diff -pruN 8.0.1-5/.clang-format 8.0.2-1/.clang-format
--- 8.0.1-5/.clang-format	1970-01-01 00:00:00.000000000 +0000
+++ 8.0.2-1/.clang-format	2024-06-11 20:41:34.000000000 +0000
@@ -0,0 +1,7 @@
+---
+Language:        Cpp
+BasedOnStyle:    LLVM
+SortIncludes:    false
+Standard:        Cpp11
+TabWidth:        2
+UseTab:          Never
diff -pruN 8.0.1-5/.flake8 8.0.2-1/.flake8
--- 8.0.1-5/.flake8	1970-01-01 00:00:00.000000000 +0000
+++ 8.0.2-1/.flake8	2024-06-11 20:41:34.000000000 +0000
@@ -0,0 +1,19 @@
+[flake8]
+max_line_length = 88
+ignore =
+    C408 # Unnecessary dict/list/tuple call - rewrite as a literal
+    E203 # whitespace before ':' - doesn't work well with black
+    E225 # missing whitespace around operator - let black worry about that
+    E262 # inline comment should start with '# '
+    E265 # block comment should start with '# '
+    E266 # too many leading '#' for block comment
+    E302 # expected 2 blank lines, found 1
+    E402 # module level import not at top of file
+    E501 # line too long - let black handle that
+    E711 # comparison to None should be
+    E712 # comparison to False/True should be
+    E741 # ambiguous variable name
+    F405 # may be undefined, or defined from star imports
+    W291 # trailing
+    W503 # line break occurred before a binary operator - let black worry about that
+    W504 # line break occurred adter a binary operator - let black worry about that
diff -pruN 8.0.1-5/.git-blame-ignore-revs 8.0.2-1/.git-blame-ignore-revs
--- 8.0.1-5/.git-blame-ignore-revs	1970-01-01 00:00:00.000000000 +0000
+++ 8.0.2-1/.git-blame-ignore-revs	2024-06-11 20:41:34.000000000 +0000
@@ -0,0 +1 @@
+8c475073defe4add51fd6bba2b7e41a23f9dc55b
diff -pruN 8.0.1-5/.github/workflows/build.yml 8.0.2-1/.github/workflows/build.yml
--- 8.0.1-5/.github/workflows/build.yml	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/.github/workflows/build.yml	2024-06-11 20:41:34.000000000 +0000
@@ -8,7 +8,7 @@ jobs:
 
     steps:
       - name: Checkout repository contents
-        uses: actions/checkout@v2
+        uses: actions/checkout@v3
 
       - name: Build
         run: docker run -e WORK_DIR="$PWD" -v $PWD:$PWD ubuntu:20.04 $PWD/.github/workflows/start.sh
diff -pruN 8.0.1-5/.github/workflows/check-crlf.yml 8.0.2-1/.github/workflows/check-crlf.yml
--- 8.0.1-5/.github/workflows/check-crlf.yml	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/.github/workflows/check-crlf.yml	2024-06-11 20:41:34.000000000 +0000
@@ -12,7 +12,7 @@ jobs:
 
     steps:
       - name: Checkout repository contents
-        uses: actions/checkout@v1
+        uses: actions/checkout@v3
 
       - name: Use action to check for CRLF endings
         uses: erclu/check-crlf@v1.2.0
diff -pruN 8.0.1-5/.github/workflows/code_checks.yml 8.0.2-1/.github/workflows/code_checks.yml
--- 8.0.1-5/.github/workflows/code_checks.yml	1970-01-01 00:00:00.000000000 +0000
+++ 8.0.2-1/.github/workflows/code_checks.yml	2024-06-11 20:41:34.000000000 +0000
@@ -0,0 +1,19 @@
+name: Code Checks
+
+on: [push, pull_request]
+
+concurrency:
+  group: ${{ github.workflow }}-${{ github.head_ref || github.ref }}
+  cancel-in-progress: true
+
+permissions:
+  contents: read
+
+jobs:
+
+  linting:
+    runs-on: ubuntu-latest
+    steps:
+      - uses: actions/checkout@v4
+      - uses: actions/setup-python@v4
+      - uses: pre-commit/action@v3.0.0
diff -pruN 8.0.1-5/.github/workflows/coverity-scan.yml 8.0.2-1/.github/workflows/coverity-scan.yml
--- 8.0.1-5/.github/workflows/coverity-scan.yml	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/.github/workflows/coverity-scan.yml	2024-06-11 20:41:34.000000000 +0000
@@ -15,7 +15,7 @@ jobs:
     runs-on: ubuntu-20.04
     if: github.repository == 'MapServer/MapServer'
     steps:
-      - uses: actions/checkout@v2
+      - uses: actions/checkout@v3
 
       - name: Install Libraries
         run: |
diff -pruN 8.0.1-5/.github/workflows/cppcheck.yml 8.0.2-1/.github/workflows/cppcheck.yml
--- 8.0.1-5/.github/workflows/cppcheck.yml	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/.github/workflows/cppcheck.yml	2024-06-11 20:41:34.000000000 +0000
@@ -9,7 +9,7 @@ jobs:
     if: "!contains(github.event.head_commit.message, '[ci skip]') && !contains(github.event.head_commit.message, '[skip ci]')"
     steps:
       - name: Checkout
-        uses: actions/checkout@v2
+        uses: actions/checkout@v3
 
       - name: Install Requirements
         run: |
diff -pruN 8.0.1-5/.pre-commit-config.yaml 8.0.2-1/.pre-commit-config.yaml
--- 8.0.1-5/.pre-commit-config.yaml	1970-01-01 00:00:00.000000000 +0000
+++ 8.0.2-1/.pre-commit-config.yaml	2024-06-11 20:41:34.000000000 +0000
@@ -0,0 +1,32 @@
+repos:
+    -   repo: https://github.com/psf/black
+        rev: 22.3.0
+        hooks:
+        -   id: black
+    -   repo: https://github.com/timothycrosley/isort
+        rev: 5.12.0
+        hooks:
+        -   id: isort
+            args: ["--profile", "black"]
+    -   repo: https://github.com/pycqa/flake8
+        rev: 3.9.2
+        hooks:
+        -   id: flake8
+    -   repo: https://github.com/pre-commit/mirrors-clang-format
+        rev: 'v15.0.7'
+        hooks:
+        -   id: clang-format
+            exclude_types: [c#, java, javascript, json, proto]
+            exclude: >
+              (?x)^(
+                build |
+                renderers/agg/ |
+                flatgeobuf/ |
+                opengl/ |
+                third-party/ |
+                maplexer.c |
+                mapparser.c |
+                mapparser.h |
+                dejavu-sans-condensed.h |
+                uthash.h
+              )
diff -pruN 8.0.1-5/CMakeLists.txt 8.0.2-1/CMakeLists.txt
--- 8.0.1-5/CMakeLists.txt	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/CMakeLists.txt	2024-06-11 20:41:34.000000000 +0000
@@ -17,7 +17,7 @@ include(CheckCSourceCompiles)
 
 set (MapServer_VERSION_MAJOR 8)
 set (MapServer_VERSION_MINOR 0)
-set (MapServer_VERSION_REVISION 1)
+set (MapServer_VERSION_REVISION 2)
 set (MapServer_VERSION_SUFFIX "")
 
 # Set C++ version
@@ -234,8 +234,10 @@ if(NOT DEFINED CMAKE_INSTALL_LIBDIR)
   set(CMAKE_INSTALL_LIBDIR "${_LIBDIR_DEFAULT}" CACHE PATH "object code libraries (${_LIBDIR_DEFAULT})")
 endif()
 
-SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
-SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
+if(NOT DEFINED CMAKE_INSTALL_RPATH)
+  SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
+  SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
+endif()
 SET(CMAKE_MACOSX_RPATH ON)
 
 if(LINK_STATIC_LIBMAPSERVER)
@@ -288,8 +290,14 @@ if(WIN32)
   set(REGEX_MALLOC 1)
   set(USE_GENERIC_MS_NINT 1)
   set(HAVE_STRING_H 0)
-  # Suppress warnings for regex.c
-  set_source_files_properties(${REGEX_SOURCES} PROPERTIES COMPILE_FLAGS /w)
+  if(MSVC)
+    # Suppress warnings for regex.c
+    set_source_files_properties(${REGEX_SOURCES} PROPERTIES COMPILE_FLAGS /w)
+  endif(MSVC)
+  if(MINGW)
+    # mingw provides stdlib.h
+    add_definitions(-DSTDC_HEADERS=1)
+  endif(MINGW)
 else(WIN32)
   set(REGEX_SOURCES "")
 endif(WIN32)
@@ -939,7 +947,6 @@ status_optional_component("GIF" "${USE_G
 status_optional_component("MYSQL" "${USE_MYSQL}" "${MYSQL_LIBRARY}")
 status_optional_component("FRIBIDI" "${USE_FRIBIDI}" "${FRIBIDI_LIBRARY}")
 status_optional_component("HARFBUZZ" "${USE_HARFBUZZ}" "${HARFBUZZ_LIBRARY}")
-status_optional_component("GIF" "${USE_GIF}" "${GIF_LIBRARY}")
 status_optional_component("CAIRO" "${USE_CAIRO}" "${CAIRO_LIBRARY}")
 status_optional_component("SVGCAIRO" "${USE_SVG_CAIRO}" "${SVGCAIRO_LIBRARY}")
 status_optional_component("RSVG" "${USE_RSVG}" "${RSVG_LIBRARY}")
@@ -1107,5 +1114,5 @@ install(
 
 install(
   FILES ${PROJECT_SOURCE_DIR}/etc/mapserver-sample.conf
-  DESTINATION ${CMAKE_INSTALL_FULL_SYSCONFDIR}/
+  DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}/
 )
diff -pruN 8.0.1-5/HISTORY.md 8.0.2-1/HISTORY.md
--- 8.0.1-5/HISTORY.md	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/HISTORY.md	2024-06-11 20:41:34.000000000 +0000
@@ -13,6 +13,11 @@ https://mapserver.org/development/change
 
 The online Migration Guide can be found at https://mapserver.org/MIGRATION_GUIDE.html
 
+8.0.2 release (2024-06-11)
+--------------------------
+
+- security fix to prevent SQL injections through regex validation (#7075)
+
 8.0.1 release (2023-04-17)
 --------------------------
 
@@ -83,6 +88,15 @@ RC2 was released as the final 8.0.0 (see
 
 - upgrade Travis and GitHub CI to run on Ubuntu Focal (#6430)
 
+7.6.5 release (2023-04-17)
+--------------------------
+
+- remove password content from logs (#6621)
+
+- increase security and stability (#6818)
+
+see detailed changelog for other fixes
+
 7.6.4 release (2021-07-12)
 --------------------------
 
diff -pruN 8.0.1-5/LICENSE.md 8.0.2-1/LICENSE.md
--- 8.0.1-5/LICENSE.md	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/LICENSE.md	2024-06-11 20:41:34.000000000 +0000
@@ -4,7 +4,7 @@ MapServer Licensing
 MapServer General
 -----------------
 
-Copyright (c) 2008-2023 Open Source Geospatial Foundation.  
+Copyright (c) 2008-2024 Open Source Geospatial Foundation.  
 Copyright (c) 1996-2008 Regents of the University of Minnesota.
 
 Permission is hereby granted, free of charge, to any person obtaining a copy 
diff -pruN 8.0.1-5/apache/mod_mapserver.c 8.0.2-1/apache/mod_mapserver.c
--- 8.0.1-5/apache/mod_mapserver.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/apache/mod_mapserver.c	2024-06-11 20:41:34.000000000 +0000
@@ -12,7 +12,7 @@
 #include "apr_tables.h"
 #include "apr_file_info.h"
 
-#include "../mapserver.h"  /* for mapObj */
+#include "../mapserver.h" /* for mapObj */
 #include "../cgiutil.h"
 #include "../mapserv.h"
 
@@ -21,45 +21,39 @@ module AP_MODULE_DECLARE_DATA mapserver_
 typedef struct {
   apr_pool_t *config_pool;
   apr_time_t mtime;
-  char   *mapfile_name;
-  char   *uri;
+  char *mapfile_name;
+  char *uri;
   mapObj *map;
 } mapserver_dir_config;
 
 /* These are the IO redirection hooks. They are mostly copied over from
  * mapio.c. Note that cbData contains Apache's request_rec!
  */
-static int
-msIO_apacheWrite (void *cbData, void *data, int byteCount)
-{
+static int msIO_apacheWrite(void *cbData, void *data, int byteCount) {
   /* simply use the block writing function which is very similiar to fwrite */
-  return ap_rwrite (data, byteCount, (request_rec*) cbData);
+  return ap_rwrite(data, byteCount, (request_rec *)cbData);
 }
 
-static int
-msIO_apacheError (void *cbData, void *data, int byteCount)
-{
+static int msIO_apacheError(void *cbData, void *data, int byteCount) {
   /* error reporting is done through the log file... */
-  ap_log_error (APLOG_MARK, APLOG_ERR, 0, NULL, "%s", (char*) data);
-  return strlen ((char*) data);
+  ap_log_error(APLOG_MARK, APLOG_ERR, 0, NULL, "%s", (char *)data);
+  return strlen((char *)data);
 }
 
-int
-msIO_installApacheRedirect (request_rec *r)
-{
+int msIO_installApacheRedirect(request_rec *r) {
   msIOContext stdout_ctx, stderr_ctx;
 
-  stdout_ctx.label         = "apache";
+  stdout_ctx.label = "apache";
   stdout_ctx.write_channel = MS_TRUE;
   stdout_ctx.readWriteFunc = msIO_apacheWrite;
-  stdout_ctx.cbData        = (void*) r;
+  stdout_ctx.cbData = (void *)r;
 
-  stderr_ctx.label         = "apache";
+  stderr_ctx.label = "apache";
   stderr_ctx.write_channel = MS_TRUE;
   stderr_ctx.readWriteFunc = msIO_apacheError;
-  stderr_ctx.cbData        = (void*) r;
+  stderr_ctx.cbData = (void *)r;
 
-  msIO_installHandlers (NULL, &stdout_ctx, &stderr_ctx);
+  msIO_installHandlers(NULL, &stdout_ctx, &stderr_ctx);
 
   return MS_TRUE;
 }
@@ -72,91 +66,89 @@ msIO_installApacheRedirect (request_rec
 /* This is our simple query decoding function. Should be improved but for now
  * it works...
  */
-static int
-mapserver_decode_args (apr_pool_t *p, char *args,
-                       char ***ParamNames, char ***ParamValues)
-{
+static int mapserver_decode_args(apr_pool_t *p, char *args, char ***ParamNames,
+                                 char ***ParamValues) {
   char **argv = NULL;
-  int    i;
-  int    n;
-  int    argc = 0;
-  char  *sep;
+  int i;
+  int n;
+  int argc = 0;
+  char *sep;
 
   /* alloc the name/value pointer list */
-  argv = (char**) apr_pcalloc (p, (WMS_MAX_ARGS + 1) * 2 * sizeof (char*));
-  *ParamNames  = argv;
+  argv = (char **)apr_pcalloc(p, (WMS_MAX_ARGS + 1) * 2 * sizeof(char *));
+  *ParamNames = argv;
   *ParamValues = argv + WMS_MAX_ARGS + 1;
   /* No arguments? Then we're done */
-  if (!args) return 0;
+  if (!args)
+    return 0;
 
-  argv [0] = args;
+  argv[0] = args;
 
   /* separate the arguments */
-  for (i = 1, n = 0; args [n] && (i < WMS_MAX_ARGS); n++)
-    if (args [n] == '&') {
-      argv [i++] = args + n + 1;
-      args [n  ] = '\0';
+  for (i = 1, n = 0; args[n] && (i < WMS_MAX_ARGS); n++)
+    if (args[n] == '&') {
+      argv[i++] = args + n + 1;
+      args[n] = '\0';
     }
 
   /* eleminate empty args */
-  for (n = 0, i = 0; argv [i]; i++)
-    if (*(argv [i]) != '\0')
-      argv [n++] = argv [i];
+  for (n = 0, i = 0; argv[i]; i++)
+    if (*(argv[i]) != '\0')
+      argv[n++] = argv[i];
     else
-      argv [i  ] = NULL;
+      argv[i] = NULL;
 
   /* argument count is the number of non-zero arguments! */
   argc = n;
 
   /* split the name/value pairs */
-  for (i = 0; argv [i]; i++) {
-    sep = strchr (argv [i], '=');
-    if (!sep) continue;
+  for (i = 0; argv[i]; i++) {
+    sep = strchr(argv[i], '=');
+    if (!sep)
+      continue;
     *sep = '\0';
-    argv [i + WMS_MAX_ARGS + 1] = (char*) apr_pstrdup (p, sep + 1);
+    argv[i + WMS_MAX_ARGS + 1] = (char *)apr_pstrdup(p, sep + 1);
 
-    if (ap_unescape_url (argv [i + WMS_MAX_ARGS + 1]) == HTTP_BAD_REQUEST) {
-      ap_log_error (APLOG_MARK, APLOG_ERR, 0, NULL,
-                    "%s: malformed URI, couldn't unescape parm %s",
-                    __func__, argv [i]);
+    if (ap_unescape_url(argv[i + WMS_MAX_ARGS + 1]) == HTTP_BAD_REQUEST) {
+      ap_log_error(APLOG_MARK, APLOG_ERR, 0, NULL,
+                   "%s: malformed URI, couldn't unescape parm %s", __func__,
+                   argv[i]);
 
-      argv [i + WMS_MAX_ARGS + 1] = NULL;
+      argv[i + WMS_MAX_ARGS + 1] = NULL;
     } else {
-      plustospace (argv [i + WMS_MAX_ARGS + 1]);
+      plustospace(argv[i + WMS_MAX_ARGS + 1]);
     }
   }
   return argc;
 }
 
-static char*
-mapserver_read_post_data (request_rec *r)
-{
-  int   size;
-  long  blen, rsize, rpos = 0;
+static char *mapserver_read_post_data(request_rec *r) {
+  int size;
+  long blen, rsize, rpos = 0;
   char *buffer = NULL;
-  char  buf [512];
+  char buf[512];
 
-  if (ap_setup_client_block (r, REQUEST_CHUNKED_ERROR) != OK)
+  if (ap_setup_client_block(r, REQUEST_CHUNKED_ERROR) != OK)
     return NULL;
 
-  if (!ap_should_client_block (r))
+  if (!ap_should_client_block(r))
     return NULL;
 
-  buffer = (char*) apr_palloc (r->pool, r->remaining + 1);
+  buffer = (char *)apr_palloc(r->pool, r->remaining + 1);
 
   if (!buffer)
     return NULL;
 
   size = r->remaining;
-  buffer [size] = '\0';
+  buffer[size] = '\0';
 
-  while ((blen = ap_get_client_block (r, buf, sizeof (buf))) > 0) {
+  while ((blen = ap_get_client_block(r, buf, sizeof(buf))) > 0) {
     if (rpos + blen > size) {
       rsize = blen - rpos;
     } else {
       rsize = blen;
     }
-    memcpy ((char*) buffer + rpos, buf, rsize);
+    memcpy((char *)buffer + rpos, buf, rsize);
     rpos += rsize;
   }
 
@@ -167,32 +159,37 @@ mapserver_read_post_data (request_rec *r
 ** Extract Map File name from params and load it.
 ** Returns map object or NULL on error.
 */
-static mapObj*
-msModuleLoadMap(mapservObj *mapserv, mapserver_dir_config *conf)
-{
+static mapObj *msModuleLoadMap(mapservObj *mapserv,
+                               mapserver_dir_config *conf) {
   int i;
   /* OK, here's the magic: we take the mapObj from our stored config.
    * We will use a copy of it created by msCopyMap since MapServer
    * modifies the object at several places during request processing
    */
-  mapObj *map = msNewMapObj ();
-  if(!map) return NULL;
-  msCopyMap (map, conf->map);
-
+  mapObj *map = msNewMapObj();
+  if (!map)
+    return NULL;
+  msCopyMap(map, conf->map);
 
-  /* check for any %variable% substitutions here, also do any map_ changes, we do this here so WMS/WFS  */
+  /* check for any %variable% substitutions here, also do any map_ changes, we
+   * do this here so WMS/WFS  */
   /* services can take advantage of these "vendor specific" extensions */
-  for(i=0; i<mapserv->request->NumParams; i++) {
+  for (i = 0; i < mapserv->request->NumParams; i++) {
     /*
     ** a few CGI variables should be skipped altogether
     **
-    ** qstring: there is separate per layer validation for attribute queries and the substitution checks
+    ** qstring: there is separate per layer validation for attribute queries and
+    *the substitution checks
     **          below conflict with that so we avoid it here
     */
-    if(strncasecmp(mapserv->request->ParamNames[i],"qstring",7) == 0) continue;
+    if (strncasecmp(mapserv->request->ParamNames[i], "qstring", 7) == 0)
+      continue;
 
-    if(strncasecmp(mapserv->request->ParamNames[i],"map_",4) == 0 || strncasecmp(mapserv->request->ParamNames[i],"map.",4) == 0) { /* check to see if there are any additions to the mapfile */
-      if(msUpdateMapFromURL(map, mapserv->request->ParamNames[i], mapserv->request->ParamValues[i]) != MS_SUCCESS) {
+    if (strncasecmp(mapserv->request->ParamNames[i], "map_", 4) == 0 ||
+        strncasecmp(mapserv->request->ParamNames[i], "map.", 4) ==
+            0) { /* check to see if there are any additions to the mapfile */
+      if (msUpdateMapFromURL(map, mapserv->request->ParamNames[i],
+                             mapserv->request->ParamValues[i]) != MS_SUCCESS) {
         msFreeMap(map);
         return NULL;
       }
@@ -200,18 +197,22 @@ msModuleLoadMap(mapservObj *mapserv, map
     }
   }
 
-  msApplySubstitutions(map, mapserv->request->ParamNames, mapserv->request->ParamValues, mapserv->request->NumParams);
+  msApplySubstitutions(map, mapserv->request->ParamNames,
+                       mapserv->request->ParamValues,
+                       mapserv->request->NumParams);
   msApplyDefaultSubstitutions(map);
 
   /* check to see if a ogc map context is passed as argument. if there */
   /* is one load it */
 
-  for(i=0; i<mapserv->request->NumParams; i++) {
-    if(strcasecmp(mapserv->request->ParamNames[i],"context") == 0) {
-      if(mapserv->request->ParamValues[i] && strlen(mapserv->request->ParamValues[i]) > 0) {
-        if(strncasecmp(mapserv->request->ParamValues[i],"http",4) == 0) {
-          if(msGetConfigOption(map, "CGI_CONTEXT_URL"))
-            msLoadMapContextURL(map, mapserv->request->ParamValues[i], MS_FALSE);
+  for (i = 0; i < mapserv->request->NumParams; i++) {
+    if (strcasecmp(mapserv->request->ParamNames[i], "context") == 0) {
+      if (mapserv->request->ParamValues[i] &&
+          strlen(mapserv->request->ParamValues[i]) > 0) {
+        if (strncasecmp(mapserv->request->ParamValues[i], "http", 4) == 0) {
+          if (msGetConfigOption(map, "CGI_CONTEXT_URL"))
+            msLoadMapContextURL(map, mapserv->request->ParamValues[i],
+                                MS_FALSE);
         } else
           msLoadMapContext(map, mapserv->request->ParamValues[i], MS_FALSE);
       }
@@ -225,9 +226,9 @@ msModuleLoadMap(mapservObj *mapserv, map
    * by an object that is part of the mapObject that would contain
    * information on the application status (such as cookie).
    */
-  if( mapserv->request->httpcookiedata != NULL ) {
-    msInsertHashTable( &(map->web.metadata), "http_cookie_data",
-                       mapserv->request->httpcookiedata );
+  if (mapserv->request->httpcookiedata != NULL) {
+    msInsertHashTable(&(map->web.metadata), "http_cookie_data",
+                      mapserv->request->httpcookiedata);
   }
 
   return map;
@@ -236,66 +237,66 @@ msModuleLoadMap(mapservObj *mapserv, map
 /***
  * The main request handler.
  **/
-static int
-mapserver_handler (request_rec *r)
-{
+static int mapserver_handler(request_rec *r) {
   /* aquire the apropriate configuration for this directory */
   mapserver_dir_config *conf;
-  conf = (mapserver_dir_config*) ap_get_module_config (r->per_dir_config,
-         &mapserver_module);
+  conf = (mapserver_dir_config *)ap_get_module_config(r->per_dir_config,
+                                                      &mapserver_module);
 
   /* decline the request if there's no map configured */
   if (!conf || !conf->map)
     return DECLINED;
 
   apr_finfo_t mapstat;
-  if (apr_stat (&mapstat, conf->mapfile_name, APR_FINFO_MTIME, r->pool) == APR_SUCCESS) {
-    if (apr_time_sec (mapstat.mtime) > apr_time_sec (conf->mtime)) {
-      mapObj *newmap = msLoadMap (conf->mapfile_name, NULL);
+  if (apr_stat(&mapstat, conf->mapfile_name, APR_FINFO_MTIME, r->pool) ==
+      APR_SUCCESS) {
+    if (apr_time_sec(mapstat.mtime) > apr_time_sec(conf->mtime)) {
+      mapObj *newmap = msLoadMap(conf->mapfile_name, NULL);
       if (newmap) {
-        msFreeMap (conf->map);
-        conf->map   = newmap;
+        msFreeMap(conf->map);
+        conf->map = newmap;
         conf->mtime = mapstat.mtime;
       } else {
-        ap_log_error (APLOG_MARK, APLOG_WARNING, 0, NULL,
-                      "unable to reload map file %s", conf->mapfile_name);
+        ap_log_error(APLOG_MARK, APLOG_WARNING, 0, NULL,
+                     "unable to reload map file %s", conf->mapfile_name);
       }
     }
   } else {
-    ap_log_error (APLOG_MARK, APLOG_WARNING, 0, NULL,
-                  "%s: unable to stat file %s", __func__, conf->mapfile_name);
+    ap_log_error(APLOG_MARK, APLOG_WARNING, 0, NULL,
+                 "%s: unable to stat file %s", __func__, conf->mapfile_name);
   }
 
   /* make a copy of the URI so we can modify it safely */
-  char *uri          = apr_pstrdup (r->pool, r->uri);
-  int   len          = strlen (uri);
-  int   conf_uri_len = strlen (conf->uri);
+  char *uri = apr_pstrdup(r->pool, r->uri);
+  int len = strlen(uri);
+  int conf_uri_len = strlen(conf->uri);
 
   /* If the URI points to a subdirectory we want to decline.
    */
   if (len > conf_uri_len)
     return DECLINED;
 
-  int    argc          = 0;
-  char **ParamNames    = NULL;
-  char **ParamValues   = NULL;
-  char  *post_data     = NULL;
-  int    szMethod      = -1;
-  char  *szContentType = NULL;
+  int argc = 0;
+  char **ParamNames = NULL;
+  char **ParamValues = NULL;
+  char *post_data = NULL;
+  int szMethod = -1;
+  char *szContentType = NULL;
   mapservObj *mapserv = NULL;
 
   /* Try decoding the query string */
   if (r->method_number == M_GET) {
-    argc = mapserver_decode_args (r->pool, (char*) apr_pstrdup (r->pool, r->args),
-                                  &ParamNames, &ParamValues);
+    argc = mapserver_decode_args(r->pool, (char *)apr_pstrdup(r->pool, r->args),
+                                 &ParamNames, &ParamValues);
     szMethod = MS_GET_REQUEST;
   } else if (r->method_number == M_POST) {
-    szContentType = (char*) apr_table_get (r->headers_in, "Content-Type");
-    post_data = mapserver_read_post_data (r);
-    szMethod  = MS_POST_REQUEST;
-    if (strcmp (szContentType, "application/x-www-form-urlencoded") == 0) {
-      argc = mapserver_decode_args (r->pool, (char*) apr_pstrdup (r->pool, r->args),
-                                    &ParamNames, &ParamValues);
+    szContentType = (char *)apr_table_get(r->headers_in, "Content-Type");
+    post_data = mapserver_read_post_data(r);
+    szMethod = MS_POST_REQUEST;
+    if (strcmp(szContentType, "application/x-www-form-urlencoded") == 0) {
+      argc =
+          mapserver_decode_args(r->pool, (char *)apr_pstrdup(r->pool, r->args),
+                                &ParamNames, &ParamValues);
     }
   } else
     return HTTP_METHOD_NOT_ALLOWED;
@@ -304,36 +305,34 @@ mapserver_handler (request_rec *r)
     return HTTP_BAD_REQUEST;
 
   /* Now we install the IO redirection.
-  */
-  if (msIO_installApacheRedirect (r) != MS_TRUE)
-    ap_log_error (APLOG_MARK, APLOG_ERR, 0, NULL,
-                  "%s: could not install apache redirect", __func__);
-
+   */
+  if (msIO_installApacheRedirect(r) != MS_TRUE)
+    ap_log_error(APLOG_MARK, APLOG_ERR, 0, NULL,
+                 "%s: could not install apache redirect", __func__);
 
   mapserv = msAllocMapServObj();
-  mapserv->request->NumParams   = argc;
-  mapserv->request->ParamNames  = ParamNames;
+  mapserv->request->NumParams = argc;
+  mapserv->request->ParamNames = ParamNames;
   mapserv->request->ParamValues = ParamValues;
-  mapserv->request->type        = (enum MS_REQUEST_TYPE) szMethod;
+  mapserv->request->type = (enum MS_REQUEST_TYPE)szMethod;
   mapserv->request->postrequest = post_data;
   mapserv->request->contenttype = szContentType;
 
-  //mapserv->map = msModuleLoadMap(mapserv,conf);
+  // mapserv->map = msModuleLoadMap(mapserv,conf);
   mapserv->map = conf->map;
-  if(!mapserv->map) {
+  if (!mapserv->map) {
     msCGIWriteError(mapserv);
     goto end_request;
   }
 
-  if(msCGIDispatchRequest(mapserv) != MS_SUCCESS) {
+  if (msCGIDispatchRequest(mapserv) != MS_SUCCESS) {
     msCGIWriteError(mapserv);
     goto end_request;
   }
 
-
 end_request:
-  if(mapserv) {
-    mapserv->request->ParamNames  = NULL;
+  if (mapserv) {
+    mapserv->request->ParamNames = NULL;
     mapserv->request->ParamValues = NULL;
     mapserv->request->postrequest = NULL;
     mapserv->request->contenttype = NULL;
@@ -342,7 +341,6 @@ end_request:
   }
   msResetErrorList();
 
-
   /* Check if status was set inside MapServer functions. If it was, we
    * return it's value instead of simply OK. This is to support redirects
    * from maptemplate.c
@@ -356,10 +354,8 @@ end_request:
 /* This function will be called on startup to allow us to register our
  * handler. We don't do anything else yet...
  */
-static void
-mapserver_register_hooks (apr_pool_t *p)
-{
-  ap_hook_handler (mapserver_handler, NULL, NULL, APR_HOOK_MIDDLE);
+static void mapserver_register_hooks(apr_pool_t *p) {
+  ap_hook_handler(mapserver_handler, NULL, NULL, APR_HOOK_MIDDLE);
 }
 
 /* That's the second part of the overall magic. This function will be called
@@ -368,38 +364,38 @@ mapserver_register_hooks (apr_pool_t *p)
  * We try to load it and store the resulting mapObj in the config of the
  * current directory. If we fail we throw a message...
  */
-static const char*
-mapserver_set_map (cmd_parms *cmd, void *config, const char *arg)
-{
-  mapserver_dir_config *conf = (mapserver_dir_config*) config;
+static const char *mapserver_set_map(cmd_parms *cmd, void *config,
+                                     const char *arg) {
+  mapserver_dir_config *conf = (mapserver_dir_config *)config;
   /* if the mapObj already exists the WMS_Map was given more than once -
    * may be the user forgot to comment something out...
    */
   if (conf->map) {
-    msWriteError (stderr);
-    return (char*) apr_psprintf (cmd->temp_pool,
-                                 "An MAP-file has already been registered for "
-                                 "this URI - not accepting '%s'.", arg );
+    msWriteError(stderr);
+    return (char *)apr_psprintf(cmd->temp_pool,
+                                "An MAP-file has already been registered for "
+                                "this URI - not accepting '%s'.",
+                                arg);
   }
   /* Simply try loading the argument as map file. */
   conf->mapfile_name = apr_pstrdup(cmd->pool, arg);
-  conf->map = msLoadMap ((char*) arg, NULL);
+  conf->map = msLoadMap((char *)arg, NULL);
 
   /* Ooops - we failed. We report it and fail. So beware: Always do a
    * configcheck before really restarting your web server!
    */
 
   if (!conf->map) {
-    msWriteError (stderr);
-    return (char*) apr_psprintf (cmd->temp_pool,
-                                 "The given MAP-file '%s' could not be loaded",
-                                 arg);
+    msWriteError(stderr);
+    return (char *)apr_psprintf(
+        cmd->temp_pool, "The given MAP-file '%s' could not be loaded", arg);
   }
 
   apr_finfo_t status;
-  if (apr_stat (&status, conf->mapfile_name, APR_FINFO_MTIME, cmd->pool) != APR_SUCCESS) {
-    ap_log_error (APLOG_MARK, APLOG_WARNING, 0, NULL,
-                  "%s: unable to stat file %s", __func__, conf->mapfile_name);
+  if (apr_stat(&status, conf->mapfile_name, APR_FINFO_MTIME, cmd->pool) !=
+      APR_SUCCESS) {
+    ap_log_error(APLOG_MARK, APLOG_WARNING, 0, NULL,
+                 "%s: unable to stat file %s", __func__, conf->mapfile_name);
   }
   conf->mtime = status.mtime;
   return NULL;
@@ -408,21 +404,20 @@ mapserver_set_map (cmd_parms *cmd, void
 /* This function creates the (default) directory configuration. Well, we have
  * no defaults to set so we simply alloc the memory...
  */
-static void*
-mapserver_create_dir_config (apr_pool_t *p, char *dir)
-{
+static void *mapserver_create_dir_config(apr_pool_t *p, char *dir) {
   mapserver_dir_config *newconf;
-  newconf = (mapserver_dir_config*) apr_pcalloc (p, sizeof (mapserver_dir_config));
+  newconf =
+      (mapserver_dir_config *)apr_pcalloc(p, sizeof(mapserver_dir_config));
   newconf->config_pool = p;
-  newconf->uri = apr_pstrdup (p, dir);
+  newconf->uri = apr_pstrdup(p, dir);
   newconf->map = NULL;
   newconf->mapfile_name = NULL;
-  newconf->mtime = apr_time_from_sec (0);
+  newconf->mtime = apr_time_from_sec(0);
 
   if (dir) {
-    int len = strlen (dir);
-    if (len > 1 && dir [len - 1] == '/' )
-      newconf->uri [len - 1] = '\0';
+    int len = strlen(dir);
+    if (len > 1 && dir[len - 1] == '/')
+      newconf->uri[len - 1] = '\0';
   }
   return newconf;
 }
@@ -431,15 +426,9 @@ mapserver_create_dir_config (apr_pool_t
  * argument.
  */
 static const command_rec mapserver_options[] = {
-  AP_INIT_TAKE1(
-    "Mapfile",
-    mapserver_set_map,
-    NULL,
-    ACCESS_CONF,
-    "WMS_Map <Path to map file>"
-  ),
-  {NULL}
-};
+    AP_INIT_TAKE1("Mapfile", mapserver_set_map, NULL, ACCESS_CONF,
+                  "WMS_Map <Path to map file>"),
+    {NULL}};
 
 /* The following structure declares everything Apache needs to treat us as
  * a module. Merging would mean inheriting from the parent directory but that
@@ -447,12 +436,11 @@ static const command_rec mapserver_optio
  */
 /* Dispatch list for API hooks */
 module AP_MODULE_DECLARE_DATA mapserver_module = {
-  STANDARD20_MODULE_STUFF,
-  mapserver_create_dir_config,  /* create per-dir    config structures */
-  NULL,     /* merge  per-dir    config structures */
-  NULL,     /* create per-server config structures */
-  NULL,     /* merge  per-server config structures */
-  mapserver_options,    /* table of config file commands       */
-  mapserver_register_hooks    /* register hooks                      */
+    STANDARD20_MODULE_STUFF,
+    mapserver_create_dir_config, /* create per-dir    config structures */
+    NULL,                        /* merge  per-dir    config structures */
+    NULL,                        /* create per-server config structures */
+    NULL,                        /* merge  per-server config structures */
+    mapserver_options,           /* table of config file commands       */
+    mapserver_register_hooks     /* register hooks                      */
 };
-
diff -pruN 8.0.1-5/cgiutil.c 8.0.2-1/cgiutil.c
--- 8.0.1-5/cgiutil.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/cgiutil.c	2024-06-11 20:41:34.000000000 +0000
@@ -5,7 +5,8 @@
  * Purpose:  cgiRequestObj and CGI parameter parsing.
  * Author:   Steve Lime and the MapServer team.
  *
- * Notes: Portions derived from NCSA HTTPd Server's example CGI programs (util.c).
+ * Notes: Portions derived from NCSA HTTPd Server's example CGI programs
+ *(util.c).
  *
  ******************************************************************************
  * Copyright (c) 1996-2005 Regents of the University of Minnesota.
@@ -41,8 +42,7 @@
 #define LF 10
 #define CR 13
 
-int readPostBody( cgiRequestObj *request, char **data )
-{
+int readPostBody(cgiRequestObj *request, char **data) {
   size_t data_max, data_len;
   int chunk_size;
 
@@ -53,26 +53,29 @@ int readPostBody( cgiRequestObj *request
   /* -------------------------------------------------------------------- */
   /*      If the length is provided, read in one gulp.                    */
   /* -------------------------------------------------------------------- */
-  if( getenv("CONTENT_LENGTH") != NULL ) {
-    data_max = (size_t) atoi(getenv("CONTENT_LENGTH"));
+  if (getenv("CONTENT_LENGTH") != NULL) {
+    data_max = (size_t)atoi(getenv("CONTENT_LENGTH"));
     /* Test for suspicious CONTENT_LENGTH (negative value or SIZE_MAX) */
-    if( data_max >= SIZE_MAX ) {
+    if (data_max >= SIZE_MAX) {
       // msIO_setHeader("Content-Type","text/html");
       // msIO_sendHeaders();
       // msIO_printf("Suspicious Content-Length.\n");
       msSetError(MS_WEBERR, "Suspicious Content-Length.", "readPostBody()");
       return MS_FAILURE;
     }
-    *data = (char *) malloc(data_max+1);
-    if( *data == NULL ) {
+    *data = (char *)malloc(data_max + 1);
+    if (*data == NULL) {
       // msIO_setHeader("Content-Type","text/html");
       // msIO_sendHeaders();
-      // msIO_printf("malloc() failed, Content-Length: %u unreasonably large?\n", (unsigned int)data_max );
-      msSetError(MS_WEBERR, "malloc() failed, Content-Length: %u unreasonably large?", "readPostBody()", (unsigned int)data_max);
+      // msIO_printf("malloc() failed, Content-Length: %u unreasonably
+      // large?\n", (unsigned int)data_max );
+      msSetError(MS_WEBERR,
+                 "malloc() failed, Content-Length: %u unreasonably large?",
+                 "readPostBody()", (unsigned int)data_max);
       return MS_FAILURE;
     }
 
-    if( (int) msIO_fread(*data, 1, data_max, stdin) < (int) data_max ) {
+    if ((int)msIO_fread(*data, 1, data_max, stdin) < (int)data_max) {
       // msIO_setHeader("Content-Type","text/html");
       // msIO_sendHeaders();
       // msIO_printf("POST body is short\n");
@@ -90,24 +93,29 @@ int readPostBody( cgiRequestObj *request
 
   data_max = DATA_ALLOC_SIZE;
   data_len = 0;
-  *data = (char *) msSmallMalloc(data_max+1);
+  *data = (char *)msSmallMalloc(data_max + 1);
   (*data)[data_max] = '\0';
 
-  while( (chunk_size = msIO_fread( *data + data_len, 1, data_max-data_len, stdin )) > 0 ) {
+  while ((chunk_size = msIO_fread(*data + data_len, 1, data_max - data_len,
+                                  stdin)) > 0) {
     data_len += chunk_size;
 
-    if( data_len == data_max ) {
+    if (data_len == data_max) {
       /* Realloc buffer, making sure we check for possible size_t overflow */
-      if ( data_max > SIZE_MAX - (DATA_ALLOC_SIZE+1) ) {
+      if (data_max > SIZE_MAX - (DATA_ALLOC_SIZE + 1)) {
         // msIO_setHeader("Content-Type","text/html");
         // msIO_sendHeaders();
-        // msIO_printf("Possible size_t overflow, cannot reallocate input buffer, POST body too large?\n" );
-	msSetError(MS_WEBERR, "Possible size_t overflow, cannot reallocate input buffer, POST body too large?", "readPostBody()");
+        // msIO_printf("Possible size_t overflow, cannot reallocate input
+        // buffer, POST body too large?\n" );
+        msSetError(MS_WEBERR,
+                   "Possible size_t overflow, cannot reallocate input buffer, "
+                   "POST body too large?",
+                   "readPostBody()");
         return MS_FAILURE;
       }
 
       data_max = data_max + DATA_ALLOC_SIZE;
-      *data = (char *) msSmallRealloc(*data, data_max+1);
+      *data = (char *)msSmallRealloc(*data, data_max + 1);
     }
   }
 
@@ -115,27 +123,24 @@ int readPostBody( cgiRequestObj *request
   return MS_SUCCESS;
 }
 
-static char* msGetEnv(const char *name, void* thread_context)
-{
+static char *msGetEnv(const char *name, void *thread_context) {
   (void)thread_context;
   return getenv(name);
 }
 
 int loadParams(cgiRequestObj *request,
-               char* (*getenv2)(const char*, void* thread_context),
-               char *raw_post_data,
-               ms_uint32 raw_post_data_length,
-               void* thread_context)
-{
-  register int x,m=0;
+               char *(*getenv2)(const char *, void *thread_context),
+               char *raw_post_data, ms_uint32 raw_post_data_length,
+               void *thread_context) {
+  register int x, m = 0;
   char *s, *queryString = NULL, *httpCookie = NULL;
   int debuglevel;
   int maxParams = MS_DEFAULT_CGI_PARAMS;
 
-  if (getenv2==NULL)
+  if (getenv2 == NULL)
     getenv2 = &msGetEnv;
 
-  if(getenv2("REQUEST_METHOD", thread_context)==NULL) {
+  if (getenv2("REQUEST_METHOD", thread_context) == NULL) {
     msIO_printf("This script can only be used to decode form results and \n");
     msIO_printf("should be initiated as a CGI process via a httpd server.\n");
     msIO_printf("For other options please try using the --help switch.\n");
@@ -144,138 +149,160 @@ int loadParams(cgiRequestObj *request,
 
   debuglevel = (int)msGetGlobalDebugLevel();
 
-  if(strcmp(getenv2("REQUEST_METHOD", thread_context),"POST") == 0 && CPLGetConfigOption("MS_NO_POST", NULL) == NULL) { /* we've got a post from a form */
+  if (strcmp(getenv2("REQUEST_METHOD", thread_context), "POST") == 0 &&
+      CPLGetConfigOption("MS_NO_POST", NULL) ==
+          NULL) { /* we've got a post from a form */
     char *post_data;
     int data_len;
     request->type = MS_POST_REQUEST;
 
-    if (request->contenttype == NULL){
-        s = getenv2("CONTENT_TYPE", thread_context);
-        if (s != NULL){
-          request->contenttype = msStrdup(s);
-        }
-        else {
-            /* we've to set default Content-Type which is
-             * application/octet-stream according to
-             * W3 RFC 2626 section 7.2.1 */
-            request->contenttype = msStrdup("application/octet-stream");
-        }
+    if (request->contenttype == NULL) {
+      s = getenv2("CONTENT_TYPE", thread_context);
+      if (s != NULL) {
+        request->contenttype = msStrdup(s);
+      } else {
+        /* we've to set default Content-Type which is
+         * application/octet-stream according to
+         * W3 RFC 2626 section 7.2.1 */
+        request->contenttype = msStrdup("application/octet-stream");
+      }
     }
 
     if (raw_post_data) {
       post_data = msStrdup(raw_post_data);
       data_len = raw_post_data_length;
     } else {
-      if(MS_SUCCESS != readPostBody( request, &post_data ))
+      if (MS_SUCCESS != readPostBody(request, &post_data))
         return -1;
       data_len = strlen(post_data);
     }
 
     /* if the content_type is application/x-www-form-urlencoded,
        we have to parse it like the QUERY_STRING variable */
-    if(strncmp(request->contenttype, "application/x-www-form-urlencoded", strlen("application/x-www-form-urlencoded")) == 0) {
-      while( data_len > 0 && isspace(post_data[data_len-1]) )
+    if (strncmp(request->contenttype, "application/x-www-form-urlencoded",
+                strlen("application/x-www-form-urlencoded")) == 0) {
+      while (data_len > 0 && isspace(post_data[data_len - 1]))
         post_data[--data_len] = '\0';
 
-      while( post_data[0] ) {
-        if(m >= maxParams) {
+      while (post_data[0]) {
+        if (m >= maxParams) {
           maxParams *= 2;
-          request->ParamNames = (char **) msSmallRealloc(request->ParamNames,sizeof(char *) * maxParams);
-          request->ParamValues = (char **) msSmallRealloc(request->ParamValues,sizeof(char *) * maxParams);
+          request->ParamNames = (char **)msSmallRealloc(
+              request->ParamNames, sizeof(char *) * maxParams);
+          request->ParamValues = (char **)msSmallRealloc(
+              request->ParamValues, sizeof(char *) * maxParams);
         }
-        request->ParamValues[m] = makeword(post_data,'&');
+        request->ParamValues[m] = makeword(post_data, '&');
         plustospace(request->ParamValues[m]);
         unescape_url(request->ParamValues[m]);
-        request->ParamNames[m] = makeword(request->ParamValues[m],'=');
+        request->ParamNames[m] = makeword(request->ParamValues[m], '=');
         m++;
       }
-      free( post_data );
+      free(post_data);
     } else
       request->postrequest = post_data;
 
     /* check the QUERY_STRING even in the post request since it can contain
        information. Eg a wfs request with  */
     s = getenv2("QUERY_STRING", thread_context);
-    if(s) {
+    if (s) {
       if (debuglevel >= MS_DEBUGLEVEL_DEBUG)
         msDebug("loadParams() QUERY_STRING: %s\n", s);
 
       queryString = msStrdup(s);
-      for(x=0; queryString[0] != '\0'; x++) {
-        if(m >= maxParams) {
+      for (x = 0; queryString[0] != '\0'; x++) {
+        if (m >= maxParams) {
           maxParams *= 2;
-          request->ParamNames = (char **) msSmallRealloc(request->ParamNames,sizeof(char *) * maxParams);
-          request->ParamValues = (char **) msSmallRealloc(request->ParamValues,sizeof(char *) * maxParams);
+          request->ParamNames = (char **)msSmallRealloc(
+              request->ParamNames, sizeof(char *) * maxParams);
+          request->ParamValues = (char **)msSmallRealloc(
+              request->ParamValues, sizeof(char *) * maxParams);
         }
-        request->ParamValues[m] = makeword(queryString,'&');
+        request->ParamValues[m] = makeword(queryString, '&');
         plustospace(request->ParamValues[m]);
         unescape_url(request->ParamValues[m]);
-        request->ParamNames[m] = makeword(request->ParamValues[m],'=');
+        request->ParamNames[m] = makeword(request->ParamValues[m], '=');
         m++;
       }
     }
   } else {
-    if(strcmp(getenv2("REQUEST_METHOD", thread_context),"GET") == 0) { /* we've got a get request */
+    if (strcmp(getenv2("REQUEST_METHOD", thread_context), "GET") ==
+        0) { /* we've got a get request */
       request->type = MS_GET_REQUEST;
 
       s = getenv2("QUERY_STRING", thread_context);
-      if(s == NULL) {
+      if (s == NULL) {
         // msIO_setHeader("Content-Type","text/html");
         // msIO_sendHeaders();
-        // msIO_printf("No query information to decode. QUERY_STRING not set.\n");
-	msSetError(MS_WEBERR, "No query information to decode. QUERY_STRING not set.", "loadParams()");
+        // msIO_printf("No query information to decode. QUERY_STRING not
+        // set.\n");
+        msSetError(MS_WEBERR,
+                   "No query information to decode. QUERY_STRING not set.",
+                   "loadParams()");
         return -1;
       }
 
       if (debuglevel >= MS_DEBUGLEVEL_DEBUG)
         msDebug("loadParams() QUERY_STRING: %s\n", s);
 
-      if(strlen(s)==0) {
+      if (strlen(s) == 0) {
         // msIO_setHeader("Content-Type","text/html");
         // msIO_sendHeaders();
-        // msIO_printf("No query information to decode. QUERY_STRING is set, but empty.\n");
-	msSetError(MS_WEBERR, "No query information to decode. QUERY_STRING is set, but empty.", "loadParams()");
+        // msIO_printf("No query information to decode. QUERY_STRING is set, but
+        // empty.\n");
+        msSetError(
+            MS_WEBERR,
+            "No query information to decode. QUERY_STRING is set, but empty.",
+            "loadParams()");
         return -1;
       }
 
       /* don't modify the string returned by getenv2 */
       queryString = msStrdup(s);
-      for(x=0; queryString[0] != '\0'; x++) {
-        if(m >= maxParams) {
+      for (x = 0; queryString[0] != '\0'; x++) {
+        if (m >= maxParams) {
           maxParams *= 2;
-          request->ParamNames = (char **) msSmallRealloc(request->ParamNames,sizeof(char *) * maxParams);
-          request->ParamValues = (char **) msSmallRealloc(request->ParamValues,sizeof(char *) * maxParams);
+          request->ParamNames = (char **)msSmallRealloc(
+              request->ParamNames, sizeof(char *) * maxParams);
+          request->ParamValues = (char **)msSmallRealloc(
+              request->ParamValues, sizeof(char *) * maxParams);
         }
-        request->ParamValues[m] = makeword(queryString,'&');
+        request->ParamValues[m] = makeword(queryString, '&');
         plustospace(request->ParamValues[m]);
         unescape_url(request->ParamValues[m]);
-        request->ParamNames[m] = makeword(request->ParamValues[m],'=');
+        request->ParamNames[m] = makeword(request->ParamValues[m], '=');
         m++;
       }
     } else {
       // msIO_setHeader("Content-Type","text/html");
       // msIO_sendHeaders();
-      // msIO_printf("This script should be referenced with a METHOD of GET or METHOD of POST.\n");
-      msSetError(MS_WEBERR, "This script should be referenced with a METHOD of GET or METHOD of POST.", "loadParams()");
+      // msIO_printf("This script should be referenced with a METHOD of GET or
+      // METHOD of POST.\n");
+      msSetError(MS_WEBERR,
+                 "This script should be referenced with a METHOD of GET or "
+                 "METHOD of POST.",
+                 "loadParams()");
       return -1;
     }
   }
 
   /* check for any available cookies */
   s = getenv2("HTTP_COOKIE", thread_context);
-  if(s != NULL) {
+  if (s != NULL) {
     httpCookie = msStrdup(s);
     request->httpcookiedata = msStrdup(s);
-    for(x=0; httpCookie[0] != '\0'; x++) {
-      if(m >= maxParams) {
+    for (x = 0; httpCookie[0] != '\0'; x++) {
+      if (m >= maxParams) {
         maxParams *= 2;
-        request->ParamNames = (char **) msSmallRealloc(request->ParamNames,sizeof(char *) * maxParams);
-        request->ParamValues = (char **) msSmallRealloc(request->ParamValues,sizeof(char *) * maxParams);
+        request->ParamNames = (char **)msSmallRealloc(
+            request->ParamNames, sizeof(char *) * maxParams);
+        request->ParamValues = (char **)msSmallRealloc(
+            request->ParamValues, sizeof(char *) * maxParams);
       }
-      request->ParamValues[m] = makeword(httpCookie,';');
+      request->ParamValues[m] = makeword(httpCookie, ';');
       plustospace(request->ParamValues[m]);
       unescape_url(request->ParamValues[m]);
-      request->ParamNames[m] = makeword_skip(request->ParamValues[m],'=',' ');
+      request->ParamNames[m] = makeword_skip(request->ParamValues[m], '=', ' ');
       m++;
     }
   }
@@ -285,142 +312,144 @@ int loadParams(cgiRequestObj *request,
   if (httpCookie)
     free(httpCookie);
 
-  return(m);
+  return (m);
 }
 
-void getword(char *word, char *line, char stop)
-{
-  int x = 0,y;
+void getword(char *word, char *line, char stop) {
+  int x = 0, y;
 
-  for(x=0; ((line[x]) && (line[x] != stop)); x++)
+  for (x = 0; ((line[x]) && (line[x] != stop)); x++)
     word[x] = line[x];
 
   word[x] = '\0';
-  if(line[x]) ++x;
-  y=0;
+  if (line[x])
+    ++x;
+  y = 0;
 
-  while((line[y++] = line[x++]));
+  while ((line[y++] = line[x++]))
+    ;
 }
 
-char *makeword_skip(char *line, char stop, char skip)
-{
-  int x = 0,y,offset=0;
-  char *word = (char *) msSmallMalloc(sizeof(char) * (strlen(line) + 1));
+char *makeword_skip(char *line, char stop, char skip) {
+  int x = 0, y, offset = 0;
+  char *word = (char *)msSmallMalloc(sizeof(char) * (strlen(line) + 1));
 
-  for(x=0; ((line[x]) && (line[x] == skip)); x++);
+  for (x = 0; ((line[x]) && (line[x] == skip)); x++)
+    ;
   offset = x;
 
-  for(x=offset; ((line[x]) && (line[x] != stop)); x++)
-    word[x-offset] = line[x];
+  for (x = offset; ((line[x]) && (line[x] != stop)); x++)
+    word[x - offset] = line[x];
 
-  word[x-offset] = '\0';
-  if(line[x]) ++x;
-  y=0;
+  word[x - offset] = '\0';
+  if (line[x])
+    ++x;
+  y = 0;
 
-  while((line[y++] = line[x++]));
+  while ((line[y++] = line[x++]))
+    ;
   return word;
 }
 
-char *makeword(char *line, char stop)
-{
-  int x = 0,y;
-  char *word = (char *) msSmallMalloc(sizeof(char) * (strlen(line) + 1));
+char *makeword(char *line, char stop) {
+  int x = 0, y;
+  char *word = (char *)msSmallMalloc(sizeof(char) * (strlen(line) + 1));
 
-  for(x=0; ((line[x]) && (line[x] != stop)); x++)
+  for (x = 0; ((line[x]) && (line[x] != stop)); x++)
     word[x] = line[x];
 
   word[x] = '\0';
-  if(line[x]) ++x;
-  y=0;
+  if (line[x])
+    ++x;
+  y = 0;
 
-  while((line[y++] = line[x++]));
+  while ((line[y++] = line[x++]))
+    ;
   return word;
 }
 
-char *fmakeword(FILE *f, char stop, int *cl)
-{
+char *fmakeword(FILE *f, char stop, int *cl) {
   int wsize;
   char *word;
   int ll;
 
   wsize = 102400;
-  ll=0;
-  word = (char *) msSmallMalloc(sizeof(char) * (wsize + 1));
+  ll = 0;
+  word = (char *)msSmallMalloc(sizeof(char) * (wsize + 1));
 
-  while(1) {
+  while (1) {
     word[ll] = (char)fgetc(f);
-    if(ll==wsize) {
-      word[ll+1] = '\0';
-      wsize+=102400;
-      word = (char *)msSmallRealloc(word,sizeof(char)*(wsize+1));
+    if (ll == wsize) {
+      word[ll + 1] = '\0';
+      wsize += 102400;
+      word = (char *)msSmallRealloc(word, sizeof(char) * (wsize + 1));
     }
     --(*cl);
-    if((word[ll] == stop) || (feof(f)) || (!(*cl))) {
-      if(word[ll] != stop) ll++;
+    if ((word[ll] == stop) || (feof(f)) || (!(*cl))) {
+      if (word[ll] != stop)
+        ll++;
       word[ll] = '\0';
-      word = (char *) msSmallRealloc(word, ll+1);
+      word = (char *)msSmallRealloc(word, ll + 1);
       return word;
     }
     ++ll;
   }
 }
 
-char x2c(char *what)
-{
+char x2c(char *what) {
   register char digit;
 
-  digit = (what[0] >= 'A' ? ((what[0] & 0xdf) - 'A')+10 : (what[0] - '0'));
+  digit = (what[0] >= 'A' ? ((what[0] & 0xdf) - 'A') + 10 : (what[0] - '0'));
   digit *= 16;
-  digit += (what[1] >= 'A' ? ((what[1] & 0xdf) - 'A')+10 : (what[1] - '0'));
-  return(digit);
+  digit += (what[1] >= 'A' ? ((what[1] & 0xdf) - 'A') + 10 : (what[1] - '0'));
+  return (digit);
 }
 
-void unescape_url(char *url)
-{
-  register int x,y;
-
-  for(x=0,y=0; url[y]; ++x,++y) {
-    if((url[x] = url[y]) == '%') {
-      url[x] = x2c(&url[y+1]);
-      y+=2;
+void unescape_url(char *url) {
+  register int x, y;
+
+  for (x = 0, y = 0; url[y]; ++x, ++y) {
+    if ((url[x] = url[y]) == '%') {
+      url[x] = x2c(&url[y + 1]);
+      y += 2;
     }
   }
   url[x] = '\0';
 }
 
-void plustospace(char *str)
-{
+void plustospace(char *str) {
   register int x;
 
-  for(x=0; str[x]; x++) if(str[x] == '+') str[x] = ' ';
+  for (x = 0; str[x]; x++)
+    if (str[x] == '+')
+      str[x] = ' ';
 }
 
-int rind(char *s, char c)
-{
+int rind(char *s, char c) {
   register int x;
-  for(x=strlen(s) - 1; x != -1; x--)
-    if(s[x] == c) return x;
+  for (x = strlen(s) - 1; x != -1; x--)
+    if (s[x] == c)
+      return x;
   return -1;
 }
 
-void send_fd(FILE *f, FILE *fd)
-{
+void send_fd(FILE *f, FILE *fd) {
   int c;
 
   while (1) {
     c = fgetc(f);
-    if(c == EOF)
+    if (c == EOF)
       return;
-    fputc((char)c,fd);
+    fputc((char)c, fd);
   }
 }
 
-int ind(char *s, char c)
-{
+int ind(char *s, char c) {
   register int x;
 
-  for(x=0; s[x]; x++)
-    if(s[x] == c) return x;
+  for (x = 0; s[x]; x++)
+    if (s[x] == c)
+      return x;
 
   return -1;
 }
@@ -428,15 +457,14 @@ int ind(char *s, char c)
 /*
 ** patched version according to CERT advisory...
 */
-void escape_shell_cmd(char *cmd)
-{
-  register int x,y,l;
-
-  l=strlen(cmd);
-  for(x=0; cmd[x]; x++) {
-    if(ind("&;`'\"|*?~<>^()[]{}$\\\n",cmd[x]) != -1) {
-      for(y=l+1; y>x; y--)
-        cmd[y] = cmd[y-1];
+void escape_shell_cmd(char *cmd) {
+  register int x, y, l;
+
+  l = strlen(cmd);
+  for (x = 0; cmd[x]; x++) {
+    if (ind("&;`'\"|*?~<>^()[]{}$\\\n", cmd[x]) != -1) {
+      for (y = l + 1; y > x; y--)
+        cmd[y] = cmd[y - 1];
       l++; /* length has been increased */
       cmd[x] = '\\';
       x++; /* skip the character */
@@ -447,15 +475,16 @@ void escape_shell_cmd(char *cmd)
 /*
 ** Allocate a new request holder structure
 */
-cgiRequestObj *msAllocCgiObj()
-{
+cgiRequestObj *msAllocCgiObj() {
   cgiRequestObj *request = (cgiRequestObj *)malloc(sizeof(cgiRequestObj));
 
-  if(!request)
+  if (!request)
     return NULL;
 
-  request->ParamNames = (char **) msSmallMalloc(MS_DEFAULT_CGI_PARAMS*sizeof(char*));
-  request->ParamValues = (char **) msSmallMalloc(MS_DEFAULT_CGI_PARAMS*sizeof(char*));
+  request->ParamNames =
+      (char **)msSmallMalloc(MS_DEFAULT_CGI_PARAMS * sizeof(char *));
+  request->ParamValues =
+      (char **)msSmallMalloc(MS_DEFAULT_CGI_PARAMS * sizeof(char *));
   request->NumParams = 0;
   request->type = MS_GET_REQUEST;
   request->contenttype = NULL;
@@ -469,8 +498,7 @@ cgiRequestObj *msAllocCgiObj()
   return request;
 }
 
-void msFreeCgiObj(cgiRequestObj *request)
-{
+void msFreeCgiObj(cgiRequestObj *request) {
   msFreeCharArray(request->ParamNames, request->NumParams);
   msFreeCharArray(request->ParamValues, request->NumParams);
   request->ParamNames = NULL;
@@ -484,7 +512,7 @@ void msFreeCgiObj(cgiRequestObj *request
   request->postrequest = NULL;
   request->httpcookiedata = NULL;
 
-  if(request->api_path) {
+  if (request->api_path) {
     msFreeCharArray(request->api_path, request->api_path_length);
     request->api_path = NULL;
     request->api_path_length = 0;
diff -pruN 8.0.1-5/cgiutil.h 8.0.2-1/cgiutil.h
--- 8.0.1-5/cgiutil.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/cgiutil.h	2024-06-11 20:41:34.000000000 +0000
@@ -5,7 +5,8 @@
  * Purpose:  cgiRequestObj and CGI parsing utility related declarations.
  * Author:   Steve Lime and the MapServer team.
  *
- * Notes: Portions derived from NCSA HTTPd Server's example CGI programs (util.c).
+ * Notes: Portions derived from NCSA HTTPd Server's example CGI programs
+ *(util.c).
  *
  ******************************************************************************
  * Copyright (c) 1996-2005 Regents of the University of Minnesota.
@@ -37,9 +38,9 @@ extern "C" {
 #endif
 
 #if defined(_WIN32) && !defined(__CYGWIN__)
-#  define MS_DLL_EXPORT     __declspec(dllexport)
+#define MS_DLL_EXPORT __declspec(dllexport)
 #else
-#define  MS_DLL_EXPORT
+#define MS_DLL_EXPORT
 #endif
 
 /*
@@ -47,7 +48,7 @@ extern "C" {
 */
 #define MS_DEFAULT_CGI_PARAMS 100
 
-enum MS_REQUEST_TYPE {MS_GET_REQUEST, MS_POST_REQUEST};
+enum MS_REQUEST_TYPE { MS_GET_REQUEST, MS_POST_REQUEST };
 
 /**
 Class for programming OWS services
@@ -66,9 +67,10 @@ typedef struct {
   %mutable;
 #endif
 
-  enum MS_REQUEST_TYPE type; ///< A :ref:`request type constant<mapfile-constants-requesttype>`
-  char *contenttype; ///< The content type of the request
-  char *postrequest; ///< Any POST data request
+  enum MS_REQUEST_TYPE
+      type; ///< A :ref:`request type constant<mapfile-constants-requesttype>`
+  char *contenttype;    ///< The content type of the request
+  char *postrequest;    ///< Any POST data request
   char *httpcookiedata; ///< Any cookie data associated with the request
 
 #ifndef SWIG
@@ -78,13 +80,15 @@ typedef struct {
 #endif
 } cgiRequestObj;
 
-
 /*
 ** Function prototypes
 */
 #ifndef SWIG
-MS_DLL_EXPORT int loadParams(cgiRequestObj *request, char* (*getenv2)(const char*, void* thread_context),
-                             char *raw_post_data, ms_uint32 raw_post_data_length, void* thread_context);
+MS_DLL_EXPORT int
+loadParams(cgiRequestObj *request,
+           char *(*getenv2)(const char *, void *thread_context),
+           char *raw_post_data, ms_uint32 raw_post_data_length,
+           void *thread_context);
 MS_DLL_EXPORT void getword(char *, char *, char);
 MS_DLL_EXPORT char *makeword_skip(char *, char, char);
 MS_DLL_EXPORT char *makeword(char *, char);
diff -pruN 8.0.1-5/classobject.c 8.0.2-1/classobject.c
--- 8.0.1-5/classobject.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/classobject.c	2024-06-11 20:41:34.000000000 +0000
@@ -31,17 +31,17 @@
 
 #include "mapserver.h"
 
-
 /*
-** Add a label to a classObj (order doesn't matter for labels like it does with styles)
+** Add a label to a classObj (order doesn't matter for labels like it does with
+*styles)
 */
-int msAddLabelToClass(classObj *class, labelObj *label)
-{
+int msAddLabelToClass(classObj *class, labelObj *label) {
   if (!label) {
     msSetError(MS_CHILDERR, "Can't add a NULL label.", "msAddLabelToClass()");
     return MS_FAILURE;
   }
-  if (msGrowClassLabels(class) == NULL) return MS_FAILURE;
+  if (msGrowClassLabels(class) == NULL)
+    return MS_FAILURE;
 
   /* msGrowClassLabels will alloc the label, free it in this case */
   free(class->labels[class->numlabels]);
@@ -54,20 +54,20 @@ int msAddLabelToClass(classObj *class, l
 /*
 ** Remove a label from a classObj.
 */
-labelObj *msRemoveLabelFromClass(classObj *class, int nLabelIndex)
-{
+labelObj *msRemoveLabelFromClass(classObj *class, int nLabelIndex) {
   int i;
   labelObj *label;
 
   if (nLabelIndex < 0 || nLabelIndex >= class->numlabels) {
-    msSetError(MS_CHILDERR, "Cannot remove label, invalid index %d", "msRemoveLabelFromClass()", nLabelIndex);
+    msSetError(MS_CHILDERR, "Cannot remove label, invalid index %d",
+               "msRemoveLabelFromClass()", nLabelIndex);
     return NULL;
   } else {
-    label=class->labels[nLabelIndex];
-    for (i=nLabelIndex; i<class->numlabels-1; i++) {
-      class->labels[i]=class->labels[i+1];
+    label = class->labels[nLabelIndex];
+    for (i = nLabelIndex; i < class->numlabels - 1; i++) {
+      class->labels[i] = class->labels[i + 1];
     }
-    class->labels[class->numlabels-1]=NULL;
+    class->labels[class->numlabels - 1] = NULL;
     class->numlabels--;
     MS_REFCNT_DECR(label);
     return label;
@@ -77,47 +77,41 @@ labelObj *msRemoveLabelFromClass(classOb
 /**
  * Move the style up inside the array of styles.
  */
-int msMoveStyleUp(classObj *class, int nStyleIndex)
-{
+int msMoveStyleUp(classObj *class, int nStyleIndex) {
   styleObj *psTmpStyle = NULL;
-  if (class && nStyleIndex < class->numstyles && nStyleIndex >0) {
+  if (class && nStyleIndex < class->numstyles && nStyleIndex > 0) {
     psTmpStyle = (styleObj *)malloc(sizeof(styleObj));
     initStyle(psTmpStyle);
 
     msCopyStyle(psTmpStyle, class->styles[nStyleIndex]);
 
-    msCopyStyle(class->styles[nStyleIndex],
-                class->styles[nStyleIndex-1]);
+    msCopyStyle(class->styles[nStyleIndex], class->styles[nStyleIndex - 1]);
 
-    msCopyStyle(class->styles[nStyleIndex-1], psTmpStyle);
+    msCopyStyle(class->styles[nStyleIndex - 1], psTmpStyle);
 
-    return(MS_SUCCESS);
+    return (MS_SUCCESS);
   }
-  msSetError(MS_CHILDERR, "Invalid index: %d", "msMoveStyleUp()",
-             nStyleIndex);
+  msSetError(MS_CHILDERR, "Invalid index: %d", "msMoveStyleUp()", nStyleIndex);
   return (MS_FAILURE);
 }
 
-
 /**
  * Move the style down inside the array of styles.
  */
-int msMoveStyleDown(classObj *class, int nStyleIndex)
-{
+int msMoveStyleDown(classObj *class, int nStyleIndex) {
   styleObj *psTmpStyle = NULL;
 
-  if (class && nStyleIndex < class->numstyles-1 && nStyleIndex >=0) {
+  if (class && nStyleIndex < class->numstyles - 1 && nStyleIndex >= 0) {
     psTmpStyle = (styleObj *)malloc(sizeof(styleObj));
     initStyle(psTmpStyle);
 
     msCopyStyle(psTmpStyle, class->styles[nStyleIndex]);
 
-    msCopyStyle(class->styles[nStyleIndex],
-                class->styles[nStyleIndex+1]);
+    msCopyStyle(class->styles[nStyleIndex], class->styles[nStyleIndex + 1]);
 
-    msCopyStyle(class->styles[nStyleIndex+1], psTmpStyle);
+    msCopyStyle(class->styles[nStyleIndex + 1], psTmpStyle);
 
-    return(MS_SUCCESS);
+    return (MS_SUCCESS);
   }
   msSetError(MS_CHILDERR, "Invalid index: %d", "msMoveStyleDown()",
              nStyleIndex);
@@ -129,8 +123,7 @@ int msMoveStyleDown(classObj *class, int
  * Returns the index at which the style was inserted
  *
  */
-int msInsertStyle(classObj *class, styleObj *style, int nStyleIndex)
-{
+int msInsertStyle(classObj *class, styleObj *style, int nStyleIndex) {
   int i;
 
   if (!style) {
@@ -144,39 +137,40 @@ int msInsertStyle(classObj *class, style
   }
   /* Catch attempt to insert past end of styles array */
   else if (nStyleIndex >= class->numstyles) {
-    msSetError(MS_CHILDERR, "Cannot insert style beyond index %d", "insertStyle()", class->numstyles-1);
+    msSetError(MS_CHILDERR, "Cannot insert style beyond index %d",
+               "insertStyle()", class->numstyles - 1);
     return -1;
   } else if (nStyleIndex < 0) { /* Insert at the end by default */
-    class->styles[class->numstyles]=style;
+    class->styles[class->numstyles] = style;
     MS_REFCNT_INCR(style);
     class->numstyles++;
-    return class->numstyles-1;
+    return class->numstyles - 1;
   } else {
     /* Move styles existing at the specified nStyleIndex or greater */
     /* to a higher nStyleIndex */
-    for (i=class->numstyles-1; i>=nStyleIndex; i--) {
-      class->styles[i+1] = class->styles[i];
+    for (i = class->numstyles - 1; i >= nStyleIndex; i--) {
+      class->styles[i + 1] = class->styles[i];
     }
-    class->styles[nStyleIndex]=style;
+    class->styles[nStyleIndex] = style;
     MS_REFCNT_INCR(style);
     class->numstyles++;
     return nStyleIndex;
   }
 }
 
-styleObj *msRemoveStyle(classObj *class, int nStyleIndex)
-{
+styleObj *msRemoveStyle(classObj *class, int nStyleIndex) {
   int i;
   styleObj *style;
   if (nStyleIndex < 0 || nStyleIndex >= class->numstyles) {
-    msSetError(MS_CHILDERR, "Cannot remove style, invalid nStyleIndex %d", "removeStyle()", nStyleIndex);
+    msSetError(MS_CHILDERR, "Cannot remove style, invalid nStyleIndex %d",
+               "removeStyle()", nStyleIndex);
     return NULL;
   } else {
-    style=class->styles[nStyleIndex];
-    for (i=nStyleIndex; i<class->numstyles-1; i++) {
-      class->styles[i]=class->styles[i+1];
+    style = class->styles[nStyleIndex];
+    for (i = nStyleIndex; i < class->numstyles - 1; i++) {
+      class->styles[i] = class->styles[i + 1];
     }
-    class->styles[class->numstyles-1]=NULL;
+    class->styles[class->numstyles - 1] = NULL;
     class->numstyles--;
     MS_REFCNT_DECR(style);
     return style;
@@ -187,19 +181,17 @@ styleObj *msRemoveStyle(classObj *class,
  * Delete the style identified by the index and shift
  * styles that follows the deleted style.
  */
-int msDeleteStyle(classObj *class, int nStyleIndex)
-{
-  if (class && nStyleIndex < class->numstyles && nStyleIndex >=0) {
+int msDeleteStyle(classObj *class, int nStyleIndex) {
+  if (class && nStyleIndex < class->numstyles && nStyleIndex >= 0) {
     if (freeStyle(class->styles[nStyleIndex]) == MS_SUCCESS)
       msFree(class->styles[nStyleIndex]);
-    for (int i=nStyleIndex; i< class->numstyles-1; i++) {
-      class->styles[i] = class->styles[i+1];
+    for (int i = nStyleIndex; i < class->numstyles - 1; i++) {
+      class->styles[i] = class->styles[i + 1];
     }
-    class->styles[class->numstyles-1] = NULL;
+    class->styles[class->numstyles - 1] = NULL;
     class->numstyles--;
-    return(MS_SUCCESS);
+    return (MS_SUCCESS);
   }
-  msSetError(MS_CHILDERR, "Invalid index: %d", "msDeleteStyle()",
-             nStyleIndex);
+  msSetError(MS_CHILDERR, "Invalid index: %d", "msDeleteStyle()", nStyleIndex);
   return (MS_FAILURE);
 }
diff -pruN 8.0.1-5/coshp.c 8.0.2-1/coshp.c
--- 8.0.1-5/coshp.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/coshp.c	2024-06-11 20:41:34.000000000 +0000
@@ -33,7 +33,6 @@
 
 #include "mapserver.h"
 
-
 typedef struct {
   SHPHandle inSHP, outSHP;
   DBFHandle inDBF, outDBF;
@@ -41,39 +40,37 @@ typedef struct {
   int numDbfFields;
 } writeState;
 
-static char* AddFileSuffix ( const char * Filename, const char * Suffix )
-{
-  char  *pszFullname, *pszBasename;
+static char *AddFileSuffix(const char *Filename, const char *Suffix) {
+  char *pszFullname, *pszBasename;
   int i;
 
   /* -------------------------------------------------------------------- */
   /*  Compute the base (layer) name.  If there is any extension     */
   /*  on the passed in filename we will strip it off.         */
   /* -------------------------------------------------------------------- */
-  pszBasename = (char *) msSmallMalloc(strlen(Filename)+5);
-  strcpy( pszBasename, Filename );
-  for( i = (int)strlen(pszBasename)-1;
-       i > 0 && pszBasename[i] != '.' && pszBasename[i] != '/'
-       && pszBasename[i] != '\\';
-       i-- ) {}
+  pszBasename = (char *)msSmallMalloc(strlen(Filename) + 5);
+  strcpy(pszBasename, Filename);
+  for (i = (int)strlen(pszBasename) - 1;
+       i > 0 && pszBasename[i] != '.' && pszBasename[i] != '/' &&
+       pszBasename[i] != '\\';
+       i--) {
+  }
 
-  if( pszBasename[i] == '.' )
+  if (pszBasename[i] == '.')
     pszBasename[i] = '\0';
 
   /* -------------------------------------------------------------------- */
   /*  Open the .shp and .shx files.  Note that files pulled from      */
   /*  a PC to Unix with upper case filenames won't work!        */
   /* -------------------------------------------------------------------- */
-  pszFullname = (char *) msSmallMalloc(strlen(pszBasename) + 5);
-  sprintf( pszFullname, "%s%s", pszBasename, Suffix);
+  pszFullname = (char *)msSmallMalloc(strlen(pszBasename) + 5);
+  sprintf(pszFullname, "%s%s", pszBasename, Suffix);
 
   free(pszBasename);
   return (pszFullname);
 }
 
-
-static int writeShape(writeState *state, int shapeId)
-{
+static int writeShape(writeState *state, int shapeId) {
   int j = 0;
   int i = state->currentOutRecord;
   char fName[20];
@@ -81,33 +78,37 @@ static int writeShape(writeState *state,
   shapeObj shape;
 
   /* Copy the DBF record over */
-  for(j=0; j<state->numDbfFields; j++) {
+  for (j = 0; j < state->numDbfFields; j++) {
 
-    DBFFieldType dbfField = msDBFGetFieldInfo(state->inDBF, j, fName, &fWidth, &fnDecimals);
+    DBFFieldType dbfField =
+        msDBFGetFieldInfo(state->inDBF, j, fName, &fWidth, &fnDecimals);
 
     switch (dbfField) {
-      case FTInteger:
-        msDBFWriteIntegerAttribute(state->outDBF, i, j,
+    case FTInteger:
+      msDBFWriteIntegerAttribute(
+          state->outDBF, i, j,
           msDBFReadIntegerAttribute(state->inDBF, shapeId, j));
-        break;
-      case FTDouble:
-        msDBFWriteDoubleAttribute(state->outDBF, i, j,
+      break;
+    case FTDouble:
+      msDBFWriteDoubleAttribute(
+          state->outDBF, i, j,
           msDBFReadDoubleAttribute(state->inDBF, shapeId, j));
-        break;
-      case FTString:
-        msDBFWriteStringAttribute(state->outDBF, i, j,
+      break;
+    case FTString:
+      msDBFWriteStringAttribute(
+          state->outDBF, i, j,
           msDBFReadStringAttribute(state->inDBF, shapeId, j));
-        break;
-      default:
-        fprintf(stderr,"Unsupported data type for field: %s, exiting.\n",fName);
-        exit(0);
+      break;
+    default:
+      fprintf(stderr, "Unsupported data type for field: %s, exiting.\n", fName);
+      exit(0);
     }
   }
 
   /* Copy the SHP record over */
-  msSHPReadShape( state->inSHP, shapeId, &shape );
-  msSHPWriteShape( state->outSHP, &shape );
-  msFreeShape( &shape );
+  msSHPReadShape(state->inSHP, shapeId, &shape);
+  msSHPWriteShape(state->outSHP, &shape);
+  msFreeShape(&shape);
 
   /* Increment output row number */
   state->currentOutRecord++;
@@ -115,59 +116,59 @@ static int writeShape(writeState *state,
   return MS_SUCCESS;
 }
 
-
-static int writeNode(writeState *state, treeNodeObj *node)
-{
+static int writeNode(writeState *state, treeNodeObj *node) {
   int i;
   if (node->ids) {
-    for(i = 0; i < node->numshapes; i++) {
+    for (i = 0; i < node->numshapes; i++) {
       int curRec = state->currentOutRecord;
       writeShape(state, node->ids[i]);
       node->ids[i] = curRec;
     }
   }
-  for(i = 0; i < node->numsubnodes; i++) {
+  for (i = 0; i < node->numsubnodes; i++) {
     if (node->subnode[i])
       writeNode(state, node->subnode[i]);
   }
   return MS_SUCCESS;
 }
 
-
-int main(int argc, char *argv[])
-{
+int main(int argc, char *argv[]) {
   treeObj *tree;          /* In-memory index */
   shapefileObj shapefile; /* Input shapefile */
-  SHPHandle    outSHP;    /* Output SHP */
-  DBFHandle    outDBF;    /* Output DBF */
+  SHPHandle outSHP;       /* Output SHP */
+  DBFHandle outDBF;       /* Output DBF */
   DBFFieldType dbfField;
-  writeState   state;
-  int          shpType, nShapes;
-  char         fName[20];
-  int          fWidth, fnDecimals;
-  char         buffer[1024];
-  int          numFields;
-  int          i;
+  writeState state;
+  int shpType, nShapes;
+  char fName[20];
+  int fWidth, fnDecimals;
+  char buffer[1024];
+  int numFields;
+  int i;
 
-  if(argc > 1 && strcmp(argv[1], "-v") == 0) {
+  if (argc > 1 && strcmp(argv[1], "-v") == 0) {
     printf("%s\n", msGetVersion());
     exit(0);
   }
 
-  /* ------------------------------------------------------------------------------- */
-  /*       Check the number of arguments, return syntax if not correct               */
-  /* ------------------------------------------------------------------------------- */
-  if( argc != 3 ) {
-    fprintf(stderr,"Syntax: %s [infile] [outfile]\n", argv[0]);
+  /* -------------------------------------------------------------------------------
+   */
+  /*       Check the number of arguments, return syntax if not correct */
+  /* -------------------------------------------------------------------------------
+   */
+  if (argc != 3) {
+    fprintf(stderr, "Syntax: %s [infile] [outfile]\n", argv[0]);
     exit(1);
   }
 
   msSetErrorFile("stderr", NULL);
 
-  /* ------------------------------------------------------------------------------- */
-  /*       Open the shapefile                                                        */
-  /* ------------------------------------------------------------------------------- */
-  if(msShapefileOpen(&shapefile, "rb", argv[1], MS_TRUE) < 0) {
+  /* -------------------------------------------------------------------------------
+   */
+  /*       Open the shapefile */
+  /* -------------------------------------------------------------------------------
+   */
+  if (msShapefileOpen(&shapefile, "rb", argv[1], MS_TRUE) < 0) {
     fprintf(stdout, "Error opening shapefile %s.\n", argv[1]);
     exit(0);
   }
@@ -176,37 +177,45 @@ int main(int argc, char *argv[])
   shpType = shapefile.type;
   numFields = msDBFGetFieldCount(shapefile.hDBF);
 
-  /* ------------------------------------------------------------------------------- */
-  /*       Index the shapefile (auto-calculate depth)                                */
-  /* ------------------------------------------------------------------------------- */
+  /* -------------------------------------------------------------------------------
+   */
+  /*       Index the shapefile (auto-calculate depth) */
+  /* -------------------------------------------------------------------------------
+   */
   tree = msCreateTree(&shapefile, 0);
   msTreeTrim(tree);
 
-  /* ------------------------------------------------------------------------------- */
-  /*       Setup the output .shp/.shx and .dbf files                                 */
-  /* ------------------------------------------------------------------------------- */
+  /* -------------------------------------------------------------------------------
+   */
+  /*       Setup the output .shp/.shx and .dbf files */
+  /* -------------------------------------------------------------------------------
+   */
   outSHP = msSHPCreate(argv[2], shpType);
-  if( outSHP == NULL ) {
-    fprintf( stderr, "Failed to create file '%s'.\n", argv[2] );
-    exit( 1 );
+  if (outSHP == NULL) {
+    fprintf(stderr, "Failed to create file '%s'.\n", argv[2]);
+    exit(1);
   }
 
-  sprintf(buffer,"%s.dbf", argv[2]);
+  sprintf(buffer, "%s.dbf", argv[2]);
   outDBF = msDBFCreate(buffer);
-  if( outDBF == NULL ) {
-    fprintf( stderr, "Failed to create dbf file '%s'.\n", buffer );
-    exit( 1 );
+  if (outDBF == NULL) {
+    fprintf(stderr, "Failed to create dbf file '%s'.\n", buffer);
+    exit(1);
   }
 
   /* Clone the fields from the input to the output definition */
-  for(i=0; i<numFields; i++) {
-    dbfField = msDBFGetFieldInfo(shapefile.hDBF, i, fName, &fWidth, &fnDecimals); /* ---- Get field info from in file ---- */
+  for (i = 0; i < numFields; i++) {
+    dbfField = msDBFGetFieldInfo(
+        shapefile.hDBF, i, fName, &fWidth,
+        &fnDecimals); /* ---- Get field info from in file ---- */
     msDBFAddField(outDBF, fName, dbfField, fWidth, fnDecimals);
   }
 
-  /* ------------------------------------------------------------------------------- */
-  /*       Write the sorted .shp/.shx and .dbf files                                 */
-  /* ------------------------------------------------------------------------------- */
+  /* -------------------------------------------------------------------------------
+   */
+  /*       Write the sorted .shp/.shx and .dbf files */
+  /* -------------------------------------------------------------------------------
+   */
 
   /* Set up writer state */
   state.inSHP = shapefile.hSHP;
@@ -218,19 +227,25 @@ int main(int argc, char *argv[])
 
   writeNode(&state, tree->root);
 
-  /* ------------------------------------------------------------------------------- */
-  /*       Write the spatial index                                                   */
-  /* ------------------------------------------------------------------------------- */
-  msWriteTree(tree, AddFileSuffix(argv[2], MS_INDEX_EXTENSION), MS_NEW_LSB_ORDER);
+  /* -------------------------------------------------------------------------------
+   */
+  /*       Write the spatial index */
+  /* -------------------------------------------------------------------------------
+   */
+  msWriteTree(tree, AddFileSuffix(argv[2], MS_INDEX_EXTENSION),
+              MS_NEW_LSB_ORDER);
   msDestroyTree(tree);
 
-  /* ------------------------------------------------------------------------------- */
-  /*       Close all files                                                           */
-  /* ------------------------------------------------------------------------------- */
+  /* -------------------------------------------------------------------------------
+   */
+  /*       Close all files */
+  /* -------------------------------------------------------------------------------
+   */
   msShapefileClose(&shapefile);
   msSHPClose(outSHP);
   msDBFClose(outDBF);
 
-  fprintf(stdout, "Wrote %d spatially sorted shapes into shapefile '%s'\n", nShapes, argv[2]);
-  return(0);
+  fprintf(stdout, "Wrote %d spatially sorted shapes into shapefile '%s'\n",
+          nShapes, argv[2]);
+  return (0);
 }
diff -pruN 8.0.1-5/debian/changelog 8.0.2-1/debian/changelog
--- 8.0.1-5/debian/changelog	2024-05-08 16:48:14.000000000 +0000
+++ 8.0.2-1/debian/changelog	2024-06-12 03:46:07.000000000 +0000
@@ -1,3 +1,14 @@
+mapserver (8.0.2-1) unstable; urgency=high
+
+  * New upstream release.
+  * Update upstream branch in gbp.conf.
+  * Update watch file to match only 8.0 releases.
+  * Update copyright file.
+  * Drop spelling-errors.patch, applied upstream.
+  * Update symbols for amd64.
+
+ -- Bas Couwenberg <sebastic@debian.org>  Wed, 12 Jun 2024 05:46:07 +0200
+
 mapserver (8.0.1-5) unstable; urgency=medium
 
   * Add patch to fix FTBFS with glibc 2.38.
diff -pruN 8.0.1-5/debian/copyright 8.0.2-1/debian/copyright
--- 8.0.1-5/debian/copyright	2024-03-25 10:04:46.000000000 +0000
+++ 8.0.2-1/debian/copyright	2024-06-12 03:45:53.000000000 +0000
@@ -23,7 +23,7 @@ Copyright:                    Joyent, In
                         2021, MapServer team
             2008, 2010, 2021, Paul Ramsey
                    1996-2022, Regents of the University of Minnesota.
-                   2008-2023, Open Source Geospatial Foundation.
+                   2008-2024, Open Source Geospatial Foundation.
 License: MIT
 
 Files: dejavu-sans-condensed.h
diff -pruN 8.0.1-5/debian/gbp.conf 8.0.2-1/debian/gbp.conf
--- 8.0.1-5/debian/gbp.conf	2024-03-25 10:04:46.000000000 +0000
+++ 8.0.2-1/debian/gbp.conf	2024-06-12 03:40:12.000000000 +0000
@@ -2,7 +2,7 @@
 
 # The default name for the upstream branch is "upstream".
 # Change it if the name is different (for instance, "master").
-upstream-branch = upstream
+upstream-branch = upstream-8.0
 
 # The default name for the Debian branch is "master".
 # Change it if the name is different (for instance, "debian/unstable").
diff -pruN 8.0.1-5/debian/libmapserver2t64.symbols 8.0.2-1/debian/libmapserver2t64.symbols
--- 8.0.1-5/debian/libmapserver2t64.symbols	2024-05-08 16:48:14.000000000 +0000
+++ 8.0.2-1/debian/libmapserver2t64.symbols	2024-06-12 03:46:07.000000000 +0000
@@ -1,4 +1,4 @@
-# SymbolsHelper-Confirmed: 8.0.1 alpha amd64 arm64 armel armhf i386 ia64 loong64 m68k mips64el mipsel powerpc ppc64 ppc64el riscv64 s390x sparc64
+# SymbolsHelper-Confirmed: 8.0.2 amd64
 libmapserver.so.2 #PACKAGE# #MINVER#
 * Build-Depends-Package: libmapserver-dev
  BuildExpressionTree@Base 6.2.1
@@ -523,8 +523,6 @@ libmapserver.so.2 #PACKAGE# #MINVER#
  _ZN4inja11LiteralNodeD0Ev@Base 8.0.0
  _ZN4inja11LiteralNodeD1Ev@Base 8.0.0
  _ZN4inja11LiteralNodeD2Ev@Base 8.0.0
- (arch=amd64)_ZN4inja11ParserErrorC1ERKNSt7__cxx1112basic_stringIcSt11char_traitsIcESaIcEEENS_14SourceLocationE@Base 8.0.1
- (arch=amd64)_ZN4inja11ParserErrorC2ERKNSt7__cxx1112basic_stringIcSt11char_traitsIcESaIcEEENS_14SourceLocationE@Base 8.0.1
  _ZN4inja11ParserErrorD0Ev@Base 8.0.0
  _ZN4inja11ParserErrorD1Ev@Base 8.0.0
  _ZN4inja11ParserErrorD2Ev@Base 8.0.0
@@ -2512,6 +2510,7 @@ libmapserver.so.2 #PACKAGE# #MINVER#
  msLayerGetPaging@Base 6.2.1
  msLayerGetProcessing@Base 6.2.1
  msLayerGetProcessingKey@Base 6.2.1
+ msLayerGetReprojectorToMap@Base 8.0.2
  msLayerGetShape@Base 6.2.1
  msLayerGetShapeCount@Base 7.2.0
  msLayerInitItemInfo@Base 6.2.1
@@ -2756,6 +2755,7 @@ libmapserver.so.2 #PACKAGE# #MINVER#
  msProjectCreateReprojector@Base 7.6.0
  msProjectDestroyReprojector@Base 7.6.0
  msProjectHasLonWrap@Base 7.0.7
+ msProjectIsReprojectorStillValid@Base 8.0.2
  msProjectLine@Base 6.2.1
  msProjectLineEx@Base 7.6.0
  msProjectPoint@Base 6.2.1
diff -pruN 8.0.1-5/debian/patches/series 8.0.2-1/debian/patches/series
--- 8.0.1-5/debian/patches/series	2024-03-25 10:05:45.000000000 +0000
+++ 8.0.2-1/debian/patches/series	2024-06-12 03:46:07.000000000 +0000
@@ -1,4 +1,3 @@
 perl-mapscript-install.patch
 java-hardening.patch
-spelling-errors.patch
 glibc-strlcat.patch
diff -pruN 8.0.1-5/debian/patches/spelling-errors.patch 8.0.2-1/debian/patches/spelling-errors.patch
--- 8.0.1-5/debian/patches/spelling-errors.patch	2024-03-25 10:04:46.000000000 +0000
+++ 8.0.2-1/debian/patches/spelling-errors.patch	1970-01-01 00:00:00.000000000 +0000
@@ -1,17 +0,0 @@
-Description: Fix spelling errors.
- * suported -> supported
-Author: Bas Couwenberg <sebastic@debian.org>
-Forwarded: https://github.com/MapServer/MapServer/pull/6869
-Applied-Upstream: https://github.com/MapServer/MapServer/commit/4caca40c620d425a82091b5a094eb7fd2821271f
-
---- a/mapshape.c
-+++ b/mapshape.c
-@@ -234,7 +234,7 @@ SHPHandle msSHPOpenVirtualFile( VSILFILE
-       VSIFSeekL( psSHP->fpSHP, 0, SEEK_END );
-       vsi_l_offset nSize = VSIFTellL( psSHP->fpSHP );
-       if( nSize > (vsi_l_offset)INT_MAX ) {
--          msDebug("Actual .shp size is larger than 2 GB. Not suported. Invalidating nFileSize");
-+          msDebug("Actual .shp size is larger than 2 GB. Not supported. Invalidating nFileSize");
-           psSHP->nFileSize = 0;
-       }
-       else
diff -pruN 8.0.1-5/debian/watch 8.0.2-1/debian/watch
--- 8.0.1-5/debian/watch	2024-03-25 10:04:46.000000000 +0000
+++ 8.0.2-1/debian/watch	2024-06-12 03:42:03.000000000 +0000
@@ -3,4 +3,4 @@ opts=\
 dversionmangle=s/\+(debian|dfsg|ds|deb)\d*$//,\
 uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/;s/RC/rc/;s/-/./g \
 https://download.osgeo.org/mapserver/ \
-(?:.*/)?(?:rel|v|mapserver)[\-\_]?(\d\S+)\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
+(?:.*/)?(?:rel|v|mapserver)[\-\_]?(8\.0\.\S+)\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
diff -pruN 8.0.1-5/dxfcolor.h 8.0.2-1/dxfcolor.h
--- 8.0.1-5/dxfcolor.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/dxfcolor.h	2024-06-11 20:41:34.000000000 +0000
@@ -1,261 +1,69 @@
 struct dxfcolor {
-  int r,g,b;
+  int r, g, b;
 };
 struct dxfcolor ctable[256] = {
-  {0,   0,  0},
-  {255,   0,  0},
-  {255,   255,  0},
-  {0,   255,  0},
-  {0,   255,  255},
-  {0,   0,  255},
-  {255,   0,  255},
-  {255,   255,  255},
-  {128,   128,  128},
-  {192,   192,  192},
-  {255,   0,  0},
-  {255,   127,  127},
-  {204,   0,  0},
-  {204,   102,  102},
-  {153,   0,  0},
-  {153,   76,   76},
-  {127,   0,  0},
-  {127,   63,   63},
-  {76,  0,  0},
-  {76,  38,   38},
-  {255,   63,   0},
-  {255,   159,  127},
-  {204,   51,   0},
-  {204,   127,  102},
-  {153,   38,   0},
-  {153,   95,   76},
-  {127,   31,   0},
-  {127,   79,   63},
-  {76,  19,   0},
-  {76,  47,   38},
-  {255,   127,  0},
-  {255,   191,  127},
-  {204,   102,  0},
-  {204,   153,  102},
-  {153,   76,   0},
-  {153,   114,  76},
-  {127,   63,   0},
-  {127,   95,   63},
-  {76,  38,   0},
-  {76,  57,   38},
-  {255,   191,  0},
-  {255,   223,  127},
-  {204,   153,  0},
-  {204,   178,  102},
-  {153,   114,  0},
-  {153,   133,  76},
-  {127,   95,   0},
-  {127,   111,  63},
-  {76,  57,   0},
-  {76,  66,   38},
-  {255,   255,  0},
-  {255,   255,  127},
-  {204,   204,  0},
-  {204,   204,  102},
-  {153,   153,  0},
-  {153,   153,  76},
-  {127,   127,  0},
-  {127,   127,  63},
-  {76,  76,   0},
-  {76,  76,   38},
-  {191,   255,  0},
-  {223,   255,  127},
-  {153,   204,  0},
-  {178,   204,  102},
-  {114,   153,  0},
-  {133,   153,  76},
-  {95,  127,  0},
-  {111,   127,  63},
-  {57,  76,   0},
-  {66,  76,   38},
-  {127,   255,  0},
-  {191,   255,  127},
-  {102,   204,  0},
-  {153,   204,  102},
-  {76,  153,  0},
-  {114,   153,  76},
-  {63,  127,  0},
-  {95,  127,  63},
-  {38,  76,   0},
-  {57,  76,   38},
-  {63,  255,  0},
-  {159,   255,  127},
-  {51,  204,  0},
-  {127,   204,  102},
-  {38,  153,  0},
-  {95,  153,  76},
-  {31,  127,  0},
-  {79,  127,  63},
-  {19,  76,   0},
-  {47,  76,   38},
-  {0,   255,  0},
-  {127,   255,  127},
-  {0,   204,  0},
-  {102,   204,  102},
-  {0,   153,  0},
-  {76,  153,  76},
-  {0,   127,  0},
-  {63,  127,  63},
-  {0,   76,   0},
-  {38,  76,   38},
-  {0,   255,  63},
-  {127,   255,  159},
-  {0,   204,  51},
-  {102,   204,  127},
-  {0,   153,  38},
-  {76,  153,  95},
-  {0,   127,  31},
-  {63,  127,  79},
-  {0,   76,   19},
-  {38,  76,   47},
-  {0,   255,  127},
-  {127,   255,  191},
-  {0,   204,  102},
-  {102,   204,  153},
-  {0,   153,  76},
-  {76,  153,  114},
-  {0,   127,  63},
-  {63,  127,  95},
-  {0,   76,   38},
-  {38,  76,   57},
-  {0,   255,  191},
-  {127,   255,  223},
-  {0,   204,  153},
-  {102,   204,  178},
-  {0,   153,  114},
-  {76,  153,  133},
-  {0,   127,  95},
-  {63,  127,  111},
-  {0,   76,   57},
-  {38,  76,   66},
-  {0,   255,  255},
-  {127,   255,  255},
-  {0,   204,  204},
-  {102,   204,  204},
-  {0,   153,  153},
-  {76,  153,  153},
-  {0,   127,  127},
-  {63,  127,  127},
-  {0,   76,   76},
-  {38,  76,   76},
-  {0,   191,  255},
-  {127,   223,  255},
-  {0,   153,  204},
-  {102,   178,  204},
-  {0,   114,  153},
-  {76,  133,  153},
-  {0,   95,   127},
-  {63,  111,  127},
-  {0,   57,   76},
-  {38,  66,   76},
-  {0,   127,  255},
-  {127,   191,  255},
-  {0,   102,  204},
-  {102,   153,  204},
-  {0,   76,   153},
-  {76,  114,  153},
-  {0,   63,   127},
-  {63,  95,   127},
-  {0,   38,   76},
-  {38,  57,   76},
-  {0,   63,   255},
-  {127,   159,  255},
-  {0,   51,   204},
-  {102,   127,  204},
-  {0,   38,   153},
-  {76,  95,   153},
-  {0,   31,   127},
-  {63,  79,   127},
-  {0,   19,   76},
-  {38,  47,   76},
-  {0,   0,  255},
-  {127,   127,  255},
-  {0,   0,  204},
-  {102,   102,  204},
-  {0,   0,  153},
-  {76,  76,   153},
-  {0,   0,  127},
-  {63,  63,   127},
-  {0,   0,  76},
-  {38,  38,   76},
-  {63,  0,  255},
-  {159,   127,  255},
-  {51,  0,  204},
-  {127,   102,  204},
-  {38,  0,  153},
-  {95,  76,   153},
-  {31,  0,  127},
-  {79,  63,   127},
-  {19,  0,  76},
-  {47,  38,   76},
-  {127,   0,  255},
-  {191,   127,  255},
-  {102,   0,  204},
-  {153,   102,  204},
-  {76,  0,  153},
-  {114,   76,   153},
-  {63,  0,  127},
-  {95,  63,   127},
-  {38,  0,  76},
-  {57,  38,   76},
-  {191,   0,  255},
-  {223,   127,  255},
-  {153,   0,  204},
-  {178,   102,  204},
-  {114,   0,  153},
-  {133,   76,   153},
-  {95,  0,  127},
-  {111,   63,   127},
-  {57,  0,  76},
-  {66,  38,   76},
-  {255,   0,  255},
-  {255,   127,  255},
-  {204,   0,  204},
-  {204,   102,  204},
-  {153,   0,  153},
-  {153,   76,   153},
-  {127,   0,  127},
-  {127,   63,   127},
-  {76,  0,  76},
-  {76,  38,   76},
-  {255,   0,  191},
-  {255,   127,  223},
-  {204,   0,  153},
-  {204,   102,  178},
-  {153,   0,  114},
-  {153,   76,   133},
-  {127,   0,  95},
-  {127,   63,   111},
-  {76,  0,  57},
-  {76,  38,   66},
-  {255,   0,  127},
-  {255,   127,  191},
-  {204,   0,  102},
-  {204,   102,  153},
-  {153,   0,  76},
-  {153,   76,   114},
-  {127,   0,  63},
-  {127,   63,   95},
-  {76,  0,  38},
-  {76,  38,   57},
-  {255,   0,  63},
-  {255,   127,  159},
-  {204,   0,  51},
-  {204,   102,  127},
-  {153,   0,  38},
-  {153,   76,   95},
-  {127,   0,  31},
-  {127,   63,   79},
-  {76,  0,  19},
-  {76,  38,   47},
-  {51,  51,   51},
-  {91,  91,   91},
-  {132,   132,  132},
-  {173,   173,  173},
-  {214,   214,  214},
-  {255,   255,  255},
+    {0, 0, 0},       {255, 0, 0},     {255, 255, 0},   {0, 255, 0},
+    {0, 255, 255},   {0, 0, 255},     {255, 0, 255},   {255, 255, 255},
+    {128, 128, 128}, {192, 192, 192}, {255, 0, 0},     {255, 127, 127},
+    {204, 0, 0},     {204, 102, 102}, {153, 0, 0},     {153, 76, 76},
+    {127, 0, 0},     {127, 63, 63},   {76, 0, 0},      {76, 38, 38},
+    {255, 63, 0},    {255, 159, 127}, {204, 51, 0},    {204, 127, 102},
+    {153, 38, 0},    {153, 95, 76},   {127, 31, 0},    {127, 79, 63},
+    {76, 19, 0},     {76, 47, 38},    {255, 127, 0},   {255, 191, 127},
+    {204, 102, 0},   {204, 153, 102}, {153, 76, 0},    {153, 114, 76},
+    {127, 63, 0},    {127, 95, 63},   {76, 38, 0},     {76, 57, 38},
+    {255, 191, 0},   {255, 223, 127}, {204, 153, 0},   {204, 178, 102},
+    {153, 114, 0},   {153, 133, 76},  {127, 95, 0},    {127, 111, 63},
+    {76, 57, 0},     {76, 66, 38},    {255, 255, 0},   {255, 255, 127},
+    {204, 204, 0},   {204, 204, 102}, {153, 153, 0},   {153, 153, 76},
+    {127, 127, 0},   {127, 127, 63},  {76, 76, 0},     {76, 76, 38},
+    {191, 255, 0},   {223, 255, 127}, {153, 204, 0},   {178, 204, 102},
+    {114, 153, 0},   {133, 153, 76},  {95, 127, 0},    {111, 127, 63},
+    {57, 76, 0},     {66, 76, 38},    {127, 255, 0},   {191, 255, 127},
+    {102, 204, 0},   {153, 204, 102}, {76, 153, 0},    {114, 153, 76},
+    {63, 127, 0},    {95, 127, 63},   {38, 76, 0},     {57, 76, 38},
+    {63, 255, 0},    {159, 255, 127}, {51, 204, 0},    {127, 204, 102},
+    {38, 153, 0},    {95, 153, 76},   {31, 127, 0},    {79, 127, 63},
+    {19, 76, 0},     {47, 76, 38},    {0, 255, 0},     {127, 255, 127},
+    {0, 204, 0},     {102, 204, 102}, {0, 153, 0},     {76, 153, 76},
+    {0, 127, 0},     {63, 127, 63},   {0, 76, 0},      {38, 76, 38},
+    {0, 255, 63},    {127, 255, 159}, {0, 204, 51},    {102, 204, 127},
+    {0, 153, 38},    {76, 153, 95},   {0, 127, 31},    {63, 127, 79},
+    {0, 76, 19},     {38, 76, 47},    {0, 255, 127},   {127, 255, 191},
+    {0, 204, 102},   {102, 204, 153}, {0, 153, 76},    {76, 153, 114},
+    {0, 127, 63},    {63, 127, 95},   {0, 76, 38},     {38, 76, 57},
+    {0, 255, 191},   {127, 255, 223}, {0, 204, 153},   {102, 204, 178},
+    {0, 153, 114},   {76, 153, 133},  {0, 127, 95},    {63, 127, 111},
+    {0, 76, 57},     {38, 76, 66},    {0, 255, 255},   {127, 255, 255},
+    {0, 204, 204},   {102, 204, 204}, {0, 153, 153},   {76, 153, 153},
+    {0, 127, 127},   {63, 127, 127},  {0, 76, 76},     {38, 76, 76},
+    {0, 191, 255},   {127, 223, 255}, {0, 153, 204},   {102, 178, 204},
+    {0, 114, 153},   {76, 133, 153},  {0, 95, 127},    {63, 111, 127},
+    {0, 57, 76},     {38, 66, 76},    {0, 127, 255},   {127, 191, 255},
+    {0, 102, 204},   {102, 153, 204}, {0, 76, 153},    {76, 114, 153},
+    {0, 63, 127},    {63, 95, 127},   {0, 38, 76},     {38, 57, 76},
+    {0, 63, 255},    {127, 159, 255}, {0, 51, 204},    {102, 127, 204},
+    {0, 38, 153},    {76, 95, 153},   {0, 31, 127},    {63, 79, 127},
+    {0, 19, 76},     {38, 47, 76},    {0, 0, 255},     {127, 127, 255},
+    {0, 0, 204},     {102, 102, 204}, {0, 0, 153},     {76, 76, 153},
+    {0, 0, 127},     {63, 63, 127},   {0, 0, 76},      {38, 38, 76},
+    {63, 0, 255},    {159, 127, 255}, {51, 0, 204},    {127, 102, 204},
+    {38, 0, 153},    {95, 76, 153},   {31, 0, 127},    {79, 63, 127},
+    {19, 0, 76},     {47, 38, 76},    {127, 0, 255},   {191, 127, 255},
+    {102, 0, 204},   {153, 102, 204}, {76, 0, 153},    {114, 76, 153},
+    {63, 0, 127},    {95, 63, 127},   {38, 0, 76},     {57, 38, 76},
+    {191, 0, 255},   {223, 127, 255}, {153, 0, 204},   {178, 102, 204},
+    {114, 0, 153},   {133, 76, 153},  {95, 0, 127},    {111, 63, 127},
+    {57, 0, 76},     {66, 38, 76},    {255, 0, 255},   {255, 127, 255},
+    {204, 0, 204},   {204, 102, 204}, {153, 0, 153},   {153, 76, 153},
+    {127, 0, 127},   {127, 63, 127},  {76, 0, 76},     {76, 38, 76},
+    {255, 0, 191},   {255, 127, 223}, {204, 0, 153},   {204, 102, 178},
+    {153, 0, 114},   {153, 76, 133},  {127, 0, 95},    {127, 63, 111},
+    {76, 0, 57},     {76, 38, 66},    {255, 0, 127},   {255, 127, 191},
+    {204, 0, 102},   {204, 102, 153}, {153, 0, 76},    {153, 76, 114},
+    {127, 0, 63},    {127, 63, 95},   {76, 0, 38},     {76, 38, 57},
+    {255, 0, 63},    {255, 127, 159}, {204, 0, 51},    {204, 102, 127},
+    {153, 0, 38},    {153, 76, 95},   {127, 0, 31},    {127, 63, 79},
+    {76, 0, 19},     {76, 38, 47},    {51, 51, 51},    {91, 91, 91},
+    {132, 132, 132}, {173, 173, 173}, {214, 214, 214}, {255, 255, 255},
 };
diff -pruN 8.0.1-5/fontcache.c 8.0.2-1/fontcache.c
--- 8.0.1-5/fontcache.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/fontcache.c	2024-06-11 20:41:34.000000000 +0000
@@ -26,7 +26,6 @@
  * DEALINGS IN THE SOFTWARE.
  *****************************************************************************/
 
-
 #include "mapserver.h"
 #include "mapthread.h"
 #include "fontcache.h"
@@ -42,86 +41,85 @@ typedef struct {
 
 #ifdef USE_THREAD
 typedef struct ft_thread_cache ft_thread_cache;
-struct ft_thread_cache{
-  void* thread_id;
+struct ft_thread_cache {
+  void *thread_id;
   ft_thread_cache *next;
   ft_cache cache;
 };
 ft_thread_cache *ft_caches;
 int use_global_ft_cache;
 #else
-  ft_cache global_ft_cache;
+ft_cache global_ft_cache;
 #endif
 
-
 void msInitFontCache(ft_cache *c) {
-  memset(c,0,sizeof(ft_cache));
+  memset(c, 0, sizeof(ft_cache));
   FT_Init_FreeType(&c->library);
 }
 
 void msFreeFontCache(ft_cache *c) {
   /* ... TODO ... */
-  face_element *cur_face,*tmp_face;
+  face_element *cur_face, *tmp_face;
   glyph_element *cur_bitmap, *tmp_bitmap;
   UT_HASH_ITER(hh, c->face_cache, cur_face, tmp_face) {
-      index_element *cur_index,*tmp_index;
-      outline_element *cur_outline,*tmp_outline;
-      glyph_element *cur_glyph,*tmp_glyph;
-      UT_HASH_ITER(hh, cur_face->index_cache, cur_index, tmp_index) {
-        UT_HASH_DEL(cur_face->index_cache,cur_index);
-        free(cur_index);
-      }
-      UT_HASH_ITER(hh, cur_face->outline_cache, cur_outline, tmp_outline) {
-        UT_HASH_DEL(cur_face->outline_cache,cur_outline);
-        FT_Outline_Done(c->library,&cur_outline->outline);
-        free(cur_outline);
-      }
-      UT_HASH_ITER(hh, cur_face->glyph_cache, cur_glyph, tmp_glyph) {
-        UT_HASH_DEL(cur_face->glyph_cache,cur_glyph);
-        free(cur_glyph);
-      }
+    index_element *cur_index, *tmp_index;
+    outline_element *cur_outline, *tmp_outline;
+    glyph_element *cur_glyph, *tmp_glyph;
+    UT_HASH_ITER(hh, cur_face->index_cache, cur_index, tmp_index) {
+      UT_HASH_DEL(cur_face->index_cache, cur_index);
+      free(cur_index);
+    }
+    UT_HASH_ITER(hh, cur_face->outline_cache, cur_outline, tmp_outline) {
+      UT_HASH_DEL(cur_face->outline_cache, cur_outline);
+      FT_Outline_Done(c->library, &cur_outline->outline);
+      free(cur_outline);
+    }
+    UT_HASH_ITER(hh, cur_face->glyph_cache, cur_glyph, tmp_glyph) {
+      UT_HASH_DEL(cur_face->glyph_cache, cur_glyph);
+      free(cur_glyph);
+    }
 #ifdef USE_HARFBUZZ
-      if(cur_face->hbfont) {
-        hb_font_destroy(cur_face->hbfont->hbfont);
-        hb_font_destroy(cur_face->hbfont->hbparentfont);
-        hb_font_funcs_destroy(cur_face->hbfont->funcs);
-        free(cur_face->hbfont);
-      }
+    if (cur_face->hbfont) {
+      hb_font_destroy(cur_face->hbfont->hbfont);
+      hb_font_destroy(cur_face->hbfont->hbparentfont);
+      hb_font_funcs_destroy(cur_face->hbfont->funcs);
+      free(cur_face->hbfont);
+    }
 #endif
-      FT_Done_Face(cur_face->face);
-      free(cur_face->font);
-      UT_HASH_DEL(c->face_cache,cur_face);
-      free(cur_face);
+    FT_Done_Face(cur_face->face);
+    free(cur_face->font);
+    UT_HASH_DEL(c->face_cache, cur_face);
+    free(cur_face);
   }
   FT_Done_FreeType(c->library);
 
-  UT_HASH_ITER(hh,c->bitmap_glyph_cache, cur_bitmap, tmp_bitmap) {
+  UT_HASH_ITER(hh, c->bitmap_glyph_cache, cur_bitmap, tmp_bitmap) {
     UT_HASH_DEL(c->bitmap_glyph_cache, cur_bitmap);
     free(cur_bitmap);
   }
-  memset(c,0,sizeof(ft_cache));
+  memset(c, 0, sizeof(ft_cache));
 }
 
-ft_cache* msGetFontCache() {
+ft_cache *msGetFontCache() {
 #ifndef USE_THREAD
   return &global_ft_cache;
 #else
-  void* nThreadId = 0;
+  void *nThreadId = 0;
   ft_thread_cache *prev = NULL, *cur = ft_caches;
 
   if (!use_global_ft_cache)
     nThreadId = msGetThreadId();
 
-  if( cur != NULL && cur->thread_id == nThreadId )
+  if (cur != NULL && cur->thread_id == nThreadId)
     return &cur->cache;
 
   /* -------------------------------------------------------------------- */
   /*      Search for cache for this thread                                */
   /* -------------------------------------------------------------------- */
-  msAcquireLock( TLOCK_TTF );
+  msAcquireLock(TLOCK_TTF);
 
   cur = ft_caches;
-  while( cur != NULL && cur->thread_id != nThreadId ) {
+  while (cur != NULL && cur->thread_id != nThreadId) {
     prev = cur;
     cur = cur->next;
   }
@@ -130,14 +128,14 @@ ft_cache* msGetFontCache() {
   /*      If we found it, make sure it is pushed to the front of the      */
   /*      link for faster finding next time, and return it.               */
   /* -------------------------------------------------------------------- */
-  if( cur != NULL ) {
-    if( prev != NULL ) {
+  if (cur != NULL) {
+    if (prev != NULL) {
       prev->next = cur->next;
       cur->next = ft_caches;
       ft_caches = cur;
     }
 
-    msReleaseLock( TLOCK_TTF );
+    msReleaseLock(TLOCK_TTF);
     return &cur->cache;
   }
 
@@ -151,7 +149,7 @@ ft_cache* msGetFontCache() {
   cur->next = ft_caches;
   ft_caches = cur;
 
-  msReleaseLock( TLOCK_TTF );
+  msReleaseLock(TLOCK_TTF);
 
   return &cur->cache;
 #endif
@@ -162,7 +160,8 @@ void msFontCacheSetup() {
   ft_cache *c = msGetFontCache();
   msInitFontCache(c);
 #else
-  const char *use_global_cache = CPLGetConfigOption("MS_USE_GLOBAL_FT_CACHE", NULL);
+  const char *use_global_cache =
+      CPLGetConfigOption("MS_USE_GLOBAL_FT_CACHE", NULL);
   if (use_global_cache)
     use_global_ft_cache = atoi(use_global_cache);
   else
@@ -177,64 +176,66 @@ void msFontCacheCleanup() {
   ft_cache *c = msGetFontCache();
   msFreeFontCache(c);
 #else
-  ft_thread_cache *cur,*next;
-  msAcquireLock( TLOCK_TTF );
-  cur =  ft_caches;
-  while( cur != NULL ) {
+  ft_thread_cache *cur, *next;
+  msAcquireLock(TLOCK_TTF);
+  cur = ft_caches;
+  while (cur != NULL) {
     msFreeFontCache(&cur->cache);
     next = cur->next;
     free(cur);
     cur = next;
   }
   ft_caches = NULL;
-  msReleaseLock( TLOCK_TTF );
+  msReleaseLock(TLOCK_TTF);
 #endif
 }
 
 unsigned int msGetGlyphIndex(face_element *face, unsigned int unicode) {
   index_element *ic;
-  if(face->face->charmap && face->face->charmap->encoding == FT_ENCODING_MS_SYMBOL) {
+  if (face->face->charmap &&
+      face->face->charmap->encoding == FT_ENCODING_MS_SYMBOL) {
     unicode |= 0xf000; /* why? */
   }
 #ifdef USE_THREAD
   if (use_global_ft_cache)
-	  msAcquireLock(TLOCK_TTF);
-#endif   
-  UT_HASH_FIND_INT(face->index_cache,&unicode,ic);
-  if(!ic) {
+    msAcquireLock(TLOCK_TTF);
+#endif
+  UT_HASH_FIND_INT(face->index_cache, &unicode, ic);
+  if (!ic) {
     ic = msSmallMalloc(sizeof(index_element));
-    ic->codepoint = FT_Get_Char_Index(face->face,unicode);
+    ic->codepoint = FT_Get_Char_Index(face->face, unicode);
     ic->unicode = unicode;
-    UT_HASH_ADD_INT(face->index_cache,unicode,ic);
+    UT_HASH_ADD_INT(face->index_cache, unicode, ic);
   }
 #ifdef USE_THREAD
   if (use_global_ft_cache)
-	  msReleaseLock(TLOCK_TTF);
-#endif  
+    msReleaseLock(TLOCK_TTF);
+#endif
   return ic->codepoint;
 }
 
 #define MS_DEFAULT_FONT_KEY "_ms_default_"
 
-face_element* msGetFontFace(char *key, fontSetObj *fontset) {
+face_element *msGetFontFace(char *key, fontSetObj *fontset) {
   face_element *fc;
   int error;
   ft_cache *cache = msGetFontCache();
-  if(!key) {
+  if (!key) {
     key = MS_DEFAULT_FONT_KEY;
   }
 #ifdef USE_THREAD
   if (use_global_ft_cache)
     msAcquireLock(TLOCK_TTF);
 #endif
-  UT_HASH_FIND_STR(cache->face_cache,key,fc);
-  if(!fc) {
+  UT_HASH_FIND_STR(cache->face_cache, key, fc);
+  if (!fc) {
     const char *fontfile = NULL;
-    fc = msSmallCalloc(1,sizeof(face_element));
-    if(fontset && strcmp(key,MS_DEFAULT_FONT_KEY)) {
-      fontfile = msLookupHashTable(&(fontset->fonts),key);
-      if(!fontfile) {
-        msSetError(MS_MISCERR, "Could not find font with key \"%s\" in fontset", "msGetFontFace()", key);
+    fc = msSmallCalloc(1, sizeof(face_element));
+    if (fontset && strcmp(key, MS_DEFAULT_FONT_KEY)) {
+      fontfile = msLookupHashTable(&(fontset->fonts), key);
+      if (!fontfile) {
+        msSetError(MS_MISCERR, "Could not find font with key \"%s\" in fontset",
+                   "msGetFontFace()", key);
         free(fc);
 #ifdef USE_THREAD
         if (use_global_ft_cache)
@@ -242,12 +243,15 @@ face_element* msGetFontFace(char *key, f
 #endif
         return NULL;
       }
-      error = FT_New_Face(cache->library,fontfile,0, &(fc->face));
+      error = FT_New_Face(cache->library, fontfile, 0, &(fc->face));
     } else {
-      error = FT_New_Memory_Face(cache->library,dejavu_sans_condensed_ttf, dejavu_sans_condensed_ttf_len , 0, &(fc->face));
+      error = FT_New_Memory_Face(cache->library, dejavu_sans_condensed_ttf,
+                                 dejavu_sans_condensed_ttf_len, 0, &(fc->face));
     }
-    if(error) {
-      msSetError(MS_MISCERR, "Freetype was unable to load font file \"%s\" for key \"%s\"", "msGetFontFace()", fontfile, key);
+    if (error) {
+      msSetError(MS_MISCERR,
+                 "Freetype was unable to load font file \"%s\" for key \"%s\"",
+                 "msGetFontFace()", fontfile, key);
       free(fc);
 #ifdef USE_THREAD
       if (use_global_ft_cache)
@@ -255,14 +259,15 @@ face_element* msGetFontFace(char *key, f
 #endif
       return NULL;
     }
-    if(!fc->face->charmap) {
+    if (!fc->face->charmap) {
       /* The font file has no unicode charmap, select an alternate one */
-      if( FT_Select_Charmap(fc->face, FT_ENCODING_MS_SYMBOL) )
+      if (FT_Select_Charmap(fc->face, FT_ENCODING_MS_SYMBOL))
         FT_Select_Charmap(fc->face, FT_ENCODING_APPLE_ROMAN);
-      /* the previous calls may have failed, we ignore as there's nothing much left to do */
+      /* the previous calls may have failed, we ignore as there's nothing much
+       * left to do */
     }
     fc->font = msStrdup(key);
-    UT_HASH_ADD_KEYPTR(hh,cache->face_cache,fc->font, strlen(key), fc);
+    UT_HASH_ADD_KEYPTR(hh, cache->face_cache, fc->font, strlen(key), fc);
   }
 #ifdef USE_THREAD
   if (use_global_ft_cache)
@@ -271,86 +276,106 @@ face_element* msGetFontFace(char *key, f
   return fc;
 }
 
-glyph_element* msGetGlyphByIndex(face_element *face, unsigned int size, unsigned int codepoint) {
+glyph_element *msGetGlyphByIndex(face_element *face, unsigned int size,
+                                 unsigned int codepoint) {
   glyph_element *gc;
   glyph_element_key key;
-  memset(&key,0,sizeof(glyph_element_key));
+  memset(&key, 0, sizeof(glyph_element_key));
   key.codepoint = codepoint;
   key.size = size;
 #ifdef USE_THREAD
   if (use_global_ft_cache)
     msAcquireLock(TLOCK_TTF);
-#endif   
-  UT_HASH_FIND(hh,face->glyph_cache,&key,sizeof(glyph_element_key),gc);
-  if(!gc) {
+#endif
+  UT_HASH_FIND(hh, face->glyph_cache, &key, sizeof(glyph_element_key), gc);
+  if (!gc) {
     FT_Error error;
     gc = msSmallMalloc(sizeof(glyph_element));
-    if(MS_NINT(size * 96.0/72.0) != face->face->size->metrics.x_ppem) {
-      FT_Set_Pixel_Sizes(face->face,0,MS_NINT(size * 96/72.0));
+    if (MS_NINT(size * 96.0 / 72.0) != face->face->size->metrics.x_ppem) {
+      FT_Set_Pixel_Sizes(face->face, 0, MS_NINT(size * 96 / 72.0));
     }
-    error = FT_Load_Glyph(face->face,key.codepoint,FT_LOAD_DEFAULT|FT_LOAD_NO_BITMAP|FT_LOAD_NO_HINTING|FT_LOAD_IGNORE_GLOBAL_ADVANCE_WIDTH);
+    error =
+        FT_Load_Glyph(face->face, key.codepoint,
+                      FT_LOAD_DEFAULT | FT_LOAD_NO_BITMAP | FT_LOAD_NO_HINTING |
+                          FT_LOAD_IGNORE_GLOBAL_ADVANCE_WIDTH);
     if (error) {
-      msDebug("Unable to load glyph %u for font \"%s\". Using ? as fallback.\n", key.codepoint, face->font);
+      msDebug("Unable to load glyph %u for font \"%s\". Using ? as fallback.\n",
+              key.codepoint, face->font);
       // If we can't find a glyph then try to fallback to a question mark.
       unsigned int fallbackCodepoint = msGetGlyphIndex(face, 0x3F);
-      error = FT_Load_Glyph(face->face,fallbackCodepoint,FT_LOAD_DEFAULT|FT_LOAD_NO_BITMAP|FT_LOAD_NO_HINTING|FT_LOAD_IGNORE_GLOBAL_ADVANCE_WIDTH);
+      error = FT_Load_Glyph(face->face, fallbackCodepoint,
+                            FT_LOAD_DEFAULT | FT_LOAD_NO_BITMAP |
+                                FT_LOAD_NO_HINTING |
+                                FT_LOAD_IGNORE_GLOBAL_ADVANCE_WIDTH);
     }
-    if(error) {
-      msSetError(MS_MISCERR, "unable to load glyph %u for font \"%s\"", "msGetGlyphByIndex()",key.codepoint, face->font);
+    if (error) {
+      msSetError(MS_MISCERR, "unable to load glyph %u for font \"%s\"",
+                 "msGetGlyphByIndex()", key.codepoint, face->font);
       free(gc);
 #ifdef USE_THREAD
       if (use_global_ft_cache)
         msReleaseLock(TLOCK_TTF);
-#endif      
+#endif
       return NULL;
     }
     gc->metrics.minx = face->face->glyph->metrics.horiBearingX / 64.0;
-    gc->metrics.maxx = gc->metrics.minx + face->face->glyph->metrics.width / 64.0;
+    gc->metrics.maxx =
+        gc->metrics.minx + face->face->glyph->metrics.width / 64.0;
     gc->metrics.maxy = face->face->glyph->metrics.horiBearingY / 64.0;
-    gc->metrics.miny = gc->metrics.maxy - face->face->glyph->metrics.height / 64.0;
+    gc->metrics.miny =
+        gc->metrics.maxy - face->face->glyph->metrics.height / 64.0;
     gc->metrics.advance = face->face->glyph->metrics.horiAdvance / 64.0;
     gc->key = key;
-    UT_HASH_ADD(hh,face->glyph_cache,key,sizeof(glyph_element_key), gc);
+    UT_HASH_ADD(hh, face->glyph_cache, key, sizeof(glyph_element_key), gc);
   }
 #ifdef USE_THREAD
   if (use_global_ft_cache)
     msReleaseLock(TLOCK_TTF);
-#endif  
+#endif
   return gc;
 }
 
-outline_element* msGetGlyphOutline(face_element *face, glyph_element *glyph) {
+outline_element *msGetGlyphOutline(face_element *face, glyph_element *glyph) {
   outline_element *oc;
   outline_element_key key;
   ft_cache *cache = msGetFontCache();
-  memset(&key,0,sizeof(outline_element_key));
+  memset(&key, 0, sizeof(outline_element_key));
   key.glyph = glyph;
 #ifdef USE_THREAD
   if (use_global_ft_cache)
     msAcquireLock(TLOCK_TTF);
 #endif
-  UT_HASH_FIND(hh,face->outline_cache,&key, sizeof(outline_element_key),oc);
-  if(!oc) {
+  UT_HASH_FIND(hh, face->outline_cache, &key, sizeof(outline_element_key), oc);
+  if (!oc) {
     FT_Matrix matrix;
     FT_Vector pen;
     FT_Error error;
     oc = msSmallMalloc(sizeof(outline_element));
-    if(MS_NINT(glyph->key.size * 96.0/72.0) != face->face->size->metrics.x_ppem) {
-      FT_Set_Pixel_Sizes(face->face,0,MS_NINT(glyph->key.size * 96/72.0));
+    if (MS_NINT(glyph->key.size * 96.0 / 72.0) !=
+        face->face->size->metrics.x_ppem) {
+      FT_Set_Pixel_Sizes(face->face, 0, MS_NINT(glyph->key.size * 96 / 72.0));
     }
     matrix.xx = matrix.yy = 0x10000L;
     matrix.xy = matrix.yx = 0x00000L;
     pen.x = pen.y = 0;
     FT_Set_Transform(face->face, &matrix, &pen);
-    error = FT_Load_Glyph(face->face,glyph->key.codepoint,FT_LOAD_DEFAULT|FT_LOAD_NO_BITMAP/*|FT_LOAD_IGNORE_TRANSFORM*/|FT_LOAD_NO_HINTING|FT_LOAD_IGNORE_GLOBAL_ADVANCE_WIDTH);
+    error = FT_Load_Glyph(
+        face->face, glyph->key.codepoint,
+        FT_LOAD_DEFAULT | FT_LOAD_NO_BITMAP /*|FT_LOAD_IGNORE_TRANSFORM*/ |
+            FT_LOAD_NO_HINTING | FT_LOAD_IGNORE_GLOBAL_ADVANCE_WIDTH);
     if (error) {
-      msDebug("Unable to load glyph %u for font \"%s\". Using ? as fallback.\n", glyph->key.codepoint, face->font);
+      msDebug("Unable to load glyph %u for font \"%s\". Using ? as fallback.\n",
+              glyph->key.codepoint, face->font);
       // If we can't find a glyph then try to fallback to a question mark.
       unsigned int fallbackCodepoint = msGetGlyphIndex(face, 0x3F);
-      error = FT_Load_Glyph(face->face,fallbackCodepoint,FT_LOAD_DEFAULT|FT_LOAD_NO_BITMAP/*|FT_LOAD_IGNORE_TRANSFORM*/|FT_LOAD_NO_HINTING|FT_LOAD_IGNORE_GLOBAL_ADVANCE_WIDTH);
+      error = FT_Load_Glyph(
+          face->face, fallbackCodepoint,
+          FT_LOAD_DEFAULT | FT_LOAD_NO_BITMAP /*|FT_LOAD_IGNORE_TRANSFORM*/ |
+              FT_LOAD_NO_HINTING | FT_LOAD_IGNORE_GLOBAL_ADVANCE_WIDTH);
     }
-    if(error) {
-      msSetError(MS_MISCERR, "unable to load glyph %u for font \"%s\"", "msGetGlyphOutline()",glyph->key.codepoint, face->font);
+    if (error) {
+      msSetError(MS_MISCERR, "unable to load glyph %u for font \"%s\"",
+                 "msGetGlyphOutline()", glyph->key.codepoint, face->font);
 #ifdef USE_THREAD
       if (use_global_ft_cache)
         msReleaseLock(TLOCK_TTF);
@@ -358,11 +383,11 @@ outline_element* msGetGlyphOutline(face_
       return NULL;
     }
     error = FT_Outline_New(cache->library, face->face->glyph->outline.n_points,
-        face->face->glyph->outline.n_contours, &oc->outline);
+                           face->face->glyph->outline.n_contours, &oc->outline);
     (void)error;
     FT_Outline_Copy(&face->face->glyph->outline, &oc->outline);
     oc->key = key;
-    UT_HASH_ADD(hh,face->outline_cache,key,sizeof(outline_element_key), oc);
+    UT_HASH_ADD(hh, face->outline_cache, key, sizeof(outline_element_key), oc);
   }
 #ifdef USE_THREAD
   if (use_global_ft_cache)
@@ -373,8 +398,9 @@ outline_element* msGetGlyphOutline(face_
 
 int msIsGlyphASpace(glyphObj *glyph) {
   /* space or tab, for now */
-  unsigned int space,tab;
-  space = msGetGlyphIndex(glyph->face,0x20);
-  tab = msGetGlyphIndex(glyph->face,0x9);
-  return glyph->glyph->key.codepoint == space || glyph->glyph->key.codepoint == tab;
+  unsigned int space, tab;
+  space = msGetGlyphIndex(glyph->face, 0x20);
+  tab = msGetGlyphIndex(glyph->face, 0x9);
+  return glyph->glyph->key.codepoint == space ||
+         glyph->glyph->key.codepoint == tab;
 }
diff -pruN 8.0.1-5/fontcache.h 8.0.2-1/fontcache.h
--- 8.0.1-5/fontcache.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/fontcache.h	2024-06-11 20:41:34.000000000 +0000
@@ -7,14 +7,13 @@
 #include FT_OUTLINE_H
 
 #ifdef USE_FRIBIDI
- #if (defined(_WIN32) && !defined(__CYGWIN__)) || defined(HAVE_FRIBIDI2)
-  #include "fribidi.h"
- #else
-  #include <fribidi/fribidi.h>
- #endif
- #include <hb-ft.h>
+#if (defined(_WIN32) && !defined(__CYGWIN__)) || defined(HAVE_FRIBIDI2)
+#include "fribidi.h"
+#else
+#include <fribidi/fribidi.h>
+#endif
+#include <hb-ft.h>
 #endif
-
 
 #ifdef __cplusplus
 extern "C" {
@@ -38,7 +37,7 @@ typedef struct {
   unsigned int size;
 } glyph_element_key;
 
-struct glyph_element{
+struct glyph_element {
   glyph_element_key key;
   glyph_metrics metrics;
   UT_hash_handle hh;
@@ -64,7 +63,7 @@ typedef struct {
   UT_hash_handle hh;
 } bitmap_element;
 
-struct face_element{
+struct face_element {
   char *font;
   FT_Face face;
   index_element *index_cache;
@@ -74,12 +73,13 @@ struct face_element{
   UT_hash_handle hh;
 };
 
-
-face_element* msGetFontFace(char *key, fontSetObj *fontset);
-outline_element* msGetGlyphOutline(face_element *face, glyph_element *glyph);
-glyph_element* msGetBitmapGlyph(rendererVTableObj *renderer, unsigned int size, unsigned int unicode);
+face_element *msGetFontFace(char *key, fontSetObj *fontset);
+outline_element *msGetGlyphOutline(face_element *face, glyph_element *glyph);
+glyph_element *msGetBitmapGlyph(rendererVTableObj *renderer, unsigned int size,
+                                unsigned int unicode);
 unsigned int msGetGlyphIndex(face_element *face, unsigned int unicode);
-glyph_element* msGetGlyphByIndex(face_element *face, unsigned int size, unsigned int codepoint);
+glyph_element *msGetGlyphByIndex(face_element *face, unsigned int size,
+                                 unsigned int codepoint);
 int msIsGlyphASpace(glyphObj *glyph);
 
 #ifdef __cplusplus
diff -pruN 8.0.1-5/fuzzers/shapefuzzer.c 8.0.2-1/fuzzers/shapefuzzer.c
--- 8.0.1-5/fuzzers/shapefuzzer.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/fuzzers/shapefuzzer.c	2024-06-11 20:41:34.000000000 +0000
@@ -7,9 +7,8 @@
 
 extern int LLVMFuzzerTestOneInput(GByte *data, size_t size);
 
-static VSILFILE *
-SegmentFile(const char *filename, GByte **data_p, size_t *size_p)
-{
+static VSILFILE *SegmentFile(const char *filename, GByte **data_p,
+                             size_t *size_p) {
   GByte *data = *data_p;
   size_t size = *size_p;
 
@@ -25,13 +24,12 @@ SegmentFile(const char *filename, GByte
   return VSIFileFromMemBuffer(filename, data, size, false);
 }
 
-int
-LLVMFuzzerTestOneInput(GByte *data, size_t size)
-{
+int LLVMFuzzerTestOneInput(GByte *data, size_t size) {
   /* this fuzzer expects three files concatenated, separated by the
      string "deadbeef"; you can generate such a file by typing:
 
-     { cat foo.shp; echo -n "deadbeef"; cat foo.shx; echo -n "deadbeef"; cat foo.dbf; } >/tmp/corpus/start
+     { cat foo.shp; echo -n "deadbeef"; cat foo.shx; echo -n "deadbeef"; cat
+     foo.dbf; } >/tmp/corpus/start
 
      then run the fuzzer:
 
@@ -43,7 +41,8 @@ LLVMFuzzerTestOneInput(GByte *data, size
   VSILFILE *dbf = SegmentFile("/vsimem/foo.dbf", &data, &size);
 
   shapefileObj file;
-  if (msShapefileOpenVirtualFile(&file, "/vsimem/foo.shp", shp, shx, dbf, false) == 0) {
+  if (msShapefileOpenVirtualFile(&file, "/vsimem/foo.shp", shp, shx, dbf,
+                                 false) == 0) {
     for (int i = 0; i < file.numshapes; ++i) {
       shapeObj shape;
       msInitShape(&shape);
diff -pruN 8.0.1-5/hittest.c 8.0.2-1/hittest.c
--- 8.0.1-5/hittest.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/hittest.c	2024-06-11 20:41:34.000000000 +0000
@@ -28,7 +28,6 @@
 
 #include "mapserver.h"
 
-
 void initStyleHitTests(styleObj *s, style_hittest *sh, int default_status) {
   (void)s;
   sh->status = default_status;
@@ -36,51 +35,51 @@ void initStyleHitTests(styleObj *s, styl
 
 void initLabelHitTests(labelObj *l, label_hittest *lh, int default_status) {
   int i;
-  lh->stylehits = msSmallCalloc(l->numstyles,sizeof(style_hittest));
+  lh->stylehits = msSmallCalloc(l->numstyles, sizeof(style_hittest));
   lh->status = default_status;
-  for(i=0; i<l->numstyles; i++) {
-    initStyleHitTests(l->styles[i],&lh->stylehits[i],default_status);
+  for (i = 0; i < l->numstyles; i++) {
+    initStyleHitTests(l->styles[i], &lh->stylehits[i], default_status);
   }
 }
 
 void initClassHitTests(classObj *c, class_hittest *ch, int default_status) {
   int i;
-  ch->stylehits = msSmallCalloc(c->numstyles,sizeof(style_hittest));
-  ch->labelhits = msSmallCalloc(c->numlabels,sizeof(label_hittest));
+  ch->stylehits = msSmallCalloc(c->numstyles, sizeof(style_hittest));
+  ch->labelhits = msSmallCalloc(c->numlabels, sizeof(label_hittest));
   ch->status = default_status;
-  for(i=0; i<c->numstyles; i++) {
-    initStyleHitTests(c->styles[i],&ch->stylehits[i],default_status);
+  for (i = 0; i < c->numstyles; i++) {
+    initStyleHitTests(c->styles[i], &ch->stylehits[i], default_status);
   }
-  for(i=0; i<c->numlabels; i++) {
-    initLabelHitTests(c->labels[i],&ch->labelhits[i],default_status);
+  for (i = 0; i < c->numlabels; i++) {
+    initLabelHitTests(c->labels[i], &ch->labelhits[i], default_status);
   }
 }
 
 void initLayerHitTests(layerObj *l, layer_hittest *lh) {
-  int i,default_status;
-  lh->classhits = msSmallCalloc(l->numclasses,sizeof(class_hittest));
+  int i, default_status;
+  lh->classhits = msSmallCalloc(l->numclasses, sizeof(class_hittest));
 
-  switch(l->type) {
-    case MS_LAYER_POLYGON:
-    case MS_LAYER_POINT:
-    case MS_LAYER_LINE:
-    case MS_LAYER_ANNOTATION:
-      default_status = 0; /* needs testing */
-      break;
-    default:
-      default_status = 1; /* no hittesting needed, use traditional mode */
-      break;
+  switch (l->type) {
+  case MS_LAYER_POLYGON:
+  case MS_LAYER_POINT:
+  case MS_LAYER_LINE:
+  case MS_LAYER_ANNOTATION:
+    default_status = 0; /* needs testing */
+    break;
+  default:
+    default_status = 1; /* no hittesting needed, use traditional mode */
+    break;
   }
   lh->status = default_status;
-  for(i=0; i<l->numclasses; i++) {
-    initClassHitTests(l->class[i],&lh->classhits[i], default_status);
+  for (i = 0; i < l->numclasses; i++) {
+    initClassHitTests(l->class[i], &lh -> classhits[i], default_status);
   }
 }
 void initMapHitTests(mapObj *map, map_hittest *mh) {
   int i;
-  mh->layerhits = msSmallCalloc(map->numlayers,sizeof(layer_hittest));
-  for(i=0; i<map->numlayers; i++) {
-    initLayerHitTests(GET_LAYER(map,i),&mh->layerhits[i]);
+  mh->layerhits = msSmallCalloc(map->numlayers, sizeof(layer_hittest));
+  for (i = 0; i < map->numlayers; i++) {
+    initLayerHitTests(GET_LAYER(map, i), &mh->layerhits[i]);
   }
 }
 
@@ -91,45 +90,47 @@ void freeLabelHitTests(labelObj *l, labe
 
 void freeClassHitTests(classObj *c, class_hittest *ch) {
   int i;
-  for(i=0; i<c->numlabels; i++) {
-    freeLabelHitTests(c->labels[i],&ch->labelhits[i]);
+  for (i = 0; i < c->numlabels; i++) {
+    freeLabelHitTests(c->labels[i], &ch->labelhits[i]);
   }
   free(ch->stylehits);
   free(ch->labelhits);
 }
 void freeLayerHitTests(layerObj *l, layer_hittest *lh) {
   int i;
-  for(i=0; i<l->numclasses; i++) {
-    freeClassHitTests(l->class[i],&lh->classhits[i]);
+  for (i = 0; i < l->numclasses; i++) {
+    freeClassHitTests(l->class[i], &lh -> classhits[i]);
   }
   free(lh->classhits);
 }
 void freeMapHitTests(mapObj *map, map_hittest *mh) {
   int i;
-  for(i=0; i<map->numlayers; i++) {
-    freeLayerHitTests(GET_LAYER(map,i),&mh->layerhits[i]);
+  for (i = 0; i < map->numlayers; i++) {
+    freeLayerHitTests(GET_LAYER(map, i), &mh->layerhits[i]);
   }
   free(mh->layerhits);
 }
 
-int msHitTestShape(mapObj *map, layerObj *layer, shapeObj *shape, int drawmode, class_hittest *hittest) {
+int msHitTestShape(mapObj *map, layerObj *layer, shapeObj *shape, int drawmode,
+                   class_hittest *hittest) {
   int i;
   classObj *cp = layer->class[shape->classindex];
-  if(MS_DRAW_FEATURES(drawmode)) {
-    for(i=0;i<cp->numstyles;i++) {
+  if (MS_DRAW_FEATURES(drawmode)) {
+    for (i = 0; i < cp->numstyles; i++) {
       styleObj *sp = cp->styles[i];
-      if(msScaleInBounds(map->scaledenom,sp->minscaledenom,sp->maxscaledenom)) {
+      if (msScaleInBounds(map->scaledenom, sp->minscaledenom,
+                          sp->maxscaledenom)) {
         hittest->stylehits[i].status = 1;
       }
     }
   }
-  if(MS_DRAW_LABELS(drawmode)) {
-    for(i=0;i<cp->numlabels;i++) {
+  if (MS_DRAW_LABELS(drawmode)) {
+    for (i = 0; i < cp->numlabels; i++) {
       labelObj *l = cp->labels[i];
-      if(msGetLabelStatus(map,layer,shape,l) == MS_ON) {
+      if (msGetLabelStatus(map, layer, shape, l) == MS_ON) {
         int s;
         hittest->labelhits[i].status = 1;
-        for(s=0; s<l->numstyles;s++) {
+        for (s = 0; s < l->numstyles; s++) {
           hittest->labelhits[i].stylehits[s].status = 1;
         }
       }
@@ -143,59 +144,66 @@ int msHitTestLayer(mapObj *map, layerObj
 #ifdef USE_GEOS
   shapeObj searchpoly;
 #endif
-  if(!msLayerIsVisible(map,layer)) {
+  if (!msLayerIsVisible(map, layer)) {
     hittest->status = 0;
     return MS_SUCCESS;
   }
-  if(layer->type == MS_LAYER_LINE || layer->type == MS_LAYER_POLYGON || layer->type == MS_LAYER_POINT || layer->type == MS_LAYER_ANNOTATION) {
-    int maxfeatures=msLayerGetMaxFeaturesToDraw(layer, NULL);
+  if (layer->type == MS_LAYER_LINE || layer->type == MS_LAYER_POLYGON ||
+      layer->type == MS_LAYER_POINT || layer->type == MS_LAYER_ANNOTATION) {
+    int maxfeatures = msLayerGetMaxFeaturesToDraw(layer, NULL);
     int annotate = msEvalContext(map, layer, layer->labelrequires);
     shapeObj shape;
-    int nclasses,featuresdrawn = 0;
+    int nclasses, featuresdrawn = 0;
     int *classgroup;
     rectObj searchrect;
-    int minfeaturesize=-1;
-    if(map->scaledenom > 0) {
-      if((layer->labelmaxscaledenom != -1) && (map->scaledenom >= layer->labelmaxscaledenom)) annotate = MS_FALSE;
-      if((layer->labelminscaledenom != -1) && (map->scaledenom < layer->labelminscaledenom)) annotate = MS_FALSE;
+    int minfeaturesize = -1;
+    if (map->scaledenom > 0) {
+      if ((layer->labelmaxscaledenom != -1) &&
+          (map->scaledenom >= layer->labelmaxscaledenom))
+        annotate = MS_FALSE;
+      if ((layer->labelminscaledenom != -1) &&
+          (map->scaledenom < layer->labelminscaledenom))
+        annotate = MS_FALSE;
     }
 
     status = msLayerOpen(layer);
-    if(status != MS_SUCCESS) return MS_FAILURE;
+    if (status != MS_SUCCESS)
+      return MS_FAILURE;
 
     /* build item list */
     status = msLayerWhichItems(layer, MS_FALSE, NULL);
 
-    if(status != MS_SUCCESS) {
+    if (status != MS_SUCCESS) {
       msLayerClose(layer);
       return MS_FAILURE;
     }
 
     /* identify target shapes */
-    if(layer->transform == MS_TRUE) {
+    if (layer->transform == MS_TRUE) {
       searchrect = map->extent;
-      if((map->projection.numargs > 0) && (layer->projection.numargs > 0))
-        msProjectRect(&map->projection, &layer->projection, &searchrect); /* project the searchrect to source coords */
-    }
-    else {
+      if ((map->projection.numargs > 0) && (layer->projection.numargs > 0))
+        msProjectRect(
+            &map->projection, &layer->projection,
+            &searchrect); /* project the searchrect to source coords */
+    } else {
       searchrect.minx = searchrect.miny = 0;
-      searchrect.maxx = map->width-1;
-      searchrect.maxy = map->height-1;
+      searchrect.maxx = map->width - 1;
+      searchrect.maxy = map->height - 1;
     }
 #ifdef USE_GEOS
     msInitShape(&searchpoly);
-    msRectToPolygon(searchrect,&searchpoly);
+    msRectToPolygon(searchrect, &searchpoly);
 #endif
 
     status = msLayerWhichShapes(layer, searchrect, MS_FALSE);
-    if(status == MS_DONE) { /* no overlap */
+    if (status == MS_DONE) { /* no overlap */
 #ifdef USE_GEOS
       msFreeShape(&searchpoly);
 #endif
       msLayerClose(layer);
       hittest->status = 0;
       return MS_SUCCESS;
-    } else if(status != MS_SUCCESS) {
+    } else if (status != MS_SUCCESS) {
 #ifdef USE_GEOS
       msFreeShape(&searchpoly);
 #endif
@@ -208,32 +216,33 @@ int msHitTestLayer(mapObj *map, layerObj
 
     nclasses = 0;
     classgroup = NULL;
-    if(layer->classgroup && layer->numclasses > 0)
+    if (layer->classgroup && layer->numclasses > 0)
       classgroup = msAllocateValidClassGroups(layer, &nclasses);
 
-    if(layer->minfeaturesize > 0)
+    if (layer->minfeaturesize > 0)
       minfeaturesize = Pix2LayerGeoref(map, layer, layer->minfeaturesize);
 
-    while((status = msLayerNextShape(layer, &shape)) == MS_SUCCESS) {
+    while ((status = msLayerNextShape(layer, &shape)) == MS_SUCCESS) {
       int drawmode = MS_DRAWMODE_FEATURES;
 #ifdef USE_GEOS
-      if(!msGEOSIntersects(&shape,&searchpoly)) {
+      if (!msGEOSIntersects(&shape, &searchpoly)) {
         msFreeShape(&shape);
         continue;
       }
 #else
-      if(shape.type == MS_SHAPE_POLYGON) {
+      if (shape.type == MS_SHAPE_POLYGON) {
         msClipPolygonRect(&shape, map->extent);
       } else {
         msClipPolylineRect(&shape, map->extent);
       }
-      if(shape.numlines == 0) {
+      if (shape.numlines == 0) {
         msFreeShape(&shape);
         continue;
       }
 #endif
       /* Check if the shape size is ok to be drawn, we need to clip */
-      if((shape.type == MS_SHAPE_LINE || shape.type == MS_SHAPE_POLYGON) && (minfeaturesize > 0)) {
+      if ((shape.type == MS_SHAPE_LINE || shape.type == MS_SHAPE_POLYGON) &&
+          (minfeaturesize > 0)) {
         msTransformShape(&shape, map->extent, map->cellsize, NULL);
         msComputeBounds(&shape);
         if (msShapeCheckSize(&shape, minfeaturesize) == MS_FALSE) {
@@ -242,26 +251,30 @@ int msHitTestLayer(mapObj *map, layerObj
         }
       }
 
-      shape.classindex = msShapeGetClass(layer, map, &shape, classgroup, nclasses);
-      if((shape.classindex == -1) || (layer->class[shape.classindex]->status == MS_OFF)) {
+      shape.classindex =
+          msShapeGetClass(layer, map, &shape, classgroup, nclasses);
+      if ((shape.classindex == -1) ||
+          (layer->class[shape.classindex] -> status == MS_OFF)) {
         msFreeShape(&shape);
         continue;
       }
       hittest->classhits[shape.classindex].status = 1;
       hittest->status = 1;
 
-      if(maxfeatures >=0 && featuresdrawn >= maxfeatures) {
+      if (maxfeatures >= 0 && featuresdrawn >= maxfeatures) {
         msFreeShape(&shape);
         status = MS_DONE;
         break;
       }
       featuresdrawn++;
 
-      if(annotate && layer->class[shape.classindex]->numlabels > 0) {
+      if (annotate && layer->class[shape.classindex] -> numlabels > 0) {
         drawmode |= MS_DRAWMODE_LABELS;
       }
 
-      status = msHitTestShape(map, layer, &shape, drawmode, &hittest->classhits[shape.classindex]); /* all styles  */
+      status = msHitTestShape(
+          map, layer, &shape, drawmode,
+          &hittest->classhits[shape.classindex]); /* all styles  */
       msFreeShape(&shape);
     }
 
@@ -272,7 +285,7 @@ int msHitTestLayer(mapObj *map, layerObj
     if (classgroup)
       msFree(classgroup);
 
-    if(status != MS_DONE) {
+    if (status != MS_DONE) {
       msLayerClose(layer);
       return MS_FAILURE;
     }
@@ -280,21 +293,23 @@ int msHitTestLayer(mapObj *map, layerObj
     return MS_SUCCESS;
 
   } else {
-    /* we don't hittest these layers, skip as they already have been initialised */
+    /* we don't hittest these layers, skip as they already have been initialised
+     */
     return MS_SUCCESS;
   }
 }
 int msHitTestMap(mapObj *map, map_hittest *hittest) {
-  int i,status;
-  map->cellsize = msAdjustExtent(&(map->extent),map->width,map->height);
-  status = msCalculateScale(map->extent,map->units,map->width,map->height, map->resolution, &map->scaledenom);
-  if(status != MS_SUCCESS) {
+  int i, status;
+  map->cellsize = msAdjustExtent(&(map->extent), map->width, map->height);
+  status = msCalculateScale(map->extent, map->units, map->width, map->height,
+                            map->resolution, &map->scaledenom);
+  if (status != MS_SUCCESS) {
     return MS_FAILURE;
   }
-  for(i=0; i<map->numlayers; i++) {
+  for (i = 0; i < map->numlayers; i++) {
     layerObj *lp = map->layers[i];
-    status = msHitTestLayer(map,lp,&hittest->layerhits[i]);
-    if(status != MS_SUCCESS) {
+    status = msHitTestLayer(map, lp, &hittest->layerhits[i]);
+    if (status != MS_SUCCESS) {
       return MS_FAILURE;
     }
   }
diff -pruN 8.0.1-5/hittest.h 8.0.2-1/hittest.h
--- 8.0.1-5/hittest.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/hittest.h	2024-06-11 20:41:34.000000000 +0000
@@ -26,7 +26,6 @@
  * DEALINGS IN THE SOFTWARE.
  ****************************************************************************/
 
-
 #ifndef HITTEST_H
 #define HITTEST_H
 
@@ -50,7 +49,7 @@ typedef struct {
   int status;
 } layer_hittest;
 
-typedef struct map_hittest{
+typedef struct map_hittest {
   layer_hittest *layerhits;
 } map_hittest;
 
diff -pruN 8.0.1-5/idw.c 8.0.2-1/idw.c
--- 8.0.1-5/idw.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/idw.c	2024-06-11 20:41:34.000000000 +0000
@@ -32,45 +32,51 @@
 #define EPSILON 0.000000001
 #include <time.h>
 
-void msIdw(float *xyz, int width, int height, int npoints, interpolationProcessingParams *interpParams, unsigned char *iValues) {
-    int i,j,index;
-    int radius = interpParams->radius;
-    float power = interpParams->power;
-    for (j=0; j < height; j++) {
-        for (i=0; i < width; i++) {
-            double den = EPSILON, num = 0;
-            for(index = 0; index < npoints*3; index += 3){
-                double d = (xyz[index] - i)*(xyz[index] - i)+(xyz[index+1] - j)*(xyz[index+1] - j);
-                if(radius*radius > d) {
-                    double w = 1.0/(pow(d, power) + EPSILON);
-                    num += w*xyz[index+2];
-                    den += w;
-                }
-            }
-            iValues[j*width + i] = num/den;
+void msIdw(float *xyz, int width, int height, int npoints,
+           interpolationProcessingParams *interpParams,
+           unsigned char *iValues) {
+  int i, j, index;
+  int radius = interpParams->radius;
+  float power = interpParams->power;
+  for (j = 0; j < height; j++) {
+    for (i = 0; i < width; i++) {
+      double den = EPSILON, num = 0;
+      for (index = 0; index < npoints * 3; index += 3) {
+        double d = (xyz[index] - i) * (xyz[index] - i) +
+                   (xyz[index + 1] - j) * (xyz[index + 1] - j);
+        if (radius * radius > d) {
+          double w = 1.0 / (pow(d, power) + EPSILON);
+          num += w * xyz[index + 2];
+          den += w;
         }
+      }
+      iValues[j * width + i] = num / den;
     }
+  }
 }
 
-void msIdwProcessing(layerObj *layer, interpolationProcessingParams *interpParams) {
-    const char *interpParamsProcessing = msLayerGetProcessingKey( layer, "IDW_POWER" );
-    if(interpParamsProcessing) {
-        interpParams->power = atof(interpParamsProcessing);
-    } else{
-        interpParams->power = 1.0;
-    }
+void msIdwProcessing(layerObj *layer,
+                     interpolationProcessingParams *interpParams) {
+  const char *interpParamsProcessing =
+      msLayerGetProcessingKey(layer, "IDW_POWER");
+  if (interpParamsProcessing) {
+    interpParams->power = atof(interpParamsProcessing);
+  } else {
+    interpParams->power = 1.0;
+  }
 
-    interpParamsProcessing = msLayerGetProcessingKey( layer, "IDW_RADIUS" );
-    if(interpParamsProcessing){
-        interpParams->radius = atof(interpParamsProcessing);
-    } else {
-        interpParams->radius = MAX(layer->map->width,layer->map->height);
-    }
+  interpParamsProcessing = msLayerGetProcessingKey(layer, "IDW_RADIUS");
+  if (interpParamsProcessing) {
+    interpParams->radius = atof(interpParamsProcessing);
+  } else {
+    interpParams->radius = MAX(layer->map->width, layer->map->height);
+  }
 
-    interpParamsProcessing = msLayerGetProcessingKey( layer, "IDW_COMPUTE_BORDERS" );
-    if(interpParamsProcessing && strcasecmp(interpParamsProcessing,"OFF")){
-        interpParams->expand_searchrect = 1;
-    } else {
-        interpParams->expand_searchrect = 0;
-    }
+  interpParamsProcessing =
+      msLayerGetProcessingKey(layer, "IDW_COMPUTE_BORDERS");
+  if (interpParamsProcessing && strcasecmp(interpParamsProcessing, "OFF")) {
+    interpParams->expand_searchrect = 1;
+  } else {
+    interpParams->expand_searchrect = 0;
+  }
 }
diff -pruN 8.0.1-5/interpolation.c 8.0.2-1/interpolation.c
--- 8.0.1-5/interpolation.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/interpolation.c	2024-06-11 20:41:34.000000000 +0000
@@ -35,225 +35,258 @@
 /******************************************************************************
  * kernel density.
  ******************************************************************************/
-void msKernelDensity(imageObj *image, float *values, int width, int height, int npoints,
-                   interpolationProcessingParams *interpParams, unsigned char *iValues);
-void msKernelDensityProcessing(layerObj *layer, interpolationProcessingParams *interpParams);
+void msKernelDensity(imageObj *image, float *values, int width, int height,
+                     int npoints, interpolationProcessingParams *interpParams,
+                     unsigned char *iValues);
+void msKernelDensityProcessing(layerObj *layer,
+                               interpolationProcessingParams *interpParams);
 
 /******************************************************************************
  * kernel density.
  ******************************************************************************/
 void msIdw(float *xyz, int width, int height, int npoints,
-         interpolationProcessingParams *interpParams, unsigned char *iValues);
-void msIdwProcessing(layerObj *layer, interpolationProcessingParams *interpParams);
+           interpolationProcessingParams *interpParams, unsigned char *iValues);
+void msIdwProcessing(layerObj *layer,
+                     interpolationProcessingParams *interpParams);
 
 //---------------------------------------------------------------------------//
-int msInterpolationDataset(mapObj *map, imageObj *image, layerObj *interpolation_layer, void **hDSvoid, void **cleanup_ptr) {
-
-    int status, layer_idx, i, nclasses=0, npoints=0, length=0;
-    rectObj searchrect;
-    shapeObj shape;
-    layerObj *layer = NULL;
-    float *values = NULL,*xyz_values=NULL;
-    int im_width = image->width, im_height = image->height;
-    double invcellsize = 1.0 / map->cellsize, georadius=0;
-    unsigned char *iValues;
-    GDALDatasetH hDS;
-    interpolationProcessingParams interpParams;
-    int *classgroup = NULL;
-
-    memset(&interpParams, 0, sizeof(interpParams));
-
-    assert(interpolation_layer->connectiontype == MS_KERNELDENSITY ||
-           interpolation_layer->connectiontype == MS_IDW);
-    *cleanup_ptr = NULL;
-
-    if(!interpolation_layer->connection || !*interpolation_layer->connection) {
-        msSetError(MS_MISCERR, "msInterpolationDataset()", "Interpolation layer has no CONNECTION defined");
-        return MS_FAILURE;
+int msInterpolationDataset(mapObj *map, imageObj *image,
+                           layerObj *interpolation_layer, void **hDSvoid,
+                           void **cleanup_ptr) {
+
+  int status, layer_idx, i, nclasses = 0, npoints = 0, length = 0;
+  rectObj searchrect;
+  shapeObj shape;
+  layerObj *layer = NULL;
+  float *values = NULL, *xyz_values = NULL;
+  int im_width = image->width, im_height = image->height;
+  double invcellsize = 1.0 / map->cellsize, georadius = 0;
+  unsigned char *iValues;
+  GDALDatasetH hDS;
+  interpolationProcessingParams interpParams;
+  int *classgroup = NULL;
+
+  memset(&interpParams, 0, sizeof(interpParams));
+
+  assert(interpolation_layer->connectiontype == MS_KERNELDENSITY ||
+         interpolation_layer->connectiontype == MS_IDW);
+  *cleanup_ptr = NULL;
+
+  if (!interpolation_layer->connection || !*interpolation_layer->connection) {
+    msSetError(MS_MISCERR, "msInterpolationDataset()",
+               "Interpolation layer has no CONNECTION defined");
+    return MS_FAILURE;
+  }
+
+  if (interpolation_layer->connectiontype == MS_KERNELDENSITY) {
+    msKernelDensityProcessing(interpolation_layer, &interpParams);
+  } else if (interpolation_layer->connectiontype == MS_IDW) {
+    msIdwProcessing(interpolation_layer, &interpParams);
+  }
+
+  layer_idx = msGetLayerIndex(map, interpolation_layer->connection);
+  if (layer_idx == -1) {
+    int nLayers, *aLayers;
+    aLayers =
+        msGetLayersIndexByGroup(map, interpolation_layer->connection, &nLayers);
+    if (!aLayers || !nLayers) {
+      msSetError(MS_MISCERR,
+                 "Interpolation layer (%s) references unknown layer (%s)",
+                 "msInterpolationDataset()", interpolation_layer->name,
+                 interpolation_layer->connection);
+      return (MS_FAILURE);
     }
-
-    if (interpolation_layer->connectiontype == MS_KERNELDENSITY) {
-        msKernelDensityProcessing(interpolation_layer, &interpParams);
-    } else if(interpolation_layer->connectiontype == MS_IDW) {
-        msIdwProcessing(interpolation_layer, &interpParams);
+    for (i = 0; i < nLayers; i++) {
+      layer_idx = aLayers[i];
+      layer = GET_LAYER(map, layer_idx);
+      if (msScaleInBounds(map->scaledenom, layer->minscaledenom,
+                          layer->maxscaledenom))
+        break;
     }
+    free(aLayers);
+    if (i == nLayers) {
+      msSetError(
+          MS_MISCERR,
+          "Interpolation layer (%s) references no layer for current scale",
+          "msInterpolationDataset()", interpolation_layer->name);
+      return (MS_FAILURE);
+    }
+  } else {
+    layer = GET_LAYER(map, layer_idx);
+  }
+  /* open the linked layer */
+  status = msLayerOpen(layer);
+  if (status != MS_SUCCESS)
+    return MS_FAILURE;
+
+  status = msLayerWhichItems(layer, MS_FALSE, NULL);
+  if (status != MS_SUCCESS) {
+    msLayerClose(layer);
+    return MS_FAILURE;
+  }
 
-    layer_idx = msGetLayerIndex(map, interpolation_layer->connection);
-    if(layer_idx == -1) {
-        int nLayers, *aLayers;
-        aLayers = msGetLayersIndexByGroup(map, interpolation_layer->connection, &nLayers);
-        if(!aLayers || !nLayers) {
-            msSetError(MS_MISCERR, "Interpolation layer (%s) references unknown layer (%s)", "msInterpolationDataset()",
-                       interpolation_layer->name,interpolation_layer->connection);
-            return (MS_FAILURE);
+  /* identify target shapes */
+  if (layer->transform == MS_TRUE) {
+    searchrect = map->extent;
+    if (interpParams.expand_searchrect) {
+      georadius = interpParams.radius * map->cellsize;
+      searchrect.minx -= georadius;
+      searchrect.miny -= georadius;
+      searchrect.maxx += georadius;
+      searchrect.maxy += georadius;
+      im_width += 2 * interpParams.radius;
+      im_height += 2 * interpParams.radius;
+    }
+  } else {
+    searchrect.minx = searchrect.miny = 0;
+    searchrect.maxx = map->width - 1;
+    searchrect.maxy = map->height - 1;
+  }
+
+  layer->project =
+      msProjectionsDiffer(&(layer->projection), &(map->projection));
+  if (layer->project)
+    msProjectRect(&map->projection, &layer->projection,
+                  &searchrect); /* project the searchrect to source coords */
+
+  status = msLayerWhichShapes(layer, searchrect, MS_FALSE);
+  /* nothing to do */
+  if (status == MS_SUCCESS) { /* at least one sample may have overlapped */
+
+    if (layer->classgroup && layer->numclasses > 0)
+      classgroup = msAllocateValidClassGroups(layer, &nclasses);
+
+    msInitShape(&shape);
+    while ((status = msLayerNextShape(layer, &shape)) == MS_SUCCESS) {
+      int l, p, s, c;
+      double weight = 1.0;
+      if (!values) { /* defer allocation until we effectively have a feature */
+        values = (float *)msSmallCalloc(im_width * im_height, sizeof(float));
+        xyz_values =
+            (float *)msSmallCalloc(im_width * im_height, sizeof(float));
+      }
+      if (layer->project)
+        msProjectShape(&layer->projection, &map->projection, &shape);
+
+      /* the weight for the sample is set to 1.0 by default. If the
+       * layer has some classes defined, we will read the weight from
+       * the class->style->size (which can be binded to an attribute)
+       */
+      if (layer->numclasses > 0) {
+        c = msShapeGetClass(layer, map, &shape, classgroup, nclasses);
+        if ((c == -1) || (layer->class[c] -> status == MS_OFF)) {
+          goto nextshape; /* no class matched, skip */
         }
-        for(i=0; i<nLayers; i++) {
-            layer_idx = aLayers[i];
-            layer = GET_LAYER(map, layer_idx);
-            if(msScaleInBounds(map->scaledenom, layer->minscaledenom, layer->maxscaledenom))
-                break;
+        for (s = 0; s < layer->class[c] -> numstyles; s++) {
+          if (msScaleInBounds(
+                  map->scaledenom,
+                  layer->class[c] -> styles[s] -> minscaledenom,
+                  layer -> class[c] -> styles[s] -> maxscaledenom)) {
+            if (layer->class[c] -> styles[s]
+                -> bindings[MS_STYLE_BINDING_SIZE].index != -1) {
+              weight =
+                  atof(shape.values[layer->class[c] -> styles[s]
+                                    -> bindings[MS_STYLE_BINDING_SIZE].index]);
+            } else {
+              weight = layer->class[c]->styles[s]->size;
+            }
+            break;
+          }
         }
-        free(aLayers);
-        if(i == nLayers) {
-            msSetError(MS_MISCERR, "Interpolation layer (%s) references no layer for current scale", "msInterpolationDataset()",
-                       interpolation_layer->name);
-            return (MS_FAILURE);
+        if (s == layer->class[c] -> numstyles) {
+          /* no style in scale bounds */
+          goto nextshape;
         }
-    } else {
-        layer = GET_LAYER(map, layer_idx);
-    }
-    /* open the linked layer */
-    status = msLayerOpen(layer);
-    if(status != MS_SUCCESS) return MS_FAILURE;
-
-    status = msLayerWhichItems(layer, MS_FALSE, NULL);
-    if(status != MS_SUCCESS) {
-        msLayerClose(layer);
-        return MS_FAILURE;
-    }
-
-    /* identify target shapes */
-    if(layer->transform == MS_TRUE) {
-        searchrect = map->extent;
-        if(interpParams.expand_searchrect) {
-            georadius = interpParams.radius * map->cellsize;
-            searchrect.minx -= georadius;
-            searchrect.miny -= georadius;
-            searchrect.maxx += georadius;
-            searchrect.maxy += georadius;
-            im_width += 2 * interpParams.radius;
-            im_height += 2 * interpParams.radius;
+      }
+      for (l = 0; l < shape.numlines; l++) {
+        for (p = 0; p < shape.line[l].numpoints; p++) {
+          int x =
+              MS_MAP2IMAGE_XCELL_IC(shape.line[l].point[p].x,
+                                    map->extent.minx - georadius, invcellsize);
+          int y =
+              MS_MAP2IMAGE_YCELL_IC(shape.line[l].point[p].y,
+                                    map->extent.maxy + georadius, invcellsize);
+          if (x >= 0 && y >= 0 && x < im_width && y < im_height) {
+            float *value = values + y * im_width + x;
+            (*value) += weight;
+            xyz_values[length++] = x;
+            xyz_values[length++] = y;
+            xyz_values[length++] = (*value);
+          }
         }
-    } else {
-        searchrect.minx = searchrect.miny = 0;
-        searchrect.maxx = map->width-1;
-        searchrect.maxy = map->height-1;
-    }
-
-    layer->project = msProjectionsDiffer(&(layer->projection), &(map->projection));
-    if(layer->project)
-        msProjectRect(&map->projection, &layer->projection, &searchrect); /* project the searchrect to source coords */
-
-    status = msLayerWhichShapes(layer, searchrect, MS_FALSE);
-    /* nothing to do */
-    if(status == MS_SUCCESS) { /* at least one sample may have overlapped */
-
-        if(layer->classgroup && layer->numclasses > 0)
-            classgroup = msAllocateValidClassGroups(layer, &nclasses);
-
-        msInitShape(&shape);
-        while((status = msLayerNextShape(layer, &shape)) == MS_SUCCESS) {
-            int l,p,s,c;
-            double weight = 1.0;
-            if(!values){ /* defer allocation until we effectively have a feature */
-                values = (float*) msSmallCalloc(im_width * im_height, sizeof(float));
-                xyz_values = (float*) msSmallCalloc(im_width * im_height, sizeof(float));
-            }
-            if(layer->project)
-                msProjectShape(&layer->projection, &map->projection, &shape);
+      }
 
-            /* the weight for the sample is set to 1.0 by default. If the
-            * layer has some classes defined, we will read the weight from
-            * the class->style->size (which can be binded to an attribute)
-            */
-            if(layer->numclasses > 0) {
-                c = msShapeGetClass(layer, map, &shape, classgroup, nclasses);
-                if((c == -1) || (layer->class[c]->status == MS_OFF)) {
-                    goto nextshape; /* no class matched, skip */
-                }
-                for (s = 0; s < layer->class[c]->numstyles; s++) {
-                    if (msScaleInBounds(map->scaledenom,
-                                        layer->class[c]->styles[s]->minscaledenom,
-                                        layer->class[c]->styles[s]->maxscaledenom)) {
-                        if(layer->class[c]->styles[s]->bindings[MS_STYLE_BINDING_SIZE].index != -1) {
-                            weight = atof(shape.values[layer->class[c]->styles[s]->bindings[MS_STYLE_BINDING_SIZE].index]);
-                        } else {
-                            weight = layer->class[c]->styles[s]->size;
-                        }
-                        break;
-                    }
-                }
-                if(s == layer->class[c]->numstyles) {
-                    /* no style in scale bounds */
-                    goto nextshape;
-                }
-            }
-            for(l=0; l<shape.numlines; l++) {
-                for(p=0; p<shape.line[l].numpoints; p++) {
-                    int x = MS_MAP2IMAGE_XCELL_IC(shape.line[l].point[p].x, map->extent.minx - georadius, invcellsize);
-                    int y = MS_MAP2IMAGE_YCELL_IC(shape.line[l].point[p].y, map->extent.maxy + georadius, invcellsize);
-                    if(x>=0 && y>=0 && x<im_width && y<im_height) {
-                        float *value = values + y * im_width + x;
-                        (*value) += weight;
-                        xyz_values[length++] = x;
-                        xyz_values[length++] = y;
-                        xyz_values[length++] = (*value);
-                    }
-                }
-            }
-
-nextshape:
-            msFreeShape(&shape);
-        }
-        //number of layer points.
-        npoints = length/3;
-    } else if(status != MS_DONE) {
-        msLayerClose(layer);
-        return MS_FAILURE;
+    nextshape:
+      msFreeShape(&shape);
     }
-
-    /* status == MS_DONE */
+    // number of layer points.
+    npoints = length / 3;
+  } else if (status != MS_DONE) {
     msLayerClose(layer);
-    status = MS_SUCCESS;
+    return MS_FAILURE;
+  }
 
-    if(npoints > 0 && interpParams.expand_searchrect) {
-        iValues = msSmallMalloc(image->width*image->height*sizeof(unsigned char));
-    } else {
-        iValues = msSmallCalloc(1,image->width*image->height*sizeof(unsigned char));
-    }
+  /* status == MS_DONE */
+  msLayerClose(layer);
+  status = MS_SUCCESS;
+
+  if (npoints > 0 && interpParams.expand_searchrect) {
+    iValues =
+        msSmallMalloc(image->width * image->height * sizeof(unsigned char));
+  } else {
+    iValues =
+        msSmallCalloc(1, image->width * image->height * sizeof(unsigned char));
+  }
 
-    if(npoints > 0) { /* no use applying the filtering kernel if we have no samples */
-        if (interpolation_layer->connectiontype == MS_KERNELDENSITY) {
-            msKernelDensity(image, values, im_width, im_height, npoints, &interpParams, iValues);
-        } else if(interpolation_layer->connectiontype == MS_IDW) {
-            msIdw(xyz_values, image->width, image->height, npoints, &interpParams, iValues);
-        }
+  if (npoints >
+      0) { /* no use applying the filtering kernel if we have no samples */
+    if (interpolation_layer->connectiontype == MS_KERNELDENSITY) {
+      msKernelDensity(image, values, im_width, im_height, npoints,
+                      &interpParams, iValues);
+    } else if (interpolation_layer->connectiontype == MS_IDW) {
+      msIdw(xyz_values, image->width, image->height, npoints, &interpParams,
+            iValues);
     }
+  }
 
-    free(values);
-    free(xyz_values);
-
+  free(values);
+  free(xyz_values);
 
-    char pointer[64];
-    char ds_string [1024];
-    double adfGeoTransform[6];
-    memset(pointer, 0, sizeof(pointer));
-    CPLPrintPointer(pointer, iValues, sizeof(pointer));
-    snprintf(ds_string,1024,"MEM:::DATAPOINTER=%s,PIXELS=%d,LINES=%d,BANDS=1,DATATYPE=Byte,PIXELOFFSET=1,LINEOFFSET=%d",
-        pointer,image->width,image->height,image->width);
-    hDS = GDALOpenShared( ds_string, GA_ReadOnly );
-    if(hDS == NULL) {
-        msSetError(MS_MISCERR,"msInterpolationDataset()","failed to create in-memory gdal dataset for interpolated data");
-        status = MS_FAILURE;
-        free(iValues);
-    }
-    adfGeoTransform[0] = map->extent.minx - map->cellsize * 0.5; /* top left x */
-    adfGeoTransform[1] = map->cellsize;/* w-e pixel resolution */
-    adfGeoTransform[2] = 0; /* 0 */
-    adfGeoTransform[3] = map->extent.maxy + map->cellsize * 0.5;/* top left y */
-    adfGeoTransform[4] = 0; /* 0 */
-    adfGeoTransform[5] = -map->cellsize;/* n-s pixel resolution (negative value) */
-    GDALSetGeoTransform(hDS,adfGeoTransform);
-    *hDSvoid = hDS;
-    *cleanup_ptr = (void*)iValues;
+  char pointer[64];
+  char ds_string[1024];
+  double adfGeoTransform[6];
+  memset(pointer, 0, sizeof(pointer));
+  CPLPrintPointer(pointer, iValues, sizeof(pointer));
+  snprintf(ds_string, 1024,
+           "MEM:::DATAPOINTER=%s,PIXELS=%d,LINES=%d,BANDS=1,DATATYPE=Byte,"
+           "PIXELOFFSET=1,LINEOFFSET=%d",
+           pointer, image->width, image->height, image->width);
+  hDS = GDALOpenShared(ds_string, GA_ReadOnly);
+  if (hDS == NULL) {
+    msSetError(MS_MISCERR, "msInterpolationDataset()",
+               "failed to create in-memory gdal dataset for interpolated data");
+    status = MS_FAILURE;
+    free(iValues);
+  }
+  adfGeoTransform[0] = map->extent.minx - map->cellsize * 0.5; /* top left x */
+  adfGeoTransform[1] = map->cellsize; /* w-e pixel resolution */
+  adfGeoTransform[2] = 0;             /* 0 */
+  adfGeoTransform[3] = map->extent.maxy + map->cellsize * 0.5; /* top left y */
+  adfGeoTransform[4] = 0;                                      /* 0 */
+  adfGeoTransform[5] =
+      -map->cellsize; /* n-s pixel resolution (negative value) */
+  GDALSetGeoTransform(hDS, adfGeoTransform);
+  *hDSvoid = hDS;
+  *cleanup_ptr = (void *)iValues;
 
-    return status;
+  return status;
 }
 
-int msCleanupInterpolationDataset(mapObj *map, imageObj *image, layerObj *layer, void *cleanup_ptr) {
-    (void)map;
-    (void)image;
-    (void)layer;
-    free(cleanup_ptr);
-    return MS_SUCCESS;
+int msCleanupInterpolationDataset(mapObj *map, imageObj *image, layerObj *layer,
+                                  void *cleanup_ptr) {
+  (void)map;
+  (void)image;
+  (void)layer;
+  free(cleanup_ptr);
+  return MS_SUCCESS;
 }
diff -pruN 8.0.1-5/kerneldensity.c 8.0.2-1/kerneldensity.c
--- 8.0.1-5/kerneldensity.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/kerneldensity.c	2024-06-11 20:41:34.000000000 +0000
@@ -32,128 +32,138 @@
 
 #include "gdal.h"
 
-static
-void gaussian_blur(float *values, int width, int height, int radius) {
-  float *tmp = (float*)msSmallMalloc(width*height*sizeof(float));
-  int length = radius*2+1;
-  float *kernel = (float*)msSmallMalloc(length*sizeof(float));
-  float sigma=radius/3.0;
-	float a=1.0/ sqrt(2.0*M_PI*sigma*sigma);
-	float den=2.0*sigma*sigma;
-	int i,x,y;
-
-	for (i=0; i<length; i++) {
-	  float x=i - radius;
-	  float v=a * exp(-(x*x) / den);
-	  kernel[i]=v;
-	}
-	memset(tmp,0,width*height*sizeof(float));
-
-	for(y=0; y<height; y++) {
-		float* src_row=values + width*y;
-		float* dst_row=tmp + width*y;
-
-		for(x=radius; x<width-radius; x++) {
-			float accum=0;
-			for(i=0; i<length; i++) {
-				accum+=src_row[x+i-radius] * kernel[i];
-			}
-			dst_row[x]=accum;
-		}
-	}
-
-	for(x=0; x<width; x++) {
-		float* src_col=tmp+x;
-		float* dst_col=values+x;
-
-		for(y=radius; y<height-radius; y++) {
-			float accum=0;
-			for (i=0; i<length; i++) {
-				accum+=src_col[width*(y+i-radius)] * kernel[i];
-			}
-			dst_col[y*width]=accum;
-		}
-	}
-  free(tmp);
-  free(kernel);
-}
-
-void msKernelDensityProcessing(layerObj *layer, interpolationProcessingParams *interpParams) {
-    const char *interpParamsProcessing = msLayerGetProcessingKey( layer, "KERNELDENSITY_RADIUS" );
-    if(interpParamsProcessing) {
-        interpParams->radius = atoi(interpParamsProcessing);
-    } else {
-        interpParams->radius = 10;
+static void gaussian_blur(float *values, int width, int height, int radius) {
+  float *tmp = (float *)msSmallMalloc(width * height * sizeof(float));
+  int length = radius * 2 + 1;
+  float *kernel = (float *)msSmallMalloc(length * sizeof(float));
+  float sigma = radius / 3.0;
+  float a = 1.0 / sqrt(2.0 * M_PI * sigma * sigma);
+  float den = 2.0 * sigma * sigma;
+  int i, x, y;
+
+  for (i = 0; i < length; i++) {
+    float x = i - radius;
+    float v = a * exp(-(x * x) / den);
+    kernel[i] = v;
+  }
+  memset(tmp, 0, width * height * sizeof(float));
+
+  for (y = 0; y < height; y++) {
+    float *src_row = values + width * y;
+    float *dst_row = tmp + width * y;
+
+    for (x = radius; x < width - radius; x++) {
+      float accum = 0;
+      for (i = 0; i < length; i++) {
+        accum += src_row[x + i - radius] * kernel[i];
+      }
+      dst_row[x] = accum;
     }
+  }
 
-    interpParamsProcessing = msLayerGetProcessingKey( layer, "KERNELDENSITY_COMPUTE_BORDERS" );
-    if(interpParamsProcessing && strcasecmp(interpParamsProcessing,"OFF")) {
-        interpParams->expand_searchrect = 1;
-    } else {
-        interpParams->expand_searchrect = 0;
+  for (x = 0; x < width; x++) {
+    float *src_col = tmp + x;
+    float *dst_col = values + x;
+
+    for (y = radius; y < height - radius; y++) {
+      float accum = 0;
+      for (i = 0; i < length; i++) {
+        accum += src_col[width * (y + i - radius)] * kernel[i];
+      }
+      dst_col[y * width] = accum;
     }
+  }
+  free(tmp);
+  free(kernel);
+}
 
-    interpParamsProcessing = msLayerGetProcessingKey( layer, "KERNELDENSITY_NORMALIZATION" );
-    if(!interpParamsProcessing || !strcasecmp(interpParamsProcessing,"AUTO")) {
-        interpParams->normalization_scale = 0.0;
+void msKernelDensityProcessing(layerObj *layer,
+                               interpolationProcessingParams *interpParams) {
+  const char *interpParamsProcessing =
+      msLayerGetProcessingKey(layer, "KERNELDENSITY_RADIUS");
+  if (interpParamsProcessing) {
+    interpParams->radius = atoi(interpParamsProcessing);
+  } else {
+    interpParams->radius = 10;
+  }
+
+  interpParamsProcessing =
+      msLayerGetProcessingKey(layer, "KERNELDENSITY_COMPUTE_BORDERS");
+  if (interpParamsProcessing && strcasecmp(interpParamsProcessing, "OFF")) {
+    interpParams->expand_searchrect = 1;
+  } else {
+    interpParams->expand_searchrect = 0;
+  }
+
+  interpParamsProcessing =
+      msLayerGetProcessingKey(layer, "KERNELDENSITY_NORMALIZATION");
+  if (!interpParamsProcessing || !strcasecmp(interpParamsProcessing, "AUTO")) {
+    interpParams->normalization_scale = 0.0;
+  } else {
+    interpParams->normalization_scale = atof(interpParamsProcessing);
+    if (interpParams->normalization_scale != 0) {
+      interpParams->normalization_scale =
+          1.0 / interpParams->normalization_scale;
     } else {
-        interpParams->normalization_scale = atof(interpParamsProcessing);
-        if(interpParams->normalization_scale != 0) {
-            interpParams->normalization_scale = 1.0 / interpParams->normalization_scale;
-        } else {
-            interpParams->normalization_scale = 1.0;
-        }
+      interpParams->normalization_scale = 1.0;
     }
+  }
 }
 
-void msKernelDensity(imageObj *image, float *values, int width, int height, int npoints,
-                   interpolationProcessingParams *interpParams, unsigned char *iValues) {
-    int i,j;
-    float valmax=FLT_MIN, valmin=FLT_MAX;
-    int radius = interpParams->radius;
-    float normalization_scale = interpParams->normalization_scale;
-    int expand_searchrect = interpParams->expand_searchrect;
-
-    gaussian_blur(values, width, height, radius);
-
-    if(normalization_scale == 0.0) {   /* auto normalization */
-        for (j = radius; j < height-radius; j++) {
-            for (i = radius; i < width-radius; i++) {
-                float val = values[j*width + i];
-                if(val >0 && val>valmax) {
-                    valmax = val;
-                }
-                if(val>0 && val<valmin) {
-                    valmin = val;
-                }
-            }
+void msKernelDensity(imageObj *image, float *values, int width, int height,
+                     int npoints, interpolationProcessingParams *interpParams,
+                     unsigned char *iValues) {
+  int i, j;
+  float valmax = FLT_MIN, valmin = FLT_MAX;
+  int radius = interpParams->radius;
+  float normalization_scale = interpParams->normalization_scale;
+  int expand_searchrect = interpParams->expand_searchrect;
+
+  gaussian_blur(values, width, height, radius);
+
+  if (normalization_scale == 0.0) { /* auto normalization */
+    for (j = radius; j < height - radius; j++) {
+      for (i = radius; i < width - radius; i++) {
+        float val = values[j * width + i];
+        if (val > 0 && val > valmax) {
+          valmax = val;
         }
-    } else {
-        valmin = 0;
-        valmax = normalization_scale;
-    }
-
-    if(expand_searchrect) {
-        for (j=0; j < image->height; j++) {
-            for (i=0; i < image->width; i++) {
-                float norm = (values[(j+radius)*width + i + radius] - valmin) / valmax;
-                int v = 255 * norm;
-                if (v<0) v=0;
-                else if (v>255) v = 255;
-                iValues[j*image->width + i] = v;
-            }
+        if (val > 0 && val < valmin) {
+          valmin = val;
         }
-    } else {
-        if(npoints > 0) {
-            for (j=radius; j < image->height-radius; j++) {
-                for (i=radius; i < image->width-radius; i++) {
-                    float norm=(values[j*width + i] - valmin) / valmax;
-                    int v=255 * norm;
-                    if (v<0) v=0;
-                    else if (v>255) v=255;
-                    iValues[j*image->width + i]=v;
-                }
-            }
+      }
+    }
+  } else {
+    valmin = 0;
+    valmax = normalization_scale;
+  }
+
+  if (expand_searchrect) {
+    for (j = 0; j < image->height; j++) {
+      for (i = 0; i < image->width; i++) {
+        float norm =
+            (values[(j + radius) * width + i + radius] - valmin) / valmax;
+        int v = 255 * norm;
+        if (v < 0)
+          v = 0;
+        else if (v > 255)
+          v = 255;
+        iValues[j * image->width + i] = v;
+      }
+    }
+  } else {
+    if (npoints > 0) {
+      for (j = radius; j < image->height - radius; j++) {
+        for (i = radius; i < image->width - radius; i++) {
+          float norm = (values[j * width + i] - valmin) / valmax;
+          int v = 255 * norm;
+          if (v < 0)
+            v = 0;
+          else if (v > 255)
+            v = 255;
+          iValues[j * image->width + i] = v;
         }
+      }
     }
+  }
 }
diff -pruN 8.0.1-5/layerobject.c 8.0.2-1/layerobject.c
--- 8.0.1-5/layerobject.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/layerobject.c	2024-06-11 20:41:34.000000000 +0000
@@ -31,15 +31,13 @@
 
 #include "mapserver.h"
 
-
 /* ===========================================================================
    msInsertClass
 
    Returns the index at which the class was inserted.
    ======================================================================== */
 
-int msInsertClass(layerObj *layer, classObj *classobj, int nIndex)
-{
+int msInsertClass(layerObj *layer, classObj *classobj, int nIndex) {
   int i;
 
   if (!classobj) {
@@ -54,36 +52,36 @@ int msInsertClass(layerObj *layer, class
   /* Catch attempt to insert past end of styles array */
   else if (nIndex >= layer->numclasses) {
     msSetError(MS_CHILDERR, "Cannot insert class beyond index %d",
-               "msInsertClass()", layer->numclasses-1);
+               "msInsertClass()", layer->numclasses - 1);
     return -1;
   } else if (nIndex < 0) { /* Insert at the end by default */
 #ifndef __cplusplus
-    layer->class[layer->numclasses]=classobj;
+    layer->class[layer->numclasses] = classobj;
 #else
-    layer->_class[layer->numclasses]=classobj;
+    layer->_class[layer->numclasses] = classobj;
 #endif
     /* set parent pointer */
-    classobj->layer=layer;
+    classobj->layer = layer;
     MS_REFCNT_INCR(classobj);
     layer->numclasses++;
-    return layer->numclasses-1;
+    return layer->numclasses - 1;
   } else {
 
     /* Copy classes existing at the specified nIndex or greater */
     /* to an index one higher */
 
 #ifndef __cplusplus
-    for (i=layer->numclasses-1; i>=nIndex; i--)
-      layer->class[i+1] = layer->class[i];
-    layer->class[nIndex]=classobj;
+    for (i = layer->numclasses - 1; i >= nIndex; i--)
+      layer->class[i + 1] = layer->class[i];
+    layer->class[nIndex] = classobj;
 #else
-    for (i=layer->numclasses-1; i>=nIndex; i--)
-      layer->_class[i+1] = layer->_class[i];
-    layer->_class[nIndex]=classobj;
+    for (i = layer->numclasses - 1; i >= nIndex; i--)
+      layer->_class[i + 1] = layer->_class[i];
+    layer->_class[nIndex] = classobj;
 #endif
 
     /* set parent pointer */
-    classobj->layer=layer;
+    classobj->layer = layer;
     MS_REFCNT_INCR(classobj);
     /* increment number of classes and return */
     layer->numclasses++;
@@ -97,8 +95,7 @@ int msInsertClass(layerObj *layer, class
    remove the class at an index from a layer, returning a copy
    ======================================================================== */
 
-classObj *msRemoveClass(layerObj *layer, int nIndex)
-{
+classObj *msRemoveClass(layerObj *layer, int nIndex) {
   int i;
   classObj *classobj;
 
@@ -108,25 +105,25 @@ classObj *msRemoveClass(layerObj *layer,
     return NULL;
   } else {
 #ifndef __cplusplus
-    classobj=layer->class[nIndex];
+    classobj = layer->class[nIndex];
 #else
-    classobj=layer->_class[nIndex];
+    classobj = layer->_class[nIndex];
 #endif
-    classobj->layer=NULL;
+    classobj->layer = NULL;
     MS_REFCNT_DECR(classobj);
 
     /* Iteratively copy the higher index classes down one index */
-    for (i=nIndex; i<layer->numclasses-1; i++) {
+    for (i = nIndex; i < layer->numclasses - 1; i++) {
 #ifndef __cplusplus
-      layer->class[i]=layer->class[i+1];
+      layer->class[i] = layer->class[i + 1];
 #else
-      layer->_class[i]=layer->_class[i+1];
+      layer->_class[i] = layer->_class[i + 1];
 #endif
     }
 #ifndef __cplusplus
-    layer->class[i]=NULL;
+    layer->class[i] = NULL;
 #else
-    layer->_class[i]=NULL;
+    layer->_class[i] = NULL;
 #endif
 
     /* decrement number of layers and return copy of removed layer */
@@ -138,38 +135,34 @@ classObj *msRemoveClass(layerObj *layer,
 /**
  * Move the class up inside the array of classes.
  */
-int msMoveClassUp(layerObj *layer, int nClassIndex)
-{
+int msMoveClassUp(layerObj *layer, int nClassIndex) {
   classObj *psTmpClass = NULL;
-  if (layer && nClassIndex < layer->numclasses && nClassIndex >0) {
-    psTmpClass=layer->class[nClassIndex];
+  if (layer && nClassIndex < layer->numclasses && nClassIndex > 0) {
+    psTmpClass = layer->class[nClassIndex];
 
-    layer->class[nClassIndex] = layer->class[nClassIndex-1];
+    layer->class[nClassIndex] = layer->class[nClassIndex - 1];
 
-    layer->class[nClassIndex-1] = psTmpClass;
+    layer->class[nClassIndex - 1] = psTmpClass;
 
-    return(MS_SUCCESS);
+    return (MS_SUCCESS);
   }
-  msSetError(MS_CHILDERR, "Invalid index: %d", "msMoveClassUp()",
-             nClassIndex);
+  msSetError(MS_CHILDERR, "Invalid index: %d", "msMoveClassUp()", nClassIndex);
   return (MS_FAILURE);
 }
 
-
 /**
  * Move the class down inside the array of classes.
  */
-int msMoveClassDown(layerObj *layer, int nClassIndex)
-{
+int msMoveClassDown(layerObj *layer, int nClassIndex) {
   classObj *psTmpClass = NULL;
-  if (layer && nClassIndex < layer->numclasses-1 && nClassIndex >=0) {
-    psTmpClass=layer->class[nClassIndex];
+  if (layer && nClassIndex < layer->numclasses - 1 && nClassIndex >= 0) {
+    psTmpClass = layer->class[nClassIndex];
 
-    layer->class[nClassIndex] = layer->class[nClassIndex+1];
+    layer->class[nClassIndex] = layer->class[nClassIndex + 1];
 
-    layer->class[nClassIndex+1] = psTmpClass;
+    layer->class[nClassIndex + 1] = psTmpClass;
 
-    return(MS_SUCCESS);
+    return (MS_SUCCESS);
   }
   msSetError(MS_CHILDERR, "Invalid index: %d", "msMoveClassDown()",
              nClassIndex);
@@ -180,9 +173,8 @@ int msMoveClassDown(layerObj *layer, int
  * Set the extent of a layer.
  */
 
-int msLayerSetExtent( layerObj *layer,
-                      double minx, double miny, double maxx, double maxy)
-{
+int msLayerSetExtent(layerObj *layer, double minx, double miny, double maxx,
+                     double maxy) {
 
   layer->extent.minx = minx;
   layer->extent.miny = miny;
@@ -190,12 +182,16 @@ int msLayerSetExtent( layerObj *layer,
   layer->extent.maxy = maxy;
 
   if (minx == -1.0 && miny == -1.0 && maxx == -1.0 && maxy == -1.0)
-    return(MS_SUCCESS);
+    return (MS_SUCCESS);
 
   if (!MS_VALID_EXTENT(layer->extent)) {
-    msSetError(MS_MISCERR, "Given layer extent is invalid. minx=%lf, miny=%lf, maxx=%lf, maxy=%lf.", "msLayerSetExtent()", layer->extent.minx, layer->extent.miny, layer->extent.maxx, layer->extent.maxy);
-    return(MS_FAILURE);
+    msSetError(MS_MISCERR,
+               "Given layer extent is invalid. minx=%lf, miny=%lf, maxx=%lf, "
+               "maxy=%lf.",
+               "msLayerSetExtent()", layer->extent.minx, layer->extent.miny,
+               layer->extent.maxx, layer->extent.maxy);
+    return (MS_FAILURE);
   }
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
diff -pruN 8.0.1-5/legend.c 8.0.2-1/legend.c
--- 8.0.1-5/legend.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/legend.c	2024-06-11 20:41:34.000000000 +0000
@@ -29,32 +29,29 @@
 
 #include "mapserver.h"
 
-
-
-int main(int argc, char *argv[])
-{
-  mapObj *map=NULL;
-  imageObj *img=NULL;
+int main(int argc, char *argv[]) {
+  mapObj *map = NULL;
+  imageObj *img = NULL;
 
   msSetup();
-  if(argc > 1 && strcmp(argv[1], "-v") == 0) {
+  if (argc > 1 && strcmp(argv[1], "-v") == 0) {
     printf("%s\n", msGetVersion());
     exit(0);
   }
 
-  if( argc < 3 ) {
-    fprintf(stdout,"Syntax: legend [mapfile] [output image]\n" );
+  if (argc < 3) {
+    fprintf(stdout, "Syntax: legend [mapfile] [output image]\n");
     exit(0);
   }
 
   map = msLoadMap(argv[1], NULL, NULL);
-  if(!map) {
+  if (!map) {
     msWriteError(stderr);
     exit(0);
   }
 
   img = msDrawLegend(map, MS_FALSE, NULL);
-  if(!img) {
+  if (!img) {
     msWriteError(stderr);
     exit(0);
   }
@@ -64,5 +61,5 @@ int main(int argc, char *argv[])
   msFreeImage(img);
   msFreeMap(map);
 
-  return(MS_TRUE);
+  return (MS_TRUE);
 }
diff -pruN 8.0.1-5/map2img.c 8.0.2-1/map2img.c
--- 8.0.1-5/map2img.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/map2img.c	2024-06-11 20:41:34.000000000 +0000
@@ -34,65 +34,70 @@
 
 #include "limits.h"
 
-int main(int argc, char *argv[])
-{
-  int i,j,k;
+int main(int argc, char *argv[]) {
+  int i, j, k;
 
-  mapObj         *map=NULL;
-  imageObj         *image = NULL;
-  configObj* config = NULL;
+  mapObj *map = NULL;
+  imageObj *image = NULL;
+  configObj *config = NULL;
 
-  char **layers=NULL;
-  int num_layers=0;
+  char **layers = NULL;
+  int num_layers = 0;
 
-  int layer_found=0;
+  int layer_found = 0;
 
-  char *outfile=NULL; /* no -o sends image to STDOUT */
+  char *outfile = NULL; /* no -o sends image to STDOUT */
 
   int iterations = 1;
   int draws = 0;
 
   /* ---- output version info and exit --- */
-  if(argc > 1 && strcmp(argv[1], "-v") == 0) {
+  if (argc > 1 && strcmp(argv[1], "-v") == 0) {
     printf("%s\n", msGetVersion());
     exit(0);
   }
-  
+
   /* ---- check the number of arguments, return syntax if not correct ---- */
-  if( argc < 3 ) {
+  if (argc < 3) {
     fprintf(stdout, "\nPurpose: convert a mapfile to an image\n\n");
-    fprintf(stdout,
-            "Syntax: map2img -m mapfile [-o image] [-e minx miny maxx maxy] [-s sizex sizey]\n"
-            "               [-l \"layer1 [layers2...]\"] [-i format]\n"
-            "               [-all_debug n] [-map_debug n] [-layer_debug n] [-p n] [-c n] [-d layername datavalue]\n"
-            "               [-conf filename]\n");
-    fprintf(stdout,"  -m mapfile: Map file to operate on - required\n" );
-    fprintf(stdout,"  -i format: Override the IMAGETYPE value to pick output format\n" );
-    fprintf(stdout,"  -o image: output filename (stdout if not provided)\n");
-    fprintf(stdout,"  -e minx miny maxx maxy: extents to render\n");
-    fprintf(stdout,"  -s sizex sizey: output image size\n");
-    fprintf(stdout,"  -l layers: layers / groups to enable - make sure they are quoted and space separated if more than one listed\n" );
-    fprintf(stdout,"  -all_debug n: Set debug level for map and all layers\n" );
-    fprintf(stdout,"  -map_debug n: Set map debug level\n" );
-    fprintf(stdout,"  -layer_debug layer_name n: Set layer debug level\n" );
-    fprintf(stdout,"  -c n: draw map n number of times\n" );
-    fprintf(stdout,"  -p n: pause for n seconds after reading the map\n" );
-    fprintf(stdout,"  -d layername datavalue: change DATA value for layer\n" );
-    fprintf(stdout,"  -conf filename: filename of the MapServer configuration file.\n" );
+    fprintf(stdout, "Syntax: map2img -m mapfile [-o image] [-e minx miny maxx "
+                    "maxy] [-s sizex sizey]\n"
+                    "               [-l \"layer1 [layers2...]\"] [-i format]\n"
+                    "               [-all_debug n] [-map_debug n] "
+                    "[-layer_debug n] [-p n] [-c n] [-d layername datavalue]\n"
+                    "               [-conf filename]\n");
+    fprintf(stdout, "  -m mapfile: Map file to operate on - required\n");
+    fprintf(
+        stdout,
+        "  -i format: Override the IMAGETYPE value to pick output format\n");
+    fprintf(stdout, "  -o image: output filename (stdout if not provided)\n");
+    fprintf(stdout, "  -e minx miny maxx maxy: extents to render\n");
+    fprintf(stdout, "  -s sizex sizey: output image size\n");
+    fprintf(stdout, "  -l layers: layers / groups to enable - make sure they "
+                    "are quoted and space separated if more than one listed\n");
+    fprintf(stdout, "  -all_debug n: Set debug level for map and all layers\n");
+    fprintf(stdout, "  -map_debug n: Set map debug level\n");
+    fprintf(stdout, "  -layer_debug layer_name n: Set layer debug level\n");
+    fprintf(stdout, "  -c n: draw map n number of times\n");
+    fprintf(stdout, "  -p n: pause for n seconds after reading the map\n");
+    fprintf(stdout, "  -d layername datavalue: change DATA value for layer\n");
+    fprintf(
+        stdout,
+        "  -conf filename: filename of the MapServer configuration file.\n");
     exit(0);
   }
 
-  if ( msSetup() != MS_SUCCESS ) {
+  if (msSetup() != MS_SUCCESS) {
     msWriteError(stderr);
     exit(1);
   }
 
   bool some_debug_requested = FALSE;
-  const char* config_filename = NULL;
-  for(i=1; i<argc; i++) {
-    if (strcmp(argv[i],"-c") == 0) { /* user specified number of draws */
-      iterations = atoi(argv[i+1]);
-      if( iterations < 0 || iterations > INT_MAX - 1 ) {
+  const char *config_filename = NULL;
+  for (i = 1; i < argc; i++) {
+    if (strcmp(argv[i], "-c") == 0) { /* user specified number of draws */
+      iterations = atoi(argv[i + 1]);
+      if (iterations < 0 || iterations > INT_MAX - 1) {
         printf("Invalid number of iterations");
         return 1;
       }
@@ -100,7 +105,7 @@ int main(int argc, char *argv[])
       continue;
     }
 
-    if(i < argc-1 && strcmp(argv[i], "-all_debug") == 0) { /* global debug */
+    if (i < argc - 1 && strcmp(argv[i], "-all_debug") == 0) { /* global debug */
       int debug_level = atoi(argv[++i]);
 
       some_debug_requested = TRUE;
@@ -110,21 +115,21 @@ int main(int argc, char *argv[])
       continue;
     }
 
-    if(i < argc-1 && (strcmp(argv[i], "-map_debug") == 0 ||
-                      strcmp(argv[i], "-layer_debug") == 0)) {
+    if (i < argc - 1 && (strcmp(argv[i], "-map_debug") == 0 ||
+                         strcmp(argv[i], "-layer_debug") == 0)) {
 
       some_debug_requested = TRUE;
       continue;
     }
 
-    if(i < argc-1 && strcmp(argv[i], "-conf") == 0) {
-      config_filename = argv[i+1];
+    if (i < argc - 1 && strcmp(argv[i], "-conf") == 0) {
+      config_filename = argv[i + 1];
       ++i;
       continue;
     }
   }
 
-  if( some_debug_requested ) {
+  if (some_debug_requested) {
     /* Send output to stderr by default */
     if (msGetErrorFile() == NULL)
       msSetErrorFile("stderr", NULL);
@@ -132,31 +137,30 @@ int main(int argc, char *argv[])
 
   config = msLoadConfig(config_filename);
 
-  for(draws=0; draws<iterations; draws++) {
+  for (draws = 0; draws < iterations; draws++) {
 
     struct mstimeval requeststarttime, requestendtime;
 
-    if(msGetGlobalDebugLevel() >= MS_DEBUGLEVEL_TUNING)
+    if (msGetGlobalDebugLevel() >= MS_DEBUGLEVEL_TUNING)
       msGettimeofday(&requeststarttime, NULL);
 
     /* Use PROJ_DATA/PROJ_LIB env vars if set */
     msProjDataInitFromEnv();
 
     /* Use MS_ERRORFILE and MS_DEBUGLEVEL env vars if set */
-    if ( msDebugInitFromEnv() != MS_SUCCESS ) {
+    if (msDebugInitFromEnv() != MS_SUCCESS) {
       msWriteError(stderr);
       msCleanup();
       msFreeConfig(config);
       exit(1);
     }
 
+    for (i = 1; i < argc;
+         i++) { /* Step though the user arguments, 1st to find map file */
 
-
-    for(i=1; i<argc; i++) { /* Step though the user arguments, 1st to find map file */
-
-      if(strcmp(argv[i],"-m") == 0) {
-        map = msLoadMap(argv[i+1], NULL, config);
-        if(!map) {
+      if (strcmp(argv[i], "-m") == 0) {
+        map = msLoadMap(argv[i + 1], NULL, config);
+        if (!map) {
           msWriteError(stderr);
           msCleanup();
           msFreeConfig(config);
@@ -166,128 +170,131 @@ int main(int argc, char *argv[])
       }
     }
 
-    if(!map) {
+    if (!map) {
       fprintf(stderr, "Mapfile (-m) option not specified.\n");
       msCleanup();
       msFreeConfig(config);
       exit(1);
     }
 
+    for (i = 1; i < argc; i++) { /* Step though the user arguments */
 
-    for(i=1; i<argc; i++) { /* Step though the user arguments */
-
-      if(strcmp(argv[i],"-m") == 0) { /* skip it */
-        i+=1;
+      if (strcmp(argv[i], "-m") == 0) { /* skip it */
+        i += 1;
       }
 
-      if(strcmp(argv[i],"-p") == 0) {
-        int pause_length = atoi(argv[i+1]);
+      if (strcmp(argv[i], "-p") == 0) {
+        int pause_length = atoi(argv[i + 1]);
         time_t start_time = time(NULL);
 
-        printf( "Start pause of %d seconds.\n", pause_length );
-        while( time(NULL) < start_time + pause_length ) {}
-        printf( "Done pause.\n" );
+        printf("Start pause of %d seconds.\n", pause_length);
+        while (time(NULL) < start_time + pause_length) {
+        }
+        printf("Done pause.\n");
 
-        i+=1;
+        i += 1;
       }
 
-      if(strcmp(argv[i],"-o") == 0) { /* load the output image filename */
-        outfile = argv[i+1];
-        i+=1;
+      if (strcmp(argv[i], "-o") == 0) { /* load the output image filename */
+        outfile = argv[i + 1];
+        i += 1;
       }
 
-      if(strcmp(argv[i],"-i") == 0) {
+      if (strcmp(argv[i], "-i") == 0) {
         outputFormatObj *format;
 
-        format = msSelectOutputFormat( map, argv[i+1] );
+        format = msSelectOutputFormat(map, argv[i + 1]);
 
-        if( format == NULL )
-          printf( "No such OUTPUTFORMAT as %s.\n", argv[i+1] );
+        if (format == NULL)
+          printf("No such OUTPUTFORMAT as %s.\n", argv[i + 1]);
         else {
-          msFree( (char *) map->imagetype );
-          map->imagetype = msStrdup( argv[i+1] );
-          msApplyOutputFormat( &(map->outputformat), format, MS_NOOVERRIDE);
+          msFree((char *)map->imagetype);
+          map->imagetype = msStrdup(argv[i + 1]);
+          msApplyOutputFormat(&(map->outputformat), format, MS_NOOVERRIDE);
         }
-        i+=1;
+        i += 1;
       }
 
-      if(strcmp(argv[i],"-d") == 0) { /* swap layer data */
-        for(j=0; j<map->numlayers; j++) {
-          if(strcmp(GET_LAYER(map, j)->name, argv[i+1]) == 0) {
+      if (strcmp(argv[i], "-d") == 0) { /* swap layer data */
+        for (j = 0; j < map->numlayers; j++) {
+          if (strcmp(GET_LAYER(map, j)->name, argv[i + 1]) == 0) {
             free(GET_LAYER(map, j)->data);
-            GET_LAYER(map, j)->data = msStrdup(argv[i+2]);
+            GET_LAYER(map, j)->data = msStrdup(argv[i + 2]);
             break;
           }
         }
-        i+=2;
+        i += 2;
       }
 
-      if(i < argc-1 && strcmp(argv[i], "-all_debug") == 0) { /* global debug */
+      if (i < argc - 1 &&
+          strcmp(argv[i], "-all_debug") == 0) { /* global debug */
         int debug_level = atoi(argv[++i]);
 
         /* msSetGlobalDebugLevel() already called. Just need to force debug
          * level in map and all layers
          */
         map->debug = debug_level;
-        for(j=0; j<map->numlayers; j++) {
+        for (j = 0; j < map->numlayers; j++) {
           GET_LAYER(map, j)->debug = debug_level;
         }
-
       }
 
-      if(i < argc-1 && strcmp(argv[i], "-map_debug") == 0) { /* debug */
+      if (i < argc - 1 && strcmp(argv[i], "-map_debug") == 0) { /* debug */
         map->debug = atoi(argv[++i]);
       }
 
-      if(i < argc-1 && strcmp(argv[i], "-layer_debug") == 0) { /* debug */
+      if (i < argc - 1 && strcmp(argv[i], "-layer_debug") == 0) { /* debug */
         const char *layer_name = argv[++i];
         int debug_level = atoi(argv[++i]);
         int got_layer = 0;
 
-        for(j=0; j<map->numlayers; j++) {
-          if(strcmp(GET_LAYER(map, j)->name,layer_name) == 0 ) {
+        for (j = 0; j < map->numlayers; j++) {
+          if (strcmp(GET_LAYER(map, j)->name, layer_name) == 0) {
             GET_LAYER(map, j)->debug = debug_level;
             got_layer = 1;
           }
         }
-        if( !got_layer )
-          fprintf( stderr,
-                   " Did not find layer '%s' from -layer_debug switch.\n",
-                   layer_name );
+        if (!got_layer)
+          fprintf(stderr,
+                  " Did not find layer '%s' from -layer_debug switch.\n",
+                  layer_name);
       }
 
-      if(strcmp(argv[i],"-e") == 0) { /* change extent */
-        if( argc <= i+4 ) {
-          fprintf( stderr,
-                   "Argument -e needs 4 space separated numbers as argument.\n" );
+      if (strcmp(argv[i], "-e") == 0) { /* change extent */
+        if (argc <= i + 4) {
+          fprintf(stderr,
+                  "Argument -e needs 4 space separated numbers as argument.\n");
           msCleanup();
           msFreeConfig(config);
           exit(1);
         }
-        map->extent.minx = atof(argv[i+1]);
-        map->extent.miny = atof(argv[i+2]);
-        map->extent.maxx = atof(argv[i+3]);
-        map->extent.maxy = atof(argv[i+4]);
-        i+=4;
+        map->extent.minx = atof(argv[i + 1]);
+        map->extent.miny = atof(argv[i + 2]);
+        map->extent.maxx = atof(argv[i + 3]);
+        map->extent.maxy = atof(argv[i + 4]);
+        i += 4;
       }
 
       if (strcmp(argv[i], "-s") == 0) {
-        msMapSetSize(map, atoi(argv[i+1]), atoi(argv[i+2]));
-        i+=2;
+        msMapSetSize(map, atoi(argv[i + 1]), atoi(argv[i + 2]));
+        i += 2;
       }
 
-      if(strcmp(argv[i],"-l") == 0) { /* load layer list */
-        layers = msStringSplit(argv[i+1], ' ', &(num_layers));
+      if (strcmp(argv[i], "-l") == 0) { /* load layer list */
+        layers = msStringSplit(argv[i + 1], ' ', &(num_layers));
 
-        for(j=0; j<num_layers; j++) { /* loop over -l */
-          layer_found=0;
-          for(k=0; k<map->numlayers; k++) {
-            if((GET_LAYER(map, k)->name && strcasecmp(GET_LAYER(map, k)->name, layers[j]) == 0) || (GET_LAYER(map, k)->group && strcasecmp(GET_LAYER(map, k)->group, layers[j]) == 0)) {
+        for (j = 0; j < num_layers; j++) { /* loop over -l */
+          layer_found = 0;
+          for (k = 0; k < map->numlayers; k++) {
+            if ((GET_LAYER(map, k)->name &&
+                 strcasecmp(GET_LAYER(map, k)->name, layers[j]) == 0) ||
+                (GET_LAYER(map, k)->group &&
+                 strcasecmp(GET_LAYER(map, k)->group, layers[j]) == 0)) {
               layer_found = 1;
               break;
             }
           }
-          if (layer_found==0) {
+          if (layer_found == 0) {
             fprintf(stderr, "Layer (-l) \"%s\" not found\n", layers[j]);
             msCleanup();
             msFreeConfig(config);
@@ -295,14 +302,16 @@ int main(int argc, char *argv[])
           }
         }
 
-        for(j=0; j<map->numlayers; j++) {
-          if(GET_LAYER(map, j)->status == MS_DEFAULT)
+        for (j = 0; j < map->numlayers; j++) {
+          if (GET_LAYER(map, j)->status == MS_DEFAULT)
             continue;
           else {
             GET_LAYER(map, j)->status = MS_OFF;
-            for(k=0; k<num_layers; k++) {
-              if((GET_LAYER(map, j)->name && strcasecmp(GET_LAYER(map, j)->name, layers[k]) == 0) ||
-                  (GET_LAYER(map, j)->group && strcasecmp(GET_LAYER(map, j)->group, layers[k]) == 0)) {
+            for (k = 0; k < num_layers; k++) {
+              if ((GET_LAYER(map, j)->name &&
+                   strcasecmp(GET_LAYER(map, j)->name, layers[k]) == 0) ||
+                  (GET_LAYER(map, j)->group &&
+                   strcasecmp(GET_LAYER(map, j)->group, layers[k]) == 0)) {
                 GET_LAYER(map, j)->status = MS_ON;
                 break;
               }
@@ -312,13 +321,13 @@ int main(int argc, char *argv[])
 
         msFreeCharArray(layers, num_layers);
 
-        i+=1;
+        i += 1;
       }
     }
 
     image = msDrawMap(map, MS_FALSE);
 
-    if(!image) {
+    if (!image) {
       msWriteError(stderr);
 
       msFreeMap(map);
@@ -327,22 +336,22 @@ int main(int argc, char *argv[])
       exit(1);
     }
 
-    if( msSaveImage(map, image, outfile) != MS_SUCCESS ) {
+    if (msSaveImage(map, image, outfile) != MS_SUCCESS) {
       msWriteError(stderr);
     }
 
     msFreeImage(image);
     msFreeMap(map);
 
-    if(msGetGlobalDebugLevel() >= MS_DEBUGLEVEL_TUNING) {
+    if (msGetGlobalDebugLevel() >= MS_DEBUGLEVEL_TUNING) {
       msGettimeofday(&requestendtime, NULL);
       msDebug("map2img total time: %.3fs\n",
-              (requestendtime.tv_sec+requestendtime.tv_usec/1.0e6)-
-              (requeststarttime.tv_sec+requeststarttime.tv_usec/1.0e6) );
+              (requestendtime.tv_sec + requestendtime.tv_usec / 1.0e6) -
+                  (requeststarttime.tv_sec + requeststarttime.tv_usec / 1.0e6));
     }
 
   } /*   for(draws=0; draws<iterations; draws++) { */
   msCleanup();
   msFreeConfig(config);
-  return(0);
+  return (0);
 } /* ---- END Main Routine ---- */
diff -pruN 8.0.1-5/mapagg.cpp 8.0.2-1/mapagg.cpp
--- 8.0.1-5/mapagg.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapagg.cpp	2024-06-11 20:41:34.000000000 +0000
@@ -80,35 +80,41 @@ typedef mapserver::rgba8 color_type;
 typedef mapserver::pixel32_type pixel_type;
 
 typedef mapserver::blender_rgba_pre<color_type, band_order> blender_pre;
-typedef mapserver::comp_op_adaptor_rgba_pre<color_type, band_order> compop_blender_pre;
+typedef mapserver::comp_op_adaptor_rgba_pre<color_type, band_order>
+    compop_blender_pre;
 
-typedef mapserver::pixfmt_alpha_blend_rgba<blender_pre, mapserver::rendering_buffer, pixel_type> pixel_format;
-typedef mapserver::pixfmt_custom_blend_rgba<compop_blender_pre, mapserver::rendering_buffer> compop_pixel_format;
+typedef mapserver::pixfmt_alpha_blend_rgba<
+    blender_pre, mapserver::rendering_buffer, pixel_type>
+    pixel_format;
+typedef mapserver::pixfmt_custom_blend_rgba<compop_blender_pre,
+                                            mapserver::rendering_buffer>
+    compop_pixel_format;
 typedef mapserver::rendering_buffer rendering_buffer;
 typedef mapserver::renderer_base<pixel_format> renderer_base;
 typedef mapserver::renderer_base<compop_pixel_format> compop_renderer_base;
 typedef mapserver::renderer_scanline_aa_solid<renderer_base> renderer_scanline;
-typedef mapserver::renderer_scanline_bin_solid<renderer_base> renderer_scanline_aliased;
+typedef mapserver::renderer_scanline_bin_solid<renderer_base>
+    renderer_scanline_aliased;
 typedef mapserver::rasterizer_scanline_aa<> rasterizer_scanline;
 typedef mapserver::font_engine_freetype_int16 font_engine_type;
 typedef mapserver::font_cache_manager<font_engine_type> font_manager_type;
-typedef mapserver::conv_curve<font_manager_type::path_adaptor_type> font_curve_type;
+typedef mapserver::conv_curve<font_manager_type::path_adaptor_type>
+    font_curve_type;
 typedef mapserver::glyph_raster_bin<color_type> glyph_gen;
 
 static const color_type AGG_NO_COLOR = color_type(0, 0, 0, 0);
 
-#define aggColor(c) mapserver::rgba8_pre((c)->red, (c)->green, (c)->blue, (c)->alpha)
+#define aggColor(c)                                                            \
+  mapserver::rgba8_pre((c)->red, (c)->green, (c)->blue, (c)->alpha)
 
-class aggRendererCache
-{
+class aggRendererCache {
 public:
   font_engine_type m_feng;
   font_manager_type m_fman;
-  aggRendererCache(): m_fman(m_feng) {}
+  aggRendererCache() : m_fman(m_feng) {}
 };
 
-class AGG2Renderer
-{
+class AGG2Renderer {
 public:
   std::vector<band_type> buffer{};
   rendering_buffer m_rendering_buffer;
@@ -120,74 +126,70 @@ public:
   renderer_scanline_aliased m_renderer_scanline_aliased;
   rasterizer_scanline m_rasterizer_aa;
   rasterizer_scanline m_rasterizer_aa_gamma;
-  mapserver::scanline_p8 sl_poly; /*packed scanlines, works faster when the area is larger
-    than the perimeter, in number of pixels*/
-  mapserver::scanline_u8 sl_line; /*unpacked scanlines, works faster if the area is roughly
-    equal to the perimeter, in number of pixels*/
+  mapserver::scanline_p8 sl_poly; /*packed scanlines, works faster when the area
+    is larger than the perimeter, in number of pixels*/
+  mapserver::scanline_u8 sl_line; /*unpacked scanlines, works faster if the area
+    is roughly equal to the perimeter, in number of pixels*/
   bool use_alpha = false;
   std::unique_ptr<mapserver::conv_stroke<line_adaptor>> stroke{};
   std::unique_ptr<mapserver::conv_dash<line_adaptor>> dash{};
-  std::unique_ptr<mapserver::conv_stroke<mapserver::conv_dash<line_adaptor> >> stroke_dash{};
+  std::unique_ptr<mapserver::conv_stroke<mapserver::conv_dash<line_adaptor>>>
+      stroke_dash{};
   double default_gamma = 0.0;
   mapserver::gamma_linear gamma_function;
 };
 
-#define AGG_RENDERER(image) ((AGG2Renderer*) (image)->img.plugin)
+#define AGG_RENDERER(image) ((AGG2Renderer *)(image)->img.plugin)
 
-template<class VertexSource>
-static void applyCJC(VertexSource &stroke, int caps, int joins)
-{
+template <class VertexSource>
+static void applyCJC(VertexSource &stroke, int caps, int joins) {
   switch (joins) {
-    case MS_CJC_ROUND:
-      stroke.line_join(mapserver::round_join);
-      break;
-    case MS_CJC_MITER:
-      stroke.line_join(mapserver::miter_join);
-      break;
-    case MS_CJC_BEVEL:
-    case MS_CJC_NONE:
-      stroke.line_join(mapserver::bevel_join);
-      break;
+  case MS_CJC_ROUND:
+    stroke.line_join(mapserver::round_join);
+    break;
+  case MS_CJC_MITER:
+    stroke.line_join(mapserver::miter_join);
+    break;
+  case MS_CJC_BEVEL:
+  case MS_CJC_NONE:
+    stroke.line_join(mapserver::bevel_join);
+    break;
   }
   switch (caps) {
-    case MS_CJC_BUTT:
-    case MS_CJC_NONE:
-      stroke.line_cap(mapserver::butt_cap);
-      break;
-    case MS_CJC_ROUND:
-      stroke.line_cap(mapserver::round_cap);
-      break;
-    case MS_CJC_SQUARE:
-      stroke.line_cap(mapserver::square_cap);
-      break;
+  case MS_CJC_BUTT:
+  case MS_CJC_NONE:
+    stroke.line_cap(mapserver::butt_cap);
+    break;
+  case MS_CJC_ROUND:
+    stroke.line_cap(mapserver::round_cap);
+    break;
+  case MS_CJC_SQUARE:
+    stroke.line_cap(mapserver::square_cap);
+    break;
   }
 }
 
-int agg2RenderLine(imageObj *img, shapeObj *p, strokeStyleObj *style)
-{
+int agg2RenderLine(imageObj *img, shapeObj *p, strokeStyleObj *style) {
 
   AGG2Renderer *r = AGG_RENDERER(img);
   line_adaptor lines = line_adaptor(p);
 
   r->m_rasterizer_aa.reset();
   r->m_rasterizer_aa.filling_rule(mapserver::fill_non_zero);
-  if (style->antialiased== MS_FALSE)
-  {
+  if (style->antialiased == MS_FALSE) {
     r->m_renderer_scanline_aliased.color(aggColor(style->color));
-  }
-  else
-  {
+  } else {
     r->m_renderer_scanline.color(aggColor(style->color));
   }
 
   if (style->patternlength <= 0) {
-    if(!r->stroke) {
+    if (!r->stroke) {
       r->stroke.reset(new mapserver::conv_stroke<line_adaptor>(lines));
     } else {
       r->stroke->attach(lines);
     }
     r->stroke->width(style->width);
-    if(style->width>1) {
+    if (style->width > 1) {
       applyCJC(*r->stroke, style->linecap, style->linejoin);
     } else {
       r->stroke->inner_join(mapserver::inner_bevel);
@@ -195,34 +197,36 @@ int agg2RenderLine(imageObj *img, shapeO
     }
     r->m_rasterizer_aa.add_path(*r->stroke);
   } else {
-    if(!r->dash) {
+    if (!r->dash) {
       r->dash.reset(new mapserver::conv_dash<line_adaptor>(lines));
     } else {
       r->dash->remove_all_dashes();
       r->dash->dash_start(0.0);
       r->dash->attach(lines);
     }
-    if(!r->stroke_dash) {
-      r->stroke_dash.reset(new mapserver::conv_stroke<mapserver::conv_dash<line_adaptor> > (*r->dash));
+    if (!r->stroke_dash) {
+      r->stroke_dash.reset(
+          new mapserver::conv_stroke<mapserver::conv_dash<line_adaptor>>(
+              *r->dash));
     } else {
       r->stroke_dash->attach(*r->dash);
     }
     int patt_length = 0;
     for (int i = 0; i < style->patternlength; i += 2) {
       if (i < style->patternlength - 1) {
-        r->dash->add_dash(MS_MAX(1,MS_NINT(style->pattern[i])),
-                      MS_MAX(1,MS_NINT(style->pattern[i + 1])));
-        if(style->patternoffset) {
-          patt_length += MS_MAX(1,MS_NINT(style->pattern[i])) +
-                         MS_MAX(1,MS_NINT(style->pattern[i + 1]));
+        r->dash->add_dash(MS_MAX(1, MS_NINT(style->pattern[i])),
+                          MS_MAX(1, MS_NINT(style->pattern[i + 1])));
+        if (style->patternoffset) {
+          patt_length += MS_MAX(1, MS_NINT(style->pattern[i])) +
+                         MS_MAX(1, MS_NINT(style->pattern[i + 1]));
         }
       }
     }
-    if(style->patternoffset > 0) {
+    if (style->patternoffset > 0) {
       r->dash->dash_start(patt_length - style->patternoffset);
     }
     r->stroke_dash->width(style->width);
-    if(style->width>1) {
+    if (style->width > 1) {
       applyCJC(*r->stroke_dash, style->linecap, style->linejoin);
     } else {
       r->stroke_dash->inner_join(mapserver::inner_bevel);
@@ -231,19 +235,25 @@ int agg2RenderLine(imageObj *img, shapeO
     r->m_rasterizer_aa.add_path(*r->stroke_dash);
   }
   if (style->antialiased == MS_FALSE)
-    mapserver::render_scanlines(r->m_rasterizer_aa, r->sl_line, r->m_renderer_scanline_aliased);
-  else 
-    mapserver::render_scanlines(r->m_rasterizer_aa, r->sl_line, r->m_renderer_scanline);
+    mapserver::render_scanlines(r->m_rasterizer_aa, r->sl_line,
+                                r->m_renderer_scanline_aliased);
+  else
+    mapserver::render_scanlines(r->m_rasterizer_aa, r->sl_line,
+                                r->m_renderer_scanline);
   return MS_SUCCESS;
 }
 
-int agg2RenderLineTiled(imageObj *img, shapeObj *p, imageObj * tile)
-{
+int agg2RenderLineTiled(imageObj *img, shapeObj *p, imageObj *tile) {
 
   mapserver::pattern_filter_bilinear_rgba8 fltr;
-  typedef mapserver::line_image_pattern<mapserver::pattern_filter_bilinear_rgba8> pattern_type;
-  typedef mapserver::renderer_outline_image<renderer_base, pattern_type> renderer_img_type;
-  typedef mapserver::rasterizer_outline_aa<renderer_img_type, mapserver::line_coord_sat> rasterizer_img_type;
+  typedef mapserver::line_image_pattern<
+      mapserver::pattern_filter_bilinear_rgba8>
+      pattern_type;
+  typedef mapserver::renderer_outline_image<renderer_base, pattern_type>
+      renderer_img_type;
+  typedef mapserver::rasterizer_outline_aa<renderer_img_type,
+                                           mapserver::line_coord_sat>
+      rasterizer_img_type;
   pattern_type patt(fltr);
 
   AGG2Renderer *r = AGG_RENDERER(img);
@@ -258,264 +268,270 @@ int agg2RenderLineTiled(imageObj *img, s
   return MS_SUCCESS;
 }
 
-int agg2RenderPolygon(imageObj *img, shapeObj *p, colorObj * color)
-{
+int agg2RenderPolygon(imageObj *img, shapeObj *p, colorObj *color) {
   AGG2Renderer *r = AGG_RENDERER(img);
   polygon_adaptor polygons(p);
   r->m_rasterizer_aa_gamma.reset();
   r->m_rasterizer_aa_gamma.filling_rule(mapserver::fill_even_odd);
   r->m_rasterizer_aa_gamma.add_path(polygons);
   r->m_renderer_scanline.color(aggColor(color));
-  mapserver::render_scanlines(r->m_rasterizer_aa_gamma, r->sl_poly, r->m_renderer_scanline);
+  mapserver::render_scanlines(r->m_rasterizer_aa_gamma, r->sl_poly,
+                              r->m_renderer_scanline);
   return MS_SUCCESS;
 }
 
-static inline double int26p6_to_dbl(int p)
-    {
-        return double(p) / 64.0;
-    }
-
-template<class PathStorage>
-    bool decompose_ft_outline(const FT_Outline& outline,
-                              bool flip_y,
-                              const mapserver::trans_affine& mtx,
-                              PathStorage& path)
-    {
-        double x1, y1, x2, y2, x3, y3;
-
-        FT_Vector*  point;
-        FT_Vector*  limit;
-        char*       tags;
-
-        int   n;         // index of contour in outline
-        int   first;     // index of first point in contour
-        char  tag;       // current point's state
-
-        first = 0;
-
-        for(n = 0; n < outline.n_contours; n++)
-        {
-            int  last;  // index of last point in contour
-
-            last  = outline.contours[n];
-            limit = outline.points + last;
-
-            FT_Vector v_start = outline.points[first];
-
-            FT_Vector v_control = v_start;
-
-            point = outline.points + first;
-            tags  = outline.tags  + first;
-            tag   = FT_CURVE_TAG(tags[0]);
-
-            // A contour cannot start with a cubic control point!
-            if(tag == FT_CURVE_TAG_CUBIC) return false;
-
-            // check first point to determine origin
-            if( tag == FT_CURVE_TAG_CONIC)
-            {
-                const FT_Vector v_last  = outline.points[last];
-
-                // first point is conic control.  Yes, this happens.
-                if(FT_CURVE_TAG(outline.tags[last]) == FT_CURVE_TAG_ON)
-                {
-                    // start at last point if it is on the curve
-                    v_start = v_last;
-                    limit--;
-                }
-                else
-                {
-                    // if both first and last points are conic,
-                    // start at their middle and record its position
-                    // for closure
-                    v_start.x = (v_start.x + v_last.x) / 2;
-                    v_start.y = (v_start.y + v_last.y) / 2;
-                }
-                point--;
-                tags--;
-            }
+static inline double int26p6_to_dbl(int p) { return double(p) / 64.0; }
 
-            x1 = int26p6_to_dbl(v_start.x);
-            y1 = int26p6_to_dbl(v_start.y);
-            if(flip_y) y1 = -y1;
-            mtx.transform(&x1, &y1);
-            path.move_to(x1,y1);
+template <class PathStorage>
+bool decompose_ft_outline(const FT_Outline &outline, bool flip_y,
+                          const mapserver::trans_affine &mtx,
+                          PathStorage &path) {
+  double x1, y1, x2, y2, x3, y3;
+
+  FT_Vector *point;
+  FT_Vector *limit;
+  char *tags;
+
+  int n;     // index of contour in outline
+  int first; // index of first point in contour
+  char tag;  // current point's state
+
+  first = 0;
 
-            while(point < limit)
-            {
-                point++;
-                tags++;
-
-                tag = FT_CURVE_TAG(tags[0]);
-                switch(tag)
-                {
-                    case FT_CURVE_TAG_ON:  // emit a single line_to
-                    {
-                        x1 = int26p6_to_dbl(point->x);
-                        y1 = int26p6_to_dbl(point->y);
-                        if(flip_y) y1 = -y1;
-                        mtx.transform(&x1, &y1);
-                        path.line_to(x1,y1);
-                        //path.line_to(conv(point->x), flip_y ? -conv(point->y) : conv(point->y));
-                        continue;
-                    }
-
-                    case FT_CURVE_TAG_CONIC:  // consume conic arcs
-                    {
-                        v_control.x = point->x;
-                        v_control.y = point->y;
-
-                    Do_Conic:
-                        if(point < limit)
-                        {
-                            FT_Vector vec;
-                            FT_Vector v_middle;
-
-                            point++;
-                            tags++;
-                            tag = FT_CURVE_TAG(tags[0]);
-
-                            vec.x = point->x;
-                            vec.y = point->y;
-
-                            if(tag == FT_CURVE_TAG_ON)
-                            {
-                                x1 = int26p6_to_dbl(v_control.x);
-                                y1 = int26p6_to_dbl(v_control.y);
-                                x2 = int26p6_to_dbl(vec.x);
-                                y2 = int26p6_to_dbl(vec.y);
-                                if(flip_y) { y1 = -y1; y2 = -y2; }
-                                mtx.transform(&x1, &y1);
-                                mtx.transform(&x2, &y2);
-                                path.curve3(x1,y1,x2,y2);
-                                continue;
-                            }
-
-                            if(tag != FT_CURVE_TAG_CONIC) return false;
-
-                            v_middle.x = (v_control.x + vec.x) / 2;
-                            v_middle.y = (v_control.y + vec.y) / 2;
-
-                            x1 = int26p6_to_dbl(v_control.x);
-                            y1 = int26p6_to_dbl(v_control.y);
-                            x2 = int26p6_to_dbl(v_middle.x);
-                            y2 = int26p6_to_dbl(v_middle.y);
-                            if(flip_y) { y1 = -y1; y2 = -y2; }
-                            mtx.transform(&x1, &y1);
-                            mtx.transform(&x2, &y2);
-                            path.curve3(x1,y1,x2,y2);
-
-                            //path.curve3(conv(v_control.x),
-                            //            flip_y ? -conv(v_control.y) : conv(v_control.y),
-                            //            conv(v_middle.x),
-                            //            flip_y ? -conv(v_middle.y) : conv(v_middle.y));
-
-                            v_control = vec;
-                            goto Do_Conic;
-                        }
-
-                        x1 = int26p6_to_dbl(v_control.x);
-                        y1 = int26p6_to_dbl(v_control.y);
-                        x2 = int26p6_to_dbl(v_start.x);
-                        y2 = int26p6_to_dbl(v_start.y);
-                        if(flip_y) { y1 = -y1; y2 = -y2; }
-                        mtx.transform(&x1, &y1);
-                        mtx.transform(&x2, &y2);
-                        path.curve3(x1,y1,x2,y2);
-
-                        //path.curve3(conv(v_control.x),
-                        //            flip_y ? -conv(v_control.y) : conv(v_control.y),
-                        //            conv(v_start.x),
-                        //            flip_y ? -conv(v_start.y) : conv(v_start.y));
-                        goto Close;
-                    }
-
-                    default:  // FT_CURVE_TAG_CUBIC
-                    {
-                        FT_Vector vec1, vec2;
-
-                        if(point + 1 > limit || FT_CURVE_TAG(tags[1]) != FT_CURVE_TAG_CUBIC)
-                        {
-                            return false;
-                        }
-
-                        vec1.x = point[0].x;
-                        vec1.y = point[0].y;
-                        vec2.x = point[1].x;
-                        vec2.y = point[1].y;
-
-                        point += 2;
-                        tags  += 2;
-
-                        if(point <= limit)
-                        {
-                            FT_Vector vec;
-
-                            vec.x = point->x;
-                            vec.y = point->y;
-
-                            x1 = int26p6_to_dbl(vec1.x);
-                            y1 = int26p6_to_dbl(vec1.y);
-                            x2 = int26p6_to_dbl(vec2.x);
-                            y2 = int26p6_to_dbl(vec2.y);
-                            x3 = int26p6_to_dbl(vec.x);
-                            y3 = int26p6_to_dbl(vec.y);
-                            if(flip_y) { y1 = -y1; y2 = -y2; y3 = -y3; }
-                            mtx.transform(&x1, &y1);
-                            mtx.transform(&x2, &y2);
-                            mtx.transform(&x3, &y3);
-                            path.curve4(x1,y1,x2,y2,x3,y3);
-
-                            //path.curve4(conv(vec1.x),
-                            //            flip_y ? -conv(vec1.y) : conv(vec1.y),
-                            //            conv(vec2.x),
-                            //            flip_y ? -conv(vec2.y) : conv(vec2.y),
-                            //            conv(vec.x),
-                            //            flip_y ? -conv(vec.y) : conv(vec.y));
-                            continue;
-                        }
-
-                        x1 = int26p6_to_dbl(vec1.x);
-                        y1 = int26p6_to_dbl(vec1.y);
-                        x2 = int26p6_to_dbl(vec2.x);
-                        y2 = int26p6_to_dbl(vec2.y);
-                        x3 = int26p6_to_dbl(v_start.x);
-                        y3 = int26p6_to_dbl(v_start.y);
-                        if(flip_y) { y1 = -y1; y2 = -y2; y3 = -y3; }
-                        mtx.transform(&x1, &y1);
-                        mtx.transform(&x2, &y2);
-                        mtx.transform(&x3, &y3);
-                        path.curve4(x1,y1,x2,y2,x3,y3);
-
-                        //path.curve4(conv(vec1.x),
-                        //            flip_y ? -conv(vec1.y) : conv(vec1.y),
-                        //            conv(vec2.x),
-                        //            flip_y ? -conv(vec2.y) : conv(vec2.y),
-                        //            conv(v_start.x),
-                        //            flip_y ? -conv(v_start.y) : conv(v_start.y));
-                        goto Close;
-                    }
-                }
+  for (n = 0; n < outline.n_contours; n++) {
+    int last; // index of last point in contour
+
+    last = outline.contours[n];
+    limit = outline.points + last;
+
+    FT_Vector v_start = outline.points[first];
+
+    FT_Vector v_control = v_start;
+
+    point = outline.points + first;
+    tags = outline.tags + first;
+    tag = FT_CURVE_TAG(tags[0]);
+
+    // A contour cannot start with a cubic control point!
+    if (tag == FT_CURVE_TAG_CUBIC)
+      return false;
+
+    // check first point to determine origin
+    if (tag == FT_CURVE_TAG_CONIC) {
+      const FT_Vector v_last = outline.points[last];
+
+      // first point is conic control.  Yes, this happens.
+      if (FT_CURVE_TAG(outline.tags[last]) == FT_CURVE_TAG_ON) {
+        // start at last point if it is on the curve
+        v_start = v_last;
+        limit--;
+      } else {
+        // if both first and last points are conic,
+        // start at their middle and record its position
+        // for closure
+        v_start.x = (v_start.x + v_last.x) / 2;
+        v_start.y = (v_start.y + v_last.y) / 2;
+      }
+      point--;
+      tags--;
+    }
+
+    x1 = int26p6_to_dbl(v_start.x);
+    y1 = int26p6_to_dbl(v_start.y);
+    if (flip_y)
+      y1 = -y1;
+    mtx.transform(&x1, &y1);
+    path.move_to(x1, y1);
+
+    while (point < limit) {
+      point++;
+      tags++;
+
+      tag = FT_CURVE_TAG(tags[0]);
+      switch (tag) {
+      case FT_CURVE_TAG_ON: // emit a single line_to
+      {
+        x1 = int26p6_to_dbl(point->x);
+        y1 = int26p6_to_dbl(point->y);
+        if (flip_y)
+          y1 = -y1;
+        mtx.transform(&x1, &y1);
+        path.line_to(x1, y1);
+        // path.line_to(conv(point->x), flip_y ? -conv(point->y) :
+        // conv(point->y));
+        continue;
+      }
+
+      case FT_CURVE_TAG_CONIC: // consume conic arcs
+      {
+        v_control.x = point->x;
+        v_control.y = point->y;
+
+      Do_Conic:
+        if (point < limit) {
+          FT_Vector vec;
+          FT_Vector v_middle;
+
+          point++;
+          tags++;
+          tag = FT_CURVE_TAG(tags[0]);
+
+          vec.x = point->x;
+          vec.y = point->y;
+
+          if (tag == FT_CURVE_TAG_ON) {
+            x1 = int26p6_to_dbl(v_control.x);
+            y1 = int26p6_to_dbl(v_control.y);
+            x2 = int26p6_to_dbl(vec.x);
+            y2 = int26p6_to_dbl(vec.y);
+            if (flip_y) {
+              y1 = -y1;
+              y2 = -y2;
             }
+            mtx.transform(&x1, &y1);
+            mtx.transform(&x2, &y2);
+            path.curve3(x1, y1, x2, y2);
+            continue;
+          }
+
+          if (tag != FT_CURVE_TAG_CONIC)
+            return false;
+
+          v_middle.x = (v_control.x + vec.x) / 2;
+          v_middle.y = (v_control.y + vec.y) / 2;
+
+          x1 = int26p6_to_dbl(v_control.x);
+          y1 = int26p6_to_dbl(v_control.y);
+          x2 = int26p6_to_dbl(v_middle.x);
+          y2 = int26p6_to_dbl(v_middle.y);
+          if (flip_y) {
+            y1 = -y1;
+            y2 = -y2;
+          }
+          mtx.transform(&x1, &y1);
+          mtx.transform(&x2, &y2);
+          path.curve3(x1, y1, x2, y2);
+
+          // path.curve3(conv(v_control.x),
+          //             flip_y ? -conv(v_control.y) : conv(v_control.y),
+          //             conv(v_middle.x),
+          //             flip_y ? -conv(v_middle.y) : conv(v_middle.y));
+
+          v_control = vec;
+          goto Do_Conic;
+        }
 
-            path.close_polygon();
+        x1 = int26p6_to_dbl(v_control.x);
+        y1 = int26p6_to_dbl(v_control.y);
+        x2 = int26p6_to_dbl(v_start.x);
+        y2 = int26p6_to_dbl(v_start.y);
+        if (flip_y) {
+          y1 = -y1;
+          y2 = -y2;
+        }
+        mtx.transform(&x1, &y1);
+        mtx.transform(&x2, &y2);
+        path.curve3(x1, y1, x2, y2);
+
+        // path.curve3(conv(v_control.x),
+        //             flip_y ? -conv(v_control.y) : conv(v_control.y),
+        //             conv(v_start.x),
+        //             flip_y ? -conv(v_start.y) : conv(v_start.y));
+        goto Close;
+      }
 
-       Close:
-            first = last + 1;
+      default: // FT_CURVE_TAG_CUBIC
+      {
+        FT_Vector vec1, vec2;
+
+        if (point + 1 > limit || FT_CURVE_TAG(tags[1]) != FT_CURVE_TAG_CUBIC) {
+          return false;
+        }
+
+        vec1.x = point[0].x;
+        vec1.y = point[0].y;
+        vec2.x = point[1].x;
+        vec2.y = point[1].y;
+
+        point += 2;
+        tags += 2;
+
+        if (point <= limit) {
+          FT_Vector vec;
+
+          vec.x = point->x;
+          vec.y = point->y;
+
+          x1 = int26p6_to_dbl(vec1.x);
+          y1 = int26p6_to_dbl(vec1.y);
+          x2 = int26p6_to_dbl(vec2.x);
+          y2 = int26p6_to_dbl(vec2.y);
+          x3 = int26p6_to_dbl(vec.x);
+          y3 = int26p6_to_dbl(vec.y);
+          if (flip_y) {
+            y1 = -y1;
+            y2 = -y2;
+            y3 = -y3;
+          }
+          mtx.transform(&x1, &y1);
+          mtx.transform(&x2, &y2);
+          mtx.transform(&x3, &y3);
+          path.curve4(x1, y1, x2, y2, x3, y3);
+
+          // path.curve4(conv(vec1.x),
+          //             flip_y ? -conv(vec1.y) : conv(vec1.y),
+          //             conv(vec2.x),
+          //             flip_y ? -conv(vec2.y) : conv(vec2.y),
+          //             conv(vec.x),
+          //             flip_y ? -conv(vec.y) : conv(vec.y));
+          continue;
         }
 
-        return true;
+        x1 = int26p6_to_dbl(vec1.x);
+        y1 = int26p6_to_dbl(vec1.y);
+        x2 = int26p6_to_dbl(vec2.x);
+        y2 = int26p6_to_dbl(vec2.y);
+        x3 = int26p6_to_dbl(v_start.x);
+        y3 = int26p6_to_dbl(v_start.y);
+        if (flip_y) {
+          y1 = -y1;
+          y2 = -y2;
+          y3 = -y3;
+        }
+        mtx.transform(&x1, &y1);
+        mtx.transform(&x2, &y2);
+        mtx.transform(&x3, &y3);
+        path.curve4(x1, y1, x2, y2, x3, y3);
+
+        // path.curve4(conv(vec1.x),
+        //             flip_y ? -conv(vec1.y) : conv(vec1.y),
+        //             conv(vec2.x),
+        //             flip_y ? -conv(vec2.y) : conv(vec2.y),
+        //             conv(v_start.x),
+        //             flip_y ? -conv(v_start.y) : conv(v_start.y));
+        goto Close;
+      }
+      }
     }
 
-int agg2RenderPolygonTiled(imageObj *img, shapeObj *p, imageObj * tile)
-{
+    path.close_polygon();
+
+  Close:
+    first = last + 1;
+  }
+
+  return true;
+}
+
+int agg2RenderPolygonTiled(imageObj *img, shapeObj *p, imageObj *tile) {
   assert(img->format->renderer == tile->format->renderer);
 
   AGG2Renderer *r = AGG_RENDERER(img);
   AGG2Renderer *tileRenderer = AGG_RENDERER(tile);
   polygon_adaptor polygons(p);
   typedef mapserver::wrap_mode_repeat wrap_type;
-  typedef mapserver::image_accessor_wrap<pixel_format,wrap_type,wrap_type> img_source_type;
+  typedef mapserver::image_accessor_wrap<pixel_format, wrap_type, wrap_type>
+      img_source_type;
   typedef mapserver::span_pattern_rgba<img_source_type> span_gen_type;
   mapserver::span_allocator<mapserver::rgba8> sa;
   r->m_rasterizer_aa.reset();
@@ -523,79 +539,82 @@ int agg2RenderPolygonTiled(imageObj *img
   img_source_type img_src(tileRenderer->m_pixel_format);
   span_gen_type sg(img_src, 0, 0);
   r->m_rasterizer_aa.add_path(polygons);
-  mapserver::render_scanlines_aa(r->m_rasterizer_aa, r->sl_poly, r->m_renderer_base, sa , sg);
+  mapserver::render_scanlines_aa(r->m_rasterizer_aa, r->sl_poly,
+                                 r->m_renderer_base, sa, sg);
   return MS_SUCCESS;
 }
 
-int agg2RenderGlyphsPath(imageObj *img, const textSymbolObj *ts, colorObj *c, colorObj *oc, int ow, int /*isMarker*/) {
-    
+int agg2RenderGlyphsPath(imageObj *img, const textSymbolObj *ts, colorObj *c,
+                         colorObj *oc, int ow, int /*isMarker*/) {
+
   const textPathObj *tp = ts->textpath;
   mapserver::path_storage glyphs;
   mapserver::trans_affine trans;
   AGG2Renderer *r = AGG_RENDERER(img);
   r->m_rasterizer_aa.filling_rule(mapserver::fill_non_zero);
-  for(int i=0; i<tp->numglyphs; i++) {
-    glyphObj *gl  = tp->glyphs + i;
+  for (int i = 0; i < tp->numglyphs; i++) {
+    glyphObj *gl = tp->glyphs + i;
     trans.reset();
     trans.rotate(-gl->rot);
     trans.translate(gl->pnt.x, gl->pnt.y);
-    outline_element *ol = msGetGlyphOutline(gl->face,gl->glyph);
-    if(!ol) {
+    outline_element *ol = msGetGlyphOutline(gl->face, gl->glyph);
+    if (!ol) {
       return MS_FAILURE;
     }
-    decompose_ft_outline(ol->outline,true,trans,glyphs);
+    decompose_ft_outline(ol->outline, true, trans, glyphs);
   }
   mapserver::conv_curve<mapserver::path_storage> m_curves(glyphs);
   if (oc) {
     r->m_rasterizer_aa.reset();
     r->m_rasterizer_aa.filling_rule(mapserver::fill_non_zero);
-    mapserver::conv_contour<mapserver::conv_curve<mapserver::path_storage> > cc(m_curves);
+    mapserver::conv_contour<mapserver::conv_curve<mapserver::path_storage>> cc(
+        m_curves);
     cc.width(ow + 1);
     r->m_rasterizer_aa.add_path(cc);
     r->m_renderer_scanline.color(aggColor(oc));
-    mapserver::render_scanlines(r->m_rasterizer_aa, r->sl_line, r->m_renderer_scanline);
+    mapserver::render_scanlines(r->m_rasterizer_aa, r->sl_line,
+                                r->m_renderer_scanline);
   }
-  if(c) {
+  if (c) {
     r->m_rasterizer_aa.reset();
     r->m_rasterizer_aa.filling_rule(mapserver::fill_non_zero);
     r->m_rasterizer_aa.add_path(m_curves);
     r->m_renderer_scanline.color(aggColor(c));
-    mapserver::render_scanlines(r->m_rasterizer_aa, r->sl_line, r->m_renderer_scanline);
+    mapserver::render_scanlines(r->m_rasterizer_aa, r->sl_line,
+                                r->m_renderer_scanline);
   }
   return MS_SUCCESS;
 }
 
-mapserver::path_storage imageVectorSymbol(symbolObj *symbol)
-{
+mapserver::path_storage imageVectorSymbol(symbolObj *symbol) {
   mapserver::path_storage path;
-  int is_new=1;
+  int is_new = 1;
 
-  for(int i=0; i < symbol->numpoints; i++) {
-    if((symbol->points[i].x == -99) && (symbol->points[i].y == -99))
-      is_new=1;
+  for (int i = 0; i < symbol->numpoints; i++) {
+    if ((symbol->points[i].x == -99) && (symbol->points[i].y == -99))
+      is_new = 1;
 
     else {
-      if(is_new) {
-        path.move_to(symbol->points[i].x,symbol->points[i].y);
-        is_new=0;
+      if (is_new) {
+        path.move_to(symbol->points[i].x, symbol->points[i].y);
+        is_new = 0;
       } else {
-        path.line_to(symbol->points[i].x,symbol->points[i].y);
+        path.line_to(symbol->points[i].x, symbol->points[i].y);
       }
     }
   }
   return path;
 }
 
-int agg2RenderVectorSymbol(imageObj *img, double x, double y,
-                           symbolObj *symbol, symbolStyleObj * style)
-{
+int agg2RenderVectorSymbol(imageObj *img, double x, double y, symbolObj *symbol,
+                           symbolStyleObj *style) {
   AGG2Renderer *r = AGG_RENDERER(img);
   double ox = symbol->sizex * 0.5;
   double oy = symbol->sizey * 0.5;
 
   mapserver::path_storage path = imageVectorSymbol(symbol);
   mapserver::trans_affine mtx;
-  mtx *= mapserver::trans_affine_translation(-ox,-oy);
+  mtx *= mapserver::trans_affine_translation(-ox, -oy);
   mtx *= mapserver::trans_affine_scaling(style->scale);
   mtx *= mapserver::trans_affine_rotation(-style->rotation);
   mtx *= mapserver::trans_affine_translation(x, y);
@@ -605,40 +624,43 @@ int agg2RenderVectorSymbol(imageObj *img
     r->m_rasterizer_aa.filling_rule(mapserver::fill_even_odd);
     r->m_rasterizer_aa.add_path(path);
     r->m_renderer_scanline.color(aggColor(style->color));
-    mapserver::render_scanlines(r->m_rasterizer_aa, r->sl_poly, r->m_renderer_scanline);
+    mapserver::render_scanlines(r->m_rasterizer_aa, r->sl_poly,
+                                r->m_renderer_scanline);
   }
-  if(style->outlinecolor) {
+  if (style->outlinecolor) {
     r->m_rasterizer_aa.reset();
     r->m_rasterizer_aa.filling_rule(mapserver::fill_non_zero);
     r->m_renderer_scanline.color(aggColor(style->outlinecolor));
     mapserver::conv_stroke<mapserver::path_storage> stroke(path);
     stroke.width(style->outlinewidth);
     r->m_rasterizer_aa.add_path(stroke);
-    mapserver::render_scanlines(r->m_rasterizer_aa, r->sl_poly, r->m_renderer_scanline);
+    mapserver::render_scanlines(r->m_rasterizer_aa, r->sl_poly,
+                                r->m_renderer_scanline);
   }
   return MS_SUCCESS;
 }
 
-int agg2RenderPixmapSymbol(imageObj *img, double x, double y, symbolObj *symbol, symbolStyleObj * style)
-{
+int agg2RenderPixmapSymbol(imageObj *img, double x, double y, symbolObj *symbol,
+                           symbolStyleObj *style) {
   AGG2Renderer *r = AGG_RENDERER(img);
   rasterBufferObj *pixmap = symbol->pixmap_buffer;
   assert(pixmap->type == MS_BUFFER_BYTE_RGBA);
-  rendering_buffer b(pixmap->data.rgba.pixels,pixmap->width,pixmap->height,pixmap->data.rgba.row_step);
+  rendering_buffer b(pixmap->data.rgba.pixels, pixmap->width, pixmap->height,
+                     pixmap->data.rgba.row_step);
   pixel_format pf(b);
 
   r->m_rasterizer_aa.reset();
   r->m_rasterizer_aa.filling_rule(mapserver::fill_non_zero);
-  if ( (style->rotation != 0 && style->rotation != MS_PI*2.)|| style->scale != 1) {
+  if ((style->rotation != 0 && style->rotation != MS_PI * 2.) ||
+      style->scale != 1) {
     mapserver::trans_affine image_mtx;
-    image_mtx *= mapserver::trans_affine_translation(-(pf.width()/2.),-(pf.height()/2.));
+    image_mtx *= mapserver::trans_affine_translation(-(pf.width() / 2.),
+                                                     -(pf.height() / 2.));
     /*agg angles are antitrigonometric*/
     image_mtx *= mapserver::trans_affine_rotation(-style->rotation);
     image_mtx *= mapserver::trans_affine_scaling(style->scale);
 
-
-
-    image_mtx *= mapserver::trans_affine_translation(x,y);
+    image_mtx *= mapserver::trans_affine_translation(x, y);
     image_mtx.invert();
     typedef mapserver::span_interpolator_linear<> interpolator_type;
     interpolator_type interpolator(image_mtx);
@@ -646,63 +668,72 @@ int agg2RenderPixmapSymbol(imageObj *img
 
     // "hardcoded" bilinear filter
     //------------------------------------------
-    typedef mapserver::span_image_filter_rgba_bilinear_clip<pixel_format, interpolator_type> span_gen_type;
-    span_gen_type sg(pf, mapserver::rgba(0,0,0,0), interpolator);
+    typedef mapserver::span_image_filter_rgba_bilinear_clip<pixel_format,
+                                                            interpolator_type>
+        span_gen_type;
+    span_gen_type sg(pf, mapserver::rgba(0, 0, 0, 0), interpolator);
     mapserver::path_storage pixmap_bbox;
-    int ims_2 = MS_NINT(MS_MAX(pixmap->width,pixmap->height)*style->scale*1.415)/2+1;
-
-    pixmap_bbox.move_to(x-ims_2,y-ims_2);
-    pixmap_bbox.line_to(x+ims_2,y-ims_2);
-    pixmap_bbox.line_to(x+ims_2,y+ims_2);
-    pixmap_bbox.line_to(x-ims_2,y+ims_2);
+    int ims_2 =
+        MS_NINT(MS_MAX(pixmap->width, pixmap->height) * style->scale * 1.415) /
+            2 +
+        1;
+
+    pixmap_bbox.move_to(x - ims_2, y - ims_2);
+    pixmap_bbox.line_to(x + ims_2, y - ims_2);
+    pixmap_bbox.line_to(x + ims_2, y + ims_2);
+    pixmap_bbox.line_to(x - ims_2, y + ims_2);
 
     r->m_rasterizer_aa.add_path(pixmap_bbox);
-    mapserver::render_scanlines_aa(r->m_rasterizer_aa, r->sl_poly, r->m_renderer_base, sa, sg);
+    mapserver::render_scanlines_aa(r->m_rasterizer_aa, r->sl_poly,
+                                   r->m_renderer_base, sa, sg);
   } else {
-    //just copy the image at the correct location (we place the pixmap on
-    //the nearest integer pixel to avoid blurring)
-    r->m_renderer_base.blend_from(pf,0,MS_NINT(x-pixmap->width/2.),MS_NINT(y-pixmap->height/2.));
+    // just copy the image at the correct location (we place the pixmap on
+    // the nearest integer pixel to avoid blurring)
+    r->m_renderer_base.blend_from(pf, 0, MS_NINT(x - pixmap->width / 2.),
+                                  MS_NINT(y - pixmap->height / 2.));
   }
   return MS_SUCCESS;
 }
 
 int agg2RenderEllipseSymbol(imageObj *image, double x, double y,
-                            symbolObj *symbol, symbolStyleObj * style)
-{
+                            symbolObj *symbol, symbolStyleObj *style) {
   AGG2Renderer *r = AGG_RENDERER(image);
   mapserver::path_storage path;
-  mapserver::ellipse ellipse(x,y,symbol->sizex*style->scale/2,symbol->sizey*style->scale/2);
+  mapserver::ellipse ellipse(x, y, symbol->sizex * style->scale / 2,
+                             symbol->sizey * style->scale / 2);
   path.concat_path(ellipse);
-  if( style->rotation != 0) {
+  if (style->rotation != 0) {
     mapserver::trans_affine mtx;
-    mtx *= mapserver::trans_affine_translation(-x,-y);
+    mtx *= mapserver::trans_affine_translation(-x, -y);
     /*agg angles are antitrigonometric*/
     mtx *= mapserver::trans_affine_rotation(-style->rotation);
-    mtx *= mapserver::trans_affine_translation(x,y);
+    mtx *= mapserver::trans_affine_translation(x, y);
     path.transform(mtx);
   }
 
-  if(style->color) {
+  if (style->color) {
     r->m_rasterizer_aa.reset();
     r->m_rasterizer_aa.filling_rule(mapserver::fill_even_odd);
     r->m_rasterizer_aa.add_path(path);
     r->m_renderer_scanline.color(aggColor(style->color));
-    mapserver::render_scanlines(r->m_rasterizer_aa, r->sl_line, r->m_renderer_scanline);
+    mapserver::render_scanlines(r->m_rasterizer_aa, r->sl_line,
+                                r->m_renderer_scanline);
   }
-  if(style->outlinewidth) {
+  if (style->outlinewidth) {
     r->m_rasterizer_aa.reset();
     r->m_rasterizer_aa.filling_rule(mapserver::fill_non_zero);
     mapserver::conv_stroke<mapserver::path_storage> stroke(path);
     stroke.width(style->outlinewidth);
     r->m_rasterizer_aa.add_path(stroke);
     r->m_renderer_scanline.color(aggColor(style->outlinecolor));
-    mapserver::render_scanlines(r->m_rasterizer_aa, r->sl_poly, r->m_renderer_scanline);
+    mapserver::render_scanlines(r->m_rasterizer_aa, r->sl_poly,
+                                r->m_renderer_scanline);
   }
   return MS_SUCCESS;
 }
 
-int agg2RenderTile(imageObj * /*img*/, imageObj * /*tile*/, double /*x*/, double /*y*/)
-{
+int agg2RenderTile(imageObj * /*img*/, imageObj * /*tile*/, double /*x*/,
+                   double /*y*/) {
   /*
   AGG2Renderer *imgRenderer = agg2GetRenderer(img);
   AGG2Renderer *tileRenderer = agg2GetRenderer(tile);
@@ -710,30 +741,27 @@ int agg2RenderTile(imageObj * /*img*/, i
   return MS_FAILURE;
 }
 
-int aggInitializeRasterBuffer(rasterBufferObj *rb, int width, int height, int mode)
-{
+int aggInitializeRasterBuffer(rasterBufferObj *rb, int width, int height,
+                              int mode) {
   rb->type = MS_BUFFER_BYTE_RGBA;
   rb->data.rgba.pixel_step = 4;
   rb->data.rgba.row_step = rb->data.rgba.pixel_step * width;
   rb->width = width;
   rb->height = height;
   int nBytes = rb->data.rgba.row_step * height;
-  rb->data.rgba.pixels = (band_type*)msSmallCalloc(nBytes,sizeof(band_type));
+  rb->data.rgba.pixels = (band_type *)msSmallCalloc(nBytes, sizeof(band_type));
   rb->data.rgba.r = &(rb->data.rgba.pixels[band_order::R]);
   rb->data.rgba.g = &(rb->data.rgba.pixels[band_order::G]);
   rb->data.rgba.b = &(rb->data.rgba.pixels[band_order::B]);
-  if(mode == MS_IMAGEMODE_RGBA) {
+  if (mode == MS_IMAGEMODE_RGBA) {
     rb->data.rgba.a = &(rb->data.rgba.pixels[band_order::A]);
   }
   return MS_SUCCESS;
 }
 
-
-
-int aggGetRasterBufferHandle(imageObj *img, rasterBufferObj * rb)
-{
+int aggGetRasterBufferHandle(imageObj *img, rasterBufferObj *rb) {
   AGG2Renderer *r = AGG_RENDERER(img);
-  rb->type =MS_BUFFER_BYTE_RGBA;
+  rb->type = MS_BUFFER_BYTE_RGBA;
   rb->data.rgba.pixels = r->buffer.data();
   rb->data.rgba.row_step = r->m_rendering_buffer.stride();
   rb->data.rgba.pixel_step = 4;
@@ -742,68 +770,72 @@ int aggGetRasterBufferHandle(imageObj *i
   rb->data.rgba.r = &(r->buffer[band_order::R]);
   rb->data.rgba.g = &(r->buffer[band_order::G]);
   rb->data.rgba.b = &(r->buffer[band_order::B]);
-  if(r->use_alpha)
+  if (r->use_alpha)
     rb->data.rgba.a = &(r->buffer[band_order::A]);
   else
     rb->data.rgba.a = NULL;
   return MS_SUCCESS;
 }
 
-int aggGetRasterBufferCopy(imageObj *img, rasterBufferObj *rb)
-{
+int aggGetRasterBufferCopy(imageObj *img, rasterBufferObj *rb) {
   AGG2Renderer *r = AGG_RENDERER(img);
   aggInitializeRasterBuffer(rb, img->width, img->height, MS_IMAGEMODE_RGBA);
-  int nBytes = r->m_rendering_buffer.stride()*r->m_rendering_buffer.height();
-  memcpy(rb->data.rgba.pixels,r->buffer.data(), nBytes);
+  int nBytes = r->m_rendering_buffer.stride() * r->m_rendering_buffer.height();
+  memcpy(rb->data.rgba.pixels, r->buffer.data(), nBytes);
   return MS_SUCCESS;
 }
 
-
-
-int agg2MergeRasterBuffer(imageObj *dest, rasterBufferObj *overlay, double opacity, int srcX, int srcY,
-                          int dstX, int dstY, int width, int height)
-{
+int agg2MergeRasterBuffer(imageObj *dest, rasterBufferObj *overlay,
+                          double opacity, int srcX, int srcY, int dstX,
+                          int dstY, int width, int height) {
   assert(overlay->type == MS_BUFFER_BYTE_RGBA);
-  rendering_buffer b(overlay->data.rgba.pixels, overlay->width, overlay->height, overlay->data.rgba.row_step);
+  rendering_buffer b(overlay->data.rgba.pixels, overlay->width, overlay->height,
+                     overlay->data.rgba.row_step);
   pixel_format pf(b);
   AGG2Renderer *r = AGG_RENDERER(dest);
-  mapserver::rect_base<int> src_rect(srcX,srcY,srcX+width,srcY+height);
-  r->m_renderer_base.blend_from(pf,&src_rect, dstX-srcX, dstY-srcY, unsigned(opacity * 255));
+  mapserver::rect_base<int> src_rect(srcX, srcY, srcX + width, srcY + height);
+  r->m_renderer_base.blend_from(pf, &src_rect, dstX - srcX, dstY - srcY,
+                                unsigned(opacity * 255));
   return MS_SUCCESS;
 }
 
 /* image i/o */
-imageObj *agg2CreateImage(int width, int height, outputFormatObj *format, colorObj * bg)
-{
+imageObj *agg2CreateImage(int width, int height, outputFormatObj *format,
+                          colorObj *bg) {
   imageObj *image = NULL;
-  if (format->imagemode != MS_IMAGEMODE_RGB && format->imagemode != MS_IMAGEMODE_RGBA) {
+  if (format->imagemode != MS_IMAGEMODE_RGB &&
+      format->imagemode != MS_IMAGEMODE_RGBA) {
     msSetError(MS_MISCERR,
-               "AGG2 driver only supports RGB or RGBA pixel models.", "agg2CreateImage()");
+               "AGG2 driver only supports RGB or RGBA pixel models.",
+               "agg2CreateImage()");
     return image;
   }
   if (width > 0 && height > 0) {
-    image = (imageObj *) calloc(1, sizeof (imageObj));
-    MS_CHECK_ALLOC(image, sizeof (imageObj), NULL);
+    image = (imageObj *)calloc(1, sizeof(imageObj));
+    MS_CHECK_ALLOC(image, sizeof(imageObj), NULL);
     AGG2Renderer *r = new AGG2Renderer();
-  
-    /* Compute size on 64bit and check that it is compatible of the platform size_t */
+
+    /* Compute size on 64bit and check that it is compatible of the platform
+     * size_t */
     AGG_INT64U bufSize64 = (AGG_INT64U)width * height * 4 * sizeof(band_type);
     size_t bufSize = (size_t)bufSize64;
-    if( (AGG_INT64U)bufSize != bufSize64 ) {
-      msSetError(MS_MEMERR, "%s: %d: Out of memory allocating " AGG_INT64U_FRMT " bytes.\n", "agg2CreateImage()",
-                 __FILE__, __LINE__, bufSize64);
+    if ((AGG_INT64U)bufSize != bufSize64) {
+      msSetError(MS_MEMERR,
+                 "%s: %d: Out of memory allocating " AGG_INT64U_FRMT
+                 " bytes.\n",
+                 "agg2CreateImage()", __FILE__, __LINE__, bufSize64);
       free(image);
       delete r;
       return NULL;
     }
 
-    try
-    {
+    try {
       r->buffer.resize(bufSize / sizeof(band_type));
-    }
-    catch( const std::bad_alloc& ) {
-      msSetError(MS_MEMERR, "%s: %d: Out of memory allocating " AGG_INT64U_FRMT " bytes.\n", "agg2CreateImage()",
-                 __FILE__, __LINE__, bufSize64);
+    } catch (const std::bad_alloc &) {
+      msSetError(MS_MEMERR,
+                 "%s: %d: Out of memory allocating " AGG_INT64U_FRMT
+                 " bytes.\n",
+                 "agg2CreateImage()", __FILE__, __LINE__, bufSize64);
       free(image);
       delete r;
       return NULL;
@@ -815,23 +847,23 @@ imageObj *agg2CreateImage(int width, int
     r->m_compop_renderer_base.attach(r->m_compop_pixel_format);
     r->m_renderer_scanline.attach(r->m_renderer_base);
     r->m_renderer_scanline_aliased.attach(r->m_renderer_base);
-    r->default_gamma = atof(msGetOutputFormatOption( format, "GAMMA", "0.75" ));
-    if(r->default_gamma <= 0.0 || r->default_gamma >= 1.0) {
+    r->default_gamma = atof(msGetOutputFormatOption(format, "GAMMA", "0.75"));
+    if (r->default_gamma <= 0.0 || r->default_gamma >= 1.0) {
       r->default_gamma = 0.75;
     }
-    r->gamma_function.set(0,r->default_gamma);
+    r->gamma_function.set(0, r->default_gamma);
     r->m_rasterizer_aa_gamma.gamma(r->gamma_function);
-    if( bg && !format->transparent )
+    if (bg && !format->transparent)
       r->m_renderer_base.clear(aggColor(bg));
     else
       r->m_renderer_base.clear(AGG_NO_COLOR);
 
-    if (!bg || format->transparent || format->imagemode == MS_IMAGEMODE_RGBA ) {
+    if (!bg || format->transparent || format->imagemode == MS_IMAGEMODE_RGBA) {
       r->use_alpha = true;
     } else {
       r->use_alpha = false;
     }
-    image->img.plugin = (void*) r;
+    image->img.plugin = (void *)r;
   } else {
     msSetError(MS_RENDERERERR, "Cannot create cairo image of size %dx%d.",
                "msImageCreateCairo()", width, height);
@@ -840,200 +872,204 @@ imageObj *agg2CreateImage(int width, int
   return image;
 }
 
-int agg2SaveImage(imageObj * /*img*/, mapObj* /*map*/, FILE * /*fp*/, outputFormatObj * /*format*/)
-{
-  
+int agg2SaveImage(imageObj * /*img*/, mapObj * /*map*/, FILE * /*fp*/,
+                  outputFormatObj * /*format*/) {
 
   return MS_FAILURE;
 }
 
-int agg2StartNewLayer(imageObj *img, mapObj* /*map*/, layerObj *layer)
-{
+int agg2StartNewLayer(imageObj *img, mapObj * /*map*/, layerObj *layer) {
   AGG2Renderer *r = AGG_RENDERER(img);
-  const char *sgamma = msLayerGetProcessingKey( layer, "GAMMA" );
+  const char *sgamma = msLayerGetProcessingKey(layer, "GAMMA");
   double gamma;
-  if(sgamma) {
+  if (sgamma) {
     gamma = atof(sgamma);
-    if(gamma <= 0 || gamma >= 1) gamma = 0.75;
+    if (gamma <= 0 || gamma >= 1)
+      gamma = 0.75;
   } else {
     gamma = r->default_gamma;
   }
-  if(r->gamma_function.end() != gamma) {
+  if (r->gamma_function.end() != gamma) {
     r->gamma_function.end(gamma);
     r->m_rasterizer_aa_gamma.gamma(r->gamma_function);
   }
   return MS_SUCCESS;
 }
 
-int agg2CloseNewLayer(imageObj * /*img*/, mapObj * /*map*/, layerObj * /*layer*/)
-{
+int agg2CloseNewLayer(imageObj * /*img*/, mapObj * /*map*/,
+                      layerObj * /*layer*/) {
   return MS_SUCCESS;
 }
 
-int agg2FreeImage(imageObj * image)
-{
+int agg2FreeImage(imageObj *image) {
   AGG2Renderer *r = AGG_RENDERER(image);
   delete r;
   image->img.plugin = NULL;
   return MS_SUCCESS;
 }
 
-int agg2FreeSymbol(symbolObj * /*symbol*/)
-{
-  return MS_SUCCESS;
-}
+int agg2FreeSymbol(symbolObj * /*symbol*/) { return MS_SUCCESS; }
 
-int agg2InitCache(void **vcache)
-{
+int agg2InitCache(void **vcache) {
   aggRendererCache *cache = new aggRendererCache();
-  *vcache = (void*)cache;
+  *vcache = (void *)cache;
   return MS_SUCCESS;
 }
 
-int agg2Cleanup(void *vcache)
-{
-  aggRendererCache *cache = (aggRendererCache*)vcache;
+int agg2Cleanup(void *vcache) {
+  aggRendererCache *cache = (aggRendererCache *)vcache;
   delete cache;
   return MS_SUCCESS;
 }
 
-
 // ------------------------------------------------------------------------
 // Function to create a custom hatch symbol based on an arbitrary angle.
 // ------------------------------------------------------------------------
-static mapserver::path_storage createHatch(double ox, double oy,
-    double rx, double ry,
-    int sx, int sy, double angle, double step)
-{
+static mapserver::path_storage createHatch(double ox, double oy, double rx,
+                                           double ry, int sx, int sy,
+                                           double angle, double step) {
   mapserver::path_storage path;
-  //restrict the angle to [0 180[, i.e ]-pi/2,pi/2] in radians
+  // restrict the angle to [0 180[, i.e ]-pi/2,pi/2] in radians
   angle = fmod(angle, 360.0);
-  if(angle < 0) angle += 360;
-  if(angle >= 180) angle -= 180;
-
-  //treat 2 easy cases which would cause divide by 0 in generic case
-  if(angle==0) {
-    double y0 = step-fmod(oy-ry,step);
-    if((oy - ry) < 0) {
+  if (angle < 0)
+    angle += 360;
+  if (angle >= 180)
+    angle -= 180;
+
+  // treat 2 easy cases which would cause divide by 0 in generic case
+  if (angle == 0) {
+    double y0 = step - fmod(oy - ry, step);
+    if ((oy - ry) < 0) {
       y0 -= step;
     }
-    for(double y=y0; y<sy; y+=step) {
-      path.move_to(0,y);
-      path.line_to(sx,y);
+    for (double y = y0; y < sy; y += step) {
+      path.move_to(0, y);
+      path.line_to(sx, y);
     }
     return path;
   }
-  if(angle==90) {
-    double x0 = step-fmod(ox-rx,step);
-    if((ox - rx) < 0) {
+  if (angle == 90) {
+    double x0 = step - fmod(ox - rx, step);
+    if ((ox - rx) < 0) {
       x0 -= step;
     }
-    for(double x=x0; x<sx; x+=step) {
-      path.move_to(x,0);
-      path.line_to(x,sy);
+    for (double x = x0; x < sx; x += step) {
+      path.move_to(x, 0);
+      path.line_to(x, sy);
     }
     return path;
   }
 
-
-  double theta = (90-angle)*MS_DEG_TO_RAD; /* theta in ]-pi/2 , pi/2] */
+  double theta = (90 - angle) * MS_DEG_TO_RAD; /* theta in ]-pi/2 , pi/2] */
   double ct = cos(theta);
   double st = sin(theta);
-  double invct = 1.0/ct;
-  double invst = 1.0/st;
-  double r0; /* distance from first hatch line to the top-left (if angle in  0,pi/2)
-                  or bottom-left (if angle in -pi/2,0) corner of the hatch bbox */
-  double rmax = sqrt((double)(sx*sx+sy*sy)); /* distance to the furthest hatch we will have to create
-TODO: this could be optimized for bounding boxes where width is very different than height for
-certain hatch angles */
-  double rref= rx*ct + ry*st; /* distance to the line passing through the refpoint, origin is
-                                   (0,0) of the imageObj */
-  double rcorner; /* distance to the line passing through the topleft or bottomleft corner
-                       of the hatch bbox (origin is (0,0) of imageObj) */
+  double invct = 1.0 / ct;
+  double invst = 1.0 / st;
+  double
+      r0; /* distance from first hatch line to the top-left (if angle in 0,pi/2)
+               or bottom-left (if angle in -pi/2,0) corner of the hatch bbox */
+  double rmax = sqrt((
+      double)(sx * sx +
+              sy *
+                  sy)); /* distance to the furthest hatch we will have to create
+TODO: this could be optimized for bounding boxes where width is very different
+than height for certain hatch angles */
+  double rref =
+      rx * ct + ry * st; /* distance to the line passing through the refpoint,
+                            origin is (0,0) of the imageObj */
+  double
+      rcorner; /* distance to the line passing through the topleft or bottomleft
+                  corner of the hatch bbox (origin is (0,0) of imageObj) */
 
   /* calculate the distance from the refpoint to the top right of the path */
-  if(angle < 90) {
-    rcorner = ox*ct + oy*st;
-    r0 = step - fmod(rcorner-rref,step);
-    if(rcorner-rref<0) r0 -= step;
+  if (angle < 90) {
+    rcorner = ox * ct + oy * st;
+    r0 = step - fmod(rcorner - rref, step);
+    if (rcorner - rref < 0)
+      r0 -= step;
   } else {
-    rcorner = ox*ct + (oy+sy)*st;
-    r0 = step - fmod(rcorner-rref,step);
-    if(rcorner-rref<0) r0 -= step;
+    rcorner = ox * ct + (oy + sy) * st;
+    r0 = step - fmod(rcorner - rref, step);
+    if (rcorner - rref < 0)
+      r0 -= step;
     st = -st;
     invst = -invst;
   }
 
-
-  //parametrize each line as r = x.cos(theta) + y.sin(theta)
-  for(double r=r0; r<rmax; r+=step) {
-    int inter=0;
-    double x,y;
-    double pt[4]; //array to store the coordinates of intersection of the line with the sides
-    //in the general case there will only be two intersections
-    //so pt[4] should be sufficient to store the coordinates of the intersection,
-    //but we allocate pt[8] to treat the special and rare/unfortunate case when the
-    //line is a perfect diagonal (and therfore intersects all four sides)
-    //note that the order for testing is important in this case so that the first
-    //two intersection points actually correspond to the diagonal and not a degenerate line
-
-    //test for intersection with each side
-
-    y=r*invst;
-    x=0; // test for intersection with left of image
-    if(y>=0&&y<=sy) {
-      pt[2*inter]=x;
-      pt[2*inter+1]=y;
+  // parametrize each line as r = x.cos(theta) + y.sin(theta)
+  for (double r = r0; r < rmax; r += step) {
+    int inter = 0;
+    double x, y;
+    double pt[4]; // array to store the coordinates of intersection of the line
+                  // with the sides
+    // in the general case there will only be two intersections
+    // so pt[4] should be sufficient to store the coordinates of the
+    // intersection, but we allocate pt[8] to treat the special and
+    // rare/unfortunate case when the line is a perfect diagonal (and therfore
+    // intersects all four sides) note that the order for testing is important
+    // in this case so that the first two intersection points actually
+    // correspond to the diagonal and not a degenerate line
+
+    // test for intersection with each side
+
+    y = r * invst;
+    x = 0; // test for intersection with left of image
+    if (y >= 0 && y <= sy) {
+      pt[2 * inter] = x;
+      pt[2 * inter + 1] = y;
       inter++;
     }
-    x=sx;
-    y=(r-sx*ct)*invst;// test for intersection with right of image
-    if(y>=0&&y<=sy) {
-      pt[2*inter]=x;
-      pt[2*inter+1]=y;
+    x = sx;
+    y = (r - sx * ct) * invst; // test for intersection with right of image
+    if (y >= 0 && y <= sy) {
+      pt[2 * inter] = x;
+      pt[2 * inter + 1] = y;
       inter++;
     }
-    if(inter<2) {
-      y=0;
-      x=r*invct;// test for intersection with top of image
-      if(x>=0&&x<=sx) {
-        pt[2*inter]=x;
-        pt[2*inter+1]=y;
+    if (inter < 2) {
+      y = 0;
+      x = r * invct; // test for intersection with top of image
+      if (x >= 0 && x <= sx) {
+        pt[2 * inter] = x;
+        pt[2 * inter + 1] = y;
         inter++;
       }
     }
-    if(inter<2) {
-      y=sy;
-      x=(r-sy*st)*invct;// test for intersection with bottom of image
-      if(x>=0&&x<=sx) {
-        pt[2*inter]=x;
-        pt[2*inter+1]=y;
+    if (inter < 2) {
+      y = sy;
+      x = (r - sy * st) * invct; // test for intersection with bottom of image
+      if (x >= 0 && x <= sx) {
+        pt[2 * inter] = x;
+        pt[2 * inter + 1] = y;
         inter++;
       }
     }
-    if(inter==2 && (pt[0]!=pt[2] || pt[1]!=pt[3])) {
-      //the line intersects with two sides of the image, it should therefore be drawn
-      if(angle<90) {
-        path.move_to(pt[0],pt[1]);
-        path.line_to(pt[2],pt[3]);
+    if (inter == 2 && (pt[0] != pt[2] || pt[1] != pt[3])) {
+      // the line intersects with two sides of the image, it should therefore be
+      // drawn
+      if (angle < 90) {
+        path.move_to(pt[0], pt[1]);
+        path.line_to(pt[2], pt[3]);
       } else {
-        path.move_to(pt[0],sy-pt[1]);
-        path.line_to(pt[2],sy-pt[3]);
+        path.move_to(pt[0], sy - pt[1]);
+        path.line_to(pt[2], sy - pt[3]);
       }
     }
   }
   return path;
 }
 
-template<class VertexSource> int renderPolygonHatches(imageObj *img,VertexSource &clipper, colorObj *color)
-{
-  if(img->format->renderer == MS_RENDER_WITH_AGG) {
+template <class VertexSource>
+int renderPolygonHatches(imageObj *img, VertexSource &clipper,
+                         colorObj *color) {
+  if (img->format->renderer == MS_RENDER_WITH_AGG) {
     AGG2Renderer *r = AGG_RENDERER(img);
     r->m_rasterizer_aa_gamma.reset();
     r->m_rasterizer_aa_gamma.filling_rule(mapserver::fill_non_zero);
     r->m_rasterizer_aa_gamma.add_path(clipper);
     r->m_renderer_scanline.color(aggColor(color));
-    mapserver::render_scanlines(r->m_rasterizer_aa_gamma, r->sl_poly, r->m_renderer_scanline);
+    mapserver::render_scanlines(r->m_rasterizer_aa_gamma, r->sl_poly,
+                                r->m_renderer_scanline);
   } else {
     shapeObj shape;
     msInitShape(&shape);
@@ -1041,37 +1077,40 @@ template<class VertexSource> int renderP
     lineObj line;
     shape.line = &line;
     shape.numlines = 1;
-    shape.line[0].point = (pointObj*)msSmallCalloc(allocated,sizeof(pointObj));
+    shape.line[0].point =
+        (pointObj *)msSmallCalloc(allocated, sizeof(pointObj));
     shape.line[0].numpoints = 0;
-    double x=0,y=0;
+    double x = 0, y = 0;
     unsigned int cmd;
     clipper.rewind(0);
-    while((cmd = clipper.vertex(&x,&y)) != mapserver::path_cmd_stop) {
-      switch(cmd) {
-        case mapserver::path_cmd_line_to:
-          if(shape.line[0].numpoints == allocated) {
-            allocated *= 2;
-            shape.line[0].point = (pointObj*)msSmallRealloc(shape.line[0].point, allocated*sizeof(pointObj));
-          }
-          shape.line[0].point[shape.line[0].numpoints].x = x;
-          shape.line[0].point[shape.line[0].numpoints].y = y;
-          shape.line[0].numpoints++;
-          break;
-        case mapserver::path_cmd_move_to:
-          shape.line[0].point[0].x = x;
-          shape.line[0].point[0].y = y;
-          shape.line[0].numpoints = 1;
-          break;
-        case mapserver::path_cmd_end_poly|mapserver::path_flags_close:
-          if(shape.line[0].numpoints > 2) {
-            if(MS_UNLIKELY(MS_FAILURE == MS_IMAGE_RENDERER(img)->renderPolygon(img,&shape,color))) {
-              free(shape.line[0].point);
-              return MS_FAILURE;
-            }
+    while ((cmd = clipper.vertex(&x, &y)) != mapserver::path_cmd_stop) {
+      switch (cmd) {
+      case mapserver::path_cmd_line_to:
+        if (shape.line[0].numpoints == allocated) {
+          allocated *= 2;
+          shape.line[0].point = (pointObj *)msSmallRealloc(
+              shape.line[0].point, allocated * sizeof(pointObj));
+        }
+        shape.line[0].point[shape.line[0].numpoints].x = x;
+        shape.line[0].point[shape.line[0].numpoints].y = y;
+        shape.line[0].numpoints++;
+        break;
+      case mapserver::path_cmd_move_to:
+        shape.line[0].point[0].x = x;
+        shape.line[0].point[0].y = y;
+        shape.line[0].numpoints = 1;
+        break;
+      case mapserver::path_cmd_end_poly | mapserver::path_flags_close:
+        if (shape.line[0].numpoints > 2) {
+          if (MS_UNLIKELY(MS_FAILURE == MS_IMAGE_RENDERER(img)->renderPolygon(
+                                            img, &shape, color))) {
+            free(shape.line[0].point);
+            return MS_FAILURE;
           }
-          break;
-        default:
-          assert(0); //WTF?
+        }
+        break;
+      default:
+        assert(0); // WTF?
       }
     }
     free(shape.line[0].point);
@@ -1079,8 +1118,9 @@ template<class VertexSource> int renderP
   return MS_SUCCESS;
 }
 
-int msHatchPolygon(imageObj *img, shapeObj *poly, double spacing, double width, double *pattern, int patternlength, double angle, colorObj *color)
-{
+int msHatchPolygon(imageObj *img, shapeObj *poly, double spacing, double width,
+                   double *pattern, int patternlength, double angle,
+                   colorObj *color) {
   assert(MS_RENDERER_PLUGIN(img->format));
   msComputeBounds(poly);
 
@@ -1088,236 +1128,246 @@ int msHatchPolygon(imageObj *img, shapeO
   double exp = width * 0.7072;
 
   /* width and height of the bounding box we will be creating the hatch in */
-  int pw=(int)(poly->bounds.maxx-poly->bounds.minx+exp*2)+1;
-  int ph=(int)(poly->bounds.maxy-poly->bounds.miny+exp*2)+1;
+  int pw = (int)(poly->bounds.maxx - poly->bounds.minx + exp * 2) + 1;
+  int ph = (int)(poly->bounds.maxy - poly->bounds.miny + exp * 2) + 1;
 
   /* position of the top-left corner of the bounding box */
   double ox = poly->bounds.minx - exp;
   double oy = poly->bounds.miny - exp;
 
-  //create a rectangular hatch of size pw,ph starting at 0,0
-  //the created hatch is of the size of the shape's bounding box
-  mapserver::path_storage hatch = createHatch(ox,oy,
-                                  img->refpt.x,img->refpt.y,pw,ph,angle,spacing);
-  if(hatch.total_vertices()<=0) return MS_SUCCESS;
+  // create a rectangular hatch of size pw,ph starting at 0,0
+  // the created hatch is of the size of the shape's bounding box
+  mapserver::path_storage hatch =
+      createHatch(ox, oy, img->refpt.x, img->refpt.y, pw, ph, angle, spacing);
+  if (hatch.total_vertices() <= 0)
+    return MS_SUCCESS;
 
-  //translate the hatch so it overlaps the current shape
-  hatch.transform(mapserver::trans_affine_translation(ox,oy));
+  // translate the hatch so it overlaps the current shape
+  hatch.transform(mapserver::trans_affine_translation(ox, oy));
 
   polygon_adaptor polygons(poly);
 
-
-
-  if(patternlength>1) {
-    //dash the color-hatch and render it clipped by the shape
-    mapserver::conv_dash<mapserver::path_storage > dash(hatch);
-    mapserver::conv_stroke<mapserver::conv_dash<mapserver::path_storage> > stroke(dash);
-    for (int i=0; i<patternlength; i+=2) {
-      if (i < patternlength-1) {
-        dash.add_dash(pattern[i], pattern[i+1]);
+  if (patternlength > 1) {
+    // dash the color-hatch and render it clipped by the shape
+    mapserver::conv_dash<mapserver::path_storage> dash(hatch);
+    mapserver::conv_stroke<mapserver::conv_dash<mapserver::path_storage>>
+        stroke(dash);
+    for (int i = 0; i < patternlength; i += 2) {
+      if (i < patternlength - 1) {
+        dash.add_dash(pattern[i], pattern[i + 1]);
       }
     }
     stroke.width(width);
     stroke.line_cap(mapserver::butt_cap);
-    mapserver::conv_clipper<polygon_adaptor,mapserver::conv_stroke<mapserver::conv_dash<mapserver::path_storage> > > clipper(polygons,stroke, mapserver::clipper_and);
-    renderPolygonHatches(img,clipper,color);
+    mapserver::conv_clipper<
+        polygon_adaptor,
+        mapserver::conv_stroke<mapserver::conv_dash<mapserver::path_storage>>>
+        clipper(polygons, stroke, mapserver::clipper_and);
+    renderPolygonHatches(img, clipper, color);
   } else {
-    //render the hatch clipped by the shape
-    mapserver::conv_stroke <mapserver::path_storage > stroke(hatch);
+    // render the hatch clipped by the shape
+    mapserver::conv_stroke<mapserver::path_storage> stroke(hatch);
     stroke.width(width);
     stroke.line_cap(mapserver::butt_cap);
-    mapserver::conv_clipper<polygon_adaptor,mapserver::conv_stroke<mapserver::path_storage> > clipper(polygons,stroke, mapserver::clipper_and);
-    renderPolygonHatches(img,clipper,color);
+    mapserver::conv_clipper<polygon_adaptor,
+                            mapserver::conv_stroke<mapserver::path_storage>>
+        clipper(polygons, stroke, mapserver::clipper_and);
+    renderPolygonHatches(img, clipper, color);
   }
 
-
-  //assert(prevCmd == mapserver::path_cmd_line_to);
-  //delete lines;
+  // assert(prevCmd == mapserver::path_cmd_line_to);
+  // delete lines;
   return MS_SUCCESS;
 }
 
 #ifdef USE_PIXMAN
 static pixman_op_t ms2pixman_compop(CompositingOperation c) {
-  switch(c) {
-    case MS_COMPOP_CLEAR:
-      return PIXMAN_OP_CLEAR;
-    case MS_COMPOP_SRC:
-      return PIXMAN_OP_SRC;
-    case MS_COMPOP_DST:
-      return PIXMAN_OP_DST;
-    case MS_COMPOP_SRC_OVER:
-      return PIXMAN_OP_OVER;
-    case MS_COMPOP_DST_OVER:
-      return PIXMAN_OP_OVER_REVERSE;
-    case MS_COMPOP_SRC_IN:
-      return PIXMAN_OP_IN;
-    case MS_COMPOP_DST_IN:
-      return PIXMAN_OP_IN_REVERSE;
-    case MS_COMPOP_SRC_OUT:
-      return PIXMAN_OP_OUT;
-    case MS_COMPOP_DST_OUT:
-      return PIXMAN_OP_OUT_REVERSE;
-    case MS_COMPOP_SRC_ATOP:
-      return PIXMAN_OP_ATOP;
-    case MS_COMPOP_DST_ATOP:
-      return PIXMAN_OP_ATOP_REVERSE;
-    case MS_COMPOP_XOR:
-      return PIXMAN_OP_XOR;
-    case MS_COMPOP_PLUS:
-      return PIXMAN_OP_ADD;
-    case MS_COMPOP_MULTIPLY:
-      return PIXMAN_OP_MULTIPLY;
-    case MS_COMPOP_SCREEN:
-      return PIXMAN_OP_SCREEN;
-    case MS_COMPOP_OVERLAY:
-      return PIXMAN_OP_OVERLAY;
-    case MS_COMPOP_DARKEN:
-      return PIXMAN_OP_DARKEN;
-    case MS_COMPOP_LIGHTEN:
-      return PIXMAN_OP_LIGHTEN;
-    case MS_COMPOP_COLOR_DODGE:
-      return PIXMAN_OP_COLOR_DODGE;
-    case MS_COMPOP_COLOR_BURN:
-      return PIXMAN_OP_COLOR_DODGE;
-    case MS_COMPOP_HARD_LIGHT:
-      return PIXMAN_OP_HARD_LIGHT;
-    case MS_COMPOP_SOFT_LIGHT:
-      return PIXMAN_OP_SOFT_LIGHT;
-    case MS_COMPOP_DIFFERENCE:
-      return PIXMAN_OP_DIFFERENCE;
-    case MS_COMPOP_EXCLUSION:
-      return PIXMAN_OP_EXCLUSION;
-    case MS_COMPOP_INVERT:
-    case MS_COMPOP_INVERT_RGB:
-    case MS_COMPOP_MINUS:
-    case MS_COMPOP_CONTRAST:
-    default:
-      return PIXMAN_OP_OVER;
+  switch (c) {
+  case MS_COMPOP_CLEAR:
+    return PIXMAN_OP_CLEAR;
+  case MS_COMPOP_SRC:
+    return PIXMAN_OP_SRC;
+  case MS_COMPOP_DST:
+    return PIXMAN_OP_DST;
+  case MS_COMPOP_SRC_OVER:
+    return PIXMAN_OP_OVER;
+  case MS_COMPOP_DST_OVER:
+    return PIXMAN_OP_OVER_REVERSE;
+  case MS_COMPOP_SRC_IN:
+    return PIXMAN_OP_IN;
+  case MS_COMPOP_DST_IN:
+    return PIXMAN_OP_IN_REVERSE;
+  case MS_COMPOP_SRC_OUT:
+    return PIXMAN_OP_OUT;
+  case MS_COMPOP_DST_OUT:
+    return PIXMAN_OP_OUT_REVERSE;
+  case MS_COMPOP_SRC_ATOP:
+    return PIXMAN_OP_ATOP;
+  case MS_COMPOP_DST_ATOP:
+    return PIXMAN_OP_ATOP_REVERSE;
+  case MS_COMPOP_XOR:
+    return PIXMAN_OP_XOR;
+  case MS_COMPOP_PLUS:
+    return PIXMAN_OP_ADD;
+  case MS_COMPOP_MULTIPLY:
+    return PIXMAN_OP_MULTIPLY;
+  case MS_COMPOP_SCREEN:
+    return PIXMAN_OP_SCREEN;
+  case MS_COMPOP_OVERLAY:
+    return PIXMAN_OP_OVERLAY;
+  case MS_COMPOP_DARKEN:
+    return PIXMAN_OP_DARKEN;
+  case MS_COMPOP_LIGHTEN:
+    return PIXMAN_OP_LIGHTEN;
+  case MS_COMPOP_COLOR_DODGE:
+    return PIXMAN_OP_COLOR_DODGE;
+  case MS_COMPOP_COLOR_BURN:
+    return PIXMAN_OP_COLOR_DODGE;
+  case MS_COMPOP_HARD_LIGHT:
+    return PIXMAN_OP_HARD_LIGHT;
+  case MS_COMPOP_SOFT_LIGHT:
+    return PIXMAN_OP_SOFT_LIGHT;
+  case MS_COMPOP_DIFFERENCE:
+    return PIXMAN_OP_DIFFERENCE;
+  case MS_COMPOP_EXCLUSION:
+    return PIXMAN_OP_EXCLUSION;
+  case MS_COMPOP_INVERT:
+  case MS_COMPOP_INVERT_RGB:
+  case MS_COMPOP_MINUS:
+  case MS_COMPOP_CONTRAST:
+  default:
+    return PIXMAN_OP_OVER;
   }
 }
 #else
 static mapserver::comp_op_e ms2agg_compop(CompositingOperation c) {
-  switch(c) {
-    case MS_COMPOP_CLEAR:
-      return mapserver::comp_op_clear;
-    case MS_COMPOP_SRC:
-      return mapserver::comp_op_src;
-    case MS_COMPOP_DST:
-      return mapserver::comp_op_dst;
-    case MS_COMPOP_SRC_OVER:
-      return mapserver::comp_op_src_over;
-    case MS_COMPOP_DST_OVER:
-      return mapserver::comp_op_dst_over;
-    case MS_COMPOP_SRC_IN:
-      return mapserver::comp_op_src_in;
-    case MS_COMPOP_DST_IN:
-      return mapserver::comp_op_dst_in;
-    case MS_COMPOP_SRC_OUT:
-      return mapserver::comp_op_src_out;
-    case MS_COMPOP_DST_OUT:
-      return mapserver::comp_op_dst_out;
-    case MS_COMPOP_SRC_ATOP:
-      return mapserver::comp_op_src_atop;
-    case MS_COMPOP_DST_ATOP:
-      return mapserver::comp_op_dst_atop;
-    case MS_COMPOP_XOR:
-      return mapserver::comp_op_xor;
-    case MS_COMPOP_PLUS:
-      return mapserver::comp_op_plus;
-    case MS_COMPOP_MINUS:
-      return mapserver::comp_op_minus;
-    case MS_COMPOP_MULTIPLY:
-      return mapserver::comp_op_multiply;
-    case MS_COMPOP_SCREEN:
-      return mapserver::comp_op_screen;
-    case MS_COMPOP_OVERLAY:
-      return mapserver::comp_op_overlay;
-    case MS_COMPOP_DARKEN:
-      return mapserver::comp_op_darken;
-    case MS_COMPOP_LIGHTEN:
-      return mapserver::comp_op_lighten;
-    case MS_COMPOP_COLOR_DODGE:
-      return mapserver::comp_op_color_dodge;
-    case MS_COMPOP_COLOR_BURN:
-      return mapserver::comp_op_color_burn;
-    case MS_COMPOP_HARD_LIGHT:
-      return mapserver::comp_op_hard_light;
-    case MS_COMPOP_SOFT_LIGHT:
-      return mapserver::comp_op_soft_light;
-    case MS_COMPOP_DIFFERENCE:
-      return mapserver::comp_op_difference;
-    case MS_COMPOP_EXCLUSION:
-      return mapserver::comp_op_exclusion;
-    case MS_COMPOP_CONTRAST:
-      return mapserver::comp_op_contrast;
-    case MS_COMPOP_INVERT:
-      return mapserver::comp_op_invert;
-    case MS_COMPOP_INVERT_RGB:
-      return mapserver::comp_op_invert_rgb;
-    default:
-      return mapserver::comp_op_src_over;
+  switch (c) {
+  case MS_COMPOP_CLEAR:
+    return mapserver::comp_op_clear;
+  case MS_COMPOP_SRC:
+    return mapserver::comp_op_src;
+  case MS_COMPOP_DST:
+    return mapserver::comp_op_dst;
+  case MS_COMPOP_SRC_OVER:
+    return mapserver::comp_op_src_over;
+  case MS_COMPOP_DST_OVER:
+    return mapserver::comp_op_dst_over;
+  case MS_COMPOP_SRC_IN:
+    return mapserver::comp_op_src_in;
+  case MS_COMPOP_DST_IN:
+    return mapserver::comp_op_dst_in;
+  case MS_COMPOP_SRC_OUT:
+    return mapserver::comp_op_src_out;
+  case MS_COMPOP_DST_OUT:
+    return mapserver::comp_op_dst_out;
+  case MS_COMPOP_SRC_ATOP:
+    return mapserver::comp_op_src_atop;
+  case MS_COMPOP_DST_ATOP:
+    return mapserver::comp_op_dst_atop;
+  case MS_COMPOP_XOR:
+    return mapserver::comp_op_xor;
+  case MS_COMPOP_PLUS:
+    return mapserver::comp_op_plus;
+  case MS_COMPOP_MINUS:
+    return mapserver::comp_op_minus;
+  case MS_COMPOP_MULTIPLY:
+    return mapserver::comp_op_multiply;
+  case MS_COMPOP_SCREEN:
+    return mapserver::comp_op_screen;
+  case MS_COMPOP_OVERLAY:
+    return mapserver::comp_op_overlay;
+  case MS_COMPOP_DARKEN:
+    return mapserver::comp_op_darken;
+  case MS_COMPOP_LIGHTEN:
+    return mapserver::comp_op_lighten;
+  case MS_COMPOP_COLOR_DODGE:
+    return mapserver::comp_op_color_dodge;
+  case MS_COMPOP_COLOR_BURN:
+    return mapserver::comp_op_color_burn;
+  case MS_COMPOP_HARD_LIGHT:
+    return mapserver::comp_op_hard_light;
+  case MS_COMPOP_SOFT_LIGHT:
+    return mapserver::comp_op_soft_light;
+  case MS_COMPOP_DIFFERENCE:
+    return mapserver::comp_op_difference;
+  case MS_COMPOP_EXCLUSION:
+    return mapserver::comp_op_exclusion;
+  case MS_COMPOP_CONTRAST:
+    return mapserver::comp_op_contrast;
+  case MS_COMPOP_INVERT:
+    return mapserver::comp_op_invert;
+  case MS_COMPOP_INVERT_RGB:
+    return mapserver::comp_op_invert_rgb;
+  default:
+    return mapserver::comp_op_src_over;
   }
 }
 #endif
 
-int aggCompositeRasterBuffer(imageObj *dest, rasterBufferObj *overlay, CompositingOperation comp, int opacity) {
+int aggCompositeRasterBuffer(imageObj *dest, rasterBufferObj *overlay,
+                             CompositingOperation comp, int opacity) {
   assert(overlay->type == MS_BUFFER_BYTE_RGBA);
   AGG2Renderer *r = AGG_RENDERER(dest);
 #ifdef USE_PIXMAN
-  pixman_image_t *si = pixman_image_create_bits(PIXMAN_a8r8g8b8,overlay->width,overlay->height,
-                       (uint32_t*)overlay->data.rgba.pixels,overlay->data.rgba.row_step);
-  pixman_image_t *bi = pixman_image_create_bits(PIXMAN_a8r8g8b8,dest->width,dest->height,
-                       reinterpret_cast<uint32_t*>(&(r->buffer[0])),dest->width*4);
-  pixman_image_t *alpha_mask_i=NULL, *alpha_mask_i_ptr;
-  pixman_image_set_filter(si,PIXMAN_FILTER_NEAREST, NULL, 0);
+  pixman_image_t *si = pixman_image_create_bits(
+      PIXMAN_a8r8g8b8, overlay->width, overlay->height,
+      (uint32_t *)overlay->data.rgba.pixels, overlay->data.rgba.row_step);
+  pixman_image_t *bi = pixman_image_create_bits(
+      PIXMAN_a8r8g8b8, dest->width, dest->height,
+      reinterpret_cast<uint32_t *>(&(r->buffer[0])), dest->width * 4);
+  pixman_image_t *alpha_mask_i = NULL, *alpha_mask_i_ptr;
+  pixman_image_set_filter(si, PIXMAN_FILTER_NEAREST, NULL, 0);
   unsigned char *alpha_mask = NULL;
-    if(opacity > 0) {
-      if(opacity == 100) {
-        alpha_mask_i_ptr = NULL;
-      } else {
-          unsigned char alpha = (unsigned char)(opacity * 2.55);
-          if(!alpha_mask_i) {
-              alpha_mask = (unsigned char*)msSmallMalloc(dest->width * dest->height);
-              alpha_mask_i = pixman_image_create_bits(PIXMAN_a8,dest->width,dest->height,
-                      (uint32_t*)alpha_mask,dest->width);
-          }
-          memset(alpha_mask,alpha,dest->width*dest->height);
-          alpha_mask_i_ptr = alpha_mask_i;
+  if (opacity > 0) {
+    if (opacity == 100) {
+      alpha_mask_i_ptr = NULL;
+    } else {
+      unsigned char alpha = (unsigned char)(opacity * 2.55);
+      if (!alpha_mask_i) {
+        alpha_mask = (unsigned char *)msSmallMalloc(dest->width * dest->height);
+        alpha_mask_i =
+            pixman_image_create_bits(PIXMAN_a8, dest->width, dest->height,
+                                     (uint32_t *)alpha_mask, dest->width);
       }
-      pixman_image_composite (ms2pixman_compop(comp), si, alpha_mask_i_ptr, bi,
-                  0, 0, 0, 0, 0, 0, dest->width,dest->height);
+      memset(alpha_mask, alpha, dest->width * dest->height);
+      alpha_mask_i_ptr = alpha_mask_i;
     }
+    pixman_image_composite(ms2pixman_compop(comp), si, alpha_mask_i_ptr, bi, 0,
+                           0, 0, 0, 0, 0, dest->width, dest->height);
+  }
   pixman_image_unref(si);
   pixman_image_unref(bi);
-  if(alpha_mask_i) {
+  if (alpha_mask_i) {
     pixman_image_unref(alpha_mask_i);
     msFree(alpha_mask);
   }
   return MS_SUCCESS;
 #else
-  rendering_buffer b(overlay->data.rgba.pixels, overlay->width, overlay->height, overlay->data.rgba.row_step);
+  rendering_buffer b(overlay->data.rgba.pixels, overlay->width, overlay->height,
+                     overlay->data.rgba.row_step);
   pixel_format pf(b);
   mapserver::comp_op_e comp_op = ms2agg_compop(comp);
-  if(comp_op == mapserver::comp_op_src_over) {
-    r->m_renderer_base.blend_from(pf,0,0,0,unsigned(opacity * 2.55));
+  if (comp_op == mapserver::comp_op_src_over) {
+    r->m_renderer_base.blend_from(pf, 0, 0, 0, unsigned(opacity * 2.55));
   } else {
     compop_pixel_format pixf(r->m_rendering_buffer);
     compop_renderer_base ren(pixf);
     pixf.comp_op(comp_op);
-    ren.blend_from(pf,0,0,0,unsigned(opacity * 2.55));
+    ren.blend_from(pf, 0, 0, 0, unsigned(opacity * 2.55));
   }
   return MS_SUCCESS;
 #endif
 }
 
-void msApplyBlurringCompositingFilter(rasterBufferObj *rb, unsigned int radius) {
-  rendering_buffer b(rb->data.rgba.pixels, rb->width, rb->height, rb->data.rgba.row_step);
+void msApplyBlurringCompositingFilter(rasterBufferObj *rb,
+                                      unsigned int radius) {
+  rendering_buffer b(rb->data.rgba.pixels, rb->width, rb->height,
+                     rb->data.rgba.row_step);
   pixel_format pf(b);
-  mapserver::stack_blur_rgba32(pf,radius,radius);
+  mapserver::stack_blur_rgba32(pf, radius, radius);
 }
 
-int msPopulateRendererVTableAGG(rendererVTableObj * renderer)
-{
+int msPopulateRendererVTableAGG(rendererVTableObj *renderer) {
   renderer->compositeRasterBuffer = &aggCompositeRasterBuffer;
   renderer->supports_pixel_buffer = 1;
   renderer->use_imagecache = 0;
diff -pruN 8.0.1-5/mapagg.h 8.0.2-1/mapagg.h
--- 8.0.1-5/mapagg.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapagg.h	2024-06-11 20:41:34.000000000 +0000
@@ -34,29 +34,31 @@
  * interface to a shapeObj representing lines, providing the functions
  * needed by the agg rasterizer. treats shapeObjs with multiple linestrings.
  */
-class line_adaptor
-{
+class line_adaptor {
 public:
-  explicit line_adaptor(shapeObj *shape):s(shape) {
-    m_line=s->line; /*first line*/
-    m_point=m_line->point; /*current vertex is first vertex of first line*/
-    m_lend=&(s->line[s->numlines]); /*pointer to after last line*/
-    m_pend=&(m_line->point[m_line->numpoints]); /*pointer to after last vertex of first line*/
+  explicit line_adaptor(shapeObj *shape) : s(shape) {
+    m_line = s->line;        /*first line*/
+    m_point = m_line->point; /*current vertex is first vertex of first line*/
+    m_lend = &(s->line[s->numlines]);             /*pointer to after last line*/
+    m_pend = &(m_line->point[m_line->numpoints]); /*pointer to after last vertex
+                                                     of first line*/
   }
 
   /* a class with virtual functions should also provide a virtual destructor */
   virtual ~line_adaptor() {}
 
   void rewind(unsigned) {
-    m_line=s->line; /*first line*/
-    m_point=m_line->point; /*current vertex is first vertex of first line*/
-    m_pend=&(m_line->point[m_line->numpoints]); /*pointer to after last vertex of first line*/
+    m_line = s->line;        /*first line*/
+    m_point = m_line->point; /*current vertex is first vertex of first line*/
+    m_pend = &(m_line->point[m_line->numpoints]); /*pointer to after last vertex
+                                                     of first line*/
   }
 
-  virtual unsigned vertex(double* x, double* y) {
-    if(m_point < m_pend) {
+  virtual unsigned vertex(double *x, double *y) {
+    if (m_point < m_pend) {
       /*here we treat the case where a real vertex is returned*/
-      bool first = m_point == m_line->point; /*is this the first vertex of a line*/
+      bool first =
+          m_point == m_line->point; /*is this the first vertex of a line*/
       *x = m_point->x;
       *y = m_point->y;
       m_point++;
@@ -65,34 +67,35 @@ public:
     /*if here, we're at the end of a line*/
     m_line++;
     *x = *y = 0.0;
-    if(m_line>=m_lend) /*is this the last line of the shapObj. normally,
-        (m_line==m_lend) should be a sufficient test, as the caller should not call
-        this function if a previous call returned path_cmd_stop.*/
+    if (m_line >= m_lend) /*is this the last line of the shapObj. normally,
+           (m_line==m_lend) should be a sufficient test, as the caller should
+           not call this function if a previous call returned path_cmd_stop.*/
       return mapserver::path_cmd_stop; /*no more points to process*/
 
     /*if here, there are more lines in the shapeObj, continue with next one*/
-    m_point=m_line->point; /*pointer to first point of next line*/
-    m_pend=&(m_line->point[m_line->numpoints]); /*pointer to after last point of next line*/
+    m_point = m_line->point; /*pointer to first point of next line*/
+    m_pend = &(m_line->point[m_line->numpoints]); /*pointer to after last point
+                                                     of next line*/
 
-    return vertex(x,y); /*this will return the first point of the next line*/
+    return vertex(x, y); /*this will return the first point of the next line*/
   }
+
 protected:
   shapeObj *s;
-  lineObj *m_line, /*current line pointer*/
-          *m_lend; /*points to after the last line*/
+  lineObj *m_line,   /*current line pointer*/
+      *m_lend;       /*points to after the last line*/
   pointObj *m_point, /*current point*/
-           *m_pend; /*points to after last point of current line*/
+      *m_pend;       /*points to after last point of current line*/
 };
 
-
-class polygon_adaptor
-{
+class polygon_adaptor {
 public:
-  explicit polygon_adaptor(shapeObj *shape):s(shape) {
-    m_line=s->line; /*first lines*/
-    m_point=m_line->point; /*first vertex of first line*/
-    m_lend=&(s->line[s->numlines]); /*pointer to after last line*/
-    m_pend=&(m_line->point[m_line->numpoints]); /*pointer to after last vertex of first line*/
+  explicit polygon_adaptor(shapeObj *shape) : s(shape) {
+    m_line = s->line;                             /*first lines*/
+    m_point = m_line->point;                      /*first vertex of first line*/
+    m_lend = &(s->line[s->numlines]);             /*pointer to after last line*/
+    m_pend = &(m_line->point[m_line->numpoints]); /*pointer to after last vertex
+                                                     of first line*/
   }
 
   /* a class with virtual functions should also provide a virtual destructor */
@@ -100,14 +103,14 @@ public:
 
   void rewind(unsigned) {
     /*reset pointers*/
-    m_stop=false;
-    m_line=s->line;
-    m_point=m_line->point;
-    m_pend=&(m_line->point[m_line->numpoints]);
+    m_stop = false;
+    m_line = s->line;
+    m_point = m_line->point;
+    m_pend = &(m_line->point[m_line->numpoints]);
   }
 
-  virtual unsigned vertex(double* x, double* y) {
-    if(m_point < m_pend) {
+  virtual unsigned vertex(double *x, double *y) {
+    if (m_point < m_pend) {
       /*if here, we have a real vertex*/
       bool first = m_point == m_line->point;
       *x = m_point->x;
@@ -116,36 +119,38 @@ public:
       return first ? mapserver::path_cmd_move_to : mapserver::path_cmd_line_to;
     }
     *x = *y = 0.0;
-    if(!m_stop) {
+    if (!m_stop) {
       /*if here, we're after the last vertex of the current line
        * we return the command to close the current polygon*/
       m_line++;
-      if(m_line>=m_lend) {
+      if (m_line >= m_lend) {
         /*if here, we've finished all the vertexes of the shape.
          * we still return the command to close the current polygon,
          * but set m_stop so the subsequent call to vertex() will return
          * the stop command*/
-        m_stop=true;
+        m_stop = true;
         return mapserver::path_cmd_end_poly;
       }
-      /*if here, there's another line in the shape, so we set the pointers accordingly
-       * and return the command to close the current polygon*/
-      m_point=m_line->point; /*first vertex of next line*/
-      m_pend=&(m_line->point[m_line->numpoints]); /*pointer to after last vertex of next line*/
+      /*if here, there's another line in the shape, so we set the pointers
+       * accordingly and return the command to close the current polygon*/
+      m_point = m_line->point; /*first vertex of next line*/
+      m_pend = &(m_line->point[m_line->numpoints]); /*pointer to after last
+                                                       vertex of next line*/
       return mapserver::path_cmd_end_poly;
     }
-    /*if here, a previous call to vertex informed us that we'd consumed all the vertexes
-     * of the shape. return the command to stop processing this shape*/
+    /*if here, a previous call to vertex informed us that we'd consumed all the
+     * vertexes of the shape. return the command to stop processing this shape*/
     return mapserver::path_cmd_stop;
   }
+
 protected:
   shapeObj *s;
   double ox = 0.0;
   double oy = 0.0;
-  lineObj *m_line, /*pointer to current line*/
-          *m_lend; /*pointer to after last line of the shape*/
-  pointObj *m_point, /*pointer to current vertex*/
-           *m_pend; /*pointer to after last vertex of current line*/
+  lineObj *m_line,     /*pointer to current line*/
+      *m_lend;         /*pointer to after last line of the shape*/
+  pointObj *m_point,   /*pointer to current vertex*/
+      *m_pend;         /*pointer to after last vertex of current line*/
   bool m_stop = false; /*should next call return stop command*/
 };
 
diff -pruN 8.0.1-5/mapaxisorder.h 8.0.2-1/mapaxisorder.h
--- 8.0.1-5/mapaxisorder.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapaxisorder.h	2024-06-11 20:41:34.000000000 +0000
@@ -14,7 +14,7 @@
  * and/or sell copies of the Software, and to permit persons to whom the
  * Software is furnished to do so, subject to the following conditions:
  *
- * The above copyright notice and this permission notice shall be included in 
+ * The above copyright notice and this permission notice shall be included in
  * all copies of this Software or works derived from this Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
@@ -25,4116 +25,4115 @@
  * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
  * DEALINGS IN THE SOFTWARE.
  ****************************************************************************/
- 
+
 /*
  * Generated file
  *
  * This file was generated from by means of a script. Do not edit manually.
  */
- 
+
 #ifdef __cplusplus
 extern "C" {
 #endif
- 
+
 static const unsigned char axisOrientationEpsgCodes[] = {
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        0 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 1 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        0 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
-        0 << 7 | 1 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 1 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        0 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        0 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        0 << 7 | 1 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 1 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 1 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 1 << 2 | 0 << 1 | 1 << 0,
-        0 << 7 | 1 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 1 << 2 | 0 << 1 | 1 << 0,
-        0 << 7 | 1 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 1 << 2 | 0 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 1 << 2 | 0 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 1 << 0,
-        0 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        1 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
-        0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0
-};
- 
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    0 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 1 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    0 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
+    0 << 7 | 1 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 1 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    0 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    0 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    0 << 7 | 1 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 1 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 1 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 1 << 2 | 0 << 1 | 1 << 0,
+    0 << 7 | 1 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 1 << 2 | 0 << 1 | 1 << 0,
+    0 << 7 | 1 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 1 << 2 | 0 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 1 << 2 | 0 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 1 << 0,
+    0 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 1 << 6 | 1 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    1 << 7 | 1 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 1 << 5 | 1 << 4 | 1 << 3 | 1 << 2 | 1 << 1 | 1 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 1 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0,
+    0 << 7 | 0 << 6 | 0 << 5 | 0 << 4 | 0 << 3 | 0 << 2 | 0 << 1 | 0 << 0};
+
 #ifdef __cplusplus
 }
 #endif
diff -pruN 8.0.1-5/mapbits.c 8.0.2-1/mapbits.c
--- 8.0.1-5/mapbits.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapbits.c	2024-06-11 20:41:34.000000000 +0000
@@ -32,8 +32,6 @@
 
 #include "mapserver.h"
 
-
-
 #include <limits.h>
 
 /*
@@ -41,24 +39,23 @@
  * See function msGetNextBit for another hardcoded value.
  */
 
-/* #define msGetBit(array, index) (*((array) + (index)/MS_ARRAY_BIT) & ( 1 << ((index) % MS_ARRAY_BIT))) */
+/* #define msGetBit(array, index) (*((array) + (index)/MS_ARRAY_BIT) & ( 1 <<
+ * ((index) % MS_ARRAY_BIT))) */
 
-size_t msGetBitArraySize(int numbits)
-{
-  return((numbits + MS_ARRAY_BIT - 1) / MS_ARRAY_BIT);
+size_t msGetBitArraySize(int numbits) {
+  return ((numbits + MS_ARRAY_BIT - 1) / MS_ARRAY_BIT);
 }
 
-ms_bitarray msAllocBitArray(int numbits)
-{
-  ms_bitarray array = calloc((numbits + MS_ARRAY_BIT - 1) / MS_ARRAY_BIT, MS_ARRAY_BIT);
+ms_bitarray msAllocBitArray(int numbits) {
+  ms_bitarray array =
+      calloc((numbits + MS_ARRAY_BIT - 1) / MS_ARRAY_BIT, MS_ARRAY_BIT);
 
-  return(array);
+  return (array);
 }
 
-int msGetBit(ms_const_bitarray array, int index)
-{
+int msGetBit(ms_const_bitarray array, int index) {
   array += index / MS_ARRAY_BIT;
-  return (*array & (1U << (index % MS_ARRAY_BIT))) != 0;    /* 0 or 1 */
+  return (*array & (1U << (index % MS_ARRAY_BIT))) != 0; /* 0 or 1 */
 }
 
 /*
@@ -68,17 +65,16 @@ int msGetBit(ms_const_bitarray array, in
 ** If hits end of bitmap without finding set bit, will return -1.
 **
 */
-int msGetNextBit(ms_const_bitarray array, int i, int size)
-{
+int msGetNextBit(ms_const_bitarray array, int i, int size) {
 
   register ms_uint32 b;
 
-  while(i < size) {
-    b = *(array + (i/MS_ARRAY_BIT));
-    if( b && (b >> (i % MS_ARRAY_BIT)) ) {
+  while (i < size) {
+    b = *(array + (i / MS_ARRAY_BIT));
+    if (b && (b >> (i % MS_ARRAY_BIT))) {
       /* There is something in this byte */
       /* And it is not to the right of us */
-      if( b & ( 1U << (i % MS_ARRAY_BIT)) ) {
+      if (b & (1U << (i % MS_ARRAY_BIT))) {
         /* There is something at this bit! */
         return i;
       } else {
@@ -94,25 +90,22 @@ int msGetNextBit(ms_const_bitarray array
   return -1;
 }
 
-void msSetBit(ms_bitarray array, int index, int value)
-{
+void msSetBit(ms_bitarray array, int index, int value) {
   array += index / MS_ARRAY_BIT;
   if (value)
-    *array |= 1U << (index % MS_ARRAY_BIT);           /* set bit */
+    *array |= 1U << (index % MS_ARRAY_BIT); /* set bit */
   else
-    *array &= ~(1U << (index % MS_ARRAY_BIT));        /* clear bit */
+    *array &= ~(1U << (index % MS_ARRAY_BIT)); /* clear bit */
 }
 
-void msSetAllBits(ms_bitarray array, int numbits, int value)
-{
+void msSetAllBits(ms_bitarray array, int numbits, int value) {
   if (value)
-    memset(array, 0xff, ((numbits + 7) / 8) ); /* set bit */
+    memset(array, 0xff, ((numbits + 7) / 8)); /* set bit */
   else
-    memset(array, 0x0,  ((numbits + 7) / 8) ); /* clear bit */
+    memset(array, 0x0, ((numbits + 7) / 8)); /* clear bit */
 }
 
-void msFlipBit(ms_bitarray array, int index)
-{
+void msFlipBit(ms_bitarray array, int index) {
   array += index / MS_ARRAY_BIT;
-  *array ^= 1U << (index % MS_ARRAY_BIT);                   /* flip bit */
+  *array ^= 1U << (index % MS_ARRAY_BIT); /* flip bit */
 }
diff -pruN 8.0.1-5/mapcairo.c 8.0.2-1/mapcairo.c
--- 8.0.1-5/mapcairo.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapcairo.c	2024-06-11 20:41:34.000000000 +0000
@@ -44,14 +44,14 @@
 #include <svg-cairo.h>
 #else
 #ifdef USE_RSVG
-  #include <librsvg/rsvg.h>
-  #ifndef LIBRSVG_CHECK_VERSION
-    #include <librsvg/librsvg-features.h>
-  #endif
-  #ifndef RSVG_CAIRO_H
-    #include <librsvg/rsvg-cairo.h>
-  #endif
-  #include <glib-object.h>
+#include <librsvg/rsvg.h>
+#ifndef LIBRSVG_CHECK_VERSION
+#include <librsvg/librsvg-features.h>
+#endif
+#ifndef RSVG_CAIRO_H
+#include <librsvg/rsvg-cairo.h>
+#endif
+#include <glib-object.h>
 #endif
 #endif
 
@@ -61,7 +61,7 @@
 
 #include "fontcache.h"
 
-# include <cairo-ft.h>
+#include <cairo-ft.h>
 /*
 #include <pango/pangocairo.h>
 #include <glib.h>
@@ -93,46 +93,41 @@ typedef struct {
   cairo_t *dummycr;
 } cairoCacheData;
 
-void initializeCache(void **vcache)
-{
-  cairoCacheData *cache = (cairoCacheData*)malloc(sizeof(cairoCacheData));
+void initializeCache(void **vcache) {
+  cairoCacheData *cache = (cairoCacheData *)malloc(sizeof(cairoCacheData));
   *vcache = cache;
 
   cache->cairofacecache = NULL;
   /* dummy surface and context */
-  cache->dummysurface = cairo_image_surface_create_for_data(cache->dummydata, CAIRO_FORMAT_ARGB32, 1,1,4);
+  cache->dummysurface = cairo_image_surface_create_for_data(
+      cache->dummydata, CAIRO_FORMAT_ARGB32, 1, 1, 4);
   cache->dummycr = cairo_create(cache->dummysurface);
 }
 
-int cleanupCairo(void *cache)
-{
-  cairoCacheData *ccache = (cairoCacheData*)cache;
+int cleanupCairo(void *cache) {
+  cairoCacheData *ccache = (cairoCacheData *)cache;
 
-  if(ccache->dummycr) {
+  if (ccache->dummycr) {
     cairo_destroy(ccache->dummycr);
   }
-  if(ccache->dummysurface) {
+  if (ccache->dummysurface) {
     cairo_surface_destroy(ccache->dummysurface);
   }
-  if(ccache->cairofacecache) {
-    cairoFaceCache *next,*cur;
+  if (ccache->cairofacecache) {
+    cairoFaceCache *next, *cur;
     cur = ccache->cairofacecache;
     do {
       next = cur->next;
       freeCairoFaceCache(cur);
       free(cur);
-      cur=next;
-    } while(cur);
+      cur = next;
+    } while (cur);
   }
 
   free(ccache);
   return MS_SUCCESS;
 }
 
-
-
-
-
 typedef struct {
   cairo_surface_t *surface;
   cairo_t *cr;
@@ -140,18 +135,15 @@ typedef struct {
   int use_alpha;
 } cairo_renderer;
 
+#define CAIRO_RENDERER(im) ((cairo_renderer *)(im->img.plugin))
 
-#define CAIRO_RENDERER(im) ((cairo_renderer*)(im->img.plugin))
-
-
-int freeImageCairo(imageObj *img)
-{
+int freeImageCairo(imageObj *img) {
   cairo_renderer *r = CAIRO_RENDERER(img);
-  if(r) {
+  if (r) {
     cairo_destroy(r->cr);
     cairo_surface_finish(r->surface);
     cairo_surface_destroy(r->surface);
-    if(r->outputStream) {
+    if (r->outputStream) {
       msBufferFree(r->outputStream);
       free(r->outputStream);
     }
@@ -160,10 +152,11 @@ int freeImageCairo(imageObj *img)
   return MS_SUCCESS;
 }
 
-static cairoFaceCache* getCairoFontFace(cairoCacheData *cache, FT_Face ftface) {
+static cairoFaceCache *getCairoFontFace(cairoCacheData *cache, FT_Face ftface) {
   cairoFaceCache *cur = cache->cairofacecache;
-  while(cur) {
-    if(cur->ftface == ftface) return cur;
+  while (cur) {
+    if (cur->ftface == ftface)
+      return cur;
     cur = cur->next;
   }
   cur = msSmallMalloc(sizeof(cairoFaceCache));
@@ -172,62 +165,64 @@ static cairoFaceCache* getCairoFontFace(
   cur->ftface = ftface;
   cur->face = cairo_ft_font_face_create_for_ft_face(ftface, 0);
   cur->options = cairo_font_options_create();
-  cairo_font_options_set_hint_style(cur->options,CAIRO_HINT_STYLE_NONE);
+  cairo_font_options_set_hint_style(cur->options, CAIRO_HINT_STYLE_NONE);
   return cur;
 }
 
-#define msCairoSetSourceColor(cr, c) cairo_set_source_rgba((cr),(c)->red/255.0,(c)->green/255.0,(c)->blue/255.0,(c)->alpha/255.0);
+#define msCairoSetSourceColor(cr, c)                                           \
+  cairo_set_source_rgba((cr), (c)->red / 255.0, (c)->green / 255.0,            \
+                        (c)->blue / 255.0, (c)->alpha / 255.0);
 
-int renderLineCairo(imageObj *img, shapeObj *p, strokeStyleObj *stroke)
-{
-  int i,j;
+int renderLineCairo(imageObj *img, shapeObj *p, strokeStyleObj *stroke) {
+  int i, j;
   cairo_renderer *r = CAIRO_RENDERER(img);
   assert(stroke->color);
   cairo_new_path(r->cr);
-  msCairoSetSourceColor(r->cr,stroke->color);
-  for(i=0; i<p->numlines; i++) {
+  msCairoSetSourceColor(r->cr, stroke->color);
+  for (i = 0; i < p->numlines; i++) {
     lineObj *l = &(p->line[i]);
-    if(l->numpoints == 0) continue;
-    cairo_move_to(r->cr,l->point[0].x,l->point[0].y);
-    for(j=1; j<l->numpoints; j++) {
-      cairo_line_to(r->cr,l->point[j].x,l->point[j].y);
+    if (l->numpoints == 0)
+      continue;
+    cairo_move_to(r->cr, l->point[0].x, l->point[0].y);
+    for (j = 1; j < l->numpoints; j++) {
+      cairo_line_to(r->cr, l->point[j].x, l->point[j].y);
     }
   }
-  if(stroke->patternlength>0) {
-    cairo_set_dash(r->cr,stroke->pattern,stroke->patternlength,-stroke->patternoffset);
-  }
-  switch(stroke->linecap) {
-    case MS_CJC_BUTT:
-      cairo_set_line_cap(r->cr,CAIRO_LINE_CAP_BUTT);
-      break;
-    case MS_CJC_SQUARE:
-      cairo_set_line_cap(r->cr,CAIRO_LINE_CAP_SQUARE);
-      break;
-    case MS_CJC_ROUND:
-    case MS_CJC_NONE:
-    default:
-      cairo_set_line_cap(r->cr,CAIRO_LINE_CAP_ROUND);
-  }
-  cairo_set_line_width (r->cr, stroke->width);
-  cairo_stroke (r->cr);
-  if(stroke->patternlength>0) {
-    cairo_set_dash(r->cr,stroke->pattern,0,0);
+  if (stroke->patternlength > 0) {
+    cairo_set_dash(r->cr, stroke->pattern, stroke->patternlength,
+                   -stroke->patternoffset);
+  }
+  switch (stroke->linecap) {
+  case MS_CJC_BUTT:
+    cairo_set_line_cap(r->cr, CAIRO_LINE_CAP_BUTT);
+    break;
+  case MS_CJC_SQUARE:
+    cairo_set_line_cap(r->cr, CAIRO_LINE_CAP_SQUARE);
+    break;
+  case MS_CJC_ROUND:
+  case MS_CJC_NONE:
+  default:
+    cairo_set_line_cap(r->cr, CAIRO_LINE_CAP_ROUND);
+  }
+  cairo_set_line_width(r->cr, stroke->width);
+  cairo_stroke(r->cr);
+  if (stroke->patternlength > 0) {
+    cairo_set_dash(r->cr, stroke->pattern, 0, 0);
   }
   return MS_SUCCESS;
 }
 
-int renderPolygonCairo(imageObj *img, shapeObj *p, colorObj *c)
-{
+int renderPolygonCairo(imageObj *img, shapeObj *p, colorObj *c) {
   cairo_renderer *r = CAIRO_RENDERER(img);
-  int i,j;
+  int i, j;
   cairo_new_path(r->cr);
-  cairo_set_fill_rule(r->cr,CAIRO_FILL_RULE_EVEN_ODD);
-  msCairoSetSourceColor(r->cr,c);
-  for(i=0; i<p->numlines; i++) {
+  cairo_set_fill_rule(r->cr, CAIRO_FILL_RULE_EVEN_ODD);
+  msCairoSetSourceColor(r->cr, c);
+  for (i = 0; i < p->numlines; i++) {
     lineObj *l = &(p->line[i]);
-    cairo_move_to(r->cr,l->point[0].x,l->point[0].y);
-    for(j=1; j<l->numpoints; j++) {
-      cairo_line_to(r->cr,l->point[j].x,l->point[j].y);
+    cairo_move_to(r->cr, l->point[0].x, l->point[0].y);
+    for (j = 1; j < l->numpoints; j++) {
+      cairo_line_to(r->cr, l->point[j].x, l->point[j].y);
     }
     cairo_close_path(r->cr);
   }
@@ -235,12 +230,12 @@ int renderPolygonCairo(imageObj *img, sh
   return MS_SUCCESS;
 }
 
-int renderPolygonTiledCairo(imageObj *img, shapeObj *p,  imageObj *tile)
-{
-  int i,j;
+int renderPolygonTiledCairo(imageObj *img, shapeObj *p, imageObj *tile) {
+  int i, j;
   cairo_renderer *r = CAIRO_RENDERER(img);
   cairo_renderer *tileRenderer = CAIRO_RENDERER(tile);
-  cairo_pattern_t *pattern = cairo_pattern_create_for_surface(tileRenderer->surface);
+  cairo_pattern_t *pattern =
+      cairo_pattern_create_for_surface(tileRenderer->surface);
   cairo_pattern_set_extend(pattern, CAIRO_EXTEND_REPEAT);
 
   cairo_set_source(r->cr, pattern);
@@ -257,76 +252,72 @@ int renderPolygonTiledCairo(imageObj *im
   return MS_SUCCESS;
 }
 
-cairo_surface_t *createSurfaceFromBuffer(rasterBufferObj *b)
-{
+cairo_surface_t *createSurfaceFromBuffer(rasterBufferObj *b) {
   assert(b->type == MS_BUFFER_BYTE_RGBA);
-  return cairo_image_surface_create_for_data (b->data.rgba.pixels,
-         CAIRO_FORMAT_ARGB32,
-         b->width,
-         b->height,
-         b->data.rgba.row_step);
+  return cairo_image_surface_create_for_data(b->data.rgba.pixels,
+                                             CAIRO_FORMAT_ARGB32, b->width,
+                                             b->height, b->data.rgba.row_step);
 }
 
-
-int renderPixmapSymbolCairo(imageObj *img, double x, double y,symbolObj *symbol,
-                            symbolStyleObj *style)
-{
+int renderPixmapSymbolCairo(imageObj *img, double x, double y,
+                            symbolObj *symbol, symbolStyleObj *style) {
   cairo_renderer *r = CAIRO_RENDERER(img);
   cairo_surface_t *im;
   rasterBufferObj *b = symbol->pixmap_buffer;
   assert(b);
-  if(!symbol->renderer_cache) {
-    symbol->renderer_cache = (void*)createSurfaceFromBuffer(b);
+  if (!symbol->renderer_cache) {
+    symbol->renderer_cache = (void *)createSurfaceFromBuffer(b);
   }
   assert(symbol->renderer_cache);
-  im=(cairo_surface_t*)symbol->renderer_cache;
+  im = (cairo_surface_t *)symbol->renderer_cache;
   cairo_save(r->cr);
-  if(style->rotation != 0 || style->scale != 1) {
-    cairo_translate (r->cr, x,y);
-    cairo_rotate (r->cr, -style->rotation);
-    cairo_scale  (r->cr, style->scale,style->scale);
-    cairo_translate (r->cr, -0.5*b->width, -0.5*b->height);
+  if (style->rotation != 0 || style->scale != 1) {
+    cairo_translate(r->cr, x, y);
+    cairo_rotate(r->cr, -style->rotation);
+    cairo_scale(r->cr, style->scale, style->scale);
+    cairo_translate(r->cr, -0.5 * b->width, -0.5 * b->height);
   } else {
-    cairo_translate (r->cr, MS_NINT(x-0.5*b->width),MS_NINT(y-0.5*b->height));
+    cairo_translate(r->cr, MS_NINT(x - 0.5 * b->width),
+                    MS_NINT(y - 0.5 * b->height));
   }
-  cairo_set_source_surface (r->cr, im, 0, 0);
-  cairo_paint (r->cr);
+  cairo_set_source_surface(r->cr, im, 0, 0);
+  cairo_paint(r->cr);
   cairo_restore(r->cr);
   return MS_SUCCESS;
 }
 
-int renderVectorSymbolCairo(imageObj *img, double x, double y, symbolObj *symbol,
-                            symbolStyleObj *style)
-{
+int renderVectorSymbolCairo(imageObj *img, double x, double y,
+                            symbolObj *symbol, symbolStyleObj *style) {
   cairo_renderer *r = CAIRO_RENDERER(img);
-  double ox=symbol->sizex*0.5,oy=symbol->sizey*0.5;
-  int is_new = 1,i;
+  double ox = symbol->sizex * 0.5, oy = symbol->sizey * 0.5;
+  int is_new = 1, i;
   cairo_new_path(r->cr);
   cairo_save(r->cr);
-  cairo_translate(r->cr,x,y);
-  cairo_scale(r->cr,style->scale,style->scale);
-  cairo_rotate(r->cr,-style->rotation);
-  cairo_translate(r->cr,-ox,-oy);
+  cairo_translate(r->cr, x, y);
+  cairo_scale(r->cr, style->scale, style->scale);
+  cairo_rotate(r->cr, -style->rotation);
+  cairo_translate(r->cr, -ox, -oy);
   for (i = 0; i < symbol->numpoints; i++) {
-    if ((symbol->points[i].x == -99) && (symbol->points[i].y == -99)) { /* (PENUP) */
+    if ((symbol->points[i].x == -99) &&
+        (symbol->points[i].y == -99)) { /* (PENUP) */
       is_new = 1;
     } else {
       if (is_new) {
-        cairo_move_to(r->cr,symbol->points[i].x,symbol->points[i].y);
+        cairo_move_to(r->cr, symbol->points[i].x, symbol->points[i].y);
         is_new = 0;
       } else {
-        cairo_line_to(r->cr,symbol->points[i].x,symbol->points[i].y);
+        cairo_line_to(r->cr, symbol->points[i].x, symbol->points[i].y);
       }
     }
   }
   cairo_restore(r->cr);
-  if(style->color) {
-    msCairoSetSourceColor(r->cr,style->color);
+  if (style->color) {
+    msCairoSetSourceColor(r->cr, style->color);
     cairo_fill_preserve(r->cr);
   }
-  if(style->outlinewidth>0) {
-    msCairoSetSourceColor(r->cr,style->outlinecolor);
-    cairo_set_line_width (r->cr, style->outlinewidth);
+  if (style->outlinewidth > 0) {
+    msCairoSetSourceColor(r->cr, style->outlinecolor);
+    cairo_set_line_width(r->cr, style->outlinewidth);
     cairo_stroke_preserve(r->cr);
   }
   cairo_new_path(r->cr);
@@ -341,38 +332,37 @@ struct svg_symbol_cache {
 #else
   svg_cairo_t *svgc;
 #endif
-  double scale,rotation;
-} ;
+  double scale, rotation;
+};
 #endif
 
 int renderSVGSymbolCairo(imageObj *img, double x, double y, symbolObj *symbol,
-                         symbolStyleObj *style)
-{
+                         symbolStyleObj *style) {
 #if defined(USE_SVG_CAIRO) || defined(USE_RSVG)
   struct svg_symbol_cache *cache;
   cairo_renderer *r = CAIRO_RENDERER(img);
 
-
-
   msPreloadSVGSymbol(symbol);
   assert(symbol->renderer_cache);
   cache = symbol->renderer_cache;
 
   cairo_save(r->cr);
-  cairo_translate(r->cr,x,y);
-  cairo_scale(r->cr,style->scale,style->scale);
+  cairo_translate(r->cr, x, y);
+  cairo_scale(r->cr, style->scale, style->scale);
 
   if (style->rotation != 0) {
     cairo_rotate(r->cr, -style->rotation);
-    cairo_translate (r->cr, -(int)(symbol->sizex/2), -(int)(symbol->sizey/2));
+    cairo_translate(r->cr, -(int)(symbol->sizex / 2),
+                    -(int)(symbol->sizey / 2));
   } else
-    cairo_translate (r->cr, -(int)(symbol->sizex/2), -(int)(symbol->sizey/2));
+    cairo_translate(r->cr, -(int)(symbol->sizex / 2),
+                    -(int)(symbol->sizey / 2));
 
 #ifdef USE_SVG_CAIRO
   {
     svg_cairo_status_t status;
     status = svg_cairo_render(cache->svgc, r->cr);
-    if(status != SVG_CAIRO_STATUS_SUCCESS) {
+    if (status != SVG_CAIRO_STATUS_SUCCESS) {
       cairo_restore(r->cr);
       return MS_FAILURE;
     }
@@ -385,30 +375,30 @@ int renderSVGSymbolCairo(imageObj *img,
 
   return MS_SUCCESS;
 
-
 #else
-  msSetError(MS_MISCERR, "SVG Symbols requested but is not built with libsvgcairo",
+  msSetError(MS_MISCERR,
+             "SVG Symbols requested but is not built with libsvgcairo",
              "renderSVGSymbolCairo()");
   return MS_FAILURE;
 #endif
 }
 
-int renderTileCairo(imageObj *img, imageObj *tile, double x, double y)
-{
+int renderTileCairo(imageObj *img, imageObj *tile, double x, double y) {
   cairo_renderer *r = CAIRO_RENDERER(img);
   cairo_surface_t *im = CAIRO_RENDERER(tile)->surface;
-  int w = cairo_image_surface_get_width (im);
-  int h = cairo_image_surface_get_height (im);
+  int w = cairo_image_surface_get_width(im);
+  int h = cairo_image_surface_get_height(im);
   cairo_save(r->cr);
-  cairo_translate(r->cr, MS_NINT(x-0.5 * w), MS_NINT(y -0.5 * h));
+  cairo_translate(r->cr, MS_NINT(x - 0.5 * w), MS_NINT(y - 0.5 * h));
   cairo_set_source_surface(r->cr, im, 0, 0);
-  cairo_pattern_set_filter (cairo_get_source (r->cr), CAIRO_FILTER_NEAREST);
+  cairo_pattern_set_filter(cairo_get_source(r->cr), CAIRO_FILTER_NEAREST);
   cairo_paint(r->cr);
   cairo_restore(r->cr);
   return MS_SUCCESS;
 }
 
-int renderGlyphs2Cairo(imageObj *img, const textSymbolObj *ts, colorObj *c, colorObj *oc, int ow, int isMarker) {
+int renderGlyphs2Cairo(imageObj *img, const textSymbolObj *ts, colorObj *c,
+                       colorObj *oc, int ow, int isMarker) {
   const textPathObj *tp = ts->textpath;
   cairo_renderer *r = CAIRO_RENDERER(img);
   cairoCacheData *cache = MS_IMAGE_RENDERER_CACHE(img);
@@ -417,25 +407,25 @@ int renderGlyphs2Cairo(imageObj *img, co
   int g;
   (void)isMarker;
 
-  cairo_set_font_size(r->cr,MS_NINT(tp->glyph_size * 96.0/72.0));
-  for(g=0;g<tp->numglyphs;g++) {
+  cairo_set_font_size(r->cr, MS_NINT(tp->glyph_size * 96.0 / 72.0));
+  for (g = 0; g < tp->numglyphs; g++) {
     glyphObj *gl = &tp->glyphs[g];
     cairo_glyph_t glyph;
     /* load the glyph's face into cairo, if not already present */
-    if(gl->face->face != prevface) {
-      cairo_face = getCairoFontFace(cache,gl->face->face);
+    if (gl->face->face != prevface) {
+      cairo_face = getCairoFontFace(cache, gl->face->face);
       cairo_set_font_face(r->cr, cairo_face->face);
-      cairo_set_font_options(r->cr,cairo_face->options);
+      cairo_set_font_options(r->cr, cairo_face->options);
       prevface = gl->face->face;
-      cairo_set_font_size(r->cr,MS_NINT(tp->glyph_size * 96.0/72.0));
+      cairo_set_font_size(r->cr, MS_NINT(tp->glyph_size * 96.0 / 72.0));
     }
     cairo_save(r->cr);
-    cairo_translate(r->cr,gl->pnt.x,gl->pnt.y);
-    if(gl->rot != 0.0)
+    cairo_translate(r->cr, gl->pnt.x, gl->pnt.y);
+    if (gl->rot != 0.0)
       cairo_rotate(r->cr, -gl->rot);
     glyph.x = glyph.y = 0;
     glyph.index = gl->glyph->key.codepoint;
-    cairo_glyph_path(r->cr,&glyph,1);
+    cairo_glyph_path(r->cr, &glyph, 1);
     cairo_restore(r->cr);
   }
   if (oc) {
@@ -445,7 +435,7 @@ int renderGlyphs2Cairo(imageObj *img, co
     cairo_stroke_preserve(r->cr);
     cairo_restore(r->cr);
   }
-  if(c) {
+  if (c) {
     msCairoSetSourceColor(r->cr, c);
     cairo_fill(r->cr);
   }
@@ -453,85 +443,88 @@ int renderGlyphs2Cairo(imageObj *img, co
   return MS_SUCCESS;
 }
 
-cairo_status_t _stream_write_fn(void *b, const unsigned char *data, unsigned int length)
-{
-  msBufferAppend((bufferObj*)b,(void*)data,length);
+cairo_status_t _stream_write_fn(void *b, const unsigned char *data,
+                                unsigned int length) {
+  msBufferAppend((bufferObj *)b, (void *)data, length);
   return CAIRO_STATUS_SUCCESS;
 }
 
-imageObj* createImageCairo(int width, int height, outputFormatObj *format,colorObj* bg)
-{
+imageObj *createImageCairo(int width, int height, outputFormatObj *format,
+                           colorObj *bg) {
   imageObj *image = NULL;
-  cairo_renderer *r=NULL;
-  if (format->imagemode != MS_IMAGEMODE_RGB && format->imagemode!= MS_IMAGEMODE_RGBA) {
+  cairo_renderer *r = NULL;
+  if (format->imagemode != MS_IMAGEMODE_RGB &&
+      format->imagemode != MS_IMAGEMODE_RGBA) {
     msSetError(MS_MISCERR,
-               "Cairo driver only supports RGB or RGBA pixel models.","msImageCreateCairo()");
+               "Cairo driver only supports RGB or RGBA pixel models.",
+               "msImageCreateCairo()");
     return image;
   }
   if (width > 0 && height > 0) {
-    image = (imageObj *) calloc(1, sizeof(imageObj));
-    r = (cairo_renderer*)calloc(1,sizeof(cairo_renderer));
-    if(!strcasecmp(format->driver,"cairo/pdf")) {
-      r->outputStream = (bufferObj*)malloc(sizeof(bufferObj));
+    image = (imageObj *)calloc(1, sizeof(imageObj));
+    r = (cairo_renderer *)calloc(1, sizeof(cairo_renderer));
+    if (!strcasecmp(format->driver, "cairo/pdf")) {
+      r->outputStream = (bufferObj *)malloc(sizeof(bufferObj));
       msBufferInit(r->outputStream);
       r->surface = cairo_pdf_surface_create_for_stream(
-                     _stream_write_fn,
-                     r->outputStream,
-                     width,height);
-#if CAIRO_VERSION >= CAIRO_VERSION_ENCODE(1,15,10)
+          _stream_write_fn, r->outputStream, width, height);
+#if CAIRO_VERSION >= CAIRO_VERSION_ENCODE(1, 15, 10)
       {
-          const char *msPDFCreationDate = CPLGetConfigOption("MS_PDF_CREATION_DATE", NULL);
-          if( msPDFCreationDate )
-          {
-              cairo_pdf_surface_set_metadata (r->surface,
-                                              CAIRO_PDF_METADATA_CREATE_DATE,
-                                              msPDFCreationDate);
-          }
+        const char *msPDFCreationDate =
+            CPLGetConfigOption("MS_PDF_CREATION_DATE", NULL);
+        if (msPDFCreationDate) {
+          cairo_pdf_surface_set_metadata(
+              r->surface, CAIRO_PDF_METADATA_CREATE_DATE, msPDFCreationDate);
+        }
       }
 #endif
-    } else if(!strcasecmp(format->driver,"cairo/svg")) {
-      r->outputStream = (bufferObj*)malloc(sizeof(bufferObj));
+    } else if (!strcasecmp(format->driver, "cairo/svg")) {
+      r->outputStream = (bufferObj *)malloc(sizeof(bufferObj));
       msBufferInit(r->outputStream);
       r->surface = cairo_svg_surface_create_for_stream(
-                     _stream_write_fn,
-                     r->outputStream,
-                     width,height);
-    } else if(!strcasecmp(format->driver,"cairo/winGDI") && format->device) {
+          _stream_write_fn, r->outputStream, width, height);
+    } else if (!strcasecmp(format->driver, "cairo/winGDI") && format->device) {
 #if CAIRO_HAS_WIN32_SURFACE
       r->outputStream = NULL;
       r->surface = cairo_win32_surface_create(format->device);
 #else
-      msSetError(MS_RENDERERERR, "Cannot create cairo image. Cairo was not compiled with support for the win32 backend.",
+      msSetError(MS_RENDERERERR,
+                 "Cannot create cairo image. Cairo was not compiled with "
+                 "support for the win32 backend.",
                  "msImageCreateCairo()");
 #endif
-    } else if(!strcasecmp(format->driver,"cairo/winGDIPrint") && format->device) {
+    } else if (!strcasecmp(format->driver, "cairo/winGDIPrint") &&
+               format->device) {
 #if CAIRO_HAS_WIN32_SURFACE
       r->outputStream = NULL;
       r->surface = cairo_win32_printing_surface_create(format->device);
 #else
-      msSetError(MS_RENDERERERR, "Cannot create cairo image. Cairo was not compiled with support for the win32 backend.",
+      msSetError(MS_RENDERERERR,
+                 "Cannot create cairo image. Cairo was not compiled with "
+                 "support for the win32 backend.",
                  "msImageCreateCairo()");
 #endif
     } else {
       r->outputStream = NULL;
-      r->surface = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, width, height);
+      r->surface =
+          cairo_image_surface_create(CAIRO_FORMAT_ARGB32, width, height);
     }
     r->cr = cairo_create(r->surface);
-    if(format->transparent || !bg || !MS_VALID_COLOR(*bg)) {
+    if (format->transparent || !bg || !MS_VALID_COLOR(*bg)) {
       r->use_alpha = 1;
-      cairo_set_source_rgba (r->cr, 0,0,0,0);
+      cairo_set_source_rgba(r->cr, 0, 0, 0, 0);
     } else {
       r->use_alpha = 0;
-      msCairoSetSourceColor(r->cr,bg);
+      msCairoSetSourceColor(r->cr, bg);
     }
-    cairo_save (r->cr);
-    cairo_set_operator (r->cr, CAIRO_OPERATOR_SOURCE);
-    cairo_paint (r->cr);
-    cairo_restore (r->cr);
-
-    cairo_set_line_cap (r->cr,CAIRO_LINE_CAP_ROUND);
-    cairo_set_line_join(r->cr,CAIRO_LINE_JOIN_ROUND);
-    image->img.plugin = (void*)r;
+    cairo_save(r->cr);
+    cairo_set_operator(r->cr, CAIRO_OPERATOR_SOURCE);
+    cairo_paint(r->cr);
+    cairo_restore(r->cr);
+
+    cairo_set_line_cap(r->cr, CAIRO_LINE_CAP_ROUND);
+    cairo_set_line_join(r->cr, CAIRO_LINE_JOIN_ROUND);
+    image->img.plugin = (void *)r;
   } else {
     msSetError(MS_RENDERERERR, "Cannot create cairo image of size %dx%d.",
                "msImageCreateCairo()", width, height);
@@ -539,23 +532,27 @@ imageObj* createImageCairo(int width, in
   return image;
 }
 
-/* msSaveImagePostPDFProcessing() will call the GDAL PDF driver to add geospatial */
-/* information to the regular PDF generated by cairo. This is only triggered if the */
-/* GEO_ENCODING outputformat option is set (to ISO32000 or OGC_BP). Additionnal */
+/* msSaveImagePostPDFProcessing() will call the GDAL PDF driver to add
+ * geospatial */
+/* information to the regular PDF generated by cairo. This is only triggered if
+ * the */
+/* GEO_ENCODING outputformat option is set (to ISO32000 or OGC_BP). Additionnal
+ */
 /* options can be provided by specifying outputformat options starting with */
 /* METADATA_ITEM: prefix. For example METADATA_ITEM:PRODUCER=MapServer */
-/* Those options are AUTHOR, CREATOR, CREATION_DATE, KEYWORDS, PRODUCER, SUBJECT, TITLE */
+/* Those options are AUTHOR, CREATOR, CREATION_DATE, KEYWORDS, PRODUCER,
+ * SUBJECT, TITLE */
 /* See http://gdal.org/frmt_pdf.html documentation. */
 
-static void msTransformToGeospatialPDF(imageObj *img, mapObj *map, cairo_renderer *r)
-{
+static void msTransformToGeospatialPDF(imageObj *img, mapObj *map,
+                                       cairo_renderer *r) {
   GDALDatasetH hDS = NULL;
-  const char* pszGEO_ENCODING = NULL;
+  const char *pszGEO_ENCODING = NULL;
   GDALDriverH hPDFDriver = NULL;
-  const char* pszVirtualIO = NULL;
+  const char *pszVirtualIO = NULL;
   int bVirtualIO = FALSE;
-  char* pszTmpFilename = NULL;
-  VSILFILE* fp = NULL;
+  char *pszTmpFilename = NULL;
+  VSILFILE *fp = NULL;
 
   if (map == NULL)
     return;
@@ -572,7 +569,7 @@ static void msTransformToGeospatialPDF(i
 
   /* When compiled against libpoppler, the PDF driver is VirtualIO capable */
   /* but not, when it is compiled against libpodofo. */
-  pszVirtualIO = GDALGetMetadataItem( hPDFDriver, GDAL_DCAP_VIRTUALIO, NULL );
+  pszVirtualIO = GDALGetMetadataItem(hPDFDriver, GDAL_DCAP_VIRTUALIO, NULL);
   if (pszVirtualIO)
     bVirtualIO = CSLTestBoolean(pszVirtualIO);
 
@@ -592,20 +589,19 @@ static void msTransformToGeospatialPDF(i
   fp = NULL;
 
   hDS = GDALOpen(pszTmpFilename, GA_Update);
-  if ( hDS != NULL ) {
-    char* pszWKT = msProjectionObj2OGCWKT( &(map->projection) );
-    if( pszWKT != NULL ) {
+  if (hDS != NULL) {
+    char *pszWKT = msProjectionObj2OGCWKT(&(map->projection));
+    if (pszWKT != NULL) {
       double adfGeoTransform[6];
       int i;
 
       /* Add user-specified options */
-      for( i = 0; i < img->format->numformatoptions; i++ ) {
-        const char* pszOption = img->format->formatoptions[i];
-        if( strncasecmp(pszOption,"METADATA_ITEM:",14) == 0 ) {
-          char* pszKey = NULL;
-          const char* pszValue = CPLParseNameValue(pszOption + 14,
-                                 &pszKey);
-          if( pszKey != NULL ) {
+      for (i = 0; i < img->format->numformatoptions; i++) {
+        const char *pszOption = img->format->formatoptions[i];
+        if (strncasecmp(pszOption, "METADATA_ITEM:", 14) == 0) {
+          char *pszKey = NULL;
+          const char *pszValue = CPLParseNameValue(pszOption + 14, &pszKey);
+          if (pszKey != NULL) {
             GDALSetMetadataItem(hDS, pszKey, pszValue, NULL);
             CPLFree(pszKey);
           }
@@ -615,12 +611,14 @@ static void msTransformToGeospatialPDF(i
       /* We need to rescale the geotransform because GDAL will not necessary */
       /* open the PDF with the DPI that was used to generate it */
       memcpy(adfGeoTransform, map->gt.geotransform, 6 * sizeof(double));
-      adfGeoTransform[1] = adfGeoTransform[1] * map->width / GDALGetRasterXSize(hDS);
-      adfGeoTransform[5] = adfGeoTransform[5] * map->height / GDALGetRasterYSize(hDS);
+      adfGeoTransform[1] =
+          adfGeoTransform[1] * map->width / GDALGetRasterXSize(hDS);
+      adfGeoTransform[5] =
+          adfGeoTransform[5] * map->height / GDALGetRasterYSize(hDS);
       GDALSetGeoTransform(hDS, adfGeoTransform);
       GDALSetProjection(hDS, pszWKT);
 
-      msFree( pszWKT );
+      msFree(pszWKT);
       pszWKT = NULL;
 
       CPLSetThreadLocalConfigOption("GDAL_PDF_GEO_ENCODING", pszGEO_ENCODING);
@@ -632,7 +630,7 @@ static void msTransformToGeospatialPDF(i
 
       /* We need to replace the buffer with the content of the GDAL file */
       fp = VSIFOpenL(pszTmpFilename, "rb");
-      if( fp != NULL ) {
+      if (fp != NULL) {
         int nFileSize;
 
         VSIFSeekL(fp, 0, SEEK_END);
@@ -641,7 +639,8 @@ static void msTransformToGeospatialPDF(i
         msBufferResize(r->outputStream, nFileSize);
 
         VSIFSeekL(fp, 0, SEEK_SET);
-        r->outputStream->size = VSIFReadL(r->outputStream->data, 1, nFileSize, fp);
+        r->outputStream->size =
+            VSIFReadL(r->outputStream->data, 1, nFileSize, fp);
 
         VSIFCloseL(fp);
         fp = NULL;
@@ -649,7 +648,7 @@ static void msTransformToGeospatialPDF(i
     }
   }
 
-  if ( hDS != NULL )
+  if (hDS != NULL)
     GDALClose(hDS);
 
   VSIUnlink(pszTmpFilename);
@@ -657,55 +656,57 @@ static void msTransformToGeospatialPDF(i
   msFree(pszTmpFilename);
 }
 
-int saveImageCairo(imageObj *img, mapObj *map, FILE *fp, outputFormatObj *format_unused)
-{
+int saveImageCairo(imageObj *img, mapObj *map, FILE *fp,
+                   outputFormatObj *format_unused) {
   (void)format_unused;
   cairo_renderer *r = CAIRO_RENDERER(img);
-  if(!strcasecmp(img->format->driver,"cairo/pdf") || !strcasecmp(img->format->driver,"cairo/svg")) {
-    cairo_surface_finish (r->surface);
+  if (!strcasecmp(img->format->driver, "cairo/pdf") ||
+      !strcasecmp(img->format->driver, "cairo/svg")) {
+    cairo_surface_finish(r->surface);
 
-    if (map != NULL && !strcasecmp(img->format->driver,"cairo/pdf"))
+    if (map != NULL && !strcasecmp(img->format->driver, "cairo/pdf"))
       msTransformToGeospatialPDF(img, map, r);
 
-    msIO_fwrite(r->outputStream->data,r->outputStream->size,1,fp);
+    msIO_fwrite(r->outputStream->data, r->outputStream->size, 1, fp);
   } else {
     /* not supported */
   }
   return MS_SUCCESS;
 }
 
-unsigned char* saveImageBufferCairo(imageObj *img, int *size_ptr, outputFormatObj *format_unused)
-{
+unsigned char *saveImageBufferCairo(imageObj *img, int *size_ptr,
+                                    outputFormatObj *format_unused) {
   (void)format_unused;
   cairo_renderer *r = CAIRO_RENDERER(img);
   unsigned char *data;
-  assert(!strcasecmp(img->format->driver,"cairo/pdf") || !strcasecmp(img->format->driver,"cairo/svg"));
-  cairo_surface_finish (r->surface);
+  assert(!strcasecmp(img->format->driver, "cairo/pdf") ||
+         !strcasecmp(img->format->driver, "cairo/svg"));
+  cairo_surface_finish(r->surface);
   data = msSmallMalloc(r->outputStream->size);
-  memcpy(data,r->outputStream->data,r->outputStream->size);
+  memcpy(data, r->outputStream->data, r->outputStream->size);
   *size_ptr = (int)r->outputStream->size;
   return data;
 }
 
-int renderEllipseSymbolCairo(imageObj *img, double x, double y, symbolObj *symbol,
-                             symbolStyleObj *style)
-{
+int renderEllipseSymbolCairo(imageObj *img, double x, double y,
+                             symbolObj *symbol, symbolStyleObj *style) {
   cairo_renderer *r = CAIRO_RENDERER(img);
 
   cairo_save(r->cr);
   cairo_set_line_cap(r->cr, CAIRO_LINE_CAP_BUTT);
   cairo_set_line_join(r->cr, CAIRO_LINE_JOIN_MITER);
-  cairo_translate(r->cr,x,y);
-  cairo_rotate(r->cr,-style->rotation);
-  cairo_scale(r->cr,symbol->sizex*style->scale/2,symbol->sizey*style->scale/2);
-  cairo_arc (r->cr, 0,0,1, 0, 2 * MS_PI);
+  cairo_translate(r->cr, x, y);
+  cairo_rotate(r->cr, -style->rotation);
+  cairo_scale(r->cr, symbol->sizex * style->scale / 2,
+              symbol->sizey * style->scale / 2);
+  cairo_arc(r->cr, 0, 0, 1, 0, 2 * MS_PI);
   cairo_restore(r->cr);
-  if(style->color) {
+  if (style->color) {
     msCairoSetSourceColor(r->cr, style->color);
     cairo_fill_preserve(r->cr);
   }
-  if(style->outlinewidth > 0) {
-    cairo_set_line_width (r->cr, style->outlinewidth);
+  if (style->outlinewidth > 0) {
+    cairo_set_line_width(r->cr, style->outlinewidth);
     msCairoSetSourceColor(r->cr, style->outlinecolor);
     cairo_stroke_preserve(r->cr);
   }
@@ -713,83 +714,76 @@ int renderEllipseSymbolCairo(imageObj *i
   return MS_SUCCESS;
 }
 
-
-
-int startLayerVectorCairo(imageObj *img, mapObj *map, layerObj *layer)
-{
+int startLayerVectorCairo(imageObj *img, mapObj *map, layerObj *layer) {
   (void)map;
-  if(layer->compositer && layer->compositer->opacity<100) {
+  if (layer->compositer && layer->compositer->opacity < 100) {
     cairo_renderer *r = CAIRO_RENDERER(img);
-    cairo_push_group (r->cr);
+    cairo_push_group(r->cr);
   }
   return MS_SUCCESS;
 }
 
-int closeLayerVectorCairo(imageObj *img, mapObj *map, layerObj *layer)
-{
+int closeLayerVectorCairo(imageObj *img, mapObj *map, layerObj *layer) {
   (void)map;
-  if(layer->compositer && layer->compositer->opacity<100) {
+  if (layer->compositer && layer->compositer->opacity < 100) {
     cairo_renderer *r = CAIRO_RENDERER(img);
-    cairo_pop_group_to_source (r->cr);
-    cairo_paint_with_alpha (r->cr, layer->compositer->opacity*0.01);
+    cairo_pop_group_to_source(r->cr);
+    cairo_paint_with_alpha(r->cr, layer->compositer->opacity * 0.01);
   }
   return MS_SUCCESS;
 }
 
-int startLayerRasterCairo(imageObj *img, mapObj *map, layerObj *layer)
-{
+int startLayerRasterCairo(imageObj *img, mapObj *map, layerObj *layer) {
   (void)img;
   (void)map;
   (void)layer;
   return MS_SUCCESS;
 }
 
-int closeLayerRasterCairo(imageObj *img, mapObj *map, layerObj *layer)
-{
+int closeLayerRasterCairo(imageObj *img, mapObj *map, layerObj *layer) {
   (void)img;
   (void)map;
   (void)layer;
   return MS_SUCCESS;
 }
 
-
-int getRasterBufferHandleCairo(imageObj *img, rasterBufferObj *rb)
-{
+int getRasterBufferHandleCairo(imageObj *img, rasterBufferObj *rb) {
   unsigned char *pb;
   cairo_renderer *r = CAIRO_RENDERER(img);
   rb->type = MS_BUFFER_BYTE_RGBA;
   pb = cairo_image_surface_get_data(r->surface);
   rb->data.rgba.pixels = pb;
   rb->data.rgba.row_step = cairo_image_surface_get_stride(r->surface);
-  rb->data.rgba.pixel_step=4;
+  rb->data.rgba.pixel_step = 4;
   rb->width = cairo_image_surface_get_width(r->surface);
   rb->height = cairo_image_surface_get_height(r->surface);
   rb->data.rgba.r = &(pb[2]);
   rb->data.rgba.g = &(pb[1]);
   rb->data.rgba.b = &(pb[0]);
-  if(r->use_alpha)
+  if (r->use_alpha)
     rb->data.rgba.a = &(pb[3]);
   else
     rb->data.rgba.a = NULL;
   return MS_SUCCESS;
 }
 
-int getRasterBufferCopyCairo(imageObj *img, rasterBufferObj *rb)
-{
+int getRasterBufferCopyCairo(imageObj *img, rasterBufferObj *rb) {
   cairo_renderer *r = CAIRO_RENDERER(img);
   unsigned char *pb;
   rb->type = MS_BUFFER_BYTE_RGBA;
   rb->data.rgba.row_step = cairo_image_surface_get_stride(r->surface);
-  rb->data.rgba.pixel_step=4;
+  rb->data.rgba.pixel_step = 4;
   rb->width = cairo_image_surface_get_width(r->surface);
   rb->height = cairo_image_surface_get_height(r->surface);
-  pb = (unsigned char*)malloc(rb->height * rb->data.rgba.row_step * sizeof(unsigned char));
-  memcpy(pb,cairo_image_surface_get_data(r->surface),rb->height * rb->data.rgba.row_step);
+  pb = (unsigned char *)malloc(rb->height * rb->data.rgba.row_step *
+                               sizeof(unsigned char));
+  memcpy(pb, cairo_image_surface_get_data(r->surface),
+         rb->height * rb->data.rgba.row_step);
   rb->data.rgba.pixels = pb;
   rb->data.rgba.r = &(pb[2]);
   rb->data.rgba.g = &(pb[1]);
   rb->data.rgba.b = &(pb[0]);
-  if(r->use_alpha)
+  if (r->use_alpha)
     rb->data.rgba.a = &(pb[3]);
   else
     rb->data.rgba.a = NULL;
@@ -797,166 +791,167 @@ int getRasterBufferCopyCairo(imageObj *i
 }
 
 static cairo_operator_t ms2cairo_compop(CompositingOperation op) {
-  switch(op) {
-    case MS_COMPOP_CLEAR:
-      return CAIRO_OPERATOR_CLEAR;
-    case MS_COMPOP_SRC:
-      return CAIRO_OPERATOR_SOURCE;
-    case MS_COMPOP_DST:
-      return CAIRO_OPERATOR_DEST;
-    case MS_COMPOP_SRC_OVER:
-      return CAIRO_OPERATOR_OVER;
-    case MS_COMPOP_DST_OVER:
-      return CAIRO_OPERATOR_DEST_OVER;
-    case MS_COMPOP_SRC_IN:
-      return CAIRO_OPERATOR_IN;
-    case MS_COMPOP_DST_IN:
-      return CAIRO_OPERATOR_DEST_IN;
-    case MS_COMPOP_SRC_OUT:
-      return CAIRO_OPERATOR_OUT;
-    case MS_COMPOP_DST_OUT:
-      return CAIRO_OPERATOR_DEST_OUT;
-    case MS_COMPOP_SRC_ATOP:
-      return CAIRO_OPERATOR_ATOP;
-    case MS_COMPOP_DST_ATOP:
-      return CAIRO_OPERATOR_DEST_ATOP;
-    case MS_COMPOP_XOR:
-      return CAIRO_OPERATOR_XOR;
-    case MS_COMPOP_PLUS:
-      return CAIRO_OPERATOR_ADD;
-    case MS_COMPOP_MULTIPLY:
-      return CAIRO_OPERATOR_MULTIPLY;
-    case MS_COMPOP_SCREEN:
-      return CAIRO_OPERATOR_SCREEN;
-    case MS_COMPOP_OVERLAY:
-      return CAIRO_OPERATOR_OVERLAY;
-    case MS_COMPOP_DARKEN:
-      return CAIRO_OPERATOR_DARKEN;
-    case MS_COMPOP_LIGHTEN:
-      return CAIRO_OPERATOR_LIGHTEN;
-    case MS_COMPOP_COLOR_DODGE:
-      return CAIRO_OPERATOR_COLOR_DODGE;
-    case MS_COMPOP_COLOR_BURN:
-      return CAIRO_OPERATOR_COLOR_BURN;
-    case MS_COMPOP_HARD_LIGHT:
-      return CAIRO_OPERATOR_HARD_LIGHT;
-    case MS_COMPOP_SOFT_LIGHT:
-      return CAIRO_OPERATOR_SOFT_LIGHT;
-    case MS_COMPOP_DIFFERENCE:
-      return CAIRO_OPERATOR_DIFFERENCE;
-    case MS_COMPOP_EXCLUSION:
-      return CAIRO_OPERATOR_EXCLUSION;
-    case MS_COMPOP_INVERT:
-    case MS_COMPOP_INVERT_RGB:
-    case MS_COMPOP_MINUS:
-    case MS_COMPOP_CONTRAST:
-    default:
-      return CAIRO_OPERATOR_OVER;
+  switch (op) {
+  case MS_COMPOP_CLEAR:
+    return CAIRO_OPERATOR_CLEAR;
+  case MS_COMPOP_SRC:
+    return CAIRO_OPERATOR_SOURCE;
+  case MS_COMPOP_DST:
+    return CAIRO_OPERATOR_DEST;
+  case MS_COMPOP_SRC_OVER:
+    return CAIRO_OPERATOR_OVER;
+  case MS_COMPOP_DST_OVER:
+    return CAIRO_OPERATOR_DEST_OVER;
+  case MS_COMPOP_SRC_IN:
+    return CAIRO_OPERATOR_IN;
+  case MS_COMPOP_DST_IN:
+    return CAIRO_OPERATOR_DEST_IN;
+  case MS_COMPOP_SRC_OUT:
+    return CAIRO_OPERATOR_OUT;
+  case MS_COMPOP_DST_OUT:
+    return CAIRO_OPERATOR_DEST_OUT;
+  case MS_COMPOP_SRC_ATOP:
+    return CAIRO_OPERATOR_ATOP;
+  case MS_COMPOP_DST_ATOP:
+    return CAIRO_OPERATOR_DEST_ATOP;
+  case MS_COMPOP_XOR:
+    return CAIRO_OPERATOR_XOR;
+  case MS_COMPOP_PLUS:
+    return CAIRO_OPERATOR_ADD;
+  case MS_COMPOP_MULTIPLY:
+    return CAIRO_OPERATOR_MULTIPLY;
+  case MS_COMPOP_SCREEN:
+    return CAIRO_OPERATOR_SCREEN;
+  case MS_COMPOP_OVERLAY:
+    return CAIRO_OPERATOR_OVERLAY;
+  case MS_COMPOP_DARKEN:
+    return CAIRO_OPERATOR_DARKEN;
+  case MS_COMPOP_LIGHTEN:
+    return CAIRO_OPERATOR_LIGHTEN;
+  case MS_COMPOP_COLOR_DODGE:
+    return CAIRO_OPERATOR_COLOR_DODGE;
+  case MS_COMPOP_COLOR_BURN:
+    return CAIRO_OPERATOR_COLOR_BURN;
+  case MS_COMPOP_HARD_LIGHT:
+    return CAIRO_OPERATOR_HARD_LIGHT;
+  case MS_COMPOP_SOFT_LIGHT:
+    return CAIRO_OPERATOR_SOFT_LIGHT;
+  case MS_COMPOP_DIFFERENCE:
+    return CAIRO_OPERATOR_DIFFERENCE;
+  case MS_COMPOP_EXCLUSION:
+    return CAIRO_OPERATOR_EXCLUSION;
+  case MS_COMPOP_INVERT:
+  case MS_COMPOP_INVERT_RGB:
+  case MS_COMPOP_MINUS:
+  case MS_COMPOP_CONTRAST:
+  default:
+    return CAIRO_OPERATOR_OVER;
   }
 }
 
-int cairoCompositeRasterBuffer(imageObj *img, rasterBufferObj *rb, CompositingOperation comp, int opacity) {
+int cairoCompositeRasterBuffer(imageObj *img, rasterBufferObj *rb,
+                               CompositingOperation comp, int opacity) {
   cairo_surface_t *src;
   cairo_renderer *r;
-  if(rb->type != MS_BUFFER_BYTE_RGBA) {
+  if (rb->type != MS_BUFFER_BYTE_RGBA) {
     return MS_FAILURE;
   }
   r = CAIRO_RENDERER(img);
 
-  src = cairo_image_surface_create_for_data(rb->data.rgba.pixels,CAIRO_FORMAT_ARGB32,
-        rb->width,rb->height,
-        rb->data.rgba.row_step);
+  src = cairo_image_surface_create_for_data(rb->data.rgba.pixels,
+                                            CAIRO_FORMAT_ARGB32, rb->width,
+                                            rb->height, rb->data.rgba.row_step);
 
-  cairo_set_source_surface (r->cr,src,0,0);
+  cairo_set_source_surface(r->cr, src, 0, 0);
   cairo_set_operator(r->cr, ms2cairo_compop(comp));
-  cairo_paint_with_alpha(r->cr,opacity/100.0);
+  cairo_paint_with_alpha(r->cr, opacity / 100.0);
   cairo_surface_finish(src);
   cairo_surface_destroy(src);
-  cairo_set_operator(r->cr,CAIRO_OPERATOR_OVER);
+  cairo_set_operator(r->cr, CAIRO_OPERATOR_OVER);
   return MS_SUCCESS;
 }
 
 int mergeRasterBufferCairo(imageObj *img, rasterBufferObj *rb, double opacity,
-                           int srcX, int srcY, int dstX, int dstY,
-                           int width, int height)
-{
+                           int srcX, int srcY, int dstX, int dstY, int width,
+                           int height) {
   cairo_surface_t *src;
   cairo_renderer *r;
   /* not implemented for src,dst,width and height */
-  if(rb->type != MS_BUFFER_BYTE_RGBA) {
+  if (rb->type != MS_BUFFER_BYTE_RGBA) {
     return MS_FAILURE;
   }
   r = CAIRO_RENDERER(img);
 
-  src = cairo_image_surface_create_for_data(rb->data.rgba.pixels,CAIRO_FORMAT_ARGB32,
-        rb->width,rb->height,
-        rb->data.rgba.row_step);
-
-  if(dstX||dstY||srcX||srcY||width!=img->width||height!=img->height) {
-    cairo_set_source_surface (r->cr, src, dstX - srcX, dstY - srcY);
-    cairo_rectangle (r->cr, dstX, dstY, width, height);
-    cairo_fill (r->cr);
+  src = cairo_image_surface_create_for_data(rb->data.rgba.pixels,
+                                            CAIRO_FORMAT_ARGB32, rb->width,
+                                            rb->height, rb->data.rgba.row_step);
+
+  if (dstX || dstY || srcX || srcY || width != img->width ||
+      height != img->height) {
+    cairo_set_source_surface(r->cr, src, dstX - srcX, dstY - srcY);
+    cairo_rectangle(r->cr, dstX, dstY, width, height);
+    cairo_fill(r->cr);
   } else {
-    cairo_set_source_surface (r->cr,src,0,0);
-    cairo_paint_with_alpha(r->cr,opacity);
+    cairo_set_source_surface(r->cr, src, 0, 0);
+    cairo_paint_with_alpha(r->cr, opacity);
   }
   cairo_surface_finish(src);
   cairo_surface_destroy(src);
   return MS_SUCCESS;
 }
 
-
 void freeSVGCache(symbolObj *s) {
 #if defined(USE_SVG_CAIRO) || defined(USE_RSVG)
-      struct svg_symbol_cache *cache = s->renderer_cache;
-      if(!cache) return;
-      assert(cache->svgc);
+  struct svg_symbol_cache *cache = s->renderer_cache;
+  if (!cache)
+    return;
+  assert(cache->svgc);
 #ifdef USE_SVG_CAIRO
-      svg_cairo_destroy(cache->svgc);
+  svg_cairo_destroy(cache->svgc);
 #else
-  #if LIBRSVG_CHECK_VERSION(2,35,0)
-      g_object_unref(cache->svgc);
-  #else
-      rsvg_handle_free(cache->svgc);
-  #endif
-#endif
-      if(cache->pixmap_buffer) {
-        msFreeRasterBuffer(cache->pixmap_buffer);
-        free(cache->pixmap_buffer);
-      }
-      msFree(s->renderer_cache);
-      s->renderer_cache = NULL;
+#if LIBRSVG_CHECK_VERSION(2, 35, 0)
+  g_object_unref(cache->svgc);
+#else
+  rsvg_handle_free(cache->svgc);
+#endif
+#endif
+  if (cache->pixmap_buffer) {
+    msFreeRasterBuffer(cache->pixmap_buffer);
+    free(cache->pixmap_buffer);
+  }
+  msFree(s->renderer_cache);
+  s->renderer_cache = NULL;
 #endif
 }
 
-int freeSymbolCairo(symbolObj *s)
-{
-  if(!s->renderer_cache)
+int freeSymbolCairo(symbolObj *s) {
+  if (!s->renderer_cache)
     return MS_SUCCESS;
-  switch(s->type) {
-    case MS_SYMBOL_VECTOR:
-      cairo_path_destroy(s->renderer_cache);
-      break;
-    case MS_SYMBOL_PIXMAP:
-      cairo_surface_destroy(s->renderer_cache);
-      break;
-    case MS_SYMBOL_SVG:
-      freeSVGCache(s);
-      break;
+  switch (s->type) {
+  case MS_SYMBOL_VECTOR:
+    cairo_path_destroy(s->renderer_cache);
+    break;
+  case MS_SYMBOL_PIXMAP:
+    cairo_surface_destroy(s->renderer_cache);
+    break;
+  case MS_SYMBOL_SVG:
+    freeSVGCache(s);
+    break;
   }
-  s->renderer_cache=NULL;
+  s->renderer_cache = NULL;
   return MS_SUCCESS;
 }
 
-int initializeRasterBufferCairo(rasterBufferObj *rb, int width, int height, int mode)
-{
+int initializeRasterBufferCairo(rasterBufferObj *rb, int width, int height,
+                                int mode) {
   (void)mode;
   rb->type = MS_BUFFER_BYTE_RGBA;
   rb->width = width;
   rb->height = height;
   rb->data.rgba.pixel_step = 4;
   rb->data.rgba.row_step = width * 4;
-  rb->data.rgba.pixels = (unsigned char*)calloc(width*height*4,sizeof(unsigned char));
+  rb->data.rgba.pixels =
+      (unsigned char *)calloc(width * height * 4, sizeof(unsigned char));
   rb->data.rgba.r = &(rb->data.rgba.pixels[2]);
   rb->data.rgba.g = &(rb->data.rgba.pixels[1]);
   rb->data.rgba.b = &(rb->data.rgba.pixels[0]);
@@ -964,19 +959,17 @@ int initializeRasterBufferCairo(rasterBu
   return MS_SUCCESS;
 }
 
-
-int msPreloadSVGSymbol(symbolObj *symbol)
-{
+int msPreloadSVGSymbol(symbolObj *symbol) {
 #if defined(USE_SVG_CAIRO) || defined(USE_RSVG)
   struct svg_symbol_cache *cache;
 
-  if(!symbol->renderer_cache) {
-    cache = msSmallCalloc(1,sizeof(struct svg_symbol_cache));
+  if (!symbol->renderer_cache) {
+    cache = msSmallCalloc(1, sizeof(struct svg_symbol_cache));
     symbol->renderer_free_func = &freeSVGCache;
   } else {
     cache = symbol->renderer_cache;
   }
-  if(cache->svgc)
+  if (cache->svgc)
     return MS_SUCCESS;
 
 #ifdef USE_SVG_CAIRO
@@ -985,17 +978,20 @@ int msPreloadSVGSymbol(symbolObj *symbol
     int status;
     status = svg_cairo_create(&cache->svgc);
     if (status) {
-      msSetError(MS_RENDERERERR, "problem creating cairo svg", "msPreloadSVGSymbol()");
+      msSetError(MS_RENDERERERR, "problem creating cairo svg",
+                 "msPreloadSVGSymbol()");
       return MS_FAILURE;
     }
     status = svg_cairo_parse(cache->svgc, symbol->full_pixmap_path);
     if (status) {
-      msSetError(MS_RENDERERERR, "problem parsing svg symbol", "msPreloadSVGSymbol()");
+      msSetError(MS_RENDERERERR, "problem parsing svg symbol",
+                 "msPreloadSVGSymbol()");
       return MS_FAILURE;
     }
-    svg_cairo_get_size (cache->svgc, &svg_width, &svg_height);
+    svg_cairo_get_size(cache->svgc, &svg_width, &svg_height);
     if (svg_width == 0 || svg_height == 0) {
-      msSetError(MS_RENDERERERR, "problem parsing svg symbol", "msPreloadSVGSymbol()");
+      msSetError(MS_RENDERERERR, "problem parsing svg symbol",
+                 "msPreloadSVGSymbol()");
       return MS_FAILURE;
     }
 
@@ -1004,39 +1000,37 @@ int msPreloadSVGSymbol(symbolObj *symbol
   }
 #else
   {
-    cache->svgc = rsvg_handle_new_from_file(symbol->full_pixmap_path,NULL);
-    if(!cache->svgc) {
-      msSetError(MS_RENDERERERR,"failed to load svg file %s", "msPreloadSVGSymbol()", symbol->full_pixmap_path);
+    cache->svgc = rsvg_handle_new_from_file(symbol->full_pixmap_path, NULL);
+    if (!cache->svgc) {
+      msSetError(MS_RENDERERERR, "failed to load svg file %s",
+                 "msPreloadSVGSymbol()", symbol->full_pixmap_path);
       return MS_FAILURE;
     }
-#if LIBRSVG_CHECK_VERSION(2,46,0)
+#if LIBRSVG_CHECK_VERSION(2, 46, 0)
     /* rsvg_handle_get_dimensions_sub() is deprecated since librsvg 2.46 */
     /* It seems rsvg_handle_get_intrinsic_dimensions() is the best equivalent */
-    /* when the <svg> root node includes a width and height attributes in pixels */
+    /* when the <svg> root node includes a width and height attributes in pixels
+     */
     gboolean has_width = FALSE;
     RsvgLength width = {0, RSVG_UNIT_PX};
     gboolean has_height = FALSE;
     RsvgLength height = {0, RSVG_UNIT_PX};
-    rsvg_handle_get_intrinsic_dimensions(cache->svgc,
-                                         &has_width, &width,
-                                         &has_height, &height,
-                                         NULL, NULL);
-    if( has_width && width.unit == RSVG_UNIT_PX &&
-        has_height && height.unit == RSVG_UNIT_PX )
-    {
-        symbol->sizex = width.length;
-        symbol->sizey = height.length;
-    }
-    else
-    {
-        RsvgRectangle ink_rect = { 0, 0, 0, 0 };
-        rsvg_handle_get_geometry_for_element (cache->svgc, NULL, &ink_rect, NULL, NULL);
-        symbol->sizex = ink_rect.width;
-        symbol->sizey = ink_rect.height;
+    rsvg_handle_get_intrinsic_dimensions(cache->svgc, &has_width, &width,
+                                         &has_height, &height, NULL, NULL);
+    if (has_width && width.unit == RSVG_UNIT_PX && has_height &&
+        height.unit == RSVG_UNIT_PX) {
+      symbol->sizex = width.length;
+      symbol->sizey = height.length;
+    } else {
+      RsvgRectangle ink_rect = {0, 0, 0, 0};
+      rsvg_handle_get_geometry_for_element(cache->svgc, NULL, &ink_rect, NULL,
+                                           NULL);
+      symbol->sizex = ink_rect.width;
+      symbol->sizey = ink_rect.height;
     }
 #else
     RsvgDimensionData dim;
-    rsvg_handle_get_dimensions_sub (cache->svgc, &dim, NULL);
+    rsvg_handle_get_dimensions_sub(cache->svgc, &dim, NULL);
     symbol->sizex = dim.width;
     symbol->sizey = dim.height;
 #endif
@@ -1048,16 +1042,15 @@ int msPreloadSVGSymbol(symbolObj *symbol
   return MS_SUCCESS;
 
 #else
-  msSetError(MS_MISCERR, "SVG Symbols requested but is not built with libsvgcairo",
+  msSetError(MS_MISCERR,
+             "SVG Symbols requested but is not built with libsvgcairo",
              "msPreloadSVGSymbol()");
   return MS_FAILURE;
 #endif
 }
 
-
-
-int msRenderRasterizedSVGSymbol(imageObj *img, double x, double y, symbolObj *symbol, symbolStyleObj *style)
-{
+int msRenderRasterizedSVGSymbol(imageObj *img, double x, double y,
+                                symbolObj *symbol, symbolStyleObj *style) {
 
 #if defined(USE_SVG_CAIRO) || defined(USE_RSVG)
   struct svg_symbol_cache *svg_cache;
@@ -1065,24 +1058,25 @@ int msRenderRasterizedSVGSymbol(imageObj
   symbolObj pixsymbol;
   int status;
 
-  if(MS_SUCCESS != msPreloadSVGSymbol(symbol))
+  if (MS_SUCCESS != msPreloadSVGSymbol(symbol))
     return MS_FAILURE;
-  svg_cache = (struct svg_symbol_cache*) symbol->renderer_cache;
+  svg_cache = (struct svg_symbol_cache *)symbol->renderer_cache;
 
-  //already rendered at the right size and scale? return
-  if(svg_cache->scale != style->scale || svg_cache->rotation != style->rotation) {
+  // already rendered at the right size and scale? return
+  if (svg_cache->scale != style->scale ||
+      svg_cache->rotation != style->rotation) {
     cairo_t *cr;
     cairo_surface_t *surface;
     unsigned char *pb;
     int width, height, surface_w, surface_h;
     /* need to recompute the pixmap */
-    if(svg_cache->pixmap_buffer) {
+    if (svg_cache->pixmap_buffer) {
       msFreeRasterBuffer(svg_cache->pixmap_buffer);
     } else {
-      svg_cache->pixmap_buffer = msSmallCalloc(1,sizeof(rasterBufferObj));
+      svg_cache->pixmap_buffer = msSmallCalloc(1, sizeof(rasterBufferObj));
     }
 
-    //increase pixmap size to accomodate scaling/rotation
+    // increase pixmap size to accomodate scaling/rotation
     if (style->scale != 1.0) {
       width = surface_w = (symbol->sizex * style->scale + 0.5);
       height = surface_h = (symbol->sizey * style->scale + 0.5);
@@ -1094,7 +1088,8 @@ int msRenderRasterizedSVGSymbol(imageObj
       surface_w = surface_h = MS_NINT(MS_MAX(height, width) * 1.415);
     }
 
-    surface = cairo_image_surface_create(CAIRO_FORMAT_ARGB32, surface_w, surface_h);
+    surface =
+        cairo_image_surface_create(CAIRO_FORMAT_ARGB32, surface_w, surface_h);
     cr = cairo_create(surface);
 
     if (style->rotation != 0) {
@@ -1106,23 +1101,24 @@ int msRenderRasterizedSVGSymbol(imageObj
       cairo_scale(cr, style->scale, style->scale);
     }
 #ifdef USE_SVG_CAIRO
-    if(svg_cairo_render(svg_cache->svgc, cr) != SVG_CAIRO_STATUS_SUCCESS) {
+    if (svg_cairo_render(svg_cache->svgc, cr) != SVG_CAIRO_STATUS_SUCCESS) {
       return MS_FAILURE;
     }
 #else
-  rsvg_handle_render_cairo(svg_cache->svgc, cr);
+    rsvg_handle_render_cairo(svg_cache->svgc, cr);
 #endif
     pb = cairo_image_surface_get_data(surface);
 
-    //set up raster
-    initializeRasterBufferCairo(svg_cache->pixmap_buffer, surface_w, surface_h, 0);
-    memcpy(svg_cache->pixmap_buffer->data.rgba.pixels, pb, surface_w * surface_h * 4 * sizeof (unsigned char));
+    // set up raster
+    initializeRasterBufferCairo(svg_cache->pixmap_buffer, surface_w, surface_h,
+                                0);
+    memcpy(svg_cache->pixmap_buffer->data.rgba.pixels, pb,
+           surface_w * surface_h * 4 * sizeof(unsigned char));
     svg_cache->scale = style->scale;
     svg_cache->rotation = style->rotation;
     cairo_destroy(cr);
     cairo_surface_destroy(surface);
   }
-  assert(svg_cache->pixmap_buffer->height && svg_cache->pixmap_buffer->width);
 
   pixstyle = *style;
   pixstyle.rotation = 0.0;
@@ -1131,27 +1127,31 @@ int msRenderRasterizedSVGSymbol(imageObj
   pixsymbol.pixmap_buffer = svg_cache->pixmap_buffer;
   pixsymbol.type = MS_SYMBOL_PIXMAP;
 
-  status = MS_IMAGE_RENDERER(img)->renderPixmapSymbol(img,x,y,&pixsymbol,&pixstyle);
+  if (svg_cache->pixmap_buffer->height && svg_cache->pixmap_buffer->width)
+    status = MS_IMAGE_RENDERER(img)->renderPixmapSymbol(img, x, y, &pixsymbol,
+                                                        &pixstyle);
+  else {
+    msDebug("SVG symbol with too small size to be rendered");
+    status = MS_SUCCESS;
+  }
   MS_IMAGE_RENDERER(img)->freeSymbol(&pixsymbol);
   return status;
 #else
-  msSetError(MS_MISCERR, "SVG Symbols requested but MapServer is not built with libsvgcairo",
-             "renderSVGSymbolCairo()");
+  msSetError(
+      MS_MISCERR,
+      "SVG Symbols requested but MapServer is not built with libsvgcairo",
+      "renderSVGSymbolCairo()");
   return MS_FAILURE;
 #endif
 }
 
-void msCairoCleanup() {
-   cairo_debug_reset_static_data();
-}
+void msCairoCleanup() { cairo_debug_reset_static_data(); }
 
 #endif /*USE_CAIRO*/
 
-
-int msPopulateRendererVTableCairoRaster( rendererVTableObj *renderer )
-{
+int msPopulateRendererVTableCairoRaster(rendererVTableObj *renderer) {
 #ifdef USE_CAIRO
-  renderer->supports_pixel_buffer=1;
+  renderer->supports_pixel_buffer = 1;
   renderer->compositeRasterBuffer = cairoCompositeRasterBuffer;
   renderer->supports_svg = 1;
   renderer->default_transform_mode = MS_TRANSFORM_SIMPLIFY;
@@ -1159,14 +1159,14 @@ int msPopulateRendererVTableCairoRaster(
   renderer->startLayer = startLayerRasterCairo;
   renderer->endLayer = closeLayerRasterCairo;
   renderer->renderLineTiled = NULL;
-  renderer->renderLine=&renderLineCairo;
-  renderer->createImage=&createImageCairo;
-  renderer->saveImage=&saveImageCairo;
-  renderer->getRasterBufferHandle=&getRasterBufferHandleCairo;
-  renderer->getRasterBufferCopy=&getRasterBufferCopyCairo;
-  renderer->renderPolygon=&renderPolygonCairo;
-  renderer->renderGlyphs=&renderGlyphs2Cairo;
-  renderer->freeImage=&freeImageCairo;
+  renderer->renderLine = &renderLineCairo;
+  renderer->createImage = &createImageCairo;
+  renderer->saveImage = &saveImageCairo;
+  renderer->getRasterBufferHandle = &getRasterBufferHandleCairo;
+  renderer->getRasterBufferCopy = &getRasterBufferCopyCairo;
+  renderer->renderPolygon = &renderPolygonCairo;
+  renderer->renderGlyphs = &renderGlyphs2Cairo;
+  renderer->freeImage = &freeImageCairo;
   renderer->renderEllipseSymbol = &renderEllipseSymbolCairo;
   renderer->renderVectorSymbol = &renderVectorSymbolCairo;
   renderer->renderSVGSymbol = &renderSVGSymbolCairo;
@@ -1185,26 +1185,25 @@ int msPopulateRendererVTableCairoRaster(
 #endif
 }
 
-int populateRendererVTableCairoVector( rendererVTableObj *renderer )
-{
+int populateRendererVTableCairoVector(rendererVTableObj *renderer) {
 #ifdef USE_CAIRO
-  renderer->use_imagecache=0;
-  renderer->supports_pixel_buffer=0;
+  renderer->use_imagecache = 0;
+  renderer->supports_pixel_buffer = 0;
   renderer->compositeRasterBuffer = NULL;
   renderer->supports_svg = 1;
   renderer->default_transform_mode = MS_TRANSFORM_SIMPLIFY;
   initializeCache(&MS_RENDERER_CACHE(renderer));
   renderer->startLayer = startLayerVectorCairo;
   renderer->endLayer = closeLayerVectorCairo;
-  renderer->renderLine=&renderLineCairo;
+  renderer->renderLine = &renderLineCairo;
   renderer->renderLineTiled = NULL;
-  renderer->createImage=&createImageCairo;
-  renderer->saveImage=&saveImageCairo;
+  renderer->createImage = &createImageCairo;
+  renderer->saveImage = &saveImageCairo;
   renderer->saveImageBuffer = &saveImageBufferCairo;
-  renderer->getRasterBufferHandle=&getRasterBufferHandleCairo;
-  renderer->renderPolygon=&renderPolygonCairo;
-  renderer->renderGlyphs=&renderGlyphs2Cairo;
-  renderer->freeImage=&freeImageCairo;
+  renderer->getRasterBufferHandle = &getRasterBufferHandleCairo;
+  renderer->renderPolygon = &renderPolygonCairo;
+  renderer->renderGlyphs = &renderGlyphs2Cairo;
+  renderer->freeImage = &freeImageCairo;
   renderer->renderEllipseSymbol = &renderEllipseSymbolCairo;
   renderer->renderVectorSymbol = &renderVectorSymbolCairo;
   renderer->renderSVGSymbol = &renderSVGSymbolCairo;
@@ -1224,12 +1223,9 @@ int populateRendererVTableCairoVector( r
 #endif
 }
 
-int msPopulateRendererVTableCairoSVG( rendererVTableObj *renderer )
-{
+int msPopulateRendererVTableCairoSVG(rendererVTableObj *renderer) {
   return populateRendererVTableCairoVector(renderer);
 }
-int msPopulateRendererVTableCairoPDF( rendererVTableObj *renderer )
-{
+int msPopulateRendererVTableCairoPDF(rendererVTableObj *renderer) {
   return populateRendererVTableCairoVector(renderer);
 }
-
diff -pruN 8.0.1-5/mapchart.c 8.0.2-1/mapchart.c
--- 8.0.1-5/mapchart.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapchart.c	2024-06-11 20:41:34.000000000 +0000
@@ -27,19 +27,19 @@
  * DEALINGS IN THE SOFTWARE.
  ****************************************************************************/
 
-
 #include "mapserver.h"
 
-
-
 #define MS_CHART_TYPE_PIE 1
 #define MS_CHART_TYPE_BAR 2
 #define MS_CHART_TYPE_VBAR 3
 
 /*
-** check if an object of width w and height h placed at point x,y can fit in an image of width mw and height mh
+** check if an object of width w and height h placed at point x,y can fit in an
+*image of width mw and height mh
 */
-#define MS_CHART_FITS(x,y,w,h,mw,mh) (((x)-(w)/2.>0.)&&((x)+(w)/2.<(mw))&&((y)-(h)/2.>0.)&&((y)+(h)/2.)<(mh))
+#define MS_CHART_FITS(x, y, w, h, mw, mh)                                      \
+  (((x) - (w) / 2. > 0.) && ((x) + (w) / 2. < (mw)) &&                         \
+   ((y) - (h) / 2. > 0.) && ((y) + (h) / 2.) < (mh))
 
 /*
 ** find a point on a shape. check if it fits in image
@@ -47,69 +47,85 @@
 **  MS_SUCCESS and point coordinates in 'p' if chart fits in image
 **  MS_FAILURE if no point could be found
 */
-int findChartPoint(mapObj *map, shapeObj *shape, int width, int height, pointObj *center)
-{
-  int middle,numpoints;
-  double invcellsize = 1.0/map->cellsize; /*speed up MAP2IMAGE_X/Y_IC_DBL*/
-  switch(shape->type) {
-    case MS_SHAPE_POINT:
-      center->x=MS_MAP2IMAGE_X_IC_DBL(shape->line[0].point[0].x, map->extent.minx, invcellsize);
-      center->y=MS_MAP2IMAGE_Y_IC_DBL(shape->line[0].point[0].y, map->extent.maxy, invcellsize);
-
-      if(MS_CHART_FITS(center->x,center->y,width,height,map->width,map->height))
-        return MS_SUCCESS;
-      else
-        return MS_FAILURE;
-      break;
-    case MS_SHAPE_LINE:
-      /*loop through line segments starting from middle (alternate between before and after middle point)
-      **first segment that fits is chosen
-      */
-      middle=shape->line[0].numpoints/2; /*start with middle segment of line*/
-      numpoints=shape->line[0].numpoints;
-      if( 1 <= middle ) {
-        int idx=middle+1;
-        if(idx<numpoints) {
-          center->x=(shape->line[0].point[idx-1].x+shape->line[0].point[idx].x)/2.;
-          center->y=(shape->line[0].point[idx-1].y+shape->line[0].point[idx].y)/2.;
-          center->x=MS_MAP2IMAGE_X_IC_DBL(center->x, map->extent.minx, invcellsize);
-          center->y=MS_MAP2IMAGE_Y_IC_DBL(center->y, map->extent.maxy, invcellsize);
+int findChartPoint(mapObj *map, shapeObj *shape, int width, int height,
+                   pointObj *center) {
+  int middle, numpoints;
+  double invcellsize = 1.0 / map->cellsize; /*speed up MAP2IMAGE_X/Y_IC_DBL*/
+  switch (shape->type) {
+  case MS_SHAPE_POINT:
+    center->x = MS_MAP2IMAGE_X_IC_DBL(shape->line[0].point[0].x,
+                                      map->extent.minx, invcellsize);
+    center->y = MS_MAP2IMAGE_Y_IC_DBL(shape->line[0].point[0].y,
+                                      map->extent.maxy, invcellsize);
 
-          if(MS_CHART_FITS(center->x,center->y,width,height,map->width,map->height))
-            return MS_SUCCESS;
-
-          return MS_FAILURE;
-        }
-        idx=middle-1;
-        center->x=(shape->line[0].point[idx].x+shape->line[0].point[idx+1].x)/2;
-        center->y=(shape->line[0].point[idx].y+shape->line[0].point[idx+1].y)/2;
-        center->x=MS_MAP2IMAGE_X_IC_DBL(center->x, map->extent.minx, invcellsize);
-        center->y=MS_MAP2IMAGE_Y_IC_DBL(center->y, map->extent.maxy, invcellsize);
+    if (MS_CHART_FITS(center->x, center->y, width, height, map->width,
+                      map->height))
+      return MS_SUCCESS;
+    else
+      return MS_FAILURE;
+    break;
+  case MS_SHAPE_LINE:
+    /*loop through line segments starting from middle (alternate between before
+     *and after middle point) *first segment that fits is chosen
+     */
+    middle = shape->line[0].numpoints / 2; /*start with middle segment of line*/
+    numpoints = shape->line[0].numpoints;
+    if (1 <= middle) {
+      int idx = middle + 1;
+      if (idx < numpoints) {
+        center->x =
+            (shape->line[0].point[idx - 1].x + shape->line[0].point[idx].x) /
+            2.;
+        center->y =
+            (shape->line[0].point[idx - 1].y + shape->line[0].point[idx].y) /
+            2.;
+        center->x =
+            MS_MAP2IMAGE_X_IC_DBL(center->x, map->extent.minx, invcellsize);
+        center->y =
+            MS_MAP2IMAGE_Y_IC_DBL(center->y, map->extent.maxy, invcellsize);
 
-        if(MS_CHART_FITS(center->x,center->y,width,height,map->width,map->height))
+        if (MS_CHART_FITS(center->x, center->y, width, height, map->width,
+                          map->height))
           return MS_SUCCESS;
+
         return MS_FAILURE;
       }
-      return MS_FAILURE;
-      break;
-    case MS_SHAPE_POLYGON:
-      msPolygonLabelPoint(shape, center, -1);
-      center->x=MS_MAP2IMAGE_X_IC_DBL(center->x, map->extent.minx, invcellsize);
-      center->y=MS_MAP2IMAGE_Y_IC_DBL(center->y, map->extent.maxy, invcellsize);
+      idx = middle - 1;
+      center->x =
+          (shape->line[0].point[idx].x + shape->line[0].point[idx + 1].x) / 2;
+      center->y =
+          (shape->line[0].point[idx].y + shape->line[0].point[idx + 1].y) / 2;
+      center->x =
+          MS_MAP2IMAGE_X_IC_DBL(center->x, map->extent.minx, invcellsize);
+      center->y =
+          MS_MAP2IMAGE_Y_IC_DBL(center->y, map->extent.maxy, invcellsize);
 
-      if(MS_CHART_FITS(center->x,center->y,width,height,map->width,map->height))
+      if (MS_CHART_FITS(center->x, center->y, width, height, map->width,
+                        map->height))
         return MS_SUCCESS;
-      else
-        return MS_FAILURE;
-      break;
-    default:
       return MS_FAILURE;
+    }
+    return MS_FAILURE;
+    break;
+  case MS_SHAPE_POLYGON:
+    msPolygonLabelPoint(shape, center, -1);
+    center->x = MS_MAP2IMAGE_X_IC_DBL(center->x, map->extent.minx, invcellsize);
+    center->y = MS_MAP2IMAGE_Y_IC_DBL(center->y, map->extent.maxy, invcellsize);
+
+    if (MS_CHART_FITS(center->x, center->y, width, height, map->width,
+                      map->height))
+      return MS_SUCCESS;
+    else
+      return MS_FAILURE;
+    break;
+  default:
+    return MS_FAILURE;
   }
 }
 
-int WARN_UNUSED drawRectangle(mapObj *map, imageObj *image, double mx, double my, double Mx, double My,
-                   styleObj *style)
-{
+int WARN_UNUSED drawRectangle(mapObj *map, imageObj *image, double mx,
+                              double my, double Mx, double My,
+                              styleObj *style) {
   shapeObj shape;
   lineObj line;
   pointObj point[5];
@@ -125,56 +141,56 @@ int WARN_UNUSED drawRectangle(mapObj *ma
   /* cppcheck-suppress unreadVariable */
   point[2].y = point[3].y = My;
 
-  return msDrawShadeSymbol(map,image,&shape,style,1.0);
+  return msDrawShadeSymbol(map, image, &shape, style, 1.0);
 }
 
 int WARN_UNUSED msDrawVBarChart(mapObj *map, imageObj *image, pointObj *center,
-                    double *values, styleObj **styles, int numvalues,
-                    double barWidth)
-{
+                                double *values, styleObj **styles,
+                                int numvalues, double barWidth) {
 
   int c;
-  double left,bottom,cur; /*shortcut to pixel boundaries of the chart*/
+  double left, bottom, cur; /*shortcut to pixel boundaries of the chart*/
   double height = 0;
 
-  for(c=0; c<numvalues; c++) {
+  for (c = 0; c < numvalues; c++) {
     height += values[c];
   }
 
-  cur = bottom = center->y+height/2.;
-  left = center->x-barWidth/2.;
+  cur = bottom = center->y + height / 2.;
+  left = center->x - barWidth / 2.;
 
-  for(c=0; c<numvalues; c++) {
-    if(MS_UNLIKELY(MS_FAILURE == drawRectangle(map, image, left, cur, left+barWidth, cur-values[c], styles[c])))
+  for (c = 0; c < numvalues; c++) {
+    if (MS_UNLIKELY(MS_FAILURE == drawRectangle(map, image, left, cur,
+                                                left + barWidth,
+                                                cur - values[c], styles[c])))
       return MS_FAILURE;
     cur -= values[c];
   }
   return MS_SUCCESS;
 }
 
-
 int msDrawBarChart(mapObj *map, imageObj *image, pointObj *center,
                    double *values, styleObj **styles, int numvalues,
-                   double width, double height, double *maxVal, double *minVal, double barWidth)
-{
+                   double width, double height, double *maxVal, double *minVal,
+                   double barWidth) {
 
-  double upperLimit,lowerLimit;
-  double shapeMaxVal,shapeMinVal,pixperval;
+  double upperLimit, lowerLimit;
+  double shapeMaxVal, shapeMinVal, pixperval;
   int c;
-  double vertOrigin,vertOriginClipped,horizStart,y;
-  double left,top,bottom; /*shortcut to pixel boundaries of the chart*/
+  double vertOrigin, vertOriginClipped, horizStart, y;
+  double left, top, bottom; /*shortcut to pixel boundaries of the chart*/
 
-  top=center->y-height/2.;
-  bottom=center->y+height/2.;
-  left=center->x-width/2.;
-
-  shapeMaxVal=shapeMinVal=values[0];
-  for(c=1; c<numvalues; c++) {
-    if(maxVal==NULL || minVal==NULL) { /*compute bounds if not specified*/
-      if(values[c]>shapeMaxVal)
-        shapeMaxVal=values[c];
-      if(values[c]<shapeMinVal)
-        shapeMinVal=values[c];
+  top = center->y - height / 2.;
+  bottom = center->y + height / 2.;
+  left = center->x - width / 2.;
+
+  shapeMaxVal = shapeMinVal = values[0];
+  for (c = 1; c < numvalues; c++) {
+    if (maxVal == NULL || minVal == NULL) { /*compute bounds if not specified*/
+      if (values[c] > shapeMaxVal)
+        shapeMaxVal = values[c];
+      if (values[c] < shapeMinVal)
+        shapeMinVal = values[c];
     }
   }
 
@@ -182,96 +198,106 @@ int msDrawBarChart(mapObj *map, imageObj
    * use specified bounds if wanted
    * if not, always show the origin
    */
-  upperLimit = (maxVal!=NULL)? *maxVal : MS_MAX(shapeMaxVal,0);
-  lowerLimit = (minVal!=NULL)? *minVal : MS_MIN(shapeMinVal,0);
-  if(upperLimit==lowerLimit) {
+  upperLimit = (maxVal != NULL) ? *maxVal : MS_MAX(shapeMaxVal, 0);
+  lowerLimit = (minVal != NULL) ? *minVal : MS_MIN(shapeMinVal, 0);
+  if (upperLimit == lowerLimit) {
     /* treat the case where we would have an unspecified behavior */
-    upperLimit+=0.5;
-    lowerLimit-=0.5;
+    upperLimit += 0.5;
+    lowerLimit -= 0.5;
   }
 
-  pixperval=height/(upperLimit-lowerLimit);
-  vertOrigin=bottom+lowerLimit*pixperval;
-  vertOriginClipped=(vertOrigin<top) ? top :
-                    (vertOrigin>bottom) ? bottom : vertOrigin;
-  horizStart=left;
-  
-  for(c=0; c<numvalues; c++) {
-    double barHeight=values[c]*pixperval;
+  pixperval = height / (upperLimit - lowerLimit);
+  vertOrigin = bottom + lowerLimit * pixperval;
+  vertOriginClipped = (vertOrigin < top)      ? top
+                      : (vertOrigin > bottom) ? bottom
+                                              : vertOrigin;
+  horizStart = left;
+
+  for (c = 0; c < numvalues; c++) {
+    double barHeight = values[c] * pixperval;
     /*clip bars*/
-    y=((vertOrigin-barHeight)<top) ? top :
-      (vertOrigin-barHeight>bottom) ? bottom : vertOrigin-barHeight;
-    if(y!=vertOriginClipped) { /*don't draw bars of height == 0 (i.e. either values==0, or clipped)*/
-      if(values[c]>0) {
-        if(MS_UNLIKELY(MS_FAILURE == drawRectangle(map, image, horizStart, y, horizStart+barWidth-1, vertOriginClipped, styles[c])))
+    y = ((vertOrigin - barHeight) < top)    ? top
+        : (vertOrigin - barHeight > bottom) ? bottom
+                                            : vertOrigin - barHeight;
+    if (y != vertOriginClipped) { /*don't draw bars of height == 0 (i.e. either
+                                     values==0, or clipped)*/
+      if (values[c] > 0) {
+        if (MS_UNLIKELY(MS_FAILURE == drawRectangle(map, image, horizStart, y,
+                                                    horizStart + barWidth - 1,
+                                                    vertOriginClipped,
+                                                    styles[c])))
           return MS_FAILURE;
-      }
-      else {
-        if(MS_UNLIKELY(MS_FAILURE == drawRectangle(map,image, horizStart, vertOriginClipped, horizStart+barWidth-1 , y, styles[c])))
+      } else {
+        if (MS_UNLIKELY(MS_FAILURE ==
+                        drawRectangle(map, image, horizStart, vertOriginClipped,
+                                      horizStart + barWidth - 1, y, styles[c])))
           return MS_FAILURE;
       }
     }
-    horizStart+=barWidth;
+    horizStart += barWidth;
   }
   return MS_SUCCESS;
 }
 
-int WARN_UNUSED msDrawPieChart(mapObj *map, imageObj *image,
-                   pointObj *center, double diameter,
-                   double *values, styleObj **styles, int numvalues)
-{
+int WARN_UNUSED msDrawPieChart(mapObj *map, imageObj *image, pointObj *center,
+                               double diameter, double *values,
+                               styleObj **styles, int numvalues) {
   int i;
-  double dTotal=0.,start=0;
+  double dTotal = 0., start = 0;
 
-  for(i=0; i<numvalues; i++) {
-    if(values[i]<0.) {
-      msSetError(MS_MISCERR, "cannot draw pie charts for negative values", "msDrawPieChart()");
+  for (i = 0; i < numvalues; i++) {
+    if (values[i] < 0.) {
+      msSetError(MS_MISCERR, "cannot draw pie charts for negative values",
+                 "msDrawPieChart()");
       return MS_FAILURE;
     }
-    dTotal+=values[i];
+    dTotal += values[i];
   }
 
-  for(i=0; i < numvalues; i++) {
+  for (i = 0; i < numvalues; i++) {
     double angle = values[i];
-    if(angle==0) continue; /*no need to draw. causes artifacts with outlines*/
-    angle*=360.0/dTotal;
-    if(MS_UNLIKELY(MS_FAILURE == msDrawPieSlice(map ,image, center, styles[i], diameter/2., start, start+angle)))
+    if (angle == 0)
+      continue; /*no need to draw. causes artifacts with outlines*/
+    angle *= 360.0 / dTotal;
+    if (MS_UNLIKELY(MS_FAILURE == msDrawPieSlice(map, image, center, styles[i],
+                                                 diameter / 2., start,
+                                                 start + angle)))
       return MS_FAILURE;
 
-    start+=angle;
+    start += angle;
   }
   return MS_SUCCESS;
 }
 
-int getNextShape(mapObj *map, layerObj *layer, double *values, int *nvalues, styleObj **styles, shapeObj *shape)
-{
+int getNextShape(mapObj *map, layerObj *layer, double *values, int *nvalues,
+                 styleObj **styles, shapeObj *shape) {
   int status;
   int c;
   status = msLayerNextShape(layer, shape);
-  if(status == MS_SUCCESS) {
+  if (status == MS_SUCCESS) {
 
-    if(layer->project)
-    {
-      if( layer->reprojectorLayerToMap == NULL )
-      {
-        layer->reprojectorLayerToMap = msProjectCreateReprojector(
-            &layer->projection, &map->projection);
-        if( layer->reprojectorLayerToMap == NULL )
-        {
-            return MS_FAILURE;
+    if (layer->project) {
+      if (layer->reprojectorLayerToMap == NULL) {
+        layer->reprojectorLayerToMap =
+            msProjectCreateReprojector(&layer->projection, &map->projection);
+        if (layer->reprojectorLayerToMap == NULL) {
+          return MS_FAILURE;
         }
       }
       msProjectShapeEx(layer->reprojectorLayerToMap, shape);
     }
 
-    if(msBindLayerToShape(layer, shape, MS_DRAWMODE_FEATURES|MS_DRAWMODE_LABELS) != MS_SUCCESS)
+    if (msBindLayerToShape(layer, shape,
+                           MS_DRAWMODE_FEATURES | MS_DRAWMODE_LABELS) !=
+        MS_SUCCESS)
       return MS_FAILURE; /* error message is set in msBindLayerToShape() */
 
     *nvalues = 0;
-    for(c=0; c<layer->numclasses; c++) {
-      if(msEvalExpression(layer, shape, &(layer->class[c]->expression), layer->classitemindex) == MS_TRUE) {
-        values[*nvalues]=(layer->class[c]->styles[0]->size);
-        styles[*nvalues]=layer->class[c]->styles[0];
+    for (c = 0; c < layer->numclasses; c++) {
+      if (msEvalExpression(layer, shape, &(layer->class[c] -> expression),
+                           layer->classitemindex) == MS_TRUE) {
+        values[*nvalues] = (layer->class[c] -> styles[0] -> size);
+        styles[*nvalues] = layer->class[c]->styles[0];
         (*nvalues)++;
       }
     }
@@ -280,38 +306,40 @@ int getNextShape(mapObj *map, layerObj *
 }
 
 /* eventually add a class to the layer to get the diameter from an attribute */
-int pieLayerProcessDynamicDiameter(layerObj *layer)
-{
-  const char *chartRangeProcessingKey=NULL;
+int pieLayerProcessDynamicDiameter(layerObj *layer) {
+  const char *chartRangeProcessingKey = NULL;
   char *attrib;
-  double mindiameter=-1, maxdiameter, minvalue, maxvalue;
+  double mindiameter = -1, maxdiameter, minvalue, maxvalue;
   classObj *newclass;
   styleObj *newstyle;
-  const char *chartSizeProcessingKey=msLayerGetProcessingKey( layer,"CHART_SIZE" );
-  if(chartSizeProcessingKey != NULL)
+  const char *chartSizeProcessingKey =
+      msLayerGetProcessingKey(layer, "CHART_SIZE");
+  if (chartSizeProcessingKey != NULL)
     return MS_FALSE;
-  chartRangeProcessingKey=msLayerGetProcessingKey( layer,"CHART_SIZE_RANGE" );
-  if(chartRangeProcessingKey==NULL)
+  chartRangeProcessingKey = msLayerGetProcessingKey(layer, "CHART_SIZE_RANGE");
+  if (chartRangeProcessingKey == NULL)
     return MS_FALSE;
   attrib = msStrdup(chartRangeProcessingKey);
-  char* space = strchr(attrib, ' ');
-  if( space ) {
-      *space = '\0';
-      switch(sscanf(space+1,"%lf %lf %lf %lf",
-                    &mindiameter,&maxdiameter,&minvalue,&maxvalue)) {
-        case 4: /*we have the attribute and the four range values*/
-          break;
-        default:
-          free(attrib);
-          msSetError(MS_MISCERR, "Chart Layer format error for processing key \"CHART_RANGE\"", "msDrawChartLayer()");
-          return MS_FAILURE;
-      }
+  char *space = strchr(attrib, ' ');
+  if (space) {
+    *space = '\0';
+    switch (sscanf(space + 1, "%lf %lf %lf %lf", &mindiameter, &maxdiameter,
+                   &minvalue, &maxvalue)) {
+    case 4: /*we have the attribute and the four range values*/
+      break;
+    default:
+      free(attrib);
+      msSetError(MS_MISCERR,
+                 "Chart Layer format error for processing key \"CHART_RANGE\"",
+                 "msDrawChartLayer()");
+      return MS_FAILURE;
+    }
   }
 
   /*create a new class in the layer containing the wanted attribute
    * as the SIZE of its first STYLE*/
-  newclass=msGrowLayerClasses(layer);
-  if(newclass==NULL) {
+  newclass = msGrowLayerClasses(layer);
+  if (newclass == NULL) {
     free(attrib);
     return MS_FAILURE;
   }
@@ -321,112 +349,117 @@ int pieLayerProcessDynamicDiameter(layer
   /*create and attach a new styleObj to our temp class
    * and bind the wanted attribute to its SIZE
    */
-  newstyle=msGrowClassStyles(newclass);
-  if(newstyle==NULL) {
+  newstyle = msGrowClassStyles(newclass);
+  if (newstyle == NULL) {
     free(attrib);
     return MS_FAILURE;
   }
   initStyle(newstyle);
   newclass->numstyles++;
-  newclass->name=(char*)msStrdup("__MS_SIZE_ATTRIBUTE_");
-  newstyle->bindings[MS_STYLE_BINDING_SIZE].item=msStrdup(attrib);
+  newclass->name = (char *)msStrdup("__MS_SIZE_ATTRIBUTE_");
+  newstyle->bindings[MS_STYLE_BINDING_SIZE].item = msStrdup(attrib);
   newstyle->numbindings++;
   free(attrib);
 
   return MS_TRUE;
-
 }
 
 /* clean up the class added temporarily */
-static void pieLayerCleanupDynamicDiameter(layerObj *layer)
-{
-  if( layer->numclasses > 0 && EQUALN(layer->class[layer->numclasses - 1]->name, "__MS_SIZE_ATTRIBUTE_", 20) ) {
-    classObj *c=msRemoveClass(layer, layer->numclasses - 1);
+static void pieLayerCleanupDynamicDiameter(layerObj *layer) {
+  if (layer->numclasses > 0 &&
+      EQUALN(layer->class[layer->numclasses - 1] -> name,
+             "__MS_SIZE_ATTRIBUTE_", 20)) {
+    classObj *c = msRemoveClass(layer, layer->numclasses - 1);
     freeClass(c);
     msFree(c);
   }
 }
 
-
-int msDrawPieChartLayer(mapObj *map, layerObj *layer, imageObj *image)
-{
-  shapeObj    shape;
-  int         status=MS_SUCCESS;
-  const char *chartRangeProcessingKey=NULL;
-  const char *chartSizeProcessingKey=msLayerGetProcessingKey( layer,"CHART_SIZE" );
-  double diameter=0, mindiameter=-1, maxdiameter=0, minvalue=0, maxvalue=0, exponent=0;
+int msDrawPieChartLayer(mapObj *map, layerObj *layer, imageObj *image) {
+  shapeObj shape;
+  int status = MS_SUCCESS;
+  const char *chartRangeProcessingKey = NULL;
+  const char *chartSizeProcessingKey =
+      msLayerGetProcessingKey(layer, "CHART_SIZE");
+  double diameter = 0, mindiameter = -1, maxdiameter = 0, minvalue = 0,
+         maxvalue = 0, exponent = 0;
   double *values;
   styleObj **styles;
   pointObj center;
-  int numvalues = layer->numclasses; /* the number of classes to represent in the graph */
+  int numvalues =
+      layer->numclasses; /* the number of classes to represent in the graph */
   int numvalues_for_shape = 0;
 
-  if(chartSizeProcessingKey==NULL) {
-    chartRangeProcessingKey=msLayerGetProcessingKey( layer,"CHART_SIZE_RANGE" );
-    if(chartRangeProcessingKey==NULL)
-      diameter=20;
+  if (chartSizeProcessingKey == NULL) {
+    chartRangeProcessingKey =
+        msLayerGetProcessingKey(layer, "CHART_SIZE_RANGE");
+    if (chartRangeProcessingKey == NULL)
+      diameter = 20;
     else {
-      sscanf(chartRangeProcessingKey,"%*s %lf %lf %lf %lf %lf",
-             &mindiameter,&maxdiameter,&minvalue,&maxvalue,&exponent);
+      sscanf(chartRangeProcessingKey, "%*s %lf %lf %lf %lf %lf", &mindiameter,
+             &maxdiameter, &minvalue, &maxvalue, &exponent);
     }
   } else {
-    if(sscanf(chartSizeProcessingKey ,"%lf",&diameter)!=1) {
-      msSetError(MS_MISCERR, "msDrawChart format error for processing key \"CHART_SIZE\"", "msDrawPieChartLayer()");
+    if (sscanf(chartSizeProcessingKey, "%lf", &diameter) != 1) {
+      msSetError(MS_MISCERR,
+                 "msDrawChart format error for processing key \"CHART_SIZE\"",
+                 "msDrawPieChartLayer()");
       return MS_FAILURE;
     }
   }
 
-  layer->project = msProjectionsDiffer(&(layer->projection), &(map->projection));
+  layer->project =
+      msProjectionsDiffer(&(layer->projection), &(map->projection));
 
   /* step through the target shapes */
   msInitShape(&shape);
 
-  values=(double*)calloc(numvalues,sizeof(double));
-  MS_CHECK_ALLOC(values, numvalues*sizeof(double), MS_FAILURE);
-  styles = (styleObj**)malloc((numvalues)*sizeof(styleObj*));
+  values = (double *)calloc(numvalues, sizeof(double));
+  MS_CHECK_ALLOC(values, numvalues * sizeof(double), MS_FAILURE);
+  styles = (styleObj **)malloc((numvalues) * sizeof(styleObj *));
   if (styles == NULL) {
-    msSetError(MS_MEMERR, "%s: %d: Out of memory allocating %u bytes.\n", "msDrawPieChartLayer()",
-               __FILE__, __LINE__, (unsigned int)(numvalues*sizeof(styleObj*)));
+    msSetError(MS_MEMERR, "%s: %d: Out of memory allocating %u bytes.\n",
+               "msDrawPieChartLayer()", __FILE__, __LINE__,
+               (unsigned int)(numvalues * sizeof(styleObj *)));
     free(values);
     return MS_FAILURE;
   }
 
-  while(MS_SUCCESS == getNextShape(map,layer,values,&numvalues_for_shape,styles,&shape)) {
-    if(chartRangeProcessingKey!=NULL)
+  while (MS_SUCCESS == getNextShape(map, layer, values, &numvalues_for_shape,
+                                    styles, &shape)) {
+    if (chartRangeProcessingKey != NULL)
       numvalues_for_shape--;
-    if(numvalues_for_shape == 0) {
+    if (numvalues_for_shape == 0) {
       msFreeShape(&shape);
       continue;
     }
     msDrawStartShape(map, layer, image, &shape);
-    if(chartRangeProcessingKey!=NULL) {
+    if (chartRangeProcessingKey != NULL) {
       diameter = values[numvalues_for_shape];
-      if(mindiameter>=0) {
-        if(diameter<=minvalue)
-          diameter=mindiameter;
-        else if(diameter>=maxvalue)
-          diameter=maxdiameter;
+      if (mindiameter >= 0) {
+        if (diameter <= minvalue)
+          diameter = mindiameter;
+        else if (diameter >= maxvalue)
+          diameter = maxdiameter;
         else {
           if (exponent <= 0)
-            diameter=MS_NINT(
-                       mindiameter+
-                       ((diameter-minvalue)/(maxvalue-minvalue))*
-                       (maxdiameter-mindiameter)
-                     );
+            diameter = MS_NINT(mindiameter +
+                               ((diameter - minvalue) / (maxvalue - minvalue)) *
+                                   (maxdiameter - mindiameter));
           else
-            diameter=MS_NINT(
-                       mindiameter+
-                       pow((diameter-minvalue)/(maxvalue-minvalue),1.0/exponent)*
-                       (maxdiameter-mindiameter)
-                     );
+            diameter = MS_NINT(
+                mindiameter + pow((diameter - minvalue) / (maxvalue - minvalue),
+                                  1.0 / exponent) *
+                                  (maxdiameter - mindiameter));
         }
       }
     }
-    if(findChartPoint(map, &shape, diameter, diameter, &center) == MS_SUCCESS) {
-      status = msDrawPieChart(map,image, &center, diameter,
-                              values,styles,numvalues_for_shape);
+    if (findChartPoint(map, &shape, diameter, diameter, &center) ==
+        MS_SUCCESS) {
+      status = msDrawPieChart(map, image, &center, diameter, values, styles,
+                              numvalues_for_shape);
     }
-    msDrawEndShape(map,layer,image,&shape);
+    msDrawEndShape(map, layer, image, &shape);
     msFreeShape(&shape);
   }
   free(values);
@@ -434,63 +467,68 @@ int msDrawPieChartLayer(mapObj *map, lay
   return status;
 }
 
-int msDrawVBarChartLayer(mapObj *map, layerObj *layer, imageObj *image)
-{
-  shapeObj    shape;
-  int         status=MS_SUCCESS;
-  const char *chartSizeProcessingKey=msLayerGetProcessingKey( layer,"CHART_SIZE" );
-  const char *chartScaleProcessingKey=msLayerGetProcessingKey( layer,"CHART_SCALE" );
-  double barWidth,scale=1.0;
+int msDrawVBarChartLayer(mapObj *map, layerObj *layer, imageObj *image) {
+  shapeObj shape;
+  int status = MS_SUCCESS;
+  const char *chartSizeProcessingKey =
+      msLayerGetProcessingKey(layer, "CHART_SIZE");
+  const char *chartScaleProcessingKey =
+      msLayerGetProcessingKey(layer, "CHART_SCALE");
+  double barWidth, scale = 1.0;
   double *values;
   styleObj **styles;
   pointObj center;
   int numvalues = layer->numclasses;
   int numvalues_for_shape;
-  if(chartSizeProcessingKey==NULL) {
-    barWidth=20;
+  if (chartSizeProcessingKey == NULL) {
+    barWidth = 20;
   } else {
-    if(sscanf(chartSizeProcessingKey ,"%lf",&barWidth) != 1) {
-      msSetError(MS_MISCERR, "msDrawChart format error for processing key \"CHART_SIZE\"", "msDrawVBarChartLayer()");
+    if (sscanf(chartSizeProcessingKey, "%lf", &barWidth) != 1) {
+      msSetError(MS_MISCERR,
+                 "msDrawChart format error for processing key \"CHART_SIZE\"",
+                 "msDrawVBarChartLayer()");
       return MS_FAILURE;
     }
   }
 
-  if(chartScaleProcessingKey) {
-    if(sscanf(chartScaleProcessingKey,"%lf",&scale)!=1) {
-      msSetError(MS_MISCERR, "Error reading value for processing key \"CHART_SCALE\"", "msDrawVBarChartLayer()");
+  if (chartScaleProcessingKey) {
+    if (sscanf(chartScaleProcessingKey, "%lf", &scale) != 1) {
+      msSetError(MS_MISCERR,
+                 "Error reading value for processing key \"CHART_SCALE\"",
+                 "msDrawVBarChartLayer()");
       return MS_FAILURE;
     }
   }
   msInitShape(&shape);
 
-  values=(double*)calloc(numvalues,sizeof(double));
-  MS_CHECK_ALLOC(values, numvalues*sizeof(double), MS_FAILURE);
-  styles = (styleObj**)malloc(numvalues*sizeof(styleObj*));
+  values = (double *)calloc(numvalues, sizeof(double));
+  MS_CHECK_ALLOC(values, numvalues * sizeof(double), MS_FAILURE);
+  styles = (styleObj **)malloc(numvalues * sizeof(styleObj *));
   if (styles == NULL) {
-    msSetError(MS_MEMERR, "%s: %d: Out of memory allocating %u bytes.\n", "msDrawVBarChartLayer()",
-               __FILE__, __LINE__, (unsigned int)(numvalues*sizeof(styleObj*)));
+    msSetError(MS_MEMERR, "%s: %d: Out of memory allocating %u bytes.\n",
+               "msDrawVBarChartLayer()", __FILE__, __LINE__,
+               (unsigned int)(numvalues * sizeof(styleObj *)));
     free(values);
     return MS_FAILURE;
   }
 
-  while(MS_SUCCESS == getNextShape(map,layer,values,&numvalues_for_shape,styles,&shape)) {
+  while (MS_SUCCESS == getNextShape(map, layer, values, &numvalues_for_shape,
+                                    styles, &shape)) {
     int i;
-    double h=0;
-    if(numvalues_for_shape == 0) {
+    double h = 0;
+    if (numvalues_for_shape == 0) {
       continue;
     }
-    for(i=0; i<numvalues_for_shape; i++) {
-      values[i]*=scale;
+    for (i = 0; i < numvalues_for_shape; i++) {
+      values[i] *= scale;
       h += values[i];
     }
     msDrawStartShape(map, layer, image, &shape);
-    if(findChartPoint(map, &shape, barWidth,h, &center)==MS_SUCCESS) {
-      status = msDrawVBarChart(map,image,
-                               &center,
-                               values, styles, numvalues_for_shape,
-                               barWidth);
+    if (findChartPoint(map, &shape, barWidth, h, &center) == MS_SUCCESS) {
+      status = msDrawVBarChart(map, image, &center, values, styles,
+                               numvalues_for_shape, barWidth);
     }
-    msDrawEndShape(map,layer,image,&shape);
+    msDrawEndShape(map, layer, image, &shape);
     msFreeShape(&shape);
   }
   free(values);
@@ -498,84 +536,94 @@ int msDrawVBarChartLayer(mapObj *map, la
   return status;
 }
 
-
-int msDrawBarChartLayer(mapObj *map, layerObj *layer, imageObj *image)
-{
-  shapeObj    shape;
-  int         status=MS_SUCCESS;
-  const char *chartSizeProcessingKey=msLayerGetProcessingKey( layer,"CHART_SIZE" );
-  const char *barMax=msLayerGetProcessingKey( layer,"CHART_BAR_MAXVAL" );
-  const char *barMin=msLayerGetProcessingKey( layer,"CHART_BAR_MINVAL" );
-  double width,height;
+int msDrawBarChartLayer(mapObj *map, layerObj *layer, imageObj *image) {
+  shapeObj shape;
+  int status = MS_SUCCESS;
+  const char *chartSizeProcessingKey =
+      msLayerGetProcessingKey(layer, "CHART_SIZE");
+  const char *barMax = msLayerGetProcessingKey(layer, "CHART_BAR_MAXVAL");
+  const char *barMin = msLayerGetProcessingKey(layer, "CHART_BAR_MINVAL");
+  double width, height;
   double barWidth;
   double *values;
   styleObj **styles;
   pointObj center;
-  double barMaxVal = 0.0,barMinVal = 0.0;
+  double barMaxVal = 0.0, barMinVal = 0.0;
   int numvalues = layer->numclasses;
   int numvalues_for_shape;
-  if(chartSizeProcessingKey==NULL) {
-    width=height=20;
+  if (chartSizeProcessingKey == NULL) {
+    width = height = 20;
   } else {
-    switch(sscanf(chartSizeProcessingKey ,"%lf %lf",&width,&height)) {
-      case 2:
-        break;
-      case 1:
-        height = width;
-        break;
-      default:
-        msSetError(MS_MISCERR, "msDrawChart format error for processing key \"CHART_SIZE\"", "msDrawBarChartLayer()");
-        return MS_FAILURE;
+    switch (sscanf(chartSizeProcessingKey, "%lf %lf", &width, &height)) {
+    case 2:
+      break;
+    case 1:
+      height = width;
+      break;
+    default:
+      msSetError(MS_MISCERR,
+                 "msDrawChart format error for processing key \"CHART_SIZE\"",
+                 "msDrawBarChartLayer()");
+      return MS_FAILURE;
     }
   }
 
-  if(barMax) {
-    if(sscanf(barMax,"%lf",&barMaxVal)!=1) {
-      msSetError(MS_MISCERR, "Error reading value for processing key \"CHART_BAR_MAXVAL\"", "msDrawBarChartLayer()");
+  if (barMax) {
+    if (sscanf(barMax, "%lf", &barMaxVal) != 1) {
+      msSetError(MS_MISCERR,
+                 "Error reading value for processing key \"CHART_BAR_MAXVAL\"",
+                 "msDrawBarChartLayer()");
       return MS_FAILURE;
     }
   }
-  if(barMin) {
-    if(sscanf(barMin,"%lf",&barMinVal)!=1) {
-      msSetError(MS_MISCERR, "Error reading value for processing key \"CHART_BAR_MINVAL\"", "msDrawBarChartLayer()");
+  if (barMin) {
+    if (sscanf(barMin, "%lf", &barMinVal) != 1) {
+      msSetError(MS_MISCERR,
+                 "Error reading value for processing key \"CHART_BAR_MINVAL\"",
+                 "msDrawBarChartLayer()");
       return MS_FAILURE;
     }
   }
-  if(barMin && barMax && barMinVal>=barMaxVal) {
-    msSetError(MS_MISCERR, "\"CHART_BAR_MINVAL\" must be less than \"CHART_BAR_MAXVAL\"", "msDrawBarChartLayer()");
+  if (barMin && barMax && barMinVal >= barMaxVal) {
+    msSetError(MS_MISCERR,
+               "\"CHART_BAR_MINVAL\" must be less than \"CHART_BAR_MAXVAL\"",
+               "msDrawBarChartLayer()");
     return MS_FAILURE;
   }
-  barWidth=(double)width/(double)layer->numclasses;
-  if(!barWidth) {
-    msSetError(MS_MISCERR, "Specified width of chart too small to fit given number of classes", "msDrawBarChartLayer()");
+  barWidth = (double)width / (double)layer->numclasses;
+  if (!barWidth) {
+    msSetError(
+        MS_MISCERR,
+        "Specified width of chart too small to fit given number of classes",
+        "msDrawBarChartLayer()");
     return MS_FAILURE;
   }
 
   msInitShape(&shape);
 
-  values=(double*)calloc(numvalues,sizeof(double));
-  MS_CHECK_ALLOC(values, numvalues*sizeof(double), MS_FAILURE);
-  styles = (styleObj**)malloc(numvalues*sizeof(styleObj*));
+  values = (double *)calloc(numvalues, sizeof(double));
+  MS_CHECK_ALLOC(values, numvalues * sizeof(double), MS_FAILURE);
+  styles = (styleObj **)malloc(numvalues * sizeof(styleObj *));
   if (styles == NULL) {
-    msSetError(MS_MEMERR, "%s: %d: Out of memory allocating %u bytes.\n", "msDrawBarChartLayer()",
-               __FILE__, __LINE__, (unsigned int)(numvalues*sizeof(styleObj*)));
+    msSetError(MS_MEMERR, "%s: %d: Out of memory allocating %u bytes.\n",
+               "msDrawBarChartLayer()", __FILE__, __LINE__,
+               (unsigned int)(numvalues * sizeof(styleObj *)));
     free(values);
     return MS_FAILURE;
   }
 
-  while(MS_SUCCESS == getNextShape(map,layer,values,&numvalues_for_shape,styles,&shape)) {
-    if(numvalues_for_shape == 0 ) continue;
+  while (MS_SUCCESS == getNextShape(map, layer, values, &numvalues_for_shape,
+                                    styles, &shape)) {
+    if (numvalues_for_shape == 0)
+      continue;
     msDrawStartShape(map, layer, image, &shape);
-    if(findChartPoint(map, &shape, width,height, &center)==MS_SUCCESS) {
-      status = msDrawBarChart(map,image,
-                              &center,
-                              values, styles, numvalues_for_shape,
-                              width,height,
-                              (barMax!=NULL)?&barMaxVal:NULL,
-                              (barMin!=NULL)?&barMinVal:NULL,
-                              barWidth);
+    if (findChartPoint(map, &shape, width, height, &center) == MS_SUCCESS) {
+      status = msDrawBarChart(map, image, &center, values, styles,
+                              numvalues_for_shape, width, height,
+                              (barMax != NULL) ? &barMaxVal : NULL,
+                              (barMin != NULL) ? &barMinVal : NULL, barWidth);
     }
-    msDrawEndShape(map,layer,image,&shape);
+    msDrawEndShape(map, layer, image, &shape);
     msFreeShape(&shape);
   }
   free(values);
@@ -586,86 +634,93 @@ int msDrawBarChartLayer(mapObj *map, lay
 /**
  * Generic function to render chart layers.
  */
-int msDrawChartLayer(mapObj *map, layerObj *layer, imageObj *image)
-{
+int msDrawChartLayer(mapObj *map, layerObj *layer, imageObj *image) {
 
-  rectObj     searchrect;
-  const char *chartTypeProcessingKey=msLayerGetProcessingKey( layer,"CHART_TYPE" );
-  int chartType=MS_CHART_TYPE_PIE;
+  rectObj searchrect;
+  const char *chartTypeProcessingKey =
+      msLayerGetProcessingKey(layer, "CHART_TYPE");
+  int chartType = MS_CHART_TYPE_PIE;
   int status = MS_FAILURE;
 
   if (image && map) {
-    if( !(MS_RENDERER_PLUGIN(image->format) )) {
-      msSetError(MS_MISCERR, "chart drawing currently only supports GD and AGG renderers", "msDrawChartLayer()");
+    if (!(MS_RENDERER_PLUGIN(image->format))) {
+      msSetError(MS_MISCERR,
+                 "chart drawing currently only supports GD and AGG renderers",
+                 "msDrawChartLayer()");
       return MS_FAILURE;
     }
 
-    if(chartTypeProcessingKey!=NULL) {
-      if( strcasecmp(chartTypeProcessingKey,"PIE") == 0 ) {
-        chartType=MS_CHART_TYPE_PIE;
-      } else if( strcasecmp(chartTypeProcessingKey,"BAR") == 0 ) {
-        chartType=MS_CHART_TYPE_BAR;
-      } else if( strcasecmp(chartTypeProcessingKey,"VBAR") == 0 ) {
-        chartType=MS_CHART_TYPE_VBAR;
+    if (chartTypeProcessingKey != NULL) {
+      if (strcasecmp(chartTypeProcessingKey, "PIE") == 0) {
+        chartType = MS_CHART_TYPE_PIE;
+      } else if (strcasecmp(chartTypeProcessingKey, "BAR") == 0) {
+        chartType = MS_CHART_TYPE_BAR;
+      } else if (strcasecmp(chartTypeProcessingKey, "VBAR") == 0) {
+        chartType = MS_CHART_TYPE_VBAR;
       } else {
-        msSetError(MS_MISCERR,"unknown chart type for processing key \"CHART_TYPE\", must be one of \"PIE\" or \"BAR\"", "msDrawChartLayer()");
+        msSetError(MS_MISCERR,
+                   "unknown chart type for processing key \"CHART_TYPE\", must "
+                   "be one of \"PIE\" or \"BAR\"",
+                   "msDrawChartLayer()");
         return MS_FAILURE;
       }
     }
-    if(chartType == MS_CHART_TYPE_PIE) {
+    if (chartType == MS_CHART_TYPE_PIE) {
       pieLayerProcessDynamicDiameter(layer);
     }
 
     /* open this layer */
     status = msLayerOpen(layer);
-    if(status != MS_SUCCESS) return MS_FAILURE;
+    if (status != MS_SUCCESS)
+      return MS_FAILURE;
 
     status = msLayerWhichItems(layer, MS_FALSE, NULL);
-    if(status != MS_SUCCESS) {
+    if (status != MS_SUCCESS) {
       msLayerClose(layer);
       return MS_FAILURE;
     }
     /* identify target shapes */
-    if(layer->transform == MS_TRUE)
+    if (layer->transform == MS_TRUE)
       searchrect = map->extent;
     else {
       searchrect.minx = searchrect.miny = 0;
-      searchrect.maxx = map->width-1;
-      searchrect.maxy = map->height-1;
+      searchrect.maxx = map->width - 1;
+      searchrect.maxy = map->height - 1;
     }
 
-    if((map->projection.numargs > 0) && (layer->projection.numargs > 0))
-      msProjectRect(&map->projection, &layer->projection, &searchrect); /* project the searchrect to source coords */
+    if ((map->projection.numargs > 0) && (layer->projection.numargs > 0))
+      msProjectRect(&map->projection, &layer->projection,
+                    &searchrect); /* project the searchrect to source coords */
 
     status = msLayerWhichShapes(layer, searchrect, MS_FALSE);
-    if(status == MS_DONE) { /* no overlap */
+    if (status == MS_DONE) { /* no overlap */
       msLayerClose(layer);
-      if(chartType == MS_CHART_TYPE_PIE)
+      if (chartType == MS_CHART_TYPE_PIE)
         pieLayerCleanupDynamicDiameter(layer);
       return MS_SUCCESS;
-    } else if(status != MS_SUCCESS) {
+    } else if (status != MS_SUCCESS) {
       msLayerClose(layer);
-      if(chartType == MS_CHART_TYPE_PIE)
+      if (chartType == MS_CHART_TYPE_PIE)
         pieLayerCleanupDynamicDiameter(layer);
       return MS_FAILURE;
     }
-    switch(chartType) {
-      case MS_CHART_TYPE_PIE:
-        status = msDrawPieChartLayer(map, layer, image);
-        break;
-      case MS_CHART_TYPE_BAR:
-        status = msDrawBarChartLayer(map, layer, image);
-        break;
-      case MS_CHART_TYPE_VBAR:
-        status = msDrawVBarChartLayer(map, layer, image);
-        break;
-      default:
-        return MS_FAILURE;/*shouldn't be here anyways*/
+    switch (chartType) {
+    case MS_CHART_TYPE_PIE:
+      status = msDrawPieChartLayer(map, layer, image);
+      break;
+    case MS_CHART_TYPE_BAR:
+      status = msDrawBarChartLayer(map, layer, image);
+      break;
+    case MS_CHART_TYPE_VBAR:
+      status = msDrawVBarChartLayer(map, layer, image);
+      break;
+    default:
+      return MS_FAILURE; /*shouldn't be here anyways*/
     }
 
     msLayerClose(layer);
 
-    if(chartType == MS_CHART_TYPE_PIE)
+    if (chartType == MS_CHART_TYPE_PIE)
       pieLayerCleanupDynamicDiameter(layer);
   }
   return status;
diff -pruN 8.0.1-5/mapcluster.c 8.0.2-1/mapcluster.c
--- 8.0.1-5/mapcluster.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapcluster.c	2024-06-11 20:41:34.000000000 +0000
@@ -33,36 +33,35 @@
 #include <assert.h>
 #include "mapserver.h"
 
-
-
-
 #ifdef USE_CLUSTER_PLUGIN
 #define USE_CLUSTER_EXTERNAL
 #endif
 
 /* custom attributes provided by this layer data source */
-#define MSCLUSTER_NUMITEMS        3
-#define MSCLUSTER_FEATURECOUNT    "Cluster_FeatureCount"
-#define MSCLUSTER_FEATURECOUNTINDEX   -100
-#define MSCLUSTER_GROUP    "Cluster_Group"
-#define MSCLUSTER_GROUPINDEX   -101
-#define MSCLUSTER_BASEFID    "Cluster_BaseFID"
-#define MSCLUSTER_BASEFIDINDEX   -102
+#define MSCLUSTER_NUMITEMS 3
+#define MSCLUSTER_FEATURECOUNT "Cluster_FeatureCount"
+#define MSCLUSTER_FEATURECOUNTINDEX -100
+#define MSCLUSTER_GROUP "Cluster_Group"
+#define MSCLUSTER_GROUPINDEX -101
+#define MSCLUSTER_BASEFID "Cluster_BaseFID"
+#define MSCLUSTER_BASEFIDINDEX -102
 
 typedef struct cluster_tree_node clusterTreeNode;
 typedef struct cluster_info clusterInfo;
 typedef struct cluster_layer_info msClusterLayerInfo;
 
 /* forward declarations */
-void msClusterLayerCopyVirtualTable(layerVTableObj* vtable);
-static void clusterTreeNodeDestroy(msClusterLayerInfo* layerinfo, clusterTreeNode *node);
+void msClusterLayerCopyVirtualTable(layerVTableObj *vtable);
+static void clusterTreeNodeDestroy(msClusterLayerInfo *layerinfo,
+                                   clusterTreeNode *node);
 
 /* cluster compare func */
-typedef int (*clusterCompareRegionFunc)(clusterInfo* current, clusterInfo* other);
+typedef int (*clusterCompareRegionFunc)(clusterInfo *current,
+                                        clusterInfo *other);
 
 /* quadtree constants */
-#define SPLITRATIO  0.55
-#define TREE_MAX_DEPTH  10
+#define SPLITRATIO 0.55
+#define TREE_MAX_DEPTH 10
 
 /* cluster algorithm */
 #define MSCLUSTER_ALGORITHM_FULL 0
@@ -70,12 +69,12 @@ typedef int (*clusterCompareRegionFunc)(
 
 /* cluster data */
 struct cluster_info {
-  double x;    /* x position of the current point */
-  double y;    /* y position of the current point */
-  double avgx; /* average x positions of this cluster */
-  double avgy; /* average y positions of this cluster */
-  double varx; /* variance of the x positions of this cluster */
-  double vary; /* variance of the y positions of this cluster */
+  double x;       /* x position of the current point */
+  double y;       /* y position of the current point */
+  double avgx;    /* average x positions of this cluster */
+  double avgy;    /* average y positions of this cluster */
+  double varx;    /* variance of the x positions of this cluster */
+  double vary;    /* variance of the y positions of this cluster */
   shapeObj shape; /* current shape */
   rectObj bounds; /* clustering region */
   /* number of the neighbouring shapes */
@@ -84,13 +83,13 @@ struct cluster_info {
   int numcollected;
   int numremoved;
   int index;
-  clusterTreeNode* node;
+  clusterTreeNode *node;
   /* collection of the siblings */
-  clusterInfo* siblings;
+  clusterInfo *siblings;
   /* next shape in the linked list */
-  clusterInfo* next;
+  clusterInfo *next;
   /* current group */
-  char* group;
+  char *group;
   int filter;
 };
 
@@ -102,34 +101,36 @@ struct cluster_tree_node {
   int numshapes;
   int index;
   int position;
-  clusterInfo* shapes;
+  clusterInfo *shapes;
   /* quad tree subnodes */
-  clusterTreeNode* subnode[4];
+  clusterTreeNode *subnode[4];
 };
 
 /* layeinfo */
 struct cluster_layer_info {
   /* array of features (finalized clusters) */
-  clusterInfo* finalized;
-  clusterInfo* finalizedSiblings;
-  clusterInfo* filtered;
+  clusterInfo *finalized;
+  clusterInfo *finalizedSiblings;
+  clusterInfo *filtered;
   int numFeatures;
   int numFinalized;
   int numFinalizedSiblings;
   int numFiltered;
   /* variables for collecting the best cluster and iterating with NextShape */
-  clusterInfo* current;
+  clusterInfo *current;
   /* check whether all shapes should be returned behind a cluster */
   int get_all_shapes;
-  /* check whether the location of the shapes should be preserved (no averaging) */
+  /* check whether the location of the shapes should be preserved (no averaging)
+   */
   int keep_locations;
-  /* the maxdistance and the buffer parameters are specified in map units (scale independent clustering) */
+  /* the maxdistance and the buffer parameters are specified in map units (scale
+   * independent clustering) */
   int use_map_units;
   double rank;
   /* root node of the quad tree */
-  clusterTreeNode* root;
+  clusterTreeNode *root;
   int numNodes;
-  clusterTreeNode* finalizedNodes;
+  clusterTreeNode *finalizedNodes;
   int numFinalizedNodes;
   /* map extent used for building cluster data */
   rectObj searchRect;
@@ -143,12 +144,10 @@ struct cluster_layer_info {
   int algorithm;
 };
 
-
 extern int yyparse(parseObj *p);
 
 /* evaluate the filter expression */
-int msClusterEvaluateFilter(expressionObj* expression, shapeObj *shape)
-{
+int msClusterEvaluateFilter(expressionObj *expression, shapeObj *shape) {
   if (expression->type == MS_EXPRESSION) {
     int status;
     parseObj p;
@@ -161,7 +160,8 @@ int msClusterEvaluateFilter(expressionOb
     status = yyparse(&p);
 
     if (status != 0) {
-      msSetError(MS_PARSEERR, "Failed to parse expression: %s", "msClusterEvaluateFilter", expression->string);
+      msSetError(MS_PARSEERR, "Failed to parse expression: %s",
+                 "msClusterEvaluateFilter", expression->string);
       return 0;
     }
 
@@ -172,58 +172,59 @@ int msClusterEvaluateFilter(expressionOb
 }
 
 /* get the group text when creating the clusters */
-char *msClusterGetGroupText(expressionObj* expression, shapeObj *shape)
-{
-  char *tmpstr=NULL;
-
-  if(expression->string) {
-    switch(expression->type) {
-      case(MS_STRING):
-        tmpstr = msStrdup(expression->string);
-        break;
-      case(MS_EXPRESSION): {
-        int status;
-        parseObj p;
-
-        p.shape = shape;
-        p.expr = expression;
-        p.expr->curtoken = p.expr->tokens; /* reset */
-        p.type = MS_PARSE_TYPE_STRING;
-
-        status = yyparse(&p);
-
-        if (status != 0) {
-          msSetError(MS_PARSEERR, "Failed to process text expression: %s", "msClusterGetGroupText", expression->string);
-          return NULL;
-        }
+char *msClusterGetGroupText(expressionObj *expression, shapeObj *shape) {
+  char *tmpstr = NULL;
 
-        tmpstr = p.result.strval;
-        break;
+  if (expression->string) {
+    switch (expression->type) {
+    case (MS_STRING):
+      tmpstr = msStrdup(expression->string);
+      break;
+    case (MS_EXPRESSION): {
+      int status;
+      parseObj p;
+
+      p.shape = shape;
+      p.expr = expression;
+      p.expr->curtoken = p.expr->tokens; /* reset */
+      p.type = MS_PARSE_TYPE_STRING;
+
+      status = yyparse(&p);
+
+      if (status != 0) {
+        msSetError(MS_PARSEERR, "Failed to process text expression: %s",
+                   "msClusterGetGroupText", expression->string);
+        return NULL;
       }
-      default:
-        break;
+
+      tmpstr = p.result.strval;
+      break;
+    }
+    default:
+      break;
     }
   }
 
-  return(tmpstr);
+  return (tmpstr);
 }
 
-int CompareEllipseRegion(clusterInfo* current, clusterInfo* other)
-{
+int CompareEllipseRegion(clusterInfo *current, clusterInfo *other) {
   if (current->group && other->group && !EQUAL(current->group, other->group))
     return MS_FALSE;
 
   if ((other->x - current->x) * (other->x - current->x) /
-      ((current->bounds.maxx - current->x) * (current->bounds.maxx - current->x)) +
-      (other->y - current->y) * (other->y - current->y) /
-      ((current->bounds.maxy - current->y) * (current->bounds.maxy - current->y)) > 1)
+              ((current->bounds.maxx - current->x) *
+               (current->bounds.maxx - current->x)) +
+          (other->y - current->y) * (other->y - current->y) /
+              ((current->bounds.maxy - current->y) *
+               (current->bounds.maxy - current->y)) >
+      1)
     return MS_FALSE;
 
   return MS_TRUE;
 }
 
-int CompareRectangleRegion(clusterInfo* current, clusterInfo* other)
-{
+int CompareRectangleRegion(clusterInfo *current, clusterInfo *other) {
   if (current->group && other->group && !EQUAL(current->group, other->group))
     return MS_FALSE;
 
@@ -239,8 +240,7 @@ int CompareRectangleRegion(clusterInfo*
   return MS_TRUE;
 }
 
-static void treeSplitBounds( rectObj *in, rectObj *out1, rectObj *out2)
-{
+static void treeSplitBounds(rectObj *in, rectObj *out1, rectObj *out2) {
   double range;
 
   /* -------------------------------------------------------------------- */
@@ -253,7 +253,7 @@ static void treeSplitBounds( rectObj *in
   /* -------------------------------------------------------------------- */
   /*      Split in X direction.                                           */
   /* -------------------------------------------------------------------- */
-  if((in->maxx - in->minx) > (in->maxy - in->miny)) {
+  if ((in->maxx - in->minx) > (in->maxy - in->miny)) {
     range = in->maxx - in->minx;
 
     out1->maxx = in->minx + range * SPLITRATIO;
@@ -272,9 +272,8 @@ static void treeSplitBounds( rectObj *in
 }
 
 /* alloc memory for a new tentative cluster */
-static clusterInfo *clusterInfoCreate(msClusterLayerInfo* layerinfo)
-{
-  clusterInfo* feature = (clusterInfo*)msSmallMalloc(sizeof(clusterInfo));
+static clusterInfo *clusterInfoCreate(msClusterLayerInfo *layerinfo) {
+  clusterInfo *feature = (clusterInfo *)msSmallMalloc(sizeof(clusterInfo));
   msInitShape(&feature->shape);
   feature->numsiblings = 0;
   feature->numcollected = 0;
@@ -290,10 +289,10 @@ static clusterInfo *clusterInfoCreate(ms
 }
 
 /* destroy memory of the cluster list */
-static void clusterInfoDestroyList(msClusterLayerInfo* layerinfo, clusterInfo* feature)
-{
-  clusterInfo* s = feature;
-  clusterInfo* next;
+static void clusterInfoDestroyList(msClusterLayerInfo *layerinfo,
+                                   clusterInfo *feature) {
+  clusterInfo *s = feature;
+  clusterInfo *next;
   /* destroy the shapes added to this node */
   while (s) {
     next = s->next;
@@ -309,13 +308,15 @@ static void clusterInfoDestroyList(msClu
 }
 
 /* alloc memory for a new treenode */
-static clusterTreeNode *clusterTreeNodeCreate(msClusterLayerInfo* layerinfo, rectObj rect)
-{
-  clusterTreeNode* node = (clusterTreeNode*)msSmallMalloc(sizeof(clusterTreeNode));
+static clusterTreeNode *clusterTreeNodeCreate(msClusterLayerInfo *layerinfo,
+                                              rectObj rect) {
+  clusterTreeNode *node =
+      (clusterTreeNode *)msSmallMalloc(sizeof(clusterTreeNode));
   node->rect = rect;
   node->numshapes = 0;
   node->shapes = NULL;
-  node->subnode[0] = node->subnode[1] = node->subnode[2] = node->subnode[3] = NULL;
+  node->subnode[0] = node->subnode[1] = node->subnode[2] = node->subnode[3] =
+      NULL;
   node->index = layerinfo->numNodes;
   node->position = 0;
   ++layerinfo->numNodes;
@@ -323,8 +324,8 @@ static clusterTreeNode *clusterTreeNodeC
 }
 
 /* traverse the quadtree and destroy all sub elements */
-static void clusterTreeNodeDestroy(msClusterLayerInfo* layerinfo, clusterTreeNode *node)
-{
+static void clusterTreeNodeDestroy(msClusterLayerInfo *layerinfo,
+                                   clusterTreeNode *node) {
   int i;
   /* destroy the shapes added to this node */
   clusterInfoDestroyList(layerinfo, node->shapes);
@@ -340,10 +341,10 @@ static void clusterTreeNodeDestroy(msClu
 }
 
 /* destroy memory of the cluster finalized list (without recursion) */
-static void clusterTreeNodeDestroyList(msClusterLayerInfo* layerinfo, clusterTreeNode *node)
-{
-  clusterTreeNode* n = node;
-  clusterTreeNode* next;
+static void clusterTreeNodeDestroyList(msClusterLayerInfo *layerinfo,
+                                       clusterTreeNode *node) {
+  clusterTreeNode *n = node;
+  clusterTreeNode *next;
   /* destroy the list of nodes */
   while (n) {
     next = n->subnode[0];
@@ -354,8 +355,7 @@ static void clusterTreeNodeDestroyList(m
   }
 }
 
-void clusterDestroyData(msClusterLayerInfo *layerinfo)
-{
+void clusterDestroyData(msClusterLayerInfo *layerinfo) {
   if (layerinfo->finalized) {
     clusterInfoDestroyList(layerinfo, layerinfo->finalized);
     layerinfo->finalized = NULL;
@@ -391,17 +391,16 @@ void clusterDestroyData(msClusterLayerIn
 
 /* traverse the quadtree to find the neighbouring shapes and update some data
 on the related shapes (when adding a new feature)*/
-static void findRelatedShapes(msClusterLayerInfo* layerinfo,
-                              clusterTreeNode *node, clusterInfo* current)
-{
+static void findRelatedShapes(msClusterLayerInfo *layerinfo,
+                              clusterTreeNode *node, clusterInfo *current) {
   int i;
-  clusterInfo* s;
+  clusterInfo *s;
 
   /* -------------------------------------------------------------------- */
   /*      Does this node overlap the area of interest at all?  If not,    */
   /*      return without adding to the list at all.                       */
   /* -------------------------------------------------------------------- */
-  if(!msRectOverlap(&node->rect, &current->bounds))
+  if (!msRectOverlap(&node->rect, &current->bounds))
     return;
 
   /* Modify the feature count of the related shapes */
@@ -410,25 +409,35 @@ static void findRelatedShapes(msClusterL
     if (layerinfo->fnCompare(current, s)) {
       ++current->numsiblings;
       /* calculating the average positions */
-      current->avgx = (current->avgx * current->numsiblings + s->x) / (current->numsiblings + 1);
-      current->avgy = (current->avgy * current->numsiblings + s->y) / (current->numsiblings + 1);
+      current->avgx = (current->avgx * current->numsiblings + s->x) /
+                      (current->numsiblings + 1);
+      current->avgy = (current->avgy * current->numsiblings + s->y) /
+                      (current->numsiblings + 1);
       /* calculating the variance */
-      current->varx = current->varx * current->numsiblings / (current->numsiblings + 1) +
-                      (s->x - current->avgx) * (s->x - current->avgx) / (current->numsiblings + 1);
-      current->vary = current->vary * current->numsiblings / (current->numsiblings + 1) +
-                      (s->y - current->avgy) * (s->y - current->avgy) / (current->numsiblings + 1);
+      current->varx =
+          current->varx * current->numsiblings / (current->numsiblings + 1) +
+          (s->x - current->avgx) * (s->x - current->avgx) /
+              (current->numsiblings + 1);
+      current->vary =
+          current->vary * current->numsiblings / (current->numsiblings + 1) +
+          (s->y - current->avgy) * (s->y - current->avgy) /
+              (current->numsiblings + 1);
 
       if (layerinfo->fnCompare(s, current)) {
         /* this feature falls into the region of the other as well */
         ++s->numsiblings;
         /* calculating the average positions */
-        s->avgx = (s->avgx * s->numsiblings + current->x) / (s->numsiblings + 1);
-        s->avgy = (s->avgy * s->numsiblings + current->y) / (s->numsiblings + 1);
+        s->avgx =
+            (s->avgx * s->numsiblings + current->x) / (s->numsiblings + 1);
+        s->avgy =
+            (s->avgy * s->numsiblings + current->y) / (s->numsiblings + 1);
         /* calculating the variance */
         s->varx = s->varx * s->numsiblings / (s->numsiblings + 1) +
-                  (current->x - s->avgx) * (current->x - s->avgx) / (s->numsiblings + 1);
+                  (current->x - s->avgx) * (current->x - s->avgx) /
+                      (s->numsiblings + 1);
         s->vary = s->vary * s->numsiblings / (s->numsiblings + 1) +
-                  (current->y - s->avgy) * (current->y - s->avgy) / (s->numsiblings + 1);
+                  (current->y - s->avgy) * (current->y - s->avgy) /
+                      (s->numsiblings + 1);
       }
     }
     s = s->next;
@@ -444,18 +453,18 @@ static void findRelatedShapes(msClusterL
   }
 }
 
-/* traverse the quadtree to find the neighbouring clusters and update data on the cluster*/
-static void findRelatedShapes2(msClusterLayerInfo* layerinfo,
-                              clusterTreeNode *node, clusterInfo* current)
-{
+/* traverse the quadtree to find the neighbouring clusters and update data on
+ * the cluster*/
+static void findRelatedShapes2(msClusterLayerInfo *layerinfo,
+                               clusterTreeNode *node, clusterInfo *current) {
   int i;
-  clusterInfo* s;
-  
+  clusterInfo *s;
+
   /* -------------------------------------------------------------------- */
   /*      Does this node overlap the area of interest at all?  If not,    */
   /*      return without adding to the list at all.                       */
   /* -------------------------------------------------------------------- */
-  if(!msRectOverlap(&node->rect, &current->bounds))
+  if (!msRectOverlap(&node->rect, &current->bounds))
     return;
 
   /* Modify the feature count of the related shapes */
@@ -463,17 +472,17 @@ static void findRelatedShapes2(msCluster
   while (s) {
     if (layerinfo->fnCompare(s, current)) {
       if (layerinfo->rank > 0) {
-        double r = (current->x - s->x) * (current->x - s->x) + (current->y - s->y) * (current->y - s->y);
+        double r = (current->x - s->x) * (current->x - s->x) +
+                   (current->y - s->y) * (current->y - s->y);
         if (r < layerinfo->rank) {
           layerinfo->current = s;
           layerinfo->rank = r;
         }
-      }
-      else {
+      } else {
         /* no rank was specified, return immediately */
         layerinfo->current = s;
         return;
-      }      
+      }
     }
     s = s->next;
   }
@@ -490,16 +499,17 @@ static void findRelatedShapes2(msCluster
 
 /* traverse the quadtree to find the neighbouring shapes and update some data
 on the related shapes (when removing a feature) */
-static void findRelatedShapesRemove(msClusterLayerInfo* layerinfo, clusterTreeNode *node, clusterInfo* current)
-{
+static void findRelatedShapesRemove(msClusterLayerInfo *layerinfo,
+                                    clusterTreeNode *node,
+                                    clusterInfo *current) {
   int i;
-  clusterInfo* s;
+  clusterInfo *s;
 
   /* -------------------------------------------------------------------- */
   /*      Does this node overlap the area of interest at all?  If not,    */
   /*      return without adding to the list at all.                       */
   /* -------------------------------------------------------------------- */
-  if(!msRectOverlap(&node->rect, &current->bounds))
+  if (!msRectOverlap(&node->rect, &current->bounds))
     return;
 
   /* Modify the feature count of the related shapes */
@@ -508,12 +518,16 @@ static void findRelatedShapesRemove(msCl
     if (layerinfo->fnCompare(current, s)) {
       if (s->numsiblings > 0) {
         /* calculating the average positions */
-        s->avgx = (s->avgx * (s->numsiblings + 1) - current->x) / s->numsiblings;
-        s->avgy = (s->avgy * (s->numsiblings + 1) - current->y) / s->numsiblings;
+        s->avgx =
+            (s->avgx * (s->numsiblings + 1) - current->x) / s->numsiblings;
+        s->avgy =
+            (s->avgy * (s->numsiblings + 1) - current->y) / s->numsiblings;
         /* calculating the variance */
-        s->varx = (s->varx - (current->x - s->avgx) * (current->x - s->avgx) / s->numsiblings) *
+        s->varx = (s->varx - (current->x - s->avgx) * (current->x - s->avgx) /
+                                 s->numsiblings) *
                   (s->numsiblings + 1) / s->numsiblings;
-        s->vary = (s->vary - (current->y - s->avgy) * (current->y - s->avgy) / s->numsiblings) *
+        s->vary = (s->vary - (current->y - s->avgy) * (current->y - s->avgy) /
+                                 s->numsiblings) *
                   (s->numsiblings + 1) / s->numsiblings;
         --s->numsiblings;
         ++s->numremoved;
@@ -530,10 +544,9 @@ static void findRelatedShapesRemove(msCl
 }
 
 /* setting the aggregated attributes */
-static void InitShapeAttributes(layerObj* layer, clusterInfo* base)
-{
+static void InitShapeAttributes(layerObj *layer, clusterInfo *base) {
   int i;
-  int* itemindexes = layer->iteminfo;
+  int *itemindexes = layer->iteminfo;
 
   for (i = 0; i < layer->numitems; i++) {
     if (base->shape.numvalues <= i)
@@ -567,10 +580,10 @@ static void InitShapeAttributes(layerObj
 }
 
 /* update the shape attributes (aggregate) */
-static void UpdateShapeAttributes(layerObj* layer, clusterInfo* base, clusterInfo* current)
-{
+static void UpdateShapeAttributes(layerObj *layer, clusterInfo *base,
+                                  clusterInfo *current) {
   int i;
-  int* itemindexes = layer->iteminfo;
+  int *itemindexes = layer->iteminfo;
 
   for (i = 0; i < layer->numitems; i++) {
     if (base->shape.numvalues <= i)
@@ -585,8 +598,8 @@ static void UpdateShapeAttributes(layerO
 
     /* setting the base feature index for each cluster member */
     if (itemindexes[i] == MSCLUSTER_BASEFIDINDEX) {
-        msFree(current->shape.values[i]);
-        current->shape.values[i] = msIntToString(base->shape.index);
+      msFree(current->shape.values[i]);
+      current->shape.values[i] = msIntToString(base->shape.index);
     }
 
     if (current->shape.values[i]) {
@@ -601,7 +614,8 @@ static void UpdateShapeAttributes(layerO
           base->shape.values[i] = msStrdup(current->shape.values[i]);
         }
       } else if (EQUALN(layer->items[i], "Sum:", 4)) {
-        double sum = atof(base->shape.values[i]) + atof(current->shape.values[i]);
+        double sum =
+            atof(base->shape.values[i]) + atof(current->shape.values[i]);
         msFree(base->shape.values[i]);
         base->shape.values[i] = msDoubleToString(sum, MS_FALSE);
       } else if (EQUALN(layer->items[i], "Count:", 6)) {
@@ -613,16 +627,18 @@ static void UpdateShapeAttributes(layerO
   }
 }
 
-static int BuildFeatureAttributes(layerObj* layer, msClusterLayerInfo* layerinfo, shapeObj* shape)
-{
-  char** values;
+static int BuildFeatureAttributes(layerObj *layer,
+                                  msClusterLayerInfo *layerinfo,
+                                  shapeObj *shape) {
+  char **values;
   int i;
-  int* itemindexes = layer->iteminfo;
+  int *itemindexes = layer->iteminfo;
 
   if (layer->numitems == layerinfo->srcLayer.numitems)
-    return MS_SUCCESS; /* we don't have custom attributes, no need to reconstruct the array */
+    return MS_SUCCESS; /* we don't have custom attributes, no need to
+                          reconstruct the array */
 
-  values = msSmallMalloc(sizeof(char*) * (layer->numitems));
+  values = msSmallMalloc(sizeof(char *) * (layer->numitems));
 
   for (i = 0; i < layer->numitems; i++) {
     if (itemindexes[i] == MSCLUSTER_FEATURECOUNTINDEX) {
@@ -647,11 +663,11 @@ static int BuildFeatureAttributes(layerO
 }
 
 /* traverse the quadtree to find the best renking cluster */
-static void findBestCluster(layerObj* layer, msClusterLayerInfo* layerinfo, clusterTreeNode *node)
-{
+static void findBestCluster(layerObj *layer, msClusterLayerInfo *layerinfo,
+                            clusterTreeNode *node) {
   int i;
   double rank;
-  clusterInfo* s = node->shapes;
+  clusterInfo *s = node->shapes;
   while (s) {
     if (s->filter < 0 && layer->cluster.filter.string != NULL) {
       InitShapeAttributes(layer, s);
@@ -665,7 +681,9 @@ static void findBestCluster(layerObj* la
     }
 
     /* calculating the rank */
-    rank = (s->x - s->avgx) * (s->x - s->avgx) + (s->y - s->avgy) * (s->y - s->avgy) /*+ s->varx + s->vary*/ + (double)1/ (1 + s->numsiblings);
+    rank = (s->x - s->avgx) * (s->x - s->avgx) +
+           (s->y - s->avgy) * (s->y - s->avgy) /*+ s->varx + s->vary*/ +
+           (double)1 / (1 + s->numsiblings);
 
     if (rank < layerinfo->rank) {
       layerinfo->current = s;
@@ -682,18 +700,19 @@ static void findBestCluster(layerObj* la
 }
 
 /* adding the shape based on the shape bounds (point) */
-static int treeNodeAddShape(msClusterLayerInfo* layerinfo, clusterTreeNode* node, clusterInfo* shape, int depth)
-{
+static int treeNodeAddShape(msClusterLayerInfo *layerinfo,
+                            clusterTreeNode *node, clusterInfo *shape,
+                            int depth) {
   int i;
 
   /* -------------------------------------------------------------------- */
   /*      If there are subnodes, then consider whether this object        */
   /*      will fit in them.                                               */
   /* -------------------------------------------------------------------- */
-  if( depth > 1 && node->subnode[0] != NULL ) {
-    for(i = 0; i < 4; i++ ) {
-      if( msRectContained(&shape->shape.bounds, &node->subnode[i]->rect)) {
-        return treeNodeAddShape( layerinfo, node->subnode[i], shape, depth-1);
+  if (depth > 1 && node->subnode[0] != NULL) {
+    for (i = 0; i < 4; i++) {
+      if (msRectContained(&shape->shape.bounds, &node->subnode[i]->rect)) {
+        return treeNodeAddShape(layerinfo, node->subnode[i], shape, depth - 1);
       }
     }
   }
@@ -702,7 +721,7 @@ static int treeNodeAddShape(msClusterLay
   /*      Otherwise, consider creating four subnodes if could fit into    */
   /*      them, and adding to the appropriate subnode.                    */
   /* -------------------------------------------------------------------- */
-  else if( depth > 1 && node->subnode[0] == NULL ) {
+  else if (depth > 1 && node->subnode[0] == NULL) {
     rectObj half1, half2, quad1, quad2, quad3, quad4;
     int subnode = -1;
 
@@ -710,13 +729,13 @@ static int treeNodeAddShape(msClusterLay
     treeSplitBounds(&half1, &quad1, &quad2);
     treeSplitBounds(&half2, &quad3, &quad4);
 
-    if(msRectContained(&shape->shape.bounds, &quad1))
+    if (msRectContained(&shape->shape.bounds, &quad1))
       subnode = 0;
-    else if(msRectContained(&shape->shape.bounds, &quad2))
+    else if (msRectContained(&shape->shape.bounds, &quad2))
       subnode = 1;
-    else if(msRectContained(&shape->shape.bounds, &quad3))
+    else if (msRectContained(&shape->shape.bounds, &quad3))
       subnode = 2;
-    else if(msRectContained(&shape->shape.bounds, &quad4))
+    else if (msRectContained(&shape->shape.bounds, &quad4))
       subnode = 3;
 
     if (subnode >= 0) {
@@ -737,7 +756,8 @@ static int treeNodeAddShape(msClusterLay
       node->subnode[3]->position = node->position * 4 + 3;
 
       /* add to subnode */
-      return treeNodeAddShape(layerinfo, node->subnode[subnode], shape, depth-1);
+      return treeNodeAddShape(layerinfo, node->subnode[subnode], shape,
+                              depth - 1);
     }
   }
 
@@ -750,16 +770,17 @@ static int treeNodeAddShape(msClusterLay
   return MS_SUCCESS;
 }
 
-/* collecting the cluster shapes, returns true if this subnode must be removed */
-static int collectClusterShapes(msClusterLayerInfo* layerinfo, clusterTreeNode *node, clusterInfo* current)
-{
+/* collecting the cluster shapes, returns true if this subnode must be removed
+ */
+static int collectClusterShapes(msClusterLayerInfo *layerinfo,
+                                clusterTreeNode *node, clusterInfo *current) {
   int i;
-  clusterInfo* prev = NULL;
-  clusterInfo* s = node->shapes;
+  clusterInfo *prev = NULL;
+  clusterInfo *s = node->shapes;
 
-  if(!msRectOverlap(&node->rect, &current->bounds))
-    return (!node->shapes && !node->subnode[0] && !node->subnode[1]
-            && !node->subnode[2] && !node->subnode[3]);
+  if (!msRectOverlap(&node->rect, &current->bounds))
+    return (!node->shapes && !node->subnode[0] && !node->subnode[1] &&
+            !node->subnode[2] && !node->subnode[3]);
 
   /* removing the shapes from this node if overlap with the cluster */
   while (s) {
@@ -809,7 +830,8 @@ static int collectClusterShapes(msCluste
 
   /* Recurse to subnodes if they exist */
   for (i = 0; i < 4; i++) {
-    if (node->subnode[i] && collectClusterShapes(layerinfo, node->subnode[i], current)) {
+    if (node->subnode[i] &&
+        collectClusterShapes(layerinfo, node->subnode[i], current)) {
       /* placing this empty node to the finalization queue */
       node->subnode[i]->subnode[0] = layerinfo->finalizedNodes;
       layerinfo->finalizedNodes = node->subnode[i];
@@ -819,16 +841,17 @@ static int collectClusterShapes(msCluste
   }
 
   /* returns true is this subnode must be removed */
-  return (!node->shapes && !node->subnode[0] && !node->subnode[1]
-          && !node->subnode[2] && !node->subnode[3]);
+  return (!node->shapes && !node->subnode[0] && !node->subnode[1] &&
+          !node->subnode[2] && !node->subnode[3]);
 }
 
-/* collecting the cluster shapes, returns true if this subnode must be removed */
-static int collectClusterShapes2(layerObj* layer, msClusterLayerInfo* layerinfo, clusterTreeNode *node)
-{
+/* collecting the cluster shapes, returns true if this subnode must be removed
+ */
+static int collectClusterShapes2(layerObj *layer, msClusterLayerInfo *layerinfo,
+                                 clusterTreeNode *node) {
   int i;
-  clusterInfo* current = NULL;
-  clusterInfo* s;
+  clusterInfo *current = NULL;
+  clusterInfo *s;
 
   while (node->shapes) {
     s = node->shapes;
@@ -838,20 +861,20 @@ static int collectClusterShapes2(layerOb
     InitShapeAttributes(layer, s);
 
     if (s->filter) {
-        s->next = layerinfo->finalized;
-        layerinfo->finalized = s;
-        ++layerinfo->numFinalized;
+      s->next = layerinfo->finalized;
+      layerinfo->finalized = s;
+      ++layerinfo->numFinalized;
     } else {
-        /* this shape is filtered */
-        s->next = layerinfo->filtered;
-        layerinfo->filtered = s;
-        ++layerinfo->numFiltered;
+      /* this shape is filtered */
+      s->next = layerinfo->filtered;
+      layerinfo->filtered = s;
+      ++layerinfo->numFiltered;
     }
 
     /* update the parameters of the related shapes if any */
     if (s->siblings) {
       current = s->siblings;
-      while(current) {
+      while (current) {
         UpdateShapeAttributes(layer, s, current);
 
         /* setting the average position to the cluster position */
@@ -875,7 +898,8 @@ static int collectClusterShapes2(layerOb
 
   /* Recurse to subnodes if they exist */
   for (i = 0; i < 4; i++) {
-    if (node->subnode[i] && collectClusterShapes2(layer, layerinfo, node->subnode[i])) {
+    if (node->subnode[i] &&
+        collectClusterShapes2(layer, layerinfo, node->subnode[i])) {
       /* placing this empty node to the finalization queue */
       node->subnode[i]->subnode[0] = layerinfo->finalizedNodes;
       layerinfo->finalizedNodes = node->subnode[i];
@@ -885,18 +909,18 @@ static int collectClusterShapes2(layerOb
   }
 
   /* returns true is this subnode must be removed */
-  return (!node->shapes && !node->subnode[0] && !node->subnode[1]
-          && !node->subnode[2] && !node->subnode[3]);
+  return (!node->shapes && !node->subnode[0] && !node->subnode[1] &&
+          !node->subnode[2] && !node->subnode[3]);
 }
 
-int selectClusterShape(layerObj* layer, long shapeindex)
-{
+int selectClusterShape(layerObj *layer, long shapeindex) {
   int i;
-  clusterInfo* current;
-  msClusterLayerInfo* layerinfo = (msClusterLayerInfo*)layer->layerinfo;
+  clusterInfo *current;
+  msClusterLayerInfo *layerinfo = (msClusterLayerInfo *)layer->layerinfo;
 
   if (!layerinfo) {
-    msSetError(MS_MISCERR, "Layer not open: %s", "selectClusterShape()", layer->name);
+    msSetError(MS_MISCERR, "Layer not open: %s", "selectClusterShape()",
+               layer->name);
     return MS_FAILURE;
   }
 
@@ -912,8 +936,10 @@ int selectClusterShape(layerObj* layer,
   layerinfo->current = current;
 
   if (layerinfo->keep_locations == MS_FALSE) {
-    current->shape.line[0].point[0].x = current->shape.bounds.minx = current->shape.bounds.maxx = current->avgx;
-    current->shape.line[0].point[0].y = current->shape.bounds.miny = current->shape.bounds.maxy = current->avgy;
+    current->shape.line[0].point[0].x = current->shape.bounds.minx =
+        current->shape.bounds.maxx = current->avgx;
+    current->shape.line[0].point[0].y = current->shape.bounds.miny =
+        current->shape.bounds.maxy = current->avgy;
   }
 
   return MS_SUCCESS;
@@ -921,10 +947,10 @@ int selectClusterShape(layerObj* layer,
 
 /* update the parameters from the related shapes */
 #ifdef ms_notused
-static void UpdateClusterParameters(msClusterLayerInfo* layerinfo, clusterTreeNode *node, clusterInfo *shape)
-{
+static void UpdateClusterParameters(msClusterLayerInfo *layerinfo,
+                                    clusterTreeNode *node, clusterInfo *shape) {
   int i;
-  clusterInfo* s = node->shapes;
+  clusterInfo *s = node->shapes;
 
   while (s) {
     if (layerinfo->fnCompare(shape, s)) {
@@ -942,13 +968,13 @@ static void UpdateClusterParameters(msCl
   }
 }
 
-/* check for the validity of the clusters added to the tree (for debug purposes) */
-static int ValidateTree(msClusterLayerInfo* layerinfo, clusterTreeNode *node)
-{
+/* check for the validity of the clusters added to the tree (for debug purposes)
+ */
+static int ValidateTree(msClusterLayerInfo *layerinfo, clusterTreeNode *node) {
   int i;
   int isValid = MS_TRUE;
 
-  clusterInfo* s = node->shapes;
+  clusterInfo *s = node->shapes;
   while (s) {
     double avgx = s->avgx;
     double avgy = s->avgy;
@@ -979,7 +1005,8 @@ static int ValidateTree(msClusterLayerIn
 
   /* Recurse to subnodes if they exist */
   for (i = 0; i < 4; i++) {
-    if (node->subnode[i] && ValidateTree(layerinfo, node->subnode[i]) == MS_FALSE)
+    if (node->subnode[i] &&
+        ValidateTree(layerinfo, node->subnode[i]) == MS_FALSE)
       return MS_FALSE;
   }
 
@@ -989,30 +1016,31 @@ static int ValidateTree(msClusterLayerIn
 #endif
 
 /* rebuild the clusters according to the current extent */
-int RebuildClusters(layerObj *layer, int isQuery)
-{
-  mapObj* map;
-  layerObj* srcLayer;
+int RebuildClusters(layerObj *layer, int isQuery) {
+  mapObj *map;
+  layerObj *srcLayer;
   double distance, maxDistanceX, maxDistanceY, cellSizeX, cellSizeY;
   rectObj searchrect;
   int status;
-  clusterInfo* current;
+  clusterInfo *current;
   int depth;
   const char *pszProcessing;
 #ifdef USE_CLUSTER_EXTERNAL
   int layerIndex;
 #endif
-  reprojectionObj* reprojector = NULL;
+  reprojectionObj *reprojector = NULL;
 
-  msClusterLayerInfo* layerinfo = layer->layerinfo;
+  msClusterLayerInfo *layerinfo = layer->layerinfo;
 
   if (!layerinfo) {
-    msSetError(MS_MISCERR, "Layer is not open: %s", "RebuildClusters()", layer->name);
+    msSetError(MS_MISCERR, "Layer is not open: %s", "RebuildClusters()",
+               layer->name);
     return MS_FAILURE;
   }
 
   if (!layer->map) {
-    msSetError(MS_MISCERR, "No map associated with this layer: %s", "RebuildClusters()", layer->name);
+    msSetError(MS_MISCERR, "No map associated with this layer: %s",
+               "RebuildClusters()", layer->name);
     return MS_FAILURE;
   }
 
@@ -1025,37 +1053,37 @@ int RebuildClusters(layerObj *layer, int
 
   /* check whether the simplified algorithm was selected */
   pszProcessing = msLayerGetProcessingKey(layer, "CLUSTER_ALGORITHM");
-  if(pszProcessing && !strncasecmp(pszProcessing,"SIMPLE",6))
-      layerinfo->algorithm = MSCLUSTER_ALGORITHM_SIMPLE;
+  if (pszProcessing && !strncasecmp(pszProcessing, "SIMPLE", 6))
+    layerinfo->algorithm = MSCLUSTER_ALGORITHM_SIMPLE;
   else
-      layerinfo->algorithm = MSCLUSTER_ALGORITHM_FULL;
+    layerinfo->algorithm = MSCLUSTER_ALGORITHM_FULL;
 
   /* check whether all shapes should be returned from a query */
-  if(msLayerGetProcessingKey(layer, "CLUSTER_GET_ALL_SHAPES") != NULL)
+  if (msLayerGetProcessingKey(layer, "CLUSTER_GET_ALL_SHAPES") != NULL)
     layerinfo->get_all_shapes = MS_TRUE;
   else
     layerinfo->get_all_shapes = MS_FALSE;
 
   /* check whether the location of the shapes should be preserved */
-  if(msLayerGetProcessingKey(layer, "CLUSTER_KEEP_LOCATIONS") != NULL)
+  if (msLayerGetProcessingKey(layer, "CLUSTER_KEEP_LOCATIONS") != NULL)
     layerinfo->keep_locations = MS_TRUE;
   else
-    layerinfo->keep_locations = MS_FALSE; 
+    layerinfo->keep_locations = MS_FALSE;
 
-  /* check whether the maxdistance and the buffer parameters 
+  /* check whether the maxdistance and the buffer parameters
   are specified in map units (scale independent clustering) */
-  if(msLayerGetProcessingKey(layer, "CLUSTER_USE_MAP_UNITS") != NULL)
+  if (msLayerGetProcessingKey(layer, "CLUSTER_USE_MAP_UNITS") != NULL)
     layerinfo->use_map_units = MS_TRUE;
   else
     layerinfo->use_map_units = MS_FALSE;
 
   /* identify the current extent */
-  if(layer->transform == MS_TRUE)
+  if (layer->transform == MS_TRUE)
     searchrect = map->extent;
   else {
     searchrect.minx = searchrect.miny = 0;
-    searchrect.maxx = map->width-1;
-    searchrect.maxy = map->height-1;
+    searchrect.maxx = map->width - 1;
+    searchrect.maxy = map->height - 1;
   }
 
   if (searchrect.minx == layerinfo->searchRect.minx &&
@@ -1072,8 +1100,9 @@ int RebuildClusters(layerObj *layer, int
   layerinfo->searchRect = searchrect;
 
   /* reproject the rectangle to layer coordinates */
-  if((map->projection.numargs > 0) && (layer->projection.numargs > 0))
-    msProjectRect(&map->projection, &layer->projection, &searchrect); /* project the searchrect to source coords */
+  if ((map->projection.numargs > 0) && (layer->projection.numargs > 0))
+    msProjectRect(&map->projection, &layer->projection,
+                  &searchrect); /* project the searchrect to source coords */
 
   /* determine the compare method */
   layerinfo->fnCompare = CompareRectangleRegion;
@@ -1086,15 +1115,17 @@ int RebuildClusters(layerObj *layer, int
   depth = 0;
   distance = layer->cluster.maxdistance;
   if (layerinfo->use_map_units == MS_TRUE) {
-    while ((distance < (searchrect.maxx - searchrect.minx) || distance < (searchrect.maxy - searchrect.miny)) && depth <= TREE_MAX_DEPTH) {
+    while ((distance < (searchrect.maxx - searchrect.minx) ||
+            distance < (searchrect.maxy - searchrect.miny)) &&
+           depth <= TREE_MAX_DEPTH) {
       distance *= 2;
       ++depth;
     }
     cellSizeX = 1;
     cellSizeY = 1;
-  }
-  else {
-    while ((distance < map->width || distance < map->height) && depth <= TREE_MAX_DEPTH) {
+  } else {
+    while ((distance < map->width || distance < map->height) &&
+           depth <= TREE_MAX_DEPTH) {
       distance *= 2;
       ++depth;
     }
@@ -1107,7 +1138,8 @@ int RebuildClusters(layerObj *layer, int
   maxDistanceX = layer->cluster.maxdistance * cellSizeX;
   maxDistanceY = layer->cluster.maxdistance * cellSizeY;
 
-  /* increase the search rectangle so that the neighbouring shapes are also retrieved */
+  /* increase the search rectangle so that the neighbouring shapes are also
+   * retrieved */
   searchrect.minx -= layer->cluster.buffer * cellSizeX;
   searchrect.maxx += layer->cluster.buffer * cellSizeX;
   searchrect.miny -= layer->cluster.buffer * cellSizeY;
@@ -1122,28 +1154,31 @@ int RebuildClusters(layerObj *layer, int
 
   /* start retrieving the shapes */
   status = msLayerWhichShapes(srcLayer, searchrect, isQuery);
-  if(status == MS_DONE) {
+  if (status == MS_DONE) {
     /* no overlap */
     return MS_SUCCESS;
-  } else if(status != MS_SUCCESS) {
+  } else if (status != MS_SUCCESS) {
     return MS_FAILURE;
   }
 
-  /* step through the source shapes and populate the quadtree with the tentative clusters */
+  /* step through the source shapes and populate the quadtree with the tentative
+   * clusters */
   if ((current = clusterInfoCreate(layerinfo)) == NULL)
     return MS_FAILURE;
 
 #if defined(USE_CLUSTER_EXTERNAL)
-    if(srcLayer->transform == MS_TRUE && srcLayer->project && layer->transform == MS_TRUE && layer->project &&msProjectionsDiffer(&(srcLayer->projection), &(layer->projection)))
-    {
-        reprojector = msProjectCreateReprojector(&srcLayer->projection, &layer->projection);
-    }
+  if (srcLayer->transform == MS_TRUE && srcLayer->project &&
+      layer->transform == MS_TRUE && layer->project &&
+      msProjectionsDiffer(&(srcLayer->projection), &(layer->projection))) {
+    reprojector =
+        msProjectCreateReprojector(&srcLayer->projection, &layer->projection);
+  }
 #endif
-  
-  while((status = msLayerNextShape(srcLayer, &current->shape)) == MS_SUCCESS) {
+
+  while ((status = msLayerNextShape(srcLayer, &current->shape)) == MS_SUCCESS) {
 #if defined(USE_CLUSTER_EXTERNAL)
     /* transform the shape to the projection of this layer */
-    if( reprojector )
+    if (reprojector)
       msProjectShapeEx(reprojector, &current->shape);
 #endif
     /* set up positions and variance */
@@ -1157,11 +1192,12 @@ int RebuildClusters(layerObj *layer, int
     current->bounds.maxy = current->y + maxDistanceY;
 
     /* if the shape doesn't overlap we must skip it to avoid further issues */
-    if(!msRectOverlap(&searchrect, &current->bounds)) {
+    if (!msRectOverlap(&searchrect, &current->bounds)) {
       msFreeShape(&current->shape);
       msInitShape(&current->shape);
 
-      msDebug("Skipping an invalid shape falling outside of the given extent\n");
+      msDebug(
+          "Skipping an invalid shape falling outside of the given extent\n");
       continue;
     }
 
@@ -1171,20 +1207,21 @@ int RebuildClusters(layerObj *layer, int
 
     /* evaluate the group expression */
     if (layer->cluster.group.string)
-      current->group = msClusterGetGroupText(&layer->cluster.group, &current->shape);
+      current->group =
+          msClusterGetGroupText(&layer->cluster.group, &current->shape);
 
     if (layerinfo->algorithm == MSCLUSTER_ALGORITHM_FULL) {
       /*start a query for the related shapes */
       findRelatedShapes(layerinfo, layerinfo->root, current);
 
       /* add this shape to the tree */
-      if (treeNodeAddShape(layerinfo, layerinfo->root, current, depth) != MS_SUCCESS) {
+      if (treeNodeAddShape(layerinfo, layerinfo->root, current, depth) !=
+          MS_SUCCESS) {
         clusterInfoDestroyList(layerinfo, current);
         msProjectDestroyReprojector(reprojector);
         return MS_FAILURE;
       }
-    }
-    else if (layerinfo->algorithm == MSCLUSTER_ALGORITHM_SIMPLE) {
+    } else if (layerinfo->algorithm == MSCLUSTER_ALGORITHM_SIMPLE) {
       /* find a related cluster and try to assign */
       layerinfo->rank = 0;
       layerinfo->current = NULL;
@@ -1193,10 +1230,10 @@ int RebuildClusters(layerObj *layer, int
         /* store these points until all clusters are created */
         current->next = layerinfo->finalizedSiblings;
         layerinfo->finalizedSiblings = current;
-      }
-      else {
+      } else {
         /* if not found add this shape as a new cluster */
-        if (treeNodeAddShape(layerinfo, layerinfo->root, current, depth) != MS_SUCCESS) {
+        if (treeNodeAddShape(layerinfo, layerinfo->root, current, depth) !=
+            MS_SUCCESS) {
           clusterInfoDestroyList(layerinfo, current);
           msProjectDestroyReprojector(reprojector);
           return MS_FAILURE;
@@ -1224,12 +1261,15 @@ int RebuildClusters(layerObj *layer, int
 
       /* pick up the best cluster from the tree and do the finalization */
       /* the initial rank must be big enough */
-      layerinfo->rank = (searchrect.maxx - searchrect.minx) * (searchrect.maxx - searchrect.minx) +
-                        (searchrect.maxy - searchrect.miny) * (searchrect.maxy - searchrect.miny) + 1;
-      
+      layerinfo->rank = (searchrect.maxx - searchrect.minx) *
+                            (searchrect.maxx - searchrect.minx) +
+                        (searchrect.maxy - searchrect.miny) *
+                            (searchrect.maxy - searchrect.miny) +
+                        1;
+
       layerinfo->current = NULL;
       findBestCluster(layer, layerinfo, layerinfo->root);
-      
+
       if (layerinfo->current == NULL) {
         if (layer->debug >= MS_DEBUGLEVEL_VVV)
           msDebug("Clustering terminated.\n");
@@ -1238,18 +1278,23 @@ int RebuildClusters(layerObj *layer, int
 
       /* Update the feature count of the shape */
       InitShapeAttributes(layer, layerinfo->current);
-      
+
       /* collecting the shapes of the cluster */
       collectClusterShapes(layerinfo, layerinfo->root, layerinfo->current);
 
       if (layer->debug >= MS_DEBUGLEVEL_VVV) {
-        msDebug("processing cluster %p: rank=%lf fcount=%d ncoll=%d nfin=%d nfins=%d nflt=%d bounds={%lf %lf %lf %lf}\n", layerinfo->current, layerinfo->rank, layerinfo->current->numsiblings + 1,
-              layerinfo->current->numcollected, layerinfo->numFinalized, layerinfo->numFinalizedSiblings,
-              layerinfo->numFiltered, layerinfo->current->bounds.minx, layerinfo->current->bounds.miny,
-              layerinfo->current->bounds.maxx, layerinfo->current->bounds.maxy);
+        msDebug(
+            "processing cluster %p: rank=%lf fcount=%d ncoll=%d nfin=%d "
+            "nfins=%d nflt=%d bounds={%lf %lf %lf %lf}\n",
+            layerinfo->current, layerinfo->rank,
+            layerinfo->current->numsiblings + 1,
+            layerinfo->current->numcollected, layerinfo->numFinalized,
+            layerinfo->numFinalizedSiblings, layerinfo->numFiltered,
+            layerinfo->current->bounds.minx, layerinfo->current->bounds.miny,
+            layerinfo->current->bounds.maxx, layerinfo->current->bounds.maxy);
         if (layerinfo->current->node) {
           char pszBuffer[TREE_MAX_DEPTH + 1];
-          clusterTreeNode* node = layerinfo->current->node;
+          clusterTreeNode *node = layerinfo->current->node;
           int position = node->position;
           int i = 1;
           while (position > 0 && i <= TREE_MAX_DEPTH) {
@@ -1258,11 +1303,14 @@ int RebuildClusters(layerObj *layer, int
             ++i;
           }
           pszBuffer[TREE_MAX_DEPTH] = 0;
-        
-          msDebug(" ->node %p: count=%d index=%d pos=%s subn={%p %p %p %p} rect={%lf %lf %lf %lf}\n",
-                  node, node->numshapes, node->index, pszBuffer + TREE_MAX_DEPTH - i + 1,
-                  node->subnode[0], node->subnode[1], node->subnode[2], node->subnode[3],
-                node->rect.minx, node->rect.miny, node->rect.maxx, node->rect.maxy);
+
+          msDebug(" ->node %p: count=%d index=%d pos=%s subn={%p %p %p %p} "
+                  "rect={%lf %lf %lf %lf}\n",
+                  node, node->numshapes, node->index,
+                  pszBuffer + TREE_MAX_DEPTH - i + 1, node->subnode[0],
+                  node->subnode[1], node->subnode[2], node->subnode[3],
+                  node->rect.minx, node->rect.miny, node->rect.maxx,
+                  node->rect.maxy);
         }
       }
 
@@ -1275,7 +1323,7 @@ int RebuildClusters(layerObj *layer, int
       if (layerinfo->current->numsiblings > 0) {
         /* update the parameters due to the shape removal */
         findRelatedShapesRemove(layerinfo, layerinfo->root, layerinfo->current);
-  
+
         if (layerinfo->current->filter == 0) {
           /* filtered shapes has no siblings */
           layerinfo->current->numsiblings = 0;
@@ -1286,7 +1334,7 @@ int RebuildClusters(layerObj *layer, int
         /* update the parameters of the related shapes if any */
         if (layerinfo->finalizedSiblings) {
           current = layerinfo->finalizedSiblings;
-          while(current) {
+          while (current) {
             /* update the parameters due to the shape removal */
             findRelatedShapesRemove(layerinfo, layerinfo->root, current);
             UpdateShapeAttributes(layer, layerinfo->current, current);
@@ -1305,7 +1353,7 @@ int RebuildClusters(layerObj *layer, int
                 current->next = layerinfo->finalized;
                 layerinfo->finalized = layerinfo->finalizedSiblings;
               } else {
-              /* preserve the clustered siblings for later use */
+                /* preserve the clustered siblings for later use */
                 layerinfo->current->siblings = layerinfo->finalizedSiblings;
               }
               break;
@@ -1332,32 +1380,31 @@ int RebuildClusters(layerObj *layer, int
       }
 #endif
     }
-  }
-  else if (layerinfo->algorithm == MSCLUSTER_ALGORITHM_SIMPLE) {
+  } else if (layerinfo->algorithm == MSCLUSTER_ALGORITHM_SIMPLE) {
     /* assingn stired points to clusters */
     while (layerinfo->finalizedSiblings) {
       current = layerinfo->finalizedSiblings;
-      layerinfo->rank = maxDistanceX * maxDistanceX + maxDistanceY * maxDistanceY;
-      layerinfo->current = NULL;      
+      layerinfo->rank =
+          maxDistanceX * maxDistanceX + maxDistanceY * maxDistanceY;
+      layerinfo->current = NULL;
       findRelatedShapes2(layerinfo, layerinfo->root, current);
       if (layerinfo->current) {
-        clusterInfo* s = layerinfo->current;
+        clusterInfo *s = layerinfo->current;
         /* found a matching cluster */
         ++s->numsiblings;
         /* assign to cluster */
         layerinfo->finalizedSiblings = current->next;
         current->next = s->siblings;
         s->siblings = current;
-      }
-      else {
+      } else {
         /* this appears to be a bug */
         layerinfo->finalizedSiblings = current->next;
         current->next = layerinfo->filtered;
         layerinfo->filtered = current;
         ++layerinfo->numFiltered;
-      }     
+      }
     }
-    
+
     /* collecting the shapes of the cluster */
     collectClusterShapes2(layer, layerinfo, layerinfo->root);
   }
@@ -1369,9 +1416,8 @@ int RebuildClusters(layerObj *layer, int
 }
 
 /* Close the the combined layer */
-int msClusterLayerClose(layerObj *layer)
-{
-  msClusterLayerInfo* layerinfo = (msClusterLayerInfo*)layer->layerinfo;
+int msClusterLayerClose(layerObj *layer) {
+  msClusterLayerInfo *layerinfo = (msClusterLayerInfo *)layer->layerinfo;
 
   if (!layerinfo)
     return MS_SUCCESS;
@@ -1386,39 +1432,35 @@ int msClusterLayerClose(layerObj *layer)
 
 #ifndef USE_CLUSTER_EXTERNAL
   /* switch back to the source layer vtable */
-  if( msInitializeVirtualTable(layer) != MS_SUCCESS )
-      return MS_FAILURE;
+  if (msInitializeVirtualTable(layer) != MS_SUCCESS)
+    return MS_FAILURE;
 #endif
 
   return MS_SUCCESS;
 }
 
 /* Return MS_TRUE if layer is open, MS_FALSE otherwise. */
-int msClusterLayerIsOpen(layerObj *layer)
-{
+int msClusterLayerIsOpen(layerObj *layer) {
   if (layer->layerinfo)
-    return(MS_TRUE);
+    return (MS_TRUE);
   else
-    return(MS_FALSE);
+    return (MS_FALSE);
 }
 
 /* Free the itemindexes array in a layer. */
-void msClusterLayerFreeItemInfo(layerObj *layer)
-{
+void msClusterLayerFreeItemInfo(layerObj *layer) {
   msFree(layer->iteminfo);
   layer->iteminfo = NULL;
 }
 
-
 /* allocate the iteminfo index array - same order as the item list */
-int msClusterLayerInitItemInfo(layerObj *layer)
-{
+int msClusterLayerInitItemInfo(layerObj *layer) {
   int i, numitems;
   int *itemindexes;
 
-  msClusterLayerInfo* layerinfo = (msClusterLayerInfo*)layer->layerinfo;
+  msClusterLayerInfo *layerinfo = (msClusterLayerInfo *)layer->layerinfo;
 
-  if(layer->numitems == 0) {
+  if (layer->numitems == 0) {
     return MS_SUCCESS;
   }
 
@@ -1428,7 +1470,7 @@ int msClusterLayerInitItemInfo(layerObj
   /* Cleanup any previous item selection */
   msClusterLayerFreeItemInfo(layer);
 
-  layer->iteminfo = (int *) msSmallMalloc(sizeof(int) * layer->numitems);
+  layer->iteminfo = (int *)msSmallMalloc(sizeof(int) * layer->numitems);
 
   itemindexes = layer->iteminfo;
 
@@ -1446,7 +1488,7 @@ int msClusterLayerInitItemInfo(layerObj
   }
 
   msLayerFreeItemInfo(&layerinfo->srcLayer);
-  if(layerinfo->srcLayer.items) {
+  if (layerinfo->srcLayer.items) {
     msFreeCharArray(layerinfo->srcLayer.items, layerinfo->srcLayer.numitems);
     layerinfo->srcLayer.items = NULL;
     layerinfo->srcLayer.numitems = 0;
@@ -1454,19 +1496,24 @@ int msClusterLayerInitItemInfo(layerObj
 
   if (numitems > 0) {
     /* now allocate and set the layer item parameters  */
-    layerinfo->srcLayer.items = (char **)msSmallMalloc(sizeof(char *)*numitems);
+    layerinfo->srcLayer.items =
+        (char **)msSmallMalloc(sizeof(char *) * numitems);
     layerinfo->srcLayer.numitems = numitems;
 
     for (i = 0; i < layer->numitems; i++) {
       if (itemindexes[i] >= 0) {
         if (EQUALN(layer->items[i], "Min:", 4))
-          layerinfo->srcLayer.items[itemindexes[i]] = msStrdup(layer->items[i] + 4);
+          layerinfo->srcLayer.items[itemindexes[i]] =
+              msStrdup(layer->items[i] + 4);
         else if (EQUALN(layer->items[i], "Max:", 4))
-          layerinfo->srcLayer.items[itemindexes[i]] = msStrdup(layer->items[i] + 4);
+          layerinfo->srcLayer.items[itemindexes[i]] =
+              msStrdup(layer->items[i] + 4);
         else if (EQUALN(layer->items[i], "Sum:", 4))
-          layerinfo->srcLayer.items[itemindexes[i]] = msStrdup(layer->items[i] + 4);
+          layerinfo->srcLayer.items[itemindexes[i]] =
+              msStrdup(layer->items[i] + 4);
         else if (EQUALN(layer->items[i], "Count:", 6))
-          layerinfo->srcLayer.items[itemindexes[i]] = msStrdup(layer->items[i] + 6);
+          layerinfo->srcLayer.items[itemindexes[i]] =
+              msStrdup(layer->items[i] + 6);
         else
           layerinfo->srcLayer.items[itemindexes[i]] = msStrdup(layer->items[i]);
       }
@@ -1480,38 +1527,43 @@ int msClusterLayerInitItemInfo(layerObj
 }
 
 /* Execute a query for this layer */
-int msClusterLayerWhichShapes(layerObj *layer, rectObj rect, int isQuery)
-{
+int msClusterLayerWhichShapes(layerObj *layer, rectObj rect, int isQuery) {
   (void)rect;
   /* rebuild the cluster database */
   return RebuildClusters(layer, isQuery);
 }
 
-static int prepareShape(layerObj* layer, msClusterLayerInfo* layerinfo, clusterInfo* current, shapeObj* shape)
-{
+static int prepareShape(layerObj *layer, msClusterLayerInfo *layerinfo,
+                        clusterInfo *current, shapeObj *shape) {
   (void)layer;
   if (msCopyShape(&(current->shape), shape) != MS_SUCCESS) {
-    msSetError(MS_SHPERR, "Cannot retrieve inline shape. There some problem with the shape", "msClusterLayerNextShape()");
+    msSetError(
+        MS_SHPERR,
+        "Cannot retrieve inline shape. There some problem with the shape",
+        "msClusterLayerNextShape()");
     return MS_FAILURE;
   }
 
   /* update the positions of the cluster shape */
   if (layerinfo->keep_locations == MS_FALSE) {
-    shape->line[0].point[0].x = shape->bounds.minx = shape->bounds.maxx = current->avgx;
-    shape->line[0].point[0].y = shape->bounds.miny = shape->bounds.maxy = current->avgy;
+    shape->line[0].point[0].x = shape->bounds.minx = shape->bounds.maxx =
+        current->avgx;
+    shape->line[0].point[0].y = shape->bounds.miny = shape->bounds.maxy =
+        current->avgy;
   }
 
   return MS_SUCCESS;
 }
 
 /* Execute a query on the DB based on fid. */
-int msClusterLayerGetShape(layerObj *layer, shapeObj *shape, resultObj *record)
-{
-  clusterInfo* current;
-  msClusterLayerInfo* layerinfo = (msClusterLayerInfo*)layer->layerinfo;
+int msClusterLayerGetShape(layerObj *layer, shapeObj *shape,
+                           resultObj *record) {
+  clusterInfo *current;
+  msClusterLayerInfo *layerinfo = (msClusterLayerInfo *)layer->layerinfo;
 
   if (!layerinfo) {
-    msSetError(MS_MISCERR, "Layer not open: %s", "msClusterLayerGetShape()", layer->name);
+    msSetError(MS_MISCERR, "Layer not open: %s", "msClusterLayerGetShape()",
+               layer->name);
     return MS_FAILURE;
   }
 
@@ -1524,7 +1576,8 @@ int msClusterLayerGetShape(layerObj *lay
   }
 
   if (current == NULL) {
-    msSetError(MS_SHPERR, "No feature with this index.", "msClusterLayerGetShape()");
+    msSetError(MS_SHPERR, "No feature with this index.",
+               "msClusterLayerGetShape()");
     return MS_FAILURE;
   }
 
@@ -1534,13 +1587,13 @@ int msClusterLayerGetShape(layerObj *lay
 /* find the next shape with the appropriate shape type */
 /* also, load in the attribute data */
 /* MS_DONE => no more data */
-int msClusterLayerNextShape(layerObj *layer, shapeObj *shape)
-{
+int msClusterLayerNextShape(layerObj *layer, shapeObj *shape) {
   int rv;
-  msClusterLayerInfo* layerinfo = (msClusterLayerInfo*)layer->layerinfo;
+  msClusterLayerInfo *layerinfo = (msClusterLayerInfo *)layer->layerinfo;
 
   if (!layerinfo) {
-    msSetError(MS_MISCERR, "Layer not open: %s", "msClusterLayerNextShape()", layer->name);
+    msSetError(MS_MISCERR, "Layer not open: %s", "msClusterLayerNextShape()",
+               layer->name);
     return MS_FAILURE;
   }
 
@@ -1555,11 +1608,10 @@ int msClusterLayerNextShape(layerObj *la
 }
 
 /* Query for the items collection */
-int msClusterLayerGetItems(layerObj *layer)
-{
+int msClusterLayerGetItems(layerObj *layer) {
   /* we support certain built in attributes */
   layer->numitems = MSCLUSTER_NUMITEMS;
-  layer->items = msSmallMalloc(sizeof(char*) * (layer->numitems));
+  layer->items = msSmallMalloc(sizeof(char *) * (layer->numitems));
   layer->items[0] = msStrdup(MSCLUSTER_FEATURECOUNT);
   layer->items[1] = msStrdup(MSCLUSTER_GROUP);
   layer->items[2] = msStrdup(MSCLUSTER_BASEFID);
@@ -1567,10 +1619,8 @@ int msClusterLayerGetItems(layerObj *lay
   return msClusterLayerInitItemInfo(layer);
 }
 
-
-int msClusterLayerGetNumFeatures(layerObj *layer)
-{
-  msClusterLayerInfo* layerinfo = (msClusterLayerInfo*)layer->layerinfo;
+int msClusterLayerGetNumFeatures(layerObj *layer) {
+  msClusterLayerInfo *layerinfo = (msClusterLayerInfo *)layer->layerinfo;
 
   if (!layerinfo)
     return -1;
@@ -1579,8 +1629,7 @@ int msClusterLayerGetNumFeatures(layerOb
 }
 
 static int msClusterLayerGetAutoStyle(mapObj *map, layerObj *layer, classObj *c,
-                                      shapeObj* shape)
-{
+                                      shapeObj *shape) {
   (void)map;
   (void)layer;
   (void)c;
@@ -1589,9 +1638,9 @@ static int msClusterLayerGetAutoStyle(ma
   return MS_SUCCESS;
 }
 
-msClusterLayerInfo* msClusterInitialize(layerObj *layer)
-{
-  msClusterLayerInfo *layerinfo =(msClusterLayerInfo*)msSmallMalloc(sizeof(msClusterLayerInfo));
+msClusterLayerInfo *msClusterInitialize(layerObj *layer) {
+  msClusterLayerInfo *layerinfo =
+      (msClusterLayerInfo *)msSmallMalloc(sizeof(msClusterLayerInfo));
 
   layer->layerinfo = layerinfo;
 
@@ -1620,24 +1669,23 @@ msClusterLayerInfo* msClusterInitialize(
   return layerinfo;
 }
 
-int msClusterLayerOpen(layerObj *layer)
-{
-  msClusterLayerInfo* layerinfo;
+int msClusterLayerOpen(layerObj *layer) {
+  msClusterLayerInfo *layerinfo;
 
   if (layer->type != MS_LAYER_POINT) {
-    msSetError(MS_MISCERR, "Only point layers are supported for clustering: %s", "msClusterLayerOpen()", layer->name);
+    msSetError(MS_MISCERR, "Only point layers are supported for clustering: %s",
+               "msClusterLayerOpen()", layer->name);
     return MS_FAILURE;
   }
 
   if (!layer->map)
     return MS_FAILURE;
 
-  if (layer->layerinfo)
-  {
+  if (layer->layerinfo) {
     if (layer->vtable->LayerOpen != msClusterLayerOpen)
-        msLayerClose(layer);
+      msLayerClose(layer);
     else
-      return MS_SUCCESS;  /* already open */
+      return MS_SUCCESS; /* already open */
   }
 
   layerinfo = msClusterInitialize(layer);
@@ -1646,7 +1694,7 @@ int msClusterLayerOpen(layerObj *layer)
     return MS_FAILURE;
 
   /* prepare the source layer */
-  if(initLayer(&layerinfo->srcLayer, layer->map) == -1)
+  if (initLayer(&layerinfo->srcLayer, layer->map) == -1)
     return MS_FAILURE;
 
 #ifdef USE_CLUSTER_EXTERNAL
@@ -1656,17 +1704,21 @@ int msClusterLayerOpen(layerObj *layer)
   layerIndex = msGetLayerIndex(layer->map, layer->connection);
 
   if (layerIndex < 0 && layerIndex >= layer->map->numlayers) {
-    msSetError(MS_MISCERR, "No source layers specified in layer: %s", "msClusterLayerOpen()", layer->name);
+    msSetError(MS_MISCERR, "No source layers specified in layer: %s",
+               "msClusterLayerOpen()", layer->name);
     return MS_FAILURE;
   }
 
   if (layer->map->layers[layerIndex]->type != MS_LAYER_POINT) {
-    msSetError(MS_MISCERR, "Only point layers are supported for cluster data source: %s", "msClusterLayerOpen()", layer->name);
+    msSetError(MS_MISCERR,
+               "Only point layers are supported for cluster data source: %s",
+               "msClusterLayerOpen()", layer->name);
     return MS_FAILURE;
   }
 
-  if (msCopyLayer(&layerinfo->srcLayer, layer->map->layers[layerIndex]) != MS_SUCCESS)
-    return(MS_FAILURE);
+  if (msCopyLayer(&layerinfo->srcLayer, layer->map->layers[layerIndex]) !=
+      MS_SUCCESS)
+    return (MS_FAILURE);
 #else
   /* hook the vtable to this driver, will be restored in LayerClose*/
   if (!layer->vtable) {
@@ -1677,79 +1729,84 @@ int msClusterLayerOpen(layerObj *layer)
   msClusterLayerCopyVirtualTable(layer->vtable);
 
   if (msCopyLayer(&layerinfo->srcLayer, layer) != MS_SUCCESS)
-    return(MS_FAILURE);
+    return (MS_FAILURE);
 #endif
 
   /* disable the connection pool for this layer */
   msLayerSetProcessingKey(&layerinfo->srcLayer, "CLOSE_CONNECTION", "ALWAYS");
 
   /* open the source layer */
-  if ( !layerinfo->srcLayer.vtable) {
+  if (!layerinfo->srcLayer.vtable) {
     if (msInitializeVirtualTable(&layerinfo->srcLayer) != MS_SUCCESS)
       return MS_FAILURE;
   }
 
-  if (layerinfo->srcLayer.vtable->LayerOpen(&layerinfo->srcLayer) != MS_SUCCESS) {
+  if (layerinfo->srcLayer.vtable->LayerOpen(&layerinfo->srcLayer) !=
+      MS_SUCCESS) {
     return MS_FAILURE;
   }
 
   return MS_SUCCESS;
 }
 
-int msClusterLayerTranslateFilter(layerObj *layer, expressionObj *filter, char *filteritem)
-{
+int msClusterLayerTranslateFilter(layerObj *layer, expressionObj *filter,
+                                  char *filteritem) {
   (void)filter;
-  msClusterLayerInfo* layerinfo = layer->layerinfo;
+  msClusterLayerInfo *layerinfo = layer->layerinfo;
 
   if (!layerinfo) {
-    msSetError(MS_MISCERR, "Layer is not open: %s", "msClusterLayerTranslateFilter()", layer->name);
+    msSetError(MS_MISCERR, "Layer is not open: %s",
+               "msClusterLayerTranslateFilter()", layer->name);
     return MS_FAILURE;
   }
 
-  if (layerinfo->srcLayer.filter.type == MS_EXPRESSION && layerinfo->srcLayer.filter.tokens == NULL)
-    msTokenizeExpression(&(layerinfo->srcLayer.filter), layer->items, &(layer->numitems));
+  if (layerinfo->srcLayer.filter.type == MS_EXPRESSION &&
+      layerinfo->srcLayer.filter.tokens == NULL)
+    msTokenizeExpression(&(layerinfo->srcLayer.filter), layer->items,
+                         &(layer->numitems));
 
-  return layerinfo->srcLayer.vtable->LayerTranslateFilter(&layerinfo->srcLayer, &layerinfo->srcLayer.filter, filteritem);
+  return layerinfo->srcLayer.vtable->LayerTranslateFilter(
+      &layerinfo->srcLayer, &layerinfo->srcLayer.filter, filteritem);
 }
 
-char* msClusterLayerEscapeSQLParam(layerObj *layer, const char* pszString)
-{
-  msClusterLayerInfo* layerinfo = layer->layerinfo;
+char *msClusterLayerEscapeSQLParam(layerObj *layer, const char *pszString) {
+  msClusterLayerInfo *layerinfo = layer->layerinfo;
 
   if (!layerinfo) {
-    msSetError(MS_MISCERR, "Layer is not open: %s", "msClusterLayerEscapeSQLParam()", layer->name);
+    msSetError(MS_MISCERR, "Layer is not open: %s",
+               "msClusterLayerEscapeSQLParam()", layer->name);
     return msStrdup("");
   }
 
-  return layerinfo->srcLayer.vtable->LayerEscapeSQLParam(&layerinfo->srcLayer, pszString);
+  return layerinfo->srcLayer.vtable->LayerEscapeSQLParam(&layerinfo->srcLayer,
+                                                         pszString);
 }
 
-int msClusterLayerGetAutoProjection(layerObj *layer, projectionObj* projection)
-{
-  msClusterLayerInfo* layerinfo = layer->layerinfo;
+int msClusterLayerGetAutoProjection(layerObj *layer,
+                                    projectionObj *projection) {
+  msClusterLayerInfo *layerinfo = layer->layerinfo;
 
   if (!layerinfo) {
-    msSetError(MS_MISCERR, "Layer is not open: %s", "msClusterLayerGetAutoProjection()", layer->name);
+    msSetError(MS_MISCERR, "Layer is not open: %s",
+               "msClusterLayerGetAutoProjection()", layer->name);
     return MS_FAILURE;
   }
 
-  return layerinfo->srcLayer.vtable->LayerGetAutoProjection(&layerinfo->srcLayer, projection);
+  return layerinfo->srcLayer.vtable->LayerGetAutoProjection(
+      &layerinfo->srcLayer, projection);
 }
 
-int msClusterLayerGetPaging(layerObj *layer)
-{
+int msClusterLayerGetPaging(layerObj *layer) {
   (void)layer;
   return MS_FALSE;
 }
 
-void msClusterLayerEnablePaging(layerObj *layer, int value)
-{
+void msClusterLayerEnablePaging(layerObj *layer, int value) {
   (void)layer;
   (void)value;
 }
 
-void msClusterLayerCopyVirtualTable(layerVTableObj* vtable)
-{
+void msClusterLayerCopyVirtualTable(layerVTableObj *vtable) {
   vtable->LayerInitItemInfo = msClusterLayerInitItemInfo;
   vtable->LayerFreeItemInfo = msClusterLayerFreeItemInfo;
   vtable->LayerOpen = msClusterLayerOpen;
@@ -1778,9 +1835,8 @@ void msClusterLayerCopyVirtualTable(laye
 
 #ifdef USE_CLUSTER_PLUGIN
 
-MS_DLL_EXPORT  int
-PluginInitializeVirtualTable(layerVTableObj* vtable, layerObj *layer)
-{
+MS_DLL_EXPORT int PluginInitializeVirtualTable(layerVTableObj *vtable,
+                                               layerObj *layer) {
   assert(layer != NULL);
   assert(vtable != NULL);
 
@@ -1791,8 +1847,7 @@ PluginInitializeVirtualTable(layerVTable
 
 #endif
 
-int msClusterLayerInitializeVirtualTable(layerObj *layer)
-{
+int msClusterLayerInitializeVirtualTable(layerObj *layer) {
   assert(layer != NULL);
   assert(layer->vtable != NULL);
 
diff -pruN 8.0.1-5/mapcompositingfilter.c 8.0.2-1/mapcompositingfilter.c
--- 8.0.1-5/mapcompositingfilter.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapcompositingfilter.c	2024-06-11 20:41:34.000000000 +0000
@@ -27,194 +27,208 @@
  *****************************************************************************/
 #include "mapserver.h"
 #include <regex.h>
-#define pixmove(rb,srcx,srcy,dstx,dsty) \
-  memcpy(rb->data.rgba.pixels+dsty*rb->data.rgba.row_step+dstx*4,\
-          rb->data.rgba.pixels+srcy*rb->data.rgba.row_step+srcx*4,\
-          4)
-#define pixerase(rb,x,y) memset(rb->data.rgba.pixels+y*rb->data.rgba.row_step+x*4,0,4)
-
-void msApplyTranslationCompositingFilter(rasterBufferObj *rb, int xtrans, int ytrans) {
-  int src_sx,src_sy,dst_sx,dst_sy;
-  if((unsigned)abs(xtrans)>=rb->width || (unsigned)abs(ytrans)>=rb->height) {
-    for(unsigned y = 0; y<rb->height; y++)
-      for(unsigned x = 0; x<rb->width; x++)
-        pixerase(rb,x,y);
+#define pixmove(rb, srcx, srcy, dstx, dsty)                                    \
+  memcpy(rb->data.rgba.pixels + dsty * rb->data.rgba.row_step + dstx * 4,      \
+         rb->data.rgba.pixels + srcy * rb->data.rgba.row_step + srcx * 4, 4)
+#define pixerase(rb, x, y)                                                     \
+  memset(rb->data.rgba.pixels + y * rb->data.rgba.row_step + x * 4, 0, 4)
+
+void msApplyTranslationCompositingFilter(rasterBufferObj *rb, int xtrans,
+                                         int ytrans) {
+  int src_sx, src_sy, dst_sx, dst_sy;
+  if ((unsigned)abs(xtrans) >= rb->width ||
+      (unsigned)abs(ytrans) >= rb->height) {
+    for (unsigned y = 0; y < rb->height; y++)
+      for (unsigned x = 0; x < rb->width; x++)
+        pixerase(rb, x, y);
   }
-  if(xtrans == 0 && ytrans == 0)
+  if (xtrans == 0 && ytrans == 0)
     return;
-  if(xtrans>=0) {
-    if(ytrans>=0) {
+  if (xtrans >= 0) {
+    if (ytrans >= 0) {
       src_sx = rb->width - xtrans - 1;
       src_sy = rb->height - ytrans - 1;
       dst_sx = rb->width - 1;
-      dst_sy = rb->height -1;
-      for(int y = src_sy,dst_y= dst_sy;y>=0;y--,dst_y--) {
-        for(int x = src_sx,dst_x= dst_sx;x>=0;x--,dst_x--) {
-          pixmove(rb,x,y,dst_x,dst_y);
+      dst_sy = rb->height - 1;
+      for (int y = src_sy, dst_y = dst_sy; y >= 0; y--, dst_y--) {
+        for (int x = src_sx, dst_x = dst_sx; x >= 0; x--, dst_x--) {
+          pixmove(rb, x, y, dst_x, dst_y);
         }
       }
-      for(int y=0;y<ytrans;y++)
-        for(unsigned x=0;x<rb->width;x++)
-          pixerase(rb,x,y);  
-      for(unsigned y=ytrans;y<rb->height;y++)
-        for(int x=0;x<xtrans;x++)
-          pixerase(rb,x,y);
+      for (int y = 0; y < ytrans; y++)
+        for (unsigned x = 0; x < rb->width; x++)
+          pixerase(rb, x, y);
+      for (unsigned y = ytrans; y < rb->height; y++)
+        for (int x = 0; x < xtrans; x++)
+          pixerase(rb, x, y);
     } else {
       src_sx = rb->width - xtrans - 1;
-      src_sy = - ytrans;
+      src_sy = -ytrans;
       dst_sx = rb->width - 1;
       dst_sy = 0;
-      for(unsigned y = src_sy,dst_y= dst_sy;y<rb->height;y++,dst_y++) {
-        for(int x = src_sx,dst_x= dst_sx;x>=0;x--,dst_x--) {
-          pixmove(rb,x,y,dst_x,dst_y);
+      for (unsigned y = src_sy, dst_y = dst_sy; y < rb->height; y++, dst_y++) {
+        for (int x = src_sx, dst_x = dst_sx; x >= 0; x--, dst_x--) {
+          pixmove(rb, x, y, dst_x, dst_y);
         }
       }
-      for(unsigned y=0;y<rb->height+ytrans;y++)
-        for(int x=0;x<xtrans;x++)
-          pixerase(rb,x,y);  
-      for(unsigned y=rb->height+ytrans;y<rb->height;y++)
-        for(unsigned x=0;x<rb->width;x++)
-          pixerase(rb,x,y);
+      for (unsigned y = 0; y < rb->height + ytrans; y++)
+        for (int x = 0; x < xtrans; x++)
+          pixerase(rb, x, y);
+      for (unsigned y = rb->height + ytrans; y < rb->height; y++)
+        for (unsigned x = 0; x < rb->width; x++)
+          pixerase(rb, x, y);
     }
   } else {
-    if(ytrans>=0) {
-      src_sx = - xtrans;
+    if (ytrans >= 0) {
+      src_sx = -xtrans;
       src_sy = rb->height - ytrans - 1;
       dst_sx = 0;
-      dst_sy = rb->height -1;
-      for(int y = src_sy,dst_y= dst_sy;y>=0;y--,dst_y--) {
-        for(unsigned x = src_sx,dst_x= dst_sx;x<rb->width;x++,dst_x++) {
-          pixmove(rb,x,y,dst_x,dst_y);
+      dst_sy = rb->height - 1;
+      for (int y = src_sy, dst_y = dst_sy; y >= 0; y--, dst_y--) {
+        for (unsigned x = src_sx, dst_x = dst_sx; x < rb->width; x++, dst_x++) {
+          pixmove(rb, x, y, dst_x, dst_y);
         }
       }
-      for(int y=0;y<ytrans;y++)
-        for(unsigned x=0;x<rb->width;x++)
-          pixerase(rb,x,y);
-      for(unsigned y=ytrans;y<rb->height;y++)
-        for(unsigned x=rb->width+xtrans;x<rb->width;x++)
-          pixerase(rb,x,y);
+      for (int y = 0; y < ytrans; y++)
+        for (unsigned x = 0; x < rb->width; x++)
+          pixerase(rb, x, y);
+      for (unsigned y = ytrans; y < rb->height; y++)
+        for (unsigned x = rb->width + xtrans; x < rb->width; x++)
+          pixerase(rb, x, y);
     } else {
-      src_sx = - xtrans;
-      src_sy = - ytrans;
+      src_sx = -xtrans;
+      src_sy = -ytrans;
       dst_sx = 0;
       dst_sy = 0;
-      for(unsigned y = src_sy,dst_y= dst_sy;y<rb->height;y++,dst_y++) {
-        for(unsigned x = src_sx,dst_x= dst_sx;x<rb->width;x++,dst_x++) {
-          pixmove(rb,x,y,dst_x,dst_y);
+      for (unsigned y = src_sy, dst_y = dst_sy; y < rb->height; y++, dst_y++) {
+        for (unsigned x = src_sx, dst_x = dst_sx; x < rb->width; x++, dst_x++) {
+          pixmove(rb, x, y, dst_x, dst_y);
         }
       }
-      for(unsigned y=0;y<rb->height+ytrans;y++)
-        for(unsigned x=rb->width+xtrans;x<rb->width;x++)
-          pixerase(rb,x,y);
-      for(unsigned y=rb->height+ytrans;y<rb->height;y++)
-        for(unsigned x=0;x<rb->width;x++)
-          pixerase(rb,x,y);
+      for (unsigned y = 0; y < rb->height + ytrans; y++)
+        for (unsigned x = rb->width + xtrans; x < rb->width; x++)
+          pixerase(rb, x, y);
+      for (unsigned y = rb->height + ytrans; y < rb->height; y++)
+        for (unsigned x = 0; x < rb->width; x++)
+          pixerase(rb, x, y);
     }
   }
 }
 
 void msApplyBlackeningCompositingFilter(rasterBufferObj *rb) {
-  unsigned char *r,*g,*b;
-  for(unsigned row=0;row<rb->height;row++) {
-    r = rb->data.rgba.r + row*rb->data.rgba.row_step;
-    g = rb->data.rgba.g + row*rb->data.rgba.row_step;
-    b = rb->data.rgba.b + row*rb->data.rgba.row_step;
-    for(unsigned col=0;col<rb->width;col++) {
+  unsigned char *r, *g, *b;
+  for (unsigned row = 0; row < rb->height; row++) {
+    r = rb->data.rgba.r + row * rb->data.rgba.row_step;
+    g = rb->data.rgba.g + row * rb->data.rgba.row_step;
+    b = rb->data.rgba.b + row * rb->data.rgba.row_step;
+    for (unsigned col = 0; col < rb->width; col++) {
       *r = *g = *b = 0;
-      r+=4;g+=4;b+=4;
-    }    
+      r += 4;
+      g += 4;
+      b += 4;
+    }
   }
 }
 
 void msApplyWhiteningCompositingFilter(rasterBufferObj *rb) {
-  unsigned char *r,*g,*b,*a;
-  for(unsigned row=0;row<rb->height;row++) {
-    r = rb->data.rgba.r + row*rb->data.rgba.row_step;
-    g = rb->data.rgba.g + row*rb->data.rgba.row_step;
-    b = rb->data.rgba.b + row*rb->data.rgba.row_step;
-    a = rb->data.rgba.a + row*rb->data.rgba.row_step;
-    for(unsigned col=0;col<rb->width;col++) {
+  unsigned char *r, *g, *b, *a;
+  for (unsigned row = 0; row < rb->height; row++) {
+    r = rb->data.rgba.r + row * rb->data.rgba.row_step;
+    g = rb->data.rgba.g + row * rb->data.rgba.row_step;
+    b = rb->data.rgba.b + row * rb->data.rgba.row_step;
+    a = rb->data.rgba.a + row * rb->data.rgba.row_step;
+    for (unsigned col = 0; col < rb->width; col++) {
       *r = *g = *b = *a;
-      r+=4;g+=4;b+=4;a+=4;
-    }    
+      r += 4;
+      g += 4;
+      b += 4;
+      a += 4;
+    }
   }
 }
 
 void msApplyGrayscaleCompositingFilter(rasterBufferObj *rb) {
-  unsigned char *r,*g,*b;
-  for(unsigned row=0;row<rb->height;row++) {
-    r = rb->data.rgba.r + row*rb->data.rgba.row_step;
-    g = rb->data.rgba.g + row*rb->data.rgba.row_step;
-    b = rb->data.rgba.b + row*rb->data.rgba.row_step;
-    for(unsigned col=0;col<rb->width;col++) {
+  unsigned char *r, *g, *b;
+  for (unsigned row = 0; row < rb->height; row++) {
+    r = rb->data.rgba.r + row * rb->data.rgba.row_step;
+    g = rb->data.rgba.g + row * rb->data.rgba.row_step;
+    b = rb->data.rgba.b + row * rb->data.rgba.row_step;
+    for (unsigned col = 0; col < rb->width; col++) {
       unsigned int mix = (unsigned int)*r + (unsigned int)*g + (unsigned int)*b;
-      mix /=3;
+      mix /= 3;
       *r = *g = *b = (unsigned char)mix;
-      r+=4;g+=4;b+=4;
-    }    
+      r += 4;
+      g += 4;
+      b += 4;
+    }
   }
 }
 
-int msApplyCompositingFilter(mapObj *map, rasterBufferObj *rb, CompositingFilter *filter) {
+int msApplyCompositingFilter(mapObj *map, rasterBufferObj *rb,
+                             CompositingFilter *filter) {
   int rstatus;
   regex_t regex;
   regmatch_t pmatch[3];
-  
+
   /* test for blurring filter */
   regcomp(&regex, "blur\\(([0-9]+)\\)", REG_EXTENDED);
   rstatus = regexec(&regex, filter->filter, 2, pmatch, 0);
   regfree(&regex);
-  if(!rstatus) {
+  if (!rstatus) {
     char *rad = malloc(pmatch[1].rm_eo - pmatch[1].rm_so + 1);
     unsigned int irad;
-    strncpy(rad,filter->filter+pmatch[1].rm_so,pmatch[1].rm_eo-pmatch[1].rm_so);
-    rad[pmatch[1].rm_eo - pmatch[1].rm_so]=0;
-    //msDebug("got blur filter with radius %s\n",rad);
+    strncpy(rad, filter->filter + pmatch[1].rm_so,
+            pmatch[1].rm_eo - pmatch[1].rm_so);
+    rad[pmatch[1].rm_eo - pmatch[1].rm_so] = 0;
+    // msDebug("got blur filter with radius %s\n",rad);
     irad = atoi(rad);
     free(rad);
-    irad = MS_NINT(irad*map->resolution/map->defresolution);
-    msApplyBlurringCompositingFilter(rb,irad);
+    irad = MS_NINT(irad * map->resolution / map->defresolution);
+    msApplyBlurringCompositingFilter(rb, irad);
     return MS_SUCCESS;
   }
-  
+
   /* test for translation filter */
   regcomp(&regex, "translate\\((-?[0-9]+),(-?[0-9]+)\\)", REG_EXTENDED);
   rstatus = regexec(&regex, filter->filter, 3, pmatch, 0);
   regfree(&regex);
-  if(!rstatus) {
+  if (!rstatus) {
     char *num;
-    int xtrans,ytrans;
+    int xtrans, ytrans;
     num = malloc(pmatch[1].rm_eo - pmatch[1].rm_so + 1);
-    strncpy(num,filter->filter+pmatch[1].rm_so,pmatch[1].rm_eo-pmatch[1].rm_so);
-    num[pmatch[1].rm_eo - pmatch[1].rm_so]=0;
+    strncpy(num, filter->filter + pmatch[1].rm_so,
+            pmatch[1].rm_eo - pmatch[1].rm_so);
+    num[pmatch[1].rm_eo - pmatch[1].rm_so] = 0;
     xtrans = atoi(num);
     free(num);
     num = malloc(pmatch[2].rm_eo - pmatch[2].rm_so + 1);
-    strncpy(num,filter->filter+pmatch[2].rm_so,pmatch[2].rm_eo-pmatch[2].rm_so);
-    num[pmatch[2].rm_eo - pmatch[2].rm_so]=0;
+    strncpy(num, filter->filter + pmatch[2].rm_so,
+            pmatch[2].rm_eo - pmatch[2].rm_so);
+    num[pmatch[2].rm_eo - pmatch[2].rm_so] = 0;
     ytrans = atoi(num);
     free(num);
-    //msDebug("got translation filter of radius %d,%d\n",xtrans,ytrans);
-    xtrans = MS_NINT(xtrans*map->resolution/map->defresolution);
-    ytrans = MS_NINT(ytrans*map->resolution/map->defresolution);
-    msApplyTranslationCompositingFilter(rb,xtrans,ytrans);
+    // msDebug("got translation filter of radius %d,%d\n",xtrans,ytrans);
+    xtrans = MS_NINT(xtrans * map->resolution / map->defresolution);
+    ytrans = MS_NINT(ytrans * map->resolution / map->defresolution);
+    msApplyTranslationCompositingFilter(rb, xtrans, ytrans);
     return MS_SUCCESS;
   }
-  
+
   /* test for grayscale filter */
-  if(!strncmp(filter->filter,"grayscale()",strlen("grayscale()"))) {
+  if (!strncmp(filter->filter, "grayscale()", strlen("grayscale()"))) {
     msApplyGrayscaleCompositingFilter(rb);
     return MS_SUCCESS;
   }
-  if(!strncmp(filter->filter,"blacken()",strlen("blacken()"))) {
+  if (!strncmp(filter->filter, "blacken()", strlen("blacken()"))) {
     msApplyBlackeningCompositingFilter(rb);
     return MS_SUCCESS;
   }
-  if(!strncmp(filter->filter,"whiten()",strlen("whiten()"))) {
+  if (!strncmp(filter->filter, "whiten()", strlen("whiten()"))) {
     msApplyWhiteningCompositingFilter(rb);
     return MS_SUCCESS;
   }
-  
-  msSetError(MS_MISCERR,"unknown compositing filter (%s)", "msApplyCompositingFilter()", filter->filter);
+
+  msSetError(MS_MISCERR, "unknown compositing filter (%s)",
+             "msApplyCompositingFilter()", filter->filter);
   return MS_FAILURE;
 }
diff -pruN 8.0.1-5/mapcontext.c 8.0.2-1/mapcontext.c
--- 8.0.1-5/mapcontext.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapcontext.c	2024-06-11 20:41:34.000000000 +0000
@@ -32,7 +32,6 @@
 #include "cpl_vsi.h"
 #include "cpl_conv.h"
 
-
 #if defined(USE_WMS_LYR)
 
 /* There is a dependency to GDAL/OGR for the GML driver and MiniXML parser */
@@ -47,16 +46,15 @@
 ** Take the filename in argument
 ** Return value must be freed by caller
 */
-static char * msGetMapContextFileText(const char *filename)
-{
+static char *msGetMapContextFileText(const char *filename) {
   char *pszBuffer;
   VSILFILE *stream;
-  vsi_l_offset  nLength;
+  vsi_l_offset nLength;
 
   /* open file */
-  if(filename != NULL && strlen(filename) > 0) {
+  if (filename != NULL && strlen(filename) > 0) {
     stream = VSIFOpenL(filename, "rb");
-    if(!stream) {
+    if (!stream) {
       msSetError(MS_IOERR, "(%s)", "msGetMapContextFileText()", filename);
       return NULL;
     }
@@ -65,37 +63,36 @@ static char * msGetMapContextFileText(co
     return NULL;
   }
 
-  VSIFSeekL( stream, 0, SEEK_END );
-  nLength = VSIFTellL( stream );
-  VSIFSeekL( stream, 0, SEEK_SET );
-  if( nLength > 100 * 1024 * 1024U )
-  {
-    msSetError(MS_MEMERR, "(%s): too big file", "msGetMapContextFileText()", filename);
-    VSIFCloseL( stream );
+  VSIFSeekL(stream, 0, SEEK_END);
+  nLength = VSIFTellL(stream);
+  VSIFSeekL(stream, 0, SEEK_SET);
+  if (nLength > 100 * 1024 * 1024U) {
+    msSetError(MS_MEMERR, "(%s): too big file", "msGetMapContextFileText()",
+               filename);
+    VSIFCloseL(stream);
     return NULL;
   }
 
-  pszBuffer = (char *) malloc((size_t)nLength+1);
-  if( pszBuffer == NULL ) {
+  pszBuffer = (char *)malloc((size_t)nLength + 1);
+  if (pszBuffer == NULL) {
     msSetError(MS_MEMERR, "(%s)", "msGetMapContextFileText()", filename);
-    VSIFCloseL( stream );
+    VSIFCloseL(stream);
     return NULL;
   }
 
-  if(VSIFReadL( pszBuffer, nLength, 1, stream ) == 0) {
-    free( pszBuffer );
-    VSIFCloseL( stream );
+  if (VSIFReadL(pszBuffer, nLength, 1, stream) == 0) {
+    free(pszBuffer);
+    VSIFCloseL(stream);
     msSetError(MS_IOERR, "(%s)", "msGetMapContextFileText()", filename);
     return NULL;
   }
   pszBuffer[nLength] = '\0';
 
-  VSIFCloseL( stream );
+  VSIFCloseL(stream);
 
   return pszBuffer;
 }
 
-
 #if defined(USE_WMS_LYR)
 
 /*
@@ -104,15 +101,14 @@ static char * msGetMapContextFileText(co
 **Get the xml value and put it in the hash table
 **
 */
-int msGetMapContextXMLHashValue( CPLXMLNode *psRoot, const char *pszXMLPath,
-                                 hashTableObj *metadata, char *pszMetadata )
-{
+int msGetMapContextXMLHashValue(CPLXMLNode *psRoot, const char *pszXMLPath,
+                                hashTableObj *metadata, char *pszMetadata) {
   char *pszValue;
 
-  pszValue = (char*)CPLGetXMLValue( psRoot, pszXMLPath, NULL);
-  if(pszValue != NULL) {
-    if( metadata != NULL ) {
-      msInsertHashTable(metadata, pszMetadata, pszValue );
+  pszValue = (char *)CPLGetXMLValue(psRoot, pszXMLPath, NULL);
+  if (pszValue != NULL) {
+    if (metadata != NULL) {
+      msInsertHashTable(metadata, pszMetadata, pszValue);
     } else {
       return MS_FAILURE;
     }
@@ -129,18 +125,17 @@ int msGetMapContextXMLHashValue( CPLXMLN
 **Get the xml value and put it in the hash table
 **
 */
-int msGetMapContextXMLHashValueDecode( CPLXMLNode *psRoot,
-                                       const char *pszXMLPath,
-                                       hashTableObj *metadata,
-                                       char *pszMetadata )
-{
+int msGetMapContextXMLHashValueDecode(CPLXMLNode *psRoot,
+                                      const char *pszXMLPath,
+                                      hashTableObj *metadata,
+                                      char *pszMetadata) {
   char *pszValue;
 
-  pszValue = (char*)CPLGetXMLValue( psRoot, pszXMLPath, NULL);
-  if(pszValue != NULL) {
-    if( metadata != NULL ) {
+  pszValue = (char *)CPLGetXMLValue(psRoot, pszXMLPath, NULL);
+  if (pszValue != NULL) {
+    if (metadata != NULL) {
       msDecodeHTMLEntities(pszValue);
-      msInsertHashTable(metadata, pszMetadata, pszValue );
+      msInsertHashTable(metadata, pszMetadata, pszValue);
     } else {
       return MS_FAILURE;
     }
@@ -151,21 +146,19 @@ int msGetMapContextXMLHashValueDecode( C
   return MS_SUCCESS;
 }
 
-
 /*
 **msGetMapContextXMLStringValue()
 **
 **Get the xml value and put it in the string field
 **
 */
-int msGetMapContextXMLStringValue( CPLXMLNode *psRoot, char *pszXMLPath,
-                                   char **pszField)
-{
+int msGetMapContextXMLStringValue(CPLXMLNode *psRoot, char *pszXMLPath,
+                                  char **pszField) {
   char *pszValue;
 
-  pszValue = (char*)CPLGetXMLValue( psRoot, pszXMLPath, NULL);
-  if(pszValue != NULL) {
-    if( pszField != NULL ) {
+  pszValue = (char *)CPLGetXMLValue(psRoot, pszXMLPath, NULL);
+  if (pszValue != NULL) {
+    if (pszField != NULL) {
       *pszField = msStrdup(pszValue);
     } else {
       return MS_FAILURE;
@@ -177,21 +170,19 @@ int msGetMapContextXMLStringValue( CPLXM
   return MS_SUCCESS;
 }
 
-
 /*
 **msGetMapContextXMLStringValue()
 **
 **Get the xml value and put it in the string field
 **
 */
-int msGetMapContextXMLStringValueDecode( CPLXMLNode *psRoot, char *pszXMLPath,
-    char **pszField)
-{
+int msGetMapContextXMLStringValueDecode(CPLXMLNode *psRoot, char *pszXMLPath,
+                                        char **pszField) {
   char *pszValue;
 
-  pszValue = (char*)CPLGetXMLValue( psRoot, pszXMLPath, NULL);
-  if(pszValue != NULL) {
-    if( pszField != NULL ) {
+  pszValue = (char *)CPLGetXMLValue(psRoot, pszXMLPath, NULL);
+  if (pszValue != NULL) {
+    if (pszField != NULL) {
       msDecodeHTMLEntities(pszValue);
       *pszField = msStrdup(pszValue);
     } else {
@@ -204,21 +195,19 @@ int msGetMapContextXMLStringValueDecode(
   return MS_SUCCESS;
 }
 
-
 /*
 **msGetMapContextXMLFloatValue()
 **
 **Get the xml value and put it in the string field
 **
 */
-int msGetMapContextXMLFloatValue( CPLXMLNode *psRoot, char *pszXMLPath,
-                                  double *pszField)
-{
+int msGetMapContextXMLFloatValue(CPLXMLNode *psRoot, char *pszXMLPath,
+                                 double *pszField) {
   char *pszValue;
 
-  pszValue = (char*)CPLGetXMLValue( psRoot, pszXMLPath, NULL);
-  if(pszValue != NULL) {
-    if( pszField != NULL ) {
+  pszValue = (char *)CPLGetXMLValue(psRoot, pszXMLPath, NULL);
+  if (pszValue != NULL) {
+    if (pszField != NULL) {
       *pszField = atof(pszValue);
     } else {
       return MS_FAILURE;
@@ -236,28 +225,27 @@ int msGetMapContextXMLFloatValue( CPLXML
 ** Take a Node and get the width, height, format and href from it.
 ** Then put this info in metadatas.
 */
-int msLoadMapContextURLELements( CPLXMLNode *psRoot, hashTableObj *metadata,
-                                 const char *pszMetadataRoot)
-{
+int msLoadMapContextURLELements(CPLXMLNode *psRoot, hashTableObj *metadata,
+                                const char *pszMetadataRoot) {
   char *pszMetadataName;
 
-  if( psRoot == NULL || metadata == NULL || pszMetadataRoot == NULL )
+  if (psRoot == NULL || metadata == NULL || pszMetadataRoot == NULL)
     return MS_FAILURE;
 
-  pszMetadataName = (char*) malloc( strlen(pszMetadataRoot) + 10 );
+  pszMetadataName = (char *)malloc(strlen(pszMetadataRoot) + 10);
 
-  sprintf( pszMetadataName, "%s_width", pszMetadataRoot );
-  msGetMapContextXMLHashValue( psRoot, "width", metadata, pszMetadataName );
+  sprintf(pszMetadataName, "%s_width", pszMetadataRoot);
+  msGetMapContextXMLHashValue(psRoot, "width", metadata, pszMetadataName);
 
-  sprintf( pszMetadataName, "%s_height", pszMetadataRoot );
-  msGetMapContextXMLHashValue( psRoot, "height", metadata, pszMetadataName );
+  sprintf(pszMetadataName, "%s_height", pszMetadataRoot);
+  msGetMapContextXMLHashValue(psRoot, "height", metadata, pszMetadataName);
 
-  sprintf( pszMetadataName, "%s_format", pszMetadataRoot );
-  msGetMapContextXMLHashValue( psRoot, "format", metadata, pszMetadataName );
+  sprintf(pszMetadataName, "%s_format", pszMetadataRoot);
+  msGetMapContextXMLHashValue(psRoot, "format", metadata, pszMetadataName);
 
-  sprintf( pszMetadataName, "%s_href", pszMetadataRoot );
-  msGetMapContextXMLHashValue( psRoot, "OnlineResource.xlink:href", metadata,
-                               pszMetadataName );
+  sprintf(pszMetadataName, "%s_href", pszMetadataRoot);
+  msGetMapContextXMLHashValue(psRoot, "OnlineResource.xlink:href", metadata,
+                              pszMetadataName);
 
   free(pszMetadataName);
 
@@ -269,15 +257,14 @@ int msLoadMapContextURLELements( CPLXMLN
 ** Put the keywords from a XML node and put them in a metadata.
 ** psRoot should be set to keywordlist
 */
-int msLoadMapContextListInMetadata( CPLXMLNode *psRoot, hashTableObj *metadata,
-                                    char *pszXMLName, char *pszMetadataName,
-                                    char *pszHashDelimiter)
-{
+int msLoadMapContextListInMetadata(CPLXMLNode *psRoot, hashTableObj *metadata,
+                                   char *pszXMLName, char *pszMetadataName,
+                                   char *pszHashDelimiter) {
   const char *pszHash, *pszXMLValue;
   char *pszMetadata;
 
-  if(psRoot == NULL || psRoot->psChild == NULL ||
-      metadata == NULL || pszMetadataName == NULL || pszXMLName == NULL)
+  if (psRoot == NULL || psRoot->psChild == NULL || metadata == NULL ||
+      pszMetadataName == NULL || pszXMLName == NULL)
     return MS_FAILURE;
 
   /* Pass from KeywordList to Keyword level */
@@ -289,13 +276,12 @@ int msLoadMapContextListInMetadata( CPLX
       pszXMLValue = psRoot->psChild->pszValue;
       pszHash = msLookupHashTable(metadata, pszMetadataName);
       if (pszHash != NULL) {
-        pszMetadata = (char*)malloc(strlen(pszHash)+
-                                    strlen(pszXMLValue)+2);
-        if(pszHashDelimiter == NULL)
-          sprintf( pszMetadata, "%s%s", pszHash, pszXMLValue );
+        pszMetadata = (char *)malloc(strlen(pszHash) + strlen(pszXMLValue) + 2);
+        if (pszHashDelimiter == NULL)
+          sprintf(pszMetadata, "%s%s", pszHash, pszXMLValue);
         else
-          sprintf( pszMetadata, "%s%s%s", pszHash, pszHashDelimiter,
-                   pszXMLValue );
+          sprintf(pszMetadata, "%s%s%s", pszHash, pszHashDelimiter,
+                  pszXMLValue);
         msInsertHashTable(metadata, pszMetadataName, pszMetadata);
         free(pszMetadata);
       } else
@@ -312,43 +298,40 @@ int msLoadMapContextListInMetadata( CPLX
 ** Put the Contact informations from a XML node and put them in a metadata.
 **
 */
-int msLoadMapContextContactInfo( CPLXMLNode *psRoot, hashTableObj *metadata )
-{
-  if(psRoot == NULL || metadata == NULL)
+int msLoadMapContextContactInfo(CPLXMLNode *psRoot, hashTableObj *metadata) {
+  if (psRoot == NULL || metadata == NULL)
     return MS_FAILURE;
 
   /* Contact Person primary */
-  msGetMapContextXMLHashValue(psRoot,
-                              "ContactPersonPrimary.ContactPerson",
+  msGetMapContextXMLHashValue(psRoot, "ContactPersonPrimary.ContactPerson",
                               metadata, "wms_contactperson");
   msGetMapContextXMLHashValue(psRoot,
                               "ContactPersonPrimary.ContactOrganization",
                               metadata, "wms_contactorganization");
   /* Contact Position */
-  msGetMapContextXMLHashValue(psRoot,
-                              "ContactPosition",
-                              metadata, "wms_contactposition");
+  msGetMapContextXMLHashValue(psRoot, "ContactPosition", metadata,
+                              "wms_contactposition");
   /* Contact Address */
-  msGetMapContextXMLHashValue(psRoot, "ContactAddress.AddressType",
-                              metadata, "wms_addresstype");
-  msGetMapContextXMLHashValue(psRoot, "ContactAddress.Address",
-                              metadata, "wms_address");
-  msGetMapContextXMLHashValue(psRoot, "ContactAddress.City",
-                              metadata, "wms_city");
+  msGetMapContextXMLHashValue(psRoot, "ContactAddress.AddressType", metadata,
+                              "wms_addresstype");
+  msGetMapContextXMLHashValue(psRoot, "ContactAddress.Address", metadata,
+                              "wms_address");
+  msGetMapContextXMLHashValue(psRoot, "ContactAddress.City", metadata,
+                              "wms_city");
   msGetMapContextXMLHashValue(psRoot, "ContactAddress.StateOrProvince",
                               metadata, "wms_stateorprovince");
-  msGetMapContextXMLHashValue(psRoot, "ContactAddress.PostCode",
-                              metadata, "wms_postcode");
-  msGetMapContextXMLHashValue(psRoot, "ContactAddress.Country",
-                              metadata, "wms_country");
+  msGetMapContextXMLHashValue(psRoot, "ContactAddress.PostCode", metadata,
+                              "wms_postcode");
+  msGetMapContextXMLHashValue(psRoot, "ContactAddress.Country", metadata,
+                              "wms_country");
 
   /* Others */
-  msGetMapContextXMLHashValue(psRoot, "ContactVoiceTelephone",
-                              metadata, "wms_contactvoicetelephone");
-  msGetMapContextXMLHashValue(psRoot, "ContactFacsimileTelephone",
-                              metadata, "wms_contactfacsimiletelephone");
-  msGetMapContextXMLHashValue(psRoot, "ContactElectronicMailAddress",
-                              metadata, "wms_contactelectronicmailaddress");
+  msGetMapContextXMLHashValue(psRoot, "ContactVoiceTelephone", metadata,
+                              "wms_contactvoicetelephone");
+  msGetMapContextXMLHashValue(psRoot, "ContactFacsimileTelephone", metadata,
+                              "wms_contactfacsimiletelephone");
+  msGetMapContextXMLHashValue(psRoot, "ContactElectronicMailAddress", metadata,
+                              "wms_contactelectronicmailaddress");
 
   return MS_SUCCESS;
 }
@@ -358,42 +341,35 @@ int msLoadMapContextContactInfo( CPLXMLN
 **
 **
 */
-int msLoadMapContextLayerFormat(CPLXMLNode *psFormat, layerObj *layer)
-{
+int msLoadMapContextLayerFormat(CPLXMLNode *psFormat, layerObj *layer) {
   const char *pszValue;
   char *pszValue1;
-  const char* pszHash;
+  const char *pszHash;
 
-  if(psFormat->psChild != NULL &&
-      strcasecmp(psFormat->pszValue, "Format") == 0 ) {
-    if(psFormat->psChild->psNext == NULL)
+  if (psFormat->psChild != NULL &&
+      strcasecmp(psFormat->pszValue, "Format") == 0) {
+    if (psFormat->psChild->psNext == NULL)
       pszValue = psFormat->psChild->pszValue;
     else
       pszValue = psFormat->psChild->psNext->pszValue;
   } else
     pszValue = NULL;
 
-  if(pszValue != NULL && strcasecmp(pszValue, "") != 0) {
+  if (pszValue != NULL && strcasecmp(pszValue, "") != 0) {
     /* wms_format */
-    pszValue1 = (char*)CPLGetXMLValue(psFormat,
-                                      "current", NULL);
-    if(pszValue1 != NULL &&
-        (strcasecmp(pszValue1, "1") == 0 || strcasecmp(pszValue1, "true")==0))
-      msInsertHashTable(&(layer->metadata),
-                        "wms_format", pszValue);
+    pszValue1 = (char *)CPLGetXMLValue(psFormat, "current", NULL);
+    if (pszValue1 != NULL &&
+        (strcasecmp(pszValue1, "1") == 0 || strcasecmp(pszValue1, "true") == 0))
+      msInsertHashTable(&(layer->metadata), "wms_format", pszValue);
     /* wms_formatlist */
-    pszHash = msLookupHashTable(&(layer->metadata),
-                                "wms_formatlist");
-    if(pszHash != NULL) {
-      pszValue1 = (char*)malloc(strlen(pszHash)+
-                                strlen(pszValue)+2);
+    pszHash = msLookupHashTable(&(layer->metadata), "wms_formatlist");
+    if (pszHash != NULL) {
+      pszValue1 = (char *)malloc(strlen(pszHash) + strlen(pszValue) + 2);
       sprintf(pszValue1, "%s,%s", pszHash, pszValue);
-      msInsertHashTable(&(layer->metadata),
-                        "wms_formatlist", pszValue1);
+      msInsertHashTable(&(layer->metadata), "wms_formatlist", pszValue1);
       free(pszValue1);
     } else
-      msInsertHashTable(&(layer->metadata),
-                        "wms_formatlist", pszValue);
+      msInsertHashTable(&(layer->metadata), "wms_formatlist", pszValue);
   }
 
   /* Make sure selected format is supported or select another
@@ -403,46 +379,43 @@ int msLoadMapContextLayerFormat(CPLXMLNo
    */
   pszValue = msLookupHashTable(&(layer->metadata), "wms_format");
 
-  if (
-    pszValue && (
+  if (pszValue && (
 #if !(defined USE_PNG)
-    strcasecmp(pszValue, "image/png") == 0 ||
-    strcasecmp(pszValue, "PNG") == 0 ||
+                      strcasecmp(pszValue, "image/png") == 0 ||
+                      strcasecmp(pszValue, "PNG") == 0 ||
 #endif
 #if !(defined USE_JPEG)
-    strcasecmp(pszValue, "image/jpeg") == 0 ||
-    strcasecmp(pszValue, "JPEG") == 0 ||
+                      strcasecmp(pszValue, "image/jpeg") == 0 ||
+                      strcasecmp(pszValue, "JPEG") == 0 ||
 #endif
-    0 )) {
-    char **papszList=NULL;
-    int i, numformats=0;
+                      0)) {
+    char **papszList = NULL;
+    int i, numformats = 0;
 
-    pszValue = msLookupHashTable(&(layer->metadata),
-                                 "wms_formatlist");
+    pszValue = msLookupHashTable(&(layer->metadata), "wms_formatlist");
 
     papszList = msStringSplit(pszValue, ',', &numformats);
-    for(i=0; i < numformats; i++) {
+    for (i = 0; i < numformats; i++) {
       if (
 #if (defined USE_PNG)
-        strcasecmp(papszList[i], "image/png") == 0 ||
-        strcasecmp(papszList[i], "PNG") == 0 ||
+          strcasecmp(papszList[i], "image/png") == 0 ||
+          strcasecmp(papszList[i], "PNG") == 0 ||
 #endif
 #if (defined USE_JPEG)
-        strcasecmp(papszList[i], "image/jpeg") == 0 ||
-        strcasecmp(papszList[i], "JPEG") == 0 ||
+          strcasecmp(papszList[i], "image/jpeg") == 0 ||
+          strcasecmp(papszList[i], "JPEG") == 0 ||
 #endif
 #ifdef USE_GD_GIF
-        strcasecmp(papszList[i], "image/gif") == 0 ||
-        strcasecmp(papszList[i], "GIF") == 0 ||
+          strcasecmp(papszList[i], "image/gif") == 0 ||
+          strcasecmp(papszList[i], "GIF") == 0 ||
 #endif
-        0 ) {
+          0) {
         /* Found a match */
-        msInsertHashTable(&(layer->metadata),
-                          "wms_format", papszList[i]);
+        msInsertHashTable(&(layer->metadata), "wms_format", papszList[i]);
         break;
       }
     }
-    if(papszList)
+    if (papszList)
       msFreeCharArray(papszList, numformats);
 
   } /* end if unsupported format */
@@ -451,81 +424,74 @@ int msLoadMapContextLayerFormat(CPLXMLNo
 }
 
 int msLoadMapContextLayerStyle(CPLXMLNode *psStyle, layerObj *layer,
-                               int nStyle)
-{
+                               int nStyle) {
   char *pszValue, *pszValue1, *pszValue2;
   const char *pszHash;
-  char* pszStyle=NULL;
+  char *pszStyle = NULL;
   char *pszStyleName;
   CPLXMLNode *psStyleSLDBody;
 
-  pszStyleName =(char*)CPLGetXMLValue(psStyle,"Name",NULL);
-  if(pszStyleName == NULL) {
-    pszStyleName = (char*)malloc(20);
+  pszStyleName = (char *)CPLGetXMLValue(psStyle, "Name", NULL);
+  if (pszStyleName == NULL) {
+    pszStyleName = (char *)malloc(20);
     sprintf(pszStyleName, "Style{%d}", nStyle);
   } else
     pszStyleName = msStrdup(pszStyleName);
 
   /* wms_style */
-  pszValue = (char*)CPLGetXMLValue(psStyle,"current",NULL);
-  if(pszValue != NULL &&
-      (strcasecmp(pszValue, "1") == 0 ||
-       strcasecmp(pszValue, "true") == 0))
-    msInsertHashTable(&(layer->metadata),
-                      "wms_style", pszStyleName);
+  pszValue = (char *)CPLGetXMLValue(psStyle, "current", NULL);
+  if (pszValue != NULL &&
+      (strcasecmp(pszValue, "1") == 0 || strcasecmp(pszValue, "true") == 0))
+    msInsertHashTable(&(layer->metadata), "wms_style", pszStyleName);
   /* wms_stylelist */
-  pszHash = msLookupHashTable(&(layer->metadata),
-                              "wms_stylelist");
-  if(pszHash != NULL) {
-    pszValue1 = (char*)malloc(strlen(pszHash)+
-                              strlen(pszStyleName)+2);
+  pszHash = msLookupHashTable(&(layer->metadata), "wms_stylelist");
+  if (pszHash != NULL) {
+    pszValue1 = (char *)malloc(strlen(pszHash) + strlen(pszStyleName) + 2);
     sprintf(pszValue1, "%s,%s", pszHash, pszStyleName);
-    msInsertHashTable(&(layer->metadata),
-                      "wms_stylelist", pszValue1);
+    msInsertHashTable(&(layer->metadata), "wms_stylelist", pszValue1);
     free(pszValue1);
   } else
-    msInsertHashTable(&(layer->metadata),
-                      "wms_stylelist", pszStyleName);
+    msInsertHashTable(&(layer->metadata), "wms_stylelist", pszStyleName);
 
   /* Title */
-  pszStyle = (char*)malloc(strlen(pszStyleName)+20);
-  sprintf(pszStyle,"wms_style_%s_title",pszStyleName);
+  pszStyle = (char *)malloc(strlen(pszStyleName) + 20);
+  sprintf(pszStyle, "wms_style_%s_title", pszStyleName);
 
-  if( msGetMapContextXMLHashValue(psStyle, "Title", &(layer->metadata),
-                                  pszStyle) == MS_FAILURE )
+  if (msGetMapContextXMLHashValue(psStyle, "Title", &(layer->metadata),
+                                  pszStyle) == MS_FAILURE)
     msInsertHashTable(&(layer->metadata), pszStyle, layer->name);
 
   free(pszStyle);
 
   /* SLD */
-  pszStyle = (char*)malloc(strlen(pszStyleName)+15);
+  pszStyle = (char *)malloc(strlen(pszStyleName) + 15);
   sprintf(pszStyle, "wms_style_%s_sld", pszStyleName);
 
-  msGetMapContextXMLHashValueDecode( psStyle, "SLD.OnlineResource.xlink:href",
-                                     &(layer->metadata), pszStyle );
+  msGetMapContextXMLHashValueDecode(psStyle, "SLD.OnlineResource.xlink:href",
+                                    &(layer->metadata), pszStyle);
   free(pszStyle);
 
   /* SLDBODY */
-  pszStyle = (char*)malloc(strlen(pszStyleName)+20);
+  pszStyle = (char *)malloc(strlen(pszStyleName) + 20);
   sprintf(pszStyle, "wms_style_%s_sld_body", pszStyleName);
 
   psStyleSLDBody = CPLGetXMLNode(psStyle, "SLD.StyledLayerDescriptor");
-  /*some clients such as OpenLayers add a name space, which I believe is wrong but
-   added this additional test for compatibility #3115*/
+  /*some clients such as OpenLayers add a name space, which I believe is wrong
+   but added this additional test for compatibility #3115*/
   if (psStyleSLDBody == NULL)
     psStyleSLDBody = CPLGetXMLNode(psStyle, "SLD.sld:StyledLayerDescriptor");
 
-  if(psStyleSLDBody != NULL && &(layer->metadata) != NULL) {
+  if (psStyleSLDBody != NULL && &(layer->metadata) != NULL) {
     pszValue = CPLSerializeXMLTree(psStyleSLDBody);
-    if(pszValue != NULL) {
+    if (pszValue != NULL) {
       /* Before including SLDBody in the mapfile, we must replace the */
       /* double quote for single quote. This is to prevent having this: */
       /* "metadata" "<string attriute="ttt">" */
       char *c;
-      for(c=pszValue; *c != '\0'; c++)
-        if(*c == '"')
+      for (c = pszValue; *c != '\0'; c++)
+        if (*c == '"')
           *c = '\'';
-      msInsertHashTable(&(layer->metadata), pszStyle, pszValue );
+      msInsertHashTable(&(layer->metadata), pszStyle, pszValue);
       msFree(pszValue);
     }
   }
@@ -533,12 +499,11 @@ int msLoadMapContextLayerStyle(CPLXMLNod
   free(pszStyle);
 
   /* LegendURL */
-  pszStyle = (char*) malloc(strlen(pszStyleName) + 25);
+  pszStyle = (char *)malloc(strlen(pszStyleName) + 25);
 
-  sprintf( pszStyle, "wms_style_%s_legendurl",
-           pszStyleName);
-  msLoadMapContextURLELements( CPLGetXMLNode(psStyle, "LegendURL"),
-                               &(layer->metadata), pszStyle );
+  sprintf(pszStyle, "wms_style_%s_legendurl", pszStyleName);
+  msLoadMapContextURLELements(CPLGetXMLNode(psStyle, "LegendURL"),
+                              &(layer->metadata), pszStyle);
 
   free(pszStyle);
 
@@ -547,20 +512,18 @@ int msLoadMapContextLayerStyle(CPLXMLNod
   /*  */
   /* Add the stylelist to the layer connection */
   /*  */
-  if(msLookupHashTable(&(layer->metadata),
-                       "wms_stylelist") == NULL) {
-    if(layer->connection)
+  if (msLookupHashTable(&(layer->metadata), "wms_stylelist") == NULL) {
+    if (layer->connection)
       pszValue = msStrdup(layer->connection);
     else
-      pszValue = msStrdup( "" );
+      pszValue = msStrdup("");
     pszValue1 = strstr(pszValue, "STYLELIST=");
-    if(pszValue1 != NULL) {
+    if (pszValue1 != NULL) {
       pszValue1 += 10;
       pszValue2 = strchr(pszValue, '&');
-      if(pszValue2 != NULL)
-        pszValue1[pszValue2-pszValue1] = '\0';
-      msInsertHashTable(&(layer->metadata), "wms_stylelist",
-                        pszValue1);
+      if (pszValue2 != NULL)
+        pszValue1[pszValue2 - pszValue1] = '\0';
+      msInsertHashTable(&(layer->metadata), "wms_stylelist", pszValue1);
     }
     free(pszValue);
   }
@@ -568,19 +531,18 @@ int msLoadMapContextLayerStyle(CPLXMLNod
   /*  */
   /* Add the style to the layer connection */
   /*  */
-  if(msLookupHashTable(&(layer->metadata), "wms_style") == NULL) {
-    if(layer->connection)
+  if (msLookupHashTable(&(layer->metadata), "wms_style") == NULL) {
+    if (layer->connection)
       pszValue = msStrdup(layer->connection);
     else
-      pszValue = msStrdup( "" );
+      pszValue = msStrdup("");
     pszValue1 = strstr(pszValue, "STYLE=");
-    if(pszValue1 != NULL) {
+    if (pszValue1 != NULL) {
       pszValue1 += 6;
       pszValue2 = strchr(pszValue, '&');
-      if(pszValue2 != NULL)
-        pszValue1[pszValue2-pszValue1] = '\0';
-      msInsertHashTable(&(layer->metadata), "wms_style",
-                        pszValue1);
+      if (pszValue2 != NULL)
+        pszValue1[pszValue2 - pszValue1] = '\0';
+      msInsertHashTable(&(layer->metadata), "wms_style", pszValue1);
     }
     free(pszValue);
   }
@@ -588,39 +550,34 @@ int msLoadMapContextLayerStyle(CPLXMLNod
   return MS_SUCCESS;
 }
 
-int msLoadMapContextLayerDimension(CPLXMLNode *psDimension, layerObj *layer)
-{
+int msLoadMapContextLayerDimension(CPLXMLNode *psDimension, layerObj *layer) {
   char *pszValue;
   const char *pszHash;
-  char *pszDimension=NULL, *pszDimensionName=NULL;
+  char *pszDimension = NULL, *pszDimensionName = NULL;
 
-  pszDimensionName =(char*)CPLGetXMLValue(psDimension,"name",NULL);
-  if(pszDimensionName == NULL) {
+  pszDimensionName = (char *)CPLGetXMLValue(psDimension, "name", NULL);
+  if (pszDimensionName == NULL) {
     return MS_FALSE;
   } else
     pszDimensionName = msStrdup(pszDimensionName);
 
-  pszDimension = (char*)malloc(strlen(pszDimensionName)+50);
+  pszDimension = (char *)malloc(strlen(pszDimensionName) + 50);
 
   /* wms_dimension: This is the current dimension */
-  pszValue = (char*)CPLGetXMLValue(psDimension, "current", NULL);
-  if(pszValue != NULL && (strcasecmp(pszValue, "1") == 0 ||
-                          strcasecmp(pszValue, "true") == 0))
-    msInsertHashTable(&(layer->metadata),
-                      "wms_dimension", pszDimensionName);
+  pszValue = (char *)CPLGetXMLValue(psDimension, "current", NULL);
+  if (pszValue != NULL &&
+      (strcasecmp(pszValue, "1") == 0 || strcasecmp(pszValue, "true") == 0))
+    msInsertHashTable(&(layer->metadata), "wms_dimension", pszDimensionName);
   /* wms_dimensionlist */
-  pszHash = msLookupHashTable(&(layer->metadata),
-                              "wms_dimensionlist");
-  if(pszHash != NULL) {
-    pszValue = (char*)malloc(strlen(pszHash)+
-                             strlen(pszDimensionName)+2);
+  pszHash = msLookupHashTable(&(layer->metadata), "wms_dimensionlist");
+  if (pszHash != NULL) {
+    pszValue = (char *)malloc(strlen(pszHash) + strlen(pszDimensionName) + 2);
     sprintf(pszValue, "%s,%s", pszHash, pszDimensionName);
-    msInsertHashTable(&(layer->metadata),
-                      "wms_dimensionlist", pszValue);
+    msInsertHashTable(&(layer->metadata), "wms_dimensionlist", pszValue);
     free(pszValue);
   } else
-    msInsertHashTable(&(layer->metadata),
-                      "wms_dimensionlist", pszDimensionName);
+    msInsertHashTable(&(layer->metadata), "wms_dimensionlist",
+                      pszDimensionName);
 
   /* Units */
   sprintf(pszDimension, "wms_dimension_%s_units", pszDimensionName);
@@ -636,7 +593,7 @@ int msLoadMapContextLayerDimension(CPLXM
   sprintf(pszDimension, "wms_dimension_%s_uservalue", pszDimensionName);
   msGetMapContextXMLHashValue(psDimension, "userValue", &(layer->metadata),
                               pszDimension);
-  if(strcasecmp(pszDimensionName, "time") == 0)
+  if (strcasecmp(pszDimensionName, "time") == 0)
     msGetMapContextXMLHashValue(psDimension, "userValue", &(layer->metadata),
                                 "wms_time");
 
@@ -647,7 +604,7 @@ int msLoadMapContextLayerDimension(CPLXM
 
   /* multipleValues */
   sprintf(pszDimension, "wms_dimension_%s_multiplevalues", pszDimensionName);
-  msGetMapContextXMLHashValue(psDimension, "multipleValues",&(layer->metadata),
+  msGetMapContextXMLHashValue(psDimension, "multipleValues", &(layer->metadata),
                               pszDimension);
 
   /* nearestValue */
@@ -662,8 +619,6 @@ int msLoadMapContextLayerDimension(CPLXM
   return MS_SUCCESS;
 }
 
-
-
 /*
 ** msLoadMapContextGeneral
 **
@@ -671,22 +626,20 @@ int msLoadMapContextLayerDimension(CPLXM
 */
 int msLoadMapContextGeneral(mapObj *map, CPLXMLNode *psGeneral,
                             CPLXMLNode *psMapContext, int nVersion,
-                            const char *filename)
-{
+                            const char *filename) {
 
-  char *pszProj=NULL;
+  char *pszProj = NULL;
   char *pszValue, *pszValue1, *pszValue2;
   int nTmp;
 
   /* Projection */
-  pszValue = (char*)CPLGetXMLValue(psGeneral,
-                                   "BoundingBox.SRS", NULL);
-  if(pszValue != NULL && !EQUAL(pszValue, "(null)")) {
-    if(strncasecmp(pszValue, "AUTO:", 5) == 0) {
+  pszValue = (char *)CPLGetXMLValue(psGeneral, "BoundingBox.SRS", NULL);
+  if (pszValue != NULL && !EQUAL(pszValue, "(null)")) {
+    if (strncasecmp(pszValue, "AUTO:", 5) == 0) {
       pszProj = msStrdup(pszValue);
     } else {
-      pszProj = (char*) malloc(sizeof(char)*(strlen(pszValue)+10));
-      sprintf(pszProj, "init=epsg:%s", pszValue+5);
+      pszProj = (char *)malloc(sizeof(char) * (strlen(pszValue) + 10));
+      sprintf(pszProj, "init=epsg:%s", pszValue + 5);
     }
 
     msFreeProjection(&map->projection);
@@ -695,104 +648,94 @@ int msLoadMapContextGeneral(mapObj *map,
     map->projection.numargs++;
     msProcessProjection(&map->projection);
 
-    if( (nTmp = GetMapserverUnitUsingProj(&(map->projection))) == -1) {
+    if ((nTmp = GetMapserverUnitUsingProj(&(map->projection))) == -1) {
+      msSetError(MS_MAPCONTEXTERR, "Unable to set units for projection '%s'",
+                 "msLoadMapContext()", pszProj);
       free(pszProj);
-      msSetError( MS_MAPCONTEXTERR,
-                  "Unable to set units for projection '%s'",
-                  "msLoadMapContext()", pszProj );
       return MS_FAILURE;
     } else {
       map->units = nTmp;
     }
     free(pszProj);
   } else {
-    msDebug("Mandatory data General.BoundingBox.SRS missing in %s.",
-            filename);
+    msDebug("Mandatory data General.BoundingBox.SRS missing in %s.", filename);
   }
 
   /* Extent */
-  if( msGetMapContextXMLFloatValue(psGeneral, "BoundingBox.minx",
+  if (msGetMapContextXMLFloatValue(psGeneral, "BoundingBox.minx",
                                    &(map->extent.minx)) == MS_FAILURE) {
-    msDebug("Mandatory data General.BoundingBox.minx missing in %s.",
-            filename);
+    msDebug("Mandatory data General.BoundingBox.minx missing in %s.", filename);
   }
-  if( msGetMapContextXMLFloatValue(psGeneral, "BoundingBox.miny",
+  if (msGetMapContextXMLFloatValue(psGeneral, "BoundingBox.miny",
                                    &(map->extent.miny)) == MS_FAILURE) {
-    msDebug("Mandatory data General.BoundingBox.miny missing in %s.",
-            filename);
+    msDebug("Mandatory data General.BoundingBox.miny missing in %s.", filename);
   }
-  if( msGetMapContextXMLFloatValue(psGeneral, "BoundingBox.maxx",
+  if (msGetMapContextXMLFloatValue(psGeneral, "BoundingBox.maxx",
                                    &(map->extent.maxx)) == MS_FAILURE) {
-    msDebug("Mandatory data General.BoundingBox.maxx missing in %s.",
-            filename);
+    msDebug("Mandatory data General.BoundingBox.maxx missing in %s.", filename);
   }
-  if( msGetMapContextXMLFloatValue(psGeneral, "BoundingBox.maxy",
+  if (msGetMapContextXMLFloatValue(psGeneral, "BoundingBox.maxy",
                                    &(map->extent.maxy)) == MS_FAILURE) {
-    msDebug("Mandatory data General.BoundingBox.maxy missing in %s.",
-            filename);
+    msDebug("Mandatory data General.BoundingBox.maxy missing in %s.", filename);
   }
 
   /* Title */
-  if( msGetMapContextXMLHashValue(psGeneral, "Title",
-                                  &(map->web.metadata), "wms_title") == MS_FAILURE) {
-    if ( nVersion >= OWS_1_0_0 )
+  if (msGetMapContextXMLHashValue(psGeneral, "Title", &(map->web.metadata),
+                                  "wms_title") == MS_FAILURE) {
+    if (nVersion >= OWS_1_0_0)
       msDebug("Mandatory data General.Title missing in %s.", filename);
     else {
-      if( msGetMapContextXMLHashValue(psGeneral, "gml:name",
-                                      &(map->web.metadata), "wms_title") == MS_FAILURE ) {
-        if( nVersion < OWS_0_1_7 )
+      if (msGetMapContextXMLHashValue(psGeneral, "gml:name",
+                                      &(map->web.metadata),
+                                      "wms_title") == MS_FAILURE) {
+        if (nVersion < OWS_0_1_7)
           msDebug("Mandatory data General.Title missing in %s.", filename);
         else
-          msDebug("Mandatory data General.gml:name missing in %s.",
-                  filename);
+          msDebug("Mandatory data General.gml:name missing in %s.", filename);
       }
     }
   }
 
   /* Name */
-  if( nVersion >= OWS_1_0_0 ) {
-    pszValue = (char*)CPLGetXMLValue(psMapContext,
-                                     "id", NULL);
-    if (pszValue)
-    {
+  if (nVersion >= OWS_1_0_0) {
+    pszValue = (char *)CPLGetXMLValue(psMapContext, "id", NULL);
+    if (pszValue) {
       msFree(map->name);
       map->name = msStrdup(pszValue);
     }
   } else {
-    char* pszMapName = NULL;
-    if(msGetMapContextXMLStringValue(psGeneral, "Name",
-                                     &pszMapName) == MS_FAILURE) {
-      msGetMapContextXMLStringValue(psGeneral, "gml:name",
-                                    &pszMapName);
+    char *pszMapName = NULL;
+    if (msGetMapContextXMLStringValue(psGeneral, "Name", &pszMapName) ==
+        MS_FAILURE) {
+      msGetMapContextXMLStringValue(psGeneral, "gml:name", &pszMapName);
     }
-    if( pszMapName ) {
+    if (pszMapName) {
       msFree(map->name);
       map->name = pszMapName;
     }
   }
   /* Keyword */
-  if( nVersion >= OWS_1_0_0 ) {
-    msLoadMapContextListInMetadata(
-      CPLGetXMLNode(psGeneral, "KeywordList"),
-      &(map->web.metadata), "KEYWORD", "wms_keywordlist", "," );
+  if (nVersion >= OWS_1_0_0) {
+    msLoadMapContextListInMetadata(CPLGetXMLNode(psGeneral, "KeywordList"),
+                                   &(map->web.metadata), "KEYWORD",
+                                   "wms_keywordlist", ",");
   } else
-    msGetMapContextXMLHashValue(psGeneral, "Keywords",
-                                &(map->web.metadata), "wms_keywordlist");
+    msGetMapContextXMLHashValue(psGeneral, "Keywords", &(map->web.metadata),
+                                "wms_keywordlist");
 
   /* Window */
-  pszValue1 = (char*)CPLGetXMLValue(psGeneral,"Window.width",NULL);
-  pszValue2 = (char*)CPLGetXMLValue(psGeneral,"Window.height",NULL);
-  if(pszValue1 != NULL && pszValue2 != NULL) {
+  pszValue1 = (char *)CPLGetXMLValue(psGeneral, "Window.width", NULL);
+  pszValue2 = (char *)CPLGetXMLValue(psGeneral, "Window.height", NULL);
+  if (pszValue1 != NULL && pszValue2 != NULL) {
     map->width = atoi(pszValue1);
     map->height = atoi(pszValue2);
   }
 
   /* Abstract */
-  if( msGetMapContextXMLHashValue( psGeneral,
-                                   "Abstract", &(map->web.metadata),
-                                   "wms_abstract") == MS_FAILURE ) {
-    msGetMapContextXMLHashValue( psGeneral, "gml:description",
-                                 &(map->web.metadata), "wms_abstract");
+  if (msGetMapContextXMLHashValue(psGeneral, "Abstract", &(map->web.metadata),
+                                  "wms_abstract") == MS_FAILURE) {
+    msGetMapContextXMLHashValue(psGeneral, "gml:description",
+                                &(map->web.metadata), "wms_abstract");
   }
 
   /* DataURL */
@@ -802,19 +745,17 @@ int msLoadMapContextGeneral(mapObj *map,
 
   /* LogoURL */
   /* The logourl have a width, height, format and an URL */
-  msLoadMapContextURLELements( CPLGetXMLNode(psGeneral, "LogoURL"),
-                               &(map->web.metadata), "wms_logourl" );
+  msLoadMapContextURLELements(CPLGetXMLNode(psGeneral, "LogoURL"),
+                              &(map->web.metadata), "wms_logourl");
 
   /* DescriptionURL */
   /* The descriptionurl have a width, height, format and an URL */
-  msLoadMapContextURLELements( CPLGetXMLNode(psGeneral,
-                               "DescriptionURL"),
-                               &(map->web.metadata), "wms_descriptionurl" );
+  msLoadMapContextURLELements(CPLGetXMLNode(psGeneral, "DescriptionURL"),
+                              &(map->web.metadata), "wms_descriptionurl");
 
   /* Contact Info */
-  msLoadMapContextContactInfo(
-    CPLGetXMLNode(psGeneral, "ContactInformation"),
-    &(map->web.metadata) );
+  msLoadMapContextContactInfo(CPLGetXMLNode(psGeneral, "ContactInformation"),
+                              &(map->web.metadata));
 
   return MS_SUCCESS;
 }
@@ -825,18 +766,17 @@ int msLoadMapContextGeneral(mapObj *map,
 ** Load a Layer block from a MapContext document
 */
 int msLoadMapContextLayer(mapObj *map, CPLXMLNode *psLayer, int nVersion,
-                          const char *filename, int unique_layer_names)
-{
+                          const char *filename, int unique_layer_names) {
   char *pszValue;
   const char *pszHash;
-  char *pszName=NULL;
+  char *pszName = NULL;
   CPLXMLNode *psFormatList, *psFormat, *psStyleList, *psStyle, *psExtension;
   CPLXMLNode *psDimensionList, *psDimension;
   int nStyle;
   layerObj *layer;
 
   /* Init new layer */
-  if(msGrowMapLayers(map) == NULL)
+  if (msGrowMapLayers(map) == NULL)
     return MS_FAILURE;
 
   layer = (GET_LAYER(map, map->numlayers));
@@ -848,57 +788,57 @@ int msLoadMapContextLayer(mapObj *map, C
   map->layerorder[map->numlayers] = map->numlayers;
   map->numlayers++;
 
-
   /* Status */
-  pszValue = (char*)CPLGetXMLValue(psLayer, "hidden", "1");
-  if((pszValue != NULL) && (atoi(pszValue) == 0 &&
-                            strcasecmp(pszValue, "true") != 0))
+  pszValue = (char *)CPLGetXMLValue(psLayer, "hidden", "1");
+  if ((pszValue != NULL) &&
+      (atoi(pszValue) == 0 && strcasecmp(pszValue, "true") != 0))
     layer->status = MS_ON;
   else
     layer->status = MS_OFF;
 
   /* Queryable */
-  pszValue = (char*)CPLGetXMLValue(psLayer, "queryable", "0");
-  if(pszValue !=NULL && (atoi(pszValue) == 1  ||
-                         strcasecmp(pszValue, "true") == 0))
+  pszValue = (char *)CPLGetXMLValue(psLayer, "queryable", "0");
+  if (pszValue != NULL &&
+      (atoi(pszValue) == 1 || strcasecmp(pszValue, "true") == 0))
     layer->template = msStrdup("ttt");
 
   /* Name and Title */
-  pszValue = (char*)CPLGetXMLValue(psLayer, "Name", NULL);
-  if(pszValue != NULL) {
-    msInsertHashTable( &(layer->metadata), "wms_name", pszValue );
+  pszValue = (char *)CPLGetXMLValue(psLayer, "Name", NULL);
+  if (pszValue != NULL) {
+    msInsertHashTable(&(layer->metadata), "wms_name", pszValue);
 
     if (unique_layer_names) {
-      pszName = (char*)malloc(sizeof(char)*(strlen(pszValue)+15));
+      pszName = (char *)malloc(sizeof(char) * (strlen(pszValue) + 15));
       sprintf(pszName, "l%d:%s", layer->index, pszValue);
       layer->name = msStrdup(pszName);
       free(pszName);
     } else
-      layer->name  = msStrdup(pszValue);
+      layer->name = msStrdup(pszValue);
   } else {
-    pszName = (char*)malloc(sizeof(char)*15);
+    pszName = (char *)malloc(sizeof(char) * 15);
     sprintf(pszName, "l%d:", layer->index);
     layer->name = msStrdup(pszName);
     free(pszName);
   }
 
-  if(msGetMapContextXMLHashValue(psLayer, "Title", &(layer->metadata),
-                                 "wms_title") == MS_FAILURE) {
-    if(msGetMapContextXMLHashValue(psLayer, "Server.title",
-                                   &(layer->metadata), "wms_title") == MS_FAILURE) {
+  if (msGetMapContextXMLHashValue(psLayer, "Title", &(layer->metadata),
+                                  "wms_title") == MS_FAILURE) {
+    if (msGetMapContextXMLHashValue(psLayer, "Server.title", &(layer->metadata),
+                                    "wms_title") == MS_FAILURE) {
       msDebug("Mandatory data Layer.Title missing in %s.", filename);
     }
   }
 
   /* Server Title */
-  msGetMapContextXMLHashValue(psLayer, "Server.title", &(layer->metadata),  "wms_server_title");
+  msGetMapContextXMLHashValue(psLayer, "Server.title", &(layer->metadata),
+                              "wms_server_title");
 
   /* Abstract */
   msGetMapContextXMLHashValue(psLayer, "Abstract", &(layer->metadata),
                               "wms_abstract");
 
   /* DataURL */
-  if(nVersion <= OWS_0_1_4) {
+  if (nVersion <= OWS_0_1_4) {
     msGetMapContextXMLHashValueDecode(psLayer,
                                       "DataURL.OnlineResource.xlink:href",
                                       &(layer->metadata), "wms_dataurl");
@@ -906,71 +846,74 @@ int msLoadMapContextLayer(mapObj *map, C
     /* The DataURL have a width, height, format and an URL */
     /* Width and height are not used, but they are included to */
     /* be consistent with the spec. */
-    msLoadMapContextURLELements( CPLGetXMLNode(psLayer, "DataURL"),
-                                 &(layer->metadata), "wms_dataurl" );
+    msLoadMapContextURLELements(CPLGetXMLNode(psLayer, "DataURL"),
+                                &(layer->metadata), "wms_dataurl");
   }
 
   /* The MetadataURL have a width, height, format and an URL */
   /* Width and height are not used, but they are included to */
   /* be consistent with the spec. */
-  msLoadMapContextURLELements( CPLGetXMLNode(psLayer, "MetadataURL"),
-                               &(layer->metadata), "wms_metadataurl" );
-
+  msLoadMapContextURLELements(CPLGetXMLNode(psLayer, "MetadataURL"),
+                              &(layer->metadata), "wms_metadataurl");
 
   /* MinScale && MaxScale */
-  pszValue = (char*)CPLGetXMLValue(psLayer, "sld:MinScaleDenominator", NULL);
-  if(pszValue != NULL) {
+  pszValue = (char *)CPLGetXMLValue(psLayer, "sld:MinScaleDenominator", NULL);
+  if (pszValue != NULL) {
     layer->minscaledenom = atof(pszValue);
   }
 
-  pszValue = (char*)CPLGetXMLValue(psLayer, "sld:MaxScaleDenominator", NULL);
-  if(pszValue != NULL) {
+  pszValue = (char *)CPLGetXMLValue(psLayer, "sld:MaxScaleDenominator", NULL);
+  if (pszValue != NULL) {
     layer->maxscaledenom = atof(pszValue);
   }
 
   /*  */
   /* Server */
   /*  */
-  if(nVersion >= OWS_0_1_4) {
-    if(msGetMapContextXMLStringValueDecode(psLayer,
-                                           "Server.OnlineResource.xlink:href",
-                                           &(layer->connection)) == MS_FAILURE) {
-      msSetError(MS_MAPCONTEXTERR,
-                 "Mandatory data Server.OnlineResource.xlink:href missing in %s.",
-                 "msLoadMapContext()", filename);
+  if (nVersion >= OWS_0_1_4) {
+    if (msGetMapContextXMLStringValueDecode(
+            psLayer, "Server.OnlineResource.xlink:href",
+            &(layer->connection)) == MS_FAILURE) {
+      msSetError(
+          MS_MAPCONTEXTERR,
+          "Mandatory data Server.OnlineResource.xlink:href missing in %s.",
+          "msLoadMapContext()", filename);
       return MS_FAILURE;
     } else {
-      msGetMapContextXMLHashValueDecode(psLayer,
-                                        "Server.OnlineResource.xlink:href",
-                                        &(layer->metadata), "wms_onlineresource");
+      msGetMapContextXMLHashValueDecode(
+          psLayer, "Server.OnlineResource.xlink:href", &(layer->metadata),
+          "wms_onlineresource");
       layer->connectiontype = MS_WMS;
     }
   } else {
-    if(msGetMapContextXMLStringValueDecode(psLayer,
-                                           "Server.onlineResource",
-                                           &(layer->connection)) == MS_FAILURE) {
+    if (msGetMapContextXMLStringValueDecode(psLayer, "Server.onlineResource",
+                                            &(layer->connection)) ==
+        MS_FAILURE) {
       msSetError(MS_MAPCONTEXTERR,
                  "Mandatory data Server.onlineResource missing in %s.",
                  "msLoadMapContext()", filename);
       return MS_FAILURE;
     } else {
       msGetMapContextXMLHashValueDecode(psLayer, "Server.onlineResource",
-                                        &(layer->metadata), "wms_onlineresource");
+                                        &(layer->metadata),
+                                        "wms_onlineresource");
       layer->connectiontype = MS_WMS;
     }
   }
 
-  if(nVersion >= OWS_0_1_4) {
-    if(msGetMapContextXMLHashValue(psLayer, "Server.version",
-                                   &(layer->metadata), "wms_server_version") == MS_FAILURE) {
+  if (nVersion >= OWS_0_1_4) {
+    if (msGetMapContextXMLHashValue(psLayer, "Server.version",
+                                    &(layer->metadata),
+                                    "wms_server_version") == MS_FAILURE) {
       msSetError(MS_MAPCONTEXTERR,
                  "Mandatory data Server.version missing in %s.",
                  "msLoadMapContext()", filename);
       return MS_FAILURE;
     }
   } else {
-    if(msGetMapContextXMLHashValue(psLayer, "Server.wmtver",
-                                   &(layer->metadata), "wms_server_version") == MS_FAILURE) {
+    if (msGetMapContextXMLHashValue(psLayer, "Server.wmtver",
+                                    &(layer->metadata),
+                                    "wms_server_version") == MS_FAILURE) {
       msSetError(MS_MAPCONTEXTERR,
                  "Mandatory data Server.wmtver missing in %s.",
                  "msLoadMapContext()", filename);
@@ -979,23 +922,23 @@ int msLoadMapContextLayer(mapObj *map, C
   }
 
   /* Projection */
-  msLoadMapContextListInMetadata( psLayer, &(layer->metadata),
-                                  "SRS", "wms_srs", " " );
+  msLoadMapContextListInMetadata(psLayer, &(layer->metadata), "SRS", "wms_srs",
+                                 " ");
 
   pszHash = msLookupHashTable(&(layer->metadata), "wms_srs");
-  if(((pszHash == NULL) || (strcasecmp(pszHash, "") == 0)) &&
+  if (((pszHash == NULL) || (strcasecmp(pszHash, "") == 0)) &&
       map->projection.numargs != 0) {
-    char* pszProj = map->projection.args[map->projection.numargs-1];
+    char *pszProj = map->projection.args[map->projection.numargs - 1];
 
-    if(pszProj != NULL) {
-      if(strncasecmp(pszProj, "AUTO:", 5) == 0) {
-        msInsertHashTable(&(layer->metadata),"wms_srs", pszProj);
+    if (pszProj != NULL) {
+      if (strncasecmp(pszProj, "AUTO:", 5) == 0) {
+        msInsertHashTable(&(layer->metadata), "wms_srs", pszProj);
       } else {
-        if(strlen(pszProj) > 10) {
-          pszProj = (char*) malloc(sizeof(char) * (strlen(pszProj)));
-          sprintf( pszProj, "EPSG:%s",
-                   map->projection.args[map->projection.numargs-1]+10);
-          msInsertHashTable(&(layer->metadata),"wms_srs", pszProj);
+        if (strlen(pszProj) > 10) {
+          pszProj = (char *)malloc(sizeof(char) * (strlen(pszProj)));
+          sprintf(pszProj, "EPSG:%s",
+                  map->projection.args[map->projection.numargs - 1] + 10);
+          msInsertHashTable(&(layer->metadata), "wms_srs", pszProj);
         } else {
           msDebug("Unable to set data for layer wms_srs from this"
                   " value %s.",
@@ -1009,34 +952,32 @@ int msLoadMapContextLayer(mapObj *map, C
   /*  */
   /* Format */
   /*  */
-  if( nVersion >= OWS_0_1_4 ) {
+  if (nVersion >= OWS_0_1_4) {
     psFormatList = CPLGetXMLNode(psLayer, "FormatList");
   } else {
     psFormatList = psLayer;
   }
 
-  if(psFormatList != NULL) {
-    for(psFormat = psFormatList->psChild;
-        psFormat != NULL;
-        psFormat = psFormat->psNext) {
+  if (psFormatList != NULL) {
+    for (psFormat = psFormatList->psChild; psFormat != NULL;
+         psFormat = psFormat->psNext) {
       msLoadMapContextLayerFormat(psFormat, layer);
     }
 
   } /* end FormatList parsing */
 
   /* Style */
-  if( nVersion >= OWS_0_1_4 ) {
+  if (nVersion >= OWS_0_1_4) {
     psStyleList = CPLGetXMLNode(psLayer, "StyleList");
   } else {
     psStyleList = psLayer;
   }
 
-  if(psStyleList != NULL) {
+  if (psStyleList != NULL) {
     nStyle = 0;
-    for(psStyle = psStyleList->psChild;
-        psStyle != NULL;
-        psStyle = psStyle->psNext) {
-      if(strcasecmp(psStyle->pszValue, "Style") == 0) {
+    for (psStyle = psStyleList->psChild; psStyle != NULL;
+         psStyle = psStyle->psNext) {
+      if (strcasecmp(psStyle->pszValue, "Style") == 0) {
         nStyle++;
         msLoadMapContextLayerStyle(psStyle, layer, nStyle);
       }
@@ -1045,11 +986,10 @@ int msLoadMapContextLayer(mapObj *map, C
 
   /* Dimension */
   psDimensionList = CPLGetXMLNode(psLayer, "DimensionList");
-  if(psDimensionList != NULL) {
-    for(psDimension = psDimensionList->psChild;
-        psDimension != NULL;
-        psDimension = psDimension->psNext) {
-      if(strcasecmp(psDimension->pszValue, "Dimension") == 0) {
+  if (psDimensionList != NULL) {
+    for (psDimension = psDimensionList->psChild; psDimension != NULL;
+         psDimension = psDimension->psNext) {
+      if (strcasecmp(psDimension->pszValue, "Dimension") == 0) {
         msLoadMapContextLayerDimension(psDimension, layer);
       }
     }
@@ -1058,13 +998,13 @@ int msLoadMapContextLayer(mapObj *map, C
   /* Extension */
   psExtension = CPLGetXMLNode(psLayer, "Extension");
   if (psExtension != NULL) {
-    pszValue = (char*)CPLGetXMLValue(psExtension, "ol:opacity", NULL);
-    if(pszValue != NULL) {
-      if(!layer->compositer) {
+    pszValue = (char *)CPLGetXMLValue(psExtension, "ol:opacity", NULL);
+    if (pszValue != NULL) {
+      if (!layer->compositer) {
         layer->compositer = msSmallMalloc(sizeof(LayerCompositer));
         initLayerCompositer(layer->compositer);
       }
-      layer->compositer->opacity = atof(pszValue)*100;
+      layer->compositer->opacity = atof(pszValue) * 100;
     }
   }
 
@@ -1073,8 +1013,6 @@ int msLoadMapContextLayer(mapObj *map, C
 
 #endif
 
-
-
 /* msLoadMapContextURL()
 **
 ** load an OGC Web Map Context format from an URL
@@ -1082,25 +1020,24 @@ int msLoadMapContextLayer(mapObj *map, C
 ** Take a map object and a URL to a conect file in arguments
 */
 
-int msLoadMapContextURL(mapObj *map, char *urlfilename, int unique_layer_names)
-{
+int msLoadMapContextURL(mapObj *map, char *urlfilename,
+                        int unique_layer_names) {
 #if defined(USE_WMS_LYR)
   char *pszTmpFile = NULL;
   int status = 0;
 
   if (!map || !urlfilename) {
-    msSetError(MS_MAPCONTEXTERR,
-               "Invalid map or url given.",
+    msSetError(MS_MAPCONTEXTERR, "Invalid map or url given.",
                "msGetMapContextURL()");
     return MS_FAILURE;
   }
 
   pszTmpFile = msTmpFile(map, map->mappath, NULL, "context.xml");
-  if (msHTTPGetFile(urlfilename, pszTmpFile, &status,-1, 0, 0, 0) ==  MS_SUCCESS) {
+  if (msHTTPGetFile(urlfilename, pszTmpFile, &status, -1, 0, 0, 0) ==
+      MS_SUCCESS) {
     return msLoadMapContext(map, pszTmpFile, unique_layer_names);
   } else {
-    msSetError(MS_MAPCONTEXTERR,
-               "Could not open context file %s.",
+    msSetError(MS_MAPCONTEXTERR, "Could not open context file %s.",
                "msGetMapContextURL()", urlfilename);
     return MS_FAILURE;
   }
@@ -1118,22 +1055,25 @@ int msLoadMapContextURL(mapObj *map, cha
 **
 ** Take as first map object and a file in arguments
 ** If The 2nd aregument unique_layer_names is set to MS_TRUE, the layer
-** name created would be unique and be prefixed with an l plus the layers's index
+** name created would be unique and be prefixed with an l plus the layers's
+*index
 ** (eg l:1:park. l:2:road ...). If It is set to MS_FALSE, the layer name
 ** would be the same name as the layer name in the context
 */
-int msLoadMapContext(mapObj *map, const char *filename, int unique_layer_names)
-{
+int msLoadMapContext(mapObj *map, const char *filename,
+                     int unique_layer_names) {
 #if defined(USE_WMS_LYR)
   char *pszWholeText, *pszValue;
   CPLXMLNode *psRoot, *psMapContext, *psLayer, *psLayerList, *psChild;
   char szPath[MS_MAXPATHLEN];
-  int nVersion=-1;
+  int nVersion = -1;
   char szVersionBuf[OWS_VERSION_MAXLEN];
 
-  const char *ms_contextfile_pattern = CPLGetConfigOption("MS_CONTEXTFILE_PATTERN", MS_DEFAULT_CONTEXTFILE_PATTERN);
-  if(msEvalRegex(ms_contextfile_pattern, filename) != MS_TRUE) {
-    msSetError(MS_REGEXERR, "Filename validation failed." , "msLoadMapContext()");
+  const char *ms_contextfile_pattern = CPLGetConfigOption(
+      "MS_CONTEXTFILE_PATTERN", MS_DEFAULT_CONTEXTFILE_PATTERN);
+  if (msEvalRegex(ms_contextfile_pattern, filename) != MS_TRUE) {
+    msSetError(MS_REGEXERR, "Filename validation failed.",
+               "msLoadMapContext()");
     return MS_FAILURE;
   }
 
@@ -1141,35 +1081,35 @@ int msLoadMapContext(mapObj *map, const
   /* Load the raw XML file */
   /*  */
 
-  pszWholeText = msGetMapContextFileText(
-                   msBuildPath(szPath, map->mappath, filename));
-  if(pszWholeText == NULL) {
-    msSetError( MS_MAPCONTEXTERR, "Unable to read %s",
-                "msLoadMapContext()", filename );
+  pszWholeText =
+      msGetMapContextFileText(msBuildPath(szPath, map->mappath, filename));
+  if (pszWholeText == NULL) {
+    msSetError(MS_MAPCONTEXTERR, "Unable to read %s", "msLoadMapContext()",
+               filename);
     return MS_FAILURE;
   }
 
-  if( ( strstr( pszWholeText, "<WMS_Viewer_Context" ) == NULL ) &&
-      ( strstr( pszWholeText, "<View_Context" ) == NULL ) &&
-      ( strstr( pszWholeText, "<ViewContext" ) == NULL ) )
+  if ((strstr(pszWholeText, "<WMS_Viewer_Context") == NULL) &&
+      (strstr(pszWholeText, "<View_Context") == NULL) &&
+      (strstr(pszWholeText, "<ViewContext") == NULL))
 
   {
-    free( pszWholeText );
-    msSetError( MS_MAPCONTEXTERR, "Not a Map Context file (%s)",
-                "msLoadMapContext()", filename );
+    free(pszWholeText);
+    msSetError(MS_MAPCONTEXTERR, "Not a Map Context file (%s)",
+               "msLoadMapContext()", filename);
     return MS_FAILURE;
   }
 
   /*  */
   /* Convert to XML parse tree. */
   /*  */
-  psRoot = CPLParseXMLString( pszWholeText );
-  free( pszWholeText );
+  psRoot = CPLParseXMLString(pszWholeText);
+  free(pszWholeText);
 
   /* We assume parser will report errors via CPL. */
-  if( psRoot == NULL ) {
-    msSetError( MS_MAPCONTEXTERR, "Invalid XML file (%s)",
-                "msLoadMapContext()", filename );
+  if (psRoot == NULL) {
+    msSetError(MS_MAPCONTEXTERR, "Invalid XML file (%s)", "msLoadMapContext()",
+               filename);
     return MS_FAILURE;
   }
 
@@ -1178,11 +1118,11 @@ int msLoadMapContext(mapObj *map, const
   /*  */
   psChild = psRoot;
   psMapContext = NULL;
-  while( psChild != NULL ) {
-    if( psChild->eType == CXT_Element &&
-        (EQUAL(psChild->pszValue,"WMS_Viewer_Context") ||
-         EQUAL(psChild->pszValue,"View_Context") ||
-         EQUAL(psChild->pszValue,"ViewContext")) ) {
+  while (psChild != NULL) {
+    if (psChild->eType == CXT_Element &&
+        (EQUAL(psChild->pszValue, "WMS_Viewer_Context") ||
+         EQUAL(psChild->pszValue, "View_Context") ||
+         EQUAL(psChild->pszValue, "ViewContext"))) {
       psMapContext = psChild;
       break;
     } else {
@@ -1190,19 +1130,19 @@ int msLoadMapContext(mapObj *map, const
     }
   }
 
-  if( psMapContext == NULL ) {
+  if (psMapContext == NULL) {
     CPLDestroyXMLNode(psRoot);
-    msSetError( MS_MAPCONTEXTERR, "Invalid Map Context File (%s)",
-                "msLoadMapContext()", filename );
+    msSetError(MS_MAPCONTEXTERR, "Invalid Map Context File (%s)",
+               "msLoadMapContext()", filename);
     return MS_FAILURE;
   }
 
   /* Fetch document version number */
-  pszValue = (char*)CPLGetXMLValue(psMapContext,
-                                   "version", NULL);
-  if( !pszValue ) {
-    msDebug( "msLoadMapContext(): Mandatory data version missing in %s, assuming 0.1.4.",
-             filename );
+  pszValue = (char *)CPLGetXMLValue(psMapContext, "version", NULL);
+  if (!pszValue) {
+    msDebug("msLoadMapContext(): Mandatory data version missing in %s, "
+            "assuming 0.1.4.",
+            filename);
     pszValue = "0.1.4";
   }
 
@@ -1210,29 +1150,29 @@ int msLoadMapContext(mapObj *map, const
 
   /* Make sure this is a supported version */
   switch (nVersion) {
-    case OWS_0_1_2:
-    case OWS_0_1_4:
-    case OWS_0_1_7:
-    case OWS_1_0_0:
-    case OWS_1_1_0:
-      /* All is good, this is a supported version. */
-      break;
-    default:
-      /* Not a supported version */
-      msSetError(MS_MAPCONTEXTERR,
-                 "This version of Map Context is not supported (%s).",
-                 "msLoadMapContext()", pszValue);
-      CPLDestroyXMLNode(psRoot);
-      return MS_FAILURE;
+  case OWS_0_1_2:
+  case OWS_0_1_4:
+  case OWS_0_1_7:
+  case OWS_1_0_0:
+  case OWS_1_1_0:
+    /* All is good, this is a supported version. */
+    break;
+  default:
+    /* Not a supported version */
+    msSetError(MS_MAPCONTEXTERR,
+               "This version of Map Context is not supported (%s).",
+               "msLoadMapContext()", pszValue);
+    CPLDestroyXMLNode(psRoot);
+    return MS_FAILURE;
   }
 
   /* Reformat and save Version in metadata */
-  msInsertHashTable( &(map->web.metadata), "wms_context_version",
-                     msOWSGetVersionString(nVersion, szVersionBuf));
+  msInsertHashTable(&(map->web.metadata), "wms_context_version",
+                    msOWSGetVersionString(nVersion, szVersionBuf));
 
-  if( nVersion >= OWS_0_1_7 && nVersion < OWS_1_0_0) {
-    if( msGetMapContextXMLHashValue(psMapContext, "fid",
-                                    &(map->web.metadata), "wms_context_fid") == MS_FAILURE ) {
+  if (nVersion >= OWS_0_1_7 && nVersion < OWS_1_0_0) {
+    if (msGetMapContextXMLHashValue(psMapContext, "fid", &(map->web.metadata),
+                                    "wms_context_fid") == MS_FAILURE) {
       msDebug("Mandatory data fid missing in %s.", filename);
     }
   }
@@ -1240,8 +1180,8 @@ int msLoadMapContext(mapObj *map, const
   /*  */
   /* Load the General bloc */
   /*  */
-  psChild = CPLGetXMLNode( psMapContext, "General" );
-  if( psChild == NULL ) {
+  psChild = CPLGetXMLNode(psMapContext, "General");
+  if (psChild == NULL) {
     CPLDestroyXMLNode(psRoot);
     msSetError(MS_MAPCONTEXTERR,
                "The Map Context document provided (%s) does not contain any "
@@ -1250,8 +1190,8 @@ int msLoadMapContext(mapObj *map, const
     return MS_FAILURE;
   }
 
-  if( msLoadMapContextGeneral(map, psChild, psMapContext,
-                              nVersion, filename) == MS_FAILURE ) {
+  if (msLoadMapContextGeneral(map, psChild, psMapContext, nVersion, filename) ==
+      MS_FAILURE) {
     CPLDestroyXMLNode(psRoot);
     return MS_FAILURE;
   }
@@ -1260,18 +1200,17 @@ int msLoadMapContext(mapObj *map, const
   /* Load the bloc LayerList */
   /*  */
   psLayerList = CPLGetXMLNode(psMapContext, "LayerList");
-  if( psLayerList != NULL ) {
-    for(psLayer = psLayerList->psChild;
-        psLayer != NULL;
-        psLayer = psLayer->psNext) {
-      if(EQUAL(psLayer->pszValue, "Layer")) {
-        if( msLoadMapContextLayer(map, psLayer, nVersion,
-                                  filename, unique_layer_names) == MS_FAILURE ) {
+  if (psLayerList != NULL) {
+    for (psLayer = psLayerList->psChild; psLayer != NULL;
+         psLayer = psLayer->psNext) {
+      if (EQUAL(psLayer->pszValue, "Layer")) {
+        if (msLoadMapContextLayer(map, psLayer, nVersion, filename,
+                                  unique_layer_names) == MS_FAILURE) {
           CPLDestroyXMLNode(psRoot);
           return MS_FAILURE;
         }
-      }/* end Layer parsing */
-    }/* for */
+      } /* end Layer parsing */
+    }   /* for */
   }
 
   CPLDestroyXMLNode(psRoot);
@@ -1286,26 +1225,24 @@ int msLoadMapContext(mapObj *map, const
 #endif
 }
 
-
 /* msSaveMapContext()
 **
 ** Save a mapfile into the OGC Web Map Context format
 **
 ** Take a map object and a file in arguments
 */
-int msSaveMapContext(mapObj *map, char *filename)
-{
+int msSaveMapContext(mapObj *map, char *filename) {
 #if defined(USE_WMS_LYR)
   FILE *stream;
   char szPath[MS_MAXPATHLEN];
   int nStatus;
 
   /* open file */
-  if(filename != NULL && strlen(filename) > 0) {
+  if (filename != NULL && strlen(filename) > 0) {
     stream = fopen(msBuildPath(szPath, map->mappath, filename), "wb");
-    if(!stream) {
+    if (!stream) {
       msSetError(MS_IOERR, "(%s)", "msSaveMapContext()", filename);
-      return(MS_FAILURE);
+      return (MS_FAILURE);
     }
   } else {
     msSetError(MS_IOERR, "Filename is undefined.", "msSaveMapContext()");
@@ -1325,133 +1262,139 @@ int msSaveMapContext(mapObj *map, char *
 #endif
 }
 
-
-
-int msWriteMapContext(mapObj *map, FILE *stream)
-{
+int msWriteMapContext(mapObj *map, FILE *stream) {
 #if defined(USE_WMS_LYR)
-  const char * version;
+  const char *version;
   char *pszEPSG;
-  char * tabspace=NULL, *pszChar,*pszSLD=NULL,*pszSLD2=NULL;
+  char *tabspace = NULL, *pszChar, *pszSLD = NULL, *pszSLD2 = NULL;
   char *pszStyleItem, *pszSLDBody;
   char *pszEncodedVal;
-  int i, nValue, nVersion=OWS_VERSION_NOTSET;
+  int i, nValue, nVersion = OWS_VERSION_NOTSET;
   /* Dimension element */
   char *pszDimension;
-  const char *pszDimUserValue=NULL, *pszDimUnits=NULL, *pszDimDefault=NULL;
-  const char *pszDimNearValue=NULL, *pszDimUnitSymbol=NULL;
-  const char *pszDimMultiValue=NULL;
+  const char *pszDimUserValue = NULL, *pszDimUnits = NULL,
+             *pszDimDefault = NULL;
+  const char *pszDimNearValue = NULL, *pszDimUnitSymbol = NULL;
+  const char *pszDimMultiValue = NULL;
   int bDimensionList = 0;
 
   /* Decide which version we're going to return... */
   version = msLookupHashTable(&(map->web.metadata), "wms_context_version");
-  if(version == NULL)
+  if (version == NULL)
     version = "1.1.0";
 
   nVersion = msOWSParseVersionString(version);
   if (nVersion == OWS_VERSION_BADFORMAT)
-    return MS_FAILURE;  /* msSetError() already called. */
+    return MS_FAILURE; /* msSetError() already called. */
 
   /* Make sure this is a supported version */
   /* Note that we don't write 0.1.2 even if we read it. */
   switch (nVersion) {
-    case OWS_0_1_4:
-    case OWS_0_1_7:
-    case OWS_1_0_0:
-    case OWS_1_1_0:
-      /* All is good, this is a supported version. */
-      break;
-    default:
-      /* Not a supported version */
-      msSetError(MS_MAPCONTEXTERR,
-                 "This version of Map Context is not supported (%s).",
-                 "msSaveMapContext()", version);
-      return MS_FAILURE;
+  case OWS_0_1_4:
+  case OWS_0_1_7:
+  case OWS_1_0_0:
+  case OWS_1_1_0:
+    /* All is good, this is a supported version. */
+    break;
+  default:
+    /* Not a supported version */
+    msSetError(MS_MAPCONTEXTERR,
+               "This version of Map Context is not supported (%s).",
+               "msSaveMapContext()", version);
+    return MS_FAILURE;
   }
 
   /* file header */
-  msIO_fprintf( stream, "<?xml version='1.0' encoding=\"UTF-8\" standalone=\"no\" ?>\n");
+  msIO_fprintf(stream,
+               "<?xml version='1.0' encoding=\"UTF-8\" standalone=\"no\" ?>\n");
 
   /* set the WMS_Viewer_Context information */
   pszEncodedVal = msEncodeHTMLEntities(version);
-  if(nVersion >= OWS_1_0_0) {
-    msIO_fprintf( stream, "<ViewContext version=\"%s\"", pszEncodedVal );
-  } else if(nVersion >= OWS_0_1_7) {
-    msIO_fprintf( stream, "<View_Context version=\"%s\"", pszEncodedVal );
+  if (nVersion >= OWS_1_0_0) {
+    msIO_fprintf(stream, "<ViewContext version=\"%s\"", pszEncodedVal);
+  } else if (nVersion >= OWS_0_1_7) {
+    msIO_fprintf(stream, "<View_Context version=\"%s\"", pszEncodedVal);
 
   } else { /* 0.1.4 */
-    msIO_fprintf( stream, "<WMS_Viewer_Context version=\"%s\"", pszEncodedVal );
+    msIO_fprintf(stream, "<WMS_Viewer_Context version=\"%s\"", pszEncodedVal);
   }
   msFree(pszEncodedVal);
 
-  if ( nVersion >= OWS_0_1_7 && nVersion < OWS_1_0_0 ) {
+  if (nVersion >= OWS_0_1_7 && nVersion < OWS_1_0_0) {
     msOWSPrintEncodeMetadata(stream, &(map->web.metadata), NULL,
-                             "wms_context_fid", OWS_NOERR," fid=\"%s\"","0");
+                             "wms_context_fid", OWS_NOERR, " fid=\"%s\"", "0");
   }
-  if ( nVersion >= OWS_1_0_0 )
+  if (nVersion >= OWS_1_0_0)
     msOWSPrintEncodeParam(stream, "MAP.NAME", map->name, OWS_NOERR,
                           " id=\"%s\"", NULL);
 
-  msIO_fprintf( stream, " xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"");
-  msIO_fprintf( stream, " xmlns:ogc=\"http://www.opengis.net/ogc\"");
+  msIO_fprintf(stream,
+               " xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"");
+  msIO_fprintf(stream, " xmlns:ogc=\"http://www.opengis.net/ogc\"");
 
-  if( nVersion >= OWS_0_1_7 && nVersion < OWS_1_0_0 ) {
-    msIO_fprintf( stream, " xmlns:gml=\"http://www.opengis.net/gml\"");
+  if (nVersion >= OWS_0_1_7 && nVersion < OWS_1_0_0) {
+    msIO_fprintf(stream, " xmlns:gml=\"http://www.opengis.net/gml\"");
   }
-  if( nVersion >= OWS_1_0_0 ) {
-    msIO_fprintf( stream, " xmlns:xlink=\"http://www.w3.org/1999/xlink\"");
-    msIO_fprintf( stream, " xmlns=\"http://www.opengis.net/context\"");
-    msIO_fprintf( stream, " xmlns:sld=\"http://www.opengis.net/sld\"");
+  if (nVersion >= OWS_1_0_0) {
+    msIO_fprintf(stream, " xmlns:xlink=\"http://www.w3.org/1999/xlink\"");
+    msIO_fprintf(stream, " xmlns=\"http://www.opengis.net/context\"");
+    msIO_fprintf(stream, " xmlns:sld=\"http://www.opengis.net/sld\"");
     pszEncodedVal = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
-    if( nVersion >= OWS_1_1_0 )
-      msIO_fprintf( stream,
-                    " xsi:schemaLocation=\"http://www.opengis.net/context %s/context/1.1.0/context.xsd\">\n",
-                    pszEncodedVal);
+    if (nVersion >= OWS_1_1_0)
+      msIO_fprintf(stream,
+                   " xsi:schemaLocation=\"http://www.opengis.net/context "
+                   "%s/context/1.1.0/context.xsd\">\n",
+                   pszEncodedVal);
     else
-      msIO_fprintf( stream,
-                    " xsi:schemaLocation=\"http://www.opengis.net/context %s/context/1.0.0/context.xsd\">\n",
-                    pszEncodedVal);
+      msIO_fprintf(stream,
+                   " xsi:schemaLocation=\"http://www.opengis.net/context "
+                   "%s/context/1.0.0/context.xsd\">\n",
+                   pszEncodedVal);
     msFree(pszEncodedVal);
   } else {
-    msIO_fprintf( stream, " xmlns:xlink=\"http://www.w3.org/TR/xlink\"");
+    msIO_fprintf(stream, " xmlns:xlink=\"http://www.w3.org/TR/xlink\"");
 
     pszEncodedVal = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
-    msIO_fprintf( stream, " xsi:noNamespaceSchemaLocation=\"%s/contexts/",
-                  pszEncodedVal );
+    msIO_fprintf(stream, " xsi:noNamespaceSchemaLocation=\"%s/contexts/",
+                 pszEncodedVal);
     msFree(pszEncodedVal);
     pszEncodedVal = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
-    msIO_fprintf( stream, "%s/context.xsd\">\n", pszEncodedVal);
+    msIO_fprintf(stream, "%s/context.xsd\">\n", pszEncodedVal);
     msFree(pszEncodedVal);
   }
 
   /* set the General information */
-  msIO_fprintf( stream, "  <General>\n" );
+  msIO_fprintf(stream, "  <General>\n");
 
   /* Window */
-  if( map->width != -1 || map->height != -1 )
-    msIO_fprintf( stream, "    <Window width=\"%d\" height=\"%d\"/>\n",
-                  map->width, map->height );
+  if (map->width != -1 || map->height != -1)
+    msIO_fprintf(stream, "    <Window width=\"%d\" height=\"%d\"/>\n",
+                 map->width, map->height);
 
   /* Bounding box corners and spatial reference system */
-  if(tabspace)
+  if (tabspace)
     free(tabspace);
   tabspace = msStrdup("    ");
-  msOWSGetEPSGProj(&(map->projection), &(map->web.metadata), "MO", MS_TRUE, &pszEPSG);
-  msIO_fprintf( stream,
-                "%s<!-- Bounding box corners and spatial reference system -->\n",
-                tabspace );
-  if(!pszEPSG || (strcasecmp(pszEPSG, "(null)") == 0))
-    msIO_fprintf(stream, "<!-- WARNING: Mandatory data 'projection' was missing in this context. -->\n");
+  msOWSGetEPSGProj(&(map->projection), &(map->web.metadata), "MO", MS_TRUE,
+                   &pszEPSG);
+  msIO_fprintf(stream,
+               "%s<!-- Bounding box corners and spatial reference system -->\n",
+               tabspace);
+  if (!pszEPSG || (strcasecmp(pszEPSG, "(null)") == 0))
+    msIO_fprintf(stream, "<!-- WARNING: Mandatory data 'projection' was "
+                         "missing in this context. -->\n");
 
   pszEncodedVal = msEncodeHTMLEntities(pszEPSG);
-  msIO_fprintf( stream, "%s<BoundingBox SRS=\"%s\" minx=\"%f\" miny=\"%f\" maxx=\"%f\" maxy=\"%f\"/>\n",
-                tabspace, pszEncodedVal, map->extent.minx, map->extent.miny,
-                map->extent.maxx, map->extent.maxy );
+  msIO_fprintf(stream,
+               "%s<BoundingBox SRS=\"%s\" minx=\"%f\" miny=\"%f\" maxx=\"%f\" "
+               "maxy=\"%f\"/>\n",
+               tabspace, pszEncodedVal, map->extent.minx, map->extent.miny,
+               map->extent.maxx, map->extent.maxy);
   msFree(pszEncodedVal);
   msFree(pszEPSG);
 
   /* Title, name */
-  if( nVersion >= OWS_0_1_7 && nVersion < OWS_1_0_0 ) {
+  if (nVersion >= OWS_0_1_7 && nVersion < OWS_1_0_0) {
     msOWSPrintEncodeParam(stream, "MAP.NAME", map->name, OWS_NOERR,
                           "    <gml:name>%s</gml:name>\n", NULL);
   } else {
@@ -1459,90 +1402,91 @@ int msWriteMapContext(mapObj *map, FILE
       msOWSPrintEncodeParam(stream, "MAP.NAME", map->name, OWS_NOERR,
                             "    <Name>%s</Name>\n", NULL);
 
-    msIO_fprintf( stream, "%s<!-- Title of Context -->\n", tabspace );
-    msOWSPrintEncodeMetadata(stream, &(map->web.metadata),
-                             NULL, "wms_title", OWS_WARN,
-                             "    <Title>%s</Title>\n", map->name);
+    msIO_fprintf(stream, "%s<!-- Title of Context -->\n", tabspace);
+    msOWSPrintEncodeMetadata(stream, &(map->web.metadata), NULL, "wms_title",
+                             OWS_WARN, "    <Title>%s</Title>\n", map->name);
   }
 
   /* keyword */
   if (nVersion >= OWS_1_0_0) {
-    if (msLookupHashTable(&(map->web.metadata),"wms_keywordlist")!=NULL) {
+    if (msLookupHashTable(&(map->web.metadata), "wms_keywordlist") != NULL) {
       char **papszKeywords;
       int nKeywords, iKey;
 
-      const char* pszValue = msLookupHashTable(&(map->web.metadata),
-                                   "wms_keywordlist");
+      const char *pszValue =
+          msLookupHashTable(&(map->web.metadata), "wms_keywordlist");
       papszKeywords = msStringSplit(pszValue, ',', &nKeywords);
-      if(nKeywords > 0 && papszKeywords) {
-        msIO_fprintf( stream, "    <KeywordList>\n");
-        for(iKey=0; iKey<nKeywords; iKey++) {
+      if (nKeywords > 0 && papszKeywords) {
+        msIO_fprintf(stream, "    <KeywordList>\n");
+        for (iKey = 0; iKey < nKeywords; iKey++) {
           pszEncodedVal = msEncodeHTMLEntities(papszKeywords[iKey]);
-          msIO_fprintf( stream, "      <Keyword>%s</Keyword>\n",
-                        pszEncodedVal);
+          msIO_fprintf(stream, "      <Keyword>%s</Keyword>\n", pszEncodedVal);
           msFree(pszEncodedVal);
         }
-        msIO_fprintf( stream, "    </KeywordList>\n");
+        msIO_fprintf(stream, "    </KeywordList>\n");
       }
     }
   } else
     msOWSPrintEncodeMetadataList(stream, &(map->web.metadata), NULL,
-                                 "wms_keywordlist",
-                                 "    <Keywords>\n", "    </Keywords>\n",
-                                 "      %s\n", NULL);
+                                 "wms_keywordlist", "    <Keywords>\n",
+                                 "    </Keywords>\n", "      %s\n", NULL);
 
   /* abstract */
-  if( nVersion >= OWS_0_1_7 && nVersion < OWS_1_0_0 ) {
-    msOWSPrintEncodeMetadata(stream, &(map->web.metadata),
-                             NULL, "wms_abstract", OWS_NOERR,
-                             "    <gml:description>%s</gml:description>\n", NULL);
+  if (nVersion >= OWS_0_1_7 && nVersion < OWS_1_0_0) {
+    msOWSPrintEncodeMetadata(
+        stream, &(map->web.metadata), NULL, "wms_abstract", OWS_NOERR,
+        "    <gml:description>%s</gml:description>\n", NULL);
   } else {
-    msOWSPrintEncodeMetadata(stream, &(map->web.metadata),
-                             NULL, "wms_abstract", OWS_NOERR,
-                             "    <Abstract>%s</Abstract>\n", NULL);
+    msOWSPrintEncodeMetadata(stream, &(map->web.metadata), NULL, "wms_abstract",
+                             OWS_NOERR, "    <Abstract>%s</Abstract>\n", NULL);
   }
 
   /* LogoURL */
   /* The LogoURL have a width, height, format and an URL */
-  msOWSPrintURLType(stream, &(map->web.metadata), "MO", "logourl",
-                    OWS_NOERR, NULL, "LogoURL", NULL, " width=\"%s\"",
-                    " height=\"%s\""," format=\"%s\"",
-                    "      <OnlineResource xlink:type=\"simple\" xlink:href=\"%s\"/>\n",
-                    MS_FALSE, MS_FALSE, MS_FALSE, MS_FALSE, MS_TRUE,
-                    NULL, NULL, NULL, NULL, NULL, "    ");
+  msOWSPrintURLType(
+      stream, &(map->web.metadata), "MO", "logourl", OWS_NOERR, NULL, "LogoURL",
+      NULL, " width=\"%s\"", " height=\"%s\"", " format=\"%s\"",
+      "      <OnlineResource xlink:type=\"simple\" xlink:href=\"%s\"/>\n",
+      MS_FALSE, MS_FALSE, MS_FALSE, MS_FALSE, MS_TRUE, NULL, NULL, NULL, NULL,
+      NULL, "    ");
 
   /* DataURL */
-  msOWSPrintEncodeMetadata(stream, &(map->web.metadata),
-                           NULL, "wms_dataurl", OWS_NOERR,
-                           "    <DataURL>\n      <OnlineResource xlink:type=\"simple\" xlink:href=\"%s\"/>\n    </DataURL>\n", NULL);
+  msOWSPrintEncodeMetadata(
+      stream, &(map->web.metadata), NULL, "wms_dataurl", OWS_NOERR,
+      "    <DataURL>\n      <OnlineResource xlink:type=\"simple\" "
+      "xlink:href=\"%s\"/>\n    </DataURL>\n",
+      NULL);
 
   /* DescriptionURL */
   /* The DescriptionURL have a width, height, format and an URL */
   /* The metadata is structured like this: "width height format url" */
-  msOWSPrintURLType(stream, &(map->web.metadata), "MO", "descriptionurl",
-                    OWS_NOERR, NULL, "DescriptionURL", NULL, " width=\"%s\"",
-                    " height=\"%s\""," format=\"%s\"",
-                    "      <OnlineResource xlink:type=\"simple\" xlink:href=\"%s\"/>\n",
-                    MS_FALSE, MS_FALSE, MS_FALSE, MS_FALSE, MS_TRUE,
-                    NULL, NULL, NULL, NULL, NULL, "    ");
+  msOWSPrintURLType(
+      stream, &(map->web.metadata), "MO", "descriptionurl", OWS_NOERR, NULL,
+      "DescriptionURL", NULL, " width=\"%s\"", " height=\"%s\"",
+      " format=\"%s\"",
+      "      <OnlineResource xlink:type=\"simple\" xlink:href=\"%s\"/>\n",
+      MS_FALSE, MS_FALSE, MS_FALSE, MS_FALSE, MS_TRUE, NULL, NULL, NULL, NULL,
+      NULL, "    ");
 
   /* Contact Info */
-  msOWSPrintContactInfo( stream, tabspace, OWS_1_1_0, &(map->web.metadata), "MO" );
+  msOWSPrintContactInfo(stream, tabspace, OWS_1_1_0, &(map->web.metadata),
+                        "MO");
 
   /* Close General */
-  msIO_fprintf( stream, "  </General>\n" );
+  msIO_fprintf(stream, "  </General>\n");
   free(tabspace);
 
   /* Set the layer list */
   msIO_fprintf(stream, "  <LayerList>\n");
 
   /* Loop on all layer   */
-  for(i=0; i<map->numlayers; i++) {
-    if(GET_LAYER(map, i)->status != MS_DELETE && GET_LAYER(map, i)->connectiontype == MS_WMS) {
-      const char* pszValue;
-      char* pszValueMod;
-      const char* pszCurrent;
-      if(GET_LAYER(map, i)->status == MS_OFF)
+  for (i = 0; i < map->numlayers; i++) {
+    if (GET_LAYER(map, i)->status != MS_DELETE &&
+        GET_LAYER(map, i)->connectiontype == MS_WMS) {
+      const char *pszValue;
+      char *pszValueMod;
+      const char *pszCurrent;
+      if (GET_LAYER(map, i)->status == MS_OFF)
         nValue = 1;
       else
         nValue = 0;
@@ -1552,72 +1496,69 @@ int msWriteMapContext(mapObj *map, FILE
       /*  */
       /* Server definition */
       /*  */
-      if(nVersion < OWS_1_0_0 )
-        msOWSPrintEncodeMetadata(stream, &(GET_LAYER(map, i)->metadata),
-                                 NULL, "wms_server_version", OWS_WARN,
-                                 "      <Server service=\"WMS\" version=\"%s\" ",
-                                 "1.0.0");
+      if (nVersion < OWS_1_0_0)
+        msOWSPrintEncodeMetadata(
+            stream, &(GET_LAYER(map, i)->metadata), NULL, "wms_server_version",
+            OWS_WARN, "      <Server service=\"WMS\" version=\"%s\" ", "1.0.0");
       else
-        msOWSPrintEncodeMetadata(stream, &(GET_LAYER(map, i)->metadata),
-                                 NULL, "wms_server_version", OWS_WARN,
-                                 "      <Server service=\"OGC:WMS\" version=\"%s\" ",
-                                 "1.0.0");
-
-      if(msOWSLookupMetadata(&(GET_LAYER(map, i)->metadata), "MO", "server_title"))
-        msOWSPrintEncodeMetadata(stream, &(GET_LAYER(map, i)->metadata),
-                                 NULL, "wms_server_title", OWS_NOERR,
+        msOWSPrintEncodeMetadata(
+            stream, &(GET_LAYER(map, i)->metadata), NULL, "wms_server_version",
+            OWS_WARN, "      <Server service=\"OGC:WMS\" version=\"%s\" ",
+            "1.0.0");
+
+      if (msOWSLookupMetadata(&(GET_LAYER(map, i)->metadata), "MO",
+                              "server_title"))
+        msOWSPrintEncodeMetadata(stream, &(GET_LAYER(map, i)->metadata), NULL,
+                                 "wms_server_title", OWS_NOERR,
                                  "title=\"%s\">\n", "");
 
-      else if(GET_LAYER(map, i)->name)
-        msOWSPrintEncodeMetadata(stream, &(GET_LAYER(map, i)->metadata),
-                                 NULL, "wms_title", OWS_NOERR,
-                                 "title=\"%s\">\n", GET_LAYER(map, i)->name);
+      else if (GET_LAYER(map, i)->name)
+        msOWSPrintEncodeMetadata(stream, &(GET_LAYER(map, i)->metadata), NULL,
+                                 "wms_title", OWS_NOERR, "title=\"%s\">\n",
+                                 GET_LAYER(map, i)->name);
       else {
-        msOWSPrintEncodeMetadata(stream, &(GET_LAYER(map, i)->metadata),
-                                 NULL, "wms_title", OWS_NOERR,
-                                 "title=\"%s\">\n", "");
+        msOWSPrintEncodeMetadata(stream, &(GET_LAYER(map, i)->metadata), NULL,
+                                 "wms_title", OWS_NOERR, "title=\"%s\">\n", "");
       }
 
       /* Get base url of the online resource to be the default value */
-      if(GET_LAYER(map, i)->connection)
-        pszValueMod = msStrdup( GET_LAYER(map, i)->connection );
+      if (GET_LAYER(map, i)->connection)
+        pszValueMod = msStrdup(GET_LAYER(map, i)->connection);
       else
-        pszValueMod = msStrdup( "" );
+        pszValueMod = msStrdup("");
       pszChar = strchr(pszValueMod, '?');
-      if( pszChar )
+      if (pszChar)
         pszValueMod[pszChar - pszValueMod] = '\0';
-      if(msOWSPrintEncodeMetadata(stream, &(GET_LAYER(map, i)->metadata),
-                                  NULL, "wms_onlineresource", OWS_WARN,
-                                  "        <OnlineResource xlink:type=\"simple\" xlink:href=\"%s\"/>\n",
-                                  pszValueMod) == OWS_WARN)
+      if (msOWSPrintEncodeMetadata(
+              stream, &(GET_LAYER(map, i)->metadata), NULL,
+              "wms_onlineresource", OWS_WARN,
+              "        <OnlineResource xlink:type=\"simple\" "
+              "xlink:href=\"%s\"/>\n",
+              pszValueMod) == OWS_WARN)
         msIO_fprintf(stream, "<!-- wms_onlineresource not set, using base URL"
-                     " , but probably not what you want -->\n");
+                             " , but probably not what you want -->\n");
       msIO_fprintf(stream, "      </Server>\n");
-      if(pszValueMod)
+      if (pszValueMod)
         free(pszValueMod);
 
       /*  */
       /* Layer information */
       /*  */
-      msOWSPrintEncodeMetadata(stream, &(GET_LAYER(map, i)->metadata),
-                               NULL, "wms_name", OWS_WARN,
-                               "      <Name>%s</Name>\n",
-                               GET_LAYER(map, i)->name);
-      msOWSPrintEncodeMetadata(stream, &(GET_LAYER(map, i)->metadata),
-                               NULL, "wms_title", OWS_WARN,
-                               "      <Title>%s</Title>\n",
+      msOWSPrintEncodeMetadata(stream, &(GET_LAYER(map, i)->metadata), NULL,
+                               "wms_name", OWS_WARN, "      <Name>%s</Name>\n",
                                GET_LAYER(map, i)->name);
-      msOWSPrintEncodeMetadata(stream, &(GET_LAYER(map, i)->metadata),
-                               NULL, "wms_abstract", OWS_NOERR,
-                               "      <Abstract>%s</Abstract>\n",
-                               NULL);
+      msOWSPrintEncodeMetadata(
+          stream, &(GET_LAYER(map, i)->metadata), NULL, "wms_title", OWS_WARN,
+          "      <Title>%s</Title>\n", GET_LAYER(map, i)->name);
+      msOWSPrintEncodeMetadata(stream, &(GET_LAYER(map, i)->metadata), NULL,
+                               "wms_abstract", OWS_NOERR,
+                               "      <Abstract>%s</Abstract>\n", NULL);
 
       /* DataURL */
-      if(nVersion <= OWS_0_1_4) {
-        msOWSPrintEncodeMetadata(stream, &(GET_LAYER(map, i)->metadata),
-                                 NULL, "wms_dataurl", OWS_NOERR,
-                                 "      <DataURL>%s</DataURL>\n",
-                                 NULL);
+      if (nVersion <= OWS_0_1_4) {
+        msOWSPrintEncodeMetadata(stream, &(GET_LAYER(map, i)->metadata), NULL,
+                                 "wms_dataurl", OWS_NOERR,
+                                 "      <DataURL>%s</DataURL>\n", NULL);
       } else {
         /* The DataURL have a width, height, format and an URL */
         /* The metadata will be structured like this:  */
@@ -1627,12 +1568,11 @@ int msWriteMapContext(mapObj *map, FILE
         /* for consistency with the URLType. */
         msOWSPrintURLType(stream, &(GET_LAYER(map, i)->metadata), "MO",
                           "dataurl", OWS_NOERR, NULL, "DataURL", NULL,
-                          " width=\"%s\"", " height=\"%s\"",
-                          " format=\"%s\"",
+                          " width=\"%s\"", " height=\"%s\"", " format=\"%s\"",
                           "        <OnlineResource xlink:type=\"simple\""
                           " xlink:href=\"%s\"/>\n",
-                          MS_FALSE, MS_FALSE, MS_FALSE, MS_FALSE,
-                          MS_TRUE, NULL, NULL, NULL,NULL,NULL, "      ");
+                          MS_FALSE, MS_FALSE, MS_FALSE, MS_FALSE, MS_TRUE, NULL,
+                          NULL, NULL, NULL, NULL, "      ");
       }
 
       /* MetadataURL */
@@ -1640,28 +1580,30 @@ int msWriteMapContext(mapObj *map, FILE
       /* The metadata will be structured like this:  */
       /* "width height format url" */
       msOWSPrintURLType(stream, &(GET_LAYER(map, i)->metadata), "MO",
-                        "metadataurl", OWS_NOERR, NULL, "MetadataURL",NULL,
-                        " width=\"%s\"", " height=\"%s\""," format=\"%s\"",
+                        "metadataurl", OWS_NOERR, NULL, "MetadataURL", NULL,
+                        " width=\"%s\"", " height=\"%s\"", " format=\"%s\"",
                         "        <OnlineResource xlink:type=\"simple\""
                         " xlink:href=\"%s\"/>\n",
-                        MS_FALSE, MS_FALSE, MS_FALSE, MS_FALSE,
-                        MS_TRUE, NULL, NULL, NULL, NULL, NULL, "      ");
+                        MS_FALSE, MS_FALSE, MS_FALSE, MS_FALSE, MS_TRUE, NULL,
+                        NULL, NULL, NULL, NULL, "      ");
 
       /* MinScale && MaxScale */
-      if(nVersion >= OWS_1_1_0 && GET_LAYER(map, i)->minscaledenom > 0)
-        msIO_fprintf(stream,
-                     "      <sld:MinScaleDenominator>%g</sld:MinScaleDenominator>\n",
-                     GET_LAYER(map, i)->minscaledenom);
-      if(nVersion >= OWS_1_1_0 && GET_LAYER(map, i)->maxscaledenom > 0)
-        msIO_fprintf(stream,
-                     "      <sld:MaxScaleDenominator>%g</sld:MaxScaleDenominator>\n",
-                     GET_LAYER(map, i)->maxscaledenom);
+      if (nVersion >= OWS_1_1_0 && GET_LAYER(map, i)->minscaledenom > 0)
+        msIO_fprintf(
+            stream,
+            "      <sld:MinScaleDenominator>%g</sld:MinScaleDenominator>\n",
+            GET_LAYER(map, i)->minscaledenom);
+      if (nVersion >= OWS_1_1_0 && GET_LAYER(map, i)->maxscaledenom > 0)
+        msIO_fprintf(
+            stream,
+            "      <sld:MaxScaleDenominator>%g</sld:MaxScaleDenominator>\n",
+            GET_LAYER(map, i)->maxscaledenom);
 
       /* Layer SRS */
       msOWSGetEPSGProj(&(GET_LAYER(map, i)->projection),
-                                         &(GET_LAYER(map, i)->metadata),
-                                         "MO", MS_FALSE, &pszEPSG);
-      if(pszEPSG && (strcasecmp(pszEPSG, "(null)") != 0)) {
+                       &(GET_LAYER(map, i)->metadata), "MO", MS_FALSE,
+                       &pszEPSG);
+      if (pszEPSG && (strcasecmp(pszEPSG, "(null)") != 0)) {
         pszEncodedVal = msEncodeHTMLEntities(pszEPSG);
         msIO_fprintf(stream, "      <SRS>%s</SRS>\n", pszEncodedVal);
         msFree(pszEncodedVal);
@@ -1669,25 +1611,27 @@ int msWriteMapContext(mapObj *map, FILE
       msFree(pszEPSG);
 
       /* Format */
-      if(msLookupHashTable(&(GET_LAYER(map, i)->metadata),"wms_formatlist")==NULL &&
-          msLookupHashTable(&(GET_LAYER(map, i)->metadata),"wms_format")==NULL) {
-        char* pszURL;
-        if(GET_LAYER(map, i)->connection)
-          pszURL = msStrdup( GET_LAYER(map, i)->connection );
+      if (msLookupHashTable(&(GET_LAYER(map, i)->metadata), "wms_formatlist") ==
+              NULL &&
+          msLookupHashTable(&(GET_LAYER(map, i)->metadata), "wms_format") ==
+              NULL) {
+        char *pszURL;
+        if (GET_LAYER(map, i)->connection)
+          pszURL = msStrdup(GET_LAYER(map, i)->connection);
         else
-          pszURL = msStrdup( "" );
+          pszURL = msStrdup("");
 
-        pszValueMod = strstr( pszURL, "FORMAT=" );
-        if( pszValueMod ) {
+        pszValueMod = strstr(pszURL, "FORMAT=");
+        if (pszValueMod) {
           pszValueMod += 7;
           pszChar = strchr(pszValueMod, '&');
-          if( pszChar )
+          if (pszChar)
             pszValueMod[pszChar - pszValueMod] = '\0';
-          if(strcasecmp(pszValueMod, "") != 0) {
+          if (strcasecmp(pszValueMod, "") != 0) {
             pszEncodedVal = msEncodeHTMLEntities(pszValueMod);
-            msIO_fprintf( stream, "      <FormatList>\n");
-            msIO_fprintf(stream,"        <Format>%s</Format>\n",pszValueMod);
-            msIO_fprintf( stream, "      </FormatList>\n");
+            msIO_fprintf(stream, "      <FormatList>\n");
+            msIO_fprintf(stream, "        <Format>%s</Format>\n", pszValueMod);
+            msIO_fprintf(stream, "      </FormatList>\n");
             msFree(pszEncodedVal);
           }
         }
@@ -1696,62 +1640,62 @@ int msWriteMapContext(mapObj *map, FILE
         char **papszFormats;
         int numFormats, nForm;
 
-        pszValue = msLookupHashTable(&(GET_LAYER(map, i)->metadata),
-                                     "wms_formatlist");
-        if(!pszValue)
-          pszValue = msLookupHashTable(&(GET_LAYER(map, i)->metadata),
-                                       "wms_format");
-        pszCurrent = msLookupHashTable(&(GET_LAYER(map, i)->metadata),
-                                       "wms_format");
+        pszValue =
+            msLookupHashTable(&(GET_LAYER(map, i)->metadata), "wms_formatlist");
+        if (!pszValue)
+          pszValue =
+              msLookupHashTable(&(GET_LAYER(map, i)->metadata), "wms_format");
+        pszCurrent =
+            msLookupHashTable(&(GET_LAYER(map, i)->metadata), "wms_format");
 
         papszFormats = msStringSplit(pszValue, ',', &numFormats);
-        if(numFormats > 0 && papszFormats) {
-          msIO_fprintf( stream, "      <FormatList>\n");
-          for(nForm=0; nForm<numFormats; nForm++) {
-            pszEncodedVal =msEncodeHTMLEntities(papszFormats[nForm]);
-            if(pszCurrent && (strcasecmp(papszFormats[nForm],
-                                         pszCurrent) == 0))
-              msIO_fprintf( stream,
-                            "        <Format current=\"1\">%s</Format>\n",
-                            pszEncodedVal);
+        if (numFormats > 0 && papszFormats) {
+          msIO_fprintf(stream, "      <FormatList>\n");
+          for (nForm = 0; nForm < numFormats; nForm++) {
+            pszEncodedVal = msEncodeHTMLEntities(papszFormats[nForm]);
+            if (pszCurrent &&
+                (strcasecmp(papszFormats[nForm], pszCurrent) == 0))
+              msIO_fprintf(stream,
+                           "        <Format current=\"1\">%s</Format>\n",
+                           pszEncodedVal);
             else
-              msIO_fprintf( stream, "        <Format>%s</Format>\n",
-                            pszEncodedVal);
+              msIO_fprintf(stream, "        <Format>%s</Format>\n",
+                           pszEncodedVal);
             msFree(pszEncodedVal);
           }
-          msIO_fprintf( stream, "      </FormatList>\n");
+          msIO_fprintf(stream, "      </FormatList>\n");
         }
-        if(papszFormats)
+        if (papszFormats)
           msFreeCharArray(papszFormats, numFormats);
       }
       /* Style */
       /* First check the stylelist */
-      pszValue = msLookupHashTable(&(GET_LAYER(map, i)->metadata),
-                                   "wms_stylelist");
-      while( pszValue && *pszValue == ' ' )
-          pszValue ++;
-      if(pszValue == NULL || strlen(pszValue) < 1) {
+      pszValue =
+          msLookupHashTable(&(GET_LAYER(map, i)->metadata), "wms_stylelist");
+      while (pszValue && *pszValue == ' ')
+        pszValue++;
+      if (pszValue == NULL || strlen(pszValue) < 1) {
         /* Check if the style is in the connection URL */
-        char* pszURL;
-        if(GET_LAYER(map, i)->connection)
-          pszURL = msStrdup( GET_LAYER(map, i)->connection );
+        char *pszURL;
+        if (GET_LAYER(map, i)->connection)
+          pszURL = msStrdup(GET_LAYER(map, i)->connection);
         else
-          pszURL = msStrdup( "" );
+          pszURL = msStrdup("");
 
         /* Grab the STYLES in the URL */
-        pszValueMod = strstr( pszURL, "STYLES=" );
-        if( pszValueMod ) {
+        pszValueMod = strstr(pszURL, "STYLES=");
+        if (pszValueMod) {
           pszValueMod += 7;
           pszChar = strchr(pszValueMod, '&');
-          if( pszChar )
+          if (pszChar)
             pszValueMod[pszChar - pszValueMod] = '\0';
 
           /* Check the SLD string from the URL */
-          if(GET_LAYER(map, i)->connection)
+          if (GET_LAYER(map, i)->connection)
             pszSLD2 = msStrdup(GET_LAYER(map, i)->connection);
           else
-            pszSLD2 = msStrdup( "" );
-          if(pszSLD2) {
+            pszSLD2 = msStrdup("");
+          if (pszSLD2) {
             pszSLD = strstr(pszSLD2, "SLD=");
             pszSLDBody = strstr(pszSLD2, "SLD_BODY=");
           } else {
@@ -1759,106 +1703,104 @@ int msWriteMapContext(mapObj *map, FILE
             pszSLDBody = NULL;
           }
           /* Check SLD */
-          if( pszSLD ) {
+          if (pszSLD) {
             pszChar = strchr(pszSLD, '&');
-            if( pszChar )
+            if (pszChar)
               pszSLD[pszChar - pszSLD] = '\0';
             pszSLD += 4;
           }
           /* Check SLDBody  */
-          if( pszSLDBody ) {
+          if (pszSLDBody) {
             pszChar = strchr(pszSLDBody, '&');
-            if( pszChar )
+            if (pszChar)
               pszSLDBody[pszChar - pszSLDBody] = '\0';
             pszSLDBody += 9;
           }
-          if( (pszValueMod && (strcasecmp(pszValueMod, "") != 0)) ||
+          if ((pszValueMod && (strcasecmp(pszValueMod, "") != 0)) ||
               (pszSLD && (strcasecmp(pszSLD, "") != 0)) ||
               (pszSLDBody && (strcasecmp(pszSLDBody, "") != 0))) {
             /* Write Name and Title */
-            msIO_fprintf( stream, "      <StyleList>\n");
-            msIO_fprintf( stream, "        <Style current=\"1\">\n");
-            if( pszValueMod && (strcasecmp(pszValueMod, "") != 0)) {
+            msIO_fprintf(stream, "      <StyleList>\n");
+            msIO_fprintf(stream, "        <Style current=\"1\">\n");
+            if (pszValueMod && (strcasecmp(pszValueMod, "") != 0)) {
               pszEncodedVal = msEncodeHTMLEntities(pszValueMod);
               msIO_fprintf(stream, "          <Name>%s</Name>\n",
                            pszEncodedVal);
-              msIO_fprintf(stream,"          <Title>%s</Title>\n",
+              msIO_fprintf(stream, "          <Title>%s</Title>\n",
                            pszEncodedVal);
               msFree(pszEncodedVal);
             }
             /* Write the SLD string from the URL */
-            if( pszSLD && (strcasecmp(pszSLD, "") != 0)) {
+            if (pszSLD && (strcasecmp(pszSLD, "") != 0)) {
               pszEncodedVal = msEncodeHTMLEntities(pszSLD);
-              msIO_fprintf( stream, "          <SLD>\n" );
-              msIO_fprintf( stream,
-                            "            <OnlineResource xlink:type=\"simple\" ");
-              msIO_fprintf(stream,"xlink:href=\"%s\"/>",
-                           pszEncodedVal);
-              msIO_fprintf( stream, "          </SLD>\n" );
+              msIO_fprintf(stream, "          <SLD>\n");
+              msIO_fprintf(
+                  stream, "            <OnlineResource xlink:type=\"simple\" ");
+              msIO_fprintf(stream, "xlink:href=\"%s\"/>", pszEncodedVal);
+              msIO_fprintf(stream, "          </SLD>\n");
               free(pszEncodedVal);
-            } else if(pszSLDBody && (strcasecmp(pszSLDBody, "") != 0)) {
-              msIO_fprintf( stream, "          <SLD>\n" );
-              msIO_fprintf( stream, "            %s\n",pszSLDBody);
-              msIO_fprintf( stream, "          </SLD>\n" );
+            } else if (pszSLDBody && (strcasecmp(pszSLDBody, "") != 0)) {
+              msIO_fprintf(stream, "          <SLD>\n");
+              msIO_fprintf(stream, "            %s\n", pszSLDBody);
+              msIO_fprintf(stream, "          </SLD>\n");
             }
-            msIO_fprintf( stream, "        </Style>\n");
-            msIO_fprintf( stream, "      </StyleList>\n");
+            msIO_fprintf(stream, "        </Style>\n");
+            msIO_fprintf(stream, "      </StyleList>\n");
           }
-          if(pszSLD2) {
+          if (pszSLD2) {
             free(pszSLD2);
             pszSLD2 = NULL;
           }
         }
         free(pszURL);
       } else {
-        const char* pszCurrent;
+        const char *pszCurrent;
         /* If the style information is not in the connection URL, */
         /* read the metadata. */
-        pszValue = msLookupHashTable(&(GET_LAYER(map, i)->metadata),
-                                     "wms_stylelist");
-        pszCurrent = msLookupHashTable(&(GET_LAYER(map, i)->metadata),
-                                       "wms_style");
-        msIO_fprintf( stream, "      <StyleList>\n");
+        pszValue =
+            msLookupHashTable(&(GET_LAYER(map, i)->metadata), "wms_stylelist");
+        pszCurrent =
+            msLookupHashTable(&(GET_LAYER(map, i)->metadata), "wms_style");
+        msIO_fprintf(stream, "      <StyleList>\n");
         /* Loop in each style in the style list */
-        while(pszValue != NULL) {
-          char* pszStyle = msStrdup(pszValue);
+        while (pszValue != NULL) {
+          char *pszStyle = msStrdup(pszValue);
           pszChar = strchr(pszStyle, ',');
-          if(pszChar != NULL)
+          if (pszChar != NULL)
             pszStyle[pszChar - pszStyle] = '\0';
-          if(pszStyle[0] == '\0')
-          {
+          if (pszStyle[0] == '\0') {
             msFree(pszStyle);
             continue;
           }
 
-          if(pszCurrent && (strcasecmp(pszStyle, pszCurrent) == 0))
-            msIO_fprintf( stream,"        <Style current=\"1\">\n" );
+          if (pszCurrent && (strcasecmp(pszStyle, pszCurrent) == 0))
+            msIO_fprintf(stream, "        <Style current=\"1\">\n");
           else
-            msIO_fprintf( stream, "        <Style>\n" );
+            msIO_fprintf(stream, "        <Style>\n");
 
           /* Write SLDURL if it is in the metadata */
-          pszStyleItem = (char*)malloc(strlen(pszStyle)+10+10);
+          pszStyleItem = (char *)malloc(strlen(pszStyle) + 10 + 10);
           sprintf(pszStyleItem, "wms_style_%s_sld", pszStyle);
-          if(msLookupHashTable(&(GET_LAYER(map, i)->metadata),
-                               pszStyleItem) != NULL) {
+          if (msLookupHashTable(&(GET_LAYER(map, i)->metadata), pszStyleItem) !=
+              NULL) {
             msIO_fprintf(stream, "          <SLD>\n");
-            msOWSPrintEncodeMetadata(stream,
-                                     &(GET_LAYER(map, i)->metadata),
-                                     NULL, pszStyleItem,
-                                     OWS_NOERR,
-                                     "            <OnlineResource xlink:type=\"simple\" xlink:href=\"%s\"/>\n",
-                                     NULL);
+            msOWSPrintEncodeMetadata(
+                stream, &(GET_LAYER(map, i)->metadata), NULL, pszStyleItem,
+                OWS_NOERR,
+                "            <OnlineResource xlink:type=\"simple\" "
+                "xlink:href=\"%s\"/>\n",
+                NULL);
             msIO_fprintf(stream, "          </SLD>\n");
             free(pszStyleItem);
           } else {
             /* If the URL is not there, check for SLDBody */
             sprintf(pszStyleItem, "wms_style_%s_sld_body", pszStyle);
-            if(msLookupHashTable(&(GET_LAYER(map, i)->metadata),
-                                 pszStyleItem) != NULL) {
+            if (msLookupHashTable(&(GET_LAYER(map, i)->metadata),
+                                  pszStyleItem) != NULL) {
               msIO_fprintf(stream, "          <SLD>\n");
-              msOWSPrintMetadata(stream,&(GET_LAYER(map, i)->metadata),
-                                 NULL, pszStyleItem, OWS_NOERR,
-                                 "            %s\n", NULL);
+              msOWSPrintMetadata(stream, &(GET_LAYER(map, i)->metadata), NULL,
+                                 pszStyleItem, OWS_NOERR, "            %s\n",
+                                 NULL);
               msIO_fprintf(stream, "          </SLD>\n");
               free(pszStyleItem);
             } else {
@@ -1870,43 +1812,38 @@ int msWriteMapContext(mapObj *map, FILE
               msIO_fprintf(stream, "          <Name>%s</Name>\n",
                            pszEncodedVal);
               msFree(pszEncodedVal);
-              pszStyleItem = (char*)malloc(strlen(pszStyle)+10+8);
-              sprintf(pszStyleItem, "wms_style_%s_title",pszStyle);
+              pszStyleItem = (char *)malloc(strlen(pszStyle) + 10 + 8);
+              sprintf(pszStyleItem, "wms_style_%s_title", pszStyle);
               /* Title */
-              msOWSPrintEncodeMetadata(stream,
-                                       &(GET_LAYER(map, i)->metadata),
-                                       NULL, pszStyleItem,
-                                       OWS_NOERR,
-                                       "          <Title>%s</Title>\n",
-                                       NULL);
+              msOWSPrintEncodeMetadata(stream, &(GET_LAYER(map, i)->metadata),
+                                       NULL, pszStyleItem, OWS_NOERR,
+                                       "          <Title>%s</Title>\n", NULL);
               free(pszStyleItem);
 
               /* LegendURL */
-              pszStyleItem = (char*)malloc(strlen(pszStyle)+10+20);
-              sprintf(pszStyleItem, "style_%s_legendurl",
-                      pszStyle);
-              msOWSPrintURLType(stream, &(GET_LAYER(map, i)->metadata),
-                                "M", pszStyleItem, OWS_NOERR, NULL,
-                                "LegendURL", NULL, " width=\"%s\"",
-                                " height=\"%s\""," format=\"%s\"",
+              pszStyleItem = (char *)malloc(strlen(pszStyle) + 10 + 20);
+              sprintf(pszStyleItem, "style_%s_legendurl", pszStyle);
+              msOWSPrintURLType(stream, &(GET_LAYER(map, i)->metadata), "M",
+                                pszStyleItem, OWS_NOERR, NULL, "LegendURL",
+                                NULL, " width=\"%s\"", " height=\"%s\"",
+                                " format=\"%s\"",
                                 "            <OnlineResource "
                                 "xlink:type=\"simple\""
                                 " xlink:href=\"%s\"/>\n          ",
-                                MS_FALSE, MS_FALSE, MS_FALSE,
-                                MS_FALSE, MS_TRUE, NULL, NULL,
-                                NULL, NULL, NULL, "          ");
+                                MS_FALSE, MS_FALSE, MS_FALSE, MS_FALSE, MS_TRUE,
+                                NULL, NULL, NULL, NULL, NULL, "          ");
               free(pszStyleItem);
             }
           }
 
-          msIO_fprintf( stream,"        </Style>\n" );
+          msIO_fprintf(stream, "        </Style>\n");
 
           msFree(pszStyle);
           pszValue = strchr(pszValue, ',');
-          if(pszValue)
+          if (pszValue)
             pszValue++;
         }
-        msIO_fprintf( stream, "      </StyleList>\n");
+        msIO_fprintf(stream, "      </StyleList>\n");
       }
 
       /* Dimension element */;
@@ -1914,75 +1851,72 @@ int msWriteMapContext(mapObj *map, FILE
 
       pszValue = msLookupHashTable(&(GET_LAYER(map, i)->metadata),
                                    "wms_dimensionlist");
-      pszCurrent = msLookupHashTable(&(GET_LAYER(map, i)->metadata),
-                                     "wms_dimension");
-      while(pszValue != NULL) {
+      pszCurrent =
+          msLookupHashTable(&(GET_LAYER(map, i)->metadata), "wms_dimension");
+      while (pszValue != NULL) {
         /* Extract the dimension name from the list */
         pszDimension = msStrdup(pszValue);
         pszChar = strchr(pszDimension, ',');
-        if(pszChar != NULL)
+        if (pszChar != NULL)
           pszDimension[pszChar - pszDimension] = '\0';
-        if(strcasecmp(pszDimension, "") == 0) {
+        if (strcasecmp(pszDimension, "") == 0) {
           free(pszDimension);
           pszValue = strchr(pszValue, ',');
-          if(pszValue)
+          if (pszValue)
             pszValue++;
           continue;
         }
 
         /* From the dimension list, extract the required dimension */
-        msOWSGetDimensionInfo(GET_LAYER(map, i), pszDimension,
-                              &pszDimUserValue, &pszDimUnits,
-                              &pszDimDefault, &pszDimNearValue,
+        msOWSGetDimensionInfo(GET_LAYER(map, i), pszDimension, &pszDimUserValue,
+                              &pszDimUnits, &pszDimDefault, &pszDimNearValue,
                               &pszDimUnitSymbol, &pszDimMultiValue);
 
-        if(pszDimUserValue == NULL || pszDimUnits == NULL ||
+        if (pszDimUserValue == NULL || pszDimUnits == NULL ||
             pszDimUnitSymbol == NULL) {
           free(pszDimension);
           pszValue = strchr(pszValue, ',');
-          if(pszValue)
+          if (pszValue)
             pszValue++;
           continue;
         }
 
-        if(!bDimensionList) {
+        if (!bDimensionList) {
           bDimensionList = 1;
-          msIO_fprintf( stream, "      <DimensionList>\n");
+          msIO_fprintf(stream, "      <DimensionList>\n");
         }
 
         /* name */
-        msIO_fprintf( stream, "        <Dimension name=\"%s\"",
-                      pszDimension);
+        msIO_fprintf(stream, "        <Dimension name=\"%s\"", pszDimension);
         /* units */
-        msIO_fprintf( stream, " units=\"%s\"",      pszDimUnits);
+        msIO_fprintf(stream, " units=\"%s\"", pszDimUnits);
         /* unitSymbol */
-        msIO_fprintf( stream, " unitSymbol=\"%s\"", pszDimUnitSymbol);
+        msIO_fprintf(stream, " unitSymbol=\"%s\"", pszDimUnitSymbol);
         /* userValue */
-        msIO_fprintf( stream, " userValue=\"%s\"",  pszDimUserValue);
+        msIO_fprintf(stream, " userValue=\"%s\"", pszDimUserValue);
         /* default */
-        if(pszDimDefault)
-          msIO_fprintf( stream, " default=\"%s\"", pszDimDefault);
+        if (pszDimDefault)
+          msIO_fprintf(stream, " default=\"%s\"", pszDimDefault);
         /* multipleValues */
-        if(pszDimMultiValue)
-          msIO_fprintf(stream, " multipleValues=\"%s\"",
-                       pszDimMultiValue);
+        if (pszDimMultiValue)
+          msIO_fprintf(stream, " multipleValues=\"%s\"", pszDimMultiValue);
         /* nearestValue */
-        if(pszDimNearValue)
-          msIO_fprintf( stream," nearestValue=\"%s\"",pszDimNearValue);
+        if (pszDimNearValue)
+          msIO_fprintf(stream, " nearestValue=\"%s\"", pszDimNearValue);
 
-        if(pszCurrent && strcasecmp(pszDimension, pszCurrent) == 0)
-          msIO_fprintf( stream, " current=\"1\"");
+        if (pszCurrent && strcasecmp(pszDimension, pszCurrent) == 0)
+          msIO_fprintf(stream, " current=\"1\"");
 
-        msIO_fprintf( stream, "/>\n");
+        msIO_fprintf(stream, "/>\n");
 
         free(pszDimension);
         pszValue = strchr(pszValue, ',');
-        if(pszValue)
+        if (pszValue)
           pszValue++;
       }
 
-      if(bDimensionList) {
-        msIO_fprintf( stream, "      </DimensionList>\n");
+      if (bDimensionList) {
+        msIO_fprintf(stream, "      </DimensionList>\n");
         bDimensionList = 0;
       }
 
@@ -1994,9 +1928,9 @@ int msWriteMapContext(mapObj *map, FILE
   msIO_fprintf(stream, "  </LayerList>\n");
   /* Close Map Context */
 
-  if(nVersion >= OWS_1_0_0) {
+  if (nVersion >= OWS_1_0_0) {
     msIO_fprintf(stream, "</ViewContext>\n");
-  } else if(nVersion >= OWS_0_1_7) {
+  } else if (nVersion >= OWS_0_1_7) {
     msIO_fprintf(stream, "</View_Context>\n");
   } else { /* 0.1.4 */
     msIO_fprintf(stream, "</WMS_Viewer_Context>\n");
@@ -2010,5 +1944,3 @@ int msWriteMapContext(mapObj *map, FILE
   return MS_FAILURE;
 #endif
 }
-
-
diff -pruN 8.0.1-5/mapcontour.c 8.0.2-1/mapcontour.c
--- 8.0.1-5/mapcontour.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapcontour.c	2024-06-11 20:41:34.000000000 +0000
@@ -42,7 +42,7 @@
 #include "mapraster.h"
 #include "cpl_string.h"
 
-#define GEO_TRANS(tr,x,y)  ((tr)[0]+(tr)[1]*(x)+(tr)[2]*(y))
+#define GEO_TRANS(tr, x, y) ((tr)[0] + (tr)[1] * (x) + (tr)[2] * (y))
 
 extern int InvGeoTransform(double *gt_in, double *gt_out);
 
@@ -53,7 +53,7 @@ typedef struct {
 
   /* internal use */
   GDALDatasetH hOrigDS;
-  GDALDatasetH  hDS;
+  GDALDatasetH hDS;
   double *buffer; /* memory dataset buffer */
   rectObj extent; /* original dataset extent */
   OGRDataSourceH hOGRDS;
@@ -61,10 +61,8 @@ typedef struct {
 
 } contourLayerInfo;
 
-
-static int msContourLayerInitItemInfo(layerObj *layer)
-{
-  contourLayerInfo *clinfo = (contourLayerInfo *) layer->layerinfo;
+static int msContourLayerInitItemInfo(layerObj *layer) {
+  contourLayerInfo *clinfo = (contourLayerInfo *)layer->layerinfo;
 
   if (clinfo == NULL) {
     msSetError(MS_MISCERR, "Assertion failed: Contour layer not opened!!!",
@@ -75,9 +73,8 @@ static int msContourLayerInitItemInfo(la
   return msLayerInitItemInfo(&clinfo->ogrLayer);
 }
 
-static void msContourLayerFreeItemInfo(layerObj *layer)
-{
-  contourLayerInfo *clinfo = (contourLayerInfo *) layer->layerinfo;
+static void msContourLayerFreeItemInfo(layerObj *layer) {
+  contourLayerInfo *clinfo = (contourLayerInfo *)layer->layerinfo;
 
   if (clinfo == NULL) {
     msSetError(MS_MISCERR, "Assertion failed: Contour layer not opened!!!",
@@ -88,28 +85,28 @@ static void msContourLayerFreeItemInfo(l
   msLayerFreeItemInfo(&clinfo->ogrLayer);
 }
 
-static void msContourLayerInfoInitialize(layerObj *layer)
-{
-  contourLayerInfo *clinfo = (contourLayerInfo *) layer->layerinfo;
+static void msContourLayerInfoInitialize(layerObj *layer) {
+  contourLayerInfo *clinfo = (contourLayerInfo *)layer->layerinfo;
 
   if (clinfo != NULL)
     return;
 
-  clinfo = (contourLayerInfo *) msSmallCalloc(1,sizeof(contourLayerInfo));
+  clinfo = (contourLayerInfo *)msSmallCalloc(1, sizeof(contourLayerInfo));
   layer->layerinfo = clinfo;
-  clinfo->hOrigDS = NULL;  
+  clinfo->hOrigDS = NULL;
   clinfo->hDS = NULL;
   clinfo->extent.minx = -1.0;
   clinfo->extent.miny = -1.0;
   clinfo->extent.maxx = -1.0;
   clinfo->extent.maxy = -1.0;
-  
+
   initLayer(&clinfo->ogrLayer, layer->map);
   clinfo->ogrLayer.type = layer->type;
   clinfo->ogrLayer.debug = layer->debug;
   clinfo->ogrLayer.connectiontype = MS_OGR;
   clinfo->ogrLayer.name = msStrdup(layer->name);
-  clinfo->ogrLayer.connection = (char*)msSmallMalloc(strlen(clinfo->ogrLayer.name)+13);
+  clinfo->ogrLayer.connection =
+      (char *)msSmallMalloc(strlen(clinfo->ogrLayer.name) + 13);
   sprintf(clinfo->ogrLayer.connection, "__%s_CONTOUR__", clinfo->ogrLayer.name);
   clinfo->ogrLayer.units = layer->units;
 
@@ -117,21 +114,20 @@ static void msContourLayerInfoInitialize
     msInsertHashTable(&(layer->metadata), "gml_ID_type", "Integer");
   }
   {
-    const char* elevItem = CSLFetchNameValue(layer->processing,"CONTOUR_ITEM");
+    const char *elevItem = CSLFetchNameValue(layer->processing, "CONTOUR_ITEM");
     if (elevItem && strlen(elevItem) > 0) {
-       char szTmp[100];
-       snprintf(szTmp, sizeof(szTmp), "%s_type", elevItem);
-       if (msOWSLookupMetadata(&(layer->metadata), "OFG", szTmp) == NULL) {
-         snprintf(szTmp, sizeof(szTmp), "gml_%s_type", elevItem);
-         msInsertHashTable(&(layer->metadata), szTmp, "Real");
-       }
+      char szTmp[100];
+      snprintf(szTmp, sizeof(szTmp), "%s_type", elevItem);
+      if (msOWSLookupMetadata(&(layer->metadata), "OFG", szTmp) == NULL) {
+        snprintf(szTmp, sizeof(szTmp), "gml_%s_type", elevItem);
+        msInsertHashTable(&(layer->metadata), szTmp, "Real");
+      }
     }
   }
 }
 
-static void msContourLayerInfoFree(layerObj *layer)
-{
-  contourLayerInfo *clinfo = (contourLayerInfo *) layer->layerinfo;
+static void msContourLayerInfoFree(layerObj *layer) {
+  contourLayerInfo *clinfo = (contourLayerInfo *)layer->layerinfo;
 
   if (clinfo == NULL)
     return;
@@ -142,23 +138,22 @@ static void msContourLayerInfoFree(layer
   layer->layerinfo = NULL;
 }
 
-static int msContourLayerReadRaster(layerObj *layer, rectObj rect)
-{
-  mapObj *map = layer->map;  
+static int msContourLayerReadRaster(layerObj *layer, rectObj rect) {
+  mapObj *map = layer->map;
   char **bands;
   char pointer[64], memDSPointer[128];
   int band = 1;
   double adfGeoTransform[6], adfInvGeoTransform[6];
-  double llx, lly, urx, ury;  
+  double llx, lly, urx, ury;
   rectObj copyRect, mapRect;
   int dst_xsize, dst_ysize;
   int virtual_grid_step_x, virtual_grid_step_y;
-  int src_xoff, src_yoff, src_xsize, src_ysize;  
+  int src_xoff, src_yoff, src_xsize, src_ysize;
   double map_cellsize_x, map_cellsize_y, dst_cellsize_x, dst_cellsize_y;
   GDALRasterBandH hBand = NULL;
   CPLErr eErr;
-  
-  contourLayerInfo *clinfo = (contourLayerInfo *) layer->layerinfo;
+
+  contourLayerInfo *clinfo = (contourLayerInfo *)layer->layerinfo;
 
   if (layer->debug)
     msDebug("Entering msContourLayerReadRaster().\n");
@@ -166,18 +161,19 @@ static int msContourLayerReadRaster(laye
   if (clinfo == NULL || clinfo->hOrigDS == NULL) {
     msSetError(MS_MISCERR, "Assertion failed: Contour layer not opened!!!",
                "msContourLayerReadRaster()");
-    return MS_FAILURE;    
+    return MS_FAILURE;
   }
 
   bands = CSLTokenizeStringComplex(
-               CSLFetchNameValue(layer->processing,"BANDS"), " ,", FALSE, FALSE );
+      CSLFetchNameValue(layer->processing, "BANDS"), " ,", FALSE, FALSE);
   if (CSLCount(bands) > 0) {
     band = atoi(bands[0]);
     if (band < 1 || band > GDALGetRasterCount(clinfo->hOrigDS)) {
-      msSetError( MS_IMGERR,
-                  "BANDS PROCESSING directive includes illegal band '%d', should be from 1 to %d.",
-                  "msContourLayerReadRaster()",
-                  band, GDALGetRasterCount(clinfo->hOrigDS));
+      msSetError(MS_IMGERR,
+                 "BANDS PROCESSING directive includes illegal band '%d', "
+                 "should be from 1 to %d.",
+                 "msContourLayerReadRaster()", band,
+                 GDALGetRasterCount(clinfo->hOrigDS));
       CSLDestroy(bands);
       return MS_FAILURE;
     }
@@ -185,10 +181,8 @@ static int msContourLayerReadRaster(laye
   CSLDestroy(bands);
 
   hBand = GDALGetRasterBand(clinfo->hOrigDS, band);
-  if (hBand == NULL)
-  {
-    msSetError(MS_IMGERR,
-               "Band %d does not exist on dataset.",
+  if (hBand == NULL) {
+    msSetError(MS_IMGERR, "Band %d does not exist on dataset.",
                "msContourLayerReadRaster()", band);
     return MS_FAILURE;
   }
@@ -198,49 +192,48 @@ static int msContourLayerReadRaster(laye
     const char *wkt;
     wkt = GDALGetProjectionRef(clinfo->hOrigDS);
     if (wkt != NULL && strlen(wkt) > 0) {
-      if (msOGCWKT2ProjectionObj(wkt, &(layer->projection),
-                                 layer->debug) != MS_SUCCESS) {
-        char  msg[MESSAGELENGTH*2];
+      if (msOGCWKT2ProjectionObj(wkt, &(layer->projection), layer->debug) !=
+          MS_SUCCESS) {
+        char msg[MESSAGELENGTH * 2];
         errorObj *ms_error = msGetErrorObj();
 
-        snprintf( msg, sizeof(msg),
-                  "%s\n"
-                  "PROJECTION AUTO cannot be used for this "
-                  "GDAL raster (`%s').",
-                  ms_error->message, layer->data);
-        msg[MESSAGELENGTH-1] = '\0';
+        snprintf(msg, sizeof(msg),
+                 "%s\n"
+                 "PROJECTION AUTO cannot be used for this "
+                 "GDAL raster (`%s').",
+                 ms_error->message, layer->data);
+        msg[MESSAGELENGTH - 1] = '\0';
 
-        msSetError(MS_OGRERR, "%s","msDrawRasterLayer()",
-                   msg);
+        msSetError(MS_OGRERR, "%s", "msDrawRasterLayer()", msg);
         return MS_FAILURE;
       }
     }
   }
-  
+
   /*
    * Compute the georeferenced window of overlap, and read the source data
    * downsampled to match output resolution, or at full resolution if
    * output resolution is lower than the source resolution.
    *
-   * A large portion of this overlap calculation code was borrowed from 
-   * msDrawRasterLayerGDAL(). 
+   * A large portion of this overlap calculation code was borrowed from
+   * msDrawRasterLayerGDAL().
    * Would be possible to move some of this to a reusable function?
    *
    * Note: This code works only if no reprojection is involved. It would
    * need rework to support cases where output projection differs from source
    * data file projection.
    */
-  
+
   src_xsize = GDALGetRasterXSize(clinfo->hOrigDS);
   src_ysize = GDALGetRasterYSize(clinfo->hOrigDS);
 
   /* set the Dataset extent */
-  msGetGDALGeoTransform(clinfo->hOrigDS, map, layer, adfGeoTransform);  
+  msGetGDALGeoTransform(clinfo->hOrigDS, map, layer, adfGeoTransform);
   clinfo->extent.minx = adfGeoTransform[0];
   clinfo->extent.maxy = adfGeoTransform[3];
   clinfo->extent.maxx = adfGeoTransform[0] + src_xsize * adfGeoTransform[1];
   clinfo->extent.miny = adfGeoTransform[3] + src_ysize * adfGeoTransform[5];
-  
+
   if (layer->transform) {
     if (layer->debug)
       msDebug("msContourLayerReadRaster(): Entering transform.\n");
@@ -248,16 +241,17 @@ static int msContourLayerReadRaster(laye
     InvGeoTransform(adfGeoTransform, adfInvGeoTransform);
 
     mapRect = rect;
-    if( map->cellsize == 0 )
-    {
-        map->cellsize = msAdjustExtent(&mapRect,map->width,map->height);
+    if (map->cellsize == 0) {
+      map->cellsize = msAdjustExtent(&mapRect, map->width, map->height);
     }
     map_cellsize_x = map_cellsize_y = map->cellsize;
     /* if necessary, project the searchrect to source coords */
-    if (msProjectionsDiffer( &(map->projection), &(layer->projection)))  {
-      if ( msProjectRect(&map->projection, &layer->projection, &mapRect)
-          != MS_SUCCESS ) {
-        msDebug("msContourLayerReadRaster(%s): unable to reproject map request rectangle into layer projection, canceling.\n", layer->name);
+    if (msProjectionsDiffer(&(map->projection), &(layer->projection))) {
+      if (msProjectRect(&map->projection, &layer->projection, &mapRect) !=
+          MS_SUCCESS) {
+        msDebug("msContourLayerReadRaster(%s): unable to reproject map request "
+                "rectangle into layer projection, canceling.\n",
+                layer->name);
         return MS_FAILURE;
       }
 
@@ -266,24 +260,26 @@ static int msContourLayerReadRaster(laye
 
       /* if the projection failed to project the extent requested, we need to
          calculate the cellsize to preserve the initial map cellsize ratio */
-      if ( (mapRect.minx < GEO_TRANS(adfGeoTransform,0,src_ysize)) ||
-           (mapRect.maxx > GEO_TRANS(adfGeoTransform,src_xsize,0)) ||
-           (mapRect.miny < GEO_TRANS(adfGeoTransform+3,0,src_ysize)) || 
-           (mapRect.maxy > GEO_TRANS(adfGeoTransform+3,src_xsize,0)) ) {
+      if ((mapRect.minx < GEO_TRANS(adfGeoTransform, 0, src_ysize)) ||
+          (mapRect.maxx > GEO_TRANS(adfGeoTransform, src_xsize, 0)) ||
+          (mapRect.miny < GEO_TRANS(adfGeoTransform + 3, 0, src_ysize)) ||
+          (mapRect.maxy > GEO_TRANS(adfGeoTransform + 3, src_xsize, 0))) {
 
         int src_unit, dst_unit;
         src_unit = GetMapserverUnitUsingProj(&map->projection);
         dst_unit = GetMapserverUnitUsingProj(&layer->projection);
         if (src_unit == -1 || dst_unit == -1) {
-          msDebug("msContourLayerReadRaster(%s): unable to reproject map request rectangle into layer projection, canceling.\n", layer->name);
+          msDebug("msContourLayerReadRaster(%s): unable to reproject map "
+                  "request rectangle into layer projection, canceling.\n",
+                  layer->name);
           return MS_FAILURE;
         }
 
-        map_cellsize_x =  MS_CONVERT_UNIT(src_unit, dst_unit,
-                                          MS_CELLSIZE(rect.minx, rect.maxx, map->width)); 
-        map_cellsize_y = MS_CONVERT_UNIT(src_unit, dst_unit,
-                                         MS_CELLSIZE(rect.miny, rect.maxy, map->height));
-      }       
+        map_cellsize_x = MS_CONVERT_UNIT(
+            src_unit, dst_unit, MS_CELLSIZE(rect.minx, rect.maxx, map->width));
+        map_cellsize_y = MS_CONVERT_UNIT(
+            src_unit, dst_unit, MS_CELLSIZE(rect.miny, rect.maxy, map->height));
+      }
     }
 
     if (map_cellsize_x == 0 || map_cellsize_y == 0) {
@@ -291,36 +287,39 @@ static int msContourLayerReadRaster(laye
         msDebug("msContourLayerReadRaster(): Cellsize can't be 0.\n");
       return MS_FAILURE;
     }
-    
-    /* Adjust MapServer pixel model to GDAL pixel model */
-    mapRect.minx -= map_cellsize_x*0.5;
-    mapRect.maxx += map_cellsize_x*0.5;
-    mapRect.miny -= map_cellsize_y*0.5;
-    mapRect.maxy += map_cellsize_y*0.5;
 
+    /* Adjust MapServer pixel model to GDAL pixel model */
+    mapRect.minx -= map_cellsize_x * 0.5;
+    mapRect.maxx += map_cellsize_x * 0.5;
+    mapRect.miny -= map_cellsize_y * 0.5;
+    mapRect.maxy += map_cellsize_y * 0.5;
 
     /*
-     * If raw data cellsize (from geotransform) is larger than output map_cellsize
-     * then we want to extract only enough data to match the output map resolution
-     * which means that GDAL will automatically sample the data on read.
+     * If raw data cellsize (from geotransform) is larger than output
+     * map_cellsize then we want to extract only enough data to match the output
+     * map resolution which means that GDAL will automatically sample the data
+     * on read.
      *
-     * To prevent bad contour effects on tile edges, we adjust the target cellsize 
-     * to align the extracted window with a virtual grid based on the origin of the 
-     * raw data and a virtual grid step size corresponding to an integer sampling step.
+     * To prevent bad contour effects on tile edges, we adjust the target
+     * cellsize to align the extracted window with a virtual grid based on the
+     * origin of the raw data and a virtual grid step size corresponding to an
+     * integer sampling step.
      *
-     * If source data has a greater cellsize (i.e. lower res) that requested ouptut map
-     * then we use the raw data cellsize as target cellsize since there is no point in 
-     * interpolating the data for contours in this case.
+     * If source data has a greater cellsize (i.e. lower res) that requested
+     * ouptut map then we use the raw data cellsize as target cellsize since
+     * there is no point in interpolating the data for contours in this case.
      */
 
     virtual_grid_step_x = (int)floor(map_cellsize_x / ABS(adfGeoTransform[1]));
     if (virtual_grid_step_x < 1)
-      virtual_grid_step_x = 1; /* Do not interpolate data if grid sampling step < 1 */
+      virtual_grid_step_x =
+          1; /* Do not interpolate data if grid sampling step < 1 */
 
     virtual_grid_step_y = (int)floor(map_cellsize_y / ABS(adfGeoTransform[5]));
     if (virtual_grid_step_y < 1)
-      virtual_grid_step_y = 1; /* Do not interpolate data if grid sampling step < 1 */
-    
+      virtual_grid_step_y =
+          1; /* Do not interpolate data if grid sampling step < 1 */
+
     /* target cellsize is a multiple of raw data cellsize based on grid step*/
     dst_cellsize_x = ABS(adfGeoTransform[1]) * virtual_grid_step_x;
     dst_cellsize_y = ABS(adfGeoTransform[5]) * virtual_grid_step_y;
@@ -329,15 +328,15 @@ static int msContourLayerReadRaster(laye
 
     copyRect = mapRect;
 
-    if (copyRect.minx < GEO_TRANS(adfGeoTransform,0,src_ysize))
-      copyRect.minx = GEO_TRANS(adfGeoTransform,0,src_ysize);
-    if (copyRect.maxx > GEO_TRANS(adfGeoTransform,src_xsize,0))
-      copyRect.maxx = GEO_TRANS(adfGeoTransform,src_xsize,0);
-    if (copyRect.miny < GEO_TRANS(adfGeoTransform+3,0,src_ysize))
-      copyRect.miny = GEO_TRANS(adfGeoTransform+3,0,src_ysize);
-    if (copyRect.maxy > GEO_TRANS(adfGeoTransform+3,src_xsize,0))
-      copyRect.maxy = GEO_TRANS(adfGeoTransform+3,src_xsize,0);
-    
+    if (copyRect.minx < GEO_TRANS(adfGeoTransform, 0, src_ysize))
+      copyRect.minx = GEO_TRANS(adfGeoTransform, 0, src_ysize);
+    if (copyRect.maxx > GEO_TRANS(adfGeoTransform, src_xsize, 0))
+      copyRect.maxx = GEO_TRANS(adfGeoTransform, src_xsize, 0);
+    if (copyRect.miny < GEO_TRANS(adfGeoTransform + 3, 0, src_ysize))
+      copyRect.miny = GEO_TRANS(adfGeoTransform + 3, 0, src_ysize);
+    if (copyRect.maxy > GEO_TRANS(adfGeoTransform + 3, src_xsize, 0))
+      copyRect.maxy = GEO_TRANS(adfGeoTransform + 3, src_xsize, 0);
+
     if (copyRect.minx >= copyRect.maxx || copyRect.miny >= copyRect.maxy) {
       if (layer->debug)
         msDebug("msContourLayerReadRaster(): No overlap.\n");
@@ -347,42 +346,46 @@ static int msContourLayerReadRaster(laye
     /*
      * Convert extraction window to raster coordinates
      */
-    llx = GEO_TRANS(adfInvGeoTransform+0,copyRect.minx,copyRect.miny);
-    lly = GEO_TRANS(adfInvGeoTransform+3,copyRect.minx,copyRect.miny);
-    urx = GEO_TRANS(adfInvGeoTransform+0,copyRect.maxx,copyRect.maxy);
-    ury = GEO_TRANS(adfInvGeoTransform+3,copyRect.maxx,copyRect.maxy);
+    llx = GEO_TRANS(adfInvGeoTransform + 0, copyRect.minx, copyRect.miny);
+    lly = GEO_TRANS(adfInvGeoTransform + 3, copyRect.minx, copyRect.miny);
+    urx = GEO_TRANS(adfInvGeoTransform + 0, copyRect.maxx, copyRect.maxy);
+    ury = GEO_TRANS(adfInvGeoTransform + 3, copyRect.maxx, copyRect.maxy);
 
-    /* 
-     * Align extraction window with virtual grid 
+    /*
+     * Align extraction window with virtual grid
      * (keep in mind raster coordinates origin is at upper-left)
      * We also add an extra buffer to fix tile boundarie issues when zoomed
      */
-    llx = floor(llx / virtual_grid_step_x) * virtual_grid_step_x - (virtual_grid_step_x*5);
-    urx = ceil(urx / virtual_grid_step_x) * virtual_grid_step_x + (virtual_grid_step_x*5);
-    ury = floor(ury / virtual_grid_step_y) * virtual_grid_step_y - (virtual_grid_step_x*5);
-    lly = ceil(lly / virtual_grid_step_y) * virtual_grid_step_y + (virtual_grid_step_x*5);
-    
-    src_xoff = MS_MAX(0,(int) floor(llx+0.5));
-    src_yoff = MS_MAX(0,(int) floor(ury+0.5));
-    src_xsize = MS_MIN(MS_MAX(0,(int) (urx - llx + 0.5)),
-                    GDALGetRasterXSize(clinfo->hOrigDS) - src_xoff);
-    src_ysize = MS_MIN(MS_MAX(0,(int) (lly - ury + 0.5)),
-                    GDALGetRasterYSize(clinfo->hOrigDS) - src_yoff);
+    llx = floor(llx / virtual_grid_step_x) * virtual_grid_step_x -
+          (virtual_grid_step_x * 5);
+    urx = ceil(urx / virtual_grid_step_x) * virtual_grid_step_x +
+          (virtual_grid_step_x * 5);
+    ury = floor(ury / virtual_grid_step_y) * virtual_grid_step_y -
+          (virtual_grid_step_x * 5);
+    lly = ceil(lly / virtual_grid_step_y) * virtual_grid_step_y +
+          (virtual_grid_step_x * 5);
+
+    src_xoff = MS_MAX(0, (int)floor(llx + 0.5));
+    src_yoff = MS_MAX(0, (int)floor(ury + 0.5));
+    src_xsize = MS_MIN(MS_MAX(0, (int)(urx - llx + 0.5)),
+                       GDALGetRasterXSize(clinfo->hOrigDS) - src_xoff);
+    src_ysize = MS_MIN(MS_MAX(0, (int)(lly - ury + 0.5)),
+                       GDALGetRasterYSize(clinfo->hOrigDS) - src_yoff);
 
     /* Update the geographic extent (buffer added) */
     /* TODO: a better way to go the geo_trans */
-    copyRect.minx = GEO_TRANS(adfGeoTransform+0,src_xoff,0);
-    copyRect.maxx = GEO_TRANS(adfGeoTransform+0,src_xoff+src_xsize,0);
-    copyRect.miny = GEO_TRANS(adfGeoTransform+3,0,src_yoff+src_ysize);
-    copyRect.maxy = GEO_TRANS(adfGeoTransform+3,0,src_yoff);
-    
-    /* 
+    copyRect.minx = GEO_TRANS(adfGeoTransform + 0, src_xoff, 0);
+    copyRect.maxx = GEO_TRANS(adfGeoTransform + 0, src_xoff + src_xsize, 0);
+    copyRect.miny = GEO_TRANS(adfGeoTransform + 3, 0, src_yoff + src_ysize);
+    copyRect.maxy = GEO_TRANS(adfGeoTransform + 3, 0, src_yoff);
+
+    /*
      * If input window is to small then stop here
      */
-    if (src_xsize < 2 || src_ysize < 2)
-    {
+    if (src_xsize < 2 || src_ysize < 2) {
       if (layer->debug)
-        msDebug("msContourLayerReadRaster(): input window too small, or no apparent overlap between map view and this window(1).\n");
+        msDebug("msContourLayerReadRaster(): input window too small, or no "
+                "apparent overlap between map view and this window(1).\n");
       return MS_SUCCESS;
     }
 
@@ -392,19 +395,20 @@ static int msContourLayerReadRaster(laye
 
     if (dst_xsize == 0 || dst_ysize == 0) {
       if (layer->debug)
-        msDebug("msContourLayerReadRaster(): no apparent overlap between map view and this window(2).\n");
+        msDebug("msContourLayerReadRaster(): no apparent overlap between map "
+                "view and this window(2).\n");
       return MS_SUCCESS;
     }
 
     if (layer->debug)
-      msDebug( "msContourLayerReadRaster(): src=%d,%d,%d,%d, dst=%d,%d,%d,%d\n",
-               src_xoff, src_yoff, src_xsize, src_ysize,
-               0, 0, dst_xsize, dst_ysize );
+      msDebug("msContourLayerReadRaster(): src=%d,%d,%d,%d, dst=%d,%d,%d,%d\n",
+              src_xoff, src_yoff, src_xsize, src_ysize, 0, 0, dst_xsize,
+              dst_ysize);
   } else {
     src_xoff = 0;
     src_yoff = 0;
-    dst_xsize = src_xsize = MS_MIN(map->width,src_xsize);
-    dst_ysize = src_ysize = MS_MIN(map->height,src_ysize);
+    dst_xsize = src_xsize = MS_MIN(map->width, src_xsize);
+    dst_ysize = src_ysize = MS_MIN(map->height, src_ysize);
     copyRect.minx = 0;
     copyRect.miny = 0;
     (void)copyRect.miny;
@@ -418,46 +422,44 @@ static int msContourLayerReadRaster(laye
   /*      Allocate buffer, and read data into it.                         */
   /* -------------------------------------------------------------------- */
 
-  clinfo->buffer = (double *) malloc(sizeof(double) * dst_xsize * dst_ysize);
+  clinfo->buffer = (double *)malloc(sizeof(double) * dst_xsize * dst_ysize);
   if (clinfo->buffer == NULL) {
-    msSetError(MS_MEMERR, "Malloc(): Out of memory.", "msContourLayerReadRaster()");
+    msSetError(MS_MEMERR, "Malloc(): Out of memory.",
+               "msContourLayerReadRaster()");
     return MS_FAILURE;
   }
 
-  eErr = GDALRasterIO(hBand, GF_Read,
-                      src_xoff, src_yoff, src_xsize, src_ysize,
-                      clinfo->buffer, dst_xsize, dst_ysize, GDT_Float64,
-                      0, 0);
+  eErr = GDALRasterIO(hBand, GF_Read, src_xoff, src_yoff, src_xsize, src_ysize,
+                      clinfo->buffer, dst_xsize, dst_ysize, GDT_Float64, 0, 0);
 
   if (eErr != CE_None) {
-    msSetError( MS_IOERR, "GDALRasterIO() failed: %s",
-                "msContourLayerReadRaster()", CPLGetLastErrorMsg() );
+    msSetError(MS_IOERR, "GDALRasterIO() failed: %s",
+               "msContourLayerReadRaster()", CPLGetLastErrorMsg());
     free(clinfo->buffer);
     return MS_FAILURE;
   }
 
   memset(pointer, 0, sizeof(pointer));
   CPLPrintPointer(pointer, clinfo->buffer, sizeof(pointer));
-  sprintf(memDSPointer,"MEM:::DATAPOINTER=%s,PIXELS=%d,LINES=%d,BANDS=1,DATATYPE=Float64",
+  sprintf(memDSPointer,
+          "MEM:::DATAPOINTER=%s,PIXELS=%d,LINES=%d,BANDS=1,DATATYPE=Float64",
           pointer, dst_xsize, dst_ysize);
-  clinfo->hDS = GDALOpen(memDSPointer,  GA_ReadOnly);
+  clinfo->hDS = GDALOpen(memDSPointer, GA_ReadOnly);
   if (clinfo->hDS == NULL) {
-    msSetError(MS_IMGERR,
-               "Unable to open GDAL Memory dataset.",
+    msSetError(MS_IMGERR, "Unable to open GDAL Memory dataset.",
                "msContourLayerReadRaster()");
     free(clinfo->buffer);
     return MS_FAILURE;
   }
 
   {
-      // Copy nodata value from source dataset to memory dataset
-      int bHasNoData = FALSE;
-      double dfNoDataValue = GDALGetRasterNoDataValue(hBand, &bHasNoData);
-      if( bHasNoData )
-      {
-          GDALSetRasterNoDataValue(GDALGetRasterBand(clinfo->hDS, 1),
-                                   dfNoDataValue);
-      }
+    // Copy nodata value from source dataset to memory dataset
+    int bHasNoData = FALSE;
+    double dfNoDataValue = GDALGetRasterNoDataValue(hBand, &bHasNoData);
+    if (bHasNoData) {
+      GDALSetRasterNoDataValue(GDALGetRasterBand(clinfo->hDS, 1),
+                               dfNoDataValue);
+    }
   }
 
   adfGeoTransform[0] = copyRect.minx;
@@ -473,14 +475,13 @@ static int msContourLayerReadRaster(laye
     sprintf(buf, "%lf", clinfo->cellsize);
     msInsertHashTable(&layer->metadata, "__data_cellsize__", buf);
   }
-      
+
   GDALSetGeoTransform(clinfo->hDS, adfGeoTransform);
   return MS_SUCCESS;
 }
 
-static void msContourOGRCloseConnection(void *conn_handle)
-{
-  OGRDataSourceH hDS = (OGRDataSourceH) conn_handle;
+static void msContourOGRCloseConnection(void *conn_handle) {
+  OGRDataSourceH hDS = (OGRDataSourceH)conn_handle;
 
   msAcquireLock(TLOCK_OGR);
   OGR_DS_Destroy(hDS);
@@ -489,19 +490,18 @@ static void msContourOGRCloseConnection(
 
 /* Function that parses multiple options in the a list. It also supports
    min/maxscaledenom checks. ie. "CONTOUR_INTERVAL=0,3842942:10" */
-static char* msContourGetOption(layerObj *layer, const char *name)
-{
+static char *msContourGetOption(layerObj *layer, const char *name) {
   int c, i, found = MS_FALSE;
   char **values, **tmp, **options;
   double maxscaledenom, minscaledenom;
   char *value = NULL;
-  
+
   options = CSLFetchNameValueMultiple(layer->processing, name);
   c = CSLCount(options);
 
   /* First pass to find the value among options that have min/maxscaledenom */
   /* specified */
-  for (i=0; i<c && found == MS_FALSE; ++i) {
+  for (i = 0; i < c && found == MS_FALSE; ++i) {
     values = CSLTokenizeStringComplex(options[i], ":", FALSE, FALSE);
     if (CSLCount(values) == 2) {
       tmp = CSLTokenizeStringComplex(values[0], ",", FALSE, FALSE);
@@ -509,8 +509,10 @@ static char* msContourGetOption(layerObj
         minscaledenom = atof(tmp[0]);
         maxscaledenom = atof(tmp[1]);
         if (layer->map->scaledenom <= 0 ||
-            (((maxscaledenom <= 0) || (layer->map->scaledenom <= maxscaledenom)) &&
-             ((minscaledenom <= 0) || (layer->map->scaledenom > minscaledenom)))) {
+            (((maxscaledenom <= 0) ||
+              (layer->map->scaledenom <= maxscaledenom)) &&
+             ((minscaledenom <= 0) ||
+              (layer->map->scaledenom > minscaledenom)))) {
           value = msStrdup(values[1]);
           found = MS_TRUE;
         }
@@ -519,10 +521,10 @@ static char* msContourGetOption(layerObj
     }
     CSLDestroy(values);
   }
-  
+
   /* Second pass to find the value among options that do NOT have */
   /* min/maxscaledenom specified */
-  for (i=0; i<c && found == MS_FALSE; ++i) {
+  for (i = 0; i < c && found == MS_FALSE; ++i) {
     values = CSLTokenizeStringComplex(options[i], ":", FALSE, FALSE);
     if (CSLCount(values) == 1) {
       value = msStrdup(values[0]);
@@ -536,8 +538,7 @@ static char* msContourGetOption(layerObj
   return value;
 }
 
-static int msContourLayerGenerateContour(layerObj *layer)
-{
+static int msContourLayerGenerateContour(layerObj *layer) {
   OGRSFDriverH hDriver;
   OGRFieldDefnH hFld;
   OGRLayerH hLayer;
@@ -550,7 +551,7 @@ static int msContourLayerGenerateContour
   int bHasNoData = FALSE;
   double dfNoDataValue;
 
-  contourLayerInfo *clinfo = (contourLayerInfo *) layer->layerinfo;
+  contourLayerInfo *clinfo = (contourLayerInfo *)layer->layerinfo;
 
   OGRRegisterAll();
 
@@ -563,12 +564,10 @@ static int msContourLayerGenerateContour
   if (!clinfo->hDS) { /* no overlap */
     return MS_SUCCESS;
   }
-  
+
   hBand = GDALGetRasterBand(clinfo->hDS, 1);
-  if (hBand == NULL)
-  {
-    msSetError(MS_IMGERR,
-               "Band %d does not exist on dataset.",
+  if (hBand == NULL) {
+    msSetError(MS_IMGERR, "Band %d does not exist on dataset.",
                "msContourLayerGenerateContour()", 1);
     return MS_FAILURE;
   }
@@ -576,22 +575,20 @@ static int msContourLayerGenerateContour
   /* Create the OGR DataSource */
   hDriver = OGRGetDriverByName("Memory");
   if (hDriver == NULL) {
-    msSetError(MS_OGRERR,
-               "Unable to get OGR driver 'Memory'.",
+    msSetError(MS_OGRERR, "Unable to get OGR driver 'Memory'.",
                "msContourLayerCreateOGRDataSource()");
     return MS_FAILURE;
   }
 
   clinfo->hOGRDS = OGR_Dr_CreateDataSource(hDriver, "", NULL);
   if (clinfo->hOGRDS == NULL) {
-    msSetError(MS_OGRERR,
-               "Unable to create OGR DataSource.",
+    msSetError(MS_OGRERR, "Unable to create OGR DataSource.",
                "msContourLayerCreateOGRDataSource()");
     return MS_FAILURE;
   }
 
   hLayer = OGR_DS_CreateLayer(clinfo->hOGRDS, clinfo->ogrLayer.name, NULL,
-                              wkbLineString, NULL );
+                              wkbLineString, NULL);
 
   hFld = OGR_Fld_Create("ID", OFTInteger);
   OGR_Fld_SetWidth(hFld, 8);
@@ -599,15 +596,14 @@ static int msContourLayerGenerateContour
   OGR_Fld_Destroy(hFld);
 
   /* Check if we have a coutour item specified */
-  elevItem = CSLFetchNameValue(layer->processing,"CONTOUR_ITEM");
+  elevItem = CSLFetchNameValue(layer->processing, "CONTOUR_ITEM");
   if (elevItem && strlen(elevItem) > 0) {
     hFld = OGR_Fld_Create(elevItem, OFTReal);
     OGR_Fld_SetWidth(hFld, 12);
     OGR_Fld_SetPrecision(hFld, 3);
     OGR_L_CreateField(hLayer, hFld, FALSE);
     OGR_Fld_Destroy(hFld);
-  }
-  else {
+  } else {
     elevItem = NULL;
   }
 
@@ -619,11 +615,11 @@ static int msContourLayerGenerateContour
 
   option = msContourGetOption(layer, "CONTOUR_LEVELS");
   if (option) {
-    int i,c;
+    int i, c;
     char **levelsTmp;
     levelsTmp = CSLTokenizeStringComplex(option, ",", FALSE, FALSE);
     c = CSLCount(levelsTmp);
-    for (i=0;i<c && i<(int)(sizeof(levels)/sizeof(double)) ;++i)
+    for (i = 0; i < c && i < (int)(sizeof(levels) / sizeof(double)); ++i)
       levels[levelCount++] = atof(levelsTmp[i]);
 
     CSLDestroy(levelsTmp);
@@ -632,30 +628,27 @@ static int msContourLayerGenerateContour
 
   dfNoDataValue = GDALGetRasterNoDataValue(hBand, &bHasNoData);
 
-  eErr = GDALContourGenerate( hBand, interval, 0.0,
-                              levelCount, levels,
-                              bHasNoData, dfNoDataValue, hLayer,
-                              OGR_FD_GetFieldIndex(OGR_L_GetLayerDefn( hLayer),
-                                                    "ID" ),
-                              (elevItem == NULL) ? -1 :
-                              OGR_FD_GetFieldIndex(OGR_L_GetLayerDefn( hLayer), 
-                                                    elevItem ),
-                              NULL, NULL );
+  eErr = GDALContourGenerate(
+      hBand, interval, 0.0, levelCount, levels, bHasNoData, dfNoDataValue,
+      hLayer, OGR_FD_GetFieldIndex(OGR_L_GetLayerDefn(hLayer), "ID"),
+      (elevItem == NULL)
+          ? -1
+          : OGR_FD_GetFieldIndex(OGR_L_GetLayerDefn(hLayer), elevItem),
+      NULL, NULL);
 
   if (eErr != CE_None) {
-    msSetError( MS_IOERR, "GDALContourGenerate() failed: %s",
-                "msContourLayerGenerateContour()", CPLGetLastErrorMsg() );
+    msSetError(MS_IOERR, "GDALContourGenerate() failed: %s",
+               "msContourLayerGenerateContour()", CPLGetLastErrorMsg());
     return MS_FAILURE;
   }
-  
-  msConnPoolRegister(&clinfo->ogrLayer, clinfo->hOGRDS, msContourOGRCloseConnection);
 
-  return MS_SUCCESS;
+  msConnPoolRegister(&clinfo->ogrLayer, clinfo->hOGRDS,
+                     msContourOGRCloseConnection);
 
+  return MS_SUCCESS;
 }
 
-int msContourLayerOpen(layerObj *layer)
-{
+int msContourLayerOpen(layerObj *layer) {
   char *decrypted_path;
   char szPath[MS_MAXPATHLEN];
   contourLayerInfo *clinfo;
@@ -667,69 +660,59 @@ int msContourLayerOpen(layerObj *layer)
   if (layer->layerinfo == NULL)
     msContourLayerInfoInitialize(layer);
 
-  clinfo = (contourLayerInfo *) layer->layerinfo;
-  if (layer->data == NULL && layer->tileindex == NULL ) {
-    msSetError(MS_MISCERR,
-               "Layer %s has neither DATA nor TILEINDEX defined.",
-               "msContourLayerOpen()",
-               layer->name);
+  clinfo = (contourLayerInfo *)layer->layerinfo;
+  if (layer->data == NULL && layer->tileindex == NULL) {
+    msSetError(MS_MISCERR, "Layer %s has neither DATA nor TILEINDEX defined.",
+               "msContourLayerOpen()", layer->name);
     return MS_FAILURE;
   }
 
-  if( layer->tileindex != NULL )
-  {
-      char szTilename[MS_MAXPATHLEN];
-      int status;
-      int tilelayerindex, tileitemindex, tilesrsindex;
-      rectObj searchrect;
-      layerObj* tlp;
-      shapeObj tshp;
-      char tilesrsname[1];
-
-      msInitShape(&tshp);
-      searchrect = layer->map->extent;
-
-      status = msDrawRasterSetupTileLayer(layer->map, layer,
-                                 &searchrect, MS_FALSE,
-                                 &tilelayerindex,
-                                 &tileitemindex,
-                                 &tilesrsindex,
-                                 &tlp);
-      if( status == MS_FAILURE )
-      {
-          return MS_FAILURE;
-      }
+  if (layer->tileindex != NULL) {
+    char szTilename[MS_MAXPATHLEN];
+    int status;
+    int tilelayerindex, tileitemindex, tilesrsindex;
+    rectObj searchrect;
+    layerObj *tlp;
+    shapeObj tshp;
+    char tilesrsname[1];
+
+    msInitShape(&tshp);
+    searchrect = layer->map->extent;
+
+    status = msDrawRasterSetupTileLayer(layer->map, layer, &searchrect,
+                                        MS_FALSE, &tilelayerindex,
+                                        &tileitemindex, &tilesrsindex, &tlp);
+    if (status == MS_FAILURE) {
+      return MS_FAILURE;
+    }
 
-      status = msDrawRasterIterateTileIndex(layer, tlp, &tshp,
-                                            tileitemindex, -1,
-                                            szTilename, sizeof(szTilename),
-                                            tilesrsname, sizeof(tilesrsname));
-      if( status == MS_FAILURE || status == MS_DONE ) {
-          if( status == MS_DONE )
-          {
-              if (layer->debug)
-                msDebug("No raster matching filter.\n");
-          }
-          msDrawRasterCleanupTileLayer(tlp, tilelayerindex);
-          return MS_FAILURE;
+    status = msDrawRasterIterateTileIndex(layer, tlp, &tshp, tileitemindex, -1,
+                                          szTilename, sizeof(szTilename),
+                                          tilesrsname, sizeof(tilesrsname));
+    if (status == MS_FAILURE || status == MS_DONE) {
+      if (status == MS_DONE) {
+        if (layer->debug)
+          msDebug("No raster matching filter.\n");
       }
-
       msDrawRasterCleanupTileLayer(tlp, tilelayerindex);
+      return MS_FAILURE;
+    }
 
-      msDrawRasterBuildRasterPath(layer->map, layer, szTilename, szPath);
-      decrypted_path = msStrdup(szPath);
+    msDrawRasterCleanupTileLayer(tlp, tilelayerindex);
 
-      /* Cancel the time filter that might have been set on ours in case of */
-      /* a inline tileindex */
-      msFreeExpression(&layer->filter);
-      msInitExpression(&layer->filter);
-  }
-  else
-  {
-      msTryBuildPath3(szPath, layer->map->mappath, layer->map->shapepath, layer->data);
-      decrypted_path = msDecryptStringTokens(layer->map, szPath);
+    msDrawRasterBuildRasterPath(layer->map, layer, szTilename, szPath);
+    decrypted_path = msStrdup(szPath);
+
+    /* Cancel the time filter that might have been set on ours in case of */
+    /* a inline tileindex */
+    msFreeExpression(&layer->filter);
+    msInitExpression(&layer->filter);
+  } else {
+    msTryBuildPath3(szPath, layer->map->mappath, layer->map->shapepath,
+                    layer->data);
+    decrypted_path = msDecryptStringTokens(layer->map, szPath);
   }
-  
+
   GDALAllRegister();
 
   /* Open the original Dataset */
@@ -744,12 +727,11 @@ int msContourLayerOpen(layerObj *layer)
   msReleaseLock(TLOCK_GDAL);
 
   if (clinfo->hOrigDS == NULL) {
-    msSetError(MS_IMGERR,
-               "Unable to open GDAL dataset.",
+    msSetError(MS_IMGERR, "Unable to open GDAL dataset.",
                "msContourLayerOpen()");
     return MS_FAILURE;
   }
-  
+
   /* Open the raster source */
   if (msContourLayerReadRaster(layer, layer->map->extent) != MS_SUCCESS)
     return MS_FAILURE;
@@ -760,27 +742,25 @@ int msContourLayerOpen(layerObj *layer)
 
   if (clinfo->hDS) {
     GDALClose(clinfo->hDS);
-    clinfo->hDS = NULL;  
+    clinfo->hDS = NULL;
     free(clinfo->buffer);
   }
 
   /* Open our virtual ogr layer */
   if (clinfo->hOGRDS && (msLayerOpen(&clinfo->ogrLayer) != MS_SUCCESS))
     return MS_FAILURE;
-  
+
   return MS_SUCCESS;
 }
 
-int msContourLayerIsOpen(layerObj *layer)
-{
+int msContourLayerIsOpen(layerObj *layer) {
   if (layer->layerinfo)
     return MS_TRUE;
   return MS_FALSE;
 }
-  
-int msContourLayerClose(layerObj *layer)
-{
-  contourLayerInfo *clinfo = (contourLayerInfo *) layer->layerinfo;
+
+int msContourLayerClose(layerObj *layer) {
+  contourLayerInfo *clinfo = (contourLayerInfo *)layer->layerinfo;
 
   if (layer->debug)
     msDebug("Entering msContourLayerClose().\n");
@@ -790,29 +770,27 @@ int msContourLayerClose(layerObj *layer)
       msConnPoolRelease(&clinfo->ogrLayer, clinfo->hOGRDS);
 
     msLayerClose(&clinfo->ogrLayer);
-    
+
     if (clinfo->hDS) {
       GDALClose(clinfo->hDS);
       clinfo->hDS = NULL;
-      free(clinfo->buffer);      
+      free(clinfo->buffer);
     }
 
     if (clinfo->hOrigDS) {
       GDALClose(clinfo->hOrigDS);
-      clinfo->hOrigDS = NULL;      
+      clinfo->hOrigDS = NULL;
     }
 
     msContourLayerInfoFree(layer);
-
   }
-  
+
   return MS_SUCCESS;
 }
 
-int msContourLayerGetItems(layerObj *layer)
-{
-  const char* elevItem;
-  contourLayerInfo *clinfo = (contourLayerInfo *) layer->layerinfo;
+int msContourLayerGetItems(layerObj *layer) {
+  const char *elevItem;
+  contourLayerInfo *clinfo = (contourLayerInfo *)layer->layerinfo;
 
   if (clinfo == NULL) {
     msSetError(MS_MISCERR, "Assertion failed: Contour layer not opened!!!",
@@ -821,10 +799,10 @@ int msContourLayerGetItems(layerObj *lay
   }
 
   layer->numitems = 0;
-  layer->items = (char **) msSmallCalloc(sizeof(char *),2);
+  layer->items = (char **)msSmallCalloc(sizeof(char *), 2);
 
   layer->items[layer->numitems++] = msStrdup("ID");
-  elevItem = CSLFetchNameValue(layer->processing,"CONTOUR_ITEM");
+  elevItem = CSLFetchNameValue(layer->processing, "CONTOUR_ITEM");
   if (elevItem && strlen(elevItem) > 0) {
     layer->items[layer->numitems++] = msStrdup(elevItem);
   }
@@ -832,11 +810,10 @@ int msContourLayerGetItems(layerObj *lay
   return msLayerGetItems(&clinfo->ogrLayer);
 }
 
-int msContourLayerWhichShapes(layerObj *layer, rectObj rect, int isQuery)
-{
+int msContourLayerWhichShapes(layerObj *layer, rectObj rect, int isQuery) {
   int i;
   rectObj newRect;
-  contourLayerInfo *clinfo = (contourLayerInfo *) layer->layerinfo;
+  contourLayerInfo *clinfo = (contourLayerInfo *)layer->layerinfo;
 
   if (layer->debug)
     msDebug("Entering msContourLayerWhichShapes().\n");
@@ -847,18 +824,17 @@ int msContourLayerWhichShapes(layerObj *
     return MS_FAILURE;
   }
 
-  if( isQuery )
-  {
+  if (isQuery) {
     newRect = layer->map->extent;
-  }
-  else
-  {
+  } else {
     newRect = rect;
     /* if necessary, project the searchrect to source coords */
-    if (msProjectionsDiffer( &(layer->map->projection), &(layer->projection)))  {
-      if (msProjectRect(&layer->projection, &layer->map->projection, &newRect)
-          != MS_SUCCESS ) {
-        msDebug("msContourLayerWhichShapes(%s): unable to reproject map request rectangle into layer projection, canceling.\n", layer->name);
+    if (msProjectionsDiffer(&(layer->map->projection), &(layer->projection))) {
+      if (msProjectRect(&layer->projection, &layer->map->projection,
+                        &newRect) != MS_SUCCESS) {
+        msDebug("msContourLayerWhichShapes(%s): unable to reproject map "
+                "request rectangle into layer projection, canceling.\n",
+                layer->name);
         return MS_FAILURE;
       }
     }
@@ -867,9 +843,9 @@ int msContourLayerWhichShapes(layerObj *
   /* regenerate the raster io */
   if (clinfo->hOGRDS)
     msConnPoolRelease(&clinfo->ogrLayer, clinfo->hOGRDS);
-  
+
   msLayerClose(&clinfo->ogrLayer);
-  
+
   /* Open the raster source */
   if (msContourLayerReadRaster(layer, newRect) != MS_SUCCESS)
     return MS_FAILURE;
@@ -883,26 +859,27 @@ int msContourLayerWhichShapes(layerObj *
     clinfo->hDS = NULL;
     free(clinfo->buffer);
   }
-  
+
   if (!clinfo->hOGRDS) /* no overlap */
     return MS_DONE;
-  
+
   /* Open our virtual ogr layer */
   if (msLayerOpen(&clinfo->ogrLayer) != MS_SUCCESS)
     return MS_FAILURE;
 
   clinfo->ogrLayer.numitems = layer->numitems;
-  clinfo->ogrLayer.items = (char **) msSmallMalloc(sizeof(char *)*layer->numitems);
-  for (i=0; i<layer->numitems;++i) {
+  clinfo->ogrLayer.items =
+      (char **)msSmallMalloc(sizeof(char *) * layer->numitems);
+  for (i = 0; i < layer->numitems; ++i) {
     clinfo->ogrLayer.items[i] = msStrdup(layer->items[i]);
   }
 
   return msLayerWhichShapes(&clinfo->ogrLayer, rect, isQuery);
 }
 
-int msContourLayerGetShape(layerObj *layer, shapeObj *shape, resultObj *record)
-{
-  contourLayerInfo *clinfo = (contourLayerInfo *) layer->layerinfo;
+int msContourLayerGetShape(layerObj *layer, shapeObj *shape,
+                           resultObj *record) {
+  contourLayerInfo *clinfo = (contourLayerInfo *)layer->layerinfo;
 
   if (layer->debug)
     msDebug("Entering msContourLayerGetShape().\n");
@@ -916,9 +893,8 @@ int msContourLayerGetShape(layerObj *lay
   return msLayerGetShape(&clinfo->ogrLayer, shape, record);
 }
 
-int msContourLayerNextShape(layerObj *layer, shapeObj *shape)
-{
-  contourLayerInfo *clinfo = (contourLayerInfo *) layer->layerinfo;
+int msContourLayerNextShape(layerObj *layer, shapeObj *shape) {
+  contourLayerInfo *clinfo = (contourLayerInfo *)layer->layerinfo;
 
   if (layer->debug)
     msDebug("Entering msContourLayerNextShape().\n");
@@ -937,9 +913,8 @@ int msContourLayerNextShape(layerObj *la
 /* Simple copy of the maprasterquery.c file. might change in the future */
 /************************************************************************/
 
-int msContourLayerGetExtent(layerObj *layer, rectObj *extent)
-{
-  contourLayerInfo *clinfo = (contourLayerInfo *) layer->layerinfo;
+int msContourLayerGetExtent(layerObj *layer, rectObj *extent) {
+  contourLayerInfo *clinfo = (contourLayerInfo *)layer->layerinfo;
 
   if (layer->debug)
     msDebug("Entering msContourLayerGetExtent().\n");
@@ -970,8 +945,7 @@ int msContourLayerGetExtent(layerObj *la
 /************************************************************************/
 
 int msContourLayerSetTimeFilter(layerObj *layer, const char *timestring,
-                               const char *timefield)
-{
+                                const char *timefield) {
   int tilelayerindex;
 
   if (layer->debug)
@@ -980,11 +954,11 @@ int msContourLayerSetTimeFilter(layerObj
   /* -------------------------------------------------------------------- */
   /*      If we don't have a tileindex the time filter has no effect.     */
   /* -------------------------------------------------------------------- */
-  if( layer->tileindex == NULL )
-  {
-      if (layer->debug)
-          msDebug("msContourLayerSetTimeFilter(): time filter without effect on layers without tileindex.\n");
-      return MS_SUCCESS;
+  if (layer->tileindex == NULL) {
+    if (layer->debug)
+      msDebug("msContourLayerSetTimeFilter(): time filter without effect on "
+              "layers without tileindex.\n");
+    return MS_SUCCESS;
   }
 
   /* -------------------------------------------------------------------- */
@@ -997,25 +971,24 @@ int msContourLayerSetTimeFilter(layerObj
   /*      to say, the tileindex name is not of another layer), then we    */
   /*      just install a backtics style filter on the current layer.      */
   /* -------------------------------------------------------------------- */
-  if( tilelayerindex == -1 )
-    return msLayerMakeBackticsTimeFilter( layer, timestring, timefield );
+  if (tilelayerindex == -1)
+    return msLayerMakeBackticsTimeFilter(layer, timestring, timefield);
 
   /* -------------------------------------------------------------------- */
   /*      Otherwise we invoke the tileindex layers SetTimeFilter          */
   /*      method.                                                         */
   /* -------------------------------------------------------------------- */
-  if ( msCheckParentPointer(layer->map,"map")==MS_FAILURE )
+  if (msCheckParentPointer(layer->map, "map") == MS_FAILURE)
     return MS_FAILURE;
-  return msLayerSetTimeFilter( layer->GET_LAYER(map,tilelayerindex),
-                               timestring, timefield );
+  return msLayerSetTimeFilter(layer->GET_LAYER(map, tilelayerindex), timestring,
+                              timefield);
 }
 
 /************************************************************************/
 /*                msRASTERLayerInitializeVirtualTable()                 */
 /************************************************************************/
 
-int msContourLayerInitializeVirtualTable(layerObj *layer)
-{
+int msContourLayerInitializeVirtualTable(layerObj *layer) {
   assert(layer != NULL);
   assert(layer->vtable != NULL);
 
diff -pruN 8.0.1-5/mapcopy.c 8.0.2-1/mapcopy.c
--- 8.0.1-5/mapcopy.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapcopy.c	2024-06-11 20:41:34.000000000 +0000
@@ -53,8 +53,8 @@
  * Copy a projectionObj while adding additional arguments              *
  **********************************************************************/
 
-int msCopyProjectionExtended(projectionObj *dst, const projectionObj *src, char ** args, int num_args)
-{
+int msCopyProjectionExtended(projectionObj *dst, const projectionObj *src,
+                             char **args, int num_args) {
   MS_COPYSTELEM(numargs);
   MS_COPYSTELEM(gt);
   MS_COPYSTELEM(automatic);
@@ -63,11 +63,10 @@ int msCopyProjectionExtended(projectionO
     /* Our destination consists of unallocated pointers */
     dst->args[i] = msStrdup(src->args[i]);
   }
-  if( args )
-  {
-      for(int i=0 ; i< num_args; i++) {
-        dst->args[dst->numargs++] = msStrdup(args[i]);
-      }
+  if (args) {
+    for (int i = 0; i < num_args; i++) {
+      dst->args[dst->numargs++] = msStrdup(args[i]);
+    }
   }
   msProjectionInheritContextFrom(dst, src);
   if (dst->numargs != 0) {
@@ -84,9 +83,8 @@ int msCopyProjectionExtended(projectionO
  * Copy a projectionObj                                                *
  **********************************************************************/
 
-int msCopyProjection(projectionObj *dst, const projectionObj *src)
-{
-  return msCopyProjectionExtended(dst,src,NULL,0);
+int msCopyProjection(projectionObj *dst, const projectionObj *src) {
+  return msCopyProjectionExtended(dst, src, NULL, 0);
 }
 
 /***********************************************************************
@@ -94,8 +92,7 @@ int msCopyProjection(projectionObj *dst,
  *                                                                     *
  * Copy a lineObj, using msCopyPoint()                                 *
  **********************************************************************/
-int msCopyLine(lineObj *dst, const lineObj *src)
-{
+int msCopyLine(lineObj *dst, const lineObj *src) {
 
   int i;
 
@@ -141,8 +138,7 @@ int msCopyShapeObj(shapeObj *dst, shapeO
  * Copy an itemObj                                                     *
  **********************************************************************/
 
-int msCopyItem(itemObj *dst, const itemObj *src)
-{
+int msCopyItem(itemObj *dst, const itemObj *src) {
 
   MS_COPYSTRING(dst->name, src->name);
   MS_COPYSTELEM(type);
@@ -159,9 +155,8 @@ int msCopyItem(itemObj *dst, const itemO
  * Copy a hashTableObj, using msInsertHashTable()                      *
  **********************************************************************/
 
-int msCopyHashTable(hashTableObj *dst, const hashTableObj *src)
-{
-  const char *key=NULL;
+int msCopyHashTable(hashTableObj *dst, const hashTableObj *src) {
+  const char *key = NULL;
   while (1) {
     key = msNextKeyFromHashTable(src, key);
     if (!key)
@@ -178,8 +173,7 @@ int msCopyHashTable(hashTableObj *dst, c
  * Copy a fontSetObj, using msCreateHashTable() and msCopyHashTable()  *
  **********************************************************************/
 
-int msCopyFontSet(fontSetObj *dst, const fontSetObj *src, mapObj *map)
-{
+int msCopyFontSet(fontSetObj *dst, const fontSetObj *src, mapObj *map) {
 
   MS_COPYSTRING(dst->filename, src->filename);
   MS_COPYSTELEM(numfonts);
@@ -201,9 +195,9 @@ int msCopyFontSet(fontSetObj *dst, const
  * Copy an expressionObj, but only its string, type and flags          *
  **********************************************************************/
 
-int msCopyExpression(expressionObj *dst, const expressionObj *src)
-{
-  if((dst->type == MS_REGEX) && dst->compiled) ms_regfree(&(dst->regex));
+int msCopyExpression(expressionObj *dst, const expressionObj *src) {
+  if ((dst->type == MS_REGEX) && dst->compiled)
+    ms_regfree(&(dst->regex));
   dst->compiled = MS_FALSE;
 
   MS_COPYSTRING(dst->string, src->string);
@@ -219,8 +213,7 @@ int msCopyExpression(expressionObj *dst,
  * Copy a joinObj                                                      *
  **********************************************************************/
 
-int msCopyJoin(joinObj *dst, const joinObj *src)
-{
+int msCopyJoin(joinObj *dst, const joinObj *src) {
   MS_COPYSTRING(dst->name, src->name);
 
   /* makes no sense to copy the items or values
@@ -253,8 +246,7 @@ int msCopyJoin(joinObj *dst, const joinO
  * Copy a queryMapObj, using msCopyColor()                             *
  **********************************************************************/
 
-int msCopyQueryMap(queryMapObj *dst, const queryMapObj *src)
-{
+int msCopyQueryMap(queryMapObj *dst, const queryMapObj *src) {
   MS_COPYSTELEM(height);
   MS_COPYSTELEM(width);
   MS_COPYSTELEM(status);
@@ -264,15 +256,13 @@ int msCopyQueryMap(queryMapObj *dst, con
   return MS_SUCCESS;
 }
 
-
 /***********************************************************************
  * msCopyLeader()                                                      *
  *                                                                     *
  * Copy a labelLeaderObj, using msCopyStyle()                          *
  **********************************************************************/
 
-int msCopyLabelLeader(labelLeaderObj *dst, const labelLeaderObj *src)
-{
+int msCopyLabelLeader(labelLeaderObj *dst, const labelLeaderObj *src) {
   int i;
   assert(dst && src);
   MS_COPYSTELEM(gridstep);
@@ -282,9 +272,10 @@ int msCopyLabelLeader(labelLeaderObj *ds
    */
 
   /* free any previous styles on the dst label */
-  for(i=0; i<dst->numstyles; i++) { /* each style */
-    if (dst->styles[i]!=NULL) {
-      if( freeStyle(dst->styles[i]) == MS_SUCCESS ) msFree(dst->styles[i]);
+  for (i = 0; i < dst->numstyles; i++) { /* each style */
+    if (dst->styles[i] != NULL) {
+      if (freeStyle(dst->styles[i]) == MS_SUCCESS)
+        msFree(dst->styles[i]);
     }
   }
   dst->numstyles = 0;
@@ -311,13 +302,13 @@ int msCopyLabelLeader(labelLeaderObj *ds
  * Copy a labelObj, using msCopyColor() and msCopyStyle()              *
  **********************************************************************/
 
-int msCopyLabel(labelObj *dst, const labelObj *src)
-{
+int msCopyLabel(labelObj *dst, const labelObj *src) {
   int i;
 
-  for(i=0; i<MS_LABEL_BINDING_LENGTH; i++) {
+  for (i = 0; i < MS_LABEL_BINDING_LENGTH; i++) {
     MS_COPYSTRING(dst->bindings[i].item, src->bindings[i].item);
-    dst->bindings[i].index = src->bindings[i].index; /* no way to use the macros */
+    dst->bindings[i].index =
+        src->bindings[i].index; /* no way to use the macros */
     MS_COPYSTRING(dst->exprBindings[i].string, src->exprBindings[i].string);
     dst->exprBindings[i].type = src->exprBindings[i].type;
   }
@@ -360,7 +351,6 @@ int msCopyLabel(labelObj *dst, const lab
   MS_COPYSTELEM(repeatdistance);
   MS_COPYSTELEM(maxoverlapangle);
 
-
   MS_COPYSTRING(dst->encoding, src->encoding);
 
   MS_COPYSTELEM(outlinewidth);
@@ -381,9 +371,10 @@ int msCopyLabel(labelObj *dst, const lab
   */
 
   /* free any previous styles on the dst label */
-  for(i=0; i<dst->numstyles; i++) { /* each style */
-    if (dst->styles[i]!=NULL) {
-      if( freeStyle(dst->styles[i]) == MS_SUCCESS ) msFree(dst->styles[i]);
+  for (i = 0; i < dst->numstyles; i++) { /* each style */
+    if (dst->styles[i] != NULL) {
+      if (freeStyle(dst->styles[i]) == MS_SUCCESS)
+        msFree(dst->styles[i]);
     }
   }
   dst->numstyles = 0;
@@ -402,12 +393,12 @@ int msCopyLabel(labelObj *dst, const lab
     dst->numstyles++;
   }
 
-  if(src->leader) {
+  if (src->leader) {
     dst->leader = msSmallMalloc(sizeof(labelLeaderObj));
     initLeader(dst->leader);
-    msCopyLabelLeader(dst->leader,src->leader);
+    msCopyLabelLeader(dst->leader, src->leader);
   } else {
-    if(dst->leader) {
+    if (dst->leader) {
       freeLabelLeader(dst->leader);
       msFree(dst->leader);
     }
@@ -427,8 +418,7 @@ int msCopyLabel(labelObj *dst, const lab
  * msCopyHashTable()                                                   *
  **********************************************************************/
 
-int msCopyWeb(webObj *dst, const webObj *src, mapObj *map)
-{
+int msCopyWeb(webObj *dst, const webObj *src, mapObj *map) {
 
   MS_COPYSTRING(dst->imagepath, src->imagepath);
   MS_COPYSTRING(dst->imageurl, src->imageurl);
@@ -453,13 +443,13 @@ int msCopyWeb(webObj *dst, const webObj
     if (msCopyHashTable(&(dst->metadata), &(src->metadata)) != MS_SUCCESS)
       return MS_FAILURE;
   }
-  msCopyHashTable(&dst->validation,&src->validation);
+  msCopyHashTable(&dst->validation, &src->validation);
 
   MS_COPYSTRING(dst->queryformat, src->queryformat);
   MS_COPYSTRING(dst->legendformat, src->legendformat);
   MS_COPYSTRING(dst->browseformat, src->browseformat);
 
-  return MS_SUCCESS ;
+  return MS_SUCCESS;
 }
 
 /***********************************************************************
@@ -468,13 +458,13 @@ int msCopyWeb(webObj *dst, const webObj
  * Copy a styleObj, using msCopyColor()                                *
  **********************************************************************/
 
-int msCopyStyle(styleObj *dst, const styleObj *src)
-{
+int msCopyStyle(styleObj *dst, const styleObj *src) {
   int i;
 
-  for(i=0; i<MS_STYLE_BINDING_LENGTH; i++) {
+  for (i = 0; i < MS_STYLE_BINDING_LENGTH; i++) {
     MS_COPYSTRING(dst->bindings[i].item, src->bindings[i].item);
-    dst->bindings[i].index = src->bindings[i].index; /* no way to use the macros */
+    dst->bindings[i].index =
+        src->bindings[i].index; /* no way to use the macros */
     MS_COPYSTRING(dst->exprBindings[i].string, src->exprBindings[i].string);
     dst->exprBindings[i].type = src->exprBindings[i].type;
   }
@@ -482,15 +472,15 @@ int msCopyStyle(styleObj *dst, const sty
   MS_COPYSTELEM(nexprbindings);
 
   MS_COPYCOLOR(&(dst->color), &(src->color));
-  MS_COPYCOLOR(&(dst->outlinecolor),&(src->outlinecolor));
+  MS_COPYCOLOR(&(dst->outlinecolor), &(src->outlinecolor));
 
   MS_COPYCOLOR(&(dst->mincolor), &(src->mincolor));
   MS_COPYCOLOR(&(dst->maxcolor), &(src->maxcolor));
 
   MS_COPYSTRING(dst->symbolname, src->symbolname);
   MS_COPYSTELEM(patternlength);
-  for(i=0; i<src->patternlength; i++)
-    dst->pattern[i]=src->pattern[i];
+  for (i = 0; i < src->patternlength; i++)
+    dst->pattern[i] = src->pattern[i];
   MS_COPYSTELEM(initialgap);
   MS_COPYSTELEM(gap);
   MS_COPYSTELEM(linejoin);
@@ -533,12 +523,11 @@ int msCopyStyle(styleObj *dst, const sty
  * msCopyLabel(), msCreateHashTable(), msCopyHashTable()               *
  **********************************************************************/
 
-int msCopyClass(classObj *dst, const classObj *src, layerObj *layer_unused)
-{
+int msCopyClass(classObj *dst, const classObj *src, layerObj *layer_unused) {
   int i, return_value;
   (void)layer_unused;
 
-  return_value = msCopyExpression(&(dst->expression),&(src->expression));
+  return_value = msCopyExpression(&(dst->expression), &(src->expression));
   if (return_value != MS_SUCCESS) {
     msSetError(MS_MEMERR, "Failed to copy expression.", "msCopyClass()");
     return MS_FAILURE;
@@ -548,9 +537,9 @@ int msCopyClass(classObj *dst, const cla
   MS_COPYSTELEM(isfallback);
 
   /* free any previous styles on the dst layer */
-  for(i=0; i<dst->numstyles; i++) { /* each style */
-    if (dst->styles[i]!=NULL) {
-      if( freeStyle(dst->styles[i]) == MS_SUCCESS ) {
+  for (i = 0; i < dst->numstyles; i++) { /* each style */
+    if (dst->styles[i] != NULL) {
+      if (freeStyle(dst->styles[i]) == MS_SUCCESS) {
         msFree(dst->styles[i]);
       }
     }
@@ -572,7 +561,7 @@ int msCopyClass(classObj *dst, const cla
     dst->numstyles++;
   }
 
-  for (i=0; i<src->numlabels; i++) {
+  for (i = 0; i < src->numlabels; i++) {
     if (msGrowClassLabels(dst) == NULL)
       return MS_FAILURE;
     initLabel(dst->labels[i]);
@@ -585,15 +574,15 @@ int msCopyClass(classObj *dst, const cla
   }
   MS_COPYSTELEM(numlabels);
 
-  if(src->leader) {
-    if(dst->leader) {
+  if (src->leader) {
+    if (dst->leader) {
       freeLabelLeader(dst->leader);
     }
-    if(!dst->leader) {
+    if (!dst->leader) {
       dst->leader = msSmallMalloc(sizeof(labelLeaderObj));
       initLeader(dst->leader);
     }
-    msCopyLabelLeader(dst->leader,src->leader);
+    msCopyLabelLeader(dst->leader, src->leader);
   }
 
   MS_COPYSTRING(dst->keyimage, src->keyimage);
@@ -616,7 +605,7 @@ int msCopyClass(classObj *dst, const cla
     /* dst->metadata = msCreateHashTable(); */
     msCopyHashTable(&(dst->metadata), &(src->metadata));
   }
-  msCopyHashTable(&dst->validation,&src->validation);
+  msCopyHashTable(&dst->validation, &src->validation);
 
   MS_COPYSTELEM(minscaledenom);
   MS_COPYSTELEM(maxscaledenom);
@@ -629,21 +618,20 @@ int msCopyClass(classObj *dst, const cla
   return MS_SUCCESS;
 }
 
-int msCopyCluster(clusterObj *dst, const clusterObj *src)
-{
+int msCopyCluster(clusterObj *dst, const clusterObj *src) {
   int return_value;
 
   MS_COPYSTELEM(maxdistance);
   MS_COPYSTELEM(buffer);
   MS_COPYSTRING(dst->region, src->region);
 
-  return_value = msCopyExpression(&(dst->group),&(src->group));
+  return_value = msCopyExpression(&(dst->group), &(src->group));
   if (return_value != MS_SUCCESS) {
     msSetError(MS_MEMERR, "Failed to copy cluster group.", "msCopyCluster()");
     return MS_FAILURE;
   }
 
-  return_value = msCopyExpression(&(dst->filter),&(src->filter));
+  return_value = msCopyExpression(&(dst->filter), &(src->filter));
   if (return_value != MS_SUCCESS) {
     msSetError(MS_MEMERR, "Failed to copy cluster filter.", "msCopyCluster()");
     return MS_FAILURE;
@@ -656,8 +644,7 @@ int msCopyCluster(clusterObj *dst, const
  * msCopyGrid()                                                        *
  **********************************************************************/
 
-int msCopyGrid(graticuleObj *dst, const graticuleObj *src)
-{
+int msCopyGrid(graticuleObj *dst, const graticuleObj *src) {
   MS_COPYSTELEM(dwhichlatitude);
   MS_COPYSTELEM(dwhichlongitude);
   MS_COPYSTELEM(dstartlatitude);
@@ -678,7 +665,7 @@ int msCopyGrid(graticuleObj *dst, const
   MS_COPYSTELEM(ilabeltype);
   MS_COPYRECT(&(dst->extent), &(src->extent));
   MS_COPYSTRING(dst->labelformat, src->labelformat);
-  
+
   return MS_SUCCESS;
 }
 
@@ -693,8 +680,8 @@ int msCopyGrid(graticuleObj *dst, const
  * make exact copies, this method might not get much use.              *
  **********************************************************************/
 
-int msCopyLabelCacheMember(labelCacheMemberObj *dst, const labelCacheMemberObj *src)
-{
+int msCopyLabelCacheMember(labelCacheMemberObj *dst,
+                           const labelCacheMemberObj *src) {
   int i;
 
   MS_COPYSTELEM(featuresize);
@@ -705,7 +692,7 @@ int msCopyLabelCacheMember(labelCacheMem
   }
 
   MS_COPYSTELEM(numlabels);
-  dst->labels = (labelObj *) msSmallMalloc(sizeof(labelObj)*dst->numlabels);
+  dst->labels = (labelObj *)msSmallMalloc(sizeof(labelObj) * dst->numlabels);
   for (i = 0; i < dst->numlabels; i++) {
     msCopyLabel(&(dst->labels[i]), &(src->labels[i]));
   }
@@ -728,8 +715,7 @@ int msCopyLabelCacheMember(labelCacheMem
  **********************************************************************/
 
 int msCopyMarkerCacheMember(markerCacheMemberObj *dst,
-                            const markerCacheMemberObj *src)
-{
+                            const markerCacheMemberObj *src) {
   MS_COPYSTELEM(id);
 
   /* msCopyShape(&(dst->poly), &(src->poly)); */
@@ -740,8 +726,7 @@ int msCopyMarkerCacheMember(markerCacheM
  * msCopyLabelCacheSlot()                                                  *
  **********************************************************************/
 
-int msCopyLabelCacheSlot(labelCacheSlotObj *dst, const labelCacheSlotObj *src)
-{
+int msCopyLabelCacheSlot(labelCacheSlotObj *dst, const labelCacheSlotObj *src) {
   int i;
 
   for (i = 0; i < dst->numlabels; i++) {
@@ -761,12 +746,11 @@ int msCopyLabelCacheSlot(labelCacheSlotO
  * msCopyLabelCache()                                                  *
  **********************************************************************/
 
-int msCopyLabelCache(labelCacheObj *dst, const labelCacheObj *src)
-{
+int msCopyLabelCache(labelCacheObj *dst, const labelCacheObj *src) {
   int p;
   MS_COPYSTELEM(numlabels);
 
-  for (p=0; p<MS_MAX_LABEL_PRIORITY; p++) {
+  for (p = 0; p < MS_MAX_LABEL_PRIORITY; p++) {
     msCopyLabelCacheSlot(&(dst->slots[p]), &(src->slots[p]));
   }
 
@@ -779,8 +763,7 @@ int msCopyLabelCache(labelCacheObj *dst,
  * msCopyResult()                                                      *
  **********************************************************************/
 
-int msCopyResult(resultObj *dst, const resultObj *src)
-{
+int msCopyResult(resultObj *dst, const resultObj *src) {
   MS_COPYSTELEM(shapeindex);
   MS_COPYSTELEM(tileindex);
   MS_COPYSTELEM(classindex);
@@ -793,8 +776,7 @@ int msCopyResult(resultObj *dst, const r
  * msCopyResultCache()                                                 *
  **********************************************************************/
 
-int msCopyResultCache(resultCacheObj *dst, const resultCacheObj *src)
-{
+int msCopyResultCache(resultCacheObj *dst, const resultCacheObj *src) {
   int i;
   MS_COPYSTELEM(cachesize);
   MS_COPYSTELEM(numresults);
@@ -814,8 +796,7 @@ int msCopyResultCache(resultCacheObj *ds
  **********************************************************************/
 
 int msCopyReferenceMap(referenceMapObj *dst, const referenceMapObj *src,
-                       mapObj *map)
-{
+                       mapObj *map) {
 
   initReferenceMap(dst);
 
@@ -824,9 +805,8 @@ int msCopyReferenceMap(referenceMapObj *
   MS_COPYSTELEM(height);
   MS_COPYSTELEM(width);
 
-
   MS_COPYCOLOR(&(dst->color), &(src->color));
-  MS_COPYCOLOR(&(dst->outlinecolor),&(src->outlinecolor));
+  MS_COPYCOLOR(&(dst->outlinecolor), &(src->outlinecolor));
   MS_COPYSTRING(dst->image, src->image);
 
   MS_COPYSTELEM(status);
@@ -847,8 +827,7 @@ int msCopyReferenceMap(referenceMapObj *
  * and msCopyLabel()                                                   *
  **********************************************************************/
 
-int msCopyScalebar(scalebarObj *dst, const scalebarObj *src)
-{
+int msCopyScalebar(scalebarObj *dst, const scalebarObj *src) {
 
   initScalebar(dst);
 
@@ -859,7 +838,7 @@ int msCopyScalebar(scalebarObj *dst, con
   MS_COPYSTELEM(intervals);
 
   if (msCopyLabel(&(dst->label), &(src->label)) != MS_SUCCESS) {
-    msSetError(MS_MEMERR, "Failed to copy label.","msCopyScalebar()");
+    msSetError(MS_MEMERR, "Failed to copy label.", "msCopyScalebar()");
     return MS_FAILURE;
   }
 
@@ -884,16 +863,14 @@ int msCopyScalebar(scalebarObj *dst, con
  * Copy a legendObj, using msCopyColor()                               *
  **********************************************************************/
 
-int msCopyLegend(legendObj *dst, const legendObj *src, mapObj *map)
-{
+int msCopyLegend(legendObj *dst, const legendObj *src, mapObj *map) {
   int return_value;
 
   MS_COPYCOLOR(&(dst->imagecolor), &(src->imagecolor));
 
   return_value = msCopyLabel(&(dst->label), &(src->label));
   if (return_value != MS_SUCCESS) {
-    msSetError(MS_MEMERR, "Failed to copy label.",
-               "msCopyLegend()");
+    msSetError(MS_MEMERR, "Failed to copy label.", "msCopyLegend()");
     return MS_FAILURE;
   }
 
@@ -902,7 +879,7 @@ int msCopyLegend(legendObj *dst, const l
   MS_COPYSTELEM(keyspacingx);
   MS_COPYSTELEM(keyspacingy);
 
-  MS_COPYCOLOR(&(dst->outlinecolor),&(src->outlinecolor));
+  MS_COPYCOLOR(&(dst->outlinecolor), &(src->outlinecolor));
 
   MS_COPYSTELEM(status);
   MS_COPYSTELEM(height);
@@ -921,8 +898,9 @@ int msCopyLegend(legendObj *dst, const l
   return MS_SUCCESS;
 }
 
-int msCopyScaleTokenEntry(const scaleTokenEntryObj *src, scaleTokenEntryObj *dst) {
-  MS_COPYSTRING(dst->value,src->value);
+int msCopyScaleTokenEntry(const scaleTokenEntryObj *src,
+                          scaleTokenEntryObj *dst) {
+  MS_COPYSTRING(dst->value, src->value);
   MS_COPYSTELEM(minscale);
   MS_COPYSTELEM(maxscale);
   return MS_SUCCESS;
@@ -930,23 +908,25 @@ int msCopyScaleTokenEntry(const scaleTok
 
 int msCopyScaleToken(const scaleTokenObj *src, scaleTokenObj *dst) {
   int i;
-  MS_COPYSTRING(dst->name,src->name);
+  MS_COPYSTRING(dst->name, src->name);
   MS_COPYSTELEM(n_entries);
-  dst->tokens = (scaleTokenEntryObj*)msSmallCalloc(src->n_entries,sizeof(scaleTokenEntryObj));
-  for(i=0;i<src->n_entries;i++) {
-    msCopyScaleTokenEntry(&src->tokens[i],&dst->tokens[i]);
+  dst->tokens = (scaleTokenEntryObj *)msSmallCalloc(src->n_entries,
+                                                    sizeof(scaleTokenEntryObj));
+  for (i = 0; i < src->n_entries; i++) {
+    msCopyScaleTokenEntry(&src->tokens[i], &dst->tokens[i]);
   }
   return MS_SUCCESS;
 }
 
-int msCopyCompositingFilter(CompositingFilter **pdst, const CompositingFilter *src) {
+int msCopyCompositingFilter(CompositingFilter **pdst,
+                            const CompositingFilter *src) {
   CompositingFilter *dst = NULL;
-  if(!src) {
+  if (!src) {
     *pdst = NULL;
     return MS_SUCCESS;
   }
-  while(src) {
-    if(!dst) {
+  while (src) {
+    if (!dst) {
       dst = *pdst = msSmallMalloc(sizeof(CompositingFilter));
     } else {
       dst->next = msSmallMalloc(sizeof(CompositingFilter));
@@ -961,13 +941,13 @@ int msCopyCompositingFilter(CompositingF
 
 int msCopyCompositer(LayerCompositer **ldst, const LayerCompositer *src) {
   LayerCompositer *dst = NULL;
-  if(!src) {
+  if (!src) {
     *ldst = NULL;
     return MS_SUCCESS;
   }
 
-  while(src) {
-    if(!dst) {
+  while (src) {
+    if (!dst) {
       dst = *ldst = msSmallMalloc(sizeof(LayerCompositer));
     } else {
       dst->next = msSmallMalloc(sizeof(LayerCompositer));
@@ -992,8 +972,7 @@ int msCopyCompositer(LayerCompositer **l
  * As it stands, we are not copying a layer's resultcache              *
  **********************************************************************/
 
-int msCopyLayer(layerObj *dst, const layerObj *src)
-{
+int msCopyLayer(layerObj *dst, const layerObj *src) {
   int i, return_value;
   featureListNodeObjPtr current;
 
@@ -1002,11 +981,11 @@ int msCopyLayer(layerObj *dst, const lay
 
   MS_COPYSTELEM(classitemindex);
 
-  for(i = 0; i < src->numscaletokens; i++) {
-    if(msGrowLayerScaletokens(dst) == NULL)
+  for (i = 0; i < src->numscaletokens; i++) {
+    if (msGrowLayerScaletokens(dst) == NULL)
       return MS_FAILURE;
     initScaleToken(&dst->scaletokens[i]);
-    msCopyScaleToken(&src->scaletokens[i],&dst->scaletokens[i]);
+    msCopyScaleToken(&src->scaletokens[i], &dst->scaletokens[i]);
     dst->numscaletokens++;
   }
 
@@ -1015,7 +994,7 @@ int msCopyLayer(layerObj *dst, const lay
       return MS_FAILURE;
 #ifndef __cplusplus
     initClass(dst->class[i]);
-    return_value = msCopyClass(dst->class[i], src->class[i], dst);
+    return_value = msCopyClass(dst->class[i], src -> class[i], dst);
 #else
     initClass(dst->_class[i]);
     return_value = msCopyClass(dst->_class[i], src->_class[i], dst);
@@ -1073,13 +1052,13 @@ int msCopyLayer(layerObj *dst, const lay
 
   MS_COPYSTRING(dst->tileindex, src->tileindex);
 
-  return_value = msCopyProjection(&(dst->projection),&(src->projection));
+  return_value = msCopyProjection(&(dst->projection), &(src->projection));
   if (return_value != MS_SUCCESS) {
     msSetError(MS_MEMERR, "Failed to copy projection.", "msCopyLayer()");
     return MS_FAILURE;
   }
 
-  return_value = msCopyCluster(&(dst->cluster),&(src->cluster));
+  return_value = msCopyCluster(&(dst->cluster), &(src->cluster));
   if (return_value != MS_SUCCESS) {
     return MS_FAILURE;
   }
@@ -1088,7 +1067,7 @@ int msCopyLayer(layerObj *dst, const lay
   MS_COPYSTELEM(units);
 
   current = src->features;
-  while(current != NULL) {
+  while (current != NULL) {
     insertFeatureList(&(dst->features), &(current->shape));
     current = current->next;
   }
@@ -1120,8 +1099,8 @@ int msCopyLayer(layerObj *dst, const lay
   if (&(src->metadata)) {
     msCopyHashTable(&(dst->metadata), &(src->metadata));
   }
-  msCopyHashTable(&dst->validation,&src->validation);
-  msCopyHashTable(&dst->connectionoptions,&src->connectionoptions);
+  msCopyHashTable(&dst->validation, &src->validation);
+  msCopyHashTable(&dst->connectionoptions, &src->connectionoptions);
 
   MS_COPYSTELEM(debug);
 
@@ -1150,13 +1129,13 @@ int msCopyLayer(layerObj *dst, const lay
       freeGrid(dst->grid);
       msFree(dst->grid);
     }
-    dst->grid = (void *) malloc(sizeof(graticuleObj));
+    dst->grid = (void *)malloc(sizeof(graticuleObj));
     MS_CHECK_ALLOC(dst->grid, sizeof(graticuleObj), -1);
     initGrid(dst->grid);
     msCopyGrid(dst->grid, src->grid);
   }
 
-  if(src->compositer) {
+  if (src->compositer) {
     msCopyCompositer(&dst->compositer, src->compositer);
   }
 
@@ -1172,8 +1151,7 @@ int msCopyLayer(layerObj *dst, const lay
  * msCopyOutputFormat(), msCopyWeb(), msCopyReferenceMap()             *
  **********************************************************************/
 
-int msCopyMap(mapObj *dst, const mapObj *src)
-{
+int msCopyMap(mapObj *dst, const mapObj *src) {
   int i, return_value;
   outputFormatObj *format;
 
@@ -1203,7 +1181,7 @@ int msCopyMap(mapObj *dst, const mapObj
   }
 
   return_value = msCopySymbolSet(&(dst->symbolset), &(src->symbolset), dst);
-  if(return_value != MS_SUCCESS) {
+  if (return_value != MS_SUCCESS) {
     msSetError(MS_MEMERR, "Failed to copy symbolset.", "msCopyMap()");
     return MS_FAILURE;
   }
@@ -1223,31 +1201,30 @@ int msCopyMap(mapObj *dst, const mapObj
   MS_COPYCOLOR(&(dst->imagecolor), &(src->imagecolor));
 
   /* clear existing destination format list */
-  if( dst->outputformat && --dst->outputformat->refcount < 1 ) {
-    msFreeOutputFormat( dst->outputformat );
+  if (dst->outputformat && --dst->outputformat->refcount < 1) {
+    msFreeOutputFormat(dst->outputformat);
     dst->outputformat = NULL;
   }
 
-  for(i=0; i < dst->numoutputformats; i++ ) {
-    if( --dst->outputformatlist[i]->refcount < 1 )
-      msFreeOutputFormat( dst->outputformatlist[i] );
+  for (i = 0; i < dst->numoutputformats; i++) {
+    if (--dst->outputformatlist[i]->refcount < 1)
+      msFreeOutputFormat(dst->outputformatlist[i]);
   }
-  if( dst->outputformatlist != NULL )
-    msFree( dst->outputformatlist );
+  if (dst->outputformatlist != NULL)
+    msFree(dst->outputformatlist);
   dst->outputformatlist = NULL;
   dst->outputformat = NULL;
   dst->numoutputformats = 0;
 
   for (i = 0; i < src->numoutputformats; i++)
-    msAppendOutputFormat( dst,
-                          msCloneOutputFormat( src->outputformatlist[i]) );
+    msAppendOutputFormat(dst, msCloneOutputFormat(src->outputformatlist[i]));
 
   /* set the active output format */
   MS_COPYSTRING(dst->imagetype, src->imagetype);
-  format = msSelectOutputFormat( dst, dst->imagetype );
+  format = msSelectOutputFormat(dst, dst->imagetype);
   msApplyOutputFormat(&(dst->outputformat), format, MS_NOOVERRIDE);
 
-  return_value = msCopyProjection(&(dst->projection),&(src->projection));
+  return_value = msCopyProjection(&(dst->projection), &(src->projection));
   if (return_value != MS_SUCCESS) {
     msSetError(MS_MEMERR, "Failed to copy projection.", "msCopyMap()");
     return MS_FAILURE;
@@ -1255,8 +1232,7 @@ int msCopyMap(mapObj *dst, const mapObj
 
   /* No need to copy latlon projection */
 
-  return_value = msCopyReferenceMap(&(dst->reference),&(src->reference),
-                                    dst);
+  return_value = msCopyReferenceMap(&(dst->reference), &(src->reference), dst);
   if (return_value != MS_SUCCESS) {
     msSetError(MS_MEMERR, "Failed to copy reference.", "msCopyMap()");
     return MS_FAILURE;
@@ -1268,7 +1244,7 @@ int msCopyMap(mapObj *dst, const mapObj
     return MS_FAILURE;
   }
 
-  return_value = msCopyLegend(&(dst->legend), &(src->legend),dst);
+  return_value = msCopyLegend(&(dst->legend), &(src->legend), dst);
   if (return_value != MS_SUCCESS) {
     msSetError(MS_MEMERR, "Failed to copy legend.", "msCopyMap()");
     return MS_FAILURE;
@@ -1286,16 +1262,17 @@ int msCopyMap(mapObj *dst, const mapObj
     return MS_FAILURE;
   }
 
-  if( src->layerorder ) {
+  if (src->layerorder) {
     for (i = 0; i < dst->numlayers; i++) {
-        MS_COPYSTELEM(layerorder[i]);
+      MS_COPYSTELEM(layerorder[i]);
     }
   }
   MS_COPYSTELEM(debug);
   MS_COPYSTRING(dst->datapattern, src->datapattern);
   MS_COPYSTRING(dst->templatepattern, src->templatepattern);
 
-  if( msCopyHashTable( &(dst->configoptions), &(src->configoptions) ) != MS_SUCCESS )
+  if (msCopyHashTable(&(dst->configoptions), &(src->configoptions)) !=
+      MS_SUCCESS)
     return MS_FAILURE;
 
   return MS_SUCCESS;
@@ -1303,19 +1280,24 @@ int msCopyMap(mapObj *dst, const mapObj
 
 int msCopyRasterBuffer(rasterBufferObj *dst, const rasterBufferObj *src) {
   *dst = *src;
-  if(src->type == MS_BUFFER_BYTE_RGBA) {
+  if (src->type == MS_BUFFER_BYTE_RGBA) {
     dst->data.rgba = src->data.rgba;
-    dst->data.rgba.pixels = msSmallMalloc(src->height * src->data.rgba.row_step);
-    memcpy(dst->data.rgba.pixels, src->data.rgba.pixels, src->data.rgba.row_step*src->height);
-    dst->data.rgba.r = dst->data.rgba.pixels + (src->data.rgba.r - src->data.rgba.pixels);
-    dst->data.rgba.g = dst->data.rgba.pixels + (src->data.rgba.g - src->data.rgba.pixels);
-    dst->data.rgba.b = dst->data.rgba.pixels + (src->data.rgba.b - src->data.rgba.pixels);
-    if(src->data.rgba.a) {
-      dst->data.rgba.a = dst->data.rgba.pixels + (src->data.rgba.a - src->data.rgba.pixels);
+    dst->data.rgba.pixels =
+        msSmallMalloc(src->height * src->data.rgba.row_step);
+    memcpy(dst->data.rgba.pixels, src->data.rgba.pixels,
+           src->data.rgba.row_step * src->height);
+    dst->data.rgba.r =
+        dst->data.rgba.pixels + (src->data.rgba.r - src->data.rgba.pixels);
+    dst->data.rgba.g =
+        dst->data.rgba.pixels + (src->data.rgba.g - src->data.rgba.pixels);
+    dst->data.rgba.b =
+        dst->data.rgba.pixels + (src->data.rgba.b - src->data.rgba.pixels);
+    if (src->data.rgba.a) {
+      dst->data.rgba.a =
+          dst->data.rgba.pixels + (src->data.rgba.a - src->data.rgba.pixels);
     } else {
       dst->data.rgba.a = NULL;
     }
   }
   return MS_SUCCESS;
 }
-
diff -pruN 8.0.1-5/mapcopy.h 8.0.2-1/mapcopy.h
--- 8.0.1-5/mapcopy.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapcopy.h	2024-06-11 20:41:34.000000000 +0000
@@ -32,42 +32,39 @@
 /* Following works for GCC and MSVC.  That's ~98% of our users, if Tyler
  * Mitchell's survey is correct
  */
-#define MS_COPYSTELEM(_name) (dst)->/**/_name = (src)->/**/_name
-
-#define MS_MACROBEGIN              do {
-#define MS_MACROEND                } while (0)
-
-#define MS_COPYRECT(_dst, _src)       \
-    MS_MACROBEGIN                     \
-        (_dst)->minx = (_src)->minx;  \
-        (_dst)->miny = (_src)->miny;  \
-        (_dst)->maxx = (_src)->maxx;  \
-        (_dst)->maxy = (_src)->maxy;  \
-    MS_MACROEND
-
-#define MS_COPYPOINT(_dst, _src)      \
-    MS_MACROBEGIN                     \
-        (_dst)->x = (_src)->x;        \
-        (_dst)->y = (_src)->y;        \
-        (_dst)->m = (_src)->m;        \
-    MS_MACROEND
-
-#define MS_COPYCOLOR(_dst, _src)      \
-    MS_MACROBEGIN                     \
-        (_dst)->red   = (_src)->red;  \
-        (_dst)->green = (_src)->green;\
-        (_dst)->blue  = (_src)->blue; \
-        (_dst)->alpha  = (_src)->alpha; \
-    MS_MACROEND
-
-#define MS_COPYSTRING(_dst, _src)     \
-    MS_MACROBEGIN                     \
-        if ((_dst) != NULL)           \
-            msFree((_dst));           \
-        if ((_src))                   \
-            (_dst) = msStrdup((_src));  \
-        else                          \
-            (_dst) = NULL;            \
-    MS_MACROEND
-
+#define MS_COPYSTELEM(_name) (dst)->/**/ _name = (src)->/**/ _name
 
+#define MS_MACROBEGIN do {
+#define MS_MACROEND                                                            \
+  }                                                                            \
+  while (0)
+
+#define MS_COPYRECT(_dst, _src)                                                \
+  MS_MACROBEGIN(_dst)->minx = (_src)->minx;                                    \
+  (_dst)->miny = (_src)->miny;                                                 \
+  (_dst)->maxx = (_src)->maxx;                                                 \
+  (_dst)->maxy = (_src)->maxy;                                                 \
+  MS_MACROEND
+
+#define MS_COPYPOINT(_dst, _src)                                               \
+  MS_MACROBEGIN(_dst)->x = (_src)->x;                                          \
+  (_dst)->y = (_src)->y;                                                       \
+  (_dst)->m = (_src)->m;                                                       \
+  MS_MACROEND
+
+#define MS_COPYCOLOR(_dst, _src)                                               \
+  MS_MACROBEGIN(_dst)->red = (_src)->red;                                      \
+  (_dst)->green = (_src)->green;                                               \
+  (_dst)->blue = (_src)->blue;                                                 \
+  (_dst)->alpha = (_src)->alpha;                                               \
+  MS_MACROEND
+
+#define MS_COPYSTRING(_dst, _src)                                              \
+  MS_MACROBEGIN                                                                \
+  if ((_dst) != NULL)                                                          \
+    msFree((_dst));                                                            \
+  if ((_src))                                                                  \
+    (_dst) = msStrdup((_src));                                                 \
+  else                                                                         \
+    (_dst) = NULL;                                                             \
+  MS_MACROEND
diff -pruN 8.0.1-5/mapcpl.c 8.0.2-1/mapcpl.c
--- 8.0.1-5/mapcpl.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapcpl.c	2024-06-11 20:41:34.000000000 +0000
@@ -41,27 +41,24 @@
 #include <assert.h>
 #include "mapserver.h"
 
-
-
 /* should be size of largest possible filename */
 #define MS_PATH_BUF_SIZE 2048
-static char     szStaticResult[MS_PATH_BUF_SIZE];
-
+static char szStaticResult[MS_PATH_BUF_SIZE];
 
 /************************************************************************/
 /*                        msFindFilenameStart()                         */
 /************************************************************************/
 
-static int msFindFilenameStart( const char * pszFilename )
+static int msFindFilenameStart(const char *pszFilename)
 
 {
-  int         iFileStart;
+  int iFileStart;
 
-  for( iFileStart = strlen(pszFilename);
-       iFileStart > 0
-       && pszFilename[iFileStart-1] != '/'
-       && pszFilename[iFileStart-1] != '\\';
-       iFileStart-- ) {}
+  for (iFileStart = strlen(pszFilename);
+       iFileStart > 0 && pszFilename[iFileStart - 1] != '/' &&
+       pszFilename[iFileStart - 1] != '\\';
+       iFileStart--) {
+  }
 
   return iFileStart;
 }
@@ -90,24 +87,25 @@ static int msFindFilenameStart( const ch
  * may be destroyed by the next ms filename handling call.
  */
 
-const char *msGetBasename( const char *pszFullFilename )
+const char *msGetBasename(const char *pszFullFilename)
 
 {
-  int iFileStart = msFindFilenameStart( pszFullFilename );
+  int iFileStart = msFindFilenameStart(pszFullFilename);
   int iExtStart, nLength;
 
-  for( iExtStart = strlen(pszFullFilename);
+  for (iExtStart = strlen(pszFullFilename);
        iExtStart > iFileStart && pszFullFilename[iExtStart] != '.';
-       iExtStart-- ) {}
+       iExtStart--) {
+  }
 
-  if( iExtStart == iFileStart )
+  if (iExtStart == iFileStart)
     iExtStart = strlen(pszFullFilename);
 
   nLength = iExtStart - iFileStart;
 
-  assert( nLength < MS_PATH_BUF_SIZE );
+  assert(nLength < MS_PATH_BUF_SIZE);
 
-  strlcpy( szStaticResult, pszFullFilename + iFileStart, nLength+1 );
+  strlcpy(szStaticResult, pszFullFilename + iFileStart, nLength + 1);
 
   return szStaticResult;
 }
@@ -159,45 +157,42 @@ const char *msGetBasename( const char *p
  * found, or the shared library can't be loaded.
  */
 
-void *msGetSymbol( const char * pszLibrary, const char * pszSymbolName )
-{
-  void        *pLibrary;
-  void        *pSymbol;
+void *msGetSymbol(const char *pszLibrary, const char *pszSymbolName) {
+  void *pLibrary;
+  void *pSymbol;
 
   pLibrary = dlopen(pszLibrary, RTLD_LAZY);
-  if( pLibrary == NULL ) {
-    msSetError(MS_MISCERR,
-               "Dynamic loading failed: %s",
-               "msGetSymbol()", dlerror());
+  if (pLibrary == NULL) {
+    msSetError(MS_MISCERR, "Dynamic loading failed: %s", "msGetSymbol()",
+               dlerror());
     return NULL;
   }
 
-  pSymbol = dlsym( pLibrary, pszSymbolName );
+  pSymbol = dlsym(pLibrary, pszSymbolName);
 
 #if (defined(__APPLE__) && defined(__MACH__))
   /* On mach-o systems, C symbols have a leading underscore and depending
    * on how dlcompat is configured it may or may not add the leading
    * underscore.  So if dlsym() fails add an underscore and try again.
    */
-  if( pSymbol == NULL ) {
+  if (pSymbol == NULL) {
     char withUnder[strlen(pszSymbolName) + 2];
     withUnder[0] = '_';
     withUnder[1] = 0;
     strcat(withUnder, pszSymbolName);
-    pSymbol = dlsym( pLibrary, withUnder );
+    pSymbol = dlsym(pLibrary, withUnder);
   }
 #endif
 
-  if( pSymbol == NULL ) {
-    msSetError(MS_MISCERR,
-               "Dynamic loading failed: %s",
-               "msGetSymbol()", dlerror());
+  if (pSymbol == NULL) {
+    msSetError(MS_MISCERR, "Dynamic loading failed: %s", "msGetSymbol()",
+               dlerror());
     return NULL;
   }
 
   /* We accept leakage of pLibrary */
   /* coverity[leaked_storage] */
-  return( pSymbol );
+  return (pSymbol);
 }
 
 #endif /* def __unix__ && defined(HAVE_DLFCN_H) */
@@ -215,29 +210,26 @@ void *msGetSymbol( const char * pszLibra
 /*                            msGetSymbol()                            */
 /************************************************************************/
 
-void *msGetSymbol( const char * pszLibrary, const char * pszSymbolName )
-{
-  void        *pLibrary;
-  void        *pSymbol;
+void *msGetSymbol(const char *pszLibrary, const char *pszSymbolName) {
+  void *pLibrary;
+  void *pSymbol;
 
   pLibrary = LoadLibrary(pszLibrary);
-  if( pLibrary == NULL ) {
-    msSetError(MS_MISCERR,
-               "Can't load requested dynamic library: %s",
+  if (pLibrary == NULL) {
+    msSetError(MS_MISCERR, "Can't load requested dynamic library: %s",
                "msGetSymbol()", pszLibrary);
     return NULL;
   }
 
-  pSymbol = (void *) GetProcAddress( (HINSTANCE) pLibrary, pszSymbolName );
+  pSymbol = (void *)GetProcAddress((HINSTANCE)pLibrary, pszSymbolName);
 
-  if( pSymbol == NULL ) {
-    msSetError(MS_MISCERR,
-               "Can't find requested entry point: %s in lib %s",
+  if (pSymbol == NULL) {
+    msSetError(MS_MISCERR, "Can't find requested entry point: %s in lib %s",
                "msGetSymbol()", pszSymbolName, pLibrary);
     return NULL;
   }
 
-  return( pSymbol );
+  return (pSymbol);
 }
 
 #endif /* def _WIN32 */
@@ -254,11 +246,11 @@ void *msGetSymbol( const char * pszLibra
 /*      Dummy implementation.                                           */
 /************************************************************************/
 
-void *msGetSymbol(const char *pszLibrary, const char *pszEntryPoint)
-{
-  msSetError(MS_MISCERR,
-             "msGetSymbol(%s,%s) called.  Failed as this is stub implementation.",
-             "msGetSymbol()", pszLibrary, pszEntryPoint);
+void *msGetSymbol(const char *pszLibrary, const char *pszEntryPoint) {
+  msSetError(
+      MS_MISCERR,
+      "msGetSymbol(%s,%s) called.  Failed as this is stub implementation.",
+      "msGetSymbol()", pszLibrary, pszEntryPoint);
   return NULL;
 }
 #endif
diff -pruN 8.0.1-5/mapcrypto.c 8.0.2-1/mapcrypto.c
--- 8.0.1-5/mapcrypto.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapcrypto.c	2024-06-11 20:41:34.000000000 +0000
@@ -28,15 +28,14 @@
  ****************************************************************************/
 
 #include <assert.h>
-#include <ctype.h>    /* isxdigit() */
-#include <stdlib.h>   /* rand() */
-#include <time.h>     /* time() */
+#include <ctype.h>  /* isxdigit() */
+#include <stdlib.h> /* rand() */
+#include <time.h>   /* time() */
 
 #include "mapserver.h"
 
 #include "cpl_conv.h"
 
-
 /**********************************************************************
  * encipher() and decipher() from the Tiny Encryption Algorithm (TEA)
  * website at:
@@ -86,35 +85,34 @@
  **********************************************************************/
 
 static void encipher(const ms_uint32 *const v, ms_uint32 *const w,
-                     const ms_uint32 *const k)
-{
-  register ms_uint32   y=v[0],z=v[1],sum=0,delta=0x9E3779B9,n=32;
+                     const ms_uint32 *const k) {
+  register ms_uint32 y = v[0], z = v[1], sum = 0, delta = 0x9E3779B9, n = 32;
 
-  while(n-->0) {
-    y += ((z << 4 ^ z >> 5) + z) ^ (sum + k[sum&3]);
+  while (n-- > 0) {
+    y += ((z << 4 ^ z >> 5) + z) ^ (sum + k[sum & 3]);
     sum += delta;
-    z += ((y << 4 ^ y >> 5) + y) ^ (sum + k[sum>>11 & 3]);
+    z += ((y << 4 ^ y >> 5) + y) ^ (sum + k[sum >> 11 & 3]);
   }
 
-  w[0]=y;
-  w[1]=z;
+  w[0] = y;
+  w[1] = z;
 }
 
 static void decipher(const ms_uint32 *const v, ms_uint32 *const w,
-                     const ms_uint32 *const k)
-{
-  register ms_uint32       y=v[0],z=v[1],sum=0xC6EF3720, delta=0x9E3779B9,n=32;
+                     const ms_uint32 *const k) {
+  register ms_uint32 y = v[0], z = v[1], sum = 0xC6EF3720, delta = 0x9E3779B9,
+                     n = 32;
 
   /* sum = delta<<5, in general sum = delta * n */
 
-  while(n-->0) {
-    z -= ((y << 4 ^ y >> 5) + y) ^ (sum + k[sum>>11 & 3]);
+  while (n-- > 0) {
+    z -= ((y << 4 ^ y >> 5) + y) ^ (sum + k[sum >> 11 & 3]);
     sum -= delta;
-    y -= ((z << 4 ^ z >> 5) + z) ^ (sum + k[sum&3]);
+    y -= ((z << 4 ^ z >> 5) + z) ^ (sum + k[sum & 3]);
   }
 
-  w[0]=y;
-  w[1]=z;
+  w[0] = y;
+  w[1] = z;
 }
 
 /**********************************************************************
@@ -125,13 +123,12 @@ static void decipher(const ms_uint32 *co
  * out[] should be preallocated by the caller to be at least 2*numbytes+1
  * (+1 for the terminating '\0')
  **********************************************************************/
-void msHexEncode(const unsigned char *in, char *out, int numbytes)
-{
+void msHexEncode(const unsigned char *in, char *out, int numbytes) {
   char *hex = "0123456789ABCDEF";
 
   while (numbytes-- > 0) {
-    *out++ = hex[*in/16];
-    *out++ = hex[*in%16];
+    *out++ = hex[*in / 16];
+    *out++ = hex[*in % 16];
     in++;
   }
   *out = '\0';
@@ -151,20 +148,19 @@ void msHexEncode(const unsigned char *in
  * Returns the number of bytes written to out[] which may be different from
  * numchars/2 if an error or a '\0' is encountered.
  **********************************************************************/
-int msHexDecode(const char *in, unsigned char *out, int numchars)
-{
+int msHexDecode(const char *in, unsigned char *out, int numchars) {
   int numbytes_out = 0;
 
   /* Make sure numchars is even */
-  numchars = (numchars/2) * 2;
+  numchars = (numchars / 2) * 2;
 
   if (numchars < 2)
     numchars = -1; /* Will result in this value being ignored in the loop*/
 
-  while (*in != '\0' && *(in+1) != '\0' && numchars != 0) {
-    *out = 0x10 * (*in >= 'A' ? ((*in & 0xdf) - 'A')+10 : (*in - '0'));
+  while (*in != '\0' && *(in + 1) != '\0' && numchars != 0) {
+    *out = 0x10 * (*in >= 'A' ? ((*in & 0xdf) - 'A') + 10 : (*in - '0'));
     in++;
-    *out += (*in >= 'A' ? ((*in & 0xdf) - 'A')+10 : (*in - '0'));
+    *out += (*in >= 'A' ? ((*in & 0xdf) - 'A') + 10 : (*in - '0'));
     in++;
 
     out++;
@@ -176,7 +172,6 @@ int msHexDecode(const char *in, unsigned
   return numbytes_out;
 }
 
-
 /**********************************************************************
  *                       msGenerateEncryptionKey()
  *
@@ -185,15 +180,13 @@ int msHexDecode(const char *in, unsigned
  * The output buffer should be at least MS_ENCRYPTION_KEY_SIZE bytes.
  **********************************************************************/
 
-int msGenerateEncryptionKey(unsigned char *k)
-{
+int msGenerateEncryptionKey(unsigned char *k) {
   int i;
 
   /* Use current time as seed for rand() */
-  srand( (unsigned int) time( NULL ));
+  srand((unsigned int)time(NULL));
 
-  for(i=0; i<MS_ENCRYPTION_KEY_SIZE; i++)
-  {
+  for (i = 0; i < MS_ENCRYPTION_KEY_SIZE; i++) {
     /* coverity[dont_call] */
     k[i] = (unsigned char)rand();
   }
@@ -211,8 +204,7 @@ int msGenerateEncryptionKey(unsigned cha
  * Returns MS_SUCCESS/MS_FAILURE.
  **********************************************************************/
 
-int msReadEncryptionKeyFromFile(const char *keyfile, unsigned char *k)
-{
+int msReadEncryptionKeyFromFile(const char *keyfile, unsigned char *k) {
   FILE *fp;
   char szBuf[100];
   int numchars;
@@ -223,18 +215,19 @@ int msReadEncryptionKeyFromFile(const ch
     return MS_FAILURE;
   }
 
-  numchars = fread(szBuf, sizeof(unsigned char), MS_ENCRYPTION_KEY_SIZE*2, fp);
+  numchars =
+      fread(szBuf, sizeof(unsigned char), MS_ENCRYPTION_KEY_SIZE * 2, fp);
   fclose(fp);
-  szBuf[MS_ENCRYPTION_KEY_SIZE*2] = '\0';
+  szBuf[MS_ENCRYPTION_KEY_SIZE * 2] = '\0';
 
-  if (numchars != MS_ENCRYPTION_KEY_SIZE*2) {
+  if (numchars != MS_ENCRYPTION_KEY_SIZE * 2) {
     msSetError(MS_MISCERR, "Invalid key file, got %d chars, expected %d.",
-               "msReadEncryptionKeyFromFile()",
-               numchars, MS_ENCRYPTION_KEY_SIZE*2);
+               "msReadEncryptionKeyFromFile()", numchars,
+               MS_ENCRYPTION_KEY_SIZE * 2);
     return MS_FAILURE;
   }
 
-  msHexDecode(szBuf, k, MS_ENCRYPTION_KEY_SIZE*2);
+  msHexDecode(szBuf, k, MS_ENCRYPTION_KEY_SIZE * 2);
 
   return MS_SUCCESS;
 }
@@ -257,8 +250,7 @@ int msReadEncryptionKeyFromFile(const ch
  * Returns MS_SUCCESS/MS_FAILURE.
  **********************************************************************/
 
-static int msLoadEncryptionKey(mapObj *map)
-{
+static int msLoadEncryptionKey(mapObj *map) {
   const char *keyfile;
 
   if (map == NULL) {
@@ -267,16 +259,18 @@ static int msLoadEncryptionKey(mapObj *m
   }
 
   if (map->encryption_key_loaded)
-    return MS_SUCCESS;  /* Already loaded */
+    return MS_SUCCESS; /* Already loaded */
 
   keyfile = msGetConfigOption(map, "MS_ENCRYPTION_KEY");
-  if(!keyfile) keyfile = CPLGetConfigOption("MS_ENCRYPTION_KEY", NULL);
+  if (!keyfile)
+    keyfile = CPLGetConfigOption("MS_ENCRYPTION_KEY", NULL);
 
   if (keyfile &&
-      msReadEncryptionKeyFromFile(keyfile,map->encryption_key) == MS_SUCCESS) {
+      msReadEncryptionKeyFromFile(keyfile, map->encryption_key) == MS_SUCCESS) {
     map->encryption_key_loaded = MS_TRUE;
   } else {
-    msSetError(MS_MISCERR, "Failed reading encryption key. Make sure "
+    msSetError(MS_MISCERR,
+               "Failed reading encryption key. Make sure "
                "MS_ENCRYPTION_KEY is set and points to a valid key file.",
                "msLoadEncryptionKey()");
     return MS_FAILURE;
@@ -294,8 +288,8 @@ static int msLoadEncryptionKey(mapObj *m
  *
  **********************************************************************/
 
-void msEncryptStringWithKey(const unsigned char *key, const char *in, char *out)
-{
+void msEncryptStringWithKey(const unsigned char *key, const char *in,
+                            char *out) {
   ms_uint32 v[4], w[4];
   const ms_uint32 *k;
   int last_block = MS_FALSE;
@@ -303,9 +297,9 @@ void msEncryptStringWithKey(const unsign
   /* Casting the key this way is safe only as long as longs are 4 bytes
    * on this platform */
   assert(sizeof(ms_uint32) == 4);
-  k = (const ms_uint32 *) key;
+  k = (const ms_uint32 *)key;
 
-  while(!last_block) {
+  while (!last_block) {
     int i, j;
     /* encipher() takes v[2] (64 bits) as input.
      * Copy bytes from in[] to the v[2] input array (pair of 4 bytes)
@@ -313,14 +307,14 @@ void msEncryptStringWithKey(const unsign
      */
     v[0] = 0;
     v[1] = 0;
-    for(i=0; !last_block && i<2; i++) {
-      for(j=0; j<4; j++) {
+    for (i = 0; !last_block && i < 2; i++) {
+      for (j = 0; j < 4; j++) {
         if (*in == '\0') {
           last_block = MS_TRUE;
           break;
         }
 
-        v[i] |= *in << (j*8);
+        v[i] |= *in << (j * 8);
         in++;
       }
     }
@@ -334,9 +328,8 @@ void msEncryptStringWithKey(const unsign
     /* Append hex-encoded bytes to output, 4 bytes at a time */
     msHexEncode((unsigned char *)w, out, 4);
     out += 8;
-    msHexEncode((unsigned char *)(w+1), out, 4);
+    msHexEncode((unsigned char *)(w + 1), out, 4);
     out += 8;
-
   }
 
   /* Make sure output is 0-terminated */
@@ -352,8 +345,8 @@ void msEncryptStringWithKey(const unsign
  *
  **********************************************************************/
 
-void msDecryptStringWithKey(const unsigned char *key, const char *in, char *out)
-{
+void msDecryptStringWithKey(const unsigned char *key, const char *in,
+                            char *out) {
   ms_uint32 v[4], w[4];
   const ms_uint32 *k;
   int last_block = MS_FALSE;
@@ -361,9 +354,9 @@ void msDecryptStringWithKey(const unsign
   /* Casting the key this way is safe only as long as longs are 4 bytes
    * on this platform */
   assert(sizeof(ms_uint32) == 4);
-  k = (const ms_uint32 *) key;
+  k = (const ms_uint32 *)key;
 
-  while(!last_block) {
+  while (!last_block) {
     int i;
     /* decipher() takes v[2] (64 bits) as input.
      * Copy bytes from in[] to the v[2] input array (pair of 4 bytes)
@@ -376,7 +369,7 @@ void msDecryptStringWithKey(const unsign
       last_block = MS_TRUE;
     else {
       in += 8;
-      if (msHexDecode(in, (unsigned char *)(v+1), 8) != 4)
+      if (msHexDecode(in, (unsigned char *)(v + 1), 8) != 4)
         last_block = MS_TRUE;
       else
         in += 8;
@@ -386,7 +379,7 @@ void msDecryptStringWithKey(const unsign
     decipher(v, w, k);
 
     /* Copy the results to out[] */
-    for(i=0; i<2; i++) {
+    for (i = 0; i < 2; i++) {
       *out++ = (w[i] & 0x000000ff);
       *out++ = (w[i] & 0x0000ff00) >> 8;
       *out++ = (w[i] & 0x00ff0000) >> 16;
@@ -410,8 +403,7 @@ void msDecryptStringWithKey(const unsign
  *
  **********************************************************************/
 
-char *msDecryptStringTokens(mapObj *map, const char *in)
-{
+char *msDecryptStringTokens(mapObj *map, const char *in) {
   char *outbuf, *out;
 
   if (map == NULL) {
@@ -421,13 +413,13 @@ char *msDecryptStringTokens(mapObj *map,
 
   /* Start with a copy of the string. Decryption can only result in
    * a string with the same or shorter length */
-  if ((outbuf = (char *)malloc((strlen(in)+1)*sizeof(char))) == NULL) {
+  if ((outbuf = (char *)malloc((strlen(in) + 1) * sizeof(char))) == NULL) {
     msSetError(MS_MEMERR, NULL, "msDecryptStringTokens()");
     return NULL;
   }
   out = outbuf;
 
-  while(*in != '\0') {
+  while (*in != '\0') {
     if (*in == '{') {
       /* Possibly beginning of a token, look for closing bracket
       ** and make sure all chars in between are valid hex encoding chars
@@ -435,12 +427,11 @@ char *msDecryptStringTokens(mapObj *map,
       const char *pszStart, *pszEnd;
       int valid_token = MS_FALSE;
 
-      pszStart = in+1;
-      if ( (pszEnd = strchr(pszStart, '}')) != NULL &&
-           pszEnd - pszStart > 1) {
+      pszStart = in + 1;
+      if ((pszEnd = strchr(pszStart, '}')) != NULL && pszEnd - pszStart > 1) {
         const char *pszTmp;
         valid_token = MS_TRUE;
-        for(pszTmp = pszStart; pszTmp < pszEnd; pszTmp++) {
+        for (pszTmp = pszStart; pszTmp < pszEnd; pszTmp++) {
           if (!isxdigit(*pszTmp)) {
             valid_token = MS_FALSE;
             break;
@@ -460,13 +451,13 @@ char *msDecryptStringTokens(mapObj *map,
         if (msLoadEncryptionKey(map) != MS_SUCCESS)
           return NULL;
 
-        pszTmp = (char*)malloc( (pszEnd-pszStart+1)*sizeof(char));
-        strlcpy(pszTmp, pszStart, (pszEnd-pszStart)+1);
+        pszTmp = (char *)malloc((pszEnd - pszStart + 1) * sizeof(char));
+        strlcpy(pszTmp, pszStart, (pszEnd - pszStart) + 1);
 
         msDecryptStringWithKey(map->encryption_key, pszTmp, out);
 
         out += strlen(out);
-        in = pszEnd+1;
+        in = pszEnd + 1;
         free(pszTmp);
       } else {
         /* Not a valid token, just copy the '{' and keep going */
@@ -482,7 +473,6 @@ char *msDecryptStringTokens(mapObj *map,
   return outbuf;
 }
 
-
 #ifdef TEST_MAPCRYPTO
 
 /* Test for mapcrypto.c functions. To run these tests, use the following
@@ -493,10 +483,9 @@ test_mapcrypto: $(LIBMAP_STATIC) mapcryp
 
 **
 */
-int main(int argc, char *argv[])
-{
+int main(int argc, char *argv[]) {
   const unsigned char bytes_in[] = {0x12, 0x34, 0xff, 0x00, 0x44, 0x22};
-  unsigned char bytes_out[8], encryption_key[MS_ENCRYPTION_KEY_SIZE*2+1];
+  unsigned char bytes_out[8], encryption_key[MS_ENCRYPTION_KEY_SIZE * 2 + 1];
   char string_buf[256], string_buf2[256];
   int numbytes = 0;
 
@@ -511,29 +500,30 @@ int main(int argc, char *argv[])
   */
   memset(bytes_out, 0, 8);
   numbytes = msHexDecode(string_buf, bytes_out, -1);
-  printf("msHexDecode(%s, -1) = %d, bytes_out = %x, %x, %x, %x, %x, %x, %x, %x\n",
-         string_buf, numbytes,
-         bytes_out[0], bytes_out[1], bytes_out[2], bytes_out[3],
-         bytes_out[4], bytes_out[5], bytes_out[6], bytes_out[7]);
+  printf(
+      "msHexDecode(%s, -1) = %d, bytes_out = %x, %x, %x, %x, %x, %x, %x, %x\n",
+      string_buf, numbytes, bytes_out[0], bytes_out[1], bytes_out[2],
+      bytes_out[3], bytes_out[4], bytes_out[5], bytes_out[6], bytes_out[7]);
 
   memset(bytes_out, 0, 8);
   numbytes = msHexDecode(string_buf, bytes_out, 4);
-  printf("msHexDecode(%s, 4) = %d, bytes_out = %x, %x, %x, %x, %x, %x, %x, %x\n",
-         string_buf, numbytes,
-         bytes_out[0], bytes_out[1], bytes_out[2], bytes_out[3],
-         bytes_out[4], bytes_out[5], bytes_out[6], bytes_out[7]);
+  printf(
+      "msHexDecode(%s, 4) = %d, bytes_out = %x, %x, %x, %x, %x, %x, %x, %x\n",
+      string_buf, numbytes, bytes_out[0], bytes_out[1], bytes_out[2],
+      bytes_out[3], bytes_out[4], bytes_out[5], bytes_out[6], bytes_out[7]);
 
   memset(bytes_out, 0, 8);
   numbytes = msHexDecode(string_buf, bytes_out, 20);
-  printf("msHexDecode(%s, 20) = %d, bytes_out = %x, %x, %x, %x, %x, %x, %x, %x\n",
-         string_buf, numbytes,
-         bytes_out[0], bytes_out[1], bytes_out[2], bytes_out[3],
-         bytes_out[4], bytes_out[5], bytes_out[6], bytes_out[7]);
+  printf(
+      "msHexDecode(%s, 20) = %d, bytes_out = %x, %x, %x, %x, %x, %x, %x, %x\n",
+      string_buf, numbytes, bytes_out[0], bytes_out[1], bytes_out[2],
+      bytes_out[3], bytes_out[4], bytes_out[5], bytes_out[6], bytes_out[7]);
 
   /*
   ** Test loading encryption key
   */
-  if (msReadEncryptionKeyFromFile("/tmp/test.key", encryption_key) != MS_SUCCESS) {
+  if (msReadEncryptionKeyFromFile("/tmp/test.key", encryption_key) !=
+      MS_SUCCESS) {
     printf("msReadEncryptionKeyFromFile() = MS_FAILURE\n");
     printf("Aborting tests!\n");
     msWriteError(stderr);
@@ -552,21 +542,24 @@ int main(int argc, char *argv[])
   printf("msEncryptStringWithKey('test1234') returned '%s'\n", string_buf);
 
   msDecryptStringWithKey(encryption_key, string_buf, string_buf2);
-  printf("msDecryptStringWithKey('%s') returned '%s'\n", string_buf, string_buf2);
+  printf("msDecryptStringWithKey('%s') returned '%s'\n", string_buf,
+         string_buf2);
 
   /* Next with an 1 byte input string */
   msEncryptStringWithKey(encryption_key, "t", string_buf);
   printf("msEncryptStringWithKey('t') returned '%s'\n", string_buf);
 
   msDecryptStringWithKey(encryption_key, string_buf, string_buf2);
-  printf("msDecryptStringWithKey('%s') returned '%s'\n", string_buf, string_buf2);
+  printf("msDecryptStringWithKey('%s') returned '%s'\n", string_buf,
+         string_buf2);
 
   /* Next with an 12 bytes input string */
   msEncryptStringWithKey(encryption_key, "test123456", string_buf);
   printf("msEncryptStringWithKey('test123456') returned '%s'\n", string_buf);
 
   msDecryptStringWithKey(encryption_key, string_buf, string_buf2);
-  printf("msDecryptStringWithKey('%s') returned '%s'\n", string_buf, string_buf2);
+  printf("msDecryptStringWithKey('%s') returned '%s'\n", string_buf,
+         string_buf2);
 
   /*
   ** Test decryption with tokens
@@ -586,8 +579,8 @@ int main(int argc, char *argv[])
       msWriteError(stderr);
       return -1;
     } else {
-      printf("msDecryptStringTokens('%s') returned '%s'\n",
-             string_buf2, pszBuf);
+      printf("msDecryptStringTokens('%s') returned '%s'\n", string_buf2,
+             pszBuf);
     }
     msFree(pszBuf);
     msFreeMap(map);
@@ -596,5 +589,4 @@ int main(int argc, char *argv[])
   return 0;
 }
 
-
 #endif /* TEST_MAPCRYPTO */
diff -pruN 8.0.1-5/mapdebug.c 8.0.2-1/mapdebug.c
--- 8.0.1-5/mapdebug.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapdebug.c	2024-06-11 20:41:34.000000000 +0000
@@ -27,7 +27,6 @@
  * DEALINGS IN THE SOFTWARE.
  ****************************************************************************/
 
-
 #include "mapserver.h"
 #include "maperror.h"
 #include "mapthread.h"
@@ -50,16 +49,11 @@
 #include <windows.h> /* OutputDebugStringA() */
 #endif
 
-
-
-
 #ifndef USE_THREAD
 
-debugInfoObj *msGetDebugInfoObj()
-{
-  static debugInfoObj debuginfo = {MS_DEBUGLEVEL_ERRORSONLY,
-                                   MS_DEBUGMODE_OFF, NULL, NULL
-                                  };
+debugInfoObj *msGetDebugInfoObj() {
+  static debugInfoObj debuginfo = {MS_DEBUGLEVEL_ERRORSONLY, MS_DEBUGMODE_OFF,
+                                   NULL, NULL};
   return &debuginfo;
 }
 
@@ -67,32 +61,32 @@ debugInfoObj *msGetDebugInfoObj()
 
 static debugInfoObj *debuginfo_list = NULL;
 
-debugInfoObj *msGetDebugInfoObj()
-{
+debugInfoObj *msGetDebugInfoObj() {
   debugInfoObj *link;
-  void* thread_id;
+  void *thread_id;
   debugInfoObj *ret_obj;
 
-  msAcquireLock( TLOCK_DEBUGOBJ );
+  msAcquireLock(TLOCK_DEBUGOBJ);
 
   thread_id = msGetThreadId();
 
   /* find link for this thread */
 
-  for( link = debuginfo_list;
-       link != NULL && link->thread_id != thread_id
-       && link->next != NULL && link->next->thread_id != thread_id;
-       link = link->next ) {}
+  for (link = debuginfo_list;
+       link != NULL && link->thread_id != thread_id && link->next != NULL &&
+       link->next->thread_id != thread_id;
+       link = link->next) {
+  }
 
   /* If the target thread link is already at the head of the list were ok */
-  if( debuginfo_list != NULL && debuginfo_list->thread_id == thread_id ) {
+  if (debuginfo_list != NULL && debuginfo_list->thread_id == thread_id) {
   }
 
   /* We don't have one ... initialize one. */
-  else if( link == NULL || link->next == NULL ) {
+  else if (link == NULL || link->next == NULL) {
     debugInfoObj *new_link;
 
-    new_link = (debugInfoObj *) msSmallMalloc(sizeof(debugInfoObj));
+    new_link = (debugInfoObj *)msSmallMalloc(sizeof(debugInfoObj));
     new_link->next = debuginfo_list;
     new_link->thread_id = thread_id;
     new_link->global_debug_level = MS_DEBUGLEVEL_ERRORSONLY;
@@ -113,13 +107,12 @@ debugInfoObj *msGetDebugInfoObj()
 
   ret_obj = debuginfo_list;
 
-  msReleaseLock( TLOCK_DEBUGOBJ );
+  msReleaseLock(TLOCK_DEBUGOBJ);
 
   return ret_obj;
 }
 #endif
 
-
 /* msSetErrorFile()
 **
 ** Set output target, ready to write to it, open file if necessary
@@ -130,8 +123,7 @@ debugInfoObj *msGetDebugInfoObj()
 **
 ** Returns MS_SUCCESS/MS_FAILURE
 */
-int msSetErrorFile(const char *pszErrorFile, const char *pszRelToPath)
-{
+int msSetErrorFile(const char *pszErrorFile, const char *pszRelToPath) {
   char extended_path[MS_MAXPATHLEN];
   debugInfoObj *debuginfo = msGetDebugInfoObj();
 
@@ -139,7 +131,7 @@ int msSetErrorFile(const char *pszErrorF
       strcmp(pszErrorFile, "stdout") != 0 &&
       strcmp(pszErrorFile, "windowsdebug") != 0) {
     /* Try to make the path relative */
-    if(msBuildPath(extended_path, pszRelToPath, pszErrorFile) == NULL)
+    if (msBuildPath(extended_path, pszRelToPath, pszErrorFile) == NULL)
       return MS_FAILURE;
     pszErrorFile = extended_path;
   }
@@ -171,13 +163,17 @@ int msSetErrorFile(const char *pszErrorF
     debuginfo->fp = NULL;
     debuginfo->debug_mode = MS_DEBUGMODE_WINDOWSDEBUG;
 #else
-    msSetError(MS_MISCERR, "'MS_ERRORFILE windowsdebug' is available only on Windows platforms.", "msSetErrorFile()");
+    msSetError(
+        MS_MISCERR,
+        "'MS_ERRORFILE windowsdebug' is available only on Windows platforms.",
+        "msSetErrorFile()");
     return MS_FAILURE;
 #endif
   } else {
     debuginfo->fp = fopen(pszErrorFile, "a");
     if (debuginfo->fp == NULL) {
-      msSetError(MS_MISCERR, "Failed to open MS_ERRORFILE %s", "msSetErrorFile()", pszErrorFile);
+      msSetError(MS_MISCERR, "Failed to open MS_ERRORFILE %s",
+                 "msSetErrorFile()", pszErrorFile);
       return MS_FAILURE;
     }
     debuginfo->errorfile = msStrdup(pszErrorFile);
@@ -191,8 +187,7 @@ int msSetErrorFile(const char *pszErrorF
 **
 ** Close current output file (if one is open) and reset related members
 */
-void msCloseErrorFile()
-{
+void msCloseErrorFile() {
   debugInfoObj *debuginfo = msGetDebugInfoObj();
 
   if (debuginfo && debuginfo->debug_mode != MS_DEBUGMODE_OFF) {
@@ -212,16 +207,13 @@ void msCloseErrorFile()
   }
 }
 
-
-
 /* msGetErrorFile()
 **
 ** Returns name of current error file
 **
 ** Returns NULL if not set.
 */
-const char *msGetErrorFile()
-{
+const char *msGetErrorFile() {
   debugInfoObj *debuginfo = msGetDebugInfoObj();
 
   if (debuginfo)
@@ -235,16 +227,14 @@ const char *msGetErrorFile()
 ** the context of mapObj or layerObj.
 **
 */
-void msSetGlobalDebugLevel(int level)
-{
+void msSetGlobalDebugLevel(int level) {
   debugInfoObj *debuginfo = msGetDebugInfoObj();
 
   if (debuginfo)
     debuginfo->global_debug_level = (debugLevel)level;
 }
 
-debugLevel msGetGlobalDebugLevel()
-{
+debugLevel msGetGlobalDebugLevel() {
   debugInfoObj *debuginfo = msGetDebugInfoObj();
 
   if (debuginfo)
@@ -253,67 +243,63 @@ debugLevel msGetGlobalDebugLevel()
   return MS_DEBUGLEVEL_ERRORSONLY;
 }
 
-
 /* msDebugInitFromEnv()
 **
 ** Init debug state from MS_ERRORFILE and MS_DEBUGLEVEL env vars if set
 **
 ** Returns MS_SUCCESS/MS_FAILURE
 */
-int msDebugInitFromEnv()
-{
+int msDebugInitFromEnv() {
   const char *val;
 
-  if( (val=CPLGetConfigOption("MS_ERRORFILE", NULL)) != NULL ) {
-    if ( msSetErrorFile(val, NULL) != MS_SUCCESS )
+  if ((val = CPLGetConfigOption("MS_ERRORFILE", NULL)) != NULL) {
+    if (msSetErrorFile(val, NULL) != MS_SUCCESS)
       return MS_FAILURE;
   }
 
-  if( (val=CPLGetConfigOption("MS_DEBUGLEVEL", NULL)) != NULL )
+  if ((val = CPLGetConfigOption("MS_DEBUGLEVEL", NULL)) != NULL)
     msSetGlobalDebugLevel(atoi(val));
 
   return MS_SUCCESS;
 }
 
-
 /* msDebugCleanup()
 **
 ** Called by msCleanup to remove info related to this thread.
 */
-void msDebugCleanup()
-{
+void msDebugCleanup() {
   /* make sure file is closed */
   msCloseErrorFile();
 
 #ifdef USE_THREAD
   {
-    void*  thread_id = msGetThreadId();
+    void *thread_id = msGetThreadId();
     debugInfoObj *link;
 
-    msAcquireLock( TLOCK_DEBUGOBJ );
+    msAcquireLock(TLOCK_DEBUGOBJ);
 
     /* find link for this thread */
 
-    for( link = debuginfo_list;
-         link != NULL && link->thread_id != thread_id
-         && link->next != NULL && link->next->thread_id != thread_id;
-         link = link->next ) {}
+    for (link = debuginfo_list;
+         link != NULL && link->thread_id != thread_id && link->next != NULL &&
+         link->next->thread_id != thread_id;
+         link = link->next) {
+    }
 
-    if( link->thread_id == thread_id ) {
+    if (link->thread_id == thread_id) {
       /* presumably link is at head of list.  */
-      if( debuginfo_list == link )
+      if (debuginfo_list == link)
         debuginfo_list = link->next;
 
-      free( link );
-    } else if( link->next != NULL && link->next->thread_id == thread_id ) {
+      free(link);
+    } else if (link->next != NULL && link->next->thread_id == thread_id) {
       debugInfoObj *next_link = link->next;
       link->next = link->next->next;
-      free( next_link );
+      free(next_link);
     }
-    msReleaseLock( TLOCK_DEBUGOBJ );
+    msReleaseLock(TLOCK_DEBUGOBJ);
   }
 #endif
-
 }
 
 /* msDebug()
@@ -322,19 +308,18 @@ void msDebugCleanup()
 ** (see msSetErrorFile())
 **
 */
-void msDebug( const char * pszFormat, ... )
-{
+void msDebug(const char *pszFormat, ...) {
   va_list args;
   debugInfoObj *debuginfo = msGetDebugInfoObj();
   char szMessage[MESSAGELENGTH];
 
   if (debuginfo == NULL || debuginfo->debug_mode == MS_DEBUGMODE_OFF)
-    return;  /* Don't waste time here! */
+    return; /* Don't waste time here! */
 
   va_start(args, pszFormat);
-  vsnprintf( szMessage, MESSAGELENGTH, pszFormat, args );
+  vsnprintf(szMessage, MESSAGELENGTH, pszFormat, args);
   va_end(args);
-  szMessage[MESSAGELENGTH-1] = '\0';
+  szMessage[MESSAGELENGTH - 1] = '\0';
 
   msRedactCredentials(szMessage);
 
@@ -351,8 +336,8 @@ void msDebug( const char * pszFormat, ..
       time_t t;
       msGettimeofday(&tv, NULL);
       t = tv.tv_sec;
-      msIO_fprintf(debuginfo->fp, "[%s].%ld ",
-                   msStringChop(ctime(&t)), (long)tv.tv_usec);
+      msIO_fprintf(debuginfo->fp, "[%s].%ld ", msStringChop(ctime(&t)),
+                   (long)tv.tv_usec);
     }
 
     msIO_fprintf(debuginfo->fp, "%s", szMessage);
@@ -363,16 +348,11 @@ void msDebug( const char * pszFormat, ..
     OutputDebugStringA(szMessage);
   }
 #endif
-
 }
 
-
 /* msDebug2()
 **
 ** Variadic function with no operation
 **
 */
-void msDebug2( int level, ... )
-{
-    (void)level;
-}
+void msDebug2(int level, ...) { (void)level; }
diff -pruN 8.0.1-5/mapdraw.c 8.0.2-1/mapdraw.c
--- 8.0.1-5/mapdraw.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapdraw.c	2024-06-11 20:41:34.000000000 +0000
@@ -35,7 +35,6 @@
 #include "mapfile.h"
 #include "mapows.h"
 
-
 /* msPrepareImage()
  *
  * Returns a new imageObj ready for rendering the current map.
@@ -44,69 +43,76 @@
  * msMapRestoreRealExtent() once they are done with the image.
  * This should be set to MS_TRUE only when called from msDrawMap(), see bug 945.
  */
-imageObj *msPrepareImage(mapObj *map, int allow_nonsquare)
-{
+imageObj *msPrepareImage(mapObj *map, int allow_nonsquare) {
   int i, status;
-  imageObj *image=NULL;
+  imageObj *image = NULL;
   double geo_cellsize;
 
-  if(map->width == -1 || map->height == -1) {
-    msSetError(MS_MISCERR, "Image dimensions not specified.", "msPrepareImage()");
-    return(NULL);
+  if (map->width == -1 || map->height == -1) {
+    msSetError(MS_MISCERR, "Image dimensions not specified.",
+               "msPrepareImage()");
+    return (NULL);
   }
 
   msFreeLabelCache(&(map->labelcache));
-  msInitLabelCache(&(map->labelcache)); /* this clears any previously allocated cache */
+  msInitLabelCache(
+      &(map->labelcache)); /* this clears any previously allocated cache */
 
   /* clear any previously created mask layer images */
-  for(i=0; i<map->numlayers; i++) {
-    if(GET_LAYER(map, i)->maskimage) {
+  for (i = 0; i < map->numlayers; i++) {
+    if (GET_LAYER(map, i)->maskimage) {
       msFreeImage(GET_LAYER(map, i)->maskimage);
       GET_LAYER(map, i)->maskimage = NULL;
     }
   }
 
-  status = msValidateContexts(map); /* make sure there are no recursive REQUIRES or LABELREQUIRES expressions */
-  if(status != MS_SUCCESS) return NULL;
+  status = msValidateContexts(map); /* make sure there are no recursive REQUIRES
+                                       or LABELREQUIRES expressions */
+  if (status != MS_SUCCESS)
+    return NULL;
 
-  if(!map->outputformat) {
+  if (!map->outputformat) {
     msSetError(MS_IMGERR, "Map outputformat not set!", "msPrepareImage()");
-    return(NULL);
+    return (NULL);
   } else if (MS_RENDERER_PLUGIN(map->outputformat)) {
     rendererVTableObj *renderer = map->outputformat->vtable;
     colorObj *bg = &map->imagecolor;
-    map->imagecolor.alpha=255;
+    map->imagecolor.alpha = 255;
 
-    image = renderer->createImage(map->width, map->height, map->outputformat,bg);
+    image =
+        renderer->createImage(map->width, map->height, map->outputformat, bg);
     if (image == NULL)
-      return(NULL);
+      return (NULL);
     image->format = map->outputformat;
     image->format->refcount++;
     image->width = map->width;
     image->height = map->height;
-    
+
     image->resolution = map->resolution;
-    image->resolutionfactor = map->resolution/map->defresolution;
+    image->resolutionfactor = map->resolution / map->defresolution;
     if (map->web.imagepath)
       image->imagepath = msStrdup(map->web.imagepath);
     if (map->web.imageurl)
       image->imageurl = msStrdup(map->web.imageurl);
 
-  } else if( MS_RENDERER_IMAGEMAP(map->outputformat) ) {
+  } else if (MS_RENDERER_IMAGEMAP(map->outputformat)) {
     image = msImageCreateIM(map->width, map->height, map->outputformat,
-                            map->web.imagepath, map->web.imageurl, map->resolution, map->defresolution);
-  } else if( MS_RENDERER_RAWDATA(map->outputformat) ) {
-    image = msImageCreate(map->width, map->height, map->outputformat,
-                          map->web.imagepath, map->web.imageurl, map->resolution, map->defresolution, &map->imagecolor);
+                            map->web.imagepath, map->web.imageurl,
+                            map->resolution, map->defresolution);
+  } else if (MS_RENDERER_RAWDATA(map->outputformat)) {
+    image =
+        msImageCreate(map->width, map->height, map->outputformat,
+                      map->web.imagepath, map->web.imageurl, map->resolution,
+                      map->defresolution, &map->imagecolor);
   } else {
     image = NULL;
   }
-  
-  if(!image) {
+
+  if (!image) {
     msSetError(MS_IMGERR, "Unable to initialize image.", "msPrepareImage()");
-    return(NULL);
+    return (NULL);
   }
-  
+
   image->map = map;
 
   /*
@@ -115,135 +121,151 @@ imageObj *msPrepareImage(mapObj *map, in
    *
    * If allow_nonsquare is set to MS_TRUE then the caller should call
    * msMapRestoreRealExtent() once they are done with the image.
-   * This should be set to MS_TRUE only when called from msDrawMap(), see bug 945.
+   * This should be set to MS_TRUE only when called from msDrawMap(), see bug
+   * 945.
    */
-  if( allow_nonsquare && msTestConfigOption( map, "MS_NONSQUARE", MS_FALSE ) ) {
-    double cellsize_x = (map->extent.maxx - map->extent.minx)/map->width;
-    double cellsize_y = (map->extent.maxy - map->extent.miny)/map->height;
-
-    if( cellsize_y != 0.0
-        && (fabs(cellsize_x/cellsize_y) > 1.00001
-            || fabs(cellsize_x/cellsize_y) < 0.99999) ) {
+  if (allow_nonsquare && msTestConfigOption(map, "MS_NONSQUARE", MS_FALSE)) {
+    double cellsize_x = (map->extent.maxx - map->extent.minx) / map->width;
+    double cellsize_y = (map->extent.maxy - map->extent.miny) / map->height;
+
+    if (cellsize_y != 0.0 && (fabs(cellsize_x / cellsize_y) > 1.00001 ||
+                              fabs(cellsize_x / cellsize_y) < 0.99999)) {
       map->gt.need_geotransform = MS_TRUE;
       if (map->debug)
-        msDebug( "msDrawMap(): kicking into non-square pixel preserving mode.\n" );
+        msDebug(
+            "msDrawMap(): kicking into non-square pixel preserving mode.\n");
     }
-    map->cellsize = (cellsize_x*0.5 + cellsize_y*0.5);
+    map->cellsize = (cellsize_x * 0.5 + cellsize_y * 0.5);
   } else
-    map->cellsize = msAdjustExtent(&(map->extent),map->width,map->height);
+    map->cellsize = msAdjustExtent(&(map->extent), map->width, map->height);
 
-  status = msCalculateScale(map->extent,map->units,map->width,map->height, map->resolution, &map->scaledenom);
-  if(status != MS_SUCCESS) {
+  status = msCalculateScale(map->extent, map->units, map->width, map->height,
+                            map->resolution, &map->scaledenom);
+  if (status != MS_SUCCESS) {
     msFreeImage(image);
-    return(NULL);
+    return (NULL);
   }
 
   /* update geotransform based on adjusted extent. */
-  msMapComputeGeotransform( map );
+  msMapComputeGeotransform(map);
 
   /* Do we need to fake out stuff for rotated support? */
-  if( map->gt.need_geotransform )
-    msMapSetFakedExtent( map );
+  if (map->gt.need_geotransform)
+    msMapSetFakedExtent(map);
 
   /* We will need a cellsize that represents a real georeferenced */
   /* coordinate cellsize here, so compute it from saved extents.   */
 
   geo_cellsize = map->cellsize;
-  if( map->gt.need_geotransform == MS_TRUE ) {
-    double cellsize_x = (map->saved_extent.maxx - map->saved_extent.minx)
-                        / map->width;
-    double cellsize_y = (map->saved_extent.maxy - map->saved_extent.miny)
-                        / map->height;
+  if (map->gt.need_geotransform == MS_TRUE) {
+    double cellsize_x =
+        (map->saved_extent.maxx - map->saved_extent.minx) / map->width;
+    double cellsize_y =
+        (map->saved_extent.maxy - map->saved_extent.miny) / map->height;
 
-    geo_cellsize = sqrt(cellsize_x*cellsize_x + cellsize_y*cellsize_y)
-                   / sqrt(2.0);
+    geo_cellsize =
+        sqrt(cellsize_x * cellsize_x + cellsize_y * cellsize_y) / sqrt(2.0);
   }
 
   /* compute layer/class/style/label scale factors now */
-  for(int lid=0; lid<map->numlayers; lid++) {
-    layerObj * layer = GET_LAYER(map, lid);
-    if(layer->sizeunits != MS_PIXELS)
-      layer->scalefactor = (msInchesPerUnit(layer->sizeunits,0)/msInchesPerUnit(map->units,0)) / geo_cellsize;
-    else if(layer->symbolscaledenom > 0 && map->scaledenom > 0)
-      layer->scalefactor = layer->symbolscaledenom/map->scaledenom*map->resolution/map->defresolution;
+  for (int lid = 0; lid < map->numlayers; lid++) {
+    layerObj *layer = GET_LAYER(map, lid);
+    if (layer->sizeunits != MS_PIXELS)
+      layer->scalefactor = (msInchesPerUnit(layer->sizeunits, 0) /
+                            msInchesPerUnit(map->units, 0)) /
+                           geo_cellsize;
+    else if (layer->symbolscaledenom > 0 && map->scaledenom > 0)
+      layer->scalefactor = layer->symbolscaledenom / map->scaledenom *
+                           map->resolution / map->defresolution;
     else
-      layer->scalefactor = map->resolution/map->defresolution;
-    for (int cid=0 ; cid<layer->numclasses ; cid++)
-    {
-      classObj * class = GET_CLASS(map, lid, cid);
+      layer->scalefactor = map->resolution / map->defresolution;
+    for (int cid = 0; cid < layer->numclasses; cid++) {
+      classObj *class = GET_CLASS(map, lid, cid);
       if (class->sizeunits == MS_INHERIT)
         class->scalefactor = layer->scalefactor;
       else if (class->sizeunits != MS_PIXELS)
-        class->scalefactor = (msInchesPerUnit(class->sizeunits,0)/msInchesPerUnit(map->units,0)) / geo_cellsize;
+        class->scalefactor = (msInchesPerUnit(class->sizeunits, 0) /
+                              msInchesPerUnit(map->units, 0)) /
+                             geo_cellsize;
       else if (layer->symbolscaledenom > 0 && map->scaledenom > 0)
-        class->scalefactor = layer->symbolscaledenom/map->scaledenom*map->resolution/map->defresolution;
+        class->scalefactor = layer->symbolscaledenom / map->scaledenom *
+                             map->resolution / map->defresolution;
       else
-        class->scalefactor = map->resolution/map->defresolution;
-      for (int sid=0 ; sid<class->numstyles ; sid++)
-      {
-        styleObj * style = class->styles[sid];
+        class->scalefactor = map->resolution / map->defresolution;
+      for (int sid = 0; sid < class->numstyles; sid++) {
+        styleObj *style = class->styles[sid];
         if (style->sizeunits == MS_INHERIT)
           style->scalefactor = class->scalefactor;
         else if (style->sizeunits != MS_PIXELS)
-          style->scalefactor = (msInchesPerUnit(style->sizeunits,0)/msInchesPerUnit(map->units,0)) / geo_cellsize;
+          style->scalefactor = (msInchesPerUnit(style->sizeunits, 0) /
+                                msInchesPerUnit(map->units, 0)) /
+                               geo_cellsize;
         else if (layer->symbolscaledenom > 0 && map->scaledenom > 0)
-          style->scalefactor = layer->symbolscaledenom/map->scaledenom*map->resolution/map->defresolution;
+          style->scalefactor = layer->symbolscaledenom / map->scaledenom *
+                               map->resolution / map->defresolution;
         else
-          style->scalefactor = map->resolution/map->defresolution;
+          style->scalefactor = map->resolution / map->defresolution;
       }
-      for (int sid=0 ; sid<class->numlabels ; sid++)
-      {
-        labelObj * label = class->labels[sid];
+      for (int sid = 0; sid < class->numlabels; sid++) {
+        labelObj *label = class->labels[sid];
         if (label->sizeunits == MS_INHERIT)
           label->scalefactor = class->scalefactor;
         else if (label->sizeunits != MS_PIXELS)
-          label->scalefactor = (msInchesPerUnit(label->sizeunits,0)/msInchesPerUnit(map->units,0)) / geo_cellsize;
+          label->scalefactor = (msInchesPerUnit(label->sizeunits, 0) /
+                                msInchesPerUnit(map->units, 0)) /
+                               geo_cellsize;
         else if (layer->symbolscaledenom > 0 && map->scaledenom > 0)
-          label->scalefactor = layer->symbolscaledenom/map->scaledenom*map->resolution/map->defresolution;
+          label->scalefactor = layer->symbolscaledenom / map->scaledenom *
+                               map->resolution / map->defresolution;
         else
-          label->scalefactor = map->resolution/map->defresolution;
-        for (int lsid=0 ; lsid<label->numstyles ; lsid++)
-        {
-          styleObj * lstyle = label->styles[lsid];
+          label->scalefactor = map->resolution / map->defresolution;
+        for (int lsid = 0; lsid < label->numstyles; lsid++) {
+          styleObj *lstyle = label->styles[lsid];
           if (lstyle->sizeunits == MS_INHERIT)
             lstyle->scalefactor = label->scalefactor;
           else if (lstyle->sizeunits != MS_PIXELS)
-            lstyle->scalefactor = (msInchesPerUnit(lstyle->sizeunits,0)/msInchesPerUnit(map->units,0)) / geo_cellsize;
+            lstyle->scalefactor = (msInchesPerUnit(lstyle->sizeunits, 0) /
+                                   msInchesPerUnit(map->units, 0)) /
+                                  geo_cellsize;
           else if (layer->symbolscaledenom > 0 && map->scaledenom > 0)
-            lstyle->scalefactor = layer->symbolscaledenom/map->scaledenom*map->resolution/map->defresolution;
+            lstyle->scalefactor = layer->symbolscaledenom / map->scaledenom *
+                                  map->resolution / map->defresolution;
           else
-            lstyle->scalefactor = map->resolution/map->defresolution;
+            lstyle->scalefactor = map->resolution / map->defresolution;
         }
       }
     }
   }
 
-  image->refpt.x = MS_MAP2IMAGE_X_IC_DBL(0, map->extent.minx, 1.0/map->cellsize);
-  image->refpt.y = MS_MAP2IMAGE_Y_IC_DBL(0, map->extent.maxy, 1.0/map->cellsize);
+  image->refpt.x =
+      MS_MAP2IMAGE_X_IC_DBL(0, map->extent.minx, 1.0 / map->cellsize);
+  image->refpt.y =
+      MS_MAP2IMAGE_Y_IC_DBL(0, map->extent.maxy, 1.0 / map->cellsize);
 
   return image;
-  
 }
 
-static int msCompositeRasterBuffer(mapObj *map, imageObj *img, rasterBufferObj *rb, LayerCompositer *comp) {
+static int msCompositeRasterBuffer(mapObj *map, imageObj *img,
+                                   rasterBufferObj *rb, LayerCompositer *comp) {
   int ret = MS_SUCCESS;
-  if(MS_IMAGE_RENDERER(img)->compositeRasterBuffer) {
-    while(comp && ret == MS_SUCCESS) {
+  if (MS_IMAGE_RENDERER(img)->compositeRasterBuffer) {
+    while (comp && ret == MS_SUCCESS) {
       rasterBufferObj *rb_ptr = rb;
       CompositingFilter *filter = comp->filter;
-      if(filter && comp->next) {
-       /* if we have another compositor to apply, then we need to copy the rasterBufferObj. Otherwise
-       * we can work on it directly */
-	rb_ptr = (rasterBufferObj*)msSmallCalloc(sizeof(rasterBufferObj),1);
-	msCopyRasterBuffer(rb_ptr,rb);
+      if (filter && comp->next) {
+        /* if we have another compositor to apply, then we need to copy the
+         * rasterBufferObj. Otherwise we can work on it directly */
+        rb_ptr = (rasterBufferObj *)msSmallCalloc(sizeof(rasterBufferObj), 1);
+        msCopyRasterBuffer(rb_ptr, rb);
       }
-      while(filter && ret == MS_SUCCESS) {
-        ret = msApplyCompositingFilter(map,rb_ptr,filter);
+      while (filter && ret == MS_SUCCESS) {
+        ret = msApplyCompositingFilter(map, rb_ptr, filter);
         filter = filter->next;
       }
-      if(ret == MS_SUCCESS)
-      	ret = MS_IMAGE_RENDERER(img)->compositeRasterBuffer(img,rb_ptr,comp->comp_op, comp->opacity);
-      if(rb_ptr != rb) {
+      if (ret == MS_SUCCESS)
+        ret = MS_IMAGE_RENDERER(img)->compositeRasterBuffer(
+            img, rb_ptr, comp->comp_op, comp->opacity);
+      if (rb_ptr != rb) {
         msFreeRasterBuffer(rb_ptr);
         msFree(rb_ptr);
       }
@@ -257,15 +279,15 @@ static int msCompositeRasterBuffer(mapOb
 
 /*
  * Generic function to render the map file.
- * The type of the image created is based on the imagetype parameter in the map file.
+ * The type of the image created is based on the imagetype parameter in the map
+ * file.
  *
  * mapObj *map - map object loaded in MapScript or via a mapfile to use
  * int querymap - is this map the result of a query operation, MS_TRUE|MS_FALSE
-*/
-imageObj *msDrawMap(mapObj *map, int querymap)
-{
+ */
+imageObj *msDrawMap(mapObj *map, int querymap) {
   int i;
-  layerObj *lp=NULL;
+  layerObj *lp = NULL;
   int status = MS_FAILURE;
   imageObj *image = NULL;
   struct mstimeval mapstarttime = {0}, mapendtime = {0};
@@ -273,85 +295,92 @@ imageObj *msDrawMap(mapObj *map, int que
 
 #if defined(USE_WMS_LYR) || defined(USE_WFS_LYR)
   enum MS_CONNECTION_TYPE lastconnectiontype;
-  httpRequestObj *pasOWSReqInfo=NULL;
-  int numOWSLayers=0;
-  int numOWSRequests=0;
+  httpRequestObj *pasOWSReqInfo = NULL;
+  int numOWSLayers = 0;
+  int numOWSRequests = 0;
   wmsParamsObj sLastWMSParams;
 #endif
 
-  if(map->debug >= MS_DEBUGLEVEL_TUNING) msGettimeofday(&mapstarttime, NULL);
+  if (map->debug >= MS_DEBUGLEVEL_TUNING)
+    msGettimeofday(&mapstarttime, NULL);
 
-  if(querymap) { /* use queryMapObj image dimensions */
-    if(map->querymap.width > 0 && map->querymap.width <= map->maxsize) map->width = map->querymap.width;
-    if(map->querymap.height > 0 && map->querymap.height <= map->maxsize) map->height = map->querymap.height;
+  if (querymap) { /* use queryMapObj image dimensions */
+    if (map->querymap.width > 0 && map->querymap.width <= map->maxsize)
+      map->width = map->querymap.width;
+    if (map->querymap.height > 0 && map->querymap.height <= map->maxsize)
+      map->height = map->querymap.height;
   }
 
   msApplyMapConfigOptions(map);
   image = msPrepareImage(map, MS_TRUE);
 
-  if(!image) {
+  if (!image) {
     msSetError(MS_IMGERR, "Unable to initialize image.", "msDrawMap()");
-    return(NULL);
+    return (NULL);
   }
 
-  if( map->debug >= MS_DEBUGLEVEL_DEBUG )
-    msDebug( "msDrawMap(): rendering using outputformat named %s (%s).\n",
-             map->outputformat->name,
-             map->outputformat->driver );
+  if (map->debug >= MS_DEBUGLEVEL_DEBUG)
+    msDebug("msDrawMap(): rendering using outputformat named %s (%s).\n",
+            map->outputformat->name, map->outputformat->driver);
 
 #if defined(USE_WMS_LYR) || defined(USE_WFS_LYR)
 
   /* Time the OWS query phase */
-  if(map->debug >= MS_DEBUGLEVEL_TUNING ) msGettimeofday(&starttime, NULL);
+  if (map->debug >= MS_DEBUGLEVEL_TUNING)
+    msGettimeofday(&starttime, NULL);
 
   /* How many OWS (WMS/WFS) layers do we have to draw?
    * Note: numOWSLayers is the number of actual layers and numOWSRequests is
    * the number of HTTP requests which could be lower if multiple layers
    * are merged into the same request.
    */
-  numOWSLayers=0;
-  for(i=0; i<map->numlayers; i++) {
-      if(map->layerorder[i] == -1 )
-        continue;
+  numOWSLayers = 0;
+  for (i = 0; i < map->numlayers; i++) {
+    if (map->layerorder[i] == -1)
+      continue;
 
-      lp = GET_LAYER(map,map->layerorder[i]);
-      if( lp->connectiontype != MS_WMS &&
-          lp->connectiontype != MS_WFS ) {
-        continue;
-      }
-      numOWSLayers++;
+    lp = GET_LAYER(map, map->layerorder[i]);
+    if (lp->connectiontype != MS_WMS && lp->connectiontype != MS_WFS) {
+      continue;
+    }
+    numOWSLayers++;
   }
 
   if (numOWSLayers > 0) {
 
     /* Alloc and init pasOWSReqInfo...
      */
-    pasOWSReqInfo = (httpRequestObj *)malloc(numOWSLayers*sizeof(httpRequestObj));
+    pasOWSReqInfo =
+        (httpRequestObj *)malloc(numOWSLayers * sizeof(httpRequestObj));
     if (pasOWSReqInfo == NULL) {
-      msSetError(MS_MEMERR, "Allocation of httpRequestObj failed.", "msDrawMap()");
+      msSetError(MS_MEMERR, "Allocation of httpRequestObj failed.",
+                 "msDrawMap()");
       return NULL;
     }
     msHTTPInitRequestObj(pasOWSReqInfo, numOWSLayers);
     msInitWmsParamsObj(&sLastWMSParams);
 
-    /* Pre-download all WMS/WFS layers in parallel before starting to draw map */
+    /* Pre-download all WMS/WFS layers in parallel before starting to draw map
+     */
     lastconnectiontype = MS_SHAPEFILE;
-    for(i=0; i<map->numlayers; i++) {
-      if(map->layerorder[i] == -1 )
+    for (i = 0; i < map->numlayers; i++) {
+      if (map->layerorder[i] == -1)
         continue;
 
-      lp = GET_LAYER(map,map->layerorder[i]);
-      if( lp->connectiontype != MS_WMS &&
-          lp->connectiontype != MS_WFS ) {
+      lp = GET_LAYER(map, map->layerorder[i]);
+      if (lp->connectiontype != MS_WMS && lp->connectiontype != MS_WFS) {
         continue;
       }
 
-      if( !msLayerIsVisible(map, lp) )
+      if (!msLayerIsVisible(map, lp))
         continue;
 
 #ifdef USE_WMS_LYR
-      if(lp->connectiontype == MS_WMS) {
-        if(msPrepareWMSLayerRequest(map->layerorder[i], map, lp, 1, lastconnectiontype, &sLastWMSParams, 0, 0, 0, NULL, pasOWSReqInfo, &numOWSRequests) == MS_FAILURE) {
+      if (lp->connectiontype == MS_WMS) {
+        if (msPrepareWMSLayerRequest(map->layerorder[i], map, lp, 1,
+                                     lastconnectiontype, &sLastWMSParams, 0, 0,
+                                     0, NULL, pasOWSReqInfo,
+                                     &numOWSRequests) == MS_FAILURE) {
           msFreeWmsParamsObj(&sLastWMSParams);
           msFreeImage(image);
           msFree(pasOWSReqInfo);
@@ -361,8 +390,9 @@ imageObj *msDrawMap(mapObj *map, int que
 #endif
 
 #ifdef USE_WFS_LYR
-      if(lp->connectiontype == MS_WFS) {
-        if(msPrepareWFSLayerRequest(map->layerorder[i], map, lp, pasOWSReqInfo, &numOWSRequests) == MS_FAILURE) {
+      if (lp->connectiontype == MS_WFS) {
+        if (msPrepareWFSLayerRequest(map->layerorder[i], map, lp, pasOWSReqInfo,
+                                     &numOWSRequests) == MS_FAILURE) {
           msFreeWmsParamsObj(&sLastWMSParams);
           msFreeImage(image);
           msFree(pasOWSReqInfo);
@@ -377,73 +407,86 @@ imageObj *msDrawMap(mapObj *map, int que
     msFreeWmsParamsObj(&sLastWMSParams);
   } /* if numOWSLayers > 0 */
 
-  if(numOWSRequests && msOWSExecuteRequests(pasOWSReqInfo, numOWSRequests, map, MS_TRUE) == MS_FAILURE) {
+  if (numOWSRequests && msOWSExecuteRequests(pasOWSReqInfo, numOWSRequests, map,
+                                             MS_TRUE) == MS_FAILURE) {
     msFreeImage(image);
     msFree(pasOWSReqInfo);
     return NULL;
   }
 
-  if(map->debug >= MS_DEBUGLEVEL_TUNING) {
+  if (map->debug >= MS_DEBUGLEVEL_TUNING) {
     msGettimeofday(&endtime, NULL);
     msDebug("msDrawMap(): WMS/WFS set-up and query, %.3fs\n",
-            (endtime.tv_sec+endtime.tv_usec/1.0e6)-
-            (starttime.tv_sec+starttime.tv_usec/1.0e6) );
+            (endtime.tv_sec + endtime.tv_usec / 1.0e6) -
+                (starttime.tv_sec + starttime.tv_usec / 1.0e6));
   }
 
 #endif /* USE_WMS_LYR || USE_WFS_LYR */
 
   /* OK, now we can start drawing */
-  for(i=0; i<map->numlayers; i++) {
+  for (i = 0; i < map->numlayers; i++) {
 
-    if(map->layerorder[i] != -1) {
+    if (map->layerorder[i] != -1) {
       const char *force_draw_label_cache = NULL;
 
-      lp = (GET_LAYER(map,  map->layerorder[i]));
+      lp = (GET_LAYER(map, map->layerorder[i]));
 
-      if(lp->postlabelcache) /* wait to draw */
+      if (lp->postlabelcache) /* wait to draw */
         continue;
 
-      if(map->debug >= MS_DEBUGLEVEL_TUNING || lp->debug >= MS_DEBUGLEVEL_TUNING ) msGettimeofday(&starttime, NULL);
+      if (map->debug >= MS_DEBUGLEVEL_TUNING ||
+          lp->debug >= MS_DEBUGLEVEL_TUNING)
+        msGettimeofday(&starttime, NULL);
 
-      if(!msLayerIsVisible(map, lp)) continue;
+      if (!msLayerIsVisible(map, lp))
+        continue;
 
-      if(lp->connectiontype == MS_WMS) {
+      if (lp->connectiontype == MS_WMS) {
 #ifdef USE_WMS_LYR
-        if(MS_RENDERER_PLUGIN(image->format) || MS_RENDERER_RAWDATA(image->format)) {
+        if (MS_RENDERER_PLUGIN(image->format) ||
+            MS_RENDERER_RAWDATA(image->format)) {
           assert(pasOWSReqInfo);
-          status = msDrawWMSLayerLow(map->layerorder[i], pasOWSReqInfo, numOWSRequests,  map, lp, image);
-        }
-        else {
-          msSetError(MS_WMSCONNERR, "Output format '%s' doesn't support WMS layers.", "msDrawMap()", image->format->name);
+          status = msDrawWMSLayerLow(map->layerorder[i], pasOWSReqInfo,
+                                     numOWSRequests, map, lp, image);
+        } else {
+          msSetError(MS_WMSCONNERR,
+                     "Output format '%s' doesn't support WMS layers.",
+                     "msDrawMap()", image->format->name);
           status = MS_FAILURE;
         }
 
-        if(status == MS_FAILURE) {
+        if (status == MS_FAILURE) {
           msSetError(MS_WMSCONNERR,
-                     "Failed to draw WMS layer named '%s'. This most likely happened because "
-                     "the remote WMS server returned an invalid image, and XML exception "
-                     "or another unexpected result in response to the GetMap request. Also check "
+                     "Failed to draw WMS layer named '%s'. This most likely "
+                     "happened because "
+                     "the remote WMS server returned an invalid image, and XML "
+                     "exception "
+                     "or another unexpected result in response to the GetMap "
+                     "request. Also check "
                      "and make sure that the layer's connection URL is valid.",
                      "msDrawMap()", lp->name);
           msFreeImage(image);
           msHTTPFreeRequestObj(pasOWSReqInfo, numOWSRequests);
           msFree(pasOWSReqInfo);
-          return(NULL);
+          return (NULL);
         }
 
-
 #else /* ndef USE_WMS_LYR */
-        msSetError(MS_WMSCONNERR, "MapServer not built with WMS Client support, unable to render layer '%s'.", "msDrawMap()", lp->name);
+        msSetError(MS_WMSCONNERR,
+                   "MapServer not built with WMS Client support, unable to "
+                   "render layer '%s'.",
+                   "msDrawMap()", lp->name);
         msFreeImage(image);
-        return(NULL);
+        return (NULL);
 #endif
       } else { /* Default case: anything but WMS layers */
-        if(querymap)
+        if (querymap)
           status = msDrawQueryLayer(map, lp, image);
         else
           status = msDrawLayer(map, lp, image);
-        if(status == MS_FAILURE) {
-          msSetError(MS_IMGERR, "Failed to draw layer named '%s'.", "msDrawMap()", lp->name);
+        if (status == MS_FAILURE) {
+          msSetError(MS_IMGERR, "Failed to draw layer named '%s'.",
+                     "msDrawMap()", lp->name);
           msFreeImage(image);
 #if defined(USE_WMS_LYR) || defined(USE_WFS_LYR)
           if (pasOWSReqInfo) {
@@ -451,80 +494,81 @@ imageObj *msDrawMap(mapObj *map, int que
             msFree(pasOWSReqInfo);
           }
 #endif /* USE_WMS_LYR || USE_WFS_LYR */
-          return(NULL);
+          return (NULL);
         }
       }
-      if(map->debug >= MS_DEBUGLEVEL_TUNING || lp->debug >= MS_DEBUGLEVEL_TUNING) {
+      if (map->debug >= MS_DEBUGLEVEL_TUNING ||
+          lp->debug >= MS_DEBUGLEVEL_TUNING) {
         msGettimeofday(&endtime, NULL);
-        msDebug("msDrawMap(): Layer %d (%s), %.3fs\n",
-                map->layerorder[i], lp->name?lp->name:"(null)",
-                (endtime.tv_sec+endtime.tv_usec/1.0e6)-
-                (starttime.tv_sec+starttime.tv_usec/1.0e6) );
+        msDebug("msDrawMap(): Layer %d (%s), %.3fs\n", map->layerorder[i],
+                lp->name ? lp->name : "(null)",
+                (endtime.tv_sec + endtime.tv_usec / 1.0e6) -
+                    (starttime.tv_sec + starttime.tv_usec / 1.0e6));
       }
 
-      /* Flush layer cache in-between layers if requested by PROCESSING directive*/
-      force_draw_label_cache = msLayerGetProcessingKey(lp, "FORCE_DRAW_LABEL_CACHE");
+      /* Flush layer cache in-between layers if requested by PROCESSING
+       * directive*/
+      force_draw_label_cache =
+          msLayerGetProcessingKey(lp, "FORCE_DRAW_LABEL_CACHE");
       if (force_draw_label_cache &&
-	  strncasecmp(force_draw_label_cache,"FLUSH",5)==0) {
-	if(map->debug >= MS_DEBUGLEVEL_V)
-	  msDebug("msDrawMap(): PROCESSING FORCE_DRAW_LABEL_CACHE=FLUSH found.\n");
-	if(msDrawLabelCache(map, image) != MS_SUCCESS) {
-	  msFreeImage(image);
+          strncasecmp(force_draw_label_cache, "FLUSH", 5) == 0) {
+        if (map->debug >= MS_DEBUGLEVEL_V)
+          msDebug(
+              "msDrawMap(): PROCESSING FORCE_DRAW_LABEL_CACHE=FLUSH found.\n");
+        if (msDrawLabelCache(map, image) != MS_SUCCESS) {
+          msFreeImage(image);
 #if defined(USE_WMS_LYR) || defined(USE_WFS_LYR)
-	  if (pasOWSReqInfo) {
-	    msHTTPFreeRequestObj(pasOWSReqInfo, numOWSRequests);
-	    msFree(pasOWSReqInfo);
-	  }
+          if (pasOWSReqInfo) {
+            msHTTPFreeRequestObj(pasOWSReqInfo, numOWSRequests);
+            msFree(pasOWSReqInfo);
+          }
 #endif /* USE_WMS_LYR || USE_WFS_LYR */
-	  return(NULL);
-	}
-	msFreeLabelCache(&(map->labelcache));
-	msInitLabelCache(&(map->labelcache));
+          return (NULL);
+        }
+        msFreeLabelCache(&(map->labelcache));
+        msInitLabelCache(&(map->labelcache));
       } /* PROCESSING FORCE_DRAW_LABEL_CACHE */
-
     }
   }
 
-  if(map->scalebar.status == MS_EMBED && !map->scalebar.postlabelcache) {
+  if (map->scalebar.status == MS_EMBED && !map->scalebar.postlabelcache) {
 
     /* We need to temporarily restore the original extent for drawing */
     /* the scalebar as it uses the extent to recompute cellsize. */
-    if(map->gt.need_geotransform)
+    if (map->gt.need_geotransform)
       msMapRestoreRealExtent(map);
 
-
-    if(MS_SUCCESS != msEmbedScalebar(map, image)) {
-      msFreeImage( image );
+    if (MS_SUCCESS != msEmbedScalebar(map, image)) {
+      msFreeImage(image);
 #if defined(USE_WMS_LYR) || defined(USE_WFS_LYR)
       /* Cleanup WMS/WFS Request stuff */
       if (pasOWSReqInfo) {
-         msHTTPFreeRequestObj(pasOWSReqInfo, numOWSRequests);
-         msFree(pasOWSReqInfo);
+        msHTTPFreeRequestObj(pasOWSReqInfo, numOWSRequests);
+        msFree(pasOWSReqInfo);
       }
 #endif
       return NULL;
     }
 
-
-    if(map->gt.need_geotransform)
+    if (map->gt.need_geotransform)
       msMapSetFakedExtent(map);
   }
 
-  if(map->legend.status == MS_EMBED && !map->legend.postlabelcache) {
-    if( msEmbedLegend(map, image) != MS_SUCCESS ) {
-      msFreeImage( image );
+  if (map->legend.status == MS_EMBED && !map->legend.postlabelcache) {
+    if (msEmbedLegend(map, image) != MS_SUCCESS) {
+      msFreeImage(image);
 #if defined(USE_WMS_LYR) || defined(USE_WFS_LYR)
       /* Cleanup WMS/WFS Request stuff */
       if (pasOWSReqInfo) {
-         msHTTPFreeRequestObj(pasOWSReqInfo, numOWSRequests);
-         msFree(pasOWSReqInfo);
+        msHTTPFreeRequestObj(pasOWSReqInfo, numOWSRequests);
+        msFree(pasOWSReqInfo);
       }
 #endif
       return NULL;
     }
   }
 
-  if(msDrawLabelCache(map, image) != MS_SUCCESS) {
+  if (msDrawLabelCache(map, image) != MS_SUCCESS) {
     msFreeImage(image);
 #if defined(USE_WMS_LYR) || defined(USE_WFS_LYR)
     if (pasOWSReqInfo) {
@@ -532,38 +576,42 @@ imageObj *msDrawMap(mapObj *map, int que
       msFree(pasOWSReqInfo);
     }
 #endif /* USE_WMS_LYR || USE_WFS_LYR */
-    return(NULL);
+    return (NULL);
   }
 
-
-  for(i=0; i<map->numlayers; i++) { /* for each layer, check for postlabelcache layers */
+  for (i = 0; i < map->numlayers;
+       i++) { /* for each layer, check for postlabelcache layers */
 
     lp = (GET_LAYER(map, map->layerorder[i]));
 
-    if(!lp->postlabelcache) continue;
-    if(!msLayerIsVisible(map, lp)) continue;
+    if (!lp->postlabelcache)
+      continue;
+    if (!msLayerIsVisible(map, lp))
+      continue;
 
-    if(map->debug >= MS_DEBUGLEVEL_TUNING || lp->debug >= MS_DEBUGLEVEL_TUNING) msGettimeofday(&starttime, NULL);
+    if (map->debug >= MS_DEBUGLEVEL_TUNING || lp->debug >= MS_DEBUGLEVEL_TUNING)
+      msGettimeofday(&starttime, NULL);
 
-    if(lp->connectiontype == MS_WMS) {
+    if (lp->connectiontype == MS_WMS) {
 #ifdef USE_WMS_LYR
-      if(MS_RENDERER_PLUGIN(image->format) || MS_RENDERER_RAWDATA(image->format))
-      {
+      if (MS_RENDERER_PLUGIN(image->format) ||
+          MS_RENDERER_RAWDATA(image->format)) {
         assert(pasOWSReqInfo);
-        status = msDrawWMSLayerLow(map->layerorder[i], pasOWSReqInfo, numOWSRequests, map, lp, image);
+        status = msDrawWMSLayerLow(map->layerorder[i], pasOWSReqInfo,
+                                   numOWSRequests, map, lp, image);
       }
 
 #else
       status = MS_FAILURE;
 #endif
     } else {
-      if(querymap)
+      if (querymap)
         status = msDrawQueryLayer(map, lp, image);
       else
         status = msDrawLayer(map, lp, image);
     }
 
-    if(status == MS_FAILURE) {
+    if (status == MS_FAILURE) {
       msFreeImage(image);
 #if defined(USE_WMS_LYR) || defined(USE_WFS_LYR)
       if (pasOWSReqInfo) {
@@ -571,27 +619,27 @@ imageObj *msDrawMap(mapObj *map, int que
         msFree(pasOWSReqInfo);
       }
 #endif /* USE_WMS_LYR || USE_WFS_LYR */
-      return(NULL);
+      return (NULL);
     }
 
-    if(map->debug >= MS_DEBUGLEVEL_TUNING || lp->debug >= MS_DEBUGLEVEL_TUNING) {
+    if (map->debug >= MS_DEBUGLEVEL_TUNING ||
+        lp->debug >= MS_DEBUGLEVEL_TUNING) {
       msGettimeofday(&endtime, NULL);
-      msDebug("msDrawMap(): Layer %d (%s), %.3fs\n",
-              map->layerorder[i], lp->name?lp->name:"(null)",
-              (endtime.tv_sec+endtime.tv_usec/1.0e6)-
-              (starttime.tv_sec+starttime.tv_usec/1.0e6) );
+      msDebug("msDrawMap(): Layer %d (%s), %.3fs\n", map->layerorder[i],
+              lp->name ? lp->name : "(null)",
+              (endtime.tv_sec + endtime.tv_usec / 1.0e6) -
+                  (starttime.tv_sec + starttime.tv_usec / 1.0e6));
     }
-
   }
 
   /* Do we need to fake out stuff for rotated support? */
   /* This really needs to be done on every preceeding exit point too... */
-  if(map->gt.need_geotransform)
+  if (map->gt.need_geotransform)
     msMapRestoreRealExtent(map);
 
-  if(map->legend.status == MS_EMBED && map->legend.postlabelcache)
-    if(MS_UNLIKELY(MS_FAILURE == msEmbedLegend(map, image))) {
-      msFreeImage( image );
+  if (map->legend.status == MS_EMBED && map->legend.postlabelcache)
+    if (MS_UNLIKELY(MS_FAILURE == msEmbedLegend(map, image))) {
+      msFreeImage(image);
 #if defined(USE_WMS_LYR) || defined(USE_WFS_LYR)
       /* Cleanup WMS/WFS Request stuff */
       if (pasOWSReqInfo) {
@@ -602,27 +650,26 @@ imageObj *msDrawMap(mapObj *map, int que
       return NULL;
     }
 
-  if(map->scalebar.status == MS_EMBED && map->scalebar.postlabelcache) {
+  if (map->scalebar.status == MS_EMBED && map->scalebar.postlabelcache) {
 
     /* We need to temporarily restore the original extent for drawing */
     /* the scalebar as it uses the extent to recompute cellsize. */
-    if(map->gt.need_geotransform)
+    if (map->gt.need_geotransform)
       msMapRestoreRealExtent(map);
 
-    if(MS_SUCCESS != msEmbedScalebar(map, image)) {
-      msFreeImage( image );
+    if (MS_SUCCESS != msEmbedScalebar(map, image)) {
+      msFreeImage(image);
 #if defined(USE_WMS_LYR) || defined(USE_WFS_LYR)
       /* Cleanup WMS/WFS Request stuff */
       if (pasOWSReqInfo) {
-         msHTTPFreeRequestObj(pasOWSReqInfo, numOWSRequests);
-         msFree(pasOWSReqInfo);
+        msHTTPFreeRequestObj(pasOWSReqInfo, numOWSRequests);
+        msFree(pasOWSReqInfo);
       }
 #endif
       return NULL;
     }
 
-
-    if(map->gt.need_geotransform)
+    if (map->gt.need_geotransform)
       msMapSetFakedExtent(map);
   }
 
@@ -634,162 +681,195 @@ imageObj *msDrawMap(mapObj *map, int que
   }
 #endif
 
-  if(map->debug >= MS_DEBUGLEVEL_TUNING) {
+  if (map->debug >= MS_DEBUGLEVEL_TUNING) {
     msGettimeofday(&mapendtime, NULL);
     msDebug("msDrawMap() total time: %.3fs\n",
-            (mapendtime.tv_sec+mapendtime.tv_usec/1.0e6)-
-            (mapstarttime.tv_sec+mapstarttime.tv_usec/1.0e6) );
+            (mapendtime.tv_sec + mapendtime.tv_usec / 1.0e6) -
+                (mapstarttime.tv_sec + mapstarttime.tv_usec / 1.0e6));
   }
 
-  return(image);
+  return (image);
 }
 
 /*
  * Test whether a layer should be drawn or not in the current map view and
  * at the current scale.
  * Returns TRUE if layer is visible, FALSE if not.
-*/
-int msLayerIsVisible(mapObj *map, layerObj *layer)
-{
+ */
+int msLayerIsVisible(mapObj *map, layerObj *layer) {
   int i;
 
-  if(!layer->data && !layer->tileindex && !layer->connection && !layer->features && !layer->grid)
-    return(MS_FALSE); /* no data associated with this layer, not an error since layer may be used as a template from MapScript */
-
-  if(layer->type == MS_LAYER_QUERY || layer->type == MS_LAYER_TILEINDEX) return(MS_FALSE);
-  if((layer->status != MS_ON) && (layer->status != MS_DEFAULT)) return(MS_FALSE);
+  if (!layer->data && !layer->tileindex && !layer->connection &&
+      !layer->features && !layer->grid)
+    return (MS_FALSE); /* no data associated with this layer, not an error since
+                          layer may be used as a template from MapScript */
+
+  if (layer->type == MS_LAYER_QUERY || layer->type == MS_LAYER_TILEINDEX)
+    return (MS_FALSE);
+  if ((layer->status != MS_ON) && (layer->status != MS_DEFAULT))
+    return (MS_FALSE);
 
   /* Do comparisons of layer scale vs map scale now, since msExtentsOverlap() */
   /* can be slow */
-  if(map->scaledenom > 0) {
+  if (map->scaledenom > 0) {
 
     /* layer scale boundaries should be checked first */
-    if((layer->maxscaledenom > 0) && (map->scaledenom > layer->maxscaledenom)) {
-      if( layer->debug >= MS_DEBUGLEVEL_V ) {
-        msDebug("msLayerIsVisible(): Skipping layer (%s) because LAYER.MAXSCALE is too small for this MAP scale\n", layer->name);
+    if ((layer->maxscaledenom > 0) &&
+        (map->scaledenom > layer->maxscaledenom)) {
+      if (layer->debug >= MS_DEBUGLEVEL_V) {
+        msDebug("msLayerIsVisible(): Skipping layer (%s) because "
+                "LAYER.MAXSCALE is too small for this MAP scale\n",
+                layer->name);
       }
-      return(MS_FALSE);
+      return (MS_FALSE);
     }
-    if(/*(layer->minscaledenom > 0) &&*/ (map->scaledenom <= layer->minscaledenom)) {
-      if( layer->debug >= MS_DEBUGLEVEL_V ) {
-        msDebug("msLayerIsVisible(): Skipping layer (%s) because LAYER.MINSCALE is too large for this MAP scale\n", layer->name);
+    if (/*(layer->minscaledenom > 0) &&*/ (map->scaledenom <=
+                                           layer->minscaledenom)) {
+      if (layer->debug >= MS_DEBUGLEVEL_V) {
+        msDebug("msLayerIsVisible(): Skipping layer (%s) because "
+                "LAYER.MINSCALE is too large for this MAP scale\n",
+                layer->name);
       }
-      return(MS_FALSE);
+      return (MS_FALSE);
     }
   }
 
-  /* Only return MS_FALSE if it is definitely false. Sometimes it will return MS_UNKNOWN, which we
-  ** consider true, for this use case (it might be visible, try and draw it, see what happens). */
-  if ( msExtentsOverlap(map, layer) == MS_FALSE ) {
-    if( layer->debug >= MS_DEBUGLEVEL_V ) {
-      msDebug("msLayerIsVisible(): Skipping layer (%s) because LAYER.EXTENT does not intersect MAP.EXTENT\n", layer->name);
+  /* Only return MS_FALSE if it is definitely false. Sometimes it will return
+   *MS_UNKNOWN, which we
+   ** consider true, for this use case (it might be visible, try and draw it,
+   *see what happens). */
+  if (msExtentsOverlap(map, layer) == MS_FALSE) {
+    if (layer->debug >= MS_DEBUGLEVEL_V) {
+      msDebug("msLayerIsVisible(): Skipping layer (%s) because LAYER.EXTENT "
+              "does not intersect MAP.EXTENT\n",
+              layer->name);
     }
-    return(MS_FALSE);
+    return (MS_FALSE);
   }
 
-  if(msEvalContext(map, layer, layer->requires) == MS_FALSE) return(MS_FALSE);
+  if (msEvalContext(map, layer, layer->requires) == MS_FALSE)
+    return (MS_FALSE);
 
-  if(map->scaledenom > 0) {
+  if (map->scaledenom > 0) {
 
     /* now check class scale boundaries (all layers *must* pass these tests) */
-    if(layer->numclasses > 0) {
-      for(i=0; i<layer->numclasses; i++) {
-        if((layer->class[i]->maxscaledenom > 0) && (map->scaledenom > layer->class[i]->maxscaledenom))
+    if (layer->numclasses > 0) {
+      for (i = 0; i < layer->numclasses; i++) {
+        if ((layer->class[i] -> maxscaledenom > 0) &&
+            (map->scaledenom > layer->class[i] -> maxscaledenom))
           continue; /* can skip this one, next class */
-        if((layer->class[i]->minscaledenom > 0) && (map->scaledenom <= layer->class[i]->minscaledenom))
+        if ((layer->class[i] -> minscaledenom > 0) &&
+            (map->scaledenom <= layer->class[i] -> minscaledenom))
           continue; /* can skip this one, next class */
 
         break; /* can't skip this class (or layer for that matter) */
       }
-      if(i == layer->numclasses) {
-        if( layer->debug >= MS_DEBUGLEVEL_V ) {
-          msDebug("msLayerIsVisible(): Skipping layer (%s) because no CLASS in the layer is in-scale for this MAP scale\n", layer->name);
+      if (i == layer->numclasses) {
+        if (layer->debug >= MS_DEBUGLEVEL_V) {
+          msDebug("msLayerIsVisible(): Skipping layer (%s) because no CLASS in "
+                  "the layer is in-scale for this MAP scale\n",
+                  layer->name);
         }
-        return(MS_FALSE);
+        return (MS_FALSE);
       }
     }
-
   }
 
   if (layer->maxscaledenom <= 0 && layer->minscaledenom <= 0) {
-    if((layer->maxgeowidth > 0) && ((map->extent.maxx - map->extent.minx) > layer->maxgeowidth)) {
-      if( layer->debug >= MS_DEBUGLEVEL_V ) {
-        msDebug("msLayerIsVisible(): Skipping layer (%s) because LAYER width is much smaller than map width\n", layer->name);
+    if ((layer->maxgeowidth > 0) &&
+        ((map->extent.maxx - map->extent.minx) > layer->maxgeowidth)) {
+      if (layer->debug >= MS_DEBUGLEVEL_V) {
+        msDebug("msLayerIsVisible(): Skipping layer (%s) because LAYER width "
+                "is much smaller than map width\n",
+                layer->name);
       }
-      return(MS_FALSE);
+      return (MS_FALSE);
     }
-    if((layer->mingeowidth > 0) && ((map->extent.maxx - map->extent.minx) < layer->mingeowidth)) {
-      if( layer->debug >= MS_DEBUGLEVEL_V ) {
-        msDebug("msLayerIsVisible(): Skipping layer (%s) because LAYER width is much larger than map width\n", layer->name);
+    if ((layer->mingeowidth > 0) &&
+        ((map->extent.maxx - map->extent.minx) < layer->mingeowidth)) {
+      if (layer->debug >= MS_DEBUGLEVEL_V) {
+        msDebug("msLayerIsVisible(): Skipping layer (%s) because LAYER width "
+                "is much larger than map width\n",
+                layer->name);
       }
-      return(MS_FALSE);
+      return (MS_FALSE);
     }
   }
 
-  return MS_TRUE;  /* All tests passed.  Layer is visible. */
+  return MS_TRUE; /* All tests passed.  Layer is visible. */
 }
 
-
-#define LAYER_NEEDS_COMPOSITING(layer) (((layer)->compositer != NULL) && ((layer)->compositer->next || (layer)->compositor->opacity < 100 || (layer)->compositor->compop != MS_COMPOP_SRC_OVER || (layer)->compositer->filter ))
+#define LAYER_NEEDS_COMPOSITING(layer)                                         \
+  (((layer)->compositer != NULL) &&                                            \
+   ((layer)->compositer->next || (layer)->compositor->opacity < 100 ||         \
+    (layer)->compositor->compop != MS_COMPOP_SRC_OVER ||                       \
+    (layer)->compositer->filter))
 /*
  * Generic function to render a layer object.
-*/
-int msDrawLayer(mapObj *map, layerObj *layer, imageObj *image)
-{
+ */
+int msDrawLayer(mapObj *map, layerObj *layer, imageObj *image) {
   imageObj *image_draw = image;
-  outputFormatObj *altFormat=NULL;
-  int retcode=MS_SUCCESS;
+  outputFormatObj *altFormat = NULL;
+  int retcode = MS_SUCCESS;
   const char *alternativeFomatString = NULL;
   layerObj *maskLayer = NULL;
 
-  if(!msLayerIsVisible(map, layer))
+  if (!msLayerIsVisible(map, layer))
     return MS_SUCCESS;
 
-  if(layer->compositer && !layer->compositer->next && layer->compositer->opacity == 0) return MS_SUCCESS; /* layer is completely transparent, skip it */
-  
+  if (layer->compositer && !layer->compositer->next &&
+      layer->compositer->opacity == 0)
+    return MS_SUCCESS; /* layer is completely transparent, skip it */
 
   /* conditions may have changed since this layer last drawn, so retest
      layer->project (Bug #673) */
-  layer->project = msProjectionsDiffer(&(layer->projection),&(map->projection));
+  layer->project =
+      msProjectionsDiffer(&(layer->projection), &(map->projection));
 
-  /* make sure labelcache setting is set correctly if postlabelcache is set. This is done by the parser but
-     may have been altered by a mapscript. see #5142 */
-  if(layer->postlabelcache) {
+  /* make sure labelcache setting is set correctly if postlabelcache is set.
+     This is done by the parser but may have been altered by a mapscript. see
+     #5142 */
+  if (layer->postlabelcache) {
     layer->labelcache = MS_FALSE;
   }
 
-  if(layer->mask) {
+  if (layer->mask) {
     int maskLayerIdx;
     /* render the mask layer in its own imageObj */
-    if(!MS_IMAGE_RENDERER(image)->supports_pixel_buffer) {
-      msSetError(MS_MISCERR, "Layer (%s) references references a mask layer, but the selected renderer does not support them", "msDrawLayer()",
-                 layer->name);
+    if (!MS_IMAGE_RENDERER(image)->supports_pixel_buffer) {
+      msSetError(MS_MISCERR,
+                 "Layer (%s) references references a mask layer, but the "
+                 "selected renderer does not support them",
+                 "msDrawLayer()", layer->name);
       return (MS_FAILURE);
     }
-    maskLayerIdx = msGetLayerIndex(map,layer->mask);
-    if(maskLayerIdx == -1) {
-      msSetError(MS_MISCERR, "Layer (%s) references unknown mask layer (%s)", "msDrawLayer()",
-                 layer->name,layer->mask);
+    maskLayerIdx = msGetLayerIndex(map, layer->mask);
+    if (maskLayerIdx == -1) {
+      msSetError(MS_MISCERR, "Layer (%s) references unknown mask layer (%s)",
+                 "msDrawLayer()", layer->name, layer->mask);
       return (MS_FAILURE);
     }
     maskLayer = GET_LAYER(map, maskLayerIdx);
-    if(!maskLayer->maskimage) {
+    if (!maskLayer->maskimage) {
       int i;
       int origstatus, origlabelcache;
-      altFormat =  msSelectOutputFormat(map, "png24");
+      altFormat = msSelectOutputFormat(map, "png24");
       msInitializeRendererVTable(altFormat);
-      /* TODO: check the png24 format hasn't been tampered with, i.e. it's agg */
-      maskLayer->maskimage= msImageCreate(image->width, image->height,altFormat,
-                                          image->imagepath, image->imageurl, map->resolution, map->defresolution, NULL);
+      /* TODO: check the png24 format hasn't been tampered with, i.e. it's agg
+       */
+      maskLayer->maskimage = msImageCreate(
+          image->width, image->height, altFormat, image->imagepath,
+          image->imageurl, map->resolution, map->defresolution, NULL);
       if (!maskLayer->maskimage) {
-        msSetError(MS_MISCERR, "Unable to initialize mask image.", "msDrawLayer()");
+        msSetError(MS_MISCERR, "Unable to initialize mask image.",
+                   "msDrawLayer()");
         return (MS_FAILURE);
       }
 
       /*
-       * force the masked layer to status on, and turn off the labelcache so that
-       * eventual labels are added to the temporary image instead of being added
-       * to the labelcache
+       * force the masked layer to status on, and turn off the labelcache so
+       * that eventual labels are added to the temporary image instead of being
+       * added to the labelcache
        */
       origstatus = maskLayer->status;
       origlabelcache = maskLayer->labelcache;
@@ -800,79 +880,85 @@ int msDrawLayer(mapObj *map, layerObj *l
       retcode = msDrawLayer(map, maskLayer, maskLayer->maskimage);
       maskLayer->status = origstatus;
       maskLayer->labelcache = origlabelcache;
-      if(retcode != MS_SUCCESS) {
+      if (retcode != MS_SUCCESS) {
         return MS_FAILURE;
       }
       /*
-       * hack to work around bug #3834: if we have use an alternate renderer, the symbolset may contain
-       * symbols that reference it. We want to remove those references before the altFormat is destroyed
-       * to avoid a segfault and/or a leak, and so the the main renderer doesn't pick the cache up thinking
-       * it's for him.
+       * hack to work around bug #3834: if we have use an alternate renderer,
+       * the symbolset may contain symbols that reference it. We want to remove
+       * those references before the altFormat is destroyed to avoid a segfault
+       * and/or a leak, and so the the main renderer doesn't pick the cache up
+       * thinking it's for him.
        */
-      for(i=0; i<map->symbolset.numsymbols; i++) {
-        if (map->symbolset.symbol[i]!=NULL) {
+      for (i = 0; i < map->symbolset.numsymbols; i++) {
+        if (map->symbolset.symbol[i] != NULL) {
           symbolObj *s = map->symbolset.symbol[i];
-          if(s->renderer == MS_IMAGE_RENDERER(maskLayer->maskimage)) {
+          if (s->renderer == MS_IMAGE_RENDERER(maskLayer->maskimage)) {
             MS_IMAGE_RENDERER(maskLayer->maskimage)->freeSymbol(s);
             s->renderer = NULL;
           }
         }
       }
-      /* set the imagetype from the original outputformat back (it was removed by msSelectOutputFormat() */
+      /* set the imagetype from the original outputformat back (it was removed
+       * by msSelectOutputFormat() */
       msFree(map->imagetype);
       map->imagetype = msStrdup(image->format->name);
     }
-
   }
   altFormat = NULL;
   /* inform the rendering device that layer draw is starting. */
   msImageStartLayer(map, layer, image);
 
-
   /*check if an alternative renderer should be used for this layer*/
-  alternativeFomatString = msLayerGetProcessingKey( layer, "RENDERER");
-  if (MS_RENDERER_PLUGIN(image_draw->format) && alternativeFomatString!=NULL &&
-      (altFormat=  msSelectOutputFormat(map, alternativeFomatString))) {
-    rendererVTableObj *renderer=NULL;
+  alternativeFomatString = msLayerGetProcessingKey(layer, "RENDERER");
+  if (MS_RENDERER_PLUGIN(image_draw->format) &&
+      alternativeFomatString != NULL &&
+      (altFormat = msSelectOutputFormat(map, alternativeFomatString))) {
+    rendererVTableObj *renderer = NULL;
     msInitializeRendererVTable(altFormat);
 
-    image_draw = msImageCreate(image->width, image->height,
-                               altFormat, image->imagepath, image->imageurl, map->resolution, map->defresolution, &map->imagecolor);
+    image_draw = msImageCreate(
+        image->width, image->height, altFormat, image->imagepath,
+        image->imageurl, map->resolution, map->defresolution, &map->imagecolor);
     renderer = MS_IMAGE_RENDERER(image_draw);
-    renderer->startLayer(image_draw,map,layer);
+    renderer->startLayer(image_draw, map, layer);
   } else if (MS_RENDERER_PLUGIN(image_draw->format)) {
     rendererVTableObj *renderer = MS_IMAGE_RENDERER(image_draw);
-    if ((layer->mask && layer->connectiontype!=MS_WMS && layer->type != MS_LAYER_RASTER) || layer->compositer) {
-      /* masking occurs at the pixel/layer level for raster images, so we don't need to create a temporary image
-       in these cases
+    if ((layer->mask && layer->connectiontype != MS_WMS &&
+         layer->type != MS_LAYER_RASTER) ||
+        layer->compositer) {
+      /* masking occurs at the pixel/layer level for raster images, so we don't
+       need to create a temporary image in these cases
        */
       if (layer->mask || renderer->compositeRasterBuffer) {
-        image_draw = msImageCreate(image->width, image->height,
-                                   image->format, image->imagepath, image->imageurl, map->resolution, map->defresolution, NULL);
+        image_draw = msImageCreate(image->width, image->height, image->format,
+                                   image->imagepath, image->imageurl,
+                                   map->resolution, map->defresolution, NULL);
         if (!image_draw) {
-          msSetError(MS_MISCERR, "Unable to initialize temporary transparent image.",
+          msSetError(MS_MISCERR,
+                     "Unable to initialize temporary transparent image.",
                      "msDrawLayer()");
           return (MS_FAILURE);
         }
         image_draw->map = map;
-        renderer->startLayer(image_draw,map,layer);
+        renderer->startLayer(image_draw, map, layer);
       }
     }
   }
   /*
   ** redirect procesing of some layer types.
   */
-  if(layer->connectiontype == MS_WMS) {
+  if (layer->connectiontype == MS_WMS) {
 #ifdef USE_WMS_LYR
     retcode = msDrawWMSLayer(map, layer, image_draw);
 #else
     retcode = MS_FAILURE;
 #endif
-  } else if(layer->type == MS_LAYER_RASTER) {
+  } else if (layer->type == MS_LAYER_RASTER) {
     retcode = msDrawRasterLayer(map, layer, image_draw);
-  } else if(layer->type == MS_LAYER_CHART) {
+  } else if (layer->type == MS_LAYER_CHART) {
     retcode = msDrawChartLayer(map, layer, image_draw);
-  } else {   /* must be a Vector layer */
+  } else { /* must be a Vector layer */
     retcode = msDrawVectorLayer(map, layer, image_draw);
   }
 
@@ -881,226 +967,230 @@ int msDrawLayer(mapObj *map, layerObj *l
     rendererVTableObj *altrenderer = MS_IMAGE_RENDERER(image_draw);
     rasterBufferObj rb;
     int i;
-    memset(&rb,0,sizeof(rasterBufferObj));
+    memset(&rb, 0, sizeof(rasterBufferObj));
 
-    altrenderer->endLayer(image_draw,map,layer);
+    altrenderer->endLayer(image_draw, map, layer);
 
-    retcode = altrenderer->getRasterBufferHandle(image_draw,&rb);
-    if(MS_UNLIKELY(retcode == MS_FAILURE)) {
+    retcode = altrenderer->getRasterBufferHandle(image_draw, &rb);
+    if (MS_UNLIKELY(retcode == MS_FAILURE)) {
       goto altformat_cleanup;
     }
-    retcode = renderer->mergeRasterBuffer(image,&rb,((layer->compositer)?(layer->compositer->opacity*0.01):(1.0)),0,0,0,0,rb.width,rb.height);
-    if(MS_UNLIKELY(retcode == MS_FAILURE)) {
+    retcode = renderer->mergeRasterBuffer(
+        image, &rb,
+        ((layer->compositer) ? (layer->compositer->opacity * 0.01) : (1.0)), 0,
+        0, 0, 0, rb.width, rb.height);
+    if (MS_UNLIKELY(retcode == MS_FAILURE)) {
       goto altformat_cleanup;
     }
 
-altformat_cleanup:
+  altformat_cleanup:
     /*
-     * hack to work around bug #3834: if we have use an alternate renderer, the symbolset may contain
-     * symbols that reference it. We want to remove those references before the altFormat is destroyed
-     * to avoid a segfault and/or a leak, and so the the main renderer doesn't pick the cache up thinking
+     * hack to work around bug #3834: if we have use an alternate renderer, the
+     * symbolset may contain symbols that reference it. We want to remove those
+     * references before the altFormat is destroyed to avoid a segfault and/or a
+     * leak, and so the the main renderer doesn't pick the cache up thinking
      * it's for him.
      */
-    for(i=0; i<map->symbolset.numsymbols; i++) {
-      if (map->symbolset.symbol[i]!=NULL) {
+    for (i = 0; i < map->symbolset.numsymbols; i++) {
+      if (map->symbolset.symbol[i] != NULL) {
         symbolObj *s = map->symbolset.symbol[i];
-        if(s->renderer == altrenderer) {
+        if (s->renderer == altrenderer) {
           altrenderer->freeSymbol(s);
           s->renderer = NULL;
         }
       }
     }
     msFreeImage(image_draw);
-    /* set the imagetype from the original outputformat back (it was removed by msSelectOutputFormat() */
+    /* set the imagetype from the original outputformat back (it was removed by
+     * msSelectOutputFormat() */
     msFree(map->imagetype);
     map->imagetype = msStrdup(image->format->name);
-  } else if( image != image_draw) {
+  } else if (image != image_draw) {
     rendererVTableObj *renderer = MS_IMAGE_RENDERER(image_draw);
     rasterBufferObj rb;
-    memset(&rb,0,sizeof(rasterBufferObj));
+    memset(&rb, 0, sizeof(rasterBufferObj));
 
-    renderer->endLayer(image_draw,map,layer);
+    renderer->endLayer(image_draw, map, layer);
 
-    retcode = renderer->getRasterBufferHandle(image_draw,&rb);
-    if(MS_UNLIKELY(retcode == MS_FAILURE)) {
+    retcode = renderer->getRasterBufferHandle(image_draw, &rb);
+    if (MS_UNLIKELY(retcode == MS_FAILURE)) {
       goto imagedraw_cleanup;
     }
-    if(maskLayer && maskLayer->maskimage) {
+    if (maskLayer && maskLayer->maskimage) {
       rasterBufferObj mask;
-      unsigned int row,col;
-      memset(&mask,0,sizeof(rasterBufferObj));
-      retcode = MS_IMAGE_RENDERER(maskLayer->maskimage)->getRasterBufferHandle(maskLayer->maskimage,&mask);
-      if(MS_UNLIKELY(retcode == MS_FAILURE)) {
+      unsigned int row, col;
+      memset(&mask, 0, sizeof(rasterBufferObj));
+      retcode = MS_IMAGE_RENDERER(maskLayer->maskimage)
+                    ->getRasterBufferHandle(maskLayer->maskimage, &mask);
+      if (MS_UNLIKELY(retcode == MS_FAILURE)) {
         goto imagedraw_cleanup;
       }
       /* modify the pixels of the overlay */
 
-      if(rb.type == MS_BUFFER_BYTE_RGBA) {
-        for(row=0; row<rb.height; row++) {
-          unsigned char *ma,*a,*r,*g,*b;
-          r=rb.data.rgba.r+row*rb.data.rgba.row_step;
-          g=rb.data.rgba.g+row*rb.data.rgba.row_step;
-          b=rb.data.rgba.b+row*rb.data.rgba.row_step;
-          a=rb.data.rgba.a+row*rb.data.rgba.row_step;
-          ma=mask.data.rgba.a+row*mask.data.rgba.row_step;
-          for(col=0; col<rb.width; col++) {
-            if(*ma == 0) {
+      if (rb.type == MS_BUFFER_BYTE_RGBA) {
+        for (row = 0; row < rb.height; row++) {
+          unsigned char *ma, *a, *r, *g, *b;
+          r = rb.data.rgba.r + row * rb.data.rgba.row_step;
+          g = rb.data.rgba.g + row * rb.data.rgba.row_step;
+          b = rb.data.rgba.b + row * rb.data.rgba.row_step;
+          a = rb.data.rgba.a + row * rb.data.rgba.row_step;
+          ma = mask.data.rgba.a + row * mask.data.rgba.row_step;
+          for (col = 0; col < rb.width; col++) {
+            if (*ma == 0) {
               *a = *r = *g = *b = 0;
             }
-            a+=rb.data.rgba.pixel_step;
-            r+=rb.data.rgba.pixel_step;
-            g+=rb.data.rgba.pixel_step;
-            b+=rb.data.rgba.pixel_step;
-            ma+=mask.data.rgba.pixel_step;
+            a += rb.data.rgba.pixel_step;
+            r += rb.data.rgba.pixel_step;
+            g += rb.data.rgba.pixel_step;
+            b += rb.data.rgba.pixel_step;
+            ma += mask.data.rgba.pixel_step;
           }
         }
       }
     }
-    if(!layer->compositer) {
-      /*we have a mask layer with no composition configured, do a nomral blend */
-      retcode = renderer->mergeRasterBuffer(image,&rb,1.0,0,0,0,0,rb.width,rb.height);
+    if (!layer->compositer) {
+      /*we have a mask layer with no composition configured, do a nomral blend
+       */
+      retcode = renderer->mergeRasterBuffer(image, &rb, 1.0, 0, 0, 0, 0,
+                                            rb.width, rb.height);
     } else {
-      retcode = msCompositeRasterBuffer(map,image,&rb,layer->compositer);
+      retcode = msCompositeRasterBuffer(map, image, &rb, layer->compositer);
     }
-    if(MS_UNLIKELY(retcode == MS_FAILURE)) {
+    if (MS_UNLIKELY(retcode == MS_FAILURE)) {
       goto imagedraw_cleanup;
     }
 
-imagedraw_cleanup:
+  imagedraw_cleanup:
     msFreeImage(image_draw);
   }
 
-  msImageEndLayer(map,layer,image);
-  return(retcode);
+  msImageEndLayer(map, layer, image);
+  return (retcode);
 }
 
-int msDrawVectorLayer(mapObj *map, layerObj *layer, imageObj *image)
-{
-  int         status, retcode=MS_SUCCESS;
-  int         drawmode=MS_DRAWMODE_FEATURES;
-  char        annotate=MS_TRUE;
-  shapeObj    shape;
-  shapeObj    savedShape;
-  rectObj     searchrect;
-  char        cache=MS_FALSE;
-  int         maxnumstyles=1;
-  featureListNodeObjPtr shpcache=NULL, current=NULL;
+int msDrawVectorLayer(mapObj *map, layerObj *layer, imageObj *image) {
+  int status, retcode = MS_SUCCESS;
+  int drawmode = MS_DRAWMODE_FEATURES;
+  char annotate = MS_TRUE;
+  shapeObj shape;
+  shapeObj savedShape;
+  rectObj searchrect;
+  char cache = MS_FALSE;
+  int maxnumstyles = 1;
+  featureListNodeObjPtr shpcache = NULL, current = NULL;
   int nclasses = 0;
   int *classgroup = NULL;
   double minfeaturesize = -1;
-  int maxfeatures=-1;
-  int featuresdrawn=0;
+  int maxfeatures = -1;
+  int featuresdrawn = 0;
 
   if (image)
-    maxfeatures=msLayerGetMaxFeaturesToDraw(layer, image->format);
+    maxfeatures = msLayerGetMaxFeaturesToDraw(layer, image->format);
 
   /* TODO TBT: draw as raster layer in vector renderers */
 
   annotate = msEvalContext(map, layer, layer->labelrequires);
-  if(map->scaledenom > 0) {
-    if((layer->labelmaxscaledenom != -1) && (map->scaledenom >= layer->labelmaxscaledenom)) annotate = MS_FALSE;
-    if((layer->labelminscaledenom != -1) && (map->scaledenom < layer->labelminscaledenom)) annotate = MS_FALSE;
+  if (map->scaledenom > 0) {
+    if ((layer->labelmaxscaledenom != -1) &&
+        (map->scaledenom >= layer->labelmaxscaledenom))
+      annotate = MS_FALSE;
+    if ((layer->labelminscaledenom != -1) &&
+        (map->scaledenom < layer->labelminscaledenom))
+      annotate = MS_FALSE;
   }
 
   /* open this layer */
   status = msLayerOpen(layer);
-  if(status != MS_SUCCESS) return MS_FAILURE;
+  if (status != MS_SUCCESS)
+    return MS_FAILURE;
 
   /* build item list. STYLEITEM javascript needs the shape attributes */
-  if (layer->styleitem && (strncasecmp(layer->styleitem, "javascript://", 13) == 0)) {  
+  if (layer->styleitem &&
+      (strncasecmp(layer->styleitem, "javascript://", 13) == 0)) {
     status = msLayerWhichItems(layer, MS_TRUE, NULL);
   } else {
     status = msLayerWhichItems(layer, MS_FALSE, NULL);
   }
 
-  if(status != MS_SUCCESS) {
+  if (status != MS_SUCCESS) {
     msLayerClose(layer);
     return MS_FAILURE;
   }
 
   /* identify target shapes */
-  if(layer->transform == MS_TRUE) {
+  if (layer->transform == MS_TRUE) {
     searchrect = map->extent;
 
-    if((map->projection.numargs > 0) && (layer->projection.numargs > 0)) {
+    if ((map->projection.numargs > 0) && (layer->projection.numargs > 0)) {
       int bDone = MS_FALSE;
 
-      if( layer->connectiontype == MS_UVRASTER )
-      {
-          /* Nasty hack to make msUVRASTERLayerWhichShapes() aware that the */
-          /* original area of interest is (map->extent, map->projection)... */
-          /* Useful when dealin with UVRASTER that extend beyond 180 deg */
-          msUVRASTERLayerUseMapExtentAndProjectionForNextWhichShapes( layer, map );
-
-          searchrect = msUVRASTERGetSearchRect( layer, map );
-          bDone = MS_TRUE;
+      if (layer->connectiontype == MS_UVRASTER) {
+        /* Nasty hack to make msUVRASTERLayerWhichShapes() aware that the */
+        /* original area of interest is (map->extent, map->projection)... */
+        /* Useful when dealin with UVRASTER that extend beyond 180 deg */
+        msUVRASTERLayerUseMapExtentAndProjectionForNextWhichShapes(layer, map);
+
+        searchrect = msUVRASTERGetSearchRect(layer, map);
+        bDone = MS_TRUE;
       }
 
-      if( !bDone )
-        msProjectRect(&map->projection, &layer->projection, &searchrect); /* project the searchrect to source coords */
+      if (!bDone)
+        msProjectRect(
+            &map->projection, &layer->projection,
+            &searchrect); /* project the searchrect to source coords */
     }
 
   } else {
     searchrect.minx = searchrect.miny = 0;
-    searchrect.maxx = map->width-1;
-    searchrect.maxy = map->height-1;
+    searchrect.maxx = map->width - 1;
+    searchrect.maxy = map->height - 1;
   }
 
   status = msLayerWhichShapes(layer, searchrect, MS_FALSE);
 
-  if( layer->connectiontype == MS_UVRASTER )
-  {
-    msUVRASTERLayerUseMapExtentAndProjectionForNextWhichShapes( layer, NULL );
+  if (layer->connectiontype == MS_UVRASTER) {
+    msUVRASTERLayerUseMapExtentAndProjectionForNextWhichShapes(layer, NULL);
   }
 
-  if(status == MS_DONE) { /* no overlap */
+  if (status == MS_DONE) { /* no overlap */
     msLayerClose(layer);
     return MS_SUCCESS;
-  } else if(status != MS_SUCCESS) {
+  } else if (status != MS_SUCCESS) {
     msLayerClose(layer);
     return MS_FAILURE;
   }
 
   nclasses = 0;
   classgroup = NULL;
-  if(layer->classgroup && layer->numclasses > 0)
+  if (layer->classgroup && layer->numclasses > 0)
     classgroup = msAllocateValidClassGroups(layer, &nclasses);
 
-  if(layer->minfeaturesize > 0)
+  if (layer->minfeaturesize > 0)
     minfeaturesize = Pix2LayerGeoref(map, layer, layer->minfeaturesize);
 
   // Select how to render classes
   //    MS_FIRST_MATCHING_CLASS: Default and historic MapServer behavior
   //    MS_ALL_MATCHING_CLASSES: SLD behavior
   int ref_rendermode;
-  const char * rendermodestr = msLayerGetProcessingKey(layer, "RENDERMODE");
-  if (layer->rendermode == MS_ALL_MATCHING_CLASSES)
-  {
+  const char *rendermodestr = msLayerGetProcessingKey(layer, "RENDERMODE");
+  if (layer->rendermode == MS_ALL_MATCHING_CLASSES) {
     // SLD takes precedence
     ref_rendermode = MS_ALL_MATCHING_CLASSES;
-  }
-  else if (!rendermodestr)
-  {
+  } else if (!rendermodestr) {
     // Default Mapfile
     ref_rendermode = MS_FIRST_MATCHING_CLASS;
-  }
-  else if (!strcmp(rendermodestr,"FIRST_MATCHING_CLASS"))
-  {
+  } else if (!strcmp(rendermodestr, "FIRST_MATCHING_CLASS")) {
     // Explicit default Mapfile
     ref_rendermode = MS_FIRST_MATCHING_CLASS;
-  }
-  else if (!strcmp(rendermodestr,"ALL_MATCHING_CLASSES"))
-  {
+  } else if (!strcmp(rendermodestr, "ALL_MATCHING_CLASSES")) {
     // SLD-like Mapfile
     ref_rendermode = MS_ALL_MATCHING_CLASSES;
-  }
-  else
-  {
+  } else {
     msLayerClose(layer);
     msSetError(MS_MISCERR,
-    "Unknown RENDERMODE: %s, should be one of: FIRST_MATCHING_CLASS, ALL_MATCHING_CLASSES.",
-    "msDrawVectorLayer()",
-    rendermodestr);
+               "Unknown RENDERMODE: %s, should be one of: "
+               "FIRST_MATCHING_CLASS, ALL_MATCHING_CLASSES.",
+               "msDrawVectorLayer()", rendermodestr);
     return MS_FAILURE;
   }
 
@@ -1118,63 +1208,78 @@ int msDrawVectorLayer(mapObj *map, layer
       }
 
       /* Check if the shape size is ok to be drawn */
-      if((shape.type == MS_SHAPE_LINE || shape.type == MS_SHAPE_POLYGON) && (minfeaturesize > 0) && (msShapeCheckSize(&shape, minfeaturesize) == MS_FALSE)) {
-        if(layer->debug >= MS_DEBUGLEVEL_V)
-          msDebug("msDrawVectorLayer(): Skipping shape (%ld) because LAYER::MINFEATURESIZE is bigger than shape size\n", shape.index);
+      if ((shape.type == MS_SHAPE_LINE || shape.type == MS_SHAPE_POLYGON) &&
+          (minfeaturesize > 0) &&
+          (msShapeCheckSize(&shape, minfeaturesize) == MS_FALSE)) {
+        if (layer->debug >= MS_DEBUGLEVEL_V)
+          msDebug("msDrawVectorLayer(): Skipping shape (%ld) because "
+                  "LAYER::MINFEATURESIZE is bigger than shape size\n",
+                  shape.index);
         continue;
       }
       classcount = 0;
     }
 
-    classindex = msShapeGetNextClass(classindex, layer, map, &shape, classgroup, nclasses);
-    if((classindex == -1) || (layer->class[classindex]->status == MS_OFF)) {
+    classindex = msShapeGetNextClass(classindex, layer, map, &shape, classgroup,
+                                     nclasses);
+    if ((classindex == -1) || (layer->class[classindex] -> status == MS_OFF)) {
       continue;
     }
     shape.classindex = classindex;
 
-    // When only one class is applicable, rendering mode is forced to its default,
-    // i.e. only the first applicable class is actually applied. As a consequence,
-    // cache can be enabled when relevant.
+    // When only one class is applicable, rendering mode is forced to its
+    // default, i.e. only the first applicable class is actually applied. As a
+    // consequence, cache can be enabled when relevant.
     classcount++;
     rendermode = ref_rendermode;
-    if ((classcount == 1) && (msShapeGetNextClass(classindex, layer, map, &shape, classgroup, nclasses) == -1))
-    {
+    if ((classcount == 1) &&
+        (msShapeGetNextClass(classindex, layer, map, &shape, classgroup,
+                             nclasses) == -1)) {
       rendermode = MS_FIRST_MATCHING_CLASS;
     }
 
-    if (rendermode == MS_FIRST_MATCHING_CLASS)
-    {
+    if (rendermode == MS_FIRST_MATCHING_CLASS) {
       classindex = -1;
     }
 
-    if(maxfeatures >=0 && featuresdrawn >= maxfeatures) {
+    if (maxfeatures >= 0 && featuresdrawn >= maxfeatures) {
       status = MS_DONE;
       break;
     }
     featuresdrawn++;
 
     cache = MS_FALSE;
-    if(layer->type == MS_LAYER_LINE && (layer->class[shape.classindex]->numstyles > 1 || (layer->class[shape.classindex]->numstyles == 1 && layer->class[shape.classindex]->styles[0]->outlinewidth > 0))) {
+    if (layer->type == MS_LAYER_LINE &&
+        (layer->class[shape.classindex]
+         -> numstyles > 1 ||
+                (layer->class[shape.classindex] -> numstyles == 1 && layer
+                 -> class[shape.classindex] -> styles[0] -> outlinewidth >
+                                                                0))) {
       int i;
-      cache = MS_TRUE; /* only line layers with multiple styles need be cached (I don't think POLYLINE layers need caching - SDL) */
+      cache = MS_TRUE; /* only line layers with multiple styles need be cached
+                          (I don't think POLYLINE layers need caching - SDL) */
 
-      /* we can't handle caching with attribute binding other than for the first style (#3976) */
-      for(i=1; i<layer->class[shape.classindex]->numstyles; i++) {
-        if(layer->class[shape.classindex]->styles[i]->numbindings > 0) cache = MS_FALSE;
+      /* we can't handle caching with attribute binding other than for the first
+       * style (#3976) */
+      for (i = 1; i < layer->class[shape.classindex] -> numstyles; i++) {
+        if (layer->class[shape.classindex] -> styles[i] -> numbindings > 0)
+          cache = MS_FALSE;
       }
     }
 
     /* With 'STYLEITEM AUTO', we will have the datasource fill the class' */
     /* style parameters for this shape. */
-    if(layer->styleitem) {
-      if(strcasecmp(layer->styleitem, "AUTO") == 0) {
-        if(msLayerGetAutoStyle(map, layer, layer->class[shape.classindex], &shape) != MS_SUCCESS) {
+    if (layer->styleitem) {
+      if (strcasecmp(layer->styleitem, "AUTO") == 0) {
+        if (msLayerGetAutoStyle(map, layer, layer->class[shape.classindex],
+                                &shape) != MS_SUCCESS) {
           retcode = MS_FAILURE;
           break;
         }
       } else {
         /* Generic feature style handling as per RFC-61 */
-        if(msLayerGetFeatureStyle(map, layer, layer->class[shape.classindex], &shape) != MS_SUCCESS) {
+        if (msLayerGetFeatureStyle(map, layer, layer->class[shape.classindex],
+                                   &shape) != MS_SUCCESS) {
           retcode = MS_FAILURE;
           break;
         }
@@ -1184,31 +1289,31 @@ int msDrawVectorLayer(mapObj *map, layer
       cache = MS_FALSE;
     }
 
-    if (rendermode == MS_ALL_MATCHING_CLASSES)
-    {
+    if (rendermode == MS_ALL_MATCHING_CLASSES) {
       // Cache is designed to handle only one class. Therefore it is
       // disabled when using SLD "painters model" rendering mode.
       cache = MS_FALSE;
     }
 
-    /* RFC77 TODO: check return value, may need a more sophisticated if-then test. */
-    if(annotate && layer->class[shape.classindex]->numlabels > 0) {
+    /* RFC77 TODO: check return value, may need a more sophisticated if-then
+     * test. */
+    if (annotate && layer->class[shape.classindex] -> numlabels > 0) {
       drawmode |= MS_DRAWMODE_LABELS;
       if (msLayerGetProcessingKey(layer, "LABEL_NO_CLIP")) {
         drawmode |= MS_DRAWMODE_UNCLIPPEDLABELS;
       }
     }
 
-    if (layer->type == MS_LAYER_LINE && msLayerGetProcessingKey(layer, "POLYLINE_NO_CLIP")) {
+    if (layer->type == MS_LAYER_LINE &&
+        msLayerGetProcessingKey(layer, "POLYLINE_NO_CLIP")) {
       drawmode |= MS_DRAWMODE_UNCLIPPEDLINES;
     }
 
-    if (rendermode == MS_ALL_MATCHING_CLASSES)
-    {
-      // In SLD "painters model" rendering mode, all applicable classes are actually applied.
-      // Coordinates stored in the shape must keep their original values for
-      // the shape to be drawn multiple times.
-      // Here the original shape is saved.
+    if (rendermode == MS_ALL_MATCHING_CLASSES) {
+      // In SLD "painters model" rendering mode, all applicable classes are
+      // actually applied. Coordinates stored in the shape must keep their
+      // original values for the shape to be drawn multiple times. Here the
+      // original shape is saved.
       msInitShape(&savedShape);
       msCopyShape(&shape, &savedShape);
     }
@@ -1224,86 +1329,95 @@ int msDrawVectorLayer(mapObj *map, layer
          *  - draw the shape (the outline) in the first pass of the
          *    caching mechanism
          */
-	msOutlineRenderingPrepareStyle(pStyle, map, layer, image);
+        msOutlineRenderingPrepareStyle(pStyle, map, layer, image);
       }
-      status = msDrawShape(map, layer, &shape, image, 0, drawmode|MS_DRAWMODE_SINGLESTYLE); /* draw a single style */
+      status = msDrawShape(
+          map, layer, &shape, image, 0,
+          drawmode | MS_DRAWMODE_SINGLESTYLE); /* draw a single style */
       if (pStyle->outlinewidth > 0) {
         /*
          * RFC 49 implementation: switch back the styleobj to its
          * original state, so the line fill will be drawn in the
          * second pass of the caching mechanism
          */
-	msOutlineRenderingRestoreStyle(pStyle, map, layer, image);
+        msOutlineRenderingRestoreStyle(pStyle, map, layer, image);
       }
     }
 
     else
-      status = msDrawShape(map, layer, &shape, image, -1, drawmode); /* all styles  */
+      status =
+          msDrawShape(map, layer, &shape, image, -1, drawmode); /* all styles */
 
-    if (rendermode == MS_ALL_MATCHING_CLASSES)
-    {
-      // In SLD "painters model" rendering mode, all applicable classes are actually applied.
-      // Coordinates stored in the shape must keep their original values for
-      // the shape to be drawn multiple times.
-      // Here the original shape is restored.
+    if (rendermode == MS_ALL_MATCHING_CLASSES) {
+      // In SLD "painters model" rendering mode, all applicable classes are
+      // actually applied. Coordinates stored in the shape must keep their
+      // original values for the shape to be drawn multiple times. Here the
+      // original shape is restored.
       msFreeShape(&shape);
       msCopyShape(&savedShape, &shape);
       msFreeShape(&savedShape);
     }
 
-    if(status != MS_SUCCESS) {
+    if (status != MS_SUCCESS) {
       retcode = MS_FAILURE;
       break;
     }
-    
-    if(shape.numlines == 0) { /* once clipped the shape didn't need to be drawn */
+
+    if (shape.numlines ==
+        0) { /* once clipped the shape didn't need to be drawn */
       continue;
     }
 
-    if(cache) {
-      if(insertFeatureList(&shpcache, &shape) == NULL) {
+    if (cache) {
+      if (insertFeatureList(&shpcache, &shape) == NULL) {
         retcode = MS_FAILURE; /* problem adding to the cache */
         break;
       }
     }
 
-    maxnumstyles = MS_MAX(maxnumstyles, layer->class[shape.classindex]->numstyles);
-
+    maxnumstyles =
+        MS_MAX(maxnumstyles, layer->class[shape.classindex] -> numstyles);
   }
   msFreeShape(&shape);
 
   if (classgroup)
     msFree(classgroup);
 
-  if(status != MS_DONE || retcode == MS_FAILURE) {
+  if (status != MS_DONE || retcode == MS_FAILURE) {
     msLayerClose(layer);
-    if(shpcache) {
+    if (shpcache) {
       freeFeatureList(shpcache);
       shpcache = NULL;
     }
     return MS_FAILURE;
   }
 
-  if(shpcache && MS_DRAW_FEATURES(drawmode)) {
+  if (shpcache && MS_DRAW_FEATURES(drawmode)) {
     int s;
-    for(s=0; s<maxnumstyles; s++) {
-      for(current=shpcache; current; current=current->next) {
-        if(layer->class[current->shape.classindex]->numstyles > s) {
+    for (s = 0; s < maxnumstyles; s++) {
+      for (current = shpcache; current; current = current->next) {
+        if (layer->class[current->shape.classindex] -> numstyles > s) {
           styleObj *pStyle = layer->class[current->shape.classindex]->styles[s];
-          if(pStyle->_geomtransform.type != MS_GEOMTRANSFORM_NONE)
+          if (pStyle->_geomtransform.type != MS_GEOMTRANSFORM_NONE)
             continue; /*skip this as it has already been rendered*/
-          if(map->scaledenom > 0) {
-            if((pStyle->maxscaledenom != -1) && (map->scaledenom >= pStyle->maxscaledenom))
+          if (map->scaledenom > 0) {
+            if ((pStyle->maxscaledenom != -1) &&
+                (map->scaledenom >= pStyle->maxscaledenom))
               continue;
-            if((pStyle->minscaledenom != -1) && (map->scaledenom < pStyle->minscaledenom))
+            if ((pStyle->minscaledenom != -1) &&
+                (map->scaledenom < pStyle->minscaledenom))
               continue;
           }
-          if(s==0 && pStyle->outlinewidth>0 && MS_VALID_COLOR(pStyle->color)) {
-            if(MS_UNLIKELY(MS_FAILURE == msDrawLineSymbol(map, image, &current->shape, pStyle, pStyle->scalefactor))) {
+          if (s == 0 && pStyle->outlinewidth > 0 &&
+              MS_VALID_COLOR(pStyle->color)) {
+            if (MS_UNLIKELY(MS_FAILURE ==
+                            msDrawLineSymbol(map, image, &current->shape,
+                                             pStyle, pStyle->scalefactor))) {
               return MS_FAILURE;
             }
-          } else if(s>0) {
-            if (pStyle->outlinewidth > 0 && MS_VALID_COLOR(pStyle->outlinecolor)) {
+          } else if (s > 0) {
+            if (pStyle->outlinewidth > 0 &&
+                MS_VALID_COLOR(pStyle->outlinecolor)) {
               /*
                * RFC 49 implementation
                * if an outlinewidth is used:
@@ -1312,8 +1426,10 @@ int msDrawVectorLayer(mapObj *map, layer
                *  - draw the shape (the outline) in the first pass of the
                *    caching mechanism
                */
-	      msOutlineRenderingPrepareStyle(pStyle, map, layer, image);
-              if(MS_UNLIKELY(MS_FAILURE == msDrawLineSymbol(map, image, &current->shape, pStyle, pStyle->scalefactor))) {
+              msOutlineRenderingPrepareStyle(pStyle, map, layer, image);
+              if (MS_UNLIKELY(MS_FAILURE ==
+                              msDrawLineSymbol(map, image, &current->shape,
+                                               pStyle, pStyle->scalefactor))) {
                 return MS_FAILURE;
               }
               /*
@@ -1321,19 +1437,19 @@ int msDrawVectorLayer(mapObj *map, layer
                * original state, so the line fill will be drawn in the
                * second pass of the caching mechanism
                */
-	      msOutlineRenderingRestoreStyle(pStyle, map, layer, image);
+              msOutlineRenderingRestoreStyle(pStyle, map, layer, image);
             }
-            /* draw a valid line, i.e. one with a color defined or of type pixmap*/
-            if(MS_VALID_COLOR(pStyle->color) || 
-                    (
-                      pStyle->symbol<map->symbolset.numsymbols &&
-                      ( 
-                        map->symbolset.symbol[pStyle->symbol]->type == MS_SYMBOL_PIXMAP ||
-                        map->symbolset.symbol[pStyle->symbol]->type == MS_SYMBOL_SVG
-                      )
-                    )
-              ) {
-              if(MS_UNLIKELY(MS_FAILURE == msDrawLineSymbol(map, image, &current->shape, pStyle, pStyle->scalefactor)))
+            /* draw a valid line, i.e. one with a color defined or of type
+             * pixmap*/
+            if (MS_VALID_COLOR(pStyle->color) ||
+                (pStyle->symbol < map->symbolset.numsymbols &&
+                 (map->symbolset.symbol[pStyle->symbol]->type ==
+                      MS_SYMBOL_PIXMAP ||
+                  map->symbolset.symbol[pStyle->symbol]->type ==
+                      MS_SYMBOL_SVG))) {
+              if (MS_UNLIKELY(MS_FAILURE ==
+                              msDrawLineSymbol(map, image, &current->shape,
+                                               pStyle, pStyle->scalefactor)))
                 return MS_FAILURE;
             }
           }
@@ -1347,52 +1463,60 @@ int msDrawVectorLayer(mapObj *map, layer
 
   msLayerClose(layer);
   return MS_SUCCESS;
-
 }
 
 /*
-** Function to draw a layer IF it already has a result cache associated with it. Called by msDrawMap and via MapScript.
+** Function to draw a layer IF it already has a result cache associated with it.
+*Called by msDrawMap and via MapScript.
 */
-int msDrawQueryLayer(mapObj *map, layerObj *layer, imageObj *image)
-{
+int msDrawQueryLayer(mapObj *map, layerObj *layer, imageObj *image) {
   int i, status;
-  char annotate=MS_TRUE, cache=MS_FALSE;
+  char annotate = MS_TRUE, cache = MS_FALSE;
   int drawmode = MS_DRAWMODE_FEATURES;
   shapeObj shape;
-  int maxnumstyles=1;
+  int maxnumstyles = 1;
 
-  featureListNodeObjPtr shpcache=NULL, current=NULL;
+  featureListNodeObjPtr shpcache = NULL, current = NULL;
 
   colorObj *colorbuffer = NULL;
   int *mindistancebuffer = NULL;
 
-  if(!layer->resultcache) return(msDrawLayer(map, layer, image));
+  if (!layer->resultcache)
+    return (msDrawLayer(map, layer, image));
 
-  if(!msLayerIsVisible(map, layer)) return(MS_SUCCESS); /* not an error, just nothing to do */
+  if (!msLayerIsVisible(map, layer))
+    return (MS_SUCCESS); /* not an error, just nothing to do */
 
   /* conditions may have changed since this layer last drawn, so reset
      layer->project to recheck projection needs (Bug #673) */
-  layer->project = msProjectionsDiffer(&(layer->projection),&(map->projection));
+  layer->project =
+      msProjectionsDiffer(&(layer->projection), &(map->projection));
 
   /* set annotation status */
   annotate = msEvalContext(map, layer, layer->labelrequires);
-  if(map->scaledenom > 0) {
-    if((layer->labelmaxscaledenom != -1) && (map->scaledenom >= layer->labelmaxscaledenom)) annotate = MS_FALSE;
-    if((layer->labelminscaledenom != -1) && (map->scaledenom < layer->labelminscaledenom)) annotate = MS_FALSE;
+  if (map->scaledenom > 0) {
+    if ((layer->labelmaxscaledenom != -1) &&
+        (map->scaledenom >= layer->labelmaxscaledenom))
+      annotate = MS_FALSE;
+    if ((layer->labelminscaledenom != -1) &&
+        (map->scaledenom < layer->labelminscaledenom))
+      annotate = MS_FALSE;
   }
 
   /*
-  ** Certain query map styles require us to render all features only (MS_NORMAL) or first (MS_HILITE). With
-  ** single-pass queries we have to make a copy of the layer and work from it instead.
+  ** Certain query map styles require us to render all features only (MS_NORMAL)
+  *or first (MS_HILITE). With
+  ** single-pass queries we have to make a copy of the layer and work from it
+  *instead.
   */
-  if(map->querymap.style == MS_NORMAL || map->querymap.style == MS_HILITE) {
+  if (map->querymap.style == MS_NORMAL || map->querymap.style == MS_HILITE) {
     layerObj tmp_layer;
 
-    if(initLayer(&tmp_layer, map) == -1)
-      return(MS_FAILURE);
+    if (initLayer(&tmp_layer, map) == -1)
+      return (MS_FAILURE);
 
     if (msCopyLayer(&tmp_layer, layer) != MS_SUCCESS)
-      return(MS_FAILURE);
+      return (MS_FAILURE);
 
     /* disable the connection pool for this layer */
     msLayerSetProcessingKey(&tmp_layer, "CLOSE_CONNECTION", "ALWAYS");
@@ -1401,72 +1525,113 @@ int msDrawQueryLayer(mapObj *map, layerO
 
     freeLayer(&tmp_layer);
 
-    if(map->querymap.style == MS_NORMAL || status != MS_SUCCESS) return(status);
+    if (map->querymap.style == MS_NORMAL || status != MS_SUCCESS)
+      return (status);
   }
 
-  /* if MS_HILITE, alter the one style (always at least 1 style), and set a MINDISTANCE for the labelObj to avoid duplicates */
-  if(map->querymap.style == MS_HILITE) {
+  /* if MS_HILITE, alter the one style (always at least 1 style), and set a
+   * MINDISTANCE for the labelObj to avoid duplicates */
+  if (map->querymap.style == MS_HILITE) {
 
     drawmode |= MS_DRAWMODE_QUERY;
 
     if (layer->numclasses > 0) {
-      colorbuffer = (colorObj*)msSmallMalloc(layer->numclasses*sizeof(colorObj));
-      mindistancebuffer = (int*)msSmallMalloc(layer->numclasses*sizeof(int));
-    }
-
-    for(i=0; i<layer->numclasses; i++) {
-      if(layer->type == MS_LAYER_POLYGON && layer->class[i]->numstyles > 0) { /* alter BOTTOM style since that's almost always the fill */
-        if (layer->class[i]->styles == NULL) {
-          msSetError(MS_MISCERR, "Don't know how to draw class %s of layer %s without a style definition.", "msDrawQueryLayer()", layer->class[i]->name, layer->name);
+      colorbuffer =
+          (colorObj *)msSmallMalloc(layer->numclasses * sizeof(colorObj));
+      mindistancebuffer = (int *)msSmallMalloc(layer->numclasses * sizeof(int));
+    }
+
+    for (i = 0; i < layer->numclasses; i++) {
+      if (layer->type == MS_LAYER_POLYGON &&
+              layer->class[i] -> numstyles >
+                                     0) { /* alter BOTTOM style since that's
+                                             almost always the fill */
+        if (layer->class[i] -> styles == NULL) {
+          msSetError(MS_MISCERR,
+                     "Don't know how to draw class %s of layer %s without a "
+                     "style definition.",
+                     "msDrawQueryLayer()", layer->class[i] -> name,
+                     layer -> name);
           msFree(colorbuffer);
           msFree(mindistancebuffer);
-          return(MS_FAILURE);
+          return (MS_FAILURE);
         }
-        if(MS_VALID_COLOR(layer->class[i]->styles[0]->color)) {
-          colorbuffer[i] = layer->class[i]->styles[0]->color; /* save the color from the BOTTOM style */
+        if (MS_VALID_COLOR(layer->class[i] -> styles[0] -> color)) {
+          colorbuffer[i] =
+              layer->class[i]
+                  ->styles[0]
+                  ->color; /* save the color from the BOTTOM style */
           layer->class[i]->styles[0]->color = map->querymap.color;
-        } else if(MS_VALID_COLOR(layer->class[i]->styles[0]->outlinecolor)) {
-          colorbuffer[i] = layer->class[i]->styles[0]->outlinecolor; /* if no color, save the outlinecolor from the BOTTOM style */
+        } else if (MS_VALID_COLOR(
+                       layer->class[i] -> styles[0] -> outlinecolor)) {
+          colorbuffer[i] =
+              layer->class[i]
+                  ->styles[0]
+                  ->outlinecolor; /* if no color, save the outlinecolor from the
+                                     BOTTOM style */
           layer->class[i]->styles[0]->outlinecolor = map->querymap.color;
         }
-      } else if (layer->type == MS_LAYER_LINE && layer->class[i]->numstyles > 0 && layer->class[i]->styles[0]->outlinewidth > 0) { /* alter BOTTOM style for lines with outlines */
-	if(MS_VALID_COLOR(layer->class[i]->styles[0]->color)) {
-          colorbuffer[i] = layer->class[i]->styles[0]->color; /* save the color from the BOTTOM style */
+      } else if (layer->type == MS_LAYER_LINE &&
+                     layer->class[i] -> numstyles > 0 &&
+                                            layer -> class[i] -> styles[0]
+                 -> outlinewidth >
+                        0) { /* alter BOTTOM style for lines with outlines */
+        if (MS_VALID_COLOR(layer->class[i] -> styles[0] -> color)) {
+          colorbuffer[i] =
+              layer->class[i]
+                  ->styles[0]
+                  ->color; /* save the color from the BOTTOM style */
           layer->class[i]->styles[0]->color = map->querymap.color;
         } /* else ??? */
-      } else if (layer->class[i]->numstyles > 0) {
-        if(MS_VALID_COLOR(layer->class[i]->styles[layer->class[i]->numstyles-1]->color)) {
-          colorbuffer[i] = layer->class[i]->styles[layer->class[i]->numstyles-1]->color; /* save the color from the TOP style */
-          layer->class[i]->styles[layer->class[i]->numstyles-1]->color = map->querymap.color;
-        } else if(MS_VALID_COLOR(layer->class[i]->styles[layer->class[i]->numstyles-1]->outlinecolor)) {
-          colorbuffer[i] = layer->class[i]->styles[layer->class[i]->numstyles-1]->outlinecolor; /* if no color, save the outlinecolor from the TOP style */
-          layer->class[i]->styles[layer->class[i]->numstyles-1]->outlinecolor = map->querymap.color;
-        }
-      } else if (layer->class[i]->numlabels > 0) {
-          colorbuffer[i] = layer->class[i]->labels[0]->color;
-          layer->class[i]->labels[0]->color = map->querymap.color;
+      } else if (layer->class[i] -> numstyles > 0) {
+        if (MS_VALID_COLOR(
+                layer->class[i] -> styles[layer->class[i] -> numstyles - 1]
+                -> color)) {
+          colorbuffer[i] = layer->class[i]
+                               ->styles[layer->class[i] -> numstyles - 1]
+                               ->color; /* save the color from the TOP style */
+          layer->class[i]->styles[layer->class[i] -> numstyles - 1]->color =
+              map->querymap.color;
+        } else if (MS_VALID_COLOR(layer->class[i]
+                                  -> styles[layer->class[i] -> numstyles - 1]
+                                  -> outlinecolor)) {
+          colorbuffer[i] =
+              layer->class[i]
+                  ->styles[layer->class[i] -> numstyles - 1]
+                  ->outlinecolor; /* if no color, save the outlinecolor from the
+                                     TOP style */
+          layer->class[i]
+              ->styles[layer->class[i] -> numstyles - 1]
+              ->outlinecolor = map->querymap.color;
+        }
+      } else if (layer->class[i] -> numlabels > 0) {
+        colorbuffer[i] = layer->class[i]->labels[0]->color;
+        layer->class[i]->labels[0]->color = map->querymap.color;
       } /* else ??? */
 
-      mindistancebuffer[i] = -1; /* RFC77 TODO: only using the first label, is that cool? */
-      if(layer->class[i]->numlabels > 0) {
+      mindistancebuffer[i] =
+          -1; /* RFC77 TODO: only using the first label, is that cool? */
+      if (layer->class[i] -> numlabels > 0) {
         mindistancebuffer[i] = layer->class[i]->labels[0]->mindistance;
-        layer->class[i]->labels[0]->mindistance = MS_MAX(0, layer->class[i]->labels[0]->mindistance);
+        layer->class[i]->labels[0]->mindistance =
+            MS_MAX(0, layer->class[i] -> labels[0] -> mindistance);
       }
     }
   }
 
   /*
-  ** Layer was opened as part of the query process, msLayerWhichItems() has also been run, shapes have been classified - start processing!
+  ** Layer was opened as part of the query process, msLayerWhichItems() has also
+  *been run, shapes have been classified - start processing!
   */
 
   msInitShape(&shape);
 
-  for(i=0; i<layer->resultcache->numresults; i++) {
+  for (i = 0; i < layer->resultcache->numresults; i++) {
     status = msLayerGetShape(layer, &shape, &(layer->resultcache->results[i]));
-    if(status != MS_SUCCESS) {
+    if (status != MS_SUCCESS) {
       msFree(colorbuffer);
       msFree(mindistancebuffer);
-      return(MS_FAILURE);
+      return (MS_FAILURE);
     }
 
     shape.classindex = layer->resultcache->results[i].classindex;
@@ -1477,89 +1642,119 @@ int msDrawQueryLayer(mapObj *map, layerO
      * FrankW: classindex is also sometimes 0 even if there are no classes, so
      * we are careful not to use out of range class values as an index.
      */
-    if(shape.classindex==-1
-        || shape.classindex >= layer->numclasses
-        || layer->class[shape.classindex]->status == MS_OFF) {
+    if (shape.classindex == -1 || shape.classindex >= layer->numclasses ||
+            layer->class[shape.classindex] -> status == MS_OFF) {
       msFreeShape(&shape);
       continue;
     }
 
     cache = MS_FALSE;
-    if(layer->type == MS_LAYER_LINE && (layer->class[shape.classindex]->numstyles > 1 || (layer->class[shape.classindex]->numstyles == 1 && layer->class[shape.classindex]->styles[0]->outlinewidth > 0))) {
+    if (layer->type == MS_LAYER_LINE &&
+        (layer->class[shape.classindex]
+         -> numstyles > 1 ||
+                (layer->class[shape.classindex] -> numstyles == 1 && layer
+                 -> class[shape.classindex] -> styles[0] -> outlinewidth >
+                                                                0))) {
       int i;
-      cache = MS_TRUE; /* only line layers with multiple styles need be cached (I don't think POLYLINE layers need caching - SDL) */
+      cache = MS_TRUE; /* only line layers with multiple styles need be cached
+                          (I don't think POLYLINE layers need caching - SDL) */
 
-      /* we can't handle caching with attribute binding other than for the first style (#3976) */
-      for(i=1; i<layer->class[shape.classindex]->numstyles; i++) {
-        if(layer->class[shape.classindex]->styles[i]->numbindings > 0) cache = MS_FALSE;
+      /* we can't handle caching with attribute binding other than for the first
+       * style (#3976) */
+      for (i = 1; i < layer->class[shape.classindex] -> numstyles; i++) {
+        if (layer->class[shape.classindex] -> styles[i] -> numbindings > 0)
+          cache = MS_FALSE;
       }
     }
 
-    if(annotate && layer->class[shape.classindex]->numlabels > 0) {
+    if (annotate && layer->class[shape.classindex] -> numlabels > 0) {
       drawmode |= MS_DRAWMODE_LABELS;
     }
 
-    if(cache) {
+    if (cache) {
       styleObj *pStyle = layer->class[shape.classindex]->styles[0];
-      if (pStyle->outlinewidth > 0) msOutlineRenderingPrepareStyle(pStyle, map, layer, image);
-      status = msDrawShape(map, layer, &shape, image, 0, drawmode|MS_DRAWMODE_SINGLESTYLE); /* draw only the first style */
-      if (pStyle->outlinewidth > 0) msOutlineRenderingRestoreStyle(pStyle, map, layer, image);
+      if (pStyle->outlinewidth > 0)
+        msOutlineRenderingPrepareStyle(pStyle, map, layer, image);
+      status = msDrawShape(
+          map, layer, &shape, image, 0,
+          drawmode | MS_DRAWMODE_SINGLESTYLE); /* draw only the first style */
+      if (pStyle->outlinewidth > 0)
+        msOutlineRenderingRestoreStyle(pStyle, map, layer, image);
     } else {
-      status = msDrawShape(map, layer, &shape, image, -1, drawmode); /* all styles  */
+      status =
+          msDrawShape(map, layer, &shape, image, -1, drawmode); /* all styles */
     }
-    if(status != MS_SUCCESS) {
+    if (status != MS_SUCCESS) {
       msLayerClose(layer);
       msFree(colorbuffer);
       msFree(mindistancebuffer);
-      return(MS_FAILURE);
+      return (MS_FAILURE);
     }
 
-    if(shape.numlines == 0) { /* once clipped the shape didn't need to be drawn */
+    if (shape.numlines ==
+        0) { /* once clipped the shape didn't need to be drawn */
       msFreeShape(&shape);
       continue;
     }
 
-    if(cache) {
-      if(insertFeatureList(&shpcache, &shape) == NULL) {
+    if (cache) {
+      if (insertFeatureList(&shpcache, &shape) == NULL) {
         msFree(colorbuffer);
         msFree(mindistancebuffer);
-        return(MS_FAILURE); /* problem adding to the cache */
+        return (MS_FAILURE); /* problem adding to the cache */
       }
     }
 
-    maxnumstyles = MS_MAX(maxnumstyles, layer->class[shape.classindex]->numstyles);
+    maxnumstyles =
+        MS_MAX(maxnumstyles, layer->class[shape.classindex] -> numstyles);
     msFreeShape(&shape);
   }
 
-  if(shpcache) {
+  if (shpcache) {
     int s;
-    for(s=0; s<maxnumstyles; s++) {
-      for(current=shpcache; current; current=current->next) {
-        if(layer->class[current->shape.classindex]->numstyles > s) {
+    for (s = 0; s < maxnumstyles; s++) {
+      for (current = shpcache; current; current = current->next) {
+        if (layer->class[current->shape.classindex] -> numstyles > s) {
           styleObj *pStyle = layer->class[current->shape.classindex]->styles[s];
-          if(pStyle->_geomtransform.type != MS_GEOMTRANSFORM_NONE)
+          if (pStyle->_geomtransform.type != MS_GEOMTRANSFORM_NONE)
             continue; /* skip this as it has already been rendered */
-          if(map->scaledenom > 0) {
-            if((pStyle->maxscaledenom != -1) && (map->scaledenom >= pStyle->maxscaledenom))
+          if (map->scaledenom > 0) {
+            if ((pStyle->maxscaledenom != -1) &&
+                (map->scaledenom >= pStyle->maxscaledenom))
               continue;
-            if((pStyle->minscaledenom != -1) && (map->scaledenom < pStyle->minscaledenom))
+            if ((pStyle->minscaledenom != -1) &&
+                (map->scaledenom < pStyle->minscaledenom))
               continue;
           }
-          if(s==0 && pStyle->outlinewidth>0 && MS_VALID_COLOR(pStyle->color)) {
-            if(MS_UNLIKELY(MS_FAILURE == msDrawLineSymbol(map, image, &current->shape, pStyle, pStyle->scalefactor))) {
+          if (s == 0 && pStyle->outlinewidth > 0 &&
+              MS_VALID_COLOR(pStyle->color)) {
+            if (MS_UNLIKELY(MS_FAILURE ==
+                            msDrawLineSymbol(map, image, &current->shape,
+                                             pStyle, pStyle->scalefactor))) {
               return MS_FAILURE;
             }
-          } else if(s>0) {
-            if (pStyle->outlinewidth > 0 && MS_VALID_COLOR(pStyle->outlinecolor)) {
+          } else if (s > 0) {
+            if (pStyle->outlinewidth > 0 &&
+                MS_VALID_COLOR(pStyle->outlinecolor)) {
               msOutlineRenderingPrepareStyle(pStyle, map, layer, image);
-              if(MS_UNLIKELY(MS_FAILURE == msDrawLineSymbol(map, image, &current->shape, pStyle, pStyle->scalefactor))) {
+              if (MS_UNLIKELY(MS_FAILURE ==
+                              msDrawLineSymbol(map, image, &current->shape,
+                                               pStyle, pStyle->scalefactor))) {
                 return MS_FAILURE;
               }
               msOutlineRenderingRestoreStyle(pStyle, map, layer, image);
             }
-            /* draw a valid line, i.e. one with a color defined or of type pixmap */
-            if(MS_VALID_COLOR(pStyle->color) || (pStyle->symbol<map->symbolset.numsymbols && (map->symbolset.symbol[pStyle->symbol]->type == MS_SYMBOL_PIXMAP || map->symbolset.symbol[pStyle->symbol]->type == MS_SYMBOL_SVG))) {
-              if(MS_UNLIKELY(MS_FAILURE == msDrawLineSymbol(map, image, &current->shape, pStyle, pStyle->scalefactor)))
+            /* draw a valid line, i.e. one with a color defined or of type
+             * pixmap */
+            if (MS_VALID_COLOR(pStyle->color) ||
+                (pStyle->symbol < map->symbolset.numsymbols &&
+                 (map->symbolset.symbol[pStyle->symbol]->type ==
+                      MS_SYMBOL_PIXMAP ||
+                  map->symbolset.symbol[pStyle->symbol]->type ==
+                      MS_SYMBOL_SVG))) {
+              if (MS_UNLIKELY(MS_FAILURE ==
+                              msDrawLineSymbol(map, image, &current->shape,
+                                               pStyle, pStyle->scalefactor)))
                 return MS_FAILURE;
             }
           }
@@ -1572,72 +1767,99 @@ int msDrawQueryLayer(mapObj *map, layerO
   }
 
   /* if MS_HILITE, restore color and mindistance values */
-  if(map->querymap.style == MS_HILITE) {
-    for(i=0; i<layer->numclasses; i++) {
-      if(layer->type == MS_LAYER_POLYGON && layer->class[i]->numstyles > 0) {
-        if(MS_VALID_COLOR(layer->class[i]->styles[0]->color))
+  if (map->querymap.style == MS_HILITE) {
+    for (i = 0; i < layer->numclasses; i++) {
+      if (layer->type == MS_LAYER_POLYGON && layer->class[i] -> numstyles > 0) {
+        if (MS_VALID_COLOR(layer->class[i] -> styles[0] -> color))
           layer->class[i]->styles[0]->color = colorbuffer[i];
-        else if(MS_VALID_COLOR(layer->class[i]->styles[0]->outlinecolor))
-          layer->class[i]->styles[0]->outlinecolor = colorbuffer[i]; /* if no color, restore outlinecolor for the BOTTOM style */
-      } else if (layer->type == MS_LAYER_LINE && layer->class[i]->numstyles > 0 && layer->class[i]->styles[0]->outlinewidth > 0) {
-        if(MS_VALID_COLOR(layer->class[i]->styles[0]->color))
-	  layer->class[i]->styles[0]->color = colorbuffer[i];
-      } else if (layer->class[i]->numstyles > 0) {
-        if(MS_VALID_COLOR(layer->class[i]->styles[layer->class[i]->numstyles-1]->color))
-          layer->class[i]->styles[layer->class[i]->numstyles-1]->color = colorbuffer[i];
-        else if(MS_VALID_COLOR(layer->class[i]->styles[layer->class[i]->numstyles-1]->outlinecolor))
-          layer->class[i]->styles[layer->class[i]->numstyles-1]->outlinecolor = colorbuffer[i]; /* if no color, restore outlinecolor for the TOP style */
-      } else if (layer->class[i]->numlabels > 0) {
-        if(MS_VALID_COLOR(layer->class[i]->labels[0]->color))
+        else if (MS_VALID_COLOR(layer->class[i] -> styles[0] -> outlinecolor))
+          layer->class[i]->styles[0]->outlinecolor =
+              colorbuffer[i]; /* if no color, restore outlinecolor for the
+                                 BOTTOM style */
+      } else if (layer->type == MS_LAYER_LINE &&
+                     layer->class[i] -> numstyles > 0 && layer -> class[i]
+                 -> styles[0] -> outlinewidth > 0) {
+        if (MS_VALID_COLOR(layer->class[i] -> styles[0] -> color))
+          layer->class[i]->styles[0]->color = colorbuffer[i];
+      } else if (layer->class[i] -> numstyles > 0) {
+        if (MS_VALID_COLOR(
+                layer->class[i] -> styles[layer->class[i] -> numstyles - 1]
+                -> color))
+          layer->class[i]->styles[layer->class[i] -> numstyles - 1]->color =
+              colorbuffer[i];
+        else if (MS_VALID_COLOR(
+                     layer->class[i] -> styles[layer->class[i] -> numstyles - 1]
+                     -> outlinecolor))
+          layer->class[i]
+              ->styles[layer->class[i] -> numstyles - 1]
+              ->outlinecolor =
+              colorbuffer[i]; /* if no color, restore outlinecolor for the TOP
+                                 style */
+      } else if (layer->class[i] -> numlabels > 0) {
+        if (MS_VALID_COLOR(layer->class[i] -> labels[0] -> color))
           layer->class[i]->labels[0]->color = colorbuffer[i];
       }
 
-      if(layer->class[i]->numlabels > 0)
-        layer->class[i]->labels[0]->mindistance = mindistancebuffer[i]; /* RFC77 TODO: again, only using the first label, is that cool? */
+      if (layer->class[i] -> numlabels > 0)
+        layer->class[i]->labels[0]->mindistance =
+            mindistancebuffer[i]; /* RFC77 TODO: again, only using the first
+                                     label, is that cool? */
     }
 
     msFree(colorbuffer);
     msFree(mindistancebuffer);
   }
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
 /**
  * msDrawRasterLayerPlugin()
  */
 
-static int
-msDrawRasterLayerPlugin( mapObj *map, layerObj *layer, imageObj *image)
+static int msDrawRasterLayerPlugin(mapObj *map, layerObj *layer,
+                                   imageObj *image)
 
 {
   rendererVTableObj *renderer = MS_IMAGE_RENDERER(image);
-  rasterBufferObj  *rb = msSmallCalloc(1,sizeof(rasterBufferObj));
+  rasterBufferObj *rb = msSmallCalloc(1, sizeof(rasterBufferObj));
   int ret;
-  if( renderer->supports_pixel_buffer ) {
-    if (MS_SUCCESS != renderer->getRasterBufferHandle( image, rb )) {
-      msSetError(MS_MISCERR,"renderer failed to extract raster buffer","msDrawRasterLayer()");
+  if (renderer->supports_pixel_buffer) {
+    if (MS_SUCCESS != renderer->getRasterBufferHandle(image, rb)) {
+      msSetError(MS_MISCERR, "renderer failed to extract raster buffer",
+                 "msDrawRasterLayer()");
       return MS_FAILURE;
     }
-    ret = msDrawRasterLayerLow( map, layer, image, rb );
+    ret = msDrawRasterLayerLow(map, layer, image, rb);
   } else {
-    if (MS_SUCCESS != renderer->initializeRasterBuffer( rb, image->width, image->height, MS_IMAGEMODE_RGBA )) {
-      msSetError(MS_MISCERR,"renderer failed to create raster buffer","msDrawRasterLayer()");
+    if (MS_SUCCESS != renderer->initializeRasterBuffer(
+                          rb, image->width, image->height, MS_IMAGEMODE_RGBA)) {
+      msSetError(MS_MISCERR, "renderer failed to create raster buffer",
+                 "msDrawRasterLayer()");
       return MS_FAILURE;
     }
 
-    ret = msDrawRasterLayerLow( map, layer, image, rb );
+    ret = msDrawRasterLayerLow(map, layer, image, rb);
 
-    if( ret == 0 ) {
-      ret = renderer->mergeRasterBuffer( image, rb, 1.0, 0, 0, 0, 0, rb->width, rb->height );
+    if (ret == 0) {
+      ret = renderer->mergeRasterBuffer(image, rb, 1.0, 0, 0, 0, 0, rb->width,
+                                        rb->height);
     }
 
     msFreeRasterBuffer(rb);
   }
-#define RB_GET_R(rb,x,y) *((rb)->data.rgba.r + (x) * (rb)->data.rgba.pixel_step + (y) * (rb)->data.rgba.row_step)
-#define RB_GET_G(rb,x,y) *((rb)->data.rgba.g + (x) * (rb)->data.rgba.pixel_step + (y) * (rb)->data.rgba.row_step)
-#define RB_GET_B(rb,x,y) *((rb)->data.rgba.b + (x) * (rb)->data.rgba.pixel_step + (y) * (rb)->data.rgba.row_step)
-#define RB_GET_A(rb,x,y) *((rb)->data.rgba.a + (x) * (rb)->data.rgba.pixel_step + (y) * (rb)->data.rgba.row_step)
+#define RB_GET_R(rb, x, y)                                                     \
+  *((rb)->data.rgba.r + (x) * (rb)->data.rgba.pixel_step +                     \
+    (y) * (rb)->data.rgba.row_step)
+#define RB_GET_G(rb, x, y)                                                     \
+  *((rb)->data.rgba.g + (x) * (rb)->data.rgba.pixel_step +                     \
+    (y) * (rb)->data.rgba.row_step)
+#define RB_GET_B(rb, x, y)                                                     \
+  *((rb)->data.rgba.b + (x) * (rb)->data.rgba.pixel_step +                     \
+    (y) * (rb)->data.rgba.row_step)
+#define RB_GET_A(rb, x, y)                                                     \
+  *((rb)->data.rgba.a + (x) * (rb)->data.rgba.pixel_step +                     \
+    (y) * (rb)->data.rgba.row_step)
 
   free(rb);
 
@@ -1647,20 +1869,21 @@ msDrawRasterLayerPlugin( mapObj *map, la
 /**
  * Generic function to render raster layers.
  */
-int msDrawRasterLayer(mapObj *map, layerObj *layer, imageObj *image)
-{
-  
+int msDrawRasterLayer(mapObj *map, layerObj *layer, imageObj *image) {
+
   int rv = MS_FAILURE;
   if (!image || !map || !layer) {
     return rv;
   }
 
   /* RFC-86 Scale dependant token replacements*/
-  rv = msLayerApplyScaletokens(layer,(layer->map)?layer->map->scaledenom:-1);
-  if (rv != MS_SUCCESS) return rv;
-  if( MS_RENDERER_PLUGIN(image->format) )
+  rv = msLayerApplyScaletokens(layer,
+                               (layer->map) ? layer->map->scaledenom : -1);
+  if (rv != MS_SUCCESS)
+    return rv;
+  if (MS_RENDERER_PLUGIN(image->format))
     rv = msDrawRasterLayerPlugin(map, layer, image);
-  else if( MS_RENDERER_RAWDATA(image->format) )
+  else if (MS_RENDERER_RAWDATA(image->format))
     rv = msDrawRasterLayerLow(map, layer, image, NULL);
   msLayerRestoreFromScaletokens(layer);
   return rv;
@@ -1675,8 +1898,7 @@ int msDrawRasterLayer(mapObj *map, layer
  */
 
 #ifdef USE_WMS_LYR
-int msDrawWMSLayer(mapObj *map, layerObj *layer, imageObj *image)
-{
+int msDrawWMSLayer(mapObj *map, layerObj *layer, imageObj *image) {
   int nStatus = MS_FAILURE;
 
   if (image && map && layer) {
@@ -1688,22 +1910,19 @@ int msDrawWMSLayer(mapObj *map, layerObj
 
     msHTTPInitRequestObj(asReqInfo, 2);
 
-    if ( msPrepareWMSLayerRequest(1, map, layer, 1,
-                                  0, NULL, 0, 0, 0, NULL,
-                                  asReqInfo, &numReq) == MS_FAILURE  ||
-         msOWSExecuteRequests(asReqInfo, numReq, map, MS_TRUE) == MS_FAILURE ) {
+    if (msPrepareWMSLayerRequest(1, map, layer, 1, 0, NULL, 0, 0, 0, NULL,
+                                 asReqInfo, &numReq) == MS_FAILURE ||
+        msOWSExecuteRequests(asReqInfo, numReq, map, MS_TRUE) == MS_FAILURE) {
       return MS_FAILURE;
     }
 
     /* ------------------------------------------------------------------
      * Then draw layer based on output format
      * ------------------------------------------------------------------ */
-    if( MS_RENDERER_PLUGIN(image->format) )
-      nStatus = msDrawWMSLayerLow(1, asReqInfo, numReq,
-                                  map, layer, image) ;
-    else if( MS_RENDERER_RAWDATA(image->format) )
-      nStatus = msDrawWMSLayerLow(1, asReqInfo, numReq,
-                                  map, layer, image) ;
+    if (MS_RENDERER_PLUGIN(image->format))
+      nStatus = msDrawWMSLayerLow(1, asReqInfo, numReq, map, layer, image);
+    else if (MS_RENDERER_RAWDATA(image->format))
+      nStatus = msDrawWMSLayerLow(1, asReqInfo, numReq, map, layer, image);
 
     else {
       msSetError(MS_WMSCONNERR,
@@ -1719,15 +1938,17 @@ int msDrawWMSLayer(mapObj *map, layerObj
 }
 #endif
 
-int circleLayerDrawShape(mapObj *map, imageObj *image, layerObj *layer, shapeObj *shape)
-{
+int circleLayerDrawShape(mapObj *map, imageObj *image, layerObj *layer,
+                         shapeObj *shape) {
   pointObj center;
   double r;
   int s;
   int c = shape->classindex;
 
-  if (shape->numlines != 1) return (MS_SUCCESS); /* invalid shape */
-  if (shape->line[0].numpoints != 2) return (MS_SUCCESS); /* invalid shape */
+  if (shape->numlines != 1)
+    return (MS_SUCCESS); /* invalid shape */
+  if (shape->line[0].numpoints != 2)
+    return (MS_SUCCESS); /* invalid shape */
 
   center.x = (shape->line[0].point[0].x + shape->line[0].point[1].x) / 2.0;
   center.y = (shape->line[0].point[0].y + shape->line[0].point[1].y) / 2.0;
@@ -1748,12 +1969,14 @@ int circleLayerDrawShape(mapObj *map, im
   } else
     msOffsetPointRelativeTo(&center, layer);
 
-  for (s = 0; s < layer->class[c]->numstyles; s++) {
+  for (s = 0; s < layer->class[c] -> numstyles; s++) {
     if (msScaleInBounds(map->scaledenom,
-                        layer->class[c]->styles[s]->minscaledenom,
-                        layer->class[c]->styles[s]->maxscaledenom))
-      if(MS_UNLIKELY(MS_FAILURE == msCircleDrawShadeSymbol(map, image, &center, r,
-                              layer->class[c]->styles[s], layer->class[c]->styles[s]->scalefactor))) {
+                        layer->class[c] -> styles[s] -> minscaledenom,
+                        layer -> class[c] -> styles[s] -> maxscaledenom))
+      if (MS_UNLIKELY(MS_FAILURE ==
+                      msCircleDrawShadeSymbol(
+                          map, image, &center, r, layer->class[c] -> styles[s],
+                          layer -> class[c] -> styles[s] -> scalefactor))) {
         return MS_FAILURE;
       }
   }
@@ -1761,41 +1984,31 @@ int circleLayerDrawShape(mapObj *map, im
   /* TODO: need to handle circle annotation */
 }
 
-static
-int pointLayerDrawShape(mapObj *map, imageObj *image, layerObj *layer, shapeObj *shape, int drawmode)
-{
+static int pointLayerDrawShape(mapObj *map, imageObj *image, layerObj *layer,
+                               shapeObj *shape, int drawmode) {
   int l, c = shape->classindex, j, i, s;
   pointObj *point;
   int ret = MS_FAILURE;
 
-  if (layer->project && layer->transform == MS_TRUE)
-  {
-      if( layer->reprojectorLayerToMap == NULL )
-      {
-          layer->reprojectorLayerToMap = msProjectCreateReprojector(
-              &layer->projection, &map->projection);
-        if( layer->reprojectorLayerToMap == NULL )
-        {
-            return MS_FAILURE;
-        }
-      }
-      msProjectShapeEx(layer->reprojectorLayerToMap, shape);
+  if (layer->project && layer->transform == MS_TRUE) {
+    reprojectionObj *reprojector = msLayerGetReprojectorToMap(layer, map);
+    if (reprojector == NULL) {
+      return MS_FAILURE;
+    }
+    msProjectShapeEx(reprojector, shape);
   }
 
   // Only take into account map rotation if the label and style angles are
   // non-zero.
-  if( map->gt.rotation_angle )
-  {
-    for (l = 0; l < layer->class[c]->numlabels; l++)
-    {
-        if( layer->class[c]->labels[l]->angle != 0 )
-            layer->class[c]->labels[l]->angle -= map->gt.rotation_angle;
+  if (map->gt.rotation_angle) {
+    for (l = 0; l < layer->class[c] -> numlabels; l++) {
+      if (layer->class[c] -> labels[l] -> angle != 0)
+        layer->class[c]->labels[l]->angle -= map->gt.rotation_angle;
     }
 
-    for (s = 0; s < layer->class[c]->numstyles; s++)
-    {
-        if( layer->class[c]->styles[s]->angle != 0 )
-            layer->class[c]->styles[s]->angle -= map->gt.rotation_angle;
+    for (s = 0; s < layer->class[c] -> numstyles; s++) {
+      if (layer->class[c] -> styles[s] -> angle != 0)
+        layer->class[c]->styles[s]->angle -= map->gt.rotation_angle;
     }
   }
 
@@ -1803,29 +2016,42 @@ int pointLayerDrawShape(mapObj *map, ima
     for (i = 0; i < shape->line[j].numpoints; i++) {
       point = &(shape->line[j].point[i]);
       if (layer->transform == MS_TRUE) {
-        if (!msPointInRect(point, &map->extent)) continue; /* next point */
+        if (!msPointInRect(point, &map->extent))
+          continue; /* next point */
         msTransformPoint(point, &map->extent, map->cellsize, image);
       } else
         msOffsetPointRelativeTo(point, layer);
 
-      if(MS_DRAW_FEATURES(drawmode)) {
-        for (s = 0; s < layer->class[c]->numstyles; s++) {
+      if (MS_DRAW_FEATURES(drawmode)) {
+        for (s = 0; s < layer->class[c] -> numstyles; s++) {
           if (msScaleInBounds(map->scaledenom,
-              layer->class[c]->styles[s]->minscaledenom,
-              layer->class[c]->styles[s]->maxscaledenom))
-            if(MS_UNLIKELY(MS_FAILURE == msDrawMarkerSymbol(map, image, point, layer->class[c]->styles[s], layer->class[c]->styles[s]->scalefactor))) {
+                              layer->class[c] -> styles[s] -> minscaledenom,
+                              layer -> class[c] -> styles[s] -> maxscaledenom))
+            if (MS_UNLIKELY(
+                    MS_FAILURE ==
+                    msDrawMarkerSymbol(
+                        map, image, point, layer->class[c] -> styles[s],
+                        layer -> class[c] -> styles[s] -> scalefactor))) {
               goto end;
             }
         }
       }
-      if(MS_DRAW_LABELS(drawmode)) {
+      if (MS_DRAW_LABELS(drawmode)) {
         if (layer->labelcache) {
-          if (msAddLabelGroup(map, image, layer, c, shape, point, -1) != MS_SUCCESS) goto end;
+          if (msAddLabelGroup(map, image, layer, c, shape, point, -1) !=
+              MS_SUCCESS)
+            goto end;
         } else {
-          for (l = 0; l < layer->class[c]->numlabels; l++)
-            if(msGetLabelStatus(map,layer,shape,layer->class[c]->labels[l]) == MS_ON) {
-              char *annotext = msShapeGetLabelAnnotation(layer,shape,layer->class[c]->labels[l]);
-              if(MS_UNLIKELY(MS_FAILURE == msDrawLabel(map, image, *point, annotext, layer->class[c]->labels[l], layer->class[c]->labels[l]->scalefactor))) {
+          for (l = 0; l < layer->class[c] -> numlabels; l++)
+            if (msGetLabelStatus(map, layer, shape,
+                                 layer->class[c] -> labels[l]) == MS_ON) {
+              char *annotext = msShapeGetLabelAnnotation(
+                  layer, shape, layer->class[c] -> labels[l]);
+              if (MS_UNLIKELY(MS_FAILURE ==
+                              msDrawLabel(map, image, *point, annotext,
+                                          layer->class[c] -> labels[l],
+                                          layer -> class[c] -> labels[l]
+                                          -> scalefactor))) {
                 goto end;
               }
             }
@@ -1836,92 +2062,103 @@ int pointLayerDrawShape(mapObj *map, ima
   ret = MS_SUCCESS;
 
 end:
-  if( map->gt.rotation_angle )
-  {
-    for (l = 0; l < layer->class[c]->numlabels; l++)
-    {
-        if( layer->class[c]->labels[l]->angle != 0 )
-            layer->class[c]->labels[l]->angle += map->gt.rotation_angle;
+  if (map->gt.rotation_angle) {
+    for (l = 0; l < layer->class[c] -> numlabels; l++) {
+      if (layer->class[c] -> labels[l] -> angle != 0)
+        layer->class[c]->labels[l]->angle += map->gt.rotation_angle;
     }
 
-    for (s = 0; s < layer->class[c]->numstyles; s++)
-    {
-        if( layer->class[c]->styles[s]->angle != 0 )
-            layer->class[c]->styles[s]->angle += map->gt.rotation_angle;
+    for (s = 0; s < layer->class[c] -> numstyles; s++) {
+      if (layer->class[c] -> styles[s] -> angle != 0)
+        layer->class[c]->styles[s]->angle += map->gt.rotation_angle;
     }
   }
 
   return ret;
 }
 
-int lineLayerDrawShape(mapObj *map, imageObj *image, layerObj *layer, shapeObj *shape,
-                       shapeObj *anno_shape, shapeObj *unclipped_shape, int style, int drawmode)
-{
+int lineLayerDrawShape(mapObj *map, imageObj *image, layerObj *layer,
+                       shapeObj *shape, shapeObj *anno_shape,
+                       shapeObj *unclipped_shape, int style, int drawmode) {
   int c = shape->classindex;
   int ret = MS_SUCCESS;
 
   /* RFC48: loop through the styles, and pass off to the type-specific
   function if the style has an appropriate type */
-  if(MS_DRAW_FEATURES(drawmode)) {
-    for (int s = 0; s < layer->class[c]->numstyles; s++) {
+  if (MS_DRAW_FEATURES(drawmode)) {
+    for (int s = 0; s < layer->class[c] -> numstyles; s++) {
       if (msScaleInBounds(map->scaledenom,
-          layer->class[c]->styles[s]->minscaledenom,
-          layer->class[c]->styles[s]->maxscaledenom)) {
-        if (layer->class[c]->styles[s]->_geomtransform.type != MS_GEOMTRANSFORM_NONE) {
-          if(MS_UNLIKELY(MS_FAILURE == msDrawTransformedShape(map, image, unclipped_shape, layer->class[c]->styles[s], layer->class[c]->styles[s]->scalefactor))) {
+                          layer->class[c] -> styles[s] -> minscaledenom,
+                          layer -> class[c] -> styles[s] -> maxscaledenom)) {
+        if (layer->class[c] -> styles[s] -> _geomtransform.type !=
+                                                MS_GEOMTRANSFORM_NONE) {
+          if (MS_UNLIKELY(MS_FAILURE ==
+                          msDrawTransformedShape(
+                              map, image, unclipped_shape,
+                              layer->class[c] -> styles[s],
+                              layer -> class[c] -> styles[s] -> scalefactor))) {
             return MS_FAILURE;
           }
-        }
-        else if (!MS_DRAW_SINGLESTYLE(drawmode) || s == style) {
-          if(MS_UNLIKELY(MS_FAILURE == msDrawLineSymbol(map, image, shape, layer->class[c]->styles[s], layer->class[c]->styles[s]->scalefactor))) {
+        } else if (!MS_DRAW_SINGLESTYLE(drawmode) || s == style) {
+          if (MS_UNLIKELY(MS_FAILURE ==
+                          msDrawLineSymbol(
+                              map, image, shape, layer->class[c] -> styles[s],
+                              layer -> class[c] -> styles[s] -> scalefactor))) {
             return MS_FAILURE;
           }
         }
       }
     }
   }
-  
-  if(MS_DRAW_LABELS(drawmode)) {
-    for (int l = 0; l < layer->class[c]->numlabels; l++) {
+
+  if (MS_DRAW_LABELS(drawmode)) {
+    for (int l = 0; l < layer->class[c] -> numlabels; l++) {
       labelObj *label = layer->class[c]->labels[l];
       textSymbolObj ts;
       char *annotext;
-      if(!msGetLabelStatus(map,layer,shape,label)) {
+      if (!msGetLabelStatus(map, layer, shape, label)) {
         continue;
       }
 
-      annotext = msShapeGetLabelAnnotation(layer,anno_shape,label);
-      if(!annotext) continue;
+      annotext = msShapeGetLabelAnnotation(layer, anno_shape, label);
+      if (!annotext)
+        continue;
       initTextSymbol(&ts);
-      msPopulateTextSymbolForLabelAndString(&ts,label,annotext,label->scalefactor,image->resolutionfactor, layer->labelcache);
-      
-      
+      msPopulateTextSymbolForLabelAndString(
+          &ts, label, annotext, label->scalefactor, image->resolutionfactor,
+          layer->labelcache);
+
       if (label->anglemode == MS_FOLLOW) { /* bug #1620 implementation */
         struct label_follow_result lfr;
-        
+
         if (!layer->labelcache) {
-          msSetError(MS_MISCERR, "Angle mode 'FOLLOW' is supported only with labelcache on", "msDrawShape()");
+          msSetError(MS_MISCERR,
+                     "Angle mode 'FOLLOW' is supported only with labelcache on",
+                     "msDrawShape()");
           ret = MS_FAILURE;
           goto line_cleanup;
         }
-        
-        memset(&lfr,0,sizeof(lfr));
+
+        memset(&lfr, 0, sizeof(lfr));
         msPolylineLabelPath(map, image, anno_shape, &ts, label, &lfr);
 
         for (int i = 0; i < lfr.num_follow_labels; i++) {
-          if (msAddLabel(map, image, label, layer->index, c, anno_shape, NULL, -1, lfr.follow_labels[i]) != MS_SUCCESS) {
+          if (msAddLabel(map, image, label, layer->index, c, anno_shape, NULL,
+                         -1, lfr.follow_labels[i]) != MS_SUCCESS) {
             ret = MS_FAILURE;
             goto line_cleanup;
           }
         }
         free(lfr.follow_labels);
-        for(int i=0; i<lfr.lar.num_label_points; i++) {
+        for (int i = 0; i < lfr.lar.num_label_points; i++) {
           textSymbolObj *ts_auto = msSmallMalloc(sizeof(textSymbolObj));
           initTextSymbol(ts_auto);
-          msCopyTextSymbol(ts_auto,&ts);
+          msCopyTextSymbol(ts_auto, &ts);
           ts_auto->rotation = lfr.lar.angles[i];
           {
-            if (msAddLabel(map, image, label, layer->index, c, anno_shape, &lfr.lar.label_points[i], -1, ts_auto) != MS_SUCCESS) {
+            if (msAddLabel(map, image, label, layer->index, c, anno_shape,
+                           &lfr.lar.label_points[i], -1,
+                           ts_auto) != MS_SUCCESS) {
               ret = MS_FAILURE;
               free(lfr.lar.angles);
               free(lfr.lar.label_points);
@@ -1933,20 +2170,23 @@ int lineLayerDrawShape(mapObj *map, imag
         free(lfr.lar.label_points);
       } else {
         struct label_auto_result lar;
-        memset(&lar,0,sizeof(struct label_auto_result));
-        ret = msPolylineLabelPoint(map, anno_shape, &ts, label, &lar, image->resolutionfactor);
-        if(MS_UNLIKELY(MS_FAILURE == ret)) goto line_cleanup;
+        memset(&lar, 0, sizeof(struct label_auto_result));
+        ret = msPolylineLabelPoint(map, anno_shape, &ts, label, &lar,
+                                   image->resolutionfactor);
+        if (MS_UNLIKELY(MS_FAILURE == ret))
+          goto line_cleanup;
 
         if (label->angle != 0)
           label->angle -= map->gt.rotation_angle; /* apply rotation angle */
 
-        for(int i=0; i<lar.num_label_points; i++) {
+        for (int i = 0; i < lar.num_label_points; i++) {
           textSymbolObj *ts_auto = msSmallMalloc(sizeof(textSymbolObj));
           initTextSymbol(ts_auto);
-          msCopyTextSymbol(ts_auto,&ts);
+          msCopyTextSymbol(ts_auto, &ts);
           ts_auto->rotation = lar.angles[i];
           if (layer->labelcache) {
-            if (msAddLabel(map, image, label, layer->index, c, anno_shape, &lar.label_points[i], -1, ts_auto) != MS_SUCCESS) {
+            if (msAddLabel(map, image, label, layer->index, c, anno_shape,
+                           &lar.label_points[i], -1, ts_auto) != MS_SUCCESS) {
               ret = MS_FAILURE;
               free(lar.angles);
               free(lar.label_points);
@@ -1955,8 +2195,8 @@ int lineLayerDrawShape(mapObj *map, imag
               goto line_cleanup;
             }
           } else {
-            if(!ts_auto->textpath) {
-              if(MS_UNLIKELY(MS_FAILURE == msComputeTextPath(map,ts_auto))) {
+            if (!ts_auto->textpath) {
+              if (MS_UNLIKELY(MS_FAILURE == msComputeTextPath(map, ts_auto))) {
                 ret = MS_FAILURE;
                 free(lar.angles);
                 free(lar.label_points);
@@ -1965,21 +2205,23 @@ int lineLayerDrawShape(mapObj *map, imag
                 goto line_cleanup;
               }
             }
-            ret = msDrawTextSymbol(map,image,lar.label_points[i],ts_auto);
+            ret = msDrawTextSymbol(map, image, lar.label_points[i], ts_auto);
             freeTextSymbol(ts_auto);
-            free(ts_auto); /* TODO RFC98: could we not re-use the original ts instead of duplicating into ts_auto ?
-                            * we cannot for now, as the rendering code will modify the glyph positions to apply
-                            * the labelpoint and rotation offsets */
+            free(ts_auto); /* TODO RFC98: could we not re-use the original ts
+                            * instead of duplicating into ts_auto ? we cannot
+                            * for now, as the rendering code will modify the
+                            * glyph positions to apply the labelpoint and
+                            * rotation offsets */
             ts_auto = NULL;
-            if(MS_UNLIKELY(MS_FAILURE == ret)) goto line_cleanup;
+            if (MS_UNLIKELY(MS_FAILURE == ret))
+              goto line_cleanup;
           }
-          
         }
         free(lar.angles);
         free(lar.label_points);
       }
 
-line_cleanup:
+    line_cleanup:
       /* clean up and reset */
       if (ret == MS_FAILURE) {
         break; /* from the label looping */
@@ -1989,29 +2231,35 @@ line_cleanup:
   }
 
   return ret;
-
 }
 
 int polygonLayerDrawShape(mapObj *map, imageObj *image, layerObj *layer,
-                          shapeObj *shape, shapeObj *anno_shape, shapeObj *unclipped_shape, int drawmode)
-{
+                          shapeObj *shape, shapeObj *anno_shape,
+                          shapeObj *unclipped_shape, int drawmode) {
 
   int c = shape->classindex;
   pointObj annopnt = {0}; // initialize
   int i;
 
-  if(MS_DRAW_FEATURES(drawmode)) {
-    for (i = 0; i < layer->class[c]->numstyles; i++) {
-      if (msScaleInBounds(map->scaledenom, layer->class[c]->styles[i]->minscaledenom,
-                          layer->class[c]->styles[i]->maxscaledenom)) {
-        if (layer->class[c]->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_NONE) {
-          if(MS_UNLIKELY(MS_FAILURE == msDrawShadeSymbol(map, image, shape, layer->class[c]->styles[i], layer->class[c]->styles[i]->scalefactor))) {
+  if (MS_DRAW_FEATURES(drawmode)) {
+    for (i = 0; i < layer->class[c] -> numstyles; i++) {
+      if (msScaleInBounds(map->scaledenom,
+                          layer->class[c] -> styles[i] -> minscaledenom,
+                          layer -> class[c] -> styles[i] -> maxscaledenom)) {
+        if (layer->class[c] -> styles[i] -> _geomtransform.type ==
+                                                MS_GEOMTRANSFORM_NONE) {
+          if (MS_UNLIKELY(MS_FAILURE ==
+                          msDrawShadeSymbol(
+                              map, image, shape, layer->class[c] -> styles[i],
+                              layer -> class[c] -> styles[i] -> scalefactor))) {
             return MS_FAILURE;
           }
-        }
-        else {
-          if(MS_UNLIKELY(MS_FAILURE == msDrawTransformedShape(map, image, unclipped_shape,
-                                 layer->class[c]->styles[i], layer->class[c]->styles[i]->scalefactor))) {
+        } else {
+          if (MS_UNLIKELY(MS_FAILURE ==
+                          msDrawTransformedShape(
+                              map, image, unclipped_shape,
+                              layer->class[c] -> styles[i],
+                              layer -> class[c] -> styles[i] -> scalefactor))) {
             return MS_FAILURE;
           }
         }
@@ -2019,22 +2267,37 @@ int polygonLayerDrawShape(mapObj *map, i
     }
   }
 
-  if(MS_DRAW_LABELS(drawmode)) {
-    if (layer->class[c]->numlabels > 0) {
-      double minfeaturesize = layer->class[c]->labels[0]->minfeaturesize * image->resolutionfactor;
-      if (msPolygonLabelPoint(anno_shape, &annopnt, minfeaturesize) == MS_SUCCESS) {
-        for (i = 0; i < layer->class[c]->numlabels; i++)
-          if (layer->class[c]->labels[i]->angle != 0) layer->class[c]->labels[i]->angle -= map->gt.rotation_angle; /* TODO: is this correct ??? */
+  if (MS_DRAW_LABELS(drawmode)) {
+    if (layer->class[c] -> numlabels > 0) {
+      double minfeaturesize =
+          layer->class[c]->labels[0]->minfeaturesize * image->resolutionfactor;
+      if (msPolygonLabelPoint(anno_shape, &annopnt, minfeaturesize) ==
+          MS_SUCCESS) {
+        for (i = 0; i < layer->class[c] -> numlabels; i++)
+          if (layer->class[c] -> labels[i] -> angle != 0)
+            layer->class[c]->labels[i]->angle -=
+                map->gt.rotation_angle; /* TODO: is this correct ??? */
         if (layer->labelcache) {
           if (msAddLabelGroup(map, image, layer, c, anno_shape, &annopnt,
-                              MS_MIN(shape->bounds.maxx - shape->bounds.minx, shape->bounds.maxy - shape->bounds.miny)) != MS_SUCCESS) {
+                              MS_MIN(shape->bounds.maxx - shape->bounds.minx,
+                                     shape->bounds.maxy -
+                                         shape->bounds.miny)) != MS_SUCCESS) {
             return MS_FAILURE;
           }
         } else {
-          for (i = 0; i < layer->class[c]->numlabels; i++)
-            if(msGetLabelStatus(map,layer,shape,layer->class[c]->labels[i]) == MS_ON) {
-              char *annotext = msShapeGetLabelAnnotation(layer,shape,layer->class[c]->labels[i]); /*ownership taken by msDrawLabel, no need to free */
-              if(MS_UNLIKELY(MS_FAILURE == msDrawLabel(map, image, annopnt, annotext, layer->class[c]->labels[i], layer->class[c]->labels[i]->scalefactor))) {
+          for (i = 0; i < layer->class[c] -> numlabels; i++)
+            if (msGetLabelStatus(map, layer, shape,
+                                 layer->class[c] -> labels[i]) == MS_ON) {
+              char *annotext = msShapeGetLabelAnnotation(
+                  layer, shape,
+                  layer->class[c]
+                  -> labels[i]); /*ownership taken by msDrawLabel, no need to
+                                    free */
+              if (MS_UNLIKELY(MS_FAILURE ==
+                              msDrawLabel(map, image, annopnt, annotext,
+                                          layer->class[c] -> labels[i],
+                                          layer -> class[c] -> labels[i]
+                                          -> scalefactor))) {
                 return MS_FAILURE;
               }
             }
@@ -2046,74 +2309,81 @@ int polygonLayerDrawShape(mapObj *map, i
 }
 
 /*
-** Function to render an individual shape, the style variable enables/disables the drawing of a single style
-** versus a single style. This is necessary when drawing entire layers as proper overlay can only be achived
-** through caching. "querymapMode" parameter is used to tell msBindLayerToShape to not override the
+** Function to render an individual shape, the style variable enables/disables
+*the drawing of a single style
+** versus a single style. This is necessary when drawing entire layers as proper
+*overlay can only be achived
+** through caching. "querymapMode" parameter is used to tell msBindLayerToShape
+*to not override the
 ** QUERYMAP HILITE color.
 */
-int msDrawShape(mapObj *map, layerObj *layer, shapeObj *shape, imageObj *image, int style, int drawmode)
-{
-  int c,s,ret=MS_SUCCESS;
+int msDrawShape(mapObj *map, layerObj *layer, shapeObj *shape, imageObj *image,
+                int style, int drawmode) {
+  int c, s, ret = MS_SUCCESS;
   shapeObj *anno_shape, *unclipped_shape = shape;
   int bNeedUnclippedShape = MS_FALSE;
   int bNeedUnclippedAnnoShape = MS_FALSE;
   int bShapeNeedsClipping = MS_TRUE;
 
-  if(shape->numlines == 0 || shape->type == MS_SHAPE_NULL) return MS_SUCCESS;
+  if (shape->numlines == 0 || shape->type == MS_SHAPE_NULL)
+    return MS_SUCCESS;
 
   c = shape->classindex;
 
   /* Before we do anything else, we will check for a rangeitem.
      If its there, we need to change the style's color to map
      the range to the shape */
-  for(s=0; s<layer->class[c]->numstyles; s++) {
+  for (s = 0; s < layer->class[c] -> numstyles; s++) {
     styleObj *style = layer->class[c]->styles[s];
-    if(style->rangeitem !=  NULL)
-      msShapeToRange((layer->class[c]->styles[s]), shape);
+    if (style->rangeitem != NULL)
+      msShapeToRange((layer->class[c] -> styles[s]), shape);
   }
 
   /* circle and point layers go through their own treatment */
-  if(layer->type == MS_LAYER_CIRCLE) {
-    if(msBindLayerToShape(layer, shape, drawmode) != MS_SUCCESS) return MS_FAILURE;
+  if (layer->type == MS_LAYER_CIRCLE) {
+    if (msBindLayerToShape(layer, shape, drawmode) != MS_SUCCESS)
+      return MS_FAILURE;
     msDrawStartShape(map, layer, image, shape);
-    ret = circleLayerDrawShape(map,image,layer,shape);
-    msDrawEndShape(map,layer,image,shape);
+    ret = circleLayerDrawShape(map, image, layer, shape);
+    msDrawEndShape(map, layer, image, shape);
     return ret;
-  } else if(layer->type == MS_LAYER_POINT || layer->type == MS_LAYER_RASTER) {
-    if(msBindLayerToShape(layer, shape, drawmode) != MS_SUCCESS) return MS_FAILURE;
+  } else if (layer->type == MS_LAYER_POINT || layer->type == MS_LAYER_RASTER) {
+    if (msBindLayerToShape(layer, shape, drawmode) != MS_SUCCESS)
+      return MS_FAILURE;
     msDrawStartShape(map, layer, image, shape);
-    ret = pointLayerDrawShape(map,image,layer,shape,drawmode);
-    msDrawEndShape(map,layer,image,shape);
+    ret = pointLayerDrawShape(map, image, layer, shape, drawmode);
+    msDrawEndShape(map, layer, image, shape);
     return ret;
   }
 
   if (layer->type == MS_LAYER_POLYGON && shape->type != MS_SHAPE_POLYGON) {
-    msSetError(MS_MISCERR, "Only polygon shapes can be drawn using a polygon layer definition.", "polygonLayerDrawShape()");
+    msSetError(
+        MS_MISCERR,
+        "Only polygon shapes can be drawn using a polygon layer definition.",
+        "polygonLayerDrawShape()");
     return (MS_FAILURE);
   }
-  if (layer->type == MS_LAYER_LINE && shape->type != MS_SHAPE_POLYGON && shape->type != MS_SHAPE_LINE) {
-    msSetError(MS_MISCERR, "Only polygon or line shapes can be drawn using a line layer definition.", "msDrawShape()");
+  if (layer->type == MS_LAYER_LINE && shape->type != MS_SHAPE_POLYGON &&
+      shape->type != MS_SHAPE_LINE) {
+    msSetError(MS_MISCERR,
+               "Only polygon or line shapes can be drawn using a line layer "
+               "definition.",
+               "msDrawShape()");
     return (MS_FAILURE);
   }
 
-  if (layer->project && layer->transform == MS_TRUE)
-  {
-      if( layer->reprojectorLayerToMap == NULL )
-      {
-          layer->reprojectorLayerToMap = msProjectCreateReprojector(
-              &layer->projection, &map->projection);
-        if( layer->reprojectorLayerToMap == NULL )
-        {
-            return MS_FAILURE;
-        }
-      }
-      msProjectShapeEx(layer->reprojectorLayerToMap, shape);
+  if (layer->project && layer->transform == MS_TRUE) {
+    reprojectionObj *reprojector = msLayerGetReprojectorToMap(layer, map);
+    if (reprojector == NULL) {
+      return MS_FAILURE;
+    }
+    msProjectShapeEx(reprojector, shape);
   }
 
   /* check if we'll need the unclipped shape */
   if (shape->type != MS_SHAPE_POINT) {
-    if(MS_DRAW_FEATURES(drawmode)) {
-      for (s = 0; s < layer->class[c]->numstyles; s++) {
+    if (MS_DRAW_FEATURES(drawmode)) {
+      for (s = 0; s < layer->class[c] -> numstyles; s++) {
         styleObj *style = layer->class[c]->styles[s];
         if (style->_geomtransform.type != MS_GEOMTRANSFORM_NONE)
           bNeedUnclippedShape = MS_TRUE;
@@ -2126,31 +2396,33 @@ int msDrawShape(mapObj *map, layerObj *l
         shape->bounds.maxy > map->extent.maxy) {
       bShapeNeedsClipping = MS_TRUE;
     }
-   
-    if(MS_DRAW_LABELS(drawmode) && MS_DRAW_UNCLIPPED_LABELS(drawmode)) {
+
+    if (MS_DRAW_LABELS(drawmode) && MS_DRAW_UNCLIPPED_LABELS(drawmode)) {
       bNeedUnclippedAnnoShape = MS_TRUE;
       bNeedUnclippedShape = MS_TRUE;
     }
 
-    if(MS_DRAW_UNCLIPPED_LINES(drawmode)) {
+    if (MS_DRAW_UNCLIPPED_LINES(drawmode)) {
       bShapeNeedsClipping = MS_FALSE;
     }
   } else {
     bShapeNeedsClipping = MS_FALSE;
   }
 
-  if(layer->transform == MS_TRUE && bShapeNeedsClipping) {
-    /* compute the size of the clipping buffer, in pixels. This buffer must account
-     for the size of symbols drawn to avoid artifacts around the image edges */
+  if (layer->transform == MS_TRUE && bShapeNeedsClipping) {
+    /* compute the size of the clipping buffer, in pixels. This buffer must
+     account for the size of symbols drawn to avoid artifacts around the image
+     edges */
     int clip_buf = 0;
     int s;
     rectObj cliprect;
-    for (s=0;s<layer->class[c]->numstyles;s++) {
+    for (s = 0; s < layer->class[c] -> numstyles; s++) {
       double maxsize, maxunscaledsize;
       symbolObj *symbol;
       styleObj *style = layer->class[c]->styles[s];
       if (!MS_IS_VALID_ARRAY_INDEX(style->symbol, map->symbolset.numsymbols)) {
-        msSetError(MS_SYMERR, "Invalid symbol index: %d", "msDrawShape()", style->symbol);
+        msSetError(MS_SYMERR, "Invalid symbol index: %d", "msDrawShape()",
+                   style->symbol);
         return MS_FAILURE;
       }
       symbol = map->symbolset.symbol[style->symbol];
@@ -2162,68 +2434,77 @@ int msDrawShape(mapObj *map, layerObj *l
         if (MS_SUCCESS != msPreloadSVGSymbol(symbol))
           return MS_FAILURE;
 #else
-        msSetError(MS_SYMERR, "SVG symbol support is not enabled.", "msDrawShape()");
+        msSetError(MS_SYMERR, "SVG symbol support is not enabled.",
+                   "msDrawShape()");
         return MS_FAILURE;
 #endif
       }
-      maxsize = MS_MAX(msSymbolGetDefaultSize(symbol), MS_MAX(style->size, style->width));
-      maxunscaledsize = MS_MAX(style->minsize*image->resolutionfactor, style->minwidth*image->resolutionfactor);
-      if(shape->type == MS_SHAPE_POLYGON && !IS_PARALLEL_OFFSET(style->offsety)) {
-         maxsize += MS_MAX(fabs(style->offsety),fabs(style->offsetx));
-      }
-      clip_buf = MS_MAX(clip_buf,MS_NINT(MS_MAX(maxsize * style->scalefactor, maxunscaledsize) + 1));
-    }
-
-
-    /* if we need a copy of the unclipped shape, transform first, then clip to avoid transforming twice */
-    if(bNeedUnclippedShape) {
+      maxsize = MS_MAX(msSymbolGetDefaultSize(symbol),
+                       MS_MAX(style->size, style->width));
+      maxunscaledsize = MS_MAX(style->minsize * image->resolutionfactor,
+                               style->minwidth * image->resolutionfactor);
+      if (shape->type == MS_SHAPE_POLYGON &&
+          !IS_PARALLEL_OFFSET(style->offsety)) {
+        maxsize += MS_MAX(fabs(style->offsety), fabs(style->offsetx));
+      }
+      clip_buf = MS_MAX(
+          clip_buf,
+          MS_NINT(MS_MAX(maxsize * style->scalefactor, maxunscaledsize) + 1));
+    }
+
+    /* if we need a copy of the unclipped shape, transform first, then clip to
+     * avoid transforming twice */
+    if (bNeedUnclippedShape) {
       msTransformShape(shape, map->extent, map->cellsize, image);
-      if(shape->numlines == 0) return MS_SUCCESS;
+      if (shape->numlines == 0)
+        return MS_SUCCESS;
       msComputeBounds(shape);
 
       /* TODO: there's an optimization here that can be implemented:
          - no need to allocate unclipped_shape for each call to this function
-         - the calls to msClipXXXRect will discard the original lineObjs, whereas
-           we have just copied them because they where needed. These two functions
-           could be changed so they are instructed not to free the original lineObjs. */
-      unclipped_shape = (shapeObj *) msSmallMalloc(sizeof (shapeObj));
+         - the calls to msClipXXXRect will discard the original lineObjs,
+         whereas we have just copied them because they where needed. These two
+         functions could be changed so they are instructed not to free the
+         original lineObjs. */
+      unclipped_shape = (shapeObj *)msSmallMalloc(sizeof(shapeObj));
       msInitShape(unclipped_shape);
       msCopyShape(shape, unclipped_shape);
-      if(shape->type == MS_SHAPE_POLYGON) {
-         /* #179: additional buffer for polygons */
-         clip_buf += 2;
+      if (shape->type == MS_SHAPE_POLYGON) {
+        /* #179: additional buffer for polygons */
+        clip_buf += 2;
       }
 
       cliprect.minx = cliprect.miny = -clip_buf;
       cliprect.maxx = image->width + clip_buf;
       cliprect.maxy = image->height + clip_buf;
-      if(shape->type == MS_SHAPE_POLYGON) {
+      if (shape->type == MS_SHAPE_POLYGON) {
         msClipPolygonRect(shape, cliprect);
       } else {
         assert(shape->type == MS_SHAPE_LINE);
         msClipPolylineRect(shape, cliprect);
       }
-      if(bNeedUnclippedAnnoShape) {
+      if (bNeedUnclippedAnnoShape) {
         anno_shape = unclipped_shape;
       } else {
         anno_shape = shape;
       }
     } else {
-      /* clip first, then transform. This means we are clipping in geographical space */
+      /* clip first, then transform. This means we are clipping in geographical
+       * space */
       double clip_buf_d;
-      if(shape->type == MS_SHAPE_POLYGON) {
-         /*
-          * add a small buffer around the cliping rectangle to
-          * avoid lines around the edges : #179
-          */
-         clip_buf += 2;
+      if (shape->type == MS_SHAPE_POLYGON) {
+        /*
+         * add a small buffer around the cliping rectangle to
+         * avoid lines around the edges : #179
+         */
+        clip_buf += 2;
       }
       clip_buf_d = clip_buf * map->cellsize;
       cliprect.minx = map->extent.minx - clip_buf_d;
       cliprect.miny = map->extent.miny - clip_buf_d;
       cliprect.maxx = map->extent.maxx + clip_buf_d;
       cliprect.maxy = map->extent.maxy + clip_buf_d;
-      if(shape->type == MS_SHAPE_POLYGON) {
+      if (shape->type == MS_SHAPE_POLYGON) {
         msClipPolygonRect(shape, cliprect);
       } else {
         assert(shape->type == MS_SHAPE_LINE);
@@ -2236,7 +2517,8 @@ int msDrawShape(mapObj *map, layerObj *l
 
   } else {
     /* the shape is fully in the map extent,
-     * or is a point type layer where out of bounds points are treated differently*/
+     * or is a point type layer where out of bounds points are treated
+     * differently*/
     if (layer->transform == MS_TRUE) {
       msTransformShape(shape, map->extent, map->cellsize, image);
       msComputeBounds(shape);
@@ -2245,36 +2527,38 @@ int msDrawShape(mapObj *map, layerObj *l
     }
     anno_shape = shape;
   }
-  if(shape->numlines == 0) {
+  if (shape->numlines == 0) {
     ret = MS_SUCCESS; /* error message is set in msBindLayerToShape() */
     goto draw_shape_cleanup;
   }
 
-  if(msBindLayerToShape(layer, shape, drawmode) != MS_SUCCESS) {
+  if (msBindLayerToShape(layer, shape, drawmode) != MS_SUCCESS) {
     ret = MS_FAILURE; /* error message is set in msBindLayerToShape() */
     goto draw_shape_cleanup;
   }
 
-  switch(layer->type) {
-    case MS_LAYER_LINE:
-      msDrawStartShape(map, layer, image, shape);
-      ret = lineLayerDrawShape(map, image, layer, shape, anno_shape, unclipped_shape, style, drawmode);
-      break;
-    case MS_LAYER_POLYGON:
-      msDrawStartShape(map, layer, image, shape);
-      ret = polygonLayerDrawShape(map, image, layer, shape, anno_shape, unclipped_shape, drawmode);
-      break;
-    case MS_LAYER_POINT:
-    case MS_LAYER_RASTER:
-      assert(0); //bug !
-    default:
-      msSetError(MS_MISCERR, "Unknown layer type.", "msDrawShape()");
-      ret = MS_FAILURE;
+  switch (layer->type) {
+  case MS_LAYER_LINE:
+    msDrawStartShape(map, layer, image, shape);
+    ret = lineLayerDrawShape(map, image, layer, shape, anno_shape,
+                             unclipped_shape, style, drawmode);
+    break;
+  case MS_LAYER_POLYGON:
+    msDrawStartShape(map, layer, image, shape);
+    ret = polygonLayerDrawShape(map, image, layer, shape, anno_shape,
+                                unclipped_shape, drawmode);
+    break;
+  case MS_LAYER_POINT:
+  case MS_LAYER_RASTER:
+    assert(0); // bug !
+  default:
+    msSetError(MS_MISCERR, "Unknown layer type.", "msDrawShape()");
+    ret = MS_FAILURE;
   }
 
 draw_shape_cleanup:
-  msDrawEndShape(map,layer,image,shape);
-  if(unclipped_shape != shape) {
+  msDrawEndShape(map, layer, image, shape);
+  if (unclipped_shape != shape) {
     msFreeShape(unclipped_shape);
     msFree(unclipped_shape);
   }
@@ -2282,93 +2566,107 @@ draw_shape_cleanup:
 }
 
 /*
-** Function to render an individual point, used as a helper function for mapscript only. Since a point
+** Function to render an individual point, used as a helper function for
+*mapscript only. Since a point
 ** can't carry attributes you can't do attribute based font size or angle.
 */
-int msDrawPoint(mapObj *map, layerObj *layer, pointObj *point, imageObj *image, int classindex, char *labeltext)
-{
-  int s,ret;
-  classObj *theclass=NULL;
-  labelObj *label=NULL;
+int msDrawPoint(mapObj *map, layerObj *layer, pointObj *point, imageObj *image,
+                int classindex, char *labeltext) {
+  int s, ret;
+  classObj *theclass = NULL;
+  labelObj *label = NULL;
 
-  if(layer->transform == MS_TRUE && layer->project && msProjectionsDiffer(&(layer->projection), &(map->projection))) {
+  if (layer->transform == MS_TRUE && layer->project &&
+      msProjectionsDiffer(&(layer->projection), &(map->projection))) {
     msProjectPoint(&(layer->projection), &(map->projection), point);
   }
-  
-  if(classindex > layer->numclasses) {
-    msSetError(MS_MISCERR, "Invalid classindex (%d)", "msDrawPoint()", classindex);
-    return MS_FAILURE; 
+
+  if (classindex > layer->numclasses) {
+    msSetError(MS_MISCERR, "Invalid classindex (%d)", "msDrawPoint()",
+               classindex);
+    return MS_FAILURE;
   }
   theclass = layer->class[classindex];
-  
-  if(labeltext && theclass->numlabels > 0) {
+
+  if (labeltext && theclass->numlabels > 0) {
     label = theclass->labels[0];
   }
-  
-  switch(layer->type) {
-    case MS_LAYER_POINT:
-      if(layer->transform == MS_TRUE) {
-        if(!msPointInRect(point, &map->extent)) return(0);
-        point->x = MS_MAP2IMAGE_X(point->x, map->extent.minx, map->cellsize);
-        point->y = MS_MAP2IMAGE_Y(point->y, map->extent.maxy, map->cellsize);
-      } else
-        msOffsetPointRelativeTo(point, layer);
 
-      for(s=0; s<theclass->numstyles; s++) {
-        if(msScaleInBounds(map->scaledenom, theclass->styles[s]->minscaledenom, theclass->styles[s]->maxscaledenom))
-          if(MS_UNLIKELY(MS_FAILURE == msDrawMarkerSymbol(map, image, point, theclass->styles[s], theclass->styles[s]->scalefactor))) {
-            return MS_FAILURE;
-          }
-      }
-      if(label && labeltext && *labeltext) {
-        textSymbolObj *ts = msSmallMalloc(sizeof(textSymbolObj));
-        initTextSymbol(ts);
-        msPopulateTextSymbolForLabelAndString(ts, label, msStrdup(labeltext), label->scalefactor, image->resolutionfactor, layer->labelcache);
-        if(layer->labelcache) {
-          if(msAddLabel(map, image, label, layer->index, classindex, NULL, point, -1, ts) != MS_SUCCESS) {
-            return(MS_FAILURE);
-          }
-        } else {
-          if(MS_UNLIKELY(MS_FAILURE == msComputeTextPath(map,ts))) {
-            freeTextSymbol(ts);
-            free(ts);
-            return MS_FAILURE;
-          }
-          ret = msDrawTextSymbol(map,image,*point,ts);
+  switch (layer->type) {
+  case MS_LAYER_POINT:
+    if (layer->transform == MS_TRUE) {
+      if (!msPointInRect(point, &map->extent))
+        return (0);
+      point->x = MS_MAP2IMAGE_X(point->x, map->extent.minx, map->cellsize);
+      point->y = MS_MAP2IMAGE_Y(point->y, map->extent.maxy, map->cellsize);
+    } else
+      msOffsetPointRelativeTo(point, layer);
+
+    for (s = 0; s < theclass->numstyles; s++) {
+      if (msScaleInBounds(map->scaledenom, theclass->styles[s]->minscaledenom,
+                          theclass->styles[s]->maxscaledenom))
+        if (MS_UNLIKELY(MS_FAILURE ==
+                        msDrawMarkerSymbol(map, image, point,
+                                           theclass->styles[s],
+                                           theclass->styles[s]->scalefactor))) {
+          return MS_FAILURE;
+        }
+    }
+    if (label && labeltext && *labeltext) {
+      textSymbolObj *ts = msSmallMalloc(sizeof(textSymbolObj));
+      initTextSymbol(ts);
+      msPopulateTextSymbolForLabelAndString(
+          ts, label, msStrdup(labeltext), label->scalefactor,
+          image->resolutionfactor, layer->labelcache);
+      if (layer->labelcache) {
+        if (msAddLabel(map, image, label, layer->index, classindex, NULL, point,
+                       -1, ts) != MS_SUCCESS) {
+          return (MS_FAILURE);
+        }
+      } else {
+        if (MS_UNLIKELY(MS_FAILURE == msComputeTextPath(map, ts))) {
           freeTextSymbol(ts);
-          free(ts); 
-          if(MS_UNLIKELY(ret == MS_FAILURE)) return MS_FAILURE;
+          free(ts);
+          return MS_FAILURE;
         }
+        ret = msDrawTextSymbol(map, image, *point, ts);
+        freeTextSymbol(ts);
+        free(ts);
+        if (MS_UNLIKELY(ret == MS_FAILURE))
+          return MS_FAILURE;
       }
-      break;
-    default:
-      break; /* don't do anything with layer of other types */
+    }
+    break;
+  default:
+    break; /* don't do anything with layer of other types */
   }
 
-  return(MS_SUCCESS); /* all done, no cleanup */
+  return (MS_SUCCESS); /* all done, no cleanup */
 }
 
 /*
-** Draws a single label independently of the label cache. No collision avoidance is performed.
+** Draws a single label independently of the label cache. No collision avoidance
+*is performed.
 */
-int msDrawLabel(mapObj *map, imageObj *image, pointObj labelPnt, char *string, labelObj *label, double scalefactor)
-{
+int msDrawLabel(mapObj *map, imageObj *image, pointObj labelPnt, char *string,
+                labelObj *label, double scalefactor) {
   shapeObj labelPoly;
   label_bounds lbounds = {0};
   lineObj labelPolyLine;
   pointObj labelPolyPoints[5];
   textSymbolObj ts = {0};
-  int needLabelPoly=MS_TRUE;
-  int needLabelPoint=MS_TRUE;
-  int haveLabelText=MS_TRUE;
+  int needLabelPoly = MS_TRUE;
+  int needLabelPoint = MS_TRUE;
+  int haveLabelText = MS_TRUE;
 
-  if(!string || !*string)
+  if (!string || !*string)
     haveLabelText = MS_FALSE;
 
-  if(haveLabelText) {
+  if (haveLabelText) {
     initTextSymbol(&ts);
-    msPopulateTextSymbolForLabelAndString(&ts, label, string, scalefactor, image->resolutionfactor, 0);
-    if(MS_UNLIKELY(MS_FAILURE == msComputeTextPath(map,&ts))) {
+    msPopulateTextSymbolForLabelAndString(&ts, label, string, scalefactor,
+                                          image->resolutionfactor, 0);
+    if (MS_UNLIKELY(MS_FAILURE == msComputeTextPath(map, &ts))) {
       freeTextSymbol(&ts);
       return MS_FAILURE;
     }
@@ -2380,24 +2678,33 @@ int msDrawLabel(mapObj *map, imageObj *i
   labelPoly.line->point = labelPolyPoints;
   labelPoly.line->numpoints = 5;
 
-  if(label->position != MS_XY) {
+  if (label->position != MS_XY) {
     pointObj p = {0};
 
-    if(label->numstyles > 0) {
+    if (label->numstyles > 0) {
       int i;
 
-      for(i=0; i<label->numstyles; i++) {
-        if(label->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOINT || label->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_NONE) {
-          if(MS_UNLIKELY(MS_FAILURE == msDrawMarkerSymbol(map, image, &labelPnt, label->styles[i], scalefactor))) {
-            if(haveLabelText)
+      for (i = 0; i < label->numstyles; i++) {
+        if (label->styles[i]->_geomtransform.type ==
+                MS_GEOMTRANSFORM_LABELPOINT ||
+            label->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_NONE) {
+          if (MS_UNLIKELY(MS_FAILURE ==
+                          msDrawMarkerSymbol(map, image, &labelPnt,
+                                             label->styles[i], scalefactor))) {
+            if (haveLabelText)
               freeTextSymbol(&ts);
             return MS_FAILURE;
           }
-        } else if(haveLabelText && (label->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOLY || label->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_LABELCENTER)) {
-          if(needLabelPoly) {
-            p = get_metrics(&labelPnt, label->position, ts.textpath, label->offsetx * ts.scalefactor,
-                    label->offsety * ts.scalefactor, ts.rotation, 1, &lbounds);
-            if(!lbounds.poly) {
+        } else if (haveLabelText && (label->styles[i]->_geomtransform.type ==
+                                         MS_GEOMTRANSFORM_LABELPOLY ||
+                                     label->styles[i]->_geomtransform.type ==
+                                         MS_GEOMTRANSFORM_LABELCENTER)) {
+          if (needLabelPoly) {
+            p = get_metrics(&labelPnt, label->position, ts.textpath,
+                            label->offsetx * ts.scalefactor,
+                            label->offsety * ts.scalefactor, ts.rotation, 1,
+                            &lbounds);
+            if (!lbounds.poly) {
               /* we need the full shape to draw the label background */
               labelPolyPoints[0].x = labelPolyPoints[4].x = lbounds.bbox.minx;
               labelPolyPoints[0].y = labelPolyPoints[4].y = lbounds.bbox.miny;
@@ -2411,36 +2718,45 @@ int msDrawLabel(mapObj *map, imageObj *i
             needLabelPoint = MS_FALSE; /* don't re-compute */
             needLabelPoly = MS_FALSE;
           }
-          if(label->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOLY) {
-            if(MS_UNLIKELY(MS_FAILURE == msDrawShadeSymbol(map, image, &labelPoly, label->styles[i], ts.scalefactor))) {
+          if (label->styles[i]->_geomtransform.type ==
+              MS_GEOMTRANSFORM_LABELPOLY) {
+            if (MS_UNLIKELY(MS_FAILURE == msDrawShadeSymbol(map, image,
+                                                            &labelPoly,
+                                                            label->styles[i],
+                                                            ts.scalefactor))) {
               freeTextSymbol(&ts);
               return MS_FAILURE;
             }
           } else {
             pointObj labelCenter;
-            labelCenter.x = (lbounds.bbox.maxx + lbounds.bbox.minx)/2;
-            labelCenter.y = (lbounds.bbox.maxy + lbounds.bbox.miny)/2;
-            if(MS_UNLIKELY(MS_FAILURE == msDrawMarkerSymbol(map, image, &labelCenter, label->styles[i], scalefactor))) {
+            labelCenter.x = (lbounds.bbox.maxx + lbounds.bbox.minx) / 2;
+            labelCenter.y = (lbounds.bbox.maxy + lbounds.bbox.miny) / 2;
+            if (MS_UNLIKELY(MS_FAILURE == msDrawMarkerSymbol(
+                                              map, image, &labelCenter,
+                                              label->styles[i], scalefactor))) {
               freeTextSymbol(&ts);
               return MS_FAILURE;
             }
           }
         } else {
-          msSetError(MS_MISCERR,"Unknown label geomtransform %s", "msDrawLabel()",label->styles[i]->_geomtransform.string);
-          if(haveLabelText)
+          msSetError(MS_MISCERR, "Unknown label geomtransform %s",
+                     "msDrawLabel()", label->styles[i]->_geomtransform.string);
+          if (haveLabelText)
             freeTextSymbol(&ts);
           return MS_FAILURE;
         }
       }
     }
 
-    if(haveLabelText) {
-      if(needLabelPoint)
-        p = get_metrics(&labelPnt, label->position, ts.textpath, label->offsetx * ts.scalefactor,
-                        label->offsety * ts.scalefactor, ts.rotation, 0, &lbounds);
+    if (haveLabelText) {
+      if (needLabelPoint)
+        p = get_metrics(&labelPnt, label->position, ts.textpath,
+                        label->offsetx * ts.scalefactor,
+                        label->offsety * ts.scalefactor, ts.rotation, 0,
+                        &lbounds);
 
       /* draw the label text */
-      if(MS_UNLIKELY(MS_FAILURE == msDrawTextSymbol(map,image,p,&ts))) {
+      if (MS_UNLIKELY(MS_FAILURE == msDrawTextSymbol(map, image, p, &ts))) {
         freeTextSymbol(&ts);
         return MS_FAILURE;
       }
@@ -2449,22 +2765,30 @@ int msDrawLabel(mapObj *map, imageObj *i
     labelPnt.x += label->offsetx * ts.scalefactor;
     labelPnt.y += label->offsety * ts.scalefactor;
 
-    if(label->numstyles > 0) {
+    if (label->numstyles > 0) {
       int i;
 
-      for(i=0; i<label->numstyles; i++) {
-        if(label->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOINT ||
-           label->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_NONE) {
-          if(MS_UNLIKELY(MS_FAILURE == msDrawMarkerSymbol(map, image, &labelPnt, label->styles[i], scalefactor))) {
+      for (i = 0; i < label->numstyles; i++) {
+        if (label->styles[i]->_geomtransform.type ==
+                MS_GEOMTRANSFORM_LABELPOINT ||
+            label->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_NONE) {
+          if (MS_UNLIKELY(MS_FAILURE ==
+                          msDrawMarkerSymbol(map, image, &labelPnt,
+                                             label->styles[i], scalefactor))) {
             freeTextSymbol(&ts);
             return MS_FAILURE;
           }
-        } else if(haveLabelText && (label->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOLY || label->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_LABELCENTER)) {
-          if(needLabelPoly) {
-            get_metrics(&labelPnt, label->position, ts.textpath, label->offsetx * ts.scalefactor,
-                    label->offsety * ts.scalefactor, ts.rotation, 1, &lbounds);
+        } else if (haveLabelText && (label->styles[i]->_geomtransform.type ==
+                                         MS_GEOMTRANSFORM_LABELPOLY ||
+                                     label->styles[i]->_geomtransform.type ==
+                                         MS_GEOMTRANSFORM_LABELCENTER)) {
+          if (needLabelPoly) {
+            get_metrics(&labelPnt, label->position, ts.textpath,
+                        label->offsetx * ts.scalefactor,
+                        label->offsety * ts.scalefactor, ts.rotation, 1,
+                        &lbounds);
             needLabelPoly = MS_FALSE; /* don't re-compute */
-            if(!lbounds.poly) {
+            if (!lbounds.poly) {
               /* we need the full shape to draw the label background */
               labelPolyPoints[0].x = labelPolyPoints[4].x = lbounds.bbox.minx;
               labelPolyPoints[0].y = labelPolyPoints[4].y = lbounds.bbox.miny;
@@ -2476,54 +2800,63 @@ int msDrawLabel(mapObj *map, imageObj *i
               labelPolyPoints[3].y = lbounds.bbox.miny;
             }
           }
-          if(label->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOLY) {
-            if(MS_UNLIKELY(MS_FAILURE == msDrawShadeSymbol(map, image, &labelPoly, label->styles[i], scalefactor))) {
+          if (label->styles[i]->_geomtransform.type ==
+              MS_GEOMTRANSFORM_LABELPOLY) {
+            if (MS_UNLIKELY(MS_FAILURE ==
+                            msDrawShadeSymbol(map, image, &labelPoly,
+                                              label->styles[i], scalefactor))) {
               freeTextSymbol(&ts);
               return MS_FAILURE;
             }
           } else {
-	    pointObj labelCenter;
-            labelCenter.x = (lbounds.bbox.maxx + lbounds.bbox.minx)/2;
-            labelCenter.y = (lbounds.bbox.maxy + lbounds.bbox.miny)/2;
-            if(MS_UNLIKELY(MS_FAILURE == msDrawMarkerSymbol(map, image, &labelCenter, label->styles[i], scalefactor))) {
+            pointObj labelCenter;
+            labelCenter.x = (lbounds.bbox.maxx + lbounds.bbox.minx) / 2;
+            labelCenter.y = (lbounds.bbox.maxy + lbounds.bbox.miny) / 2;
+            if (MS_UNLIKELY(MS_FAILURE == msDrawMarkerSymbol(
+                                              map, image, &labelCenter,
+                                              label->styles[i], scalefactor))) {
               freeTextSymbol(&ts);
               return MS_FAILURE;
             }
           }
         } else {
-          msSetError(MS_MISCERR,"Unknown label geomtransform %s", "msDrawLabel()",label->styles[i]->_geomtransform.string);
-          if(haveLabelText)
+          msSetError(MS_MISCERR, "Unknown label geomtransform %s",
+                     "msDrawLabel()", label->styles[i]->_geomtransform.string);
+          if (haveLabelText)
             freeTextSymbol(&ts);
           return MS_FAILURE;
         }
       }
     }
 
-    if(haveLabelText) {
+    if (haveLabelText) {
       /* draw the label text */
-      if(MS_UNLIKELY(MS_FAILURE == msDrawTextSymbol(map,image,labelPnt,&ts))) {
+      if (MS_UNLIKELY(MS_FAILURE ==
+                      msDrawTextSymbol(map, image, labelPnt, &ts))) {
         freeTextSymbol(&ts);
         return MS_FAILURE;
       }
     }
   }
-  if(haveLabelText)
+  if (haveLabelText)
     freeTextSymbol(&ts);
 
   return MS_SUCCESS;
 }
 
-static inline void offset_bbox(const rectObj *from, rectObj *to, double ox, double oy) {
+static inline void offset_bbox(const rectObj *from, rectObj *to, double ox,
+                               double oy) {
   to->minx = from->minx + ox;
   to->miny = from->miny + oy;
   to->maxx = from->maxx + ox;
   to->maxy = from->maxy + oy;
 }
 
-static inline void offset_label_bounds(const label_bounds *from, label_bounds *to, double ox, double oy) {
-  if(from->poly) {
+static inline void offset_label_bounds(const label_bounds *from,
+                                       label_bounds *to, double ox, double oy) {
+  if (from->poly) {
     int i;
-    for(i=0; i<from->poly->numpoints; i++) {
+    for (i = 0; i < from->poly->numpoints; i++) {
       to->poly->point[i].x = from->poly->point[i].x + ox;
       to->poly->point[i].y = from->poly->point[i].y + oy;
     }
@@ -2535,30 +2868,33 @@ static inline void offset_label_bounds(c
 }
 
 /* private shortcut function to try a leader offsetted label
- * the caller must ensure that scratch->poly->points has been sufficiently allocated
- * to hold the points from the cachePtr's label_bounds */
-void offsetAndTest(mapObj *map, labelCacheMemberObj *cachePtr, double ox, double oy,
-                   int priority, int label_idx, label_bounds *scratch)
-{
-  int i,j,status;
+ * the caller must ensure that scratch->poly->points has been sufficiently
+ * allocated to hold the points from the cachePtr's label_bounds */
+void offsetAndTest(mapObj *map, labelCacheMemberObj *cachePtr, double ox,
+                   double oy, int priority, int label_idx,
+                   label_bounds *scratch) {
+  int i, j, status;
   pointObj leaderpt;
   lineObj *scratch_line = scratch->poly;
 
-  for(i=0; i<cachePtr->numtextsymbols; i++) {
+  for (i = 0; i < cachePtr->numtextsymbols; i++) {
     textSymbolObj *ts = cachePtr->textsymbols[i];
-    if(ts->textpath) {
+    if (ts->textpath) {
       offset_label_bounds(&ts->textpath->bounds, scratch, ox, oy);
-      status = msTestLabelCacheCollisions(map, cachePtr, scratch, priority, label_idx);
-      if(!status) {
+      status = msTestLabelCacheCollisions(map, cachePtr, scratch, priority,
+                                          label_idx);
+      if (!status) {
         return;
       }
     }
-    for(j=0; j<ts->label->numstyles; j++) {
-      if(ts->label->styles[j]->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOINT) {
+    for (j = 0; j < ts->label->numstyles; j++) {
+      if (ts->label->styles[j]->_geomtransform.type ==
+          MS_GEOMTRANSFORM_LABELPOINT) {
         scratch->poly = scratch_line;
         offset_label_bounds(ts->style_bounds[j], scratch, ox, oy);
-        status = msTestLabelCacheCollisions(map, cachePtr, scratch, priority, label_idx);
-        if(!status) {
+        status = msTestLabelCacheCollisions(map, cachePtr, scratch, priority,
+                                            label_idx);
+        if (!status) {
           return;
         }
       }
@@ -2569,11 +2905,10 @@ void offsetAndTest(mapObj *map, labelCac
   leaderpt.y = cachePtr->point.y + oy;
 
   status = msTestLabelCacheLeaderCollision(map, &cachePtr->point, &leaderpt);
-  if(!status) {
+  if (!status) {
     return;
   }
 
-
   /* the current offset is ok */
   cachePtr->leaderbbox = msSmallMalloc(sizeof(rectObj));
   cachePtr->leaderline = msSmallMalloc(sizeof(lineObj));
@@ -2581,32 +2916,31 @@ void offsetAndTest(mapObj *map, labelCac
   cachePtr->leaderline->numpoints = 2;
   cachePtr->leaderline->point[0] = cachePtr->point;
   cachePtr->leaderline->point[1] = leaderpt;
-  cachePtr->leaderbbox->minx = MS_MIN(leaderpt.x,cachePtr->point.x);
-  cachePtr->leaderbbox->maxx = MS_MAX(leaderpt.x,cachePtr->point.x);
-  cachePtr->leaderbbox->miny = MS_MIN(leaderpt.y,cachePtr->point.y);
-  cachePtr->leaderbbox->maxy = MS_MAX(leaderpt.y,cachePtr->point.y);
+  cachePtr->leaderbbox->minx = MS_MIN(leaderpt.x, cachePtr->point.x);
+  cachePtr->leaderbbox->maxx = MS_MAX(leaderpt.x, cachePtr->point.x);
+  cachePtr->leaderbbox->miny = MS_MIN(leaderpt.y, cachePtr->point.y);
+  cachePtr->leaderbbox->maxy = MS_MAX(leaderpt.y, cachePtr->point.y);
   cachePtr->status = MS_ON;
 
-  offset_bbox(&cachePtr->bbox,&cachePtr->bbox,ox,oy);
+  offset_bbox(&cachePtr->bbox, &cachePtr->bbox, ox, oy);
 
-  for(i=0; i<cachePtr->numtextsymbols; i++) {
+  for (i = 0; i < cachePtr->numtextsymbols; i++) {
     textSymbolObj *ts = cachePtr->textsymbols[i];
-    if(ts->textpath) {
+    if (ts->textpath) {
       offset_label_bounds(&ts->textpath->bounds, &ts->textpath->bounds, ox, oy);
       ts->annopoint.x += ox;
       ts->annopoint.y += oy;
     }
-    if(ts->style_bounds) {
-      for(j=0; j<ts->label->numstyles; j++) {
-        if(ts->label->styles[j]->_geomtransform.type != MS_GEOMTRANSFORM_NONE)
+    if (ts->style_bounds) {
+      for (j = 0; j < ts->label->numstyles; j++) {
+        if (ts->label->styles[j]->_geomtransform.type != MS_GEOMTRANSFORM_NONE)
           offset_label_bounds(ts->style_bounds[j], ts->style_bounds[j], ox, oy);
       }
     }
   }
 }
 
-int msDrawOffsettedLabels(imageObj *image, mapObj *map, int priority)
-{
+int msDrawOffsettedLabels(imageObj *image, mapObj *map, int priority) {
   int retval = MS_SUCCESS;
   int l;
   labelCacheObj *labelcache = &(map->labelcache);
@@ -2620,68 +2954,75 @@ int msDrawOffsettedLabels(imageObj *imag
   cacheslot = &(labelcache->slots[priority]);
   scratch.poly = &scratch_line;
 
-  for(l=cacheslot->numlabels-1; l>=0; l--) {
-    cachePtr = &(cacheslot->labels[l]); /* point to right spot in the label cache */
-    if(cachePtr->status == MS_OFF) {
+  for (l = cacheslot->numlabels - 1; l >= 0; l--) {
+    cachePtr =
+        &(cacheslot->labels[l]); /* point to right spot in the label cache */
+    if (cachePtr->status == MS_OFF) {
       /* only test regular labels that have had their bounding box computed
        and that haven't been rendered  */
-      classObj *classPtr = (GET_CLASS(map,cachePtr->layerindex,cachePtr->classindex));
-      layerObj *layerPtr = (GET_LAYER(map,cachePtr->layerindex));
-      int steps,i,num_scratch_points_to_allocate = 0;
+      classObj *classPtr =
+          (GET_CLASS(map, cachePtr->layerindex, cachePtr->classindex));
+      layerObj *layerPtr = (GET_LAYER(map, cachePtr->layerindex));
+      int steps, i, num_scratch_points_to_allocate = 0;
 
-      assert(classPtr->leader); /* cachePtrs that don't need to be tested have been marked as status on or delete */
+      assert(classPtr->leader); /* cachePtrs that don't need to be tested have
+                                   been marked as status on or delete */
 
-      if(cachePtr->point.x < labelcache->gutter ||
+      if (cachePtr->point.x < labelcache->gutter ||
           cachePtr->point.y < labelcache->gutter ||
           cachePtr->point.x >= image->width - labelcache->gutter ||
           cachePtr->point.y >= image->height - labelcache->gutter) {
-        /* don't look for leaders if point is in edge buffer as the leader line would end up chopped off */
+        /* don't look for leaders if point is in edge buffer as the leader line
+         * would end up chopped off */
         continue;
       }
 
-      for(i=0; i<cachePtr->numtextsymbols; i++) {
+      for (i = 0; i < cachePtr->numtextsymbols; i++) {
         int j;
         textSymbolObj *ts = cachePtr->textsymbols[i];
-        if(ts->textpath && ts->textpath->bounds.poly) {
-          num_scratch_points_to_allocate = MS_MAX(num_scratch_points_to_allocate, ts->textpath->bounds.poly->numpoints);
-        }
-        if(ts->style_bounds) {
-          for(j=0;j<ts->label->numstyles; j++) {
-            if(ts->label->styles[j]->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOINT &&
+        if (ts->textpath && ts->textpath->bounds.poly) {
+          num_scratch_points_to_allocate =
+              MS_MAX(num_scratch_points_to_allocate,
+                     ts->textpath->bounds.poly->numpoints);
+        }
+        if (ts->style_bounds) {
+          for (j = 0; j < ts->label->numstyles; j++) {
+            if (ts->label->styles[j]->_geomtransform.type ==
+                    MS_GEOMTRANSFORM_LABELPOINT &&
                 ts->style_bounds[j]->poly) {
-              num_scratch_points_to_allocate = MS_MAX(num_scratch_points_to_allocate, ts->style_bounds[j]->poly->numpoints);
+              num_scratch_points_to_allocate =
+                  MS_MAX(num_scratch_points_to_allocate,
+                         ts->style_bounds[j]->poly->numpoints);
             }
           }
         }
       }
-      if(num_scratch_points_to_allocate > num_allocated_scratch_points) {
-        scratch_points = msSmallRealloc(scratch_points, num_scratch_points_to_allocate * sizeof(pointObj));
+      if (num_scratch_points_to_allocate > num_allocated_scratch_points) {
+        scratch_points = msSmallRealloc(
+            scratch_points, num_scratch_points_to_allocate * sizeof(pointObj));
         num_allocated_scratch_points = num_scratch_points_to_allocate;
       }
 
-
       steps = classPtr->leader->maxdistance / classPtr->leader->gridstep;
 
 #define x0 (cachePtr->point.x)
 #define y0 (cachePtr->point.y)
 #define gridstepsc (classPtr->leader->gridstep)
 
-
-#define otest(ox,oy) if((x0+(ox)) >= labelcache->gutter &&\
-                (y0+(oy)) >= labelcache->gutter &&\
-                (x0+(ox)) < image->width - labelcache->gutter &&\
-                (y0+(oy)) < image->height - labelcache->gutter) {\
-                   scratch_line.point = scratch_points;\
-                   scratch.poly = &scratch_line; \
-                   offsetAndTest(map,cachePtr,(ox),(oy),priority,l,&scratch); \
-                   if(cachePtr->status == MS_ON) break;\
-                }
+#define otest(ox, oy)                                                          \
+  if ((x0 + (ox)) >= labelcache->gutter &&                                     \
+      (y0 + (oy)) >= labelcache->gutter &&                                     \
+      (x0 + (ox)) < image->width - labelcache->gutter &&                       \
+      (y0 + (oy)) < image->height - labelcache->gutter) {                      \
+    scratch_line.point = scratch_points;                                       \
+    scratch.poly = &scratch_line;                                              \
+    offsetAndTest(map, cachePtr, (ox), (oy), priority, l, &scratch);           \
+    if (cachePtr->status == MS_ON)                                             \
+      break;                                                                   \
+  }
 
       /* loop through possible offsetted positions */
-      for(i=1; i<=steps; i++) {
-
-
-
+      for (i = 1; i <= steps; i++) {
 
         /* test the intermediate points on the ring */
 
@@ -2696,27 +3037,27 @@ int msDrawOffsettedLabels(imageObj *imag
            X00X00X
         */
         int j;
-        for(j=1; j<i-1; j++) {
+        for (j = 1; j < i - 1; j++) {
           /* test the right positions */
-          otest(i*gridstepsc,j * gridstepsc);
-          otest(i*gridstepsc,- j * gridstepsc);
+          otest(i * gridstepsc, j * gridstepsc);
+          otest(i * gridstepsc, -j * gridstepsc);
           /* test the left positions */
-          otest(- i*gridstepsc,j * gridstepsc);
-          otest(- i*gridstepsc,- j * gridstepsc);
+          otest(-i * gridstepsc, j * gridstepsc);
+          otest(-i * gridstepsc, -j * gridstepsc);
           /* test the top positions */
-          otest(j*gridstepsc,- i * gridstepsc);
-          otest(- j *gridstepsc,- i * gridstepsc);
+          otest(j * gridstepsc, -i * gridstepsc);
+          otest(-j * gridstepsc, -i * gridstepsc);
           /* test the bottom positions */
-          otest(j*gridstepsc,i * gridstepsc);
-          otest(- j *gridstepsc,i * gridstepsc);
+          otest(j * gridstepsc, i * gridstepsc);
+          otest(-j * gridstepsc, i * gridstepsc);
         }
-        if(j<(i-1)) break;
-
-        otest(i*gridstepsc,i*gridstepsc);
-        otest(-i*gridstepsc,-i*gridstepsc);
-        otest(i*gridstepsc,-i*gridstepsc);
-        otest(-i*gridstepsc,i*gridstepsc);
+        if (j < (i - 1))
+          break;
 
+        otest(i * gridstepsc, i * gridstepsc);
+        otest(-i * gridstepsc, -i * gridstepsc);
+        otest(i * gridstepsc, -i * gridstepsc);
+        otest(-i * gridstepsc, i * gridstepsc);
 
         /* test the intermediate points on the ring */
 
@@ -2769,57 +3110,77 @@ int msDrawOffsettedLabels(imageObj *imag
          * (x0,y0-i*gridstep), pos uc
          * (x0,y0+i*gridstep), pos lc
          */
-        otest(i*gridstepsc,0);
-        otest(-i*gridstepsc,0);
-        otest(0,-i*gridstepsc);
-        otest(0,i*gridstepsc);
+        otest(i * gridstepsc, 0);
+        otest(-i * gridstepsc, 0);
+        otest(0, -i * gridstepsc);
+        otest(0, i * gridstepsc);
       }
-      if(cachePtr->status == MS_ON) {
+      if (cachePtr->status == MS_ON) {
         int ll;
-        shapeObj labelLeader; /* label polygon (bounding box, possibly rotated) */
-        labelLeader.line = cachePtr->leaderline; /* setup the label polygon structure */
+        shapeObj
+            labelLeader; /* label polygon (bounding box, possibly rotated) */
+        labelLeader.line =
+            cachePtr->leaderline; /* setup the label polygon structure */
         labelLeader.numlines = 1;
         insertRenderedLabelMember(map, cachePtr);
 
-        for(ll=0; ll<classPtr->leader->numstyles; ll++) {
-          retval = msDrawLineSymbol(map, image,&labelLeader , classPtr->leader->styles[ll], layerPtr->scalefactor);
-          if(MS_UNLIKELY(retval == MS_FAILURE)) {
+        for (ll = 0; ll < classPtr->leader->numstyles; ll++) {
+          retval = msDrawLineSymbol(map, image, &labelLeader,
+                                    classPtr->leader->styles[ll],
+                                    layerPtr->scalefactor);
+          if (MS_UNLIKELY(retval == MS_FAILURE)) {
             goto offset_cleanup;
           }
         }
-        for(ll=0; ll<cachePtr->numtextsymbols; ll++) {
+        for (ll = 0; ll < cachePtr->numtextsymbols; ll++) {
           textSymbolObj *ts = cachePtr->textsymbols[ll];
 
-          if(ts->style_bounds) {
+          if (ts->style_bounds) {
             /* here's where we draw the label styles */
-            for(i=0; i<ts->label->numstyles; i++) {
-              if(ts->label->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOINT) {
-                retval = msDrawMarkerSymbol(map, image, &(labelLeader.line->point[1]), ts->label->styles[i], layerPtr->scalefactor);
-                if(MS_UNLIKELY(retval == MS_FAILURE)) {
+            for (i = 0; i < ts->label->numstyles; i++) {
+              if (ts->label->styles[i]->_geomtransform.type ==
+                  MS_GEOMTRANSFORM_LABELPOINT) {
+                retval = msDrawMarkerSymbol(
+                    map, image, &(labelLeader.line->point[1]),
+                    ts->label->styles[i], layerPtr->scalefactor);
+                if (MS_UNLIKELY(retval == MS_FAILURE)) {
                   goto offset_cleanup;
                 }
-              } else if(ts->label->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOLY) {
-                retval = msDrawLabelBounds(map,image,ts->style_bounds[i],ts->label->styles[i], ts->scalefactor);
-                if(MS_UNLIKELY(retval == MS_FAILURE)) {
+              } else if (ts->label->styles[i]->_geomtransform.type ==
+                         MS_GEOMTRANSFORM_LABELPOLY) {
+                retval =
+                    msDrawLabelBounds(map, image, ts->style_bounds[i],
+                                      ts->label->styles[i], ts->scalefactor);
+                if (MS_UNLIKELY(retval == MS_FAILURE)) {
                   goto offset_cleanup;
                 }
-	      } else if(ts->label->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_LABELCENTER) {
+              } else if (ts->label->styles[i]->_geomtransform.type ==
+                         MS_GEOMTRANSFORM_LABELCENTER) {
                 pointObj labelCenter;
-                labelCenter.x = (ts->style_bounds[i]->bbox.maxx + ts->style_bounds[i]->bbox.minx)/2;
-                labelCenter.y = (ts->style_bounds[i]->bbox.maxy + ts->style_bounds[i]->bbox.miny)/2;
-                retval = msDrawMarkerSymbol(map, image, &labelCenter, ts->label->styles[i], layerPtr->scalefactor);
-                if(MS_UNLIKELY(retval == MS_FAILURE)) {
+                labelCenter.x = (ts->style_bounds[i]->bbox.maxx +
+                                 ts->style_bounds[i]->bbox.minx) /
+                                2;
+                labelCenter.y = (ts->style_bounds[i]->bbox.maxy +
+                                 ts->style_bounds[i]->bbox.miny) /
+                                2;
+                retval = msDrawMarkerSymbol(map, image, &labelCenter,
+                                            ts->label->styles[i],
+                                            layerPtr->scalefactor);
+                if (MS_UNLIKELY(retval == MS_FAILURE)) {
                   goto offset_cleanup;
                 }
               } else {
-                msSetError(MS_MISCERR,"Labels only support LABELPNT, LABELPOLY and LABELCENTER GEOMTRANSFORMS", "msDrawOffsettedLabels()");
+                msSetError(MS_MISCERR,
+                           "Labels only support LABELPNT, LABELPOLY and "
+                           "LABELCENTER GEOMTRANSFORMS",
+                           "msDrawOffsettedLabels()");
                 retval = MS_FAILURE;
               }
             }
           }
-          if(ts->annotext) {
-            retval = msDrawTextSymbol(map,image,ts->annopoint,ts);
-            if(MS_UNLIKELY(retval == MS_FAILURE)) {
+          if (ts->annotext) {
+            retval = msDrawTextSymbol(map, image, ts->annopoint, ts);
+            if (MS_UNLIKELY(retval == MS_FAILURE)) {
               goto offset_cleanup;
             }
           }
@@ -2839,9 +3200,9 @@ int msDrawOffsettedLabels(imageObj *imag
          tstyle.color.red = random()%255;
          tstyle.color.green = random()%255;
          tstyle.color.blue =random()%255;
-         msDrawLineSymbol(&map->symbolset, image, cachePtr->poly, &tstyle, layerPtr->scalefactor);
+         msDrawLineSymbol(&map->symbolset, image, cachePtr->poly, &tstyle,
+         layerPtr->scalefactor);
         */
-
       }
     }
   }
@@ -2850,18 +3211,15 @@ offset_cleanup:
 
   free(scratch_points);
 
-
   return retval;
 }
 
-void fastComputeBounds(lineObj *line, rectObj *bounds)
-{
+void fastComputeBounds(lineObj *line, rectObj *bounds) {
   int j;
   bounds->minx = bounds->maxx = line->point[0].x;
   bounds->miny = bounds->maxy = line->point[0].y;
 
-
-  for( j=0; j<line->numpoints; j++ ) {
+  for (j = 0; j < line->numpoints; j++) {
     bounds->minx = MS_MIN(bounds->minx, line->point[j].x);
     bounds->maxx = MS_MAX(bounds->maxx, line->point[j].x);
     bounds->miny = MS_MIN(bounds->miny, line->point[j].y);
@@ -2869,35 +3227,36 @@ void fastComputeBounds(lineObj *line, re
   }
 }
 
-int computeMarkerBounds(mapObj *map, pointObj *annopoint, textSymbolObj *ts, label_bounds *poly)
-{
+int computeMarkerBounds(mapObj *map, pointObj *annopoint, textSymbolObj *ts,
+                        label_bounds *poly) {
   int i;
-  for (i=0; i<ts->label->numstyles; i++) {
+  for (i = 0; i < ts->label->numstyles; i++) {
     styleObj *style = ts->label->styles[i];
-    if(style->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOINT &&
+    if (style->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOINT &&
         style->symbol < map->symbolset.numsymbols && style->symbol >= 0) {
-      double sx,sy;
+      double sx, sy;
       int p;
-      double aox,aoy;
+      double aox, aoy;
       symbolObj *symbol = map->symbolset.symbol[style->symbol];
-      if(msGetMarkerSize(map, style, &sx, &sy, ts->scalefactor) != MS_SUCCESS)
-        return -1; /* real error, different from MS_FALSE, return -1 so we can trap it */
-      if(style->angle) {
+      if (msGetMarkerSize(map, style, &sx, &sy, ts->scalefactor) != MS_SUCCESS)
+        return -1; /* real error, different from MS_FALSE, return -1 so we can
+                      trap it */
+      if (style->angle) {
         pointObj *point = poly->poly->point;
         point[0].x = sx / 2.0;
         point[0].y = sy / 2.0;
-        point[1].x =  point[0].x;
+        point[1].x = point[0].x;
         point[1].y = -point[0].y;
         point[2].x = -point[0].x;
         point[2].y = -point[0].y;
         point[3].x = -point[0].x;
-        point[3].y =  point[0].y;
-        point[4].x =  point[0].x;
-        point[4].y =  point[0].y;
-        if(symbol->anchorpoint_x != 0.5 || symbol->anchorpoint_y != 0.5) {
+        point[3].y = point[0].y;
+        point[4].x = point[0].x;
+        point[4].y = point[0].y;
+        if (symbol->anchorpoint_x != 0.5 || symbol->anchorpoint_y != 0.5) {
           aox = (0.5 - symbol->anchorpoint_x) * sx;
           aoy = (0.5 - symbol->anchorpoint_y) * sy;
-          for(p=0; p<5; p++) {
+          for (p = 0; p < 5; p++) {
             point[p].x += aox;
             point[p].y += aoy;
           }
@@ -2906,7 +3265,7 @@ int computeMarkerBounds(mapObj *map, poi
           double rot = -style->angle * MS_DEG_TO_RAD;
           double sina = sin(rot);
           double cosa = cos(rot);
-          for(p=0; p<5; p++) {
+          for (p = 0; p < 5; p++) {
             double tmpx = point[p].x;
             point[p].x = point[p].x * cosa - point[p].y * sina;
             point[p].y = tmpx * sina + point[p].y * cosa;
@@ -2914,35 +3273,35 @@ int computeMarkerBounds(mapObj *map, poi
         }
         aox = annopoint->x + style->offsetx * ts->scalefactor;
         aoy = annopoint->y + style->offsety * ts->scalefactor;
-        for(p=0; p<5; p++) {
+        for (p = 0; p < 5; p++) {
           point[p].x += aox;
           point[p].y += aoy;
         }
-        fastComputeBounds(poly->poly,&poly->bbox);
+        fastComputeBounds(poly->poly, &poly->bbox);
       } else {
-        double aox = (0.5 - symbol->anchorpoint_x)*sx + annopoint->x + style->offsetx * ts->scalefactor;
-        double aoy = (0.5 - symbol->anchorpoint_y)*sy + annopoint->y + style->offsety * ts->scalefactor;
+        double aox = (0.5 - symbol->anchorpoint_x) * sx + annopoint->x +
+                     style->offsetx * ts->scalefactor;
+        double aoy = (0.5 - symbol->anchorpoint_y) * sy + annopoint->y +
+                     style->offsety * ts->scalefactor;
         poly->poly = NULL;
-        poly->bbox.maxx = sx/2.0 + aox; 
-        poly->bbox.minx = -sx/2.0 + aox; 
-        poly->bbox.maxy = sy/2.0 + aoy;
-        poly->bbox.miny = -sy/2.0 + aoy;
+        poly->bbox.maxx = sx / 2.0 + aox;
+        poly->bbox.minx = -sx / 2.0 + aox;
+        poly->bbox.maxy = sy / 2.0 + aoy;
+        poly->bbox.miny = -sy / 2.0 + aoy;
       }
       break;
     }
   }
-  if(i == ts->label->numstyles)
+  if (i == ts->label->numstyles)
     return MS_FALSE; /* the label has no marker styles */
   else
     return MS_TRUE;
 }
 
+/* check that the current entry does not fall close to a label with identical
+ * text, if configured so. Currently only checks the first label/text */
 
-/* check that the current entry does not fall close to a label with identical text, if configured so.
- * Currently only checks the first label/text */
-
-int msCheckLabelMinDistance(mapObj *map, labelCacheMemberObj *lc)
-{
+int msCheckLabelMinDistance(mapObj *map, labelCacheMemberObj *lc) {
   int i;
   textSymbolObj *s; /* shortcut */
   textSymbolObj *ts;
@@ -2951,13 +3310,14 @@ int msCheckLabelMinDistance(mapObj *map,
     return MS_FALSE; /* no label with text */
   s = lc->textsymbols[0];
 
-  if (!s->annotext || s->label->mindistance <= 0.0 || s->label->force == MS_TRUE)
+  if (!s->annotext || s->label->mindistance <= 0.0 ||
+      s->label->force == MS_TRUE)
     return MS_FALSE; /*  min distance is not checked */
 
   /* we buffer the label and check for intersection instead of calculating
-     the distance of two textpaths. we also buffer only the bbox of lc for 
+     the distance of two textpaths. we also buffer only the bbox of lc for
      faster computation (it is still compared to the full textpath
-     of the label cache members). 
+     of the label cache members).
   */
   buffered = lc->bbox;
   buffered.minx -= s->label->mindistance * s->resolutionfactor;
@@ -2968,7 +3328,7 @@ int msCheckLabelMinDistance(mapObj *map,
   for (i = 0; i < map->labelcache.num_rendered_members; i++) {
     labelCacheMemberObj *ilc = map->labelcache.rendered_text_symbols[i];
     if (ilc->numtextsymbols == 0 || !ilc->textsymbols[0]->annotext)
-       continue;
+      continue;
 
     ts = ilc->textsymbols[0];
     if (strcmp(s->annotext, ts->annotext) != 0) {
@@ -2980,66 +3340,74 @@ int msCheckLabelMinDistance(mapObj *map,
       return MS_TRUE;
     }
 
-    if(ts->textpath && ts->textpath->absolute) {
-      if (intersectLabelPolygons(ts->textpath->bounds.poly, &ilc->bbox, NULL, &buffered) == MS_TRUE) {
+    if (ts->textpath && ts->textpath->absolute) {
+      if (intersectLabelPolygons(ts->textpath->bounds.poly, &ilc->bbox, NULL,
+                                 &buffered) == MS_TRUE) {
         return MS_TRUE;
       }
       continue;
     }
 
-
     if (intersectLabelPolygons(NULL, &ilc->bbox, NULL, &buffered) == MS_TRUE) {
-        return MS_TRUE;
+      return MS_TRUE;
     }
-
   }
   return MS_FALSE;
 }
 
 void copyLabelBounds(label_bounds *dst, label_bounds *src) {
   *dst = *src;
-  if(src->poly) {
+  if (src->poly) {
     int i;
     dst->poly = msSmallMalloc(sizeof(lineObj));
     dst->poly->numpoints = src->poly->numpoints;
     dst->poly->point = msSmallMalloc(dst->poly->numpoints * sizeof(pointObj));
-    for(i=0; i<dst->poly->numpoints; i++) {
+    for (i = 0; i < dst->poly->numpoints; i++) {
       dst->poly->point[i] = src->poly->point[i];
     }
   }
 }
 
 static int getLabelPositionFromString(char *pszString) {
-  if (strcasecmp(pszString, "UL")==0) return MS_UL;
-  else if (strcasecmp(pszString, "LR")==0) return MS_LR;
-  else if (strcasecmp(pszString, "UR")==0) return MS_UR;
-  else if (strcasecmp(pszString, "LL")==0) return MS_LL;
-  else if (strcasecmp(pszString, "CR")==0) return MS_CR;
-  else if (strcasecmp(pszString, "CL")==0) return MS_CL;
-  else if (strcasecmp(pszString, "UC")==0) return MS_UC;
-  else if (strcasecmp(pszString, "LC")==0) return MS_LC;
-  else return MS_CC;
+  if (strcasecmp(pszString, "UL") == 0)
+    return MS_UL;
+  else if (strcasecmp(pszString, "LR") == 0)
+    return MS_LR;
+  else if (strcasecmp(pszString, "UR") == 0)
+    return MS_UR;
+  else if (strcasecmp(pszString, "LL") == 0)
+    return MS_LL;
+  else if (strcasecmp(pszString, "CR") == 0)
+    return MS_CR;
+  else if (strcasecmp(pszString, "CL") == 0)
+    return MS_CL;
+  else if (strcasecmp(pszString, "UC") == 0)
+    return MS_UC;
+  else if (strcasecmp(pszString, "LC") == 0)
+    return MS_LC;
+  else
+    return MS_CC;
 }
 
-int msDrawLabelCache(mapObj *map, imageObj *image)
-{
+int msDrawLabelCache(mapObj *map, imageObj *image) {
   int nReturnVal = MS_SUCCESS;
-  struct mstimeval starttime={0}, endtime={0};
+  struct mstimeval starttime = {0}, endtime = {0};
 
-  if(map->debug >= MS_DEBUGLEVEL_TUNING) msGettimeofday(&starttime, NULL);
+  if (map->debug >= MS_DEBUGLEVEL_TUNING)
+    msGettimeofday(&starttime, NULL);
 
-  if(image) {
-    if(MS_RENDERER_PLUGIN(image->format)) {
+  if (image) {
+    if (MS_RENDERER_PLUGIN(image->format)) {
       int i, l, ll, priority, its;
 
       double marker_offset_x, marker_offset_y;
       int label_offset_x, label_offset_y;
       const char *value;
 
-      labelCacheMemberObj *cachePtr=NULL;
-      layerObj *layerPtr=NULL;
-      classObj *classPtr=NULL;
-      textSymbolObj *textSymbolPtr=NULL;
+      labelCacheMemberObj *cachePtr = NULL;
+      layerObj *layerPtr = NULL;
+      classObj *classPtr = NULL;
+      textSymbolObj *textSymbolPtr = NULL;
 
       /*
        * some statically allocated containers for storing label bounds before
@@ -3049,7 +3417,7 @@ int msDrawLabelCache(mapObj *map, imageO
       lineObj labelpoly_line;
       pointObj labelpoly_points[5];
       label_bounds labelpoly_bounds = {0};
-      lineObj  label_marker_line;
+      lineObj label_marker_line;
       pointObj label_marker_points[5];
       label_bounds label_marker_bounds;
       lineObj metrics_line;
@@ -3064,365 +3432,545 @@ int msDrawLabelCache(mapObj *map, imageO
       labelpoly_line.numpoints = 5;
 
       /* Look for labelcache_map_edge_buffer map metadata
-       * If set then the value defines a buffer (in pixels) along the edge of the
-       * map image where labels can't fall
+       * If set then the value defines a buffer (in pixels) along the edge of
+       * the map image where labels can't fall
        */
-      if((value = msLookupHashTable(&(map->web.metadata), "labelcache_map_edge_buffer")) != NULL) {
+      if ((value = msLookupHashTable(&(map->web.metadata),
+                                     "labelcache_map_edge_buffer")) != NULL) {
         map->labelcache.gutter = MS_ABS(atoi(value));
-        if(map->debug) msDebug("msDrawLabelCache(): labelcache_map_edge_buffer = %d\n", map->labelcache.gutter);
+        if (map->debug)
+          msDebug("msDrawLabelCache(): labelcache_map_edge_buffer = %d\n",
+                  map->labelcache.gutter);
       }
 
-      for(priority=MS_MAX_LABEL_PRIORITY-1; priority>=0; priority--) {
+      for (priority = MS_MAX_LABEL_PRIORITY - 1; priority >= 0; priority--) {
         labelCacheSlotObj *cacheslot;
         cacheslot = &(map->labelcache.slots[priority]);
 
-        for(l=cacheslot->numlabels-1; l>=0; l--) {
-          cachePtr = &(cacheslot->labels[l]); /* point to right spot in the label cache */
-
-          layerPtr = (GET_LAYER(map, cachePtr->layerindex)); /* set a couple of other pointers, avoids nasty references */
-          classPtr = (GET_CLASS(map, cachePtr->layerindex, cachePtr->classindex));
+        for (l = cacheslot->numlabels - 1; l >= 0; l--) {
+          cachePtr =
+              &(cacheslot
+                    ->labels[l]); /* point to right spot in the label cache */
+
+          layerPtr = (GET_LAYER(
+              map, cachePtr->layerindex)); /* set a couple of other pointers,
+                                              avoids nasty references */
+          classPtr =
+              (GET_CLASS(map, cachePtr->layerindex, cachePtr->classindex));
 
-          if(cachePtr->textsymbols[0]->textpath && cachePtr->textsymbols[0]->textpath->absolute) {
+          if (cachePtr->textsymbols[0]->textpath &&
+              cachePtr->textsymbols[0]->textpath->absolute) {
             /* we have an angle follow label */
             cachePtr->bbox = cachePtr->textsymbols[0]->textpath->bounds.bbox;
 
             /* before going any futher, check that mindistance is respected */
-            if (cachePtr->numtextsymbols && cachePtr->textsymbols[0]->label->mindistance > 0.0 && cachePtr->textsymbols[0]->annotext) {
+            if (cachePtr->numtextsymbols &&
+                cachePtr->textsymbols[0]->label->mindistance > 0.0 &&
+                cachePtr->textsymbols[0]->annotext) {
               if (msCheckLabelMinDistance(map, cachePtr) == MS_TRUE) {
                 cachePtr->status = MS_DELETE;
                 MS_DEBUG(MS_DEBUGLEVEL_DEVDEBUG, map,
-                          "Skipping labelgroup %d \"%s\" in layer \"%s\": too close to an identical label (mindistance)\n",
-                          l, cachePtr->textsymbols[0]->annotext, layerPtr->name);
-                continue; /* move on to next entry, this one is too close to an already placed one */
+                         "Skipping labelgroup %d \"%s\" in layer \"%s\": too "
+                         "close to an identical label (mindistance)\n",
+                         l, cachePtr->textsymbols[0]->annotext, layerPtr->name);
+                continue; /* move on to next entry, this one is too close to an
+                             already placed one */
               }
             }
 
-            if(!cachePtr->textsymbols[0]->label->force)
-              cachePtr->status = msTestLabelCacheCollisions(map,cachePtr,&cachePtr->textsymbols[0]->textpath->bounds, priority, l);
+            if (!cachePtr->textsymbols[0]->label->force)
+              cachePtr->status = msTestLabelCacheCollisions(
+                  map, cachePtr, &cachePtr->textsymbols[0]->textpath->bounds,
+                  priority, l);
             else
               cachePtr->status = MS_ON;
-            if(cachePtr->status) {
-
+            if (cachePtr->status) {
 
-              if (MS_UNLIKELY(MS_FAILURE == msDrawTextSymbol(map, image, cachePtr->textsymbols[0]->annopoint /*not used*/, cachePtr->textsymbols[0])))
-              {
+              if (MS_UNLIKELY(
+                      MS_FAILURE ==
+                      msDrawTextSymbol(
+                          map, image,
+                          cachePtr->textsymbols[0]->annopoint /*not used*/,
+                          cachePtr->textsymbols[0]))) {
                 return MS_FAILURE;
               }
               insertRenderedLabelMember(map, cachePtr);
             } else {
-              MS_DEBUG(MS_DEBUGLEVEL_DEVDEBUG,map,
-                  "Skipping follow labelgroup %d \"%s\" in layer \"%s\": text collided\n",
-                  l, cachePtr->textsymbols[0]->annotext, layerPtr->name);
+              MS_DEBUG(MS_DEBUGLEVEL_DEVDEBUG, map,
+                       "Skipping follow labelgroup %d \"%s\" in layer \"%s\": "
+                       "text collided\n",
+                       l, cachePtr->textsymbols[0]->annotext, layerPtr->name);
             }
-            cachePtr->status = MS_DELETE; /* we're done with this label, it won't even have a second chance in the leader phase */
+            cachePtr->status =
+                MS_DELETE; /* we're done with this label, it won't even have a
+                              second chance in the leader phase */
           } else {
             marker_offset_x = marker_offset_y = 0; /* assume no marker */
-            
-            if (layerPtr->type == MS_LAYER_POINT && cachePtr->markerid!=-1) { /* there is a marker already in the image that we need to account for */
-              markerCacheMemberObj *markerPtr = &(cacheslot->markers[cachePtr->markerid]); /* point to the right spot in the marker cache*/
-              marker_offset_x = (markerPtr->bounds.maxx-markerPtr->bounds.minx)/2.0;
-              marker_offset_y = (markerPtr->bounds.maxy-markerPtr->bounds.miny)/2.0;
-            }
 
+            if (layerPtr->type == MS_LAYER_POINT &&
+                cachePtr->markerid !=
+                    -1) { /* there is a marker already in the image that we need
+                             to account for */
+              markerCacheMemberObj *markerPtr = &(
+                  cacheslot
+                      ->markers[cachePtr->markerid]); /* point to the right spot
+                                                         in the marker cache*/
+              marker_offset_x =
+                  (markerPtr->bounds.maxx - markerPtr->bounds.minx) / 2.0;
+              marker_offset_y =
+                  (markerPtr->bounds.maxy - markerPtr->bounds.miny) / 2.0;
+            }
 
             /*
             ** all other cases *could* have multiple labels defined
             */
-            cachePtr->status = MS_ON; /* assume this cache element can be placed */
-            for(ll=0; ll<cachePtr->numtextsymbols; ll++) { /* RFC 77 TODO: Still may want to step through backwards... */
-              int label_marker_status = MS_ON, have_label_marker, metrics_status = MS_ON;
+            cachePtr->status =
+                MS_ON; /* assume this cache element can be placed */
+            for (ll = 0; ll < cachePtr->numtextsymbols;
+                 ll++) { /* RFC 77 TODO: Still may want to step through
+                            backwards... */
+              int label_marker_status = MS_ON, have_label_marker,
+                  metrics_status = MS_ON;
               int need_labelpoly = 0;
-              
-              /* reset the lineObj which may have been unset by a previous call to get_metrics() */
+
+              /* reset the lineObj which may have been unset by a previous call
+               * to get_metrics() */
               label_marker_bounds.poly = &label_marker_line;
               labelpoly_bounds.poly = &labelpoly_line;
 
               textSymbolPtr = cachePtr->textsymbols[ll];
-              for(i=0; i<textSymbolPtr->label->numstyles; i++) {
-                if(textSymbolPtr->label->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOLY || 
-                   textSymbolPtr->label->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_LABELCENTER) {
+              for (i = 0; i < textSymbolPtr->label->numstyles; i++) {
+                if (textSymbolPtr->label->styles[i]->_geomtransform.type ==
+                        MS_GEOMTRANSFORM_LABELPOLY ||
+                    textSymbolPtr->label->styles[i]->_geomtransform.type ==
+                        MS_GEOMTRANSFORM_LABELCENTER) {
                   need_labelpoly = 1;
                   break;
                 }
               }
 
               /* compute the poly of the label styles */
-              if((have_label_marker = computeMarkerBounds(map,&cachePtr->point,textSymbolPtr, &label_marker_bounds)) == MS_TRUE) {
-                if(cachePtr->numtextsymbols > 1) { /* FIXME this test doesn't seem right, should probably check if we have an annotation layer with a regular style defined */
-                  marker_offset_x = (label_marker_bounds.bbox.maxx-label_marker_bounds.bbox.minx)/2.0;
-                  marker_offset_y = (label_marker_bounds.bbox.maxy-label_marker_bounds.bbox.miny)/2.0;
+              if ((have_label_marker =
+                       computeMarkerBounds(map, &cachePtr->point, textSymbolPtr,
+                                           &label_marker_bounds)) == MS_TRUE) {
+                if (cachePtr->numtextsymbols >
+                    1) { /* FIXME this test doesn't seem right, should probably
+                            check if we have an annotation layer with a regular
+                            style defined */
+                  marker_offset_x = (label_marker_bounds.bbox.maxx -
+                                     label_marker_bounds.bbox.minx) /
+                                    2.0;
+                  marker_offset_y = (label_marker_bounds.bbox.maxy -
+                                     label_marker_bounds.bbox.miny) /
+                                    2.0;
                 } else {
                   /* we might be using an old style behavior with a markerPtr */
-                  marker_offset_x = MS_MAX(marker_offset_x,(label_marker_bounds.bbox.maxx-label_marker_bounds.bbox.minx)/2.0);
-                  marker_offset_y = MS_MAX(marker_offset_y,(label_marker_bounds.bbox.maxy-label_marker_bounds.bbox.miny)/2.0);
+                  marker_offset_x =
+                      MS_MAX(marker_offset_x, (label_marker_bounds.bbox.maxx -
+                                               label_marker_bounds.bbox.minx) /
+                                                  2.0);
+                  marker_offset_y =
+                      MS_MAX(marker_offset_y, (label_marker_bounds.bbox.maxy -
+                                               label_marker_bounds.bbox.miny) /
+                                                  2.0);
                 }
                 /* add marker to cachePtr->poly */
-                if(textSymbolPtr->label->force != MS_TRUE) {
-                  label_marker_status = msTestLabelCacheCollisions(map, cachePtr, &label_marker_bounds ,priority, l);
+                if (textSymbolPtr->label->force != MS_TRUE) {
+                  label_marker_status = msTestLabelCacheCollisions(
+                      map, cachePtr, &label_marker_bounds, priority, l);
                 }
-                if(label_marker_status == MS_OFF &&
-                    !(textSymbolPtr->label->force==MS_ON || classPtr->leader)) {
+                if (label_marker_status == MS_OFF &&
+                    !(textSymbolPtr->label->force == MS_ON ||
+                      classPtr->leader)) {
                   cachePtr->status = MS_DELETE;
                   MS_DEBUG(MS_DEBUGLEVEL_DEVDEBUG, map,
-                      "Skipping label %d of labelgroup %d of class %d in layer \"%s\": marker collided\n",
-                      ll, l, cachePtr->classindex, layerPtr->name);
+                           "Skipping label %d of labelgroup %d of class %d in "
+                           "layer \"%s\": marker collided\n",
+                           ll, l, cachePtr->classindex, layerPtr->name);
                   break; /* the marker collided, break from multi-label loop */
                 }
               }
-              if(have_label_marker == -1) return MS_FAILURE; /* error occured (symbol not found, etc...) */
+              if (have_label_marker == -1)
+                return MS_FAILURE; /* error occured (symbol not found, etc...)
+                                    */
 
-              if(textSymbolPtr->annotext) {
+              if (textSymbolPtr->annotext) {
                 /*
-                 * if we don't have an offset defined, first check that the labelpoint itself does not collide
-                 * this helps speed things up in dense labelling, as if the labelpoint collides there's
-                 * no use in computing the labeltext bounds (i.e. going into shaping+freetype).
-                 * We do however skip collision testing against the marker cache, as we want to allow rendering
-                 * a label for points that overlap each other: this is done by setting priority to MAX_PRIORITY
-                 * in the call to msTestLabelCacheCollisions (which is a hack!!)
+                 * if we don't have an offset defined, first check that the
+                 * labelpoint itself does not collide this helps speed things up
+                 * in dense labelling, as if the labelpoint collides there's no
+                 * use in computing the labeltext bounds (i.e. going into
+                 * shaping+freetype). We do however skip collision testing
+                 * against the marker cache, as we want to allow rendering a
+                 * label for points that overlap each other: this is done by
+                 * setting priority to MAX_PRIORITY in the call to
+                 * msTestLabelCacheCollisions (which is a hack!!)
                  */
-                if(!have_label_marker && textSymbolPtr->label->force != MS_TRUE && !classPtr->leader &&
-                    !textSymbolPtr->label->offsetx && !textSymbolPtr->label->offsety) {
+                if (!have_label_marker &&
+                    textSymbolPtr->label->force != MS_TRUE &&
+                    !classPtr->leader && !textSymbolPtr->label->offsetx &&
+                    !textSymbolPtr->label->offsety) {
                   label_bounds labelpoint_bounds;
                   labelpoint_bounds.poly = NULL;
                   labelpoint_bounds.bbox.minx = cachePtr->point.x - 0.1;
                   labelpoint_bounds.bbox.maxx = cachePtr->point.x + 0.1;
                   labelpoint_bounds.bbox.miny = cachePtr->point.y - 0.1;
                   labelpoint_bounds.bbox.maxy = cachePtr->point.y + 0.1;
-                  if(MS_OFF == msTestLabelCacheCollisions(map, cachePtr, &labelpoint_bounds, MS_MAX_LABEL_PRIORITY, l)) {
-                    cachePtr->status = MS_DELETE; /* we won't check for leader offseted positions, as the anchor point colided */
+                  if (MS_OFF == msTestLabelCacheCollisions(
+                                    map, cachePtr, &labelpoint_bounds,
+                                    MS_MAX_LABEL_PRIORITY, l)) {
+                    cachePtr->status =
+                        MS_DELETE; /* we won't check for leader offseted
+                                      positions, as the anchor point colided */
                     MS_DEBUG(MS_DEBUGLEVEL_DEVDEBUG, map,
-                        "Skipping label %d \"%s\" of labelgroup %d of class %d in layer \"%s\": labelpoint collided\n",
-                        ll, textSymbolPtr->annotext, l, cachePtr->classindex, layerPtr->name);
+                             "Skipping label %d \"%s\" of labelgroup %d of "
+                             "class %d in layer \"%s\": labelpoint collided\n",
+                             ll, textSymbolPtr->annotext, l,
+                             cachePtr->classindex, layerPtr->name);
                     break;
                   }
                 }
 
                 /* compute label size */
-                if(!textSymbolPtr->textpath) {
-                  if(MS_UNLIKELY(MS_FAILURE == msComputeTextPath(map,textSymbolPtr))) {
+                if (!textSymbolPtr->textpath) {
+                  if (MS_UNLIKELY(MS_FAILURE ==
+                                  msComputeTextPath(map, textSymbolPtr))) {
                     return MS_FAILURE;
                   }
                 }
 
-                /* if our label has an outline, adjust the marker offset so the outlinecolor does
-                 * not bleed into the marker */
-                if(marker_offset_x && MS_VALID_COLOR(textSymbolPtr->label->outlinecolor)) {
-                  marker_offset_x += textSymbolPtr->label->outlinewidth/2.0 * textSymbolPtr->scalefactor;
-                  marker_offset_y += textSymbolPtr->label->outlinewidth/2.0 * textSymbolPtr->scalefactor;
+                /* if our label has an outline, adjust the marker offset so the
+                 * outlinecolor does not bleed into the marker */
+                if (marker_offset_x &&
+                    MS_VALID_COLOR(textSymbolPtr->label->outlinecolor)) {
+                  marker_offset_x += textSymbolPtr->label->outlinewidth / 2.0 *
+                                     textSymbolPtr->scalefactor;
+                  marker_offset_y += textSymbolPtr->label->outlinewidth / 2.0 *
+                                     textSymbolPtr->scalefactor;
                 }
-                
+
                 /* apply offset and buffer settings */
-                if(textSymbolPtr->label->anglemode != MS_FOLLOW) {
-                  label_offset_x = textSymbolPtr->label->offsetx * textSymbolPtr->scalefactor;
-                  label_offset_y = textSymbolPtr->label->offsety * textSymbolPtr-> scalefactor;
+                if (textSymbolPtr->label->anglemode != MS_FOLLOW) {
+                  label_offset_x = textSymbolPtr->label->offsetx *
+                                   textSymbolPtr->scalefactor;
+                  label_offset_y = textSymbolPtr->label->offsety *
+                                   textSymbolPtr->scalefactor;
                 } else {
                   label_offset_x = 0;
                   label_offset_y = 0;
                 }
 
-                if(textSymbolPtr->label->position == MS_AUTO) {
-                  /* no point in using auto positionning if the marker cannot be placed */
-                  int positions[MS_POSITIONS_LENGTH], npositions=0;
-		  
+                if (textSymbolPtr->label->position == MS_AUTO) {
+                  /* no point in using auto positionning if the marker cannot be
+                   * placed */
+                  int positions[MS_POSITIONS_LENGTH], npositions = 0;
+
                   /*
                   **   (Note: might be able to re-order this for more speed.)
                   */
-		  if(msLayerGetProcessingKey(layerPtr, "LABEL_POSITIONS")) {
-                    int p, ncustom_positions=0;
-                    char **custom_positions = msStringSplitComplex(msLayerGetProcessingKey(layerPtr, "LABEL_POSITIONS"), ",", &ncustom_positions, MS_STRIPLEADSPACES|MS_STRIPENDSPACES);
-                    for(p=0; p<MS_MIN(9,ncustom_positions); p++)
-                      positions[p] = getLabelPositionFromString(custom_positions[p]);
+                  if (msLayerGetProcessingKey(layerPtr, "LABEL_POSITIONS")) {
+                    int p, ncustom_positions = 0;
+                    char **custom_positions = msStringSplitComplex(
+                        msLayerGetProcessingKey(layerPtr, "LABEL_POSITIONS"),
+                        ",", &ncustom_positions,
+                        MS_STRIPLEADSPACES | MS_STRIPENDSPACES);
+                    for (p = 0; p < MS_MIN(9, ncustom_positions); p++)
+                      positions[p] =
+                          getLabelPositionFromString(custom_positions[p]);
                     npositions = p;
                     msFree(custom_positions);
-		  } else if(layerPtr->type == MS_LAYER_POLYGON && marker_offset_x==0 ) {
-                    positions[0]=MS_CC;
-                    positions[1]=MS_UC;
-                    positions[2]=MS_LC;
-                    positions[3]=MS_CL;
-                    positions[4]=MS_CR;
+                  } else if (layerPtr->type == MS_LAYER_POLYGON &&
+                             marker_offset_x == 0) {
+                    positions[0] = MS_CC;
+                    positions[1] = MS_UC;
+                    positions[2] = MS_LC;
+                    positions[3] = MS_CL;
+                    positions[4] = MS_CR;
                     npositions = 5;
-                  } else if(layerPtr->type == MS_LAYER_LINE && marker_offset_x == 0) {
-                    positions[0]=MS_UC;
-                    positions[1]=MS_LC;
-                    positions[2]=MS_CC;
+                  } else if (layerPtr->type == MS_LAYER_LINE &&
+                             marker_offset_x == 0) {
+                    positions[0] = MS_UC;
+                    positions[1] = MS_LC;
+                    positions[2] = MS_CC;
                     npositions = 3;
                   } else {
-                    positions[0]=MS_UL;
-                    positions[1]=MS_LR;
-                    positions[2]=MS_UR;
-                    positions[3]=MS_LL;
-                    positions[4]=MS_CR;
-                    positions[5]=MS_CL;
-                    positions[6]=MS_UC;
-                    positions[7]=MS_LC;
+                    positions[0] = MS_UL;
+                    positions[1] = MS_LR;
+                    positions[2] = MS_UR;
+                    positions[3] = MS_LL;
+                    positions[4] = MS_CR;
+                    positions[5] = MS_CL;
+                    positions[6] = MS_UC;
+                    positions[7] = MS_LC;
                     npositions = 8;
                   }
 
-                  for(i=0; i<npositions; i++) {
+                  for (i = 0; i < npositions; i++) {
                     // RFC 77 TODO: take label_marker_offset_x/y into account
                     metrics_bounds.poly = &metrics_line;
-                    textSymbolPtr->annopoint = get_metrics(&(cachePtr->point), positions[i], textSymbolPtr->textpath,
-                                                           marker_offset_x + label_offset_x, marker_offset_y + label_offset_y,
-                                                           textSymbolPtr->rotation, textSymbolPtr->label->buffer * textSymbolPtr->scalefactor, &metrics_bounds);
-                    if(textSymbolPtr->label->force == MS_OFF) {
-                      for(its=0;its<ll;its++) {
+                    textSymbolPtr->annopoint =
+                        get_metrics(&(cachePtr->point), positions[i],
+                                    textSymbolPtr->textpath,
+                                    marker_offset_x + label_offset_x,
+                                    marker_offset_y + label_offset_y,
+                                    textSymbolPtr->rotation,
+                                    textSymbolPtr->label->buffer *
+                                        textSymbolPtr->scalefactor,
+                                    &metrics_bounds);
+                    if (textSymbolPtr->label->force == MS_OFF) {
+                      for (its = 0; its < ll; its++) {
                         /* check for collisions inside the label group */
-                        if(intersectTextSymbol(cachePtr->textsymbols[its],&metrics_bounds) == MS_TRUE) {
+                        if (intersectTextSymbol(cachePtr->textsymbols[its],
+                                                &metrics_bounds) == MS_TRUE) {
                           /* there was a self intersection */
-                          break; /* next position, will break out to next position in containing loop*/
+                          break; /* next position, will break out to next
+                                    position in containing loop*/
                         }
-                        if(its != ll)
-                          continue; /* goto next position, this one had an intersection with our own label group */
+                        if (its != ll)
+                          continue; /* goto next position, this one had an
+                                       intersection with our own label group */
                       }
                     }
 
-                    metrics_status = msTestLabelCacheCollisions(map, cachePtr,&metrics_bounds, priority, l);
+                    metrics_status = msTestLabelCacheCollisions(
+                        map, cachePtr, &metrics_bounds, priority, l);
 
                     /* found a suitable place for this label */
-                    if(metrics_status == MS_TRUE || (i==(npositions-1) && textSymbolPtr->label->force == MS_ON)) {
-                      metrics_status = MS_TRUE; /* set to true in case we are forcing it */
+                    if (metrics_status == MS_TRUE ||
+                        (i == (npositions - 1) &&
+                         textSymbolPtr->label->force == MS_ON)) {
+                      metrics_status =
+                          MS_TRUE; /* set to true in case we are forcing it */
                       /* compute anno poly for label background if needed */
-                      if(need_labelpoly) get_metrics(&(cachePtr->point), positions[i], textSymbolPtr->textpath,
-                                                                marker_offset_x + label_offset_x, marker_offset_y + label_offset_y,
-                                                                textSymbolPtr->rotation, 1, &labelpoly_bounds);
+                      if (need_labelpoly)
+                        get_metrics(&(cachePtr->point), positions[i],
+                                    textSymbolPtr->textpath,
+                                    marker_offset_x + label_offset_x,
+                                    marker_offset_y + label_offset_y,
+                                    textSymbolPtr->rotation, 1,
+                                    &labelpoly_bounds);
 
                       break; /* ...out of position loop */
                     }
                   } /* next position */
 
-                  /* if position auto didn't manage to find a position, but we have leader configured
-                   * for the class, then we want to compute the label poly anyway, placed as MS_CC */
-                  if(classPtr->leader && metrics_status == MS_FALSE) {
+                  /* if position auto didn't manage to find a position, but we
+                   * have leader configured for the class, then we want to
+                   * compute the label poly anyway, placed as MS_CC */
+                  if (classPtr->leader && metrics_status == MS_FALSE) {
                     metrics_bounds.poly = &metrics_line;
-                    textSymbolPtr->annopoint = get_metrics(&(cachePtr->point), MS_CC, textSymbolPtr->textpath, label_offset_x, label_offset_y,
-                                                           textSymbolPtr->rotation, textSymbolPtr->label->buffer * textSymbolPtr->scalefactor,
-                                                           &metrics_bounds);
-                    if(need_labelpoly) get_metrics(&(cachePtr->point), MS_CC, textSymbolPtr->textpath,
-                                                              label_offset_x, label_offset_y,
-                                                              textSymbolPtr->rotation, 1, &labelpoly_bounds);
+                    textSymbolPtr->annopoint = get_metrics(
+                        &(cachePtr->point), MS_CC, textSymbolPtr->textpath,
+                        label_offset_x, label_offset_y, textSymbolPtr->rotation,
+                        textSymbolPtr->label->buffer *
+                            textSymbolPtr->scalefactor,
+                        &metrics_bounds);
+                    if (need_labelpoly)
+                      get_metrics(&(cachePtr->point), MS_CC,
+                                  textSymbolPtr->textpath, label_offset_x,
+                                  label_offset_y, textSymbolPtr->rotation, 1,
+                                  &labelpoly_bounds);
                   }
                 } else { /* explicit position */
-                  if(textSymbolPtr->label->position == MS_CC) { /* don't need the marker_offset */
+                  if (textSymbolPtr->label->position ==
+                      MS_CC) { /* don't need the marker_offset */
                     metrics_bounds.poly = &metrics_line;
-                    textSymbolPtr->annopoint = get_metrics(&(cachePtr->point), MS_CC, textSymbolPtr->textpath, label_offset_x, label_offset_y,
-                            textSymbolPtr->rotation, textSymbolPtr->label->buffer * textSymbolPtr->scalefactor, &metrics_bounds);
-                    if(need_labelpoly) get_metrics(&(cachePtr->point), MS_CC, textSymbolPtr->textpath,
-                                                              label_offset_x, label_offset_y, textSymbolPtr->rotation, 1, &labelpoly_bounds);
+                    textSymbolPtr->annopoint = get_metrics(
+                        &(cachePtr->point), MS_CC, textSymbolPtr->textpath,
+                        label_offset_x, label_offset_y, textSymbolPtr->rotation,
+                        textSymbolPtr->label->buffer *
+                            textSymbolPtr->scalefactor,
+                        &metrics_bounds);
+                    if (need_labelpoly)
+                      get_metrics(&(cachePtr->point), MS_CC,
+                                  textSymbolPtr->textpath, label_offset_x,
+                                  label_offset_y, textSymbolPtr->rotation, 1,
+                                  &labelpoly_bounds);
                   } else {
                     metrics_bounds.poly = &metrics_line;
-                    textSymbolPtr->annopoint = get_metrics(&(cachePtr->point), textSymbolPtr->label->position, textSymbolPtr->textpath,
-                                                           marker_offset_x + label_offset_x, marker_offset_y + label_offset_y,
-                                                           textSymbolPtr->rotation, textSymbolPtr->label->buffer * textSymbolPtr->scalefactor,
-                                                           &metrics_bounds);
-                    if(need_labelpoly) get_metrics(&(cachePtr->point), textSymbolPtr->label->position, textSymbolPtr->textpath,
-                                                              marker_offset_x + label_offset_x, marker_offset_y + label_offset_y, textSymbolPtr->rotation, 1, &labelpoly_bounds);
+                    textSymbolPtr->annopoint = get_metrics(
+                        &(cachePtr->point), textSymbolPtr->label->position,
+                        textSymbolPtr->textpath,
+                        marker_offset_x + label_offset_x,
+                        marker_offset_y + label_offset_y,
+                        textSymbolPtr->rotation,
+                        textSymbolPtr->label->buffer *
+                            textSymbolPtr->scalefactor,
+                        &metrics_bounds);
+                    if (need_labelpoly)
+                      get_metrics(
+                          &(cachePtr->point), textSymbolPtr->label->position,
+                          textSymbolPtr->textpath,
+                          marker_offset_x + label_offset_x,
+                          marker_offset_y + label_offset_y,
+                          textSymbolPtr->rotation, 1, &labelpoly_bounds);
                   }
 
-                  if(textSymbolPtr->label->force == MS_ON) {
+                  if (textSymbolPtr->label->force == MS_ON) {
                     metrics_status = MS_ON;
                   } else {
-                    if(textSymbolPtr->label->force == MS_OFF) {
-                      /* check for collisions inside the label group unless the label is FORCE GROUP */
-                      for(its=0;its<ll;its++) {
+                    if (textSymbolPtr->label->force == MS_OFF) {
+                      /* check for collisions inside the label group unless the
+                       * label is FORCE GROUP */
+                      for (its = 0; its < ll; its++) {
                         /* check for collisions inside the label group */
-                        if(intersectTextSymbol(cachePtr->textsymbols[its],&metrics_bounds) == MS_TRUE) {
+                        if (intersectTextSymbol(cachePtr->textsymbols[its],
+                                                &metrics_bounds) == MS_TRUE) {
                           /* there was a self intersection */
-                          break; /* will break out to next position in containing loop*/
+                          break; /* will break out to next position in
+                                    containing loop*/
                         }
-                        if(its != ll) {
-                          cachePtr->status = MS_DELETE; /* TODO RFC98: check if this is correct */
-                          MS_DEBUG(MS_DEBUGLEVEL_DEVDEBUG,map,
-                              "Skipping label %d (\"%s\") of labelgroup %d of class %d in layer \"%s\": intercollision with label text inside labelgroup\n",
-                              ll, textSymbolPtr->annotext, l,cachePtr->classindex, layerPtr->name);
-                          break; /* collision within the group, break out of textSymbol loop */
+                        if (its != ll) {
+                          cachePtr->status = MS_DELETE; /* TODO RFC98: check if
+                                                           this is correct */
+                          MS_DEBUG(
+                              MS_DEBUGLEVEL_DEVDEBUG, map,
+                              "Skipping label %d (\"%s\") of labelgroup %d of "
+                              "class %d in layer \"%s\": intercollision with "
+                              "label text inside labelgroup\n",
+                              ll, textSymbolPtr->annotext, l,
+                              cachePtr->classindex, layerPtr->name);
+                          break; /* collision within the group, break out of
+                                    textSymbol loop */
                         }
                       }
                     }
-                    /* TODO: in case we have leader lines and multiple labels, there's no use in testing for labelcache collisions
-                    * once a first collision has been found. we only need to know that the label group has collided, and the
-                    * poly of the whole label group: if(label_group) testLabelCacheCollisions */
-                    metrics_status = msTestLabelCacheCollisions(map, cachePtr,&metrics_bounds, priority, l);
+                    /* TODO: in case we have leader lines and multiple labels,
+                     * there's no use in testing for labelcache collisions once
+                     * a first collision has been found. we only need to know
+                     * that the label group has collided, and the poly of the
+                     * whole label group: if(label_group)
+                     * testLabelCacheCollisions */
+                    metrics_status = msTestLabelCacheCollisions(
+                        map, cachePtr, &metrics_bounds, priority, l);
                   }
                 } /* end POSITION AUTO vs Fixed POSITION */
 
-                if(!metrics_status && classPtr->leader == 0) {
+                if (!metrics_status && classPtr->leader == 0) {
                   cachePtr->status = MS_DELETE;
-                  MS_DEBUG(MS_DEBUGLEVEL_DEVDEBUG,map,
-                      "Skipping label %d \"%s\" of labelgroup %d of class %d in layer \"%s\": text collided\n",
-                      ll, textSymbolPtr->annotext, l, cachePtr->classindex, layerPtr->name);
-                  break; /* no point looking at more labels, unless their is a leader defined */
+                  MS_DEBUG(MS_DEBUGLEVEL_DEVDEBUG, map,
+                           "Skipping label %d \"%s\" of labelgroup %d of class "
+                           "%d in layer \"%s\": text collided\n",
+                           ll, textSymbolPtr->annotext, l, cachePtr->classindex,
+                           layerPtr->name);
+                  break; /* no point looking at more labels, unless their is a
+                            leader defined */
                 }
               }
 
-              /* if we're here, we can either fit the label directly, or we need to put it in the leader queue */
-              assert((metrics_status && label_marker_status) || classPtr->leader);
-
-              if(textSymbolPtr->annotext) {
-                copyLabelBounds(&textSymbolPtr->textpath->bounds, &metrics_bounds);
+              /* if we're here, we can either fit the label directly, or we need
+               * to put it in the leader queue */
+              assert((metrics_status && label_marker_status) ||
+                     classPtr->leader);
+
+              if (textSymbolPtr->annotext) {
+                copyLabelBounds(&textSymbolPtr->textpath->bounds,
+                                &metrics_bounds);
               }
-              if(have_label_marker) {
-                if(!textSymbolPtr->style_bounds)
-                  textSymbolPtr->style_bounds = msSmallCalloc(textSymbolPtr->label->numstyles, sizeof(label_bounds*));
-                for(its=0;its<textSymbolPtr->label->numstyles; its++) {
-                  if(textSymbolPtr->label->styles[its]->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOINT) {
-                    textSymbolPtr->style_bounds[its] = msSmallMalloc(sizeof(label_bounds));
-                    copyLabelBounds(textSymbolPtr->style_bounds[its], &label_marker_bounds);
+              if (have_label_marker) {
+                if (!textSymbolPtr->style_bounds)
+                  textSymbolPtr->style_bounds = msSmallCalloc(
+                      textSymbolPtr->label->numstyles, sizeof(label_bounds *));
+                for (its = 0; its < textSymbolPtr->label->numstyles; its++) {
+                  if (textSymbolPtr->label->styles[its]->_geomtransform.type ==
+                      MS_GEOMTRANSFORM_LABELPOINT) {
+                    textSymbolPtr->style_bounds[its] =
+                        msSmallMalloc(sizeof(label_bounds));
+                    copyLabelBounds(textSymbolPtr->style_bounds[its],
+                                    &label_marker_bounds);
                   }
                 }
               }
-              if(!label_marker_status || ! metrics_status) {
+              if (!label_marker_status || !metrics_status) {
                 MS_DEBUG(MS_DEBUGLEVEL_DEVDEBUG, map,
-                    "Putting label %d of labelgroup %d of class %d , layer \"%s\" in leader queue\n",
-                    ll, l, cachePtr->classindex, layerPtr->name);
-                cachePtr->status = MS_OFF; /* we have a collision, but this entry is a candidate for leader testing */
+                         "Putting label %d of labelgroup %d of class %d , "
+                         "layer \"%s\" in leader queue\n",
+                         ll, l, cachePtr->classindex, layerPtr->name);
+                cachePtr->status =
+                    MS_OFF; /* we have a collision, but this entry is a
+                               candidate for leader testing */
               }
 
-              /* do we need to copy the labelpoly, or can we use the static one ?*/
-              if(cachePtr->numtextsymbols > 1 || (cachePtr->status == MS_OFF && classPtr->leader)) {
+              /* do we need to copy the labelpoly, or can we use the static one
+               * ?*/
+              if (cachePtr->numtextsymbols > 1 ||
+                  (cachePtr->status == MS_OFF && classPtr->leader)) {
                 /*
-                 * if we have more than one label, or if we have a single one which didn't fit but needs
-                 * to go through leader offset testing
+                 * if we have more than one label, or if we have a single one
+                 * which didn't fit but needs to go through leader offset
+                 * testing
                  */
-                if(!textSymbolPtr->style_bounds)
-                  textSymbolPtr->style_bounds = msSmallCalloc(textSymbolPtr->label->numstyles, sizeof(label_bounds*));
-                for(its=0;its<textSymbolPtr->label->numstyles; its++) {
-                  if(textSymbolPtr->label->styles[its]->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOLY || 
-                     textSymbolPtr->label->styles[its]->_geomtransform.type == MS_GEOMTRANSFORM_LABELCENTER) {
-                    textSymbolPtr->style_bounds[its] = msSmallMalloc(sizeof(label_bounds));
-                    copyLabelBounds(textSymbolPtr->style_bounds[its], &labelpoly_bounds);
+                if (!textSymbolPtr->style_bounds)
+                  textSymbolPtr->style_bounds = msSmallCalloc(
+                      textSymbolPtr->label->numstyles, sizeof(label_bounds *));
+                for (its = 0; its < textSymbolPtr->label->numstyles; its++) {
+                  if (textSymbolPtr->label->styles[its]->_geomtransform.type ==
+                          MS_GEOMTRANSFORM_LABELPOLY ||
+                      textSymbolPtr->label->styles[its]->_geomtransform.type ==
+                          MS_GEOMTRANSFORM_LABELCENTER) {
+                    textSymbolPtr->style_bounds[its] =
+                        msSmallMalloc(sizeof(label_bounds));
+                    copyLabelBounds(textSymbolPtr->style_bounds[its],
+                                    &labelpoly_bounds);
                   }
                 }
 
               } /* else: we'll use labelpoly_bounds directly below */
-            } /* next label in the group */
+            }   /* next label in the group */
 
-            if(cachePtr->status != MS_DELETE) {
+            if (cachePtr->status != MS_DELETE) {
               /* compute the global label bbox */
-              int inited = 0,s;
-              for(its=0;its<cachePtr->numtextsymbols;its++) {
-                if(cachePtr->textsymbols[its]->annotext) {
-                  if(inited == 0) {
-                    cachePtr->bbox = cachePtr->textsymbols[its]->textpath->bounds.bbox;
+              int inited = 0, s;
+              for (its = 0; its < cachePtr->numtextsymbols; its++) {
+                if (cachePtr->textsymbols[its]->annotext) {
+                  if (inited == 0) {
+                    cachePtr->bbox =
+                        cachePtr->textsymbols[its]->textpath->bounds.bbox;
                     inited = 1;
                   } else {
-                    cachePtr->bbox.minx = MS_MIN(cachePtr->bbox.minx, cachePtr->textsymbols[its]->textpath->bounds.bbox.minx);
-                    cachePtr->bbox.miny = MS_MIN(cachePtr->bbox.miny, cachePtr->textsymbols[its]->textpath->bounds.bbox.miny);
-                    cachePtr->bbox.maxx = MS_MAX(cachePtr->bbox.maxx, cachePtr->textsymbols[its]->textpath->bounds.bbox.maxx);
-                    cachePtr->bbox.maxy = MS_MAX(cachePtr->bbox.maxy, cachePtr->textsymbols[its]->textpath->bounds.bbox.maxy);
+                    cachePtr->bbox.minx = MS_MIN(
+                        cachePtr->bbox.minx,
+                        cachePtr->textsymbols[its]->textpath->bounds.bbox.minx);
+                    cachePtr->bbox.miny = MS_MIN(
+                        cachePtr->bbox.miny,
+                        cachePtr->textsymbols[its]->textpath->bounds.bbox.miny);
+                    cachePtr->bbox.maxx = MS_MAX(
+                        cachePtr->bbox.maxx,
+                        cachePtr->textsymbols[its]->textpath->bounds.bbox.maxx);
+                    cachePtr->bbox.maxy = MS_MAX(
+                        cachePtr->bbox.maxy,
+                        cachePtr->textsymbols[its]->textpath->bounds.bbox.maxy);
                   }
                 }
-                for(s=0; s<cachePtr->textsymbols[its]->label->numstyles; s++) {
-                  if(cachePtr->textsymbols[its]->label->styles[s]->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOINT) {
-                    if(inited == 0) {
-                      cachePtr->bbox = cachePtr->textsymbols[its]->style_bounds[s]->bbox;
+                for (s = 0; s < cachePtr->textsymbols[its]->label->numstyles;
+                     s++) {
+                  if (cachePtr->textsymbols[its]
+                          ->label->styles[s]
+                          ->_geomtransform.type ==
+                      MS_GEOMTRANSFORM_LABELPOINT) {
+                    if (inited == 0) {
+                      cachePtr->bbox =
+                          cachePtr->textsymbols[its]->style_bounds[s]->bbox;
                       inited = 1;
                       break;
                     } else {
-                      cachePtr->bbox.minx = MS_MIN(cachePtr->bbox.minx, cachePtr->textsymbols[its]->style_bounds[s]->bbox.minx);
-                      cachePtr->bbox.miny = MS_MIN(cachePtr->bbox.miny, cachePtr->textsymbols[its]->style_bounds[s]->bbox.miny);
-                      cachePtr->bbox.maxx = MS_MAX(cachePtr->bbox.maxx, cachePtr->textsymbols[its]->style_bounds[s]->bbox.maxx);
-                      cachePtr->bbox.maxy = MS_MAX(cachePtr->bbox.maxy, cachePtr->textsymbols[its]->style_bounds[s]->bbox.maxy);
-                      break; 
+                      cachePtr->bbox.minx =
+                          MS_MIN(cachePtr->bbox.minx, cachePtr->textsymbols[its]
+                                                          ->style_bounds[s]
+                                                          ->bbox.minx);
+                      cachePtr->bbox.miny =
+                          MS_MIN(cachePtr->bbox.miny, cachePtr->textsymbols[its]
+                                                          ->style_bounds[s]
+                                                          ->bbox.miny);
+                      cachePtr->bbox.maxx =
+                          MS_MAX(cachePtr->bbox.maxx, cachePtr->textsymbols[its]
+                                                          ->style_bounds[s]
+                                                          ->bbox.maxx);
+                      cachePtr->bbox.maxy =
+                          MS_MAX(cachePtr->bbox.maxy, cachePtr->textsymbols[its]
+                                                          ->style_bounds[s]
+                                                          ->bbox.maxy);
+                      break;
                     }
                   }
                 }
@@ -3430,72 +3978,122 @@ int msDrawLabelCache(mapObj *map, imageO
             }
 
             /* check that mindistance is respected */
-            if (cachePtr->numtextsymbols && cachePtr->textsymbols[0]->label->mindistance > 0.0 && cachePtr->textsymbols[0]->annotext) {
+            if (cachePtr->numtextsymbols &&
+                cachePtr->textsymbols[0]->label->mindistance > 0.0 &&
+                cachePtr->textsymbols[0]->annotext) {
               if (msCheckLabelMinDistance(map, cachePtr) == MS_TRUE) {
                 cachePtr->status = MS_DELETE;
                 MS_DEBUG(MS_DEBUGLEVEL_DEVDEBUG, map,
-                         "Skipping labelgroup %d \"%s\" in layer \"%s\": too close to an identical label (mindistance)\n",
+                         "Skipping labelgroup %d \"%s\" in layer \"%s\": too "
+                         "close to an identical label (mindistance)\n",
                          l, cachePtr->textsymbols[0]->annotext, layerPtr->name);
               }
             }
 
-            if(cachePtr->status == MS_OFF || cachePtr->status == MS_DELETE)
+            if (cachePtr->status == MS_OFF || cachePtr->status == MS_DELETE)
               continue; /* next labelCacheMemberObj, as we had a collision */
 
             /* insert the rendered label */
             insertRenderedLabelMember(map, cachePtr);
 
-            for(ll=0; ll<cachePtr->numtextsymbols; ll++) {
+            for (ll = 0; ll < cachePtr->numtextsymbols; ll++) {
               textSymbolPtr = cachePtr->textsymbols[ll];
 
               /* here's where we draw the label styles */
-                for(i=0; i<textSymbolPtr->label->numstyles; i++) {
-                  if(textSymbolPtr->label->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOINT) {
-                    if(MS_UNLIKELY(MS_FAILURE == msDrawMarkerSymbol(map, image, &(cachePtr->point), textSymbolPtr->label->styles[i], textSymbolPtr->scalefactor))) {
+              for (i = 0; i < textSymbolPtr->label->numstyles; i++) {
+                if (textSymbolPtr->label->styles[i]->_geomtransform.type ==
+                    MS_GEOMTRANSFORM_LABELPOINT) {
+                  if (MS_UNLIKELY(
+                          MS_FAILURE ==
+                          msDrawMarkerSymbol(map, image, &(cachePtr->point),
+                                             textSymbolPtr->label->styles[i],
+                                             textSymbolPtr->scalefactor))) {
+                    return MS_FAILURE;
+                  }
+                } else if (textSymbolPtr->annotext &&
+                           textSymbolPtr->label->styles[i]
+                                   ->_geomtransform.type ==
+                               MS_GEOMTRANSFORM_LABELPOLY) {
+                  if (textSymbolPtr->style_bounds &&
+                      textSymbolPtr->style_bounds[i]) {
+                    if (MS_UNLIKELY(
+                            MS_FAILURE ==
+                            msDrawLabelBounds(map, image,
+                                              textSymbolPtr->style_bounds[i],
+                                              textSymbolPtr->label->styles[i],
+                                              textSymbolPtr->scalefactor))) {
                       return MS_FAILURE;
                     }
-                  } else if(textSymbolPtr->annotext && textSymbolPtr->label->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOLY) {
-                    if(textSymbolPtr->style_bounds && textSymbolPtr->style_bounds[i]) {
-                      if(MS_UNLIKELY(MS_FAILURE == msDrawLabelBounds(map,image,textSymbolPtr->style_bounds[i],textSymbolPtr->label->styles[i], textSymbolPtr->scalefactor))) {
-                        return MS_FAILURE;
-                      }
-                    } else {
-                      if(MS_UNLIKELY(MS_FAILURE == msDrawLabelBounds(map,image,&labelpoly_bounds,textSymbolPtr->label->styles[i], textSymbolPtr->scalefactor))) {
-                        return MS_FAILURE;
-                      }
+                  } else {
+                    if (MS_UNLIKELY(
+                            MS_FAILURE ==
+                            msDrawLabelBounds(map, image, &labelpoly_bounds,
+                                              textSymbolPtr->label->styles[i],
+                                              textSymbolPtr->scalefactor))) {
+                      return MS_FAILURE;
                     }
-		  } else if(textSymbolPtr->annotext && textSymbolPtr->label->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_LABELCENTER) {
-                    pointObj labelCenter;
-
-                    if(textSymbolPtr->style_bounds && textSymbolPtr->style_bounds[i]) {
-                      labelCenter.x = (textSymbolPtr->style_bounds[i]->bbox.maxx + textSymbolPtr->style_bounds[i]->bbox.minx)/2;
-                      labelCenter.y = (textSymbolPtr->style_bounds[i]->bbox.maxy + textSymbolPtr->style_bounds[i]->bbox.miny)/2;
-                      if(MS_UNLIKELY(MS_FAILURE == msDrawMarkerSymbol(map,image,&labelCenter,textSymbolPtr->label->styles[i], textSymbolPtr->scalefactor))) {
-                        return MS_FAILURE;
-                      }
-                    } else {
-                      labelCenter.x = (labelpoly_bounds.bbox.maxx + labelpoly_bounds.bbox.minx)/2;
-                      labelCenter.y = (labelpoly_bounds.bbox.maxy + labelpoly_bounds.bbox.miny)/2;
-                      if(MS_UNLIKELY(MS_FAILURE == msDrawMarkerSymbol(map,image,&labelCenter,textSymbolPtr->label->styles[i], textSymbolPtr->scalefactor))) {
-                        return MS_FAILURE;
-                      }
+                  }
+                } else if (textSymbolPtr->annotext &&
+                           textSymbolPtr->label->styles[i]
+                                   ->_geomtransform.type ==
+                               MS_GEOMTRANSFORM_LABELCENTER) {
+                  pointObj labelCenter;
+
+                  if (textSymbolPtr->style_bounds &&
+                      textSymbolPtr->style_bounds[i]) {
+                    labelCenter.x =
+                        (textSymbolPtr->style_bounds[i]->bbox.maxx +
+                         textSymbolPtr->style_bounds[i]->bbox.minx) /
+                        2;
+                    labelCenter.y =
+                        (textSymbolPtr->style_bounds[i]->bbox.maxy +
+                         textSymbolPtr->style_bounds[i]->bbox.miny) /
+                        2;
+                    if (MS_UNLIKELY(
+                            MS_FAILURE ==
+                            msDrawMarkerSymbol(map, image, &labelCenter,
+                                               textSymbolPtr->label->styles[i],
+                                               textSymbolPtr->scalefactor))) {
+                      return MS_FAILURE;
                     }
-
                   } else {
-                    msSetError(MS_MISCERR,"Labels only support LABELPNT, LABELPOLY and LABELCENTER GEOMTRANSFORMS", "msDrawLabelCache()");
-                    return MS_FAILURE;
+                    labelCenter.x = (labelpoly_bounds.bbox.maxx +
+                                     labelpoly_bounds.bbox.minx) /
+                                    2;
+                    labelCenter.y = (labelpoly_bounds.bbox.maxy +
+                                     labelpoly_bounds.bbox.miny) /
+                                    2;
+                    if (MS_UNLIKELY(
+                            MS_FAILURE ==
+                            msDrawMarkerSymbol(map, image, &labelCenter,
+                                               textSymbolPtr->label->styles[i],
+                                               textSymbolPtr->scalefactor))) {
+                      return MS_FAILURE;
+                    }
                   }
+
+                } else {
+                  msSetError(MS_MISCERR,
+                             "Labels only support LABELPNT, LABELPOLY and "
+                             "LABELCENTER GEOMTRANSFORMS",
+                             "msDrawLabelCache()");
+                  return MS_FAILURE;
                 }
-              
-              if(textSymbolPtr->annotext) {
-                if(MS_UNLIKELY(MS_FAILURE == msDrawTextSymbol(map,image,textSymbolPtr->annopoint,textSymbolPtr))) {
+              }
+
+              if (textSymbolPtr->annotext) {
+                if (MS_UNLIKELY(MS_FAILURE ==
+                                msDrawTextSymbol(map, image,
+                                                 textSymbolPtr->annopoint,
+                                                 textSymbolPtr))) {
                   return MS_FAILURE;
                 }
               }
             }
           }
         } /* next label(group) from cacheslot */
-        if(MS_UNLIKELY(MS_FAILURE == msDrawOffsettedLabels(image, map, priority))) {
+        if (MS_UNLIKELY(MS_FAILURE ==
+                        msDrawOffsettedLabels(image, map, priority))) {
           return MS_FAILURE;
         }
       } /* next priority */
@@ -3507,18 +4105,21 @@ int msDrawLabelCache(mapObj *map, imageO
       tstyle.color.red = 255;
       tstyle.color.green = 0;
       tstyle.color.blue = 0;
-      for(priority=MS_MAX_LABEL_PRIORITY-1; priority>=0; priority--) {
+      for (priority = MS_MAX_LABEL_PRIORITY - 1; priority >= 0; priority--) {
         labelCacheSlotObj *cacheslot;
         cacheslot = &(map->labelcache.slots[priority]);
 
-        for(l=cacheslot->numlabels-1; l>=0; l--) {
-          cachePtr = &(cacheslot->labels[l]); /* point to right spot in the label cache */
+        for (l = cacheslot->numlabels - 1; l >= 0; l--) {
+          cachePtr =
+              &(cacheslot
+                    ->labels[l]); /* point to right spot in the label cache */
           /*
           assert((cachePtr->poly == NULL && cachePtr->status == MS_OFF) ||
                   (cachePtr->poly && (cachePtr->status == MS_ON));
            */
-          if(cachePtr->status) {
-            msDrawLineSymbol(map, image, cachePtr->poly, &tstyle, layerPtr->scalefactor);
+          if (cachePtr->status) {
+            msDrawLineSymbol(map, image, cachePtr->poly, &tstyle,
+                             layerPtr->scalefactor);
           }
         }
       }
@@ -3528,60 +4129,60 @@ int msDrawLabelCache(mapObj *map, imageO
     }
   }
 
-  if(map->debug >= MS_DEBUGLEVEL_TUNING) {
+  if (map->debug >= MS_DEBUGLEVEL_TUNING) {
     msGettimeofday(&endtime, NULL);
     msDebug("msDrawMap(): Drawing Label Cache, %.3fs\n",
-            (endtime.tv_sec+endtime.tv_usec/1.0e6)-
-            (starttime.tv_sec+starttime.tv_usec/1.0e6) );
+            (endtime.tv_sec + endtime.tv_usec / 1.0e6) -
+                (starttime.tv_sec + starttime.tv_usec / 1.0e6));
   }
 
   return nReturnVal;
 }
 
-
 /**
  * Generic function to tell the underline device that layer
  * drawing is stating
  */
 
-void msImageStartLayer(mapObj *map, layerObj *layer, imageObj *image)
-{
+void msImageStartLayer(mapObj *map, layerObj *layer, imageObj *image) {
   if (image) {
-    if( MS_RENDERER_PLUGIN(image->format) ) {
-      const char *approximation_scale = msLayerGetProcessingKey( layer, "APPROXIMATION_SCALE" );
-      if(approximation_scale) {
-        if(!strncasecmp(approximation_scale,"ROUND",5)) {
+    if (MS_RENDERER_PLUGIN(image->format)) {
+      const char *approximation_scale =
+          msLayerGetProcessingKey(layer, "APPROXIMATION_SCALE");
+      if (approximation_scale) {
+        if (!strncasecmp(approximation_scale, "ROUND", 5)) {
           MS_IMAGE_RENDERER(image)->transform_mode = MS_TRANSFORM_ROUND;
-        } else if(!strncasecmp(approximation_scale,"FULL",4)) {
-          MS_IMAGE_RENDERER(image)->transform_mode = MS_TRANSFORM_FULLRESOLUTION;
-        } else if(!strncasecmp(approximation_scale,"SIMPLIFY",8)) {
+        } else if (!strncasecmp(approximation_scale, "FULL", 4)) {
+          MS_IMAGE_RENDERER(image)->transform_mode =
+              MS_TRANSFORM_FULLRESOLUTION;
+        } else if (!strncasecmp(approximation_scale, "SIMPLIFY", 8)) {
           MS_IMAGE_RENDERER(image)->transform_mode = MS_TRANSFORM_SIMPLIFY;
         } else {
           MS_IMAGE_RENDERER(image)->transform_mode = MS_TRANSFORM_SNAPTOGRID;
-          MS_IMAGE_RENDERER(image)->approximation_scale = atof(approximation_scale);
+          MS_IMAGE_RENDERER(image)->approximation_scale =
+              atof(approximation_scale);
         }
       } else {
-        MS_IMAGE_RENDERER(image)->transform_mode = MS_IMAGE_RENDERER(image)->default_transform_mode;
-        MS_IMAGE_RENDERER(image)->approximation_scale = MS_IMAGE_RENDERER(image)->default_approximation_scale;
+        MS_IMAGE_RENDERER(image)->transform_mode =
+            MS_IMAGE_RENDERER(image)->default_transform_mode;
+        MS_IMAGE_RENDERER(image)->approximation_scale =
+            MS_IMAGE_RENDERER(image)->default_approximation_scale;
       }
       MS_IMAGE_RENDERER(image)->startLayer(image, map, layer);
-    } else if( MS_RENDERER_IMAGEMAP(image->format) )
+    } else if (MS_RENDERER_IMAGEMAP(image->format))
       msImageStartLayerIM(map, layer, image);
-
   }
 }
 
-
 /**
  * Generic function to tell the underline device that layer
  * drawing is ending
  */
 
-void msImageEndLayer(mapObj *map, layerObj *layer, imageObj *image)
-{
-  if(image) {
-    if( MS_RENDERER_PLUGIN(image->format) ) {
-      MS_IMAGE_RENDERER(image)->endLayer(image,map,layer);
+void msImageEndLayer(mapObj *map, layerObj *layer, imageObj *image) {
+  if (image) {
+    if (MS_RENDERER_PLUGIN(image->format)) {
+      MS_IMAGE_RENDERER(image)->endLayer(image, map, layer);
     }
   }
 }
@@ -3592,32 +4193,27 @@ void msImageEndLayer(mapObj *map, layerO
  */
 
 void msDrawStartShape(mapObj *map, layerObj *layer, imageObj *image,
-                      shapeObj *shape)
-{
+                      shapeObj *shape) {
   (void)map;
   (void)layer;
   if (image) {
-    if(MS_RENDERER_PLUGIN(image->format)) {
+    if (MS_RENDERER_PLUGIN(image->format)) {
       if (image->format->vtable->startShape)
         image->format->vtable->startShape(image, shape);
     }
-
-
   }
 }
 
-
 /**
  * Generic function to tell the underline device that shape
  * drawing is ending
  */
 
 void msDrawEndShape(mapObj *map, layerObj *layer, imageObj *image,
-                    shapeObj *shape)
-{
+                    shapeObj *shape) {
   (void)map;
   (void)layer;
-  if(MS_RENDERER_PLUGIN(image->format)) {
+  if (MS_RENDERER_PLUGIN(image->format)) {
     if (image->format->vtable->endShape)
       image->format->vtable->endShape(image, shape);
   }
@@ -3626,11 +4222,10 @@ void msDrawEndShape(mapObj *map, layerOb
  * take the value from the shape and use it to change the
  * color in the style to match the range map
  */
-int msShapeToRange(styleObj *style, shapeObj *shape)
-{
+int msShapeToRange(styleObj *style, shapeObj *shape) {
   /*first, get the value of the rangeitem, which should*/
   /*evaluate to a double*/
-  const char* fieldStr = shape->values[style->rangeitemindex];
+  const char *fieldStr = shape->values[style->rangeitemindex];
   if (fieldStr == NULL) { /*if there's not value, bail*/
     return MS_FAILURE;
   }
@@ -3644,42 +4239,59 @@ int msShapeToRange(styleObj *style, shap
  * Ranges.  The styls passed in is updated to reflect the right color
  * based on the fieldVal
  */
-int msValueToRange(styleObj *style, double fieldVal, colorspace cs)
-{
+int msValueToRange(styleObj *style, double fieldVal, colorspace cs) {
   double range;
   double scaledVal;
 
   range = style->maxvalue - style->minvalue;
-  scaledVal = (fieldVal - style->minvalue)/range;
+  scaledVal = (fieldVal - style->minvalue) / range;
 
-  if(cs == MS_COLORSPACE_RGB) {
+  if (cs == MS_COLORSPACE_RGB) {
     /*At this point, we know where on the range we need to be*/
     /*However, we don't know how to map it yet, since RGB(A) can */
     /*Go up or down*/
-    style->color.red = (int)(MS_MAX(0,(MS_MIN(255, (style->mincolor.red + ((style->maxcolor.red - style->mincolor.red) * scaledVal))))));
-    style->color.green = (int)(MS_MAX(0,(MS_MIN(255,(style->mincolor.green + ((style->maxcolor.green - style->mincolor.green) * scaledVal))))));
-    style->color.blue = (int)(MS_MAX(0,(MS_MIN(255,(style->mincolor.blue + ((style->maxcolor.blue - style->mincolor.blue) * scaledVal))))));
-    style->color.alpha = (int)(MS_MAX(0,(MS_MIN(255,(style->mincolor.alpha + ((style->maxcolor.alpha - style->mincolor.alpha) * scaledVal))))));
+    style->color.red = (int)(MS_MAX(
+        0, (MS_MIN(255, (style->mincolor.red +
+                         ((style->maxcolor.red - style->mincolor.red) *
+                          scaledVal))))));
+    style->color.green = (int)(MS_MAX(
+        0, (MS_MIN(255, (style->mincolor.green +
+                         ((style->maxcolor.green - style->mincolor.green) *
+                          scaledVal))))));
+    style->color.blue = (int)(MS_MAX(
+        0, (MS_MIN(255, (style->mincolor.blue +
+                         ((style->maxcolor.blue - style->mincolor.blue) *
+                          scaledVal))))));
+    style->color.alpha = (int)(MS_MAX(
+        0, (MS_MIN(255, (style->mincolor.alpha +
+                         ((style->maxcolor.alpha - style->mincolor.alpha) *
+                          scaledVal))))));
   } else {
     /* HSL */
     assert(cs == MS_COLORSPACE_HSL);
-    if(fieldVal <= style->minvalue) style->color = style->mincolor;
-    else if(fieldVal >= style->maxvalue) style->color = style->maxcolor;
+    if (fieldVal <= style->minvalue)
+      style->color = style->mincolor;
+    else if (fieldVal >= style->maxvalue)
+      style->color = style->maxcolor;
     else {
-      double mh,ms,ml,Mh,Ms,Ml;
-      msRGBtoHSL(&style->mincolor,&mh,&ms,&ml);
-      msRGBtoHSL(&style->maxcolor,&Mh,&Ms,&Ml);
-      mh+=(Mh-mh)*scaledVal;
-      ms+=(Ms-ms)*scaledVal;
-      ml+=(Ml-ml)*scaledVal;
-      msHSLtoRGB(mh,ms,ml,&style->color);
-      style->color.alpha = style->mincolor.alpha + (style->maxcolor.alpha - style->mincolor.alpha)*scaledVal;
+      double mh, ms, ml, Mh, Ms, Ml;
+      msRGBtoHSL(&style->mincolor, &mh, &ms, &ml);
+      msRGBtoHSL(&style->maxcolor, &Mh, &Ms, &Ml);
+      mh += (Mh - mh) * scaledVal;
+      ms += (Ms - ms) * scaledVal;
+      ml += (Ml - ml) * scaledVal;
+      msHSLtoRGB(mh, ms, ml, &style->color);
+      style->color.alpha =
+          style->mincolor.alpha +
+          (style->maxcolor.alpha - style->mincolor.alpha) * scaledVal;
     }
   }
-  /*( "msMapRange(): %i %i %i", style->color.red , style->color.green, style->color.blue);*/
+  /*( "msMapRange(): %i %i %i", style->color.red , style->color.green,
+   * style->color.blue);*/
 
 #if ALPHACOLOR_ENABLED
-  /*NO ALPHA RANGE YET  style->color.alpha = style->mincolor.alpha + ((style->maxcolor.alpha - style->mincolor.alpha) * scaledVal);*/
+  /*NO ALPHA RANGE YET  style->color.alpha = style->mincolor.alpha +
+   * ((style->maxcolor.alpha - style->mincolor.alpha) * scaledVal);*/
 #endif
 
   return MS_SUCCESS;
diff -pruN 8.0.1-5/mapdrawgdal.c 8.0.2-1/mapdrawgdal.c
--- 8.0.1-5/mapdrawgdal.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapdrawgdal.c	2024-06-11 20:41:34.000000000 +0000
@@ -35,57 +35,50 @@
 #include "mapthread.h"
 #include "maptime.h"
 
-
-extern int InvGeoTransform( double *gt_in, double *gt_out );
+extern int InvGeoTransform(double *gt_in, double *gt_out);
 
 #define MAXCOLORS 256
-#define GEO_TRANS(tr,x,y)  ((tr)[0]+(tr)[1]*(x)+(tr)[2]*(y))
-#define SKIP_MASK(x,y) (mask_rb && !*(mask_rb->data.rgba.a+(y)*mask_rb->data.rgba.row_step+(x)*mask_rb->data.rgba.pixel_step))
+#define GEO_TRANS(tr, x, y) ((tr)[0] + (tr)[1] * (x) + (tr)[2] * (y))
+#define SKIP_MASK(x, y)                                                        \
+  (mask_rb && !*(mask_rb->data.rgba.a + (y)*mask_rb->data.rgba.row_step +      \
+                 (x)*mask_rb->data.rgba.pixel_step))
 
 #include "gdal.h"
 #include "cpl_string.h"
 
 #include "gdal_alg.h"
 
-static bool
-IsNoData( double dfValue, double dfNoDataValue );
-
-static int
-LoadGDALImages( GDALDatasetH hDS, int band_numbers[4], int band_count,
-                layerObj *layer,
-                int src_xoff, int src_yoff, int src_xsize, int src_ysize,
-                GByte *pabyBuffer,
-                int dst_xsize, int dst_ysize,
-                int *pbHaveRGBNoData,
-                int *pnNoData1, int *pnNoData2, int *pnNoData3,
-                bool *pbScaled, double *pdfScaleMin, double *pdfScaleRatio,
-                bool **ppbIsNoDataBuffer );
-static int
-msDrawRasterLayerGDAL_RawMode(
-  mapObj *map, layerObj *layer, imageObj *image, GDALDatasetH hDS,
-  int src_xoff, int src_yoff, int src_xsize, int src_ysize,
-  int dst_xoff, int dst_yoff, int dst_xsize, int dst_ysize );
-
-static int
-msDrawRasterLayerGDAL_16BitClassification(
-  mapObj *map, layerObj *layer, rasterBufferObj *rb,
-  GDALRasterBandH hBand,
-  int src_xoff, int src_yoff, int src_xsize, int src_ysize,
-  int dst_xoff, int dst_yoff, int dst_xsize, int dst_ysize );
+static bool IsNoData(double dfValue, double dfNoDataValue);
 
+static int LoadGDALImages(GDALDatasetH hDS, int band_numbers[4], int band_count,
+                          layerObj *layer, int src_xoff, int src_yoff,
+                          int src_xsize, int src_ysize, GByte *pabyBuffer,
+                          int dst_xsize, int dst_ysize, int *pbHaveRGBNoData,
+                          int *pnNoData1, int *pnNoData2, int *pnNoData3,
+                          bool *pbScaled, double *pdfScaleMin,
+                          double *pdfScaleRatio, bool **ppbIsNoDataBuffer);
+static int msDrawRasterLayerGDAL_RawMode(mapObj *map, layerObj *layer,
+                                         imageObj *image, GDALDatasetH hDS,
+                                         int src_xoff, int src_yoff,
+                                         int src_xsize, int src_ysize,
+                                         int dst_xoff, int dst_yoff,
+                                         int dst_xsize, int dst_ysize);
+
+static int msDrawRasterLayerGDAL_16BitClassification(
+    mapObj *map, layerObj *layer, rasterBufferObj *rb, GDALRasterBandH hBand,
+    int src_xoff, int src_yoff, int src_xsize, int src_ysize, int dst_xoff,
+    int dst_yoff, int dst_xsize, int dst_ysize);
 
 /*
  * rasterBufferObj setting macros.
  */
 
-
-
 /************************************************************************/
 /*                       msDrawRasterLayerGDAL()                        */
 /************************************************************************/
 
 int msDrawRasterLayerGDAL(mapObj *map, layerObj *layer, imageObj *image,
-                          rasterBufferObj *rb, void *hDSVoid )
+                          rasterBufferObj *rb, void *hDSVoid)
 
 {
   int i; /* loop counters */
@@ -99,35 +92,37 @@ int msDrawRasterLayerGDAL(mapObj *map, l
   int src_xoff, src_yoff, src_xsize, src_ysize;
   double llx, lly, urx, ury;
   rectObj copyRect, mapRect;
-  unsigned char *pabyRaw1=NULL, *pabyRaw2=NULL, *pabyRaw3=NULL,
-                 *pabyRawAlpha = NULL;
+  unsigned char *pabyRaw1 = NULL, *pabyRaw2 = NULL, *pabyRaw3 = NULL,
+                *pabyRawAlpha = NULL;
   int classified = FALSE;
-  int red_band=0, green_band=0, blue_band=0, alpha_band=0;
+  int red_band = 0, green_band = 0, blue_band = 0, alpha_band = 0;
   int band_count, band_numbers[4];
   GDALDatasetH hDS = hDSVoid;
-  GDALColorTableH hColorMap=NULL;
-  GDALRasterBandH hBand1=NULL, hBand2=NULL, hBand3=NULL, hBandAlpha=NULL;
+  GDALColorTableH hColorMap = NULL;
+  GDALRasterBandH hBand1 = NULL, hBand2 = NULL, hBand3 = NULL,
+                  hBandAlpha = NULL;
   int bHaveRGBNoData = FALSE;
-  int nNoData1=-1,nNoData2=-1,nNoData3=-1;
+  int nNoData1 = -1, nNoData2 = -1, nNoData3 = -1;
   rasterBufferObj *mask_rb = NULL;
   rasterBufferObj s_mask_rb;
 
-  if(layer->mask) {
+  if (layer->mask) {
     int ret;
-    layerObj *maskLayer = GET_LAYER(map, msGetLayerIndex(map,layer->mask));
+    layerObj *maskLayer = GET_LAYER(map, msGetLayerIndex(map, layer->mask));
     mask_rb = &s_mask_rb;
     memset(mask_rb, 0, sizeof(s_mask_rb));
-    ret = MS_IMAGE_RENDERER(maskLayer->maskimage)->getRasterBufferHandle(maskLayer->maskimage,mask_rb);
-    if(ret != MS_SUCCESS)
+    ret = MS_IMAGE_RENDERER(maskLayer->maskimage)
+              ->getRasterBufferHandle(maskLayer->maskimage, mask_rb);
+    if (ret != MS_SUCCESS)
       return -1;
   }
 
   /*only support rawdata and pluggable renderers*/
-  assert(MS_RENDERER_RAWDATA(image->format) || (MS_RENDERER_PLUGIN(image->format) && rb));
-
+  assert(MS_RENDERER_RAWDATA(image->format) ||
+         (MS_RENDERER_PLUGIN(image->format) && rb));
 
-  memset( cmap, 0xff, MAXCOLORS * sizeof(int) );
-  memset( rb_cmap, 0, sizeof(rb_cmap) );
+  memset(cmap, 0xff, MAXCOLORS * sizeof(int));
+  memset(rb_cmap, 0, sizeof(rb_cmap));
 
   /* -------------------------------------------------------------------- */
   /*      Test the image format instead of the map format.                */
@@ -137,9 +132,8 @@ int msDrawRasterLayerGDAL(mapObj *map, l
   /*      and then dumped into the SWF or the PDF file.                   */
   /* -------------------------------------------------------------------- */
 
-
-  src_xsize = GDALGetRasterXSize( hDS );
-  src_ysize = GDALGetRasterYSize( hDS );
+  src_xsize = GDALGetRasterXSize(hDS);
+  src_ysize = GDALGetRasterYSize(hDS);
 
   /*
    * If the RAW_WINDOW attribute is set, use that to establish what to
@@ -147,21 +141,19 @@ int msDrawRasterLayerGDAL(mapObj *map, l
    * problems with rotated maps.
    */
 
-  if( CSLFetchNameValue( layer->processing, "RAW_WINDOW" ) != NULL ) {
+  if (CSLFetchNameValue(layer->processing, "RAW_WINDOW") != NULL) {
     char **papszTokens =
-      CSLTokenizeString(
-        CSLFetchNameValue( layer->processing, "RAW_WINDOW" ) );
+        CSLTokenizeString(CSLFetchNameValue(layer->processing, "RAW_WINDOW"));
 
-    if( layer->debug )
-      msDebug( "msDrawGDAL(%s): using RAW_WINDOW=%s, dst=0,0,%d,%d\n",
-               layer->name,
-               CSLFetchNameValue( layer->processing, "RAW_WINDOW" ),
-               image->width, image->height );
-
-    if( CSLCount(papszTokens) != 4 ) {
-      CSLDestroy( papszTokens );
-      msSetError( MS_IMGERR, "RAW_WINDOW PROCESSING directive corrupt.",
-                  "msDrawGDAL()" );
+    if (layer->debug)
+      msDebug("msDrawGDAL(%s): using RAW_WINDOW=%s, dst=0,0,%d,%d\n",
+              layer->name, CSLFetchNameValue(layer->processing, "RAW_WINDOW"),
+              image->width, image->height);
+
+    if (CSLCount(papszTokens) != 4) {
+      CSLDestroy(papszTokens);
+      msSetError(MS_IMGERR, "RAW_WINDOW PROCESSING directive corrupt.",
+                 "msDrawGDAL()");
       return -1;
     }
 
@@ -175,107 +167,109 @@ int msDrawRasterLayerGDAL(mapObj *map, l
     dst_xsize = image->width;
     dst_ysize = image->height;
 
-    CSLDestroy( papszTokens );
+    CSLDestroy(papszTokens);
   }
 
   /*
    * Compute the georeferenced window of overlap, and do nothing if there
    * is no overlap between the map extents, and the file we are operating on.
    */
-  else if( layer->transform ) {
+  else if (layer->transform) {
     int dst_lrx, dst_lry;
 
-    if( layer->debug )
-      msDebug( "msDrawRasterLayerGDAL(): Entering transform.\n" );
+    if (layer->debug)
+      msDebug("msDrawRasterLayerGDAL(): Entering transform.\n");
 
-    msGetGDALGeoTransform( hDS, map, layer, adfGeoTransform );
-    InvGeoTransform( adfGeoTransform, adfInvGeoTransform );
+    msGetGDALGeoTransform(hDS, map, layer, adfGeoTransform);
+    InvGeoTransform(adfGeoTransform, adfInvGeoTransform);
 
     mapRect = map->extent;
 
-    mapRect.minx -= map->cellsize*0.5;
-    mapRect.maxx += map->cellsize*0.5;
-    mapRect.miny -= map->cellsize*0.5;
-    mapRect.maxy += map->cellsize*0.5;
+    mapRect.minx -= map->cellsize * 0.5;
+    mapRect.maxx += map->cellsize * 0.5;
+    mapRect.miny -= map->cellsize * 0.5;
+    mapRect.maxy += map->cellsize * 0.5;
 
     copyRect = mapRect;
 
-    if( copyRect.minx < GEO_TRANS(adfGeoTransform,0,src_ysize) )
-      copyRect.minx = GEO_TRANS(adfGeoTransform,0,src_ysize);
-    if( copyRect.maxx > GEO_TRANS(adfGeoTransform,src_xsize,0) )
-      copyRect.maxx = GEO_TRANS(adfGeoTransform,src_xsize,0);
-
-    if( copyRect.miny < GEO_TRANS(adfGeoTransform+3,0,src_ysize) )
-      copyRect.miny = GEO_TRANS(adfGeoTransform+3,0,src_ysize);
-    if( copyRect.maxy > GEO_TRANS(adfGeoTransform+3,src_xsize,0) )
-      copyRect.maxy = GEO_TRANS(adfGeoTransform+3,src_xsize,0);
-
-    if( copyRect.minx >= copyRect.maxx || copyRect.miny >= copyRect.maxy ) {
-      if( layer->debug )
-        msDebug( "msDrawRasterLayerGDAL(): Error in overlap calculation.\n" );
+    if (copyRect.minx < GEO_TRANS(adfGeoTransform, 0, src_ysize))
+      copyRect.minx = GEO_TRANS(adfGeoTransform, 0, src_ysize);
+    if (copyRect.maxx > GEO_TRANS(adfGeoTransform, src_xsize, 0))
+      copyRect.maxx = GEO_TRANS(adfGeoTransform, src_xsize, 0);
+
+    if (copyRect.miny < GEO_TRANS(adfGeoTransform + 3, 0, src_ysize))
+      copyRect.miny = GEO_TRANS(adfGeoTransform + 3, 0, src_ysize);
+    if (copyRect.maxy > GEO_TRANS(adfGeoTransform + 3, src_xsize, 0))
+      copyRect.maxy = GEO_TRANS(adfGeoTransform + 3, src_xsize, 0);
+
+    if (copyRect.minx >= copyRect.maxx || copyRect.miny >= copyRect.maxy) {
+      if (layer->debug)
+        msDebug("msDrawRasterLayerGDAL(): Error in overlap calculation.\n");
       return 0;
     }
 
     /*
      * Copy the source and destination raster coordinates.
      */
-    llx = GEO_TRANS(adfInvGeoTransform+0,copyRect.minx,copyRect.miny);
-    lly = GEO_TRANS(adfInvGeoTransform+3,copyRect.minx,copyRect.miny);
-    urx = GEO_TRANS(adfInvGeoTransform+0,copyRect.maxx,copyRect.maxy);
-    ury = GEO_TRANS(adfInvGeoTransform+3,copyRect.maxx,copyRect.maxy);
-
-    src_xoff = MS_MAX(0,(int) floor(llx+0.5));
-    src_yoff = MS_MAX(0,(int) floor(ury+0.5));
-    src_xsize = MS_MIN(MS_MAX(0,(int) (urx - llx + 0.5)),
-                    GDALGetRasterXSize(hDS) - src_xoff);
-    src_ysize = MS_MIN(MS_MAX(0,(int) (lly - ury + 0.5)),
-                    GDALGetRasterYSize(hDS) - src_yoff);
+    llx = GEO_TRANS(adfInvGeoTransform + 0, copyRect.minx, copyRect.miny);
+    lly = GEO_TRANS(adfInvGeoTransform + 3, copyRect.minx, copyRect.miny);
+    urx = GEO_TRANS(adfInvGeoTransform + 0, copyRect.maxx, copyRect.maxy);
+    ury = GEO_TRANS(adfInvGeoTransform + 3, copyRect.maxx, copyRect.maxy);
+
+    src_xoff = MS_MAX(0, (int)floor(llx + 0.5));
+    src_yoff = MS_MAX(0, (int)floor(ury + 0.5));
+    src_xsize = MS_MIN(MS_MAX(0, (int)(urx - llx + 0.5)),
+                       GDALGetRasterXSize(hDS) - src_xoff);
+    src_ysize = MS_MIN(MS_MAX(0, (int)(lly - ury + 0.5)),
+                       GDALGetRasterYSize(hDS) - src_yoff);
 
     /* We want very small windows to use at least one source pixel (#4172) */
-    if( src_xsize == 0 && (urx - llx) > 0.0 ) {
+    if (src_xsize == 0 && (urx - llx) > 0.0) {
       src_xsize = 1;
-      src_xoff = MS_MIN(src_xoff,GDALGetRasterXSize(hDS)-1);
+      src_xoff = MS_MIN(src_xoff, GDALGetRasterXSize(hDS) - 1);
     }
-    if( src_ysize == 0 && (lly - ury) > 0.0 ) {
+    if (src_ysize == 0 && (lly - ury) > 0.0) {
       src_ysize = 1;
-      src_yoff = MS_MIN(src_yoff,GDALGetRasterYSize(hDS)-1);
+      src_yoff = MS_MIN(src_yoff, GDALGetRasterYSize(hDS) - 1);
     }
 
-    if( src_xsize == 0 || src_ysize == 0 ) {
-      if( layer->debug )
-        msDebug( "msDrawRasterLayerGDAL(): no apparent overlap between map view and this window(1).\n" );
+    if (src_xsize == 0 || src_ysize == 0) {
+      if (layer->debug)
+        msDebug("msDrawRasterLayerGDAL(): no apparent overlap between map view "
+                "and this window(1).\n");
       return 0;
     }
 
     if (map->cellsize == 0) {
-      if( layer->debug )
-        msDebug( "msDrawRasterLayerGDAL(): Cellsize can't be 0.\n" );
+      if (layer->debug)
+        msDebug("msDrawRasterLayerGDAL(): Cellsize can't be 0.\n");
       return 0;
     }
 
-    dst_xoff = (int) ((copyRect.minx - mapRect.minx) / map->cellsize);
-    dst_yoff = (int) ((mapRect.maxy - copyRect.maxy) / map->cellsize);
+    dst_xoff = (int)((copyRect.minx - mapRect.minx) / map->cellsize);
+    dst_yoff = (int)((mapRect.maxy - copyRect.maxy) / map->cellsize);
 
-    dst_lrx = (int) ((copyRect.maxx - mapRect.minx) / map->cellsize + 0.5);
-    dst_lry = (int) ((mapRect.maxy - copyRect.miny) / map->cellsize + 0.5);
-    dst_lrx = MS_MAX(0,MS_MIN(image->width,dst_lrx));
-    dst_lry = MS_MAX(0,MS_MIN(image->height,dst_lry));
-
-    dst_xsize = MS_MAX(0,MS_MIN(image->width,dst_lrx - dst_xoff));
-    dst_ysize = MS_MAX(0,MS_MIN(image->height,dst_lry - dst_yoff));
-
-    if( dst_xsize == 0 || dst_ysize == 0 ) {
-      if( layer->debug )
-        msDebug( "msDrawRasterLayerGDAL(): no apparent overlap between map view and this window(2).\n" );
+    dst_lrx = (int)((copyRect.maxx - mapRect.minx) / map->cellsize + 0.5);
+    dst_lry = (int)((mapRect.maxy - copyRect.miny) / map->cellsize + 0.5);
+    dst_lrx = MS_MAX(0, MS_MIN(image->width, dst_lrx));
+    dst_lry = MS_MAX(0, MS_MIN(image->height, dst_lry));
+
+    dst_xsize = MS_MAX(0, MS_MIN(image->width, dst_lrx - dst_xoff));
+    dst_ysize = MS_MAX(0, MS_MIN(image->height, dst_lry - dst_yoff));
+
+    if (dst_xsize == 0 || dst_ysize == 0) {
+      if (layer->debug)
+        msDebug("msDrawRasterLayerGDAL(): no apparent overlap between map view "
+                "and this window(2).\n");
       return 0;
     }
 
-    if( layer->debug )
-      msDebug( "msDrawRasterLayerGDAL(): src=%d,%d,%d,%d, dst=%d,%d,%d,%d\n",
-               src_xoff, src_yoff, src_xsize, src_ysize,
-               dst_xoff, dst_yoff, dst_xsize, dst_ysize );
+    if (layer->debug)
+      msDebug("msDrawRasterLayerGDAL(): src=%d,%d,%d,%d, dst=%d,%d,%d,%d\n",
+              src_xoff, src_yoff, src_xsize, src_ysize, dst_xoff, dst_yoff,
+              dst_xsize, dst_ysize);
 #ifndef notdef
-    if( layer->debug ) {
+    if (layer->debug) {
       double d_src_xoff, d_src_yoff, geo_x, geo_y;
 
       geo_x = mapRect.minx + dst_xoff * map->cellsize;
@@ -284,9 +278,9 @@ int msDrawRasterLayerGDAL(mapObj *map, l
       d_src_xoff = (geo_x - adfGeoTransform[0]) / adfGeoTransform[1];
       d_src_yoff = (geo_y - adfGeoTransform[3]) / adfGeoTransform[5];
 
-      msDebug( "msDrawRasterLayerGDAL(): source raster PL (%.3f,%.3f) for dst PL (%d,%d).\n",
-               d_src_xoff, d_src_yoff,
-               dst_xoff, dst_yoff );
+      msDebug("msDrawRasterLayerGDAL(): source raster PL (%.3f,%.3f) for dst "
+              "PL (%d,%d).\n",
+              d_src_xoff, d_src_yoff, dst_xoff, dst_yoff);
     }
 #endif
   }
@@ -297,19 +291,18 @@ int msDrawRasterLayerGDAL(mapObj *map, l
   else {
     dst_xoff = src_xoff = 0;
     dst_yoff = src_yoff = 0;
-    dst_xsize = src_xsize = MS_MIN(image->width,src_xsize);
-    dst_ysize = src_ysize = MS_MIN(image->height,src_ysize);
+    dst_xsize = src_xsize = MS_MIN(image->width, src_xsize);
+    dst_ysize = src_ysize = MS_MIN(image->height, src_ysize);
   }
 
   /*
    * In RAWDATA mode we don't fool with colors.  Do the raw processing,
    * and return from the function early.
    */
-  if( MS_RENDERER_RAWDATA( image->format ) ) {
+  if (MS_RENDERER_RAWDATA(image->format)) {
     return msDrawRasterLayerGDAL_RawMode(
-             map, layer, image, hDS,
-             src_xoff, src_yoff, src_xsize, src_ysize,
-             dst_xoff, dst_yoff, dst_xsize, dst_ysize );
+        map, layer, image, hDS, src_xoff, src_yoff, src_xsize, src_ysize,
+        dst_xoff, dst_yoff, dst_xsize, dst_ysize);
   }
 
   /*
@@ -318,19 +311,19 @@ int msDrawRasterLayerGDAL(mapObj *map, l
    * to treat the raster as classified if there is just a bogus class here
    * to force inclusion in the legend.
    */
-  for( i = 0; i < layer->numclasses; i++ ) {
+  for (i = 0; i < layer->numclasses; i++) {
     int s;
 
     /* change colour based on colour range? */
-    for(s=0; s<layer->class[i]->numstyles; s++) {
-      if( MS_VALID_COLOR(layer->class[i]->styles[s]->mincolor)
-          && MS_VALID_COLOR(layer->class[i]->styles[s]->maxcolor) ) {
+    for (s = 0; s < layer->class[i] -> numstyles; s++) {
+      if (MS_VALID_COLOR(layer->class[i] -> styles[s] -> mincolor) &&
+          MS_VALID_COLOR(layer->class[i] -> styles[s] -> maxcolor)) {
         classified = TRUE;
         break;
       }
     }
 
-    if( layer->class[i]->expression.string != NULL ) {
+    if (layer->class[i] -> expression.string != NULL) {
       classified = TRUE;
       break;
     }
@@ -342,35 +335,32 @@ int msDrawRasterLayerGDAL(mapObj *map, l
    * red=1,green=2,blue=3 or red=1,green=2,blue=3,alpha>=4.
    */
 
-  if( CSLFetchNameValue( layer->processing, "BANDS" ) == NULL ) {
-    const int gdal_band_count = GDALGetRasterCount( hDS );
+  if (CSLFetchNameValue(layer->processing, "BANDS") == NULL) {
+    const int gdal_band_count = GDALGetRasterCount(hDS);
     red_band = 1;
 
-    if( gdal_band_count >= 4 )
-    {
-        /* The alpha band is not necessarily the 4th one */
-        for( i = 4; i <= gdal_band_count; i ++ ) {
-            if( GDALGetRasterColorInterpretation(
-                GDALGetRasterBand( hDS, i ) ) == GCI_AlphaBand ) {
-                alpha_band = i;
-                break;
-            }
+    if (gdal_band_count >= 4) {
+      /* The alpha band is not necessarily the 4th one */
+      for (i = 4; i <= gdal_band_count; i++) {
+        if (GDALGetRasterColorInterpretation(GDALGetRasterBand(hDS, i)) ==
+            GCI_AlphaBand) {
+          alpha_band = i;
+          break;
         }
+      }
     }
 
-    if( gdal_band_count >= 3 ) {
+    if (gdal_band_count >= 3) {
       green_band = 2;
       blue_band = 3;
     }
 
-    if( gdal_band_count == 2
-        && GDALGetRasterColorInterpretation(
-          GDALGetRasterBand( hDS, 2 ) ) == GCI_AlphaBand )
+    if (gdal_band_count == 2 && GDALGetRasterColorInterpretation(
+                                    GDALGetRasterBand(hDS, 2)) == GCI_AlphaBand)
       alpha_band = 2;
 
-    hBand1 = GDALGetRasterBand( hDS, red_band );
-    if( classified
-        || GDALGetRasterColorTable( hBand1 ) != NULL ) {
+    hBand1 = GDALGetRasterBand(hDS, red_band);
+    if (classified || GDALGetRasterColorTable(hBand1) != NULL) {
       alpha_band = 0;
       green_band = 0;
       blue_band = 0;
@@ -378,15 +368,15 @@ int msDrawRasterLayerGDAL(mapObj *map, l
   } else {
     int *band_list;
 
-    band_list = msGetGDALBandList( layer, hDS, 4, &band_count );
-    if( band_list == NULL )
+    band_list = msGetGDALBandList(layer, hDS, 4, &band_count);
+    if (band_list == NULL)
       return -1;
 
-    if( band_count > 0 )
+    if (band_count > 0)
       red_band = band_list[0];
     else
       red_band = 0;
-    if( band_count > 2 ) {
+    if (band_count > 2) {
       green_band = band_list[1];
       blue_band = band_list[2];
     } else {
@@ -394,12 +384,12 @@ int msDrawRasterLayerGDAL(mapObj *map, l
       blue_band = 0;
     }
 
-    if( band_count > 3 )
+    if (band_count > 3)
       alpha_band = band_list[3];
     else
       alpha_band = 0;
 
-    free( band_list );
+    free(band_list);
   }
 
   band_numbers[0] = red_band;
@@ -407,53 +397,53 @@ int msDrawRasterLayerGDAL(mapObj *map, l
   band_numbers[2] = blue_band;
   band_numbers[3] = 0;
 
-  if( blue_band != 0 && alpha_band != 0 ) {
+  if (blue_band != 0 && alpha_band != 0) {
     band_numbers[3] = alpha_band;
     band_count = 4;
-  } else if( blue_band != 0 && alpha_band == 0 )
+  } else if (blue_band != 0 && alpha_band == 0)
     band_count = 3;
-  else if( alpha_band != 0 ) {
+  else if (alpha_band != 0) {
     band_numbers[1] = alpha_band;
     band_count = 2;
   } else
     band_count = 1;
 
-  if( layer->debug > 1 || (layer->debug > 0 && green_band != 0) ) {
-    msDebug( "msDrawRasterLayerGDAL(): red,green,blue,alpha bands = %d,%d,%d,%d\n",
-             red_band, green_band, blue_band, alpha_band );
+  if (layer->debug > 1 || (layer->debug > 0 && green_band != 0)) {
+    msDebug(
+        "msDrawRasterLayerGDAL(): red,green,blue,alpha bands = %d,%d,%d,%d\n",
+        red_band, green_band, blue_band, alpha_band);
   }
 
   /*
    * Get band handles for PC256, RGB or RGBA cases.
    */
-  hBand1 = GDALGetRasterBand( hDS, red_band );
-  if( hBand1 == NULL )
+  hBand1 = GDALGetRasterBand(hDS, red_band);
+  if (hBand1 == NULL)
     return -1;
 
   hBand2 = hBand3 = hBandAlpha = NULL;
 
-  if( green_band != 0 ) {
-    hBand1 = GDALGetRasterBand( hDS, red_band );
-    hBand2 = GDALGetRasterBand( hDS, green_band );
-    hBand3 = GDALGetRasterBand( hDS, blue_band );
-    if( hBand1 == NULL || hBand2 == NULL || hBand3 == NULL )
+  if (green_band != 0) {
+    hBand1 = GDALGetRasterBand(hDS, red_band);
+    hBand2 = GDALGetRasterBand(hDS, green_band);
+    hBand3 = GDALGetRasterBand(hDS, blue_band);
+    if (hBand1 == NULL || hBand2 == NULL || hBand3 == NULL)
       return -1;
   }
 
-  if( alpha_band != 0 )
-    hBandAlpha = GDALGetRasterBand( hDS, alpha_band );
+  if (alpha_band != 0)
+    hBandAlpha = GDALGetRasterBand(hDS, alpha_band);
 
   /*
    * The logic for a classification rendering of non-8bit raster bands
    * is sufficiently different than the normal mechanism of loading
    * into an 8bit buffer, that we isolate it into it's own subfunction.
    */
-  if( classified
-      && hBand1 != NULL && GDALGetRasterDataType( hBand1 ) != GDT_Byte ) {
+  if (classified && hBand1 != NULL &&
+      GDALGetRasterDataType(hBand1) != GDT_Byte) {
     return msDrawRasterLayerGDAL_16BitClassification(
-             map, layer, rb, hBand1,
-             src_xoff, src_yoff, src_xsize, src_ysize,
-             dst_xoff, dst_yoff, dst_xsize, dst_ysize );
+        map, layer, rb, hBand1, src_xoff, src_yoff, src_xsize, src_ysize,
+        dst_xoff, dst_yoff, dst_xsize, dst_ysize);
   }
 
   /*
@@ -462,17 +452,17 @@ int msDrawRasterLayerGDAL(mapObj *map, l
    */
   bool isDefaultGreyscale = false;
 
-  if( hBand2 != NULL )
+  if (hBand2 != NULL)
     hColorMap = NULL;
   else {
-    hColorMap = GDALGetRasterColorTable( hBand1 );
-    if( hColorMap != NULL )
-      hColorMap = GDALCloneColorTable( hColorMap );
+    hColorMap = GDALGetRasterColorTable(hBand1);
+    if (hColorMap != NULL)
+      hColorMap = GDALCloneColorTable(hColorMap);
     else {
-      hColorMap = GDALCreateColorTable( GPI_RGB );
+      hColorMap = GDALCreateColorTable(GPI_RGB);
       isDefaultGreyscale = true;
 
-      for( i = 0; i < 256; i++ ) {
+      for (i = 0; i < 256; i++) {
         colorObj pixel;
         GDALColorEntry sEntry;
 
@@ -480,7 +470,7 @@ int msDrawRasterLayerGDAL(mapObj *map, l
         pixel.green = i;
         pixel.blue = i;
 
-        if(MS_COMPARE_COLORS(pixel, layer->offsite)) {
+        if (MS_COMPARE_COLORS(pixel, layer->offsite)) {
           sEntry.c1 = 0;
           sEntry.c2 = 0;
           sEntry.c3 = 0;
@@ -492,7 +482,7 @@ int msDrawRasterLayerGDAL(mapObj *map, l
           sEntry.c4 = 255;
         }
 
-        GDALSetColorEntry( hColorMap, i, &sEntry );
+        GDALSetColorEntry(hColorMap, i, &sEntry);
       }
     }
 
@@ -500,20 +490,18 @@ int msDrawRasterLayerGDAL(mapObj *map, l
     ** If we have a known NODATA value, mark it now as transparent.
     */
     {
-      int    bGotNoData;
-      double dfNoDataValue = msGetGDALNoDataValue( layer, hBand1,
-                             &bGotNoData);
+      int bGotNoData;
+      double dfNoDataValue = msGetGDALNoDataValue(layer, hBand1, &bGotNoData);
 
-      if( bGotNoData && dfNoDataValue >= 0
-          && dfNoDataValue < GDALGetColorEntryCount( hColorMap ) ) {
+      if (bGotNoData && dfNoDataValue >= 0 &&
+          dfNoDataValue < GDALGetColorEntryCount(hColorMap)) {
         GDALColorEntry sEntry;
 
-        memcpy( &sEntry,
-                GDALGetColorEntry( hColorMap, (int) dfNoDataValue ),
-                sizeof(GDALColorEntry) );
+        memcpy(&sEntry, GDALGetColorEntry(hColorMap, (int)dfNoDataValue),
+               sizeof(GDALColorEntry));
 
         sEntry.c4 = 0;
-        GDALSetColorEntry( hColorMap, (int) dfNoDataValue, &sEntry );
+        GDALSetColorEntry(hColorMap, (int)dfNoDataValue, &sEntry);
       }
     }
   }
@@ -521,20 +509,20 @@ int msDrawRasterLayerGDAL(mapObj *map, l
   /*
    * Allocate imagery buffers.
    */
-  pabyRaw1 = (unsigned char *) malloc(dst_xsize * dst_ysize * band_count);
-  if( pabyRaw1 == NULL ) {
+  pabyRaw1 = (unsigned char *)malloc(dst_xsize * dst_ysize * band_count);
+  if (pabyRaw1 == NULL) {
     msSetError(MS_MEMERR, "Allocating work image of size %dx%dx%d failed.",
-               "msDrawRasterLayerGDAL()", dst_xsize, dst_ysize, band_count );
+               "msDrawRasterLayerGDAL()", dst_xsize, dst_ysize, band_count);
     return -1;
   }
 
-  if( hBand2 != NULL && hBand3 != NULL ) {
+  if (hBand2 != NULL && hBand3 != NULL) {
     pabyRaw2 = pabyRaw1 + dst_xsize * dst_ysize * 1;
     pabyRaw3 = pabyRaw1 + dst_xsize * dst_ysize * 2;
   }
 
-  if( hBandAlpha != NULL ) {
-    if( hBand2 != NULL )
+  if (hBandAlpha != NULL) {
+    if (hBand2 != NULL)
       pabyRawAlpha = pabyRaw1 + dst_xsize * dst_ysize * 3;
     else
       pabyRawAlpha = pabyRaw1 + dst_xsize * dst_ysize * 1;
@@ -546,16 +534,13 @@ int msDrawRasterLayerGDAL(mapObj *map, l
   bool bScaled = false;
   double dfScaleMin = 0;
   double dfScaleRatio = 0;
-  bool* pbIsNoDataBuffer = NULL;
-  if( LoadGDALImages( hDS, band_numbers, band_count, layer,
-                      src_xoff, src_yoff, src_xsize, src_ysize,
-                      pabyRaw1, dst_xsize, dst_ysize,
-                      &bHaveRGBNoData,
-                      &nNoData1, &nNoData2, &nNoData3,
-                      &bScaled, &dfScaleMin, &dfScaleRatio,
-                      &pbIsNoDataBuffer ) == -1 ) {
-    free( pabyRaw1 );
-    free( pbIsNoDataBuffer );
+  bool *pbIsNoDataBuffer = NULL;
+  if (LoadGDALImages(hDS, band_numbers, band_count, layer, src_xoff, src_yoff,
+                     src_xsize, src_ysize, pabyRaw1, dst_xsize, dst_ysize,
+                     &bHaveRGBNoData, &nNoData1, &nNoData2, &nNoData3, &bScaled,
+                     &dfScaleMin, &dfScaleRatio, &pbIsNoDataBuffer) == -1) {
+    free(pabyRaw1);
+    free(pbIsNoDataBuffer);
     return -1;
   }
 
@@ -565,93 +550,105 @@ int msDrawRasterLayerGDAL(mapObj *map, l
    * class colors are provided by the MAP file, or where we use the native
    * color table.
    */
-  if( classified ) {
+  if (classified) {
     int c;
-    const char* pszRangeColorspace = msLayerGetProcessingKey( layer, "RANGE_COLORSPACE" );
+    const char *pszRangeColorspace =
+        msLayerGetProcessingKey(layer, "RANGE_COLORSPACE");
     colorspace iRangeColorspace;
 
 #ifndef NDEBUG
     cmap_set = TRUE;
 #endif
 
-    if( hColorMap == NULL ) {
+    if (hColorMap == NULL) {
       msSetError(MS_IOERR,
                  "Attempt to classify 24bit image, this is unsupported.",
                  "drawGDAL()");
-      free( pabyRaw1 );
-      free( pbIsNoDataBuffer );
+      free(pabyRaw1);
+      free(pbIsNoDataBuffer);
       return -1;
     }
-    
-    if(!pszRangeColorspace || !strcasecmp(pszRangeColorspace, "RGB")) {
+
+    if (!pszRangeColorspace || !strcasecmp(pszRangeColorspace, "RGB")) {
       iRangeColorspace = MS_COLORSPACE_RGB;
-    } else if(!strcasecmp(pszRangeColorspace, "HSL")) {
+    } else if (!strcasecmp(pszRangeColorspace, "HSL")) {
       iRangeColorspace = MS_COLORSPACE_HSL;
     } else {
       msSetError(MS_MISCERR,
                  "Unknown RANGE_COLORSPACE \"%s\", expecting RGB or HSL",
                  "drawGDAL()", pszRangeColorspace);
-      GDALDestroyColorTable( hColorMap );
-      free( pabyRaw1 );
-      free( pbIsNoDataBuffer );
+      GDALDestroyColorTable(hColorMap);
+      free(pabyRaw1);
+      free(pbIsNoDataBuffer);
       return -1;
     }
 
     int color_count = GDALGetColorEntryCount(hColorMap);
     const bool bScaleColors = bScaled && !isDefaultGreyscale;
 
-    if( !bScaleColors && color_count > 256 )
+    if (!bScaleColors && color_count > 256)
       color_count = 256;
 
-    for(i=0; i < color_count; i++) {
+    for (i = 0; i < color_count; i++) {
       colorObj pixel;
       int colormap_index;
       GDALColorEntry sEntry;
 
-      GDALGetColorEntryAsRGB( hColorMap, i, &sEntry );
+      GDALGetColorEntryAsRGB(hColorMap, i, &sEntry);
 
-      const int j = bScaleColors ? MAX(0, MIN(255, (int) ((i-dfScaleMin)*dfScaleRatio))) : i;
+      const int j =
+          bScaleColors
+              ? MAX(0, MIN(255, (int)((i - dfScaleMin) * dfScaleRatio)))
+              : i;
 
       pixel.red = sEntry.c1;
       pixel.green = sEntry.c2;
       pixel.blue = sEntry.c3;
       colormap_index = i;
 
-      if(!MS_COMPARE_COLORS(pixel, layer->offsite)) {
+      if (!MS_COMPARE_COLORS(pixel, layer->offsite)) {
         c = msGetClass(layer, &pixel, colormap_index);
 
-        if(c != -1) { /* belongs to any class */
+        if (c != -1) { /* belongs to any class */
           int s;
 
           /* change colour based on colour range?  Currently we
              only address the greyscale case properly. */
 
-          if( MS_VALID_COLOR(layer->class[c]->styles[0]->mincolor) ) {
-            for(s=0; s<layer->class[c]->numstyles; s++) {
-              if( MS_VALID_COLOR(layer->class[c]->styles[s]->mincolor)
-                 && MS_VALID_COLOR(layer->class[c]->styles[s]->maxcolor)) {
-                if( sEntry.c1 >= layer->class[c]->styles[s]->minvalue
-                     && sEntry.c1 <= layer->class[c]->styles[s]->maxvalue ) {
-                  msValueToRange(layer->class[c]->styles[s], sEntry.c1, iRangeColorspace);
-                  if(MS_VALID_COLOR(layer->class[c]->styles[s]->color)) {
+          if (MS_VALID_COLOR(layer->class[c] -> styles[0] -> mincolor)) {
+            for (s = 0; s < layer->class[c] -> numstyles; s++) {
+              if (MS_VALID_COLOR(layer->class[c] -> styles[s] -> mincolor) &&
+                  MS_VALID_COLOR(layer->class[c] -> styles[s] -> maxcolor)) {
+                if (sEntry.c1 >= layer->class[c] -> styles[s]
+                    -> minvalue &&
+                           sEntry.c1 <=
+                               layer->class[c] -> styles[s] -> maxvalue) {
+                  msValueToRange(layer->class[c] -> styles[s], sEntry.c1,
+                                 iRangeColorspace);
+                  if (MS_VALID_COLOR(layer->class[c] -> styles[s] -> color)) {
                     rb_cmap[0][j] = layer->class[c]->styles[s]->color.red;
                     rb_cmap[1][j] = layer->class[c]->styles[s]->color.green;
                     rb_cmap[2][j] = layer->class[c]->styles[s]->color.blue;
-                    rb_cmap[3][j] = (layer->class[c]->styles[s]->color.alpha != 255)?(layer->class[c]->styles[s]->color.alpha):(255*layer->class[c]->styles[0]->opacity / 100);
+                    rb_cmap[3][j] =
+                        (layer->class[c] -> styles[s] -> color.alpha != 255)
+                            ? (layer->class[c] -> styles[s] -> color.alpha)
+                            : (255 * layer->class[c] -> styles[0] -> opacity /
+                                                                         100);
                     break;
                   }
                 }
               }
             }
-          }
-          else if( MS_TRANSPARENT_COLOR(layer->class[c]->styles[0]->color))
+          } else if (MS_TRANSPARENT_COLOR(
+                         layer->class[c] -> styles[0] -> color))
             /* leave it transparent */;
 
-          else if( MS_VALID_COLOR(layer->class[c]->styles[0]->color)) {
+          else if (MS_VALID_COLOR(layer->class[c] -> styles[0] -> color)) {
             rb_cmap[0][j] = layer->class[c]->styles[0]->color.red;
             rb_cmap[1][j] = layer->class[c]->styles[0]->color.green;
             rb_cmap[2][j] = layer->class[c]->styles[0]->color.blue;
-            rb_cmap[3][j] = (255*layer->class[c]->styles[0]->opacity / 100);
+            rb_cmap[3][j] =
+                (255 * layer->class[c] -> styles[0] -> opacity / 100);
           }
 
           else { /* Use raster color */
@@ -663,29 +660,32 @@ int msDrawRasterLayerGDAL(mapObj *map, l
         }
       }
     }
-  } else if( hBand2 == NULL && hColorMap != NULL && rb->type == MS_BUFFER_BYTE_RGBA ) {
+  } else if (hBand2 == NULL && hColorMap != NULL &&
+             rb->type == MS_BUFFER_BYTE_RGBA) {
     int color_count;
 #ifndef NDEBUG
     cmap_set = TRUE;
 #endif
 
-    color_count = MS_MIN(256,GDALGetColorEntryCount(hColorMap));
+    color_count = MS_MIN(256, GDALGetColorEntryCount(hColorMap));
     const bool bScaleColors = bScaled && !isDefaultGreyscale;
 
-    if( !bScaleColors && color_count > 256 )
+    if (!bScaleColors && color_count > 256)
       color_count = 256;
 
-    for(i=0; i < color_count; i++) {
+    for (i = 0; i < color_count; i++) {
       GDALColorEntry sEntry;
 
-      GDALGetColorEntryAsRGB( hColorMap, i, &sEntry );
-      const int j = bScaleColors ? MAX(0, MIN(255, (int) ((i-dfScaleMin)*dfScaleRatio))) : i;
-
-      if( sEntry.c4 != 0
-          && (!MS_VALID_COLOR( layer->offsite )
-              || layer->offsite.red != sEntry.c1
-              || layer->offsite.green != sEntry.c2
-              || layer->offsite.blue != sEntry.c3 ) ) {
+      GDALGetColorEntryAsRGB(hColorMap, i, &sEntry);
+      const int j =
+          bScaleColors
+              ? MAX(0, MIN(255, (int)((i - dfScaleMin) * dfScaleRatio)))
+              : i;
+
+      if (sEntry.c4 != 0 &&
+          (!MS_VALID_COLOR(layer->offsite) || layer->offsite.red != sEntry.c1 ||
+           layer->offsite.green != sEntry.c2 ||
+           layer->offsite.blue != sEntry.c3)) {
         rb_cmap[0][j] = sEntry.c1;
         rb_cmap[1][j] = sEntry.c2;
         rb_cmap[2][j] = sEntry.c3;
@@ -694,45 +694,43 @@ int msDrawRasterLayerGDAL(mapObj *map, l
     }
   }
 
-  if( bHaveRGBNoData && layer->debug )
-    msDebug( "msDrawGDAL(): using RGB nodata values from GDAL dataset.\n" );
+  if (bHaveRGBNoData && layer->debug)
+    msDebug("msDrawGDAL(): using RGB nodata values from GDAL dataset.\n");
 
   /* -------------------------------------------------------------------- */
   /*      If there was no alpha band, but we have a dataset level mask    */
   /*      load it as massage it so it will function as our alpha for      */
   /*      transparency purposes.                                          */
   /* -------------------------------------------------------------------- */
-  if( hBandAlpha == NULL ) {
+  if (hBandAlpha == NULL) {
     int nMaskFlags = GDALGetMaskFlags(hBand1);
 
-    if( CSLTestBoolean(CSLFetchNameValueDef( layer->processing, "USE_MASK_BAND", "YES" )) &&
+    if (CSLTestBoolean(
+            CSLFetchNameValueDef(layer->processing, "USE_MASK_BAND", "YES")) &&
         (nMaskFlags & GMF_PER_DATASET) != 0 &&
-        (nMaskFlags & (GMF_NODATA|GMF_ALL_VALID)) == 0 ) {
+        (nMaskFlags & (GMF_NODATA | GMF_ALL_VALID)) == 0) {
       CPLErr eErr;
-      unsigned char * pabyOrig = pabyRaw1;
+      unsigned char *pabyOrig = pabyRaw1;
 
-
-      if( layer->debug )
-        msDebug( "msDrawGDAL(): using GDAL mask band for alpha.\n" );
+      if (layer->debug)
+        msDebug("msDrawGDAL(): using GDAL mask band for alpha.\n");
 
       band_count++;
 
-      pabyRaw1 = (unsigned char *)
-                 realloc(pabyOrig,dst_xsize * dst_ysize * band_count);
+      pabyRaw1 = (unsigned char *)realloc(pabyOrig,
+                                          dst_xsize * dst_ysize * band_count);
 
-      if( pabyRaw1 == NULL ) {
-        msSetError(MS_MEMERR,
-                   "Allocating work image of size %dx%dx%d failed.",
-                   "msDrawRasterLayerGDAL()",
-                   dst_xsize, dst_ysize, band_count );
+      if (pabyRaw1 == NULL) {
+        msSetError(MS_MEMERR, "Allocating work image of size %dx%dx%d failed.",
+                   "msDrawRasterLayerGDAL()", dst_xsize, dst_ysize, band_count);
         free(pabyOrig);
-        if( hColorMap != NULL )     
-          GDALDestroyColorTable( hColorMap );
-        free( pbIsNoDataBuffer );
+        if (hColorMap != NULL)
+          GDALDestroyColorTable(hColorMap);
+        free(pbIsNoDataBuffer);
         return -1;
       }
 
-      if( hBand2 != NULL ) {
+      if (hBand2 != NULL) {
         pabyRaw2 = pabyRaw1 + dst_xsize * dst_ysize * 1;
         pabyRaw3 = pabyRaw1 + dst_xsize * dst_ysize * 2;
         pabyRawAlpha = pabyRaw1 + dst_xsize * dst_ysize * 3;
@@ -742,147 +740,125 @@ int msDrawRasterLayerGDAL(mapObj *map, l
 
       hBandAlpha = GDALGetMaskBand(hBand1);
 
-      eErr = GDALRasterIO( hBandAlpha, GF_Read,
-                           src_xoff, src_yoff, src_xsize, src_ysize,
-                           pabyRawAlpha, dst_xsize, dst_ysize, GDT_Byte, 0,0);
-
-      if( eErr != CE_None ) {
-        msSetError( MS_IOERR, "GDALRasterIO() failed: %s",
-                    "drawGDAL()", CPLGetLastErrorMsg() );
-        if( hColorMap != NULL )     
-          GDALDestroyColorTable( hColorMap );
-        free( pabyRaw1 );
-        free( pbIsNoDataBuffer );
+      eErr = GDALRasterIO(hBandAlpha, GF_Read, src_xoff, src_yoff, src_xsize,
+                          src_ysize, pabyRawAlpha, dst_xsize, dst_ysize,
+                          GDT_Byte, 0, 0);
+
+      if (eErr != CE_None) {
+        msSetError(MS_IOERR, "GDALRasterIO() failed: %s", "drawGDAL()",
+                   CPLGetLastErrorMsg());
+        if (hColorMap != NULL)
+          GDALDestroyColorTable(hColorMap);
+        free(pabyRaw1);
+        free(pbIsNoDataBuffer);
         return -1;
       }
 
       /* In case the mask is not an alpha channel, expand values of 1 to 255, */
       /* so we can deal as it was an alpha band afterwards */
       if ((nMaskFlags & GMF_ALPHA) == 0) {
-        for(i=0; i<dst_xsize * dst_ysize; i++)
+        for (i = 0; i < dst_xsize * dst_ysize; i++)
           if (pabyRawAlpha[i])
             pabyRawAlpha[i] = 255;
       }
     }
   }
 
-    /* -------------------------------------------------------------------- */
-    /*      Single band plus colormap and alpha to truecolor. (RB)          */
-    /* -------------------------------------------------------------------- */
-    if( hBand2 == NULL && rb->type == MS_BUFFER_BYTE_RGBA && hBandAlpha != NULL ) {
-      assert( cmap_set );
+  /* -------------------------------------------------------------------- */
+  /*      Single band plus colormap and alpha to truecolor. (RB)          */
+  /* -------------------------------------------------------------------- */
+  if (hBand2 == NULL && rb->type == MS_BUFFER_BYTE_RGBA && hBandAlpha != NULL) {
+    assert(cmap_set);
 
-      int k = 0;
-      for( i = dst_yoff; i < dst_yoff + dst_ysize; i++ ) {
-        for( int j = dst_xoff; j < dst_xoff + dst_xsize; j++, k++ ) {
-          int src_pixel, src_alpha, cmap_alpha, merged_alpha;
-          if(SKIP_MASK(j,i) || (pbIsNoDataBuffer && pbIsNoDataBuffer[k]))
-            continue;
+    int k = 0;
+    for (i = dst_yoff; i < dst_yoff + dst_ysize; i++) {
+      for (int j = dst_xoff; j < dst_xoff + dst_xsize; j++, k++) {
+        int src_pixel, src_alpha, cmap_alpha, merged_alpha;
+        if (SKIP_MASK(j, i) || (pbIsNoDataBuffer && pbIsNoDataBuffer[k]))
+          continue;
 
-          src_pixel = pabyRaw1[k];
-          src_alpha = pabyRawAlpha[k];
-          cmap_alpha = rb_cmap[3][src_pixel];
-
-          merged_alpha = (src_alpha * cmap_alpha) / 255;
-
-          if( merged_alpha < 2 )
-            /* do nothing - transparent */;
-          else if( merged_alpha > 253 ) {
-            RB_SET_PIXEL( rb, j, i,
-                          rb_cmap[0][src_pixel],
-                          rb_cmap[1][src_pixel],
-                          rb_cmap[2][src_pixel],
-                          cmap_alpha );
-          } else {
-            RB_MIX_PIXEL( rb, j, i,
-                          rb_cmap[0][src_pixel],
-                          rb_cmap[1][src_pixel],
-                          rb_cmap[2][src_pixel],
-                          merged_alpha );
-          }
+        src_pixel = pabyRaw1[k];
+        src_alpha = pabyRawAlpha[k];
+        cmap_alpha = rb_cmap[3][src_pixel];
+
+        merged_alpha = (src_alpha * cmap_alpha) / 255;
+
+        if (merged_alpha < 2)
+          /* do nothing - transparent */;
+        else if (merged_alpha > 253) {
+          RB_SET_PIXEL(rb, j, i, rb_cmap[0][src_pixel], rb_cmap[1][src_pixel],
+                       rb_cmap[2][src_pixel], cmap_alpha);
+        } else {
+          RB_MIX_PIXEL(rb, j, i, rb_cmap[0][src_pixel], rb_cmap[1][src_pixel],
+                       rb_cmap[2][src_pixel], merged_alpha);
         }
       }
     }
+  }
 
   /* -------------------------------------------------------------------- */
   /*      Single band plus colormap (no alpha) to truecolor (RB)          */
   /* -------------------------------------------------------------------- */
-    else if( hBand2 == NULL && rb->type == MS_BUFFER_BYTE_RGBA ) {
-      assert( cmap_set );
+  else if (hBand2 == NULL && rb->type == MS_BUFFER_BYTE_RGBA) {
+    assert(cmap_set);
 
-      int k = 0;
-      for( i = dst_yoff; i < dst_yoff + dst_ysize; i++ ) {
-        for( int j = dst_xoff; j < dst_xoff + dst_xsize; j++, k++ ) {
-          int src_pixel = pabyRaw1[k];
-          if(SKIP_MASK(j,i) || (pbIsNoDataBuffer && pbIsNoDataBuffer[k]))
-            continue;
+    int k = 0;
+    for (i = dst_yoff; i < dst_yoff + dst_ysize; i++) {
+      for (int j = dst_xoff; j < dst_xoff + dst_xsize; j++, k++) {
+        int src_pixel = pabyRaw1[k];
+        if (SKIP_MASK(j, i) || (pbIsNoDataBuffer && pbIsNoDataBuffer[k]))
+          continue;
 
-          if( rb_cmap[3][src_pixel] > 253 ) {
-            RB_SET_PIXEL( rb, j, i,
-                          rb_cmap[0][src_pixel],
-                          rb_cmap[1][src_pixel],
-                          rb_cmap[2][src_pixel],
-                          rb_cmap[3][src_pixel] );
-          } else if( rb_cmap[3][src_pixel] > 1 ) {
-            RB_MIX_PIXEL( rb, j, i,
-                          rb_cmap[0][src_pixel],
-                          rb_cmap[1][src_pixel],
-                          rb_cmap[2][src_pixel],
-                          rb_cmap[3][src_pixel] );
-          }
+        if (rb_cmap[3][src_pixel] > 253) {
+          RB_SET_PIXEL(rb, j, i, rb_cmap[0][src_pixel], rb_cmap[1][src_pixel],
+                       rb_cmap[2][src_pixel], rb_cmap[3][src_pixel]);
+        } else if (rb_cmap[3][src_pixel] > 1) {
+          RB_MIX_PIXEL(rb, j, i, rb_cmap[0][src_pixel], rb_cmap[1][src_pixel],
+                       rb_cmap[2][src_pixel], rb_cmap[3][src_pixel]);
         }
       }
     }
+  }
 
   /* -------------------------------------------------------------------- */
   /*      Input is 3 band RGB.  Alpha blending is mixed into the loop     */
   /*      since this case is less commonly used and has lots of other     */
   /*      overhead. (RB)                                                  */
   /* -------------------------------------------------------------------- */
-    else if( hBand3 != NULL && rb->type == MS_BUFFER_BYTE_RGBA ) {
-      int k = 0;
-      for( i = dst_yoff; i < dst_yoff + dst_ysize; i++ ) {
-        for( int j = dst_xoff; j < dst_xoff + dst_xsize; j++, k++ ) {
-          if(SKIP_MASK(j,i) || (pbIsNoDataBuffer && pbIsNoDataBuffer[k]))
-            continue;
-          if( MS_VALID_COLOR( layer->offsite )
-              && pabyRaw1[k] == layer->offsite.red
-              && pabyRaw2[k] == layer->offsite.green
-              && pabyRaw3[k] == layer->offsite.blue )
-            continue;
+  else if (hBand3 != NULL && rb->type == MS_BUFFER_BYTE_RGBA) {
+    int k = 0;
+    for (i = dst_yoff; i < dst_yoff + dst_ysize; i++) {
+      for (int j = dst_xoff; j < dst_xoff + dst_xsize; j++, k++) {
+        if (SKIP_MASK(j, i) || (pbIsNoDataBuffer && pbIsNoDataBuffer[k]))
+          continue;
+        if (MS_VALID_COLOR(layer->offsite) &&
+            pabyRaw1[k] == layer->offsite.red &&
+            pabyRaw2[k] == layer->offsite.green &&
+            pabyRaw3[k] == layer->offsite.blue)
+          continue;
 
-          if( bHaveRGBNoData
-              && pabyRaw1[k] == nNoData1
-              && pabyRaw2[k] == nNoData2
-              && pabyRaw3[k] == nNoData3 )
-            continue;
+        if (bHaveRGBNoData && pabyRaw1[k] == nNoData1 &&
+            pabyRaw2[k] == nNoData2 && pabyRaw3[k] == nNoData3)
+          continue;
 
-          if( pabyRawAlpha == NULL || pabyRawAlpha[k] == 255 ) {
-            RB_SET_PIXEL( rb, j, i,
-                          pabyRaw1[k],
-                          pabyRaw2[k],
-                          pabyRaw3[k],
-                          255 );
-          } else if( pabyRawAlpha[k] != 0 ) {
-            RB_MIX_PIXEL( rb, j, i,
-                          pabyRaw1[k],
-                          pabyRaw2[k],
-                          pabyRaw3[k],
-                          pabyRawAlpha[k] );
-          }
+        if (pabyRawAlpha == NULL || pabyRawAlpha[k] == 255) {
+          RB_SET_PIXEL(rb, j, i, pabyRaw1[k], pabyRaw2[k], pabyRaw3[k], 255);
+        } else if (pabyRawAlpha[k] != 0) {
+          RB_MIX_PIXEL(rb, j, i, pabyRaw1[k], pabyRaw2[k], pabyRaw3[k],
+                       pabyRawAlpha[k]);
         }
       }
     }
-
+  }
 
   /*
   ** Cleanup
   */
-  free( pabyRaw1 );
-  free( pbIsNoDataBuffer );
+  free(pabyRaw1);
+  free(pbIsNoDataBuffer);
 
-  if( hColorMap != NULL )
-    GDALDestroyColorTable( hColorMap );
+  if (hColorMap != NULL)
+    GDALDestroyColorTable(hColorMap);
 
   return 0;
 }
@@ -891,27 +867,27 @@ int msDrawRasterLayerGDAL(mapObj *map, l
 /*                          ParseDefaultLUT()                           */
 /************************************************************************/
 
-static int ParseDefaultLUT( const char *lut_def, GByte *lut, int nMaxValIn )
+static int ParseDefaultLUT(const char *lut_def, GByte *lut, int nMaxValIn)
 
 {
   const char *lut_read;
-  int last_in=0, last_out=0, all_done=FALSE;
+  int last_in = 0, last_out = 0, all_done = FALSE;
 
   /* -------------------------------------------------------------------- */
   /*      Parse definition, applying to lut on the fly.                   */
   /* -------------------------------------------------------------------- */
   lut_read = lut_def;
-  while( !all_done ) {
-    int this_in=0, this_out=0;
+  while (!all_done) {
+    int this_in = 0, this_out = 0;
     int lut_i;
 
-    while( isspace(*lut_read) )
+    while (isspace(*lut_read))
       lut_read++;
 
     /* if we are at end, assume nMaxValIn:255 */
-    if( *lut_read == '\0' ) {
+    if (*lut_read == '\0') {
       all_done = TRUE;
-      if ( last_in != nMaxValIn ) {
+      if (last_in != nMaxValIn) {
         this_in = nMaxValIn;
         this_out = 255;
       }
@@ -920,35 +896,35 @@ static int ParseDefaultLUT( const char *
     /* otherwise read "in:out", and skip past */
     else {
       this_in = atoi(lut_read);
-      while( *lut_read != ':' && *lut_read )
+      while (*lut_read != ':' && *lut_read)
         lut_read++;
-      if( *lut_read == ':' )
+      if (*lut_read == ':')
         lut_read++;
-      while( isspace(*lut_read) )
+      while (isspace(*lut_read))
         lut_read++;
       this_out = atoi(lut_read);
-      while( *lut_read && *lut_read != ',' && *lut_read != '\n' )
+      while (*lut_read && *lut_read != ',' && *lut_read != '\n')
         lut_read++;
-      if( *lut_read == ',' || *lut_read == '\n' )
+      if (*lut_read == ',' || *lut_read == '\n')
         lut_read++;
-      while( isspace(*lut_read) )
+      while (isspace(*lut_read))
         lut_read++;
     }
 
-    this_in = MS_MAX(0,MS_MIN(nMaxValIn,this_in));
-    this_out = MS_MAX(0,MS_MIN(255,this_out));
+    this_in = MS_MAX(0, MS_MIN(nMaxValIn, this_in));
+    this_out = MS_MAX(0, MS_MIN(255, this_out));
 
     /* apply linear values from last in:out to this in:out */
-    for( lut_i = last_in; lut_i <= this_in; lut_i++ ) {
+    for (lut_i = last_in; lut_i <= this_in; lut_i++) {
       double ratio;
 
-      if( last_in == this_in )
+      if (last_in == this_in)
         ratio = 1.0;
       else
-        ratio = (lut_i - last_in) / (double) (this_in - last_in);
+        ratio = (lut_i - last_in) / (double)(this_in - last_in);
 
-      lut[lut_i] = (int)
-                   floor(((1.0 - ratio)*last_out + ratio*this_out) + 0.5);
+      lut[lut_i] =
+          (int)floor(((1.0 - ratio) * last_out + ratio * this_out) + 0.5);
     }
 
     last_in = this_in;
@@ -962,46 +938,46 @@ static int ParseDefaultLUT( const char *
 /*                          LutFromGimpLine()                           */
 /************************************************************************/
 
-static int LutFromGimpLine( char *lut_line, GByte *lut )
+static int LutFromGimpLine(char *lut_line, GByte *lut)
 
 {
   char wrkLUTDef[1000];
-  int  i, count = 0;
+  int i, count = 0;
   char **tokens;
 
   /* cleanup white space at end of line (DOS LF, etc) */
   i = strlen(lut_line) - 1;
-  while( i > 0 && isspace(lut_line[i]) )
+  while (i > 0 && isspace(lut_line[i]))
     lut_line[i--] = '\0';
 
-  while( *lut_line == 10 || *lut_line == 13 )
+  while (*lut_line == 10 || *lut_line == 13)
     lut_line++;
 
   /* tokenize line */
-  tokens = CSLTokenizeString( lut_line );
-  if( CSLCount(tokens) != 17 * 2 ) {
-    CSLDestroy( tokens );
-    msSetError(MS_MISCERR,
-               "GIMP curve file appears corrupt.",
-               "LutFromGimpLine()" );
+  tokens = CSLTokenizeString(lut_line);
+  if (CSLCount(tokens) != 17 * 2) {
+    CSLDestroy(tokens);
+    msSetError(MS_MISCERR, "GIMP curve file appears corrupt.",
+               "LutFromGimpLine()");
     return -1;
   }
 
   /* Convert to our own format */
   wrkLUTDef[0] = '\0';
-  for( i = 0; i < 17; i++ ) {
-    if( atoi(tokens[i*2]) >= 0 ) {
-      if( count++ > 0 )
-        strlcat( wrkLUTDef, ",", sizeof(wrkLUTDef));
+  for (i = 0; i < 17; i++) {
+    if (atoi(tokens[i * 2]) >= 0) {
+      if (count++ > 0)
+        strlcat(wrkLUTDef, ",", sizeof(wrkLUTDef));
 
-      snprintf( wrkLUTDef + strlen(wrkLUTDef), sizeof(wrkLUTDef)-strlen(wrkLUTDef),
-                "%s:%s", tokens[i*2], tokens[i*2+1] );
+      snprintf(wrkLUTDef + strlen(wrkLUTDef),
+               sizeof(wrkLUTDef) - strlen(wrkLUTDef), "%s:%s", tokens[i * 2],
+               tokens[i * 2 + 1]);
     }
   }
 
-  CSLDestroy( tokens );
+  CSLDestroy(tokens);
 
-  return ParseDefaultLUT( wrkLUTDef, lut, 255 );
+  return ParseDefaultLUT(wrkLUTDef, lut, 255);
 }
 
 /************************************************************************/
@@ -1010,33 +986,30 @@ static int LutFromGimpLine( char *lut_li
 /*      Parse a Gimp style LUT.                                         */
 /************************************************************************/
 
-static int ParseGimpLUT( const char *lut_def, GByte *lut, int iColorIndex )
+static int ParseGimpLUT(const char *lut_def, GByte *lut, int iColorIndex)
 
 {
   int i;
   GByte lutValue[256];
   GByte lutColorBand[256];
-  char **lines =
-    CSLTokenizeStringComplex( lut_def, "\n", FALSE, FALSE );
+  char **lines = CSLTokenizeStringComplex(lut_def, "\n", FALSE, FALSE);
 
-  if( !EQUALN(lines[0],"# GIMP Curves File",18)
-      || CSLCount(lines) < 6 ) {
-    msSetError(MS_MISCERR,
-               "GIMP curve file appears corrupt.",
-               "ParseGimpLUT()" );
-    CSLDestroy( lines );
+  if (!EQUALN(lines[0], "# GIMP Curves File", 18) || CSLCount(lines) < 6) {
+    msSetError(MS_MISCERR, "GIMP curve file appears corrupt.",
+               "ParseGimpLUT()");
+    CSLDestroy(lines);
     return -1;
   }
 
   /*
    * Convert the overall curve, and the color band specific curve into LUTs.
    */
-  if( LutFromGimpLine( lines[1], lutValue ) != 0
-      || LutFromGimpLine( lines[iColorIndex + 1], lutColorBand ) != 0 ) {
-    CSLDestroy( lines );
+  if (LutFromGimpLine(lines[1], lutValue) != 0 ||
+      LutFromGimpLine(lines[iColorIndex + 1], lutColorBand) != 0) {
+    CSLDestroy(lines);
     return -1;
   }
-  CSLDestroy( lines );
+  CSLDestroy(lines);
 
   /*
    * Compose the two luts as if the raw value passed through the color band
@@ -1044,7 +1017,7 @@ static int ParseGimpLUT( const char *lut
    * other will be the identity mapping, but not always.
    */
 
-  for( i = 0; i < 256; i++ ) {
+  for (i = 0; i < 256; i++) {
     lut[i] = lutValue[lutColorBand[i]];
   }
 
@@ -1057,7 +1030,7 @@ static int ParseGimpLUT( const char *lut
 /*      Load a LUT according to RFC 21.                                 */
 /************************************************************************/
 
-static int LoadLUT( layerObj *layer, int iColorIndex, char** ppszLutDef )
+static int LoadLUT(layerObj *layer, int iColorIndex, char **ppszLutDef)
 
 {
   const char *lut_def;
@@ -1069,37 +1042,35 @@ static int LoadLUT( layerObj *layer, int
   /*      Get lut specifier from processing directives.  Do nothing if    */
   /*      none are found.                                                 */
   /* -------------------------------------------------------------------- */
-  sprintf( key, "LUT_%d", iColorIndex );
-  lut_def = msLayerGetProcessingKey( layer, key );
-  if( lut_def == NULL )
-    lut_def = msLayerGetProcessingKey( layer, "LUT" );
-  if( lut_def == NULL )
+  sprintf(key, "LUT_%d", iColorIndex);
+  lut_def = msLayerGetProcessingKey(layer, key);
+  if (lut_def == NULL)
+    lut_def = msLayerGetProcessingKey(layer, "LUT");
+  if (lut_def == NULL)
     return 0;
 
   /* -------------------------------------------------------------------- */
   /*      Does this look like a file?  If so, read it into memory.        */
   /* -------------------------------------------------------------------- */
-  if( strspn(lut_def,"0123456789:, ") != strlen(lut_def) ) {
+  if (strspn(lut_def, "0123456789:, ") != strlen(lut_def)) {
     FILE *fp;
     char path[MS_MAXPATHLEN];
     int len;
     msBuildPath(path, layer->map->mappath, lut_def);
-    fp = fopen( path, "rb" );
-    if( fp == NULL ) {
-      msSetError(MS_IOERR,
-                 "Failed to open LUT file '%s'.",
-                 "drawGDAL()", path );
+    fp = fopen(path, "rb");
+    if (fp == NULL) {
+      msSetError(MS_IOERR, "Failed to open LUT file '%s'.", "drawGDAL()", path);
       return -1;
     }
 
-    len = fread( lut_def_fromfile, 1, sizeof(lut_def_fromfile), fp );
-    fclose( fp );
+    len = fread(lut_def_fromfile, 1, sizeof(lut_def_fromfile), fp);
+    fclose(fp);
 
-    if( len == sizeof(lut_def_fromfile) ) {
+    if (len == sizeof(lut_def_fromfile)) {
       msSetError(MS_IOERR,
-                 "LUT definition from file %s longer than maximum buffer size (%d bytes).",
-                 "drawGDAL()",
-                 path, (int)sizeof(lut_def_fromfile) );
+                 "LUT definition from file %s longer than maximum buffer size "
+                 "(%d bytes).",
+                 "drawGDAL()", path, (int)sizeof(lut_def_fromfile));
       return -1;
     }
 
@@ -1111,19 +1082,17 @@ static int LoadLUT( layerObj *layer, int
   *ppszLutDef = msStrdup(lut_def);
 
   return 0;
-
 }
 
 /************************************************************************/
 /*                              FreeLUTs()                              */
 /************************************************************************/
 
-static void FreeLUTs(char** apszLUTs)
-{
-    int i;
-    for( i = 0; i < 4; i++ )
-        msFree(apszLUTs[i]);
-    msFree(apszLUTs);
+static void FreeLUTs(char **apszLUTs) {
+  int i;
+  for (i = 0; i < 4; i++)
+    msFree(apszLUTs[i]);
+  msFree(apszLUTs);
 }
 
 /************************************************************************/
@@ -1133,24 +1102,21 @@ static void FreeLUTs(char** apszLUTs)
 /* or NULL in case of failure.                                          */
 /************************************************************************/
 
-static char** LoadLUTs(layerObj *layer, int band_count)
-{
-    int i;
-    char** apszLUTs;
-    
-    assert(band_count <= 4);
+static char **LoadLUTs(layerObj *layer, int band_count) {
+  int i;
+  char **apszLUTs;
 
-    apszLUTs = (char**) msSmallCalloc( 4, sizeof(char*) );
-    for( i = 0; i < band_count; i++ )
-    {
-        if( LoadLUT( layer, i+1, &apszLUTs[i] ) != 0 )
-        {
-            FreeLUTs(apszLUTs);
-            return NULL;
-        }
+  assert(band_count <= 4);
+
+  apszLUTs = (char **)msSmallCalloc(4, sizeof(char *));
+  for (i = 0; i < band_count; i++) {
+    if (LoadLUT(layer, i + 1, &apszLUTs[i]) != 0) {
+      FreeLUTs(apszLUTs);
+      return NULL;
     }
+  }
 
-    return apszLUTs;
+  return apszLUTs;
 }
 
 /************************************************************************/
@@ -1161,105 +1127,88 @@ static char** LoadLUTs(layerObj *layer,
 /*      must be queries on 16-bits.                                     */
 /************************************************************************/
 
-static GDALDataType GetDataTypeAppropriateForLUTS(char** apszLUTs)
-{
-    GDALDataType eDT = GDT_Byte;
-    int i;
-    for( i = 0; i < 4; i++ )
-    {
-        const char* pszLastTuple;
-        int nLastInValue;
-        if( apszLUTs[i] == NULL )
-            continue;
-        if( EQUALN(apszLUTs[i],"# GIMP",6) )
-            continue;
-        /* Find last in:out tuple in string */
-        pszLastTuple = strrchr( apszLUTs[i], ',' );
-        if( pszLastTuple == NULL )
-            pszLastTuple = apszLUTs[i];
-        else
-            pszLastTuple ++;
-        while( *pszLastTuple == ' ' )
-            pszLastTuple ++;
-        nLastInValue = atoi(pszLastTuple);
-        if( nLastInValue > 255 )
-        {
-            eDT = GDT_UInt16;
-            break;
-        }
+static GDALDataType GetDataTypeAppropriateForLUTS(char **apszLUTs) {
+  GDALDataType eDT = GDT_Byte;
+  int i;
+  for (i = 0; i < 4; i++) {
+    const char *pszLastTuple;
+    int nLastInValue;
+    if (apszLUTs[i] == NULL)
+      continue;
+    if (EQUALN(apszLUTs[i], "# GIMP", 6))
+      continue;
+    /* Find last in:out tuple in string */
+    pszLastTuple = strrchr(apszLUTs[i], ',');
+    if (pszLastTuple == NULL)
+      pszLastTuple = apszLUTs[i];
+    else
+      pszLastTuple++;
+    while (*pszLastTuple == ' ')
+      pszLastTuple++;
+    nLastInValue = atoi(pszLastTuple);
+    if (nLastInValue > 255) {
+      eDT = GDT_UInt16;
+      break;
     }
-    return eDT;
+  }
+  return eDT;
 }
 
 /************************************************************************/
 /*                              ApplyLUT()                              */
 /************************************************************************/
 
-static int ApplyLUT( int iColorIndex, const char* lut_def,
-                     const void* pInBuffer, GDALDataType eDT,
-                     GByte* pabyOutBuffer,
-                     int nPixelCount )
-{
+static int ApplyLUT(int iColorIndex, const char *lut_def, const void *pInBuffer,
+                    GDALDataType eDT, GByte *pabyOutBuffer, int nPixelCount) {
   int i, err;
   GByte byteLut[256];
-  GByte* uint16Lut = NULL;
+  GByte *uint16Lut = NULL;
 
-  assert( eDT == GDT_Byte || eDT == GDT_UInt16 );
-  
-  if( lut_def == NULL )
-  {
-      if( pInBuffer != pabyOutBuffer )
-      {
-        GDALCopyWords( (void*)pInBuffer, eDT, GDALGetDataTypeSize(eDT) / 8,
-                        pabyOutBuffer, GDT_Byte, 1,
-                        nPixelCount );
-      }
-      return 0;
+  assert(eDT == GDT_Byte || eDT == GDT_UInt16);
+
+  if (lut_def == NULL) {
+    if (pInBuffer != pabyOutBuffer) {
+      GDALCopyWords((void *)pInBuffer, eDT, GDALGetDataTypeSize(eDT) / 8,
+                    pabyOutBuffer, GDT_Byte, 1, nPixelCount);
+    }
+    return 0;
   }
 
   /* -------------------------------------------------------------------- */
   /*      Parse the LUT description.                                      */
   /* -------------------------------------------------------------------- */
-  if( EQUALN(lut_def,"# GIMP",6) ) {
-    if( eDT != GDT_Byte ) {
-      msSetError(MS_MISCERR,
-                 "Cannot apply a GIMP LUT on a 16-bit buffer",
+  if (EQUALN(lut_def, "# GIMP", 6)) {
+    if (eDT != GDT_Byte) {
+      msSetError(MS_MISCERR, "Cannot apply a GIMP LUT on a 16-bit buffer",
                  "ApplyLUT()");
       return -1;
     }
-    err = ParseGimpLUT( lut_def, byteLut, iColorIndex );
+    err = ParseGimpLUT(lut_def, byteLut, iColorIndex);
   } else {
-    if( eDT == GDT_Byte )
-        err = ParseDefaultLUT( lut_def, byteLut, 255 );
-    else
-    {
-        uint16Lut = (GByte*) malloc( 65536 );
-        if( uint16Lut == NULL )
-        {
-            msSetError(MS_MEMERR,
-                 "Cannot allocate 16-bit LUT",
-                 "ApplyLUT()" );
-            return -1;
-        }
-        err = ParseDefaultLUT( lut_def, uint16Lut, 65535 );
+    if (eDT == GDT_Byte)
+      err = ParseDefaultLUT(lut_def, byteLut, 255);
+    else {
+      uint16Lut = (GByte *)malloc(65536);
+      if (uint16Lut == NULL) {
+        msSetError(MS_MEMERR, "Cannot allocate 16-bit LUT", "ApplyLUT()");
+        return -1;
+      }
+      err = ParseDefaultLUT(lut_def, uint16Lut, 65535);
     }
   }
 
   /* -------------------------------------------------------------------- */
   /*      Apply LUT.                                                      */
   /* -------------------------------------------------------------------- */
-  if( eDT == GDT_Byte )
-  {
-    for( i = 0; i < nPixelCount; i++ )
-        pabyOutBuffer[i] = byteLut[((GByte*)pInBuffer)[i]];
-  }
-  else
-  {
-      for( i = 0; i < nPixelCount; i++ )
-        pabyOutBuffer[i] = uint16Lut[((GUInt16*)pInBuffer)[i]];
-      free(uint16Lut);
+  if (eDT == GDT_Byte) {
+    for (i = 0; i < nPixelCount; i++)
+      pabyOutBuffer[i] = byteLut[((GByte *)pInBuffer)[i]];
+  } else {
+    for (i = 0; i < nPixelCount; i++)
+      pabyOutBuffer[i] = uint16Lut[((GUInt16 *)pInBuffer)[i]];
+    free(uint16Lut);
   }
-  
+
   return err;
 }
 
@@ -1271,22 +1220,19 @@ static int ApplyLUT( int iColorIndex, co
 /*      buffer.  The processing options include scaling.                */
 /************************************************************************/
 
-static int
-LoadGDALImages( GDALDatasetH hDS, int band_numbers[4], int band_count,
-                layerObj *layer,
-                int src_xoff, int src_yoff, int src_xsize, int src_ysize,
-                GByte *pabyWholeBuffer,
-                int dst_xsize, int dst_ysize,
-                int *pbHaveRGBNoData,
-                int *pnNoData1, int *pnNoData2, int *pnNoData3,
-                bool *pbScaled, double *pdfScaleMin, double *pdfScaleRatio,
-                bool **ppbIsNoDataBuffer )
+static int LoadGDALImages(GDALDatasetH hDS, int band_numbers[4], int band_count,
+                          layerObj *layer, int src_xoff, int src_yoff,
+                          int src_xsize, int src_ysize, GByte *pabyWholeBuffer,
+                          int dst_xsize, int dst_ysize, int *pbHaveRGBNoData,
+                          int *pnNoData1, int *pnNoData2, int *pnNoData3,
+                          bool *pbScaled, double *pdfScaleMin,
+                          double *pdfScaleRatio, bool **ppbIsNoDataBuffer)
 
 {
-  int    iColorIndex, result_code=0;
+  int iColorIndex, result_code = 0;
   CPLErr eErr;
   float *pafWholeRawData;
-  char** papszLUTs;
+  char **papszLUTs;
 
   *pbScaled = false;
   *pdfScaleMin = 0;
@@ -1299,87 +1245,73 @@ LoadGDALImages( GDALDatasetH hDS, int ba
   /*      input band, then nodata will already have been adderssed as     */
   /*      part of the real or manufactured color table.                   */
   /* -------------------------------------------------------------------- */
-  if( band_count == 3 ) {
-    *pnNoData1 = (int)
-                 msGetGDALNoDataValue( layer,
-                                       GDALGetRasterBand(hDS,band_numbers[0]),
-                                       pbHaveRGBNoData);
-
-    if( *pbHaveRGBNoData )
-      *pnNoData2 = (int)
-                   msGetGDALNoDataValue( layer,
-                                         GDALGetRasterBand(hDS,band_numbers[1]),
-                                         pbHaveRGBNoData);
-    if( *pbHaveRGBNoData )
-      *pnNoData3 = (int)
-                   msGetGDALNoDataValue( layer,
-                                         GDALGetRasterBand(hDS,band_numbers[2]),
-                                         pbHaveRGBNoData);
+  if (band_count == 3) {
+    *pnNoData1 = (int)msGetGDALNoDataValue(
+        layer, GDALGetRasterBand(hDS, band_numbers[0]), pbHaveRGBNoData);
+
+    if (*pbHaveRGBNoData)
+      *pnNoData2 = (int)msGetGDALNoDataValue(
+          layer, GDALGetRasterBand(hDS, band_numbers[1]), pbHaveRGBNoData);
+    if (*pbHaveRGBNoData)
+      *pnNoData3 = (int)msGetGDALNoDataValue(
+          layer, GDALGetRasterBand(hDS, band_numbers[2]), pbHaveRGBNoData);
   }
 
   /* -------------------------------------------------------------------- */
   /*      Are we doing a simple, non-scaling case?  If so, read directly  */
   /*      and return.                                                     */
   /* -------------------------------------------------------------------- */
-  if( CSLFetchNameValue( layer->processing, "SCALE" ) == NULL
-      && CSLFetchNameValue( layer->processing, "SCALE_1" ) == NULL
-      && CSLFetchNameValue( layer->processing, "SCALE_2" ) == NULL
-      && CSLFetchNameValue( layer->processing, "SCALE_3" ) == NULL
-      && CSLFetchNameValue( layer->processing, "SCALE_4" ) == NULL ) {
-      
+  if (CSLFetchNameValue(layer->processing, "SCALE") == NULL &&
+      CSLFetchNameValue(layer->processing, "SCALE_1") == NULL &&
+      CSLFetchNameValue(layer->processing, "SCALE_2") == NULL &&
+      CSLFetchNameValue(layer->processing, "SCALE_3") == NULL &&
+      CSLFetchNameValue(layer->processing, "SCALE_4") == NULL) {
+
     GDALDataType eDT;
-    GUInt16* panBuffer = NULL;
-    void* pBuffer;
+    GUInt16 *panBuffer = NULL;
+    void *pBuffer;
 
     papszLUTs = LoadLUTs(layer, band_count);
-    if( papszLUTs == NULL ) {
-        return -1;
+    if (papszLUTs == NULL) {
+      return -1;
     }
 
     eDT = GetDataTypeAppropriateForLUTS(papszLUTs);
-    if( eDT == GDT_UInt16 ) {
-        panBuffer =
-            (GUInt16 *) malloc(sizeof(GUInt16) * dst_xsize * dst_ysize * band_count );
-
-        if( panBuffer == NULL ) {
-            msSetError(MS_MEMERR,
-                    "Allocating work uint16 image of size %dx%dx%d failed.",
-                    "msDrawRasterLayerGDAL()",
-                    dst_xsize, dst_ysize, band_count );
-            FreeLUTs(papszLUTs);
-            return -1;
-        }
-        pBuffer = panBuffer;
-    }
-    else
-        pBuffer = pabyWholeBuffer;
+    if (eDT == GDT_UInt16) {
+      panBuffer = (GUInt16 *)malloc(sizeof(GUInt16) * dst_xsize * dst_ysize *
+                                    band_count);
 
-    eErr = GDALDatasetRasterIO( hDS, GF_Read,
-                                src_xoff, src_yoff, src_xsize, src_ysize,
-                                pBuffer,
-                                dst_xsize, dst_ysize, eDT,
-                                band_count, band_numbers,
-                                0,0,0);
-
-    if( eErr != CE_None ) {
-      msSetError( MS_IOERR,
-                  "GDALDatasetRasterIO() failed: %s",
-                  "drawGDAL()",
-                  CPLGetLastErrorMsg() );
+      if (panBuffer == NULL) {
+        msSetError(MS_MEMERR,
+                   "Allocating work uint16 image of size %dx%dx%d failed.",
+                   "msDrawRasterLayerGDAL()", dst_xsize, dst_ysize, band_count);
+        FreeLUTs(papszLUTs);
+        return -1;
+      }
+      pBuffer = panBuffer;
+    } else
+      pBuffer = pabyWholeBuffer;
+
+    eErr = GDALDatasetRasterIO(hDS, GF_Read, src_xoff, src_yoff, src_xsize,
+                               src_ysize, pBuffer, dst_xsize, dst_ysize, eDT,
+                               band_count, band_numbers, 0, 0, 0);
+
+    if (eErr != CE_None) {
+      msSetError(MS_IOERR, "GDALDatasetRasterIO() failed: %s", "drawGDAL()",
+                 CPLGetLastErrorMsg());
       FreeLUTs(papszLUTs);
       msFree(panBuffer);
       return -1;
     }
 
-    for( iColorIndex = 0;
-         iColorIndex < band_count && result_code == 0; iColorIndex++ ) {
-      result_code = ApplyLUT( iColorIndex+1,
-                              papszLUTs[iColorIndex],
-                              (GByte*)pBuffer
-                                + dst_xsize*dst_ysize*iColorIndex*(GDALGetDataTypeSize(eDT)/8),
-                              eDT,
-                              pabyWholeBuffer + dst_xsize*dst_ysize*iColorIndex,
-                              dst_xsize * dst_ysize );
+    for (iColorIndex = 0; iColorIndex < band_count && result_code == 0;
+         iColorIndex++) {
+      result_code =
+          ApplyLUT(iColorIndex + 1, papszLUTs[iColorIndex],
+                   (GByte *)pBuffer + dst_xsize * dst_ysize * iColorIndex *
+                                          (GDALGetDataTypeSize(eDT) / 8),
+                   eDT, pabyWholeBuffer + dst_xsize * dst_ysize * iColorIndex,
+                   dst_xsize * dst_ysize);
     }
 
     FreeLUTs(papszLUTs);
@@ -1406,85 +1338,76 @@ LoadGDALImages( GDALDatasetH hDS, int ba
   /*      interleaved).                                                   */
   /* -------------------------------------------------------------------- */
   pafWholeRawData =
-    (float *) malloc(sizeof(float) * dst_xsize * dst_ysize * band_count );
+      (float *)malloc(sizeof(float) * dst_xsize * dst_ysize * band_count);
 
-  if( pafWholeRawData == NULL ) {
+  if (pafWholeRawData == NULL) {
     msSetError(MS_MEMERR,
                "Allocating work float image of size %dx%dx%d failed.",
-               "msDrawRasterLayerGDAL()",
-               dst_xsize, dst_ysize, band_count );
+               "msDrawRasterLayerGDAL()", dst_xsize, dst_ysize, band_count);
     return -1;
   }
 
-  eErr = GDALDatasetRasterIO(
-           hDS, GF_Read,
-           src_xoff, src_yoff, src_xsize, src_ysize,
-           pafWholeRawData, dst_xsize, dst_ysize, GDT_Float32,
-           band_count, band_numbers,
-           0, 0, 0 );
-
-  if( eErr != CE_None ) {
-    msSetError( MS_IOERR, "GDALDatasetRasterIO() failed: %s",
-                "drawGDAL()",
-                CPLGetLastErrorMsg() );
+  eErr = GDALDatasetRasterIO(hDS, GF_Read, src_xoff, src_yoff, src_xsize,
+                             src_ysize, pafWholeRawData, dst_xsize, dst_ysize,
+                             GDT_Float32, band_count, band_numbers, 0, 0, 0);
+
+  if (eErr != CE_None) {
+    msSetError(MS_IOERR, "GDALDatasetRasterIO() failed: %s", "drawGDAL()",
+               CPLGetLastErrorMsg());
 
-    free( pafWholeRawData );
+    free(pafWholeRawData);
     return -1;
   }
 
   papszLUTs = LoadLUTs(layer, band_count);
-  if( papszLUTs == NULL ) {
-    free( pafWholeRawData );
+  if (papszLUTs == NULL) {
+    free(pafWholeRawData);
     return -1;
   }
 
-  if( GetDataTypeAppropriateForLUTS(papszLUTs) != GDT_Byte ) {
-    msDebug( "LoadGDALImage(%s): One of the LUT contains a input value > 255.\n"
-             "This is not properly supported in combination with SCALE\n",
-             layer->name );
+  if (GetDataTypeAppropriateForLUTS(papszLUTs) != GDT_Byte) {
+    msDebug("LoadGDALImage(%s): One of the LUT contains a input value > 255.\n"
+            "This is not properly supported in combination with SCALE\n",
+            layer->name);
   }
 
   /* -------------------------------------------------------------------- */
   /*      Fetch the scale processing option.                              */
   /* -------------------------------------------------------------------- */
-  for( iColorIndex = 0; iColorIndex < band_count; iColorIndex++ ) {
+  for (iColorIndex = 0; iColorIndex < band_count; iColorIndex++) {
     unsigned char *pabyBuffer;
-    double dfScaleMin=0.0, dfScaleMax=255.0, dfScaleRatio, dfNoDataValue;
+    double dfScaleMin = 0.0, dfScaleMax = 255.0, dfScaleRatio, dfNoDataValue;
     const char *pszScaleInfo;
     float *pafRawData;
-    int   nPixelCount = dst_xsize * dst_ysize, i, bGotNoData = FALSE;
-    GDALRasterBandH hBand =GDALGetRasterBand(hDS,band_numbers[iColorIndex]);
-    pszScaleInfo = CSLFetchNameValue( layer->processing, "SCALE" );
-    if( pszScaleInfo == NULL ) {
+    int nPixelCount = dst_xsize * dst_ysize, i, bGotNoData = FALSE;
+    GDALRasterBandH hBand = GDALGetRasterBand(hDS, band_numbers[iColorIndex]);
+    pszScaleInfo = CSLFetchNameValue(layer->processing, "SCALE");
+    if (pszScaleInfo == NULL) {
       char szBandScalingName[20];
 
-      sprintf( szBandScalingName, "SCALE_%d", iColorIndex+1 );
-      pszScaleInfo = CSLFetchNameValue( layer->processing,
-                                        szBandScalingName);
+      sprintf(szBandScalingName, "SCALE_%d", iColorIndex + 1);
+      pszScaleInfo = CSLFetchNameValue(layer->processing, szBandScalingName);
     }
 
-    if( pszScaleInfo != NULL ) {
+    if (pszScaleInfo != NULL) {
       char **papszTokens;
 
-      papszTokens = CSLTokenizeStringComplex( pszScaleInfo, " ,",
-                                              FALSE, FALSE );
-      if( CSLCount(papszTokens) == 1
-          && EQUAL(papszTokens[0],"AUTO") ) {
+      papszTokens = CSLTokenizeStringComplex(pszScaleInfo, " ,", FALSE, FALSE);
+      if (CSLCount(papszTokens) == 1 && EQUAL(papszTokens[0], "AUTO")) {
         dfScaleMin = dfScaleMax = 0.0;
-      } else if( CSLCount(papszTokens) != 2 ) {
-        free( pafWholeRawData );
-        CSLDestroy( papszTokens );
-        FreeLUTs( papszLUTs );
-        msSetError( MS_MISCERR,
-                    "SCALE PROCESSING option unparsable for layer %s.",
-                    "msDrawGDAL()",
-                    layer->name );
+      } else if (CSLCount(papszTokens) != 2) {
+        free(pafWholeRawData);
+        CSLDestroy(papszTokens);
+        FreeLUTs(papszLUTs);
+        msSetError(MS_MISCERR,
+                   "SCALE PROCESSING option unparsable for layer %s.",
+                   "msDrawGDAL()", layer->name);
         return -1;
       } else {
         dfScaleMin = atof(papszTokens[0]);
         dfScaleMax = atof(papszTokens[1]);
       }
-      CSLDestroy( papszTokens );
+      CSLDestroy(papszTokens);
     }
 
     /* -------------------------------------------------------------------- */
@@ -1494,42 +1417,42 @@ LoadGDALImages( GDALDatasetH hDS, int ba
     /* -------------------------------------------------------------------- */
     pafRawData = pafWholeRawData + iColorIndex * dst_xsize * dst_ysize;
 
-    dfNoDataValue = msGetGDALNoDataValue( layer, hBand, &bGotNoData );
+    dfNoDataValue = msGetGDALNoDataValue(layer, hBand, &bGotNoData);
 
     /* we force assignment to a float rather than letting pafRawData[i]
        get promoted to double later to avoid float precision issues. */
-    float fNoDataValue = (float) dfNoDataValue;
+    float fNoDataValue = (float)dfNoDataValue;
 
-    if( dfScaleMin == dfScaleMax ) {
+    if (dfScaleMin == dfScaleMax) {
       int bMinMaxSet = 0;
 
       /* we force assignment to a float rather than letting pafRawData[i]
          get promoted to double later to avoid float precision issues. */
-      float fNoDataValue = (float) dfNoDataValue;
+      float fNoDataValue = (float)dfNoDataValue;
 
-      for( i = 0; i < nPixelCount; i++ ) {
-        if( bGotNoData && IsNoData(pafRawData[i], fNoDataValue) )
+      for (i = 0; i < nPixelCount; i++) {
+        if (bGotNoData && IsNoData(pafRawData[i], fNoDataValue))
           continue;
 
-        if( CPLIsNan(pafRawData[i]) )
+        if (CPLIsNan(pafRawData[i]))
           continue;
 
-        if( !bMinMaxSet ) {
+        if (!bMinMaxSet) {
           dfScaleMin = dfScaleMax = pafRawData[i];
           bMinMaxSet = TRUE;
         }
 
-        dfScaleMin = MS_MIN(dfScaleMin,pafRawData[i]);
-        dfScaleMax = MS_MAX(dfScaleMax,pafRawData[i]);
+        dfScaleMin = MS_MIN(dfScaleMin, pafRawData[i]);
+        dfScaleMax = MS_MAX(dfScaleMax, pafRawData[i]);
       }
 
-      if( dfScaleMin == dfScaleMax )
+      if (dfScaleMin == dfScaleMax)
         dfScaleMax = dfScaleMin + 1.0;
     }
 
-    if( layer->debug > 0 )
-      msDebug( "msDrawGDAL(%s): scaling to 8bit, src range=%g,%g\n",
-               layer->name, dfScaleMin, dfScaleMax );
+    if (layer->debug > 0)
+      msDebug("msDrawGDAL(%s): scaling to 8bit, src range=%g,%g\n", layer->name,
+              dfScaleMin, dfScaleMax);
 
     /* -------------------------------------------------------------------- */
     /*      Now process the data.                                           */
@@ -1537,29 +1460,29 @@ LoadGDALImages( GDALDatasetH hDS, int ba
     dfScaleRatio = 256.0 / (dfScaleMax - dfScaleMin);
     pabyBuffer = pabyWholeBuffer + iColorIndex * nPixelCount;
 
-    if( iColorIndex == 0 && bGotNoData )
+    if (iColorIndex == 0 && bGotNoData)
       *ppbIsNoDataBuffer = (bool *)calloc(nPixelCount, 1);
 
-    for( i = 0; i < nPixelCount; i++ ) {
+    for (i = 0; i < nPixelCount; i++) {
       float fScaledValue;
 
-      if( bGotNoData && IsNoData(pafRawData[i], fNoDataValue) ) {
-        if( iColorIndex == 0 )
+      if (bGotNoData && IsNoData(pafRawData[i], fNoDataValue)) {
+        if (iColorIndex == 0)
           (*ppbIsNoDataBuffer)[i] = true;
         continue;
       }
 
-      fScaledValue = (float) ((pafRawData[i]-dfScaleMin)*dfScaleRatio);
+      fScaledValue = (float)((pafRawData[i] - dfScaleMin) * dfScaleRatio);
 
-      if( fScaledValue < 0.0 )
+      if (fScaledValue < 0.0)
         pabyBuffer[i] = 0;
-      else if( fScaledValue > 255.0 )
+      else if (fScaledValue > 255.0)
         pabyBuffer[i] = 255;
       else
-        pabyBuffer[i] = (int) fScaledValue;
+        pabyBuffer[i] = (int)fScaledValue;
     }
 
-    if( iColorIndex == 0 ) {
+    if (iColorIndex == 0) {
       *pbScaled = true;
       *pdfScaleMin = dfScaleMin;
       *pdfScaleRatio = dfScaleRatio;
@@ -1570,36 +1493,33 @@ LoadGDALImages( GDALDatasetH hDS, int ba
     /*      unable to utilize it since we can't return any pixels marked    */
     /*      as nodata from this function.  Need to fix someday.             */
     /* -------------------------------------------------------------------- */
-    if( bGotNoData )
-      msDebug( "LoadGDALImage(%s): NODATA value %g in GDAL\n"
-               "file or PROCESSING directive largely ignored.  Not yet fully supported for\n"
-               "unclassified scaled data.  The NODATA value is excluded from auto-scaling\n"
-               "min/max computation, but will not be transparent.\n",
-               layer->name, dfNoDataValue );
+    if (bGotNoData)
+      msDebug("LoadGDALImage(%s): NODATA value %g in GDAL\n"
+              "file or PROCESSING directive largely ignored.  Not yet fully "
+              "supported for\n"
+              "unclassified scaled data.  The NODATA value is excluded from "
+              "auto-scaling\n"
+              "min/max computation, but will not be transparent.\n",
+              layer->name, dfNoDataValue);
 
     /* -------------------------------------------------------------------- */
     /*      Apply LUT if there is one.                                      */
     /* -------------------------------------------------------------------- */
-    result_code = ApplyLUT( iColorIndex+1,
-                            papszLUTs[iColorIndex],
-                            pabyBuffer,
-                            GDT_Byte,
-                            pabyBuffer,
-                            dst_xsize * dst_ysize );
-    if( result_code == -1 ) {
-      free( pafWholeRawData );
-      FreeLUTs( papszLUTs );
+    result_code = ApplyLUT(iColorIndex + 1, papszLUTs[iColorIndex], pabyBuffer,
+                           GDT_Byte, pabyBuffer, dst_xsize * dst_ysize);
+    if (result_code == -1) {
+      free(pafWholeRawData);
+      FreeLUTs(papszLUTs);
       return result_code;
     }
   }
 
-  free( pafWholeRawData );
-  FreeLUTs( papszLUTs );
+  free(pafWholeRawData);
+  FreeLUTs(papszLUTs);
 
   return result_code;
 }
 
-
 /************************************************************************/
 /*                       msGetGDALGeoTransform()                        */
 /*                                                                      */
@@ -1608,8 +1528,8 @@ LoadGDALImages( GDALDatasetH hDS, int ba
 /*      before this function is called.                                 */
 /************************************************************************/
 
-int msGetGDALGeoTransform( GDALDatasetH hDS, mapObj *map, layerObj *layer,
-                           double *padfGeoTransform )
+int msGetGDALGeoTransform(GDALDatasetH hDS, mapObj *map, layerObj *layer,
+                          double *padfGeoTransform)
 
 {
   const char *extent_priority = NULL;
@@ -1620,7 +1540,7 @@ int msGetGDALGeoTransform( GDALDatasetH
   char szPath[MS_MAXPATHLEN];
   int fullPathLen;
   int success = 0;
-  rectObj  rect;
+  rectObj rect;
 
   /* -------------------------------------------------------------------- */
   /*      some GDAL drivers (ie. GIF) don't set geotransform on failure.  */
@@ -1635,33 +1555,32 @@ int msGetGDALGeoTransform( GDALDatasetH
   /* -------------------------------------------------------------------- */
   /*      Do we want to override GDAL with a worldfile if one is present? */
   /* -------------------------------------------------------------------- */
-  extent_priority = CSLFetchNameValue( layer->processing,
-                                       "EXTENT_PRIORITY" );
+  extent_priority = CSLFetchNameValue(layer->processing, "EXTENT_PRIORITY");
 
-  if( extent_priority != NULL
-      && EQUALN(extent_priority,"WORLD",5) ) {
+  if (extent_priority != NULL && EQUALN(extent_priority, "WORLD", 5)) {
     /* is there a user configured worldfile? */
-    value = CSLFetchNameValue( layer->processing, "WORLDFILE" );
+    value = CSLFetchNameValue(layer->processing, "WORLDFILE");
 
-    if( value != NULL ) {
+    if (value != NULL) {
       /* at this point, fullPath may be a filePath or path only */
       fullPath = msBuildPath(szPath, map->mappath, value);
 
       /* fullPath is a path only, so let's append the dataset filename */
-      if( strrchr(szPath,'.') == NULL ) {
+      if (strrchr(szPath, '.') == NULL) {
         fullPathLen = strlen(fullPath);
-        gdalDesc = msStripPath((char*)GDALGetDescription(hDS));
+        gdalDesc = msStripPath((char *)GDALGetDescription(hDS));
 
-        if ( (fullPathLen + strlen(gdalDesc)) < MS_MAXPATHLEN ) {
-          strcpy((char*)(fullPath + fullPathLen), gdalDesc);
+        if ((fullPathLen + strlen(gdalDesc)) < MS_MAXPATHLEN) {
+          strcpy((char *)(fullPath + fullPathLen), gdalDesc);
         } else {
-          msDebug("Path length to alternative worldfile exceeds MS_MAXPATHLEN.\n");
+          msDebug(
+              "Path length to alternative worldfile exceeds MS_MAXPATHLEN.\n");
           fullPath = NULL;
         }
       }
       /* fullPath has a filename included, so get the extension */
       else {
-        fileExtension = msStrdup(strrchr(szPath,'.') + 1);
+        fileExtension = msStrdup(strrchr(szPath, '.') + 1);
       }
     }
     /* common behaviour with worldfile generated from basename + .wld */
@@ -1670,18 +1589,18 @@ int msGetGDALGeoTransform( GDALDatasetH
       fileExtension = msStrdup("wld");
     }
 
-    if( fullPath )
+    if (fullPath)
       success = GDALReadWorldFile(fullPath, fileExtension, padfGeoTransform);
 
-    if( success && layer->debug >= MS_DEBUGLEVEL_VVV ) {
+    if (success && layer->debug >= MS_DEBUGLEVEL_VVV) {
       msDebug("Worldfile location: %s.\n", fullPath);
-    } else if( layer->debug >= MS_DEBUGLEVEL_VVV ) {
+    } else if (layer->debug >= MS_DEBUGLEVEL_VVV) {
       msDebug("Failed using worldfile location: %s.\n", fullPath);
     }
 
     msFree(fileExtension);
 
-    if( success )
+    if (success)
       return MS_SUCCESS;
   }
 
@@ -1694,8 +1613,8 @@ int msGetGDALGeoTransform( GDALDatasetH
   /*      files with no coordinate system otherwise they break down in    */
   /*      many ways.                                                      */
   /* -------------------------------------------------------------------- */
-  if (GDALGetGeoTransform( hDS, padfGeoTransform ) == CE_None ) {
-    if( padfGeoTransform[5] == 1.0 && padfGeoTransform[3] == 0.0 ) {
+  if (GDALGetGeoTransform(hDS, padfGeoTransform) == CE_None) {
+    if (padfGeoTransform[5] == 1.0 && padfGeoTransform[3] == 0.0) {
       padfGeoTransform[5] = -1.0;
       padfGeoTransform[3] = GDALGetRasterYSize(hDS);
     }
@@ -1706,9 +1625,8 @@ int msGetGDALGeoTransform( GDALDatasetH
   /* -------------------------------------------------------------------- */
   /*      Try worldfile.                                                  */
   /* -------------------------------------------------------------------- */
-  if( GDALGetDescription(hDS) != NULL
-      && GDALReadWorldFile(GDALGetDescription(hDS), "wld",
-                           padfGeoTransform) ) {
+  if (GDALGetDescription(hDS) != NULL &&
+      GDALReadWorldFile(GDALGetDescription(hDS), "wld", padfGeoTransform)) {
     return MS_SUCCESS;
   }
 
@@ -1724,13 +1642,13 @@ int msGetGDALGeoTransform( GDALDatasetH
     rect = layer->extent;
 
     padfGeoTransform[0] = rect.minx;
-    padfGeoTransform[1] = (rect.maxx - rect.minx) /
-                          (double) GDALGetRasterXSize( hDS );
+    padfGeoTransform[1] =
+        (rect.maxx - rect.minx) / (double)GDALGetRasterXSize(hDS);
     padfGeoTransform[2] = 0;
     padfGeoTransform[3] = rect.maxy;
     padfGeoTransform[4] = 0;
-    padfGeoTransform[5] = (rect.miny - rect.maxy) /
-                          (double) GDALGetRasterYSize( hDS );
+    padfGeoTransform[5] =
+        (rect.miny - rect.maxy) / (double)GDALGetRasterYSize(hDS);
 
     return MS_SUCCESS;
   }
@@ -1757,47 +1675,48 @@ int msGetGDALGeoTransform( GDALDatasetH
 /************************************************************************/
 
 static int
-msDrawRasterLayerGDAL_RawMode(
-  mapObj *map, layerObj *layer, imageObj *image, GDALDatasetH hDS,
-  int src_xoff, int src_yoff, int src_xsize, int src_ysize,
-  int dst_xoff, int dst_yoff, int dst_xsize, int dst_ysize )
+msDrawRasterLayerGDAL_RawMode(mapObj *map, layerObj *layer, imageObj *image,
+                              GDALDatasetH hDS, int src_xoff, int src_yoff,
+                              int src_xsize, int src_ysize, int dst_xoff,
+                              int dst_yoff, int dst_xsize, int dst_ysize)
 
 {
   void *pBuffer;
   GDALDataType eDataType;
   int *band_list, band_count;
-  int  i, j, k, band;
+  int i, j, k, band;
   CPLErr eErr;
   float *f_nodatas = NULL;
   unsigned char *b_nodatas = NULL;
   GInt16 *i_nodatas = NULL;
-  int got_nodata=FALSE;
+  int got_nodata = FALSE;
   rasterBufferObj *mask_rb = NULL;
   rasterBufferObj s_mask_rb;
-  if(layer->mask) {
+  if (layer->mask) {
     int ret;
-    layerObj *maskLayer = GET_LAYER(map, msGetLayerIndex(map,layer->mask));
+    layerObj *maskLayer = GET_LAYER(map, msGetLayerIndex(map, layer->mask));
     mask_rb = &s_mask_rb;
     memset(mask_rb, 0, sizeof(s_mask_rb));
-    ret = MS_IMAGE_RENDERER(maskLayer->maskimage)->getRasterBufferHandle(maskLayer->maskimage,mask_rb);
-    if(ret != MS_SUCCESS)
+    ret = MS_IMAGE_RENDERER(maskLayer->maskimage)
+              ->getRasterBufferHandle(maskLayer->maskimage, mask_rb);
+    if (ret != MS_SUCCESS)
       return -1;
   }
 
-  if( image->format->bands > 256 ) {
-    msSetError( MS_IMGERR, "Too many bands (more than 256).",
-                "msDrawRasterLayerGDAL_RawMode()" );
+  if (image->format->bands > 256) {
+    msSetError(MS_IMGERR, "Too many bands (more than 256).",
+               "msDrawRasterLayerGDAL_RawMode()");
     return -1;
   }
 
   /* -------------------------------------------------------------------- */
   /*      What data type do we need?                                      */
   /* -------------------------------------------------------------------- */
-  if( image->format->imagemode == MS_IMAGEMODE_INT16 )
+  if (image->format->imagemode == MS_IMAGEMODE_INT16)
     eDataType = GDT_Int16;
-  else if( image->format->imagemode == MS_IMAGEMODE_FLOAT32 )
+  else if (image->format->imagemode == MS_IMAGEMODE_FLOAT32)
     eDataType = GDT_Float32;
-  else if( image->format->imagemode == MS_IMAGEMODE_BYTE )
+  else if (image->format->imagemode == MS_IMAGEMODE_BYTE)
     eDataType = GDT_Byte;
   else
     return -1;
@@ -1805,90 +1724,89 @@ msDrawRasterLayerGDAL_RawMode(
   /* -------------------------------------------------------------------- */
   /*      Work out the band list.                                         */
   /* -------------------------------------------------------------------- */
-  band_list = msGetGDALBandList( layer, hDS, image->format->bands,
-                                 &band_count );
-  if( band_list == NULL )
+  band_list = msGetGDALBandList(layer, hDS, image->format->bands, &band_count);
+  if (band_list == NULL)
     return -1;
 
-  if( band_count != image->format->bands ) {
-    free( band_list );
-    msSetError( MS_IMGERR, "BANDS PROCESSING directive has wrong number of bands, expected %d, got %d.",
-                "msDrawRasterLayerGDAL_RawMode()",
-                image->format->bands, band_count );
+  if (band_count != image->format->bands) {
+    free(band_list);
+    msSetError(MS_IMGERR,
+               "BANDS PROCESSING directive has wrong number of bands, expected "
+               "%d, got %d.",
+               "msDrawRasterLayerGDAL_RawMode()", image->format->bands,
+               band_count);
     return -1;
   }
 
   /* -------------------------------------------------------------------- */
   /*      Do we have nodata values?                                       */
   /* -------------------------------------------------------------------- */
-  f_nodatas = (float *) calloc(sizeof(float),band_count);
+  f_nodatas = (float *)calloc(sizeof(float), band_count);
   if (f_nodatas == NULL) {
-    msSetError(MS_MEMERR, "%s: %d: Out of memory allocating %u bytes.\n", "msDrawRasterLayerGDAL_RawMode()",
-               __FILE__, __LINE__, (unsigned int)(sizeof(float)*band_count));
-    free( band_list );
+    msSetError(MS_MEMERR, "%s: %d: Out of memory allocating %u bytes.\n",
+               "msDrawRasterLayerGDAL_RawMode()", __FILE__, __LINE__,
+               (unsigned int)(sizeof(float) * band_count));
+    free(band_list);
     return -1;
   }
 
-  if( band_count <= 3
-      && (layer->offsite.red != -1
-          || layer->offsite.green != -1
-          || layer->offsite.blue != -1) ) {
-    if( band_count > 0 )
+  if (band_count <= 3 &&
+      (layer->offsite.red != -1 || layer->offsite.green != -1 ||
+       layer->offsite.blue != -1)) {
+    if (band_count > 0)
       f_nodatas[0] = layer->offsite.red;
-    if( band_count > 1 )
+    if (band_count > 1)
       f_nodatas[1] = layer->offsite.green;
-    if( band_count > 2 )
+    if (band_count > 2)
       f_nodatas[2] = layer->offsite.blue;
     got_nodata = TRUE;
   }
 
-  if( !got_nodata ) {
+  if (!got_nodata) {
     got_nodata = TRUE;
-    for( band = 0; band < band_count && got_nodata; band++ ) {
+    for (band = 0; band < band_count && got_nodata; band++) {
       f_nodatas[band] = msGetGDALNoDataValue(
-                          layer, GDALGetRasterBand(hDS,band_list[band]), &got_nodata );
+          layer, GDALGetRasterBand(hDS, band_list[band]), &got_nodata);
     }
   }
 
-  if( !got_nodata ) {
-    free( f_nodatas );
+  if (!got_nodata) {
+    free(f_nodatas);
     f_nodatas = NULL;
-  } else if( eDataType == GDT_Byte ) {
-    b_nodatas = (unsigned char *) f_nodatas;
-    for( band = 0; band < band_count; band++ )
-      b_nodatas[band] = (unsigned char) f_nodatas[band];
-  } else if( eDataType == GDT_Int16 ) {
-    i_nodatas = (GInt16 *) f_nodatas;
-    for( band = 0; band < band_count; band++ )
-      i_nodatas[band] = (GInt16) f_nodatas[band];
+  } else if (eDataType == GDT_Byte) {
+    b_nodatas = (unsigned char *)f_nodatas;
+    for (band = 0; band < band_count; band++)
+      b_nodatas[band] = (unsigned char)f_nodatas[band];
+  } else if (eDataType == GDT_Int16) {
+    i_nodatas = (GInt16 *)f_nodatas;
+    for (band = 0; band < band_count; band++)
+      i_nodatas[band] = (GInt16)f_nodatas[band];
   }
 
   /* -------------------------------------------------------------------- */
   /*      Allocate buffer, and read data into it.                         */
   /* -------------------------------------------------------------------- */
-  pBuffer = malloc(dst_xsize * dst_ysize * image->format->bands
-                   * (GDALGetDataTypeSize(eDataType)/8) );
-  if( pBuffer == NULL ) {
-    msSetError(MS_MEMERR,
-               "Allocating work image of size %dx%d failed.",
-               "msDrawRasterLayerGDAL()", dst_xsize, dst_ysize );
-    free( band_list );
-    free( f_nodatas );
+  pBuffer = malloc(dst_xsize * dst_ysize * image->format->bands *
+                   (GDALGetDataTypeSize(eDataType) / 8));
+  if (pBuffer == NULL) {
+    msSetError(MS_MEMERR, "Allocating work image of size %dx%d failed.",
+               "msDrawRasterLayerGDAL()", dst_xsize, dst_ysize);
+    free(band_list);
+    free(f_nodatas);
     return -1;
   }
 
-  eErr = GDALDatasetRasterIO( hDS, GF_Read,
-                              src_xoff, src_yoff, src_xsize, src_ysize,
-                              pBuffer, dst_xsize, dst_ysize, eDataType,
-                              image->format->bands, band_list,
-                              0, 0, 0 );
-  free( band_list );
-
-  if( eErr != CE_None ) {
-    msSetError( MS_IOERR, "GDALRasterIO() failed: %s",
-                "msDrawRasterLayerGDAL_RawMode()", CPLGetLastErrorMsg() );
-    free( pBuffer );
-    free( f_nodatas );
+  eErr =
+      GDALDatasetRasterIO(hDS, GF_Read, src_xoff, src_yoff, src_xsize,
+                          src_ysize, pBuffer, dst_xsize, dst_ysize, eDataType,
+                          image->format->bands, band_list, 0, 0, 0);
+  free(band_list);
+
+  if (eErr != CE_None) {
+    msSetError(MS_IOERR, "GDALRasterIO() failed: %s",
+               "msDrawRasterLayerGDAL_RawMode()", CPLGetLastErrorMsg());
+    free(pBuffer);
+    free(f_nodatas);
     return -1;
   }
 
@@ -1896,59 +1814,56 @@ msDrawRasterLayerGDAL_RawMode(
   /*      Transfer the data to the imageObj.                              */
   /* -------------------------------------------------------------------- */
   k = 0;
-  for( band = 0; band < image->format->bands; band++ ) {
-    for( i = dst_yoff; i < dst_yoff + dst_ysize; i++ ) {
-      if( image->format->imagemode == MS_IMAGEMODE_INT16 ) {
-        for( j = dst_xoff; j < dst_xoff + dst_xsize; j++ ) {
-          int off = j + i * image->width
-                    + band*image->width*image->height;
+  for (band = 0; band < image->format->bands; band++) {
+    for (i = dst_yoff; i < dst_yoff + dst_ysize; i++) {
+      if (image->format->imagemode == MS_IMAGEMODE_INT16) {
+        for (j = dst_xoff; j < dst_xoff + dst_xsize; j++) {
+          int off = j + i * image->width + band * image->width * image->height;
           int off_mask = j + i * image->width;
 
-          if( ( i_nodatas && ((GInt16 *) pBuffer)[k] == i_nodatas[band] )
-              || SKIP_MASK(j,i)) {
+          if ((i_nodatas && ((GInt16 *)pBuffer)[k] == i_nodatas[band]) ||
+              SKIP_MASK(j, i)) {
             k++;
             continue;
           }
 
-          image->img.raw_16bit[off] = ((GInt16 *) pBuffer)[k++];
-          MS_SET_BIT(image->img_mask,off_mask);
+          image->img.raw_16bit[off] = ((GInt16 *)pBuffer)[k++];
+          MS_SET_BIT(image->img_mask, off_mask);
         }
-      } else if( image->format->imagemode == MS_IMAGEMODE_FLOAT32 ) {
-        for( j = dst_xoff; j < dst_xoff + dst_xsize; j++ ) {
-          int off = j + i * image->width
-                    + band*image->width*image->height;
+      } else if (image->format->imagemode == MS_IMAGEMODE_FLOAT32) {
+        for (j = dst_xoff; j < dst_xoff + dst_xsize; j++) {
+          int off = j + i * image->width + band * image->width * image->height;
           int off_mask = j + i * image->width;
 
-          if( ( f_nodatas && ((float *) pBuffer)[k] == f_nodatas[band] )
-              || SKIP_MASK(j,i)) {
+          if ((f_nodatas && ((float *)pBuffer)[k] == f_nodatas[band]) ||
+              SKIP_MASK(j, i)) {
             k++;
             continue;
           }
 
-          image->img.raw_float[off] = ((float *) pBuffer)[k++];
-          MS_SET_BIT(image->img_mask,off_mask);
+          image->img.raw_float[off] = ((float *)pBuffer)[k++];
+          MS_SET_BIT(image->img_mask, off_mask);
         }
-      } else if( image->format->imagemode == MS_IMAGEMODE_BYTE ) {
-        for( j = dst_xoff; j < dst_xoff + dst_xsize; j++ ) {
-          int off = j + i * image->width
-                    + band*image->width*image->height;
+      } else if (image->format->imagemode == MS_IMAGEMODE_BYTE) {
+        for (j = dst_xoff; j < dst_xoff + dst_xsize; j++) {
+          int off = j + i * image->width + band * image->width * image->height;
           int off_mask = j + i * image->width;
 
-          if( ( b_nodatas && ((unsigned char *) pBuffer)[k] == b_nodatas[band] )
-              || SKIP_MASK(j,i)) {
+          if ((b_nodatas && ((unsigned char *)pBuffer)[k] == b_nodatas[band]) ||
+              SKIP_MASK(j, i)) {
             k++;
             continue;
           }
 
-          image->img.raw_byte[off] = ((unsigned char *) pBuffer)[k++];
-          MS_SET_BIT(image->img_mask,off_mask);
+          image->img.raw_byte[off] = ((unsigned char *)pBuffer)[k++];
+          MS_SET_BIT(image->img_mask, off_mask);
         }
       }
     }
   }
 
-  free( pBuffer );
-  free( f_nodatas );
+  free(pBuffer);
+  free(f_nodatas);
 
   return 0;
 }
@@ -1965,129 +1880,123 @@ msDrawRasterLayerGDAL_RawMode(
 /*      the 16bit cases at the cost of some complication.               */
 /************************************************************************/
 
-static int
-msDrawRasterLayerGDAL_16BitClassification(
-  mapObj *map, layerObj *layer, rasterBufferObj *rb,
-  GDALRasterBandH hBand,
-  int src_xoff, int src_yoff, int src_xsize, int src_ysize,
-  int dst_xoff, int dst_yoff, int dst_xsize, int dst_ysize )
+static int msDrawRasterLayerGDAL_16BitClassification(
+    mapObj *map, layerObj *layer, rasterBufferObj *rb, GDALRasterBandH hBand,
+    int src_xoff, int src_yoff, int src_xsize, int src_ysize, int dst_xoff,
+    int dst_yoff, int dst_xsize, int dst_ysize)
 
 {
   float *pafRawData;
-  double dfScaleMin=0.0, dfScaleMax=0.0, dfScaleRatio;
-  int   nPixelCount = dst_xsize * dst_ysize, i, nBucketCount=0;
+  double dfScaleMin = 0.0, dfScaleMax = 0.0, dfScaleRatio;
+  int nPixelCount = dst_xsize * dst_ysize, i, nBucketCount = 0;
   GDALDataType eDataType;
-  float fDataMin=0.0, fDataMax=255.0, fNoDataValue;
+  float fDataMin = 0.0, fDataMax = 255.0, fNoDataValue;
   const char *pszScaleInfo;
   const char *pszBuckets;
-  int  *cmap, c, j, k, bGotNoData = FALSE, bGotFirstValue;
+  int *cmap, c, j, k, bGotNoData = FALSE, bGotFirstValue;
   unsigned char *rb_cmap[4];
   CPLErr eErr;
   rasterBufferObj *mask_rb = NULL;
   rasterBufferObj s_mask_rb;
   int lastC;
-  struct mstimeval starttime={0}, endtime={0};
+  struct mstimeval starttime = {0}, endtime = {0};
 
   const char *pszClassifyScaled;
   int bClassifyScaled = FALSE;
 
-  if(layer->mask) {
+  if (layer->mask) {
     int ret;
-    layerObj *maskLayer = GET_LAYER(map, msGetLayerIndex(map,layer->mask));
+    layerObj *maskLayer = GET_LAYER(map, msGetLayerIndex(map, layer->mask));
     mask_rb = &s_mask_rb;
     memset(mask_rb, 0, sizeof(s_mask_rb));
-    ret = MS_IMAGE_RENDERER(maskLayer->maskimage)->getRasterBufferHandle(maskLayer->maskimage,mask_rb);
-    if(ret != MS_SUCCESS)
+    ret = MS_IMAGE_RENDERER(maskLayer->maskimage)
+              ->getRasterBufferHandle(maskLayer->maskimage, mask_rb);
+    if (ret != MS_SUCCESS)
       return -1;
   }
 
-  assert( rb->type == MS_BUFFER_BYTE_RGBA );
+  assert(rb->type == MS_BUFFER_BYTE_RGBA);
 
   /* ==================================================================== */
   /*      Read the requested data in one gulp into a floating point       */
   /*      buffer.                                                         */
   /* ==================================================================== */
-  pafRawData = (float *) malloc(sizeof(float) * dst_xsize * dst_ysize );
-  if( pafRawData == NULL ) {
-    msSetError( MS_MEMERR, "Out of memory allocating working buffer.",
-                "msDrawRasterLayerGDAL_16BitClassification()" );
+  pafRawData = (float *)malloc(sizeof(float) * dst_xsize * dst_ysize);
+  if (pafRawData == NULL) {
+    msSetError(MS_MEMERR, "Out of memory allocating working buffer.",
+               "msDrawRasterLayerGDAL_16BitClassification()");
     return -1;
   }
 
-  eErr = GDALRasterIO( hBand, GF_Read,
-                       src_xoff, src_yoff, src_xsize, src_ysize,
-                       pafRawData, dst_xsize, dst_ysize, GDT_Float32, 0, 0 );
-
-  if( eErr != CE_None ) {
-    free( pafRawData );
-    msSetError( MS_IOERR, "GDALRasterIO() failed: %s",
-                "msDrawRasterLayerGDAL_16BitClassification()",
-                CPLGetLastErrorMsg() );
+  eErr = GDALRasterIO(hBand, GF_Read, src_xoff, src_yoff, src_xsize, src_ysize,
+                      pafRawData, dst_xsize, dst_ysize, GDT_Float32, 0, 0);
+
+  if (eErr != CE_None) {
+    free(pafRawData);
+    msSetError(MS_IOERR, "GDALRasterIO() failed: %s",
+               "msDrawRasterLayerGDAL_16BitClassification()",
+               CPLGetLastErrorMsg());
     return -1;
   }
 
-  fNoDataValue = (float) msGetGDALNoDataValue( layer, hBand, &bGotNoData );
+  fNoDataValue = (float)msGetGDALNoDataValue(layer, hBand, &bGotNoData);
 
   /* ==================================================================== */
   /*      Determine scaling.                                              */
   /* ==================================================================== */
-  eDataType = GDALGetRasterDataType( hBand );
+  eDataType = GDALGetRasterDataType(hBand);
 
   /* -------------------------------------------------------------------- */
   /*      Scan for absolute min/max of this block.                        */
   /* -------------------------------------------------------------------- */
   bGotFirstValue = FALSE;
 
-  for( i = 1; i < nPixelCount; i++ ) {
-    if( bGotNoData && IsNoData(pafRawData[i], fNoDataValue) )
+  for (i = 1; i < nPixelCount; i++) {
+    if (bGotNoData && IsNoData(pafRawData[i], fNoDataValue))
       continue;
 
-    if( CPLIsNan(pafRawData[i]) )
+    if (CPLIsNan(pafRawData[i]))
       continue;
 
-    if( !bGotFirstValue ) {
+    if (!bGotFirstValue) {
       fDataMin = fDataMax = pafRawData[i];
       bGotFirstValue = TRUE;
     } else {
-      fDataMin = MS_MIN(fDataMin,pafRawData[i]);
-      fDataMax = MS_MAX(fDataMax,pafRawData[i]);
+      fDataMin = MS_MIN(fDataMin, pafRawData[i]);
+      fDataMax = MS_MAX(fDataMax, pafRawData[i]);
     }
   }
 
   /* -------------------------------------------------------------------- */
   /*      Fetch the scale classification option.                          */
   /* -------------------------------------------------------------------- */
-  pszClassifyScaled = CSLFetchNameValue( layer->processing, "CLASSIFY_SCALED" );
-  if( pszClassifyScaled != NULL )
+  pszClassifyScaled = CSLFetchNameValue(layer->processing, "CLASSIFY_SCALED");
+  if (pszClassifyScaled != NULL)
     bClassifyScaled = CSLTestBoolean(pszClassifyScaled);
 
   /* -------------------------------------------------------------------- */
   /*      Fetch the scale processing option.                              */
   /* -------------------------------------------------------------------- */
-  pszBuckets = CSLFetchNameValue( layer->processing, "SCALE_BUCKETS" );
-  pszScaleInfo = CSLFetchNameValue( layer->processing, "SCALE" );
+  pszBuckets = CSLFetchNameValue(layer->processing, "SCALE_BUCKETS");
+  pszScaleInfo = CSLFetchNameValue(layer->processing, "SCALE");
 
-  if( pszScaleInfo != NULL ) {
+  if (pszScaleInfo != NULL) {
     char **papszTokens;
 
-    papszTokens = CSLTokenizeStringComplex( pszScaleInfo, " ,",
-                                            FALSE, FALSE );
-    if( CSLCount(papszTokens) == 1
-        && EQUAL(papszTokens[0],"AUTO") ) {
+    papszTokens = CSLTokenizeStringComplex(pszScaleInfo, " ,", FALSE, FALSE);
+    if (CSLCount(papszTokens) == 1 && EQUAL(papszTokens[0], "AUTO")) {
       dfScaleMin = dfScaleMax = 0.0;
-    } else if( CSLCount(papszTokens) != 2 ) {
-      free( pafRawData );
-      CSLDestroy( papszTokens );
-      msSetError( MS_MISCERR,
-                  "SCALE PROCESSING option unparsable for layer %s.",
-                  "msDrawGDAL()",
-                  layer->name );
+    } else if (CSLCount(papszTokens) != 2) {
+      free(pafRawData);
+      CSLDestroy(papszTokens);
+      msSetError(MS_MISCERR, "SCALE PROCESSING option unparsable for layer %s.",
+                 "msDrawGDAL()", layer->name);
       return -1;
     } else {
       dfScaleMin = atof(papszTokens[0]);
       dfScaleMax = atof(papszTokens[1]);
     }
-    CSLDestroy( papszTokens );
+    CSLDestroy(papszTokens);
   }
 
   /* -------------------------------------------------------------------- */
@@ -2096,23 +2005,23 @@ msDrawRasterLayerGDAL_16BitClassificatio
   /*      TODO: Treat Int32 and UInt32 case the same way *if* the min     */
   /*      and max are less than 65536 apart.                              */
   /* -------------------------------------------------------------------- */
-  if( eDataType == GDT_Byte || eDataType == GDT_Int16
-      || eDataType == GDT_UInt16 ) {
-    if( pszScaleInfo == NULL ) {
+  if (eDataType == GDT_Byte || eDataType == GDT_Int16 ||
+      eDataType == GDT_UInt16) {
+    if (pszScaleInfo == NULL) {
       dfScaleMin = fDataMin - 0.5;
       dfScaleMax = fDataMax + 0.5;
     }
 
-    if( pszBuckets == NULL ) {
-      nBucketCount = (int) floor(fDataMax - fDataMin + 1.1);
+    if (pszBuckets == NULL) {
+      nBucketCount = (int)floor(fDataMax - fDataMin + 1.1);
     }
   }
 
   /* -------------------------------------------------------------------- */
   /*      General case if no scaling values provided in mapfile.          */
   /* -------------------------------------------------------------------- */
-  else if( dfScaleMin == 0.0 && dfScaleMax == 0.0 ) {
-    double dfEpsilon = (fDataMax - fDataMin) / (65536*2);
+  else if (dfScaleMin == 0.0 && dfScaleMax == 0.0) {
+    double dfEpsilon = (fDataMax - fDataMin) / (65536 * 2);
     dfScaleMin = fDataMin - dfEpsilon;
     dfScaleMax = fDataMax + dfEpsilon;
   }
@@ -2120,17 +2029,17 @@ msDrawRasterLayerGDAL_16BitClassificatio
   /* -------------------------------------------------------------------- */
   /*      How many buckets?  Only set if we don't already have a value.   */
   /* -------------------------------------------------------------------- */
-  if( pszBuckets == NULL ) {
-    if( nBucketCount == 0 )
+  if (pszBuckets == NULL) {
+    if (nBucketCount == 0)
       nBucketCount = 65536;
   } else {
     nBucketCount = atoi(pszBuckets);
-    if( nBucketCount < 2 ) {
-      free( pafRawData );
-      msSetError( MS_MISCERR,
-                  "SCALE_BUCKETS PROCESSING option is not a value of 2 or more: %s.",
-                  "msDrawRasterLayerGDAL_16BitClassification()",
-                  pszBuckets );
+    if (nBucketCount < 2) {
+      free(pafRawData);
+      msSetError(
+          MS_MISCERR,
+          "SCALE_BUCKETS PROCESSING option is not a value of 2 or more: %s.",
+          "msDrawRasterLayerGDAL_16BitClassification()", pszBuckets);
       return -1;
     }
   }
@@ -2138,87 +2047,94 @@ msDrawRasterLayerGDAL_16BitClassificatio
   /* -------------------------------------------------------------------- */
   /*      Compute scaling ratio.                                          */
   /* -------------------------------------------------------------------- */
-  if( dfScaleMax == dfScaleMin )
+  if (dfScaleMax == dfScaleMin)
     dfScaleMax = dfScaleMin + 1.0;
 
   dfScaleRatio = nBucketCount / (dfScaleMax - dfScaleMin);
 
-  if( layer->debug > 0 )
-    msDebug( "msDrawRasterGDAL_16BitClassification(%s):\n"
-             "  scaling to %d buckets from range=%g,%g.\n",
-             layer->name, nBucketCount, dfScaleMin, dfScaleMax );
+  if (layer->debug > 0)
+    msDebug("msDrawRasterGDAL_16BitClassification(%s):\n"
+            "  scaling to %d buckets from range=%g,%g.\n",
+            layer->name, nBucketCount, dfScaleMin, dfScaleMax);
 
   /* ==================================================================== */
   /*      Compute classification lookup table.                            */
   /* ==================================================================== */
 
-  cmap = (int *) msSmallCalloc(sizeof(int),nBucketCount);
-  rb_cmap[0] = (unsigned char *) msSmallCalloc(1,nBucketCount);
-  rb_cmap[1] = (unsigned char *) msSmallCalloc(1,nBucketCount);
-  rb_cmap[2] = (unsigned char *) msSmallCalloc(1,nBucketCount);
-  rb_cmap[3] = (unsigned char *) msSmallCalloc(1,nBucketCount);
-
+  cmap = (int *)msSmallCalloc(sizeof(int), nBucketCount);
+  rb_cmap[0] = (unsigned char *)msSmallCalloc(1, nBucketCount);
+  rb_cmap[1] = (unsigned char *)msSmallCalloc(1, nBucketCount);
+  rb_cmap[2] = (unsigned char *)msSmallCalloc(1, nBucketCount);
+  rb_cmap[3] = (unsigned char *)msSmallCalloc(1, nBucketCount);
 
-  if(layer->debug >= MS_DEBUGLEVEL_TUNING) {
+  if (layer->debug >= MS_DEBUGLEVEL_TUNING) {
     msGettimeofday(&starttime, NULL);
   }
 
   lastC = -1;
-  for(i=0; i < nBucketCount; i++) {
+  for (i = 0; i < nBucketCount; i++) {
     double dfOriginalValue;
 
     cmap[i] = -1;
 
     // i = (int) ((dfOriginalValue - dfScaleMin) * dfScaleRatio+1)-1;
-    dfOriginalValue = (i+0.5) / dfScaleRatio + dfScaleMin;
+    dfOriginalValue = (i + 0.5) / dfScaleRatio + dfScaleMin;
 
-    /* The creation of buckets takes a significant time when they are many, and many classes
-       as well. When iterating over buckets, a faster strategy is to reuse first the last used
-       class index. */
-    if(bClassifyScaled == TRUE)
-      c = msGetClass_FloatRGB_WithFirstClassToTry(layer, (float) i, -1, -1, -1, lastC);
+    /* The creation of buckets takes a significant time when they are many, and
+       many classes as well. When iterating over buckets, a faster strategy is
+       to reuse first the last used class index. */
+    if (bClassifyScaled == TRUE)
+      c = msGetClass_FloatRGB_WithFirstClassToTry(layer, (float)i, -1, -1, -1,
+                                                  lastC);
     else
-      c = msGetClass_FloatRGB_WithFirstClassToTry(layer, (float) dfOriginalValue, -1, -1, -1, lastC);
+      c = msGetClass_FloatRGB_WithFirstClassToTry(layer, (float)dfOriginalValue,
+                                                  -1, -1, -1, lastC);
 
     lastC = c;
-    if( c != -1 ) {
+    if (c != -1) {
       int s;
       int styleindex = 0;
 
       /* change colour based on colour range? */
-      if( MS_VALID_COLOR(layer->class[c]->styles[0]->mincolor) )
-      {
+      if (MS_VALID_COLOR(layer->class[c] -> styles[0] -> mincolor)) {
         styleindex = -1;
-        for(s=0; s<layer->class[c]->numstyles; s++) {
-          if( MS_VALID_COLOR(layer->class[c]->styles[s]->mincolor)
-              && MS_VALID_COLOR(layer->class[c]->styles[s]->maxcolor)
-              && dfOriginalValue + 0.5 / dfScaleRatio >= layer->class[c]->styles[s]->minvalue
-              && dfOriginalValue - 0.5 / dfScaleRatio <= layer->class[c]->styles[s]->maxvalue ) {
-            msValueToRange(layer->class[c]->styles[s],dfOriginalValue, MS_COLORSPACE_RGB);
+        for (s = 0; s < layer->class[c] -> numstyles; s++) {
+          if (MS_VALID_COLOR(layer->class[c] -> styles[s] -> mincolor) &&
+                  MS_VALID_COLOR(layer->class[c] -> styles[s] -> maxcolor) &&
+                  dfOriginalValue + 0.5 / dfScaleRatio >=
+                      layer->class[c] -> styles[s]
+              -> minvalue && dfOriginalValue - 0.5 / dfScaleRatio <=
+                                 layer -> class[c] -> styles[s] -> maxvalue) {
+            msValueToRange(layer->class[c] -> styles[s], dfOriginalValue,
+                           MS_COLORSPACE_RGB);
             styleindex = s;
             break;
           }
         }
       }
-      if( styleindex >= 0 ) {
-        if( MS_TRANSPARENT_COLOR(layer->class[c]->styles[styleindex]->color) ) {
+      if (styleindex >= 0) {
+        if (MS_TRANSPARENT_COLOR(
+                layer->class[c] -> styles[styleindex] -> color)) {
           /* leave it transparent */
-        } else if( MS_VALID_COLOR(layer->class[c]->styles[styleindex]->color)) {
+        } else if (MS_VALID_COLOR(
+                       layer->class[c] -> styles[styleindex] -> color)) {
           /* use class color */
           rb_cmap[0][i] = layer->class[c]->styles[styleindex]->color.red;
           rb_cmap[1][i] = layer->class[c]->styles[styleindex]->color.green;
           rb_cmap[2][i] = layer->class[c]->styles[styleindex]->color.blue;
-          rb_cmap[3][i] = (255*layer->class[c]->styles[styleindex]->opacity / 100);
+          rb_cmap[3][i] =
+              (255 * layer->class[c] -> styles[styleindex] -> opacity / 100);
         }
       }
     }
   }
 
-  if(layer->debug >= MS_DEBUGLEVEL_TUNING) {
+  if (layer->debug >= MS_DEBUGLEVEL_TUNING) {
     msGettimeofday(&endtime, NULL);
-    msDebug("msDrawRasterGDAL_16BitClassification() bucket creation time: %.3fs\n",
-            (endtime.tv_sec+endtime.tv_usec/1.0e6)-
-            (starttime.tv_sec+starttime.tv_usec/1.0e6) );
+    msDebug(
+        "msDrawRasterGDAL_16BitClassification() bucket creation time: %.3fs\n",
+        (endtime.tv_sec + endtime.tv_usec / 1.0e6) -
+            (starttime.tv_sec + starttime.tv_usec / 1.0e6));
   }
 
   /* ==================================================================== */
@@ -2226,53 +2142,50 @@ msDrawRasterLayerGDAL_16BitClassificatio
   /* ==================================================================== */
   k = 0;
 
-  for( i = dst_yoff; i < dst_yoff + dst_ysize; i++ ) {
-    for( j = dst_xoff; j < dst_xoff + dst_xsize; j++ ) {
+  for (i = dst_yoff; i < dst_yoff + dst_ysize; i++) {
+    for (j = dst_xoff; j < dst_xoff + dst_xsize; j++) {
       float fRawValue = pafRawData[k++];
-      int   iMapIndex;
+      int iMapIndex;
 
       /*
        * Skip nodata pixels ... no processing.
        */
-      if( bGotNoData && IsNoData(fRawValue, fNoDataValue) )
+      if (bGotNoData && IsNoData(fRawValue, fNoDataValue))
         continue;
 
-      if( CPLIsNan(fRawValue) )
+      if (CPLIsNan(fRawValue))
         continue;
 
-      if(SKIP_MASK(j,i))
+      if (SKIP_MASK(j, i))
         continue;
 
       /*
        * The funny +1/-1 is to avoid odd rounding around zero.
        * We could use floor() but sometimes it is expensive.
        */
-      iMapIndex = (int) ((fRawValue - dfScaleMin) * dfScaleRatio+1)-1;
+      iMapIndex = (int)((fRawValue - dfScaleMin) * dfScaleRatio + 1) - 1;
 
-      if( iMapIndex >= nBucketCount || iMapIndex < 0 ) {
+      if (iMapIndex >= nBucketCount || iMapIndex < 0) {
         continue;
       }
       /* currently we never have partial alpha so keep simple */
-      if( rb_cmap[3][iMapIndex] > 0 )
-        RB_SET_PIXEL( rb, j, i,
-                      rb_cmap[0][iMapIndex],
-                      rb_cmap[1][iMapIndex],
-                      rb_cmap[2][iMapIndex],
-                      rb_cmap[3][iMapIndex] );
+      if (rb_cmap[3][iMapIndex] > 0)
+        RB_SET_PIXEL(rb, j, i, rb_cmap[0][iMapIndex], rb_cmap[1][iMapIndex],
+                     rb_cmap[2][iMapIndex], rb_cmap[3][iMapIndex]);
     }
   }
 
   /* -------------------------------------------------------------------- */
   /*      Cleanup                                                         */
   /* -------------------------------------------------------------------- */
-  free( pafRawData );
-  free( cmap );
-  free( rb_cmap[0] );
-  free( rb_cmap[1] );
-  free( rb_cmap[2] );
-  free( rb_cmap[3] );
+  free(pafRawData);
+  free(cmap);
+  free(rb_cmap[0]);
+  free(rb_cmap[1]);
+  free(rb_cmap[2]);
+  free(rb_cmap[3]);
 
-  assert( k == dst_xsize * dst_ysize );
+  assert(k == dst_xsize * dst_ysize);
 
   return 0;
 }
@@ -2280,17 +2193,14 @@ msDrawRasterLayerGDAL_16BitClassificatio
 /************************************************************************/
 /*                          IsNoData()                                  */
 /************************************************************************/
-static bool
-IsNoData( double dfValue, double dfNoDataValue )
-{
+static bool IsNoData(double dfValue, double dfNoDataValue) {
   return isnan(dfValue) || dfValue == dfNoDataValue;
 }
 
 /************************************************************************/
 /*                          msGetGDALNoDataValue()                      */
 /************************************************************************/
-double
-msGetGDALNoDataValue( layerObj *layer, void *hBand, int *pbGotNoData )
+double msGetGDALNoDataValue(layerObj *layer, void *hBand, int *pbGotNoData)
 
 {
   const char *pszNODATAOpt;
@@ -2300,11 +2210,11 @@ msGetGDALNoDataValue( layerObj *layer, v
   /* -------------------------------------------------------------------- */
   /*      Check for a NODATA setting in the .map file.                    */
   /* -------------------------------------------------------------------- */
-  pszNODATAOpt = CSLFetchNameValue(layer->processing,"NODATA");
-  if( pszNODATAOpt != NULL ) {
-    if( EQUAL(pszNODATAOpt,"OFF") || strlen(pszNODATAOpt) == 0 )
+  pszNODATAOpt = CSLFetchNameValue(layer->processing, "NODATA");
+  if (pszNODATAOpt != NULL) {
+    if (EQUAL(pszNODATAOpt, "OFF") || strlen(pszNODATAOpt) == 0)
       return -1234567.0;
-    if( !EQUAL(pszNODATAOpt,"AUTO") ) {
+    if (!EQUAL(pszNODATAOpt, "AUTO")) {
       *pbGotNoData = TRUE;
       return atof(pszNODATAOpt);
     }
@@ -2313,10 +2223,10 @@ msGetGDALNoDataValue( layerObj *layer, v
   /* -------------------------------------------------------------------- */
   /*      Check for a NODATA setting on the raw file.                     */
   /* -------------------------------------------------------------------- */
-  if( hBand == NULL )
+  if (hBand == NULL)
     return -1234567.0;
   else
-    return GDALGetRasterNoDataValue( hBand, pbGotNoData );
+    return GDALGetRasterNoDataValue(hBand, pbGotNoData);
 }
 
 /************************************************************************/
@@ -2329,19 +2239,18 @@ msGetGDALNoDataValue( layerObj *layer, v
 /*      returns malloc() list of band numbers (*band_count long).       */
 /************************************************************************/
 
-int *msGetGDALBandList( layerObj *layer, void *hDS,
-                        int max_bands, int *band_count )
+int *msGetGDALBandList(layerObj *layer, void *hDS, int max_bands,
+                       int *band_count)
 
 {
   int i, file_bands;
   int *band_list = NULL;
 
-  file_bands = GDALGetRasterCount( hDS );
-  if( file_bands == 0 ) {
-    msSetError( MS_IMGERR,
-                "Attempt to operate on GDAL file with no bands, layer=%s.",
-                "msGetGDALBandList()",
-                layer->name );
+  file_bands = GDALGetRasterCount(hDS);
+  if (file_bands == 0) {
+    msSetError(MS_IMGERR,
+               "Attempt to operate on GDAL file with no bands, layer=%s.",
+               "msGetGDALBandList()", layer->name);
 
     return NULL;
   }
@@ -2349,19 +2258,19 @@ int *msGetGDALBandList( layerObj *layer,
   /* -------------------------------------------------------------------- */
   /*      Use all (or first) bands.                                       */
   /* -------------------------------------------------------------------- */
-  if( CSLFetchNameValue( layer->processing, "BANDS" ) == NULL ) {
-    if( max_bands > 0 )
-      *band_count = MS_MIN(file_bands,max_bands);
+  if (CSLFetchNameValue(layer->processing, "BANDS") == NULL) {
+    if (max_bands > 0)
+      *band_count = MS_MIN(file_bands, max_bands);
     else
       *band_count = file_bands;
 
-    band_list = (int *) malloc(sizeof(int) * *band_count );
+    band_list = (int *)malloc(sizeof(int) * *band_count);
 
     /* FIXME MS_CHECK_ALLOC leaks papszItems */
     MS_CHECK_ALLOC(band_list, sizeof(int) * *band_count, NULL);
 
-    for( i = 0; i < *band_count; i++ )
-      band_list[i] = i+1;
+    for (i = 0; i < *band_count; i++)
+      band_list[i] = i + 1;
     return band_list;
   }
 
@@ -2370,38 +2279,40 @@ int *msGetGDALBandList( layerObj *layer,
   /* -------------------------------------------------------------------- */
   else {
     char **papszItems = CSLTokenizeStringComplex(
-                          CSLFetchNameValue(layer->processing,"BANDS"), " ,", FALSE, FALSE );
+        CSLFetchNameValue(layer->processing, "BANDS"), " ,", FALSE, FALSE);
 
-    if( CSLCount(papszItems) == 0 ) {
-      CSLDestroy( papszItems );
-      msSetError( MS_IMGERR, "BANDS PROCESSING directive has no items.",
-                  "msGetGDALBandList()" );
+    if (CSLCount(papszItems) == 0) {
+      CSLDestroy(papszItems);
+      msSetError(MS_IMGERR, "BANDS PROCESSING directive has no items.",
+                 "msGetGDALBandList()");
       return NULL;
-    } else if( max_bands != 0 && CSLCount(papszItems) > max_bands ) {
-      msSetError( MS_IMGERR, "BANDS PROCESSING directive has wrong number of bands, expected at most %d, got %d.",
-                  "msGetGDALBandList()",
-                  max_bands, CSLCount(papszItems) );
-      CSLDestroy( papszItems );
+    } else if (max_bands != 0 && CSLCount(papszItems) > max_bands) {
+      msSetError(MS_IMGERR,
+                 "BANDS PROCESSING directive has wrong number of bands, "
+                 "expected at most %d, got %d.",
+                 "msGetGDALBandList()", max_bands, CSLCount(papszItems));
+      CSLDestroy(papszItems);
       return NULL;
     }
 
     *band_count = CSLCount(papszItems);
-    band_list = (int *) malloc(sizeof(int) * *band_count);
+    band_list = (int *)malloc(sizeof(int) * *band_count);
     MS_CHECK_ALLOC(band_list, sizeof(int) * *band_count, NULL);
 
-    for( i = 0; i < *band_count; i++ ) {
+    for (i = 0; i < *band_count; i++) {
       band_list[i] = atoi(papszItems[i]);
-      if( band_list[i] < 1 || band_list[i] > GDALGetRasterCount(hDS) ) {
-        msSetError( MS_IMGERR,
-                    "BANDS PROCESSING directive includes illegal band '%s', should be from 1 to %d.",
-                    "msGetGDALBandList()",
-                    papszItems[i], GDALGetRasterCount(hDS) );
-        CSLDestroy( papszItems );
-        free( band_list );
+      if (band_list[i] < 1 || band_list[i] > GDALGetRasterCount(hDS)) {
+        msSetError(MS_IMGERR,
+                   "BANDS PROCESSING directive includes illegal band '%s', "
+                   "should be from 1 to %d.",
+                   "msGetGDALBandList()", papszItems[i],
+                   GDALGetRasterCount(hDS));
+        CSLDestroy(papszItems);
+        free(band_list);
         return NULL;
       }
     }
-    CSLDestroy( papszItems );
+    CSLDestroy(papszItems);
 
     return band_list;
   }
diff -pruN 8.0.1-5/mapdummyrenderer.c 8.0.2-1/mapdummyrenderer.c
--- 8.0.1-5/mapdummyrenderer.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapdummyrenderer.c	2024-06-11 20:41:34.000000000 +0000
@@ -29,202 +29,200 @@
 
 #include "mapserver.h"
 
-int renderLineDummy(imageObj *img, shapeObj *p, strokeStyleObj *style)
-{
+int renderLineDummy(imageObj *img, shapeObj *p, strokeStyleObj *style) {
   (void)img;
   (void)p;
   (void)style;
-  msSetError(MS_RENDERERERR,"renderLine not implemented","renderLine()");
+  msSetError(MS_RENDERERERR, "renderLine not implemented", "renderLine()");
   return MS_FAILURE;
 }
 
-int renderPolygonDummy(imageObj *img, shapeObj *p, colorObj *color)
-{
+int renderPolygonDummy(imageObj *img, shapeObj *p, colorObj *color) {
   (void)img;
   (void)p;
   (void)color;
-  msSetError(MS_RENDERERERR,"renderPolygon not implemented","renderPolygon()");
+  msSetError(MS_RENDERERERR, "renderPolygon not implemented",
+             "renderPolygon()");
   return MS_FAILURE;
 }
 
-int renderPolygonTiledDummy(imageObj *img, shapeObj *p, imageObj *tile)
-{
+int renderPolygonTiledDummy(imageObj *img, shapeObj *p, imageObj *tile) {
   (void)img;
   (void)p;
   (void)tile;
-  msSetError(MS_RENDERERERR,"renderPolygonTiled not implemented","renderPolygonTiled()");
+  msSetError(MS_RENDERERERR, "renderPolygonTiled not implemented",
+             "renderPolygonTiled()");
   return MS_FAILURE;
 }
 
-int renderLineTiledDummy(imageObj *img, shapeObj *p, imageObj *tile)
-{
+int renderLineTiledDummy(imageObj *img, shapeObj *p, imageObj *tile) {
   (void)img;
   (void)p;
   (void)tile;
-  msSetError(MS_RENDERERERR,"renderLineTiled not implemented","renderLineTiled()");
+  msSetError(MS_RENDERERERR, "renderLineTiled not implemented",
+             "renderLineTiled()");
   return MS_FAILURE;
 }
 
 int renderRasterGlyphsDummy(imageObj *img, double x, double y, int fontIndex,
-                            colorObj *color, char* text)
-{
+                            colorObj *color, char *text) {
   (void)img;
   (void)x;
   (void)y;
   (void)fontIndex;
   (void)color;
   (void)text;
-  msSetError(MS_RENDERERERR,"renderRasterGlyphs not implemented","renderRasterGlyphs()");
+  msSetError(MS_RENDERERERR, "renderRasterGlyphs not implemented",
+             "renderRasterGlyphs()");
   return MS_FAILURE;
 }
 
-int renderGlyphsLineDummy(imageObj *img,labelPathObj *labelpath,
-                          labelStyleObj *style, char *text)
-{
+int renderGlyphsLineDummy(imageObj *img, labelPathObj *labelpath,
+                          labelStyleObj *style, char *text) {
   (void)img;
   (void)labelpath;
   (void)style;
   (void)text;
-  msSetError(MS_RENDERERERR,"renderGlyphsLine not implemented","renderGlyphsLine()");
+  msSetError(MS_RENDERERERR, "renderGlyphsLine not implemented",
+             "renderGlyphsLine()");
   return MS_FAILURE;
 }
 
 int renderVectorSymbolDummy(imageObj *img, double x, double y,
-                            symbolObj *symbol, symbolStyleObj *style)
-{
+                            symbolObj *symbol, symbolStyleObj *style) {
   (void)img;
   (void)x;
   (void)y;
   (void)symbol;
   (void)style;
-  msSetError(MS_RENDERERERR,"renderVectorSymbol not implemented","renderVectorSymbol()");
+  msSetError(MS_RENDERERERR, "renderVectorSymbol not implemented",
+             "renderVectorSymbol()");
   return MS_FAILURE;
 }
 
-void* createVectorSymbolTileDummy(int width, int height,
-                                  symbolObj *symbol, symbolStyleObj *style)
-{
+void *createVectorSymbolTileDummy(int width, int height, symbolObj *symbol,
+                                  symbolStyleObj *style) {
   (void)width;
   (void)height;
   (void)symbol;
   (void)style;
-  msSetError(MS_RENDERERERR,"createVectorSymbolTile not implemented","createVectorSymbolTile()");
+  msSetError(MS_RENDERERERR, "createVectorSymbolTile not implemented",
+             "createVectorSymbolTile()");
   return NULL;
 }
 
 int renderPixmapSymbolDummy(imageObj *img, double x, double y,
-                            symbolObj *symbol, symbolStyleObj *style)
-{
+                            symbolObj *symbol, symbolStyleObj *style) {
   (void)img;
   (void)x;
   (void)y;
   (void)symbol;
   (void)style;
-  msSetError(MS_RENDERERERR,"renderPixmapSymbol not implemented","renderPixmapSymbol()");
+  msSetError(MS_RENDERERERR, "renderPixmapSymbol not implemented",
+             "renderPixmapSymbol()");
   return MS_FAILURE;
 }
 
-void* createPixmapSymbolTileDummy(int width, int height,
-                                  symbolObj *symbol, symbolStyleObj *style)
-{
+void *createPixmapSymbolTileDummy(int width, int height, symbolObj *symbol,
+                                  symbolStyleObj *style) {
   (void)width;
   (void)height;
   (void)symbol;
   (void)style;
-  msSetError(MS_RENDERERERR,"createPixmapSymbolTile not implemented","createPixmapSymbolTile()");
+  msSetError(MS_RENDERERERR, "createPixmapSymbolTile not implemented",
+             "createPixmapSymbolTile()");
   return NULL;
 }
 
 int renderEllipseSymbolDummy(imageObj *image, double x, double y,
-                             symbolObj *symbol, symbolStyleObj *style)
-{
+                             symbolObj *symbol, symbolStyleObj *style) {
   (void)image;
   (void)x;
   (void)y;
   (void)symbol;
   (void)style;
-  msSetError(MS_RENDERERERR,"renderEllipseSymbol not implemented","renderEllipseSymbol()");
+  msSetError(MS_RENDERERERR, "renderEllipseSymbol not implemented",
+             "renderEllipseSymbol()");
   return MS_FAILURE;
 }
 
-void* createEllipseSymbolTileDummy(int width, int height,
-                                   symbolObj *symbol, symbolStyleObj *style)
-{
+void *createEllipseSymbolTileDummy(int width, int height, symbolObj *symbol,
+                                   symbolStyleObj *style) {
   (void)width;
   (void)height;
   (void)symbol;
   (void)style;
-  msSetError(MS_RENDERERERR,"createEllipseSymbolTile not implemented","createEllipseSymbolTile()");
+  msSetError(MS_RENDERERERR, "createEllipseSymbolTile not implemented",
+             "createEllipseSymbolTile()");
   return NULL;
 }
 
 int renderTruetypeSymbolDummy(imageObj *img, double x, double y,
-                              symbolObj *symbol, symbolStyleObj *style)
-{
+                              symbolObj *symbol, symbolStyleObj *style) {
   (void)img;
   (void)x;
   (void)y;
   (void)symbol;
   (void)style;
-  msSetError(MS_RENDERERERR,"renderTruetypeSymbol not implemented","renderTruetypeSymbol()");
+  msSetError(MS_RENDERERERR, "renderTruetypeSymbol not implemented",
+             "renderTruetypeSymbol()");
   return MS_FAILURE;
 }
 
-void* createTruetypeSymbolTileDummy(int width, int height,
-                                    symbolObj *symbol, symbolStyleObj *style)
-{
+void *createTruetypeSymbolTileDummy(int width, int height, symbolObj *symbol,
+                                    symbolStyleObj *style) {
   (void)width;
   (void)height;
   (void)symbol;
   (void)style;
-  msSetError(MS_RENDERERERR,"createTruetypeSymbolTile not implemented","createTruetypeSymbolTile()");
+  msSetError(MS_RENDERERERR, "createTruetypeSymbolTile not implemented",
+             "createTruetypeSymbolTile()");
   return NULL;
 }
 
-int renderTileDummy(imageObj *img, imageObj *tile, double x, double y)
-{
+int renderTileDummy(imageObj *img, imageObj *tile, double x, double y) {
   (void)img;
   (void)tile;
   (void)x;
   (void)y;
-  msSetError(MS_RENDERERERR,"renderTile not implemented","renderTile()");
+  msSetError(MS_RENDERERERR, "renderTile not implemented", "renderTile()");
   return MS_FAILURE;
 }
 
-rasterBufferObj* loadImageFromFileDummy(char *path)
-{
+rasterBufferObj *loadImageFromFileDummy(char *path) {
   (void)path;
-  msSetError(MS_RENDERERERR,"loadImageFromFile not implemented","loadImageFromFile()");
+  msSetError(MS_RENDERERERR, "loadImageFromFile not implemented",
+             "loadImageFromFile()");
   return NULL;
 }
 
-
-int getRasterBufferHandleDummy(imageObj *img, rasterBufferObj *rb)
-{
+int getRasterBufferHandleDummy(imageObj *img, rasterBufferObj *rb) {
   (void)img;
   (void)rb;
-  msSetError(MS_RENDERERERR,"getRasterBufferHandle not implemented","getRasterBufferHandle()");
+  msSetError(MS_RENDERERERR, "getRasterBufferHandle not implemented",
+             "getRasterBufferHandle()");
   return MS_FAILURE;
 }
 
-int getRasterBufferCopyDummy(imageObj *img, rasterBufferObj *rb)
-{
+int getRasterBufferCopyDummy(imageObj *img, rasterBufferObj *rb) {
   (void)img;
   (void)rb;
-  msSetError(MS_RENDERERERR,"getRasterBufferCopy not implemented","getRasterBufferCopy()");
+  msSetError(MS_RENDERERERR, "getRasterBufferCopy not implemented",
+             "getRasterBufferCopy()");
   return MS_FAILURE;
 }
 
-rasterBufferObj* createRasterBufferDummy(int width, int height)
-{
+rasterBufferObj *createRasterBufferDummy(int width, int height) {
   (void)width;
   (void)height;
-  msSetError(MS_RENDERERERR,"createRasterBuffer not implemented","createRasterBuffer()");
+  msSetError(MS_RENDERERERR, "createRasterBuffer not implemented",
+             "createRasterBuffer()");
   return NULL;
 }
 
-int mergeRasterBufferDummy(imageObj *dest, rasterBufferObj *overlay, double opacity, int srcX, int srcY, int dstX, int dstY, int width, int height)
-{
+int mergeRasterBufferDummy(imageObj *dest, rasterBufferObj *overlay,
+                           double opacity, int srcX, int srcY, int dstX,
+                           int dstY, int width, int height) {
   (void)dest;
   (void)overlay;
   (void)opacity;
@@ -234,48 +232,49 @@ int mergeRasterBufferDummy(imageObj *des
   (void)dstY;
   (void)width;
   (void)height;
-  msSetError(MS_RENDERERERR,"mergeRasterBuffer not implemented","mergeRasterBuffer()");
+  msSetError(MS_RENDERERERR, "mergeRasterBuffer not implemented",
+             "mergeRasterBuffer()");
   return MS_FAILURE;
 }
 
-int initializeRasterBufferDummy(rasterBufferObj *rb, int width, int height, int mode)
-{
+int initializeRasterBufferDummy(rasterBufferObj *rb, int width, int height,
+                                int mode) {
   (void)rb;
   (void)width;
   (void)height;
   (void)mode;
-  msSetError(MS_RENDERERERR,"initializeRasterBuffer not implemented","initializeRasterBuffer()");
+  msSetError(MS_RENDERERERR, "initializeRasterBuffer not implemented",
+             "initializeRasterBuffer()");
   return MS_FAILURE;
 }
 
-
-
 /* image i/o */
-imageObj* createImageDummy(int width, int height, outputFormatObj *format, colorObj* bg)
-{
+imageObj *createImageDummy(int width, int height, outputFormatObj *format,
+                           colorObj *bg) {
   (void)width;
   (void)height;
   (void)format;
   (void)bg;
-  msSetError(MS_RENDERERERR,"createImage not implemented","createImage()");
+  msSetError(MS_RENDERERERR, "createImage not implemented", "createImage()");
   return NULL;
 }
 
-int saveImageDummy(imageObj *img, mapObj *map, FILE *fp, outputFormatObj *format)
-{
+int saveImageDummy(imageObj *img, mapObj *map, FILE *fp,
+                   outputFormatObj *format) {
   (void)img;
   (void)map;
   (void)fp;
   (void)format;
-  msSetError(MS_RENDERERERR,"saveImage not implemented","saveImage()");
+  msSetError(MS_RENDERERERR, "saveImage not implemented", "saveImage()");
   return MS_FAILURE;
 }
 /*...*/
 
 /* helper functions */
-int getTruetypeTextBBoxDummy(rendererVTableObj *renderer, char **fonts, int numfonts, double size,
-                             char *string,rectObj *rect, double **advances, int bAdjustBaseline)
-{
+int getTruetypeTextBBoxDummy(rendererVTableObj *renderer, char **fonts,
+                             int numfonts, double size, char *string,
+                             rectObj *rect, double **advances,
+                             int bAdjustBaseline) {
   (void)renderer;
   (void)fonts;
   (void)numfonts;
@@ -284,87 +283,77 @@ int getTruetypeTextBBoxDummy(rendererVTa
   (void)rect;
   (void)advances;
   (void)bAdjustBaseline;
-  msSetError(MS_RENDERERERR,"getTruetypeTextBBox not implemented","getTruetypeTextBBox()");
+  msSetError(MS_RENDERERERR, "getTruetypeTextBBox not implemented",
+             "getTruetypeTextBBox()");
   return MS_FAILURE;
 }
 
-int startLayerDummy(imageObj *img, mapObj *map, layerObj *layer)
-{
+int startLayerDummy(imageObj *img, mapObj *map, layerObj *layer) {
   (void)img;
   (void)map;
   (void)layer;
-  msSetError(MS_RENDERERERR,"startLayer not implemented","startLayer()");
+  msSetError(MS_RENDERERERR, "startLayer not implemented", "startLayer()");
   return MS_FAILURE;
 }
 
-int endLayerDummy(imageObj *img, mapObj *map, layerObj *layer)
-{
+int endLayerDummy(imageObj *img, mapObj *map, layerObj *layer) {
   (void)img;
   (void)map;
   (void)layer;
-  msSetError(MS_RENDERERERR,"endLayer not implemented","endLayer()");
+  msSetError(MS_RENDERERERR, "endLayer not implemented", "endLayer()");
   return MS_FAILURE;
 }
 
-int startShapeDummy(imageObj *img, shapeObj *shape)
-{
+int startShapeDummy(imageObj *img, shapeObj *shape) {
   (void)img;
   (void)shape;
-  msSetError(MS_RENDERERERR,"startShape not implemented","startShape()");
+  msSetError(MS_RENDERERERR, "startShape not implemented", "startShape()");
   return MS_FAILURE;
 }
 
-int endShapeDummy(imageObj *img, shapeObj *shape)
-{
+int endShapeDummy(imageObj *img, shapeObj *shape) {
   (void)img;
   (void)shape;
-  msSetError(MS_RENDERERERR,"endShape not implemented","endShape()");
+  msSetError(MS_RENDERERERR, "endShape not implemented", "endShape()");
   return MS_FAILURE;
 }
 
-int setClipDummy(imageObj *img, rectObj clipRect)
-{
+int setClipDummy(imageObj *img, rectObj clipRect) {
   (void)img;
   (void)clipRect;
-  msSetError(MS_RENDERERERR,"setClip not implemented","setClip()");
+  msSetError(MS_RENDERERERR, "setClip not implemented", "setClip()");
   return MS_FAILURE;
 }
-int resetClipDummy(imageObj *img)
-{
+int resetClipDummy(imageObj *img) {
   (void)img;
-  msSetError(MS_RENDERERERR,"resetClip not implemented","resetClip()");
+  msSetError(MS_RENDERERERR, "resetClip not implemented", "resetClip()");
   return MS_FAILURE;
 }
 
-int freeImageDummy(imageObj *image)
-{
+int freeImageDummy(imageObj *image) {
   (void)image;
-  msSetError(MS_RENDERERERR,"freeImage not implemented","freeImage()");
+  msSetError(MS_RENDERERERR, "freeImage not implemented", "freeImage()");
   return MS_FAILURE;
 }
 
-int freeTileDummy(imageObj *tile)
-{
+int freeTileDummy(imageObj *tile) {
   (void)tile;
-  msSetError(MS_RENDERERERR,"freeTile not implemented","freeTile()");
+  msSetError(MS_RENDERERERR, "freeTile not implemented", "freeTile()");
   return MS_FAILURE;
 }
 
-int freeSymbolDummy(symbolObj *symbol)
-{
+int freeSymbolDummy(symbolObj *symbol) {
   (void)symbol;
-  msSetError(MS_RENDERERERR,"freeSymbol not implemented","freeSymbol()");
+  msSetError(MS_RENDERERERR, "freeSymbol not implemented", "freeSymbol()");
   return MS_FAILURE;
 }
 
-int cleanupDummy(void *renderer_data)
-{
+int cleanupDummy(void *renderer_data) {
   (void)renderer_data;
   return MS_SUCCESS;
 }
 
-int msInitializeDummyRenderer(rendererVTableObj *renderer)
-{
+int msInitializeDummyRenderer(rendererVTableObj *renderer) {
 
   renderer->use_imagecache = 0;
   renderer->supports_pixel_buffer = 0;
@@ -375,15 +364,15 @@ int msInitializeDummyRenderer(rendererVT
   renderer->transform_mode = MS_TRANSFORM_SIMPLIFY;
   renderer->startLayer = &startLayerDummy;
   renderer->endLayer = &endLayerDummy;
-  renderer->renderLine=&renderLineDummy;
+  renderer->renderLine = &renderLineDummy;
   renderer->renderLineTiled = NULL;
-  renderer->createImage=&createImageDummy;
-  renderer->saveImage=&saveImageDummy;
-  renderer->getRasterBufferHandle=&getRasterBufferHandleDummy;
-  renderer->getRasterBufferCopy=getRasterBufferCopyDummy;
-  renderer->initializeRasterBuffer=initializeRasterBufferDummy;
-  renderer->renderPolygon=&renderPolygonDummy;
-  renderer->freeImage=&freeImageDummy;
+  renderer->createImage = &createImageDummy;
+  renderer->saveImage = &saveImageDummy;
+  renderer->getRasterBufferHandle = &getRasterBufferHandleDummy;
+  renderer->getRasterBufferCopy = getRasterBufferCopyDummy;
+  renderer->initializeRasterBuffer = initializeRasterBufferDummy;
+  renderer->renderPolygon = &renderPolygonDummy;
+  renderer->freeImage = &freeImageDummy;
   renderer->renderEllipseSymbol = &renderEllipseSymbolDummy;
   renderer->renderVectorSymbol = &renderVectorSymbolDummy;
   renderer->renderPixmapSymbol = &renderPixmapSymbolDummy;
@@ -397,5 +386,3 @@ int msInitializeDummyRenderer(rendererVT
   renderer->renderGlyphs = NULL;
   return MS_SUCCESS;
 }
-
-
diff -pruN 8.0.1-5/mapentities.h 8.0.2-1/mapentities.h
--- 8.0.1-5/mapentities.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapentities.h	2024-06-11 20:41:34.000000000 +0000
@@ -41,263 +41,74 @@
 extern "C" {
 #endif
 
-  static const struct mapentities_s {
-    const char  *name;
-    int value;
-  } mapentities[] = {
-    {"AElig", 198},
-    {"Aacute", 193},
-    {"Acirc", 194},
-    {"Agrave", 192},
-    {"Alpha", 913},
-    {"Aring", 197},
-    {"Atilde", 195},
-    {"Auml", 196},
-    {"Beta", 914},
-    {"Ccedil", 199},
-    {"Chi", 935},
-    {"Dagger", 8225},
-    {"Delta", 916},
-    {"ETH", 208},
-    {"Eacute", 201},
-    {"Ecirc", 202},
-    {"Egrave", 200},
-    {"Epsilon", 917},
-    {"Eta", 919},
-    {"Euml", 203},
-    {"Gamma", 915},
-    {"Iacute", 205},
-    {"Icirc", 206},
-    {"Igrave", 204},
-    {"Iota", 921},
-    {"Iuml", 207},
-    {"Kappa", 922},
-    {"Lambda", 923},
-    {"Mu", 924},
-    {"Ntilde", 209},
-    {"Nu", 925},
-    {"OElig", 338},
-    {"Oacute", 211},
-    {"Ocirc", 212},
-    {"Ograve", 210},
-    {"Omega", 937},
-    {"Omicron", 927},
-    {"Oslash", 216},
-    {"Otilde", 213},
-    {"Ouml", 214},
-    {"Phi", 934},
-    {"Pi", 928},
-    {"Prime", 8243},
-    {"Psi", 936},
-    {"Rho", 929},
-    {"Scaron", 352},
-    {"Sigma", 931},
-    {"THORN", 222},
-    {"Tau", 932},
-    {"Theta", 920},
-    {"Uacute", 218},
-    {"Ucirc", 219},
-    {"Ugrave", 217},
-    {"Upsilon", 933},
-    {"Uuml", 220},
-    {"Xi", 926},
-    {"Yacute", 221},
-    {"Yuml", 376},
-    {"Zeta", 918},
-    {"aacute", 225},
-    {"acirc", 226},
-    {"acute", 180},
-    {"aelig", 230},
-    {"agrave", 224},
-    {"alefsym", 8501},
-    {"alpha", 945},
-    {"amp", 38},
-    {"and", 8743},
-    {"ang", 8736},
-    {"aring", 229},
-    {"asymp", 8776},
-    {"atilde", 227},
-    {"auml", 228},
-    {"bdquo", 8222},
-    {"beta", 946},
-    {"brvbar", 166},
-    {"bull", 8226},
-    {"cap", 8745},
-    {"ccedil", 231},
-    {"cedil", 184},
-    {"cent", 162},
-    {"chi", 967},
-    {"circ", 710},
-    {"clubs", 9827},
-    {"cong", 8773},
-    {"copy", 169},
-    {"crarr", 8629},
-    {"cup", 8746},
-    {"curren", 164},
-    {"dArr", 8659},
-    {"dagger", 8224},
-    {"darr", 8595},
-    {"deg", 176},
-    {"delta", 948},
-    {"diams", 9830},
-    {"divide", 247},
-    {"eacute", 233},
-    {"ecirc", 234},
-    {"egrave", 232},
-    {"empty", 8709},
-    {"emsp", 8195},
-    {"ensp", 8194},
-    {"epsilon", 949},
-    {"equiv", 8801},
-    {"eta", 951},
-    {"eth", 240},
-    {"euml", 235},
-    {"euro", 8364},
-    {"exist", 8707},
-    {"fnof", 402},
-    {"forall", 8704},
-    {"frac12", 189},
-    {"frac14", 188},
-    {"frac34", 190},
-    {"frasl", 8260},
-    {"gamma", 947},
-    {"ge", 8805},
-    {"gt", 62},
-    {"hArr", 8660},
-    {"harr", 8596},
-    {"hearts", 9829},
-    {"hellip", 8230},
-    {"iacute", 237},
-    {"icirc", 238},
-    {"iexcl", 161},
-    {"igrave", 236},
-    {"image", 8465},
-    {"infin", 8734},
-    {"int", 8747},
-    {"iota", 953},
-    {"iquest", 191},
-    {"isin", 8712},
-    {"iuml", 239},
-    {"kappa", 954},
-    {"lArr", 8656},
-    {"lambda", 955},
-    {"lang", 9001},
-    {"laquo", 171},
-    {"larr", 8592},
-    {"lceil", 8968},
-    {"ldquo", 8220},
-    {"le", 8804},
-    {"lfloor", 8970},
-    {"lowast", 8727},
-    {"loz", 9674},
-    {"lrm", 8206},
-    {"lsaquo", 8249},
-    {"lsquo", 8216},
-    {"lt", 60},
-    {"macr", 175},
-    {"mdash", 8212},
-    {"micro", 181},
-    {"middot", 183},
-    {"minus", 8722},
-    {"mu", 956},
-    {"nabla", 8711},
-    {"nbsp", 160},
-    {"ndash", 8211},
-    {"ne", 8800},
-    {"ni", 8715},
-    {"not", 172},
-    {"notin", 8713},
-    {"nsub", 8836},
-    {"ntilde", 241},
-    {"nu", 957},
-    {"oacute", 243},
-    {"ocirc", 244},
-    {"oelig", 339},
-    {"ograve", 242},
-    {"oline", 8254},
-    {"omega", 969},
-    {"omicron", 959},
-    {"oplus", 8853},
-    {"or", 8744},
-    {"ordf", 170},
-    {"ordm", 186},
-    {"oslash", 248},
-    {"otilde", 245},
-    {"otimes", 8855},
-    {"ouml", 246},
-    {"para", 182},
-    {"part", 8706},
-    {"permil", 8240},
-    {"perp", 8869},
-    {"phi", 966},
-    {"pi", 960},
-    {"piv", 982},
-    {"plusmn", 177},
-    {"pound", 163},
-    {"prime", 8242},
-    {"prod", 8719},
-    {"prop", 8733},
-    {"psi", 968},
-    {"quot", 34},
-    {"rArr", 8658},
-    {"radic", 8730},
-    {"rang", 9002},
-    {"raquo", 187},
-    {"rarr", 8594},
-    {"rceil", 8969},
-    {"rdquo", 8221},
-    {"real", 8476},
-    {"reg", 174},
-    {"rfloor", 8971},
-    {"rho", 961},
-    {"rlm", 8207},
-    {"rsaquo", 8250},
-    {"rsquo", 8217},
-    {"sbquo", 8218},
-    {"scaron", 353},
-    {"sdot", 8901},
-    {"sect", 167},
-    {"shy", 173},
-    {"sigma", 963},
-    {"sigmaf", 962},
-    {"sim", 8764},
-    {"spades", 9824},
-    {"sub", 8834},
-    {"sube", 8838},
-    {"sum", 8721},
-    {"sup", 8835},
-    {"sup1", 185},
-    {"sup2", 178},
-    {"sup3", 179},
-    {"supe", 8839},
-    {"szlig", 223},
-    {"tau", 964},
-    {"there4", 8756},
-    {"theta", 952},
-    {"thetasym", 977},
-    {"thinsp", 8201},
-    {"thorn", 254},
-    {"tilde", 732},
-    {"times", 215},
-    {"trade", 8482},
-    {"uArr", 8657},
-    {"uacute", 250},
-    {"uarr", 8593},
-    {"ucirc", 251},
-    {"ugrave", 249},
-    {"uml", 168},
-    {"upsih", 978},
-    {"upsilon", 965},
-    {"uuml", 252},
-    {"weierp", 8472},
-    {"xi", 958},
-    {"yacute", 253},
-    {"yen", 165},
-    {"yuml", 255},
-    {"zeta", 950},
-    {"zwj", 8205},
-    {"zwnj", 8204},
-  };
+static const struct mapentities_s {
+  const char *name;
+  int value;
+} mapentities[] = {
+    {"AElig", 198},    {"Aacute", 193},   {"Acirc", 194},   {"Agrave", 192},
+    {"Alpha", 913},    {"Aring", 197},    {"Atilde", 195},  {"Auml", 196},
+    {"Beta", 914},     {"Ccedil", 199},   {"Chi", 935},     {"Dagger", 8225},
+    {"Delta", 916},    {"ETH", 208},      {"Eacute", 201},  {"Ecirc", 202},
+    {"Egrave", 200},   {"Epsilon", 917},  {"Eta", 919},     {"Euml", 203},
+    {"Gamma", 915},    {"Iacute", 205},   {"Icirc", 206},   {"Igrave", 204},
+    {"Iota", 921},     {"Iuml", 207},     {"Kappa", 922},   {"Lambda", 923},
+    {"Mu", 924},       {"Ntilde", 209},   {"Nu", 925},      {"OElig", 338},
+    {"Oacute", 211},   {"Ocirc", 212},    {"Ograve", 210},  {"Omega", 937},
+    {"Omicron", 927},  {"Oslash", 216},   {"Otilde", 213},  {"Ouml", 214},
+    {"Phi", 934},      {"Pi", 928},       {"Prime", 8243},  {"Psi", 936},
+    {"Rho", 929},      {"Scaron", 352},   {"Sigma", 931},   {"THORN", 222},
+    {"Tau", 932},      {"Theta", 920},    {"Uacute", 218},  {"Ucirc", 219},
+    {"Ugrave", 217},   {"Upsilon", 933},  {"Uuml", 220},    {"Xi", 926},
+    {"Yacute", 221},   {"Yuml", 376},     {"Zeta", 918},    {"aacute", 225},
+    {"acirc", 226},    {"acute", 180},    {"aelig", 230},   {"agrave", 224},
+    {"alefsym", 8501}, {"alpha", 945},    {"amp", 38},      {"and", 8743},
+    {"ang", 8736},     {"aring", 229},    {"asymp", 8776},  {"atilde", 227},
+    {"auml", 228},     {"bdquo", 8222},   {"beta", 946},    {"brvbar", 166},
+    {"bull", 8226},    {"cap", 8745},     {"ccedil", 231},  {"cedil", 184},
+    {"cent", 162},     {"chi", 967},      {"circ", 710},    {"clubs", 9827},
+    {"cong", 8773},    {"copy", 169},     {"crarr", 8629},  {"cup", 8746},
+    {"curren", 164},   {"dArr", 8659},    {"dagger", 8224}, {"darr", 8595},
+    {"deg", 176},      {"delta", 948},    {"diams", 9830},  {"divide", 247},
+    {"eacute", 233},   {"ecirc", 234},    {"egrave", 232},  {"empty", 8709},
+    {"emsp", 8195},    {"ensp", 8194},    {"epsilon", 949}, {"equiv", 8801},
+    {"eta", 951},      {"eth", 240},      {"euml", 235},    {"euro", 8364},
+    {"exist", 8707},   {"fnof", 402},     {"forall", 8704}, {"frac12", 189},
+    {"frac14", 188},   {"frac34", 190},   {"frasl", 8260},  {"gamma", 947},
+    {"ge", 8805},      {"gt", 62},        {"hArr", 8660},   {"harr", 8596},
+    {"hearts", 9829},  {"hellip", 8230},  {"iacute", 237},  {"icirc", 238},
+    {"iexcl", 161},    {"igrave", 236},   {"image", 8465},  {"infin", 8734},
+    {"int", 8747},     {"iota", 953},     {"iquest", 191},  {"isin", 8712},
+    {"iuml", 239},     {"kappa", 954},    {"lArr", 8656},   {"lambda", 955},
+    {"lang", 9001},    {"laquo", 171},    {"larr", 8592},   {"lceil", 8968},
+    {"ldquo", 8220},   {"le", 8804},      {"lfloor", 8970}, {"lowast", 8727},
+    {"loz", 9674},     {"lrm", 8206},     {"lsaquo", 8249}, {"lsquo", 8216},
+    {"lt", 60},        {"macr", 175},     {"mdash", 8212},  {"micro", 181},
+    {"middot", 183},   {"minus", 8722},   {"mu", 956},      {"nabla", 8711},
+    {"nbsp", 160},     {"ndash", 8211},   {"ne", 8800},     {"ni", 8715},
+    {"not", 172},      {"notin", 8713},   {"nsub", 8836},   {"ntilde", 241},
+    {"nu", 957},       {"oacute", 243},   {"ocirc", 244},   {"oelig", 339},
+    {"ograve", 242},   {"oline", 8254},   {"omega", 969},   {"omicron", 959},
+    {"oplus", 8853},   {"or", 8744},      {"ordf", 170},    {"ordm", 186},
+    {"oslash", 248},   {"otilde", 245},   {"otimes", 8855}, {"ouml", 246},
+    {"para", 182},     {"part", 8706},    {"permil", 8240}, {"perp", 8869},
+    {"phi", 966},      {"pi", 960},       {"piv", 982},     {"plusmn", 177},
+    {"pound", 163},    {"prime", 8242},   {"prod", 8719},   {"prop", 8733},
+    {"psi", 968},      {"quot", 34},      {"rArr", 8658},   {"radic", 8730},
+    {"rang", 9002},    {"raquo", 187},    {"rarr", 8594},   {"rceil", 8969},
+    {"rdquo", 8221},   {"real", 8476},    {"reg", 174},     {"rfloor", 8971},
+    {"rho", 961},      {"rlm", 8207},     {"rsaquo", 8250}, {"rsquo", 8217},
+    {"sbquo", 8218},   {"scaron", 353},   {"sdot", 8901},   {"sect", 167},
+    {"shy", 173},      {"sigma", 963},    {"sigmaf", 962},  {"sim", 8764},
+    {"spades", 9824},  {"sub", 8834},     {"sube", 8838},   {"sum", 8721},
+    {"sup", 8835},     {"sup1", 185},     {"sup2", 178},    {"sup3", 179},
+    {"supe", 8839},    {"szlig", 223},    {"tau", 964},     {"there4", 8756},
+    {"theta", 952},    {"thetasym", 977}, {"thinsp", 8201}, {"thorn", 254},
+    {"tilde", 732},    {"times", 215},    {"trade", 8482},  {"uArr", 8657},
+    {"uacute", 250},   {"uarr", 8593},    {"ucirc", 251},   {"ugrave", 249},
+    {"uml", 168},      {"upsih", 978},    {"upsilon", 965}, {"uuml", 252},
+    {"weierp", 8472},  {"xi", 958},       {"yacute", 253},  {"yen", 165},
+    {"yuml", 255},     {"zeta", 950},     {"zwj", 8205},    {"zwnj", 8204},
+};
 
 #define MAP_ENTITY_NAME_LENGTH_MAX 8
 #define MAP_NR_OF_ENTITIES 252
diff -pruN 8.0.1-5/maperror.c 8.0.2-1/maperror.c
--- 8.0.1-5/maperror.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/maperror.c	2024-06-11 20:41:34.000000000 +0000
@@ -41,58 +41,58 @@
 
 #include "cpl_conv.h"
 
-static char *const ms_errorCodes[MS_NUMERRORCODES] = { "",
-  "Unable to access file.",
-  "Memory allocation error.",
-  "Incorrect data type.",
-  "Symbol definition error.",
-  "Regular expression error.",
-  "TrueType Font error.",
-  "DBASE file error.",
-  "GD library error.",
-  "Unknown identifier.",
-  "Premature End-of-File.",
-  "Projection library error.",
-  "General error message.",
-  "CGI error.",
-  "Web application error.",
-  "Image handling error.",
-  "Hash table error.",
-  "Join error.",
-  "Search returned no results.",
-  "Shapefile error.",
-  "Expression parser error.",
-  "SDE error.",
-  "OGR error.",
-  "Query error.",
-  "WMS server error.",
-  "WMS connection error.",
-  "OracleSpatial error.",
-  "WFS server error.",
-  "WFS connection error.",
-  "WMS Map Context error.",
-  "HTTP request error.",
-  "Child array error.",
-  "WCS server error.",
-  "GEOS library error.",
-  "Invalid rectangle.",
-  "Date/time error.",
-  "GML encoding error.",
-  "SOS server error.",
-  "NULL parent pointer error.",
-  "AGG library error.",
-  "OWS error.",
-  "OpenGL renderer error.",
-  "Renderer error.",
-  "V8 engine error.",
-  "OCG API error."
-};
+static char *const ms_errorCodes[MS_NUMERRORCODES] = {
+    "",
+    "Unable to access file.",
+    "Memory allocation error.",
+    "Incorrect data type.",
+    "Symbol definition error.",
+    "Regular expression error.",
+    "TrueType Font error.",
+    "DBASE file error.",
+    "GD library error.",
+    "Unknown identifier.",
+    "Premature End-of-File.",
+    "Projection library error.",
+    "General error message.",
+    "CGI error.",
+    "Web application error.",
+    "Image handling error.",
+    "Hash table error.",
+    "Join error.",
+    "Search returned no results.",
+    "Shapefile error.",
+    "Expression parser error.",
+    "SDE error.",
+    "OGR error.",
+    "Query error.",
+    "WMS server error.",
+    "WMS connection error.",
+    "OracleSpatial error.",
+    "WFS server error.",
+    "WFS connection error.",
+    "WMS Map Context error.",
+    "HTTP request error.",
+    "Child array error.",
+    "WCS server error.",
+    "GEOS library error.",
+    "Invalid rectangle.",
+    "Date/time error.",
+    "GML encoding error.",
+    "SOS server error.",
+    "NULL parent pointer error.",
+    "AGG library error.",
+    "OWS error.",
+    "OpenGL renderer error.",
+    "Renderer error.",
+    "V8 engine error.",
+    "OCG API error.",
+    "Flatgeobuf error."};
 
 #ifndef USE_THREAD
 
 // Get the MapServer error object
-errorObj *msGetErrorObj()
-{
+errorObj *msGetErrorObj() {
   static errorObj ms_error = {MS_NOERR, "", "", MS_FALSE, 0, NULL};
   return &ms_error;
 }
@@ -108,33 +108,33 @@ typedef struct te_info {
 
 static te_info_t *error_list = NULL;
 
-errorObj *msGetErrorObj()
-{
+errorObj *msGetErrorObj() {
   te_info_t *link;
   void *thread_id;
   errorObj *ret_obj;
 
-  msAcquireLock( TLOCK_ERROROBJ );
+  msAcquireLock(TLOCK_ERROROBJ);
 
   thread_id = msGetThreadId();
 
   /* find link for this thread */
 
-  for( link = error_list;
-       link != NULL && link->thread_id != thread_id
-       && link->next != NULL && link->next->thread_id != thread_id;
-       link = link->next ) {}
+  for (link = error_list;
+       link != NULL && link->thread_id != thread_id && link->next != NULL &&
+       link->next->thread_id != thread_id;
+       link = link->next) {
+  }
 
   /* If the target thread link is already at the head of the list were ok */
-  if( error_list != NULL && error_list->thread_id == thread_id ) {
+  if (error_list != NULL && error_list->thread_id == thread_id) {
   }
 
   /* We don't have one ... initialize one. */
-  else if( link == NULL || link->next == NULL ) {
+  else if (link == NULL || link->next == NULL) {
     te_info_t *new_link;
-    errorObj   error_obj = { MS_NOERR, "", "", 0, 0, NULL, 0 };
+    errorObj error_obj = {MS_NOERR, "", "", 0, 0, NULL, 0};
 
-    new_link = (te_info_t *) malloc(sizeof(te_info_t));
+    new_link = (te_info_t *)malloc(sizeof(te_info_t));
     new_link->next = error_list;
     new_link->thread_id = thread_id;
     new_link->ms_error = error_obj;
@@ -153,7 +153,7 @@ errorObj *msGetErrorObj()
 
   ret_obj = &(error_list->ms_error);
 
-  msReleaseLock( TLOCK_ERROROBJ );
+  msReleaseLock(TLOCK_ERROROBJ);
 
   return ret_obj;
 }
@@ -175,8 +175,7 @@ errorObj *msGetErrorObj()
 ** the head is moved to the new errorObj, freeing the head errorObj to receive
 ** the new error information.
 */
-static errorObj *msInsertErrorObj(void)
-{
+static errorObj *msInsertErrorObj(void) {
   errorObj *ms_error;
   ms_error = msGetErrorObj();
 
@@ -196,8 +195,10 @@ static errorObj *msInsertErrorObj(void)
       new_error->next = ms_error->next;
       new_error->code = ms_error->code;
       new_error->isreported = ms_error->isreported;
-      strlcpy(new_error->routine, ms_error->routine, sizeof(new_error->routine));
-      strlcpy(new_error->message, ms_error->message, sizeof(new_error->message));
+      strlcpy(new_error->routine, ms_error->routine,
+              sizeof(new_error->routine));
+      strlcpy(new_error->message, ms_error->message,
+              sizeof(new_error->message));
       new_error->errorcount = ms_error->errorcount;
 
       ms_error->next = new_error;
@@ -207,7 +208,7 @@ static errorObj *msInsertErrorObj(void)
       ms_error->message[0] = '\0';
       ms_error->errorcount = 0;
     }
-    ms_error->totalerrorcount ++;
+    ms_error->totalerrorcount++;
   }
 
   return ms_error;
@@ -217,13 +218,12 @@ static errorObj *msInsertErrorObj(void)
 **
 ** Clear the list of error objects.
 */
-void msResetErrorList()
-{
+void msResetErrorList() {
   errorObj *ms_error, *this_error;
   ms_error = msGetErrorObj();
 
   this_error = ms_error->next;
-  while( this_error != NULL) {
+  while (this_error != NULL) {
     errorObj *next_error;
 
     next_error = this_error->next;
@@ -245,41 +245,41 @@ void msResetErrorList()
   /* -------------------------------------------------------------------- */
 #ifdef USE_THREAD
   {
-    void*  thread_id = msGetThreadId();
+    void *thread_id = msGetThreadId();
     te_info_t *link;
 
-    msAcquireLock( TLOCK_ERROROBJ );
+    msAcquireLock(TLOCK_ERROROBJ);
 
     /* find link for this thread */
 
-    for( link = error_list;
-         link != NULL && link->thread_id != thread_id
-         && link->next != NULL && link->next->thread_id != thread_id;
-         link = link->next ) {}
+    for (link = error_list;
+         link != NULL && link->thread_id != thread_id && link->next != NULL &&
+         link->next->thread_id != thread_id;
+         link = link->next) {
+    }
 
-    if( link->thread_id == thread_id ) {
+    if (link->thread_id == thread_id) {
       /* presumably link is at head of list.  */
-      if( error_list == link )
+      if (error_list == link)
         error_list = link->next;
 
-      free( link );
-    } else if( link->next != NULL && link->next->thread_id == thread_id ) {
+      free(link);
+    } else if (link->next != NULL && link->next->thread_id == thread_id) {
       te_info_t *next_link = link->next;
       link->next = link->next->next;
-      free( next_link );
+      free(next_link);
     }
-    msReleaseLock( TLOCK_ERROROBJ );
+    msReleaseLock(TLOCK_ERROROBJ);
   }
 #endif
 }
 
-char *msGetErrorCodeString(int code)
-{
+char *msGetErrorCodeString(int code) {
 
-  if(code<0 || code>MS_NUMERRORCODES-1)
-    return("Invalid error code.");
+  if (code < 0 || code > MS_NUMERRORCODES - 1)
+    return ("Invalid error code.");
 
-  return(ms_errorCodes[code]);
+  return (ms_errorCodes[code]);
 }
 
 /* -------------------------------------------------------------------- */
@@ -287,63 +287,72 @@ char *msGetErrorCodeString(int code)
 /*      and reallocates the memory enough to hold the characters.       */
 /*      If source is null returns a newly allocated string              */
 /* -------------------------------------------------------------------- */
-char *msAddErrorDisplayString(char *source, errorObj *error)
-{
-  if((source = msStringConcatenate(source, error->routine)) == NULL) return(NULL);
-  if((source = msStringConcatenate(source, ": ")) == NULL) return(NULL);
-  if((source = msStringConcatenate(source, ms_errorCodes[error->code])) == NULL) return(NULL);
-  if((source = msStringConcatenate(source, " ")) == NULL) return(NULL);
-  if((source = msStringConcatenate(source, error->message)) == NULL) return(NULL);
+char *msAddErrorDisplayString(char *source, errorObj *error) {
+  if ((source = msStringConcatenate(source, error->routine)) == NULL)
+    return (NULL);
+  if ((source = msStringConcatenate(source, ": ")) == NULL)
+    return (NULL);
+  if ((source = msStringConcatenate(source, ms_errorCodes[error->code])) ==
+      NULL)
+    return (NULL);
+  if ((source = msStringConcatenate(source, " ")) == NULL)
+    return (NULL);
+  if ((source = msStringConcatenate(source, error->message)) == NULL)
+    return (NULL);
   if (error->errorcount > 0) {
-    char* pszTmp;
-    if((source = msStringConcatenate(source, " (message repeated ")) == NULL) return(NULL);
+    char *pszTmp;
+    if ((source = msStringConcatenate(source, " (message repeated ")) == NULL)
+      return (NULL);
     pszTmp = msIntToString(error->errorcount);
-    if((source = msStringConcatenate(source, pszTmp)) == NULL) {
+    if ((source = msStringConcatenate(source, pszTmp)) == NULL) {
       msFree(pszTmp);
-      return(NULL);
+      return (NULL);
     }
     msFree(pszTmp);
-    if((source = msStringConcatenate(source, " times)")) == NULL) return(NULL);
+    if ((source = msStringConcatenate(source, " times)")) == NULL)
+      return (NULL);
   }
 
   return source;
 }
 
-char *msGetErrorString(const char *delimiter)
-{
-  char *errstr=NULL;
+char *msGetErrorString(const char *delimiter) {
+  char *errstr = NULL;
 
   errorObj *error = msGetErrorObj();
 
-  if(!delimiter || !error) return(NULL);
+  if (!delimiter || !error)
+    return (NULL);
 
-  while(error && error->code != MS_NOERR) {
-    if((errstr = msAddErrorDisplayString(errstr, error)) == NULL) return(NULL);
-
-    if(error->next && error->next->code != MS_NOERR) { /* (peek ahead) more errors, use delimiter */
-      if((errstr = msStringConcatenate(errstr, delimiter)) == NULL) return(NULL);
+  while (error && error->code != MS_NOERR) {
+    if ((errstr = msAddErrorDisplayString(errstr, error)) == NULL)
+      return (NULL);
+
+    if (error->next &&
+        error->next->code !=
+            MS_NOERR) { /* (peek ahead) more errors, use delimiter */
+      if ((errstr = msStringConcatenate(errstr, delimiter)) == NULL)
+        return (NULL);
     }
     error = error->next;
   }
 
-  return(errstr);
+  return (errstr);
 }
 
-void msRedactString(char* str, const char* keyword, const char delimeter)
-{
+void msRedactString(char *str, const char *keyword, const char delimeter) {
 
-    char* password = strstr(str, keyword);
-    if (password != NULL) {
-        char* ptr = password + strlen(keyword);
-        while (*ptr != '\0' && *ptr != delimeter) {
-            *ptr = '*';
-            ptr++;
-        }
+  char *password = strstr(str, keyword);
+  if (password != NULL) {
+    char *ptr = password + strlen(keyword);
+    while (*ptr != '\0' && *ptr != delimeter) {
+      *ptr = '*';
+      ptr++;
     }
+  }
 }
 
-void msRedactCredentials(char* str)
-{
+void msRedactCredentials(char *str) {
 
   // postgres formats
   msRedactString(str, "password=", ' ');
@@ -353,58 +362,56 @@ void msRedactCredentials(char* str)
   msRedactString(str, "pwd=", ';');
 }
 
-void msSetError(int code, const char *message_fmt, const char *routine, ...)
-{
+void msSetError(int code, const char *message_fmt, const char *routine, ...) {
   errorObj *ms_error;
   va_list args;
   char message[MESSAGELENGTH];
 
-  if(!message_fmt)
+  if (!message_fmt)
     strcpy(message, "");
   else {
     va_start(args, routine);
-    vsnprintf( message, MESSAGELENGTH, message_fmt, args );
+    vsnprintf(message, MESSAGELENGTH, message_fmt, args);
     va_end(args);
   }
 
   ms_error = msGetErrorObj();
 
   /* Insert the error to the list if it is not the same as the previous error*/
-  if (ms_error->code != code || !EQUAL(message, ms_error->message) || 
-                     !EQUAL(routine, ms_error->routine)) {
-      ms_error = msInsertErrorObj();
-      if(!routine)
-        strcpy(ms_error->routine, "");
-      else {
-        strlcpy(ms_error->routine, routine, sizeof(ms_error->routine));
-      }
-      strlcpy(ms_error->message, message, sizeof(ms_error->message));
-      ms_error->code = code;
-      ms_error->errorcount = 0;
-  }
-  else
-      ++ms_error->errorcount;
+  if (ms_error->code != code || !EQUAL(message, ms_error->message) ||
+      !EQUAL(routine, ms_error->routine)) {
+    ms_error = msInsertErrorObj();
+    if (!routine)
+      strcpy(ms_error->routine, "");
+    else {
+      strlcpy(ms_error->routine, routine, sizeof(ms_error->routine));
+    }
+    strlcpy(ms_error->message, message, sizeof(ms_error->message));
+    ms_error->code = code;
+    ms_error->errorcount = 0;
+  } else
+    ++ms_error->errorcount;
 
   msRedactCredentials(ms_error->message);
 
-  /* Log a copy of errors to MS_ERRORFILE if set (handled automatically inside msDebug()) */
-  msDebug("%s: %s %s\n", ms_error->routine, ms_errorCodes[ms_error->code], ms_error->message);
-
+  /* Log a copy of errors to MS_ERRORFILE if set (handled automatically inside
+   * msDebug()) */
+  msDebug("%s: %s %s\n", ms_error->routine, ms_errorCodes[ms_error->code],
+          ms_error->message);
 }
 
-void msWriteError(FILE *stream)
-{
+void msWriteError(FILE *stream) {
   errorObj *ms_error = msGetErrorObj();
 
   while (ms_error && ms_error->code != MS_NOERR) {
-    msIO_fprintf(stream, "%s: %s %s <br>\n", ms_error->routine, ms_errorCodes[ms_error->code], ms_error->message);
+    msIO_fprintf(stream, "%s: %s %s <br>\n", ms_error->routine,
+                 ms_errorCodes[ms_error->code], ms_error->message);
     ms_error->isreported = MS_TRUE;
     ms_error = ms_error->next;
   }
 }
 
-void msWriteErrorXML(FILE *stream)
-{
+void msWriteErrorXML(FILE *stream) {
   char *message;
   errorObj *ms_error = msGetErrorObj();
 
@@ -420,28 +427,28 @@ void msWriteErrorXML(FILE *stream)
   }
 }
 
-void msWriteErrorImage(mapObj *map, char *filename, int blank)
-{
+void msWriteErrorImage(mapObj *map, char *filename, int blank) {
   imageObj *img;
-  int width=400, height=300;
-  const int nMargin =5;
+  int width = 400, height = 300;
+  const int nMargin = 5;
 
   char **papszLines = NULL;
-  pointObj pnt = { 0 };
+  pointObj pnt = {0};
   outputFormatObj *format = NULL;
   char *errormsg = msGetErrorString("; ");
   errorObj *error = msGetErrorObj();
   char *imagepath = NULL, *imageurl = NULL;
-  colorObj imagecolor, *imagecolorptr=NULL;
+  colorObj imagecolor, *imagecolorptr = NULL;
   textSymbolObj ts;
   labelObj label;
-  int charWidth = 5, charHeight = 8; /* hardcoded, should be looked up from ft face */
-  if(!errormsg) {
+  int charWidth = 5,
+      charHeight = 8; /* hardcoded, should be looked up from ft face */
+  if (!errormsg) {
     errormsg = msStrdup("No error found sorry. This is likely a bug");
   }
 
   if (map) {
-    if( map->width > 0 && map->height > 0 ) {
+    if (map->width > 0 && map->height > 0) {
       width = map->width;
       height = map->height;
     }
@@ -452,68 +459,73 @@ void msWriteErrorImage(mapObj *map, char
 
   /* Default to GIF if no suitable GD output format set */
   if (format == NULL || !MS_RENDERER_PLUGIN(format))
-    format = msCreateDefaultOutputFormat( NULL, "AGG/PNG8", "png", NULL );
+    format = msCreateDefaultOutputFormat(NULL, "AGG/PNG8", "png", NULL);
 
-  if(!format->transparent) {
-    if(map && MS_VALID_COLOR(map->imagecolor)) {
+  if (!format->transparent) {
+    if (map && MS_VALID_COLOR(map->imagecolor)) {
       imagecolorptr = &map->imagecolor;
     } else {
-      MS_INIT_COLOR(imagecolor,255,255,255,255);
+      MS_INIT_COLOR(imagecolor, 255, 255, 255, 255);
       imagecolorptr = &imagecolor;
     }
   }
 
-  img = msImageCreate(width,height,format,imagepath,imageurl,MS_DEFAULT_RESOLUTION,MS_DEFAULT_RESOLUTION,imagecolorptr);
+  img = msImageCreate(width, height, format, imagepath, imageurl,
+                      MS_DEFAULT_RESOLUTION, MS_DEFAULT_RESOLUTION,
+                      imagecolorptr);
 
   const int nTextLength = strlen(errormsg);
-  const int nWidthTxt  =  nTextLength * charWidth;
-  const int nUsableWidth = width - (nMargin*2);
+  const int nWidthTxt = nTextLength * charWidth;
+  const int nUsableWidth = width - (nMargin * 2);
 
-  /* Check to see if it all fits on one line. If not, split the text on several lines. */
-  if(!blank) {
+  /* Check to see if it all fits on one line. If not, split the text on several
+   * lines. */
+  if (!blank) {
     int nLines;
     if (nWidthTxt > nUsableWidth) {
-      const int nMaxCharsPerLine =  nUsableWidth/charWidth;
-      nLines = (int) ceil ((double)nTextLength / (double)nMaxCharsPerLine);
+      const int nMaxCharsPerLine = nUsableWidth / charWidth;
+      nLines = (int)ceil((double)nTextLength / (double)nMaxCharsPerLine);
       if (nLines > 0) {
-        papszLines = (char **)malloc(nLines*sizeof(char *));
-        for (int i=0; i<nLines; i++) {
-          papszLines[i] = (char *)malloc((nMaxCharsPerLine+1)*sizeof(char));
+        papszLines = (char **)malloc(nLines * sizeof(char *));
+        for (int i = 0; i < nLines; i++) {
+          papszLines[i] = (char *)malloc((nMaxCharsPerLine + 1) * sizeof(char));
           papszLines[i][0] = '\0';
         }
       }
-      for (int i=0; i<nLines; i++) {
-        const int nStart = i*nMaxCharsPerLine;
+      for (int i = 0; i < nLines; i++) {
+        const int nStart = i * nMaxCharsPerLine;
         int nEnd = nStart + nMaxCharsPerLine;
         if (nStart < nTextLength) {
           if (nEnd > nTextLength)
             nEnd = nTextLength;
-          const int nLength = nEnd-nStart;
+          const int nLength = nEnd - nStart;
 
-          strncpy(papszLines[i], errormsg+nStart, nLength);
+          strncpy(papszLines[i], errormsg + nStart, nLength);
           papszLines[i][nLength] = '\0';
         }
       }
     } else {
       nLines = 1;
-      papszLines = (char **)malloc(nLines*sizeof(char *));
+      papszLines = (char **)malloc(nLines * sizeof(char *));
       papszLines[0] = msStrdup(errormsg);
     }
     initLabel(&label);
-    MS_INIT_COLOR(label.color,0,0,0,255);
-    MS_INIT_COLOR(label.outlinecolor,255,255,255,255);
+    MS_INIT_COLOR(label.color, 0, 0, 0, 255);
+    MS_INIT_COLOR(label.outlinecolor, 255, 255, 255, 255);
     label.outlinewidth = 1;
 
     label.size = MS_SMALL;
     MS_REFCNT_INCR((&label));
-    for (int i=0; i<nLines; i++) {
-      pnt.y = charHeight * ((i*2) +1);
+    for (int i = 0; i < nLines; i++) {
+      pnt.y = charHeight * ((i * 2) + 1);
       pnt.x = charWidth;
       initTextSymbol(&ts);
-      msPopulateTextSymbolForLabelAndString(&ts,&label,papszLines[i],1,1,0);
-      if(MS_LIKELY(MS_SUCCESS == msComputeTextPath(map,&ts))) {
-        if(MS_SUCCESS!=msDrawTextSymbol(NULL,img,pnt,&ts)) {
-          /* an error occured, but there's nothing much we can do about it here as we are already handling an error condition */
+      msPopulateTextSymbolForLabelAndString(&ts, &label, papszLines[i], 1, 1,
+                                            0);
+      if (MS_LIKELY(MS_SUCCESS == msComputeTextPath(map, &ts))) {
+        if (MS_SUCCESS != msDrawTextSymbol(NULL, img, pnt, &ts)) {
+          /* an error occured, but there's nothing much we can do about it here
+           * as we are already handling an error condition */
         }
         freeTextSymbol(&ts);
       }
@@ -524,15 +536,15 @@ void msWriteErrorImage(mapObj *map, char
   }
 
   /* actually write the image */
-  if(!filename) {
-    msIO_setHeader("Content-Type","%s", MS_IMAGE_MIME_TYPE(format));
+  if (!filename) {
+    msIO_setHeader("Content-Type", "%s", MS_IMAGE_MIME_TYPE(format));
     msIO_sendHeaders();
   }
-  msSaveImage(NULL,img,filename);
+  msSaveImage(NULL, img, filename);
   msFreeImage(img);
 
   /* the errors are reported */
-  while(error && error->code != MS_NOERR) {
+  while (error && error->code != MS_NOERR) {
     error->isreported = MS_TRUE;
     error = error->next;
   }
@@ -542,19 +554,22 @@ void msWriteErrorImage(mapObj *map, char
   msFree(errormsg);
 }
 
-char *msGetVersion()
-{
+char *msGetVersion() {
   static char version[2048];
 
   sprintf(version, "MapServer version %s", MS_VERSION);
 
   // add versions of required dependencies
+#if PROJ_VERSION_MAJOR >= 6
   static char PROJVersion[20];
-  sprintf(PROJVersion, " PROJ version %d.%d", PROJ_VERSION_MAJOR, PROJ_VERSION_MINOR);
+  sprintf(PROJVersion, " PROJ version %d.%d", PROJ_VERSION_MAJOR,
+          PROJ_VERSION_MINOR);
   strcat(version, PROJVersion);
+#endif
 
   static char GDALVersion[20];
-  sprintf(GDALVersion, " GDAL version %d.%d", GDAL_VERSION_MAJOR, GDAL_VERSION_MINOR);
+  sprintf(GDALVersion, " GDAL version %d.%d", GDAL_VERSION_MAJOR,
+          GDAL_VERSION_MINOR);
   strcat(version, GDALVersion);
 
 #if (defined USE_PNG)
@@ -574,11 +589,11 @@ char *msGetVersion()
 #endif
 #if defined(USE_SVG_CAIRO) || defined(USE_RSVG)
   strcat(version, " SUPPORTS=SVG_SYMBOLS");
-  #ifdef USE_SVG_CAIRO
-    strcat(version, " SUPPORTS=SVGCAIRO");
-  #else
-    strcat(version, " SUPPORTS=RSVG");
-  #endif
+#ifdef USE_SVG_CAIRO
+  strcat(version, " SUPPORTS=SVGCAIRO");
+#else
+  strcat(version, " SUPPORTS=RSVG");
+#endif
 #endif
 #ifdef USE_OGL
   strcat(version, " SUPPORTS=OPENGL");
@@ -644,10 +659,7 @@ char *msGetVersion()
   strcat(version, " INPUT=GDAL");
   strcat(version, " INPUT=SHAPEFILE");
   strcat(version, " INPUT=FLATGEOBUF");
-  return(version);
+  return (version);
 }
 
-int msGetVersionInt()
-{
-  return MS_VERSION_NUM;
-}
+int msGetVersionInt() { return MS_VERSION_NUM; }
diff -pruN 8.0.1-5/maperror.h 8.0.2-1/maperror.h
--- 8.0.1-5/maperror.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/maperror.h	2024-06-11 20:41:34.000000000 +0000
@@ -36,9 +36,9 @@
 extern "C" {
 #endif
 
-  /*====================================================================
-   *   maperror.c
-   *====================================================================*/
+/*====================================================================
+ *   maperror.c
+ *====================================================================*/
 
 #define MS_NOERR 0 /* general error codes */
 #define MS_IOERR 1
@@ -63,14 +63,14 @@ extern "C" {
 #define MS_UNUSEDERR 21
 #define MS_OGRERR 22
 #define MS_QUERYERR 23
-#define MS_WMSERR 24      /* WMS server error */
-#define MS_WMSCONNERR 25  /* WMS connectiontype error */
+#define MS_WMSERR 24     /* WMS server error */
+#define MS_WMSCONNERR 25 /* WMS connectiontype error */
 #define MS_ORACLESPATIALERR 26
-#define MS_WFSERR 27      /* WFS server error */
-#define MS_WFSCONNERR 28  /* WFS connectiontype error */
+#define MS_WFSERR 27        /* WFS server error */
+#define MS_WFSCONNERR 28    /* WFS connectiontype error */
 #define MS_MAPCONTEXTERR 29 /* Map Context error */
 #define MS_HTTPERR 30
-#define MS_CHILDERR 31    /* Errors involving arrays of child objects */
+#define MS_CHILDERR 31 /* Errors involving arrays of child objects */
 #define MS_WCSERR 32
 #define MS_GEOSERR 33
 #define MS_RECTERR 34
@@ -93,117 +93,129 @@ extern "C" {
 #define MS_ERROR_LANGUAGE "en-US"
 
 #if defined(_WIN32) && !defined(__CYGWIN__)
-#  define MS_DLL_EXPORT     __declspec(dllexport)
+#define MS_DLL_EXPORT __declspec(dllexport)
 #else
-#define  MS_DLL_EXPORT
+#define MS_DLL_EXPORT
 #endif
 
 #ifndef MS_PRINT_FUNC_FORMAT
 #if defined(__GNUC__) && __GNUC__ >= 3 && !defined(DOXYGEN_SKIP)
-#define MS_PRINT_FUNC_FORMAT( format_idx, arg_idx )  __attribute__((__format__ (__printf__, format_idx, arg_idx)))
+#define MS_PRINT_FUNC_FORMAT(format_idx, arg_idx)                              \
+  __attribute__((__format__(__printf__, format_idx, arg_idx)))
 #else
-#define MS_PRINT_FUNC_FORMAT( format_idx, arg_idx )
+#define MS_PRINT_FUNC_FORMAT(format_idx, arg_idx)
 #endif
 #endif
 
 /**
-This class allows inspection of the MapServer error stack. 
-Instances of errorObj are created internally by MapServer as errors happen. 
-Errors are managed as a chained list with the first item being the most recent error.
-*/
-  typedef struct errorObj {
-    int code; ///< MapServer error code such as :data:`MS_IMGERR`
-    char routine[ROUTINELENGTH]; ///< MapServer function in which the error was set
-    char message[MESSAGELENGTH]; ///< Context-dependent error message
-    int isreported; ///< :data:`MS_TRUE` or :data:`MS_FALSE` flag indicating if the error has been output
-    int errorcount; ///< Number of subsequent errors
+This class allows inspection of the MapServer error stack.
+Instances of errorObj are created internally by MapServer as errors happen.
+Errors are managed as a chained list with the first item being the most recent
+error.
+*/
+typedef struct errorObj {
+  int code; ///< MapServer error code such as :data:`MS_IMGERR`
+  char
+      routine[ROUTINELENGTH]; ///< MapServer function in which the error was set
+  char message[MESSAGELENGTH]; ///< Context-dependent error message
+  int isreported; ///< :data:`MS_TRUE` or :data:`MS_FALSE` flag indicating if
+                  ///< the error has been output
+  int errorcount; ///< Number of subsequent errors
 #ifndef SWIG
-    struct errorObj *next;
-    int totalerrorcount;
+  struct errorObj *next;
+  int totalerrorcount;
 #endif
-  } errorObj;
+} errorObj;
 
-  /*
-  ** Function prototypes
-  */
-
-  /**
-  Get the MapServer error object
-  */
-  MS_DLL_EXPORT errorObj *msGetErrorObj(void);
-  /**
-  Clear the list of error objects
-  */
-  MS_DLL_EXPORT void msResetErrorList(void);
-  /**
-  Returns a string containing MapServer version information, and details on what optional components 
-  are built in - the same report as produced by ``mapserv -v``
-  */
-  MS_DLL_EXPORT char *msGetVersion(void);
-  /**
-  Returns the MapServer version number (x.y.z) as an integer (x*10000 + y*100 + z) 
-  e.g. V7.4.2 would return 70402
-  */
-  MS_DLL_EXPORT int  msGetVersionInt(void);
-  /**
-  Return a string of all errors
-  */
-  MS_DLL_EXPORT char *msGetErrorString(const char *delimiter);
+/*
+** Function prototypes
+*/
 
-#ifndef SWIG
-  MS_DLL_EXPORT void msRedactCredentials(char* str);
-  MS_DLL_EXPORT void msSetError(int code, const char *message, const char *routine, ...) MS_PRINT_FUNC_FORMAT(2,4) ;
-  MS_DLL_EXPORT void msWriteError(FILE *stream);
-  MS_DLL_EXPORT void msWriteErrorXML(FILE *stream);
-  MS_DLL_EXPORT char *msGetErrorCodeString(int code);
-  MS_DLL_EXPORT char *msAddErrorDisplayString(char *source, errorObj *error);
+/**
+Get the MapServer error object
+*/
+MS_DLL_EXPORT errorObj *msGetErrorObj(void);
+/**
+Clear the list of error objects
+*/
+MS_DLL_EXPORT void msResetErrorList(void);
+/**
+Returns a string containing MapServer version information, and details on what
+optional components are built in - the same report as produced by ``mapserv -v``
+*/
+MS_DLL_EXPORT char *msGetVersion(void);
+/**
+Returns the MapServer version number (x.y.z) as an integer (x*10000 + y*100 + z)
+e.g. V7.4.2 would return 70402
+*/
+MS_DLL_EXPORT int msGetVersionInt(void);
+/**
+Return a string of all errors
+*/
+MS_DLL_EXPORT char *msGetErrorString(const char *delimiter);
 
-  struct mapObj;
-  MS_DLL_EXPORT void msWriteErrorImage(struct mapObj *map, char *filename, int blank);
+#ifndef SWIG
+MS_DLL_EXPORT void msRedactCredentials(char *str);
+MS_DLL_EXPORT void msSetError(int code, const char *message,
+                              const char *routine, ...)
+    MS_PRINT_FUNC_FORMAT(2, 4);
+MS_DLL_EXPORT void msWriteError(FILE *stream);
+MS_DLL_EXPORT void msWriteErrorXML(FILE *stream);
+MS_DLL_EXPORT char *msGetErrorCodeString(int code);
+MS_DLL_EXPORT char *msAddErrorDisplayString(char *source, errorObj *error);
+
+struct mapObj;
+MS_DLL_EXPORT void msWriteErrorImage(struct mapObj *map, char *filename,
+                                     int blank);
 
 #endif /* SWIG */
 
-  /*====================================================================
-   *   mapdebug.c (See also MS-RFC-28)
-   *====================================================================*/
-
-  typedef enum { MS_DEBUGLEVEL_ERRORSONLY = 0,  /* DEBUG OFF, log fatal errors */
-                 MS_DEBUGLEVEL_DEBUG      = 1,  /* DEBUG ON */
-                 MS_DEBUGLEVEL_TUNING     = 2,  /* Reports timing info */
-                 MS_DEBUGLEVEL_V          = 3,  /* Verbose */
-                 MS_DEBUGLEVEL_VV         = 4,  /* Very verbose */
-                 MS_DEBUGLEVEL_VVV        = 5,  /* Very very verbose */
-                 MS_DEBUGLEVEL_DEVDEBUG   = 20, /* Undocumented, will trigger debug messages only useful for developers */
-               } debugLevel;
+/*====================================================================
+ *   mapdebug.c (See also MS-RFC-28)
+ *====================================================================*/
+
+typedef enum {
+  MS_DEBUGLEVEL_ERRORSONLY = 0, /* DEBUG OFF, log fatal errors */
+  MS_DEBUGLEVEL_DEBUG = 1,      /* DEBUG ON */
+  MS_DEBUGLEVEL_TUNING = 2,     /* Reports timing info */
+  MS_DEBUGLEVEL_V = 3,          /* Verbose */
+  MS_DEBUGLEVEL_VV = 4,         /* Very verbose */
+  MS_DEBUGLEVEL_VVV = 5,        /* Very very verbose */
+  MS_DEBUGLEVEL_DEVDEBUG = 20, /* Undocumented, will trigger debug messages only
+                                  useful for developers */
+} debugLevel;
 
 #ifndef SWIG
 
-  typedef enum { MS_DEBUGMODE_OFF,
-                 MS_DEBUGMODE_FILE,
-                 MS_DEBUGMODE_STDERR,
-                 MS_DEBUGMODE_STDOUT,
-                 MS_DEBUGMODE_WINDOWSDEBUG
-               } debugMode;
-
-  typedef struct debug_info_obj {
-    debugLevel  global_debug_level;
-    debugMode   debug_mode;
-    char        *errorfile;
-    FILE        *fp;
-    /* The following 2 members are used only with USE_THREAD (but we won't #ifndef them) */
-    void* thread_id;
-    struct debug_info_obj *next;
-  } debugInfoObj;
-
-
-  MS_DLL_EXPORT void msDebug( const char * pszFormat, ... ) MS_PRINT_FUNC_FORMAT(1,2) ;
-  MS_DLL_EXPORT int msSetErrorFile(const char *pszErrorFile, const char *pszRelToPath);
-  MS_DLL_EXPORT void msCloseErrorFile( void );
-  MS_DLL_EXPORT const char *msGetErrorFile( void );
-  MS_DLL_EXPORT void msSetGlobalDebugLevel(int level);
-  MS_DLL_EXPORT debugLevel msGetGlobalDebugLevel( void );
-  MS_DLL_EXPORT int msDebugInitFromEnv( void );
-  MS_DLL_EXPORT void msDebugCleanup( void );
+typedef enum {
+  MS_DEBUGMODE_OFF,
+  MS_DEBUGMODE_FILE,
+  MS_DEBUGMODE_STDERR,
+  MS_DEBUGMODE_STDOUT,
+  MS_DEBUGMODE_WINDOWSDEBUG
+} debugMode;
+
+typedef struct debug_info_obj {
+  debugLevel global_debug_level;
+  debugMode debug_mode;
+  char *errorfile;
+  FILE *fp;
+  /* The following 2 members are used only with USE_THREAD (but we won't #ifndef
+   * them) */
+  void *thread_id;
+  struct debug_info_obj *next;
+} debugInfoObj;
+
+MS_DLL_EXPORT void msDebug(const char *pszFormat, ...)
+    MS_PRINT_FUNC_FORMAT(1, 2);
+MS_DLL_EXPORT int msSetErrorFile(const char *pszErrorFile,
+                                 const char *pszRelToPath);
+MS_DLL_EXPORT void msCloseErrorFile(void);
+MS_DLL_EXPORT const char *msGetErrorFile(void);
+MS_DLL_EXPORT void msSetGlobalDebugLevel(int level);
+MS_DLL_EXPORT debugLevel msGetGlobalDebugLevel(void);
+MS_DLL_EXPORT int msDebugInitFromEnv(void);
+MS_DLL_EXPORT void msDebugCleanup(void);
 
 #endif /* SWIG */
 
diff -pruN 8.0.1-5/mapfile.c 8.0.2-1/mapfile.c
--- 8.0.1-5/mapfile.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapfile.c	2024-06-11 20:41:34.000000000 +0000
@@ -62,24 +62,31 @@ extern char *msyystring_buffer;
 extern int msyystring_icase;
 
 extern int loadSymbol(symbolObj *s, char *symbolpath); /* in mapsymbol.c */
-extern void writeSymbol(symbolObj *s, FILE *stream); /* in mapsymbol.c */
-static int loadGrid( layerObj *pLayer );
+extern void writeSymbol(symbolObj *s, FILE *stream);   /* in mapsymbol.c */
+static int loadGrid(layerObj *pLayer);
 static int loadStyle(styleObj *style);
-static void writeStyle(FILE* stream, int indent, styleObj *style);
+static void writeStyle(FILE *stream, int indent, styleObj *style);
 static int resolveSymbolNames(mapObj *map);
 static int loadExpression(expressionObj *exp);
-static void writeExpression(FILE *stream, int indent, const char *name, expressionObj *exp);
-
+static void writeExpression(FILE *stream, int indent, const char *name,
+                            expressionObj *exp);
 
 /*
 ** Symbol to string static arrays needed for writing map files.
 ** Must be kept in sync with enumerations and defines found in mapserver.h.
 */
-/* static char *msUnits[9]={"INCHES", "FEET", "MILES", "METERS", "KILOMETERS", "DD", "PIXELS", "PERCENTAGES", "NAUTICALMILES"}; */
-/* static char *msLayerTypes[10]={"POINT", "LINE", "POLYGON", "RASTER", "ANNOTATION", "QUERY", "CIRCLE", "TILEINDEX","CHART"}; */
-char *msPositionsText[MS_POSITIONS_LENGTH] = {"UL", "LR", "UR", "LL", "CR", "CL", "UC", "LC", "CC", "AUTO", "XY", "FOLLOW"}; /* msLabelPositions[] also used in mapsymbols.c (not static) */
-/* static char *msBitmapFontSizes[5]={"TINY", "SMALL", "MEDIUM", "LARGE", "GIANT"}; */
-/* static char *msQueryMapStyles[4]={"NORMAL", "HILITE", "SELECTED", "INVERTED"}; */
+/* static char *msUnits[9]={"INCHES", "FEET", "MILES", "METERS", "KILOMETERS",
+ * "DD", "PIXELS", "PERCENTAGES", "NAUTICALMILES"}; */
+/* static char *msLayerTypes[10]={"POINT", "LINE", "POLYGON", "RASTER",
+ * "ANNOTATION", "QUERY", "CIRCLE", "TILEINDEX","CHART"}; */
+char *msPositionsText[MS_POSITIONS_LENGTH] = {
+    "UL", "LR", "UR",   "LL", "CR",    "CL", "UC",
+    "LC", "CC", "AUTO", "XY", "FOLLOW"}; /* msLabelPositions[] also used in
+                                            mapsymbols.c (not static) */
+/* static char *msBitmapFontSizes[5]={"TINY", "SMALL", "MEDIUM", "LARGE",
+ * "GIANT"}; */
+/* static char *msQueryMapStyles[4]={"NORMAL", "HILITE", "SELECTED",
+ * "INVERTED"}; */
 /* static char *msStatus[4]={"OFF", "ON", "DEFAULT", "EMBED"}; */
 /* static char *msOnOff[2]={"OFF", "ON"}; */
 /* static char *msTrueFalse[2]={"FALSE", "TRUE"}; */
@@ -88,84 +95,93 @@ char *msPositionsText[MS_POSITIONS_LENGT
 /* static char *msAlignValue[3]={"LEFT","CENTER","RIGHT"}; */
 
 /*
-** Validates a string (value) against a series of patterns. We support up to four to allow cascading from classObj to
+** Validates a string (value) against a series of patterns. We support up to
+*four to allow cascading from classObj to
 ** layerObj to webObj plus a legacy pattern like TEMPLATEPATTERN.
 */
-int msValidateParameter(const char *value, const char *pattern1, const char *pattern2, const char *pattern3, const char *pattern4)
-{
-  if(msEvalRegex(pattern1, value) == MS_TRUE) return MS_SUCCESS;
-  if(msEvalRegex(pattern2, value) == MS_TRUE) return MS_SUCCESS;
-  if(msEvalRegex(pattern3, value) == MS_TRUE) return MS_SUCCESS;
-  if(msEvalRegex(pattern4, value) == MS_TRUE) return MS_SUCCESS;
+int msValidateParameter(const char *value, const char *pattern1,
+                        const char *pattern2, const char *pattern3,
+                        const char *pattern4) {
+  if (msEvalRegex(pattern1, value) == MS_TRUE)
+    return MS_SUCCESS;
+  if (msEvalRegex(pattern2, value) == MS_TRUE)
+    return MS_SUCCESS;
+  if (msEvalRegex(pattern3, value) == MS_TRUE)
+    return MS_SUCCESS;
+  if (msEvalRegex(pattern4, value) == MS_TRUE)
+    return MS_SUCCESS;
 
-  return(MS_FAILURE);
+  return (MS_FAILURE);
 }
 
-int msIsValidRegex(const char* e) {
+int msIsValidRegex(const char *e) {
   ms_regex_t re;
-  if(ms_regcomp(&re, e, MS_REG_EXTENDED|MS_REG_NOSUB) != 0) {
-    msSetError(MS_REGEXERR, "Failed to compile expression (%s).", "msEvalRegex()", e);
-    return(MS_FALSE);
+  if (ms_regcomp(&re, e, MS_REG_EXTENDED | MS_REG_NOSUB) != 0) {
+    msSetError(MS_REGEXERR, "Failed to compile expression (%s).",
+               "msEvalRegex()", e);
+    return (MS_FALSE);
   }
   ms_regfree(&re);
   return MS_TRUE;
 }
 
-int msEvalRegex(const char *e, const char *s)
-{
+int msEvalRegex(const char *e, const char *s) {
   ms_regex_t re;
 
-  if(!e || !s) return(MS_FALSE);
+  if (!e || !s)
+    return (MS_FALSE);
 
-  if(ms_regcomp(&re, e, MS_REG_EXTENDED|MS_REG_NOSUB) != 0) {
-    msSetError(MS_REGEXERR, "Failed to compile expression (%s).", "msEvalRegex()", e);
-    return(MS_FALSE);
+  if (ms_regcomp(&re, e, MS_REG_EXTENDED | MS_REG_NOSUB) != 0) {
+    msSetError(MS_REGEXERR, "Failed to compile expression (%s).",
+               "msEvalRegex()", e);
+    return (MS_FALSE);
   }
 
-  if(ms_regexec(&re, s, 0, NULL, 0) != 0) { /* no match */
+  if (ms_regexec(&re, s, 0, NULL, 0) != 0) { /* no match */
     ms_regfree(&re);
-    return(MS_FALSE);
+    return (MS_FALSE);
   }
   ms_regfree(&re);
 
-  return(MS_TRUE);
+  return (MS_TRUE);
 }
 
-int msCaseEvalRegex(const char *e, const char *s)
-{
+int msCaseEvalRegex(const char *e, const char *s) {
   ms_regex_t re;
 
-  if(!e || !s) return(MS_FALSE);
+  if (!e || !s)
+    return (MS_FALSE);
 
-  if(ms_regcomp(&re, e, MS_REG_EXTENDED|MS_REG_ICASE|MS_REG_NOSUB) != 0) {
-    msSetError(MS_REGEXERR, "Failed to compile expression (%s).", "msEvalRegex()", e);
-    return(MS_FALSE);
+  if (ms_regcomp(&re, e, MS_REG_EXTENDED | MS_REG_ICASE | MS_REG_NOSUB) != 0) {
+    msSetError(MS_REGEXERR, "Failed to compile expression (%s).",
+               "msEvalRegex()", e);
+    return (MS_FALSE);
   }
 
-  if(ms_regexec(&re, s, 0, NULL, 0) != 0) { /* no match */
+  if (ms_regexec(&re, s, 0, NULL, 0) != 0) { /* no match */
     ms_regfree(&re);
-    return(MS_FALSE);
+    return (MS_FALSE);
   }
   ms_regfree(&re);
 
-  return(MS_TRUE);
+  return (MS_TRUE);
 }
 
 #ifdef USE_MSFREE
-void msFree(void *p)
-{
-  if(p) free(p);
+void msFree(void *p) {
+  if (p)
+    free(p);
 }
 #endif
 
 /*
 ** Free memory allocated for a character array
 */
-void msFreeCharArray(char **array, int num_items)
-{
+void msFreeCharArray(char **array, int num_items) {
   int i;
-  if(!array) return;
-  for(i=0; i<num_items; i++)
+  if (!array)
+    return;
+  for (i = 0; i < num_items; i++)
     msFree(array[i]);
   msFree(array);
 }
@@ -174,59 +190,57 @@ void msFreeCharArray(char **array, int n
 ** Checks symbol from lexer against variable length list of
 ** legal symbols.
 */
-int getSymbol(int n, ...)
-{
+int getSymbol(int n, ...) {
   int symbol;
   va_list argp;
-  int i=0;
+  int i = 0;
 
   symbol = msyylex();
 
   va_start(argp, n);
-  while(i<n) { /* check each symbol in the list */
-    if(symbol == va_arg(argp, int)) {
+  while (i < n) { /* check each symbol in the list */
+    if (symbol == va_arg(argp, int)) {
       va_end(argp);
-      return(symbol);
+      return (symbol);
     }
     i++;
   }
 
   va_end(argp);
 
-  msSetError(MS_SYMERR, "Parsing error near (%s):(line %d)", "getSymbol()", msyystring_buffer, msyylineno);
-  return(-1);
+  msSetError(MS_SYMERR, "Parsing error near (%s):(line %d)", "getSymbol()",
+             msyystring_buffer, msyylineno);
+  return (-1);
 }
 
 /*
 ** Same as getSymbol, except no error message is set on failure
 */
-int getSymbol2(int n, ...)
-{
+int getSymbol2(int n, ...) {
   int symbol;
   va_list argp;
-  int i=0;
+  int i = 0;
 
   symbol = msyylex();
 
   va_start(argp, n);
-  while(i<n) { /* check each symbol in the list */
-    if(symbol == va_arg(argp, int)) {
+  while (i < n) { /* check each symbol in the list */
+    if (symbol == va_arg(argp, int)) {
       va_end(argp);
-      return(symbol);
+      return (symbol);
     }
     i++;
   }
 
   va_end(argp);
-  return(-1);
+  return (-1);
 }
 
 /*
 ** Get a string or symbol as a string.   Operates like getString(), but also
 ** supports symbols.
 */
-static char *getToken(void)
-{
+static char *getToken(void) {
   msyylex();
   return msStrdup(msyystring_buffer);
 }
@@ -234,31 +248,32 @@ static char *getToken(void)
 /*
 ** Load a string from the map file. A "string" is defined in lexer.l.
 */
-int getString(char **s)
-{
+int getString(char **s) {
   /* if (*s)
-    msSetError(MS_SYMERR, "Duplicate item (%s):(line %d)", "getString()", msyystring_buffer, msyylineno);
-    return(MS_FAILURE);
-  } else */
-  if(msyylex() == MS_STRING) {
-    if(*s) free(*s); /* avoid leak */
+    msSetError(MS_SYMERR, "Duplicate item (%s):(line %d)", "getString()",
+  msyystring_buffer, msyylineno); return(MS_FAILURE); } else */
+  if (msyylex() == MS_STRING) {
+    if (*s)
+      free(*s); /* avoid leak */
     *s = msStrdup(msyystring_buffer);
-    return(MS_SUCCESS);
+    return (MS_SUCCESS);
   }
 
-  msSetError(MS_SYMERR, "Parsing error near (%s):(line %d)", "getString()", msyystring_buffer, msyylineno);
-  return(MS_FAILURE);
+  msSetError(MS_SYMERR, "Parsing error near (%s):(line %d)", "getString()",
+             msyystring_buffer, msyylineno);
+  return (MS_FAILURE);
 }
 
-int msCheckNumber(double number, int num_check_type, double value1, double value2)
-{
-  if(num_check_type == MS_NUM_CHECK_NONE) {
+int msCheckNumber(double number, int num_check_type, double value1,
+                  double value2) {
+  if (num_check_type == MS_NUM_CHECK_NONE) {
     return MS_SUCCESS;
-  } else if(num_check_type == MS_NUM_CHECK_RANGE && number >= value1 && number <= value2) {
+  } else if (num_check_type == MS_NUM_CHECK_RANGE && number >= value1 &&
+             number <= value2) {
     return MS_SUCCESS;
-  } else if(num_check_type == MS_NUM_CHECK_GT && number > value1) {
+  } else if (num_check_type == MS_NUM_CHECK_GT && number > value1) {
     return MS_SUCCESS;
-  } else if(num_check_type == MS_NUM_CHECK_GTE && number >= value1) {
+  } else if (num_check_type == MS_NUM_CHECK_GTE && number >= value1) {
     return MS_SUCCESS;
   }
 
@@ -268,55 +283,56 @@ int msCheckNumber(double number, int num
 /*
 ** Load a floating point number from the map file. (see lexer.l)
 */
-int getDouble(double *d, int num_check_type, double value1, double value2)
-{
-  if(msyylex() == MS_NUMBER) {
-    if(msCheckNumber(msyynumber, num_check_type, value1, value2) == MS_SUCCESS) {
+int getDouble(double *d, int num_check_type, double value1, double value2) {
+  if (msyylex() == MS_NUMBER) {
+    if (msCheckNumber(msyynumber, num_check_type, value1, value2) ==
+        MS_SUCCESS) {
       *d = msyynumber;
-      return(0);
+      return (0);
     }
   }
 
-  msSetError(MS_SYMERR, "Parsing error near (%s):(line %d)", "getDouble()", msyystring_buffer, msyylineno);
-  return(-1);
+  msSetError(MS_SYMERR, "Parsing error near (%s):(line %d)", "getDouble()",
+             msyystring_buffer, msyylineno);
+  return (-1);
 }
 
 /*
 ** Load a integer from the map file. (see lexer.l)
 */
-int getInteger(int *i, int num_check_type, int value1, int value2)
-{
-  if(msyylex() == MS_NUMBER) {
-    if(msCheckNumber(msyynumber, num_check_type, value1, value2) == MS_SUCCESS) {
+int getInteger(int *i, int num_check_type, int value1, int value2) {
+  if (msyylex() == MS_NUMBER) {
+    if (msCheckNumber(msyynumber, num_check_type, value1, value2) ==
+        MS_SUCCESS) {
       *i = (int)msyynumber;
-      return(0);
+      return (0);
     }
   }
 
-  msSetError(MS_SYMERR, "Parsing error near (%s):(line %d)", "getInteger()", msyystring_buffer, msyylineno);
-  return(-1);
+  msSetError(MS_SYMERR, "Parsing error near (%s):(line %d)", "getInteger()",
+             msyystring_buffer, msyylineno);
+  return (-1);
 }
 
-int getCharacter(char *c)
-{
-  if(msyylex() == MS_STRING) {
+int getCharacter(char *c) {
+  if (msyylex() == MS_STRING) {
     *c = msyystring_buffer[0];
-    return(0);
+    return (0);
   }
 
-  msSetError(MS_SYMERR, "Parsing error near (%s):(line %d)", "getCharacter()", msyystring_buffer, msyylineno);
-  return(-1);
+  msSetError(MS_SYMERR, "Parsing error near (%s):(line %d)", "getCharacter()",
+             msyystring_buffer, msyylineno);
+  return (-1);
 }
 
 /*
 ** Try to load as an integer, then try as a named symbol.
 ** Part of work on bug 490.
 */
-int getIntegerOrSymbol(int *i, int n, ...)
-{
+int getIntegerOrSymbol(int *i, int n, ...) {
   int symbol;
   va_list argp;
-  int j=0;
+  int j = 0;
 
   symbol = msyylex();
 
@@ -326,8 +342,8 @@ int getIntegerOrSymbol(int *i, int n, ..
   }
 
   va_start(argp, n);
-  while (j<n) { /* check each symbol in the list */
-    if(symbol == va_arg(argp, int)) {
+  while (j < n) { /* check each symbol in the list */
+    if (symbol == va_arg(argp, int)) {
       va_end(argp);
       *i = symbol;
       return MS_SUCCESS;
@@ -338,29 +354,27 @@ int getIntegerOrSymbol(int *i, int n, ..
 
   msSetError(MS_SYMERR, "Parsing error near (%s):(line %d)",
              "getIntegerOrSymbol()", msyystring_buffer, msyylineno);
-  return(-1);
+  return (-1);
 }
 
-
 /*
 ** msBuildPluginLibraryPath
 **
 ** This function builds a path to be used dynamically to load plugin library.
 */
-int msBuildPluginLibraryPath(char **dest, const char *lib_str, mapObj *map)
-{
-  char szLibPath[MS_MAXPATHLEN] = { '\0' };
-  char szLibPathExt[MS_MAXPATHLEN] = { '\0' };
+int msBuildPluginLibraryPath(char **dest, const char *lib_str, mapObj *map) {
+  char szLibPath[MS_MAXPATHLEN] = {'\0'};
+  char szLibPathExt[MS_MAXPATHLEN] = {'\0'};
   const char *plugin_dir = NULL;
 
   if (map)
     plugin_dir = msLookupHashTable(&(map->configoptions), "MS_PLUGIN_DIR");
 
-  /* do nothing on windows, filename without .dll will be loaded by default*/
+    /* do nothing on windows, filename without .dll will be loaded by default*/
 #if !defined(_WIN32)
   if (lib_str) {
     size_t len = strlen(lib_str);
-    if (3 < len && strcmp(lib_str + len-3, ".so")) {
+    if (3 < len && strcmp(lib_str + len - 3, ".so")) {
       strlcpy(szLibPathExt, lib_str, MS_MAXPATHLEN);
       strlcat(szLibPathExt, ".so", MS_MAXPATHLEN);
       lib_str = szLibPathExt;
@@ -382,70 +396,78 @@ int msBuildPluginLibraryPath(char **dest
 ** If try_addimage_if_notfound==MS_TRUE then msAddImageSymbol() will be called
 ** to try to allocate the symbol as an image symbol.
 */
-int msGetSymbolIndex(symbolSetObj *symbols, char *name, int try_addimage_if_notfound)
-{
+int msGetSymbolIndex(symbolSetObj *symbols, char *name,
+                     int try_addimage_if_notfound) {
   int i;
 
-  if(!symbols || !name) return(-1);
+  if (!symbols || !name)
+    return (-1);
 
   /* symbol 0 has no name */
-  for(i=1; i<symbols->numsymbols; i++) {
-    if(symbols->symbol[i]->name)
-      if(strcasecmp(symbols->symbol[i]->name, name) == 0) return(i);
+  for (i = 1; i < symbols->numsymbols; i++) {
+    if (symbols->symbol[i]->name)
+      if (strcasecmp(symbols->symbol[i]->name, name) == 0)
+        return (i);
   }
 
   if (try_addimage_if_notfound)
-    return(msAddImageSymbol(symbols, name)); /* make sure it's not a filename */
+    return (
+        msAddImageSymbol(symbols, name)); /* make sure it's not a filename */
 
-  return(-1);
+  return (-1);
 }
 
 /*
 ** Return the index number for a given layer based on its name.
 */
-int msGetLayerIndex(mapObj *map, const char *name)
-{
+int msGetLayerIndex(mapObj *map, const char *name) {
   int i;
 
-  if(!name) return(-1);
+  if (!name)
+    return (-1);
 
-  for(i=0; i<map->numlayers; i++) {
-    if(!GET_LAYER(map, i)->name) /* skip it */
+  for (i = 0; i < map->numlayers; i++) {
+    if (!GET_LAYER(map, i)->name) /* skip it */
       continue;
-    if(strcmp(name, GET_LAYER(map, i)->name) == 0)
-      return(i);
+    if (strcmp(name, GET_LAYER(map, i)->name) == 0)
+      return (i);
   }
-  return(-1);
+  return (-1);
 }
 
-int loadColor(colorObj *color, attributeBindingObj *binding)
-{
+int loadColor(colorObj *color, attributeBindingObj *binding) {
   int symbol;
   char hex[2];
 
   /*
-  ** Note that negative color values can be used to suppress or change behavior. For example, referenceObj uses 
+  ** Note that negative color values can be used to suppress or change behavior.
+  *For example, referenceObj uses
   ** a negative color component to suppress rectangle fills.
   */
 
-  if(binding) {
-    if((symbol = getSymbol(3, MS_NUMBER, MS_BINDING, MS_STRING)) == -1) return MS_FAILURE;
+  if (binding) {
+    if ((symbol = getSymbol(3, MS_NUMBER, MS_BINDING, MS_STRING)) == -1)
+      return MS_FAILURE;
   } else {
-    if((symbol = getSymbol(2, MS_NUMBER, MS_STRING)) == -1) return MS_FAILURE;
+    if ((symbol = getSymbol(2, MS_NUMBER, MS_STRING)) == -1)
+      return MS_FAILURE;
   }
 
-  color->alpha=255;
-  if(symbol == MS_NUMBER) {
-    if(msyynumber >= -255 && msyynumber <= 255) {
-      color->red = (int) msyynumber;
+  color->alpha = 255;
+  if (symbol == MS_NUMBER) {
+    if (msyynumber >= -255 && msyynumber <= 255) {
+      color->red = (int)msyynumber;
     } else {
       return MS_FAILURE;
     }
-    if(getInteger(&(color->green), MS_NUM_CHECK_RANGE, -255, 255) == -1) return MS_FAILURE;
-    if(getInteger(&(color->blue), MS_NUM_CHECK_RANGE, -255, 255) == -1) return MS_FAILURE;
-  } else if(symbol == MS_STRING) {
+    if (getInteger(&(color->green), MS_NUM_CHECK_RANGE, -255, 255) == -1)
+      return MS_FAILURE;
+    if (getInteger(&(color->blue), MS_NUM_CHECK_RANGE, -255, 255) == -1)
+      return MS_FAILURE;
+  } else if (symbol == MS_STRING) {
     int len = strlen(msyystring_buffer);
-    if(msyystring_buffer[0] == '#' && (len == 7 || len == 9)) { /* got a hex color w/optional alpha */
+    if (msyystring_buffer[0] == '#' &&
+        (len == 7 || len == 9)) { /* got a hex color w/optional alpha */
       hex[0] = msyystring_buffer[1];
       hex[1] = msyystring_buffer[2];
       color->red = msHexToInt(hex);
@@ -455,14 +477,15 @@ int loadColor(colorObj *color, attribute
       hex[0] = msyystring_buffer[5];
       hex[1] = msyystring_buffer[6];
       color->blue = msHexToInt(hex);
-      if(len == 9) {
+      if (len == 9) {
         hex[0] = msyystring_buffer[7];
         hex[1] = msyystring_buffer[8];
         color->alpha = msHexToInt(hex);
       }
     } else {
       /* TODO: consider named colors here */
-      msSetError(MS_SYMERR, "Invalid hex color (%s):(line %d)", "loadColor()", msyystring_buffer, msyylineno);
+      msSetError(MS_SYMERR, "Invalid hex color (%s):(line %d)", "loadColor()",
+                 msyystring_buffer, msyylineno);
       return MS_FAILURE;
     }
   } else {
@@ -476,18 +499,18 @@ int loadColor(colorObj *color, attribute
 }
 
 #if ALPHACOLOR_ENABLED
-int loadColorWithAlpha(colorObj *color)
-{
+int loadColorWithAlpha(colorObj *color) {
   char hex[2];
 
-
   /*
-  ** Note that negative color values can be used to suppress or change behavior. For example, referenceObj uses 
+  ** Note that negative color values can be used to suppress or change behavior.
+  *For example, referenceObj uses
   ** a negative color component to suppress rectangle fills.
   */
 
-  if(getInteger(&(color->red), MS_NUM_CHECK_RANGE, -255, 255) == -1) {
-    if(msyystring_buffer[0] == '#' && strlen(msyystring_buffer) == 7) { /* got a hex color */
+  if (getInteger(&(color->red), MS_NUM_CHECK_RANGE, -255, 255) == -1) {
+    if (msyystring_buffer[0] == '#' &&
+        strlen(msyystring_buffer) == 7) { /* got a hex color */
       hex[0] = msyystring_buffer[1];
       hex[1] = msyystring_buffer[2];
       color->red = msHexToInt(hex);
@@ -499,8 +522,10 @@ int loadColorWithAlpha(colorObj *color)
       color->blue = msHexToInt(hex);
       color->alpha = 0;
 
-      return(MS_SUCCESS);
-    } else if(msyystring_buffer[0] == '#' && strlen(msyystring_buffer) == 9) { /* got a hex color with alpha */
+      return (MS_SUCCESS);
+    } else if (msyystring_buffer[0] == '#' &&
+               strlen(msyystring_buffer) ==
+                   9) { /* got a hex color with alpha */
       hex[0] = msyystring_buffer[1];
       hex[1] = msyystring_buffer[2];
       color->red = msHexToInt(hex);
@@ -513,56 +538,55 @@ int loadColorWithAlpha(colorObj *color)
       hex[0] = msyystring_buffer[7];
       hex[1] = msyystring_buffer[8];
       color->alpha = msHexToInt(hex);
-      return(MS_SUCCESS);
+      return (MS_SUCCESS);
     }
-    return(MS_FAILURE);
+    return (MS_FAILURE);
   }
-  if(getInteger(&(color->green), MS_NUM_CHECK_RANGE, -255, 255) == -1) return(MS_FAILURE);
-  if(getInteger(&(color->blue), MS_NUM_CHECK_RANGE, -255, 255) == -1) return(MS_FAILURE);
-  if(getInteger(&(color->alpha), MS_NUM_CHECK_RANGE, 0, 255) == -1) return(MS_FAILURE);
+  if (getInteger(&(color->green), MS_NUM_CHECK_RANGE, -255, 255) == -1)
+    return (MS_FAILURE);
+  if (getInteger(&(color->blue), MS_NUM_CHECK_RANGE, -255, 255) == -1)
+    return (MS_FAILURE);
+  if (getInteger(&(color->alpha), MS_NUM_CHECK_RANGE, 0, 255) == -1)
+    return (MS_FAILURE);
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 #endif
 
 /*
 ** Helper functions for writing mapfiles.
 */
-static void writeLineFeed(FILE *stream)
-{
-  msIO_fprintf(stream, "\n");
-}
+static void writeLineFeed(FILE *stream) { msIO_fprintf(stream, "\n"); }
 
-static void writeIndent(FILE *stream, int indent)
-{
-  const char *str="  "; /* change this string to define the indent */
+static void writeIndent(FILE *stream, int indent) {
+  const char *str = "  "; /* change this string to define the indent */
   int i;
-  for(i=0; i<indent; i++) msIO_fprintf(stream, "%s", str);
+  for (i = 0; i < indent; i++)
+    msIO_fprintf(stream, "%s", str);
 }
 
-static void writeBlockBegin(FILE *stream, int indent, const char *name)
-{
+static void writeBlockBegin(FILE *stream, int indent, const char *name) {
   writeIndent(stream, indent);
   msIO_fprintf(stream, "%s\n", name);
 }
 
-static void writeBlockEnd(FILE *stream, int indent, const char *name)
-{
+static void writeBlockEnd(FILE *stream, int indent, const char *name) {
   writeIndent(stream, indent);
   msIO_fprintf(stream, "END # %s\n", name);
 }
 
-static void writeKeyword(FILE *stream, int indent, const char *name, int value, int size, ...)
-{
+static void writeKeyword(FILE *stream, int indent, const char *name, int value,
+                         int size, ...) {
   va_list argp;
-  int i, j=0;
+  int i, j = 0;
   const char *s;
 
   va_start(argp, size);
-  while (j<size) { /* check each value/keyword mapping in the list, values with no match are ignored */
+  while (j < size) { /* check each value/keyword mapping in the list, values
+                        with no match are ignored */
     i = va_arg(argp, int);
     s = va_arg(argp, const char *);
-    if(value == i) {
+    if (value == i) {
       writeIndent(stream, ++indent);
       msIO_fprintf(stream, "%s %s\n", name, s);
       va_end(argp);
@@ -573,95 +597,112 @@ static void writeKeyword(FILE *stream, i
   va_end(argp);
 }
 
-static void writeDimension(FILE *stream, int indent, const char *name, double x, double y, char *bind_x, char *bind_y)
-{
+static void writeDimension(FILE *stream, int indent, const char *name, double x,
+                           double y, char *bind_x, char *bind_y) {
   writeIndent(stream, ++indent);
-  if(bind_x) msIO_fprintf(stream, "%s [%s] ", name, bind_x);
-  else msIO_fprintf(stream, "%s %.15g ", name, x);
-  if(bind_y) msIO_fprintf(stream, "[%s]\n", bind_y);
-  else msIO_fprintf(stream, "%.15g\n", y);
+  if (bind_x)
+    msIO_fprintf(stream, "%s [%s] ", name, bind_x);
+  else
+    msIO_fprintf(stream, "%s %.15g ", name, x);
+  if (bind_y)
+    msIO_fprintf(stream, "[%s]\n", bind_y);
+  else
+    msIO_fprintf(stream, "%.15g\n", y);
 }
 
-static void writeDoubleRange(FILE *stream, int indent, const char *name, double x, double y)
-{
+static void writeDoubleRange(FILE *stream, int indent, const char *name,
+                             double x, double y) {
   writeIndent(stream, ++indent);
   msIO_fprintf(stream, "%s %f %f\n", name, x, y);
 }
 
-static void writeExtent(FILE *stream, int indent, const char *name, rectObj extent)
-{
-  if(!MS_VALID_EXTENT(extent)) return;
+static void writeExtent(FILE *stream, int indent, const char *name,
+                        rectObj extent) {
+  if (!MS_VALID_EXTENT(extent))
+    return;
   writeIndent(stream, ++indent);
-  msIO_fprintf(stream, "%s %.15g %.15g %.15g %.15g\n", name, extent.minx, extent.miny, extent.maxx, extent.maxy);
+  msIO_fprintf(stream, "%s %.15g %.15g %.15g %.15g\n", name, extent.minx,
+               extent.miny, extent.maxx, extent.maxy);
 }
 
-static void writeNumber(FILE *stream, int indent, const char *name, double defaultNumber, double number)
-{
-  if(number == defaultNumber) return; /* don't output default */
+static void writeNumber(FILE *stream, int indent, const char *name,
+                        double defaultNumber, double number) {
+  if (number == defaultNumber)
+    return; /* don't output default */
   writeIndent(stream, ++indent);
   msIO_fprintf(stream, "%s %.15g\n", name, number);
 }
 
-static void writeCharacter(FILE *stream, int indent, const char *name, const char defaultCharacter, char character)
-{
-  if(defaultCharacter == character) return;
+static void writeCharacter(FILE *stream, int indent, const char *name,
+                           const char defaultCharacter, char character) {
+  if (defaultCharacter == character)
+    return;
   writeIndent(stream, ++indent);
   msIO_fprintf(stream, "%s '%c'\n", name, character);
 }
 
-static void writeStringElement(FILE *stream, char *string)
-{
-    char *string_escaped;
-
-    if(strchr(string,'\\')) {
-      string_escaped = msStrdup(string);
-      string_escaped = msReplaceSubstring(string_escaped,"\\","\\\\");
-    } else {
-      string_escaped = string;
-    }
-    if ( (strchr(string_escaped, '\'') == NULL) && (strchr(string_escaped, '\"') == NULL))
-      msIO_fprintf(stream, "\"%s\"", string_escaped);
-    else if ( (strchr(string_escaped, '\"') != NULL) && (strchr(string_escaped, '\'') == NULL))
-      msIO_fprintf(stream, "'%s'", string_escaped);
-    else if ( (strchr(string_escaped, '\'') != NULL) && (strchr(string_escaped, '\"') == NULL))
-      msIO_fprintf(stream, "\"%s\"", string_escaped);
-    else {
-      char *string_tmp = msStringEscape(string_escaped);
-      msIO_fprintf(stream, "\"%s\"", string_tmp);
-      if(string_escaped!=string_tmp) free(string_tmp);
-    }
-    if(string_escaped!=string) free(string_escaped);
-}
-
-static void writeString(FILE *stream, int indent, const char *name, const char *defaultString, char *string)
-{
-  if(!string) return;
-  if(defaultString && strcmp(string, defaultString) == 0) return;
+static void writeStringElement(FILE *stream, char *string) {
+  char *string_escaped;
+
+  if (strchr(string, '\\')) {
+    string_escaped = msStrdup(string);
+    string_escaped = msReplaceSubstring(string_escaped, "\\", "\\\\");
+  } else {
+    string_escaped = string;
+  }
+  if ((strchr(string_escaped, '\'') == NULL) &&
+      (strchr(string_escaped, '\"') == NULL))
+    msIO_fprintf(stream, "\"%s\"", string_escaped);
+  else if ((strchr(string_escaped, '\"') != NULL) &&
+           (strchr(string_escaped, '\'') == NULL))
+    msIO_fprintf(stream, "'%s'", string_escaped);
+  else if ((strchr(string_escaped, '\'') != NULL) &&
+           (strchr(string_escaped, '\"') == NULL))
+    msIO_fprintf(stream, "\"%s\"", string_escaped);
+  else {
+    char *string_tmp = msStringEscape(string_escaped);
+    msIO_fprintf(stream, "\"%s\"", string_tmp);
+    if (string_escaped != string_tmp)
+      free(string_tmp);
+  }
+  if (string_escaped != string)
+    free(string_escaped);
+}
+
+static void writeString(FILE *stream, int indent, const char *name,
+                        const char *defaultString, char *string) {
+  if (!string)
+    return;
+  if (defaultString && strcmp(string, defaultString) == 0)
+    return;
   writeIndent(stream, ++indent);
-  if(name) msIO_fprintf(stream, "%s ", name);
+  if (name)
+    msIO_fprintf(stream, "%s ", name);
   writeStringElement(stream, string);
   writeLineFeed(stream);
 }
 
-static void writeNumberOrString(FILE *stream, int indent, const char *name, double defaultNumber, double number, char *string)
-{
-  if(string)
+static void writeNumberOrString(FILE *stream, int indent, const char *name,
+                                double defaultNumber, double number,
+                                char *string) {
+  if (string)
     writeString(stream, indent, name, NULL, string);
   else
     writeNumber(stream, indent, name, defaultNumber, number);
 }
 
-static void writeNumberOrKeyword(FILE *stream, int indent, const char *name, double defaultNumber, double number, int value, int size, ...)
-{
+static void writeNumberOrKeyword(FILE *stream, int indent, const char *name,
+                                 double defaultNumber, double number, int value,
+                                 int size, ...) {
   va_list argp;
-  int i, j=0;
+  int i, j = 0;
   const char *s;
 
   va_start(argp, size);
-  while (j<size) { /* check each value/keyword mapping in the list */
+  while (j < size) { /* check each value/keyword mapping in the list */
     i = va_arg(argp, int);
     s = va_arg(argp, const char *);
-    if(value == i) {
+    if (value == i) {
       writeIndent(stream, ++indent);
       msIO_fprintf(stream, "%s %s\n", name, s);
       va_end(argp);
@@ -674,65 +715,73 @@ static void writeNumberOrKeyword(FILE *s
   writeNumber(stream, indent, name, defaultNumber, number);
 }
 
-static void writeNameValuePair(FILE *stream, int indent, const char *name, const char *value)
-{
-  if(!name || !value) return;
+static void writeNameValuePair(FILE *stream, int indent, const char *name,
+                               const char *value) {
+  if (!name || !value)
+    return;
   writeIndent(stream, ++indent);
 
-  writeStringElement(stream, (char*)name);
-  msIO_fprintf(stream,"\t");
-  writeStringElement(stream, (char*)value);
+  writeStringElement(stream, (char *)name);
+  msIO_fprintf(stream, "\t");
+  writeStringElement(stream, (char *)value);
   writeLineFeed(stream);
 }
 
-static void writeAttributeBinding(FILE *stream, int indent, const char *name, attributeBindingObj *binding)
-{
-  if(!binding || !binding->item) return;
+static void writeAttributeBinding(FILE *stream, int indent, const char *name,
+                                  attributeBindingObj *binding) {
+  if (!binding || !binding->item)
+    return;
   writeIndent(stream, ++indent);
   msIO_fprintf(stream, "%s [%s]\n", name, binding->item);
 }
 
-static void writeColor(FILE *stream, int indent, const char *name, colorObj *defaultColor, colorObj *color)
-{
-  if (!defaultColor && !MS_VALID_COLOR(*color)) return;
-  else if(defaultColor && MS_COMPARE_COLOR(*defaultColor, *color)) return; /* if defaultColor has the same value than the color, return.*/
+static void writeColor(FILE *stream, int indent, const char *name,
+                       colorObj *defaultColor, colorObj *color) {
+  if (!defaultColor && !MS_VALID_COLOR(*color))
+    return;
+  else if (defaultColor && MS_COMPARE_COLOR(*defaultColor, *color))
+    return; /* if defaultColor has the same value than the color, return.*/
 
   writeIndent(stream, ++indent);
 #if ALPHACOLOR_ENABLED
-  msIO_fprintf(stream, "%s %d %d %d\n", name, color->red, color->green, color->blue, color->alpha);
+  msIO_fprintf(stream, "%s %d %d %d\n", name, color->red, color->green,
+               color->blue, color->alpha);
 #else
-  if(color->alpha != 255) {
+  if (color->alpha != 255) {
     char buffer[9];
     sprintf(buffer, "%02x", color->red);
-    sprintf(buffer+2, "%02x", color->green);
-    sprintf(buffer+4, "%02x", color->blue);
-    sprintf(buffer+6, "%02x", color->alpha);
-    *(buffer+8) = 0;
+    sprintf(buffer + 2, "%02x", color->green);
+    sprintf(buffer + 4, "%02x", color->blue);
+    sprintf(buffer + 6, "%02x", color->alpha);
+    *(buffer + 8) = 0;
     msIO_fprintf(stream, "%s \"#%s\"\n", name, buffer);
   } else {
-    msIO_fprintf(stream, "%s %d %d %d\n", name, color->red, color->green, color->blue);
+    msIO_fprintf(stream, "%s %d %d %d\n", name, color->red, color->green,
+                 color->blue);
   }
 #endif
 }
 
 /* todo: deal with alpha's... */
-static void writeColorRange(FILE *stream, int indent, const char *name, colorObj *mincolor, colorObj *maxcolor)
-{
-  if(!MS_VALID_COLOR(*mincolor) || !MS_VALID_COLOR(*maxcolor)) return;
+static void writeColorRange(FILE *stream, int indent, const char *name,
+                            colorObj *mincolor, colorObj *maxcolor) {
+  if (!MS_VALID_COLOR(*mincolor) || !MS_VALID_COLOR(*maxcolor))
+    return;
   writeIndent(stream, ++indent);
-  msIO_fprintf(stream, "%s %d %d %d  %d %d %d\n", name, mincolor->red, mincolor->green, mincolor->blue, maxcolor->red, maxcolor->green, maxcolor->blue);
+  msIO_fprintf(stream, "%s %d %d %d  %d %d %d\n", name, mincolor->red,
+               mincolor->green, mincolor->blue, maxcolor->red, maxcolor->green,
+               maxcolor->blue);
 }
 
 /*
 ** Initialize, load and free a single join
 */
-void initJoin(joinObj *join)
-{
+void initJoin(joinObj *join) {
   join->numitems = 0;
 
   join->name = NULL; /* unique join name, used for variable substitution */
 
-  join->items = NULL; /* array to hold item names for the joined table */
+  join->items = NULL;  /* array to hold item names for the joined table */
   join->values = NULL; /* arrays of strings to holds one record worth of data */
 
   join->table = NULL;
@@ -752,8 +801,7 @@ void initJoin(joinObj *join)
   join->connectiontype = MS_DB_XBASE;
 }
 
-void freeJoin(joinObj *join)
-{
+void freeJoin(joinObj *join) {
   msFree(join->name);
   msFree(join->table);
   msFree(join->from);
@@ -763,7 +811,8 @@ void freeJoin(joinObj *join)
   msFree(join->template);
   msFree(join->footer);
 
-  msFreeCharArray(join->items, join->numitems); /* these may have been free'd elsewhere */
+  msFreeCharArray(join->items,
+                  join->numitems); /* these may have been free'd elsewhere */
   msFreeCharArray(join->values, join->numitems);
   join->numitems = 0;
 
@@ -771,63 +820,80 @@ void freeJoin(joinObj *join)
   msFree(join->connection);
 }
 
-int loadJoin(joinObj *join)
-{
+int loadJoin(joinObj *join) {
   int nTmp;
   initJoin(join);
 
-  for(;;) {
-    switch(msyylex()) {
-      case(CONNECTION):
-        if(getString(&join->connection) == MS_FAILURE) return(-1);
-        break;
-      case(CONNECTIONTYPE):
-        if((nTmp = getSymbol(5, MS_DB_XBASE, MS_DB_MYSQL, MS_DB_ORACLE, MS_DB_POSTGRES, MS_DB_CSV)) == -1) return(-1);
-        join->connectiontype = nTmp;
-        break;
-      case(EOF):
-        msSetError(MS_EOFERR, NULL, "loadJoin()");
-        return(-1);
-      case(END):
-        if((join->from == NULL) || (join->to == NULL) || (join->table == NULL)) {
-          msSetError(MS_EOFERR, "Join must define table, name, from and to properties.", "loadJoin()");
-          return(-1);
-        }
-        if((join->type == MS_MULTIPLE) && ((join->template == NULL) || (join->name == NULL))) {
-          msSetError(MS_EOFERR, "One-to-many joins must define template and name properties.", "loadJoin()");
-          return(-1);
-        }
-        return(0);
-      case(FOOTER):
-        if(getString(&join->footer) == MS_FAILURE) return(-1);
-        break;
-      case(FROM):
-        if(getString(&join->from) == MS_FAILURE) return(-1);
-        break;
-      case(HEADER):
-        if(getString(&join->header) == MS_FAILURE) return(-1);
-        break;
-      case(JOIN):
-        break; /* for string loads */
-      case(NAME):
-        if(getString(&join->name) == MS_FAILURE) return(-1);
-        break;
-      case(TABLE):
-        if(getString(&join->table) == MS_FAILURE) return(-1);
-        break;
-      case(TEMPLATE):
-        if(getString(&join->template) == MS_FAILURE) return(-1);
-        break;
-      case(TO):
-        if(getString(&join->to) == MS_FAILURE) return(-1);
-        break;
-      case(TYPE):
-        if((nTmp = getSymbol(2, MS_JOIN_ONE_TO_ONE, MS_JOIN_ONE_TO_MANY)) == -1) return(-1);
-        join->type = nTmp;
-        break;
-      default:
-        msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)", "loadJoin()", msyystring_buffer, msyylineno);
-        return(-1);
+  for (;;) {
+    switch (msyylex()) {
+    case (CONNECTION):
+      if (getString(&join->connection) == MS_FAILURE)
+        return (-1);
+      break;
+    case (CONNECTIONTYPE):
+      if ((nTmp = getSymbol(5, MS_DB_XBASE, MS_DB_MYSQL, MS_DB_ORACLE,
+                            MS_DB_POSTGRES, MS_DB_CSV)) == -1)
+        return (-1);
+      join->connectiontype = nTmp;
+      break;
+    case (EOF):
+      msSetError(MS_EOFERR, NULL, "loadJoin()");
+      return (-1);
+    case (END):
+      if ((join->from == NULL) || (join->to == NULL) || (join->table == NULL)) {
+        msSetError(MS_EOFERR,
+                   "Join must define table, name, from and to properties.",
+                   "loadJoin()");
+        return (-1);
+      }
+      if ((join->type == MS_MULTIPLE) &&
+          ((join->template == NULL) || (join->name == NULL))) {
+        msSetError(
+            MS_EOFERR,
+            "One-to-many joins must define template and name properties.",
+            "loadJoin()");
+        return (-1);
+      }
+      return (0);
+    case (FOOTER):
+      if (getString(&join->footer) == MS_FAILURE)
+        return (-1);
+      break;
+    case (FROM):
+      if (getString(&join->from) == MS_FAILURE)
+        return (-1);
+      break;
+    case (HEADER):
+      if (getString(&join->header) == MS_FAILURE)
+        return (-1);
+      break;
+    case (JOIN):
+      break; /* for string loads */
+    case (NAME):
+      if (getString(&join->name) == MS_FAILURE)
+        return (-1);
+      break;
+    case (TABLE):
+      if (getString(&join->table) == MS_FAILURE)
+        return (-1);
+      break;
+    case (TEMPLATE):
+      if (getString(&join->template) == MS_FAILURE)
+        return (-1);
+      break;
+    case (TO):
+      if (getString(&join->to) == MS_FAILURE)
+        return (-1);
+      break;
+    case (TYPE):
+      if ((nTmp = getSymbol(2, MS_JOIN_ONE_TO_ONE, MS_JOIN_ONE_TO_MANY)) == -1)
+        return (-1);
+      join->type = nTmp;
+      break;
+    default:
+      msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)", "loadJoin()",
+                 msyystring_buffer, msyylineno);
+      return (-1);
     }
   } /* next token */
 }
@@ -835,22 +901,21 @@ int loadJoin(joinObj *join)
 static void writeScaleToken(FILE *stream, int indent, scaleTokenObj *token) {
   int i;
   indent++;
-  writeBlockBegin(stream,indent,"SCALETOKEN");
+  writeBlockBegin(stream, indent, "SCALETOKEN");
   writeString(stream, indent, "NAME", NULL, token->name);
   indent++;
-  writeBlockBegin(stream,indent,"VALUES");
-  for(i=0;i<token->n_entries;i++) {
+  writeBlockBegin(stream, indent, "VALUES");
+  for (i = 0; i < token->n_entries; i++) {
     char minscale[32];
-    sprintf(minscale,"%g",token->tokens[i].minscale);
+    sprintf(minscale, "%g", token->tokens[i].minscale);
     writeNameValuePair(stream, indent, minscale, token->tokens[i].value);
   }
-  writeBlockEnd(stream,indent,"VALUES");
+  writeBlockEnd(stream, indent, "VALUES");
   indent--;
-  writeBlockEnd(stream,indent,"SCALETOKEN");
+  writeBlockEnd(stream, indent, "SCALETOKEN");
 }
 
-static void writeJoin(FILE *stream, int indent, joinObj *join)
-{
+static void writeJoin(FILE *stream, int indent, joinObj *join) {
   indent++;
   writeBlockBegin(stream, indent, "JOIN");
   writeString(stream, indent, "FOOTER", NULL, join->footer);
@@ -860,36 +925,44 @@ static void writeJoin(FILE *stream, int
   writeString(stream, indent, "TABLE", NULL, join->table);
   writeString(stream, indent, "TEMPLATE", NULL, join->template);
   writeString(stream, indent, "TO", NULL, join->to);
-  writeKeyword(stream, indent, "CONNECTIONTYPE", join->connectiontype, 3, MS_DB_CSV, "CSV", MS_DB_POSTGRES, "POSTGRESQL", MS_DB_MYSQL, "MYSQL");
-  writeKeyword(stream, indent, "TYPE", join->type, 1, MS_JOIN_ONE_TO_MANY, "ONE-TO-MANY");
+  writeKeyword(stream, indent, "CONNECTIONTYPE", join->connectiontype, 3,
+               MS_DB_CSV, "CSV", MS_DB_POSTGRES, "POSTGRESQL", MS_DB_MYSQL,
+               "MYSQL");
+  writeKeyword(stream, indent, "TYPE", join->type, 1, MS_JOIN_ONE_TO_MANY,
+               "ONE-TO-MANY");
   writeBlockEnd(stream, indent, "JOIN");
 }
 
 /* inserts a feature at the end of the list, can create a new list */
-featureListNodeObjPtr insertFeatureList(featureListNodeObjPtr *list, shapeObj *shape)
-{
+featureListNodeObjPtr insertFeatureList(featureListNodeObjPtr *list,
+                                        shapeObj *shape) {
   featureListNodeObjPtr node;
 
-  node = (featureListNodeObjPtr) msSmallMalloc(sizeof(featureListNodeObj));
+  node = (featureListNodeObjPtr)msSmallMalloc(sizeof(featureListNodeObj));
 
   msInitShape(&(node->shape));
-  if(msCopyShape(shape, &(node->shape)) == -1) {
+  if (msCopyShape(shape, &(node->shape)) == -1) {
     msFree(node);
-    return(NULL);
+    return (NULL);
   }
 
-  /* AJS - alans@wunderground.com O(n^2) -> O(n) conversion, keep a pointer to the end */
+  /* AJS - alans@wunderground.com O(n^2) -> O(n) conversion, keep a pointer to
+   * the end */
 
-  /* set the tailifhead to NULL, since it is only set for the head of the list */
+  /* set the tailifhead to NULL, since it is only set for the head of the list
+   */
   node->tailifhead = NULL;
   node->next = NULL;
 
-  /* if we are at the head of the list, we need to set the list to node, before pointing tailifhead somewhere  */
-  if(*list == NULL) {
-    *list=node;
+  /* if we are at the head of the list, we need to set the list to node, before
+   * pointing tailifhead somewhere  */
+  if (*list == NULL) {
+    *list = node;
   } else {
-    if((*list)->tailifhead!=NULL) /* this should never be NULL, but just in case */
-      (*list)->tailifhead->next=node; /* put the node at the end of the list */
+    if ((*list)->tailifhead !=
+        NULL) /* this should never be NULL, but just in case */
+      (*list)->tailifhead->next =
+          node; /* put the node at the end of the list */
   }
 
   /* repoint the head of the list to the end  - our new element
@@ -897,13 +970,12 @@ featureListNodeObjPtr insertFeatureList(
      walk in a loop */
   (*list)->tailifhead = node;
 
-  return(node); /* a pointer to last object in the list */
+  return (node); /* a pointer to last object in the list */
 }
 
-void freeFeatureList(featureListNodeObjPtr list)
-{
+void freeFeatureList(featureListNodeObjPtr list) {
   featureListNodeObjPtr listNext = NULL;
-  while (list!=NULL) {
+  while (list != NULL) {
     listNext = list->next;
     msFreeShape(&(list->shape));
     msFree(list);
@@ -912,53 +984,59 @@ void freeFeatureList(featureListNodeObjP
 }
 
 /* lineObj = multipointObj */
-static int loadFeaturePoints(lineObj *points)
-{
+static int loadFeaturePoints(lineObj *points) {
   int ret = -1;
-  int buffer_size=0;
+  int buffer_size = 0;
 
-  points->point = (pointObj *)malloc(sizeof(pointObj)*MS_FEATUREINITSIZE);
-  MS_CHECK_ALLOC(points->point, sizeof(pointObj)*MS_FEATUREINITSIZE, MS_FAILURE);
+  points->point = (pointObj *)malloc(sizeof(pointObj) * MS_FEATUREINITSIZE);
+  MS_CHECK_ALLOC(points->point, sizeof(pointObj) * MS_FEATUREINITSIZE,
+                 MS_FAILURE);
   points->numpoints = 0;
   buffer_size = MS_FEATUREINITSIZE;
 
-  while( ret < 0 ) {
-    switch(msyylex()) {
-      case(EOF):
-        msSetError(MS_EOFERR, NULL, "loadFeaturePoints()");
-        ret = MS_FAILURE;
-        break;
-      case(END):
-        ret = MS_SUCCESS;
-        break;
-      case(MS_NUMBER):
-        if(points->numpoints == buffer_size) { /* just add it to the end */
-          pointObj* newPoints = (pointObj *) realloc(points->point, sizeof(pointObj)*(buffer_size+MS_FEATUREINCREMENT));
-          if( newPoints == NULL ) {
-            msSetError(MS_MEMERR, "%s: %d: Out of memory allocating %u bytes.\n", __FUNCTION__,
-                       __FILE__, __LINE__, (unsigned int)(sizeof(pointObj)*(buffer_size+MS_FEATUREINCREMENT)));
-            ret = MS_FAILURE;
-            break;
-          }
-          points->point = newPoints;
-          buffer_size+=MS_FEATUREINCREMENT;
-        }
-
-        points->point[points->numpoints].x = atof(msyystring_buffer);
-        if(getDouble(&(points->point[points->numpoints].y), MS_NUM_CHECK_NONE, -1, -1) == -1) {
+  while (ret < 0) {
+    switch (msyylex()) {
+    case (EOF):
+      msSetError(MS_EOFERR, NULL, "loadFeaturePoints()");
+      ret = MS_FAILURE;
+      break;
+    case (END):
+      ret = MS_SUCCESS;
+      break;
+    case (MS_NUMBER):
+      if (points->numpoints == buffer_size) { /* just add it to the end */
+        pointObj *newPoints = (pointObj *)realloc(
+            points->point,
+            sizeof(pointObj) * (buffer_size + MS_FEATUREINCREMENT));
+        if (newPoints == NULL) {
+          msSetError(MS_MEMERR, "%s: %d: Out of memory allocating %u bytes.\n",
+                     __FUNCTION__, __FILE__, __LINE__,
+                     (unsigned int)(sizeof(pointObj) *
+                                    (buffer_size + MS_FEATUREINCREMENT)));
           ret = MS_FAILURE;
           break;
         }
-        points->numpoints++;
-        break;
-      default:
-        msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)", "loadFeaturePoints()",  msyystring_buffer, msyylineno );
+        points->point = newPoints;
+        buffer_size += MS_FEATUREINCREMENT;
+      }
+
+      points->point[points->numpoints].x = atof(msyystring_buffer);
+      if (getDouble(&(points->point[points->numpoints].y), MS_NUM_CHECK_NONE,
+                    -1, -1) == -1) {
         ret = MS_FAILURE;
         break;
+      }
+      points->numpoints++;
+      break;
+    default:
+      msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)",
+                 "loadFeaturePoints()", msyystring_buffer, msyylineno);
+      ret = MS_FAILURE;
+      break;
     }
   }
 
-  if( ret == MS_FAILURE ) {
+  if (ret == MS_FAILURE) {
     msFree(points->point); /* clean up */
     points->point = NULL;
     points->numpoints = 0;
@@ -966,121 +1044,124 @@ static int loadFeaturePoints(lineObj *po
   return ret;
 }
 
-static int loadFeature(layerObj *player, int type)
-{
-  int status=MS_SUCCESS;
+static int loadFeature(layerObj *player, int type) {
+  int status = MS_SUCCESS;
   featureListNodeObjPtr *list = &(player->features);
-  multipointObj points= {0,NULL};
-  shapeObj *shape=NULL;
+  multipointObj points = {0, NULL};
+  shapeObj *shape = NULL;
 
-  shape = (shapeObj *) malloc(sizeof(shapeObj));
+  shape = (shapeObj *)malloc(sizeof(shapeObj));
   MS_CHECK_ALLOC(shape, sizeof(shapeObj), MS_FAILURE);
 
   msInitShape(shape);
   shape->type = type;
 
-  for(;;) {
-    switch(msyylex()) {
-      case(EOF):
-        msSetError(MS_EOFERR, NULL, "loadFeature()");
+  for (;;) {
+    switch (msyylex()) {
+    case (EOF):
+      msSetError(MS_EOFERR, NULL, "loadFeature()");
+      msFreeShape(shape); /* clean up */
+      msFree(shape);
+      return (MS_FAILURE);
+    case (END):
+      if (player->features != NULL && player->features->tailifhead != NULL)
+        shape->index = player->features->tailifhead->shape.index + 1;
+      else
+        shape->index = 0;
+      if (insertFeatureList(list, shape) == NULL)
+        status = MS_FAILURE;
+
+      msFreeShape(shape); /* clean up */
+      msFree(shape);
+
+      return (status);
+    case (FEATURE):
+      break; /* for string loads */
+    case (POINTS):
+      if (loadFeaturePoints(&points) == MS_FAILURE) {
         msFreeShape(shape); /* clean up */
         msFree(shape);
-        return(MS_FAILURE);
-      case(END):
-        if(player->features != NULL && player->features->tailifhead != NULL)
-          shape->index = player->features->tailifhead->shape.index + 1;
-        else
-          shape->index = 0;
-        if(insertFeatureList(list, shape) == NULL)
-          status = MS_FAILURE;
+        return (MS_FAILURE);
+      }
+      status = msAddLine(shape, &points);
 
+      msFree(points.point); /* clean up */
+      points.numpoints = 0;
+
+      if (status == MS_FAILURE) {
         msFreeShape(shape); /* clean up */
         msFree(shape);
-
-        return(status);
-      case(FEATURE):
-        break; /* for string loads */
-      case(POINTS):
-        if(loadFeaturePoints(&points) == MS_FAILURE) {
-          msFreeShape(shape); /* clean up */
-          msFree(shape);
-          return(MS_FAILURE);
-        }
-        status = msAddLine(shape, &points);
-
-        msFree(points.point); /* clean up */
-        points.numpoints = 0;
-
-        if(status == MS_FAILURE) {
-          msFreeShape(shape); /* clean up */
-          msFree(shape);
-          return(MS_FAILURE);
-        }
-        break;
-      case(ITEMS): {
-        char *string=NULL;
-        if(getString(&string) == MS_FAILURE) {
-          msFreeShape(shape); /* clean up */
-          msFree(shape);
-          return(MS_FAILURE);
-        }
-        if (string) {
-          if(shape->values) msFreeCharArray(shape->values, shape->numvalues);
-          shape->values = msStringSplitComplex(string, ";", &shape->numvalues,MS_ALLOWEMPTYTOKENS);
-          msFree(string); /* clean up */
-        }
-        break;
+        return (MS_FAILURE);
       }
-      case(TEXT):
-        if(getString(&shape->text) == MS_FAILURE) {
-          msFreeShape(shape); /* clean up */
-          msFree(shape);
-          return(MS_FAILURE);
-        }
-        break;
-      case(WKT): {
-        char *string=NULL;
+      break;
+    case (ITEMS): {
+      char *string = NULL;
+      if (getString(&string) == MS_FAILURE) {
+        msFreeShape(shape); /* clean up */
+        msFree(shape);
+        return (MS_FAILURE);
+      }
+      if (string) {
+        if (shape->values)
+          msFreeCharArray(shape->values, shape->numvalues);
+        shape->values = msStringSplitComplex(string, ";", &shape->numvalues,
+                                             MS_ALLOWEMPTYTOKENS);
+        msFree(string); /* clean up */
+      }
+      break;
+    }
+    case (TEXT):
+      if (getString(&shape->text) == MS_FAILURE) {
+        msFreeShape(shape); /* clean up */
+        msFree(shape);
+        return (MS_FAILURE);
+      }
+      break;
+    case (WKT): {
+      char *string = NULL;
 
-        /* todo, what do we do with multiple WKT property occurances? */
+      /* todo, what do we do with multiple WKT property occurances? */
 
-        msFreeShape(shape);
-        msFree(shape);
-        if(getString(&string) == MS_FAILURE) return(MS_FAILURE);
+      msFreeShape(shape);
+      msFree(shape);
+      if (getString(&string) == MS_FAILURE)
+        return (MS_FAILURE);
 
-        if((shape = msShapeFromWKT(string)) == NULL)
-          status = MS_FAILURE;
+      if ((shape = msShapeFromWKT(string)) == NULL)
+        status = MS_FAILURE;
 
-        msFree(string); /* clean up */
+      msFree(string); /* clean up */
 
-        if(status == MS_FAILURE) {
-          msFreeShape(shape); /* clean up */
-          msFree(shape);
-          return(MS_FAILURE);
-        }
-        break;
-      }
-      default:
-        msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)", "loadfeature()", msyystring_buffer, msyylineno);
+      if (status == MS_FAILURE) {
         msFreeShape(shape); /* clean up */
         msFree(shape);
-        return(MS_FAILURE);
+        return (MS_FAILURE);
+      }
+      break;
+    }
+    default:
+      msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)",
+                 "loadfeature()", msyystring_buffer, msyylineno);
+      msFreeShape(shape); /* clean up */
+      msFree(shape);
+      return (MS_FAILURE);
     }
   } /* next token */
 }
 
-static void writeFeature(FILE *stream, int indent, shapeObj *feature)
-{
-  int i,j;
+static void writeFeature(FILE *stream, int indent, shapeObj *feature) {
+  int i, j;
 
   indent++;
   writeBlockBegin(stream, indent, "FEATURE");
 
   indent++;
-  for(i=0; i<feature->numlines; i++) {
+  for (i = 0; i < feature->numlines; i++) {
     writeBlockBegin(stream, indent, "POINTS");
-    for(j=0; j<feature->line[i].numpoints; j++) {
+    for (j = 0; j < feature->line[i].numpoints; j++) {
       writeIndent(stream, indent);
-      msIO_fprintf(stream, "%.15g %.15g\n", feature->line[i].point[j].x, feature->line[i].point[j].y);
+      msIO_fprintf(stream, "%.15g %.15g\n", feature->line[i].point[j].x,
+                   feature->line[i].point[j].y);
     }
     writeBlockEnd(stream, indent, "POINTS");
   }
@@ -1089,7 +1170,7 @@ static void writeFeature(FILE *stream, i
   if (feature->numvalues) {
     writeIndent(stream, indent);
     msIO_fprintf(stream, "ITEMS \"");
-    for (i=0; i<feature->numvalues; i++) {
+    for (i = 0; i < feature->numvalues; i++) {
       if (i == 0)
         msIO_fprintf(stream, "%s", feature->values[i]);
       else
@@ -1102,73 +1183,77 @@ static void writeFeature(FILE *stream, i
   writeBlockEnd(stream, indent, "FEATURE");
 }
 
-void initGrid( graticuleObj *pGraticule )
-{
-  memset( pGraticule, 0, sizeof( graticuleObj ) );
+void initGrid(graticuleObj *pGraticule) {
+  memset(pGraticule, 0, sizeof(graticuleObj));
 }
 
-void freeGrid( graticuleObj *pGraticule )
-{
+void freeGrid(graticuleObj *pGraticule) {
   msFree(pGraticule->labelformat);
   msFree(pGraticule->pboundingpoints);
   msFree(pGraticule->pboundinglines);
 }
 
-static int loadGrid( layerObj *pLayer )
-{
-  for(;;) {
-    switch(msyylex()) {
-      case(EOF):
-        msSetError(MS_EOFERR, NULL, "loadGrid()");
-        return(-1);
-      case(END):
-        return(0);
-      case(GRID):
-        break; /* for string loads */
-      case( LABELFORMAT ):
-        if(getString(&(pLayer->grid->labelformat)) == MS_FAILURE) {
-          if(strcasecmp(msyystring_buffer, "DD") == 0) /* DD triggers a symbol to be returned instead of a string so check for this special case */ {
-            msFree(pLayer->grid->labelformat);
-            pLayer->grid->labelformat = msStrdup("DD");
-          }
-          else
-            return(-1);
-        }
-        break;
-      case( MINARCS ):
-        if(getDouble(&(pLayer->grid->minarcs), MS_NUM_CHECK_GT, 0, -1) == -1)
-          return(-1);
-        break;
-      case( MAXARCS ):
-        if(getDouble(&(pLayer->grid->maxarcs), MS_NUM_CHECK_GT, 0, -1) == -1)
-          return(-1);
-        break;
-      case( MININTERVAL ):
-        if(getDouble(&(pLayer->grid->minincrement), MS_NUM_CHECK_GT, 0, -1) == -1)
-          return(-1);
-        break;
-      case( MAXINTERVAL ):
-        if(getDouble(&(pLayer->grid->maxincrement), MS_NUM_CHECK_GT, 0, -1) == -1)
-          return(-1);
-        break;
-      case( MINSUBDIVIDE ):
-        if(getDouble(&(pLayer->grid->minsubdivides), MS_NUM_CHECK_GT, 0, -1) == -1)
-          return(-1);
-        break;
-      case( MAXSUBDIVIDE ):
-        if(getDouble(&(pLayer->grid->maxsubdivides), MS_NUM_CHECK_GT, 0, -1) == -1)
-          return(-1);
-        break;
-      default:
-        msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)", "loadGrid()", msyystring_buffer, msyylineno);
-        return(-1);
+static int loadGrid(layerObj *pLayer) {
+  for (;;) {
+    switch (msyylex()) {
+    case (EOF):
+      msSetError(MS_EOFERR, NULL, "loadGrid()");
+      return (-1);
+    case (END):
+      return (0);
+    case (GRID):
+      break; /* for string loads */
+    case (LABELFORMAT):
+      if (getString(&(pLayer->grid->labelformat)) == MS_FAILURE) {
+        if (strcasecmp(msyystring_buffer, "DD") ==
+            0) /* DD triggers a symbol to be returned instead of a string so
+                  check for this special case */
+        {
+          msFree(pLayer->grid->labelformat);
+          pLayer->grid->labelformat = msStrdup("DD");
+        } else
+          return (-1);
+      }
+      break;
+    case (MINARCS):
+      if (getDouble(&(pLayer->grid->minarcs), MS_NUM_CHECK_GT, 0, -1) == -1)
+        return (-1);
+      break;
+    case (MAXARCS):
+      if (getDouble(&(pLayer->grid->maxarcs), MS_NUM_CHECK_GT, 0, -1) == -1)
+        return (-1);
+      break;
+    case (MININTERVAL):
+      if (getDouble(&(pLayer->grid->minincrement), MS_NUM_CHECK_GT, 0, -1) ==
+          -1)
+        return (-1);
+      break;
+    case (MAXINTERVAL):
+      if (getDouble(&(pLayer->grid->maxincrement), MS_NUM_CHECK_GT, 0, -1) ==
+          -1)
+        return (-1);
+      break;
+    case (MINSUBDIVIDE):
+      if (getDouble(&(pLayer->grid->minsubdivides), MS_NUM_CHECK_GT, 0, -1) ==
+          -1)
+        return (-1);
+      break;
+    case (MAXSUBDIVIDE):
+      if (getDouble(&(pLayer->grid->maxsubdivides), MS_NUM_CHECK_GT, 0, -1) ==
+          -1)
+        return (-1);
+      break;
+    default:
+      msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)", "loadGrid()",
+                 msyystring_buffer, msyylineno);
+      return (-1);
     }
   }
 }
 
-static void writeGrid(FILE *stream, int indent, graticuleObj *pGraticule)
-{
-  if(!pGraticule) return;
+static void writeGrid(FILE *stream, int indent, graticuleObj *pGraticule) {
+  if (!pGraticule)
+    return;
 
   indent++;
   writeBlockBegin(stream, indent, "GRID");
@@ -1182,97 +1267,98 @@ static void writeGrid(FILE *stream, int
   writeBlockEnd(stream, indent, "GRID");
 }
 
-static int loadProjection(projectionObj *p)
-{
+static int loadProjection(projectionObj *p) {
   p->gt.need_geotransform = MS_FALSE;
 
-  if ( p->proj != NULL || p->numargs != 0 ) {
-    msSetError(MS_MISCERR, "Projection is already initialized. Multiple projection definitions are not allowed in this object. (line %d)",
+  if (p->proj != NULL || p->numargs != 0) {
+    msSetError(MS_MISCERR,
+               "Projection is already initialized. Multiple projection "
+               "definitions are not allowed in this object. (line %d)",
                "loadProjection()", msyylineno);
-    return(-1);
+    return (-1);
   }
 
-  for(;;) {
-    switch(msyylex()) {
-      case(EOF):
-        msSetError(MS_EOFERR, NULL, "loadProjection()");
-        return(-1);
-      case(END):
-        if( p->numargs == 1 && strstr(p->args[0],"+") != NULL ) {
-          char *one_line_def = p->args[0];
-          int result;
-
-          p->args[0] = NULL;
-          p->numargs = 0;
-          result = msLoadProjectionString( p, one_line_def );
-          free( one_line_def );
-          return result;
-        } else {
-          if(p->numargs != 0)
-            return msProcessProjection(p);
-          else
-            return 0;
-        }
-        break;
-      case(MS_STRING):
-      case(MS_AUTO):
-        if( p->numargs == MS_MAXPROJARGS ) {
-            msSetError(MS_MISCERR, "Parsing error near (%s):(line %d): Too many arguments in projection string", "loadProjection()",
-                   msyystring_buffer, msyylineno);
-            return -1;
-        }
-        p->args[p->numargs] = msStrdup(msyystring_buffer);
-        p->automatic = MS_TRUE;
-        p->numargs++;
-        break;
-      default:
-        msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)", "loadProjection()",
-                   msyystring_buffer, msyylineno);
-        return(-1);
+  for (;;) {
+    switch (msyylex()) {
+    case (EOF):
+      msSetError(MS_EOFERR, NULL, "loadProjection()");
+      return (-1);
+    case (END):
+      if (p->numargs == 1 && strstr(p->args[0], "+") != NULL) {
+        char *one_line_def = p->args[0];
+        int result;
+
+        p->args[0] = NULL;
+        p->numargs = 0;
+        result = msLoadProjectionString(p, one_line_def);
+        free(one_line_def);
+        return result;
+      } else {
+        if (p->numargs != 0)
+          return msProcessProjection(p);
+        else
+          return 0;
+      }
+      break;
+    case (MS_STRING):
+    case (MS_AUTO):
+      if (p->numargs == MS_MAXPROJARGS) {
+        msSetError(MS_MISCERR,
+                   "Parsing error near (%s):(line %d): Too many arguments in "
+                   "projection string",
+                   "loadProjection()", msyystring_buffer, msyylineno);
+        return -1;
+      }
+      p->args[p->numargs] = msStrdup(msyystring_buffer);
+      p->automatic = MS_TRUE;
+      p->numargs++;
+      break;
+    default:
+      msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)",
+                 "loadProjection()", msyystring_buffer, msyylineno);
+      return (-1);
     }
   } /* next token */
 }
 
-
 /************************************************************************/
 /*                     msLoadProjectionStringEPSGLike                   */
 /************************************************************************/
 
 static int msLoadProjectionStringEPSGLike(projectionObj *p, const char *value,
-                                          const char* pszPrefix,
-                                          int bFollowEPSGAxisOrder)
-{
-    size_t buffer_size = 0;
-    char *init_string =  NULL;
-    const char *code;
-    const char *next_sep;
-    size_t prefix_len;
+                                          const char *pszPrefix,
+                                          int bFollowEPSGAxisOrder) {
+  size_t buffer_size = 0;
+  char *init_string = NULL;
+  const char *code;
+  const char *next_sep;
+  size_t prefix_len;
 
-    prefix_len = strlen(pszPrefix);
-    if( strncasecmp(value, pszPrefix, prefix_len) != 0 )
-        return -1;
+  prefix_len = strlen(pszPrefix);
+  if (strncasecmp(value, pszPrefix, prefix_len) != 0)
+    return -1;
 
-    code = value + prefix_len;
-    next_sep = strchr(code, pszPrefix[prefix_len-1]);
-    if( next_sep != NULL )
-        code = next_sep + 1;
+  code = value + prefix_len;
+  next_sep = strchr(code, pszPrefix[prefix_len - 1]);
+  if (next_sep != NULL)
+    code = next_sep + 1;
 
-    buffer_size = 10 + strlen(code) + 1;
-    init_string = (char*)msSmallMalloc(buffer_size);
+  buffer_size = 10 + strlen(code) + 1;
+  init_string = (char *)msSmallMalloc(buffer_size);
 
-    /* translate into PROJ.4 format. */
-    snprintf( init_string, buffer_size, "init=epsg:%s", code );
+  /* translate into PROJ.4 format. */
+  snprintf(init_string, buffer_size, "init=epsg:%s", code);
 
-    p->args = (char**)msSmallMalloc(sizeof(char*) * 2);
-    p->args[0] = init_string;
-    p->numargs = 1;
+  p->args = (char **)msSmallMalloc(sizeof(char *) * 2);
+  p->args[0] = init_string;
+  p->numargs = 1;
 
-    if( bFollowEPSGAxisOrder && msIsAxisInverted(atoi(code))) {
-      p->args[1] = msStrdup("+epsgaxis=ne");
-      p->numargs = 2;
-    }
+  if (bFollowEPSGAxisOrder && msIsAxisInverted(atoi(code))) {
+    p->args[1] = msStrdup("+epsgaxis=ne");
+    p->numargs = 2;
+  }
 
-    return 0;
+  return 0;
 }
 
 /************************************************************************/
@@ -1280,43 +1366,40 @@ static int msLoadProjectionStringEPSGLik
 /************************************************************************/
 
 static int msLoadProjectionStringCRSLike(projectionObj *p, const char *value,
-                                         const char* pszPrefix)
-{
-    char init_string[100];
-    const char *id;
-    const char *next_sep;
-    size_t prefix_len;
-
-    prefix_len = strlen(pszPrefix);
-    if( strncasecmp(value, pszPrefix, prefix_len) != 0 )
-        return -1;
-
-    id = value + prefix_len;
-    next_sep = strchr(id, pszPrefix[prefix_len-1]);
-    if( next_sep != NULL )
-        id = next_sep + 1;
-
-    init_string[0] = '\0';
-
-    if( strcasecmp(id,"84") == 0 || strcasecmp(id,"CRS84") == 0 )
-      strncpy( init_string, "init=epsg:4326", sizeof(init_string) );
-    else if( strcasecmp(id,"83") == 0 || strcasecmp(id,"CRS83") == 0 )
-      strncpy( init_string, "init=epsg:4269", sizeof(init_string) );
-    else if( strcasecmp(id,"27") == 0 || strcasecmp(id,"CRS27") == 0 )
-      strncpy( init_string, "init=epsg:4267", sizeof(init_string) );
-    else {
-      msSetError( MS_PROJERR,
-                  "Unrecognised OGC CRS def '%s'.",
-                  "msLoadProjectionString()",
-                  value );
-      return -1;
-    }
+                                         const char *pszPrefix) {
+  char init_string[100];
+  const char *id;
+  const char *next_sep;
+  size_t prefix_len;
+
+  prefix_len = strlen(pszPrefix);
+  if (strncasecmp(value, pszPrefix, prefix_len) != 0)
+    return -1;
+
+  id = value + prefix_len;
+  next_sep = strchr(id, pszPrefix[prefix_len - 1]);
+  if (next_sep != NULL)
+    id = next_sep + 1;
+
+  init_string[0] = '\0';
+
+  if (strcasecmp(id, "84") == 0 || strcasecmp(id, "CRS84") == 0)
+    strncpy(init_string, "init=epsg:4326", sizeof(init_string));
+  else if (strcasecmp(id, "83") == 0 || strcasecmp(id, "CRS83") == 0)
+    strncpy(init_string, "init=epsg:4269", sizeof(init_string));
+  else if (strcasecmp(id, "27") == 0 || strcasecmp(id, "CRS27") == 0)
+    strncpy(init_string, "init=epsg:4267", sizeof(init_string));
+  else {
+    msSetError(MS_PROJERR, "Unrecognised OGC CRS def '%s'.",
+               "msLoadProjectionString()", value);
+    return -1;
+  }
 
-    p->args = (char**)msSmallMalloc(sizeof(char*) * 2);
-    p->args[0] = msStrdup(init_string);
-    p->numargs = 1;
+  p->args = (char **)msSmallMalloc(sizeof(char *) * 2);
+  p->args[0] = msStrdup(init_string);
+  p->numargs = 1;
 
-    return 0;
+  return 0;
 }
 
 /************************************************************************/
@@ -1326,33 +1409,30 @@ static int msLoadProjectionStringCRSLike
 /*      certain code ranges.                                            */
 /*      Use for now in WMS 1.3.0 and WFS >= 1.1.0                       */
 /************************************************************************/
-int msLoadProjectionStringEPSG(projectionObj *p, const char *value)
-{
+int msLoadProjectionStringEPSG(projectionObj *p, const char *value) {
   assert(p);
 
   msFreeProjectionExceptContext(p);
 
   p->gt.need_geotransform = MS_FALSE;
 #ifdef USE_PROJ_FASTPATHS
-  if(strcasestr(value,"epsg:4326")) {
+  if (strcasestr(value, "epsg:4326")) {
     p->wellknownprojection = wkp_lonlat;
-  } else if(strcasestr(value,"epsg:3857")) {
+  } else if (strcasestr(value, "epsg:3857")) {
     p->wellknownprojection = wkp_gmerc;
   } else {
     p->wellknownprojection = wkp_none;
   }
 #endif
 
-  if( msLoadProjectionStringEPSGLike(p, value, "EPSG:", MS_TRUE) == 0 )
-  {
-    return msProcessProjection( p );
+  if (msLoadProjectionStringEPSGLike(p, value, "EPSG:", MS_TRUE) == 0) {
+    return msProcessProjection(p);
   }
 
   return msLoadProjectionString(p, value);
 }
 
-int msLoadProjectionString(projectionObj *p, const char *value)
-{
+int msLoadProjectionString(projectionObj *p, const char *value) {
   assert(p);
   p->gt.need_geotransform = MS_FALSE;
 
@@ -1364,70 +1444,80 @@ int msLoadProjectionString(projectionObj
    * eg.
    *    "+proj=utm +zone=11 +ellps=WGS84"
    */
-  if( value[0] == '+' ) {
-    char  *trimmed;
-    int i, i_out=0;
-
-    trimmed = msStrdup(value+1);
-    for( i = 1; value[i] != '\0'; i++ ) {
-      if( !isspace( value[i] ) )
+  if (value[0] == '+') {
+    char *trimmed;
+    int i, i_out = 0;
+
+    trimmed = msStrdup(value + 1);
+    for (i = 1; value[i] != '\0'; i++) {
+      if (!isspace(value[i]))
         trimmed[i_out++] = value[i];
     }
     trimmed[i_out] = '\0';
 
-    p->args = msStringSplit(trimmed,'+', &p->numargs);
-    free( trimmed );
+    p->args = msStringSplit(trimmed, '+', &p->numargs);
+    free(trimmed);
   } else if (strncasecmp(value, "AUTO:", 5) == 0 ||
              strncasecmp(value, "AUTO2:", 6) == 0) {
     /* WMS/WFS AUTO projection: "AUTO:proj_id,units_id,lon0,lat0" */
     /* WMS 1.3.0 projection: "AUTO2:auto_crs_id,factor,lon0,lat0"*/
     /* Keep the projection defn into a single token for writeProjection() */
     /* to work fine. */
-    p->args = (char**)msSmallMalloc(sizeof(char*));
+    p->args = (char **)msSmallMalloc(sizeof(char *));
     p->args[0] = msStrdup(value);
     p->numargs = 1;
-  } else if (msLoadProjectionStringEPSGLike(p, value, "EPSG:", MS_FALSE) == 0 ) {
-   /* Assume lon/lat ordering. Use msLoadProjectionStringEPSG() if wanting to follow EPSG axis */
-  } else if (msLoadProjectionStringEPSGLike(p, value, "urn:ogc:def:crs:EPSG:", MS_TRUE) == 0 ) {
-  } else if (msLoadProjectionStringEPSGLike(p, value, "urn:EPSG:geographicCRS:", MS_TRUE) == 0 ) {
-  } else if (msLoadProjectionStringEPSGLike(p, value, "urn:x-ogc:def:crs:EPSG:", MS_TRUE) == 0 ) {
+  } else if (msLoadProjectionStringEPSGLike(p, value, "EPSG:", MS_FALSE) == 0) {
+    /* Assume lon/lat ordering. Use msLoadProjectionStringEPSG() if wanting to
+     * follow EPSG axis */
+  } else if (msLoadProjectionStringEPSGLike(
+                 p, value, "urn:ogc:def:crs:EPSG:", MS_TRUE) == 0) {
+  } else if (msLoadProjectionStringEPSGLike(
+                 p, value, "urn:EPSG:geographicCRS:", MS_TRUE) == 0) {
+  } else if (msLoadProjectionStringEPSGLike(
+                 p, value, "urn:x-ogc:def:crs:EPSG:", MS_TRUE) == 0) {
     /*this case is to account for OGC CITE tests where x-ogc was used
       before the ogc name became an official NID. Note also we also account
-      for the fact that a space for the version of the espg is not used with CITE tests.
-      (Syntax used could be urn:ogc:def:objectType:authority:code)*/
-  } else if (msLoadProjectionStringCRSLike(p, value, "urn:ogc:def:crs:OGC:") == 0 ) {
-  } else if (msLoadProjectionStringEPSGLike(p, value, "http://www.opengis.net/def/crs/EPSG/", MS_TRUE) == 0 ) {
+      for the fact that a space for the version of the espg is not used with
+      CITE tests. (Syntax used could be urn:ogc:def:objectType:authority:code)*/
+  } else if (msLoadProjectionStringCRSLike(p, value, "urn:ogc:def:crs:OGC:") ==
+             0) {
+  } else if (msLoadProjectionStringEPSGLike(
+                 p, value, "http://www.opengis.net/def/crs/EPSG/", MS_TRUE) ==
+             0) {
     /* URI projection support */
-  } else if (msLoadProjectionStringCRSLike(p, value, "http://www.opengis.net/def/crs/OGC/") == 0 ) {
-    /* Mandatory support for this URI format specified in WFS1.1 (also in 1.0?) */
-  } else if (msLoadProjectionStringEPSGLike(p, value, "http://www.opengis.net/gml/srs/epsg.xml#", MS_FALSE) == 0 ) {
+  } else if (msLoadProjectionStringCRSLike(
+                 p, value, "http://www.opengis.net/def/crs/OGC/") == 0) {
+    /* Mandatory support for this URI format specified in WFS1.1 (also in 1.0?)
+     */
+  } else if (msLoadProjectionStringEPSGLike(
+                 p, value, "http://www.opengis.net/gml/srs/epsg.xml#",
+                 MS_FALSE) == 0) {
     /* We assume always lon/lat ordering, as that is what GeoServer does... */
-  } else if (msLoadProjectionStringCRSLike(p, value, "CRS:") == 0 ) {
+  } else if (msLoadProjectionStringCRSLike(p, value, "CRS:") == 0) {
   }
   /*
    * Handle old style comma delimited.  eg. "proj=utm,zone=11,ellps=WGS84".
    */
   else {
-    p->args = msStringSplit(value,',', &p->numargs);
+    p->args = msStringSplit(value, ',', &p->numargs);
   }
 
-  return msProcessProjection( p );
+  return msProcessProjection(p);
 }
 
-static void writeProjection(FILE *stream, int indent, projectionObj *p)
-{
+static void writeProjection(FILE *stream, int indent, projectionObj *p) {
   int i;
 
-  if(!p || p->numargs <= 0) return;
+  if (!p || p->numargs <= 0)
+    return;
   indent++;
   writeBlockBegin(stream, indent, "PROJECTION");
-  for(i=0; i<p->numargs; i++)
+  for (i = 0; i < p->numargs; i++)
     writeString(stream, indent, NULL, NULL, p->args[i]);
   writeBlockEnd(stream, indent, "PROJECTION");
 }
 
-void initLeader(labelLeaderObj *leader)
-{
+void initLeader(labelLeaderObj *leader) {
   leader->gridstep = 5;
   leader->maxdistance = 0;
 
@@ -1441,18 +1531,17 @@ void initLeader(labelLeaderObj *leader)
 /*
 ** Initialize, load and free a labelObj structure
 */
-void initLabel(labelObj *label)
-{
+void initLabel(labelObj *label) {
   int i;
 
   MS_REFCNT_INIT(label);
 
   label->align = MS_ALIGN_DEFAULT;
-  MS_INIT_COLOR(label->color, 0,0,0,255);
-  MS_INIT_COLOR(label->outlinecolor, -1,-1,-1,255); /* don't use it */
-  label->outlinewidth=1;
+  MS_INIT_COLOR(label->color, 0, 0, 0, 255);
+  MS_INIT_COLOR(label->outlinecolor, -1, -1, -1, 255); /* don't use it */
+  label->outlinewidth = 1;
 
-  MS_INIT_COLOR(label->shadowcolor, -1,-1,-1,255); /* don't use it */
+  MS_INIT_COLOR(label->shadowcolor, -1, -1, -1, 255); /* don't use it */
   label->shadowsizex = label->shadowsizey = 1;
 
   label->font = NULL;
@@ -1465,17 +1554,17 @@ void initLabel(labelObj *label)
   label->maxsize = MS_MAXFONTSIZE;
   label->buffer = 0;
   label->offsetx = label->offsety = 0;
-  label->minscaledenom=-1;
-  label->maxscaledenom=-1;
+  label->minscaledenom = -1;
+  label->maxscaledenom = -1;
   label->minfeaturesize = -1; /* no limit */
   label->autominfeaturesize = MS_FALSE;
-  label->mindistance = -1; /* no limit */
-  label->repeatdistance = 0; /* no repeat */
+  label->mindistance = -1;       /* no limit */
+  label->repeatdistance = 0;     /* no repeat */
   label->maxoverlapangle = 22.5; /* default max overlap angle */
   label->partials = MS_FALSE;
   label->wrap = '\0';
   label->maxlength = 0;
-  label->space_size_10=0.0;
+  label->space_size_10 = 0.0;
 
   label->encoding = NULL;
 
@@ -1490,7 +1579,7 @@ void initLabel(labelObj *label)
 
   label->numbindings = 0;
   label->nexprbindings = 0;
-  for(i=0; i<MS_LABEL_BINDING_LENGTH; i++) {
+  for (i = 0; i < MS_LABEL_BINDING_LENGTH; i++) {
     label->bindings[i].item = NULL;
     label->bindings[i].index = -1;
     msInitExpression(&(label->exprBindings[i]));
@@ -1507,11 +1596,10 @@ void initLabel(labelObj *label)
   return;
 }
 
-int freeLabelLeader(labelLeaderObj *leader)
-{
+int freeLabelLeader(labelLeaderObj *leader) {
   int i;
-  for(i=0; i<leader->numstyles; i++) {
-    if(freeStyle(leader->styles[i]) == MS_SUCCESS) {
+  for (i = 0; i < leader->numstyles; i++) {
+    if (freeStyle(leader->styles[i]) == MS_SUCCESS) {
       msFree(leader->styles[i]);
     }
   }
@@ -1519,27 +1607,26 @@ int freeLabelLeader(labelLeaderObj *lead
 
   return MS_SUCCESS;
 }
-int freeLabel(labelObj *label)
-{
+int freeLabel(labelObj *label) {
   int i;
 
-  if( MS_REFCNT_DECR_IS_NOT_ZERO(label) ) {
+  if (MS_REFCNT_DECR_IS_NOT_ZERO(label)) {
     return MS_FAILURE;
   }
 
   msFree(label->font);
   msFree(label->encoding);
 
-  for(i=0; i<label->numstyles; i++) { /* each style */
-    if(label->styles[i]!=NULL) {
-      if(freeStyle(label->styles[i]) == MS_SUCCESS) {
+  for (i = 0; i < label->numstyles; i++) { /* each style */
+    if (label->styles[i] != NULL) {
+      if (freeStyle(label->styles[i]) == MS_SUCCESS) {
         msFree(label->styles[i]);
       }
     }
   }
   msFree(label->styles);
 
-  for(i=0; i<MS_LABEL_BINDING_LENGTH; i++) {
+  for (i = 0; i < MS_LABEL_BINDING_LENGTH; i++) {
     msFree(label->bindings[i].item);
     msFreeExpression(&(label->exprBindings[i]));
   }
@@ -1547,7 +1634,7 @@ int freeLabel(labelObj *label)
   msFreeExpression(&(label->expression));
   msFreeExpression(&(label->text));
 
-  if(label->leader) {
+  if (label->leader) {
     freeLabelLeader(label->leader);
     msFree(label->leader);
     label->leader = NULL;
@@ -1556,330 +1643,403 @@ int freeLabel(labelObj *label)
   return MS_SUCCESS;
 }
 
-static int loadLeader(labelLeaderObj *leader)
-{
-  for(;;) {
-    switch(msyylex()) {
-      case(END):
-        return(0);
-        break;
-      case(EOF):
-        msSetError(MS_EOFERR, NULL, "loadLeader()");
-        return(-1);
-      case GRIDSTEP:
-        if(getInteger(&(leader->gridstep), MS_NUM_CHECK_GT, 0, -1) == -1) return(-1);
-        break;
-      case MAXDISTANCE:
-        if(getInteger(&(leader->maxdistance), MS_NUM_CHECK_GT, 0, -1) == -1) return(-1);
-        break;
-      case STYLE:
-        if(msGrowLeaderStyles(leader) == NULL)
-          return(-1);
-        initStyle(leader->styles[leader->numstyles]);
-        if(loadStyle(leader->styles[leader->numstyles]) != MS_SUCCESS)
-        {
-            freeStyle(leader->styles[leader->numstyles]);
-            free(leader->styles[leader->numstyles]);
-            leader->styles[leader->numstyles] = NULL;
-            return -1;
-        }
-        leader->numstyles++;
-        break;
-      default:
-        if(strlen(msyystring_buffer) > 0) {
-          msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)", "loadLeader()", msyystring_buffer, msyylineno);
-          return(-1);
-        } else {
-          return(0); /* end of a string, not an error */
-        }
+static int loadLeader(labelLeaderObj *leader) {
+  for (;;) {
+    switch (msyylex()) {
+    case (END):
+      return (0);
+      break;
+    case (EOF):
+      msSetError(MS_EOFERR, NULL, "loadLeader()");
+      return (-1);
+    case GRIDSTEP:
+      if (getInteger(&(leader->gridstep), MS_NUM_CHECK_GT, 0, -1) == -1)
+        return (-1);
+      break;
+    case MAXDISTANCE:
+      if (getInteger(&(leader->maxdistance), MS_NUM_CHECK_GT, 0, -1) == -1)
+        return (-1);
+      break;
+    case STYLE:
+      if (msGrowLeaderStyles(leader) == NULL)
+        return (-1);
+      initStyle(leader->styles[leader->numstyles]);
+      if (loadStyle(leader->styles[leader->numstyles]) != MS_SUCCESS) {
+        freeStyle(leader->styles[leader->numstyles]);
+        free(leader->styles[leader->numstyles]);
+        leader->styles[leader->numstyles] = NULL;
+        return -1;
+      }
+      leader->numstyles++;
+      break;
+    default:
+      if (strlen(msyystring_buffer) > 0) {
+        msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)",
+                   "loadLeader()", msyystring_buffer, msyylineno);
+        return (-1);
+      } else {
+        return (0); /* end of a string, not an error */
+      }
     }
   }
 }
 
-static int loadLabel(labelObj *label)
-{
+static int loadLabel(labelObj *label) {
   int symbol;
 
-  for(;;) {
-    switch(msyylex()) {
-      case(ANGLE):
-        if((symbol = getSymbol(5, MS_NUMBER,MS_AUTO,MS_AUTO2,MS_FOLLOW,MS_BINDING)) == -1)
-          return(-1);
-
-        if(symbol == MS_NUMBER) {
-          if(msCheckNumber(msyynumber, MS_NUM_CHECK_RANGE, -360.0, 360.0) == MS_FAILURE) {
-            msSetError(MS_MISCERR, "Invalid ANGLE, must be between -360 and 360 (line %d)", "loadLabel()", msyylineno);
-            return(MS_FAILURE);
-          }
-          label->angle = (double) msyynumber;
-        } else if(symbol == MS_BINDING) {
-          if (label->bindings[MS_LABEL_BINDING_ANGLE].item != NULL)
-            msFree(label->bindings[MS_LABEL_BINDING_ANGLE].item);
-          label->bindings[MS_LABEL_BINDING_ANGLE].item = msStrdup(msyystring_buffer);
-          label->numbindings++;
-        } else {
-          label->anglemode = symbol;
-        }
-        break;
-      case(ALIGN):
-        if((symbol = getSymbol(4, MS_ALIGN_LEFT,MS_ALIGN_CENTER,MS_ALIGN_RIGHT,MS_BINDING)) == -1)
-          return(-1);
-        if((symbol == MS_ALIGN_LEFT)||(symbol == MS_ALIGN_CENTER)||(symbol == MS_ALIGN_RIGHT)) {
-          label->align = symbol;
-        } else {
-          if (label->bindings[MS_LABEL_BINDING_ALIGN].item != NULL)
-            msFree(label->bindings[MS_LABEL_BINDING_ALIGN].item);
-          label->bindings[MS_LABEL_BINDING_ALIGN].item = msStrdup(msyystring_buffer);
-          label->numbindings++;
-        }
-        break;
-      case(ANTIALIAS): /*ignore*/
-        msyylex();
-        break;
-      case(BUFFER):
-        if(getInteger(&(label->buffer), MS_NUM_CHECK_NONE, -1, -1) == -1) return(-1);
-        break;
-      case(COLOR):
-        if(loadColor(&(label->color), &(label->bindings[MS_LABEL_BINDING_COLOR])) != MS_SUCCESS) return(-1);
-        if(label->bindings[MS_LABEL_BINDING_COLOR].item) label->numbindings++;
-        break;
-      case(ENCODING):
-        if((getString(&label->encoding)) == MS_FAILURE) return(-1);
-        break;
-      case(END):
-        return(0);
-        break;
-      case(EOF):
-        msSetError(MS_EOFERR, NULL, "loadLabel()");
-        return(-1);
-      case(EXPRESSION):
-        if(loadExpression(&(label->expression)) == -1) return(-1); /* loadExpression() cleans up previously allocated expression */
-        break;
-      case(FONT):
-        if((symbol = getSymbol(2, MS_STRING, MS_BINDING)) == -1)
-          return(-1);
-
-        if(symbol == MS_STRING) {
-          if (label->font != NULL)
-            msFree(label->font);
-          label->font = msStrdup(msyystring_buffer);
-        } else {
-          if (label->bindings[MS_LABEL_BINDING_FONT].item != NULL)
-            msFree(label->bindings[MS_LABEL_BINDING_FONT].item);
-          label->bindings[MS_LABEL_BINDING_FONT].item = msStrdup(msyystring_buffer);
-          label->numbindings++;
-        }
-        break;
-      case(FORCE):
-        switch(msyylex()) {
-          case MS_ON:
-            label->force = MS_ON;
-            break;
-          case MS_OFF:
-            label->force = MS_OFF;
-            break;
-          case GROUP:
-            label->force = MS_LABEL_FORCE_GROUP;
-            break;
-          default:
-            msSetError(MS_MISCERR, "Invalid FORCE, must be ON,OFF,or GROUP (line %d)" , "loadLabel()", msyylineno);
-            return(-1);
-        }
-        break;
-      case(LABEL):
-        break; /* for string loads */
-      case(LEADER):
-        msSetError(MS_MISCERR, "LABEL LEADER not implemented. LEADER goes at the CLASS level (line %d)" , "loadLabel()", msyylineno);
-        return(-1);
-      case(MAXSIZE):
-        if(getInteger(&(label->maxsize), MS_NUM_CHECK_GT, 0, -1) == -1) return(-1);
-        break;
-      case(MAXSCALEDENOM):
-        if(getDouble(&(label->maxscaledenom), MS_NUM_CHECK_GTE, 0, -1) == -1) return(-1);
-        break;
-      case(MAXLENGTH):
-        if(getInteger(&(label->maxlength), MS_NUM_CHECK_GT, 0, -1) == -1) return(-1);
-        break;
-      case(MINDISTANCE):
-        if(getInteger(&(label->mindistance), MS_NUM_CHECK_GT, 0, -1) == -1) return(-1);
-        break;
-      case(REPEATDISTANCE):
-        if(getInteger(&(label->repeatdistance), MS_NUM_CHECK_GT, 0, -1) == -1) return(-1);
-        break;
-      case(MAXOVERLAPANGLE):
-        if(getDouble(&(label->maxoverlapangle), MS_NUM_CHECK_RANGE, 0, 360) == -1) return(-1);
-        break;
-      case(MINFEATURESIZE):
-        if((symbol = getSymbol(2, MS_NUMBER,MS_AUTO)) == -1) return(-1);
-        if(symbol == MS_NUMBER) {
-	  if(msCheckNumber(msyynumber, MS_NUM_CHECK_GT, 0, -1) == MS_FAILURE) {
-            msSetError(MS_MISCERR, "Invalid MINFEATURESIZE, must be greater than 0 (line %d)", "loadLabel()", msyylineno);
-            return(MS_FAILURE);
-          }
-          label->minfeaturesize = (int)msyynumber;
-        } else
-          label->autominfeaturesize = MS_TRUE;
+  for (;;) {
+    switch (msyylex()) {
+    case (ANGLE):
+      if ((symbol = getSymbol(5, MS_NUMBER, MS_AUTO, MS_AUTO2, MS_FOLLOW,
+                              MS_BINDING)) == -1)
+        return (-1);
+
+      if (symbol == MS_NUMBER) {
+        if (msCheckNumber(msyynumber, MS_NUM_CHECK_RANGE, -360.0, 360.0) ==
+            MS_FAILURE) {
+          msSetError(MS_MISCERR,
+                     "Invalid ANGLE, must be between -360 and 360 (line %d)",
+                     "loadLabel()", msyylineno);
+          return (MS_FAILURE);
+        }
+        label->angle = (double)msyynumber;
+      } else if (symbol == MS_BINDING) {
+        if (label->bindings[MS_LABEL_BINDING_ANGLE].item != NULL)
+          msFree(label->bindings[MS_LABEL_BINDING_ANGLE].item);
+        label->bindings[MS_LABEL_BINDING_ANGLE].item =
+            msStrdup(msyystring_buffer);
+        label->numbindings++;
+      } else {
+        label->anglemode = symbol;
+      }
+      break;
+    case (ALIGN):
+      if ((symbol = getSymbol(4, MS_ALIGN_LEFT, MS_ALIGN_CENTER, MS_ALIGN_RIGHT,
+                              MS_BINDING)) == -1)
+        return (-1);
+      if ((symbol == MS_ALIGN_LEFT) || (symbol == MS_ALIGN_CENTER) ||
+          (symbol == MS_ALIGN_RIGHT)) {
+        label->align = symbol;
+      } else {
+        if (label->bindings[MS_LABEL_BINDING_ALIGN].item != NULL)
+          msFree(label->bindings[MS_LABEL_BINDING_ALIGN].item);
+        label->bindings[MS_LABEL_BINDING_ALIGN].item =
+            msStrdup(msyystring_buffer);
+        label->numbindings++;
+      }
+      break;
+    case (ANTIALIAS): /*ignore*/
+      msyylex();
+      break;
+    case (BUFFER):
+      if (getInteger(&(label->buffer), MS_NUM_CHECK_NONE, -1, -1) == -1)
+        return (-1);
+      break;
+    case (COLOR):
+      if (loadColor(&(label->color),
+                    &(label->bindings[MS_LABEL_BINDING_COLOR])) != MS_SUCCESS)
+        return (-1);
+      if (label->bindings[MS_LABEL_BINDING_COLOR].item)
+        label->numbindings++;
+      break;
+    case (ENCODING):
+      if ((getString(&label->encoding)) == MS_FAILURE)
+        return (-1);
+      break;
+    case (END):
+      return (0);
+      break;
+    case (EOF):
+      msSetError(MS_EOFERR, NULL, "loadLabel()");
+      return (-1);
+    case (EXPRESSION):
+      if (loadExpression(&(label->expression)) == -1)
+        return (-1); /* loadExpression() cleans up previously allocated
+                        expression */
+      break;
+    case (FONT):
+      if ((symbol = getSymbol(2, MS_STRING, MS_BINDING)) == -1)
+        return (-1);
+
+      if (symbol == MS_STRING) {
+        if (label->font != NULL)
+          msFree(label->font);
+        label->font = msStrdup(msyystring_buffer);
+      } else {
+        if (label->bindings[MS_LABEL_BINDING_FONT].item != NULL)
+          msFree(label->bindings[MS_LABEL_BINDING_FONT].item);
+        label->bindings[MS_LABEL_BINDING_FONT].item =
+            msStrdup(msyystring_buffer);
+        label->numbindings++;
+      }
+      break;
+    case (FORCE):
+      switch (msyylex()) {
+      case MS_ON:
+        label->force = MS_ON;
         break;
-      case(MINSCALEDENOM):
-        if(getDouble(&(label->minscaledenom), MS_NUM_CHECK_GTE, 0, -1) == -1) return(-1);
+      case MS_OFF:
+        label->force = MS_OFF;
         break;
-      case(MINSIZE):
-        if(getInteger(&(label->minsize), MS_NUM_CHECK_GT, 0, -1) == -1) return(-1);
+      case GROUP:
+        label->force = MS_LABEL_FORCE_GROUP;
         break;
-      case(OFFSET):
-        if((symbol = getSymbol(2, MS_NUMBER,MS_BINDING)) == -1) return(MS_FAILURE);
-        if(symbol == MS_NUMBER)
-          label->offsetx = (int) msyynumber; // any integer ok
-        else {
-          if (label->bindings[MS_LABEL_BINDING_OFFSET_X].item != NULL)
-            msFree(label->bindings[MS_LABEL_BINDING_OFFSET_X].item);
-          label->bindings[MS_LABEL_BINDING_OFFSET_X].item = msStrdup(msyystring_buffer);
-          label->numbindings++;
-        }
+      default:
+        msSetError(MS_MISCERR,
+                   "Invalid FORCE, must be ON,OFF,or GROUP (line %d)",
+                   "loadLabel()", msyylineno);
+        return (-1);
+      }
+      break;
+    case (LABEL):
+      break; /* for string loads */
+    case (LEADER):
+      msSetError(MS_MISCERR,
+                 "LABEL LEADER not implemented. LEADER goes at the CLASS level "
+                 "(line %d)",
+                 "loadLabel()", msyylineno);
+      return (-1);
+    case (MAXSIZE):
+      if (getInteger(&(label->maxsize), MS_NUM_CHECK_GT, 0, -1) == -1)
+        return (-1);
+      break;
+    case (MAXSCALEDENOM):
+      if (getDouble(&(label->maxscaledenom), MS_NUM_CHECK_GTE, 0, -1) == -1)
+        return (-1);
+      break;
+    case (MAXLENGTH):
+      if (getInteger(&(label->maxlength), MS_NUM_CHECK_GT, 0, -1) == -1)
+        return (-1);
+      break;
+    case (MINDISTANCE):
+      if (getInteger(&(label->mindistance), MS_NUM_CHECK_GT, 0, -1) == -1)
+        return (-1);
+      break;
+    case (REPEATDISTANCE):
+      if (getInteger(&(label->repeatdistance), MS_NUM_CHECK_GT, 0, -1) == -1)
+        return (-1);
+      break;
+    case (MAXOVERLAPANGLE):
+      if (getDouble(&(label->maxoverlapangle), MS_NUM_CHECK_RANGE, 0, 360) ==
+          -1)
+        return (-1);
+      break;
+    case (MINFEATURESIZE):
+      if ((symbol = getSymbol(2, MS_NUMBER, MS_AUTO)) == -1)
+        return (-1);
+      if (symbol == MS_NUMBER) {
+        if (msCheckNumber(msyynumber, MS_NUM_CHECK_GT, 0, -1) == MS_FAILURE) {
+          msSetError(MS_MISCERR,
+                     "Invalid MINFEATURESIZE, must be greater than 0 (line %d)",
+                     "loadLabel()", msyylineno);
+          return (MS_FAILURE);
+        }
+        label->minfeaturesize = (int)msyynumber;
+      } else
+        label->autominfeaturesize = MS_TRUE;
+      break;
+    case (MINSCALEDENOM):
+      if (getDouble(&(label->minscaledenom), MS_NUM_CHECK_GTE, 0, -1) == -1)
+        return (-1);
+      break;
+    case (MINSIZE):
+      if (getInteger(&(label->minsize), MS_NUM_CHECK_GT, 0, -1) == -1)
+        return (-1);
+      break;
+    case (OFFSET):
+      if ((symbol = getSymbol(2, MS_NUMBER, MS_BINDING)) == -1)
+        return (MS_FAILURE);
+      if (symbol == MS_NUMBER)
+        label->offsetx = (int)msyynumber; // any integer ok
+      else {
+        if (label->bindings[MS_LABEL_BINDING_OFFSET_X].item != NULL)
+          msFree(label->bindings[MS_LABEL_BINDING_OFFSET_X].item);
+        label->bindings[MS_LABEL_BINDING_OFFSET_X].item =
+            msStrdup(msyystring_buffer);
+        label->numbindings++;
+      }
 
-        if((symbol = getSymbol(2, MS_NUMBER,MS_BINDING)) == -1) return(MS_FAILURE);
-        if(symbol == MS_NUMBER)
-          label->offsety = (int) msyynumber; // any integer ok
-        else {
-          if (label->bindings[MS_LABEL_BINDING_OFFSET_Y].item != NULL)
-            msFree(label->bindings[MS_LABEL_BINDING_OFFSET_Y].item);
-          label->bindings[MS_LABEL_BINDING_OFFSET_Y].item = msStrdup(msyystring_buffer);
-          label->numbindings++;
-        }
-        break;
-      case(OUTLINECOLOR):
-        if(loadColor(&(label->outlinecolor), &(label->bindings[MS_LABEL_BINDING_OUTLINECOLOR])) != MS_SUCCESS) return(-1);
-        if(label->bindings[MS_LABEL_BINDING_OUTLINECOLOR].item) label->numbindings++;
-        break;
-      case(OUTLINEWIDTH):
-        if(getInteger(&(label->outlinewidth), MS_NUM_CHECK_GT, 0, -1) == -1) return(-1);
-        break;
-      case(PARTIALS):
-        if((label->partials = getSymbol(2, MS_TRUE,MS_FALSE)) == -1) return(-1);
-        break;
-      case(POSITION):
-        if((label->position = getSymbol(11, MS_UL,MS_UC,MS_UR,MS_CL,MS_CC,MS_CR,MS_LL,MS_LC,MS_LR,MS_AUTO,MS_BINDING)) == -1)
-          return(-1);
-        if(label->position == MS_BINDING) {
-          if(label->bindings[MS_LABEL_BINDING_POSITION].item != NULL)
-            msFree(label->bindings[MS_LABEL_BINDING_POSITION].item);
-          label->bindings[MS_LABEL_BINDING_POSITION].item = msStrdup(msyystring_buffer);
-          label->numbindings++;
-        }
-        break;
-      case(PRIORITY):
-        if((symbol = getSymbol(2, MS_NUMBER,MS_BINDING)) == -1) return(-1);
-        if(symbol == MS_NUMBER) {
-          if(msCheckNumber(msyynumber, MS_NUM_CHECK_RANGE, 1, MS_MAX_LABEL_PRIORITY) == MS_FAILURE) {
-            msSetError(MS_MISCERR, "Invalid PRIORITY, must be an integer between 1 and %d (line %d)" , "loadLabel()", MS_MAX_LABEL_PRIORITY, msyylineno);
-            return(-1);
-          }
-          label->priority = (int) msyynumber;
-        } else {
-          if (label->bindings[MS_LABEL_BINDING_PRIORITY].item != NULL)
-            msFree(label->bindings[MS_LABEL_BINDING_PRIORITY].item);
-          label->bindings[MS_LABEL_BINDING_PRIORITY].item = msStrdup(msyystring_buffer);
-          label->numbindings++;
-        }
-        break;
-      case(SHADOWCOLOR):
-        if(loadColor(&(label->shadowcolor), NULL) != MS_SUCCESS) return(-1);
-        break;
-      case(SHADOWSIZE):
-        if((symbol = getSymbol(2, MS_NUMBER,MS_BINDING)) == -1) return(-1);
-        if(symbol == MS_NUMBER) {
-          label->shadowsizex = (int) msyynumber; // x offset, any int ok
-        } else {
-          if (label->bindings[MS_LABEL_BINDING_SHADOWSIZEX].item != NULL)
-            msFree(label->bindings[MS_LABEL_BINDING_SHADOWSIZEX].item);
-          label->bindings[MS_LABEL_BINDING_SHADOWSIZEX].item = msStrdup(msyystring_buffer);
-          label->numbindings++;
+      if ((symbol = getSymbol(2, MS_NUMBER, MS_BINDING)) == -1)
+        return (MS_FAILURE);
+      if (symbol == MS_NUMBER)
+        label->offsety = (int)msyynumber; // any integer ok
+      else {
+        if (label->bindings[MS_LABEL_BINDING_OFFSET_Y].item != NULL)
+          msFree(label->bindings[MS_LABEL_BINDING_OFFSET_Y].item);
+        label->bindings[MS_LABEL_BINDING_OFFSET_Y].item =
+            msStrdup(msyystring_buffer);
+        label->numbindings++;
+      }
+      break;
+    case (OUTLINECOLOR):
+      if (loadColor(&(label->outlinecolor),
+                    &(label->bindings[MS_LABEL_BINDING_OUTLINECOLOR])) !=
+          MS_SUCCESS)
+        return (-1);
+      if (label->bindings[MS_LABEL_BINDING_OUTLINECOLOR].item)
+        label->numbindings++;
+      break;
+    case (OUTLINEWIDTH):
+      if (getInteger(&(label->outlinewidth), MS_NUM_CHECK_GT, 0, -1) == -1)
+        return (-1);
+      break;
+    case (PARTIALS):
+      if ((label->partials = getSymbol(2, MS_TRUE, MS_FALSE)) == -1)
+        return (-1);
+      break;
+    case (POSITION):
+      if ((label->position =
+               getSymbol(11, MS_UL, MS_UC, MS_UR, MS_CL, MS_CC, MS_CR, MS_LL,
+                         MS_LC, MS_LR, MS_AUTO, MS_BINDING)) == -1)
+        return (-1);
+      if (label->position == MS_BINDING) {
+        if (label->bindings[MS_LABEL_BINDING_POSITION].item != NULL)
+          msFree(label->bindings[MS_LABEL_BINDING_POSITION].item);
+        label->bindings[MS_LABEL_BINDING_POSITION].item =
+            msStrdup(msyystring_buffer);
+        label->numbindings++;
+      }
+      break;
+    case (PRIORITY):
+      if ((symbol = getSymbol(2, MS_NUMBER, MS_BINDING)) == -1)
+        return (-1);
+      if (symbol == MS_NUMBER) {
+        if (msCheckNumber(msyynumber, MS_NUM_CHECK_RANGE, 1,
+                          MS_MAX_LABEL_PRIORITY) == MS_FAILURE) {
+          msSetError(
+              MS_MISCERR,
+              "Invalid PRIORITY, must be an integer between 1 and %d (line %d)",
+              "loadLabel()", MS_MAX_LABEL_PRIORITY, msyylineno);
+          return (-1);
         }
+        label->priority = (int)msyynumber;
+      } else {
+        if (label->bindings[MS_LABEL_BINDING_PRIORITY].item != NULL)
+          msFree(label->bindings[MS_LABEL_BINDING_PRIORITY].item);
+        label->bindings[MS_LABEL_BINDING_PRIORITY].item =
+            msStrdup(msyystring_buffer);
+        label->numbindings++;
+      }
+      break;
+    case (SHADOWCOLOR):
+      if (loadColor(&(label->shadowcolor), NULL) != MS_SUCCESS)
+        return (-1);
+      break;
+    case (SHADOWSIZE):
+      if ((symbol = getSymbol(2, MS_NUMBER, MS_BINDING)) == -1)
+        return (-1);
+      if (symbol == MS_NUMBER) {
+        label->shadowsizex = (int)msyynumber; // x offset, any int ok
+      } else {
+        if (label->bindings[MS_LABEL_BINDING_SHADOWSIZEX].item != NULL)
+          msFree(label->bindings[MS_LABEL_BINDING_SHADOWSIZEX].item);
+        label->bindings[MS_LABEL_BINDING_SHADOWSIZEX].item =
+            msStrdup(msyystring_buffer);
+        label->numbindings++;
+      }
 
-        if((symbol = getSymbol(2, MS_NUMBER,MS_BINDING)) == -1) return(-1);
-        if(symbol == MS_NUMBER) {
-          label->shadowsizey = (int) msyynumber; // y offset, any int ok
-        } else {
-          if (label->bindings[MS_LABEL_BINDING_SHADOWSIZEY].item != NULL)
-            msFree(label->bindings[MS_LABEL_BINDING_SHADOWSIZEY].item);
-          label->bindings[MS_LABEL_BINDING_SHADOWSIZEY].item = msStrdup(msyystring_buffer);
-          label->numbindings++;
-        }
-        break;
-      case(SIZE):
-        if(label->bindings[MS_LABEL_BINDING_SIZE].item) {
-          msFree(label->bindings[MS_LABEL_BINDING_SIZE].item);
-          label->bindings[MS_LABEL_BINDING_SIZE].item = NULL;
-          label->numbindings--;
-        }
-        if (label->exprBindings[MS_LABEL_BINDING_SIZE].string) {
-          msFreeExpression(&label->exprBindings[MS_LABEL_BINDING_SIZE]);
-          label->nexprbindings--;
-        }
+      if ((symbol = getSymbol(2, MS_NUMBER, MS_BINDING)) == -1)
+        return (-1);
+      if (symbol == MS_NUMBER) {
+        label->shadowsizey = (int)msyynumber; // y offset, any int ok
+      } else {
+        if (label->bindings[MS_LABEL_BINDING_SHADOWSIZEY].item != NULL)
+          msFree(label->bindings[MS_LABEL_BINDING_SHADOWSIZEY].item);
+        label->bindings[MS_LABEL_BINDING_SHADOWSIZEY].item =
+            msStrdup(msyystring_buffer);
+        label->numbindings++;
+      }
+      break;
+    case (SIZE):
+      if (label->bindings[MS_LABEL_BINDING_SIZE].item) {
+        msFree(label->bindings[MS_LABEL_BINDING_SIZE].item);
+        label->bindings[MS_LABEL_BINDING_SIZE].item = NULL;
+        label->numbindings--;
+      }
+      if (label->exprBindings[MS_LABEL_BINDING_SIZE].string) {
+        msFreeExpression(&label->exprBindings[MS_LABEL_BINDING_SIZE]);
+        label->nexprbindings--;
+      }
 
-        if((symbol = getSymbol(8, MS_EXPRESSION,MS_NUMBER,MS_BINDING,MS_TINY,MS_SMALL,MS_MEDIUM,MS_LARGE,MS_GIANT)) == -1)
-          return(-1);
+      if ((symbol = getSymbol(8, MS_EXPRESSION, MS_NUMBER, MS_BINDING, MS_TINY,
+                              MS_SMALL, MS_MEDIUM, MS_LARGE, MS_GIANT)) == -1)
+        return (-1);
 
-        if(symbol == MS_NUMBER) {
-          if(msCheckNumber(msyynumber, MS_NUM_CHECK_GT, 0, -1) == MS_FAILURE) {
-            msSetError(MS_MISCERR, "Invalid SIZE, must be greater than 0 (line %d)" , "loadLabel()", msyylineno);
-            return(-1);
-          }
-          label->size = (double) msyynumber;
-        } else if(symbol == MS_BINDING) {
-          label->bindings[MS_LABEL_BINDING_SIZE].item = msStrdup(msyystring_buffer);
-          label->numbindings++;
-        } else if (symbol == MS_EXPRESSION) {
-          msFree(label->exprBindings[MS_LABEL_BINDING_SIZE].string);
-          label->exprBindings[MS_LABEL_BINDING_SIZE].string = msStrdup(msyystring_buffer);
-          label->exprBindings[MS_LABEL_BINDING_SIZE].type = MS_EXPRESSION;
-          label->nexprbindings++;
-        } else
-          label->size = symbol;
-        break;
-      case(STYLE):
-        if(msGrowLabelStyles(label) == NULL)
-          return(-1);
-        initStyle(label->styles[label->numstyles]);
-        if(loadStyle(label->styles[label->numstyles]) != MS_SUCCESS) {
-            freeStyle(label->styles[label->numstyles]);
-            free(label->styles[label->numstyles]);
-            label->styles[label->numstyles] = NULL;
-            return(-1);
-        }
-        if(label->styles[label->numstyles]->_geomtransform.type == MS_GEOMTRANSFORM_NONE)
-          label->styles[label->numstyles]->_geomtransform.type = MS_GEOMTRANSFORM_LABELPOINT; /* set a default, a marker? */
-        label->numstyles++;
-        break;
-      case(TEXT):
-        if(loadExpression(&(label->text)) == -1) return(-1); /* loadExpression() cleans up previously allocated expression */
-        if((label->text.type != MS_STRING) && (label->text.type != MS_EXPRESSION)) {
-          msSetError(MS_MISCERR, "Text expressions support constant or tagged replacement strings." , "loadLabel()");
-          return(-1);
-        }
-        break;
-      case(TYPE):
-        if(getSymbol(2, MS_TRUETYPE,MS_BITMAP) == -1) return(-1); /* ignore TYPE */
-        break;
-      case(WRAP):
-        if(getCharacter(&(label->wrap)) == -1) return(-1);
-        break;
-      default:
-        if(strlen(msyystring_buffer) > 0) {
-          msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)", "loadLabel()", msyystring_buffer, msyylineno);
-          return(-1);
-        } else {
-          return(0); /* end of a string, not an error */
-        }
+      if (symbol == MS_NUMBER) {
+        if (msCheckNumber(msyynumber, MS_NUM_CHECK_GT, 0, -1) == MS_FAILURE) {
+          msSetError(MS_MISCERR,
+                     "Invalid SIZE, must be greater than 0 (line %d)",
+                     "loadLabel()", msyylineno);
+          return (-1);
+        }
+        label->size = (double)msyynumber;
+      } else if (symbol == MS_BINDING) {
+        label->bindings[MS_LABEL_BINDING_SIZE].item =
+            msStrdup(msyystring_buffer);
+        label->numbindings++;
+      } else if (symbol == MS_EXPRESSION) {
+        msFree(label->exprBindings[MS_LABEL_BINDING_SIZE].string);
+        label->exprBindings[MS_LABEL_BINDING_SIZE].string =
+            msStrdup(msyystring_buffer);
+        label->exprBindings[MS_LABEL_BINDING_SIZE].type = MS_EXPRESSION;
+        label->nexprbindings++;
+      } else
+        label->size = symbol;
+      break;
+    case (STYLE):
+      if (msGrowLabelStyles(label) == NULL)
+        return (-1);
+      initStyle(label->styles[label->numstyles]);
+      if (loadStyle(label->styles[label->numstyles]) != MS_SUCCESS) {
+        freeStyle(label->styles[label->numstyles]);
+        free(label->styles[label->numstyles]);
+        label->styles[label->numstyles] = NULL;
+        return (-1);
+      }
+      if (label->styles[label->numstyles]->_geomtransform.type ==
+          MS_GEOMTRANSFORM_NONE)
+        label->styles[label->numstyles]->_geomtransform.type =
+            MS_GEOMTRANSFORM_LABELPOINT; /* set a default, a marker? */
+      label->numstyles++;
+      break;
+    case (TEXT):
+      if (loadExpression(&(label->text)) == -1)
+        return (-1); /* loadExpression() cleans up previously allocated
+                        expression */
+      if ((label->text.type != MS_STRING) &&
+          (label->text.type != MS_EXPRESSION)) {
+        msSetError(
+            MS_MISCERR,
+            "Text expressions support constant or tagged replacement strings.",
+            "loadLabel()");
+        return (-1);
+      }
+      break;
+    case (TYPE):
+      if (getSymbol(2, MS_TRUETYPE, MS_BITMAP) == -1)
+        return (-1); /* ignore TYPE */
+      break;
+    case (WRAP):
+      if (getCharacter(&(label->wrap)) == -1)
+        return (-1);
+      break;
+    default:
+      if (strlen(msyystring_buffer) > 0) {
+        msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)",
+                   "loadLabel()", msyystring_buffer, msyylineno);
+        return (-1);
+      } else {
+        return (0); /* end of a string, not an error */
+      }
     }
   } /* next token */
 }
 
-int msUpdateLabelFromString(labelObj *label, char *string)
-{
-  if(!label || !string) return MS_FAILURE;
+int msUpdateLabelFromString(labelObj *label, char *string) {
+  if (!label || !string)
+    return MS_FAILURE;
 
-  msAcquireLock( TLOCK_PARSER );
+  msAcquireLock(TLOCK_PARSER);
 
   msyystate = MS_TOKENIZE_STRING;
   msyystring = string;
@@ -1887,101 +2047,128 @@ int msUpdateLabelFromString(labelObj *la
 
   msyylineno = 1; /* start at line 1 */
 
-  if(loadLabel(label) == -1) {
-    msReleaseLock( TLOCK_PARSER );
-    return MS_FAILURE; /* parse error */;
+  if (loadLabel(label) == -1) {
+    msReleaseLock(TLOCK_PARSER);
+    return MS_FAILURE; /* parse error */
+    ;
   }
-  msReleaseLock( TLOCK_PARSER );
+  msReleaseLock(TLOCK_PARSER);
 
   msyylex_destroy();
   return MS_SUCCESS;
 }
 
-static void writeLeader(FILE *stream, int indent, labelLeaderObj *leader)
-{
+static void writeLeader(FILE *stream, int indent, labelLeaderObj *leader) {
   int i;
-  if(leader->maxdistance == 0 && leader->numstyles == 0) {
+  if (leader->maxdistance == 0 && leader->numstyles == 0) {
     return;
   }
   indent++;
   writeBlockBegin(stream, indent, "LEADER");
   writeNumber(stream, indent, "MAXDISTANCE", 0, leader->maxdistance);
   writeNumber(stream, indent, "GRIDSTEP", 5, leader->gridstep);
-  for(i=0; i<leader->numstyles; i++)
+  for (i = 0; i < leader->numstyles; i++)
     writeStyle(stream, indent, leader->styles[i]);
 
   writeBlockEnd(stream, indent, "LEADER");
 }
 
-static void writeLabel(FILE *stream, int indent, labelObj *label)
-{
+static void writeLabel(FILE *stream, int indent, labelObj *label) {
   int i;
   colorObj c;
 
-  if(label->size == -1) return; /* there is no default label anymore */
+  if (label->size == -1)
+    return; /* there is no default label anymore */
 
   indent++;
   writeBlockBegin(stream, indent, "LABEL");
 
-  if(label->numbindings > 0 && label->bindings[MS_LABEL_BINDING_ANGLE].item)
-    writeAttributeBinding(stream, indent, "ANGLE", &(label->bindings[MS_LABEL_BINDING_ANGLE]));
-  else writeNumberOrKeyword(stream, indent, "ANGLE", 0, label->angle, label->anglemode, 3, MS_FOLLOW, "FOLLOW", MS_AUTO, "AUTO", MS_AUTO2, "AUTO2");
+  if (label->numbindings > 0 && label->bindings[MS_LABEL_BINDING_ANGLE].item)
+    writeAttributeBinding(stream, indent, "ANGLE",
+                          &(label->bindings[MS_LABEL_BINDING_ANGLE]));
+  else
+    writeNumberOrKeyword(stream, indent, "ANGLE", 0, label->angle,
+                         label->anglemode, 3, MS_FOLLOW, "FOLLOW", MS_AUTO,
+                         "AUTO", MS_AUTO2, "AUTO2");
 
   writeExpression(stream, indent, "EXPRESSION", &(label->expression));
 
-  if(label->numbindings > 0 && label->bindings[MS_LABEL_BINDING_FONT].item)
-    writeAttributeBinding(stream, indent, "FONT", &(label->bindings[MS_LABEL_BINDING_FONT]));
-  else writeString(stream, indent, "FONT", NULL, label->font);
-
-  writeNumber(stream, indent, "MAXSIZE",  MS_MAXFONTSIZE, label->maxsize);
-  writeNumber(stream, indent, "MINSIZE",  MS_MINFONTSIZE, label->minsize);
-
-  if(label->numbindings > 0 && label->bindings[MS_LABEL_BINDING_SIZE].item)
-    writeAttributeBinding(stream, indent, "SIZE", &(label->bindings[MS_LABEL_BINDING_SIZE]));
-  else writeNumber(stream, indent, "SIZE", -1, label->size);
+  if (label->numbindings > 0 && label->bindings[MS_LABEL_BINDING_FONT].item)
+    writeAttributeBinding(stream, indent, "FONT",
+                          &(label->bindings[MS_LABEL_BINDING_FONT]));
+  else
+    writeString(stream, indent, "FONT", NULL, label->font);
+
+  writeNumber(stream, indent, "MAXSIZE", MS_MAXFONTSIZE, label->maxsize);
+  writeNumber(stream, indent, "MINSIZE", MS_MINFONTSIZE, label->minsize);
 
-  writeKeyword(stream, indent, "ALIGN", label->align, 3, MS_ALIGN_LEFT, "LEFT", MS_ALIGN_CENTER, "CENTER", MS_ALIGN_RIGHT, "RIGHT");
+  if (label->numbindings > 0 && label->bindings[MS_LABEL_BINDING_SIZE].item)
+    writeAttributeBinding(stream, indent, "SIZE",
+                          &(label->bindings[MS_LABEL_BINDING_SIZE]));
+  else
+    writeNumber(stream, indent, "SIZE", -1, label->size);
+
+  writeKeyword(stream, indent, "ALIGN", label->align, 3, MS_ALIGN_LEFT, "LEFT",
+               MS_ALIGN_CENTER, "CENTER", MS_ALIGN_RIGHT, "RIGHT");
   writeNumber(stream, indent, "BUFFER", 0, label->buffer);
 
-  if(label->numbindings > 0 && label->bindings[MS_LABEL_BINDING_COLOR].item)
-    writeAttributeBinding(stream, indent, "COLOR", &(label->bindings[MS_LABEL_BINDING_COLOR]));
+  if (label->numbindings > 0 && label->bindings[MS_LABEL_BINDING_COLOR].item)
+    writeAttributeBinding(stream, indent, "COLOR",
+                          &(label->bindings[MS_LABEL_BINDING_COLOR]));
   else {
-    MS_INIT_COLOR(c,0,0,0,255);
+    MS_INIT_COLOR(c, 0, 0, 0, 255);
     writeColor(stream, indent, "COLOR", &c, &(label->color));
   }
 
   writeString(stream, indent, "ENCODING", NULL, label->encoding);
-  if(label->leader)
-    writeLeader(stream,indent,label->leader);
-  writeKeyword(stream, indent, "FORCE", label->force, 2, MS_TRUE, "TRUE", MS_LABEL_FORCE_GROUP, "GROUP");
+  if (label->leader)
+    writeLeader(stream, indent, label->leader);
+  writeKeyword(stream, indent, "FORCE", label->force, 2, MS_TRUE, "TRUE",
+               MS_LABEL_FORCE_GROUP, "GROUP");
   writeNumber(stream, indent, "MAXLENGTH", 0, label->maxlength);
   writeNumber(stream, indent, "MAXSCALEDENOM", -1, label->maxscaledenom);
   writeNumber(stream, indent, "MINDISTANCE", -1, label->mindistance);
-  writeNumberOrKeyword(stream, indent, "MINFEATURESIZE", -1, label->minfeaturesize, 1, label->autominfeaturesize, MS_TRUE, "AUTO");
+  writeNumberOrKeyword(stream, indent, "MINFEATURESIZE", -1,
+                       label->minfeaturesize, 1, label->autominfeaturesize,
+                       MS_TRUE, "AUTO");
   writeNumber(stream, indent, "MINSCALEDENOM", -1, label->minscaledenom);
-  writeDimension(stream, indent, "OFFSET",  label->offsetx, label->offsety, NULL, NULL);
+  writeDimension(stream, indent, "OFFSET", label->offsetx, label->offsety, NULL,
+                 NULL);
 
-  if(label->numbindings > 0 && label->bindings[MS_LABEL_BINDING_OUTLINECOLOR].item)
-    writeAttributeBinding(stream, indent, "OUTLINECOLOR", &(label->bindings[MS_LABEL_BINDING_OUTLINECOLOR]));
-  else  writeColor(stream, indent, "OUTLINECOLOR", NULL, &(label->outlinecolor));
+  if (label->numbindings > 0 &&
+      label->bindings[MS_LABEL_BINDING_OUTLINECOLOR].item)
+    writeAttributeBinding(stream, indent, "OUTLINECOLOR",
+                          &(label->bindings[MS_LABEL_BINDING_OUTLINECOLOR]));
+  else
+    writeColor(stream, indent, "OUTLINECOLOR", NULL, &(label->outlinecolor));
 
   writeNumber(stream, indent, "OUTLINEWIDTH", 1, label->outlinewidth);
   writeKeyword(stream, indent, "PARTIALS", label->partials, 1, MS_TRUE, "TRUE");
 
-  if(label->numbindings > 0 && label->bindings[MS_LABEL_BINDING_POSITION].item)
-    writeAttributeBinding(stream, indent, "POSITION", &(label->bindings[MS_LABEL_BINDING_POSITION]));
-  else writeKeyword(stream, indent, "POSITION", label->position, 10, MS_UL, "UL", MS_UC, "UC", MS_UR, "UR", MS_CL, "CL", MS_CC, "CC", MS_CR, "CR", MS_LL, "LL", MS_LC, "LC", MS_LR, "LR", MS_AUTO, "AUTO");
-
-  if(label->numbindings > 0 && label->bindings[MS_LABEL_BINDING_PRIORITY].item)
-    writeAttributeBinding(stream, indent, "PRIORITY", &(label->bindings[MS_LABEL_BINDING_PRIORITY]));
-  else writeNumber(stream, indent, "PRIORITY", MS_DEFAULT_LABEL_PRIORITY, label->priority);
+  if (label->numbindings > 0 && label->bindings[MS_LABEL_BINDING_POSITION].item)
+    writeAttributeBinding(stream, indent, "POSITION",
+                          &(label->bindings[MS_LABEL_BINDING_POSITION]));
+  else
+    writeKeyword(stream, indent, "POSITION", label->position, 10, MS_UL, "UL",
+                 MS_UC, "UC", MS_UR, "UR", MS_CL, "CL", MS_CC, "CC", MS_CR,
+                 "CR", MS_LL, "LL", MS_LC, "LC", MS_LR, "LR", MS_AUTO, "AUTO");
+
+  if (label->numbindings > 0 && label->bindings[MS_LABEL_BINDING_PRIORITY].item)
+    writeAttributeBinding(stream, indent, "PRIORITY",
+                          &(label->bindings[MS_LABEL_BINDING_PRIORITY]));
+  else
+    writeNumber(stream, indent, "PRIORITY", MS_DEFAULT_LABEL_PRIORITY,
+                label->priority);
 
   writeNumber(stream, indent, "REPEATDISTANCE", 0, label->repeatdistance);
   writeColor(stream, indent, "SHADOWCOLOR", NULL, &(label->shadowcolor));
-  writeDimension(stream, indent, "SHADOWSIZE", label->shadowsizex, label->shadowsizey, label->bindings[MS_LABEL_BINDING_SHADOWSIZEX].item, label->bindings[MS_LABEL_BINDING_SHADOWSIZEY].item);
+  writeDimension(stream, indent, "SHADOWSIZE", label->shadowsizex,
+                 label->shadowsizey,
+                 label->bindings[MS_LABEL_BINDING_SHADOWSIZEX].item,
+                 label->bindings[MS_LABEL_BINDING_SHADOWSIZEY].item);
 
   writeNumber(stream, indent, "MAXOVERLAPANGLE", 22.5, label->maxoverlapangle);
-  for(i=0; i<label->numstyles; i++)
+  for (i = 0; i < label->numstyles; i++)
     writeStyle(stream, indent, label->styles[i]);
 
   writeExpression(stream, indent, "TEXT", &(label->text));
@@ -1990,9 +2177,8 @@ static void writeLabel(FILE *stream, int
   writeBlockEnd(stream, indent, "LABEL");
 }
 
-char* msWriteLabelToString(labelObj *label)
-{
-  msIOContext  context;
+char *msWriteLabelToString(labelObj *label) {
+  msIOContext context;
   msIOBuffer buffer;
 
   context.label = NULL;
@@ -2003,53 +2189,52 @@ char* msWriteLabelToString(labelObj *lab
   buffer.data_len = 0;
   buffer.data_offset = 0;
 
-  msIO_installHandlers( NULL, &context, NULL );
+  msIO_installHandlers(NULL, &context, NULL);
 
   writeLabel(stdout, -1, label);
-  msIO_bufferWrite( &buffer, "", 1 );
+  msIO_bufferWrite(&buffer, "", 1);
 
-  msIO_installHandlers( NULL, NULL, NULL );
+  msIO_installHandlers(NULL, NULL, NULL);
 
-  return (char*)buffer.data;
+  return (char *)buffer.data;
 }
 
-void msInitExpression(expressionObj *exp)
-{
+void msInitExpression(expressionObj *exp) {
   memset(exp, 0, sizeof(*exp));
   exp->type = MS_STRING;
 }
 
-void msFreeExpressionTokens(expressionObj *exp)
-{
+void msFreeExpressionTokens(expressionObj *exp) {
   tokenListNodeObjPtr node = NULL;
   tokenListNodeObjPtr nextNode = NULL;
 
-  if(!exp) return;
+  if (!exp)
+    return;
 
-  if(exp->tokens) {
+  if (exp->tokens) {
     node = exp->tokens;
     while (node != NULL) {
       nextNode = node->next;
 
       msFree(node->tokensrc); /* not set very often */
 
-      switch(node->token) {
-        case MS_TOKEN_BINDING_DOUBLE:
-        case MS_TOKEN_BINDING_INTEGER:
-        case MS_TOKEN_BINDING_STRING:
-        case MS_TOKEN_BINDING_TIME:
-          msFree(node->tokenval.bindval.item);
-          break;
-        case MS_TOKEN_LITERAL_TIME:
-          /* anything to do? */
-          break;
-        case MS_TOKEN_LITERAL_STRING:
-          msFree(node->tokenval.strval);
-          break;
-        case MS_TOKEN_LITERAL_SHAPE:
-          msFreeShape(node->tokenval.shpval);
-          free(node->tokenval.shpval);
-          break;
+      switch (node->token) {
+      case MS_TOKEN_BINDING_DOUBLE:
+      case MS_TOKEN_BINDING_INTEGER:
+      case MS_TOKEN_BINDING_STRING:
+      case MS_TOKEN_BINDING_TIME:
+        msFree(node->tokenval.bindval.item);
+        break;
+      case MS_TOKEN_LITERAL_TIME:
+        /* anything to do? */
+        break;
+      case MS_TOKEN_LITERAL_STRING:
+        msFree(node->tokenval.strval);
+        break;
+      case MS_TOKEN_LITERAL_SHAPE:
+        msFreeShape(node->tokenval.shpval);
+        free(node->tokenval.shpval);
+        break;
       }
 
       msFree(node);
@@ -2059,22 +2244,25 @@ void msFreeExpressionTokens(expressionOb
   }
 }
 
-void msFreeExpression(expressionObj *exp)
-{
-  if(!exp) return;
+void msFreeExpression(expressionObj *exp) {
+  if (!exp)
+    return;
   msFree(exp->string);
   msFree(exp->native_string);
-  if((exp->type == MS_REGEX) && exp->compiled) ms_regfree(&(exp->regex));
+  if ((exp->type == MS_REGEX) && exp->compiled)
+    ms_regfree(&(exp->regex));
   msFreeExpressionTokens(exp);
   msInitExpression(exp); /* re-initialize */
 }
 
-int loadExpression(expressionObj *exp)
-{
-  /* TODO: should we call msFreeExpression if exp->string != NULL? We do some checking to avoid a leak but is it enough... */
+int loadExpression(expressionObj *exp) {
+  /* TODO: should we call msFreeExpression if exp->string != NULL? We do some
+   * checking to avoid a leak but is it enough... */
 
   msyystring_icase = MS_TRUE;
-  if((exp->type = getSymbol(6, MS_STRING,MS_EXPRESSION,MS_REGEX,MS_ISTRING,MS_IREGEX,MS_LIST)) == -1) return(-1);
+  if ((exp->type = getSymbol(6, MS_STRING, MS_EXPRESSION, MS_REGEX, MS_ISTRING,
+                             MS_IREGEX, MS_LIST)) == -1)
+    return (-1);
   if (exp->string != NULL) {
     msFree(exp->string);
     msFree(exp->native_string);
@@ -2082,15 +2270,15 @@ int loadExpression(expressionObj *exp)
   exp->string = msStrdup(msyystring_buffer);
   exp->native_string = NULL;
 
-  if(exp->type == MS_ISTRING) {
+  if (exp->type == MS_ISTRING) {
     exp->flags = exp->flags | MS_EXP_INSENSITIVE;
     exp->type = MS_STRING;
-  } else if(exp->type == MS_IREGEX) {
+  } else if (exp->type == MS_IREGEX) {
     exp->flags = exp->flags | MS_EXP_INSENSITIVE;
     exp->type = MS_REGEX;
   }
 
-  return(0);
+  return (0);
 }
 
 /* ---------------------------------------------------------------------------
@@ -2105,46 +2293,47 @@ int loadExpression(expressionObj *exp)
    See bug 339 for more details -- SG.
    ------------------------------------------------------------------------ */
 
-int msLoadExpressionString(expressionObj *exp, char *value)
-{
+int msLoadExpressionString(expressionObj *exp, char *value) {
   int retval = MS_FAILURE;
 
-  msAcquireLock( TLOCK_PARSER );
-  retval = loadExpressionString( exp, value );
-  msReleaseLock( TLOCK_PARSER );
+  msAcquireLock(TLOCK_PARSER);
+  retval = loadExpressionString(exp, value);
+  msReleaseLock(TLOCK_PARSER);
 
   return retval;
 }
 
-int loadExpressionString(expressionObj *exp, char *value)
-{
+int loadExpressionString(expressionObj *exp, char *value) {
   msyystate = MS_TOKENIZE_STRING;
   msyystring = value;
   msyylex(); /* sets things up but processes no tokens */
 
-  msFreeExpression(exp); /* we're totally replacing the old expression so free (which re-inits) to start over */
+  msFreeExpression(exp); /* we're totally replacing the old expression so free
+                            (which re-inits) to start over */
 
   msyystring_icase = MS_TRUE;
-  if((exp->type = getSymbol2(5, MS_EXPRESSION,MS_REGEX,MS_IREGEX,MS_ISTRING,MS_LIST)) != -1) {
+  if ((exp->type = getSymbol2(5, MS_EXPRESSION, MS_REGEX, MS_IREGEX, MS_ISTRING,
+                              MS_LIST)) != -1) {
     exp->string = msStrdup(msyystring_buffer);
 
-    if(exp->type == MS_ISTRING) {
+    if (exp->type == MS_ISTRING) {
       exp->type = MS_STRING;
       exp->flags = exp->flags | MS_EXP_INSENSITIVE;
-    } else if(exp->type == MS_IREGEX) {
+    } else if (exp->type == MS_IREGEX) {
       exp->type = MS_REGEX;
       exp->flags = exp->flags | MS_EXP_INSENSITIVE;
     }
   } else {
-    /* failure above is not an error since we'll consider anything not matching (like an unquoted number) as a STRING) */
+    /* failure above is not an error since we'll consider anything not matching
+     * (like an unquoted number) as a STRING) */
     exp->type = MS_STRING;
-    if((strlen(value) - strlen(msyystring_buffer)) == 2)
+    if ((strlen(value) - strlen(msyystring_buffer)) == 2)
       exp->string = msStrdup(msyystring_buffer); /* value was quoted */
     else
       exp->string = msStrdup(value); /* use the whole value */
   }
 
-  return(0);
+  return (0);
 }
 
 /* msGetExpressionString()
@@ -2154,136 +2343,143 @@ int loadExpressionString(expressionObj *
  *
  * Returns a newly allocated buffer that should be freed by the caller or NULL.
  */
-char *msGetExpressionString(expressionObj *exp)
-{
-  if(exp->string) {
+char *msGetExpressionString(expressionObj *exp) {
+  if (exp->string) {
     char *exprstring;
     size_t buffer_size;
     const char *case_insensitive = "";
 
-    if(exp->flags & MS_EXP_INSENSITIVE)
+    if (exp->flags & MS_EXP_INSENSITIVE)
       case_insensitive = "i";
 
     /* Alloc buffer big enough for string + 2 delimiters + 'i' + \0 */
-    buffer_size = strlen(exp->string)+4;
-    exprstring = (char*)msSmallMalloc(buffer_size);
+    buffer_size = strlen(exp->string) + 4;
+    exprstring = (char *)msSmallMalloc(buffer_size);
 
-    switch(exp->type) {
-      case(MS_REGEX):
-        snprintf(exprstring, buffer_size, "/%s/%s", exp->string, case_insensitive);
-        return exprstring;
-      case(MS_STRING):
-        snprintf(exprstring, buffer_size, "\"%s\"%s", exp->string, case_insensitive);
-        return exprstring;
-      case(MS_EXPRESSION):
-        snprintf(exprstring, buffer_size, "(%s)", exp->string);
-        return exprstring;
-      case(MS_LIST):
-        snprintf(exprstring, buffer_size, "{%s}", exp->string);
-        return exprstring;
-      default:
-        /* We should never get to here really! */
-        free(exprstring);
-        return NULL;
+    switch (exp->type) {
+    case (MS_REGEX):
+      snprintf(exprstring, buffer_size, "/%s/%s", exp->string,
+               case_insensitive);
+      return exprstring;
+    case (MS_STRING):
+      snprintf(exprstring, buffer_size, "\"%s\"%s", exp->string,
+               case_insensitive);
+      return exprstring;
+    case (MS_EXPRESSION):
+      snprintf(exprstring, buffer_size, "(%s)", exp->string);
+      return exprstring;
+    case (MS_LIST):
+      snprintf(exprstring, buffer_size, "{%s}", exp->string);
+      return exprstring;
+    default:
+      /* We should never get to here really! */
+      free(exprstring);
+      return NULL;
     }
   }
   return NULL;
 }
 
-static void writeExpression(FILE *stream, int indent, const char *name, expressionObj *exp)
-{
-  if(!exp || !exp->string) return;
+static void writeExpression(FILE *stream, int indent, const char *name,
+                            expressionObj *exp) {
+  if (!exp || !exp->string)
+    return;
 
   writeIndent(stream, ++indent);
-  switch(exp->type) {
-    case(MS_LIST):
-      fprintf(stream, "%s {%s}", name, exp->string);
-      break;
-    case(MS_REGEX):
-      msIO_fprintf(stream, "%s /%s/", name, exp->string);
-      break;
-    case(MS_STRING):
-      msIO_fprintf(stream, "%s ", name);
-      writeStringElement(stream, exp->string);
-      break;
-    case(MS_EXPRESSION):
-      msIO_fprintf(stream, "%s (%s)", name, exp->string);
-      break;
+  switch (exp->type) {
+  case (MS_LIST):
+    fprintf(stream, "%s {%s}", name, exp->string);
+    break;
+  case (MS_REGEX):
+    msIO_fprintf(stream, "%s /%s/", name, exp->string);
+    break;
+  case (MS_STRING):
+    msIO_fprintf(stream, "%s ", name);
+    writeStringElement(stream, exp->string);
+    break;
+  case (MS_EXPRESSION):
+    msIO_fprintf(stream, "%s (%s)", name, exp->string);
+    break;
   }
-  if((exp->type == MS_STRING || exp->type == MS_REGEX) && (exp->flags & MS_EXP_INSENSITIVE))
+  if ((exp->type == MS_STRING || exp->type == MS_REGEX) &&
+      (exp->flags & MS_EXP_INSENSITIVE))
     msIO_fprintf(stream, "i");
   writeLineFeed(stream);
 }
 
-int loadHashTable(hashTableObj *ptable)
-{
+int loadHashTable(hashTableObj *ptable) {
   assert(ptable);
 
-  for(;;) {
-    switch(msyylex()) {
-      case(EOF):
-        msSetError(MS_EOFERR, NULL, "loadHashTable()");
-        return(MS_FAILURE);
-      case(END):
-        return(MS_SUCCESS);
-      case(MS_STRING):
-      {
-        char* data = NULL;
-        char* key = msStrdup(msyystring_buffer); /* the key is *always* a string */
-        if(getString(&data) == MS_FAILURE) {
-          free(key);
-          return(MS_FAILURE);
-        }
-        msInsertHashTable(ptable, key, data);
-
+  for (;;) {
+    switch (msyylex()) {
+    case (EOF):
+      msSetError(MS_EOFERR, NULL, "loadHashTable()");
+      return (MS_FAILURE);
+    case (END):
+      return (MS_SUCCESS);
+    case (MS_STRING): {
+      char *data = NULL;
+      char *key =
+          msStrdup(msyystring_buffer); /* the key is *always* a string */
+      if (getString(&data) == MS_FAILURE) {
         free(key);
-        free(data);
-        break;
+        return (MS_FAILURE);
       }
-      default:
-        msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)", "loadHashTable()", msyystring_buffer, msyylineno );
-        return(MS_FAILURE);
+      msInsertHashTable(ptable, key, data);
+
+      free(key);
+      free(data);
+      break;
+    }
+    default:
+      msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)",
+                 "loadHashTable()", msyystring_buffer, msyylineno);
+      return (MS_FAILURE);
     }
   }
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
-static void writeHashTable(FILE *stream, int indent, const char *title, hashTableObj *table)
-{
+static void writeHashTable(FILE *stream, int indent, const char *title,
+                           hashTableObj *table) {
   struct hashObj *tp;
   int i;
 
-  if(!table) return;
-  if(msHashIsEmpty(table)) return;
+  if (!table)
+    return;
+  if (msHashIsEmpty(table))
+    return;
 
   indent++;
   writeBlockBegin(stream, indent, title);
-  for (i=0; i<MS_HASHSIZE; i++) {
+  for (i = 0; i < MS_HASHSIZE; i++) {
     if (table->items[i] != NULL) {
-      for (tp=table->items[i]; tp!=NULL; tp=tp->next)
+      for (tp = table->items[i]; tp != NULL; tp = tp->next)
         writeNameValuePair(stream, indent, tp->key, tp->data);
     }
   }
   writeBlockEnd(stream, indent, title);
 }
 
-static void writeHashTableInline(FILE *stream, int indent, char *name, hashTableObj* table)
-{
+static void writeHashTableInline(FILE *stream, int indent, char *name,
+                                 hashTableObj *table) {
   struct hashObj *tp = NULL;
   int i;
 
-  if(!table) return;
-  if(msHashIsEmpty(table)) return;
+  if (!table)
+    return;
+  if (msHashIsEmpty(table))
+    return;
 
   ++indent;
-  for (i=0; i<MS_HASHSIZE; ++i) {
+  for (i = 0; i < MS_HASHSIZE; ++i) {
     if (table->items[i] != NULL) {
-      for (tp=table->items[i]; tp!=NULL; tp=tp->next) {
+      for (tp = table->items[i]; tp != NULL; tp = tp->next) {
         writeIndent(stream, indent);
         msIO_fprintf(stream, "%s ", name);
         writeStringElement(stream, tp->key);
-        msIO_fprintf(stream," ");
+        msIO_fprintf(stream, " ");
         writeStringElement(stream, tp->data);
         writeLineFeed(stream);
       }
@@ -2294,8 +2490,7 @@ static void writeHashTableInline(FILE *s
 /*
 ** Initialize, load and free a cluster object
 */
-void initCluster(clusterObj *cluster)
-{
+void initCluster(clusterObj *cluster) {
   cluster->maxdistance = 10;
   cluster->buffer = 0;
   cluster->region = NULL;
@@ -2303,55 +2498,58 @@ void initCluster(clusterObj *cluster)
   msInitExpression(&(cluster->filter));
 }
 
-void freeCluster(clusterObj *cluster)
-{
+void freeCluster(clusterObj *cluster) {
   msFree(cluster->region);
   msFreeExpression(&(cluster->group));
   msFreeExpression(&(cluster->filter));
 }
 
-int loadCluster(clusterObj *cluster)
-{
-  for(;;) {
-    switch(msyylex()) {
-      case(CLUSTER):
-        break; /* for string loads */
-      case(MAXDISTANCE):
-        if(getDouble(&(cluster->maxdistance), MS_NUM_CHECK_GT, 0, -1) == -1) return(-1);
-        break;
-      case(BUFFER):
-        if(getDouble(&(cluster->buffer), MS_NUM_CHECK_GT, 0, -1) == -1) return(-1);
-        break;
-      case(REGION):
-        if(getString(&cluster->region) == MS_FAILURE) return(-1);
-        break;
-      case(END):
-        return(0);
-        break;
-      case(GROUP):
-        if(loadExpression(&(cluster->group)) == -1) return(-1);
-        break;
-      case(FILTER):
-        if(loadExpression(&(cluster->filter)) == -1) return(-1);
-        break;
-      default:
-        if(strlen(msyystring_buffer) > 0) {
-          msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)", "loadCluster()", msyystring_buffer, msyylineno);
-          return(-1);
-        } else {
-          return(0); /* end of a string, not an error */
-        }
-
+int loadCluster(clusterObj *cluster) {
+  for (;;) {
+    switch (msyylex()) {
+    case (CLUSTER):
+      break; /* for string loads */
+    case (MAXDISTANCE):
+      if (getDouble(&(cluster->maxdistance), MS_NUM_CHECK_GT, 0, -1) == -1)
+        return (-1);
+      break;
+    case (BUFFER):
+      if (getDouble(&(cluster->buffer), MS_NUM_CHECK_GT, 0, -1) == -1)
+        return (-1);
+      break;
+    case (REGION):
+      if (getString(&cluster->region) == MS_FAILURE)
+        return (-1);
+      break;
+    case (END):
+      return (0);
+      break;
+    case (GROUP):
+      if (loadExpression(&(cluster->group)) == -1)
+        return (-1);
+      break;
+    case (FILTER):
+      if (loadExpression(&(cluster->filter)) == -1)
+        return (-1);
+      break;
+    default:
+      if (strlen(msyystring_buffer) > 0) {
+        msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)",
+                   "loadCluster()", msyystring_buffer, msyylineno);
+        return (-1);
+      } else {
+        return (0); /* end of a string, not an error */
+      }
     }
   }
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
-int msUpdateClusterFromString(clusterObj *cluster, char *string)
-{
-  if(!cluster || !string) return MS_FAILURE;
+int msUpdateClusterFromString(clusterObj *cluster, char *string) {
+  if (!cluster || !string)
+    return MS_FAILURE;
 
-  msAcquireLock( TLOCK_PARSER );
+  msAcquireLock(TLOCK_PARSER);
 
   msyystate = MS_TOKENIZE_STRING;
   msyystring = string;
@@ -2359,25 +2557,23 @@ int msUpdateClusterFromString(clusterObj
 
   msyylineno = 1; /* start at line 1 */
 
-  if(loadCluster(cluster) == -1) {
-    msReleaseLock( TLOCK_PARSER );
-    return MS_FAILURE; /* parse error */;
+  if (loadCluster(cluster) == -1) {
+    msReleaseLock(TLOCK_PARSER);
+    return MS_FAILURE; /* parse error */
+    ;
   }
-  msReleaseLock( TLOCK_PARSER );
+  msReleaseLock(TLOCK_PARSER);
 
   msyylex_destroy();
   return MS_SUCCESS;
 }
 
-static void writeCluster(FILE *stream, int indent, clusterObj *cluster)
-{
+static void writeCluster(FILE *stream, int indent, clusterObj *cluster) {
 
-  if (cluster->maxdistance == 10 &&
-      cluster->buffer == 0.0 &&
-      cluster->region == NULL &&
-      cluster->group.string == NULL &&
+  if (cluster->maxdistance == 10 && cluster->buffer == 0.0 &&
+      cluster->region == NULL && cluster->group.string == NULL &&
       cluster->filter.string == NULL)
-    return;  /* Nothing to write */
+    return; /* Nothing to write */
 
   indent++;
   writeBlockBegin(stream, indent, "CLUSTER");
@@ -2389,9 +2585,8 @@ static void writeCluster(FILE *stream, i
   writeBlockEnd(stream, indent, "CLUSTER");
 }
 
-char* msWriteClusterToString(clusterObj *cluster)
-{
-  msIOContext  context;
+char *msWriteClusterToString(clusterObj *cluster) {
+  msIOContext context;
   msIOBuffer buffer;
 
   context.label = NULL;
@@ -2402,28 +2597,27 @@ char* msWriteClusterToString(clusterObj
   buffer.data_len = 0;
   buffer.data_offset = 0;
 
-  msIO_installHandlers( NULL, &context, NULL );
+  msIO_installHandlers(NULL, &context, NULL);
 
   writeCluster(stdout, -1, cluster);
-  msIO_bufferWrite( &buffer, "", 1 );
+  msIO_bufferWrite(&buffer, "", 1);
 
-  msIO_installHandlers( NULL, NULL, NULL );
+  msIO_installHandlers(NULL, NULL, NULL);
 
-  return (char*)buffer.data;
+  return (char *)buffer.data;
 }
 
 /*
 ** Initialize, load and free a single style
 */
-int initStyle(styleObj *style)
-{
+int initStyle(styleObj *style) {
   int i;
   MS_REFCNT_INIT(style);
-  MS_INIT_COLOR(style->color, -1,-1,-1,255); /* must explictly set colors */
-  MS_INIT_COLOR(style->outlinecolor, -1,-1,-1,255);
+  MS_INIT_COLOR(style->color, -1, -1, -1, 255); /* must explictly set colors */
+  MS_INIT_COLOR(style->outlinecolor, -1, -1, -1, 255);
   /* New Color Range fields*/
-  MS_INIT_COLOR(style->mincolor, -1,-1,-1,255);
-  MS_INIT_COLOR(style->maxcolor, -1,-1,-1,255);
+  MS_INIT_COLOR(style->mincolor, -1, -1, -1, 255);
+  MS_INIT_COLOR(style->maxcolor, -1, -1, -1, 255);
   style->minvalue = 0.0;
   style->maxvalue = 1.0;
   style->rangeitem = NULL;
@@ -2433,15 +2627,15 @@ int initStyle(styleObj *style)
   style->size = -1; /* in SIZEUNITS (layerObj) */
   style->minsize = MS_MINSYMBOLSIZE;
   style->maxsize = MS_MAXSYMBOLSIZE;
-  style->width = 1; /* in pixels */
+  style->width = 1;        /* in pixels */
   style->outlinewidth = 0; /* in pixels */
   style->minwidth = MS_MINSYMBOLWIDTH;
   style->maxwidth = MS_MAXSYMBOLWIDTH;
-  style->minscaledenom=style->maxscaledenom = -1.0;
-  style->offsetx = style->offsety = 0; /* no offset */
+  style->minscaledenom = style->maxscaledenom = -1.0;
+  style->offsetx = style->offsety = 0;                   /* no offset */
   style->polaroffsetpixel = style->polaroffsetangle = 0; /* no polar offset */
   style->angle = 0;
-  style->autoangle= MS_FALSE;
+  style->autoangle = MS_FALSE;
   style->antialiased = MS_TRUE;
   style->opacity = 100; /* fully opaque */
 
@@ -2457,7 +2651,7 @@ int initStyle(styleObj *style)
 
   style->numbindings = 0;
   style->nexprbindings = 0;
-  for(i=0; i<MS_STYLE_BINDING_LENGTH; i++) {
+  for (i = 0; i < MS_STYLE_BINDING_LENGTH; i++) {
     style->bindings[i].item = NULL;
     style->bindings[i].index = -1;
     msInitExpression(&(style->exprBindings[i]));
@@ -2469,295 +2663,362 @@ int initStyle(styleObj *style)
   return MS_SUCCESS;
 }
 
-int loadStyle(styleObj *style)
-{
+int loadStyle(styleObj *style) {
   int symbol;
 
-  for(;;) {
-    switch(msyylex()) {
-        /* New Color Range fields*/
-      case (COLORRANGE):
-        /*These are both in one line now*/
-        if(loadColor(&(style->mincolor), NULL) != MS_SUCCESS) return(MS_FAILURE);
-        if(loadColor(&(style->maxcolor), NULL) != MS_SUCCESS) return(MS_FAILURE);
-        break;
-      case(DATARANGE):
-        /*These are both in one line now*/
-        if(getDouble(&(style->minvalue), MS_NUM_CHECK_NONE, -1, -1) == -1) return(MS_FAILURE);
-        if(getDouble(&(style->maxvalue), MS_NUM_CHECK_NONE, -1, -1) == -1) return(MS_FAILURE);
-        break;
-      case(RANGEITEM):
-        if(getString(&style->rangeitem) == MS_FAILURE) return(MS_FAILURE);
-        break;
-        /* End Range fields*/
-      case(ANGLE):
-        if((symbol = getSymbol(3, MS_NUMBER,MS_BINDING,MS_AUTO)) == -1) return(MS_FAILURE);
-
-        if(symbol == MS_NUMBER) {
-          if(msCheckNumber(msyynumber, MS_NUM_CHECK_RANGE, -360.0, 360.0) == MS_FAILURE) {
-            msSetError(MS_MISCERR, "Invalid ANGLE, must be between -360 and 360 (line %d)", "loadStyle()", msyylineno);
-            return(MS_FAILURE);
-          }
-          style->angle = (double) msyynumber;
-        } else if(symbol==MS_BINDING) {
-          if (style->bindings[MS_STYLE_BINDING_ANGLE].item != NULL)
-            msFree(style->bindings[MS_STYLE_BINDING_ANGLE].item);
-          style->bindings[MS_STYLE_BINDING_ANGLE].item = msStrdup(msyystring_buffer);
-          style->numbindings++;
-        } else {
-          style->autoangle=MS_TRUE;
-        }
-        break;
-      case(ANTIALIAS):
-        if ((symbol = getSymbol(2, MS_TRUE,MS_FALSE)) == -1) return(MS_FAILURE);
-        if (symbol == MS_FALSE) {
-            style->antialiased = MS_FALSE;
-        }
-        break;
-      case(COLOR):
-        if(loadColor(&(style->color), &(style->bindings[MS_STYLE_BINDING_COLOR])) != MS_SUCCESS) return(MS_FAILURE);
-        if(style->bindings[MS_STYLE_BINDING_COLOR].item) style->numbindings++;
-        break;
-      case(EOF):
-        msSetError(MS_EOFERR, NULL, "loadStyle()");
-        return(MS_FAILURE); /* missing END (probably) */
-      case(END): {
-        int alpha;
-
-        /* apply opacity as the alpha channel color(s) */
-        if(style->opacity < 100) {
-          alpha = MS_NINT(style->opacity*2.55);
+  for (;;) {
+    switch (msyylex()) {
+      /* New Color Range fields*/
+    case (COLORRANGE):
+      /*These are both in one line now*/
+      if (loadColor(&(style->mincolor), NULL) != MS_SUCCESS)
+        return (MS_FAILURE);
+      if (loadColor(&(style->maxcolor), NULL) != MS_SUCCESS)
+        return (MS_FAILURE);
+      break;
+    case (DATARANGE):
+      /*These are both in one line now*/
+      if (getDouble(&(style->minvalue), MS_NUM_CHECK_NONE, -1, -1) == -1)
+        return (MS_FAILURE);
+      if (getDouble(&(style->maxvalue), MS_NUM_CHECK_NONE, -1, -1) == -1)
+        return (MS_FAILURE);
+      break;
+    case (RANGEITEM):
+      if (getString(&style->rangeitem) == MS_FAILURE)
+        return (MS_FAILURE);
+      break;
+      /* End Range fields*/
+    case (ANGLE):
+      if ((symbol = getSymbol(3, MS_NUMBER, MS_BINDING, MS_AUTO)) == -1)
+        return (MS_FAILURE);
+
+      if (symbol == MS_NUMBER) {
+        if (msCheckNumber(msyynumber, MS_NUM_CHECK_RANGE, -360.0, 360.0) ==
+            MS_FAILURE) {
+          msSetError(MS_MISCERR,
+                     "Invalid ANGLE, must be between -360 and 360 (line %d)",
+                     "loadStyle()", msyylineno);
+          return (MS_FAILURE);
+        }
+        style->angle = (double)msyynumber;
+      } else if (symbol == MS_BINDING) {
+        if (style->bindings[MS_STYLE_BINDING_ANGLE].item != NULL)
+          msFree(style->bindings[MS_STYLE_BINDING_ANGLE].item);
+        style->bindings[MS_STYLE_BINDING_ANGLE].item =
+            msStrdup(msyystring_buffer);
+        style->numbindings++;
+      } else {
+        style->autoangle = MS_TRUE;
+      }
+      break;
+    case (ANTIALIAS):
+      if ((symbol = getSymbol(2, MS_TRUE, MS_FALSE)) == -1)
+        return (MS_FAILURE);
+      if (symbol == MS_FALSE) {
+        style->antialiased = MS_FALSE;
+      }
+      break;
+    case (COLOR):
+      if (loadColor(&(style->color),
+                    &(style->bindings[MS_STYLE_BINDING_COLOR])) != MS_SUCCESS)
+        return (MS_FAILURE);
+      if (style->bindings[MS_STYLE_BINDING_COLOR].item)
+        style->numbindings++;
+      break;
+    case (EOF):
+      msSetError(MS_EOFERR, NULL, "loadStyle()");
+      return (MS_FAILURE); /* missing END (probably) */
+    case (END): {
+      int alpha;
+
+      /* apply opacity as the alpha channel color(s) */
+      if (style->opacity < 100) {
+        alpha = MS_NINT(style->opacity * 2.55);
 
-          style->color.alpha = alpha;
-          style->outlinecolor.alpha = alpha;
+        style->color.alpha = alpha;
+        style->outlinecolor.alpha = alpha;
 
-          style->mincolor.alpha = alpha;
-          style->maxcolor.alpha = alpha;
-        }
+        style->mincolor.alpha = alpha;
+        style->maxcolor.alpha = alpha;
+      }
 
-        return(MS_SUCCESS);
+      return (MS_SUCCESS);
+    } break;
+    case (GAP):
+      if (getDouble(&(style->gap), MS_NUM_CHECK_NONE, -1, -1) == -1)
+        return (MS_FAILURE);
+      break;
+    case (INITIALGAP):
+      if (getDouble(&(style->initialgap), MS_NUM_CHECK_GTE, 0, -1) ==
+          -1) { // zero is ok
+        msSetError(MS_MISCERR,
+                   "INITIALGAP requires a positive values (line %d)",
+                   "loadStyle()", msyylineno);
+        return (MS_FAILURE);
       }
       break;
-      case(GAP):
-        if(getDouble(&(style->gap), MS_NUM_CHECK_NONE, -1, -1) == -1) return(MS_FAILURE);
-        break;
-      case(INITIALGAP):
-        if(getDouble(&(style->initialgap), MS_NUM_CHECK_GTE, 0, -1) == -1) { // zero is ok
-          msSetError(MS_MISCERR, "INITIALGAP requires a positive values (line %d)", "loadStyle()", msyylineno);
-          return(MS_FAILURE);
-        }
-        break;
-      case(MAXSCALEDENOM):
-        if(getDouble(&(style->maxscaledenom), MS_NUM_CHECK_GTE, 0, -1) == -1) return(MS_FAILURE);
-        break;
-      case(MINSCALEDENOM):
-        if(getDouble(&(style->minscaledenom), MS_NUM_CHECK_GTE, 0, -1) == -1) return(MS_FAILURE);
-        break;
-      case(GEOMTRANSFORM): {
-        int s;
-        if((s = getSymbol(2, MS_STRING, MS_EXPRESSION)) == -1) return(MS_FAILURE);
-        if(s == MS_STRING)
-          msStyleSetGeomTransform(style, msyystring_buffer);
-        else {
-          /* handle expression case here for the moment */
-          msFree(style->_geomtransform.string);
-          style->_geomtransform.string = msStrdup(msyystring_buffer);
-          style->_geomtransform.type = MS_GEOMTRANSFORM_EXPRESSION;
-        }
+    case (MAXSCALEDENOM):
+      if (getDouble(&(style->maxscaledenom), MS_NUM_CHECK_GTE, 0, -1) == -1)
+        return (MS_FAILURE);
+      break;
+    case (MINSCALEDENOM):
+      if (getDouble(&(style->minscaledenom), MS_NUM_CHECK_GTE, 0, -1) == -1)
+        return (MS_FAILURE);
+      break;
+    case (GEOMTRANSFORM): {
+      int s;
+      if ((s = getSymbol(2, MS_STRING, MS_EXPRESSION)) == -1)
+        return (MS_FAILURE);
+      if (s == MS_STRING)
+        msStyleSetGeomTransform(style, msyystring_buffer);
+      else {
+        /* handle expression case here for the moment */
+        msFree(style->_geomtransform.string);
+        style->_geomtransform.string = msStrdup(msyystring_buffer);
+        style->_geomtransform.type = MS_GEOMTRANSFORM_EXPRESSION;
       }
+    } break;
+    case (LINECAP):
+      if ((style->linecap = getSymbol(4, MS_CJC_BUTT, MS_CJC_ROUND,
+                                      MS_CJC_SQUARE, MS_CJC_TRIANGLE)) == -1)
+        return (MS_FAILURE);
       break;
-      case(LINECAP):
-        if((style->linecap = getSymbol(4,MS_CJC_BUTT, MS_CJC_ROUND, MS_CJC_SQUARE, MS_CJC_TRIANGLE)) == -1) return(MS_FAILURE);
-        break;
-      case(LINEJOIN):
-        if((style->linejoin = getSymbol(4,MS_CJC_NONE, MS_CJC_ROUND, MS_CJC_MITER, MS_CJC_BEVEL)) == -1) return(MS_FAILURE);
-        break;
-      case(LINEJOINMAXSIZE):
-        if(getDouble(&(style->linejoinmaxsize), MS_NUM_CHECK_GT, 0, -1) == -1) return(MS_FAILURE);
-        break;
-      case(MAXSIZE):
-        if(getDouble(&(style->maxsize), MS_NUM_CHECK_GT, 0, -1) == -1) return(MS_FAILURE);
-        break;
-      case(MINSIZE):
-        if(getDouble(&(style->minsize), MS_NUM_CHECK_GTE, 0, -1) == -1) return(MS_FAILURE);
-        break;
-      case(MAXWIDTH):
-        if(getDouble(&(style->maxwidth), MS_NUM_CHECK_GT, 0, -1) == -1) return(MS_FAILURE);
-        break;
-      case(MINWIDTH):
-        if(getDouble(&(style->minwidth), MS_NUM_CHECK_GTE, 0, -1) == -1) return(MS_FAILURE);
-        break;
-      case(OFFSET):
-        if((symbol = getSymbol(2, MS_NUMBER,MS_BINDING)) == -1) return(MS_FAILURE);
-        if(symbol == MS_NUMBER)
-          style->offsetx = (double) msyynumber; // any double ok
-        else {
-          if (style->bindings[MS_STYLE_BINDING_OFFSET_X].item != NULL)
-            msFree(style->bindings[MS_STYLE_BINDING_OFFSET_X].item);
-          style->bindings[MS_STYLE_BINDING_OFFSET_X].item = msStrdup(msyystring_buffer);
-          style->numbindings++;
-        }
+    case (LINEJOIN):
+      if ((style->linejoin = getSymbol(4, MS_CJC_NONE, MS_CJC_ROUND,
+                                       MS_CJC_MITER, MS_CJC_BEVEL)) == -1)
+        return (MS_FAILURE);
+      break;
+    case (LINEJOINMAXSIZE):
+      if (getDouble(&(style->linejoinmaxsize), MS_NUM_CHECK_GT, 0, -1) == -1)
+        return (MS_FAILURE);
+      break;
+    case (MAXSIZE):
+      if (getDouble(&(style->maxsize), MS_NUM_CHECK_GT, 0, -1) == -1)
+        return (MS_FAILURE);
+      break;
+    case (MINSIZE):
+      if (getDouble(&(style->minsize), MS_NUM_CHECK_GTE, 0, -1) == -1)
+        return (MS_FAILURE);
+      break;
+    case (MAXWIDTH):
+      if (getDouble(&(style->maxwidth), MS_NUM_CHECK_GT, 0, -1) == -1)
+        return (MS_FAILURE);
+      break;
+    case (MINWIDTH):
+      if (getDouble(&(style->minwidth), MS_NUM_CHECK_GTE, 0, -1) == -1)
+        return (MS_FAILURE);
+      break;
+    case (OFFSET):
+      if ((symbol = getSymbol(2, MS_NUMBER, MS_BINDING)) == -1)
+        return (MS_FAILURE);
+      if (symbol == MS_NUMBER)
+        style->offsetx = (double)msyynumber; // any double ok
+      else {
+        if (style->bindings[MS_STYLE_BINDING_OFFSET_X].item != NULL)
+          msFree(style->bindings[MS_STYLE_BINDING_OFFSET_X].item);
+        style->bindings[MS_STYLE_BINDING_OFFSET_X].item =
+            msStrdup(msyystring_buffer);
+        style->numbindings++;
+      }
 
-        if((symbol = getSymbol(2, MS_NUMBER,MS_BINDING)) == -1) return(MS_FAILURE);
-        if(symbol == MS_NUMBER)
-          style->offsety = (double) msyynumber; // any double ok
-        else {
-          if (style->bindings[MS_STYLE_BINDING_OFFSET_Y].item != NULL)
-            msFree(style->bindings[MS_STYLE_BINDING_OFFSET_Y].item);
-          style->bindings[MS_STYLE_BINDING_OFFSET_Y].item = msStrdup(msyystring_buffer);
-          style->numbindings++;
-        }
-        break;
-      case(OPACITY):
-        if((symbol = getSymbol(2, MS_NUMBER,MS_BINDING)) == -1) return(MS_FAILURE);
-        if(symbol == MS_NUMBER)
-          style->opacity = MS_MAX(MS_MIN((int) msyynumber, 100), 0); /* force opacity to between 0 and 100 */
-        else {
-          if (style->bindings[MS_STYLE_BINDING_OPACITY].item != NULL)
-            msFree(style->bindings[MS_STYLE_BINDING_OPACITY].item);
-          style->bindings[MS_STYLE_BINDING_OPACITY].item = msStrdup(msyystring_buffer);
-          style->numbindings++;
-        }
-        break;
-      case(OUTLINECOLOR):
-        if(loadColor(&(style->outlinecolor), &(style->bindings[MS_STYLE_BINDING_OUTLINECOLOR])) != MS_SUCCESS) return(MS_FAILURE);
-        if(style->bindings[MS_STYLE_BINDING_OUTLINECOLOR].item) style->numbindings++;
-        break;
-      case(PATTERN): {
-        int done = MS_FALSE;
-        for(;;) { /* read till the next END */
-          switch(msyylex()) {
-            case(END):
-              if(style->patternlength < 2) {
-                msSetError(MS_SYMERR, "Not enough pattern elements. A minimum of 2 are required (line %d)", "loadStyle()", msyylineno);
-                return(MS_FAILURE);
-              }
-              done = MS_TRUE;
-              break;
-            case(MS_NUMBER): /* read the pattern values */
-              if(style->patternlength == MS_MAXPATTERNLENGTH) {
-                msSetError(MS_SYMERR, "Pattern too long.", "loadStyle()");
-                return(MS_FAILURE);
-              }
-              style->pattern[style->patternlength] = atof(msyystring_buffer); // good enough?
-              style->patternlength++;
-              break;
-            default:
-              msSetError(MS_TYPEERR, "Parsing error near (%s):(line %d)", "loadStyle()", msyystring_buffer, msyylineno);
-              return(MS_FAILURE);
-          }
-          if(done == MS_TRUE)
-            break;
-        }
-        break;
+      if ((symbol = getSymbol(2, MS_NUMBER, MS_BINDING)) == -1)
+        return (MS_FAILURE);
+      if (symbol == MS_NUMBER)
+        style->offsety = (double)msyynumber; // any double ok
+      else {
+        if (style->bindings[MS_STYLE_BINDING_OFFSET_Y].item != NULL)
+          msFree(style->bindings[MS_STYLE_BINDING_OFFSET_Y].item);
+        style->bindings[MS_STYLE_BINDING_OFFSET_Y].item =
+            msStrdup(msyystring_buffer);
+        style->numbindings++;
+      }
+      break;
+    case (OPACITY):
+      if ((symbol = getSymbol(2, MS_NUMBER, MS_BINDING)) == -1)
+        return (MS_FAILURE);
+      if (symbol == MS_NUMBER)
+        style->opacity = MS_MAX(MS_MIN((int)msyynumber, 100),
+                                0); /* force opacity to between 0 and 100 */
+      else {
+        if (style->bindings[MS_STYLE_BINDING_OPACITY].item != NULL)
+          msFree(style->bindings[MS_STYLE_BINDING_OPACITY].item);
+        style->bindings[MS_STYLE_BINDING_OPACITY].item =
+            msStrdup(msyystring_buffer);
+        style->numbindings++;
       }
-      case(OUTLINEWIDTH):
-        if((symbol = getSymbol(2, MS_NUMBER,MS_BINDING)) == -1) return(MS_FAILURE);
-        if(symbol == MS_NUMBER) {
-	  if(msCheckNumber(msyynumber, MS_NUM_CHECK_GTE, 0, -1) == MS_FAILURE) {
-            msSetError(MS_MISCERR, "Invalid OUTLINEWIDTH, must be greater then or equal to 0 (line %d)", "loadStyle()", msyylineno);
-            return(MS_FAILURE);
+      break;
+    case (OUTLINECOLOR):
+      if (loadColor(&(style->outlinecolor),
+                    &(style->bindings[MS_STYLE_BINDING_OUTLINECOLOR])) !=
+          MS_SUCCESS)
+        return (MS_FAILURE);
+      if (style->bindings[MS_STYLE_BINDING_OUTLINECOLOR].item)
+        style->numbindings++;
+      break;
+    case (PATTERN): {
+      int done = MS_FALSE;
+      for (;;) { /* read till the next END */
+        switch (msyylex()) {
+        case (END):
+          if (style->patternlength < 2) {
+            msSetError(MS_SYMERR,
+                       "Not enough pattern elements. A minimum of 2 are "
+                       "required (line %d)",
+                       "loadStyle()", msyylineno);
+            return (MS_FAILURE);
           }
-          style->outlinewidth = (double) msyynumber;
-        } else {
-          if (style->bindings[MS_STYLE_BINDING_OUTLINEWIDTH].item != NULL)
-            msFree(style->bindings[MS_STYLE_BINDING_OUTLINEWIDTH].item);
-          style->bindings[MS_STYLE_BINDING_OUTLINEWIDTH].item = msStrdup(msyystring_buffer);
-          style->numbindings++;
-        }
-        break;
-      case(SIZE):
-        if((symbol = getSymbol(2, MS_NUMBER,MS_BINDING)) == -1) return(MS_FAILURE);
-        if(symbol == MS_NUMBER) {
-          if(msCheckNumber(msyynumber, MS_NUM_CHECK_GT, 0, -1) == MS_FAILURE) {
-            msSetError(MS_MISCERR, "Invalid SIZE, must be greater than 0 (line %d)", "loadStyle()", msyylineno);
-            return(MS_FAILURE);
+          done = MS_TRUE;
+          break;
+        case (MS_NUMBER): /* read the pattern values */
+          if (style->patternlength == MS_MAXPATTERNLENGTH) {
+            msSetError(MS_SYMERR, "Pattern too long.", "loadStyle()");
+            return (MS_FAILURE);
           }
-          style->size = (double) msyynumber;
-        } else {
-          if (style->bindings[MS_STYLE_BINDING_SIZE].item != NULL)
-            msFree(style->bindings[MS_STYLE_BINDING_SIZE].item);
-          style->bindings[MS_STYLE_BINDING_SIZE].item = msStrdup(msyystring_buffer);
-          style->numbindings++;
+          style->pattern[style->patternlength] =
+              atof(msyystring_buffer); // good enough?
+          style->patternlength++;
+          break;
+        default:
+          msSetError(MS_TYPEERR, "Parsing error near (%s):(line %d)",
+                     "loadStyle()", msyystring_buffer, msyylineno);
+          return (MS_FAILURE);
         }
-        break;
-      case(STYLE):
-        break; /* for string loads */
-      case(SYMBOL):
-        if((symbol = getSymbol(3, MS_NUMBER,MS_STRING,MS_BINDING)) == -1) return(MS_FAILURE);
-        if(symbol == MS_NUMBER) {
-          if(msCheckNumber(msyynumber, MS_NUM_CHECK_GTE, 0, -1) == MS_FAILURE) {
-            msSetError(MS_MISCERR, "Invalid SYMBOL id, must be greater than or equal to 0 (line %d)", "loadStyle()", msyylineno);
-            return(MS_FAILURE);
-          }
-          if(style->symbolname != NULL) {
-            msFree(style->symbolname);
-            style->symbolname = NULL;
-          }
-          style->symbol = (int) msyynumber;
-        } else if(symbol == MS_STRING) {
-          if (style->symbolname != NULL)
-            msFree(style->symbolname);
-          style->symbolname = msStrdup(msyystring_buffer);
-        } else {
-          if (style->bindings[MS_STYLE_BINDING_SYMBOL].item != NULL)
-            msFree(style->bindings[MS_STYLE_BINDING_SYMBOL].item);
-          style->bindings[MS_STYLE_BINDING_SYMBOL].item = msStrdup(msyystring_buffer);
-          style->numbindings++;
+        if (done == MS_TRUE)
+          break;
+      }
+      break;
+    }
+    case (OUTLINEWIDTH):
+      if ((symbol = getSymbol(2, MS_NUMBER, MS_BINDING)) == -1)
+        return (MS_FAILURE);
+      if (symbol == MS_NUMBER) {
+        if (msCheckNumber(msyynumber, MS_NUM_CHECK_GTE, 0, -1) == MS_FAILURE) {
+          msSetError(MS_MISCERR,
+                     "Invalid OUTLINEWIDTH, must be greater then or equal to 0 "
+                     "(line %d)",
+                     "loadStyle()", msyylineno);
+          return (MS_FAILURE);
         }
-        break;
-      case(WIDTH):
-        if((symbol = getSymbol(2, MS_NUMBER,MS_BINDING)) == -1) return(MS_FAILURE);
-        if(symbol == MS_NUMBER) {
-	  if(msCheckNumber(msyynumber, MS_NUM_CHECK_GTE, 0, -1) == MS_FAILURE) {
-            msSetError(MS_MISCERR, "Invalid WIDTH, must be greater than or equal to 0 (line %d)", "loadStyle()", msyylineno);
-            return(MS_FAILURE);
-          }
-          style->width = (double) msyynumber;
-        } else {
-          if (style->bindings[MS_STYLE_BINDING_WIDTH].item != NULL)
-            msFree(style->bindings[MS_STYLE_BINDING_WIDTH].item);
-          style->bindings[MS_STYLE_BINDING_WIDTH].item = msStrdup(msyystring_buffer);
-          style->numbindings++;
+        style->outlinewidth = (double)msyynumber;
+      } else {
+        if (style->bindings[MS_STYLE_BINDING_OUTLINEWIDTH].item != NULL)
+          msFree(style->bindings[MS_STYLE_BINDING_OUTLINEWIDTH].item);
+        style->bindings[MS_STYLE_BINDING_OUTLINEWIDTH].item =
+            msStrdup(msyystring_buffer);
+        style->numbindings++;
+      }
+      break;
+    case (SIZE):
+      if ((symbol = getSymbol(2, MS_NUMBER, MS_BINDING)) == -1)
+        return (MS_FAILURE);
+      if (symbol == MS_NUMBER) {
+        if (msCheckNumber(msyynumber, MS_NUM_CHECK_GT, 0, -1) == MS_FAILURE) {
+          msSetError(MS_MISCERR,
+                     "Invalid SIZE, must be greater than 0 (line %d)",
+                     "loadStyle()", msyylineno);
+          return (MS_FAILURE);
         }
-        break;
-      case(POLAROFFSET):
-        if((symbol = getSymbol(2, MS_NUMBER,MS_BINDING)) == -1) return(MS_FAILURE);
-        if(symbol == MS_NUMBER) {
-          style->polaroffsetpixel = (double) msyynumber; // ok?
-        } else {
-          if (style->bindings[MS_STYLE_BINDING_POLAROFFSET_PIXEL].item != NULL)
-            msFree(style->bindings[MS_STYLE_BINDING_POLAROFFSET_PIXEL].item);
-          style->bindings[MS_STYLE_BINDING_POLAROFFSET_PIXEL].item = msStrdup(msyystring_buffer);
-          style->numbindings++;
+        style->size = (double)msyynumber;
+      } else {
+        if (style->bindings[MS_STYLE_BINDING_SIZE].item != NULL)
+          msFree(style->bindings[MS_STYLE_BINDING_SIZE].item);
+        style->bindings[MS_STYLE_BINDING_SIZE].item =
+            msStrdup(msyystring_buffer);
+        style->numbindings++;
+      }
+      break;
+    case (STYLE):
+      break; /* for string loads */
+    case (SYMBOL):
+      if ((symbol = getSymbol(3, MS_NUMBER, MS_STRING, MS_BINDING)) == -1)
+        return (MS_FAILURE);
+      if (symbol == MS_NUMBER) {
+        if (msCheckNumber(msyynumber, MS_NUM_CHECK_GTE, 0, -1) == MS_FAILURE) {
+          msSetError(
+              MS_MISCERR,
+              "Invalid SYMBOL id, must be greater than or equal to 0 (line %d)",
+              "loadStyle()", msyylineno);
+          return (MS_FAILURE);
+        }
+        if (style->symbolname != NULL) {
+          msFree(style->symbolname);
+          style->symbolname = NULL;
+        }
+        style->symbol = (int)msyynumber;
+      } else if (symbol == MS_STRING) {
+        if (style->symbolname != NULL)
+          msFree(style->symbolname);
+        style->symbolname = msStrdup(msyystring_buffer);
+      } else {
+        if (style->bindings[MS_STYLE_BINDING_SYMBOL].item != NULL)
+          msFree(style->bindings[MS_STYLE_BINDING_SYMBOL].item);
+        style->bindings[MS_STYLE_BINDING_SYMBOL].item =
+            msStrdup(msyystring_buffer);
+        style->numbindings++;
+      }
+      break;
+    case (WIDTH):
+      if ((symbol = getSymbol(2, MS_NUMBER, MS_BINDING)) == -1)
+        return (MS_FAILURE);
+      if (symbol == MS_NUMBER) {
+        if (msCheckNumber(msyynumber, MS_NUM_CHECK_GTE, 0, -1) == MS_FAILURE) {
+          msSetError(
+              MS_MISCERR,
+              "Invalid WIDTH, must be greater than or equal to 0 (line %d)",
+              "loadStyle()", msyylineno);
+          return (MS_FAILURE);
         }
+        style->width = (double)msyynumber;
+      } else {
+        if (style->bindings[MS_STYLE_BINDING_WIDTH].item != NULL)
+          msFree(style->bindings[MS_STYLE_BINDING_WIDTH].item);
+        style->bindings[MS_STYLE_BINDING_WIDTH].item =
+            msStrdup(msyystring_buffer);
+        style->numbindings++;
+      }
+      break;
+    case (POLAROFFSET):
+      if ((symbol = getSymbol(2, MS_NUMBER, MS_BINDING)) == -1)
+        return (MS_FAILURE);
+      if (symbol == MS_NUMBER) {
+        style->polaroffsetpixel = (double)msyynumber; // ok?
+      } else {
+        if (style->bindings[MS_STYLE_BINDING_POLAROFFSET_PIXEL].item != NULL)
+          msFree(style->bindings[MS_STYLE_BINDING_POLAROFFSET_PIXEL].item);
+        style->bindings[MS_STYLE_BINDING_POLAROFFSET_PIXEL].item =
+            msStrdup(msyystring_buffer);
+        style->numbindings++;
+      }
 
-        if((symbol = getSymbol(2, MS_NUMBER,MS_BINDING)) == -1) return(MS_FAILURE);
-        if(symbol == MS_NUMBER) {
-          style->polaroffsetangle = (double) msyynumber; // ok?
-        } else {
-          if (style->bindings[MS_STYLE_BINDING_POLAROFFSET_ANGLE].item != NULL)
-            msFree(style->bindings[MS_STYLE_BINDING_POLAROFFSET_ANGLE].item);
-          style->bindings[MS_STYLE_BINDING_POLAROFFSET_ANGLE].item = msStrdup(msyystring_buffer);
-          style->numbindings++;
-        }
-        break;
-      default:
-        if(strlen(msyystring_buffer) > 0) {
-          msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)", "loadStyle()", msyystring_buffer, msyylineno);
-          return(MS_FAILURE);
-        } else {
-          return(MS_SUCCESS); /* end of a string, not an error */
-        }
+      if ((symbol = getSymbol(2, MS_NUMBER, MS_BINDING)) == -1)
+        return (MS_FAILURE);
+      if (symbol == MS_NUMBER) {
+        style->polaroffsetangle = (double)msyynumber; // ok?
+      } else {
+        if (style->bindings[MS_STYLE_BINDING_POLAROFFSET_ANGLE].item != NULL)
+          msFree(style->bindings[MS_STYLE_BINDING_POLAROFFSET_ANGLE].item);
+        style->bindings[MS_STYLE_BINDING_POLAROFFSET_ANGLE].item =
+            msStrdup(msyystring_buffer);
+        style->numbindings++;
+      }
+      break;
+    default:
+      if (strlen(msyystring_buffer) > 0) {
+        msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)",
+                   "loadStyle()", msyystring_buffer, msyylineno);
+        return (MS_FAILURE);
+      } else {
+        return (MS_SUCCESS); /* end of a string, not an error */
+      }
     }
   }
 }
 
-int msUpdateStyleFromString(styleObj *style, char *string)
-{
-  if(!style || !string) return MS_FAILURE;
+int msUpdateStyleFromString(styleObj *style, char *string) {
+  if (!style || !string)
+    return MS_FAILURE;
 
-  msAcquireLock( TLOCK_PARSER );
+  msAcquireLock(TLOCK_PARSER);
 
   msyystate = MS_TOKENIZE_STRING;
   msyystring = string;
@@ -2765,21 +3026,21 @@ int msUpdateStyleFromString(styleObj *st
 
   msyylineno = 1; /* start at line 1 */
 
-  if(loadStyle(style) == -1) {
-    msReleaseLock( TLOCK_PARSER );
-    return MS_FAILURE; /* parse error */;
+  if (loadStyle(style) == -1) {
+    msReleaseLock(TLOCK_PARSER);
+    return MS_FAILURE; /* parse error */
+    ;
   }
-  msReleaseLock( TLOCK_PARSER );
+  msReleaseLock(TLOCK_PARSER);
 
   msyylex_destroy();
   return MS_SUCCESS;
 }
 
-int freeStyle(styleObj *style)
-{
+int freeStyle(styleObj *style) {
   int i;
 
-  if( MS_REFCNT_DECR_IS_NOT_ZERO(style) ) {
+  if (MS_REFCNT_DECR_IS_NOT_ZERO(style)) {
     return MS_FAILURE;
   }
 
@@ -2787,7 +3048,7 @@ int freeStyle(styleObj *style)
   msFreeExpression(&style->_geomtransform);
   msFree(style->rangeitem);
 
-  for(i=0; i<MS_STYLE_BINDING_LENGTH; i++) {
+  for (i = 0; i < MS_STYLE_BINDING_LENGTH; i++) {
     msFree(style->bindings[i].item);
     msFreeExpression(&(style->exprBindings[i]));
   }
@@ -2795,57 +3056,52 @@ int freeStyle(styleObj *style)
   return MS_SUCCESS;
 }
 
-void writeStyle(FILE *stream, int indent, styleObj *style)
-{
+void writeStyle(FILE *stream, int indent, styleObj *style) {
 
   indent++;
   writeBlockBegin(stream, indent, "STYLE");
 
-  if(style->numbindings > 0 && style->bindings[MS_STYLE_BINDING_ANGLE].item)
-    writeAttributeBinding(stream, indent, "ANGLE", &(style->bindings[MS_STYLE_BINDING_ANGLE]));
-  else writeNumberOrKeyword(stream, indent, "ANGLE", 0, style->angle, style->autoangle, 1, MS_TRUE, "AUTO");
-
-  if(style->numbindings > 0 && style->bindings[MS_STYLE_BINDING_COLOR].item)
-    writeAttributeBinding(stream, indent, "COLOR", &(style->bindings[MS_STYLE_BINDING_COLOR]));
-  else writeColor(stream, indent, "COLOR", NULL, &(style->color));
+  if (style->numbindings > 0 && style->bindings[MS_STYLE_BINDING_ANGLE].item)
+    writeAttributeBinding(stream, indent, "ANGLE",
+                          &(style->bindings[MS_STYLE_BINDING_ANGLE]));
+  else
+    writeNumberOrKeyword(stream, indent, "ANGLE", 0, style->angle,
+                         style->autoangle, 1, MS_TRUE, "AUTO");
+
+  if (style->numbindings > 0 && style->bindings[MS_STYLE_BINDING_COLOR].item)
+    writeAttributeBinding(stream, indent, "COLOR",
+                          &(style->bindings[MS_STYLE_BINDING_COLOR]));
+  else
+    writeColor(stream, indent, "COLOR", NULL, &(style->color));
 
   writeNumber(stream, indent, "GAP", 0, style->gap);
   writeNumber(stream, indent, "INITIALGAP", -1, style->initialgap);
 
-  if(style->_geomtransform.type == MS_GEOMTRANSFORM_EXPRESSION) {
+  if (style->_geomtransform.type == MS_GEOMTRANSFORM_EXPRESSION) {
     writeIndent(stream, indent + 1);
     msIO_fprintf(stream, "GEOMTRANSFORM (%s)\n", style->_geomtransform.string);
-  }
-  else if(style->_geomtransform.type != MS_GEOMTRANSFORM_NONE) {
+  } else if (style->_geomtransform.type != MS_GEOMTRANSFORM_NONE) {
     writeKeyword(stream, indent, "GEOMTRANSFORM", style->_geomtransform.type, 8,
-                 MS_GEOMTRANSFORM_BBOX, "\"bbox\"",
-                 MS_GEOMTRANSFORM_END, "\"end\"",
-                 MS_GEOMTRANSFORM_LABELPOINT, "\"labelpnt\"",
+                 MS_GEOMTRANSFORM_BBOX, "\"bbox\"", MS_GEOMTRANSFORM_END,
+                 "\"end\"", MS_GEOMTRANSFORM_LABELPOINT, "\"labelpnt\"",
                  MS_GEOMTRANSFORM_LABELPOLY, "\"labelpoly\"",
                  MS_GEOMTRANSFORM_LABELCENTER, "\"labelcenter\"",
-                 MS_GEOMTRANSFORM_START, "\"start\"",
-                 MS_GEOMTRANSFORM_VERTICES, "\"vertices\"",
-                 MS_GEOMTRANSFORM_CENTROID, "\"centroid\""
-                );
-  }
-
-  if(style->linecap != MS_CJC_DEFAULT_CAPS) {
-    writeKeyword(stream,indent,"LINECAP",(int)style->linecap,5,
-                 MS_CJC_NONE,"NONE",
-                 MS_CJC_ROUND, "ROUND",
-                 MS_CJC_SQUARE, "SQUARE",
-                 MS_CJC_BUTT, "BUTT",
-                 MS_CJC_TRIANGLE, "TRIANGLE");
-  }
-  if(style->linejoin != MS_CJC_DEFAULT_JOINS) {
-    writeKeyword(stream,indent,"LINEJOIN",(int)style->linejoin,5,
-                 MS_CJC_NONE,"NONE",
-                 MS_CJC_ROUND, "ROUND",
-                 MS_CJC_BEVEL, "BEVEL",
-                 MS_CJC_MITER, "MITER");
+                 MS_GEOMTRANSFORM_START, "\"start\"", MS_GEOMTRANSFORM_VERTICES,
+                 "\"vertices\"", MS_GEOMTRANSFORM_CENTROID, "\"centroid\"");
   }
-  writeNumber(stream, indent, "LINEJOINMAXSIZE", MS_CJC_DEFAULT_JOIN_MAXSIZE , style->linejoinmaxsize);
 
+  if (style->linecap != MS_CJC_DEFAULT_CAPS) {
+    writeKeyword(stream, indent, "LINECAP", (int)style->linecap, 5, MS_CJC_NONE,
+                 "NONE", MS_CJC_ROUND, "ROUND", MS_CJC_SQUARE, "SQUARE",
+                 MS_CJC_BUTT, "BUTT", MS_CJC_TRIANGLE, "TRIANGLE");
+  }
+  if (style->linejoin != MS_CJC_DEFAULT_JOINS) {
+    writeKeyword(stream, indent, "LINEJOIN", (int)style->linejoin, 5,
+                 MS_CJC_NONE, "NONE", MS_CJC_ROUND, "ROUND", MS_CJC_BEVEL,
+                 "BEVEL", MS_CJC_MITER, "MITER");
+  }
+  writeNumber(stream, indent, "LINEJOINMAXSIZE", MS_CJC_DEFAULT_JOIN_MAXSIZE,
+              style->linejoinmaxsize);
 
   writeNumber(stream, indent, "MAXSCALEDENOM", -1, style->maxscaledenom);
   writeNumber(stream, indent, "MAXSIZE", MS_MAXSYMBOLSIZE, style->maxsize);
@@ -2853,62 +3109,88 @@ void writeStyle(FILE *stream, int indent
   writeNumber(stream, indent, "MINSCALEDENOM", -1, style->minscaledenom);
   writeNumber(stream, indent, "MINSIZE", MS_MINSYMBOLSIZE, style->minsize);
   writeNumber(stream, indent, "MINWIDTH", MS_MINSYMBOLWIDTH, style->minwidth);
-  if((style->numbindings > 0 && (style->bindings[MS_STYLE_BINDING_OFFSET_X].item||style->bindings[MS_STYLE_BINDING_OFFSET_Y].item))||style->offsetx!=0||style->offsety!=0)
-    writeDimension(stream, indent, "OFFSET", style->offsetx, style->offsety, style->bindings[MS_STYLE_BINDING_OFFSET_X].item, style->bindings[MS_STYLE_BINDING_OFFSET_Y].item);
-  if((style->numbindings > 0 && (style->bindings[MS_STYLE_BINDING_POLAROFFSET_PIXEL].item||style->bindings[MS_STYLE_BINDING_POLAROFFSET_ANGLE].item))||style->polaroffsetangle!=0||style->polaroffsetpixel!=0)
-    writeDimension(stream, indent, "POLAROFFSET", style->polaroffsetpixel, style->polaroffsetangle,
-                 style->bindings[MS_STYLE_BINDING_POLAROFFSET_PIXEL].item, style->bindings[MS_STYLE_BINDING_POLAROFFSET_ANGLE].item);
-
-  if(style->numbindings > 0 && style->bindings[MS_STYLE_BINDING_OPACITY].item)
-    writeAttributeBinding(stream, indent, "OPACITY", &(style->bindings[MS_STYLE_BINDING_OPACITY]));
-  else writeNumber(stream, indent, "OPACITY", 100, style->opacity);
-
-  if(style->numbindings > 0 && style->bindings[MS_STYLE_BINDING_OUTLINECOLOR].item)
-    writeAttributeBinding(stream, indent, "OUTLINECOLOR", &(style->bindings[MS_STYLE_BINDING_OUTLINECOLOR]));
-  else  writeColor(stream, indent, "OUTLINECOLOR", NULL, &(style->outlinecolor));
-
-  if(style->numbindings > 0 && style->bindings[MS_STYLE_BINDING_OUTLINEWIDTH].item)
-    writeAttributeBinding(stream, indent, "OUTLINEWIDTH", &(style->bindings[MS_STYLE_BINDING_OUTLINEWIDTH]));
-  else writeNumber(stream, indent, "OUTLINEWIDTH", 0, style->outlinewidth);
+  if ((style->numbindings > 0 &&
+       (style->bindings[MS_STYLE_BINDING_OFFSET_X].item ||
+        style->bindings[MS_STYLE_BINDING_OFFSET_Y].item)) ||
+      style->offsetx != 0 || style->offsety != 0)
+    writeDimension(stream, indent, "OFFSET", style->offsetx, style->offsety,
+                   style->bindings[MS_STYLE_BINDING_OFFSET_X].item,
+                   style->bindings[MS_STYLE_BINDING_OFFSET_Y].item);
+  if ((style->numbindings > 0 &&
+       (style->bindings[MS_STYLE_BINDING_POLAROFFSET_PIXEL].item ||
+        style->bindings[MS_STYLE_BINDING_POLAROFFSET_ANGLE].item)) ||
+      style->polaroffsetangle != 0 || style->polaroffsetpixel != 0)
+    writeDimension(stream, indent, "POLAROFFSET", style->polaroffsetpixel,
+                   style->polaroffsetangle,
+                   style->bindings[MS_STYLE_BINDING_POLAROFFSET_PIXEL].item,
+                   style->bindings[MS_STYLE_BINDING_POLAROFFSET_ANGLE].item);
+
+  if (style->numbindings > 0 && style->bindings[MS_STYLE_BINDING_OPACITY].item)
+    writeAttributeBinding(stream, indent, "OPACITY",
+                          &(style->bindings[MS_STYLE_BINDING_OPACITY]));
+  else
+    writeNumber(stream, indent, "OPACITY", 100, style->opacity);
+
+  if (style->numbindings > 0 &&
+      style->bindings[MS_STYLE_BINDING_OUTLINECOLOR].item)
+    writeAttributeBinding(stream, indent, "OUTLINECOLOR",
+                          &(style->bindings[MS_STYLE_BINDING_OUTLINECOLOR]));
+  else
+    writeColor(stream, indent, "OUTLINECOLOR", NULL, &(style->outlinecolor));
+
+  if (style->numbindings > 0 &&
+      style->bindings[MS_STYLE_BINDING_OUTLINEWIDTH].item)
+    writeAttributeBinding(stream, indent, "OUTLINEWIDTH",
+                          &(style->bindings[MS_STYLE_BINDING_OUTLINEWIDTH]));
+  else
+    writeNumber(stream, indent, "OUTLINEWIDTH", 0, style->outlinewidth);
 
   /* PATTERN */
-  if(style->patternlength != 0) {
+  if (style->patternlength != 0) {
     int i;
     indent++;
-    writeBlockBegin(stream,indent,"PATTERN");
+    writeBlockBegin(stream, indent, "PATTERN");
     writeIndent(stream, indent);
-    for(i=0; i<style->patternlength; i++)
+    for (i = 0; i < style->patternlength; i++)
       msIO_fprintf(stream, " %.2f", style->pattern[i]);
-    msIO_fprintf(stream,"\n");
-    writeBlockEnd(stream,indent,"PATTERN");
+    msIO_fprintf(stream, "\n");
+    writeBlockEnd(stream, indent, "PATTERN");
     indent--;
   }
 
-  if(style->numbindings > 0 && style->bindings[MS_STYLE_BINDING_SIZE].item)
-    writeAttributeBinding(stream, indent, "SIZE", &(style->bindings[MS_STYLE_BINDING_SIZE]));
-  else writeNumber(stream, indent, "SIZE", -1, style->size);
-
-  if(style->numbindings > 0 && style->bindings[MS_STYLE_BINDING_SYMBOL].item)
-    writeAttributeBinding(stream, indent, "SYMBOL", &(style->bindings[MS_STYLE_BINDING_SYMBOL]));
-  else writeNumberOrString(stream, indent, "SYMBOL", 0, style->symbol, style->symbolname);
-
-  if(style->numbindings > 0 && style->bindings[MS_STYLE_BINDING_WIDTH].item)
-    writeAttributeBinding(stream, indent, "WIDTH", &(style->bindings[MS_STYLE_BINDING_WIDTH]));
-  else writeNumber(stream, indent, "WIDTH", 1, style->width);
+  if (style->numbindings > 0 && style->bindings[MS_STYLE_BINDING_SIZE].item)
+    writeAttributeBinding(stream, indent, "SIZE",
+                          &(style->bindings[MS_STYLE_BINDING_SIZE]));
+  else
+    writeNumber(stream, indent, "SIZE", -1, style->size);
+
+  if (style->numbindings > 0 && style->bindings[MS_STYLE_BINDING_SYMBOL].item)
+    writeAttributeBinding(stream, indent, "SYMBOL",
+                          &(style->bindings[MS_STYLE_BINDING_SYMBOL]));
+  else
+    writeNumberOrString(stream, indent, "SYMBOL", 0, style->symbol,
+                        style->symbolname);
+
+  if (style->numbindings > 0 && style->bindings[MS_STYLE_BINDING_WIDTH].item)
+    writeAttributeBinding(stream, indent, "WIDTH",
+                          &(style->bindings[MS_STYLE_BINDING_WIDTH]));
+  else
+    writeNumber(stream, indent, "WIDTH", 1, style->width);
 
   writeString(stream, indent, "RANGEITEM", NULL, style->rangeitem);
   /* If COLORRANGE is valid, assume DATARANGE also needs to be written */
-  if(MS_VALID_COLOR(style->mincolor) && MS_VALID_COLOR(style->maxcolor)) {
-    writeColorRange(stream, indent, "COLORRANGE", &(style->mincolor), &(style->maxcolor));
-    writeDoubleRange(stream, indent, "DATARANGE", style->minvalue, style->maxvalue);
+  if (MS_VALID_COLOR(style->mincolor) && MS_VALID_COLOR(style->maxcolor)) {
+    writeColorRange(stream, indent, "COLORRANGE", &(style->mincolor),
+                    &(style->maxcolor));
+    writeDoubleRange(stream, indent, "DATARANGE", style->minvalue,
+                     style->maxvalue);
   }
 
   writeBlockEnd(stream, indent, "STYLE");
 }
 
-char* msWriteStyleToString(styleObj *style)
-{
-  msIOContext  context;
+char *msWriteStyleToString(styleObj *style) {
+  msIOContext context;
   msIOBuffer buffer;
 
   context.label = NULL;
@@ -2919,21 +3201,20 @@ char* msWriteStyleToString(styleObj *sty
   buffer.data_len = 0;
   buffer.data_offset = 0;
 
-  msIO_installHandlers( NULL, &context, NULL );
+  msIO_installHandlers(NULL, &context, NULL);
 
   writeStyle(stdout, -1, style);
-  msIO_bufferWrite( &buffer, "", 1 );
+  msIO_bufferWrite(&buffer, "", 1);
 
-  msIO_installHandlers( NULL, NULL, NULL );
+  msIO_installHandlers(NULL, NULL, NULL);
 
-  return (char*)buffer.data;
+  return (char *)buffer.data;
 }
 
 /*
 ** Initialize, load and free a single class
 */
-int initClass(classObj *class)
-{
+int initClass(classObj *class) {
   class->status = MS_ON;
   class->debug = MS_OFF;
   MS_REFCNT_INIT(class);
@@ -2970,14 +3251,13 @@ int initClass(classObj *class)
   class->sizeunits = MS_INHERIT;
   class->scalefactor = 1.0;
 
-  return(0);
+  return (0);
 }
 
-int freeClass(classObj *class)
-{
+int freeClass(classObj *class) {
   int i;
 
-  if( MS_REFCNT_DECR_IS_NOT_ZERO(class) ) {
+  if (MS_REFCNT_DECR_IS_NOT_ZERO(class)) {
     return MS_FAILURE;
   }
 
@@ -2988,21 +3268,23 @@ int freeClass(classObj *class)
   msFree(class->template);
   msFree(class->group);
 
-  if (&(class->metadata)) msFreeHashItems(&(class->metadata));
-  if (&(class->validation)) msFreeHashItems(&(class->validation));
-
-  for(i=0; i<class->numstyles; i++) { /* each style */
-    if(class->styles[i]!=NULL) {
-      if(freeStyle(class->styles[i]) == MS_SUCCESS) {
+  if (&(class->metadata))
+    msFreeHashItems(&(class->metadata));
+  if (&(class->validation))
+    msFreeHashItems(&(class->validation));
+
+  for (i = 0; i < class->numstyles; i++) { /* each style */
+    if (class->styles[i] != NULL) {
+      if (freeStyle(class->styles[i]) == MS_SUCCESS) {
         msFree(class->styles[i]);
       }
     }
   }
   msFree(class->styles);
 
-  for(i=0; i<class->numlabels; i++) { /* each label */
-    if(class->labels[i]!=NULL) {
-      if(freeLabel(class->labels[i]) == MS_SUCCESS) {
+  for (i = 0; i < class->numlabels; i++) { /* each label */
+    if (class->labels[i] != NULL) {
+      if (freeLabel(class->labels[i]) == MS_SUCCESS) {
         msFree(class->labels[i]);
       }
     }
@@ -3011,7 +3293,7 @@ int freeClass(classObj *class)
 
   msFree(class->keyimage);
 
-  if(class->leader) {
+  if (class->leader) {
     freeLabelLeader(class->leader);
     msFree(class->leader);
     class->leader = NULL;
@@ -3032,8 +3314,7 @@ int freeClass(classObj *class)
 **
 ** Returns a reference to the new styleObj on success, NULL on error.
 */
-styleObj *msGrowClassStyles( classObj *class )
-{
+styleObj *msGrowClassStyles(classObj *class) {
   /* Do we need to increase the size of styles[] by  MS_STYLE_ALLOCSIZE?
    */
   if (class->numstyles == class->maxstyles) {
@@ -3043,18 +3324,19 @@ styleObj *msGrowClassStyles( classObj *c
     newsize = class->maxstyles + MS_STYLE_ALLOCSIZE;
 
     /* Alloc/realloc styles */
-    newStylePtr = (styleObj**)realloc(class->styles, newsize*sizeof(styleObj*));
-    MS_CHECK_ALLOC(newStylePtr, newsize*sizeof(styleObj*), NULL);
+    newStylePtr =
+        (styleObj **)realloc(class->styles, newsize * sizeof(styleObj *));
+    MS_CHECK_ALLOC(newStylePtr, newsize * sizeof(styleObj *), NULL);
 
     class->styles = newStylePtr;
     class->maxstyles = newsize;
-    for(i=class->numstyles; i<class->maxstyles; i++) {
+    for (i = class->numstyles; i < class->maxstyles; i++) {
       class->styles[i] = NULL;
     }
   }
 
-  if (class->styles[class->numstyles]==NULL) {
-    class->styles[class->numstyles]=(styleObj*)calloc(1,sizeof(styleObj));
+  if (class->styles[class->numstyles] == NULL) {
+    class->styles[class->numstyles] = (styleObj *)calloc(1, sizeof(styleObj));
     MS_CHECK_ALLOC(class->styles[class->numstyles], sizeof(styleObj), NULL);
   }
 
@@ -3062,8 +3344,7 @@ styleObj *msGrowClassStyles( classObj *c
 }
 
 /* exactly the same as for a classObj */
-styleObj *msGrowLabelStyles( labelObj *label )
-{
+styleObj *msGrowLabelStyles(labelObj *label) {
   /* Do we need to increase the size of styles[] by  MS_STYLE_ALLOCSIZE?
    */
   if (label->numstyles == label->maxstyles) {
@@ -3073,18 +3354,19 @@ styleObj *msGrowLabelStyles( labelObj *l
     newsize = label->maxstyles + MS_STYLE_ALLOCSIZE;
 
     /* Alloc/realloc styles */
-    newStylePtr = (styleObj**)realloc(label->styles, newsize*sizeof(styleObj*));
-    MS_CHECK_ALLOC(newStylePtr, newsize*sizeof(styleObj*), NULL);
+    newStylePtr =
+        (styleObj **)realloc(label->styles, newsize * sizeof(styleObj *));
+    MS_CHECK_ALLOC(newStylePtr, newsize * sizeof(styleObj *), NULL);
 
     label->styles = newStylePtr;
     label->maxstyles = newsize;
-    for(i=label->numstyles; i<label->maxstyles; i++) {
+    for (i = label->numstyles; i < label->maxstyles; i++) {
       label->styles[i] = NULL;
     }
   }
 
-  if (label->styles[label->numstyles]==NULL) {
-    label->styles[label->numstyles]=(styleObj*)calloc(1,sizeof(styleObj));
+  if (label->styles[label->numstyles] == NULL) {
+    label->styles[label->numstyles] = (styleObj *)calloc(1, sizeof(styleObj));
     MS_CHECK_ALLOC(label->styles[label->numstyles], sizeof(styleObj), NULL);
   }
 
@@ -3092,8 +3374,7 @@ styleObj *msGrowLabelStyles( labelObj *l
 }
 
 /* exactly the same as for a labelLeaderObj, needs refactoring */
-styleObj *msGrowLeaderStyles( labelLeaderObj *leader )
-{
+styleObj *msGrowLeaderStyles(labelLeaderObj *leader) {
   /* Do we need to increase the size of styles[] by  MS_STYLE_ALLOCSIZE?
    */
   if (leader->numstyles == leader->maxstyles) {
@@ -3103,19 +3384,19 @@ styleObj *msGrowLeaderStyles( labelLeade
     newsize = leader->maxstyles + MS_STYLE_ALLOCSIZE;
 
     /* Alloc/realloc styles */
-    newStylePtr = (styleObj**)realloc(leader->styles,
-                                      newsize*sizeof(styleObj*));
-    MS_CHECK_ALLOC(newStylePtr, newsize*sizeof(styleObj*), NULL);
+    newStylePtr =
+        (styleObj **)realloc(leader->styles, newsize * sizeof(styleObj *));
+    MS_CHECK_ALLOC(newStylePtr, newsize * sizeof(styleObj *), NULL);
 
     leader->styles = newStylePtr;
     leader->maxstyles = newsize;
-    for(i=leader->numstyles; i<leader->maxstyles; i++) {
+    for (i = leader->numstyles; i < leader->maxstyles; i++) {
       leader->styles[i] = NULL;
     }
   }
 
-  if (leader->styles[leader->numstyles]==NULL) {
-    leader->styles[leader->numstyles]=(styleObj*)calloc(1,sizeof(styleObj));
+  if (leader->styles[leader->numstyles] == NULL) {
+    leader->styles[leader->numstyles] = (styleObj *)calloc(1, sizeof(styleObj));
     MS_CHECK_ALLOC(leader->styles[leader->numstyles], sizeof(styleObj), NULL);
   }
 
@@ -3128,50 +3409,48 @@ styleObj *msGrowLeaderStyles( labelLeade
 **
 ** Returns MS_SUCCESS/MS_FAILURE.
 */
-int msMaybeAllocateClassStyle(classObj* c, int idx)
-{
-  if (c==NULL) return MS_FAILURE;
+int msMaybeAllocateClassStyle(classObj *c, int idx) {
+  if (c == NULL)
+    return MS_FAILURE;
 
-  if ( idx < 0 ) {
-    msSetError(MS_MISCERR, "Invalid style index: %d", "msMaybeAllocateClassStyle()", idx);
+  if (idx < 0) {
+    msSetError(MS_MISCERR, "Invalid style index: %d",
+               "msMaybeAllocateClassStyle()", idx);
     return MS_FAILURE;
   }
 
   /* Alloc empty styles as needed up to idx.
    * Nothing to do if requested style already exists
    */
-  while(c->numstyles <= idx) {
+  while (c->numstyles <= idx) {
     if (msGrowClassStyles(c) == NULL)
       return MS_FAILURE;
 
-    if ( initStyle(c->styles[c->numstyles]) == MS_FAILURE ) {
+    if (initStyle(c->styles[c->numstyles]) == MS_FAILURE) {
       msSetError(MS_MISCERR, "Failed to init new styleObj",
                  "msMaybeAllocateClassStyle()");
       freeStyle(c->styles[c->numstyles]);
       free(c->styles[c->numstyles]);
       c->styles[c->numstyles] = NULL;
-      return(MS_FAILURE);
+      return (MS_FAILURE);
     }
     c->numstyles++;
   }
   return MS_SUCCESS;
 }
 
-
-
 /*
  * Reset style info in the class to defaults
  * the only members we don't touch are name, expression, and join/query stuff
  * This is used with STYLEITEM before overwriting the contents of a class.
  */
-void resetClassStyle(classObj *class)
-{
+void resetClassStyle(classObj *class) {
   int i;
 
   /* reset labels */
-  for(i=0; i<class->numlabels; i++) {
-    if(class->labels[i] != NULL) {
-      if(freeLabel(class->labels[i]) == MS_SUCCESS ) {
+  for (i = 0; i < class->numlabels; i++) {
+    if (class->labels[i] != NULL) {
+      if (freeLabel(class->labels[i]) == MS_SUCCESS) {
         msFree(class->labels[i]);
       }
       class->labels[i] = NULL;
@@ -3183,9 +3462,9 @@ void resetClassStyle(classObj *class)
   msInitExpression(&(class->text));
 
   /* reset styles */
-  for(i=0; i<class->numstyles; i++) {
-    if(class->styles[i] != NULL) {
-      if( freeStyle(class->styles[i]) == MS_SUCCESS ) {
+  for (i = 0; i < class->numstyles; i++) {
+    if (class->styles[i] != NULL) {
+      if (freeStyle(class->styles[i]) == MS_SUCCESS) {
         msFree(class->styles[i]);
       }
       class->styles[i] = NULL;
@@ -3196,8 +3475,7 @@ void resetClassStyle(classObj *class)
   class->layer = NULL;
 }
 
-labelObj *msGrowClassLabels( classObj *class )
-{
+labelObj *msGrowClassLabels(classObj *class) {
 
   /* Do we need to increase the size of labels[] by MS_LABEL_ALLOCSIZE?
    */
@@ -3208,159 +3486,197 @@ labelObj *msGrowClassLabels( classObj *c
     newsize = class->maxlabels + MS_LABEL_ALLOCSIZE;
 
     /* Alloc/realloc labels */
-    newLabelPtr = (labelObj**)realloc(class->labels, newsize*sizeof(labelObj*));
-    MS_CHECK_ALLOC(newLabelPtr, newsize*sizeof(labelObj*), NULL);
+    newLabelPtr =
+        (labelObj **)realloc(class->labels, newsize * sizeof(labelObj *));
+    MS_CHECK_ALLOC(newLabelPtr, newsize * sizeof(labelObj *), NULL);
 
     class->labels = newLabelPtr;
     class->maxlabels = newsize;
-    for(i=class->numlabels; i<class->maxlabels; i++) {
+    for (i = class->numlabels; i < class->maxlabels; i++) {
       class->labels[i] = NULL;
     }
   }
 
-  if (class->labels[class->numlabels]==NULL) {
-    class->labels[class->numlabels]=(labelObj*)calloc(1,sizeof(labelObj));
+  if (class->labels[class->numlabels] == NULL) {
+    class->labels[class->numlabels] = (labelObj *)calloc(1, sizeof(labelObj));
     MS_CHECK_ALLOC(class->labels[class->numlabels], sizeof(labelObj), NULL);
   }
 
   return class->labels[class->numlabels];
 }
 
-int loadClass(classObj *class, layerObj *layer)
-{
-  if(!class || !layer) return(-1);
-
-  class->layer = (layerObj *) layer;
-
-  for(;;) {
-    switch(msyylex()) {
-      case(CLASS):
-        break; /* for string loads */
-      case(DEBUG):
-        if((class->debug = getSymbol(3, MS_ON,MS_OFF, MS_NUMBER)) == -1) return(-1);
-        if(class->debug == MS_NUMBER) {
-	  if(msCheckNumber(msyynumber, MS_NUM_CHECK_RANGE, 0, 5) == MS_FAILURE) {
-            msSetError(MS_MISCERR, "Invalid DEBUG level, must be between 0 and 5 (line %d)", "loadClass()", msyylineno);
-            return(-1);
-          }
-          class->debug = (int) msyynumber;
-        }
-        break;
-      case(EOF):
-        msSetError(MS_EOFERR, NULL, "loadClass()");
-        return(-1);
-      case(END):
-        return(0);
-        break;
-      case(EXPRESSION):
-        if(loadExpression(&(class->expression)) == -1) return(-1); /* loadExpression() cleans up previously allocated expression */
-        break;
-      case(GROUP):
-        if(getString(&class->group) == MS_FAILURE) return(-1); /* getString() cleans up previously allocated string */
-        break;
-      case(KEYIMAGE):
-        if(getString(&class->keyimage) == MS_FAILURE) return(-1); /* getString() cleans up previously allocated string */
-        break;
-      case(LABEL):
-        if(msGrowClassLabels(class) == NULL) return(-1);
-        initLabel(class->labels[class->numlabels]);
-        class->labels[class->numlabels]->size = MS_MEDIUM; /* only set a default if the LABEL section is present */
-        if(loadLabel(class->labels[class->numlabels]) == -1) {
-          freeLabel(class->labels[class->numlabels]);
-          free(class->labels[class->numlabels]);
-          class->labels[class->numlabels] = NULL;
-          return(-1);
-        }
-        class->numlabels++;
-        break;
-      case(LEADER):
-        if(!class->leader) {
-          class->leader = msSmallMalloc(sizeof(labelLeaderObj));
-          initLeader(class->leader);
-        }
-        if(loadLeader(class->leader) == -1) return(-1);
-        break;
-      case(MAXSCALE):
-      case(MAXSCALEDENOM):
-        if(getDouble(&(class->maxscaledenom), MS_NUM_CHECK_GTE, 0, -1) == -1) return(-1);
-        break;
-      case(METADATA):
-        if(loadHashTable(&(class->metadata)) != MS_SUCCESS) return(-1);
-        break;
-      case(MINSCALE):
-      case(MINSCALEDENOM):
-        if(getDouble(&(class->minscaledenom), MS_NUM_CHECK_GTE, 0, -1) == -1) return(-1);
-        break;
-      case(MINFEATURESIZE):
-        if(getInteger(&(class->minfeaturesize), MS_NUM_CHECK_GT, 0, -1) == -1) return(-1);
-        break;
-      case(NAME):
-        if(getString(&class->name) == MS_FAILURE) return(-1);
-        break;
-      case(STATUS):
-        if((class->status = getSymbol(2, MS_ON,MS_OFF)) == -1) return(-1);
-        break;
-      case(STYLE):
-        if(msGrowClassStyles(class) == NULL)
-          return(-1);
-        initStyle(class->styles[class->numstyles]);
-        if(loadStyle(class->styles[class->numstyles]) != MS_SUCCESS) {
-            freeStyle(class->styles[class->numstyles]);
-            free(class->styles[class->numstyles]);
-            class->styles[class->numstyles] = NULL;
-            return(-1);
-        }
-        class->numstyles++;
-        break;
-      case(TEMPLATE):
-        if(getString(&class->template) == MS_FAILURE) return(-1); /* getString() cleans up previously allocated string */
-        break;
-      case(TEXT):
-        if(loadExpression(&(class->text)) == -1) return(-1); /* loadExpression() cleans up previously allocated expression */
-        if((class->text.type != MS_STRING) && (class->text.type != MS_EXPRESSION)) {
-          msSetError(MS_MISCERR, "Text expressions support constant or tagged replacement strings." , "loadClass()");
-          return(-1);
-        }
-        break;
-      case(TITLE):
-        if(getString(&class->title) == MS_FAILURE) return(-1); /* getString() cleans up previously allocated string */
-        break;
-      case(VALIDATION):
-        if(loadHashTable(&(class->validation)) != MS_SUCCESS) return(-1);
-        break;
-      default:
-        if(strlen(msyystring_buffer) > 0) {
-          msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)", "loadClass()", msyystring_buffer, msyylineno);
-          return(-1);
-        } else {
-          return(0); /* end of a string, not an error */
+int loadClass(classObj *class, layerObj *layer) {
+  if (!class || !layer)
+    return (-1);
+
+  class->layer = (layerObj *)layer;
+
+  for (;;) {
+    switch (msyylex()) {
+    case (CLASS):
+      break; /* for string loads */
+    case (DEBUG):
+      if ((class->debug = getSymbol(3, MS_ON, MS_OFF, MS_NUMBER)) == -1)
+        return (-1);
+      if (class->debug == MS_NUMBER) {
+        if (msCheckNumber(msyynumber, MS_NUM_CHECK_RANGE, 0, 5) == MS_FAILURE) {
+          msSetError(MS_MISCERR,
+                     "Invalid DEBUG level, must be between 0 and 5 (line %d)",
+                     "loadClass()", msyylineno);
+          return (-1);
         }
+        class->debug = (int)msyynumber;
+      }
+      break;
+    case (EOF):
+      msSetError(MS_EOFERR, NULL, "loadClass()");
+      return (-1);
+    case (END):
+      return (0);
+      break;
+    case (EXPRESSION):
+      if (loadExpression(&(class->expression)) == -1)
+        return (-1); /* loadExpression() cleans up previously allocated
+                        expression */
+      break;
+    case (GROUP):
+      if (getString(&class->group) == MS_FAILURE)
+        return (-1); /* getString() cleans up previously allocated string */
+      break;
+    case (KEYIMAGE):
+      if (getString(&class->keyimage) == MS_FAILURE)
+        return (-1); /* getString() cleans up previously allocated string */
+      break;
+    case (LABEL):
+      if (msGrowClassLabels(class) == NULL)
+        return (-1);
+      initLabel(class->labels[class->numlabels]);
+      class->labels[class->numlabels]->size =
+          MS_MEDIUM; /* only set a default if the LABEL section is present */
+      if (loadLabel(class->labels[class->numlabels]) == -1) {
+        freeLabel(class->labels[class->numlabels]);
+        free(class->labels[class->numlabels]);
+        class->labels[class->numlabels] = NULL;
+        return (-1);
+      }
+      class->numlabels++;
+      break;
+    case (LEADER):
+      if (!class->leader) {
+        class->leader = msSmallMalloc(sizeof(labelLeaderObj));
+        initLeader(class->leader);
+      }
+      if (loadLeader(class->leader) == -1)
+        return (-1);
+      break;
+    case (MAXSCALE):
+    case (MAXSCALEDENOM):
+      if (getDouble(&(class->maxscaledenom), MS_NUM_CHECK_GTE, 0, -1) == -1)
+        return (-1);
+      break;
+    case (METADATA):
+      if (loadHashTable(&(class->metadata)) != MS_SUCCESS)
+        return (-1);
+      break;
+    case (MINSCALE):
+    case (MINSCALEDENOM):
+      if (getDouble(&(class->minscaledenom), MS_NUM_CHECK_GTE, 0, -1) == -1)
+        return (-1);
+      break;
+    case (MINFEATURESIZE):
+      if (getInteger(&(class->minfeaturesize), MS_NUM_CHECK_GT, 0, -1) == -1)
+        return (-1);
+      break;
+    case (NAME):
+      if (getString(&class->name) == MS_FAILURE)
+        return (-1);
+      break;
+    case (STATUS):
+      if ((class->status = getSymbol(2, MS_ON, MS_OFF)) == -1)
+        return (-1);
+      break;
+    case (STYLE):
+      if (msGrowClassStyles(class) == NULL)
+        return (-1);
+      initStyle(class->styles[class->numstyles]);
+      if (loadStyle(class->styles[class->numstyles]) != MS_SUCCESS) {
+        freeStyle(class->styles[class->numstyles]);
+        free(class->styles[class->numstyles]);
+        class->styles[class->numstyles] = NULL;
+        return (-1);
+      }
+      class->numstyles++;
+      break;
+    case (TEMPLATE):
+      if (getString(&class->template) == MS_FAILURE)
+        return (-1); /* getString() cleans up previously allocated string */
+      break;
+    case (TEXT):
+      if (loadExpression(&(class->text)) == -1)
+        return (-1); /* loadExpression() cleans up previously allocated
+                        expression */
+      if ((class->text.type != MS_STRING) &&
+          (class->text.type != MS_EXPRESSION)) {
+        msSetError(
+            MS_MISCERR,
+            "Text expressions support constant or tagged replacement strings.",
+            "loadClass()");
+        return (-1);
+      }
+      break;
+    case (TITLE):
+      if (getString(&class->title) == MS_FAILURE)
+        return (-1); /* getString() cleans up previously allocated string */
+      break;
+    case (VALIDATION):
+      if (loadHashTable(&(class->validation)) != MS_SUCCESS)
+        return (-1);
+      break;
+    default:
+      if (strlen(msyystring_buffer) > 0) {
+        msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)",
+                   "loadClass()", msyystring_buffer, msyylineno);
+        return (-1);
+      } else {
+        return (0); /* end of a string, not an error */
+      }
     }
   }
 }
 
-static int classResolveSymbolNames(classObj *class)
-{
-  int i,j;
+static int classResolveSymbolNames(classObj *class) {
+  int i, j;
   int try_addimage_if_notfound = MS_TRUE;
 
   /* step through styles and labels to resolve symbol names */
   /* class styles */
-  for(i=0; i<class->numstyles; i++) {
-    if(class->styles[i]->symbolname) {
-      if((class->styles[i]->symbol =  msGetSymbolIndex(&(class->layer->map->symbolset), class->styles[i]->symbolname, try_addimage_if_notfound)) == -1) {
-        msSetError(MS_MISCERR, "Undefined symbol \"%s\" in class, style %d of layer %s.", "classResolveSymbolNames()", class->styles[i]->symbolname, i, class->layer->name);
+  for (i = 0; i < class->numstyles; i++) {
+    if (class->styles[i]->symbolname) {
+      if ((class->styles[i]->symbol = msGetSymbolIndex(
+               &(class->layer->map->symbolset), class->styles[i]->symbolname,
+               try_addimage_if_notfound)) == -1) {
+        msSetError(MS_MISCERR,
+                   "Undefined symbol \"%s\" in class, style %d of layer %s.",
+                   "classResolveSymbolNames()", class->styles[i]->symbolname, i,
+                   class->layer->name);
         return MS_FAILURE;
       }
     }
   }
 
   /* label styles */
-  for(i=0; i<class->numlabels; i++) {
-    for(j=0; j<class->labels[i]->numstyles; j++) {
-      if(class->labels[i]->styles[j]->symbolname) {
-        if((class->labels[i]->styles[j]->symbol =  msGetSymbolIndex(&(class->layer->map->symbolset), class->labels[i]->styles[j]->symbolname, try_addimage_if_notfound)) == -1) {
-          msSetError(MS_MISCERR, "Undefined symbol \"%s\" in class, label style %d of layer %s.", "classResolveSymbolNames()", class->labels[i]->styles[j]->symbolname, j, class->layer->name);
+  for (i = 0; i < class->numlabels; i++) {
+    for (j = 0; j < class->labels[i]->numstyles; j++) {
+      if (class->labels[i]->styles[j]->symbolname) {
+        if ((class->labels[i]->styles[j]->symbol =
+                 msGetSymbolIndex(&(class->layer->map->symbolset),
+                                  class->labels[i]->styles[j]->symbolname,
+                                  try_addimage_if_notfound)) == -1) {
+          msSetError(
+              MS_MISCERR,
+              "Undefined symbol \"%s\" in class, label style %d of layer %s.",
+              "classResolveSymbolNames()",
+              class->labels[i]->styles[j]->symbolname, j, class->layer->name);
           return MS_FAILURE;
         }
       }
@@ -3370,11 +3686,11 @@ static int classResolveSymbolNames(class
   return MS_SUCCESS;
 }
 
-int msUpdateClassFromString(classObj *class, char *string)
-{
-  if(!class || !string) return MS_FAILURE;
+int msUpdateClassFromString(classObj *class, char *string) {
+  if (!class || !string)
+    return MS_FAILURE;
 
-  msAcquireLock( TLOCK_PARSER );
+  msAcquireLock(TLOCK_PARSER);
 
   msyystate = MS_TOKENIZE_STRING;
   msyystring = string;
@@ -3382,24 +3698,26 @@ int msUpdateClassFromString(classObj *cl
 
   msyylineno = 1; /* start at line 1 */
 
-  if(loadClass(class, class->layer) == -1) {
-    msReleaseLock( TLOCK_PARSER );
-    return MS_FAILURE; /* parse error */;
+  if (loadClass(class, class->layer) == -1) {
+    msReleaseLock(TLOCK_PARSER);
+    return MS_FAILURE; /* parse error */
+    ;
   }
-  msReleaseLock( TLOCK_PARSER );
+  msReleaseLock(TLOCK_PARSER);
 
   msyylex_destroy();
 
-  if(classResolveSymbolNames(class) != MS_SUCCESS) return MS_FAILURE;
+  if (classResolveSymbolNames(class) != MS_SUCCESS)
+    return MS_FAILURE;
 
   return MS_SUCCESS;
 }
 
-static void writeClass(FILE *stream, int indent, classObj *class)
-{
+static void writeClass(FILE *stream, int indent, classObj *class) {
   int i;
 
-  if(class->status == MS_DELETE) return;
+  if (class->status == MS_DELETE)
+    return;
 
   indent++;
   writeBlockBegin(stream, indent, "CLASS");
@@ -3408,15 +3726,17 @@ static void writeClass(FILE *stream, int
   writeNumber(stream, indent, "DEBUG", 0, class->debug);
   writeExpression(stream, indent, "EXPRESSION", &(class->expression));
   writeString(stream, indent, "KEYIMAGE", NULL, class->keyimage);
-  for(i=0; i<class->numlabels; i++) writeLabel(stream, indent, class->labels[i]);
-  if(class->leader)
-    writeLeader(stream,indent,class->leader);
+  for (i = 0; i < class->numlabels; i++)
+    writeLabel(stream, indent, class->labels[i]);
+  if (class->leader)
+    writeLeader(stream, indent, class->leader);
   writeNumber(stream, indent, "MAXSCALEDENOM", -1, class->maxscaledenom);
   writeHashTable(stream, indent, "METADATA", &(class->metadata));
   writeNumber(stream, indent, "MINSCALEDENOM", -1, class->minscaledenom);
   writeNumber(stream, indent, "MINFEATURESIZE", -1, class->minfeaturesize);
   writeKeyword(stream, indent, "STATUS", class->status, 1, MS_OFF, "OFF");
-  for(i=0; i<class->numstyles; i++) writeStyle(stream, indent, class->styles[i]);
+  for (i = 0; i < class->numstyles; i++)
+    writeStyle(stream, indent, class->styles[i]);
   writeString(stream, indent, "TEMPLATE", NULL, class->template);
   writeExpression(stream, indent, "TEXT", &(class->text));
   writeString(stream, indent, "TITLE", NULL, class->title);
@@ -3424,9 +3744,8 @@ static void writeClass(FILE *stream, int
   writeBlockEnd(stream, indent, "CLASS");
 }
 
-char* msWriteClassToString(classObj *class)
-{
-  msIOContext  context;
+char *msWriteClassToString(classObj *class) {
+  msIOContext context;
   msIOBuffer buffer;
 
   context.label = NULL;
@@ -3437,14 +3756,14 @@ char* msWriteClassToString(classObj *cla
   buffer.data_len = 0;
   buffer.data_offset = 0;
 
-  msIO_installHandlers( NULL, &context, NULL );
+  msIO_installHandlers(NULL, &context, NULL);
 
   writeClass(stdout, -1, class);
-  msIO_bufferWrite( &buffer, "", 1 );
+  msIO_bufferWrite(&buffer, "", 1);
 
-  msIO_installHandlers( NULL, NULL, NULL );
+  msIO_installHandlers(NULL, NULL, NULL);
 
-  return (char*)buffer.data;
+  return (char *)buffer.data;
 }
 
 int initCompositingFilter(CompositingFilter *filter) {
@@ -3454,8 +3773,9 @@ int initCompositingFilter(CompositingFil
 }
 
 void freeCompositingFilter(CompositingFilter *filter) {
-  if(!filter) return;
-  if(filter->next)
+  if (!filter)
+    return;
+  if (filter->next)
     freeCompositingFilter(filter->next);
   free(filter->filter);
   free(filter);
@@ -3470,8 +3790,9 @@ int initLayerCompositer(LayerCompositer
 }
 
 void freeLayerCompositer(LayerCompositer *compositer) {
-  if(!compositer) return;
-  if(compositer->next)
+  if (!compositer)
+    return;
+  if (compositer->next)
     freeLayerCompositer(compositer->next);
   freeCompositingFilter(compositer->filter);
   free(compositer);
@@ -3480,11 +3801,10 @@ void freeLayerCompositer(LayerCompositer
 /*
 ** Initialize, load and free a single layer structure
 */
-int initLayer(layerObj *layer, mapObj *map)
-{
-  if (layer==NULL) {
+int initLayer(layerObj *layer, mapObj *map) {
+  if (layer == NULL) {
     msSetError(MS_MEMERR, "Layer is null", "initLayer()");
-    return(-1);
+    return (-1);
   }
   layer->debug = (int)msGetGlobalDebugLevel();
   MS_REFCNT_INIT(layer);
@@ -3507,7 +3827,8 @@ int initLayer(layerObj *layer, mapObj *m
   layer->type = -1;
 
   layer->toleranceunits = MS_PIXELS;
-  layer->tolerance = -1; /* perhaps this should have a different value based on type */
+  layer->tolerance =
+      -1; /* perhaps this should have a different value based on type */
 
   layer->symbolscaledenom = -1.0; /* -1 means nothing is set */
   layer->scalefactor = 1.0;
@@ -3520,7 +3841,7 @@ int initLayer(layerObj *layer, mapObj *m
   layer->sizeunits = MS_PIXELS;
 
   layer->maxfeatures = -1; /* no quota */
-  layer->startindex = -1; /*used for pagination*/
+  layer->startindex = -1;  /*used for pagination*/
 
   layer->scaletokens = NULL;
   layer->numscaletokens = 0;
@@ -3533,10 +3854,10 @@ int initLayer(layerObj *layer, mapObj *m
   layer->classitemindex = -1;
 
   layer->units = MS_METERS;
-  if(msInitProjection(&(layer->projection)) == -1) return(-1);
+  if (msInitProjection(&(layer->projection)) == -1)
+    return (-1);
 
-  if( map )
-  {
+  if (map) {
     msProjectionInheritContextFrom(&(layer->projection), &(map->projection));
   }
 
@@ -3546,7 +3867,7 @@ int initLayer(layerObj *layer, mapObj *m
 
   initCluster(&layer->cluster);
 
-  MS_INIT_COLOR(layer->offsite, -1,-1,-1, 255);
+  MS_INIT_COLOR(layer->offsite, -1, -1, -1, 255);
 
   layer->labelcache = MS_ON;
   layer->postlabelcache = MS_FALSE;
@@ -3581,13 +3902,15 @@ int initLayer(layerObj *layer, mapObj *m
   layer->iteminfo = NULL;
   layer->numitems = 0;
 
-  layer->resultcache= NULL;
+  layer->resultcache = NULL;
 
   msInitExpression(&(layer->filter));
   layer->filteritem = NULL;
   layer->filteritemindex = -1;
 
-  layer->requires = layer->labelrequires = NULL;
+  layer->
+    requires
+  = layer->labelrequires = NULL;
 
   initHashTable(&(layer->metadata));
   initHashTable(&(layer->bindvals));
@@ -3599,8 +3922,8 @@ int initLayer(layerObj *layer, mapObj *m
   layer->numprocessing = 0;
   layer->processing = NULL;
   layer->numjoins = 0;
-  layer->joins = (joinObj *) malloc(MS_MAXJOINS*sizeof(joinObj));
-  MS_CHECK_ALLOC(layer->joins, MS_MAXJOINS*sizeof(joinObj), -1);
+  layer->joins = (joinObj *)malloc(MS_MAXJOINS * sizeof(joinObj));
+  MS_CHECK_ALLOC(layer->joins, MS_MAXJOINS * sizeof(joinObj), -1);
 
   layer->extent.minx = -1.0;
   layer->extent.miny = -1.0;
@@ -3628,17 +3951,17 @@ int initLayer(layerObj *layer, mapObj *m
 
   initHashTable(&(layer->connectionoptions));
 
-  return(0);
+  return (0);
 }
 
-int initScaleToken(scaleTokenObj* token) {
+int initScaleToken(scaleTokenObj *token) {
   token->n_entries = 0;
   token->name = NULL;
   token->tokens = NULL;
   return MS_SUCCESS;
 }
 
-int freeScaleTokenEntry( scaleTokenEntryObj *token) {
+int freeScaleTokenEntry(scaleTokenEntryObj *token) {
   msFree(token->value);
   return MS_SUCCESS;
 }
@@ -3646,25 +3969,25 @@ int freeScaleTokenEntry( scaleTokenEntry
 int freeScaleToken(scaleTokenObj *scaletoken) {
   int i;
   msFree(scaletoken->name);
-  for(i=0;i<scaletoken->n_entries;i++) {
+  for (i = 0; i < scaletoken->n_entries; i++) {
     freeScaleTokenEntry(&scaletoken->tokens[i]);
   }
   msFree(scaletoken->tokens);
   return MS_SUCCESS;
 }
 
-int freeLayer(layerObj *layer)
-{
+int freeLayer(layerObj *layer) {
   int i;
-  if (!layer) return MS_FAILURE;
-  if( MS_REFCNT_DECR_IS_NOT_ZERO(layer) ) {
+  if (!layer)
+    return MS_FAILURE;
+  if (MS_REFCNT_DECR_IS_NOT_ZERO(layer)) {
     return MS_FAILURE;
   }
 
   if (layer->debug >= MS_DEBUGLEVEL_VVV)
-    msDebug("freeLayer(): freeing layer at %p.\n",layer);
+    msDebug("freeLayer(): freeing layer at %p.\n", layer);
 
-  if(msLayerIsOpen(layer))
+  if (msLayerIsOpen(layer))
     msLayerClose(layer);
 
   msFree(layer->name);
@@ -3693,27 +4016,27 @@ int freeLayer(layerObj *layer)
 
   freeCluster(&layer->cluster);
 
-  for(i=0; i<layer->maxclasses; i++) {
+  for (i = 0; i < layer->maxclasses; i++) {
     if (layer->class[i] != NULL) {
-      layer->class[i]->layer=NULL;
-      if ( freeClass(layer->class[i]) == MS_SUCCESS ) {
+      layer->class[i]->layer = NULL;
+      if (freeClass(layer->class[i]) == MS_SUCCESS) {
         msFree(layer->class[i]);
       }
     }
   }
   msFree(layer->class);
 
-  if(layer->numscaletokens>0) {
-    for(i=0;i<layer->numscaletokens;i++) {
+  if (layer->numscaletokens > 0) {
+    for (i = 0; i < layer->numscaletokens; i++) {
       freeScaleToken(&layer->scaletokens[i]);
     }
     msFree(layer->scaletokens);
   }
 
-  if(layer->features)
+  if (layer->features)
     freeFeatureList(layer->features);
 
-  if(layer->resultcache) {
+  if (layer->resultcache) {
     cleanupResultCache(layer->resultcache);
     msFree(layer->resultcache);
   }
@@ -3726,14 +4049,17 @@ int freeLayer(layerObj *layer)
   msFree(layer->requires);
   msFree(layer->labelrequires);
 
-  if(&(layer->metadata)) msFreeHashItems(&(layer->metadata));
-  if(&(layer->validation)) msFreeHashItems(&(layer->validation));
-  if(&(layer->bindvals))  msFreeHashItems(&layer->bindvals);
+  if (&(layer->metadata))
+    msFreeHashItems(&(layer->metadata));
+  if (&(layer->validation))
+    msFreeHashItems(&(layer->validation));
+  if (&(layer->bindvals))
+    msFreeHashItems(&layer->bindvals);
 
-  if(layer->numprocessing > 0)
+  if (layer->numprocessing > 0)
     msFreeCharArray(layer->processing, layer->numprocessing);
 
-  for(i=0; i<layer->numjoins; i++) /* each join */
+  for (i = 0; i < layer->numjoins; i++) /* each join */
     freeJoin(&(layer->joins[i]));
   msFree(layer->joins);
   layer->numjoins = 0;
@@ -3741,11 +4067,11 @@ int freeLayer(layerObj *layer)
   layer->classgroup = NULL;
 
   msFree(layer->mask);
-  if(layer->maskimage) {
+  if (layer->maskimage) {
     msFreeImage(layer->maskimage);
   }
 
-  if(layer->compositer) {
+  if (layer->compositer) {
     freeLayerCompositer(layer->compositer);
   }
 
@@ -3757,11 +4083,12 @@ int freeLayer(layerObj *layer)
   msFreeExpression(&(layer->utfdata));
   msFree(layer->utfitem);
 
-  for(i=0;i<layer->sortBy.nProperties;i++)
-      msFree(layer->sortBy.properties[i].item);
+  for (i = 0; i < layer->sortBy.nProperties; i++)
+    msFree(layer->sortBy.properties[i].item);
   msFree(layer->sortBy.properties);
 
-  if(&(layer->connectionoptions))  msFreeHashItems(&layer->connectionoptions);
+  if (&(layer->connectionoptions))
+    msFreeHashItems(&layer->connectionoptions);
 
   return MS_SUCCESS;
 }
@@ -3778,8 +4105,7 @@ int freeLayer(layerObj *layer)
 **
 ** Returns a reference to the new classObj on success, NULL on error.
 */
-classObj *msGrowLayerClasses( layerObj *layer )
-{
+classObj *msGrowLayerClasses(layerObj *layer) {
   /* Do we need to increase the size of class[] by  MS_CLASS_ALLOCSIZE?
    */
   if (layer->numclasses == layer->maxclasses) {
@@ -3789,542 +4115,657 @@ classObj *msGrowLayerClasses( layerObj *
     newsize = layer->maxclasses + MS_CLASS_ALLOCSIZE;
 
     /* Alloc/realloc classes */
-    newClassPtr = (classObj**)realloc(layer->class,
-                                      newsize*sizeof(classObj*));
-    MS_CHECK_ALLOC(newClassPtr, newsize*sizeof(classObj*), NULL);
+    newClassPtr =
+        (classObj **)realloc(layer->class, newsize * sizeof(classObj *));
+    MS_CHECK_ALLOC(newClassPtr, newsize * sizeof(classObj *), NULL);
 
     layer->class = newClassPtr;
     layer->maxclasses = newsize;
-    for(i=layer->numclasses; i<layer->maxclasses; i++) {
+    for (i = layer->numclasses; i < layer->maxclasses; i++) {
       layer->class[i] = NULL;
     }
   }
 
-  if (layer->class[layer->numclasses]==NULL) {
-    layer->class[layer->numclasses]=(classObj*)calloc(1,sizeof(classObj));
+  if (layer->class[layer->numclasses] == NULL) {
+    layer->class[layer->numclasses] = (classObj *)calloc(1, sizeof(classObj));
     MS_CHECK_ALLOC(layer->class[layer->numclasses], sizeof(classObj), NULL);
   }
 
   return layer->class[layer->numclasses];
 }
 
-scaleTokenObj *msGrowLayerScaletokens( layerObj *layer )
-{
-  layer->scaletokens = msSmallRealloc(layer->scaletokens,(layer->numscaletokens+1)*sizeof(scaleTokenObj));
-  memset(&layer->scaletokens[layer->numscaletokens],0,sizeof(scaleTokenObj));
+scaleTokenObj *msGrowLayerScaletokens(layerObj *layer) {
+  layer->scaletokens = msSmallRealloc(
+      layer->scaletokens, (layer->numscaletokens + 1) * sizeof(scaleTokenObj));
+  memset(&layer->scaletokens[layer->numscaletokens], 0, sizeof(scaleTokenObj));
   return &layer->scaletokens[layer->numscaletokens];
 }
 
 int loadScaletoken(scaleTokenObj *token, layerObj *layer) {
   (void)layer;
-  for(;;) {
+  for (;;) {
     int stop = 0;
-    switch(msyylex()) {
-      case(EOF):
-        msSetError(MS_EOFERR, NULL, "loadScaletoken()");
-        return(MS_FAILURE);
-      case(NAME):
-        if(getString(&token->name) == MS_FAILURE) return(MS_FAILURE);
-        break;
-      case(VALUES):
-         for(;;) {
-           if(stop) break;
-           switch(msyylex()) {
-             case(EOF):
-               msSetError(MS_EOFERR, NULL, "loadScaletoken()");
-               return(MS_FAILURE);
-             case(END):
-               stop = 1;
-               if(token->n_entries == 0) {
-                 msSetError(MS_PARSEERR,"Scaletoken (line:%d) has no VALUES defined","loadScaleToken()",msyylineno);
-                 return(MS_FAILURE);
-               }
-               token->tokens[token->n_entries-1].maxscale = DBL_MAX;
-               break;
-             case(MS_STRING):
-               /* we have a key */
-               token->tokens = msSmallRealloc(token->tokens,(token->n_entries+1)*sizeof(scaleTokenEntryObj));
-
-               if(1 != sscanf(msyystring_buffer,"%lf",&token->tokens[token->n_entries].minscale)) {
-                 msSetError(MS_PARSEERR, "failed to parse SCALETOKEN VALUE (%s):(line %d), expecting \"minscale\"", "loadScaletoken()",
-                         msyystring_buffer,msyylineno);
-                 return(MS_FAILURE);
-               }
-               if(token->n_entries == 0) {
-                 /* check supplied value was 0*/
-                 if(token->tokens[0].minscale != 0) {
-                  msSetError(MS_PARSEERR, "First SCALETOKEN VALUE (%s):(line %d) must be zero, expecting \"0\"", "loadScaletoken()",
-                         msyystring_buffer,msyylineno);
-                  return(MS_FAILURE);
-                 }
-               } else {
-                 /* set max scale of previous token */
-                 token->tokens[token->n_entries-1].maxscale = token->tokens[token->n_entries].minscale;
-               }
-               token->tokens[token->n_entries].value = NULL;
-               if(getString(&(token->tokens[token->n_entries].value)) == MS_FAILURE) return(MS_FAILURE);
-               token->n_entries++;
-               break;
-             default:
-               msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)", "loadScaletoken()",  msyystring_buffer, msyylineno );
-               return(MS_FAILURE);
-           }
-         }
-         break;
-      case(END):
-        if(!token->name || !*(token->name)) {
-          msSetError(MS_PARSEERR,"ScaleToken missing mandatory NAME entry (line %d)","loadScaleToken()",msyylineno);
-          return MS_FAILURE;
-        }
-        if(token->n_entries == 0) {
-          msSetError(MS_PARSEERR,"ScaleToken missing at least one VALUES entry (line %d)","loadScaleToken()",msyylineno);
-          return MS_FAILURE;
+    switch (msyylex()) {
+    case (EOF):
+      msSetError(MS_EOFERR, NULL, "loadScaletoken()");
+      return (MS_FAILURE);
+    case (NAME):
+      if (getString(&token->name) == MS_FAILURE)
+        return (MS_FAILURE);
+      break;
+    case (VALUES):
+      for (;;) {
+        if (stop)
+          break;
+        switch (msyylex()) {
+        case (EOF):
+          msSetError(MS_EOFERR, NULL, "loadScaletoken()");
+          return (MS_FAILURE);
+        case (END):
+          stop = 1;
+          if (token->n_entries == 0) {
+            msSetError(MS_PARSEERR,
+                       "Scaletoken (line:%d) has no VALUES defined",
+                       "loadScaleToken()", msyylineno);
+            return (MS_FAILURE);
+          }
+          token->tokens[token->n_entries - 1].maxscale = DBL_MAX;
+          break;
+        case (MS_STRING):
+          /* we have a key */
+          token->tokens =
+              msSmallRealloc(token->tokens, (token->n_entries + 1) *
+                                                sizeof(scaleTokenEntryObj));
+
+          if (1 != sscanf(msyystring_buffer, "%lf",
+                          &token->tokens[token->n_entries].minscale)) {
+            msSetError(MS_PARSEERR,
+                       "failed to parse SCALETOKEN VALUE (%s):(line %d), "
+                       "expecting \"minscale\"",
+                       "loadScaletoken()", msyystring_buffer, msyylineno);
+            return (MS_FAILURE);
+          }
+          if (token->n_entries == 0) {
+            /* check supplied value was 0*/
+            if (token->tokens[0].minscale != 0) {
+              msSetError(MS_PARSEERR,
+                         "First SCALETOKEN VALUE (%s):(line %d) must be zero, "
+                         "expecting \"0\"",
+                         "loadScaletoken()", msyystring_buffer, msyylineno);
+              return (MS_FAILURE);
+            }
+          } else {
+            /* set max scale of previous token */
+            token->tokens[token->n_entries - 1].maxscale =
+                token->tokens[token->n_entries].minscale;
+          }
+          token->tokens[token->n_entries].value = NULL;
+          if (getString(&(token->tokens[token->n_entries].value)) == MS_FAILURE)
+            return (MS_FAILURE);
+          token->n_entries++;
+          break;
+        default:
+          msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)",
+                     "loadScaletoken()", msyystring_buffer, msyylineno);
+          return (MS_FAILURE);
         }
-        return MS_SUCCESS;
-      default:
-        msSetError(MS_IDENTERR, "Parsing error 2 near (%s):(line %d)", "loadScaletoken()",  msyystring_buffer, msyylineno );
-        return(MS_FAILURE);
+      }
+      break;
+    case (END):
+      if (!token->name || !*(token->name)) {
+        msSetError(MS_PARSEERR,
+                   "ScaleToken missing mandatory NAME entry (line %d)",
+                   "loadScaleToken()", msyylineno);
+        return MS_FAILURE;
+      }
+      if (token->n_entries == 0) {
+        msSetError(MS_PARSEERR,
+                   "ScaleToken missing at least one VALUES entry (line %d)",
+                   "loadScaleToken()", msyylineno);
+        return MS_FAILURE;
+      }
+      return MS_SUCCESS;
+    default:
+      msSetError(MS_IDENTERR, "Parsing error 2 near (%s):(line %d)",
+                 "loadScaletoken()", msyystring_buffer, msyylineno);
+      return (MS_FAILURE);
     }
   } /* next token*/
 }
 
 int loadLayerCompositer(LayerCompositer *compositer) {
-  for(;;) {
-    switch(msyylex()) {
-      case COMPFILTER: {
-        CompositingFilter **filter = &compositer->filter;
-        while(*filter) {
-          filter = &((*filter)->next);
-        }
-        *filter = msSmallMalloc(sizeof(CompositingFilter));
-        initCompositingFilter(*filter);
-        if(getString(&((*filter)->filter)) == MS_FAILURE) return(MS_FAILURE);
+  for (;;) {
+    switch (msyylex()) {
+    case COMPFILTER: {
+      CompositingFilter **filter = &compositer->filter;
+      while (*filter) {
+        filter = &((*filter)->next);
       }
-        break;
-      case COMPOP: {
-        char *compop=NULL;
-        if(getString(&compop) == MS_FAILURE) return(MS_FAILURE);
-        else if(!strcmp(compop,"clear"))
-          compositer->comp_op = MS_COMPOP_CLEAR;
-        else if(!strcmp(compop,"color-burn"))
-          compositer->comp_op = MS_COMPOP_COLOR_BURN;
-        else if(!strcmp(compop,"color-dodge"))
-          compositer->comp_op = MS_COMPOP_COLOR_DODGE;
-        else if(!strcmp(compop,"contrast"))
-          compositer->comp_op = MS_COMPOP_CONTRAST;
-        else if(!strcmp(compop,"darken"))
-          compositer->comp_op = MS_COMPOP_DARKEN;
-        else if(!strcmp(compop,"difference"))
-          compositer->comp_op = MS_COMPOP_DIFFERENCE;
-        else if(!strcmp(compop,"dst"))
-          compositer->comp_op = MS_COMPOP_DST;
-        else if(!strcmp(compop,"dst-atop"))
-          compositer->comp_op = MS_COMPOP_DST_ATOP;
-        else if(!strcmp(compop,"dst-in"))
-          compositer->comp_op = MS_COMPOP_DST_IN;
-        else if(!strcmp(compop,"dst-out"))
-          compositer->comp_op = MS_COMPOP_DST_OUT;
-        else if(!strcmp(compop,"dst-over"))
-          compositer->comp_op = MS_COMPOP_DST_OVER;
-        else if(!strcmp(compop,"exclusion"))
-          compositer->comp_op = MS_COMPOP_EXCLUSION;
-        else if(!strcmp(compop,"hard-light"))
-          compositer->comp_op = MS_COMPOP_HARD_LIGHT;
-        else if(!strcmp(compop,"invert"))
-          compositer->comp_op = MS_COMPOP_INVERT;
-        else if(!strcmp(compop,"invert-rgb"))
-          compositer->comp_op = MS_COMPOP_INVERT_RGB;
-        else if(!strcmp(compop,"lighten"))
-          compositer->comp_op = MS_COMPOP_LIGHTEN;
-        else if(!strcmp(compop,"minus"))
-          compositer->comp_op = MS_COMPOP_MINUS;
-        else if(!strcmp(compop,"multiply"))
-          compositer->comp_op = MS_COMPOP_MULTIPLY;
-        else if(!strcmp(compop,"overlay"))
-          compositer->comp_op = MS_COMPOP_OVERLAY;
-        else if(!strcmp(compop,"plus"))
-          compositer->comp_op = MS_COMPOP_PLUS;
-        else if(!strcmp(compop,"screen"))
-          compositer->comp_op = MS_COMPOP_SCREEN;
-        else if(!strcmp(compop,"soft-light"))
-          compositer->comp_op = MS_COMPOP_SOFT_LIGHT;
-        else if(!strcmp(compop,"src"))
-          compositer->comp_op = MS_COMPOP_SRC;
-        else if(!strcmp(compop,"src-atop"))
-          compositer->comp_op = MS_COMPOP_SRC_ATOP;
-        else if(!strcmp(compop,"src-in"))
-          compositer->comp_op = MS_COMPOP_SRC_IN;
-        else if(!strcmp(compop,"src-out"))
-          compositer->comp_op = MS_COMPOP_SRC_OUT;
-        else if(!strcmp(compop,"src-over"))
-          compositer->comp_op = MS_COMPOP_SRC_OVER;
-        else if(!strcmp(compop,"xor"))
-          compositer->comp_op = MS_COMPOP_XOR;
-        else {
-          msSetError(MS_PARSEERR,"Unknown COMPOP \"%s\"", "loadLayerCompositer()", compop);
-          free(compop);
-          return MS_FAILURE;
-        }
+      *filter = msSmallMalloc(sizeof(CompositingFilter));
+      initCompositingFilter(*filter);
+      if (getString(&((*filter)->filter)) == MS_FAILURE)
+        return (MS_FAILURE);
+    } break;
+    case COMPOP: {
+      char *compop = NULL;
+      if (getString(&compop) == MS_FAILURE)
+        return (MS_FAILURE);
+      else if (!strcmp(compop, "clear"))
+        compositer->comp_op = MS_COMPOP_CLEAR;
+      else if (!strcmp(compop, "color-burn"))
+        compositer->comp_op = MS_COMPOP_COLOR_BURN;
+      else if (!strcmp(compop, "color-dodge"))
+        compositer->comp_op = MS_COMPOP_COLOR_DODGE;
+      else if (!strcmp(compop, "contrast"))
+        compositer->comp_op = MS_COMPOP_CONTRAST;
+      else if (!strcmp(compop, "darken"))
+        compositer->comp_op = MS_COMPOP_DARKEN;
+      else if (!strcmp(compop, "difference"))
+        compositer->comp_op = MS_COMPOP_DIFFERENCE;
+      else if (!strcmp(compop, "dst"))
+        compositer->comp_op = MS_COMPOP_DST;
+      else if (!strcmp(compop, "dst-atop"))
+        compositer->comp_op = MS_COMPOP_DST_ATOP;
+      else if (!strcmp(compop, "dst-in"))
+        compositer->comp_op = MS_COMPOP_DST_IN;
+      else if (!strcmp(compop, "dst-out"))
+        compositer->comp_op = MS_COMPOP_DST_OUT;
+      else if (!strcmp(compop, "dst-over"))
+        compositer->comp_op = MS_COMPOP_DST_OVER;
+      else if (!strcmp(compop, "exclusion"))
+        compositer->comp_op = MS_COMPOP_EXCLUSION;
+      else if (!strcmp(compop, "hard-light"))
+        compositer->comp_op = MS_COMPOP_HARD_LIGHT;
+      else if (!strcmp(compop, "invert"))
+        compositer->comp_op = MS_COMPOP_INVERT;
+      else if (!strcmp(compop, "invert-rgb"))
+        compositer->comp_op = MS_COMPOP_INVERT_RGB;
+      else if (!strcmp(compop, "lighten"))
+        compositer->comp_op = MS_COMPOP_LIGHTEN;
+      else if (!strcmp(compop, "minus"))
+        compositer->comp_op = MS_COMPOP_MINUS;
+      else if (!strcmp(compop, "multiply"))
+        compositer->comp_op = MS_COMPOP_MULTIPLY;
+      else if (!strcmp(compop, "overlay"))
+        compositer->comp_op = MS_COMPOP_OVERLAY;
+      else if (!strcmp(compop, "plus"))
+        compositer->comp_op = MS_COMPOP_PLUS;
+      else if (!strcmp(compop, "screen"))
+        compositer->comp_op = MS_COMPOP_SCREEN;
+      else if (!strcmp(compop, "soft-light"))
+        compositer->comp_op = MS_COMPOP_SOFT_LIGHT;
+      else if (!strcmp(compop, "src"))
+        compositer->comp_op = MS_COMPOP_SRC;
+      else if (!strcmp(compop, "src-atop"))
+        compositer->comp_op = MS_COMPOP_SRC_ATOP;
+      else if (!strcmp(compop, "src-in"))
+        compositer->comp_op = MS_COMPOP_SRC_IN;
+      else if (!strcmp(compop, "src-out"))
+        compositer->comp_op = MS_COMPOP_SRC_OUT;
+      else if (!strcmp(compop, "src-over"))
+        compositer->comp_op = MS_COMPOP_SRC_OVER;
+      else if (!strcmp(compop, "xor"))
+        compositer->comp_op = MS_COMPOP_XOR;
+      else {
+        msSetError(MS_PARSEERR, "Unknown COMPOP \"%s\"",
+                   "loadLayerCompositer()", compop);
         free(compop);
+        return MS_FAILURE;
       }
-        break;
-      case END:
-        return MS_SUCCESS;
-      case OPACITY:
-        if (getInteger(&(compositer->opacity), MS_NUM_CHECK_RANGE, 0, 100) == -1) {
-          msSetError(MS_PARSEERR,"OPACITY must be between 0 and 100 (line %d)","loadLayerCompositer()",msyylineno);
-          return MS_FAILURE;
-        }
-        break;
-      default:
-        msSetError(MS_IDENTERR, "Parsing error 2 near (%s):(line %d)", "loadLayerCompositer()",  msyystring_buffer, msyylineno );
-        return(MS_FAILURE);
+      free(compop);
+    } break;
+    case END:
+      return MS_SUCCESS;
+    case OPACITY:
+      if (getInteger(&(compositer->opacity), MS_NUM_CHECK_RANGE, 0, 100) ==
+          -1) {
+        msSetError(MS_PARSEERR, "OPACITY must be between 0 and 100 (line %d)",
+                   "loadLayerCompositer()", msyylineno);
+        return MS_FAILURE;
+      }
+      break;
+    default:
+      msSetError(MS_IDENTERR, "Parsing error 2 near (%s):(line %d)",
+                 "loadLayerCompositer()", msyystring_buffer, msyylineno);
+      return (MS_FAILURE);
     }
   }
 }
-int loadLayer(layerObj *layer, mapObj *map)
-{
+int loadLayer(layerObj *layer, mapObj *map) {
   int type;
 
   layer->map = (mapObj *)map;
 
-  for(;;) {
-    switch(msyylex()) {
-      case(BINDVALS):
-        if(loadHashTable(&(layer->bindvals)) != MS_SUCCESS) return(-1);
-        break;
-      case(CLASS):
-        if (msGrowLayerClasses(layer) == NULL)
-          return(-1);
-        initClass(layer->class[layer->numclasses]);
-        if(loadClass(layer->class[layer->numclasses], layer) == -1)
-        {
-            freeClass(layer->class[layer->numclasses]);
-            free(layer->class[layer->numclasses]);
-            layer->class[layer->numclasses] = NULL;
-            return(-1);
-        }
-        layer->numclasses++;
-        break;
-      case(CLUSTER):
-        if(loadCluster(&layer->cluster) == -1) return(-1);
-        break;
-      case(CLASSGROUP):
-        if(getString(&layer->classgroup) == MS_FAILURE) return(-1); /* getString() cleans up previously allocated string */
-        break;
-      case(CLASSITEM):
-        if(getString(&layer->classitem) == MS_FAILURE) return(-1); /* getString() cleans up previously allocated string */
-        break;
-      case(COMPOSITE): {
-        LayerCompositer *compositer = msSmallMalloc(sizeof(LayerCompositer));
-        initLayerCompositer(compositer);
-        if(MS_FAILURE == loadLayerCompositer(compositer)) {
-          freeLayerCompositer(compositer);
-          return -1;
-          }
-        if(!layer->compositer) {
-          layer->compositer = compositer;
-        } else {
-          LayerCompositer *lctmp = layer->compositer;
-          while(lctmp->next) lctmp = lctmp->next;
-          lctmp->next = compositer;
-        }
-        break;
+  for (;;) {
+    switch (msyylex()) {
+    case (BINDVALS):
+      if (loadHashTable(&(layer->bindvals)) != MS_SUCCESS)
+        return (-1);
+      break;
+    case (CLASS):
+      if (msGrowLayerClasses(layer) == NULL)
+        return (-1);
+      initClass(layer->class[layer->numclasses]);
+      if (loadClass(layer->class[layer->numclasses], layer) == -1) {
+        freeClass(layer->class[layer->numclasses]);
+        free(layer->class[layer->numclasses]);
+        layer->class[layer->numclasses] = NULL;
+        return (-1);
       }
-      case(CONNECTION):
-        if(getString(&layer->connection) == MS_FAILURE) return(-1); /* getString() cleans up previously allocated string */
-        break;
-      case(CONNECTIONTYPE):
-        if((type = getSymbol(13, MS_OGR, MS_POSTGIS, MS_WMS, MS_ORACLESPATIAL, MS_WFS, MS_GRATICULE, MS_PLUGIN, MS_UNION, MS_UVRASTER, MS_CONTOUR, MS_KERNELDENSITY, MS_IDW, MS_FLATGEOBUF)) == -1) return(-1);
-        layer->connectiontype = type;
-        break;
-      case(DATA):
-        if(getString(&layer->data) == MS_FAILURE) return(-1); /* getString() cleans up previously allocated string */
-        break;
-      case(DEBUG):
-        if((layer->debug = getSymbol(3, MS_ON,MS_OFF, MS_NUMBER)) == -1) return(-1);
-	if(layer->debug == MS_NUMBER) {
-          if(msCheckNumber(msyynumber, MS_NUM_CHECK_RANGE, 0, 5) == MS_FAILURE) {
-            msSetError(MS_MISCERR, "Invalid DEBUG level, must be between 0 and 5 (line %d)", "loadLayer()", msyylineno);
-            return(-1);
-          }
-          layer->debug = (int) msyynumber;
-        }
-        break;
-      case(EOF):
-        msSetError(MS_EOFERR, NULL, "loadLayer()");
-        return(-1);
-        break;
-      case(ENCODING):
-        if(getString(&layer->encoding) == MS_FAILURE) return(-1);
-        break;
-      case(END):
-        if((int)layer->type == -1) {
-          msSetError(MS_MISCERR, "Layer type not set.", "loadLayer()");
-          return(-1);
+      layer->numclasses++;
+      break;
+    case (CLUSTER):
+      if (loadCluster(&layer->cluster) == -1)
+        return (-1);
+      break;
+    case (CLASSGROUP):
+      if (getString(&layer->classgroup) == MS_FAILURE)
+        return (-1); /* getString() cleans up previously allocated string */
+      break;
+    case (CLASSITEM):
+      if (getString(&layer->classitem) == MS_FAILURE)
+        return (-1); /* getString() cleans up previously allocated string */
+      break;
+    case (COMPOSITE): {
+      LayerCompositer *compositer = msSmallMalloc(sizeof(LayerCompositer));
+      initLayerCompositer(compositer);
+      if (MS_FAILURE == loadLayerCompositer(compositer)) {
+        freeLayerCompositer(compositer);
+        return -1;
+      }
+      if (!layer->compositer) {
+        layer->compositer = compositer;
+      } else {
+        LayerCompositer *lctmp = layer->compositer;
+        while (lctmp->next)
+          lctmp = lctmp->next;
+        lctmp->next = compositer;
+      }
+      break;
+    }
+    case (CONNECTION):
+      if (getString(&layer->connection) == MS_FAILURE)
+        return (-1); /* getString() cleans up previously allocated string */
+      break;
+    case (CONNECTIONTYPE):
+      if ((type = getSymbol(13, MS_OGR, MS_POSTGIS, MS_WMS, MS_ORACLESPATIAL,
+                            MS_WFS, MS_GRATICULE, MS_PLUGIN, MS_UNION,
+                            MS_UVRASTER, MS_CONTOUR, MS_KERNELDENSITY, MS_IDW,
+                            MS_FLATGEOBUF)) == -1)
+        return (-1);
+      layer->connectiontype = type;
+      break;
+    case (DATA):
+      if (getString(&layer->data) == MS_FAILURE)
+        return (-1); /* getString() cleans up previously allocated string */
+      break;
+    case (DEBUG):
+      if ((layer->debug = getSymbol(3, MS_ON, MS_OFF, MS_NUMBER)) == -1)
+        return (-1);
+      if (layer->debug == MS_NUMBER) {
+        if (msCheckNumber(msyynumber, MS_NUM_CHECK_RANGE, 0, 5) == MS_FAILURE) {
+          msSetError(MS_MISCERR,
+                     "Invalid DEBUG level, must be between 0 and 5 (line %d)",
+                     "loadLayer()", msyylineno);
+          return (-1);
         }
+        layer->debug = (int)msyynumber;
+      }
+      break;
+    case (EOF):
+      msSetError(MS_EOFERR, NULL, "loadLayer()");
+      return (-1);
+      break;
+    case (ENCODING):
+      if (getString(&layer->encoding) == MS_FAILURE)
+        return (-1);
+      break;
+    case (END):
+      if ((int)layer->type == -1) {
+        msSetError(MS_MISCERR, "Layer type not set.", "loadLayer()");
+        return (-1);
+      }
 
-        return(0);
-        break;
-      case(EXTENT): {
-        if(getDouble(&(layer->extent.minx), MS_NUM_CHECK_NONE, -1, -1) == -1) return(-1);
-        if(getDouble(&(layer->extent.miny), MS_NUM_CHECK_NONE, -1, -1) == -1) return(-1);
-        if(getDouble(&(layer->extent.maxx), MS_NUM_CHECK_NONE, -1, -1) == -1) return(-1);
-        if(getDouble(&(layer->extent.maxy), MS_NUM_CHECK_NONE, -1, -1) == -1) return(-1);
-        if (!MS_VALID_EXTENT(layer->extent)) {
-          msSetError(MS_MISCERR, "Given layer extent is invalid. Check that it is in the form: minx, miny, maxx, maxy", "loadLayer()");
-          return(-1);
-        }
-        break;
+      return (0);
+      break;
+    case (EXTENT): {
+      if (getDouble(&(layer->extent.minx), MS_NUM_CHECK_NONE, -1, -1) == -1)
+        return (-1);
+      if (getDouble(&(layer->extent.miny), MS_NUM_CHECK_NONE, -1, -1) == -1)
+        return (-1);
+      if (getDouble(&(layer->extent.maxx), MS_NUM_CHECK_NONE, -1, -1) == -1)
+        return (-1);
+      if (getDouble(&(layer->extent.maxy), MS_NUM_CHECK_NONE, -1, -1) == -1)
+        return (-1);
+      if (!MS_VALID_EXTENT(layer->extent)) {
+        msSetError(MS_MISCERR,
+                   "Given layer extent is invalid. Check that it is in the "
+                   "form: minx, miny, maxx, maxy",
+                   "loadLayer()");
+        return (-1);
+      }
+      break;
+    }
+    case (FEATURE):
+      if ((int)layer->type == -1) {
+        msSetError(MS_MISCERR,
+                   "Layer type must be set before defining inline features.",
+                   "loadLayer()");
+        return (-1);
       }
-      case(FEATURE):
-        if((int)layer->type == -1) {
-          msSetError(MS_MISCERR, "Layer type must be set before defining inline features.", "loadLayer()");
-          return(-1);
-        }
 
-        if(layer->type == MS_LAYER_POLYGON)
-          type = MS_SHAPE_POLYGON;
-        else if(layer->type == MS_LAYER_LINE)
-          type = MS_SHAPE_LINE;
-        else
-          type = MS_SHAPE_POINT;
+      if (layer->type == MS_LAYER_POLYGON)
+        type = MS_SHAPE_POLYGON;
+      else if (layer->type == MS_LAYER_LINE)
+        type = MS_SHAPE_LINE;
+      else
+        type = MS_SHAPE_POINT;
 
-        layer->connectiontype = MS_INLINE;
+      layer->connectiontype = MS_INLINE;
 
-        if(loadFeature(layer, type) == MS_FAILURE) return(-1);
-        break;
-      case(FILTER):
-        if(loadExpression(&(layer->filter)) == -1) return(-1); /* loadExpression() cleans up previously allocated expression */
-        break;
-      case(FILTERITEM):
-        if(getString(&layer->filteritem) == MS_FAILURE) return(-1); /* getString() cleans up previously allocated string */
-        break;
-      case(FOOTER):
-        if(getString(&layer->footer) == MS_FAILURE) return(-1); /* getString() cleans up previously allocated string */
-        break;
-      case(GRID):
-        layer->connectiontype = MS_GRATICULE;
-        if (layer->grid) {
-          freeGrid(layer->grid);
-          msFree(layer->grid);
-        }
-        layer->grid = (void *) malloc(sizeof(graticuleObj));
-        MS_CHECK_ALLOC(layer->grid, sizeof(graticuleObj), -1);
-
-        initGrid(layer->grid);
-        loadGrid(layer);
-        break;
-      case(GROUP):
-        if(getString(&layer->group) == MS_FAILURE) return(-1); /* getString() cleans up previously allocated string */
-        break;
-      case(GEOMTRANSFORM): {
-        int s;
-        if((s = getSymbol(1, MS_EXPRESSION)) == -1) return(MS_FAILURE);
-        /* handle expression case here for the moment */
-        msFree(layer->_geomtransform.string);
-        layer->_geomtransform.string = msStrdup(msyystring_buffer);
-        layer->_geomtransform.type = MS_GEOMTRANSFORM_EXPRESSION;
+      if (loadFeature(layer, type) == MS_FAILURE)
+        return (-1);
+      break;
+    case (FILTER):
+      if (loadExpression(&(layer->filter)) == -1)
+        return (-1); /* loadExpression() cleans up previously allocated
+                        expression */
+      break;
+    case (FILTERITEM):
+      if (getString(&layer->filteritem) == MS_FAILURE)
+        return (-1); /* getString() cleans up previously allocated string */
+      break;
+    case (FOOTER):
+      if (getString(&layer->footer) == MS_FAILURE)
+        return (-1); /* getString() cleans up previously allocated string */
+      break;
+    case (GRID):
+      layer->connectiontype = MS_GRATICULE;
+      if (layer->grid) {
+        freeGrid(layer->grid);
+        msFree(layer->grid);
       }
+      layer->grid = (void *)malloc(sizeof(graticuleObj));
+      MS_CHECK_ALLOC(layer->grid, sizeof(graticuleObj), -1);
+
+      initGrid(layer->grid);
+      loadGrid(layer);
       break;
-      case(HEADER):
-        if(getString(&layer->header) == MS_FAILURE) return(-1); /* getString() cleans up previously allocated string */
-        break;
-      case(JOIN):
-        if(layer->numjoins == MS_MAXJOINS) { /* no room */
-          msSetError(MS_IDENTERR, "Maximum number of joins reached.", "loadLayer()");
-          return(-1);
-        }
+    case (GROUP):
+      if (getString(&layer->group) == MS_FAILURE)
+        return (-1); /* getString() cleans up previously allocated string */
+      break;
+    case (GEOMTRANSFORM): {
+      int s;
+      if ((s = getSymbol(1, MS_EXPRESSION)) == -1)
+        return (MS_FAILURE);
+      /* handle expression case here for the moment */
+      msFree(layer->_geomtransform.string);
+      layer->_geomtransform.string = msStrdup(msyystring_buffer);
+      layer->_geomtransform.type = MS_GEOMTRANSFORM_EXPRESSION;
+    } break;
+    case (HEADER):
+      if (getString(&layer->header) == MS_FAILURE)
+        return (-1); /* getString() cleans up previously allocated string */
+      break;
+    case (JOIN):
+      if (layer->numjoins == MS_MAXJOINS) { /* no room */
+        msSetError(MS_IDENTERR, "Maximum number of joins reached.",
+                   "loadLayer()");
+        return (-1);
+      }
 
-        if(loadJoin(&(layer->joins[layer->numjoins])) == -1) {
-            freeJoin(&(layer->joins[layer->numjoins]));
-            return(-1);
-        }
-        layer->numjoins++;
-        break;
-      case(LABELCACHE):
-        if((layer->labelcache = getSymbol(2, MS_ON, MS_OFF)) == -1) return(-1);
-        break;
-      case(LABELITEM):
-        if(getString(&layer->labelitem) == MS_FAILURE) return(-1); /* getString() cleans up previously allocated string */
-        break;
-      case(LABELMAXSCALE):
-      case(LABELMAXSCALEDENOM):
-        if(getDouble(&(layer->labelmaxscaledenom), MS_NUM_CHECK_GTE, 0, -1) == -1) return(-1);
-        break;
-      case(LABELMINSCALE):
-      case(LABELMINSCALEDENOM):
-        if(getDouble(&(layer->labelminscaledenom), MS_NUM_CHECK_GTE, 0, -1) == -1) return(-1);
-        break;
-      case(LABELREQUIRES):
-        if(getString(&layer->labelrequires) == MS_FAILURE) return(-1); /* getString() cleans up previously allocated string */
-        break;
-      case(LAYER):
-        break; /* for string loads */
-      case(MASK):
-        if(getString(&layer->mask) == MS_FAILURE) return(-1); /* getString() cleans up previously allocated string */
-        break;
-      case(MAXFEATURES):
-        if(getInteger(&(layer->maxfeatures), MS_NUM_CHECK_GT, 0, -1) == -1) return(-1);
-        break;
-      case(MAXSCALE):
-      case(MAXSCALEDENOM):
-        if(getDouble(&(layer->maxscaledenom), MS_NUM_CHECK_GTE, 0, -1) == -1) return(-1);
-        break;
-      case(MAXGEOWIDTH):
-        if(getDouble(&(layer->maxgeowidth), MS_NUM_CHECK_GT, 0, -1) == -1) return(-1);
-        break;
-      case(METADATA):
-        if(loadHashTable(&(layer->metadata)) != MS_SUCCESS) return(-1);
-        break;
-      case(MINSCALE):
-      case(MINSCALEDENOM):
-        if(getDouble(&(layer->minscaledenom), MS_NUM_CHECK_GTE, 0, -1) == -1) return(-1);
-        break;
-      case(MINGEOWIDTH):
-        if(getDouble(&(layer->mingeowidth), MS_NUM_CHECK_GT, 0, -1) == -1) return(-1);
-        break;
-      case(MINFEATURESIZE):
-        if(getInteger(&(layer->minfeaturesize), MS_NUM_CHECK_GT, 0, -1) == -1) return(-1);
-        break;
-      case(NAME):
-        if(getString(&layer->name) == MS_FAILURE) return(-1);
-        break;
-      case(OFFSITE):
-        if(loadColor(&(layer->offsite), NULL) != MS_SUCCESS) return(-1);
-        break;
+      if (loadJoin(&(layer->joins[layer->numjoins])) == -1) {
+        freeJoin(&(layer->joins[layer->numjoins]));
+        return (-1);
+      }
+      layer->numjoins++;
+      break;
+    case (LABELCACHE):
+      if ((layer->labelcache = getSymbol(2, MS_ON, MS_OFF)) == -1)
+        return (-1);
+      break;
+    case (LABELITEM):
+      if (getString(&layer->labelitem) == MS_FAILURE)
+        return (-1); /* getString() cleans up previously allocated string */
+      break;
+    case (LABELMAXSCALE):
+    case (LABELMAXSCALEDENOM):
+      if (getDouble(&(layer->labelmaxscaledenom), MS_NUM_CHECK_GTE, 0, -1) ==
+          -1)
+        return (-1);
+      break;
+    case (LABELMINSCALE):
+    case (LABELMINSCALEDENOM):
+      if (getDouble(&(layer->labelminscaledenom), MS_NUM_CHECK_GTE, 0, -1) ==
+          -1)
+        return (-1);
+      break;
+    case (LABELREQUIRES):
+      if (getString(&layer->labelrequires) == MS_FAILURE)
+        return (-1); /* getString() cleans up previously allocated string */
+      break;
+    case (LAYER):
+      break; /* for string loads */
+    case (MASK):
+      if (getString(&layer->mask) == MS_FAILURE)
+        return (-1); /* getString() cleans up previously allocated string */
+      break;
+    case (MAXFEATURES):
+      if (getInteger(&(layer->maxfeatures), MS_NUM_CHECK_GT, 0, -1) == -1)
+        return (-1);
+      break;
+    case (MAXSCALE):
+    case (MAXSCALEDENOM):
+      if (getDouble(&(layer->maxscaledenom), MS_NUM_CHECK_GTE, 0, -1) == -1)
+        return (-1);
+      break;
+    case (MAXGEOWIDTH):
+      if (getDouble(&(layer->maxgeowidth), MS_NUM_CHECK_GT, 0, -1) == -1)
+        return (-1);
+      break;
+    case (METADATA):
+      if (loadHashTable(&(layer->metadata)) != MS_SUCCESS)
+        return (-1);
+      break;
+    case (MINSCALE):
+    case (MINSCALEDENOM):
+      if (getDouble(&(layer->minscaledenom), MS_NUM_CHECK_GTE, 0, -1) == -1)
+        return (-1);
+      break;
+    case (MINGEOWIDTH):
+      if (getDouble(&(layer->mingeowidth), MS_NUM_CHECK_GT, 0, -1) == -1)
+        return (-1);
+      break;
+    case (MINFEATURESIZE):
+      if (getInteger(&(layer->minfeaturesize), MS_NUM_CHECK_GT, 0, -1) == -1)
+        return (-1);
+      break;
+    case (NAME):
+      if (getString(&layer->name) == MS_FAILURE)
+        return (-1);
+      break;
+    case (OFFSITE):
+      if (loadColor(&(layer->offsite), NULL) != MS_SUCCESS)
+        return (-1);
+      break;
 
-      case(CONNECTIONOPTIONS):
-        if(loadHashTable(&(layer->connectionoptions)) != MS_SUCCESS) return(-1);
-        break;
-      case(MS_PLUGIN): {
-        int rv;
-        if(map->config) { // value *must* represent a config key
-          char *value = NULL;
-          const char *plugin_library = NULL;
-
-          if(getString(&value) == MS_FAILURE) return(-1);
-          plugin_library = msConfigGetPlugin(map->config, value);
-          msFree(value);
-          if(!plugin_library) {
-            msSetError(MS_MISCERR, "Plugin value not found in config file. See mapserver.org/mapfile/config.html for more information." , "loadLayer()");
-            return(-1);
-          }
-          msFree(layer->plugin_library_original);
-          layer->plugin_library_original = strdup(plugin_library);
-        } else {
-          if(getString(&layer->plugin_library_original) == MS_FAILURE) return(-1);
+    case (CONNECTIONOPTIONS):
+      if (loadHashTable(&(layer->connectionoptions)) != MS_SUCCESS)
+        return (-1);
+      break;
+    case (MS_PLUGIN): {
+      int rv;
+      if (map->config) { // value *must* represent a config key
+        char *value = NULL;
+        const char *plugin_library = NULL;
+
+        if (getString(&value) == MS_FAILURE)
+          return (-1);
+        plugin_library = msConfigGetPlugin(map->config, value);
+        msFree(value);
+        if (!plugin_library) {
+          msSetError(MS_MISCERR,
+                     "Plugin value not found in config file. See "
+                     "mapserver.org/mapfile/config.html for more information.",
+                     "loadLayer()");
+          return (-1);
         }
-        rv = msBuildPluginLibraryPath(&layer->plugin_library, layer->plugin_library_original, map);
-        if (rv == MS_FAILURE) return(-1);
+        msFree(layer->plugin_library_original);
+        layer->plugin_library_original = strdup(plugin_library);
+      } else {
+        if (getString(&layer->plugin_library_original) == MS_FAILURE)
+          return (-1);
       }
+      rv = msBuildPluginLibraryPath(&layer->plugin_library,
+                                    layer->plugin_library_original, map);
+      if (rv == MS_FAILURE)
+        return (-1);
+    } break;
+    case (PROCESSING): {
+      /* NOTE: processing array maintained as size+1 with NULL terminator.
+               This ensure that CSL (GDAL string list) functions can be
+               used on the list for easy processing. */
+      char *value = NULL;
+      if (getString(&value) == MS_FAILURE)
+        return (-1);
+      msLayerAddProcessing(layer, value);
+      free(value);
+      value = NULL;
+    } break;
+    case (POSTLABELCACHE):
+      if ((layer->postlabelcache = getSymbol(2, MS_TRUE, MS_FALSE)) == -1)
+        return (-1);
+      if (layer->postlabelcache)
+        layer->labelcache = MS_OFF;
       break;
-      case(PROCESSING): {
-        /* NOTE: processing array maintained as size+1 with NULL terminator.
-                 This ensure that CSL (GDAL string list) functions can be
-                 used on the list for easy processing. */
-        char *value=NULL;
-        if(getString(&value) == MS_FAILURE) return(-1);
-        msLayerAddProcessing( layer, value );
-        free(value);
-        value=NULL;
+    case (PROJECTION):
+      if (loadProjection(&(layer->projection)) == -1)
+        return (-1);
+      layer->project = MS_TRUE;
+      break;
+    case (REQUIRES):
+      if (getString(&layer->requires) == MS_FAILURE)
+        return (-1); /* getString() cleans up previously allocated string */
+      break;
+    case (SCALETOKEN):
+      if (msGrowLayerScaletokens(layer) == NULL)
+        return (-1);
+      initScaleToken(&layer->scaletokens[layer->numscaletokens]);
+      if (loadScaletoken(&layer->scaletokens[layer->numscaletokens], layer) ==
+          -1) {
+        freeScaleToken(&layer->scaletokens[layer->numscaletokens]);
+        return (-1);
       }
+      layer->numscaletokens++;
       break;
-      case(POSTLABELCACHE):
-        if((layer->postlabelcache = getSymbol(2, MS_TRUE, MS_FALSE)) == -1) return(-1);
-        if(layer->postlabelcache)
-          layer->labelcache = MS_OFF;
-        break;
-      case(PROJECTION):
-        if(loadProjection(&(layer->projection)) == -1) return(-1);
-        layer->project = MS_TRUE;
-        break;
-      case(REQUIRES):
-        if(getString(&layer->requires) == MS_FAILURE) return(-1); /* getString() cleans up previously allocated string */
-        break;
-      case(SCALETOKEN):
-        if (msGrowLayerScaletokens(layer) == NULL)
-          return(-1);
-        initScaleToken(&layer->scaletokens[layer->numscaletokens]);
-        if(loadScaletoken(&layer->scaletokens[layer->numscaletokens], layer) == -1) {
-            freeScaleToken(&layer->scaletokens[layer->numscaletokens]);
-            return(-1);
-        }
-        layer->numscaletokens++;
-        break;
-      case(SIZEUNITS):
-        if((layer->sizeunits = getSymbol(8, MS_INCHES,MS_FEET,MS_MILES,MS_METERS,MS_KILOMETERS,MS_NAUTICALMILES,MS_DD,MS_PIXELS)) == -1) return(-1);
-        break;
-      case(STATUS):
-        if((layer->status = getSymbol(3, MS_ON,MS_OFF,MS_DEFAULT)) == -1) return(-1);
-        break;
-      case(STYLEITEM):
-        if(getString(&layer->styleitem) == MS_FAILURE) return(-1); /* getString() cleans up previously allocated string */
-        break;
-      case(SYMBOLSCALE):
-      case(SYMBOLSCALEDENOM):
-        if(getDouble(&(layer->symbolscaledenom), MS_NUM_CHECK_GTE, 1, -1) == -1) return(-1);
-        break;
-      case(TEMPLATE):
-        if(getString(&layer->template) == MS_FAILURE) return(-1); /* getString() cleans up previously allocated string */
-        break;
-      case(TILEINDEX):
-        if(getString(&layer->tileindex) == MS_FAILURE) return(-1); /* getString() cleans up previously allocated string */
-        break;
-      case(TILEITEM):
-        if(getString(&layer->tileitem) == MS_FAILURE) return(-1); /* getString() cleans up previously allocated string */
-        break;
-      case(TILESRS):
-        if(getString(&layer->tilesrs) == MS_FAILURE) return(-1); /* getString() cleans up previously allocated string */
-        break;
-      case(TOLERANCE):
-        if(getDouble(&(layer->tolerance), MS_NUM_CHECK_GTE, 0, -1) == -1) return(-1);
-        break;
-      case(TOLERANCEUNITS):
-        if((layer->toleranceunits = getSymbol(8, MS_INCHES,MS_FEET,MS_MILES,MS_METERS,MS_KILOMETERS,MS_NAUTICALMILES,MS_DD,MS_PIXELS)) == -1) return(-1);
-        break;
-      case(TRANSFORM):
-        if((layer->transform = getSymbol(11, MS_TRUE,MS_FALSE, MS_UL,MS_UC,MS_UR,MS_CL,MS_CC,MS_CR,MS_LL,MS_LC,MS_LR)) == -1) return(-1);
-        break;
-      case(TYPE):
-        if((type = getSymbol(9, MS_LAYER_POINT,MS_LAYER_LINE,MS_LAYER_RASTER,MS_LAYER_POLYGON,MS_LAYER_ANNOTATION,MS_LAYER_QUERY,MS_LAYER_CIRCLE,MS_LAYER_CHART,TILEINDEX)) == -1) return(-1);
-        if(type == TILEINDEX) type = MS_LAYER_TILEINDEX; /* TILEINDEX is also a parameter */
-        if(type == MS_LAYER_ANNOTATION) {
-          msSetError(MS_IDENTERR, "Annotation Layers have been removed. To obtain same functionality, use a layer with label->styles and no class->styles", "loadLayer()");
-          return -1;
-        }
-        layer->type = type;
-        break;
-      case(UNITS):
-        if((layer->units = getSymbol(9, MS_INCHES,MS_FEET,MS_MILES,MS_METERS,MS_KILOMETERS,MS_NAUTICALMILES,MS_DD,MS_PIXELS,MS_PERCENTAGES)) == -1) return(-1);
-        break;
-      case(UTFDATA):
-        if(loadExpression(&(layer->utfdata)) == -1) return(-1); /* loadExpression() cleans up previously allocated expression */
-        break;
-      case(UTFITEM):
-        if(getString(&layer->utfitem) == MS_FAILURE) return(-1);
-        break;
-      case(VALIDATION):
-        if(loadHashTable(&(layer->validation)) != MS_SUCCESS) return(-1);
-        break;
-      default:
-        if(strlen(msyystring_buffer) > 0) {
-          msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)", "loadLayer()", msyystring_buffer, msyylineno);
-          return(-1);
-        } else {
-          return(0); /* end of a string, not an error */
-        }
+    case (SIZEUNITS):
+      if ((layer->sizeunits = getSymbol(
+               8, MS_INCHES, MS_FEET, MS_MILES, MS_METERS, MS_KILOMETERS,
+               MS_NAUTICALMILES, MS_DD, MS_PIXELS)) == -1)
+        return (-1);
+      break;
+    case (STATUS):
+      if ((layer->status = getSymbol(3, MS_ON, MS_OFF, MS_DEFAULT)) == -1)
+        return (-1);
+      break;
+    case (STYLEITEM):
+      if (getString(&layer->styleitem) == MS_FAILURE)
+        return (-1); /* getString() cleans up previously allocated string */
+      break;
+    case (SYMBOLSCALE):
+    case (SYMBOLSCALEDENOM):
+      if (getDouble(&(layer->symbolscaledenom), MS_NUM_CHECK_GTE, 1, -1) == -1)
+        return (-1);
+      break;
+    case (TEMPLATE):
+      if (getString(&layer->template) == MS_FAILURE)
+        return (-1); /* getString() cleans up previously allocated string */
+      break;
+    case (TILEINDEX):
+      if (getString(&layer->tileindex) == MS_FAILURE)
+        return (-1); /* getString() cleans up previously allocated string */
+      break;
+    case (TILEITEM):
+      if (getString(&layer->tileitem) == MS_FAILURE)
+        return (-1); /* getString() cleans up previously allocated string */
+      break;
+    case (TILESRS):
+      if (getString(&layer->tilesrs) == MS_FAILURE)
+        return (-1); /* getString() cleans up previously allocated string */
+      break;
+    case (TOLERANCE):
+      if (getDouble(&(layer->tolerance), MS_NUM_CHECK_GTE, 0, -1) == -1)
+        return (-1);
+      break;
+    case (TOLERANCEUNITS):
+      if ((layer->toleranceunits = getSymbol(
+               8, MS_INCHES, MS_FEET, MS_MILES, MS_METERS, MS_KILOMETERS,
+               MS_NAUTICALMILES, MS_DD, MS_PIXELS)) == -1)
+        return (-1);
+      break;
+    case (TRANSFORM):
+      if ((layer->transform =
+               getSymbol(11, MS_TRUE, MS_FALSE, MS_UL, MS_UC, MS_UR, MS_CL,
+                         MS_CC, MS_CR, MS_LL, MS_LC, MS_LR)) == -1)
+        return (-1);
+      break;
+    case (TYPE):
+      if ((type =
+               getSymbol(9, MS_LAYER_POINT, MS_LAYER_LINE, MS_LAYER_RASTER,
+                         MS_LAYER_POLYGON, MS_LAYER_ANNOTATION, MS_LAYER_QUERY,
+                         MS_LAYER_CIRCLE, MS_LAYER_CHART, TILEINDEX)) == -1)
+        return (-1);
+      if (type == TILEINDEX)
+        type = MS_LAYER_TILEINDEX; /* TILEINDEX is also a parameter */
+      if (type == MS_LAYER_ANNOTATION) {
+        msSetError(MS_IDENTERR,
+                   "Annotation Layers have been removed. To obtain same "
+                   "functionality, use a layer with label->styles and no "
+                   "class->styles",
+                   "loadLayer()");
+        return -1;
+      }
+      layer->type = type;
+      break;
+    case (UNITS):
+      if ((layer->units = getSymbol(9, MS_INCHES, MS_FEET, MS_MILES, MS_METERS,
+                                    MS_KILOMETERS, MS_NAUTICALMILES, MS_DD,
+                                    MS_PIXELS, MS_PERCENTAGES)) == -1)
+        return (-1);
+      break;
+    case (UTFDATA):
+      if (loadExpression(&(layer->utfdata)) == -1)
+        return (-1); /* loadExpression() cleans up previously allocated
+                        expression */
+      break;
+    case (UTFITEM):
+      if (getString(&layer->utfitem) == MS_FAILURE)
+        return (-1);
+      break;
+    case (VALIDATION):
+      if (loadHashTable(&(layer->validation)) != MS_SUCCESS)
+        return (-1);
+      break;
+    default:
+      if (strlen(msyystring_buffer) > 0) {
+        msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)",
+                   "loadLayer()", msyystring_buffer, msyylineno);
+        return (-1);
+      } else {
+        return (0); /* end of a string, not an error */
+      }
     }
   } /* next token */
 }
 
-int msUpdateLayerFromString(layerObj *layer, char *string)
-{
+int msUpdateLayerFromString(layerObj *layer, char *string) {
   int i;
 
-  if(!layer || !string) return MS_FAILURE;
+  if (!layer || !string)
+    return MS_FAILURE;
 
-  msAcquireLock( TLOCK_PARSER );
+  msAcquireLock(TLOCK_PARSER);
 
   msyystate = MS_TOKENIZE_STRING;
   msyystring = string;
@@ -4332,133 +4773,136 @@ int msUpdateLayerFromString(layerObj *la
 
   msyylineno = 1; /* start at line 1 */
 
-  if(loadLayer(layer, layer->map) == -1) {
-    msReleaseLock( TLOCK_PARSER );
-    return MS_FAILURE; /* parse error */;
+  if (loadLayer(layer, layer->map) == -1) {
+    msReleaseLock(TLOCK_PARSER);
+    return MS_FAILURE; /* parse error */
+    ;
   }
-  msReleaseLock( TLOCK_PARSER );
+  msReleaseLock(TLOCK_PARSER);
 
   msyylex_destroy();
 
   /* step through classes to resolve symbol names */
-  for(i=0; i<layer->numclasses; i++) {
-    if(classResolveSymbolNames(layer->class[i]) != MS_SUCCESS) return MS_FAILURE;
+  for (i = 0; i < layer->numclasses; i++) {
+    if (classResolveSymbolNames(layer->class[i]) != MS_SUCCESS)
+      return MS_FAILURE;
   }
 
   return MS_SUCCESS;
 }
 
-static void writeCompositingFilter(FILE *stream, int indent, CompositingFilter *filter) {
-  while(filter) {
+static void writeCompositingFilter(FILE *stream, int indent,
+                                   CompositingFilter *filter) {
+  while (filter) {
     writeString(stream, indent, "COMPFILTER", "", filter->filter);
     filter = filter->next;
   }
 }
 
-static void writeLayerCompositer(FILE *stream, int indent, LayerCompositer *compositor) {
+static void writeLayerCompositer(FILE *stream, int indent,
+                                 LayerCompositer *compositor) {
   indent++;
-  while(compositor) {
+  while (compositor) {
     writeBlockBegin(stream, indent, "COMPOSITE");
     writeCompositingFilter(stream, indent, compositor->filter);
-    if(compositor->comp_op != MS_COMPOP_SRC_OVER) {
-      switch(compositor->comp_op) {
-        case MS_COMPOP_CLEAR:
-          writeString(stream, indent, "COMPOP", NULL, "clear");
-          break;
-        case MS_COMPOP_COLOR_BURN:
-          writeString(stream, indent, "COMPOP", NULL, "color-burn");
-          break;
-        case MS_COMPOP_COLOR_DODGE:
-          writeString(stream, indent, "COMPOP", NULL, "color-dodge");
-          break;
-        case MS_COMPOP_CONTRAST:
-          writeString(stream, indent, "COMPOP", NULL, "contrast");
-          break;
-        case MS_COMPOP_DARKEN:
-          writeString(stream, indent, "COMPOP", NULL, "darken");
-          break;
-        case MS_COMPOP_DIFFERENCE:
-          writeString(stream, indent, "COMPOP", NULL, "difference");
-          break;
-        case MS_COMPOP_DST:
-          writeString(stream, indent, "COMPOP", NULL, "dst");
-          break;
-        case MS_COMPOP_DST_ATOP:
-          writeString(stream, indent, "COMPOP", NULL, "dst-atop");
-          break;
-        case MS_COMPOP_DST_IN:
-          writeString(stream, indent, "COMPOP", NULL, "dst-in");
-          break;
-        case MS_COMPOP_DST_OUT:
-          writeString(stream, indent, "COMPOP", NULL, "dst-out");
-          break;
-        case MS_COMPOP_DST_OVER:
-          writeString(stream, indent, "COMPOP", NULL, "dst-over");
-          break;
-        case MS_COMPOP_EXCLUSION:
-          writeString(stream, indent, "COMPOP", NULL, "exclusion");
-          break;
-        case MS_COMPOP_HARD_LIGHT:
-          writeString(stream, indent, "COMPOP", NULL, "hard-light");
-          break;
-        case MS_COMPOP_INVERT:
-          writeString(stream, indent, "COMPOP", NULL, "invert");
-          break;
-        case MS_COMPOP_INVERT_RGB:
-          writeString(stream, indent, "COMPOP", NULL, "invert-rgb");
-          break;
-        case MS_COMPOP_LIGHTEN:
-          writeString(stream, indent, "COMPOP", NULL, "lighten");
-          break;
-        case MS_COMPOP_MINUS:
-          writeString(stream, indent, "COMPOP", NULL, "minus");
-          break;
-        case MS_COMPOP_MULTIPLY:
-          writeString(stream, indent, "COMPOP", NULL, "multiply");
-          break;
-        case MS_COMPOP_OVERLAY:
-          writeString(stream, indent, "COMPOP", NULL, "overlay");
-          break;
-        case MS_COMPOP_PLUS:
-          writeString(stream, indent, "COMPOP", NULL, "plus");
-          break;
-        case MS_COMPOP_SCREEN:
-          writeString(stream, indent, "COMPOP", NULL, "screen");
-          break;
-        case MS_COMPOP_SOFT_LIGHT:
-          writeString(stream, indent, "COMPOP", NULL, "soft-light");
-          break;
-        case MS_COMPOP_SRC:
-          writeString(stream, indent, "COMPOP", NULL, "src");
-          break;
-        case MS_COMPOP_SRC_ATOP:
-          writeString(stream, indent, "COMPOP", NULL, "src-atop");
-          break;
-        case MS_COMPOP_SRC_IN:
-          writeString(stream, indent, "COMPOP", NULL, "src-in");
-          break;
-        case MS_COMPOP_SRC_OUT:
-          writeString(stream, indent, "COMPOP", NULL, "src-out");
-          break;
-        case MS_COMPOP_SRC_OVER:
-          writeString(stream, indent, "COMPOP", NULL, "src-over");
-          break;
-        case MS_COMPOP_XOR:
-          writeString(stream, indent, "COMPOP", NULL, "xor");
-          break;
+    if (compositor->comp_op != MS_COMPOP_SRC_OVER) {
+      switch (compositor->comp_op) {
+      case MS_COMPOP_CLEAR:
+        writeString(stream, indent, "COMPOP", NULL, "clear");
+        break;
+      case MS_COMPOP_COLOR_BURN:
+        writeString(stream, indent, "COMPOP", NULL, "color-burn");
+        break;
+      case MS_COMPOP_COLOR_DODGE:
+        writeString(stream, indent, "COMPOP", NULL, "color-dodge");
+        break;
+      case MS_COMPOP_CONTRAST:
+        writeString(stream, indent, "COMPOP", NULL, "contrast");
+        break;
+      case MS_COMPOP_DARKEN:
+        writeString(stream, indent, "COMPOP", NULL, "darken");
+        break;
+      case MS_COMPOP_DIFFERENCE:
+        writeString(stream, indent, "COMPOP", NULL, "difference");
+        break;
+      case MS_COMPOP_DST:
+        writeString(stream, indent, "COMPOP", NULL, "dst");
+        break;
+      case MS_COMPOP_DST_ATOP:
+        writeString(stream, indent, "COMPOP", NULL, "dst-atop");
+        break;
+      case MS_COMPOP_DST_IN:
+        writeString(stream, indent, "COMPOP", NULL, "dst-in");
+        break;
+      case MS_COMPOP_DST_OUT:
+        writeString(stream, indent, "COMPOP", NULL, "dst-out");
+        break;
+      case MS_COMPOP_DST_OVER:
+        writeString(stream, indent, "COMPOP", NULL, "dst-over");
+        break;
+      case MS_COMPOP_EXCLUSION:
+        writeString(stream, indent, "COMPOP", NULL, "exclusion");
+        break;
+      case MS_COMPOP_HARD_LIGHT:
+        writeString(stream, indent, "COMPOP", NULL, "hard-light");
+        break;
+      case MS_COMPOP_INVERT:
+        writeString(stream, indent, "COMPOP", NULL, "invert");
+        break;
+      case MS_COMPOP_INVERT_RGB:
+        writeString(stream, indent, "COMPOP", NULL, "invert-rgb");
+        break;
+      case MS_COMPOP_LIGHTEN:
+        writeString(stream, indent, "COMPOP", NULL, "lighten");
+        break;
+      case MS_COMPOP_MINUS:
+        writeString(stream, indent, "COMPOP", NULL, "minus");
+        break;
+      case MS_COMPOP_MULTIPLY:
+        writeString(stream, indent, "COMPOP", NULL, "multiply");
+        break;
+      case MS_COMPOP_OVERLAY:
+        writeString(stream, indent, "COMPOP", NULL, "overlay");
+        break;
+      case MS_COMPOP_PLUS:
+        writeString(stream, indent, "COMPOP", NULL, "plus");
+        break;
+      case MS_COMPOP_SCREEN:
+        writeString(stream, indent, "COMPOP", NULL, "screen");
+        break;
+      case MS_COMPOP_SOFT_LIGHT:
+        writeString(stream, indent, "COMPOP", NULL, "soft-light");
+        break;
+      case MS_COMPOP_SRC:
+        writeString(stream, indent, "COMPOP", NULL, "src");
+        break;
+      case MS_COMPOP_SRC_ATOP:
+        writeString(stream, indent, "COMPOP", NULL, "src-atop");
+        break;
+      case MS_COMPOP_SRC_IN:
+        writeString(stream, indent, "COMPOP", NULL, "src-in");
+        break;
+      case MS_COMPOP_SRC_OUT:
+        writeString(stream, indent, "COMPOP", NULL, "src-out");
+        break;
+      case MS_COMPOP_SRC_OVER:
+        writeString(stream, indent, "COMPOP", NULL, "src-over");
+        break;
+      case MS_COMPOP_XOR:
+        writeString(stream, indent, "COMPOP", NULL, "xor");
+        break;
       }
     }
-    writeNumber(stream,indent,"OPACITY",100,compositor->opacity);
-    writeBlockEnd(stream,indent,"COMPOSITE");
+    writeNumber(stream, indent, "OPACITY", 100, compositor->opacity);
+    writeBlockEnd(stream, indent, "COMPOSITE");
     compositor = compositor->next;
   }
 }
-static void writeLayer(FILE *stream, int indent, layerObj *layer)
-{
+static void writeLayer(FILE *stream, int indent, layerObj *layer) {
   int i;
-  featureListNodeObjPtr current=NULL;
+  featureListNodeObjPtr current = NULL;
 
-  if(layer->status == MS_DELETE)
+  if (layer->status == MS_DELETE)
     return;
 
   indent++;
@@ -4470,10 +4914,17 @@ static void writeLayer(FILE *stream, int
   writeCluster(stream, indent, &(layer->cluster));
   writeLayerCompositer(stream, indent, layer->compositer);
   writeString(stream, indent, "CONNECTION", NULL, layer->connection);
-  writeKeyword(stream, indent, "CONNECTIONTYPE", layer->connectiontype, 12, MS_OGR, "OGR", MS_POSTGIS, "POSTGIS", MS_WMS, "WMS", MS_ORACLESPATIAL, "ORACLESPATIAL", MS_WFS, "WFS", MS_PLUGIN, "PLUGIN", MS_UNION, "UNION", MS_UVRASTER, "UVRASTER", MS_CONTOUR, "CONTOUR", MS_KERNELDENSITY, "KERNELDENSITY", MS_IDW, "IDW", MS_FLATGEOBUF, "FLATGEOBUF");
-  writeHashTable(stream, indent, "CONNECTIONOPTIONS", &(layer->connectionoptions));
+  writeKeyword(stream, indent, "CONNECTIONTYPE", layer->connectiontype, 12,
+               MS_OGR, "OGR", MS_POSTGIS, "POSTGIS", MS_WMS, "WMS",
+               MS_ORACLESPATIAL, "ORACLESPATIAL", MS_WFS, "WFS", MS_PLUGIN,
+               "PLUGIN", MS_UNION, "UNION", MS_UVRASTER, "UVRASTER", MS_CONTOUR,
+               "CONTOUR", MS_KERNELDENSITY, "KERNELDENSITY", MS_IDW, "IDW",
+               MS_FLATGEOBUF, "FLATGEOBUF");
+  writeHashTable(stream, indent, "CONNECTIONOPTIONS",
+                 &(layer->connectionoptions));
   writeString(stream, indent, "DATA", NULL, layer->data);
-  writeNumber(stream, indent, "DEBUG", 0, layer->debug); /* is this right? see loadLayer() */
+  writeNumber(stream, indent, "DEBUG", 0,
+              layer->debug); /* is this right? see loadLayer() */
   writeString(stream, indent, "ENCODING", NULL, layer->encoding);
   writeExtent(stream, indent, "EXTENT", layer->extent);
   writeExpression(stream, indent, "FILTER", &(layer->filter));
@@ -4481,17 +4932,20 @@ static void writeLayer(FILE *stream, int
   writeString(stream, indent, "FOOTER", NULL, layer->footer);
   writeString(stream, indent, "GROUP", NULL, layer->group);
 
-  if(layer->_geomtransform.type == MS_GEOMTRANSFORM_EXPRESSION) {
+  if (layer->_geomtransform.type == MS_GEOMTRANSFORM_EXPRESSION) {
     writeIndent(stream, indent + 1);
     fprintf(stream, "GEOMTRANSFORM (%s)\n", layer->_geomtransform.string);
   }
 
   writeString(stream, indent, "HEADER", NULL, layer->header);
   /* join - see below */
-  writeKeyword(stream, indent, "LABELCACHE", layer->labelcache, 1, MS_OFF, "OFF");
+  writeKeyword(stream, indent, "LABELCACHE", layer->labelcache, 1, MS_OFF,
+               "OFF");
   writeString(stream, indent, "LABELITEM", NULL, layer->labelitem);
-  writeNumber(stream, indent, "LABELMAXSCALEDENOM", -1, layer->labelmaxscaledenom);
-  writeNumber(stream, indent, "LABELMINSCALEDENOM", -1, layer->labelminscaledenom);
+  writeNumber(stream, indent, "LABELMAXSCALEDENOM", -1,
+              layer->labelmaxscaledenom);
+  writeNumber(stream, indent, "LABELMINSCALEDENOM", -1,
+              layer->labelminscaledenom);
   writeString(stream, indent, "LABELREQUIRES", NULL, layer->labelrequires);
   writeNumber(stream, indent, "MAXFEATURES", -1, layer->maxfeatures);
   writeNumber(stream, indent, "MAXGEOWIDTH", -1, layer->maxgeowidth);
@@ -4504,13 +4958,18 @@ static void writeLayer(FILE *stream, int
   writeString(stream, indent, "NAME", NULL, layer->name);
   writeColor(stream, indent, "OFFSITE", NULL, &(layer->offsite));
   writeString(stream, indent, "PLUGIN", NULL, layer->plugin_library_original);
-  writeKeyword(stream, indent, "POSTLABELCACHE", layer->postlabelcache, 1, MS_TRUE, "TRUE");
-  for(i=0; i<layer->numprocessing; i++)
+  writeKeyword(stream, indent, "POSTLABELCACHE", layer->postlabelcache, 1,
+               MS_TRUE, "TRUE");
+  for (i = 0; i < layer->numprocessing; i++)
     writeString(stream, indent, "PROCESSING", NULL, layer->processing[i]);
   writeProjection(stream, indent, &(layer->projection));
   writeString(stream, indent, "REQUIRES", NULL, layer->requires);
-  writeKeyword(stream, indent, "SIZEUNITS", layer->sizeunits, 7, MS_INCHES, "INCHES", MS_FEET ,"FEET", MS_MILES, "MILES", MS_METERS, "METERS", MS_KILOMETERS, "KILOMETERS", MS_NAUTICALMILES, "NAUTICALMILES", MS_DD, "DD");
-  writeKeyword(stream, indent, "STATUS", layer->status, 3, MS_ON, "ON", MS_OFF, "OFF", MS_DEFAULT, "DEFAULT");
+  writeKeyword(stream, indent, "SIZEUNITS", layer->sizeunits, 7, MS_INCHES,
+               "INCHES", MS_FEET, "FEET", MS_MILES, "MILES", MS_METERS,
+               "METERS", MS_KILOMETERS, "KILOMETERS", MS_NAUTICALMILES,
+               "NAUTICALMILES", MS_DD, "DD");
+  writeKeyword(stream, indent, "STATUS", layer->status, 3, MS_ON, "ON", MS_OFF,
+               "OFF", MS_DEFAULT, "DEFAULT");
   writeString(stream, indent, "STYLEITEM", NULL, layer->styleitem);
   writeNumber(stream, indent, "SYMBOLSCALEDENOM", -1, layer->symbolscaledenom);
   writeString(stream, indent, "TEMPLATE", NULL, layer->template);
@@ -4518,24 +4977,40 @@ static void writeLayer(FILE *stream, int
   writeString(stream, indent, "TILEITEM", NULL, layer->tileitem);
   writeString(stream, indent, "TILESRS", NULL, layer->tilesrs);
   writeNumber(stream, indent, "TOLERANCE", -1, layer->tolerance);
-  writeKeyword(stream, indent, "TOLERANCEUNITS", layer->toleranceunits, 7, MS_INCHES, "INCHES", MS_FEET ,"FEET", MS_MILES, "MILES", MS_METERS, "METERS", MS_KILOMETERS, "KILOMETERS", MS_NAUTICALMILES, "NAUTICALMILES", MS_DD, "DD");
-  writeKeyword(stream, indent, "TRANSFORM", layer->transform, 10, MS_FALSE, "FALSE", MS_UL, "UL", MS_UC, "UC", MS_UR, "UR", MS_CL, "CL", MS_CC, "CC", MS_CR, "CR", MS_LL, "LL", MS_LC, "LC", MS_LR, "LR");
-  writeKeyword(stream, indent, "TYPE", layer->type, 9, MS_LAYER_POINT, "POINT", MS_LAYER_LINE, "LINE", MS_LAYER_POLYGON, "POLYGON", MS_LAYER_RASTER, "RASTER", MS_LAYER_ANNOTATION, "ANNOTATION", MS_LAYER_QUERY, "QUERY", MS_LAYER_CIRCLE, "CIRCLE", MS_LAYER_TILEINDEX, "TILEINDEX", MS_LAYER_CHART, "CHART");
-  writeKeyword(stream, indent, "UNITS", layer->units, 9, MS_INCHES, "INCHES", MS_FEET ,"FEET", MS_MILES, "MILES", MS_METERS, "METERS", MS_KILOMETERS, "KILOMETERS", MS_NAUTICALMILES, "NAUTICALMILES", MS_DD, "DD", MS_PIXELS, "PIXELS", MS_PERCENTAGES, "PERCENTATGES");
+  writeKeyword(stream, indent, "TOLERANCEUNITS", layer->toleranceunits, 7,
+               MS_INCHES, "INCHES", MS_FEET, "FEET", MS_MILES, "MILES",
+               MS_METERS, "METERS", MS_KILOMETERS, "KILOMETERS",
+               MS_NAUTICALMILES, "NAUTICALMILES", MS_DD, "DD");
+  writeKeyword(stream, indent, "TRANSFORM", layer->transform, 10, MS_FALSE,
+               "FALSE", MS_UL, "UL", MS_UC, "UC", MS_UR, "UR", MS_CL, "CL",
+               MS_CC, "CC", MS_CR, "CR", MS_LL, "LL", MS_LC, "LC", MS_LR, "LR");
+  writeKeyword(stream, indent, "TYPE", layer->type, 9, MS_LAYER_POINT, "POINT",
+               MS_LAYER_LINE, "LINE", MS_LAYER_POLYGON, "POLYGON",
+               MS_LAYER_RASTER, "RASTER", MS_LAYER_ANNOTATION, "ANNOTATION",
+               MS_LAYER_QUERY, "QUERY", MS_LAYER_CIRCLE, "CIRCLE",
+               MS_LAYER_TILEINDEX, "TILEINDEX", MS_LAYER_CHART, "CHART");
+  writeKeyword(stream, indent, "UNITS", layer->units, 9, MS_INCHES, "INCHES",
+               MS_FEET, "FEET", MS_MILES, "MILES", MS_METERS, "METERS",
+               MS_KILOMETERS, "KILOMETERS", MS_NAUTICALMILES, "NAUTICALMILES",
+               MS_DD, "DD", MS_PIXELS, "PIXELS", MS_PERCENTAGES,
+               "PERCENTATGES");
   writeExpression(stream, indent, "UTFDATA", &(layer->utfdata));
   writeString(stream, indent, "UTFITEM", NULL, layer->utfitem);
   writeHashTable(stream, indent, "VALIDATION", &(layer->validation));
 
   /* write potentially multiply occuring objects last */
-  for(i=0; i<layer->numscaletokens; i++)  writeScaleToken(stream, indent, &(layer->scaletokens[i]));
-  for(i=0; i<layer->numjoins; i++)  writeJoin(stream, indent, &(layer->joins[i]));
-  for(i=0; i<layer->numclasses; i++) writeClass(stream, indent, layer->class[i]);
+  for (i = 0; i < layer->numscaletokens; i++)
+    writeScaleToken(stream, indent, &(layer->scaletokens[i]));
+  for (i = 0; i < layer->numjoins; i++)
+    writeJoin(stream, indent, &(layer->joins[i]));
+  for (i = 0; i < layer->numclasses; i++)
+    writeClass(stream, indent, layer->class[i]);
 
-  if( layer->grid &&  layer->connectiontype == MS_GRATICULE)
+  if (layer->grid && layer->connectiontype == MS_GRATICULE)
     writeGrid(stream, indent, layer->grid);
   else {
     current = layer->features;
-    while(current != NULL) {
+    while (current != NULL) {
       writeFeature(stream, indent, &(current->shape));
       current = current->next;
     }
@@ -4545,9 +5020,8 @@ static void writeLayer(FILE *stream, int
   writeLineFeed(stream);
 }
 
-char* msWriteLayerToString(layerObj *layer)
-{
-  msIOContext  context;
+char *msWriteLayerToString(layerObj *layer) {
+  msIOContext context;
   msIOBuffer buffer;
 
   context.label = NULL;
@@ -4558,23 +5032,23 @@ char* msWriteLayerToString(layerObj *lay
   buffer.data_len = 0;
   buffer.data_offset = 0;
 
-  msIO_installHandlers( NULL, &context, NULL );
+  msIO_installHandlers(NULL, &context, NULL);
 
   writeLayer(stdout, -1, layer);
-  msIO_bufferWrite( &buffer, "", 1 );
+  msIO_bufferWrite(&buffer, "", 1);
 
-  msIO_installHandlers( NULL, NULL, NULL );
+  msIO_installHandlers(NULL, NULL, NULL);
 
-  return (char*)buffer.data;
+  return (char *)buffer.data;
 }
 
 /*
 ** Initialize, load and free a referenceMapObj structure
 */
-void initReferenceMap(referenceMapObj *ref)
-{
+void initReferenceMap(referenceMapObj *ref) {
   ref->height = ref->width = 0;
-  ref->extent.minx = ref->extent.miny = ref->extent.maxx = ref->extent.maxy = -1.0;
+  ref->extent.minx = ref->extent.miny = ref->extent.maxx = ref->extent.maxy =
+      -1.0;
   ref->image = NULL;
   MS_INIT_COLOR(ref->color, 255, 0, 0, 255);
   MS_INIT_COLOR(ref->outlinecolor, 0, 0, 0, 255);
@@ -4587,103 +5061,124 @@ void initReferenceMap(referenceMapObj *r
   ref->map = NULL;
 }
 
-void freeReferenceMap(referenceMapObj *ref)
-{
+void freeReferenceMap(referenceMapObj *ref) {
   msFree(ref->image);
   msFree(ref->markername);
 }
 
-int loadReferenceMap(referenceMapObj *ref, mapObj *map)
-{
+int loadReferenceMap(referenceMapObj *ref, mapObj *map) {
   int state;
 
   ref->map = (mapObj *)map;
 
-  for(;;) {
-    switch(msyylex()) {
-      case(EOF):
-        msSetError(MS_EOFERR, NULL, "loadReferenceMap()");
-        return(-1);
-      case(END):
-        if(!ref->image) {
-          msSetError(MS_MISCERR, "No image defined for the reference map.", "loadReferenceMap()");
-          return(-1);
-        }
-        if(ref->width == 0 || ref->height == 0) {
-          msSetError(MS_MISCERR, "No image size defined for the reference map.", "loadReferenceMap()");
-          return(-1);
-        }
-        return(0);
-        break;
-      case(COLOR):
-        if(loadColor(&(ref->color), NULL) != MS_SUCCESS) return(-1);
-        break;
-      case(EXTENT):
-        if(getDouble(&(ref->extent.minx), MS_NUM_CHECK_NONE, -1, -1) == -1) return(-1);
-        if(getDouble(&(ref->extent.miny), MS_NUM_CHECK_NONE, -1, -1) == -1) return(-1);
-        if(getDouble(&(ref->extent.maxx), MS_NUM_CHECK_NONE, -1, -1) == -1) return(-1);
-        if(getDouble(&(ref->extent.maxy), MS_NUM_CHECK_NONE, -1, -1) == -1) return(-1);
-        if (!MS_VALID_EXTENT(ref->extent)) {
-          msSetError(MS_MISCERR, "Given reference extent is invalid. Check that it " \
-                     "is in the form: minx, miny, maxx, maxy", "loadReferenceMap()");
-          return(-1);
-        }
-        break;
-      case(IMAGE):
-        if(getString(&ref->image) == MS_FAILURE) return(-1);
-        break;
-      case(OUTLINECOLOR):
-        if(loadColor(&(ref->outlinecolor), NULL) != MS_SUCCESS) return(-1);
-        break;
-      case(SIZE):
-        if(getInteger(&(ref->width), MS_NUM_CHECK_RANGE, 5, ref->map->maxsize) == -1) return(-1); // is 5 reasonable?
-        if(getInteger(&(ref->height), MS_NUM_CHECK_RANGE, 5, ref->map->maxsize) == -1) return(-1);
-        break;
-      case(STATUS):
-        if((ref->status = getSymbol(2, MS_ON,MS_OFF)) == -1) return(-1);
-        break;
-      case(MARKER):
-        if((state = getSymbol(2, MS_NUMBER,MS_STRING)) == -1) return(-1);
+  for (;;) {
+    switch (msyylex()) {
+    case (EOF):
+      msSetError(MS_EOFERR, NULL, "loadReferenceMap()");
+      return (-1);
+    case (END):
+      if (!ref->image) {
+        msSetError(MS_MISCERR, "No image defined for the reference map.",
+                   "loadReferenceMap()");
+        return (-1);
+      }
+      if (ref->width == 0 || ref->height == 0) {
+        msSetError(MS_MISCERR, "No image size defined for the reference map.",
+                   "loadReferenceMap()");
+        return (-1);
+      }
+      return (0);
+      break;
+    case (COLOR):
+      if (loadColor(&(ref->color), NULL) != MS_SUCCESS)
+        return (-1);
+      break;
+    case (EXTENT):
+      if (getDouble(&(ref->extent.minx), MS_NUM_CHECK_NONE, -1, -1) == -1)
+        return (-1);
+      if (getDouble(&(ref->extent.miny), MS_NUM_CHECK_NONE, -1, -1) == -1)
+        return (-1);
+      if (getDouble(&(ref->extent.maxx), MS_NUM_CHECK_NONE, -1, -1) == -1)
+        return (-1);
+      if (getDouble(&(ref->extent.maxy), MS_NUM_CHECK_NONE, -1, -1) == -1)
+        return (-1);
+      if (!MS_VALID_EXTENT(ref->extent)) {
+        msSetError(MS_MISCERR,
+                   "Given reference extent is invalid. Check that it "
+                   "is in the form: minx, miny, maxx, maxy",
+                   "loadReferenceMap()");
+        return (-1);
+      }
+      break;
+    case (IMAGE):
+      if (getString(&ref->image) == MS_FAILURE)
+        return (-1);
+      break;
+    case (OUTLINECOLOR):
+      if (loadColor(&(ref->outlinecolor), NULL) != MS_SUCCESS)
+        return (-1);
+      break;
+    case (SIZE):
+      if (getInteger(&(ref->width), MS_NUM_CHECK_RANGE, 5, ref->map->maxsize) ==
+          -1)
+        return (-1); // is 5 reasonable?
+      if (getInteger(&(ref->height), MS_NUM_CHECK_RANGE, 5,
+                     ref->map->maxsize) == -1)
+        return (-1);
+      break;
+    case (STATUS):
+      if ((ref->status = getSymbol(2, MS_ON, MS_OFF)) == -1)
+        return (-1);
+      break;
+    case (MARKER):
+      if ((state = getSymbol(2, MS_NUMBER, MS_STRING)) == -1)
+        return (-1);
 
-        if(state == MS_NUMBER) {
-	  if(msCheckNumber(msyynumber, MS_NUM_CHECK_GTE, 0, -1) == MS_FAILURE) {
-            msSetError(MS_MISCERR, "Invalid MARKER, must be greater than 0 (line %d)", "loadReferenceMap()", msyylineno);
-            return(-1);
-          }
-          ref->marker = (int) msyynumber;
-        } else {
-          if (ref->markername != NULL)
-            msFree(ref->markername);
-          ref->markername = msStrdup(msyystring_buffer);
-        }
-        break;
-      case(MARKERSIZE):
-        if(getInteger(&(ref->markersize), MS_NUM_CHECK_GT, 0, -1) == -1) return(-1);
-        break;
-      case(MINBOXSIZE):
-        if(getInteger(&(ref->minboxsize), MS_NUM_CHECK_GT, 0, -1) == -1) return(-1);
-        break;
-      case(MAXBOXSIZE):
-        if(getInteger(&(ref->maxboxsize), MS_NUM_CHECK_GT, 0, -1) == -1) return(-1);
-        break;
-      case(REFERENCE):
-        break; /* for string loads */
-      default:
-        if(strlen(msyystring_buffer) > 0) {
-          msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)", "loadReferenceMap()", msyystring_buffer, msyylineno);
-          return(-1);
-        } else {
-          return(0); /* end of a string, not an error */
+      if (state == MS_NUMBER) {
+        if (msCheckNumber(msyynumber, MS_NUM_CHECK_GTE, 0, -1) == MS_FAILURE) {
+          msSetError(MS_MISCERR,
+                     "Invalid MARKER, must be greater than 0 (line %d)",
+                     "loadReferenceMap()", msyylineno);
+          return (-1);
         }
+        ref->marker = (int)msyynumber;
+      } else {
+        if (ref->markername != NULL)
+          msFree(ref->markername);
+        ref->markername = msStrdup(msyystring_buffer);
+      }
+      break;
+    case (MARKERSIZE):
+      if (getInteger(&(ref->markersize), MS_NUM_CHECK_GT, 0, -1) == -1)
+        return (-1);
+      break;
+    case (MINBOXSIZE):
+      if (getInteger(&(ref->minboxsize), MS_NUM_CHECK_GT, 0, -1) == -1)
+        return (-1);
+      break;
+    case (MAXBOXSIZE):
+      if (getInteger(&(ref->maxboxsize), MS_NUM_CHECK_GT, 0, -1) == -1)
+        return (-1);
+      break;
+    case (REFERENCE):
+      break; /* for string loads */
+    default:
+      if (strlen(msyystring_buffer) > 0) {
+        msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)",
+                   "loadReferenceMap()", msyystring_buffer, msyylineno);
+        return (-1);
+      } else {
+        return (0); /* end of a string, not an error */
+      }
     }
   } /* next token */
 }
 
-int msUpdateReferenceMapFromString(referenceMapObj *ref, char *string)
-{
-  if(!ref || !string) return MS_FAILURE;
+int msUpdateReferenceMapFromString(referenceMapObj *ref, char *string) {
+  if (!ref || !string)
+    return MS_FAILURE;
 
-  msAcquireLock( TLOCK_PARSER );
+  msAcquireLock(TLOCK_PARSER);
 
   msyystate = MS_TOKENIZE_STRING;
   msyystring = string;
@@ -4691,33 +5186,36 @@ int msUpdateReferenceMapFromString(refer
 
   msyylineno = 1; /* start at line 1 */
 
-  if(loadReferenceMap(ref, ref->map) == -1) {
-    msReleaseLock( TLOCK_PARSER );
-    return MS_FAILURE; /* parse error */;
+  if (loadReferenceMap(ref, ref->map) == -1) {
+    msReleaseLock(TLOCK_PARSER);
+    return MS_FAILURE; /* parse error */
+    ;
   }
-  msReleaseLock( TLOCK_PARSER );
+  msReleaseLock(TLOCK_PARSER);
 
   msyylex_destroy();
   return MS_SUCCESS;
 }
 
-static void writeReferenceMap(FILE *stream, int indent, referenceMapObj *ref)
-{
+static void writeReferenceMap(FILE *stream, int indent, referenceMapObj *ref) {
   colorObj c;
 
-  if(!ref->image) return;
+  if (!ref->image)
+    return;
 
   indent++;
   writeBlockBegin(stream, indent, "REFERENCE");
-  MS_INIT_COLOR(c,255,0,0,255);
+  MS_INIT_COLOR(c, 255, 0, 0, 255);
   writeColor(stream, indent, "COLOR", &c, &(ref->color));
   writeExtent(stream, indent, "EXTENT", ref->extent);
   writeString(stream, indent, "IMAGE", NULL, ref->image);
-  MS_INIT_COLOR(c,0,0,0,255);
+  MS_INIT_COLOR(c, 0, 0, 0, 255);
   writeColor(stream, indent, "OUTLINECOLOR", &c, &(ref->outlinecolor));
   writeDimension(stream, indent, "SIZE", ref->width, ref->height, NULL, NULL);
-  writeKeyword(stream, indent, "STATUS", ref->status, 2, MS_ON, "ON", MS_OFF, "OFF");
-  writeNumberOrString(stream, indent, "MARKER", 0, ref->marker, ref->markername);
+  writeKeyword(stream, indent, "STATUS", ref->status, 2, MS_ON, "ON", MS_OFF,
+               "OFF");
+  writeNumberOrString(stream, indent, "MARKER", 0, ref->marker,
+                      ref->markername);
   writeNumber(stream, indent, "MARKERSIZE", -1, ref->markersize);
   writeNumber(stream, indent, "MAXBOXSIZE", -1, ref->maxboxsize);
   writeNumber(stream, indent, "MINBOXSIZE", -1, ref->minboxsize);
@@ -4725,9 +5223,8 @@ static void writeReferenceMap(FILE *stre
   writeLineFeed(stream);
 }
 
-char* msWriteReferenceMapToString(referenceMapObj *ref)
-{
-  msIOContext  context;
+char *msWriteReferenceMapToString(referenceMapObj *ref) {
+  msIOContext context;
   msIOBuffer buffer;
 
   context.label = NULL;
@@ -4738,20 +5235,19 @@ char* msWriteReferenceMapToString(refere
   buffer.data_len = 0;
   buffer.data_offset = 0;
 
-  msIO_installHandlers( NULL, &context, NULL );
+  msIO_installHandlers(NULL, &context, NULL);
 
   writeReferenceMap(stdout, -1, ref);
-  msIO_bufferWrite( &buffer, "", 1 );
+  msIO_bufferWrite(&buffer, "", 1);
 
-  msIO_installHandlers( NULL, NULL, NULL );
+  msIO_installHandlers(NULL, NULL, NULL);
 
-  return (char*)buffer.data;
+  return (char *)buffer.data;
 }
 
 #define MAX_FORMATOPTIONS 100
 
-static int loadOutputFormat(mapObj *map)
-{
+static int loadOutputFormat(mapObj *map) {
   char *name = NULL;
   char *mimetype = NULL;
   char *driver = NULL;
@@ -4759,173 +5255,179 @@ static int loadOutputFormat(mapObj *map)
   int imagemode = MS_NOOVERRIDE;
   int transparent = MS_NOOVERRIDE;
   char *formatoptions[MAX_FORMATOPTIONS];
-  int  numformatoptions = 0;
+  int numformatoptions = 0;
   char *value = NULL;
 
-  for(;;) {
-    switch(msyylex()) {
-      case(EOF):
-        msSetError(MS_EOFERR, NULL, "loadOutputFormat()");
-        goto load_output_error;
+  for (;;) {
+    switch (msyylex()) {
+    case (EOF):
+      msSetError(MS_EOFERR, NULL, "loadOutputFormat()");
+      goto load_output_error;
 
-      case(END): {
-        outputFormatObj *format;
+    case (END): {
+      outputFormatObj *format;
 
-        if( driver == NULL ) {
-          msSetError(MS_MISCERR,
-                     "OUTPUTFORMAT clause lacks DRIVER keyword near (%s):(%d)",
-                     "loadOutputFormat()",
-                     msyystring_buffer, msyylineno );
-          goto load_output_error;
-        }
+      if (driver == NULL) {
+        msSetError(MS_MISCERR,
+                   "OUTPUTFORMAT clause lacks DRIVER keyword near (%s):(%d)",
+                   "loadOutputFormat()", msyystring_buffer, msyylineno);
+        goto load_output_error;
+      }
 
-        format = msCreateDefaultOutputFormat( map, driver, name, NULL );
-        if( format == NULL ) {
-          msSetError(MS_MISCERR,
-                     "OUTPUTFORMAT (%s) clause references driver (%s), but this driver isn't configured.",
-                     "loadOutputFormat()", name, driver );
+      format = msCreateDefaultOutputFormat(map, driver, name, NULL);
+      if (format == NULL) {
+        msSetError(MS_MISCERR,
+                   "OUTPUTFORMAT (%s) clause references driver (%s), but this "
+                   "driver isn't configured.",
+                   "loadOutputFormat()", name, driver);
+        goto load_output_error;
+      }
+      msFree(name);
+      name = NULL;
+      msFree(driver);
+      driver = NULL;
+
+      if (transparent != MS_NOOVERRIDE)
+        format->transparent = transparent;
+      if (extension != NULL) {
+        msFree(format->extension);
+        format->extension = extension;
+        extension = NULL;
+      }
+      if (mimetype != NULL) {
+        msFree(format->mimetype);
+        format->mimetype = mimetype;
+        mimetype = NULL;
+      }
+      if (imagemode != MS_NOOVERRIDE) {
+        if (format->renderer != MS_RENDER_WITH_AGG ||
+            imagemode != MS_IMAGEMODE_PC256) {
+          /* don't force to PC256 with agg, this can happen when using mapfile
+           * defined GD outputformats that are now falling back to agg/png8
+           */
+          format->imagemode = imagemode;
+        }
+
+        if (transparent == MS_NOOVERRIDE) {
+          if (imagemode == MS_IMAGEMODE_RGB)
+            format->transparent = MS_FALSE;
+          else if (imagemode == MS_IMAGEMODE_RGBA)
+            format->transparent = MS_TRUE;
+        }
+        if (format->imagemode == MS_IMAGEMODE_INT16 ||
+            format->imagemode == MS_IMAGEMODE_FLOAT32 ||
+            format->imagemode == MS_IMAGEMODE_BYTE)
+          format->renderer = MS_RENDER_WITH_RAWDATA;
+      }
+      while (numformatoptions--) {
+        char *key = strchr(formatoptions[numformatoptions], '=');
+        if (!key || !*(key + 1)) {
+          msSetError(
+              MS_MISCERR,
+              "Failed to parse FORMATOPTION, expecting \"KEY=VALUE\" syntax.",
+              "loadOutputFormat()");
           goto load_output_error;
         }
-        msFree( name );
-        name = NULL;
-        msFree( driver );
-        driver = NULL;
-
-        if( transparent != MS_NOOVERRIDE )
-          format->transparent = transparent;
-        if( extension != NULL ) {
-          msFree( format->extension );
-          format->extension = extension;
-          extension = NULL;
-        }
-        if( mimetype != NULL ) {
-          msFree( format->mimetype );
-          format->mimetype = mimetype;
-          mimetype = NULL;
-        }
-        if( imagemode != MS_NOOVERRIDE ) {
-          if(format->renderer != MS_RENDER_WITH_AGG || imagemode != MS_IMAGEMODE_PC256) {
-            /* don't force to PC256 with agg, this can happen when using mapfile defined GD
-             * outputformats that are now falling back to agg/png8
-             */
-            format->imagemode = imagemode;
-          }
-
-          if( transparent == MS_NOOVERRIDE ) {
-            if( imagemode == MS_IMAGEMODE_RGB  )
-              format->transparent = MS_FALSE;
-            else if( imagemode == MS_IMAGEMODE_RGBA  )
-              format->transparent = MS_TRUE;
-          }
-          if( format->imagemode == MS_IMAGEMODE_INT16
-              || format->imagemode == MS_IMAGEMODE_FLOAT32
-              || format->imagemode == MS_IMAGEMODE_BYTE )
-            format->renderer = MS_RENDER_WITH_RAWDATA;
-        }
-        while(numformatoptions--) {
-          char *key = strchr(formatoptions[numformatoptions],'=');
-          if(!key || !*(key+1)) {
-            msSetError(MS_MISCERR,"Failed to parse FORMATOPTION, expecting \"KEY=VALUE\" syntax.","loadOutputFormat()");
-            goto load_output_error;
-          }
-          *key = 0;
-          key++;
-          msSetOutputFormatOption(format,formatoptions[numformatoptions],key);
-          free(formatoptions[numformatoptions]);
-        }
+        *key = 0;
+        key++;
+        msSetOutputFormatOption(format, formatoptions[numformatoptions], key);
+        free(formatoptions[numformatoptions]);
+      }
 
-        format->inmapfile = MS_TRUE;
+      format->inmapfile = MS_TRUE;
 
-        msOutputFormatValidate( format, MS_FALSE );
-        return(0);
+      msOutputFormatValidate(format, MS_FALSE);
+      return (0);
+    }
+    case (NAME):
+      msFree(name);
+      if ((name = getToken()) == NULL)
+        goto load_output_error;
+      break;
+    case (MIMETYPE):
+      if (getString(&mimetype) == MS_FAILURE)
+        goto load_output_error;
+      break;
+    case (DRIVER): {
+      int s;
+      if ((s = getSymbol(2, MS_STRING, TEMPLATE)) ==
+          -1) /* allow the template to be quoted or not in the mapfile */
+        goto load_output_error;
+      free(driver);
+      if (s == MS_STRING)
+        driver = msStrdup(msyystring_buffer);
+      else
+        driver = msStrdup("TEMPLATE");
+    } break;
+    case (EXTENSION):
+      if (getString(&extension) == MS_FAILURE)
+        goto load_output_error;
+      if (extension[0] == '.') {
+        char *temp = msStrdup(extension + 1);
+        free(extension);
+        extension = temp;
       }
-      case(NAME):
-        msFree( name );
-        if((name = getToken()) == NULL)
-          goto load_output_error;
-        break;
-      case(MIMETYPE):
-        if(getString(&mimetype) == MS_FAILURE)
-          goto load_output_error;
-        break;
-      case(DRIVER): {
-        int s;
-        if((s = getSymbol(2, MS_STRING, TEMPLATE)) == -1) /* allow the template to be quoted or not in the mapfile */
-          goto load_output_error;
-        free(driver);
-        if(s == MS_STRING)
-          driver = msStrdup(msyystring_buffer);
-        else
-          driver = msStrdup("TEMPLATE");
+      break;
+    case (FORMATOPTION):
+      if (getString(&value) == MS_FAILURE)
+        goto load_output_error;
+      if (numformatoptions < MAX_FORMATOPTIONS)
+        formatoptions[numformatoptions++] = value;
+      value = NULL;
+      break;
+    case (IMAGEMODE):
+      value = getToken();
+      if (strcasecmp(value, "PC256") == 0)
+        imagemode = MS_IMAGEMODE_PC256;
+      else if (strcasecmp(value, "RGB") == 0)
+        imagemode = MS_IMAGEMODE_RGB;
+      else if (strcasecmp(value, "RGBA") == 0)
+        imagemode = MS_IMAGEMODE_RGBA;
+      else if (strcasecmp(value, "INT16") == 0)
+        imagemode = MS_IMAGEMODE_INT16;
+      else if (strcasecmp(value, "FLOAT32") == 0)
+        imagemode = MS_IMAGEMODE_FLOAT32;
+      else if (strcasecmp(value, "BYTE") == 0)
+        imagemode = MS_IMAGEMODE_BYTE;
+      else if (strcasecmp(value, "FEATURE") == 0)
+        imagemode = MS_IMAGEMODE_FEATURE;
+      else {
+        msSetError(MS_IDENTERR,
+                   "Parsing error near (%s):(line %d), expected PC256, RGB, "
+                   "RGBA, FEATURE, BYTE, INT16, or FLOAT32 for IMAGEMODE.",
+                   "loadOutputFormat()", msyystring_buffer, msyylineno);
+        goto load_output_error;
       }
+      free(value);
+      value = NULL;
       break;
-      case(EXTENSION):
-        if(getString(&extension) == MS_FAILURE)
-          goto load_output_error;
-        if( extension[0] == '.' ) {
-          char *temp = msStrdup(extension+1);
-          free( extension );
-          extension = temp;
-        }
-        break;
-      case(FORMATOPTION):
-        if(getString(&value) == MS_FAILURE)
-          goto load_output_error;
-        if( numformatoptions < MAX_FORMATOPTIONS )
-          formatoptions[numformatoptions++] = value;
-        value=NULL;
-        break;
-      case(IMAGEMODE):
-        value = getToken();
-        if( strcasecmp(value,"PC256") == 0 )
-          imagemode = MS_IMAGEMODE_PC256;
-        else if( strcasecmp(value,"RGB") == 0 )
-          imagemode = MS_IMAGEMODE_RGB;
-        else if( strcasecmp(value,"RGBA") == 0)
-          imagemode = MS_IMAGEMODE_RGBA;
-        else if( strcasecmp(value,"INT16") == 0)
-          imagemode = MS_IMAGEMODE_INT16;
-        else if( strcasecmp(value,"FLOAT32") == 0)
-          imagemode = MS_IMAGEMODE_FLOAT32;
-        else if( strcasecmp(value,"BYTE") == 0)
-          imagemode = MS_IMAGEMODE_BYTE;
-        else if( strcasecmp(value,"FEATURE") == 0)
-          imagemode = MS_IMAGEMODE_FEATURE;
-        else {
-          msSetError(MS_IDENTERR,
-                     "Parsing error near (%s):(line %d), expected PC256, RGB, RGBA, FEATURE, BYTE, INT16, or FLOAT32 for IMAGEMODE.", "loadOutputFormat()",
-                     msyystring_buffer, msyylineno);
-          goto load_output_error;
-        }
-        free(value);
-        value=NULL;
-        break;
-      case(TRANSPARENT):
-        if((transparent = getSymbol(2, MS_ON,MS_OFF)) == -1)
-          goto load_output_error;
-        break;
-      default:
-        msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)", "loadOutputFormat()",
-                   msyystring_buffer, msyylineno);
+    case (TRANSPARENT):
+      if ((transparent = getSymbol(2, MS_ON, MS_OFF)) == -1)
         goto load_output_error;
+      break;
+    default:
+      msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)",
+                 "loadOutputFormat()", msyystring_buffer, msyylineno);
+      goto load_output_error;
     }
   } /* next token */
 load_output_error:
-  msFree( driver );
-  msFree( extension );
-  msFree( mimetype );
-  msFree( name );
-  msFree( value );
+  msFree(driver);
+  msFree(extension);
+  msFree(mimetype);
+  msFree(name);
+  msFree(value);
   return -1;
 }
 
 /*
 ** utility function to write an output format structure to file
 */
-static void writeOutputformatobject(FILE *stream, int indent, outputFormatObj *outputformat)
-{
+static void writeOutputformatobject(FILE *stream, int indent,
+                                    outputFormatObj *outputformat) {
   int i = 0;
-  if(!outputformat) return;
+  if (!outputformat)
+    return;
 
   indent++;
   writeBlockBegin(stream, indent, "OUTPUTFORMAT");
@@ -4933,26 +5435,32 @@ static void writeOutputformatobject(FILE
   writeString(stream, indent, "MIMETYPE", NULL, outputformat->mimetype);
   writeString(stream, indent, "DRIVER", NULL, outputformat->driver);
   writeString(stream, indent, "EXTENSION", NULL, outputformat->extension);
-  writeKeyword(stream, indent, "IMAGEMODE", outputformat->imagemode, 7, MS_IMAGEMODE_PC256, "PC256", MS_IMAGEMODE_RGB, "RGB", MS_IMAGEMODE_RGBA, "RGBA", MS_IMAGEMODE_INT16, "INT16", MS_IMAGEMODE_FLOAT32, "FLOAT32", MS_IMAGEMODE_BYTE, "BYTE", MS_IMAGEMODE_FEATURE, "FEATURE");
-  writeKeyword(stream, indent, "TRANSPARENT", outputformat->transparent, 2, MS_TRUE, "TRUE", MS_FALSE, "FALSE");
-  for (i=0; i<outputformat->numformatoptions; i++)
-    writeString(stream, indent, "FORMATOPTION", NULL, outputformat->formatoptions[i]);
+  writeKeyword(stream, indent, "IMAGEMODE", outputformat->imagemode, 7,
+               MS_IMAGEMODE_PC256, "PC256", MS_IMAGEMODE_RGB, "RGB",
+               MS_IMAGEMODE_RGBA, "RGBA", MS_IMAGEMODE_INT16, "INT16",
+               MS_IMAGEMODE_FLOAT32, "FLOAT32", MS_IMAGEMODE_BYTE, "BYTE",
+               MS_IMAGEMODE_FEATURE, "FEATURE");
+  writeKeyword(stream, indent, "TRANSPARENT", outputformat->transparent, 2,
+               MS_TRUE, "TRUE", MS_FALSE, "FALSE");
+  for (i = 0; i < outputformat->numformatoptions; i++)
+    writeString(stream, indent, "FORMATOPTION", NULL,
+                outputformat->formatoptions[i]);
   writeBlockEnd(stream, indent, "OUTPUTFORMAT");
   writeLineFeed(stream);
 }
 
-
 /*
 ** Write the output formats to file
 */
-static void writeOutputformat(FILE *stream, int indent, mapObj *map)
-{
-  int i=0;
-  if(!map->outputformat) return;
+static void writeOutputformat(FILE *stream, int indent, mapObj *map) {
+  int i = 0;
+  if (!map->outputformat)
+    return;
 
   writeOutputformatobject(stream, indent, map->outputformat);
-  for(i=0; i<map->numoutputformats; i++) {
-    if(map->outputformatlist[i]->inmapfile == MS_TRUE && strcmp(map->outputformatlist[i]->name, map->outputformat->name) != 0)
+  for (i = 0; i < map->numoutputformats; i++) {
+    if (map->outputformatlist[i]->inmapfile == MS_TRUE &&
+        strcmp(map->outputformatlist[i]->name, map->outputformat->name) != 0)
       writeOutputformatobject(stream, indent, map->outputformatlist[i]);
   }
 }
@@ -4960,11 +5468,10 @@ static void writeOutputformat(FILE *stre
 /*
 ** Initialize, load and free a legendObj structure
 */
-void initLegend(legendObj *legend)
-{
+void initLegend(legendObj *legend) {
   legend->height = legend->width = 0;
-  MS_INIT_COLOR(legend->imagecolor, 255,255,255,255); /* white */
-  MS_INIT_COLOR(legend->outlinecolor, -1,-1,-1,255);
+  MS_INIT_COLOR(legend->imagecolor, 255, 255, 255, 255); /* white */
+  MS_INIT_COLOR(legend->outlinecolor, -1, -1, -1, 255);
   initLabel(&legend->label);
   legend->label.position = MS_XY; /* override */
   legend->keysizex = 20;
@@ -4979,77 +5486,93 @@ void initLegend(legendObj *legend)
   legend->map = NULL;
 }
 
-void freeLegend(legendObj *legend)
-{
+void freeLegend(legendObj *legend) {
   if (legend->template)
     free(legend->template);
   freeLabel(&(legend->label));
 }
 
-int loadLegend(legendObj *legend, mapObj *map)
-{
+int loadLegend(legendObj *legend, mapObj *map) {
   legend->map = (mapObj *)map;
 
-  for(;;) {
-    switch(msyylex()) {
-      case(EOF):
-        msSetError(MS_EOFERR, NULL, "loadLegend()");
-        return(-1);
-      case(END):
-        legend->label.position = MS_XY; /* overrides go here */
-        return(0);
-        break;
-      case(IMAGECOLOR):
-        if(loadColor(&(legend->imagecolor), NULL) != MS_SUCCESS) return(-1);
-        break;
-      case(KEYSIZE):
-        if(getInteger(&(legend->keysizex), MS_NUM_CHECK_RANGE, MS_LEGEND_KEYSIZE_MIN, MS_LEGEND_KEYSIZE_MAX) == -1) return(-1);
-        if(getInteger(&(legend->keysizey), MS_NUM_CHECK_RANGE, MS_LEGEND_KEYSIZE_MIN, MS_LEGEND_KEYSIZE_MAX) == -1) return(-1);
-        break;
-      case(KEYSPACING):
-        if(getInteger(&(legend->keyspacingx), MS_NUM_CHECK_RANGE, MS_LEGEND_KEYSPACING_MIN, MS_LEGEND_KEYSPACING_MAX) == -1) return(-1);
-        if(getInteger(&(legend->keyspacingy), MS_NUM_CHECK_RANGE, MS_LEGEND_KEYSPACING_MIN, MS_LEGEND_KEYSPACING_MAX) == -1) return(-1);
-        break;
-      case(LABEL):
-        if(loadLabel(&(legend->label)) == -1) return(-1);
-        legend->label.angle = 0; /* force */
-        break;
-      case(LEGEND):
-        break; /* for string loads */
-      case(OUTLINECOLOR):
-        if(loadColor(&(legend->outlinecolor), NULL) != MS_SUCCESS) return(-1);
-        break;
-      case(POSITION):
-        if((legend->position = getSymbol(6, MS_UL,MS_UR,MS_LL,MS_LR,MS_UC,MS_LC)) == -1) return(-1);
-        break;
-      case(POSTLABELCACHE):
-        if((legend->postlabelcache = getSymbol(2, MS_TRUE,MS_FALSE)) == -1) return(-1);
-        break;
-      case(STATUS):
-        if((legend->status = getSymbol(3, MS_ON,MS_OFF,MS_EMBED)) == -1) return(-1);
-        break;
-      case(TRANSPARENT):
-        if((legend->transparent = getSymbol(2, MS_ON,MS_OFF)) == -1) return(-1);
-        break;
-      case(TEMPLATE):
-        if(getString(&legend->template) == MS_FAILURE) return(-1);
-        break;
-      default:
-        if(strlen(msyystring_buffer) > 0) {
-          msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)", "loadLegend()", msyystring_buffer, msyylineno);
-          return(-1);
-        } else {
-          return(0); /* end of a string, not an error */
-        }
+  for (;;) {
+    switch (msyylex()) {
+    case (EOF):
+      msSetError(MS_EOFERR, NULL, "loadLegend()");
+      return (-1);
+    case (END):
+      legend->label.position = MS_XY; /* overrides go here */
+      return (0);
+      break;
+    case (IMAGECOLOR):
+      if (loadColor(&(legend->imagecolor), NULL) != MS_SUCCESS)
+        return (-1);
+      break;
+    case (KEYSIZE):
+      if (getInteger(&(legend->keysizex), MS_NUM_CHECK_RANGE,
+                     MS_LEGEND_KEYSIZE_MIN, MS_LEGEND_KEYSIZE_MAX) == -1)
+        return (-1);
+      if (getInteger(&(legend->keysizey), MS_NUM_CHECK_RANGE,
+                     MS_LEGEND_KEYSIZE_MIN, MS_LEGEND_KEYSIZE_MAX) == -1)
+        return (-1);
+      break;
+    case (KEYSPACING):
+      if (getInteger(&(legend->keyspacingx), MS_NUM_CHECK_RANGE,
+                     MS_LEGEND_KEYSPACING_MIN, MS_LEGEND_KEYSPACING_MAX) == -1)
+        return (-1);
+      if (getInteger(&(legend->keyspacingy), MS_NUM_CHECK_RANGE,
+                     MS_LEGEND_KEYSPACING_MIN, MS_LEGEND_KEYSPACING_MAX) == -1)
+        return (-1);
+      break;
+    case (LABEL):
+      if (loadLabel(&(legend->label)) == -1)
+        return (-1);
+      legend->label.angle = 0; /* force */
+      break;
+    case (LEGEND):
+      break; /* for string loads */
+    case (OUTLINECOLOR):
+      if (loadColor(&(legend->outlinecolor), NULL) != MS_SUCCESS)
+        return (-1);
+      break;
+    case (POSITION):
+      if ((legend->position =
+               getSymbol(6, MS_UL, MS_UR, MS_LL, MS_LR, MS_UC, MS_LC)) == -1)
+        return (-1);
+      break;
+    case (POSTLABELCACHE):
+      if ((legend->postlabelcache = getSymbol(2, MS_TRUE, MS_FALSE)) == -1)
+        return (-1);
+      break;
+    case (STATUS):
+      if ((legend->status = getSymbol(3, MS_ON, MS_OFF, MS_EMBED)) == -1)
+        return (-1);
+      break;
+    case (TRANSPARENT):
+      if ((legend->transparent = getSymbol(2, MS_ON, MS_OFF)) == -1)
+        return (-1);
+      break;
+    case (TEMPLATE):
+      if (getString(&legend->template) == MS_FAILURE)
+        return (-1);
+      break;
+    default:
+      if (strlen(msyystring_buffer) > 0) {
+        msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)",
+                   "loadLegend()", msyystring_buffer, msyylineno);
+        return (-1);
+      } else {
+        return (0); /* end of a string, not an error */
+      }
     }
   } /* next token */
 }
 
-int msUpdateLegendFromString(legendObj *legend, char *string)
-{
-  if(!legend || !string) return MS_FAILURE;
+int msUpdateLegendFromString(legendObj *legend, char *string) {
+  if (!legend || !string)
+    return MS_FAILURE;
 
-  msAcquireLock( TLOCK_PARSER );
+  msAcquireLock(TLOCK_PARSER);
 
   msyystate = MS_TOKENIZE_STRING;
   msyystring = string;
@@ -5057,40 +5580,47 @@ int msUpdateLegendFromString(legendObj *
 
   msyylineno = 1; /* start at line 1 */
 
-  if(loadLegend(legend, legend->map) == -1) {
-    msReleaseLock( TLOCK_PARSER );
-    return MS_FAILURE; /* parse error */;
+  if (loadLegend(legend, legend->map) == -1) {
+    msReleaseLock(TLOCK_PARSER);
+    return MS_FAILURE; /* parse error */
+    ;
   }
-  msReleaseLock( TLOCK_PARSER );
+  msReleaseLock(TLOCK_PARSER);
 
   msyylex_destroy();
   return MS_SUCCESS;
 }
 
-static void writeLegend(FILE *stream, int indent, legendObj *legend)
-{
+static void writeLegend(FILE *stream, int indent, legendObj *legend) {
   colorObj c;
 
   indent++;
   writeBlockBegin(stream, indent, "LEGEND");
-  MS_INIT_COLOR(c,255,255,255,255);
+  MS_INIT_COLOR(c, 255, 255, 255, 255);
   writeColor(stream, indent, "IMAGECOLOR", &c, &(legend->imagecolor));
-  writeDimension(stream, indent, "KEYSIZE", legend->keysizex, legend->keysizey, NULL, NULL);
-  writeDimension(stream, indent, "KEYSPACING", legend->keyspacingx, legend->keyspacingy, NULL, NULL);
+  writeDimension(stream, indent, "KEYSIZE", legend->keysizex, legend->keysizey,
+                 NULL, NULL);
+  writeDimension(stream, indent, "KEYSPACING", legend->keyspacingx,
+                 legend->keyspacingy, NULL, NULL);
   writeLabel(stream, indent, &(legend->label));
   writeColor(stream, indent, "OUTLINECOLOR", NULL, &(legend->outlinecolor));
-  if(legend->status == MS_EMBED) writeKeyword(stream, indent, "POSITION", legend->position, 6, MS_LL, "LL", MS_UL, "UL", MS_UR, "UR", MS_LR, "LR", MS_UC, "UC", MS_LC, "LC");
-  writeKeyword(stream, indent, "POSTLABELCACHE", legend->postlabelcache, 1, MS_TRUE, "TRUE");
-  writeKeyword(stream, indent, "STATUS", legend->status, 3, MS_ON, "ON", MS_OFF, "OFF", MS_EMBED, "EMBED");
-  writeKeyword(stream, indent, "TRANSPARENT", legend->transparent, 2, MS_TRUE, "TRUE", MS_FALSE, "FALSE");
+  if (legend->status == MS_EMBED)
+    writeKeyword(stream, indent, "POSITION", legend->position, 6, MS_LL, "LL",
+                 MS_UL, "UL", MS_UR, "UR", MS_LR, "LR", MS_UC, "UC", MS_LC,
+                 "LC");
+  writeKeyword(stream, indent, "POSTLABELCACHE", legend->postlabelcache, 1,
+               MS_TRUE, "TRUE");
+  writeKeyword(stream, indent, "STATUS", legend->status, 3, MS_ON, "ON", MS_OFF,
+               "OFF", MS_EMBED, "EMBED");
+  writeKeyword(stream, indent, "TRANSPARENT", legend->transparent, 2, MS_TRUE,
+               "TRUE", MS_FALSE, "FALSE");
   writeString(stream, indent, "TEMPLATE", NULL, legend->template);
   writeBlockEnd(stream, indent, "LEGEND");
   writeLineFeed(stream);
 }
 
-char* msWriteLegendToString(legendObj *legend)
-{
-  msIOContext  context;
+char *msWriteLegendToString(legendObj *legend) {
+  msIOContext context;
   msIOBuffer buffer;
 
   context.label = NULL;
@@ -5101,123 +5631,147 @@ char* msWriteLegendToString(legendObj *l
   buffer.data_len = 0;
   buffer.data_offset = 0;
 
-  msIO_installHandlers( NULL, &context, NULL );
+  msIO_installHandlers(NULL, &context, NULL);
 
   writeLegend(stdout, -1, legend);
-  msIO_bufferWrite( &buffer, "", 1 );
+  msIO_bufferWrite(&buffer, "", 1);
 
-  msIO_installHandlers( NULL, NULL, NULL );
+  msIO_installHandlers(NULL, NULL, NULL);
 
-  return (char*)buffer.data;
+  return (char *)buffer.data;
 }
 
 /*
 ** Initialize, load and free a scalebarObj structure
 */
-void initScalebar(scalebarObj *scalebar)
-{
-  MS_INIT_COLOR(scalebar->imagecolor, -1,-1,-1,255);
+void initScalebar(scalebarObj *scalebar) {
+  MS_INIT_COLOR(scalebar->imagecolor, -1, -1, -1, 255);
   scalebar->width = 200;
   scalebar->height = 3;
   scalebar->style = 0; /* only 2 styles at this point */
   scalebar->intervals = 4;
   initLabel(&scalebar->label);
   scalebar->label.position = MS_XY; /* override */
-  MS_INIT_COLOR(scalebar->backgroundcolor, -1,-1,-1,255);  /* if not set, scalebar creation needs to set this to match the background color */
-  MS_INIT_COLOR(scalebar->color, 0,0,0,255); /* default to black */
-  MS_INIT_COLOR(scalebar->outlinecolor, -1,-1,-1,255);
+  MS_INIT_COLOR(scalebar->backgroundcolor, -1, -1, -1,
+                255); /* if not set, scalebar creation needs to set this to
+                         match the background color */
+  MS_INIT_COLOR(scalebar->color, 0, 0, 0, 255); /* default to black */
+  MS_INIT_COLOR(scalebar->outlinecolor, -1, -1, -1, 255);
   scalebar->units = MS_MILES;
   scalebar->status = MS_OFF;
   scalebar->position = MS_LL;
   scalebar->transparent = MS_NOOVERRIDE; /* no transparency */
-  scalebar->postlabelcache = MS_FALSE; /* draw with labels */
+  scalebar->postlabelcache = MS_FALSE;   /* draw with labels */
   scalebar->align = MS_ALIGN_CENTER;
   scalebar->offsetx = 0;
   scalebar->offsety = 0;
 }
 
-void freeScalebar(scalebarObj *scalebar)
-{
-  freeLabel(&(scalebar->label));
-}
+void freeScalebar(scalebarObj *scalebar) { freeLabel(&(scalebar->label)); }
 
-int loadScalebar(scalebarObj *scalebar)
-{
-  for(;;) {
-    switch(msyylex()) {
-      case(ALIGN):
-        if((scalebar->align = getSymbol(3, MS_ALIGN_LEFT,MS_ALIGN_CENTER,MS_ALIGN_RIGHT)) == -1) return(-1);
-        break;
-      case(BACKGROUNDCOLOR):
-        if(loadColor(&(scalebar->backgroundcolor), NULL) != MS_SUCCESS) return(-1);
-        break;
-      case(COLOR):
-        if(loadColor(&(scalebar->color), NULL) != MS_SUCCESS) return(-1);
-        break;
-      case(EOF):
-        msSetError(MS_EOFERR, NULL, "loadScalebar()");
-        return(-1);
-      case(END):
-        return(0);
-        break;
-      case(IMAGECOLOR):
-        if(loadColor(&(scalebar->imagecolor), NULL) != MS_SUCCESS) return(-1);
-        break;
-      case(INTERVALS):
-        if(getInteger(&(scalebar->intervals), MS_NUM_CHECK_RANGE, MS_SCALEBAR_INTERVALS_MIN, MS_SCALEBAR_INTERVALS_MAX) == -1) return(-1);
-        break;
-      case(LABEL):
-        if(loadLabel(&(scalebar->label)) == -1) return(-1);
-        scalebar->label.angle = 0;
-        break;
-      case(OUTLINECOLOR):
-        if(loadColor(&(scalebar->outlinecolor), NULL) != MS_SUCCESS) return(-1);
-        break;
-      case(POSITION):
-        if((scalebar->position = getSymbol(6, MS_UL,MS_UR,MS_LL,MS_LR,MS_UC,MS_LC)) == -1)
-          return(-1);
-        break;
-      case(POSTLABELCACHE):
-        if((scalebar->postlabelcache = getSymbol(2, MS_TRUE,MS_FALSE)) == -1) return(-1);
-        break;
-      case(SCALEBAR):
-        break; /* for string loads */
-      case(SIZE):
-        if(getInteger(&(scalebar->width), MS_NUM_CHECK_RANGE, MS_SCALEBAR_WIDTH_MIN, MS_SCALEBAR_WIDTH_MAX) == -1) return(-1);
-        if(getInteger(&(scalebar->height), MS_NUM_CHECK_RANGE, MS_SCALEBAR_HEIGHT_MIN, MS_SCALEBAR_HEIGHT_MAX) == -1) return(-1);
-        break;
-      case(STATUS):
-        if((scalebar->status = getSymbol(3, MS_ON,MS_OFF,MS_EMBED)) == -1) return(-1);
-        break;
-      case(STYLE):
-        if(getInteger(&(scalebar->style), MS_NUM_CHECK_RANGE, 0, 1) == -1) return(-1); // only 2 styles: 0 and 1
-        break;
-      case(TRANSPARENT):
-        if((scalebar->transparent = getSymbol(2, MS_ON,MS_OFF)) == -1) return(-1);
-        break;
-      case(UNITS):
-        if((scalebar->units = getSymbol(6, MS_INCHES,MS_FEET,MS_MILES,MS_METERS,MS_KILOMETERS,MS_NAUTICALMILES)) == -1) return(-1);
-        break;
-      case(OFFSET):
-        if(getInteger(&(scalebar->offsetx), MS_NUM_CHECK_RANGE, MS_SCALEBAR_OFFSET_MIN, MS_SCALEBAR_OFFSET_MAX) == -1) return(-1);
-        if(getInteger(&(scalebar->offsety), MS_NUM_CHECK_RANGE, MS_SCALEBAR_OFFSET_MIN, MS_SCALEBAR_OFFSET_MAX) == -1) return(-1);
-        break;
-      default:
-        if(strlen(msyystring_buffer) > 0) {
-          msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)", "loadScalebar()", msyystring_buffer, msyylineno);
-          return(-1);
-        } else {
-          return(0); /* end of a string, not an error */
-        }
+int loadScalebar(scalebarObj *scalebar) {
+  for (;;) {
+    switch (msyylex()) {
+    case (ALIGN):
+      if ((scalebar->align = getSymbol(3, MS_ALIGN_LEFT, MS_ALIGN_CENTER,
+                                       MS_ALIGN_RIGHT)) == -1)
+        return (-1);
+      break;
+    case (BACKGROUNDCOLOR):
+      if (loadColor(&(scalebar->backgroundcolor), NULL) != MS_SUCCESS)
+        return (-1);
+      break;
+    case (COLOR):
+      if (loadColor(&(scalebar->color), NULL) != MS_SUCCESS)
+        return (-1);
+      break;
+    case (EOF):
+      msSetError(MS_EOFERR, NULL, "loadScalebar()");
+      return (-1);
+    case (END):
+      return (0);
+      break;
+    case (IMAGECOLOR):
+      if (loadColor(&(scalebar->imagecolor), NULL) != MS_SUCCESS)
+        return (-1);
+      break;
+    case (INTERVALS):
+      if (getInteger(&(scalebar->intervals), MS_NUM_CHECK_RANGE,
+                     MS_SCALEBAR_INTERVALS_MIN,
+                     MS_SCALEBAR_INTERVALS_MAX) == -1)
+        return (-1);
+      break;
+    case (LABEL):
+      if (loadLabel(&(scalebar->label)) == -1)
+        return (-1);
+      scalebar->label.angle = 0;
+      break;
+    case (OUTLINECOLOR):
+      if (loadColor(&(scalebar->outlinecolor), NULL) != MS_SUCCESS)
+        return (-1);
+      break;
+    case (POSITION):
+      if ((scalebar->position =
+               getSymbol(6, MS_UL, MS_UR, MS_LL, MS_LR, MS_UC, MS_LC)) == -1)
+        return (-1);
+      break;
+    case (POSTLABELCACHE):
+      if ((scalebar->postlabelcache = getSymbol(2, MS_TRUE, MS_FALSE)) == -1)
+        return (-1);
+      break;
+    case (SCALEBAR):
+      break; /* for string loads */
+    case (SIZE):
+      if (getInteger(&(scalebar->width), MS_NUM_CHECK_RANGE,
+                     MS_SCALEBAR_WIDTH_MIN, MS_SCALEBAR_WIDTH_MAX) == -1)
+        return (-1);
+      if (getInteger(&(scalebar->height), MS_NUM_CHECK_RANGE,
+                     MS_SCALEBAR_HEIGHT_MIN, MS_SCALEBAR_HEIGHT_MAX) == -1)
+        return (-1);
+      break;
+    case (STATUS):
+      if ((scalebar->status = getSymbol(3, MS_ON, MS_OFF, MS_EMBED)) == -1)
+        return (-1);
+      break;
+    case (STYLE):
+      if (getInteger(&(scalebar->style), MS_NUM_CHECK_RANGE, 0, 1) == -1)
+        return (-1); // only 2 styles: 0 and 1
+      break;
+    case (TRANSPARENT):
+      if ((scalebar->transparent = getSymbol(2, MS_ON, MS_OFF)) == -1)
+        return (-1);
+      break;
+    case (UNITS):
+      if ((scalebar->units =
+               getSymbol(6, MS_INCHES, MS_FEET, MS_MILES, MS_METERS,
+                         MS_KILOMETERS, MS_NAUTICALMILES)) == -1)
+        return (-1);
+      break;
+    case (OFFSET):
+      if (getInteger(&(scalebar->offsetx), MS_NUM_CHECK_RANGE,
+                     MS_SCALEBAR_OFFSET_MIN, MS_SCALEBAR_OFFSET_MAX) == -1)
+        return (-1);
+      if (getInteger(&(scalebar->offsety), MS_NUM_CHECK_RANGE,
+                     MS_SCALEBAR_OFFSET_MIN, MS_SCALEBAR_OFFSET_MAX) == -1)
+        return (-1);
+      break;
+    default:
+      if (strlen(msyystring_buffer) > 0) {
+        msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)",
+                   "loadScalebar()", msyystring_buffer, msyylineno);
+        return (-1);
+      } else {
+        return (0); /* end of a string, not an error */
+      }
     }
   } /* next token */
 }
 
-int msUpdateScalebarFromString(scalebarObj *scalebar, char *string)
-{
-  if(!scalebar || !string) return MS_FAILURE;
+int msUpdateScalebarFromString(scalebarObj *scalebar, char *string) {
+  if (!scalebar || !string)
+    return MS_FAILURE;
 
-  msAcquireLock( TLOCK_PARSER );
+  msAcquireLock(TLOCK_PARSER);
 
   msyystate = MS_TOKENIZE_STRING;
   msyystring = string;
@@ -5225,44 +5779,54 @@ int msUpdateScalebarFromString(scalebarO
 
   msyylineno = 1; /* start at line 1 */
 
-  if(loadScalebar(scalebar) == -1) {
-    msReleaseLock( TLOCK_PARSER );
-    return MS_FAILURE; /* parse error */;
+  if (loadScalebar(scalebar) == -1) {
+    msReleaseLock(TLOCK_PARSER);
+    return MS_FAILURE; /* parse error */
+    ;
   }
-  msReleaseLock( TLOCK_PARSER );
+  msReleaseLock(TLOCK_PARSER);
 
   msyylex_destroy();
   return MS_SUCCESS;
 }
 
-static void writeScalebar(FILE *stream, int indent, scalebarObj *scalebar)
-{
+static void writeScalebar(FILE *stream, int indent, scalebarObj *scalebar) {
   colorObj c;
 
   indent++;
   writeBlockBegin(stream, indent, "SCALEBAR");
-  writeKeyword(stream, indent, "ALIGN", scalebar->align, 2, MS_ALIGN_LEFT, "LEFT", MS_ALIGN_RIGHT, "RIGHT");
-  writeColor(stream, indent, "BACKGROUNDCOLOR", NULL, &(scalebar->backgroundcolor));
-  MS_INIT_COLOR(c,0,0,0,255);
+  writeKeyword(stream, indent, "ALIGN", scalebar->align, 2, MS_ALIGN_LEFT,
+               "LEFT", MS_ALIGN_RIGHT, "RIGHT");
+  writeColor(stream, indent, "BACKGROUNDCOLOR", NULL,
+             &(scalebar->backgroundcolor));
+  MS_INIT_COLOR(c, 0, 0, 0, 255);
   writeColor(stream, indent, "COLOR", &c, &(scalebar->color));
   writeColor(stream, indent, "IMAGECOLOR", NULL, &(scalebar->imagecolor));
   writeNumber(stream, indent, "INTERVALS", -1, scalebar->intervals);
   writeLabel(stream, indent, &(scalebar->label));
   writeColor(stream, indent, "OUTLINECOLOR", NULL, &(scalebar->outlinecolor));
-  if(scalebar->status == MS_EMBED) writeKeyword(stream, indent, "POSITION", scalebar->position, 6, MS_LL, "LL", MS_UL, "UL", MS_UR, "UR", MS_LR, "LR", MS_UC, "UC", MS_LC, "LC");
-  writeKeyword(stream, indent, "POSTLABELCACHE", scalebar->postlabelcache, 1, MS_TRUE, "TRUE");
-  writeDimension(stream, indent, "SIZE", scalebar->width, scalebar->height, NULL, NULL);
-  writeKeyword(stream, indent, "STATUS", scalebar->status, 3, MS_ON, "ON", MS_OFF, "OFF", MS_EMBED, "EMBED");
+  if (scalebar->status == MS_EMBED)
+    writeKeyword(stream, indent, "POSITION", scalebar->position, 6, MS_LL, "LL",
+                 MS_UL, "UL", MS_UR, "UR", MS_LR, "LR", MS_UC, "UC", MS_LC,
+                 "LC");
+  writeKeyword(stream, indent, "POSTLABELCACHE", scalebar->postlabelcache, 1,
+               MS_TRUE, "TRUE");
+  writeDimension(stream, indent, "SIZE", scalebar->width, scalebar->height,
+                 NULL, NULL);
+  writeKeyword(stream, indent, "STATUS", scalebar->status, 3, MS_ON, "ON",
+               MS_OFF, "OFF", MS_EMBED, "EMBED");
   writeNumber(stream, indent, "STYLE", 0, scalebar->style);
-  writeKeyword(stream, indent, "TRANSPARENT", scalebar->transparent, 2, MS_TRUE, "TRUE", MS_FALSE, "FALSE");
-  writeKeyword(stream, indent, "UNITS", scalebar->units, 6, MS_INCHES, "INCHES", MS_FEET ,"FEET", MS_MILES, "MILES", MS_METERS, "METERS", MS_KILOMETERS, "KILOMETERS", MS_NAUTICALMILES, "NAUTICALMILES");
+  writeKeyword(stream, indent, "TRANSPARENT", scalebar->transparent, 2, MS_TRUE,
+               "TRUE", MS_FALSE, "FALSE");
+  writeKeyword(stream, indent, "UNITS", scalebar->units, 6, MS_INCHES, "INCHES",
+               MS_FEET, "FEET", MS_MILES, "MILES", MS_METERS, "METERS",
+               MS_KILOMETERS, "KILOMETERS", MS_NAUTICALMILES, "NAUTICALMILES");
   writeBlockEnd(stream, indent, "SCALEBAR");
   writeLineFeed(stream);
 }
 
-char* msWriteScalebarToString(scalebarObj *scalebar)
-{
-  msIOContext  context;
+char *msWriteScalebarToString(scalebarObj *scalebar) {
+  msIOContext context;
   msIOBuffer buffer;
 
   context.label = NULL;
@@ -5273,80 +5837,90 @@ char* msWriteScalebarToString(scalebarOb
   buffer.data_len = 0;
   buffer.data_offset = 0;
 
-  msIO_installHandlers( NULL, &context, NULL );
+  msIO_installHandlers(NULL, &context, NULL);
 
   writeScalebar(stdout, -1, scalebar);
-  msIO_bufferWrite( &buffer, "", 1 );
+  msIO_bufferWrite(&buffer, "", 1);
 
-  msIO_installHandlers( NULL, NULL, NULL );
+  msIO_installHandlers(NULL, NULL, NULL);
 
-  return (char*)buffer.data;
+  return (char *)buffer.data;
 }
 
 /*
 ** Initialize a queryMapObj structure
 */
-void initQueryMap(queryMapObj *querymap)
-{
+void initQueryMap(queryMapObj *querymap) {
   querymap->width = querymap->height = -1;
   querymap->style = MS_HILITE;
   querymap->status = MS_OFF;
-  MS_INIT_COLOR(querymap->color, 255,255,0,255); /* yellow */
+  MS_INIT_COLOR(querymap->color, 255, 255, 0, 255); /* yellow */
 }
 
-int loadQueryMap(queryMapObj *querymap, mapObj *map)
-{
+int loadQueryMap(queryMapObj *querymap, mapObj *map) {
   querymap->map = (mapObj *)map;
 
-  for(;;) {
-    switch(msyylex()) {
-      case(QUERYMAP):
-        break; /* for string loads */
-      case(COLOR):
-        if(loadColor(&(querymap->color), NULL) != MS_SUCCESS) return MS_FAILURE;
-        break;
-      case(EOF):
-        msSetError(MS_EOFERR, NULL, "loadQueryMap()");
-        return(-1);
-      case(END):
-        return(0);
-        break;
-      case(SIZE):
-        /*
-	** we do -1 (and avoid 0) here to maintain backwards compatability as older versions write "SIZE -1 -1" when saving a mapfile
-        */
-        if(getInteger(&(querymap->width), MS_NUM_CHECK_RANGE, -1, querymap->map->maxsize) == -1 || querymap->width == 0) {
-          msSetError(MS_MISCERR, "Invalid SIZE value (line %d)", "loadQueryMap()", msyylineno);
-          return(-1);
-        }
-        if(getInteger(&(querymap->height), MS_NUM_CHECK_RANGE, -1, querymap->map->maxsize) == -1 || querymap->height == 0) {
-          msSetError(MS_MISCERR, "Invalid SIZE value (line %d)", "loadQueryMap()", msyylineno);
-          return(-1);
-        }
-        break;
-      case(STATUS):
-        if((querymap->status = getSymbol(2, MS_ON,MS_OFF)) == -1) return(-1);
-        break;
-      case(STYLE):
-      case(TYPE):
-        if((querymap->style = getSymbol(3, MS_NORMAL,MS_HILITE,MS_SELECTED)) == -1) return(-1);
-        break;
-      default:
-        if(strlen(msyystring_buffer) > 0) {
-          msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)", "loadQueryMap()", msyystring_buffer, msyylineno);
-          return(-1);
-        } else {
-          return(0); /* end of a string, not an error */
-        }
+  for (;;) {
+    switch (msyylex()) {
+    case (QUERYMAP):
+      break; /* for string loads */
+    case (COLOR):
+      if (loadColor(&(querymap->color), NULL) != MS_SUCCESS)
+        return MS_FAILURE;
+      break;
+    case (EOF):
+      msSetError(MS_EOFERR, NULL, "loadQueryMap()");
+      return (-1);
+    case (END):
+      return (0);
+      break;
+    case (SIZE):
+      /*
+       ** we do -1 (and avoid 0) here to maintain backwards compatability as
+       *older versions write "SIZE -1 -1" when saving a mapfile
+       */
+      if (getInteger(&(querymap->width), MS_NUM_CHECK_RANGE, -1,
+                     querymap->map->maxsize) == -1 ||
+          querymap->width == 0) {
+        msSetError(MS_MISCERR, "Invalid SIZE value (line %d)", "loadQueryMap()",
+                   msyylineno);
+        return (-1);
+      }
+      if (getInteger(&(querymap->height), MS_NUM_CHECK_RANGE, -1,
+                     querymap->map->maxsize) == -1 ||
+          querymap->height == 0) {
+        msSetError(MS_MISCERR, "Invalid SIZE value (line %d)", "loadQueryMap()",
+                   msyylineno);
+        return (-1);
+      }
+      break;
+    case (STATUS):
+      if ((querymap->status = getSymbol(2, MS_ON, MS_OFF)) == -1)
+        return (-1);
+      break;
+    case (STYLE):
+    case (TYPE):
+      if ((querymap->style = getSymbol(3, MS_NORMAL, MS_HILITE, MS_SELECTED)) ==
+          -1)
+        return (-1);
+      break;
+    default:
+      if (strlen(msyystring_buffer) > 0) {
+        msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)",
+                   "loadQueryMap()", msyystring_buffer, msyylineno);
+        return (-1);
+      } else {
+        return (0); /* end of a string, not an error */
+      }
     }
   }
 }
 
-int msUpdateQueryMapFromString(queryMapObj *querymap, char *string)
-{
-  if(!querymap || !string) return MS_FAILURE;
+int msUpdateQueryMapFromString(queryMapObj *querymap, char *string) {
+  if (!querymap || !string)
+    return MS_FAILURE;
 
-  msAcquireLock( TLOCK_PARSER );
+  msAcquireLock(TLOCK_PARSER);
 
   msyystate = MS_TOKENIZE_STRING;
   msyystring = string;
@@ -5354,35 +5928,38 @@ int msUpdateQueryMapFromString(queryMapO
 
   msyylineno = 1; /* start at line 1 */
 
-  if(loadQueryMap(querymap, querymap->map) == -1) {
-    msReleaseLock( TLOCK_PARSER );
-    return MS_FAILURE; /* parse error */;
+  if (loadQueryMap(querymap, querymap->map) == -1) {
+    msReleaseLock(TLOCK_PARSER);
+    return MS_FAILURE; /* parse error */
+    ;
   }
-  msReleaseLock( TLOCK_PARSER );
+  msReleaseLock(TLOCK_PARSER);
 
   msyylex_destroy();
   return MS_SUCCESS;
 }
 
-static void writeQueryMap(FILE *stream, int indent, queryMapObj *querymap)
-{
+static void writeQueryMap(FILE *stream, int indent, queryMapObj *querymap) {
   colorObj c;
 
   indent++;
   writeBlockBegin(stream, indent, "QUERYMAP");
-  MS_INIT_COLOR(c,255,255,0,255);
-  writeColor(stream, indent, "COLOR",  &c, &(querymap->color));
-  if(querymap->width != -1 && querymap->height != -1) // don't write SIZE if not explicitly set
-    writeDimension(stream, indent, "SIZE", querymap->width, querymap->height, NULL, NULL);
-  writeKeyword(stream, indent, "STATUS", querymap->status, 2, MS_ON, "ON", MS_OFF, "OFF");
-  writeKeyword(stream, indent, "STYLE", querymap->style, 3, MS_NORMAL, "NORMAL", MS_HILITE, "HILITE", MS_SELECTED, "SELECTED");
+  MS_INIT_COLOR(c, 255, 255, 0, 255);
+  writeColor(stream, indent, "COLOR", &c, &(querymap->color));
+  if (querymap->width != -1 &&
+      querymap->height != -1) // don't write SIZE if not explicitly set
+    writeDimension(stream, indent, "SIZE", querymap->width, querymap->height,
+                   NULL, NULL);
+  writeKeyword(stream, indent, "STATUS", querymap->status, 2, MS_ON, "ON",
+               MS_OFF, "OFF");
+  writeKeyword(stream, indent, "STYLE", querymap->style, 3, MS_NORMAL, "NORMAL",
+               MS_HILITE, "HILITE", MS_SELECTED, "SELECTED");
   writeBlockEnd(stream, indent, "QUERYMAP");
   writeLineFeed(stream);
 }
 
-char* msWriteQueryMapToString(queryMapObj *querymap)
-{
-  msIOContext  context;
+char *msWriteQueryMapToString(queryMapObj *querymap) {
+  msIOContext context;
   msIOBuffer buffer;
 
   context.label = NULL;
@@ -5393,24 +5970,23 @@ char* msWriteQueryMapToString(queryMapOb
   buffer.data_len = 0;
   buffer.data_offset = 0;
 
-  msIO_installHandlers( NULL, &context, NULL );
+  msIO_installHandlers(NULL, &context, NULL);
 
   writeQueryMap(stdout, -1, querymap);
-  msIO_bufferWrite( &buffer, "", 1 );
+  msIO_bufferWrite(&buffer, "", 1);
 
-  msIO_installHandlers( NULL, NULL, NULL );
+  msIO_installHandlers(NULL, NULL, NULL);
 
-  return (char*)buffer.data;
+  return (char *)buffer.data;
 }
 
 /*
 ** Initialize a webObj structure
 */
-void initWeb(webObj *web)
-{
+void initWeb(webObj *web) {
   web->template = NULL;
   web->header = web->footer = NULL;
-  web->error =  web->empty = NULL;
+  web->error = web->empty = NULL;
   web->mintemplate = web->maxtemplate = NULL;
   web->minscaledenom = web->maxscaledenom = -1;
   web->imagepath = msStrdup("");
@@ -5426,8 +6002,7 @@ void initWeb(webObj *web)
   web->browseformat = msStrdup("text/html");
 }
 
-void freeWeb(webObj *web)
-{
+void freeWeb(webObj *web) {
   msFree(web->template);
   msFree(web->header);
   msFree(web->footer);
@@ -5441,12 +6016,13 @@ void freeWeb(webObj *web)
   msFree(web->queryformat);
   msFree(web->legendformat);
   msFree(web->browseformat);
-  if(&(web->metadata)) msFreeHashItems(&(web->metadata));
-  if(&(web->validation)) msFreeHashItems(&(web->validation));
+  if (&(web->metadata))
+    msFreeHashItems(&(web->metadata));
+  if (&(web->validation))
+    msFreeHashItems(&(web->validation));
 }
 
-static void writeWeb(FILE *stream, int indent, webObj *web)
-{
+static void writeWeb(FILE *stream, int indent, webObj *web) {
   indent++;
   writeBlockBegin(stream, indent, "WEB");
   writeString(stream, indent, "BROWSEFORMAT", "text/html", web->browseformat);
@@ -5470,9 +6046,8 @@ static void writeWeb(FILE *stream, int i
   writeLineFeed(stream);
 }
 
-char* msWriteWebToString(webObj *web)
-{
-  msIOContext  context;
+char *msWriteWebToString(webObj *web) {
+  msIOContext context;
   msIOBuffer buffer;
 
   context.label = NULL;
@@ -5483,103 +6058,120 @@ char* msWriteWebToString(webObj *web)
   buffer.data_len = 0;
   buffer.data_offset = 0;
 
-  msIO_installHandlers( NULL, &context, NULL );
+  msIO_installHandlers(NULL, &context, NULL);
 
   writeWeb(stdout, -1, web);
-  msIO_bufferWrite( &buffer, "", 1 );
+  msIO_bufferWrite(&buffer, "", 1);
 
-  msIO_installHandlers( NULL, NULL, NULL );
+  msIO_installHandlers(NULL, NULL, NULL);
 
-  return (char*)buffer.data;
+  return (char *)buffer.data;
 }
 
-int loadWeb(webObj *web, mapObj *map)
-{
+int loadWeb(webObj *web, mapObj *map) {
   web->map = (mapObj *)map;
 
-  for(;;) {
-    switch(msyylex()) {
-      case(BROWSEFORMAT): /* change to use validation in 6.0 */
-        free(web->browseformat);
-        web->browseformat = NULL; /* there is a default */
-        if(getString(&web->browseformat) == MS_FAILURE) return(-1);
-        break;
-      case(EMPTY):
-        if(getString(&web->empty) == MS_FAILURE) return(-1);
-        break;
-      case(WEB):
-        break; /* for string loads */
-      case(EOF):
-        msSetError(MS_EOFERR, NULL, "loadWeb()");
-        return(-1);
-      case(END):
-        return(0);
-        break;
-      case(ERROR):
-        if(getString(&web->error) == MS_FAILURE) return(-1);
-        break;
-      case(FOOTER):
-        if(getString(&web->footer) == MS_FAILURE) return(-1); /* getString() cleans up previously allocated string */
-        break;
-      case(HEADER):
-        if(getString(&web->header) == MS_FAILURE) return(-1); /* getString() cleans up previously allocated string */
-        break;
-      case(IMAGEPATH):
-        if(getString(&web->imagepath) == MS_FAILURE) return(-1);
-        break;
-      case(TEMPPATH):
-        if(getString(&web->temppath) == MS_FAILURE) return(-1);
-        break;
-      case(IMAGEURL):
-        if(getString(&web->imageurl) == MS_FAILURE) return(-1);
-        break;
-      case(LEGENDFORMAT): /* change to use validation in 6.0 */
-        free(web->legendformat);
-        web->legendformat = NULL; /* there is a default */
-        if(getString(&web->legendformat) == MS_FAILURE) return(-1);
-        break;
-      case(MAXSCALEDENOM):
-        if(getDouble(&web->maxscaledenom, MS_NUM_CHECK_GTE, 0, -1) == -1) return(-1);
-        break;
-      case(MAXTEMPLATE):
-        if(getString(&web->maxtemplate) == MS_FAILURE) return(-1);
-        break;
-      case(METADATA):
-        if(loadHashTable(&(web->metadata)) != MS_SUCCESS) return(-1);
-        break;
-      case(MINSCALEDENOM):
-        if(getDouble(&web->minscaledenom, MS_NUM_CHECK_GTE, 0, -1) == -1) return(-1);
-        break;
-      case(MINTEMPLATE):
-        if(getString(&web->mintemplate) == MS_FAILURE) return(-1);
-        break;
-      case(QUERYFORMAT): /* change to use validation in 6.0 */
-        free(web->queryformat);
-        web->queryformat = NULL; /* there is a default */
-        if(getString(&web->queryformat) == MS_FAILURE) return(-1);
-        break;
-      case(TEMPLATE):
-        if(getString(&web->template) == MS_FAILURE) return(-1); /* getString() cleans up previously allocated string */
-        break;
-      case(VALIDATION):
-        if(loadHashTable(&(web->validation)) != MS_SUCCESS) return(-1);
-        break;
-      default:
-        if(strlen(msyystring_buffer) > 0) {
-          msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)", "loadWeb()", msyystring_buffer, msyylineno);
-          return(-1);
-        } else {
-          return(0); /* end of a string, not an error */
-        }
+  for (;;) {
+    switch (msyylex()) {
+    case (BROWSEFORMAT): /* change to use validation in 6.0 */
+      free(web->browseformat);
+      web->browseformat = NULL; /* there is a default */
+      if (getString(&web->browseformat) == MS_FAILURE)
+        return (-1);
+      break;
+    case (EMPTY):
+      if (getString(&web->empty) == MS_FAILURE)
+        return (-1);
+      break;
+    case (WEB):
+      break; /* for string loads */
+    case (EOF):
+      msSetError(MS_EOFERR, NULL, "loadWeb()");
+      return (-1);
+    case (END):
+      return (0);
+      break;
+    case (ERROR):
+      if (getString(&web->error) == MS_FAILURE)
+        return (-1);
+      break;
+    case (FOOTER):
+      if (getString(&web->footer) == MS_FAILURE)
+        return (-1); /* getString() cleans up previously allocated string */
+      break;
+    case (HEADER):
+      if (getString(&web->header) == MS_FAILURE)
+        return (-1); /* getString() cleans up previously allocated string */
+      break;
+    case (IMAGEPATH):
+      if (getString(&web->imagepath) == MS_FAILURE)
+        return (-1);
+      break;
+    case (TEMPPATH):
+      if (getString(&web->temppath) == MS_FAILURE)
+        return (-1);
+      break;
+    case (IMAGEURL):
+      if (getString(&web->imageurl) == MS_FAILURE)
+        return (-1);
+      break;
+    case (LEGENDFORMAT): /* change to use validation in 6.0 */
+      free(web->legendformat);
+      web->legendformat = NULL; /* there is a default */
+      if (getString(&web->legendformat) == MS_FAILURE)
+        return (-1);
+      break;
+    case (MAXSCALEDENOM):
+      if (getDouble(&web->maxscaledenom, MS_NUM_CHECK_GTE, 0, -1) == -1)
+        return (-1);
+      break;
+    case (MAXTEMPLATE):
+      if (getString(&web->maxtemplate) == MS_FAILURE)
+        return (-1);
+      break;
+    case (METADATA):
+      if (loadHashTable(&(web->metadata)) != MS_SUCCESS)
+        return (-1);
+      break;
+    case (MINSCALEDENOM):
+      if (getDouble(&web->minscaledenom, MS_NUM_CHECK_GTE, 0, -1) == -1)
+        return (-1);
+      break;
+    case (MINTEMPLATE):
+      if (getString(&web->mintemplate) == MS_FAILURE)
+        return (-1);
+      break;
+    case (QUERYFORMAT): /* change to use validation in 6.0 */
+      free(web->queryformat);
+      web->queryformat = NULL; /* there is a default */
+      if (getString(&web->queryformat) == MS_FAILURE)
+        return (-1);
+      break;
+    case (TEMPLATE):
+      if (getString(&web->template) == MS_FAILURE)
+        return (-1); /* getString() cleans up previously allocated string */
+      break;
+    case (VALIDATION):
+      if (loadHashTable(&(web->validation)) != MS_SUCCESS)
+        return (-1);
+      break;
+    default:
+      if (strlen(msyystring_buffer) > 0) {
+        msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)",
+                   "loadWeb()", msyystring_buffer, msyylineno);
+        return (-1);
+      } else {
+        return (0); /* end of a string, not an error */
+      }
     }
   }
 }
 
-int msUpdateWebFromString(webObj *web, char *string)
-{
-  if(!web || !string) return MS_FAILURE;
+int msUpdateWebFromString(webObj *web, char *string) {
+  if (!web || !string)
+    return MS_FAILURE;
 
-  msAcquireLock( TLOCK_PARSER );
+  msAcquireLock(TLOCK_PARSER);
 
   msyystate = MS_TOKENIZE_STRING;
   msyystring = string;
@@ -5587,11 +6179,12 @@ int msUpdateWebFromString(webObj *web, c
 
   msyylineno = 1; /* start at line 1 */
 
-  if(loadWeb(web, web->map) == -1) {
-    msReleaseLock( TLOCK_PARSER );
-    return MS_FAILURE; /* parse error */;
+  if (loadWeb(web, web->map) == -1) {
+    msReleaseLock(TLOCK_PARSER);
+    return MS_FAILURE; /* parse error */
+    ;
   }
-  msReleaseLock( TLOCK_PARSER );
+  msReleaseLock(TLOCK_PARSER);
 
   msyylex_destroy();
   return MS_SUCCESS;
@@ -5604,9 +6197,8 @@ int msUpdateWebFromString(webObj *web, c
 ** lots of other init methods in this file.
 */
 
-int initMap(mapObj *map)
-{
-  int i=0;
+int initMap(mapObj *map) {
+  int i = 0;
   MS_REFCNT_INIT(map);
 
   map->debug = (int)msGetGlobalDebugLevel();
@@ -5617,14 +6209,16 @@ int initMap(mapObj *map)
   map->numlayers = 0;
   map->maxlayers = 0;
   map->layers = NULL;
-  map->layerorder = NULL; /* used to modify the order in which the layers are drawn */
+  map->layerorder =
+      NULL; /* used to modify the order in which the layers are drawn */
 
   map->status = MS_ON;
   map->name = msStrdup("MS");
-  map->extent.minx = map->extent.miny = map->extent.maxx = map->extent.maxy = -1.0;
+  map->extent.minx = map->extent.miny = map->extent.maxx = map->extent.maxy =
+      -1.0;
 
   map->scaledenom = -1.0;
-  map->resolution = MS_DEFAULT_RESOLUTION; /* pixels per inch */
+  map->resolution = MS_DEFAULT_RESOLUTION;    /* pixels per inch */
   map->defresolution = MS_DEFAULT_RESOLUTION; /* pixels per inch */
 
   map->height = map->width = -1;
@@ -5639,7 +6233,7 @@ int initMap(mapObj *map)
   map->mappath = NULL;
   map->sldurl = NULL;
 
-  MS_INIT_COLOR(map->imagecolor, 255,255,255,255); /* white */
+  MS_INIT_COLOR(map->imagecolor, 255, 255, 255, 255); /* white */
 
   map->numoutputformats = 0;
   map->outputformatlist = NULL;
@@ -5652,8 +6246,9 @@ int initMap(mapObj *map)
 
   map->palette.numcolors = 0;
 
-  for(i=0; i<MS_MAX_LABEL_PRIORITY; i++) {
-    map->labelcache.slots[i].labels = NULL; /* cache is initialize at draw time */
+  for (i = 0; i < MS_MAX_LABEL_PRIORITY; i++) {
+    map->labelcache.slots[i].labels =
+        NULL; /* cache is initialize at draw time */
     map->labelcache.slots[i].cachesize = 0;
     map->labelcache.slots[i].numlabels = 0;
     map->labelcache.slots[i].markers = NULL;
@@ -5668,7 +6263,7 @@ int initMap(mapObj *map)
   initHashTable(&(map->fontset.fonts));
 
   msInitSymbolSet(&map->symbolset);
-  map->symbolset.fontset =  &(map->fontset);
+  map->symbolset.fontset = &(map->fontset);
   map->symbolset.map = map;
 
   initLegend(&map->legend);
@@ -5679,10 +6274,10 @@ int initMap(mapObj *map)
 
   map->projContext = msProjectionContextGetFromPool();
 
-  if(msInitProjection(&(map->projection)) == -1)
-    return(-1);
-  if(msInitProjection(&(map->latlon)) == -1)
-    return(-1);
+  if (msInitProjection(&(map->projection)) == -1)
+    return (-1);
+  if (msInitProjection(&(map->latlon)) == -1)
+    return (-1);
 
   msProjectionSetContext(&(map->projection), map->projContext);
   msProjectionSetContext(&(map->latlon), map->projContext);
@@ -5690,8 +6285,10 @@ int initMap(mapObj *map)
   /* initialize a default "geographic" projection */
   map->latlon.numargs = 2;
   map->latlon.args[0] = msStrdup("proj=latlong");
-  map->latlon.args[1] = msStrdup("ellps=WGS84"); /* probably want a different ellipsoid */
-  if(msProcessProjection(&(map->latlon)) == -1) return(-1);
+  map->latlon.args[1] =
+      msStrdup("ellps=WGS84"); /* probably want a different ellipsoid */
+  if (msProcessProjection(&(map->latlon)) == -1)
+    return (-1);
 
   map->templatepattern = map->datapattern = NULL;
 
@@ -5706,7 +6303,7 @@ int initMap(mapObj *map)
 
   map->config = NULL;
 
-  return(0);
+  return (0);
 }
 
 /*
@@ -5721,8 +6318,7 @@ int initMap(mapObj *map)
 **
 ** Returns a reference to the new layerObj on success, NULL on error.
 */
-layerObj *msGrowMapLayers( mapObj *map )
-{
+layerObj *msGrowMapLayers(mapObj *map) {
   /* Do we need to increase the size of layers/layerorder by
    * MS_LAYER_ALLOCSIZE?
    */
@@ -5734,50 +6330,47 @@ layerObj *msGrowMapLayers( mapObj *map )
     newsize = map->maxlayers + MS_LAYER_ALLOCSIZE;
 
     /* Alloc/realloc layers */
-    newLayersPtr = (layerObj**)realloc(map->layers,
-                                       newsize*sizeof(layerObj*));
-    MS_CHECK_ALLOC(newLayersPtr, newsize*sizeof(layerObj*), NULL);
+    newLayersPtr =
+        (layerObj **)realloc(map->layers, newsize * sizeof(layerObj *));
+    MS_CHECK_ALLOC(newLayersPtr, newsize * sizeof(layerObj *), NULL);
 
     map->layers = newLayersPtr;
 
     /* Alloc/realloc layerorder */
-    newLayerorderPtr = (int *)realloc(map->layerorder,
-                                      newsize*sizeof(int));
-    MS_CHECK_ALLOC(newLayerorderPtr, newsize*sizeof(int), NULL);
+    newLayerorderPtr = (int *)realloc(map->layerorder, newsize * sizeof(int));
+    MS_CHECK_ALLOC(newLayerorderPtr, newsize * sizeof(int), NULL);
 
     map->layerorder = newLayerorderPtr;
 
     map->maxlayers = newsize;
-    for(i=map->numlayers; i<map->maxlayers; i++) {
+    for (i = map->numlayers; i < map->maxlayers; i++) {
       map->layers[i] = NULL;
       map->layerorder[i] = 0;
     }
   }
 
-  if (map->layers[map->numlayers]==NULL) {
-    map->layers[map->numlayers]=(layerObj*)calloc(1,sizeof(layerObj));
+  if (map->layers[map->numlayers] == NULL) {
+    map->layers[map->numlayers] = (layerObj *)calloc(1, sizeof(layerObj));
     MS_CHECK_ALLOC(map->layers[map->numlayers], sizeof(layerObj), NULL);
   }
 
   return map->layers[map->numlayers];
 }
 
-
-int msFreeLabelCacheSlot(labelCacheSlotObj *cacheslot)
-{
+int msFreeLabelCacheSlot(labelCacheSlotObj *cacheslot) {
   int i, j;
 
   /* free the labels */
   if (cacheslot->labels) {
-    for(i=0; i<cacheslot->numlabels; i++) {
+    for (i = 0; i < cacheslot->numlabels; i++) {
 
-      for(j=0; j<cacheslot->labels[i].numtextsymbols; j++) {
+      for (j = 0; j < cacheslot->labels[i].numtextsymbols; j++) {
         freeTextSymbol(cacheslot->labels[i].textsymbols[j]);
         free(cacheslot->labels[i].textsymbols[j]);
       }
       msFree(cacheslot->labels[i].textsymbols);
 
-      if(cacheslot->labels[i].leaderline) {
+      if (cacheslot->labels[i].leaderline) {
         msFree(cacheslot->labels[i].leaderline->point);
         msFree(cacheslot->labels[i].leaderline);
         msFree(cacheslot->labels[i].leaderbbox);
@@ -5794,14 +6387,13 @@ int msFreeLabelCacheSlot(labelCacheSlotO
   cacheslot->markercachesize = 0;
   cacheslot->nummarkers = 0;
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
-int msFreeLabelCache(labelCacheObj *cache)
-{
+int msFreeLabelCache(labelCacheObj *cache) {
   int p;
 
-  for(p=0; p<MS_MAX_LABEL_PRIORITY; p++) {
+  for (p = 0; p < MS_MAX_LABEL_PRIORITY; p++) {
     if (msFreeLabelCacheSlot(&(cache->slots[p])) != MS_SUCCESS)
       return MS_FAILURE;
   }
@@ -5812,32 +6404,36 @@ int msFreeLabelCache(labelCacheObj *cach
   return MS_SUCCESS;
 }
 
-int msInitLabelCacheSlot(labelCacheSlotObj *cacheslot)
-{
+int msInitLabelCacheSlot(labelCacheSlotObj *cacheslot) {
 
-  if(cacheslot->labels || cacheslot->markers)
+  if (cacheslot->labels || cacheslot->markers)
     msFreeLabelCacheSlot(cacheslot);
 
-  cacheslot->labels = (labelCacheMemberObj *)malloc(sizeof(labelCacheMemberObj)*MS_LABELCACHEINITSIZE);
-  MS_CHECK_ALLOC(cacheslot->labels, sizeof(labelCacheMemberObj)*MS_LABELCACHEINITSIZE, MS_FAILURE);
+  cacheslot->labels = (labelCacheMemberObj *)malloc(
+      sizeof(labelCacheMemberObj) * MS_LABELCACHEINITSIZE);
+  MS_CHECK_ALLOC(cacheslot->labels,
+                 sizeof(labelCacheMemberObj) * MS_LABELCACHEINITSIZE,
+                 MS_FAILURE);
 
   cacheslot->cachesize = MS_LABELCACHEINITSIZE;
   cacheslot->numlabels = 0;
 
-  cacheslot->markers = (markerCacheMemberObj *)malloc(sizeof(markerCacheMemberObj)*MS_LABELCACHEINITSIZE);
-  MS_CHECK_ALLOC(cacheslot->markers, sizeof(markerCacheMemberObj)*MS_LABELCACHEINITSIZE, MS_FAILURE);
+  cacheslot->markers = (markerCacheMemberObj *)malloc(
+      sizeof(markerCacheMemberObj) * MS_LABELCACHEINITSIZE);
+  MS_CHECK_ALLOC(cacheslot->markers,
+                 sizeof(markerCacheMemberObj) * MS_LABELCACHEINITSIZE,
+                 MS_FAILURE);
 
   cacheslot->markercachesize = MS_LABELCACHEINITSIZE;
   cacheslot->nummarkers = 0;
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
-int msInitLabelCache(labelCacheObj *cache)
-{
+int msInitLabelCache(labelCacheObj *cache) {
   int p;
 
-  for(p=0; p<MS_MAX_LABEL_PRIORITY; p++) {
+  for (p = 0; p < MS_MAX_LABEL_PRIORITY; p++) {
     if (msInitLabelCacheSlot(&(cache->slots[p])) != MS_SUCCESS)
       return MS_FAILURE;
   }
@@ -5848,8 +6444,7 @@ int msInitLabelCache(labelCacheObj *cach
   return MS_SUCCESS;
 }
 
-static void writeMap(FILE *stream, int indent, mapObj *map)
-{
+static void writeMap(FILE *stream, int indent, mapObj *map) {
   int i;
   colorObj c;
 
@@ -5860,7 +6455,7 @@ static void writeMap(FILE *stream, int i
   writeNumber(stream, indent, "DEFRESOLUTION", 72.0, map->defresolution);
   writeExtent(stream, indent, "EXTENT", map->extent);
   writeString(stream, indent, "FONTSET", NULL, map->fontset.filename);
-  MS_INIT_COLOR(c,255,255,255,255);
+  MS_INIT_COLOR(c, 255, 255, 255, 255);
   writeColor(stream, indent, "IMAGECOLOR", &c, &(map->imagecolor));
   writeString(stream, indent, "IMAGETYPE", NULL, map->imagetype);
   writeNumber(stream, indent, "MAXSIZE", MS_MAXIMAGESIZE_DEFAULT, map->maxsize);
@@ -5868,16 +6463,21 @@ static void writeMap(FILE *stream, int i
   writeNumber(stream, indent, "RESOLUTION", 72.0, map->resolution);
   writeString(stream, indent, "SHAPEPATH", NULL, map->shapepath);
   writeDimension(stream, indent, "SIZE", map->width, map->height, NULL, NULL);
-  writeKeyword(stream, indent, "STATUS", map->status, 2, MS_ON, "ON", MS_OFF, "OFF");
+  writeKeyword(stream, indent, "STATUS", map->status, 2, MS_ON, "ON", MS_OFF,
+               "OFF");
   writeString(stream, indent, "SYMBOLSET", NULL, map->symbolset.filename);
-  writeKeyword(stream, indent, "UNITS", map->units, 7, MS_INCHES, "INCHES", MS_FEET ,"FEET", MS_MILES, "MILES", MS_METERS, "METERS", MS_KILOMETERS, "KILOMETERS", MS_NAUTICALMILES, "NAUTICALMILES", MS_DD, "DD");
+  writeKeyword(stream, indent, "UNITS", map->units, 7, MS_INCHES, "INCHES",
+               MS_FEET, "FEET", MS_MILES, "MILES", MS_METERS, "METERS",
+               MS_KILOMETERS, "KILOMETERS", MS_NAUTICALMILES, "NAUTICALMILES",
+               MS_DD, "DD");
   writeLineFeed(stream);
 
   writeOutputformat(stream, indent, map);
 
   /* write symbol with INLINE tag in mapfile */
-  for(i=0; i<map->symbolset.numsymbols; i++) {
-    if(map->symbolset.symbol[i]->inmapfile) writeSymbol(map->symbolset.symbol[i], stream);
+  for (i = 0; i < map->symbolset.numsymbols; i++) {
+    if (map->symbolset.symbol[i]->inmapfile)
+      writeSymbol(map->symbolset.symbol[i], stream);
   }
 
   writeProjection(stream, indent, &(map->projection));
@@ -5888,15 +6488,14 @@ static void writeMap(FILE *stream, int i
   writeScalebar(stream, indent, &(map->scalebar));
   writeWeb(stream, indent, &(map->web));
 
-  for(i=0; i<map->numlayers; i++)
+  for (i = 0; i < map->numlayers; i++)
     writeLayer(stream, indent, GET_LAYER(map, map->layerorder[i]));
 
   writeBlockEnd(stream, indent, "MAP");
 }
 
-char* msWriteMapToString(mapObj *map)
-{
-  msIOContext  context;
+char *msWriteMapToString(mapObj *map) {
+  msIOContext context;
   msIOBuffer buffer;
 
   context.label = NULL;
@@ -5907,294 +6506,333 @@ char* msWriteMapToString(mapObj *map)
   buffer.data_len = 0;
   buffer.data_offset = 0;
 
-  msIO_installHandlers( NULL, &context, NULL );
+  msIO_installHandlers(NULL, &context, NULL);
 
   writeMap(stdout, 0, map);
-  msIO_bufferWrite( &buffer, "", 1 );
+  msIO_bufferWrite(&buffer, "", 1);
 
-  msIO_installHandlers( NULL, NULL, NULL );
+  msIO_installHandlers(NULL, NULL, NULL);
 
-  return (char*)buffer.data;
+  return (char *)buffer.data;
 }
 
-int msSaveMap(mapObj *map, char *filename)
-{
+int msSaveMap(mapObj *map, char *filename) {
   FILE *stream;
   char szPath[MS_MAXPATHLEN];
 
-  if(!map) {
+  if (!map) {
     msSetError(MS_MISCERR, "Map is undefined.", "msSaveMap()");
-    return(-1);
+    return (-1);
   }
 
-  if(!filename) {
+  if (!filename) {
     msSetError(MS_MISCERR, "Filename is undefined.", "msSaveMap()");
-    return(-1);
+    return (-1);
   }
 
   stream = fopen(msBuildPath(szPath, map->mappath, filename), "w");
-  if(!stream) {
+  if (!stream) {
     msSetError(MS_IOERR, "(%s)", "msSaveMap()", filename);
-    return(-1);
+    return (-1);
   }
 
   writeMap(stream, 0, map);
   fclose(stream);
 
-  return(0);
+  return (0);
 }
 
-static void writeConfig(FILE *stream, int indent, configObj *config)
-{
+static void writeConfig(FILE *stream, int indent, configObj *config) {
   writeBlockBegin(stream, indent, "CONFIG");
   writeHashTable(stream, indent, "ENV", &(config->env));
   writeHashTable(stream, indent, "MAPS", &(config->maps));
   writeBlockEnd(stream, indent, "CONFIG");
 }
 
-int msSaveConfig(configObj *config, const char *filename)
-{
+int msSaveConfig(configObj *config, const char *filename) {
   FILE *stream;
 
-  if(!config) {
+  if (!config) {
     msSetError(MS_MISCERR, "Config is undefined.", "msSaveConfigMap()");
-    return(-1);
+    return (-1);
   }
 
-  if(!filename) {
+  if (!filename) {
     msSetError(MS_MISCERR, "Filename is undefined.", "msSaveConfigMap()");
-    return(-1);
+    return (-1);
   }
 
   stream = fopen(filename, "w");
-  if(!stream) {
+  if (!stream) {
     msSetError(MS_IOERR, "(%s)", "msSaveConfig()", filename);
-    return(-1);
+    return (-1);
   }
 
-  writeConfig(stream,0,config);
+  writeConfig(stream, 0, config);
   fclose(stream);
 
-  return(0);
+  return (0);
 }
 
-static int loadMapInternal(mapObj *map)
-{
-  int foundMapToken=MS_FALSE;
+static int loadMapInternal(mapObj *map) {
+  int foundMapToken = MS_FALSE;
   int foundBomToken = MS_FALSE;
   int token;
 
-  for(;;) {
+  for (;;) {
 
     token = msyylex();
 
-    if(!foundBomToken && token == BOM) {
+    if (!foundBomToken && token == BOM) {
       foundBomToken = MS_TRUE;
-      if(!foundMapToken) {
+      if (!foundMapToken) {
         continue; /*skip a leading bom*/
       }
     }
-    if(!foundMapToken && token != MAP) {
-      msSetError(MS_IDENTERR, "First token must be MAP, this doesn't look like a mapfile.", "msLoadMap()");
-      return(MS_FAILURE);
+    if (!foundMapToken && token != MAP) {
+      msSetError(MS_IDENTERR,
+                 "First token must be MAP, this doesn't look like a mapfile.",
+                 "msLoadMap()");
+      return (MS_FAILURE);
     }
 
-    switch(token) {
+    switch (token) {
 
-      case(CONFIG): {
-        char *key=NULL, *value=NULL;
+    case (CONFIG): {
+      char *key = NULL, *value = NULL;
 
-        if( getString(&key) == MS_FAILURE )
-          return MS_FAILURE;
+      if (getString(&key) == MS_FAILURE)
+        return MS_FAILURE;
 
-        if( getString(&value) == MS_FAILURE ) {
-          free(key);
-          return MS_FAILURE;
-        }
+      if (getString(&value) == MS_FAILURE) {
+        free(key);
+        return MS_FAILURE;
+      }
 
-        if (msSetConfigOption( map, key, value ) == MS_FAILURE) {
-          free(key);
-          free(value);
-          return MS_FAILURE;
-        }
+      if (msSetConfigOption(map, key, value) == MS_FAILURE) {
+        free(key);
+        free(value);
+        return MS_FAILURE;
+      }
 
-        free( key );
-        free( value );
+      free(key);
+      free(value);
+    } break;
+    case (DEBUG):
+      if ((map->debug = getSymbol(3, MS_ON, MS_OFF, MS_NUMBER)) == -1)
+        return MS_FAILURE;
+      if (map->debug == MS_NUMBER) {
+        if (msCheckNumber(msyynumber, MS_NUM_CHECK_RANGE, 0, 5) == MS_FAILURE) {
+          msSetError(MS_MISCERR,
+                     "Invalid DEBUG level, must be between 0 and 5 (line %d)",
+                     "msLoadMap()", msyylineno);
+          return (-1);
+        }
+        map->debug = (int)msyynumber;
       }
       break;
-      case(DEBUG):
-        if((map->debug = getSymbol(3, MS_ON,MS_OFF, MS_NUMBER)) == -1) return MS_FAILURE;
-        if(map->debug == MS_NUMBER) {
-          if(msCheckNumber(msyynumber, MS_NUM_CHECK_RANGE, 0, 5) == MS_FAILURE) {
-            msSetError(MS_MISCERR, "Invalid DEBUG level, must be between 0 and 5 (line %d)", "msLoadMap()", msyylineno);
-            return(-1);
-          }
-          map->debug = (int) msyynumber;
-        }
-        break;
-      case(END):
-        if(msyyin) {
-          fclose(msyyin);
-          msyyin = NULL;
-        }
-
-        /*** Make config options current ***/
-        msApplyMapConfigOptions( map );
+    case (END):
+      if (msyyin) {
+        fclose(msyyin);
+        msyyin = NULL;
+      }
 
-        /*** Compute rotated extent info if applicable ***/
-        msMapComputeGeotransform( map );
+      /*** Make config options current ***/
+      msApplyMapConfigOptions(map);
 
-        /*** OUTPUTFORMAT related setup ***/
-        if( msPostMapParseOutputFormatSetup( map ) == MS_FAILURE )
-          return MS_FAILURE;
+      /*** Compute rotated extent info if applicable ***/
+      msMapComputeGeotransform(map);
 
-        if(loadSymbolSet(&(map->symbolset), map) == -1) return MS_FAILURE;
+      /*** OUTPUTFORMAT related setup ***/
+      if (msPostMapParseOutputFormatSetup(map) == MS_FAILURE)
+        return MS_FAILURE;
 
-        if (resolveSymbolNames(map) == MS_FAILURE) return MS_FAILURE;
+      if (loadSymbolSet(&(map->symbolset), map) == -1)
+        return MS_FAILURE;
 
+      if (resolveSymbolNames(map) == MS_FAILURE)
+        return MS_FAILURE;
 
-        if(msLoadFontSet(&(map->fontset), map) == -1) return MS_FAILURE;
+      if (msLoadFontSet(&(map->fontset), map) == -1)
+        return MS_FAILURE;
 
-        return MS_SUCCESS;
-        break;
-      case(EOF):
-        msSetError(MS_EOFERR, NULL, "msLoadMap()");
+      return MS_SUCCESS;
+      break;
+    case (EOF):
+      msSetError(MS_EOFERR, NULL, "msLoadMap()");
+      return MS_FAILURE;
+    case (EXTENT): {
+      if (getDouble(&(map->extent.minx), MS_NUM_CHECK_NONE, -1, -1) == -1)
+        return MS_FAILURE;
+      if (getDouble(&(map->extent.miny), MS_NUM_CHECK_NONE, -1, -1) == -1)
+        return MS_FAILURE;
+      if (getDouble(&(map->extent.maxx), MS_NUM_CHECK_NONE, -1, -1) == -1)
+        return MS_FAILURE;
+      if (getDouble(&(map->extent.maxy), MS_NUM_CHECK_NONE, -1, -1) == -1)
+        return MS_FAILURE;
+      if (!MS_VALID_EXTENT(map->extent)) {
+        msSetError(MS_MISCERR,
+                   "Given map extent is invalid. Check that it "
+                   "is in the form: minx, miny, maxx, maxy",
+                   "loadMapInternal()");
         return MS_FAILURE;
-      case(EXTENT): {
-        if(getDouble(&(map->extent.minx), MS_NUM_CHECK_NONE, -1, -1) == -1) return MS_FAILURE;
-        if(getDouble(&(map->extent.miny), MS_NUM_CHECK_NONE, -1, -1) == -1) return MS_FAILURE;
-        if(getDouble(&(map->extent.maxx), MS_NUM_CHECK_NONE, -1, -1) == -1) return MS_FAILURE;
-        if(getDouble(&(map->extent.maxy), MS_NUM_CHECK_NONE, -1, -1) == -1) return MS_FAILURE;
-        if (!MS_VALID_EXTENT(map->extent)) {
-          msSetError(MS_MISCERR, "Given map extent is invalid. Check that it " \
-                     "is in the form: minx, miny, maxx, maxy", "loadMapInternal()");
-          return MS_FAILURE;
-        }
       }
+    } break;
+    case (ANGLE): {
+      double rotation_angle;
+      if (getDouble(&(rotation_angle), MS_NUM_CHECK_RANGE, -360, 360) == -1)
+        return MS_FAILURE;
+      msMapSetRotation(map, rotation_angle);
+    } break;
+    case (FONTSET):
+      if (getString(&map->fontset.filename) == MS_FAILURE)
+        return MS_FAILURE;
+      break;
+    case (IMAGECOLOR):
+      if (loadColor(&(map->imagecolor), NULL) != MS_SUCCESS)
+        return MS_FAILURE;
+      break;
+    case (IMAGETYPE):
+      msFree(map->imagetype);
+      map->imagetype = getToken();
+      break;
+    case (LATLON):
+      if (loadProjection(&map->latlon) == -1)
+        return MS_FAILURE;
+      break;
+    case (LAYER):
+      if (msGrowMapLayers(map) == NULL)
+        return MS_FAILURE;
+      if (initLayer((GET_LAYER(map, map->numlayers)), map) == -1)
+        return MS_FAILURE;
+      if (loadLayer((GET_LAYER(map, map->numlayers)), map) == -1)
+        return MS_FAILURE;
+      GET_LAYER(map, map->numlayers)->index =
+          map->numlayers; /* save the index */
+      /* Update the layer order list with the layer's index. */
+      map->layerorder[map->numlayers] = map->numlayers;
+      map->numlayers++;
+      break;
+    case (OUTPUTFORMAT):
+      if (loadOutputFormat(map) == -1)
+        return MS_FAILURE;
+      break;
+    case (LEGEND):
+      if (loadLegend(&(map->legend), map) == -1)
+        return MS_FAILURE;
+      break;
+    case (MAP):
+      foundMapToken = MS_TRUE;
+      break;
+    case (MAXSIZE):
+      if (getInteger(&(map->maxsize), MS_NUM_CHECK_GT, 0, -1) == -1)
+        return MS_FAILURE;
+      break;
+    case (NAME):
+      free(map->name);
+      map->name = NULL; /* erase default */
+      if (getString(&map->name) == MS_FAILURE)
+        return MS_FAILURE;
+      break;
+    case (PROJECTION):
+      if (loadProjection(&map->projection) == -1)
+        return MS_FAILURE;
+      break;
+    case (QUERYMAP):
+      if (loadQueryMap(&(map->querymap), map) == -1)
+        return MS_FAILURE;
+      break;
+    case (REFERENCE):
+      if (loadReferenceMap(&(map->reference), map) == -1)
+        return MS_FAILURE;
+      break;
+    case (RESOLUTION):
+      if (getDouble(&(map->resolution), MS_NUM_CHECK_RANGE, MS_RESOLUTION_MIN,
+                    MS_RESOLUTION_MAX) == -1)
+        return MS_FAILURE;
+      break;
+    case (DEFRESOLUTION):
+      if (getDouble(&(map->defresolution), MS_NUM_CHECK_RANGE,
+                    MS_RESOLUTION_MIN, MS_RESOLUTION_MAX) == -1)
+        return MS_FAILURE;
+      break;
+    case (SCALE):
+    case (SCALEDENOM):
+      if (getDouble(&(map->scaledenom), MS_NUM_CHECK_GTE, 1, -1) == -1)
+        return MS_FAILURE;
+      break;
+    case (SCALEBAR):
+      if (loadScalebar(&(map->scalebar)) == -1)
+        return MS_FAILURE;
+      break;
+    case (SHAPEPATH):
+      if (getString(&map->shapepath) == MS_FAILURE)
+        return MS_FAILURE;
+      break;
+    case (SIZE):
+      if (getInteger(&(map->width), MS_NUM_CHECK_RANGE, 1, map->maxsize) == -1)
+        return MS_FAILURE;
+      if (getInteger(&(map->height), MS_NUM_CHECK_RANGE, 1, map->maxsize) == -1)
+        return MS_FAILURE;
+      break;
+    case (STATUS):
+      if ((map->status = getSymbol(2, MS_ON, MS_OFF)) == -1)
+        return MS_FAILURE;
       break;
-      case(ANGLE): {
-        double rotation_angle;
-        if(getDouble(&(rotation_angle), MS_NUM_CHECK_RANGE, -360, 360) == -1) return MS_FAILURE;
-        msMapSetRotation( map, rotation_angle );
+    case (SYMBOL):
+      if (msGrowSymbolSet(&(map->symbolset)) == NULL)
+        return MS_FAILURE;
+      if ((loadSymbol(map->symbolset.symbol[map->symbolset.numsymbols],
+                      map->mappath) == -1)) {
+        msFreeSymbol(map->symbolset.symbol[map->symbolset.numsymbols]);
+        free(map->symbolset.symbol[map->symbolset.numsymbols]);
+        map->symbolset.symbol[map->symbolset.numsymbols] = NULL;
+        return MS_FAILURE;
       }
+      map->symbolset.symbol[map->symbolset.numsymbols]->inmapfile = MS_TRUE;
+      map->symbolset.numsymbols++;
       break;
-      case(FONTSET):
-        if(getString(&map->fontset.filename) == MS_FAILURE) return MS_FAILURE;
-        break;
-      case(IMAGECOLOR):
-        if(loadColor(&(map->imagecolor), NULL) != MS_SUCCESS) return MS_FAILURE;
-        break;
-      case(IMAGETYPE):
-        msFree(map->imagetype);
-        map->imagetype = getToken();
-        break;
-      case(LATLON):
-        if(loadProjection(&map->latlon) == -1) return MS_FAILURE;
-        break;
-      case(LAYER):
-        if(msGrowMapLayers(map) == NULL)
-          return MS_FAILURE;
-        if(initLayer((GET_LAYER(map, map->numlayers)), map) == -1) return MS_FAILURE;
-        if(loadLayer((GET_LAYER(map, map->numlayers)), map) == -1) return MS_FAILURE;
-        GET_LAYER(map, map->numlayers)->index = map->numlayers; /* save the index */
-        /* Update the layer order list with the layer's index. */
-        map->layerorder[map->numlayers] = map->numlayers;
-        map->numlayers++;
-        break;
-      case(OUTPUTFORMAT):
-        if(loadOutputFormat(map) == -1) return MS_FAILURE;
-        break;
-      case(LEGEND):
-        if(loadLegend(&(map->legend), map) == -1) return MS_FAILURE;
-        break;
-      case(MAP):
-        foundMapToken = MS_TRUE;
-        break;
-      case(MAXSIZE):
-        if(getInteger(&(map->maxsize), MS_NUM_CHECK_GT, 0, -1) == -1) return MS_FAILURE;
-        break;
-      case(NAME):
-        free(map->name);
-        map->name = NULL; /* erase default */
-        if(getString(&map->name) == MS_FAILURE) return MS_FAILURE;
-        break;
-      case(PROJECTION):
-        if(loadProjection(&map->projection) == -1) return MS_FAILURE;
-        break;
-      case(QUERYMAP):
-        if(loadQueryMap(&(map->querymap), map) == -1) return MS_FAILURE;
-        break;
-      case(REFERENCE):
-        if(loadReferenceMap(&(map->reference), map) == -1) return MS_FAILURE;
-        break;
-      case(RESOLUTION):
-        if(getDouble(&(map->resolution), MS_NUM_CHECK_RANGE, MS_RESOLUTION_MIN, MS_RESOLUTION_MAX) == -1) return MS_FAILURE;
-        break;
-      case(DEFRESOLUTION):
-        if(getDouble(&(map->defresolution), MS_NUM_CHECK_RANGE, MS_RESOLUTION_MIN, MS_RESOLUTION_MAX) == -1) return MS_FAILURE;
-        break;
-      case(SCALE):
-      case(SCALEDENOM):
-        if(getDouble(&(map->scaledenom), MS_NUM_CHECK_GTE, 1, -1) == -1) return MS_FAILURE;
-        break;
-      case(SCALEBAR):
-        if(loadScalebar(&(map->scalebar)) == -1) return MS_FAILURE;
-        break;
-      case(SHAPEPATH):
-        if(getString(&map->shapepath) == MS_FAILURE) return MS_FAILURE;
-        break;
-      case(SIZE):
-        if(getInteger(&(map->width), MS_NUM_CHECK_RANGE, 1, map->maxsize) == -1) return MS_FAILURE;
-        if(getInteger(&(map->height), MS_NUM_CHECK_RANGE, 1, map->maxsize) == -1) return MS_FAILURE;
-        break;
-      case(STATUS):
-        if((map->status = getSymbol(2, MS_ON,MS_OFF)) == -1) return MS_FAILURE;
-        break;
-      case(SYMBOL):
-        if(msGrowSymbolSet(&(map->symbolset)) == NULL)
-          return MS_FAILURE;
-        if((loadSymbol(map->symbolset.symbol[map->symbolset.numsymbols], map->mappath) == -1)) {
-            msFreeSymbol(map->symbolset.symbol[map->symbolset.numsymbols]);
-            free(map->symbolset.symbol[map->symbolset.numsymbols]);
-            map->symbolset.symbol[map->symbolset.numsymbols] = NULL;
-            return MS_FAILURE;
-        }
-        map->symbolset.symbol[map->symbolset.numsymbols]->inmapfile = MS_TRUE;
-        map->symbolset.numsymbols++;
-        break;
-      case(SYMBOLSET):
-        if(getString(&map->symbolset.filename) == MS_FAILURE) return MS_FAILURE;
-        break;
-      case(UNITS):
-        if((int)(map->units = getSymbol(7, MS_INCHES,MS_FEET,MS_MILES,MS_METERS,MS_KILOMETERS,MS_NAUTICALMILES,MS_DD)) == -1) return MS_FAILURE;
-        break;
-      case(WEB):
-        if(loadWeb(&(map->web), map) == -1) return MS_FAILURE;
-        break;
-      default:
-        msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)", "msLoadMap()", msyystring_buffer, msyylineno);
+    case (SYMBOLSET):
+      if (getString(&map->symbolset.filename) == MS_FAILURE)
+        return MS_FAILURE;
+      break;
+    case (UNITS):
+      if ((int)(map->units =
+                    getSymbol(7, MS_INCHES, MS_FEET, MS_MILES, MS_METERS,
+                              MS_KILOMETERS, MS_NAUTICALMILES, MS_DD)) == -1)
         return MS_FAILURE;
+      break;
+    case (WEB):
+      if (loadWeb(&(map->web), map) == -1)
+        return MS_FAILURE;
+      break;
+    default:
+      msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)",
+                 "msLoadMap()", msyystring_buffer, msyylineno);
+      return MS_FAILURE;
     }
   } /* next token */
 }
 
-static bool msGetCWD(char* szBuffer, size_t nBufferSize, const char* pszFunctionName)
-{
-  if(NULL == getcwd(szBuffer, nBufferSize)) {
+static bool msGetCWD(char *szBuffer, size_t nBufferSize,
+                     const char *pszFunctionName) {
+  if (NULL == getcwd(szBuffer, nBufferSize)) {
 #ifndef _WIN32
-    if( errno == EACCES )
-        msSetError(MS_MISCERR,
-                   "getcwd() failed with EACCES: you may need to force the "
-                   "current directory in the mapserver launcher "
-                   "(e.g -d option of spawn-fcgi)", pszFunctionName);
-    else if( errno == ENAMETOOLONG )
-        msSetError(MS_MISCERR, "getcwd() returned a too long path",
-                   pszFunctionName);
+    if (errno == EACCES)
+      msSetError(MS_MISCERR,
+                 "getcwd() failed with EACCES: you may need to force the "
+                 "current directory in the mapserver launcher "
+                 "(e.g -d option of spawn-fcgi)",
+                 pszFunctionName);
+    else if (errno == ENAMETOOLONG)
+      msSetError(MS_MISCERR, "getcwd() returned a too long path",
+                 pszFunctionName);
     else
-        msSetError(MS_MISCERR, "getcwd() failed with errno code %d",
-                   pszFunctionName, errno);
+      msSetError(MS_MISCERR, "getcwd() failed with errno code %d",
+                 pszFunctionName, errno);
 #else
-    msSetError(MS_MISCERR, "getcwd() returned a too long path", pszFunctionName);
+    msSetError(MS_MISCERR, "getcwd() returned a too long path",
+               pszFunctionName);
 #endif
     return FALSE;
   }
@@ -6202,14 +6840,15 @@ static bool msGetCWD(char* szBuffer, siz
 }
 
 /*
-** Sets up string-based mapfile loading and calls loadMapInternal to do the work.
+** Sets up string-based mapfile loading and calls loadMapInternal to do the
+*work.
 */
-mapObj *msLoadMapFromString(char *buffer, char *new_mappath, const configObj *config)
-{
+mapObj *msLoadMapFromString(char *buffer, char *new_mappath,
+                            const configObj *config) {
   mapObj *map;
   struct mstimeval starttime = {0}, endtime = {0};
   char szPath[MS_MAXPATHLEN], szCWDPath[MS_MAXPATHLEN];
-  char *mappath=NULL;
+  char *mappath = NULL;
   int debuglevel;
 
   debuglevel = (int)msGetGlobalDebugLevel();
@@ -6219,25 +6858,26 @@ mapObj *msLoadMapFromString(char *buffer
     msGettimeofday(&starttime, NULL);
   }
 
-  if(!buffer) {
+  if (!buffer) {
     msSetError(MS_MISCERR, "No buffer to load.", "msLoadMapFromString()");
-    return(NULL);
+    return (NULL);
   }
 
   /*
   ** Allocate mapObj structure
   */
-  map = (mapObj *)calloc(sizeof(mapObj),1);
+  map = (mapObj *)calloc(sizeof(mapObj), 1);
   MS_CHECK_ALLOC(map, sizeof(mapObj), NULL);
 
-  if(initMap(map) == -1) { /* initialize this map */
+  if (initMap(map) == -1) { /* initialize this map */
     msFreeMap(map);
-    return(NULL);
+    return (NULL);
   }
 
   map->config = config; // create a read-only reference
-  
-  msAcquireLock( TLOCK_PARSER ); /* might need to move this lock a bit higher, yup (bug 2108) */
+
+  msAcquireLock(TLOCK_PARSER); /* might need to move this lock a bit higher, yup
+                                  (bug 2108) */
 
   msyystate = MS_TOKENIZE_STRING;
   msyystring = buffer;
@@ -6246,9 +6886,9 @@ mapObj *msLoadMapFromString(char *buffer
   msyylineno = 1; /* start at line 1 (do lines mean anything here?) */
 
   /* If new_mappath is provided then use it, otherwise use the CWD */
-  if(!msGetCWD(szCWDPath, MS_MAXPATHLEN, "msLoadMapFromString()")) {
+  if (!msGetCWD(szCWDPath, MS_MAXPATHLEN, "msLoadMapFromString()")) {
     msFreeMap(map);
-    msReleaseLock( TLOCK_PARSER );
+    msReleaseLock(TLOCK_PARSER);
   }
   if (new_mappath) {
     mappath = msStrdup(new_mappath);
@@ -6258,27 +6898,30 @@ mapObj *msLoadMapFromString(char *buffer
 
   msyybasepath = map->mappath; /* for INCLUDEs */
 
-  if(loadMapInternal(map) != MS_SUCCESS) {
+  if (loadMapInternal(map) != MS_SUCCESS) {
     msFreeMap(map);
-    msReleaseLock( TLOCK_PARSER );
-    if(mappath != NULL) free(mappath);
+    msReleaseLock(TLOCK_PARSER);
+    if (mappath != NULL)
+      free(mappath);
     return NULL;
   }
 
-  if (mappath != NULL) free(mappath);
+  if (mappath != NULL)
+    free(mappath);
   msyylex_destroy();
 
-  msReleaseLock( TLOCK_PARSER );
+  msReleaseLock(TLOCK_PARSER);
 
   if (debuglevel >= MS_DEBUGLEVEL_TUNING) {
     /* In debug mode, report time spent loading/parsing mapfile. */
     msGettimeofday(&endtime, NULL);
     msDebug("msLoadMap(): %.3fs\n",
-            (endtime.tv_sec+endtime.tv_usec/1.0e6)-
-            (starttime.tv_sec+starttime.tv_usec/1.0e6) );
+            (endtime.tv_sec + endtime.tv_usec / 1.0e6) -
+                (starttime.tv_sec + starttime.tv_usec / 1.0e6));
   }
 
-  if (resolveSymbolNames(map) == MS_FAILURE) return NULL;
+  if (resolveSymbolNames(map) == MS_FAILURE)
+    return NULL;
 
   return map;
 }
@@ -6286,10 +6929,10 @@ mapObj *msLoadMapFromString(char *buffer
 /*
 ** Sets up file-based mapfile loading and calls loadMapInternal to do the work.
 */
-mapObj *msLoadMap(const char *filename, const char *new_mappath, const configObj *config)
-{
+mapObj *msLoadMap(const char *filename, const char *new_mappath,
+                  const configObj *config) {
   mapObj *map;
-  struct mstimeval starttime={0}, endtime={0};
+  struct mstimeval starttime = {0}, endtime = {0};
   char szPath[MS_MAXPATHLEN], szCWDPath[MS_MAXPATHLEN];
   int debuglevel;
 
@@ -6300,57 +6943,62 @@ mapObj *msLoadMap(const char *filename,
     msGettimeofday(&starttime, NULL);
   }
 
-  if(!filename) {
+  if (!filename) {
     msSetError(MS_MISCERR, "Filename is undefined.", "msLoadMap()");
-    return(NULL);
+    return (NULL);
   }
 
-  const char *ms_mapfile_pattern = CPLGetConfigOption("MS_MAPFILE_PATTERN", MS_DEFAULT_MAPFILE_PATTERN);
-  if(msEvalRegex(ms_mapfile_pattern, filename) != MS_TRUE) {
-    msSetError(MS_REGEXERR, "Filename validation failed." , "msLoadMap()");
-    return(NULL);
+  const char *ms_mapfile_pattern =
+      CPLGetConfigOption("MS_MAPFILE_PATTERN", MS_DEFAULT_MAPFILE_PATTERN);
+  if (msEvalRegex(ms_mapfile_pattern, filename) != MS_TRUE) {
+    msSetError(MS_REGEXERR, "Filename validation failed.", "msLoadMap()");
+    return (NULL);
   }
 
   /*
   ** Allocate mapObj structure
   */
-  map = (mapObj *)calloc(sizeof(mapObj),1);
+  map = (mapObj *)calloc(sizeof(mapObj), 1);
   MS_CHECK_ALLOC(map, sizeof(mapObj), NULL);
 
-  if(initMap(map) == -1) { /* initialize this map */
+  if (initMap(map) == -1) { /* initialize this map */
     msFreeMap(map);
-    return(NULL);
+    return (NULL);
   }
 
   map->config = config; // create a read-only reference
 
-  msAcquireLock( TLOCK_PARSER );  /* Steve: might need to move this lock a bit higher; Umberto: done */
+  msAcquireLock(TLOCK_PARSER); /* Steve: might need to move this lock a bit
+                                  higher; Umberto: done */
 
 #ifdef USE_XMLMAPFILE
   /* If the mapfile is an xml mapfile, transform it */
-  const char *ms_xmlmapfile_xslt = CPLGetConfigOption("MS_XMLMAPFILE_XSLT", NULL);
+  const char *ms_xmlmapfile_xslt =
+      CPLGetConfigOption("MS_XMLMAPFILE_XSLT", NULL);
   if (ms_xmlmapfile_xslt &&
       (msEvalRegex(MS_DEFAULT_XMLMAPFILE_PATTERN, filename) == MS_TRUE)) {
 
     msyyin = tmpfile();
     if (msyyin == NULL) {
-      msSetError(MS_IOERR, "tmpfile() failed to create temporary file", "msLoadMap()");
-      msReleaseLock( TLOCK_PARSER );
+      msSetError(MS_IOERR, "tmpfile() failed to create temporary file",
+                 "msLoadMap()");
+      msReleaseLock(TLOCK_PARSER);
       msFreeMap(map);
       return NULL;
     }
 
-    if (msTransformXmlMapfile(ms_xmlmapfile_xslt, filename, msyyin) != MS_SUCCESS) {
+    if (msTransformXmlMapfile(ms_xmlmapfile_xslt, filename, msyyin) !=
+        MS_SUCCESS) {
       fclose(msyyin);
       msFreeMap(map);
       return NULL;
     }
-    fseek ( msyyin , 0 , SEEK_SET );
+    fseek(msyyin, 0, SEEK_SET);
   } else {
 #endif
-    if((msyyin = fopen(filename,"r")) == NULL) {
+    if ((msyyin = fopen(filename, "r")) == NULL) {
       msSetError(MS_IOERR, "(%s)", "msLoadMap()", filename);
-      msReleaseLock( TLOCK_PARSER );
+      msReleaseLock(TLOCK_PARSER);
       msFreeMap(map);
       return NULL;
     }
@@ -6366,8 +7014,8 @@ mapObj *msLoadMap(const char *filename,
 
   /* If new_mappath is provided then use it, otherwise use the location */
   /* of the mapfile as the default path */
-  if(!msGetCWD(szCWDPath, MS_MAXPATHLEN, "msLoadMap()")) {
-    msReleaseLock( TLOCK_PARSER );
+  if (!msGetCWD(szCWDPath, MS_MAXPATHLEN, "msLoadMap()")) {
+    msReleaseLock(TLOCK_PARSER);
     msFreeMap(map);
     return NULL;
   }
@@ -6377,41 +7025,42 @@ mapObj *msLoadMap(const char *filename,
   else {
     char *path = msGetPath(filename);
     map->mappath = msStrdup(msBuildPath(szPath, szCWDPath, path));
-    free( path );
+    free(path);
   }
 
   msyybasepath = map->mappath; /* for INCLUDEs */
 
-  if(loadMapInternal(map) != MS_SUCCESS) {
+  if (loadMapInternal(map) != MS_SUCCESS) {
     msFreeMap(map);
-    msReleaseLock( TLOCK_PARSER );
-    if( msyyin ) {
+    msReleaseLock(TLOCK_PARSER);
+    if (msyyin) {
       msyycleanup_includes();
       fclose(msyyin);
       msyyin = NULL;
     }
     return NULL;
   }
-  msReleaseLock( TLOCK_PARSER );
+  msReleaseLock(TLOCK_PARSER);
 
   if (debuglevel >= MS_DEBUGLEVEL_TUNING) {
     /* In debug mode, report time spent loading/parsing mapfile. */
     msGettimeofday(&endtime, NULL);
     msDebug("msLoadMap(): %.3fs\n",
-            (endtime.tv_sec+endtime.tv_usec/1.0e6)-
-            (starttime.tv_sec+starttime.tv_usec/1.0e6) );
+            (endtime.tv_sec + endtime.tv_usec / 1.0e6) -
+                (starttime.tv_sec + starttime.tv_usec / 1.0e6));
   }
 
   return map;
 }
 
-static void hashTableSubstituteString(hashTableObj *hash, const char *from, const char *to) {
+static void hashTableSubstituteString(hashTableObj *hash, const char *from,
+                                      const char *to) {
   const char *key, *val;
   char *new_val;
   key = msFirstKeyFromHashTable(hash);
-  while(key != NULL) {
+  while (key != NULL) {
     val = msLookupHashTable(hash, key);
-    if(strcasestr(val, from)) {
+    if (strcasestr(val, from)) {
       new_val = msCaseReplaceSubstring(msStrdup(val), from, to);
       msInsertHashTable(hash, key, new_val);
       msFree(new_val);
@@ -6420,66 +7069,81 @@ static void hashTableSubstituteString(ha
   }
 }
 
-static void classSubstituteString(classObj *class, const char *from, const char *to) {
-  if(class->expression.string) class->expression.string = msCaseReplaceSubstring(class->expression.string, from, to);
-  if(class->text.string) class->text.string = msCaseReplaceSubstring(class->text.string, from, to);
-  if(class->title) class->title = msCaseReplaceSubstring(class->title, from, to);
+static void classSubstituteString(classObj *class, const char *from,
+                                  const char *to) {
+  if (class->expression.string)
+    class->expression.string =
+        msCaseReplaceSubstring(class->expression.string, from, to);
+  if (class->text.string)
+    class->text.string = msCaseReplaceSubstring(class->text.string, from, to);
+  if (class->title)
+    class->title = msCaseReplaceSubstring(class->title, from, to);
 }
 
-
-static void layerSubstituteString(layerObj *layer, const char *from, const char *to)
-{
+static void layerSubstituteString(layerObj *layer, const char *from,
+                                  const char *to) {
   int c;
-  if(layer->data) layer->data = msCaseReplaceSubstring(layer->data, from, to);
-  if(layer->tileindex) layer->tileindex = msCaseReplaceSubstring(layer->tileindex, from, to);
-  if(layer->connection) layer->connection = msCaseReplaceSubstring(layer->connection, from, to);
-  if(layer->filter.string) layer->filter.string = msCaseReplaceSubstring(layer->filter.string, from, to);
-  if(layer->mask) layer->mask = msCaseReplaceSubstring(layer->mask, from, to); // new for 8.0
+  if (layer->data)
+    layer->data = msCaseReplaceSubstring(layer->data, from, to);
+  if (layer->tileindex)
+    layer->tileindex = msCaseReplaceSubstring(layer->tileindex, from, to);
+  if (layer->connection)
+    layer->connection = msCaseReplaceSubstring(layer->connection, from, to);
+  if (layer->filter.string)
+    layer->filter.string =
+        msCaseReplaceSubstring(layer->filter.string, from, to);
+  if (layer->mask)
+    layer->mask = msCaseReplaceSubstring(layer->mask, from, to); // new for 8.0
 
-  /* The bindvalues are most useful when able to substitute values from the URL */
+  /* The bindvalues are most useful when able to substitute values from the URL
+   */
   hashTableSubstituteString(&layer->bindvals, from, to);
   hashTableSubstituteString(&layer->metadata, from, to);
-  msLayerSubstituteProcessing( layer, from, to );
-  for(c=0; c<layer->numclasses;c++) {
+  msLayerSubstituteProcessing(layer, from, to);
+  for (c = 0; c < layer->numclasses; c++) {
     classSubstituteString(layer->class[c], from, to);
   }
 }
 
 static void mapSubstituteString(mapObj *map, const char *from, const char *to) {
   int l;
-  for(l=0;l<map->numlayers; l++) {
-    layerSubstituteString(GET_LAYER(map,l), from, to);
+  for (l = 0; l < map->numlayers; l++) {
+    layerSubstituteString(GET_LAYER(map, l), from, to);
   }
 
   /* output formats (#3751) */
-  for(l=0; l<map->numoutputformats; l++) {
+  for (l = 0; l < map->numoutputformats; l++) {
     int o;
-    for(o=0; o<map->outputformatlist[l]->numformatoptions; o++) {
-      map->outputformatlist[l]->formatoptions[o] = msCaseReplaceSubstring(map->outputformatlist[l]->formatoptions[o], from, to);
+    for (o = 0; o < map->outputformatlist[l]->numformatoptions; o++) {
+      map->outputformatlist[l]->formatoptions[o] = msCaseReplaceSubstring(
+          map->outputformatlist[l]->formatoptions[o], from, to);
     }
   }
 
   hashTableSubstituteString(&map->web.metadata, from, to);
-  if(map->web.template) map->web.template = msCaseReplaceSubstring(map->web.template, from, to);
+  if (map->web.template)
+    map->web.template = msCaseReplaceSubstring(map->web.template, from, to);
 }
 
-static void applyOutputFormatDefaultSubstitutions(outputFormatObj *format, const char *option, hashTableObj *table)
-{
+static void applyOutputFormatDefaultSubstitutions(outputFormatObj *format,
+                                                  const char *option,
+                                                  hashTableObj *table) {
   const char *filename;
 
   filename = msGetOutputFormatOption(format, option, NULL);
-  if(filename && strlen(filename)>0) {
+  if (filename && strlen(filename) > 0) {
     char *tmpfilename = msStrdup(filename);
     const char *default_key = msFirstKeyFromHashTable(table);
-    while(default_key) {
-      if(!strncasecmp(default_key,"default_",8)) {
+    while (default_key) {
+      if (!strncasecmp(default_key, "default_", 8)) {
         char *new_filename = NULL;
-        size_t buffer_size = (strlen(default_key)-5);
+        size_t buffer_size = (strlen(default_key) - 5);
         char *tag = (char *)msSmallMalloc(buffer_size);
         snprintf(tag, buffer_size, "%%%s%%", &(default_key[8]));
 
         new_filename = msStrdup(tmpfilename);
-        new_filename = msCaseReplaceSubstring(new_filename, tag, msLookupHashTable(table, default_key));
+        new_filename = msCaseReplaceSubstring(
+            new_filename, tag, msLookupHashTable(table, default_key));
         free(tag);
 
         msSetOutputFormatOption(format, option, new_filename);
@@ -6492,12 +7156,12 @@ static void applyOutputFormatDefaultSubs
   return;
 }
 
-static void applyClassDefaultSubstitutions(classObj *class, hashTableObj *table)
-{
+static void applyClassDefaultSubstitutions(classObj *class,
+                                           hashTableObj *table) {
   const char *default_key = msFirstKeyFromHashTable(table);
-  while(default_key) {
-    if(!strncasecmp(default_key,"default_",8)) {
-      size_t buffer_size = (strlen(default_key)-5);
+  while (default_key) {
+    if (!strncasecmp(default_key, "default_", 8)) {
+      size_t buffer_size = (strlen(default_key) - 5);
       char *tag = (char *)msSmallMalloc(buffer_size);
       snprintf(tag, buffer_size, "%%%s%%", &(default_key[8]));
 
@@ -6509,18 +7173,18 @@ static void applyClassDefaultSubstitutio
   return;
 }
 
-static void applyLayerDefaultSubstitutions(layerObj *layer, hashTableObj *table)
-{
+static void applyLayerDefaultSubstitutions(layerObj *layer,
+                                           hashTableObj *table) {
   int i;
   const char *default_key = msFirstKeyFromHashTable(table);
-  while(default_key) {
-    if(!strncasecmp(default_key,"default_",8)) {
-      size_t buffer_size = (strlen(default_key)-5);
+  while (default_key) {
+    if (!strncasecmp(default_key, "default_", 8)) {
+      size_t buffer_size = (strlen(default_key) - 5);
       const char *to = msLookupHashTable(table, default_key);
       char *tag = (char *)msSmallMalloc(buffer_size);
       snprintf(tag, buffer_size, "%%%s%%", &(default_key[8]));
 
-      for(i=0; i<layer->numclasses; i++) {
+      for (i = 0; i < layer->numclasses; i++) {
         classSubstituteString(layer->class[i], tag, to);
       }
       layerSubstituteString(layer, tag, to);
@@ -6531,8 +7195,8 @@ static void applyLayerDefaultSubstitutio
   return;
 }
 
-static void applyHashTableDefaultSubstitutions(hashTableObj *hashTab, hashTableObj *table)
-{
+static void applyHashTableDefaultSubstitutions(hashTableObj *hashTab,
+                                               hashTableObj *table) {
   const char *default_key = msFirstKeyFromHashTable(table);
   while (default_key) {
     if (!strncasecmp(default_key, "default_", 8)) {
@@ -6550,117 +7214,134 @@ static void applyHashTableDefaultSubstit
 }
 
 /*
-** Loop through layer metadata for keys that have a default_%key% pattern to replace
+** Loop through layer metadata for keys that have a default_%key% pattern to
+*replace
 ** remaining %key% entries by their default value.
 */
-void msApplyDefaultSubstitutions(mapObj *map)
-{
-  int i,j;
+void msApplyDefaultSubstitutions(mapObj *map) {
+  int i, j;
 
   /* output formats (#3751) */
-  for(i=0; i<map->numoutputformats; i++) {
-    applyOutputFormatDefaultSubstitutions(map->outputformatlist[i], "filename", &(map->web.validation));
-    applyOutputFormatDefaultSubstitutions(map->outputformatlist[i], "JSONP", &(map->web.validation));
+  for (i = 0; i < map->numoutputformats; i++) {
+    applyOutputFormatDefaultSubstitutions(map->outputformatlist[i], "filename",
+                                          &(map->web.validation));
+    applyOutputFormatDefaultSubstitutions(map->outputformatlist[i], "JSONP",
+                                          &(map->web.validation));
   }
 
-  for(i=0; i<map->numlayers; i++) {
+  for (i = 0; i < map->numlayers; i++) {
     layerObj *layer = GET_LAYER(map, i);
 
-    for(j=0; j<layer->numclasses; j++) {    /* class settings take precedence...  */
+    for (j = 0; j < layer->numclasses;
+         j++) { /* class settings take precedence...  */
       classObj *class = GET_CLASS(map, i, j);
       applyClassDefaultSubstitutions(class, &(class->validation));
     }
 
-    applyLayerDefaultSubstitutions(layer, &(layer->validation)); /* ...then layer settings... */
-    applyLayerDefaultSubstitutions(layer, &(map->web.validation)); /* ...and finally web settings */
+    applyLayerDefaultSubstitutions(
+        layer, &(layer->validation)); /* ...then layer settings... */
+    applyLayerDefaultSubstitutions(
+        layer, &(map->web.validation)); /* ...and finally web settings */
   }
-  applyHashTableDefaultSubstitutions(&map->web.metadata, &(map->web.validation));
+  applyHashTableDefaultSubstitutions(&map->web.metadata,
+                                     &(map->web.validation));
 }
 
-char *_get_param_value(const char *key, char **names, char **values, int npairs) 
-{
-  if(npairs <= 0) return NULL; // bail, no point searching
+char *_get_param_value(const char *key, char **names, char **values,
+                       int npairs) {
+  if (npairs <= 0)
+    return NULL; // bail, no point searching
 
-  if(getenv(key)) { /* envirronment override */
+  if (getenv(key)) { /* envirronment override */
     return getenv(key);
   }
-  while(npairs) {
+  while (npairs) {
     npairs--;
-    if(strcasecmp(key, names[npairs]) == 0) {
+    if (strcasecmp(key, names[npairs]) == 0) {
       return values[npairs];
     }
   }
   return NULL;
 }
 
-void msApplySubstitutions(mapObj *map, char **names, char **values, int npairs)
-{
+void msApplySubstitutions(mapObj *map, char **names, char **values,
+                          int npairs) {
   int l;
   const char *key, *value, *validation;
   char *tag;
-  for(l=0; l<map->numlayers; l++) {
+  for (l = 0; l < map->numlayers; l++) {
     int c;
-    layerObj *lp = GET_LAYER(map,l);
-    for(c=0; c<lp->numclasses; c++) {
+    layerObj *lp = GET_LAYER(map, l);
+    for (c = 0; c < lp->numclasses; c++) {
       classObj *cp = lp->class[c];
       key = NULL;
-      while( (key = msNextKeyFromHashTable(&cp->validation, key)) ) {
-        value = _get_param_value(key,names,values,npairs);
-        if(!value) continue; /*parameter was not in url*/
+      while ((key = msNextKeyFromHashTable(&cp->validation, key))) {
+        value = _get_param_value(key, names, values, npairs);
+        if (!value)
+          continue; /*parameter was not in url*/
         validation = msLookupHashTable(&cp->validation, key);
-        if(msEvalRegex(validation, value)) {
-          /* we've found a substitution and it validates correctly, now let's apply it */
-          tag = msSmallMalloc(strlen(key)+3);
-          sprintf(tag,"%%%s%%",key);
-          classSubstituteString(cp,tag,value);
+        if (msEvalRegex(validation, value)) {
+          /* we've found a substitution and it validates correctly, now let's
+           * apply it */
+          tag = msSmallMalloc(strlen(key) + 3);
+          sprintf(tag, "%%%s%%", key);
+          classSubstituteString(cp, tag, value);
           free(tag);
         } else {
-          msSetError(MS_REGEXERR, "Parameter pattern validation failed." , "msApplySubstitutions()");
-          if(map->debug || lp->debug) {
-            msDebug("layer (%s), class %d: failed to validate (%s=%s) for regex (%s)\n", lp->name, c, key, value, validation);
+          msSetError(MS_REGEXERR, "Parameter pattern validation failed.",
+                     "msApplySubstitutions()");
+          if (map->debug || lp->debug) {
+            msDebug("layer (%s), class %d: failed to validate (%s=%s) for "
+                    "regex (%s)\n",
+                    lp->name, c, key, value, validation);
           }
         }
-
       }
     }
     key = NULL;
-    while( (key = msNextKeyFromHashTable(&lp->validation, key)) ) {
-      value = _get_param_value(key,names,values,npairs);
-      if(!value) continue; /*parameter was not in url*/
+    while ((key = msNextKeyFromHashTable(&lp->validation, key))) {
+      value = _get_param_value(key, names, values, npairs);
+      if (!value)
+        continue; /*parameter was not in url*/
       validation = msLookupHashTable(&lp->validation, key);
-      if(msEvalRegex(validation, value)) {
-        /* we've found a substitution and it validates correctly, now let's apply it */
-        tag = msSmallMalloc(strlen(key)+3);
-        sprintf(tag,"%%%s%%",key);
-        layerSubstituteString(lp,tag,value);
+      if (msEvalRegex(validation, value)) {
+        /* we've found a substitution and it validates correctly, now let's
+         * apply it */
+        tag = msSmallMalloc(strlen(key) + 3);
+        sprintf(tag, "%%%s%%", key);
+        layerSubstituteString(lp, tag, value);
         free(tag);
       } else {
-        msSetError(MS_REGEXERR, "Parameter pattern validation failed." , "msApplySubstitutions()");
-        if(map->debug || lp->debug) {
-          msDebug("layer (%s): failed to validate (%s=%s) for regex (%s)\n", lp->name, key, value, validation);
+        msSetError(MS_REGEXERR, "Parameter pattern validation failed.",
+                   "msApplySubstitutions()");
+        if (map->debug || lp->debug) {
+          msDebug("layer (%s): failed to validate (%s=%s) for regex (%s)\n",
+                  lp->name, key, value, validation);
         }
       }
-
     }
   }
   key = NULL;
-  while( (key = msNextKeyFromHashTable(&map->web.validation, key)) ) {
-    value = _get_param_value(key,names,values,npairs);
-    if(!value) continue; /*parameter was not in url*/
+  while ((key = msNextKeyFromHashTable(&map->web.validation, key))) {
+    value = _get_param_value(key, names, values, npairs);
+    if (!value)
+      continue; /*parameter was not in url*/
     validation = msLookupHashTable(&map->web.validation, key);
-    if(msEvalRegex(validation, value)) {
-      /* we've found a substitution and it validates correctly, now let's apply it */
-      tag = msSmallMalloc(strlen(key)+3);
-      sprintf(tag,"%%%s%%",key);
-      mapSubstituteString(map,tag,value);
+    if (msEvalRegex(validation, value)) {
+      /* we've found a substitution and it validates correctly, now let's apply
+       * it */
+      tag = msSmallMalloc(strlen(key) + 3);
+      sprintf(tag, "%%%s%%", key);
+      mapSubstituteString(map, tag, value);
       free(tag);
     } else {
-      msSetError(MS_REGEXERR, "Parameter pattern validation failed." , "msApplySubstitutions()");
-      if(map->debug) {
-        msDebug("failed to validate (%s=%s) for regex (%s)\n", key, value, validation);
+      msSetError(MS_REGEXERR, "Parameter pattern validation failed.",
+                 "msApplySubstitutions()");
+      if (map->debug) {
+        msDebug("failed to validate (%s=%s) for regex (%s)\n", key, value,
+                validation);
       }
     }
-
   }
 }
 
@@ -6670,15 +7351,14 @@ void msApplySubstitutions(mapObj *map, c
 **
 ** The returned array should be freed using msFreeCharArray().
 */
-static char **tokenizeMapInternal(char *filename, int *ret_numtokens)
-{
+static char **tokenizeMapInternal(char *filename, int *ret_numtokens) {
   char **tokens = NULL;
-  int  numtokens=0, numtokens_allocated=0;
+  int numtokens = 0, numtokens_allocated = 0;
   size_t buffer_size = 0;
 
   *ret_numtokens = 0;
 
-  if(!filename) {
+  if (!filename) {
     msSetError(MS_MISCERR, "Filename is undefined.", "msTokenizeMap()");
     return NULL;
   }
@@ -6686,18 +7366,20 @@ static char **tokenizeMapInternal(char *
   /*
   ** Check map filename to make sure it's legal
   */
-  const char *ms_mapfile_pattern = CPLGetConfigOption("MS_MAPFILE_PATTERN", MS_DEFAULT_MAPFILE_PATTERN);
-  if(msEvalRegex(ms_mapfile_pattern, filename) != MS_TRUE) {
-    msSetError(MS_REGEXERR, "Filename validation failed." , "msLoadMap()");
-    return(NULL);
+  const char *ms_mapfile_pattern =
+      CPLGetConfigOption("MS_MAPFILE_PATTERN", MS_DEFAULT_MAPFILE_PATTERN);
+  if (msEvalRegex(ms_mapfile_pattern, filename) != MS_TRUE) {
+    msSetError(MS_REGEXERR, "Filename validation failed.", "msLoadMap()");
+    return (NULL);
   }
 
-  if((msyyin = fopen(filename,"r")) == NULL) {
+  if ((msyyin = fopen(filename, "r")) == NULL) {
     msSetError(MS_IOERR, "(%s)", "msTokenizeMap()", filename);
     return NULL;
   }
 
-  msyystate = MS_TOKENIZE_FILE; /* restore lexer state to INITIAL, and do return comments */
+  msyystate = MS_TOKENIZE_FILE; /* restore lexer state to INITIAL, and do return
+                                   comments */
   msyylex();
   msyyreturncomments = 1; /* want all tokens, including comments */
 
@@ -6706,60 +7388,62 @@ static char **tokenizeMapInternal(char *
 
   numtokens = 0;
   numtokens_allocated = 256;
-  tokens = (char **) malloc(numtokens_allocated*sizeof(char*));
-  if(tokens == NULL) {
+  tokens = (char **)malloc(numtokens_allocated * sizeof(char *));
+  if (tokens == NULL) {
     msSetError(MS_MEMERR, NULL, "msTokenizeMap()");
     fclose(msyyin);
     return NULL;
   }
 
-  for(;;) {
+  for (;;) {
 
-    if(numtokens_allocated <= numtokens) {
-      numtokens_allocated *= 2; /* double size of the array every time we reach the limit */
-      char** tokensNew = (char **)realloc(tokens, numtokens_allocated*sizeof(char*));
-      if(tokensNew == NULL) {
+    if (numtokens_allocated <= numtokens) {
+      numtokens_allocated *=
+          2; /* double size of the array every time we reach the limit */
+      char **tokensNew =
+          (char **)realloc(tokens, numtokens_allocated * sizeof(char *));
+      if (tokensNew == NULL) {
         msSetError(MS_MEMERR, "Realloc() error.", "msTokenizeMap()");
         fclose(msyyin);
-        for(int i=0; i<numtokens; i++)
-            msFree(tokens[i]);
+        for (int i = 0; i < numtokens; i++)
+          msFree(tokens[i]);
         msFree(tokens);
         return NULL;
       }
       tokens = tokensNew;
     }
 
-    switch(msyylex()) {
-      case(EOF): /* This is the normal way out... cleanup and exit */
-        fclose(msyyin);
-        *ret_numtokens = numtokens;
-        return(tokens);
-        break;
-      case(MS_STRING):
-        buffer_size = strlen(msyystring_buffer)+2+1;
-        tokens[numtokens] = (char*) msSmallMalloc(buffer_size);
-        snprintf(tokens[numtokens], buffer_size, "\"%s\"", msyystring_buffer);
-        break;
-      case(MS_EXPRESSION):
-        buffer_size = strlen(msyystring_buffer)+2+1;
-        tokens[numtokens] = (char*) msSmallMalloc(buffer_size);
-        snprintf(tokens[numtokens], buffer_size, "(%s)", msyystring_buffer);
-        break;
-      case(MS_REGEX):
-        buffer_size = strlen(msyystring_buffer)+2+1;
-        tokens[numtokens] = (char*) msSmallMalloc(buffer_size);
-        snprintf(tokens[numtokens], buffer_size, "/%s/", msyystring_buffer);
-        break;
-      default:
-        tokens[numtokens] = msStrdup(msyystring_buffer);
-        break;
+    switch (msyylex()) {
+    case (EOF): /* This is the normal way out... cleanup and exit */
+      fclose(msyyin);
+      *ret_numtokens = numtokens;
+      return (tokens);
+      break;
+    case (MS_STRING):
+      buffer_size = strlen(msyystring_buffer) + 2 + 1;
+      tokens[numtokens] = (char *)msSmallMalloc(buffer_size);
+      snprintf(tokens[numtokens], buffer_size, "\"%s\"", msyystring_buffer);
+      break;
+    case (MS_EXPRESSION):
+      buffer_size = strlen(msyystring_buffer) + 2 + 1;
+      tokens[numtokens] = (char *)msSmallMalloc(buffer_size);
+      snprintf(tokens[numtokens], buffer_size, "(%s)", msyystring_buffer);
+      break;
+    case (MS_REGEX):
+      buffer_size = strlen(msyystring_buffer) + 2 + 1;
+      tokens[numtokens] = (char *)msSmallMalloc(buffer_size);
+      snprintf(tokens[numtokens], buffer_size, "/%s/", msyystring_buffer);
+      break;
+    default:
+      tokens[numtokens] = msStrdup(msyystring_buffer);
+      break;
     }
 
-    if(tokens[numtokens] == NULL) {
+    if (tokens[numtokens] == NULL) {
       int i;
       msSetError(MS_MEMERR, NULL, "msTokenizeMap()");
       fclose(msyyin);
-      for(i=0; i<numtokens; i++)
+      for (i = 0; i < numtokens; i++)
         msFree(tokens[i]);
       msFree(tokens);
       return NULL;
@@ -6768,32 +7452,31 @@ static char **tokenizeMapInternal(char *
     numtokens++;
   }
 
-  return NULL;   /* should never get here */
+  return NULL; /* should never get here */
 }
 
 /*
 ** Wraps tokenizeMapInternal
 */
-char **msTokenizeMap(char *filename, int *numtokens)
-{
+char **msTokenizeMap(char *filename, int *numtokens) {
   char **tokens;
 
-  msAcquireLock( TLOCK_PARSER );
-  tokens = tokenizeMapInternal( filename, numtokens );
-  msReleaseLock( TLOCK_PARSER );
+  msAcquireLock(TLOCK_PARSER);
+  tokens = tokenizeMapInternal(filename, numtokens);
+  msReleaseLock(TLOCK_PARSER);
 
   return tokens;
 }
 
-void msCloseConnections(mapObj *map)
-{
+void msCloseConnections(mapObj *map) {
   int i;
   layerObj *lp;
 
-  for (i=0; i<map->numlayers; i++) {
+  for (i = 0; i < map->numlayers; i++) {
     lp = (GET_LAYER(map, i));
 
-    /* If the vtable is null, then the layer is never accessed or used -> skip it
+    /* If the vtable is null, then the layer is never accessed or used -> skip
+     * it
      */
     if (lp->vtable) {
       lp->vtable->LayerCloseConnection(lp);
@@ -6801,47 +7484,42 @@ void msCloseConnections(mapObj *map)
   }
 }
 
-void initResultCache(resultCacheObj *resultcache)
-{
+void initResultCache(resultCacheObj *resultcache) {
   if (resultcache) {
     resultcache->results = NULL;
     resultcache->numresults = 0;
     resultcache->cachesize = 0;
-    resultcache->bounds.minx = resultcache->bounds.miny = resultcache->bounds.maxx = resultcache->bounds.maxy = -1;
+    resultcache->bounds.minx = resultcache->bounds.miny =
+        resultcache->bounds.maxx = resultcache->bounds.maxy = -1;
     resultcache->previousBounds = resultcache->bounds;
   }
 }
 
-void cleanupResultCache(resultCacheObj *resultcache)
-{
-  if(resultcache) {
-    if(resultcache->results)
-    {
-        int i;
-        for( i = 0; i < resultcache->numresults; i++ )
-        {
-            if( resultcache->results[i].shape )
-            {
-                msFreeShape( resultcache->results[i].shape );
-                msFree( resultcache->results[i].shape );
-            }
+void cleanupResultCache(resultCacheObj *resultcache) {
+  if (resultcache) {
+    if (resultcache->results) {
+      int i;
+      for (i = 0; i < resultcache->numresults; i++) {
+        if (resultcache->results[i].shape) {
+          msFreeShape(resultcache->results[i].shape);
+          msFree(resultcache->results[i].shape);
         }
-        free(resultcache->results);
+      }
+      free(resultcache->results);
     }
     resultcache->results = NULL;
     initResultCache(resultcache);
   }
 }
 
-
-static int resolveSymbolNames(mapObj* map)
-{
+static int resolveSymbolNames(mapObj *map) {
   int i, j;
 
   /* step through layers and classes to resolve symbol names */
-  for(i=0; i<map->numlayers; i++) {
-    for(j=0; j<GET_LAYER(map, i)->numclasses; j++) {
-      if(classResolveSymbolNames(GET_LAYER(map, i)->class[j]) != MS_SUCCESS) return MS_FAILURE;
+  for (i = 0; i < map->numlayers; i++) {
+    for (j = 0; j < GET_LAYER(map, i)->numclasses; j++) {
+      if (classResolveSymbolNames(GET_LAYER(map, i)->class[j]) != MS_SUCCESS)
+        return MS_FAILURE;
     }
   }
 
diff -pruN 8.0.1-5/mapfile.h 8.0.2-1/mapfile.h
--- 8.0.1-5/mapfile.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapfile.h	2024-06-11 20:41:34.000000000 +0000
@@ -27,12 +27,19 @@
  * DEALINGS IN THE SOFTWARE.
  ****************************************************************************/
 
-
 #ifndef MAPFILE_H
 #define MAPFILE_H
 
-enum MS_LEXER_STATES {MS_TOKENIZE_DEFAULT=0, MS_TOKENIZE_FILE, MS_TOKENIZE_STRING, MS_TOKENIZE_EXPRESSION, MS_TOKENIZE_VALUE, MS_TOKENIZE_NAME, MS_TOKENIZE_CONFIG};
-enum MS_TOKEN_SOURCES {MS_FILE_TOKENS=0, MS_STRING_TOKENS};
+enum MS_LEXER_STATES {
+  MS_TOKENIZE_DEFAULT = 0,
+  MS_TOKENIZE_FILE,
+  MS_TOKENIZE_STRING,
+  MS_TOKENIZE_EXPRESSION,
+  MS_TOKENIZE_VALUE,
+  MS_TOKENIZE_NAME,
+  MS_TOKENIZE_CONFIG
+};
+enum MS_TOKEN_SOURCES { MS_FILE_TOKENS = 0, MS_STRING_TOKENS };
 
 /*
 ** Keyword definitions for the mapfiles and symbolfiles (used by lexer)
@@ -81,7 +88,6 @@ enum MS_TOKEN_SOURCES {MS_FILE_TOKENS=0,
 #define LOG 1043
 #define MAP 1044
 
-
 #define MAXFEATURES 1047
 #define MAXSCALE 1048
 #define MAXSIZE 1049
@@ -190,10 +196,10 @@ enum MS_TOKEN_SOURCES {MS_FILE_TOKENS=0,
 #define MAXINTERVAL 1144
 #define MININTERVAL 1145
 #define MAXSUBDIVIDE 1146
-#define MINSUBDIVIDE  1147
-#define LABELFORMAT  1148
+#define MINSUBDIVIDE 1147
+#define LABELFORMAT 1148
 
-#define PROCESSING  1153
+#define PROCESSING 1153
 
 /* The DEBUG macro is also used to request debugging output.  Redefine
    for keyword purposes.  */
@@ -308,7 +314,6 @@ enum MS_TOKEN_SOURCES {MS_FILE_TOKENS=0,
 #define COMPOP 1291
 #define COMPFILTER 1292
 
-
 #define BOM 1300
 
 /* rfc59 bindvals objects */
diff -pruN 8.0.1-5/mapflatgeobuf.c 8.0.2-1/mapflatgeobuf.c
--- 8.0.1-5/mapflatgeobuf.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapflatgeobuf.c	2024-06-11 20:41:34.000000000 +0000
@@ -39,66 +39,66 @@
 #include <cpl_conv.h>
 #include <ogr_srs_api.h>
 
-static void msFGBPassThroughFieldDefinitions(layerObj *layer, flatgeobuf_ctx *ctx)
-{
+static void msFGBPassThroughFieldDefinitions(layerObj *layer,
+                                             flatgeobuf_ctx *ctx) {
   for (int i = 0; i < ctx->columns_len; i++) {
     char item[255];
     char gml_width[32], gml_precision[32];
     const char *gml_type = NULL;
 
-    const flatgeobuf_column* column = &(ctx->columns[i]);
+    const flatgeobuf_column *column = &(ctx->columns[i]);
     strncpy(item, column->name, 255 - 1);
 
     gml_width[0] = '\0';
     gml_precision[0] = '\0';
 
-    switch( column->type ) {
-      case flatgeobuf_column_type_byte:
-      case flatgeobuf_column_type_ubyte:
-      case flatgeobuf_column_type_bool:
-      case flatgeobuf_column_type_short:
-      case flatgeobuf_column_type_ushort:
-      case flatgeobuf_column_type_int:
-      case flatgeobuf_column_type_uint:
-        gml_type = "Integer";
-        sprintf( gml_width, "%d", 4 );
-        break;
-      case flatgeobuf_column_type_long:
-      case flatgeobuf_column_type_ulong:
-        gml_type = "Long";
-        sprintf( gml_width, "%d", 8 );
-        break;
-      case flatgeobuf_column_type_float:
-      case flatgeobuf_column_type_double:
-        gml_type = "Real";
-        sprintf( gml_width, "%d", 8 );
-        sprintf( gml_precision, "%d", 15 );
-        break;
-      case flatgeobuf_column_type_string:
-      case flatgeobuf_column_type_json:
-      case flatgeobuf_column_type_datetime:
-      default:
-        gml_type = "Character";
-        sprintf( gml_width, "%d", 4096 );
-        break;
+    switch (column->type) {
+    case flatgeobuf_column_type_byte:
+    case flatgeobuf_column_type_ubyte:
+    case flatgeobuf_column_type_bool:
+    case flatgeobuf_column_type_short:
+    case flatgeobuf_column_type_ushort:
+    case flatgeobuf_column_type_int:
+    case flatgeobuf_column_type_uint:
+      gml_type = "Integer";
+      sprintf(gml_width, "%d", 4);
+      break;
+    case flatgeobuf_column_type_long:
+    case flatgeobuf_column_type_ulong:
+      gml_type = "Long";
+      sprintf(gml_width, "%d", 8);
+      break;
+    case flatgeobuf_column_type_float:
+    case flatgeobuf_column_type_double:
+      gml_type = "Real";
+      sprintf(gml_width, "%d", 8);
+      sprintf(gml_precision, "%d", 15);
+      break;
+    case flatgeobuf_column_type_string:
+    case flatgeobuf_column_type_json:
+    case flatgeobuf_column_type_datetime:
+    default:
+      gml_type = "Character";
+      sprintf(gml_width, "%d", 4096);
+      break;
     }
 
-    msUpdateGMLFieldMetadata(layer, item, gml_type, gml_width, gml_precision, 0);
+    msUpdateGMLFieldMetadata(layer, item, gml_type, gml_width, gml_precision,
+                             0);
   }
 }
 
-void msFlatGeobufLayerFreeItemInfo(layerObj *layer)
-{
+void msFlatGeobufLayerFreeItemInfo(layerObj *layer) {
   if (layer->iteminfo) {
     free(layer->iteminfo);
     layer->iteminfo = NULL;
   }
 }
 
-int msFlatGeobufLayerInitItemInfo(layerObj *layer)
-{
-  if(!layer->layerinfo) {
-    msSetError(MS_FGBERR, "FlatGeobuf layer has not been opened.", "msFlatGeobufLayerInitItemInfo()");
+int msFlatGeobufLayerInitItemInfo(layerObj *layer) {
+  if (!layer->layerinfo) {
+    msSetError(MS_FGBERR, "FlatGeobuf layer has not been opened.",
+               "msFlatGeobufLayerInitItemInfo()");
     return MS_FAILURE;
   }
 
@@ -109,39 +109,38 @@ int msFlatGeobufLayerInitItemInfo(layerO
   if (!ctx)
     return MS_FAILURE;
 
-  for (int j = 0; j < ctx->columns_len; j++)
-  {
+  for (int j = 0; j < ctx->columns_len; j++) {
     ctx->columns[j].itemindex = -1;
-    for (int i = 0; i < layer->numitems; i++)
-    {
-        if (strcasecmp(layer->items[i], ctx->columns[j].name) == 0)
-        {
-            ctx->columns[j].itemindex = i;
-            break;
-        }
+    for (int i = 0; i < layer->numitems; i++) {
+      if (strcasecmp(layer->items[i], ctx->columns[j].name) == 0) {
+        ctx->columns[j].itemindex = i;
+        break;
+      }
     }
   }
 
   return MS_SUCCESS;
 }
 
-int msFlatGeobufLayerOpen(layerObj *layer)
-{
+int msFlatGeobufLayerOpen(layerObj *layer) {
   char szPath[MS_MAXPATHLEN];
   int ret;
 
-  if(layer->layerinfo)
+  if (layer->layerinfo)
     return MS_SUCCESS;
 
-  if (msCheckParentPointer(layer->map,"map") == MS_FAILURE)
+  if (msCheckParentPointer(layer->map, "map") == MS_FAILURE)
     return MS_FAILURE;
 
   flatgeobuf_ctx *ctx = flatgeobuf_init_ctx();
   layer->layerinfo = ctx;
 
-  ctx->file = VSIFOpenL(msBuildPath(szPath, layer->map->mappath, layer->data), "rb");
+  ctx->file =
+      VSIFOpenL(msBuildPath(szPath, layer->map->mappath, layer->data), "rb");
   if (!ctx->file)
-    ctx->file = VSIFOpenL(msBuildPath3(szPath, layer->map->mappath, layer->map->shapepath, layer->data), "rb");
+    ctx->file = VSIFOpenL(msBuildPath3(szPath, layer->map->mappath,
+                                       layer->map->shapepath, layer->data),
+                          "rb");
   if (!ctx->file) {
     layer->layerinfo = NULL;
     flatgeobuf_free_ctx(ctx);
@@ -164,7 +163,7 @@ int msFlatGeobufLayerOpen(layerObj *laye
 
   if (layer->projection.numargs > 0 &&
       EQUAL(layer->projection.args[0], "auto")) {
-    OGRSpatialReferenceH hSRS = OSRNewSpatialReference( NULL );
+    OGRSpatialReferenceH hSRS = OSRNewSpatialReference(NULL);
     char *pszWKT = NULL;
     if (ctx->srid > 0) {
       if (OSRImportFromEPSG(hSRS, ctx->srid) != OGRERR_NONE) {
@@ -182,28 +181,29 @@ int msFlatGeobufLayerOpen(layerObj *laye
       return MS_SUCCESS;
     }
     int bOK = MS_FALSE;
-    if (msOGCWKT2ProjectionObj(ctx->wkt ? ctx->wkt : pszWKT, &(layer->projection), layer->debug) == MS_SUCCESS)
+    if (msOGCWKT2ProjectionObj(ctx->wkt ? ctx->wkt : pszWKT,
+                               &(layer->projection),
+                               layer->debug) == MS_SUCCESS)
       bOK = MS_TRUE;
     CPLFree(pszWKT);
     OSRDestroySpatialReference(hSRS);
-    if( bOK != MS_TRUE )
-      if( layer->debug || layer->map->debug )
-        msDebug( "Unable to get SRS from FlatGeobuf '%s' for layer '%s'.\n", szPath, layer->name );
+    if (bOK != MS_TRUE)
+      if (layer->debug || layer->map->debug)
+        msDebug("Unable to get SRS from FlatGeobuf '%s' for layer '%s'.\n",
+                szPath, layer->name);
   }
 
   return MS_SUCCESS;
 }
 
-int msFlatGeobufLayerIsOpen(layerObj *layer)
-{
-  if(layer->layerinfo)
+int msFlatGeobufLayerIsOpen(layerObj *layer) {
+  if (layer->layerinfo)
     return MS_TRUE;
   else
     return MS_FALSE;
 }
 
-int msFlatGeobufLayerWhichShapes(layerObj *layer, rectObj rect, int isQuery)
-{
+int msFlatGeobufLayerWhichShapes(layerObj *layer, rectObj rect, int isQuery) {
   (void)isQuery;
   flatgeobuf_ctx *ctx;
   ctx = layer->layerinfo;
@@ -213,19 +213,22 @@ int msFlatGeobufLayerWhichShapes(layerOb
   if (!ctx->has_extent || !ctx->index_node_size)
     return MS_SUCCESS;
 
-  if(msRectOverlap(&ctx->bounds, &rect) != MS_TRUE)
+  if (msRectOverlap(&ctx->bounds, &rect) != MS_TRUE)
     return MS_DONE;
 
-  if (msRectContained(&ctx->bounds, &rect) == MS_FALSE && ctx->index_node_size > 0)
+  if (msRectContained(&ctx->bounds, &rect) == MS_FALSE &&
+      ctx->index_node_size > 0) {
     flatgeobuf_index_search(ctx, &rect);
-  else
+    if (ctx->search_result_len == 0)
+      return MS_DONE;
+  } else {
     flatgeobuf_index_skip(ctx);
+  }
 
   return MS_SUCCESS;
 }
 
-int msFlatGeobufLayerNextShape(layerObj *layer, shapeObj *shape)
-{
+int msFlatGeobufLayerNextShape(layerObj *layer, shapeObj *shape) {
   flatgeobuf_ctx *ctx;
   ctx = layer->layerinfo;
   if (!ctx)
@@ -233,12 +236,14 @@ int msFlatGeobufLayerNextShape(layerObj
 
   do {
     if (ctx->search_result) {
-      if (ctx->search_index >= ctx->search_result_len - 1)
+      if (ctx->search_index >= ctx->search_result_len)
         return MS_DONE;
       flatgeobuf_search_item item = ctx->search_result[ctx->search_index];
-      if (VSIFSeekL(ctx->file, ctx->feature_offset + item.offset, SEEK_SET) == -1) {
-          msSetError(MS_FGBERR, "Unable to seek in file", "msFlatGeobufLayerNextShape");
-          return MS_FAILURE;
+      if (VSIFSeekL(ctx->file, ctx->feature_offset + item.offset, SEEK_SET) ==
+          -1) {
+        msSetError(MS_FGBERR, "Unable to seek in file",
+                   "msFlatGeobufLayerNextShape");
+        return MS_FAILURE;
       }
       ctx->offset = ctx->feature_offset + item.offset;
       ctx->search_index++;
@@ -253,17 +258,17 @@ int msFlatGeobufLayerNextShape(layerObj
     if (ctx->done)
       return MS_DONE;
     if (ctx->is_null_geom) {
-        msFreeCharArray(shape->values, shape->numvalues);
-        shape->values = NULL;
+      msFreeCharArray(shape->values, shape->numvalues);
+      shape->values = NULL;
     }
-  } while(ctx->is_null_geom);
+  } while (ctx->is_null_geom);
 
   return MS_SUCCESS;
 }
 
-int msFlatGeobufLayerGetShape(layerObj *layer, shapeObj *shape, resultObj *record)
-{
-  
+int msFlatGeobufLayerGetShape(layerObj *layer, shapeObj *shape,
+                              resultObj *record) {
+
   (void)shape;
   (void)record;
   flatgeobuf_ctx *ctx;
@@ -271,15 +276,16 @@ int msFlatGeobufLayerGetShape(layerObj *
   if (!ctx)
     return MS_FAILURE;
   long i = record->shapeindex;
-  if (i < 0 || (uint64_t) i >= ctx->features_count) {
+  if (i < 0 || (uint64_t)i >= ctx->features_count) {
     msSetError(MS_MISCERR, "Invalid feature id", "msFlatGeobufLayerGetShape");
     return MS_FAILURE;
   }
   uint64_t offset;
   flatgeobuf_read_feature_offset(ctx, i, &offset);
   if (VSIFSeekL(ctx->file, ctx->feature_offset + offset, SEEK_SET) == -1) {
-      msSetError(MS_FGBERR, "Unable to seek in file", "msFlatGeobufLayerGetShape");
-      return MS_FAILURE;
+    msSetError(MS_FGBERR, "Unable to seek in file",
+               "msFlatGeobufLayerGetShape");
+    return MS_FAILURE;
   }
   int ret = flatgeobuf_decode_feature(ctx, layer, shape);
   if (ret == -1)
@@ -287,8 +293,7 @@ int msFlatGeobufLayerGetShape(layerObj *
   return MS_SUCCESS;
 }
 
-int msFlatGeobufLayerClose(layerObj *layer)
-{
+int msFlatGeobufLayerClose(layerObj *layer) {
   flatgeobuf_ctx *ctx;
   ctx = layer->layerinfo;
   if (!ctx)
@@ -299,8 +304,7 @@ int msFlatGeobufLayerClose(layerObj *lay
   return MS_SUCCESS;
 }
 
-int msFlatGeobufLayerGetItems(layerObj *layer)
-{
+int msFlatGeobufLayerGetItems(layerObj *layer) {
   const char *value;
   flatgeobuf_ctx *ctx;
   ctx = layer->layerinfo;
@@ -308,20 +312,19 @@ int msFlatGeobufLayerGetItems(layerObj *
     return MS_FAILURE;
   layer->numitems = ctx->columns_len;
 
-  char **items = (char **) malloc(sizeof(char *) * ctx->columns_len);
+  char **items = (char **)malloc(sizeof(char *) * ctx->columns_len);
   for (int i = 0; i < ctx->columns_len; i++)
     items[i] = msStrdup(ctx->columns[i].name);
   layer->items = items;
 
-  if((value = msOWSLookupMetadata(&(layer->metadata), "G", "types")) != NULL
-      && strcasecmp(value,"auto") == 0 )
+  if ((value = msOWSLookupMetadata(&(layer->metadata), "G", "types")) != NULL &&
+      strcasecmp(value, "auto") == 0)
     msFGBPassThroughFieldDefinitions(layer, ctx);
 
   return msLayerInitItemInfo(layer);
 }
 
-int msFlatGeobufLayerGetExtent(layerObj *layer, rectObj *extent)
-{
+int msFlatGeobufLayerGetExtent(layerObj *layer, rectObj *extent) {
   flatgeobuf_ctx *ctx;
   ctx = layer->layerinfo;
   extent->minx = ctx->xmin;
@@ -331,18 +334,17 @@ int msFlatGeobufLayerGetExtent(layerObj
   return MS_SUCCESS;
 }
 
-int msFlatGeobufLayerSupportsCommonFilters(layerObj *layer)
-{
+int msFlatGeobufLayerSupportsCommonFilters(layerObj *layer) {
   (void)layer;
   return MS_TRUE;
 }
 
-int msFlatGeobufLayerInitializeVirtualTable(layerObj *layer)
-{
+int msFlatGeobufLayerInitializeVirtualTable(layerObj *layer) {
   assert(layer != NULL);
   assert(layer->vtable != NULL);
 
-  layer->vtable->LayerSupportsCommonFilters = msFlatGeobufLayerSupportsCommonFilters;
+  layer->vtable->LayerSupportsCommonFilters =
+      msFlatGeobufLayerSupportsCommonFilters;
   layer->vtable->LayerInitItemInfo = msFlatGeobufLayerInitItemInfo;
   layer->vtable->LayerFreeItemInfo = msFlatGeobufLayerFreeItemInfo;
   layer->vtable->LayerOpen = msFlatGeobufLayerOpen;
diff -pruN 8.0.1-5/mapgdal.cpp 8.0.2-1/mapgdal.cpp
--- 8.0.1-5/mapgdal.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapgdal.cpp	2024-06-11 20:41:34.000000000 +0000
@@ -32,28 +32,27 @@
 #include "mapgdal.h"
 #include <assert.h>
 
-
 #include "cpl_conv.h"
 #include "cpl_string.h"
 #include "ogr_srs_api.h"
 
 #include "gdal.h"
 
-static int    bGDALInitialized = 0;
+static int bGDALInitialized = 0;
 
 /************************************************************************/
 /*                          msGDALInitialize()                          */
 /************************************************************************/
 
-void msGDALInitialize( void )
+void msGDALInitialize(void)
 
 {
-  if( !bGDALInitialized ) {
-    msAcquireLock( TLOCK_GDAL );
+  if (!bGDALInitialized) {
+    msAcquireLock(TLOCK_GDAL);
 
     GDALAllRegister();
-    CPLPushErrorHandler( CPLQuietErrorHandler );
-    msReleaseLock( TLOCK_GDAL );
+    CPLPushErrorHandler(CPLQuietErrorHandler);
+    msReleaseLock(TLOCK_GDAL);
 
     bGDALInitialized = 1;
   }
@@ -63,42 +62,42 @@ void msGDALInitialize( void )
 /*                           msGDALCleanup()                            */
 /************************************************************************/
 
-void msGDALCleanup( void )
+void msGDALCleanup(void)
 
 {
-  if( bGDALInitialized ) {
+  if (bGDALInitialized) {
     int iRepeat = 5;
 
-      /*
-      ** Cleanup any unreferenced but open datasets as will tend
-      ** to exist due to deferred close requests.  We are careful
-      ** to only close one file at a time before refecting the
-      ** list as closing some datasets may cause others to be
-      ** closed (subdatasets in a VRT for instance).
-      */
+    /*
+    ** Cleanup any unreferenced but open datasets as will tend
+    ** to exist due to deferred close requests.  We are careful
+    ** to only close one file at a time before refecting the
+    ** list as closing some datasets may cause others to be
+    ** closed (subdatasets in a VRT for instance).
+    */
     GDALDatasetH *pahDSList = NULL;
     int nDSCount = 0;
     int bDidSomething;
 
-    msAcquireLock( TLOCK_GDAL );
+    msAcquireLock(TLOCK_GDAL);
 
     do {
-        int i;
-        GDALGetOpenDatasets( &pahDSList, &nDSCount );
-        bDidSomething = FALSE;
-        for( i = 0; i < nDSCount && !bDidSomething; i++ ) {
-          if( GDALReferenceDataset( pahDSList[i] ) == 1 ) {
-            GDALClose( pahDSList[i] );
-            bDidSomething = TRUE;
-          } else
-            GDALDereferenceDataset( pahDSList[i] );
-        }
-    } while( bDidSomething );
+      int i;
+      GDALGetOpenDatasets(&pahDSList, &nDSCount);
+      bDidSomething = FALSE;
+      for (i = 0; i < nDSCount && !bDidSomething; i++) {
+        if (GDALReferenceDataset(pahDSList[i]) == 1) {
+          GDALClose(pahDSList[i]);
+          bDidSomething = TRUE;
+        } else
+          GDALDereferenceDataset(pahDSList[i]);
+      }
+    } while (bDidSomething);
 
-    while( iRepeat-- )
+    while (iRepeat--)
       CPLPopErrorHandler();
 
-    msReleaseLock( TLOCK_GDAL );
+    msReleaseLock(TLOCK_GDAL);
 
     bGDALInitialized = 0;
   }
@@ -111,62 +110,61 @@ void msGDALCleanup( void )
 /*      things are clean before we start, and after we are done.        */
 /************************************************************************/
 
-void msCleanVSIDir( const char *pszDir )
+void msCleanVSIDir(const char *pszDir)
 
 {
-  char **papszFiles = CPLReadDir( pszDir );
-  int i, nFileCount = CSLCount( papszFiles );
+  char **papszFiles = CPLReadDir(pszDir);
+  int i, nFileCount = CSLCount(papszFiles);
 
-  for( i = 0; i < nFileCount; i++ ) {
-    if( strcasecmp(papszFiles[i],".") == 0
-        || strcasecmp(papszFiles[i],"..") == 0 )
+  for (i = 0; i < nFileCount; i++) {
+    if (strcasecmp(papszFiles[i], ".") == 0 ||
+        strcasecmp(papszFiles[i], "..") == 0)
       continue;
 
-    VSIUnlink( CPLFormFilename(pszDir, papszFiles[i], NULL) );
+    VSIUnlink(CPLFormFilename(pszDir, papszFiles[i], NULL));
   }
 
-  CSLDestroy( papszFiles );
+  CSLDestroy(papszFiles);
 }
 
 /************************************************************************/
 /*                          msSaveImageGDAL()                           */
 /************************************************************************/
 
-int msSaveImageGDAL( mapObj *map, imageObj *image, const char *filenameIn )
+int msSaveImageGDAL(mapObj *map, imageObj *image, const char *filenameIn)
 
 {
-  int  bFileIsTemporary = MS_FALSE;
+  int bFileIsTemporary = MS_FALSE;
   GDALDatasetH hMemDS, hOutputDS;
-  GDALDriverH  hMemDriver, hOutputDriver;
-  int          nBands = 1;
-  int          iLine;
+  GDALDriverH hMemDriver, hOutputDriver;
+  int nBands = 1;
+  int iLine;
   outputFormatObj *format = image->format;
   rasterBufferObj rb;
   GDALDataType eDataType = GDT_Byte;
   int bUseXmp = MS_FALSE;
-  const char   *filename = NULL;
-  char         *filenameToFree = NULL;
-  const char   *gdal_driver_shortname = format->driver+5;
+  const char *filename = NULL;
+  char *filenameToFree = NULL;
+  const char *gdal_driver_shortname = format->driver + 5;
 
   msGDALInitialize();
-  memset(&rb,0,sizeof(rasterBufferObj));
+  memset(&rb, 0, sizeof(rasterBufferObj));
 
 #ifdef USE_EXEMPI
-  if( map != NULL ) {
+  if (map != NULL) {
     bUseXmp = msXmpPresent(map);
   }
 #endif
 
-
   /* -------------------------------------------------------------------- */
   /*      Identify the proposed output driver.                            */
   /* -------------------------------------------------------------------- */
-  msAcquireLock( TLOCK_GDAL );
-  hOutputDriver = GDALGetDriverByName( gdal_driver_shortname );
-  if( hOutputDriver == NULL ) {
-    msReleaseLock( TLOCK_GDAL );
-    msSetError( MS_MISCERR, "Failed to find %s driver.",
-                "msSaveImageGDAL()", gdal_driver_shortname );
+  msAcquireLock(TLOCK_GDAL);
+  hOutputDriver = GDALGetDriverByName(gdal_driver_shortname);
+  if (hOutputDriver == NULL) {
+    msReleaseLock(TLOCK_GDAL);
+    msSetError(MS_MISCERR, "Failed to find %s driver.", "msSaveImageGDAL()",
+               gdal_driver_shortname);
     return MS_FAILURE;
   }
 
@@ -177,27 +175,26 @@ int msSaveImageGDAL( mapObj *map, imageO
   /*      memory, otherwise we try to put it in a reasonable temporary    */
   /*      file location.                                                  */
   /* -------------------------------------------------------------------- */
-  if( filenameIn == NULL ) {
+  if (filenameIn == NULL) {
     const char *pszExtension = format->extension;
-    if( pszExtension == NULL )
+    if (pszExtension == NULL)
       pszExtension = "img.tmp";
 
-    if( bUseXmp == MS_FALSE &&
-        msGDALDriverSupportsVirtualIOOutput(hOutputDriver) ) {
-      msCleanVSIDir( "/vsimem/msout" );
-      filenameToFree = msTmpFile(map, NULL, "/vsimem/msout/", pszExtension );
+    if (bUseXmp == MS_FALSE &&
+        msGDALDriverSupportsVirtualIOOutput(hOutputDriver)) {
+      msCleanVSIDir("/vsimem/msout");
+      filenameToFree = msTmpFile(map, NULL, "/vsimem/msout/", pszExtension);
     }
 
-    if( filenameToFree == NULL && map != NULL)
-      filenameToFree = msTmpFile(map, map->mappath,NULL,pszExtension);
-    else if( filenameToFree == NULL ) {
-      filenameToFree = msTmpFile(map, NULL, NULL, pszExtension );
+    if (filenameToFree == NULL && map != NULL)
+      filenameToFree = msTmpFile(map, map->mappath, NULL, pszExtension);
+    else if (filenameToFree == NULL) {
+      filenameToFree = msTmpFile(map, NULL, NULL, pszExtension);
     }
     filename = filenameToFree;
 
     bFileIsTemporary = MS_TRUE;
-  }
-  else {
+  } else {
     filename = filenameIn;
   }
 
@@ -206,35 +203,38 @@ int msSaveImageGDAL( mapObj *map, imageO
   /*      dataset.                                                        */
   /* -------------------------------------------------------------------- */
 
-  if( format->imagemode == MS_IMAGEMODE_RGB ) {
+  if (format->imagemode == MS_IMAGEMODE_RGB) {
     nBands = 3;
-    assert( MS_RENDERER_PLUGIN(format) && format->vtable->supports_pixel_buffer );
-    if(MS_UNLIKELY(MS_FAILURE == format->vtable->getRasterBufferHandle(image,&rb))) {
-      msReleaseLock( TLOCK_GDAL );
-      msFree( filenameToFree );
+    assert(MS_RENDERER_PLUGIN(format) && format->vtable->supports_pixel_buffer);
+    if (MS_UNLIKELY(MS_FAILURE ==
+                    format->vtable->getRasterBufferHandle(image, &rb))) {
+      msReleaseLock(TLOCK_GDAL);
+      msFree(filenameToFree);
       return MS_FAILURE;
     }
-  } else if( format->imagemode == MS_IMAGEMODE_RGBA ) {
+  } else if (format->imagemode == MS_IMAGEMODE_RGBA) {
     nBands = 4;
-    assert( MS_RENDERER_PLUGIN(format) && format->vtable->supports_pixel_buffer );
-    if(MS_UNLIKELY(MS_FAILURE == format->vtable->getRasterBufferHandle(image,&rb))) {
-      msReleaseLock( TLOCK_GDAL );
-      msFree( filenameToFree );
+    assert(MS_RENDERER_PLUGIN(format) && format->vtable->supports_pixel_buffer);
+    if (MS_UNLIKELY(MS_FAILURE ==
+                    format->vtable->getRasterBufferHandle(image, &rb))) {
+      msReleaseLock(TLOCK_GDAL);
+      msFree(filenameToFree);
       return MS_FAILURE;
     }
-  } else if( format->imagemode == MS_IMAGEMODE_INT16 ) {
+  } else if (format->imagemode == MS_IMAGEMODE_INT16) {
     nBands = format->bands;
     eDataType = GDT_Int16;
-  } else if( format->imagemode == MS_IMAGEMODE_FLOAT32 ) {
+  } else if (format->imagemode == MS_IMAGEMODE_FLOAT32) {
     nBands = format->bands;
     eDataType = GDT_Float32;
-  } else if( format->imagemode == MS_IMAGEMODE_BYTE ) {
+  } else if (format->imagemode == MS_IMAGEMODE_BYTE) {
     nBands = format->bands;
     eDataType = GDT_Byte;
   } else {
-    msReleaseLock( TLOCK_GDAL );
-    msSetError( MS_MEMERR, "Unknown format. This is a bug.", "msSaveImageGDAL()");
-    msFree( filenameToFree );
+    msReleaseLock(TLOCK_GDAL);
+    msSetError(MS_MEMERR, "Unknown format. This is a bug.",
+               "msSaveImageGDAL()");
+    msFree(filenameToFree);
     return MS_FAILURE;
   }
 
@@ -242,118 +242,117 @@ int msSaveImageGDAL( mapObj *map, imageO
   /*      Create a memory dataset which we can use as a source for a      */
   /*      CreateCopy().                                                   */
   /* -------------------------------------------------------------------- */
-  hMemDriver = GDALGetDriverByName( "MEM" );
-  if( hMemDriver == NULL ) {
-    msReleaseLock( TLOCK_GDAL );
-    msSetError( MS_MISCERR, "Failed to find MEM driver.",
-                "msSaveImageGDAL()" );
-    msFree( filenameToFree );
+  hMemDriver = GDALGetDriverByName("MEM");
+  if (hMemDriver == NULL) {
+    msReleaseLock(TLOCK_GDAL);
+    msSetError(MS_MISCERR, "Failed to find MEM driver.", "msSaveImageGDAL()");
+    msFree(filenameToFree);
     return MS_FAILURE;
   }
 
-  hMemDS = GDALCreate( hMemDriver, "msSaveImageGDAL_temp",
-                       image->width, image->height, nBands,
-                       eDataType, NULL );
-  if( hMemDS == NULL ) {
-    msReleaseLock( TLOCK_GDAL );
-    msSetError( MS_MISCERR, "Failed to create MEM dataset.",
-                "msSaveImageGDAL()" );
-    msFree( filenameToFree );
+  hMemDS = GDALCreate(hMemDriver, "msSaveImageGDAL_temp", image->width,
+                      image->height, nBands, eDataType, NULL);
+  if (hMemDS == NULL) {
+    msReleaseLock(TLOCK_GDAL);
+    msSetError(MS_MISCERR, "Failed to create MEM dataset.",
+               "msSaveImageGDAL()");
+    msFree(filenameToFree);
     return MS_FAILURE;
   }
 
   /* -------------------------------------------------------------------- */
   /*      Copy the gd image into the memory dataset.                      */
   /* -------------------------------------------------------------------- */
-  for( iLine = 0; iLine < image->height; iLine++ ) {
+  for (iLine = 0; iLine < image->height; iLine++) {
     int iBand;
 
-    for( iBand = 0; iBand < nBands; iBand++ ) {
+    for (iBand = 0; iBand < nBands; iBand++) {
       CPLErr eErr;
-      GDALRasterBandH hBand = GDALGetRasterBand( hMemDS, iBand+1 );
+      GDALRasterBandH hBand = GDALGetRasterBand(hMemDS, iBand + 1);
 
-      if( format->imagemode == MS_IMAGEMODE_INT16 ) {
-        eErr = GDALRasterIO( hBand, GF_Write, 0, iLine, image->width, 1,
-                      image->img.raw_16bit + iLine * image->width
-                      + iBand * image->width * image->height,
-                      image->width, 1, GDT_Int16, 2, 0 );
-
-      } else if( format->imagemode == MS_IMAGEMODE_FLOAT32 ) {
-        eErr = GDALRasterIO( hBand, GF_Write, 0, iLine, image->width, 1,
-                      image->img.raw_float + iLine * image->width
-                      + iBand * image->width * image->height,
-                      image->width, 1, GDT_Float32, 4, 0 );
-      } else if( format->imagemode == MS_IMAGEMODE_BYTE ) {
-        eErr = GDALRasterIO( hBand, GF_Write, 0, iLine, image->width, 1,
-                      image->img.raw_byte + iLine * image->width
-                      + iBand * image->width * image->height,
-                      image->width, 1, GDT_Byte, 1, 0 );
+      if (format->imagemode == MS_IMAGEMODE_INT16) {
+        eErr = GDALRasterIO(hBand, GF_Write, 0, iLine, image->width, 1,
+                            image->img.raw_16bit + iLine * image->width +
+                                iBand * image->width * image->height,
+                            image->width, 1, GDT_Int16, 2, 0);
+
+      } else if (format->imagemode == MS_IMAGEMODE_FLOAT32) {
+        eErr = GDALRasterIO(hBand, GF_Write, 0, iLine, image->width, 1,
+                            image->img.raw_float + iLine * image->width +
+                                iBand * image->width * image->height,
+                            image->width, 1, GDT_Float32, 4, 0);
+      } else if (format->imagemode == MS_IMAGEMODE_BYTE) {
+        eErr = GDALRasterIO(hBand, GF_Write, 0, iLine, image->width, 1,
+                            image->img.raw_byte + iLine * image->width +
+                                iBand * image->width * image->height,
+                            image->width, 1, GDT_Byte, 1, 0);
       } else {
         GByte *pabyData;
         unsigned char *pixptr = NULL;
-        assert( rb.type == MS_BUFFER_BYTE_RGBA );
-        switch(iBand) {
-          case 0:
-            pixptr = rb.data.rgba.r;
-            break;
-          case 1:
-            pixptr = rb.data.rgba.g;
-            break;
-          case 2:
-            pixptr = rb.data.rgba.b;
-            break;
-          case 3:
-            pixptr = rb.data.rgba.a;
-            break;
+        assert(rb.type == MS_BUFFER_BYTE_RGBA);
+        switch (iBand) {
+        case 0:
+          pixptr = rb.data.rgba.r;
+          break;
+        case 1:
+          pixptr = rb.data.rgba.g;
+          break;
+        case 2:
+          pixptr = rb.data.rgba.b;
+          break;
+        case 3:
+          pixptr = rb.data.rgba.a;
+          break;
         }
         assert(pixptr);
-        if( pixptr == NULL ) {
-          msReleaseLock( TLOCK_GDAL );
-          msSetError( MS_MISCERR, "Missing RGB or A buffer.\n",
-                      "msSaveImageGDAL()" );
+        if (pixptr == NULL) {
+          msReleaseLock(TLOCK_GDAL);
+          msSetError(MS_MISCERR, "Missing RGB or A buffer.\n",
+                     "msSaveImageGDAL()");
           GDALClose(hMemDS);
-          msFree( filenameToFree );
+          msFree(filenameToFree);
           return MS_FAILURE;
         }
 
-        pabyData = (GByte *)(pixptr + iLine*rb.data.rgba.row_step);
+        pabyData = (GByte *)(pixptr + iLine * rb.data.rgba.row_step);
 
-        if( rb.data.rgba.a == NULL || iBand == 3 ) {
-          eErr = GDALRasterIO( hBand, GF_Write, 0, iLine, image->width, 1,
-                        pabyData, image->width, 1, GDT_Byte,
-                        rb.data.rgba.pixel_step, 0 );
+        if (rb.data.rgba.a == NULL || iBand == 3) {
+          eErr = GDALRasterIO(hBand, GF_Write, 0, iLine, image->width, 1,
+                              pabyData, image->width, 1, GDT_Byte,
+                              rb.data.rgba.pixel_step, 0);
         } else { /* We need to un-pre-multiple RGB by alpha. */
-          GByte *pabyUPM = (GByte*) malloc(image->width);
-          GByte *pabyAlpha= (GByte *)(rb.data.rgba.a + iLine*rb.data.rgba.row_step);
+          GByte *pabyUPM = (GByte *)malloc(image->width);
+          GByte *pabyAlpha =
+              (GByte *)(rb.data.rgba.a + iLine * rb.data.rgba.row_step);
           int i;
 
-          for( i = 0; i < image->width; i++ ) {
-            int alpha = pabyAlpha[i*rb.data.rgba.pixel_step];
+          for (i = 0; i < image->width; i++) {
+            int alpha = pabyAlpha[i * rb.data.rgba.pixel_step];
 
-            if( alpha == 0 )
+            if (alpha == 0)
               pabyUPM[i] = 0;
             else {
-              int result = (pabyData[i*rb.data.rgba.pixel_step] * 255) / alpha;
+              int result =
+                  (pabyData[i * rb.data.rgba.pixel_step] * 255) / alpha;
 
-              if( result > 255 )
+              if (result > 255)
                 result = 255;
 
               pabyUPM[i] = result;
             }
           }
 
-          eErr = GDALRasterIO( hBand, GF_Write, 0, iLine, image->width, 1,
-                        pabyUPM, image->width, 1, GDT_Byte, 1, 0 );
-          free( pabyUPM );
+          eErr = GDALRasterIO(hBand, GF_Write, 0, iLine, image->width, 1,
+                              pabyUPM, image->width, 1, GDT_Byte, 1, 0);
+          free(pabyUPM);
         }
       }
-      if( eErr != CE_None ) {
-          msReleaseLock( TLOCK_GDAL );
-          msSetError( MS_MISCERR, "GDALRasterIO() failed.\n",
-                      "msSaveImageGDAL()" );
-          GDALClose(hMemDS);
-          msFree( filenameToFree );
-          return MS_FAILURE;
+      if (eErr != CE_None) {
+        msReleaseLock(TLOCK_GDAL);
+        msSetError(MS_MISCERR, "GDALRasterIO() failed.\n", "msSaveImageGDAL()");
+        GDALClose(hMemDS);
+        msFree(filenameToFree);
+        return MS_FAILURE;
       }
     }
   }
@@ -361,118 +360,107 @@ int msSaveImageGDAL( mapObj *map, imageO
   /* -------------------------------------------------------------------- */
   /*      Attach the palette if appropriate.                              */
   /* -------------------------------------------------------------------- */
-    if( format->imagemode == MS_IMAGEMODE_RGB ) {
-      GDALSetRasterColorInterpretation(
-        GDALGetRasterBand( hMemDS, 1 ), GCI_RedBand );
-      GDALSetRasterColorInterpretation(
-        GDALGetRasterBand( hMemDS, 2 ), GCI_GreenBand );
-      GDALSetRasterColorInterpretation(
-        GDALGetRasterBand( hMemDS, 3 ), GCI_BlueBand );
-    } else if( format->imagemode == MS_IMAGEMODE_RGBA ) {
-      GDALSetRasterColorInterpretation(
-        GDALGetRasterBand( hMemDS, 1 ), GCI_RedBand );
-      GDALSetRasterColorInterpretation(
-        GDALGetRasterBand( hMemDS, 2 ), GCI_GreenBand );
-      GDALSetRasterColorInterpretation(
-        GDALGetRasterBand( hMemDS, 3 ), GCI_BlueBand );
-      GDALSetRasterColorInterpretation(
-        GDALGetRasterBand( hMemDS, 4 ), GCI_AlphaBand );
-    }
+  if (format->imagemode == MS_IMAGEMODE_RGB) {
+    GDALSetRasterColorInterpretation(GDALGetRasterBand(hMemDS, 1), GCI_RedBand);
+    GDALSetRasterColorInterpretation(GDALGetRasterBand(hMemDS, 2),
+                                     GCI_GreenBand);
+    GDALSetRasterColorInterpretation(GDALGetRasterBand(hMemDS, 3),
+                                     GCI_BlueBand);
+  } else if (format->imagemode == MS_IMAGEMODE_RGBA) {
+    GDALSetRasterColorInterpretation(GDALGetRasterBand(hMemDS, 1), GCI_RedBand);
+    GDALSetRasterColorInterpretation(GDALGetRasterBand(hMemDS, 2),
+                                     GCI_GreenBand);
+    GDALSetRasterColorInterpretation(GDALGetRasterBand(hMemDS, 3),
+                                     GCI_BlueBand);
+    GDALSetRasterColorInterpretation(GDALGetRasterBand(hMemDS, 4),
+                                     GCI_AlphaBand);
+  }
 
   /* -------------------------------------------------------------------- */
   /*      Assign the projection and coordinate system to the memory       */
   /*      dataset.                                                        */
   /* -------------------------------------------------------------------- */
 
-  if( map != NULL ) {
+  if (map != NULL) {
     char *pszWKT;
 
-    GDALSetGeoTransform( hMemDS, map->gt.geotransform );
+    GDALSetGeoTransform(hMemDS, map->gt.geotransform);
 
-    pszWKT = msProjectionObj2OGCWKT( &(map->projection) );
-    if( pszWKT != NULL ) {
-      GDALSetProjection( hMemDS, pszWKT );
-      msFree( pszWKT );
+    pszWKT = msProjectionObj2OGCWKT(&(map->projection));
+    if (pszWKT != NULL) {
+      GDALSetProjection(hMemDS, pszWKT);
+      msFree(pszWKT);
     }
   }
 
   /* -------------------------------------------------------------------- */
   /*      Possibly assign a nodata value.                                 */
   /* -------------------------------------------------------------------- */
-  const char *nullvalue = msGetOutputFormatOption(format,"NULLVALUE",NULL);
-  if( nullvalue != NULL ) {
+  const char *nullvalue = msGetOutputFormatOption(format, "NULLVALUE", NULL);
+  if (nullvalue != NULL) {
     const double dfNullValue = atof(nullvalue);
-    for( int iBand = 0; iBand < nBands; iBand++ ) {
-      GDALRasterBandH hBand = GDALGetRasterBand( hMemDS, iBand+1 );
-      GDALSetRasterNoDataValue( hBand, dfNullValue );
+    for (int iBand = 0; iBand < nBands; iBand++) {
+      GDALRasterBandH hBand = GDALGetRasterBand(hMemDS, iBand + 1);
+      GDALSetRasterNoDataValue(hBand, dfNullValue);
     }
   }
 
   /* -------------------------------------------------------------------- */
   /*  Try to save resolution in the output file.                          */
   /* -------------------------------------------------------------------- */
-  if( image->resolution > 0 ) {
+  if (image->resolution > 0) {
     char res[30];
 
-    sprintf( res, "%lf", image->resolution );
-    GDALSetMetadataItem( hMemDS, "TIFFTAG_XRESOLUTION", res, NULL );
-    GDALSetMetadataItem( hMemDS, "TIFFTAG_YRESOLUTION", res, NULL );
-    GDALSetMetadataItem( hMemDS, "TIFFTAG_RESOLUTIONUNIT", "2", NULL );
+    sprintf(res, "%lf", image->resolution);
+    GDALSetMetadataItem(hMemDS, "TIFFTAG_XRESOLUTION", res, NULL);
+    GDALSetMetadataItem(hMemDS, "TIFFTAG_YRESOLUTION", res, NULL);
+    GDALSetMetadataItem(hMemDS, "TIFFTAG_RESOLUTIONUNIT", "2", NULL);
   }
 
   /* -------------------------------------------------------------------- */
   /*      Separate creation options from metadata items.                  */
   /* -------------------------------------------------------------------- */
-  std::vector<char*> apszCreationOptions;
-  for( int i = 0; i < format->numformatoptions; i++ )
-  {
-    char* option = format->formatoptions[i];
+  std::vector<char *> apszCreationOptions;
+  for (int i = 0; i < format->numformatoptions; i++) {
+    char *option = format->formatoptions[i];
 
     // MDI stands for MetaDataItem
-    if( STARTS_WITH(option, "mdi_") )
-    {
-      const char* option_without_band = option + strlen("mdi_");
+    if (STARTS_WITH(option, "mdi_")) {
+      const char *option_without_band = option + strlen("mdi_");
       GDALMajorObjectH hObject = (GDALMajorObjectH)hMemDS;
-      if( STARTS_WITH(option_without_band, "BAND_") )
-      {
+      if (STARTS_WITH(option_without_band, "BAND_")) {
         int nBandNumber = atoi(option_without_band + strlen("BAND_"));
-        if( nBandNumber > 0 && nBandNumber <= nBands )
-        {
-          const char* pszAfterBand = strchr(option_without_band + strlen("BAND_"), '_');
-          if( pszAfterBand != NULL )
-          {
-              hObject = (GDALMajorObjectH)GDALGetRasterBand(hMemDS, nBandNumber);
-              option_without_band = pszAfterBand + 1;
+        if (nBandNumber > 0 && nBandNumber <= nBands) {
+          const char *pszAfterBand =
+              strchr(option_without_band + strlen("BAND_"), '_');
+          if (pszAfterBand != NULL) {
+            hObject = (GDALMajorObjectH)GDALGetRasterBand(hMemDS, nBandNumber);
+            option_without_band = pszAfterBand + 1;
           }
-        }
-        else {
-          msDebug("Invalid band number %d in metadata item option %s", nBandNumber, option);
+        } else {
+          msDebug("Invalid band number %d in metadata item option %s",
+                  nBandNumber, option);
         }
       }
-      if( hObject ) {
+      if (hObject) {
         std::string osDomain(option_without_band);
         size_t nUnderscorePos = osDomain.find('_');
-        if( nUnderscorePos != std::string::npos ) {
+        if (nUnderscorePos != std::string::npos) {
           std::string osKeyValue = osDomain.substr(nUnderscorePos + 1);
           osDomain.resize(nUnderscorePos);
-          if( osDomain == "default" )
-              osDomain.clear();
+          if (osDomain == "default")
+            osDomain.clear();
           size_t nEqualPos = osKeyValue.find('=');
-          if( nEqualPos != std::string::npos )
-          {
-              GDALSetMetadataItem(hObject,
-                                  osKeyValue.substr(0, nEqualPos).c_str(),
-                                  osKeyValue.substr(nEqualPos + 1).c_str(),
-                                  osDomain.c_str());
+          if (nEqualPos != std::string::npos) {
+            GDALSetMetadataItem(
+                hObject, osKeyValue.substr(0, nEqualPos).c_str(),
+                osKeyValue.substr(nEqualPos + 1).c_str(), osDomain.c_str());
           }
-        }
-        else {
+        } else {
           msDebug("Invalid format in metadata item option %s", option);
         }
       }
-    }
-    else
-    {
+    } else {
       apszCreationOptions.emplace_back(option);
     }
   }
@@ -482,38 +470,35 @@ int msSaveImageGDAL( mapObj *map, imageO
   /*      Create a disk image in the selected output format from the      */
   /*      memory image.                                                   */
   /* -------------------------------------------------------------------- */
-  hOutputDS = GDALCreateCopy( hOutputDriver, filename, hMemDS, FALSE,
-                              &apszCreationOptions[0], NULL, NULL );
-
+  hOutputDS = GDALCreateCopy(hOutputDriver, filename, hMemDS, FALSE,
+                             &apszCreationOptions[0], NULL, NULL);
 
-  if( hOutputDS == NULL ) {
-    GDALClose( hMemDS );
-    msReleaseLock( TLOCK_GDAL );
-    msSetError( MS_MISCERR, "Failed to create output %s file.\n%s",
-                "msSaveImageGDAL()", format->driver+5,
-                CPLGetLastErrorMsg() );
-    msFree( filenameToFree );
+  if (hOutputDS == NULL) {
+    GDALClose(hMemDS);
+    msReleaseLock(TLOCK_GDAL);
+    msSetError(MS_MISCERR, "Failed to create output %s file.\n%s",
+               "msSaveImageGDAL()", format->driver + 5, CPLGetLastErrorMsg());
+    msFree(filenameToFree);
     return MS_FAILURE;
   }
 
   /* closing the memory DS also frees all associated resources. */
-  GDALClose( hMemDS );
-
-  GDALClose( hOutputDS );
-  msReleaseLock( TLOCK_GDAL );
+  GDALClose(hMemDS);
 
+  GDALClose(hOutputDS);
+  msReleaseLock(TLOCK_GDAL);
 
   /* -------------------------------------------------------------------- */
   /*      Are we writing license info into the image?                     */
   /*      If so, add it to the temp file on disk now.                     */
   /* -------------------------------------------------------------------- */
 #ifdef USE_EXEMPI
-  if ( bUseXmp == MS_TRUE ) {
-    if( msXmpWrite(map, filename) == MS_FAILURE ) {
+  if (bUseXmp == MS_TRUE) {
+    if (msXmpWrite(map, filename) == MS_FAILURE) {
       /* Something bad happened. */
-      msSetError( MS_MISCERR, "XMP write to %s failed.\n",
-                  "msSaveImageGDAL()", filename);
-      msFree( filenameToFree );
+      msSetError(MS_MISCERR, "XMP write to %s failed.\n", "msSaveImageGDAL()",
+                 filename);
+      msFree(filenameToFree);
       return MS_FAILURE;
     }
   }
@@ -523,39 +508,36 @@ int msSaveImageGDAL( mapObj *map, imageO
   /*      Is this supposed to be a temporary file?  If so, stream to      */
   /*      stdout and delete the file.                                     */
   /* -------------------------------------------------------------------- */
-  if( bFileIsTemporary ) {
+  if (bFileIsTemporary) {
     VSILFILE *fp;
     unsigned char block[4000];
     int bytes_read;
 
-    if( msIO_needBinaryStdout() == MS_FAILURE )
-    {
-      msFree( filenameToFree );
+    if (msIO_needBinaryStdout() == MS_FAILURE) {
+      msFree(filenameToFree);
       return MS_FAILURE;
     }
 
     /* We aren't sure how far back GDAL exports the VSI*L API, so
        we only use it if we suspect we need it.  But we do need it if
        holding temporary file in memory. */
-    fp = VSIFOpenL( filename, "rb" );
-    if( fp == NULL ) {
-      msSetError( MS_MISCERR,
-                  "Failed to open %s for streaming to stdout.",
-                  "msSaveImageGDAL()", filename );
-      msFree( filenameToFree );
+    fp = VSIFOpenL(filename, "rb");
+    if (fp == NULL) {
+      msSetError(MS_MISCERR, "Failed to open %s for streaming to stdout.",
+                 "msSaveImageGDAL()", filename);
+      msFree(filenameToFree);
       return MS_FAILURE;
     }
 
-    while( (bytes_read = VSIFReadL(block, 1, sizeof(block), fp)) > 0 )
-      msIO_fwrite( block, 1, bytes_read, stdout );
-
-    VSIFCloseL( fp );
+    while ((bytes_read = VSIFReadL(block, 1, sizeof(block), fp)) > 0)
+      msIO_fwrite(block, 1, bytes_read, stdout);
 
-    VSIUnlink( filename );
-    msCleanVSIDir( "/vsimem/msout" );
+    VSIFCloseL(fp);
 
+    VSIUnlink(filename);
+    msCleanVSIDir("/vsimem/msout");
   }
-  msFree( filenameToFree );
+  msFree(filenameToFree);
 
   return MS_SUCCESS;
 }
@@ -564,7 +546,7 @@ int msSaveImageGDAL( mapObj *map, imageO
 /*                       msInitGDALOutputFormat()                       */
 /************************************************************************/
 
-int msInitDefaultGDALOutputFormat( outputFormatObj *format )
+int msInitDefaultGDALOutputFormat(outputFormatObj *format)
 
 {
   GDALDriverH hDriver;
@@ -576,17 +558,17 @@ int msInitDefaultGDALOutputFormat( outpu
   /*      be pretty threadsafe so don't bother acquiring the GDAL         */
   /*      lock.                                                           */
   /* -------------------------------------------------------------------- */
-  hDriver = GDALGetDriverByName( format->driver+5 );
-  if( hDriver == NULL ) {
-    msSetError( MS_MISCERR, "No GDAL driver named `%s' available.",
-                "msInitGDALOutputFormat()", format->driver+5 );
+  hDriver = GDALGetDriverByName(format->driver + 5);
+  if (hDriver == NULL) {
+    msSetError(MS_MISCERR, "No GDAL driver named `%s' available.",
+               "msInitGDALOutputFormat()", format->driver + 5);
     return MS_FAILURE;
   }
 
-  if( GDALGetMetadataItem( hDriver, GDAL_DCAP_CREATE, NULL ) == NULL
-      && GDALGetMetadataItem( hDriver, GDAL_DCAP_CREATECOPY, NULL ) == NULL ) {
-    msSetError( MS_MISCERR, "GDAL `%s' driver does not support output.",
-                "msInitGDALOutputFormat()", format->driver+5 );
+  if (GDALGetMetadataItem(hDriver, GDAL_DCAP_CREATE, NULL) == NULL &&
+      GDALGetMetadataItem(hDriver, GDAL_DCAP_CREATECOPY, NULL) == NULL) {
+    msSetError(MS_MISCERR, "GDAL `%s' driver does not support output.",
+               "msInitGDALOutputFormat()", format->driver + 5);
     return MS_FAILURE;
   }
 
@@ -596,28 +578,29 @@ int msInitDefaultGDALOutputFormat( outpu
   format->imagemode = MS_IMAGEMODE_RGB;
   format->renderer = MS_RENDER_WITH_AGG;
 
-  if( GDALGetMetadataItem( hDriver, GDAL_DMD_MIMETYPE, NULL ) != NULL )
+  if (GDALGetMetadataItem(hDriver, GDAL_DMD_MIMETYPE, NULL) != NULL)
     format->mimetype =
-      msStrdup(GDALGetMetadataItem(hDriver,GDAL_DMD_MIMETYPE,NULL));
-  if( GDALGetMetadataItem( hDriver, GDAL_DMD_EXTENSION, NULL ) != NULL )
+        msStrdup(GDALGetMetadataItem(hDriver, GDAL_DMD_MIMETYPE, NULL));
+  if (GDALGetMetadataItem(hDriver, GDAL_DMD_EXTENSION, NULL) != NULL)
     format->extension =
-      msStrdup(GDALGetMetadataItem(hDriver,GDAL_DMD_EXTENSION,NULL));
+        msStrdup(GDALGetMetadataItem(hDriver, GDAL_DMD_EXTENSION, NULL));
 
   return MS_SUCCESS;
 }
 
-char** msGetStringListFromHashTable(hashTableObj* table)
-{
+char **msGetStringListFromHashTable(hashTableObj *table) {
   struct hashObj *tp = NULL;
   int i;
-  char** papszRet = NULL;
+  char **papszRet = NULL;
 
-  if(!table) return NULL;
-  if(msHashIsEmpty(table)) return NULL;
+  if (!table)
+    return NULL;
+  if (msHashIsEmpty(table))
+    return NULL;
 
-  for (i=0; i<MS_HASHSIZE; ++i) {
+  for (i = 0; i < MS_HASHSIZE; ++i) {
     if (table->items[i] != NULL) {
-      for (tp=table->items[i]; tp!=NULL; tp=tp->next) {
+      for (tp = table->items[i]; tp != NULL; tp = tp->next) {
         papszRet = CSLSetNameValue(papszRet, tp->key, tp->data);
       }
     }
@@ -625,7 +608,6 @@ char** msGetStringListFromHashTable(hash
   return papszRet;
 }
 
-
 /************************************************************************/
 /*                      msProjectionObj2OGCWKT()                        */
 /*                                                                      */
@@ -637,59 +619,59 @@ char** msGetStringListFromHashTable(hash
 /*      returned string should be freed with msFree().                  */
 /************************************************************************/
 
-char *msProjectionObj2OGCWKT( projectionObj *projection )
+char *msProjectionObj2OGCWKT(projectionObj *projection)
 
 {
   OGRSpatialReferenceH hSRS;
-  char *pszWKT=NULL, *pszProj4, *pszInitEpsg=NULL;
-  int  nLength = 0, i;
+  char *pszWKT = NULL, *pszProj4, *pszInitEpsg = NULL;
+  int nLength = 0, i;
   OGRErr eErr;
 
-  if( projection->proj == NULL )
+  if (projection->proj == NULL)
     return NULL;
 
-  hSRS = OSRNewSpatialReference( NULL );
+  hSRS = OSRNewSpatialReference(NULL);
   /* -------------------------------------------------------------------- */
   /*      Look for an EPSG-like projection argument                       */
   /* -------------------------------------------------------------------- */
-  if( projection->numargs == 1 &&
-        (pszInitEpsg = strcasestr(projection->args[0],"init=epsg:"))) {
-     int nEpsgCode = atoi(pszInitEpsg + strlen("init=epsg:"));
-     eErr = OSRImportFromEPSG(hSRS, nEpsgCode);
+  if (projection->numargs == 1 &&
+      (pszInitEpsg = strcasestr(projection->args[0], "init=epsg:"))) {
+    int nEpsgCode = atoi(pszInitEpsg + strlen("init=epsg:"));
+    eErr = OSRImportFromEPSG(hSRS, nEpsgCode);
   } else {
     /* -------------------------------------------------------------------- */
     /*      Form arguments into a full Proj.4 definition string.            */
     /* -------------------------------------------------------------------- */
-    for( i = 0; i < projection->numargs; i++ )
+    for (i = 0; i < projection->numargs; i++)
       nLength += strlen(projection->args[i]) + 2;
 
-    pszProj4 = (char *) CPLMalloc(nLength+2);
+    pszProj4 = (char *)CPLMalloc(nLength + 2);
     pszProj4[0] = '\0';
 
-    for( i = 0; i < projection->numargs; i++ ) {
-      strcat( pszProj4, "+" );
-      strcat( pszProj4, projection->args[i] );
-      strcat( pszProj4, " " );
+    for (i = 0; i < projection->numargs; i++) {
+      strcat(pszProj4, "+");
+      strcat(pszProj4, projection->args[i]);
+      strcat(pszProj4, " ");
     }
 
     /* -------------------------------------------------------------------- */
     /*      Ingest the string into OGRSpatialReference.                     */
     /* -------------------------------------------------------------------- */
-    eErr =  OSRImportFromProj4( hSRS, pszProj4 );
-    CPLFree( pszProj4 );
+    eErr = OSRImportFromProj4(hSRS, pszProj4);
+    CPLFree(pszProj4);
   }
 
   /* -------------------------------------------------------------------- */
   /*      Export as a WKT string.                                         */
   /* -------------------------------------------------------------------- */
-  if( eErr == OGRERR_NONE )
-    OSRExportToWkt( hSRS, &pszWKT );
+  if (eErr == OGRERR_NONE)
+    OSRExportToWkt(hSRS, &pszWKT);
 
-  OSRDestroySpatialReference( hSRS );
+  OSRDestroySpatialReference(hSRS);
 
-  if( pszWKT ) {
+  if (pszWKT) {
     char *pszWKT2 = msStrdup(pszWKT);
-    CPLFree( pszWKT );
+    CPLFree(pszWKT);
 
     return pszWKT2;
   } else
@@ -700,11 +682,10 @@ char *msProjectionObj2OGCWKT( projection
 /*                    msGDALDriverSupportsVirtualIOOutput()             */
 /************************************************************************/
 
-int msGDALDriverSupportsVirtualIOOutput( GDALDriverH hDriver )
-{
-    /* We need special testing here for the netCDF driver, since recent */
-    /* GDAL versions advertize VirtualIO support, but this is only for the */
-    /* read-side of the driver, not the write-side. */
-    return GDALGetMetadataItem( hDriver, GDAL_DCAP_VIRTUALIO, NULL ) != NULL &&
-           !EQUAL(GDALGetDescription(hDriver), "netCDF");
+int msGDALDriverSupportsVirtualIOOutput(GDALDriverH hDriver) {
+  /* We need special testing here for the netCDF driver, since recent */
+  /* GDAL versions advertize VirtualIO support, but this is only for the */
+  /* read-side of the driver, not the write-side. */
+  return GDALGetMetadataItem(hDriver, GDAL_DCAP_VIRTUALIO, NULL) != NULL &&
+         !EQUAL(GDALGetDescription(hDriver), "netCDF");
 }
diff -pruN 8.0.1-5/mapgdal.h 8.0.2-1/mapgdal.h
--- 8.0.1-5/mapgdal.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapgdal.h	2024-06-11 20:41:34.000000000 +0000
@@ -37,7 +37,7 @@
 extern "C" {
 #endif
 
-int msGDALDriverSupportsVirtualIOOutput( GDALDriverH hDriver );
+int msGDALDriverSupportsVirtualIOOutput(GDALDriverH hDriver);
 
 #ifdef __cplusplus
 }
diff -pruN 8.0.1-5/mapgeomtransform.c 8.0.2-1/mapgeomtransform.c
--- 8.0.1-5/mapgeomtransform.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapgeomtransform.c	2024-06-11 20:41:34.000000000 +0000
@@ -32,8 +32,7 @@
 
 extern int yyparse(parseObj *p);
 
-void msStyleSetGeomTransform(styleObj *s, char *transform)
-{
+void msStyleSetGeomTransform(styleObj *s, char *transform) {
   msFree(s->_geomtransform.string);
   if (!transform) {
     s->_geomtransform.type = MS_GEOMTRANSFORM_NONE;
@@ -41,71 +40,65 @@ void msStyleSetGeomTransform(styleObj *s
     return;
   }
   s->_geomtransform.string = msStrdup(transform);
-  if(!strncasecmp("start",transform,5)) {
+  if (!strncasecmp("start", transform, 5)) {
     s->_geomtransform.type = MS_GEOMTRANSFORM_START;
-  } else if(!strncasecmp("end",transform,3)) {
+  } else if (!strncasecmp("end", transform, 3)) {
     s->_geomtransform.type = MS_GEOMTRANSFORM_END;
-  } else if(!strncasecmp("vertices",transform,8)) {
+  } else if (!strncasecmp("vertices", transform, 8)) {
     s->_geomtransform.type = MS_GEOMTRANSFORM_VERTICES;
-  } else if(!strncasecmp("bbox",transform,4)) {
+  } else if (!strncasecmp("bbox", transform, 4)) {
     s->_geomtransform.type = MS_GEOMTRANSFORM_BBOX;
-  } else if(!strncasecmp("labelpnt",transform,8)) {
+  } else if (!strncasecmp("labelpnt", transform, 8)) {
     s->_geomtransform.type = MS_GEOMTRANSFORM_LABELPOINT;
-  } else if(!strncasecmp("labelpoly",transform,9)) {
+  } else if (!strncasecmp("labelpoly", transform, 9)) {
     s->_geomtransform.type = MS_GEOMTRANSFORM_LABELPOLY;
-  } else if(!strncasecmp("labelcenter",transform,11)) {
+  } else if (!strncasecmp("labelcenter", transform, 11)) {
     s->_geomtransform.type = MS_GEOMTRANSFORM_LABELCENTER;
-  } else if(!strncasecmp("centroid",transform,8)) {
+  } else if (!strncasecmp("centroid", transform, 8)) {
     s->_geomtransform.type = MS_GEOMTRANSFORM_CENTROID;
   } else {
     s->_geomtransform.type = MS_GEOMTRANSFORM_NONE;
-    msSetError(MS_MISCERR,"unknown transform expression","msStyleSetGeomTransform()");
+    msSetError(MS_MISCERR, "unknown transform expression",
+               "msStyleSetGeomTransform()");
     msFree(s->_geomtransform.string);
     s->_geomtransform.string = NULL;
   }
 }
 
-
 /*
  * return a copy of the geometry transform expression
  * returned char* must be freed by the caller
  */
-char *msStyleGetGeomTransform(styleObj *s)
-{
+char *msStyleGetGeomTransform(styleObj *s) {
   return msStrdup(s->_geomtransform.string);
 }
 
-
-double calcOrientation(pointObj *p1, pointObj *p2)
-{
+double calcOrientation(pointObj *p1, pointObj *p2) {
   double theta;
-  theta = atan2(p2->x - p1->x,p2->y - p1->y);
-  return MS_RAD_TO_DEG*(theta-MS_PI2);
+  theta = atan2(p2->x - p1->x, p2->y - p1->y);
+  return MS_RAD_TO_DEG * (theta - MS_PI2);
 }
 
-double calcMidAngle(pointObj *p1, pointObj *p2, pointObj *p3)
-{
+double calcMidAngle(pointObj *p1, pointObj *p2, pointObj *p3) {
   pointObj p1n;
   double dx12, dy12, dx23, dy23, l12, l23;
 
-  /* We treat both segments as vector 1-2 and vector 2-3 and 
-   * compute their dx,dy and length 
+  /* We treat both segments as vector 1-2 and vector 2-3 and
+   * compute their dx,dy and length
    */
   dx12 = p2->x - p1->x;
   dy12 = p2->y - p1->y;
-  l12 = sqrt(dx12*dx12 + dy12*dy12);
+  l12 = sqrt(dx12 * dx12 + dy12 * dy12);
   dx23 = p3->x - p2->x;
   dy23 = p3->y - p2->y;
-  l23 = sqrt(dx23*dx23 + dy23*dy23);
+  l23 = sqrt(dx23 * dx23 + dy23 * dy23);
 
   /* Normalize length of vector 1-2 to same as length of vector 2-3 */
-  if (l12 > 0.0)
-  {
-    p1n.x = p2->x - dx12*(l23/l12);
-    p1n.y = p2->y - dy12*(l23/l12);
-  }
-  else
-    p1n = *p2;  /* segment 1-2 is 0-length, use segment 2-3 for orientation */
+  if (l12 > 0.0) {
+    p1n.x = p2->x - dx12 * (l23 / l12);
+    p1n.y = p2->y - dy12 * (l23 / l12);
+  } else
+    p1n = *p2; /* segment 1-2 is 0-length, use segment 2-3 for orientation */
 
   /* Return the orientation defined by the sum of the normalized vectors */
   return calcOrientation(&p1n, p3);
@@ -116,133 +109,139 @@ double calcMidAngle(pointObj *p1, pointO
  *  - transform the original shapeobj
  *  - use the styleObj to render the transformed shapeobj
  */
-int msDrawTransformedShape(mapObj *map, imageObj *image, shapeObj *shape, styleObj *style, double scalefactor)
-{
+int msDrawTransformedShape(mapObj *map, imageObj *image, shapeObj *shape,
+                           styleObj *style, double scalefactor) {
   int type = style->_geomtransform.type;
-  int i,j,status = MS_SUCCESS;
-  switch(type) {
-    case MS_GEOMTRANSFORM_END: /*render point on last vertex only*/
-      for(j=0; j<shape->numlines; j++) {
-        lineObj *line = &(shape->line[j]);
-        pointObj *p = &(line->point[line->numpoints-1]);
-        if(p->x<0||p->x>image->width||p->y<0||p->y>image->height)
-          continue;
-        if(style->autoangle==MS_TRUE && line->numpoints>1) {
-          style->angle = calcOrientation(&(line->point[line->numpoints-2]),p);
-        }
-        status = msDrawMarkerSymbol(map,image,p,style,scalefactor);
-      }
-      break;
-    case MS_GEOMTRANSFORM_START: /*render point on first vertex only*/
-      for(j=0; j<shape->numlines; j++) {
-        lineObj *line = &(shape->line[j]);
-        pointObj *p = &(line->point[0]);
-        /*skip if outside image*/
-        if(p->x<0||p->x>image->width||p->y<0||p->y>image->height)
-          continue;
-        if(style->autoangle==MS_TRUE && line->numpoints>1) {
-          style->angle = calcOrientation(p,&(line->point[1]));
-        }
-        status = msDrawMarkerSymbol(map,image,p,style,scalefactor);
-      }
-      break;
-    case MS_GEOMTRANSFORM_VERTICES:
-      for(j=0; j<shape->numlines; j++) {
-        lineObj *line = &(shape->line[j]);
-        for(i=1; i<line->numpoints-1; i++) {
-          pointObj *p = &(line->point[i]);
-          /*skip points outside image*/
-          if(p->x<0||p->x>image->width||p->y<0||p->y>image->height)
-            continue;
-          if(style->autoangle==MS_TRUE) {
-            style->angle = calcMidAngle(&(line->point[i-1]),&(line->point[i]),&(line->point[i+1]));
-          }
-          status = msDrawMarkerSymbol(map,image,p,style,scalefactor);
-        }
+  int i, j, status = MS_SUCCESS;
+  switch (type) {
+  case MS_GEOMTRANSFORM_END: /*render point on last vertex only*/
+    for (j = 0; j < shape->numlines; j++) {
+      lineObj *line = &(shape->line[j]);
+      pointObj *p = &(line->point[line->numpoints - 1]);
+      if (p->x < 0 || p->x > image->width || p->y < 0 || p->y > image->height)
+        continue;
+      if (style->autoangle == MS_TRUE && line->numpoints > 1) {
+        style->angle = calcOrientation(&(line->point[line->numpoints - 2]), p);
       }
-      break;
-    case MS_GEOMTRANSFORM_BBOX: {
-      shapeObj bbox;
-      lineObj bbox_line;
-      pointObj bbox_points[5];
-      int padding = MS_MAX(style->width,style->size)+3; /* so clipped shape does not extent into image */
-
-      /*create a shapeObj representing the bounding box (clipped by the image size)*/
-      bbox.numlines = 1;
-      bbox.line = &bbox_line;
-      bbox.line->numpoints = 5;
-      bbox.line->point = bbox_points;
-
-      msComputeBounds(shape);
-      bbox_points[0].x=bbox_points[4].x=bbox_points[1].x =
-                                          (shape->bounds.minx < -padding) ? -padding : shape->bounds.minx;
-      /* cppcheck-suppress unreadVariable */
-      bbox_points[2].x=bbox_points[3].x =
-                         (shape->bounds.maxx > image->width+padding) ? image->width+padding : shape->bounds.maxx;
-      bbox_points[0].y=bbox_points[4].y=bbox_points[3].y =
-                                          (shape->bounds.miny < -padding) ? -padding : shape->bounds.miny;
-      /* cppcheck-suppress unreadVariable */
-      bbox_points[1].y=bbox_points[2].y =
-                         (shape->bounds.maxy > image->height+padding) ? image->height+padding : shape->bounds.maxy;
-      status = msDrawShadeSymbol(map, image, &bbox, style, scalefactor);
+      status = msDrawMarkerSymbol(map, image, p, style, scalefactor);
     }
     break;
-    case MS_GEOMTRANSFORM_CENTROID: {
-      double unused; /*used by centroid function*/
-      pointObj centroid;
-      if(MS_SUCCESS == msGetPolygonCentroid(shape,&centroid,&unused,&unused)) {
-        status = msDrawMarkerSymbol(map,image,&centroid,style,scalefactor);
+  case MS_GEOMTRANSFORM_START: /*render point on first vertex only*/
+    for (j = 0; j < shape->numlines; j++) {
+      lineObj *line = &(shape->line[j]);
+      pointObj *p = &(line->point[0]);
+      /*skip if outside image*/
+      if (p->x < 0 || p->x > image->width || p->y < 0 || p->y > image->height)
+        continue;
+      if (style->autoangle == MS_TRUE && line->numpoints > 1) {
+        style->angle = calcOrientation(p, &(line->point[1]));
       }
+      status = msDrawMarkerSymbol(map, image, p, style, scalefactor);
     }
     break;
-    case MS_GEOMTRANSFORM_EXPRESSION: {
-      int status;
-      shapeObj *tmpshp;
-      parseObj p;
-
-      p.shape = shape; /* set a few parser globals (hence the lock) */
-      p.expr = &(style->_geomtransform);
-
-      if(p.expr->tokens == NULL) { /* this could happen if drawing originates from legend code (#5193) */
-        status = msTokenizeExpression(p.expr, NULL, NULL);
-        if(status != MS_SUCCESS) {
-          msSetError(MS_MISCERR, "Unable to tokenize expression.", "msDrawTransformedShape()");
-          return MS_FAILURE;
+  case MS_GEOMTRANSFORM_VERTICES:
+    for (j = 0; j < shape->numlines; j++) {
+      lineObj *line = &(shape->line[j]);
+      for (i = 1; i < line->numpoints - 1; i++) {
+        pointObj *p = &(line->point[i]);
+        /*skip points outside image*/
+        if (p->x < 0 || p->x > image->width || p->y < 0 || p->y > image->height)
+          continue;
+        if (style->autoangle == MS_TRUE) {
+          style->angle = calcMidAngle(&(line->point[i - 1]), &(line->point[i]),
+                                      &(line->point[i + 1]));
         }
+        status = msDrawMarkerSymbol(map, image, p, style, scalefactor);
       }
-
-      p.expr->curtoken = p.expr->tokens; /* reset */
-      p.type = MS_PARSE_TYPE_SHAPE;
-
-      status = yyparse(&p);
-      if (status != 0) {
-        msSetError(MS_PARSEERR, "Failed to process shape expression: %s", "msDrawTransformedShape", style->_geomtransform.string);
+    }
+    break;
+  case MS_GEOMTRANSFORM_BBOX: {
+    shapeObj bbox;
+    lineObj bbox_line;
+    pointObj bbox_points[5];
+    int padding = MS_MAX(style->width, style->size) +
+                  3; /* so clipped shape does not extent into image */
+
+    /*create a shapeObj representing the bounding box (clipped by the image
+     * size)*/
+    bbox.numlines = 1;
+    bbox.line = &bbox_line;
+    bbox.line->numpoints = 5;
+    bbox.line->point = bbox_points;
+
+    msComputeBounds(shape);
+    bbox_points[0].x = bbox_points[4].x = bbox_points[1].x =
+        (shape->bounds.minx < -padding) ? -padding : shape->bounds.minx;
+    /* cppcheck-suppress unreadVariable */
+    bbox_points[2].x = bbox_points[3].x =
+        (shape->bounds.maxx > image->width + padding) ? image->width + padding
+                                                      : shape->bounds.maxx;
+    bbox_points[0].y = bbox_points[4].y = bbox_points[3].y =
+        (shape->bounds.miny < -padding) ? -padding : shape->bounds.miny;
+    /* cppcheck-suppress unreadVariable */
+    bbox_points[1].y = bbox_points[2].y =
+        (shape->bounds.maxy > image->height + padding) ? image->height + padding
+                                                       : shape->bounds.maxy;
+    status = msDrawShadeSymbol(map, image, &bbox, style, scalefactor);
+  } break;
+  case MS_GEOMTRANSFORM_CENTROID: {
+    double unused; /*used by centroid function*/
+    pointObj centroid;
+    if (MS_SUCCESS ==
+        msGetPolygonCentroid(shape, &centroid, &unused, &unused)) {
+      status = msDrawMarkerSymbol(map, image, &centroid, style, scalefactor);
+    }
+  } break;
+  case MS_GEOMTRANSFORM_EXPRESSION: {
+    int status;
+    shapeObj *tmpshp;
+    parseObj p;
+
+    p.shape = shape; /* set a few parser globals (hence the lock) */
+    p.expr = &(style->_geomtransform);
+
+    if (p.expr->tokens == NULL) { /* this could happen if drawing originates
+                                     from legend code (#5193) */
+      status = msTokenizeExpression(p.expr, NULL, NULL);
+      if (status != MS_SUCCESS) {
+        msSetError(MS_MISCERR, "Unable to tokenize expression.",
+                   "msDrawTransformedShape()");
         return MS_FAILURE;
       }
-      tmpshp = p.result.shpval;
+    }
 
-      switch (tmpshp->type) {
-        case MS_SHAPE_POINT:
-        case MS_SHAPE_POLYGON:
-          /* cppcheck-suppress unreadVariable */
-          status = msDrawShadeSymbol(map, image, tmpshp, style, scalefactor);
-          break;
-        case MS_SHAPE_LINE:
-          /* cppcheck-suppress unreadVariable */
-          status = msDrawLineSymbol(map, image, tmpshp, style, scalefactor);
-          break;
-      }
+    p.expr->curtoken = p.expr->tokens; /* reset */
+    p.type = MS_PARSE_TYPE_SHAPE;
 
-      msFreeShape(tmpshp);
-      msFree(tmpshp);
+    status = yyparse(&p);
+    if (status != 0) {
+      msSetError(MS_PARSEERR, "Failed to process shape expression: %s",
+                 "msDrawTransformedShape", style->_geomtransform.string);
+      return MS_FAILURE;
     }
-    break;
-    case MS_GEOMTRANSFORM_LABELPOINT:
-    case MS_GEOMTRANSFORM_LABELPOLY:
+    tmpshp = p.result.shpval;
+
+    switch (tmpshp->type) {
+    case MS_SHAPE_POINT:
+    case MS_SHAPE_POLYGON:
+      /* cppcheck-suppress unreadVariable */
+      status = msDrawShadeSymbol(map, image, tmpshp, style, scalefactor);
       break;
-    default:
-      msSetError(MS_MISCERR, "unknown geomtransform", "msDrawTransformedShape()");
-      return MS_FAILURE;
+    case MS_SHAPE_LINE:
+      /* cppcheck-suppress unreadVariable */
+      status = msDrawLineSymbol(map, image, tmpshp, style, scalefactor);
+      break;
+    }
+
+    msFreeShape(tmpshp);
+    msFree(tmpshp);
+  } break;
+  case MS_GEOMTRANSFORM_LABELPOINT:
+  case MS_GEOMTRANSFORM_LABELPOLY:
+    break;
+  default:
+    msSetError(MS_MISCERR, "unknown geomtransform", "msDrawTransformedShape()");
+    return MS_FAILURE;
   }
   return status;
 }
@@ -251,70 +250,71 @@ int msDrawTransformedShape(mapObj *map,
  * RFC89 implementation:
  *  - transform directly the shapeobj
  */
-int msGeomTransformShape(mapObj *map, layerObj *layer, shapeObj *shape)
-{
+int msGeomTransformShape(mapObj *map, layerObj *layer, shapeObj *shape) {
   int i;
-  expressionObj *e =  &layer->_geomtransform;  
+  expressionObj *e = &layer->_geomtransform;
 
 #ifdef USE_V8_MAPSCRIPT
   if (!map->v8context) {
     msV8CreateContext(map);
-    if (!map->v8context)
-    {
-      msSetError(MS_V8ERR, "Unable to create v8 context.", "msGeomTransformShape()");
+    if (!map->v8context) {
+      msSetError(MS_V8ERR, "Unable to create v8 context.",
+                 "msGeomTransformShape()");
       return MS_FAILURE;
     }
   }
 
   msV8ContextSetLayer(map, layer);
 #endif
- 
-  switch(e->type) {
-    case MS_GEOMTRANSFORM_EXPRESSION: {
-      int status;
-      shapeObj *tmpshp;
-      parseObj p;
-
-      p.shape = shape; /* set a few parser globals (hence the lock) */
-      p.expr = e;
-      p.expr->curtoken = p.expr->tokens; /* reset */
-      p.type = MS_PARSE_TYPE_SHAPE;
-      p.dblval = map->cellsize * (msInchesPerUnit(map->units,0)/msInchesPerUnit(layer->units,0));
-      p.dblval2 = 0;
-      /* data_cellsize is only set with contour layer */
-      if (layer->connectiontype == MS_CONTOUR)
-      {
-        const char *value = msLookupHashTable(&layer->metadata, "__data_cellsize__");
-        if (value)
-          p.dblval2 = atof(value);
-      }
-          
-      status = yyparse(&p);
-      if (status != 0) {
-        msSetError(MS_PARSEERR, "Failed to process shape expression: %s", "msGeomTransformShape()", e->string);
-        return MS_FAILURE;
-      }
-      
-      tmpshp = p.result.shpval;
 
-      for (i= 0; i < shape->numlines; i++)
-        free(shape->line[i].point);
-      shape->numlines = 0;
-      if (shape->line) free(shape->line);
-      shape->line = NULL;
-      shape->type = tmpshp->type; /* might have been a change (e.g. centerline) */
-
-      for(i=0; i<tmpshp->numlines; i++)
-        msAddLine(shape, &(tmpshp->line[i])); /* copy each line */
-
-      msFreeShape(tmpshp);
-      msFree(tmpshp);
+  switch (e->type) {
+  case MS_GEOMTRANSFORM_EXPRESSION: {
+    int status;
+    shapeObj *tmpshp;
+    parseObj p;
+
+    p.shape = shape; /* set a few parser globals (hence the lock) */
+    p.expr = e;
+    p.expr->curtoken = p.expr->tokens; /* reset */
+    p.type = MS_PARSE_TYPE_SHAPE;
+    p.dblval = map->cellsize * (msInchesPerUnit(map->units, 0) /
+                                msInchesPerUnit(layer->units, 0));
+    p.dblval2 = 0;
+    /* data_cellsize is only set with contour layer */
+    if (layer->connectiontype == MS_CONTOUR) {
+      const char *value =
+          msLookupHashTable(&layer->metadata, "__data_cellsize__");
+      if (value)
+        p.dblval2 = atof(value);
     }
-    break;
-    default:
-      msSetError(MS_MISCERR, "unknown geomtransform", "msGeomTransformShape()");
+
+    status = yyparse(&p);
+    if (status != 0) {
+      msSetError(MS_PARSEERR, "Failed to process shape expression: %s",
+                 "msGeomTransformShape()", e->string);
       return MS_FAILURE;
+    }
+
+    tmpshp = p.result.shpval;
+
+    for (i = 0; i < shape->numlines; i++)
+      free(shape->line[i].point);
+    shape->numlines = 0;
+    if (shape->line)
+      free(shape->line);
+    shape->line = NULL;
+    shape->type = tmpshp->type; /* might have been a change (e.g. centerline) */
+
+    for (i = 0; i < tmpshp->numlines; i++)
+      msAddLine(shape, &(tmpshp->line[i])); /* copy each line */
+
+    msFreeShape(tmpshp);
+    msFree(tmpshp);
+  } break;
+  default:
+    msSetError(MS_MISCERR, "unknown geomtransform", "msGeomTransformShape()");
+    return MS_FAILURE;
   }
-  
+
   return MS_SUCCESS;
 }
diff -pruN 8.0.1-5/mapgeomutil.cpp 8.0.2-1/mapgeomutil.cpp
--- 8.0.1-5/mapgeomutil.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapgeomutil.cpp	2024-06-11 20:41:34.000000000 +0000
@@ -31,31 +31,32 @@
 #include "renderers/agg/include/agg_arc.h"
 #include "renderers/agg/include/agg_basics.h"
 
-
-
-shapeObj *msRasterizeArc(double x0, double y0, double radius, double startAngle, double endAngle, int isSlice)
-{
-  static int allocated_size=100;
-  shapeObj *shape = (shapeObj*)calloc(1,sizeof(shapeObj));
+shapeObj *msRasterizeArc(double x0, double y0, double radius, double startAngle,
+                         double endAngle, int isSlice) {
+  static int allocated_size = 100;
+  shapeObj *shape = (shapeObj *)calloc(1, sizeof(shapeObj));
   MS_CHECK_ALLOC(shape, sizeof(shapeObj), NULL);
-  mapserver::arc arc ( x0, y0,radius,radius, startAngle*MS_DEG_TO_RAD, endAngle*MS_DEG_TO_RAD,true );
-  arc.approximation_scale ( 1 );
+  mapserver::arc arc(x0, y0, radius, radius, startAngle * MS_DEG_TO_RAD,
+                     endAngle * MS_DEG_TO_RAD, true);
+  arc.approximation_scale(1);
   arc.rewind(1);
   msInitShape(shape);
 
-  lineObj *line = (lineObj*)calloc(1,sizeof(lineObj));
+  lineObj *line = (lineObj *)calloc(1, sizeof(lineObj));
   if (!line) {
-    msSetError(MS_MEMERR, "%s: %d: Out of memory allocating %u bytes.\n", "msRasterizeArc()" ,
-               __FILE__, __LINE__, (unsigned int)sizeof(lineObj));
+    msSetError(MS_MEMERR, "%s: %d: Out of memory allocating %u bytes.\n",
+               "msRasterizeArc()", __FILE__, __LINE__,
+               (unsigned int)sizeof(lineObj));
     free(shape);
     return NULL;
   }
   shape->line = line;
   shape->numlines = 1;
-  line->point = (pointObj*)calloc(allocated_size,sizeof(pointObj));
+  line->point = (pointObj *)calloc(allocated_size, sizeof(pointObj));
   if (!line->point) {
-    msSetError(MS_MEMERR, "%s: %d: Out of memory allocating %u bytes.\n", "msRasterizeArc()" ,
-               __FILE__, __LINE__, (unsigned int)(allocated_size*sizeof(pointObj)));
+    msSetError(MS_MEMERR, "%s: %d: Out of memory allocating %u bytes.\n",
+               "msRasterizeArc()", __FILE__, __LINE__,
+               (unsigned int)(allocated_size * sizeof(pointObj)));
     free(line);
     free(shape);
     return NULL;
@@ -63,21 +64,23 @@ shapeObj *msRasterizeArc(double x0, doub
 
   line->numpoints = 0;
 
-  double x,y;
+  double x, y;
 
-  //first segment from center to first point of arc
-  if(isSlice) {
+  // first segment from center to first point of arc
+  if (isSlice) {
     line->point[0].x = x0;
     line->point[0].y = y0;
     line->numpoints = 1;
   }
-  while(arc.vertex(&x,&y) != mapserver::path_cmd_stop) {
-    if(line->numpoints == allocated_size) {
+  while (arc.vertex(&x, &y) != mapserver::path_cmd_stop) {
+    if (line->numpoints == allocated_size) {
       allocated_size *= 2;
-      line->point = (pointObj*)realloc(line->point, allocated_size * sizeof(pointObj));
+      line->point =
+          (pointObj *)realloc(line->point, allocated_size * sizeof(pointObj));
       if (!line->point) {
-        msSetError(MS_MEMERR, "%s: %d: Out of memory allocating %u bytes.\n", "msRasterizeArc()" ,
-                   __FILE__, __LINE__, (unsigned int)(allocated_size * sizeof(pointObj)));
+        msSetError(MS_MEMERR, "%s: %d: Out of memory allocating %u bytes.\n",
+                   "msRasterizeArc()", __FILE__, __LINE__,
+                   (unsigned int)(allocated_size * sizeof(pointObj)));
         free(line);
         free(shape);
         return NULL;
@@ -88,12 +91,13 @@ shapeObj *msRasterizeArc(double x0, doub
     line->numpoints++;
   }
 
-  //make sure the shape is closed
-  if(line->point[line->numpoints-1].x != line->point[0].x ||
-      line->point[line->numpoints-1].y != line->point[0].y) {
-    if(line->numpoints == allocated_size) {
+  // make sure the shape is closed
+  if (line->point[line->numpoints - 1].x != line->point[0].x ||
+      line->point[line->numpoints - 1].y != line->point[0].y) {
+    if (line->numpoints == allocated_size) {
       allocated_size *= 2;
-      line->point = (pointObj*)msSmallRealloc(line->point, allocated_size * sizeof(pointObj));
+      line->point = (pointObj *)msSmallRealloc(
+          line->point, allocated_size * sizeof(pointObj));
     }
     line->point[line->numpoints].x = line->point[0].x;
     line->point[line->numpoints].y = line->point[0].y;
@@ -102,6 +106,3 @@ shapeObj *msRasterizeArc(double x0, doub
 
   return shape;
 }
-
-
-
diff -pruN 8.0.1-5/mapgeos.c 8.0.2-1/mapgeos.c
--- 8.0.1-5/mapgeos.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapgeos.c	2024-06-11 20:41:34.000000000 +0000
@@ -41,27 +41,25 @@
 /*
 ** Error handling...
 */
-static void msGEOSError(const char *format, ...)
-{
+static void msGEOSError(const char *format, ...) {
   va_list args;
 
-  va_start (args, format);
-  msSetError(MS_GEOSERR, format, "msGEOSError()", args); /* just pass along to MapServer error handling */
+  va_start(args, format);
+  msSetError(MS_GEOSERR, format, "msGEOSError()",
+             args); /* just pass along to MapServer error handling */
   va_end(args);
 
   return;
 }
 
-static void msGEOSNotice(const char *fmt, ...)
-{
+static void msGEOSNotice(const char *fmt, ...) {
   (void)fmt; /* do nothing with notices at this point */
 }
 
 #ifndef USE_THREAD
 static GEOSContextHandle_t geos_handle;
 
-static inline GEOSContextHandle_t msGetGeosContextHandle()
-{
+static inline GEOSContextHandle_t msGetGeosContextHandle() {
   return geos_handle;
 }
 
@@ -69,37 +67,37 @@ static inline GEOSContextHandle_t msGetG
 #include "mapthread.h"
 typedef struct geos_thread_info {
   struct geos_thread_info *next;
-  void*             thread_id;
-  GEOSContextHandle_t        geos_handle;
+  void *thread_id;
+  GEOSContextHandle_t geos_handle;
 } geos_thread_info_t;
 
 static geos_thread_info_t *geos_list = NULL;
 
-static GEOSContextHandle_t msGetGeosContextHandle()
-{
+static GEOSContextHandle_t msGetGeosContextHandle() {
   geos_thread_info_t *link;
   GEOSContextHandle_t ret_obj;
-  void*        thread_id;
+  void *thread_id;
 
-  msAcquireLock( TLOCK_GEOS );
+  msAcquireLock(TLOCK_GEOS);
 
   thread_id = msGetThreadId();
 
   /* find link for this thread */
 
-  for( link = geos_list;
-       link != NULL && link->thread_id != thread_id
-       && link->next != NULL && link->next->thread_id != thread_id;
-       link = link->next ) {}
+  for (link = geos_list;
+       link != NULL && link->thread_id != thread_id && link->next != NULL &&
+       link->next->thread_id != thread_id;
+       link = link->next) {
+  }
 
   /* If the target thread link is already at the head of the list were ok */
-  if( geos_list != NULL && geos_list->thread_id == thread_id ) {
+  if (geos_list != NULL && geos_list->thread_id == thread_id) {
   }
 
   /* We don't have one ... initialize one. */
-  else if( link == NULL || link->next == NULL ) {
+  else if (link == NULL || link->next == NULL) {
     geos_thread_info_t *new_link;
-    new_link = (geos_thread_info_t *) malloc(sizeof(geos_thread_info_t));
+    new_link = (geos_thread_info_t *)malloc(sizeof(geos_thread_info_t));
     new_link->next = geos_list;
     new_link->thread_id = thread_id;
     new_link->geos_handle = initGEOS_r(msGEOSNotice, msGEOSError);
@@ -118,7 +116,7 @@ static GEOSContextHandle_t msGetGeosCont
 
   ret_obj = geos_list->geos_handle;
 
-  msReleaseLock( TLOCK_GEOS );
+  msReleaseLock(TLOCK_GEOS);
 
   return ret_obj;
 }
@@ -127,214 +125,231 @@ static GEOSContextHandle_t msGetGeosCont
 /*
 ** Setup/Cleanup wrappers
 */
-void msGEOSSetup()
-{
+void msGEOSSetup() {
 #ifndef USE_THREAD
   geos_handle = initGEOS_r(msGEOSNotice, msGEOSError);
 #endif
 }
 
-void msGEOSCleanup()
-{
+void msGEOSCleanup() {
 #ifndef USE_THREAD
   finishGEOS_r(geos_handle);
   geos_handle = NULL;
 #else
   geos_thread_info_t *link;
-  msAcquireLock( TLOCK_GEOS );
-  for( link = geos_list; link != NULL;) {
+  msAcquireLock(TLOCK_GEOS);
+  for (link = geos_list; link != NULL;) {
     geos_thread_info_t *cur = link;
     link = link->next;
     finishGEOS_r(cur->geos_handle);
     free(cur);
   }
   geos_list = NULL;
-  msReleaseLock( TLOCK_GEOS );
+  msReleaseLock(TLOCK_GEOS);
 #endif
 }
 
 /*
 ** Translation functions
 */
-static GEOSGeom msGEOSShape2Geometry_point(pointObj *point)
-{
+static GEOSGeom msGEOSShape2Geometry_point(pointObj *point) {
   GEOSCoordSeq coords;
   GEOSGeom g;
   GEOSContextHandle_t handle = msGetGeosContextHandle();
 
-  if(!point) return NULL;
+  if (!point)
+    return NULL;
 
-  coords = GEOSCoordSeq_create_r(handle,1, 2); /* todo handle z's */
-  if(!coords) return NULL;
+  coords = GEOSCoordSeq_create_r(handle, 1, 2); /* todo handle z's */
+  if (!coords)
+    return NULL;
 
-  GEOSCoordSeq_setX_r(handle,coords, 0, point->x);
-  GEOSCoordSeq_setY_r(handle,coords, 0, point->y);
+  GEOSCoordSeq_setX_r(handle, coords, 0, point->x);
+  GEOSCoordSeq_setY_r(handle, coords, 0, point->y);
   /* GEOSCoordSeq_setY(coords, 0, point->z); */
 
-  g = GEOSGeom_createPoint_r(handle,coords); /* g owns the coordinate in coords */
+  g = GEOSGeom_createPoint_r(handle,
+                             coords); /* g owns the coordinate in coords */
 
   return g;
 }
 
-static GEOSGeom msGEOSShape2Geometry_multipoint(lineObj *multipoint)
-{
+static GEOSGeom msGEOSShape2Geometry_multipoint(lineObj *multipoint) {
   int i;
   GEOSGeom g;
   GEOSGeom *points;
   GEOSContextHandle_t handle = msGetGeosContextHandle();
 
-  if(!multipoint) return NULL;
+  if (!multipoint)
+    return NULL;
 
-  points = malloc(multipoint->numpoints*sizeof(GEOSGeom));
-  if(!points) return NULL;
+  points = malloc(multipoint->numpoints * sizeof(GEOSGeom));
+  if (!points)
+    return NULL;
 
-  for(i=0; i<multipoint->numpoints; i++)
+  for (i = 0; i < multipoint->numpoints; i++)
     points[i] = msGEOSShape2Geometry_point(&(multipoint->point[i]));
 
-  g = GEOSGeom_createCollection_r(handle,GEOS_MULTIPOINT, points, multipoint->numpoints);
+  g = GEOSGeom_createCollection_r(handle, GEOS_MULTIPOINT, points,
+                                  multipoint->numpoints);
 
   free(points);
 
   return g;
 }
 
-static GEOSGeom msGEOSShape2Geometry_line(lineObj *line)
-{
+static GEOSGeom msGEOSShape2Geometry_line(lineObj *line) {
   int i;
   GEOSGeom g;
   GEOSCoordSeq coords;
   GEOSContextHandle_t handle = msGetGeosContextHandle();
 
-  if(!line) return NULL;
+  if (!line)
+    return NULL;
 
-  coords = GEOSCoordSeq_create_r(handle,line->numpoints, 2); /* todo handle z's */
-  if(!coords) return NULL;
+  coords =
+      GEOSCoordSeq_create_r(handle, line->numpoints, 2); /* todo handle z's */
+  if (!coords)
+    return NULL;
 
-  for(i=0; i<line->numpoints; i++) {
-    GEOSCoordSeq_setX_r(handle,coords, i, line->point[i].x);
-    GEOSCoordSeq_setY_r(handle,coords, i, line->point[i].y);
+  for (i = 0; i < line->numpoints; i++) {
+    GEOSCoordSeq_setX_r(handle, coords, i, line->point[i].x);
+    GEOSCoordSeq_setY_r(handle, coords, i, line->point[i].y);
     /* GEOSCoordSeq_setZ(coords, i, line->point[i].z); */
   }
 
-  g = GEOSGeom_createLineString_r(handle,coords); /* g owns the coordinates in coords */
+  g = GEOSGeom_createLineString_r(
+      handle, coords); /* g owns the coordinates in coords */
 
   return g;
 }
 
-static GEOSGeom msGEOSShape2Geometry_multiline(shapeObj *multiline)
-{
+static GEOSGeom msGEOSShape2Geometry_multiline(shapeObj *multiline) {
   int i;
   GEOSGeom g;
   GEOSGeom *lines;
   GEOSContextHandle_t handle = msGetGeosContextHandle();
 
-  if(!multiline) return NULL;
+  if (!multiline)
+    return NULL;
 
-  lines = malloc(multiline->numlines*sizeof(GEOSGeom));
-  if(!lines) return NULL;
+  lines = malloc(multiline->numlines * sizeof(GEOSGeom));
+  if (!lines)
+    return NULL;
 
-  for(i=0; i<multiline->numlines; i++)
+  for (i = 0; i < multiline->numlines; i++)
     lines[i] = msGEOSShape2Geometry_line(&(multiline->line[i]));
 
-  g = GEOSGeom_createCollection_r(handle,GEOS_MULTILINESTRING, lines, multiline->numlines);
+  g = GEOSGeom_createCollection_r(handle, GEOS_MULTILINESTRING, lines,
+                                  multiline->numlines);
 
   free(lines);
 
   return g;
 }
 
-static GEOSGeom msGEOSShape2Geometry_simplepolygon(shapeObj *shape, int r, int *outerList)
-{
+static GEOSGeom msGEOSShape2Geometry_simplepolygon(shapeObj *shape, int r,
+                                                   int *outerList) {
   int i, j, k;
   GEOSCoordSeq coords;
   GEOSGeom g;
   GEOSGeom outerRing;
-  GEOSGeom *innerRings=NULL;
-  int numInnerRings=0, *innerList;
+  GEOSGeom *innerRings = NULL;
+  int numInnerRings = 0, *innerList;
   GEOSContextHandle_t handle = msGetGeosContextHandle();
 
-  if(!shape || !outerList) return NULL;
+  if (!shape || !outerList)
+    return NULL;
 
   /* build the outer shell */
-  coords = GEOSCoordSeq_create_r(handle,shape->line[r].numpoints, 2); /* todo handle z's */
-  if(!coords) return NULL;
+  coords = GEOSCoordSeq_create_r(handle, shape->line[r].numpoints,
+                                 2); /* todo handle z's */
+  if (!coords)
+    return NULL;
 
-  for(i=0; i<shape->line[r].numpoints; i++) {
-    GEOSCoordSeq_setX_r(handle,coords, i, shape->line[r].point[i].x);
-    GEOSCoordSeq_setY_r(handle,coords, i, shape->line[r].point[i].y);
+  for (i = 0; i < shape->line[r].numpoints; i++) {
+    GEOSCoordSeq_setX_r(handle, coords, i, shape->line[r].point[i].x);
+    GEOSCoordSeq_setY_r(handle, coords, i, shape->line[r].point[i].y);
     /* GEOSCoordSeq_setZ(coords, i, shape->line[r].point[i].z); */
   }
 
-  outerRing = GEOSGeom_createLinearRing_r(handle,coords); /* outerRing owns the coordinates in coords */
+  outerRing = GEOSGeom_createLinearRing_r(
+      handle, coords); /* outerRing owns the coordinates in coords */
 
   /* build the holes */
   innerList = msGetInnerList(shape, r, outerList);
-  for(j=0; j<shape->numlines; j++)
-    if(innerList[j] == MS_TRUE) numInnerRings++;
+  for (j = 0; j < shape->numlines; j++)
+    if (innerList[j] == MS_TRUE)
+      numInnerRings++;
 
-  if(numInnerRings > 0) {
+  if (numInnerRings > 0) {
     k = 0; /* inner ring counter */
 
-    innerRings = msSmallMalloc(numInnerRings*sizeof(GEOSGeom));
-
-    for(j=0; j<shape->numlines; j++) {
-      if(innerList[j] == MS_FALSE) continue;
+    innerRings = msSmallMalloc(numInnerRings * sizeof(GEOSGeom));
 
-      coords = GEOSCoordSeq_create_r(handle,shape->line[j].numpoints, 2); /* todo handle z's */
-      if(!coords) {
+    for (j = 0; j < shape->numlines; j++) {
+      if (innerList[j] == MS_FALSE)
+        continue;
+
+      coords = GEOSCoordSeq_create_r(handle, shape->line[j].numpoints,
+                                     2); /* todo handle z's */
+      if (!coords) {
         free(innerRings);
         free(innerList);
         return NULL; /* todo, this will leak memory (shell + allocated holes) */
       }
 
-      for(i=0; i<shape->line[j].numpoints; i++) {
-        GEOSCoordSeq_setX_r(handle,coords, i, shape->line[j].point[i].x);
-        GEOSCoordSeq_setY_r(handle,coords, i, shape->line[j].point[i].y);
+      for (i = 0; i < shape->line[j].numpoints; i++) {
+        GEOSCoordSeq_setX_r(handle, coords, i, shape->line[j].point[i].x);
+        GEOSCoordSeq_setY_r(handle, coords, i, shape->line[j].point[i].y);
         /* GEOSCoordSeq_setZ(coords, i, shape->line[j].point[i].z); */
       }
 
-      innerRings[k] = GEOSGeom_createLinearRing_r(handle,coords); /* innerRings[k] owns the coordinates in coords */
+      innerRings[k] = GEOSGeom_createLinearRing_r(
+          handle, coords); /* innerRings[k] owns the coordinates in coords */
       k++;
     }
   }
 
-  g = GEOSGeom_createPolygon_r(handle,outerRing, innerRings, numInnerRings);
+  g = GEOSGeom_createPolygon_r(handle, outerRing, innerRings, numInnerRings);
 
-  free(innerList); /* clean up */
+  free(innerList);  /* clean up */
   free(innerRings); /* clean up */
 
   return g;
 }
 
-static GEOSGeom msGEOSShape2Geometry_polygon(shapeObj *shape)
-{
+static GEOSGeom msGEOSShape2Geometry_polygon(shapeObj *shape) {
   int i, j;
   GEOSGeom *polygons;
-  int *outerList, numOuterRings=0, lastOuterRing=0;
+  int *outerList, numOuterRings = 0, lastOuterRing = 0;
   GEOSGeom g;
   GEOSContextHandle_t handle = msGetGeosContextHandle();
 
   outerList = msGetOuterList(shape);
-  for(i=0; i<shape->numlines; i++) {
-    if(outerList[i] == MS_TRUE) {
+  for (i = 0; i < shape->numlines; i++) {
+    if (outerList[i] == MS_TRUE) {
       numOuterRings++;
       lastOuterRing = i; /* save for the simple case */
     }
   }
 
-  if(numOuterRings == 1) {
+  if (numOuterRings == 1) {
     g = msGEOSShape2Geometry_simplepolygon(shape, lastOuterRing, outerList);
   } else { /* a true multipolygon */
-    polygons = msSmallMalloc(numOuterRings*sizeof(GEOSGeom));
+    polygons = msSmallMalloc(numOuterRings * sizeof(GEOSGeom));
 
     j = 0; /* part counter */
-    for(i=0; i<shape->numlines; i++) {
-      if(outerList[i] == MS_FALSE) continue;
-      polygons[j] = msGEOSShape2Geometry_simplepolygon(shape, i, outerList); /* TODO: account for NULL return values */
+    for (i = 0; i < shape->numlines; i++) {
+      if (outerList[i] == MS_FALSE)
+        continue;
+      polygons[j] = msGEOSShape2Geometry_simplepolygon(
+          shape, i, outerList); /* TODO: account for NULL return values */
       j++;
     }
 
-    g = GEOSGeom_createCollection_r(handle,GEOS_MULTIPOLYGON, polygons, numOuterRings);
+    g = GEOSGeom_createCollection_r(handle, GEOS_MULTIPOLYGON, polygons,
+                                    numOuterRings);
     free(polygons);
   }
 
@@ -342,65 +357,69 @@ static GEOSGeom msGEOSShape2Geometry_pol
   return g;
 }
 
-GEOSGeom msGEOSShape2Geometry(shapeObj *shape)
-{
-  if(!shape)
+GEOSGeom msGEOSShape2Geometry(shapeObj *shape) {
+  if (!shape)
     return NULL; /* a NULL shape generates a NULL geometry */
 
-  switch(shape->type) {
-    case MS_SHAPE_POINT:
-      if(shape->numlines == 0 || shape->line[0].numpoints == 0) /* not enough info for a point */
-        return NULL;
-
-      if(shape->line[0].numpoints == 1) /* simple point */
-        return msGEOSShape2Geometry_point(&(shape->line[0].point[0]));
-      else /* multi-point */
-        return msGEOSShape2Geometry_multipoint(&(shape->line[0]));
-      break;
-    case MS_SHAPE_LINE:
-      if(shape->numlines == 0 || shape->line[0].numpoints < 2) /* not enough info for a line */
-        return NULL;
-
-      if(shape->numlines == 1) /* simple line */
-        return msGEOSShape2Geometry_line(&(shape->line[0]));
-      else /* multi-line */
-        return msGEOSShape2Geometry_multiline(shape);
-      break;
-    case MS_SHAPE_POLYGON:
-      if(shape->numlines == 0 || shape->line[0].numpoints < 4) /* not enough info for a polygon (first=last) */
-        return NULL;
-
-      return msGEOSShape2Geometry_polygon(shape); /* simple and multipolygon cases are addressed */
-      break;
-    default:
-      break;
+  switch (shape->type) {
+  case MS_SHAPE_POINT:
+    if (shape->numlines == 0 ||
+        shape->line[0].numpoints == 0) /* not enough info for a point */
+      return NULL;
+
+    if (shape->line[0].numpoints == 1) /* simple point */
+      return msGEOSShape2Geometry_point(&(shape->line[0].point[0]));
+    else /* multi-point */
+      return msGEOSShape2Geometry_multipoint(&(shape->line[0]));
+    break;
+  case MS_SHAPE_LINE:
+    if (shape->numlines == 0 ||
+        shape->line[0].numpoints < 2) /* not enough info for a line */
+      return NULL;
+
+    if (shape->numlines == 1) /* simple line */
+      return msGEOSShape2Geometry_line(&(shape->line[0]));
+    else /* multi-line */
+      return msGEOSShape2Geometry_multiline(shape);
+    break;
+  case MS_SHAPE_POLYGON:
+    if (shape->numlines == 0 ||
+        shape->line[0].numpoints <
+            4) /* not enough info for a polygon (first=last) */
+      return NULL;
+
+    return msGEOSShape2Geometry_polygon(
+        shape); /* simple and multipolygon cases are addressed */
+    break;
+  default:
+    break;
   }
 
   return NULL; /* should not get here */
 }
 
-static shapeObj *msGEOSGeometry2Shape_point(GEOSGeom g)
-{
+static shapeObj *msGEOSGeometry2Shape_point(GEOSGeom g) {
   GEOSCoordSeq coords;
-  shapeObj *shape=NULL;
+  shapeObj *shape = NULL;
   GEOSContextHandle_t handle = msGetGeosContextHandle();
 
-  if(!g) return NULL;
+  if (!g)
+    return NULL;
 
-  shape = (shapeObj *) malloc(sizeof(shapeObj));
+  shape = (shapeObj *)malloc(sizeof(shapeObj));
   msInitShape(shape);
 
   shape->type = MS_SHAPE_POINT;
-  shape->line = (lineObj *) malloc(sizeof(lineObj));
+  shape->line = (lineObj *)malloc(sizeof(lineObj));
   shape->numlines = 1;
-  shape->line[0].point = (pointObj *) malloc(sizeof(pointObj));
+  shape->line[0].point = (pointObj *)malloc(sizeof(pointObj));
   shape->line[0].numpoints = 1;
-  shape->geometry = (GEOSGeom) g;
+  shape->geometry = (GEOSGeom)g;
 
-  coords = (GEOSCoordSeq) GEOSGeom_getCoordSeq_r(handle,g);
+  coords = (GEOSCoordSeq)GEOSGeom_getCoordSeq_r(handle, g);
 
-  GEOSCoordSeq_getX_r(handle,coords, 0, &(shape->line[0].point[0].x));
-  GEOSCoordSeq_getY_r(handle,coords, 0, &(shape->line[0].point[0].y));
+  GEOSCoordSeq_getX_r(handle, coords, 0, &(shape->line[0].point[0].x));
+  GEOSCoordSeq_getY_r(handle, coords, 0, &(shape->line[0].point[0].y));
   /* GEOSCoordSeq_getZ(coords, 0, &(shape->line[0].point[0].z)); */
 
   shape->bounds.minx = shape->bounds.maxx = shape->line[0].point[0].x;
@@ -409,35 +428,35 @@ static shapeObj *msGEOSGeometry2Shape_po
   return shape;
 }
 
-static shapeObj *msGEOSGeometry2Shape_multipoint(GEOSGeom g)
-{
+static shapeObj *msGEOSGeometry2Shape_multipoint(GEOSGeom g) {
   int i;
   int numPoints;
   GEOSCoordSeq coords;
   GEOSGeom point;
 
-  shapeObj *shape=NULL;
+  shapeObj *shape = NULL;
   GEOSContextHandle_t handle = msGetGeosContextHandle();
 
-  if(!g) return NULL;
-  numPoints = GEOSGetNumGeometries_r(handle,g); /* each geometry has 1 point */
+  if (!g)
+    return NULL;
+  numPoints = GEOSGetNumGeometries_r(handle, g); /* each geometry has 1 point */
 
-  shape = (shapeObj *) malloc(sizeof(shapeObj));
+  shape = (shapeObj *)malloc(sizeof(shapeObj));
   msInitShape(shape);
 
   shape->type = MS_SHAPE_POINT;
-  shape->line = (lineObj *) malloc(sizeof(lineObj));
+  shape->line = (lineObj *)malloc(sizeof(lineObj));
   shape->numlines = 1;
-  shape->line[0].point = (pointObj *) malloc(sizeof(pointObj)*numPoints);
+  shape->line[0].point = (pointObj *)malloc(sizeof(pointObj) * numPoints);
   shape->line[0].numpoints = numPoints;
-  shape->geometry = (GEOSGeom) g;
+  shape->geometry = (GEOSGeom)g;
 
-  for(i=0; i<numPoints; i++) {
-    point = (GEOSGeom) GEOSGetGeometryN_r(handle,g, i);
-    coords = (GEOSCoordSeq) GEOSGeom_getCoordSeq_r(handle,point);
+  for (i = 0; i < numPoints; i++) {
+    point = (GEOSGeom)GEOSGetGeometryN_r(handle, g, i);
+    coords = (GEOSCoordSeq)GEOSGeom_getCoordSeq_r(handle, point);
 
-    GEOSCoordSeq_getX_r(handle,coords, 0, &(shape->line[0].point[i].x));
-    GEOSCoordSeq_getY_r(handle,coords, 0, &(shape->line[0].point[i].y));
+    GEOSCoordSeq_getX_r(handle, coords, 0, &(shape->line[0].point[i].x));
+    GEOSCoordSeq_getY_r(handle, coords, 0, &(shape->line[0].point[i].y));
     /* GEOSCoordSeq_getZ(coords, 0, &(shape->line[0].point[i].z)); */
   }
 
@@ -446,32 +465,32 @@ static shapeObj *msGEOSGeometry2Shape_mu
   return shape;
 }
 
-static shapeObj *msGEOSGeometry2Shape_line(GEOSGeom g)
-{
-  shapeObj *shape=NULL;
+static shapeObj *msGEOSGeometry2Shape_line(GEOSGeom g) {
+  shapeObj *shape = NULL;
   GEOSContextHandle_t handle = msGetGeosContextHandle();
 
   int i;
   int numPoints;
   GEOSCoordSeq coords;
 
-  if(!g) return NULL;
-  numPoints = GEOSGetNumCoordinates_r(handle,g);
-  coords = (GEOSCoordSeq) GEOSGeom_getCoordSeq_r(handle,g);
+  if (!g)
+    return NULL;
+  numPoints = GEOSGetNumCoordinates_r(handle, g);
+  coords = (GEOSCoordSeq)GEOSGeom_getCoordSeq_r(handle, g);
 
-  shape = (shapeObj *) malloc(sizeof(shapeObj));
+  shape = (shapeObj *)malloc(sizeof(shapeObj));
   msInitShape(shape);
 
   shape->type = MS_SHAPE_LINE;
-  shape->line = (lineObj *) malloc(sizeof(lineObj));
+  shape->line = (lineObj *)malloc(sizeof(lineObj));
   shape->numlines = 1;
-  shape->line[0].point = (pointObj *) malloc(sizeof(pointObj)*numPoints);
+  shape->line[0].point = (pointObj *)malloc(sizeof(pointObj) * numPoints);
   shape->line[0].numpoints = numPoints;
-  shape->geometry = (GEOSGeom) g;
+  shape->geometry = (GEOSGeom)g;
 
-  for(i=0; i<numPoints; i++) {
-    GEOSCoordSeq_getX_r(handle,coords, i, &(shape->line[0].point[i].x));
-    GEOSCoordSeq_getY_r(handle,coords, i, &(shape->line[0].point[i].y));
+  for (i = 0; i < numPoints; i++) {
+    GEOSCoordSeq_getX_r(handle, coords, i, &(shape->line[0].point[i].x));
+    GEOSCoordSeq_getY_r(handle, coords, i, &(shape->line[0].point[i].y));
     /* GEOSCoordSeq_getZ(coords, i, &(shape->line[0].point[i].z)); */
   }
 
@@ -480,29 +499,31 @@ static shapeObj *msGEOSGeometry2Shape_li
   return shape;
 }
 
-static void msGEOSGeometry2Shape_multiline_part(GEOSContextHandle_t handle, GEOSGeom part, shapeObj *shape) {
+static void msGEOSGeometry2Shape_multiline_part(GEOSContextHandle_t handle,
+                                                GEOSGeom part,
+                                                shapeObj *shape) {
   int i;
   int type, numGeometries, numPoints;
   GEOSCoordSeq coords;
   lineObj line;
-  
-  type = GEOSGeomTypeId_r(handle,part); 
+
+  type = GEOSGeomTypeId_r(handle, part);
   if (type == GEOS_MULTILINESTRING) {
-    numGeometries = GEOSGetNumGeometries_r(handle,part);
+    numGeometries = GEOSGetNumGeometries_r(handle, part);
 
-    for(i=0; i<numGeometries; i++) {
-      GEOSGeom subPart = (GEOSGeom) GEOSGetGeometryN_r(handle, part, i);
+    for (i = 0; i < numGeometries; i++) {
+      GEOSGeom subPart = (GEOSGeom)GEOSGetGeometryN_r(handle, part, i);
       msGEOSGeometry2Shape_multiline_part(handle, subPart, shape);
     }
   } else {
-    numPoints = GEOSGetNumCoordinates_r(handle,part);
-    coords = (GEOSCoordSeq) GEOSGeom_getCoordSeq_r(handle,part);
-    line.point = (pointObj *) malloc(sizeof(pointObj)*numPoints);
+    numPoints = GEOSGetNumCoordinates_r(handle, part);
+    coords = (GEOSCoordSeq)GEOSGeom_getCoordSeq_r(handle, part);
+    line.point = (pointObj *)malloc(sizeof(pointObj) * numPoints);
     line.numpoints = numPoints;
 
-    for(i=0; i<numPoints; i++) {
-      GEOSCoordSeq_getX_r(handle,coords, i, &(line.point[i].x));
-      GEOSCoordSeq_getY_r(handle,coords, i, &(line.point[i].y));
+    for (i = 0; i < numPoints; i++) {
+      GEOSCoordSeq_getX_r(handle, coords, i, &(line.point[i].x));
+      GEOSCoordSeq_getY_r(handle, coords, i, &(line.point[i].y));
       /* GEOSCoordSeq_getZ(coords, i, &(line.point[i].z)); */
     }
 
@@ -510,26 +531,26 @@ static void msGEOSGeometry2Shape_multili
   }
 }
 
-static shapeObj *msGEOSGeometry2Shape_multiline(GEOSGeom g)
-{
+static shapeObj *msGEOSGeometry2Shape_multiline(GEOSGeom g) {
   int i;
   int numGeometries;
   GEOSGeom part;
 
-  shapeObj *shape=NULL;
+  shapeObj *shape = NULL;
   GEOSContextHandle_t handle = msGetGeosContextHandle();
 
-  if(!g) return NULL;
-  numGeometries = GEOSGetNumGeometries_r(handle,g);
+  if (!g)
+    return NULL;
+  numGeometries = GEOSGetNumGeometries_r(handle, g);
 
-  shape = (shapeObj *) malloc(sizeof(shapeObj));
+  shape = (shapeObj *)malloc(sizeof(shapeObj));
   msInitShape(shape);
 
   shape->type = MS_SHAPE_LINE;
-  shape->geometry = (GEOSGeom) g;
+  shape->geometry = (GEOSGeom)g;
 
-  for(i=0; i<numGeometries; i++) {
-    part = (GEOSGeom) GEOSGetGeometryN_r(handle, g, i);
+  for (i = 0; i < numGeometries; i++) {
+    part = (GEOSGeom)GEOSGetGeometryN_r(handle, g, i);
     msGEOSGeometry2Shape_multiline_part(handle, part, shape);
   }
 
@@ -538,9 +559,8 @@ static shapeObj *msGEOSGeometry2Shape_mu
   return shape;
 }
 
-static shapeObj *msGEOSGeometry2Shape_polygon(GEOSGeom g)
-{
-  shapeObj *shape=NULL;
+static shapeObj *msGEOSGeometry2Shape_polygon(GEOSGeom g) {
+  shapeObj *shape = NULL;
   lineObj line;
   int numPoints, numRings;
   int i, j;
@@ -549,43 +569,45 @@ static shapeObj *msGEOSGeometry2Shape_po
   GEOSGeom ring;
   GEOSContextHandle_t handle = msGetGeosContextHandle();
 
-  if(!g) return NULL;
+  if (!g)
+    return NULL;
 
-  shape = (shapeObj *) malloc(sizeof(shapeObj));
+  shape = (shapeObj *)malloc(sizeof(shapeObj));
   msInitShape(shape);
   shape->type = MS_SHAPE_POLYGON;
-  shape->geometry = (GEOSGeom) g;
+  shape->geometry = (GEOSGeom)g;
 
   /* exterior ring */
-  ring = (GEOSGeom) GEOSGetExteriorRing_r(handle,g);
-  numPoints = GEOSGetNumCoordinates_r(handle,ring);
-  coords = (GEOSCoordSeq) GEOSGeom_getCoordSeq_r(handle,ring);
+  ring = (GEOSGeom)GEOSGetExteriorRing_r(handle, g);
+  numPoints = GEOSGetNumCoordinates_r(handle, ring);
+  coords = (GEOSCoordSeq)GEOSGeom_getCoordSeq_r(handle, ring);
 
-  line.point = (pointObj *) malloc(sizeof(pointObj)*numPoints);
+  line.point = (pointObj *)malloc(sizeof(pointObj) * numPoints);
   line.numpoints = numPoints;
 
-  for(i=0; i<numPoints; i++) {
-    GEOSCoordSeq_getX_r(handle,coords, i, &(line.point[i].x));
-    GEOSCoordSeq_getY_r(handle,coords, i, &(line.point[i].y));
+  for (i = 0; i < numPoints; i++) {
+    GEOSCoordSeq_getX_r(handle, coords, i, &(line.point[i].x));
+    GEOSCoordSeq_getY_r(handle, coords, i, &(line.point[i].y));
     /* GEOSCoordSeq_getZ(coords, i, &(line.point[i].z)); */
   }
   msAddLineDirectly(shape, &line);
 
   /* interior rings */
-  numRings = GEOSGetNumInteriorRings_r(handle,g);
-  for(j=0; j<numRings; j++) {
-    ring = (GEOSGeom) GEOSGetInteriorRingN_r(handle,g, j);
-    if(GEOSisRing_r(handle,ring) != 1) continue; /* skip it */
+  numRings = GEOSGetNumInteriorRings_r(handle, g);
+  for (j = 0; j < numRings; j++) {
+    ring = (GEOSGeom)GEOSGetInteriorRingN_r(handle, g, j);
+    if (GEOSisRing_r(handle, ring) != 1)
+      continue; /* skip it */
 
-    numPoints = GEOSGetNumCoordinates_r(handle,ring);
-    coords = (GEOSCoordSeq) GEOSGeom_getCoordSeq_r(handle,ring);
+    numPoints = GEOSGetNumCoordinates_r(handle, ring);
+    coords = (GEOSCoordSeq)GEOSGeom_getCoordSeq_r(handle, ring);
 
-    line.point = (pointObj *) malloc(sizeof(pointObj)*numPoints);
+    line.point = (pointObj *)malloc(sizeof(pointObj) * numPoints);
     line.numpoints = numPoints;
 
-    for(i=0; i<numPoints; i++) {
-      GEOSCoordSeq_getX_r(handle,coords, i, &(line.point[i].x));
-      GEOSCoordSeq_getY_r(handle,coords, i, &(line.point[i].y));
+    for (i = 0; i < numPoints; i++) {
+      GEOSCoordSeq_getX_r(handle, coords, i, &(line.point[i].x));
+      GEOSCoordSeq_getY_r(handle, coords, i, &(line.point[i].y));
       /* GEOSCoordSeq_getZ(coords, i, &(line.point[i].z)); */
     }
     msAddLineDirectly(shape, &line);
@@ -596,10 +618,9 @@ static shapeObj *msGEOSGeometry2Shape_po
   return shape;
 }
 
-static shapeObj *msGEOSGeometry2Shape_multipolygon(GEOSGeom g)
-{
+static shapeObj *msGEOSGeometry2Shape_multipolygon(GEOSGeom g) {
   int i, j, k;
-  shapeObj *shape=NULL;
+  shapeObj *shape = NULL;
   lineObj line;
   int numPoints, numRings, numPolygons;
 
@@ -607,48 +628,50 @@ static shapeObj *msGEOSGeometry2Shape_mu
   GEOSGeom polygon, ring;
   GEOSContextHandle_t handle = msGetGeosContextHandle();
 
-  if(!g) return NULL;
-  numPolygons = GEOSGetNumGeometries_r(handle,g);
+  if (!g)
+    return NULL;
+  numPolygons = GEOSGetNumGeometries_r(handle, g);
 
-  shape = (shapeObj *) malloc(sizeof(shapeObj));
+  shape = (shapeObj *)malloc(sizeof(shapeObj));
   msInitShape(shape);
   shape->type = MS_SHAPE_POLYGON;
-  shape->geometry = (GEOSGeom) g;
+  shape->geometry = (GEOSGeom)g;
 
-  for(k=0; k<numPolygons; k++) { /* for each polygon */
-    polygon = (GEOSGeom) GEOSGetGeometryN_r(handle,g, k);
+  for (k = 0; k < numPolygons; k++) { /* for each polygon */
+    polygon = (GEOSGeom)GEOSGetGeometryN_r(handle, g, k);
 
     /* exterior ring */
-    ring = (GEOSGeom) GEOSGetExteriorRing_r(handle,polygon);
-    numPoints = GEOSGetNumCoordinates_r(handle,ring);
-    coords = (GEOSCoordSeq) GEOSGeom_getCoordSeq_r(handle,ring);
+    ring = (GEOSGeom)GEOSGetExteriorRing_r(handle, polygon);
+    numPoints = GEOSGetNumCoordinates_r(handle, ring);
+    coords = (GEOSCoordSeq)GEOSGeom_getCoordSeq_r(handle, ring);
 
-    line.point = (pointObj *) malloc(sizeof(pointObj)*numPoints);
+    line.point = (pointObj *)malloc(sizeof(pointObj) * numPoints);
     line.numpoints = numPoints;
 
-    for(i=0; i<numPoints; i++) {
-      GEOSCoordSeq_getX_r(handle,coords, i, &(line.point[i].x));
-      GEOSCoordSeq_getY_r(handle,coords, i, &(line.point[i].y));
+    for (i = 0; i < numPoints; i++) {
+      GEOSCoordSeq_getX_r(handle, coords, i, &(line.point[i].x));
+      GEOSCoordSeq_getY_r(handle, coords, i, &(line.point[i].y));
       /* GEOSCoordSeq_getZ(coords, i, &(line.point[i].z)); */
     }
     msAddLineDirectly(shape, &line);
 
     /* interior rings */
-    numRings = GEOSGetNumInteriorRings_r(handle,polygon);
+    numRings = GEOSGetNumInteriorRings_r(handle, polygon);
 
-    for(j=0; j<numRings; j++) {
-      ring = (GEOSGeom) GEOSGetInteriorRingN_r(handle,polygon, j);
-      if(GEOSisRing_r(handle,ring) != 1) continue; /* skip it */
+    for (j = 0; j < numRings; j++) {
+      ring = (GEOSGeom)GEOSGetInteriorRingN_r(handle, polygon, j);
+      if (GEOSisRing_r(handle, ring) != 1)
+        continue; /* skip it */
 
-      numPoints = GEOSGetNumCoordinates_r(handle,ring);
-      coords = (GEOSCoordSeq) GEOSGeom_getCoordSeq_r(handle,ring);
+      numPoints = GEOSGetNumCoordinates_r(handle, ring);
+      coords = (GEOSCoordSeq)GEOSGeom_getCoordSeq_r(handle, ring);
 
-      line.point = (pointObj *) malloc(sizeof(pointObj)*numPoints);
+      line.point = (pointObj *)malloc(sizeof(pointObj) * numPoints);
       line.numpoints = numPoints;
 
-      for(i=0; i<numPoints; i++) {
-        GEOSCoordSeq_getX_r(handle,coords, i, &(line.point[i].x));
-        GEOSCoordSeq_getY_r(handle,coords, i, &(line.point[i].y));
+      for (i = 0; i < numPoints; i++) {
+        GEOSCoordSeq_getX_r(handle, coords, i, &(line.point[i].x));
+        GEOSCoordSeq_getY_r(handle, coords, i, &(line.point[i].y));
         /* GEOSCoordSeq_getZ(coords, i, &(line.point[i].z)); */
       }
       msAddLineDirectly(shape, &line);
@@ -660,59 +683,59 @@ static shapeObj *msGEOSGeometry2Shape_mu
   return shape;
 }
 
-shapeObj *msGEOSGeometry2Shape(GEOSGeom g)
-{
+shapeObj *msGEOSGeometry2Shape(GEOSGeom g) {
   int type;
   GEOSContextHandle_t handle = msGetGeosContextHandle();
 
-  if(!g)
+  if (!g)
     return NULL; /* a NULL geometry generates a NULL shape */
 
-  type = GEOSGeomTypeId_r(handle,g);
-  switch(type) {
-    case GEOS_POINT:
-      return msGEOSGeometry2Shape_point(g);
-      break;
-    case GEOS_MULTIPOINT:
-      return msGEOSGeometry2Shape_multipoint(g);
-      break;
-    case GEOS_LINESTRING:
-      return msGEOSGeometry2Shape_line(g);
-      break;
-    case GEOS_MULTILINESTRING:
-      return msGEOSGeometry2Shape_multiline(g);
-      break;
-    case GEOS_POLYGON:
-      return msGEOSGeometry2Shape_polygon(g);
-      break;
-    case GEOS_MULTIPOLYGON:
-      return msGEOSGeometry2Shape_multipolygon(g);
-      break;
-    case GEOS_GEOMETRYCOLLECTION:
-      if (!GEOSisEmpty_r(handle,g))
-      {
-        shapeObj* shape = (shapeObj *) malloc(sizeof(shapeObj));
-        msInitShape(shape);
-        shape->type = MS_SHAPE_LINE;
-        shape->geometry = (GEOSGeom) g;
-
-        const int numGeoms = GEOSGetNumGeometries_r(handle,g);
-        for(int i = 0; i < numGeoms; i++) { /* for each geometry */
-           shapeObj* shape2 = msGEOSGeometry2Shape((GEOSGeom)GEOSGetGeometryN_r(handle,g, i));
-           if (shape2) {
-              for (int j = 0; j < shape2->numlines; j++)
-                 msAddLineDirectly(shape, &shape2->line[j]);
-              shape2->numlines = 0;
-              shape2->geometry = NULL; /* not owned */
-              msFreeShape(shape2);
-           }
+  type = GEOSGeomTypeId_r(handle, g);
+  switch (type) {
+  case GEOS_POINT:
+    return msGEOSGeometry2Shape_point(g);
+    break;
+  case GEOS_MULTIPOINT:
+    return msGEOSGeometry2Shape_multipoint(g);
+    break;
+  case GEOS_LINESTRING:
+    return msGEOSGeometry2Shape_line(g);
+    break;
+  case GEOS_MULTILINESTRING:
+    return msGEOSGeometry2Shape_multiline(g);
+    break;
+  case GEOS_POLYGON:
+    return msGEOSGeometry2Shape_polygon(g);
+    break;
+  case GEOS_MULTIPOLYGON:
+    return msGEOSGeometry2Shape_multipolygon(g);
+    break;
+  case GEOS_GEOMETRYCOLLECTION:
+    if (!GEOSisEmpty_r(handle, g)) {
+      shapeObj *shape = (shapeObj *)malloc(sizeof(shapeObj));
+      msInitShape(shape);
+      shape->type = MS_SHAPE_LINE;
+      shape->geometry = (GEOSGeom)g;
+
+      const int numGeoms = GEOSGetNumGeometries_r(handle, g);
+      for (int i = 0; i < numGeoms; i++) { /* for each geometry */
+        shapeObj *shape2 =
+            msGEOSGeometry2Shape((GEOSGeom)GEOSGetGeometryN_r(handle, g, i));
+        if (shape2) {
+          for (int j = 0; j < shape2->numlines; j++)
+            msAddLineDirectly(shape, &shape2->line[j]);
+          shape2->numlines = 0;
+          shape2->geometry = NULL; /* not owned */
+          msFreeShape(shape2);
         }
-        msComputeBounds(shape);
-        return shape;
       }
-      break;
-    default:
-      msSetError(MS_GEOSERR, "Unsupported GEOS geometry type (%d).", "msGEOSGeometry2Shape()", type);
+      msComputeBounds(shape);
+      return shape;
+    }
+    break;
+  default:
+    msSetError(MS_GEOSERR, "Unsupported GEOS geometry type (%d).",
+               "msGEOSGeometry2Shape()", type);
   }
   return NULL;
 }
@@ -722,20 +745,20 @@ shapeObj *msGEOSGeometry2Shape(GEOSGeom
 ** Maintenence functions exposed to MapServer/MapScript.
 */
 
-void msGEOSFreeGeometry(shapeObj *shape)
-{
+void msGEOSFreeGeometry(shapeObj *shape) {
 #ifdef USE_GEOS
-  GEOSGeom g=NULL;
+  GEOSGeom g = NULL;
   GEOSContextHandle_t handle = msGetGeosContextHandle();
 
-  if(!shape || !shape->geometry)
+  if (!shape || !shape->geometry)
     return;
 
-  g = (GEOSGeom) shape->geometry;
-  GEOSGeom_destroy_r(handle,g);
+  g = (GEOSGeom)shape->geometry;
+  GEOSGeom_destroy_r(handle, g);
   shape->geometry = NULL;
 #else
-  msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSFreeGEOSGeom()");
+  msSetError(MS_GEOSERR, "GEOS support is not available.",
+             "msGEOSFreeGEOSGeom()");
   return;
 #endif
 }
@@ -743,59 +766,61 @@ void msGEOSFreeGeometry(shapeObj *shape)
 /*
 ** WKT input and output functions
 */
-shapeObj *msGEOSShapeFromWKT(const char *wkt)
-{
+shapeObj *msGEOSShapeFromWKT(const char *wkt) {
 #ifdef USE_GEOS
   GEOSGeom g;
   GEOSContextHandle_t handle = msGetGeosContextHandle();
 
-  if(!wkt)
+  if (!wkt)
     return NULL;
 
-  g = GEOSGeomFromWKT_r(handle,wkt);
-  if(!g) {
-    msSetError(MS_GEOSERR, "Error reading WKT geometry \"%s\".", "msGEOSShapeFromWKT()", wkt);
+  g = GEOSGeomFromWKT_r(handle, wkt);
+  if (!g) {
+    msSetError(MS_GEOSERR, "Error reading WKT geometry \"%s\".",
+               "msGEOSShapeFromWKT()", wkt);
     return NULL;
   } else {
     return msGEOSGeometry2Shape(g);
   }
 
 #else
-  msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSShapeFromWKT()");
+  msSetError(MS_GEOSERR, "GEOS support is not available.",
+             "msGEOSShapeFromWKT()");
   return NULL;
 #endif
 }
 
 /* Return should be freed with msGEOSFreeWKT */
-char *msGEOSShapeToWKT(shapeObj *shape)
-{
+char *msGEOSShapeToWKT(shapeObj *shape) {
 #ifdef USE_GEOS
   GEOSGeom g;
   GEOSContextHandle_t handle = msGetGeosContextHandle();
 
-  if(!shape)
+  if (!shape)
     return NULL;
 
   /* if we have a geometry, we should update it*/
   msGEOSFreeGeometry(shape);
 
-  shape->geometry = (GEOSGeom) msGEOSShape2Geometry(shape);
-  g = (GEOSGeom) shape->geometry;
-  if(!g) return NULL;
+  shape->geometry = (GEOSGeom)msGEOSShape2Geometry(shape);
+  g = (GEOSGeom)shape->geometry;
+  if (!g)
+    return NULL;
 
-  return GEOSGeomToWKT_r(handle,g);
+  return GEOSGeomToWKT_r(handle, g);
 #else
-  msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSShapeToWKT()");
+  msSetError(MS_GEOSERR, "GEOS support is not available.",
+             "msGEOSShapeToWKT()");
   return NULL;
 #endif
 }
 
-void msGEOSFreeWKT(char* pszGEOSWKT)
-{
+void msGEOSFreeWKT(char *pszGEOSWKT) {
 #ifdef USE_GEOS
   GEOSContextHandle_t handle = msGetGeosContextHandle();
-#if GEOS_VERSION_MAJOR > 3 || (GEOS_VERSION_MAJOR == 3 && GEOS_VERSION_MINOR >= 2)
-  GEOSFree_r(handle,pszGEOSWKT);
+#if GEOS_VERSION_MAJOR > 3 ||                                                  \
+    (GEOS_VERSION_MAJOR == 3 && GEOS_VERSION_MINOR >= 2)
+  GEOSFree_r(handle, pszGEOSWKT);
 #endif
 #else
   msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSFreeWKT()");
@@ -803,12 +828,13 @@ void msGEOSFreeWKT(char* pszGEOSWKT)
 }
 
 shapeObj *msGEOSOffsetCurve(shapeObj *p, double offset) {
-#if defined USE_GEOS && (GEOS_VERSION_MAJOR > 3 || (GEOS_VERSION_MAJOR == 3 && GEOS_VERSION_MINOR >= 3))
+#if defined USE_GEOS && (GEOS_VERSION_MAJOR > 3 ||                             \
+                         (GEOS_VERSION_MAJOR == 3 && GEOS_VERSION_MINOR >= 3))
   int typeChanged = 0;
   GEOSGeom g1, g2 = NULL;
   GEOSContextHandle_t handle = msGetGeosContextHandle();
 
-  if(!p) 
+  if (!p)
     return NULL;
 
   /*
@@ -816,40 +842,41 @@ shapeObj *msGEOSOffsetCurve(shapeObj *p,
    * works with lines, naturally. In order to allow offsets for a MapServer
    * polygonObj, it has to be processed as line and afterwards reverted.
    */
-  if(p->type == MS_SHAPE_POLYGON) {
+  if (p->type == MS_SHAPE_POLYGON) {
     p->type = MS_SHAPE_LINE;
     typeChanged = 1;
     msGEOSFreeGeometry(p);
   }
 
-  if(typeChanged || !p->geometry)
-    p->geometry = (GEOSGeom) msGEOSShape2Geometry(p);
+  if (typeChanged || !p->geometry)
+    p->geometry = (GEOSGeom)msGEOSShape2Geometry(p);
+
+  g1 = (GEOSGeom)p->geometry;
+  if (!g1)
+    return NULL;
 
-  g1 = (GEOSGeom) p->geometry;
-  if(!g1) return NULL;
-  
-  if (GEOSGeomTypeId_r(handle,g1) == GEOS_MULTILINESTRING)
-  {
-    GEOSGeom *lines = malloc(p->numlines*sizeof(GEOSGeom));
-    if (!lines) return NULL;
-    for(int i=0; i<p->numlines; i++)
-    {
-      lines[i] = GEOSOffsetCurve_r(handle, GEOSGetGeometryN_r(handle,g1,i),
-                                   offset, 4, GEOSBUF_JOIN_MITRE, fabs(offset*1.5));
+  if (GEOSGeomTypeId_r(handle, g1) == GEOS_MULTILINESTRING) {
+    GEOSGeom *lines = malloc(p->numlines * sizeof(GEOSGeom));
+    if (!lines)
+      return NULL;
+    for (int i = 0; i < p->numlines; i++) {
+      lines[i] =
+          GEOSOffsetCurve_r(handle, GEOSGetGeometryN_r(handle, g1, i), offset,
+                            4, GEOSBUF_JOIN_MITRE, fabs(offset * 1.5));
     }
-    g2 = GEOSGeom_createCollection_r(handle,GEOS_MULTILINESTRING, lines, p->numlines);
+    g2 = GEOSGeom_createCollection_r(handle, GEOS_MULTILINESTRING, lines,
+                                     p->numlines);
     free(lines);
-  }
-  else
-  {
-    g2 = GEOSOffsetCurve_r(handle,g1, offset, 4, GEOSBUF_JOIN_MITRE, fabs(offset*1.5));
+  } else {
+    g2 = GEOSOffsetCurve_r(handle, g1, offset, 4, GEOSBUF_JOIN_MITRE,
+                           fabs(offset * 1.5));
   }
 
   /*
    * Undo change of geometry type. We won't re-create the geos gemotry here,
    * it's up to each geos function to create it.
    */
-  if(typeChanged) {
+  if (typeChanged) {
     msGEOSFreeGeometry(p);
     p->type = MS_SHAPE_POLYGON;
   }
@@ -859,7 +886,8 @@ shapeObj *msGEOSOffsetCurve(shapeObj *p,
 
   return NULL;
 #else
-  msSetError(MS_GEOSERR, "GEOS Offset Curve support is not available.", "msGEOSingleSidedBuffer()");
+  msSetError(MS_GEOSERR, "GEOS Offset Curve support is not available.",
+             "msGEOSingleSidedBuffer()");
   return NULL;
 #endif
 }
@@ -868,22 +896,22 @@ shapeObj *msGEOSOffsetCurve(shapeObj *p,
 ** Analytical functions exposed to MapServer/MapScript.
 */
 
-shapeObj *msGEOSBuffer(shapeObj *shape, double width)
-{
+shapeObj *msGEOSBuffer(shapeObj *shape, double width) {
 #ifdef USE_GEOS
   GEOSGeom g1, g2;
   GEOSContextHandle_t handle = msGetGeosContextHandle();
 
-  if(!shape)
+  if (!shape)
     return NULL;
 
-  if(!shape->geometry) /* if no geometry for the shape then build one */
-    shape->geometry = (GEOSGeom) msGEOSShape2Geometry(shape);
+  if (!shape->geometry) /* if no geometry for the shape then build one */
+    shape->geometry = (GEOSGeom)msGEOSShape2Geometry(shape);
 
-  g1 = (GEOSGeom) shape->geometry;
-  if(!g1) return NULL;
+  g1 = (GEOSGeom)shape->geometry;
+  if (!g1)
+    return NULL;
 
-  g2 = GEOSBuffer_r(handle,g1, width, 30);
+  g2 = GEOSBuffer_r(handle, g1, width, 30);
   return msGEOSGeometry2Shape(g2);
 #else
   msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSBuffer()");
@@ -891,87 +919,92 @@ shapeObj *msGEOSBuffer(shapeObj *shape,
 #endif
 }
 
-shapeObj *msGEOSSimplify(shapeObj *shape, double tolerance)
-{
+shapeObj *msGEOSSimplify(shapeObj *shape, double tolerance) {
 #ifdef USE_GEOS
   GEOSGeom g1, g2;
   GEOSContextHandle_t handle = msGetGeosContextHandle();
 
-  if(!shape)
+  if (!shape)
     return NULL;
 
-  if(!shape->geometry) /* if no geometry for the shape then build one */
-    shape->geometry = (GEOSGeom) msGEOSShape2Geometry(shape);
+  if (!shape->geometry) /* if no geometry for the shape then build one */
+    shape->geometry = (GEOSGeom)msGEOSShape2Geometry(shape);
 
-  g1 = (GEOSGeom) shape->geometry;
-  if(!g1) return NULL;
+  g1 = (GEOSGeom)shape->geometry;
+  if (!g1)
+    return NULL;
 
-  g2 = GEOSSimplify_r(handle,g1, tolerance);
+  g2 = GEOSSimplify_r(handle, g1, tolerance);
   return msGEOSGeometry2Shape(g2);
 #else
-  msSetError(MS_GEOSERR, "GEOS Simplify support is not available.", "msGEOSSimplify()");
+  msSetError(MS_GEOSERR, "GEOS Simplify support is not available.",
+             "msGEOSSimplify()");
   return NULL;
 #endif
 }
 
-shapeObj *msGEOSTopologyPreservingSimplify(shapeObj *shape, double tolerance)
-{
+shapeObj *msGEOSTopologyPreservingSimplify(shapeObj *shape, double tolerance) {
 #ifdef USE_GEOS
   GEOSGeom g1, g2;
   GEOSContextHandle_t handle = msGetGeosContextHandle();
 
-  if(!shape)
+  if (!shape)
     return NULL;
 
-  if(!shape->geometry) /* if no geometry for the shape then build one */
-    shape->geometry = (GEOSGeom) msGEOSShape2Geometry(shape);
+  if (!shape->geometry) /* if no geometry for the shape then build one */
+    shape->geometry = (GEOSGeom)msGEOSShape2Geometry(shape);
 
-  g1 = (GEOSGeom) shape->geometry;
-  if(!g1) return NULL;
+  g1 = (GEOSGeom)shape->geometry;
+  if (!g1)
+    return NULL;
 
-  g2 = GEOSTopologyPreserveSimplify_r(handle,g1, tolerance);
+  g2 = GEOSTopologyPreserveSimplify_r(handle, g1, tolerance);
   return msGEOSGeometry2Shape(g2);
 #else
-  msSetError(MS_GEOSERR, "GEOS Simplify support is not available.", "msGEOSTopologyPreservingSimplify()");
+  msSetError(MS_GEOSERR, "GEOS Simplify support is not available.",
+             "msGEOSTopologyPreservingSimplify()");
   return NULL;
 #endif
 }
 
-shapeObj *msGEOSConvexHull(shapeObj *shape)
-{
+shapeObj *msGEOSConvexHull(shapeObj *shape) {
 #ifdef USE_GEOS
   GEOSGeom g1, g2;
   GEOSContextHandle_t handle = msGetGeosContextHandle();
 
-  if(!shape) return NULL;
+  if (!shape)
+    return NULL;
 
-  if(!shape->geometry) /* if no geometry for the shape then build one */
-    shape->geometry = (GEOSGeom) msGEOSShape2Geometry(shape);
-  g1 = (GEOSGeom) shape->geometry;
-  if(!g1) return NULL;
+  if (!shape->geometry) /* if no geometry for the shape then build one */
+    shape->geometry = (GEOSGeom)msGEOSShape2Geometry(shape);
+  g1 = (GEOSGeom)shape->geometry;
+  if (!g1)
+    return NULL;
 
-  g2 = GEOSConvexHull_r(handle,g1);
+  g2 = GEOSConvexHull_r(handle, g1);
   return msGEOSGeometry2Shape(g2);
 #else
-  msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSConvexHull()");
+  msSetError(MS_GEOSERR, "GEOS support is not available.",
+             "msGEOSConvexHull()");
   return NULL;
 #endif
 }
 
-shapeObj *msGEOSBoundary(shapeObj *shape)
-{
+shapeObj *msGEOSBoundary(shapeObj *shape) {
 #ifdef USE_GEOS
   GEOSGeom g1, g2;
   GEOSContextHandle_t handle = msGetGeosContextHandle();
 
-  if(!shape) return NULL;
+  if (!shape)
+    return NULL;
 
-  if(!shape->geometry) /* if no geometry for the shape then build one */
-    shape->geometry = (GEOSGeom) msGEOSShape2Geometry(shape);
-  g1 = (GEOSGeom) shape->geometry;
-  if(!g1) return NULL;
+  if (!shape->geometry) /* if no geometry for the shape then build one */
+    shape->geometry = (GEOSGeom)msGEOSShape2Geometry(shape);
+  g1 = (GEOSGeom)shape->geometry;
+  if (!g1)
+    return NULL;
 
-  g2 = GEOSBoundary_r(handle,g1);
+  g2 = GEOSBoundary_r(handle, g1);
   return msGEOSGeometry2Shape(g2);
 #else
   msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSBoundary()");
@@ -979,61 +1012,65 @@ shapeObj *msGEOSBoundary(shapeObj *shape
 #endif
 }
 
-pointObj *msGEOSGetCentroid(shapeObj *shape)
-{
+pointObj *msGEOSGetCentroid(shapeObj *shape) {
 #ifdef USE_GEOS
   GEOSGeom g1, g2;
   GEOSCoordSeq coords;
   pointObj *point;
   GEOSContextHandle_t handle = msGetGeosContextHandle();
 
-  if(!shape) return NULL;
+  if (!shape)
+    return NULL;
 
-  if(!shape->geometry) /* if no geometry for the shape then build one */
-    shape->geometry = (GEOSGeom) msGEOSShape2Geometry(shape);
-  g1 = (GEOSGeom) shape->geometry;
-  if(!g1) return NULL;
+  if (!shape->geometry) /* if no geometry for the shape then build one */
+    shape->geometry = (GEOSGeom)msGEOSShape2Geometry(shape);
+  g1 = (GEOSGeom)shape->geometry;
+  if (!g1)
+    return NULL;
 
-  g2 = GEOSGetCentroid_r(handle,g1);
-  if (!g2) return NULL;
+  g2 = GEOSGetCentroid_r(handle, g1);
+  if (!g2)
+    return NULL;
 
-  point = (pointObj *) malloc(sizeof(pointObj));
+  point = (pointObj *)malloc(sizeof(pointObj));
 
-  coords = (GEOSCoordSeq) GEOSGeom_getCoordSeq_r(handle,g2);
+  coords = (GEOSCoordSeq)GEOSGeom_getCoordSeq_r(handle, g2);
 
-  GEOSCoordSeq_getX_r(handle,coords, 0, &(point->x));
-  GEOSCoordSeq_getY_r(handle,coords, 0, &(point->y));
+  GEOSCoordSeq_getX_r(handle, coords, 0, &(point->x));
+  GEOSCoordSeq_getY_r(handle, coords, 0, &(point->y));
   /* GEOSCoordSeq_getZ(coords, 0, &(point->z)); */
 
   GEOSGeom_destroy_r(handle, g2);
 
   return point;
 #else
-  msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSGetCentroid()");
+  msSetError(MS_GEOSERR, "GEOS support is not available.",
+             "msGEOSGetCentroid()");
   return NULL;
 #endif
 }
 
-shapeObj *msGEOSUnion(shapeObj *shape1, shapeObj *shape2)
-{
+shapeObj *msGEOSUnion(shapeObj *shape1, shapeObj *shape2) {
 #ifdef USE_GEOS
   GEOSGeom g1, g2, g3;
   GEOSContextHandle_t handle = msGetGeosContextHandle();
 
-  if(!shape1 || !shape2)
+  if (!shape1 || !shape2)
     return NULL;
 
-  if(!shape1->geometry) /* if no geometry for the shape then build one */
-    shape1->geometry = (GEOSGeom) msGEOSShape2Geometry(shape1);
-  g1 = (GEOSGeom) shape1->geometry;
-  if(!g1) return NULL;
+  if (!shape1->geometry) /* if no geometry for the shape then build one */
+    shape1->geometry = (GEOSGeom)msGEOSShape2Geometry(shape1);
+  g1 = (GEOSGeom)shape1->geometry;
+  if (!g1)
+    return NULL;
 
-  if(!shape2->geometry) /* if no geometry for the shape then build one */
-    shape2->geometry = (GEOSGeom) msGEOSShape2Geometry(shape2);
-  g2 = (GEOSGeom) shape2->geometry;
-  if(!g2) return NULL;
+  if (!shape2->geometry) /* if no geometry for the shape then build one */
+    shape2->geometry = (GEOSGeom)msGEOSShape2Geometry(shape2);
+  g2 = (GEOSGeom)shape2->geometry;
+  if (!g2)
+    return NULL;
 
-  g3 = GEOSUnion_r(handle,g1, g2);
+  g3 = GEOSUnion_r(handle, g1, g2);
   return msGEOSGeometry2Shape(g3);
 #else
   msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSUnion()");
@@ -1041,100 +1078,108 @@ shapeObj *msGEOSUnion(shapeObj *shape1,
 #endif
 }
 
-shapeObj *msGEOSIntersection(shapeObj *shape1, shapeObj *shape2)
-{
+shapeObj *msGEOSIntersection(shapeObj *shape1, shapeObj *shape2) {
 #ifdef USE_GEOS
   GEOSGeom g1, g2, g3;
   GEOSContextHandle_t handle = msGetGeosContextHandle();
 
-  if(!shape1 || !shape2)
+  if (!shape1 || !shape2)
     return NULL;
 
-  if(!shape1->geometry) /* if no geometry for the shape then build one */
-    shape1->geometry = (GEOSGeom) msGEOSShape2Geometry(shape1);
-  g1 = (GEOSGeom) shape1->geometry;
-  if(!g1) return NULL;
+  if (!shape1->geometry) /* if no geometry for the shape then build one */
+    shape1->geometry = (GEOSGeom)msGEOSShape2Geometry(shape1);
+  g1 = (GEOSGeom)shape1->geometry;
+  if (!g1)
+    return NULL;
 
-  if(!shape2->geometry) /* if no geometry for the shape then build one */
-    shape2->geometry = (GEOSGeom) msGEOSShape2Geometry(shape2);
-  g2 = (GEOSGeom) shape2->geometry;
-  if(!g2) return NULL;
+  if (!shape2->geometry) /* if no geometry for the shape then build one */
+    shape2->geometry = (GEOSGeom)msGEOSShape2Geometry(shape2);
+  g2 = (GEOSGeom)shape2->geometry;
+  if (!g2)
+    return NULL;
 
-  g3 = GEOSIntersection_r(handle,g1, g2);
+  g3 = GEOSIntersection_r(handle, g1, g2);
   return msGEOSGeometry2Shape(g3);
 #else
-  msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSIntersection()");
+  msSetError(MS_GEOSERR, "GEOS support is not available.",
+             "msGEOSIntersection()");
   return NULL;
 #endif
 }
 
-shapeObj *msGEOSDifference(shapeObj *shape1, shapeObj *shape2)
-{
+shapeObj *msGEOSDifference(shapeObj *shape1, shapeObj *shape2) {
 #ifdef USE_GEOS
   GEOSGeom g1, g2, g3;
   GEOSContextHandle_t handle = msGetGeosContextHandle();
 
-  if(!shape1 || !shape2)
+  if (!shape1 || !shape2)
     return NULL;
 
-  if(!shape1->geometry) /* if no geometry for the shape then build one */
-    shape1->geometry = (GEOSGeom) msGEOSShape2Geometry(shape1);
-  g1 = (GEOSGeom) shape1->geometry;
-  if(!g1) return NULL;
+  if (!shape1->geometry) /* if no geometry for the shape then build one */
+    shape1->geometry = (GEOSGeom)msGEOSShape2Geometry(shape1);
+  g1 = (GEOSGeom)shape1->geometry;
+  if (!g1)
+    return NULL;
 
-  if(!shape2->geometry) /* if no geometry for the shape then build one */
-    shape2->geometry = (GEOSGeom) msGEOSShape2Geometry(shape2);
-  g2 = (GEOSGeom) shape2->geometry;
-  if(!g2) return NULL;
+  if (!shape2->geometry) /* if no geometry for the shape then build one */
+    shape2->geometry = (GEOSGeom)msGEOSShape2Geometry(shape2);
+  g2 = (GEOSGeom)shape2->geometry;
+  if (!g2)
+    return NULL;
 
-  g3 = GEOSDifference_r(handle,g1, g2);
+  g3 = GEOSDifference_r(handle, g1, g2);
   return msGEOSGeometry2Shape(g3);
 #else
-  msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSDifference()");
+  msSetError(MS_GEOSERR, "GEOS support is not available.",
+             "msGEOSDifference()");
   return NULL;
 #endif
 }
 
-shapeObj *msGEOSSymDifference(shapeObj *shape1, shapeObj *shape2)
-{
+shapeObj *msGEOSSymDifference(shapeObj *shape1, shapeObj *shape2) {
 #ifdef USE_GEOS
   GEOSGeom g1, g2, g3;
   GEOSContextHandle_t handle = msGetGeosContextHandle();
 
-  if(!shape1 || !shape2)
+  if (!shape1 || !shape2)
     return NULL;
 
-  if(!shape1->geometry) /* if no geometry for the shape then build one */
-    shape1->geometry = (GEOSGeom) msGEOSShape2Geometry(shape1);
-  g1 = (GEOSGeom) shape1->geometry;
-  if(!g1) return NULL;
+  if (!shape1->geometry) /* if no geometry for the shape then build one */
+    shape1->geometry = (GEOSGeom)msGEOSShape2Geometry(shape1);
+  g1 = (GEOSGeom)shape1->geometry;
+  if (!g1)
+    return NULL;
 
-  if(!shape2->geometry) /* if no geometry for the shape then build one */
-    shape2->geometry = (GEOSGeom) msGEOSShape2Geometry(shape2);
-  g2 = (GEOSGeom) shape2->geometry;
-  if(!g2) return NULL;
+  if (!shape2->geometry) /* if no geometry for the shape then build one */
+    shape2->geometry = (GEOSGeom)msGEOSShape2Geometry(shape2);
+  g2 = (GEOSGeom)shape2->geometry;
+  if (!g2)
+    return NULL;
 
-  g3 = GEOSSymDifference_r(handle,g1, g2);
+  g3 = GEOSSymDifference_r(handle, g1, g2);
   return msGEOSGeometry2Shape(g3);
 #else
-  msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSSymDifference()");
+  msSetError(MS_GEOSERR, "GEOS support is not available.",
+             "msGEOSSymDifference()");
   return NULL;
 #endif
 }
 
-shapeObj *msGEOSLineMerge(shapeObj *shape)
-{
+shapeObj *msGEOSLineMerge(shapeObj *shape) {
 #ifdef USE_GEOS
   GEOSGeom g1, g2;
   GEOSContextHandle_t handle = msGetGeosContextHandle();
 
-  if(!shape) return NULL;
-  if(shape->type != MS_SHAPE_LINE) return NULL;
+  if (!shape)
+    return NULL;
+  if (shape->type != MS_SHAPE_LINE)
+    return NULL;
 
-  if(!shape->geometry) /* if no geometry for the shape then build one */
-    shape->geometry = (GEOSGeom) msGEOSShape2Geometry(shape);
-  g1 = (GEOSGeom) shape->geometry;
-  if(!g1) return NULL;
+  if (!shape->geometry) /* if no geometry for the shape then build one */
+    shape->geometry = (GEOSGeom)msGEOSShape2Geometry(shape);
+  g1 = (GEOSGeom)shape->geometry;
+  if (!g1)
+    return NULL;
 
   g2 = GEOSLineMerge_r(handle, g1);
   return msGEOSGeometry2Shape(g2);
@@ -1144,52 +1189,64 @@ shapeObj *msGEOSLineMerge(shapeObj *shap
 #endif
 }
 
-shapeObj *msGEOSVoronoiDiagram(shapeObj *shape, double tolerance, int onlyEdges)
-{
-#if defined(USE_GEOS) && (GEOS_VERSION_MAJOR > 3 || (GEOS_VERSION_MAJOR == 3 && GEOS_VERSION_MINOR >= 5))
+shapeObj *msGEOSVoronoiDiagram(shapeObj *shape, double tolerance,
+                               int onlyEdges) {
+#if defined(USE_GEOS) &&                                                       \
+    (GEOS_VERSION_MAJOR > 3 ||                                                 \
+     (GEOS_VERSION_MAJOR == 3 && GEOS_VERSION_MINOR >= 5))
   GEOSGeom g1, g2;
   GEOSContextHandle_t handle = msGetGeosContextHandle();
 
-  if(!shape) return NULL;
+  if (!shape)
+    return NULL;
 
-  if(!shape->geometry) /* if no geometry for the shape then build one */
-    shape->geometry = (GEOSGeom) msGEOSShape2Geometry(shape);
-  g1 = (GEOSGeom) shape->geometry;
-  if(!g1) return NULL;
+  if (!shape->geometry) /* if no geometry for the shape then build one */
+    shape->geometry = (GEOSGeom)msGEOSShape2Geometry(shape);
+  g1 = (GEOSGeom)shape->geometry;
+  if (!g1)
+    return NULL;
 
   g2 = GEOSVoronoiDiagram_r(handle, g1, NULL, tolerance, onlyEdges);
   return msGEOSGeometry2Shape(g2);
 #else
-  msSetError(MS_GEOSERR, "GEOS support is not available or GEOS version is not 3.5 or higher.", "msGEOSVoronoiDiagram()");
+  msSetError(
+      MS_GEOSERR,
+      "GEOS support is not available or GEOS version is not 3.5 or higher.",
+      "msGEOSVoronoiDiagram()");
   return NULL;
 #endif
 }
 
-static int keepEdge(lineObj *segment, shapeObj *polygon)
-{
-  int i,j;
-
-  if(segment->numpoints<2) return MS_FALSE;
-  if(msIntersectPointPolygon(&segment->point[0], polygon) != MS_TRUE) return MS_FALSE;
-  if(msIntersectPointPolygon(&segment->point[1], polygon) != MS_TRUE) return MS_FALSE;
-
-  for(i=0; i<polygon->numlines; i++)
-    for(j=1; j<polygon->line[i].numpoints; j++)
-      if(msIntersectSegments(&(segment->point[0]), &(segment->point[1]), &(polygon->line[i].point[j-1]), &(polygon->line[i].point[j])) ==  MS_TRUE)
-        return(MS_FALSE);
-
-  return(MS_TRUE);
-}
-
-#define ARE_SAME_POINTS(a,b) (((a).x!=(b).x || (a).y!=(b).y)?MS_FALSE:MS_TRUE)
+static int keepEdge(lineObj *segment, shapeObj *polygon) {
+  int i, j;
 
-// returns the index of the node, we use z to store a count of points at the same coordinate
-static int buildNodes(multipointObj *nodes, pointObj *point)
-{
+  if (segment->numpoints < 2)
+    return MS_FALSE;
+  if (msIntersectPointPolygon(&segment->point[0], polygon) != MS_TRUE)
+    return MS_FALSE;
+  if (msIntersectPointPolygon(&segment->point[1], polygon) != MS_TRUE)
+    return MS_FALSE;
+
+  for (i = 0; i < polygon->numlines; i++)
+    for (j = 1; j < polygon->line[i].numpoints; j++)
+      if (msIntersectSegments(&(segment->point[0]), &(segment->point[1]),
+                              &(polygon->line[i].point[j - 1]),
+                              &(polygon->line[i].point[j])) == MS_TRUE)
+        return (MS_FALSE);
+
+  return (MS_TRUE);
+}
+
+#define ARE_SAME_POINTS(a, b)                                                  \
+  (((a).x != (b).x || (a).y != (b).y) ? MS_FALSE : MS_TRUE)
+
+// returns the index of the node, we use z to store a count of points at the
+// same coordinate
+static int buildNodes(multipointObj *nodes, pointObj *point) {
   int i;
 
-  for(i=0; i<nodes->numpoints; i++) {
-    if(ARE_SAME_POINTS(nodes->point[i], *point)) { // found it
+  for (i = 0; i < nodes->numpoints; i++) {
+    if (ARE_SAME_POINTS(nodes->point[i], *point)) { // found it
       nodes->point[i].z++;
       return i;
     }
@@ -1204,60 +1261,70 @@ static int buildNodes(multipointObj *nod
   return i;
 }
 
-shapeObj *msGEOSCenterline(shapeObj *shape)
-{
-#if defined(USE_GEOS) && (GEOS_VERSION_MAJOR > 3 || (GEOS_VERSION_MAJOR == 3 && GEOS_VERSION_MINOR >= 5))
+shapeObj *msGEOSCenterline(shapeObj *shape) {
+#if defined(USE_GEOS) &&                                                       \
+    (GEOS_VERSION_MAJOR > 3 ||                                                 \
+     (GEOS_VERSION_MAJOR == 3 && GEOS_VERSION_MINOR >= 5))
   int i;
-  shapeObj *shape2=NULL;
+  shapeObj *shape2 = NULL;
 
   multipointObj nodes;
   graphObj *graph;
 
-  int *path=NULL; // array of node indexes
-  int path_size=0;
-  double path_dist=-1, max_path_dist=-1;
-
-  if(!shape) return NULL;
-  if(shape->type != MS_SHAPE_POLYGON) {
-    msSetError(MS_GEOSERR, "Centerlines can only be computed for polygon shapes.", "msGEOSCenterline()");
+  int *path = NULL; // array of node indexes
+  int path_size = 0;
+  double path_dist = -1, max_path_dist = -1;
+
+  if (!shape)
+    return NULL;
+  if (shape->type != MS_SHAPE_POLYGON) {
+    msSetError(MS_GEOSERR,
+               "Centerlines can only be computed for polygon shapes.",
+               "msGEOSCenterline()");
     return NULL;
   }
 
   shape2 = msGEOSVoronoiDiagram(shape, 0.0, MS_TRUE);
-  if(!shape2) {
-    msSetError(MS_GEOSERR, "Voronoi diagram generation failed.", "msGEOSCenterline()");
+  if (!shape2) {
+    msSetError(MS_GEOSERR, "Voronoi diagram generation failed.",
+               "msGEOSCenterline()");
     return NULL;
   }
 
   // process the edges and build a graph representation
-  nodes.point = (pointObj *) malloc(shape2->numlines*sizeof(pointObj)*2);
+  nodes.point = (pointObj *)malloc(shape2->numlines * sizeof(pointObj) * 2);
   nodes.numpoints = 0;
-  if(!nodes.point) {
+  if (!nodes.point) {
     msFreeShape(shape2);
     free(shape2);
     return NULL;
   }
 
-  graph = msCreateGraph(shape2->numlines*2);
-  if(!graph) {
+  graph = msCreateGraph(shape2->numlines * 2);
+  if (!graph) {
     msFreeShape(shape2);
     free(shape2);
     free(nodes.point);
     return NULL;
   }
 
-  for(i=0; i<shape2->numlines; i++) {
-    if(keepEdge(&shape2->line[i], shape) == MS_TRUE) {
+  for (i = 0; i < shape2->numlines; i++) {
+    if (keepEdge(&shape2->line[i], shape) == MS_TRUE) {
       int src = buildNodes(&nodes, &shape2->line[i].point[0]);
       int dest = buildNodes(&nodes, &shape2->line[i].point[1]);
-      msGraphAddEdge(graph, src, dest, msDistancePointToPoint(&shape2->line[i].point[0], &shape2->line[i].point[1]));
+      msGraphAddEdge(graph, src, dest,
+                     msDistancePointToPoint(&shape2->line[i].point[0],
+                                            &shape2->line[i].point[1]));
     }
   }
-  msFreeShape(shape2); // done with voronoi geometry, shape2 is still allocated though, just empty
+  msFreeShape(shape2); // done with voronoi geometry, shape2 is still allocated
+                       // though, just empty
   shape2->type = MS_SHAPE_LINE; // will fill with centerline
 
-  if(nodes.numpoints == 0) {
-    msSetError(MS_GEOSERR, "Centerline generation failed, try densifying the shapes.", "msGEOSCenterline()");
+  if (nodes.numpoints == 0) {
+    msSetError(MS_GEOSERR,
+               "Centerline generation failed, try densifying the shapes.",
+               "msGEOSCenterline()");
     free(shape2);
     msFreeGraph(graph);
     free(nodes.point);
@@ -1265,20 +1332,23 @@ shapeObj *msGEOSCenterline(shapeObj *sha
   }
 
   // step through edge nodes (z=1)
-  for(i=0; i<nodes.numpoints; i++) {
-    if(nodes.point[i].z != 1) continue; // skip
+  for (i = 0; i < nodes.numpoints; i++) {
+    if (nodes.point[i].z != 1)
+      continue; // skip
 
-    if(!path) { // first one, keep this path
+    if (!path) { // first one, keep this path
       path = msGraphGetLongestShortestPath(graph, i, &path_size, &path_dist);
       max_path_dist = path_dist;
     } else {
-      int *tmp_path=NULL;
-      int tmp_path_size=0;
-      double tmp_path_dist=-1;
-
-      if(i == path[path_size-1]) continue; // skip, graph is bi-directional so it can't be any longer
-      tmp_path = msGraphGetLongestShortestPath(graph, i, &tmp_path_size, &tmp_path_dist);
-      if(tmp_path_dist > max_path_dist) {
+      int *tmp_path = NULL;
+      int tmp_path_size = 0;
+      double tmp_path_dist = -1;
+
+      if (i == path[path_size - 1])
+        continue; // skip, graph is bi-directional so it can't be any longer
+      tmp_path = msGraphGetLongestShortestPath(graph, i, &tmp_path_size,
+                                               &tmp_path_dist);
+      if (tmp_path_dist > max_path_dist) {
         free(path);
         path = tmp_path;
         path_size = tmp_path_size;
@@ -1292,15 +1362,16 @@ shapeObj *msGEOSCenterline(shapeObj *sha
   msFreeGraph(graph); // done with graph
 
   // transform the path into a shape
-  if(!path) {
-    msSetError(MS_GEOSERR, "Centerline generation failed.", "msGEOSCenterline()");
+  if (!path) {
+    msSetError(MS_GEOSERR, "Centerline generation failed.",
+               "msGEOSCenterline()");
     free(shape2);
     free(nodes.point);
     return NULL;
   } else {
     lineObj line;
-    line.point = (pointObj *) malloc(path_size*sizeof(pointObj));
-    if(!line.point) {
+    line.point = (pointObj *)malloc(path_size * sizeof(pointObj));
+    if (!line.point) {
       free(shape2);
       free(path);
       free(nodes.point);
@@ -1308,7 +1379,7 @@ shapeObj *msGEOSCenterline(shapeObj *sha
     }
     line.numpoints = path_size;
 
-    for(i=0; i<path_size; i++) {
+    for (i = 0; i < path_size; i++) {
       line.point[i].x = nodes.point[path[i]].x;
       line.point[i].y = nodes.point[path[i]].y;
     }
@@ -1320,7 +1391,10 @@ shapeObj *msGEOSCenterline(shapeObj *sha
 
   return shape2;
 #else
-  msSetError(MS_GEOSERR, "GEOS support is not available or GEOS version is not 3.5 or higher.", "msGEOSCenterline()");
+  msSetError(
+      MS_GEOSERR,
+      "GEOS support is not available or GEOS version is not 3.5 or higher.",
+      "msGEOSCenterline()");
   return NULL;
 #endif
 }
@@ -1332,28 +1406,29 @@ shapeObj *msGEOSCenterline(shapeObj *sha
 /*
 ** Does shape1 contain shape2, returns MS_TRUE/MS_FALSE or -1 for an error.
 */
-int msGEOSContains(shapeObj *shape1, shapeObj *shape2)
-{
+int msGEOSContains(shapeObj *shape1, shapeObj *shape2) {
 #ifdef USE_GEOS
   GEOSGeom g1, g2;
   int result;
   GEOSContextHandle_t handle = msGetGeosContextHandle();
 
-  if(!shape1 || !shape2)
+  if (!shape1 || !shape2)
     return -1;
 
-  if(!shape1->geometry) /* if no geometry for shape1 then build one */
-    shape1->geometry = (GEOSGeom) msGEOSShape2Geometry(shape1);
+  if (!shape1->geometry) /* if no geometry for shape1 then build one */
+    shape1->geometry = (GEOSGeom)msGEOSShape2Geometry(shape1);
   g1 = shape1->geometry;
-  if(!g1) return -1;
+  if (!g1)
+    return -1;
 
-  if(!shape2->geometry) /* if no geometry for shape2 then build one */
-    shape2->geometry = (GEOSGeom) msGEOSShape2Geometry(shape2);
+  if (!shape2->geometry) /* if no geometry for shape2 then build one */
+    shape2->geometry = (GEOSGeom)msGEOSShape2Geometry(shape2);
   g2 = shape2->geometry;
-  if(!g2) return -1;
+  if (!g2)
+    return -1;
 
-  result = GEOSContains_r(handle,g1, g2);
-  return ((result==2) ? -1 : result);
+  result = GEOSContains_r(handle, g1, g2);
+  return ((result == 2) ? -1 : result);
 #else
   msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSContains()");
   return -1;
@@ -1363,28 +1438,29 @@ int msGEOSContains(shapeObj *shape1, sha
 /*
 ** Does shape1 overlap shape2, returns MS_TRUE/MS_FALSE or -1 for an error.
 */
-int msGEOSOverlaps(shapeObj *shape1, shapeObj *shape2)
-{
+int msGEOSOverlaps(shapeObj *shape1, shapeObj *shape2) {
 #ifdef USE_GEOS
   GEOSGeom g1, g2;
   int result;
   GEOSContextHandle_t handle = msGetGeosContextHandle();
 
-  if(!shape1 || !shape2)
+  if (!shape1 || !shape2)
     return -1;
 
-  if(!shape1->geometry) /* if no geometry for shape1 then build one */
-    shape1->geometry = (GEOSGeom) msGEOSShape2Geometry(shape1);
+  if (!shape1->geometry) /* if no geometry for shape1 then build one */
+    shape1->geometry = (GEOSGeom)msGEOSShape2Geometry(shape1);
   g1 = shape1->geometry;
-  if(!g1) return -1;
+  if (!g1)
+    return -1;
 
-  if(!shape2->geometry) /* if no geometry for shape2 then build one */
-    shape2->geometry = (GEOSGeom) msGEOSShape2Geometry(shape2);
+  if (!shape2->geometry) /* if no geometry for shape2 then build one */
+    shape2->geometry = (GEOSGeom)msGEOSShape2Geometry(shape2);
   g2 = shape2->geometry;
-  if(!g2) return -1;
+  if (!g2)
+    return -1;
 
-  result = GEOSOverlaps_r(handle,g1, g2);
-  return ((result==2) ? -1 : result);
+  result = GEOSOverlaps_r(handle, g1, g2);
+  return ((result == 2) ? -1 : result);
 #else
   msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSOverlaps()");
   return -1;
@@ -1394,28 +1470,29 @@ int msGEOSOverlaps(shapeObj *shape1, sha
 /*
 ** Is shape1 within shape2, returns MS_TRUE/MS_FALSE or -1 for an error.
 */
-int msGEOSWithin(shapeObj *shape1, shapeObj *shape2)
-{
+int msGEOSWithin(shapeObj *shape1, shapeObj *shape2) {
 #ifdef USE_GEOS
   GEOSGeom g1, g2;
   int result;
   GEOSContextHandle_t handle = msGetGeosContextHandle();
 
-  if(!shape1 || !shape2)
+  if (!shape1 || !shape2)
     return -1;
 
-  if(!shape1->geometry) /* if no geometry for shape1 then build one */
-    shape1->geometry = (GEOSGeom) msGEOSShape2Geometry(shape1);
+  if (!shape1->geometry) /* if no geometry for shape1 then build one */
+    shape1->geometry = (GEOSGeom)msGEOSShape2Geometry(shape1);
   g1 = shape1->geometry;
-  if(!g1) return -1;
+  if (!g1)
+    return -1;
 
-  if(!shape2->geometry) /* if no geometry for shape2 then build one */
-    shape2->geometry = (GEOSGeom) msGEOSShape2Geometry(shape2);
+  if (!shape2->geometry) /* if no geometry for shape2 then build one */
+    shape2->geometry = (GEOSGeom)msGEOSShape2Geometry(shape2);
   g2 = shape2->geometry;
-  if(!g2) return -1;
+  if (!g2)
+    return -1;
 
-  result = GEOSWithin_r(handle,g1, g2);
-  return ((result==2) ? -1 : result);
+  result = GEOSWithin_r(handle, g1, g2);
+  return ((result == 2) ? -1 : result);
 #else
   msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSWithin()");
   return -1;
@@ -1425,28 +1502,29 @@ int msGEOSWithin(shapeObj *shape1, shape
 /*
 ** Does shape1 cross shape2, returns MS_TRUE/MS_FALSE or -1 for an error.
 */
-int msGEOSCrosses(shapeObj *shape1, shapeObj *shape2)
-{
+int msGEOSCrosses(shapeObj *shape1, shapeObj *shape2) {
 #ifdef USE_GEOS
   GEOSGeom g1, g2;
   int result;
   GEOSContextHandle_t handle = msGetGeosContextHandle();
 
-  if(!shape1 || !shape2)
+  if (!shape1 || !shape2)
     return -1;
 
-  if(!shape1->geometry) /* if no geometry for shape1 then build one */
-    shape1->geometry = (GEOSGeom) msGEOSShape2Geometry(shape1);
+  if (!shape1->geometry) /* if no geometry for shape1 then build one */
+    shape1->geometry = (GEOSGeom)msGEOSShape2Geometry(shape1);
   g1 = shape1->geometry;
-  if(!g1) return -1;
+  if (!g1)
+    return -1;
 
-  if(!shape2->geometry) /* if no geometry for shape2 then build one */
-    shape2->geometry = (GEOSGeom) msGEOSShape2Geometry(shape2);
+  if (!shape2->geometry) /* if no geometry for shape2 then build one */
+    shape2->geometry = (GEOSGeom)msGEOSShape2Geometry(shape2);
   g2 = shape2->geometry;
-  if(!g2) return -1;
+  if (!g2)
+    return -1;
 
-  result = GEOSCrosses_r(handle,g1, g2);
-  return ((result==2) ? -1 : result);
+  result = GEOSCrosses_r(handle, g1, g2);
+  return ((result == 2) ? -1 : result);
 #else
   msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSCrosses()");
   return -1;
@@ -1456,49 +1534,50 @@ int msGEOSCrosses(shapeObj *shape1, shap
 /*
 ** Does shape1 intersect shape2, returns MS_TRUE/MS_FALSE or -1 for an error.
 */
-int msGEOSIntersects(shapeObj *shape1, shapeObj *shape2)
-{
+int msGEOSIntersects(shapeObj *shape1, shapeObj *shape2) {
 #ifdef USE_GEOS
   GEOSGeom g1, g2;
   int result;
   GEOSContextHandle_t handle = msGetGeosContextHandle();
 
-  if(!shape1 || !shape2)
+  if (!shape1 || !shape2)
     return -1;
 
-  if(!shape1->geometry) /* if no geometry for shape1 then build one */
-    shape1->geometry = (GEOSGeom) msGEOSShape2Geometry(shape1);
-  g1 = (GEOSGeom) shape1->geometry;
-  if(!g1) return -1;
+  if (!shape1->geometry) /* if no geometry for shape1 then build one */
+    shape1->geometry = (GEOSGeom)msGEOSShape2Geometry(shape1);
+  g1 = (GEOSGeom)shape1->geometry;
+  if (!g1)
+    return -1;
 
-  if(!shape2->geometry) /* if no geometry for shape2 then build one */
-    shape2->geometry = (GEOSGeom) msGEOSShape2Geometry(shape2);
-  g2 = (GEOSGeom) shape2->geometry;
-  if(!g2) return -1;
+  if (!shape2->geometry) /* if no geometry for shape2 then build one */
+    shape2->geometry = (GEOSGeom)msGEOSShape2Geometry(shape2);
+  g2 = (GEOSGeom)shape2->geometry;
+  if (!g2)
+    return -1;
 
-  result = GEOSIntersects_r(handle,g1, g2);
-  return ((result==2) ? -1 : result);
+  result = GEOSIntersects_r(handle, g1, g2);
+  return ((result == 2) ? -1 : result);
 #else
-  if(!shape1 || !shape2)
+  if (!shape1 || !shape2)
     return -1;
 
-  switch(shape1->type) { /* todo: deal with point shapes */
-    case(MS_SHAPE_LINE):
-      switch(shape2->type) {
-        case(MS_SHAPE_LINE):
-          return msIntersectPolylines(shape1, shape2);
-        case(MS_SHAPE_POLYGON):
-          return msIntersectPolylinePolygon(shape1, shape2);
-      }
-      break;
-    case(MS_SHAPE_POLYGON):
-      switch(shape2->type) {
-        case(MS_SHAPE_LINE):
-          return msIntersectPolylinePolygon(shape2, shape1);
-        case(MS_SHAPE_POLYGON):
-          return msIntersectPolygons(shape1, shape2);
-      }
-      break;
+  switch (shape1->type) { /* todo: deal with point shapes */
+  case (MS_SHAPE_LINE):
+    switch (shape2->type) {
+    case (MS_SHAPE_LINE):
+      return msIntersectPolylines(shape1, shape2);
+    case (MS_SHAPE_POLYGON):
+      return msIntersectPolylinePolygon(shape1, shape2);
+    }
+    break;
+  case (MS_SHAPE_POLYGON):
+    switch (shape2->type) {
+    case (MS_SHAPE_LINE):
+      return msIntersectPolylinePolygon(shape2, shape1);
+    case (MS_SHAPE_POLYGON):
+      return msIntersectPolygons(shape1, shape2);
+    }
+    break;
   }
 
   return -1;
@@ -1508,28 +1587,29 @@ int msGEOSIntersects(shapeObj *shape1, s
 /*
 ** Does shape1 touch shape2, returns MS_TRUE/MS_FALSE or -1 for an error.
 */
-int msGEOSTouches(shapeObj *shape1, shapeObj *shape2)
-{
+int msGEOSTouches(shapeObj *shape1, shapeObj *shape2) {
 #ifdef USE_GEOS
   GEOSGeom g1, g2;
   int result;
   GEOSContextHandle_t handle = msGetGeosContextHandle();
 
-  if(!shape1 || !shape2)
+  if (!shape1 || !shape2)
     return -1;
 
-  if(!shape1->geometry) /* if no geometry for shape1 then build one */
-    shape1->geometry = (GEOSGeom) msGEOSShape2Geometry(shape1);
-  g1 = (GEOSGeom) shape1->geometry;
-  if(!g1) return -1;
+  if (!shape1->geometry) /* if no geometry for shape1 then build one */
+    shape1->geometry = (GEOSGeom)msGEOSShape2Geometry(shape1);
+  g1 = (GEOSGeom)shape1->geometry;
+  if (!g1)
+    return -1;
 
-  if(!shape2->geometry) /* if no geometry for shape2 then build one */
-    shape2->geometry = (GEOSGeom) msGEOSShape2Geometry(shape2);
-  g2 = (GEOSGeom) shape2->geometry;
-  if(!g2) return -1;
+  if (!shape2->geometry) /* if no geometry for shape2 then build one */
+    shape2->geometry = (GEOSGeom)msGEOSShape2Geometry(shape2);
+  g2 = (GEOSGeom)shape2->geometry;
+  if (!g2)
+    return -1;
 
-  result = GEOSTouches_r(handle,g1, g2);
-  return ((result==2) ? -1 : result);
+  result = GEOSTouches_r(handle, g1, g2);
+  return ((result == 2) ? -1 : result);
 #else
   msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSTouches()");
   return -1;
@@ -1539,28 +1619,29 @@ int msGEOSTouches(shapeObj *shape1, shap
 /*
 ** Does shape1 equal shape2, returns MS_TRUE/MS_FALSE or -1 for an error.
 */
-int msGEOSEquals(shapeObj *shape1, shapeObj *shape2)
-{
+int msGEOSEquals(shapeObj *shape1, shapeObj *shape2) {
 #ifdef USE_GEOS
   GEOSGeom g1, g2;
   int result;
   GEOSContextHandle_t handle = msGetGeosContextHandle();
 
-  if(!shape1 || !shape2)
+  if (!shape1 || !shape2)
     return -1;
 
-  if(!shape1->geometry) /* if no geometry for shape1 then build one */
-    shape1->geometry = (GEOSGeom) msGEOSShape2Geometry(shape1);
-  g1 = (GEOSGeom) shape1->geometry;
-  if(!g1) return -1;
+  if (!shape1->geometry) /* if no geometry for shape1 then build one */
+    shape1->geometry = (GEOSGeom)msGEOSShape2Geometry(shape1);
+  g1 = (GEOSGeom)shape1->geometry;
+  if (!g1)
+    return -1;
 
-  if(!shape2->geometry) /* if no geometry for shape2 then build one */
-    shape2->geometry = (GEOSGeom) msGEOSShape2Geometry(shape2);
-  g2 = (GEOSGeom) shape2->geometry;
-  if(!g2) return -1;
+  if (!shape2->geometry) /* if no geometry for shape2 then build one */
+    shape2->geometry = (GEOSGeom)msGEOSShape2Geometry(shape2);
+  g2 = (GEOSGeom)shape2->geometry;
+  if (!g2)
+    return -1;
 
-  result = GEOSEquals_r(handle,g1, g2);
-  return ((result==2) ? -1 : result);
+  result = GEOSEquals_r(handle, g1, g2);
+  return ((result == 2) ? -1 : result);
 #else
   msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSEquals()");
   return -1;
@@ -1570,28 +1651,29 @@ int msGEOSEquals(shapeObj *shape1, shape
 /*
 ** Are shape1 and shape2 disjoint, returns MS_TRUE/MS_FALSE or -1 for an error.
 */
-int msGEOSDisjoint(shapeObj *shape1, shapeObj *shape2)
-{
+int msGEOSDisjoint(shapeObj *shape1, shapeObj *shape2) {
 #ifdef USE_GEOS
   GEOSGeom g1, g2;
   int result;
   GEOSContextHandle_t handle = msGetGeosContextHandle();
 
-  if(!shape1 || !shape2)
+  if (!shape1 || !shape2)
     return -1;
 
-  if(!shape1->geometry) /* if no geometry for shape1 then build one */
-    shape1->geometry = (GEOSGeom) msGEOSShape2Geometry(shape1);
-  g1 = (GEOSGeom) shape1->geometry;
-  if(!g1) return -1;
+  if (!shape1->geometry) /* if no geometry for shape1 then build one */
+    shape1->geometry = (GEOSGeom)msGEOSShape2Geometry(shape1);
+  g1 = (GEOSGeom)shape1->geometry;
+  if (!g1)
+    return -1;
 
-  if(!shape2->geometry) /* if no geometry for shape2 then build one */
-    shape2->geometry = (GEOSGeom) msGEOSShape2Geometry(shape2);
-  g2 = (GEOSGeom) shape2->geometry;
-  if(!g2) return -1;
+  if (!shape2->geometry) /* if no geometry for shape2 then build one */
+    shape2->geometry = (GEOSGeom)msGEOSShape2Geometry(shape2);
+  g2 = (GEOSGeom)shape2->geometry;
+  if (!g2)
+    return -1;
 
-  result = GEOSDisjoint_r(handle,g1, g2);
-  return ((result==2) ? -1 : result);
+  result = GEOSDisjoint_r(handle, g1, g2);
+  return ((result == 2) ? -1 : result);
 #else
   msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSDisjoint()");
   return -1;
@@ -1601,25 +1683,30 @@ int msGEOSDisjoint(shapeObj *shape1, sha
 /*
 ** Useful misc. functions that return -1 on failure.
 */
-double msGEOSArea(shapeObj *shape)
-{
-#if defined(USE_GEOS) && defined(GEOS_CAPI_VERSION_MAJOR) && defined(GEOS_CAPI_VERSION_MINOR) && (GEOS_CAPI_VERSION_MAJOR > 1 || GEOS_CAPI_VERSION_MINOR >= 1)
+double msGEOSArea(shapeObj *shape) {
+#if defined(USE_GEOS) && defined(GEOS_CAPI_VERSION_MAJOR) &&                   \
+    defined(GEOS_CAPI_VERSION_MINOR) &&                                        \
+    (GEOS_CAPI_VERSION_MAJOR > 1 || GEOS_CAPI_VERSION_MINOR >= 1)
   GEOSGeom g;
   double area;
   int result;
   GEOSContextHandle_t handle = msGetGeosContextHandle();
 
-  if(!shape) return -1;
+  if (!shape)
+    return -1;
 
-  if(!shape->geometry) /* if no geometry for the shape then build one */
-    shape->geometry = (GEOSGeom) msGEOSShape2Geometry(shape);
-  g = (GEOSGeom) shape->geometry;
-  if(!g) return -1;
+  if (!shape->geometry) /* if no geometry for the shape then build one */
+    shape->geometry = (GEOSGeom)msGEOSShape2Geometry(shape);
+  g = (GEOSGeom)shape->geometry;
+  if (!g)
+    return -1;
 
-  result = GEOSArea_r(handle,g, &area);
-  return  ((result==0) ? -1 : area);
+  result = GEOSArea_r(handle, g, &area);
+  return ((result == 0) ? -1 : area);
 #elif defined(USE_GEOS)
-  msSetError(MS_GEOSERR, "GEOS support enabled, but old version lacks GEOSArea().", "msGEOSArea()");
+  msSetError(MS_GEOSERR,
+             "GEOS support enabled, but old version lacks GEOSArea().",
+             "msGEOSArea()");
   return -1;
 #else
   msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSArea()");
@@ -1627,26 +1714,31 @@ double msGEOSArea(shapeObj *shape)
 #endif
 }
 
-double msGEOSLength(shapeObj *shape)
-{
-#if defined(USE_GEOS) && defined(GEOS_CAPI_VERSION_MAJOR) && defined(GEOS_CAPI_VERSION_MINOR) && (GEOS_CAPI_VERSION_MAJOR > 1 || GEOS_CAPI_VERSION_MINOR >= 1)
+double msGEOSLength(shapeObj *shape) {
+#if defined(USE_GEOS) && defined(GEOS_CAPI_VERSION_MAJOR) &&                   \
+    defined(GEOS_CAPI_VERSION_MINOR) &&                                        \
+    (GEOS_CAPI_VERSION_MAJOR > 1 || GEOS_CAPI_VERSION_MINOR >= 1)
 
   GEOSGeom g;
   double length;
   int result;
   GEOSContextHandle_t handle = msGetGeosContextHandle();
 
-  if(!shape) return -1;
+  if (!shape)
+    return -1;
 
-  if(!shape->geometry) /* if no geometry for the shape then build one */
-    shape->geometry = (GEOSGeom) msGEOSShape2Geometry(shape);
-  g = (GEOSGeom) shape->geometry;
-  if(!g) return -1;
+  if (!shape->geometry) /* if no geometry for the shape then build one */
+    shape->geometry = (GEOSGeom)msGEOSShape2Geometry(shape);
+  g = (GEOSGeom)shape->geometry;
+  if (!g)
+    return -1;
 
-  result = GEOSLength_r(handle,g, &length);
-  return  ((result==0) ? -1 : length);
+  result = GEOSLength_r(handle, g, &length);
+  return ((result == 0) ? -1 : length);
 #elif defined(USE_GEOS)
-  msSetError(MS_GEOSERR, "GEOS support enabled, but old version lacks GEOSLength().", "msGEOSLength()");
+  msSetError(MS_GEOSERR,
+             "GEOS support enabled, but old version lacks GEOSLength().",
+             "msGEOSLength()");
   return -1;
 #else
   msSetError(MS_GEOSERR, "GEOS support is not available.", "msGEOSLength()");
@@ -1654,30 +1746,32 @@ double msGEOSLength(shapeObj *shape)
 #endif
 }
 
-double msGEOSDistance(shapeObj *shape1, shapeObj *shape2)
-{
+double msGEOSDistance(shapeObj *shape1, shapeObj *shape2) {
 #ifdef USE_GEOS
   GEOSGeom g1, g2;
   double distance;
   int result;
   GEOSContextHandle_t handle = msGetGeosContextHandle();
 
-  if(!shape1 || !shape2)
+  if (!shape1 || !shape2)
     return -1;
 
-  if(!shape1->geometry) /* if no geometry for shape1 then build one */
-    shape1->geometry = (GEOSGeom) msGEOSShape2Geometry(shape1);
-  g1 = (GEOSGeom) shape1->geometry;
-  if(!g1) return -1;
+  if (!shape1->geometry) /* if no geometry for shape1 then build one */
+    shape1->geometry = (GEOSGeom)msGEOSShape2Geometry(shape1);
+  g1 = (GEOSGeom)shape1->geometry;
+  if (!g1)
+    return -1;
 
-  if(!shape2->geometry) /* if no geometry for shape2 then build one */
-    shape2->geometry = (GEOSGeom) msGEOSShape2Geometry(shape2);
-  g2 = (GEOSGeom) shape2->geometry;
-  if(!g2) return -1;
+  if (!shape2->geometry) /* if no geometry for shape2 then build one */
+    shape2->geometry = (GEOSGeom)msGEOSShape2Geometry(shape2);
+  g2 = (GEOSGeom)shape2->geometry;
+  if (!g2)
+    return -1;
 
-  result = GEOSDistance_r(handle,g1, g2, &distance);
-  return ((result==0) ? -1 : distance);
+  result = GEOSDistance_r(handle, g1, g2, &distance);
+  return ((result == 0) ? -1 : distance);
 #else
-  return msDistanceShapeToShape(shape1, shape2); /* fall back on brute force method (for MapScript) */
+  return msDistanceShapeToShape(
+      shape1, shape2); /* fall back on brute force method (for MapScript) */
 #endif
 }
diff -pruN 8.0.1-5/mapgml.c 8.0.2-1/mapgml.c
--- 8.0.1-5/mapgml.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapgml.c	2024-06-11 20:41:34.000000000 +0000
@@ -33,38 +33,42 @@
 #include "mapgml.h"
 #include "maptime.h"
 
+/* Use only mapgml.c if WMS or WFS is available (with minor exceptions at end)
+ */
 
-/* Use only mapgml.c if WMS or WFS is available (with minor exceptions at end) */
-
-#if defined(USE_WMS_SVR) || defined (USE_WFS_SVR)
+#if defined(USE_WMS_SVR) || defined(USE_WFS_SVR)
 
-static int msGMLGeometryLookup(gmlGeometryListObj *geometryList, const char *type);
+static int msGMLGeometryLookup(gmlGeometryListObj *geometryList,
+                               const char *type);
 
 /*
 ** Functions that write the feature boundary geometry (i.e. a rectObj).
 */
 
 /* GML 2.1.2 */
-static int gmlWriteBounds_GML2(FILE *stream, rectObj *rect,
-                               const char *srsname, const char *tab,
-                               const char *pszTopPrefix)
-{
+static int gmlWriteBounds_GML2(FILE *stream, rectObj *rect, const char *srsname,
+                               const char *tab, const char *pszTopPrefix) {
   char *srsname_encoded;
 
-  if(!stream) return(MS_FAILURE);
-  if(!rect) return(MS_FAILURE);
-  if(!tab) return(MS_FAILURE);
+  if (!stream)
+    return (MS_FAILURE);
+  if (!rect)
+    return (MS_FAILURE);
+  if (!tab)
+    return (MS_FAILURE);
 
   msIO_fprintf(stream, "%s<%s:boundedBy>\n", tab, pszTopPrefix);
-  if(srsname) {
+  if (srsname) {
     srsname_encoded = msEncodeHTMLEntities(srsname);
-    msIO_fprintf(stream, "%s\t<gml:Box srsName=\"%s\">\n", tab, srsname_encoded);
+    msIO_fprintf(stream, "%s\t<gml:Box srsName=\"%s\">\n", tab,
+                 srsname_encoded);
     msFree(srsname_encoded);
   } else
     msIO_fprintf(stream, "%s\t<gml:Box>\n", tab);
 
   msIO_fprintf(stream, "%s\t\t<gml:coordinates>", tab);
-  msIO_fprintf(stream, "%.6f,%.6f %.6f,%.6f", rect->minx, rect->miny, rect->maxx, rect->maxy );
+  msIO_fprintf(stream, "%.6f,%.6f %.6f,%.6f", rect->minx, rect->miny,
+               rect->maxx, rect->maxy);
   msIO_fprintf(stream, "</gml:coordinates>\n");
   msIO_fprintf(stream, "%s\t</gml:Box>\n", tab);
   msIO_fprintf(stream, "%s</%s:boundedBy>\n", tab, pszTopPrefix);
@@ -73,26 +77,30 @@ static int gmlWriteBounds_GML2(FILE *str
 }
 
 /* GML 3.1 or GML 3.2 (MapServer limits GML encoding to the level 0 profile) */
-static int gmlWriteBounds_GML3(FILE *stream, rectObj *rect,
-                               const char *srsname, const char *tab,
-                               const char *pszTopPrefix)
-{
+static int gmlWriteBounds_GML3(FILE *stream, rectObj *rect, const char *srsname,
+                               const char *tab, const char *pszTopPrefix) {
   char *srsname_encoded;
 
-  if(!stream) return(MS_FAILURE);
-  if(!rect) return(MS_FAILURE);
-  if(!tab) return(MS_FAILURE);
+  if (!stream)
+    return (MS_FAILURE);
+  if (!rect)
+    return (MS_FAILURE);
+  if (!tab)
+    return (MS_FAILURE);
 
   msIO_fprintf(stream, "%s<%s:boundedBy>\n", tab, pszTopPrefix);
-  if(srsname) {
+  if (srsname) {
     srsname_encoded = msEncodeHTMLEntities(srsname);
-    msIO_fprintf(stream, "%s\t<gml:Envelope srsName=\"%s\">\n", tab, srsname_encoded);
+    msIO_fprintf(stream, "%s\t<gml:Envelope srsName=\"%s\">\n", tab,
+                 srsname_encoded);
     msFree(srsname_encoded);
   } else
     msIO_fprintf(stream, "%s\t<gml:Envelope>\n", tab);
 
-  msIO_fprintf(stream, "%s\t\t<gml:lowerCorner>%.6f %.6f</gml:lowerCorner>\n", tab, rect->minx, rect->miny);
-  msIO_fprintf(stream, "%s\t\t<gml:upperCorner>%.6f %.6f</gml:upperCorner>\n", tab, rect->maxx, rect->maxy);
+  msIO_fprintf(stream, "%s\t\t<gml:lowerCorner>%.6f %.6f</gml:lowerCorner>\n",
+               tab, rect->minx, rect->miny);
+  msIO_fprintf(stream, "%s\t\t<gml:upperCorner>%.6f %.6f</gml:upperCorner>\n",
+               tab, rect->maxx, rect->maxy);
 
   msIO_fprintf(stream, "%s\t</gml:Envelope>\n", tab);
   msIO_fprintf(stream, "%s</%s:boundedBy>\n", tab, pszTopPrefix);
@@ -101,26 +109,26 @@ static int gmlWriteBounds_GML3(FILE *str
 }
 
 static void gmlStartGeometryContainer(FILE *stream, const char *name,
-                                      const char *namespace, const char *tab)
-{
-  const char *tag_name=OWS_GML_DEFAULT_GEOMETRY_NAME;
+                                      const char *namespace, const char *tab) {
+  const char *tag_name = OWS_GML_DEFAULT_GEOMETRY_NAME;
 
-  if(name) tag_name = name;
+  if (name)
+    tag_name = name;
 
-  if(namespace)
+  if (namespace)
     msIO_fprintf(stream, "%s<%s:%s>\n", tab, namespace, tag_name);
   else
     msIO_fprintf(stream, "%s<%s>\n", tab, tag_name);
 }
 
 static void gmlEndGeometryContainer(FILE *stream, const char *name,
-                                    const char *namespace, const char *tab)
-{
-  const char *tag_name=OWS_GML_DEFAULT_GEOMETRY_NAME;
+                                    const char *namespace, const char *tab) {
+  const char *tag_name = OWS_GML_DEFAULT_GEOMETRY_NAME;
 
-  if(name) tag_name = name;
+  if (name)
+    tag_name = name;
 
-  if(namespace)
+  if (namespace)
     msIO_fprintf(stream, "%s</%s:%s>\n", tab, namespace, tag_name);
   else
     msIO_fprintf(stream, "%s</%s>\n", tab, tag_name);
@@ -130,677 +138,840 @@ static void gmlEndGeometryContainer(FILE
 static int gmlWriteGeometry_GML2(FILE *stream, gmlGeometryListObj *geometryList,
                                  shapeObj *shape, const char *srsname,
                                  const char *namespace, const char *tab,
-                                 int nSRSDimension, int geometry_precision)
-{
+                                 int nSRSDimension, int geometry_precision) {
   int i, j, k;
-  int *innerlist, *outerlist=NULL, numouters;
+  int *innerlist, *outerlist = NULL, numouters;
   char *srsname_encoded = NULL;
 
   int geometry_aggregate_index, geometry_simple_index;
   char *geometry_aggregate_name = NULL, *geometry_simple_name = NULL;
 
-  if(!stream) return(MS_FAILURE);
-  if(!shape) return(MS_FAILURE);
-  if(!tab) return(MS_FAILURE);
-  if(!geometryList) return(MS_FAILURE);
+  if (!stream)
+    return (MS_FAILURE);
+  if (!shape)
+    return (MS_FAILURE);
+  if (!tab)
+    return (MS_FAILURE);
+  if (!geometryList)
+    return (MS_FAILURE);
 
-  if(shape->numlines <= 0) return(MS_SUCCESS); /* empty shape, nothing to output */
+  if (shape->numlines <= 0)
+    return (MS_SUCCESS); /* empty shape, nothing to output */
 
-  if(srsname)
+  if (srsname)
     srsname_encoded = msEncodeHTMLEntities(srsname);
 
   /* feature geometry */
-  switch(shape->type) {
-    case(MS_SHAPE_POINT):
-      geometry_simple_index = msGMLGeometryLookup(geometryList, "point");
-      geometry_aggregate_index = msGMLGeometryLookup(geometryList, "multipoint");
-      if(geometry_simple_index >= 0) geometry_simple_name = geometryList->geometries[geometry_simple_index].name;
-      if(geometry_aggregate_index >= 0) geometry_aggregate_name = geometryList->geometries[geometry_aggregate_index].name;
-
-      if((geometry_simple_index != -1 && shape->line[0].numpoints == 1 && shape->numlines == 1) ||
-          (geometry_simple_index != -1 && geometry_aggregate_index == -1) ||
-          (geometryList->numgeometries == 0 && shape->line[0].numpoints == 1 && shape->numlines == 1)) { /* write a Point(s) */
-
-        for(i=0; i<shape->numlines; i++) {
-          for(j=0; j<shape->line[i].numpoints; j++) {
-            gmlStartGeometryContainer(stream, geometry_simple_name, namespace, tab);
-
-            /* Point */
-            if(srsname_encoded)
-              msIO_fprintf(stream, "%s<gml:Point srsName=\"%s\">\n", tab, srsname_encoded);
-            else
-              msIO_fprintf(stream, "%s<gml:Point>\n", tab);
+  switch (shape->type) {
+  case (MS_SHAPE_POINT):
+    geometry_simple_index = msGMLGeometryLookup(geometryList, "point");
+    geometry_aggregate_index = msGMLGeometryLookup(geometryList, "multipoint");
+    if (geometry_simple_index >= 0)
+      geometry_simple_name =
+          geometryList->geometries[geometry_simple_index].name;
+    if (geometry_aggregate_index >= 0)
+      geometry_aggregate_name =
+          geometryList->geometries[geometry_aggregate_index].name;
+
+    if ((geometry_simple_index != -1 && shape->line[0].numpoints == 1 &&
+         shape->numlines == 1) ||
+        (geometry_simple_index != -1 && geometry_aggregate_index == -1) ||
+        (geometryList->numgeometries == 0 && shape->line[0].numpoints == 1 &&
+         shape->numlines == 1)) { /* write a Point(s) */
+
+      for (i = 0; i < shape->numlines; i++) {
+        for (j = 0; j < shape->line[i].numpoints; j++) {
+          gmlStartGeometryContainer(stream, geometry_simple_name, namespace,
+                                    tab);
+
+          /* Point */
+          if (srsname_encoded)
+            msIO_fprintf(stream, "%s<gml:Point srsName=\"%s\">\n", tab,
+                         srsname_encoded);
+          else
+            msIO_fprintf(stream, "%s<gml:Point>\n", tab);
 
-            if( nSRSDimension == 3 )
-              msIO_fprintf(stream, "%s  <gml:coordinates>%.*f,%.*f,%.*f</gml:coordinates>\n",
-                           tab, geometry_precision,shape->line[i].point[j].x, geometry_precision,shape->line[i].point[j].y, geometry_precision,shape->line[i].point[j].z);
-            else
-                /* fall-through */
+          if (nSRSDimension == 3)
+            msIO_fprintf(
+                stream,
+                "%s  <gml:coordinates>%.*f,%.*f,%.*f</gml:coordinates>\n", tab,
+                geometry_precision, shape->line[i].point[j].x,
+                geometry_precision, shape->line[i].point[j].y,
+                geometry_precision, shape->line[i].point[j].z);
+          else
+            /* fall-through */
 
-            msIO_fprintf(stream, "%s  <gml:coordinates>%.*f,%.*f</gml:coordinates>\n", tab, geometry_precision,shape->line[i].point[j].x, geometry_precision,shape->line[i].point[j].y);
+            msIO_fprintf(stream,
+                         "%s  <gml:coordinates>%.*f,%.*f</gml:coordinates>\n",
+                         tab, geometry_precision, shape->line[i].point[j].x,
+                         geometry_precision, shape->line[i].point[j].y);
 
-            msIO_fprintf(stream, "%s</gml:Point>\n", tab);
+          msIO_fprintf(stream, "%s</gml:Point>\n", tab);
 
-            gmlEndGeometryContainer(stream, geometry_simple_name, namespace, tab);
-          }
+          gmlEndGeometryContainer(stream, geometry_simple_name, namespace, tab);
         }
-      } else if((geometry_aggregate_index != -1) || (geometryList->numgeometries == 0)) { /* write a MultiPoint */
-        gmlStartGeometryContainer(stream, geometry_aggregate_name, namespace, tab);
-
-        /* MultiPoint */
-        if(srsname_encoded)
-          msIO_fprintf(stream, "%s<gml:MultiPoint srsName=\"%s\">\n", tab, srsname_encoded);
-        else
-          msIO_fprintf(stream, "%s<gml:MultiPoint>\n", tab);
+      }
+    } else if ((geometry_aggregate_index != -1) ||
+               (geometryList->numgeometries == 0)) { /* write a MultiPoint */
+      gmlStartGeometryContainer(stream, geometry_aggregate_name, namespace,
+                                tab);
+
+      /* MultiPoint */
+      if (srsname_encoded)
+        msIO_fprintf(stream, "%s<gml:MultiPoint srsName=\"%s\">\n", tab,
+                     srsname_encoded);
+      else
+        msIO_fprintf(stream, "%s<gml:MultiPoint>\n", tab);
 
-        for(i=0; i<shape->numlines; i++) {
-          for(j=0; j<shape->line[i].numpoints; j++) {
-            msIO_fprintf(stream, "%s  <gml:pointMember>\n", tab);
-            msIO_fprintf(stream, "%s    <gml:Point>\n", tab);
-            if( nSRSDimension == 3 )
-              msIO_fprintf(stream, "%s      <gml:coordinates>%.*f,%.*f,%.*f</gml:coordinates>\n",
-                           tab, geometry_precision, shape->line[i].point[j].x, geometry_precision, shape->line[i].point[j].y,
-                           geometry_precision, shape->line[i].point[j].z);
-            else
-                /* fall-through */
-            msIO_fprintf(stream, "%s      <gml:coordinates>%f,%f</gml:coordinates>\n", tab, shape->line[i].point[j].x, shape->line[i].point[j].y);
-            msIO_fprintf(stream, "%s    </gml:Point>\n", tab);
-            msIO_fprintf(stream, "%s  </gml:pointMember>\n", tab);
-          }
+      for (i = 0; i < shape->numlines; i++) {
+        for (j = 0; j < shape->line[i].numpoints; j++) {
+          msIO_fprintf(stream, "%s  <gml:pointMember>\n", tab);
+          msIO_fprintf(stream, "%s    <gml:Point>\n", tab);
+          if (nSRSDimension == 3)
+            msIO_fprintf(
+                stream,
+                "%s      <gml:coordinates>%.*f,%.*f,%.*f</gml:coordinates>\n",
+                tab, geometry_precision, shape->line[i].point[j].x,
+                geometry_precision, shape->line[i].point[j].y,
+                geometry_precision, shape->line[i].point[j].z);
+          else
+            /* fall-through */
+            msIO_fprintf(
+                stream, "%s      <gml:coordinates>%f,%f</gml:coordinates>\n",
+                tab, shape->line[i].point[j].x, shape->line[i].point[j].y);
+          msIO_fprintf(stream, "%s    </gml:Point>\n", tab);
+          msIO_fprintf(stream, "%s  </gml:pointMember>\n", tab);
         }
+      }
 
-        msIO_fprintf(stream, "%s</gml:MultiPoint>\n", tab);
+      msIO_fprintf(stream, "%s</gml:MultiPoint>\n", tab);
 
-        gmlEndGeometryContainer(stream, geometry_aggregate_name, namespace, tab);
-      } else {
-        msIO_fprintf(stream, "<!-- Warning: Cannot write geometry- no point/multipoint geometry defined. -->\n");
-      }
+      gmlEndGeometryContainer(stream, geometry_aggregate_name, namespace, tab);
+    } else {
+      msIO_fprintf(stream, "<!-- Warning: Cannot write geometry- no "
+                           "point/multipoint geometry defined. -->\n");
+    }
+
+    break;
+  case (MS_SHAPE_LINE):
+    geometry_simple_index = msGMLGeometryLookup(geometryList, "line");
+    geometry_aggregate_index = msGMLGeometryLookup(geometryList, "multiline");
+    if (geometry_simple_index >= 0)
+      geometry_simple_name =
+          geometryList->geometries[geometry_simple_index].name;
+    if (geometry_aggregate_index >= 0)
+      geometry_aggregate_name =
+          geometryList->geometries[geometry_aggregate_index].name;
+
+    if ((geometry_simple_index != -1 && shape->numlines == 1) ||
+        (geometry_simple_index != -1 && geometry_aggregate_index == -1) ||
+        (geometryList->numgeometries == 0 &&
+         shape->numlines == 1)) { /* write a LineStrings(s) */
+      for (i = 0; i < shape->numlines; i++) {
+        gmlStartGeometryContainer(stream, geometry_simple_name, namespace, tab);
+
+        /* LineString */
+        if (srsname_encoded)
+          msIO_fprintf(stream, "%s<gml:LineString srsName=\"%s\">\n", tab,
+                       srsname_encoded);
+        else
+          msIO_fprintf(stream, "%s<gml:LineString>\n", tab);
 
-      break;
-    case(MS_SHAPE_LINE):
-      geometry_simple_index = msGMLGeometryLookup(geometryList, "line");
-      geometry_aggregate_index = msGMLGeometryLookup(geometryList, "multiline");
-      if(geometry_simple_index >= 0) geometry_simple_name = geometryList->geometries[geometry_simple_index].name;
-      if(geometry_aggregate_index >= 0) geometry_aggregate_name = geometryList->geometries[geometry_aggregate_index].name;
-
-      if((geometry_simple_index != -1 && shape->numlines == 1) ||
-          (geometry_simple_index != -1 && geometry_aggregate_index == -1) ||
-          (geometryList->numgeometries == 0 && shape->numlines == 1)) { /* write a LineStrings(s) */
-        for(i=0; i<shape->numlines; i++) {
-          gmlStartGeometryContainer(stream, geometry_simple_name, namespace, tab);
-
-          /* LineString */
-          if(srsname_encoded)
-            msIO_fprintf(stream, "%s<gml:LineString srsName=\"%s\">\n", tab, srsname_encoded);
+        msIO_fprintf(stream, "%s  <gml:coordinates>", tab);
+        for (j = 0; j < shape->line[i].numpoints; j++) {
+          if (nSRSDimension == 3)
+            msIO_fprintf(stream, "%.*f,%.*f,%.*f ", geometry_precision,
+                         shape->line[i].point[j].x, geometry_precision,
+                         shape->line[i].point[j].y, geometry_precision,
+                         shape->line[i].point[j].z);
           else
-            msIO_fprintf(stream, "%s<gml:LineString>\n", tab);
+            /* fall-through */
+            msIO_fprintf(stream, "%.*f,%.*f ", geometry_precision,
+                         shape->line[i].point[j].x, geometry_precision,
+                         shape->line[i].point[j].y);
+        }
+        msIO_fprintf(stream, "</gml:coordinates>\n");
+
+        msIO_fprintf(stream, "%s</gml:LineString>\n", tab);
+
+        gmlEndGeometryContainer(stream, geometry_simple_name, namespace, tab);
+      }
+    } else if (geometry_aggregate_index != -1 ||
+               (geometryList->numgeometries == 0)) { /* write a MultiCurve */
+      gmlStartGeometryContainer(stream, geometry_aggregate_name, namespace,
+                                tab);
+
+      /* MultiLineString */
+      if (srsname_encoded)
+        msIO_fprintf(stream, "%s<gml:MultiLineString srsName=\"%s\">\n", tab,
+                     srsname_encoded);
+      else
+        msIO_fprintf(stream, "%s<gml:MultiLineString>\n", tab);
 
-          msIO_fprintf(stream, "%s  <gml:coordinates>", tab);
-          for(j=0; j<shape->line[i].numpoints; j++)
-          {
-            if( nSRSDimension == 3 )
-              msIO_fprintf(stream, "%.*f,%.*f,%.*f ", geometry_precision,shape->line[i].point[j].x, geometry_precision, shape->line[i].point[j].y,
-                           geometry_precision, shape->line[i].point[j].z);
-            else
-                /* fall-through */
-            msIO_fprintf(stream, "%.*f,%.*f ", geometry_precision, shape->line[i].point[j].x, geometry_precision, shape->line[i].point[j].y);
-          }
-          msIO_fprintf(stream, "</gml:coordinates>\n");
+      for (j = 0; j < shape->numlines; j++) {
+        msIO_fprintf(stream, "%s  <gml:lineStringMember>\n",
+                     tab); /* no srsname at this point */
+        msIO_fprintf(stream, "%s    <gml:LineString>\n",
+                     tab); /* no srsname at this point */
+
+        msIO_fprintf(stream, "%s      <gml:coordinates>", tab);
+        for (i = 0; i < shape->line[j].numpoints; i++) {
+          if (nSRSDimension == 3)
+            msIO_fprintf(stream, "%.*f,%.*f,%.*f ", geometry_precision,
+                         shape->line[j].point[i].x, geometry_precision,
+                         shape->line[j].point[i].y, geometry_precision,
+                         shape->line[j].point[i].z);
+          else
+            /* fall-through */
+            msIO_fprintf(stream, "%.*f,%.*f ", geometry_precision,
+                         shape->line[j].point[i].x, geometry_precision,
+                         shape->line[j].point[i].y);
+        }
+        msIO_fprintf(stream, "</gml:coordinates>\n");
+        msIO_fprintf(stream, "%s    </gml:LineString>\n", tab);
+        msIO_fprintf(stream, "%s  </gml:lineStringMember>\n", tab);
+      }
 
-          msIO_fprintf(stream, "%s</gml:LineString>\n", tab);
+      msIO_fprintf(stream, "%s</gml:MultiLineString>\n", tab);
 
-          gmlEndGeometryContainer(stream, geometry_simple_name, namespace, tab);
-        }
-      } else if(geometry_aggregate_index != -1 || (geometryList->numgeometries == 0)) { /* write a MultiCurve */
-        gmlStartGeometryContainer(stream, geometry_aggregate_name, namespace, tab);
+      gmlEndGeometryContainer(stream, geometry_aggregate_name, namespace, tab);
+    } else {
+      msIO_fprintf(stream, "<!-- Warning: Cannot write geometry- no "
+                           "line/multiline geometry defined. -->\n");
+    }
 
-        /* MultiLineString */
-        if(srsname_encoded)
-          msIO_fprintf(stream, "%s<gml:MultiLineString srsName=\"%s\">\n", tab, srsname_encoded);
+    break;
+  case (
+      MS_SHAPE_POLYGON): /* this gets nasty, since our shapes are so flexible */
+    geometry_simple_index = msGMLGeometryLookup(geometryList, "polygon");
+    geometry_aggregate_index =
+        msGMLGeometryLookup(geometryList, "multipolygon");
+    if (geometry_simple_index >= 0)
+      geometry_simple_name =
+          geometryList->geometries[geometry_simple_index].name;
+    if (geometry_aggregate_index >= 0)
+      geometry_aggregate_name =
+          geometryList->geometries[geometry_aggregate_index].name;
+
+    /* get a list of outter rings for this polygon */
+    outerlist = msGetOuterList(shape);
+
+    numouters = 0;
+    for (i = 0; i < shape->numlines; i++)
+      if (outerlist[i] == MS_TRUE)
+        numouters++;
+
+    if ((geometry_simple_index != -1 && numouters == 1) ||
+        (geometry_simple_index != -1 && geometry_aggregate_index == -1) ||
+        (geometryList->numgeometries == 0 &&
+         shape->numlines == 1)) { /* write a Polygon(s) */
+      for (i = 0; i < shape->numlines; i++) {
+        if (outerlist[i] == MS_FALSE)
+          break; /* skip non-outer rings, each outer ring is a new polygon */
+
+        /* get a list of inner rings for this polygon */
+        innerlist = msGetInnerList(shape, i, outerlist);
+
+        gmlStartGeometryContainer(stream, geometry_simple_name, namespace, tab);
+
+        /* Polygon */
+        if (srsname_encoded)
+          msIO_fprintf(stream, "%s<gml:Polygon srsName=\"%s\">\n", tab,
+                       srsname_encoded);
         else
-          msIO_fprintf(stream, "%s<gml:MultiLineString>\n", tab);
+          msIO_fprintf(stream, "%s<gml:Polygon>\n", tab);
 
-        for(j=0; j<shape->numlines; j++) {
-          msIO_fprintf(stream, "%s  <gml:lineStringMember>\n", tab); /* no srsname at this point */
-          msIO_fprintf(stream, "%s    <gml:LineString>\n", tab); /* no srsname at this point */
-
-          msIO_fprintf(stream, "%s      <gml:coordinates>", tab);
-          for(i=0; i<shape->line[j].numpoints; i++)
-          {
-            if( nSRSDimension == 3 )
-              msIO_fprintf(stream, "%.*f,%.*f,%.*f ", geometry_precision, shape->line[j].point[i].x, geometry_precision, shape->line[j].point[i].y,
-                           geometry_precision, shape->line[j].point[i].z);
-            else
+        msIO_fprintf(stream, "%s  <gml:outerBoundaryIs>\n", tab);
+        msIO_fprintf(stream, "%s    <gml:LinearRing>\n", tab);
+
+        msIO_fprintf(stream, "%s      <gml:coordinates>", tab);
+        for (j = 0; j < shape->line[i].numpoints; j++) {
+          if (nSRSDimension == 3)
+            msIO_fprintf(stream, "%.*f,%.*f,%.*f ", geometry_precision,
+                         shape->line[i].point[j].x, geometry_precision,
+                         shape->line[i].point[j].y, geometry_precision,
+                         shape->line[i].point[j].z);
+          else
+            /* fall-through */
+            msIO_fprintf(stream, "%.*f,%.*f ", geometry_precision,
+                         shape->line[i].point[j].x, geometry_precision,
+                         shape->line[i].point[j].y);
+        }
+        msIO_fprintf(stream, "</gml:coordinates>\n");
+
+        msIO_fprintf(stream, "%s    </gml:LinearRing>\n", tab);
+        msIO_fprintf(stream, "%s  </gml:outerBoundaryIs>\n", tab);
+
+        for (k = 0; k < shape->numlines;
+             k++) { /* now step through all the inner rings */
+          if (innerlist[k] == MS_TRUE) {
+            msIO_fprintf(stream, "%s  <gml:innerBoundaryIs>\n", tab);
+            msIO_fprintf(stream, "%s    <gml:LinearRing>\n", tab);
+
+            msIO_fprintf(stream, "%s      <gml:coordinates>", tab);
+            for (j = 0; j < shape->line[k].numpoints; j++) {
+              if (nSRSDimension == 3)
+                msIO_fprintf(stream, "%.*f,%.*f,%.*f ", geometry_precision,
+                             shape->line[k].point[j].x, geometry_precision,
+                             shape->line[k].point[j].y, geometry_precision,
+                             shape->line[k].point[j].z);
+              else
                 /* fall-through */
-            msIO_fprintf(stream, "%.*f,%.*f ", geometry_precision, shape->line[j].point[i].x, geometry_precision, shape->line[j].point[i].y);
+                msIO_fprintf(stream, "%.*f,%.*f ", geometry_precision,
+                             shape->line[k].point[j].x, geometry_precision,
+                             shape->line[k].point[j].y);
+            }
+            msIO_fprintf(stream, "</gml:coordinates>\n");
+
+            msIO_fprintf(stream, "%s    </gml:LinearRing>\n", tab);
+            msIO_fprintf(stream, "%s  </gml:innerBoundaryIs>\n", tab);
           }
-          msIO_fprintf(stream, "</gml:coordinates>\n");
-          msIO_fprintf(stream, "%s    </gml:LineString>\n", tab);
-          msIO_fprintf(stream, "%s  </gml:lineStringMember>\n", tab);
         }
 
-        msIO_fprintf(stream, "%s</gml:MultiLineString>\n", tab);
+        msIO_fprintf(stream, "%s</gml:Polygon>\n", tab);
+        free(innerlist);
 
-        gmlEndGeometryContainer(stream, geometry_aggregate_name, namespace, tab);
-      } else {
-        msIO_fprintf(stream, "<!-- Warning: Cannot write geometry- no line/multiline geometry defined. -->\n");
+        gmlEndGeometryContainer(stream, geometry_simple_name, namespace, tab);
       }
+      free(outerlist);
+      outerlist = NULL;
+    } else if (geometry_aggregate_index != -1 ||
+               (geometryList->numgeometries == 0)) { /* write a MultiPolygon */
+      gmlStartGeometryContainer(stream, geometry_aggregate_name, namespace,
+                                tab);
+
+      /* MultiPolygon */
+      if (srsname_encoded)
+        msIO_fprintf(stream, "%s<gml:MultiPolygon srsName=\"%s\">\n", tab,
+                     srsname_encoded);
+      else
+        msIO_fprintf(stream, "%s<gml:MultiPolygon>\n", tab);
 
-      break;
-    case(MS_SHAPE_POLYGON): /* this gets nasty, since our shapes are so flexible */
-      geometry_simple_index = msGMLGeometryLookup(geometryList, "polygon");
-      geometry_aggregate_index = msGMLGeometryLookup(geometryList, "multipolygon");
-      if(geometry_simple_index >= 0) geometry_simple_name = geometryList->geometries[geometry_simple_index].name;
-      if(geometry_aggregate_index >= 0) geometry_aggregate_name = geometryList->geometries[geometry_aggregate_index].name;
-
-      /* get a list of outter rings for this polygon */
-      outerlist = msGetOuterList(shape);
-
-      numouters = 0;
-      for(i=0; i<shape->numlines; i++)
-        if(outerlist[i] == MS_TRUE) numouters++;
-
-      if((geometry_simple_index != -1 && numouters == 1) ||
-          (geometry_simple_index != -1 && geometry_aggregate_index == -1) ||
-          (geometryList->numgeometries == 0 && shape->numlines == 1)) { /* write a Polygon(s) */
-        for(i=0; i<shape->numlines; i++) {
-          if(outerlist[i] == MS_FALSE) break; /* skip non-outer rings, each outer ring is a new polygon */
-
-          /* get a list of inner rings for this polygon */
+      for (i = 0; i < shape->numlines; i++) { /* step through the outer rings */
+        if (outerlist[i] == MS_TRUE) {
           innerlist = msGetInnerList(shape, i, outerlist);
 
-          gmlStartGeometryContainer(stream, geometry_simple_name, namespace, tab);
-
-          /* Polygon */
-          if(srsname_encoded)
-            msIO_fprintf(stream, "%s<gml:Polygon srsName=\"%s\">\n", tab, srsname_encoded);
-          else
-            msIO_fprintf(stream, "%s<gml:Polygon>\n", tab);
+          msIO_fprintf(stream, "%s<gml:polygonMember>\n", tab);
+          msIO_fprintf(stream, "%s  <gml:Polygon>\n", tab);
 
-          msIO_fprintf(stream, "%s  <gml:outerBoundaryIs>\n", tab);
-          msIO_fprintf(stream, "%s    <gml:LinearRing>\n", tab);
+          msIO_fprintf(stream, "%s    <gml:outerBoundaryIs>\n", tab);
+          msIO_fprintf(stream, "%s      <gml:LinearRing>\n", tab);
 
-          msIO_fprintf(stream, "%s      <gml:coordinates>", tab);
-          for(j=0; j<shape->line[i].numpoints; j++)
-          {
-            if( nSRSDimension == 3 )
-              msIO_fprintf(stream, "%.*f,%.*f,%.*f ", geometry_precision, shape->line[i].point[j].x, geometry_precision, shape->line[i].point[j].y,
-                           geometry_precision, shape->line[i].point[j].z);
+          msIO_fprintf(stream, "%s        <gml:coordinates>", tab);
+          for (j = 0; j < shape->line[i].numpoints; j++) {
+            if (nSRSDimension == 3)
+              msIO_fprintf(stream, "%.*f,%.*f,%.*f ", geometry_precision,
+                           shape->line[i].point[j].x, geometry_precision,
+                           shape->line[i].point[j].y, geometry_precision,
+                           shape->line[i].point[j].z);
             else
-                /* fall-through */
-            msIO_fprintf(stream, "%.*f,%.*f ", geometry_precision, shape->line[i].point[j].x, geometry_precision, shape->line[i].point[j].y);
+              /* fall-through */
+              msIO_fprintf(stream, "%.*f,%.*f ", geometry_precision,
+                           shape->line[i].point[j].x, geometry_precision,
+                           shape->line[i].point[j].y);
           }
           msIO_fprintf(stream, "</gml:coordinates>\n");
 
-          msIO_fprintf(stream, "%s    </gml:LinearRing>\n", tab);
-          msIO_fprintf(stream, "%s  </gml:outerBoundaryIs>\n", tab);
+          msIO_fprintf(stream, "%s      </gml:LinearRing>\n", tab);
+          msIO_fprintf(stream, "%s    </gml:outerBoundaryIs>\n", tab);
+
+          for (k = 0; k < shape->numlines;
+               k++) { /* now step through all the inner rings */
+            if (innerlist[k] == MS_TRUE) {
+              msIO_fprintf(stream, "%s    <gml:innerBoundaryIs>\n", tab);
+              msIO_fprintf(stream, "%s      <gml:LinearRing>\n", tab);
 
-          for(k=0; k<shape->numlines; k++) { /* now step through all the inner rings */
-            if(innerlist[k] == MS_TRUE) {
-              msIO_fprintf(stream, "%s  <gml:innerBoundaryIs>\n", tab);
-              msIO_fprintf(stream, "%s    <gml:LinearRing>\n", tab);
-
-              msIO_fprintf(stream, "%s      <gml:coordinates>", tab);
-              for(j=0; j<shape->line[k].numpoints; j++)
-              {
-                if( nSRSDimension == 3 )
-                  msIO_fprintf(stream, "%.*f,%.*f,%.*f ", geometry_precision,shape->line[k].point[j].x, geometry_precision,shape->line[k].point[j].y,
-                           geometry_precision,shape->line[k].point[j].z);
+              msIO_fprintf(stream, "%s        <gml:coordinates>", tab);
+              for (j = 0; j < shape->line[k].numpoints; j++) {
+                if (nSRSDimension == 3)
+                  msIO_fprintf(stream, "%.*f,%.*f,%.*f ", geometry_precision,
+                               shape->line[k].point[j].x, geometry_precision,
+                               shape->line[k].point[j].y, geometry_precision,
+                               shape->line[k].point[j].z);
                 else
                   /* fall-through */
-                msIO_fprintf(stream, "%.*f,%.*f ",geometry_precision, shape->line[k].point[j].x, geometry_precision,shape->line[k].point[j].y);
+                  msIO_fprintf(stream, "%.*f,%.*f ", geometry_precision,
+                               shape->line[k].point[j].x, geometry_precision,
+                               shape->line[k].point[j].y);
               }
               msIO_fprintf(stream, "</gml:coordinates>\n");
 
-              msIO_fprintf(stream, "%s    </gml:LinearRing>\n", tab);
-              msIO_fprintf(stream, "%s  </gml:innerBoundaryIs>\n", tab);
+              msIO_fprintf(stream, "%s      </gml:LinearRing>\n", tab);
+              msIO_fprintf(stream, "%s    </gml:innerBoundaryIs>\n", tab);
             }
           }
 
-          msIO_fprintf(stream, "%s</gml:Polygon>\n", tab);
-          free(innerlist);
-
-          gmlEndGeometryContainer(stream, geometry_simple_name, namespace, tab);
-        }
-        free(outerlist);
-        outerlist = NULL;
-      } else if(geometry_aggregate_index != -1 || (geometryList->numgeometries == 0)) { /* write a MultiPolygon */
-        gmlStartGeometryContainer(stream, geometry_aggregate_name, namespace, tab);
-
-        /* MultiPolygon */
-        if(srsname_encoded)
-          msIO_fprintf(stream, "%s<gml:MultiPolygon srsName=\"%s\">\n", tab, srsname_encoded);
-        else
-          msIO_fprintf(stream, "%s<gml:MultiPolygon>\n", tab);
-
-        for(i=0; i<shape->numlines; i++) { /* step through the outer rings */
-          if(outerlist[i] == MS_TRUE) {
-            innerlist = msGetInnerList(shape, i, outerlist);
-
-            msIO_fprintf(stream, "%s<gml:polygonMember>\n", tab);
-            msIO_fprintf(stream, "%s  <gml:Polygon>\n", tab);
-
-            msIO_fprintf(stream, "%s    <gml:outerBoundaryIs>\n", tab);
-            msIO_fprintf(stream, "%s      <gml:LinearRing>\n", tab);
-
-            msIO_fprintf(stream, "%s        <gml:coordinates>", tab);
-            for(j=0; j<shape->line[i].numpoints; j++)
-            {
-              if( nSRSDimension == 3 )
-                msIO_fprintf(stream, "%.*f,%.*f,%.*f ", geometry_precision, shape->line[i].point[j].x, geometry_precision, shape->line[i].point[j].y,
-                             geometry_precision, shape->line[i].point[j].z);
-              else
-                /* fall-through */
-              msIO_fprintf(stream, "%.*f,%.*f ", geometry_precision, shape->line[i].point[j].x, geometry_precision, shape->line[i].point[j].y);
-            }
-            msIO_fprintf(stream, "</gml:coordinates>\n");
-
-            msIO_fprintf(stream, "%s      </gml:LinearRing>\n", tab);
-            msIO_fprintf(stream, "%s    </gml:outerBoundaryIs>\n", tab);
-
-            for(k=0; k<shape->numlines; k++) { /* now step through all the inner rings */
-              if(innerlist[k] == MS_TRUE) {
-                msIO_fprintf(stream, "%s    <gml:innerBoundaryIs>\n", tab);
-                msIO_fprintf(stream, "%s      <gml:LinearRing>\n", tab);
-
-                msIO_fprintf(stream, "%s        <gml:coordinates>", tab);
-                for(j=0; j<shape->line[k].numpoints; j++)
-                {
-                  if( nSRSDimension == 3 )
-                    msIO_fprintf(stream, "%.*f,%.*f,%.*f ", geometry_precision,shape->line[k].point[j].x, geometry_precision,shape->line[k].point[j].y,
-                                geometry_precision,shape->line[k].point[j].z);
-                  else
-                    /* fall-through */
-                  msIO_fprintf(stream, "%.*f,%.*f ", geometry_precision,shape->line[k].point[j].x, geometry_precision,shape->line[k].point[j].y);
-                }
-                msIO_fprintf(stream, "</gml:coordinates>\n");
-
-                msIO_fprintf(stream, "%s      </gml:LinearRing>\n", tab);
-                msIO_fprintf(stream, "%s    </gml:innerBoundaryIs>\n", tab);
-              }
-            }
-
-            msIO_fprintf(stream, "%s  </gml:Polygon>\n", tab);
-            msIO_fprintf(stream, "%s</gml:polygonMember>\n", tab);
+          msIO_fprintf(stream, "%s  </gml:Polygon>\n", tab);
+          msIO_fprintf(stream, "%s</gml:polygonMember>\n", tab);
 
-            free(innerlist);
-          }
+          free(innerlist);
         }
-        msIO_fprintf(stream, "%s</gml:MultiPolygon>\n", tab);
+      }
+      msIO_fprintf(stream, "%s</gml:MultiPolygon>\n", tab);
 
-        free(outerlist);
-        outerlist = NULL;
+      free(outerlist);
+      outerlist = NULL;
 
-        gmlEndGeometryContainer(stream, geometry_aggregate_name, namespace, tab);
-      } else {
-        msIO_fprintf(stream, "<!-- Warning: Cannot write geometry- no polygon/multipolygon geometry defined. -->\n");
-      }
+      gmlEndGeometryContainer(stream, geometry_aggregate_name, namespace, tab);
+    } else {
+      msIO_fprintf(stream, "<!-- Warning: Cannot write geometry- no "
+                           "polygon/multipolygon geometry defined. -->\n");
+    }
 
-      break;
-    default:
-      break;
+    break;
+  default:
+    break;
   }
 
   /* clean-up */
   msFree(srsname_encoded);
   msFree(outerlist);
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
-static char* gmlCreateGeomId(OWSGMLVersion nGMLVersion, const char* pszFID, int* p_id)
-{
-    char* pszGMLId;
-    if( nGMLVersion == OWS_GML32 )
-    {
-        pszGMLId = (char*) msSmallMalloc( strlen(pszFID) + 1 + strlen(" gml:id=\"\"") + 10 );
-        sprintf(pszGMLId, " gml:id=\"%s.%d\"", pszFID, *p_id);
-        (*p_id) ++;
-    }
-    else
-        pszGMLId = msStrdup("");
-    return pszGMLId;
+static char *gmlCreateGeomId(OWSGMLVersion nGMLVersion, const char *pszFID,
+                             int *p_id) {
+  char *pszGMLId;
+  if (nGMLVersion == OWS_GML32) {
+    pszGMLId =
+        (char *)msSmallMalloc(strlen(pszFID) + 1 + strlen(" gml:id=\"\"") + 10);
+    sprintf(pszGMLId, " gml:id=\"%s.%d\"", pszFID, *p_id);
+    (*p_id)++;
+  } else
+    pszGMLId = msStrdup("");
+  return pszGMLId;
 }
 
 /* GML 3.1 or GML 3.2 (MapServer limits GML encoding to the level 0 profile) */
-static int gmlWriteGeometry_GML3(FILE *stream, gmlGeometryListObj *geometryList, shapeObj *shape,
-                                 const char *srsname, const char *namespace, const char *tab,
+static int gmlWriteGeometry_GML3(FILE *stream, gmlGeometryListObj *geometryList,
+                                 shapeObj *shape, const char *srsname,
+                                 const char *namespace, const char *tab,
                                  const char *pszFID, OWSGMLVersion nGMLVersion,
-                                 int nSRSDimension, int geometry_precision)
-{
+                                 int nSRSDimension, int geometry_precision) {
   int i, j, k, id = 1;
-  int *innerlist, *outerlist=NULL, numouters;
+  int *innerlist, *outerlist = NULL, numouters;
   char *srsname_encoded = NULL;
-  char* pszGMLId;
+  char *pszGMLId;
 
   int geometry_aggregate_index, geometry_simple_index;
   char *geometry_aggregate_name = NULL, *geometry_simple_name = NULL;
 
-  if(!stream) return(MS_FAILURE);
-  if(!shape) return(MS_FAILURE);
-  if(!tab) return(MS_FAILURE);
-  if(!geometryList) return(MS_FAILURE);
+  if (!stream)
+    return (MS_FAILURE);
+  if (!shape)
+    return (MS_FAILURE);
+  if (!tab)
+    return (MS_FAILURE);
+  if (!geometryList)
+    return (MS_FAILURE);
 
-  if(shape->numlines <= 0) return(MS_SUCCESS); /* empty shape, nothing to output */
+  if (shape->numlines <= 0)
+    return (MS_SUCCESS); /* empty shape, nothing to output */
 
-  if(srsname)
+  if (srsname)
     srsname_encoded = msEncodeHTMLEntities(srsname);
 
   /* feature geometry */
-  switch(shape->type) {
-    case(MS_SHAPE_POINT):
-      geometry_simple_index = msGMLGeometryLookup(geometryList, "point");
-      geometry_aggregate_index = msGMLGeometryLookup(geometryList, "multipoint");
-      if(geometry_simple_index >= 0) geometry_simple_name = geometryList->geometries[geometry_simple_index].name;
-      if(geometry_aggregate_index >= 0) geometry_aggregate_name = geometryList->geometries[geometry_aggregate_index].name;
-
-      if((geometry_simple_index != -1 && shape->line[0].numpoints == 1 && shape->numlines == 1) ||
-          (geometry_simple_index != -1 && geometry_aggregate_index == -1) ||
-          (geometryList->numgeometries == 0 && shape->line[0].numpoints == 1 && shape->numlines == 1)) { /* write a Point(s) */
-
-        for(i=0; i<shape->numlines; i++) {
-          for(j=0; j<shape->line[i].numpoints; j++) {
-            gmlStartGeometryContainer(stream, geometry_simple_name, namespace, tab);
-
-            /* Point */
-            pszGMLId = gmlCreateGeomId(nGMLVersion, pszFID, &id);
-            if(srsname_encoded)
-              msIO_fprintf(stream, "%s  <gml:Point%s srsName=\"%s\">\n", tab, pszGMLId, srsname_encoded);
-            else
-              msIO_fprintf(stream, "%s  <gml:Point%s>\n", tab, pszGMLId);
+  switch (shape->type) {
+  case (MS_SHAPE_POINT):
+    geometry_simple_index = msGMLGeometryLookup(geometryList, "point");
+    geometry_aggregate_index = msGMLGeometryLookup(geometryList, "multipoint");
+    if (geometry_simple_index >= 0)
+      geometry_simple_name =
+          geometryList->geometries[geometry_simple_index].name;
+    if (geometry_aggregate_index >= 0)
+      geometry_aggregate_name =
+          geometryList->geometries[geometry_aggregate_index].name;
+
+    if ((geometry_simple_index != -1 && shape->line[0].numpoints == 1 &&
+         shape->numlines == 1) ||
+        (geometry_simple_index != -1 && geometry_aggregate_index == -1) ||
+        (geometryList->numgeometries == 0 && shape->line[0].numpoints == 1 &&
+         shape->numlines == 1)) { /* write a Point(s) */
+
+      for (i = 0; i < shape->numlines; i++) {
+        for (j = 0; j < shape->line[i].numpoints; j++) {
+          gmlStartGeometryContainer(stream, geometry_simple_name, namespace,
+                                    tab);
 
-            if( nSRSDimension == 3 )
-              msIO_fprintf(stream, "%s    <gml:pos srsDimension=\"3\">%.*f %.*f %.*f</gml:pos>\n", tab, geometry_precision, shape->line[i].point[j].x, geometry_precision, shape->line[i].point[j].y, geometry_precision, shape->line[i].point[j].z);
-            else
-                /* fall-through */
-            msIO_fprintf(stream, "%s    <gml:pos>%.*f %.*f</gml:pos>\n", tab, geometry_precision, shape->line[i].point[j].x, geometry_precision, shape->line[i].point[j].y);
+          /* Point */
+          pszGMLId = gmlCreateGeomId(nGMLVersion, pszFID, &id);
+          if (srsname_encoded)
+            msIO_fprintf(stream, "%s  <gml:Point%s srsName=\"%s\">\n", tab,
+                         pszGMLId, srsname_encoded);
+          else
+            msIO_fprintf(stream, "%s  <gml:Point%s>\n", tab, pszGMLId);
 
-            msIO_fprintf(stream, "%s  </gml:Point>\n", tab);
+          if (nSRSDimension == 3)
+            msIO_fprintf(
+                stream,
+                "%s    <gml:pos srsDimension=\"3\">%.*f %.*f %.*f</gml:pos>\n",
+                tab, geometry_precision, shape->line[i].point[j].x,
+                geometry_precision, shape->line[i].point[j].y,
+                geometry_precision, shape->line[i].point[j].z);
+          else
+            /* fall-through */
+            msIO_fprintf(stream, "%s    <gml:pos>%.*f %.*f</gml:pos>\n", tab,
+                         geometry_precision, shape->line[i].point[j].x,
+                         geometry_precision, shape->line[i].point[j].y);
 
-            gmlEndGeometryContainer(stream, geometry_simple_name, namespace, tab);
-            msFree(pszGMLId);
-          }
+          msIO_fprintf(stream, "%s  </gml:Point>\n", tab);
+
+          gmlEndGeometryContainer(stream, geometry_simple_name, namespace, tab);
+          msFree(pszGMLId);
         }
-      } else if((geometry_aggregate_index != -1) || (geometryList->numgeometries == 0)) { /* write a MultiPoint */
-        pszGMLId = gmlCreateGeomId(nGMLVersion, pszFID, &id);
-        gmlStartGeometryContainer(stream, geometry_aggregate_name, namespace, tab);
+      }
+    } else if ((geometry_aggregate_index != -1) ||
+               (geometryList->numgeometries == 0)) { /* write a MultiPoint */
+      pszGMLId = gmlCreateGeomId(nGMLVersion, pszFID, &id);
+      gmlStartGeometryContainer(stream, geometry_aggregate_name, namespace,
+                                tab);
+
+      /* MultiPoint */
+      if (srsname_encoded)
+        msIO_fprintf(stream, "%s  <gml:MultiPoint%s srsName=\"%s\">\n", tab,
+                     pszGMLId, srsname_encoded);
+      else
+        msIO_fprintf(stream, "%s  <gml:MultiPoint%s>\n", tab, pszGMLId);
+
+      msFree(pszGMLId);
+
+      for (i = 0; i < shape->numlines; i++) {
+        for (j = 0; j < shape->line[i].numpoints; j++) {
+          msIO_fprintf(stream, "%s    <gml:pointMember>\n", tab);
+          pszGMLId = gmlCreateGeomId(nGMLVersion, pszFID, &id);
+          msIO_fprintf(stream, "%s      <gml:Point%s>\n", tab, pszGMLId);
+          if (nSRSDimension == 3)
+            msIO_fprintf(stream,
+                         "%s        <gml:pos srsDimension=\"3\">%.*f %.*f "
+                         "%.*f</gml:pos>\n",
+                         tab, geometry_precision, shape->line[i].point[j].x,
+                         geometry_precision, shape->line[i].point[j].y,
+                         geometry_precision, shape->line[i].point[j].z);
+          else
+            /* fall-through */
+            msIO_fprintf(stream, "%s        <gml:pos>%.*f %.*f</gml:pos>\n",
+                         tab, geometry_precision, shape->line[i].point[j].x,
+                         geometry_precision, shape->line[i].point[j].y);
+          msIO_fprintf(stream, "%s      </gml:Point>\n", tab);
+          msFree(pszGMLId);
+          msIO_fprintf(stream, "%s    </gml:pointMember>\n", tab);
+        }
+      }
+
+      msIO_fprintf(stream, "%s  </gml:MultiPoint>\n", tab);
+
+      gmlEndGeometryContainer(stream, geometry_aggregate_name, namespace, tab);
+    } else {
+      msIO_fprintf(stream, "<!-- Warning: Cannot write geometry- no "
+                           "point/multipoint geometry defined. -->\n");
+    }
+
+    break;
+  case (MS_SHAPE_LINE):
+    geometry_simple_index = msGMLGeometryLookup(geometryList, "line");
+    geometry_aggregate_index = msGMLGeometryLookup(geometryList, "multiline");
+    if (geometry_simple_index >= 0)
+      geometry_simple_name =
+          geometryList->geometries[geometry_simple_index].name;
+    if (geometry_aggregate_index >= 0)
+      geometry_aggregate_name =
+          geometryList->geometries[geometry_aggregate_index].name;
+
+    if ((geometry_simple_index != -1 && shape->numlines == 1) ||
+        (geometry_simple_index != -1 && geometry_aggregate_index == -1) ||
+        (geometryList->numgeometries == 0 &&
+         shape->numlines == 1)) { /* write a LineStrings(s) */
+      for (i = 0; i < shape->numlines; i++) {
+        gmlStartGeometryContainer(stream, geometry_simple_name, namespace, tab);
 
-        /* MultiPoint */
-        if(srsname_encoded)
-          msIO_fprintf(stream, "%s  <gml:MultiPoint%s srsName=\"%s\">\n", tab, pszGMLId, srsname_encoded);
+        /* LineString (should be Curve?) */
+        pszGMLId = gmlCreateGeomId(nGMLVersion, pszFID, &id);
+        if (srsname_encoded)
+          msIO_fprintf(stream, "%s  <gml:LineString%s srsName=\"%s\">\n", tab,
+                       pszGMLId, srsname_encoded);
         else
-          msIO_fprintf(stream, "%s  <gml:MultiPoint%s>\n", tab, pszGMLId);
+          msIO_fprintf(stream, "%s  <gml:LineString%s>\n", tab, pszGMLId);
+        msFree(pszGMLId);
+
+        msIO_fprintf(stream, "%s    <gml:posList srsDimension=\"%d\">", tab,
+                     nSRSDimension);
+        for (j = 0; j < shape->line[i].numpoints; j++) {
+          if (nSRSDimension == 3)
+            msIO_fprintf(stream, "%.*f %.*f %.*f ", geometry_precision,
+                         shape->line[i].point[j].x, geometry_precision,
+                         shape->line[i].point[j].y, geometry_precision,
+                         shape->line[i].point[j].z);
+          else
+            /* fall-through */
+            msIO_fprintf(stream, "%.*f %.*f ", geometry_precision,
+                         shape->line[i].point[j].x, geometry_precision,
+                         shape->line[i].point[j].y);
+        }
+        msIO_fprintf(stream, "</gml:posList>\n");
+
+        msIO_fprintf(stream, "%s  </gml:LineString>\n", tab);
+
+        gmlEndGeometryContainer(stream, geometry_simple_name, namespace, tab);
+      }
+    } else if (geometry_aggregate_index != -1 ||
+               (geometryList->numgeometries == 0)) { /* write a MultiCurve */
+      gmlStartGeometryContainer(stream, geometry_aggregate_name, namespace,
+                                tab);
+
+      /* MultiCurve */
+      pszGMLId = gmlCreateGeomId(nGMLVersion, pszFID, &id);
+      if (srsname_encoded)
+        msIO_fprintf(stream, "%s  <gml:MultiCurve%s srsName=\"%s\">\n", tab,
+                     pszGMLId, srsname_encoded);
+      else
+        msIO_fprintf(stream, "%s  <gml:MultiCurve%s>\n", tab, pszGMLId);
+      msFree(pszGMLId);
 
+      for (i = 0; i < shape->numlines; i++) {
+        msIO_fprintf(stream, "%s    <gml:curveMember>\n", tab);
+        pszGMLId = gmlCreateGeomId(nGMLVersion, pszFID, &id);
+        msIO_fprintf(stream, "%s      <gml:LineString%s>\n", tab,
+                     pszGMLId); /* no srsname at this point */
         msFree(pszGMLId);
 
-        for(i=0; i<shape->numlines; i++) {
-          for(j=0; j<shape->line[i].numpoints; j++) {
-            msIO_fprintf(stream, "%s    <gml:pointMember>\n", tab);
-            pszGMLId = gmlCreateGeomId(nGMLVersion, pszFID, &id);
-            msIO_fprintf(stream, "%s      <gml:Point%s>\n", tab, pszGMLId);
-            if( nSRSDimension == 3 )
-              msIO_fprintf(stream, "%s        <gml:pos srsDimension=\"3\">%.*f %.*f %.*f</gml:pos>\n", tab, geometry_precision, shape->line[i].point[j].x, geometry_precision, shape->line[i].point[j].y, geometry_precision, shape->line[i].point[j].z);
-            else
-                /* fall-through */
-            msIO_fprintf(stream, "%s        <gml:pos>%.*f %.*f</gml:pos>\n", tab, geometry_precision, shape->line[i].point[j].x, geometry_precision, shape->line[i].point[j].y);
-            msIO_fprintf(stream, "%s      </gml:Point>\n", tab);
-            msFree(pszGMLId);
-            msIO_fprintf(stream, "%s    </gml:pointMember>\n", tab);
-          }
+        msIO_fprintf(stream, "%s        <gml:posList srsDimension=\"%d\">", tab,
+                     nSRSDimension);
+        for (j = 0; j < shape->line[i].numpoints; j++) {
+          if (nSRSDimension == 3)
+            msIO_fprintf(stream, "%.*f %.*f %.*f ", geometry_precision,
+                         shape->line[i].point[j].x, geometry_precision,
+                         shape->line[i].point[j].y, geometry_precision,
+                         shape->line[i].point[j].z);
+          else
+            /* fall-through */
+            msIO_fprintf(stream, "%.*f %.*f ", geometry_precision,
+                         shape->line[i].point[j].x, geometry_precision,
+                         shape->line[i].point[j].y);
         }
 
-        msIO_fprintf(stream, "%s  </gml:MultiPoint>\n", tab);
-
-        gmlEndGeometryContainer(stream, geometry_aggregate_name, namespace, tab);
-      } else {
-        msIO_fprintf(stream, "<!-- Warning: Cannot write geometry- no point/multipoint geometry defined. -->\n");
+        msIO_fprintf(stream, "</gml:posList>\n");
+        msIO_fprintf(stream, "%s      </gml:LineString>\n", tab);
+        msIO_fprintf(stream, "%s    </gml:curveMember>\n", tab);
       }
 
-      break;
-    case(MS_SHAPE_LINE):
-      geometry_simple_index = msGMLGeometryLookup(geometryList, "line");
-      geometry_aggregate_index = msGMLGeometryLookup(geometryList, "multiline");
-      if(geometry_simple_index >= 0) geometry_simple_name = geometryList->geometries[geometry_simple_index].name;
-      if(geometry_aggregate_index >= 0) geometry_aggregate_name = geometryList->geometries[geometry_aggregate_index].name;
-
-      if((geometry_simple_index != -1 && shape->numlines == 1) ||
-          (geometry_simple_index != -1 && geometry_aggregate_index == -1) ||
-          (geometryList->numgeometries == 0 && shape->numlines == 1)) { /* write a LineStrings(s) */
-        for(i=0; i<shape->numlines; i++) {
-          gmlStartGeometryContainer(stream, geometry_simple_name, namespace, tab);
+      msIO_fprintf(stream, "%s  </gml:MultiCurve>\n", tab);
 
-          /* LineString (should be Curve?) */
-          pszGMLId = gmlCreateGeomId(nGMLVersion, pszFID, &id);
-          if(srsname_encoded)
-            msIO_fprintf(stream, "%s  <gml:LineString%s srsName=\"%s\">\n", tab, pszGMLId, srsname_encoded);
-          else
-            msIO_fprintf(stream, "%s  <gml:LineString%s>\n", tab, pszGMLId);
-          msFree(pszGMLId);
+      gmlEndGeometryContainer(stream, geometry_aggregate_name, namespace, tab);
+    } else {
+      msIO_fprintf(stream, "<!-- Warning: Cannot write geometry- no "
+                           "line/multiline geometry defined. -->\n");
+    }
 
-          msIO_fprintf(stream, "%s    <gml:posList srsDimension=\"%d\">", tab, nSRSDimension);
-          for(j=0; j<shape->line[i].numpoints; j++)
-          {
-            if( nSRSDimension == 3 )
-              msIO_fprintf(stream, "%.*f %.*f %.*f ", geometry_precision, shape->line[i].point[j].x, geometry_precision, shape->line[i].point[j].y, geometry_precision, shape->line[i].point[j].z);
-            else
-                /* fall-through */
-              msIO_fprintf(stream, "%.*f %.*f ", geometry_precision, shape->line[i].point[j].x, geometry_precision, shape->line[i].point[j].y);
-          }
-          msIO_fprintf(stream, "</gml:posList>\n");
+    break;
+  case (
+      MS_SHAPE_POLYGON): /* this gets nasty, since our shapes are so flexible */
+    geometry_simple_index = msGMLGeometryLookup(geometryList, "polygon");
+    geometry_aggregate_index =
+        msGMLGeometryLookup(geometryList, "multipolygon");
+    if (geometry_simple_index >= 0)
+      geometry_simple_name =
+          geometryList->geometries[geometry_simple_index].name;
+    if (geometry_aggregate_index >= 0)
+      geometry_aggregate_name =
+          geometryList->geometries[geometry_aggregate_index].name;
+
+    /* get a list of outter rings for this polygon */
+    outerlist = msGetOuterList(shape);
+
+    numouters = 0;
+    for (i = 0; i < shape->numlines; i++)
+      if (outerlist[i] == MS_TRUE)
+        numouters++;
+
+    if ((geometry_simple_index != -1 && numouters == 1) ||
+        (geometry_simple_index != -1 && geometry_aggregate_index == -1) ||
+        (geometryList->numgeometries == 0 &&
+         shape->numlines == 1)) { /* write a Polygon(s) */
+      for (i = 0; i < shape->numlines; i++) {
+        if (outerlist[i] == MS_FALSE)
+          break; /* skip non-outer rings, each outer ring is a new polygon */
 
-          msIO_fprintf(stream, "%s  </gml:LineString>\n", tab);
+        /* get a list of inner rings for this polygon */
+        innerlist = msGetInnerList(shape, i, outerlist);
 
-          gmlEndGeometryContainer(stream, geometry_simple_name, namespace, tab);
-        }
-      } else if(geometry_aggregate_index != -1 || (geometryList->numgeometries == 0)) { /* write a MultiCurve */
-        gmlStartGeometryContainer(stream, geometry_aggregate_name, namespace, tab);
+        gmlStartGeometryContainer(stream, geometry_simple_name, namespace, tab);
 
-        /* MultiCurve */
         pszGMLId = gmlCreateGeomId(nGMLVersion, pszFID, &id);
-        if(srsname_encoded)
-          msIO_fprintf(stream, "%s  <gml:MultiCurve%s srsName=\"%s\">\n", tab, pszGMLId, srsname_encoded);
+
+        /* Polygon (should be Surface?) */
+        if (srsname_encoded)
+          msIO_fprintf(stream, "%s  <gml:Polygon%s srsName=\"%s\">\n", tab,
+                       pszGMLId, srsname_encoded);
         else
-          msIO_fprintf(stream, "%s  <gml:MultiCurve%s>\n", tab, pszGMLId);
+          msIO_fprintf(stream, "%s  <gml:Polygon%s>\n", tab, pszGMLId);
         msFree(pszGMLId);
 
-        for(i=0; i<shape->numlines; i++) {
-          msIO_fprintf(stream, "%s    <gml:curveMember>\n", tab);
-          pszGMLId = gmlCreateGeomId(nGMLVersion, pszFID, &id);
-          msIO_fprintf(stream, "%s      <gml:LineString%s>\n", tab, pszGMLId); /* no srsname at this point */
-          msFree(pszGMLId);
+        msIO_fprintf(stream, "%s    <gml:exterior>\n", tab);
+        msIO_fprintf(stream, "%s      <gml:LinearRing>\n", tab);
 
-          msIO_fprintf(stream, "%s        <gml:posList srsDimension=\"%d\">", tab, nSRSDimension);
-          for(j=0; j<shape->line[i].numpoints; j++)
-          {
-            if( nSRSDimension == 3 )
-              msIO_fprintf(stream, "%.*f %.*f %.*f ", geometry_precision, shape->line[i].point[j].x, geometry_precision, shape->line[i].point[j].y, geometry_precision, shape->line[i].point[j].z);
-            else
+        msIO_fprintf(stream, "%s        <gml:posList srsDimension=\"%d\">", tab,
+                     nSRSDimension);
+        for (j = 0; j < shape->line[i].numpoints; j++) {
+          if (nSRSDimension == 3)
+            msIO_fprintf(stream, "%.*f %.*f %.*f ", geometry_precision,
+                         shape->line[i].point[j].x, geometry_precision,
+                         shape->line[i].point[j].y, geometry_precision,
+                         shape->line[i].point[j].z);
+          else
+            /* fall-through */
+            msIO_fprintf(stream, "%.*f %.*f ", geometry_precision,
+                         shape->line[i].point[j].x, geometry_precision,
+                         shape->line[i].point[j].y);
+        }
+
+        msIO_fprintf(stream, "</gml:posList>\n");
+
+        msIO_fprintf(stream, "%s      </gml:LinearRing>\n", tab);
+        msIO_fprintf(stream, "%s    </gml:exterior>\n", tab);
+
+        for (k = 0; k < shape->numlines;
+             k++) { /* now step through all the inner rings */
+          if (innerlist[k] == MS_TRUE) {
+            msIO_fprintf(stream, "%s    <gml:interior>\n", tab);
+            msIO_fprintf(stream, "%s      <gml:LinearRing>\n", tab);
+
+            msIO_fprintf(stream, "%s        <gml:posList srsDimension=\"%d\">",
+                         tab, nSRSDimension);
+            for (j = 0; j < shape->line[k].numpoints; j++) {
+              if (nSRSDimension == 3)
+                msIO_fprintf(stream, "%.*f %.*f %.*f ", geometry_precision,
+                             shape->line[k].point[j].x, geometry_precision,
+                             shape->line[k].point[j].y, geometry_precision,
+                             shape->line[k].point[j].z);
+              else
                 /* fall-through */
-              msIO_fprintf(stream, "%.*f %.*f ", geometry_precision, shape->line[i].point[j].x, geometry_precision, shape->line[i].point[j].y);
-          }
+                msIO_fprintf(stream, "%.*f %.*f ", geometry_precision,
+                             shape->line[k].point[j].x, geometry_precision,
+                             shape->line[k].point[j].y);
+            }
 
-          msIO_fprintf(stream, "</gml:posList>\n");
-          msIO_fprintf(stream, "%s      </gml:LineString>\n", tab);
-          msIO_fprintf(stream, "%s    </gml:curveMember>\n", tab);
+            msIO_fprintf(stream, "</gml:posList>\n");
+
+            msIO_fprintf(stream, "%s      </gml:LinearRing>\n", tab);
+            msIO_fprintf(stream, "%s    </gml:interior>\n", tab);
+          }
         }
 
-        msIO_fprintf(stream, "%s  </gml:MultiCurve>\n", tab);
+        msIO_fprintf(stream, "%s  </gml:Polygon>\n", tab);
+        free(innerlist);
 
-        gmlEndGeometryContainer(stream, geometry_aggregate_name, namespace, tab);
-      } else {
-        msIO_fprintf(stream, "<!-- Warning: Cannot write geometry- no line/multiline geometry defined. -->\n");
+        gmlEndGeometryContainer(stream, geometry_simple_name, namespace, tab);
       }
+      free(outerlist);
+      outerlist = NULL;
+    } else if (geometry_aggregate_index != -1 ||
+               (geometryList->numgeometries == 0)) { /* write a MultiSurface */
+      gmlStartGeometryContainer(stream, geometry_aggregate_name, namespace,
+                                tab);
+
+      pszGMLId = gmlCreateGeomId(nGMLVersion, pszFID, &id);
+
+      /* MultiSurface */
+      if (srsname_encoded)
+        msIO_fprintf(stream, "%s  <gml:MultiSurface%s srsName=\"%s\">\n", tab,
+                     pszGMLId, srsname_encoded);
+      else
+        msIO_fprintf(stream, "%s  <gml:MultiSurface%s>\n", tab, pszGMLId);
+      msFree(pszGMLId);
 
-      break;
-    case(MS_SHAPE_POLYGON): /* this gets nasty, since our shapes are so flexible */
-      geometry_simple_index = msGMLGeometryLookup(geometryList, "polygon");
-      geometry_aggregate_index = msGMLGeometryLookup(geometryList, "multipolygon");
-      if(geometry_simple_index >= 0) geometry_simple_name = geometryList->geometries[geometry_simple_index].name;
-      if(geometry_aggregate_index >= 0) geometry_aggregate_name = geometryList->geometries[geometry_aggregate_index].name;
-
-      /* get a list of outter rings for this polygon */
-      outerlist = msGetOuterList(shape);
-
-      numouters = 0;
-      for(i=0; i<shape->numlines; i++)
-        if(outerlist[i] == MS_TRUE) numouters++;
-
-      if((geometry_simple_index != -1 && numouters == 1) ||
-          (geometry_simple_index != -1 && geometry_aggregate_index == -1) ||
-          (geometryList->numgeometries == 0 && shape->numlines == 1)) { /* write a Polygon(s) */
-        for(i=0; i<shape->numlines; i++) {
-          if(outerlist[i] == MS_FALSE) break; /* skip non-outer rings, each outer ring is a new polygon */
+      for (i = 0; i < shape->numlines; i++) { /* step through the outer rings */
+        if (outerlist[i] == MS_TRUE) {
+          msIO_fprintf(stream, "%s    <gml:surfaceMember>\n", tab);
 
           /* get a list of inner rings for this polygon */
           innerlist = msGetInnerList(shape, i, outerlist);
 
-          gmlStartGeometryContainer(stream, geometry_simple_name, namespace, tab);
-
           pszGMLId = gmlCreateGeomId(nGMLVersion, pszFID, &id);
 
-          /* Polygon (should be Surface?) */
-          if(srsname_encoded)
-            msIO_fprintf(stream, "%s  <gml:Polygon%s srsName=\"%s\">\n", tab, pszGMLId, srsname_encoded);
-          else
-            msIO_fprintf(stream, "%s  <gml:Polygon%s>\n", tab, pszGMLId);
+          msIO_fprintf(stream, "%s      <gml:Polygon%s>\n", tab, pszGMLId);
           msFree(pszGMLId);
 
-          msIO_fprintf(stream, "%s    <gml:exterior>\n", tab);
-          msIO_fprintf(stream, "%s      <gml:LinearRing>\n", tab);
+          msIO_fprintf(stream, "%s        <gml:exterior>\n", tab);
+          msIO_fprintf(stream, "%s          <gml:LinearRing>\n", tab);
 
-          msIO_fprintf(stream, "%s        <gml:posList srsDimension=\"%d\">", tab, nSRSDimension);
-          for(j=0; j<shape->line[i].numpoints; j++)
-          {
-            if( nSRSDimension == 3 )
-              msIO_fprintf(stream, "%.*f %.*f %.*f ", geometry_precision, shape->line[i].point[j].x, geometry_precision, shape->line[i].point[j].y, geometry_precision, shape->line[i].point[j].z);
+          msIO_fprintf(stream,
+                       "%s            <gml:posList srsDimension=\"%d\">", tab,
+                       nSRSDimension);
+          for (j = 0; j < shape->line[i].numpoints; j++) {
+            if (nSRSDimension == 3)
+              msIO_fprintf(stream, "%.*f %.*f %.*f ", geometry_precision,
+                           shape->line[i].point[j].x, geometry_precision,
+                           shape->line[i].point[j].y, geometry_precision,
+                           shape->line[i].point[j].z);
             else
-                /* fall-through */
-              msIO_fprintf(stream, "%.*f %.*f ", geometry_precision, shape->line[i].point[j].x, geometry_precision, shape->line[i].point[j].y);
+              /* fall-through */
+              msIO_fprintf(stream, "%.*f %.*f ", geometry_precision,
+                           shape->line[i].point[j].x, geometry_precision,
+                           shape->line[i].point[j].y);
           }
 
           msIO_fprintf(stream, "</gml:posList>\n");
 
-          msIO_fprintf(stream, "%s      </gml:LinearRing>\n", tab);
-          msIO_fprintf(stream, "%s    </gml:exterior>\n", tab);
+          msIO_fprintf(stream, "%s          </gml:LinearRing>\n", tab);
+          msIO_fprintf(stream, "%s        </gml:exterior>\n", tab);
 
-          for(k=0; k<shape->numlines; k++) { /* now step through all the inner rings */
-            if(innerlist[k] == MS_TRUE) {
-              msIO_fprintf(stream, "%s    <gml:interior>\n", tab);
-              msIO_fprintf(stream, "%s      <gml:LinearRing>\n", tab);
-
-              msIO_fprintf(stream, "%s        <gml:posList srsDimension=\"%d\">", tab, nSRSDimension);
-              for(j=0; j<shape->line[k].numpoints; j++)
-              {
-                if( nSRSDimension == 3 )
-                    msIO_fprintf(stream, "%.*f %.*f %.*f ", geometry_precision,shape->line[k].point[j].x, geometry_precision,shape->line[k].point[j].y, geometry_precision,shape->line[k].point[j].z);
+          for (k = 0; k < shape->numlines;
+               k++) { /* now step through all the inner rings */
+            if (innerlist[k] == MS_TRUE) {
+              msIO_fprintf(stream, "%s        <gml:interior>\n", tab);
+              msIO_fprintf(stream, "%s          <gml:LinearRing>\n", tab);
+
+              msIO_fprintf(stream,
+                           "%s            <gml:posList srsDimension=\"%d\">",
+                           tab, nSRSDimension);
+              for (j = 0; j < shape->line[k].numpoints; j++) {
+                if (nSRSDimension == 3)
+                  msIO_fprintf(stream, "%.*f %.*f %.*f ", geometry_precision,
+                               shape->line[k].point[j].x, geometry_precision,
+                               shape->line[k].point[j].y, geometry_precision,
+                               shape->line[k].point[j].z);
                 else
-                        /* fall-through */
-                msIO_fprintf(stream, "%.*f %.*f ", geometry_precision,shape->line[k].point[j].x, geometry_precision,shape->line[k].point[j].y);
+                  /* fall-through */
+                  msIO_fprintf(stream, "%.*f %.*f ", geometry_precision,
+                               shape->line[k].point[j].x, geometry_precision,
+                               shape->line[k].point[j].y);
               }
-
               msIO_fprintf(stream, "</gml:posList>\n");
 
-              msIO_fprintf(stream, "%s      </gml:LinearRing>\n", tab);
-              msIO_fprintf(stream, "%s    </gml:interior>\n", tab);
+              msIO_fprintf(stream, "%s          </gml:LinearRing>\n", tab);
+              msIO_fprintf(stream, "%s        </gml:interior>\n", tab);
             }
           }
 
-          msIO_fprintf(stream, "%s  </gml:Polygon>\n", tab);
-          free(innerlist);
-
-          gmlEndGeometryContainer(stream, geometry_simple_name, namespace, tab);
-        }
-        free(outerlist);
-        outerlist = NULL;
-      } else if(geometry_aggregate_index != -1 || (geometryList->numgeometries == 0)) { /* write a MultiSurface */
-        gmlStartGeometryContainer(stream, geometry_aggregate_name, namespace, tab);
-
-        pszGMLId = gmlCreateGeomId(nGMLVersion, pszFID, &id);
-
-        /* MultiSurface */
-        if(srsname_encoded)
-          msIO_fprintf(stream, "%s  <gml:MultiSurface%s srsName=\"%s\">\n", tab, pszGMLId, srsname_encoded);
-        else
-          msIO_fprintf(stream, "%s  <gml:MultiSurface%s>\n", tab, pszGMLId);
-        msFree(pszGMLId);
-
-        for(i=0; i<shape->numlines; i++) { /* step through the outer rings */
-          if(outerlist[i] == MS_TRUE) {
-            msIO_fprintf(stream, "%s    <gml:surfaceMember>\n", tab);
-
-            /* get a list of inner rings for this polygon */
-            innerlist = msGetInnerList(shape, i, outerlist);
-
-            pszGMLId = gmlCreateGeomId(nGMLVersion, pszFID, &id);
-
-            msIO_fprintf(stream, "%s      <gml:Polygon%s>\n", tab, pszGMLId);
-            msFree(pszGMLId);
-
-            msIO_fprintf(stream, "%s        <gml:exterior>\n", tab);
-            msIO_fprintf(stream, "%s          <gml:LinearRing>\n", tab);
-
-            msIO_fprintf(stream, "%s            <gml:posList srsDimension=\"%d\">", tab, nSRSDimension);
-            for(j=0; j<shape->line[i].numpoints; j++)
-            {
-            if( nSRSDimension == 3 )
-              msIO_fprintf(stream, "%.*f %.*f %.*f ", geometry_precision,shape->line[i].point[j].x, geometry_precision,shape->line[i].point[j].y, geometry_precision,shape->line[i].point[j].z);
-            else
-                /* fall-through */
-              msIO_fprintf(stream, "%.*f %.*f ", geometry_precision,shape->line[i].point[j].x, geometry_precision,shape->line[i].point[j].y);
-            }
-
-            msIO_fprintf(stream, "</gml:posList>\n");
-
-            msIO_fprintf(stream, "%s          </gml:LinearRing>\n", tab);
-            msIO_fprintf(stream, "%s        </gml:exterior>\n", tab);
-
-            for(k=0; k<shape->numlines; k++) { /* now step through all the inner rings */
-              if(innerlist[k] == MS_TRUE) {
-                msIO_fprintf(stream, "%s        <gml:interior>\n", tab);
-                msIO_fprintf(stream, "%s          <gml:LinearRing>\n", tab);
-
-                msIO_fprintf(stream, "%s            <gml:posList srsDimension=\"%d\">", tab, nSRSDimension);
-                for(j=0; j<shape->line[k].numpoints; j++)
-                {
-                  if( nSRSDimension == 3 )
-                    msIO_fprintf(stream, "%.*f %.*f %.*f ", geometry_precision, shape->line[k].point[j].x, geometry_precision,shape->line[k].point[j].y, geometry_precision,shape->line[k].point[j].z);
-                  else
-                        /* fall-through */
-                  msIO_fprintf(stream, "%.*f %.*f ", geometry_precision,shape->line[k].point[j].x, geometry_precision,shape->line[k].point[j].y);
-                }
-                msIO_fprintf(stream, "</gml:posList>\n");
-
-                msIO_fprintf(stream, "%s          </gml:LinearRing>\n", tab);
-                msIO_fprintf(stream, "%s        </gml:interior>\n", tab);
-              }
-            }
+          msIO_fprintf(stream, "%s      </gml:Polygon>\n", tab);
 
-            msIO_fprintf(stream, "%s      </gml:Polygon>\n", tab);
-
-            free(innerlist);
-            msIO_fprintf(stream, "%s    </gml:surfaceMember>\n", tab);
-          }
+          free(innerlist);
+          msIO_fprintf(stream, "%s    </gml:surfaceMember>\n", tab);
         }
-        msIO_fprintf(stream, "%s  </gml:MultiSurface>\n", tab);
+      }
+      msIO_fprintf(stream, "%s  </gml:MultiSurface>\n", tab);
 
-        free(outerlist);
-        outerlist = NULL;
+      free(outerlist);
+      outerlist = NULL;
 
-        gmlEndGeometryContainer(stream, geometry_aggregate_name, namespace, tab);
-      } else {
-        msIO_fprintf(stream, "<!-- Warning: Cannot write geometry- no polygon/multipolygon geometry defined. -->\n");
-      }
+      gmlEndGeometryContainer(stream, geometry_aggregate_name, namespace, tab);
+    } else {
+      msIO_fprintf(stream, "<!-- Warning: Cannot write geometry- no "
+                           "polygon/multipolygon geometry defined. -->\n");
+    }
 
-      break;
-    default:
-      break;
+    break;
+  default:
+    break;
   }
 
   /* clean-up */
   msFree(outerlist);
   msFree(srsname_encoded);
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
 /*
@@ -808,113 +979,125 @@ static int gmlWriteGeometry_GML3(FILE *s
 */
 static int gmlWriteBounds(FILE *stream, OWSGMLVersion format, rectObj *rect,
                           const char *srsname, const char *tab,
-                          const char *pszTopPrefix)
-{
-  switch(format) {
-    case(OWS_GML2):
-      return gmlWriteBounds_GML2(stream, rect, srsname, tab, pszTopPrefix);
-      break;
-    case(OWS_GML3):
-    case(OWS_GML32):
-      return gmlWriteBounds_GML3(stream, rect, srsname, tab, pszTopPrefix);
-      break;
-    default:
-      msSetError(MS_IOERR, "Unsupported GML format.", "gmlWriteBounds()");
+                          const char *pszTopPrefix) {
+  switch (format) {
+  case (OWS_GML2):
+    return gmlWriteBounds_GML2(stream, rect, srsname, tab, pszTopPrefix);
+    break;
+  case (OWS_GML3):
+  case (OWS_GML32):
+    return gmlWriteBounds_GML3(stream, rect, srsname, tab, pszTopPrefix);
+    break;
+  default:
+    msSetError(MS_IOERR, "Unsupported GML format.", "gmlWriteBounds()");
   }
 
-  return(MS_FAILURE);
+  return (MS_FAILURE);
 }
 
 static int gmlWriteGeometry(FILE *stream, gmlGeometryListObj *geometryList,
                             OWSGMLVersion format, shapeObj *shape,
                             const char *srsname, const char *namespace,
-                            const char *tab, const char* pszFID, int nSRSDimension, int geometry_precision)
-{
-  switch(format) {
-    case(OWS_GML2):
-      return gmlWriteGeometry_GML2(stream, geometryList, shape, srsname, namespace, tab, nSRSDimension, geometry_precision);
-      break;
-    case(OWS_GML3):
-    case(OWS_GML32):
-      return gmlWriteGeometry_GML3(stream, geometryList, shape, srsname, namespace, tab, pszFID, format, nSRSDimension, geometry_precision);
-      break;
-    default:
-      msSetError(MS_IOERR, "Unsupported GML format.", "gmlWriteGeometry()");
+                            const char *tab, const char *pszFID,
+                            int nSRSDimension, int geometry_precision) {
+  switch (format) {
+  case (OWS_GML2):
+    return gmlWriteGeometry_GML2(stream, geometryList, shape, srsname,
+                                 namespace, tab, nSRSDimension,
+                                 geometry_precision);
+    break;
+  case (OWS_GML3):
+  case (OWS_GML32):
+    return gmlWriteGeometry_GML3(stream, geometryList, shape, srsname,
+                                 namespace, tab, pszFID, format, nSRSDimension,
+                                 geometry_precision);
+    break;
+  default:
+    msSetError(MS_IOERR, "Unsupported GML format.", "gmlWriteGeometry()");
   }
 
-  return(MS_FAILURE);
+  return (MS_FAILURE);
 }
 
 /*
 ** GML specific metadata handling functions.
 */
 
-int msItemInGroups(const char *name, gmlGroupListObj *groupList)
-{
+int msItemInGroups(const char *name, gmlGroupListObj *groupList) {
   int i, j;
   gmlGroupObj *group;
 
-  if(!groupList) return MS_FALSE; /* no groups */
+  if (!groupList)
+    return MS_FALSE; /* no groups */
 
-  for(i=0; i<groupList->numgroups; i++) {
+  for (i = 0; i < groupList->numgroups; i++) {
     group = &(groupList->groups[i]);
-    for(j=0; j<group->numitems; j++) {
-      if(strcasecmp(name, group->items[j]) == 0) return MS_TRUE;
+    for (j = 0; j < group->numitems; j++) {
+      if (strcasecmp(name, group->items[j]) == 0)
+        return MS_TRUE;
     }
   }
 
   return MS_FALSE;
 }
 
-static int msGMLGeometryLookup(gmlGeometryListObj *geometryList, const char *type)
-{
+static int msGMLGeometryLookup(gmlGeometryListObj *geometryList,
+                               const char *type) {
   int i;
 
-  if(!geometryList || !type) return -1; /* nothing to look for */
+  if (!geometryList || !type)
+    return -1; /* nothing to look for */
 
-  for(i=0; i<geometryList->numgeometries; i++)
-    if(geometryList->geometries[i].type && (strcasecmp(geometryList->geometries[i].type, type) == 0))
+  for (i = 0; i < geometryList->numgeometries; i++)
+    if (geometryList->geometries[i].type &&
+        (strcasecmp(geometryList->geometries[i].type, type) == 0))
       return i;
 
-  if( geometryList->numgeometries == 1 && geometryList->geometries[0].type == NULL )
+  if (geometryList->numgeometries == 1 &&
+      geometryList->geometries[0].type == NULL)
     return 0;
 
   return -1; /* not found */
 }
 
-gmlGeometryListObj *msGMLGetGeometries(layerObj *layer, const char *metadata_namespaces, int bWithDefaultGeom)
-{
+gmlGeometryListObj *msGMLGetGeometries(layerObj *layer,
+                                       const char *metadata_namespaces,
+                                       int bWithDefaultGeom) {
   int i;
 
-  const char *value=NULL;
+  const char *value = NULL;
   char tag[64];
 
-  char **names=NULL;
-  int numnames=0;
+  char **names = NULL;
+  int numnames = 0;
 
-  gmlGeometryListObj *geometryList=NULL;
-  gmlGeometryObj *geometry=NULL;
+  gmlGeometryListObj *geometryList = NULL;
+  gmlGeometryObj *geometry = NULL;
 
   /* allocate memory and initialize the item collection */
-  geometryList = (gmlGeometryListObj *) malloc(sizeof(gmlGeometryListObj));
-  MS_CHECK_ALLOC(geometryList, sizeof(gmlGeometryListObj), NULL) ;
+  geometryList = (gmlGeometryListObj *)malloc(sizeof(gmlGeometryListObj));
+  MS_CHECK_ALLOC(geometryList, sizeof(gmlGeometryListObj), NULL);
   geometryList->geometries = NULL;
   geometryList->numgeometries = 0;
 
-  if((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces, "geometries")) != NULL) {
+  if ((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces,
+                                   "geometries")) != NULL) {
     names = msStringSplit(value, ',', &numnames);
 
     /* allocation an array of gmlGeometryObj's */
     geometryList->numgeometries = numnames;
-    geometryList->geometries = (gmlGeometryObj *) malloc(sizeof(gmlGeometryObj)*geometryList->numgeometries);
-    if (geometryList->geometries ==  NULL) {
-      msSetError(MS_MEMERR, "Out of memory allocating %u bytes.\n", "msGMLGetGeometries()",
-                 (unsigned int)(sizeof(gmlGeometryObj)*geometryList->numgeometries));
+    geometryList->geometries = (gmlGeometryObj *)malloc(
+        sizeof(gmlGeometryObj) * geometryList->numgeometries);
+    if (geometryList->geometries == NULL) {
+      msSetError(
+          MS_MEMERR, "Out of memory allocating %u bytes.\n",
+          "msGMLGetGeometries()",
+          (unsigned int)(sizeof(gmlGeometryObj) * geometryList->numgeometries));
       free(geometryList);
       return NULL;
     }
 
-    for(i=0; i<geometryList->numgeometries; i++) {
+    for (i = 0; i < geometryList->numgeometries; i++) {
       geometry = &(geometryList->geometries[i]);
 
       geometry->name = msStrdup(names[i]); /* initialize a few things */
@@ -923,31 +1106,33 @@ gmlGeometryListObj *msGMLGetGeometries(l
       geometry->occurmax = 1;
 
       snprintf(tag, 64, "%s_type", names[i]);
-      if((value =  msOWSLookupMetadata(&(layer->metadata), metadata_namespaces, tag)) != NULL)
+      if ((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces,
+                                       tag)) != NULL)
         geometry->type = msStrdup(value); /* TODO: validate input value */
 
       snprintf(tag, 64, "%s_occurances", names[i]);
-      if((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces, tag)) != NULL) {
+      if ((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces,
+                                       tag)) != NULL) {
         char **occur;
         int numoccur;
 
         occur = msStringSplit(value, ',', &numoccur);
-        if(numoccur == 2) { /* continue (TODO: throw an error if != 2) */
+        if (numoccur == 2) { /* continue (TODO: throw an error if != 2) */
           geometry->occurmin = atof(occur[0]);
-          if(strcasecmp(occur[1], "UNBOUNDED") == 0)
+          if (strcasecmp(occur[1], "UNBOUNDED") == 0)
             geometry->occurmax = OWS_GML_OCCUR_UNBOUNDED;
           else
             geometry->occurmax = atof(occur[1]);
         }
-        msFreeCharArray(occur,numoccur);
+        msFreeCharArray(occur, numoccur);
       }
     }
 
     msFreeCharArray(names, numnames);
-  }
-  else if( bWithDefaultGeom ) {
+  } else if (bWithDefaultGeom) {
     geometryList->numgeometries = 1;
-    geometryList->geometries = (gmlGeometryObj *) calloc(1, sizeof(gmlGeometryObj));
+    geometryList->geometries =
+        (gmlGeometryObj *)calloc(1, sizeof(gmlGeometryObj));
     geometryList->geometries[0].name = msStrdup(OWS_GML_DEFAULT_GEOMETRY_NAME);
     geometryList->geometries[0].type = NULL;
     geometryList->geometries[0].occurmin = 0;
@@ -957,13 +1142,13 @@ gmlGeometryListObj *msGMLGetGeometries(l
   return geometryList;
 }
 
-void msGMLFreeGeometries(gmlGeometryListObj *geometryList)
-{
+void msGMLFreeGeometries(gmlGeometryListObj *geometryList) {
   int i;
 
-  if(!geometryList) return;
+  if (!geometryList)
+    return;
 
-  for(i=0; i<geometryList->numgeometries; i++) {
+  for (i = 0; i < geometryList->numgeometries; i++) {
     msFree(geometryList->geometries[i].name);
     msFree(geometryList->geometries[i].type);
   }
@@ -972,143 +1157,143 @@ void msGMLFreeGeometries(gmlGeometryList
   free(geometryList);
 }
 
-static void msGMLWriteItem(FILE *stream, gmlItemObj *item,
-                           const char *value, const char *namespace,
-                           const char *tab,
-                           OWSGMLVersion outputformat,
-                           const char *pszFID)
-{
+static void msGMLWriteItem(FILE *stream, gmlItemObj *item, const char *value,
+                           const char *namespace, const char *tab,
+                           OWSGMLVersion outputformat, const char *pszFID) {
   char *encoded_value = NULL, *tag_name;
   int add_namespace = MS_TRUE;
   char gmlid[256];
   gmlid[0] = 0;
 
-  if(!stream || !item) return;
-  if(!item->visible) return;
+  if (!stream || !item)
+    return;
+  if (!item->visible)
+    return;
 
-  if(!namespace) add_namespace = MS_FALSE;
+  if (!namespace)
+    add_namespace = MS_FALSE;
 
-  if(item->alias)
+  if (item->alias)
     tag_name = item->alias;
   else
     tag_name = item->name;
-  if(strchr(tag_name, ':') != NULL) add_namespace = MS_FALSE;
-
-  if( item->type && (EQUAL(item->type, "Date") ||
-                     EQUAL(item->type, "DateTime") ||
-                     EQUAL(item->type, "Time")) ) {
-      struct tm tm;
-      if( msParseTime(value, &tm) == MS_TRUE ) {
-          const char* pszStartTag = "";
-          const char* pszEndTag = "";
-
-          encoded_value = (char*) msSmallMalloc(256);
-          if( outputformat == OWS_GML32  ) {
-              if( pszFID != NULL )
-                snprintf(gmlid, 256, " gml:id=\"%s.%s\"", pszFID, tag_name);
-              pszStartTag = "<gml:timePosition>";
-              pszEndTag = "</gml:timePosition>";
-          }
+  if (strchr(tag_name, ':') != NULL)
+    add_namespace = MS_FALSE;
 
-          if( EQUAL(item->type, "Date") )
-              snprintf(encoded_value, 256, "%s%04d-%02d-%02d%s",
-                       pszStartTag,
-                       tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday,
-                       pszEndTag);
-          else if( EQUAL(item->type, "Time") )
-              snprintf(encoded_value, 256, "%s%02d:%02d:%02dZ%s",
-                       pszStartTag,
-                       tm.tm_hour, tm.tm_min, tm.tm_sec,
-                       pszEndTag);
-          else
-          {
-              // Detected date time already formatted as YYYY-MM-DDTHH:mm:SS+ab:cd
-              // because msParseTime() can't handle time zones.
-              if( strlen(value) == 4+1+2+1+2+1+2+1+2+1+2+1+2+1+2 &&
-                  value[4] == '-' && value[7] == '-' && value[10] == 'T' &&
-                  value[13] == ':' && value[16] == ':' &&
-                  (value[19] == '+' || value[19] == '-') &&
-                  value[22] == ':' )
-              {
-                  snprintf(encoded_value, 256, "%s%s%s",
-                           pszStartTag, value, pszEndTag);
-              }
-              else
-              {
-                  snprintf(encoded_value, 256, "%s%04d-%02d-%02dT%02d:%02d:%02dZ%s",
-                           pszStartTag,
-                           tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday,
-                           tm.tm_hour, tm.tm_min, tm.tm_sec, pszEndTag);
-              }
-          }
+  if (item->type &&
+      (EQUAL(item->type, "Date") || EQUAL(item->type, "DateTime") ||
+       EQUAL(item->type, "Time"))) {
+    struct tm tm;
+    if (msParseTime(value, &tm) == MS_TRUE) {
+      const char *pszStartTag = "";
+      const char *pszEndTag = "";
+
+      encoded_value = (char *)msSmallMalloc(256);
+      if (outputformat == OWS_GML32) {
+        if (pszFID != NULL)
+          snprintf(gmlid, 256, " gml:id=\"%s.%s\"", pszFID, tag_name);
+        pszStartTag = "<gml:timePosition>";
+        pszEndTag = "</gml:timePosition>";
+      }
+
+      if (EQUAL(item->type, "Date"))
+        snprintf(encoded_value, 256, "%s%04d-%02d-%02d%s", pszStartTag,
+                 tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday, pszEndTag);
+      else if (EQUAL(item->type, "Time"))
+        snprintf(encoded_value, 256, "%s%02d:%02d:%02dZ%s", pszStartTag,
+                 tm.tm_hour, tm.tm_min, tm.tm_sec, pszEndTag);
+      else {
+        // Detected date time already formatted as YYYY-MM-DDTHH:mm:SS+ab:cd
+        // because msParseTime() can't handle time zones.
+        if (strlen(value) ==
+                4 + 1 + 2 + 1 + 2 + 1 + 2 + 1 + 2 + 1 + 2 + 1 + 2 + 1 + 2 &&
+            value[4] == '-' && value[7] == '-' && value[10] == 'T' &&
+            value[13] == ':' && value[16] == ':' &&
+            (value[19] == '+' || value[19] == '-') && value[22] == ':') {
+          snprintf(encoded_value, 256, "%s%s%s", pszStartTag, value, pszEndTag);
+        } else {
+          snprintf(encoded_value, 256, "%s%04d-%02d-%02dT%02d:%02d:%02dZ%s",
+                   pszStartTag, tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday,
+                   tm.tm_hour, tm.tm_min, tm.tm_sec, pszEndTag);
+        }
       }
+    }
   }
 
-  if( encoded_value == NULL )
-  {
-    if(item->encode == MS_TRUE)
+  if (encoded_value == NULL) {
+    if (item->encode == MS_TRUE)
       encoded_value = msEncodeHTMLEntities(value);
     else
       encoded_value = msStrdup(value);
   }
 
-  if(!item->template) { /* build the tag from pieces */
+  if (!item->template) { /* build the tag from pieces */
 
-    if(add_namespace == MS_TRUE && msIsXMLTagValid(tag_name) == MS_FALSE)
-      msIO_fprintf(stream, "<!-- WARNING: The value '%s' is not valid in a XML tag context. -->\n", tag_name);
-
-    if(add_namespace == MS_TRUE)
-      msIO_fprintf(stream, "%s<%s:%s%s>%s</%s:%s>\n", tab, namespace, tag_name, gmlid, encoded_value, namespace, tag_name);
+    if (add_namespace == MS_TRUE && msIsXMLTagValid(tag_name) == MS_FALSE)
+      msIO_fprintf(stream,
+                   "<!-- WARNING: The value '%s' is not valid in a XML tag "
+                   "context. -->\n",
+                   tag_name);
+
+    if (add_namespace == MS_TRUE)
+      msIO_fprintf(stream, "%s<%s:%s%s>%s</%s:%s>\n", tab, namespace, tag_name,
+                   gmlid, encoded_value, namespace, tag_name);
     else
-      msIO_fprintf(stream, "%s<%s%s>%s</%s>\n", tab, tag_name, gmlid, encoded_value, tag_name);
+      msIO_fprintf(stream, "%s<%s%s>%s</%s>\n", tab, tag_name, gmlid,
+                   encoded_value, tag_name);
   } else {
     char *tag = NULL;
 
     tag = msStrdup(item->template);
     tag = msReplaceSubstring(tag, "$value", encoded_value);
-    if(namespace) tag = msReplaceSubstring(tag, "$namespace", namespace);
+    if (namespace)
+      tag = msReplaceSubstring(tag, "$namespace", namespace);
     msIO_fprintf(stream, "%s%s\n", tab, tag);
     free(tag);
   }
 
-  free( encoded_value );
+  free(encoded_value);
 
   return;
 }
 
-gmlNamespaceListObj *msGMLGetNamespaces(webObj *web, const char *metadata_namespaces)
-{
+gmlNamespaceListObj *msGMLGetNamespaces(webObj *web,
+                                        const char *metadata_namespaces) {
   int i;
-  const char *value=NULL;
+  const char *value = NULL;
   char tag[64];
 
-  char **prefixes=NULL;
-  int numprefixes=0;
+  char **prefixes = NULL;
+  int numprefixes = 0;
 
-  gmlNamespaceListObj *namespaceList=NULL;
-  gmlNamespaceObj *namespace=NULL;
+  gmlNamespaceListObj *namespaceList = NULL;
+  gmlNamespaceObj *namespace = NULL;
 
   /* allocate the collection */
-  namespaceList = (gmlNamespaceListObj *) malloc(sizeof(gmlNamespaceListObj));
-  MS_CHECK_ALLOC(namespaceList, sizeof(gmlNamespaceListObj), NULL) ;
+  namespaceList = (gmlNamespaceListObj *)malloc(sizeof(gmlNamespaceListObj));
+  MS_CHECK_ALLOC(namespaceList, sizeof(gmlNamespaceListObj), NULL);
   namespaceList->namespaces = NULL;
   namespaceList->numnamespaces = 0;
 
   /* list of namespaces (TODO: make this automatic by parsing metadata) */
-  if((value = msOWSLookupMetadata(&(web->metadata), metadata_namespaces, "external_namespace_prefixes")) != NULL) {
+  if ((value = msOWSLookupMetadata(&(web->metadata), metadata_namespaces,
+                                   "external_namespace_prefixes")) != NULL) {
     prefixes = msStringSplit(value, ',', &numprefixes);
 
     /* allocation an array of gmlNamespaceObj's */
     namespaceList->numnamespaces = numprefixes;
-    namespaceList->namespaces = (gmlNamespaceObj *) malloc(sizeof(gmlNamespaceObj)*namespaceList->numnamespaces);
+    namespaceList->namespaces = (gmlNamespaceObj *)malloc(
+        sizeof(gmlNamespaceObj) * namespaceList->numnamespaces);
     if (namespaceList->namespaces == NULL) {
-      msSetError(MS_MEMERR, "Out of memory allocating %u bytes.\n", "msGMLGetNamespaces()",
-                 (unsigned int)(sizeof(gmlNamespaceObj)*namespaceList->numnamespaces));
+      msSetError(MS_MEMERR, "Out of memory allocating %u bytes.\n",
+                 "msGMLGetNamespaces()",
+                 (unsigned int)(sizeof(gmlNamespaceObj) *
+                                namespaceList->numnamespaces));
       free(namespaceList);
       return NULL;
     }
 
-    for(i=0; i<namespaceList->numnamespaces; i++) {
+    for (i = 0; i < namespaceList->numnamespaces; i++) {
       namespace = &(namespaceList->namespaces[i]);
 
       namespace->prefix = msStrdup(prefixes[i]); /* initialize a few things */
@@ -1116,12 +1301,14 @@ gmlNamespaceListObj *msGMLGetNamespaces(
       namespace->schemalocation = NULL;
 
       snprintf(tag, 64, "%s_uri", namespace->prefix);
-      if((value = msOWSLookupMetadata(&(web->metadata), metadata_namespaces, tag)) != NULL)
-        namespace->uri = msStrdup(value);
+      if ((value = msOWSLookupMetadata(&(web->metadata), metadata_namespaces,
+                                       tag)) != NULL)
+      namespace->uri = msStrdup(value);
 
       snprintf(tag, 64, "%s_schema_location", namespace->prefix);
-      if((value = msOWSLookupMetadata(&(web->metadata), metadata_namespaces, tag)) != NULL)
-        namespace->schemalocation = msStrdup(value);
+      if ((value = msOWSLookupMetadata(&(web->metadata), metadata_namespaces,
+                                       tag)) != NULL)
+      namespace->schemalocation = msStrdup(value);
     }
 
     msFreeCharArray(prefixes, numprefixes);
@@ -1130,13 +1317,13 @@ gmlNamespaceListObj *msGMLGetNamespaces(
   return namespaceList;
 }
 
-void msGMLFreeNamespaces(gmlNamespaceListObj *namespaceList)
-{
+void msGMLFreeNamespaces(gmlNamespaceListObj *namespaceList) {
   int i;
 
-  if(!namespaceList) return;
+  if (!namespaceList)
+    return;
 
-  for(i=0; i<namespaceList->numnamespaces; i++) {
+  for (i = 0; i < namespaceList->numnamespaces; i++) {
     msFree(namespaceList->namespaces[i].prefix);
     msFree(namespaceList->namespaces[i].uri);
     msFree(namespaceList->namespaces[i].schemalocation);
@@ -1145,40 +1332,43 @@ void msGMLFreeNamespaces(gmlNamespaceLis
   free(namespaceList);
 }
 
-gmlConstantListObj *msGMLGetConstants(layerObj *layer, const char *metadata_namespaces)
-{
+gmlConstantListObj *msGMLGetConstants(layerObj *layer,
+                                      const char *metadata_namespaces) {
   int i;
-  const char *value=NULL;
+  const char *value = NULL;
   char tag[64];
 
-  char **names=NULL;
-  int numnames=0;
+  char **names = NULL;
+  int numnames = 0;
 
-  gmlConstantListObj *constantList=NULL;
-  gmlConstantObj *constant=NULL;
+  gmlConstantListObj *constantList = NULL;
+  gmlConstantObj *constant = NULL;
 
   /* allocate the collection */
-  constantList = (gmlConstantListObj *) malloc(sizeof(gmlConstantListObj));
+  constantList = (gmlConstantListObj *)malloc(sizeof(gmlConstantListObj));
   MS_CHECK_ALLOC(constantList, sizeof(gmlConstantListObj), NULL);
   constantList->constants = NULL;
   constantList->numconstants = 0;
 
   /* list of constants (TODO: make this automatic by parsing metadata) */
-  if((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces, "constants")) != NULL) {
+  if ((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces,
+                                   "constants")) != NULL) {
     names = msStringSplit(value, ',', &numnames);
 
     /* allocation an array of gmlConstantObj's */
     constantList->numconstants = numnames;
-    constantList->constants = (gmlConstantObj *) malloc(sizeof(gmlConstantObj)*constantList->numconstants);
+    constantList->constants = (gmlConstantObj *)malloc(
+        sizeof(gmlConstantObj) * constantList->numconstants);
     if (constantList->constants == NULL) {
-      msSetError(MS_MEMERR, "Out of memory allocating %u bytes.\n", "msGMLGetConstants()",
-                 (unsigned int)(sizeof(gmlConstantObj)*constantList->numconstants));
+      msSetError(
+          MS_MEMERR, "Out of memory allocating %u bytes.\n",
+          "msGMLGetConstants()",
+          (unsigned int)(sizeof(gmlConstantObj) * constantList->numconstants));
       free(constantList);
       return NULL;
     }
 
-
-    for(i=0; i<constantList->numconstants; i++) {
+    for (i = 0; i < constantList->numconstants; i++) {
       constant = &(constantList->constants[i]);
 
       constant->name = msStrdup(names[i]); /* initialize a few things */
@@ -1186,11 +1376,13 @@ gmlConstantListObj *msGMLGetConstants(la
       constant->type = NULL;
 
       snprintf(tag, 64, "%s_value", constant->name);
-      if((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces, tag)) != NULL)
+      if ((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces,
+                                       tag)) != NULL)
         constant->value = msStrdup(value);
 
       snprintf(tag, 64, "%s_type", constant->name);
-      if((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces, tag)) != NULL)
+      if ((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces,
+                                       tag)) != NULL)
         constant->type = msStrdup(value);
     }
 
@@ -1200,13 +1392,13 @@ gmlConstantListObj *msGMLGetConstants(la
   return constantList;
 }
 
-void msGMLFreeConstants(gmlConstantListObj *constantList)
-{
+void msGMLFreeConstants(gmlConstantListObj *constantList) {
   int i;
 
-  if(!constantList) return;
+  if (!constantList)
+    return;
 
-  for(i=0; i<constantList->numconstants; i++) {
+  for (i = 0; i < constantList->numconstants; i++) {
     msFree(constantList->constants[i].name);
     msFree(constantList->constants[i].value);
     msFree(constantList->constants[i].type);
@@ -1215,79 +1407,89 @@ void msGMLFreeConstants(gmlConstantListO
   free(constantList);
 }
 
-static void msGMLWriteConstant(FILE *stream, gmlConstantObj *constant, const char *namespace, const char *tab)
-{
+static void msGMLWriteConstant(FILE *stream, gmlConstantObj *constant,
+                               const char *namespace, const char *tab) {
   int add_namespace = MS_TRUE;
 
-  if(!stream || !constant) return;
-  if(!constant->value) return;
-
-  if(!namespace) add_namespace = MS_FALSE;
-  if(strchr(constant->name, ':') != NULL) add_namespace = MS_FALSE;
-
-  if(add_namespace == MS_TRUE && msIsXMLTagValid(constant->name) == MS_FALSE)
-    msIO_fprintf(stream, "<!-- WARNING: The value '%s' is not valid in a XML tag context. -->\n", constant->name);
-
-  if(add_namespace == MS_TRUE)
-    msIO_fprintf(stream, "%s<%s:%s>%s</%s:%s>\n", tab, namespace, constant->name, constant->value, namespace, constant->name);
+  if (!stream || !constant)
+    return;
+  if (!constant->value)
+    return;
+
+  if (!namespace)
+    add_namespace = MS_FALSE;
+  if (strchr(constant->name, ':') != NULL)
+    add_namespace = MS_FALSE;
+
+  if (add_namespace == MS_TRUE && msIsXMLTagValid(constant->name) == MS_FALSE)
+    msIO_fprintf(
+        stream,
+        "<!-- WARNING: The value '%s' is not valid in a XML tag context. -->\n",
+        constant->name);
+
+  if (add_namespace == MS_TRUE)
+    msIO_fprintf(stream, "%s<%s:%s>%s</%s:%s>\n", tab, namespace,
+                 constant->name, constant->value, namespace, constant->name);
   else
-    msIO_fprintf(stream, "%s<%s>%s</%s>\n", tab, constant->name, constant->value, constant->name);
+    msIO_fprintf(stream, "%s<%s>%s</%s>\n", tab, constant->name,
+                 constant->value, constant->name);
 
   return;
 }
 
-static void msGMLWriteGroup(FILE *stream,
-                            gmlGroupObj *group, shapeObj *shape,
+static void msGMLWriteGroup(FILE *stream, gmlGroupObj *group, shapeObj *shape,
                             gmlItemListObj *itemList,
                             gmlConstantListObj *constantList,
                             const char *namespace, const char *tab,
-                            OWSGMLVersion outputformat,
-                            const char *pszFID)
-{
-  int i,j;
+                            OWSGMLVersion outputformat, const char *pszFID) {
+  int i, j;
   int add_namespace = MS_TRUE;
   char *itemtab;
 
-  gmlItemObj *item=NULL;
-  gmlConstantObj *constant=NULL;
+  gmlItemObj *item = NULL;
+  gmlConstantObj *constant = NULL;
 
-  if(!stream || !group) return;
+  if (!stream || !group)
+    return;
 
   /* setup the item/constant tab */
-  itemtab = (char *) msSmallMalloc(sizeof(char)*strlen(tab)+3);
+  itemtab = (char *)msSmallMalloc(sizeof(char) * strlen(tab) + 3);
 
   sprintf(itemtab, "%s  ", tab);
 
-  if(!namespace || strchr(group->name, ':') != NULL) add_namespace = MS_FALSE;
+  if (!namespace || strchr(group->name, ':') != NULL)
+    add_namespace = MS_FALSE;
 
   /* start the group */
-  if(add_namespace == MS_TRUE)
+  if (add_namespace == MS_TRUE)
     msIO_fprintf(stream, "%s<%s:%s>\n", tab, namespace, group->name);
   else
     msIO_fprintf(stream, "%s<%s>\n", tab, group->name);
 
   /* now the items/constants in the group */
-  for(i=0; i<group->numitems; i++) {
-    for(j=0; j<constantList->numconstants; j++) {
+  for (i = 0; i < group->numitems; i++) {
+    for (j = 0; j < constantList->numconstants; j++) {
       constant = &(constantList->constants[j]);
-      if(strcasecmp(constant->name, group->items[i]) == 0) {
+      if (strcasecmp(constant->name, group->items[i]) == 0) {
         msGMLWriteConstant(stream, constant, namespace, itemtab);
         break;
       }
     }
-    if(j != constantList->numconstants) continue; /* found this one */
-    for(j=0; j<itemList->numitems; j++) {
+    if (j != constantList->numconstants)
+      continue; /* found this one */
+    for (j = 0; j < itemList->numitems; j++) {
       item = &(itemList->items[j]);
-      if(strcasecmp(item->name, group->items[i]) == 0) {
+      if (strcasecmp(item->name, group->items[i]) == 0) {
         /* the number of items matches the number of values exactly */
-        msGMLWriteItem(stream, item, shape->values[j], namespace, itemtab, outputformat, pszFID);
+        msGMLWriteItem(stream, item, shape->values[j], namespace, itemtab,
+                       outputformat, pszFID);
         break;
       }
     }
   }
 
   /* end the group */
-  if(add_namespace == MS_TRUE)
+  if (add_namespace == MS_TRUE)
     msIO_fprintf(stream, "%s</%s:%s>\n", tab, namespace, group->name);
   else
     msIO_fprintf(stream, "%s</%s>\n", tab, group->name);
@@ -1298,40 +1500,43 @@ static void msGMLWriteGroup(FILE *stream
 }
 #endif
 
-gmlGroupListObj *msGMLGetGroups(layerObj *layer, const char *metadata_namespaces)
-{
+gmlGroupListObj *msGMLGetGroups(layerObj *layer,
+                                const char *metadata_namespaces) {
   int i;
-  const char *value=NULL;
+  const char *value = NULL;
   char tag[64];
 
-  char **names=NULL;
-  int numnames=0;
+  char **names = NULL;
+  int numnames = 0;
 
-  gmlGroupListObj *groupList=NULL;
-  gmlGroupObj *group=NULL;
+  gmlGroupListObj *groupList = NULL;
+  gmlGroupObj *group = NULL;
 
   /* allocate the collection */
-  groupList = (gmlGroupListObj *) malloc(sizeof(gmlGroupListObj));
-  MS_CHECK_ALLOC(groupList, sizeof(gmlGroupListObj), NULL) ;
+  groupList = (gmlGroupListObj *)malloc(sizeof(gmlGroupListObj));
+  MS_CHECK_ALLOC(groupList, sizeof(gmlGroupListObj), NULL);
   groupList->groups = NULL;
   groupList->numgroups = 0;
 
   /* list of groups (TODO: make this automatic by parsing metadata) */
-  if((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces, "groups")) != NULL &&
-      value[0] != '\0' ) {
+  if ((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces,
+                                   "groups")) != NULL &&
+      value[0] != '\0') {
     names = msStringSplit(value, ',', &numnames);
 
     /* allocation an array of gmlGroupObj's */
     groupList->numgroups = numnames;
-    groupList->groups = (gmlGroupObj *) malloc(sizeof(gmlGroupObj)*groupList->numgroups);
+    groupList->groups =
+        (gmlGroupObj *)malloc(sizeof(gmlGroupObj) * groupList->numgroups);
     if (groupList->groups == NULL) {
-      msSetError(MS_MEMERR, "Out of memory allocating %u bytes.\n", "msGMLGetGroups()",
-                 (unsigned int)(sizeof(gmlGroupObj)*groupList->numgroups));
+      msSetError(MS_MEMERR, "Out of memory allocating %u bytes.\n",
+                 "msGMLGetGroups()",
+                 (unsigned int)(sizeof(gmlGroupObj) * groupList->numgroups));
       free(groupList);
       return NULL;
     }
 
-    for(i=0; i<groupList->numgroups; i++) {
+    for (i = 0; i < groupList->numgroups; i++) {
       group = &(groupList->groups[i]);
 
       group->name = msStrdup(names[i]); /* initialize a few things */
@@ -1340,11 +1545,13 @@ gmlGroupListObj *msGMLGetGroups(layerObj
       group->type = NULL;
 
       snprintf(tag, 64, "%s_group", group->name);
-      if((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces, tag)) != NULL)
+      if ((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces,
+                                       tag)) != NULL)
         group->items = msStringSplit(value, ',', &group->numitems);
 
       snprintf(tag, 64, "%s_type", group->name);
-      if((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces, tag)) != NULL)
+      if ((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces,
+                                       tag)) != NULL)
         group->type = msStrdup(value);
     }
 
@@ -1354,13 +1561,13 @@ gmlGroupListObj *msGMLGetGroups(layerObj
   return groupList;
 }
 
-void msGMLFreeGroups(gmlGroupListObj *groupList)
-{
+void msGMLFreeGroups(gmlGroupListObj *groupList) {
   int i;
 
-  if(!groupList) return;
+  if (!groupList)
+    return;
 
-  for(i=0; i<groupList->numgroups; i++) {
+  for (i = 0; i < groupList->numgroups; i++) {
     msFree(groupList->groups[i].name);
     msFreeCharArray(groupList->groups[i].items, groupList->groups[i].numitems);
     msFree(groupList->groups[i].type);
@@ -1371,87 +1578,104 @@ void msGMLFreeGroups(gmlGroupListObj *gr
 }
 
 /* Dump GML query results for WMS GetFeatureInfo */
-int msGMLWriteQuery(mapObj *map, char *filename, const char *namespaces)
-{
+int msGMLWriteQuery(mapObj *map, char *filename, const char *namespaces) {
 #if defined(USE_WMS_SVR)
   int status;
-  int i,j,k;
-  layerObj *lp=NULL;
+  int i, j, k;
+  layerObj *lp = NULL;
   shapeObj shape;
   FILE *stream_to_free = NULL;
-  FILE *stream=stdout; /* defaults to stdout */
+  FILE *stream = stdout; /* defaults to stdout */
   char szPath[MS_MAXPATHLEN];
   char *value;
   char *pszMapSRS = NULL;
 
-  gmlGroupListObj *groupList=NULL;
-  gmlItemListObj *itemList=NULL;
-  gmlConstantListObj *constantList=NULL;
-  gmlGeometryListObj *geometryList=NULL;
-  gmlItemObj *item=NULL;
-  gmlConstantObj *constant=NULL;
+  gmlGroupListObj *groupList = NULL;
+  gmlItemListObj *itemList = NULL;
+  gmlConstantListObj *constantList = NULL;
+  gmlGeometryListObj *geometryList = NULL;
+  gmlItemObj *item = NULL;
+  gmlConstantObj *constant = NULL;
 
   msInitShape(&shape);
 
-  if(filename && strlen(filename) > 0) { /* deal with the filename if present */
+  if (filename &&
+      strlen(filename) > 0) { /* deal with the filename if present */
     stream_to_free = fopen(msBuildPath(szPath, map->mappath, filename), "w");
-    if(!stream_to_free) {
+    if (!stream_to_free) {
       msSetError(MS_IOERR, "(%s)", "msGMLWriteQuery()", filename);
-      return(MS_FAILURE);
+      return (MS_FAILURE);
     }
     stream = stream_to_free;
   }
 
   msIO_fprintf(stream, "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n\n");
-  msOWSPrintValidateMetadata(stream, &(map->web.metadata), namespaces, "rootname", OWS_NOERR, "<%s ", "msGMLOutput");
+  msOWSPrintValidateMetadata(stream, &(map->web.metadata), namespaces,
+                             "rootname", OWS_NOERR, "<%s ", "msGMLOutput");
 
-  msOWSPrintEncodeMetadata(stream, &(map->web.metadata), namespaces, "uri", OWS_NOERR, "xmlns=\"%s\"", NULL);
-  msIO_fprintf(stream, "\n\t xmlns:gml=\"http://www.opengis.net/gml\"" );
+  msOWSPrintEncodeMetadata(stream, &(map->web.metadata), namespaces, "uri",
+                           OWS_NOERR, "xmlns=\"%s\"", NULL);
+  msIO_fprintf(stream, "\n\t xmlns:gml=\"http://www.opengis.net/gml\"");
   msIO_fprintf(stream, "\n\t xmlns:xlink=\"http://www.w3.org/1999/xlink\"");
-  msIO_fprintf(stream, "\n\t xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"");
-  msOWSPrintEncodeMetadata(stream, &(map->web.metadata), namespaces, "schema", OWS_NOERR, "\n\t xsi:schemaLocation=\"%s\"", NULL);
+  msIO_fprintf(stream,
+               "\n\t xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"");
+  msOWSPrintEncodeMetadata(stream, &(map->web.metadata), namespaces, "schema",
+                           OWS_NOERR, "\n\t xsi:schemaLocation=\"%s\"", NULL);
   msIO_fprintf(stream, ">\n");
 
   /* a schema *should* be required */
-  msOWSPrintEncodeMetadata(stream, &(map->web.metadata), namespaces, "description", OWS_NOERR, "\t<gml:description>%s</gml:description>\n", NULL);
+  msOWSPrintEncodeMetadata(stream, &(map->web.metadata), namespaces,
+                           "description", OWS_NOERR,
+                           "\t<gml:description>%s</gml:description>\n", NULL);
 
-  /* Look up map SRS. We need an EPSG code for GML, if not then we get null and we'll fall back on the layer's SRS */
+  /* Look up map SRS. We need an EPSG code for GML, if not then we get null and
+   * we'll fall back on the layer's SRS */
   msOWSGetEPSGProj(&(map->projection), NULL, namespaces, MS_TRUE, &pszMapSRS);
 
   /* step through the layers looking for query results */
-  for(i=0; i<map->numlayers; i++) {
+  for (i = 0; i < map->numlayers; i++) {
     char *pszOutputSRS = NULL;
     int nSRSDimension = 2;
-    const char* geomtype;
+    const char *geomtype;
     lp = (GET_LAYER(map, map->layerorder[i]));
 
-    if(lp->resultcache && lp->resultcache->numresults > 0) { /* found results */
+    if (lp->resultcache &&
+        lp->resultcache->numresults > 0) { /* found results */
 
-      reprojectionObj* reprojector = NULL;
+      reprojectionObj *reprojector = NULL;
 
-      /* Determine output SRS, if map has none, then try using layer's native SRS */
+      /* Determine output SRS, if map has none, then try using layer's native
+       * SRS */
       if ((pszOutputSRS = pszMapSRS) == NULL) {
-        msOWSGetEPSGProj(&(lp->projection), NULL, namespaces, MS_TRUE, &pszOutputSRS);
+        msOWSGetEPSGProj(&(lp->projection), NULL, namespaces, MS_TRUE,
+                         &pszOutputSRS);
         if (pszOutputSRS == NULL) {
-          msSetError(MS_WMSERR, "No valid EPSG code in map or layer projection for GML output", "msGMLWriteQuery()");
-          continue;  /* No EPSG code, cannot output this layer */
+          msSetError(
+              MS_WMSERR,
+              "No valid EPSG code in map or layer projection for GML output",
+              "msGMLWriteQuery()");
+          continue; /* No EPSG code, cannot output this layer */
         }
       }
 
       /* start this collection (layer) */
       /* if no layer name provided fall back on the layer name + "_layer" */
-      value = (char*) msSmallMalloc(strlen(lp->name)+7);
+      value = (char *)msSmallMalloc(strlen(lp->name) + 7);
       sprintf(value, "%s_layer", lp->name);
-      msOWSPrintValidateMetadata(stream, &(lp->metadata), namespaces, "layername", OWS_NOERR, "\t<%s>\n", value);
+      msOWSPrintValidateMetadata(stream, &(lp->metadata), namespaces,
+                                 "layername", OWS_NOERR, "\t<%s>\n", value);
       msFree(value);
 
-      value = (char *) msOWSLookupMetadata(&(lp->metadata), "OM", "title");
+      value = (char *)msOWSLookupMetadata(&(lp->metadata), "OM", "title");
       if (value) {
-        msOWSPrintEncodeMetadata(stream, &(lp->metadata), namespaces, "title", OWS_NOERR, "\t<gml:name>%s</gml:name>\n", value);
+        msOWSPrintEncodeMetadata(stream, &(lp->metadata), namespaces, "title",
+                                 OWS_NOERR, "\t<gml:name>%s</gml:name>\n",
+                                 value);
       }
 
       geomtype = msOWSLookupMetadata(&(lp->metadata), "OFG", "geomtype");
-      if( geomtype != NULL && (strstr(geomtype, "25d") != NULL || strstr(geomtype, "25D") != NULL) ) {
+      if (geomtype != NULL && (strstr(geomtype, "25d") != NULL ||
+                               strstr(geomtype, "25D") != NULL)) {
         nSRSDimension = 3;
       }
 
@@ -1460,87 +1684,111 @@ int msGMLWriteQuery(mapObj *map, char *f
       constantList = msGMLGetConstants(lp, namespaces);
       groupList = msGMLGetGroups(lp, namespaces);
       geometryList = msGMLGetGeometries(lp, namespaces, MS_FALSE);
-      if (itemList == NULL || constantList == NULL || groupList == NULL || geometryList == NULL) {
-        msSetError(MS_MISCERR, "Unable to populate item and group metadata structures", "msGMLWriteQuery()");
-        if(stream_to_free != NULL) fclose(stream_to_free);
+      if (itemList == NULL || constantList == NULL || groupList == NULL ||
+          geometryList == NULL) {
+        msSetError(MS_MISCERR,
+                   "Unable to populate item and group metadata structures",
+                   "msGMLWriteQuery()");
+        if (stream_to_free != NULL)
+          fclose(stream_to_free);
         return MS_FAILURE;
       }
 
-      if(pszOutputSRS == pszMapSRS && msProjectionsDiffer(&(lp->projection), &(map->projection))) {
-        reprojector = msProjectCreateReprojector(&(lp->projection), &(map->projection));
-        if( reprojector == NULL ) {
+      if (pszOutputSRS == pszMapSRS &&
+          msProjectionsDiffer(&(lp->projection), &(map->projection))) {
+        reprojector =
+            msProjectCreateReprojector(&(lp->projection), &(map->projection));
+        if (reprojector == NULL) {
           msGMLFreeGroups(groupList);
           msGMLFreeConstants(constantList);
           msGMLFreeItems(itemList);
           msGMLFreeGeometries(geometryList);
           msFree(pszOutputSRS);
-          if(stream_to_free != NULL) fclose(stream_to_free);
+          if (stream_to_free != NULL)
+            fclose(stream_to_free);
           return MS_FAILURE;
         }
       }
 
-      for(j=0; j<lp->resultcache->numresults; j++) {
+      for (j = 0; j < lp->resultcache->numresults; j++) {
         status = msLayerGetShape(lp, &shape, &(lp->resultcache->results[j]));
-        if(status != MS_SUCCESS) {
+        if (status != MS_SUCCESS) {
           msGMLFreeGroups(groupList);
           msGMLFreeConstants(constantList);
           msGMLFreeItems(itemList);
           msGMLFreeGeometries(geometryList);
           msProjectDestroyReprojector(reprojector);
           msFree(pszOutputSRS);
-          if(stream_to_free != NULL) fclose(stream_to_free);
+          if (stream_to_free != NULL)
+            fclose(stream_to_free);
           return MS_FAILURE;
         }
 
-        /* project the shape into the map projection (if necessary), note that this projects the bounds as well */
-        if(reprojector) {
+        /* project the shape into the map projection (if necessary), note that
+         * this projects the bounds as well */
+        if (reprojector) {
           status = msProjectShapeEx(reprojector, &shape);
-          if(status != MS_SUCCESS) {
-            msIO_fprintf(stream, "<!-- Warning: Failed to reproject shape: %s -->\n",msGetErrorString(","));
+          if (status != MS_SUCCESS) {
+            msIO_fprintf(stream,
+                         "<!-- Warning: Failed to reproject shape: %s -->\n",
+                         msGetErrorString(","));
             msFreeShape(&shape);
             continue;
           }
         }
 
         /* start this feature */
-        /* specify a feature name, if nothing provided fall back on the layer name + "_feature" */
-        value = (char*) msSmallMalloc(strlen(lp->name)+9);
+        /* specify a feature name, if nothing provided fall back on the layer
+         * name + "_feature" */
+        value = (char *)msSmallMalloc(strlen(lp->name) + 9);
         sprintf(value, "%s_feature", lp->name);
-        msOWSPrintValidateMetadata(stream, &(lp->metadata), namespaces, "featurename", OWS_NOERR, "\t\t<%s>\n", value);
+        msOWSPrintValidateMetadata(stream, &(lp->metadata), namespaces,
+                                   "featurename", OWS_NOERR, "\t\t<%s>\n",
+                                   value);
         msFree(value);
 
-        /* Write the feature geometry and bounding box unless 'none' was requested. */
-        /* Default to bbox only if nothing specified and output full geometry only if explicitly requested */
-        if(!(geometryList && geometryList->numgeometries == 1 && strcasecmp(geometryList->geometries[0].name, "none") == 0)) {
-          gmlWriteBounds(stream, OWS_GML2, &(shape.bounds), pszOutputSRS, "\t\t\t", "gml");
-          if (geometryList && geometryList->numgeometries > 0 )
-            gmlWriteGeometry(stream, geometryList, OWS_GML2, &(shape), pszOutputSRS, NULL, "\t\t\t", "", nSRSDimension, 6);
+        /* Write the feature geometry and bounding box unless 'none' was
+         * requested. */
+        /* Default to bbox only if nothing specified and output full geometry
+         * only if explicitly requested */
+        if (!(geometryList && geometryList->numgeometries == 1 &&
+              strcasecmp(geometryList->geometries[0].name, "none") == 0)) {
+          gmlWriteBounds(stream, OWS_GML2, &(shape.bounds), pszOutputSRS,
+                         "\t\t\t", "gml");
+          if (geometryList && geometryList->numgeometries > 0)
+            gmlWriteGeometry(stream, geometryList, OWS_GML2, &(shape),
+                             pszOutputSRS, NULL, "\t\t\t", "", nSRSDimension,
+                             6);
         }
 
         /* write any item/values */
-        for(k=0; k<itemList->numitems; k++) {
+        for (k = 0; k < itemList->numitems; k++) {
           item = &(itemList->items[k]);
-          if(msItemInGroups(item->name, groupList) == MS_FALSE)
-            msGMLWriteItem(stream, item, shape.values[k], NULL, "\t\t\t", OWS_GML2, NULL);
+          if (msItemInGroups(item->name, groupList) == MS_FALSE)
+            msGMLWriteItem(stream, item, shape.values[k], NULL, "\t\t\t",
+                           OWS_GML2, NULL);
         }
 
         /* write any constants */
-        for(k=0; k<constantList->numconstants; k++) {
+        for (k = 0; k < constantList->numconstants; k++) {
           constant = &(constantList->constants[k]);
-          if(msItemInGroups(constant->name, groupList) == MS_FALSE)
+          if (msItemInGroups(constant->name, groupList) == MS_FALSE)
             msGMLWriteConstant(stream, constant, NULL, "\t\t\t");
         }
 
         /* write any groups */
-        for(k=0; k<groupList->numgroups; k++)
-          msGMLWriteGroup(stream, &(groupList->groups[k]), &shape, itemList, constantList, NULL, "\t\t\t", OWS_GML2, NULL);
+        for (k = 0; k < groupList->numgroups; k++)
+          msGMLWriteGroup(stream, &(groupList->groups[k]), &shape, itemList,
+                          constantList, NULL, "\t\t\t", OWS_GML2, NULL);
 
         /* end this feature */
         /* specify a feature name if nothing provided */
         /* fall back on the layer name + "Feature" */
-        value = (char*) msSmallMalloc(strlen(lp->name)+9);
+        value = (char *)msSmallMalloc(strlen(lp->name) + 9);
         sprintf(value, "%s_feature", lp->name);
-        msOWSPrintValidateMetadata(stream, &(lp->metadata), namespaces, "featurename", OWS_NOERR, "\t\t</%s>\n", value);
+        msOWSPrintValidateMetadata(stream, &(lp->metadata), namespaces,
+                                   "featurename", OWS_NOERR, "\t\t</%s>\n",
+                                   value);
         msFree(value);
 
         msFreeShape(&shape); /* init too */
@@ -1550,9 +1798,10 @@ int msGMLWriteQuery(mapObj *map, char *f
 
       /* end this collection (layer) */
       /* if no layer name provided fall back on the layer name + "_layer" */
-      value = (char*) msSmallMalloc(strlen(lp->name)+7);
+      value = (char *)msSmallMalloc(strlen(lp->name) + 7);
       sprintf(value, "%s_layer", lp->name);
-      msOWSPrintValidateMetadata(stream, &(lp->metadata), namespaces, "layername", OWS_NOERR, "\t</%s>\n", value);
+      msOWSPrintValidateMetadata(stream, &(lp->metadata), namespaces,
+                                 "layername", OWS_NOERR, "\t</%s>\n", value);
       msFree(value);
 
       msGMLFreeGroups(groupList);
@@ -1562,18 +1811,20 @@ int msGMLWriteQuery(mapObj *map, char *f
 
       /* msLayerClose(lp); */
     }
-    if(pszOutputSRS!=pszMapSRS) {
+    if (pszOutputSRS != pszMapSRS) {
       msFree(pszOutputSRS);
     }
   } /* next layer */
 
   /* end this document */
-  msOWSPrintValidateMetadata(stream, &(map->web.metadata), namespaces, "rootname", OWS_NOERR, "</%s>\n", "msGMLOutput");
+  msOWSPrintValidateMetadata(stream, &(map->web.metadata), namespaces,
+                             "rootname", OWS_NOERR, "</%s>\n", "msGMLOutput");
 
-  if(stream_to_free != NULL) fclose(stream_to_free);
+  if (stream_to_free != NULL)
+    fclose(stream_to_free);
   msFree(pszMapSRS);
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 
 #else /* Stub for mapscript */
   msSetError(MS_MISCERR, "WMS server support not enabled", "msGMLWriteQuery()");
@@ -1583,39 +1834,37 @@ int msGMLWriteQuery(mapObj *map, char *f
 
 #ifdef USE_WFS_SVR
 void msGMLWriteWFSBounds(mapObj *map, FILE *stream, const char *tab,
-                         OWSGMLVersion outputformat, int nWFSVersion, int bUseURN)
-{
-  rectObj  resultBounds = {-1.0,-1.0,-1.0,-1.0};
+                         OWSGMLVersion outputformat, int nWFSVersion,
+                         int bUseURN) {
+  rectObj resultBounds = {-1.0, -1.0, -1.0, -1.0};
 
   /*add a check to see if the map projection is set to be north-east*/
   int bSwapAxis = msIsAxisInvertedProj(&(map->projection));
 
   /* Need to start with BBOX of the whole resultset */
   if (msGetQueryResultBounds(map, &resultBounds) > 0) {
-    char* srs = NULL;
+    char *srs = NULL;
     if (bSwapAxis) {
       double tmp;
 
       tmp = resultBounds.minx;
-      resultBounds.minx =  resultBounds.miny;
+      resultBounds.minx = resultBounds.miny;
       resultBounds.miny = tmp;
 
       tmp = resultBounds.maxx;
-      resultBounds.maxx =  resultBounds.maxy;
+      resultBounds.maxx = resultBounds.maxy;
       resultBounds.maxy = tmp;
-
-    }
-    if( bUseURN )
-    {
-        srs = msOWSGetProjURN(&(map->projection), NULL, "FGO", MS_TRUE);
-        if (!srs)
-            srs = msOWSGetProjURN(&(map->projection), &(map->web.metadata), "FGO", MS_TRUE);
     }
-    else
-    {
-        msOWSGetEPSGProj(&(map->projection), NULL, "FGO", MS_TRUE, &srs);
-        if (!srs)
-            msOWSGetEPSGProj(&(map->projection), &(map->web.metadata), "FGO", MS_TRUE, &srs);
+    if (bUseURN) {
+      srs = msOWSGetProjURN(&(map->projection), NULL, "FGO", MS_TRUE);
+      if (!srs)
+        srs = msOWSGetProjURN(&(map->projection), &(map->web.metadata), "FGO",
+                              MS_TRUE);
+    } else {
+      msOWSGetEPSGProj(&(map->projection), NULL, "FGO", MS_TRUE, &srs);
+      if (!srs)
+        msOWSGetEPSGProj(&(map->projection), &(map->web.metadata), "FGO",
+                         MS_TRUE, &srs);
     }
 
     gmlWriteBounds(stream, outputformat, &resultBounds, srs, tab,
@@ -1631,24 +1880,24 @@ void msGMLWriteWFSBounds(mapObj *map, FI
 **
 ** Similar to msGMLWriteQuery() but tuned for use with WFS
 */
-int msGMLWriteWFSQuery(mapObj *map, FILE *stream, const char *default_namespace_prefix,
+int msGMLWriteWFSQuery(mapObj *map, FILE *stream,
+                       const char *default_namespace_prefix,
                        OWSGMLVersion outputformat, int nWFSVersion, int bUseURN,
-                       int bGetPropertyValueRequest)
-{
+                       int bGetPropertyValueRequest) {
 #ifdef USE_WFS_SVR
   int status;
-  int i,j,k;
-  layerObj *lp=NULL;
+  int i, j, k;
+  layerObj *lp = NULL;
   shapeObj shape;
 
-  gmlGroupListObj *groupList=NULL;
-  gmlItemListObj *itemList=NULL;
-  gmlConstantListObj *constantList=NULL;
-  gmlGeometryListObj *geometryList=NULL;
-  gmlItemObj *item=NULL;
-  gmlConstantObj *constant=NULL;
+  gmlGroupListObj *groupList = NULL;
+  gmlItemListObj *itemList = NULL;
+  gmlConstantListObj *constantList = NULL;
+  gmlGeometryListObj *geometryList = NULL;
+  gmlItemObj *item = NULL;
+  gmlConstantObj *constant = NULL;
 
-  const char *namespace_prefix=NULL;
+  const char *namespace_prefix = NULL;
   int bSwapAxis;
 
   msInitShape(&shape);
@@ -1658,218 +1907,240 @@ int msGMLWriteWFSQuery(mapObj *map, FILE
 
   /* Need to start with BBOX of the whole resultset */
   if (!bGetPropertyValueRequest) {
-    msGMLWriteWFSBounds(map, stream, "      ", outputformat, nWFSVersion, bUseURN);
+    msGMLWriteWFSBounds(map, stream, "      ", outputformat, nWFSVersion,
+                        bUseURN);
   }
   /* step through the layers looking for query results */
-  for(i=0; i<map->numlayers; i++) {
+  for (i = 0; i < map->numlayers; i++) {
 
     lp = GET_LAYER(map, map->layerorder[i]);
 
-    if(lp->resultcache && lp->resultcache->numresults > 0)  { /* found results */
+    if (lp->resultcache &&
+        lp->resultcache->numresults > 0) { /* found results */
       char *layerName;
       const char *value;
-      int featureIdIndex=-1; /* no feature id */
-      char* srs = NULL;
+      int featureIdIndex = -1; /* no feature id */
+      char *srs = NULL;
       int bOutputGMLIdOnly = MS_FALSE;
       int nSRSDimension = 2;
-      const char* geomtype;
-      reprojectionObj* reprojector = NULL;
+      const char *geomtype;
+      reprojectionObj *reprojector = NULL;
       int geometry_precision = 6;
 
       /* setup namespace, a layer can override the default */
-      namespace_prefix = msOWSLookupMetadata(&(lp->metadata), "OFG", "namespace_prefix");
-      if(!namespace_prefix) namespace_prefix = default_namespace_prefix;
+      namespace_prefix =
+          msOWSLookupMetadata(&(lp->metadata), "OFG", "namespace_prefix");
+      if (!namespace_prefix)
+        namespace_prefix = default_namespace_prefix;
 
       geomtype = msOWSLookupMetadata(&(lp->metadata), "OFG", "geomtype");
-      if( geomtype != NULL && (strstr(geomtype, "25d") != NULL || strstr(geomtype, "25D") != NULL) )
-      {
-          nSRSDimension = 3;
+      if (geomtype != NULL && (strstr(geomtype, "25d") != NULL ||
+                               strstr(geomtype, "25D") != NULL)) {
+        nSRSDimension = 3;
       }
 
       value = msOWSLookupMetadata(&(lp->metadata), "OFG", "featureid");
-      if(value) { /* find the featureid amongst the items for this layer */
-        for(j=0; j<lp->numitems; j++) {
-          if(strcasecmp(lp->items[j], value) == 0) { /* found it */
+      if (value) { /* find the featureid amongst the items for this layer */
+        for (j = 0; j < lp->numitems; j++) {
+          if (strcasecmp(lp->items[j], value) == 0) { /* found it */
             featureIdIndex = j;
             break;
           }
         }
 
-        /* Produce a warning if a featureid was set but the corresponding item is not found. */
+        /* Produce a warning if a featureid was set but the corresponding item
+         * is not found. */
         if (featureIdIndex == -1)
-          msIO_fprintf(stream, "<!-- WARNING: FeatureId item '%s' not found in typename '%s'. -->\n", value, lp->name);
-      }
-      else if( outputformat == OWS_GML32 )
-          msIO_fprintf(stream, "<!-- WARNING: No featureid defined for typename '%s'. Output will not validate. -->\n", lp->name);
+          msIO_fprintf(stream,
+                       "<!-- WARNING: FeatureId item '%s' not found in "
+                       "typename '%s'. -->\n",
+                       value, lp->name);
+      } else if (outputformat == OWS_GML32)
+        msIO_fprintf(stream,
+                     "<!-- WARNING: No featureid defined for typename '%s'. "
+                     "Output will not validate. -->\n",
+                     lp->name);
 
       /* populate item and group metadata structures */
       itemList = msGMLGetItems(lp, "G");
       constantList = msGMLGetConstants(lp, "G");
       groupList = msGMLGetGroups(lp, "G");
       geometryList = msGMLGetGeometries(lp, "GFO", MS_FALSE);
-      if (itemList == NULL || constantList == NULL || groupList == NULL || geometryList == NULL) {
-        msSetError(MS_MISCERR, "Unable to populate item and group metadata structures", "msGMLWriteWFSQuery()");
+      if (itemList == NULL || constantList == NULL || groupList == NULL ||
+          geometryList == NULL) {
+        msSetError(MS_MISCERR,
+                   "Unable to populate item and group metadata structures",
+                   "msGMLWriteWFSQuery()");
         return MS_FAILURE;
       }
 
-      if( bGetPropertyValueRequest )
-      {
-        const char* value = msOWSLookupMetadata(&(lp->metadata), "G", "include_items");
-        if( value != NULL && strcmp(value, "@gml:id") == 0 )
-            bOutputGMLIdOnly = MS_TRUE;
+      if (bGetPropertyValueRequest) {
+        const char *value =
+            msOWSLookupMetadata(&(lp->metadata), "G", "include_items");
+        if (value != NULL && strcmp(value, "@gml:id") == 0)
+          bOutputGMLIdOnly = MS_TRUE;
       }
 
       if (namespace_prefix) {
-        layerName = (char *) msSmallMalloc(strlen(namespace_prefix)+strlen(lp->name)+2);
+        layerName = (char *)msSmallMalloc(strlen(namespace_prefix) +
+                                          strlen(lp->name) + 2);
         sprintf(layerName, "%s:%s", namespace_prefix, lp->name);
       } else {
         layerName = msStrdup(lp->name);
       }
 
-      if( bUseURN )
-      {
-          srs = msOWSGetProjURN(&(map->projection), NULL, "FGO", MS_TRUE);
-          if (!srs)
-            srs = msOWSGetProjURN(&(map->projection), &(map->web.metadata), "FGO", MS_TRUE);
-          if (!srs)
-            srs = msOWSGetProjURN(&(lp->projection), &(lp->metadata), "FGO", MS_TRUE);
-      }
-      else
-      {
-          msOWSGetEPSGProj(&(map->projection), NULL, "FGO", MS_TRUE, &srs);
-          if (!srs)
-            msOWSGetEPSGProj(&(map->projection), &(map->web.metadata), "FGO", MS_TRUE, &srs);
-          if (!srs)
-            msOWSGetEPSGProj(&(lp->projection), &(lp->metadata), "FGO", MS_TRUE, &srs);
-      }
-
-      if(msProjectionsDiffer(&(lp->projection), &(map->projection))) {
-        reprojector = msProjectCreateReprojector(&(lp->projection), &(map->projection));
-        if( reprojector == NULL ) {
-           msGMLFreeGroups(groupList);
-           msGMLFreeConstants(constantList);
-           msGMLFreeItems(itemList);
-           msGMLFreeGeometries(geometryList);
-           msFree(layerName);
-           msFree(srs);
-           return MS_FAILURE;
-        }
+      if (bUseURN) {
+        srs = msOWSGetProjURN(&(map->projection), NULL, "FGO", MS_TRUE);
+        if (!srs)
+          srs = msOWSGetProjURN(&(map->projection), &(map->web.metadata), "FGO",
+                                MS_TRUE);
+        if (!srs)
+          srs = msOWSGetProjURN(&(lp->projection), &(lp->metadata), "FGO",
+                                MS_TRUE);
+      } else {
+        msOWSGetEPSGProj(&(map->projection), NULL, "FGO", MS_TRUE, &srs);
+        if (!srs)
+          msOWSGetEPSGProj(&(map->projection), &(map->web.metadata), "FGO",
+                           MS_TRUE, &srs);
+        if (!srs)
+          msOWSGetEPSGProj(&(lp->projection), &(lp->metadata), "FGO", MS_TRUE,
+                           &srs);
       }
 
-      for(j=0; j<lp->resultcache->numresults; j++) {
-        char* pszFID;
-
-        if( lp->resultcache->results[j].shape )
-        {
-            /* msDebug("Using cached shape %ld\n", lp->resultcache->results[j].shapeindex); */
-            msCopyShape(lp->resultcache->results[j].shape, &shape);
-        }
-        else
-        {
-            status = msLayerGetShape(lp, &shape, &(lp->resultcache->results[j]));
-            if(status != MS_SUCCESS) {
-                msGMLFreeGroups(groupList);
-                msGMLFreeConstants(constantList);
-                msGMLFreeItems(itemList);
-                msGMLFreeGeometries(geometryList);
-                msFree(layerName);
-                msProjectDestroyReprojector(reprojector);
-                msFree(srs);
-                return(status);
-            }
+      if (msProjectionsDiffer(&(lp->projection), &(map->projection))) {
+        reprojector =
+            msProjectCreateReprojector(&(lp->projection), &(map->projection));
+        if (reprojector == NULL) {
+          msGMLFreeGroups(groupList);
+          msGMLFreeConstants(constantList);
+          msGMLFreeItems(itemList);
+          msGMLFreeGeometries(geometryList);
+          msFree(layerName);
+          msFree(srs);
+          return MS_FAILURE;
         }
+      }
 
-        /* project the shape into the map projection (if necessary), note that this projects the bounds as well */
-        if(reprojector)
-          msProjectShapeEx(reprojector, &shape);
+      for (j = 0; j < lp->resultcache->numresults; j++) {
+        char *pszFID;
 
-        if(featureIdIndex != -1) {
-            pszFID = (char*) msSmallMalloc( strlen(lp->name) + 1 + strlen(shape.values[featureIdIndex]) + 1 );
-            sprintf(pszFID, "%s.%s", lp->name, shape.values[featureIdIndex]);
+        if (lp->resultcache->results[j].shape) {
+          /* msDebug("Using cached shape %ld\n",
+           * lp->resultcache->results[j].shapeindex); */
+          msCopyShape(lp->resultcache->results[j].shape, &shape);
+        } else {
+          status = msLayerGetShape(lp, &shape, &(lp->resultcache->results[j]));
+          if (status != MS_SUCCESS) {
+            msGMLFreeGroups(groupList);
+            msGMLFreeConstants(constantList);
+            msGMLFreeItems(itemList);
+            msGMLFreeGeometries(geometryList);
+            msFree(layerName);
+            msProjectDestroyReprojector(reprojector);
+            msFree(srs);
+            return (status);
+          }
         }
-        else
-            pszFID = msStrdup("");
 
+        /* project the shape into the map projection (if necessary), note that
+         * this projects the bounds as well */
+        if (reprojector)
+          msProjectShapeEx(reprojector, &shape);
 
-        if( bOutputGMLIdOnly )
-        {
-            msIO_fprintf(stream, "    <wfs:member>%s</wfs:member>\n", pszFID);
-            msFree(pszFID);
-            msFreeShape(&shape); /* init too */
-            continue;
+        if (featureIdIndex != -1) {
+          pszFID = (char *)msSmallMalloc(
+              strlen(lp->name) + 1 + strlen(shape.values[featureIdIndex]) + 1);
+          sprintf(pszFID, "%s.%s", lp->name, shape.values[featureIdIndex]);
+        } else
+          pszFID = msStrdup("");
+
+        if (bOutputGMLIdOnly) {
+          msIO_fprintf(stream, "    <wfs:member>%s</wfs:member>\n", pszFID);
+          msFree(pszFID);
+          msFreeShape(&shape); /* init too */
+          continue;
         }
 
         /*
         ** start this feature
         */
-        if( nWFSVersion == OWS_2_0_0 )
-            msIO_fprintf(stream, "    <wfs:member>\n");
+        if (nWFSVersion == OWS_2_0_0)
+          msIO_fprintf(stream, "    <wfs:member>\n");
         else
-            msIO_fprintf(stream, "    <gml:featureMember>\n");
-        if(msIsXMLTagValid(layerName) == MS_FALSE)
-            msIO_fprintf(stream, "<!-- WARNING: The value '%s' is not valid in a XML tag context. -->\n", layerName);
-        if(featureIdIndex != -1) {
-            if( !bGetPropertyValueRequest )
-            {
-                if(outputformat == OWS_GML2)
-                    msIO_fprintf(stream, "      <%s fid=\"%s\">\n", layerName, pszFID);
-                else  /* OWS_GML3 or OWS_GML32 */
-                    msIO_fprintf(stream, "      <%s gml:id=\"%s\">\n", layerName, pszFID);
-            }
+          msIO_fprintf(stream, "    <gml:featureMember>\n");
+        if (msIsXMLTagValid(layerName) == MS_FALSE)
+          msIO_fprintf(stream,
+                       "<!-- WARNING: The value '%s' is not valid in a XML tag "
+                       "context. -->\n",
+                       layerName);
+        if (featureIdIndex != -1) {
+          if (!bGetPropertyValueRequest) {
+            if (outputformat == OWS_GML2)
+              msIO_fprintf(stream, "      <%s fid=\"%s\">\n", layerName,
+                           pszFID);
+            else /* OWS_GML3 or OWS_GML32 */
+              msIO_fprintf(stream, "      <%s gml:id=\"%s\">\n", layerName,
+                           pszFID);
+          }
         } else {
-            if( !bGetPropertyValueRequest )
-                msIO_fprintf(stream, "      <%s>\n", layerName);
+          if (!bGetPropertyValueRequest)
+            msIO_fprintf(stream, "      <%s>\n", layerName);
         }
 
         if (bSwapAxis)
           msAxisSwapShape(&shape);
 
         /* write the feature geometry and bounding box */
-        if(!(geometryList && geometryList->numgeometries == 1 &&
-            strcasecmp(geometryList->geometries[0].name, "none") == 0)) {
-          if( !bGetPropertyValueRequest )
-            gmlWriteBounds(stream, outputformat, &(shape.bounds), srs, "        ", "gml");
-        
-          if(msOWSLookupMetadata(&(lp->metadata), "F", "geometry_precision")){
-            geometry_precision=atoi(msOWSLookupMetadata(&(lp->metadata), "F", "geometry_precision"));
-          } else if(msOWSLookupMetadata(&map->web.metadata, "F", "geometry_precision")){
-            geometry_precision=atoi(msOWSLookupMetadata(&map->web.metadata, "F", "geometry_precision"));
+        if (!(geometryList && geometryList->numgeometries == 1 &&
+              strcasecmp(geometryList->geometries[0].name, "none") == 0)) {
+          if (!bGetPropertyValueRequest)
+            gmlWriteBounds(stream, outputformat, &(shape.bounds), srs,
+                           "        ", "gml");
+
+          if (msOWSLookupMetadata(&(lp->metadata), "F", "geometry_precision")) {
+            geometry_precision = atoi(msOWSLookupMetadata(
+                &(lp->metadata), "F", "geometry_precision"));
+          } else if (msOWSLookupMetadata(&map->web.metadata, "F",
+                                         "geometry_precision")) {
+            geometry_precision = atoi(msOWSLookupMetadata(
+                &map->web.metadata, "F", "geometry_precision"));
           }
 
           gmlWriteGeometry(stream, geometryList, outputformat, &(shape), srs,
-                           namespace_prefix, "        ", pszFID, nSRSDimension,geometry_precision);
+                           namespace_prefix, "        ", pszFID, nSRSDimension,
+                           geometry_precision);
         }
 
         /* write any item/values */
-        for(k=0; k<itemList->numitems; k++) {
+        for (k = 0; k < itemList->numitems; k++) {
           item = &(itemList->items[k]);
-          if(msItemInGroups(item->name, groupList) == MS_FALSE)
+          if (msItemInGroups(item->name, groupList) == MS_FALSE)
             msGMLWriteItem(stream, item, shape.values[k], namespace_prefix,
                            "        ", outputformat, pszFID);
         }
 
         /* write any constants */
-        for(k=0; k<constantList->numconstants; k++) {
+        for (k = 0; k < constantList->numconstants; k++) {
           constant = &(constantList->constants[k]);
-          if(msItemInGroups(constant->name, groupList) == MS_FALSE)
+          if (msItemInGroups(constant->name, groupList) == MS_FALSE)
             msGMLWriteConstant(stream, constant, namespace_prefix, "        ");
         }
 
         /* write any groups */
-        for(k=0; k<groupList->numgroups; k++)
+        for (k = 0; k < groupList->numgroups; k++)
           msGMLWriteGroup(stream, &(groupList->groups[k]), &shape, itemList,
-                          constantList, namespace_prefix, "        ", outputformat, pszFID);
+                          constantList, namespace_prefix, "        ",
+                          outputformat, pszFID);
 
-        if( !bGetPropertyValueRequest )
-            /* end this feature */
-            msIO_fprintf(stream, "      </%s>\n", layerName);
+        if (!bGetPropertyValueRequest)
+          /* end this feature */
+          msIO_fprintf(stream, "      </%s>\n", layerName);
 
-        if( nWFSVersion == OWS_2_0_0 )
+        if (nWFSVersion == OWS_2_0_0)
           msIO_fprintf(stream, "    </wfs:member>\n");
         else
           msIO_fprintf(stream, "    </gml:featureMember>\n");
 
-
         msFree(pszFID);
         pszFID = NULL;
         msFreeShape(&shape); /* init too */
@@ -1892,15 +2163,15 @@ int msGMLWriteWFSQuery(mapObj *map, FILE
 
   } /* next layer */
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 
-#else /* Stub for mapscript */
-  msSetError(MS_MISCERR, "WFS server support not enabled", "msGMLWriteWFSQuery()");
+#else  /* Stub for mapscript */
+  msSetError(MS_MISCERR, "WFS server support not enabled",
+             "msGMLWriteWFSQuery()");
   return MS_FAILURE;
 #endif /* USE_WFS_SVR */
 }
 
-
 #ifdef USE_LIBXML2
 
 /**
@@ -1920,8 +2191,8 @@ int msGMLWriteWFSQuery(mapObj *map, FILE
  *
  */
 
-xmlNodePtr msGML3BoundedBy(xmlNsPtr psNs, double minx, double miny, double maxx, double maxy, const char *psEpsg)
-{
+xmlNodePtr msGML3BoundedBy(xmlNsPtr psNs, double minx, double miny, double maxx,
+                           double maxy, const char *psEpsg) {
   xmlNodePtr psNode = NULL, psSubNode = NULL;
   char *pszTmp = NULL;
   char *pszTmp2 = NULL;
@@ -1931,8 +2202,8 @@ xmlNodePtr msGML3BoundedBy(xmlNsPtr psNs
   psSubNode = xmlNewChild(psNode, NULL, BAD_CAST "Envelope", NULL);
 
   if (psEpsg) {
-    const size_t bufferSize = strlen(psEpsg)+1;
-    pszEpsg = (char*) msSmallMalloc(bufferSize);
+    const size_t bufferSize = strlen(psEpsg) + 1;
+    pszEpsg = (char *)msSmallMalloc(bufferSize);
     snprintf(pszEpsg, bufferSize, "%s", psEpsg);
     msStringToLower(pszEpsg);
     pszTmp = msStringConcatenate(pszTmp, "urn:ogc:crs:");
@@ -1955,7 +2226,7 @@ xmlNodePtr msGML3BoundedBy(xmlNsPtr psNs
 
   pszTmp = msDoubleToString(maxx, MS_TRUE);
   pszTmp = msStringConcatenate(pszTmp, " ");
-  pszTmp2 = msDoubleToString(maxy,MS_TRUE);
+  pszTmp2 = msDoubleToString(maxy, MS_TRUE);
   pszTmp = msStringConcatenate(pszTmp, pszTmp2);
   xmlNewChild(psSubNode, NULL, BAD_CAST "upperCorner", BAD_CAST pszTmp);
   free(pszTmp);
@@ -1979,9 +2250,9 @@ xmlNodePtr msGML3BoundedBy(xmlNsPtr psNs
  *
  */
 
-xmlNodePtr msGML3Point(xmlNsPtr psNs, const char *psSrsName, const char *id, double x, double y)
-{
-  
+xmlNodePtr msGML3Point(xmlNsPtr psNs, const char *psSrsName, const char *id,
+                       double x, double y) {
+
   xmlNodePtr psNode = xmlNewNode(psNs, BAD_CAST "Point");
 
   if (id) {
@@ -1989,8 +2260,8 @@ xmlNodePtr msGML3Point(xmlNsPtr psNs, co
   }
 
   if (psSrsName) {
-    const size_t bufferSize = strlen(psSrsName)+1;
-    char* pszSrsName = (char *) msSmallMalloc(bufferSize);
+    const size_t bufferSize = strlen(psSrsName) + 1;
+    char *pszSrsName = (char *)msSmallMalloc(bufferSize);
     snprintf(pszSrsName, bufferSize, "%s", psSrsName);
     msStringToLower(pszSrsName);
     char *pszTmp = NULL;
@@ -2005,9 +2276,9 @@ xmlNodePtr msGML3Point(xmlNsPtr psNs, co
     free(pszTmp);
   }
 
-  char* pszTmp = msDoubleToString(x, MS_TRUE);
+  char *pszTmp = msDoubleToString(x, MS_TRUE);
   pszTmp = msStringConcatenate(pszTmp, " ");
-  char* pszTmp2 = msDoubleToString(y, MS_TRUE);
+  char *pszTmp2 = msDoubleToString(y, MS_TRUE);
   pszTmp = msStringConcatenate(pszTmp, pszTmp2);
   xmlNewChild(psNode, NULL, BAD_CAST "pos", BAD_CAST pszTmp);
 
@@ -2029,9 +2300,8 @@ xmlNodePtr msGML3Point(xmlNsPtr psNs, co
  *
  */
 
-xmlNodePtr msGML3TimePeriod(xmlNsPtr psNs, char *pszStart, char *pszEnd)
-{
-  xmlNodePtr psNode=NULL;
+xmlNodePtr msGML3TimePeriod(xmlNsPtr psNs, char *pszStart, char *pszEnd) {
+  xmlNodePtr psNode = NULL;
 
   psNode = xmlNewNode(psNs, BAD_CAST "TimePeriod");
   xmlNewChild(psNode, NULL, BAD_CAST "beginPosition", BAD_CAST pszStart);
@@ -2056,9 +2326,8 @@ xmlNodePtr msGML3TimePeriod(xmlNsPtr psN
  *
  */
 
-xmlNodePtr msGML3TimeInstant(xmlNsPtr psNs, char *pszTime)
-{
-  xmlNodePtr psNode=NULL;
+xmlNodePtr msGML3TimeInstant(xmlNsPtr psNs, char *pszTime) {
+  xmlNodePtr psNode = NULL;
 
   psNode = xmlNewNode(psNs, BAD_CAST "TimeInstant");
   xmlNewChild(psNode, NULL, BAD_CAST "timePosition", BAD_CAST pszTime);
@@ -2067,83 +2336,93 @@ xmlNodePtr msGML3TimeInstant(xmlNsPtr ps
 
 #endif /* USE_LIBXML2 */
 
-
 /************************************************************************/
 /*      The following functions are enabled in all cases, even if       */
 /*      WMS and WFS are not available.                                  */
 /************************************************************************/
 
-gmlItemListObj *msGMLGetItems(layerObj *layer, const char *metadata_namespaces)
-{
-  int i,j;
+gmlItemListObj *msGMLGetItems(layerObj *layer,
+                              const char *metadata_namespaces) {
+  int i, j;
 
-  char **xmlitems=NULL;
-  int numxmlitems=0;
+  char **xmlitems = NULL;
+  int numxmlitems = 0;
 
-  char **incitems=NULL;
-  int numincitems=0;
+  char **incitems = NULL;
+  int numincitems = 0;
 
-  char **excitems=NULL;
-  int numexcitems=0;
+  char **excitems = NULL;
+  int numexcitems = 0;
 
-  char **optionalitems=NULL;
-  int numoptionalitems=0;
+  char **optionalitems = NULL;
+  int numoptionalitems = 0;
 
-  char **mandatoryitems=NULL;
-  int nummandatoryitems=0;
+  char **mandatoryitems = NULL;
+  int nummandatoryitems = 0;
 
-  char **defaultitems=NULL;
-  int numdefaultitems=0;
+  char **defaultitems = NULL;
+  int numdefaultitems = 0;
 
-  const char *value=NULL;
+  const char *value = NULL;
   char tag[64];
 
-  gmlItemListObj *itemList=NULL;
-  gmlItemObj *item=NULL;
+  gmlItemListObj *itemList = NULL;
+  gmlItemObj *item = NULL;
 
   /* get a list of items that might be included in output */
-  if((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces, "include_items")) != NULL)
+  if ((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces,
+                                   "include_items")) != NULL)
     incitems = msStringSplit(value, ',', &numincitems);
 
   /* get a list of items that should be excluded in output */
-  if((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces, "exclude_items")) != NULL)
+  if ((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces,
+                                   "exclude_items")) != NULL)
     excitems = msStringSplit(value, ',', &numexcitems);
 
   /* get a list of items that should not be XML encoded */
-  if((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces, "xml_items")) != NULL)
+  if ((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces,
+                                   "xml_items")) != NULL)
     xmlitems = msStringSplit(value, ',', &numxmlitems);
 
-  /* get a list of items that should be indicated as optional in DescribeFeatureType */
-  if((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces, "optional_items")) != NULL)
+  /* get a list of items that should be indicated as optional in
+   * DescribeFeatureType */
+  if ((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces,
+                                   "optional_items")) != NULL)
     optionalitems = msStringSplit(value, ',', &numoptionalitems);
 
-  /* get a list of items that should be indicated as mandatory in DescribeFeatureType */
-  if((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces, "mandatory_items")) != NULL)
+  /* get a list of items that should be indicated as mandatory in
+   * DescribeFeatureType */
+  if ((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces,
+                                   "mandatory_items")) != NULL)
     mandatoryitems = msStringSplit(value, ',', &nummandatoryitems);
 
   /* get a list of items that should be presented by default in GetFeature */
-  if((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces, "default_items")) != NULL)
+  if ((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces,
+                                   "default_items")) != NULL)
     defaultitems = msStringSplit(value, ',', &numdefaultitems);
 
   /* allocate memory and iinitialize the item collection */
-  itemList = (gmlItemListObj *) malloc(sizeof(gmlItemListObj));
-  if(itemList == NULL) {
-    msSetError(MS_MEMERR, "Error allocating a collection GML item structures.", "msGMLGetItems()");
+  itemList = (gmlItemListObj *)malloc(sizeof(gmlItemListObj));
+  if (itemList == NULL) {
+    msSetError(MS_MEMERR, "Error allocating a collection GML item structures.",
+               "msGMLGetItems()");
     return NULL;
   }
 
   itemList->numitems = layer->numitems;
-  itemList->items = (gmlItemObj *) malloc(sizeof(gmlItemObj)*itemList->numitems);
-  if(!itemList->items) {
-    msSetError(MS_MEMERR, "Error allocating a collection GML item structures.", "msGMLGetItems()");
+  itemList->items =
+      (gmlItemObj *)malloc(sizeof(gmlItemObj) * itemList->numitems);
+  if (!itemList->items) {
+    msSetError(MS_MEMERR, "Error allocating a collection GML item structures.",
+               "msGMLGetItems()");
     free(itemList);
     return NULL;
   }
 
-  for(i=0; i<layer->numitems; i++) {
+  for (i = 0; i < layer->numitems; i++) {
     item = &(itemList->items[i]);
 
-    item->name = msStrdup(layer->items[i]);  /* initialize the item */
+    item->name = msStrdup(layer->items[i]); /* initialize the item */
     item->alias = NULL;
     item->type = NULL;
     item->template = NULL;
@@ -2155,73 +2434,78 @@ gmlItemListObj *msGMLGetItems(layerObj *
     item->minOccurs = 0;
 
     /* check visibility, included items first... */
-    if(numincitems == 1 && strcasecmp("all", incitems[0]) == 0) {
+    if (numincitems == 1 && strcasecmp("all", incitems[0]) == 0) {
       item->visible = MS_TRUE;
     } else {
-      for(j=0; j<numincitems; j++) {
-        if(strcasecmp(layer->items[i], incitems[j]) == 0)
+      for (j = 0; j < numincitems; j++) {
+        if (strcasecmp(layer->items[i], incitems[j]) == 0)
           item->visible = MS_TRUE;
       }
     }
 
     /* ...and now excluded items */
-    for(j=0; j<numexcitems; j++) {
-      if(strcasecmp(layer->items[i], excitems[j]) == 0)
+    for (j = 0; j < numexcitems; j++) {
+      if (strcasecmp(layer->items[i], excitems[j]) == 0)
         item->visible = MS_FALSE;
     }
 
     /* check encoding */
-    for(j=0; j<numxmlitems; j++) {
-      if(strcasecmp(layer->items[i], xmlitems[j]) == 0)
+    for (j = 0; j < numxmlitems; j++) {
+      if (strcasecmp(layer->items[i], xmlitems[j]) == 0)
         item->encode = MS_FALSE;
     }
 
     /* check optional */
-    if(numoptionalitems == 1 && strcasecmp("all", optionalitems[0]) == 0) {
+    if (numoptionalitems == 1 && strcasecmp("all", optionalitems[0]) == 0) {
       item->minOccurs = 0;
-    } else if( numoptionalitems > 0) {
+    } else if (numoptionalitems > 0) {
       item->minOccurs = 1;
-      for(j=0; j<numoptionalitems; j++) {
-        if(strcasecmp(layer->items[i], optionalitems[j]) == 0)
+      for (j = 0; j < numoptionalitems; j++) {
+        if (strcasecmp(layer->items[i], optionalitems[j]) == 0)
           item->minOccurs = 0;
       }
     }
 
     /* check mandatory */
-    if(nummandatoryitems == 1 && strcasecmp("all", mandatoryitems[0]) == 0) {
+    if (nummandatoryitems == 1 && strcasecmp("all", mandatoryitems[0]) == 0) {
       item->minOccurs = 1;
-    } else if( nummandatoryitems > 0) {
+    } else if (nummandatoryitems > 0) {
       item->minOccurs = 0;
-      for(j=0; j<nummandatoryitems; j++) {
-        if(strcasecmp(layer->items[i], mandatoryitems[j]) == 0)
+      for (j = 0; j < nummandatoryitems; j++) {
+        if (strcasecmp(layer->items[i], mandatoryitems[j]) == 0)
           item->minOccurs = 1;
       }
     }
 
     /* check default */
-    for(j=0; j<numdefaultitems; j++) {
-      if(strcasecmp(layer->items[i], defaultitems[j]) == 0)
+    for (j = 0; j < numdefaultitems; j++) {
+      if (strcasecmp(layer->items[i], defaultitems[j]) == 0)
         item->outputByDefault = 1;
     }
 
     snprintf(tag, sizeof(tag), "%s_alias", layer->items[i]);
-    if((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces, tag)) != NULL)
+    if ((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces,
+                                     tag)) != NULL)
       item->alias = msStrdup(value);
 
     snprintf(tag, sizeof(tag), "%s_type", layer->items[i]);
-    if((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces, tag)) != NULL)
+    if ((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces,
+                                     tag)) != NULL)
       item->type = msStrdup(value);
 
     snprintf(tag, sizeof(tag), "%s_template", layer->items[i]);
-    if((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces, tag)) != NULL)
+    if ((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces,
+                                     tag)) != NULL)
       item->template = msStrdup(value);
 
     snprintf(tag, sizeof(tag), "%s_width", layer->items[i]);
-    if((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces, tag)) != NULL)
+    if ((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces,
+                                     tag)) != NULL)
       item->width = atoi(value);
 
     snprintf(tag, sizeof(tag), "%s_precision", layer->items[i]);
-    if((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces, tag)) != NULL)
+    if ((value = msOWSLookupMetadata(&(layer->metadata), metadata_namespaces,
+                                     tag)) != NULL)
       item->precision = atoi(value);
   }
 
@@ -2235,20 +2519,20 @@ gmlItemListObj *msGMLGetItems(layerObj *
   return itemList;
 }
 
-void msGMLFreeItems(gmlItemListObj *itemList)
-{
+void msGMLFreeItems(gmlItemListObj *itemList) {
   int i;
 
-  if(!itemList) return;
+  if (!itemList)
+    return;
 
-  for(i=0; i<itemList->numitems; i++) {
+  for (i = 0; i < itemList->numitems; i++) {
     msFree(itemList->items[i].name);
     msFree(itemList->items[i].alias);
     msFree(itemList->items[i].type);
     msFree(itemList->items[i].template);
   }
 
-  if( itemList->items != NULL )
+  if (itemList->items != NULL)
     free(itemList->items);
 
   free(itemList);
diff -pruN 8.0.1-5/mapgml.h 8.0.2-1/mapgml.h
--- 8.0.1-5/mapgml.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapgml.h	2024-06-11 20:41:34.000000000 +0000
@@ -28,18 +28,19 @@
  * DEALINGS IN THE SOFTWARE.
  ****************************************************************************/
 
-
 #ifndef MAPGML_H
 #define MAPGML_H
 
 #ifdef USE_LIBXML2
-#include<libxml/parser.h>
-#include<libxml/tree.h>
+#include <libxml/parser.h>
+#include <libxml/tree.h>
 
-xmlNodePtr msGML3BoundedBy(xmlNsPtr psNs, double minx, double miny, double maxx, double maxy, const char *psEpsg);
+xmlNodePtr msGML3BoundedBy(xmlNsPtr psNs, double minx, double miny, double maxx,
+                           double maxy, const char *psEpsg);
 xmlNodePtr msGML3TimePeriod(xmlNsPtr psNs, char *pszStart, char *pszEnd);
 xmlNodePtr msGML3TimeInstant(xmlNsPtr psNs, char *timeInstant);
-xmlNodePtr msGML3Point(xmlNsPtr psNs, const char *psSrsName, const char *id, double x, double y);
+xmlNodePtr msGML3Point(xmlNsPtr psNs, const char *psSrsName, const char *id,
+                       double x, double y);
 
 #endif /* USE_LIBXML2 */
 
diff -pruN 8.0.1-5/mapgraph.cpp 8.0.2-1/mapgraph.cpp
--- 8.0.1-5/mapgraph.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapgraph.cpp	2024-06-11 20:41:34.000000000 +0000
@@ -31,17 +31,18 @@
 #include "mapgraph.h"
 #include <algorithm> // for std::swap
 
-graphObj *msCreateGraph(signed int numnodes)
-{
-  graphObj *graph=nullptr;
+graphObj *msCreateGraph(signed int numnodes) {
+  graphObj *graph = nullptr;
 
-  if(numnodes <= 0) return nullptr;
+  if (numnodes <= 0)
+    return nullptr;
 
-  graph = (graphObj *) malloc(sizeof(graphObj));
-  if(!graph) return nullptr;
+  graph = (graphObj *)malloc(sizeof(graphObj));
+  if (!graph)
+    return nullptr;
 
-  graph->head = (graphNodeObj **) calloc(numnodes, sizeof(graphNodeObj*));
-  if(!graph->head) {
+  graph->head = (graphNodeObj **)calloc(numnodes, sizeof(graphNodeObj *));
+  if (!graph->head) {
     free(graph);
     return nullptr;
   }
@@ -50,14 +51,14 @@ graphObj *msCreateGraph(signed int numno
   return graph;
 }
 
-void msFreeGraph(graphObj *graph)
-{
-  if(!graph) return;
-
-  graphNodeObj *tmp=nullptr;
-  
-  for(int i=0; i<graph->numnodes; i++) {
-    while(graph->head[i] != nullptr) {
+void msFreeGraph(graphObj *graph) {
+  if (!graph)
+    return;
+
+  graphNodeObj *tmp = nullptr;
+
+  for (int i = 0; i < graph->numnodes; i++) {
+    while (graph->head[i] != nullptr) {
       tmp = graph->head[i];
       graph->head[i] = graph->head[i]->next;
       free(tmp);
@@ -68,15 +69,16 @@ void msFreeGraph(graphObj *graph)
   free(graph);
 }
 
-int msGraphAddEdge(graphObj *graph, int src, int dest, double weight)
-{
-  graphNodeObj *node=nullptr;
+int msGraphAddEdge(graphObj *graph, int src, int dest, double weight) {
+  graphNodeObj *node = nullptr;
 
-  if(!graph) return MS_FAILURE;
+  if (!graph)
+    return MS_FAILURE;
 
   // src -> dest
-  node = (graphNodeObj *) malloc(sizeof(graphNodeObj));
-  if(!node) return MS_FAILURE;
+  node = (graphNodeObj *)malloc(sizeof(graphNodeObj));
+  if (!node)
+    return MS_FAILURE;
 
   node->dest = dest;
   node->weight = weight;
@@ -84,8 +86,9 @@ int msGraphAddEdge(graphObj *graph, int
   graph->head[src] = node;
 
   // dest -> src
-  node = (graphNodeObj *) malloc(sizeof(graphNodeObj));
-  if(!node) return MS_FAILURE;
+  node = (graphNodeObj *)malloc(sizeof(graphNodeObj));
+  if (!node)
+    return MS_FAILURE;
 
   node->dest = src;
   node->weight = weight;
@@ -95,15 +98,15 @@ int msGraphAddEdge(graphObj *graph, int
   return MS_SUCCESS;
 }
 
-void msPrintGraph(graphObj *graph)
-{
+void msPrintGraph(graphObj *graph) {
   int i;
 
-  if(!graph) return;
+  if (!graph)
+    return;
 
-  for(i=0; i<graph->numnodes; i++) {
+  for (i = 0; i < graph->numnodes; i++) {
     graphNodeObj *node = graph->head[i];
-    if(node != nullptr) {
+    if (node != nullptr) {
       do {
         msDebug("%d -> %d (%.6f)\t", i, node->dest, node->weight);
         node = node->next;
@@ -116,7 +119,8 @@ void msPrintGraph(graphObj *graph)
 /*
 ** Derived from an number web resources including:
 **
-**   https://www.geeksforgeeks.org/dijkstras-algorithm-for-adjacency-list-representation-greedy-algo-8/
+**
+*https://www.geeksforgeeks.org/dijkstras-algorithm-for-adjacency-list-representation-greedy-algo-8/
 **   https://youtube.com/watch?v=pSqmAO-m7Lk
 **   https://en.wikipedia.org/wiki/Dijkstra%27s_algorithm
 **
@@ -135,41 +139,42 @@ typedef struct {
   minHeapNodeObj **nodes;
 } minHeapObj;
 
-static minHeapNodeObj *newMinHeapNode(int idx, double dist)
-{
-  minHeapNodeObj *node = (minHeapNodeObj *) malloc(sizeof(minHeapNodeObj));
-  if(!node) return nullptr;
+static minHeapNodeObj *newMinHeapNode(int idx, double dist) {
+  minHeapNodeObj *node = (minHeapNodeObj *)malloc(sizeof(minHeapNodeObj));
+  if (!node)
+    return nullptr;
   node->idx = idx;
   node->dist = dist;
   return node;
 }
 
-static void freeMinHeap(minHeapObj *minHeap)
-{
-  if(!minHeap) return;
+static void freeMinHeap(minHeapObj *minHeap) {
+  if (!minHeap)
+    return;
 
   free(minHeap->pos);
-  for(int i=0; i<minHeap->size; i++) {
+  for (int i = 0; i < minHeap->size; i++) {
     free(minHeap->nodes[i]);
   }
   free(minHeap->nodes);
   free(minHeap);
 }
 
-static minHeapObj *createMinHeap(signed int capacity)
-{
-  minHeapObj *minHeap = (minHeapObj *) malloc(sizeof(minHeapObj));
-  if(!minHeap) return nullptr;
+static minHeapObj *createMinHeap(signed int capacity) {
+  minHeapObj *minHeap = (minHeapObj *)malloc(sizeof(minHeapObj));
+  if (!minHeap)
+    return nullptr;
 
-  minHeap->pos = (int *) malloc(capacity * sizeof(int));
-  if(!minHeap->pos) {
+  minHeap->pos = (int *)malloc(capacity * sizeof(int));
+  if (!minHeap->pos) {
     free(minHeap);
     return nullptr;
   }
   minHeap->size = 0;
   minHeap->capacity = capacity;
-  minHeap->nodes = (minHeapNodeObj **) malloc(capacity * sizeof(minHeapNodeObj *));
-  if(!minHeap->nodes) {
+  minHeap->nodes =
+      (minHeapNodeObj **)malloc(capacity * sizeof(minHeapNodeObj *));
+  if (!minHeap->nodes) {
     free(minHeap->pos);
     free(minHeap);
     return nullptr;
@@ -177,79 +182,75 @@ static minHeapObj *createMinHeap(signed
   return minHeap;
 }
 
-static void minHeapify(minHeapObj *minHeap, int idx)
-{
+static void minHeapify(minHeapObj *minHeap, int idx) {
   int smallest = idx;
-  const int left = 2*idx + 1;
-  const int right = 2*idx + 2;
- 
-  if (left < minHeap->size && minHeap->nodes[left]->dist < minHeap->nodes[smallest]->dist)
+  const int left = 2 * idx + 1;
+  const int right = 2 * idx + 2;
+
+  if (left < minHeap->size &&
+      minHeap->nodes[left]->dist < minHeap->nodes[smallest]->dist)
     smallest = left;
- 
-  if (right < minHeap->size && minHeap->nodes[right]->dist < minHeap->nodes[smallest]->dist)
+
+  if (right < minHeap->size &&
+      minHeap->nodes[right]->dist < minHeap->nodes[smallest]->dist)
     smallest = right;
- 
+
   if (smallest != idx) {
     minHeapNodeObj *smallestNode = minHeap->nodes[smallest];
     minHeapNodeObj *idxNode = minHeap->nodes[idx];
- 
+
     minHeap->pos[smallestNode->idx] = idx; // swap positions
     minHeap->pos[idxNode->idx] = smallest;
- 
+
     std::swap(minHeap->nodes[smallest], minHeap->nodes[idx]); // swap nodes
     minHeapify(minHeap, smallest);
   }
 }
 
-static bool isEmpty(const minHeapObj *minHeap)
-{
-  return minHeap->size == 0;
-}
+static bool isEmpty(const minHeapObj *minHeap) { return minHeap->size == 0; }
+
+static minHeapNodeObj *extractMin(minHeapObj *minHeap) {
+  if (isEmpty(minHeap))
+    return nullptr;
 
-static minHeapNodeObj *extractMin(minHeapObj *minHeap)
-{
-  if (isEmpty(minHeap)) return nullptr;
- 
   // store root node
   minHeapNodeObj *root = minHeap->nodes[0];
- 
+
   // replace root node with last node
   minHeapNodeObj *lastNode = minHeap->nodes[minHeap->size - 1];
   minHeap->nodes[0] = lastNode;
- 
+
   // update position of last node
   minHeap->pos[root->idx] = minHeap->size - 1;
   minHeap->pos[lastNode->idx] = 0;
- 
+
   // Reduce heap size and heapify root
   --minHeap->size;
   minHeapify(minHeap, 0);
- 
+
   return root;
 }
 
-static void decreaseKey(minHeapObj *minHeap, int idx, int dist)
-{
+static void decreaseKey(minHeapObj *minHeap, int idx, int dist) {
   // get the index of idx in min heap nodes
   int i = minHeap->pos[idx];
- 
+
   // get the node and update its dist value
   minHeap->nodes[i]->dist = dist;
- 
+
   // travel up while the complete tree is not hepified (this is a O(Logn) loop)
   while (i && minHeap->nodes[i]->dist < minHeap->nodes[(i - 1) / 2]->dist) {
     // swap this node with its parent
-    minHeap->pos[minHeap->nodes[i]->idx] = (i-1)/2;
-    minHeap->pos[minHeap->nodes[(i-1)/2]->idx] = i;
+    minHeap->pos[minHeap->nodes[i]->idx] = (i - 1) / 2;
+    minHeap->pos[minHeap->nodes[(i - 1) / 2]->idx] = i;
     std::swap(minHeap->nodes[i], minHeap->nodes[(i - 1) / 2]);
- 
+
     // move to parent index
     i = (i - 1) / 2;
   }
 }
 
-static bool isInMinHeap(const minHeapObj *minHeap, int idx)
-{
+static bool isInMinHeap(const minHeapObj *minHeap, int idx) {
   return minHeap->pos[idx] < minHeap->size;
 }
 
@@ -258,18 +259,19 @@ typedef struct {
   int *prev;
 } dijkstraOutputObj;
 
-static dijkstraOutputObj *dijkstra(graphObj *graph, int src)
-{
+static dijkstraOutputObj *dijkstra(graphObj *graph, int src) {
   int n = graph->numnodes;
 
-  minHeapObj *minHeap = createMinHeap(n); // priority queue implemented as a min heap structure
-  if(!minHeap) return nullptr;
+  minHeapObj *minHeap =
+      createMinHeap(n); // priority queue implemented as a min heap structure
+  if (!minHeap)
+    return nullptr;
 
   dijkstraOutputObj *output = nullptr;
-  output = (dijkstraOutputObj *) malloc(sizeof(dijkstraOutputObj));
-  output->dist = (double *) malloc(n * sizeof(double));
-  output->prev = (int *) malloc(n * sizeof(int));
-  if(!output->dist || !output->prev) {
+  output = (dijkstraOutputObj *)malloc(sizeof(dijkstraOutputObj));
+  output->dist = (double *)malloc(n * sizeof(double));
+  output->prev = (int *)malloc(n * sizeof(int));
+  if (!output->dist || !output->prev) {
     msFree(output->dist);
     msFree(output->prev);
     free(output);
@@ -278,21 +280,22 @@ static dijkstraOutputObj *dijkstra(graph
   }
 
   // initialize
-  for (int i=0; i<n; i++) {
+  for (int i = 0; i < n; i++) {
     output->dist[i] = HUGE_VAL;
     output->prev[i] = -1;
-    minHeap->nodes[i] = newMinHeapNode(i, output->dist[i]); // allocate a min heap node for each graph node
+    minHeap->nodes[i] = newMinHeapNode(
+        i, output->dist[i]); // allocate a min heap node for each graph node
     minHeap->pos[i] = i;
   }
- 
+
   // make dist value of src vertex as 0 so that it is extracted first
   minHeap->pos[src] = src;
   output->dist[src] = 0;
   decreaseKey(minHeap, src, output->dist[src]);
- 
+
   // initially size of min heap is equal to graph->numnodes (n)
   minHeap->size = n;
- 
+
   // In the following loop, minHeap contains all nodes
   // whose shortest distance is not yet finalized.
   while (!isEmpty(minHeap)) {
@@ -306,10 +309,11 @@ static dijkstraOutputObj *dijkstra(graph
     graphNodeObj *node = graph->head[u];
     while (node != nullptr) {
       int v = node->dest;
- 
+
       // if shortest distance to v is not finalized yet, and distance to v
       // through u is less than its previously calculated distance
-      if (isInMinHeap(minHeap, v) && output->dist[u] != HUGE_VAL && node->weight + output->dist[u] < output->dist[v]) {
+      if (isInMinHeap(minHeap, v) && output->dist[u] != HUGE_VAL &&
+          node->weight + output->dist[u] < output->dist[v]) {
         output->dist[v] = output->dist[u] + node->weight;
         output->prev[v] = u;
         decreaseKey(minHeap, v, output->dist[v]);
@@ -317,21 +321,25 @@ static dijkstraOutputObj *dijkstra(graph
       node = node->next;
     }
   }
- 
+
   freeMinHeap(minHeap);
 
   return output;
 }
 
-int *msGraphGetLongestShortestPath(graphObj *graph, int src, int *path_size, double *path_dist)
-{
-  if(!graph || src < 0 || src > graph->numnodes) return nullptr;
+int *msGraphGetLongestShortestPath(graphObj *graph, int src, int *path_size,
+                                   double *path_dist) {
+  if (!graph || src < 0 || src > graph->numnodes)
+    return nullptr;
 
-  int* path = (int *) malloc((graph->numnodes)*sizeof(int)); // worst case is path traverses all nodes
-  if(!path) return nullptr;
+  int *path =
+      (int *)malloc((graph->numnodes) *
+                    sizeof(int)); // worst case is path traverses all nodes
+  if (!path)
+    return nullptr;
 
   dijkstraOutputObj *output = dijkstra(graph, src);
-  if(!output) {
+  if (!output) {
     free(path);
     return nullptr; // algorithm failed for some reason
   }
@@ -339,14 +347,14 @@ int *msGraphGetLongestShortestPath(graph
   // get longest shortest distance from src to another node (our dest)
   *path_dist = -1;
   int dest = -1;
-  for(int i=0; i<graph->numnodes; i++) {
-    if(output->dist[i] != HUGE_VAL && *path_dist < output->dist[i]) {
+  for (int i = 0; i < graph->numnodes; i++) {
+    if (output->dist[i] != HUGE_VAL && *path_dist < output->dist[i]) {
       *path_dist = output->dist[i];
       dest = i;
     }
   }
 
-  if(dest == -1) { // unable to determine destination node
+  if (dest == -1) { // unable to determine destination node
     free(path);
     free(output->dist);
     free(output->prev);
@@ -356,7 +364,8 @@ int *msGraphGetLongestShortestPath(graph
 
   // construct the path from src to dest
   int j = 0;
-  for(int i=dest; i!=-1; i=output->prev[i],j++) path[j] = i;
+  for (int i = dest; i != -1; i = output->prev[i], j++)
+    path[j] = i;
   std::reverse(path, path + j);
   *path_size = j;
 
diff -pruN 8.0.1-5/mapgraph.h 8.0.2-1/mapgraph.h
--- 8.0.1-5/mapgraph.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapgraph.h	2024-06-11 20:41:34.000000000 +0000
@@ -30,7 +30,7 @@
 #ifndef MAPGRAPH_H
 #define MAPGRAPH_H
 
-#ifdef  __cplusplus
+#ifdef __cplusplus
 extern "C" {
 #endif
 
@@ -50,9 +50,10 @@ void msFreeGraph(graphObj *graph);
 int msGraphAddEdge(graphObj *graph, int src, int dest, double weight);
 void msPrintGraph(graphObj *graph);
 
-int *msGraphGetLongestShortestPath(graphObj *graph, int src, int *path_size, double *path_dist);
+int *msGraphGetLongestShortestPath(graphObj *graph, int src, int *path_size,
+                                   double *path_dist);
 
-#ifdef  __cplusplus
+#ifdef __cplusplus
 }
 #endif
 
diff -pruN 8.0.1-5/mapgraticule.c 8.0.2-1/mapgraticule.c
--- 8.0.1-5/mapgraticule.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapgraticule.c	2024-06-11 20:41:34.000000000 +0000
@@ -30,17 +30,10 @@
 #include <assert.h>
 #include "mapproject.h"
 
-
-
 /**********************************************************************************************************************
  *
  */
-typedef enum {
-  posBottom = 1,
-  posTop,
-  posLeft,
-  posRight
-} msGraticulePosition;
+typedef enum { posBottom = 1, posTop, posLeft, posRight } msGraticulePosition;
 
 typedef enum {
   lpDefault = 0,
@@ -49,27 +42,28 @@ typedef enum {
   lpDD
 } msLabelProcessingType;
 
-void DefineAxis( int iTickCountTarget, double *Min, double *Max, double *Inc );
-static int _AdjustLabelPosition( layerObj *pLayer, shapeObj *pShape, msGraticulePosition ePosition );
-static void _FormatLabel( layerObj *pLayer, shapeObj *pShape, double dDataToFormat );
+void DefineAxis(int iTickCountTarget, double *Min, double *Max, double *Inc);
+static int _AdjustLabelPosition(layerObj *pLayer, shapeObj *pShape,
+                                msGraticulePosition ePosition);
+static void _FormatLabel(layerObj *pLayer, shapeObj *pShape,
+                         double dDataToFormat);
 
 int msGraticuleLayerInitItemInfo(layerObj *layer);
 
-#define MAPGRATICULE_ARC_SUBDIVISION_DEFAULT   (256)
-#define MAPGRATICULE_ARC_MINIMUM             (16)
-#define MAPGRATICULE_FORMAT_STRING_DEFAULT      "%5.2g"
-#define MAPGRATICULE_FORMAT_STRING_DDMMSS      "%3d %02d %02d"
-#define MAPGRATICULE_FORMAT_STRING_DDMM         "%3d %02d"
-#define MAPGRATICULE_FORMAT_STRING_DD                   "%3d"
+#define MAPGRATICULE_ARC_SUBDIVISION_DEFAULT (256)
+#define MAPGRATICULE_ARC_MINIMUM (16)
+#define MAPGRATICULE_FORMAT_STRING_DEFAULT "%5.2g"
+#define MAPGRATICULE_FORMAT_STRING_DDMMSS "%3d %02d %02d"
+#define MAPGRATICULE_FORMAT_STRING_DDMM "%3d %02d"
+#define MAPGRATICULE_FORMAT_STRING_DD "%3d"
 
 /**********************************************************************************************************************
  *
  */
-int msGraticuleLayerOpen(layerObj *layer)
-{
+int msGraticuleLayerOpen(layerObj *layer) {
   graticuleObj *pInfo = layer->grid;
 
-  if( pInfo == NULL )
+  if (pInfo == NULL)
     return MS_FAILURE;
 
   pInfo->dincrementlatitude = 15.0;
@@ -78,33 +72,37 @@ int msGraticuleLayerOpen(layerObj *layer
   pInfo->dwhichlongitude = -180.0;
   pInfo->bvertical = 1;
 
-  if( layer->numclasses == 0 )
-    msDebug( "GRID layer has no classes, nothing will be rendered.\n" );
+  if (layer->numclasses == 0)
+    msDebug("GRID layer has no classes, nothing will be rendered.\n");
 
-  if( layer->numclasses > 0 && layer->class[0]->numlabels > 0 )
+  if (layer->numclasses > 0 && layer->class[0] -> numlabels > 0)
     pInfo->blabelaxes = 1;
   else
     pInfo->blabelaxes = 0;
 
-  if( pInfo->labelformat == NULL ) {
-    pInfo->labelformat = (char *) msSmallMalloc( strlen( MAPGRATICULE_FORMAT_STRING_DEFAULT ) + 1 );
-    pInfo->ilabeltype = (int) lpDefault;
-    strcpy( pInfo->labelformat, MAPGRATICULE_FORMAT_STRING_DEFAULT );
-  } else if( strcmp( pInfo->labelformat, "DDMMSS" ) == 0 ) {
+  if (pInfo->labelformat == NULL) {
+    pInfo->labelformat =
+        (char *)msSmallMalloc(strlen(MAPGRATICULE_FORMAT_STRING_DEFAULT) + 1);
+    pInfo->ilabeltype = (int)lpDefault;
+    strcpy(pInfo->labelformat, MAPGRATICULE_FORMAT_STRING_DEFAULT);
+  } else if (strcmp(pInfo->labelformat, "DDMMSS") == 0) {
     msFree(pInfo->labelformat);
-    pInfo->labelformat = (char *) msSmallMalloc( strlen( MAPGRATICULE_FORMAT_STRING_DDMMSS ) + 1 );
-    pInfo->ilabeltype = (int) lpDDMMSS;
-    strcpy( pInfo->labelformat, MAPGRATICULE_FORMAT_STRING_DDMMSS );
-  } else if( strcmp( pInfo->labelformat, "DDMM" )   == 0 ) {
+    pInfo->labelformat =
+        (char *)msSmallMalloc(strlen(MAPGRATICULE_FORMAT_STRING_DDMMSS) + 1);
+    pInfo->ilabeltype = (int)lpDDMMSS;
+    strcpy(pInfo->labelformat, MAPGRATICULE_FORMAT_STRING_DDMMSS);
+  } else if (strcmp(pInfo->labelformat, "DDMM") == 0) {
     msFree(pInfo->labelformat);
-    pInfo->labelformat = (char *) msSmallMalloc( strlen( MAPGRATICULE_FORMAT_STRING_DDMM ) + 1 );
-    pInfo->ilabeltype = (int) lpDDMM;
-    strcpy( pInfo->labelformat, MAPGRATICULE_FORMAT_STRING_DDMM );
-  } else if( strcmp( pInfo->labelformat, "DD" )   == 0 ) {
+    pInfo->labelformat =
+        (char *)msSmallMalloc(strlen(MAPGRATICULE_FORMAT_STRING_DDMM) + 1);
+    pInfo->ilabeltype = (int)lpDDMM;
+    strcpy(pInfo->labelformat, MAPGRATICULE_FORMAT_STRING_DDMM);
+  } else if (strcmp(pInfo->labelformat, "DD") == 0) {
     msFree(pInfo->labelformat);
-    pInfo->labelformat = (char *) msSmallMalloc( strlen( MAPGRATICULE_FORMAT_STRING_DD ) + 1 );
-    pInfo->ilabeltype = (int) lpDD;
-    strcpy( pInfo->labelformat, MAPGRATICULE_FORMAT_STRING_DD );
+    pInfo->labelformat =
+        (char *)msSmallMalloc(strlen(MAPGRATICULE_FORMAT_STRING_DD) + 1);
+    pInfo->ilabeltype = (int)lpDD;
+    strcpy(pInfo->labelformat, MAPGRATICULE_FORMAT_STRING_DD);
   }
 
   return MS_SUCCESS;
@@ -113,20 +111,17 @@ int msGraticuleLayerOpen(layerObj *layer
 /**********************************************************************************************************************
  * Return MS_TRUE if layer is open, MS_FALSE otherwise.
  */
-int msGraticuleLayerIsOpen(layerObj *layer)
-{
-  if(layer->grid)
+int msGraticuleLayerIsOpen(layerObj *layer) {
+  if (layer->grid)
     return MS_TRUE;
 
   return MS_FALSE;
 }
 
-
 /**********************************************************************************************************************
  *
  */
-int msGraticuleLayerClose(layerObj *layer)
-{
+int msGraticuleLayerClose(layerObj *layer) {
   (void)layer;
   return MS_SUCCESS;
 }
@@ -134,14 +129,13 @@ int msGraticuleLayerClose(layerObj *laye
 /**********************************************************************************************************************
  *
  */
-int msGraticuleLayerWhichShapes(layerObj *layer, rectObj rect, int isQuery)
-{
+int msGraticuleLayerWhichShapes(layerObj *layer, rectObj rect, int isQuery) {
   (void)isQuery;
   graticuleObj *pInfo = layer->grid;
   int iAxisTickCount = 0;
   rectObj rectMapCoordinates;
 
-  if(msCheckParentPointer(layer->map,"map") == MS_FAILURE)
+  if (msCheckParentPointer(layer->map, "map") == MS_FAILURE)
     return MS_FAILURE;
 
   pInfo->dstartlatitude = rect.miny;
@@ -149,12 +143,12 @@ int msGraticuleLayerWhichShapes(layerObj
   pInfo->dendlatitude = rect.maxy;
   pInfo->dendlongitude = rect.maxx;
   pInfo->bvertical = 1;
-  pInfo->extent   = rect;
+  pInfo->extent = rect;
 
-  if( pInfo->minincrement > 0.0 ) {
+  if (pInfo->minincrement > 0.0) {
     pInfo->dincrementlongitude = pInfo->minincrement;
     pInfo->dincrementlatitude = pInfo->minincrement;
-  } else if( pInfo->maxincrement > 0.0 ) {
+  } else if (pInfo->maxincrement > 0.0) {
     pInfo->dincrementlongitude = pInfo->maxincrement;
     pInfo->dincrementlatitude = pInfo->maxincrement;
   } else {
@@ -162,64 +156,68 @@ int msGraticuleLayerWhichShapes(layerObj
     pInfo->dincrementlatitude = 0;
   }
 
-  if( pInfo->maxarcs > 0 )
-    iAxisTickCount = (int) pInfo->maxarcs;
-  else if( pInfo->minarcs > 0 )
-    iAxisTickCount = (int) pInfo->minarcs;
-
-  DefineAxis( iAxisTickCount, &pInfo->dstartlongitude, &pInfo->dendlongitude, &pInfo->dincrementlongitude);
-  DefineAxis( iAxisTickCount, &pInfo->dstartlatitude, &pInfo->dendlatitude, &pInfo->dincrementlatitude);
+  if (pInfo->maxarcs > 0)
+    iAxisTickCount = (int)pInfo->maxarcs;
+  else if (pInfo->minarcs > 0)
+    iAxisTickCount = (int)pInfo->minarcs;
+
+  DefineAxis(iAxisTickCount, &pInfo->dstartlongitude, &pInfo->dendlongitude,
+             &pInfo->dincrementlongitude);
+  DefineAxis(iAxisTickCount, &pInfo->dstartlatitude, &pInfo->dendlatitude,
+             &pInfo->dincrementlatitude);
 
-  pInfo->dwhichlatitude   = pInfo->dstartlatitude;
+  pInfo->dwhichlatitude = pInfo->dstartlatitude;
   pInfo->dwhichlongitude = pInfo->dstartlongitude;
 
-  if( pInfo->minincrement > 0.0 && pInfo->maxincrement > 0.0 && pInfo->minincrement == pInfo->maxincrement ) {
+  if (pInfo->minincrement > 0.0 && pInfo->maxincrement > 0.0 &&
+      pInfo->minincrement == pInfo->maxincrement) {
     pInfo->dincrementlongitude = pInfo->minincrement;
     pInfo->dincrementlatitude = pInfo->minincrement;
-  } else if( pInfo->minincrement > 0.0 ) {
+  } else if (pInfo->minincrement > 0.0) {
     pInfo->dincrementlongitude = pInfo->minincrement;
     pInfo->dincrementlatitude = pInfo->minincrement;
-  } else if( pInfo->maxincrement > 0.0 ) {
+  } else if (pInfo->maxincrement > 0.0) {
     pInfo->dincrementlongitude = pInfo->maxincrement;
     pInfo->dincrementlatitude = pInfo->maxincrement;
   }
 
   /*
-   * If using PROJ, project rect back into map system, and generate rect corner points in native system.
-   * These lines will be used when generating labels to get correct placement at arc/rect edge intersections.
+   * If using PROJ, project rect back into map system, and generate rect corner
+   * points in native system. These lines will be used when generating labels to
+   * get correct placement at arc/rect edge intersections.
    */
   rectMapCoordinates = layer->map->extent;
 
-  layer->project = msProjectionsDiffer(&(layer->projection), &(layer->map->projection));
-  if( layer->project &&
-      strstr(layer->map->projection.args[0], "epsg:3857") &&
-      msProjIsGeographicCRS(&(layer->projection)) )
-  {
-      if( rectMapCoordinates.minx < -20037508)
-          rectMapCoordinates.minx = -20037508;
-      if( rectMapCoordinates.maxx > 20037508 )
-          rectMapCoordinates.maxx = 20037508;
+  layer->project =
+      msProjectionsDiffer(&(layer->projection), &(layer->map->projection));
+  if (layer->project && strstr(layer->map->projection.args[0], "epsg:3857") &&
+      msProjIsGeographicCRS(&(layer->projection))) {
+    if (rectMapCoordinates.minx < -20037508)
+      rectMapCoordinates.minx = -20037508;
+    if (rectMapCoordinates.maxx > 20037508)
+      rectMapCoordinates.maxx = 20037508;
   }
 
   msFree(pInfo->pboundinglines);
-  pInfo->pboundinglines   = (lineObj *)  msSmallMalloc( sizeof( lineObj )  * 4 );
+  pInfo->pboundinglines = (lineObj *)msSmallMalloc(sizeof(lineObj) * 4);
   msFree(pInfo->pboundingpoints);
-  pInfo->pboundingpoints = (pointObj *) msSmallMalloc( sizeof( pointObj ) * 8 );
+  pInfo->pboundingpoints = (pointObj *)msSmallMalloc(sizeof(pointObj) * 8);
 
   {
 
     /*
      * top
      */
-    pInfo->pboundinglines[0].numpoints   = 2;
+    pInfo->pboundinglines[0].numpoints = 2;
     pInfo->pboundinglines[0].point = &pInfo->pboundingpoints[0];
     pInfo->pboundinglines[0].point[0].x = rectMapCoordinates.minx;
     pInfo->pboundinglines[0].point[0].y = rectMapCoordinates.maxy;
     pInfo->pboundinglines[0].point[1].x = rectMapCoordinates.maxx;
     pInfo->pboundinglines[0].point[1].y = rectMapCoordinates.maxy;
 
-    if(layer->project)
-      msProjectLine(&layer->map->projection, &layer->projection, &pInfo->pboundinglines[0]);
+    if (layer->project)
+      msProjectLine(&layer->map->projection, &layer->projection,
+                    &pInfo->pboundinglines[0]);
 
     /*
      * bottom
@@ -227,38 +225,41 @@ int msGraticuleLayerWhichShapes(layerObj
     pInfo->pboundinglines[1].numpoints = 2;
     pInfo->pboundinglines[1].point = &pInfo->pboundingpoints[2];
     pInfo->pboundinglines[1].point[0].x = rectMapCoordinates.minx;
-    pInfo->pboundinglines[1].point[0].y   = rectMapCoordinates.miny;
-    pInfo->pboundinglines[1].point[1].x   = rectMapCoordinates.maxx;
+    pInfo->pboundinglines[1].point[0].y = rectMapCoordinates.miny;
+    pInfo->pboundinglines[1].point[1].x = rectMapCoordinates.maxx;
     pInfo->pboundinglines[1].point[1].y = rectMapCoordinates.miny;
 
-    if(layer->project)
-      msProjectLine(&layer->map->projection, &layer->projection, &pInfo->pboundinglines[1]);
+    if (layer->project)
+      msProjectLine(&layer->map->projection, &layer->projection,
+                    &pInfo->pboundinglines[1]);
 
     /*
      * left
      */
     pInfo->pboundinglines[2].numpoints = 2;
     pInfo->pboundinglines[2].point = &pInfo->pboundingpoints[4];
-    pInfo->pboundinglines[2].point[0].x   = rectMapCoordinates.minx;
-    pInfo->pboundinglines[2].point[0].y   = rectMapCoordinates.miny;
-    pInfo->pboundinglines[2].point[1].x   = rectMapCoordinates.minx;
-    pInfo->pboundinglines[2].point[1].y   = rectMapCoordinates.maxy;
-
-    if(layer->project)
-      msProjectLine(&layer->map->projection, &layer->projection, &pInfo->pboundinglines[2]);
+    pInfo->pboundinglines[2].point[0].x = rectMapCoordinates.minx;
+    pInfo->pboundinglines[2].point[0].y = rectMapCoordinates.miny;
+    pInfo->pboundinglines[2].point[1].x = rectMapCoordinates.minx;
+    pInfo->pboundinglines[2].point[1].y = rectMapCoordinates.maxy;
+
+    if (layer->project)
+      msProjectLine(&layer->map->projection, &layer->projection,
+                    &pInfo->pboundinglines[2]);
 
     /*
      * right
      */
     pInfo->pboundinglines[3].numpoints = 2;
     pInfo->pboundinglines[3].point = &pInfo->pboundingpoints[6];
-    pInfo->pboundinglines[3].point[0].x   = rectMapCoordinates.maxx;
-    pInfo->pboundinglines[3].point[0].y   = rectMapCoordinates.miny;
+    pInfo->pboundinglines[3].point[0].x = rectMapCoordinates.maxx;
+    pInfo->pboundinglines[3].point[0].y = rectMapCoordinates.miny;
     pInfo->pboundinglines[3].point[1].x = rectMapCoordinates.maxx;
     pInfo->pboundinglines[3].point[1].y = rectMapCoordinates.maxy;
 
-    if(layer->project)
-      msProjectLine(&layer->map->projection, &layer->projection, &pInfo->pboundinglines[3]);
+    if (layer->project)
+      msProjectLine(&layer->map->projection, &layer->projection,
+                    &pInfo->pboundinglines[3]);
   }
 
   return MS_SUCCESS;
@@ -267,219 +268,242 @@ int msGraticuleLayerWhichShapes(layerObj
 /**********************************************************************************************************************
  *
  */
-int msGraticuleLayerNextShape(layerObj *layer, shapeObj *shape)
-{
+int msGraticuleLayerNextShape(layerObj *layer, shapeObj *shape) {
   graticuleObj *pInfo = layer->grid;
 
-  if( pInfo->minsubdivides <= 0.0 || pInfo->maxsubdivides <= 0.0 )
-    pInfo->minsubdivides = pInfo->maxsubdivides = MAPGRATICULE_ARC_SUBDIVISION_DEFAULT;
+  if (pInfo->minsubdivides <= 0.0 || pInfo->maxsubdivides <= 0.0)
+    pInfo->minsubdivides = pInfo->maxsubdivides =
+        MAPGRATICULE_ARC_SUBDIVISION_DEFAULT;
 
   shape->numlines = 1;
   shape->type = MS_SHAPE_LINE;
-  shape->line = (lineObj *) msSmallMalloc(sizeof( lineObj ));
-  shape->line->numpoints = (int) pInfo->maxsubdivides;
+  shape->line = (lineObj *)msSmallMalloc(sizeof(lineObj));
+  shape->line->numpoints = (int)pInfo->maxsubdivides;
   shape->line->point = NULL;
 
   /*
    * Subdivide and draw current arc, rendering the arc labels first
    */
-  if( pInfo->bvertical ) {
+  if (pInfo->bvertical) {
     int iPointIndex;
-    double dArcDelta = (pInfo->dendlatitude - pInfo->dstartlatitude) / (double) shape->line->numpoints;
-    double dArcPosition  = pInfo->dstartlatitude + dArcDelta;
+    double dArcDelta = (pInfo->dendlatitude - pInfo->dstartlatitude) /
+                       (double)shape->line->numpoints;
+    double dArcPosition = pInfo->dstartlatitude + dArcDelta;
     double dStartY, dDeltaX;
 
-    switch( pInfo->ilabelstate ) {
-      case 0:
-        if(!pInfo->blabelaxes)  { /* Bottom */
-          pInfo->ilabelstate++;
-          msFreeShape(shape);
-          return MS_SUCCESS;
-        }
-
-        dDeltaX = (pInfo->dwhichlongitude - pInfo->pboundinglines[1].point[0].x) / (pInfo->pboundinglines[1].point[1].x - pInfo->pboundinglines[1].point[0].x);
-        if (dDeltaX < 0)
-          dDeltaX=dDeltaX*-1;
-
-        dStartY = (pInfo->pboundinglines[1].point[1].y - pInfo->pboundinglines[1].point[0].y) * dDeltaX + pInfo->pboundinglines[1].point[0].y;
-        shape->line->numpoints = (int) 2;
-        shape->line->point = (pointObj *) msSmallMalloc( sizeof( pointObj ) * 2 );
-
-        shape->line->point[0].x = pInfo->dwhichlongitude;
-        shape->line->point[0].y = dStartY;
-        shape->line->point[1].x = pInfo->dwhichlongitude;
-        shape->line->point[1].y = dStartY + dArcDelta;
-
-        _FormatLabel( layer, shape, shape->line->point[0].x );
-        if(_AdjustLabelPosition( layer, shape, posBottom ) != MS_SUCCESS)
-        {
-            msFreeShape(shape);
-            pInfo->ilabelstate++;
-            return MS_SUCCESS;
-        }
+    switch (pInfo->ilabelstate) {
+    case 0:
+      if (!pInfo->blabelaxes) { /* Bottom */
+        pInfo->ilabelstate++;
+        msFreeShape(shape);
+        return MS_SUCCESS;
+      }
 
+      dDeltaX = (pInfo->dwhichlongitude - pInfo->pboundinglines[1].point[0].x) /
+                (pInfo->pboundinglines[1].point[1].x -
+                 pInfo->pboundinglines[1].point[0].x);
+      if (dDeltaX < 0)
+        dDeltaX = dDeltaX * -1;
+
+      dStartY = (pInfo->pboundinglines[1].point[1].y -
+                 pInfo->pboundinglines[1].point[0].y) *
+                    dDeltaX +
+                pInfo->pboundinglines[1].point[0].y;
+      shape->line->numpoints = (int)2;
+      shape->line->point = (pointObj *)msSmallMalloc(sizeof(pointObj) * 2);
+
+      shape->line->point[0].x = pInfo->dwhichlongitude;
+      shape->line->point[0].y = dStartY;
+      shape->line->point[1].x = pInfo->dwhichlongitude;
+      shape->line->point[1].y = dStartY + dArcDelta;
+
+      _FormatLabel(layer, shape, shape->line->point[0].x);
+      if (_AdjustLabelPosition(layer, shape, posBottom) != MS_SUCCESS) {
+        msFreeShape(shape);
         pInfo->ilabelstate++;
         return MS_SUCCESS;
+      }
 
-      case 1:
-        if(!pInfo->blabelaxes) { /* Top */
-          pInfo->ilabelstate++;
-          msFreeShape(shape);
-          return MS_SUCCESS;
-        }
+      pInfo->ilabelstate++;
+      return MS_SUCCESS;
 
-        dDeltaX = (pInfo->dwhichlongitude - pInfo->pboundinglines[0].point[0].x) / (pInfo->pboundinglines[0].point[1].x - pInfo->pboundinglines[0].point[0].x );
-        if (dDeltaX < 0)
-          dDeltaX=dDeltaX*-1;
-
-        dStartY = (pInfo->pboundinglines[0].point[1].y - pInfo->pboundinglines[0].point[0].y) * dDeltaX + pInfo->pboundinglines[0].point[1].y;
-        shape->line->numpoints = (int) 2;
-        shape->line->point = (pointObj *) msSmallMalloc( sizeof( pointObj ) * 2 );
-
-        shape->line->point[0].x = pInfo->dwhichlongitude;
-        shape->line->point[0].y = dStartY - dArcDelta;
-        shape->line->point[1].x = pInfo->dwhichlongitude;
-        shape->line->point[1].y = dStartY;
-
-        _FormatLabel( layer, shape, shape->line->point[0].x );
-        if(_AdjustLabelPosition( layer, shape, posTop ) != MS_SUCCESS)
-        {
-            msFreeShape(shape);
-            pInfo->ilabelstate++;
-            return MS_SUCCESS;
-        }
+    case 1:
+      if (!pInfo->blabelaxes) { /* Top */
+        pInfo->ilabelstate++;
+        msFreeShape(shape);
+        return MS_SUCCESS;
+      }
 
+      dDeltaX = (pInfo->dwhichlongitude - pInfo->pboundinglines[0].point[0].x) /
+                (pInfo->pboundinglines[0].point[1].x -
+                 pInfo->pboundinglines[0].point[0].x);
+      if (dDeltaX < 0)
+        dDeltaX = dDeltaX * -1;
+
+      dStartY = (pInfo->pboundinglines[0].point[1].y -
+                 pInfo->pboundinglines[0].point[0].y) *
+                    dDeltaX +
+                pInfo->pboundinglines[0].point[1].y;
+      shape->line->numpoints = (int)2;
+      shape->line->point = (pointObj *)msSmallMalloc(sizeof(pointObj) * 2);
+
+      shape->line->point[0].x = pInfo->dwhichlongitude;
+      shape->line->point[0].y = dStartY - dArcDelta;
+      shape->line->point[1].x = pInfo->dwhichlongitude;
+      shape->line->point[1].y = dStartY;
+
+      _FormatLabel(layer, shape, shape->line->point[0].x);
+      if (_AdjustLabelPosition(layer, shape, posTop) != MS_SUCCESS) {
+        msFreeShape(shape);
         pInfo->ilabelstate++;
         return MS_SUCCESS;
+      }
 
-      case 2:
-        shape->line->numpoints = (int) shape->line->numpoints + 1;
-        shape->line->point = (pointObj *) msSmallMalloc( sizeof( pointObj ) * shape->line->numpoints );
-
-        shape->line->point[0].x = pInfo->dwhichlongitude;
-        shape->line->point[0].y = pInfo->dstartlatitude;
-
-        for( iPointIndex = 1; iPointIndex < shape->line->numpoints; iPointIndex++ ) {
-          shape->line->point[iPointIndex].x   = pInfo->dwhichlongitude;
-          shape->line->point[iPointIndex].y   = dArcPosition;
+      pInfo->ilabelstate++;
+      return MS_SUCCESS;
 
-          dArcPosition += dArcDelta;
-        }
+    case 2:
+      shape->line->numpoints = (int)shape->line->numpoints + 1;
+      shape->line->point =
+          (pointObj *)msSmallMalloc(sizeof(pointObj) * shape->line->numpoints);
+
+      shape->line->point[0].x = pInfo->dwhichlongitude;
+      shape->line->point[0].y = pInfo->dstartlatitude;
+
+      for (iPointIndex = 1; iPointIndex < shape->line->numpoints;
+           iPointIndex++) {
+        shape->line->point[iPointIndex].x = pInfo->dwhichlongitude;
+        shape->line->point[iPointIndex].y = dArcPosition;
 
-        pInfo->ilabelstate = 0;
+        dArcPosition += dArcDelta;
+      }
+
+      pInfo->ilabelstate = 0;
 
-        pInfo->dwhichlongitude      += pInfo->dincrementlongitude;
-        break;
+      pInfo->dwhichlongitude += pInfo->dincrementlongitude;
+      break;
 
-      default:
-        pInfo->ilabelstate    = 0;
-        break;
+    default:
+      pInfo->ilabelstate = 0;
+      break;
     }
 
   } else { /*horizontal*/
     int iPointIndex;
-    double dArcDelta = (pInfo->dendlongitude - pInfo->dstartlongitude) / (double) shape->line->numpoints;
-    double dArcPosition   = pInfo->dstartlongitude + dArcDelta;
+    double dArcDelta = (pInfo->dendlongitude - pInfo->dstartlongitude) /
+                       (double)shape->line->numpoints;
+    double dArcPosition = pInfo->dstartlongitude + dArcDelta;
     double dStartX, dDeltaY;
 
-    switch( pInfo->ilabelstate ) {
-      case 0:
-        if(!pInfo->blabelaxes) { /* Left side */
-          pInfo->ilabelstate++;
-          msFreeShape(shape);
-          return MS_SUCCESS;
-        }
-
-        dDeltaY = (pInfo->dwhichlatitude - pInfo->pboundinglines[2].point[0].y) / (pInfo->pboundinglines[2].point[1].y - pInfo->pboundinglines[2].point[0].y );
-        if (dDeltaY < 0)
-          dDeltaY= dDeltaY*-1;
-
-        dStartX = (pInfo->pboundinglines[2].point[1].x - pInfo->pboundinglines[2].point[0].x) * dDeltaY + pInfo->pboundinglines[2].point[0].x;
-        shape->line->numpoints = (int) 2;
-        shape->line->point    = (pointObj *) msSmallMalloc( sizeof( pointObj ) * 2 );
-
-        shape->line->point[0].x = dStartX;
-        shape->line->point[0].y = pInfo->dwhichlatitude;
-        shape->line->point[1].x = dStartX + dArcDelta;
-        shape->line->point[1].y = pInfo->dwhichlatitude;
-
-        _FormatLabel( layer, shape, shape->line->point[0].y );
-        if(_AdjustLabelPosition( layer, shape, posLeft ) != MS_SUCCESS)
-        {
-            msFreeShape(shape);
-            pInfo->ilabelstate++;
-            return MS_SUCCESS;
-        }
+    switch (pInfo->ilabelstate) {
+    case 0:
+      if (!pInfo->blabelaxes) { /* Left side */
+        pInfo->ilabelstate++;
+        msFreeShape(shape);
+        return MS_SUCCESS;
+      }
 
+      dDeltaY = (pInfo->dwhichlatitude - pInfo->pboundinglines[2].point[0].y) /
+                (pInfo->pboundinglines[2].point[1].y -
+                 pInfo->pboundinglines[2].point[0].y);
+      if (dDeltaY < 0)
+        dDeltaY = dDeltaY * -1;
+
+      dStartX = (pInfo->pboundinglines[2].point[1].x -
+                 pInfo->pboundinglines[2].point[0].x) *
+                    dDeltaY +
+                pInfo->pboundinglines[2].point[0].x;
+      shape->line->numpoints = (int)2;
+      shape->line->point = (pointObj *)msSmallMalloc(sizeof(pointObj) * 2);
+
+      shape->line->point[0].x = dStartX;
+      shape->line->point[0].y = pInfo->dwhichlatitude;
+      shape->line->point[1].x = dStartX + dArcDelta;
+      shape->line->point[1].y = pInfo->dwhichlatitude;
+
+      _FormatLabel(layer, shape, shape->line->point[0].y);
+      if (_AdjustLabelPosition(layer, shape, posLeft) != MS_SUCCESS) {
+        msFreeShape(shape);
         pInfo->ilabelstate++;
         return MS_SUCCESS;
+      }
 
-      case 1:
-        if(!pInfo->blabelaxes) { /* Right side */
-          pInfo->ilabelstate++;
-          msFreeShape(shape);
-          return MS_SUCCESS;
-        }
+      pInfo->ilabelstate++;
+      return MS_SUCCESS;
 
-        dDeltaY = (pInfo->dwhichlatitude - pInfo->pboundinglines[3].point[0].y) / (pInfo->pboundinglines[3].point[1].y - pInfo->pboundinglines[3].point[0].y );
-        if (dDeltaY < 0)
-          dDeltaY= dDeltaY*-1;
-
-        dStartX = (pInfo->pboundinglines[3].point[1].x - pInfo->pboundinglines[3].point[0].x) * dDeltaY + pInfo->pboundinglines[3].point[0].x;
-        shape->line->numpoints = (int) 2;
-        shape->line->point = (pointObj *) msSmallMalloc( sizeof( pointObj ) * 2 );
-
-        shape->line->point[0].x = dStartX - dArcDelta;
-        shape->line->point[0].y = pInfo->dwhichlatitude;
-        shape->line->point[1].x = dStartX;
-        shape->line->point[1].y = pInfo->dwhichlatitude;
-
-        _FormatLabel( layer, shape, shape->line->point[0].y );
-        if(_AdjustLabelPosition( layer, shape, posRight ) != MS_SUCCESS)
-        {
-            msFreeShape(shape);
-            pInfo->ilabelstate++;
-            return MS_SUCCESS;
-        }
+    case 1:
+      if (!pInfo->blabelaxes) { /* Right side */
+        pInfo->ilabelstate++;
+        msFreeShape(shape);
+        return MS_SUCCESS;
+      }
 
+      dDeltaY = (pInfo->dwhichlatitude - pInfo->pboundinglines[3].point[0].y) /
+                (pInfo->pboundinglines[3].point[1].y -
+                 pInfo->pboundinglines[3].point[0].y);
+      if (dDeltaY < 0)
+        dDeltaY = dDeltaY * -1;
+
+      dStartX = (pInfo->pboundinglines[3].point[1].x -
+                 pInfo->pboundinglines[3].point[0].x) *
+                    dDeltaY +
+                pInfo->pboundinglines[3].point[0].x;
+      shape->line->numpoints = (int)2;
+      shape->line->point = (pointObj *)msSmallMalloc(sizeof(pointObj) * 2);
+
+      shape->line->point[0].x = dStartX - dArcDelta;
+      shape->line->point[0].y = pInfo->dwhichlatitude;
+      shape->line->point[1].x = dStartX;
+      shape->line->point[1].y = pInfo->dwhichlatitude;
+
+      _FormatLabel(layer, shape, shape->line->point[0].y);
+      if (_AdjustLabelPosition(layer, shape, posRight) != MS_SUCCESS) {
+        msFreeShape(shape);
         pInfo->ilabelstate++;
         return MS_SUCCESS;
+      }
 
-      case 2:
-        shape->line->numpoints = (int) shape->line->numpoints + 1;
-        shape->line->point = (pointObj *) msSmallMalloc( sizeof( pointObj ) * shape->line->numpoints );
-
-        shape->line->point[0].x = pInfo->dstartlongitude;
-        shape->line->point[0].y = pInfo->dwhichlatitude;
-
-        for(iPointIndex = 1; iPointIndex < shape->line->numpoints; iPointIndex++) {
-          shape->line->point[iPointIndex].x   = dArcPosition;
-          shape->line->point[iPointIndex].y   = pInfo->dwhichlatitude;
+      pInfo->ilabelstate++;
+      return MS_SUCCESS;
 
-          dArcPosition += dArcDelta;
-        }
+    case 2:
+      shape->line->numpoints = (int)shape->line->numpoints + 1;
+      shape->line->point =
+          (pointObj *)msSmallMalloc(sizeof(pointObj) * shape->line->numpoints);
+
+      shape->line->point[0].x = pInfo->dstartlongitude;
+      shape->line->point[0].y = pInfo->dwhichlatitude;
+
+      for (iPointIndex = 1; iPointIndex < shape->line->numpoints;
+           iPointIndex++) {
+        shape->line->point[iPointIndex].x = dArcPosition;
+        shape->line->point[iPointIndex].y = pInfo->dwhichlatitude;
+
+        dArcPosition += dArcDelta;
+      }
 
-        pInfo->ilabelstate    = 0;
-        pInfo->dwhichlatitude += pInfo->dincrementlatitude;
-        break;
-
-      default:
-        pInfo->ilabelstate    = 0;
-        break;
+      pInfo->ilabelstate = 0;
+      pInfo->dwhichlatitude += pInfo->dincrementlatitude;
+      break;
+
+    default:
+      pInfo->ilabelstate = 0;
+      break;
     }
   }
 
   /*
-    * Increment and move to next arc
-    */
+   * Increment and move to next arc
+   */
 
-  if( pInfo->bvertical && pInfo->dwhichlongitude > pInfo->dendlongitude )   {
-    pInfo->dwhichlatitude   = pInfo->dstartlatitude;
-    pInfo->bvertical   = 0;
+  if (pInfo->bvertical && pInfo->dwhichlongitude > pInfo->dendlongitude) {
+    pInfo->dwhichlatitude = pInfo->dstartlatitude;
+    pInfo->bvertical = 0;
   }
 
-  if (pInfo->dwhichlatitude >  pInfo->dendlatitude) {
-    /* free the lineObj and pointObj that have been erroneously allocated beforehand */
+  if (pInfo->dwhichlatitude > pInfo->dendlatitude) {
+    /* free the lineObj and pointObj that have been erroneously allocated
+     * beforehand */
     msFreeShape(shape);
     return MS_DONE;
   }
@@ -490,15 +514,14 @@ int msGraticuleLayerNextShape(layerObj *
 /**********************************************************************************************************************
  *
  */
-int msGraticuleLayerGetItems(layerObj *layer)
-{
-  char **ppItemName   = (char **) msSmallMalloc( sizeof( char * ) );
+int msGraticuleLayerGetItems(layerObj *layer) {
+  char **ppItemName = (char **)msSmallMalloc(sizeof(char *));
 
-  *ppItemName = (char *) msSmallMalloc( 64 ); /* why is this necessary? */
-  strcpy( *ppItemName, "Graticule" );
+  *ppItemName = (char *)msSmallMalloc(64); /* why is this necessary? */
+  strcpy(*ppItemName, "Graticule");
 
-  layer->numitems   = 1;
-  layer->items   = ppItemName;
+  layer->numitems = 1;
+  layer->items = ppItemName;
 
   return MS_SUCCESS;
 }
@@ -506,8 +529,7 @@ int msGraticuleLayerGetItems(layerObj *l
 /**********************************************************************************************************************
  *
  */
-int msGraticuleLayerInitItemInfo(layerObj *layer)
-{
+int msGraticuleLayerInitItemInfo(layerObj *layer) {
   (void)layer;
   return MS_SUCCESS;
 }
@@ -515,16 +537,13 @@ int msGraticuleLayerInitItemInfo(layerOb
 /**********************************************************************************************************************
  *
  */
-void msGraticuleLayerFreeItemInfo(layerObj *layer)
-{
-  (void)layer;
-}
+void msGraticuleLayerFreeItemInfo(layerObj *layer) { (void)layer; }
 
 /**********************************************************************************************************************
  *
  */
-int msGraticuleLayerGetShape(layerObj *layer, shapeObj *shape, resultObj *record)
-{
+int msGraticuleLayerGetShape(layerObj *layer, shapeObj *shape,
+                             resultObj *record) {
   (void)layer;
   (void)shape;
   (void)record;
@@ -534,11 +553,10 @@ int msGraticuleLayerGetShape(layerObj *l
 /**********************************************************************************************************************
  *
  */
-int msGraticuleLayerGetExtent(layerObj *layer, rectObj *extent)
-{
+int msGraticuleLayerGetExtent(layerObj *layer, rectObj *extent) {
   graticuleObj *pInfo = layer->grid;
 
-  if(pInfo) {
+  if (pInfo) {
     *extent = pInfo->extent;
     return MS_SUCCESS;
   }
@@ -549,8 +567,8 @@ int msGraticuleLayerGetExtent(layerObj *
 /**********************************************************************************************************************
  *
  */
-int msGraticuleLayerGetAutoStyle(mapObj *map, layerObj *layer, classObj *c, shapeObj* shape)
-{
+int msGraticuleLayerGetAutoStyle(mapObj *map, layerObj *layer, classObj *c,
+                                 shapeObj *shape) {
   (void)map;
   (void)layer;
   (void)c;
@@ -558,32 +576,29 @@ int msGraticuleLayerGetAutoStyle(mapObj
   return MS_SUCCESS;
 }
 
-
 /************************************************************************/
 /*                  msGraticuleLayerFreeIntersectionPoints              */
 /*                                                                      */
 /*      Free intersection object.                                       */
 /************************************************************************/
-void msGraticuleLayerFreeIntersectionPoints( graticuleIntersectionObj *psValue)
-{
+void msGraticuleLayerFreeIntersectionPoints(graticuleIntersectionObj *psValue) {
   if (psValue) {
-    for (int i=0; i<psValue->nTop; i++)
+    for (int i = 0; i < psValue->nTop; i++)
       msFree(psValue->papszTopLabels[i]);
     msFree(psValue->papszTopLabels);
     msFree(psValue->pasTop);
 
-    for (int i=0; i<psValue->nBottom; i++)
+    for (int i = 0; i < psValue->nBottom; i++)
       msFree(psValue->papszBottomLabels[i]);
     msFree(psValue->papszBottomLabels);
     msFree(psValue->pasBottom);
 
-
-    for (int i=0; i<psValue->nLeft; i++)
+    for (int i = 0; i < psValue->nLeft; i++)
       msFree(psValue->papszLeftLabels[i]);
     msFree(psValue->papszLeftLabels);
     msFree(psValue->pasLeft);
 
-    for (int i=0; i<psValue->nRight; i++)
+    for (int i = 0; i < psValue->nRight; i++)
       msFree(psValue->papszRightLabels[i]);
     msFree(psValue->papszRightLabels);
     msFree(psValue->pasRight);
@@ -592,14 +607,13 @@ void msGraticuleLayerFreeIntersectionPoi
   }
 }
 
-
 /************************************************************************/
 /*                  msGraticuleLayerInitIntersectionPoints              */
 /*                                                                      */
 /*      init intersection object.                                       */
 /************************************************************************/
-static void msGraticuleLayerInitIntersectionPoints( graticuleIntersectionObj *psValue)
-{
+static void
+msGraticuleLayerInitIntersectionPoints(graticuleIntersectionObj *psValue) {
   if (psValue) {
     psValue->nTop = 0;
     psValue->pasTop = NULL;
@@ -616,81 +630,82 @@ static void msGraticuleLayerInitIntersec
   }
 }
 
-
 /************************************************************************/
 /*                  msGraticuleLayerGetIntersectionPoints               */
 /*                                                                      */
 /*      Utility function thar returns all intersection positions and    */
 /*      labels (4 sides of the map) for a grid layer.                   */
 /************************************************************************/
-graticuleIntersectionObj *msGraticuleLayerGetIntersectionPoints(mapObj *map,
-    layerObj *layer)
-{
-
-  shapeObj    shapegrid, tmpshape;
-  rectObj     searchrect;
-  int         status;
+graticuleIntersectionObj *
+msGraticuleLayerGetIntersectionPoints(mapObj *map, layerObj *layer) {
+
+  shapeObj shapegrid, tmpshape;
+  rectObj searchrect;
+  int status;
   pointObj oFirstPoint;
   pointObj oLastPoint;
   lineObj oLineObj;
   rectObj cliprect;
-  graticuleObj   *pInfo  = NULL;
+  graticuleObj *pInfo = NULL;
   double dfTmp;
   graticuleIntersectionObj *psValues = NULL;
-  int i=0;
+  int i = 0;
 
   if (layer->connectiontype != MS_GRATICULE)
     return NULL;
 
-  pInfo  = layer->grid;
+  pInfo = layer->grid;
 
   /*set cellsize if bnot already set*/
   if (map->cellsize == 0)
-    map->cellsize = msAdjustExtent(&(map->extent),map->width,map->height);
+    map->cellsize = msAdjustExtent(&(map->extent), map->width, map->height);
 
-  psValues = (graticuleIntersectionObj *)msSmallMalloc(sizeof(graticuleIntersectionObj));
+  psValues = (graticuleIntersectionObj *)msSmallMalloc(
+      sizeof(graticuleIntersectionObj));
 
   msGraticuleLayerInitIntersectionPoints(psValues);
 
-  if(layer->transform == MS_TRUE)
+  if (layer->transform == MS_TRUE)
     searchrect = map->extent;
   else {
     searchrect.minx = searchrect.miny = 0;
-    searchrect.maxx = map->width-1;
-    searchrect.maxy = map->height-1;
+    searchrect.maxx = map->width - 1;
+    searchrect.maxy = map->height - 1;
   }
 
-  if((map->projection.numargs > 0) && (layer->projection.numargs > 0))
-    msProjectRect(&map->projection, &layer->projection, &searchrect); /* project the searchrect to source coords */
+  if ((map->projection.numargs > 0) && (layer->projection.numargs > 0))
+    msProjectRect(&map->projection, &layer->projection,
+                  &searchrect); /* project the searchrect to source coords */
 
- status =  msLayerOpen(layer);
- if(status != MS_SUCCESS)
-   return NULL;
+  status = msLayerOpen(layer);
+  if (status != MS_SUCCESS)
+    return NULL;
 
   status = msLayerWhichShapes(layer, searchrect, MS_FALSE);
-  if(status == MS_DONE) { /* no overlap */
+  if (status == MS_DONE) { /* no overlap */
     msLayerClose(layer);
     return NULL;
-  } else if(status != MS_SUCCESS) {
+  } else if (status != MS_SUCCESS) {
     msLayerClose(layer);
     return NULL;
   }
 
   /* step through the target shapes */
   msInitShape(&shapegrid);
-  cliprect.minx = map->extent.minx- map->cellsize;
-  cliprect.miny = map->extent.miny- map->cellsize;
+  cliprect.minx = map->extent.minx - map->cellsize;
+  cliprect.miny = map->extent.miny - map->cellsize;
   cliprect.maxx = map->extent.maxx + map->cellsize;
   cliprect.maxy = map->extent.maxy + map->cellsize;
 
   /* clip using the layer projection */
   /* msProjectRect(&map->projection , &layer->projection,  &cliprect); */
 
-  while((status = msLayerNextShape(layer, &shapegrid)) == MS_SUCCESS) {
+  while ((status = msLayerNextShape(layer, &shapegrid)) == MS_SUCCESS) {
     /*don't really need a class here*/
     /*
-      shapegrid.classindex = msShapeGetClass(layer, &shapegrid, map->scaledenom, NULL, 0);
-      if((shapegrid.classindex == -1) || (layer->class[shapegrid.classindex]->status == MS_OFF)) {
+      shapegrid.classindex = msShapeGetClass(layer, &shapegrid, map->scaledenom,
+    NULL, 0); if((shapegrid.classindex == -1) ||
+    (layer->class[shapegrid.classindex]->status == MS_OFF)) {
     msFreeShape(&shapegrid);
     continue;
     }
@@ -700,31 +715,27 @@ graticuleIntersectionObj *msGraticuleLay
     msCopyShape(&shapegrid, &tmpshape);
     /* status = msDrawShape(map, layer, &tmpshape, image, -1); */
 
-    if(layer->project) {
-      if( layer->reprojectorLayerToMap == NULL )
-      {
-        layer->reprojectorLayerToMap = msProjectCreateReprojector(
-            &layer->projection, &map->projection);
+    if (layer->project) {
+      if (layer->reprojectorLayerToMap == NULL) {
+        layer->reprojectorLayerToMap =
+            msProjectCreateReprojector(&layer->projection, &map->projection);
       }
-      if( layer->reprojectorLayerToMap )
+      if (layer->reprojectorLayerToMap)
         msProjectShapeEx(layer->reprojectorLayerToMap, &shapegrid);
     }
 
     msClipPolylineRect(&shapegrid, cliprect);
 
-
     msTransformShapeToPixelRound(&shapegrid, map->extent, map->cellsize);
 
-
-
-    if(shapegrid.numlines <= 0 || shapegrid.line[0].numpoints < 2) { /* once clipped the shape didn't need to be drawn */
+    if (shapegrid.numlines <= 0 ||
+        shapegrid.line[0].numpoints <
+            2) { /* once clipped the shape didn't need to be drawn */
       msFreeShape(&shapegrid);
       msFreeShape(&tmpshape);
       continue;
     }
 
-
-
     {
       int iTmpLine = 0;
       int nNumPoints = 0;
@@ -733,7 +744,7 @@ graticuleIntersectionObj *msGraticuleLay
         points, which should be the most likley to be correct*/
 
       if (shapegrid.numlines > 1) {
-        for (i=0; i<shapegrid.numlines; i++) {
+        for (i = 0; i < shapegrid.numlines; i++) {
           if (shapegrid.line[i].numpoints > nNumPoints) {
             nNumPoints = shapegrid.line[i].numpoints;
             iTmpLine = i;
@@ -744,14 +755,14 @@ graticuleIntersectionObj *msGraticuleLay
       oFirstPoint.x = shapegrid.line[iTmpLine].point[0].x;
       oFirstPoint.y = shapegrid.line[iTmpLine].point[0].y;
       oLineObj = shapegrid.line[iTmpLine];
-      oLastPoint.x = oLineObj.point[oLineObj.numpoints-1].x;
-      oLastPoint.y = oLineObj.point[oLineObj.numpoints-1].y;
+      oLastPoint.x = oLineObj.point[oLineObj.numpoints - 1].x;
+      oLastPoint.y = oLineObj.point[oLineObj.numpoints - 1].y;
 
-      if ( pInfo->bvertical) { /*vertical*/
+      if (pInfo->bvertical) { /*vertical*/
         /*SHAPES ARE DRAWN FROM BOTTOM TO TOP.*/
-        /*Normally lines are drawn FROM BOTTOM TO TOP but not always for some reason, so
-          make sure that firstpoint < lastpoint in y, We are in pixel coordinates so y increases as we
-        we go down*/
+        /*Normally lines are drawn FROM BOTTOM TO TOP but not always for some
+        reason, so make sure that firstpoint < lastpoint in y, We are in pixel
+        coordinates so y increases as we we go down*/
         if (oFirstPoint.y < oLastPoint.y) {
           dfTmp = oFirstPoint.x;
           oFirstPoint.x = oLastPoint.x;
@@ -759,13 +770,12 @@ graticuleIntersectionObj *msGraticuleLay
           dfTmp = oFirstPoint.y;
           oFirstPoint.y = oLastPoint.y;
           oLastPoint.y = dfTmp;
-
         }
 
         /*first point should cross the BOTTOM base where y== map->height*/
 
-        if (abs ((int)oFirstPoint.y - map->height)  <=1) {
-          char *pszLabel=NULL;
+        if (abs((int)oFirstPoint.y - map->height) <= 1) {
+          char *pszLabel = NULL;
           oFirstPoint.y = map->height;
 
           /*validate point is in map width/height*/
@@ -777,46 +787,51 @@ graticuleIntersectionObj *msGraticuleLay
             continue;
 
           if (shapegrid.text)
-            pszLabel =  msStrdup(shapegrid.text);
+            pszLabel = msStrdup(shapegrid.text);
           else {
-            _FormatLabel(layer, &tmpshape, tmpshape.line[0].point[tmpshape.line[0].numpoints-1].x );
+            _FormatLabel(
+                layer, &tmpshape,
+                tmpshape.line[0].point[tmpshape.line[0].numpoints - 1].x);
             if (tmpshape.text)
               pszLabel = msStrdup(tmpshape.text);
             else
               pszLabel = msStrdup("unknown");
           }
           /*validate that the  value is not already in the array*/
-          if ( psValues->nBottom > 0) {
+          if (psValues->nBottom > 0) {
             /* if (psValues->pasBottom[psValues->nBottom-1].x == oFirstPoint.x)
                  continue; */
 
-            for (i=0; i<psValues->nBottom; i++) {
+            for (i = 0; i < psValues->nBottom; i++) {
               if (psValues->pasBottom[i].x == oFirstPoint.x)
                 break;
             }
-            if (i  < psValues->nBottom) {
+            if (i < psValues->nBottom) {
               msFree(pszLabel);
               continue;
             }
           }
           if (psValues->pasBottom == NULL) {
             psValues->pasBottom = (pointObj *)msSmallMalloc(sizeof(pointObj));
-            psValues->papszBottomLabels = (char **)msSmallMalloc(sizeof(char *));
+            psValues->papszBottomLabels =
+                (char **)msSmallMalloc(sizeof(char *));
             psValues->nBottom = 1;
           } else {
             psValues->nBottom++;
-            psValues->pasBottom = (pointObj *)msSmallRealloc(psValues->pasBottom, sizeof(pointObj)*psValues->nBottom);
-            psValues->papszBottomLabels = (char **)msSmallRealloc(psValues->papszBottomLabels, sizeof(char *)*psValues->nBottom);
+            psValues->pasBottom = (pointObj *)msSmallRealloc(
+                psValues->pasBottom, sizeof(pointObj) * psValues->nBottom);
+            psValues->papszBottomLabels =
+                (char **)msSmallRealloc(psValues->papszBottomLabels,
+                                        sizeof(char *) * psValues->nBottom);
           }
 
-          psValues->pasBottom[psValues->nBottom-1].x = oFirstPoint.x;
-          psValues->pasBottom[psValues->nBottom-1].y = oFirstPoint.y;
-          psValues->papszBottomLabels[psValues->nBottom-1] = pszLabel;
-
+          psValues->pasBottom[psValues->nBottom - 1].x = oFirstPoint.x;
+          psValues->pasBottom[psValues->nBottom - 1].y = oFirstPoint.y;
+          psValues->papszBottomLabels[psValues->nBottom - 1] = pszLabel;
         }
         /*first point should cross the TOP base where y==0*/
-        if (abs((int)oLastPoint.y) <=1) {
-          char *pszLabel=NULL;
+        if (abs((int)oLastPoint.y) <= 1) {
+          char *pszLabel = NULL;
           oLastPoint.y = 0;
 
           /*validate point is in map width/height*/
@@ -824,20 +839,22 @@ graticuleIntersectionObj *msGraticuleLay
             continue;
 
           if (shapegrid.text)
-            pszLabel =  msStrdup(shapegrid.text);
+            pszLabel = msStrdup(shapegrid.text);
           else {
-            _FormatLabel(layer, &tmpshape, tmpshape.line[0].point[tmpshape.line[0].numpoints-1].x );
+            _FormatLabel(
+                layer, &tmpshape,
+                tmpshape.line[0].point[tmpshape.line[0].numpoints - 1].x);
             if (tmpshape.text)
               pszLabel = msStrdup(tmpshape.text);
             else
               pszLabel = msStrdup("unknown");
           }
           /*validate if same value is not already there*/
-          if ( psValues->nTop > 0) {
+          if (psValues->nTop > 0) {
             /* if (psValues->pasTop[psValues->nTop-1].x == oLastPoint.x)
                  continue; */
 
-            for (i=0; i<psValues->nTop; i++) {
+            for (i = 0; i < psValues->nTop; i++) {
               if (psValues->pasTop[i].x == oLastPoint.x ||
                   strcasecmp(pszLabel, psValues->papszTopLabels[i]) == 0)
                 break;
@@ -848,24 +865,25 @@ graticuleIntersectionObj *msGraticuleLay
             }
           }
 
-
           if (psValues->pasTop == NULL) {
             psValues->pasTop = (pointObj *)msSmallMalloc(sizeof(pointObj));
             psValues->papszTopLabels = (char **)msSmallMalloc(sizeof(char *));
             psValues->nTop = 1;
           } else {
             psValues->nTop++;
-            psValues->pasTop = (pointObj *)msSmallRealloc(psValues->pasTop, sizeof(pointObj)*psValues->nTop);
-            psValues->papszTopLabels = (char **)msSmallRealloc(psValues->papszTopLabels, sizeof(char *)*psValues->nTop);
+            psValues->pasTop = (pointObj *)msSmallRealloc(
+                psValues->pasTop, sizeof(pointObj) * psValues->nTop);
+            psValues->papszTopLabels = (char **)msSmallRealloc(
+                psValues->papszTopLabels, sizeof(char *) * psValues->nTop);
           }
 
-          psValues->pasTop[psValues->nTop-1].x = oLastPoint.x;
-          psValues->pasTop[psValues->nTop-1].y = oLastPoint.y;
-          psValues->papszTopLabels[psValues->nTop-1] = pszLabel;
+          psValues->pasTop[psValues->nTop - 1].x = oLastPoint.x;
+          psValues->pasTop[psValues->nTop - 1].y = oLastPoint.y;
+          psValues->papszTopLabels[psValues->nTop - 1] = pszLabel;
         }
       } else { /*horzontal*/
-        /*Normally lines are drawn from left to right but not always for some reason, so
-          make sure that firstpoint < lastpoint in x*/
+        /*Normally lines are drawn from left to right but not always for some
+          reason, so make sure that firstpoint < lastpoint in x*/
         if (oFirstPoint.x > oLastPoint.x) {
 
           dfTmp = oFirstPoint.x;
@@ -874,11 +892,10 @@ graticuleIntersectionObj *msGraticuleLay
           dfTmp = oFirstPoint.y;
           oFirstPoint.y = oLastPoint.y;
           oLastPoint.y = dfTmp;
-
         }
         /*first point should cross the LEFT base where x=0 axis*/
-        if (abs((int)oFirstPoint.x) <=1) {
-          char *pszLabel=NULL;
+        if (abs((int)oFirstPoint.x) <= 1) {
+          char *pszLabel = NULL;
           oFirstPoint.x = 0;
 
           /*validate point is in map width/height*/
@@ -886,9 +903,11 @@ graticuleIntersectionObj *msGraticuleLay
             continue;
 
           if (shapegrid.text)
-            pszLabel =  msStrdup(shapegrid.text);
+            pszLabel = msStrdup(shapegrid.text);
           else {
-            _FormatLabel(layer, &tmpshape, tmpshape.line[0].point[tmpshape.line[0].numpoints-1].y );
+            _FormatLabel(
+                layer, &tmpshape,
+                tmpshape.line[0].point[tmpshape.line[0].numpoints - 1].y);
             if (tmpshape.text)
               pszLabel = msStrdup(tmpshape.text);
             else
@@ -896,11 +915,11 @@ graticuleIntersectionObj *msGraticuleLay
           }
 
           /*validate that the previous value is not the same*/
-          if ( psValues->nLeft > 0) {
+          if (psValues->nLeft > 0) {
             /* if (psValues->pasLeft[psValues->nLeft-1].y == oFirstPoint.y)
                  continue; */
 
-            for (i=0; i<psValues->nLeft; i++) {
+            for (i = 0; i < psValues->nLeft; i++) {
               if (psValues->pasLeft[i].y == oFirstPoint.y)
                 break;
             }
@@ -915,27 +934,32 @@ graticuleIntersectionObj *msGraticuleLay
             psValues->nLeft = 1;
           } else {
             psValues->nLeft++;
-            psValues->pasLeft = (pointObj *)msSmallRealloc(psValues->pasLeft, sizeof(pointObj)*psValues->nLeft);
-            psValues->papszLeftLabels = (char **)msSmallRealloc(psValues->papszLeftLabels, sizeof(char *)*psValues->nLeft);
+            psValues->pasLeft = (pointObj *)msSmallRealloc(
+                psValues->pasLeft, sizeof(pointObj) * psValues->nLeft);
+            psValues->papszLeftLabels = (char **)msSmallRealloc(
+                psValues->papszLeftLabels, sizeof(char *) * psValues->nLeft);
           }
 
-          psValues->pasLeft[psValues->nLeft-1].x = oFirstPoint.x;
-          psValues->pasLeft[psValues->nLeft-1].y = oFirstPoint.y;
-          psValues->papszLeftLabels[psValues->nLeft-1] = pszLabel; /* takes ownership of allocated pszLabel */
+          psValues->pasLeft[psValues->nLeft - 1].x = oFirstPoint.x;
+          psValues->pasLeft[psValues->nLeft - 1].y = oFirstPoint.y;
+          psValues->papszLeftLabels[psValues->nLeft - 1] =
+              pszLabel; /* takes ownership of allocated pszLabel */
         }
         /*first point should cross the RIGHT base where x=map=>width axis*/
-        if (abs((int)oLastPoint.x - map->width) <=1) {
-          char *pszLabel=NULL;
-          oLastPoint.x =  map->width;
+        if (abs((int)oLastPoint.x - map->width) <= 1) {
+          char *pszLabel = NULL;
+          oLastPoint.x = map->width;
 
           /*validate point is in map width/height*/
           if (oLastPoint.y < 0 || oLastPoint.y > map->height)
             continue;
 
           if (shapegrid.text)
-            pszLabel =  msStrdup(shapegrid.text);
+            pszLabel = msStrdup(shapegrid.text);
           else {
-            _FormatLabel(layer, &tmpshape, tmpshape.line[0].point[tmpshape.line[0].numpoints-1].y );
+            _FormatLabel(
+                layer, &tmpshape,
+                tmpshape.line[0].point[tmpshape.line[0].numpoints - 1].y);
             if (tmpshape.text)
               pszLabel = msStrdup(tmpshape.text);
             else
@@ -943,10 +967,10 @@ graticuleIntersectionObj *msGraticuleLay
           }
 
           /*validate that the previous value is not the same*/
-          if ( psValues->nRight > 0) {
+          if (psValues->nRight > 0) {
             /* if (psValues->pasRight[psValues->nRight-1].y == oLastPoint.y)
                  continue; */
-            for (i=0; i<psValues->nRight; i++) {
+            for (i = 0; i < psValues->nRight; i++) {
               if (psValues->pasRight[i].y == oLastPoint.y)
                 break;
             }
@@ -961,38 +985,36 @@ graticuleIntersectionObj *msGraticuleLay
             psValues->nRight = 1;
           } else {
             psValues->nRight++;
-            psValues->pasRight = (pointObj *)msSmallRealloc(psValues->pasRight, sizeof(pointObj)*psValues->nRight);
-            psValues->papszRightLabels = (char **)msSmallRealloc(psValues->papszRightLabels, sizeof(char *)*psValues->nRight);
+            psValues->pasRight = (pointObj *)msSmallRealloc(
+                psValues->pasRight, sizeof(pointObj) * psValues->nRight);
+            psValues->papszRightLabels = (char **)msSmallRealloc(
+                psValues->papszRightLabels, sizeof(char *) * psValues->nRight);
           }
 
-          psValues->pasRight[psValues->nRight-1].x = oLastPoint.x;
-          psValues->pasRight[psValues->nRight-1].y = oLastPoint.y;
-          psValues->papszRightLabels[psValues->nRight-1] = pszLabel;
+          psValues->pasRight[psValues->nRight - 1].x = oLastPoint.x;
+          psValues->pasRight[psValues->nRight - 1].y = oLastPoint.y;
+          psValues->papszRightLabels[psValues->nRight - 1] = pszLabel;
         }
       }
       msFreeShape(&shapegrid);
       msFreeShape(&tmpshape);
     }
     msInitShape(&shapegrid);
-
-
-
   }
   msLayerClose(layer);
   return psValues;
-
 }
 
-
 /**********************************************************************************************************************
  *
  */
-int msGraticuleLayerInitializeVirtualTable(layerObj *layer)
-{
+int msGraticuleLayerInitializeVirtualTable(layerObj *layer) {
   assert(layer != NULL);
   assert(layer->vtable != NULL);
 
-  layer->vtable->LayerInitItemInfo = msGraticuleLayerInitItemInfo; /* should use defaults for item info functions */
+  layer->vtable->LayerInitItemInfo =
+      msGraticuleLayerInitItemInfo; /* should use defaults for item info
+                                       functions */
   layer->vtable->LayerFreeItemInfo = msGraticuleLayerFreeItemInfo;
   layer->vtable->LayerOpen = msGraticuleLayerOpen;
   layer->vtable->LayerIsOpen = msGraticuleLayerIsOpen;
@@ -1017,208 +1039,208 @@ int msGraticuleLayerInitializeVirtualTab
 /**********************************************************************************************************************
  *
  */
-static void _FormatLabel( layerObj *pLayer, shapeObj *pShape, double dDataToFormat )
-{
+static void _FormatLabel(layerObj *pLayer, shapeObj *pShape,
+                         double dDataToFormat) {
   graticuleObj *pInfo = pLayer->grid;
   char cBuffer[32];
   int iDegrees, iMinutes;
 
-  switch( pInfo->ilabeltype ) {
-    case lpDDMMSS:
-      iDegrees = (int) dDataToFormat;
-      dDataToFormat = fabs( dDataToFormat - (double) iDegrees );
-      iMinutes = (int) (dDataToFormat * 60.0);
-      dDataToFormat = dDataToFormat - (((double) iMinutes) / 60.0);
-      sprintf( cBuffer, pInfo->labelformat, iDegrees, iMinutes, (int) (dDataToFormat * 3600.0) );
-      break;
-    case lpDDMM:
-      iDegrees = (int) dDataToFormat;
-      dDataToFormat = fabs( dDataToFormat - (double) iDegrees );
-      sprintf( cBuffer, pInfo->labelformat, iDegrees, (int) (dDataToFormat * 60.0) );
-      break;
-    case lpDD:
-      iDegrees = (int) dDataToFormat;
-      sprintf( cBuffer, pInfo->labelformat, iDegrees);
-      break;
-    case lpDefault:
-    default:
-      sprintf( cBuffer, pInfo->labelformat, dDataToFormat );
+  switch (pInfo->ilabeltype) {
+  case lpDDMMSS:
+    iDegrees = (int)dDataToFormat;
+    dDataToFormat = fabs(dDataToFormat - (double)iDegrees);
+    iMinutes = (int)(dDataToFormat * 60.0);
+    dDataToFormat = dDataToFormat - (((double)iMinutes) / 60.0);
+    sprintf(cBuffer, pInfo->labelformat, iDegrees, iMinutes,
+            (int)(dDataToFormat * 3600.0));
+    break;
+  case lpDDMM:
+    iDegrees = (int)dDataToFormat;
+    dDataToFormat = fabs(dDataToFormat - (double)iDegrees);
+    sprintf(cBuffer, pInfo->labelformat, iDegrees, (int)(dDataToFormat * 60.0));
+    break;
+  case lpDD:
+    iDegrees = (int)dDataToFormat;
+    sprintf(cBuffer, pInfo->labelformat, iDegrees);
+    break;
+  case lpDefault:
+  default:
+    sprintf(cBuffer, pInfo->labelformat, dDataToFormat);
   }
 
-  pShape->text = msStrdup( cBuffer );
+  pShape->text = msStrdup(cBuffer);
 }
 
 /**********************************************************************************************************************
  *
  *  Move label position into display area by adjusting underlying shape line.
  */
-static int _AdjustLabelPosition( layerObj *pLayer, shapeObj *pShape, msGraticulePosition ePosition )
-{
+static int _AdjustLabelPosition(layerObj *pLayer, shapeObj *pShape,
+                                msGraticulePosition ePosition) {
   graticuleObj *pInfo = pLayer->grid;
   rectObj rectLabel;
   pointObj ptPoint;
   double size = -1;
   char *labeltxt;
 
-  if( pInfo == NULL || pShape == NULL ) {
-    msSetError(MS_MISCERR, "Assertion failed: Null shape or non-configured grid!, ", "_AdjustLabelPosition()");
+  if (pInfo == NULL || pShape == NULL) {
+    msSetError(MS_MISCERR,
+               "Assertion failed: Null shape or non-configured grid!, ",
+               "_AdjustLabelPosition()");
     return MS_FAILURE;
   }
 
-  assert(pLayer->class[0]->numlabels >= 1);
+  assert(pLayer->class[0] -> numlabels >= 1);
 
-  if(msCheckParentPointer(pLayer->map,"map")==MS_FAILURE)
+  if (msCheckParentPointer(pLayer->map, "map") == MS_FAILURE)
     return MS_FAILURE;
 
   ptPoint = pShape->line->point[0];
 
-  if(pLayer->project)
-  {
-    if( pLayer->reprojectorLayerToMap == NULL )
-    {
-        pLayer->reprojectorLayerToMap = msProjectCreateReprojector(
-            &pLayer->projection, &pLayer->map->projection);
+  if (pLayer->project) {
+    if (pLayer->reprojectorLayerToMap == NULL) {
+      pLayer->reprojectorLayerToMap = msProjectCreateReprojector(
+          &pLayer->projection, &pLayer->map->projection);
     }
-    if( pLayer->reprojectorLayerToMap )
-        msProjectShapeEx(pLayer->reprojectorLayerToMap, pShape );
+    if (pLayer->reprojectorLayerToMap)
+      msProjectShapeEx(pLayer->reprojectorLayerToMap, pShape);
 
     /* Poor man detection of reprojection failure */
-    if( msProjIsGeographicCRS(&(pLayer->projection)) != 
-        msProjIsGeographicCRS(&(pLayer->map->projection)) )
-    {
-        if( ptPoint.x == pShape->line->point[0].x &&
-            ptPoint.y == pShape->line->point[0].y )
-        {
-            return MS_FAILURE;
-        }
+    if (msProjIsGeographicCRS(&(pLayer->projection)) !=
+        msProjIsGeographicCRS(&(pLayer->map->projection))) {
+      if (ptPoint.x == pShape->line->point[0].x &&
+          ptPoint.y == pShape->line->point[0].y) {
+        return MS_FAILURE;
+      }
     }
   }
 
-  if(pLayer->transform) {
-    msTransformShapeToPixelRound(pShape, pLayer->map->extent, pLayer->map->cellsize);
+  if (pLayer->transform) {
+    msTransformShapeToPixelRound(pShape, pLayer->map->extent,
+                                 pLayer->map->cellsize);
   }
-  
-  size = pLayer->class[0]->labels[0]->size; /* TODO someday: adjust minsize/maxsize/resolution*/
-  /* We only use the first label as there's no use (yet) in defining multiple lables for GRID layers,
-   as the only label to represent is the longitude or latitude */
-  labeltxt = msShapeGetLabelAnnotation(pLayer, pShape, pLayer->class[0]->labels[0]);
+
+  size = pLayer->class[0]
+             ->labels[0]
+             ->size; /* TODO someday: adjust minsize/maxsize/resolution*/
+  /* We only use the first label as there's no use (yet) in defining multiple
+   lables for GRID layers, as the only label to represent is the longitude or
+   latitude */
+  labeltxt =
+      msShapeGetLabelAnnotation(pLayer, pShape, pLayer->class[0] -> labels[0]);
   assert(labeltxt);
-  if(msGetStringSize(pLayer->map, pLayer->class[0]->labels[0], size, labeltxt, &rectLabel) != MS_SUCCESS) {
+  if (msGetStringSize(pLayer->map, pLayer->class[0] -> labels[0], size,
+                      labeltxt, &rectLabel) != MS_SUCCESS) {
     free(labeltxt);
-    return MS_FAILURE;  /* msSetError already called */
+    return MS_FAILURE; /* msSetError already called */
   }
   free(labeltxt);
 
-  switch( ePosition ) {
-    case posBottom:
-      pShape->line->point[1].y = pLayer->map->height;
-      pShape->line->point[0].y = pLayer->map->height - (fabs(rectLabel.maxy - rectLabel.miny) * 2 + 5);
-      break;
-    case posTop:
-      pShape->line->point[1].y = 0;
-      pShape->line->point[0].y = fabs(rectLabel.maxy - rectLabel.miny) * 2 + 5;
-      break;
-    case posLeft:
-      pShape->line->point[0].x = 0;
-      pShape->line->point[1].x = fabs(rectLabel.maxx - rectLabel.minx) * 2 + 5;
-      break;
-    case posRight:
-      pShape->line->point[1].x = pLayer->map->width;
-      pShape->line->point[0].x = pLayer->map->width - (fabs(rectLabel.maxx - rectLabel.minx) * 2 + 5);
-      break;
+  switch (ePosition) {
+  case posBottom:
+    pShape->line->point[1].y = pLayer->map->height;
+    pShape->line->point[0].y =
+        pLayer->map->height - (fabs(rectLabel.maxy - rectLabel.miny) * 2 + 5);
+    break;
+  case posTop:
+    pShape->line->point[1].y = 0;
+    pShape->line->point[0].y = fabs(rectLabel.maxy - rectLabel.miny) * 2 + 5;
+    break;
+  case posLeft:
+    pShape->line->point[0].x = 0;
+    pShape->line->point[1].x = fabs(rectLabel.maxx - rectLabel.minx) * 2 + 5;
+    break;
+  case posRight:
+    pShape->line->point[1].x = pLayer->map->width;
+    pShape->line->point[0].x =
+        pLayer->map->width - (fabs(rectLabel.maxx - rectLabel.minx) * 2 + 5);
+    break;
   }
 
-  if(pLayer->transform)
-    msTransformPixelToShape( pShape, pLayer->map->extent, pLayer->map->cellsize );
+  if (pLayer->transform)
+    msTransformPixelToShape(pShape, pLayer->map->extent, pLayer->map->cellsize);
 
-  if(pLayer->project)
-  {
+  if (pLayer->project) {
     /* Clamp coordinates into the validity area of the projection, in the */
     /* particular case of EPSG:3857 (WebMercator) to longlat reprojection */
-    if( strstr(pLayer->map->projection.args[0], "epsg:3857") &&
-        msProjIsGeographicCRS(&(pLayer->projection)) )
-    {
-        if( !pLayer->map->projection.gt.need_geotransform &&
-            ePosition == posLeft && pShape->line->point[0].x < -20037508)
-        {
-          pShape->line->point[1].x = -20037508 + (pShape->line->point[1].x -
-                                                  pShape->line->point[0].x);
-          pShape->line->point[0].x = -20037508;
-        }
-        else if( pLayer->map->projection.gt.need_geotransform &&
+    if (strstr(pLayer->map->projection.args[0], "epsg:3857") &&
+        msProjIsGeographicCRS(&(pLayer->projection))) {
+      if (!pLayer->map->projection.gt.need_geotransform &&
+          ePosition == posLeft && pShape->line->point[0].x < -20037508) {
+        pShape->line->point[1].x =
+            -20037508 + (pShape->line->point[1].x - pShape->line->point[0].x);
+        pShape->line->point[0].x = -20037508;
+      } else if (pLayer->map->projection.gt.need_geotransform &&
                  ePosition == posLeft &&
                  pLayer->map->projection.gt.geotransform[0] +
-                    pShape->line->point[0].x *
-                        pLayer->map->projection.gt.geotransform[1] +
-                    pShape->line->point[0].y *
-                        pLayer->map->projection.gt.geotransform[2] < -20037508)
-        {
-          double y_tmp;
-          double width = pShape->line->point[1].x - pShape->line->point[0].x;
+                         pShape->line->point[0].x *
+                             pLayer->map->projection.gt.geotransform[1] +
+                         pShape->line->point[0].y *
+                             pLayer->map->projection.gt.geotransform[2] <
+                     -20037508) {
+        double y_tmp;
+        double width = pShape->line->point[1].x - pShape->line->point[0].x;
 
-          y_tmp = pLayer->map->projection.gt.geotransform[3] +
-            pShape->line->point[0].x *
+        y_tmp = pLayer->map->projection.gt.geotransform[3] +
+                pShape->line->point[0].x *
                     pLayer->map->projection.gt.geotransform[4] +
-            pShape->line->point[0].y *
+                pShape->line->point[0].y *
                     pLayer->map->projection.gt.geotransform[5];
-          pShape->line->point[0].x =
+        pShape->line->point[0].x =
             pLayer->map->projection.gt.invgeotransform[0] +
-                    -20037508 * pLayer->map->projection.gt.invgeotransform[1] +
-                    y_tmp * pLayer->map->projection.gt.invgeotransform[2];
-          pShape->line->point[1].x = pShape->line->point[0].x + width;
-        }
+            -20037508 * pLayer->map->projection.gt.invgeotransform[1] +
+            y_tmp * pLayer->map->projection.gt.invgeotransform[2];
+        pShape->line->point[1].x = pShape->line->point[0].x + width;
+      }
 
-        if( !pLayer->map->projection.gt.need_geotransform &&
-            ePosition == posRight && pShape->line->point[1].x > 20037508)
-        {
-          pShape->line->point[0].x = 20037508 - (pShape->line->point[1].x -
-                                                 pShape->line->point[0].x);
-          pShape->line->point[1].x = 20037508;
-        }
-        else if( pLayer->map->projection.gt.need_geotransform &&
+      if (!pLayer->map->projection.gt.need_geotransform &&
+          ePosition == posRight && pShape->line->point[1].x > 20037508) {
+        pShape->line->point[0].x =
+            20037508 - (pShape->line->point[1].x - pShape->line->point[0].x);
+        pShape->line->point[1].x = 20037508;
+      } else if (pLayer->map->projection.gt.need_geotransform &&
                  ePosition == posRight &&
                  pLayer->map->projection.gt.geotransform[0] +
-                    pShape->line->point[1].x *
-                        pLayer->map->projection.gt.geotransform[1] +
-                    pShape->line->point[1].y *
-                        pLayer->map->projection.gt.geotransform[2] > 20037508)
-        {
-          double y_tmp;
-          double width = pShape->line->point[1].x - pShape->line->point[0].x;
+                         pShape->line->point[1].x *
+                             pLayer->map->projection.gt.geotransform[1] +
+                         pShape->line->point[1].y *
+                             pLayer->map->projection.gt.geotransform[2] >
+                     20037508) {
+        double y_tmp;
+        double width = pShape->line->point[1].x - pShape->line->point[0].x;
 
-          y_tmp = pLayer->map->projection.gt.geotransform[3] +
-            pShape->line->point[1].x *
+        y_tmp = pLayer->map->projection.gt.geotransform[3] +
+                pShape->line->point[1].x *
                     pLayer->map->projection.gt.geotransform[4] +
-            pShape->line->point[1].y *
+                pShape->line->point[1].y *
                     pLayer->map->projection.gt.geotransform[5];
-          pShape->line->point[1].x =
+        pShape->line->point[1].x =
             pLayer->map->projection.gt.invgeotransform[0] +
-                    20037508 * pLayer->map->projection.gt.invgeotransform[1] +
-                    y_tmp * pLayer->map->projection.gt.invgeotransform[2];
-          pShape->line->point[0].x = pShape->line->point[1].x - width;
-        }
+            20037508 * pLayer->map->projection.gt.invgeotransform[1] +
+            y_tmp * pLayer->map->projection.gt.invgeotransform[2];
+        pShape->line->point[0].x = pShape->line->point[1].x - width;
+      }
     }
 
-    if( pLayer->reprojectorMapToLayer == NULL )
-    {
-        pLayer->reprojectorMapToLayer = msProjectCreateReprojector(
-            &pLayer->map->projection, &pLayer->projection);
+    if (pLayer->reprojectorMapToLayer == NULL) {
+      pLayer->reprojectorMapToLayer = msProjectCreateReprojector(
+          &pLayer->map->projection, &pLayer->projection);
     }
-    if( pLayer->reprojectorMapToLayer )
-        msProjectShapeEx(pLayer->reprojectorMapToLayer, pShape );
+    if (pLayer->reprojectorMapToLayer)
+      msProjectShapeEx(pLayer->reprojectorMapToLayer, pShape);
   }
 
-  switch( ePosition ) {
-    case posBottom:
-    case posTop:
-      pShape->line->point[1].x = ptPoint.x;
-      pShape->line->point[0].x = ptPoint.x;
-      break;
-    case posLeft:
-    case posRight:
-      pShape->line->point[1].y = ptPoint.y;
-      pShape->line->point[0].y = ptPoint.y;
-      break;
+  switch (ePosition) {
+  case posBottom:
+  case posTop:
+    pShape->line->point[1].x = ptPoint.x;
+    pShape->line->point[0].x = ptPoint.x;
+    break;
+  case posLeft:
+  case posRight:
+    pShape->line->point[1].y = ptPoint.y;
+    pShape->line->point[0].y = ptPoint.y;
+    break;
   }
 
   return MS_SUCCESS;
@@ -1233,51 +1255,50 @@ static int _AdjustLabelPosition( layerOb
  *
  * Minor tweaks to incrment calculations - jnovak
  */
-void DefineAxis( int iTickCountTarget, double *Min, double *Max, double *Inc )
-{
+void DefineAxis(int iTickCountTarget, double *Min, double *Max, double *Inc) {
   /* define local variables... */
 
-  double Test_inc,    /* candidate increment value */
-         Test_min,    /* minimum scale value */
-         Test_max,    /* maximum scale value */
-         Range = *Max - *Min ;  /* range of data */
+  double Test_inc,         /* candidate increment value */
+      Test_min,            /* minimum scale value */
+      Test_max,            /* maximum scale value */
+      Range = *Max - *Min; /* range of data */
 
-  int i = 0 ;   /* counter */
+  int i = 0; /* counter */
 
   /* don't create problems -- solve them */
 
-  if( Range < 0 )  {
-    *Inc = 0 ;
-    return ;
+  if (Range < 0) {
+    *Inc = 0;
+    return;
   }
 
   /* handle special case of repeated values */
 
-  else if( Range == 0)  {
-    *Min = ceil(*Max) - 1 ;
-    *Max = *Min + 1 ;
-    *Inc = 1 ;
-    return ;
+  else if (Range == 0) {
+    *Min = ceil(*Max) - 1;
+    *Max = *Min + 1;
+    *Inc = 1;
+    return;
   }
 
   /* compute candidate for increment */
 
-  Test_inc = pow( 10.0, ceil( log10( Range/10 ) ) ) ;
-  if(*Inc > 0 && ( Test_inc < *Inc || Test_inc > *Inc ))
+  Test_inc = pow(10.0, ceil(log10(Range / 10)));
+  if (*Inc > 0 && (Test_inc < *Inc || Test_inc > *Inc))
     Test_inc = *Inc;
 
   /* establish maximum scale value... */
-  Test_max = ( (long)(*Max / Test_inc)) * Test_inc ;
+  Test_max = ((long)(*Max / Test_inc)) * Test_inc;
 
-  if( Test_max < *Max )
-    Test_max += Test_inc ;
+  if (Test_max < *Max)
+    Test_max += Test_inc;
 
   /* establish minimum scale value... */
-  Test_min = Test_max ;
+  Test_min = Test_max;
   do {
-    ++i ;
-    Test_min -= Test_inc ;
-  } while( Test_min > *Min ) ;
+    ++i;
+    Test_min -= Test_inc;
+  } while (Test_min > *Min);
 
   /* subtracting small values can screw up the scale limits, */
   /* eg: if DefineAxis is called with (min,max)=(0.01, 0.1), */
@@ -1289,20 +1310,20 @@ void DefineAxis( int iTickCountTarget, d
 
   /* adjust for too few tick marks */
 
-  if(iTickCountTarget <= 0)
-    iTickCountTarget   = MAPGRATICULE_ARC_MINIMUM;
+  if (iTickCountTarget <= 0)
+    iTickCountTarget = MAPGRATICULE_ARC_MINIMUM;
 
-  while(i < iTickCountTarget) {
-    Test_inc /= 2 ;
-    i *= 2 ;
+  while (i < iTickCountTarget) {
+    Test_inc /= 2;
+    i *= 2;
   }
 
-  if(i < 6 && 0) {
-    Test_inc /= 2 ;
-    if((Test_min + Test_inc) <= *Min)
-      Test_min += Test_inc ;
-    if((Test_max - Test_inc) >= *Max)
-      Test_max -= Test_inc ;
+  if (i < 6 && 0) {
+    Test_inc /= 2;
+    if ((Test_min + Test_inc) <= *Min)
+      Test_min += Test_inc;
+    if ((Test_max - Test_inc) >= *Max)
+      Test_max -= Test_inc;
   }
 
   /* pass back axis definition to caller */
diff -pruN 8.0.1-5/maphash.c 8.0.2-1/maphash.c
--- 8.0.1-5/maphash.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/maphash.c	2024-06-11 20:41:34.000000000 +0000
@@ -32,74 +32,69 @@
 #include "mapserver.h"
 #include "maphash.h"
 
-
-
-static unsigned hash(const char *key)
-{
+static unsigned hash(const char *key) {
   unsigned hashval;
 
-  for(hashval=0; *key!='\0'; key++)
+  for (hashval = 0; *key != '\0'; key++)
     hashval = tolower(*key) + 31 * hashval;
 
-  return(hashval % MS_HASHSIZE);
+  return (hashval % MS_HASHSIZE);
 }
 
-hashTableObj *msCreateHashTable()
-{
+hashTableObj *msCreateHashTable() {
   int i;
   hashTableObj *table;
 
-  table = (hashTableObj *) msSmallMalloc(sizeof(hashTableObj));
-  table->items = (struct hashObj **) msSmallMalloc(sizeof(struct hashObj *)*MS_HASHSIZE);
+  table = (hashTableObj *)msSmallMalloc(sizeof(hashTableObj));
+  table->items =
+      (struct hashObj **)msSmallMalloc(sizeof(struct hashObj *) * MS_HASHSIZE);
 
-  for (i=0; i<MS_HASHSIZE; i++)
+  for (i = 0; i < MS_HASHSIZE; i++)
     table->items[i] = NULL;
   table->numitems = 0;
 
   return table;
 }
 
-int initHashTable( hashTableObj *table )
-{
+int initHashTable(hashTableObj *table) {
   int i;
 
-  table->items = (struct hashObj **) malloc(sizeof(struct hashObj *)*MS_HASHSIZE);
-  MS_CHECK_ALLOC(table->items, sizeof(struct hashObj *)*MS_HASHSIZE, MS_FAILURE);
+  table->items =
+      (struct hashObj **)malloc(sizeof(struct hashObj *) * MS_HASHSIZE);
+  MS_CHECK_ALLOC(table->items, sizeof(struct hashObj *) * MS_HASHSIZE,
+                 MS_FAILURE);
 
-  for (i=0; i<MS_HASHSIZE; i++)
+  for (i = 0; i < MS_HASHSIZE; i++)
     table->items[i] = NULL;
   table->numitems = 0;
   return MS_SUCCESS;
 }
 
-void msFreeHashTable( hashTableObj *table )
-{
-  if( table != NULL ) {
+void msFreeHashTable(hashTableObj *table) {
+  if (table != NULL) {
     msFreeHashItems(table);
     free(table);
   }
 }
 
-int msHashIsEmpty( const hashTableObj *table )
-{
-  if (table->numitems == 0 )
+int msHashIsEmpty(const hashTableObj *table) {
+  if (table->numitems == 0)
     return MS_TRUE;
   else
     return MS_FALSE;
 }
 
-
-void msFreeHashItems( hashTableObj *table )
-{
+void msFreeHashItems(hashTableObj *table) {
   int i;
-  struct hashObj *tp=NULL;
-  struct hashObj *prev_tp=NULL;
+  struct hashObj *tp = NULL;
+  struct hashObj *prev_tp = NULL;
 
   if (table) {
-    if(table->items) {
-      for (i=0; i<MS_HASHSIZE; i++) {
+    if (table->items) {
+      for (i = 0; i < MS_HASHSIZE; i++) {
         if (table->items[i] != NULL) {
-          for (tp=table->items[i]; tp!=NULL; prev_tp=tp,tp=tp->next,free(prev_tp)) {
+          for (tp = table->items[i]; tp != NULL;
+               prev_tp = tp, tp = tp->next, free(prev_tp)) {
             msFree(tp->key);
             msFree(tp->data);
           }
@@ -115,23 +110,22 @@ void msFreeHashItems( hashTableObj *tabl
   }
 }
 
-struct hashObj *msInsertHashTable(hashTableObj *table,
-                                  const char *key, const char *value) {
+struct hashObj *msInsertHashTable(hashTableObj *table, const char *key,
+                                  const char *value) {
   struct hashObj *tp;
   unsigned hashval;
 
   if (!table || !key || !value) {
-    msSetError(MS_HASHERR, "Invalid hash table or key",
-               "msInsertHashTable");
+    msSetError(MS_HASHERR, "Invalid hash table or key", "msInsertHashTable");
     return NULL;
   }
 
-  for (tp=table->items[hash(key)]; tp!=NULL; tp=tp->next)
-    if(strcasecmp(key, tp->key) == 0)
+  for (tp = table->items[hash(key)]; tp != NULL; tp = tp->next)
+    if (strcasecmp(key, tp->key) == 0)
       break;
 
   if (tp == NULL) { /* not found */
-    tp = (struct hashObj *) malloc(sizeof(*tp));
+    tp = (struct hashObj *)malloc(sizeof(*tp));
     MS_CHECK_ALLOC(tp, sizeof(*tp), NULL);
     tp->key = msStrdup(key);
     hashval = hash(key);
@@ -148,25 +142,23 @@ struct hashObj *msInsertHashTable(hashTa
   return tp;
 }
 
-const char *msLookupHashTable(const hashTableObj *table, const char *key)
-{
+const char *msLookupHashTable(const hashTableObj *table, const char *key) {
   struct hashObj *tp;
 
   if (!table || !key) {
-    return(NULL);
+    return (NULL);
   }
 
-  for (tp=table->items[hash(key)]; tp!=NULL; tp=tp->next)
+  for (tp = table->items[hash(key)]; tp != NULL; tp = tp->next)
     if (strcasecmp(key, tp->key) == 0)
-      return(tp->data);
+      return (tp->data);
 
   return NULL;
 }
 
-int msRemoveHashTable(hashTableObj *table, const char *key)
-{
+int msRemoveHashTable(hashTableObj *table, const char *key) {
   struct hashObj *tp;
-  struct hashObj *prev_tp=NULL;
+  struct hashObj *prev_tp = NULL;
   int status = MS_FAILURE;
 
   if (!table || !key) {
@@ -174,7 +166,7 @@ int msRemoveHashTable(hashTableObj *tabl
     return MS_FAILURE;
   }
 
-  tp=table->items[hash(key)];
+  tp = table->items[hash(key)];
   if (!tp) {
     msSetError(MS_HASHERR, "No such hash entry", "msRemoveHashTable");
     return MS_FAILURE;
@@ -208,8 +200,7 @@ int msRemoveHashTable(hashTableObj *tabl
   return status;
 }
 
-const char *msFirstKeyFromHashTable( const hashTableObj *table )
-{
+const char *msFirstKeyFromHashTable(const hashTableObj *table) {
   int hash_index;
 
   if (!table) {
@@ -217,16 +208,16 @@ const char *msFirstKeyFromHashTable( con
     return NULL;
   }
 
-  for (hash_index = 0; hash_index < MS_HASHSIZE; hash_index++ ) {
-    if (table->items[hash_index] != NULL )
+  for (hash_index = 0; hash_index < MS_HASHSIZE; hash_index++) {
+    if (table->items[hash_index] != NULL)
       return table->items[hash_index]->key;
   }
 
   return NULL;
 }
 
-const char *msNextKeyFromHashTable( const hashTableObj *table, const char *lastKey )
-{
+const char *msNextKeyFromHashTable(const hashTableObj *table,
+                                   const char *lastKey) {
   int hash_index;
   struct hashObj *link;
 
@@ -235,22 +226,21 @@ const char *msNextKeyFromHashTable( cons
     return NULL;
   }
 
-  if ( lastKey == NULL )
-    return msFirstKeyFromHashTable( table );
+  if (lastKey == NULL)
+    return msFirstKeyFromHashTable(table);
 
   hash_index = hash(lastKey);
-  for ( link = table->items[hash_index];
-        link != NULL && strcasecmp(lastKey,link->key) != 0;
-        link = link->next ) {}
+  for (link = table->items[hash_index];
+       link != NULL && strcasecmp(lastKey, link->key) != 0; link = link->next) {
+  }
 
-  if ( link != NULL && link->next != NULL )
+  if (link != NULL && link->next != NULL)
     return link->next->key;
 
-  while ( ++hash_index < MS_HASHSIZE ) {
-    if ( table->items[hash_index] != NULL )
+  while (++hash_index < MS_HASHSIZE) {
+    if (table->items[hash_index] != NULL)
       return table->items[hash_index]->key;
   }
 
   return NULL;
 }
-
diff -pruN 8.0.1-5/maphash.h 8.0.2-1/maphash.h
--- 8.0.1-5/maphash.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/maphash.h	2024-06-11 20:41:34.000000000 +0000
@@ -35,128 +35,127 @@ extern "C" {
 #endif
 
 #if defined(_WIN32) && !defined(__CYGWIN__)
-#  define MS_DLL_EXPORT     __declspec(dllexport)
+#define MS_DLL_EXPORT __declspec(dllexport)
 #else
-#define  MS_DLL_EXPORT
+#define MS_DLL_EXPORT
 #endif
 
 #define MS_HASHSIZE 41
 
-  /* =========================================================================
-   * Structs
-   * ========================================================================= */
+/* =========================================================================
+ * Structs
+ * ========================================================================= */
 
 #ifndef SWIG
-  struct hashObj {
-    struct hashObj *next;  /* pointer to next item */
-    char           *key;   /* string key that is hashed */
-    char           *data;  /* string stored in this item */
-  };
+struct hashObj {
+  struct hashObj *next; /* pointer to next item */
+  char *key;            /* string key that is hashed */
+  char *data;           /* string stored in this item */
+};
 #endif /*SWIG*/
 
-
 /**
  * An object to store key-value pairs
  *
  */
-  typedef struct {
+typedef struct {
 #ifndef SWIG
-    struct hashObj **items;  /* the hash table */
+  struct hashObj **items; /* the hash table */
 #endif
 #ifdef SWIG
     %immutable;
-#endif /*SWIG*/
-    int              numitems;  ///< \**immutable** number of items
+#endif          /*SWIG*/
+  int numitems; ///< \**immutable** number of items
 #ifdef SWIG
     %mutable;
 #endif /*SWIG*/
-  } hashTableObj;
+} hashTableObj;
 
-  /* =========================================================================
-   * Functions
-   * ========================================================================= */
+/* =========================================================================
+ * Functions
+ * ========================================================================= */
 
 #ifndef SWIG
-  /* msCreateHashTable - create a hash table
-   * ARGS:
-   *     None
-   * RETURNS:
-   *     New hash table
-   */
-  MS_DLL_EXPORT hashTableObj *msCreateHashTable( void );
-
-  /* For use in mapfile.c with hashTableObj structure members */
-  MS_DLL_EXPORT int initHashTable( hashTableObj *table );
-
-  /* msFreeHashTable - free allocated memory
-   * ARGS:
-   *     table - target hash table
-   * RETURNS:
-   *     None
-   */
-  MS_DLL_EXPORT void msFreeHashTable( hashTableObj *table );
-
-  /* Free only the items for hashTableObj structure members (metadata, &c) */
-  MS_DLL_EXPORT void msFreeHashItems( hashTableObj *table );
-
-  /* msInsertHashTable - insert new item
-   * ARGS:
-   *     table - the target hash table
-   *     key   - key string for new item
-   *     value - data string for new item
-   * RETURNS:
-   *     pointer to the new item or NULL
-   * EXCEPTIONS:
-   *     raise MS_HASHERR on failure
-   */
-  MS_DLL_EXPORT struct hashObj *msInsertHashTable( hashTableObj *table,
-      const char *key,
-      const char *value );
-
-  /* msLookupHashTable - get the value of an item by its key
-   * ARGS:
-   *     table - the target hash table
-   *     key   - key string of item
-   * RETURNS:
-   *     string value of item
-   */
-  MS_DLL_EXPORT const char *msLookupHashTable( const hashTableObj *table, const char *key);
-
-  /* msRemoveHashTable - remove item from table at key
-   * ARGS:
-   *     table - target hash table
-   *     key   - key string
-   * RETURNS:
-   *     MS_SUCCESS or MS_FAILURE
-   */
-  MS_DLL_EXPORT int msRemoveHashTable( hashTableObj *table, const char *key);
-
-  /* msFirstKeyFromHashTable - get key of first item
-   * ARGS:
-   *     table - target hash table
-   * RETURNS:
-   *     first key as a string
-   */
-  MS_DLL_EXPORT const char *msFirstKeyFromHashTable( const hashTableObj *table );
-
-  /* msNextKeyFromHashTable - get next key
-   * ARGS:
-   *     table - target hash table
-   *     prevkey - the previous key
-   * RETURNS:
-   *     the key of the item of following prevkey as a string
-   */
-  MS_DLL_EXPORT const char *msNextKeyFromHashTable( const hashTableObj *table,
-      const char *prevkey );
-
-  /* msHashIsEmpty - get next key
-   * ARGS:
-   *     table - target hash table
-   * RETURNS:
-   *     MS_TRUE if the table is empty and MS_FALSE if the table has items
-   */
+/* msCreateHashTable - create a hash table
+ * ARGS:
+ *     None
+ * RETURNS:
+ *     New hash table
+ */
+MS_DLL_EXPORT hashTableObj *msCreateHashTable(void);
+
+/* For use in mapfile.c with hashTableObj structure members */
+MS_DLL_EXPORT int initHashTable(hashTableObj *table);
+
+/* msFreeHashTable - free allocated memory
+ * ARGS:
+ *     table - target hash table
+ * RETURNS:
+ *     None
+ */
+MS_DLL_EXPORT void msFreeHashTable(hashTableObj *table);
+
+/* Free only the items for hashTableObj structure members (metadata, &c) */
+MS_DLL_EXPORT void msFreeHashItems(hashTableObj *table);
+
+/* msInsertHashTable - insert new item
+ * ARGS:
+ *     table - the target hash table
+ *     key   - key string for new item
+ *     value - data string for new item
+ * RETURNS:
+ *     pointer to the new item or NULL
+ * EXCEPTIONS:
+ *     raise MS_HASHERR on failure
+ */
+MS_DLL_EXPORT struct hashObj *
+msInsertHashTable(hashTableObj *table, const char *key, const char *value);
+
+/* msLookupHashTable - get the value of an item by its key
+ * ARGS:
+ *     table - the target hash table
+ *     key   - key string of item
+ * RETURNS:
+ *     string value of item
+ */
+MS_DLL_EXPORT const char *msLookupHashTable(const hashTableObj *table,
+                                            const char *key);
+
+/* msRemoveHashTable - remove item from table at key
+ * ARGS:
+ *     table - target hash table
+ *     key   - key string
+ * RETURNS:
+ *     MS_SUCCESS or MS_FAILURE
+ */
+MS_DLL_EXPORT int msRemoveHashTable(hashTableObj *table, const char *key);
+
+/* msFirstKeyFromHashTable - get key of first item
+ * ARGS:
+ *     table - target hash table
+ * RETURNS:
+ *     first key as a string
+ */
+MS_DLL_EXPORT const char *msFirstKeyFromHashTable(const hashTableObj *table);
+
+/* msNextKeyFromHashTable - get next key
+ * ARGS:
+ *     table - target hash table
+ *     prevkey - the previous key
+ * RETURNS:
+ *     the key of the item of following prevkey as a string
+ */
+MS_DLL_EXPORT const char *msNextKeyFromHashTable(const hashTableObj *table,
+                                                 const char *prevkey);
+
+/* msHashIsEmpty - get next key
+ * ARGS:
+ *     table - target hash table
+ * RETURNS:
+ *     MS_TRUE if the table is empty and MS_FALSE if the table has items
+ */
 
-  MS_DLL_EXPORT int msHashIsEmpty( const hashTableObj* table );
+MS_DLL_EXPORT int msHashIsEmpty(const hashTableObj *table);
 
 #endif /*SWIG*/
 
diff -pruN 8.0.1-5/maphttp.c 8.0.2-1/maphttp.c
--- 8.0.1-5/maphttp.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/maphttp.c	2024-06-11 20:41:34.000000000 +0000
@@ -57,8 +57,8 @@
  */
 #include <curl/curl.h>
 
-
-#define unchecked_curl_easy_setopt(handle,opt,param) IGNORE_RET_VAL(curl_easy_setopt(handle,opt,param))
+#define unchecked_curl_easy_setopt(handle, opt, param)                         \
+  IGNORE_RET_VAL(curl_easy_setopt(handle, opt, param))
 
 /**********************************************************************
  *                          msHTTPInit()
@@ -74,19 +74,16 @@
  **********************************************************************/
 static int gbCurlInitialized = MS_FALSE;
 
-int msHTTPInit()
-{
+int msHTTPInit() {
   /* curl_global_init() should only be called once (no matter how
    * many threads or libcurl sessions that'll be used) by every
    * application that uses libcurl.
    */
 
   msAcquireLock(TLOCK_OWS);
-  if (!gbCurlInitialized &&
-      curl_global_init(CURL_GLOBAL_ALL) != 0) {
+  if (!gbCurlInitialized && curl_global_init(CURL_GLOBAL_ALL) != 0) {
     msReleaseLock(TLOCK_OWS);
-    msSetError(MS_HTTPERR, "Libcurl initialization failed.",
-               "msHTTPInit()");
+    msSetError(MS_HTTPERR, "Libcurl initialization failed.", "msHTTPInit()");
     return MS_FAILURE;
   }
 
@@ -96,13 +93,11 @@ int msHTTPInit()
   return MS_SUCCESS;
 }
 
-
 /**********************************************************************
  *                          msHTTPCleanup()
  *
  **********************************************************************/
-void msHTTPCleanup()
-{
+void msHTTPCleanup() {
   msAcquireLock(TLOCK_OWS);
   if (gbCurlInitialized)
     curl_global_cleanup();
@@ -111,7 +106,6 @@ void msHTTPCleanup()
   msReleaseLock(TLOCK_OWS);
 }
 
-
 /**********************************************************************
  *                          msHTTPInitRequestObj()
  *
@@ -119,11 +113,10 @@ void msHTTPCleanup()
  * for use with msHTTPExecuteRequest(), etc.
  *
  **********************************************************************/
-void msHTTPInitRequestObj(httpRequestObj *pasReqInfo, int numRequests)
-{
+void msHTTPInitRequestObj(httpRequestObj *pasReqInfo, int numRequests) {
   int i;
 
-  for(i=0; i<numRequests; i++) {
+  for (i = 0; i < numRequests; i++) {
     pasReqInfo[i].pszGetUrl = NULL;
     pasReqInfo[i].pszPostRequest = NULL;
     pasReqInfo[i].pszPostContentType = NULL;
@@ -152,15 +145,13 @@ void msHTTPInitRequestObj(httpRequestObj
   }
 }
 
-
 /**********************************************************************
  *                          msHTTPFreeRequestObj()
  *
  **********************************************************************/
-void msHTTPFreeRequestObj(httpRequestObj *pasReqInfo, int numRequests)
-{
+void msHTTPFreeRequestObj(httpRequestObj *pasReqInfo, int numRequests) {
   int i;
-  for(i=0; i<numRequests; i++) {
+  for (i = 0; i < numRequests; i++) {
     if (pasReqInfo[i].pszGetUrl)
       free(pasReqInfo[i].pszGetUrl);
     pasReqInfo[i].pszGetUrl = NULL;
@@ -195,14 +186,13 @@ void msHTTPFreeRequestObj(httpRequestObj
 
     pasReqInfo[i].curl_handle = NULL;
 
-    free( pasReqInfo[i].result_data );
+    free(pasReqInfo[i].result_data);
     pasReqInfo[i].result_data = NULL;
     pasReqInfo[i].result_size = 0;
     pasReqInfo[i].result_buf_size = 0;
   }
 }
 
-
 /**********************************************************************
  *                          msHTTPWriteFct()
  *
@@ -214,55 +204,53 @@ void msHTTPFreeRequestObj(httpRequestObj
  *
  **********************************************************************/
 static size_t msHTTPWriteFct(void *buffer, size_t size, size_t nmemb,
-                             void *reqInfo)
-{
+                             void *reqInfo) {
   httpRequestObj *psReq;
 
   psReq = (httpRequestObj *)reqInfo;
 
   if (psReq->debug) {
-    msDebug("msHTTPWriteFct(id=%d, %d bytes)\n",
-            psReq->nLayerId, (int)(size*nmemb));
+    msDebug("msHTTPWriteFct(id=%d, %d bytes)\n", psReq->nLayerId,
+            (int)(size * nmemb));
   }
 
-  if(psReq->nMaxBytes > 0 && (psReq->result_size + size*nmemb) > (size_t)psReq->nMaxBytes) {
-      msSetError(MS_HTTPERR, "Requested transfer larger than configured maximum %d.",
-                 "msHTTPWriteFct()",
-                 psReq->nMaxBytes );
-      return -1;
+  if (psReq->nMaxBytes > 0 &&
+      (psReq->result_size + size * nmemb) > (size_t)psReq->nMaxBytes) {
+    msSetError(MS_HTTPERR,
+               "Requested transfer larger than configured maximum %d.",
+               "msHTTPWriteFct()", psReq->nMaxBytes);
+    return -1;
   }
   /* Case where we are writing to a disk file. */
-  if( psReq->fp != NULL ) {
-    psReq->result_size += size*nmemb;
+  if (psReq->fp != NULL) {
+    psReq->result_size += size * nmemb;
     return fwrite(buffer, size, nmemb, psReq->fp);
   }
 
   /* Case where we build up the result in memory */
   else {
-    if( psReq->result_data == NULL ) {
-      psReq->result_buf_size = size*nmemb + 10000;
-      psReq->result_data = (char *) msSmallMalloc( psReq->result_buf_size );
-    } else if( psReq->result_size + nmemb * size > (size_t)psReq->result_buf_size ) {
-      psReq->result_buf_size = psReq->result_size + nmemb*size + 10000;
-      psReq->result_data = (char *) msSmallRealloc( psReq->result_data,
-                           psReq->result_buf_size );
+    if (psReq->result_data == NULL) {
+      psReq->result_buf_size = size * nmemb + 10000;
+      psReq->result_data = (char *)msSmallMalloc(psReq->result_buf_size);
+    } else if (psReq->result_size + nmemb * size >
+               (size_t)psReq->result_buf_size) {
+      psReq->result_buf_size = psReq->result_size + nmemb * size + 10000;
+      psReq->result_data =
+          (char *)msSmallRealloc(psReq->result_data, psReq->result_buf_size);
     }
 
-    if( psReq->result_data == NULL ) {
-      msSetError(MS_HTTPERR,
-                 "Unable to grow HTTP result buffer to size %d.",
-                 "msHTTPWriteFct()",
-                 psReq->result_buf_size );
+    if (psReq->result_data == NULL) {
+      msSetError(MS_HTTPERR, "Unable to grow HTTP result buffer to size %d.",
+                 "msHTTPWriteFct()", psReq->result_buf_size);
       psReq->result_buf_size = 0;
       psReq->result_size = 0;
       return -1;
     }
 
-    memcpy( psReq->result_data + psReq->result_size,
-            buffer, size*nmemb );
-    psReq->result_size += size*nmemb;
+    memcpy(psReq->result_data + psReq->result_size, buffer, size * nmemb);
+    psReq->result_size += size * nmemb;
 
-    return size*nmemb;
+    return size * nmemb;
   }
 }
 
@@ -272,25 +260,23 @@ static size_t msHTTPWriteFct(void *buffe
  * Returns the equivalent CURL CURLAUTH_ constant given a
  * MS_HTTP_AUTH_TYPE, or CURLAUTH_BASIC if no match is found.
  **********************************************************************/
-long msGetCURLAuthType(enum MS_HTTP_AUTH_TYPE authType)
-{
+long msGetCURLAuthType(enum MS_HTTP_AUTH_TYPE authType) {
   switch (authType) {
-    case MS_BASIC:
-      return CURLAUTH_BASIC;
-    case MS_DIGEST:
-      return CURLAUTH_DIGEST;
-    case MS_NTLM:
-      return CURLAUTH_NTLM;
-    case MS_ANY:
-      return CURLAUTH_ANY;
-    case MS_ANYSAFE:
-      return CURLAUTH_ANYSAFE;
-    default:
-      return CURLAUTH_BASIC;
+  case MS_BASIC:
+    return CURLAUTH_BASIC;
+  case MS_DIGEST:
+    return CURLAUTH_DIGEST;
+  case MS_NTLM:
+    return CURLAUTH_NTLM;
+  case MS_ANY:
+    return CURLAUTH_ANY;
+  case MS_ANYSAFE:
+    return CURLAUTH_ANYSAFE;
+  default:
+    return CURLAUTH_BASIC;
   }
 }
 
-
 /**********************************************************************
  *                          msHTTPAuthProxySetup()
  *
@@ -303,35 +289,33 @@ long msGetCURLAuthType(enum MS_HTTP_AUTH
  **********************************************************************/
 int msHTTPAuthProxySetup(hashTableObj *mapmd, hashTableObj *lyrmd,
                          httpRequestObj *pasReqInfo, int numRequests,
-                         mapObj *map, const char* namespaces)
-{
+                         mapObj *map, const char *namespaces) {
 
   const char *pszTmp;
-  char    *pszProxyHost=NULL;
-  long     nProxyPort=0;
-  char    *pszProxyUsername=NULL, *pszProxyPassword=NULL;
-  char    *pszHttpAuthUsername=NULL, *pszHttpAuthPassword=NULL;
+  char *pszProxyHost = NULL;
+  long nProxyPort = 0;
+  char *pszProxyUsername = NULL, *pszProxyPassword = NULL;
+  char *pszHttpAuthUsername = NULL, *pszHttpAuthPassword = NULL;
   enum MS_HTTP_AUTH_TYPE eHttpAuthType = MS_BASIC;
   enum MS_HTTP_AUTH_TYPE eProxyAuthType = MS_BASIC;
   enum MS_HTTP_PROXY_TYPE eProxyType = MS_HTTP;
 
-
   /* ------------------------------------------------------------------
-   * Check for authentication and proxying metadata. If the metadata is not found
-   * in the layer metadata, check the map-level metadata.
+   * Check for authentication and proxying metadata. If the metadata is not
+   * found in the layer metadata, check the map-level metadata.
    * ------------------------------------------------------------------ */
-  if ((pszTmp = msOWSLookupMetadata2(lyrmd, mapmd, namespaces,
-                                     "proxy_host")) != NULL) {
+  if ((pszTmp = msOWSLookupMetadata2(lyrmd, mapmd, namespaces, "proxy_host")) !=
+      NULL) {
     pszProxyHost = msStrdup(pszTmp);
   }
 
-  if ((pszTmp = msOWSLookupMetadata2(lyrmd, mapmd, namespaces,
-                                     "proxy_port")) != NULL) {
+  if ((pszTmp = msOWSLookupMetadata2(lyrmd, mapmd, namespaces, "proxy_port")) !=
+      NULL) {
     nProxyPort = atol(pszTmp);
   }
 
-  if ((pszTmp = msOWSLookupMetadata2(lyrmd, mapmd, namespaces,
-                                     "proxy_type")) != NULL) {
+  if ((pszTmp = msOWSLookupMetadata2(lyrmd, mapmd, namespaces, "proxy_type")) !=
+      NULL) {
 
     if (strcasecmp(pszTmp, "HTTP") == 0)
       eProxyType = MS_HTTP;
@@ -363,7 +347,6 @@ int msHTTPAuthProxySetup(hashTableObj *m
     }
   }
 
-
   if ((pszTmp = msOWSLookupMetadata2(lyrmd, mapmd, namespaces,
                                      "proxy_username")) != NULL) {
     pszProxyUsername = msStrdup(pszTmp);
@@ -375,12 +358,12 @@ int msHTTPAuthProxySetup(hashTableObj *m
     if (pszProxyPassword == NULL) {
       msFree(pszProxyHost);
       msFree(pszProxyUsername);
-      return(MS_FAILURE);  /* An error should already have been produced */
+      return (MS_FAILURE); /* An error should already have been produced */
     }
   }
 
-  if ((pszTmp = msOWSLookupMetadata2(lyrmd, mapmd, namespaces,
-                                     "auth_type")) != NULL) {
+  if ((pszTmp = msOWSLookupMetadata2(lyrmd, mapmd, namespaces, "auth_type")) !=
+      NULL) {
     if (strcasecmp(pszTmp, "BASIC") == 0)
       eHttpAuthType = MS_BASIC;
     else if (strcasecmp(pszTmp, "DIGEST") == 0)
@@ -411,19 +394,19 @@ int msHTTPAuthProxySetup(hashTableObj *m
       msFree(pszProxyHost);
       msFree(pszProxyUsername);
       msFree(pszProxyPassword);
-      return(MS_FAILURE);  /* An error should already have been produced */
+      return (MS_FAILURE); /* An error should already have been produced */
     }
   }
 
-  pasReqInfo[numRequests].pszProxyAddress  = pszProxyHost;
-  pasReqInfo[numRequests].nProxyPort       = nProxyPort;
-  pasReqInfo[numRequests].eProxyType       = eProxyType;
-  pasReqInfo[numRequests].eProxyAuthType   = eProxyAuthType;
+  pasReqInfo[numRequests].pszProxyAddress = pszProxyHost;
+  pasReqInfo[numRequests].nProxyPort = nProxyPort;
+  pasReqInfo[numRequests].eProxyType = eProxyType;
+  pasReqInfo[numRequests].eProxyAuthType = eProxyAuthType;
   pasReqInfo[numRequests].pszProxyUsername = pszProxyUsername;
   pasReqInfo[numRequests].pszProxyPassword = pszProxyPassword;
-  pasReqInfo[numRequests].eHttpAuthType    = eHttpAuthType;
-  pasReqInfo[numRequests].pszHttpUsername  = pszHttpAuthUsername;
-  pasReqInfo[numRequests].pszHttpPassword  = pszHttpAuthPassword;
+  pasReqInfo[numRequests].eHttpAuthType = eHttpAuthType;
+  pasReqInfo[numRequests].pszHttpUsername = pszHttpAuthUsername;
+  pasReqInfo[numRequests].pszHttpPassword = pszHttpAuthPassword;
 
   return MS_SUCCESS;
 }
@@ -442,16 +425,15 @@ int msHTTPAuthProxySetup(hashTableObj *m
  * MS_DONE if some requests failed with 40x status for instance (not fatal)
  **********************************************************************/
 int msHTTPExecuteRequests(httpRequestObj *pasReqInfo, int numRequests,
-                          int bCheckLocalCache)
-{
-  int     i, nStatus = MS_SUCCESS, nTimeout, still_running=0, num_msgs=0;
-  CURLM   *multi_handle;
+                          int bCheckLocalCache) {
+  int i, nStatus = MS_SUCCESS, nTimeout, still_running = 0, num_msgs = 0;
+  CURLM *multi_handle;
   CURLMsg *curl_msg;
-  char     debug = MS_FALSE;
+  char debug = MS_FALSE;
   const char *pszCurlCABundle = NULL;
 
   if (numRequests == 0)
-    return MS_SUCCESS;  /* Nothing to do */
+    return MS_SUCCESS; /* Nothing to do */
 
   if (!gbCurlInitialized)
     msHTTPInit();
@@ -461,12 +443,12 @@ int msHTTPExecuteRequests(httpRequestObj
    * We use the longest timeout value in the array of requests
    */
   nTimeout = pasReqInfo[0].nTimeout;
-  for (i=0; i<numRequests; i++) {
+  for (i = 0; i < numRequests; i++) {
     if (pasReqInfo[i].nTimeout > nTimeout)
       nTimeout = pasReqInfo[i].nTimeout;
 
     if (pasReqInfo[i].debug)
-      debug = MS_TRUE;  /* For the download loop */
+      debug = MS_TRUE; /* For the download loop */
   }
 
   if (nTimeout <= 0)
@@ -484,7 +466,7 @@ int msHTTPExecuteRequests(httpRequestObj
       msDebug("Using CURL_CA_BUNDLE=%s\n", pszCurlCABundle);
   }
 
-  const char* pszHttpVersion = CPLGetConfigOption("CURL_HTTP_VERSION", NULL);
+  const char *pszHttpVersion = CPLGetConfigOption("CURL_HTTP_VERSION", NULL);
 
   /* Alloc a curl-multi handle, and add a curl-easy handle to it for each
    * file to download.
@@ -493,22 +475,22 @@ int msHTTPExecuteRequests(httpRequestObj
   if (multi_handle == NULL) {
     msSetError(MS_HTTPERR, "curl_multi_init() failed.",
                "msHTTPExecuteRequests()");
-    return(MS_FAILURE);
+    return (MS_FAILURE);
   }
 
-  for (i=0; i<numRequests; i++) {
+  for (i = 0; i < numRequests; i++) {
     CURL *http_handle;
     FILE *fp;
 
-    if (pasReqInfo[i].pszGetUrl == NULL ) {
+    if (pasReqInfo[i].pszGetUrl == NULL) {
       msSetError(MS_HTTPERR, "URL or output file parameter missing.",
                  "msHTTPExecuteRequests()");
-      return(MS_FAILURE);
+      return (MS_FAILURE);
     }
 
     if (pasReqInfo[i].debug) {
-      msDebug("HTTP request: id=%d, %s\n",
-              pasReqInfo[i].nLayerId, pasReqInfo[i].pszGetUrl);
+      msDebug("HTTP request: id=%d, %s\n", pasReqInfo[i].nLayerId,
+              pasReqInfo[i].pszGetUrl);
     }
 
     /* Reset some members */
@@ -518,7 +500,7 @@ int msHTTPExecuteRequests(httpRequestObj
     pasReqInfo[i].pszContentType = NULL;
 
     /* Check local cache if requested */
-    if (bCheckLocalCache && pasReqInfo[i].pszOutputFile != NULL ) {
+    if (bCheckLocalCache && pasReqInfo[i].pszOutputFile != NULL) {
       fp = fopen(pasReqInfo[i].pszOutputFile, "r");
       if (fp) {
         /* File already there, don't download again. */
@@ -537,22 +519,24 @@ int msHTTPExecuteRequests(httpRequestObj
     if (http_handle == NULL) {
       msSetError(MS_HTTPERR, "curl_easy_init() failed.",
                  "msHTTPExecuteRequests()");
-      return(MS_FAILURE);
+      return (MS_FAILURE);
     }
 
     pasReqInfo[i].curl_handle = http_handle;
 
     /* set URL, note that curl keeps only a ref to our string buffer */
-    unchecked_curl_easy_setopt(http_handle, CURLOPT_URL, pasReqInfo[i].pszGetUrl );
+    unchecked_curl_easy_setopt(http_handle, CURLOPT_URL,
+                               pasReqInfo[i].pszGetUrl);
 
-    unchecked_curl_easy_setopt(http_handle, CURLOPT_PROTOCOLS, CURLPROTO_HTTP|CURLPROTO_HTTPS );
+    unchecked_curl_easy_setopt(http_handle, CURLOPT_PROTOCOLS,
+                               CURLPROTO_HTTP | CURLPROTO_HTTPS);
 
     if (pszHttpVersion && strcmp(pszHttpVersion, "1.0") == 0)
-        unchecked_curl_easy_setopt(http_handle, CURLOPT_HTTP_VERSION,
-                                   CURL_HTTP_VERSION_1_0);
+      unchecked_curl_easy_setopt(http_handle, CURLOPT_HTTP_VERSION,
+                                 CURL_HTTP_VERSION_1_0);
     else if (pszHttpVersion && strcmp(pszHttpVersion, "1.1") == 0)
-        unchecked_curl_easy_setopt(http_handle, CURLOPT_HTTP_VERSION,
-                                   CURL_HTTP_VERSION_1_1);
+      unchecked_curl_easy_setopt(http_handle, CURLOPT_HTTP_VERSION,
+                                 CURL_HTTP_VERSION_1_1);
 
     /* Set User-Agent (auto-generate if not set by caller */
     if (pasReqInfo[i].pszUserAgent == NULL) {
@@ -560,95 +544,93 @@ int msHTTPExecuteRequests(httpRequestObj
 
       psCurlVInfo = curl_version_info(CURLVERSION_NOW);
 
-      pasReqInfo[i].pszUserAgent = (char*)msSmallMalloc(100*sizeof(char));
+      pasReqInfo[i].pszUserAgent = (char *)msSmallMalloc(100 * sizeof(char));
 
       if (pasReqInfo[i].pszUserAgent) {
-        sprintf(pasReqInfo[i].pszUserAgent,
-                "MapServer/%s libcurl/%d.%d.%d",
-                MS_VERSION,
-                psCurlVInfo->version_num/0x10000 & 0xff,
-                psCurlVInfo->version_num/0x100 & 0xff,
-                psCurlVInfo->version_num & 0xff );
+        sprintf(pasReqInfo[i].pszUserAgent, "MapServer/%s libcurl/%d.%d.%d",
+                MS_VERSION, psCurlVInfo->version_num / 0x10000 & 0xff,
+                psCurlVInfo->version_num / 0x100 & 0xff,
+                psCurlVInfo->version_num & 0xff);
       }
     }
     if (pasReqInfo[i].pszUserAgent) {
-      unchecked_curl_easy_setopt(http_handle,
-                       CURLOPT_USERAGENT, pasReqInfo[i].pszUserAgent );
+      unchecked_curl_easy_setopt(http_handle, CURLOPT_USERAGENT,
+                                 pasReqInfo[i].pszUserAgent);
     }
 
     /* Enable following redirections.  Requires libcurl 7.10.1 at least */
-    unchecked_curl_easy_setopt(http_handle, CURLOPT_FOLLOWLOCATION, 1 );
-    unchecked_curl_easy_setopt(http_handle, CURLOPT_MAXREDIRS, 10 );
+    unchecked_curl_easy_setopt(http_handle, CURLOPT_FOLLOWLOCATION, 1);
+    unchecked_curl_easy_setopt(http_handle, CURLOPT_MAXREDIRS, 10);
 
     /* Set timeout.*/
-    unchecked_curl_easy_setopt(http_handle, CURLOPT_TIMEOUT, nTimeout );
+    unchecked_curl_easy_setopt(http_handle, CURLOPT_TIMEOUT, nTimeout);
 
     /* Pass CURL_CA_BUNDLE if set */
     if (pszCurlCABundle)
-      unchecked_curl_easy_setopt(http_handle, CURLOPT_CAINFO, pszCurlCABundle );
+      unchecked_curl_easy_setopt(http_handle, CURLOPT_CAINFO, pszCurlCABundle);
 
     /* Set proxying settings */
-    if (pasReqInfo[i].pszProxyAddress != NULL
-        && strlen(pasReqInfo[i].pszProxyAddress) > 0) {
-      long    nProxyType     = CURLPROXY_HTTP;
+    if (pasReqInfo[i].pszProxyAddress != NULL &&
+        strlen(pasReqInfo[i].pszProxyAddress) > 0) {
+      long nProxyType = CURLPROXY_HTTP;
 
       unchecked_curl_easy_setopt(http_handle, CURLOPT_PROXY,
-                       pasReqInfo[i].pszProxyAddress);
+                                 pasReqInfo[i].pszProxyAddress);
 
-      if (pasReqInfo[i].nProxyPort > 0
-          && pasReqInfo[i].nProxyPort < 65535) {
+      if (pasReqInfo[i].nProxyPort > 0 && pasReqInfo[i].nProxyPort < 65535) {
         unchecked_curl_easy_setopt(http_handle, CURLOPT_PROXYPORT,
-                         pasReqInfo[i].nProxyPort);
+                                   pasReqInfo[i].nProxyPort);
       }
 
       switch (pasReqInfo[i].eProxyType) {
-        case MS_HTTP:
-          nProxyType = CURLPROXY_HTTP;
-          break;
-        case MS_SOCKS5:
-          nProxyType = CURLPROXY_SOCKS5;
-          break;
+      case MS_HTTP:
+        nProxyType = CURLPROXY_HTTP;
+        break;
+      case MS_SOCKS5:
+        nProxyType = CURLPROXY_SOCKS5;
+        break;
       }
       unchecked_curl_easy_setopt(http_handle, CURLOPT_PROXYTYPE, nProxyType);
 
       /* If there is proxy authentication information, set it */
-      if (pasReqInfo[i].pszProxyUsername != NULL
-          && pasReqInfo[i].pszProxyPassword != NULL
-          && strlen(pasReqInfo[i].pszProxyUsername) > 0
-          && strlen(pasReqInfo[i].pszProxyPassword) > 0) {
-        char    szUsernamePasswd[128];
+      if (pasReqInfo[i].pszProxyUsername != NULL &&
+          pasReqInfo[i].pszProxyPassword != NULL &&
+          strlen(pasReqInfo[i].pszProxyUsername) > 0 &&
+          strlen(pasReqInfo[i].pszProxyPassword) > 0) {
+        char szUsernamePasswd[128];
 #if LIBCURL_VERSION_NUM >= 0x070a07
-        long    nProxyAuthType = CURLAUTH_BASIC;
+        long nProxyAuthType = CURLAUTH_BASIC;
         /* CURLOPT_PROXYAUTH available only in Curl 7.10.7 and up */
         nProxyAuthType = msGetCURLAuthType(pasReqInfo[i].eProxyAuthType);
-        unchecked_curl_easy_setopt(http_handle, CURLOPT_PROXYAUTH, nProxyAuthType);
+        unchecked_curl_easy_setopt(http_handle, CURLOPT_PROXYAUTH,
+                                   nProxyAuthType);
 #else
         /* We log an error but don't abort processing */
-        msSetError(MS_HTTPERR, "CURLOPT_PROXYAUTH not supported. Requires Curl 7.10.7 and up. *_proxy_auth_type setting ignored.",
+        msSetError(MS_HTTPERR,
+                   "CURLOPT_PROXYAUTH not supported. Requires Curl 7.10.7 and "
+                   "up. *_proxy_auth_type setting ignored.",
                    "msHTTPExecuteRequests()");
 #endif /* LIBCURL_VERSION_NUM */
 
-        snprintf(szUsernamePasswd, 127, "%s:%s",
-                 pasReqInfo[i].pszProxyUsername,
+        snprintf(szUsernamePasswd, 127, "%s:%s", pasReqInfo[i].pszProxyUsername,
                  pasReqInfo[i].pszProxyPassword);
         unchecked_curl_easy_setopt(http_handle, CURLOPT_PROXYUSERPWD,
-                         szUsernamePasswd);
+                                   szUsernamePasswd);
       }
     }
 
     /* Set HTTP Authentication settings */
-    if (pasReqInfo[i].pszHttpUsername != NULL
-        && pasReqInfo[i].pszHttpPassword != NULL
-        && strlen(pasReqInfo[i].pszHttpUsername) > 0
-        && strlen(pasReqInfo[i].pszHttpPassword) > 0) {
-      char    szUsernamePasswd[128];
-      long    nHttpAuthType = CURLAUTH_BASIC;
+    if (pasReqInfo[i].pszHttpUsername != NULL &&
+        pasReqInfo[i].pszHttpPassword != NULL &&
+        strlen(pasReqInfo[i].pszHttpUsername) > 0 &&
+        strlen(pasReqInfo[i].pszHttpPassword) > 0) {
+      char szUsernamePasswd[128];
+      long nHttpAuthType = CURLAUTH_BASIC;
 
-      snprintf(szUsernamePasswd, 127, "%s:%s",
-               pasReqInfo[i].pszHttpUsername,
+      snprintf(szUsernamePasswd, 127, "%s:%s", pasReqInfo[i].pszHttpUsername,
                pasReqInfo[i].pszHttpPassword);
       unchecked_curl_easy_setopt(http_handle, CURLOPT_USERPWD,
-                       szUsernamePasswd);
+                                 szUsernamePasswd);
 
       nHttpAuthType = msGetCURLAuthType(pasReqInfo[i].eHttpAuthType);
       unchecked_curl_easy_setopt(http_handle, CURLOPT_HTTPAUTH, nHttpAuthType);
@@ -659,73 +641,75 @@ int msHTTPExecuteRequests(httpRequestObj
      * (this force avoiding the use of sgnal handlers)
      */
 #ifdef CURLOPT_NOSIGNAL
-    unchecked_curl_easy_setopt(http_handle, CURLOPT_NOSIGNAL, 1 );
+    unchecked_curl_easy_setopt(http_handle, CURLOPT_NOSIGNAL, 1);
 #endif
 
     /* If we are writing file to disk, open the file now. */
-    if( pasReqInfo[i].pszOutputFile != NULL ) {
-      if ( (fp = fopen(pasReqInfo[i].pszOutputFile, "wb")) == NULL) {
+    if (pasReqInfo[i].pszOutputFile != NULL) {
+      if ((fp = fopen(pasReqInfo[i].pszOutputFile, "wb")) == NULL) {
         msSetError(MS_HTTPERR, "Can't open output file %s.",
                    "msHTTPExecuteRequests()", pasReqInfo[i].pszOutputFile);
-        return(MS_FAILURE);
+        return (MS_FAILURE);
       }
 
       pasReqInfo[i].fp = fp;
     }
 
     /* coverity[bad_sizeof] */
-    unchecked_curl_easy_setopt(http_handle, CURLOPT_WRITEDATA, &(pasReqInfo[i]));
-    unchecked_curl_easy_setopt(http_handle, CURLOPT_WRITEFUNCTION, msHTTPWriteFct);
+    unchecked_curl_easy_setopt(http_handle, CURLOPT_WRITEDATA,
+                               &(pasReqInfo[i]));
+    unchecked_curl_easy_setopt(http_handle, CURLOPT_WRITEFUNCTION,
+                               msHTTPWriteFct);
 
     /* Provide a buffer where libcurl can write human readable error msgs
      */
     if (pasReqInfo[i].pszErrBuf == NULL)
-      pasReqInfo[i].pszErrBuf = (char *)msSmallMalloc((CURL_ERROR_SIZE+1)*
-                                sizeof(char));
+      pasReqInfo[i].pszErrBuf =
+          (char *)msSmallMalloc((CURL_ERROR_SIZE + 1) * sizeof(char));
     pasReqInfo[i].pszErrBuf[0] = '\0';
 
     unchecked_curl_easy_setopt(http_handle, CURLOPT_ERRORBUFFER,
-                     pasReqInfo[i].pszErrBuf);
+                               pasReqInfo[i].pszErrBuf);
 
-    if(pasReqInfo[i].pszPostRequest != NULL ) {
+    if (pasReqInfo[i].pszPostRequest != NULL) {
       char szBuf[100];
 
-      struct curl_slist *headers=NULL;
-      snprintf(szBuf, 100,
-               "Content-Type: %s", pasReqInfo[i].pszPostContentType);
+      struct curl_slist *headers = NULL;
+      snprintf(szBuf, 100, "Content-Type: %s",
+               pasReqInfo[i].pszPostContentType);
       headers = curl_slist_append(headers, szBuf);
 
-      unchecked_curl_easy_setopt(http_handle, CURLOPT_POST, 1 );
+      unchecked_curl_easy_setopt(http_handle, CURLOPT_POST, 1);
       unchecked_curl_easy_setopt(http_handle, CURLOPT_POSTFIELDS,
-                       pasReqInfo[i].pszPostRequest);
-      if( debug )
-      {
-          msDebug("HTTP: POST = %s", pasReqInfo[i].pszPostRequest);
+                                 pasReqInfo[i].pszPostRequest);
+      if (debug) {
+        msDebug("HTTP: POST = %s", pasReqInfo[i].pszPostRequest);
       }
       unchecked_curl_easy_setopt(http_handle, CURLOPT_HTTPHEADER, headers);
       /* curl_slist_free_all(headers); */ /* free the header list */
     }
 
     /* Added by RFC-42 HTTP Cookie Forwarding */
-    if(pasReqInfo[i].pszHTTPCookieData != NULL) {
+    if (pasReqInfo[i].pszHTTPCookieData != NULL) {
       /* Check if there's no end of line in the Cookie string */
       /* This could break the HTTP Header */
-      for(size_t nPos=0; nPos<strlen(pasReqInfo[i].pszHTTPCookieData); nPos++) {
-        if(pasReqInfo[i].pszHTTPCookieData[nPos] == '\n') {
-          msSetError(MS_HTTPERR, "Can't use cookie containing a newline character.",
+      for (size_t nPos = 0; nPos < strlen(pasReqInfo[i].pszHTTPCookieData);
+           nPos++) {
+        if (pasReqInfo[i].pszHTTPCookieData[nPos] == '\n') {
+          msSetError(MS_HTTPERR,
+                     "Can't use cookie containing a newline character.",
                      "msHTTPExecuteRequests()");
-          return(MS_FAILURE);
+          return (MS_FAILURE);
         }
       }
 
       /* Set the Curl option to send Cookie */
       unchecked_curl_easy_setopt(http_handle, CURLOPT_COOKIE,
-                       pasReqInfo[i].pszHTTPCookieData);
+                                 pasReqInfo[i].pszHTTPCookieData);
     }
 
     /* Add to multi handle */
     curl_multi_add_handle(multi_handle, http_handle);
-
   }
 
   if (debug) {
@@ -735,10 +719,11 @@ int msHTTPExecuteRequests(httpRequestObj
   /* DOWNLOAD LOOP ... inspired from multi-double.c example */
 
   /* we start some action by calling perform right away */
-  while(CURLM_CALL_MULTI_PERFORM ==
-        curl_multi_perform(multi_handle, &still_running));
+  while (CURLM_CALL_MULTI_PERFORM ==
+         curl_multi_perform(multi_handle, &still_running))
+    ;
 
-  while(still_running) {
+  while (still_running) {
     struct timeval timeout;
     int rc; /* select() return code */
 
@@ -758,27 +743,27 @@ int msHTTPExecuteRequests(httpRequestObj
     /* get file descriptors from the transfers */
     curl_multi_fdset(multi_handle, &fdread, &fdwrite, &fdexcep, &maxfd);
 
-    rc = select(maxfd+1, &fdread, &fdwrite, &fdexcep, &timeout);
+    rc = select(maxfd + 1, &fdread, &fdwrite, &fdexcep, &timeout);
 
-    switch(rc) {
-      case -1:
-        /* select error */
-
-        /* ==================================================================== */
-        /*      On Windows the select function (just above) returns -1 when     */
-        /*      it is called the second time and all the calls after            */
-        /*      that. This causes an infinite loop.                             */
-        /*      I do not really know why.                                       */
-        /*      To sovle the problem the break frop case -1 has been removed.   */
-        /* ==================================================================== */
+    switch (rc) {
+    case -1:
+      /* select error */
+
+      /* ==================================================================== */
+      /*      On Windows the select function (just above) returns -1 when     */
+      /*      it is called the second time and all the calls after            */
+      /*      that. This causes an infinite loop.                             */
+      /*      I do not really know why.                                       */
+      /*      To sovle the problem the break frop case -1 has been removed.   */
+      /* ==================================================================== */
 #ifndef _WIN32
-        break;
+      break;
 #endif
-      case 0:
-      default:
-        /* timeout or readable/writable sockets */
-        curl_multi_perform(multi_handle, &still_running);
-        break;
+    case 0:
+    default:
+      /* timeout or readable/writable sockets */
+      curl_multi_perform(multi_handle, &still_running);
+      break;
     }
   }
 
@@ -787,14 +772,13 @@ int msHTTPExecuteRequests(httpRequestObj
 
   /* Scan message stack from CURL and report fatal errors*/
 
-  while((curl_msg = curl_multi_info_read( multi_handle, &num_msgs)) != NULL) {
+  while ((curl_msg = curl_multi_info_read(multi_handle, &num_msgs)) != NULL) {
     httpRequestObj *psReq = NULL;
 
-    if (curl_msg->msg == CURLMSG_DONE &&
-        curl_msg->data.result != CURLE_OK) {
+    if (curl_msg->msg == CURLMSG_DONE && curl_msg->data.result != CURLE_OK) {
       /* Something went wrong with this transfer... report error */
 
-      for (i=0; i<numRequests; i++) {
+      for (i = 0; i < numRequests; i++) {
         if (pasReqInfo[i].curl_handle == curl_msg->easy_handle) {
           psReq = &(pasReqInfo[i]);
           break;
@@ -810,38 +794,37 @@ int msHTTPExecuteRequests(httpRequestObj
 
   if (debug) {
     /* Print a msDebug header for timings reported in the loop below */
-    msDebug("msHTTPExecuteRequests() timing summary per layer (connect_time + time_to_first_packet + download_time = total_time in seconds)\n");
+    msDebug("msHTTPExecuteRequests() timing summary per layer (connect_time + "
+            "time_to_first_packet + download_time = total_time in seconds)\n");
   }
 
   /* Check status of all requests, close files, report errors and cleanup
    * handles
    */
-  for (i=0; i<numRequests; i++) {
+  for (i = 0; i < numRequests; i++) {
     httpRequestObj *psReq;
     CURL *http_handle;
-    long lVal=0;
+    long lVal = 0;
 
     psReq = &(pasReqInfo[i]);
 
     if (psReq->nStatus == 242)
-      continue;  /* Nothing to do here, this file was in cache already */
+      continue; /* Nothing to do here, this file was in cache already */
 
     if (psReq->fp)
       fclose(psReq->fp);
     psReq->fp = NULL;
 
-    http_handle = (CURL*)(psReq->curl_handle);
+    http_handle = (CURL *)(psReq->curl_handle);
 
     if (psReq->nStatus == 0 &&
-        curl_easy_getinfo(http_handle,
-                          CURLINFO_HTTP_CODE, &lVal) == CURLE_OK) {
+        curl_easy_getinfo(http_handle, CURLINFO_HTTP_CODE, &lVal) == CURLE_OK) {
       char *pszContentType = NULL;
 
       psReq->nStatus = lVal;
 
       /* Fetch content type of response */
-      if (curl_easy_getinfo(http_handle,
-                            CURLINFO_CONTENT_TYPE,
+      if (curl_easy_getinfo(http_handle, CURLINFO_CONTENT_TYPE,
                             &pszContentType) == CURLE_OK &&
           pszContentType != NULL) {
         psReq->pszContentType = msStrdup(pszContentType);
@@ -856,33 +839,29 @@ int msHTTPExecuteRequests(httpRequestObj
       if (psReq->nStatus == -(CURLE_OPERATION_TIMEOUTED)) {
         /* Timeout isn't a fatal error */
         if (psReq->debug)
-          msDebug("HTTP: TIMEOUT of %d seconds exceeded for %s\n",
-                  nTimeout, psReq->pszGetUrl );
+          msDebug("HTTP: TIMEOUT of %d seconds exceeded for %s\n", nTimeout,
+                  psReq->pszGetUrl);
 
-        msSetError(MS_HTTPERR,
-                   "HTTP: TIMEOUT of %d seconds exceeded for %s\n",
-                   "msHTTPExecuteRequests()",
-                   nTimeout, psReq->pszGetUrl);
+        msSetError(MS_HTTPERR, "HTTP: TIMEOUT of %d seconds exceeded for %s\n",
+                   "msHTTPExecuteRequests()", nTimeout, psReq->pszGetUrl);
 
         /* Rewrite error message, the curl timeout message isn't
          * of much use to our users.
          */
-        sprintf(psReq->pszErrBuf,
-                "TIMEOUT of %d seconds exceeded.", nTimeout);
+        sprintf(psReq->pszErrBuf, "TIMEOUT of %d seconds exceeded.", nTimeout);
       } else if (psReq->nStatus > 0) {
         /* Got an HTTP Error, e.g. 404, etc. */
 
         if (psReq->debug)
           msDebug("HTTP: HTTP GET request failed with status %d (%s)"
                   " for %s\n",
-                  psReq->nStatus, psReq->pszErrBuf,
-                  psReq->pszGetUrl);
+                  psReq->nStatus, psReq->pszErrBuf, psReq->pszGetUrl);
 
         msSetError(MS_HTTPERR,
                    "HTTP GET request failed with status %d (%s) "
                    "for %s",
-                   "msHTTPExecuteRequests()", psReq->nStatus,
-                   psReq->pszErrBuf, psReq->pszGetUrl);
+                   "msHTTPExecuteRequests()", psReq->nStatus, psReq->pszErrBuf,
+                   psReq->pszGetUrl);
       } else {
         /* Got a curl error */
 
@@ -890,45 +869,42 @@ int msHTTPExecuteRequests(httpRequestObj
         if (psReq->debug)
           msDebug("HTTP: request failed with curl error "
                   "code %d (%s) for %s",
-                  -psReq->nStatus, psReq->pszErrBuf,
-                  psReq->pszGetUrl);
+                  -psReq->nStatus, psReq->pszErrBuf, psReq->pszGetUrl);
 
-        if(!error || error->code == MS_NOERR) /* only set error if one hasn't already been set */
+        if (!error ||
+            error->code ==
+                MS_NOERR) /* only set error if one hasn't already been set */
           msSetError(MS_HTTPERR,
-                   "HTTP: request failed with curl error "
-                   "code %d (%s) for %s",
-                   "msHTTPExecuteRequests()",
-                   -psReq->nStatus, psReq->pszErrBuf,
-                   psReq->pszGetUrl);
+                     "HTTP: request failed with curl error "
+                     "code %d (%s) for %s",
+                     "msHTTPExecuteRequests()", -psReq->nStatus,
+                     psReq->pszErrBuf, psReq->pszGetUrl);
       }
     }
 
     /* Report download times foreach handle, in debug mode */
     if (psReq->debug) {
-      double dConnectTime=0.0, dTotalTime=0.0, dStartTfrTime=0.0;
+      double dConnectTime = 0.0, dTotalTime = 0.0, dStartTfrTime = 0.0;
 
-      curl_easy_getinfo(http_handle,
-                        CURLINFO_CONNECT_TIME, &dConnectTime);
-      curl_easy_getinfo(http_handle,
-                        CURLINFO_STARTTRANSFER_TIME, &dStartTfrTime);
-      curl_easy_getinfo(http_handle,
-                        CURLINFO_TOTAL_TIME, &dTotalTime);
+      curl_easy_getinfo(http_handle, CURLINFO_CONNECT_TIME, &dConnectTime);
+      curl_easy_getinfo(http_handle, CURLINFO_STARTTRANSFER_TIME,
+                        &dStartTfrTime);
+      curl_easy_getinfo(http_handle, CURLINFO_TOTAL_TIME, &dTotalTime);
       /* STARTTRANSFER_TIME includes CONNECT_TIME, but TOTAL_TIME
        * doesn't, so we need to add it.
        */
       dTotalTime += dConnectTime;
 
       msDebug("Layer %d: %.3f + %.3f + %.3f = %.3fs\n", psReq->nLayerId,
-              dConnectTime, dStartTfrTime-dConnectTime,
-              dTotalTime-dStartTfrTime, dTotalTime);
+              dConnectTime, dStartTfrTime - dConnectTime,
+              dTotalTime - dStartTfrTime, dTotalTime);
     }
 
     /* Cleanup this handle */
-    unchecked_curl_easy_setopt(http_handle, CURLOPT_URL, "" );
+    unchecked_curl_easy_setopt(http_handle, CURLOPT_URL, "");
     curl_multi_remove_handle(multi_handle, http_handle);
     curl_easy_cleanup(http_handle);
     psReq->curl_handle = NULL;
-
   }
 
   /* Cleanup multi handle, each handle had to be cleaned up individually */
@@ -944,17 +920,16 @@ int msHTTPExecuteRequests(httpRequestObj
  **********************************************************************/
 int msHTTPGetFile(const char *pszGetUrl, const char *pszOutputFile,
                   int *pnHTTPStatus, int nTimeout, int bCheckLocalCache,
-                  int bDebug, int nMaxBytes)
-{
+                  int bDebug, int nMaxBytes) {
   httpRequestObj *pasReqInfo;
 
   /* Alloc httpRequestInfo structs through which status of each request
    * will be returned.
    * We need to alloc 2 instance of requestobj so that the last
    * object in the array can be set to NULL.
-  */
-  pasReqInfo = (httpRequestObj*)calloc(2, sizeof(httpRequestObj));
-  MS_CHECK_ALLOC(pasReqInfo, 2*sizeof(httpRequestObj), MS_FAILURE);
+   */
+  pasReqInfo = (httpRequestObj *)calloc(2, sizeof(httpRequestObj));
+  MS_CHECK_ALLOC(pasReqInfo, 2 * sizeof(httpRequestObj), MS_FAILURE);
 
   msHTTPInitRequestObj(pasReqInfo, 2);
 
@@ -981,5 +956,4 @@ int msHTTPGetFile(const char *pszGetUrl,
   return MS_SUCCESS;
 }
 
-
 #endif /* defined(USE_WMS_LYR) || defined(USE_WMS_SVR) */
diff -pruN 8.0.1-5/maphttp.h 8.0.2-1/maphttp.h
--- 8.0.1-5/maphttp.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/maphttp.h	2024-06-11 20:41:34.000000000 +0000
@@ -30,8 +30,6 @@
 #ifndef MAPHTTP_H
 #define MAPHTTP_H
 
-
-
 #include "mapprimitive.h"
 #include <stdio.h>
 
@@ -39,86 +37,73 @@
 extern "C" {
 #endif
 
-#define MS_HTTP_SUCCESS(status)  (status == 200 || status == 242)
+#define MS_HTTP_SUCCESS(status) (status == 200 || status == 242)
+
+enum MS_HTTP_PROXY_TYPE { MS_HTTP, MS_SOCKS5 };
+
+enum MS_HTTP_AUTH_TYPE { MS_BASIC, MS_DIGEST, MS_NTLM, MS_ANY, MS_ANYSAFE };
 
-  enum MS_HTTP_PROXY_TYPE
-  {
-    MS_HTTP,
-    MS_SOCKS5
-  };
-
-  enum MS_HTTP_AUTH_TYPE {
-    MS_BASIC,
-    MS_DIGEST,
-    MS_NTLM,
-    MS_ANY,
-    MS_ANYSAFE
-  };
-
-  typedef struct http_request_info {
-    int     nLayerId;
-    char    *pszGetUrl;
-    char    *pszOutputFile;
-    int     nTimeout;
-    int     nMaxBytes;
-    rectObj bbox;
-    int     width;
-    int     height;
-    int     nStatus;            /* 200=success, value < 0 if request failed */
-    char    *pszContentType;    /* Content-Type of the response */
-    char    *pszErrBuf;         /* Buffer where curl can write errors */
-    char    *pszPostRequest;    /* post request content (NULL for GET) */
-    char    *pszPostContentType;/* post request MIME type */
-    char    *pszUserAgent;      /* User-Agent, auto-generated if not set */
-    char    *pszHTTPCookieData; /* HTTP Cookie data */
-
-    char    *pszProxyAddress;   /* The address (IP or hostname) of proxy svr */
-    long     nProxyPort;        /* The proxy's port                          */
-    enum MS_HTTP_PROXY_TYPE eProxyType; /* The type of proxy                 */
-    enum MS_HTTP_AUTH_TYPE  eProxyAuthType; /* Auth method against proxy     */
-    char    *pszProxyUsername;  /* Proxy authentication username             */
-    char    *pszProxyPassword;  /* Proxy authentication password             */
-
-    enum MS_HTTP_AUTH_TYPE eHttpAuthType; /* HTTP Authentication type        */
-    char    *pszHttpUsername;   /* HTTP Authentication username              */
-    char    *pszHttpPassword;   /* HTTP Authentication password              */
-
-    /* For debugging/profiling */
-    int         debug;         /* Debug mode?  MS_TRUE/MS_FALSE */
-
-    /* Private members */
-    void      * curl_handle;   /* CURLM * handle */
-    FILE      * fp;            /* FILE * used during download */
-
-    char      * result_data;   /* output if pszOutputFile is NULL */
-    int       result_size;
-    int       result_buf_size;
+typedef struct http_request_info {
+  int nLayerId;
+  char *pszGetUrl;
+  char *pszOutputFile;
+  int nTimeout;
+  int nMaxBytes;
+  rectObj bbox;
+  int width;
+  int height;
+  int nStatus;              /* 200=success, value < 0 if request failed */
+  char *pszContentType;     /* Content-Type of the response */
+  char *pszErrBuf;          /* Buffer where curl can write errors */
+  char *pszPostRequest;     /* post request content (NULL for GET) */
+  char *pszPostContentType; /* post request MIME type */
+  char *pszUserAgent;       /* User-Agent, auto-generated if not set */
+  char *pszHTTPCookieData;  /* HTTP Cookie data */
+
+  char *pszProxyAddress; /* The address (IP or hostname) of proxy svr */
+  long nProxyPort;       /* The proxy's port                          */
+  enum MS_HTTP_PROXY_TYPE eProxyType;    /* The type of proxy                 */
+  enum MS_HTTP_AUTH_TYPE eProxyAuthType; /* Auth method against proxy     */
+  char *pszProxyUsername; /* Proxy authentication username             */
+  char *pszProxyPassword; /* Proxy authentication password             */
+
+  enum MS_HTTP_AUTH_TYPE eHttpAuthType; /* HTTP Authentication type        */
+  char *pszHttpUsername; /* HTTP Authentication username              */
+  char *pszHttpPassword; /* HTTP Authentication password              */
+
+  /* For debugging/profiling */
+  int debug; /* Debug mode?  MS_TRUE/MS_FALSE */
+
+  /* Private members */
+  void *curl_handle; /* CURLM * handle */
+  FILE *fp;          /* FILE * used during download */
+
+  char *result_data; /* output if pszOutputFile is NULL */
+  int result_size;
+  int result_buf_size;
 
-  } httpRequestObj;
+} httpRequestObj;
 
 #ifdef USE_CURL
 
-  int msHTTPInit(void);
-  void msHTTPCleanup(void);
+int msHTTPInit(void);
+void msHTTPCleanup(void);
 
-  void msHTTPInitRequestObj(httpRequestObj *pasReqInfo, int numRequests);
-  void msHTTPFreeRequestObj(httpRequestObj *pasReqInfo, int numRequests);
-  int  msHTTPExecuteRequests(httpRequestObj *pasReqInfo, int numRequests,
-                             int bCheckLocalCache);
-  int  msHTTPGetFile(const char *pszGetUrl, const char *pszOutputFile,
-                     int *pnHTTPStatus, int nTimeout, int bCheckLocalCache,
-                     int bDebug, int nMaxBytes);
-
-  int msHTTPAuthProxySetup(hashTableObj *mapmd, hashTableObj *lyrmd,
-                           httpRequestObj *pasReqInfo, int numRequests,
-                           mapObj *map, const char* namespaces);
+void msHTTPInitRequestObj(httpRequestObj *pasReqInfo, int numRequests);
+void msHTTPFreeRequestObj(httpRequestObj *pasReqInfo, int numRequests);
+int msHTTPExecuteRequests(httpRequestObj *pasReqInfo, int numRequests,
+                          int bCheckLocalCache);
+int msHTTPGetFile(const char *pszGetUrl, const char *pszOutputFile,
+                  int *pnHTTPStatus, int nTimeout, int bCheckLocalCache,
+                  int bDebug, int nMaxBytes);
+
+int msHTTPAuthProxySetup(hashTableObj *mapmd, hashTableObj *lyrmd,
+                         httpRequestObj *pasReqInfo, int numRequests,
+                         mapObj *map, const char *namespaces);
 #endif /*USE_CURL*/
 
 #ifdef __cplusplus
 }
 #endif
 
-
-
-
 #endif /* MAPHTTP_H */
diff -pruN 8.0.1-5/mapiconv.c 8.0.2-1/mapiconv.c
--- 8.0.1-5/mapiconv.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapiconv.c	2024-06-11 20:41:34.000000000 +0000
@@ -28,9 +28,7 @@
 
 #include "mapiconv.h"
 
-size_t msIconv(iconv_t cd,
-               char **inbuf, size_t *inbytesleft,
-               char **outbuf, size_t *outbytesleft)
-{
-    return iconv(cd, inbuf, inbytesleft, outbuf, outbytesleft);
+size_t msIconv(iconv_t cd, char **inbuf, size_t *inbytesleft, char **outbuf,
+               size_t *outbytesleft) {
+  return iconv(cd, inbuf, inbytesleft, outbuf, outbytesleft);
 }
diff -pruN 8.0.1-5/mapiconv.h 8.0.2-1/mapiconv.h
--- 8.0.1-5/mapiconv.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapiconv.h	2024-06-11 20:41:34.000000000 +0000
@@ -36,9 +36,8 @@ extern "C" {
 #include <iconv.h>
 
 /* Wrapper of iconv() to be used from C++ */
-size_t msIconv(iconv_t cd,
-               char **inbuf, size_t *inbytesleft,
-               char **outbuf, size_t *outbytesleft);
+size_t msIconv(iconv_t cd, char **inbuf, size_t *inbytesleft, char **outbuf,
+               size_t *outbytesleft);
 
 #ifdef __cplusplus
 }
diff -pruN 8.0.1-5/mapimageio.c 8.0.2-1/mapimageio.c
--- 8.0.1-5/mapimageio.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapimageio.c	2024-06-11 20:41:34.000000000 +0000
@@ -38,30 +38,24 @@
 #include <gif_lib.h>
 #endif
 
-
-
 typedef struct _streamInfo {
   FILE *fp;
   bufferObj *buffer;
 } streamInfo;
 
-static
-void png_write_data_to_stream(png_structp png_ptr, png_bytep data, png_size_t length)
-{
-  FILE *fp = ((streamInfo*)png_get_io_ptr(png_ptr))->fp;
-  msIO_fwrite(data,length,1,fp);
+static void png_write_data_to_stream(png_structp png_ptr, png_bytep data,
+                                     png_size_t length) {
+  FILE *fp = ((streamInfo *)png_get_io_ptr(png_ptr))->fp;
+  msIO_fwrite(data, length, 1, fp);
 }
 
-static
-void png_write_data_to_buffer(png_structp png_ptr, png_bytep data, png_size_t length)
-{
-  bufferObj *buffer = ((streamInfo*)png_get_io_ptr(png_ptr))->buffer;
-  msBufferAppend(buffer,data,length);
+static void png_write_data_to_buffer(png_structp png_ptr, png_bytep data,
+                                     png_size_t length) {
+  bufferObj *buffer = ((streamInfo *)png_get_io_ptr(png_ptr))->buffer;
+  msBufferAppend(buffer, data, length);
 }
 
-static
-void png_flush_data(png_structp png_ptr)
-{
+static void png_flush_data(png_structp png_ptr) {
   (void)png_ptr;
   /* do nothing */
 }
@@ -83,123 +77,116 @@ typedef struct {
 
 #define OUTPUT_BUF_SIZE 4096
 
-static void
-jpeg_init_destination (j_compress_ptr cinfo)
-{
-  ms_destination_mgr *dest = (ms_destination_mgr*) cinfo->dest;
+static void jpeg_init_destination(j_compress_ptr cinfo) {
+  ms_destination_mgr *dest = (ms_destination_mgr *)cinfo->dest;
 
   /* Allocate the output buffer --- it will be released when done with image */
-  dest->data = (unsigned char *)
-               (*cinfo->mem->alloc_small) ((j_common_ptr) cinfo, JPOOL_IMAGE,
-                   OUTPUT_BUF_SIZE * sizeof (unsigned char));
+  dest->data = (unsigned char *)(*cinfo->mem->alloc_small)(
+      (j_common_ptr)cinfo, JPOOL_IMAGE,
+      OUTPUT_BUF_SIZE * sizeof(unsigned char));
 
   dest->pub.next_output_byte = dest->data;
   dest->pub.free_in_buffer = OUTPUT_BUF_SIZE;
 }
 
-static
-void jpeg_stream_term_destination (j_compress_ptr cinfo)
-{
-  ms_stream_destination_mgr *dest = (ms_stream_destination_mgr*) cinfo->dest;
-  msIO_fwrite(dest->mgr.data, OUTPUT_BUF_SIZE-dest->mgr.pub.free_in_buffer, 1, dest->stream);
+static void jpeg_stream_term_destination(j_compress_ptr cinfo) {
+  ms_stream_destination_mgr *dest = (ms_stream_destination_mgr *)cinfo->dest;
+  msIO_fwrite(dest->mgr.data, OUTPUT_BUF_SIZE - dest->mgr.pub.free_in_buffer, 1,
+              dest->stream);
   dest->mgr.pub.next_output_byte = dest->mgr.data;
   dest->mgr.pub.free_in_buffer = OUTPUT_BUF_SIZE;
 }
 
-static
-void jpeg_buffer_term_destination (j_compress_ptr cinfo)
-{
-  ms_buffer_destination_mgr *dest = (ms_buffer_destination_mgr*) cinfo->dest;
-  msBufferAppend(dest->buffer, dest->mgr.data, OUTPUT_BUF_SIZE-dest->mgr.pub.free_in_buffer);
+static void jpeg_buffer_term_destination(j_compress_ptr cinfo) {
+  ms_buffer_destination_mgr *dest = (ms_buffer_destination_mgr *)cinfo->dest;
+  msBufferAppend(dest->buffer, dest->mgr.data,
+                 OUTPUT_BUF_SIZE - dest->mgr.pub.free_in_buffer);
   dest->mgr.pub.next_output_byte = dest->mgr.data;
   dest->mgr.pub.free_in_buffer = OUTPUT_BUF_SIZE;
 }
 
-static
-boolean jpeg_stream_empty_output_buffer (j_compress_ptr cinfo)
-{
-  ms_stream_destination_mgr *dest = (ms_stream_destination_mgr*) cinfo->dest;
+static boolean jpeg_stream_empty_output_buffer(j_compress_ptr cinfo) {
+  ms_stream_destination_mgr *dest = (ms_stream_destination_mgr *)cinfo->dest;
   msIO_fwrite(dest->mgr.data, OUTPUT_BUF_SIZE, 1, dest->stream);
   dest->mgr.pub.next_output_byte = dest->mgr.data;
   dest->mgr.pub.free_in_buffer = OUTPUT_BUF_SIZE;
   return TRUE;
 }
 
-static
-boolean jpeg_buffer_empty_output_buffer (j_compress_ptr cinfo)
-{
-  ms_buffer_destination_mgr *dest = (ms_buffer_destination_mgr*) cinfo->dest;
+static boolean jpeg_buffer_empty_output_buffer(j_compress_ptr cinfo) {
+  ms_buffer_destination_mgr *dest = (ms_buffer_destination_mgr *)cinfo->dest;
   msBufferAppend(dest->buffer, dest->mgr.data, OUTPUT_BUF_SIZE);
   dest->mgr.pub.next_output_byte = dest->mgr.data;
   dest->mgr.pub.free_in_buffer = OUTPUT_BUF_SIZE;
   return TRUE;
 }
 
-static void msJPEGErrorExit(j_common_ptr cinfo)
-{
-    jmp_buf* pJmpBuffer = (jmp_buf* ) cinfo->client_data;
-    char buffer[JMSG_LENGTH_MAX];
+static void msJPEGErrorExit(j_common_ptr cinfo) {
+  jmp_buf *pJmpBuffer = (jmp_buf *)cinfo->client_data;
+  char buffer[JMSG_LENGTH_MAX];
 
-    /* Create the message */
-    (*cinfo->err->format_message) (cinfo, buffer);
+  /* Create the message */
+  (*cinfo->err->format_message)(cinfo, buffer);
 
-    msSetError(MS_MISCERR,"libjpeg: %s","jpeg_ErrorExit()", buffer);
+  msSetError(MS_MISCERR, "libjpeg: %s", "jpeg_ErrorExit()", buffer);
 
-    /* Return control to the setjmp point */
-    longjmp(*pJmpBuffer, 1);
+  /* Return control to the setjmp point */
+  longjmp(*pJmpBuffer, 1);
 }
 
 int saveAsJPEG(mapObj *map, rasterBufferObj *rb, streamInfo *info,
-               outputFormatObj *format)
-{
+               outputFormatObj *format) {
   struct jpeg_compress_struct cinfo;
   struct jpeg_error_mgr jerr;
   int quality;
-  const char* pszOptimized;
+  const char *pszOptimized;
   int optimized;
   int arithmetic;
   ms_destination_mgr *dest;
   JSAMPLE *rowdata = NULL;
   unsigned int row;
   jmp_buf setjmp_buffer;
-  
-  quality = atoi(msGetOutputFormatOption( format, "QUALITY", "75"));
-  pszOptimized = msGetOutputFormatOption( format, "OPTIMIZED", "YES");
+
+  quality = atoi(msGetOutputFormatOption(format, "QUALITY", "75"));
+  pszOptimized = msGetOutputFormatOption(format, "OPTIMIZED", "YES");
   optimized = EQUAL(pszOptimized, "YES") || EQUAL(pszOptimized, "ON") ||
               EQUAL(pszOptimized, "TRUE");
   arithmetic = EQUAL(pszOptimized, "ARITHMETIC");
 
-  if (setjmp(setjmp_buffer)) 
-  {
-     jpeg_destroy_compress(&cinfo);
-     free(rowdata);
-     return MS_FAILURE;
+  if (setjmp(setjmp_buffer)) {
+    jpeg_destroy_compress(&cinfo);
+    free(rowdata);
+    return MS_FAILURE;
   }
 
   cinfo.err = jpeg_std_error(&jerr);
   jerr.error_exit = msJPEGErrorExit;
-  cinfo.client_data = (void *) &(setjmp_buffer);
+  cinfo.client_data = (void *)&(setjmp_buffer);
   jpeg_create_compress(&cinfo);
 
   if (cinfo.dest == NULL) {
-    if(info->fp) {
-      cinfo.dest = (struct jpeg_destination_mgr *)
-                   (*cinfo.mem->alloc_small) ((j_common_ptr) &cinfo, JPOOL_PERMANENT,
-                                              sizeof (ms_stream_destination_mgr));
-      ((ms_stream_destination_mgr*)cinfo.dest)->mgr.pub.empty_output_buffer = jpeg_stream_empty_output_buffer;
-      ((ms_stream_destination_mgr*)cinfo.dest)->mgr.pub.term_destination = jpeg_stream_term_destination;
-      ((ms_stream_destination_mgr*)cinfo.dest)->stream = info->fp;
+    if (info->fp) {
+      cinfo.dest = (struct jpeg_destination_mgr *)(*cinfo.mem->alloc_small)(
+          (j_common_ptr)&cinfo, JPOOL_PERMANENT,
+          sizeof(ms_stream_destination_mgr));
+      ((ms_stream_destination_mgr *)cinfo.dest)->mgr.pub.empty_output_buffer =
+          jpeg_stream_empty_output_buffer;
+      ((ms_stream_destination_mgr *)cinfo.dest)->mgr.pub.term_destination =
+          jpeg_stream_term_destination;
+      ((ms_stream_destination_mgr *)cinfo.dest)->stream = info->fp;
     } else {
 
-      cinfo.dest = (struct jpeg_destination_mgr *)
-                   (*cinfo.mem->alloc_small) ((j_common_ptr) &cinfo, JPOOL_PERMANENT,
-                                              sizeof (ms_buffer_destination_mgr));
-      ((ms_buffer_destination_mgr*)cinfo.dest)->mgr.pub.empty_output_buffer = jpeg_buffer_empty_output_buffer;
-      ((ms_buffer_destination_mgr*)cinfo.dest)->mgr.pub.term_destination = jpeg_buffer_term_destination;
-      ((ms_buffer_destination_mgr*)cinfo.dest)->buffer = info->buffer;
+      cinfo.dest = (struct jpeg_destination_mgr *)(*cinfo.mem->alloc_small)(
+          (j_common_ptr)&cinfo, JPOOL_PERMANENT,
+          sizeof(ms_buffer_destination_mgr));
+      ((ms_buffer_destination_mgr *)cinfo.dest)->mgr.pub.empty_output_buffer =
+          jpeg_buffer_empty_output_buffer;
+      ((ms_buffer_destination_mgr *)cinfo.dest)->mgr.pub.term_destination =
+          jpeg_buffer_term_destination;
+      ((ms_buffer_destination_mgr *)cinfo.dest)->buffer = info->buffer;
     }
   }
-  dest = (ms_destination_mgr*) cinfo.dest;
+  dest = (ms_destination_mgr *)cinfo.dest;
   dest->pub.init_destination = jpeg_init_destination;
 
   cinfo.image_width = rb->width;
@@ -208,43 +195,47 @@ int saveAsJPEG(mapObj *map, rasterBuffer
   cinfo.in_color_space = JCS_RGB;
   jpeg_set_defaults(&cinfo);
   jpeg_set_quality(&cinfo, quality, TRUE);
-  if( arithmetic )
+  if (arithmetic)
     cinfo.arith_code = TRUE;
-  else if( optimized )
+  else if (optimized)
     cinfo.optimize_coding = TRUE;
 
-  if( arithmetic || optimized ) {
+  if (arithmetic || optimized) {
     /* libjpeg turbo 1.5.2 honours max_memory_to_use, but has no backing */
     /* store implementation, so better not set max_memory_to_use ourselves. */
     /* See https://github.com/libjpeg-turbo/libjpeg-turbo/issues/162 */
-    if( cinfo.mem->max_memory_to_use > 0 ) {
+    if (cinfo.mem->max_memory_to_use > 0) {
       if (map == NULL || msGetConfigOption(map, "JPEGMEM") == NULL) {
-        /* If the user doesn't provide a value for JPEGMEM, we want to be sure */
-        /* that at least the image size will be used before creating the temporary file */
+        /* If the user doesn't provide a value for JPEGMEM, we want to be sure
+         */
+        /* that at least the image size will be used before creating the
+         * temporary file */
         cinfo.mem->max_memory_to_use =
-          MS_MAX(cinfo.mem->max_memory_to_use, cinfo.input_components * rb->width * rb->height);
+            MS_MAX(cinfo.mem->max_memory_to_use,
+                   cinfo.input_components * rb->width * rb->height);
       }
     }
   }
 
   jpeg_start_compress(&cinfo, TRUE);
-  rowdata = (JSAMPLE*)malloc(rb->width*cinfo.input_components*sizeof(JSAMPLE));
+  rowdata =
+      (JSAMPLE *)malloc(rb->width * cinfo.input_components * sizeof(JSAMPLE));
 
-  for(row=0; row<rb->height; row++) {
+  for (row = 0; row < rb->height; row++) {
     JSAMPLE *pixptr = rowdata;
-    unsigned char *r,*g,*b;
-    r=rb->data.rgba.r+row*rb->data.rgba.row_step;
-    g=rb->data.rgba.g+row*rb->data.rgba.row_step;
-    b=rb->data.rgba.b+row*rb->data.rgba.row_step;
-    for(unsigned col=0; col<rb->width; col++) {
+    unsigned char *r, *g, *b;
+    r = rb->data.rgba.r + row * rb->data.rgba.row_step;
+    g = rb->data.rgba.g + row * rb->data.rgba.row_step;
+    b = rb->data.rgba.b + row * rb->data.rgba.row_step;
+    for (unsigned col = 0; col < rb->width; col++) {
       *(pixptr++) = *r;
       *(pixptr++) = *g;
       *(pixptr++) = *b;
-      r+=rb->data.rgba.pixel_step;
-      g+=rb->data.rgba.pixel_step;
-      b+=rb->data.rgba.pixel_step;
+      r += rb->data.rgba.pixel_step;
+      g += rb->data.rgba.pixel_step;
+      b += rb->data.rgba.pixel_step;
     }
-    (void) jpeg_write_scanlines(&cinfo, &rowdata, 1);
+    (void)jpeg_write_scanlines(&cinfo, &rowdata, 1);
   }
 
   /* Step 6: Finish compression */
@@ -256,10 +247,11 @@ int saveAsJPEG(mapObj *map, rasterBuffer
 }
 
 /*
- * sort a given list of rgba entries so that all the opaque pixels are at the end
+ * sort a given list of rgba entries so that all the opaque pixels are at the
+ * end
  */
-int remapPaletteForPNG(rasterBufferObj *rb, rgbPixel *rgb, unsigned char *a, int *num_a)
-{
+int remapPaletteForPNG(rasterBufferObj *rb, rgbPixel *rgb, unsigned char *a,
+                       int *num_a) {
   int bot_idx, top_idx;
   unsigned x;
   int remap[256];
@@ -275,7 +267,8 @@ int remapPaletteForPNG(rasterBufferObj *
   ** --not that this should matter to anyone.
   */
 
-  for (top_idx = (int)rb->data.palette.num_entries-1, bot_idx = x = 0;  x < rb->data.palette.num_entries;  ++x) {
+  for (top_idx = (int)rb->data.palette.num_entries - 1, bot_idx = x = 0;
+       x < rb->data.palette.num_entries; ++x) {
     if (rb->data.palette.palette[x].a == maxval)
       remap[x] = top_idx--;
     else
@@ -283,50 +276,53 @@ int remapPaletteForPNG(rasterBufferObj *
   }
   /* sanity check:  top and bottom indices should have just crossed paths */
   if (bot_idx != top_idx + 1) {
-    msSetError(MS_MISCERR,"quantization sanity check failed","createPNGPalette()");
+    msSetError(MS_MISCERR, "quantization sanity check failed",
+               "createPNGPalette()");
     return MS_FAILURE;
   }
 
   *num_a = bot_idx;
 
-  for(x=0; x<rb->width*rb->height; x++)
+  for (x = 0; x < rb->width * rb->height; x++)
     rb->data.palette.pixels[x] = remap[rb->data.palette.pixels[x]];
 
-
   for (x = 0; x < rb->data.palette.num_entries; ++x) {
-    if(maxval == 255) {
+    if (maxval == 255) {
       a[remap[x]] = rb->data.palette.palette[x].a;
       rgb[remap[x]].r = rb->data.palette.palette[x].r;
       rgb[remap[x]].g = rb->data.palette.palette[x].g;
       rgb[remap[x]].b = rb->data.palette.palette[x].b;
     } else {
       /* rescale palette */
-      rgb[remap[x]].r = (rb->data.palette.palette[x].r * 255 + (maxval >> 1)) / maxval;
-      rgb[remap[x]].g = (rb->data.palette.palette[x].g * 255 + (maxval >> 1)) / maxval;
-      rgb[remap[x]].b = (rb->data.palette.palette[x].b * 255 + (maxval >> 1)) / maxval;
-      a[remap[x]] = (rb->data.palette.palette[x].a * 255 + (maxval >> 1)) / maxval;
+      rgb[remap[x]].r =
+          (rb->data.palette.palette[x].r * 255 + (maxval >> 1)) / maxval;
+      rgb[remap[x]].g =
+          (rb->data.palette.palette[x].g * 255 + (maxval >> 1)) / maxval;
+      rgb[remap[x]].b =
+          (rb->data.palette.palette[x].b * 255 + (maxval >> 1)) / maxval;
+      a[remap[x]] =
+          (rb->data.palette.palette[x].a * 255 + (maxval >> 1)) / maxval;
     }
-    if(a[remap[x]] != 255) {
+    if (a[remap[x]] != 255) {
       /* un-premultiply pixels */
-      double da = 255.0/a[remap[x]];
-      rgb[remap[x]].r *=  da;
-      rgb[remap[x]].g *=  da;
-      rgb[remap[x]].b *=  da;
+      double da = 255.0 / a[remap[x]];
+      rgb[remap[x]].r *= da;
+      rgb[remap[x]].g *= da;
+      rgb[remap[x]].b *= da;
     }
   }
 
   return MS_SUCCESS;
 }
 
-int savePalettePNG(rasterBufferObj *rb, streamInfo *info, int compression)
-{
+int savePalettePNG(rasterBufferObj *rb, streamInfo *info, int compression) {
   png_infop info_ptr;
   rgbPixel rgb[256];
   unsigned char a[256];
   int num_a;
   int sample_depth;
-  png_structp png_ptr = png_create_write_struct(
-                          PNG_LIBPNG_VER_STRING, NULL,NULL,NULL);
+  png_structp png_ptr =
+      png_create_write_struct(PNG_LIBPNG_VER_STRING, NULL, NULL, NULL);
 
   assert(rb->type == MS_BUFFER_BYTE_PALETTE);
 
@@ -334,12 +330,11 @@ int savePalettePNG(rasterBufferObj *rb,
     return (MS_FAILURE);
 
   png_set_compression_level(png_ptr, compression);
-  png_set_filter (png_ptr,0, PNG_FILTER_NONE);
+  png_set_filter(png_ptr, 0, PNG_FILTER_NONE);
 
   info_ptr = png_create_info_struct(png_ptr);
   if (!info_ptr) {
-    png_destroy_write_struct(&png_ptr,
-                             (png_infopp)NULL);
+    png_destroy_write_struct(&png_ptr, (png_infopp)NULL);
     return (MS_FAILURE);
   }
 
@@ -347,11 +342,10 @@ int savePalettePNG(rasterBufferObj *rb,
     png_destroy_write_struct(&png_ptr, &info_ptr);
     return (MS_FAILURE);
   }
-  if(info->fp)
-    png_set_write_fn(png_ptr,info, png_write_data_to_stream, png_flush_data);
+  if (info->fp)
+    png_set_write_fn(png_ptr, info, png_write_data_to_stream, png_flush_data);
   else
-    png_set_write_fn(png_ptr,info, png_write_data_to_buffer, png_flush_data);
-
+    png_set_write_fn(png_ptr, info, png_write_data_to_buffer, png_flush_data);
 
   if (rb->data.palette.num_entries <= 2)
     sample_depth = 1;
@@ -362,22 +356,22 @@ int savePalettePNG(rasterBufferObj *rb,
   else
     sample_depth = 8;
 
-  png_set_IHDR(png_ptr, info_ptr, rb->width, rb->height,
-               sample_depth, PNG_COLOR_TYPE_PALETTE,
-               0, PNG_COMPRESSION_TYPE_DEFAULT,
+  png_set_IHDR(png_ptr, info_ptr, rb->width, rb->height, sample_depth,
+               PNG_COLOR_TYPE_PALETTE, 0, PNG_COMPRESSION_TYPE_DEFAULT,
                PNG_FILTER_TYPE_DEFAULT);
 
-  remapPaletteForPNG(rb,rgb,a,&num_a);
+  remapPaletteForPNG(rb, rgb, a, &num_a);
 
-  png_set_PLTE(png_ptr, info_ptr, (png_colorp)(rgb),rb->data.palette.num_entries);
-  if(num_a)
-    png_set_tRNS(png_ptr, info_ptr, a,num_a, NULL);
+  png_set_PLTE(png_ptr, info_ptr, (png_colorp)(rgb),
+               rb->data.palette.num_entries);
+  if (num_a)
+    png_set_tRNS(png_ptr, info_ptr, a, num_a, NULL);
 
   png_write_info(png_ptr, info_ptr);
   png_set_packing(png_ptr);
 
-  for(unsigned row=0; row<rb->height; row++) {
-    unsigned char *rowptr = &(rb->data.palette.pixels[row*rb->width]);
+  for (unsigned row = 0; row < rb->height; row++) {
+    unsigned char *rowptr = &(rb->data.palette.pixels[row * rb->width]);
     png_write_row(png_ptr, rowptr);
   }
   png_write_end(png_ptr, info_ptr);
@@ -385,38 +379,45 @@ int savePalettePNG(rasterBufferObj *rb,
   return MS_SUCCESS;
 }
 
-int readPalette(const char *palette, rgbaPixel *entries, unsigned int *nEntries, int useAlpha)
-{
+int readPalette(const char *palette, rgbaPixel *entries, unsigned int *nEntries,
+                int useAlpha) {
   FILE *stream = NULL;
   char buffer[MS_BUFFER_LENGTH];
   *nEntries = 0;
 
   stream = fopen(palette, "r");
-  if(!stream) {
-    msSetError(MS_IOERR, "Error opening palette file %s.", "readPalette()", palette);
+  if (!stream) {
+    msSetError(MS_IOERR, "Error opening palette file %s.", "readPalette()",
+               palette);
     return MS_FAILURE;
   }
 
-  while(fgets(buffer, MS_BUFFER_LENGTH, stream) && *nEntries<256) {
-    int r,g,b,a = 0;
+  while (fgets(buffer, MS_BUFFER_LENGTH, stream) && *nEntries < 256) {
+    int r, g, b, a = 0;
     /* while there are colors to load */
-    if(buffer[0] == '#' || buffer[0] == '\n' || buffer[0] == '\r')
+    if (buffer[0] == '#' || buffer[0] == '\n' || buffer[0] == '\r')
       continue; /* skip comments and blank lines */
-    if(!useAlpha) {
-      if(3 != sscanf(buffer,"%d,%d,%d\n",&r,&g,&b)) {
+    if (!useAlpha) {
+      if (3 != sscanf(buffer, "%d,%d,%d\n", &r, &g, &b)) {
         fclose(stream);
-        msSetError(MS_MISCERR,"failed to parse color %d r,g,b triplet in line \"%s\" from file %s","readPalette()",*nEntries+1,buffer,palette);
+        msSetError(MS_MISCERR,
+                   "failed to parse color %d r,g,b triplet in line \"%s\" from "
+                   "file %s",
+                   "readPalette()", *nEntries + 1, buffer, palette);
         return MS_FAILURE;
       }
     } else {
-      if(4 != sscanf(buffer,"%d,%d,%d,%d\n",&r,&g,&b,&a)) {
+      if (4 != sscanf(buffer, "%d,%d,%d,%d\n", &r, &g, &b, &a)) {
         fclose(stream);
-        msSetError(MS_MISCERR,"failed to parse color %d r,g,b,a quadruplet in line \"%s\" from file %s","readPalette()",*nEntries+1,buffer,palette);
+        msSetError(MS_MISCERR,
+                   "failed to parse color %d r,g,b,a quadruplet in line \"%s\" "
+                   "from file %s",
+                   "readPalette()", *nEntries + 1, buffer, palette);
         return MS_FAILURE;
       }
     }
-    if(useAlpha && a != 255) {
-      double da = a/255.0;
+    if (useAlpha && a != 255) {
+      double da = a / 255.0;
       entries[*nEntries].r = r * da;
       entries[*nEntries].g = g * da;
       entries[*nEntries].b = b * da;
@@ -433,100 +434,113 @@ int readPalette(const char *palette, rgb
   return MS_SUCCESS;
 }
 
-int saveAsPNG(mapObj *map,rasterBufferObj *rb, streamInfo *info, outputFormatObj *format)
-{
+int saveAsPNG(mapObj *map, rasterBufferObj *rb, streamInfo *info,
+              outputFormatObj *format) {
   int force_pc256 = MS_FALSE;
   int force_palette = MS_FALSE;
 
-  const char *force_string,*zlib_compression;
+  const char *force_string, *zlib_compression;
   int compression = -1;
 
-  zlib_compression = msGetOutputFormatOption( format, "COMPRESSION", NULL);
-  if(zlib_compression && *zlib_compression) {
+  zlib_compression = msGetOutputFormatOption(format, "COMPRESSION", NULL);
+  if (zlib_compression && *zlib_compression) {
     char *endptr;
-    compression = strtol(zlib_compression,&endptr,10);
-    if(*endptr || compression<-1 || compression>9) {
-      msSetError(MS_MISCERR,"failed to parse FORMATOPTION \"COMPRESSION=%s\", expecting integer from 0 to 9.","saveAsPNG()",zlib_compression);
+    compression = strtol(zlib_compression, &endptr, 10);
+    if (*endptr || compression < -1 || compression > 9) {
+      msSetError(MS_MISCERR,
+                 "failed to parse FORMATOPTION \"COMPRESSION=%s\", expecting "
+                 "integer from 0 to 9.",
+                 "saveAsPNG()", zlib_compression);
       return MS_FAILURE;
     }
   }
 
-
-  force_string = msGetOutputFormatOption( format, "QUANTIZE_FORCE", NULL );
-  if( force_string && (strcasecmp(force_string,"on") == 0  || strcasecmp(force_string,"yes") == 0 || strcasecmp(force_string,"true") == 0) )
+  force_string = msGetOutputFormatOption(format, "QUANTIZE_FORCE", NULL);
+  if (force_string && (strcasecmp(force_string, "on") == 0 ||
+                       strcasecmp(force_string, "yes") == 0 ||
+                       strcasecmp(force_string, "true") == 0))
     force_pc256 = MS_TRUE;
 
-  force_string = msGetOutputFormatOption( format, "PALETTE_FORCE", NULL );
-  if( force_string && (strcasecmp(force_string,"on") == 0  || strcasecmp(force_string,"yes") == 0 || strcasecmp(force_string,"true") == 0) )
+  force_string = msGetOutputFormatOption(format, "PALETTE_FORCE", NULL);
+  if (force_string && (strcasecmp(force_string, "on") == 0 ||
+                       strcasecmp(force_string, "yes") == 0 ||
+                       strcasecmp(force_string, "true") == 0))
     force_palette = MS_TRUE;
 
-  if(force_pc256 || force_palette) {
+  if (force_pc256 || force_palette) {
     rasterBufferObj qrb;
     rgbaPixel palette[256], paletteGiven[256];
     unsigned int numPaletteGivenEntries;
-    memset(&qrb,0,sizeof(rasterBufferObj));
+    memset(&qrb, 0, sizeof(rasterBufferObj));
     qrb.type = MS_BUFFER_BYTE_PALETTE;
     qrb.width = rb->width;
     qrb.height = rb->height;
-    qrb.data.palette.pixels = (unsigned char*)malloc(qrb.width*qrb.height*sizeof(unsigned char));
+    qrb.data.palette.pixels =
+        (unsigned char *)malloc(qrb.width * qrb.height * sizeof(unsigned char));
     qrb.data.palette.scaling_maxval = 255;
     int ret;
-    if(force_pc256) {
+    if (force_pc256) {
       qrb.data.palette.palette = palette;
-      qrb.data.palette.num_entries = atoi(msGetOutputFormatOption( format, "QUANTIZE_COLORS", "256"));
-      ret = msQuantizeRasterBuffer(rb,&(qrb.data.palette.num_entries),qrb.data.palette.palette,
-                                   NULL, 0,
+      qrb.data.palette.num_entries =
+          atoi(msGetOutputFormatOption(format, "QUANTIZE_COLORS", "256"));
+      ret = msQuantizeRasterBuffer(rb, &(qrb.data.palette.num_entries),
+                                   qrb.data.palette.palette, NULL, 0,
                                    &qrb.data.palette.scaling_maxval);
     } else {
-      unsigned colorsWanted = (unsigned)atoi(msGetOutputFormatOption( format, "QUANTIZE_COLORS", "0"));
-      const char *palettePath = msGetOutputFormatOption( format, "PALETTE", "palette.txt");
+      unsigned colorsWanted = (unsigned)atoi(
+          msGetOutputFormatOption(format, "QUANTIZE_COLORS", "0"));
+      const char *palettePath =
+          msGetOutputFormatOption(format, "PALETTE", "palette.txt");
       char szPath[MS_MAXPATHLEN];
-      if(map) {
+      if (map) {
         msBuildPath(szPath, map->mappath, palettePath);
         palettePath = szPath;
       }
-      if(readPalette(palettePath,paletteGiven,&numPaletteGivenEntries,format->transparent) != MS_SUCCESS) {
+      if (readPalette(palettePath, paletteGiven, &numPaletteGivenEntries,
+                      format->transparent) != MS_SUCCESS) {
         return MS_FAILURE;
       }
 
-      if(numPaletteGivenEntries == 256 || colorsWanted == 0) {
+      if (numPaletteGivenEntries == 256 || colorsWanted == 0) {
         qrb.data.palette.palette = paletteGiven;
         qrb.data.palette.num_entries = numPaletteGivenEntries;
         ret = MS_SUCCESS;
 
-        /* we have a full palette and don't want an additional quantization step */
+        /* we have a full palette and don't want an additional quantization step
+         */
       } else {
         /* quantize the image, and mix our colours in the resulting palette */
         qrb.data.palette.palette = palette;
-        qrb.data.palette.num_entries = MS_MAX(colorsWanted,numPaletteGivenEntries);
-        ret = msQuantizeRasterBuffer(rb,&(qrb.data.palette.num_entries),qrb.data.palette.palette,
-                                     paletteGiven,numPaletteGivenEntries,
+        qrb.data.palette.num_entries =
+            MS_MAX(colorsWanted, numPaletteGivenEntries);
+        ret = msQuantizeRasterBuffer(rb, &(qrb.data.palette.num_entries),
+                                     qrb.data.palette.palette, paletteGiven,
+                                     numPaletteGivenEntries,
                                      &qrb.data.palette.scaling_maxval);
       }
     }
-    if(ret != MS_FAILURE) {
-      msClassifyRasterBuffer(rb,&qrb);
-      ret = savePalettePNG(&qrb,info,compression);
+    if (ret != MS_FAILURE) {
+      msClassifyRasterBuffer(rb, &qrb);
+      ret = savePalettePNG(&qrb, info, compression);
     }
     msFree(qrb.data.palette.pixels);
     return ret;
-  } else if(rb->type == MS_BUFFER_BYTE_RGBA) {
+  } else if (rb->type == MS_BUFFER_BYTE_RGBA) {
     png_infop info_ptr;
     int color_type;
     unsigned int *rowdata;
-    png_structp png_ptr = png_create_write_struct(
-                            PNG_LIBPNG_VER_STRING, NULL,NULL,NULL);
+    png_structp png_ptr =
+        png_create_write_struct(PNG_LIBPNG_VER_STRING, NULL, NULL, NULL);
 
     if (!png_ptr)
       return (MS_FAILURE);
 
     png_set_compression_level(png_ptr, compression);
-    png_set_filter (png_ptr,0, PNG_FILTER_NONE);
+    png_set_filter(png_ptr, 0, PNG_FILTER_NONE);
 
     info_ptr = png_create_info_struct(png_ptr);
     if (!info_ptr) {
-      png_destroy_write_struct(&png_ptr,
-                               (png_infopp)NULL);
+      png_destroy_write_struct(&png_ptr, (png_infopp)NULL);
       return (MS_FAILURE);
     }
 
@@ -534,73 +548,72 @@ int saveAsPNG(mapObj *map,rasterBufferOb
       png_destroy_write_struct(&png_ptr, &info_ptr);
       return (MS_FAILURE);
     }
-    if(info->fp)
-      png_set_write_fn(png_ptr,info, png_write_data_to_stream, png_flush_data);
+    if (info->fp)
+      png_set_write_fn(png_ptr, info, png_write_data_to_stream, png_flush_data);
     else
-      png_set_write_fn(png_ptr,info, png_write_data_to_buffer, png_flush_data);
+      png_set_write_fn(png_ptr, info, png_write_data_to_buffer, png_flush_data);
 
-    if(rb->data.rgba.a)
+    if (rb->data.rgba.a)
       color_type = PNG_COLOR_TYPE_RGB_ALPHA;
     else
       color_type = PNG_COLOR_TYPE_RGB;
 
-    png_set_IHDR(png_ptr, info_ptr, rb->width, rb->height,
-                 8, color_type, PNG_INTERLACE_NONE,
-                 PNG_COMPRESSION_TYPE_DEFAULT, PNG_FILTER_TYPE_DEFAULT);
+    png_set_IHDR(png_ptr, info_ptr, rb->width, rb->height, 8, color_type,
+                 PNG_INTERLACE_NONE, PNG_COMPRESSION_TYPE_DEFAULT,
+                 PNG_FILTER_TYPE_DEFAULT);
 
     png_write_info(png_ptr, info_ptr);
 
-    if(!rb->data.rgba.a && rb->data.rgba.pixel_step==4)
+    if (!rb->data.rgba.a && rb->data.rgba.pixel_step == 4)
       png_set_filler(png_ptr, 0, PNG_FILLER_AFTER);
 
-    rowdata = (unsigned int*)malloc(rb->width*sizeof(unsigned int));
-    for(unsigned row=0; row<rb->height; row++) {
+    rowdata = (unsigned int *)malloc(rb->width * sizeof(unsigned int));
+    for (unsigned row = 0; row < rb->height; row++) {
       unsigned int *pixptr = rowdata;
-      unsigned char *a,*r,*g,*b;
-      r=rb->data.rgba.r+row*rb->data.rgba.row_step;
-      g=rb->data.rgba.g+row*rb->data.rgba.row_step;
-      b=rb->data.rgba.b+row*rb->data.rgba.row_step;
-      if(rb->data.rgba.a) {
-        a=rb->data.rgba.a+row*rb->data.rgba.row_step;
-        for(unsigned col=0; col<rb->width; col++) {
-          if(*a) {
-            double da = *a/255.0;
-            unsigned char *pix = (unsigned char*)pixptr;
-            pix[0] = *r/da;
-            pix[1] = *g/da;
-            pix[2] = *b/da;
+      unsigned char *a, *r, *g, *b;
+      r = rb->data.rgba.r + row * rb->data.rgba.row_step;
+      g = rb->data.rgba.g + row * rb->data.rgba.row_step;
+      b = rb->data.rgba.b + row * rb->data.rgba.row_step;
+      if (rb->data.rgba.a) {
+        a = rb->data.rgba.a + row * rb->data.rgba.row_step;
+        for (unsigned col = 0; col < rb->width; col++) {
+          if (*a) {
+            double da = *a / 255.0;
+            unsigned char *pix = (unsigned char *)pixptr;
+            pix[0] = *r / da;
+            pix[1] = *g / da;
+            pix[2] = *b / da;
             pix[3] = *a;
           } else {
-            *pixptr=0;
+            *pixptr = 0;
           }
           pixptr++;
-          a+=rb->data.rgba.pixel_step;
-          r+=rb->data.rgba.pixel_step;
-          g+=rb->data.rgba.pixel_step;
-          b+=rb->data.rgba.pixel_step;
+          a += rb->data.rgba.pixel_step;
+          r += rb->data.rgba.pixel_step;
+          g += rb->data.rgba.pixel_step;
+          b += rb->data.rgba.pixel_step;
         }
       } else {
-        for(unsigned col=0; col<rb->width; col++) {
-          unsigned char *pix = (unsigned char*)pixptr;
+        for (unsigned col = 0; col < rb->width; col++) {
+          unsigned char *pix = (unsigned char *)pixptr;
           pix[0] = *r;
           pix[1] = *g;
           pix[2] = *b;
           pixptr++;
-          r+=rb->data.rgba.pixel_step;
-          g+=rb->data.rgba.pixel_step;
-          b+=rb->data.rgba.pixel_step;
+          r += rb->data.rgba.pixel_step;
+          g += rb->data.rgba.pixel_step;
+          b += rb->data.rgba.pixel_step;
         }
       }
 
-      png_write_row(png_ptr,(png_bytep)rowdata);
-
+      png_write_row(png_ptr, (png_bytep)rowdata);
     }
     png_write_end(png_ptr, info_ptr);
     free(rowdata);
     png_destroy_write_struct(&png_ptr, &info_ptr);
     return MS_SUCCESS;
   } else {
-    msSetError(MS_MISCERR,"Unknown buffer type","saveAsPNG()");
+    msSetError(MS_MISCERR, "Unknown buffer type", "saveAsPNG()");
     return MS_FAILURE;
   }
 }
@@ -612,60 +625,58 @@ int saveAsPNG(mapObj *map,rasterBufferOb
 #define SEEK_SET 0
 #endif /* SEEK_SET */
 
-
-int readPNG(char *path, rasterBufferObj *rb)
-{
-  png_uint_32 width,height;
-  unsigned char *a,*r,*g,*b;
-  int bit_depth,color_type;
+int readPNG(char *path, rasterBufferObj *rb) {
+  png_uint_32 width, height;
+  unsigned char *a, *r, *g, *b;
+  int bit_depth, color_type;
   unsigned char **row_pointers;
   png_structp png_ptr = NULL;
   png_infop info_ptr = NULL;
 
-  FILE *stream = fopen(path,"rb");
-  if(!stream)
+  FILE *stream = fopen(path, "rb");
+  if (!stream)
     return MS_FAILURE;
 
   /* could pass pointers to user-defined error handlers instead of NULLs: */
   png_ptr = png_create_read_struct(PNG_LIBPNG_VER_STRING, NULL, NULL, NULL);
   if (!png_ptr) {
     fclose(stream);
-    return MS_FAILURE;   /* out of memory */
+    return MS_FAILURE; /* out of memory */
   }
 
   info_ptr = png_create_info_struct(png_ptr);
   if (!info_ptr) {
     png_destroy_read_struct(&png_ptr, NULL, NULL);
     fclose(stream);
-    return MS_FAILURE;   /* out of memory */
+    return MS_FAILURE; /* out of memory */
   }
 
-  if(setjmp(png_jmpbuf(png_ptr))) {
-    png_destroy_read_struct(&png_ptr,&info_ptr,NULL);
+  if (setjmp(png_jmpbuf(png_ptr))) {
+    png_destroy_read_struct(&png_ptr, &info_ptr, NULL);
     fclose(stream);
     return MS_FAILURE;
   }
 
-  png_init_io(png_ptr,stream);
-  png_read_info(png_ptr,info_ptr);
-  png_get_IHDR(png_ptr, info_ptr, &width, &height,
-               &bit_depth, &color_type,
-               NULL,NULL,NULL);
+  png_init_io(png_ptr, stream);
+  png_read_info(png_ptr, info_ptr);
+  png_get_IHDR(png_ptr, info_ptr, &width, &height, &bit_depth, &color_type,
+               NULL, NULL, NULL);
 
   rb->width = width;
   rb->height = height;
   rb->type = MS_BUFFER_BYTE_RGBA;
-  rb->data.rgba.pixels = (unsigned char*)malloc(width*height*4*sizeof(unsigned char));
-  row_pointers = (unsigned char**)malloc(height*sizeof(unsigned char*));
-  rb->data.rgba.pixel_step=4;
-  rb->data.rgba.row_step = width*4;
+  rb->data.rgba.pixels =
+      (unsigned char *)malloc(width * height * 4 * sizeof(unsigned char));
+  row_pointers = (unsigned char **)malloc(height * sizeof(unsigned char *));
+  rb->data.rgba.pixel_step = 4;
+  rb->data.rgba.row_step = width * 4;
   b = rb->data.rgba.b = &rb->data.rgba.pixels[0];
   g = rb->data.rgba.g = &rb->data.rgba.pixels[1];
   r = rb->data.rgba.r = &rb->data.rgba.pixels[2];
   a = rb->data.rgba.a = &rb->data.rgba.pixels[3];
 
-  for(unsigned i=0; i<height; i++) {
-    row_pointers[i] = &(rb->data.rgba.pixels[i*rb->data.rgba.row_step]);
+  for (unsigned i = 0; i < height; i++) {
+    row_pointers[i] = &(rb->data.rgba.pixels[i * rb->data.rgba.row_step]);
   }
 
   if (color_type == PNG_COLOR_TYPE_PALETTE)
@@ -695,68 +706,67 @@ int readPNG(char *path, rasterBufferObj
 
   png_read_image(png_ptr, row_pointers);
   free(row_pointers);
-  row_pointers=NULL;
-  png_read_end(png_ptr,NULL);
+  row_pointers = NULL;
+  png_read_end(png_ptr, NULL);
   png_destroy_read_struct(&png_ptr, &info_ptr, NULL);
 
   /*premultiply data*/
-  for(unsigned i=0; i<width*height; i++) {
-    if(*a < 255) {
-      if(*a == 0) {
-        *r=*g=*b=0;
+  for (unsigned i = 0; i < width * height; i++) {
+    if (*a < 255) {
+      if (*a == 0) {
+        *r = *g = *b = 0;
       } else {
         *r = (*r * *a + 255) >> 8;
         *g = (*g * *a + 255) >> 8;
         *b = (*b * *a + 255) >> 8;
       }
     }
-    a+=4;
-    b+=4;
-    g+=4;
-    r+=4;
+    a += 4;
+    b += 4;
+    g += 4;
+    r += 4;
   }
 
   fclose(stream);
   return MS_SUCCESS;
-
 }
 
 int msSaveRasterBuffer(mapObj *map, rasterBufferObj *rb, FILE *stream,
-                       outputFormatObj *format)
-{
-  if(strcasestr(format->driver,"/png")) {
+                       outputFormatObj *format) {
+  if (strcasestr(format->driver, "/png")) {
     streamInfo info;
     info.fp = stream;
     info.buffer = NULL;
 
-    return saveAsPNG(map, rb,&info,format);
-  } else if(strcasestr(format->driver,"/jpeg")) {
+    return saveAsPNG(map, rb, &info, format);
+  } else if (strcasestr(format->driver, "/jpeg")) {
     streamInfo info;
     info.fp = stream;
-    info.buffer=NULL;
-    
-    return saveAsJPEG(map, rb,&info,format);
+    info.buffer = NULL;
+
+    return saveAsJPEG(map, rb, &info, format);
   } else {
-    msSetError(MS_MISCERR,"unsupported image format\n", "msSaveRasterBuffer()");
+    msSetError(MS_MISCERR, "unsupported image format\n",
+               "msSaveRasterBuffer()");
     return MS_FAILURE;
   }
 }
 
 int msSaveRasterBufferToBuffer(rasterBufferObj *data, bufferObj *buffer,
-                               outputFormatObj *format)
-{
-  if(strcasestr(format->driver,"/png")) {
+                               outputFormatObj *format) {
+  if (strcasestr(format->driver, "/png")) {
     streamInfo info;
     info.fp = NULL;
     info.buffer = buffer;
-    return saveAsPNG(NULL, data,&info,format);
-  } else if(strcasestr(format->driver,"/jpeg")) {
+    return saveAsPNG(NULL, data, &info, format);
+  } else if (strcasestr(format->driver, "/jpeg")) {
     streamInfo info;
     info.fp = NULL;
-    info.buffer=buffer;
-    return saveAsJPEG(NULL, data,&info,format);
+    info.buffer = buffer;
+    return saveAsJPEG(NULL, data, &info, format);
   } else {
-    msSetError(MS_MISCERR,"unsupported image format\n", "msSaveRasterBuffer()");
+    msSetError(MS_MISCERR, "unsupported image format\n",
+               "msSaveRasterBuffer()");
     return MS_FAILURE;
   }
 }
@@ -774,112 +784,111 @@ static char const *gif_error_msg()
   int code = GifLastError();
 #endif
   switch (code) {
-    case E_GIF_ERR_OPEN_FAILED: /* should not see this */
-      return "Failed to open given file";
+  case E_GIF_ERR_OPEN_FAILED: /* should not see this */
+    return "Failed to open given file";
 
-    case E_GIF_ERR_WRITE_FAILED:
-      return "Write failed";
+  case E_GIF_ERR_WRITE_FAILED:
+    return "Write failed";
 
-    case E_GIF_ERR_HAS_SCRN_DSCR: /* should not see this */
-      return "Screen descriptor already passed to giflib";
+  case E_GIF_ERR_HAS_SCRN_DSCR: /* should not see this */
+    return "Screen descriptor already passed to giflib";
 
-    case E_GIF_ERR_HAS_IMAG_DSCR: /* should not see this */
-      return "Image descriptor already passed to giflib";
+  case E_GIF_ERR_HAS_IMAG_DSCR: /* should not see this */
+    return "Image descriptor already passed to giflib";
 
-    case E_GIF_ERR_NO_COLOR_MAP: /* should not see this */
-      return "Neither global nor local color map set";
+  case E_GIF_ERR_NO_COLOR_MAP: /* should not see this */
+    return "Neither global nor local color map set";
 
-    case E_GIF_ERR_DATA_TOO_BIG: /* should not see this */
-      return "Too much pixel data passed to giflib";
+  case E_GIF_ERR_DATA_TOO_BIG: /* should not see this */
+    return "Too much pixel data passed to giflib";
 
-    case E_GIF_ERR_NOT_ENOUGH_MEM:
-      return "Out of memory";
+  case E_GIF_ERR_NOT_ENOUGH_MEM:
+    return "Out of memory";
 
-    case E_GIF_ERR_DISK_IS_FULL:
-      return "Disk is full";
+  case E_GIF_ERR_DISK_IS_FULL:
+    return "Disk is full";
 
-    case E_GIF_ERR_CLOSE_FAILED: /* should not see this */
-      return "File close failed";
+  case E_GIF_ERR_CLOSE_FAILED: /* should not see this */
+    return "File close failed";
 
-    case E_GIF_ERR_NOT_WRITEABLE: /* should not see this */
-      return "File not writable";
+  case E_GIF_ERR_NOT_WRITEABLE: /* should not see this */
+    return "File not writable";
 
-    case D_GIF_ERR_OPEN_FAILED:
-      return "Failed to open file";
+  case D_GIF_ERR_OPEN_FAILED:
+    return "Failed to open file";
 
-    case D_GIF_ERR_READ_FAILED:
-      return "Failed to read from file";
+  case D_GIF_ERR_READ_FAILED:
+    return "Failed to read from file";
 
-    case D_GIF_ERR_NOT_GIF_FILE:
-      return "File is not a GIF file";
+  case D_GIF_ERR_NOT_GIF_FILE:
+    return "File is not a GIF file";
 
-    case D_GIF_ERR_NO_SCRN_DSCR:
-      return "No screen descriptor detected - invalid file";
+  case D_GIF_ERR_NO_SCRN_DSCR:
+    return "No screen descriptor detected - invalid file";
 
-    case D_GIF_ERR_NO_IMAG_DSCR:
-      return "No image descriptor detected - invalid file";
+  case D_GIF_ERR_NO_IMAG_DSCR:
+    return "No image descriptor detected - invalid file";
 
-    case D_GIF_ERR_NO_COLOR_MAP:
-      return "No global or local color map found";
+  case D_GIF_ERR_NO_COLOR_MAP:
+    return "No global or local color map found";
 
-    case D_GIF_ERR_WRONG_RECORD:
-      return "Wrong record type detected - invalid file?";
+  case D_GIF_ERR_WRONG_RECORD:
+    return "Wrong record type detected - invalid file?";
 
-    case D_GIF_ERR_DATA_TOO_BIG:
-      return "Data in file too big for image";
+  case D_GIF_ERR_DATA_TOO_BIG:
+    return "Data in file too big for image";
 
-    case D_GIF_ERR_NOT_ENOUGH_MEM:
-      return "Out of memory";
+  case D_GIF_ERR_NOT_ENOUGH_MEM:
+    return "Out of memory";
 
-    case D_GIF_ERR_CLOSE_FAILED:
-      return "Close failed";
+  case D_GIF_ERR_CLOSE_FAILED:
+    return "Close failed";
 
-    case D_GIF_ERR_NOT_READABLE:
-      return "File not opened for read";
+  case D_GIF_ERR_NOT_READABLE:
+    return "File not opened for read";
 
-    case D_GIF_ERR_IMAGE_DEFECT:
-      return "Defective image";
+  case D_GIF_ERR_IMAGE_DEFECT:
+    return "Defective image";
 
-    case D_GIF_ERR_EOF_TOO_SOON:
-      return "Unexpected EOF - invalid file";
+  case D_GIF_ERR_EOF_TOO_SOON:
+    return "Unexpected EOF - invalid file";
 
-    default:
-      sprintf(msg, "Unknown giflib error code %d", code);
-      return msg;
+  default:
+    sprintf(msg, "Unknown giflib error code %d", code);
+    return msg;
   }
 }
 
-
 /* not fully implemented and tested */
 /* missing: set the first pointer to a,r,g,b */
-int readGIF(char *path, rasterBufferObj *rb)
-{
+int readGIF(char *path, rasterBufferObj *rb) {
   int codeSize, extCode, firstImageRead = MS_FALSE;
-  unsigned char *r,*g,*b,*a;
+  unsigned char *r, *g, *b, *a;
   int transIdx = -1;
   GifFileType *image;
   GifPixelType *line;
   GifRecordType recordType;
   GifByteType *codeBlock, *extension;
   ColorMapObject *cmap;
-  int interlacedOffsets[] = {0,4,2,1};
-  int interlacedJumps[] = {8,8,4,2};
+  int interlacedOffsets[] = {0, 4, 2, 1};
+  int interlacedJumps[] = {8, 8, 4, 2};
 #if defined GIFLIB_MAJOR && GIFLIB_MAJOR >= 5
   int errcode;
 #endif
 
-
   rb->type = MS_BUFFER_BYTE_RGBA;
 #if defined GIFLIB_MAJOR && GIFLIB_MAJOR >= 5
-  image =  DGifOpenFileName(path, &errcode);
+  image = DGifOpenFileName(path, &errcode);
   if (image == NULL) {
-    msSetError(MS_MISCERR,"failed to load gif image: %s","readGIF()", gif_error_msg(errcode));
+    msSetError(MS_MISCERR, "failed to load gif image: %s", "readGIF()",
+               gif_error_msg(errcode));
     return MS_FAILURE;
   }
 #else
-  image =  DGifOpenFileName(path);
+  image = DGifOpenFileName(path);
   if (image == NULL) {
-    msSetError(MS_MISCERR,"failed to load gif image: %s","readGIF()", gif_error_msg());
+    msSetError(MS_MISCERR, "failed to load gif image: %s", "readGIF()",
+               gif_error_msg());
     return MS_FAILURE;
   }
 #endif
@@ -887,114 +896,93 @@ int readGIF(char *path, rasterBufferObj
   rb->height = image->SHeight;
   rb->data.rgba.row_step = rb->width * 4;
   rb->data.rgba.pixel_step = 4;
-  rb->data.rgba.pixels = (unsigned char*)malloc(rb->width*rb->height*4*sizeof(unsigned char));
+  rb->data.rgba.pixels = (unsigned char *)malloc(rb->width * rb->height * 4 *
+                                                 sizeof(unsigned char));
   b = rb->data.rgba.b = &rb->data.rgba.pixels[0];
   g = rb->data.rgba.g = &rb->data.rgba.pixels[1];
   r = rb->data.rgba.r = &rb->data.rgba.pixels[2];
   a = rb->data.rgba.a = &rb->data.rgba.pixels[3];
 
-  cmap = (image->Image.ColorMap)?image->Image.ColorMap:image->SColorMap;
-  for(unsigned i=0; i<rb->width*rb->height; i++) {
+  cmap = (image->Image.ColorMap) ? image->Image.ColorMap : image->SColorMap;
+  for (unsigned i = 0; i < rb->width * rb->height; i++) {
     *a = 255;
     *r = cmap->Colors[image->SBackGroundColor].Red;
     *g = cmap->Colors[image->SBackGroundColor].Green;
     *b = cmap->Colors[image->SBackGroundColor].Blue;
-    a+=rb->data.rgba.pixel_step;
-    r+=rb->data.rgba.pixel_step;
-    g+=rb->data.rgba.pixel_step;
-    b+=rb->data.rgba.pixel_step;
+    a += rb->data.rgba.pixel_step;
+    r += rb->data.rgba.pixel_step;
+    g += rb->data.rgba.pixel_step;
+    b += rb->data.rgba.pixel_step;
   }
 
   do {
     if (DGifGetRecordType(image, &recordType) == GIF_ERROR) {
 #if defined GIFLIB_MAJOR && GIFLIB_MAJOR >= 5
-      msSetError(MS_MISCERR,"corrupted gif image?: %s","readGIF()", gif_error_msg(image->Error));
+      msSetError(MS_MISCERR, "corrupted gif image?: %s", "readGIF()",
+                 gif_error_msg(image->Error));
 #else
-      msSetError(MS_MISCERR,"corrupted gif image?: %s","readGIF()", gif_error_msg());
+      msSetError(MS_MISCERR, "corrupted gif image?: %s", "readGIF()",
+                 gif_error_msg());
 #endif
       return MS_FAILURE;
     }
 
     switch (recordType) {
-      case SCREEN_DESC_RECORD_TYPE:
-        DGifGetScreenDesc(image);
-        break;
-      case IMAGE_DESC_RECORD_TYPE:
-        if (DGifGetImageDesc(image) == GIF_ERROR) {
+    case SCREEN_DESC_RECORD_TYPE:
+      DGifGetScreenDesc(image);
+      break;
+    case IMAGE_DESC_RECORD_TYPE:
+      if (DGifGetImageDesc(image) == GIF_ERROR) {
 #if defined GIFLIB_MAJOR && GIFLIB_MAJOR >= 5
-          msSetError(MS_MISCERR,"corrupted gif image?: %s","readGIF()", gif_error_msg(image->Error));
+        msSetError(MS_MISCERR, "corrupted gif image?: %s", "readGIF()",
+                   gif_error_msg(image->Error));
 #else
-          msSetError(MS_MISCERR,"corrupted gif image?: %s","readGIF()", gif_error_msg());
+        msSetError(MS_MISCERR, "corrupted gif image?: %s", "readGIF()",
+                   gif_error_msg());
 #endif
+        return MS_FAILURE;
+      }
+      if (!firstImageRead) {
+
+        unsigned row = image->Image.Top;
+        unsigned col = image->Image.Left;
+        unsigned width = image->Image.Width;
+        unsigned height = image->Image.Height;
+
+        /* sanity check: */
+        if (col + width > rb->width || row + height > rb->height) {
+          msSetError(MS_MISCERR,
+                     "corrupted gif image, img size exceeds screen size",
+                     "readGIF()");
           return MS_FAILURE;
         }
-        if (!firstImageRead) {
-
-          unsigned row = image->Image.Top;
-          unsigned col = image->Image.Left;
-          unsigned width = image->Image.Width;
-          unsigned height = image->Image.Height;
-
-          /* sanity check: */
-          if(col+width>rb->width || row+height>rb->height) {
-            msSetError(MS_MISCERR,"corrupted gif image, img size exceeds screen size","readGIF()");
-            return MS_FAILURE;
-          }
-
-          line = (GifPixelType *) malloc(width * sizeof(GifPixelType));
-          if(image->Image.Interlace) {
-            int count;
-            for(count=0; count<4; count++) {
-              for(unsigned i=row+interlacedOffsets[count]; i<row+height; i+=interlacedJumps[count]) {
-                int offset = i * rb->data.rgba.row_step + col * rb->data.rgba.pixel_step;
-                a = rb->data.rgba.a + offset;
-                r = rb->data.rgba.r + offset;
-                g = rb->data.rgba.g + offset;
-                b = rb->data.rgba.b + offset;
-                if (DGifGetLine(image, line, width) == GIF_ERROR) {
-#if defined GIFLIB_MAJOR && GIFLIB_MAJOR >= 5
-                  msSetError(MS_MISCERR,"corrupted gif image?: %s","readGIF()",gif_error_msg(image->Error));
-#else
-                  msSetError(MS_MISCERR,"corrupted gif image?: %s","readGIF()",gif_error_msg());
-#endif
-                  return MS_FAILURE;
-                }
 
-                for(unsigned j=0; j<width; j++) {
-                  GifPixelType pix = line[j];
-                  if(transIdx == -1 || pix != transIdx) {
-                    *a = 255;
-                    *r = cmap->Colors[pix].Red;
-                    *g = cmap->Colors[pix].Green;
-                    *b = cmap->Colors[pix].Blue;
-                  } else {
-                    *a = *r = *g = *b = 0;
-                  }
-                  a+=rb->data.rgba.pixel_step;
-                  r+=rb->data.rgba.pixel_step;
-                  g+=rb->data.rgba.pixel_step;
-                  b+=rb->data.rgba.pixel_step;
-                }
-              }
-            }
-          } else {
-            for (unsigned i = 0; i < height; i++) {
-              int offset = i * rb->data.rgba.row_step + col * rb->data.rgba.pixel_step;
+        line = (GifPixelType *)malloc(width * sizeof(GifPixelType));
+        if (image->Image.Interlace) {
+          int count;
+          for (count = 0; count < 4; count++) {
+            for (unsigned i = row + interlacedOffsets[count]; i < row + height;
+                 i += interlacedJumps[count]) {
+              int offset =
+                  i * rb->data.rgba.row_step + col * rb->data.rgba.pixel_step;
               a = rb->data.rgba.a + offset;
               r = rb->data.rgba.r + offset;
               g = rb->data.rgba.g + offset;
               b = rb->data.rgba.b + offset;
               if (DGifGetLine(image, line, width) == GIF_ERROR) {
 #if defined GIFLIB_MAJOR && GIFLIB_MAJOR >= 5
-                msSetError(MS_MISCERR,"corrupted gif image?: %s","readGIF()",gif_error_msg(image->Error));
+                msSetError(MS_MISCERR, "corrupted gif image?: %s", "readGIF()",
+                           gif_error_msg(image->Error));
 #else
-                msSetError(MS_MISCERR,"corrupted gif image?: %s","readGIF()",gif_error_msg());
+                msSetError(MS_MISCERR, "corrupted gif image?: %s", "readGIF()",
+                           gif_error_msg());
 #endif
                 return MS_FAILURE;
               }
-              for(unsigned j=0; j<width; j++) {
+
+              for (unsigned j = 0; j < width; j++) {
                 GifPixelType pix = line[j];
-                if(transIdx == -1 || pix != transIdx) {
+                if (transIdx == -1 || pix != transIdx) {
                   *a = 255;
                   *r = cmap->Colors[pix].Red;
                   *g = cmap->Colors[pix].Green;
@@ -1002,86 +990,132 @@ int readGIF(char *path, rasterBufferObj
                 } else {
                   *a = *r = *g = *b = 0;
                 }
-                a+=rb->data.rgba.pixel_step;
-                r+=rb->data.rgba.pixel_step;
-                g+=rb->data.rgba.pixel_step;
-                b+=rb->data.rgba.pixel_step;
+                a += rb->data.rgba.pixel_step;
+                r += rb->data.rgba.pixel_step;
+                g += rb->data.rgba.pixel_step;
+                b += rb->data.rgba.pixel_step;
               }
             }
           }
-          free((char *) line);
-          firstImageRead = MS_TRUE;
         } else {
-          /* Skip all next images */
-          if (DGifGetCode(image, &codeSize, &codeBlock) == GIF_ERROR) {
-#if defined GIFLIB_MAJOR && GIFLIB_MAJOR >= 5
-            msSetError(MS_MISCERR,"corrupted gif image?: %s","readGIF()", gif_error_msg(image->Error));
-#else
-            msSetError(MS_MISCERR,"corrupted gif image?: %s","readGIF()", gif_error_msg());
-#endif
-            return MS_FAILURE;
-          }
-          while (codeBlock != NULL) {
-            if (DGifGetCodeNext(image, &codeBlock) == GIF_ERROR) {
+          for (unsigned i = 0; i < height; i++) {
+            int offset =
+                i * rb->data.rgba.row_step + col * rb->data.rgba.pixel_step;
+            a = rb->data.rgba.a + offset;
+            r = rb->data.rgba.r + offset;
+            g = rb->data.rgba.g + offset;
+            b = rb->data.rgba.b + offset;
+            if (DGifGetLine(image, line, width) == GIF_ERROR) {
 #if defined GIFLIB_MAJOR && GIFLIB_MAJOR >= 5
-              msSetError(MS_MISCERR,"corrupted gif image?: %s","readGIF()", gif_error_msg(image->Error));
+              msSetError(MS_MISCERR, "corrupted gif image?: %s", "readGIF()",
+                         gif_error_msg(image->Error));
 #else
-              msSetError(MS_MISCERR,"corrupted gif image?: %s","readGIF()", gif_error_msg());
+              msSetError(MS_MISCERR, "corrupted gif image?: %s", "readGIF()",
+                         gif_error_msg());
 #endif
               return MS_FAILURE;
             }
+            for (unsigned j = 0; j < width; j++) {
+              GifPixelType pix = line[j];
+              if (transIdx == -1 || pix != transIdx) {
+                *a = 255;
+                *r = cmap->Colors[pix].Red;
+                *g = cmap->Colors[pix].Green;
+                *b = cmap->Colors[pix].Blue;
+              } else {
+                *a = *r = *g = *b = 0;
+              }
+              a += rb->data.rgba.pixel_step;
+              r += rb->data.rgba.pixel_step;
+              g += rb->data.rgba.pixel_step;
+              b += rb->data.rgba.pixel_step;
+            }
           }
         }
-        break;
-      case EXTENSION_RECORD_TYPE:
-        /* skip all extension blocks */
-        if (DGifGetExtension(image, &extCode, &extension) == GIF_ERROR) {
+        free((char *)line);
+        firstImageRead = MS_TRUE;
+      } else {
+        /* Skip all next images */
+        if (DGifGetCode(image, &codeSize, &codeBlock) == GIF_ERROR) {
 #if defined GIFLIB_MAJOR && GIFLIB_MAJOR >= 5
-          msSetError(MS_MISCERR,"corrupted gif image?: %s","readGIF()", gif_error_msg(image->Error));
+          msSetError(MS_MISCERR, "corrupted gif image?: %s", "readGIF()",
+                     gif_error_msg(image->Error));
 #else
-          msSetError(MS_MISCERR,"corrupted gif image?: %s","readGIF()", gif_error_msg());
+          msSetError(MS_MISCERR, "corrupted gif image?: %s", "readGIF()",
+                     gif_error_msg());
 #endif
           return MS_FAILURE;
         }
-        if(extCode == 249 && (extension[1] & 1))
-          transIdx = extension[4];
-        for (;;) {
-          if (DGifGetExtensionNext(image, &extension) == GIF_ERROR) {
+        while (codeBlock != NULL) {
+          if (DGifGetCodeNext(image, &codeBlock) == GIF_ERROR) {
 #if defined GIFLIB_MAJOR && GIFLIB_MAJOR >= 5
-            msSetError(MS_MISCERR,"corrupted gif image?: %s","readGIF()", gif_error_msg(image->Error));
+            msSetError(MS_MISCERR, "corrupted gif image?: %s", "readGIF()",
+                       gif_error_msg(image->Error));
 #else
-            msSetError(MS_MISCERR,"corrupted gif image?: %s","readGIF()", gif_error_msg());
+            msSetError(MS_MISCERR, "corrupted gif image?: %s", "readGIF()",
+                       gif_error_msg());
 #endif
             return MS_FAILURE;
           }
-          if (extension == NULL)
-            break;
-          if(extension[1] & 1)
-            transIdx = extension[4];
         }
-        break;
-      case UNDEFINED_RECORD_TYPE:
-        break;
-      case TERMINATE_RECORD_TYPE:
-        break;
-      default:
-        break;
+      }
+      break;
+    case EXTENSION_RECORD_TYPE:
+      /* skip all extension blocks */
+      if (DGifGetExtension(image, &extCode, &extension) == GIF_ERROR) {
+#if defined GIFLIB_MAJOR && GIFLIB_MAJOR >= 5
+        msSetError(MS_MISCERR, "corrupted gif image?: %s", "readGIF()",
+                   gif_error_msg(image->Error));
+#else
+        msSetError(MS_MISCERR, "corrupted gif image?: %s", "readGIF()",
+                   gif_error_msg());
+#endif
+        return MS_FAILURE;
+      }
+      if (extCode == 249 && (extension[1] & 1))
+        transIdx = extension[4];
+      for (;;) {
+        if (DGifGetExtensionNext(image, &extension) == GIF_ERROR) {
+#if defined GIFLIB_MAJOR && GIFLIB_MAJOR >= 5
+          msSetError(MS_MISCERR, "corrupted gif image?: %s", "readGIF()",
+                     gif_error_msg(image->Error));
+#else
+          msSetError(MS_MISCERR, "corrupted gif image?: %s", "readGIF()",
+                     gif_error_msg());
+#endif
+          return MS_FAILURE;
+        }
+        if (extension == NULL)
+          break;
+        if (extension[1] & 1)
+          transIdx = extension[4];
+      }
+      break;
+    case UNDEFINED_RECORD_TYPE:
+      break;
+    case TERMINATE_RECORD_TYPE:
+      break;
+    default:
+      break;
     }
 
   } while (recordType != TERMINATE_RECORD_TYPE);
 
-
-#if defined GIFLIB_MAJOR && GIFLIB_MINOR && ((GIFLIB_MAJOR == 5 && GIFLIB_MINOR >= 1) || (GIFLIB_MAJOR > 5))
+#if defined GIFLIB_MAJOR && GIFLIB_MINOR &&                                    \
+    ((GIFLIB_MAJOR == 5 && GIFLIB_MINOR >= 1) || (GIFLIB_MAJOR > 5))
   if (DGifCloseFile(image, &errcode) == GIF_ERROR) {
-    msSetError(MS_MISCERR,"failed to close gif after loading: %s","readGIF()", gif_error_msg(errcode));
+    msSetError(MS_MISCERR, "failed to close gif after loading: %s", "readGIF()",
+               gif_error_msg(errcode));
     return MS_FAILURE;
   }
 #else
   if (DGifCloseFile(image) == GIF_ERROR) {
 #if defined GIFLIB_MAJOR && GIFLIB_MAJOR >= 5
-    msSetError(MS_MISCERR,"failed to close gif after loading: %s","readGIF()", gif_error_msg(image->Error));
+    msSetError(MS_MISCERR, "failed to close gif after loading: %s", "readGIF()",
+               gif_error_msg(image->Error));
 #else
-    msSetError(MS_MISCERR,"failed to close gif after loading: %s","readGIF()", gif_error_msg());
+    msSetError(MS_MISCERR, "failed to close gif after loading: %s", "readGIF()",
+               gif_error_msg());
 #endif
     return MS_FAILURE;
   }
@@ -1091,33 +1125,37 @@ int readGIF(char *path, rasterBufferObj
 }
 #endif
 
-int msLoadMSRasterBufferFromFile(char *path, rasterBufferObj *rb)
-{
+int msLoadMSRasterBufferFromFile(char *path, rasterBufferObj *rb) {
   FILE *stream;
   unsigned char signature[8];
   int ret = MS_FAILURE;
-  stream = fopen(path,"rb");
-  if(!stream) {
-    msSetError(MS_MISCERR, "unable to open file %s for reading", "msLoadMSRasterBufferFromFile()", path);
+  stream = fopen(path, "rb");
+  if (!stream) {
+    msSetError(MS_MISCERR, "unable to open file %s for reading",
+               "msLoadMSRasterBufferFromFile()", path);
     return MS_FAILURE;
   }
-  if(1 != fread(signature,8,1,stream)) {
+  if (1 != fread(signature, 8, 1, stream)) {
     fclose(stream);
-    msSetError(MS_MISCERR, "Unable to read header from image file %s", "msLoadMSRasterBufferFromFile()",path);
+    msSetError(MS_MISCERR, "Unable to read header from image file %s",
+               "msLoadMSRasterBufferFromFile()", path);
     return MS_FAILURE;
   }
   fclose(stream);
-  if(png_sig_cmp(signature,0,8) == 0) {
-    ret = readPNG(path,rb);
-  } else if (!strncmp((char*)signature,"GIF",3)) {
+  if (png_sig_cmp(signature, 0, 8) == 0) {
+    ret = readPNG(path, rb);
+  } else if (!strncmp((char *)signature, "GIF", 3)) {
 #ifdef USE_GIF
-    ret = readGIF(path,rb);
+    ret = readGIF(path, rb);
 #else
-    msSetError(MS_MISCERR,"pixmap %s seems to be GIF formatted, but this server is compiled without GIF support","readImage()",path);
+    msSetError(MS_MISCERR,
+               "pixmap %s seems to be GIF formatted, but this server is "
+               "compiled without GIF support",
+               "readImage()", path);
     return MS_FAILURE;
 #endif
   } else {
-    msSetError(MS_MISCERR,"unsupported pixmap format","readImage()");
+    msSetError(MS_MISCERR, "unsupported pixmap format", "readImage()");
     return MS_FAILURE;
   }
   return ret;
diff -pruN 8.0.1-5/mapimagemap.c 8.0.2-1/mapimagemap.c
--- 8.0.1-5/mapimagemap.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapimagemap.c	2024-06-11 20:41:34.000000000 +0000
@@ -38,8 +38,6 @@
 #include <io.h>
 #endif
 
-
-
 #define MYDEBUG 0
 #define DEBUG_IF if (MYDEBUG > 2)
 
@@ -107,46 +105,45 @@ typedef struct pString {
  * imagemap/dxf file; parts of this live in another data structure and
  * are only referenced indirectly here.  The other contains layer-specific
  * information for the dxf output. */
-static char *layerlist=NULL;
-static int layersize=0;
-static pString imgStr, layerStr= { &layerlist, &layersize, 0 };
+static char *layerlist = NULL;
+static int layersize = 0;
+static pString imgStr, layerStr = {&layerlist, &layersize, 0};
 
 /* Format strings for the various bits of a client-side imagemap. */
 static const char *polyHrefFmt, *polyMOverFmt, *polyMOutFmt;
 static const char *symbolHrefFmt, *symbolMOverFmt, *symbolMOutFmt;
 static const char *mapName;
 /* Should we suppress AREA declarations in imagemaps with no title? */
-static int suppressEmpty=0;
+static int suppressEmpty = 0;
 
 /* Prevent buffer-overrun and format-string attacks by "sanitizing" any
  * provided format string to fit the number of expected string arguments
  * (MAX) exactly. */
-static const char *makeFmtSafe(const char *fmt, int MAX)
-{
+static const char *makeFmtSafe(const char *fmt, int MAX) {
   /* format string should have exactly 'MAX' %s */
 
-  char *result = msSmallMalloc(strlen(fmt)+1+3*MAX), *cp;
-  int numstr=0, saw_percent=0;
+  char *result = msSmallMalloc(strlen(fmt) + 1 + 3 * MAX), *cp;
+  int numstr = 0, saw_percent = 0;
 
   strcpy(result, fmt);
-  for (cp=result; *cp; cp++) {
+  for (cp = result; *cp; cp++) {
     if (saw_percent) {
-      if (*cp=='%') {
+      if (*cp == '%') {
         /* safe */
-      } else if (*cp=='s' && numstr<MAX) {
+      } else if (*cp == 's' && numstr < MAX) {
         numstr++; /* still safe */
       } else {
         /* disable this unsafe format string! */
-        *(cp-1)=' ';
+        *(cp - 1) = ' ';
       }
-      saw_percent=0;
-    } else if (*cp=='%')
-      saw_percent=1;
+      saw_percent = 0;
+    } else if (*cp == '%')
+      saw_percent = 1;
   }
   /* fixup format strings without enough %s in them */
-  while (numstr<MAX) {
+  while (numstr < MAX) {
     strcpy(cp, "%.s"); /* print using zero-length precision */
-    cp+=3;
+    cp += 3;
     numstr++;
   }
   return result;
@@ -155,16 +152,14 @@ static const char *makeFmtSafe(const cha
 /* Append the given printf-style formatted string to the pString 'ps'.
  * This is much cleaner (and faster) than the technique this file
  * used to use! */
-static void im_iprintf(pString *ps, const char *fmt, ...)
-{
+static void im_iprintf(pString *ps, const char *fmt, ...) {
   int n, remaining;
   va_list ap;
   do {
     remaining = *(ps->alloc_size) - ps->string_len;
     va_start(ap, fmt);
 #if defined(HAVE_VSNPRINTF)
-    n = vsnprintf((*(ps->string)) + ps->string_len,
-                  remaining, fmt, ap);
+    n = vsnprintf((*(ps->string)) + ps->string_len, remaining, fmt, ap);
 #else
     /* If vsnprintf() is not available then require a minimum
      * of 512 bytes of free space to prevent a buffer overflow
@@ -177,35 +172,33 @@ static void im_iprintf(pString *ps, cons
 #endif
     va_end(ap);
     /* if that worked, we're done! */
-    if (-1<n && n<remaining) {
+    if (-1 < n && n < remaining) {
       ps->string_len += n;
       return;
-    } else { /* double allocated string size */
-      *(ps->alloc_size) *= 2;/* these keeps realloc linear.*/
+    } else {                  /* double allocated string size */
+      *(ps->alloc_size) *= 2; /* these keeps realloc linear.*/
       if (*(ps->alloc_size) < 1024)
         /* careful: initial size can be 0 */
-        *(ps->alloc_size)=1024;
-      if (n>-1 && *(ps->alloc_size) <= (n + ps->string_len))
+        *(ps->alloc_size) = 1024;
+      if (n > -1 && *(ps->alloc_size) <= (n + ps->string_len))
         /* ensure at least as much as what is needed */
-        *(ps->alloc_size) = n+ps->string_len+1;
-      *(ps->string) = (char *) msSmallRealloc
-                      (*(ps->string), *(ps->alloc_size));
+        *(ps->alloc_size) = n + ps->string_len + 1;
+      *(ps->string) = (char *)msSmallRealloc(*(ps->string), *(ps->alloc_size));
       /* if realloc doesn't work, we're screwed! */
     }
   } while (1); /* go back and try again. */
 }
 
-
-
-static int lastcolor=-1;
-static int matchdxfcolor(colorObj col)
-{
-  int best=7;
-  int delta=128*255;
+static int lastcolor = -1;
+static int matchdxfcolor(colorObj col) {
+  int best = 7;
+  int delta = 128 * 255;
   int tcolor = 0;
   if (lastcolor != -1)
     return lastcolor;
-  while (tcolor < 256 && (ctable[tcolor].r != col.red || ctable[tcolor].g != col.green || ctable[tcolor].b != col.blue)) {
+  while (tcolor < 256 &&
+         (ctable[tcolor].r != col.red || ctable[tcolor].g != col.green ||
+          ctable[tcolor].b != col.blue)) {
     const int dr = ctable[tcolor].r - col.red;
     const int dg = ctable[tcolor].g - col.green;
     const int db = ctable[tcolor].b - col.blue;
@@ -216,17 +209,19 @@ static int matchdxfcolor(colorObj col)
     }
     tcolor++;
   }
-  if (tcolor >= 256) tcolor = best;
-  /* DEBUG_IF printf("%d/%d/%d (%d/%d - %d), %d : %d/%d/%d<BR>\n", ctable[tcolor].r, ctable[tcolor].g, ctable[tcolor].b, tcolor, best, delta, lastcolor, col.red, col.green, col.blue); */
+  if (tcolor >= 256)
+    tcolor = best;
+  /* DEBUG_IF printf("%d/%d/%d (%d/%d - %d), %d : %d/%d/%d<BR>\n",
+   * ctable[tcolor].r, ctable[tcolor].g, ctable[tcolor].b, tcolor, best, delta,
+   * lastcolor, col.red, col.green, col.blue); */
   lastcolor = tcolor;
   return tcolor;
 }
 
-static char* lname;
+static char *lname;
 static int dxf;
 
-void msImageStartLayerIM(mapObj *map, layerObj *layer, imageObj *image)
-{
+void msImageStartLayerIM(mapObj *map, layerObj *layer, imageObj *image) {
   (void)map;
   (void)image;
   DEBUG_IF printf("ImageStartLayerIM\n<BR>");
@@ -240,7 +235,8 @@ void msImageStartLayerIM(mapObj *map, la
   } else if (dxf) {
     im_iprintf(&layerStr,
                "  0\nLAYER\n  2\n%s\n"
-               " 70\n  64\n 6\nCONTINUOUS\n", lname);
+               " 70\n  64\n 6\nCONTINUOUS\n",
+               lname);
   }
   lastcolor = -1;
 }
@@ -250,15 +246,15 @@ void msImageStartLayerIM(mapObj *map, la
  * a pointer to an imageObj structure.
  */
 imageObj *msImageCreateIM(int width, int height, outputFormatObj *format,
-                          char *imagepath, char *imageurl, double resolution, double defresolution)
-{
-  imageObj  *image=NULL;
-  if (setvbuf(stdout, NULL, _IONBF , 0)) {
+                          char *imagepath, char *imageurl, double resolution,
+                          double defresolution) {
+  imageObj *image = NULL;
+  if (setvbuf(stdout, NULL, _IONBF, 0)) {
     printf("Whoops...");
   };
   DEBUG_IF printf("msImageCreateIM<BR>\n");
   if (width > 0 && height > 0) {
-    image = (imageObj *)msSmallCalloc(1,sizeof(imageObj));
+    image = (imageObj *)msSmallCalloc(1, sizeof(imageObj));
     imgStr.string = &(image->img.imagemap);
     imgStr.alloc_size = &(image->size);
 
@@ -270,48 +266,51 @@ imageObj *msImageCreateIM(int width, int
     image->imagepath = NULL;
     image->imageurl = NULL;
     image->resolution = resolution;
-    image->resolutionfactor = resolution/defresolution;
+    image->resolutionfactor = resolution / defresolution;
 
-    if( strcasecmp("ON",msGetOutputFormatOption( format, "DXF", "OFF" )) == 0) {
+    if (strcasecmp("ON", msGetOutputFormatOption(format, "DXF", "OFF")) == 0) {
       dxf = 1;
       im_iprintf(&layerStr, "  2\nLAYER\n 70\n  10\n");
     } else
       dxf = 0;
 
-    if( strcasecmp("ON",msGetOutputFormatOption( format, "SCRIPT", "OFF" )) == 0) {
+    if (strcasecmp("ON", msGetOutputFormatOption(format, "SCRIPT", "OFF")) ==
+        0) {
       dxf = 2;
       im_iprintf(&layerStr, "");
     }
 
     /* get href formation string options */
-    polyHrefFmt = makeFmtSafe(msGetOutputFormatOption
-        ( format, "POLYHREF", "javascript:Clicked('%s');"), 1);
-    polyMOverFmt = makeFmtSafe(msGetOutputFormatOption
-        ( format, "POLYMOUSEOVER", ""), 1);
-    polyMOutFmt = makeFmtSafe(msGetOutputFormatOption
-        ( format, "POLYMOUSEOUT", ""), 1);
-    symbolHrefFmt = makeFmtSafe(msGetOutputFormatOption
-        ( format, "SYMBOLHREF", "javascript:SymbolClicked();"), 1);
-    symbolMOverFmt = makeFmtSafe(msGetOutputFormatOption
-        ( format, "SYMBOLMOUSEOVER", ""), 1);
-    symbolMOutFmt = makeFmtSafe(msGetOutputFormatOption
-        ( format, "SYMBOLMOUSEOUT", ""), 1);
+    polyHrefFmt =
+        makeFmtSafe(msGetOutputFormatOption(format, "POLYHREF",
+                                            "javascript:Clicked('%s');"),
+                    1);
+    polyMOverFmt =
+        makeFmtSafe(msGetOutputFormatOption(format, "POLYMOUSEOVER", ""), 1);
+    polyMOutFmt =
+        makeFmtSafe(msGetOutputFormatOption(format, "POLYMOUSEOUT", ""), 1);
+    symbolHrefFmt =
+        makeFmtSafe(msGetOutputFormatOption(format, "SYMBOLHREF",
+                                            "javascript:SymbolClicked();"),
+                    1);
+    symbolMOverFmt =
+        makeFmtSafe(msGetOutputFormatOption(format, "SYMBOLMOUSEOVER", ""), 1);
+    symbolMOutFmt =
+        makeFmtSafe(msGetOutputFormatOption(format, "SYMBOLMOUSEOUT", ""), 1);
     /* get name of client-side image map */
-    mapName = msGetOutputFormatOption
-      ( format, "MAPNAME", "map1" );
+    mapName = msGetOutputFormatOption(format, "MAPNAME", "map1");
     /* should we suppress area declarations with no title? */
-    if( strcasecmp("YES",msGetOutputFormatOption( format, "SUPPRESS", "NO" )) == 0) {
-      suppressEmpty=1;
+    if (strcasecmp("YES", msGetOutputFormatOption(format, "SUPPRESS", "NO")) ==
+        0) {
+      suppressEmpty = 1;
     }
 
     lname = msStrdup("NONE");
     *(imgStr.string) = msStrdup("");
     if (*(imgStr.string)) {
-      *(imgStr.alloc_size) =
-        imgStr.string_len = strlen(*(imgStr.string));
+      *(imgStr.alloc_size) = imgStr.string_len = strlen(*(imgStr.string));
     } else {
-      *(imgStr.alloc_size) =
-        imgStr.string_len = 0;
+      *(imgStr.alloc_size) = imgStr.string_len = 0;
     }
     if (imagepath) {
       image->imagepath = msStrdup(imagepath);
@@ -322,9 +321,8 @@ imageObj *msImageCreateIM(int width, int
 
     return image;
   } else {
-    msSetError(MS_IMGERR,
-               "Cannot create IM image of size %d x %d.",
-               "msImageCreateIM()", width, height );
+    msSetError(MS_IMGERR, "Cannot create IM image of size %d x %d.",
+               "msImageCreateIM()", width, height);
   }
   return image;
 }
@@ -332,8 +330,8 @@ imageObj *msImageCreateIM(int width, int
 /* ------------------------------------------------------------------------- */
 /* Draw a single marker symbol of the specified size and color               */
 /* ------------------------------------------------------------------------- */
-void msDrawMarkerSymbolIM(mapObj *map, imageObj* img, pointObj *p, styleObj *style, double scalefactor)
-{
+void msDrawMarkerSymbolIM(mapObj *map, imageObj *img, pointObj *p,
+                          styleObj *style, double scalefactor) {
   symbolObj *symbol;
   int ox, oy;
   double size;
@@ -342,56 +340,57 @@ void msDrawMarkerSymbolIM(mapObj *map, i
 
   /* skip this, we don't do text */
 
+  if (!p)
+    return;
 
-
-  if(!p) return;
-
-
-  if(style->symbol > map->symbolset.numsymbols || style->symbol < 0) return; /* no such symbol, 0 is OK */
+  if (style->symbol > map->symbolset.numsymbols || style->symbol < 0)
+    return; /* no such symbol, 0 is OK */
   symbol = map->symbolset.symbol[style->symbol];
-  ox = style->offsetx*scalefactor;
-  oy = style->offsety*scalefactor;
-  if(style->size == -1) {
-    size = msSymbolGetDefaultSize( symbol );
-    size = MS_NINT(size*scalefactor);
+  ox = style->offsetx * scalefactor;
+  oy = style->offsety * scalefactor;
+  if (style->size == -1) {
+    size = msSymbolGetDefaultSize(symbol);
+    size = MS_NINT(size * scalefactor);
   } else
-    size = MS_NINT(style->size*scalefactor);
-  size = MS_MAX(size, style->minsize*img->resolutionfactor);
-  size = MS_MIN(size, style->maxsize*img->resolutionfactor);
+    size = MS_NINT(style->size * scalefactor);
+  size = MS_MAX(size, style->minsize * img->resolutionfactor);
+  size = MS_MIN(size, style->maxsize * img->resolutionfactor);
 
-  if(size < 1) return; /* size too small */
+  if (size < 1)
+    return; /* size too small */
 
   /* DEBUG_IF printf(".%d.%d.%d.", symbol->type, style->symbol, fc); */
-  if(style->symbol == 0) { /* simply draw a single pixel of the specified color */
+  if (style->symbol ==
+      0) { /* simply draw a single pixel of the specified color */
 
     if (dxf) {
-      if (dxf==2)
-        im_iprintf (&imgStr, "POINT\n%.0f %.0f\n%d\n",
-                    p->x + ox, p->y + oy, matchdxfcolor(style->color));
+      if (dxf == 2)
+        im_iprintf(&imgStr, "POINT\n%.0f %.0f\n%d\n", p->x + ox, p->y + oy,
+                   matchdxfcolor(style->color));
       else
-        im_iprintf (&imgStr,
-                    "  0\nPOINT\n 10\n%f\n 20\n%f\n 30\n0.0\n"
-                    " 62\n%6d\n  8\n%s\n",
-                    p->x + ox, p->y + oy, matchdxfcolor(style->color), lname);
+        im_iprintf(&imgStr,
+                   "  0\nPOINT\n 10\n%f\n 20\n%f\n 30\n0.0\n"
+                   " 62\n%6d\n  8\n%s\n",
+                   p->x + ox, p->y + oy, matchdxfcolor(style->color), lname);
     } else {
-      im_iprintf (&imgStr, "<area ");
-      if (strcmp(symbolHrefFmt,"%.s")!=0) {
-        im_iprintf (&imgStr, "href=\"");
-        im_iprintf (&imgStr, symbolHrefFmt, lname);
-        im_iprintf (&imgStr, "\" ");
-      }
-      if (strcmp(symbolMOverFmt,"%.s")!=0) {
-        im_iprintf (&imgStr, "onMouseOver=\"");
-        im_iprintf (&imgStr, symbolMOverFmt, lname);
-        im_iprintf (&imgStr, "\" ");
+      im_iprintf(&imgStr, "<area ");
+      if (strcmp(symbolHrefFmt, "%.s") != 0) {
+        im_iprintf(&imgStr, "href=\"");
+        im_iprintf(&imgStr, symbolHrefFmt, lname);
+        im_iprintf(&imgStr, "\" ");
+      }
+      if (strcmp(symbolMOverFmt, "%.s") != 0) {
+        im_iprintf(&imgStr, "onMouseOver=\"");
+        im_iprintf(&imgStr, symbolMOverFmt, lname);
+        im_iprintf(&imgStr, "\" ");
+      }
+      if (strcmp(symbolMOutFmt, "%.s") != 0) {
+        im_iprintf(&imgStr, "onMouseOut=\"");
+        im_iprintf(&imgStr, symbolMOutFmt, lname);
+        im_iprintf(&imgStr, "\" ");
       }
-      if (strcmp(symbolMOutFmt,"%.s")!=0) {
-        im_iprintf (&imgStr, "onMouseOut=\"");
-        im_iprintf (&imgStr, symbolMOutFmt, lname);
-        im_iprintf (&imgStr, "\" ");
-      }
-      im_iprintf (&imgStr, "shape=\"circle\" coords=\"%.0f,%.0f, 3\" />\n",
-                  p->x + ox, p->y + oy);
+      im_iprintf(&imgStr, "shape=\"circle\" coords=\"%.0f,%.0f, 3\" />\n",
+                 p->x + ox, p->y + oy);
     }
 
     /* point2 = &( p->line[j].point[i] ); */
@@ -399,61 +398,61 @@ void msDrawMarkerSymbolIM(mapObj *map, i
     return;
   }
   DEBUG_IF printf("A");
-  switch(symbol->type) {
-    case(MS_SYMBOL_TRUETYPE):
-      DEBUG_IF printf("T");
-      break;
-    case(MS_SYMBOL_PIXMAP):
-      DEBUG_IF printf("P");
-      break;
-    case(MS_SYMBOL_VECTOR):
-      DEBUG_IF printf("V");
-      {
-        double d, offset_x, offset_y;
-
-        d = size/symbol->sizey;
-        offset_x = MS_NINT(p->x - d*.5*symbol->sizex + ox);
-        offset_y = MS_NINT(p->y - d*.5*symbol->sizey + oy);
-
-        /* For now I only render filled vector symbols in imagemap, and no */
-        /* dxf support available yet.  */
-        if(symbol->filled && !dxf /* && fc >= 0 */ ) {
-          /* char *title=(p->numvalues) ? p->values[0] : ""; */
-          char *title = "";
-          int  j;
-
-          im_iprintf (&imgStr, "<area ");
-          if (strcmp(symbolHrefFmt,"%.s")!=0) {
-            im_iprintf (&imgStr, "href=\"");
-            im_iprintf (&imgStr, symbolHrefFmt, lname);
-            im_iprintf (&imgStr, "\" ");
-          }
-          if (strcmp(symbolMOverFmt,"%.s")!=0) {
-            im_iprintf (&imgStr, "onMouseOver=\"");
-            im_iprintf (&imgStr, symbolMOverFmt, lname);
-            im_iprintf (&imgStr, "\" ");
-          }
-          if (strcmp(symbolMOutFmt,"%.s")!=0) {
-            im_iprintf (&imgStr, "onMouseOut=\"");
-            im_iprintf (&imgStr, symbolMOutFmt, lname);
-            im_iprintf (&imgStr, "\" ");
-          }
-
-          im_iprintf (&imgStr, "title=\"%s\" shape=\"poly\" coords=\"", title);
-
-          for(j=0; j < symbol->numpoints; j++) {
-            im_iprintf (&imgStr, "%s %d,%d", j == 0 ? "": ",",
-                        (int)MS_NINT(d*symbol->points[j].x + offset_x),
-                        (int)MS_NINT(d*symbol->points[j].y + offset_y) );
-          }
-          im_iprintf (&imgStr, "\" />\n");
-        } /* end of imagemap, filled case. */
-      }
-      break;
+  switch (symbol->type) {
+  case (MS_SYMBOL_TRUETYPE):
+    DEBUG_IF printf("T");
+    break;
+  case (MS_SYMBOL_PIXMAP):
+    DEBUG_IF printf("P");
+    break;
+  case (MS_SYMBOL_VECTOR):
+    DEBUG_IF printf("V");
+    {
+      double d, offset_x, offset_y;
+
+      d = size / symbol->sizey;
+      offset_x = MS_NINT(p->x - d * .5 * symbol->sizex + ox);
+      offset_y = MS_NINT(p->y - d * .5 * symbol->sizey + oy);
+
+      /* For now I only render filled vector symbols in imagemap, and no */
+      /* dxf support available yet.  */
+      if (symbol->filled && !dxf /* && fc >= 0 */) {
+        /* char *title=(p->numvalues) ? p->values[0] : ""; */
+        char *title = "";
+        int j;
+
+        im_iprintf(&imgStr, "<area ");
+        if (strcmp(symbolHrefFmt, "%.s") != 0) {
+          im_iprintf(&imgStr, "href=\"");
+          im_iprintf(&imgStr, symbolHrefFmt, lname);
+          im_iprintf(&imgStr, "\" ");
+        }
+        if (strcmp(symbolMOverFmt, "%.s") != 0) {
+          im_iprintf(&imgStr, "onMouseOver=\"");
+          im_iprintf(&imgStr, symbolMOverFmt, lname);
+          im_iprintf(&imgStr, "\" ");
+        }
+        if (strcmp(symbolMOutFmt, "%.s") != 0) {
+          im_iprintf(&imgStr, "onMouseOut=\"");
+          im_iprintf(&imgStr, symbolMOutFmt, lname);
+          im_iprintf(&imgStr, "\" ");
+        }
 
-    default:
-      DEBUG_IF printf("DEF");
-      break;
+        im_iprintf(&imgStr, "title=\"%s\" shape=\"poly\" coords=\"", title);
+
+        for (j = 0; j < symbol->numpoints; j++) {
+          im_iprintf(&imgStr, "%s %d,%d", j == 0 ? "" : ",",
+                     (int)MS_NINT(d * symbol->points[j].x + offset_x),
+                     (int)MS_NINT(d * symbol->points[j].y + offset_y));
+        }
+        im_iprintf(&imgStr, "\" />\n");
+      } /* end of imagemap, filled case. */
+    }
+    break;
+
+  default:
+    DEBUG_IF printf("DEF");
+    break;
   } /* end switch statement */
 
   return;
@@ -462,174 +461,197 @@ void msDrawMarkerSymbolIM(mapObj *map, i
 /* ------------------------------------------------------------------------- */
 /* Draw a line symbol of the specified size and color                        */
 /* ------------------------------------------------------------------------- */
-void msDrawLineSymbolIM(mapObj *map, imageObj* img, shapeObj *p, styleObj *style, double scalefactor_ignored)
-{
+void msDrawLineSymbolIM(mapObj *map, imageObj *img, shapeObj *p,
+                        styleObj *style, double scalefactor_ignored) {
   (void)img;
   (void)scalefactor_ignored;
   symbolObj *symbol;
-  int i,j,l;
+  int i, j, l;
   char first = 1;
   DEBUG_IF printf("msDrawLineSymbolIM<BR>\n");
 
+  if (!p)
+    return;
+  if (p->numlines <= 0)
+    return;
 
-  if(!p) return;
-  if(p->numlines <= 0) return;
-
-  if(style->symbol > map->symbolset.numsymbols || style->symbol < 0) return; /* no such symbol, 0 is OK */
+  if (style->symbol > map->symbolset.numsymbols || style->symbol < 0)
+    return; /* no such symbol, 0 is OK */
   symbol = map->symbolset.symbol[style->symbol];
 
-  if (suppressEmpty && p->numvalues==0) return;/* suppress area with empty title */
-  if(style->symbol == 0) { /* just draw a single width line */
-    for(l=0,j=0; j<p->numlines; j++) {
+  if (suppressEmpty && p->numvalues == 0)
+    return;                 /* suppress area with empty title */
+  if (style->symbol == 0) { /* just draw a single width line */
+    for (l = 0, j = 0; j < p->numlines; j++) {
       if (dxf == 2) {
-        im_iprintf (&imgStr, "LINE\n%d\n", matchdxfcolor(style->color));
+        im_iprintf(&imgStr, "LINE\n%d\n", matchdxfcolor(style->color));
       } else if (dxf) {
-        im_iprintf (&imgStr, "  0\nPOLYLINE\n 70\n     0\n 62\n%6d\n  8\n%s\n", matchdxfcolor(style->color), lname);
+        im_iprintf(&imgStr, "  0\nPOLYLINE\n 70\n     0\n 62\n%6d\n  8\n%s\n",
+                   matchdxfcolor(style->color), lname);
       } else {
         char *title;
 
         first = 1;
-        title=(p->numvalues) ? p->values[0] : "";
-        im_iprintf (&imgStr, "<area ");
-        if (strcmp(polyHrefFmt,"%.s")!=0) {
-          im_iprintf (&imgStr, "href=\"");
-          im_iprintf (&imgStr, polyHrefFmt, title);
-          im_iprintf (&imgStr, "\" ");
-        }
-        if (strcmp(polyMOverFmt,"%.s")!=0) {
-          im_iprintf (&imgStr, "onMouseOver=\"");
-          im_iprintf (&imgStr, polyMOverFmt, title);
-          im_iprintf (&imgStr, "\" ");
-        }
-        if (strcmp(polyMOutFmt,"%.s")!=0) {
-          im_iprintf (&imgStr, "onMouseOut=\"");
-          im_iprintf (&imgStr, polyMOutFmt, title);
-          im_iprintf (&imgStr, "\" ");
+        title = (p->numvalues) ? p->values[0] : "";
+        im_iprintf(&imgStr, "<area ");
+        if (strcmp(polyHrefFmt, "%.s") != 0) {
+          im_iprintf(&imgStr, "href=\"");
+          im_iprintf(&imgStr, polyHrefFmt, title);
+          im_iprintf(&imgStr, "\" ");
+        }
+        if (strcmp(polyMOverFmt, "%.s") != 0) {
+          im_iprintf(&imgStr, "onMouseOver=\"");
+          im_iprintf(&imgStr, polyMOverFmt, title);
+          im_iprintf(&imgStr, "\" ");
         }
-        im_iprintf (&imgStr, "title=\"%s\" shape=\"poly\" coords=\"", title);
+        if (strcmp(polyMOutFmt, "%.s") != 0) {
+          im_iprintf(&imgStr, "onMouseOut=\"");
+          im_iprintf(&imgStr, polyMOutFmt, title);
+          im_iprintf(&imgStr, "\" ");
+        }
+        im_iprintf(&imgStr, "title=\"%s\" shape=\"poly\" coords=\"", title);
       }
       /* point1 = &( p->line[j].point[p->line[j].numpoints-1] ); */
-      for(i=0; i < p->line[j].numpoints; i++,l++) {
+      for (i = 0; i < p->line[j].numpoints; i++, l++) {
         if (dxf == 2) {
-          im_iprintf (&imgStr, "%.0f %.0f\n", p->line[j].point[i].x, p->line[j].point[i].y);
+          im_iprintf(&imgStr, "%.0f %.0f\n", p->line[j].point[i].x,
+                     p->line[j].point[i].y);
         } else if (dxf) {
-          im_iprintf (&imgStr, "  0\nVERTEX\n 10\n%f\n 20\n%f\n 30\n%f\n", p->line[j].point[i].x, p->line[j].point[i].y, 0.0);
+          im_iprintf(&imgStr, "  0\nVERTEX\n 10\n%f\n 20\n%f\n 30\n%f\n",
+                     p->line[j].point[i].x, p->line[j].point[i].y, 0.0);
         } else {
-          im_iprintf (&imgStr, "%s %.0f,%.0f", first ? "": ",", p->line[j].point[i].x, p->line[j].point[i].y);
+          im_iprintf(&imgStr, "%s %.0f,%.0f", first ? "" : ",",
+                     p->line[j].point[i].x, p->line[j].point[i].y);
         }
         first = 0;
 
         /* point2 = &( p->line[j].point[i] ); */
         /* if(point1->y == point2->y) {} */
       }
-      im_iprintf (&imgStr, dxf ? (dxf == 2 ? "": "  0\nSEQEND\n") : "\" />\n");
+      im_iprintf(&imgStr, dxf ? (dxf == 2 ? "" : "  0\nSEQEND\n") : "\" />\n");
     }
 
     /* DEBUG_IF printf ("%d, ",strlen(img->img.imagemap) ); */
     return;
   }
 
-  DEBUG_IF printf("-%d-",symbol->type);
+  DEBUG_IF printf("-%d-", symbol->type);
 
   return;
 }
 
-
 /* ------------------------------------------------------------------------- */
 /* Draw a shade symbol of the specified size and color                       */
 /* ------------------------------------------------------------------------- */
-void msDrawShadeSymbolIM(mapObj *map, imageObj* img, shapeObj *p, styleObj *style, double scalefactor_ignored)
-{
+void msDrawShadeSymbolIM(mapObj *map, imageObj *img, shapeObj *p,
+                         styleObj *style, double scalefactor_ignored) {
   (void)img;
   (void)scalefactor_ignored;
   symbolObj *symbol;
-  int i,j,l;
+  int i, j, l;
   char first = 1;
 
   DEBUG_IF printf("msDrawShadeSymbolIM\n<BR>");
-  if(!p) return;
-  if(p->numlines <= 0) return;
+  if (!p)
+    return;
+  if (p->numlines <= 0)
+    return;
 
   symbol = map->symbolset.symbol[style->symbol];
 
-  if (suppressEmpty && p->numvalues==0) return;/* suppress area with empty title */
-  if(style->symbol == 0) { /* simply draw a single pixel of the specified color //     */
-    for(l=0,j=0; j<p->numlines; j++) {
+  if (suppressEmpty && p->numvalues == 0)
+    return; /* suppress area with empty title */
+  if (style->symbol ==
+      0) { /* simply draw a single pixel of the specified color //     */
+    for (l = 0, j = 0; j < p->numlines; j++) {
       if (dxf == 2) {
-        im_iprintf (&imgStr, "POLY\n%d\n", matchdxfcolor(style->color));
+        im_iprintf(&imgStr, "POLY\n%d\n", matchdxfcolor(style->color));
       } else if (dxf) {
-        im_iprintf (&imgStr, "  0\nPOLYLINE\n 73\n     1\n 62\n%6d\n  8\n%s\n", matchdxfcolor(style->color), lname);
+        im_iprintf(&imgStr, "  0\nPOLYLINE\n 73\n     1\n 62\n%6d\n  8\n%s\n",
+                   matchdxfcolor(style->color), lname);
       } else {
-        char *title=(p->numvalues) ? p->values[0] : "";
+        char *title = (p->numvalues) ? p->values[0] : "";
         first = 1;
-        im_iprintf (&imgStr, "<area ");
-        if (strcmp(polyHrefFmt,"%.s")!=0) {
-          im_iprintf (&imgStr, "href=\"");
-          im_iprintf (&imgStr, polyHrefFmt, title);
-          im_iprintf (&imgStr, "\" ");
-        }
-        if (strcmp(polyMOverFmt,"%.s")!=0) {
-          im_iprintf (&imgStr, "onMouseOver=\"");
-          im_iprintf (&imgStr, polyMOverFmt, title);
-          im_iprintf (&imgStr, "\" ");
-        }
-        if (strcmp(polyMOutFmt,"%.s")!=0) {
-          im_iprintf (&imgStr, "onMouseOut=\"");
-          im_iprintf (&imgStr, polyMOutFmt, title);
-          im_iprintf (&imgStr, "\" ");
+        im_iprintf(&imgStr, "<area ");
+        if (strcmp(polyHrefFmt, "%.s") != 0) {
+          im_iprintf(&imgStr, "href=\"");
+          im_iprintf(&imgStr, polyHrefFmt, title);
+          im_iprintf(&imgStr, "\" ");
+        }
+        if (strcmp(polyMOverFmt, "%.s") != 0) {
+          im_iprintf(&imgStr, "onMouseOver=\"");
+          im_iprintf(&imgStr, polyMOverFmt, title);
+          im_iprintf(&imgStr, "\" ");
+        }
+        if (strcmp(polyMOutFmt, "%.s") != 0) {
+          im_iprintf(&imgStr, "onMouseOut=\"");
+          im_iprintf(&imgStr, polyMOutFmt, title);
+          im_iprintf(&imgStr, "\" ");
         }
-        im_iprintf (&imgStr, "title=\"%s\" shape=\"poly\" coords=\"", title);
+        im_iprintf(&imgStr, "title=\"%s\" shape=\"poly\" coords=\"", title);
       }
 
       /* point1 = &( p->line[j].point[p->line[j].numpoints-1] ); */
-      for(i=0; i < p->line[j].numpoints; i++,l++) {
+      for (i = 0; i < p->line[j].numpoints; i++, l++) {
         if (dxf == 2) {
-          im_iprintf (&imgStr, "%.0f %.0f\n", p->line[j].point[i].x, p->line[j].point[i].y);
+          im_iprintf(&imgStr, "%.0f %.0f\n", p->line[j].point[i].x,
+                     p->line[j].point[i].y);
         } else if (dxf) {
-          im_iprintf (&imgStr, "  0\nVERTEX\n 10\n%f\n 20\n%f\n 30\n%f\n", p->line[j].point[i].x, p->line[j].point[i].y, 0.0);
+          im_iprintf(&imgStr, "  0\nVERTEX\n 10\n%f\n 20\n%f\n 30\n%f\n",
+                     p->line[j].point[i].x, p->line[j].point[i].y, 0.0);
         } else {
-          im_iprintf (&imgStr, "%s %.0f,%.0f", first ? "": ",", p->line[j].point[i].x, p->line[j].point[i].y);
+          im_iprintf(&imgStr, "%s %.0f,%.0f", first ? "" : ",",
+                     p->line[j].point[i].x, p->line[j].point[i].y);
         }
         first = 0;
 
         /* point2 = &( p->line[j].point[i] ); */
         /* if(point1->y == point2->y) {} */
       }
-      im_iprintf (&imgStr, dxf ? (dxf == 2 ? "": "  0\nSEQEND\n") : "\" />\n");
+      im_iprintf(&imgStr, dxf ? (dxf == 2 ? "" : "  0\nSEQEND\n") : "\" />\n");
     }
 
     return;
   }
   /* DEBUG_IF printf ("d"); */
-  DEBUG_IF printf("-%d-",symbol->type);
+  DEBUG_IF printf("-%d-", symbol->type);
   return;
 }
 
 /*
  * Simply draws a label based on the label point and the supplied label object.
  */
-int msDrawTextIM(mapObj *map, imageObj* img, pointObj labelPnt, char *string, labelObj *label, double scalefactor)
-{
+int msDrawTextIM(mapObj *map, imageObj *img, pointObj labelPnt, char *string,
+                 labelObj *label, double scalefactor) {
   (void)map;
   (void)img;
   DEBUG_IF printf("msDrawText<BR>\n");
-  if(!string) return(0); /* not errors, just don't want to do anything */
-  if(strlen(string) == 0) return(0);
-  if(!dxf) return (0);
+  if (!string)
+    return (0); /* not errors, just don't want to do anything */
+  if (strlen(string) == 0)
+    return (0);
+  if (!dxf)
+    return (0);
 
   if (dxf == 2) {
-    im_iprintf (&imgStr, "TEXT\n%d\n%s\n%.0f\n%.0f\n%.0f\n" , matchdxfcolor(label->color), string, labelPnt.x, labelPnt.y, -label->angle);
+    im_iprintf(&imgStr, "TEXT\n%d\n%s\n%.0f\n%.0f\n%.0f\n",
+               matchdxfcolor(label->color), string, labelPnt.x, labelPnt.y,
+               -label->angle);
   } else {
-    im_iprintf (&imgStr, "  0\nTEXT\n  1\n%s\n 10\n%f\n 20\n%f\n 30\n0.0\n 40\n%f\n 50\n%f\n 62\n%6d\n  8\n%s\n 73\n   2\n 72\n   1\n" , string, labelPnt.x, labelPnt.y, label->size * scalefactor *100, -label->angle, matchdxfcolor(label->color), lname);
+    im_iprintf(&imgStr,
+               "  0\nTEXT\n  1\n%s\n 10\n%f\n 20\n%f\n 30\n0.0\n 40\n%f\n "
+               "50\n%f\n 62\n%6d\n  8\n%s\n 73\n   2\n 72\n   1\n",
+               string, labelPnt.x, labelPnt.y, label->size * scalefactor * 100,
+               -label->angle, matchdxfcolor(label->color), lname);
   }
-  return(0);
+  return (0);
 }
 
 /*
  * Save an image to a file named filename, if filename is NULL it goes to stdout
  */
 
-int msSaveImageIM(imageObj* img, const char *filename, outputFormatObj *format )
+int msSaveImageIM(imageObj *img, const char *filename, outputFormatObj *format)
 
 {
   FILE *stream_to_free = NULL;
@@ -638,11 +660,11 @@ int msSaveImageIM(imageObj* img, const c
 
   DEBUG_IF printf("msSaveImageIM\n<BR>");
 
-  if(filename != NULL && strlen(filename) > 0) {
+  if (filename != NULL && strlen(filename) > 0) {
     stream_to_free = fopen(filename, "wb");
-    if(!stream_to_free) {
+    if (!stream_to_free) {
       msSetError(MS_IOERR, "(%s)", "msSaveImage()", filename);
-      return(MS_FAILURE);
+      return (MS_FAILURE);
     }
     stream = stream_to_free;
   } else { /* use stdout */
@@ -651,24 +673,31 @@ int msSaveImageIM(imageObj* img, const c
     /*
      * Change stdout mode to binary on win32 platforms
      */
-    if(_setmode( _fileno(stdout), _O_BINARY) == -1) {
-      msSetError(MS_IOERR, "Unable to change stdout to binary mode.", "msSaveImage()");
-      return(MS_FAILURE);
+    if (_setmode(_fileno(stdout), _O_BINARY) == -1) {
+      msSetError(MS_IOERR, "Unable to change stdout to binary mode.",
+                 "msSaveImage()");
+      return (MS_FAILURE);
     }
 #endif
     stream = stdout;
   }
 
-  if( strcasecmp(format->driver,"imagemap") == 0 ) {
+  if (strcasecmp(format->driver, "imagemap") == 0) {
     DEBUG_IF printf("ALLOCD %d<BR>\n", img->size);
     /* DEBUG_IF printf("F %s<BR>\n", img->img.imagemap); */
     DEBUG_IF printf("FLEN %d<BR>\n", (int)strlen(img->img.imagemap));
     if (dxf == 2) {
       msIO_fprintf(stream, "%s", layerlist);
     } else if (dxf) {
-      msIO_fprintf(stream, "  0\nSECTION\n  2\nHEADER\n  9\n$ACADVER\n  1\nAC1009\n0\nENDSEC\n  0\nSECTION\n  2\nTABLES\n  0\nTABLE\n%s0\nENDTAB\n0\nENDSEC\n  0\nSECTION\n  2\nBLOCKS\n0\nENDSEC\n  0\nSECTION\n  2\nENTITIES\n", layerlist);
+      msIO_fprintf(
+          stream,
+          "  0\nSECTION\n  2\nHEADER\n  9\n$ACADVER\n  1\nAC1009\n0\nENDSEC\n  "
+          "0\nSECTION\n  2\nTABLES\n  0\nTABLE\n%s0\nENDTAB\n0\nENDSEC\n  "
+          "0\nSECTION\n  2\nBLOCKS\n0\nENDSEC\n  0\nSECTION\n  2\nENTITIES\n",
+          layerlist);
     } else {
-      msIO_fprintf(stream, "<map name=\"%s\" width=\"%d\" height=\"%d\">\n", mapName, img->width, img->height);
+      msIO_fprintf(stream, "<map name=\"%s\" width=\"%d\" height=\"%d\">\n",
+                   mapName, img->width, img->height);
     }
     const int nSize = sizeof(workbuffer);
 
@@ -676,18 +705,20 @@ int msSaveImageIM(imageObj* img, const c
     if (size > nSize) {
       int iIndice = 0;
       while ((iIndice + nSize) <= size) {
-        snprintf(workbuffer, sizeof(workbuffer), "%s", img->img.imagemap+iIndice );
-        workbuffer[nSize-1] = '\0';
+        snprintf(workbuffer, sizeof(workbuffer), "%s",
+                 img->img.imagemap + iIndice);
+        workbuffer[nSize - 1] = '\0';
         msIO_fwrite(workbuffer, strlen(workbuffer), 1, stream);
-        iIndice +=nSize-1;
+        iIndice += nSize - 1;
       }
       if (iIndice < size) {
-        sprintf(workbuffer, "%s", img->img.imagemap+iIndice );
+        sprintf(workbuffer, "%s", img->img.imagemap + iIndice);
         msIO_fprintf(stream, "%s", workbuffer);
       }
     } else
       msIO_fwrite(img->img.imagemap, size, 1, stream);
-    if( strcasecmp("OFF",msGetOutputFormatOption( format, "SKIPENDTAG", "OFF" )) == 0) {
+    if (strcasecmp("OFF",
+                   msGetOutputFormatOption(format, "SKIPENDTAG", "OFF")) == 0) {
       if (dxf == 2)
         msIO_fprintf(stream, "END");
       else if (dxf)
@@ -697,21 +728,18 @@ int msSaveImageIM(imageObj* img, const c
     }
   } else {
     msSetError(MS_MISCERR, "Unknown output image type driver: %s.",
-               "msSaveImage()", format->driver );
-    if(stream_to_free != NULL) fclose(stream_to_free);
-    return(MS_FAILURE);
+               "msSaveImage()", format->driver);
+    if (stream_to_free != NULL)
+      fclose(stream_to_free);
+    return (MS_FAILURE);
   }
 
-  if(stream_to_free != NULL) fclose(stream_to_free);
-  return(MS_SUCCESS);
+  if (stream_to_free != NULL)
+    fclose(stream_to_free);
+  return (MS_SUCCESS);
 }
 
-
 /*
  * Free gdImagePtr
  */
-void msFreeImageIM(imageObj* img)
-{
-  free(img->img.imagemap);
-}
-
+void msFreeImageIM(imageObj *img) { free(img->img.imagemap); }
diff -pruN 8.0.1-5/mapio.c 8.0.2-1/mapio.c
--- 8.0.1-5/mapio.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapio.c	2024-06-11 20:41:34.000000000 +0000
@@ -38,13 +38,10 @@
 #endif
 
 #ifdef MOD_WMS_ENABLED
-#  include "httpd.h"
-#  include "apr_strings.h"
+#include "httpd.h"
+#include "apr_strings.h"
 #endif
 
-
-
-
 static int is_msIO_initialized = MS_FALSE;
 static int is_msIO_header_enabled = MS_TRUE;
 
@@ -53,20 +50,20 @@ typedef struct msIOContextGroup_t {
   msIOContext stdout_context;
   msIOContext stderr_context;
 
-  void*    thread_id;
+  void *thread_id;
   struct msIOContextGroup_t *next;
 } msIOContextGroup;
 
 static msIOContextGroup default_contexts;
 static msIOContextGroup *io_context_list = NULL;
-static void msIO_Initialize( void );
+static void msIO_Initialize(void);
 
 #ifdef msIO_printf
-#  undef msIO_printf
-#  undef msIO_fprintf
-#  undef msIO_fwrite
-#  undef msIO_fread
-#  undef msIO_vfprintf
+#undef msIO_printf
+#undef msIO_fprintf
+#undef msIO_fwrite
+#undef msIO_fread
+#undef msIO_vfprintf
 #endif
 
 /************************************************************************/
@@ -76,14 +73,14 @@ static void msIO_Initialize( void );
 void msIO_Cleanup()
 
 {
-  if( is_msIO_initialized )
+  if (is_msIO_initialized)
 
   {
     is_msIO_initialized = MS_FALSE;
-    while( io_context_list != NULL ) {
+    while (io_context_list != NULL) {
       msIOContextGroup *last = io_context_list;
       io_context_list = io_context_list->next;
-      free( last );
+      free(last);
     }
   }
 }
@@ -95,20 +92,20 @@ void msIO_Cleanup()
 static msIOContextGroup *msIO_GetContextGroup()
 
 {
-  void* nThreadId = msGetThreadId();
+  void *nThreadId = msGetThreadId();
   msIOContextGroup *prev = NULL, *group = io_context_list;
 
-  if( group != NULL && group->thread_id == nThreadId )
+  if (group != NULL && group->thread_id == nThreadId)
     return group;
 
   /* -------------------------------------------------------------------- */
   /*      Search for group for this thread                                */
   /* -------------------------------------------------------------------- */
-  msAcquireLock( TLOCK_IOCONTEXT );
+  msAcquireLock(TLOCK_IOCONTEXT);
   msIO_Initialize();
 
   group = io_context_list;
-  while( group != NULL && group->thread_id != nThreadId ) {
+  while (group != NULL && group->thread_id != nThreadId) {
     prev = group;
     group = group->next;
   }
@@ -117,21 +114,21 @@ static msIOContextGroup *msIO_GetContext
   /*      If we found it, make sure it is pushed to the front of the      */
   /*      link for faster finding next time, and return it.               */
   /* -------------------------------------------------------------------- */
-  if( group != NULL ) {
-    if( prev != NULL ) {
+  if (group != NULL) {
+    if (prev != NULL) {
       prev->next = group->next;
       group->next = io_context_list;
       io_context_list = group;
     }
 
-    msReleaseLock( TLOCK_IOCONTEXT );
+    msReleaseLock(TLOCK_IOCONTEXT);
     return group;
   }
 
   /* -------------------------------------------------------------------- */
   /*      Create a new context group for this thread.                     */
   /* -------------------------------------------------------------------- */
-  group = (msIOContextGroup *) calloc(sizeof(msIOContextGroup),1);
+  group = (msIOContextGroup *)calloc(sizeof(msIOContextGroup), 1);
 
   group->stdin_context = default_contexts.stdin_context;
   group->stdout_context = default_contexts.stdout_context;
@@ -141,7 +138,7 @@ static msIOContextGroup *msIO_GetContext
   group->next = io_context_list;
   io_context_list = group;
 
-  msReleaseLock( TLOCK_IOCONTEXT );
+  msReleaseLock(TLOCK_IOCONTEXT);
 
   return group;
 }
@@ -149,16 +146,16 @@ static msIOContextGroup *msIO_GetContext
 /* returns MS_TRUE if the msIO standard output hasn't been redirected */
 int msIO_isStdContext() {
   msIOContextGroup *group = io_context_list;
-  void* nThreadId = msGetThreadId();
-  if(!group || group->thread_id != nThreadId) {
+  void *nThreadId = msGetThreadId();
+  if (!group || group->thread_id != nThreadId) {
     group = msIO_GetContextGroup();
-    if(!group) {
+    if (!group) {
       return MS_FALSE; /* probably a bug */
     }
   }
-  if(group->stderr_context.cbData == (void*)stderr &&
-      group->stdin_context.cbData == (void*)stdin &&
-      group->stdout_context.cbData == (void*)stdout)
+  if (group->stderr_context.cbData == (void *)stderr &&
+      group->stdin_context.cbData == (void *)stdin &&
+      group->stdout_context.cbData == (void *)stdout)
     return MS_TRUE;
   return MS_FALSE;
 }
@@ -167,25 +164,25 @@ int msIO_isStdContext() {
 /*                          msIO_getHandler()                           */
 /************************************************************************/
 
-msIOContext *msIO_getHandler( FILE * fp )
+msIOContext *msIO_getHandler(FILE *fp)
 
 {
-  void* nThreadId = msGetThreadId();
+  void *nThreadId = msGetThreadId();
   msIOContextGroup *group = io_context_list;
 
   msIO_Initialize();
 
-  if( group == NULL || group->thread_id != nThreadId ) {
+  if (group == NULL || group->thread_id != nThreadId) {
     group = msIO_GetContextGroup();
-    if( group == NULL )
+    if (group == NULL)
       return NULL;
   }
 
-  if( fp == stdin || fp == NULL || strcmp((const char *)fp,"stdin") == 0 )
+  if (fp == stdin || fp == NULL || strcmp((const char *)fp, "stdin") == 0)
     return &(group->stdin_context);
-  else if( fp == stdout || strcmp((const char *)fp,"stdout") == 0 )
+  else if (fp == stdout || strcmp((const char *)fp, "stdout") == 0)
     return &(group->stdout_context);
-  else if( fp == stderr || strcmp((const char *)fp,"stderr") == 0 )
+  else if (fp == stderr || strcmp((const char *)fp, "stderr") == 0)
     return &(group->stderr_context);
   else
     return NULL;
@@ -195,68 +192,60 @@ msIOContext *msIO_getHandler( FILE * fp
 /*                      msIO_setHeaderEnabled()                         */
 /************************************************************************/
 
-void msIO_setHeaderEnabled(int bFlag)
-{
-    is_msIO_header_enabled = bFlag;
-}
+void msIO_setHeaderEnabled(int bFlag) { is_msIO_header_enabled = bFlag; }
 
 /************************************************************************/
 /*                           msIO_setHeader()                           */
 /************************************************************************/
 
-void msIO_setHeader (const char *header, const char* value, ...)
-{
+void msIO_setHeader(const char *header, const char *value, ...) {
   va_list args;
-  va_start( args, value );
+  va_start(args, value);
 #ifdef MOD_WMS_ENABLED
-  msIOContext *ioctx = msIO_getHandler (stdout);
-  if(ioctx && !strcmp(ioctx->label,"apache")) {
+  msIOContext *ioctx = msIO_getHandler(stdout);
+  if (ioctx && !strcmp(ioctx->label, "apache")) {
 
-    request_rec *r = (request_rec*) (ioctx->cbData);
-    char *fullvalue = apr_pvsprintf(r->pool, value,args);
-    if (strcasecmp (header, "Content-Type") == 0) {
+    request_rec *r = (request_rec *)(ioctx->cbData);
+    char *fullvalue = apr_pvsprintf(r->pool, value, args);
+    if (strcasecmp(header, "Content-Type") == 0) {
       r->content_type = fullvalue;
-    } else if (strcasecmp (header, "Status") == 0) {
-      r->status = atoi (fullvalue);
+    } else if (strcasecmp(header, "Status") == 0) {
+      r->status = atoi(fullvalue);
     } else {
-      apr_table_setn (r->headers_out,
-                      apr_pstrdup (r->pool, header),
-                      fullvalue
-                     );
+      apr_table_setn(r->headers_out, apr_pstrdup(r->pool, header), fullvalue);
     }
   } else {
 #endif // MOD_WMS_ENABLED
-   if( is_msIO_header_enabled ) {
-      msIO_fprintf(stdout,"%s: ",header);
-      msIO_vfprintf(stdout,value,args);
-      msIO_fprintf(stdout,"\r\n");
-   }
+    if (is_msIO_header_enabled) {
+      msIO_fprintf(stdout, "%s: ", header);
+      msIO_vfprintf(stdout, value, args);
+      msIO_fprintf(stdout, "\r\n");
+    }
 #ifdef MOD_WMS_ENABLED
   }
 #endif
-  va_end( args );
+  va_end(args);
 }
 
-void msIO_sendHeaders ()
-{
+void msIO_sendHeaders() {
 #ifdef MOD_WMS_ENABLED
-  msIOContext *ioctx = msIO_getHandler (stdout);
-  if(ioctx && !strcmp(ioctx->label,"apache")) return;
+  msIOContext *ioctx = msIO_getHandler(stdout);
+  if (ioctx && !strcmp(ioctx->label, "apache"))
+    return;
 #endif // !MOD_WMS_ENABLED
-  if( is_msIO_header_enabled ) {
-    msIO_printf ("\r\n");
-    fflush (stdout);
+  if (is_msIO_header_enabled) {
+    msIO_printf("\r\n");
+    fflush(stdout);
   }
 }
 
-
 /************************************************************************/
 /*                        msIO_installHandlers()                        */
 /************************************************************************/
 
-int msIO_installHandlers( msIOContext *stdin_context,
-                          msIOContext *stdout_context,
-                          msIOContext *stderr_context )
+int msIO_installHandlers(msIOContext *stdin_context,
+                         msIOContext *stdout_context,
+                         msIOContext *stderr_context)
 
 {
   msIOContextGroup *group;
@@ -265,19 +254,19 @@ int msIO_installHandlers( msIOContext *s
 
   group = msIO_GetContextGroup();
 
-  if( stdin_context == NULL )
+  if (stdin_context == NULL)
     group->stdin_context = default_contexts.stdin_context;
-  else if( stdin_context != &group->stdin_context )
+  else if (stdin_context != &group->stdin_context)
     group->stdin_context = *stdin_context;
 
-  if( stdout_context == NULL )
+  if (stdout_context == NULL)
     group->stdout_context = default_contexts.stdout_context;
-  else if( stdout_context != &group->stdout_context )
+  else if (stdout_context != &group->stdout_context)
     group->stdout_context = *stdout_context;
 
-  if( stderr_context == NULL )
+  if (stderr_context == NULL)
     group->stderr_context = default_contexts.stderr_context;
-  else if( stderr_context != &group->stderr_context )
+  else if (stderr_context != &group->stderr_context)
     group->stderr_context = *stderr_context;
 
   return MS_TRUE;
@@ -287,27 +276,26 @@ int msIO_installHandlers( msIOContext *s
 /*                          msIO_contextRead()                          */
 /************************************************************************/
 
-int msIO_contextRead( msIOContext *context, void *data, int byteCount )
+int msIO_contextRead(msIOContext *context, void *data, int byteCount)
 
 {
-  if( context->write_channel == MS_TRUE )
+  if (context->write_channel == MS_TRUE)
     return 0;
   else
-    return context->readWriteFunc( context->cbData, data, byteCount );
+    return context->readWriteFunc(context->cbData, data, byteCount);
 }
 
 /************************************************************************/
 /*                         msIO_contextWrite()                          */
 /************************************************************************/
 
-int msIO_contextWrite( msIOContext *context, const void *data, int byteCount )
+int msIO_contextWrite(msIOContext *context, const void *data, int byteCount)
 
 {
-  if( context->write_channel == MS_FALSE )
+  if (context->write_channel == MS_FALSE)
     return 0;
   else
-    return context->readWriteFunc( context->cbData, (void *) data,
-                                   byteCount );
+    return context->readWriteFunc(context->cbData, (void *)data, byteCount);
 }
 
 /* ==================================================================== */
@@ -320,15 +308,15 @@ int msIO_contextWrite( msIOContext *cont
 /*                            _ms_vsprintf()                            */
 /************************************************************************/
 
-static int _ms_vsprintf(char **workBufPtr, const char *format, va_list ap )
+static int _ms_vsprintf(char **workBufPtr, const char *format, va_list ap)
 
 {
-  int     ret_val;
-  int   workBufSize = 16000;
+  int ret_val;
+  int workBufSize = 16000;
 
-  *workBufPtr = (char*)malloc(workBufSize * sizeof(char));
+  *workBufPtr = (char *)malloc(workBufSize * sizeof(char));
   if (*workBufPtr == NULL) {
-    msSetError( MS_MEMERR, NULL, "_ms_vsprintf()");
+    msSetError(MS_MEMERR, NULL, "_ms_vsprintf()");
     return -1;
   }
 
@@ -338,35 +326,35 @@ static int _ms_vsprintf(char **workBufPt
     va_list wrk_args;
 
 #ifdef va_copy
-    va_copy( wrk_args, ap );
+    va_copy(wrk_args, ap);
 #else
     wrk_args = ap;
 #endif
 
-    while( (ret_val = vsnprintf( *workBufPtr, workBufSize,
-                                 format, wrk_args)) >= workBufSize-1
-           || ret_val == -1 ) {
+    while ((ret_val = vsnprintf(*workBufPtr, workBufSize, format, wrk_args)) >=
+               workBufSize - 1 ||
+           ret_val == -1) {
       workBufSize *= 4;
-      *workBufPtr = (char *) realloc(*workBufPtr, workBufSize );
+      *workBufPtr = (char *)realloc(*workBufPtr, workBufSize);
       if (*workBufPtr == NULL) {
-        msSetError( MS_MEMERR, NULL, "_ms_vsprintf()");
-        va_end( wrk_args );
+        msSetError(MS_MEMERR, NULL, "_ms_vsprintf()");
+        va_end(wrk_args);
         return -1;
       }
 #ifdef va_copy
-      va_end( wrk_args );
-      va_copy( wrk_args, ap );
+      va_end(wrk_args);
+      va_copy(wrk_args, ap);
 #else
       wrk_args = ap;
 #endif
     }
-    va_end( wrk_args );
+    va_end(wrk_args);
   }
 #else
   /* We do not have vsnprintf()... there is a risk of buffer overrun */
-  ret_val = vsprintf( *workBufPtr, format, ap );
+  ret_val = vsprintf(*workBufPtr, format, ap);
 
-  if( ret_val < 0 || ret_val >= workBufSize ) {
+  if (ret_val < 0 || ret_val >= workBufSize) {
     msSetError(MS_MISCERR, "Possible buffer overrun.", "_ms_vsprintf()");
     msFree(*workBufPtr);
     *workBufPtr = NULL;
@@ -377,18 +365,17 @@ static int _ms_vsprintf(char **workBufPt
   return ret_val;
 }
 
-
 /************************************************************************/
 /*                            msIO_printf()                             */
 /************************************************************************/
 
-int msIO_printf( const char *format, ... )
+int msIO_printf(const char *format, ...)
 
 {
   va_list args;
   int ret;
-  va_start( args, format );
-  ret = msIO_vfprintf(stdout,format,args);
+  va_start(args, format);
+  ret = msIO_vfprintf(stdout, format, args);
   va_end(args);
   return ret;
 }
@@ -397,13 +384,13 @@ int msIO_printf( const char *format, ...
 /*                            msIO_fprintf()                            */
 /************************************************************************/
 
-int msIO_fprintf( FILE *fp, const char *format, ... )
+int msIO_fprintf(FILE *fp, const char *format, ...)
 
 {
   va_list args;
   int ret;
-  va_start( args, format );
-  ret = msIO_vfprintf(fp,format,args);
+  va_start(args, format);
+  ret = msIO_vfprintf(fp, format, args);
   va_end(args);
   return ret;
 }
@@ -412,53 +399,51 @@ int msIO_fprintf( FILE *fp, const char *
 /*                            msIO_vfprintf()                           */
 /************************************************************************/
 
-int msIO_vfprintf( FILE *fp, const char *format, va_list ap )
+int msIO_vfprintf(FILE *fp, const char *format, va_list ap)
 
 {
-  int     return_val;
+  int return_val;
   msIOContext *context;
   char workBuf[8000];
 
 #if !defined(HAVE_VSNPRINTF)
-  return_val = vsprintf( workBuf, format, ap);
+  return_val = vsprintf(workBuf, format, ap);
 
-  if( return_val < 0 || return_val >= sizeof(workBuf) ) {
+  if (return_val < 0 || return_val >= sizeof(workBuf)) {
     msSetError(MS_MISCERR, "Possible buffer overrun.", "msIO_vfprintf()");
     return -1;
   }
 
-  char* outbuf = workBuf;
+  char *outbuf = workBuf;
 
 #else
 
   va_list args_copy;
 #ifdef va_copy
-  va_copy( args_copy, ap );
+  va_copy(args_copy, ap);
 #else
   args_copy = ap;
 #endif /* va_copy */
 
-  char* largerBuf = NULL;
-  return_val = vsnprintf( workBuf, sizeof(workBuf), format, ap );
-  if (return_val == -1 || return_val >= (int)sizeof(workBuf)-1) {
-    return_val = _ms_vsprintf(&largerBuf, format, args_copy );
+  char *largerBuf = NULL;
+  return_val = vsnprintf(workBuf, sizeof(workBuf), format, ap);
+  if (return_val == -1 || return_val >= (int)sizeof(workBuf) - 1) {
+    return_val = _ms_vsprintf(&largerBuf, format, args_copy);
   }
   va_end(args_copy);
 
   if (return_val < 0)
     return -1;
 
-  char* outbuf = largerBuf?largerBuf:workBuf;
+  char *outbuf = largerBuf ? largerBuf : workBuf;
 
 #endif /* HAVE_VSNPRINTF */
 
-  context = msIO_getHandler( fp );
-  if( context == NULL )
-    return_val = fwrite(outbuf , 1, return_val, fp );
+  context = msIO_getHandler(fp);
+  if (context == NULL)
+    return_val = fwrite(outbuf, 1, return_val, fp);
   else
-    return_val =  msIO_contextWrite( context,
-                                     outbuf,
-                                     return_val );
+    return_val = msIO_contextWrite(context, outbuf, return_val);
 
 #if defined(HAVE_VSNPRINTF)
   msFree(largerBuf);
@@ -471,38 +456,38 @@ int msIO_vfprintf( FILE *fp, const char
 /*                            msIO_fwrite()                             */
 /************************************************************************/
 
-int msIO_fwrite( const void *data, size_t size, size_t nmemb, FILE *fp )
+int msIO_fwrite(const void *data, size_t size, size_t nmemb, FILE *fp)
 
 {
   msIOContext *context;
 
-  if( size == 0 || nmemb == 0 )
+  if (size == 0 || nmemb == 0)
     return 0;
 
-  context = msIO_getHandler( fp );
-  if( context == NULL )
-    return fwrite( data, size, nmemb, fp );
+  context = msIO_getHandler(fp);
+  if (context == NULL)
+    return fwrite(data, size, nmemb, fp);
   else
-    return msIO_contextWrite( context, data, size * nmemb ) / size;
+    return msIO_contextWrite(context, data, size * nmemb) / size;
 }
 
 /************************************************************************/
 /*                            msIO_fread()                              */
 /************************************************************************/
 
-int msIO_fread( void *data, size_t size, size_t nmemb, FILE *fp )
+int msIO_fread(void *data, size_t size, size_t nmemb, FILE *fp)
 
 {
   msIOContext *context;
 
-  if( size == 0 || nmemb == 0 )
+  if (size == 0 || nmemb == 0)
     return 0;
 
-  context = msIO_getHandler( fp );
-  if( context == NULL )
-    return fread( data, size, nmemb, fp );
+  context = msIO_getHandler(fp);
+  if (context == NULL)
+    return fread(data, size, nmemb, fp);
   else
-    return msIO_contextRead( context, data, size * nmemb ) / size;
+    return msIO_contextRead(context, data, size * nmemb) / size;
 }
 
 /* ==================================================================== */
@@ -518,10 +503,10 @@ int msIO_fread( void *data, size_t size,
 /*      This is the default implementation via stdio.                   */
 /************************************************************************/
 
-static int msIO_stdioRead( void *cbData, void *data, int byteCount )
+static int msIO_stdioRead(void *cbData, void *data, int byteCount)
 
 {
-  return fread( data, 1, byteCount, (FILE *) cbData );
+  return fread(data, 1, byteCount, (FILE *)cbData);
 }
 
 /************************************************************************/
@@ -530,36 +515,36 @@ static int msIO_stdioRead( void *cbData,
 /*      This is the default implementation via stdio.                   */
 /************************************************************************/
 
-static int msIO_stdioWrite( void *cbData, void *data, int byteCount )
+static int msIO_stdioWrite(void *cbData, void *data, int byteCount)
 
 {
-  return fwrite( data, 1, byteCount, (FILE *) cbData );
+  return fwrite(data, 1, byteCount, (FILE *)cbData);
 }
 
 /************************************************************************/
 /*                          msIO_Initialize()                           */
 /************************************************************************/
 
-static void msIO_Initialize( void )
+static void msIO_Initialize(void)
 
 {
-  if( is_msIO_initialized == MS_TRUE )
+  if (is_msIO_initialized == MS_TRUE)
     return;
 
   default_contexts.stdin_context.label = "stdio";
   default_contexts.stdin_context.write_channel = MS_FALSE;
   default_contexts.stdin_context.readWriteFunc = msIO_stdioRead;
-  default_contexts.stdin_context.cbData = (void *) stdin;
+  default_contexts.stdin_context.cbData = (void *)stdin;
 
   default_contexts.stdout_context.label = "stdio";
   default_contexts.stdout_context.write_channel = MS_TRUE;
   default_contexts.stdout_context.readWriteFunc = msIO_stdioWrite;
-  default_contexts.stdout_context.cbData = (void *) stdout;
+  default_contexts.stdout_context.cbData = (void *)stdout;
 
   default_contexts.stderr_context.label = "stdio";
   default_contexts.stderr_context.write_channel = MS_TRUE;
   default_contexts.stderr_context.readWriteFunc = msIO_stdioWrite;
-  default_contexts.stderr_context.cbData = (void *) stderr;
+  default_contexts.stderr_context.cbData = (void *)stderr;
 
   default_contexts.next = NULL;
   default_contexts.thread_id = 0;
@@ -567,15 +552,12 @@ static void msIO_Initialize( void )
   is_msIO_initialized = MS_TRUE;
 }
 
-
 /* ==================================================================== */
 /* ==================================================================== */
 /*      FastCGI output redirection functions.                           */
 /* ==================================================================== */
 /* ==================================================================== */
 
-
-
 /************************************************************************/
 /*                       msIO_needBinaryStdout()                        */
 /*                                                                      */
@@ -592,11 +574,10 @@ int msIO_needBinaryStdout()
 
 {
 #if defined(_WIN32) && !defined(USE_FASTCGI)
-  if(_setmode( _fileno(stdout), _O_BINARY) == -1) {
-    msSetError(MS_IOERR,
-               "Unable to change stdout to binary mode.",
-               "msIO_needBinaryStdout()" );
-    return(MS_FAILURE);
+  if (_setmode(_fileno(stdout), _O_BINARY) == -1) {
+    msSetError(MS_IOERR, "Unable to change stdout to binary mode.",
+               "msIO_needBinaryStdout()");
+    return (MS_FAILURE);
   }
 #endif
 
@@ -619,11 +600,10 @@ int msIO_needBinaryStdin()
 
 {
 #if defined(_WIN32) && !defined(USE_FASTCGI)
-  if(_setmode( _fileno(stdin), _O_BINARY) == -1) {
-    msSetError(MS_IOERR,
-               "Unable to change stdin to binary mode.",
-               "msIO_needBinaryStdin()" );
-    return(MS_FAILURE);
+  if (_setmode(_fileno(stdin), _O_BINARY) == -1) {
+    msSetError(MS_IOERR, "Unable to change stdin to binary mode.",
+               "msIO_needBinaryStdin()");
+    return (MS_FAILURE);
   }
 #endif
 
@@ -643,34 +623,34 @@ void msIO_resetHandlers()
 {
   msIOContextGroup *group = msIO_GetContextGroup();
 
-  if( group == NULL )
+  if (group == NULL)
     return;
 
-  if( strcmp(group->stdin_context.label,"buffer") == 0 ) {
-    msIOBuffer *buf = (msIOBuffer *) group->stdin_context.cbData;
+  if (strcmp(group->stdin_context.label, "buffer") == 0) {
+    msIOBuffer *buf = (msIOBuffer *)group->stdin_context.cbData;
 
-    if( buf->data != NULL )
-      free( buf->data );
-    free( buf );
+    if (buf->data != NULL)
+      free(buf->data);
+    free(buf);
   }
 
-  if( strcmp(group->stdout_context.label,"buffer") == 0 ) {
-    msIOBuffer *buf = (msIOBuffer *) group->stdout_context.cbData;
+  if (strcmp(group->stdout_context.label, "buffer") == 0) {
+    msIOBuffer *buf = (msIOBuffer *)group->stdout_context.cbData;
 
-    if( buf->data != NULL )
-      free( buf->data );
-    free( buf );
+    if (buf->data != NULL)
+      free(buf->data);
+    free(buf);
   }
 
-  if( strcmp(group->stderr_context.label,"buffer") == 0 ) {
-    msIOBuffer *buf = (msIOBuffer *) group->stderr_context.cbData;
+  if (strcmp(group->stderr_context.label, "buffer") == 0) {
+    msIOBuffer *buf = (msIOBuffer *)group->stderr_context.cbData;
 
-    if( buf->data != NULL )
-      free( buf->data );
-    free( buf );
+    if (buf->data != NULL)
+      free(buf->data);
+    free(buf);
   }
 
-  msIO_installHandlers( NULL, NULL, NULL );
+  msIO_installHandlers(NULL, NULL, NULL);
 }
 
 /************************************************************************/
@@ -681,19 +661,16 @@ void msIO_installStdoutToBuffer()
 
 {
   msIOContextGroup *group = msIO_GetContextGroup();
-  msIOContext  context;
+  msIOContext context;
 
   context.label = "buffer";
   context.write_channel = MS_TRUE;
   context.readWriteFunc = msIO_bufferWrite;
-  context.cbData = calloc(sizeof(msIOBuffer),1);
+  context.cbData = calloc(sizeof(msIOBuffer), 1);
 
-  msIO_installHandlers( &group->stdin_context,
-                        &context,
-                        &group->stderr_context );
+  msIO_installHandlers(&group->stdin_context, &context, &group->stderr_context);
 }
 
-
 /************************************************************************/
 /*               msIO_pushStdoutToBufferAndGetOldContext()              */
 /*                                                                      */
@@ -704,14 +681,14 @@ void msIO_installStdoutToBuffer()
 /* libxml objects XML generated by msIO_fprintf()                       */
 /************************************************************************/
 
-msIOContext* msIO_pushStdoutToBufferAndGetOldContext()
+msIOContext *msIO_pushStdoutToBufferAndGetOldContext()
 
 {
   msIOContextGroup *group = msIO_GetContextGroup();
   msIOContext *old_context;
 
   /* Backup current context */
-  old_context = (msIOContext*) msSmallMalloc(sizeof(msIOContext));
+  old_context = (msIOContext *)msSmallMalloc(sizeof(msIOContext));
   memcpy(old_context, &group->stdout_context, sizeof(msIOContext));
 
   msIO_installStdoutToBuffer();
@@ -723,23 +700,21 @@ msIOContext* msIO_pushStdoutToBufferAndG
 /*                    msIO_restoreOldStdoutContext()                    */
 /************************************************************************/
 
-void msIO_restoreOldStdoutContext(msIOContext *context_to_restore)
-{
+void msIO_restoreOldStdoutContext(msIOContext *context_to_restore) {
   msIOContextGroup *group = msIO_GetContextGroup();
   msIOContext *prev_context = &group->stdout_context;
-  msIOBuffer* buffer;
-  
+  msIOBuffer *buffer;
+
   /* Free memory associated to our temporary context */
-  assert( strcmp(prev_context->label, "buffer") == 0 );
+  assert(strcmp(prev_context->label, "buffer") == 0);
 
-  buffer = (msIOBuffer* )prev_context->cbData;
+  buffer = (msIOBuffer *)prev_context->cbData;
   msFree(buffer->data);
   msFree(buffer);
 
   /* Restore old context */
-  msIO_installHandlers( &group->stdin_context,
-                        context_to_restore,
-                        &group->stderr_context );
+  msIO_installHandlers(&group->stdin_context, context_to_restore,
+                       &group->stderr_context);
 
   msFree(context_to_restore);
 }
@@ -752,16 +727,15 @@ void msIO_installStdinFromBuffer()
 
 {
   msIOContextGroup *group = msIO_GetContextGroup();
-  msIOContext  context;
+  msIOContext context;
 
   context.label = "buffer";
   context.write_channel = MS_FALSE;
   context.readWriteFunc = msIO_bufferRead;
-  context.cbData = calloc(sizeof(msIOBuffer),1);
+  context.cbData = calloc(sizeof(msIOBuffer), 1);
 
-  msIO_installHandlers( &context,
-                        &group->stdout_context,
-                        &group->stderr_context );
+  msIO_installHandlers(&context, &group->stdout_context,
+                       &group->stderr_context);
 }
 
 /************************************************************************/
@@ -769,24 +743,23 @@ void msIO_installStdinFromBuffer()
 /*                                                                      */
 /************************************************************************/
 
-hashTableObj* msIO_getAndStripStdoutBufferMimeHeaders()
-{
+hashTableObj *msIO_getAndStripStdoutBufferMimeHeaders() {
   /* -------------------------------------------------------------------- */
   /*      Find stdout buffer.                                             */
   /* -------------------------------------------------------------------- */
-  msIOContext *ctx = msIO_getHandler( (FILE *) "stdout" );
-  msIOBuffer  *buf;
+  msIOContext *ctx = msIO_getHandler((FILE *)"stdout");
+  msIOBuffer *buf;
   int start_of_mime_header, current_pos;
-  hashTableObj* hashTable;
+  hashTableObj *hashTable;
 
-  if( ctx == NULL || ctx->write_channel == MS_FALSE
-      || strcmp(ctx->label,"buffer") != 0 ) {
-    msSetError( MS_MISCERR, "Can't identify msIO buffer.",
-                "msIO_getAndStripStdoutBufferMimeHeaders" );
+  if (ctx == NULL || ctx->write_channel == MS_FALSE ||
+      strcmp(ctx->label, "buffer") != 0) {
+    msSetError(MS_MISCERR, "Can't identify msIO buffer.",
+               "msIO_getAndStripStdoutBufferMimeHeaders");
     return NULL;
   }
 
-  buf = (msIOBuffer *) ctx->cbData;
+  buf = (msIOBuffer *)ctx->cbData;
 
   hashTable = msCreateHashTable();
 
@@ -794,90 +767,82 @@ hashTableObj* msIO_getAndStripStdoutBuff
   /*      Loop over all headers.                                          */
   /* -------------------------------------------------------------------- */
   current_pos = 0;
-  while( MS_TRUE ) {
+  while (MS_TRUE) {
     int pos_of_column = -1;
-    char* key, *value;
+    char *key, *value;
 
     start_of_mime_header = current_pos;
-    while( current_pos < buf->data_offset )
-    {
-        if( buf->data[current_pos] == '\r' )
-        {
-            if( current_pos + 1 == buf->data_offset ||
-                buf->data[current_pos + 1] != '\n' )
-            {
-                pos_of_column = -1;
-                break;
-            }
-            break;
+    while (current_pos < buf->data_offset) {
+      if (buf->data[current_pos] == '\r') {
+        if (current_pos + 1 == buf->data_offset ||
+            buf->data[current_pos + 1] != '\n') {
+          pos_of_column = -1;
+          break;
         }
-        if( buf->data[current_pos] == ':' )
-        {
-            pos_of_column = current_pos;
-            if( current_pos + 1 == buf->data_offset ||
-                buf->data[current_pos + 1] != ' ' )
-            {
-                pos_of_column = -1;
-                break;
-            }
+        break;
+      }
+      if (buf->data[current_pos] == ':') {
+        pos_of_column = current_pos;
+        if (current_pos + 1 == buf->data_offset ||
+            buf->data[current_pos + 1] != ' ') {
+          pos_of_column = -1;
+          break;
         }
-        current_pos++;
+      }
+      current_pos++;
     }
 
-    if( pos_of_column < 0 || current_pos == buf->data_offset ) {
-      msSetError( MS_MISCERR, "Corrupt mime headers.",
-                  "msIO_getAndStripStdoutBufferMimeHeaders" );
+    if (pos_of_column < 0 || current_pos == buf->data_offset) {
+      msSetError(MS_MISCERR, "Corrupt mime headers.",
+                 "msIO_getAndStripStdoutBufferMimeHeaders");
       msFreeHashTable(hashTable);
       return NULL;
     }
 
-    key = (char*) malloc( pos_of_column - start_of_mime_header + 1 );
-    memcpy( key, buf->data+start_of_mime_header, pos_of_column - start_of_mime_header);
+    key = (char *)malloc(pos_of_column - start_of_mime_header + 1);
+    memcpy(key, buf->data + start_of_mime_header,
+           pos_of_column - start_of_mime_header);
     key[pos_of_column - start_of_mime_header] = '\0';
 
-    value = (char*) malloc( current_pos - (pos_of_column+2) + 1 );
-    memcpy( value, buf->data+pos_of_column+2, current_pos - (pos_of_column+2));
-    value[current_pos - (pos_of_column+2)] = '\0';
+    value = (char *)malloc(current_pos - (pos_of_column + 2) + 1);
+    memcpy(value, buf->data + pos_of_column + 2,
+           current_pos - (pos_of_column + 2));
+    value[current_pos - (pos_of_column + 2)] = '\0';
 
-    msInsertHashTable( hashTable, key, value );
+    msInsertHashTable(hashTable, key, value);
 
-    msFree( key );
-    msFree( value );
+    msFree(key);
+    msFree(value);
 
     /* -------------------------------------------------------------------- */
     /*      Go to next line.                                                */
     /* -------------------------------------------------------------------- */
     current_pos += 2;
-    if( current_pos == buf->data_offset )
-    {
-      msSetError( MS_MISCERR, "Corrupt mime headers.",
-                  "msIO_getAndStripStdoutBufferMimeHeaders" );
+    if (current_pos == buf->data_offset) {
+      msSetError(MS_MISCERR, "Corrupt mime headers.",
+                 "msIO_getAndStripStdoutBufferMimeHeaders");
       msFreeHashTable(hashTable);
       return NULL;
     }
 
     /* If next line is a '\r', this is the end of mime headers. */
-    if( buf->data[current_pos] == '\r' )
-    {
-        current_pos ++;
-        if( current_pos == buf->data_offset ||
-            buf->data[current_pos] != '\n' )
-        {
-            msSetError( MS_MISCERR, "Corrupt mime headers.",
-                        "msIO_getAndStripStdoutBufferMimeHeaders" );
-            msFreeHashTable(hashTable);
-            return NULL;
-        }
-        current_pos ++;
-        break;
+    if (buf->data[current_pos] == '\r') {
+      current_pos++;
+      if (current_pos == buf->data_offset || buf->data[current_pos] != '\n') {
+        msSetError(MS_MISCERR, "Corrupt mime headers.",
+                   "msIO_getAndStripStdoutBufferMimeHeaders");
+        msFreeHashTable(hashTable);
+        return NULL;
+      }
+      current_pos++;
+      break;
     }
   }
 
   /* -------------------------------------------------------------------- */
   /*      Move data to front of buffer, and reset length.                 */
   /* -------------------------------------------------------------------- */
-  memmove( buf->data, buf->data+current_pos,
-           buf->data_offset - current_pos );
+  memmove(buf->data, buf->data + current_pos, buf->data_offset - current_pos);
   buf->data[buf->data_offset - current_pos] = '\0';
   buf->data_offset -= current_pos;
 
@@ -899,38 +864,37 @@ char *msIO_stripStdoutBufferContentType(
   /* -------------------------------------------------------------------- */
   /*      Find stdout buffer.                                             */
   /* -------------------------------------------------------------------- */
-  msIOContext *ctx = msIO_getHandler( (FILE *) "stdout" );
-  msIOBuffer  *buf;
+  msIOContext *ctx = msIO_getHandler((FILE *)"stdout");
+  msIOBuffer *buf;
   char *content_type = NULL;
   int end_of_ct, start_of_data;
 
-  if( ctx == NULL || ctx->write_channel == MS_FALSE
-      || strcmp(ctx->label,"buffer") != 0 ) {
-    msSetError( MS_MISCERR, "Can't identify msIO buffer.",
-                "msIO_stripStdoutBufferContentType" );
+  if (ctx == NULL || ctx->write_channel == MS_FALSE ||
+      strcmp(ctx->label, "buffer") != 0) {
+    msSetError(MS_MISCERR, "Can't identify msIO buffer.",
+               "msIO_stripStdoutBufferContentType");
     return NULL;
   }
 
-  buf = (msIOBuffer *) ctx->cbData;
+  buf = (msIOBuffer *)ctx->cbData;
 
   /* -------------------------------------------------------------------- */
   /*      Return NULL if we don't have a Content-Type header.             */
   /* -------------------------------------------------------------------- */
-  if( buf->data_offset < 14
-      || strncasecmp((const char*) buf->data,"Content-Type: ",14) != 0 )
+  if (buf->data_offset < 14 ||
+      strncasecmp((const char *)buf->data, "Content-Type: ", 14) != 0)
     return NULL;
 
   /* -------------------------------------------------------------------- */
   /*      Find newline marker at end of content type argument.            */
   /* -------------------------------------------------------------------- */
   end_of_ct = 13;
-  while( end_of_ct+1 < buf->data_offset
-         && buf->data[end_of_ct+1] != '\r' )
+  while (end_of_ct + 1 < buf->data_offset && buf->data[end_of_ct + 1] != '\r')
     end_of_ct++;
 
-  if( end_of_ct+1 == buf->data_offset ) {
-    msSetError( MS_MISCERR, "Corrupt Content-Type header.",
-                "msIO_stripStdoutBufferContentType" );
+  if (end_of_ct + 1 == buf->data_offset) {
+    msSetError(MS_MISCERR, "Corrupt Content-Type header.",
+               "msIO_stripStdoutBufferContentType");
     return NULL;
   }
 
@@ -938,14 +902,13 @@ char *msIO_stripStdoutBufferContentType(
   /*      Continue on to the start of data ...                            */
   /*      Go to next line and skip if empty.                              */
   /* -------------------------------------------------------------------- */
-  start_of_data = end_of_ct+3;
-  if( start_of_data  < buf->data_offset
-      && buf->data[start_of_data] == '\r' )
-    start_of_data +=2;
-  
-  if( start_of_data == buf->data_offset ) {
-    msSetError( MS_MISCERR, "Corrupt Content-Type header.",
-                "msIO_stripStdoutBufferContentType" );
+  start_of_data = end_of_ct + 3;
+  if (start_of_data < buf->data_offset && buf->data[start_of_data] == '\r')
+    start_of_data += 2;
+
+  if (start_of_data == buf->data_offset) {
+    msSetError(MS_MISCERR, "Corrupt Content-Type header.",
+               "msIO_stripStdoutBufferContentType");
     return NULL;
   }
 
@@ -955,15 +918,15 @@ char *msIO_stripStdoutBufferContentType(
   /*      buffer may not be NULL terminated - strlcpy() requires NULL     */
   /*      terminated sources (see issue #4672).                           */
   /* -------------------------------------------------------------------- */
-  content_type = (char *) malloc(end_of_ct-14+2);
-  strncpy( content_type, (const char *) buf->data + 14, end_of_ct - 14 + 2);
-  content_type[end_of_ct-14+1] = '\0';
+  content_type = (char *)malloc(end_of_ct - 14 + 2);
+  strncpy(content_type, (const char *)buf->data + 14, end_of_ct - 14 + 2);
+  content_type[end_of_ct - 14 + 1] = '\0';
 
   /* -------------------------------------------------------------------- */
   /*      Move data to front of buffer, and reset length.                 */
   /* -------------------------------------------------------------------- */
-  memmove( buf->data, buf->data+start_of_data,
-           buf->data_offset - start_of_data );
+  memmove(buf->data, buf->data + start_of_data,
+          buf->data_offset - start_of_data);
   buf->data[buf->data_offset - start_of_data] = '\0';
   buf->data_offset -= start_of_data;
 
@@ -976,75 +939,74 @@ char *msIO_stripStdoutBufferContentType(
 /*      Strip off Content-* headers from buffer.                        */
 /************************************************************************/
 
-void msIO_stripStdoutBufferContentHeaders()
-{
+void msIO_stripStdoutBufferContentHeaders() {
   /* -------------------------------------------------------------------- */
   /*      Find stdout buffer.                                             */
   /* -------------------------------------------------------------------- */
-  msIOContext *ctx = msIO_getHandler( (FILE *) "stdout" );
-  msIOBuffer  *buf;
+  msIOContext *ctx = msIO_getHandler((FILE *)"stdout");
+  msIOBuffer *buf;
   int start_of_data;
 
-  if( ctx == NULL || ctx->write_channel == MS_FALSE
-      || strcmp(ctx->label,"buffer") != 0 ) {
-    msSetError( MS_MISCERR, "Can't identify msIO buffer.",
-                "msIO_stripStdoutBufferContentHeaders" );
+  if (ctx == NULL || ctx->write_channel == MS_FALSE ||
+      strcmp(ctx->label, "buffer") != 0) {
+    msSetError(MS_MISCERR, "Can't identify msIO buffer.",
+               "msIO_stripStdoutBufferContentHeaders");
     return;
   }
 
-  buf = (msIOBuffer *) ctx->cbData;
+  buf = (msIOBuffer *)ctx->cbData;
 
   /* -------------------------------------------------------------------- */
   /*      Exit if we don't have any content-* header.                     */
   /* -------------------------------------------------------------------- */
-  if( buf->data_offset < 8
-      || strncasecmp((const char*) buf->data,"Content-",8) != 0 )
+  if (buf->data_offset < 8 ||
+      strncasecmp((const char *)buf->data, "Content-", 8) != 0)
     return;
 
   /* -------------------------------------------------------------------- */
   /*      Loop over all content-* headers.                                */
   /* -------------------------------------------------------------------- */
   start_of_data = 0;
-  while( buf->data_offset > start_of_data
-         && strncasecmp((const char*) buf->data+start_of_data,"Content-",8) == 0 ) {
+  while (buf->data_offset > start_of_data &&
+         strncasecmp((const char *)buf->data + start_of_data, "Content-", 8) ==
+             0) {
     /* -------------------------------------------------------------------- */
     /*      Find newline marker at end of content-* header argument.        */
     /* -------------------------------------------------------------------- */
-    start_of_data +=7;
-    while( start_of_data+1 < buf->data_offset
-           && buf->data[start_of_data+1] != '\r' )
+    start_of_data += 7;
+    while (start_of_data + 1 < buf->data_offset &&
+           buf->data[start_of_data + 1] != '\r')
       start_of_data++;
 
-    if( start_of_data+1 == buf->data_offset ) {
-      msSetError( MS_MISCERR, "Corrupt Content-* header.",
-                  "msIO_stripStdoutBufferContentHeaders" );
+    if (start_of_data + 1 == buf->data_offset) {
+      msSetError(MS_MISCERR, "Corrupt Content-* header.",
+                 "msIO_stripStdoutBufferContentHeaders");
       return;
     }
     /* -------------------------------------------------------------------- */
     /*      Go to next line.                                                */
     /* -------------------------------------------------------------------- */
-    start_of_data +=3;
+    start_of_data += 3;
   }
 
   /* -------------------------------------------------------------------- */
   /*      Continue on to the start of data ...                            */
   /*      Skip next line if empty.                                        */
   /* -------------------------------------------------------------------- */
-  if( start_of_data  < buf->data_offset
-      && buf->data[start_of_data] == '\r' )
-    start_of_data +=2;
-
-  if( start_of_data == buf->data_offset ) {
-    msSetError( MS_MISCERR, "Corrupt Content-* header.",
-                "msIO_stripStdoutBufferContentHeaders" );
+  if (start_of_data < buf->data_offset && buf->data[start_of_data] == '\r')
+    start_of_data += 2;
+
+  if (start_of_data == buf->data_offset) {
+    msSetError(MS_MISCERR, "Corrupt Content-* header.",
+               "msIO_stripStdoutBufferContentHeaders");
     return;
   }
 
   /* -------------------------------------------------------------------- */
   /*      Move data to front of buffer, and reset length.                 */
   /* -------------------------------------------------------------------- */
-  memmove( buf->data, buf->data+start_of_data,
-           buf->data_offset - start_of_data );
+  memmove(buf->data, buf->data + start_of_data,
+          buf->data_offset - start_of_data);
   buf->data[buf->data_offset - start_of_data] = '\0';
   buf->data_offset -= start_of_data;
 
@@ -1055,25 +1017,24 @@ void msIO_stripStdoutBufferContentHeader
 /*                          msIO_bufferWrite()                          */
 /************************************************************************/
 
-int msIO_bufferWrite( void *cbData, void *data, int byteCount )
+int msIO_bufferWrite(void *cbData, void *data, int byteCount)
 
 {
-  msIOBuffer *buf = (msIOBuffer *) cbData;
+  msIOBuffer *buf = (msIOBuffer *)cbData;
 
   /*
   ** Grow buffer if needed (reserve one extra byte to put nul character)
   */
-  if( buf->data_offset + byteCount >= buf->data_len ) {
+  if (buf->data_offset + byteCount >= buf->data_len) {
     buf->data_len = buf->data_len * 2 + byteCount + 100;
-    if( buf->data == NULL )
-      buf->data = (unsigned char *) malloc(buf->data_len);
+    if (buf->data == NULL)
+      buf->data = (unsigned char *)malloc(buf->data_len);
     else
-      buf->data = (unsigned char *) realloc(buf->data, buf->data_len);
+      buf->data = (unsigned char *)realloc(buf->data, buf->data_len);
 
-    if( buf->data == NULL ) {
-      msSetError( MS_MEMERR,
-                  "Failed to allocate %d bytes for capture buffer.",
-                  "msIO_bufferWrite()", buf->data_len );
+    if (buf->data == NULL) {
+      msSetError(MS_MEMERR, "Failed to allocate %d bytes for capture buffer.",
+                 "msIO_bufferWrite()", buf->data_len);
       buf->data_len = 0;
       return 0;
     }
@@ -1083,7 +1044,7 @@ int msIO_bufferWrite( void *cbData, void
   ** Copy result into buffer.
   */
 
-  memcpy( buf->data + buf->data_offset, data, byteCount );
+  memcpy(buf->data + buf->data_offset, data, byteCount);
   buf->data_offset += byteCount;
   buf->data[buf->data_offset] = '\0';
 
@@ -1094,7 +1055,7 @@ int msIO_bufferWrite( void *cbData, void
 /*                          msIO_bufferRead()                           */
 /************************************************************************/
 
-int msIO_bufferRead( void *cbData, void *data, int byteCount )
+int msIO_bufferRead(void *cbData, void *data, int byteCount)
 
 {
   (void)cbData;
diff -pruN 8.0.1-5/mapio.h 8.0.2-1/mapio.h
--- 8.0.1-5/mapio.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapio.h	2024-06-11 20:41:34.000000000 +0000
@@ -45,79 +45,85 @@ extern "C" {
 
 #ifndef MS_PRINT_FUNC_FORMAT
 #if defined(__GNUC__) && __GNUC__ >= 3 && !defined(DOXYGEN_SKIP)
-#define MS_PRINT_FUNC_FORMAT( format_idx, arg_idx )  __attribute__((__format__ (__printf__, format_idx, arg_idx)))
+#define MS_PRINT_FUNC_FORMAT(format_idx, arg_idx)                              \
+  __attribute__((__format__(__printf__, format_idx, arg_idx)))
 #else
-#define MS_PRINT_FUNC_FORMAT( format_idx, arg_idx )
+#define MS_PRINT_FUNC_FORMAT(format_idx, arg_idx)
 #endif
 #endif
 
-  /* stdio analogs */
-  int MS_DLL_EXPORT msIO_printf( const char *format, ... ) MS_PRINT_FUNC_FORMAT(1,2);
-  int MS_DLL_EXPORT msIO_fprintf( FILE *stream, const char *format, ... ) MS_PRINT_FUNC_FORMAT(2,3);
-  int MS_DLL_EXPORT msIO_fwrite( const void *ptr, size_t size, size_t nmemb, FILE *stream );
-  int MS_DLL_EXPORT msIO_fread( void *ptr, size_t size, size_t nmemb, FILE *stream );
-  int MS_DLL_EXPORT msIO_vfprintf( FILE *fp, const char *format, va_list ap ) MS_PRINT_FUNC_FORMAT(2,0);
-
-  /*
-  ** Definitions for the callback function and the details of the IO
-  ** channel contexts.
-  */
-
-  typedef int (*msIO_llReadWriteFunc)( void *cbData, void *data, int byteCount );
-
-  typedef struct msIOContext_t {
-    const char           *label;
-    int                   write_channel; /* 1 for stdout/stderr, 0 for stdin */
-    msIO_llReadWriteFunc  readWriteFunc;
-    void                  *cbData;
-  } msIOContext;
-
-  int MS_DLL_EXPORT msIO_installHandlers( msIOContext *stdin_context,
-                                          msIOContext *stdout_context,
-                                          msIOContext *stderr_context );
-  msIOContext MS_DLL_EXPORT *msIO_getHandler( FILE * );
-  void MS_DLL_EXPORT msIO_setHeaderEnabled(int bFlag);
-  void msIO_setHeader (const char *header, const char* value, ...) MS_PRINT_FUNC_FORMAT(2,3);
-  void msIO_sendHeaders(void);
-
-  /*
-  ** These can be used instead of the stdio style functions if you have
-  ** msIOContext's for the channel in question.
-  */
-  int msIO_contextRead( msIOContext *context, void *data, int byteCount );
-  int msIO_contextWrite( msIOContext *context, const void *data, int byteCount );
-
-  /*
-  ** For redirecting IO to a memory buffer.
-  */
-
-  typedef struct {
-    unsigned char *data;
-    int            data_len;    /* really buffer length */
-    int            data_offset; /* really buffer used */
-  } msIOBuffer;
-
-  int MS_DLL_EXPORT msIO_bufferRead( void *, void *, int );
-  int MS_DLL_EXPORT msIO_bufferWrite( void *, void *, int );
-
-  void MS_DLL_EXPORT msIO_resetHandlers(void);
-  void MS_DLL_EXPORT msIO_installStdoutToBuffer(void);
-  void MS_DLL_EXPORT msIO_installStdinFromBuffer(void);
-  void MS_DLL_EXPORT msIO_Cleanup(void);
-  char MS_DLL_EXPORT *msIO_stripStdoutBufferContentType(void);
-  void MS_DLL_EXPORT msIO_stripStdoutBufferContentHeaders(void);
-  hashTableObj MS_DLL_EXPORT *msIO_getAndStripStdoutBufferMimeHeaders(void);
-
-  msIOContext *msIO_pushStdoutToBufferAndGetOldContext(void);
-  void msIO_restoreOldStdoutContext(msIOContext *context_to_restore);
+/* stdio analogs */
+int MS_DLL_EXPORT msIO_printf(const char *format, ...)
+    MS_PRINT_FUNC_FORMAT(1, 2);
+int MS_DLL_EXPORT msIO_fprintf(FILE *stream, const char *format, ...)
+    MS_PRINT_FUNC_FORMAT(2, 3);
+int MS_DLL_EXPORT msIO_fwrite(const void *ptr, size_t size, size_t nmemb,
+                              FILE *stream);
+int MS_DLL_EXPORT msIO_fread(void *ptr, size_t size, size_t nmemb,
+                             FILE *stream);
+int MS_DLL_EXPORT msIO_vfprintf(FILE *fp, const char *format, va_list ap)
+    MS_PRINT_FUNC_FORMAT(2, 0);
+
+/*
+** Definitions for the callback function and the details of the IO
+** channel contexts.
+*/
+
+typedef int (*msIO_llReadWriteFunc)(void *cbData, void *data, int byteCount);
+
+typedef struct msIOContext_t {
+  const char *label;
+  int write_channel; /* 1 for stdout/stderr, 0 for stdin */
+  msIO_llReadWriteFunc readWriteFunc;
+  void *cbData;
+} msIOContext;
+
+int MS_DLL_EXPORT msIO_installHandlers(msIOContext *stdin_context,
+                                       msIOContext *stdout_context,
+                                       msIOContext *stderr_context);
+msIOContext MS_DLL_EXPORT *msIO_getHandler(FILE *);
+void MS_DLL_EXPORT msIO_setHeaderEnabled(int bFlag);
+void msIO_setHeader(const char *header, const char *value, ...)
+    MS_PRINT_FUNC_FORMAT(2, 3);
+void msIO_sendHeaders(void);
+
+/*
+** These can be used instead of the stdio style functions if you have
+** msIOContext's for the channel in question.
+*/
+int msIO_contextRead(msIOContext *context, void *data, int byteCount);
+int msIO_contextWrite(msIOContext *context, const void *data, int byteCount);
+
+/*
+** For redirecting IO to a memory buffer.
+*/
+
+typedef struct {
+  unsigned char *data;
+  int data_len;    /* really buffer length */
+  int data_offset; /* really buffer used */
+} msIOBuffer;
+
+int MS_DLL_EXPORT msIO_bufferRead(void *, void *, int);
+int MS_DLL_EXPORT msIO_bufferWrite(void *, void *, int);
+
+void MS_DLL_EXPORT msIO_resetHandlers(void);
+void MS_DLL_EXPORT msIO_installStdoutToBuffer(void);
+void MS_DLL_EXPORT msIO_installStdinFromBuffer(void);
+void MS_DLL_EXPORT msIO_Cleanup(void);
+char MS_DLL_EXPORT *msIO_stripStdoutBufferContentType(void);
+void MS_DLL_EXPORT msIO_stripStdoutBufferContentHeaders(void);
+hashTableObj MS_DLL_EXPORT *msIO_getAndStripStdoutBufferMimeHeaders(void);
+
+msIOContext *msIO_pushStdoutToBufferAndGetOldContext(void);
+void msIO_restoreOldStdoutContext(msIOContext *context_to_restore);
 
-  int MS_DLL_EXPORT msIO_isStdContext(void);
+int MS_DLL_EXPORT msIO_isStdContext(void);
 
+/* this is just for setting normal stdout's to binary mode on windows */
 
-  /* this is just for setting normal stdout's to binary mode on windows */
-
-  int msIO_needBinaryStdout( void );
-  int msIO_needBinaryStdin( void );
+int msIO_needBinaryStdout(void);
+int msIO_needBinaryStdin(void);
 
 #ifdef __cplusplus
 }
diff -pruN 8.0.1-5/mapjoin.c 8.0.2-1/mapjoin.c
--- 8.0.1-5/mapjoin.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapjoin.c	2024-06-11 20:41:34.000000000 +0000
@@ -29,11 +29,8 @@
 
 #include "mapserver.h"
 
-
-
 #define ROW_ALLOCATION_SIZE 10
 
-
 /* DBF/XBase function prototypes */
 int msDBFJoinConnect(layerObj *layer, joinObj *join);
 int msDBFJoinPrepare(joinObj *join, shapeObj *shape);
@@ -62,92 +59,90 @@ int msPOSTGRESQLJoinNext(joinObj *join);
 int msPOSTGRESQLJoinClose(joinObj *join);
 
 /* wrapper function for DB specific join functions */
-int msJoinConnect(layerObj *layer, joinObj *join)
-{
-  switch(join->connectiontype) {
-    case(MS_DB_XBASE):
-      return msDBFJoinConnect(layer, join);
-      break;
-    case(MS_DB_CSV):
-      return msCSVJoinConnect(layer, join);
-      break;
-    case(MS_DB_MYSQL):
-      return msMySQLJoinConnect(layer, join);
-      break;
-    case(MS_DB_POSTGRES):
-      return msPOSTGRESQLJoinConnect(layer, join);
-      break;
-    default:
-      break;
+int msJoinConnect(layerObj *layer, joinObj *join) {
+  switch (join->connectiontype) {
+  case (MS_DB_XBASE):
+    return msDBFJoinConnect(layer, join);
+    break;
+  case (MS_DB_CSV):
+    return msCSVJoinConnect(layer, join);
+    break;
+  case (MS_DB_MYSQL):
+    return msMySQLJoinConnect(layer, join);
+    break;
+  case (MS_DB_POSTGRES):
+    return msPOSTGRESQLJoinConnect(layer, join);
+    break;
+  default:
+    break;
   }
 
-  msSetError(MS_JOINERR, "Unsupported join connection type.", "msJoinConnect()");
+  msSetError(MS_JOINERR, "Unsupported join connection type.",
+             "msJoinConnect()");
   return MS_FAILURE;
 }
 
-int msJoinPrepare(joinObj *join, shapeObj *shape)
-{
-  switch(join->connectiontype) {
-    case(MS_DB_XBASE):
-      return msDBFJoinPrepare(join, shape);
-      break;
-    case(MS_DB_CSV):
-      return msCSVJoinPrepare(join, shape);
-      break;
-    case(MS_DB_MYSQL):
-      return msMySQLJoinPrepare(join, shape);
-      break;
-    case(MS_DB_POSTGRES):
-      return msPOSTGRESQLJoinPrepare(join, shape);
-      break;
-    default:
-      break;
+int msJoinPrepare(joinObj *join, shapeObj *shape) {
+  switch (join->connectiontype) {
+  case (MS_DB_XBASE):
+    return msDBFJoinPrepare(join, shape);
+    break;
+  case (MS_DB_CSV):
+    return msCSVJoinPrepare(join, shape);
+    break;
+  case (MS_DB_MYSQL):
+    return msMySQLJoinPrepare(join, shape);
+    break;
+  case (MS_DB_POSTGRES):
+    return msPOSTGRESQLJoinPrepare(join, shape);
+    break;
+  default:
+    break;
   }
 
-  msSetError(MS_JOINERR, "Unsupported join connection type.", "msJoinPrepare()");
+  msSetError(MS_JOINERR, "Unsupported join connection type.",
+             "msJoinPrepare()");
   return MS_FAILURE;
 }
 
-int msJoinNext(joinObj *join)
-{
-  switch(join->connectiontype) {
-    case(MS_DB_XBASE):
-      return msDBFJoinNext(join);
-      break;
-    case(MS_DB_CSV):
-      return msCSVJoinNext(join);
-      break;
-    case(MS_DB_MYSQL):
-      return msMySQLJoinNext(join);
-      break;
-    case(MS_DB_POSTGRES):
-      return msPOSTGRESQLJoinNext(join);
-      break;
-    default:
-      break;
+int msJoinNext(joinObj *join) {
+  switch (join->connectiontype) {
+  case (MS_DB_XBASE):
+    return msDBFJoinNext(join);
+    break;
+  case (MS_DB_CSV):
+    return msCSVJoinNext(join);
+    break;
+  case (MS_DB_MYSQL):
+    return msMySQLJoinNext(join);
+    break;
+  case (MS_DB_POSTGRES):
+    return msPOSTGRESQLJoinNext(join);
+    break;
+  default:
+    break;
   }
 
   msSetError(MS_JOINERR, "Unsupported join connection type.", "msJoinNext()");
   return MS_FAILURE;
 }
 
-int msJoinClose(joinObj *join)
-{
-  switch(join->connectiontype) {
-    case(MS_DB_XBASE):
-      return msDBFJoinClose(join);
-      break;
-    case(MS_DB_CSV):
-      return msCSVJoinClose(join);
-      break;
-    case(MS_DB_MYSQL):
-      return msMySQLJoinClose(join);
-      break;
-    case(MS_DB_POSTGRES):
-      return msPOSTGRESQLJoinClose(join);
-      break;
-    default:
-      break;
+int msJoinClose(joinObj *join) {
+  switch (join->connectiontype) {
+  case (MS_DB_XBASE):
+    return msDBFJoinClose(join);
+    break;
+  case (MS_DB_CSV):
+    return msCSVJoinClose(join);
+    break;
+  case (MS_DB_MYSQL):
+    return msMySQLJoinClose(join);
+    break;
+  case (MS_DB_POSTGRES):
+    return msPOSTGRESQLJoinClose(join);
+    break;
+  default:
+    break;
   }
 
   msSetError(MS_JOINERR, "Unsupported join connection type.", "msJoinClose()");
@@ -164,23 +159,23 @@ typedef struct {
   int nextrecord;
 } msDBFJoinInfo;
 
-int msDBFJoinConnect(layerObj *layer, joinObj *join)
-{
+int msDBFJoinConnect(layerObj *layer, joinObj *join) {
   int i;
   char szPath[MS_MAXPATHLEN];
   msDBFJoinInfo *joininfo;
 
-  if(join->joininfo) return(MS_SUCCESS); /* already open */
+  if (join->joininfo)
+    return (MS_SUCCESS); /* already open */
 
-  if ( msCheckParentPointer(layer->map,"map")==MS_FAILURE )
+  if (msCheckParentPointer(layer->map, "map") == MS_FAILURE)
     return MS_FAILURE;
 
-
   /* allocate a msDBFJoinInfo struct */
-  joininfo = (msDBFJoinInfo *) malloc(sizeof(msDBFJoinInfo));
-  if(!joininfo) {
-    msSetError(MS_MEMERR, "Error allocating XBase table info structure.", "msDBFJoinConnect()");
-    return(MS_FAILURE);
+  joininfo = (msDBFJoinInfo *)malloc(sizeof(msDBFJoinInfo));
+  if (!joininfo) {
+    msSetError(MS_MEMERR, "Error allocating XBase table info structure.",
+               "msDBFJoinConnect()");
+    return (MS_FAILURE);
   }
 
   /* initialize any members that won't get set later on in this function */
@@ -190,126 +185,145 @@ int msDBFJoinConnect(layerObj *layer, jo
   join->joininfo = joininfo;
 
   /* open the XBase file */
-  if((joininfo->hDBF = msDBFOpen( msBuildPath3(szPath, layer->map->mappath, layer->map->shapepath, join->table), "rb" )) == NULL) {
-    if((joininfo->hDBF = msDBFOpen( msBuildPath(szPath, layer->map->mappath, join->table), "rb" )) == NULL) {
+  if ((joininfo->hDBF =
+           msDBFOpen(msBuildPath3(szPath, layer->map->mappath,
+                                  layer->map->shapepath, join->table),
+                     "rb")) == NULL) {
+    if ((joininfo->hDBF =
+             msDBFOpen(msBuildPath(szPath, layer->map->mappath, join->table),
+                       "rb")) == NULL) {
       msSetError(MS_IOERR, "(%s)", "msDBFJoinConnect()", join->table);
-      return(MS_FAILURE);
+      return (MS_FAILURE);
     }
   }
 
   /* get "to" item index */
-  if((joininfo->toindex = msDBFGetItemIndex(joininfo->hDBF, join->to)) == -1) {
-    msSetError(MS_DBFERR, "Item %s not found in table %s.", "msDBFJoinConnect()", join->to, join->table);
-    return(MS_FAILURE);
+  if ((joininfo->toindex = msDBFGetItemIndex(joininfo->hDBF, join->to)) == -1) {
+    msSetError(MS_DBFERR, "Item %s not found in table %s.",
+               "msDBFJoinConnect()", join->to, join->table);
+    return (MS_FAILURE);
   }
 
   /* get "from" item index   */
-  for(i=0; i<layer->numitems; i++) {
-    if(strcasecmp(layer->items[i],join->from) == 0) { /* found it */
+  for (i = 0; i < layer->numitems; i++) {
+    if (strcasecmp(layer->items[i], join->from) == 0) { /* found it */
       joininfo->fromindex = i;
       break;
     }
   }
 
-  if(i == layer->numitems) {
-    msSetError(MS_JOINERR, "Item %s not found in layer %s.", "msDBFJoinConnect()", join->from, layer->name);
-    return(MS_FAILURE);
+  if (i == layer->numitems) {
+    msSetError(MS_JOINERR, "Item %s not found in layer %s.",
+               "msDBFJoinConnect()", join->from, layer->name);
+    return (MS_FAILURE);
   }
 
   /* finally store away the item names in the XBase table */
-  join->numitems =  msDBFGetFieldCount(joininfo->hDBF);
+  join->numitems = msDBFGetFieldCount(joininfo->hDBF);
   join->items = msDBFGetItems(joininfo->hDBF);
-  if(!join->items) return(MS_FAILURE);
+  if (!join->items)
+    return (MS_FAILURE);
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
-int msDBFJoinPrepare(joinObj *join, shapeObj *shape)
-{
+int msDBFJoinPrepare(joinObj *join, shapeObj *shape) {
   msDBFJoinInfo *joininfo = join->joininfo;
 
-  if(!joininfo) {
-    msSetError(MS_JOINERR, "Join connection has not be created.", "msDBFJoinPrepare()");
-    return(MS_FAILURE);
-  }
-
-  if(!shape) {
-    msSetError(MS_JOINERR, "Shape to be joined is empty.", "msDBFJoinPrepare()");
-    return(MS_FAILURE);
-  }
-
-  if(!shape->values) {
-    msSetError(MS_JOINERR, "Shape to be joined has no attributes.", "msDBFJoinPrepare()");
-    return(MS_FAILURE);
+  if (!joininfo) {
+    msSetError(MS_JOINERR, "Join connection has not be created.",
+               "msDBFJoinPrepare()");
+    return (MS_FAILURE);
+  }
+
+  if (!shape) {
+    msSetError(MS_JOINERR, "Shape to be joined is empty.",
+               "msDBFJoinPrepare()");
+    return (MS_FAILURE);
+  }
+
+  if (!shape->values) {
+    msSetError(MS_JOINERR, "Shape to be joined has no attributes.",
+               "msDBFJoinPrepare()");
+    return (MS_FAILURE);
   }
 
   joininfo->nextrecord = 0; /* starting with the first record */
 
-  if(joininfo->target) free(joininfo->target); /* clear last target */
+  if (joininfo->target)
+    free(joininfo->target); /* clear last target */
   joininfo->target = msStrdup(shape->values[joininfo->fromindex]);
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
-int msDBFJoinNext(joinObj *join)
-{
+int msDBFJoinNext(joinObj *join) {
   int i, n;
   msDBFJoinInfo *joininfo = join->joininfo;
 
-  if(!joininfo) {
-    msSetError(MS_JOINERR, "Join connection has not be created.", "msDBFJoinNext()");
-    return(MS_FAILURE);
+  if (!joininfo) {
+    msSetError(MS_JOINERR, "Join connection has not be created.",
+               "msDBFJoinNext()");
+    return (MS_FAILURE);
   }
 
-  if(!joininfo->target) {
-    msSetError(MS_JOINERR, "No target specified, run msDBFJoinPrepare() first.", "msDBFJoinNext()");
-    return(MS_FAILURE);
+  if (!joininfo->target) {
+    msSetError(MS_JOINERR, "No target specified, run msDBFJoinPrepare() first.",
+               "msDBFJoinNext()");
+    return (MS_FAILURE);
   }
 
   /* clear any old data */
-  if(join->values) {
+  if (join->values) {
     msFreeCharArray(join->values, join->numitems);
     join->values = NULL;
   }
 
   n = msDBFGetRecordCount(joininfo->hDBF);
 
-  for(i=joininfo->nextrecord; i<n; i++) { /* find a match */
-    if(strcmp(joininfo->target, msDBFReadStringAttribute(joininfo->hDBF, i, joininfo->toindex)) == 0) break;
+  for (i = joininfo->nextrecord; i < n; i++) { /* find a match */
+    if (strcmp(joininfo->target, msDBFReadStringAttribute(joininfo->hDBF, i,
+                                                          joininfo->toindex)) ==
+        0)
+      break;
   }
 
-  if(i == n) { /* unable to do the join */
-    if((join->values = (char **)malloc(sizeof(char *)*join->numitems)) == NULL) {
+  if (i == n) { /* unable to do the join */
+    if ((join->values = (char **)malloc(sizeof(char *) * join->numitems)) ==
+        NULL) {
       msSetError(MS_MEMERR, NULL, "msDBFJoinNext()");
-      return(MS_FAILURE);
+      return (MS_FAILURE);
     }
-    for(i=0; i<join->numitems; i++)
+    for (i = 0; i < join->numitems; i++)
       join->values[i] = msStrdup("\0"); /* intialize to zero length strings */
 
     joininfo->nextrecord = n;
-    return(MS_DONE);
+    return (MS_DONE);
   }
 
-  if((join->values = msDBFGetValues(joininfo->hDBF,i)) == NULL)
-    return(MS_FAILURE);
+  if ((join->values = msDBFGetValues(joininfo->hDBF, i)) == NULL)
+    return (MS_FAILURE);
 
-  joininfo->nextrecord = i+1; /* so we know where to start looking next time through */
+  joininfo->nextrecord =
+      i + 1; /* so we know where to start looking next time through */
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
-int msDBFJoinClose(joinObj *join)
-{
+int msDBFJoinClose(joinObj *join) {
   msDBFJoinInfo *joininfo = join->joininfo;
 
-  if(!joininfo) return(MS_SUCCESS); /* already closed */
+  if (!joininfo)
+    return (MS_SUCCESS); /* already closed */
 
-  if(joininfo->hDBF) msDBFClose(joininfo->hDBF);
-  if(joininfo->target) free(joininfo->target);
+  if (joininfo->hDBF)
+    msDBFClose(joininfo->hDBF);
+  if (joininfo->target)
+    free(joininfo->target);
   free(joininfo);
   joininfo = NULL;
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
 /*  */
@@ -323,23 +337,23 @@ typedef struct {
   int nextrow;
 } msCSVJoinInfo;
 
-int msCSVJoinConnect(layerObj *layer, joinObj *join)
-{
+int msCSVJoinConnect(layerObj *layer, joinObj *join) {
   int i;
   FILE *stream;
   char szPath[MS_MAXPATHLEN];
   msCSVJoinInfo *joininfo;
   char buffer[MS_BUFFER_LENGTH];
 
-  if(join->joininfo) return(MS_SUCCESS); /* already open */
-  if ( msCheckParentPointer(layer->map,"map")==MS_FAILURE )
+  if (join->joininfo)
+    return (MS_SUCCESS); /* already open */
+  if (msCheckParentPointer(layer->map, "map") == MS_FAILURE)
     return MS_FAILURE;
 
-
   /* allocate a msCSVJoinInfo struct */
-  if((joininfo = (msCSVJoinInfo *) malloc(sizeof(msCSVJoinInfo))) == NULL) {
-    msSetError(MS_MEMERR, "Error allocating CSV table info structure.", "msCSVJoinConnect()");
-    return(MS_FAILURE);
+  if ((joininfo = (msCSVJoinInfo *)malloc(sizeof(msCSVJoinInfo))) == NULL) {
+    msSetError(MS_MEMERR, "Error allocating CSV table info structure.",
+               "msCSVJoinConnect()");
+    return (MS_FAILURE);
   }
 
   /* initialize any members that won't get set later on in this function */
@@ -349,175 +363,190 @@ int msCSVJoinConnect(layerObj *layer, jo
   join->joininfo = joininfo;
 
   /* open the CSV file */
-  if((stream = fopen( msBuildPath3(szPath, layer->map->mappath, layer->map->shapepath, join->table), "r" )) == NULL) {
-    if((stream = fopen( msBuildPath(szPath, layer->map->mappath, join->table), "r" )) == NULL) {
+  if ((stream = fopen(msBuildPath3(szPath, layer->map->mappath,
+                                   layer->map->shapepath, join->table),
+                      "r")) == NULL) {
+    if ((stream = fopen(msBuildPath(szPath, layer->map->mappath, join->table),
+                        "r")) == NULL) {
       msSetError(MS_IOERR, "(%s)", "msCSVJoinConnect()", join->table);
-      return(MS_FAILURE);
+      return (MS_FAILURE);
     }
   }
 
   /* once through to get the number of rows */
   joininfo->numrows = 0;
-  while(fgets(buffer, MS_BUFFER_LENGTH, stream) != NULL) joininfo->numrows++;
+  while (fgets(buffer, MS_BUFFER_LENGTH, stream) != NULL)
+    joininfo->numrows++;
   rewind(stream);
 
-  if((joininfo->rows = (char ***) malloc(joininfo->numrows*sizeof(char **))) == NULL) {
+  if ((joininfo->rows =
+           (char ***)malloc(joininfo->numrows * sizeof(char **))) == NULL) {
     fclose(stream);
     msSetError(MS_MEMERR, "Error allocating rows.", "msCSVJoinConnect()");
-    return(MS_FAILURE);
+    return (MS_FAILURE);
   }
 
   /* load the rows */
   i = 0;
-  while(fgets(buffer, MS_BUFFER_LENGTH, stream) != NULL) {
+  while (fgets(buffer, MS_BUFFER_LENGTH, stream) != NULL) {
     msStringTrimEOL(buffer);
-    joininfo->rows[i] = msStringSplitComplex(buffer, ",", &(join->numitems), MS_ALLOWEMPTYTOKENS);
+    joininfo->rows[i] = msStringSplitComplex(buffer, ",", &(join->numitems),
+                                             MS_ALLOWEMPTYTOKENS);
     i++;
   }
   fclose(stream);
 
   /* get "from" item index   */
-  for(i=0; i<layer->numitems; i++) {
-    if(strcasecmp(layer->items[i],join->from) == 0) { /* found it */
+  for (i = 0; i < layer->numitems; i++) {
+    if (strcasecmp(layer->items[i], join->from) == 0) { /* found it */
       joininfo->fromindex = i;
       break;
     }
   }
 
-  if(i == layer->numitems) {
-    msSetError(MS_JOINERR, "Item %s not found in layer %s.", "msCSVJoinConnect()", join->from, layer->name);
-    return(MS_FAILURE);
+  if (i == layer->numitems) {
+    msSetError(MS_JOINERR, "Item %s not found in layer %s.",
+               "msCSVJoinConnect()", join->from, layer->name);
+    return (MS_FAILURE);
   }
 
   /* get "to" index (for now the user tells us which column, 1..n) */
   joininfo->toindex = atoi(join->to) - 1;
-  if(joininfo->toindex < 0 || joininfo->toindex > join->numitems) {
-    msSetError(MS_JOINERR, "Invalid column index %s.", "msCSVJoinConnect()", join->to);
-    return(MS_FAILURE);
+  if (joininfo->toindex < 0 || joininfo->toindex > join->numitems) {
+    msSetError(MS_JOINERR, "Invalid column index %s.", "msCSVJoinConnect()",
+               join->to);
+    return (MS_FAILURE);
   }
 
   /* store away the column names (1..n) */
-  if((join->items = (char **) malloc(sizeof(char *)*join->numitems)) == NULL) {
-    msSetError(MS_MEMERR, "Error allocating space for join item names.", "msCSVJoinConnect()");
-    return(MS_FAILURE);
+  if ((join->items = (char **)malloc(sizeof(char *) * join->numitems)) ==
+      NULL) {
+    msSetError(MS_MEMERR, "Error allocating space for join item names.",
+               "msCSVJoinConnect()");
+    return (MS_FAILURE);
   }
-  for(i=0; i<join->numitems; i++) {
-    join->items[i] = (char *) malloc(12); /* plenty of space */
-    sprintf(join->items[i], "%d", i+1);
+  for (i = 0; i < join->numitems; i++) {
+    join->items[i] = (char *)malloc(12); /* plenty of space */
+    sprintf(join->items[i], "%d", i + 1);
   }
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
-int msCSVJoinPrepare(joinObj *join, shapeObj *shape)
-{
+int msCSVJoinPrepare(joinObj *join, shapeObj *shape) {
   msCSVJoinInfo *joininfo = join->joininfo;
 
-  if(!joininfo) {
-    msSetError(MS_JOINERR, "Join connection has not be created.", "msCSVJoinPrepare()");
-    return(MS_FAILURE);
-  }
-
-  if(!shape) {
-    msSetError(MS_JOINERR, "Shape to be joined is empty.", "msCSVJoinPrepare()");
-    return(MS_FAILURE);
-  }
-
-  if(!shape->values) {
-    msSetError(MS_JOINERR, "Shape to be joined has no attributes.", "msCSVJoinPrepare()");
-    return(MS_FAILURE);
+  if (!joininfo) {
+    msSetError(MS_JOINERR, "Join connection has not be created.",
+               "msCSVJoinPrepare()");
+    return (MS_FAILURE);
+  }
+
+  if (!shape) {
+    msSetError(MS_JOINERR, "Shape to be joined is empty.",
+               "msCSVJoinPrepare()");
+    return (MS_FAILURE);
+  }
+
+  if (!shape->values) {
+    msSetError(MS_JOINERR, "Shape to be joined has no attributes.",
+               "msCSVJoinPrepare()");
+    return (MS_FAILURE);
   }
 
   joininfo->nextrow = 0; /* starting with the first record */
 
-  if(joininfo->target) free(joininfo->target); /* clear last target */
+  if (joininfo->target)
+    free(joininfo->target); /* clear last target */
   joininfo->target = msStrdup(shape->values[joininfo->fromindex]);
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
-int msCSVJoinNext(joinObj *join)
-{
-  int i,j;
+int msCSVJoinNext(joinObj *join) {
+  int i, j;
   msCSVJoinInfo *joininfo = join->joininfo;
 
-  if(!joininfo) {
-    msSetError(MS_JOINERR, "Join connection has not be created.", "msCSVJoinNext()");
-    return(MS_FAILURE);
+  if (!joininfo) {
+    msSetError(MS_JOINERR, "Join connection has not be created.",
+               "msCSVJoinNext()");
+    return (MS_FAILURE);
   }
 
   /* clear any old data */
-  if(join->values) {
+  if (join->values) {
     msFreeCharArray(join->values, join->numitems);
     join->values = NULL;
   }
 
-  for(i=joininfo->nextrow; i<joininfo->numrows; i++) { /* find a match     */
-    if(strcmp(joininfo->target, joininfo->rows[i][joininfo->toindex]) == 0) break;
+  for (i = joininfo->nextrow; i < joininfo->numrows; i++) { /* find a match */
+    if (strcmp(joininfo->target, joininfo->rows[i][joininfo->toindex]) == 0)
+      break;
   }
 
-  if((join->values = (char ** )malloc(sizeof(char *)*join->numitems)) == NULL) {
+  if ((join->values = (char **)malloc(sizeof(char *) * join->numitems)) ==
+      NULL) {
     msSetError(MS_MEMERR, NULL, "msCSVJoinNext()");
-    return(MS_FAILURE);
+    return (MS_FAILURE);
   }
 
-  if(i == joininfo->numrows) { /* unable to do the join     */
-    for(j=0; j<join->numitems; j++)
+  if (i == joininfo->numrows) { /* unable to do the join     */
+    for (j = 0; j < join->numitems; j++)
       join->values[j] = msStrdup("\0"); /* intialize to zero length strings */
 
     joininfo->nextrow = joininfo->numrows;
-    return(MS_DONE);
+    return (MS_DONE);
   }
 
-  for(j=0; j<join->numitems; j++)
+  for (j = 0; j < join->numitems; j++)
     join->values[j] = msStrdup(joininfo->rows[i][j]);
 
-  joininfo->nextrow = i+1; /* so we know where to start looking next time through */
+  joininfo->nextrow =
+      i + 1; /* so we know where to start looking next time through */
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
-int msCSVJoinClose(joinObj *join)
-{
+int msCSVJoinClose(joinObj *join) {
   int i;
   msCSVJoinInfo *joininfo = join->joininfo;
 
-  if(!joininfo) return(MS_SUCCESS); /* already closed */
+  if (!joininfo)
+    return (MS_SUCCESS); /* already closed */
 
-  for(i=0; i<joininfo->numrows; i++)
+  for (i = 0; i < joininfo->numrows; i++)
     msFreeCharArray(joininfo->rows[i], join->numitems);
   free(joininfo->rows);
-  if(joininfo->target) free(joininfo->target);
+  if (joininfo->target)
+    free(joininfo->target);
   free(joininfo);
   joininfo = NULL;
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
-
 #ifdef USE_MYSQL
 
 #ifndef _mysql_h
 #include <mysql/mysql.h>
 #endif
 
-char* DB_HOST = NULL;
-char* DB_USER = NULL;
-char* DB_PASSWD = NULL;
-char* DB_DATABASE = NULL;
-char* delim;
+char *DB_HOST = NULL;
+char *DB_USER = NULL;
+char *DB_PASSWD = NULL;
+char *DB_DATABASE = NULL;
+char *delim;
 
 #define MYDEBUG if (0)
 
-MYSQL_RES *msMySQLQuery(char *q, MYSQL *conn)
-{
-  MYSQL_RES *qresult=NULL;
-  if (mysql_query(conn,q) < 0) {
+MYSQL_RES *msMySQLQuery(char *q, MYSQL *conn) {
+  MYSQL_RES *qresult = NULL;
+  if (mysql_query(conn, q) < 0) {
     mysql_close(conn);
     msSetError(MS_QUERYERR, "Bad mysql query (%s)", "msMySQLQuery()", q);
     return qresult;
   }
-  if (!(qresult=mysql_store_result(conn)))    {
+  if (!(qresult = mysql_store_result(conn))) {
     mysql_close(conn);
     msSetError(MS_QUERYERR, "mysql query failed (%s)", "msMySQLQuery()", q);
     return qresult;
@@ -540,30 +569,30 @@ typedef struct {
 } msMySQLJoinInfo;
 #endif
 
-
-int msMySQLJoinConnect(layerObj *layer, joinObj *join)
-{
+int msMySQLJoinConnect(layerObj *layer, joinObj *join) {
   (void)layer;
   (void)join;
 #ifndef USE_MYSQL
-  msSetError(MS_QUERYERR, "MySQL support not available (compile with --with-mysql)", "msMySQLJoinConnect()");
-  return(MS_FAILURE);
+  msSetError(MS_QUERYERR,
+             "MySQL support not available (compile with --with-mysql)",
+             "msMySQLJoinConnect()");
+  return (MS_FAILURE);
 #else
   int i;
   char qbuf[4000];
   char *conn_decrypted;
   msMySQLJoinInfo *joininfo;
 
-  MYDEBUG if (setvbuf(stdout, NULL, _IONBF , 0)) {
-    printf("Whoops...");
-  };
-  if(join->joininfo) return(MS_SUCCESS); /* already open */
+  MYDEBUG if (setvbuf(stdout, NULL, _IONBF, 0)) { printf("Whoops..."); };
+  if (join->joininfo)
+    return (MS_SUCCESS); /* already open */
 
   /* allocate a msMySQLJoinInfo struct */
-  joininfo = (msMySQLJoinInfo *) malloc(sizeof(msMySQLJoinInfo));
-  if(!joininfo) {
-    msSetError(MS_MEMERR, "Error allocating mysql table info structure.", "msMySQLJoinConnect()");
-    return(MS_FAILURE);
+  joininfo = (msMySQLJoinInfo *)malloc(sizeof(msMySQLJoinInfo));
+  if (!joininfo) {
+    msSetError(MS_MEMERR, "Error allocating mysql table info structure.",
+               "msMySQLJoinConnect()");
+    return (MS_FAILURE);
   }
 
   /* initialize any members that won't get set later on in this function */
@@ -575,18 +604,22 @@ int msMySQLJoinConnect(layerObj *layer,
 
   /* open the mysql connection */
 
-  if( join->connection == NULL ) {
-    msSetError(MS_QUERYERR, "Error parsing MYSQL JOIN: nothing specified in CONNECTION statement.",
-               "msMySQLJoinConnect()");
+  if (join->connection == NULL) {
+    msSetError(
+        MS_QUERYERR,
+        "Error parsing MYSQL JOIN: nothing specified in CONNECTION statement.",
+        "msMySQLJoinConnect()");
 
-    return(MS_FAILURE);
+    return (MS_FAILURE);
   }
 
   conn_decrypted = msDecryptStringTokens(layer->map, join->connection);
   if (conn_decrypted == NULL) {
-    msSetError(MS_QUERYERR, "Error parsing MYSQL JOIN: unable to decrypt CONNECTION statement.",
-               "msMySQLJoinConnect()");
-    return(MS_FAILURE);
+    msSetError(
+        MS_QUERYERR,
+        "Error parsing MYSQL JOIN: unable to decrypt CONNECTION statement.",
+        "msMySQLJoinConnect()");
+    return (MS_FAILURE);
   }
 
   delim = msStrdup(":");
@@ -596,29 +629,38 @@ int msMySQLJoinConnect(layerObj *layer,
   DB_DATABASE = msStrdup(strtok(NULL, delim));
   free(conn_decrypted);
 
-  if (DB_HOST == NULL || DB_USER == NULL || DB_PASSWD == NULL || DB_DATABASE == NULL) {
-    msSetError(MS_QUERYERR, "DB param error: at least one of HOST, USER, PASSWD or DATABASE is null!", "msMySQLJoinConnect()");
+  if (DB_HOST == NULL || DB_USER == NULL || DB_PASSWD == NULL ||
+      DB_DATABASE == NULL) {
+    msSetError(MS_QUERYERR,
+               "DB param error: at least one of HOST, USER, PASSWD or DATABASE "
+               "is null!",
+               "msMySQLJoinConnect()");
     return MS_FAILURE;
   }
-  if (strcmp(DB_PASSWD, "none") == 0) strcpy(DB_PASSWD, "");
+  if (strcmp(DB_PASSWD, "none") == 0)
+    strcpy(DB_PASSWD, "");
 
 #if MYSQL_VERSION_ID >= 40000
   mysql_init(&(joininfo->mysql));
-  if (!(joininfo->conn = mysql_real_connect(&(joininfo->mysql),DB_HOST,DB_USER,DB_PASSWD,NULL, 0, NULL, 0)))
+  if (!(joininfo->conn = mysql_real_connect(
+            &(joininfo->mysql), DB_HOST, DB_USER, DB_PASSWD, NULL, 0, NULL, 0)))
 #else
-  if (!(joininfo->conn = mysql_connect(&(joininfo->mysql),DB_HOST,DB_USER,DB_PASSWD)))
+  if (!(joininfo->conn =
+            mysql_connect(&(joininfo->mysql), DB_HOST, DB_USER, DB_PASSWD)))
 #endif
   {
     char tmp[4000];
-    snprintf( tmp, sizeof(tmp), "Failed to connect to SQL server: Error: %s\nHost: %s\nUsername:%s\nPassword:%s\n", mysql_error(joininfo->conn), DB_HOST, DB_USER, DB_PASSWD);
-    msSetError(MS_QUERYERR, "%s",
-               "msMYSQLLayerOpen()", tmp);
+    snprintf(tmp, sizeof(tmp),
+             "Failed to connect to SQL server: Error: %s\nHost: "
+             "%s\nUsername:%s\nPassword:%s\n",
+             mysql_error(joininfo->conn), DB_HOST, DB_USER, DB_PASSWD);
+    msSetError(MS_QUERYERR, "%s", "msMYSQLLayerOpen()", tmp);
     free(joininfo);
     return MS_FAILURE;
   }
 
   MYDEBUG printf("msMYSQLLayerOpen2 called<br>\n");
-  if (mysql_select_db(joininfo->conn,DB_DATABASE) < 0) {
+  if (mysql_select_db(joininfo->conn, DB_DATABASE) < 0) {
     mysql_close(joininfo->conn);
   }
   MYDEBUG printf("msMYSQLLayerOpen3 called<br>\n");
@@ -627,118 +669,135 @@ int msMySQLJoinConnect(layerObj *layer,
     mysql_free_result(joininfo->qresult);
   }
   MYDEBUG printf("msMYSQLLayerOpen5 called<br>\n");
-  snprintf(qbuf, sizeof(qbuf), "SELECT count(%s) FROM %s", join->to, join->table);
+  snprintf(qbuf, sizeof(qbuf), "SELECT count(%s) FROM %s", join->to,
+           join->table);
   MYDEBUG printf("%s<br>\n", qbuf);
-  if ((joininfo->qresult = msMySQLQuery(qbuf, joininfo->conn))) { /* There were some rows found, write 'em out for debug */
+  if ((joininfo->qresult =
+           msMySQLQuery(qbuf, joininfo->conn))) { /* There were some rows found,
+                                                     write 'em out for debug */
     int numrows = mysql_affected_rows(joininfo->conn);
     MYDEBUG printf("%d rows<br>\n", numrows);
-    for(i=0; i<numrows; i++) {
+    for (i = 0; i < numrows; i++) {
       MYSQL_ROW row = mysql_fetch_row(joininfo->qresult);
-      MYDEBUG printf("(%s)<BR>\n",row[0]);
+      MYDEBUG printf("(%s)<BR>\n", row[0]);
       joininfo->rows = atoi(row[0]);
     }
   } else {
-    msSetError(MS_DBFERR, "Item %s not found in table %s.", "msMySQLJoinConnect()", join->to, join->table);
-    return(MS_FAILURE);
+    msSetError(MS_DBFERR, "Item %s not found in table %s.",
+               "msMySQLJoinConnect()", join->to, join->table);
+    return (MS_FAILURE);
   }
   snprintf(qbuf, sizeof(qbuf), "EXPLAIN %s", join->table);
-  if ((joininfo->qresult = msMySQLQuery(qbuf, joininfo->conn))) { /* There were some rows found, write 'em out for debug */
+  if ((joininfo->qresult =
+           msMySQLQuery(qbuf, joininfo->conn))) { /* There were some rows found,
+                                                     write 'em out for debug */
     join->numitems = mysql_affected_rows(joininfo->conn);
-    if((join->items = (char **)malloc(sizeof(char *)*join->numitems)) == NULL) {
+    if ((join->items = (char **)malloc(sizeof(char *) * join->numitems)) ==
+        NULL) {
       msSetError(MS_MEMERR, NULL, "msMySQLJoinConnect()");
-      return(MS_FAILURE);
+      return (MS_FAILURE);
     }
     MYDEBUG printf("%d rows<br>\n", join->numitems);
-    for(i=0; i<join->numitems; i++) {
+    for (i = 0; i < join->numitems; i++) {
       MYSQL_ROW row = mysql_fetch_row(joininfo->qresult);
-      MYDEBUG printf("(%s)<BR>\n",row[0]);
+      MYDEBUG printf("(%s)<BR>\n", row[0]);
       join->items[i] = msStrdup(row[0]);
     }
   } else {
-    msSetError(MS_DBFERR, "Item %s not found in table %s.", "msMySQLJoinConnect()", join->to, join->table);
-    return(MS_FAILURE);
+    msSetError(MS_DBFERR, "Item %s not found in table %s.",
+               "msMySQLJoinConnect()", join->to, join->table);
+    return (MS_FAILURE);
   }
   joininfo->tocolumn = msStrdup(join->to);
 
-
-
   /* get "from" item index   */
-  for(i=0; i<layer->numitems; i++) {
-    if(strcasecmp(layer->items[i],join->from) == 0) { /* found it */
+  for (i = 0; i < layer->numitems; i++) {
+    if (strcasecmp(layer->items[i], join->from) == 0) { /* found it */
       joininfo->fromindex = i;
       break;
     }
   }
 
-  if(i == layer->numitems) {
-    msSetError(MS_JOINERR, "Item %s not found in layer %s.", "msMySQLJoinConnect()", join->from, layer->name);
-    return(MS_FAILURE);
+  if (i == layer->numitems) {
+    msSetError(MS_JOINERR, "Item %s not found in layer %s.",
+               "msMySQLJoinConnect()", join->from, layer->name);
+    return (MS_FAILURE);
   }
 
   /* finally store away the item names in the XBase table */
-  if(!join->items) return(MS_FAILURE);
+  if (!join->items)
+    return (MS_FAILURE);
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 #endif
 }
 
-int msMySQLJoinPrepare(joinObj *join, shapeObj *shape)
-{
+int msMySQLJoinPrepare(joinObj *join, shapeObj *shape) {
   (void)join;
   (void)shape;
 #ifndef USE_MYSQL
-  msSetError(MS_QUERYERR, "MySQL support not available (compile with --with-mysql)", "msMySQLJoinPrepare()");
-  return(MS_FAILURE);
+  msSetError(MS_QUERYERR,
+             "MySQL support not available (compile with --with-mysql)",
+             "msMySQLJoinPrepare()");
+  return (MS_FAILURE);
 #else
   msMySQLJoinInfo *joininfo = join->joininfo;
 
-  if(!joininfo) {
-    msSetError(MS_JOINERR, "Join connection has not be created.", "msMySQLJoinPrepare()");
-    return(MS_FAILURE);
-  }
-
-  if(!shape) {
-    msSetError(MS_JOINERR, "Shape to be joined is empty.", "msMySQLJoinPrepare()");
-    return(MS_FAILURE);
-  }
-
-  if(!shape->values) {
-    msSetError(MS_JOINERR, "Shape to be joined has no attributes.", "msMySQLJoinPrepare()");
-    return(MS_FAILURE);
+  if (!joininfo) {
+    msSetError(MS_JOINERR, "Join connection has not be created.",
+               "msMySQLJoinPrepare()");
+    return (MS_FAILURE);
+  }
+
+  if (!shape) {
+    msSetError(MS_JOINERR, "Shape to be joined is empty.",
+               "msMySQLJoinPrepare()");
+    return (MS_FAILURE);
+  }
+
+  if (!shape->values) {
+    msSetError(MS_JOINERR, "Shape to be joined has no attributes.",
+               "msMySQLJoinPrepare()");
+    return (MS_FAILURE);
   }
 
   joininfo->nextrecord = 0; /* starting with the first record */
 
-  if(joininfo->target) free(joininfo->target); /* clear last target */
+  if (joininfo->target)
+    free(joininfo->target); /* clear last target */
   joininfo->target = msStrdup(shape->values[joininfo->fromindex]);
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 #endif
 }
 
-int msMySQLJoinNext(joinObj *join)
-{
+int msMySQLJoinNext(joinObj *join) {
   (void)join;
 #ifndef USE_MYSQL
-  msSetError(MS_QUERYERR, "MySQL support not available (compile with --with-mysql)", "msMySQLJoinNext()");
-  return(MS_FAILURE);
+  msSetError(MS_QUERYERR,
+             "MySQL support not available (compile with --with-mysql)",
+             "msMySQLJoinNext()");
+  return (MS_FAILURE);
 #else
   int i;
   char qbuf[4000];
   msMySQLJoinInfo *joininfo = join->joininfo;
 
-  if(!joininfo) {
-    msSetError(MS_JOINERR, "Join connection has not be created.", "msMySQLJoinNext()");
-    return(MS_FAILURE);
+  if (!joininfo) {
+    msSetError(MS_JOINERR, "Join connection has not be created.",
+               "msMySQLJoinNext()");
+    return (MS_FAILURE);
   }
 
-  if(!joininfo->target) {
-    msSetError(MS_JOINERR, "No target specified, run msMySQLJoinPrepare() first.", "msMySQLJoinNext()");
-    return(MS_FAILURE);
+  if (!joininfo->target) {
+    msSetError(MS_JOINERR,
+               "No target specified, run msMySQLJoinPrepare() first.",
+               "msMySQLJoinNext()");
+    return (MS_FAILURE);
   }
 
   /* clear any old data */
-  if(join->values) {
+  if (join->values) {
     msFreeCharArray(join->values, join->numitems);
     join->values = NULL;
   }
@@ -746,84 +805,97 @@ int msMySQLJoinNext(joinObj *join)
   /* int n = joininfo->rows; */
 
   /* for(i=joininfo->nextrecord; i<n; i++) { // find a match */
-  /* if(strcmp(joininfo->target, msMySQLReadStringAttribute(joininfo->conn, i, joininfo->toindex)) == 0) break; */
+  /* if(strcmp(joininfo->target, msMySQLReadStringAttribute(joininfo->conn, i,
+   * joininfo->toindex)) == 0) break; */
   /* }   */
-  snprintf(qbuf, sizeof(qbuf), "SELECT * FROM %s WHERE %s = %s", join->table, joininfo->tocolumn, joininfo->target);
+  snprintf(qbuf, sizeof(qbuf), "SELECT * FROM %s WHERE %s = %s", join->table,
+           joininfo->tocolumn, joininfo->target);
   MYDEBUG printf("%s<BR>\n", qbuf);
-  if ((joininfo->qresult = msMySQLQuery(qbuf, joininfo->conn))) { /* There were some rows found, write 'em out for debug */
+  if ((joininfo->qresult =
+           msMySQLQuery(qbuf, joininfo->conn))) { /* There were some rows found,
+                                                     write 'em out for debug */
     int numrows = mysql_affected_rows(joininfo->conn);
     int numfields = mysql_field_count(joininfo->conn);
     MYDEBUG printf("%d rows<br>\n", numrows);
     if (numrows > 0) {
       MYSQL_ROW row = mysql_fetch_row(joininfo->qresult);
-      for(i=0; i<numfields; i++) {
-        MYDEBUG printf("%s,",row[i]);
+      for (i = 0; i < numfields; i++) {
+        MYDEBUG printf("%s,", row[i]);
       }
       MYDEBUG printf("<BR>\n");
       free(join->values);
-      if((join->values = (char **)malloc(sizeof(char *)*join->numitems)) == NULL) {
+      if ((join->values = (char **)malloc(sizeof(char *) * join->numitems)) ==
+          NULL) {
         msSetError(MS_MEMERR, NULL, "msMySQLJoinNext()");
-        return(MS_FAILURE);
+        return (MS_FAILURE);
       }
-      for(i=0; i<join->numitems; i++) {
-        /* join->values[i] = msStrdup("\0"); */ /* intialize to zero length strings */
-        join->values[i] = msStrdup(row[i]); /* intialize to zero length strings */
+      for (i = 0; i < join->numitems; i++) {
+        /* join->values[i] = msStrdup("\0"); */ /* intialize to zero length
+                                                   strings */
+        join->values[i] =
+            msStrdup(row[i]); /* intialize to zero length strings */
         /* rows = atoi(row[0]); */
       }
     } else {
-      if((join->values = (char **)malloc(sizeof(char *)*join->numitems)) == NULL) {
+      if ((join->values = (char **)malloc(sizeof(char *) * join->numitems)) ==
+          NULL) {
         msSetError(MS_MEMERR, NULL, "msMySQLJoinNext()");
-        return(MS_FAILURE);
+        return (MS_FAILURE);
       }
-      for(i=0; i<join->numitems; i++)
-        join->values[i] = msStrdup("\0"); /* intialize to zero length strings  */
+      for (i = 0; i < join->numitems; i++)
+        join->values[i] = msStrdup("\0"); /* intialize to zero length strings */
 
-      return(MS_DONE);
+      return (MS_DONE);
     }
   } else {
     msSetError(MS_QUERYERR, "Query error (%s)", "msMySQLJoinNext()", qbuf);
-    return(MS_FAILURE);
+    return (MS_FAILURE);
   }
 
 #ifdef __NOTDEF__
-  if(i == n) { /* unable to do the join */
-    if((join->values = (char **)malloc(sizeof(char *)*join->numitems)) == NULL) {
+  if (i == n) { /* unable to do the join */
+    if ((join->values = (char **)malloc(sizeof(char *) * join->numitems)) ==
+        NULL) {
       msSetError(MS_MEMERR, NULL, "msMySQLJoinNext()");
-      return(MS_FAILURE);
+      return (MS_FAILURE);
     }
-    for(i=0; i<join->numitems; i++)
+    for (i = 0; i < join->numitems; i++)
       join->values[i] = msStrdup("\0"); /* intialize to zero length strings  */
 
     joininfo->nextrecord = n;
-    return(MS_DONE);
+    return (MS_DONE);
   }
 
-  if((join->values = msMySQLGetValues(joininfo->conn,i)) == NULL)
-    return(MS_FAILURE);
+  if ((join->values = msMySQLGetValues(joininfo->conn, i)) == NULL)
+    return (MS_FAILURE);
 
-  joininfo->nextrecord = i+1; /* so we know where to start looking next time through */
+  joininfo->nextrecord =
+      i + 1; /* so we know where to start looking next time through */
 #endif /* __NOTDEF__ */
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 #endif
 }
 
-int msMySQLJoinClose(joinObj *join)
-{
+int msMySQLJoinClose(joinObj *join) {
   (void)join;
 #ifndef USE_MYSQL
-  msSetError(MS_QUERYERR, "MySQL support not available (compile with --with-mysql)", "msMySQLJoinClose()");
-  return(MS_FAILURE);
+  msSetError(MS_QUERYERR,
+             "MySQL support not available (compile with --with-mysql)",
+             "msMySQLJoinClose()");
+  return (MS_FAILURE);
 #else
   msMySQLJoinInfo *joininfo = join->joininfo;
 
-  if(!joininfo) return(MS_SUCCESS); /* already closed */
+  if (!joininfo)
+    return (MS_SUCCESS); /* already closed */
 
   mysql_close(joininfo->conn);
-  if(joininfo->target) free(joininfo->target);
+  if (joininfo->target)
+    free(joininfo->target);
   free(joininfo);
   joininfo = NULL;
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 #endif
 }
diff -pruN 8.0.1-5/mapkml.cpp 8.0.2-1/mapkml.cpp
--- 8.0.1-5/mapkml.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapkml.cpp	2024-06-11 20:41:34.000000000 +0000
@@ -36,183 +36,166 @@
 extern "C" {
 #endif
 
-  KmlRenderer* getKmlRenderer(imageObj* img)
-  {
-    return (KmlRenderer*) img->img.plugin;
-  }
-
-  imageObj* msCreateImageKml(int width, int height, outputFormatObj *format, colorObj* bg)
-  {
-    imageObj *image = NULL;
-
-    image = (imageObj*)malloc(sizeof(imageObj));
-    MS_CHECK_ALLOC(image, sizeof(imageObj), NULL);
-    memset(image, 0, sizeof(imageObj));
-
-    KmlRenderer *ren = new KmlRenderer(width, height, format, bg);
-    image->img.plugin = (void *) ren;
+KmlRenderer *getKmlRenderer(imageObj *img) {
+  return (KmlRenderer *)img->img.plugin;
+}
 
-    return image;
-  }
+imageObj *msCreateImageKml(int width, int height, outputFormatObj *format,
+                           colorObj *bg) {
+  imageObj *image = NULL;
+
+  image = (imageObj *)malloc(sizeof(imageObj));
+  MS_CHECK_ALLOC(image, sizeof(imageObj), NULL);
+  memset(image, 0, sizeof(imageObj));
 
-  int msSaveImageKml(imageObj *img, mapObj* /*map*/, FILE *fp, outputFormatObj *format)
-  {
-    KmlRenderer* renderer = getKmlRenderer(img);
-    return renderer->saveImage(img, fp, format);
-  }
+  KmlRenderer *ren = new KmlRenderer(width, height, format, bg);
+  image->img.plugin = (void *)ren;
 
-  int msRenderLineKml(imageObj *img, shapeObj *p, strokeStyleObj *style)
-  {
-    KmlRenderer* renderer = getKmlRenderer(img);
-    renderer->renderLine(img, p, style);
-    return MS_SUCCESS;
-  }
+  return image;
+}
 
-  int msRenderPolygonKml(imageObj *img, shapeObj *p, colorObj *color)
-  {
-    KmlRenderer* renderer = getKmlRenderer(img);
-    renderer->renderPolygon(img, p, color);
-    return MS_SUCCESS;
-  }
+int msSaveImageKml(imageObj *img, mapObj * /*map*/, FILE *fp,
+                   outputFormatObj *format) {
+  KmlRenderer *renderer = getKmlRenderer(img);
+  return renderer->saveImage(img, fp, format);
+}
 
-  int msRenderPolygonTiledKml(imageObj * /*img*/, shapeObj * /*p*/,  imageObj * /*tile*/)
-  {
-    /*KmlRenderer* renderer = getKmlRenderer(img);*/
-    return MS_SUCCESS;
-  }
+int msRenderLineKml(imageObj *img, shapeObj *p, strokeStyleObj *style) {
+  KmlRenderer *renderer = getKmlRenderer(img);
+  renderer->renderLine(img, p, style);
+  return MS_SUCCESS;
+}
 
-  int msRenderLineTiledKml(imageObj * /*img*/, shapeObj * /*p*/, imageObj * /*tile*/)
-  {
-    return MS_SUCCESS;
-  }
+int msRenderPolygonKml(imageObj *img, shapeObj *p, colorObj *color) {
+  KmlRenderer *renderer = getKmlRenderer(img);
+  renderer->renderPolygon(img, p, color);
+  return MS_SUCCESS;
+}
 
-  int msRenderGlyphsKml(imageObj *img, const textSymbolObj *ts, colorObj *c, colorObj *oc, int ow, int /*isMarker*/)
-  {
-    KmlRenderer* renderer = getKmlRenderer(img);
-    renderer->renderGlyphs(img, ts, c, oc, ow);
-    return MS_SUCCESS;
-  }
+int msRenderPolygonTiledKml(imageObj * /*img*/, shapeObj * /*p*/,
+                            imageObj * /*tile*/) {
+  /*KmlRenderer* renderer = getKmlRenderer(img);*/
+  return MS_SUCCESS;
+}
 
-  int msRenderVectorSymbolKml(imageObj *img, double x, double y,
-                              symbolObj *symbol, symbolStyleObj *style)
-  {
-    KmlRenderer* renderer = getKmlRenderer(img);
-    renderer->renderVectorSymbol(img, x, y, symbol, style);
-    return MS_SUCCESS;
-  }
+int msRenderLineTiledKml(imageObj * /*img*/, shapeObj * /*p*/,
+                         imageObj * /*tile*/) {
+  return MS_SUCCESS;
+}
 
-  int msRenderPixmapSymbolKml(imageObj *img, double x, double y,
-                              symbolObj *symbol, symbolStyleObj *style)
-  {
-    KmlRenderer* renderer = getKmlRenderer(img);
-    renderer->renderPixmapSymbol(img, x, y, symbol, style);
-    return MS_SUCCESS;
-  }
+int msRenderGlyphsKml(imageObj *img, const textSymbolObj *ts, colorObj *c,
+                      colorObj *oc, int ow, int /*isMarker*/) {
+  KmlRenderer *renderer = getKmlRenderer(img);
+  renderer->renderGlyphs(img, ts, c, oc, ow);
+  return MS_SUCCESS;
+}
 
-  int msRenderEllipseSymbolKml(imageObj *image, double x, double y,
-                               symbolObj *symbol, symbolStyleObj *style)
-  {
-    KmlRenderer* renderer = getKmlRenderer(image);
-    renderer->renderEllipseSymbol(image, x, y, symbol, style);
-    return MS_SUCCESS;
-  }
+int msRenderVectorSymbolKml(imageObj *img, double x, double y,
+                            symbolObj *symbol, symbolStyleObj *style) {
+  KmlRenderer *renderer = getKmlRenderer(img);
+  renderer->renderVectorSymbol(img, x, y, symbol, style);
+  return MS_SUCCESS;
+}
 
-  int msRenderTruetypeSymbolKml(imageObj *image, double x, double y,
-                                symbolObj *symbol, symbolStyleObj *style)
-  {
-    KmlRenderer* renderer = getKmlRenderer(image);
-    renderer->renderTruetypeSymbol(image, x, y, symbol, style);
-    return MS_SUCCESS;
-  }
+int msRenderPixmapSymbolKml(imageObj *img, double x, double y,
+                            symbolObj *symbol, symbolStyleObj *style) {
+  KmlRenderer *renderer = getKmlRenderer(img);
+  renderer->renderPixmapSymbol(img, x, y, symbol, style);
+  return MS_SUCCESS;
+}
 
+int msRenderEllipseSymbolKml(imageObj *image, double x, double y,
+                             symbolObj *symbol, symbolStyleObj *style) {
+  KmlRenderer *renderer = getKmlRenderer(image);
+  renderer->renderEllipseSymbol(image, x, y, symbol, style);
+  return MS_SUCCESS;
+}
 
-  int msRenderTileKml(imageObj * /*img*/, imageObj * /*tile*/, double /*x*/, double /*y*/)
-  {
-    return MS_SUCCESS;
-  }
+int msRenderTruetypeSymbolKml(imageObj *image, double x, double y,
+                              symbolObj *symbol, symbolStyleObj *style) {
+  KmlRenderer *renderer = getKmlRenderer(image);
+  renderer->renderTruetypeSymbol(image, x, y, symbol, style);
+  return MS_SUCCESS;
+}
 
-  int msGetRasterBufferKml(imageObj * /*img*/,rasterBufferObj * /*rb*/)
-  {
-    return MS_FAILURE; //not supported for kml
-  }
+int msRenderTileKml(imageObj * /*img*/, imageObj * /*tile*/, double /*x*/,
+                    double /*y*/) {
+  return MS_SUCCESS;
+}
 
+int msGetRasterBufferKml(imageObj * /*img*/, rasterBufferObj * /*rb*/) {
+  return MS_FAILURE; // not supported for kml
+}
 
-  int msGetTruetypeTextBBoxKml(rendererVTableObj * /*r*/,char** /*fonts*/, int /*numfonts*/, double size, char *string,
-                               rectObj *rect, double **advances, int /*bAdjustBaseline*/)
-  {
-    rect->minx=0.0;
-    rect->maxx=0.0;
-    rect->miny=0.0;
-    rect->maxy=0.0;
-    if (advances) {
-      int numglyphs = msGetNumGlyphs(string);
-      *advances = (double*) msSmallMalloc(numglyphs * sizeof (double));
-      for(int i=0; i<numglyphs; i++) {
-        (*advances)[i] = size;
-      }
+int msGetTruetypeTextBBoxKml(rendererVTableObj * /*r*/, char ** /*fonts*/,
+                             int /*numfonts*/, double size, char *string,
+                             rectObj *rect, double **advances,
+                             int /*bAdjustBaseline*/) {
+  rect->minx = 0.0;
+  rect->maxx = 0.0;
+  rect->miny = 0.0;
+  rect->maxy = 0.0;
+  if (advances) {
+    int numglyphs = msGetNumGlyphs(string);
+    *advances = (double *)msSmallMalloc(numglyphs * sizeof(double));
+    for (int i = 0; i < numglyphs; i++) {
+      (*advances)[i] = size;
     }
-    return MS_SUCCESS;
   }
+  return MS_SUCCESS;
+}
 
-  int msStartNewLayerKml(imageObj *img, mapObj * /*map*/, layerObj *layer)
-  {
-    KmlRenderer* renderer = getKmlRenderer(img);
-    return renderer->startNewLayer(img, layer);
-  }
+int msStartNewLayerKml(imageObj *img, mapObj * /*map*/, layerObj *layer) {
+  KmlRenderer *renderer = getKmlRenderer(img);
+  return renderer->startNewLayer(img, layer);
+}
 
-  int msCloseNewLayerKml(imageObj *img, mapObj * /*map*/, layerObj *layer)
-  {
-    KmlRenderer* renderer = getKmlRenderer(img);
-    return renderer->closeNewLayer(img, layer);
-  }
+int msCloseNewLayerKml(imageObj *img, mapObj * /*map*/, layerObj *layer) {
+  KmlRenderer *renderer = getKmlRenderer(img);
+  return renderer->closeNewLayer(img, layer);
+}
 
-  int msFreeImageKml(imageObj *image)
-  {
-    KmlRenderer* renderer = getKmlRenderer(image);
-    if (renderer) {
-      delete renderer;
-    }
-    image->img.plugin=NULL;
-    return MS_SUCCESS;
+int msFreeImageKml(imageObj *image) {
+  KmlRenderer *renderer = getKmlRenderer(image);
+  if (renderer) {
+    delete renderer;
   }
+  image->img.plugin = NULL;
+  return MS_SUCCESS;
+}
 
-  int msFreeSymbolKml(symbolObj * /*symbol*/)
-  {
-    return MS_SUCCESS;
-  }
+int msFreeSymbolKml(symbolObj * /*symbol*/) { return MS_SUCCESS; }
 
-  int msStartShapeKml(imageObj *img, shapeObj *shape)
-  {
-    KmlRenderer* renderer = getKmlRenderer(img);
-    renderer->startShape(img, shape);
-    return MS_SUCCESS;
-  }
+int msStartShapeKml(imageObj *img, shapeObj *shape) {
+  KmlRenderer *renderer = getKmlRenderer(img);
+  renderer->startShape(img, shape);
+  return MS_SUCCESS;
+}
 
-  int msEndShapeKml(imageObj *img, shapeObj *shape)
-  {
-    KmlRenderer* renderer = getKmlRenderer(img);
-    renderer->endShape(img, shape);
-    return MS_SUCCESS;
-  }
+int msEndShapeKml(imageObj *img, shapeObj *shape) {
+  KmlRenderer *renderer = getKmlRenderer(img);
+  renderer->endShape(img, shape);
+  return MS_SUCCESS;
+}
 
-  int msMergeRasterBufferKml(imageObj *dest, rasterBufferObj *overlay, double /*opacity*/, int /*srcX*/,
-                             int /*srcY*/, int /*dstX*/, int /*dstY*/, int /*width*/, int /*height*/)
-  {
-    KmlRenderer* renderer = getKmlRenderer(dest);
-    return renderer->mergeRasterBuffer(dest,overlay);
-  }
+int msMergeRasterBufferKml(imageObj *dest, rasterBufferObj *overlay,
+                           double /*opacity*/, int /*srcX*/, int /*srcY*/,
+                           int /*dstX*/, int /*dstY*/, int /*width*/,
+                           int /*height*/) {
+  KmlRenderer *renderer = getKmlRenderer(dest);
+  return renderer->mergeRasterBuffer(dest, overlay);
+}
 
 #ifdef __cplusplus
 }
 #endif
 
-
 #endif /*USE_KML*/
 
-int aggInitializeRasterBuffer(rasterBufferObj *rb, int width, int height, int mode);
+int aggInitializeRasterBuffer(rasterBufferObj *rb, int width, int height,
+                              int mode);
 
-int msPopulateRendererVTableKML( rendererVTableObj *renderer )
-{
+int msPopulateRendererVTableKML(rendererVTableObj *renderer) {
 #ifdef USE_KML
   renderer->supports_pixel_buffer = 0;
   renderer->supports_clipping = 0;
@@ -221,11 +204,11 @@ int msPopulateRendererVTableKML( rendere
 
   renderer->startLayer = msStartNewLayerKml;
   renderer->endLayer = msCloseNewLayerKml;
-  renderer->renderLine=&msRenderLineKml;
-  renderer->createImage=&msCreateImageKml;
-  renderer->saveImage=&msSaveImageKml;
-  renderer->renderPolygon=&msRenderPolygonKml;
-  renderer->renderGlyphs=&msRenderGlyphsKml;
+  renderer->renderLine = &msRenderLineKml;
+  renderer->createImage = &msCreateImageKml;
+  renderer->saveImage = &msSaveImageKml;
+  renderer->renderPolygon = &msRenderPolygonKml;
+  renderer->renderGlyphs = &msRenderGlyphsKml;
   renderer->renderEllipseSymbol = &msRenderEllipseSymbolKml;
   renderer->renderVectorSymbol = &msRenderVectorSymbolKml;
   renderer->renderPixmapSymbol = &msRenderPixmapSymbolKml;
@@ -236,12 +219,12 @@ int msPopulateRendererVTableKML( rendere
   renderer->renderPolygonTiled = &msRenderPolygonTiledKml;
   renderer->renderLineTiled = NULL;
   renderer->freeSymbol = &msFreeSymbolKml;
-  renderer->freeImage=&msFreeImageKml;
+  renderer->freeImage = &msFreeImageKml;
   renderer->mergeRasterBuffer = msMergeRasterBufferKml;
   renderer->compositeRasterBuffer = NULL;
 
-  renderer->startShape=&msStartShapeKml;
-  renderer->endShape=&msEndShapeKml;
+  renderer->startShape = &msStartShapeKml;
+  renderer->endShape = &msEndShapeKml;
 
   return MS_SUCCESS;
 #else
@@ -250,4 +233,3 @@ int msPopulateRendererVTableKML( rendere
   return MS_FAILURE;
 #endif
 }
-
diff -pruN 8.0.1-5/mapkmlrenderer.cpp 8.0.2-1/mapkmlrenderer.cpp
--- 8.0.1-5/mapkmlrenderer.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapkmlrenderer.cpp	2024-06-11 20:41:34.000000000 +0000
@@ -39,22 +39,25 @@
 #include "cpl_conv.h"
 #include "cpl_vsi.h"
 
-#define  KML_MAXFEATURES_TODRAW 1000
+#define KML_MAXFEATURES_TODRAW 1000
 
-KmlRenderer::KmlRenderer(int width, int height, outputFormatObj * /*format*/, colorObj* /*color*/)
-  : Width(width), Height(height), MapCellsize(1.0), XmlDoc(NULL), LayerNode(NULL), GroundOverlayNode(NULL),
-    PlacemarkNode(NULL), GeomNode(NULL),
-    Items(NULL), NumItems(0), FirstLayer(MS_TRUE), map(NULL), currentLayer(NULL),
-    mElevationFromAttribute( false ), mElevationAttributeIndex( -1 ), mCurrentElevationValue(0.0)
+KmlRenderer::KmlRenderer(int width, int height, outputFormatObj * /*format*/,
+                         colorObj * /*color*/)
+    : Width(width), Height(height), MapCellsize(1.0), XmlDoc(NULL),
+      LayerNode(NULL), GroundOverlayNode(NULL), PlacemarkNode(NULL),
+      GeomNode(NULL), Items(NULL), NumItems(0), FirstLayer(MS_TRUE), map(NULL),
+      currentLayer(NULL), mElevationFromAttribute(false),
+      mElevationAttributeIndex(-1), mCurrentElevationValue(0.0)
 
 {
   /*private variables*/
   pszLayerDescMetadata = NULL;
   papszLayerIncludeItems = NULL;
-  nIncludeItems=0;
+  nIncludeItems = 0;
   papszLayerExcludeItems = NULL;
-  nExcludeItems=0;
-  pszLayerNameAttributeMetadata = NULL;  /*metadata to use for a name for each feature*/
+  nExcludeItems = 0;
+  pszLayerNameAttributeMetadata =
+      NULL; /*metadata to use for a name for each feature*/
 
   LineStyle = NULL;
   numLineStyle = 0;
@@ -67,7 +70,8 @@ KmlRenderer::KmlRenderer(int width, int
   xmlNodePtr rootNode = xmlNewNode(NULL, BAD_CAST "kml");
 
   /*  Name spaces*/
-  xmlSetNs(rootNode, xmlNewNs(rootNode, BAD_CAST "http://www.opengis.net/kml/2.2", NULL));
+  xmlSetNs(rootNode,
+           xmlNewNs(rootNode, BAD_CAST "http://www.opengis.net/kml/2.2", NULL));
 
   xmlDocSetRootElement(XmlDoc, rootNode);
 
@@ -79,46 +83,45 @@ KmlRenderer::KmlRenderer(int width, int
   xmlNewChild(listStyleNode, NULL, BAD_CAST "listItemType", BAD_CAST "check");
 
   styleNode = xmlNewChild(DocNode, NULL, BAD_CAST "Style", NULL);
-  xmlNewProp(styleNode, BAD_CAST "id", BAD_CAST "LayerFolder_checkHideChildren");
+  xmlNewProp(styleNode, BAD_CAST "id",
+             BAD_CAST "LayerFolder_checkHideChildren");
   listStyleNode = xmlNewChild(styleNode, NULL, BAD_CAST "ListStyle", NULL);
-  xmlNewChild(listStyleNode, NULL, BAD_CAST "listItemType", BAD_CAST "checkHideChildren");
+  xmlNewChild(listStyleNode, NULL, BAD_CAST "listItemType",
+              BAD_CAST "checkHideChildren");
 
   styleNode = xmlNewChild(DocNode, NULL, BAD_CAST "Style", NULL);
   xmlNewProp(styleNode, BAD_CAST "id", BAD_CAST "LayerFolder_checkOffOnly");
   listStyleNode = xmlNewChild(styleNode, NULL, BAD_CAST "ListStyle", NULL);
-  xmlNewChild(listStyleNode, NULL, BAD_CAST "listItemType", BAD_CAST "checkOffOnly");
+  xmlNewChild(listStyleNode, NULL, BAD_CAST "listItemType",
+              BAD_CAST "checkOffOnly");
 
   styleNode = xmlNewChild(DocNode, NULL, BAD_CAST "Style", NULL);
   xmlNewProp(styleNode, BAD_CAST "id", BAD_CAST "LayerFolder_radioFolder");
   listStyleNode = xmlNewChild(styleNode, NULL, BAD_CAST "ListStyle", NULL);
-  xmlNewChild(listStyleNode, NULL, BAD_CAST "listItemType", BAD_CAST "radioFolder");
-
+  xmlNewChild(listStyleNode, NULL, BAD_CAST "listItemType",
+              BAD_CAST "radioFolder");
 
   StyleHashTable = msCreateHashTable();
-
 }
 
-KmlRenderer::~KmlRenderer()
-{
+KmlRenderer::~KmlRenderer() {
   if (XmlDoc)
     xmlFreeDoc(XmlDoc);
 
   if (StyleHashTable)
     msFreeHashTable(StyleHashTable);
 
-  if(LineStyle)
+  if (LineStyle)
     msFree(LineStyle);
 
   xmlCleanupParser();
 }
 
-imageObj* KmlRenderer::createImage(int, int, outputFormatObj*, colorObj*)
-{
+imageObj *KmlRenderer::createImage(int, int, outputFormatObj *, colorObj *) {
   return NULL;
 }
 
-int KmlRenderer::saveImage(imageObj *, FILE *fp, outputFormatObj *format)
-{
+int KmlRenderer::saveImage(imageObj *, FILE *fp, outputFormatObj *format) {
   /* -------------------------------------------------------------------- */
   /*      Write out the document.                                         */
   /* -------------------------------------------------------------------- */
@@ -129,7 +132,7 @@ int KmlRenderer::saveImage(imageObj *, F
   int chunkSize = 4096;
   int bZip = MS_FALSE;
 
-  if( msIO_needBinaryStdout() == MS_FAILURE )
+  if (msIO_needBinaryStdout() == MS_FAILURE)
     return MS_FAILURE;
 
   xmlDocDumpFormatMemoryEnc(XmlDoc, &buf, &bufSize, "UTF-8", 1);
@@ -142,63 +145,60 @@ int KmlRenderer::saveImage(imageObj *, F
     VSILFILE *fpZip;
     int bytes_read;
     char buffer[1024];
-    char *zip_filename =NULL;
-    void *hZip=NULL;
+    char *zip_filename = NULL;
+    void *hZip = NULL;
 
-    zip_filename = msTmpFile(NULL, NULL, "/vsimem/kmlzip/", "kmz" );
-    hZip = CPLCreateZip( zip_filename, NULL );
-    CPLCreateFileInZip( hZip, "mapserver.kml", NULL );
-    for (int i=0; i<bufSize; i+=chunkSize) {
+    zip_filename = msTmpFile(NULL, NULL, "/vsimem/kmlzip/", "kmz");
+    hZip = CPLCreateZip(zip_filename, NULL);
+    CPLCreateFileInZip(hZip, "mapserver.kml", NULL);
+    for (int i = 0; i < bufSize; i += chunkSize) {
       int size = chunkSize;
       if (i + size > bufSize)
         size = bufSize - i;
-      CPLWriteFileInZip( hZip,  buf+i, size);
+      CPLWriteFileInZip(hZip, buf + i, size);
     }
-    CPLCloseFileInZip( hZip );
-    CPLCloseZip( hZip );
+    CPLCloseFileInZip(hZip);
+    CPLCloseZip(hZip);
 
     context = msIO_getHandler(fp);
-    fpZip = VSIFOpenL( zip_filename, "r" );
+    fpZip = VSIFOpenL(zip_filename, "r");
 
-    while( (bytes_read = VSIFReadL( buffer, 1, sizeof(buffer), fpZip )) > 0 ) {
+    while ((bytes_read = VSIFReadL(buffer, 1, sizeof(buffer), fpZip)) > 0) {
       if (context)
         msIO_contextWrite(context, buffer, bytes_read);
       else
-        msIO_fwrite( buffer, 1, bytes_read, fp );
+        msIO_fwrite(buffer, 1, bytes_read, fp);
     }
-    VSIFCloseL( fpZip );
-    msFree( zip_filename);
+    VSIFCloseL(fpZip);
+    msFree(zip_filename);
     xmlFree(buf);
-    return(MS_SUCCESS);
+    return (MS_SUCCESS);
   }
 
   context = msIO_getHandler(fp);
 
-
-  for (int i=0; i<bufSize; i+=chunkSize) {
+  for (int i = 0; i < bufSize; i += chunkSize) {
     int size = chunkSize;
     if (i + size > bufSize)
       size = bufSize - i;
 
     if (context)
-      msIO_contextWrite(context, buf+i, size);
+      msIO_contextWrite(context, buf + i, size);
     else
-      msIO_fwrite(buf+i, 1, size, fp);
+      msIO_fwrite(buf + i, 1, size, fp);
   }
 
   xmlFree(buf);
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
-
 /************************************************************************/
 /*                               processLayer                           */
 /*                                                                      */
 /*      Set parameters that make sense to a kml output.                 */
 /************************************************************************/
-void KmlRenderer::processLayer(layerObj *layer, outputFormatObj *format)
-{
+void KmlRenderer::processLayer(layerObj *layer, outputFormatObj *format) {
   int i;
   const char *asRaster = NULL;
   int nMaxFeatures = -1;
@@ -213,29 +213,30 @@ void KmlRenderer::processLayer(layerObj
 
   /*if there are labels we want the coordinates to
     be the center of the element.*/
-  for(i=0; i<layer->numclasses; i++)
-    if(layer->_class[i]->numlabels > 0) layer->_class[i]->labels[0]->position = MS_XY;
+  for (i = 0; i < layer->numclasses; i++)
+    if (layer->_class[i]->numlabels > 0)
+      layer->_class[i]->labels[0]->position = MS_XY;
 
   /*we do not want to draw multiple styles.
     the new rendering architecture does not allow
     to know if we are dealing with a multi-style.
     So here we remove all styles beside the first one*/
 
-  for(i=0; i<layer->numclasses; i++) {
+  for (i = 0; i < layer->numclasses; i++) {
     while (layer->_class[i]->numstyles > 1)
-      msDeleteStyle(layer->_class[i], layer->_class[i]->numstyles-1);
+      msDeleteStyle(layer->_class[i], layer->_class[i]->numstyles - 1);
   }
 
-  /*if layer has a metadata KML_OUTPUTASRASTER set to true, add a processing directive
-    to use an agg driver*/
+  /*if layer has a metadata KML_OUTPUTASRASTER set to true, add a processing
+    directive to use an agg driver*/
   asRaster = msLookupHashTable(&layer->metadata, "kml_outputasraster");
   if (!asRaster)
-    asRaster = msLookupHashTable(&(layer->map->web.metadata), "kml_outputasraster");
-  if (asRaster && (strcasecmp(asRaster, "true") == 0 ||
-                   strcasecmp(asRaster, "yes") == 0))
+    asRaster =
+        msLookupHashTable(&(layer->map->web.metadata), "kml_outputasraster");
+  if (asRaster &&
+      (strcasecmp(asRaster, "true") == 0 || strcasecmp(asRaster, "yes") == 0))
     msLayerAddProcessing(layer, "RENDERER=png24");
 
-
   /*set a maxfeaturestodraw, if not already set*/
 
   pszTmp = msLookupHashTable(&layer->metadata, "maxfeaturestodraw");
@@ -247,13 +248,13 @@ void KmlRenderer::processLayer(layerObj
       nMaxFeatures = atoi(pszTmp);
   }
   if (nMaxFeatures < 0 && format)
-    nMaxFeatures = atoi(msGetOutputFormatOption( format, "maxfeaturestodraw", "-1"));
+    nMaxFeatures =
+        atoi(msGetOutputFormatOption(format, "maxfeaturestodraw", "-1"));
 
   if (nMaxFeatures < 0 && format) {
     snprintf(szTmp, sizeof(szTmp), "%d", KML_MAXFEATURES_TODRAW);
-    msSetOutputFormatOption( format, "maxfeaturestodraw", szTmp);
+    msSetOutputFormatOption(format, "maxfeaturestodraw", szTmp);
   }
-
 }
 
 /************************************************************************/
@@ -261,15 +262,14 @@ void KmlRenderer::processLayer(layerObj
 /*                                                                      */
 /*      Internal utility function to build name used fo rthe layer.     */
 /************************************************************************/
-char* KmlRenderer::getLayerName(layerObj *layer)
-{
+char *KmlRenderer::getLayerName(layerObj *layer) {
   char stmp[20];
-  const char *name=NULL;;
+  const char *name = NULL;
+  ;
 
   if (!layer)
     return NULL;
 
-
   name = msLookupHashTable(&layer->metadata, "ows_name");
   if (name && strlen(name) > 0)
     return msStrdup(name);
@@ -277,13 +277,12 @@ char* KmlRenderer::getLayerName(layerObj
   if (layer->name && strlen(layer->name) > 0)
     return msStrdup(layer->name);
 
-  sprintf(stmp, "Layer%d",layer->index);
+  sprintf(stmp, "Layer%d", layer->index);
   return msStrdup(stmp);
-
 }
 
-const char* KmlRenderer::getAliasName(layerObj *lp, char *pszItemName, const char *namespaces)
-{
+const char *KmlRenderer::getAliasName(layerObj *lp, char *pszItemName,
+                                      const char *namespaces) {
   const char *pszAlias = NULL;
   if (lp && pszItemName && strlen(pszItemName) > 0) {
     char szTmp[256];
@@ -293,10 +292,9 @@ const char* KmlRenderer::getAliasName(la
   return pszAlias;
 }
 
-int KmlRenderer::startNewLayer(imageObj *img, layerObj *layer)
-{
-  char *layerName=NULL;
-  const char *value=NULL;
+int KmlRenderer::startNewLayer(imageObj *img, layerObj *layer) {
+  char *layerName = NULL;
+  const char *value = NULL;
 
   LayerNode = xmlNewNode(NULL, BAD_CAST "Folder");
 
@@ -307,25 +305,31 @@ int KmlRenderer::startNewLayer(imageObj
   const char *layerVisibility = layer->status != MS_OFF ? "1" : "0";
   xmlNewChild(LayerNode, NULL, BAD_CAST "visibility", BAD_CAST layerVisibility);
 
-  const char *layerDsiplayFolder = msLookupHashTable(&(layer->metadata), "kml_folder_display");
+  const char *layerDsiplayFolder =
+      msLookupHashTable(&(layer->metadata), "kml_folder_display");
   if (layerDsiplayFolder == NULL)
-    layerDsiplayFolder = msLookupHashTable(&(layer->map->web.metadata), "kml_folder_display");
-  if (!layerDsiplayFolder || strlen(layerDsiplayFolder)<=0) {
-    xmlNewChild(LayerNode, NULL, BAD_CAST "styleUrl", BAD_CAST "#LayerFolder_check");
+    layerDsiplayFolder =
+        msLookupHashTable(&(layer->map->web.metadata), "kml_folder_display");
+  if (!layerDsiplayFolder || strlen(layerDsiplayFolder) <= 0) {
+    xmlNewChild(LayerNode, NULL, BAD_CAST "styleUrl",
+                BAD_CAST "#LayerFolder_check");
   }
 
   else {
     if (strcasecmp(layerDsiplayFolder, "checkHideChildren") == 0)
-      xmlNewChild(LayerNode, NULL, BAD_CAST "styleUrl", BAD_CAST "#LayerFolder_checkHideChildren");
+      xmlNewChild(LayerNode, NULL, BAD_CAST "styleUrl",
+                  BAD_CAST "#LayerFolder_checkHideChildren");
     else if (strcasecmp(layerDsiplayFolder, "checkOffOnly") == 0)
-      xmlNewChild(LayerNode, NULL, BAD_CAST "styleUrl", BAD_CAST "#LayerFolder_checkOffOnly");
+      xmlNewChild(LayerNode, NULL, BAD_CAST "styleUrl",
+                  BAD_CAST "#LayerFolder_checkOffOnly");
     else if (strcasecmp(layerDsiplayFolder, "radioFolder") == 0)
-      xmlNewChild(LayerNode, NULL, BAD_CAST "styleUrl", BAD_CAST "#LayerFolder_radioFolder");
+      xmlNewChild(LayerNode, NULL, BAD_CAST "styleUrl",
+                  BAD_CAST "#LayerFolder_radioFolder");
     else
-      xmlNewChild(LayerNode, NULL, BAD_CAST "styleUrl", BAD_CAST "#LayerFolder_check");
+      xmlNewChild(LayerNode, NULL, BAD_CAST "styleUrl",
+                  BAD_CAST "#LayerFolder_check");
   }
 
-
   /*Init few things on the first layer*/
   if (FirstLayer) {
     FirstLayer = MS_FALSE;
@@ -338,9 +342,10 @@ int KmlRenderer::startNewLayer(imageObj
     checkProjection(layer->map);
 
     /*check for image path and image url*/
-    if (layer->map->debug && (layer->map->web.imageurl == NULL ||   layer->map->web.imagepath == NULL))
-      msDebug("KmlRenderer::startNewLayer: imagepath and imageurl should be set in the web object\n");
-
+    if (layer->map->debug &&
+        (layer->map->web.imageurl == NULL || layer->map->web.imagepath == NULL))
+      msDebug("KmlRenderer::startNewLayer: imagepath and imageurl should be "
+              "set in the web object\n");
 
     /*map rect for ground overlay*/
     MapExtent = layer->map->extent;
@@ -348,16 +353,16 @@ int KmlRenderer::startNewLayer(imageObj
     BgColor = layer->map->imagecolor;
 
     xmlNewChild(DocNode, NULL, BAD_CAST "name", BAD_CAST layer->map->name);
-    aggFormat = msSelectOutputFormat( layer->map, "png24");
+    aggFormat = msSelectOutputFormat(layer->map, "png24");
     aggFormat->transparent = MS_TRUE;
-
   }
 
   currentLayer = layer;
 
   if (!msLayerIsOpen(layer)) {
     if (msLayerOpen(layer) != MS_SUCCESS) {
-      msSetError(MS_MISCERR, "msLayerOpen failed", "KmlRenderer::startNewLayer" );
+      msSetError(MS_MISCERR, "msLayerOpen failed",
+                 "KmlRenderer::startNewLayer");
       return MS_FAILURE;
     }
   }
@@ -369,45 +374,46 @@ int KmlRenderer::startNewLayer(imageObj
     processLayer(layer, NULL);
 
   if (msLookupHashTable(&layer->metadata, "kml_description"))
-    pszLayerDescMetadata = msLookupHashTable(&layer->metadata, "kml_description");
+    pszLayerDescMetadata =
+        msLookupHashTable(&layer->metadata, "kml_description");
   else if (msLookupHashTable(&layer->metadata, "ows_description"))
-    pszLayerDescMetadata = msLookupHashTable(&layer->metadata, "ows_description");
+    pszLayerDescMetadata =
+        msLookupHashTable(&layer->metadata, "ows_description");
 
-  value=msLookupHashTable(&layer->metadata, "kml_include_items");
+  value = msLookupHashTable(&layer->metadata, "kml_include_items");
   if (!value)
-    value=msLookupHashTable(&layer->metadata, "ows_include_items");
+    value = msLookupHashTable(&layer->metadata, "ows_include_items");
   if (value)
     papszLayerIncludeItems = msStringSplit(value, ',', &nIncludeItems);
 
-  value=msLookupHashTable(&layer->metadata, "kml_exclude_items");
+  value = msLookupHashTable(&layer->metadata, "kml_exclude_items");
   if (!value)
-    value=msLookupHashTable(&layer->metadata, "ows_exclude_items");
+    value = msLookupHashTable(&layer->metadata, "ows_exclude_items");
   if (value)
     papszLayerExcludeItems = msStringSplit(value, ',', &nExcludeItems);
 
-
   if (msLookupHashTable(&layer->metadata, "kml_name_item"))
-    pszLayerNameAttributeMetadata = msLookupHashTable(&layer->metadata, "kml_name_item");
+    pszLayerNameAttributeMetadata =
+        msLookupHashTable(&layer->metadata, "kml_name_item");
 
   /*get all attributes*/
-  if(msLayerWhichItems(layer, MS_TRUE, NULL) != MS_SUCCESS) {
+  if (msLayerWhichItems(layer, MS_TRUE, NULL) != MS_SUCCESS) {
     return MS_FAILURE;
   }
 
-
   NumItems = layer->numitems;
   if (NumItems) {
     Items = (char **)msSmallCalloc(NumItems, sizeof(char *));
-    for (int i=0; i<NumItems; i++)
+    for (int i = 0; i < NumItems; i++)
       Items[i] = msStrdup(layer->items[i]);
   }
 
-
-  const char* elevationAttribute = msLookupHashTable(&layer->metadata, "kml_elevation_attribute");
-  if( elevationAttribute ) {
+  const char *elevationAttribute =
+      msLookupHashTable(&layer->metadata, "kml_elevation_attribute");
+  if (elevationAttribute) {
     mElevationFromAttribute = true;
-    for( int i = 0; i < layer->numitems; ++i ) {
-      if( strcasecmp( layer->items[i], elevationAttribute ) == 0 ) {
+    for (int i = 0; i < layer->numitems; ++i) {
+      if (strcasecmp(layer->items[i], elevationAttribute) == 0) {
         mElevationAttributeIndex = i;
       }
     }
@@ -417,13 +423,12 @@ int KmlRenderer::startNewLayer(imageObj
   return MS_SUCCESS;
 }
 
-int KmlRenderer::closeNewLayer(imageObj *, layerObj *)
-{
+int KmlRenderer::closeNewLayer(imageObj *, layerObj *) {
   flushPlacemark();
 
   xmlAddChild(DocNode, LayerNode);
 
-  if(Items) {
+  if (Items) {
     msFreeCharArray(Items, NumItems);
     Items = NULL;
     NumItems = 0;
@@ -434,33 +439,32 @@ int KmlRenderer::closeNewLayer(imageObj
   if (pszLayerNameAttributeMetadata)
     pszLayerNameAttributeMetadata = NULL;
 
-  if (papszLayerIncludeItems && nIncludeItems>0)
+  if (papszLayerIncludeItems && nIncludeItems > 0)
     msFreeCharArray(papszLayerIncludeItems, nIncludeItems);
-  papszLayerIncludeItems=NULL;
+  papszLayerIncludeItems = NULL;
 
-  if (papszLayerExcludeItems && nExcludeItems>0)
+  if (papszLayerExcludeItems && nExcludeItems > 0)
     msFreeCharArray(papszLayerExcludeItems, nExcludeItems);
-  papszLayerExcludeItems=NULL;
+  papszLayerExcludeItems = NULL;
 
   return MS_SUCCESS;
 }
 
-int KmlRenderer::mergeRasterBuffer(imageObj *image, rasterBufferObj *rb)
-{
+int KmlRenderer::mergeRasterBuffer(imageObj *image, rasterBufferObj *rb) {
   assert(rb && rb->type == MS_BUFFER_BYTE_RGBA);
   char *tmpFileName = NULL;
   char *tmpUrl = NULL;
   FILE *tmpFile = NULL;
 
   tmpFileName = msTmpFile(NULL, MapPath, image->imagepath, "png");
-  tmpFile = fopen(tmpFileName,"wb");
+  tmpFile = fopen(tmpFileName, "wb");
   if (tmpFile) {
 
     if (!aggFormat->vtable)
       msInitializeRendererVTable(aggFormat);
 
-    msSaveRasterBuffer(map,rb,tmpFile,aggFormat);
-    tmpUrl = msStrdup( image->imageurl);
+    msSaveRasterBuffer(map, rb, tmpFile, aggFormat);
+    tmpUrl = msStrdup(image->imageurl);
     tmpUrl = msStringConcatenate(tmpUrl, (char *)(msGetBasename(tmpFileName)));
     tmpUrl = msStringConcatenate(tmpUrl, ".png");
 
@@ -470,24 +474,25 @@ int KmlRenderer::mergeRasterBuffer(image
     fclose(tmpFile);
     return MS_SUCCESS;
   } else {
-    msSetError(MS_IOERR,"Failed to create file for kml overlay","KmlRenderer::mergeRasterBuffer()");
+    msSetError(MS_IOERR, "Failed to create file for kml overlay",
+               "KmlRenderer::mergeRasterBuffer()");
     return MS_FAILURE;
   }
 }
 
-void KmlRenderer::setupRenderingParams(hashTableObj *layerMetadata)
-{
+void KmlRenderer::setupRenderingParams(hashTableObj *layerMetadata) {
   AltitudeMode = 0;
   Extrude = 0;
   Tessellate = 0;
 
-  const char *altitudeModeVal = msLookupHashTable(layerMetadata, "kml_altitudeMode");
+  const char *altitudeModeVal =
+      msLookupHashTable(layerMetadata, "kml_altitudeMode");
   if (altitudeModeVal) {
-    if(strcasecmp(altitudeModeVal, "absolute") == 0)
+    if (strcasecmp(altitudeModeVal, "absolute") == 0)
       AltitudeMode = absolute;
-    else if(strcasecmp(altitudeModeVal, "relativeToGround") == 0)
+    else if (strcasecmp(altitudeModeVal, "relativeToGround") == 0)
       AltitudeMode = relativeToGround;
-    else if(strcasecmp(altitudeModeVal, "clampToGround") == 0)
+    else if (strcasecmp(altitudeModeVal, "clampToGround") == 0)
       AltitudeMode = clampToGround;
   }
 
@@ -496,31 +501,31 @@ void KmlRenderer::setupRenderingParams(h
     Extrude = atoi(extrudeVal);
   }
 
-  const char *tessellateVal = msLookupHashTable(layerMetadata, "kml_tessellate");
+  const char *tessellateVal =
+      msLookupHashTable(layerMetadata, "kml_tessellate");
   if (tessellateVal) {
     Tessellate = atoi(tessellateVal);
   }
-
 }
 
-int KmlRenderer::checkProjection(mapObj *map)
-{
-  projectionObj *projection= &map->projection;
-  if (projection && projection->numargs > 0 && msProjIsGeographicCRS(projection)) {
+int KmlRenderer::checkProjection(mapObj *map) {
+  projectionObj *projection = &map->projection;
+  if (projection && projection->numargs > 0 &&
+      msProjIsGeographicCRS(projection)) {
     return MS_SUCCESS;
   } else {
     char epsg_string[100];
     rectObj sRect;
     projectionObj out;
 
-    /* for layer the do not have any projection set, set them with the current map
-       projection*/
+    /* for layer the do not have any projection set, set them with the current
+       map projection*/
     if (projection && projection->numargs > 0) {
       layerObj *lp = NULL;
-      int i =0;
+      int i = 0;
       char *pszMapProjectString = msGetProjectionString(projection);
       if (pszMapProjectString) {
-        for(i=0; i<map->numlayers; i++) {
+        for (i = 0; i < map->numlayers; i++) {
           lp = GET_LAYER(map, i);
           if (lp->projection.numargs == 0 && lp->transform == MS_TRUE) {
             msFreeProjection(&lp->projection);
@@ -530,7 +535,7 @@ int KmlRenderer::checkProjection(mapObj
         msFree(pszMapProjectString);
       }
     }
-    strcpy(epsg_string, "epsg:4326" );
+    strcpy(epsg_string, "epsg:4326");
     msInitProjection(&out);
     msProjectionInheritContextFrom(&out, projection);
     msLoadProjectionString(&out, epsg_string);
@@ -544,22 +549,24 @@ int KmlRenderer::checkProjection(mapObj
     map->extent = sRect;
     map->units = MS_DD;
 
-
     if (map->debug)
-      msDebug("KmlRenderer::checkProjection: Mapfile projection set to epsg:4326\n");
+      msDebug("KmlRenderer::checkProjection: Mapfile projection set to "
+              "epsg:4326\n");
 
     return MS_SUCCESS;
   }
 }
 
-xmlNodePtr KmlRenderer::createPlacemarkNode(xmlNodePtr parentNode, char *styleUrl)
-{
-  xmlNodePtr placemarkNode = xmlNewChild(parentNode, NULL, BAD_CAST "Placemark", NULL);
+xmlNodePtr KmlRenderer::createPlacemarkNode(xmlNodePtr parentNode,
+                                            char *styleUrl) {
+  xmlNodePtr placemarkNode =
+      xmlNewChild(parentNode, NULL, BAD_CAST "Placemark", NULL);
   /*always add a name. It will be replaced by a text value if available*/
   char tmpid[100];
-  char *stmp=NULL, *layerName=NULL;
-  if (CurrentShapeName && strlen(CurrentShapeName)>0) {
-    xmlNewChild(placemarkNode, NULL, BAD_CAST "name", BAD_CAST CurrentShapeName);
+  char *stmp = NULL, *layerName = NULL;
+  if (CurrentShapeName && strlen(CurrentShapeName) > 0) {
+    xmlNewChild(placemarkNode, NULL, BAD_CAST "name",
+                BAD_CAST CurrentShapeName);
   } else {
     sprintf(tmpid, ".%d", CurrentShapeIndex);
     layerName = getLayerName(currentLayer);
@@ -575,8 +582,7 @@ xmlNodePtr KmlRenderer::createPlacemarkN
   return placemarkNode;
 }
 
-void KmlRenderer::renderLine(imageObj*, shapeObj *p, strokeStyleObj *style)
-{
+void KmlRenderer::renderLine(imageObj *, shapeObj *p, strokeStyleObj *style) {
   if (p->numlines == 0)
     return;
 
@@ -599,8 +605,9 @@ void KmlRenderer::renderLine(imageObj*,
     /* more than one line => MultiGeometry*/
     if (p->numlines > 1) {
       geomNode = getGeomParentNode("LineString"); // returns MultiGeom Node
-      for (int i=1; i<p->numlines; i++) {
-        xmlNodePtr lineStringNode = xmlNewChild(geomNode, NULL, BAD_CAST "LineString", NULL);
+      for (int i = 1; i < p->numlines; i++) {
+        xmlNodePtr lineStringNode =
+            xmlNewChild(geomNode, NULL, BAD_CAST "LineString", NULL);
         addAddRenderingSpecifications(lineStringNode);
         addCoordsNode(lineStringNode, p->line[i].point, p->line[i].numpoints);
       }
@@ -608,11 +615,9 @@ void KmlRenderer::renderLine(imageObj*,
 
     CurrentDrawnShapeIndex = p->index;
   }
-
 }
 
-void KmlRenderer::renderPolygon(imageObj*, shapeObj *p, colorObj *color)
-{
+void KmlRenderer::renderPolygon(imageObj *, shapeObj *p, colorObj *color) {
   if (PlacemarkNode == NULL)
     PlacemarkNode = createPlacemarkNode(LayerNode, NULL);
 
@@ -622,40 +627,42 @@ void KmlRenderer::renderPolygon(imageObj
   memcpy(&PolygonColor, color, sizeof(colorObj));
   SymbologyFlag[Polygon] = 1;
 
-
   if (p->index != CurrentDrawnShapeIndex) {
 
     xmlNodePtr geomParentNode = getGeomParentNode("Polygon");
 
-    for (int i=0; i<p->numlines; i++) {
+    for (int i = 0; i < p->numlines; i++) {
       xmlNodePtr bdryNode = NULL;
 
-      if (i==0) /* __TODO__ check ring order*/
-        bdryNode = xmlNewChild(geomParentNode, NULL, BAD_CAST "outerBoundaryIs", NULL);
+      if (i == 0) /* __TODO__ check ring order*/
+        bdryNode =
+            xmlNewChild(geomParentNode, NULL, BAD_CAST "outerBoundaryIs", NULL);
       else
-        bdryNode = xmlNewChild(geomParentNode, NULL, BAD_CAST "innerBoundaryIs", NULL);
+        bdryNode =
+            xmlNewChild(geomParentNode, NULL, BAD_CAST "innerBoundaryIs", NULL);
 
-      xmlNodePtr ringNode = xmlNewChild(bdryNode, NULL, BAD_CAST "LinearRing", NULL);
+      xmlNodePtr ringNode =
+          xmlNewChild(bdryNode, NULL, BAD_CAST "LinearRing", NULL);
       addAddRenderingSpecifications(ringNode);
       addCoordsNode(ringNode, p->line[i].point, p->line[i].numpoints);
     }
 
     CurrentDrawnShapeIndex = p->index;
-
   }
-
 }
 
-void KmlRenderer::addCoordsNode(xmlNodePtr parentNode, pointObj *pts, int numPts)
-{
+void KmlRenderer::addCoordsNode(xmlNodePtr parentNode, pointObj *pts,
+                                int numPts) {
   char lineBuf[128];
 
-  xmlNodePtr coordsNode = xmlNewChild(parentNode, NULL, BAD_CAST "coordinates", NULL);
+  xmlNodePtr coordsNode =
+      xmlNewChild(parentNode, NULL, BAD_CAST "coordinates", NULL);
   xmlNodeAddContent(coordsNode, BAD_CAST "\n");
 
-  for (int i=0; i<numPts; i++) {
-    if( mElevationFromAttribute ) {
-      sprintf(lineBuf, "\t%.8f,%.8f,%.8f\n", pts[i].x, pts[i].y, mCurrentElevationValue);
+  for (int i = 0; i < numPts; i++) {
+    if (mElevationFromAttribute) {
+      sprintf(lineBuf, "\t%.8f,%.8f,%.8f\n", pts[i].x, pts[i].y,
+              mCurrentElevationValue);
     } else if (AltitudeMode == relativeToGround || AltitudeMode == absolute) {
       sprintf(lineBuf, "\t%.8f,%.8f,%.8f\n", pts[i].x, pts[i].y, pts[i].z);
     } else
@@ -666,9 +673,9 @@ void KmlRenderer::addCoordsNode(xmlNodeP
   xmlNodeAddContent(coordsNode, BAD_CAST "\t");
 }
 
-void KmlRenderer::renderGlyphs(imageObj *, const textSymbolObj *ts, colorObj *clr, colorObj * /*oc*/, int /*ow*/)
-{
-  if( ts->annotext == NULL || ts->textpath->numglyphs == 0 )
+void KmlRenderer::renderGlyphs(imageObj *, const textSymbolObj *ts,
+                               colorObj *clr, colorObj * /*oc*/, int /*ow*/) {
+  if (ts->annotext == NULL || ts->textpath->numglyphs == 0)
     return;
 
   if (PlacemarkNode == NULL)
@@ -686,7 +693,7 @@ void KmlRenderer::renderGlyphs(imageObj
       continue;
 
     if (strcmp((char *)node->name, "name") == 0) {
-      xmlNodeSetContent(node,  BAD_CAST ts->annotext);
+      xmlNodeSetContent(node, BAD_CAST ts->annotext);
       break;
     }
   }
@@ -702,8 +709,7 @@ void KmlRenderer::renderGlyphs(imageObj
   addCoordsNode(geomNode, &pt, 1);
 }
 
-void KmlRenderer::addAddRenderingSpecifications(xmlNodePtr node)
-{
+void KmlRenderer::addAddRenderingSpecifications(xmlNodePtr node) {
   /*
     <extrude>0</extrude>                   <!-- boolean -->
     <tessellate>0</tessellate>             <!-- boolean -->
@@ -719,48 +725,50 @@ void KmlRenderer::addAddRenderingSpecifi
   if (AltitudeMode == absolute)
     xmlNewChild(node, NULL, BAD_CAST "altitudeMode", BAD_CAST "absolute");
   else if (AltitudeMode == relativeToGround)
-    xmlNewChild(node, NULL, BAD_CAST "altitudeMode", BAD_CAST "relativeToGround");
+    xmlNewChild(node, NULL, BAD_CAST "altitudeMode",
+                BAD_CAST "relativeToGround");
   else if (AltitudeMode == clampToGround)
     xmlNewChild(node, NULL, BAD_CAST "altitudeMode", BAD_CAST "clampToGround");
 }
 
+imageObj *agg2CreateImage(int width, int height, outputFormatObj *format,
+                          colorObj *bg);
 
-imageObj *agg2CreateImage(int width, int height, outputFormatObj *format, colorObj * bg);
-
-int KmlRenderer::createIconImage(char *fileName, symbolObj *symbol, symbolStyleObj *symstyle)
-{
+int KmlRenderer::createIconImage(char *fileName, symbolObj *symbol,
+                                 symbolStyleObj *symstyle) {
   pointObj p;
   int status;
 
   imageObj *tmpImg = NULL;
 
-  tmpImg = agg2CreateImage((int)(symbol->sizex*symstyle->scale),
-                           (int)(symbol->sizey*symstyle->scale),
-                           aggFormat, NULL);
+  tmpImg =
+      agg2CreateImage((int)(symbol->sizex * symstyle->scale),
+                      (int)(symbol->sizey * symstyle->scale), aggFormat, NULL);
   tmpImg->format = aggFormat;
   if (!aggFormat->vtable)
     msInitializeRendererVTable(aggFormat);
 
   p.x = symbol->sizex * symstyle->scale / 2;
-  p.y = symbol->sizey *symstyle->scale / 2;
+  p.y = symbol->sizey * symstyle->scale / 2;
   p.z = 0.0;
 
-  status = msDrawMarkerSymbol(map,tmpImg, &p, symstyle->style, 1);
-  if( status != MS_SUCCESS )
+  status = msDrawMarkerSymbol(map, tmpImg, &p, symstyle->style, 1);
+  if (status != MS_SUCCESS)
     return status;
 
   return msSaveImage(map, tmpImg, fileName);
 }
 
-void KmlRenderer::renderSymbol(imageObj *img, double x, double y, symbolObj *symbol, symbolStyleObj *style)
-{
+void KmlRenderer::renderSymbol(imageObj *img, double x, double y,
+                               symbolObj *symbol, symbolStyleObj *style) {
   if (PlacemarkNode == NULL)
     PlacemarkNode = createPlacemarkNode(LayerNode, NULL);
 
   if (!PlacemarkNode)
     return;
 
-  snprintf(SymbolUrl, sizeof(SymbolUrl), "%s", lookupSymbolUrl(img, symbol, style));
+  snprintf(SymbolUrl, sizeof(SymbolUrl), "%s",
+           lookupSymbolUrl(img, symbol, style));
   SymbologyFlag[Symbol] = 1;
 
   xmlNodePtr geomNode = getGeomParentNode("Point");
@@ -772,32 +780,31 @@ void KmlRenderer::renderSymbol(imageObj
   addCoordsNode(geomNode, &pt, 1);
 }
 
-void KmlRenderer::renderPixmapSymbol(imageObj *img, double x, double y, symbolObj *symbol,
-                                     symbolStyleObj *style)
-{
+void KmlRenderer::renderPixmapSymbol(imageObj *img, double x, double y,
+                                     symbolObj *symbol, symbolStyleObj *style) {
   renderSymbol(img, x, y, symbol, style);
 }
 
-void KmlRenderer::renderVectorSymbol(imageObj *img, double x, double y, symbolObj *symbol,
-                                     symbolStyleObj *style)
-{
+void KmlRenderer::renderVectorSymbol(imageObj *img, double x, double y,
+                                     symbolObj *symbol, symbolStyleObj *style) {
   renderSymbol(img, x, y, symbol, style);
 }
 
-void KmlRenderer::renderEllipseSymbol(imageObj *img, double x, double y, symbolObj *symbol,
-                                      symbolStyleObj *style)
-{
+void KmlRenderer::renderEllipseSymbol(imageObj *img, double x, double y,
+                                      symbolObj *symbol,
+                                      symbolStyleObj *style) {
   renderSymbol(img, x, y, symbol, style);
 }
 
-void KmlRenderer::renderTruetypeSymbol(imageObj *img, double x, double y, symbolObj *symbol,
-                                       symbolStyleObj *style)
-{
+void KmlRenderer::renderTruetypeSymbol(imageObj *img, double x, double y,
+                                       symbolObj *symbol,
+                                       symbolStyleObj *style) {
   renderSymbol(img, x, y, symbol, style);
 }
 
-xmlNodePtr KmlRenderer::createGroundOverlayNode(xmlNodePtr parentNode, char *imageHref, layerObj *layer)
-{
+xmlNodePtr KmlRenderer::createGroundOverlayNode(xmlNodePtr parentNode,
+                                                char *imageHref,
+                                                layerObj *layer) {
   /*
     <?xml version="1.0" encoding="UTF-8"?>
     <kml xmlns="http://www.opengis.net/kml/2.2">
@@ -821,21 +828,26 @@ xmlNodePtr KmlRenderer::createGroundOver
     </GroundOverlay>
     </kml>
   */
-  char  layerHexColor[32];
-  xmlNodePtr groundOverlayNode = xmlNewChild(parentNode, NULL, BAD_CAST "GroundOverlay", NULL);
+  char layerHexColor[32];
+  xmlNodePtr groundOverlayNode =
+      xmlNewChild(parentNode, NULL, BAD_CAST "GroundOverlay", NULL);
   char *layerName = getLayerName(layer);
   xmlNewChild(groundOverlayNode, NULL, BAD_CAST "name", BAD_CAST layerName);
-  if (layer->compositer && layer->compositer->opacity > 0 && layer->compositer->opacity < 100) {
-    sprintf(layerHexColor, "%02xffffff", (unsigned int)MS_NINT(layer->compositer->opacity*2.55));
-    xmlNewChild(groundOverlayNode, NULL, BAD_CAST "color", BAD_CAST layerHexColor);
+  if (layer->compositer && layer->compositer->opacity > 0 &&
+      layer->compositer->opacity < 100) {
+    sprintf(layerHexColor, "%02xffffff",
+            (unsigned int)MS_NINT(layer->compositer->opacity * 2.55));
+    xmlNewChild(groundOverlayNode, NULL, BAD_CAST "color",
+                BAD_CAST layerHexColor);
   } else
     xmlNewChild(groundOverlayNode, NULL, BAD_CAST "color", BAD_CAST "ffffffff");
   char stmp[20];
-  sprintf(stmp, "%d",layer->index);
+  sprintf(stmp, "%d", layer->index);
   xmlNewChild(groundOverlayNode, NULL, BAD_CAST "drawOrder", BAD_CAST stmp);
 
   if (imageHref) {
-    xmlNodePtr iconNode = xmlNewChild(groundOverlayNode, NULL, BAD_CAST "Icon", NULL);
+    xmlNodePtr iconNode =
+        xmlNewChild(groundOverlayNode, NULL, BAD_CAST "Icon", NULL);
     xmlNewChild(iconNode, NULL, BAD_CAST "href", BAD_CAST imageHref);
   }
 
@@ -846,7 +858,8 @@ xmlNodePtr KmlRenderer::createGroundOver
   else
     mapextent = currentLayer->map->extent;
 
-  xmlNodePtr latLonBoxNode = xmlNewChild(groundOverlayNode, NULL, BAD_CAST "LatLonBox", NULL);
+  xmlNodePtr latLonBoxNode =
+      xmlNewChild(groundOverlayNode, NULL, BAD_CAST "LatLonBox", NULL);
   sprintf(crdStr, "%.8f", mapextent.maxy);
   xmlNewChild(latLonBoxNode, NULL, BAD_CAST "north", BAD_CAST crdStr);
 
@@ -864,17 +877,17 @@ xmlNodePtr KmlRenderer::createGroundOver
   return groundOverlayNode;
 }
 
-void KmlRenderer::startShape(imageObj *, shapeObj *shape)
-{
+void KmlRenderer::startShape(imageObj *, shapeObj *shape) {
   if (PlacemarkNode)
     flushPlacemark();
 
-  CurrentShapeIndex=-1;
+  CurrentShapeIndex = -1;
   CurrentDrawnShapeIndex = -1;
-  CurrentShapeName=NULL;
+  CurrentShapeName = NULL;
 
-  /*should be done at endshape but the plugin architecture does not call endshape yet*/
-  if(LineStyle) {
+  /*should be done at endshape but the plugin architecture does not call
+   * endshape yet*/
+  if (LineStyle) {
     msFree(LineStyle);
 
     LineStyle = NULL;
@@ -883,8 +896,10 @@ void KmlRenderer::startShape(imageObj *,
 
   CurrentShapeIndex = shape->index;
   if (pszLayerNameAttributeMetadata) {
-    for (int i=0; i<currentLayer->numitems; i++) {
-      if (strcasecmp(currentLayer->items[i], pszLayerNameAttributeMetadata) == 0 && shape->values[i]) {
+    for (int i = 0; i < currentLayer->numitems; i++) {
+      if (strcasecmp(currentLayer->items[i], pszLayerNameAttributeMetadata) ==
+              0 &&
+          shape->values[i]) {
         CurrentShapeName = msStrdup(shape->values[i]);
         break;
       }
@@ -895,33 +910,33 @@ void KmlRenderer::startShape(imageObj *,
 
   DescriptionNode = createDescriptionNode(shape);
 
-  if( mElevationFromAttribute && shape->numvalues > mElevationAttributeIndex &&
-      mElevationAttributeIndex >= 0 && shape->values[mElevationAttributeIndex]) {
-    mCurrentElevationValue = atof( shape->values[mElevationAttributeIndex] );
+  if (mElevationFromAttribute && shape->numvalues > mElevationAttributeIndex &&
+      mElevationAttributeIndex >= 0 &&
+      shape->values[mElevationAttributeIndex]) {
+    mCurrentElevationValue = atof(shape->values[mElevationAttributeIndex]);
   }
 
-
   memset(SymbologyFlag, 0, NumSymbologyFlag);
 }
 
-void KmlRenderer::endShape(imageObj*, shapeObj*)
-{
+void KmlRenderer::endShape(imageObj *, shapeObj *) {
   CurrentShapeIndex = -1;
   if (CurrentShapeName)
     msFree(CurrentShapeName);
   CurrentShapeName = NULL;
 }
 
-xmlNodePtr KmlRenderer::getGeomParentNode(const char *geomName)
-{
+xmlNodePtr KmlRenderer::getGeomParentNode(const char *geomName) {
   /*we do not need a multi-geometry for point layers*/
-  if (currentLayer->type != MS_LAYER_POINT && currentLayer->type != MS_LAYER_ANNOTATION && GeomNode) {
+  if (currentLayer->type != MS_LAYER_POINT &&
+      currentLayer->type != MS_LAYER_ANNOTATION && GeomNode) {
     /*placemark geometry already defined, we need multigeometry node*/
     xmlNodePtr multiGeomNode = xmlNewNode(NULL, BAD_CAST "MultiGeometry");
     xmlAddChild(multiGeomNode, GeomNode);
     GeomNode = multiGeomNode;
 
-    xmlNodePtr geomNode = xmlNewChild(multiGeomNode, NULL, BAD_CAST geomName, NULL);
+    xmlNodePtr geomNode =
+        xmlNewChild(multiGeomNode, NULL, BAD_CAST geomName, NULL);
     return geomNode;
   } else {
     GeomNode = xmlNewNode(NULL, BAD_CAST geomName);
@@ -929,9 +944,9 @@ xmlNodePtr KmlRenderer::getGeomParentNod
   }
 }
 
-const char* KmlRenderer::lookupSymbolUrl(imageObj *img, symbolObj *symbol, symbolStyleObj *symstyle)
-{
-  char  symbolHexColor[32];
+const char *KmlRenderer::lookupSymbolUrl(imageObj *img, symbolObj *symbol,
+                                         symbolStyleObj *symstyle) {
+  char symbolHexColor[32];
   /*
       <Style id="randomColorIcon">
       <IconStyle>
@@ -945,9 +960,11 @@ const char* KmlRenderer::lookupSymbolUrl
       </Style>
   */
 
-  sprintf(symbolHexColor,"%02x%02x%02x%02x", symstyle->style->color.alpha, symstyle->style->color.blue,
-          symstyle->style->color.green, symstyle->style->color.red);
-  snprintf(SymbolName, sizeof(SymbolName), "symbol_%s_%.1f_%s", symbol->name, symstyle->scale, symbolHexColor);
+  sprintf(symbolHexColor, "%02x%02x%02x%02x", symstyle->style->color.alpha,
+          symstyle->style->color.blue, symstyle->style->color.green,
+          symstyle->style->color.red);
+  snprintf(SymbolName, sizeof(SymbolName), "symbol_%s_%.1f_%s", symbol->name,
+           symstyle->scale, symbolHexColor);
 
   const char *symbolUrl = msLookupHashTable(StyleHashTable, SymbolName);
   if (!symbolUrl) {
@@ -959,16 +976,19 @@ const char* KmlRenderer::lookupSymbolUrl
       snprintf(iconFileName, sizeof(iconFileName), "%s", tmpFileName);
       msFree(tmpFileName);
     } else {
-      sprintf(iconFileName, "symbol_%s_%.1f.%s", symbol->name, symstyle->scale, "png");
+      sprintf(iconFileName, "symbol_%s_%.1f.%s", symbol->name, symstyle->scale,
+              "png");
     }
 
     if (createIconImage(iconFileName, symbol, symstyle) != MS_SUCCESS) {
-      msSetError(MS_IOERR, "Error creating icon file '%s'", "KmlRenderer::lookupSymbolStyle()", iconFileName);
+      msSetError(MS_IOERR, "Error creating icon file '%s'",
+                 "KmlRenderer::lookupSymbolStyle()", iconFileName);
       return NULL;
     }
 
     if (img->imageurl)
-      sprintf(iconUrl, "%s%s.%s", img->imageurl, msGetBasename(iconFileName), "png");
+      sprintf(iconUrl, "%s%s.%s", img->imageurl, msGetBasename(iconFileName),
+              "png");
     else
       snprintf(iconUrl, sizeof(iconUrl), "%s", iconFileName);
 
@@ -979,12 +999,11 @@ const char* KmlRenderer::lookupSymbolUrl
   return symbolUrl;
 }
 
-const char* KmlRenderer::lookupPlacemarkStyle()
-{
-  char  lineHexColor[32];
-  char  polygonHexColor[32];
-  char  labelHexColor[32];
-  char        *styleName=NULL;
+const char *KmlRenderer::lookupPlacemarkStyle() {
+  char lineHexColor[32];
+  char polygonHexColor[32];
+  char labelHexColor[32];
+  char *styleName = NULL;
 
   styleName = msStringConcatenate(styleName, "style");
 
@@ -993,23 +1012,29 @@ const char* KmlRenderer::lookupPlacemark
       <LineStyle id="ID">
       <!-- inherited from ColorStyle -->
       <color>ffffffff</color>            <!-- kml:color -->
-      <colorMode>normal</colorMode>      <!-- colorModeEnum: normal or random -->
+      <colorMode>normal</colorMode>      <!-- colorModeEnum: normal or random
+      -->
 
       <!-- specific to LineStyle -->
       <width>1</width>                   <!-- float -->
       </LineStyle>
     */
 
-    for (int i=0; i<numLineStyle; i++) {
-      if (currentLayer && currentLayer->compositer && currentLayer->compositer->opacity > 0 && currentLayer->compositer->opacity < 100 &&
+    for (int i = 0; i < numLineStyle; i++) {
+      if (currentLayer && currentLayer->compositer &&
+          currentLayer->compositer->opacity > 0 &&
+          currentLayer->compositer->opacity < 100 &&
           LineStyle[i].color->alpha == 255)
-        LineStyle[i].color->alpha = MS_NINT(currentLayer->compositer->opacity*2.55);
+        LineStyle[i].color->alpha =
+            MS_NINT(currentLayer->compositer->opacity * 2.55);
 
-      sprintf(lineHexColor,"%02x%02x%02x%02x", LineStyle[i].color->alpha, LineStyle[0].color->blue,
-              LineStyle[i].color->green, LineStyle[i].color->red);
+      sprintf(lineHexColor, "%02x%02x%02x%02x", LineStyle[i].color->alpha,
+              LineStyle[0].color->blue, LineStyle[i].color->green,
+              LineStyle[i].color->red);
 
       char lineStyleName[64];
-      snprintf(lineStyleName, sizeof(lineStyleName), "_line_%s_w%.1f", lineHexColor, LineStyle[i].width);
+      snprintf(lineStyleName, sizeof(lineStyleName), "_line_%s_w%.1f",
+               lineHexColor, LineStyle[i].width);
       styleName = msStringConcatenate(styleName, lineStyleName);
     }
   }
@@ -1019,7 +1044,8 @@ const char* KmlRenderer::lookupPlacemark
       <PolyStyle id="ID">
       <!-- inherited from ColorStyle -->
       <color>ffffffff</color>            <!-- kml:color -->
-      <colorMode>normal</colorMode>      <!-- kml:colorModeEnum: normal or random -->
+      <colorMode>normal</colorMode>      <!-- kml:colorModeEnum: normal or
+      random -->
 
       <!-- specific to PolyStyle -->
       <fill>1</fill>                     <!-- boolean -->
@@ -1027,10 +1053,12 @@ const char* KmlRenderer::lookupPlacemark
       </PolyStyle>
     */
 
-    if (currentLayer && currentLayer->compositer && currentLayer->compositer->opacity > 0 && currentLayer->compositer->opacity < 100 &&
-        PolygonColor.alpha == 255)
-      PolygonColor.alpha = MS_NINT(currentLayer->compositer->opacity*2.55);
-    sprintf(polygonHexColor,"%02x%02x%02x%02x", PolygonColor.alpha, PolygonColor.blue, PolygonColor.green, PolygonColor.red);
+    if (currentLayer && currentLayer->compositer &&
+        currentLayer->compositer->opacity > 0 &&
+        currentLayer->compositer->opacity < 100 && PolygonColor.alpha == 255)
+      PolygonColor.alpha = MS_NINT(currentLayer->compositer->opacity * 2.55);
+    sprintf(polygonHexColor, "%02x%02x%02x%02x", PolygonColor.alpha,
+            PolygonColor.blue, PolygonColor.green, PolygonColor.red);
 
     char polygonStyleName[64];
     sprintf(polygonStyleName, "_polygon_%s", polygonHexColor);
@@ -1042,17 +1070,20 @@ const char* KmlRenderer::lookupPlacemark
       <LabelStyle id="ID">
       <!-- inherited from ColorStyle -->
       <color>ffffffff</color>            <!-- kml:color -->
-      <colorMode>normal</colorMode>      <!-- kml:colorModeEnum: normal or random -->
+      <colorMode>normal</colorMode>      <!-- kml:colorModeEnum: normal or
+      random -->
 
       <!-- specific to LabelStyle -->
       <scale>1</scale>                   <!-- float -->
       </LabelStyle>
     */
 
-    if (currentLayer && currentLayer->compositer && currentLayer->compositer->opacity > 0 && currentLayer->compositer->opacity < 100 &&
-        LabelColor.alpha == 255)
-      LabelColor.alpha = MS_NINT(currentLayer->compositer->opacity*2.55);
-    sprintf(labelHexColor,"%02x%02x%02x%02x", LabelColor.alpha, LabelColor.blue, LabelColor.green, LabelColor.red);
+    if (currentLayer && currentLayer->compositer &&
+        currentLayer->compositer->opacity > 0 &&
+        currentLayer->compositer->opacity < 100 && LabelColor.alpha == 255)
+      LabelColor.alpha = MS_NINT(currentLayer->compositer->opacity * 2.55);
+    sprintf(labelHexColor, "%02x%02x%02x%02x", LabelColor.alpha,
+            LabelColor.blue, LabelColor.green, LabelColor.red);
 
     // __TODO__ add label scale
 
@@ -1083,7 +1114,7 @@ const char* KmlRenderer::lookupPlacemark
 
   const char *styleUrl = msLookupHashTable(StyleHashTable, styleName);
   if (!styleUrl) {
-    char *styleValue=NULL;
+    char *styleValue = NULL;
     styleValue = msStringConcatenate(styleValue, "#");
     styleValue = msStringConcatenate(styleValue, styleName);
     hashObj *hash = msInsertHashTable(StyleHashTable, styleName, styleValue);
@@ -1095,16 +1126,21 @@ const char* KmlRenderer::lookupPlacemark
     xmlNewProp(styleNode, BAD_CAST "id", BAD_CAST styleName);
 
     if (SymbologyFlag[Polygon]) {
-      xmlNodePtr polyStyleNode = xmlNewChild(styleNode, NULL, BAD_CAST "PolyStyle", NULL);
-      xmlNewChild(polyStyleNode, NULL, BAD_CAST "color", BAD_CAST polygonHexColor);
+      xmlNodePtr polyStyleNode =
+          xmlNewChild(styleNode, NULL, BAD_CAST "PolyStyle", NULL);
+      xmlNewChild(polyStyleNode, NULL, BAD_CAST "color",
+                  BAD_CAST polygonHexColor);
     }
 
     if (SymbologyFlag[Line]) {
-      for (int i=0; i<numLineStyle; i++) {
-        xmlNodePtr lineStyleNode = xmlNewChild(styleNode, NULL, BAD_CAST "LineStyle", NULL);
-        sprintf(lineHexColor,"%02x%02x%02x%02x", LineStyle[i].color->alpha, LineStyle[i].color->blue,
-                LineStyle[i].color->green, LineStyle[i].color->red);
-        xmlNewChild(lineStyleNode, NULL, BAD_CAST "color", BAD_CAST lineHexColor);
+      for (int i = 0; i < numLineStyle; i++) {
+        xmlNodePtr lineStyleNode =
+            xmlNewChild(styleNode, NULL, BAD_CAST "LineStyle", NULL);
+        sprintf(lineHexColor, "%02x%02x%02x%02x", LineStyle[i].color->alpha,
+                LineStyle[i].color->blue, LineStyle[i].color->green,
+                LineStyle[i].color->red);
+        xmlNewChild(lineStyleNode, NULL, BAD_CAST "color",
+                    BAD_CAST lineHexColor);
 
         char width[16];
         sprintf(width, "%.1f", LineStyle[i].width);
@@ -1113,27 +1149,34 @@ const char* KmlRenderer::lookupPlacemark
     }
 
     if (SymbologyFlag[Symbol]) {
-      xmlNodePtr iconStyleNode = xmlNewChild(styleNode, NULL, BAD_CAST "IconStyle", NULL);
+      xmlNodePtr iconStyleNode =
+          xmlNewChild(styleNode, NULL, BAD_CAST "IconStyle", NULL);
 
-      xmlNodePtr iconNode = xmlNewChild(iconStyleNode, NULL, BAD_CAST "Icon", NULL);
+      xmlNodePtr iconNode =
+          xmlNewChild(iconStyleNode, NULL, BAD_CAST "Icon", NULL);
       xmlNewChild(iconNode, NULL, BAD_CAST "href", BAD_CAST SymbolUrl);
 
       /*char scale[16];
         sprintf(scale, "%.1f", style->scale);
         xmlNewChild(iconStyleNode, NULL, BAD_CAST "scale", BAD_CAST scale);*/
     } else {
-      const char *value=msLookupHashTable(&currentLayer->metadata, "kml_default_symbol_href");
+      const char *value =
+          msLookupHashTable(&currentLayer->metadata, "kml_default_symbol_href");
       if (value && strlen(value) > 0) {
-        xmlNodePtr iconStyleNode = xmlNewChild(styleNode, NULL, BAD_CAST "IconStyle", NULL);
+        xmlNodePtr iconStyleNode =
+            xmlNewChild(styleNode, NULL, BAD_CAST "IconStyle", NULL);
 
-        xmlNodePtr iconNode = xmlNewChild(iconStyleNode, NULL, BAD_CAST "Icon", NULL);
+        xmlNodePtr iconNode =
+            xmlNewChild(iconStyleNode, NULL, BAD_CAST "Icon", NULL);
         xmlNewChild(iconNode, NULL, BAD_CAST "href", BAD_CAST value);
       }
     }
 
     if (SymbologyFlag[Label]) {
-      xmlNodePtr labelStyleNode = xmlNewChild(styleNode, NULL, BAD_CAST "LabelStyle", NULL);
-      xmlNewChild(labelStyleNode, NULL, BAD_CAST "color", BAD_CAST labelHexColor);
+      xmlNodePtr labelStyleNode =
+          xmlNewChild(styleNode, NULL, BAD_CAST "LabelStyle", NULL);
+      xmlNewChild(labelStyleNode, NULL, BAD_CAST "color",
+                  BAD_CAST labelHexColor);
 
       /*char scale[16];
         sprintf(scale, "%.1f", style->scale);
@@ -1147,8 +1190,7 @@ const char* KmlRenderer::lookupPlacemark
   return styleUrl;
 }
 
-void KmlRenderer::flushPlacemark()
-{
+void KmlRenderer::flushPlacemark() {
   if (PlacemarkNode) {
     const char *styleUrl = lookupPlacemarkStyle();
     xmlNewChild(PlacemarkNode, NULL, BAD_CAST "styleUrl", BAD_CAST styleUrl);
@@ -1161,9 +1203,7 @@ void KmlRenderer::flushPlacemark()
   }
 }
 
-
-xmlNodePtr KmlRenderer::createDescriptionNode(shapeObj *shape)
-{
+xmlNodePtr KmlRenderer::createDescriptionNode(shapeObj *shape) {
   /*
     <description>
     <![CDATA[
@@ -1172,23 +1212,23 @@ xmlNodePtr KmlRenderer::createDescriptio
     <description>
   */
 
-
   /*description nodes for vector layers:
     - if kml_description is set, use it
     - if not, dump the attributes */
 
   if (pszLayerDescMetadata) {
-    char *pszTmp=NULL;
+    char *pszTmp = NULL;
     char *pszTmpDesc = NULL;
     size_t bufferSize = 0;
     pszTmpDesc = msStrdup(pszLayerDescMetadata);
 
-    for (int i=0; i<currentLayer->numitems; i++) {
+    for (int i = 0; i < currentLayer->numitems; i++) {
       bufferSize = strlen(currentLayer->items[i]) + 3;
       pszTmp = (char *)msSmallMalloc(bufferSize);
-      snprintf(pszTmp, bufferSize, "%%%s%%",currentLayer->items[i]);
+      snprintf(pszTmp, bufferSize, "%%%s%%", currentLayer->items[i]);
       if (strcasestr(pszTmpDesc, pszTmp))
-        pszTmpDesc = msCaseReplaceSubstring(pszTmpDesc,  pszTmp, shape->values[i]);
+        pszTmpDesc =
+            msCaseReplaceSubstring(pszTmpDesc, pszTmp, shape->values[i]);
       msFree(pszTmp);
     }
     xmlNodePtr descriptionNode = xmlNewNode(NULL, BAD_CAST "description");
@@ -1204,38 +1244,43 @@ xmlNodePtr KmlRenderer::createDescriptio
 
     xmlNodePtr extendedDataNode = xmlNewNode(NULL, BAD_CAST "ExtendedData");
     xmlNodePtr dataNode = NULL;
-    const char*pszAlias=NULL;
+    const char *pszAlias = NULL;
     int bIncludeAll = MS_FALSE;
 
-    if(papszLayerIncludeItems && nIncludeItems == 1 &&
+    if (papszLayerIncludeItems && nIncludeItems == 1 &&
         strcasecmp(papszLayerIncludeItems[0], "all") == 0)
       bIncludeAll = MS_TRUE;
 
-    for (int i=0; i<currentLayer->numitems; i++) {
-      int j=0,k=0;
+    for (int i = 0; i < currentLayer->numitems; i++) {
+      int j = 0, k = 0;
 
       /*TODO optimize to calculate this only once per layer*/
-      for (j=0; j<nIncludeItems; j++) {
+      for (j = 0; j < nIncludeItems; j++) {
         if (strcasecmp(currentLayer->items[i], papszLayerIncludeItems[j]) == 0)
           break;
       }
-      if (j<nIncludeItems || bIncludeAll) {
+      if (j < nIncludeItems || bIncludeAll) {
         if (papszLayerExcludeItems && nExcludeItems > 0) {
-          for (k=0; k<nExcludeItems; k++) {
-            if (strcasecmp(currentLayer->items[i], papszLayerExcludeItems[k]) == 0)
+          for (k = 0; k < nExcludeItems; k++) {
+            if (strcasecmp(currentLayer->items[i], papszLayerExcludeItems[k]) ==
+                0)
               break;
           }
         }
         if (nExcludeItems == 0 || k == nExcludeItems) {
           dataNode = xmlNewNode(NULL, BAD_CAST "Data");
-          xmlNewProp(dataNode, BAD_CAST "name", BAD_CAST  currentLayer->items[i]);
+          xmlNewProp(dataNode, BAD_CAST "name",
+                     BAD_CAST currentLayer->items[i]);
           pszAlias = getAliasName(currentLayer, currentLayer->items[i], "GO");
           if (pszAlias)
-            xmlNewChild(dataNode, NULL, BAD_CAST "displayName", BAD_CAST  pszAlias);
+            xmlNewChild(dataNode, NULL, BAD_CAST "displayName",
+                        BAD_CAST pszAlias);
           else
-            xmlNewChild(dataNode, NULL, BAD_CAST "displayName", BAD_CAST  currentLayer->items[i]);
+            xmlNewChild(dataNode, NULL, BAD_CAST "displayName",
+                        BAD_CAST currentLayer->items[i]);
           if (shape->values[i] && strlen(shape->values[i]))
-            xmlNewChild(dataNode, NULL, BAD_CAST "value", BAD_CAST  shape->values[i]);
+            xmlNewChild(dataNode, NULL, BAD_CAST "value",
+                        BAD_CAST shape->values[i]);
           else
             xmlNewChild(dataNode, NULL, BAD_CAST "value", NULL);
           xmlAddChild(extendedDataNode, dataNode);
@@ -1244,19 +1289,16 @@ xmlNodePtr KmlRenderer::createDescriptio
     }
 
     return extendedDataNode;
-
-
   }
 
   return NULL;
 }
 
-void KmlRenderer::addLineStyleToList(strokeStyleObj *style)
-{
+void KmlRenderer::addLineStyleToList(strokeStyleObj *style) {
   /*actually this is not necessary. kml only uses the last LineStyle
     so we should not bother keeping them all*/
-  int i =0;
-  for (i=0; i<numLineStyle; i++) {
+  int i = 0;
+  for (i = 0; i < numLineStyle; i++) {
     if (style->width == LineStyle[i].width &&
         LineStyle[i].color->alpha == style->color->alpha &&
         LineStyle[i].color->red == style->color->red &&
@@ -1269,11 +1311,11 @@ void KmlRenderer::addLineStyleToList(str
     if (LineStyle == NULL)
       LineStyle = (strokeStyleObj *)msSmallMalloc(sizeof(strokeStyleObj));
     else
-      LineStyle = (strokeStyleObj *)msSmallRealloc(LineStyle, sizeof(strokeStyleObj)*numLineStyle);
+      LineStyle = (strokeStyleObj *)msSmallRealloc(
+          LineStyle, sizeof(strokeStyleObj) * numLineStyle);
 
-    memcpy(&LineStyle[numLineStyle-1], style, sizeof(strokeStyleObj));
+    memcpy(&LineStyle[numLineStyle - 1], style, sizeof(strokeStyleObj));
   }
-
 }
 
 #endif
diff -pruN 8.0.1-5/mapkmlrenderer.h 8.0.2-1/mapkmlrenderer.h
--- 8.0.1-5/mapkmlrenderer.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapkmlrenderer.h	2024-06-11 20:41:34.000000000 +0000
@@ -27,7 +27,6 @@
  * DEALINGS IN THE SOFTWARE.
  *****************************************************************************/
 
-
 #ifndef MAPKMLRENDERER_H
 #define MAPKMLRENDERER_H
 
@@ -37,9 +36,7 @@
 #include "mapserver.h"
 #include "maplibxml2.h"
 
-
-class KmlRenderer
-{
+class KmlRenderer {
 private:
   const char *pszLayerDescMetadata = nullptr; /*if the kml_description is set*/
   char **papszLayerIncludeItems = nullptr;
@@ -49,74 +46,78 @@ private:
   const char *pszLayerNameAttributeMetadata = nullptr;
 
 protected:
-
   // map properties
-  int       Width = 0, Height = 0;
-  rectObj     MapExtent = {0,0,0,0};
-  double      MapCellsize = 0;
-  colorObj    BgColor = {0,0,0,0};
-  char      MapPath[MS_MAXPATHLEN] = {0};
+  int Width = 0, Height = 0;
+  rectObj MapExtent = {0, 0, 0, 0};
+  double MapCellsize = 0;
+  colorObj BgColor = {0, 0, 0, 0};
+  char MapPath[MS_MAXPATHLEN] = {0};
 
   // xml nodes pointers
   xmlDocPtr XmlDoc = nullptr;
-  xmlNodePtr  DocNode = nullptr;
-  xmlNodePtr  LayerNode = nullptr;
-  xmlNodePtr  GroundOverlayNode = nullptr;
-
-  xmlNodePtr  PlacemarkNode = nullptr;
-  xmlNodePtr  GeomNode = nullptr;
-  xmlNodePtr  DescriptionNode = nullptr;
-
-  int         CurrentShapeIndex = 0;
-  int         CurrentDrawnShapeIndex = 0;
-  char            *CurrentShapeName = nullptr;
-  char    **Items = nullptr;
-  int     NumItems = 0;
-  int     DumpAttributes = 0;
+  xmlNodePtr DocNode = nullptr;
+  xmlNodePtr LayerNode = nullptr;
+  xmlNodePtr GroundOverlayNode = nullptr;
+
+  xmlNodePtr PlacemarkNode = nullptr;
+  xmlNodePtr GeomNode = nullptr;
+  xmlNodePtr DescriptionNode = nullptr;
+
+  int CurrentShapeIndex = 0;
+  int CurrentDrawnShapeIndex = 0;
+  char *CurrentShapeName = nullptr;
+  char **Items = nullptr;
+  int NumItems = 0;
+  int DumpAttributes = 0;
 
   // placemark symbology
-  hashTableObj  *StyleHashTable = nullptr;
+  hashTableObj *StyleHashTable = nullptr;
 
-  colorObj                LabelColor = {0,0,0,0};
-  strokeStyleObj          *LineStyle = nullptr;
-  int                     numLineStyle = 0;
-  colorObj    PolygonColor = {0,0,0,0};
+  colorObj LabelColor = {0, 0, 0, 0};
+  strokeStyleObj *LineStyle = nullptr;
+  int numLineStyle = 0;
+  colorObj PolygonColor = {0, 0, 0, 0};
 
-  char      SymbolName[128] = {0};
-  char      SymbolUrl[128] = {0};
+  char SymbolName[128] = {0};
+  char SymbolUrl[128] = {0};
 
-  enum      { NumSymbologyFlag = 4};
-  char      SymbologyFlag[NumSymbologyFlag] = {0,0,0,0};
+  enum { NumSymbologyFlag = 4 };
+  char SymbologyFlag[NumSymbologyFlag] = {0, 0, 0, 0};
 
-  enum      symbFlagsEnum { Label, Line, Polygon, Symbol };
+  enum symbFlagsEnum { Label, Line, Polygon, Symbol };
 
-  int       FirstLayer = 0;
+  int FirstLayer = 0;
 
-  mapObj                  *map = nullptr;
-  layerObj                *currentLayer = nullptr;
+  mapObj *map = nullptr;
+  layerObj *currentLayer = nullptr;
 
-  int       AltitudeMode = 0;
-  int       Tessellate = 0;
-  int       Extrude = 0;
+  int AltitudeMode = 0;
+  int Tessellate = 0;
+  int Extrude = 0;
 
-  enum altitudeModeEnum { undefined, clampToGround, relativeToGround, absolute };
+  enum altitudeModeEnum {
+    undefined,
+    clampToGround,
+    relativeToGround,
+    absolute
+  };
   /**True if elevation is taken from a feature attribute*/
   bool mElevationFromAttribute = false;
   /**Attribute index of elevation (or -1 if elevation is not attribute driven*/
   int mElevationAttributeIndex = 0;
   double mCurrentElevationValue = 0;
 
-
   outputFormatObj *aggFormat = nullptr;
 
 protected:
-
-  imageObj* createInternalImage();
+  imageObj *createInternalImage();
   xmlNodePtr createPlacemarkNode(xmlNodePtr parentNode, char *styleUrl);
-  xmlNodePtr createGroundOverlayNode(xmlNodePtr parentNode, char *imageHref, layerObj *layer);
+  xmlNodePtr createGroundOverlayNode(xmlNodePtr parentNode, char *imageHref,
+                                     layerObj *layer);
   xmlNodePtr createDescriptionNode(shapeObj *shape);
 
-  const char* lookupSymbolUrl(imageObj *img, symbolObj *symbol, symbolStyleObj *style);
+  const char *lookupSymbolUrl(imageObj *img, symbolObj *symbol,
+                              symbolStyleObj *style);
 
   void addCoordsNode(xmlNodePtr parentNode, pointObj *pts, int numPts);
 
@@ -127,27 +128,30 @@ protected:
 
   int createIconImage(char *fileName, symbolObj *symbol, symbolStyleObj *style);
 
-  void renderSymbol(imageObj *img, double x, double y, symbolObj *symbol, symbolStyleObj *style);
+  void renderSymbol(imageObj *img, double x, double y, symbolObj *symbol,
+                    symbolStyleObj *style);
 
   //////////////////////////////////////////////////////////////////////////////
 
   void renderLineVector(imageObj *img, shapeObj *p, strokeStyleObj *style);
   void renderPolygonVector(imageObj *img, shapeObj *p, colorObj *color);
 
-  const char* lookupPlacemarkStyle();
+  const char *lookupPlacemarkStyle();
   void flushPlacemark();
   xmlNodePtr getGeomParentNode(const char *geomName);
-  char* getLayerName(layerObj *layer);
+  char *getLayerName(layerObj *layer);
   void processLayer(layerObj *layer, outputFormatObj *format);
   void addLineStyleToList(strokeStyleObj *style);
-  const char *getAliasName(layerObj *lp, char *pszItemName, const char *namespaces);
+  const char *getAliasName(layerObj *lp, char *pszItemName,
+                           const char *namespaces);
 
 public:
-
-  KmlRenderer(int width, int height, outputFormatObj *format, colorObj* color = NULL);
+  KmlRenderer(int width, int height, outputFormatObj *format,
+              colorObj *color = NULL);
   virtual ~KmlRenderer();
 
-  imageObj* createImage(int width, int height, outputFormatObj *format, colorObj* bg);
+  imageObj *createImage(int width, int height, outputFormatObj *format,
+                        colorObj *bg);
   int saveImage(imageObj *img, FILE *fp, outputFormatObj *format);
 
   int startNewLayer(imageObj *img, layerObj *layer);
@@ -159,15 +163,22 @@ public:
   void renderLine(imageObj *img, shapeObj *p, strokeStyleObj *style);
   void renderPolygon(imageObj *img, shapeObj *p, colorObj *color);
 
-  void renderGlyphs(imageObj *img, const textSymbolObj *ts, colorObj *c, colorObj *oc, int ow);
+  void renderGlyphs(imageObj *img, const textSymbolObj *ts, colorObj *c,
+                    colorObj *oc, int ow);
 
   // Symbols
-  void renderPixmapSymbol(imageObj *img, double x, double y, symbolObj *symbol, symbolStyleObj *style);
-  void renderVectorSymbol(imageObj *img, double x, double y, symbolObj *symbol, symbolStyleObj *style);
-  void renderEllipseSymbol(imageObj *img, double x, double y, symbolObj *symbol, symbolStyleObj *style);
-  void renderTruetypeSymbol(imageObj *img, double x, double y, symbolObj *symbol, symbolStyleObj *style);
-
-  int getTruetypeTextBBox(imageObj *img,char **fonts, int numfonts, double size, char *string, rectObj *rect, double **advances);
+  void renderPixmapSymbol(imageObj *img, double x, double y, symbolObj *symbol,
+                          symbolStyleObj *style);
+  void renderVectorSymbol(imageObj *img, double x, double y, symbolObj *symbol,
+                          symbolStyleObj *style);
+  void renderEllipseSymbol(imageObj *img, double x, double y, symbolObj *symbol,
+                           symbolStyleObj *style);
+  void renderTruetypeSymbol(imageObj *img, double x, double y,
+                            symbolObj *symbol, symbolStyleObj *style);
+
+  int getTruetypeTextBBox(imageObj *img, char **fonts, int numfonts,
+                          double size, char *string, rectObj *rect,
+                          double **advances);
   int mergeRasterBuffer(imageObj *image, rasterBufferObj *rb);
 };
 
diff -pruN 8.0.1-5/maplabel.c 8.0.2-1/maplabel.c
--- 8.0.1-5/maplabel.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/maplabel.c	2024-06-11 20:41:34.000000000 +0000
@@ -40,24 +40,20 @@
 #include "cpl_vsi.h"
 #include "cpl_string.h"
 
+void initTextPath(textPathObj *ts) { memset(ts, 0, sizeof(*ts)); }
 
-
-
-
-void initTextPath(textPathObj *ts) {
-  memset(ts,0,sizeof(*ts));
-}
-
-int WARN_UNUSED msLayoutTextSymbol(mapObj *map, textSymbolObj *ts, textPathObj *tgret);
+int WARN_UNUSED msLayoutTextSymbol(mapObj *map, textSymbolObj *ts,
+                                   textPathObj *tgret);
 
 #if defined(USE_EXTENDED_DEBUG) && 0
 static void msDebugTextPath(textSymbolObj *ts) {
   int i;
-  msDebug("text: %s\n",ts->annotext);
-  if(ts->textpath) {
-    for(i=0;i<ts->textpath->numglyphs; i++) {
+  msDebug("text: %s\n", ts->annotext);
+  if (ts->textpath) {
+    for (i = 0; i < ts->textpath->numglyphs; i++) {
       glyphObj *g = &ts->textpath->glyphs[i];
-      msDebug("glyph %d: pos: %f %f\n",g->glyph->key.codepoint,g->pnt.x,g->pnt.y);
+      msDebug("glyph %d: pos: %f %f\n", g->glyph->key.codepoint, g->pnt.x,
+              g->pnt.y);
     }
   } else {
     msDebug("no glyphs\n");
@@ -73,39 +69,37 @@ int msComputeTextPath(mapObj *map, textS
   ts->textpath = tgret;
   tgret->absolute = 0;
   tgret->glyph_size = ts->label->size * ts->scalefactor;
-  tgret->glyph_size = MS_MAX(tgret->glyph_size, ts->label->minsize * ts->resolutionfactor);
-  tgret->glyph_size = MS_NINT(MS_MIN(tgret->glyph_size, ts->label->maxsize * ts->resolutionfactor));
+  tgret->glyph_size =
+      MS_MAX(tgret->glyph_size, ts->label->minsize * ts->resolutionfactor);
+  tgret->glyph_size = MS_NINT(
+      MS_MIN(tgret->glyph_size, ts->label->maxsize * ts->resolutionfactor));
   tgret->line_height = ceil(tgret->glyph_size * 1.33);
-  return msLayoutTextSymbol(map,ts,tgret);
+  return msLayoutTextSymbol(map, ts, tgret);
 }
 
-void initTextSymbol(textSymbolObj *ts) {
-  memset(ts,0,sizeof(*ts));
-}
+void initTextSymbol(textSymbolObj *ts) { memset(ts, 0, sizeof(*ts)); }
 
 void freeTextPath(textPathObj *tp) {
   free(tp->glyphs);
-  if(tp->bounds.poly) {
+  if (tp->bounds.poly) {
     free(tp->bounds.poly->point);
     free(tp->bounds.poly);
   }
 }
 
-void freeTextSymbol(textSymbolObj *ts) {
-    freeTextSymbolEx(ts, MS_TRUE);
-}
+void freeTextSymbol(textSymbolObj *ts) { freeTextSymbolEx(ts, MS_TRUE); }
 
 void freeTextSymbolEx(textSymbolObj *ts, int doFreeLabel) {
-  if(ts->textpath) {
+  if (ts->textpath) {
     freeTextPath(ts->textpath);
     free(ts->textpath);
   }
-  if(ts->label->numstyles) {
-    if(ts->style_bounds) {
+  if (ts->label->numstyles) {
+    if (ts->style_bounds) {
       int i;
-      for(i=0;i<ts->label->numstyles; i++) {
-        if(ts->style_bounds[i]) {
-          if(ts->style_bounds[i]->poly) {
+      for (i = 0; i < ts->label->numstyles; i++) {
+        if (ts->style_bounds[i]) {
+          if (ts->style_bounds[i]->poly) {
             free(ts->style_bounds[i]->poly->point);
             free(ts->style_bounds[i]->poly);
           }
@@ -116,7 +110,7 @@ void freeTextSymbolEx(textSymbolObj *ts,
     }
   }
   free(ts->annotext);
-  if(doFreeLabel && freeLabel(ts->label) == MS_SUCCESS) {
+  if (doFreeLabel && freeLabel(ts->label) == MS_SUCCESS) {
     free(ts->label);
   }
 }
@@ -124,19 +118,20 @@ void freeTextSymbolEx(textSymbolObj *ts,
 void msCopyTextPath(textPathObj *dst, textPathObj *src) {
   int i;
   *dst = *src;
-  if(src->bounds.poly) {
+  if (src->bounds.poly) {
     dst->bounds.poly = msSmallMalloc(sizeof(lineObj));
     dst->bounds.poly->numpoints = src->bounds.poly->numpoints;
-    dst->bounds.poly->point = msSmallMalloc(src->bounds.poly->numpoints * sizeof(pointObj));
-    for(i=0; i<src->bounds.poly->numpoints; i++) {
+    dst->bounds.poly->point =
+        msSmallMalloc(src->bounds.poly->numpoints * sizeof(pointObj));
+    for (i = 0; i < src->bounds.poly->numpoints; i++) {
       dst->bounds.poly->point[i] = src->bounds.poly->point[i];
     }
   } else {
     dst->bounds.poly = NULL;
   }
-  if(dst->numglyphs > 0) {
+  if (dst->numglyphs > 0) {
     dst->glyphs = msSmallMalloc(dst->numglyphs * sizeof(glyphObj));
-    for(i=0; i<dst->numglyphs; i++)
+    for (i = 0; i < dst->numglyphs; i++)
       dst->glyphs[i] = src->glyphs[i];
   }
 }
@@ -145,15 +140,16 @@ void msCopyTextSymbol(textSymbolObj *dst
   *dst = *src;
   MS_REFCNT_INCR(src->label);
   dst->annotext = msStrdup(src->annotext);
-  if(src->textpath) {
+  if (src->textpath) {
     dst->textpath = msSmallMalloc(sizeof(textPathObj));
-    msCopyTextPath(dst->textpath,src->textpath);
+    msCopyTextPath(dst->textpath, src->textpath);
   }
-  if(src->style_bounds) {
+  if (src->style_bounds) {
     int i;
-    dst->style_bounds = msSmallCalloc(src->label->numstyles, sizeof(label_bounds*));
-    for(i=0; i<src->label->numstyles; i++) {
-      if(src->style_bounds[i]) {
+    dst->style_bounds =
+        msSmallCalloc(src->label->numstyles, sizeof(label_bounds *));
+    for (i = 0; i < src->label->numstyles; i++) {
+      if (src->style_bounds[i]) {
         dst->style_bounds[i] = msSmallMalloc(sizeof(label_bounds));
         copyLabelBounds(dst->style_bounds[i], src->style_bounds[i]);
       }
@@ -163,27 +159,31 @@ void msCopyTextSymbol(textSymbolObj *dst
 
 static int labelNeedsDeepCopy(labelObj *label) {
   int i;
-  if(label->numbindings > 0) return MS_TRUE;
-  for(i=0; i<label->numstyles; i++) {
-    if(label->styles[i]->numbindings>0) {
+  if (label->numbindings > 0)
+    return MS_TRUE;
+  for (i = 0; i < label->numstyles; i++) {
+    if (label->styles[i]->numbindings > 0) {
       return MS_TRUE;
     }
   }
   return MS_FALSE;
 }
 
-void msPopulateTextSymbolForLabelAndString(textSymbolObj *ts, labelObj *l, char *string, double scalefactor, double resolutionfactor, label_cache_mode cache) {
-  if(cache == duplicate_always) {
+void msPopulateTextSymbolForLabelAndString(textSymbolObj *ts, labelObj *l,
+                                           char *string, double scalefactor,
+                                           double resolutionfactor,
+                                           label_cache_mode cache) {
+  if (cache == duplicate_always) {
     ts->label = msSmallMalloc(sizeof(labelObj));
     initLabel(ts->label);
-    msCopyLabel(ts->label,l);
-  } else if(cache == duplicate_never) {
+    msCopyLabel(ts->label, l);
+  } else if (cache == duplicate_never) {
     ts->label = l;
     MS_REFCNT_INCR(l);
-  } else if(cache == duplicate_if_needed && labelNeedsDeepCopy(l)) {
+  } else if (cache == duplicate_if_needed && labelNeedsDeepCopy(l)) {
     ts->label = msSmallMalloc(sizeof(labelObj));
     initLabel(ts->label);
-    msCopyLabel(ts->label,l);
+    msCopyLabel(ts->label, l);
   } else {
     ts->label = l;
     MS_REFCNT_INCR(l);
@@ -194,14 +194,15 @@ void msPopulateTextSymbolForLabelAndStri
   ts->rotation = l->angle * MS_DEG_TO_RAD;
 }
 
-int msAddLabelGroup(mapObj *map, imageObj *image, layerObj* layer, int classindex, shapeObj *shape, pointObj *point, double featuresize)
-{
-  int l,s, priority;
+int msAddLabelGroup(mapObj *map, imageObj *image, layerObj *layer,
+                    int classindex, shapeObj *shape, pointObj *point,
+                    double featuresize) {
+  int l, s, priority;
   labelCacheSlotObj *cacheslot;
 
-  labelCacheMemberObj *cachePtr=NULL;
-  layerObj *layerPtr=NULL;
-  classObj *classPtr=NULL;
+  labelCacheMemberObj *cachePtr = NULL;
+  layerObj *layerPtr = NULL;
+  classObj *classPtr = NULL;
   int numtextsymbols = 0;
   textSymbolObj **textsymbols, *ts;
   int layerindex = layer->index;
@@ -211,69 +212,82 @@ int msAddLabelGroup(mapObj *map, imageOb
   layerPtr = layer;
   classPtr = layer->class[classindex];
 
-  if(classPtr->numlabels == 0) return MS_SUCCESS; /* not an error just nothing to do */
+  if (classPtr->numlabels == 0)
+    return MS_SUCCESS; /* not an error just nothing to do */
 
   /* check that the label intersects the layer mask */
-  if(layerPtr->mask) {
-    int maskLayerIdx = msGetLayerIndex(map,layerPtr->mask);
-    layerObj *maskLayer = GET_LAYER(map,maskLayerIdx);
+  if (layerPtr->mask) {
+    int maskLayerIdx = msGetLayerIndex(map, layerPtr->mask);
+    layerObj *maskLayer = GET_LAYER(map, maskLayerIdx);
     unsigned char *alphapixptr;
-    if(maskLayer->maskimage && MS_IMAGE_RENDERER(maskLayer->maskimage)->supports_pixel_buffer) {
+    if (maskLayer->maskimage &&
+        MS_IMAGE_RENDERER(maskLayer->maskimage)->supports_pixel_buffer) {
       rasterBufferObj rb;
-      int x,y;
-      memset(&rb,0,sizeof(rasterBufferObj));
-      if(MS_UNLIKELY(MS_FAILURE == MS_IMAGE_RENDERER(maskLayer->maskimage)->getRasterBufferHandle(maskLayer->maskimage,&rb))) {
+      int x, y;
+      memset(&rb, 0, sizeof(rasterBufferObj));
+      if (MS_UNLIKELY(MS_FAILURE ==
+                      MS_IMAGE_RENDERER(maskLayer->maskimage)
+                          ->getRasterBufferHandle(maskLayer->maskimage, &rb))) {
         return MS_FAILURE;
       }
       x = MS_NINT(point->x);
       y = MS_NINT(point->y);
-      /* Using label repeatdistance, we might have a point with x/y below 0. See #4764 */
+      /* Using label repeatdistance, we might have a point with x/y below 0. See
+       * #4764 */
       if (x >= 0 && x < (int)rb.width && y >= 0 && y < (int)rb.height) {
         assert(rb.type == MS_BUFFER_BYTE_RGBA);
-        alphapixptr = rb.data.rgba.a+rb.data.rgba.row_step*y + rb.data.rgba.pixel_step*x;
-        if(!*alphapixptr) {
+        alphapixptr = rb.data.rgba.a + rb.data.rgba.row_step * y +
+                      rb.data.rgba.pixel_step * x;
+        if (!*alphapixptr) {
           /* label point does not intersect mask */
           return MS_SUCCESS;
         }
       } else {
-        return MS_SUCCESS; /* label point does not intersect image extent, we cannot know if it intersects
-                             mask, so we discard it (#5237)*/
+        return MS_SUCCESS; /* label point does not intersect image extent, we
+                             cannot know if it intersects mask, so we discard it
+                             (#5237)*/
       }
     } else {
-      msSetError(MS_MISCERR, "Layer (%s) references references a mask layer, but the selected renderer does not support them", "msAddLabelGroup()", layerPtr->name);
+      msSetError(MS_MISCERR,
+                 "Layer (%s) references references a mask layer, but the "
+                 "selected renderer does not support them",
+                 "msAddLabelGroup()", layerPtr->name);
       return (MS_FAILURE);
     }
   }
 
-  textsymbols = msSmallMalloc(classPtr->numlabels * sizeof(textSymbolObj*));
+  textsymbols = msSmallMalloc(classPtr->numlabels * sizeof(textSymbolObj *));
 
-  for(l=0; l<classPtr->numlabels; l++) {
+  for (l = 0; l < classPtr->numlabels; l++) {
     labelObj *lbl = classPtr->labels[l];
     char *annotext;
-    if(msGetLabelStatus(map,layerPtr,shape,lbl) == MS_OFF) {
+    if (msGetLabelStatus(map, layerPtr, shape, lbl) == MS_OFF) {
       continue;
     }
-    annotext = msShapeGetLabelAnnotation(layerPtr,shape,lbl);
-    if(!annotext) {
-      for(s=0;s<lbl->numstyles;s++) {
-        if(lbl->styles[s]->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOINT)
-          break; /* we have a "symbol only label, so we shouldn't skip this label */
+    annotext = msShapeGetLabelAnnotation(layerPtr, shape, lbl);
+    if (!annotext) {
+      for (s = 0; s < lbl->numstyles; s++) {
+        if (lbl->styles[s]->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOINT)
+          break; /* we have a "symbol only label, so we shouldn't skip this
+                    label */
       }
-      if(s == lbl->numstyles) {
+      if (s == lbl->numstyles) {
         continue; /* no anno text, and no label symbols */
       }
     }
     ts = msSmallMalloc(sizeof(textSymbolObj));
     initTextSymbol(ts);
-    msPopulateTextSymbolForLabelAndString(ts,lbl,annotext,layerPtr->scalefactor,image->resolutionfactor, 1);
+    msPopulateTextSymbolForLabelAndString(
+        ts, lbl, annotext, layerPtr->scalefactor, image->resolutionfactor, 1);
 
-    if(annotext && *annotext && lbl->autominfeaturesize && featuresize > 0) {
-      if(MS_UNLIKELY(MS_FAILURE == msComputeTextPath(map,ts))) {
+    if (annotext && *annotext && lbl->autominfeaturesize && featuresize > 0) {
+      if (MS_UNLIKELY(MS_FAILURE == msComputeTextPath(map, ts))) {
         freeTextSymbol(ts);
         free(ts);
         return MS_FAILURE;
       }
-      if(featuresize < (ts->textpath->bounds.bbox.maxx - ts->textpath->bounds.bbox.minx)) {
+      if (featuresize <
+          (ts->textpath->bounds.bbox.maxx - ts->textpath->bounds.bbox.minx)) {
         /* feature is too big to be drawn, skip it */
         freeTextSymbol(ts);
         free(ts);
@@ -284,29 +298,37 @@ int msAddLabelGroup(mapObj *map, imageOb
     numtextsymbols++;
   }
 
-  if(numtextsymbols == 0) {
+  if (numtextsymbols == 0) {
     free(textsymbols);
     return MS_SUCCESS;
   }
 
   /* Validate label priority value and get ref on label cache for it */
-  priority = classPtr->labels[0]->priority; /* take priority from the first label */
+  priority =
+      classPtr->labels[0]->priority; /* take priority from the first label */
   if (priority < 1)
     priority = 1;
   else if (priority > MS_MAX_LABEL_PRIORITY)
     priority = MS_MAX_LABEL_PRIORITY;
 
-  cacheslot = &(map->labelcache.slots[priority-1]);
+  cacheslot = &(map->labelcache.slots[priority - 1]);
 
-  if(cacheslot->numlabels == cacheslot->cachesize) { /* just add it to the end */
-    cacheslot->labels = (labelCacheMemberObj *) realloc(cacheslot->labels, sizeof(labelCacheMemberObj)*(cacheslot->cachesize+MS_LABELCACHEINCREMENT));
-    MS_CHECK_ALLOC(cacheslot->labels, sizeof(labelCacheMemberObj)*(cacheslot->cachesize+MS_LABELCACHEINCREMENT), MS_FAILURE);
+  if (cacheslot->numlabels ==
+      cacheslot->cachesize) { /* just add it to the end */
+    cacheslot->labels = (labelCacheMemberObj *)realloc(
+        cacheslot->labels, sizeof(labelCacheMemberObj) *
+                               (cacheslot->cachesize + MS_LABELCACHEINCREMENT));
+    MS_CHECK_ALLOC(cacheslot->labels,
+                   sizeof(labelCacheMemberObj) *
+                       (cacheslot->cachesize + MS_LABELCACHEINCREMENT),
+                   MS_FAILURE);
     cacheslot->cachesize += MS_LABELCACHEINCREMENT;
   }
 
   cachePtr = &(cacheslot->labels[cacheslot->numlabels]);
 
-  cachePtr->layerindex = layerindex; /* so we can get back to this *raw* data if necessary */
+  cachePtr->layerindex =
+      layerindex; /* so we can get back to this *raw* data if necessary */
 
   cachePtr->classindex = classindex;
 
@@ -319,24 +341,35 @@ int msAddLabelGroup(mapObj *map, imageOb
 
   cachePtr->status = MS_FALSE;
 
-  if(layerPtr->type == MS_LAYER_POINT && classPtr->numstyles > 0) {
+  if (layerPtr->type == MS_LAYER_POINT && classPtr->numstyles > 0) {
     /* cache the marker placement, it's already on the map */
-    /* TO DO: at the moment only checks the bottom style, perhaps should check all of them */
+    /* TO DO: at the moment only checks the bottom style, perhaps should check
+     * all of them */
     /* #2347: after RFC-24 classPtr->styles could be NULL so we check it */
     double w, h;
-    if(msGetMarkerSize(map, classPtr->styles[0], &w, &h, layerPtr->scalefactor) != MS_SUCCESS)
-      return(MS_FAILURE);
+    if (msGetMarkerSize(map, classPtr->styles[0], &w, &h,
+                        layerPtr->scalefactor) != MS_SUCCESS)
+      return (MS_FAILURE);
 
-    if(cacheslot->nummarkers == cacheslot->markercachesize) { /* just add it to the end */
-      cacheslot->markers = (markerCacheMemberObj *) realloc(cacheslot->markers, sizeof(markerCacheMemberObj)*(cacheslot->cachesize+MS_LABELCACHEINCREMENT));
-      MS_CHECK_ALLOC(cacheslot->markers, sizeof(markerCacheMemberObj)*(cacheslot->cachesize+MS_LABELCACHEINCREMENT), MS_FAILURE);
-      cacheslot->markercachesize+=MS_LABELCACHEINCREMENT;
+    if (cacheslot->nummarkers ==
+        cacheslot->markercachesize) { /* just add it to the end */
+      cacheslot->markers = (markerCacheMemberObj *)realloc(
+          cacheslot->markers,
+          sizeof(markerCacheMemberObj) *
+              (cacheslot->cachesize + MS_LABELCACHEINCREMENT));
+      MS_CHECK_ALLOC(cacheslot->markers,
+                     sizeof(markerCacheMemberObj) *
+                         (cacheslot->cachesize + MS_LABELCACHEINCREMENT),
+                     MS_FAILURE);
+      cacheslot->markercachesize += MS_LABELCACHEINCREMENT;
     }
 
     cacheslot->markers[cacheslot->nummarkers].bounds.minx = (point->x - .5 * w);
     cacheslot->markers[cacheslot->nummarkers].bounds.miny = (point->y - .5 * h);
-    cacheslot->markers[cacheslot->nummarkers].bounds.maxx = cacheslot->markers[cacheslot->nummarkers].bounds.minx + (w-1);
-    cacheslot->markers[cacheslot->nummarkers].bounds.maxy = cacheslot->markers[cacheslot->nummarkers].bounds.miny + (h-1);
+    cacheslot->markers[cacheslot->nummarkers].bounds.maxx =
+        cacheslot->markers[cacheslot->nummarkers].bounds.minx + (w - 1);
+    cacheslot->markers[cacheslot->nummarkers].bounds.maxy =
+        cacheslot->markers[cacheslot->nummarkers].bounds.miny + (h - 1);
     cacheslot->markers[cacheslot->nummarkers].id = cacheslot->numlabels;
 
     cachePtr->markerid = cacheslot->nummarkers;
@@ -347,21 +380,21 @@ int msAddLabelGroup(mapObj *map, imageOb
 
   cacheslot->numlabels++;
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
-int msAddLabel(mapObj *map, imageObj *image, labelObj *label, int layerindex, int classindex,
-    shapeObj *shape, pointObj *point, double featuresize, textSymbolObj *ts)
-{
+int msAddLabel(mapObj *map, imageObj *image, labelObj *label, int layerindex,
+               int classindex, shapeObj *shape, pointObj *point,
+               double featuresize, textSymbolObj *ts) {
   int i;
   labelCacheSlotObj *cacheslot;
-  labelCacheMemberObj *cachePtr=NULL;
+  labelCacheMemberObj *cachePtr = NULL;
   const char *annotext = NULL;
   char *annotextToFree = NULL;
   layerObj *layerPtr;
   classObj *classPtr;
 
-  layerPtr=GET_LAYER(map,layerindex);
+  layerPtr = GET_LAYER(map, layerindex);
   assert(layerPtr);
 
   assert(classindex < layerPtr->numclasses);
@@ -369,23 +402,22 @@ int msAddLabel(mapObj *map, imageObj *im
 
   assert(label);
 
-  if(ts)
+  if (ts)
     annotext = ts->annotext;
-  else if(shape)
-  {
-    annotextToFree = msShapeGetLabelAnnotation(layerPtr,shape,label);
+  else if (shape) {
+    annotextToFree = msShapeGetLabelAnnotation(layerPtr, shape, label);
     annotext = annotextToFree;
   }
 
-  if(!annotext) {
+  if (!annotext) {
     /* check if we have a labelpnt style */
-    for(i=0; i<label->numstyles; i++) {
-      if(label->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOINT)
+    for (i = 0; i < label->numstyles; i++) {
+      if (label->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOINT)
         break;
     }
-    if(i==label->numstyles) {
+    if (i == label->numstyles) {
       /* label has no text or marker symbols */
-      if(ts) {
+      if (ts) {
         freeTextSymbol(ts);
         free(ts);
       }
@@ -393,9 +425,10 @@ int msAddLabel(mapObj *map, imageObj *im
     }
   }
 
-  if(classPtr->leader) {
-    if(ts && ts->textpath && ts->textpath->absolute) {
-      msSetError(MS_MISCERR, "LEADERs are not supported on ANGLE FOLLOW labels", "msAddLabel()");
+  if (classPtr->leader) {
+    if (ts && ts->textpath && ts->textpath->absolute) {
+      msSetError(MS_MISCERR, "LEADERs are not supported on ANGLE FOLLOW labels",
+                 "msAddLabel()");
       return MS_FAILURE;
     }
   }
@@ -405,10 +438,13 @@ int msAddLabel(mapObj *map, imageObj *im
     int maskLayerIdx = msGetLayerIndex(map, layerPtr->mask);
     layerObj *maskLayer = GET_LAYER(map, maskLayerIdx);
     unsigned char *alphapixptr;
-    if (maskLayer->maskimage && MS_IMAGE_RENDERER(maskLayer->maskimage)->supports_pixel_buffer) {
+    if (maskLayer->maskimage &&
+        MS_IMAGE_RENDERER(maskLayer->maskimage)->supports_pixel_buffer) {
       rasterBufferObj rb;
-      memset(&rb, 0, sizeof (rasterBufferObj));
-      if(MS_UNLIKELY(MS_FAILURE == MS_IMAGE_RENDERER(maskLayer->maskimage)->getRasterBufferHandle(maskLayer->maskimage, &rb))) {
+      memset(&rb, 0, sizeof(rasterBufferObj));
+      if (MS_UNLIKELY(MS_FAILURE ==
+                      MS_IMAGE_RENDERER(maskLayer->maskimage)
+                          ->getRasterBufferHandle(maskLayer->maskimage, &rb))) {
         msFree(annotextToFree);
         return MS_FAILURE;
       }
@@ -416,12 +452,14 @@ int msAddLabel(mapObj *map, imageObj *im
       if (point) {
         int x = MS_NINT(point->x);
         int y = MS_NINT(point->y);
-        /* Using label repeatdistance, we might have a point with x/y below 0. See #4764 */
+        /* Using label repeatdistance, we might have a point with x/y below 0.
+         * See #4764 */
         if (x >= 0 && x < (int)rb.width && y >= 0 && y < (int)rb.height) {
-          alphapixptr = rb.data.rgba.a+rb.data.rgba.row_step*y + rb.data.rgba.pixel_step*x;
-          if(!*alphapixptr) {
+          alphapixptr = rb.data.rgba.a + rb.data.rgba.row_step * y +
+                        rb.data.rgba.pixel_step * x;
+          if (!*alphapixptr) {
             /* label point does not intersect mask */
-            if(ts) {
+            if (ts) {
               freeTextSymbol(ts);
               free(ts);
             }
@@ -430,8 +468,9 @@ int msAddLabel(mapObj *map, imageObj *im
           }
         } else {
           msFree(annotextToFree);
-          return MS_SUCCESS; /* label point does not intersect image extent, we cannot know if it intersects
-                                mask, so we discard it (#5237)*/
+          return MS_SUCCESS; /* label point does not intersect image extent, we
+                                cannot know if it intersects mask, so we discard
+                                it (#5237)*/
         }
       } else if (ts && ts->textpath) {
         int i = 0;
@@ -439,7 +478,8 @@ int msAddLabel(mapObj *map, imageObj *im
           int x = MS_NINT(ts->textpath->glyphs[i].pnt.x);
           int y = MS_NINT(ts->textpath->glyphs[i].pnt.y);
           if (x >= 0 && x < (int)rb.width && y >= 0 && y < (int)rb.height) {
-            alphapixptr = rb.data.rgba.a + rb.data.rgba.row_step * y + rb.data.rgba.pixel_step*x;
+            alphapixptr = rb.data.rgba.a + rb.data.rgba.row_step * y +
+                          rb.data.rgba.pixel_step * x;
             if (!*alphapixptr) {
               freeTextSymbol(ts);
               free(ts);
@@ -450,34 +490,41 @@ int msAddLabel(mapObj *map, imageObj *im
             freeTextSymbol(ts);
             free(ts);
             msFree(annotextToFree);
-            return MS_SUCCESS; /* label point does not intersect image extent, we cannot know if it intersects
-                                  mask, so we discard it (#5237)*/
+            return MS_SUCCESS; /* label point does not intersect image extent,
+                                  we cannot know if it intersects mask, so we
+                                  discard it (#5237)*/
           }
         }
       }
     } else {
-      msSetError(MS_MISCERR, "Layer (%s) references references a mask layer, but the selected renderer does not support them", "msAddLabel()", layerPtr->name);
+      msSetError(MS_MISCERR,
+                 "Layer (%s) references references a mask layer, but the "
+                 "selected renderer does not support them",
+                 "msAddLabel()", layerPtr->name);
       msFree(annotextToFree);
       return (MS_FAILURE);
     }
   }
 
-  if(!ts) {
+  if (!ts) {
     ts = msSmallMalloc(sizeof(textSymbolObj));
     initTextSymbol(ts);
-    msPopulateTextSymbolForLabelAndString(ts,label,annotextToFree,layerPtr->scalefactor,image->resolutionfactor, 1);
+    msPopulateTextSymbolForLabelAndString(ts, label, annotextToFree,
+                                          layerPtr->scalefactor,
+                                          image->resolutionfactor, 1);
     // annotextToFree = NULL;
   }
 
-  if(annotext && label->autominfeaturesize && featuresize > 0) {
-    if(!ts->textpath) {
-      if(MS_UNLIKELY(MS_FAILURE == msComputeTextPath(map,ts)))
+  if (annotext && label->autominfeaturesize && featuresize > 0) {
+    if (!ts->textpath) {
+      if (MS_UNLIKELY(MS_FAILURE == msComputeTextPath(map, ts)))
         return MS_FAILURE;
     }
-    if(!ts->textpath) {
+    if (!ts->textpath) {
       return MS_FAILURE;
     }
-    if(featuresize > (ts->textpath->bounds.bbox.maxx - ts->textpath->bounds.bbox.minx)) {
+    if (featuresize >
+        (ts->textpath->bounds.bbox.maxx - ts->textpath->bounds.bbox.minx)) {
       /* feature is too big to be drawn, skip it */
       freeTextSymbol(ts);
       free(ts);
@@ -485,67 +532,89 @@ int msAddLabel(mapObj *map, imageObj *im
     }
   }
 
-
-
   /* Validate label priority value and get ref on label cache for it */
   if (label->priority < 1)
     label->priority = 1;
   else if (label->priority > MS_MAX_LABEL_PRIORITY)
     label->priority = MS_MAX_LABEL_PRIORITY;
 
-  cacheslot = &(map->labelcache.slots[label->priority-1]);
+  cacheslot = &(map->labelcache.slots[label->priority - 1]);
 
-  if(cacheslot->numlabels == cacheslot->cachesize) { /* just add it to the end */
-    cacheslot->labels = (labelCacheMemberObj *) realloc(cacheslot->labels, sizeof(labelCacheMemberObj)*(cacheslot->cachesize+MS_LABELCACHEINCREMENT));
-    MS_CHECK_ALLOC(cacheslot->labels, sizeof(labelCacheMemberObj)*(cacheslot->cachesize+MS_LABELCACHEINCREMENT), MS_FAILURE);
+  if (cacheslot->numlabels ==
+      cacheslot->cachesize) { /* just add it to the end */
+    cacheslot->labels = (labelCacheMemberObj *)realloc(
+        cacheslot->labels, sizeof(labelCacheMemberObj) *
+                               (cacheslot->cachesize + MS_LABELCACHEINCREMENT));
+    MS_CHECK_ALLOC(cacheslot->labels,
+                   sizeof(labelCacheMemberObj) *
+                       (cacheslot->cachesize + MS_LABELCACHEINCREMENT),
+                   MS_FAILURE);
     cacheslot->cachesize += MS_LABELCACHEINCREMENT;
   }
 
   cachePtr = &(cacheslot->labels[cacheslot->numlabels]);
 
-  cachePtr->layerindex = layerindex; /* so we can get back to this *raw* data if necessary */
+  cachePtr->layerindex =
+      layerindex; /* so we can get back to this *raw* data if necessary */
   cachePtr->classindex = classindex;
   cachePtr->leaderline = NULL;
   cachePtr->leaderbbox = NULL;
 
   /* Store the label point or the label path (Bug #1620) */
-  if ( point ) {
+  if (point) {
     cachePtr->point = *point; /* the actual label point */
   } else {
-    assert(ts && ts->textpath && ts->textpath->absolute && ts->textpath->numglyphs>0);
+    assert(ts && ts->textpath && ts->textpath->absolute &&
+           ts->textpath->numglyphs > 0);
     /* Use the middle point of the labelpath for mindistance calculations */
-    cachePtr->point = ts->textpath->glyphs[ts->textpath->numglyphs/2].pnt;
+    cachePtr->point = ts->textpath->glyphs[ts->textpath->numglyphs / 2].pnt;
   }
 
   /* copy the label */
   cachePtr->numtextsymbols = 1;
-  cachePtr->textsymbols = (textSymbolObj **) msSmallMalloc(sizeof(textSymbolObj*));
+  cachePtr->textsymbols =
+      (textSymbolObj **)msSmallMalloc(sizeof(textSymbolObj *));
   cachePtr->textsymbols[0] = ts;
   cachePtr->markerid = -1;
 
   cachePtr->status = MS_FALSE;
 
-  if(layerPtr->type == MS_LAYER_POINT && classPtr->numstyles > 0) { /* cache the marker placement, it's already on the map */
+  if (layerPtr->type == MS_LAYER_POINT &&
+      classPtr->numstyles >
+          0) { /* cache the marker placement, it's already on the map */
     double w, h;
 
-    if(cacheslot->nummarkers == cacheslot->markercachesize) { /* just add it to the end */
-      cacheslot->markers = (markerCacheMemberObj *) realloc(cacheslot->markers, sizeof(markerCacheMemberObj)*(cacheslot->cachesize+MS_LABELCACHEINCREMENT));
-      MS_CHECK_ALLOC(cacheslot->markers, sizeof(markerCacheMemberObj)*(cacheslot->cachesize+MS_LABELCACHEINCREMENT), MS_FAILURE);
-      cacheslot->markercachesize+=MS_LABELCACHEINCREMENT;
+    if (cacheslot->nummarkers ==
+        cacheslot->markercachesize) { /* just add it to the end */
+      cacheslot->markers = (markerCacheMemberObj *)realloc(
+          cacheslot->markers,
+          sizeof(markerCacheMemberObj) *
+              (cacheslot->cachesize + MS_LABELCACHEINCREMENT));
+      MS_CHECK_ALLOC(cacheslot->markers,
+                     sizeof(markerCacheMemberObj) *
+                         (cacheslot->cachesize + MS_LABELCACHEINCREMENT),
+                     MS_FAILURE);
+      cacheslot->markercachesize += MS_LABELCACHEINCREMENT;
     }
 
     i = cacheslot->nummarkers;
 
-    /* TO DO: at the moment only checks the bottom style, perhaps should check all of them */
+    /* TO DO: at the moment only checks the bottom style, perhaps should check
+     * all of them */
     /* #2347: after RFC-24 classPtr->styles could be NULL so we check it */
-    if(classPtr->styles != NULL) {
-      if(msGetMarkerSize(map, classPtr->styles[0], &w, &h, layerPtr->scalefactor) != MS_SUCCESS)
-        return(MS_FAILURE);
+    if (classPtr->styles != NULL) {
+      if (msGetMarkerSize(map, classPtr->styles[0], &w, &h,
+                          layerPtr->scalefactor) != MS_SUCCESS)
+        return (MS_FAILURE);
       assert(point);
-      cacheslot->markers[cacheslot->nummarkers].bounds.minx = (point->x - .5 * w);
-      cacheslot->markers[cacheslot->nummarkers].bounds.miny = (point->y - .5 * h);
-      cacheslot->markers[cacheslot->nummarkers].bounds.maxx = cacheslot->markers[cacheslot->nummarkers].bounds.minx + (w-1);
-      cacheslot->markers[cacheslot->nummarkers].bounds.maxy = cacheslot->markers[cacheslot->nummarkers].bounds.miny + (h-1);
+      cacheslot->markers[cacheslot->nummarkers].bounds.minx =
+          (point->x - .5 * w);
+      cacheslot->markers[cacheslot->nummarkers].bounds.miny =
+          (point->y - .5 * h);
+      cacheslot->markers[cacheslot->nummarkers].bounds.maxx =
+          cacheslot->markers[cacheslot->nummarkers].bounds.minx + (w - 1);
+      cacheslot->markers[cacheslot->nummarkers].bounds.maxy =
+          cacheslot->markers[cacheslot->nummarkers].bounds.miny + (h - 1);
       cacheslot->markers[i].id = cacheslot->numlabels;
 
       cachePtr->markerid = i;
@@ -556,7 +625,7 @@ int msAddLabel(mapObj *map, imageObj *im
 
   cacheslot->numlabels++;
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
 /*
@@ -564,80 +633,87 @@ int msAddLabel(mapObj *map, imageObj *im
 ** image for no labels (effectively making image larger. The gutter can be
 ** negative in cases where a label has a buffer around it.
 */
-static int labelInImage(int width, int height, lineObj *lpoly, rectObj *bounds, int gutter)
-{
+static int labelInImage(int width, int height, lineObj *lpoly, rectObj *bounds,
+                        int gutter) {
   int j;
 
   /* do a bbox test first */
-  if(bounds->minx >= gutter &&
-      bounds->miny >= gutter &&
-      bounds->maxx < width-gutter &&
-      bounds->maxy < height-gutter) {
+  if (bounds->minx >= gutter && bounds->miny >= gutter &&
+      bounds->maxx < width - gutter && bounds->maxy < height - gutter) {
     return MS_TRUE;
   }
 
-  if(lpoly) {
-    for(j=1; j<lpoly->numpoints; j++) {
-      if(lpoly->point[j].x < gutter) return(MS_FALSE);
-      if(lpoly->point[j].x >= width-gutter) return(MS_FALSE);
-      if(lpoly->point[j].y < gutter) return(MS_FALSE);
-      if(lpoly->point[j].y >= height-gutter) return(MS_FALSE);
+  if (lpoly) {
+    for (j = 1; j < lpoly->numpoints; j++) {
+      if (lpoly->point[j].x < gutter)
+        return (MS_FALSE);
+      if (lpoly->point[j].x >= width - gutter)
+        return (MS_FALSE);
+      if (lpoly->point[j].y < gutter)
+        return (MS_FALSE);
+      if (lpoly->point[j].y >= height - gutter)
+        return (MS_FALSE);
     }
   } else {
     /* if no poly, then return false as the boundong box intersected */
     return MS_FALSE;
   }
 
-  return(MS_TRUE);
+  return (MS_TRUE);
 }
 
 void insertRenderedLabelMember(mapObj *map, labelCacheMemberObj *cachePtr) {
-  if(map->labelcache.num_rendered_members == map->labelcache.num_allocated_rendered_members) {
-    if(map->labelcache.num_rendered_members == 0) {
+  if (map->labelcache.num_rendered_members ==
+      map->labelcache.num_allocated_rendered_members) {
+    if (map->labelcache.num_rendered_members == 0) {
       map->labelcache.num_allocated_rendered_members = 50;
     } else {
       map->labelcache.num_allocated_rendered_members *= 2;
     }
-    map->labelcache.rendered_text_symbols = msSmallRealloc(map->labelcache.rendered_text_symbols,
-            map->labelcache.num_allocated_rendered_members * sizeof(labelCacheMemberObj*));
-  }
-  map->labelcache.rendered_text_symbols[map->labelcache.num_rendered_members++] = cachePtr;
+    map->labelcache.rendered_text_symbols =
+        msSmallRealloc(map->labelcache.rendered_text_symbols,
+                       map->labelcache.num_allocated_rendered_members *
+                           sizeof(labelCacheMemberObj *));
+  }
+  map->labelcache
+      .rendered_text_symbols[map->labelcache.num_rendered_members++] = cachePtr;
 }
 
-static inline int testSegmentLabelBBoxIntersection(const rectObj *leaderbbox, const pointObj *lp1,
-    const pointObj *lp2, const label_bounds *test) {
-  if(msRectOverlap(leaderbbox, &test->bbox)) {
-    if(test->poly) {
+static inline int testSegmentLabelBBoxIntersection(const rectObj *leaderbbox,
+                                                   const pointObj *lp1,
+                                                   const pointObj *lp2,
+                                                   const label_bounds *test) {
+  if (msRectOverlap(leaderbbox, &test->bbox)) {
+    if (test->poly) {
       int pp;
-      for(pp=1; pp<test->poly->numpoints; pp++) {
-        if(msIntersectSegments(
-            &(test->poly->point[pp-1]),
-            &(test->poly->point[pp]),
-            lp1,lp2) ==  MS_TRUE) {
-          return(MS_FALSE);
+      for (pp = 1; pp < test->poly->numpoints; pp++) {
+        if (msIntersectSegments(&(test->poly->point[pp - 1]),
+                                &(test->poly->point[pp]), lp1,
+                                lp2) == MS_TRUE) {
+          return (MS_FALSE);
         }
       }
     } else {
-      pointObj tp1 = {0},tp2 = {0};
+      pointObj tp1 = {0}, tp2 = {0};
       tp1.x = test->bbox.minx;
       tp1.y = test->bbox.miny;
       tp2.x = test->bbox.minx;
       tp2.y = test->bbox.maxy;
-      if(msIntersectSegments(lp1,lp2,&tp1,&tp2))
+      if (msIntersectSegments(lp1, lp2, &tp1, &tp2))
         return MS_FALSE;
       tp2.x = test->bbox.maxx;
       tp2.y = test->bbox.miny;
-      if(msIntersectSegments(lp1,lp2,&tp1,&tp2))
+      if (msIntersectSegments(lp1, lp2, &tp1, &tp2))
         return MS_FALSE;
       tp1.x = test->bbox.maxx;
       tp1.y = test->bbox.maxy;
       tp2.x = test->bbox.minx;
       tp2.y = test->bbox.maxy;
-      if(msIntersectSegments(lp1,lp2,&tp1,&tp2))
+      if (msIntersectSegments(lp1, lp2, &tp1, &tp2))
         return MS_FALSE;
       tp2.x = test->bbox.maxx;
       tp2.y = test->bbox.miny;
-      if(msIntersectSegments(lp1,lp2,&tp1,&tp2))
+      if (msIntersectSegments(lp1, lp2, &tp1, &tp2))
         return MS_FALSE;
     }
   }
@@ -647,35 +723,41 @@ static inline int testSegmentLabelBBoxIn
 int msTestLabelCacheLeaderCollision(mapObj *map, pointObj *lp1, pointObj *lp2) {
   int p;
   rectObj leaderbbox;
-  leaderbbox.minx = MS_MIN(lp1->x,lp2->x);
-  leaderbbox.maxx = MS_MAX(lp1->x,lp2->x);
-  leaderbbox.miny = MS_MIN(lp1->y,lp2->y);
-  leaderbbox.maxy = MS_MAX(lp1->y,lp2->y);
-  for(p=0; p<map->labelcache.num_rendered_members; p++) {
-    labelCacheMemberObj *curCachePtr= map->labelcache.rendered_text_symbols[p];
-    if(msRectOverlap(&leaderbbox, &(curCachePtr->bbox))) {
-    /* leaderbbox interesects with the curCachePtr's global bbox */
+  leaderbbox.minx = MS_MIN(lp1->x, lp2->x);
+  leaderbbox.maxx = MS_MAX(lp1->x, lp2->x);
+  leaderbbox.miny = MS_MIN(lp1->y, lp2->y);
+  leaderbbox.maxy = MS_MAX(lp1->y, lp2->y);
+  for (p = 0; p < map->labelcache.num_rendered_members; p++) {
+    labelCacheMemberObj *curCachePtr = map->labelcache.rendered_text_symbols[p];
+    if (msRectOverlap(&leaderbbox, &(curCachePtr->bbox))) {
+      /* leaderbbox interesects with the curCachePtr's global bbox */
       int t;
-      for(t=0; t<curCachePtr->numtextsymbols; t++) {
+      for (t = 0; t < curCachePtr->numtextsymbols; t++) {
         int s;
         textSymbolObj *ts = curCachePtr->textsymbols[t];
         /* check for intersect with textpath */
-        if(ts->textpath && testSegmentLabelBBoxIntersection(&leaderbbox, lp1, lp2, &ts->textpath->bounds) == MS_FALSE) {
+        if (ts->textpath &&
+            testSegmentLabelBBoxIntersection(
+                &leaderbbox, lp1, lp2, &ts->textpath->bounds) == MS_FALSE) {
           return MS_FALSE;
         }
         /* check for intersect with label's labelpnt styles */
-        if(ts->style_bounds) {
-          for(s=0; s<ts->label->numstyles; s++) {
-            if(ts->label->styles[s]->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOINT) {
-              if(testSegmentLabelBBoxIntersection(&leaderbbox, lp1,lp2, ts->style_bounds[s]) == MS_FALSE) {
+        if (ts->style_bounds) {
+          for (s = 0; s < ts->label->numstyles; s++) {
+            if (ts->label->styles[s]->_geomtransform.type ==
+                MS_GEOMTRANSFORM_LABELPOINT) {
+              if (testSegmentLabelBBoxIntersection(
+                      &leaderbbox, lp1, lp2, ts->style_bounds[s]) == MS_FALSE) {
                 return MS_FALSE;
               }
             }
           }
         }
       }
-      if(curCachePtr->leaderbbox) {
-        if(msIntersectSegments(lp1,lp2,&(curCachePtr->leaderline->point[0]), &(curCachePtr->leaderline->point[1])) ==  MS_TRUE) {
+      if (curCachePtr->leaderbbox) {
+        if (msIntersectSegments(lp1, lp2, &(curCachePtr->leaderline->point[0]),
+                                &(curCachePtr->leaderline->point[1])) ==
+            MS_TRUE) {
           return MS_FALSE;
         }
       }
@@ -686,25 +768,28 @@ int msTestLabelCacheLeaderCollision(mapO
 
 /* msTestLabelCacheCollisions()
 **
-** Compares label bounds (in *bounds) against labels already drawn and markers from cache and
-** returns MS_FALSE if it collides with another label, or collides with a marker.
+** Compares label bounds (in *bounds) against labels already drawn and markers
+from cache and
+** returns MS_FALSE if it collides with another label, or collides with a
+marker.
 **
 ** This function is used by the various msDrawLabelCacheXX() implementations.
 
-int msTestLabelCacheCollisions(mapObj *map, labelCacheMemberObj *cachePtr, label_bounds *bounds,
-              int current_priority, int current_label);
+int msTestLabelCacheCollisions(mapObj *map, labelCacheMemberObj *cachePtr,
+label_bounds *bounds, int current_priority, int current_label);
 */
-int msTestLabelCacheCollisions(mapObj *map, labelCacheMemberObj *cachePtr, label_bounds *lb,
-        int current_priority, int current_label)
-{
+int msTestLabelCacheCollisions(mapObj *map, labelCacheMemberObj *cachePtr,
+                               label_bounds *lb, int current_priority,
+                               int current_label) {
   labelCacheObj *labelcache = &(map->labelcache);
   int i, p, ll;
 
   /*
    * Check against image bounds first
    */
-  if(!cachePtr->textsymbols[0]->label->partials) {
-    if(labelInImage(map->width, map->height, lb->poly, &lb->bbox, labelcache->gutter) == MS_FALSE) {
+  if (!cachePtr->textsymbols[0]->label->partials) {
+    if (labelInImage(map->width, map->height, lb->poly, &lb->bbox,
+                     labelcache->gutter) == MS_FALSE) {
       return MS_FALSE;
     }
   }
@@ -712,33 +797,43 @@ int msTestLabelCacheCollisions(mapObj *m
   /* Compare against all rendered markers from this priority level and higher.
   ** Labels can overlap their own marker and markers from lower priority levels
   */
-  for (p=current_priority; p < MS_MAX_LABEL_PRIORITY; p++) {
+  for (p = current_priority; p < MS_MAX_LABEL_PRIORITY; p++) {
     labelCacheSlotObj *markerslot;
     markerslot = &(labelcache->slots[p]);
 
-    for ( ll = 0; ll < markerslot->nummarkers; ll++ ) {
-      if ( !(p == current_priority && current_label == markerslot->markers[ll].id ) ) {  /* labels can overlap their own marker */
-        if ( intersectLabelPolygons(NULL, &markerslot->markers[ll].bounds, lb->poly, &lb->bbox ) == MS_TRUE ) {
+    for (ll = 0; ll < markerslot->nummarkers; ll++) {
+      if (!(p == current_priority &&
+            current_label ==
+                markerslot->markers[ll]
+                    .id)) { /* labels can overlap their own marker */
+        if (intersectLabelPolygons(NULL, &markerslot->markers[ll].bounds,
+                                   lb->poly, &lb->bbox) == MS_TRUE) {
           return MS_FALSE;
         }
       }
     }
   }
 
-  for(p=0; p<labelcache->num_rendered_members; p++) {
-    labelCacheMemberObj *curCachePtr= labelcache->rendered_text_symbols[p];
-    if(msRectOverlap(&curCachePtr->bbox,&lb->bbox)) {
-      for(i=0; i<curCachePtr->numtextsymbols; i++) {
+  for (p = 0; p < labelcache->num_rendered_members; p++) {
+    labelCacheMemberObj *curCachePtr = labelcache->rendered_text_symbols[p];
+    if (msRectOverlap(&curCachePtr->bbox, &lb->bbox)) {
+      for (i = 0; i < curCachePtr->numtextsymbols; i++) {
         int j;
         textSymbolObj *ts = curCachePtr->textsymbols[i];
-        if(ts->textpath && intersectLabelPolygons(ts->textpath->bounds.poly, &ts->textpath->bounds.bbox, lb->poly, &lb->bbox) == MS_TRUE ) {
+        if (ts->textpath &&
+            intersectLabelPolygons(ts->textpath->bounds.poly,
+                                   &ts->textpath->bounds.bbox, lb->poly,
+                                   &lb->bbox) == MS_TRUE) {
           return MS_FALSE;
         }
-        if(ts->style_bounds) {
-          for(j=0;j<ts->label->numstyles;j++) {
-            if(ts->style_bounds[j] && ts->label->styles[j]->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOINT) {
-              if(intersectLabelPolygons(ts->style_bounds[j]->poly, &ts->style_bounds[j]->bbox,
-                  lb->poly, &lb->bbox)) {
+        if (ts->style_bounds) {
+          for (j = 0; j < ts->label->numstyles; j++) {
+            if (ts->style_bounds[j] &&
+                ts->label->styles[j]->_geomtransform.type ==
+                    MS_GEOMTRANSFORM_LABELPOINT) {
+              if (intersectLabelPolygons(ts->style_bounds[j]->poly,
+                                         &ts->style_bounds[j]->bbox, lb->poly,
+                                         &lb->bbox)) {
                 return MS_FALSE;
               }
             }
@@ -746,9 +841,10 @@ int msTestLabelCacheCollisions(mapObj *m
         }
       }
     }
-    if(curCachePtr->leaderline) {
-      if(testSegmentLabelBBoxIntersection(curCachePtr->leaderbbox, &curCachePtr->leaderline->point[0],
-          &curCachePtr->leaderline->point[1], lb) == MS_FALSE) {
+    if (curCachePtr->leaderline) {
+      if (testSegmentLabelBBoxIntersection(
+              curCachePtr->leaderbbox, &curCachePtr->leaderline->point[0],
+              &curCachePtr->leaderline->point[1], lb) == MS_FALSE) {
         return MS_FALSE;
       }
     }
@@ -756,23 +852,23 @@ int msTestLabelCacheCollisions(mapObj *m
   return MS_TRUE;
 }
 
-/* utility function to get the rect of a string outside of a rendering loop, i.e.
- without going through textpath layouts */
-int msGetStringSize(mapObj *map, labelObj *label, int size, char *string, rectObj *r) {
+/* utility function to get the rect of a string outside of a rendering loop,
+ i.e. without going through textpath layouts */
+int msGetStringSize(mapObj *map, labelObj *label, int size, char *string,
+                    rectObj *r) {
   textSymbolObj ts;
   double lsize = label->size;
   initTextSymbol(&ts);
   label->size = size;
-  msPopulateTextSymbolForLabelAndString(&ts,label,msStrdup(string),1,1,0);
-  if(MS_UNLIKELY(MS_FAILURE == msGetTextSymbolSize(map,&ts,r)))
+  msPopulateTextSymbolForLabelAndString(&ts, label, msStrdup(string), 1, 1, 0);
+  if (MS_UNLIKELY(MS_FAILURE == msGetTextSymbolSize(map, &ts, r)))
     return MS_FAILURE;
   label->size = lsize;
   freeTextSymbol(&ts);
   return MS_SUCCESS;
 }
 
-int msInitFontSet(fontSetObj *fontset)
-{
+int msInitFontSet(fontSetObj *fontset) {
   fontset->filename = NULL;
 
   /* fontset->fonts = NULL; */
@@ -780,11 +876,10 @@ int msInitFontSet(fontSetObj *fontset)
 
   fontset->numfonts = 0;
   fontset->map = NULL;
-  return( 0 );
+  return (0);
 }
 
-int msFreeFontSet(fontSetObj *fontset)
-{
+int msFreeFontSet(fontSetObj *fontset) {
   if (fontset->filename)
     free(fontset->filename);
   fontset->filename = NULL;
@@ -793,24 +888,23 @@ int msFreeFontSet(fontSetObj *fontset)
   /* fontset->fonts = NULL; */
   fontset->numfonts = 0;
 
-  return( 0 );
+  return (0);
 }
 
-int msLoadFontSet(fontSetObj *fontset, mapObj *map)
-{
+int msLoadFontSet(fontSetObj *fontset, mapObj *map) {
   VSILFILE *stream;
-  const char* line;
+  const char *line;
   char *path;
   char szPath[MS_MAXPATHLEN];
   int i;
   int bFullPath = 0;
-  const char* realpath;
+  const char *realpath;
 
-  if(fontset->numfonts != 0) /* already initialized */
-    return(0);
+  if (fontset->numfonts != 0) /* already initialized */
+    return (0);
 
-  if(!fontset->filename)
-    return(0);
+  if (!fontset->filename)
+    return (0);
 
   fontset->map = (mapObj *)map;
 
@@ -818,41 +912,43 @@ int msLoadFontSet(fontSetObj *fontset, m
 
   /* fontset->fonts = msCreateHashTable(); // create font hash */
   /* if(!fontset->fonts) { */
-  /* msSetError(MS_HASHERR, "Error initializing font hash.", "msLoadFontSet()"); */
+  /* msSetError(MS_HASHERR, "Error initializing font hash.", "msLoadFontSet()");
+   */
   /* return(-1); */
   /* } */
 
   realpath = msBuildPath(szPath, fontset->map->mappath, fontset->filename);
-  if( !realpath ) {
+  if (!realpath) {
     free(path);
     return -1;
   }
-  stream = VSIFOpenL( realpath, "rb");
-  if(!stream) {
+  stream = VSIFOpenL(realpath, "rb");
+  if (!stream) {
     msSetError(MS_IOERR, "Error opening fontset %s.", "msLoadFontset()",
                fontset->filename);
     free(path);
-    return(-1);
+    return (-1);
   }
 
   i = 0;
-  while( (line = CPLReadLineL(stream)) != NULL ) { /* while there's something to load */
+  while ((line = CPLReadLineL(stream)) !=
+         NULL) { /* while there's something to load */
 
-    if(line[0] == '#' || line[0] == '\n' || line[0] == '\r' || line[0] == ' ')
+    if (line[0] == '#' || line[0] == '\n' || line[0] == '\r' || line[0] == ' ')
       continue; /* skip comments and blank lines */
 
     char alias[64];
     snprintf(alias, sizeof(alias), "%s", line);
-    char* ptr = strpbrk(alias, " \t");
-    if( !ptr )
-        continue;
+    char *ptr = strpbrk(alias, " \t");
+    if (!ptr)
+      continue;
     *ptr = '\0';
 
-    const char* file1StartPtr = line + (ptr - alias);
-    file1StartPtr ++;
+    const char *file1StartPtr = line + (ptr - alias);
+    file1StartPtr++;
     /* Skip leading spaces */
-    while( isspace((int)*file1StartPtr) )
-        file1StartPtr ++;
+    while (isspace((int)*file1StartPtr))
+      file1StartPtr++;
 
     if (!(*file1StartPtr) || !(*alias))
       continue;
@@ -861,10 +957,9 @@ int msLoadFontSet(fontSetObj *fontset, m
     snprintf(file1, sizeof(file1), "%s", file1StartPtr);
     /* Remove trailing spaces */
     ptr = file1 + strlen(file1) - 1;
-    while( ptr >= file1 && isspace((int)*ptr) )
-    {
-        *ptr = '\0';
-        --ptr;
+    while (ptr >= file1 && isspace((int)*ptr)) {
+      *ptr = '\0';
+      --ptr;
     }
 
     bFullPath = 0;
@@ -872,11 +967,11 @@ int msLoadFontSet(fontSetObj *fontset, m
     if (file1[0] == '\\' || (strlen(file1) > 1 && (file1[1] == ':')))
       bFullPath = 1;
 #else
-    if(file1[0] == '/')
+    if (file1[0] == '/')
       bFullPath = 1;
 #endif
 
-    if(bFullPath) { /* already full path */
+    if (bFullPath) { /* already full path */
       msInsertHashTable(&(fontset->fonts), alias, file1);
     } else {
       char file2[MS_PATH_LENGTH];
@@ -890,7 +985,6 @@ int msLoadFontSet(fontSetObj *fontset, m
       */
       msInsertHashTable(&(fontset->fonts), alias,
                         msBuildPath(szPath, fontset->map->mappath, file2));
-
     }
 
     i++;
@@ -900,93 +994,94 @@ int msLoadFontSet(fontSetObj *fontset, m
   VSIFCloseL(stream); /* close the file */
   free(path);
 
-  return(0);
+  return (0);
 }
 
-
 int msGetTextSymbolSize(mapObj *map, textSymbolObj *ts, rectObj *r) {
-  if(!ts->textpath) {
-    if(MS_UNLIKELY(MS_FAILURE == msComputeTextPath(map,ts)))
+  if (!ts->textpath) {
+    if (MS_UNLIKELY(MS_FAILURE == msComputeTextPath(map, ts)))
       return MS_FAILURE;
   }
-  if(!ts->textpath)
+  if (!ts->textpath)
     return MS_FAILURE;
   *r = ts->textpath->bounds.bbox;
   return MS_SUCCESS;
 }
 /*
-** Note: All these routines assume a reference point at the LL corner of the text. GD's
-** bitmapped fonts use UL and this is compensated for. Note the rect is relative to the
+** Note: All these routines assume a reference point at the LL corner of the
+*text. GD's
+** bitmapped fonts use UL and this is compensated for. Note the rect is relative
+*to the
 ** LL corner of the text to be rendered, this is first line for TrueType fonts.
 */
 
 #define MARKER_SLOP 2
 
-pointObj get_metrics(pointObj *p, int position, textPathObj *tp, int ox, int oy, double rotation, int buffer, label_bounds *bounds)
-{
+pointObj get_metrics(pointObj *p, int position, textPathObj *tp, int ox, int oy,
+                     double rotation, int buffer, label_bounds *bounds) {
   pointObj q = {0}; // initialize
-  double x1=0, y1=0, x2=0, y2=0;
-  double sin_a,cos_a;
+  double x1 = 0, y1 = 0, x2 = 0, y2 = 0;
+  double sin_a, cos_a;
   double w, h, x, y;
 
   w = tp->bounds.bbox.maxx - tp->bounds.bbox.minx;
   h = tp->bounds.bbox.maxy - tp->bounds.bbox.miny;
 
-  switch(position) {
-    case MS_UL:
-      x1 = -w - ox;
-      y1 = -oy;
-      break;
-    case MS_UC:
-      x1 = -(w/2.0);
-      y1 = -oy - MARKER_SLOP;
-      break;
-    case MS_UR:
-      x1 = ox;
-      y1 = -oy;
-      break;
-    case MS_CL:
-      x1 = -w - ox - MARKER_SLOP;
-      if(oy > 0 && tp->numlines == 1)
-        y1 = oy;
-      else
-        y1 = (h/2.0);
-      break;
-    case MS_CC:
-      x1 = -(w/2.0) + ox;
-      y1 = (h/2.0) + oy;
-      break;
-    case MS_CR:
-      x1 = ox + MARKER_SLOP;
-      if(oy > 0 && tp->numlines == 1)
-        y1 = oy;
-      else
-        y1 = (h/2.0);
-      break;
-    case MS_LL:
-      x1 = -w - ox;
-      y1 = h + oy;
-      break;
-    case MS_LC:
-      x1 = -(w/2.0);
-      y1 = h + oy + MARKER_SLOP;
-      break;
-    case MS_LR:
-      x1 = ox;
-      y1 = h + oy;
-      break;
+  switch (position) {
+  case MS_UL:
+    x1 = -w - ox;
+    y1 = -oy;
+    break;
+  case MS_UC:
+    x1 = -(w / 2.0);
+    y1 = -oy - MARKER_SLOP;
+    break;
+  case MS_UR:
+    x1 = ox;
+    y1 = -oy;
+    break;
+  case MS_CL:
+    x1 = -w - ox - MARKER_SLOP;
+    if (oy > 0 && tp->numlines == 1)
+      y1 = oy;
+    else
+      y1 = (h / 2.0);
+    break;
+  case MS_CC:
+    x1 = -(w / 2.0) + ox;
+    y1 = (h / 2.0) + oy;
+    break;
+  case MS_CR:
+    x1 = ox + MARKER_SLOP;
+    if (oy > 0 && tp->numlines == 1)
+      y1 = oy;
+    else
+      y1 = (h / 2.0);
+    break;
+  case MS_LL:
+    x1 = -w - ox;
+    y1 = h + oy;
+    break;
+  case MS_LC:
+    x1 = -(w / 2.0);
+    y1 = h + oy + MARKER_SLOP;
+    break;
+  case MS_LR:
+    x1 = ox;
+    y1 = h + oy;
+    break;
   }
 
-  if(rotation) {
+  if (rotation) {
     sin_a = sin(rotation);
     cos_a = cos(rotation);
 
     x = x1 - tp->bounds.bbox.minx;
     y = tp->bounds.bbox.maxy - y1;
-    q.x = p->x + (x * cos_a - (y) * sin_a);
-    q.y = p->y - (x * sin_a + (y) * cos_a);
+    q.x = p->x + (x * cos_a - (y)*sin_a);
+    q.y = p->y - (x * sin_a + (y)*cos_a);
 
-    if(bounds) {
+    if (bounds) {
       x2 = x1 - buffer; /* ll */
       y2 = y1 + buffer;
       bounds->poly->point[0].x = p->x + (x2 * cos_a - (-y2) * sin_a);
@@ -1009,37 +1104,39 @@ pointObj get_metrics(pointObj *p, int po
 
       bounds->poly->point[4].x = bounds->poly->point[0].x;
       bounds->poly->point[4].y = bounds->poly->point[0].y;
-      fastComputeBounds(bounds->poly,&bounds->bbox);
+      fastComputeBounds(bounds->poly, &bounds->bbox);
     }
-  }
-  else {
+  } else {
     q.x = p->x + x1 - tp->bounds.bbox.minx;
     q.y = p->y + y1 - tp->bounds.bbox.maxy;
 
-    if(bounds) {
+    if (bounds) {
       /* no rotation, we only need to return a bbox */
       bounds->poly = NULL;
 
-
       bounds->bbox.minx = q.x - buffer;
       bounds->bbox.maxy = q.y + buffer + tp->bounds.bbox.maxy;
       bounds->bbox.maxx = q.x + w + buffer;
-      bounds->bbox.miny = bounds->bbox.maxy - h - buffer*2;
+      bounds->bbox.miny = bounds->bbox.maxy - h - buffer * 2;
     }
   }
-  return(q);
+  return (q);
 }
 
 int intersectTextSymbol(textSymbolObj *ts, label_bounds *lb) {
-  if(ts->textpath && ts->textpath->absolute) {
-    if(intersectLabelPolygons(lb->poly,&lb->bbox,ts->textpath->bounds.poly,&ts->textpath->bounds.bbox))
+  if (ts->textpath && ts->textpath->absolute) {
+    if (intersectLabelPolygons(lb->poly, &lb->bbox, ts->textpath->bounds.poly,
+                               &ts->textpath->bounds.bbox))
       return MS_TRUE;
   }
-  if(ts->style_bounds) {
+  if (ts->style_bounds) {
     int s;
-    for(s=0; s<ts->label->numstyles; s++) {
-      if(ts->style_bounds[s] && ts->label->styles[s]->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOINT &&
-          intersectLabelPolygons(lb->poly,&lb->bbox,ts->style_bounds[s]->poly, &ts->style_bounds[s]->bbox))
+    for (s = 0; s < ts->label->numstyles; s++) {
+      if (ts->style_bounds[s] &&
+          ts->label->styles[s]->_geomtransform.type ==
+              MS_GEOMTRANSFORM_LABELPOINT &&
+          intersectLabelPolygons(lb->poly, &lb->bbox, ts->style_bounds[s]->poly,
+                                 &ts->style_bounds[s]->bbox))
         return MS_TRUE;
     }
   }
@@ -1047,25 +1144,24 @@ int intersectTextSymbol(textSymbolObj *t
 }
 
 /*
-** Variation on msIntersectPolygons. Label polygons aren't like shapefile polygons. They
+** Variation on msIntersectPolygons. Label polygons aren't like shapefile
+*polygons. They
 ** have no holes, and often do have overlapping parts (i.e. road symbols).
 */
-int intersectLabelPolygons(lineObj *l1, rectObj *r1, lineObj *l2, rectObj *r2)
-{
-  int v1,v2;
+int intersectLabelPolygons(lineObj *l1, rectObj *r1, lineObj *l2, rectObj *r2) {
+  int v1, v2;
   pointObj *point;
-  lineObj *p1,*p2,sp1,sp2;
-  pointObj pnts1[5],pnts2[5];
-
+  lineObj *p1, *p2, sp1, sp2;
+  pointObj pnts1[5], pnts2[5];
 
   /* STEP 0: check bounding boxes */
-  if(!msRectOverlap(r1,r2)) { /* from alans@wunderground.com */
-    return(MS_FALSE);
+  if (!msRectOverlap(r1, r2)) { /* from alans@wunderground.com */
+    return (MS_FALSE);
   }
-  if(!l1 && !l2)
+  if (!l1 && !l2)
     return MS_TRUE;
 
-  if(!l1) {
+  if (!l1) {
     p1 = &sp1;
     p1->numpoints = 5;
     p1->point = pnts1;
@@ -1076,7 +1172,7 @@ int intersectLabelPolygons(lineObj *l1,
   } else {
     p1 = l1;
   }
-  if(!l2) {
+  if (!l2) {
     p2 = &sp2;
     p2->numpoints = 5;
     p2->point = pnts2;
@@ -1087,42 +1183,58 @@ int intersectLabelPolygons(lineObj *l1,
   } else {
     p2 = l2;
   }
-  (void)pnts1[0].x; (void)pnts1[0].y;
-  (void)pnts1[1].x; (void)pnts1[1].y;
-  (void)pnts1[2].x; (void)pnts1[2].y;
-  (void)pnts1[3].x; (void)pnts1[3].y;
-  (void)pnts1[4].x; (void)pnts1[4].y;
-  (void)pnts2[0].x; (void)pnts2[0].y;
-  (void)pnts2[1].x; (void)pnts2[1].y;
-  (void)pnts2[2].x; (void)pnts2[2].y;
-  (void)pnts2[3].x; (void)pnts2[3].y;
-  (void)pnts2[4].x; (void)pnts2[4].y;
+  (void)pnts1[0].x;
+  (void)pnts1[0].y;
+  (void)pnts1[1].x;
+  (void)pnts1[1].y;
+  (void)pnts1[2].x;
+  (void)pnts1[2].y;
+  (void)pnts1[3].x;
+  (void)pnts1[3].y;
+  (void)pnts1[4].x;
+  (void)pnts1[4].y;
+  (void)pnts2[0].x;
+  (void)pnts2[0].y;
+  (void)pnts2[1].x;
+  (void)pnts2[1].y;
+  (void)pnts2[2].x;
+  (void)pnts2[2].y;
+  (void)pnts2[3].x;
+  (void)pnts2[3].y;
+  (void)pnts2[4].x;
+  (void)pnts2[4].y;
 
   /* STEP 1: look for intersecting line segments */
-  for(v1=1; v1<p1->numpoints; v1++)
-    for(v2=1; v2<p2->numpoints; v2++)
-      if(msIntersectSegments(&(p1->point[v1-1]), &(p1->point[v1]), &(p2->point[v2-1]), &(p2->point[v2])) ==  MS_TRUE) {
-        return(MS_TRUE);
-    }
+  for (v1 = 1; v1 < p1->numpoints; v1++)
+    for (v2 = 1; v2 < p2->numpoints; v2++)
+      if (msIntersectSegments(&(p1->point[v1 - 1]), &(p1->point[v1]),
+                              &(p2->point[v2 - 1]),
+                              &(p2->point[v2])) == MS_TRUE) {
+        return (MS_TRUE);
+      }
 
-  /* STEP 2: polygon one completely contains two (only need to check one point from each part) */
+  /* STEP 2: polygon one completely contains two (only need to check one point
+   * from each part) */
   point = &(p2->point[0]);
-  if(msPointInPolygon(point, p1) == MS_TRUE) /* ok, the point is in a polygon */
-    return(MS_TRUE);
+  if (msPointInPolygon(point, p1) ==
+      MS_TRUE) /* ok, the point is in a polygon */
+    return (MS_TRUE);
 
-  /* STEP 3: polygon two completely contains one (only need to check one point from each part) */
+  /* STEP 3: polygon two completely contains one (only need to check one point
+   * from each part) */
   point = &(p1->point[0]);
-  if(msPointInPolygon(point, p2) == MS_TRUE) /* ok, the point is in a polygon */
-    return(MS_TRUE);
+  if (msPointInPolygon(point, p2) ==
+      MS_TRUE) /* ok, the point is in a polygon */
+    return (MS_TRUE);
 
-  return(MS_FALSE);
+  return (MS_FALSE);
 }
 
 /* For MapScript, exactly the same the msInsertStyle */
-int msInsertLabelStyle(labelObj *label, styleObj *style, int nStyleIndex)
-{
+int msInsertLabelStyle(labelObj *label, styleObj *style, int nStyleIndex) {
   if (!style) {
-    msSetError(MS_CHILDERR, "Can't insert a NULL Style", "msInsertLabelStyle()");
+    msSetError(MS_CHILDERR, "Can't insert a NULL Style",
+               "msInsertLabelStyle()");
     return -1;
   }
 
@@ -1132,20 +1244,21 @@ int msInsertLabelStyle(labelObj *label,
   }
   /* Catch attempt to insert past end of styles array */
   else if (nStyleIndex >= label->numstyles) {
-    msSetError(MS_CHILDERR, "Cannot insert style beyond index %d", "insertLabelStyle()", label->numstyles-1);
+    msSetError(MS_CHILDERR, "Cannot insert style beyond index %d",
+               "insertLabelStyle()", label->numstyles - 1);
     return -1;
   } else if (nStyleIndex < 0) { /* Insert at the end by default */
-    label->styles[label->numstyles]=style;
+    label->styles[label->numstyles] = style;
     MS_REFCNT_INCR(style);
     label->numstyles++;
-    return label->numstyles-1;
+    return label->numstyles - 1;
   } else {
     /* Move styles existing at the specified nStyleIndex or greater */
     /* to a higher nStyleIndex */
-    for (int i=label->numstyles-1; i>=nStyleIndex; i--) {
-      label->styles[i+1] = label->styles[i];
+    for (int i = label->numstyles - 1; i >= nStyleIndex; i--) {
+      label->styles[i + 1] = label->styles[i];
     }
-    label->styles[nStyleIndex]=style;
+    label->styles[nStyleIndex] = style;
     MS_REFCNT_INCR(style);
     label->numstyles++;
     return nStyleIndex;
@@ -1155,46 +1268,41 @@ int msInsertLabelStyle(labelObj *label,
 /**
  * Move the style up inside the array of styles.
  */
-int msMoveLabelStyleUp(labelObj *label, int nStyleIndex)
-{
-  if (label && nStyleIndex < label->numstyles && nStyleIndex >0) {
-    styleObj* psTmpStyle = (styleObj *)malloc(sizeof(styleObj));
+int msMoveLabelStyleUp(labelObj *label, int nStyleIndex) {
+  if (label && nStyleIndex < label->numstyles && nStyleIndex > 0) {
+    styleObj *psTmpStyle = (styleObj *)malloc(sizeof(styleObj));
     initStyle(psTmpStyle);
 
     msCopyStyle(psTmpStyle, label->styles[nStyleIndex]);
 
-    msCopyStyle(label->styles[nStyleIndex],
-                label->styles[nStyleIndex-1]);
+    msCopyStyle(label->styles[nStyleIndex], label->styles[nStyleIndex - 1]);
 
-    msCopyStyle(label->styles[nStyleIndex-1], psTmpStyle);
+    msCopyStyle(label->styles[nStyleIndex - 1], psTmpStyle);
 
-    return(MS_SUCCESS);
+    return (MS_SUCCESS);
   }
   msSetError(MS_CHILDERR, "Invalid index: %d", "msMoveLabelStyleUp()",
              nStyleIndex);
   return (MS_FAILURE);
 }
 
-
 /**
  * Move the style down inside the array of styles.
  */
-int msMoveLabelStyleDown(labelObj *label, int nStyleIndex)
-{
+int msMoveLabelStyleDown(labelObj *label, int nStyleIndex) {
   styleObj *psTmpStyle = NULL;
 
-  if (label && nStyleIndex < label->numstyles-1 && nStyleIndex >=0) {
+  if (label && nStyleIndex < label->numstyles - 1 && nStyleIndex >= 0) {
     psTmpStyle = (styleObj *)malloc(sizeof(styleObj));
     initStyle(psTmpStyle);
 
     msCopyStyle(psTmpStyle, label->styles[nStyleIndex]);
 
-    msCopyStyle(label->styles[nStyleIndex],
-                label->styles[nStyleIndex+1]);
+    msCopyStyle(label->styles[nStyleIndex], label->styles[nStyleIndex + 1]);
 
-    msCopyStyle(label->styles[nStyleIndex+1], psTmpStyle);
+    msCopyStyle(label->styles[nStyleIndex + 1], psTmpStyle);
 
-    return(MS_SUCCESS);
+    return (MS_SUCCESS);
   }
   msSetError(MS_CHILDERR, "Invalid index: %d", "msMoveLabelStyleDown()",
              nStyleIndex);
@@ -1205,36 +1313,35 @@ int msMoveLabelStyleDown(labelObj *label
  * Delete the style identified by the index and shift
  * styles that follows the deleted style.
  */
-int msDeleteLabelStyle(labelObj *label, int nStyleIndex)
-{
-  if (label && nStyleIndex < label->numstyles && nStyleIndex >=0) {
+int msDeleteLabelStyle(labelObj *label, int nStyleIndex) {
+  if (label && nStyleIndex < label->numstyles && nStyleIndex >= 0) {
     if (freeStyle(label->styles[nStyleIndex]) == MS_SUCCESS)
       msFree(label->styles[nStyleIndex]);
-    for (int i=nStyleIndex; i< label->numstyles-1; i++) {
-      label->styles[i] = label->styles[i+1];
+    for (int i = nStyleIndex; i < label->numstyles - 1; i++) {
+      label->styles[i] = label->styles[i + 1];
     }
-    label->styles[label->numstyles-1] = NULL;
+    label->styles[label->numstyles - 1] = NULL;
     label->numstyles--;
-    return(MS_SUCCESS);
+    return (MS_SUCCESS);
   }
   msSetError(MS_CHILDERR, "Invalid index: %d", "msDeleteLabelStyle()",
              nStyleIndex);
   return (MS_FAILURE);
 }
 
-styleObj *msRemoveLabelStyle(labelObj *label, int nStyleIndex)
-{
+styleObj *msRemoveLabelStyle(labelObj *label, int nStyleIndex) {
   int i;
   styleObj *style;
   if (nStyleIndex < 0 || nStyleIndex >= label->numstyles) {
-    msSetError(MS_CHILDERR, "Cannot remove style, invalid nStyleIndex %d", "removeLabelStyle()", nStyleIndex);
+    msSetError(MS_CHILDERR, "Cannot remove style, invalid nStyleIndex %d",
+               "removeLabelStyle()", nStyleIndex);
     return NULL;
   } else {
-    style=label->styles[nStyleIndex];
-    for (i=nStyleIndex; i<label->numstyles-1; i++) {
-      label->styles[i]=label->styles[i+1];
+    style = label->styles[nStyleIndex];
+    for (i = nStyleIndex; i < label->numstyles - 1; i++) {
+      label->styles[i] = label->styles[i + 1];
     }
-    label->styles[label->numstyles-1]=NULL;
+    label->styles[label->numstyles - 1] = NULL;
     label->numstyles--;
     MS_REFCNT_DECR(style);
     return style;
diff -pruN 8.0.1-5/maplayer.c 8.0.2-1/maplayer.c
--- 8.0.1-5/maplayer.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/maplayer.c	2024-06-11 20:41:34.000000000 +0000
@@ -38,23 +38,29 @@
 #include <assert.h>
 
 #ifndef cppcheck_assert
-#define cppcheck_assert(x) do {} while(0)
+#define cppcheck_assert(x)                                                     \
+  do {                                                                         \
+  } while (0)
 #endif
 
 static int populateVirtualTable(layerVTableObj *vtable);
 
 /*
-** Iteminfo is a layer parameter that holds information necessary to retrieve an individual item for
-** a particular source. It is an array built from a list of items. The type of iteminfo will vary by
-** source. For shapefiles and OGR it is simply an array of integers where each value is an index for
-** the item. For SDE it's a ESRI specific type that contains index and column type information. Two
-** helper functions below initialize and free that structure member which is used locally by layer
+** Iteminfo is a layer parameter that holds information necessary to retrieve an
+*individual item for
+** a particular source. It is an array built from a list of items. The type of
+*iteminfo will vary by
+** source. For shapefiles and OGR it is simply an array of integers where each
+*value is an index for
+** the item. For SDE it's a ESRI specific type that contains index and column
+*type information. Two
+** helper functions below initialize and free that structure member which is
+*used locally by layer
 ** specific functions.
 */
-int msLayerInitItemInfo(layerObj *layer)
-{
-  if ( ! layer->vtable) {
-    int rv =  msInitializeVirtualTable(layer);
+int msLayerInitItemInfo(layerObj *layer) {
+  if (!layer->vtable) {
+    int rv = msInitializeVirtualTable(layer);
     if (rv != MS_SUCCESS)
       return rv;
   }
@@ -62,11 +68,10 @@ int msLayerInitItemInfo(layerObj *layer)
   return layer->vtable->LayerInitItemInfo(layer);
 }
 
-void msLayerFreeItemInfo(layerObj *layer)
-{
-  if ( ! layer->vtable) {
-    int rv =  msInitializeVirtualTable(layer);
-    if( rv != MS_SUCCESS )
+void msLayerFreeItemInfo(layerObj *layer) {
+  if (!layer->vtable) {
+    int rv = msInitializeVirtualTable(layer);
+    if (rv != MS_SUCCESS)
       return;
   }
   cppcheck_assert(layer->vtable);
@@ -80,167 +85,184 @@ void msLayerFreeItemInfo(layerObj *layer
   msLayerFreeExpressions(layer);
 }
 
-int msLayerRestoreFromScaletokens(layerObj *layer)
-{
-  if(!layer->scaletokens || !layer->orig_st) {
+int msLayerRestoreFromScaletokens(layerObj *layer) {
+  if (!layer->scaletokens || !layer->orig_st) {
     return MS_SUCCESS;
   }
-  if(layer->orig_st->data) {
+  if (layer->orig_st->data) {
     msFree(layer->data);
     layer->data = layer->orig_st->data;
   }
-  if(layer->orig_st->tileindex) {
+  if (layer->orig_st->tileindex) {
     msFree(layer->tileindex);
     layer->tileindex = layer->orig_st->tileindex;
   }
-  if(layer->orig_st->tileitem) {
+  if (layer->orig_st->tileitem) {
     msFree(layer->tileitem);
     layer->tileitem = layer->orig_st->tileitem;
   }
-  if(layer->orig_st->filter) {
-    msLoadExpressionString(&(layer->filter),layer->orig_st->filter);
+  if (layer->orig_st->filter) {
+    msLoadExpressionString(&(layer->filter), layer->orig_st->filter);
     msFree(layer->orig_st->filter);
   }
-  if(layer->orig_st->filteritem) {
+  if (layer->orig_st->filteritem) {
     msFree(layer->filteritem);
     layer->filteritem = layer->orig_st->filteritem;
   }
-  if(layer->orig_st->n_processing) {
+  if (layer->orig_st->n_processing) {
     int i;
-    for(i=0;i<layer->orig_st->n_processing;i++) {
+    for (i = 0; i < layer->orig_st->n_processing; i++) {
       msFree(layer->processing[layer->orig_st->processing_idx[i]]);
-      layer->processing[layer->orig_st->processing_idx[i]] = layer->orig_st->processing[i];
+      layer->processing[layer->orig_st->processing_idx[i]] =
+          layer->orig_st->processing[i];
     }
     msFree(layer->orig_st->processing);
     msFree(layer->orig_st->processing_idx);
   }
   msFree(layer->orig_st);
   layer->orig_st = NULL;
-  return MS_SUCCESS; 
+  return MS_SUCCESS;
 }
 
-#define check_st_alloc(l) if(!l->orig_st) l->orig_st=msSmallCalloc(1,sizeof(originalScaleTokenStrings));
-int msLayerApplyScaletokens(layerObj *layer, double scale)
-{
-  int i,p;
-  if(!layer->scaletokens) {
+#define check_st_alloc(l)                                                      \
+  if (!l->orig_st)                                                             \
+    l->orig_st = msSmallCalloc(1, sizeof(originalScaleTokenStrings));
+int msLayerApplyScaletokens(layerObj *layer, double scale) {
+  int i, p;
+  if (!layer->scaletokens) {
     return MS_SUCCESS;
   }
   msLayerRestoreFromScaletokens(layer);
-  for(i=0;i<layer->numscaletokens;i++) {
+  for (i = 0; i < layer->numscaletokens; i++) {
     scaleTokenObj *st = &layer->scaletokens[i];
     scaleTokenEntryObj *ste = NULL;
-    if(scale<=0) {
-       ste = &(st->tokens[0]);
+    if (scale <= 0) {
+      ste = &(st->tokens[0]);
       /* no scale defined, use first entry */
     } else {
-      int tokenindex=0;
-      while(tokenindex<st->n_entries) {
+      int tokenindex = 0;
+      while (tokenindex < st->n_entries) {
         ste = &(st->tokens[tokenindex]);
-        if(scale < ste->maxscale && scale >= ste->minscale) break; /* current token is the correct one */
+        if (scale < ste->maxscale && scale >= ste->minscale)
+          break; /* current token is the correct one */
         tokenindex++;
         ste = NULL;
       }
     }
     assert(ste);
-    if(layer->data && strstr(layer->data,st->name)) {
-      if(layer->debug >= MS_DEBUGLEVEL_DEBUG) {
-        msDebug("replacing scaletoken (%s) with (%s) in layer->data (%s) for scale=%f\n",
-                st->name,ste->value,layer->name,scale);
+    if (layer->data && strstr(layer->data, st->name)) {
+      if (layer->debug >= MS_DEBUGLEVEL_DEBUG) {
+        msDebug("replacing scaletoken (%s) with (%s) in layer->data (%s) for "
+                "scale=%f\n",
+                st->name, ste->value, layer->name, scale);
       }
       check_st_alloc(layer);
       layer->orig_st->data = layer->data;
       layer->data = msStrdup(layer->data);
-      layer->data = msReplaceSubstring(layer->data,st->name,ste->value);
+      layer->data = msReplaceSubstring(layer->data, st->name, ste->value);
     }
-    if(layer->tileindex && strstr(layer->tileindex,st->name)) {
-      if(layer->debug >= MS_DEBUGLEVEL_DEBUG) {
-        msDebug("replacing scaletoken (%s) with (%s) in layer->tileindex (%s) for scale=%f\n",
-                st->name,ste->value,layer->name,scale);
+    if (layer->tileindex && strstr(layer->tileindex, st->name)) {
+      if (layer->debug >= MS_DEBUGLEVEL_DEBUG) {
+        msDebug("replacing scaletoken (%s) with (%s) in layer->tileindex (%s) "
+                "for scale=%f\n",
+                st->name, ste->value, layer->name, scale);
       }
       check_st_alloc(layer);
       layer->orig_st->tileindex = layer->tileindex;
       layer->tileindex = msStrdup(layer->tileindex);
-      layer->tileindex = msReplaceSubstring(layer->tileindex,st->name,ste->value);
+      layer->tileindex =
+          msReplaceSubstring(layer->tileindex, st->name, ste->value);
     }
-    if(layer->tileitem && strstr(layer->tileitem,st->name)) {
-      if(layer->debug >= MS_DEBUGLEVEL_DEBUG) {
-        msDebug("replacing scaletoken (%s) with (%s) in layer->tileitem (%s) for scale=%f\n",
-                st->name,ste->value,layer->name,scale);
+    if (layer->tileitem && strstr(layer->tileitem, st->name)) {
+      if (layer->debug >= MS_DEBUGLEVEL_DEBUG) {
+        msDebug("replacing scaletoken (%s) with (%s) in layer->tileitem (%s) "
+                "for scale=%f\n",
+                st->name, ste->value, layer->name, scale);
       }
       check_st_alloc(layer);
       layer->orig_st->tileitem = layer->tileitem;
       layer->tileitem = msStrdup(layer->tileitem);
-      layer->tileitem = msReplaceSubstring(layer->tileitem,st->name,ste->value);
+      layer->tileitem =
+          msReplaceSubstring(layer->tileitem, st->name, ste->value);
     }
-    if(layer->filteritem && strstr(layer->filteritem,st->name)) {
-      if(layer->debug >= MS_DEBUGLEVEL_DEBUG) {
-        msDebug("replacing scaletoken (%s) with (%s) in layer->filteritem (%s) for scale=%f\n",
-                st->name,ste->value,layer->name,scale);
+    if (layer->filteritem && strstr(layer->filteritem, st->name)) {
+      if (layer->debug >= MS_DEBUGLEVEL_DEBUG) {
+        msDebug("replacing scaletoken (%s) with (%s) in layer->filteritem (%s) "
+                "for scale=%f\n",
+                st->name, ste->value, layer->name, scale);
       }
       check_st_alloc(layer);
       layer->orig_st->filteritem = layer->filteritem;
       layer->filteritem = msStrdup(layer->filteritem);
-      layer->filteritem = msReplaceSubstring(layer->filteritem,st->name,ste->value);
+      layer->filteritem =
+          msReplaceSubstring(layer->filteritem, st->name, ste->value);
     }
-    if(layer->filter.string && strstr(layer->filter.string,st->name)) {
+    if (layer->filter.string && strstr(layer->filter.string, st->name)) {
       char *tmpval;
-      if(layer->debug >= MS_DEBUGLEVEL_DEBUG) {
-        msDebug("replacing scaletoken (%s) with (%s) in layer->filter (%s) for scale=%f\n",
-                st->name,ste->value,layer->name,scale);
+      if (layer->debug >= MS_DEBUGLEVEL_DEBUG) {
+        msDebug("replacing scaletoken (%s) with (%s) in layer->filter (%s) for "
+                "scale=%f\n",
+                st->name, ste->value, layer->name, scale);
       }
       check_st_alloc(layer);
       layer->orig_st->filter = msStrdup(layer->filter.string);
       tmpval = msStrdup(layer->filter.string);
-      tmpval = msReplaceSubstring(tmpval,st->name,ste->value);
-      if(msLoadExpressionString(&(layer->filter),tmpval) == -1) return(MS_FAILURE); /* msLoadExpressionString() cleans up previously allocated expression */
+      tmpval = msReplaceSubstring(tmpval, st->name, ste->value);
+      if (msLoadExpressionString(&(layer->filter), tmpval) == -1)
+        return (MS_FAILURE); /* msLoadExpressionString() cleans up previously
+                                allocated expression */
       msFree(tmpval);
     }
-    for(p=0;p<layer->numprocessing;p++) {
-      if(strstr(layer->processing[p],st->name)) {
+    for (p = 0; p < layer->numprocessing; p++) {
+      if (strstr(layer->processing[p], st->name)) {
         check_st_alloc(layer);
         layer->orig_st->n_processing++;
-        layer->orig_st->processing = msSmallRealloc(layer->orig_st->processing, layer->orig_st->n_processing * sizeof(char*));
-        layer->orig_st->processing_idx = msSmallRealloc(layer->orig_st->processing_idx, layer->orig_st->n_processing * sizeof(int));
-        layer->orig_st->processing[layer->orig_st->n_processing-1] = layer->processing[p];
-        layer->orig_st->processing_idx[layer->orig_st->n_processing-1] = p;
+        layer->orig_st->processing =
+            msSmallRealloc(layer->orig_st->processing,
+                           layer->orig_st->n_processing * sizeof(char *));
+        layer->orig_st->processing_idx =
+            msSmallRealloc(layer->orig_st->processing_idx,
+                           layer->orig_st->n_processing * sizeof(int));
+        layer->orig_st->processing[layer->orig_st->n_processing - 1] =
+            layer->processing[p];
+        layer->orig_st->processing_idx[layer->orig_st->n_processing - 1] = p;
         layer->processing[p] = msStrdup(layer->processing[p]);
-        layer->processing[p] = msReplaceSubstring(layer->processing[p],st->name,ste->value);
+        layer->processing[p] =
+            msReplaceSubstring(layer->processing[p], st->name, ste->value);
       }
     }
-
   }
   return MS_SUCCESS;
 }
 
-
 /*
 ** Does exactly what it implies, readies a layer for processing.
 */
-int msLayerOpen(layerObj *layer)
-{
+int msLayerOpen(layerObj *layer) {
   int rv;
 
   /* RFC-86 Scale dependant token replacements*/
-  rv = msLayerApplyScaletokens(layer,(layer->map)?layer->map->scaledenom:-1);
-  if (rv != MS_SUCCESS) return rv;
+  rv = msLayerApplyScaletokens(layer,
+                               (layer->map) ? layer->map->scaledenom : -1);
+  if (rv != MS_SUCCESS)
+    return rv;
 
   /* RFC-69 clustering support */
   if (layer->cluster.region)
     return msClusterLayerOpen(layer);
 
-  if(layer->features && layer->connectiontype != MS_GRATICULE )
+  if (layer->features && layer->connectiontype != MS_GRATICULE)
     layer->connectiontype = MS_INLINE;
 
-  if(layer->tileindex && layer->connectiontype == MS_SHAPEFILE)
+  if (layer->tileindex && layer->connectiontype == MS_SHAPEFILE)
     layer->connectiontype = MS_TILED_SHAPEFILE;
 
-  if(layer->type == MS_LAYER_RASTER && layer->connectiontype != MS_WMS
-      && layer->connectiontype != MS_KERNELDENSITY)
+  if (layer->type == MS_LAYER_RASTER && layer->connectiontype != MS_WMS &&
+      layer->connectiontype != MS_KERNELDENSITY)
     layer->connectiontype = MS_RASTER;
 
-  if ( ! layer->vtable) {
-    rv =  msInitializeVirtualTable(layer);
+  if (!layer->vtable) {
+    rv = msInitializeVirtualTable(layer);
     if (rv != MS_SUCCESS)
       return rv;
   }
@@ -249,12 +271,12 @@ int msLayerOpen(layerObj *layer)
 }
 
 /*
-** Returns MS_TRUE if layer has been opened using msLayerOpen(), MS_FALSE otherwise
+** Returns MS_TRUE if layer has been opened using msLayerOpen(), MS_FALSE
+*otherwise
 */
-int msLayerIsOpen(layerObj *layer)
-{
-  if ( ! layer->vtable) {
-    int rv =  msInitializeVirtualTable(layer);
+int msLayerIsOpen(layerObj *layer) {
+  if (!layer->vtable) {
+    int rv = msInitializeVirtualTable(layer);
     if (rv != MS_SUCCESS)
       return rv;
   }
@@ -263,12 +285,12 @@ int msLayerIsOpen(layerObj *layer)
 }
 
 /*
-** Returns MS_TRUE is a layer supports the common expression/filter syntax (RFC 64) and MS_FALSE otherwise.
+** Returns MS_TRUE is a layer supports the common expression/filter syntax (RFC
+*64) and MS_FALSE otherwise.
 */
-int msLayerSupportsCommonFilters(layerObj *layer)
-{
-  if ( ! layer->vtable) {
-    int rv =  msInitializeVirtualTable(layer);
+int msLayerSupportsCommonFilters(layerObj *layer) {
+  if (!layer->vtable) {
+    int rv = msInitializeVirtualTable(layer);
     if (rv != MS_SUCCESS)
       return rv;
   }
@@ -276,10 +298,10 @@ int msLayerSupportsCommonFilters(layerOb
   return layer->vtable->LayerSupportsCommonFilters(layer);
 }
 
-int msLayerTranslateFilter(layerObj *layer, expressionObj *filter, char *filteritem)
-{
+int msLayerTranslateFilter(layerObj *layer, expressionObj *filter,
+                           char *filteritem) {
   if (!layer->vtable) {
-    int rv =  msInitializeVirtualTable(layer);
+    int rv = msInitializeVirtualTable(layer);
     if (rv != MS_SUCCESS)
       return rv;
   }
@@ -288,22 +310,26 @@ int msLayerTranslateFilter(layerObj *lay
 }
 
 /*
-** Performs a spatial, and optionally an attribute based feature search. The function basically
-** prepares things so that candidate features can be accessed by query or drawing functions. For
-** OGR and shapefiles this sets an internal bit vector that indicates whether a particular feature
-** is to processed. For SDE it executes an SQL statement on the SDE server. Once run the msLayerNextShape
+** Performs a spatial, and optionally an attribute based feature search. The
+*function basically
+** prepares things so that candidate features can be accessed by query or
+*drawing functions. For
+** OGR and shapefiles this sets an internal bit vector that indicates whether a
+*particular feature
+** is to processed. For SDE it executes an SQL statement on the SDE server. Once
+*run the msLayerNextShape
 ** function should be called to actually access the shapes.
 **
-** Note that for shapefiles we apply any maxfeatures constraint at this point. That may be the only
+** Note that for shapefiles we apply any maxfeatures constraint at this point.
+*That may be the only
 ** connection type where this is feasible.
 */
-int msLayerWhichShapes(layerObj *layer, rectObj rect, int isQuery)
-{
-  if(!msLayerSupportsCommonFilters(layer))
+int msLayerWhichShapes(layerObj *layer, rectObj rect, int isQuery) {
+  if (!msLayerSupportsCommonFilters(layer))
     msLayerTranslateFilter(layer, &layer->filter, layer->filteritem);
 
-  if ( ! layer->vtable) {
-    int rv =  msInitializeVirtualTable(layer);
+  if (!layer->vtable) {
+    int rv = msInitializeVirtualTable(layer);
     if (rv != MS_SUCCESS)
       return rv;
   }
@@ -312,17 +338,17 @@ int msLayerWhichShapes(layerObj *layer,
 }
 
 /*
-** Called after msWhichShapes has been called to actually retrieve shapes within a given area
+** Called after msWhichShapes has been called to actually retrieve shapes within
+*a given area
 ** and matching a vendor specific filter (i.e. layer FILTER attribute).
 **
 ** Shapefiles: NULL shapes (shapes with attributes but NO vertices are skipped)
 */
-int msLayerNextShape(layerObj *layer, shapeObj *shape)
-{
+int msLayerNextShape(layerObj *layer, shapeObj *shape) {
   int rv, filter_passed;
-  
-  if ( ! layer->vtable) {
-    rv =  msInitializeVirtualTable(layer);
+
+  if (!layer->vtable) {
+    rv = msInitializeVirtualTable(layer);
     if (rv != MS_SUCCESS)
       return rv;
   }
@@ -330,53 +356,58 @@ int msLayerNextShape(layerObj *layer, sh
 
 #ifdef USE_V8_MAPSCRIPT
   /* we need to force the GetItems for the geomtransform attributes */
-  if(!layer->items &&
-     layer->_geomtransform.type == MS_GEOMTRANSFORM_EXPRESSION &&
-     strstr(layer->_geomtransform.string, "javascript"))
-      msLayerGetItems(layer);
+  if (!layer->items &&
+      layer->_geomtransform.type == MS_GEOMTRANSFORM_EXPRESSION &&
+      strstr(layer->_geomtransform.string, "javascript"))
+    msLayerGetItems(layer);
 #endif
 
   /* At the end of switch case (default -> break; -> return MS_FAILURE),
    * was following TODO ITEM:
    *
    * TO DO! This is where dynamic joins will happen. Joined attributes will be
-   * tagged on to the main attributes with the naming scheme [join name].[item name].
-   * We need to leverage the iteminfo (I think) at this point 
+   * tagged on to the main attributes with the naming scheme [join name].[item
+   * name]. We need to leverage the iteminfo (I think) at this point
    */
 
   /* RFC 91: MapServer-based filtering is done at a more general level. */
   do {
     rv = layer->vtable->LayerNextShape(layer, shape);
-    if(rv != MS_SUCCESS) return rv;
+    if (rv != MS_SUCCESS)
+      return rv;
 
-    /* attributes need to be iconv'd to UTF-8 before any filter logic is applied */
-    if(layer->encoding) {
-      rv = msLayerEncodeShapeAttributes(layer,shape);
-      if(rv != MS_SUCCESS)
+    /* attributes need to be iconv'd to UTF-8 before any filter logic is applied
+     */
+    if (layer->encoding) {
+      rv = msLayerEncodeShapeAttributes(layer, shape);
+      if (rv != MS_SUCCESS)
         return rv;
     }
 
-    filter_passed = msEvalExpression(layer, shape, &(layer->filter), layer->filteritemindex);
+    filter_passed = msEvalExpression(layer, shape, &(layer->filter),
+                                     layer->filteritemindex);
 
-    if(!filter_passed) msFreeShape(shape);
-  } while(!filter_passed);
+    if (!filter_passed)
+      msFreeShape(shape);
+  } while (!filter_passed);
 
   /* RFC89 Apply Layer GeomTransform */
-  if(layer->_geomtransform.type != MS_GEOMTRANSFORM_NONE && rv == MS_SUCCESS) {
-    rv = msGeomTransformShape(layer->map, layer, shape);      
-    if(rv != MS_SUCCESS)
+  if (layer->_geomtransform.type != MS_GEOMTRANSFORM_NONE && rv == MS_SUCCESS) {
+    rv = msGeomTransformShape(layer->map, layer, shape);
+    if (rv != MS_SUCCESS)
       return rv;
   }
 
-  
   return rv;
 }
 
 /*
-** Used to retrieve a shape from a result set by index. Result sets are created by the various
+** Used to retrieve a shape from a result set by index. Result sets are created
+*by the various
 ** msQueryBy...() functions. The index is assigned by the data source.
 */
-/* int msLayerResultsGetShape(layerObj *layer, shapeObj *shape, int tile, long record)
+/* int msLayerResultsGetShape(layerObj *layer, shapeObj *shape, int tile, long
+record)
 {
   if ( ! layer->vtable) {
     int rv =  msInitializeVirtualTable(layer);
@@ -388,39 +419,40 @@ int msLayerNextShape(layerObj *layer, sh
 } */
 
 /*
-** Used to retrieve a shape by index. All data sources must be capable of random access using
+** Used to retrieve a shape by index. All data sources must be capable of random
+*access using
 ** a record number(s) of some sort.
 */
-int msLayerGetShape(layerObj *layer, shapeObj *shape, resultObj *record)
-{
+int msLayerGetShape(layerObj *layer, shapeObj *shape, resultObj *record) {
   int rv;
-  
-  if( ! layer->vtable) {
-    rv =  msInitializeVirtualTable(layer);
-    if(rv != MS_SUCCESS)
+
+  if (!layer->vtable) {
+    rv = msInitializeVirtualTable(layer);
+    if (rv != MS_SUCCESS)
       return rv;
   }
   cppcheck_assert(layer->vtable);
 
   /*
   ** TODO: This is where dynamic joins could happen. Joined attributes would be
-  ** tagged on to the main attributes with the naming scheme [join name].[item name].
+  ** tagged on to the main attributes with the naming scheme [join name].[item
+  *name].
   */
 
   rv = layer->vtable->LayerGetShape(layer, shape, record);
-  if(rv != MS_SUCCESS)
+  if (rv != MS_SUCCESS)
     return rv;
 
   /* RFC89 Apply Layer GeomTransform */
-  if(layer->_geomtransform.type != MS_GEOMTRANSFORM_NONE) {
-    rv = msGeomTransformShape(layer->map, layer, shape); 
-    if(rv != MS_SUCCESS)
+  if (layer->_geomtransform.type != MS_GEOMTRANSFORM_NONE) {
+    rv = msGeomTransformShape(layer->map, layer, shape);
+    if (rv != MS_SUCCESS)
       return rv;
   }
 
-  if(layer->encoding) {
-    rv = msLayerEncodeShapeAttributes(layer,shape);
-    if(rv != MS_SUCCESS)
+  if (layer->encoding) {
+    rv = msLayerEncodeShapeAttributes(layer, shape);
+    if (rv != MS_SUCCESS)
       return rv;
   }
 
@@ -429,21 +461,21 @@ int msLayerGetShape(layerObj *layer, sha
 
 /*
 ** Returns the number of shapes that match the potential filter and extent.
- * rectProjection is the projection in which rect is expressed, or can be NULL if
- * rect should be considered in the layer projection.
- * This should be equivalent to calling msLayerWhichShapes() and counting the
- * number of shapes returned by msLayerNextShape(), honouring layer->maxfeatures
- * limitation if layer->maxfeatures>=0, and honouring layer->startindex if
- * layer->startindex >= 1 and paging is enabled.
- * Returns -1 in case of failure.
- */
-int msLayerGetShapeCount(layerObj *layer, rectObj rect, projectionObj *rectProjection)
-{
+* rectProjection is the projection in which rect is expressed, or can be NULL if
+* rect should be considered in the layer projection.
+* This should be equivalent to calling msLayerWhichShapes() and counting the
+* number of shapes returned by msLayerNextShape(), honouring layer->maxfeatures
+* limitation if layer->maxfeatures>=0, and honouring layer->startindex if
+* layer->startindex >= 1 and paging is enabled.
+* Returns -1 in case of failure.
+*/
+int msLayerGetShapeCount(layerObj *layer, rectObj rect,
+                         projectionObj *rectProjection) {
   int rv;
 
-  if( ! layer->vtable) {
+  if (!layer->vtable) {
     rv = msInitializeVirtualTable(layer);
-    if(rv != MS_SUCCESS)
+    if (rv != MS_SUCCESS)
       return -1;
   }
   cppcheck_assert(layer->vtable);
@@ -451,21 +483,20 @@ int msLayerGetShapeCount(layerObj *layer
   return layer->vtable->LayerGetShapeCount(layer, rect, rectProjection);
 }
 
-
 /*
 ** Closes resources used by a particular layer.
 */
-void msLayerClose(layerObj *layer)
-{
+void msLayerClose(layerObj *layer) {
   /* no need for items once the layer is closed */
   msLayerFreeItemInfo(layer);
-  if(layer->items) {
+  if (layer->items) {
     msFreeCharArray(layer->items, layer->numitems);
     layer->items = NULL;
     layer->numitems = 0;
   }
 
-  /* clear out items used as part of expressions (bug #2702) -- what about the layer filter? */
+  /* clear out items used as part of expressions (bug #2702) -- what about the
+   * layer filter? */
   msLayerFreeExpressions(layer);
 
   if (layer->vtable) {
@@ -477,43 +508,43 @@ void msLayerClose(layerObj *layer)
 /*
 ** Clear out items used as part of expressions.
 */
-void msLayerFreeExpressions(layerObj *layer)
-{
-  int i,j,k;
+void msLayerFreeExpressions(layerObj *layer) {
+  int i, j, k;
 
   msFreeExpressionTokens(&(layer->filter));
   msFreeExpressionTokens(&(layer->cluster.group));
   msFreeExpressionTokens(&(layer->cluster.filter));
-  for(i=0; i<layer->numclasses; i++) {
-    msFreeExpressionTokens(&(layer->class[i]->expression));
-    msFreeExpressionTokens(&(layer->class[i]->text));
-    for(j=0; j<layer->class[i]->numstyles; j++)
-      msFreeExpressionTokens(&(layer->class[i]->styles[j]->_geomtransform));
-    for(k=0; k<layer->class[i]->numlabels; k++) {
-      msFreeExpressionTokens(&(layer->class[i]->labels[k]->expression));
-      msFreeExpressionTokens(&(layer->class[i]->labels[k]->text));
+  for (i = 0; i < layer->numclasses; i++) {
+    msFreeExpressionTokens(&(layer->class[i] -> expression));
+    msFreeExpressionTokens(&(layer->class[i] -> text));
+    for (j = 0; j < layer->class[i] -> numstyles; j++)
+      msFreeExpressionTokens(&(layer->class[i] -> styles[j] -> _geomtransform));
+    for (k = 0; k < layer->class[i] -> numlabels; k++) {
+      msFreeExpressionTokens(&(layer->class[i] -> labels[k] -> expression));
+      msFreeExpressionTokens(&(layer->class[i] -> labels[k] -> text));
     }
   }
 }
 
 /*
-** Retrieves a list of attributes available for this layer. Most sources also set the iteminfo array
-** at this point. This function is used when processing query results to expose attributes to query
+** Retrieves a list of attributes available for this layer. Most sources also
+*set the iteminfo array
+** at this point. This function is used when processing query results to expose
+*attributes to query
 ** templates. At that point all attributes are fair game.
 */
-int msLayerGetItems(layerObj *layer)
-{
+int msLayerGetItems(layerObj *layer) {
   const char *itemNames;
   /* clean up any previously allocated instances */
   msLayerFreeItemInfo(layer);
-  if(layer->items) {
+  if (layer->items) {
     msFreeCharArray(layer->items, layer->numitems);
     layer->items = NULL;
     layer->numitems = 0;
   }
 
-  if ( ! layer->vtable) {
-    int rv =  msInitializeVirtualTable(layer);
+  if (!layer->vtable) {
+    int rv = msInitializeVirtualTable(layer);
     if (rv != MS_SUCCESS)
       return rv;
   }
@@ -522,8 +553,9 @@ int msLayerGetItems(layerObj *layer)
   /* At the end of switch case (default -> break; -> return MS_FAILURE),
    * was following TODO ITEM:
    */
-  /* TO DO! Need to add any joined itemd on to the core layer items, one long list!  */
-  itemNames = msLayerGetProcessingKey( layer, "ITEMS" );
+  /* TO DO! Need to add any joined itemd on to the core layer items, one long
+   * list!  */
+  itemNames = msLayerGetProcessingKey(layer, "ITEMS");
   if (itemNames) {
     layer->items = msStringSplit(itemNames, ',', &layer->numitems);
     /* populate the iteminfo array */
@@ -543,8 +575,7 @@ int msLayerGetItems(layerObj *layer)
 **
 ** Returns MS_SUCCESS/MS_FAILURE.
 */
-int msLayerGetExtent(layerObj *layer, rectObj *extent)
-{
+int msLayerGetExtent(layerObj *layer, rectObj *extent) {
   int need_to_close = MS_FALSE, status = MS_SUCCESS;
 
   if (MS_VALID_EXTENT(layer->extent)) {
@@ -558,8 +589,8 @@ int msLayerGetExtent(layerObj *layer, re
     need_to_close = MS_TRUE;
   }
 
-  if ( ! layer->vtable) {
-    int rv =  msInitializeVirtualTable(layer);
+  if (!layer->vtable) {
+    int rv = msInitializeVirtualTable(layer);
     if (rv != MS_SUCCESS) {
       if (need_to_close)
         msLayerClose(layer);
@@ -570,34 +601,33 @@ int msLayerGetExtent(layerObj *layer, re
   status = layer->vtable->LayerGetExtent(layer, extent);
 
   if (status == MS_SUCCESS) {
-      layer->extent = *extent;
+    layer->extent = *extent;
   }
 
   if (need_to_close)
     msLayerClose(layer);
 
-  return(status);
+  return (status);
 }
 
-int msLayerGetItemIndex(layerObj *layer, char *item)
-{
+int msLayerGetItemIndex(layerObj *layer, char *item) {
   int i;
 
-  for(i=0; i<layer->numitems; i++) {
-    if(strcasecmp(layer->items[i], item) == 0) return(i);
+  for (i = 0; i < layer->numitems; i++) {
+    if (strcasecmp(layer->items[i], item) == 0)
+      return (i);
   }
 
   return -1; /* item not found */
 }
 
-static int string2list(char **list, int *listsize, char *string)
-{
+static int string2list(char **list, int *listsize, char *string) {
   int i;
 
-  for(i=0; i<(*listsize); i++) {
-    if(strcasecmp(list[i], string) == 0) {
+  for (i = 0; i < (*listsize); i++) {
+    if (strcasecmp(list[i], string) == 0) {
       /* printf("string2list (duplicate): %s %d\n", string, i); */
-      return(i);
+      return (i);
     }
   }
 
@@ -606,7 +636,7 @@ static int string2list(char **list, int
 
   /* printf("string2list: %s %d\n", string, i); */
 
-  return(i);
+  return (i);
 }
 
 extern int msyylex(void);
@@ -619,72 +649,118 @@ extern double msyynumber; /* token conta
 extern char *msyystring_buffer;
 
 const char *msExpressionTokenToString(int token) {
-  switch(token) {
-    case '(': return "(";          
-    case ')': return ")";
-    case ',': return ",";
-    case '+': return "+";
-    case '-': return "-";
-    case '/': return "/";
-    case '*': return "*";
-    case '%': return "%";
-
-    case MS_TOKEN_LOGICAL_AND: return " and ";
-    case MS_TOKEN_LOGICAL_OR: return " or ";
-    case MS_TOKEN_LOGICAL_NOT: return " not ";
-
-    case MS_TOKEN_COMPARISON_EQ: return " = ";
-    case MS_TOKEN_COMPARISON_NE: return " != ";
-    case MS_TOKEN_COMPARISON_GT: return " > ";
-    case MS_TOKEN_COMPARISON_GE: return " >= ";
-    case MS_TOKEN_COMPARISON_LT: return " < ";
-    case MS_TOKEN_COMPARISON_LE: return " <= ";
-    case MS_TOKEN_COMPARISON_IEQ: return "";
-    case MS_TOKEN_COMPARISON_RE: return " ~ ";
-    case MS_TOKEN_COMPARISON_IRE: return " ~* ";
-    case MS_TOKEN_COMPARISON_IN: return " in ";
-    case MS_TOKEN_COMPARISON_LIKE: return " like ";
-
-    case MS_TOKEN_COMPARISON_INTERSECTS: return "intersects";
-    case MS_TOKEN_COMPARISON_DISJOINT: return "disjoint";
-    case MS_TOKEN_COMPARISON_TOUCHES: return "touches";
-    case MS_TOKEN_COMPARISON_OVERLAPS: return "overlaps";
-    case MS_TOKEN_COMPARISON_CROSSES: return "crosses";
-    case MS_TOKEN_COMPARISON_WITHIN: return "within";
-    case MS_TOKEN_COMPARISON_CONTAINS: return "contains";
-    case MS_TOKEN_COMPARISON_EQUALS: return "equals";
-    case MS_TOKEN_COMPARISON_BEYOND: return "beyond";
-    case MS_TOKEN_COMPARISON_DWITHIN: return "dwithin";
-
-    case MS_TOKEN_FUNCTION_LENGTH: return "length";
-    case MS_TOKEN_FUNCTION_TOSTRING: return "tostring";
-    case MS_TOKEN_FUNCTION_COMMIFY: return "commify";
-    case MS_TOKEN_FUNCTION_AREA: return "area";
-    case MS_TOKEN_FUNCTION_ROUND: return "round";
-    case MS_TOKEN_FUNCTION_BUFFER: return "buffer";
-    case MS_TOKEN_FUNCTION_DIFFERENCE: return "difference";
-    case MS_TOKEN_FUNCTION_SIMPLIFY: return "simplify";
-    // case MS_TOKEN_FUNCTION_SIMPLIFYPT:
-    case MS_TOKEN_FUNCTION_GENERALIZE: return "generalize";
-    default: return NULL;
+  switch (token) {
+  case '(':
+    return "(";
+  case ')':
+    return ")";
+  case ',':
+    return ",";
+  case '+':
+    return "+";
+  case '-':
+    return "-";
+  case '/':
+    return "/";
+  case '*':
+    return "*";
+  case '%':
+    return "%";
+
+  case MS_TOKEN_LOGICAL_AND:
+    return " and ";
+  case MS_TOKEN_LOGICAL_OR:
+    return " or ";
+  case MS_TOKEN_LOGICAL_NOT:
+    return " not ";
+
+  case MS_TOKEN_COMPARISON_EQ:
+    return " = ";
+  case MS_TOKEN_COMPARISON_NE:
+    return " != ";
+  case MS_TOKEN_COMPARISON_GT:
+    return " > ";
+  case MS_TOKEN_COMPARISON_GE:
+    return " >= ";
+  case MS_TOKEN_COMPARISON_LT:
+    return " < ";
+  case MS_TOKEN_COMPARISON_LE:
+    return " <= ";
+  case MS_TOKEN_COMPARISON_IEQ:
+    return "";
+  case MS_TOKEN_COMPARISON_RE:
+    return " ~ ";
+  case MS_TOKEN_COMPARISON_IRE:
+    return " ~* ";
+  case MS_TOKEN_COMPARISON_IN:
+    return " in ";
+  case MS_TOKEN_COMPARISON_LIKE:
+    return " like ";
+
+  case MS_TOKEN_COMPARISON_INTERSECTS:
+    return "intersects";
+  case MS_TOKEN_COMPARISON_DISJOINT:
+    return "disjoint";
+  case MS_TOKEN_COMPARISON_TOUCHES:
+    return "touches";
+  case MS_TOKEN_COMPARISON_OVERLAPS:
+    return "overlaps";
+  case MS_TOKEN_COMPARISON_CROSSES:
+    return "crosses";
+  case MS_TOKEN_COMPARISON_WITHIN:
+    return "within";
+  case MS_TOKEN_COMPARISON_CONTAINS:
+    return "contains";
+  case MS_TOKEN_COMPARISON_EQUALS:
+    return "equals";
+  case MS_TOKEN_COMPARISON_BEYOND:
+    return "beyond";
+  case MS_TOKEN_COMPARISON_DWITHIN:
+    return "dwithin";
+
+  case MS_TOKEN_FUNCTION_LENGTH:
+    return "length";
+  case MS_TOKEN_FUNCTION_TOSTRING:
+    return "tostring";
+  case MS_TOKEN_FUNCTION_COMMIFY:
+    return "commify";
+  case MS_TOKEN_FUNCTION_AREA:
+    return "area";
+  case MS_TOKEN_FUNCTION_ROUND:
+    return "round";
+  case MS_TOKEN_FUNCTION_BUFFER:
+    return "buffer";
+  case MS_TOKEN_FUNCTION_DIFFERENCE:
+    return "difference";
+  case MS_TOKEN_FUNCTION_SIMPLIFY:
+    return "simplify";
+  // case MS_TOKEN_FUNCTION_SIMPLIFYPT:
+  case MS_TOKEN_FUNCTION_GENERALIZE:
+    return "generalize";
+  default:
+    return NULL;
   }
 }
 
-int msTokenizeExpression(expressionObj *expression, char **list, int *listsize)
-{
+int msTokenizeExpression(expressionObj *expression, char **list,
+                         int *listsize) {
   tokenListNodeObjPtr node;
   int token;
 
-  /* TODO: make sure the constants can't somehow reference invalid expression types */
-  /* if(expression->type != MS_EXPRESSION && expression->type != MS_GEOMTRANSFORM_EXPRESSION) return MS_SUCCESS; */
+  /* TODO: make sure the constants can't somehow reference invalid expression
+   * types */
+  /* if(expression->type != MS_EXPRESSION && expression->type !=
+   * MS_GEOMTRANSFORM_EXPRESSION) return MS_SUCCESS; */
 
   msAcquireLock(TLOCK_PARSER);
   msyystate = MS_TOKENIZE_EXPRESSION;
   msyystring = expression->string; /* the thing we're tokenizing */
 
-  while((token = msyylex()) != 0) { /* keep processing tokens until the end of the string (\0) */
+  while ((token = msyylex()) !=
+         0) { /* keep processing tokens until the end of the string (\0) */
 
-    if((node = (tokenListNodeObjPtr) malloc(sizeof(tokenListNodeObj))) == NULL) {
+    if ((node = (tokenListNodeObjPtr)malloc(sizeof(tokenListNodeObj))) ==
+        NULL) {
       msSetError(MS_MEMERR, NULL, "msTokenizeExpression()");
       goto parse_error;
     }
@@ -694,86 +770,99 @@ int msTokenizeExpression(expressionObj *
     node->tailifhead = NULL;
     node->next = NULL;
 
-    switch(token) {
-      case MS_TOKEN_LITERAL_BOOLEAN:
-      case MS_TOKEN_LITERAL_NUMBER:
-        node->token = token;
-        node->tokenval.dblval = msyynumber;
-        break;
-      case MS_TOKEN_LITERAL_STRING:
-        node->token = token;
-        node->tokenval.strval = msStrdup(msyystring_buffer);
-        break;
-      case MS_TOKEN_LITERAL_TIME:
-        node->tokensrc = msStrdup(msyystring_buffer);
-        node->token = token;
-        msTimeInit(&(node->tokenval.tmval));
-        if(msParseTime(msyystring_buffer, &(node->tokenval.tmval)) != MS_TRUE) {
-          msSetError(MS_PARSEERR, "Parsing time value failed.", "msTokenizeExpression()");
-          free(node);
-          goto parse_error;
-        }
-        break;
-      case MS_TOKEN_BINDING_DOUBLE: /* we've encountered an attribute (binding) reference */
-      case MS_TOKEN_BINDING_INTEGER:
-      case MS_TOKEN_BINDING_STRING:
-      case MS_TOKEN_BINDING_TIME:
-        node->token = token; /* binding type */
-        node->tokenval.bindval.item = msStrdup(msyystring_buffer);
-        if(list) node->tokenval.bindval.index = string2list(list, listsize, msyystring_buffer);
-        break;
-      case MS_TOKEN_BINDING_SHAPE:
-        node->token = token;
-        break;
-      case MS_TOKEN_BINDING_MAP_CELLSIZE:
-        node->token = token;
-        break;
-      case MS_TOKEN_BINDING_DATA_CELLSIZE:
-        node->token = token;
-        break;        
-      case MS_TOKEN_FUNCTION_FROMTEXT: /* we want to process a shape from WKT once and not for every feature being evaluated */
-        if((token = msyylex()) != 40) { /* ( */
-          msSetError(MS_PARSEERR, "Parsing fromText function failed.", "msTokenizeExpression()");
-          free(node);
-          goto parse_error;
-        }
-
-        if((token = msyylex()) != MS_TOKEN_LITERAL_STRING) {
-          msSetError(MS_PARSEERR, "Parsing fromText function failed.", "msTokenizeExpression()");
-          free(node);
-          goto parse_error;
-        }
-
-        node->token = MS_TOKEN_LITERAL_SHAPE;
-        node->tokenval.shpval = msShapeFromWKT(msyystring_buffer);
-
-        if(!node->tokenval.shpval) {
-          msSetError(MS_PARSEERR, "Parsing fromText function failed, WKT processing failed.", "msTokenizeExpression()");
-          free(node);
-          goto parse_error;
-        }
-
-        /* todo: perhaps process optional args (e.g. projection) */
-
-        if((token = msyylex()) != 41) { /* ) */
-          msSetError(MS_PARSEERR, "Parsing fromText function failed.", "msTokenizeExpression()");
-          msFreeShape(node->tokenval.shpval);
-          free(node->tokenval.shpval);
-          free(node);
-          goto parse_error;
-        }
-        break;
-      default:
-        node->token = token; /* for everything else */
-        break;
+    switch (token) {
+    case MS_TOKEN_LITERAL_BOOLEAN:
+    case MS_TOKEN_LITERAL_NUMBER:
+      node->token = token;
+      node->tokenval.dblval = msyynumber;
+      break;
+    case MS_TOKEN_LITERAL_STRING:
+      node->token = token;
+      node->tokenval.strval = msStrdup(msyystring_buffer);
+      break;
+    case MS_TOKEN_LITERAL_TIME:
+      node->tokensrc = msStrdup(msyystring_buffer);
+      node->token = token;
+      msTimeInit(&(node->tokenval.tmval));
+      if (msParseTime(msyystring_buffer, &(node->tokenval.tmval)) != MS_TRUE) {
+        msSetError(MS_PARSEERR, "Parsing time value failed.",
+                   "msTokenizeExpression()");
+        free(node);
+        goto parse_error;
+      }
+      break;
+    case MS_TOKEN_BINDING_DOUBLE: /* we've encountered an attribute (binding)
+                                     reference */
+    case MS_TOKEN_BINDING_INTEGER:
+    case MS_TOKEN_BINDING_STRING:
+    case MS_TOKEN_BINDING_TIME:
+      node->token = token; /* binding type */
+      node->tokenval.bindval.item = msStrdup(msyystring_buffer);
+      if (list)
+        node->tokenval.bindval.index =
+            string2list(list, listsize, msyystring_buffer);
+      break;
+    case MS_TOKEN_BINDING_SHAPE:
+      node->token = token;
+      break;
+    case MS_TOKEN_BINDING_MAP_CELLSIZE:
+      node->token = token;
+      break;
+    case MS_TOKEN_BINDING_DATA_CELLSIZE:
+      node->token = token;
+      break;
+    case MS_TOKEN_FUNCTION_FROMTEXT: /* we want to process a shape from WKT once
+                                        and not for every feature being
+                                        evaluated */
+      if ((token = msyylex()) != 40) { /* ( */
+        msSetError(MS_PARSEERR, "Parsing fromText function failed.",
+                   "msTokenizeExpression()");
+        free(node);
+        goto parse_error;
+      }
+
+      if ((token = msyylex()) != MS_TOKEN_LITERAL_STRING) {
+        msSetError(MS_PARSEERR, "Parsing fromText function failed.",
+                   "msTokenizeExpression()");
+        free(node);
+        goto parse_error;
+      }
+
+      node->token = MS_TOKEN_LITERAL_SHAPE;
+      node->tokenval.shpval = msShapeFromWKT(msyystring_buffer);
+
+      if (!node->tokenval.shpval) {
+        msSetError(MS_PARSEERR,
+                   "Parsing fromText function failed, WKT processing failed.",
+                   "msTokenizeExpression()");
+        free(node);
+        goto parse_error;
+      }
+
+      /* todo: perhaps process optional args (e.g. projection) */
+
+      if ((token = msyylex()) != 41) { /* ) */
+        msSetError(MS_PARSEERR, "Parsing fromText function failed.",
+                   "msTokenizeExpression()");
+        msFreeShape(node->tokenval.shpval);
+        free(node->tokenval.shpval);
+        free(node);
+        goto parse_error;
+      }
+      break;
+    default:
+      node->token = token; /* for everything else */
+      break;
     }
 
     /* add node to token list */
-    if(expression->tokens == NULL) {
+    if (expression->tokens == NULL) {
       expression->tokens = node;
     } else {
-      if(expression->tokens->tailifhead != NULL) /* this should never be NULL, but just in case */
-        expression->tokens->tailifhead->next = node; /* put the node at the end of the list */
+      if (expression->tokens->tailifhead !=
+          NULL) /* this should never be NULL, but just in case */
+        expression->tokens->tailifhead->next =
+            node; /* put the node at the end of the list */
     }
 
     /* repoint the head of the list to the end  - our new element
@@ -792,114 +881,166 @@ parse_error:
   return MS_FAILURE;
 }
 
-
-static void buildLayerItemList(layerObj *layer)
-{
+static void buildLayerItemList(layerObj *layer) {
   int i, j, k, l;
   /*
-  ** build layer item list, compute item indexes for explicity item references (e.g. classitem) or item bindings
+  ** build layer item list, compute item indexes for explicity item references
+  *(e.g. classitem) or item bindings
   */
 
   /* layer items */
-  if(layer->classitem) layer->classitemindex = string2list(layer->items, &(layer->numitems), layer->classitem);
-  if(layer->filteritem) layer->filteritemindex = string2list(layer->items, &(layer->numitems), layer->filteritem);
-  if(layer->styleitem && (strcasecmp(layer->styleitem, "AUTO") != 0) && (strncasecmp(layer->styleitem, "javascript://",13) != 0)) 
-    layer->styleitemindex = string2list(layer->items, &(layer->numitems), layer->styleitem);
-  if(layer->labelitem) layer->labelitemindex = string2list(layer->items, &(layer->numitems), layer->labelitem);
-  if(layer->utfitem) layer->utfitemindex = string2list(layer->items, &(layer->numitems), layer->utfitem);
+  if (layer->classitem)
+    layer->classitemindex =
+        string2list(layer->items, &(layer->numitems), layer->classitem);
+  if (layer->filteritem)
+    layer->filteritemindex =
+        string2list(layer->items, &(layer->numitems), layer->filteritem);
+  if (layer->styleitem && (strcasecmp(layer->styleitem, "AUTO") != 0) &&
+      (strncasecmp(layer->styleitem, "javascript://", 13) != 0))
+    layer->styleitemindex =
+        string2list(layer->items, &(layer->numitems), layer->styleitem);
+  if (layer->labelitem)
+    layer->labelitemindex =
+        string2list(layer->items, &(layer->numitems), layer->labelitem);
+  if (layer->utfitem)
+    layer->utfitemindex =
+        string2list(layer->items, &(layer->numitems), layer->utfitem);
 
   /* layer classes */
-  for(i=0; i<layer->numclasses; i++) {
-    
-    if(layer->class[i]->expression.type == MS_EXPRESSION) /* class expression */
-      msTokenizeExpression(&(layer->class[i]->expression), layer->items, &(layer->numitems));
+  for (i = 0; i < layer->numclasses; i++) {
+
+    if (layer->class[i] -> expression.type ==
+                               MS_EXPRESSION) /* class expression */
+      msTokenizeExpression(&(layer->class[i] -> expression), layer->items,
+                           &(layer->numitems));
 
     /* class styles (items, bindings, geomtransform) */
-    for(j=0; j<layer->class[i]->numstyles; j++) {
-      if(layer->class[i]->styles[j]->rangeitem) 
-        layer->class[i]->styles[j]->rangeitemindex = string2list(layer->items, &(layer->numitems), layer->class[i]->styles[j]->rangeitem);
-      for(k=0; k<MS_STYLE_BINDING_LENGTH; k++) {
-        if(layer->class[i]->styles[j]->bindings[k].item) 
-          layer->class[i]->styles[j]->bindings[k].index = string2list(layer->items, &(layer->numitems), layer->class[i]->styles[j]->bindings[k].item);
-        if (layer->class[i]->styles[j]->exprBindings[k].type == MS_EXPRESSION)
-        {
+    for (j = 0; j < layer->class[i] -> numstyles; j++) {
+      if (layer->class[i] -> styles[j] -> rangeitem)
+        layer->class[i]->styles[j]->rangeitemindex =
+            string2list(layer->items, &(layer->numitems),
+                        layer->class[i] -> styles[j] -> rangeitem);
+      for (k = 0; k < MS_STYLE_BINDING_LENGTH; k++) {
+        if (layer->class[i] -> styles[j] -> bindings[k].item)
+          layer->class[i]->styles[j]->bindings[k].index =
+              string2list(layer->items, &(layer->numitems),
+                          layer->class[i] -> styles[j] -> bindings[k].item);
+        if (layer->class[i] -> styles[j] -> exprBindings[k].type ==
+                                                MS_EXPRESSION) {
           msTokenizeExpression(
-              &(layer->class[i]->styles[j]->exprBindings[k]),
-              layer->items, &(layer->numitems));
+              &(layer->class[i] -> styles[j] -> exprBindings[k]), layer->items,
+              &(layer->numitems));
         }
       }
-      if(layer->class[i]->styles[j]->_geomtransform.type == MS_GEOMTRANSFORM_EXPRESSION)
-        msTokenizeExpression(&(layer->class[i]->styles[j]->_geomtransform), layer->items, &(layer->numitems));
+      if (layer->class[i] -> styles[j] -> _geomtransform.type ==
+                                              MS_GEOMTRANSFORM_EXPRESSION)
+        msTokenizeExpression(&(layer->class[i] -> styles[j] -> _geomtransform),
+                             layer->items, &(layer->numitems));
     }
 
     /* class labels and label styles (items, bindings, geomtransform) */
-    for(l=0; l<layer->class[i]->numlabels; l++) {
-      for(j=0; j<layer->class[i]->labels[l]->numstyles; j++) {
-        if(layer->class[i]->labels[l]->styles[j]->rangeitem) 
-          layer->class[i]->labels[l]->styles[j]->rangeitemindex = string2list(layer->items, &(layer->numitems), layer->class[i]->labels[l]->styles[j]->rangeitem);
-        for(k=0; k<MS_STYLE_BINDING_LENGTH; k++) {
-          if(layer->class[i]->labels[l]->styles[j]->bindings[k].item) 
-            layer->class[i]->labels[l]->styles[j]->bindings[k].index = string2list(layer->items, &(layer->numitems), layer->class[i]->labels[l]->styles[j]->bindings[k].item);
-          if(layer->class[i]->labels[l]->styles[j]->_geomtransform.type == MS_GEOMTRANSFORM_EXPRESSION)
-            msTokenizeExpression(&(layer->class[i]->labels[l]->styles[j]->_geomtransform), layer->items, &(layer->numitems));
+    for (l = 0; l < layer->class[i] -> numlabels; l++) {
+      for (j = 0; j < layer->class[i] -> labels[l] -> numstyles; j++) {
+        if (layer->class[i] -> labels[l] -> styles[j] -> rangeitem)
+          layer->class[i]->labels[l]->styles[j]->rangeitemindex = string2list(
+              layer->items, &(layer->numitems),
+              layer->class[i] -> labels[l] -> styles[j] -> rangeitem);
+        for (k = 0; k < MS_STYLE_BINDING_LENGTH; k++) {
+          if (layer->class[i] -> labels[l] -> styles[j] -> bindings[k].item)
+            layer->class[i]->labels[l]->styles[j]->bindings[k].index =
+                string2list(layer->items, &(layer->numitems),
+                            layer->class[i] -> labels[l] -> styles[j]
+                            -> bindings[k].item);
+          if (layer->class[i] -> labels[l] -> styles[j]
+              -> _geomtransform.type == MS_GEOMTRANSFORM_EXPRESSION)
+            msTokenizeExpression(
+                &(layer->class[i] -> labels[l] -> styles[j] -> _geomtransform),
+                layer->items, &(layer->numitems));
         }
       }
-      for(k=0; k<MS_LABEL_BINDING_LENGTH; k++) {
-        if(layer->class[i]->labels[l]->bindings[k].item) 
-          layer->class[i]->labels[l]->bindings[k].index = string2list(layer->items, &(layer->numitems), layer->class[i]->labels[l]->bindings[k].item);
-        if (layer->class[i]->labels[l]->exprBindings[k].type == MS_EXPRESSION)
-        {
+      for (k = 0; k < MS_LABEL_BINDING_LENGTH; k++) {
+        if (layer->class[i] -> labels[l] -> bindings[k].item)
+          layer->class[i]->labels[l]->bindings[k].index =
+              string2list(layer->items, &(layer->numitems),
+                          layer->class[i] -> labels[l] -> bindings[k].item);
+        if (layer->class[i] -> labels[l] -> exprBindings[k].type ==
+                                                MS_EXPRESSION) {
           msTokenizeExpression(
-              &(layer->class[i]->labels[l]->exprBindings[k]),
-              layer->items, &(layer->numitems));
+              &(layer->class[i] -> labels[l] -> exprBindings[k]), layer->items,
+              &(layer->numitems));
         }
       }
 
-       /* label expression */
-      if(layer->class[i]->labels[l]->expression.type == MS_EXPRESSION) msTokenizeExpression(&(layer->class[i]->labels[l]->expression), layer->items, &(layer->numitems));
+      /* label expression */
+      if (layer->class[i] -> labels[l] -> expression.type == MS_EXPRESSION)
+        msTokenizeExpression(&(layer->class[i] -> labels[l] -> expression),
+                             layer->items, &(layer->numitems));
 
       /* label text */
-      if(layer->class[i]->labels[l]->text.type == MS_EXPRESSION || (layer->class[i]->labels[l]->text.string && strchr(layer->class[i]->labels[l]->text.string,'[') != NULL && strchr(layer->class[i]->labels[l]->text.string,']') != NULL))
-        msTokenizeExpression(&(layer->class[i]->labels[l]->text), layer->items, &(layer->numitems));
+      if (layer->class[i] -> labels[l]
+          -> text.type == MS_EXPRESSION ||
+                 (layer->class[i] -> labels[l]
+                  -> text.string &&strchr(
+                         layer->class[i] -> labels[l] -> text.string, '[') !=
+                             NULL &&
+                         strchr(layer->class[i] -> labels[l] -> text.string,
+                                ']') != NULL))
+        msTokenizeExpression(&(layer->class[i] -> labels[l] -> text),
+                             layer->items, &(layer->numitems));
     }
 
     /* class text */
-    if(layer->class[i]->text.type == MS_EXPRESSION || (layer->class[i]->text.string && strchr(layer->class[i]->text.string,'[') != NULL && strchr(layer->class[i]->text.string,']') != NULL))
-      msTokenizeExpression(&(layer->class[i]->text), layer->items, &(layer->numitems));
+    if (layer->class[i]
+        -> text.type == MS_EXPRESSION ||
+               (layer->class[i]
+                -> text.string &&strchr(layer->class[i] -> text.string, '[') !=
+                           NULL &&
+                       strchr(layer->class[i] -> text.string, ']') != NULL))
+      msTokenizeExpression(&(layer->class[i] -> text), layer->items,
+                           &(layer->numitems));
   }
 
   /* layer filter */
-  if(layer->filter.type == MS_EXPRESSION) msTokenizeExpression(&(layer->filter), layer->items, &(layer->numitems));
+  if (layer->filter.type == MS_EXPRESSION)
+    msTokenizeExpression(&(layer->filter), layer->items, &(layer->numitems));
 
   /* cluster expressions */
-  if(layer->cluster.group.type == MS_EXPRESSION) msTokenizeExpression(&(layer->cluster.group), layer->items, &(layer->numitems));
-  if(layer->cluster.filter.type == MS_EXPRESSION) msTokenizeExpression(&(layer->cluster.filter), layer->items, &(layer->numitems));
+  if (layer->cluster.group.type == MS_EXPRESSION)
+    msTokenizeExpression(&(layer->cluster.group), layer->items,
+                         &(layer->numitems));
+  if (layer->cluster.filter.type == MS_EXPRESSION)
+    msTokenizeExpression(&(layer->cluster.filter), layer->items,
+                         &(layer->numitems));
 
   /* utfdata */
-  if(layer->utfdata.type == MS_EXPRESSION || (layer->utfdata.string && strchr(layer->utfdata.string,'[') != NULL && strchr(layer->utfdata.string,']') != NULL)) {
+  if (layer->utfdata.type == MS_EXPRESSION ||
+      (layer->utfdata.string && strchr(layer->utfdata.string, '[') != NULL &&
+       strchr(layer->utfdata.string, ']') != NULL)) {
     msTokenizeExpression(&(layer->utfdata), layer->items, &(layer->numitems));
   }
 }
 
 /*
-** This function builds a list of items necessary to draw or query a particular layer by
-** examining the contents of the various xxxxitem parameters and expressions. That list is
+** This function builds a list of items necessary to draw or query a particular
+*layer by
+** examining the contents of the various xxxxitem parameters and expressions.
+*That list is
 ** then used to set the iteminfo variable.
 */
-int msLayerWhichItems(layerObj *layer, int get_all, const char *metadata)
-{
+int msLayerWhichItems(layerObj *layer, int get_all, const char *metadata) {
   int i, j, k, l, rv;
-  int nt=0;
+  int nt = 0;
 
   if (!layer->vtable) {
-    rv =  msInitializeVirtualTable(layer);
-    if (rv != MS_SUCCESS) return rv;
+    rv = msInitializeVirtualTable(layer);
+    if (rv != MS_SUCCESS)
+      return rv;
   }
   cppcheck_assert(layer->vtable);
 
   /* Cleanup any previous item selection */
   msLayerFreeItemInfo(layer);
-  if(layer->items) {
+  if (layer->items) {
     msFreeCharArray(layer->items, layer->numitems);
     layer->items = NULL;
     layer->numitems = 0;
@@ -916,130 +1057,163 @@ int msLayerWhichItems(layerObj *layer, i
   layer->labelitemindex = -1;
   layer->utfitemindex = -1;
 
-  if(layer->classitem) nt++;
-  if(layer->filteritem) nt++;
-  if(layer->styleitem &&
-     (strcasecmp(layer->styleitem, "AUTO") != 0) &&
-     (strncasecmp(layer->styleitem, "javascript://", 13) != 0)) nt++;
-     
-  if(layer->filter.type == MS_EXPRESSION)
+  if (layer->classitem)
+    nt++;
+  if (layer->filteritem)
+    nt++;
+  if (layer->styleitem && (strcasecmp(layer->styleitem, "AUTO") != 0) &&
+      (strncasecmp(layer->styleitem, "javascript://", 13) != 0))
+    nt++;
+
+  if (layer->filter.type == MS_EXPRESSION)
     nt += msCountChars(layer->filter.string, '[');
 
-  if(layer->cluster.group.type == MS_EXPRESSION)
+  if (layer->cluster.group.type == MS_EXPRESSION)
     nt += msCountChars(layer->cluster.group.string, '[');
 
-  if(layer->cluster.filter.type == MS_EXPRESSION)
+  if (layer->cluster.filter.type == MS_EXPRESSION)
     nt += msCountChars(layer->cluster.filter.string, '[');
 
-  if(layer->labelitem) nt++;
-  if(layer->utfitem) nt++;
-
-  if(layer->_geomtransform.type == MS_GEOMTRANSFORM_EXPRESSION)
-    msTokenizeExpression(&layer->_geomtransform, layer->items, &(layer->numitems));
+  if (layer->labelitem)
+    nt++;
+  if (layer->utfitem)
+    nt++;
+
+  if (layer->_geomtransform.type == MS_GEOMTRANSFORM_EXPRESSION)
+    msTokenizeExpression(&layer->_geomtransform, layer->items,
+                         &(layer->numitems));
 
   /* class level counts */
-  for(i=0; i<layer->numclasses; i++) {
+  for (i = 0; i < layer->numclasses; i++) {
 
-    for(j=0; j<layer->class[i]->numstyles; j++) {
-      if(layer->class[i]->styles[j]->rangeitem) nt++;
+    for (j = 0; j < layer->class[i] -> numstyles; j++) {
+      if (layer->class[i] -> styles[j] -> rangeitem)
+        nt++;
       nt += layer->class[i]->styles[j]->numbindings;
-      if(layer->class[i]->styles[j]->_geomtransform.type == MS_GEOMTRANSFORM_EXPRESSION)
-        nt += msCountChars(layer->class[i]->styles[j]->_geomtransform.string, '[');
-      for(k=0; k<MS_STYLE_BINDING_LENGTH; k++) {
-        if (layer->class[i]->styles[j]->exprBindings[k].type == MS_EXPRESSION)
-        {
-          nt += msCountChars(layer->class[i]->styles[j]->exprBindings[k].string, '[');
+      if (layer->class[i] -> styles[j] -> _geomtransform.type ==
+                                              MS_GEOMTRANSFORM_EXPRESSION)
+        nt += msCountChars(
+            layer->class[i] -> styles[j] -> _geomtransform.string, '[');
+      for (k = 0; k < MS_STYLE_BINDING_LENGTH; k++) {
+        if (layer->class[i] -> styles[j] -> exprBindings[k].type ==
+                                                MS_EXPRESSION) {
+          nt += msCountChars(
+              layer->class[i] -> styles[j] -> exprBindings[k].string, '[');
         }
       }
     }
 
-    if(layer->class[i]->expression.type == MS_EXPRESSION)
-      nt += msCountChars(layer->class[i]->expression.string, '[');
+    if (layer->class[i] -> expression.type == MS_EXPRESSION)
+      nt += msCountChars(layer->class[i] -> expression.string, '[');
 
-    for(l=0; l<layer->class[i]->numlabels; l++) {
+    for (l = 0; l < layer->class[i] -> numlabels; l++) {
       nt += layer->class[i]->labels[l]->numbindings;
-      for(j=0; j<layer->class[i]->labels[l]->numstyles; j++) {
-        if(layer->class[i]->labels[l]->styles[j]->rangeitem) nt++;
+      for (j = 0; j < layer->class[i] -> labels[l] -> numstyles; j++) {
+        if (layer->class[i] -> labels[l] -> styles[j] -> rangeitem)
+          nt++;
         nt += layer->class[i]->labels[l]->styles[j]->numbindings;
-        if(layer->class[i]->labels[l]->styles[j]->_geomtransform.type == MS_GEOMTRANSFORM_EXPRESSION)
-          nt += msCountChars(layer->class[i]->labels[l]->styles[j]->_geomtransform.string, '[');
-      }
-      for(k=0; k<MS_LABEL_BINDING_LENGTH; k++) {
-        if (layer->class[i]->labels[l]->exprBindings[k].type == MS_EXPRESSION)
-        {
-          nt += msCountChars(layer->class[i]->labels[l]->exprBindings[k].string, '[');
+        if (layer->class[i] -> labels[l] -> styles[j]
+            -> _geomtransform.type == MS_GEOMTRANSFORM_EXPRESSION)
+          nt += msCountChars(layer->class[i] -> labels[l] -> styles[j]
+                             -> _geomtransform.string,
+                             '[');
+      }
+      for (k = 0; k < MS_LABEL_BINDING_LENGTH; k++) {
+        if (layer->class[i] -> labels[l] -> exprBindings[k].type ==
+                                                MS_EXPRESSION) {
+          nt += msCountChars(
+              layer->class[i] -> labels[l] -> exprBindings[k].string, '[');
         }
       }
 
-      if(layer->class[i]->labels[l]->expression.type == MS_EXPRESSION)
-        nt += msCountChars(layer->class[i]->labels[l]->expression.string, '[');
-      if(layer->class[i]->labels[l]->text.type == MS_EXPRESSION || (layer->class[i]->labels[l]->text.string && strchr(layer->class[i]->labels[l]->text.string,'[') != NULL && strchr(layer->class[i]->labels[l]->text.string,']') != NULL))
-        nt += msCountChars(layer->class[i]->labels[l]->text.string, '[');
-    }
-
-    if(layer->class[i]->text.type == MS_EXPRESSION || (layer->class[i]->text.string && strchr(layer->class[i]->text.string,'[') != NULL && strchr(layer->class[i]->text.string,']') != NULL))
-      nt += msCountChars(layer->class[i]->text.string, '[');
+      if (layer->class[i] -> labels[l] -> expression.type == MS_EXPRESSION)
+        nt += msCountChars(layer->class[i] -> labels[l] -> expression.string,
+                           '[');
+      if (layer->class[i] -> labels[l]
+          -> text.type == MS_EXPRESSION ||
+                 (layer->class[i] -> labels[l]
+                  -> text.string &&strchr(
+                         layer->class[i] -> labels[l] -> text.string, '[') !=
+                             NULL &&
+                         strchr(layer->class[i] -> labels[l] -> text.string,
+                                ']') != NULL))
+        nt += msCountChars(layer->class[i] -> labels[l] -> text.string, '[');
+    }
+
+    if (layer->class[i]
+        -> text.type == MS_EXPRESSION ||
+               (layer->class[i]
+                -> text.string &&strchr(layer->class[i] -> text.string, '[') !=
+                           NULL &&
+                       strchr(layer->class[i] -> text.string, ']') != NULL))
+      nt += msCountChars(layer->class[i] -> text.string, '[');
   }
 
   /* utfgrid count */
-  if(layer->utfdata.type == MS_EXPRESSION || (layer->utfdata.string && strchr(layer->utfdata.string,'[') != NULL && strchr(layer->utfdata.string,']') != NULL))
+  if (layer->utfdata.type == MS_EXPRESSION ||
+      (layer->utfdata.string && strchr(layer->utfdata.string, '[') != NULL &&
+       strchr(layer->utfdata.string, ']') != NULL))
     nt += msCountChars(layer->utfdata.string, '[');
 
-  // if we are using a GetMap request with a WMS filter we don't need to return all items
+  // if we are using a GetMap request with a WMS filter we don't need to return
+  // all items
   if (msOWSLookupMetadata(&(layer->metadata), "G", "wmsfilter_flag") != NULL) {
-      get_all = MS_FALSE;
+    get_all = MS_FALSE;
   }
 
-  if(metadata == NULL){
-      // check item set by mapwfs.cpp to restrict the number of columns selected
-      metadata = msOWSLookupMetadata(&(layer->metadata), "G", "select_items");
-      if (metadata) {
-          /* get only selected items */
-          get_all = MS_FALSE;
-      }
+  if (metadata == NULL) {
+    // check item set by mapwfs.cpp to restrict the number of columns selected
+    metadata = msOWSLookupMetadata(&(layer->metadata), "G", "select_items");
+    if (metadata) {
+      /* get only selected items */
+      get_all = MS_FALSE;
+    }
   }
 
   /* always retrieve all items in some cases */
-  if(layer->connectiontype == MS_INLINE ||
-      (layer->map->outputformat && layer->map->outputformat->renderer == MS_RENDER_WITH_KML)) {
+  if (layer->connectiontype == MS_INLINE ||
+      (layer->map->outputformat &&
+       layer->map->outputformat->renderer == MS_RENDER_WITH_KML)) {
     get_all = MS_TRUE;
   }
 
   /*
   ** allocate space for the item list (worse case size)
   */
-  if( get_all ) {
+  if (get_all) {
     rv = msLayerGetItems(layer);
-    if(nt > 0) /* need to realloc the array to accept the possible new items*/
-      layer->items = (char **)msSmallRealloc(layer->items, sizeof(char *)*(layer->numitems + nt));
+    if (nt > 0) /* need to realloc the array to accept the possible new items*/
+      layer->items = (char **)msSmallRealloc(
+          layer->items, sizeof(char *) * (layer->numitems + nt));
   } else {
     rv = layer->vtable->LayerCreateItems(layer, nt);
   }
-  if(rv != MS_SUCCESS)
+  if (rv != MS_SUCCESS)
     return rv;
 
   buildLayerItemList(layer);
 
-  if(metadata) {
+  if (metadata) {
     char **tokens;
     int n = 0;
     int j;
 
     tokens = msStringSplit(metadata, ',', &n);
-    if(tokens) {
-      for(i=0; i<n; i++) {
+    if (tokens) {
+      for (i = 0; i < n; i++) {
         int bFound = 0;
-        for(j=0; j<layer->numitems; j++) {
-          if(strcasecmp(tokens[i], layer->items[j]) == 0) {
+        for (j = 0; j < layer->numitems; j++) {
+          if (strcasecmp(tokens[i], layer->items[j]) == 0) {
             bFound = 1;
             break;
           }
         }
 
-        if(!bFound) {
+        if (!bFound) {
           layer->numitems++;
-          layer->items =  (char **)msSmallRealloc(layer->items, sizeof(char *)*(layer->numitems));
-          layer->items[layer->numitems-1] = msStrdup(tokens[i]);
+          layer->items = (char **)msSmallRealloc(
+              layer->items, sizeof(char *) * (layer->numitems));
+          layer->items[layer->numitems - 1] = msStrdup(tokens[i]);
         }
       }
       msFreeCharArray(tokens, n);
@@ -1049,99 +1223,93 @@ int msLayerWhichItems(layerObj *layer, i
     /* order of the layer->items array is consistent with it. This is */
     /* important so that WFS DescribeFeatureType and GetFeature requests */
     /* return items in the same order */
-    if( !get_all && layer->numitems ) {
-        char** unsorted_items = layer->items;
-        int numitems = layer->numitems;
-
-        /* Retrieve all items */
-        layer->items = NULL;
-        layer->numitems = 0;
-        rv = msLayerGetItems(layer);
-        if( rv != MS_SUCCESS ) {
-            msFreeCharArray(unsorted_items, numitems);
-            return rv;
-        }
+    if (!get_all && layer->numitems) {
+      char **unsorted_items = layer->items;
+      int numitems = layer->numitems;
+
+      /* Retrieve all items */
+      layer->items = NULL;
+      layer->numitems = 0;
+      rv = msLayerGetItems(layer);
+      if (rv != MS_SUCCESS) {
+        msFreeCharArray(unsorted_items, numitems);
+        return rv;
+      }
 
-        /* Sort unsorted_items in the order of layer->items */
-        char** sorted_items = (char **)msSmallMalloc(sizeof(char*) * numitems);
-        int num_sorted_items = 0;
-        for( i = 0; i < layer->numitems; i++ )
-        {
-            if( layer->items[i] )
-            {
-                for( j = 0; j < numitems; j++ )
-                {
-                    if( unsorted_items[j] &&
-                        strcasecmp(layer->items[i], unsorted_items[j]) == 0 )
-                    {
-                        sorted_items[num_sorted_items] = layer->items[i];
-                        num_sorted_items ++;
-
-                        layer->items[i] = NULL;
-                        msFree(unsorted_items[j]);
-                        unsorted_items[j] = NULL;
-                        break;
-                    }
-                }
+      /* Sort unsorted_items in the order of layer->items */
+      char **sorted_items = (char **)msSmallMalloc(sizeof(char *) * numitems);
+      int num_sorted_items = 0;
+      for (i = 0; i < layer->numitems; i++) {
+        if (layer->items[i]) {
+          for (j = 0; j < numitems; j++) {
+            if (unsorted_items[j] &&
+                strcasecmp(layer->items[i], unsorted_items[j]) == 0) {
+              sorted_items[num_sorted_items] = layer->items[i];
+              num_sorted_items++;
+
+              layer->items[i] = NULL;
+              msFree(unsorted_items[j]);
+              unsorted_items[j] = NULL;
+              break;
             }
+          }
         }
+      }
 
-        /* Add items that are not returned by msLayerGetItems() (not sure if that can happen) */
-        for( j = 0; j < numitems; j++ )
-        {
-            if( unsorted_items[j] )
-            {
-                sorted_items[num_sorted_items] = unsorted_items[j];
-                num_sorted_items ++;
-            }
+      /* Add items that are not returned by msLayerGetItems() (not sure if that
+       * can happen) */
+      for (j = 0; j < numitems; j++) {
+        if (unsorted_items[j]) {
+          sorted_items[num_sorted_items] = unsorted_items[j];
+          num_sorted_items++;
         }
+      }
 
-        if(layer->numitems > 0) {
-            msFreeCharArray(layer->items, layer->numitems);
-        }
-        msFreeCharArray(unsorted_items, numitems);
+      if (layer->numitems > 0) {
+        msFreeCharArray(layer->items, layer->numitems);
+      }
+      msFreeCharArray(unsorted_items, numitems);
 
-        layer->items = sorted_items;
-        layer->numitems = numitems;
+      layer->items = sorted_items;
+      layer->numitems = numitems;
 
-        /* Re-run buildLayerItemList() with the now correctly sorted items */
-        buildLayerItemList(layer);
+      /* Re-run buildLayerItemList() with the now correctly sorted items */
+      buildLayerItemList(layer);
     }
-
   }
 
   /* populate the iteminfo array */
-  if(layer->numitems == 0)
-    return(MS_SUCCESS);
+  if (layer->numitems == 0)
+    return (MS_SUCCESS);
 
-  return(msLayerInitItemInfo(layer));
+  return (msLayerInitItemInfo(layer));
 }
 
 /*
-** A helper function to set the items to be retrieved with a particular shape. Unused at the moment but will be used
+** A helper function to set the items to be retrieved with a particular shape.
+*Unused at the moment but will be used
 ** from within MapScript. Should not need modification.
 */
-int msLayerSetItems(layerObj *layer, char **items, int numitems)
-{
+int msLayerSetItems(layerObj *layer, char **items, int numitems) {
   int i;
   /* Cleanup any previous item selection */
   msLayerFreeItemInfo(layer);
-  if(layer->items) {
+  if (layer->items) {
     msFreeCharArray(layer->items, layer->numitems);
     layer->items = NULL;
     layer->numitems = 0;
   }
 
   /* now allocate and set the layer item parameters  */
-  layer->items = (char **)malloc(sizeof(char *)*numitems);
-  MS_CHECK_ALLOC(layer->items, sizeof(char *)*numitems, MS_FAILURE);
+  layer->items = (char **)malloc(sizeof(char *) * numitems);
+  MS_CHECK_ALLOC(layer->items, sizeof(char *) * numitems, MS_FAILURE);
 
-  for(i=0; i<numitems; i++)
+  for (i = 0; i < numitems; i++)
     layer->items[i] = msStrdup(items[i]);
   layer->numitems = numitems;
 
   /* populate the iteminfo array */
-  return(msLayerInitItemInfo(layer));
+  return (msLayerInitItemInfo(layer));
 }
 
 /*
@@ -1152,10 +1320,10 @@ int msLayerSetItems(layerObj *layer, cha
 ** twice.
 **
 */
-int msLayerGetAutoStyle(mapObj *map, layerObj *layer, classObj *c, shapeObj* shape)
-{
-  if ( ! layer->vtable) {
-    int rv =  msInitializeVirtualTable(layer);
+int msLayerGetAutoStyle(mapObj *map, layerObj *layer, classObj *c,
+                        shapeObj *shape) {
+  if (!layer->vtable) {
+    int rv = msInitializeVirtualTable(layer);
     if (rv != MS_SUCCESS)
       return rv;
   }
@@ -1168,37 +1336,38 @@ int msLayerGetAutoStyle(mapObj *map, lay
 ** with STYLEITEM "attribute" when rendering shapes.
 **
 */
-int msLayerGetFeatureStyle(mapObj *map, layerObj *layer, classObj *c, shapeObj* shape)
-{
-  char* stylestring = NULL;
-  if (layer->styleitem && layer->styleitemindex >=0) {
+int msLayerGetFeatureStyle(mapObj *map, layerObj *layer, classObj *c,
+                           shapeObj *shape) {
+  char *stylestring = NULL;
+  if (layer->styleitem && layer->styleitemindex >= 0) {
     stylestring = msStrdup(shape->values[layer->styleitemindex]);
-  }
-  else if (layer->styleitem && strncasecmp(layer->styleitem,"javascript://",13) == 0) {
+  } else if (layer->styleitem &&
+             strncasecmp(layer->styleitem, "javascript://", 13) == 0) {
 #ifdef USE_V8_MAPSCRIPT
-    char *filename = layer->styleitem+13;
+    char *filename = layer->styleitem + 13;
 
     if (!map->v8context) {
       msV8CreateContext(map);
-      if (!map->v8context)
-      {
-        msSetError(MS_V8ERR, "Unable to create v8 context.", "msLayerGetFeatureStyle()");
+      if (!map->v8context) {
+        msSetError(MS_V8ERR, "Unable to create v8 context.",
+                   "msLayerGetFeatureStyle()");
         return MS_FAILURE;
       }
     }
 
     if (*filename == '\0') {
-      msSetError(MS_V8ERR, "Invalid javascript filename: \"%s\".", "msLayerGetFeatureStyle()", layer->styleitem);
+      msSetError(MS_V8ERR, "Invalid javascript filename: \"%s\".",
+                 "msLayerGetFeatureStyle()", layer->styleitem);
       return MS_FAILURE;
     }
-    
+
     stylestring = msV8GetFeatureStyle(map, filename, layer, shape);
 #else
-      msSetError(MS_V8ERR, "V8 Javascript support is not available.", "msLayerGetFeatureStyle()");
-      return MS_FAILURE;
+    msSetError(MS_V8ERR, "V8 Javascript support is not available.",
+               "msLayerGetFeatureStyle()");
+    return MS_FAILURE;
 #endif
-  }
-  else { /* unknown styleitem */
+  } else { /* unknown styleitem */
     return MS_FAILURE;
   }
 
@@ -1206,32 +1375,36 @@ int msLayerGetFeatureStyle(mapObj *map,
   if (!stylestring)
     return MS_FAILURE;
 
-  if (strncasecmp(stylestring,"style",5) == 0) {
+  if (strncasecmp(stylestring, "style", 5) == 0) {
     resetClassStyle(c);
     c->layer = layer;
     if (msMaybeAllocateClassStyle(c, 0)) {
       free(stylestring);
-      return(MS_FAILURE);
+      return (MS_FAILURE);
     }
 
     msUpdateStyleFromString(c->styles[0], stylestring);
-    if(c->styles[0]->symbolname) {
-      if((c->styles[0]->symbol =  msGetSymbolIndex(&(map->symbolset), c->styles[0]->symbolname, MS_TRUE)) == -1) {
-        msSetError(MS_MISCERR, "Undefined symbol \"%s\" in class of layer %s.", "msLayerGetFeatureStyle()", 
-                   c->styles[0]->symbolname, layer->name);
+    if (c->styles[0]->symbolname) {
+      if ((c->styles[0]->symbol = msGetSymbolIndex(
+               &(map->symbolset), c->styles[0]->symbolname, MS_TRUE)) == -1) {
+        msSetError(MS_MISCERR, "Undefined symbol \"%s\" in class of layer %s.",
+                   "msLayerGetFeatureStyle()", c->styles[0]->symbolname,
+                   layer->name);
         free(stylestring);
         return MS_FAILURE;
       }
     }
-  } else if (strncasecmp(stylestring,"class",5) == 0) {
+  } else if (strncasecmp(stylestring, "class", 5) == 0) {
     if (strcasestr(stylestring, " style ") != NULL) {
       /* reset style if stylestring contains style definitions */
       resetClassStyle(c);
       c->layer = layer;
     }
     msUpdateClassFromString(c, stylestring);
-  } else if (strncasecmp(stylestring,"pen",3) == 0 || strncasecmp(stylestring,"brush",5) == 0 ||
-             strncasecmp(stylestring,"symbol",6) == 0 || strncasecmp(stylestring,"label",5) == 0) {
+  } else if (strncasecmp(stylestring, "pen", 3) == 0 ||
+             strncasecmp(stylestring, "brush", 5) == 0 ||
+             strncasecmp(stylestring, "symbol", 6) == 0 ||
+             strncasecmp(stylestring, "label", 5) == 0) {
     msOGRUpdateStyleFromString(map, layer, c, stylestring);
   } else {
     resetClassStyle(c);
@@ -1241,62 +1414,60 @@ int msLayerGetFeatureStyle(mapObj *map,
   return MS_SUCCESS;
 }
 
-
 /*
 Returns the number of inline feature of a layer
 */
-int msLayerGetNumFeatures(layerObj *layer)
-{
-    int need_to_close = MS_FALSE, result = -1;
+int msLayerGetNumFeatures(layerObj *layer) {
+  int need_to_close = MS_FALSE, result = -1;
 
-    if (!msLayerIsOpen(layer)) {
-        if (msLayerOpen(layer) != MS_SUCCESS)
-            return result;
-        need_to_close = MS_TRUE;
-    }
+  if (!msLayerIsOpen(layer)) {
+    if (msLayerOpen(layer) != MS_SUCCESS)
+      return result;
+    need_to_close = MS_TRUE;
+  }
 
-    if (!layer->vtable) {
-        int rv = msInitializeVirtualTable(layer);
-        if (rv != MS_SUCCESS)
-            return result;
-    }
-    cppcheck_assert(layer->vtable);
+  if (!layer->vtable) {
+    int rv = msInitializeVirtualTable(layer);
+    if (rv != MS_SUCCESS)
+      return result;
+  }
+  cppcheck_assert(layer->vtable);
 
-    result = layer->vtable->LayerGetNumFeatures(layer);
+  result = layer->vtable->LayerGetNumFeatures(layer);
 
-    if (need_to_close)
-        msLayerClose(layer);
+  if (need_to_close)
+    msLayerClose(layer);
 
-    return(result);
+  return (result);
 }
 
-void
-msLayerSetProcessingKey( layerObj *layer, const char *key, const char *value)
+void msLayerSetProcessingKey(layerObj *layer, const char *key,
+                             const char *value)
 
 {
   int len = strlen(key);
   int i;
   char *directive = NULL;
 
-  if( value != NULL ) {
-    directive = (char *) msSmallMalloc(strlen(key)+strlen(value)+2);
-    sprintf( directive, "%s=%s", key, value );
+  if (value != NULL) {
+    directive = (char *)msSmallMalloc(strlen(key) + strlen(value) + 2);
+    sprintf(directive, "%s=%s", key, value);
   }
 
-  for( i = 0; i < layer->numprocessing; i++ ) {
-    if( strncasecmp( key, layer->processing[i], len ) == 0
-        && layer->processing[i][len] == '=' ) {
-      free( layer->processing[i] );
+  for (i = 0; i < layer->numprocessing; i++) {
+    if (strncasecmp(key, layer->processing[i], len) == 0 &&
+        layer->processing[i][len] == '=') {
+      free(layer->processing[i]);
 
       /*
       ** Either replace the existing entry with a new one or
       ** clear the entry.
       */
-      if( directive != NULL )
+      if (directive != NULL)
         layer->processing[i] = directive;
       else {
-        layer->processing[i] = layer->processing[layer->numprocessing-1];
-        layer->processing[layer->numprocessing-1] = NULL;
+        layer->processing[i] = layer->processing[layer->numprocessing - 1];
+        layer->processing[layer->numprocessing - 1] = NULL;
         layer->numprocessing--;
       }
       return;
@@ -1305,55 +1476,56 @@ msLayerSetProcessingKey( layerObj *layer
 
   /* otherwise add the directive at the end. */
 
-  if( directive != NULL ) {
-    msLayerAddProcessing( layer, directive );
-    free( directive );
+  if (directive != NULL) {
+    msLayerAddProcessing(layer, directive);
+    free(directive);
   }
 }
 
-void msLayerSubstituteProcessing( layerObj *layer, const char *from, const char *to ) {
+void msLayerSubstituteProcessing(layerObj *layer, const char *from,
+                                 const char *to) {
   int i;
-  for( i = 0; i < layer->numprocessing; i++ ) {
-    layer->processing[i] = msCaseReplaceSubstring(layer->processing[i], from, to);
+  for (i = 0; i < layer->numprocessing; i++) {
+    layer->processing[i] =
+        msCaseReplaceSubstring(layer->processing[i], from, to);
   }
 }
 
-void msLayerAddProcessing( layerObj *layer, const char *directive )
+void msLayerAddProcessing(layerObj *layer, const char *directive)
 
 {
   layer->numprocessing++;
-  if( layer->numprocessing == 1 )
-    layer->processing = (char **) msSmallMalloc(2*sizeof(char *));
+  if (layer->numprocessing == 1)
+    layer->processing = (char **)msSmallMalloc(2 * sizeof(char *));
   else
-    layer->processing = (char **) msSmallRealloc(layer->processing, sizeof(char*) * (layer->numprocessing+1) );
-  layer->processing[layer->numprocessing-1] = msStrdup(directive);
+    layer->processing = (char **)msSmallRealloc(
+        layer->processing, sizeof(char *) * (layer->numprocessing + 1));
+  layer->processing[layer->numprocessing - 1] = msStrdup(directive);
   layer->processing[layer->numprocessing] = NULL;
 }
 
-const char *msLayerGetProcessing( const layerObj *layer, int proc_index)
-{
+const char *msLayerGetProcessing(const layerObj *layer, int proc_index) {
   if (proc_index < 0 || proc_index >= layer->numprocessing) {
-    msSetError(MS_CHILDERR, "Invalid processing index.", "msLayerGetProcessing()");
+    msSetError(MS_CHILDERR, "Invalid processing index.",
+               "msLayerGetProcessing()");
     return NULL;
   } else {
     return layer->processing[proc_index];
   }
 }
 
-const char *msLayerGetProcessingKey( const layerObj *layer, const char *key )
-{
+const char *msLayerGetProcessingKey(const layerObj *layer, const char *key) {
   int i, len = strlen(key);
 
-  for( i = 0; i < layer->numprocessing; i++ ) {
-    if( strncasecmp(layer->processing[i],key,len) == 0
-        && layer->processing[i][len] == '=' )
+  for (i = 0; i < layer->numprocessing; i++) {
+    if (strncasecmp(layer->processing[i], key, len) == 0 &&
+        layer->processing[i][len] == '=')
       return layer->processing[i] + len + 1;
   }
 
   return NULL;
 }
 
-
 /************************************************************************/
 /*                       msLayerGetMaxFeaturesToDraw                    */
 /*                                                                      */
@@ -1361,8 +1533,7 @@ const char *msLayerGetProcessingKey( con
 /*      output format option. Used for vector layers to limit the       */
 /*      number of fatures rendered.                                     */
 /************************************************************************/
-int msLayerGetMaxFeaturesToDraw(layerObj *layer, outputFormatObj *format)
-{
+int msLayerGetMaxFeaturesToDraw(layerObj *layer, outputFormatObj *format) {
   int nMaxFeatures = -1;
   const char *pszTmp = NULL;
   if (layer) {
@@ -1371,39 +1542,34 @@ int msLayerGetMaxFeaturesToDraw(layerObj
     if (pszTmp)
       nMaxFeatures = atoi(pszTmp);
     else {
-      pszTmp = msLookupHashTable(&layer->map->web.metadata, "maxfeaturestodraw");
+      pszTmp =
+          msLookupHashTable(&layer->map->web.metadata, "maxfeaturestodraw");
       if (pszTmp)
         nMaxFeatures = atoi(pszTmp);
     }
   }
-  if(format) {
+  if (format) {
     if (nMaxFeatures < 0)
-      nMaxFeatures = atoi(msGetOutputFormatOption( format, "maxfeaturestodraw", "-1"));
+      nMaxFeatures =
+          atoi(msGetOutputFormatOption(format, "maxfeaturestodraw", "-1"));
   }
 
   return nMaxFeatures;
-
 }
-int msLayerClearProcessing( layerObj *layer )
-{
+int msLayerClearProcessing(layerObj *layer) {
   if (layer->numprocessing > 0) {
-    msFreeCharArray( layer->processing, layer->numprocessing );
+    msFreeCharArray(layer->processing, layer->numprocessing);
     layer->processing = NULL;
     layer->numprocessing = 0;
   }
   return layer->numprocessing;
 }
 
-
-int
-makeTimeFilter(layerObj *lp,
-               const char *timestring,
-               const char *timefield,
-               const int addtimebacktics)
-{
+int makeTimeFilter(layerObj *lp, const char *timestring, const char *timefield,
+                   const int addtimebacktics) {
 
   char **atimes, **tokens = NULL;
-  int numtimes,i, ntmp = 0;
+  int numtimes, i, ntmp = 0;
   char *pszBuffer = NULL;
   int bOnlyExistingFilter = 0;
 
@@ -1426,22 +1592,22 @@ makeTimeFilter(layerObj *lp,
     /* if the filter is set and it's a sting type, concatenate it with
        the time. If not just free it */
     if (lp->filter.string && lp->filter.type == MS_STRING) {
-     pszBuffer = msStringConcatenate(pszBuffer, "((");
-     pszBuffer = msStringConcatenate(pszBuffer, lp->filter.string);
-     pszBuffer = msStringConcatenate(pszBuffer, ") and ");
+      pszBuffer = msStringConcatenate(pszBuffer, "((");
+      pszBuffer = msStringConcatenate(pszBuffer, lp->filter.string);
+      pszBuffer = msStringConcatenate(pszBuffer, ") and ");
     } else if (lp->filter.string && lp->filter.type == MS_EXPRESSION) {
-     char* pszExpressionString = msGetExpressionString(&(lp->filter));
-     pszBuffer = msStringConcatenate(pszBuffer, "(");
-     pszBuffer = msStringConcatenate(pszBuffer, pszExpressionString);
-     pszBuffer = msStringConcatenate(pszBuffer, " and ");
-     msFree(pszExpressionString);
+      char *pszExpressionString = msGetExpressionString(&(lp->filter));
+      pszBuffer = msStringConcatenate(pszBuffer, "(");
+      pszBuffer = msStringConcatenate(pszBuffer, pszExpressionString);
+      pszBuffer = msStringConcatenate(pszBuffer, " and ");
+      msFree(pszExpressionString);
     } else {
-     msFreeExpression(&lp->filter);
+      msFreeExpression(&lp->filter);
     }
 
     pszBuffer = msStringConcatenate(pszBuffer, "(");
     if (addtimebacktics)
-      pszBuffer = msStringConcatenate(pszBuffer,  "`");
+      pszBuffer = msStringConcatenate(pszBuffer, "`");
 
     if (addtimebacktics)
       pszBuffer = msStringConcatenate(pszBuffer, "[");
@@ -1449,29 +1615,28 @@ makeTimeFilter(layerObj *lp,
     if (addtimebacktics)
       pszBuffer = msStringConcatenate(pszBuffer, "]");
     if (addtimebacktics)
-      pszBuffer = msStringConcatenate(pszBuffer,  "`");
-
+      pszBuffer = msStringConcatenate(pszBuffer, "`");
 
     pszBuffer = msStringConcatenate(pszBuffer, " = ");
     if (addtimebacktics)
-      pszBuffer = msStringConcatenate(pszBuffer,  "`");
+      pszBuffer = msStringConcatenate(pszBuffer, "`");
     else
-      pszBuffer = msStringConcatenate(pszBuffer,  "'");
+      pszBuffer = msStringConcatenate(pszBuffer, "'");
 
     pszBuffer = msStringConcatenate(pszBuffer, (char *)timestring);
     if (addtimebacktics)
-      pszBuffer = msStringConcatenate(pszBuffer,  "`");
+      pszBuffer = msStringConcatenate(pszBuffer, "`");
     else
-      pszBuffer = msStringConcatenate(pszBuffer,  "'");
+      pszBuffer = msStringConcatenate(pszBuffer, "'");
 
     pszBuffer = msStringConcatenate(pszBuffer, ")");
 
-    /* if there was a filter, It was concatenate with an And ans should be closed*/
+    /* if there was a filter, It was concatenate with an And ans should be
+     * closed*/
     if (lp->filter.string &&
-       (lp->filter.type == MS_STRING || lp->filter.type == MS_EXPRESSION))
+        (lp->filter.type == MS_STRING || lp->filter.type == MS_EXPRESSION))
       pszBuffer = msStringConcatenate(pszBuffer, ")");
 
-
     msLoadExpressionString(&lp->filter, pszBuffer);
 
     if (pszBuffer)
@@ -1481,7 +1646,7 @@ makeTimeFilter(layerObj *lp,
 
   atimes = msStringSplit(timestring, ',', &numtimes);
   if (atimes == NULL || numtimes < 1) {
-    msFreeCharArray(atimes,numtimes);
+    msFreeCharArray(atimes, numtimes);
     return MS_FALSE;
   }
 
@@ -1494,7 +1659,7 @@ makeTimeFilter(layerObj *lp,
       added to the buffer */
     bOnlyExistingFilter = 1;
   } else if (lp->filter.string && lp->filter.type == MS_EXPRESSION) {
-    char* pszExpressionString = msGetExpressionString(&(lp->filter));
+    char *pszExpressionString = msGetExpressionString(&(lp->filter));
     pszBuffer = msStringConcatenate(pszBuffer, "(");
     pszBuffer = msStringConcatenate(pszBuffer, pszExpressionString);
     pszBuffer = msStringConcatenate(pszBuffer, " and ");
@@ -1504,11 +1669,11 @@ makeTimeFilter(layerObj *lp,
     msFreeExpression(&lp->filter);
 
   /* check to see if we have ranges by parsing the first entry */
-  tokens = msStringSplit(atimes[0],  '/', &ntmp);
+  tokens = msStringSplit(atimes[0], '/', &ntmp);
   if (ntmp == 2) { /* ranges */
     msFreeCharArray(tokens, ntmp);
-    for (i=0; i<numtimes; i++) {
-      tokens = msStringSplit(atimes[i],  '/', &ntmp);
+    for (i = 0; i < numtimes; i++) {
+      tokens = msStringSplit(atimes[i], '/', &ntmp);
       if (ntmp == 2) {
         if (pszBuffer && strlen(pszBuffer) > 0 && bOnlyExistingFilter == 0)
           pszBuffer = msStringConcatenate(pszBuffer, " OR ");
@@ -1519,7 +1684,7 @@ makeTimeFilter(layerObj *lp,
 
         pszBuffer = msStringConcatenate(pszBuffer, "(");
         if (addtimebacktics)
-          pszBuffer = msStringConcatenate(pszBuffer,  "`");
+          pszBuffer = msStringConcatenate(pszBuffer, "`");
 
         if (addtimebacktics)
           pszBuffer = msStringConcatenate(pszBuffer, "[");
@@ -1528,23 +1693,23 @@ makeTimeFilter(layerObj *lp,
           pszBuffer = msStringConcatenate(pszBuffer, "]");
 
         if (addtimebacktics)
-          pszBuffer = msStringConcatenate(pszBuffer,  "`");
+          pszBuffer = msStringConcatenate(pszBuffer, "`");
 
         pszBuffer = msStringConcatenate(pszBuffer, " >= ");
         if (addtimebacktics)
-          pszBuffer = msStringConcatenate(pszBuffer,  "`");
+          pszBuffer = msStringConcatenate(pszBuffer, "`");
         else
-          pszBuffer = msStringConcatenate(pszBuffer,  "'");
+          pszBuffer = msStringConcatenate(pszBuffer, "'");
 
         pszBuffer = msStringConcatenate(pszBuffer, tokens[0]);
         if (addtimebacktics)
-          pszBuffer = msStringConcatenate(pszBuffer,  "`");
+          pszBuffer = msStringConcatenate(pszBuffer, "`");
         else
-          pszBuffer = msStringConcatenate(pszBuffer,  "'");
+          pszBuffer = msStringConcatenate(pszBuffer, "'");
         pszBuffer = msStringConcatenate(pszBuffer, " AND ");
 
         if (addtimebacktics)
-          pszBuffer = msStringConcatenate(pszBuffer,  "`");
+          pszBuffer = msStringConcatenate(pszBuffer, "`");
 
         if (addtimebacktics)
           pszBuffer = msStringConcatenate(pszBuffer, "[");
@@ -1552,19 +1717,19 @@ makeTimeFilter(layerObj *lp,
         if (addtimebacktics)
           pszBuffer = msStringConcatenate(pszBuffer, "]");
         if (addtimebacktics)
-          pszBuffer = msStringConcatenate(pszBuffer,  "`");
+          pszBuffer = msStringConcatenate(pszBuffer, "`");
 
         pszBuffer = msStringConcatenate(pszBuffer, " <= ");
 
         if (addtimebacktics)
-          pszBuffer = msStringConcatenate(pszBuffer,  "`");
+          pszBuffer = msStringConcatenate(pszBuffer, "`");
         else
-          pszBuffer = msStringConcatenate(pszBuffer,  "'");
+          pszBuffer = msStringConcatenate(pszBuffer, "'");
         pszBuffer = msStringConcatenate(pszBuffer, tokens[1]);
         if (addtimebacktics)
-          pszBuffer = msStringConcatenate(pszBuffer,  "`");
+          pszBuffer = msStringConcatenate(pszBuffer, "`");
         else
-          pszBuffer = msStringConcatenate(pszBuffer,  "'");
+          pszBuffer = msStringConcatenate(pszBuffer, "'");
         pszBuffer = msStringConcatenate(pszBuffer, ")");
       }
 
@@ -1575,7 +1740,7 @@ makeTimeFilter(layerObj *lp,
   } else if (ntmp == 1) { /* multiple times */
     msFreeCharArray(tokens, ntmp);
     pszBuffer = msStringConcatenate(pszBuffer, "(");
-    for (i=0; i<numtimes; i++) {
+    for (i = 0; i < numtimes; i++) {
       if (i > 0)
         pszBuffer = msStringConcatenate(pszBuffer, " OR ");
 
@@ -1597,12 +1762,12 @@ makeTimeFilter(layerObj *lp,
       if (addtimebacktics)
         pszBuffer = msStringConcatenate(pszBuffer, "`");
       else
-        pszBuffer = msStringConcatenate(pszBuffer,  "'");
+        pszBuffer = msStringConcatenate(pszBuffer, "'");
       pszBuffer = msStringConcatenate(pszBuffer, atimes[i]);
       if (addtimebacktics)
-        pszBuffer = msStringConcatenate(pszBuffer,  "`");
+        pszBuffer = msStringConcatenate(pszBuffer, "`");
       else
-        pszBuffer = msStringConcatenate(pszBuffer,  "'");
+        pszBuffer = msStringConcatenate(pszBuffer, "'");
       pszBuffer = msStringConcatenate(pszBuffer, ")");
     }
     pszBuffer = msStringConcatenate(pszBuffer, ")");
@@ -1617,7 +1782,8 @@ makeTimeFilter(layerObj *lp,
 
   /* load the string to the filter */
   if (pszBuffer && strlen(pszBuffer) > 0) {
-    if(lp->filter.string && (lp->filter.type == MS_STRING || lp->filter.type == MS_EXPRESSION ))
+    if (lp->filter.string &&
+        (lp->filter.type == MS_STRING || lp->filter.type == MS_EXPRESSION))
       pszBuffer = msStringConcatenate(pszBuffer, ")");
     /*
     if(lp->filteritem)
@@ -1626,7 +1792,6 @@ makeTimeFilter(layerObj *lp,
     */
 
     msLoadExpressionString(&lp->filter, pszBuffer);
-
   }
   msFree(pszBuffer);
   return MS_TRUE;
@@ -1637,10 +1802,9 @@ makeTimeFilter(layerObj *lp,
 **/
 
 int msLayerSetTimeFilter(layerObj *layer, const char *timestring,
-                         const char *timefield)
-{
-  if ( ! layer->vtable) {
-    int rv =  msInitializeVirtualTable(layer);
+                         const char *timefield) {
+  if (!layer->vtable) {
+    int rv = msInitializeVirtualTable(layer);
     if (rv != MS_SUCCESS)
       return rv;
   }
@@ -1648,141 +1812,124 @@ int msLayerSetTimeFilter(layerObj *layer
   return layer->vtable->LayerSetTimeFilter(layer, timestring, timefield);
 }
 
-int
-msLayerMakeBackticsTimeFilter(layerObj *lp, const char *timestring,
-                              const char *timefield)
-{
+int msLayerMakeBackticsTimeFilter(layerObj *lp, const char *timestring,
+                                  const char *timefield) {
   return makeTimeFilter(lp, timestring, timefield, MS_TRUE);
 }
 
-int
-msLayerMakePlainTimeFilter(layerObj *lp, const char *timestring,
-                           const char *timefield)
-{
+int msLayerMakePlainTimeFilter(layerObj *lp, const char *timestring,
+                               const char *timefield) {
   return makeTimeFilter(lp, timestring, timefield, MS_FALSE);
 }
 
-
 /*
  * Dummies / default actions for layers
  */
-int LayerDefaultInitItemInfo(layerObj *layer)
-{
+int LayerDefaultInitItemInfo(layerObj *layer) {
   (void)layer;
   return MS_SUCCESS;
 }
 
-void LayerDefaultFreeItemInfo(layerObj *layer)
-{
-  (void)layer;
-}
+void LayerDefaultFreeItemInfo(layerObj *layer) { (void)layer; }
 
-int LayerDefaultOpen(layerObj *layer)
-{
+int LayerDefaultOpen(layerObj *layer) {
   (void)layer;
   return MS_FAILURE;
 }
 
-int LayerDefaultIsOpen(layerObj *layer)
-{
+int LayerDefaultIsOpen(layerObj *layer) {
   (void)layer;
   return MS_FALSE;
 }
 
-int LayerDefaultWhichShapes(layerObj *layer, rectObj rect, int isQuery)
-{
+int LayerDefaultWhichShapes(layerObj *layer, rectObj rect, int isQuery) {
   (void)layer;
   (void)rect;
   (void)isQuery;
   return MS_SUCCESS;
 }
 
-int LayerDefaultNextShape(layerObj *layer, shapeObj *shape)
-{
+int LayerDefaultNextShape(layerObj *layer, shapeObj *shape) {
   (void)layer;
   (void)shape;
   return MS_FAILURE;
 }
 
-int LayerDefaultGetShape(layerObj *layer, shapeObj *shape, resultObj *record)
-{
+int LayerDefaultGetShape(layerObj *layer, shapeObj *shape, resultObj *record) {
   (void)layer;
   (void)shape;
   (void)record;
   return MS_FAILURE;
 }
 
-int LayerDefaultGetShapeCount(layerObj *layer, rectObj rect, projectionObj *rectProjection)
-{
+int LayerDefaultGetShapeCount(layerObj *layer, rectObj rect,
+                              projectionObj *rectProjection) {
   int status;
   shapeObj shape, searchshape;
   int nShapeCount = 0;
   rectObj searchrect = rect;
-  reprojectionObj* reprojector = NULL;
+  reprojectionObj *reprojector = NULL;
 
   msInitShape(&searchshape);
   msRectToPolygon(searchrect, &searchshape);
 
-  if( rectProjection != NULL ) 
-  {
-    if(layer->project && msProjectionsDiffer(&(layer->projection), rectProjection))
-      msProjectRect(rectProjection, &(layer->projection), &searchrect); /* project the searchrect to source coords */
+  if (rectProjection != NULL) {
+    if (layer->project &&
+        msProjectionsDiffer(&(layer->projection), rectProjection))
+      msProjectRect(rectProjection, &(layer->projection),
+                    &searchrect); /* project the searchrect to source coords */
     else
       layer->project = MS_FALSE;
   }
 
-  status = msLayerWhichShapes(layer, searchrect, MS_TRUE) ;
-  if( status == MS_FAILURE )
-  {
+  status = msLayerWhichShapes(layer, searchrect, MS_TRUE);
+  if (status == MS_FAILURE) {
     msFreeShape(&searchshape);
     return -1;
-  }
-  else if( status == MS_DONE )
-  {
+  } else if (status == MS_DONE) {
     msFreeShape(&searchshape);
     return 0;
   }
 
   msInitShape(&shape);
-  while((status = msLayerNextShape(layer, &shape)) == MS_SUCCESS)
-  {
-    if( rectProjection != NULL ) 
-    {
-      if(layer->project && msProjectionsDiffer(&(layer->projection), rectProjection))
-      {
-        if( reprojector == NULL )
-            reprojector = msProjectCreateReprojector(&(layer->projection), rectProjection);
-        if( reprojector )
-            msProjectShapeEx(reprojector, &shape);
-      }
-      else
+  while ((status = msLayerNextShape(layer, &shape)) == MS_SUCCESS) {
+    if (rectProjection != NULL) {
+      if (layer->project &&
+          msProjectionsDiffer(&(layer->projection), rectProjection)) {
+        if (reprojector == NULL)
+          reprojector =
+              msProjectCreateReprojector(&(layer->projection), rectProjection);
+        if (reprojector)
+          msProjectShapeEx(reprojector, &shape);
+      } else
         layer->project = MS_FALSE;
 
-      if(msRectContained(&shape.bounds, &rect) == MS_TRUE) { /* if the whole shape is in, don't intersect */
+      if (msRectContained(&shape.bounds, &rect) ==
+          MS_TRUE) { /* if the whole shape is in, don't intersect */
         status = MS_TRUE;
       } else {
-        switch(shape.type) { /* make sure shape actually intersects the qrect (ADD FUNCTIONS SPECIFIC TO RECTOBJ) */
-          case MS_SHAPE_POINT:
-            status = msIntersectMultipointPolygon(&shape, &searchshape);
-            break;
-          case MS_SHAPE_LINE:
-            status = msIntersectPolylinePolygon(&shape, &searchshape);
-            break;
-          case MS_SHAPE_POLYGON:
-            status = msIntersectPolygons(&shape, &searchshape);
-            break;
-          default:
-            break;
+        switch (shape.type) { /* make sure shape actually intersects the qrect
+                                 (ADD FUNCTIONS SPECIFIC TO RECTOBJ) */
+        case MS_SHAPE_POINT:
+          status = msIntersectMultipointPolygon(&shape, &searchshape);
+          break;
+        case MS_SHAPE_LINE:
+          status = msIntersectPolylinePolygon(&shape, &searchshape);
+          break;
+        case MS_SHAPE_POLYGON:
+          status = msIntersectPolygons(&shape, &searchshape);
+          break;
+        default:
+          break;
         }
       }
-    }
-    else
+    } else
       status = MS_TRUE;
 
-    if( status == MS_TRUE )
-      nShapeCount++ ;
+    if (status == MS_TRUE)
+      nShapeCount++;
     msFreeShape(&shape);
-    if(layer->maxfeatures > 0 && layer->maxfeatures == nShapeCount)
+    if (layer->maxfeatures > 0 && layer->maxfeatures == nShapeCount)
       break;
   }
 
@@ -1792,48 +1939,46 @@ int LayerDefaultGetShapeCount(layerObj *
   return nShapeCount;
 }
 
-int LayerDefaultClose(layerObj *layer)
-{
+int LayerDefaultClose(layerObj *layer) {
   (void)layer;
   return MS_SUCCESS;
 }
 
-int LayerDefaultGetItems(layerObj *layer)
-{
+int LayerDefaultGetItems(layerObj *layer) {
   (void)layer;
   return MS_SUCCESS; /* returning no items is legit */
 }
 
-int
-msLayerApplyCondSQLFilterToLayer(FilterEncodingNode *psNode, mapObj *map,
-                                 int iLayerIndex)
-{
+int msLayerApplyCondSQLFilterToLayer(FilterEncodingNode *psNode, mapObj *map,
+                                     int iLayerIndex) {
   return FLTLayerApplyCondSQLFilterToLayer(psNode, map, iLayerIndex);
 }
 
-int msLayerSupportsPaging(layerObj *layer)
-{
-  if (layer &&
-      ((layer->connectiontype == MS_ORACLESPATIAL) ||
-       (layer->connectiontype == MS_POSTGIS)) )
+int msLayerSupportsPaging(layerObj *layer) {
+  if (layer && ((layer->connectiontype == MS_ORACLESPATIAL) ||
+                (layer->connectiontype == MS_POSTGIS)))
     return MS_TRUE;
 
   return MS_FALSE;
 }
 
-int msLayerApplyPlainFilterToLayer(FilterEncodingNode *psNode, mapObj *map, int iLayerIndex);
+int msLayerApplyPlainFilterToLayer(FilterEncodingNode *psNode, mapObj *map,
+                                   int iLayerIndex);
 
 /*
  * msLayerSupportsSorting()
  *
  * Returns MS_TRUE if the layer supports sorting/ordering.
  */
-int msLayerSupportsSorting(layerObj *layer)
-{
-  if (layer && (
-    (layer->connectiontype == MS_OGR) || (layer->connectiontype == MS_POSTGIS) || (layer->connectiontype == MS_ORACLESPATIAL) || ((layer->connectiontype == MS_PLUGIN) && (strstr(layer->plugin_library,"msplugin_oracle") != NULL)) || ((layer->connectiontype == MS_PLUGIN) && (strstr(layer->plugin_library,"msplugin_mssql2008") != NULL))
-               )
-     )
+int msLayerSupportsSorting(layerObj *layer) {
+  if (layer &&
+      ((layer->connectiontype == MS_OGR) ||
+       (layer->connectiontype == MS_POSTGIS) ||
+       (layer->connectiontype == MS_ORACLESPATIAL) ||
+       ((layer->connectiontype == MS_PLUGIN) &&
+        (strstr(layer->plugin_library, "msplugin_oracle") != NULL)) ||
+       ((layer->connectiontype == MS_PLUGIN) &&
+        (strstr(layer->plugin_library, "msplugin_mssql2008") != NULL))))
     return MS_TRUE;
 
   return MS_FALSE;
@@ -1844,20 +1989,20 @@ int msLayerSupportsSorting(layerObj *lay
  *
  * Copy the sortBy clause passed as an argument into the layer sortBy member.
  */
-void msLayerSetSort(layerObj *layer, const sortByClause* sortBy)
-{
+void msLayerSetSort(layerObj *layer, const sortByClause *sortBy) {
   int i;
-  for(i=0;i<layer->sortBy.nProperties;i++)
+  for (i = 0; i < layer->sortBy.nProperties; i++)
     msFree(layer->sortBy.properties[i].item);
   msFree(layer->sortBy.properties);
 
   layer->sortBy.nProperties = sortBy->nProperties;
-  layer->sortBy.properties = (sortByProperties*) msSmallMalloc(sortBy->nProperties * sizeof(sortByProperties));
-  for(i=0;i<layer->sortBy.nProperties;i++) {
+  layer->sortBy.properties = (sortByProperties *)msSmallMalloc(
+      sortBy->nProperties * sizeof(sortByProperties));
+  for (i = 0; i < layer->sortBy.nProperties; i++) {
     layer->sortBy.properties[i].item = msStrdup(sortBy->properties[i].item);
     layer->sortBy.properties[i].sortOrder = sortBy->properties[i].sortOrder;
   }
- }
+}
 
 /*
  * msLayerBuildSQLOrderBy()
@@ -1865,17 +2010,17 @@ void msLayerSetSort(layerObj *layer, con
  * Returns the content of a SQL ORDER BY clause from the sortBy member of
  * the layer. The string does not contain the "ORDER BY" keywords itself.
  */
-char* msLayerBuildSQLOrderBy(layerObj *layer)
-{
-  char* strOrderBy = NULL;
-  if( layer->sortBy.nProperties > 0 ) {
+char *msLayerBuildSQLOrderBy(layerObj *layer) {
+  char *strOrderBy = NULL;
+  if (layer->sortBy.nProperties > 0) {
     int i;
-    for(i=0;i<layer->sortBy.nProperties;i++) {
-      char* escaped = msLayerEscapePropertyName(layer, layer->sortBy.properties[i].item);
-      if( i > 0 )
+    for (i = 0; i < layer->sortBy.nProperties; i++) {
+      char *escaped =
+          msLayerEscapePropertyName(layer, layer->sortBy.properties[i].item);
+      if (i > 0)
         strOrderBy = msStringConcatenate(strOrderBy, ", ");
       strOrderBy = msStringConcatenate(strOrderBy, escaped);
-      if( layer->sortBy.properties[i].sortOrder == SORT_DESC )
+      if (layer->sortBy.properties[i].sortOrder == SORT_DESC)
         strOrderBy = msStringConcatenate(strOrderBy, " DESC");
       msFree(escaped);
     }
@@ -1883,18 +2028,17 @@ char* msLayerBuildSQLOrderBy(layerObj *l
   return strOrderBy;
 }
 
-int
-msLayerApplyPlainFilterToLayer(FilterEncodingNode *psNode, mapObj *map, int iLayerIndex)
-{
+int msLayerApplyPlainFilterToLayer(FilterEncodingNode *psNode, mapObj *map,
+                                   int iLayerIndex) {
   return FLTLayerApplyPlainFilterToLayer(psNode, map, iLayerIndex);
 }
 
-int msLayerGetPaging(layerObj *layer)
-{
-  if ( ! layer->vtable) {
-    int rv =  msInitializeVirtualTable(layer);
+int msLayerGetPaging(layerObj *layer) {
+  if (!layer->vtable) {
+    int rv = msInitializeVirtualTable(layer);
     if (rv != MS_SUCCESS) {
-      msSetError(MS_MISCERR, "Unable to initialize virtual table", "msLayerGetPaging()");
+      msSetError(MS_MISCERR, "Unable to initialize virtual table",
+                 "msLayerGetPaging()");
       return MS_FAILURE;
     }
   }
@@ -1902,12 +2046,12 @@ int msLayerGetPaging(layerObj *layer)
   return layer->vtable->LayerGetPaging(layer);
 }
 
-void msLayerEnablePaging(layerObj *layer, int value)
-{
-  if ( ! layer->vtable) {
-    int rv =  msInitializeVirtualTable(layer);
+void msLayerEnablePaging(layerObj *layer, int value) {
+  if (!layer->vtable) {
+    int rv = msInitializeVirtualTable(layer);
     if (rv != MS_SUCCESS) {
-      msSetError(MS_MISCERR, "Unable to initialize virtual table", "msLayerEnablePaging()");
+      msSetError(MS_MISCERR, "Unable to initialize virtual table",
+                 "msLayerEnablePaging()");
       return;
     }
   }
@@ -1915,33 +2059,48 @@ void msLayerEnablePaging(layerObj *layer
   layer->vtable->LayerEnablePaging(layer, value);
 }
 
-int LayerDefaultGetExtent(layerObj *layer, rectObj *extent)
-{
+/** Returns a cached reprojector from the layer projection to the map projection
+ */
+reprojectionObj *msLayerGetReprojectorToMap(layerObj *layer, mapObj *map) {
+  if (layer->reprojectorLayerToMap != NULL &&
+      !msProjectIsReprojectorStillValid(layer->reprojectorLayerToMap)) {
+    msProjectDestroyReprojector(layer->reprojectorLayerToMap);
+    layer->reprojectorLayerToMap = NULL;
+  }
+
+  if (layer->reprojectorLayerToMap == NULL) {
+    layer->reprojectorLayerToMap =
+        msProjectCreateReprojector(&layer->projection, &map->projection);
+  }
+  return layer->reprojectorLayerToMap;
+}
+
+int LayerDefaultGetExtent(layerObj *layer, rectObj *extent) {
   (void)layer;
   (void)extent;
   return MS_FAILURE;
 }
 
-int LayerDefaultGetAutoStyle(mapObj *map, layerObj *layer, classObj *c, shapeObj *shape)
-{
+int LayerDefaultGetAutoStyle(mapObj *map, layerObj *layer, classObj *c,
+                             shapeObj *shape) {
   (void)map;
   (void)layer;
   (void)c;
   (void)shape;
-  msSetError(MS_MISCERR, "'STYLEITEM AUTO' not supported for this data source.", "msLayerGetAutoStyle()");
+  msSetError(MS_MISCERR, "'STYLEITEM AUTO' not supported for this data source.",
+             "msLayerGetAutoStyle()");
   return MS_FAILURE;
 }
 
-int LayerDefaultCloseConnection(layerObj *layer)
-{
+int LayerDefaultCloseConnection(layerObj *layer) {
   (void)layer;
   return MS_SUCCESS;
 }
 
-int LayerDefaultCreateItems(layerObj *layer, const int nt)
-{
+int LayerDefaultCreateItems(layerObj *layer, const int nt) {
   if (nt > 0) {
-    layer->items = (char **)calloc(nt, sizeof(char *)); /* should be more than enough space */
+    layer->items = (char **)calloc(
+        nt, sizeof(char *)); /* should be more than enough space */
     MS_CHECK_ALLOC(layer->items, sizeof(char *), MS_FAILURE);
 
     layer->numitems = 0;
@@ -1949,79 +2108,79 @@ int LayerDefaultCreateItems(layerObj *la
   return MS_SUCCESS;
 }
 
-int LayerDefaultGetNumFeatures(layerObj *layer)
-{
-    rectObj extent;
-    int status;
-    int result;
-    shapeObj shape;
-
-    /* calculate layer extent */
-    if (!MS_VALID_EXTENT(layer->extent)) {
-        if (msLayerGetExtent(layer, &extent) != MS_SUCCESS) {
-            msSetError(MS_MISCERR, "Unable to get layer extent", "LayerDefaultGetNumFeatures()");
-            return -1;
-        }
-    }
-    else
-        extent = layer->extent;
+int LayerDefaultGetNumFeatures(layerObj *layer) {
+  rectObj extent;
+  int status;
+  int result;
+  shapeObj shape;
 
-    /* Cleanup any previous item selection */
-    msLayerFreeItemInfo(layer);
-    if (layer->items) {
-        msFreeCharArray(layer->items, layer->numitems);
-        layer->items = NULL;
-        layer->numitems = 0;
+  /* calculate layer extent */
+  if (!MS_VALID_EXTENT(layer->extent)) {
+    if (msLayerGetExtent(layer, &extent) != MS_SUCCESS) {
+      msSetError(MS_MISCERR, "Unable to get layer extent",
+                 "LayerDefaultGetNumFeatures()");
+      return -1;
     }
+  } else
+    extent = layer->extent;
 
-    status = msLayerWhichShapes(layer, extent, MS_FALSE);
-    if (status == MS_DONE) { /* no overlap */
-        return 0;
-    }
-    else if (status != MS_SUCCESS) {
-        return -1;
-    }
+  /* Cleanup any previous item selection */
+  msLayerFreeItemInfo(layer);
+  if (layer->items) {
+    msFreeCharArray(layer->items, layer->numitems);
+    layer->items = NULL;
+    layer->numitems = 0;
+  }
 
-    result = 0;
-    while ((status = msLayerNextShape(layer, &shape)) == MS_SUCCESS) {
-        ++result;
-    }
+  status = msLayerWhichShapes(layer, extent, MS_FALSE);
+  if (status == MS_DONE) { /* no overlap */
+    return 0;
+  } else if (status != MS_SUCCESS) {
+    return -1;
+  }
 
-    return result;
+  result = 0;
+  while ((status = msLayerNextShape(layer, &shape)) == MS_SUCCESS) {
+    ++result;
+    msFreeShape(&shape);
+  }
+
+  return result;
 }
 
-int LayerDefaultAutoProjection(layerObj *layer, projectionObj* projection)
-{
+int LayerDefaultAutoProjection(layerObj *layer, projectionObj *projection) {
   (void)layer;
   (void)projection;
-  msSetError(MS_MISCERR, "This data driver does not implement AUTO projection support", "LayerDefaultAutoProjection()");
+  msSetError(MS_MISCERR,
+             "This data driver does not implement AUTO projection support",
+             "LayerDefaultAutoProjection()");
   return MS_FAILURE;
 }
 
-int LayerDefaultSupportsCommonFilters(layerObj *layer)
-{
+int LayerDefaultSupportsCommonFilters(layerObj *layer) {
   (void)layer;
   return MS_FALSE;
 }
 
-int LayerDefaultTranslateFilter(layerObj *layer, expressionObj *filter, char *filteritem) 
-{
+int LayerDefaultTranslateFilter(layerObj *layer, expressionObj *filter,
+                                char *filteritem) {
   (void)layer;
   (void)filteritem;
-  if(!filter->string) return MS_SUCCESS; /* nothing to do, not an error */
+  if (!filter->string)
+    return MS_SUCCESS; /* nothing to do, not an error */
 
-  msSetError(MS_MISCERR, "This data driver does not implement filter translation support", "LayerDefaultTranslateFilter()");
+  msSetError(MS_MISCERR,
+             "This data driver does not implement filter translation support",
+             "LayerDefaultTranslateFilter()");
   return MS_FAILURE;
 }
 
-int msLayerDefaultGetPaging(layerObj *layer)
-{
+int msLayerDefaultGetPaging(layerObj *layer) {
   (void)layer;
   return MS_FALSE;
 }
 
-void msLayerDefaultEnablePaging(layerObj *layer, int value)
-{
+void msLayerDefaultEnablePaging(layerObj *layer, int value) {
   (void)layer;
   (void)value;
 }
@@ -2033,17 +2192,16 @@ void msLayerDefaultEnablePaging(layerObj
 /*      injection. Specific drivers should redefine if an escaping      */
 /*      function is available in the driver.                            */
 /************************************************************************/
-char *LayerDefaultEscapeSQLParam(layerObj *layer, const char* pszString)
-{
+char *LayerDefaultEscapeSQLParam(layerObj *layer, const char *pszString) {
   (void)layer;
-  char *pszEscapedStr=NULL;
+  char *pszEscapedStr = NULL;
   if (pszString) {
     int nSrcLen;
     char c;
-    int i=0, j=0;
+    int i = 0, j = 0;
     nSrcLen = (int)strlen(pszString);
-    pszEscapedStr = (char*) msSmallMalloc( 2 * nSrcLen + 1);
-    for(i = 0, j = 0; i < nSrcLen; i++) {
+    pszEscapedStr = (char *)msSmallMalloc(2 * nSrcLen + 1);
+    for (i = 0, j = 0; i < nSrcLen; i++) {
       c = pszString[i];
       if (c == '\'') {
         pszEscapedStr[j++] = '\'';
@@ -2064,22 +2222,21 @@ char *LayerDefaultEscapeSQLParam(layerOb
 /*                                                                      */
 /*      Return the property name in a properly escaped and quoted form. */
 /************************************************************************/
-char *LayerDefaultEscapePropertyName(layerObj *layer, const char* pszString)
-{
-  char* pszEscapedStr=NULL;
+char *LayerDefaultEscapePropertyName(layerObj *layer, const char *pszString) {
+  char *pszEscapedStr = NULL;
   int i, j = 0;
 
   if (layer && pszString && strlen(pszString) > 0) {
     int nLength = strlen(pszString);
 
-    pszEscapedStr = (char*) msSmallMalloc( 1 + 2 * nLength + 1 + 1);
+    pszEscapedStr = (char *)msSmallMalloc(1 + 2 * nLength + 1 + 1);
     pszEscapedStr[j++] = '"';
 
-    for (i=0; i<nLength; i++) {
+    for (i = 0; i < nLength; i++) {
       char c = pszString[i];
       if (c == '"') {
         pszEscapedStr[j++] = '"';
-        pszEscapedStr[j++] ='"';
+        pszEscapedStr[j++] = '"';
       } else if (c == '\\') {
         pszEscapedStr[j++] = '\\';
         pszEscapedStr[j++] = '\\';
@@ -2088,12 +2245,10 @@ char *LayerDefaultEscapePropertyName(lay
     }
     pszEscapedStr[j++] = '"';
     pszEscapedStr[j++] = 0;
-
   }
   return pszEscapedStr;
 }
 
-
 /*
  * msConnectLayer
  *
@@ -2102,10 +2257,8 @@ char *LayerDefaultEscapePropertyName(lay
  * For Internal types the library_str is ignored, for PLUGIN it's
  * define what plugin to use. Returns MS_FAILURE or MS_SUCCESS.
  */
-int msConnectLayer(layerObj *layer,
-                   const int connectiontype,
-                   const char *library_str)
-{
+int msConnectLayer(layerObj *layer, const int connectiontype,
+                   const char *library_str) {
   layer->connectiontype = connectiontype;
   /* For internal types, library_str is ignored */
   if (connectiontype == MS_PLUGIN) {
@@ -2115,17 +2268,15 @@ int msConnectLayer(layerObj *layer,
     layer->plugin_library_original = msStrdup(library_str);
 
     rv = msBuildPluginLibraryPath(&layer->plugin_library,
-                                  layer->plugin_library_original,
-                                  layer->map);
+                                  layer->plugin_library_original, layer->map);
     if (rv != MS_SUCCESS) {
       return rv;
     }
   }
-  return msInitializeVirtualTable(layer) ;
+  return msInitializeVirtualTable(layer);
 }
 
-static int populateVirtualTable(layerVTableObj *vtable)
-{
+static int populateVirtualTable(layerVTableObj *vtable) {
   assert(vtable != NULL);
 
   vtable->LayerSupportsCommonFilters = LayerDefaultSupportsCommonFilters;
@@ -2167,94 +2318,92 @@ static int populateVirtualTable(layerVTa
   return MS_SUCCESS;
 }
 
-static int createVirtualTable(layerVTableObj **vtable)
-{
+static int createVirtualTable(layerVTableObj **vtable) {
   *vtable = malloc(sizeof(**vtable));
   MS_CHECK_ALLOC(*vtable, sizeof(**vtable), MS_FAILURE);
 
   return populateVirtualTable(*vtable);
 }
 
-static int destroyVirtualTable(layerVTableObj **vtable)
-{
+static int destroyVirtualTable(layerVTableObj **vtable) {
   memset(*vtable, 0, sizeof(**vtable));
   msFree(*vtable);
   *vtable = NULL;
   return MS_SUCCESS;
 }
 
-int msInitializeVirtualTable(layerObj *layer)
-{
+int msInitializeVirtualTable(layerObj *layer) {
   if (layer->vtable) {
     destroyVirtualTable(&layer->vtable);
   }
   createVirtualTable(&layer->vtable);
 
-  if(layer->features && layer->connectiontype != MS_GRATICULE )
+  if (layer->features && layer->connectiontype != MS_GRATICULE)
     layer->connectiontype = MS_INLINE;
 
-  if(layer->tileindex && layer->connectiontype == MS_SHAPEFILE)
+  if (layer->tileindex && layer->connectiontype == MS_SHAPEFILE)
     layer->connectiontype = MS_TILED_SHAPEFILE;
 
-  if(layer->type == MS_LAYER_RASTER && layer->connectiontype != MS_WMS
-      && layer->connectiontype != MS_KERNELDENSITY)
+  if (layer->type == MS_LAYER_RASTER && layer->connectiontype != MS_WMS &&
+      layer->connectiontype != MS_KERNELDENSITY)
     layer->connectiontype = MS_RASTER;
 
-  switch(layer->connectiontype) {
-    case(MS_INLINE):
-      return(msINLINELayerInitializeVirtualTable(layer));
-      break;
-    case(MS_SHAPEFILE):
-      return(msSHPLayerInitializeVirtualTable(layer));
-      break;
-    case(MS_TILED_SHAPEFILE):
-      return(msTiledSHPLayerInitializeVirtualTable(layer));
-      break;
-    case(MS_OGR):
-      return(msOGRLayerInitializeVirtualTable(layer));
-      break;
-    case(MS_FLATGEOBUF):
-      return(msFlatGeobufLayerInitializeVirtualTable(layer));
-      break;
-    case(MS_POSTGIS):
-      return(msPostGISLayerInitializeVirtualTable(layer));
-      break;
-    case(MS_WMS):
-      /* WMS should be treated as a raster layer */
-      return(msRASTERLayerInitializeVirtualTable(layer));
-      break;
-    case(MS_KERNELDENSITY):
-      /* KERNELDENSITY should be treated as a raster layer */
-      return(msRASTERLayerInitializeVirtualTable(layer));
-      break;
-    case(MS_ORACLESPATIAL):
-      return(msOracleSpatialLayerInitializeVirtualTable(layer));
-      break;
-    case(MS_WFS):
-      return(msWFSLayerInitializeVirtualTable(layer));
-      break;
-    case(MS_GRATICULE):
-      return(msGraticuleLayerInitializeVirtualTable(layer));
-      break;
-    case(MS_RASTER):
-      return(msRASTERLayerInitializeVirtualTable(layer));
-      break;
-    case(MS_PLUGIN):
-      return(msPluginLayerInitializeVirtualTable(layer));
-      break;
-    case(MS_UNION):
-      return(msUnionLayerInitializeVirtualTable(layer));
-      break;
-    case(MS_UVRASTER):
-      return(msUVRASTERLayerInitializeVirtualTable(layer));
-      break;
-    case(MS_CONTOUR):
-      return(msContourLayerInitializeVirtualTable(layer));
-      break;      
-    default:
-      msSetError(MS_MISCERR, "Unknown connectiontype, it was %d", "msInitializeVirtualTable()", layer->connectiontype);
-      return MS_FAILURE;
-      break;
+  switch (layer->connectiontype) {
+  case (MS_INLINE):
+    return (msINLINELayerInitializeVirtualTable(layer));
+    break;
+  case (MS_SHAPEFILE):
+    return (msSHPLayerInitializeVirtualTable(layer));
+    break;
+  case (MS_TILED_SHAPEFILE):
+    return (msTiledSHPLayerInitializeVirtualTable(layer));
+    break;
+  case (MS_OGR):
+    return (msOGRLayerInitializeVirtualTable(layer));
+    break;
+  case (MS_FLATGEOBUF):
+    return (msFlatGeobufLayerInitializeVirtualTable(layer));
+    break;
+  case (MS_POSTGIS):
+    return (msPostGISLayerInitializeVirtualTable(layer));
+    break;
+  case (MS_WMS):
+    /* WMS should be treated as a raster layer */
+    return (msRASTERLayerInitializeVirtualTable(layer));
+    break;
+  case (MS_KERNELDENSITY):
+    /* KERNELDENSITY should be treated as a raster layer */
+    return (msRASTERLayerInitializeVirtualTable(layer));
+    break;
+  case (MS_ORACLESPATIAL):
+    return (msOracleSpatialLayerInitializeVirtualTable(layer));
+    break;
+  case (MS_WFS):
+    return (msWFSLayerInitializeVirtualTable(layer));
+    break;
+  case (MS_GRATICULE):
+    return (msGraticuleLayerInitializeVirtualTable(layer));
+    break;
+  case (MS_RASTER):
+    return (msRASTERLayerInitializeVirtualTable(layer));
+    break;
+  case (MS_PLUGIN):
+    return (msPluginLayerInitializeVirtualTable(layer));
+    break;
+  case (MS_UNION):
+    return (msUnionLayerInitializeVirtualTable(layer));
+    break;
+  case (MS_UVRASTER):
+    return (msUVRASTERLayerInitializeVirtualTable(layer));
+    break;
+  case (MS_CONTOUR):
+    return (msContourLayerInitializeVirtualTable(layer));
+    break;
+  default:
+    msSetError(MS_MISCERR, "Unknown connectiontype, it was %d",
+               "msInitializeVirtualTable()", layer->connectiontype);
+    return MS_FAILURE;
+    break;
   }
 
   /* not reached */
@@ -2268,53 +2417,49 @@ int msInitializeVirtualTable(layerObj *l
 typedef struct {
   rectObj searchrect;
   int is_relative; /* relative coordinates? */
-}
-msINLINELayerInfo;
+} msINLINELayerInfo;
 
-int msINLINELayerIsOpen(layerObj *layer)
-{
+int msINLINELayerIsOpen(layerObj *layer) {
   if (layer->layerinfo)
-    return(MS_TRUE);
+    return (MS_TRUE);
   else
-    return(MS_FALSE);
+    return (MS_FALSE);
 }
 
-msINLINELayerInfo *msINLINECreateLayerInfo(void)
-{
+msINLINELayerInfo *msINLINECreateLayerInfo(void) {
   msINLINELayerInfo *layerinfo = msSmallMalloc(sizeof(msINLINELayerInfo));
   layerinfo->searchrect.minx = -1.0;
   layerinfo->searchrect.miny = -1.0;
   layerinfo->searchrect.maxx = -1.0;
   layerinfo->searchrect.maxy = -1.0;
   layerinfo->is_relative = MS_FALSE;
-  return layerinfo;  
+  return layerinfo;
 }
 
-int msINLINELayerOpen(layerObj *layer)
-{
-  msINLINELayerInfo  *layerinfo;
+int msINLINELayerOpen(layerObj *layer) {
+  msINLINELayerInfo *layerinfo;
 
   if (layer->layerinfo) {
     if (layer->debug) {
       msDebug("msINLINELayerOpen: Layer is already open!\n");
     }
-    return MS_SUCCESS;  /* already open */
+    return MS_SUCCESS; /* already open */
   }
-  
+
   /*
   ** Initialize the layerinfo
   **/
   layerinfo = msINLINECreateLayerInfo();
-  
-  layer->currentfeature = layer->features; /* point to the begining of the feature list */
 
-  layer->layerinfo = (void*)layerinfo;
-  
-  return(MS_SUCCESS);
+  layer->currentfeature =
+      layer->features; /* point to the begining of the feature list */
+
+  layer->layerinfo = (void *)layerinfo;
+
+  return (MS_SUCCESS);
 }
 
-int msINLINELayerClose(layerObj *layer)
-{
+int msINLINELayerClose(layerObj *layer) {
   if (layer->layerinfo) {
     free(layer->layerinfo);
     layer->layerinfo = NULL;
@@ -2323,43 +2468,47 @@ int msINLINELayerClose(layerObj *layer)
   return MS_SUCCESS;
 }
 
-int msINLINELayerWhichShapes(layerObj *layer, rectObj rect, int isQuery)
-{
+int msINLINELayerWhichShapes(layerObj *layer, rectObj rect, int isQuery) {
   (void)isQuery;
-  msINLINELayerInfo *layerinfo = NULL;  
-  layerinfo = (msINLINELayerInfo*) layer->layerinfo;
+  msINLINELayerInfo *layerinfo = NULL;
+  layerinfo = (msINLINELayerInfo *)layer->layerinfo;
 
   layerinfo->searchrect = rect;
-  layerinfo->is_relative = (layer->transform != MS_FALSE && layer->transform != MS_TRUE);
-  
+  layerinfo->is_relative =
+      (layer->transform != MS_FALSE && layer->transform != MS_TRUE);
+
   return MS_SUCCESS;
 }
 
 /* Author: Cristoph Spoerri and Sean Gillies */
-int msINLINELayerGetShape(layerObj *layer, shapeObj *shape, resultObj *record)
-{
-  int i=0;
+int msINLINELayerGetShape(layerObj *layer, shapeObj *shape, resultObj *record) {
+  int i = 0;
   featureListNodeObjPtr current;
 
   int shapeindex = record->shapeindex; /* only index necessary */
 
   current = layer->features;
-  while (current!=NULL && i!=shapeindex) {
+  while (current != NULL && i != shapeindex) {
     i++;
     current = current->next;
   }
   if (current == NULL) {
-    msSetError(MS_SHPERR, "No inline feature with this index.", "msINLINELayerGetShape()");
+    msSetError(MS_SHPERR, "No inline feature with this index.",
+               "msINLINELayerGetShape()");
     return MS_FAILURE;
   }
 
   if (msCopyShape(&(current->shape), shape) != MS_SUCCESS) {
-    msSetError(MS_SHPERR, "Cannot retrieve inline shape. There some problem with the shape", "msINLINELayerGetShape()");
+    msSetError(
+        MS_SHPERR,
+        "Cannot retrieve inline shape. There some problem with the shape",
+        "msINLINELayerGetShape()");
     return MS_FAILURE;
   }
   /* check for the expected size of the values array */
   if (layer->numitems > shape->numvalues) {
-    shape->values = (char **)msSmallRealloc(shape->values, sizeof(char *)*(layer->numitems));
+    shape->values = (char **)msSmallRealloc(shape->values,
+                                            sizeof(char *) * (layer->numitems));
     for (i = shape->numvalues; i < layer->numitems; i++)
       shape->values[i] = msStrdup("");
   }
@@ -2367,32 +2516,33 @@ int msINLINELayerGetShape(layerObj *laye
   return MS_SUCCESS;
 }
 
-int msINLINELayerNextShape(layerObj *layer, shapeObj *shape)
-{
-  msINLINELayerInfo *layerinfo = NULL;  
-  shapeObj * s;
-  
-  layerinfo = (msINLINELayerInfo*) layer->layerinfo;
-  
+int msINLINELayerNextShape(layerObj *layer, shapeObj *shape) {
+  msINLINELayerInfo *layerinfo = NULL;
+  shapeObj *s;
+
+  layerinfo = (msINLINELayerInfo *)layer->layerinfo;
+
   while (1) {
 
-    if( ! (layer->currentfeature)) {
+    if (!(layer->currentfeature)) {
       /* out of features */
-      return(MS_DONE);
+      return (MS_DONE);
     }
 
     s = &(layer->currentfeature->shape);
     layer->currentfeature = layer->currentfeature->next;
     msComputeBounds(s);
 
-    if (layerinfo->is_relative || msRectOverlap(&s->bounds, &layerinfo->searchrect)) {
-   
+    if (layerinfo->is_relative ||
+        msRectOverlap(&s->bounds, &layerinfo->searchrect)) {
+
       msCopyShape(s, shape);
 
       /* check for the expected size of the values array */
       if (layer->numitems > shape->numvalues) {
         int i;
-        shape->values = (char **)msSmallRealloc(shape->values, sizeof(char *)*(layer->numitems));
+        shape->values = (char **)msSmallRealloc(
+            shape->values, sizeof(char *) * (layer->numitems));
         for (i = shape->numvalues; i < layer->numitems; i++)
           shape->values[i] = msStrdup("");
         shape->numvalues = layer->numitems;
@@ -2400,14 +2550,12 @@ int msINLINELayerNextShape(layerObj *lay
 
       break;
     }
-    
   }
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
-int msINLINELayerGetNumFeatures(layerObj *layer)
-{
+int msINLINELayerGetNumFeatures(layerObj *layer) {
   int i = 0;
   featureListNodeObjPtr current;
 
@@ -2419,15 +2567,12 @@ int msINLINELayerGetNumFeatures(layerObj
   return i;
 }
 
-
-
 /*
 Returns an escaped string
 */
-char  *msLayerEscapeSQLParam(layerObj *layer, const char*pszString)
-{
-  if ( ! layer->vtable) {
-    int rv =  msInitializeVirtualTable(layer);
+char *msLayerEscapeSQLParam(layerObj *layer, const char *pszString) {
+  if (!layer->vtable) {
+    int rv = msInitializeVirtualTable(layer);
     if (rv != MS_SUCCESS)
       return "";
   }
@@ -2435,10 +2580,9 @@ char  *msLayerEscapeSQLParam(layerObj *l
   return layer->vtable->LayerEscapeSQLParam(layer, pszString);
 }
 
-char  *msLayerEscapePropertyName(layerObj *layer, const char*pszString)
-{
-  if ( ! layer->vtable) {
-    int rv =  msInitializeVirtualTable(layer);
+char *msLayerEscapePropertyName(layerObj *layer, const char *pszString) {
+  if (!layer->vtable) {
+    int rv = msInitializeVirtualTable(layer);
     if (rv != MS_SUCCESS)
       return "";
   }
@@ -2446,10 +2590,7 @@ char  *msLayerEscapePropertyName(layerOb
   return layer->vtable->LayerEscapePropertyName(layer, pszString);
 }
 
-
-int
-msINLINELayerInitializeVirtualTable(layerObj *layer)
-{
+int msINLINELayerInitializeVirtualTable(layerObj *layer) {
   assert(layer != NULL);
   assert(layer->vtable != NULL);
 
@@ -2487,5 +2628,3 @@ msINLINELayerInitializeVirtualTable(laye
 
   return MS_SUCCESS;
 }
-
-
diff -pruN 8.0.1-5/maplegend.c 8.0.2-1/maplegend.c
--- 8.0.1-5/maplegend.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/maplegend.c	2024-06-11 20:41:34.000000000 +0000
@@ -29,57 +29,51 @@
 
 #include "mapserver.h"
 
-
-
 #define PSF .8
 #define VMARGIN 5 /* margin at top and bottom of legend graphic */
 #define HMARGIN 5 /* margin at left and right of legend graphic */
 
-
-static int msDrawGradientSymbol(rendererVTableObj* renderer,
-                                imageObj* image_draw,
-                                double x_center,
-                                double y_center,
-                                int width,
-                                int height,
-                                styleObj* style)
-{
-    unsigned char *r,*g,*b,*a;
-    symbolObj symbol;
-    rasterBufferObj* rb;
-    symbolStyleObj symbolStyle;
-    int ret;
-
-    initSymbol(&symbol);
-    rb = (rasterBufferObj*)calloc(1,sizeof(rasterBufferObj));
-    symbol.pixmap_buffer = rb;
-    rb->type = MS_BUFFER_BYTE_RGBA;
-    rb->width = width;
-    rb->height = height;
-    rb->data.rgba.row_step = rb->width * 4;
-    rb->data.rgba.pixel_step = 4;
-    rb->data.rgba.pixels = (unsigned char*)malloc(
-                                rb->width*rb->height*4*sizeof(unsigned char));
-    b = rb->data.rgba.b = &rb->data.rgba.pixels[0];
-    g = rb->data.rgba.g = &rb->data.rgba.pixels[1];
-    r = rb->data.rgba.r = &rb->data.rgba.pixels[2];
-    a = rb->data.rgba.a = &rb->data.rgba.pixels[3];
-    for( unsigned j = 0; j < rb->height; j++ )
-    {
-        for( unsigned i = 0; i < rb->width; i++ )
-        {
-            msValueToRange(style, style->minvalue +
-                (double)i / rb->width * (style->maxvalue - style->minvalue), MS_COLORSPACE_RGB);
-            b[4*(j * rb->width + i)] = style->color.blue;
-            g[4*(j * rb->width + i)] = style->color.green;
-            r[4*(j * rb->width + i)] = style->color.red;
-            a[4*(j * rb->width + i)] = style->color.alpha;
-        }
-    }
-    INIT_SYMBOL_STYLE(symbolStyle);
-    ret = renderer->renderPixmapSymbol(image_draw, x_center, y_center, &symbol, &symbolStyle);
-    msFreeSymbol(&symbol);
-    return ret;
+static int msDrawGradientSymbol(rendererVTableObj *renderer,
+                                imageObj *image_draw, double x_center,
+                                double y_center, int width, int height,
+                                styleObj *style) {
+  unsigned char *r, *g, *b, *a;
+  symbolObj symbol;
+  rasterBufferObj *rb;
+  symbolStyleObj symbolStyle;
+  int ret;
+
+  initSymbol(&symbol);
+  rb = (rasterBufferObj *)calloc(1, sizeof(rasterBufferObj));
+  symbol.pixmap_buffer = rb;
+  rb->type = MS_BUFFER_BYTE_RGBA;
+  rb->width = width;
+  rb->height = height;
+  rb->data.rgba.row_step = rb->width * 4;
+  rb->data.rgba.pixel_step = 4;
+  rb->data.rgba.pixels = (unsigned char *)malloc(rb->width * rb->height * 4 *
+                                                 sizeof(unsigned char));
+  b = rb->data.rgba.b = &rb->data.rgba.pixels[0];
+  g = rb->data.rgba.g = &rb->data.rgba.pixels[1];
+  r = rb->data.rgba.r = &rb->data.rgba.pixels[2];
+  a = rb->data.rgba.a = &rb->data.rgba.pixels[3];
+  for (unsigned j = 0; j < rb->height; j++) {
+    for (unsigned i = 0; i < rb->width; i++) {
+      msValueToRange(style,
+                     style->minvalue + (double)i / rb->width *
+                                           (style->maxvalue - style->minvalue),
+                     MS_COLORSPACE_RGB);
+      b[4 * (j * rb->width + i)] = style->color.blue;
+      g[4 * (j * rb->width + i)] = style->color.green;
+      r[4 * (j * rb->width + i)] = style->color.red;
+      a[4 * (j * rb->width + i)] = style->color.alpha;
+    }
+  }
+  INIT_SYMBOL_STYLE(symbolStyle);
+  ret = renderer->renderPixmapSymbol(image_draw, x_center, y_center, &symbol,
+                                     &symbolStyle);
+  msFreeSymbol(&symbol);
+  return ret;
 }
 
 /*
@@ -87,78 +81,84 @@ static int msDrawGradientSymbol(renderer
  * renderer specific drawing functions shouldn't be called directly, but through
  * this function
  */
-int msDrawLegendIcon(mapObj *map, layerObj *lp, classObj *theclass,
-                     int width, int height, imageObj *image, int dstX, int dstY,
-                     int scale_independant, class_hittest *hittest)
-{
-  int i, type, hasmarkersymbol, ret=MS_SUCCESS;
+int msDrawLegendIcon(mapObj *map, layerObj *lp, classObj *theclass, int width,
+                     int height, imageObj *image, int dstX, int dstY,
+                     int scale_independant, class_hittest *hittest) {
+  int i, type, hasmarkersymbol, ret = MS_SUCCESS;
   double offset;
-  double polygon_contraction = 0.5; /* used to account for the width of a polygon's outline */
+  double polygon_contraction =
+      0.5; /* used to account for the width of a polygon's outline */
   shapeObj box, zigzag;
-  lineObj box_line,zigzag_line;
+  lineObj box_line, zigzag_line;
   pointObj box_point[5], zigzag_point[4];
   pointObj marker;
   char szPath[MS_MAXPATHLEN];
   styleObj outline_style;
   imageObj *image_draw = image;
   rendererVTableObj *renderer;
-  outputFormatObj *transFormat = NULL, *altFormat=NULL;
+  outputFormatObj *transFormat = NULL, *altFormat = NULL;
   const char *alternativeFormatString = NULL;
 
-  if(!MS_RENDERER_PLUGIN(image->format)) {
-    msSetError(MS_MISCERR,"unsupported image format","msDrawLegendIcon()");
+  if (!MS_RENDERER_PLUGIN(image->format)) {
+    msSetError(MS_MISCERR, "unsupported image format", "msDrawLegendIcon()");
     return MS_FAILURE;
   }
 
   alternativeFormatString = msLayerGetProcessingKey(lp, "RENDERER");
-  if (MS_RENDERER_PLUGIN(image_draw->format) && alternativeFormatString!=NULL &&
-      (altFormat=  msSelectOutputFormat(map, alternativeFormatString))) {
+  if (MS_RENDERER_PLUGIN(image_draw->format) &&
+      alternativeFormatString != NULL &&
+      (altFormat = msSelectOutputFormat(map, alternativeFormatString))) {
     msInitializeRendererVTable(altFormat);
 
-    image_draw = msImageCreate(image->width, image->height,
-                               altFormat, image->imagepath, image->imageurl, map->resolution, map->defresolution, &map->imagecolor);
+    image_draw = msImageCreate(
+        image->width, image->height, altFormat, image->imagepath,
+        image->imageurl, map->resolution, map->defresolution, &map->imagecolor);
     image_draw->map = map;
     renderer = MS_IMAGE_RENDERER(image_draw);
   } else {
     renderer = MS_IMAGE_RENDERER(image_draw);
     if (lp->compositer && renderer->compositeRasterBuffer) {
-      image_draw = msImageCreate(image->width, image->height,
-              image->format, image->imagepath, image->imageurl, map->resolution, map->defresolution, NULL);
+      image_draw = msImageCreate(image->width, image->height, image->format,
+                                 image->imagepath, image->imageurl,
+                                 map->resolution, map->defresolution, NULL);
       if (!image_draw) {
-        msSetError(MS_MISCERR, "Unable to initialize temporary transparent image.",
-                "msDrawLegendIcon()");
+        msSetError(MS_MISCERR,
+                   "Unable to initialize temporary transparent image.",
+                   "msDrawLegendIcon()");
         return (MS_FAILURE);
       }
       image_draw->map = map;
     }
   }
 
-
-  if(renderer->supports_clipping && MS_VALID_COLOR(map->legend.outlinecolor)) {
+  if (renderer->supports_clipping && MS_VALID_COLOR(map->legend.outlinecolor)) {
     /* keep GD specific code here for now as it supports clipping */
     rectObj clip;
     clip.maxx = dstX + width - 1;
-    clip.maxy = dstY + height -1;
+    clip.maxy = dstY + height - 1;
     clip.minx = dstX;
     clip.miny = dstY;
-    renderer->setClip(image_draw,clip);
+    renderer->setClip(image_draw, clip);
   }
-  
+
   /* if the class has a keyimage, treat it as a point layer
    * (the keyimage will be treated there) */
-  if(theclass->keyimage != NULL) {
+  if (theclass->keyimage != NULL) {
     type = MS_LAYER_POINT;
   } else {
-    /* some polygon layers may be better drawn using zigzag if there is no fill */
+    /* some polygon layers may be better drawn using zigzag if there is no fill
+     */
     type = lp->type;
-    if(type == MS_LAYER_POLYGON) {
+    if (type == MS_LAYER_POLYGON) {
       type = MS_LAYER_LINE;
-      for(i=0; i<theclass->numstyles; i++) {
-        if(MS_VALID_COLOR(theclass->styles[i]->color)) { /* there is a fill */
+      for (i = 0; i < theclass->numstyles; i++) {
+        if (MS_VALID_COLOR(theclass->styles[i]->color)) { /* there is a fill */
           type = MS_LAYER_POLYGON;
         }
-        if(MS_VALID_COLOR(theclass->styles[i]->outlinecolor)) { /* there is an outline */
-          polygon_contraction = MS_MAX(polygon_contraction, theclass->styles[i]->width / 2.0);
+        if (MS_VALID_COLOR(
+                theclass->styles[i]->outlinecolor)) { /* there is an outline */
+          polygon_contraction =
+              MS_MAX(polygon_contraction, theclass->styles[i]->width / 2.0);
         }
       }
     }
@@ -183,180 +183,211 @@ int msDrawLegendIcon(mapObj *map, layerO
   box.line[0].point[4].x = box.line[0].point[0].x;
   box.line[0].point[4].y = box.line[0].point[0].y;
 
-
-
   /*
   ** now draw the appropriate color/symbol/size combination
   */
 
   /* Scalefactor will be infinity when SIZEUNITS is set in LAYER */
-  if(lp->sizeunits != MS_PIXELS) {
-    lp->scalefactor = 1.0; 
+  if (lp->sizeunits != MS_PIXELS) {
+    lp->scalefactor = 1.0;
   }
 
-  switch(type) {
-    case MS_LAYER_POINT:
-      marker.x = dstX + MS_NINT(width / 2.0);
-      marker.y = dstY + MS_NINT(height / 2.0);
-      if(theclass->keyimage != NULL) {
-        int symbolNum;
-        styleObj imgStyle;
-        symbolObj *symbol=NULL;
-        symbolNum = msAddImageSymbol(&(map->symbolset), msBuildPath(szPath, map->mappath, theclass->keyimage));
-        if(symbolNum == -1) {
-          msSetError(MS_IMGERR, "Failed to open legend key image", "msCreateLegendIcon()");
-          return(MS_FAILURE);
-        }
-
-        symbol = map->symbolset.symbol[symbolNum];
-
-        initStyle(&imgStyle);
-        /*set size so that symbol will be scaled properly #3296*/
-        if (width/symbol->sizex < height/symbol->sizey)
-          imgStyle.size = symbol->sizey*(width/symbol->sizex);
-        else
-          imgStyle.size = symbol->sizey*(height/symbol->sizey);
-
-        if (imgStyle.size > imgStyle.maxsize)
-          imgStyle.maxsize = imgStyle.size;
-
-        imgStyle.symbol = symbolNum;
-        ret = msDrawMarkerSymbol(map ,image_draw,&marker,&imgStyle, 1.0);
-        if(MS_UNLIKELY(ret == MS_FAILURE)) goto legend_icon_cleanup;
-        /* TO DO: we may want to handle this differently depending on the relative size of the keyimage */
-      } else {
-        for(i=0; i<theclass->numstyles; i++) {
-          if(!scale_independant && map->scaledenom > 0) {
-            styleObj *lp = theclass->styles[i];
-            if((lp->maxscaledenom > 0) && (map->scaledenom > lp->maxscaledenom)) continue;
-            if((lp->minscaledenom > 0) && (map->scaledenom <= lp->minscaledenom)) continue;
-          }
-          if(hittest && hittest->stylehits[i].status == 0) continue;
-          ret = msDrawMarkerSymbol(map, image_draw, &marker, theclass->styles[i], lp->scalefactor * image->resolutionfactor);
-          if(MS_UNLIKELY(ret == MS_FAILURE)) goto legend_icon_cleanup;
-        }
-      }
-      break;
-    case MS_LAYER_LINE:
-      offset = 1;
-      /* To set the offset, we only check the size/width parameter of the first style */
-      if (theclass->numstyles > 0) {
-        if (theclass->styles[0]->symbol > 0 && theclass->styles[0]->symbol < map->symbolset.numsymbols && 
-              map->symbolset.symbol[theclass->styles[0]->symbol]->type != MS_SYMBOL_SIMPLE)
-            offset = theclass->styles[0]->size/2;
-        else
-            offset = theclass->styles[0]->width/2;
-      }
-      msInitShape(&zigzag);
-      zigzag.line = &zigzag_line;
-      zigzag.numlines = 1;
-      zigzag.line[0].point = zigzag_point;
-      zigzag.line[0].numpoints = 4;
-      zigzag.type = MS_SHAPE_LINE;
-
-      zigzag.line[0].point[0].x = dstX + offset;
-      zigzag.line[0].point[0].y = dstY + height - offset;
-      zigzag.line[0].point[1].x = dstX + MS_NINT(width / 3.0) - 1;
-      zigzag.line[0].point[1].y = dstY + offset;
-      zigzag.line[0].point[2].x = dstX + MS_NINT(2.0 * width / 3.0) - 1;
-      zigzag.line[0].point[2].y = dstY + height - offset;
-      zigzag.line[0].point[3].x = dstX + width - offset;
-      zigzag.line[0].point[3].y = dstY + offset;
+  switch (type) {
+  case MS_LAYER_POINT:
+    marker.x = dstX + MS_NINT(width / 2.0);
+    marker.y = dstY + MS_NINT(height / 2.0);
+    if (theclass->keyimage != NULL) {
+      int symbolNum;
+      styleObj imgStyle;
+      symbolObj *symbol = NULL;
+      symbolNum =
+          msAddImageSymbol(&(map->symbolset), msBuildPath(szPath, map->mappath,
+                                                          theclass->keyimage));
+      if (symbolNum == -1) {
+        msSetError(MS_IMGERR, "Failed to open legend key image",
+                   "msCreateLegendIcon()");
+        return (MS_FAILURE);
+      }
+
+      symbol = map->symbolset.symbol[symbolNum];
 
-      for(i=0; i<theclass->numstyles; i++) {
-        if(!scale_independant && map->scaledenom > 0) {
+      initStyle(&imgStyle);
+      /*set size so that symbol will be scaled properly #3296*/
+      if (width / symbol->sizex < height / symbol->sizey)
+        imgStyle.size = symbol->sizey * (width / symbol->sizex);
+      else
+        imgStyle.size = symbol->sizey * (height / symbol->sizey);
+
+      if (imgStyle.size > imgStyle.maxsize)
+        imgStyle.maxsize = imgStyle.size;
+
+      imgStyle.symbol = symbolNum;
+      ret = msDrawMarkerSymbol(map, image_draw, &marker, &imgStyle, 1.0);
+      if (MS_UNLIKELY(ret == MS_FAILURE))
+        goto legend_icon_cleanup;
+      /* TO DO: we may want to handle this differently depending on the relative
+       * size of the keyimage */
+    } else {
+      for (i = 0; i < theclass->numstyles; i++) {
+        if (!scale_independant && map->scaledenom > 0) {
           styleObj *lp = theclass->styles[i];
-          if((lp->maxscaledenom > 0) && (map->scaledenom > lp->maxscaledenom)) continue;
-          if((lp->minscaledenom > 0) && (map->scaledenom <= lp->minscaledenom)) continue;
-        }
-        if(hittest && hittest->stylehits[i].status == 0) continue;
-        if (theclass->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_NONE ||
-            theclass->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOINT ||
-            theclass->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOLY) {
-	  if (theclass->styles[i]->outlinewidth > 0) {
-	    /* Swap the style contents to render the outline first,
-	     * and then restore the style to render the interior of the line
-	     */
-	    msOutlineRenderingPrepareStyle(theclass->styles[i], map, lp, image);
-	    ret = msDrawLineSymbol(map, image_draw, &zigzag, theclass->styles[i], lp->scalefactor * image_draw->resolutionfactor);
-	    msOutlineRenderingRestoreStyle(theclass->styles[i], map, lp, image);
-            if(MS_UNLIKELY(ret == MS_FAILURE)) goto legend_icon_cleanup;
-	  }
-          ret = msDrawLineSymbol(map, image_draw, &zigzag, theclass->styles[i], lp->scalefactor * image_draw->resolutionfactor);
-          if(MS_UNLIKELY(ret == MS_FAILURE)) goto legend_icon_cleanup;
-        }
-        else {
-	  if (theclass->styles[i]->outlinewidth > 0) {
-	    /* Swap the style contents to render the outline first,
-	     * and then restore the style to render the interior of the line
-	     */
-	    msOutlineRenderingPrepareStyle(theclass->styles[i], map, lp, image);
-	    ret = msDrawTransformedShape(map, image_draw, &zigzag, theclass->styles[i], lp->scalefactor * image_draw->resolutionfactor);
-	    msOutlineRenderingRestoreStyle(theclass->styles[i], map, lp, image);
-            if(MS_UNLIKELY(ret == MS_FAILURE)) goto legend_icon_cleanup;
-	  }
-          ret = msDrawTransformedShape(map, image_draw, &zigzag, theclass->styles[i], lp->scalefactor * image_draw->resolutionfactor);
-          if(MS_UNLIKELY(ret == MS_FAILURE)) goto legend_icon_cleanup;
+          if ((lp->maxscaledenom > 0) && (map->scaledenom > lp->maxscaledenom))
+            continue;
+          if ((lp->minscaledenom > 0) && (map->scaledenom <= lp->minscaledenom))
+            continue;
         }
+        if (hittest && hittest->stylehits[i].status == 0)
+          continue;
+        ret = msDrawMarkerSymbol(map, image_draw, &marker, theclass->styles[i],
+                                 lp->scalefactor * image->resolutionfactor);
+        if (MS_UNLIKELY(ret == MS_FAILURE))
+          goto legend_icon_cleanup;
       }
-
-      break;
-    case MS_LAYER_CIRCLE:
-    case MS_LAYER_RASTER:
-    case MS_LAYER_CHART:
-    case MS_LAYER_POLYGON:
-      for(i=0; i<theclass->numstyles; i++) {
-        if(!scale_independant && map->scaledenom > 0) {
-          styleObj *lp = theclass->styles[i];
-          if((lp->maxscaledenom > 0) && (map->scaledenom > lp->maxscaledenom)) continue;
-          if((lp->minscaledenom > 0) && (map->scaledenom <= lp->minscaledenom)) continue;
+    }
+    break;
+  case MS_LAYER_LINE:
+    offset = 1;
+    /* To set the offset, we only check the size/width parameter of the first
+     * style */
+    if (theclass->numstyles > 0) {
+      if (theclass->styles[0]->symbol > 0 &&
+          theclass->styles[0]->symbol < map->symbolset.numsymbols &&
+          map->symbolset.symbol[theclass->styles[0]->symbol]->type !=
+              MS_SYMBOL_SIMPLE)
+        offset = theclass->styles[0]->size / 2;
+      else
+        offset = theclass->styles[0]->width / 2;
+    }
+    msInitShape(&zigzag);
+    zigzag.line = &zigzag_line;
+    zigzag.numlines = 1;
+    zigzag.line[0].point = zigzag_point;
+    zigzag.line[0].numpoints = 4;
+    zigzag.type = MS_SHAPE_LINE;
+
+    zigzag.line[0].point[0].x = dstX + offset;
+    zigzag.line[0].point[0].y = dstY + height - offset;
+    zigzag.line[0].point[1].x = dstX + MS_NINT(width / 3.0) - 1;
+    zigzag.line[0].point[1].y = dstY + offset;
+    zigzag.line[0].point[2].x = dstX + MS_NINT(2.0 * width / 3.0) - 1;
+    zigzag.line[0].point[2].y = dstY + height - offset;
+    zigzag.line[0].point[3].x = dstX + width - offset;
+    zigzag.line[0].point[3].y = dstY + offset;
+
+    for (i = 0; i < theclass->numstyles; i++) {
+      if (!scale_independant && map->scaledenom > 0) {
+        styleObj *lp = theclass->styles[i];
+        if ((lp->maxscaledenom > 0) && (map->scaledenom > lp->maxscaledenom))
+          continue;
+        if ((lp->minscaledenom > 0) && (map->scaledenom <= lp->minscaledenom))
+          continue;
+      }
+      if (hittest && hittest->stylehits[i].status == 0)
+        continue;
+      if (theclass->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_NONE ||
+          theclass->styles[i]->_geomtransform.type ==
+              MS_GEOMTRANSFORM_LABELPOINT ||
+          theclass->styles[i]->_geomtransform.type ==
+              MS_GEOMTRANSFORM_LABELPOLY) {
+        if (theclass->styles[i]->outlinewidth > 0) {
+          /* Swap the style contents to render the outline first,
+           * and then restore the style to render the interior of the line
+           */
+          msOutlineRenderingPrepareStyle(theclass->styles[i], map, lp, image);
+          ret =
+              msDrawLineSymbol(map, image_draw, &zigzag, theclass->styles[i],
+                               lp->scalefactor * image_draw->resolutionfactor);
+          msOutlineRenderingRestoreStyle(theclass->styles[i], map, lp, image);
+          if (MS_UNLIKELY(ret == MS_FAILURE))
+            goto legend_icon_cleanup;
         }
-        if(hittest && hittest->stylehits[i].status == 0) continue;
-        if (theclass->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_NONE ||
-            theclass->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOINT ||
-            theclass->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOLY) {
-
-            if (MS_VALID_COLOR(theclass->styles[i]->mincolor))
-            {
-                ret = msDrawGradientSymbol(renderer,
-                                           image_draw,
-                                           dstX + width / 2.,
-                                           dstY + height / 2.0,
-                                           width - 2 * polygon_contraction,
-                                           height - 2 * polygon_contraction,
-                                           theclass->styles[i]);
-            }
-            else
-            {
-                ret = msDrawShadeSymbol(map, image_draw, &box, theclass->styles[i], lp->scalefactor * image_draw->resolutionfactor);
-            }
-            if(MS_UNLIKELY(ret == MS_FAILURE)) goto legend_icon_cleanup;
+        ret = msDrawLineSymbol(map, image_draw, &zigzag, theclass->styles[i],
+                               lp->scalefactor * image_draw->resolutionfactor);
+        if (MS_UNLIKELY(ret == MS_FAILURE))
+          goto legend_icon_cleanup;
+      } else {
+        if (theclass->styles[i]->outlinewidth > 0) {
+          /* Swap the style contents to render the outline first,
+           * and then restore the style to render the interior of the line
+           */
+          msOutlineRenderingPrepareStyle(theclass->styles[i], map, lp, image);
+          ret = msDrawTransformedShape(
+              map, image_draw, &zigzag, theclass->styles[i],
+              lp->scalefactor * image_draw->resolutionfactor);
+          msOutlineRenderingRestoreStyle(theclass->styles[i], map, lp, image);
+          if (MS_UNLIKELY(ret == MS_FAILURE))
+            goto legend_icon_cleanup;
         }
-        else {
-          ret = msDrawTransformedShape(map, image_draw, &box,
-                                 theclass->styles[i], lp->scalefactor);
-          if(MS_UNLIKELY(ret == MS_FAILURE)) goto legend_icon_cleanup;
+        ret = msDrawTransformedShape(
+            map, image_draw, &zigzag, theclass->styles[i],
+            lp->scalefactor * image_draw->resolutionfactor);
+        if (MS_UNLIKELY(ret == MS_FAILURE))
+          goto legend_icon_cleanup;
+      }
+    }
+
+    break;
+  case MS_LAYER_CIRCLE:
+  case MS_LAYER_RASTER:
+  case MS_LAYER_CHART:
+  case MS_LAYER_POLYGON:
+    for (i = 0; i < theclass->numstyles; i++) {
+      if (!scale_independant && map->scaledenom > 0) {
+        styleObj *lp = theclass->styles[i];
+        if ((lp->maxscaledenom > 0) && (map->scaledenom > lp->maxscaledenom))
+          continue;
+        if ((lp->minscaledenom > 0) && (map->scaledenom <= lp->minscaledenom))
+          continue;
+      }
+      if (hittest && hittest->stylehits[i].status == 0)
+        continue;
+      if (theclass->styles[i]->_geomtransform.type == MS_GEOMTRANSFORM_NONE ||
+          theclass->styles[i]->_geomtransform.type ==
+              MS_GEOMTRANSFORM_LABELPOINT ||
+          theclass->styles[i]->_geomtransform.type ==
+              MS_GEOMTRANSFORM_LABELPOLY) {
+
+        if (MS_VALID_COLOR(theclass->styles[i]->mincolor)) {
+          ret = msDrawGradientSymbol(
+              renderer, image_draw, dstX + width / 2., dstY + height / 2.0,
+              width - 2 * polygon_contraction, height - 2 * polygon_contraction,
+              theclass->styles[i]);
+        } else {
+          ret =
+              msDrawShadeSymbol(map, image_draw, &box, theclass->styles[i],
+                                lp->scalefactor * image_draw->resolutionfactor);
         }
+        if (MS_UNLIKELY(ret == MS_FAILURE))
+          goto legend_icon_cleanup;
+      } else {
+        ret = msDrawTransformedShape(map, image_draw, &box, theclass->styles[i],
+                                     lp->scalefactor);
+        if (MS_UNLIKELY(ret == MS_FAILURE))
+          goto legend_icon_cleanup;
       }
-      break;
-    default:
-      return MS_FAILURE;
-      break;
+    }
+    break;
+  default:
+    return MS_FAILURE;
+    break;
   } /* end symbol drawing */
 
   /* handle label styles */
-  for(i=0; i<theclass->numlabels; i++) {
+  for (i = 0; i < theclass->numlabels; i++) {
     labelObj *l = theclass->labels[i];
-    if(!scale_independant && map->scaledenom > 0) {
-      if(msScaleInBounds(map->scaledenom, l->minscaledenom, l->maxscaledenom)) {
+    if (!scale_independant && map->scaledenom > 0) {
+      if (msScaleInBounds(map->scaledenom, l->minscaledenom,
+                          l->maxscaledenom)) {
         int j;
-        for(j=0; j<l->numstyles; j++) {
+        for (j = 0; j < l->numstyles; j++) {
           styleObj *s = l->styles[j];
           marker.x = dstX + MS_NINT(width / 2.0);
           marker.y = dstY + MS_NINT(height / 2.0);
-          if(s->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOINT) {
-            ret = msDrawMarkerSymbol(map, image_draw, &marker, s, lp->scalefactor);
-            if(MS_UNLIKELY(ret == MS_FAILURE)) goto legend_icon_cleanup;
+          if (s->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOINT) {
+            ret = msDrawMarkerSymbol(map, image_draw, &marker, s,
+                                     lp->scalefactor);
+            if (MS_UNLIKELY(ret == MS_FAILURE))
+              goto legend_icon_cleanup;
           }
         }
       }
@@ -365,15 +396,16 @@ int msDrawLegendIcon(mapObj *map, layerO
 
   /* handle "pure" text layers, i.e. layers with no symbology */
   hasmarkersymbol = 0;
-  if(theclass->numstyles == 0) {
-    for(i=0; i<theclass->numlabels; i++) {
+  if (theclass->numstyles == 0) {
+    for (i = 0; i < theclass->numlabels; i++) {
       labelObj *l = theclass->labels[i];
-      if(!scale_independant && map->scaledenom > 0) {
-        if(msScaleInBounds(map->scaledenom, l->minscaledenom, l->maxscaledenom)) {
+      if (!scale_independant && map->scaledenom > 0) {
+        if (msScaleInBounds(map->scaledenom, l->minscaledenom,
+                            l->maxscaledenom)) {
           int j;
-          for(j=0; j<l->numstyles; j++) {
+          for (j = 0; j < l->numstyles; j++) {
             styleObj *s = l->styles[j];
-            if(s->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOINT) {
+            if (s->_geomtransform.type == MS_GEOMTRANSFORM_LABELPOINT) {
               hasmarkersymbol = 1;
             }
           }
@@ -384,33 +416,38 @@ int msDrawLegendIcon(mapObj *map, layerO
     hasmarkersymbol = 1;
   }
 
-  if(!hasmarkersymbol && theclass->numlabels>0) {
+  if (!hasmarkersymbol && theclass->numlabels > 0) {
     textSymbolObj ts;
     pointObj textstartpt;
     marker.x = dstX + MS_NINT(width / 2.0);
     marker.y = dstY + MS_NINT(height / 2.0);
     initTextSymbol(&ts);
-    msPopulateTextSymbolForLabelAndString(&ts,theclass->labels[0],msStrdup("Az"),lp->scalefactor*image_draw->resolutionfactor,image_draw->resolutionfactor, duplicate_always);
+    msPopulateTextSymbolForLabelAndString(
+        &ts, theclass->labels[0], msStrdup("Az"),
+        lp->scalefactor * image_draw->resolutionfactor,
+        image_draw->resolutionfactor, duplicate_always);
     ts.label->size = height - 1;
     ts.rotation = 0;
-    ret = msComputeTextPath(map,&ts);
-    if(MS_UNLIKELY(ret == MS_FAILURE)) goto legend_icon_cleanup;
-    textstartpt = get_metrics(&marker,MS_CC,ts.textpath,0,0,0,0,NULL);
-    ret = msDrawTextSymbol(map,image_draw, textstartpt, &ts);
+    ret = msComputeTextPath(map, &ts);
+    if (MS_UNLIKELY(ret == MS_FAILURE))
+      goto legend_icon_cleanup;
+    textstartpt = get_metrics(&marker, MS_CC, ts.textpath, 0, 0, 0, 0, NULL);
+    ret = msDrawTextSymbol(map, image_draw, textstartpt, &ts);
     freeTextSymbol(&ts);
-    if(MS_UNLIKELY(ret == MS_FAILURE)) goto legend_icon_cleanup;
-
+    if (MS_UNLIKELY(ret == MS_FAILURE))
+      goto legend_icon_cleanup;
   }
 
-
   /* handle an outline if necessary */
-  if(MS_VALID_COLOR(map->legend.outlinecolor)) {
+  if (MS_VALID_COLOR(map->legend.outlinecolor)) {
     initStyle(&outline_style);
     outline_style.color = map->legend.outlinecolor;
-    ret = msDrawLineSymbol(map, image_draw, &box, &outline_style, image_draw->resolutionfactor);
-    if(MS_UNLIKELY(ret == MS_FAILURE)) goto legend_icon_cleanup;
+    ret = msDrawLineSymbol(map, image_draw, &box, &outline_style,
+                           image_draw->resolutionfactor);
+    if (MS_UNLIKELY(ret == MS_FAILURE))
+      goto legend_icon_cleanup;
     /* reset clipping rectangle */
-    if(renderer->supports_clipping)
+    if (renderer->supports_clipping)
       renderer->resetClip(image_draw);
   }
 
@@ -418,74 +455,84 @@ int msDrawLegendIcon(mapObj *map, layerO
     rendererVTableObj *renderer = MS_IMAGE_RENDERER(image);
     rendererVTableObj *altrenderer = MS_IMAGE_RENDERER(image_draw);
     rasterBufferObj rb;
-    memset(&rb,0,sizeof(rasterBufferObj));
+    memset(&rb, 0, sizeof(rasterBufferObj));
 
-    ret = altrenderer->getRasterBufferHandle(image_draw,&rb);
-    if(MS_UNLIKELY(ret == MS_FAILURE)) goto legend_icon_cleanup;
-    ret = renderer->mergeRasterBuffer(image,&rb,((lp->compositer)?lp->compositer->opacity*0.01:1.0),0,0,0,0,rb.width,rb.height);
-    if(MS_UNLIKELY(ret == MS_FAILURE)) goto legend_icon_cleanup;
+    ret = altrenderer->getRasterBufferHandle(image_draw, &rb);
+    if (MS_UNLIKELY(ret == MS_FAILURE))
+      goto legend_icon_cleanup;
+    ret = renderer->mergeRasterBuffer(
+        image, &rb, ((lp->compositer) ? lp->compositer->opacity * 0.01 : 1.0),
+        0, 0, 0, 0, rb.width, rb.height);
+    if (MS_UNLIKELY(ret == MS_FAILURE))
+      goto legend_icon_cleanup;
     /*
-     * hack to work around bug #3834: if we have use an alternate renderer, the symbolset may contain
-     * symbols that reference it. We want to remove those references before the altFormat is destroyed
-     * to avoid a segfault and/or a leak, and so the the main renderer doesn't pick the cache up thinking
+     * hack to work around bug #3834: if we have use an alternate renderer, the
+     * symbolset may contain symbols that reference it. We want to remove those
+     * references before the altFormat is destroyed to avoid a segfault and/or a
+     * leak, and so the the main renderer doesn't pick the cache up thinking
      * it's for him.
      */
-    for(i=0; i<map->symbolset.numsymbols; i++) {
-      if (map->symbolset.symbol[i]!=NULL) {
+    for (i = 0; i < map->symbolset.numsymbols; i++) {
+      if (map->symbolset.symbol[i] != NULL) {
         symbolObj *s = map->symbolset.symbol[i];
-        if(s->renderer == altrenderer) {
+        if (s->renderer == altrenderer) {
           altrenderer->freeSymbol(s);
           s->renderer = NULL;
         }
       }
     }
 
-  } else if(image != image_draw) {
+  } else if (image != image_draw) {
     rendererVTableObj *renderer = MS_IMAGE_RENDERER(image_draw);
     rasterBufferObj rb;
-    memset(&rb,0,sizeof(rasterBufferObj));
+    memset(&rb, 0, sizeof(rasterBufferObj));
 
-    ret = renderer->getRasterBufferHandle(image_draw,&rb);
-    if(MS_UNLIKELY(ret == MS_FAILURE)) goto legend_icon_cleanup;
-    ret = renderer->mergeRasterBuffer(image,&rb,((lp->compositer)?lp->compositer->opacity*0.01:1.0),0,0,0,0,rb.width,rb.height);
-    if(MS_UNLIKELY(ret == MS_FAILURE)) goto legend_icon_cleanup;
+    ret = renderer->getRasterBufferHandle(image_draw, &rb);
+    if (MS_UNLIKELY(ret == MS_FAILURE))
+      goto legend_icon_cleanup;
+    ret = renderer->mergeRasterBuffer(
+        image, &rb, ((lp->compositer) ? lp->compositer->opacity * 0.01 : 1.0),
+        0, 0, 0, 0, rb.width, rb.height);
+    if (MS_UNLIKELY(ret == MS_FAILURE))
+      goto legend_icon_cleanup;
 
     /* deref and possibly free temporary transparent output format.  */
-    msApplyOutputFormat( &transFormat, NULL, MS_NOOVERRIDE);
-
+    msApplyOutputFormat(&transFormat, NULL, MS_NOOVERRIDE);
   }
 
 legend_icon_cleanup:
-  if(image != image_draw) {
+  if (image != image_draw) {
     msFreeImage(image_draw);
   }
   return ret;
 }
 
-imageObj *msCreateLegendIcon(mapObj* map, layerObj* lp, classObj* class, int width, int height, int scale_independant)
-{
+imageObj *msCreateLegendIcon(mapObj *map, layerObj *lp, classObj *class,
+                             int width, int height, int scale_independant) {
   imageObj *image;
   outputFormatObj *format = NULL;
 
   rendererVTableObj *renderer = MS_MAP_RENDERER(map);
 
-  if( !renderer ) {
+  if (!renderer) {
     msSetError(MS_MISCERR, "invalid map outputformat", "msCreateLegendIcon()");
-    return(NULL);
+    return (NULL);
   }
 
   /* ensure we have an image format representing the options for the legend */
   msApplyOutputFormat(&format, map->outputformat, map->legend.transparent);
 
-  image = msImageCreate(width,height,format,map->web.imagepath, map->web.imageurl,
-                        map->resolution, map->defresolution, &(map->legend.imagecolor));
+  image = msImageCreate(width, height, format, map->web.imagepath,
+                        map->web.imageurl, map->resolution, map->defresolution,
+                        &(map->legend.imagecolor));
 
   /* drop this reference to output format */
-  msApplyOutputFormat( &format, NULL, MS_NOOVERRIDE);
+  msApplyOutputFormat(&format, NULL, MS_NOOVERRIDE);
 
-  if(image == NULL) {
-    msSetError(MS_IMGERR, "Unable to initialize image.","msCreateLegendIcon()");
-    return(NULL);
+  if (image == NULL) {
+    msSetError(MS_IMGERR, "Unable to initialize image.",
+               "msCreateLegendIcon()");
+    return (NULL);
   }
   image->map = map;
 
@@ -495,13 +542,18 @@ imageObj *msCreateLegendIcon(mapObj* map
   /* Fev 2004 by AY) */
   if (lp) {
     if (class) {
-      if(MS_UNLIKELY(MS_FAILURE == msDrawLegendIcon(map, lp, class, width, height, image, 0, 0, scale_independant, NULL))) {
+      if (MS_UNLIKELY(MS_FAILURE ==
+                      msDrawLegendIcon(map, lp, class, width, height, image, 0,
+                                       0, scale_independant, NULL))) {
         msFreeImage(image);
         return NULL;
       }
     } else {
-      for (int i=0; i<lp->numclasses; i++) {
-        if(MS_UNLIKELY(MS_FAILURE == msDrawLegendIcon(map, lp, lp->class[i], width, height, image, 0, 0, scale_independant, NULL))) {
+      for (int i = 0; i < lp->numclasses; i++) {
+        if (MS_UNLIKELY(MS_FAILURE == msDrawLegendIcon(map, lp, lp->class[i],
+                                                       width, height, image, 0,
+                                                       0, scale_independant,
+                                                       NULL))) {
           msFreeImage(image);
           return NULL;
         }
@@ -521,38 +573,39 @@ imageObj *msCreateLegendIcon(mapObj* map
  *   MS_SUCCESS
  *   MS_FAILURE
  */
-int msLegendCalcSize(mapObj *map, int scale_independent, int *size_x, int *size_y,
-                     int *layer_index, int num_layers, map_hittest *hittest,
-                     double resolutionfactor)
-{
+int msLegendCalcSize(mapObj *map, int scale_independent, int *size_x,
+                     int *size_y, int *layer_index, int num_layers,
+                     map_hittest *hittest, double resolutionfactor) {
   int i, j;
-  int status, maxwidth=0, nLegendItems=0;
+  int status, maxwidth = 0, nLegendItems = 0;
   char *text;
   layerObj *lp;
   rectObj rect;
-  int current_layers=0;
+  int current_layers = 0;
 
   /* reset sizes */
   *size_x = 0;
   *size_y = 0;
 
   /* enable scale-dependent calculations */
-  if(!scale_independent) {
+  if (!scale_independent) {
     map->cellsize = msAdjustExtent(&(map->extent), map->width, map->height);
-    status = msCalculateScale(map->extent, map->units, map->width, map->height, map->resolution, &map->scaledenom);
-    if(status != MS_SUCCESS) return MS_FAILURE;
+    status = msCalculateScale(map->extent, map->units, map->width, map->height,
+                              map->resolution, &map->scaledenom);
+    if (status != MS_SUCCESS)
+      return MS_FAILURE;
   }
 
   /*
    * step through all map classes, and for each one that will be displayed
    * calculate the label size
    */
-  if (layer_index != NULL && num_layers >0)
-    current_layers  = num_layers;
+  if (layer_index != NULL && num_layers > 0)
+    current_layers = num_layers;
   else
     current_layers = map->numlayers;
 
-  for(i=0; i< current_layers; i++) {
+  for (i = 0; i < current_layers; i++) {
     int layerindex;
     if (layer_index != NULL && num_layers > 0)
       layerindex = layer_index[i];
@@ -561,36 +614,53 @@ int msLegendCalcSize(mapObj *map, int sc
 
     lp = (GET_LAYER(map, layerindex));
 
-    if((lp->status == MS_OFF && (layer_index == NULL || num_layers <= 0)) || (lp->type == MS_LAYER_QUERY)) /* skip it */
+    if ((lp->status == MS_OFF && (layer_index == NULL || num_layers <= 0)) ||
+        (lp->type == MS_LAYER_QUERY)) /* skip it */
       continue;
 
-    if(hittest && hittest->layerhits[layerindex].status == 0) continue;
+    if (hittest && hittest->layerhits[layerindex].status == 0)
+      continue;
 
-    if(!scale_independent && map->scaledenom > 0) {
-      if((lp->maxscaledenom > 0) && (map->scaledenom > lp->maxscaledenom)) continue;
-      if((lp->minscaledenom > 0) && (map->scaledenom <= lp->minscaledenom)) continue;
+    if (!scale_independent && map->scaledenom > 0) {
+      if ((lp->maxscaledenom > 0) && (map->scaledenom > lp->maxscaledenom))
+        continue;
+      if ((lp->minscaledenom > 0) && (map->scaledenom <= lp->minscaledenom))
+        continue;
     }
 
-    for(j=lp->numclasses-1; j>=0; j--) {
+    for (j = lp->numclasses - 1; j >= 0; j--) {
       textSymbolObj ts;
-      text = lp->class[j]->title?lp->class[j]->title:lp->class[j]->name; /* point to the right legend text, title takes precedence */
-      if(!text) continue; /* skip it */
+      text = lp->class[j]->title
+                 ? lp->class[j]->title
+                 : lp->class[j]->name; /* point to the right legend text, title
+                                          takes precedence */
+      if (!text)
+        continue; /* skip it */
 
       /* skip the class if the classgroup is defined */
-      if(lp->classgroup && (lp->class[j]->group == NULL || strcasecmp(lp->class[j]->group, lp->classgroup) != 0))
+      if (lp->classgroup &&
+          (lp->class[j] -> group == NULL || strcasecmp(lp->class[j] -> group,
+                                                       lp -> classgroup) != 0))
         continue;
 
       /* verify class scale */
-      if(!scale_independent && map->scaledenom > 0) {
-        if((lp->class[j]->maxscaledenom > 0) && (map->scaledenom > lp->class[j]->maxscaledenom)) continue;
-        if((lp->class[j]->minscaledenom > 0) && (map->scaledenom <= lp->class[j]->minscaledenom)) continue;
+      if (!scale_independent && map->scaledenom > 0) {
+        if ((lp->class[j] -> maxscaledenom > 0) &&
+            (map->scaledenom > lp->class[j] -> maxscaledenom))
+          continue;
+        if ((lp->class[j] -> minscaledenom > 0) &&
+            (map->scaledenom <= lp->class[j] -> minscaledenom))
+          continue;
       }
-      if(hittest && hittest->layerhits[layerindex].classhits[j].status == 0) continue;
+      if (hittest && hittest->layerhits[layerindex].classhits[j].status == 0)
+        continue;
 
-      if(*text) {
+      if (*text) {
         initTextSymbol(&ts);
-        msPopulateTextSymbolForLabelAndString(&ts,&map->legend.label,msStrdup(text),resolutionfactor,resolutionfactor, 0);
-        if(MS_UNLIKELY(MS_FAILURE == msGetTextSymbolSize(map,&ts,&rect))) {
+        msPopulateTextSymbolForLabelAndString(&ts, &map->legend.label,
+                                              msStrdup(text), resolutionfactor,
+                                              resolutionfactor, 0);
+        if (MS_UNLIKELY(MS_FAILURE == msGetTextSymbolSize(map, &ts, &rect))) {
           freeTextSymbol(&ts);
           return MS_FAILURE;
         }
@@ -607,11 +677,12 @@ int msLegendCalcSize(mapObj *map, int sc
 
   /* Calculate the size of the legend: */
   /*   - account for the Y keyspacing */
-  *size_y += (2*VMARGIN) + ((nLegendItems-1) * map->legend.keyspacingy);
+  *size_y += (2 * VMARGIN) + ((nLegendItems - 1) * map->legend.keyspacingy);
   /*   - determine the legend width */
-  *size_x = (2*HMARGIN) + maxwidth + map->legend.keyspacingx + map->legend.keysizex;
+  *size_x =
+      (2 * HMARGIN) + maxwidth + map->legend.keyspacingx + map->legend.keysizex;
 
-  if(*size_y <=0 ||  *size_x <=0)
+  if (*size_y <= 0 || *size_x <= 0)
     return MS_FAILURE;
 
   return MS_SUCCESS;
@@ -627,11 +698,11 @@ int msLegendCalcSize(mapObj *map, int sc
 ** and maxscale are ignored and layers that are currently out of scale still
 ** show up in the legend.
 */
-imageObj *msDrawLegend(mapObj *map, int scale_independent, map_hittest *hittest)
-{
-  int i,j,ret=MS_SUCCESS; /* loop counters */
+imageObj *msDrawLegend(mapObj *map, int scale_independent,
+                       map_hittest *hittest) {
+  int i, j, ret = MS_SUCCESS; /* loop counters */
   pointObj pnt;
-  int size_x, size_y=0;
+  int size_x, size_y = 0;
   layerObj *lp;
   rectObj rect;
   imageObj *image = NULL;
@@ -642,78 +713,110 @@ imageObj *msDrawLegend(mapObj *map, int
     int height;
     textSymbolObj ts;
     int layerindex, classindex;
-    struct legend_struct* pred;
+    struct legend_struct *pred;
   };
   typedef struct legend_struct legendlabel;
-  legendlabel *head=NULL,*cur=NULL;
+  legendlabel *head = NULL, *cur = NULL;
 
-  if(!MS_RENDERER_PLUGIN(map->outputformat)) {
-    msSetError(MS_MISCERR,"unsupported output format","msDrawLegend()");
+  if (!MS_RENDERER_PLUGIN(map->outputformat)) {
+    msSetError(MS_MISCERR, "unsupported output format", "msDrawLegend()");
     return NULL;
   }
-  if(msValidateContexts(map) != MS_SUCCESS) return NULL; /* make sure there are no recursive REQUIRES or LABELREQUIRES expressions */
-  if(msLegendCalcSize(map, scale_independent, &size_x, &size_y, NULL, 0, hittest, map->resolution/map->defresolution) != MS_SUCCESS) return NULL;
+  if (msValidateContexts(map) != MS_SUCCESS)
+    return NULL; /* make sure there are no recursive REQUIRES or LABELREQUIRES
+                    expressions */
+  if (msLegendCalcSize(map, scale_independent, &size_x, &size_y, NULL, 0,
+                       hittest,
+                       map->resolution / map->defresolution) != MS_SUCCESS)
+    return NULL;
 
   /*
    * step through all map classes, and for each one that will be displayed
    * keep a reference to its label size and text
    */
-  
-  for(i=0; i<map->numlayers; i++) {
+
+  for (i = 0; i < map->numlayers; i++) {
     lp = (GET_LAYER(map, map->layerorder[i]));
 
-    if((lp->status == MS_OFF) || (lp->type == MS_LAYER_QUERY)) /* skip it */
+    if ((lp->status == MS_OFF) || (lp->type == MS_LAYER_QUERY)) /* skip it */
       continue;
 
-    if(hittest && hittest->layerhits[map->layerorder[i]].status == 0)
+    if (hittest && hittest->layerhits[map->layerorder[i]].status == 0)
       continue;
 
-    if(!scale_independent && map->scaledenom > 0) {
-      if((lp->maxscaledenom > 0) && (map->scaledenom > lp->maxscaledenom)) continue;
-      if((lp->minscaledenom > 0) && (map->scaledenom <= lp->minscaledenom)) continue;
+    if (!scale_independent && map->scaledenom > 0) {
+      if ((lp->maxscaledenom > 0) && (map->scaledenom > lp->maxscaledenom))
+        continue;
+      if ((lp->minscaledenom > 0) && (map->scaledenom <= lp->minscaledenom))
+        continue;
     }
 
-    if(!scale_independent && lp->maxscaledenom <=0 && lp->minscaledenom <=0) {
-      if((lp->maxgeowidth > 0) && ((map->extent.maxx - map->extent.minx) > lp->maxgeowidth)) continue;
-      if((lp->mingeowidth > 0) && ((map->extent.maxx - map->extent.minx) < lp->mingeowidth)) continue;
-    }
-    
-    /* set the scale factor so that scale dependant symbols are drawn in the legend with their default size */
-    if(lp->sizeunits != MS_PIXELS) {
+    if (!scale_independent && lp->maxscaledenom <= 0 &&
+        lp->minscaledenom <= 0) {
+      if ((lp->maxgeowidth > 0) &&
+          ((map->extent.maxx - map->extent.minx) > lp->maxgeowidth))
+        continue;
+      if ((lp->mingeowidth > 0) &&
+          ((map->extent.maxx - map->extent.minx) < lp->mingeowidth))
+        continue;
+    }
+
+    /* set the scale factor so that scale dependant symbols are drawn in the
+     * legend with their default size */
+    if (lp->sizeunits != MS_PIXELS) {
       map->cellsize = msAdjustExtent(&(map->extent), map->width, map->height);
-      lp->scalefactor = (msInchesPerUnit(lp->sizeunits,0)/msInchesPerUnit(map->units,0)) / map->cellsize;
+      lp->scalefactor =
+          (msInchesPerUnit(lp->sizeunits, 0) / msInchesPerUnit(map->units, 0)) /
+          map->cellsize;
     }
 
-    for(j=lp->numclasses-1; j>=0; j--) {
-      text = lp->class[j]->title?lp->class[j]->title:lp->class[j]->name; /* point to the right legend text, title takes precedence */
-      if(!text) continue; /* skip it */
+    for (j = lp->numclasses - 1; j >= 0; j--) {
+      text = lp->class[j]->title
+                 ? lp->class[j]->title
+                 : lp->class[j]->name; /* point to the right legend text, title
+                                          takes precedence */
+      if (!text)
+        continue; /* skip it */
 
       /* skip the class if the classgroup is defined */
-      if(lp->classgroup && (lp->class[j]->group == NULL || strcasecmp(lp->class[j]->group, lp->classgroup) != 0))
+      if (lp->classgroup &&
+          (lp->class[j] -> group == NULL || strcasecmp(lp->class[j] -> group,
+                                                       lp -> classgroup) != 0))
         continue;
 
-      if(!scale_independent && map->scaledenom > 0) {  /* verify class scale here */
-        if((lp->class[j]->maxscaledenom > 0) && (map->scaledenom > lp->class[j]->maxscaledenom)) continue;
-        if((lp->class[j]->minscaledenom > 0) && (map->scaledenom <= lp->class[j]->minscaledenom)) continue;
+      if (!scale_independent &&
+          map->scaledenom > 0) { /* verify class scale here */
+        if ((lp->class[j] -> maxscaledenom > 0) &&
+            (map->scaledenom > lp->class[j] -> maxscaledenom))
+          continue;
+        if ((lp->class[j] -> minscaledenom > 0) &&
+            (map->scaledenom <= lp->class[j] -> minscaledenom))
+          continue;
       }
 
-      if(hittest && hittest->layerhits[map->layerorder[i]].classhits[j].status == 0) {
-          continue;
+      if (hittest &&
+          hittest->layerhits[map->layerorder[i]].classhits[j].status == 0) {
+        continue;
       }
 
-      cur = (legendlabel*) msSmallMalloc(sizeof(legendlabel));
+      cur = (legendlabel *)msSmallMalloc(sizeof(legendlabel));
       initTextSymbol(&cur->ts);
-      if(*text) {
-        msPopulateTextSymbolForLabelAndString(&cur->ts,&map->legend.label,msStrdup(text),map->resolution/map->defresolution,map->resolution/map->defresolution, 0);
-        if(MS_UNLIKELY(MS_FAILURE == msComputeTextPath(map,&cur->ts))) {
+      if (*text) {
+        msPopulateTextSymbolForLabelAndString(
+            &cur->ts, &map->legend.label, msStrdup(text),
+            map->resolution / map->defresolution,
+            map->resolution / map->defresolution, 0);
+        if (MS_UNLIKELY(MS_FAILURE == msComputeTextPath(map, &cur->ts))) {
           ret = MS_FAILURE;
           goto cleanup;
         }
-        if(MS_UNLIKELY(MS_FAILURE == msGetTextSymbolSize(map,&cur->ts,&rect))) {
+        if (MS_UNLIKELY(MS_FAILURE ==
+                        msGetTextSymbolSize(map, &cur->ts, &rect))) {
           ret = MS_FAILURE;
           goto cleanup;
         }
-        cur->height = MS_MAX(MS_NINT(rect.maxy - rect.miny), map->legend.keysizey);
+        cur->height =
+            MS_MAX(MS_NINT(rect.maxy - rect.miny), map->legend.keysizey);
       } else {
         cur->height = map->legend.keysizey;
       }
@@ -725,19 +828,21 @@ imageObj *msDrawLegend(mapObj *map, int
     }
   }
 
-
   /* ensure we have an image format representing the options for the legend. */
   msApplyOutputFormat(&format, map->outputformat, map->legend.transparent);
 
   /* initialize the legend image */
-  image = msImageCreate(size_x, size_y, format, map->web.imagepath, map->web.imageurl, map->resolution, map->defresolution, &map->legend.imagecolor);
-  if(!image) {
+  image = msImageCreate(size_x, size_y, format, map->web.imagepath,
+                        map->web.imageurl, map->resolution, map->defresolution,
+                        &map->legend.imagecolor);
+  if (!image) {
     msSetError(MS_MISCERR, "Unable to initialize image.", "msDrawLegend()");
     return NULL;
   }
   image->map = map;
 
-  /* image = renderer->createImage(size_x,size_y,format,&(map->legend.imagecolor)); */
+  /* image =
+   * renderer->createImage(size_x,size_y,format,&(map->legend.imagecolor)); */
 
   /* drop this reference to output format */
   msApplyOutputFormat(&format, NULL, MS_NOOVERRIDE);
@@ -745,37 +850,45 @@ imageObj *msDrawLegend(mapObj *map, int
   pnt.y = VMARGIN;
   pnt.x = HMARGIN + map->legend.keysizex + map->legend.keyspacingx;
 
-  while(cur) { /* cur initially points on the last legend item, i.e. the one that should be at the top */
+  while (cur) { /* cur initially points on the last legend item, i.e. the one
+                   that should be at the top */
     class_hittest *ch = NULL;
 
-    /* set the scale factor so that scale dependant symbols are drawn in the legend with their default size */
-    if(map->layers[cur->layerindex]->sizeunits != MS_PIXELS) {
+    /* set the scale factor so that scale dependant symbols are drawn in the
+     * legend with their default size */
+    if (map->layers[cur->layerindex]->sizeunits != MS_PIXELS) {
       map->cellsize = msAdjustExtent(&(map->extent), map->width, map->height);
-      map->layers[cur->layerindex]->scalefactor = (msInchesPerUnit(map->layers[cur->layerindex]->sizeunits,0)/msInchesPerUnit(map->units,0)) / map->cellsize;
+      map->layers[cur->layerindex]->scalefactor =
+          (msInchesPerUnit(map->layers[cur->layerindex]->sizeunits, 0) /
+           msInchesPerUnit(map->units, 0)) /
+          map->cellsize;
     }
-    if(hittest) {
+    if (hittest) {
       ch = &hittest->layerhits[cur->layerindex].classhits[cur->classindex];
     }
-    ret = msDrawLegendIcon(map, map->layers[cur->layerindex], map->layers[cur->layerindex]->class[cur->classindex],  map->legend.keysizex,  map->legend.keysizey, image, HMARGIN, (int) pnt.y, scale_independent, ch);
-    if(MS_UNLIKELY(ret != MS_SUCCESS))
+    ret = msDrawLegendIcon(map, map->layers[cur->layerindex],
+                           map->layers[cur->layerindex]->class[cur->classindex],
+                           map -> legend.keysizex, map->legend.keysizey, image,
+                           HMARGIN, (int)pnt.y, scale_independent, ch);
+    if (MS_UNLIKELY(ret != MS_SUCCESS))
       goto cleanup;
 
     pnt.y += cur->height;
 
-    if(cur->ts.annotext) {
+    if (cur->ts.annotext) {
       pointObj textPnt = pnt;
       textPnt.y -= cur->ts.textpath->bounds.bbox.maxy;
       textPnt.y += map->legend.label.offsety;
       textPnt.x += map->legend.label.offsetx;
-      ret = msDrawTextSymbol(map,image,textPnt,&cur->ts);
-      if(MS_UNLIKELY(ret == MS_FAILURE))
+      ret = msDrawTextSymbol(map, image, textPnt, &cur->ts);
+      if (MS_UNLIKELY(ret == MS_FAILURE))
         goto cleanup;
       /* Coverity Scan is confused by label refcount, and wrongly believe we */
       /* might free &map->legend.label, so make it clear we won't */
       freeTextSymbolEx(&cur->ts, MS_FALSE);
       MS_REFCNT_DECR(cur->ts.label);
     }
-    
+
     pnt.y += map->legend.keyspacingy; /* bump y for next label */
 
     /* clean up */
@@ -785,7 +898,7 @@ imageObj *msDrawLegend(mapObj *map, int
   } /* next legend */
 
 cleanup:
-  while(cur) {
+  while (cur) {
     /* Coverity Scan is confused by label refcount, and wrongly believe we */
     /* might free &map->legend.label, so make it clear we won't */
     freeTextSymbolEx(&cur->ts, MS_FALSE);
@@ -794,69 +907,76 @@ cleanup:
     cur = cur->pred;
     free(head);
   }
-  if(MS_UNLIKELY(ret != MS_SUCCESS)) {
-    if(image) msFreeImage(image);
+  if (MS_UNLIKELY(ret != MS_SUCCESS)) {
+    if (image)
+      msFreeImage(image);
     return NULL;
   }
-  return(image);
+  return (image);
 }
 
 /* TODO */
-int msEmbedLegend(mapObj *map, imageObj *img)
-{
-  int s,l;
+int msEmbedLegend(mapObj *map, imageObj *img) {
+  int s, l;
   pointObj point;
   imageObj *image = NULL;
   symbolObj *legendSymbol;
-  char* imageType = NULL;
+  char *imageType = NULL;
 
   rendererVTableObj *renderer;
 
   s = msGetSymbolIndex(&(map->symbolset), "legend", MS_FALSE);
-  if(s != -1)
-    msRemoveSymbol(&(map->symbolset), s); /* solves some caching issues in AGG with long-running processes */
+  if (s != -1)
+    msRemoveSymbol(
+        &(map->symbolset),
+        s); /* solves some caching issues in AGG with long-running processes */
 
-  if(msGrowSymbolSet(&map->symbolset) == NULL)
+  if (msGrowSymbolSet(&map->symbolset) == NULL)
     return -1;
   s = map->symbolset.numsymbols;
   legendSymbol = map->symbolset.symbol[s];
   map->symbolset.numsymbols++;
   initSymbol(legendSymbol);
 
-  if(!MS_RENDERER_PLUGIN(map->outputformat) || !MS_MAP_RENDERER(map)->supports_pixel_buffer) {
+  if (!MS_RENDERER_PLUGIN(map->outputformat) ||
+      !MS_MAP_RENDERER(map)->supports_pixel_buffer) {
     imageType = msStrdup(map->imagetype); /* save format */
-    if MS_DRIVER_CAIRO(map->outputformat)
-      map->outputformat = msSelectOutputFormat( map, "cairopng" );
+    if MS_DRIVER_CAIRO (map->outputformat)
+      map->outputformat = msSelectOutputFormat(map, "cairopng");
     else
-      map->outputformat = msSelectOutputFormat( map, "png" );
-    
+      map->outputformat = msSelectOutputFormat(map, "png");
+
     msInitializeRendererVTable(map->outputformat);
   }
   renderer = MS_MAP_RENDERER(map);
 
   /* render the legend. */
   image = msDrawLegend(map, MS_FALSE, NULL);
-  if( image == NULL ) {
+  if (image == NULL) {
     msFree(imageType);
     return MS_FAILURE;
   }
 
   if (imageType) {
-    map->outputformat = msSelectOutputFormat( map, imageType ); /* restore format */
+    map->outputformat =
+        msSelectOutputFormat(map, imageType); /* restore format */
     msFree(imageType);
   }
 
   /* copy renderered legend image into symbol */
-  legendSymbol->pixmap_buffer = calloc(1,sizeof(rasterBufferObj));
-  MS_CHECK_ALLOC(legendSymbol->pixmap_buffer, sizeof(rasterBufferObj), MS_FAILURE);
+  legendSymbol->pixmap_buffer = calloc(1, sizeof(rasterBufferObj));
+  MS_CHECK_ALLOC(legendSymbol->pixmap_buffer, sizeof(rasterBufferObj),
+                 MS_FAILURE);
 
-  if(MS_SUCCESS != renderer->getRasterBufferCopy(image,legendSymbol->pixmap_buffer))
+  if (MS_SUCCESS !=
+      renderer->getRasterBufferCopy(image, legendSymbol->pixmap_buffer))
     return MS_FAILURE;
   legendSymbol->renderer = renderer;
 
-  msFreeImage( image );
+  msFreeImage(image);
 
-  if(!legendSymbol->pixmap_buffer) return(MS_FAILURE); /* something went wrong creating scalebar */
+  if (!legendSymbol->pixmap_buffer)
+    return (MS_FAILURE); /* something went wrong creating scalebar */
 
   legendSymbol->type = MS_SYMBOL_PIXMAP; /* intialize a few things */
   legendSymbol->name = msStrdup("legend");
@@ -867,46 +987,48 @@ int msEmbedLegend(mapObj *map, imageObj
   /* if(map->legend.transparent == MS_ON) */
   /*  gdImageColorTransparent(legendSymbol->img_deprecated, 0); */
 
-  switch(map->legend.position) {
-    case(MS_LL):
-      point.x = MS_NINT(legendSymbol->sizex/2.0);
-      point.y = map->height - MS_NINT(legendSymbol->sizey/2.0);
-      break;
-    case(MS_LR):
-      point.x = map->width - MS_NINT(legendSymbol->sizex/2.0);
-      point.y = map->height - MS_NINT(legendSymbol->sizey/2.0);
-      break;
-    case(MS_LC):
-      point.x = MS_NINT(map->width/2.0);
-      point.y = map->height - MS_NINT(legendSymbol->sizey/2.0);
-      break;
-    case(MS_UR):
-      point.x = map->width - MS_NINT(legendSymbol->sizex/2.0);
-      point.y = MS_NINT(legendSymbol->sizey/2.0);
-      break;
-    case(MS_UL):
-      point.x = MS_NINT(legendSymbol->sizex/2.0);
-      point.y = MS_NINT(legendSymbol->sizey/2.0);
-      break;
-    case(MS_UC):
-      point.x = MS_NINT(map->width/2.0);
-      point.y = MS_NINT(legendSymbol->sizey/2.0);
-      break;
+  switch (map->legend.position) {
+  case (MS_LL):
+    point.x = MS_NINT(legendSymbol->sizex / 2.0);
+    point.y = map->height - MS_NINT(legendSymbol->sizey / 2.0);
+    break;
+  case (MS_LR):
+    point.x = map->width - MS_NINT(legendSymbol->sizex / 2.0);
+    point.y = map->height - MS_NINT(legendSymbol->sizey / 2.0);
+    break;
+  case (MS_LC):
+    point.x = MS_NINT(map->width / 2.0);
+    point.y = map->height - MS_NINT(legendSymbol->sizey / 2.0);
+    break;
+  case (MS_UR):
+    point.x = map->width - MS_NINT(legendSymbol->sizex / 2.0);
+    point.y = MS_NINT(legendSymbol->sizey / 2.0);
+    break;
+  case (MS_UL):
+    point.x = MS_NINT(legendSymbol->sizex / 2.0);
+    point.y = MS_NINT(legendSymbol->sizey / 2.0);
+    break;
+  case (MS_UC):
+    point.x = MS_NINT(map->width / 2.0);
+    point.y = MS_NINT(legendSymbol->sizey / 2.0);
+    break;
   }
 
   l = msGetLayerIndex(map, "__embed__legend");
-  if(l == -1) {
-    if(msGrowMapLayers(map) == NULL)
-      return(-1);
+  if (l == -1) {
+    if (msGrowMapLayers(map) == NULL)
+      return (-1);
     l = map->numlayers;
     map->numlayers++;
-    if(initLayer((GET_LAYER(map, l)), map) == -1) return(-1);
+    if (initLayer((GET_LAYER(map, l)), map) == -1)
+      return (-1);
     GET_LAYER(map, l)->name = msStrdup("__embed__legend");
     GET_LAYER(map, l)->type = MS_LAYER_POINT;
 
-    if(msGrowLayerClasses( GET_LAYER(map, l) ) == NULL)
-      return(-1);
-    if(initClass(GET_LAYER(map, l)->class[0]) == -1) return(-1);
+    if (msGrowLayerClasses(GET_LAYER(map, l)) == NULL)
+      return (-1);
+    if (initClass(GET_LAYER(map, l)->class[0]) == -1)
+      return (-1);
     GET_LAYER(map, l)->numclasses = 1; /* so we make sure to free it */
 
     /* update the layer order list with the layer's index. */
@@ -915,33 +1037,45 @@ int msEmbedLegend(mapObj *map, imageObj
 
   GET_LAYER(map, l)->status = MS_ON;
 
-  if(map->legend.postlabelcache) { /* add it directly to the image */
-    if(MS_UNLIKELY(msMaybeAllocateClassStyle(GET_LAYER(map, l)->class[0], 0)==MS_FAILURE)) return MS_FAILURE;
+  if (map->legend.postlabelcache) { /* add it directly to the image */
+    if (MS_UNLIKELY(msMaybeAllocateClassStyle(GET_LAYER(map, l)->class[0], 0) ==
+                    MS_FAILURE))
+      return MS_FAILURE;
     GET_LAYER(map, l)->class[0]->styles[0]->symbol = s;
-    if(MS_UNLIKELY(MS_FAILURE == msDrawMarkerSymbol(map, img, &point, GET_LAYER(map, l)->class[0]->styles[0], 1.0)))
+    if (MS_UNLIKELY(MS_FAILURE ==
+                    msDrawMarkerSymbol(map, img, &point,
+                                       GET_LAYER(map, l)->class[0] -> styles[0],
+                                       1.0)))
       return MS_FAILURE;
   } else {
-    if(!GET_LAYER(map, l)->class[0]->labels) {
-      if(msGrowClassLabels(GET_LAYER(map, l)->class[0]) == NULL) return MS_FAILURE;
-      initLabel(GET_LAYER(map, l)->class[0]->labels[0]);
+    if (!GET_LAYER(map, l)->class[0] -> labels) {
+      if (msGrowClassLabels(GET_LAYER(map, l)->class[0]) == NULL)
+        return MS_FAILURE;
+      initLabel(GET_LAYER(map, l)->class[0] -> labels[0]);
       GET_LAYER(map, l)->class[0]->numlabels = 1;
       GET_LAYER(map, l)->class[0]->labels[0]->force = MS_TRUE;
-      GET_LAYER(map, l)->class[0]->labels[0]->size = MS_MEDIUM; /* must set a size to have a valid label definition */
+      GET_LAYER(map, l)->class[0]->labels[0]->size =
+          MS_MEDIUM; /* must set a size to have a valid label definition */
       GET_LAYER(map, l)->class[0]->labels[0]->priority = MS_MAX_LABEL_PRIORITY;
     }
-    if(GET_LAYER(map, l)->class[0]->labels[0]->numstyles == 0) {
-      if(msGrowLabelStyles(GET_LAYER(map,l)->class[0]->labels[0]) == NULL)
-        return(MS_FAILURE);
-      GET_LAYER(map,l)->class[0]->labels[0]->numstyles = 1;
-      initStyle(GET_LAYER(map,l)->class[0]->labels[0]->styles[0]);
-      GET_LAYER(map,l)->class[0]->labels[0]->styles[0]->_geomtransform.type = MS_GEOMTRANSFORM_LABELPOINT;
+    if (GET_LAYER(map, l)->class[0] -> labels[0] -> numstyles == 0) {
+      if (msGrowLabelStyles(GET_LAYER(map, l)->class[0] -> labels[0]) == NULL)
+        return (MS_FAILURE);
+      GET_LAYER(map, l)->class[0]->labels[0]->numstyles = 1;
+      initStyle(GET_LAYER(map, l)->class[0] -> labels[0] -> styles[0]);
+      GET_LAYER(map, l)->class[0]->labels[0]->styles[0]->_geomtransform.type =
+          MS_GEOMTRANSFORM_LABELPOINT;
     }
-    GET_LAYER(map,l)->class[0]->labels[0]->styles[0]->symbol = s;
-    if(MS_UNLIKELY(MS_FAILURE == msAddLabel(map, img, GET_LAYER(map, l)->class[0]->labels[0], l, 0, NULL, &point, -1, NULL)))
+    GET_LAYER(map, l)->class[0]->labels[0]->styles[0]->symbol = s;
+    if (MS_UNLIKELY(MS_FAILURE ==
+                    msAddLabel(map, img,
+                               GET_LAYER(map, l)->class[0] -> labels[0], l, 0,
+                               NULL, &point, -1, NULL)))
       return MS_FAILURE;
   }
 
-  /* Mark layer as deleted so that it doesn't interfere with html legends or with saving maps */
+  /* Mark layer as deleted so that it doesn't interfere with html legends or
+   * with saving maps */
   GET_LAYER(map, l)->status = MS_DELETE;
 
   return MS_SUCCESS;
diff -pruN 8.0.1-5/maplibxml2.c 8.0.2-1/maplibxml2.c
--- 8.0.1-5/maplibxml2.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/maplibxml2.c	2024-06-11 20:41:34.000000000 +0000
@@ -31,17 +31,16 @@
 
 #ifdef USE_LIBXML2
 
-#include<libxml/parser.h>
-#include<libxml/tree.h>
-#include<libxml/xpath.h>
-#include<libxml/xpathInternals.h>
-
-
+#include <libxml/parser.h>
+#include <libxml/tree.h>
+#include <libxml/xpath.h>
+#include <libxml/xpathInternals.h>
 
 /**
  * msLibXml2GenerateList()
  *
- * Convenience function to produce a series of XML elements from a delimited list
+ * Convenience function to produce a series of XML elements from a delimited
+ * list
  *
  * @param xmlNodePtr psParent the encompassing node
  * @param xmlNsPtr psNs the namespace object
@@ -51,16 +50,17 @@
  *
  */
 
-void msLibXml2GenerateList(xmlNodePtr psParent, xmlNsPtr psNs, const char *elname, const char *values, char delim)
-{
+void msLibXml2GenerateList(xmlNodePtr psParent, xmlNsPtr psNs,
+                           const char *elname, const char *values, char delim) {
   char **tokens = NULL;
   int n = 0;
   int i = 0;
   tokens = msStringSplit(values, delim, &n);
-  for (i=0; i<n; i++) {
+  for (i = 0; i < n; i++) {
     // Not sure we really need to distinguish empty vs non-empty case, but
-    // this does change the result of msautotest/wxs/expected/wcs_empty_cap111.xml otherwise
-    if( tokens[i] && tokens[i][0] != '\0' )
+    // this does change the result of
+    // msautotest/wxs/expected/wcs_empty_cap111.xml otherwise
+    if (tokens[i] && tokens[i][0] != '\0')
       xmlNewTextChild(psParent, psNs, BAD_CAST elname, BAD_CAST tokens[i]);
     else
       xmlNewChild(psParent, psNs, BAD_CAST elname, BAD_CAST tokens[i]);
@@ -81,15 +81,15 @@ void msLibXml2GenerateList(xmlNodePtr ps
  *
  */
 
-xmlXPathObjectPtr msLibXml2GetXPath(xmlDocPtr doc, xmlXPathContextPtr context, xmlChar *xpath)
-{
+xmlXPathObjectPtr msLibXml2GetXPath(xmlDocPtr doc, xmlXPathContextPtr context,
+                                    xmlChar *xpath) {
   (void)doc;
   xmlXPathObjectPtr result;
   result = xmlXPathEval(xpath, context);
   if (result == NULL) {
     return NULL;
   }
-  if(xmlXPathNodeSetIsEmpty(result->nodesetval)) {
+  if (xmlXPathNodeSetIsEmpty(result->nodesetval)) {
     xmlXPathFreeObject(result);
     return NULL;
   }
@@ -108,8 +108,7 @@ xmlXPathObjectPtr msLibXml2GetXPath(xmlD
  *
  */
 
-char *msLibXml2GetXPathTree(xmlDocPtr doc, xmlXPathObjectPtr xpath)
-{
+char *msLibXml2GetXPathTree(xmlDocPtr doc, xmlXPathObjectPtr xpath) {
   xmlBufferPtr xbuf;
   char *result = NULL;
 
diff -pruN 8.0.1-5/maplibxml2.h 8.0.2-1/maplibxml2.h
--- 8.0.1-5/maplibxml2.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/maplibxml2.h	2024-06-11 20:41:34.000000000 +0000
@@ -32,10 +32,10 @@
 
 #ifdef USE_LIBXML2
 
-#include<libxml/parser.h>
-#include<libxml/tree.h>
-#include<libxml/xpath.h>
-#include<libxml/xpathInternals.h>
+#include <libxml/parser.h>
+#include <libxml/tree.h>
+#include <libxml/xpath.h>
+#include <libxml/xpathInternals.h>
 #include <libxml/xmlschemas.h>
 #include <libxml/xmlschemastypes.h>
 
@@ -43,9 +43,11 @@
 extern "C" {
 #endif
 
-xmlXPathObjectPtr msLibXml2GetXPath(xmlDocPtr doc, xmlXPathContextPtr context, xmlChar *xpath);
+xmlXPathObjectPtr msLibXml2GetXPath(xmlDocPtr doc, xmlXPathContextPtr context,
+                                    xmlChar *xpath);
 
-void msLibXml2GenerateList(xmlNodePtr psParent, xmlNsPtr psNs, const char *elname, const char *values, char delim);
+void msLibXml2GenerateList(xmlNodePtr psParent, xmlNsPtr psNs,
+                           const char *elname, const char *values, char delim);
 
 char *msLibXml2GetXPathTree(xmlDocPtr doc, xmlXPathObjectPtr xpath);
 
diff -pruN 8.0.1-5/mapmetadata.c 8.0.2-1/mapmetadata.c
--- 8.0.1-5/mapmetadata.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapmetadata.c	2024-06-11 20:41:34.000000000 +0000
@@ -31,13 +31,13 @@
 #include "mapowscommon.h"
 #include "maplibxml2.h"
 
-#if defined(USE_WMS_SVR) || defined (USE_WFS_SVR) || defined (USE_WCS_SVR) || defined(USE_SOS_SVR) || defined(USE_WMS_LYR) || defined(USE_WFS_LYR)
+#if defined(USE_WMS_SVR) || defined(USE_WFS_SVR) || defined(USE_WCS_SVR) ||    \
+    defined(USE_SOS_SVR) || defined(USE_WMS_LYR) || defined(USE_WFS_LYR)
 
 #ifdef USE_LIBXML2
 
-static
-int msMetadataParseRequest(cgiRequestObj *request,
-                      metadataParamsObj *metadataparams);
+static int msMetadataParseRequest(cgiRequestObj *request,
+                                  metadataParamsObj *metadataparams);
 
 /************************************************************************/
 /*                   _msMetadataGetCharacterString                      */
@@ -45,12 +45,15 @@ int msMetadataParseRequest(cgiRequestObj
 /*      Create a gmd:name/gmd:CharacterString element pattern           */
 /************************************************************************/
 
-static
-xmlNodePtr _msMetadataGetCharacterString(xmlNsPtr namespace, const char *name, const char *value, xmlNsPtr* ppsNsGco) {
+static xmlNodePtr _msMetadataGetCharacterString(xmlNsPtr namespace,
+                                                const char *name,
+                                                const char *value,
+                                                xmlNsPtr *ppsNsGco) {
   xmlNodePtr psNode = NULL;
 
-  if( *ppsNsGco == NULL )
-    *ppsNsGco = xmlNewNs(NULL, BAD_CAST "http://www.isotc211.org/2005/gmd", BAD_CAST "gco");
+  if (*ppsNsGco == NULL)
+    *ppsNsGco = xmlNewNs(NULL, BAD_CAST "http://www.isotc211.org/2005/gmd",
+                         BAD_CAST "gco");
 
   psNode = xmlNewNode(namespace, BAD_CAST name);
 
@@ -59,22 +62,21 @@ xmlNodePtr _msMetadataGetCharacterString
   else
     xmlNewChild(psNode, *ppsNsGco, BAD_CAST "CharacterString", BAD_CAST value);
   return psNode;
-
 }
 
-
 /************************************************************************/
 /*                   _msMetadataGetURL                                  */
 /*                                                                      */
 /*      Create a gmd:name/gmd:URL element pattern                       */
 /************************************************************************/
 
-static
-xmlNodePtr _msMetadataGetURL(xmlNsPtr namespace, const char *name, const char *value, xmlNsPtr* ppsNsGco) {
+static xmlNodePtr _msMetadataGetURL(xmlNsPtr namespace, const char *name,
+                                    const char *value, xmlNsPtr *ppsNsGco) {
   xmlNodePtr psNode = NULL;
 
-  if( *ppsNsGco == NULL )
-    *ppsNsGco = xmlNewNs(NULL, BAD_CAST "http://www.isotc211.org/2005/gmd", BAD_CAST "gco");
+  if (*ppsNsGco == NULL)
+    *ppsNsGco = xmlNewNs(NULL, BAD_CAST "http://www.isotc211.org/2005/gmd",
+                         BAD_CAST "gco");
 
   psNode = xmlNewNode(namespace, BAD_CAST name);
 
@@ -83,7 +85,6 @@ xmlNodePtr _msMetadataGetURL(xmlNsPtr na
   else
     xmlNewChild(psNode, namespace, BAD_CAST "URL", BAD_CAST value);
   return psNode;
-
 }
 
 /************************************************************************/
@@ -92,16 +93,17 @@ xmlNodePtr _msMetadataGetURL(xmlNsPtr na
 /*               Create a gmd:onLine element pattern                    */
 /************************************************************************/
 
-static char* _stringConcatenateAndEncodeHTML(char* str, const char* appendStr)
-{
-  char* pszTmp = msEncodeHTMLEntities(appendStr);
+static char *_stringConcatenateAndEncodeHTML(char *str, const char *appendStr) {
+  char *pszTmp = msEncodeHTMLEntities(appendStr);
   str = msStringConcatenate(str, pszTmp);
   msFree(pszTmp);
   return str;
 }
 
-static
-xmlNodePtr _msMetadataGetOnline(xmlNsPtr namespace, layerObj *layer, const char *service, const char *format, const char *desc, const char *url_in, xmlNsPtr* ppsNsGco) {
+static xmlNodePtr _msMetadataGetOnline(xmlNsPtr namespace, layerObj *layer,
+                                       const char *service, const char *format,
+                                       const char *desc, const char *url_in,
+                                       xmlNsPtr *ppsNsGco) {
 
   int status;
   char *url = NULL;
@@ -119,16 +121,19 @@ xmlNodePtr _msMetadataGetOnline(xmlNsPtr
   url = msStrdup(url_in);
 
   if (strcasecmp(service, "M") == 0) {
-    url = _stringConcatenateAndEncodeHTML(url, "service=WMS&version=1.3.0&request=GetMap&width=500&height=300&styles=&layers=");
+    url = _stringConcatenateAndEncodeHTML(
+        url, "service=WMS&version=1.3.0&request=GetMap&width=500&height=300&"
+             "styles=&layers=");
     url = _stringConcatenateAndEncodeHTML(url, layer->name);
     url = _stringConcatenateAndEncodeHTML(url, "&format=");
     url = _stringConcatenateAndEncodeHTML(url, format);
     url = _stringConcatenateAndEncodeHTML(url, "&crs=");
     {
-        char* epsg_str = NULL;
-        msOWSGetEPSGProj(&(layer->projection), &(layer->metadata), "MFCSGO", MS_TRUE, &epsg_str);
-        url = _stringConcatenateAndEncodeHTML(url, epsg_str);
-        msFree(epsg_str);
+      char *epsg_str = NULL;
+      msOWSGetEPSGProj(&(layer->projection), &(layer->metadata), "MFCSGO",
+                       MS_TRUE, &epsg_str);
+      url = _stringConcatenateAndEncodeHTML(url, epsg_str);
+      msFree(epsg_str);
     }
     link_protocol = "WWW:DOWNLOAD-1.0-http-get-map";
 
@@ -148,17 +153,17 @@ xmlNodePtr _msMetadataGetOnline(xmlNsPtr
       sprintf(buffer, "%f", rect.maxx);
       url = msStringConcatenate(url, buffer);
     }
-  }
-  else if (strcasecmp(service, "F") == 0) {
+  } else if (strcasecmp(service, "F") == 0) {
     link_protocol = "WWW:DOWNLOAD-1.0-http--download";
-    url = _stringConcatenateAndEncodeHTML(url, "service=WFS&version=1.1.0&request=GetFeature&typename=");
+    url = _stringConcatenateAndEncodeHTML(
+        url, "service=WFS&version=1.1.0&request=GetFeature&typename=");
     url = _stringConcatenateAndEncodeHTML(url, layer->name);
     url = _stringConcatenateAndEncodeHTML(url, "&outputformat=");
     url = _stringConcatenateAndEncodeHTML(url, format);
-  }
-  else if (strcasecmp(service, "C") == 0) {
+  } else if (strcasecmp(service, "C") == 0) {
     link_protocol = "WWW:DOWNLOAD-1.0-http--download";
-    url = _stringConcatenateAndEncodeHTML(url, "service=WCS&version=2.0.1&request=GetCoverage&coverageid=");
+    url = _stringConcatenateAndEncodeHTML(
+        url, "service=WCS&version=2.0.1&request=GetCoverage&coverageid=");
     url = _stringConcatenateAndEncodeHTML(url, layer->name);
     url = _stringConcatenateAndEncodeHTML(url, "&format=");
     url = _stringConcatenateAndEncodeHTML(url, format);
@@ -167,31 +172,34 @@ xmlNodePtr _msMetadataGetOnline(xmlNsPtr
   xmlAddChild(psORNode, _msMetadataGetURL(namespace, "linkage", url, ppsNsGco));
   msFree(url);
 
-  xmlAddChild(psORNode, _msMetadataGetCharacterString(namespace, "protocol", link_protocol, ppsNsGco));
-  xmlAddChild(psORNode, _msMetadataGetCharacterString(namespace, "name", layer->name, ppsNsGco));
+  xmlAddChild(psORNode, _msMetadataGetCharacterString(namespace, "protocol",
+                                                      link_protocol, ppsNsGco));
+  xmlAddChild(psORNode, _msMetadataGetCharacterString(namespace, "name",
+                                                      layer->name, ppsNsGco));
 
-  xmlAddChild(psORNode, _msMetadataGetCharacterString(namespace, "description", desc, ppsNsGco));
+  xmlAddChild(psORNode, _msMetadataGetCharacterString(namespace, "description",
+                                                      desc, ppsNsGco));
 
   return psNode;
 }
 
-
 /************************************************************************/
 /*                   _msMetadataGetInteger                              */
 /*                                                                      */
 /*      Create a gmd:name/gmd:Integer element pattern                   */
 /************************************************************************/
 
-static
-xmlNodePtr _msMetadataGetInteger(xmlNsPtr namespace, const char *name, int value, xmlNsPtr* ppsNsGco) {
+static xmlNodePtr _msMetadataGetInteger(xmlNsPtr namespace, const char *name,
+                                        int value, xmlNsPtr *ppsNsGco) {
   char buffer[8];
 
   xmlNodePtr psNode = NULL;
 
   sprintf(buffer, "%d", value);
 
-  if( *ppsNsGco == NULL )
-    *ppsNsGco = xmlNewNs(NULL, BAD_CAST "http://www.isotc211.org/2005/gmd", BAD_CAST "gco");
+  if (*ppsNsGco == NULL)
+    *ppsNsGco = xmlNewNs(NULL, BAD_CAST "http://www.isotc211.org/2005/gmd",
+                         BAD_CAST "gco");
 
   psNode = xmlNewNode(namespace, BAD_CAST name);
 
@@ -202,23 +210,23 @@ xmlNodePtr _msMetadataGetInteger(xmlNsPt
   return psNode;
 }
 
-
 /************************************************************************/
 /*                   _msMetadataGetDecimal                              */
 /*                                                                      */
 /*      Create a gmd:name/gmd:Decimal element pattern                   */
 /************************************************************************/
 
-static
-xmlNodePtr _msMetadataGetDecimal(xmlNsPtr namespace, const char *name, double value, xmlNsPtr* ppsNsGco) {
+static xmlNodePtr _msMetadataGetDecimal(xmlNsPtr namespace, const char *name,
+                                        double value, xmlNsPtr *ppsNsGco) {
   char buffer[32];
 
   xmlNodePtr psNode = NULL;
 
   snprintf(buffer, sizeof(buffer), "%.6f", value);
 
-  if( *ppsNsGco == NULL )
-    *ppsNsGco = xmlNewNs(NULL, BAD_CAST "http://www.isotc211.org/2005/gmd", BAD_CAST "gco");
+  if (*ppsNsGco == NULL)
+    *ppsNsGco = xmlNewNs(NULL, BAD_CAST "http://www.isotc211.org/2005/gmd",
+                         BAD_CAST "gco");
 
   psNode = xmlNewNode(namespace, BAD_CAST name);
 
@@ -229,19 +237,21 @@ xmlNodePtr _msMetadataGetDecimal(xmlNsPt
   return psNode;
 }
 
-
 /************************************************************************/
 /*                   _msMetadataGetCodeList                             */
 /*                                                                      */
 /*      Create a gmd:name/gmd:* code list element pattern               */
 /************************************************************************/
 
-xmlNodePtr _msMetadataGetCodeList(xmlNsPtr namespace, const char *parent_element, const char *name, const char *value) {
+xmlNodePtr _msMetadataGetCodeList(xmlNsPtr namespace,
+                                  const char *parent_element, const char *name,
+                                  const char *value) {
   char *codelist = NULL;
   xmlNodePtr psNode = NULL;
   xmlNodePtr psCodeNode = NULL;
 
-  codelist = msStrdup("http://www.isotc211.org/2005/resources/Codelist/gmxCodelists.xml#");
+  codelist = msStrdup(
+      "http://www.isotc211.org/2005/resources/Codelist/gmxCodelists.xml#");
   codelist = msStringConcatenate(codelist, name);
 
   psNode = xmlNewNode(namespace, BAD_CAST parent_element);
@@ -253,20 +263,18 @@ xmlNodePtr _msMetadataGetCodeList(xmlNsP
   return psNode;
 }
 
-
 /************************************************************************/
 /*                   _msMetadataGetGMLTimePeriod                        */
 /*                                                                      */
 /*      Create a gml:TimePeriod element pattern                         */
 /************************************************************************/
 
-static
-xmlNodePtr _msMetadataGetGMLTimePeriod(char **temporal)
-{
+static xmlNodePtr _msMetadataGetGMLTimePeriod(char **temporal) {
   xmlNsPtr psNsGml = NULL;
   xmlNodePtr psNode = NULL;
 
-  psNsGml = xmlNewNs(NULL, BAD_CAST "http://www.opengis.net/gml", BAD_CAST "gml");
+  psNsGml =
+      xmlNewNs(NULL, BAD_CAST "http://www.opengis.net/gml", BAD_CAST "gml");
   psNode = xmlNewNode(psNsGml, BAD_CAST "TimePeriod");
   xmlNewNsProp(psNode, psNsGml, BAD_CAST "id", BAD_CAST "T001");
   xmlNewNs(psNode, BAD_CAST "http://www.opengis.net/gml", BAD_CAST "gml");
@@ -277,16 +285,14 @@ xmlNodePtr _msMetadataGetGMLTimePeriod(c
   return psNode;
 }
 
-
 /************************************************************************/
 /*                   _msMetadataGetExtent                               */
 /*                                                                      */
 /*            Create a gmd:extent element pattern                       */
 /************************************************************************/
 
-static
-xmlNodePtr _msMetadataGetExtent(xmlNsPtr namespace, layerObj *layer, xmlNsPtr *ppsNsGco)
-{
+static xmlNodePtr _msMetadataGetExtent(xmlNsPtr namespace, layerObj *layer,
+                                       xmlNsPtr *ppsNsGco) {
   int n = 0;
   int status;
   char *value = NULL;
@@ -305,41 +311,50 @@ xmlNodePtr _msMetadataGetExtent(xmlNsPtr
   psEXNode = xmlNewChild(psNode, namespace, BAD_CAST "EX_Extent", NULL);
 
   /* scan for geospatial extent */
-  status = msLayerGetExtent(layer, &rect); 
+  status = msLayerGetExtent(layer, &rect);
 
   if (status == 0) {
     /* always project to lat long */
     msOWSProjectToWGS84(&layer->projection, &rect);
 
-    psGNode = xmlNewChild(psEXNode, namespace, BAD_CAST "geographicElement", NULL);
-    psGNode2 = xmlNewChild(psGNode, namespace, BAD_CAST "EX_GeographicBoundingBox", NULL);
-    xmlAddChild(psGNode2, _msMetadataGetDecimal(namespace, "westBoundLongitude", rect.minx, ppsNsGco));
-    xmlAddChild(psGNode2, _msMetadataGetDecimal(namespace, "eastBoundLongitude", rect.maxx, ppsNsGco));
-    xmlAddChild(psGNode2, _msMetadataGetDecimal(namespace, "southBoundLatitude", rect.miny, ppsNsGco));
-    xmlAddChild(psGNode2, _msMetadataGetDecimal(namespace, "northBoundLatitude", rect.maxy, ppsNsGco));
+    psGNode =
+        xmlNewChild(psEXNode, namespace, BAD_CAST "geographicElement", NULL);
+    psGNode2 = xmlNewChild(psGNode, namespace,
+                           BAD_CAST "EX_GeographicBoundingBox", NULL);
+    xmlAddChild(psGNode2, _msMetadataGetDecimal(namespace, "westBoundLongitude",
+                                                rect.minx, ppsNsGco));
+    xmlAddChild(psGNode2, _msMetadataGetDecimal(namespace, "eastBoundLongitude",
+                                                rect.maxx, ppsNsGco));
+    xmlAddChild(psGNode2, _msMetadataGetDecimal(namespace, "southBoundLatitude",
+                                                rect.miny, ppsNsGco));
+    xmlAddChild(psGNode2, _msMetadataGetDecimal(namespace, "northBoundLatitude",
+                                                rect.maxy, ppsNsGco));
   }
 
   /* scan for temporal extent */
   value = (char *)msOWSLookupMetadata(&(layer->metadata), "MO", "timeextent");
   if (value) { /* WMS */
     temporal = msStringSplit(value, '/', &n);
-  }
-  else { /* WCS */
-    value = (char *)msOWSLookupMetadata(&(layer->metadata), "CO", "timeposition");
+  } else { /* WCS */
+    value =
+        (char *)msOWSLookupMetadata(&(layer->metadata), "CO", "timeposition");
     if (value) {
       /* split extent */
       temporal = msStringSplit(value, ',', &n);
     }
   }
   if (!value) { /* SOS */
-      value = (char *)msOWSLookupMetadata(&(layer->metadata), "SO", "offering_timeextent");
-      if (value)
-        temporal = msStringSplit(value, '/', &n);
+    value = (char *)msOWSLookupMetadata(&(layer->metadata), "SO",
+                                        "offering_timeextent");
+    if (value)
+      temporal = msStringSplit(value, '/', &n);
   }
-  if (value) { 
+  if (value) {
     if (temporal && n > 0) {
-      psTNode = xmlNewChild(psEXNode, namespace, BAD_CAST "temporalElement", NULL);
-      psTNode2 = xmlNewChild(psTNode, namespace, BAD_CAST "EX_TemporalExtent", NULL);
+      psTNode =
+          xmlNewChild(psEXNode, namespace, BAD_CAST "temporalElement", NULL);
+      psTNode2 =
+          xmlNewChild(psTNode, namespace, BAD_CAST "EX_TemporalExtent", NULL);
       psENode = xmlNewChild(psTNode2, namespace, BAD_CAST "extent", NULL);
       xmlAddChild(psENode, _msMetadataGetGMLTimePeriod(temporal));
     }
@@ -349,16 +364,15 @@ xmlNodePtr _msMetadataGetExtent(xmlNsPtr
   return psNode;
 }
 
-
 /************************************************************************/
 /*                   _msMetadataGetReferenceSystemInfo                  */
 /*                                                                      */
 /*      Create a gmd:referenceSystemInfo element pattern                */
 /************************************************************************/
 
-static
-xmlNodePtr _msMetadataGetReferenceSystemInfo(xmlNsPtr namespace, layerObj *layer, xmlNsPtr* ppsNsGco)
-{
+static xmlNodePtr _msMetadataGetReferenceSystemInfo(xmlNsPtr namespace,
+                                                    layerObj *layer,
+                                                    xmlNsPtr *ppsNsGco) {
   char *epsg_str = NULL;
   xmlNodePtr psNode = NULL;
   xmlNodePtr psRSNode = NULL;
@@ -366,28 +380,35 @@ xmlNodePtr _msMetadataGetReferenceSystem
   xmlNodePtr psRSINode2 = NULL;
 
   psNode = xmlNewNode(namespace, BAD_CAST "referenceSystemInfo");
-  psRSNode = xmlNewChild(psNode, namespace, BAD_CAST "MD_ReferenceSystem", NULL);
-  psRSINode = xmlNewChild(psRSNode, namespace, BAD_CAST "referenceSystemIdentifier", NULL);
-  psRSINode2 = xmlNewChild(psRSINode, namespace, BAD_CAST "RS_Identifier", NULL);
-
-  msOWSGetEPSGProj(&(layer->projection), &(layer->metadata), "MFCSGO", MS_TRUE, &epsg_str);
-  xmlAddChild(psRSINode2, _msMetadataGetCharacterString(namespace, "code", epsg_str, ppsNsGco));
-  xmlAddChild(psRSINode2, _msMetadataGetCharacterString(namespace, "codeSpace", "http://www.epsg-registry.org", ppsNsGco));
-  xmlAddChild(psRSINode2, _msMetadataGetCharacterString(namespace, "version", "6.14", ppsNsGco));
+  psRSNode =
+      xmlNewChild(psNode, namespace, BAD_CAST "MD_ReferenceSystem", NULL);
+  psRSINode = xmlNewChild(psRSNode, namespace,
+                          BAD_CAST "referenceSystemIdentifier", NULL);
+  psRSINode2 =
+      xmlNewChild(psRSINode, namespace, BAD_CAST "RS_Identifier", NULL);
+
+  msOWSGetEPSGProj(&(layer->projection), &(layer->metadata), "MFCSGO", MS_TRUE,
+                   &epsg_str);
+  xmlAddChild(psRSINode2, _msMetadataGetCharacterString(namespace, "code",
+                                                        epsg_str, ppsNsGco));
+  xmlAddChild(psRSINode2, _msMetadataGetCharacterString(
+                              namespace, "codeSpace",
+                              "http://www.epsg-registry.org", ppsNsGco));
+  xmlAddChild(psRSINode2, _msMetadataGetCharacterString(namespace, "version",
+                                                        "6.14", ppsNsGco));
   msFree(epsg_str);
 
   return psNode;
 }
 
-
 /************************************************************************/
 /*                   _msMetadataGetContact                              */
 /*                                                                      */
 /*      Create a gmd:contact element pattern                            */
 /************************************************************************/
 
-xmlNodePtr _msMetadataGetContact(xmlNsPtr namespace, char *contact_element, mapObj *map, xmlNsPtr* ppsNsGco)
-{
+xmlNodePtr _msMetadataGetContact(xmlNsPtr namespace, char *contact_element,
+                                 mapObj *map, xmlNsPtr *ppsNsGco) {
   char *value = NULL;
   xmlNodePtr psNode = NULL;
   xmlNodePtr psCNode = NULL;
@@ -401,83 +422,111 @@ xmlNodePtr _msMetadataGetContact(xmlNsPt
   xmlNodePtr psORNode2 = NULL;
 
   psNode = xmlNewNode(namespace, BAD_CAST contact_element);
-  psCNode = xmlNewChild(psNode, namespace, BAD_CAST "CI_ResponsibleParty", NULL);
+  psCNode =
+      xmlNewChild(psNode, namespace, BAD_CAST "CI_ResponsibleParty", NULL);
   xmlNewProp(psCNode, BAD_CAST "id", BAD_CAST contact_element);
 
-  value = (char *)msOWSLookupMetadata(&(map->web.metadata), "MCFO", "contactperson");
+  value = (char *)msOWSLookupMetadata(&(map->web.metadata), "MCFO",
+                                      "contactperson");
   if (value)
-    xmlAddChild(psCNode, _msMetadataGetCharacterString(namespace, "individualName", value, ppsNsGco));
+    xmlAddChild(psCNode, _msMetadataGetCharacterString(
+                             namespace, "individualName", value, ppsNsGco));
 
-  value = (char *)msOWSLookupMetadata(&(map->web.metadata), "MCFO", "contactorganization");
+  value = (char *)msOWSLookupMetadata(&(map->web.metadata), "MCFO",
+                                      "contactorganization");
   if (value)
-    xmlAddChild(psCNode, _msMetadataGetCharacterString(namespace, "organisationName", value, ppsNsGco));
+    xmlAddChild(psCNode, _msMetadataGetCharacterString(
+                             namespace, "organisationName", value, ppsNsGco));
 
-  value = (char *)msOWSLookupMetadata(&(map->web.metadata), "MCFO", "contactposition");
+  value = (char *)msOWSLookupMetadata(&(map->web.metadata), "MCFO",
+                                      "contactposition");
   if (value)
-    xmlAddChild(psCNode, _msMetadataGetCharacterString(namespace, "positionName", value, ppsNsGco));
+    xmlAddChild(psCNode, _msMetadataGetCharacterString(
+                             namespace, "positionName", value, ppsNsGco));
 
   psCINode = xmlNewChild(psCNode, namespace, BAD_CAST "contactInfo", NULL);
   psCINode2 = xmlNewChild(psCINode, namespace, BAD_CAST "CI_Contact", NULL);
   psPhoneNode = xmlNewChild(psCINode2, namespace, BAD_CAST "phone", NULL);
-  psCIPhoneNode = xmlNewChild(psPhoneNode, namespace, BAD_CAST "CI_Telephone", NULL);
+  psCIPhoneNode =
+      xmlNewChild(psPhoneNode, namespace, BAD_CAST "CI_Telephone", NULL);
 
-  value = (char *)msOWSLookupMetadata(&(map->web.metadata), "MCFO", "contactvoicetelephone");
+  value = (char *)msOWSLookupMetadata(&(map->web.metadata), "MCFO",
+                                      "contactvoicetelephone");
   if (value)
-    xmlAddChild(psCIPhoneNode, _msMetadataGetCharacterString(namespace, "voice", value, ppsNsGco));
+    xmlAddChild(psCIPhoneNode, _msMetadataGetCharacterString(namespace, "voice",
+                                                             value, ppsNsGco));
 
-  value = (char *)msOWSLookupMetadata(&(map->web.metadata), "MCFO", "contactfacsimiletelephone");
+  value = (char *)msOWSLookupMetadata(&(map->web.metadata), "MCFO",
+                                      "contactfacsimiletelephone");
   if (value)
-    xmlAddChild(psCIPhoneNode, _msMetadataGetCharacterString(namespace, "facsimile", value, ppsNsGco));
+    xmlAddChild(psCIPhoneNode, _msMetadataGetCharacterString(
+                                   namespace, "facsimile", value, ppsNsGco));
 
   psAddressNode = xmlNewChild(psCINode2, namespace, BAD_CAST "address", NULL);
-  psCIAddressNode = xmlNewChild(psAddressNode, namespace, BAD_CAST "CI_Address", NULL);
+  psCIAddressNode =
+      xmlNewChild(psAddressNode, namespace, BAD_CAST "CI_Address", NULL);
 
   value = (char *)msOWSLookupMetadata(&(map->web.metadata), "MCFO", "address");
   if (value)
-    xmlAddChild(psCIAddressNode, _msMetadataGetCharacterString(namespace, "deliveryPoint", value, ppsNsGco));
+    xmlAddChild(psCIAddressNode,
+                _msMetadataGetCharacterString(namespace, "deliveryPoint", value,
+                                              ppsNsGco));
 
   value = (char *)msOWSLookupMetadata(&(map->web.metadata), "MCFO", "city");
   if (value)
-    xmlAddChild(psCIAddressNode, _msMetadataGetCharacterString(namespace, "city", value, ppsNsGco));
+    xmlAddChild(psCIAddressNode, _msMetadataGetCharacterString(
+                                     namespace, "city", value, ppsNsGco));
 
-  value = (char *)msOWSLookupMetadata(&(map->web.metadata), "MCFO", "stateorprovince");
+  value = (char *)msOWSLookupMetadata(&(map->web.metadata), "MCFO",
+                                      "stateorprovince");
   if (value)
-    xmlAddChild(psCIAddressNode, _msMetadataGetCharacterString(namespace, "administrativeArea", value, ppsNsGco));
+    xmlAddChild(psCIAddressNode,
+                _msMetadataGetCharacterString(namespace, "administrativeArea",
+                                              value, ppsNsGco));
 
   value = (char *)msOWSLookupMetadata(&(map->web.metadata), "MCFO", "postcode");
   if (value)
-    xmlAddChild(psCIAddressNode, _msMetadataGetCharacterString(namespace, "postalCode", value, ppsNsGco));
+    xmlAddChild(psCIAddressNode, _msMetadataGetCharacterString(
+                                     namespace, "postalCode", value, ppsNsGco));
 
   value = (char *)msOWSLookupMetadata(&(map->web.metadata), "MCFO", "country");
   if (value)
-    xmlAddChild(psCIAddressNode, _msMetadataGetCharacterString(namespace, "country", value, ppsNsGco));
+    xmlAddChild(psCIAddressNode, _msMetadataGetCharacterString(
+                                     namespace, "country", value, ppsNsGco));
 
-  value = (char *)msOWSLookupMetadata(&(map->web.metadata), "MCFO", "contactelectronicmailaddress");
+  value = (char *)msOWSLookupMetadata(&(map->web.metadata), "MCFO",
+                                      "contactelectronicmailaddress");
   if (value)
-    xmlAddChild(psCIAddressNode, _msMetadataGetCharacterString(namespace, "electronicMailAddress", value, ppsNsGco));
+    xmlAddChild(psCIAddressNode,
+                _msMetadataGetCharacterString(
+                    namespace, "electronicMailAddress", value, ppsNsGco));
 
-  value = (char *)msOWSLookupMetadata(&(map->web.metadata), "MCFO", "onlineresource");
+  value = (char *)msOWSLookupMetadata(&(map->web.metadata), "MCFO",
+                                      "onlineresource");
   if (value) {
-    psORNode = xmlNewChild(psCINode2, namespace, BAD_CAST "onlineResource", NULL);
-    psORNode2 = xmlNewChild(psORNode, namespace, BAD_CAST "CI_OnlineResource", NULL);
-    xmlAddChild(psORNode2, _msMetadataGetURL(namespace, "linkage", value, ppsNsGco));
+    psORNode =
+        xmlNewChild(psCINode2, namespace, BAD_CAST "onlineResource", NULL);
+    psORNode2 =
+        xmlNewChild(psORNode, namespace, BAD_CAST "CI_OnlineResource", NULL);
+    xmlAddChild(psORNode2,
+                _msMetadataGetURL(namespace, "linkage", value, ppsNsGco));
   }
 
-  xmlAddChild(psCNode, _msMetadataGetCodeList(namespace, "role", "CI_RoleCode", "pointOfContact"));
+  xmlAddChild(psCNode, _msMetadataGetCodeList(namespace, "role", "CI_RoleCode",
+                                              "pointOfContact"));
 
   return psNode;
 }
 
-
 /************************************************************************/
 /*                   _msMetadataGetIdentificationInfo                   */
 /*                                                                      */
 /*      Create a gmd:identificationInfo element pattern                 */
 /************************************************************************/
 
-static
-xmlNodePtr _msMetadataGetIdentificationInfo(xmlNsPtr namespace, mapObj *map, layerObj *layer, xmlNsPtr *ppsNsGco)
-{
+static xmlNodePtr _msMetadataGetIdentificationInfo(xmlNsPtr namespace,
+                                                   mapObj *map, layerObj *layer,
+                                                   xmlNsPtr *ppsNsGco) {
   char *value;
   xmlNodePtr psNode = NULL;
   xmlNodePtr psDINode = NULL;
@@ -489,61 +538,74 @@ xmlNodePtr _msMetadataGetIdentificationI
 
   psNode = xmlNewNode(namespace, BAD_CAST "identificationInfo");
 
-  psDINode = xmlNewChild(psNode, namespace, BAD_CAST "MD_DataIdentification", NULL);
+  psDINode =
+      xmlNewChild(psNode, namespace, BAD_CAST "MD_DataIdentification", NULL);
   xmlNewProp(psDINode, BAD_CAST "id", BAD_CAST layer->name);
   psCNode = xmlNewChild(psDINode, namespace, BAD_CAST "citation", NULL);
   psCINode = xmlNewChild(psCNode, namespace, BAD_CAST "CI_Citation", NULL);
 
   value = (char *)msOWSLookupMetadata(&(layer->metadata), "MCFGO", "title");
   if (!value)
-      value = (char *)msOWSLookupMetadata(&(layer->metadata), "S", "offering_name");
-  xmlAddChild(psCINode, _msMetadataGetCharacterString(namespace, "title", value, ppsNsGco));
+    value =
+        (char *)msOWSLookupMetadata(&(layer->metadata), "S", "offering_name");
+  xmlAddChild(psCINode, _msMetadataGetCharacterString(namespace, "title", value,
+                                                      ppsNsGco));
 
   psDNode = xmlNewChild(psCINode, namespace, BAD_CAST "date", NULL);
   xmlNewNsProp(psDNode, *ppsNsGco, BAD_CAST "nilReason", BAD_CAST "missing");
 
-  value = (char *)msOWSLookupMetadata(&(layer->metadata), "MCFGO", "attribution_title");
+  value = (char *)msOWSLookupMetadata(&(layer->metadata), "MCFGO",
+                                      "attribution_title");
   if (value) {
-      xmlAddChild(psCINode, _msMetadataGetCharacterString(namespace, "otherCitationDetails", value, ppsNsGco));
+    xmlAddChild(psCINode,
+                _msMetadataGetCharacterString(namespace, "otherCitationDetails",
+                                              value, ppsNsGco));
   }
 
   value = (char *)msOWSLookupMetadata(&(layer->metadata), "MCFGO", "abstract");
   if (!value)
-      value = (char *)msOWSLookupMetadata(&(layer->metadata), "S", "offering_description");
-  xmlAddChild(psDINode, _msMetadataGetCharacterString(namespace, "abstract", value, ppsNsGco));
+    value = (char *)msOWSLookupMetadata(&(layer->metadata), "S",
+                                        "offering_description");
+  xmlAddChild(psDINode, _msMetadataGetCharacterString(namespace, "abstract",
+                                                      value, ppsNsGco));
 
-  value = (char *)msOWSLookupMetadata(&(layer->metadata), "MCFSGO", "keywordlist");
+  value =
+      (char *)msOWSLookupMetadata(&(layer->metadata), "MCFSGO", "keywordlist");
 
   if (value) {
-    psKWNode = xmlNewChild(psDINode, namespace, BAD_CAST "descriptiveKeywords", NULL);
+    psKWNode =
+        xmlNewChild(psDINode, namespace, BAD_CAST "descriptiveKeywords", NULL);
     psMDKNode = xmlNewChild(psKWNode, namespace, BAD_CAST "MD_Keywords", NULL);
 
     int n = 0;
-    char** tokens = msStringSplit(value, ',', &n);
+    char **tokens = msStringSplit(value, ',', &n);
     if (tokens && n > 0) {
-      for (int i=0; i<n; i++) {
-        xmlAddChild(psMDKNode, _msMetadataGetCharacterString(namespace, "keyword", tokens[i], ppsNsGco));
+      for (int i = 0; i < n; i++) {
+        xmlAddChild(psMDKNode, _msMetadataGetCharacterString(
+                                   namespace, "keyword", tokens[i], ppsNsGco));
       }
     }
     msFreeCharArray(tokens, n);
   }
 
-  xmlAddChild(psDINode, _msMetadataGetCharacterString(namespace, "language", (char *)msOWSGetLanguage(map, "exception"), ppsNsGco));
+  xmlAddChild(psDINode,
+              _msMetadataGetCharacterString(
+                  namespace, "language",
+                  (char *)msOWSGetLanguage(map, "exception"), ppsNsGco));
   xmlAddChild(psDINode, _msMetadataGetExtent(namespace, layer, ppsNsGco));
 
   return psNode;
 }
 
-
 /************************************************************************/
 /*                   _msMetadataGetSpatialRepresentationInfo            */
 /*                                                                      */
 /*      Create a gmd:spatialRepresentationInfo element pattern          */
 /************************************************************************/
 
-static
-xmlNodePtr _msMetadataGetSpatialRepresentationInfo(xmlNsPtr namespace, layerObj *layer, xmlNsPtr* ppsNsGco)
-{
+static xmlNodePtr _msMetadataGetSpatialRepresentationInfo(xmlNsPtr namespace,
+                                                          layerObj *layer,
+                                                          xmlNsPtr *ppsNsGco) {
   char *value;
   xmlNodePtr psNode = NULL;
   xmlNodePtr psSRNode = NULL;
@@ -553,15 +615,23 @@ xmlNodePtr _msMetadataGetSpatialRepresen
   psNode = xmlNewNode(namespace, BAD_CAST "spatialRepresentationInfo");
 
   if (layer->type == MS_LAYER_RASTER) {
-    psSRNode = xmlNewChild(psNode, namespace, BAD_CAST "MD_GridSpatialRepresentation", NULL);
-    xmlAddChild(psSRNode, _msMetadataGetInteger(namespace, "numberOfDimensions", 2, ppsNsGco));
-    xmlAddChild(psSRNode, _msMetadataGetCodeList(namespace, "cellGeometry", "MD_CellGeometryCode", "area"));
-  }
-  else {
-    psSRNode = xmlNewChild(psNode, namespace, BAD_CAST "MD_VectorSpatialRepresentation", NULL);
-    xmlAddChild(psSRNode, _msMetadataGetCodeList(namespace, "topologyLevel", "MD_TopologyLevelCode", "geometryOnly"));
-    psGONode = xmlNewChild(psSRNode, namespace, BAD_CAST "geometricObjects", NULL);
-    psGONode2 = xmlNewChild(psGONode, namespace, BAD_CAST "MD_GeometricObjects", NULL);
+    psSRNode = xmlNewChild(psNode, namespace,
+                           BAD_CAST "MD_GridSpatialRepresentation", NULL);
+    xmlAddChild(psSRNode, _msMetadataGetInteger(namespace, "numberOfDimensions",
+                                                2, ppsNsGco));
+    xmlAddChild(psSRNode,
+                _msMetadataGetCodeList(namespace, "cellGeometry",
+                                       "MD_CellGeometryCode", "area"));
+  } else {
+    psSRNode = xmlNewChild(psNode, namespace,
+                           BAD_CAST "MD_VectorSpatialRepresentation", NULL);
+    xmlAddChild(psSRNode,
+                _msMetadataGetCodeList(namespace, "topologyLevel",
+                                       "MD_TopologyLevelCode", "geometryOnly"));
+    psGONode =
+        xmlNewChild(psSRNode, namespace, BAD_CAST "geometricObjects", NULL);
+    psGONode2 =
+        xmlNewChild(psGONode, namespace, BAD_CAST "MD_GeometricObjects", NULL);
     if (layer->type == MS_LAYER_POINT)
       value = "point";
     else if (layer->type == MS_LAYER_LINE)
@@ -570,24 +640,27 @@ xmlNodePtr _msMetadataGetSpatialRepresen
       value = "surface";
     else
       value = "complex";
-    xmlAddChild(psGONode2, _msMetadataGetCodeList(namespace, "geometricObjectType", "MD_GeometricObjectTypeCode", value));
+    xmlAddChild(psGONode2,
+                _msMetadataGetCodeList(namespace, "geometricObjectType",
+                                       "MD_GeometricObjectTypeCode", value));
     // TODO: find way to get feature count in a fast way
-    /* xmlAddChild(psGONode2, _msMetadataGetInteger(namespace, "geometricObjectCount", msLayerGetNumFeatures(layer))); */
+    /* xmlAddChild(psGONode2, _msMetadataGetInteger(namespace,
+     * "geometricObjectCount", msLayerGetNumFeatures(layer))); */
   }
 
   return psNode;
 }
 
-
 /************************************************************************/
 /*                   _msMetadataGetDistributionInfo                     */
 /*                                                                      */
 /*      Create a gmd:identificationInfo element pattern                 */
 /************************************************************************/
 
-static
-xmlNodePtr _msMetadataGetDistributionInfo(xmlNsPtr namespace, mapObj *map, layerObj *layer, cgiRequestObj *cgi_request, xmlNsPtr* ppsNsGco)
-{
+static xmlNodePtr _msMetadataGetDistributionInfo(xmlNsPtr namespace,
+                                                 mapObj *map, layerObj *layer,
+                                                 cgiRequestObj *cgi_request,
+                                                 xmlNsPtr *ppsNsGco) {
   char *url = NULL;
   xmlNodePtr psNode = NULL;
   xmlNodePtr psMDNode = NULL;
@@ -600,35 +673,47 @@ xmlNodePtr _msMetadataGetDistributionInf
   psMDNode = xmlNewChild(psNode, namespace, BAD_CAST "MD_Distribution", NULL);
 
   {
-      char* pszTmp = msOWSGetOnlineResource(map, "MFCSGO", "onlineresource", cgi_request);
-      url = msEncodeHTMLEntities(pszTmp);
-      msFree(pszTmp);
+    char *pszTmp =
+        msOWSGetOnlineResource(map, "MFCSGO", "onlineresource", cgi_request);
+    url = msEncodeHTMLEntities(pszTmp);
+    msFree(pszTmp);
   }
 
   /* gmd:distributor */
   psDNode = xmlNewChild(psMDNode, namespace, BAD_CAST "distributor", NULL);
   psDNode2 = xmlNewChild(psDNode, namespace, BAD_CAST "MD_Distributor", NULL);
-  xmlAddChild(psDNode2, _msMetadataGetContact(namespace, "distributorContact", map, ppsNsGco));
+  xmlAddChild(psDNode2, _msMetadataGetContact(namespace, "distributorContact",
+                                              map, ppsNsGco));
 
   /* gmd:transferOptions */
   psTONode = xmlNewChild(psMDNode, namespace, BAD_CAST "transferOptions", NULL);
-  psDTONode = xmlNewChild(psTONode, namespace, BAD_CAST "MD_DigitalTransferOptions", NULL);
-  xmlAddChild(psDTONode, _msMetadataGetCharacterString(namespace, "unitsOfDistribution", "KB", ppsNsGco));
+  psDTONode = xmlNewChild(psTONode, namespace,
+                          BAD_CAST "MD_DigitalTransferOptions", NULL);
+  xmlAddChild(psDTONode, _msMetadataGetCharacterString(
+                             namespace, "unitsOfDistribution", "KB", ppsNsGco));
 
   /* links */
 
   /* WMS */
-  xmlAddChild(psDTONode, _msMetadataGetOnline(namespace, layer, "M", "image/png", "PNG Format", url, ppsNsGco));
-  xmlAddChild(psDTONode, _msMetadataGetOnline(namespace, layer, "M", "image/jpeg", "JPEG Format", url, ppsNsGco));
+  xmlAddChild(psDTONode,
+              _msMetadataGetOnline(namespace, layer, "M", "image/png",
+                                   "PNG Format", url, ppsNsGco));
+  xmlAddChild(psDTONode,
+              _msMetadataGetOnline(namespace, layer, "M", "image/jpeg",
+                                   "JPEG Format", url, ppsNsGco));
 
   /* WCS */
   if (layer->type == MS_LAYER_RASTER) {
-    xmlAddChild(psDTONode, _msMetadataGetOnline(namespace, layer, "C", "image/tiff", "GeoTIFF Format", url, ppsNsGco));
+    xmlAddChild(psDTONode,
+                _msMetadataGetOnline(namespace, layer, "C", "image/tiff",
+                                     "GeoTIFF Format", url, ppsNsGco));
   }
   /* WFS */
   else {
-    xmlAddChild(psDTONode, _msMetadataGetOnline(namespace, layer, "F", "GML2", "GML2 Format", url, ppsNsGco));
-    xmlAddChild(psDTONode, _msMetadataGetOnline(namespace, layer, "F", "GML3", "GML3 Format", url, ppsNsGco));
+    xmlAddChild(psDTONode, _msMetadataGetOnline(namespace, layer, "F", "GML2",
+                                                "GML2 Format", url, ppsNsGco));
+    xmlAddChild(psDTONode, _msMetadataGetOnline(namespace, layer, "F", "GML3",
+                                                "GML3 Format", url, ppsNsGco));
   }
 
   msFree(url);
@@ -642,28 +727,26 @@ xmlNodePtr _msMetadataGetDistributionInf
 /*              Generate an OWS Common Exception Report                 */
 /************************************************************************/
 
-static
-xmlNodePtr msMetadataGetExceptionReport(mapObj *map, char *code, char *locator, char *message, xmlNsPtr* ppsNsOws)
-{
+static xmlNodePtr msMetadataGetExceptionReport(mapObj *map, char *code,
+                                               char *locator, char *message,
+                                               xmlNsPtr *ppsNsOws) {
   char *schemas_location = NULL;
 
   xmlNodePtr psRootNode = NULL;
 
   schemas_location = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
-  *ppsNsOws = xmlNewNs(NULL, BAD_CAST "http://www.opengis.net/ows/1.1", BAD_CAST "ows");
+  *ppsNsOws =
+      xmlNewNs(NULL, BAD_CAST "http://www.opengis.net/ows/1.1", BAD_CAST "ows");
 
-  psRootNode = msOWSCommonExceptionReport(*ppsNsOws,
-                                          OWS_1_1_0,
-                                          schemas_location,
-                                          "1.1.0",
-                                          msOWSGetLanguage(map, "exception"),
-                                          code, locator, message);
+  psRootNode = msOWSCommonExceptionReport(
+      *ppsNsOws, OWS_1_1_0, schemas_location, "1.1.0",
+      msOWSGetLanguage(map, "exception"), code, locator, message);
   msFree(schemas_location);
 
-  xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/ows/1.1", BAD_CAST "ows");
+  xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/ows/1.1",
+           BAD_CAST "ows");
 
   return psRootNode;
-
 }
 
 /************************************************************************/
@@ -672,9 +755,11 @@ xmlNodePtr msMetadataGetExceptionReport(
 /*      Generate an ISO 19139-1:2019 representation of layer metadata   */
 /************************************************************************/
 
-static
-xmlNodePtr msMetadataGetLayerMetadata(mapObj *map, metadataParamsObj *paramsObj, cgiRequestObj *cgi_request, xmlNsPtr* ppsNsOws, xmlNsPtr* ppsNsXsi, xmlNsPtr* ppsNsGmd, xmlNsPtr* ppsNsGco)
-{
+static xmlNodePtr
+msMetadataGetLayerMetadata(mapObj *map, metadataParamsObj *paramsObj,
+                           cgiRequestObj *cgi_request, xmlNsPtr *ppsNsOws,
+                           xmlNsPtr *ppsNsXsi, xmlNsPtr *ppsNsGmd,
+                           xmlNsPtr *ppsNsGco) {
   int i;
   int layer_found = MS_FALSE;
 
@@ -682,74 +767,105 @@ xmlNodePtr msMetadataGetLayerMetadata(ma
 
   layerObj *layer = NULL;
 
-  /* Check that layer requested exists in mapfile */ 
-  for (i=0; i<map->numlayers; i++) {
-    if(strcasecmp(GET_LAYER(map, i)->name, paramsObj->pszLayer) == 0) {
-        layer_found = MS_TRUE;
-        layer = GET_LAYER(map, i);
-        // when checking a layer with clustering msLayerGetExtent does not have access
-        // to the source layer, so remove clustering first
-        if (layer->cluster.region) {
-            layer->cluster.region = NULL;
-        }
-        break;
+  /* Check that layer requested exists in mapfile */
+  for (i = 0; i < map->numlayers; i++) {
+    if (strcasecmp(GET_LAYER(map, i)->name, paramsObj->pszLayer) == 0) {
+      layer_found = MS_TRUE;
+      layer = GET_LAYER(map, i);
+      // when checking a layer with clustering msLayerGetExtent does not have
+      // access to the source layer, so remove clustering first
+      if (layer->cluster.region) {
+        layer->cluster.region = NULL;
+      }
+      break;
     }
   }
 
   if (layer_found == MS_FALSE) {
-    psRootNode = msMetadataGetExceptionReport(map, "InvalidParameterValue", "layer", "Layer not found", ppsNsOws);
+    psRootNode = msMetadataGetExceptionReport(
+        map, "InvalidParameterValue", "layer", "Layer not found", ppsNsOws);
   }
 
   /* Check that outputschema is valid */
-  else if (paramsObj->pszOutputSchema && strcasecmp(paramsObj->pszOutputSchema, "http://www.isotc211.org/2005/gmd") != 0) {
-    psRootNode = msMetadataGetExceptionReport(map, "InvalidParameterValue", "outputschema", "OUTPUTSCHEMA must be \"http://www.isotc211.org/2005/gmd\"", ppsNsOws);
+  else if (paramsObj->pszOutputSchema &&
+           strcasecmp(paramsObj->pszOutputSchema,
+                      "http://www.isotc211.org/2005/gmd") != 0) {
+    psRootNode = msMetadataGetExceptionReport(
+        map, "InvalidParameterValue", "outputschema",
+        "OUTPUTSCHEMA must be \"http://www.isotc211.org/2005/gmd\"", ppsNsOws);
   }
 
   else {
-    *ppsNsXsi = xmlNewNs(NULL, BAD_CAST "http://www.w3.org/2001/XMLSchema-instance", BAD_CAST "xsi");
-    *ppsNsGmd = xmlNewNs(NULL, BAD_CAST "http://www.isotc211.org/2005/gmd", BAD_CAST "gmd");
+    *ppsNsXsi =
+        xmlNewNs(NULL, BAD_CAST "http://www.w3.org/2001/XMLSchema-instance",
+                 BAD_CAST "xsi");
+    *ppsNsGmd = xmlNewNs(NULL, BAD_CAST "http://www.isotc211.org/2005/gmd",
+                         BAD_CAST "gmd");
     /* root element */
     psRootNode = xmlNewNode(NULL, BAD_CAST "MD_Metadata");
-    xmlNewNs(psRootNode, BAD_CAST "http://www.isotc211.org/2005/gmd", BAD_CAST "gmd");
-    xmlNewNs(psRootNode, BAD_CAST "http://www.isotc211.org/2005/gco", BAD_CAST "gco");
-    xmlNewNs(psRootNode, BAD_CAST "http://www.w3.org/2001/XMLSchema-instance", BAD_CAST "xsi");
+    xmlNewNs(psRootNode, BAD_CAST "http://www.isotc211.org/2005/gmd",
+             BAD_CAST "gmd");
+    xmlNewNs(psRootNode, BAD_CAST "http://www.isotc211.org/2005/gco",
+             BAD_CAST "gco");
+    xmlNewNs(psRootNode, BAD_CAST "http://www.w3.org/2001/XMLSchema-instance",
+             BAD_CAST "xsi");
     xmlSetNs(psRootNode, *ppsNsGmd);
 
-    xmlNewNsProp(psRootNode, *ppsNsXsi, BAD_CAST "schemaLocation", BAD_CAST "http://www.isotc211.org/2005/gmd http://www.isotc211.org/2005/gmd/gmd.xsd");
+    xmlNewNsProp(psRootNode, *ppsNsXsi, BAD_CAST "schemaLocation",
+                 BAD_CAST "http://www.isotc211.org/2005/gmd "
+                          "http://www.isotc211.org/2005/gmd/gmd.xsd");
 
     /* gmd:identifier */
-    xmlAddChild(psRootNode, _msMetadataGetCharacterString(*ppsNsGmd, "fileIdentifier", layer->name, ppsNsGco));
+    xmlAddChild(psRootNode,
+                _msMetadataGetCharacterString(*ppsNsGmd, "fileIdentifier",
+                                              layer->name, ppsNsGco));
 
     /* gmd:language */
-    xmlAddChild(psRootNode, _msMetadataGetCharacterString(*ppsNsGmd, "language", (char *)msOWSGetLanguage(map, "exception"), ppsNsGco));
+    xmlAddChild(psRootNode,
+                _msMetadataGetCharacterString(
+                    *ppsNsGmd, "language",
+                    (char *)msOWSGetLanguage(map, "exception"), ppsNsGco));
 
     /* gmd:hierarchyLevel */
-    xmlAddChild(psRootNode, _msMetadataGetCodeList(*ppsNsGmd, "hierarchyLevel", "MD_ScopeCode", "dataset"));
+    xmlAddChild(psRootNode, _msMetadataGetCodeList(*ppsNsGmd, "hierarchyLevel",
+                                                   "MD_ScopeCode", "dataset"));
 
     /* gmd:contact */
-    xmlAddChild(psRootNode, _msMetadataGetContact(*ppsNsGmd, "contact", map, ppsNsGco));
+    xmlAddChild(psRootNode,
+                _msMetadataGetContact(*ppsNsGmd, "contact", map, ppsNsGco));
 
     /* gmd:dateStamp */
     /* TODO: nil for now, find way to derive this automagically */
-    xmlAddChild(psRootNode, _msMetadataGetCharacterString(*ppsNsGmd, "dateStamp", NULL, ppsNsGco));
+    xmlAddChild(psRootNode, _msMetadataGetCharacterString(
+                                *ppsNsGmd, "dateStamp", NULL, ppsNsGco));
 
     /* gmd:metadataStandardName */
-    xmlAddChild(psRootNode, _msMetadataGetCharacterString(*ppsNsGmd, "metadataStandardName", "ISO 19115:2003 - Geographic information - Metadata", ppsNsGco));
+    xmlAddChild(psRootNode,
+                _msMetadataGetCharacterString(
+                    *ppsNsGmd, "metadataStandardName",
+                    "ISO 19115:2003 - Geographic information - Metadata",
+                    ppsNsGco));
 
     /* gmd:metadataStandardVersion */
-    xmlAddChild(psRootNode, _msMetadataGetCharacterString(*ppsNsGmd, "metadataStandardVersion", "ISO 19115:2003", ppsNsGco));
+    xmlAddChild(psRootNode, _msMetadataGetCharacterString(
+                                *ppsNsGmd, "metadataStandardVersion",
+                                "ISO 19115:2003", ppsNsGco));
 
     /* gmd:spatialRepresentationInfo */
-    xmlAddChild(psRootNode, _msMetadataGetSpatialRepresentationInfo(*ppsNsGmd, layer, ppsNsGco));
+    xmlAddChild(psRootNode, _msMetadataGetSpatialRepresentationInfo(
+                                *ppsNsGmd, layer, ppsNsGco));
 
     /* gmd:referenceSystemInfo */
-    xmlAddChild(psRootNode, _msMetadataGetReferenceSystemInfo(*ppsNsGmd, layer, ppsNsGco));
+    xmlAddChild(psRootNode,
+                _msMetadataGetReferenceSystemInfo(*ppsNsGmd, layer, ppsNsGco));
 
     /* gmd:identificationInfo */
-    xmlAddChild(psRootNode, _msMetadataGetIdentificationInfo(*ppsNsGmd, map, layer, ppsNsGco));
+    xmlAddChild(psRootNode, _msMetadataGetIdentificationInfo(*ppsNsGmd, map,
+                                                             layer, ppsNsGco));
 
     /* gmd:distributionInfo */
-    xmlAddChild(psRootNode, _msMetadataGetDistributionInfo(*ppsNsGmd, map, layer, cgi_request, ppsNsGco));
+    xmlAddChild(psRootNode, _msMetadataGetDistributionInfo(
+                                *ppsNsGmd, map, layer, cgi_request, ppsNsGco));
   }
 
   return psRootNode;
@@ -761,15 +877,14 @@ xmlNodePtr msMetadataGetLayerMetadata(ma
 /* Entry point for metadata requests.                                   */
 /*                                                                      */
 /* - If this is a valid request then it is processed and MS_SUCCESS     */
-/*   is returned on success, or MS_FAILURE on failure.                  */ 
+/*   is returned on success, or MS_FAILURE on failure.                  */
 /*                                                                      */
 /* - If this does not appear to be a valid WFS request then MS_DONE     */
 /*   is returned and MapServer is expected to process this as a regular */
 /*   MapServer request.                                                 */
 /************************************************************************/
 
-int msMetadataDispatch(mapObj *map, cgiRequestObj *cgi_request)
-{
+int msMetadataDispatch(mapObj *map, cgiRequestObj *cgi_request) {
   int i;
   int status = MS_SUCCESS;
   xmlNodePtr psRootNode = NULL;
@@ -788,31 +903,37 @@ int msMetadataDispatch(mapObj *map, cgiR
   xml_document = xmlNewDoc(BAD_CAST "1.0");
 
   if (msMetadataParseRequest(cgi_request, paramsObj) == MS_FAILURE) {
-    psRootNode = msMetadataGetExceptionReport(map, "InvalidRequest", "layer", "Request parsing failed", &psNsOws);
+    psRootNode = msMetadataGetExceptionReport(
+        map, "InvalidRequest", "layer", "Request parsing failed", &psNsOws);
     status = MS_FAILURE;
   }
 
   /* if layer= is not specified, */
-  if (paramsObj->pszLayer==NULL || strlen(paramsObj->pszLayer)==0) {
-    psRootNode = msMetadataGetExceptionReport(map, "MissingParameterValue", "layer", "Missing layer parameter", &psNsOws);
+  if (paramsObj->pszLayer == NULL || strlen(paramsObj->pszLayer) == 0) {
+    psRootNode =
+        msMetadataGetExceptionReport(map, "MissingParameterValue", "layer",
+                                     "Missing layer parameter", &psNsOws);
     status = MS_FAILURE;
   }
 
   if (status == MS_SUCCESS) { /* Start dispatching request */
     /* Check that layer requested exists in mapfile */
-    for (i=0; i<map->numlayers; i++) {
-      if(strcasecmp(GET_LAYER(map, i)->name, paramsObj->pszLayer) == 0) {
+    for (i = 0; i < map->numlayers; i++) {
+      if (strcasecmp(GET_LAYER(map, i)->name, paramsObj->pszLayer) == 0) {
         layer = GET_LAYER(map, i);
         break;
       }
     }
-    if (layer != NULL && msOWSLookupMetadata(&(layer->metadata), "MFCO", "metadataurl_href")) {
+    if (layer != NULL &&
+        msOWSLookupMetadata(&(layer->metadata), "MFCO", "metadataurl_href")) {
       msIO_setHeader("Status", "301 Moved Permanently");
-      msIO_setHeader("Location", "%s", msOWSLookupMetadata(&(layer->metadata), "MFCO", "metadataurl_href"));
+      msIO_setHeader(
+          "Location", "%s",
+          msOWSLookupMetadata(&(layer->metadata), "MFCO", "metadataurl_href"));
       msIO_sendHeaders();
-    }
-    else {
-      psRootNode = msMetadataGetLayerMetadata(map, paramsObj, cgi_request, &psNsOws, &psNsXsi, &psNsGmd, &psNsGco);
+    } else {
+      psRootNode = msMetadataGetLayerMetadata(
+          map, paramsObj, cgi_request, &psNsOws, &psNsXsi, &psNsGmd, &psNsGco);
     }
   }
 
@@ -824,24 +945,25 @@ int msMetadataDispatch(mapObj *map, cgiR
     msIO_setHeader("Content-type", "text/xml; charset=UTF-8");
     msIO_sendHeaders();
 
-    msIOContext* context = NULL;
+    msIOContext *context = NULL;
 
     context = msIO_getHandler(stdout);
 
-    xmlDocDumpFormatMemoryEnc(xml_document, &xml_buffer, &buffersize, "UTF-8", 1);
+    xmlDocDumpFormatMemoryEnc(xml_document, &xml_buffer, &buffersize, "UTF-8",
+                              1);
     msIO_contextWrite(context, xml_buffer, buffersize);
 
     xmlFree(xml_buffer);
   }
   xmlFreeDoc(xml_document);
-  if( psNsOws )
-      xmlFreeNs(psNsOws);
-  if( psNsXsi )
-      xmlFreeNs(psNsXsi);
-  if( psNsGmd )
-      xmlFreeNs(psNsGmd);
-  if( psNsGco )
-      xmlFreeNs(psNsGco);
+  if (psNsOws)
+    xmlFreeNs(psNsOws);
+  if (psNsXsi)
+    xmlFreeNs(psNsXsi);
+  if (psNsGmd)
+    xmlFreeNs(psNsGmd);
+  if (psNsGco)
+    xmlFreeNs(psNsGco);
 
   msMetadataFreeParamsObj(paramsObj);
 
@@ -857,9 +979,9 @@ int msMetadataDispatch(mapObj *map, cgiR
 /*   The caller should free the object using msMetadataFreeParamsObj.   */
 /************************************************************************/
 
-metadataParamsObj *msMetadataCreateParamsObj()
-{
-  metadataParamsObj *paramsObj = (metadataParamsObj *)calloc(1, sizeof(metadataParamsObj));
+metadataParamsObj *msMetadataCreateParamsObj() {
+  metadataParamsObj *paramsObj =
+      (metadataParamsObj *)calloc(1, sizeof(metadataParamsObj));
   MS_CHECK_ALLOC(paramsObj, sizeof(metadataParamsObj), NULL);
 
   paramsObj->pszLayer = NULL;
@@ -867,15 +989,13 @@ metadataParamsObj *msMetadataCreateParam
   return paramsObj;
 }
 
-
 /************************************************************************/
 /*                            msMetadataFreeParmsObj                    */
 /*                                                                      */
 /*      Free params object.                                             */
 /************************************************************************/
 
-void msMetadataFreeParamsObj(metadataParamsObj *metadataparams)
-{
+void msMetadataFreeParamsObj(metadataParamsObj *metadataparams) {
   if (metadataparams) {
     free(metadataparams->pszRequest);
     free(metadataparams->pszLayer);
@@ -884,22 +1004,19 @@ void msMetadataFreeParamsObj(metadataPar
   }
 }
 
-
 /************************************************************************/
 /*                            msMetadataParseRequest                    */
 /*                                                                      */
 /*      Parse request into the params object.                           */
 /************************************************************************/
 
-static
-int msMetadataParseRequest(cgiRequestObj *request,
-                      metadataParamsObj *metadataparams)
-{
+static int msMetadataParseRequest(cgiRequestObj *request,
+                                  metadataParamsObj *metadataparams) {
   if (!request || !metadataparams)
     return MS_FAILURE;
 
   if (request->NumParams > 0) {
-    for(int i=0; i<request->NumParams; i++) {
+    for (int i = 0; i < request->NumParams; i++) {
       if (request->ParamNames[i] && request->ParamValues[i]) {
         if (strcasecmp(request->ParamNames[i], "LAYER") == 0)
           metadataparams->pszLayer = msStrdup(request->ParamValues[i]);
@@ -917,13 +1034,13 @@ int msMetadataParseRequest(cgiRequestObj
 /*      Parse request into the params object.                           */
 /************************************************************************/
 
-void msMetadataSetGetMetadataURL(layerObj *lp, const char *url)
-{
-  char *pszMetadataURL=NULL;
+void msMetadataSetGetMetadataURL(layerObj *lp, const char *url) {
+  char *pszMetadataURL = NULL;
 
   pszMetadataURL = msStrdup(url);
   msDecodeHTMLEntities(pszMetadataURL);
-  pszMetadataURL = msStringConcatenate(pszMetadataURL, "request=GetMetadata&layer=");
+  pszMetadataURL =
+      msStringConcatenate(pszMetadataURL, "request=GetMetadata&layer=");
   pszMetadataURL = msStringConcatenate(pszMetadataURL, lp->name);
 
   msInsertHashTable(&(lp->metadata), "ows_metadataurl_href", pszMetadataURL);
diff -pruN 8.0.1-5/mapmssql2008.c 8.0.2-1/mapmssql2008.c
--- 8.0.1-5/mapmssql2008.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapmssql2008.c	2024-06-11 20:41:34.000000000 +0000
@@ -87,9 +87,9 @@ SerializationProps (bitmask) 1 byte
   0x10 = IsSingleLineSegment
   0x20 = IsLargerThanAHemisphere
 
-Point (2-4)x8 bytes, size depends on SerializationProps & HasZValues & HasMValues
-  [x][y]                  - SqlGeometry
-  [latitude][longitude]   - SqlGeography
+Point (2-4)x8 bytes, size depends on SerializationProps & HasZValues &
+HasMValues [x][y]                  - SqlGeometry [latitude][longitude]   -
+SqlGeography
 
 Figure
   [FigureAttribute][PointOffset]
@@ -145,7 +145,7 @@ SegmentType (1 byte)
 #define MSSQLGEOMETRY_WKT 2
 
 /* geometry column types */
-#define MSSQLCOLTYPE_GEOMETRY  0
+#define MSSQLCOLTYPE_GEOMETRY 0
 #define MSSQLCOLTYPE_GEOGRAPHY 1
 #define MSSQLCOLTYPE_BINARY 2
 #define MSSQLCOLTYPE_TEXT 3
@@ -176,27 +176,32 @@ SegmentType (1 byte)
 #define SMT_FIRSTLINE 2
 #define SMT_FIRSTARC 3
 
-#define ReadInt32(nPos) (*((unsigned int*)(gpi->pszData + (nPos))))
+#define ReadInt32(nPos) (*((unsigned int *)(gpi->pszData + (nPos))))
 
 #define ReadByte(nPos) (gpi->pszData[nPos])
 
-#define ReadDouble(nPos) (*((double*)(gpi->pszData + (nPos))))
+#define ReadDouble(nPos) (*((double *)(gpi->pszData + (nPos))))
 
-#define ParentOffset(iShape) (ReadInt32(gpi->nShapePos + (iShape) * 9 ))
-#define FigureOffset(iShape) (ReadInt32(gpi->nShapePos + (iShape) * 9 + 4))
-#define ShapeType(iShape) (ReadByte(gpi->nShapePos + (iShape) * 9 + 8))
+#define ParentOffset(iShape) (ReadInt32(gpi->nShapePos + (iShape)*9))
+#define FigureOffset(iShape) (ReadInt32(gpi->nShapePos + (iShape)*9 + 4))
+#define ShapeType(iShape) (ReadByte(gpi->nShapePos + (iShape)*9 + 8))
 #define SegmentType(iSegment) (ReadByte(gpi->nSegmentPos + (iSegment)))
 
-#define NextFigureOffset(iShape) (iShape + 1 < gpi->nNumShapes? FigureOffset((iShape) +1) : gpi->nNumFigures)
+#define NextFigureOffset(iShape)                                               \
+  (iShape + 1 < gpi->nNumShapes ? FigureOffset((iShape) + 1) : gpi->nNumFigures)
 
-#define FigureAttribute(iFigure) (ReadByte(gpi->nFigurePos + (iFigure) * 5))
-#define PointOffset(iFigure) (ReadInt32(gpi->nFigurePos + (iFigure) * 5 + 1))
-#define NextPointOffset(iFigure) (iFigure + 1 < gpi->nNumFigures? PointOffset((iFigure) +1) : (unsigned)gpi->nNumPoints)
+#define FigureAttribute(iFigure) (ReadByte(gpi->nFigurePos + (iFigure)*5))
+#define PointOffset(iFigure) (ReadInt32(gpi->nFigurePos + (iFigure)*5 + 1))
+#define NextPointOffset(iFigure)                                               \
+  (iFigure + 1 < gpi->nNumFigures ? PointOffset((iFigure) + 1)                 \
+                                  : (unsigned)gpi->nNumPoints)
 
 #define ReadX(iPoint) (ReadDouble(gpi->nPointPos + 16 * (iPoint)))
 #define ReadY(iPoint) (ReadDouble(gpi->nPointPos + 16 * (iPoint) + 8))
-#define ReadZ(iPoint) (ReadDouble(gpi->nPointPos + 16 * gpi->nNumPoints + 8 * (iPoint)))
-#define ReadM(iPoint) (ReadDouble(gpi->nPointPos + 24 * gpi->nNumPoints + 8 * (iPoint)))
+#define ReadZ(iPoint)                                                          \
+  (ReadDouble(gpi->nPointPos + 16 * gpi->nNumPoints + 8 * (iPoint)))
+#define ReadM(iPoint)                                                          \
+  (ReadDouble(gpi->nPointPos + 24 * gpi->nNumPoints + 8 * (iPoint)))
 
 #define FP_EPSILON 1e-12
 #define SEGMENT_ANGLE 5.0
@@ -204,7 +209,7 @@ SegmentType (1 byte)
 
 /* Native geometry parser struct */
 typedef struct msGeometryParserInfo_t {
-  unsigned char* pszData;
+  unsigned char *pszData;
   int nLen;
   /* version */
   char chVersion;
@@ -234,48 +239,58 @@ typedef struct msGeometryParserInfo_t {
   double maxy;
 } msGeometryParserInfo;
 
-/* Structure for connection to an ODBC database (Microsoft preferred way to connect to SQL Server 2005 from c/c++) */
+/* Structure for connection to an ODBC database (Microsoft preferred way to
+ * connect to SQL Server 2005 from c/c++) */
 typedef struct msODBCconn_t {
-  SQLHENV     henv;               /* ODBC HENV */
-  SQLHDBC     hdbc;               /* ODBC HDBC */
-  SQLHSTMT    hstmt;              /* ODBC HSTMNT */
-  char        errorMessage[1024]; /* Last error message if any */
+  SQLHENV henv;            /* ODBC HENV */
+  SQLHDBC hdbc;            /* ODBC HDBC */
+  SQLHSTMT hstmt;          /* ODBC HSTMNT */
+  char errorMessage[1024]; /* Last error message if any */
 } msODBCconn;
 
 typedef struct ms_MSSQL2008_layer_info_t {
-  char *sql;           /* sql query to send to DB */
-  long row_num;        /* what row is the NEXT to be read (for random access) */
-  char *geom_column; /* name of the actual geometry column parsed from the LAYER's DATA field */
-  char *geom_column_type;  /* the type of the geometry column */
-  char *geom_table;  /* the table name or sub-select decalred in the LAYER's DATA field */
-  char *urid_name;     /* name of user-specified unique identifier or OID */
-  char *user_srid;     /* zero length = calculate, non-zero means using this value! */
-  char *index_name;  /* hopefully this isn't necessary - but if the optimizer ain't cuttin' it... */
-  char *sort_spec;  /* the sort by specification which should be applied to the generated select statement */
+  char *sql;         /* sql query to send to DB */
+  long row_num;      /* what row is the NEXT to be read (for random access) */
+  char *geom_column; /* name of the actual geometry column parsed from the
+                        LAYER's DATA field */
+  char *geom_column_type; /* the type of the geometry column */
+  char *geom_table; /* the table name or sub-select decalred in the LAYER's DATA
+                       field */
+  char *urid_name;  /* name of user-specified unique identifier or OID */
+  char *
+      user_srid; /* zero length = calculate, non-zero means using this value! */
+  char *index_name; /* hopefully this isn't necessary - but if the optimizer
+                       ain't cuttin' it... */
+  char *sort_spec;  /* the sort by specification which should be applied to the
+                       generated select statement */
   int mssqlversion_major; /* the sql server major version number */
-  int paging;           /* Driver handling of pagination, enabled by default */
-  SQLSMALLINT *itemtypes; /* storing the sql field types for further reference */
-
-  msODBCconn * conn;          /* Connection to db */
-  msGeometryParserInfo gpi;   /* struct for the geometry parser */
-  int geometry_format;        /* Geometry format to be retrieved from the database */
+  int paging; /* Driver handling of pagination, enabled by default */
+  SQLSMALLINT
+  *itemtypes; /* storing the sql field types for further reference */
+
+  msODBCconn *conn;         /* Connection to db */
+  msGeometryParserInfo gpi; /* struct for the geometry parser */
+  int geometry_format; /* Geometry format to be retrieved from the database */
   tokenListNodeObjPtr current_node; /* filter expression translation */
 } msMSSQL2008LayerInfo;
 
 #define SQL_COLUMN_NAME_MAX_LENGTH 128
 #define SQL_TABLE_NAME_MAX_LENGTH 128
 
-#define DATA_ERROR_MESSAGE \
-    "%s" \
-    "Error with MSSQL2008 data variable. You specified '%s'.<br>\n" \
-    "Standard ways of specifiying are : <br>\n(1) 'geometry_column from geometry_table' <br>\n(2) 'geometry_column from (&lt;sub query&gt;) as foo using unique &lt;column name&gt; using SRID=&lt;srid#&gt;' <br><br>\n\n" \
-    "Make sure you utilize the 'using unique  &lt;column name&gt;' and 'using with &lt;index name&gt;' clauses in.\n\n<br><br>" \
-    "For more help, please see http://www.mapdotnet.com \n\n<br><br>" \
-    "mapmssql2008.c - version of 2007/7/1.\n"
+#define DATA_ERROR_MESSAGE                                                     \
+  "%s"                                                                         \
+  "Error with MSSQL2008 data variable. You specified '%s'.<br>\n"              \
+  "Standard ways of specifiying are : <br>\n(1) 'geometry_column from "        \
+  "geometry_table' <br>\n(2) 'geometry_column from (&lt;sub query&gt;) as "    \
+  "foo using unique &lt;column name&gt; using SRID=&lt;srid#&gt;' "            \
+  "<br><br>\n\n"                                                               \
+  "Make sure you utilize the 'using unique  &lt;column name&gt;' and 'using "  \
+  "with &lt;index name&gt;' clauses in.\n\n<br><br>"                           \
+  "For more help, please see http://www.mapdotnet.com \n\n<br><br>"            \
+  "mapmssql2008.c - version of 2007/7/1.\n"
 
 /* Native geometry parser code */
-void ReadPoint(msGeometryParserInfo* gpi, pointObj* p, int iPoint)
-{
+void ReadPoint(msGeometryParserInfo *gpi, pointObj *p, int iPoint) {
   if (gpi->nColType == MSSQLCOLTYPE_GEOGRAPHY) {
     p->x = ReadY(iPoint);
     p->y = ReadX(iPoint);
@@ -288,131 +303,130 @@ void ReadPoint(msGeometryParserInfo* gpi
     gpi->minx = gpi->maxx = p->x;
     gpi->miny = gpi->maxy = p->y;
   } else {
-    if (gpi->minx > p->x) gpi->minx = p->x;
-    else if (gpi->maxx < p->x) gpi->maxx = p->x;
-    if (gpi->miny > p->y) gpi->miny = p->y;
-    else if (gpi->maxy < p->y) gpi->maxy = p->y;
+    if (gpi->minx > p->x)
+      gpi->minx = p->x;
+    else if (gpi->maxx < p->x)
+      gpi->maxx = p->x;
+    if (gpi->miny > p->y)
+      gpi->miny = p->y;
+    else if (gpi->maxy < p->y)
+      gpi->maxy = p->y;
   }
 
-  if ((gpi->chProps & SP_HASZVALUES) && (gpi->chProps & SP_HASMVALUES))
-  {
+  if ((gpi->chProps & SP_HASZVALUES) && (gpi->chProps & SP_HASMVALUES)) {
     p->z = ReadZ(iPoint);
     p->m = ReadM(iPoint);
-  }
-  else if (gpi->chProps & SP_HASZVALUES)
-  {
-      p->z = ReadZ(iPoint);
-      p->m = 0.0;
-  }
-  else if (gpi->chProps & SP_HASMVALUES)
-  {
-      p->z = 0.0;
-      p->m = ReadZ(iPoint);
-  }
-  else
-  {
-      p->z = 0.0;
-      p->m = 0.0;
+  } else if (gpi->chProps & SP_HASZVALUES) {
+    p->z = ReadZ(iPoint);
+    p->m = 0.0;
+  } else if (gpi->chProps & SP_HASMVALUES) {
+    p->z = 0.0;
+    p->m = ReadZ(iPoint);
+  } else {
+    p->z = 0.0;
+    p->m = 0.0;
   }
 }
 
-int StrokeArcToLine(msGeometryParserInfo* gpi, lineObj* line, int index)
-{
-    if (index > 1) {
-        double x, y, x1, y1, x2, y2, x3, y3, dxa, dya, sxa, sya, dxb, dyb;
-        double d, sxb, syb, ox, oy, a1, a3, sa, da, a, radius;
-        int numpoints;
-        double z;
-        z = line->point[index].z; /* must be equal for arc segments */
-        /* first point */
-        x1 = line->point[index - 2].x;
-        y1 = line->point[index - 2].y;
-        /* second point */
-        x2 = line->point[index - 1].x;
-        y2 = line->point[index - 1].y;
-        /* third point */
-        x3 = line->point[index].x;
-        y3 = line->point[index].y;
-
-        sxa = (x1 + x2);
-        sya = (y1 + y2);
-        dxa = x2 - x1;
-        dya = y2 - y1;
-
-        sxb = (x2 + x3);
-        syb = (y2 + y3);
-        dxb = x3 - x2;
-        dyb = y3 - y2;
-
-        d = (dxa * dyb - dya * dxb) * 2;
-
-        if (fabs(d) < FP_EPSILON) {
-            /* points are colinear, nothing to do here */
-            return index;
-        }
-
-        /* calculating the center of circle */
-        ox = ((sya - syb) * dya * dyb + sxa * dyb * dxa - sxb * dya * dxb) / d;
-        oy = ((sxb - sxa) * dxa * dxb + syb * dyb * dxa - sya * dya * dxb) / d;
-
-        radius = sqrt((x1 - ox) * (x1 - ox) + (y1 - oy) * (y1 - oy));
-
-        /* calculating the angle to be used */
-        a1 = atan2(y1 - oy, x1 - ox);
-        a3 = atan2(y3 - oy, x3 - ox);
-
-        if (d > 0) {
-            /* draw counterclockwise */
-            if (a3 > a1) /* Wrapping past 180? */
-                sa = a3 - a1;
-            else
-                sa = a3 - a1 + 2.0 * M_PI ;
-        }
-        else {
-            if (a3 > a1) /* Wrapping past 180? */
-                sa = a3 - a1 + 2.0 * M_PI;
-            else
-                sa = a3 - a1;
-        }
-
-        numpoints = (int)floor(fabs(sa) * 180 / SEGMENT_ANGLE / M_PI);
-        if (numpoints < SEGMENT_MINPOINTS)
-            numpoints = SEGMENT_MINPOINTS;
-
-        da = sa / numpoints;
-
-        /* extend the point array */
-        line->numpoints += numpoints - 2;
-        line->point = msSmallRealloc(line->point, sizeof(pointObj) * line->numpoints);
-        --index;
-
-        a = a1 + da;
-        while (numpoints > 1) {
-            line->point[index].x = x = ox + radius * cos(a);
-            line->point[index].y = y = oy + radius * sin(a);
-            line->point[index].z = z;
-
-            /* calculate bounds */
-            if (gpi->minx > x) gpi->minx = x;
-            else if (gpi->maxx < x) gpi->maxx = x;
-            if (gpi->miny > y) gpi->miny = y;
-            else if (gpi->maxy < y) gpi->maxy = y;
-
-            a += da;
-            ++index;
-            --numpoints;
-        }
-        /* set last point */
-        line->point[index].x = x3;
-        line->point[index].y = y3;
-        line->point[index].z = z;
+int StrokeArcToLine(msGeometryParserInfo *gpi, lineObj *line, int index) {
+  if (index > 1) {
+    double x, y, x1, y1, x2, y2, x3, y3, dxa, dya, sxa, sya, dxb, dyb;
+    double d, sxb, syb, ox, oy, a1, a3, sa, da, a, radius;
+    int numpoints;
+    double z;
+    z = line->point[index].z; /* must be equal for arc segments */
+    /* first point */
+    x1 = line->point[index - 2].x;
+    y1 = line->point[index - 2].y;
+    /* second point */
+    x2 = line->point[index - 1].x;
+    y2 = line->point[index - 1].y;
+    /* third point */
+    x3 = line->point[index].x;
+    y3 = line->point[index].y;
+
+    sxa = (x1 + x2);
+    sya = (y1 + y2);
+    dxa = x2 - x1;
+    dya = y2 - y1;
+
+    sxb = (x2 + x3);
+    syb = (y2 + y3);
+    dxb = x3 - x2;
+    dyb = y3 - y2;
+
+    d = (dxa * dyb - dya * dxb) * 2;
+
+    if (fabs(d) < FP_EPSILON) {
+      /* points are colinear, nothing to do here */
+      return index;
+    }
+
+    /* calculating the center of circle */
+    ox = ((sya - syb) * dya * dyb + sxa * dyb * dxa - sxb * dya * dxb) / d;
+    oy = ((sxb - sxa) * dxa * dxb + syb * dyb * dxa - sya * dya * dxb) / d;
+
+    radius = sqrt((x1 - ox) * (x1 - ox) + (y1 - oy) * (y1 - oy));
+
+    /* calculating the angle to be used */
+    a1 = atan2(y1 - oy, x1 - ox);
+    a3 = atan2(y3 - oy, x3 - ox);
+
+    if (d > 0) {
+      /* draw counterclockwise */
+      if (a3 > a1) /* Wrapping past 180? */
+        sa = a3 - a1;
+      else
+        sa = a3 - a1 + 2.0 * M_PI;
+    } else {
+      if (a3 > a1) /* Wrapping past 180? */
+        sa = a3 - a1 + 2.0 * M_PI;
+      else
+        sa = a3 - a1;
     }
-    return index;
+
+    numpoints = (int)floor(fabs(sa) * 180 / SEGMENT_ANGLE / M_PI);
+    if (numpoints < SEGMENT_MINPOINTS)
+      numpoints = SEGMENT_MINPOINTS;
+
+    da = sa / numpoints;
+
+    /* extend the point array */
+    line->numpoints += numpoints - 2;
+    line->point =
+        msSmallRealloc(line->point, sizeof(pointObj) * line->numpoints);
+    --index;
+
+    a = a1 + da;
+    while (numpoints > 1) {
+      line->point[index].x = x = ox + radius * cos(a);
+      line->point[index].y = y = oy + radius * sin(a);
+      line->point[index].z = z;
+
+      /* calculate bounds */
+      if (gpi->minx > x)
+        gpi->minx = x;
+      else if (gpi->maxx < x)
+        gpi->maxx = x;
+      if (gpi->miny > y)
+        gpi->miny = y;
+      else if (gpi->maxy < y)
+        gpi->maxy = y;
+
+      a += da;
+      ++index;
+      --numpoints;
+    }
+    /* set last point */
+    line->point[index].x = x3;
+    line->point[index].y = y3;
+    line->point[index].z = z;
+  }
+  return index;
 }
 
-int ParseSqlGeometry(msMSSQL2008LayerInfo* layerinfo, shapeObj *shape)
-{
-  msGeometryParserInfo* gpi = &layerinfo->gpi;
+int ParseSqlGeometry(msMSSQL2008LayerInfo *layerinfo, shapeObj *shape) {
+  msGeometryParserInfo *gpi = &layerinfo->gpi;
 
   gpi->nNumPointsRead = 0;
 
@@ -435,13 +449,13 @@ int ParseSqlGeometry(msMSSQL2008LayerInf
 
   gpi->nPointSize = 16;
 
-  if ( gpi->chProps & SP_HASMVALUES )
+  if (gpi->chProps & SP_HASMVALUES)
     gpi->nPointSize += 8;
 
-  if ( gpi->chProps & SP_HASZVALUES )
+  if (gpi->chProps & SP_HASZVALUES)
     gpi->nPointSize += 8;
 
-  if ( gpi->chProps & SP_ISSINGLEPOINT ) {
+  if (gpi->chProps & SP_ISSINGLEPOINT) {
     // single point geometry
     gpi->nNumPoints = 1;
     if (gpi->nLen < 6 + gpi->nPointSize) {
@@ -450,14 +464,14 @@ int ParseSqlGeometry(msMSSQL2008LayerInf
     }
 
     shape->type = MS_SHAPE_POINT;
-    shape->line = (lineObj *) msSmallMalloc(sizeof(lineObj));
+    shape->line = (lineObj *)msSmallMalloc(sizeof(lineObj));
     shape->numlines = 1;
-    shape->line[0].point = (pointObj *) msSmallMalloc(sizeof(pointObj));
+    shape->line[0].point = (pointObj *)msSmallMalloc(sizeof(pointObj));
     shape->line[0].numpoints = 1;
     gpi->nPointPos = 6;
 
     ReadPoint(gpi, &shape->line[0].point[0], 0);
-  } else if ( gpi->chProps & SP_ISSINGLELINESEGMENT ) {
+  } else if (gpi->chProps & SP_ISSINGLELINESEGMENT) {
     // single line segment with 2 points
     gpi->nNumPoints = 2;
     if (gpi->nLen < 6 + 2 * gpi->nPointSize) {
@@ -466,9 +480,9 @@ int ParseSqlGeometry(msMSSQL2008LayerInf
     }
 
     shape->type = MS_SHAPE_LINE;
-    shape->line = (lineObj *) msSmallMalloc(sizeof(lineObj));
+    shape->line = (lineObj *)msSmallMalloc(sizeof(lineObj));
     shape->numlines = 1;
-    shape->line[0].point = (pointObj *) msSmallMalloc(sizeof(pointObj) * 2);
+    shape->line[0].point = (pointObj *)msSmallMalloc(sizeof(pointObj) * 2);
     shape->line[0].numpoints = 2;
     gpi->nPointPos = 6;
 
@@ -479,7 +493,7 @@ int ParseSqlGeometry(msMSSQL2008LayerInf
     // complex geometries
     gpi->nNumPoints = ReadInt32(6);
 
-    if ( gpi->nNumPoints <= 0 ) {
+    if (gpi->nNumPoints <= 0) {
       return NOERROR;
     }
 
@@ -496,7 +510,7 @@ int ParseSqlGeometry(msMSSQL2008LayerInf
 
     gpi->nNumFigures = ReadInt32(gpi->nFigurePos - 4);
 
-    if ( gpi->nNumFigures <= 0 ) {
+    if (gpi->nNumFigures <= 0) {
       return NOERROR;
     }
 
@@ -515,12 +529,12 @@ int ParseSqlGeometry(msMSSQL2008LayerInf
       return NOT_ENOUGH_DATA;
     }
 
-    if ( gpi->nNumShapes <= 0 ) {
+    if (gpi->nNumShapes <= 0) {
       return NOERROR;
     }
 
     // pick up the root shape
-    if ( ParentOffset(0) != 0xFFFFFFFF) {
+    if (ParentOffset(0) != 0xFFFFFFFF) {
       msDebug("ParseSqlGeometry CORRUPT_DATA\n");
       return CORRUPT_DATA;
     }
@@ -531,19 +545,20 @@ int ParseSqlGeometry(msMSSQL2008LayerInf
       if (shapeType == ST_POINT || shapeType == ST_MULTIPOINT) {
         shape->type = MS_SHAPE_POINT;
         break;
-      } else if (shapeType == ST_LINESTRING || shapeType == ST_MULTILINESTRING || 
-                 shapeType == ST_CIRCULARSTRING || shapeType == ST_COMPOUNDCURVE) {
+      } else if (shapeType == ST_LINESTRING ||
+                 shapeType == ST_MULTILINESTRING ||
+                 shapeType == ST_CIRCULARSTRING ||
+                 shapeType == ST_COMPOUNDCURVE) {
         shape->type = MS_SHAPE_LINE;
         break;
-      } else if (shapeType == ST_POLYGON || shapeType == ST_MULTIPOLYGON || 
-                 shapeType == ST_CURVEPOLYGON)
-      {
+      } else if (shapeType == ST_POLYGON || shapeType == ST_MULTIPOLYGON ||
+                 shapeType == ST_CURVEPOLYGON) {
         shape->type = MS_SHAPE_POLYGON;
         break;
       }
     }
 
-    shape->line = (lineObj *) msSmallMalloc(sizeof(lineObj) * gpi->nNumFigures);
+    shape->line = (lineObj *)msSmallMalloc(sizeof(lineObj) * gpi->nNumFigures);
     shape->numlines = gpi->nNumFigures;
     gpi->nNumSegments = 0;
 
@@ -553,61 +568,63 @@ int ParseSqlGeometry(msMSSQL2008LayerInf
       iPoint = PointOffset(iFigure);
       iNextPoint = NextPointOffset(iFigure);
 
-      shape->line[iFigure].point = (pointObj *) msSmallMalloc(sizeof(pointObj)*(iNextPoint - iPoint));
+      shape->line[iFigure].point =
+          (pointObj *)msSmallMalloc(sizeof(pointObj) * (iNextPoint - iPoint));
       shape->line[iFigure].numpoints = iNextPoint - iPoint;
       i = 0;
 
       if (gpi->chVersion == 0x02 && FigureAttribute(iFigure) >= 0x02) {
-          int nPointPrepared = 0;
-          lineObj* line = &shape->line[iFigure];
-          if (FigureAttribute(iFigure) == 0x03) {
-              if (gpi->nNumSegments == 0) {
-                  /* position of the segment types */
-                  gpi->nSegmentPos = gpi->nShapePos + 9 * gpi->nNumShapes + 4;
-                  gpi->nNumSegments = ReadInt32(gpi->nSegmentPos - 4);
-                  if (gpi->nLen < gpi->nSegmentPos + gpi->nNumSegments) {
-                      msDebug("ParseSqlGeometry NOT_ENOUGH_DATA\n");
-                      return NOT_ENOUGH_DATA;
-                  }
-                  iSegment = 0;
-              }             
-             
-              while (iPoint < iNextPoint && iSegment < gpi->nNumSegments) {
-                  ReadPoint(gpi, &line->point[i], iPoint);
-                  ++iPoint;
-                  ++nPointPrepared;
-
-                  if (nPointPrepared == 2 && (SegmentType(iSegment) == SMT_FIRSTLINE || SegmentType(iSegment) == SMT_LINE)) {
-                      ++iSegment;
-                      nPointPrepared = 1;
-                  }
-                  else if (nPointPrepared == 3 && (SegmentType(iSegment) == SMT_FIRSTARC || SegmentType(iSegment) == SMT_ARC)) {
-                      i = StrokeArcToLine(gpi, line, i);
-                      ++iSegment;
-                      nPointPrepared = 1;
-                  }
-                  ++i;
-              }
+        int nPointPrepared = 0;
+        lineObj *line = &shape->line[iFigure];
+        if (FigureAttribute(iFigure) == 0x03) {
+          if (gpi->nNumSegments == 0) {
+            /* position of the segment types */
+            gpi->nSegmentPos = gpi->nShapePos + 9 * gpi->nNumShapes + 4;
+            gpi->nNumSegments = ReadInt32(gpi->nSegmentPos - 4);
+            if (gpi->nLen < gpi->nSegmentPos + gpi->nNumSegments) {
+              msDebug("ParseSqlGeometry NOT_ENOUGH_DATA\n");
+              return NOT_ENOUGH_DATA;
+            }
+            iSegment = 0;
           }
-          else {
-              while (iPoint < iNextPoint) {
-                  ReadPoint(gpi, &line->point[i], iPoint);
-                  ++iPoint;
-                  ++nPointPrepared;
-                  if (nPointPrepared == 3) {
-                      i = StrokeArcToLine(gpi, line, i);
-                      nPointPrepared = 1;
-                  }
-                  ++i;
-              }
+
+          while (iPoint < iNextPoint && iSegment < gpi->nNumSegments) {
+            ReadPoint(gpi, &line->point[i], iPoint);
+            ++iPoint;
+            ++nPointPrepared;
+
+            if (nPointPrepared == 2 &&
+                (SegmentType(iSegment) == SMT_FIRSTLINE ||
+                 SegmentType(iSegment) == SMT_LINE)) {
+              ++iSegment;
+              nPointPrepared = 1;
+            } else if (nPointPrepared == 3 &&
+                       (SegmentType(iSegment) == SMT_FIRSTARC ||
+                        SegmentType(iSegment) == SMT_ARC)) {
+              i = StrokeArcToLine(gpi, line, i);
+              ++iSegment;
+              nPointPrepared = 1;
+            }
+            ++i;
           }
-      }
-      else {
+        } else {
           while (iPoint < iNextPoint) {
-              ReadPoint(gpi, &shape->line[iFigure].point[i], iPoint);
-              ++iPoint;
-              ++i;
+            ReadPoint(gpi, &line->point[i], iPoint);
+            ++iPoint;
+            ++nPointPrepared;
+            if (nPointPrepared == 3) {
+              i = StrokeArcToLine(gpi, line, i);
+              nPointPrepared = 1;
+            }
+            ++i;
           }
+        }
+      } else {
+        while (iPoint < iNextPoint) {
+          ReadPoint(gpi, &shape->line[iFigure].point[i], iPoint);
+          ++iPoint;
+          ++i;
+        }
       }
     }
   }
@@ -623,22 +640,20 @@ int ParseSqlGeometry(msMSSQL2008LayerInf
 
 /* MS SQL driver code*/
 
-msMSSQL2008LayerInfo *getMSSQL2008LayerInfo(const layerObj *layer)
-{
+msMSSQL2008LayerInfo *getMSSQL2008LayerInfo(const layerObj *layer) {
   return layer->layerinfo;
 }
 
-void setMSSQL2008LayerInfo(layerObj *layer, msMSSQL2008LayerInfo *MSSQL2008layerinfo)
-{
-  layer->layerinfo = (void*) MSSQL2008layerinfo;
+void setMSSQL2008LayerInfo(layerObj *layer,
+                           msMSSQL2008LayerInfo *MSSQL2008layerinfo) {
+  layer->layerinfo = (void *)MSSQL2008layerinfo;
 }
 
-void handleSQLError(layerObj *layer)
-{
-  SQLCHAR       SqlState[6], Msg[SQL_MAX_MESSAGE_LENGTH];
-  SQLINTEGER     NativeError;
-  SQLSMALLINT   i, MsgLen;
-  SQLRETURN  rc;
+void handleSQLError(layerObj *layer) {
+  SQLCHAR SqlState[6], Msg[SQL_MAX_MESSAGE_LENGTH];
+  SQLINTEGER NativeError;
+  SQLSMALLINT i, MsgLen;
+  SQLRETURN rc;
   msMSSQL2008LayerInfo *layerinfo = getMSSQL2008LayerInfo(layer);
 
   if (layerinfo == NULL)
@@ -646,9 +661,10 @@ void handleSQLError(layerObj *layer)
 
   // Get the status records.
   i = 1;
-  while ((rc = SQLGetDiagRec(SQL_HANDLE_STMT, layerinfo->conn->hstmt, i, SqlState, &NativeError,
-                             Msg, sizeof(Msg), &MsgLen)) != SQL_NO_DATA) {
-    if(layer->debug) {
+  while ((rc = SQLGetDiagRec(SQL_HANDLE_STMT, layerinfo->conn->hstmt, i,
+                             SqlState, &NativeError, Msg, sizeof(Msg),
+                             &MsgLen)) != SQL_NO_DATA) {
+    if (layer->debug) {
       msDebug("SQLError: %s\n", Msg);
     }
     i++;
@@ -656,33 +672,32 @@ void handleSQLError(layerObj *layer)
 }
 
 /* TODO Take a look at glibc's strcasestr */
-static char *strstrIgnoreCase(const char *haystack, const char *needle)
-{
-  char    *hay_lower;
-  char    *needle_lower;
-  size_t  len_hay,len_need, match;
-  int    found = MS_FALSE;
-  char    *loc;
+static char *strstrIgnoreCase(const char *haystack, const char *needle) {
+  char *hay_lower;
+  char *needle_lower;
+  size_t len_hay, len_need, match;
+  int found = MS_FALSE;
+  char *loc;
 
   len_hay = strlen(haystack);
   len_need = strlen(needle);
 
-  hay_lower = (char*) msSmallMalloc(len_hay + 1);
-  needle_lower =(char*) msSmallMalloc(len_need + 1);
+  hay_lower = (char *)msSmallMalloc(len_hay + 1);
+  needle_lower = (char *)msSmallMalloc(len_need + 1);
 
   size_t t;
-  for(t = 0; t < len_hay; t++) {
+  for (t = 0; t < len_hay; t++) {
     hay_lower[t] = (char)tolower(haystack[t]);
   }
   hay_lower[t] = 0;
 
-  for(t = 0; t < len_need; t++) {
+  for (t = 0; t < len_need; t++) {
     needle_lower[t] = (char)tolower(needle[t]);
   }
   needle_lower[t] = 0;
 
   loc = strstr(hay_lower, needle_lower);
-  if(loc) {
+  if (loc) {
     match = loc - hay_lower;
     found = MS_TRUE;
   }
@@ -690,15 +705,18 @@ static char *strstrIgnoreCase(const char
   msFree(hay_lower);
   msFree(needle_lower);
 
-  return (char *) (found == MS_FALSE ? NULL : haystack + match);
+  return (char *)(found == MS_FALSE ? NULL : haystack + match);
 }
 
-static int msMSSQL2008LayerParseData(layerObj *layer, char **geom_column_name, char **geom_column_type, char **table_name, char **urid_name, char **user_srid, char **index_name, char **sort_spec, int debug);
+static int msMSSQL2008LayerParseData(layerObj *layer, char **geom_column_name,
+                                     char **geom_column_type, char **table_name,
+                                     char **urid_name, char **user_srid,
+                                     char **index_name, char **sort_spec,
+                                     int debug);
 
 /* Close connection and handles */
-static void msMSSQL2008CloseConnection(void *conn_handle)
-{
-  msODBCconn * conn = (msODBCconn *) conn_handle;
+static void msMSSQL2008CloseConnection(void *conn_handle) {
+  msODBCconn *conn = (msODBCconn *)conn_handle;
 
   if (!conn) {
     return;
@@ -719,69 +737,72 @@ static void msMSSQL2008CloseConnection(v
 }
 
 /* Set the error string for the connection */
-static void setConnError(msODBCconn *conn)
-{
+static void setConnError(msODBCconn *conn) {
   SQLSMALLINT len;
 
-  SQLGetDiagField(SQL_HANDLE_DBC, conn->hdbc, 1, SQL_DIAG_MESSAGE_TEXT, (SQLPOINTER) conn->errorMessage, sizeof(conn->errorMessage), &len);
+  SQLGetDiagField(SQL_HANDLE_DBC, conn->hdbc, 1, SQL_DIAG_MESSAGE_TEXT,
+                  (SQLPOINTER)conn->errorMessage, sizeof(conn->errorMessage),
+                  &len);
 
   conn->errorMessage[len] = 0;
 }
 
 #ifdef USE_ICONV
-static SQLWCHAR* convertCwchartToSQLWCHAR(const wchar_t* inStr)
-{
-    SQLWCHAR* outStr;
-    int i, len;
-    for( len = 0; inStr[len] != 0; ++len )
-    {
-        /* do nothing */
-    }
-    outStr = (SQLWCHAR*)msSmallMalloc(sizeof(SQLWCHAR) * (len + 1));
-    for( i = 0; i <= len; i++ )
-    {
-        outStr[i] = (SQLWCHAR)inStr[i];
-    }
-    return outStr;
+static SQLWCHAR *convertCwchartToSQLWCHAR(const wchar_t *inStr) {
+  SQLWCHAR *outStr;
+  int i, len;
+  for (len = 0; inStr[len] != 0; ++len) {
+    /* do nothing */
+  }
+  outStr = (SQLWCHAR *)msSmallMalloc(sizeof(SQLWCHAR) * (len + 1));
+  for (i = 0; i <= len; i++) {
+    outStr[i] = (SQLWCHAR)inStr[i];
+  }
+  return outStr;
 }
 #endif
 
 /* Connect to db */
-static msODBCconn * mssql2008Connect(const char * connString)
-{
+static msODBCconn *mssql2008Connect(const char *connString) {
   SQLSMALLINT outConnStringLen;
   SQLRETURN rc;
-  msODBCconn * conn = msSmallMalloc(sizeof(msODBCconn));
+  msODBCconn *conn = msSmallMalloc(sizeof(msODBCconn));
   char fullConnString[1024];
 
   memset(conn, 0, sizeof(*conn));
 
   SQLAllocHandle(SQL_HANDLE_ENV, SQL_NULL_HANDLE, &conn->henv);
 
-  SQLSetEnvAttr(conn->henv, SQL_ATTR_ODBC_VERSION, (SQLPOINTER) SQL_OV_ODBC3, 0);
+  SQLSetEnvAttr(conn->henv, SQL_ATTR_ODBC_VERSION, (SQLPOINTER)SQL_OV_ODBC3, 0);
 
   SQLAllocHandle(SQL_HANDLE_DBC, conn->henv, &conn->hdbc);
 
-  if (strcasestr(connString, "DRIVER=") == 0)
-  {
-      snprintf(fullConnString, sizeof(fullConnString), "DRIVER={SQL Server};%s", connString);
+  if (strcasestr(connString, "DRIVER=") == 0) {
+    snprintf(fullConnString, sizeof(fullConnString), "DRIVER={SQL Server};%s",
+             connString);
 
-      connString = fullConnString;
+    connString = fullConnString;
   }
 
   {
 #ifdef USE_ICONV
-      wchar_t *decodedConnString = msConvertWideStringFromUTF8(connString, "UCS-2LE");
-      SQLWCHAR outConnString[1024];
-      SQLWCHAR* decodedConnStringSQLWCHAR = convertCwchartToSQLWCHAR(decodedConnString);
-      rc = SQLDriverConnectW(conn->hdbc, NULL, decodedConnStringSQLWCHAR, SQL_NTS, outConnString, 1024, &outConnStringLen, SQL_DRIVER_NOPROMPT);
-      msFree(decodedConnString);
-      msFree(decodedConnStringSQLWCHAR);
+    wchar_t *decodedConnString =
+        msConvertWideStringFromUTF8(connString, "UCS-2LE");
+    SQLWCHAR outConnString[1024];
+    SQLWCHAR *decodedConnStringSQLWCHAR =
+        convertCwchartToSQLWCHAR(decodedConnString);
+    rc = SQLDriverConnectW(conn->hdbc, NULL, decodedConnStringSQLWCHAR, SQL_NTS,
+                           outConnString, 1024, &outConnStringLen,
+                           SQL_DRIVER_NOPROMPT);
+    msFree(decodedConnString);
+    msFree(decodedConnStringSQLWCHAR);
 #else
-      SQLCHAR outConnString[1024];
-      rc = SQLDriverConnect(conn->hdbc, NULL, (SQLCHAR*)connString, SQL_NTS, outConnString, 1024, &outConnStringLen, SQL_DRIVER_NOPROMPT);
+    SQLCHAR outConnString[1024];
+    rc = SQLDriverConnect(conn->hdbc, NULL, (SQLCHAR *)connString, SQL_NTS,
+                          outConnString, 1024, &outConnStringLen,
+                          SQL_DRIVER_NOPROMPT);
 #endif
-  }  
+  }
 
   if (rc != SQL_SUCCESS && rc != SQL_SUCCESS_WITH_INFO) {
     setConnError(conn);
@@ -795,18 +816,18 @@ static msODBCconn * mssql2008Connect(con
 }
 
 /* Set the error string for the statement execution */
-static void setStmntError(msODBCconn *conn)
-{
+static void setStmntError(msODBCconn *conn) {
   SQLSMALLINT len;
 
-  SQLGetDiagField(SQL_HANDLE_STMT, conn->hstmt, 1, SQL_DIAG_MESSAGE_TEXT, (SQLPOINTER) conn->errorMessage, sizeof(conn->errorMessage), &len);
+  SQLGetDiagField(SQL_HANDLE_STMT, conn->hstmt, 1, SQL_DIAG_MESSAGE_TEXT,
+                  (SQLPOINTER)conn->errorMessage, sizeof(conn->errorMessage),
+                  &len);
 
   conn->errorMessage[len] = 0;
 }
 
 /* Execute SQL against connection. Set error string  if failed */
-static int executeSQL(msODBCconn *conn, const char * sql)
-{
+static int executeSQL(msODBCconn *conn, const char *sql) {
   SQLRETURN rc;
 
   SQLCloseCursor(conn->hstmt);
@@ -814,13 +835,13 @@ static int executeSQL(msODBCconn *conn,
 #ifdef USE_ICONV
   {
     wchar_t *decodedSql = msConvertWideStringFromUTF8(sql, "UCS-2LE");
-    SQLWCHAR* decodedSqlSQLWCHAR = convertCwchartToSQLWCHAR(decodedSql);
+    SQLWCHAR *decodedSqlSQLWCHAR = convertCwchartToSQLWCHAR(decodedSql);
     rc = SQLExecDirectW(conn->hstmt, decodedSqlSQLWCHAR, SQL_NTS);
     msFree(decodedSql);
     msFree(decodedSqlSQLWCHAR);
   }
 #else
-  rc = SQLExecDirect(conn->hstmt, (SQLCHAR *) sql, SQL_NTS);
+  rc = SQLExecDirect(conn->hstmt, (SQLCHAR *)sql, SQL_NTS);
 #endif
 
   if (rc == SQL_SUCCESS || rc == SQL_SUCCESS_WITH_INFO) {
@@ -832,8 +853,9 @@ static int executeSQL(msODBCconn *conn,
 }
 
 /* Get columns name from query results */
-static int columnName(msODBCconn *conn, int index, char *buffer, int bufferLength, layerObj *layer, char pass_field_def, SQLSMALLINT *itemType)
-{
+static int columnName(msODBCconn *conn, int index, char *buffer,
+                      int bufferLength, layerObj *layer, char pass_field_def,
+                      SQLSMALLINT *itemType) {
   SQLRETURN rc;
 
   SQLCHAR columnName[SQL_COLUMN_NAME_MAX_LENGTH + 1];
@@ -843,16 +865,9 @@ static int columnName(msODBCconn *conn,
   SQLSMALLINT decimalDigits;
   SQLSMALLINT nullable;
 
-  rc = SQLDescribeCol(
-         conn->hstmt,
-         (SQLUSMALLINT)index,
-         columnName,
-         SQL_COLUMN_NAME_MAX_LENGTH,
-         &columnNameLen,
-         &dataType,
-         &columnSize,
-         &decimalDigits,
-         &nullable);
+  rc = SQLDescribeCol(conn->hstmt, (SQLUSMALLINT)index, columnName,
+                      SQL_COLUMN_NAME_MAX_LENGTH, &columnNameLen, &dataType,
+                      &columnSize, &decimalDigits, &nullable);
 
   if (rc == SQL_SUCCESS || rc == SQL_SUCCESS_WITH_INFO) {
     if (bufferLength < SQL_COLUMN_NAME_MAX_LENGTH + 1)
@@ -869,50 +884,51 @@ static int columnName(msODBCconn *conn,
       gml_width[0] = '\0';
       gml_precision[0] = '\0';
 
-      switch( dataType ) {
-        case SQL_INTEGER:
-        case SQL_SMALLINT:
-        case SQL_TINYINT:
-          gml_type = "Integer";
-          break;
-
-        case SQL_BIGINT:
-          gml_type = "Long";
-          break;
-
-        case SQL_REAL:
-        case SQL_FLOAT:
-        case SQL_DOUBLE:
-        case SQL_DECIMAL:
-        case SQL_NUMERIC:
-          gml_type = "Real";
-          if( decimalDigits > 0 )
-            sprintf( gml_precision, "%d", decimalDigits );
-          break;
-
-        case SQL_TYPE_DATE:
-          gml_type = "Date";
-          break;
-        case SQL_TYPE_TIME:
-          gml_type = "Time";
-          break;
-        case SQL_TYPE_TIMESTAMP:
-          gml_type = "DateTime";
-          break;
-
-        case SQL_BIT:
-          gml_type = "Boolean";
-          break;
-
-        default:
-          gml_type = "Character";
-          break;
+      switch (dataType) {
+      case SQL_INTEGER:
+      case SQL_SMALLINT:
+      case SQL_TINYINT:
+        gml_type = "Integer";
+        break;
+
+      case SQL_BIGINT:
+        gml_type = "Long";
+        break;
+
+      case SQL_REAL:
+      case SQL_FLOAT:
+      case SQL_DOUBLE:
+      case SQL_DECIMAL:
+      case SQL_NUMERIC:
+        gml_type = "Real";
+        if (decimalDigits > 0)
+          sprintf(gml_precision, "%d", decimalDigits);
+        break;
+
+      case SQL_TYPE_DATE:
+        gml_type = "Date";
+        break;
+      case SQL_TYPE_TIME:
+        gml_type = "Time";
+        break;
+      case SQL_TYPE_TIMESTAMP:
+        gml_type = "DateTime";
+        break;
+
+      case SQL_BIT:
+        gml_type = "Boolean";
+        break;
+
+      default:
+        gml_type = "Character";
+        break;
       }
 
-      if( columnSize > 0 )
-            sprintf( gml_width, "%u", (unsigned int)columnSize );
+      if (columnSize > 0)
+        sprintf(gml_width, "%u", (unsigned int)columnSize);
 
-      msUpdateGMLFieldMetadata(layer, buffer, gml_type, gml_width, gml_precision, (const short) nullable);
+      msUpdateGMLFieldMetadata(layer, buffer, gml_type, gml_width,
+                               gml_precision, (const short)nullable);
     }
     return 1;
   } else {
@@ -921,38 +937,43 @@ static int columnName(msODBCconn *conn,
   }
 }
 
-/* open up a connection to the MS SQL 2008 database using the connection string in layer->connection */
-/* ie. "driver=<driver>;server=<server>;database=<database>;integrated security=?;user id=<username>;password=<password>" */
-int msMSSQL2008LayerOpen(layerObj *layer)
-{
-  msMSSQL2008LayerInfo  *layerinfo;
+/* open up a connection to the MS SQL 2008 database using the connection string
+ * in layer->connection */
+/* ie. "driver=<driver>;server=<server>;database=<database>;integrated
+ * security=?;user id=<username>;password=<password>" */
+int msMSSQL2008LayerOpen(layerObj *layer) {
+  msMSSQL2008LayerInfo *layerinfo;
   char *conn_decrypted = NULL;
 
-  if(layer->debug) {
+  if (layer->debug) {
     msDebug("msMSSQL2008LayerOpen called datastatement: %s\n", layer->data);
   }
 
-  if(getMSSQL2008LayerInfo(layer)) {
-    if(layer->debug) {
+  if (getMSSQL2008LayerInfo(layer)) {
+    if (layer->debug) {
       msDebug("msMSSQL2008LayerOpen :: layer is already open!!\n");
     }
-    return MS_SUCCESS;  /* already open */
+    return MS_SUCCESS; /* already open */
   }
 
-  if(!layer->data) {
-    msSetError(MS_QUERYERR, DATA_ERROR_MESSAGE, "msMSSQL2008LayerOpen()", "", "Error parsing MSSQL2008 data variable: nothing specified in DATA statement.<br><br>\n\nMore Help:<br><br>\n\n");
+  if (!layer->data) {
+    msSetError(MS_QUERYERR, DATA_ERROR_MESSAGE, "msMSSQL2008LayerOpen()", "",
+               "Error parsing MSSQL2008 data variable: nothing specified in "
+               "DATA statement.<br><br>\n\nMore Help:<br><br>\n\n");
 
     return MS_FAILURE;
   }
 
-  if(!layer->connection) {
-    msSetError( MS_QUERYERR, "MSSQL connection parameter not specified.", "msMSSQL2008LayerOpen()");
+  if (!layer->connection) {
+    msSetError(MS_QUERYERR, "MSSQL connection parameter not specified.",
+               "msMSSQL2008LayerOpen()");
     return MS_FAILURE;
   }
 
   /* have to setup a connection to the database */
 
-  layerinfo = (msMSSQL2008LayerInfo*) msSmallMalloc(sizeof(msMSSQL2008LayerInfo));
+  layerinfo =
+      (msMSSQL2008LayerInfo *)msSmallMalloc(sizeof(msMSSQL2008LayerInfo));
 
   layerinfo->sql = NULL; /* calc later */
   layerinfo->row_num = 0;
@@ -968,17 +989,17 @@ int msMSSQL2008LayerOpen(layerObj *layer
   layerinfo->mssqlversion_major = 0;
   layerinfo->paging = MS_TRUE;
 
-  layerinfo->conn = (msODBCconn *) msConnPoolRequest(layer);
+  layerinfo->conn = (msODBCconn *)msConnPoolRequest(layer);
 
-  if(!layerinfo->conn) {
-    if(layer->debug) {
+  if (!layerinfo->conn) {
+    if (layer->debug) {
       msDebug("MSMSSQL2008LayerOpen -- shared connection not available.\n");
     }
 
     /* Decrypt any encrypted token in connection and attempt to connect */
     conn_decrypted = msDecryptStringTokens(layer->map, layer->connection);
     if (conn_decrypted == NULL) {
-      return(MS_FAILURE);  /* An error should already have been produced */
+      return (MS_FAILURE); /* An error should already have been produced */
     }
 
     layerinfo->conn = mssql2008Connect(conn_decrypted);
@@ -986,26 +1007,34 @@ int msMSSQL2008LayerOpen(layerObj *layer
     msFree(conn_decrypted);
     conn_decrypted = NULL;
 
-    if(!layerinfo->conn || layerinfo->conn->errorMessage[0]) {
+    if (!layerinfo->conn || layerinfo->conn->errorMessage[0]) {
       char *errMess = "Out of memory";
 
       if (layer->debug)
-          msDebug("MSMSSQL2008LayerOpen: Connection failure.\n");
+        msDebug("MSMSSQL2008LayerOpen: Connection failure.\n");
 
       if (layerinfo->conn) {
         errMess = layerinfo->conn->errorMessage;
       }
 
-      msDebug("Couldn't make connection to MS SQL Server with connect string '%s'.\n"
-                 "Error reported was '%s'.\n\n"
-                 "This error occured when trying to make a connection to the specified SQL server.\n"
-                 "Most commonly this is caused by: \n"
-                 "(1) incorrect connection string \n"
-                 "(2) you didn't specify a 'user id=...' in your connection string \n"
-                 "(3) SQL server isnt running \n"
-                 "(4) TCPIP not enabled for SQL Client or server \n\n",
-                 layer->connection, errMess);
-      msSetError(MS_QUERYERR, "Database connection failed. Check server logs for more details. Is SQL Server running? Is it allowing connections? Does the specified user exist? Is the password valid? Is the database on the standard port?", "MSMSSQL2008LayerOpen()");
+      msDebug(
+          "Couldn't make connection to MS SQL Server with connect string "
+          "'%s'.\n"
+          "Error reported was '%s'.\n\n"
+          "This error occured when trying to make a connection to the "
+          "specified SQL server.\n"
+          "Most commonly this is caused by: \n"
+          "(1) incorrect connection string \n"
+          "(2) you didn't specify a 'user id=...' in your connection string \n"
+          "(3) SQL server isnt running \n"
+          "(4) TCPIP not enabled for SQL Client or server \n\n",
+          layer->connection, errMess);
+      msSetError(MS_QUERYERR,
+                 "Database connection failed. Check server logs for more "
+                 "details. Is SQL Server running? Is it allowing connections? "
+                 "Does the specified user exist? Is the password valid? Is the "
+                 "database on the standard port?",
+                 "MSMSSQL2008LayerOpen()");
 
       msMSSQL2008CloseConnection(layerinfo->conn);
       msFree(layerinfo);
@@ -1017,13 +1046,18 @@ int msMSSQL2008LayerOpen(layerObj *layer
 
   setMSSQL2008LayerInfo(layer, layerinfo);
 
-  if (msMSSQL2008LayerParseData(layer, &layerinfo->geom_column, &layerinfo->geom_column_type, &layerinfo->geom_table, &layerinfo->urid_name, &layerinfo->user_srid, &layerinfo->index_name, &layerinfo->sort_spec, layer->debug) != MS_SUCCESS) {
-    msSetError( MS_QUERYERR, "Could not parse the layer data", "msMSSQL2008LayerOpen()");
+  if (msMSSQL2008LayerParseData(
+          layer, &layerinfo->geom_column, &layerinfo->geom_column_type,
+          &layerinfo->geom_table, &layerinfo->urid_name, &layerinfo->user_srid,
+          &layerinfo->index_name, &layerinfo->sort_spec,
+          layer->debug) != MS_SUCCESS) {
+    msSetError(MS_QUERYERR, "Could not parse the layer data",
+               "msMSSQL2008LayerOpen()");
     return MS_FAILURE;
   }
 
   /* identify the geometry transfer type */
-  if (msLayerGetProcessingKey( layer, "MSSQL_READ_WKB" ) != NULL)
+  if (msLayerGetProcessingKey(layer, "MSSQL_READ_WKB") != NULL)
     layerinfo->geometry_format = MSSQLGEOMETRY_WKB;
   else {
     layerinfo->geometry_format = MSSQLGEOMETRY_NATIVE;
@@ -1037,75 +1071,72 @@ int msMSSQL2008LayerOpen(layerObj *layer
 }
 
 /* Return MS_TRUE if layer is open, MS_FALSE otherwise. */
-int msMSSQL2008LayerIsOpen(layerObj *layer)
-{
+int msMSSQL2008LayerIsOpen(layerObj *layer) {
   return getMSSQL2008LayerInfo(layer) ? MS_TRUE : MS_FALSE;
 }
 
-
 /* Free the itemindexes array in a layer. */
-void msMSSQL2008LayerFreeItemInfo(layerObj *layer)
-{
-  if(layer->debug) {
+void msMSSQL2008LayerFreeItemInfo(layerObj *layer) {
+  if (layer->debug) {
     msDebug("msMSSQL2008LayerFreeItemInfo called\n");
   }
 
-  if(layer->iteminfo) {
+  if (layer->iteminfo) {
     msFree(layer->iteminfo);
   }
 
   layer->iteminfo = NULL;
 }
 
-
 /* allocate the iteminfo index array - same order as the item list */
-int msMSSQL2008LayerInitItemInfo(layerObj *layer)
-{
-  int     i;
-  int     *itemindexes ;
+int msMSSQL2008LayerInitItemInfo(layerObj *layer) {
+  int i;
+  int *itemindexes;
 
   if (layer->debug) {
     msDebug("msMSSQL2008LayerInitItemInfo called\n");
   }
 
-  if(layer->numitems == 0) {
+  if (layer->numitems == 0) {
     return MS_SUCCESS;
   }
 
   msFree(layer->iteminfo);
 
-  layer->iteminfo = (int *) msSmallMalloc(sizeof(int) * layer->numitems);
+  layer->iteminfo = (int *)msSmallMalloc(sizeof(int) * layer->numitems);
 
-  itemindexes = (int*)layer->iteminfo;
+  itemindexes = (int *)layer->iteminfo;
 
-  for(i = 0; i < layer->numitems; i++) {
-    itemindexes[i] = i; /* last one is always the geometry one - the rest are non-geom */
+  for (i = 0; i < layer->numitems; i++) {
+    itemindexes[i] =
+        i; /* last one is always the geometry one - the rest are non-geom */
   }
 
   return MS_SUCCESS;
 }
 
-static int getMSSQLMajorVersion(layerObj* layer)
-{
-  msMSSQL2008LayerInfo  *layerinfo = getMSSQL2008LayerInfo(layer);
+static int getMSSQLMajorVersion(layerObj *layer) {
+  msMSSQL2008LayerInfo *layerinfo = getMSSQL2008LayerInfo(layer);
   if (layerinfo == NULL)
     return 0;
 
   if (layerinfo->mssqlversion_major == 0) {
-    const char* mssqlversion_major = msLayerGetProcessingKey(layer, "MSSQL_VERSION_MAJOR");
+    const char *mssqlversion_major =
+        msLayerGetProcessingKey(layer, "MSSQL_VERSION_MAJOR");
     if (mssqlversion_major != NULL) {
       layerinfo->mssqlversion_major = atoi(mssqlversion_major);
-    }
-    else {
+    } else {
       /* need to query from database */
-      if (executeSQL(layerinfo->conn, "SELECT SERVERPROPERTY('ProductVersion')")) {
+      if (executeSQL(layerinfo->conn,
+                     "SELECT SERVERPROPERTY('ProductVersion')")) {
         SQLRETURN rc = SQLFetch(layerinfo->conn->hstmt);
         if (rc == SQL_SUCCESS || rc == SQL_SUCCESS_WITH_INFO) {
           /* process results */
           char result_data[256];
           SQLLEN retLen = 0;
 
-          rc = SQLGetData(layerinfo->conn->hstmt, 1, SQL_C_CHAR, result_data, sizeof(result_data), &retLen);
+          rc = SQLGetData(layerinfo->conn->hstmt, 1, SQL_C_CHAR, result_data,
+                          sizeof(result_data), &retLen);
 
           if (rc != SQL_ERROR) {
             result_data[retLen] = 0;
@@ -1119,17 +1150,16 @@ static int getMSSQLMajorVersion(layerObj
   return layerinfo->mssqlversion_major;
 }
 
-static int addFilter(layerObj *layer, char **query)
-{
+static int addFilter(layerObj *layer, char **query) {
   if (layer->filter.native_string) {
     (*query) = msStringConcatenate(*query, " WHERE (");
     (*query) = msStringConcatenate(*query, layer->filter.native_string);
     (*query) = msStringConcatenate(*query, ")");
     return MS_TRUE;
-  }
-  else if (msLayerGetProcessingKey(layer, "NATIVE_FILTER") != NULL) {
+  } else if (msLayerGetProcessingKey(layer, "NATIVE_FILTER") != NULL) {
     (*query) = msStringConcatenate(*query, " WHERE (");
-    (*query) = msStringConcatenate(*query, msLayerGetProcessingKey(layer, "NATIVE_FILTER"));
+    (*query) = msStringConcatenate(
+        *query, msLayerGetProcessingKey(layer, "NATIVE_FILTER"));
     (*query) = msStringConcatenate(*query, ")");
     return MS_TRUE;
   }
@@ -1139,195 +1169,214 @@ static int addFilter(layerObj *layer, ch
 
 /* Get the layer extent as specified in the mapfile or a largest area */
 /* covering all features */
-int msMSSQL2008LayerGetExtent(layerObj *layer, rectObj *extent)
-{
-    msMSSQL2008LayerInfo *layerinfo;
-    char *query = 0;
-    char result_data[256];
-    SQLLEN retLen;
-    SQLRETURN rc;
-    
-    if(layer->debug) {
-      msDebug("msMSSQL2008LayerGetExtent called\n");
-    }
+int msMSSQL2008LayerGetExtent(layerObj *layer, rectObj *extent) {
+  msMSSQL2008LayerInfo *layerinfo;
+  char *query = 0;
+  char result_data[256];
+  SQLLEN retLen;
+  SQLRETURN rc;
+
+  if (layer->debug) {
+    msDebug("msMSSQL2008LayerGetExtent called\n");
+  }
 
-    if (!(layer->extent.minx == -1.0 && layer->extent.miny == -1.0 && 
+  if (!(layer->extent.minx == -1.0 && layer->extent.miny == -1.0 &&
         layer->extent.maxx == -1.0 && layer->extent.maxy == -1.0)) {
-      /* extent was already set */
-      extent->minx = layer->extent.minx;
-      extent->miny = layer->extent.miny;
-      extent->maxx = layer->extent.maxx;
-      extent->maxy = layer->extent.maxy;
-    }
+    /* extent was already set */
+    extent->minx = layer->extent.minx;
+    extent->miny = layer->extent.miny;
+    extent->maxx = layer->extent.maxx;
+    extent->maxy = layer->extent.maxy;
+  }
 
-    layerinfo = getMSSQL2008LayerInfo(layer);
+  layerinfo = getMSSQL2008LayerInfo(layer);
 
-    if (!layerinfo) {
-        msSetError(MS_QUERYERR, "GetExtent called with layerinfo = NULL", "msMSSQL2008LayerGetExtent()");
-        return MS_FAILURE;
-    }
+  if (!layerinfo) {
+    msSetError(MS_QUERYERR, "GetExtent called with layerinfo = NULL",
+               "msMSSQL2008LayerGetExtent()");
+    return MS_FAILURE;
+  }
 
-    /* set up statement */
-    if (getMSSQLMajorVersion(layer) >= 11) {
-      if (strcasecmp(layerinfo->geom_column_type, "geography") == 0) {
-        query = msStringConcatenate(query, "WITH extent(extentcol) AS (SELECT geometry::EnvelopeAggregate(geometry::STGeomFromWKB(");
-        query = msStringConcatenate(query, layerinfo->geom_column);
-        query = msStringConcatenate(query, ".STAsBinary(), ");
-        query = msStringConcatenate(query, layerinfo->geom_column);
-        query = msStringConcatenate(query, ".STSrid)");
-      }
-      else {
-        query = msStringConcatenate(query, "WITH extent(extentcol) AS (SELECT geometry::EnvelopeAggregate(");
-        query = msStringConcatenate(query, layerinfo->geom_column);        
-      }
-      query = msStringConcatenate(query, ") AS extentcol FROM ");
-      query = msStringConcatenate(query, layerinfo->geom_table);
-
-      /* adding attribute filter */
-      addFilter(layer, &query);
-
-      query = msStringConcatenate(query, ") SELECT extentcol.STPointN(1).STX, extentcol.STPointN(1).STY, extentcol.STPointN(3).STX, extentcol.STPointN(3).STY FROM extent");
-    }
-    else {
-      if (strcasecmp(layerinfo->geom_column_type, "geography") == 0) {
-        query = msStringConcatenate(query, "WITH ENVELOPE as (SELECT geometry::STGeomFromWKB(");
-        query = msStringConcatenate(query, layerinfo->geom_column);
-        query = msStringConcatenate(query, ".STAsBinary(), ");
-        query = msStringConcatenate(query, layerinfo->geom_column);
-        query = msStringConcatenate(query, ".STSrid)");
-      }
-      else {
-        query = msStringConcatenate(query, "WITH ENVELOPE as (SELECT ");
-        query = msStringConcatenate(query, layerinfo->geom_column);      
-      }
-      query = msStringConcatenate(query, ".STEnvelope() as envelope from ");
-      query = msStringConcatenate(query, layerinfo->geom_table);
+  /* set up statement */
+  if (getMSSQLMajorVersion(layer) >= 11) {
+    if (strcasecmp(layerinfo->geom_column_type, "geography") == 0) {
+      query = msStringConcatenate(
+          query, "WITH extent(extentcol) AS (SELECT "
+                 "geometry::EnvelopeAggregate(geometry::STGeomFromWKB(");
+      query = msStringConcatenate(query, layerinfo->geom_column);
+      query = msStringConcatenate(query, ".STAsBinary(), ");
+      query = msStringConcatenate(query, layerinfo->geom_column);
+      query = msStringConcatenate(query, ".STSrid)");
+    } else {
+      query = msStringConcatenate(
+          query,
+          "WITH extent(extentcol) AS (SELECT geometry::EnvelopeAggregate(");
+      query = msStringConcatenate(query, layerinfo->geom_column);
+    }
+    query = msStringConcatenate(query, ") AS extentcol FROM ");
+    query = msStringConcatenate(query, layerinfo->geom_table);
 
-      /* adding attribute filter */
-      addFilter(layer, &query);
+    /* adding attribute filter */
+    addFilter(layer, &query);
 
-      query = msStringConcatenate(query, "), CORNERS as (SELECT envelope.STPointN(1) as point from ENVELOPE UNION ALL select envelope.STPointN(3) from ENVELOPE) SELECT MIN(point.STX), MIN(point.STY), MAX(point.STX), MAX(point.STY) FROM CORNERS");
+    query = msStringConcatenate(
+        query,
+        ") SELECT extentcol.STPointN(1).STX, extentcol.STPointN(1).STY, "
+        "extentcol.STPointN(3).STX, extentcol.STPointN(3).STY FROM extent");
+  } else {
+    if (strcasecmp(layerinfo->geom_column_type, "geography") == 0) {
+      query = msStringConcatenate(
+          query, "WITH ENVELOPE as (SELECT geometry::STGeomFromWKB(");
+      query = msStringConcatenate(query, layerinfo->geom_column);
+      query = msStringConcatenate(query, ".STAsBinary(), ");
+      query = msStringConcatenate(query, layerinfo->geom_column);
+      query = msStringConcatenate(query, ".STSrid)");
+    } else {
+      query = msStringConcatenate(query, "WITH ENVELOPE as (SELECT ");
+      query = msStringConcatenate(query, layerinfo->geom_column);
     }
+    query = msStringConcatenate(query, ".STEnvelope() as envelope from ");
+    query = msStringConcatenate(query, layerinfo->geom_table);
 
-    if (!executeSQL(layerinfo->conn, query)) {
-        msFree(query);
-        return MS_FAILURE;
-    }
+    /* adding attribute filter */
+    addFilter(layer, &query);
+
+    query = msStringConcatenate(
+        query, "), CORNERS as (SELECT envelope.STPointN(1) as point from "
+               "ENVELOPE UNION ALL select envelope.STPointN(3) from ENVELOPE) "
+               "SELECT MIN(point.STX), MIN(point.STY), MAX(point.STX), "
+               "MAX(point.STY) FROM CORNERS");
+  }
 
+  if (!executeSQL(layerinfo->conn, query)) {
     msFree(query);
+    return MS_FAILURE;
+  }
 
-    /* process results */
-    rc = SQLFetch(layerinfo->conn->hstmt);
+  msFree(query);
 
-    if (rc != SQL_SUCCESS && rc != SQL_SUCCESS_WITH_INFO) {
-        if (layer->debug) {
-            msDebug("msMSSQL2008LayerGetExtent: No results found.\n");
-        }
-        return MS_FAILURE;
-    }
+  /* process results */
+  rc = SQLFetch(layerinfo->conn->hstmt);
 
-    rc = SQLGetData(layerinfo->conn->hstmt, 1, SQL_C_CHAR, result_data, sizeof(result_data), &retLen);
-    if (rc == SQL_ERROR || retLen < 0) {
-        msSetError(MS_QUERYERR, "Failed to get MinX value", "msMSSQL2008LayerGetExtent()");
-        return MS_FAILURE;
+  if (rc != SQL_SUCCESS && rc != SQL_SUCCESS_WITH_INFO) {
+    if (layer->debug) {
+      msDebug("msMSSQL2008LayerGetExtent: No results found.\n");
     }
+    return MS_FAILURE;
+  }
 
-    result_data[retLen] = 0;
+  rc = SQLGetData(layerinfo->conn->hstmt, 1, SQL_C_CHAR, result_data,
+                  sizeof(result_data), &retLen);
+  if (rc == SQL_ERROR || retLen < 0) {
+    msSetError(MS_QUERYERR, "Failed to get MinX value",
+               "msMSSQL2008LayerGetExtent()");
+    return MS_FAILURE;
+  }
 
-    extent->minx = atof(result_data);
+  result_data[retLen] = 0;
 
-    rc = SQLGetData(layerinfo->conn->hstmt, 2, SQL_C_CHAR, result_data, sizeof(result_data), &retLen);
-    if (rc == SQL_ERROR || retLen < 0) {
-        msSetError(MS_QUERYERR, "Failed to get MinY value", "msMSSQL2008LayerGetExtent()");
-        return MS_FAILURE;
-    }
+  extent->minx = atof(result_data);
 
-    result_data[retLen] = 0;
+  rc = SQLGetData(layerinfo->conn->hstmt, 2, SQL_C_CHAR, result_data,
+                  sizeof(result_data), &retLen);
+  if (rc == SQL_ERROR || retLen < 0) {
+    msSetError(MS_QUERYERR, "Failed to get MinY value",
+               "msMSSQL2008LayerGetExtent()");
+    return MS_FAILURE;
+  }
 
-    extent->miny = atof(result_data);
+  result_data[retLen] = 0;
 
-    rc = SQLGetData(layerinfo->conn->hstmt, 3, SQL_C_CHAR, result_data, sizeof(result_data), &retLen);
-    if (rc == SQL_ERROR || retLen < 0) {
-        msSetError(MS_QUERYERR, "Failed to get MaxX value", "msMSSQL2008LayerGetExtent()");
-        return MS_FAILURE;
-    }
+  extent->miny = atof(result_data);
 
-    result_data[retLen] = 0;
+  rc = SQLGetData(layerinfo->conn->hstmt, 3, SQL_C_CHAR, result_data,
+                  sizeof(result_data), &retLen);
+  if (rc == SQL_ERROR || retLen < 0) {
+    msSetError(MS_QUERYERR, "Failed to get MaxX value",
+               "msMSSQL2008LayerGetExtent()");
+    return MS_FAILURE;
+  }
 
-    extent->maxx = atof(result_data);
+  result_data[retLen] = 0;
 
-    rc = SQLGetData(layerinfo->conn->hstmt, 4, SQL_C_CHAR, result_data, sizeof(result_data), &retLen);
-    if (rc == SQL_ERROR || retLen < 0) {
-        msSetError(MS_QUERYERR, "Failed to get MaxY value", "msMSSQL2008LayerGetExtent()");
-        return MS_FAILURE;
-    }
+  extent->maxx = atof(result_data);
+
+  rc = SQLGetData(layerinfo->conn->hstmt, 4, SQL_C_CHAR, result_data,
+                  sizeof(result_data), &retLen);
+  if (rc == SQL_ERROR || retLen < 0) {
+    msSetError(MS_QUERYERR, "Failed to get MaxY value",
+               "msMSSQL2008LayerGetExtent()");
+    return MS_FAILURE;
+  }
 
-    result_data[retLen] = 0;
+  result_data[retLen] = 0;
 
-    extent->maxy = atof(result_data);
+  extent->maxy = atof(result_data);
 
-    return MS_SUCCESS;
+  return MS_SUCCESS;
 }
 
 /* Get the layer feature count */
-int msMSSQL2008LayerGetNumFeatures(layerObj *layer)
-{
-    msMSSQL2008LayerInfo *layerinfo;
-    char *query = 0;
-    char result_data[256];
-    SQLLEN retLen;
-    SQLRETURN rc;
-
-    if (layer->debug) {
-        msDebug("msMSSQL2008LayerGetNumFeatures called\n");
-    }
+int msMSSQL2008LayerGetNumFeatures(layerObj *layer) {
+  msMSSQL2008LayerInfo *layerinfo;
+  char *query = 0;
+  char result_data[256];
+  SQLLEN retLen;
+  SQLRETURN rc;
 
-    layerinfo = getMSSQL2008LayerInfo(layer);
+  if (layer->debug) {
+    msDebug("msMSSQL2008LayerGetNumFeatures called\n");
+  }
 
-    if (!layerinfo) {
-        msSetError(MS_QUERYERR, "GetNumFeatures called with layerinfo = NULL", "msMSSQL2008LayerGetNumFeatures()");
-        return -1;
-    }
+  layerinfo = getMSSQL2008LayerInfo(layer);
 
-    /* set up statement */
-    query = msStringConcatenate(query, "SELECT count(*) FROM ");
-    query = msStringConcatenate(query, layerinfo->geom_table);
+  if (!layerinfo) {
+    msSetError(MS_QUERYERR, "GetNumFeatures called with layerinfo = NULL",
+               "msMSSQL2008LayerGetNumFeatures()");
+    return -1;
+  }
 
-    /* adding attribute filter */
-    addFilter(layer, &query);
+  /* set up statement */
+  query = msStringConcatenate(query, "SELECT count(*) FROM ");
+  query = msStringConcatenate(query, layerinfo->geom_table);
 
-    if (!executeSQL(layerinfo->conn, query)) {
-        msFree(query);
-        return -1;
-    }
+  /* adding attribute filter */
+  addFilter(layer, &query);
 
+  if (!executeSQL(layerinfo->conn, query)) {
     msFree(query);
+    return -1;
+  }
 
-    rc = SQLFetch(layerinfo->conn->hstmt);
+  msFree(query);
 
-    if (rc != SQL_SUCCESS && rc != SQL_SUCCESS_WITH_INFO) {
-        if (layer->debug) {
-            msDebug("msMSSQL2008LayerGetNumFeatures: No results found.\n");
-        }
+  rc = SQLFetch(layerinfo->conn->hstmt);
 
-        return -1;
+  if (rc != SQL_SUCCESS && rc != SQL_SUCCESS_WITH_INFO) {
+    if (layer->debug) {
+      msDebug("msMSSQL2008LayerGetNumFeatures: No results found.\n");
     }
 
-    rc = SQLGetData(layerinfo->conn->hstmt, 1, SQL_C_CHAR, result_data, sizeof(result_data), &retLen);
+    return -1;
+  }
 
-    if (rc == SQL_ERROR) {
-        msSetError(MS_QUERYERR, "Failed to get feature count", "msMSSQL2008LayerGetNumFeatures()");
-        return -1;
-    }
+  rc = SQLGetData(layerinfo->conn->hstmt, 1, SQL_C_CHAR, result_data,
+                  sizeof(result_data), &retLen);
+
+  if (rc == SQL_ERROR) {
+    msSetError(MS_QUERYERR, "Failed to get feature count",
+               "msMSSQL2008LayerGetNumFeatures()");
+    return -1;
+  }
 
-    result_data[retLen] = 0;
+  result_data[retLen] = 0;
 
-    return atoi(result_data);
+  return atoi(result_data);
 }
 
 /* Prepare and execute the SQL statement for this layer */
-static int prepare_database(layerObj *layer, rectObj rect, char **query_string, int isQuery)
-{
+static int prepare_database(layerObj *layer, rectObj rect, char **query_string,
+                            int isQuery) {
   msMSSQL2008LayerInfo *layerinfo;
   char *query = 0;
   char *data_source = 0;
@@ -1337,24 +1386,26 @@ static int prepare_database(layerObj *la
   char *paging_query = 0;
   /*
     "Geometry::STGeomFromText('POLYGON(())',)" + terminator = 40 chars
-    Plus 10 formatted doubles (15 digits of precision, a decimal point, a space/comma delimiter each = 17 chars each)
-    Plus SRID + comma - if SRID is a long...we'll be safe with 10 chars
+    Plus 10 formatted doubles (15 digits of precision, a decimal point, a
+    space/comma delimiter each = 17 chars each) Plus SRID + comma - if SRID is a
+    long...we'll be safe with 10 chars
+
+    or for geography columns
 
-  	or for geography columns
-	
     "Geography::STGeomFromText('CURVEPOLYGON(())',)" + terminator = 46 chars
-    Plus 18 formatted doubles (15 digits of precision, a decimal point, a space/comma delimiter each = 17 chars each)
-    Plus SRID + comma - if SRID is a long...we'll be safe with 10 chars
+    Plus 18 formatted doubles (15 digits of precision, a decimal point, a
+    space/comma delimiter each = 17 chars each) Plus SRID + comma - if SRID is a
+    long...we'll be safe with 10 chars
   */
-  char        box3d[46 + 18 * 22 + 11];
-  int         t;
+  char box3d[46 + 18 * 22 + 11];
+  int t;
 
-  char        *pos_from, *pos_ftab, *pos_space, *pos_paren;
+  char *pos_from, *pos_ftab, *pos_space, *pos_paren;
   int hasFilter = MS_FALSE;
   const rectObj rectInvalid = MS_INIT_INVALID_RECT;
   const int bIsValidRect = memcmp(&rect, &rectInvalid, sizeof(rect)) != 0;
 
-  layerinfo =  getMSSQL2008LayerInfo(layer);
+  layerinfo = getMSSQL2008LayerInfo(layer);
 
   /* Extract the proper f_table_name from the geom_table string.
    * We are expecting the geom_table to be either a single word
@@ -1369,10 +1420,10 @@ static int prepare_database(layerObj *la
   geom_table = msStrdup(layerinfo->geom_table);
   pos_from = strstrIgnoreCase(geom_table, " from ");
 
-  if(!pos_from) {
-    f_table_name = (char *) msSmallMalloc(strlen(geom_table) + 1);
+  if (!pos_from) {
+    f_table_name = (char *)msSmallMalloc(strlen(geom_table) + 1);
     strcpy(f_table_name, geom_table);
-  } else { /* geom_table is a sub-select clause */
+  } else {                   /* geom_table is a sub-select clause */
     pos_ftab = pos_from + 6; /* This should be the start of the ftab name */
     pos_space = strstr(pos_ftab, " "); /* First space */
 
@@ -1383,82 +1434,83 @@ static int prepare_database(layerObj *la
     pos_paren = rindex(pos_ftab, ')');
 #endif
 
-    if(!pos_space || !pos_paren) {
-      msSetError(MS_QUERYERR, DATA_ERROR_MESSAGE, "prepare_database()", geom_table, "Error parsing MSSQL2008 data variable: Something is wrong with your subselect statement.<br><br>\n\nMore Help:<br><br>\n\n");
+    if (!pos_space || !pos_paren) {
+      msSetError(
+          MS_QUERYERR, DATA_ERROR_MESSAGE, "prepare_database()", geom_table,
+          "Error parsing MSSQL2008 data variable: Something is wrong with your "
+          "subselect statement.<br><br>\n\nMore Help:<br><br>\n\n");
 
       return MS_FAILURE;
     }
 
     if (pos_paren < pos_space) { /* closing parenthesis preceeds any space */
-      f_table_name = (char *) msSmallMalloc(pos_paren - pos_ftab + 1);
+      f_table_name = (char *)msSmallMalloc(pos_paren - pos_ftab + 1);
       strlcpy(f_table_name, pos_ftab, pos_paren - pos_ftab + 1);
     } else {
-      f_table_name = (char *) msSmallMalloc(pos_space - pos_ftab + 1);
+      f_table_name = (char *)msSmallMalloc(pos_space - pos_ftab + 1);
       strlcpy(f_table_name, pos_ftab, pos_space - pos_ftab + 1);
     }
   }
 
   if (rect.minx == rect.maxx || rect.miny == rect.maxy) {
-      /* create point shape for rectangles with zero area */
-      sprintf(box3d, "%s::STGeomFromText('POINT(%.15g %.15g)',%s)", /* %s.STSrid)", */
-          layerinfo->geom_column_type, rect.minx, rect.miny, layerinfo->user_srid);
+    /* create point shape for rectangles with zero area */
+    sprintf(box3d,
+            "%s::STGeomFromText('POINT(%.15g %.15g)',%s)", /* %s.STSrid)", */
+            layerinfo->geom_column_type, rect.minx, rect.miny,
+            layerinfo->user_srid);
   } else if (strcasecmp(layerinfo->geom_column_type, "geography") == 0) {
-	  /* SQL Server has a problem when x is -180 or 180 */  
-	  double minx = rect.minx <= -180? -179.999: rect.minx;
-	  double maxx = rect.maxx >= 180? 179.999: rect.maxx;
-	  double miny = rect.miny < -90? -90: rect.miny;
-	  double maxy = rect.maxy > 90? 90: rect.maxy;
-	  sprintf(box3d, "Geography::STGeomFromText('CURVEPOLYGON((%.15g %.15g,%.15g %.15g,%.15g %.15g,%.15g %.15g,%.15g %.15g,%.15g %.15g,%.15g %.15g,%.15g %.15g,%.15g %.15g))',%s)", /* %s.STSrid)", */
-          minx, miny,
-          minx + (maxx - minx) / 2, miny,
-          maxx, miny,
-          maxx, miny + (maxy - miny) / 2,
-          maxx, maxy,
-          minx + (maxx - minx) / 2, maxy,
-          minx, maxy,
-          minx, miny + (maxy - miny) / 2,
-          minx, miny,
-          layerinfo->user_srid);  
+    /* SQL Server has a problem when x is -180 or 180 */
+    double minx = rect.minx <= -180 ? -179.999 : rect.minx;
+    double maxx = rect.maxx >= 180 ? 179.999 : rect.maxx;
+    double miny = rect.miny < -90 ? -90 : rect.miny;
+    double maxy = rect.maxy > 90 ? 90 : rect.maxy;
+    sprintf(box3d,
+            "Geography::STGeomFromText('CURVEPOLYGON((%.15g %.15g,%.15g "
+            "%.15g,%.15g %.15g,%.15g %.15g,%.15g %.15g,%.15g %.15g,%.15g "
+            "%.15g,%.15g %.15g,%.15g %.15g))',%s)", /* %s.STSrid)", */
+            minx, miny, minx + (maxx - minx) / 2, miny, maxx, miny, maxx,
+            miny + (maxy - miny) / 2, maxx, maxy, minx + (maxx - minx) / 2,
+            maxy, minx, maxy, minx, miny + (maxy - miny) / 2, minx, miny,
+            layerinfo->user_srid);
   } else {
-      sprintf(box3d, "Geometry::STGeomFromText('POLYGON((%.15g %.15g,%.15g %.15g,%.15g %.15g,%.15g %.15g,%.15g %.15g))',%s)", /* %s.STSrid)", */
-          rect.minx, rect.miny,
-          rect.maxx, rect.miny,
-          rect.maxx, rect.maxy,
-          rect.minx, rect.maxy,
-          rect.minx, rect.miny,
-          layerinfo->user_srid
-      );
+    sprintf(box3d,
+            "Geometry::STGeomFromText('POLYGON((%.15g %.15g,%.15g %.15g,%.15g "
+            "%.15g,%.15g %.15g,%.15g %.15g))',%s)", /* %s.STSrid)", */
+            rect.minx, rect.miny, rect.maxx, rect.miny, rect.maxx, rect.maxy,
+            rect.minx, rect.maxy, rect.minx, rect.miny, layerinfo->user_srid);
   }
 
-  /* substitute token '!BOX!' in geom_table with the box3d - do an unlimited # of subs */
-  /* to not undo the work here, we need to make sure that data_source is malloc'd here */
+  /* substitute token '!BOX!' in geom_table with the box3d - do an unlimited #
+   * of subs */
+  /* to not undo the work here, we need to make sure that data_source is
+   * malloc'd here */
 
   if (!strstr(geom_table, "!BOX!")) {
-      data_source = (char *)msSmallMalloc(strlen(geom_table) + 1);
-      strcpy(data_source, geom_table);
-  }
-  else {
-      char* result = NULL;
+    data_source = (char *)msSmallMalloc(strlen(geom_table) + 1);
+    strcpy(data_source, geom_table);
+  } else {
+    char *result = NULL;
 
-      while (strstr(geom_table, "!BOX!")) {
-          /* need to do a substition */
-          char    *start, *end;
-          char    *oldresult = result;
-          start = strstr(geom_table, "!BOX!");
-          end = start + 5;
+    while (strstr(geom_table, "!BOX!")) {
+      /* need to do a substition */
+      char *start, *end;
+      char *oldresult = result;
+      start = strstr(geom_table, "!BOX!");
+      end = start + 5;
 
-          result = (char *)msSmallMalloc((start - geom_table) + strlen(box3d) + strlen(end) + 1);
+      result = (char *)msSmallMalloc((start - geom_table) + strlen(box3d) +
+                                     strlen(end) + 1);
 
-          strlcpy(result, geom_table, start - geom_table + 1);
-          strcpy(result + (start - geom_table), box3d);
-          strcat(result, end);
+      strlcpy(result, geom_table, start - geom_table + 1);
+      strcpy(result + (start - geom_table), box3d);
+      strcat(result, end);
 
-          geom_table = result;
-          msFree(oldresult);
-      }
+      geom_table = result;
+      msFree(oldresult);
+    }
 
-      /* if we're here, this will be a malloc'd string, so no need to copy it */
-      data_source = (char *)geom_table;
+    /* if we're here, this will be a malloc'd string, so no need to copy it */
+    data_source = (char *)geom_table;
   }
 
   /* start creating the query */
@@ -1470,64 +1522,61 @@ static int prepare_database(layerObj *la
   /* adding items to the select list */
   for (t = 0; t < layer->numitems; t++) {
 #ifdef USE_ICONV
-      query = msStringConcatenate(query, "convert(nvarchar(max), [");     
+    query = msStringConcatenate(query, "convert(nvarchar(max), [");
 #else
-      query = msStringConcatenate(query, "convert(varchar(max), [");
+    query = msStringConcatenate(query, "convert(varchar(max), [");
 #endif
-      query = msStringConcatenate(query, layer->items[t]);
-      query = msStringConcatenate(query, "]) '");
-      tmp = msIntToString(t);
-      query = msStringConcatenate(query, tmp);
-      if (paging_query) {
-          paging_query = msStringConcatenate(paging_query, "[");
-          paging_query = msStringConcatenate(paging_query, tmp);
-          paging_query = msStringConcatenate(paging_query, "], ");
-      }
-      msFree(tmp);
-      query = msStringConcatenate(query, "',");
+    query = msStringConcatenate(query, layer->items[t]);
+    query = msStringConcatenate(query, "]) '");
+    tmp = msIntToString(t);
+    query = msStringConcatenate(query, tmp);
+    if (paging_query) {
+      paging_query = msStringConcatenate(paging_query, "[");
+      paging_query = msStringConcatenate(paging_query, tmp);
+      paging_query = msStringConcatenate(paging_query, "], ");
+    }
+    msFree(tmp);
+    query = msStringConcatenate(query, "',");
   }
 
   /* adding geometry column */
   query = msStringConcatenate(query, "[");
   query = msStringConcatenate(query, layerinfo->geom_column);
   if (layerinfo->geometry_format == MSSQLGEOMETRY_NATIVE)
-      query = msStringConcatenate(query, "] 'geom',");
+    query = msStringConcatenate(query, "] 'geom',");
   else {
-      query = msStringConcatenate(query, "].STAsBinary() 'geom',");
+    query = msStringConcatenate(query, "].STAsBinary() 'geom',");
   }
 
   /* adding id column */
   query = msStringConcatenate(query, "convert(varchar(36), [");
   query = msStringConcatenate(query, layerinfo->urid_name);
   if (paging_query) {
-      paging_query = msStringConcatenate(paging_query, "[geom], [id] FROM (");
-      query = msStringConcatenate(query, "]) 'id', row_number() over (");
-      if (layerinfo->sort_spec) {
-          query = msStringConcatenate(query, layerinfo->sort_spec);
-      }
+    paging_query = msStringConcatenate(paging_query, "[geom], [id] FROM (");
+    query = msStringConcatenate(query, "]) 'id', row_number() over (");
+    if (layerinfo->sort_spec) {
+      query = msStringConcatenate(query, layerinfo->sort_spec);
+    }
 
-      if (layer->sortBy.nProperties > 0) {
-          tmp = msLayerBuildSQLOrderBy(layer);
-          if (layerinfo->sort_spec) {
-              query = msStringConcatenate(query, ", ");
-          }
-          else {
-              query = msStringConcatenate(query, " ORDER BY ");
-          }
-          query = msStringConcatenate(query, tmp);
-          msFree(tmp);
+    if (layer->sortBy.nProperties > 0) {
+      tmp = msLayerBuildSQLOrderBy(layer);
+      if (layerinfo->sort_spec) {
+        query = msStringConcatenate(query, ", ");
+      } else {
+        query = msStringConcatenate(query, " ORDER BY ");
       }
-      else {
-          if (!layerinfo->sort_spec) {
-              // use the unique Id as the default sort for paging
-              query = msStringConcatenate(query, "ORDER BY ");
-              query = msStringConcatenate(query, layerinfo->urid_name);
-          }
+      query = msStringConcatenate(query, tmp);
+      msFree(tmp);
+    } else {
+      if (!layerinfo->sort_spec) {
+        // use the unique Id as the default sort for paging
+        query = msStringConcatenate(query, "ORDER BY ");
+        query = msStringConcatenate(query, layerinfo->urid_name);
       }
-      query = msStringConcatenate(query, ") 'rownum' FROM ");
-  }
-  else {
-      query = msStringConcatenate(query, "]) 'id' FROM ");
+    }
+    query = msStringConcatenate(query, ") 'rownum' FROM ");
+  } else {
+    query = msStringConcatenate(query, "]) 'id' FROM ");
   }
 
   /* adding the source */
@@ -1537,20 +1586,20 @@ static int prepare_database(layerObj *la
 
   /* use the index hint if provided */
   if (layerinfo->index_name) {
-      query = msStringConcatenate(query, " WITH (INDEX(");
-      query = msStringConcatenate(query, layerinfo->index_name);
-      query = msStringConcatenate(query, "))");
+    query = msStringConcatenate(query, " WITH (INDEX(");
+    query = msStringConcatenate(query, layerinfo->index_name);
+    query = msStringConcatenate(query, "))");
   }
 
   /* adding attribute filter */
   hasFilter = addFilter(layer, &query);
 
-  if( bIsValidRect ) {
+  if (bIsValidRect) {
     /* adding spatial filter */
     if (hasFilter == MS_FALSE)
-        query = msStringConcatenate(query, " WHERE ");
+      query = msStringConcatenate(query, " WHERE ");
     else
-        query = msStringConcatenate(query, " AND ");
+      query = msStringConcatenate(query, " AND ");
 
     query = msStringConcatenate(query, layerinfo->geom_column);
     query = msStringConcatenate(query, ".STIntersects(");
@@ -1559,117 +1608,123 @@ static int prepare_database(layerObj *la
   }
 
   if (paging_query) {
-      paging_query = msStringConcatenate(paging_query, query);
-      paging_query = msStringConcatenate(paging_query, ") tbl where [rownum] ");
-      if (layer->startindex > 0) {
-          tmp = msIntToString(layer->startindex);
-          paging_query = msStringConcatenate(paging_query, ">= ");
-          paging_query = msStringConcatenate(paging_query, tmp);
-          if (layer->maxfeatures >= 0) {
-              msFree(tmp);
-              tmp = msIntToString(layer->startindex + layer->maxfeatures);
-              paging_query = msStringConcatenate(paging_query, " and [rownum] < ");
-              paging_query = msStringConcatenate(paging_query, tmp);
-          }
-      }
-      else {
-          tmp = msIntToString(layer->maxfeatures);
-          paging_query = msStringConcatenate(paging_query, "< ");
-          paging_query = msStringConcatenate(paging_query, tmp);
-      }
-      msFree(tmp);
-      msFree(query);
-      query = paging_query;
-  } 
-  else {
-      if (layerinfo->sort_spec) {
-          query = msStringConcatenate(query, layerinfo->sort_spec);
+    paging_query = msStringConcatenate(paging_query, query);
+    paging_query = msStringConcatenate(paging_query, ") tbl where [rownum] ");
+    if (layer->startindex > 0) {
+      tmp = msIntToString(layer->startindex);
+      paging_query = msStringConcatenate(paging_query, ">= ");
+      paging_query = msStringConcatenate(paging_query, tmp);
+      if (layer->maxfeatures >= 0) {
+        msFree(tmp);
+        tmp = msIntToString(layer->startindex + layer->maxfeatures);
+        paging_query = msStringConcatenate(paging_query, " and [rownum] < ");
+        paging_query = msStringConcatenate(paging_query, tmp);
       }
+    } else {
+      tmp = msIntToString(layer->maxfeatures);
+      paging_query = msStringConcatenate(paging_query, "< ");
+      paging_query = msStringConcatenate(paging_query, tmp);
+    }
+    msFree(tmp);
+    msFree(query);
+    query = paging_query;
+  } else {
+    if (layerinfo->sort_spec) {
+      query = msStringConcatenate(query, layerinfo->sort_spec);
+    }
 
-      /* Add extra sort by */
-      if (layer->sortBy.nProperties > 0) {
-          char* pszTmp = msLayerBuildSQLOrderBy(layer);
-          if (layerinfo->sort_spec)
-              query = msStringConcatenate(query, ", ");
-          else
-              query = msStringConcatenate(query, " ORDER BY ");
-          query = msStringConcatenate(query, pszTmp);
-          msFree(pszTmp);
-      }
-      else if (isQuery && !layerinfo->sort_spec) {
-          /* Add orderby to make the result set order deterministic */
-          query = msStringConcatenate(query, " ORDER BY [");
-          query = msStringConcatenate(query, layerinfo->urid_name);
-          query = msStringConcatenate(query, "]");
-      }
+    /* Add extra sort by */
+    if (layer->sortBy.nProperties > 0) {
+      char *pszTmp = msLayerBuildSQLOrderBy(layer);
+      if (layerinfo->sort_spec)
+        query = msStringConcatenate(query, ", ");
+      else
+        query = msStringConcatenate(query, " ORDER BY ");
+      query = msStringConcatenate(query, pszTmp);
+      msFree(pszTmp);
+    } else if (isQuery && !layerinfo->sort_spec) {
+      /* Add orderby to make the result set order deterministic */
+      query = msStringConcatenate(query, " ORDER BY [");
+      query = msStringConcatenate(query, layerinfo->urid_name);
+      query = msStringConcatenate(query, "]");
+    }
   }
 
-
   if (layer->debug) {
-      msDebug("query:%s\n", query);
+    msDebug("query:%s\n", query);
   }
 
   if (executeSQL(layerinfo->conn, query)) {
-      char pass_field_def = 0;
-      int t;
-      const char *value;
-      *query_string = query;
-      /* collect result information */
-      if ((value = msOWSLookupMetadata(&(layer->metadata), "G", "types")) != NULL
-          && strcasecmp(value, "auto") == 0)
-          pass_field_def = 1;
-
-      msFree(layerinfo->itemtypes);
-      layerinfo->itemtypes = msSmallMalloc(sizeof(SQLSMALLINT) * (layer->numitems + 1));
-      for (t = 0; t < layer->numitems; t++) {
-          char colBuff[256];
-          SQLSMALLINT itemType = 0;
-
-          columnName(layerinfo->conn, t + 1, colBuff, sizeof(colBuff), layer, pass_field_def, &itemType);
-          layerinfo->itemtypes[t] = itemType;
-      }
+    char pass_field_def = 0;
+    int t;
+    const char *value;
+    *query_string = query;
+    /* collect result information */
+    if ((value = msOWSLookupMetadata(&(layer->metadata), "G", "types")) !=
+            NULL &&
+        strcasecmp(value, "auto") == 0)
+      pass_field_def = 1;
+
+    msFree(layerinfo->itemtypes);
+    layerinfo->itemtypes =
+        msSmallMalloc(sizeof(SQLSMALLINT) * (layer->numitems + 1));
+    for (t = 0; t < layer->numitems; t++) {
+      char colBuff[256];
+      SQLSMALLINT itemType = 0;
+
+      columnName(layerinfo->conn, t + 1, colBuff, sizeof(colBuff), layer,
+                 pass_field_def, &itemType);
+      layerinfo->itemtypes[t] = itemType;
+    }
 
-      return MS_SUCCESS;
-  }
-  else {
-      msSetError(MS_QUERYERR, "Error executing MSSQL2008 SQL statement: %s\n-%s\n", "msMSSQL2008LayerGetShape()", query, layerinfo->conn->errorMessage);
+    return MS_SUCCESS;
+  } else {
+    msSetError(
+        MS_QUERYERR, "Error executing MSSQL2008 SQL statement: %s\n-%s\n",
+        "msMSSQL2008LayerGetShape()", query, layerinfo->conn->errorMessage);
 
-      msFree(query);
+    msFree(query);
 
-      return MS_FAILURE;
+    return MS_FAILURE;
   }
 }
 
 /* Execute SQL query for this layer */
-int msMSSQL2008LayerWhichShapes(layerObj *layer, rectObj rect, int isQuery)
-{
+int msMSSQL2008LayerWhichShapes(layerObj *layer, rectObj rect, int isQuery) {
   (void)isQuery;
-  msMSSQL2008LayerInfo  *layerinfo = 0;
-  char    *query_str = 0;
-  int     set_up_result;
+  msMSSQL2008LayerInfo *layerinfo = 0;
+  char *query_str = 0;
+  int set_up_result;
 
-  if(layer->debug) {
+  if (layer->debug) {
     msDebug("msMSSQL2008LayerWhichShapes called\n");
   }
 
   layerinfo = getMSSQL2008LayerInfo(layer);
 
-  if(!layerinfo) {
+  if (!layerinfo) {
     /* layer not opened yet */
-    msSetError(MS_QUERYERR, "msMSSQL2008LayerWhichShapes called on unopened layer (layerinfo = NULL)", "msMSSQL2008LayerWhichShapes()");
+    msSetError(MS_QUERYERR,
+               "msMSSQL2008LayerWhichShapes called on unopened layer "
+               "(layerinfo = NULL)",
+               "msMSSQL2008LayerWhichShapes()");
 
     return MS_FAILURE;
   }
 
-  if(!layer->data) {
-    msSetError(MS_QUERYERR, "Missing DATA clause in MSSQL2008 Layer definition.  DATA statement must contain 'geometry_column from table_name' or 'geometry_column from (sub-query) as foo'.", "msMSSQL2008LayerWhichShapes()");
+  if (!layer->data) {
+    msSetError(MS_QUERYERR,
+               "Missing DATA clause in MSSQL2008 Layer definition.  DATA "
+               "statement must contain 'geometry_column from table_name' or "
+               "'geometry_column from (sub-query) as foo'.",
+               "msMSSQL2008LayerWhichShapes()");
 
     return MS_FAILURE;
   }
 
   set_up_result = prepare_database(layer, rect, &query_str, isQuery);
 
-  if(set_up_result != MS_SUCCESS) {
+  if (set_up_result != MS_SUCCESS) {
     msFree(query_str);
 
     return set_up_result; /* relay error */
@@ -1683,13 +1738,12 @@ int msMSSQL2008LayerWhichShapes(layerObj
 }
 
 /* Close the MSSQL2008 record set and connection */
-int msMSSQL2008LayerClose(layerObj *layer)
-{
-  msMSSQL2008LayerInfo  *layerinfo;
+int msMSSQL2008LayerClose(layerObj *layer) {
+  msMSSQL2008LayerInfo *layerinfo;
 
   layerinfo = getMSSQL2008LayerInfo(layer);
 
-  if(layer->debug) {
+  if (layer->debug) {
     char *data = "";
 
     if (layer->data) {
@@ -1699,56 +1753,56 @@ int msMSSQL2008LayerClose(layerObj *laye
     msDebug("msMSSQL2008LayerClose datastatement: %s\n", data);
   }
 
-  if(layer->debug && !layerinfo) {
+  if (layer->debug && !layerinfo) {
     msDebug("msMSSQL2008LayerClose -- layerinfo is  NULL\n");
   }
 
-  if(layerinfo) {
+  if (layerinfo) {
     msConnPoolRelease(layer, layerinfo->conn);
 
     layerinfo->conn = NULL;
 
-    if(layerinfo->user_srid) {
+    if (layerinfo->user_srid) {
       msFree(layerinfo->user_srid);
       layerinfo->user_srid = NULL;
     }
 
-    if(layerinfo->urid_name) {
+    if (layerinfo->urid_name) {
       msFree(layerinfo->urid_name);
       layerinfo->urid_name = NULL;
     }
 
-    if(layerinfo->index_name) {
+    if (layerinfo->index_name) {
       msFree(layerinfo->index_name);
       layerinfo->index_name = NULL;
     }
 
-    if(layerinfo->sort_spec) {
+    if (layerinfo->sort_spec) {
       msFree(layerinfo->sort_spec);
       layerinfo->sort_spec = NULL;
     }
 
-    if(layerinfo->sql) {
+    if (layerinfo->sql) {
       msFree(layerinfo->sql);
       layerinfo->sql = NULL;
     }
 
-    if(layerinfo->geom_column) {
+    if (layerinfo->geom_column) {
       msFree(layerinfo->geom_column);
       layerinfo->geom_column = NULL;
     }
 
-    if(layerinfo->geom_column_type) {
+    if (layerinfo->geom_column_type) {
       msFree(layerinfo->geom_column_type);
       layerinfo->geom_column_type = NULL;
     }
 
-    if(layerinfo->geom_table) {
+    if (layerinfo->geom_table) {
       msFree(layerinfo->geom_table);
       layerinfo->geom_table = NULL;
     }
 
-    if(layerinfo->itemtypes) {
+    if (layerinfo->itemtypes) {
       msFree(layerinfo->itemtypes);
       layerinfo->itemtypes = NULL;
     }
@@ -1764,83 +1818,82 @@ int msMSSQL2008LayerClose(layerObj *laye
 /* wkb is assumed to be 2d (force_2d) */
 /* and wkb is a GEOMETRYCOLLECTION (force_collection) */
 /* and wkb is in the endian of this computer (asbinary(...,'[XN]DR')) */
-/* each of the sub-geom inside the collection are point,linestring, or polygon */
+/* each of the sub-geom inside the collection are point,linestring, or polygon
+ */
 /*  */
 /* also, int is 32bits long */
 /* double is 64bits long */
 /* ******************************************************* */
 
-
 /* convert the wkb into points */
 /* points -> pass through */
 /* lines->   constituent points */
 /* polys->   treat ring like line and pull out the consituent points */
 
-static int  force_to_points(char *wkb, shapeObj *shape)
-{
-  /* we're going to make a 'line' for each entity (point, line or ring) in the geom collection */
-
-  int     offset = 0;
-  int     ngeoms;
-  int     t, u, v;
-  int     type, nrings, npoints;
+static int force_to_points(char *wkb, shapeObj *shape) {
+  /* we're going to make a 'line' for each entity (point, line or ring) in the
+   * geom collection */
+
+  int offset = 0;
+  int ngeoms;
+  int t, u, v;
+  int type, nrings, npoints;
   lineObj line = {0, NULL};
 
-  shape->type = MS_SHAPE_NULL;  /* nothing in it */
+  shape->type = MS_SHAPE_NULL; /* nothing in it */
 
   memcpy(&ngeoms, &wkb[5], 4);
-  offset = 9;  /* were the first geometry is */
-  for(t=0; t < ngeoms; t++) {
-    memcpy(&type, &wkb[offset + 1], 4);  /* type of this geometry */
+  offset = 9; /* were the first geometry is */
+  for (t = 0; t < ngeoms; t++) {
+    memcpy(&type, &wkb[offset + 1], 4); /* type of this geometry */
 
-    if(type == 1) {
+    if (type == 1) {
       /* Point */
       shape->type = MS_SHAPE_POINT;
       line.numpoints = 1;
-      line.point = (pointObj *) msSmallMalloc(sizeof(pointObj));
+      line.point = (pointObj *)msSmallMalloc(sizeof(pointObj));
 
       memcpy(&line.point[0].x, &wkb[offset + 5], 8);
       memcpy(&line.point[0].y, &wkb[offset + 5 + 8], 8);
       offset += 5 + 16;
       msAddLine(shape, &line);
       msFree(line.point);
-    } else if(type == 2) {
+    } else if (type == 2) {
       /* Linestring */
       shape->type = MS_SHAPE_POINT;
 
-      memcpy(&line.numpoints, &wkb[offset+5], 4); /* num points */
-      line.point = (pointObj *) msSmallMalloc(sizeof(pointObj) * line.numpoints);
-      for(u = 0; u < line.numpoints; u++) {
-        memcpy( &line.point[u].x, &wkb[offset+9 + (16 * u)], 8);
-        memcpy( &line.point[u].y, &wkb[offset+9 + (16 * u)+8], 8);
+      memcpy(&line.numpoints, &wkb[offset + 5], 4); /* num points */
+      line.point = (pointObj *)msSmallMalloc(sizeof(pointObj) * line.numpoints);
+      for (u = 0; u < line.numpoints; u++) {
+        memcpy(&line.point[u].x, &wkb[offset + 9 + (16 * u)], 8);
+        memcpy(&line.point[u].y, &wkb[offset + 9 + (16 * u) + 8], 8);
       }
-      offset += 9 + 16 * line.numpoints;  /* length of object */
+      offset += 9 + 16 * line.numpoints; /* length of object */
       msAddLine(shape, &line);
       msFree(line.point);
-    } else if(type == 3) {
+    } else if (type == 3) {
       /* Polygon */
       shape->type = MS_SHAPE_POINT;
 
-      memcpy(&nrings, &wkb[offset+5],4); /* num rings */
+      memcpy(&nrings, &wkb[offset + 5], 4); /* num rings */
       /* add a line for each polygon ring */
       offset += 9; /* now points at 1st linear ring */
-      for(u = 0; u < nrings; u++) {
+      for (u = 0; u < nrings; u++) {
         /* for each ring, make a line */
         memcpy(&npoints, &wkb[offset], 4); /* num points */
         line.numpoints = npoints;
-        line.point = (pointObj *) msSmallMalloc(sizeof(pointObj)* npoints);
+        line.point = (pointObj *)msSmallMalloc(sizeof(pointObj) * npoints);
         /* point struct */
-        for(v = 0; v < npoints; v++) {
+        for (v = 0; v < npoints; v++) {
           memcpy(&line.point[v].x, &wkb[offset + 4 + (16 * v)], 8);
           memcpy(&line.point[v].y, &wkb[offset + 4 + (16 * v) + 8], 8);
         }
         /* make offset point to next linear ring */
         msAddLine(shape, &line);
         msFree(line.point);
-        offset += 4 + 16 *npoints;
+        offset += 4 + 16 * npoints;
       }
     }
-
   }
 
   return MS_SUCCESS;
@@ -1851,50 +1904,49 @@ static int  force_to_points(char *wkb, s
 /* lines -> pass through */
 /* polys -> treat rings as lines */
 
-static int  force_to_lines(char *wkb, shapeObj *shape)
-{
-  int     offset = 0;
-  int     ngeoms;
-  int     t, u, v;
-  int     type, nrings, npoints;
+static int force_to_lines(char *wkb, shapeObj *shape) {
+  int offset = 0;
+  int ngeoms;
+  int t, u, v;
+  int type, nrings, npoints;
   lineObj line = {0, NULL};
 
-  shape->type = MS_SHAPE_NULL;  /* nothing in it */
+  shape->type = MS_SHAPE_NULL; /* nothing in it */
 
   memcpy(&ngeoms, &wkb[5], 4);
-  offset = 9;  /* were the first geometry is */
-  for(t=0; t < ngeoms; t++) {
-    memcpy(&type, &wkb[offset + 1], 4);  /* type of this geometry */
+  offset = 9; /* were the first geometry is */
+  for (t = 0; t < ngeoms; t++) {
+    memcpy(&type, &wkb[offset + 1], 4); /* type of this geometry */
 
     /* cannot do anything with a point */
 
-    if(type == 2) {
+    if (type == 2) {
       /* Linestring */
       shape->type = MS_SHAPE_LINE;
 
       memcpy(&line.numpoints, &wkb[offset + 5], 4);
-      line.point = (pointObj*) msSmallMalloc(sizeof(pointObj) * line.numpoints );
-      for(u=0; u < line.numpoints; u++) {
+      line.point = (pointObj *)msSmallMalloc(sizeof(pointObj) * line.numpoints);
+      for (u = 0; u < line.numpoints; u++) {
         memcpy(&line.point[u].x, &wkb[offset + 9 + (16 * u)], 8);
-        memcpy(&line.point[u].y, &wkb[offset + 9 + (16 * u)+8], 8);
+        memcpy(&line.point[u].y, &wkb[offset + 9 + (16 * u) + 8], 8);
       }
-      offset += 9 + 16 * line.numpoints;  /* length of object */
+      offset += 9 + 16 * line.numpoints; /* length of object */
       msAddLine(shape, &line);
       msFree(line.point);
-    } else if(type == 3) {
+    } else if (type == 3) {
       /* polygon */
       shape->type = MS_SHAPE_LINE;
 
       memcpy(&nrings, &wkb[offset + 5], 4); /* num rings */
       /* add a line for each polygon ring */
       offset += 9; /* now points at 1st linear ring */
-      for(u = 0; u < nrings; u++) {
+      for (u = 0; u < nrings; u++) {
         /* for each ring, make a line */
         memcpy(&npoints, &wkb[offset], 4);
         line.numpoints = npoints;
-        line.point = (pointObj*) msSmallMalloc(sizeof(pointObj) * npoints);
+        line.point = (pointObj *)msSmallMalloc(sizeof(pointObj) * npoints);
         /* point struct */
-        for(v = 0; v < npoints; v++) {
+        for (v = 0; v < npoints; v++) {
           memcpy(&line.point[v].x, &wkb[offset + 4 + (16 * v)], 8);
           memcpy(&line.point[v].y, &wkb[offset + 4 + (16 * v) + 8], 8);
         }
@@ -1912,34 +1964,33 @@ static int  force_to_lines(char *wkb, sh
 /* point   -> reject */
 /* line    -> reject */
 /* polygon -> lines of linear rings */
-static int  force_to_polygons(char  *wkb, shapeObj *shape)
-{
-  int     offset = 0;
-  int     ngeoms;
-  int     t, u, v;
-  int     type, nrings, npoints;
+static int force_to_polygons(char *wkb, shapeObj *shape) {
+  int offset = 0;
+  int ngeoms;
+  int t, u, v;
+  int type, nrings, npoints;
   lineObj line = {0, NULL};
 
-  shape->type = MS_SHAPE_NULL;  /* nothing in it */
+  shape->type = MS_SHAPE_NULL; /* nothing in it */
 
   memcpy(&ngeoms, &wkb[5], 4);
-  offset = 9;  /* were the first geometry is */
-  for(t = 0; t < ngeoms; t++) {
-    memcpy(&type, &wkb[offset + 1], 4);  /* type of this geometry */
+  offset = 9; /* were the first geometry is */
+  for (t = 0; t < ngeoms; t++) {
+    memcpy(&type, &wkb[offset + 1], 4); /* type of this geometry */
 
-    if(type == 3) {
+    if (type == 3) {
       /* polygon */
       shape->type = MS_SHAPE_POLYGON;
 
       memcpy(&nrings, &wkb[offset + 5], 4); /* num rings */
       /* add a line for each polygon ring */
       offset += 9; /* now points at 1st linear ring */
-      for(u=0; u < nrings; u++) {
+      for (u = 0; u < nrings; u++) {
         /* for each ring, make a line */
         memcpy(&npoints, &wkb[offset], 4); /* num points */
         line.numpoints = npoints;
-        line.point = (pointObj*) msSmallMalloc(sizeof(pointObj) * npoints);
-        for(v=0; v < npoints; v++) {
+        line.point = (pointObj *)msSmallMalloc(sizeof(pointObj) * npoints);
+        for (v = 0; v < npoints; v++) {
           memcpy(&line.point[v].x, &wkb[offset + 4 + (16 * v)], 8);
           memcpy(&line.point[v].y, &wkb[offset + 4 + (16 * v) + 8], 8);
         }
@@ -1958,36 +2009,35 @@ static int  force_to_polygons(char  *wkb
 /* if there is any line in wkb, return force_line */
 /* otherwise return force_point */
 
-static int  dont_force(char *wkb, shapeObj *shape)
-{
-  int     offset =0;
-  int     ngeoms;
-  int     type, t;
-  int     best_type;
+static int dont_force(char *wkb, shapeObj *shape) {
+  int offset = 0;
+  int ngeoms;
+  int type, t;
+  int best_type;
 
-  best_type = MS_SHAPE_NULL;  /* nothing in it */
+  best_type = MS_SHAPE_NULL; /* nothing in it */
 
   memcpy(&ngeoms, &wkb[5], 4);
-  offset = 9;  /* were the first geometry is */
-  for(t = 0; t < ngeoms; t++) {
-    memcpy(&type, &wkb[offset + 1], 4);  /* type of this geometry */
+  offset = 9; /* were the first geometry is */
+  for (t = 0; t < ngeoms; t++) {
+    memcpy(&type, &wkb[offset + 1], 4); /* type of this geometry */
 
-    if(type == 3) {
+    if (type == 3) {
       best_type = MS_SHAPE_POLYGON;
-    } else if(type ==2 && best_type != MS_SHAPE_POLYGON) {
+    } else if (type == 2 && best_type != MS_SHAPE_POLYGON) {
       best_type = MS_SHAPE_LINE;
-    } else if(type == 1 && best_type == MS_SHAPE_NULL) {
+    } else if (type == 1 && best_type == MS_SHAPE_NULL) {
       best_type = MS_SHAPE_POINT;
     }
   }
 
-  if(best_type == MS_SHAPE_POINT) {
+  if (best_type == MS_SHAPE_POINT) {
     return force_to_points(wkb, shape);
   }
-  if(best_type == MS_SHAPE_LINE) {
+  if (best_type == MS_SHAPE_LINE) {
     return force_to_lines(wkb, shape);
   }
-  if(best_type == MS_SHAPE_POLYGON) {
+  if (best_type == MS_SHAPE_POLYGON) {
     return force_to_polygons(wkb, shape);
   }
 
@@ -2091,81 +2141,80 @@ static int  force_to_shapeType(char *wkb
 ///* if there is any polygon in wkb, return force_polygon */
 ///* if there is any line in wkb, return force_line */
 ///* otherwise return force_point */
-//static int  dont_force(char *wkb, shapeObj *shape)
+// static int  dont_force(char *wkb, shapeObj *shape)
 //{
-//    int     offset =0;
-//    int     ngeoms = 1;
-//    int     type;
-//    int     best_type;
-//    int     u;
-//    int     nrings, npoints;
+//     int     offset =0;
+//     int     ngeoms = 1;
+//     int     type;
+//     int     best_type;
+//     int     u;
+//     int     nrings, npoints;
 //
-//    best_type = MS_SHAPE_NULL;  /* nothing in it */
+//     best_type = MS_SHAPE_NULL;  /* nothing in it */
 //
-//    do
-//    {
-//        ngeoms--;
+//     do
+//     {
+//         ngeoms--;
 //
-//        memcpy(&type, &wkb[offset + 1], 4);  /* type of this geometry */
+//         memcpy(&type, &wkb[offset + 1], 4);  /* type of this geometry */
 //
-//        if(type == 3) {
-//            best_type = MS_SHAPE_POLYGON;
-//        } else if(type ==2 && best_type != MS_SHAPE_POLYGON) {
-//            best_type = MS_SHAPE_LINE;
-//        } else if(type == 1 && best_type == MS_SHAPE_NULL) {
-//            best_type = MS_SHAPE_POINT;
-//        }
+//         if(type == 3) {
+//             best_type = MS_SHAPE_POLYGON;
+//         } else if(type ==2 && best_type != MS_SHAPE_POLYGON) {
+//             best_type = MS_SHAPE_LINE;
+//         } else if(type == 1 && best_type == MS_SHAPE_NULL) {
+//             best_type = MS_SHAPE_POINT;
+//         }
 //
-//        if (type == 1)
-//        {
-//            /* Point */
-//            offset += 5 + 16;
-//        }
-//        else if(type == 2)
-//        {
-//            int numPoints;
+//         if (type == 1)
+//         {
+//             /* Point */
+//             offset += 5 + 16;
+//         }
+//         else if(type == 2)
+//         {
+//             int numPoints;
 //
-//            memcpy(&numPoints, &wkb[offset+5], 4); /* num points */
-//            /* Linestring */
-//            offset += 9 + 16 * numPoints;  /* length of object */
-//        }
-//        else if(type == 3)
-//        {
-//            /* Polygon */
-//            memcpy(&nrings, &wkb[offset+5],4); /* num rings */
-//            offset += 9; /* now points at 1st linear ring */
-//            for(u = 0; u < nrings; u++) {
-//                /* for each ring, make a line */
-//                memcpy(&npoints, &wkb[offset], 4); /* num points */
-//                offset += 4 + 16 *npoints;
-//            }
-//        }
-//        else if(type >= 4 && type <= 7)
-//        {
-//            int cnt = 0;
+//             memcpy(&numPoints, &wkb[offset+5], 4); /* num points */
+//             /* Linestring */
+//             offset += 9 + 16 * numPoints;  /* length of object */
+//         }
+//         else if(type == 3)
+//         {
+//             /* Polygon */
+//             memcpy(&nrings, &wkb[offset+5],4); /* num rings */
+//             offset += 9; /* now points at 1st linear ring */
+//             for(u = 0; u < nrings; u++) {
+//                 /* for each ring, make a line */
+//                 memcpy(&npoints, &wkb[offset], 4); /* num points */
+//                 offset += 4 + 16 *npoints;
+//             }
+//         }
+//         else if(type >= 4 && type <= 7)
+//         {
+//             int cnt = 0;
 //
-//            offset += 5;
+//             offset += 5;
 //
-//            memcpy(&cnt, &wkb[offset], 4);
-//            offset += 4;  /* were the first geometry is */
+//             memcpy(&cnt, &wkb[offset], 4);
+//             offset += 4;  /* were the first geometry is */
 //
-//            ngeoms += cnt;
-//        }
-//    }
-//    while (ngeoms > 0);
+//             ngeoms += cnt;
+//         }
+//     }
+//     while (ngeoms > 0);
 //
-//    return force_to_shapeType(wkb, shape, best_type);
-//}
+//     return force_to_shapeType(wkb, shape, best_type);
+// }
 //
 /* find the bounds of the shape */
-static void find_bounds(shapeObj *shape)
-{
-  int     t, u;
-  int     first_one = 1;
-
-  for(t = 0; t < shape->numlines; t++) {
-    for(u = 0; u < shape->line[t].numpoints; u++) {
-      if(first_one) {
+static void find_bounds(shapeObj *shape) {
+  int t, u;
+  int first_one = 1;
+
+  for (t = 0; t < shape->numlines; t++) {
+    for (u = 0; u < shape->line[t].numpoints; u++) {
+      if (first_one) {
         shape->bounds.minx = shape->line[t].point[u].x;
         shape->bounds.maxx = shape->line[t].point[u].x;
 
@@ -2173,17 +2222,17 @@ static void find_bounds(shapeObj *shape)
         shape->bounds.maxy = shape->line[t].point[u].y;
         first_one = 0;
       } else {
-        if(shape->line[t].point[u].x < shape->bounds.minx) {
+        if (shape->line[t].point[u].x < shape->bounds.minx) {
           shape->bounds.minx = shape->line[t].point[u].x;
         }
-        if(shape->line[t].point[u].x > shape->bounds.maxx) {
+        if (shape->line[t].point[u].x > shape->bounds.maxx) {
           shape->bounds.maxx = shape->line[t].point[u].x;
         }
 
-        if(shape->line[t].point[u].y < shape->bounds.miny) {
+        if (shape->line[t].point[u].y < shape->bounds.miny) {
           shape->bounds.miny = shape->line[t].point[u].y;
         }
-        if(shape->line[t].point[u].y > shape->bounds.maxy) {
+        if (shape->line[t].point[u].y > shape->bounds.maxy) {
           shape->bounds.maxy = shape->line[t].point[u].y;
         }
       }
@@ -2192,15 +2241,16 @@ static void find_bounds(shapeObj *shape)
 }
 
 /* Used by NextShape() to access a shape in the query set */
-int msMSSQL2008LayerGetShapeRandom(layerObj *layer, shapeObj *shape, long *record)
-{
-  msMSSQL2008LayerInfo  *layerinfo;
+int msMSSQL2008LayerGetShapeRandom(layerObj *layer, shapeObj *shape,
+                                   long *record) {
+  msMSSQL2008LayerInfo *layerinfo;
   SQLLEN needLen = 0;
   SQLLEN retLen = 0;
   char dummyBuffer[1];
   char *wkbBuffer;
   char *valueBuffer;
-  char oidBuffer[ 16 ];   /* assuming the OID will always be a long this should be enough */
+  char oidBuffer[16]; /* assuming the OID will always be a long this should be
+                         enough */
   long record_oid;
   int t;
 
@@ -2210,22 +2260,27 @@ int msMSSQL2008LayerGetShapeRandom(layer
 
   layerinfo = getMSSQL2008LayerInfo(layer);
 
-  if(!layerinfo) {
-    msSetError(MS_QUERYERR, "GetShape called with layerinfo = NULL", "msMSSQL2008LayerGetShape()");
+  if (!layerinfo) {
+    msSetError(MS_QUERYERR, "GetShape called with layerinfo = NULL",
+               "msMSSQL2008LayerGetShape()");
     return MS_FAILURE;
   }
 
-  if(!layerinfo->conn) {
-    msSetError(MS_QUERYERR, "NextShape called on MSSQL2008 layer with no connection to DB.", "msMSSQL2008LayerGetShape()");
+  if (!layerinfo->conn) {
+    msSetError(MS_QUERYERR,
+               "NextShape called on MSSQL2008 layer with no connection to DB.",
+               "msMSSQL2008LayerGetShape()");
     return MS_FAILURE;
   }
 
   shape->type = MS_SHAPE_NULL;
 
-  while(shape->type == MS_SHAPE_NULL) {
-    /* SQLRETURN rc = SQLFetchScroll(layerinfo->conn->hstmt, SQL_FETCH_ABSOLUTE, (SQLLEN) (*record) + 1); */
+  while (shape->type == MS_SHAPE_NULL) {
+    /* SQLRETURN rc = SQLFetchScroll(layerinfo->conn->hstmt, SQL_FETCH_ABSOLUTE,
+     * (SQLLEN) (*record) + 1); */
 
-    /* We only do forward fetches. the parameter 'record' is ignored, but is incremented */
+    /* We only do forward fetches. the parameter 'record' is ignored, but is
+     * incremented */
     SQLRETURN rc = SQLFetch(layerinfo->conn->hstmt);
 
     /* Any error assume out of recordset bounds */
@@ -2238,15 +2293,17 @@ int msMSSQL2008LayerGetShapeRandom(layer
 
     {
       /* have to retrieve shape attributes */
-      shape->values = (char **) msSmallMalloc(sizeof(char *) * layer->numitems);
+      shape->values = (char **)msSmallMalloc(sizeof(char *) * layer->numitems);
       shape->numvalues = layer->numitems;
 
-      for(t=0; t < layer->numitems; t++) {
-        /* Startwith a 64 character long buffer. This may need to be increased after calling SQLGetData. */
+      for (t = 0; t < layer->numitems; t++) {
+        /* Startwith a 64 character long buffer. This may need to be increased
+         * after calling SQLGetData. */
         SQLLEN emptyLen = 64;
-        valueBuffer = (char*) msSmallMalloc(emptyLen);
-        if ( valueBuffer == NULL ) {
-          msSetError( MS_QUERYERR, "Could not allocate value buffer.", "msMSSQL2008LayerGetShapeRandom()" );
+        valueBuffer = (char *)msSmallMalloc(emptyLen);
+        if (valueBuffer == NULL) {
+          msSetError(MS_QUERYERR, "Could not allocate value buffer.",
+                     "msMSSQL2008LayerGetShapeRandom()");
           return MS_FAILURE;
         }
 
@@ -2259,27 +2316,36 @@ int msMSSQL2008LayerGetShapeRandom(layer
         char *bufferLocation = valueBuffer;
         int r = 0;
         while (r < 20) {
-          rc = SQLGetData(layerinfo->conn->hstmt, (SQLUSMALLINT)(t + 1), targetType, bufferLocation, emptyLen, &retLen);
+          rc = SQLGetData(layerinfo->conn->hstmt, (SQLUSMALLINT)(t + 1),
+                          targetType, bufferLocation, emptyLen, &retLen);
 
           if (rc == SQL_SUCCESS || rc == SQL_SUCCESS_WITH_INFO)
-            totalLen += retLen > emptyLen || retLen == SQL_NO_TOTAL ? emptyLen : retLen;
+            totalLen +=
+                retLen > emptyLen || retLen == SQL_NO_TOTAL ? emptyLen : retLen;
 
           if (rc == SQL_SUCCESS_WITH_INFO && rc != SQL_NO_DATA) {
-            /* We must compensate for the last null termination that SQLGetData include */
-            /* If we get SQL_NO_TOTAL we do not know how big buffer we need so we increase it with 512. */
+            /* We must compensate for the last null termination that SQLGetData
+             * include */
+            /* If we get SQL_NO_TOTAL we do not know how big buffer we need so
+             * we increase it with 512. */
 #ifdef USE_ICONV
             totalLen -= sizeof(wchar_t);
-            emptyLen = retLen != SQL_NO_TOTAL? retLen - emptyLen + 2 * sizeof(wchar_t): 512;
+            emptyLen = retLen != SQL_NO_TOTAL
+                           ? retLen - emptyLen + 2 * sizeof(wchar_t)
+                           : 512;
 #else
             totalLen -= sizeof(char);
-            emptyLen = retLen != SQL_NO_TOTAL? retLen - emptyLen + 2 * sizeof(char): 512;
+            emptyLen = retLen != SQL_NO_TOTAL
+                           ? retLen - emptyLen + 2 * sizeof(char)
+                           : 512;
 #endif
 
-            valueBuffer = (char *)msSmallRealloc(valueBuffer, totalLen + emptyLen);
+            valueBuffer =
+                (char *)msSmallRealloc(valueBuffer, totalLen + emptyLen);
             bufferLocation = valueBuffer + totalLen;
           } else
             break;
-          
+
           r++;
         }
 
@@ -2289,7 +2355,8 @@ int msMSSQL2008LayerGetShapeRandom(layer
         if (totalLen > 0) {
           /* Pop the value into the shape's value array */
 #ifdef USE_ICONV
-          shape->values[t] = msConvertWideStringToUTF8((wchar_t*)valueBuffer, "UCS-2LE");
+          shape->values[t] =
+              msConvertWideStringToUTF8((wchar_t *)valueBuffer, "UCS-2LE");
           msFree(valueBuffer);
 #else
           shape->values[t] = valueBuffer;
@@ -2304,46 +2371,51 @@ int msMSSQL2008LayerGetShapeRandom(layer
       /* Get shape geometry */
       {
         /* Set up to request the size of the buffer needed */
-        rc = SQLGetData(layerinfo->conn->hstmt, (SQLUSMALLINT)(layer->numitems + 1), SQL_C_BINARY, dummyBuffer, 0, &needLen);
+        rc = SQLGetData(layerinfo->conn->hstmt,
+                        (SQLUSMALLINT)(layer->numitems + 1), SQL_C_BINARY,
+                        dummyBuffer, 0, &needLen);
         if (rc == SQL_ERROR)
           handleSQLError(layer);
 
         /* allow space for coercion to geometry collection if needed*/
-        wkbTemp = (char*)msSmallMalloc(needLen+9);
+        wkbTemp = (char *)msSmallMalloc(needLen + 9);
 
         /* write data above space allocated for geometry collection coercion */
         wkbBuffer = wkbTemp + 9;
 
-        if ( wkbBuffer == NULL ) {
-          msSetError( MS_QUERYERR, "Could not allocate value buffer.", "msMSSQL2008LayerGetShapeRandom()" );
+        if (wkbBuffer == NULL) {
+          msSetError(MS_QUERYERR, "Could not allocate value buffer.",
+                     "msMSSQL2008LayerGetShapeRandom()");
           return MS_FAILURE;
         }
 
         /* Grab the WKB */
-        rc = SQLGetData(layerinfo->conn->hstmt, (SQLUSMALLINT)(layer->numitems + 1), SQL_C_BINARY, wkbBuffer, needLen, &retLen);
+        rc = SQLGetData(layerinfo->conn->hstmt,
+                        (SQLUSMALLINT)(layer->numitems + 1), SQL_C_BINARY,
+                        wkbBuffer, needLen, &retLen);
         if (rc == SQL_ERROR || rc == SQL_SUCCESS_WITH_INFO)
           handleSQLError(layer);
 
         if (layerinfo->geometry_format == MSSQLGEOMETRY_NATIVE) {
-          layerinfo->gpi.pszData = (unsigned char*)wkbBuffer;
+          layerinfo->gpi.pszData = (unsigned char *)wkbBuffer;
           layerinfo->gpi.nLen = (int)retLen;
 
           if (!ParseSqlGeometry(layerinfo, shape)) {
-            switch(layer->type) {
-              case MS_LAYER_POINT:
-                shape->type = MS_SHAPE_POINT;
-                break;
-
-              case MS_LAYER_LINE:
-                shape->type = MS_SHAPE_LINE;
-                break;
-
-              case MS_LAYER_POLYGON:
-                shape->type = MS_SHAPE_POLYGON;
-                break;
+            switch (layer->type) {
+            case MS_LAYER_POINT:
+              shape->type = MS_SHAPE_POINT;
+              break;
+
+            case MS_LAYER_LINE:
+              shape->type = MS_SHAPE_LINE;
+              break;
 
-              default:
-                break;
+            case MS_LAYER_POLYGON:
+              shape->type = MS_SHAPE_POLYGON;
+              break;
+
+            default:
+              break;
             }
           }
         } else {
@@ -2355,7 +2427,8 @@ int msMSSQL2008LayerGetShapeRandom(layer
             wkbTemp[0] = wkbBuffer[0];
             wkbBuffer = wkbTemp;
 
-            /* indicate type is geometry collection (although geomType + 3 would also work) */
+            /* indicate type is geometry collection (although geomType + 3 would
+             * also work) */
             wkbBuffer[1] = (char)7;
             wkbBuffer[2] = (char)0;
             wkbBuffer[3] = (char)0;
@@ -2368,65 +2441,65 @@ int msMSSQL2008LayerGetShapeRandom(layer
             wkbBuffer[8] = (char)0;
           }
 
-          switch(layer->type) {
-            case MS_LAYER_POINT:
-              /*result =*/ force_to_points(wkbBuffer, shape);
-              break;
+          switch (layer->type) {
+          case MS_LAYER_POINT:
+            /*result =*/force_to_points(wkbBuffer, shape);
+            break;
 
-            case MS_LAYER_LINE:
-              /*result =*/ force_to_lines(wkbBuffer, shape);
-              break;
+          case MS_LAYER_LINE:
+            /*result =*/force_to_lines(wkbBuffer, shape);
+            break;
 
-            case MS_LAYER_POLYGON:
-              /*result =*/ force_to_polygons(wkbBuffer, shape);
-              break;
+          case MS_LAYER_POLYGON:
+            /*result =*/force_to_polygons(wkbBuffer, shape);
+            break;
 
-            case MS_LAYER_QUERY:
-            case MS_LAYER_CHART:
-              /*result =*/ dont_force(wkbBuffer, shape);
-              break;
+          case MS_LAYER_QUERY:
+          case MS_LAYER_CHART:
+            /*result =*/dont_force(wkbBuffer, shape);
+            break;
 
-            case MS_LAYER_RASTER:
-              msDebug( "Ignoring MS_LAYER_RASTER in mapMSSQL2008.c\n" );
-              break;
+          case MS_LAYER_RASTER:
+            msDebug("Ignoring MS_LAYER_RASTER in mapMSSQL2008.c\n");
+            break;
 
-            case MS_LAYER_CIRCLE:
-              msDebug( "Ignoring MS_LAYER_CIRCLE in mapMSSQL2008.c\n" );
-              break;
+          case MS_LAYER_CIRCLE:
+            msDebug("Ignoring MS_LAYER_CIRCLE in mapMSSQL2008.c\n");
+            break;
 
-            default:
-              msDebug( "Unsupported layer type in msMSSQL2008LayerNextShape()!" );
-              break;
+          default:
+            msDebug("Unsupported layer type in msMSSQL2008LayerNextShape()!");
+            break;
           }
           find_bounds(shape);
         }
 
-        //free(wkbBuffer);
+        // free(wkbBuffer);
         msFree(wkbTemp);
       }
 
-      /* Next get unique id for row - since the OID shouldn't be larger than a long we'll assume billions as a limit */
-      rc = SQLGetData(layerinfo->conn->hstmt, (SQLUSMALLINT)(layer->numitems + 2), SQL_C_BINARY, oidBuffer, sizeof(oidBuffer) - 1, &retLen);
+      /* Next get unique id for row - since the OID shouldn't be larger than a
+       * long we'll assume billions as a limit */
+      rc = SQLGetData(layerinfo->conn->hstmt,
+                      (SQLUSMALLINT)(layer->numitems + 2), SQL_C_BINARY,
+                      oidBuffer, sizeof(oidBuffer) - 1, &retLen);
       if (rc == SQL_ERROR || rc == SQL_SUCCESS_WITH_INFO)
         handleSQLError(layer);
 
-      if (retLen < (int)sizeof(oidBuffer))
-	  {
-		oidBuffer[retLen] = 0;
-		record_oid = strtol(oidBuffer, NULL, 10);
-		shape->index = record_oid;
-	  }
-	  else
-	  {
-		/* non integer fid column, use single pass */
-		shape->index = -1;
-	  }
+      if (retLen < (int)sizeof(oidBuffer)) {
+        oidBuffer[retLen] = 0;
+        record_oid = strtol(oidBuffer, NULL, 10);
+        shape->index = record_oid;
+      } else {
+        /* non integer fid column, use single pass */
+        shape->index = -1;
+      }
 
       shape->resultindex = (*record);
 
-      (*record)++;        /* move to next shape */
+      (*record)++; /* move to next shape */
 
-      if(shape->type != MS_SHAPE_NULL) {
+      if (shape->type != MS_SHAPE_NULL) {
         return MS_SUCCESS;
       } else {
         msDebug("msMSSQL2008LayerGetShapeRandom bad shape: %ld\n", *record);
@@ -2440,19 +2513,20 @@ int msMSSQL2008LayerGetShapeRandom(layer
   return MS_FAILURE;
 }
 
-/* find the next shape with the appropriate shape type (convert it if necessary) */
+/* find the next shape with the appropriate shape type (convert it if necessary)
+ */
 /* also, load in the attribute data */
 /* MS_DONE => no more data */
-int msMSSQL2008LayerNextShape(layerObj *layer, shapeObj *shape)
-{
-  int     result;
+int msMSSQL2008LayerNextShape(layerObj *layer, shapeObj *shape) {
+  int result;
 
-  msMSSQL2008LayerInfo  *layerinfo;
+  msMSSQL2008LayerInfo *layerinfo;
 
   layerinfo = getMSSQL2008LayerInfo(layer);
 
-  if(!layerinfo) {
-    msSetError(MS_QUERYERR, "NextShape called with layerinfo = NULL", "msMSSQL2008LayerNextShape()");
+  if (!layerinfo) {
+    msSetError(MS_QUERYERR, "NextShape called with layerinfo = NULL",
+               "msMSSQL2008LayerNextShape()");
     return MS_FAILURE;
   }
 
@@ -2464,44 +2538,53 @@ int msMSSQL2008LayerNextShape(layerObj *
 }
 
 /* Execute a query on the DB based on the query result. */
-int msMSSQL2008LayerGetShape(layerObj *layer, shapeObj *shape, resultObj *record)
-{
-  char    *query_str;
-  char    *columns_wanted = 0;
+int msMSSQL2008LayerGetShape(layerObj *layer, shapeObj *shape,
+                             resultObj *record) {
+  char *query_str;
+  char *columns_wanted = 0;
 
-  msMSSQL2008LayerInfo  *layerinfo;
-  int                 t;
+  msMSSQL2008LayerInfo *layerinfo;
+  int t;
   char buffer[32000] = "";
   long shapeindex = record->shapeindex;
   long resultindex = record->resultindex;
 
-  if(layer->debug) {
-    msDebug("msMSSQL2008LayerGetShape called for shapeindex = %ld\n", shapeindex);
+  if (layer->debug) {
+    msDebug("msMSSQL2008LayerGetShape called for shapeindex = %ld\n",
+            shapeindex);
   }
 
   layerinfo = getMSSQL2008LayerInfo(layer);
 
-  if(!layerinfo) {
+  if (!layerinfo) {
     /* Layer not open */
-    msSetError(MS_QUERYERR, "msMSSQL2008LayerGetShape called on unopened layer (layerinfo = NULL)", "msMSSQL2008LayerGetShape()");
+    msSetError(
+        MS_QUERYERR,
+        "msMSSQL2008LayerGetShape called on unopened layer (layerinfo = NULL)",
+        "msMSSQL2008LayerGetShape()");
 
     return MS_FAILURE;
   }
 
   if (resultindex >= 0 && layerinfo->sql) {
-    /* trying to provide the result from the current resultset (single-pass query) */
-    if( resultindex < layerinfo->row_num) {
+    /* trying to provide the result from the current resultset (single-pass
+     * query) */
+    if (resultindex < layerinfo->row_num) {
       /* re-issue the query */
       if (!executeSQL(layerinfo->conn, layerinfo->sql)) {
-        msSetError(MS_QUERYERR, "Error executing MSSQL2008 SQL statement: %s\n-%s\n", "msMSSQL2008LayerGetShape()", layerinfo->sql, layerinfo->conn->errorMessage);
+        msSetError(MS_QUERYERR,
+                   "Error executing MSSQL2008 SQL statement: %s\n-%s\n",
+                   "msMSSQL2008LayerGetShape()", layerinfo->sql,
+                   layerinfo->conn->errorMessage);
 
         return MS_FAILURE;
       }
       layerinfo->row_num = 0;
     }
-    while( layerinfo->row_num < resultindex ) {
+    while (layerinfo->row_num < resultindex) {
       /* move forward until we reach the desired index */
-      if (msMSSQL2008LayerGetShapeRandom(layer, shape, &(layerinfo->row_num)) != MS_SUCCESS)
+      if (msMSSQL2008LayerGetShapeRandom(layer, shape, &(layerinfo->row_num)) !=
+          MS_SUCCESS)
         return MS_FAILURE;
     }
 
@@ -2510,39 +2593,51 @@ int msMSSQL2008LayerGetShape(layerObj *l
 
   /* non single-pass case, fetch the record from the database */
 
-  if(layer->numitems == 0) {
+  if (layer->numitems == 0) {
     if (layerinfo->geometry_format == MSSQLGEOMETRY_NATIVE)
-      snprintf(buffer, sizeof(buffer), "%s, convert(varchar(36), %s)", layerinfo->geom_column, layerinfo->urid_name);
+      snprintf(buffer, sizeof(buffer), "%s, convert(varchar(36), %s)",
+               layerinfo->geom_column, layerinfo->urid_name);
     else
-      snprintf(buffer, sizeof(buffer), "%s.STAsBinary(), convert(varchar(36), %s)", layerinfo->geom_column, layerinfo->urid_name);
+      snprintf(buffer, sizeof(buffer),
+               "%s.STAsBinary(), convert(varchar(36), %s)",
+               layerinfo->geom_column, layerinfo->urid_name);
     columns_wanted = msStrdup(buffer);
   } else {
-    for(t = 0; t < layer->numitems; t++) {
-      snprintf(buffer + strlen(buffer), sizeof(buffer) - strlen(buffer), "convert(varchar(max), %s),", layer->items[t]);
+    for (t = 0; t < layer->numitems; t++) {
+      snprintf(buffer + strlen(buffer), sizeof(buffer) - strlen(buffer),
+               "convert(varchar(max), %s),", layer->items[t]);
     }
 
     if (layerinfo->geometry_format == MSSQLGEOMETRY_NATIVE)
-      snprintf(buffer + strlen(buffer), sizeof(buffer) - strlen(buffer), "%s, convert(varchar(36), %s)", layerinfo->geom_column, layerinfo->urid_name);
+      snprintf(buffer + strlen(buffer), sizeof(buffer) - strlen(buffer),
+               "%s, convert(varchar(36), %s)", layerinfo->geom_column,
+               layerinfo->urid_name);
     else
-      snprintf(buffer + strlen(buffer), sizeof(buffer) - strlen(buffer), "%s.STAsBinary(), convert(varchar(36), %s)", layerinfo->geom_column, layerinfo->urid_name);
+      snprintf(buffer + strlen(buffer), sizeof(buffer) - strlen(buffer),
+               "%s.STAsBinary(), convert(varchar(36), %s)",
+               layerinfo->geom_column, layerinfo->urid_name);
 
     columns_wanted = msStrdup(buffer);
   }
 
-  /* index_name is ignored here since the hint should be for the spatial index, not the PK index */
-  snprintf(buffer, sizeof(buffer), "select %s from %s where %s = %ld", columns_wanted, layerinfo->geom_table, layerinfo->urid_name, shapeindex);
+  /* index_name is ignored here since the hint should be for the spatial index,
+   * not the PK index */
+  snprintf(buffer, sizeof(buffer), "select %s from %s where %s = %ld",
+           columns_wanted, layerinfo->geom_table, layerinfo->urid_name,
+           shapeindex);
 
   query_str = msStrdup(buffer);
 
-  if(layer->debug) {
+  if (layer->debug) {
     msDebug("msMSSQL2008LayerGetShape: %s \n", query_str);
   }
 
   msFree(columns_wanted);
 
   if (!executeSQL(layerinfo->conn, query_str)) {
-    msSetError(MS_QUERYERR, "Error executing MSSQL2008 SQL statement: %s\n-%s\n", "msMSSQL2008LayerGetShape()",
-               query_str, layerinfo->conn->errorMessage);
+    msSetError(
+        MS_QUERYERR, "Error executing MSSQL2008 SQL statement: %s\n-%s\n",
+        "msMSSQL2008LayerGetShape()", query_str, layerinfo->conn->errorMessage);
 
     msFree(query_str);
 
@@ -2558,167 +2653,180 @@ int msMSSQL2008LayerGetShape(layerObj *l
 
 /*
 ** Returns the number of shapes that match the potential filter and extent.
- * rectProjection is the projection in which rect is expressed, or can be NULL if
- * rect should be considered in the layer projection.
- * This should be equivalent to calling msLayerWhichShapes() and counting the
- * number of shapes returned by msLayerNextShape(), honouring layer->maxfeatures
- * limitation if layer->maxfeatures>=0, and honouring layer->startindex if
- * layer->startindex >= 1 and paging is enabled.
- * Returns -1 in case of failure.
- */
-int msMSSQL2008LayerGetShapeCount(layerObj *layer, rectObj rect, projectionObj *rectProjection)
-{
-    msMSSQL2008LayerInfo *layerinfo;
-    char *query = 0;
-    char result_data[256];
-    char box3d[40 + 10 * 22 + 11];
-    SQLLEN retLen;
-    SQLRETURN rc;
-    int hasFilter = MS_FALSE;
-    const rectObj rectInvalid = MS_INIT_INVALID_RECT;
-    const int bIsValidRect = memcmp(&rect, &rectInvalid, sizeof(rect)) != 0;
-
-    rectObj searchrectInLayerProj = rect;
+* rectProjection is the projection in which rect is expressed, or can be NULL if
+* rect should be considered in the layer projection.
+* This should be equivalent to calling msLayerWhichShapes() and counting the
+* number of shapes returned by msLayerNextShape(), honouring layer->maxfeatures
+* limitation if layer->maxfeatures>=0, and honouring layer->startindex if
+* layer->startindex >= 1 and paging is enabled.
+* Returns -1 in case of failure.
+*/
+int msMSSQL2008LayerGetShapeCount(layerObj *layer, rectObj rect,
+                                  projectionObj *rectProjection) {
+  msMSSQL2008LayerInfo *layerinfo;
+  char *query = 0;
+  char result_data[256];
+  char box3d[40 + 10 * 22 + 11];
+  SQLLEN retLen;
+  SQLRETURN rc;
+  int hasFilter = MS_FALSE;
+  const rectObj rectInvalid = MS_INIT_INVALID_RECT;
+  const int bIsValidRect = memcmp(&rect, &rectInvalid, sizeof(rect)) != 0;
 
-    if (layer->debug) {
-        msDebug("msMSSQL2008LayerGetShapeCount called.\n");
-    }
+  rectObj searchrectInLayerProj = rect;
 
-    layerinfo = getMSSQL2008LayerInfo(layer);
+  if (layer->debug) {
+    msDebug("msMSSQL2008LayerGetShapeCount called.\n");
+  }
 
-    if (!layerinfo) {
-        /* Layer not open */
-        msSetError(MS_QUERYERR, "msMSSQL2008LayerGetShapeCount called on unopened layer (layerinfo = NULL)", "msMSSQL2008LayerGetShapeCount()");
+  layerinfo = getMSSQL2008LayerInfo(layer);
 
-        return MS_FAILURE;
-    }
+  if (!layerinfo) {
+    /* Layer not open */
+    msSetError(MS_QUERYERR,
+               "msMSSQL2008LayerGetShapeCount called on unopened layer "
+               "(layerinfo = NULL)",
+               "msMSSQL2008LayerGetShapeCount()");
 
-    // Special processing if the specified projection for the rect is different from the layer projection
-    // We want to issue a WHERE that includes
-    // ((the_geom && rect_reprojected_in_layer_SRID) AND NOT ST_Disjoint(ST_Transform(the_geom, rect_SRID), rect))
-    if (rectProjection != NULL && layer->project &&
-        msProjectionsDiffer(&(layer->projection), rectProjection))
-    {
-        // If we cannot guess the EPSG code of the rectProjection, fallback on slow implementation
-        if (rectProjection->numargs < 1 ||
-            strncasecmp(rectProjection->args[0], "init=epsg:", (int)strlen("init=epsg:")) != 0)
-        {
-            if (layer->debug) {
-                msDebug("msMSSQL2008LayerGetShapeCount(): cannot find EPSG code of rectProjection. Falling back on client-side feature count.\n");
-            }
-            return LayerDefaultGetShapeCount(layer, rect, rectProjection);
-        }
+    return MS_FAILURE;
+  }
 
-        // Reproject the passed rect into the layer projection and get
-        // the SRID from the rectProjection
-        msProjectRect(rectProjection, &(layer->projection), &searchrectInLayerProj); /* project the searchrect to source coords */
-    }
-
-    if (searchrectInLayerProj.minx == searchrectInLayerProj.maxx || 
-        searchrectInLayerProj.miny == searchrectInLayerProj.maxy) {
-        /* create point shape for rectangles with zero area */
-        snprintf(box3d, sizeof(box3d), "%s::STGeomFromText('POINT(%.15g %.15g)',%s)", /* %s.STSrid)", */
-            layerinfo->geom_column_type, searchrectInLayerProj.minx, searchrectInLayerProj.miny, layerinfo->user_srid);
-    }
-    else {
-         snprintf(box3d, sizeof(box3d), "%s::STGeomFromText('POLYGON((%.15g %.15g,%.15g %.15g,%.15g %.15g,%.15g %.15g,%.15g %.15g))',%s)", /* %s.STSrid)", */
-            layerinfo->geom_column_type,
-            searchrectInLayerProj.minx, searchrectInLayerProj.miny,
-            searchrectInLayerProj.maxx, searchrectInLayerProj.miny,
-            searchrectInLayerProj.maxx, searchrectInLayerProj.maxy,
-            searchrectInLayerProj.minx, searchrectInLayerProj.maxy,
-            searchrectInLayerProj.minx, searchrectInLayerProj.miny,
-            layerinfo->user_srid
-        );
+  // Special processing if the specified projection for the rect is different
+  // from the layer projection We want to issue a WHERE that includes
+  // ((the_geom && rect_reprojected_in_layer_SRID) AND NOT
+  // ST_Disjoint(ST_Transform(the_geom, rect_SRID), rect))
+  if (rectProjection != NULL && layer->project &&
+      msProjectionsDiffer(&(layer->projection), rectProjection)) {
+    // If we cannot guess the EPSG code of the rectProjection, fallback on slow
+    // implementation
+    if (rectProjection->numargs < 1 ||
+        strncasecmp(rectProjection->args[0],
+                    "init=epsg:", (int)strlen("init=epsg:")) != 0) {
+      if (layer->debug) {
+        msDebug("msMSSQL2008LayerGetShapeCount(): cannot find EPSG code of "
+                "rectProjection. Falling back on client-side feature count.\n");
+      }
+      return LayerDefaultGetShapeCount(layer, rect, rectProjection);
     }
 
-    msLayerTranslateFilter(layer, &layer->filter, layer->filteritem);
-
-    /* set up statement */
-    query = msStringConcatenate(query, "SELECT count(*) FROM ");
-    query = msStringConcatenate(query, layerinfo->geom_table);
+    // Reproject the passed rect into the layer projection and get
+    // the SRID from the rectProjection
+    msProjectRect(
+        rectProjection, &(layer->projection),
+        &searchrectInLayerProj); /* project the searchrect to source coords */
+  }
+
+  if (searchrectInLayerProj.minx == searchrectInLayerProj.maxx ||
+      searchrectInLayerProj.miny == searchrectInLayerProj.maxy) {
+    /* create point shape for rectangles with zero area */
+    snprintf(box3d, sizeof(box3d),
+             "%s::STGeomFromText('POINT(%.15g %.15g)',%s)", /* %s.STSrid)", */
+             layerinfo->geom_column_type, searchrectInLayerProj.minx,
+             searchrectInLayerProj.miny, layerinfo->user_srid);
+  } else {
+    snprintf(box3d, sizeof(box3d),
+             "%s::STGeomFromText('POLYGON((%.15g %.15g,%.15g %.15g,%.15g "
+             "%.15g,%.15g %.15g,%.15g %.15g))',%s)", /* %s.STSrid)", */
+             layerinfo->geom_column_type, searchrectInLayerProj.minx,
+             searchrectInLayerProj.miny, searchrectInLayerProj.maxx,
+             searchrectInLayerProj.miny, searchrectInLayerProj.maxx,
+             searchrectInLayerProj.maxy, searchrectInLayerProj.minx,
+             searchrectInLayerProj.maxy, searchrectInLayerProj.minx,
+             searchrectInLayerProj.miny, layerinfo->user_srid);
+  }
+
+  msLayerTranslateFilter(layer, &layer->filter, layer->filteritem);
+
+  /* set up statement */
+  query = msStringConcatenate(query, "SELECT count(*) FROM ");
+  query = msStringConcatenate(query, layerinfo->geom_table);
 
-    /* adding attribute filter */
-    hasFilter = addFilter(layer, &query);
+  /* adding attribute filter */
+  hasFilter = addFilter(layer, &query);
 
-    if( bIsValidRect ) {
-        /* adding spatial filter */
-        if (hasFilter == MS_FALSE)
-            query = msStringConcatenate(query, " WHERE ");
-        else
-            query = msStringConcatenate(query, " AND ");
-
-        query = msStringConcatenate(query, layerinfo->geom_column);
-        query = msStringConcatenate(query, ".STIntersects(");
-        query = msStringConcatenate(query, box3d);
-        query = msStringConcatenate(query, ") = 1 ");
-    }
+  if (bIsValidRect) {
+    /* adding spatial filter */
+    if (hasFilter == MS_FALSE)
+      query = msStringConcatenate(query, " WHERE ");
+    else
+      query = msStringConcatenate(query, " AND ");
 
-    if (layer->debug) {
-      msDebug("query:%s\n", query);
-    }
+    query = msStringConcatenate(query, layerinfo->geom_column);
+    query = msStringConcatenate(query, ".STIntersects(");
+    query = msStringConcatenate(query, box3d);
+    query = msStringConcatenate(query, ") = 1 ");
+  }
 
-    if (!executeSQL(layerinfo->conn, query)) {
-        msFree(query);
-        return -1;
-    }
+  if (layer->debug) {
+    msDebug("query:%s\n", query);
+  }
 
+  if (!executeSQL(layerinfo->conn, query)) {
     msFree(query);
+    return -1;
+  }
 
-    rc = SQLFetch(layerinfo->conn->hstmt);
+  msFree(query);
 
-    if (rc != SQL_SUCCESS && rc != SQL_SUCCESS_WITH_INFO) {
-        if (layer->debug) {
-            msDebug("msMSSQL2008LayerGetShapeCount: No results found.\n");
-        }
+  rc = SQLFetch(layerinfo->conn->hstmt);
 
-        return -1;
+  if (rc != SQL_SUCCESS && rc != SQL_SUCCESS_WITH_INFO) {
+    if (layer->debug) {
+      msDebug("msMSSQL2008LayerGetShapeCount: No results found.\n");
     }
 
-    rc = SQLGetData(layerinfo->conn->hstmt, 1, SQL_C_CHAR, result_data, sizeof(result_data), &retLen);
+    return -1;
+  }
+
+  rc = SQLGetData(layerinfo->conn->hstmt, 1, SQL_C_CHAR, result_data,
+                  sizeof(result_data), &retLen);
 
-    if (rc == SQL_ERROR) {
-        msSetError(MS_QUERYERR, "Failed to get feature count", "msMSSQL2008LayerGetShapeCount()");
-        return -1;
-    }
+  if (rc == SQL_ERROR) {
+    msSetError(MS_QUERYERR, "Failed to get feature count",
+               "msMSSQL2008LayerGetShapeCount()");
+    return -1;
+  }
 
-    result_data[retLen] = 0;
+  result_data[retLen] = 0;
 
-    return atoi(result_data);
+  return atoi(result_data);
 }
 
 /* Query the DB for info about the requested table */
-int msMSSQL2008LayerGetItems(layerObj *layer)
-{
-  msMSSQL2008LayerInfo  *layerinfo;
-  char                *sql = NULL;
-  size_t              sqlSize;
-  char                found_geom = 0;
-  int                 t, item_num;
+int msMSSQL2008LayerGetItems(layerObj *layer) {
+  msMSSQL2008LayerInfo *layerinfo;
+  char *sql = NULL;
+  size_t sqlSize;
+  char found_geom = 0;
+  int t, item_num;
   SQLSMALLINT cols = 0;
   const char *value;
   /*
-  * Pass the field definitions through to the layer metadata in the
-  * "gml_[item]_{type,width,precision}" set of metadata items for
-  * defining fields.
-  */
-  char                pass_field_def = 0;
+   * Pass the field definitions through to the layer metadata in the
+   * "gml_[item]_{type,width,precision}" set of metadata items for
+   * defining fields.
+   */
+  char pass_field_def = 0;
 
-  if(layer->debug) {
+  if (layer->debug) {
     msDebug("in msMSSQL2008LayerGetItems  (find column names)\n");
   }
 
   layerinfo = getMSSQL2008LayerInfo(layer);
 
-  if(!layerinfo) {
+  if (!layerinfo) {
     /* layer not opened yet */
-    msSetError(MS_QUERYERR, "msMSSQL2008LayerGetItems called on unopened layer", "msMSSQL2008LayerGetItems()");
+    msSetError(MS_QUERYERR, "msMSSQL2008LayerGetItems called on unopened layer",
+               "msMSSQL2008LayerGetItems()");
 
     return MS_FAILURE;
   }
 
-  if(!layerinfo->conn) {
-    msSetError(MS_QUERYERR, "msMSSQL2008LayerGetItems called on MSSQL2008 layer with no connection to DB.", "msMSSQL2008LayerGetItems()");
+  if (!layerinfo->conn) {
+    msSetError(MS_QUERYERR,
+               "msMSSQL2008LayerGetItems called on MSSQL2008 layer with no "
+               "connection to DB.",
+               "msMSSQL2008LayerGetItems()");
 
     return MS_FAILURE;
   }
@@ -2735,12 +2843,16 @@ int msMSSQL2008LayerGetItems(layerObj *l
 
   msFree(sql);
 
-  SQLNumResultCols (layerinfo->conn->hstmt, &cols);
+  SQLNumResultCols(layerinfo->conn->hstmt, &cols);
 
   layer->numitems = cols - 1; /* dont include the geometry column */
 
-  layer->items = msSmallMalloc(sizeof(char *) * (layer->numitems + 1)); /* +1 in case there is a problem finding goeometry column */
-  layerinfo->itemtypes = msSmallMalloc(sizeof(SQLSMALLINT) * (layer->numitems + 1));
+  layer->items = msSmallMalloc(
+      sizeof(char *) *
+      (layer->numitems +
+       1)); /* +1 in case there is a problem finding goeometry column */
+  layerinfo->itemtypes =
+      msSmallMalloc(sizeof(SQLSMALLINT) * (layer->numitems + 1));
   /* it will return an error if there is no geometry column found, */
   /* so this isnt a problem */
 
@@ -2748,19 +2860,20 @@ int msMSSQL2008LayerGetItems(layerObj *l
   item_num = 0;
 
   /* consider populating the field definitions in metadata */
-  if((value = msOWSLookupMetadata(&(layer->metadata), "G", "types")) != NULL
-      && strcasecmp(value,"auto") == 0 )
+  if ((value = msOWSLookupMetadata(&(layer->metadata), "G", "types")) != NULL &&
+      strcasecmp(value, "auto") == 0)
     pass_field_def = 1;
 
-  for(t = 0; t < cols; t++) {
+  for (t = 0; t < cols; t++) {
     char colBuff[256];
     SQLSMALLINT itemType = 0;
 
-    columnName(layerinfo->conn, t + 1, colBuff, sizeof(colBuff), layer, pass_field_def, &itemType);
+    columnName(layerinfo->conn, t + 1, colBuff, sizeof(colBuff), layer,
+               pass_field_def, &itemType);
 
-    if(strcmp(colBuff, layerinfo->geom_column) != 0) {
+    if (strcmp(colBuff, layerinfo->geom_column) != 0) {
       /* this isnt the geometry column */
-      layer->items[item_num] = (char *) msSmallMalloc(strlen(colBuff) + 1);
+      layer->items[item_num] = (char *)msSmallMalloc(strlen(colBuff) + 1);
       strcpy(layer->items[item_num], colBuff);
       layerinfo->itemtypes[item_num] = itemType;
       item_num++;
@@ -2769,8 +2882,12 @@ int msMSSQL2008LayerGetItems(layerObj *l
     }
   }
 
-  if(!found_geom) {
-    msSetError(MS_QUERYERR, "msMSSQL2008LayerGetItems: tried to find the geometry column in the results from the database, but couldnt find it.  Is it miss-capitialized? '%s'", "msMSSQL2008LayerGetItems()", layerinfo->geom_column);
+  if (!found_geom) {
+    msSetError(MS_QUERYERR,
+               "msMSSQL2008LayerGetItems: tried to find the geometry column in "
+               "the results from the database, but couldnt find it.  Is it "
+               "miss-capitialized? '%s'",
+               "msMSSQL2008LayerGetItems()", layerinfo->geom_column);
     return MS_FAILURE;
   }
 
@@ -2778,55 +2895,64 @@ int msMSSQL2008LayerGetItems(layerObj *l
 }
 
 /* Get primary key column of table */
-int msMSSQL2008LayerRetrievePK(layerObj *layer, char **urid_name, char* table_name, int debug)
-{
+int msMSSQL2008LayerRetrievePK(layerObj *layer, char **urid_name,
+                               char *table_name, int debug) {
 
-  char        sql[1024];
+  char sql[1024];
   msMSSQL2008LayerInfo *layerinfo = 0;
   SQLRETURN rc;
 
   snprintf(sql, sizeof(sql),
-           "SELECT     convert(varchar(50), sys.columns.name) AS ColumnName, sys.indexes.name "
+           "SELECT     convert(varchar(50), sys.columns.name) AS ColumnName, "
+           "sys.indexes.name "
            "FROM         sys.columns INNER JOIN "
            "                     sys.indexes INNER JOIN "
-           "                     sys.tables ON sys.indexes.object_id = sys.tables.object_id INNER JOIN "
-           "                     sys.index_columns ON sys.indexes.object_id = sys.index_columns.object_id AND sys.indexes.index_id = sys.index_columns.index_id ON "
-           "                     sys.columns.object_id = sys.index_columns.object_id AND sys.columns.column_id = sys.index_columns.column_id "
-           "WHERE     (sys.indexes.is_primary_key = 1) AND (sys.tables.name = N'%s') ",
+           "                     sys.tables ON sys.indexes.object_id = "
+           "sys.tables.object_id INNER JOIN "
+           "                     sys.index_columns ON sys.indexes.object_id = "
+           "sys.index_columns.object_id AND sys.indexes.index_id = "
+           "sys.index_columns.index_id ON "
+           "                     sys.columns.object_id = "
+           "sys.index_columns.object_id AND sys.columns.column_id = "
+           "sys.index_columns.column_id "
+           "WHERE     (sys.indexes.is_primary_key = 1) AND (sys.tables.name = "
+           "N'%s') ",
            table_name);
 
   if (debug) {
     msDebug("msMSSQL2008LayerRetrievePK: query = %s\n", sql);
   }
 
-  layerinfo = (msMSSQL2008LayerInfo *) layer->layerinfo;
+  layerinfo = (msMSSQL2008LayerInfo *)layer->layerinfo;
 
-  if(layerinfo->conn == NULL) {
+  if (layerinfo->conn == NULL) {
 
-    msSetError(MS_QUERYERR, "Layer does not have a MSSQL2008 connection.", "msMSSQL2008LayerRetrievePK()");
+    msSetError(MS_QUERYERR, "Layer does not have a MSSQL2008 connection.",
+               "msMSSQL2008LayerRetrievePK()");
 
-    return(MS_FAILURE);
+    return (MS_FAILURE);
   }
 
   /* error somewhere above here in this method */
 
-  if(!executeSQL(layerinfo->conn, sql)) {
+  if (!executeSQL(layerinfo->conn, sql)) {
     char *tmp1;
     char *tmp2 = NULL;
 
     tmp1 = "Error executing MSSQL2008 statement (msMSSQL2008LayerRetrievePK():";
-    tmp2 = (char *)msSmallMalloc(sizeof(char)*(strlen(tmp1) + strlen(sql) + 1));
+    tmp2 =
+        (char *)msSmallMalloc(sizeof(char) * (strlen(tmp1) + strlen(sql) + 1));
     strcpy(tmp2, tmp1);
     strcat(tmp2, sql);
     msSetError(MS_QUERYERR, "%s", "msMSSQL2008LayerRetrievePK()", tmp2);
     msFree(tmp2);
-    return(MS_FAILURE);
+    return (MS_FAILURE);
   }
 
   rc = SQLFetch(layerinfo->conn->hstmt);
 
-  if(rc != SQL_SUCCESS && rc != SQL_SUCCESS_WITH_INFO) {
-    if(debug) {
+  if (rc != SQL_SUCCESS && rc != SQL_SUCCESS_WITH_INFO) {
+    if (debug) {
       msDebug("msMSSQL2008LayerRetrievePK: No results found.\n");
     }
 
@@ -2836,13 +2962,15 @@ int msMSSQL2008LayerRetrievePK(layerObj
   {
     char buff[100];
     SQLLEN retLen;
-    rc = SQLGetData(layerinfo->conn->hstmt, 1, SQL_C_BINARY, buff, sizeof(buff), &retLen);
+    rc = SQLGetData(layerinfo->conn->hstmt, 1, SQL_C_BINARY, buff, sizeof(buff),
+                    &retLen);
 
     rc = SQLFetch(layerinfo->conn->hstmt);
 
-    if(rc == SQL_SUCCESS || rc == SQL_SUCCESS_WITH_INFO) {
-      if(debug) {
-        msDebug("msMSSQL2008LayerRetrievePK: Multiple primary key columns are not supported in MapServer\n");
+    if (rc == SQL_SUCCESS || rc == SQL_SUCCESS_WITH_INFO) {
+      if (debug) {
+        msDebug("msMSSQL2008LayerRetrievePK: Multiple primary key columns are "
+                "not supported in MapServer\n");
       }
 
       return MS_FAILURE;
@@ -2860,10 +2988,14 @@ int msMSSQL2008LayerRetrievePK(layerObj
  * column name, table name and name of a column to serve as a
  * unique record id
  */
-static int msMSSQL2008LayerParseData(layerObj *layer, char **geom_column_name, char **geom_column_type, char **table_name, char **urid_name, char **user_srid, char **index_name, char **sort_spec, int debug)
-{
-  char    *pos_opt, *pos_scn, *tmp, *pos_srid, *pos_urid, *pos_geomtype, *pos_geomtype2, *pos_indexHint, *data, *pos_order;
-  size_t     slength;
+static int msMSSQL2008LayerParseData(layerObj *layer, char **geom_column_name,
+                                     char **geom_column_type, char **table_name,
+                                     char **urid_name, char **user_srid,
+                                     char **index_name, char **sort_spec,
+                                     int debug) {
+  char *pos_opt, *pos_scn, *tmp, *pos_srid, *pos_urid, *pos_geomtype,
+      *pos_geomtype2, *pos_indexHint, *data, *pos_order;
+  size_t slength;
 
   data = msStrdup(layer->data);
   /* replace tabs with spaces */
@@ -2877,57 +3009,72 @@ static int msMSSQL2008LayerParseData(lay
   /* First look for the optional ' using unique ID' string */
   pos_urid = strstrIgnoreCase(data, " using unique ");
 
-  if(pos_urid) {
-    /* CHANGE - protect the trailing edge for thing like 'using unique ftab_id using srid=33' */
+  if (pos_urid) {
+    /* CHANGE - protect the trailing edge for thing like 'using unique ftab_id
+     * using srid=33' */
     tmp = strstr(pos_urid + 14, " ");
-    if(!tmp) {
+    if (!tmp) {
       tmp = pos_urid + strlen(pos_urid);
     }
-    *urid_name = (char *) msSmallMalloc((tmp - (pos_urid + 14)) + 1);
+    *urid_name = (char *)msSmallMalloc((tmp - (pos_urid + 14)) + 1);
     strlcpy(*urid_name, pos_urid + 14, (tmp - (pos_urid + 14)) + 1);
   }
 
   /* Find the srid */
   pos_srid = strstrIgnoreCase(data, " using SRID=");
-  if(!pos_srid) {
-    *user_srid = (char *) msSmallMalloc(2);
+  if (!pos_srid) {
+    *user_srid = (char *)msSmallMalloc(2);
     (*user_srid)[0] = '0';
     (*user_srid)[1] = 0;
   } else {
     slength = strspn(pos_srid + 12, "-0123456789");
-    if(!slength) {
-      msSetError(MS_QUERYERR, DATA_ERROR_MESSAGE, "msMSSQL2008LayerParseData()", "Error parsing MSSQL2008 data variable: You specified 'using SRID=#' but didn't have any numbers!<br><br>\n\nMore Help:<br><br>\n\n", data);
+    if (!slength) {
+      msSetError(
+          MS_QUERYERR, DATA_ERROR_MESSAGE, "msMSSQL2008LayerParseData()",
+          "Error parsing MSSQL2008 data variable: You specified 'using SRID=#' "
+          "but didn't have any numbers!<br><br>\n\nMore Help:<br><br>\n\n",
+          data);
 
       msFree(data);
       return MS_FAILURE;
     } else {
-      *user_srid = (char *) msSmallMalloc(slength + 1);
-      strlcpy(*user_srid, pos_srid + 12, slength+1);
+      *user_srid = (char *)msSmallMalloc(slength + 1);
+      strlcpy(*user_srid, pos_srid + 12, slength + 1);
     }
   }
 
   pos_indexHint = strstrIgnoreCase(data, " using index ");
-  if(pos_indexHint) {
-    /* CHANGE - protect the trailing edge for thing like 'using unique ftab_id using srid=33' */
+  if (pos_indexHint) {
+    /* CHANGE - protect the trailing edge for thing like 'using unique ftab_id
+     * using srid=33' */
     tmp = strstr(pos_indexHint + 13, " ");
-    if(!tmp) {
+    if (!tmp) {
       tmp = pos_indexHint + strlen(pos_indexHint);
     }
-    *index_name = (char *) msSmallMalloc((tmp - (pos_indexHint + 13)) + 1);
-    strlcpy(*index_name, pos_indexHint + 13, tmp - (pos_indexHint + 13)+1);
+    *index_name = (char *)msSmallMalloc((tmp - (pos_indexHint + 13)) + 1);
+    strlcpy(*index_name, pos_indexHint + 13, tmp - (pos_indexHint + 13) + 1);
   }
 
-  /* this is a little hack so the rest of the code works.  If the ' using SRID=' comes before */
-  /* the ' using unique ', then make sure pos_opt points to where the ' using SRID' starts! */
+  /* this is a little hack so the rest of the code works.  If the ' using SRID='
+   * comes before */
+  /* the ' using unique ', then make sure pos_opt points to where the ' using
+   * SRID' starts! */
   pos_opt = pos_urid;
-  if ( !pos_opt || ( pos_srid && pos_srid < pos_opt ) ) pos_opt = pos_srid;
-  if ( !pos_opt || ( pos_indexHint && pos_indexHint < pos_opt ) ) pos_opt = pos_indexHint;
-  if ( !pos_opt ) pos_opt = data + strlen(data);
+  if (!pos_opt || (pos_srid && pos_srid < pos_opt))
+    pos_opt = pos_srid;
+  if (!pos_opt || (pos_indexHint && pos_indexHint < pos_opt))
+    pos_opt = pos_indexHint;
+  if (!pos_opt)
+    pos_opt = data + strlen(data);
 
   /* Scan for the table or sub-select clause */
   pos_scn = strstrIgnoreCase(data, " from ");
-  if(!pos_scn) {
-    msSetError(MS_QUERYERR, DATA_ERROR_MESSAGE, "msMSSQL2008LayerParseData()", "Error parsing MSSQL2008 data variable.  Must contain 'geometry_column from table_name' or 'geom from (subselect) as foo' (couldn't find ' from ').  More help: <br><br>\n\n", data);
+  if (!pos_scn) {
+    msSetError(MS_QUERYERR, DATA_ERROR_MESSAGE, "msMSSQL2008LayerParseData()",
+               "Error parsing MSSQL2008 data variable.  Must contain "
+               "'geometry_column from table_name' or 'geom from (subselect) as "
+               "foo' (couldn't find ' from ').  More help: <br><br>\n\n",
+               data);
 
     msFree(data);
     return MS_FAILURE;
@@ -2938,42 +3085,54 @@ static int msMSSQL2008LayerParseData(lay
   while (pos_geomtype < pos_scn && *pos_geomtype != '(' && *pos_geomtype != 0)
     ++pos_geomtype;
 
-  if(*pos_geomtype == '(') {
+  if (*pos_geomtype == '(') {
     pos_geomtype2 = pos_geomtype;
-    while (pos_geomtype2 < pos_scn && *pos_geomtype2 != ')' && *pos_geomtype2 != 0)
+    while (pos_geomtype2 < pos_scn && *pos_geomtype2 != ')' &&
+           *pos_geomtype2 != 0)
       ++pos_geomtype2;
     if (*pos_geomtype2 != ')' || pos_geomtype2 == pos_geomtype) {
-      msSetError(MS_QUERYERR, DATA_ERROR_MESSAGE, "msMSSQL2008LayerParseData()", "Error parsing MSSQL2008 data variable.  Invalid syntax near geometry column type.", data);
+      msSetError(MS_QUERYERR, DATA_ERROR_MESSAGE, "msMSSQL2008LayerParseData()",
+                 "Error parsing MSSQL2008 data variable.  Invalid syntax near "
+                 "geometry column type.",
+                 data);
       msFree(data);
       return MS_FAILURE;
     }
 
-    *geom_column_name = (char *) msSmallMalloc((pos_geomtype - data) + 1);
+    *geom_column_name = (char *)msSmallMalloc((pos_geomtype - data) + 1);
     strlcpy(*geom_column_name, data, pos_geomtype - data + 1);
 
-    *geom_column_type = (char *) msSmallMalloc(pos_geomtype2 - pos_geomtype);
+    *geom_column_type = (char *)msSmallMalloc(pos_geomtype2 - pos_geomtype);
     strlcpy(*geom_column_type, pos_geomtype + 1, pos_geomtype2 - pos_geomtype);
   } else {
     /* Copy the geometry column name */
-    *geom_column_name = (char *) msSmallMalloc((pos_scn - data) + 1);
+    *geom_column_name = (char *)msSmallMalloc((pos_scn - data) + 1);
     strlcpy(*geom_column_name, data, pos_scn - data + 1);
     *geom_column_type = msStrdup("geometry");
   }
 
   /* Copy out the table name or sub-select clause */
-  *table_name = (char *) msSmallMalloc((pos_opt - (pos_scn + 6)) + 1);
+  *table_name = (char *)msSmallMalloc((pos_opt - (pos_scn + 6)) + 1);
   strlcpy(*table_name, pos_scn + 6, pos_opt - (pos_scn + 6) + 1);
 
-  if(strlen(*table_name) < 1 || strlen(*geom_column_name) < 1) {
-    msSetError(MS_QUERYERR, DATA_ERROR_MESSAGE, "msMSSQL2008LayerParseData()", "Error parsing MSSQL2008 data variable.  Must contain 'geometry_column from table_name' or 'geom from (subselect) as foo' (couldnt find a geometry_column or table/subselect).  More help: <br><br>\n\n", data);
+  if (strlen(*table_name) < 1 || strlen(*geom_column_name) < 1) {
+    msSetError(
+        MS_QUERYERR, DATA_ERROR_MESSAGE, "msMSSQL2008LayerParseData()",
+        "Error parsing MSSQL2008 data variable.  Must contain 'geometry_column "
+        "from table_name' or 'geom from (subselect) as foo' (couldnt find a "
+        "geometry_column or table/subselect).  More help: <br><br>\n\n",
+        data);
 
     msFree(data);
     return MS_FAILURE;
   }
 
-  if( !pos_urid ) {
-    if( msMSSQL2008LayerRetrievePK(layer, urid_name, *table_name, debug) != MS_SUCCESS ) {
-      msSetError(MS_QUERYERR, DATA_ERROR_MESSAGE, "msMSSQL2008LayerParseData()", "No primary key defined for table, or primary key contains more that one column\n\n",
+  if (!pos_urid) {
+    if (msMSSQL2008LayerRetrievePK(layer, urid_name, *table_name, debug) !=
+        MS_SUCCESS) {
+      msSetError(MS_QUERYERR, DATA_ERROR_MESSAGE, "msMSSQL2008LayerParseData()",
+                 "No primary key defined for table, or primary key contains "
+                 "more that one column\n\n",
                  *table_name);
 
       msFree(data);
@@ -2983,32 +3142,34 @@ static int msMSSQL2008LayerParseData(lay
 
   /* Find the order by */
   pos_order = strstrIgnoreCase(pos_opt, " order by ");
-  
+
   if (pos_order) {
     *sort_spec = msStrdup(pos_order);
   }
 
-  if(debug) {
-    msDebug("msMSSQL2008LayerParseData: unique column = %s, srid='%s', geom_column_name = %s, table_name=%s\n", *urid_name, *user_srid, *geom_column_name, *table_name);
+  if (debug) {
+    msDebug("msMSSQL2008LayerParseData: unique column = %s, srid='%s', "
+            "geom_column_name = %s, table_name=%s\n",
+            *urid_name, *user_srid, *geom_column_name, *table_name);
   }
 
   msFree(data);
   return MS_SUCCESS;
 }
 
-char *msMSSQL2008LayerEscapePropertyName(layerObj *layer, const char* pszString)
-{
+char *msMSSQL2008LayerEscapePropertyName(layerObj *layer,
+                                         const char *pszString) {
   (void)layer;
-  char* pszEscapedStr=NULL;
+  char *pszEscapedStr = NULL;
   int j = 0;
 
   if (pszString && strlen(pszString) > 0) {
     size_t nLength = strlen(pszString);
 
-    pszEscapedStr = (char*) msSmallMalloc( 1 + nLength + 1 + 1);
+    pszEscapedStr = (char *)msSmallMalloc(1 + nLength + 1 + 1);
     pszEscapedStr[j++] = '[';
 
-    for (size_t i=0; i<nLength; i++)
+    for (size_t i = 0; i < nLength; i++)
       pszEscapedStr[j++] = pszString[i];
 
     pszEscapedStr[j++] = ']';
@@ -3017,17 +3178,16 @@ char *msMSSQL2008LayerEscapePropertyName
   return pszEscapedStr;
 }
 
-char *msMSSQL2008LayerEscapeSQLParam(layerObj *layer, const char *pszString)
-{
+char *msMSSQL2008LayerEscapeSQLParam(layerObj *layer, const char *pszString) {
   (void)layer;
-  char *pszEscapedStr=NULL;
+  char *pszEscapedStr = NULL;
   if (pszString) {
     int nSrcLen;
     char c;
-    int i=0, j=0;
+    int i = 0, j = 0;
     nSrcLen = (int)strlen(pszString);
-    pszEscapedStr = (char*) msSmallMalloc( 2 * nSrcLen + 1);
-    for(i = 0, j = 0; i < nSrcLen; i++) {
+    pszEscapedStr = (char *)msSmallMalloc(2 * nSrcLen + 1);
+    for (i = 0, j = 0; i < nSrcLen; i++) {
       c = pszString[i];
       if (c == '\'') {
         pszEscapedStr[j++] = '\'';
@@ -3040,580 +3200,701 @@ char *msMSSQL2008LayerEscapeSQLParam(lay
   return pszEscapedStr;
 }
 
-int msMSSQL2008GetPaging(layerObj *layer)
-{
-    msMSSQL2008LayerInfo *layerinfo = NULL;
+int msMSSQL2008GetPaging(layerObj *layer) {
+  msMSSQL2008LayerInfo *layerinfo = NULL;
 
-    if (!msMSSQL2008LayerIsOpen(layer))
-        return MS_TRUE;
+  if (!msMSSQL2008LayerIsOpen(layer))
+    return MS_TRUE;
 
-    assert(layer->layerinfo != NULL);
-    layerinfo = (msMSSQL2008LayerInfo *)layer->layerinfo;
+  assert(layer->layerinfo != NULL);
+  layerinfo = (msMSSQL2008LayerInfo *)layer->layerinfo;
 
-    return layerinfo->paging;
+  return layerinfo->paging;
 }
 
-void msMSSQL2008EnablePaging(layerObj *layer, int value)
-{
-    msMSSQL2008LayerInfo *layerinfo = NULL;
+void msMSSQL2008EnablePaging(layerObj *layer, int value) {
+  msMSSQL2008LayerInfo *layerinfo = NULL;
 
-    if (!msMSSQL2008LayerIsOpen(layer))
-    {
-      if(msMSSQL2008LayerOpen(layer) != MS_SUCCESS)
-      {
-        return;
-      }
+  if (!msMSSQL2008LayerIsOpen(layer)) {
+    if (msMSSQL2008LayerOpen(layer) != MS_SUCCESS) {
+      return;
     }
+  }
 
-    assert(layer->layerinfo != NULL);
-    layerinfo = (msMSSQL2008LayerInfo *)layer->layerinfo;
+  assert(layer->layerinfo != NULL);
+  layerinfo = (msMSSQL2008LayerInfo *)layer->layerinfo;
 
-    layerinfo->paging = value;
+  layerinfo->paging = value;
 }
 
-int process_node(layerObj* layer, expressionObj *filter)
-{
+int process_node(layerObj *layer, expressionObj *filter) {
   char *snippet = NULL;
   char *strtmpl = NULL;
   char *stresc = NULL;
-  msMSSQL2008LayerInfo *layerinfo = (msMSSQL2008LayerInfo *) layer->layerinfo;
+  msMSSQL2008LayerInfo *layerinfo = (msMSSQL2008LayerInfo *)layer->layerinfo;
 
-  if (!layerinfo->current_node)
-  {
-    msSetError(MS_MISCERR, "Unecpected end of expression", "msMSSQL2008LayerTranslateFilter()");
+  if (!layerinfo->current_node) {
+    msSetError(MS_MISCERR, "Unecpected end of expression",
+               "msMSSQL2008LayerTranslateFilter()");
     return 0;
   }
 
-  switch(layerinfo->current_node->token) {
-    case '(':
-       filter->native_string = msStringConcatenate(filter->native_string, "(");
-       /* process subexpression */
-       layerinfo->current_node = layerinfo->current_node->next;
-       while (layerinfo->current_node != NULL) { 
-         if (!process_node(layer, filter))
-           return 0;
-         if (!layerinfo->current_node)
-           break;
-         if (layerinfo->current_node->token == ')')
-           break;
-         layerinfo->current_node = layerinfo->current_node->next;
-       }
-       break;
-    case ')':
-       filter->native_string = msStringConcatenate(filter->native_string, ")");
-       break;
-    /* argument separator */
-    case ',':
-       break;
-    /* literal tokens */
-    case MS_TOKEN_LITERAL_BOOLEAN:
-      if(layerinfo->current_node->tokenval.dblval == MS_TRUE)
-        filter->native_string = msStringConcatenate(filter->native_string, "1");
-      else
-        filter->native_string = msStringConcatenate(filter->native_string, "0");
-      break;
-    case MS_TOKEN_LITERAL_NUMBER:
-    {
-      char buffer[32];
-      snprintf(buffer, sizeof(buffer), "%.18g", layerinfo->current_node->tokenval.dblval);
-      filter->native_string = msStringConcatenate(filter->native_string, buffer);
-      break;
+  switch (layerinfo->current_node->token) {
+  case '(':
+    filter->native_string = msStringConcatenate(filter->native_string, "(");
+    /* process subexpression */
+    layerinfo->current_node = layerinfo->current_node->next;
+    while (layerinfo->current_node != NULL) {
+      if (!process_node(layer, filter))
+        return 0;
+      if (!layerinfo->current_node)
+        break;
+      if (layerinfo->current_node->token == ')')
+        break;
+      layerinfo->current_node = layerinfo->current_node->next;
     }
-    case MS_TOKEN_LITERAL_STRING:
-      strtmpl = "'%s'";
-      stresc = msMSSQL2008LayerEscapeSQLParam(layer, layerinfo->current_node->tokenval.strval);
-      snippet = (char *) msSmallMalloc(strlen(strtmpl) + strlen(stresc));
-      sprintf(snippet, strtmpl, stresc);
-      filter->native_string = msStringConcatenate(filter->native_string, snippet);
-      msFree(snippet);
-      msFree(stresc);
-      break;
-    case MS_TOKEN_LITERAL_TIME:
-      {
-        int resolution = msTimeGetResolution(layerinfo->current_node->tokensrc);
-        snippet = (char *) msSmallMalloc(128);
-        switch(resolution) {
-          case TIME_RESOLUTION_YEAR:
-            sprintf(snippet, "'%d'", (layerinfo->current_node->tokenval.tmval.tm_year+1900));
-            break;
-          case TIME_RESOLUTION_MONTH:
-            sprintf(snippet, "'%d-%02d-01'", (layerinfo->current_node->tokenval.tmval.tm_year+1900), 
-                    (layerinfo->current_node->tokenval.tmval.tm_mon+1));
-            break;
-          case TIME_RESOLUTION_DAY:
-            sprintf(snippet, "'%d-%02d-%02d'", (layerinfo->current_node->tokenval.tmval.tm_year+1900), 
-                    (layerinfo->current_node->tokenval.tmval.tm_mon+1), 
-                    layerinfo->current_node->tokenval.tmval.tm_mday);
-            break;
-          case TIME_RESOLUTION_HOUR:
-            sprintf(snippet, "'%d-%02d-%02d %02d:00'", (layerinfo->current_node->tokenval.tmval.tm_year+1900), 
-                (layerinfo->current_node->tokenval.tmval.tm_mon+1), 
-                layerinfo->current_node->tokenval.tmval.tm_mday, 
-                layerinfo->current_node->tokenval.tmval.tm_hour);
-            break;
-          case TIME_RESOLUTION_MINUTE:
-            sprintf(snippet, "%d-%02d-%02d %02d:%02d'", (layerinfo->current_node->tokenval.tmval.tm_year+1900), 
-                (layerinfo->current_node->tokenval.tmval.tm_mon+1), 
-                layerinfo->current_node->tokenval.tmval.tm_mday, 
-                layerinfo->current_node->tokenval.tmval.tm_hour, 
-                layerinfo->current_node->tokenval.tmval.tm_min);
-            break;
-          case TIME_RESOLUTION_SECOND:
-            sprintf(snippet, "'%d-%02d-%02d %02d:%02d:%02d'", (layerinfo->current_node->tokenval.tmval.tm_year+1900),
-                (layerinfo->current_node->tokenval.tmval.tm_mon+1), 
-                layerinfo->current_node->tokenval.tmval.tm_mday, 
-                layerinfo->current_node->tokenval.tmval.tm_hour, 
-                layerinfo->current_node->tokenval.tmval.tm_min, 
-                layerinfo->current_node->tokenval.tmval.tm_sec);
-            break;
-        }    
-        filter->native_string = msStringConcatenate(filter->native_string, snippet);
-        msFree(snippet);
-      }
-      break;
-    case MS_TOKEN_LITERAL_SHAPE:
-      if (strcasecmp(layerinfo->geom_column_type, "geography") == 0)
-        filter->native_string = msStringConcatenate(filter->native_string, "geography::STGeomFromText('");
-      else
-        filter->native_string = msStringConcatenate(filter->native_string, "geometry::STGeomFromText('");
-      filter->native_string = msStringConcatenate(filter->native_string, msShapeToWKT(layerinfo->current_node->tokenval.shpval));
-      filter->native_string = msStringConcatenate(filter->native_string, "'");
-      if(layerinfo->user_srid && strcmp(layerinfo->user_srid, "") != 0) {
-        filter->native_string = msStringConcatenate(filter->native_string, ", ");
-        filter->native_string = msStringConcatenate(filter->native_string, layerinfo->user_srid);
-      }
-      filter->native_string = msStringConcatenate(filter->native_string, ")");
-      break;
-    case MS_TOKEN_BINDING_TIME:
-    case MS_TOKEN_BINDING_DOUBLE:
-    case MS_TOKEN_BINDING_INTEGER:
-    case MS_TOKEN_BINDING_STRING:
-      if(layerinfo->current_node->next->token == MS_TOKEN_COMPARISON_IRE)
-        strtmpl = "LOWER(%s)";
-      else
-        strtmpl = "%s";
-
-      stresc = msMSSQL2008LayerEscapePropertyName(layer, layerinfo->current_node->tokenval.bindval.item);
-      snippet = (char *) msSmallMalloc(strlen(strtmpl) + strlen(stresc));
-      sprintf(snippet, strtmpl, stresc);
-      filter->native_string = msStringConcatenate(filter->native_string, snippet);
-      msFree(snippet);
-      msFree(stresc);
-      break;
-    case MS_TOKEN_BINDING_SHAPE:
-      filter->native_string = msStringConcatenate(filter->native_string, layerinfo->geom_column);
-      break;
-    case MS_TOKEN_BINDING_MAP_CELLSIZE:
-    {
-      char buffer[32];
-      snprintf(buffer, sizeof(buffer), "%.18g", layer->map->cellsize);
-      filter->native_string = msStringConcatenate(filter->native_string, buffer);
+    break;
+  case ')':
+    filter->native_string = msStringConcatenate(filter->native_string, ")");
+    break;
+  /* argument separator */
+  case ',':
+    break;
+  /* literal tokens */
+  case MS_TOKEN_LITERAL_BOOLEAN:
+    if (layerinfo->current_node->tokenval.dblval == MS_TRUE)
+      filter->native_string = msStringConcatenate(filter->native_string, "1");
+    else
+      filter->native_string = msStringConcatenate(filter->native_string, "0");
+    break;
+  case MS_TOKEN_LITERAL_NUMBER: {
+    char buffer[32];
+    snprintf(buffer, sizeof(buffer), "%.18g",
+             layerinfo->current_node->tokenval.dblval);
+    filter->native_string = msStringConcatenate(filter->native_string, buffer);
+    break;
+  }
+  case MS_TOKEN_LITERAL_STRING:
+    strtmpl = "'%s'";
+    stresc = msMSSQL2008LayerEscapeSQLParam(
+        layer, layerinfo->current_node->tokenval.strval);
+    snippet = (char *)msSmallMalloc(strlen(strtmpl) + strlen(stresc));
+    sprintf(snippet, strtmpl, stresc);
+    filter->native_string = msStringConcatenate(filter->native_string, snippet);
+    msFree(snippet);
+    msFree(stresc);
+    break;
+  case MS_TOKEN_LITERAL_TIME: {
+    int resolution = msTimeGetResolution(layerinfo->current_node->tokensrc);
+    snippet = (char *)msSmallMalloc(128);
+    switch (resolution) {
+    case TIME_RESOLUTION_YEAR:
+      sprintf(snippet, "'%d'",
+              (layerinfo->current_node->tokenval.tmval.tm_year + 1900));
+      break;
+    case TIME_RESOLUTION_MONTH:
+      sprintf(snippet, "'%d-%02d-01'",
+              (layerinfo->current_node->tokenval.tmval.tm_year + 1900),
+              (layerinfo->current_node->tokenval.tmval.tm_mon + 1));
+      break;
+    case TIME_RESOLUTION_DAY:
+      sprintf(snippet, "'%d-%02d-%02d'",
+              (layerinfo->current_node->tokenval.tmval.tm_year + 1900),
+              (layerinfo->current_node->tokenval.tmval.tm_mon + 1),
+              layerinfo->current_node->tokenval.tmval.tm_mday);
+      break;
+    case TIME_RESOLUTION_HOUR:
+      sprintf(snippet, "'%d-%02d-%02d %02d:00'",
+              (layerinfo->current_node->tokenval.tmval.tm_year + 1900),
+              (layerinfo->current_node->tokenval.tmval.tm_mon + 1),
+              layerinfo->current_node->tokenval.tmval.tm_mday,
+              layerinfo->current_node->tokenval.tmval.tm_hour);
+      break;
+    case TIME_RESOLUTION_MINUTE:
+      sprintf(snippet, "%d-%02d-%02d %02d:%02d'",
+              (layerinfo->current_node->tokenval.tmval.tm_year + 1900),
+              (layerinfo->current_node->tokenval.tmval.tm_mon + 1),
+              layerinfo->current_node->tokenval.tmval.tm_mday,
+              layerinfo->current_node->tokenval.tmval.tm_hour,
+              layerinfo->current_node->tokenval.tmval.tm_min);
+      break;
+    case TIME_RESOLUTION_SECOND:
+      sprintf(snippet, "'%d-%02d-%02d %02d:%02d:%02d'",
+              (layerinfo->current_node->tokenval.tmval.tm_year + 1900),
+              (layerinfo->current_node->tokenval.tmval.tm_mon + 1),
+              layerinfo->current_node->tokenval.tmval.tm_mday,
+              layerinfo->current_node->tokenval.tmval.tm_hour,
+              layerinfo->current_node->tokenval.tmval.tm_min,
+              layerinfo->current_node->tokenval.tmval.tm_sec);
       break;
     }
+    filter->native_string = msStringConcatenate(filter->native_string, snippet);
+    msFree(snippet);
+  } break;
+  case MS_TOKEN_LITERAL_SHAPE:
+    if (strcasecmp(layerinfo->geom_column_type, "geography") == 0)
+      filter->native_string = msStringConcatenate(
+          filter->native_string, "geography::STGeomFromText('");
+    else
+      filter->native_string = msStringConcatenate(filter->native_string,
+                                                  "geometry::STGeomFromText('");
+    filter->native_string = msStringConcatenate(
+        filter->native_string,
+        msShapeToWKT(layerinfo->current_node->tokenval.shpval));
+    filter->native_string = msStringConcatenate(filter->native_string, "'");
+    if (layerinfo->user_srid && strcmp(layerinfo->user_srid, "") != 0) {
+      filter->native_string = msStringConcatenate(filter->native_string, ", ");
+      filter->native_string =
+          msStringConcatenate(filter->native_string, layerinfo->user_srid);
+    }
+    filter->native_string = msStringConcatenate(filter->native_string, ")");
+    break;
+  case MS_TOKEN_BINDING_TIME:
+  case MS_TOKEN_BINDING_DOUBLE:
+  case MS_TOKEN_BINDING_INTEGER:
+  case MS_TOKEN_BINDING_STRING:
+    if (layerinfo->current_node->next->token == MS_TOKEN_COMPARISON_IRE)
+      strtmpl = "LOWER(%s)";
+    else
+      strtmpl = "%s";
 
-    /* comparisons */
-    case MS_TOKEN_COMPARISON_IN:
-      filter->native_string = msStringConcatenate(filter->native_string, " IN ");
-      break;
-    case MS_TOKEN_COMPARISON_RE: 
-    case MS_TOKEN_COMPARISON_IRE: 
-    case MS_TOKEN_COMPARISON_LIKE: {
-      /* process regexp */
-      size_t i = 0, j = 0;
-      char c;
-      char c_next;
-      int bCaseInsensitive = (layerinfo->current_node->token == MS_TOKEN_COMPARISON_IRE);
-      int nEscapeLen = 0;
-      if (bCaseInsensitive)
-        filter->native_string = msStringConcatenate(filter->native_string, " LIKE LOWER(");
-      else
-        filter->native_string = msStringConcatenate(filter->native_string, " LIKE ");
+    stresc = msMSSQL2008LayerEscapePropertyName(
+        layer, layerinfo->current_node->tokenval.bindval.item);
+    snippet = (char *)msSmallMalloc(strlen(strtmpl) + strlen(stresc));
+    sprintf(snippet, strtmpl, stresc);
+    filter->native_string = msStringConcatenate(filter->native_string, snippet);
+    msFree(snippet);
+    msFree(stresc);
+    break;
+  case MS_TOKEN_BINDING_SHAPE:
+    filter->native_string =
+        msStringConcatenate(filter->native_string, layerinfo->geom_column);
+    break;
+  case MS_TOKEN_BINDING_MAP_CELLSIZE: {
+    char buffer[32];
+    snprintf(buffer, sizeof(buffer), "%.18g", layer->map->cellsize);
+    filter->native_string = msStringConcatenate(filter->native_string, buffer);
+    break;
+  }
 
-      layerinfo->current_node = layerinfo->current_node->next;
-      if (layerinfo->current_node->token != MS_TOKEN_LITERAL_STRING) return 0;
+  /* comparisons */
+  case MS_TOKEN_COMPARISON_IN:
+    filter->native_string = msStringConcatenate(filter->native_string, " IN ");
+    break;
+  case MS_TOKEN_COMPARISON_RE:
+  case MS_TOKEN_COMPARISON_IRE:
+  case MS_TOKEN_COMPARISON_LIKE: {
+    /* process regexp */
+    size_t i = 0, j = 0;
+    char c;
+    char c_next;
+    int bCaseInsensitive =
+        (layerinfo->current_node->token == MS_TOKEN_COMPARISON_IRE);
+    int nEscapeLen = 0;
+    if (bCaseInsensitive)
+      filter->native_string =
+          msStringConcatenate(filter->native_string, " LIKE LOWER(");
+    else
+      filter->native_string =
+          msStringConcatenate(filter->native_string, " LIKE ");
 
-      strtmpl = msStrdup(layerinfo->current_node->tokenval.strval);
-      if (strtmpl[0] == '/') {
-        stresc = strtmpl + 1;
-        strtmpl[strlen(strtmpl) - 1] = '\0';
-      }
-      else if (strtmpl[0] == '^')
-        stresc = strtmpl + 1;
-      else
-        stresc = strtmpl;
+    layerinfo->current_node = layerinfo->current_node->next;
+    if (layerinfo->current_node->token != MS_TOKEN_LITERAL_STRING)
+      return 0;
 
-      while (*stresc) {
-        c = stresc[i];
-        if (c == '%' || c == '_' || c == '[' || c == ']' || c == '^') {
-           nEscapeLen++;
-        }
-        stresc++;
-      }
-      snippet = (char *)msSmallMalloc(strlen(strtmpl) + nEscapeLen + 3);
-      snippet[j++] = '\'';
-      while (i < strlen(strtmpl)) {
-        c = strtmpl[i];
-        c_next = strtmpl[i+1];
-
-        if (i == 0 && c == '^') {
-          i++;
-          continue;
-        }
-        if( c == '$' && c_next == 0 && strtmpl[0] == '^' )
-          break;
+    strtmpl = msStrdup(layerinfo->current_node->tokenval.strval);
+    if (strtmpl[0] == '/') {
+      stresc = strtmpl + 1;
+      strtmpl[strlen(strtmpl) - 1] = '\0';
+    } else if (strtmpl[0] == '^')
+      stresc = strtmpl + 1;
+    else
+      stresc = strtmpl;
 
-        if (c == '\\') {
-          i++;
-          c = c_next;
-        }
-         
-        if (c == '%' || c == '_' || c == '[' || c == ']' || c == '^') {
-           snippet[j++] = '\\';
-        }
-        
-        if (c == '.' && c_next == '*') {
-          i++;
-          c = '%';
-        }
-        else if (c == '.')
-          c = '_';
+    while (*stresc) {
+      c = stresc[i];
+      if (c == '%' || c == '_' || c == '[' || c == ']' || c == '^') {
+        nEscapeLen++;
+      }
+      stresc++;
+    }
+    snippet = (char *)msSmallMalloc(strlen(strtmpl) + nEscapeLen + 3);
+    snippet[j++] = '\'';
+    while (i < strlen(strtmpl)) {
+      c = strtmpl[i];
+      c_next = strtmpl[i + 1];
+
+      if (i == 0 && c == '^') {
+        i++;
+        continue;
+      }
+      if (c == '$' && c_next == 0 && strtmpl[0] == '^')
+        break;
 
-        
-        snippet[j++] = c;
-        i++;          
+      if (c == '\\') {
+        i++;
+        c = c_next;
       }
-      snippet[j++] = '\'';
-      snippet[j] = '\0';
 
-      filter->native_string = msStringConcatenate(filter->native_string, snippet);
-      msFree(strtmpl);
-      msFree(snippet);
+      if (c == '%' || c == '_' || c == '[' || c == ']' || c == '^') {
+        snippet[j++] = '\\';
+      }
 
-      if (bCaseInsensitive)
-        filter->native_string = msStringConcatenate(filter->native_string, ")");
+      if (c == '.' && c_next == '*') {
+        i++;
+        c = '%';
+      } else if (c == '.')
+        c = '_';
 
-      if (nEscapeLen > 0)
-        filter->native_string = msStringConcatenate(filter->native_string, " ESCAPE '\\'");
+      snippet[j++] = c;
+      i++;
     }
-    break;
-    case MS_TOKEN_COMPARISON_EQ:
-      filter->native_string = msStringConcatenate(filter->native_string, " = ");
-      break;
-    case MS_TOKEN_COMPARISON_NE: 
-      filter->native_string = msStringConcatenate(filter->native_string, " != ");
-      break;
-    case MS_TOKEN_COMPARISON_GT: 
-      filter->native_string = msStringConcatenate(filter->native_string, " > ");
-      break;
-    case MS_TOKEN_COMPARISON_GE:
-      filter->native_string = msStringConcatenate(filter->native_string, " >= ");
-      break;
-    case MS_TOKEN_COMPARISON_LT:
-      filter->native_string = msStringConcatenate(filter->native_string, " < ");
-      break;
-    case MS_TOKEN_COMPARISON_LE:
-      filter->native_string = msStringConcatenate(filter->native_string, " <= ");
-      break;
+    snippet[j++] = '\'';
+    snippet[j] = '\0';
 
-    /* logical ops */
-    case MS_TOKEN_LOGICAL_AND:
-      filter->native_string = msStringConcatenate(filter->native_string, " AND ");
-      break;
-    case MS_TOKEN_LOGICAL_OR:
-      filter->native_string = msStringConcatenate(filter->native_string, " OR ");
-      break;
-    case MS_TOKEN_LOGICAL_NOT:
-      filter->native_string = msStringConcatenate(filter->native_string, " NOT ");
-      break;
+    filter->native_string = msStringConcatenate(filter->native_string, snippet);
+    msFree(strtmpl);
+    msFree(snippet);
 
-    /* spatial comparison tokens */
-    case MS_TOKEN_COMPARISON_INTERSECTS:
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (!process_node(layer, filter))
-        return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      filter->native_string = msStringConcatenate(filter->native_string, ".STIntersects(");
-      if (!process_node(layer, filter))
-        return 0;
-      break;
+    if (bCaseInsensitive)
+      filter->native_string = msStringConcatenate(filter->native_string, ")");
 
-    case MS_TOKEN_COMPARISON_DISJOINT:
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (!process_node(layer, filter))
-        return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      filter->native_string = msStringConcatenate(filter->native_string, ".STDisjoint(");
-      if (!process_node(layer, filter))
-        return 0;
-      break;
+    if (nEscapeLen > 0)
+      filter->native_string =
+          msStringConcatenate(filter->native_string, " ESCAPE '\\'");
+  } break;
+  case MS_TOKEN_COMPARISON_EQ:
+    filter->native_string = msStringConcatenate(filter->native_string, " = ");
+    break;
+  case MS_TOKEN_COMPARISON_NE:
+    filter->native_string = msStringConcatenate(filter->native_string, " != ");
+    break;
+  case MS_TOKEN_COMPARISON_GT:
+    filter->native_string = msStringConcatenate(filter->native_string, " > ");
+    break;
+  case MS_TOKEN_COMPARISON_GE:
+    filter->native_string = msStringConcatenate(filter->native_string, " >= ");
+    break;
+  case MS_TOKEN_COMPARISON_LT:
+    filter->native_string = msStringConcatenate(filter->native_string, " < ");
+    break;
+  case MS_TOKEN_COMPARISON_LE:
+    filter->native_string = msStringConcatenate(filter->native_string, " <= ");
+    break;
 
-    case MS_TOKEN_COMPARISON_TOUCHES:
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (!process_node(layer, filter))
-        return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      filter->native_string = msStringConcatenate(filter->native_string, ".STTouches(");
-      if (!process_node(layer, filter))
-        return 0;
-      break;
+  /* logical ops */
+  case MS_TOKEN_LOGICAL_AND:
+    filter->native_string = msStringConcatenate(filter->native_string, " AND ");
+    break;
+  case MS_TOKEN_LOGICAL_OR:
+    filter->native_string = msStringConcatenate(filter->native_string, " OR ");
+    break;
+  case MS_TOKEN_LOGICAL_NOT:
+    filter->native_string = msStringConcatenate(filter->native_string, " NOT ");
+    break;
 
-    case MS_TOKEN_COMPARISON_OVERLAPS:
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (!process_node(layer, filter))
-        return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      filter->native_string = msStringConcatenate(filter->native_string, ".STOverlaps(");
-      if (!process_node(layer, filter))
-        return 0;
-      break;
+  /* spatial comparison tokens */
+  case MS_TOKEN_COMPARISON_INTERSECTS:
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (!process_node(layer, filter))
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    filter->native_string =
+        msStringConcatenate(filter->native_string, ".STIntersects(");
+    if (!process_node(layer, filter))
+      return 0;
+    break;
 
-    case MS_TOKEN_COMPARISON_CROSSES:
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (!process_node(layer, filter))
-        return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      filter->native_string = msStringConcatenate(filter->native_string, ".STCrosses(");
-      if (!process_node(layer, filter))
-        return 0;
-      break;
+  case MS_TOKEN_COMPARISON_DISJOINT:
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (!process_node(layer, filter))
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    filter->native_string =
+        msStringConcatenate(filter->native_string, ".STDisjoint(");
+    if (!process_node(layer, filter))
+      return 0;
+    break;
 
-    case MS_TOKEN_COMPARISON_WITHIN:
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (!process_node(layer, filter))
-        return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      filter->native_string = msStringConcatenate(filter->native_string, ".STWithin(");
-      if (!process_node(layer, filter))
-        return 0;
-      break;
+  case MS_TOKEN_COMPARISON_TOUCHES:
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (!process_node(layer, filter))
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    filter->native_string =
+        msStringConcatenate(filter->native_string, ".STTouches(");
+    if (!process_node(layer, filter))
+      return 0;
+    break;
 
-    case MS_TOKEN_COMPARISON_CONTAINS:
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (!process_node(layer, filter))
-        return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      filter->native_string = msStringConcatenate(filter->native_string, ".STContains(");
-      if (!process_node(layer, filter))
-        return 0;
-      break;
+  case MS_TOKEN_COMPARISON_OVERLAPS:
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (!process_node(layer, filter))
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    filter->native_string =
+        msStringConcatenate(filter->native_string, ".STOverlaps(");
+    if (!process_node(layer, filter))
+      return 0;
+    break;
 
-    case MS_TOKEN_COMPARISON_EQUALS:
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (!process_node(layer, filter))
-        return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      filter->native_string = msStringConcatenate(filter->native_string, ".STEquals(");
-      if (!process_node(layer, filter))
-        return 0;
-      break;
+  case MS_TOKEN_COMPARISON_CROSSES:
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (!process_node(layer, filter))
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    filter->native_string =
+        msStringConcatenate(filter->native_string, ".STCrosses(");
+    if (!process_node(layer, filter))
+      return 0;
+    break;
 
-    case MS_TOKEN_COMPARISON_BEYOND:
-      msSetError(MS_MISCERR, "Beyond operator is unsupported.", "msMSSQL2008LayerTranslateFilter()");
+  case MS_TOKEN_COMPARISON_WITHIN:
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
       return 0;
+    if (!process_node(layer, filter))
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    filter->native_string =
+        msStringConcatenate(filter->native_string, ".STWithin(");
+    if (!process_node(layer, filter))
+      return 0;
+    break;
 
-    case MS_TOKEN_COMPARISON_DWITHIN:
-      msSetError(MS_MISCERR, "DWithin operator is unsupported.", "msMSSQL2008LayerTranslateFilter()");
+  case MS_TOKEN_COMPARISON_CONTAINS:
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
       return 0;
+    if (!process_node(layer, filter))
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    filter->native_string =
+        msStringConcatenate(filter->native_string, ".STContains(");
+    if (!process_node(layer, filter))
+      return 0;
+    break;
 
-    /* spatial functions */
-    case MS_TOKEN_FUNCTION_AREA:
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (!process_node(layer, filter))
-        return 0;
-      filter->native_string = msStringConcatenate(filter->native_string, ".STArea()");
-      break;
+  case MS_TOKEN_COMPARISON_EQUALS:
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (!process_node(layer, filter))
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    filter->native_string =
+        msStringConcatenate(filter->native_string, ".STEquals(");
+    if (!process_node(layer, filter))
+      return 0;
+    break;
 
-    case MS_TOKEN_FUNCTION_BUFFER:
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (!process_node(layer, filter))
-        return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      filter->native_string = msStringConcatenate(filter->native_string, ".STBuffer(");
-      if (!process_node(layer, filter))
-        return 0;
-      filter->native_string = msStringConcatenate(filter->native_string, ")");
-      break;
+  case MS_TOKEN_COMPARISON_BEYOND:
+    msSetError(MS_MISCERR, "Beyond operator is unsupported.",
+               "msMSSQL2008LayerTranslateFilter()");
+    return 0;
 
-    case MS_TOKEN_FUNCTION_DIFFERENCE:
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (!process_node(layer, filter))
-        return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      if (layerinfo->current_node->next) layerinfo->current_node = layerinfo->current_node->next;
-      else return 0;
-      filter->native_string = msStringConcatenate(filter->native_string, ".STDifference(");
-      if (!process_node(layer, filter))
-        return 0;
-      filter->native_string = msStringConcatenate(filter->native_string, ")");
-      break;
+  case MS_TOKEN_COMPARISON_DWITHIN:
+    msSetError(MS_MISCERR, "DWithin operator is unsupported.",
+               "msMSSQL2008LayerTranslateFilter()");
+    return 0;
 
-    case MS_TOKEN_FUNCTION_FROMTEXT:
-      if (strcasecmp(layerinfo->geom_column_type, "geography") == 0)
-        filter->native_string = msStringConcatenate(filter->native_string, "geography::STGeomFromText");
-      else
-        filter->native_string = msStringConcatenate(filter->native_string, "geometry::STGeomFromText");          
-      break;
+  /* spatial functions */
+  case MS_TOKEN_FUNCTION_AREA:
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (!process_node(layer, filter))
+      return 0;
+    filter->native_string =
+        msStringConcatenate(filter->native_string, ".STArea()");
+    break;
 
-    case MS_TOKEN_FUNCTION_LENGTH:
-      filter->native_string = msStringConcatenate(filter->native_string, "len");
-      break;
+  case MS_TOKEN_FUNCTION_BUFFER:
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (!process_node(layer, filter))
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    filter->native_string =
+        msStringConcatenate(filter->native_string, ".STBuffer(");
+    if (!process_node(layer, filter))
+      return 0;
+    filter->native_string = msStringConcatenate(filter->native_string, ")");
+    break;
 
-    case MS_TOKEN_FUNCTION_ROUND:
-      filter->native_string = msStringConcatenate(filter->native_string, "round");
-      break;
-    
-    case MS_TOKEN_FUNCTION_TOSTRING:
-      break;
+  case MS_TOKEN_FUNCTION_DIFFERENCE:
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (!process_node(layer, filter))
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    if (layerinfo->current_node->next)
+      layerinfo->current_node = layerinfo->current_node->next;
+    else
+      return 0;
+    filter->native_string =
+        msStringConcatenate(filter->native_string, ".STDifference(");
+    if (!process_node(layer, filter))
+      return 0;
+    filter->native_string = msStringConcatenate(filter->native_string, ")");
+    break;
 
-    case MS_TOKEN_FUNCTION_COMMIFY:
-      break;
+  case MS_TOKEN_FUNCTION_FROMTEXT:
+    if (strcasecmp(layerinfo->geom_column_type, "geography") == 0)
+      filter->native_string = msStringConcatenate(filter->native_string,
+                                                  "geography::STGeomFromText");
+    else
+      filter->native_string = msStringConcatenate(filter->native_string,
+                                                  "geometry::STGeomFromText");
+    break;
 
-    case MS_TOKEN_FUNCTION_SIMPLIFY:
-      filter->native_string = msStringConcatenate(filter->native_string, ".Reduce"); 
-      break;
-    case MS_TOKEN_FUNCTION_SIMPLIFYPT:
-      break;
-    case MS_TOKEN_FUNCTION_GENERALIZE:
-      filter->native_string = msStringConcatenate(filter->native_string, ".Reduce"); 
-      break;
+  case MS_TOKEN_FUNCTION_LENGTH:
+    filter->native_string = msStringConcatenate(filter->native_string, "len");
+    break;
 
-    default:
-      msSetError(MS_MISCERR, "Translation to native SQL failed.","msMSSQL2008LayerTranslateFilter()");
-      if (layer->debug) {
-        msDebug("Token not caught, exiting: Token is %i\n", layerinfo->current_node->token);
-      }
-      return 0;
+  case MS_TOKEN_FUNCTION_ROUND:
+    filter->native_string = msStringConcatenate(filter->native_string, "round");
+    break;
+
+  case MS_TOKEN_FUNCTION_TOSTRING:
+    break;
+
+  case MS_TOKEN_FUNCTION_COMMIFY:
+    break;
+
+  case MS_TOKEN_FUNCTION_SIMPLIFY:
+    filter->native_string =
+        msStringConcatenate(filter->native_string, ".Reduce");
+    break;
+  case MS_TOKEN_FUNCTION_SIMPLIFYPT:
+    break;
+  case MS_TOKEN_FUNCTION_GENERALIZE:
+    filter->native_string =
+        msStringConcatenate(filter->native_string, ".Reduce");
+    break;
+
+  default:
+    msSetError(MS_MISCERR, "Translation to native SQL failed.",
+               "msMSSQL2008LayerTranslateFilter()");
+    if (layer->debug) {
+      msDebug("Token not caught, exiting: Token is %i\n",
+              layerinfo->current_node->token);
+    }
+    return 0;
   }
   return 1;
 }
 
 /* Translate filter expression to native msssql filter */
-int msMSSQL2008LayerTranslateFilter(layerObj *layer, expressionObj *filter, char *filteritem)
-{
+int msMSSQL2008LayerTranslateFilter(layerObj *layer, expressionObj *filter,
+                                    char *filteritem) {
   char *snippet = NULL;
   char *strtmpl = NULL;
   char *stresc = NULL;
-  msMSSQL2008LayerInfo *layerinfo = (msMSSQL2008LayerInfo *) layer->layerinfo;
+  msMSSQL2008LayerInfo *layerinfo = (msMSSQL2008LayerInfo *)layer->layerinfo;
 
-  if(!filter->string) return MS_SUCCESS;
+  if (!filter->string)
+    return MS_SUCCESS;
 
   msFree(filter->native_string);
   filter->native_string = NULL;
 
-  if(filter->type == MS_STRING && filter->string && filteritem) { /* item/value pair */
+  if (filter->type == MS_STRING && filter->string &&
+      filteritem) { /* item/value pair */
     stresc = msMSSQL2008LayerEscapePropertyName(layer, filteritem);
-    if(filter->flags & MS_EXP_INSENSITIVE) {
-      filter->native_string = msStringConcatenate(filter->native_string, "upper(");
-      filter->native_string = msStringConcatenate(filter->native_string, stresc);
-      filter->native_string = msStringConcatenate(filter->native_string, ") = upper(");
+    if (filter->flags & MS_EXP_INSENSITIVE) {
+      filter->native_string =
+          msStringConcatenate(filter->native_string, "upper(");
+      filter->native_string =
+          msStringConcatenate(filter->native_string, stresc);
+      filter->native_string =
+          msStringConcatenate(filter->native_string, ") = upper(");
     } else {
-      filter->native_string = msStringConcatenate(filter->native_string, stresc);
+      filter->native_string =
+          msStringConcatenate(filter->native_string, stresc);
       filter->native_string = msStringConcatenate(filter->native_string, " = ");
     }
     msFree(stresc);
 
-    strtmpl = "'%s'";  /* don't have a type for the righthand literal so assume it's a string and we quote */
-    snippet = (char *) msSmallMalloc(strlen(strtmpl) + strlen(filter->string));
-    sprintf(snippet, strtmpl, filter->string);  // TODO: escape filter->string
+    strtmpl = "'%s'"; /* don't have a type for the righthand literal so assume
+                         it's a string and we quote */
+    snippet = (char *)msSmallMalloc(strlen(strtmpl) + strlen(filter->string));
+    sprintf(snippet, strtmpl, filter->string); // TODO: escape filter->string
     filter->native_string = msStringConcatenate(filter->native_string, snippet);
     free(snippet);
 
-    if(filter->flags & MS_EXP_INSENSITIVE) 
-        filter->native_string = msStringConcatenate(filter->native_string, ")");
-    
-  } else if(filter->type == MS_REGEX && filter->string && filteritem) { /* item/regex pair */
-    /* NOTE: regex is not supported by MSSQL natively. We should install it in CLR UDF 
-       according to https://msdn.microsoft.com/en-us/magazine/cc163473.aspx*/
-    filter->native_string = msStringConcatenate(filter->native_string, "dbo.RegexMatch(");
-    if(filter->flags & MS_EXP_INSENSITIVE) {
-      filter->native_string = msStringConcatenate(filter->native_string, "'(?i)");
+    if (filter->flags & MS_EXP_INSENSITIVE)
+      filter->native_string = msStringConcatenate(filter->native_string, ")");
+
+  } else if (filter->type == MS_REGEX && filter->string &&
+             filteritem) { /* item/regex pair */
+    /* NOTE: regex is not supported by MSSQL natively. We should install it in
+       CLR UDF according to
+       https://msdn.microsoft.com/en-us/magazine/cc163473.aspx*/
+    filter->native_string =
+        msStringConcatenate(filter->native_string, "dbo.RegexMatch(");
+    if (filter->flags & MS_EXP_INSENSITIVE) {
+      filter->native_string =
+          msStringConcatenate(filter->native_string, "'(?i)");
     }
     filter->native_string = msStrdup(filteritem);
     filter->native_string = msStringConcatenate(filter->native_string, ", ");
     strtmpl = "'%s'";
-    snippet = (char *) msSmallMalloc(strlen(strtmpl) + strlen(filter->string));
+    snippet = (char *)msSmallMalloc(strlen(strtmpl) + strlen(filter->string));
     sprintf(snippet, strtmpl, filter->string); // TODO: escape filter->string
     filter->native_string = msStringConcatenate(filter->native_string, snippet);
 
     filter->native_string = msStringConcatenate(filter->native_string, "')");
     free(snippet);
-  } else if(filter->type == MS_EXPRESSION) {
-    
-      if(layer->debug >= 2) 
+  } else if (filter->type == MS_EXPRESSION) {
+
+    if (layer->debug >= 2)
       msDebug("msMSSQL2008LayerTranslateFilter. String: %s.\n", filter->string);
 
-    if(!filter->tokens) {
-      if(layer->debug >= 2) 
-        msDebug("msMSSQL2008LayerTranslateFilter. There are tokens to process... \n");
+    if (!filter->tokens) {
+      if (layer->debug >= 2)
+        msDebug("msMSSQL2008LayerTranslateFilter. There are tokens to "
+                "process... \n");
       return MS_SUCCESS;
     }
 
     /* start processing nodes */
     layerinfo->current_node = filter->tokens;
     while (layerinfo->current_node != NULL) {
-      if (!process_node(layer, filter))
-      {
+      if (!process_node(layer, filter)) {
         msFree(filter->native_string);
         filter->native_string = 0;
         return MS_FAILURE;
@@ -3623,7 +3904,7 @@ int msMSSQL2008LayerTranslateFilter(laye
         break;
 
       layerinfo->current_node = layerinfo->current_node->next;
-    }   
+    }
   }
 
   return MS_SUCCESS;
@@ -3633,110 +3914,150 @@ int msMSSQL2008LayerTranslateFilter(laye
 
 /* prototypes if MSSQL2008 isnt supposed to be compiled */
 
-int msMSSQL2008LayerOpen(layerObj *layer)
-{
-  msSetError(MS_QUERYERR, "msMSSQL2008LayerOpen called but unimplemented!  (mapserver not compiled with MSSQL2008 support)", "msMSSQL2008LayerOpen()");
+int msMSSQL2008LayerOpen(layerObj *layer) {
+  msSetError(MS_QUERYERR,
+             "msMSSQL2008LayerOpen called but unimplemented!  (mapserver not "
+             "compiled with MSSQL2008 support)",
+             "msMSSQL2008LayerOpen()");
   return MS_FAILURE;
 }
 
-int msMSSQL2008LayerIsOpen(layerObj *layer)
-{
-  msSetError(MS_QUERYERR, "msMSSQL2008IsLayerOpen called but unimplemented!  (mapserver not compiled with MSSQL2008 support)", "msMSSQL2008LayerIsOpen()");
+int msMSSQL2008LayerIsOpen(layerObj *layer) {
+  msSetError(MS_QUERYERR,
+             "msMSSQL2008IsLayerOpen called but unimplemented!  (mapserver not "
+             "compiled with MSSQL2008 support)",
+             "msMSSQL2008LayerIsOpen()");
   return MS_FALSE;
 }
 
-void msMSSQL2008LayerFreeItemInfo(layerObj *layer)
-{
-  msSetError(MS_QUERYERR, "msMSSQL2008LayerFreeItemInfo called but unimplemented!(mapserver not compiled with MSSQL2008 support)", "msMSSQL2008LayerFreeItemInfo()");
+void msMSSQL2008LayerFreeItemInfo(layerObj *layer) {
+  msSetError(MS_QUERYERR,
+             "msMSSQL2008LayerFreeItemInfo called but unimplemented!(mapserver "
+             "not compiled with MSSQL2008 support)",
+             "msMSSQL2008LayerFreeItemInfo()");
 }
 
-int msMSSQL2008LayerInitItemInfo(layerObj *layer)
-{
-  msSetError(MS_QUERYERR, "msMSSQL2008LayerInitItemInfo called but unimplemented!(mapserver not compiled with MSSQL2008 support)", "msMSSQL2008LayerInitItemInfo()");
+int msMSSQL2008LayerInitItemInfo(layerObj *layer) {
+  msSetError(MS_QUERYERR,
+             "msMSSQL2008LayerInitItemInfo called but unimplemented!(mapserver "
+             "not compiled with MSSQL2008 support)",
+             "msMSSQL2008LayerInitItemInfo()");
   return MS_FAILURE;
 }
 
-int msMSSQL2008LayerWhichShapes(layerObj *layer, rectObj rect, int isQuery)
-{
-  msSetError(MS_QUERYERR, "msMSSQL2008LayerWhichShapes called but unimplemented!(mapserver not compiled with MSSQL2008 support)", "msMSSQL2008LayerWhichShapes()");
+int msMSSQL2008LayerWhichShapes(layerObj *layer, rectObj rect, int isQuery) {
+  msSetError(MS_QUERYERR,
+             "msMSSQL2008LayerWhichShapes called but unimplemented!(mapserver "
+             "not compiled with MSSQL2008 support)",
+             "msMSSQL2008LayerWhichShapes()");
   return MS_FAILURE;
 }
 
-int msMSSQL2008LayerClose(layerObj *layer)
-{
-  msSetError(MS_QUERYERR, "msMSSQL2008LayerClose called but unimplemented!(mapserver not compiled with MSSQL2008 support)", "msMSSQL2008LayerClose()");
+int msMSSQL2008LayerClose(layerObj *layer) {
+  msSetError(MS_QUERYERR,
+             "msMSSQL2008LayerClose called but unimplemented!(mapserver not "
+             "compiled with MSSQL2008 support)",
+             "msMSSQL2008LayerClose()");
   return MS_FAILURE;
 }
 
-int msMSSQL2008LayerNextShape(layerObj *layer, shapeObj *shape)
-{
-  msSetError(MS_QUERYERR, "msMSSQL2008LayerNextShape called but unimplemented!(mapserver not compiled with MSSQL2008 support)", "msMSSQL2008LayerNextShape()");
+int msMSSQL2008LayerNextShape(layerObj *layer, shapeObj *shape) {
+  msSetError(MS_QUERYERR,
+             "msMSSQL2008LayerNextShape called but unimplemented!(mapserver "
+             "not compiled with MSSQL2008 support)",
+             "msMSSQL2008LayerNextShape()");
   return MS_FAILURE;
 }
 
-int msMSSQL2008LayerGetShape(layerObj *layer, shapeObj *shape, long record)
-{
-  msSetError(MS_QUERYERR, "msMSSQL2008LayerGetShape called but unimplemented!(mapserver not compiled with MSSQL2008 support)", "msMSSQL2008LayerGetShape()");
+int msMSSQL2008LayerGetShape(layerObj *layer, shapeObj *shape, long record) {
+  msSetError(MS_QUERYERR,
+             "msMSSQL2008LayerGetShape called but unimplemented!(mapserver not "
+             "compiled with MSSQL2008 support)",
+             "msMSSQL2008LayerGetShape()");
   return MS_FAILURE;
 }
 
-int msMSSQL2008LayerGetShapeCount(layerObj *layer, rectObj rect, projectionObj *rectProjection)
-{
-    msSetError(MS_QUERYERR, "msMSSQL2008LayerGetShapeCount called but unimplemented!(mapserver not compiled with MSSQL2008 support)", "msMSSQL2008LayerGetShapeCount()");
-    return MS_FAILURE;
+int msMSSQL2008LayerGetShapeCount(layerObj *layer, rectObj rect,
+                                  projectionObj *rectProjection) {
+  msSetError(MS_QUERYERR,
+             "msMSSQL2008LayerGetShapeCount called but "
+             "unimplemented!(mapserver not compiled with MSSQL2008 support)",
+             "msMSSQL2008LayerGetShapeCount()");
+  return MS_FAILURE;
 }
 
-int msMSSQL2008LayerGetExtent(layerObj *layer, rectObj *extent)
-{
-  msSetError(MS_QUERYERR, "msMSSQL2008LayerGetExtent called but unimplemented!(mapserver not compiled with MSSQL2008 support)", "msMSSQL2008LayerGetExtent()");
+int msMSSQL2008LayerGetExtent(layerObj *layer, rectObj *extent) {
+  msSetError(MS_QUERYERR,
+             "msMSSQL2008LayerGetExtent called but unimplemented!(mapserver "
+             "not compiled with MSSQL2008 support)",
+             "msMSSQL2008LayerGetExtent()");
   return MS_FAILURE;
 }
 
-int msMSSQL2008LayerGetNumFeatures(layerObj *layer)
-{
-    msSetError(MS_QUERYERR, "msMSSQL2008LayerGetNumFeatures called but unimplemented!(mapserver not compiled with MSSQL2008 support)", "msMSSQL2008LayerGetNumFeatures()");
-    return -1;
+int msMSSQL2008LayerGetNumFeatures(layerObj *layer) {
+  msSetError(MS_QUERYERR,
+             "msMSSQL2008LayerGetNumFeatures called but "
+             "unimplemented!(mapserver not compiled with MSSQL2008 support)",
+             "msMSSQL2008LayerGetNumFeatures()");
+  return -1;
 }
 
-int msMSSQL2008LayerGetShapeRandom(layerObj *layer, shapeObj *shape, long *record)
-{
-  msSetError(MS_QUERYERR, "msMSSQL2008LayerGetShapeRandom called but unimplemented!(mapserver not compiled with MSSQL2008 support)", "msMSSQL2008LayerGetShapeRandom()");
+int msMSSQL2008LayerGetShapeRandom(layerObj *layer, shapeObj *shape,
+                                   long *record) {
+  msSetError(MS_QUERYERR,
+             "msMSSQL2008LayerGetShapeRandom called but "
+             "unimplemented!(mapserver not compiled with MSSQL2008 support)",
+             "msMSSQL2008LayerGetShapeRandom()");
   return MS_FAILURE;
 }
 
-int msMSSQL2008LayerGetItems(layerObj *layer)
-{
-  msSetError(MS_QUERYERR, "msMSSQL2008LayerGetItems called but unimplemented!(mapserver not compiled with MSSQL2008 support)", "msMSSQL2008LayerGetItems()");
+int msMSSQL2008LayerGetItems(layerObj *layer) {
+  msSetError(MS_QUERYERR,
+             "msMSSQL2008LayerGetItems called but unimplemented!(mapserver not "
+             "compiled with MSSQL2008 support)",
+             "msMSSQL2008LayerGetItems()");
   return MS_FAILURE;
 }
 
-void msMSSQL2008EnablePaging(layerObj *layer, int value)
-{
-    msSetError(MS_QUERYERR, "msMSSQL2008EnablePaging called but unimplemented!(mapserver not compiled with MSSQL2008 support)", "msMSSQL2008EnablePaging()");
-    return;
+void msMSSQL2008EnablePaging(layerObj *layer, int value) {
+  msSetError(MS_QUERYERR,
+             "msMSSQL2008EnablePaging called but unimplemented!(mapserver not "
+             "compiled with MSSQL2008 support)",
+             "msMSSQL2008EnablePaging()");
+  return;
 }
 
-int msMSSQL2008GetPaging(layerObj *layer)
-{
-    msSetError(MS_QUERYERR, "msMSSQL2008GetPaging called but unimplemented!(mapserver not compiled with MSSQL2008 support)", "msMSSQL2008GetPaging()");
-    return MS_FAILURE;
+int msMSSQL2008GetPaging(layerObj *layer) {
+  msSetError(MS_QUERYERR,
+             "msMSSQL2008GetPaging called but unimplemented!(mapserver not "
+             "compiled with MSSQL2008 support)",
+             "msMSSQL2008GetPaging()");
+  return MS_FAILURE;
 }
 
-int msMSSQL2008LayerTranslateFilter(layerObj *layer, expressionObj *filter, char *filteritem)
-{
-  msSetError(MS_QUERYERR, "msMSSQL2008LayerTranslateFilter called but unimplemented!(mapserver not compiled with MSSQL2008 support)", "msMSSQL2008LayerTranslateFilter()");
+int msMSSQL2008LayerTranslateFilter(layerObj *layer, expressionObj *filter,
+                                    char *filteritem) {
+  msSetError(MS_QUERYERR,
+             "msMSSQL2008LayerTranslateFilter called but "
+             "unimplemented!(mapserver not compiled with MSSQL2008 support)",
+             "msMSSQL2008LayerTranslateFilter()");
   return MS_FAILURE;
 }
 
-char *msMSSQL2008LayerEscapeSQLParam(layerObj *layer, const char *pszString)
-{
-  msSetError(MS_QUERYERR, "msMSSQL2008EscapeSQLParam called but unimplemented!(mapserver not compiled with MSSQL2008 support)", "msMSSQL2008LayerEscapeSQLParam()");
+char *msMSSQL2008LayerEscapeSQLParam(layerObj *layer, const char *pszString) {
+  msSetError(MS_QUERYERR,
+             "msMSSQL2008EscapeSQLParam called but unimplemented!(mapserver "
+             "not compiled with MSSQL2008 support)",
+             "msMSSQL2008LayerEscapeSQLParam()");
   return NULL;
 }
 
-char *msMSSQL2008LayerEscapePropertyName(layerObj *layer, const char *pszString)
-{
-  msSetError(MS_QUERYERR, "msMSSQL2008LayerEscapePropertyName called but unimplemented!(mapserver not compiled with MSSQL2008 support)", "msMSSQL2008LayerEscapePropertyName()");
+char *msMSSQL2008LayerEscapePropertyName(layerObj *layer,
+                                         const char *pszString) {
+  msSetError(MS_QUERYERR,
+             "msMSSQL2008LayerEscapePropertyName called but "
+             "unimplemented!(mapserver not compiled with MSSQL2008 support)",
+             "msMSSQL2008LayerEscapePropertyName()");
   return NULL;
 }
 
@@ -3745,8 +4066,8 @@ char *msMSSQL2008LayerEscapePropertyName
 
 #ifdef USE_MSSQL2008_PLUGIN
 
-MS_DLL_EXPORT int PluginInitializeVirtualTable(layerVTableObj* vtable, layerObj *layer)
-{
+MS_DLL_EXPORT int PluginInitializeVirtualTable(layerVTableObj *vtable,
+                                               layerObj *layer) {
   assert(layer != NULL);
   assert(vtable != NULL);
 
@@ -3785,9 +4106,7 @@ MS_DLL_EXPORT int PluginInitializeVirtua
 
 #endif
 
-int
-msMSSQL2008LayerInitializeVirtualTable(layerObj *layer)
-{
+int msMSSQL2008LayerInitializeVirtualTable(layerObj *layer) {
   assert(layer != NULL);
   assert(layer->vtable != NULL);
 
@@ -3820,6 +4139,5 @@ msMSSQL2008LayerInitializeVirtualTable(l
   /* layer->vtable->LayerCreateItems, use default */
   layer->vtable->LayerGetNumFeatures = msMSSQL2008LayerGetNumFeatures;
 
-
   return MS_SUCCESS;
 }
diff -pruN 8.0.1-5/mapmvt.c 8.0.2-1/mapmvt.c
--- 8.0.1-5/mapmvt.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapmvt.c	2024-06-11 20:41:34.000000000 +0000
@@ -42,7 +42,11 @@
 
 #define FEATURES_INCREMENT_SIZE 5
 
-enum MS_RING_DIRECTION { MS_DIRECTION_INVALID_RING, MS_DIRECTION_CLOCKWISE, MS_DIRECTION_COUNTERCLOCKWISE };
+enum MS_RING_DIRECTION {
+  MS_DIRECTION_INVALID_RING,
+  MS_DIRECTION_CLOCKWISE,
+  MS_DIRECTION_COUNTERCLOCKWISE
+};
 
 typedef struct {
   char *value;
@@ -54,46 +58,54 @@ typedef struct {
   value_lookup *cache;
 } value_lookup_table;
 
-#define COMMAND(id, count) (((id) & 0x7) | ((count) << 3))
+#define COMMAND(id, count) (((id)&0x7) | ((count) << 3))
 #define PARAMETER(n) (((n) << 1) ^ ((n) >> 31))
 
-static double getTriangleHeight(lineObj *ring)
-{
+static double getTriangleHeight(lineObj *ring) {
   int i;
-  double s=0, b=0;
+  double s = 0, b = 0;
 
-  if(ring->numpoints != 4) return -1; /* not a triangle */
+  if (ring->numpoints != 4)
+    return -1; /* not a triangle */
 
-  for(i=0; i<ring->numpoints-1; i++) {
-    s += (ring->point[i].x*ring->point[i+1].y - ring->point[i+1].x*ring->point[i].y);
-    b = MS_MAX(b, msDistancePointToPoint(&ring->point[i], &ring->point[i+1]));
+  for (i = 0; i < ring->numpoints - 1; i++) {
+    s += (ring->point[i].x * ring->point[i + 1].y -
+          ring->point[i + 1].x * ring->point[i].y);
+    b = MS_MAX(b, msDistancePointToPoint(&ring->point[i], &ring->point[i + 1]));
   }
 
-  return (MS_ABS(s/b));
+  return (MS_ABS(s / b));
 }
 
 static enum MS_RING_DIRECTION mvtGetRingDirection(lineObj *ring) {
-  int i, sum=0;
+  int i, sum = 0;
 
-  if(ring->numpoints < 4) return MS_DIRECTION_INVALID_RING;
+  if (ring->numpoints < 4)
+    return MS_DIRECTION_INVALID_RING;
 
   /* step throught the edges */
-  for(i=0; i<ring->numpoints-1; i++) {
-    sum += ring->point[i].x * ring->point[i+1].y - ring->point[i+1].x * ring->point[i].y;
+  for (i = 0; i < ring->numpoints - 1; i++) {
+    sum += ring->point[i].x * ring->point[i + 1].y -
+           ring->point[i + 1].x * ring->point[i].y;
   }
 
-  return sum > 0 ? MS_DIRECTION_CLOCKWISE :
-         sum < 0 ? MS_DIRECTION_COUNTERCLOCKWISE : MS_DIRECTION_INVALID_RING;
+  return sum > 0   ? MS_DIRECTION_CLOCKWISE
+         : sum < 0 ? MS_DIRECTION_COUNTERCLOCKWISE
+                   : MS_DIRECTION_INVALID_RING;
 }
 
 static void mvtReverseRingDirection(lineObj *ring) {
   pointObj temp;
-  int start=1, end=ring->numpoints-2; /* first and last points are the same so skip 'em */
+  int start = 1, end = ring->numpoints -
+                       2; /* first and last points are the same so skip 'em */
 
   while (start < end) {
-    temp.x = ring->point[start].x; temp.y = ring->point[start].y;
-    ring->point[start].x = ring->point[end].x; ring->point[start].y = ring->point[end].y;
-    ring->point[end].x = temp.x; ring->point[end].y = temp.y;
+    temp.x = ring->point[start].x;
+    temp.y = ring->point[start].y;
+    ring->point[start].x = ring->point[end].x;
+    ring->point[start].y = ring->point[end].y;
+    ring->point[end].x = temp.x;
+    ring->point[end].y = temp.y;
     start++;
     end--;
   }
@@ -102,201 +114,228 @@ static void mvtReverseRingDirection(line
 static void mvtReorderRings(shapeObj *shape, int *outers) {
   int i, j;
   int t1;
-  lineObj t2; 
+  lineObj t2;
 
-  for(i=0; i<(shape->numlines-1); i++) {
-    for(j=0; j<(shape->numlines-i-1); j++) {
-      if(outers[j] < outers[j+1]) {
+  for (i = 0; i < (shape->numlines - 1); i++) {
+    for (j = 0; j < (shape->numlines - i - 1); j++) {
+      if (outers[j] < outers[j + 1]) {
         /* swap */
-	t1 = outers[j];
-        outers[j] = outers[j+1];
-	outers[j+1] = t1;
+        t1 = outers[j];
+        outers[j] = outers[j + 1];
+        outers[j + 1] = t1;
 
-	t2 = shape->line[j];
-        shape->line[j] = shape->line[j+1];
-	shape->line[j+1] = t2;
+        t2 = shape->line[j];
+        shape->line[j] = shape->line[j + 1];
+        shape->line[j + 1] = t2;
       }
     }
   }
 }
 
-static int mvtTransformShape(shapeObj *shape, rectObj *extent, int layer_type, int mvt_layer_extent) {
-  double scale_x,scale_y;
-  int i,j,outj;
+static int mvtTransformShape(shapeObj *shape, rectObj *extent, int layer_type,
+                             int mvt_layer_extent) {
+  double scale_x, scale_y;
+  int i, j, outj;
 
-  int *outers=NULL, ring_direction;
+  int *outers = NULL, ring_direction;
 
-  scale_x = (double)mvt_layer_extent/(extent->maxx - extent->minx);
-  scale_y = (double)mvt_layer_extent/(extent->maxy - extent->miny);
+  scale_x = (double)mvt_layer_extent / (extent->maxx - extent->minx);
+  scale_y = (double)mvt_layer_extent / (extent->maxy - extent->miny);
 
-  if(layer_type == MS_LAYER_POLYGON) {
+  if (layer_type == MS_LAYER_POLYGON) {
     outers = msGetOuterList(shape); /* compute before we muck with the shape */
-    if(outers[0] == 0) /* first ring must be an outer */
+    if (outers[0] == 0)             /* first ring must be an outer */
       mvtReorderRings(shape, outers);
   }
 
-  for(i=0;i<shape->numlines;i++) {
-    for(j=0,outj=0;j<shape->line[i].numpoints;j++) {
+  for (i = 0; i < shape->numlines; i++) {
+    for (j = 0, outj = 0; j < shape->line[i].numpoints; j++) {
 
-      shape->line[i].point[outj].x = (int)((shape->line[i].point[j].x - extent->minx)*scale_x);
-      shape->line[i].point[outj].y = mvt_layer_extent - (int)((shape->line[i].point[j].y - extent->miny)*scale_y);
-
-      if(!outj || shape->line[i].point[outj].x != shape->line[i].point[outj-1].x || shape->line[i].point[outj].y != shape->line[i].point[outj-1].y)
-        outj++; /* add the point to the shape only if it's the first one or if it's different than the previous one */
+      shape->line[i].point[outj].x =
+          (int)((shape->line[i].point[j].x - extent->minx) * scale_x);
+      shape->line[i].point[outj].y =
+          mvt_layer_extent -
+          (int)((shape->line[i].point[j].y - extent->miny) * scale_y);
+
+      if (!outj ||
+          shape->line[i].point[outj].x != shape->line[i].point[outj - 1].x ||
+          shape->line[i].point[outj].y != shape->line[i].point[outj - 1].y)
+        outj++; /* add the point to the shape only if it's the first one or if
+                   it's different than the previous one */
     }
     shape->line[i].numpoints = outj;
 
-    if(layer_type == MS_LAYER_POLYGON) {
-      if(shape->line[i].numpoints == 4 && getTriangleHeight(&shape->line[i]) < 1) {        
+    if (layer_type == MS_LAYER_POLYGON) {
+      if (shape->line[i].numpoints == 4 &&
+          getTriangleHeight(&shape->line[i]) < 1) {
         shape->line[i].numpoints = 0; /* so it's not considered anymore */
-        continue; /* next ring */
+        continue;                     /* next ring */
       }
 
       ring_direction = mvtGetRingDirection(&shape->line[i]);
-      if(ring_direction == MS_DIRECTION_INVALID_RING)
+      if (ring_direction == MS_DIRECTION_INVALID_RING)
         shape->line[i].numpoints = 0; /* so it's not considered anymore */
-      else if((outers[i] && ring_direction != MS_DIRECTION_CLOCKWISE) || (!outers[i] && ring_direction != MS_DIRECTION_COUNTERCLOCKWISE))
+      else if ((outers[i] && ring_direction != MS_DIRECTION_CLOCKWISE) ||
+               (!outers[i] && ring_direction != MS_DIRECTION_COUNTERCLOCKWISE))
         mvtReverseRingDirection(&shape->line[i]);
     }
   }
 
-  msComputeBounds(shape); /* TODO: might need to limit this to just valid parts... */
+  msComputeBounds(
+      shape); /* TODO: might need to limit this to just valid parts... */
   msFree(outers);
 
-  return (shape->numlines == 0)?MS_FAILURE:MS_SUCCESS; /* sucess if at least one line */
+  return (shape->numlines == 0) ? MS_FAILURE
+                                : MS_SUCCESS; /* sucess if at least one line */
 }
 
-static int mvtClipShape(shapeObj *shape, int layer_type, int buffer, int mvt_layer_extent) {
+static int mvtClipShape(shapeObj *shape, int layer_type, int buffer,
+                        int mvt_layer_extent) {
   rectObj tile_rect;
-  tile_rect.minx = tile_rect.miny=-buffer*16;
-  tile_rect.maxx = tile_rect.maxy=mvt_layer_extent + buffer*16;
+  tile_rect.minx = tile_rect.miny = -buffer * 16;
+  tile_rect.maxx = tile_rect.maxy = mvt_layer_extent + buffer * 16;
 
-  if(layer_type == MS_LAYER_POLYGON) {
+  if (layer_type == MS_LAYER_POLYGON) {
     msClipPolygonRect(shape, tile_rect);
-  } else if(layer_type == MS_LAYER_LINE) {
+  } else if (layer_type == MS_LAYER_LINE) {
     msClipPolylineRect(shape, tile_rect);
   }
 
   /* success if at least one line and not a degenerate bounding box */
-  if(shape->numlines > 0 && (layer_type == MS_LAYER_POINT || (shape->bounds.minx != shape->bounds.maxx || shape->bounds.miny != shape->bounds.maxy)))
+  if (shape->numlines > 0 && (layer_type == MS_LAYER_POINT ||
+                              (shape->bounds.minx != shape->bounds.maxx ||
+                               shape->bounds.miny != shape->bounds.maxy)))
     return MS_SUCCESS;
   else
     return MS_FAILURE;
 }
 
-static void freeMvtFeature( VectorTile__Tile__Feature *mvt_feature ) {
-  if(mvt_feature->tags)
+static void freeMvtFeature(VectorTile__Tile__Feature *mvt_feature) {
+  if (mvt_feature->tags)
     msFree(mvt_feature->tags);
-  if(mvt_feature->geometry)
+  if (mvt_feature->geometry)
     msFree(mvt_feature->geometry);
 }
 
-static void freeMvtValue( VectorTile__Tile__Value *mvt_value ) {
-  if(mvt_value->string_value)
+static void freeMvtValue(VectorTile__Tile__Value *mvt_value) {
+  if (mvt_value->string_value)
     msFree(mvt_value->string_value);
 }
 
-static void freeMvtLayer( VectorTile__Tile__Layer *mvt_layer ) {
-  if(mvt_layer->keys) {
-    for(unsigned i=0;i<mvt_layer->n_keys; i++) {
+static void freeMvtLayer(VectorTile__Tile__Layer *mvt_layer) {
+  if (mvt_layer->keys) {
+    for (unsigned i = 0; i < mvt_layer->n_keys; i++) {
       msFree(mvt_layer->keys[i]);
     }
     msFree(mvt_layer->keys);
   }
-  if(mvt_layer->values) {
-    for(unsigned i=0;i<mvt_layer->n_values; i++) {
-        freeMvtValue(mvt_layer->values[i]);
-        msFree(mvt_layer->values[i]);
+  if (mvt_layer->values) {
+    for (unsigned i = 0; i < mvt_layer->n_values; i++) {
+      freeMvtValue(mvt_layer->values[i]);
+      msFree(mvt_layer->values[i]);
     }
     msFree(mvt_layer->values);
   }
-  if(mvt_layer->features) {
-    for(unsigned i=0;i<mvt_layer->n_features; i++) {
-        freeMvtFeature(mvt_layer->features[i]);
-        msFree(mvt_layer->features[i]);
+  if (mvt_layer->features) {
+    for (unsigned i = 0; i < mvt_layer->n_features; i++) {
+      freeMvtFeature(mvt_layer->features[i]);
+      msFree(mvt_layer->features[i]);
     }
     msFree(mvt_layer->features);
   }
 }
 
-int mvtWriteShape( layerObj *layer, shapeObj *shape, VectorTile__Tile__Layer *mvt_layer,
-                   gmlItemListObj *item_list, value_lookup_table *value_lookup_cache,
-                   rectObj *unbuffered_bbox, int buffer) {
+int mvtWriteShape(layerObj *layer, shapeObj *shape,
+                  VectorTile__Tile__Layer *mvt_layer, gmlItemListObj *item_list,
+                  value_lookup_table *value_lookup_cache,
+                  rectObj *unbuffered_bbox, int buffer) {
   VectorTile__Tile__Feature *mvt_feature;
-  int i,j,iout;
+  int i, j, iout;
   value_lookup *value;
   long int n_geometry;
 
   /* could consider an intersection test here */
 
-  if(mvtTransformShape(shape, unbuffered_bbox, layer->type, mvt_layer->extent) != MS_SUCCESS) {
+  if (mvtTransformShape(shape, unbuffered_bbox, layer->type,
+                        mvt_layer->extent) != MS_SUCCESS) {
     return MS_SUCCESS; /* degenerate shape */
   }
-  if(mvtClipShape(shape, layer->type, buffer, mvt_layer->extent) != MS_SUCCESS) {
+  if (mvtClipShape(shape, layer->type, buffer, mvt_layer->extent) !=
+      MS_SUCCESS) {
     return MS_SUCCESS; /* no features left after clipping */
   }
 
   n_geometry = 0;
-  if(layer->type == MS_LAYER_POINT) {
-    for(i=0;i<shape->numlines;i++)
+  if (layer->type == MS_LAYER_POINT) {
+    for (i = 0; i < shape->numlines; i++)
       n_geometry += shape->line[i].numpoints * 2;
-    if(n_geometry)
+    if (n_geometry)
       n_geometry++; /* one MOVETO */
-  } else if(layer->type == MS_LAYER_LINE) {
-    for(i=0;i<shape->numlines;i++)
-      if(shape->line[i].numpoints >= 2) n_geometry += 2 + shape->line[i].numpoints * 2; /* one MOVETO, one LINETO */
-  } else { /* MS_LAYER_POLYGON */
-    for(i=0;i<shape->numlines;i++)
-      if(shape->line[i].numpoints >= 4) n_geometry += 3 + (shape->line[i].numpoints-1) * 2; /* one MOVETO, one LINETO, one CLOSEPATH (don't consider last duplicate point) */
+  } else if (layer->type == MS_LAYER_LINE) {
+    for (i = 0; i < shape->numlines; i++)
+      if (shape->line[i].numpoints >= 2)
+        n_geometry +=
+            2 + shape->line[i].numpoints * 2; /* one MOVETO, one LINETO */
+  } else {                                    /* MS_LAYER_POLYGON */
+    for (i = 0; i < shape->numlines; i++)
+      if (shape->line[i].numpoints >= 4)
+        n_geometry += 3 + (shape->line[i].numpoints - 1) *
+                              2; /* one MOVETO, one LINETO, one CLOSEPATH (don't
+                                    consider last duplicate point) */
   }
 
-  if(n_geometry == 0) return MS_SUCCESS;
+  if (n_geometry == 0)
+    return MS_SUCCESS;
 
-  mvt_layer->features[mvt_layer->n_features++] = msSmallMalloc(sizeof(VectorTile__Tile__Feature));
-  mvt_feature = mvt_layer->features[mvt_layer->n_features-1];
+  mvt_layer->features[mvt_layer->n_features++] =
+      msSmallMalloc(sizeof(VectorTile__Tile__Feature));
+  mvt_feature = mvt_layer->features[mvt_layer->n_features - 1];
   vector_tile__tile__feature__init(mvt_feature);
   mvt_feature->n_tags = mvt_layer->n_keys * 2;
   mvt_feature->tags = msSmallMalloc(mvt_feature->n_tags * sizeof(uint32_t));
   mvt_feature->id = shape->index;
   mvt_feature->has_id = 1;
 
-  if(layer->type == MS_LAYER_POLYGON)
+  if (layer->type == MS_LAYER_POLYGON)
     mvt_feature->type = VECTOR_TILE__TILE__GEOM_TYPE__POLYGON;
-  else if(layer->type == MS_LAYER_LINE)
+  else if (layer->type == MS_LAYER_LINE)
     mvt_feature->type = VECTOR_TILE__TILE__GEOM_TYPE__LINESTRING;
   else
     mvt_feature->type = VECTOR_TILE__TILE__GEOM_TYPE__POINT;
   mvt_feature->has_type = 1;
 
   /* output values */
-  for( i = 0, iout = 0; i < item_list->numitems; i++ ) {
+  for (i = 0, iout = 0; i < item_list->numitems; i++) {
     gmlItemObj *item = item_list->items + i;
 
-    if( !item->visible )
+    if (!item->visible)
       continue;
 
     UT_HASH_FIND_STR(value_lookup_cache->cache, shape->values[i], value);
-    if(!value) {
+    if (!value) {
       VectorTile__Tile__Value *mvt_value;
       value = msSmallMalloc(sizeof(value_lookup));
       value->value = msStrdup(shape->values[i]);
       value->index = mvt_layer->n_values;
-      mvt_layer->values = msSmallRealloc(mvt_layer->values,(++mvt_layer->n_values)*sizeof(VectorTile__Tile__Value*));
-      mvt_layer->values[mvt_layer->n_values-1] = msSmallMalloc(sizeof(VectorTile__Tile__Value));
-      mvt_value = mvt_layer->values[mvt_layer->n_values-1];
+      mvt_layer->values = msSmallRealloc(mvt_layer->values,
+                                         (++mvt_layer->n_values) *
+                                             sizeof(VectorTile__Tile__Value *));
+      mvt_layer->values[mvt_layer->n_values - 1] =
+          msSmallMalloc(sizeof(VectorTile__Tile__Value));
+      mvt_value = mvt_layer->values[mvt_layer->n_values - 1];
       vector_tile__tile__value__init(mvt_value);
 
-      if( item->type && EQUAL(item->type,"Integer")) {
+      if (item->type && EQUAL(item->type, "Integer")) {
         mvt_value->int_value = atoi(value->value);
         mvt_value->has_int_value = 1;
-      } else if( item->type && EQUAL(item->type,"Long")) { /* signed */
-	mvt_value->sint_value = atol(value->value);
-	mvt_value->has_sint_value = 1;
-      } else if( item->type && EQUAL(item->type,"Real")) {
+      } else if (item->type && EQUAL(item->type, "Long")) { /* signed */
+        mvt_value->sint_value = atol(value->value);
+        mvt_value->has_sint_value = 1;
+      } else if (item->type && EQUAL(item->type, "Real")) {
         mvt_value->float_value = atof(value->value);
         mvt_value->has_float_value = 1;
-      } else if( item->type && EQUAL(item->type,"Boolean") ) {
-        if(EQUAL(value->value,"0") || EQUAL(value->value,"false"))
+      } else if (item->type && EQUAL(item->type, "Boolean")) {
+        if (EQUAL(value->value, "0") || EQUAL(value->value, "false"))
           mvt_value->bool_value = 0;
         else
           mvt_value->bool_value = 1;
@@ -304,52 +343,63 @@ int mvtWriteShape( layerObj *layer, shap
       } else {
         mvt_value->string_value = msStrdup(value->value);
       }
-      UT_HASH_ADD_KEYPTR(hh,value_lookup_cache->cache,value->value, strlen(value->value), value);
+      UT_HASH_ADD_KEYPTR(hh, value_lookup_cache->cache, value->value,
+                         strlen(value->value), value);
     }
-    mvt_feature->tags[iout*2] = iout;
-    mvt_feature->tags[iout*2+1] = value->index;
+    mvt_feature->tags[iout * 2] = iout;
+    mvt_feature->tags[iout * 2 + 1] = value->index;
 
     iout++;
   }
 
   /* output geom */
   mvt_feature->n_geometry = n_geometry;
-  mvt_feature->geometry = msSmallMalloc(mvt_feature->n_geometry * sizeof(uint32_t));
+  mvt_feature->geometry =
+      msSmallMalloc(mvt_feature->n_geometry * sizeof(uint32_t));
 
-  if(layer->type == MS_LAYER_POINT) {
-    int idx=0, lastx=0, lasty=0;
-    mvt_feature->geometry[idx++] = COMMAND(MOVETO, (mvt_feature->n_geometry-1) / 2);
-    for(i=0;i<shape->numlines;i++) {
-      for(j=0;j<shape->line[i].numpoints;j++) {
-        mvt_feature->geometry[idx++] = PARAMETER(MS_NINT(shape->line[i].point[j].x)-lastx);
-        mvt_feature->geometry[idx++] = PARAMETER(MS_NINT(shape->line[i].point[j].y)-lasty);
+  if (layer->type == MS_LAYER_POINT) {
+    int idx = 0, lastx = 0, lasty = 0;
+    mvt_feature->geometry[idx++] =
+        COMMAND(MOVETO, (mvt_feature->n_geometry - 1) / 2);
+    for (i = 0; i < shape->numlines; i++) {
+      for (j = 0; j < shape->line[i].numpoints; j++) {
+        mvt_feature->geometry[idx++] =
+            PARAMETER(MS_NINT(shape->line[i].point[j].x) - lastx);
+        mvt_feature->geometry[idx++] =
+            PARAMETER(MS_NINT(shape->line[i].point[j].y) - lasty);
         lastx = MS_NINT(shape->line[i].point[j].x);
         lasty = MS_NINT(shape->line[i].point[j].y);
       }
     }
   } else { /* MS_LAYER_LINE or MS_LAYER_POLYGON */
     int numpoints;
-    int idx=0, lastx=0, lasty=0;
-    for(i=0;i<shape->numlines;i++) {
+    int idx = 0, lastx = 0, lasty = 0;
+    for (i = 0; i < shape->numlines; i++) {
 
-      if((layer->type == MS_LAYER_LINE && !(shape->line[i].numpoints >= 2)) || 
-         (layer->type == MS_LAYER_POLYGON && !(shape->line[i].numpoints >= 4))) {        
+      if ((layer->type == MS_LAYER_LINE && !(shape->line[i].numpoints >= 2)) ||
+          (layer->type == MS_LAYER_POLYGON &&
+           !(shape->line[i].numpoints >= 4))) {
         continue; /* skip malformed parts */
       }
 
-      numpoints = (layer->type == MS_LAYER_LINE)?shape->line[i].numpoints:(shape->line[i].numpoints-1); /* don't consider last point for polygons */
-      for(j=0;j<numpoints;j++) {
-        if(j==0) {
+      numpoints = (layer->type == MS_LAYER_LINE)
+                      ? shape->line[i].numpoints
+                      : (shape->line[i].numpoints -
+                         1); /* don't consider last point for polygons */
+      for (j = 0; j < numpoints; j++) {
+        if (j == 0) {
           mvt_feature->geometry[idx++] = COMMAND(MOVETO, 1);
-        } else if(j==1) {
-          mvt_feature->geometry[idx++] = COMMAND(LINETO, numpoints-1);
+        } else if (j == 1) {
+          mvt_feature->geometry[idx++] = COMMAND(LINETO, numpoints - 1);
         }
-        mvt_feature->geometry[idx++] = PARAMETER(MS_NINT(shape->line[i].point[j].x)-lastx);
-	mvt_feature->geometry[idx++] = PARAMETER(MS_NINT(shape->line[i].point[j].y)-lasty);
-	lastx = MS_NINT(shape->line[i].point[j].x);
-	lasty = MS_NINT(shape->line[i].point[j].y);
+        mvt_feature->geometry[idx++] =
+            PARAMETER(MS_NINT(shape->line[i].point[j].x) - lastx);
+        mvt_feature->geometry[idx++] =
+            PARAMETER(MS_NINT(shape->line[i].point[j].y) - lasty);
+        lastx = MS_NINT(shape->line[i].point[j].x);
+        lasty = MS_NINT(shape->line[i].point[j].y);
       }
-      if(layer->type == MS_LAYER_POLYGON) {
+      if (layer->type == MS_LAYER_POLYGON) {
         mvt_feature->geometry[idx++] = COMMAND(CLOSEPATH, 1);
       }
     }
@@ -358,36 +408,41 @@ int mvtWriteShape( layerObj *layer, shap
   return MS_SUCCESS;
 }
 
-static void freeMvtTile( VectorTile__Tile *mvt_tile ) {
-  for(unsigned iLayer=0;iLayer<mvt_tile->n_layers;iLayer++) {
+static void freeMvtTile(VectorTile__Tile *mvt_tile) {
+  for (unsigned iLayer = 0; iLayer < mvt_tile->n_layers; iLayer++) {
     freeMvtLayer(mvt_tile->layers[iLayer]);
     msFree(mvt_tile->layers[iLayer]);
   }
   msFree(mvt_tile->layers);
 }
 
-int msMVTWriteTile( mapObj *map, int sendheaders ) {
-  int iLayer,retcode=MS_SUCCESS;
+int msMVTWriteTile(mapObj *map, int sendheaders) {
+  int iLayer, retcode = MS_SUCCESS;
   unsigned len;
   void *buf;
-  const char *mvt_extent = msGetOutputFormatOption(map->outputformat, "EXTENT", "4096");
-  const char *mvt_buffer = msGetOutputFormatOption(map->outputformat, "EDGE_BUFFER", "10");
+  const char *mvt_extent =
+      msGetOutputFormatOption(map->outputformat, "EXTENT", "4096");
+  const char *mvt_buffer =
+      msGetOutputFormatOption(map->outputformat, "EDGE_BUFFER", "10");
   int buffer = MS_ABS(atoi(mvt_buffer));
   VectorTile__Tile mvt_tile = VECTOR_TILE__TILE__INIT;
-  mvt_tile.layers = msSmallCalloc(map->numlayers, sizeof(VectorTile__Tile__Layer*));
+  mvt_tile.layers =
+      msSmallCalloc(map->numlayers, sizeof(VectorTile__Tile__Layer *));
 
   /* make sure we have a scale and cellsize computed */
   map->cellsize = MS_CELLSIZE(map->extent.minx, map->extent.maxx, map->width);
-  msCalculateScale(map->extent, map->units, map->width, map->height, map->resolution, &map->scaledenom);
+  msCalculateScale(map->extent, map->units, map->width, map->height,
+                   map->resolution, &map->scaledenom);
 
-  /* expand the map->extent so it goes from pixel center (MapServer) to pixel edge (OWS) */
+  /* expand the map->extent so it goes from pixel center (MapServer) to pixel
+   * edge (OWS) */
   map->extent.minx -= map->cellsize * 0.5;
   map->extent.maxx += map->cellsize * 0.5;
   map->extent.miny -= map->cellsize * 0.5;
   map->extent.maxy += map->cellsize * 0.5;
 
-  for( iLayer = 0; iLayer < map->numlayers; iLayer++ ) {
-    int status=MS_SUCCESS;
+  for (iLayer = 0; iLayer < map->numlayers; iLayer++) {
+    int status = MS_SUCCESS;
     layerObj *layer = GET_LAYER(map, iLayer);
     int i;
     shapeObj shape;
@@ -399,19 +454,23 @@ int msMVTWriteTile( mapObj *map, int sen
 
     unsigned features_size = 0;
 
-    if(!msLayerIsVisible(map, layer)) continue;
+    if (!msLayerIsVisible(map, layer))
+      continue;
 
-    if(layer->type != MS_LAYER_POINT && layer->type != MS_LAYER_POLYGON && layer->type != MS_LAYER_LINE)
+    if (layer->type != MS_LAYER_POINT && layer->type != MS_LAYER_POLYGON &&
+        layer->type != MS_LAYER_LINE)
       continue;
 
     status = msLayerOpen(layer);
-    if(status != MS_SUCCESS) {
+    if (status != MS_SUCCESS) {
       retcode = status;
       goto layer_cleanup;
     }
 
-    status = msLayerWhichItems(layer, MS_TRUE, NULL); /* we want all items - behaves like a query in that sense */
-    if(status != MS_SUCCESS) {
+    status = msLayerWhichItems(
+        layer, MS_TRUE,
+        NULL); /* we want all items - behaves like a query in that sense */
+    if (status != MS_SUCCESS) {
       retcode = status;
       goto layer_cleanup;
     }
@@ -419,22 +478,25 @@ int msMVTWriteTile( mapObj *map, int sen
     /* -------------------------------------------------------------------- */
     /*      Will we need to reproject?                                      */
     /* -------------------------------------------------------------------- */
-    layer->project = msProjectionsDiffer(&(layer->projection), &(map->projection));
+    layer->project =
+        msProjectionsDiffer(&(layer->projection), &(map->projection));
 
     rect = map->extent;
-    if(layer->project) msProjectRect(&(map->projection), &(layer->projection), &rect);
+    if (layer->project)
+      msProjectRect(&(map->projection), &(layer->projection), &rect);
 
     status = msLayerWhichShapes(layer, rect, MS_TRUE);
-    if(status == MS_DONE) { /* no overlap - that's ok */
+    if (status == MS_DONE) { /* no overlap - that's ok */
       retcode = MS_SUCCESS;
       goto layer_cleanup;
-    } else if(status != MS_SUCCESS) {
+    } else if (status != MS_SUCCESS) {
       retcode = status;
       goto layer_cleanup;
     }
 
-    mvt_tile.layers[mvt_tile.n_layers++] = msSmallMalloc(sizeof(VectorTile__Tile__Layer));
-    mvt_layer = mvt_tile.layers[mvt_tile.n_layers-1];
+    mvt_tile.layers[mvt_tile.n_layers++] =
+        msSmallMalloc(sizeof(VectorTile__Tile__Layer));
+    mvt_layer = mvt_tile.layers[mvt_tile.n_layers - 1];
     vector_tile__tile__layer__init(mvt_layer);
     mvt_layer->version = 2;
     mvt_layer->name = layer->name;
@@ -445,18 +507,18 @@ int msMVTWriteTile( mapObj *map, int sen
     /* -------------------------------------------------------------------- */
     /*      Create appropriate attributes on this layer.                    */
     /* -------------------------------------------------------------------- */
-    item_list = msGMLGetItems( layer, "G" );
-    assert( item_list->numitems == layer->numitems );
+    item_list = msGMLGetItems(layer, "G");
+    assert(item_list->numitems == layer->numitems);
 
-    mvt_layer->keys = msSmallMalloc(layer->numitems * sizeof(char*));
+    mvt_layer->keys = msSmallMalloc(layer->numitems * sizeof(char *));
 
-    for( i = 0; i < layer->numitems; i++ ) {
+    for (i = 0; i < layer->numitems; i++) {
       gmlItemObj *item = item_list->items + i;
 
-      if( !item->visible )
+      if (!item->visible)
         continue;
 
-      if( item->alias )
+      if (item->alias)
         mvt_layer->keys[mvt_layer->n_keys++] = msStrdup(item->alias);
       else
         mvt_layer->keys[mvt_layer->n_keys++] = msStrdup(item->name);
@@ -465,109 +527,122 @@ int msMVTWriteTile( mapObj *map, int sen
     /* -------------------------------------------------------------------- */
     /*      Setup joins if needed.  This is likely untested.                */
     /* -------------------------------------------------------------------- */
-    if(layer->numjoins > 0) {
+    if (layer->numjoins > 0) {
       int j;
-      for(j=0; j<layer->numjoins; j++) {
+      for (j = 0; j < layer->numjoins; j++) {
         status = msJoinConnect(layer, &(layer->joins[j]));
-        if(status != MS_SUCCESS) {
+        if (status != MS_SUCCESS) {
           retcode = status;
           goto layer_cleanup;
         }
       }
     }
 
-    mvt_layer->features = msSmallCalloc(FEATURES_INCREMENT_SIZE, sizeof(VectorTile__Tile__Feature*));
+    mvt_layer->features = msSmallCalloc(FEATURES_INCREMENT_SIZE,
+                                        sizeof(VectorTile__Tile__Feature *));
     features_size = FEATURES_INCREMENT_SIZE;
 
     msInitShape(&shape);
-    while((status = msLayerNextShape(layer, &shape)) == MS_SUCCESS) {
-      
-      if(layer->numclasses > 0) {
-        shape.classindex = msShapeGetClass(layer, map, &shape, NULL, -1); /* Perform classification, and some annotation related magic. */
-        if(shape.classindex < 0)
+    while ((status = msLayerNextShape(layer, &shape)) == MS_SUCCESS) {
+
+      if (layer->numclasses > 0) {
+        shape.classindex = msShapeGetClass(
+            layer, map, &shape, NULL, -1); /* Perform classification, and some
+                                              annotation related magic. */
+        if (shape.classindex < 0)
           goto feature_cleanup; /* no matching CLASS found, skip this feature */
       }
 
       /*
       ** prepare any necessary JOINs here (one-to-one only)
       */
-      if( layer->numjoins > 0) {
+      if (layer->numjoins > 0) {
         int j;
 
-        for(j=0; j < layer->numjoins; j++) {
-          if(layer->joins[j].type == MS_JOIN_ONE_TO_ONE) {
+        for (j = 0; j < layer->numjoins; j++) {
+          if (layer->joins[j].type == MS_JOIN_ONE_TO_ONE) {
             msJoinPrepare(&(layer->joins[j]), &shape);
             msJoinNext(&(layer->joins[j])); /* fetch the first row */
           }
         }
       }
 
-      if(mvt_layer->n_features == features_size) { /* need to allocate more space */
+      if (mvt_layer->n_features ==
+          features_size) { /* need to allocate more space */
         features_size += FEATURES_INCREMENT_SIZE;
-        mvt_layer->features = msSmallRealloc(mvt_layer->features, sizeof(VectorTile__Tile__Feature*)*(features_size));
+        mvt_layer->features = msSmallRealloc(
+            mvt_layer->features,
+            sizeof(VectorTile__Tile__Feature *) * (features_size));
       }
 
-      if( layer->project ) {
-        if( layer->reprojectorLayerToMap == NULL )
-        {
-            layer->reprojectorLayerToMap = msProjectCreateReprojector(
-                &layer->projection, &map->projection);
+      if (layer->project) {
+        if (layer->reprojectorLayerToMap == NULL) {
+          layer->reprojectorLayerToMap =
+              msProjectCreateReprojector(&layer->projection, &map->projection);
         }
-        if( layer->reprojectorLayerToMap )
-            status = msProjectShapeEx(layer->reprojectorLayerToMap, &shape);
+        if (layer->reprojectorLayerToMap)
+          status = msProjectShapeEx(layer->reprojectorLayerToMap, &shape);
         else
-            status = MS_FAILURE;
+          status = MS_FAILURE;
       }
-      if( status == MS_SUCCESS ) {
-        status = mvtWriteShape( layer, &shape, mvt_layer, item_list, &value_lookup_cache, &map->extent, buffer );
+      if (status == MS_SUCCESS) {
+        status = mvtWriteShape(layer, &shape, mvt_layer, item_list,
+                               &value_lookup_cache, &map->extent, buffer);
       }
 
-      feature_cleanup:
+    feature_cleanup:
       msFreeShape(&shape);
-      if(status != MS_SUCCESS) goto layer_cleanup;
+      if (status != MS_SUCCESS)
+        goto layer_cleanup;
     } /* next shape */
-layer_cleanup:
+  layer_cleanup:
     msLayerClose(layer);
     msGMLFreeItems(item_list);
-    UT_HASH_ITER(hh, value_lookup_cache.cache, cur_value_lookup, tmp_value_lookup) {
+    UT_HASH_ITER(hh, value_lookup_cache.cache, cur_value_lookup,
+                 tmp_value_lookup) {
       msFree(cur_value_lookup->value);
-      UT_HASH_DEL(value_lookup_cache.cache,cur_value_lookup);
+      UT_HASH_DEL(value_lookup_cache.cache, cur_value_lookup);
       msFree(cur_value_lookup);
     }
-    if(retcode != MS_SUCCESS) goto cleanup;
+    if (retcode != MS_SUCCESS)
+      goto cleanup;
   } /* next layer */
 
-  len = vector_tile__tile__get_packed_size(&mvt_tile); // This is the calculated packing length
+  len = vector_tile__tile__get_packed_size(
+      &mvt_tile); // This is the calculated packing length
 
   buf = msSmallMalloc(len); // Allocate memory
   vector_tile__tile__pack(&mvt_tile, buf);
-  if( sendheaders ) {
-    msIO_fprintf( stdout,
-		  "Content-Length: %d\r\n"
-		  "Content-Type: %s\r\n\r\n",
-                  len, MS_IMAGE_MIME_TYPE(map->outputformat));
+  if (sendheaders) {
+    msIO_fprintf(stdout,
+                 "Content-Length: %d\r\n"
+                 "Content-Type: %s\r\n\r\n",
+                 len, MS_IMAGE_MIME_TYPE(map->outputformat));
   }
-  msIO_fwrite(buf,len,1,stdout);
+  msIO_fwrite(buf, len, 1, stdout);
   msFree(buf);
 
-  cleanup:
+cleanup:
   freeMvtTile(&mvt_tile);
 
   return retcode;
 }
 
-int msPopulateRendererVTableMVT(rendererVTableObj * renderer) {
+int msPopulateRendererVTableMVT(rendererVTableObj *renderer) {
   (void)renderer;
   return MS_SUCCESS;
 }
 #else
-int msPopulateRendererVTableMVT(rendererVTableObj * renderer) {
-  msSetError(MS_MISCERR, "Vector Tile Driver requested but support is not compiled in", "msPopulateRendererVTableMVT()");
+int msPopulateRendererVTableMVT(rendererVTableObj *renderer) {
+  msSetError(MS_MISCERR,
+             "Vector Tile Driver requested but support is not compiled in",
+             "msPopulateRendererVTableMVT()");
   return MS_FAILURE;
 }
 
-int msMVTWriteTile( mapObj *map, int sendheaders ) {
-  msSetError(MS_MISCERR, "Vector Tile support is not available.", "msMVTWriteTile()");
+int msMVTWriteTile(mapObj *map, int sendheaders) {
+  msSetError(MS_MISCERR, "Vector Tile support is not available.",
+             "msMVTWriteTile()");
   return MS_FAILURE;
 }
 #endif
diff -pruN 8.0.1-5/mapobject.c 8.0.2-1/mapobject.c
--- 8.0.1-5/mapobject.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapobject.c	2024-06-11 20:41:34.000000000 +0000
@@ -45,24 +45,23 @@ void freeLegend(legendObj *legend);
 /*      Create a new initialized map object.                            */
 /************************************************************************/
 
-mapObj *msNewMapObj()
-{
+mapObj *msNewMapObj() {
   mapObj *map = NULL;
 
   /* create an empty map, no layers etc... */
-  map = (mapObj *)calloc(sizeof(mapObj),1);
+  map = (mapObj *)calloc(sizeof(mapObj), 1);
 
-  if(!map) {
+  if (!map) {
     msSetError(MS_MEMERR, NULL, "msCreateMap()");
     return NULL;
   }
 
-  if( initMap( map ) == -1 ) {
+  if (initMap(map) == -1) {
     msFreeMap(map);
     return NULL;
   }
 
-  if( msPostMapParseOutputFormatSetup( map ) == MS_FAILURE ) {
+  if (msPostMapParseOutputFormatSetup(map) == MS_FAILURE) {
     msFreeMap(map);
     return NULL;
   }
@@ -74,18 +73,19 @@ mapObj *msNewMapObj()
 /*                             msFreeMap()                              */
 /************************************************************************/
 
-void msFreeMap(mapObj *map)
-{
+void msFreeMap(mapObj *map) {
   int i;
 
-  if(!map) return;
+  if (!map)
+    return;
 
-  /* printf("msFreeMap(): maybe freeing map at %p count=%d.\n",map, map->refcount); */
-  if(MS_REFCNT_DECR_IS_NOT_ZERO(map)) {
+  /* printf("msFreeMap(): maybe freeing map at %p count=%d.\n",map,
+   * map->refcount); */
+  if (MS_REFCNT_DECR_IS_NOT_ZERO(map)) {
     return;
   }
-  if(map->debug >= MS_DEBUGLEVEL_VV)
-    msDebug("msFreeMap(): freeing map at %p.\n",map);
+  if (map->debug >= MS_DEBUGLEVEL_VV)
+    msDebug("msFreeMap(): freeing map at %p.\n", map);
 
   msCloseConnections(map);
 
@@ -112,29 +112,31 @@ void msFreeMap(mapObj *map)
   freeReferenceMap(&(map->reference));
   freeLegend(&(map->legend));
 
-  for(i=0; i<map->maxlayers; i++) {
-    if(GET_LAYER(map, i) != NULL) {
+  for (i = 0; i < map->maxlayers; i++) {
+    if (GET_LAYER(map, i) != NULL) {
       GET_LAYER(map, i)->map = NULL;
-      if(freeLayer((GET_LAYER(map, i))) == MS_SUCCESS)
+      if (freeLayer((GET_LAYER(map, i))) == MS_SUCCESS)
         free(GET_LAYER(map, i));
     }
   }
   msFree(map->layers);
 
-  if(map->layerorder)
+  if (map->layerorder)
     free(map->layerorder);
 
   msFree(map->templatepattern);
   msFree(map->datapattern);
   msFreeHashItems(&(map->configoptions));
-  if(map->outputformat && map->outputformat->refcount > 0 && --map->outputformat->refcount < 1)
+  if (map->outputformat && map->outputformat->refcount > 0 &&
+      --map->outputformat->refcount < 1)
     msFreeOutputFormat(map->outputformat);
 
-  for(i=0; i<map->numoutputformats; i++ ) {
-    if(map->outputformatlist[i]->refcount > 0 && --map->outputformatlist[i]->refcount < 1)
+  for (i = 0; i < map->numoutputformats; i++) {
+    if (map->outputformatlist[i]->refcount > 0 &&
+        --map->outputformatlist[i]->refcount < 1)
       msFreeOutputFormat(map->outputformatlist[i]);
   }
-  if(map->outputformatlist != NULL)
+  if (map->outputformatlist != NULL)
     msFree(map->outputformatlist);
 
   msFreeQuery(&(map->query));
@@ -151,38 +153,38 @@ void msFreeMap(mapObj *map)
 /*                         msGetConfigOption()                          */
 /************************************************************************/
 
-const char *msGetConfigOption( mapObj *map, const char *key)
+const char *msGetConfigOption(mapObj *map, const char *key)
 
 {
-  return msLookupHashTable( &(map->configoptions), key );
+  return msLookupHashTable(&(map->configoptions), key);
 }
 
 /************************************************************************/
 /*                         msSetConfigOption()                          */
 /************************************************************************/
 
-int msSetConfigOption( mapObj *map, const char *key, const char *value)
+int msSetConfigOption(mapObj *map, const char *key, const char *value)
 
 {
   /* We have special "early" handling of this so that it will be */
   /* in effect when the projection blocks are parsed and pj_init is called. */
-  if( strcasecmp(key,"PROJ_DATA") == 0 || strcasecmp(key,"PROJ_LIB") == 0 ) {
+  if (strcasecmp(key, "PROJ_DATA") == 0 || strcasecmp(key, "PROJ_LIB") == 0) {
     /* value may be relative to map path */
-    msSetPROJ_DATA( value, map->mappath );
+    msSetPROJ_DATA(value, map->mappath);
   }
 
   /* Same for MS_ERRORFILE, we want it to kick in as early as possible
    * to catch parsing errors.
    * Value can be relative to mapfile, unless it's already absolute
    */
-  if( strcasecmp(key,"MS_ERRORFILE") == 0 ) {
-    if (msSetErrorFile( value, map->mappath ) != MS_SUCCESS)
+  if (strcasecmp(key, "MS_ERRORFILE") == 0) {
+    if (msSetErrorFile(value, map->mappath) != MS_SUCCESS)
       return MS_FAILURE;
   }
 
-  if( msLookupHashTable( &(map->configoptions), key ) != NULL )
-    msRemoveHashTable( &(map->configoptions), key );
-  msInsertHashTable( &(map->configoptions), key, value );
+  if (msLookupHashTable(&(map->configoptions), key) != NULL)
+    msRemoveHashTable(&(map->configoptions), key);
+  msInsertHashTable(&(map->configoptions), key, value);
 
   return MS_SUCCESS;
 }
@@ -191,17 +193,16 @@ int msSetConfigOption( mapObj *map, cons
 /*                         msTestConfigOption()                         */
 /************************************************************************/
 
-int msTestConfigOption( mapObj *map, const char *key, int default_result )
+int msTestConfigOption(mapObj *map, const char *key, int default_result)
 
 {
-  const char *result = msGetConfigOption( map, key );
+  const char *result = msGetConfigOption(map, key);
 
-  if( result == NULL )
+  if (result == NULL)
     return default_result;
 
-  if( strcasecmp(result,"YES") == 0
-      || strcasecmp(result,"ON") == 0
-      || strcasecmp(result,"TRUE") == 0 )
+  if (strcasecmp(result, "YES") == 0 || strcasecmp(result, "ON") == 0 ||
+      strcasecmp(result, "TRUE") == 0)
     return MS_TRUE;
   else
     return MS_FALSE;
@@ -211,48 +212,45 @@ int msTestConfigOption( mapObj *map, con
 /*                      msApplyMapConfigOptions()                       */
 /************************************************************************/
 
-void msApplyMapConfigOptions( mapObj *map )
+void msApplyMapConfigOptions(mapObj *map)
 
 {
   const char *key;
 
-  for( key = msFirstKeyFromHashTable( &(map->configoptions) );
-       key != NULL;
-       key = msNextKeyFromHashTable( &(map->configoptions), key ) ) {
-    const char *value = msLookupHashTable( &(map->configoptions), key );
-    if( strcasecmp(key,"PROJ_DATA") == 0 ||
-        strcasecmp(key,"PROJ_LIB") == 0 ) {
-      msSetPROJ_DATA( value, map->mappath );
-    } else if( strcasecmp(key,"MS_ERRORFILE") == 0 ) {
-      msSetErrorFile( value, map->mappath );
+  for (key = msFirstKeyFromHashTable(&(map->configoptions)); key != NULL;
+       key = msNextKeyFromHashTable(&(map->configoptions), key)) {
+    const char *value = msLookupHashTable(&(map->configoptions), key);
+    if (strcasecmp(key, "PROJ_DATA") == 0 || strcasecmp(key, "PROJ_LIB") == 0) {
+      msSetPROJ_DATA(value, map->mappath);
+    } else if (strcasecmp(key, "MS_ERRORFILE") == 0) {
+      msSetErrorFile(value, map->mappath);
     } else {
-      CPLSetConfigOption( key, value );
+      CPLSetConfigOption(key, value);
     }
   }
 }
 
 /************************************************************************/
-/*                         msMapIgnoreMissingData()                               */
+/*                         msMapIgnoreMissingData() */
 /************************************************************************/
 
-int msMapIgnoreMissingData( mapObj *map )
-{
-  const char *result = msGetConfigOption( map, "ON_MISSING_DATA" );
+int msMapIgnoreMissingData(mapObj *map) {
+  const char *result = msGetConfigOption(map, "ON_MISSING_DATA");
   const int default_result =
 #ifndef IGNORE_MISSING_DATA
-    MS_MISSING_DATA_FAIL;
+      MS_MISSING_DATA_FAIL;
 #else
-    MS_MISSING_DATA_LOG;
+      MS_MISSING_DATA_LOG;
 #endif
 
-  if( result == NULL )
+  if (result == NULL)
     return default_result;
 
-  if( strcasecmp(result,"FAIL") == 0 )
+  if (strcasecmp(result, "FAIL") == 0)
     return MS_MISSING_DATA_FAIL;
-  else if( strcasecmp(result,"LOG") == 0 )
+  else if (strcasecmp(result, "LOG") == 0)
     return MS_MISSING_DATA_LOG;
-  else if( strcasecmp(result,"IGNORE") == 0 )
+  else if (strcasecmp(result, "IGNORE") == 0)
     return MS_MISSING_DATA_IGNORE;
 
   return default_result;
@@ -262,9 +260,8 @@ int msMapIgnoreMissingData( mapObj *map
 /*                           msMapSetExtent()                           */
 /************************************************************************/
 
-int msMapSetExtent( mapObj *map,
-                    double minx, double miny, double maxx, double maxy)
-{
+int msMapSetExtent(mapObj *map, double minx, double miny, double maxx,
+                   double maxy) {
 
   map->extent.minx = minx;
   map->extent.miny = miny;
@@ -272,44 +269,43 @@ int msMapSetExtent( mapObj *map,
   map->extent.maxy = maxy;
 
   if (!MS_VALID_EXTENT(map->extent)) {
-    msSetError(MS_MISCERR, "Given map extent is invalid. Check that it " \
-               "is in the form: minx, miny, maxx, maxy", "setExtent()");
+    msSetError(MS_MISCERR,
+               "Given map extent is invalid. Check that it "
+               "is in the form: minx, miny, maxx, maxy",
+               "setExtent()");
     return MS_FAILURE;
   }
 
-  map->cellsize = msAdjustExtent(&(map->extent), map->width,
-                                 map->height);
+  map->cellsize = msAdjustExtent(&(map->extent), map->width, map->height);
 
   /* if the map size is also set, recompute scale, ignore errors? */
-  if( map->width != -1 || map->height != -1 )
+  if (map->width != -1 || map->height != -1)
     msCalculateScale(map->extent, map->units, map->width, map->height,
                      map->resolution, &(map->scaledenom));
 
-  return msMapComputeGeotransform( map );
+  return msMapComputeGeotransform(map);
 }
 
 /************************************************************************/
 /*                           msMapOffsetExtent()                        */
 /************************************************************************/
 
-int msMapOffsetExtent( mapObj *map, double x, double y)
-{
-  return msMapSetExtent( map,
-                         map->extent.minx + x, map->extent.miny + y,
-                         map->extent.maxx + x, map->extent.maxy + y);
+int msMapOffsetExtent(mapObj *map, double x, double y) {
+  return msMapSetExtent(map, map->extent.minx + x, map->extent.miny + y,
+                        map->extent.maxx + x, map->extent.maxy + y);
 }
 
 /************************************************************************/
 /*                           msMapScaleExtent()                         */
 /************************************************************************/
 
-int msMapScaleExtent( mapObj *map, double zoomfactor,
-                      double minscaledenom, double maxscaledenom)
-{
+int msMapScaleExtent(mapObj *map, double zoomfactor, double minscaledenom,
+                     double maxscaledenom) {
   double geo_width, geo_height, center_x, center_y, md;
 
   if (zoomfactor <= 0.0) {
-    msSetError(MS_MISCERR, "The given zoomfactor is invalid", "msMapScaleExtent()");
+    msSetError(MS_MISCERR, "The given zoomfactor is invalid",
+               "msMapScaleExtent()");
   }
 
   geo_width = map->extent.maxx - map->extent.minx;
@@ -322,7 +318,8 @@ int msMapScaleExtent( mapObj *map, doubl
 
   if (minscaledenom > 0 || maxscaledenom > 0) {
     /* ensure we are within the valid scale domain */
-    md = (map->width-1)/(map->resolution * msInchesPerUnit(map->units, center_y));
+    md = (map->width - 1) /
+         (map->resolution * msInchesPerUnit(map->units, center_y));
     if (minscaledenom > 0 && geo_width < minscaledenom * md)
       geo_width = minscaledenom * md;
     if (maxscaledenom > 0 && geo_width > maxscaledenom * md)
@@ -332,57 +329,57 @@ int msMapScaleExtent( mapObj *map, doubl
   geo_width *= 0.5;
   geo_height = geo_width * map->height / map->width;
 
-  return msMapSetExtent( map,
-                         center_x - geo_width, center_y - geo_height,
-                         center_x + geo_width, center_y + geo_height);
+  return msMapSetExtent(map, center_x - geo_width, center_y - geo_height,
+                        center_x + geo_width, center_y + geo_height);
 }
 
 /************************************************************************/
 /*                           msMapSetCenter()                           */
 /************************************************************************/
 
-int msMapSetCenter( mapObj *map, pointObj *center)
-{
-  return msMapOffsetExtent(map, center->x - (map->extent.minx + map->extent.maxx) * 0.5,
-                           center->y - (map->extent.miny + map->extent.maxy) * 0.5);
+int msMapSetCenter(mapObj *map, pointObj *center) {
+  return msMapOffsetExtent(
+      map, center->x - (map->extent.minx + map->extent.maxx) * 0.5,
+      center->y - (map->extent.miny + map->extent.maxy) * 0.5);
 }
 
 /************************************************************************/
 /*                           msMapSetRotation()                         */
 /************************************************************************/
 
-int msMapSetRotation( mapObj *map, double rotation_angle )
+int msMapSetRotation(mapObj *map, double rotation_angle)
 
 {
   map->gt.rotation_angle = rotation_angle;
-  if( map->gt.rotation_angle != 0.0 )
+  if (map->gt.rotation_angle != 0.0)
     map->gt.need_geotransform = MS_TRUE;
   else
     map->gt.need_geotransform = MS_FALSE;
 
-  return msMapComputeGeotransform( map );
+  return msMapComputeGeotransform(map);
 }
 
 /************************************************************************/
 /*                             msMapSetSize()                           */
 /************************************************************************/
 
-int msMapSetSize( mapObj *map, int width, int height )
+int msMapSetSize(mapObj *map, int width, int height)
 
 {
   map->width = width;
   map->height = height;
 
-  return msMapComputeGeotransform( map ); /* like SetRotation -- sean */
+  return msMapComputeGeotransform(map); /* like SetRotation -- sean */
 }
 
 /************************************************************************/
 /*                      msMapComputeGeotransform()                      */
 /************************************************************************/
 
-extern int InvGeoTransform( double *gt_in, double *gt_out );
+extern int InvGeoTransform(double *gt_in, double *gt_out);
 
-int msMapComputeGeotransformEx( mapObj * map, double resolutionX, double resolutionY )
+int msMapComputeGeotransformEx(mapObj *map, double resolutionX,
+                               double resolutionY)
 
 {
   double rot_angle;
@@ -395,57 +392,51 @@ int msMapComputeGeotransformEx( mapObj *
   geo_width = map->extent.maxx - map->extent.minx;
   geo_height = map->extent.maxy - map->extent.miny;
 
-  center_x = map->extent.minx + geo_width*0.5;
-  center_y = map->extent.miny + geo_height*0.5;
+  center_x = map->extent.minx + geo_width * 0.5;
+  center_y = map->extent.miny + geo_height * 0.5;
 
   /*
   ** Per bug 1916 we have to adjust for the fact that map extents
   ** are based on the center of the edge pixels, not the outer
   ** edges as is expected in a geotransform.
   */
-  map->gt.geotransform[1] =
-    cos(rot_angle) * resolutionX;
-  map->gt.geotransform[2] =
-    sin(rot_angle) * resolutionY;
-  map->gt.geotransform[0] = center_x
-                            - (map->width * 0.5) * map->gt.geotransform[1]
-                            - (map->height * 0.5) * map->gt.geotransform[2];
-
-  map->gt.geotransform[4] =
-    sin(rot_angle) * resolutionX;
-  map->gt.geotransform[5] =
-    - cos(rot_angle) * resolutionY;
-  map->gt.geotransform[3] = center_y
-                            - (map->width * 0.5) * map->gt.geotransform[4]
-                            - (map->height * 0.5) * map->gt.geotransform[5];
+  map->gt.geotransform[1] = cos(rot_angle) * resolutionX;
+  map->gt.geotransform[2] = sin(rot_angle) * resolutionY;
+  map->gt.geotransform[0] = center_x -
+                            (map->width * 0.5) * map->gt.geotransform[1] -
+                            (map->height * 0.5) * map->gt.geotransform[2];
+
+  map->gt.geotransform[4] = sin(rot_angle) * resolutionX;
+  map->gt.geotransform[5] = -cos(rot_angle) * resolutionY;
+  map->gt.geotransform[3] = center_y -
+                            (map->width * 0.5) * map->gt.geotransform[4] -
+                            (map->height * 0.5) * map->gt.geotransform[5];
 
-  if( InvGeoTransform( map->gt.geotransform,
-                       map->gt.invgeotransform ) )
+  if (InvGeoTransform(map->gt.geotransform, map->gt.invgeotransform))
     return MS_SUCCESS;
   else
     return MS_FAILURE;
 }
 
-int msMapComputeGeotransform( mapObj * map )
+int msMapComputeGeotransform(mapObj *map)
 
 {
   /* Do we have all required parameters? */
-  if( map->extent.minx == map->extent.maxx
-      || map->width <= 1 || map->height <= 1 )
+  if (map->extent.minx == map->extent.maxx || map->width <= 1 ||
+      map->height <= 1)
     return MS_FAILURE;
 
   const double geo_width = map->extent.maxx - map->extent.minx;
   const double geo_height = map->extent.maxy - map->extent.miny;
-  return msMapComputeGeotransformEx(map,
-                                    geo_width / (map->width-1),
-                                    geo_height / (map->height-1));
+  return msMapComputeGeotransformEx(map, geo_width / (map->width - 1),
+                                    geo_height / (map->height - 1));
 }
 
 /************************************************************************/
 /*                         msMapPixelToGeoref()                         */
 /************************************************************************/
 
-void msMapPixelToGeoref( mapObj *map, double *x, double *y )
+void msMapPixelToGeoref(mapObj *map, double *x, double *y)
 
 {
   (void)map;
@@ -458,7 +449,7 @@ void msMapPixelToGeoref( mapObj *map, do
 /*                         msMapGeorefToPixel()                         */
 /************************************************************************/
 
-void msMapGeorefToPixel( mapObj *map, double *x, double *y )
+void msMapGeorefToPixel(mapObj *map, double *x, double *y)
 
 {
   (void)map;
@@ -471,7 +462,7 @@ void msMapGeorefToPixel( mapObj *map, do
 /*                        msMapSetFakedExtent()                         */
 /************************************************************************/
 
-int msMapSetFakedExtent( mapObj *map )
+int msMapSetFakedExtent(mapObj *map)
 
 {
   int i;
@@ -502,26 +493,24 @@ int msMapSetFakedExtent( mapObj *map )
   /* -------------------------------------------------------------------- */
   map->projection.gt = map->gt;
 
-  map->projection.gt.geotransform[0]
-  += map->height * map->gt.geotransform[2];
-  map->projection.gt.geotransform[3]
-  += map->height * map->gt.geotransform[5];
+  map->projection.gt.geotransform[0] += map->height * map->gt.geotransform[2];
+  map->projection.gt.geotransform[3] += map->height * map->gt.geotransform[5];
 
   map->projection.gt.geotransform[2] *= -1;
   map->projection.gt.geotransform[5] *= -1;
 
-  for(i=0; i<map->numlayers; i++)
+  for (i = 0; i < map->numlayers; i++)
     GET_LAYER(map, i)->project = MS_TRUE;
 
-  return InvGeoTransform( map->projection.gt.geotransform,
-                          map->projection.gt.invgeotransform );
+  return InvGeoTransform(map->projection.gt.geotransform,
+                         map->projection.gt.invgeotransform);
 }
 
 /************************************************************************/
 /*                      msMapRestoreRealExtent()                        */
 /************************************************************************/
 
-int msMapRestoreRealExtent( mapObj *map )
+int msMapRestoreRealExtent(mapObj *map)
 
 {
   map->projection.gt.need_geotransform = MS_FALSE;
@@ -537,8 +526,7 @@ int msMapRestoreRealExtent( mapObj *map
 /* Returns the index at which the layer was inserted
  */
 
-int msInsertLayer(mapObj *map, layerObj *layer, int nIndex)
-{
+int msInsertLayer(mapObj *map, layerObj *layer, int nIndex) {
   if (!layer) {
     msSetError(MS_CHILDERR, "Can't insert a NULL Layer", "msInsertLayer()");
     return -1;
@@ -550,16 +538,17 @@ int msInsertLayer(mapObj *map, layerObj
       return -1;
   }
 
-  /* msGrowMapLayers allocates the new layer which we don't need to do since we have 1 that we are inserting
-                  not sure if it is possible for this to be non null otherwise, but better to check since this function
-                  replaces the value */
-  if (map->layers[map->numlayers]!=NULL)
+  /* msGrowMapLayers allocates the new layer which we don't need to do since we
+     have 1 that we are inserting not sure if it is possible for this to be non
+     null otherwise, but better to check since this function replaces the value
+   */
+  if (map->layers[map->numlayers] != NULL)
     free(map->layers[map->numlayers]);
 
   /* Catch attempt to insert past end of layers array */
   if (nIndex >= map->numlayers) {
     msSetError(MS_CHILDERR, "Cannot insert layer beyond index %d",
-               "msInsertLayer()", map->numlayers-1);
+               "msInsertLayer()", map->numlayers - 1);
     return -1;
   } else if (nIndex < 0) { /* Insert at the end by default */
     map->layerorder[map->numlayers] = map->numlayers;
@@ -568,28 +557,30 @@ int msInsertLayer(mapObj *map, layerObj
     GET_LAYER(map, map->numlayers)->map = map;
     MS_REFCNT_INCR(layer);
     map->numlayers++;
-    return map->numlayers-1;
-  } else  {
+    return map->numlayers - 1;
+  } else {
     /* Move existing layers at the specified nIndex or greater */
     /* to an index one higher */
     int i;
-    for (i=map->numlayers; i>nIndex; i--) {
-      GET_LAYER(map, i)=GET_LAYER(map, i-1);
+    for (i = map->numlayers; i > nIndex; i--) {
+      GET_LAYER(map, i) = GET_LAYER(map, i - 1);
       GET_LAYER(map, i)->index = i;
     }
 
     /* assign new layer to specified index */
-    GET_LAYER(map, nIndex)=layer;
+    GET_LAYER(map, nIndex) = layer;
     GET_LAYER(map, nIndex)->index = nIndex;
     GET_LAYER(map, nIndex)->map = map;
 
     /* adjust layers drawing order */
-    for (i=map->numlayers; i>nIndex; i--) {
-      map->layerorder[i] = map->layerorder[i-1];
-      if (map->layerorder[i] >= nIndex) map->layerorder[i]++;
-    }
-    for (i=0; i<nIndex; i++) {
-      if (map->layerorder[i] >= nIndex) map->layerorder[i]++;
+    for (i = map->numlayers; i > nIndex; i--) {
+      map->layerorder[i] = map->layerorder[i - 1];
+      if (map->layerorder[i] >= nIndex)
+        map->layerorder[i]++;
+    }
+    for (i = 0; i < nIndex; i++) {
+      if (map->layerorder[i] >= nIndex)
+        map->layerorder[i]++;
     }
     map->layerorder[nIndex] = nIndex;
 
@@ -603,8 +594,7 @@ int msInsertLayer(mapObj *map, layerObj
 /************************************************************************/
 /*                           msRemoveLayer()                            */
 /************************************************************************/
-layerObj *msRemoveLayer(mapObj *map, int nIndex)
-{
+layerObj *msRemoveLayer(mapObj *map, int nIndex) {
   int i;
   int order_index;
   layerObj *layer;
@@ -614,38 +604,40 @@ layerObj *msRemoveLayer(mapObj *map, int
                "msRemoveLayer()", nIndex);
     return NULL;
   } else {
-    layer=GET_LAYER(map, nIndex);
+    layer = GET_LAYER(map, nIndex);
     /* msCopyLayer(layer, (GET_LAYER(map, nIndex))); */
 
     /* Iteratively copy the higher index layers down one index */
-    for (i=nIndex; i<map->numlayers-1; i++) {
+    for (i = nIndex; i < map->numlayers - 1; i++) {
       /* freeLayer((GET_LAYER(map, i))); */
       /* initLayer((GET_LAYER(map, i)), map); */
       /* msCopyLayer(GET_LAYER(map, i), GET_LAYER(map, i+1)); */
-      GET_LAYER(map, i)=GET_LAYER(map, i+1);
+      GET_LAYER(map, i) = GET_LAYER(map, i + 1);
       GET_LAYER(map, i)->index = i;
     }
     /* Free the extra layer at the end */
     /* freeLayer((GET_LAYER(map, map->numlayers-1))); */
-    GET_LAYER(map, map->numlayers-1)=NULL;
+    GET_LAYER(map, map->numlayers - 1) = NULL;
 
     /* Adjust drawing order */
     order_index = 0;
-    for (i=0; i<map->numlayers; i++) {
-      if (map->layerorder[i] > nIndex) map->layerorder[i]--;
+    for (i = 0; i < map->numlayers; i++) {
+      if (map->layerorder[i] > nIndex)
+        map->layerorder[i]--;
       if (map->layerorder[i] == nIndex) {
         order_index = i;
         break;
       }
     }
-    for (i=order_index; i<map->numlayers-1; i++) {
-      map->layerorder[i] = map->layerorder[i+1];
-      if (map->layerorder[i] > nIndex) map->layerorder[i]--;
+    for (i = order_index; i < map->numlayers - 1; i++) {
+      map->layerorder[i] = map->layerorder[i + 1];
+      if (map->layerorder[i] > nIndex)
+        map->layerorder[i]--;
     }
 
     /* decrement number of layers and return copy of removed layer */
     map->numlayers--;
-    layer->map=NULL;
+    layer->map = NULL;
     MS_REFCNT_DECR(layer);
     return layer;
   }
@@ -655,30 +647,27 @@ layerObj *msRemoveLayer(mapObj *map, int
 ** Move the layer's order for drawing purpose. Moving it up here
 ** will have the effect of drawing the layer earlier.
 */
-int msMoveLayerUp(mapObj *map, int nLayerIndex)
-{
+int msMoveLayerUp(mapObj *map, int nLayerIndex) {
   int iCurrentIndex = -1;
-  if (map && nLayerIndex < map->numlayers && nLayerIndex >=0) {
-    for (int i=0; i<map->numlayers; i++) {
-      if ( map->layerorder[i] == nLayerIndex) {
+  if (map && nLayerIndex < map->numlayers && nLayerIndex >= 0) {
+    for (int i = 0; i < map->numlayers; i++) {
+      if (map->layerorder[i] == nLayerIndex) {
         iCurrentIndex = i;
         break;
       }
     }
-    if (iCurrentIndex >=0) {
+    if (iCurrentIndex >= 0) {
       /* we do not need to promote if it is the first one. */
       if (iCurrentIndex == 0)
         return MS_FAILURE;
 
-      map->layerorder[iCurrentIndex] =
-        map->layerorder[iCurrentIndex-1];
-      map->layerorder[iCurrentIndex-1] = nLayerIndex;
+      map->layerorder[iCurrentIndex] = map->layerorder[iCurrentIndex - 1];
+      map->layerorder[iCurrentIndex - 1] = nLayerIndex;
 
       return MS_SUCCESS;
     }
   }
-  msSetError(MS_CHILDERR, "Invalid index: %d", "msMoveLayerUp()",
-             nLayerIndex);
+  msSetError(MS_CHILDERR, "Invalid index: %d", "msMoveLayerUp()", nLayerIndex);
   return MS_FAILURE;
 }
 
@@ -686,24 +675,22 @@ int msMoveLayerUp(mapObj *map, int nLaye
 ** Move the layer's order for drawing purpose. Moving it down here
 ** will have the effect of drawing the layer later.
 */
-int msMoveLayerDown(mapObj *map, int nLayerIndex)
-{
+int msMoveLayerDown(mapObj *map, int nLayerIndex) {
   int iCurrentIndex = -1;
-  if (map && nLayerIndex < map->numlayers && nLayerIndex >=0) {
-    for (int i=0; i<map->numlayers; i++) {
-      if ( map->layerorder[i] == nLayerIndex) {
+  if (map && nLayerIndex < map->numlayers && nLayerIndex >= 0) {
+    for (int i = 0; i < map->numlayers; i++) {
+      if (map->layerorder[i] == nLayerIndex) {
         iCurrentIndex = i;
         break;
       }
     }
-    if (iCurrentIndex >=0) {
+    if (iCurrentIndex >= 0) {
       /* we do not need to demote if it is the last one. */
-      if (iCurrentIndex == map->numlayers-1)
+      if (iCurrentIndex == map->numlayers - 1)
         return MS_FAILURE;
 
-      map->layerorder[iCurrentIndex] =
-        map->layerorder[iCurrentIndex+1];
-      map->layerorder[iCurrentIndex+1] = nLayerIndex;
+      map->layerorder[iCurrentIndex] = map->layerorder[iCurrentIndex + 1];
+      map->layerorder[iCurrentIndex + 1] = nLayerIndex;
 
       return MS_SUCCESS;
     }
@@ -713,7 +700,6 @@ int msMoveLayerDown(mapObj *map, int nLa
   return MS_FAILURE;
 }
 
-
 /*
 ** Set the array used for the drawing order. The array passed must contain
 ** all the layer's index ordered by the drawing priority.
@@ -728,13 +714,12 @@ int msMoveLayerDown(mapObj *map, int nLa
 **        of elements as the number of layers in the map.
 ** Return TRUE on success else FALSE.
 */
-int msSetLayersdrawingOrder(mapObj *self, int *panIndexes)
-{
+int msSetLayersdrawingOrder(mapObj *self, int *panIndexes) {
   if (self && panIndexes) {
     const int nElements = self->numlayers;
-    for (int i=0; i<nElements; i++) {
+    for (int i = 0; i < nElements; i++) {
       int bFound = 0;
-      for (int j=0; j<nElements; j++) {
+      for (int j = 0; j < nElements; j++) {
         if (panIndexes[j] == i) {
           bFound = 1;
           break;
@@ -746,7 +731,7 @@ int msSetLayersdrawingOrder(mapObj *self
     /* -------------------------------------------------------------------- */
     /*    At this point the array is valid so update the layers order array.*/
     /* -------------------------------------------------------------------- */
-    for (int i=0; i<nElements; i++) {
+    for (int i = 0; i < nElements; i++) {
       self->layerorder[i] = panIndexes[i];
     }
     return 1;
@@ -754,7 +739,6 @@ int msSetLayersdrawingOrder(mapObj *self
   return 0;
 }
 
-
 /* =========================================================================
    msMapLoadOWSParameters
 
@@ -762,32 +746,29 @@ int msSetLayersdrawingOrder(mapObj *self
    ========================================================================= */
 
 int msMapLoadOWSParameters(mapObj *map, cgiRequestObj *request,
-                           const char *wmtver)
-{
+                           const char *wmtver) {
 #ifdef USE_WMS_SVR
   int version;
   char *wms_exception_format = NULL;
-  const char *wms_request= NULL;
+  const char *wms_request = NULL;
   int result, i = 0;
   owsRequestObj ows_request;
 
   msOWSInitRequestObj(&ows_request);
 
-
   version = msOWSParseVersionString(wmtver);
-  for(i=0; i<request->NumParams; i++) {
+  for (i = 0; i < request->NumParams; i++) {
     if (strcasecmp(request->ParamNames[i], "EXCEPTIONS") == 0)
       wms_exception_format = request->ParamValues[i];
     else if (strcasecmp(request->ParamNames[i], "REQUEST") == 0)
       wms_request = request->ParamValues[i];
-
   }
 
   msOWSRequestLayersEnabled(map, "M", wms_request, &ows_request);
 
-  result = msWMSLoadGetMapParams(map, version, request->ParamNames,
-                                 request->ParamValues, request->NumParams,  wms_exception_format,
-                                 wms_request, &ows_request);
+  result = msWMSLoadGetMapParams(
+      map, version, request->ParamNames, request->ParamValues,
+      request->NumParams, wms_exception_format, wms_request, &ows_request);
 
   msOWSClearRequestObj(&ows_request);
 
@@ -799,4 +780,3 @@ int msMapLoadOWSParameters(mapObj *map,
   return MS_FAILURE;
 #endif
 }
-
diff -pruN 8.0.1-5/mapogcapi.cpp 8.0.2-1/mapogcapi.cpp
--- 8.0.1-5/mapogcapi.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapogcapi.cpp	2024-06-11 20:41:34.000000000 +0000
@@ -6,7 +6,7 @@
  * Author:   Steve Lime and the MapServer team.
  *
  **********************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota. 
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
  *
  * Permission is hereby granted, free of charge, to any person obtaining a
  * copy of this software and associated documentation files (the "Software"),
@@ -55,17 +55,12 @@ using json = nlohmann::json;
 #define OGCAPI_TEMPLATE_HTML_COLLECTION_ITEM "collection-item.html"
 #define OGCAPI_TEMPLATE_HTML_OPENAPI "openapi.html"
 
-enum class OGCAPIFormat
-{
-    JSON,
-    GeoJSON,
-    OpenAPI_V3,
-    HTML
-};
+enum class OGCAPIFormat { JSON, GeoJSON, OpenAPI_V3, HTML };
 
 #define OGCAPI_MIMETYPE_JSON "application/json"
 #define OGCAPI_MIMETYPE_GEOJSON "application/geo+json"
-#define OGCAPI_MIMETYPE_OPENAPI_V3 "application/vnd.oai.openapi+json;version=3.0"
+#define OGCAPI_MIMETYPE_OPENAPI_V3                                             \
+  "application/vnd.oai.openapi+json;version=3.0"
 #define OGCAPI_MIMETYPE_HTML "text/html"
 
 #define OGCAPI_DEFAULT_LIMIT 10 // by specification
@@ -84,21 +79,16 @@ enum class OGCAPIFormat
 /*
 ** Returns a JSON object using and a description.
 */
-static void outputError(int code, const std::string& description)
-{
-  if(code < 0 || code >= OGCAPI_NUM_ERROR_CODES) code = 0;
-
-  json error_codes = {
-    { {"text", "ServerError"}, {"status", "500"} },
-    { {"text", "ConfigError"}, {"status", "500"} },
-    { {"text", "InvalidParamterValue"}, {"status", "400"} },
-    { {"text", "NotFound"}, {"status", "404"} }
-  };
+static void outputError(int code, const std::string &description) {
+  if (code < 0 || code >= OGCAPI_NUM_ERROR_CODES)
+    code = 0;
+
+  json error_codes = {{{"text", "ServerError"}, {"status", "500"}},
+                      {{"text", "ConfigError"}, {"status", "500"}},
+                      {{"text", "InvalidParamterValue"}, {"status", "400"}},
+                      {{"text", "NotFound"}, {"status", "404"}}};
 
-  json j = {
-    { "code", error_codes[code]["text"] },
-    { "description", description }
-  };
+  json j = {{"code", error_codes[code]["text"]}, {"description", description}};
 
   std::string status = error_codes[code]["status"];
 
@@ -109,9 +99,8 @@ static void outputError(int code, const
 }
 
 static int includeLayer(mapObj *map, layerObj *layer) {
-  if(!msOWSRequestIsEnabled(map, layer, "AO", "OGCAPI", MS_FALSE) || 
-     !msWFSIsLayerSupported(layer) || 
-     !msIsLayerQueryable(layer)) {
+  if (!msOWSRequestIsEnabled(map, layer, "AO", "OGCAPI", MS_FALSE) ||
+      !msWFSIsLayerSupported(layer) || !msIsLayerQueryable(layer)) {
     return MS_FALSE;
   } else {
     return MS_TRUE;
@@ -123,58 +112,63 @@ static int includeLayer(mapObj *map, lay
 */
 
 /*
-** Returns the value associated with an item from the request's query string and NULL if the item was not found.
+** Returns the value associated with an item from the request's query string and
+*NULL if the item was not found.
 */
-static const char *getRequestParameter(cgiRequestObj *request, const char *item)
-{
+static const char *getRequestParameter(cgiRequestObj *request,
+                                       const char *item) {
   int i;
 
-  for(i=0; i<request->NumParams; i++) {
-    if(strcmp(item, request->ParamNames[i]) == 0)
+  for (i = 0; i < request->NumParams; i++) {
+    if (strcmp(item, request->ParamNames[i]) == 0)
       return request->ParamValues[i];
   }
 
   return NULL;
 }
 
-static int getMaxLimit(mapObj *map, layerObj *layer)
-{
+static int getMaxLimit(mapObj *map, layerObj *layer) {
   int max_limit = OGCAPI_MAX_LIMIT;
-  const char *value;  
+  const char *value;
 
   // check metadata, layer then map
   value = msOWSLookupMetadata(&(layer->metadata), "A", "max_limit");
-  if(value == NULL) value = msOWSLookupMetadata(&(map->web.metadata), "A", "max_limit");
+  if (value == NULL)
+    value = msOWSLookupMetadata(&(map->web.metadata), "A", "max_limit");
 
-  if(value != NULL) {
+  if (value != NULL) {
     int status = msStringToInt(value, &max_limit, 10);
-    if(status != MS_SUCCESS) max_limit = OGCAPI_MAX_LIMIT; // conversion failed
+    if (status != MS_SUCCESS)
+      max_limit = OGCAPI_MAX_LIMIT; // conversion failed
   }
 
   return max_limit;
 }
 
-static int getDefaultLimit(mapObj *map, layerObj *layer)
-{
+static int getDefaultLimit(mapObj *map, layerObj *layer) {
   int default_limit = OGCAPI_DEFAULT_LIMIT;
 
   // check metadata, layer then map
-  const char* value = msOWSLookupMetadata(&(layer->metadata), "A", "default_limit");
-  if(value == NULL) value = msOWSLookupMetadata(&(map->web.metadata), "A", "default_limit");
+  const char *value =
+      msOWSLookupMetadata(&(layer->metadata), "A", "default_limit");
+  if (value == NULL)
+    value = msOWSLookupMetadata(&(map->web.metadata), "A", "default_limit");
 
-  if(value != NULL) {
+  if (value != NULL) {
     int status = msStringToInt(value, &default_limit, 10);
-    if(status != MS_SUCCESS) default_limit = OGCAPI_DEFAULT_LIMIT; // conversion failed
+    if (status != MS_SUCCESS)
+      default_limit = OGCAPI_DEFAULT_LIMIT; // conversion failed
   }
 
   return default_limit;
 }
 
 /*
-** Returns the limit as an int - between 1 and getMaxLimit(). We always return a valid value...
+** Returns the limit as an int - between 1 and getMaxLimit(). We always return a
+*valid value...
 */
-static int getLimit(mapObj *map, cgiRequestObj *request, layerObj *layer, int *limit)
-{
+static int getLimit(mapObj *map, cgiRequestObj *request, layerObj *layer,
+                    int *limit) {
   int status;
   const char *p;
 
@@ -182,15 +176,17 @@ static int getLimit(mapObj *map, cgiRequ
   max_limit = getMaxLimit(map, layer);
 
   p = getRequestParameter(request, "limit");
-  if(!p || (p && strlen(p) == 0)) { // missing or empty
-    *limit = MS_MIN(getDefaultLimit(map, layer), max_limit); // max could be smaller than the default
+  if (!p || (p && strlen(p) == 0)) { // missing or empty
+    *limit = MS_MIN(getDefaultLimit(map, layer),
+                    max_limit); // max could be smaller than the default
   } else {
     status = msStringToInt(p, limit, 10);
-    if(status != MS_SUCCESS)
+    if (status != MS_SUCCESS)
       return MS_FAILURE;
 
-    if(*limit <= 0) {
-      *limit = MS_MIN(getDefaultLimit(map, layer), max_limit); // max could be smaller than the default
+    if (*limit <= 0) {
+      *limit = MS_MIN(getDefaultLimit(map, layer),
+                      max_limit); // max could be smaller than the default
     } else {
       *limit = MS_MIN(*limit, max_limit);
     }
@@ -202,27 +198,27 @@ static int getLimit(mapObj *map, cgiRequ
 /*
 ** Returns the bbox in SRS of the map.
 */
-static bool getBbox(mapObj *map, cgiRequestObj *request, rectObj *bbox)
-{
+static bool getBbox(mapObj *map, cgiRequestObj *request, rectObj *bbox) {
   int status;
   const char *p;
 
   p = getRequestParameter(request, "bbox");
-  if(!p || (p && strlen(p) == 0)) { // missing or empty - assign map->extent (no projection necessary)
+  if (!p || (p && strlen(p) == 0)) { // missing or empty - assign map->extent
+                                     // (no projection necessary)
     bbox->minx = map->extent.minx;
     bbox->miny = map->extent.miny;
     bbox->maxx = map->extent.maxx;
     bbox->maxy = map->extent.maxy;
   } else {
     const auto tokens = msStringSplit(p, ',');
-    if(tokens.size() != 4) {
+    if (tokens.size() != 4) {
       return false;
     }
 
     double values[4];
-    for(int i=0; i<4; i++) {
+    for (int i = 0; i < 4; i++) {
       status = msStringToDouble(tokens[i].c_str(), &values[i]);
-      if(status != MS_SUCCESS) {
+      if (status != MS_SUCCESS) {
         return false;
       }
     }
@@ -233,11 +229,13 @@ static bool getBbox(mapObj *map, cgiRequ
     bbox->maxy = values[3];
 
     // validate bbox is well-formed (degenerate is ok)
-    if(MS_VALID_SEARCH_EXTENT(*bbox) != MS_TRUE) return false;
+    if (MS_VALID_SEARCH_EXTENT(*bbox) != MS_TRUE)
+      return false;
 
     // at the moment we are assuming the bbox is given in lat/lon
     status = msProjectRect(&map->latlon, &map->projection, bbox);
-    if(status != MS_SUCCESS) return false;
+    if (status != MS_SUCCESS)
+      return false;
   }
 
   return true;
@@ -246,28 +244,30 @@ static bool getBbox(mapObj *map, cgiRequ
 /*
 ** Returns the template directory location or NULL if it isn't set.
 */
-static const char *getTemplateDirectory(mapObj *map, const char *key, const char *envvar)
-{
+static const char *getTemplateDirectory(mapObj *map, const char *key,
+                                        const char *envvar) {
   const char *directory;
 
-  // TODO: if directory is provided then perhaps we need to check for a trailing slash
+  // TODO: if directory is provided then perhaps we need to check for a trailing
+  // slash
 
-  if((directory = msOWSLookupMetadata(&(map->web.metadata), "A", key)) != NULL) 
+  if ((directory = msOWSLookupMetadata(&(map->web.metadata), "A", key)) != NULL)
     return directory;
-  else if((directory = CPLGetConfigOption(envvar, NULL)) != NULL)
+  else if ((directory = CPLGetConfigOption(envvar, NULL)) != NULL)
     return directory;
   else
     return NULL;
 }
 
 /*
-** Returns the service title from oga_{key} and/or ows_{key} or a default value if not set.
+** Returns the service title from oga_{key} and/or ows_{key} or a default value
+*if not set.
 */
-static const char *getWebMetadata(mapObj *map, const char* domain, const char* key, const char* defaultVal)
-{
+static const char *getWebMetadata(mapObj *map, const char *domain,
+                                  const char *key, const char *defaultVal) {
   const char *value;
 
-  if((value = msOWSLookupMetadata(&(map->web.metadata), domain, key)) != NULL)
+  if ((value = msOWSLookupMetadata(&(map->web.metadata), domain, key)) != NULL)
     return value;
   else
     return defaultVal;
@@ -276,107 +276,94 @@ static const char *getWebMetadata(mapObj
 /*
 ** Returns the service title from oga|ows_title or a default value if not set.
 */
-static const char *getTitle(mapObj *map)
-{
+static const char *getTitle(mapObj *map) {
   return getWebMetadata(map, "OA", "title", OGCAPI_DEFAULT_TITLE);
 }
 
 /*
-** Returns the API root URL from oga_onlineresource or builds a value if not set.
+** Returns the API root URL from oga_onlineresource or builds a value if not
+*set.
 */
-static std::string getApiRootUrl(mapObj *map)
-{
+static std::string getApiRootUrl(mapObj *map) {
   const char *root;
 
-  if((root = msOWSLookupMetadata(&(map->web.metadata), "A", "onlineresource")) != NULL)
+  if ((root = msOWSLookupMetadata(&(map->web.metadata), "A",
+                                  "onlineresource")) != NULL)
     return std::string(root);
   else
-    return "http://" + std::string(getenv("SERVER_NAME")) + ":" + std::string(getenv("SERVER_PORT")) + std::string(getenv("SCRIPT_NAME")) + std::string(getenv("PATH_INFO"));
+    return "http://" + std::string(getenv("SERVER_NAME")) + ":" +
+           std::string(getenv("SERVER_PORT")) +
+           std::string(getenv("SCRIPT_NAME")) +
+           std::string(getenv("PATH_INFO"));
 }
 
-static json getFeatureConstant(const gmlConstantObj *constant)
-{
+static json getFeatureConstant(const gmlConstantObj *constant) {
   json j; // empty (null)
 
-  if(!constant) throw std::runtime_error("Null constant metadata.");
-  if(!constant->value) return j;
-  
+  if (!constant)
+    throw std::runtime_error("Null constant metadata.");
+  if (!constant->value)
+    return j;
+
   // initialize
-  j = { { constant->name, constant->value } };  
+  j = {{constant->name, constant->value}};
 
   return j;
 }
 
-static json getFeatureItem(const gmlItemObj *item, const char *value)
-{
+static json getFeatureItem(const gmlItemObj *item, const char *value) {
   json j; // empty (null)
   const char *key;
 
-  if(!item) throw std::runtime_error("Null item metadata.");
-  if(!item->visible) return j;
+  if (!item)
+    throw std::runtime_error("Null item metadata.");
+  if (!item->visible)
+    return j;
 
-  if(item->alias)
+  if (item->alias)
     key = item->alias;
   else
     key = item->name;
 
   // initialize
-  j = { { key, value } };
-
-  if( item->type && (EQUAL(item->type, "Date") ||
-                     EQUAL(item->type, "DateTime") ||
-                     EQUAL(item->type, "Time")) ) {
-      struct tm tm;
-      if( msParseTime(value, &tm) == MS_TRUE ) {
-          char tmpValue[64];
-          if( EQUAL(item->type, "Date") )
-              snprintf(tmpValue, sizeof(tmpValue),
-                       "%04d-%02d-%02d",
-                       tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday);
-          else if( EQUAL(item->type, "Time") )
-              snprintf(tmpValue, sizeof(tmpValue),
-                       "%02d:%02d:%02dZ",
-                       tm.tm_hour, tm.tm_min, tm.tm_sec);
-          else
-              snprintf(tmpValue, sizeof(tmpValue),
-                       "%04d-%02d-%02dT%02d:%02d:%02dZ",
-                       tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday,
-                       tm.tm_hour, tm.tm_min, tm.tm_sec);
+  j = {{key, value}};
 
-          j = { { key, tmpValue } };
-      }
-  }
-  else if( item->type && (EQUAL(item->type, "Integer") ||
-                          EQUAL(item->type, "Long")) )
-  {
-      try
-      {
-          j = { { key, std::stoll(value) } };
-      }
-      catch( const std::exception& )
-      {
-      }
-  }
-  else if( item->type && EQUAL(item->type, "Real"))
-  {
-      try
-      {
-          j = { { key, std::stod(value) } };
-      }
-      catch( const std::exception& )
-      {
-      }
-  }
-  else if( item->type && EQUAL(item->type, "Boolean"))
-  {
-      if( EQUAL(value,"0") || EQUAL(value,"false") )
-      {
-          j = { { key, false } };
-      }
+  if (item->type &&
+      (EQUAL(item->type, "Date") || EQUAL(item->type, "DateTime") ||
+       EQUAL(item->type, "Time"))) {
+    struct tm tm;
+    if (msParseTime(value, &tm) == MS_TRUE) {
+      char tmpValue[64];
+      if (EQUAL(item->type, "Date"))
+        snprintf(tmpValue, sizeof(tmpValue), "%04d-%02d-%02d",
+                 tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday);
+      else if (EQUAL(item->type, "Time"))
+        snprintf(tmpValue, sizeof(tmpValue), "%02d:%02d:%02dZ", tm.tm_hour,
+                 tm.tm_min, tm.tm_sec);
       else
-      {
-          j = { { key, true } };
-      }
+        snprintf(tmpValue, sizeof(tmpValue), "%04d-%02d-%02dT%02d:%02d:%02dZ",
+                 tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday, tm.tm_hour,
+                 tm.tm_min, tm.tm_sec);
+
+      j = {{key, tmpValue}};
+    }
+  } else if (item->type &&
+             (EQUAL(item->type, "Integer") || EQUAL(item->type, "Long"))) {
+    try {
+      j = {{key, std::stoll(value)}};
+    } catch (const std::exception &) {
+    }
+  } else if (item->type && EQUAL(item->type, "Real")) {
+    try {
+      j = {{key, std::stod(value)}};
+    } catch (const std::exception &) {
+    }
+  } else if (item->type && EQUAL(item->type, "Boolean")) {
+    if (EQUAL(value, "0") || EQUAL(value, "false")) {
+      j = {{key, false}};
+    } else {
+      j = {{key, true}};
+    }
   }
 
   return j;
@@ -392,69 +379,82 @@ static double round_up(double value, int
   return std::ceil(value * multiplier) / multiplier;
 }
 
-static json getFeatureGeometry(shapeObj *shape, int precision)
-{
+static json getFeatureGeometry(shapeObj *shape, int precision) {
   json geometry; // empty (null)
-  int *outerList=NULL, numOuterRings=0;
+  int *outerList = NULL, numOuterRings = 0;
 
-  if(!shape) throw std::runtime_error("Null shape.");
+  if (!shape)
+    throw std::runtime_error("Null shape.");
 
-  switch(shape->type) {
-  case(MS_SHAPE_POINT):
-    if(shape->numlines == 0 || shape->line[0].numpoints == 0) // not enough info for a point
+  switch (shape->type) {
+  case (MS_SHAPE_POINT):
+    if (shape->numlines == 0 ||
+        shape->line[0].numpoints == 0) // not enough info for a point
       return geometry;
 
-    if(shape->line[0].numpoints == 1) {
+    if (shape->line[0].numpoints == 1) {
       geometry["type"] = "Point";
-      geometry["coordinates"] = { round_up(shape->line[0].point[0].x, precision), round_up(shape->line[0].point[0].y, precision) };
+      geometry["coordinates"] = {
+          round_up(shape->line[0].point[0].x, precision),
+          round_up(shape->line[0].point[0].y, precision)};
     } else {
       geometry["type"] = "MultiPoint";
       geometry["coordinates"] = json::array();
-      for(int j=0; j<shape->line[0].numpoints; j++) {
-        geometry["coordinates"].push_back( { round_up(shape->line[0].point[j].x, precision), round_up(shape->line[0].point[j].y, precision) } );
+      for (int j = 0; j < shape->line[0].numpoints; j++) {
+        geometry["coordinates"].push_back(
+            {round_up(shape->line[0].point[j].x, precision),
+             round_up(shape->line[0].point[j].y, precision)});
       }
     }
     break;
-  case(MS_SHAPE_LINE):
-    if(shape->numlines == 0 || shape->line[0].numpoints < 2) // not enough info for a line
+  case (MS_SHAPE_LINE):
+    if (shape->numlines == 0 ||
+        shape->line[0].numpoints < 2) // not enough info for a line
       return geometry;
 
-    if(shape->numlines == 1) {
+    if (shape->numlines == 1) {
       geometry["type"] = "LineString";
       geometry["coordinates"] = json::array();
-      for(int j=0; j<shape->line[0].numpoints; j++) {
-	geometry["coordinates"].push_back( { round_up(shape->line[0].point[j].x, precision), round_up(shape->line[0].point[j].y, precision) } );
+      for (int j = 0; j < shape->line[0].numpoints; j++) {
+        geometry["coordinates"].push_back(
+            {round_up(shape->line[0].point[j].x, precision),
+             round_up(shape->line[0].point[j].y, precision)});
       }
     } else {
       geometry["type"] = "MultiLineString";
       geometry["coordinates"] = json::array();
-      for(int i=0; i<shape->numlines; i++) {
+      for (int i = 0; i < shape->numlines; i++) {
         json part = json::array();
-        for(int j=0; j<shape->line[i].numpoints; j++) {
-          part.push_back( { round_up(shape->line[i].point[j].x, precision), round_up(shape->line[i].point[j].y, precision) } );
+        for (int j = 0; j < shape->line[i].numpoints; j++) {
+          part.push_back({round_up(shape->line[i].point[j].x, precision),
+                          round_up(shape->line[i].point[j].y, precision)});
         }
         geometry["coordinates"].push_back(part);
       }
     }
     break;
-  case(MS_SHAPE_POLYGON):
-    if(shape->numlines == 0 || shape->line[0].numpoints < 4) // not enough info for a polygon (first=last)
+  case (MS_SHAPE_POLYGON):
+    if (shape->numlines == 0 ||
+        shape->line[0].numpoints <
+            4) // not enough info for a polygon (first=last)
       return geometry;
 
     outerList = msGetOuterList(shape);
-    if(outerList == NULL) throw std::runtime_error("Unable to allocate list of outer rings.");
-    for(int k=0; k<shape->numlines; k++) {
-      if(outerList[k] == MS_TRUE)
-	numOuterRings++;
+    if (outerList == NULL)
+      throw std::runtime_error("Unable to allocate list of outer rings.");
+    for (int k = 0; k < shape->numlines; k++) {
+      if (outerList[k] == MS_TRUE)
+        numOuterRings++;
     }
 
-    if(numOuterRings == 1) {
+    if (numOuterRings == 1) {
       geometry["type"] = "Polygon";
       geometry["coordinates"] = json::array();
-      for(int i=0; i<shape->numlines; i++) {
+      for (int i = 0; i < shape->numlines; i++) {
         json part = json::array();
-        for(int j=0; j<shape->line[i].numpoints; j++) {
-          part.push_back( { round_up(shape->line[i].point[j].x, precision), round_up(shape->line[i].point[j].y, precision) } );
+        for (int j = 0; j < shape->line[i].numpoints; j++) {
+          part.push_back({round_up(shape->line[i].point[j].x, precision),
+                          round_up(shape->line[i].point[j].y, precision)});
         }
         geometry["coordinates"].push_back(part);
       }
@@ -462,20 +462,25 @@ static json getFeatureGeometry(shapeObj
       geometry["type"] = "MultiPolygon";
       geometry["coordinates"] = json::array();
 
-      for(int k=0; k<shape->numlines; k++) {
-        if(outerList[k] == MS_TRUE) { // outer ring: generate polygon and add to coordinates
+      for (int k = 0; k < shape->numlines; k++) {
+        if (outerList[k] ==
+            MS_TRUE) { // outer ring: generate polygon and add to coordinates
           int *innerList = msGetInnerList(shape, k, outerList);
-          if(innerList == NULL) {
+          if (innerList == NULL) {
             msFree(outerList);
             throw std::runtime_error("Unable to allocate list of inner rings.");
           }
 
           json polygon = json::array();
-          for(int i=0; i<shape->numlines; i++) {
-            if(i == k || outerList[i] == MS_TRUE) { // add outer ring (k) and any inner rings
+          for (int i = 0; i < shape->numlines; i++) {
+            if (i == k ||
+                outerList[i] ==
+                    MS_TRUE) { // add outer ring (k) and any inner rings
               json part = json::array();
-              for(int j=0; j<shape->line[i].numpoints; j++) {
-                part.push_back( { round_up(shape->line[i].point[j].x, precision), round_up(shape->line[i].point[j].y, precision) } );
+              for (int j = 0; j < shape->line[i].numpoints; j++) {
+                part.push_back(
+                    {round_up(shape->line[i].point[j].x, precision),
+                     round_up(shape->line[i].point[j].y, precision)});
               }
               polygon.push_back(part);
             }
@@ -499,55 +504,61 @@ static json getFeatureGeometry(shapeObj
 /*
 ** Return a GeoJSON representation of a shape.
 */
-static json getFeature(layerObj *layer, shapeObj *shape, gmlItemListObj *items, gmlConstantListObj *constants, int geometry_precision)
-{
+static json getFeature(layerObj *layer, shapeObj *shape, gmlItemListObj *items,
+                       gmlConstantListObj *constants, int geometry_precision) {
   int i;
   json feature; // empty (null)
 
-  if(!layer || !shape) throw std::runtime_error("Null arguments.");
+  if (!layer || !shape)
+    throw std::runtime_error("Null arguments.");
 
   // initialize
-  feature = {
-    { "type", "Feature" },
-    { "properties", json::object() }
-  };
+  feature = {{"type", "Feature"}, {"properties", json::object()}};
 
   // id
-  const char *featureIdItem = msOWSLookupMetadata(&(layer->metadata), "AGFO", "featureid");
-  if(featureIdItem == NULL) throw std::runtime_error("Missing required featureid metadata."); // should have been trapped earlier
-  for(i=0; i<items->numitems; i++) {
-    if(strcasecmp(featureIdItem, items->items[i].name) == 0) {
+  const char *featureIdItem =
+      msOWSLookupMetadata(&(layer->metadata), "AGFO", "featureid");
+  if (featureIdItem == NULL)
+    throw std::runtime_error(
+        "Missing required featureid metadata."); // should have been trapped
+                                                 // earlier
+  for (i = 0; i < items->numitems; i++) {
+    if (strcasecmp(featureIdItem, items->items[i].name) == 0) {
       feature["id"] = shape->values[i];
       break;
     }
   }
 
-  if(i == items->numitems) throw std::runtime_error("Feature id not found.");
+  if (i == items->numitems)
+    throw std::runtime_error("Feature id not found.");
 
   // properties - build from items and constants, no group support for now
 
-  for(int i=0; i<items->numitems; i++) {    
+  for (int i = 0; i < items->numitems; i++) {
     try {
       json item = getFeatureItem(&(items->items[i]), shape->values[i]);
-      if(!item.is_null()) feature["properties"].insert(item.begin(), item.end());
+      if (!item.is_null())
+        feature["properties"].insert(item.begin(), item.end());
     } catch (const std::runtime_error &) {
       throw std::runtime_error("Error fetching item.");
     }
   }
 
-  for(int i=0; i<constants->numconstants; i++) {
+  for (int i = 0; i < constants->numconstants; i++) {
     try {
       json constant = getFeatureConstant(&(constants->constants[i]));
-      if(!constant.is_null()) feature["properties"].insert(constant.begin(), constant.end());
+      if (!constant.is_null())
+        feature["properties"].insert(constant.begin(), constant.end());
     } catch (const std::runtime_error &) {
-      throw std::runtime_error("Error fetching constant.");  
+      throw std::runtime_error("Error fetching constant.");
     }
   }
 
   // geometry
   try {
     json geometry = getFeatureGeometry(shape, geometry_precision);
-    if(!geometry.is_null()) feature["geometry"] = geometry;
+    if (!geometry.is_null())
+      feature["geometry"] = geometry;
   } catch (const std::runtime_error &) {
     throw std::runtime_error("Error fetching geometry.");
   }
@@ -555,72 +566,85 @@ static json getFeature(layerObj *layer,
   return feature;
 }
 
-static json getLink(hashTableObj *metadata, const std::string& name)
-{
+static json getLink(hashTableObj *metadata, const std::string &name) {
   json link;
 
-  const char *href = msOWSLookupMetadata(metadata, "A", (name + "_href").c_str());
-  if(!href) throw std::runtime_error("Missing required link href property.");
-
-  const char *title = msOWSLookupMetadata(metadata, "A", (name + "_title").c_str());
-  const char *type = msOWSLookupMetadata(metadata, "A", (name + "_type").c_str());
-
-  link = {
-    { "href", href },
-    { "title", title?title:href },
-    { "type", type?type:"text/html" }
-  };
+  const char *href =
+      msOWSLookupMetadata(metadata, "A", (name + "_href").c_str());
+  if (!href)
+    throw std::runtime_error("Missing required link href property.");
+
+  const char *title =
+      msOWSLookupMetadata(metadata, "A", (name + "_title").c_str());
+  const char *type =
+      msOWSLookupMetadata(metadata, "A", (name + "_type").c_str());
+
+  link = {{"href", href},
+          {"title", title ? title : href},
+          {"type", type ? type : "text/html"}};
 
   return link;
 }
 
-static const char* getCollectionDescription(layerObj* layer)
-{
-  const char *description = msOWSLookupMetadata(&(layer->metadata), "A", "description");
-  if(!description) description = msOWSLookupMetadata(&(layer->metadata), "OF", "abstract"); // fallback on abstract
-  if(!description) description = "<!-- Warning: unable to set the collection description. -->"; // finally a warning...
+static const char *getCollectionDescription(layerObj *layer) {
+  const char *description =
+      msOWSLookupMetadata(&(layer->metadata), "A", "description");
+  if (!description)
+    description = msOWSLookupMetadata(&(layer->metadata), "OF",
+                                      "abstract"); // fallback on abstract
+  if (!description)
+    description =
+        "<!-- Warning: unable to set the collection description. -->"; // finally
+                                                                       // a
+                                                                       // warning...
   return description;
 }
 
-static const char* getCollectionTitle(layerObj* layer)
-{
-    const char* title = msOWSLookupMetadata(&(layer->metadata), "AOF", "title");
-    if(!title) title = layer->name; // revert to layer name if no title found
-    return title;
-}
-
-static int getGeometryPrecision(mapObj *map, layerObj *layer)
-{
-    int geometry_precision = OGCAPI_DEFAULT_GEOMETRY_PRECISION;
-    if(msOWSLookupMetadata(&(layer->metadata), "AF", "geometry_precision")) {
-      geometry_precision = atoi(msOWSLookupMetadata(&(layer->metadata), "AF", "geometry_precision"));
-    } else if(msOWSLookupMetadata(&map->web.metadata, "AF", "geometry_precision")) {
-      geometry_precision = atoi(msOWSLookupMetadata(&map->web.metadata, "AF", "geometry_precision"));
-    }
-    return geometry_precision;
+static const char *getCollectionTitle(layerObj *layer) {
+  const char *title = msOWSLookupMetadata(&(layer->metadata), "AOF", "title");
+  if (!title)
+    title = layer->name; // revert to layer name if no title found
+  return title;
+}
+
+static int getGeometryPrecision(mapObj *map, layerObj *layer) {
+  int geometry_precision = OGCAPI_DEFAULT_GEOMETRY_PRECISION;
+  if (msOWSLookupMetadata(&(layer->metadata), "AF", "geometry_precision")) {
+    geometry_precision = atoi(
+        msOWSLookupMetadata(&(layer->metadata), "AF", "geometry_precision"));
+  } else if (msOWSLookupMetadata(&map->web.metadata, "AF",
+                                 "geometry_precision")) {
+    geometry_precision = atoi(
+        msOWSLookupMetadata(&map->web.metadata, "AF", "geometry_precision"));
+  }
+  return geometry_precision;
 }
 
-static json getCollection(mapObj *map, layerObj *layer, OGCAPIFormat format)
-{
+static json getCollection(mapObj *map, layerObj *layer, OGCAPIFormat format) {
   json collection; // empty (null)
   rectObj bbox;
 
-  if(!map || !layer) return collection;
+  if (!map || !layer)
+    return collection;
 
-  if(!includeLayer(map, layer)) return collection;
+  if (!includeLayer(map, layer))
+    return collection;
 
   // initialize some things
   std::string api_root = getApiRootUrl(map);
 
-  if(msOWSGetLayerExtent(map, layer, "AOF", &bbox) == MS_SUCCESS) {
+  if (msOWSGetLayerExtent(map, layer, "AOF", &bbox) == MS_SUCCESS) {
     if (layer->projection.numargs > 0)
       msOWSProjectToWGS84(&layer->projection, &bbox);
     else if (map->projection.numargs > 0)
       msOWSProjectToWGS84(&map->projection, &bbox);
     else
-      throw std::runtime_error("Unable to transform bounding box, no projection defined.");
+      throw std::runtime_error(
+          "Unable to transform bounding box, no projection defined.");
   } else {
-    throw std::runtime_error("Unable to get collection bounding box."); // might be too harsh since extent is optional
+    throw std::runtime_error(
+        "Unable to get collection bounding box."); // might be too harsh since
+                                                   // extent is optional
   }
 
   const char *description = getCollectionDescription(layer);
@@ -632,69 +656,64 @@ static json getCollection(mapObj *map, l
   const int geometry_precision = getGeometryPrecision(map, layer);
 
   // build collection object
-  collection = {
-    { "id", id },
-    { "description", description },
-    { "title", title },
-    { "extent", {
-        { "spatial", {
-            { "bbox", {{ round_down(bbox.minx, geometry_precision),
-                         round_down(bbox.miny, geometry_precision),
-                         round_up(bbox.maxx, geometry_precision),
-                         round_up(bbox.maxy, geometry_precision) }}},
-            { "crs", "http://www.opengis.net/def/crs/OGC/1.3/CRS84" }
-          }
-        }
-      }
-    },
-    { "links", {
-        {
-          { "rel", format==OGCAPIFormat::JSON?"self":"alternate" },
-          { "type", OGCAPI_MIMETYPE_JSON },
-          { "title", "This collection as JSON" },
-          { "href", api_root + "/collections/" + std::string(id_encoded) + "?f=json" }
-        },{
-          { "rel", format==OGCAPIFormat::HTML?"self":"alternate" },
-          { "type", OGCAPI_MIMETYPE_HTML },
-          { "title", "This collection as HTML" },
-          { "href", api_root + "/collections/" + std::string(id_encoded) + "?f=html" }
-        },{
-          { "rel", "items" },
-          { "type", OGCAPI_MIMETYPE_GEOJSON },
-          { "title", "Items for this collection as GeoJSON" },
-          { "href", api_root + "/collections/" + std::string(id_encoded) + "/items?f=json" }
-        },{
-          { "rel", "items" },
-          { "type", OGCAPI_MIMETYPE_HTML },
-          { "title", "Items for this collection as HTML" },
-          { "href", api_root + "/collections/" + std::string(id_encoded) + "/items?f=html" }
-        }
+  collection = {{"id", id},
+                {"description", description},
+                {"title", title},
+                {"extent",
+                 {{"spatial",
+                   {{"bbox",
+                     {{round_down(bbox.minx, geometry_precision),
+                       round_down(bbox.miny, geometry_precision),
+                       round_up(bbox.maxx, geometry_precision),
+                       round_up(bbox.maxy, geometry_precision)}}},
+                    {"crs", "http://www.opengis.net/def/crs/OGC/1.3/CRS84"}}}}},
+                {"links",
+                 {{{"rel", format == OGCAPIFormat::JSON ? "self" : "alternate"},
+                   {"type", OGCAPI_MIMETYPE_JSON},
+                   {"title", "This collection as JSON"},
+                   {"href", api_root + "/collections/" +
+                                std::string(id_encoded) + "?f=json"}},
+                  {{"rel", format == OGCAPIFormat::HTML ? "self" : "alternate"},
+                   {"type", OGCAPI_MIMETYPE_HTML},
+                   {"title", "This collection as HTML"},
+                   {"href", api_root + "/collections/" +
+                                std::string(id_encoded) + "?f=html"}},
+                  {{"rel", "items"},
+                   {"type", OGCAPI_MIMETYPE_GEOJSON},
+                   {"title", "Items for this collection as GeoJSON"},
+                   {"href", api_root + "/collections/" +
+                                std::string(id_encoded) + "/items?f=json"}},
+                  {{"rel", "items"},
+                   {"type", OGCAPI_MIMETYPE_HTML},
+                   {"title", "Items for this collection as HTML"},
+                   {"href", api_root + "/collections/" +
+                                std::string(id_encoded) + "/items?f=html"}}
 
-      }
-    },
-    { "itemType", "feature" }
-  };
+                 }},
+                {"itemType", "feature"}};
 
   msFree(id_encoded); // done
 
   // handle optional configuration (keywords and links)
   const char *value = msOWSLookupMetadata(&(layer->metadata), "A", "keywords");
-  if(!value) value = msOWSLookupMetadata(&(layer->metadata), "OF", "keywordlist"); // fallback on keywordlist
-  if(value) {
+  if (!value)
+    value = msOWSLookupMetadata(&(layer->metadata), "OF",
+                                "keywordlist"); // fallback on keywordlist
+  if (value) {
     std::vector<std::string> keywords = msStringSplit(value, ',');
-    for(std::string keyword : keywords) {
+    for (std::string keyword : keywords) {
       collection["keywords"].push_back(keyword);
     }
   }
 
   value = msOWSLookupMetadata(&(layer->metadata), "A", "links");
-  if(value) {
+  if (value) {
     std::vector<std::string> names = msStringSplit(value, ',');
-    for(std::string name : names) {
+    for (std::string name : names) {
       try {
         json link = getLink(&(layer->metadata), name);
         collection["links"].push_back(link);
-      } catch(const std::runtime_error &e) {
+      } catch (const std::runtime_error &e) {
         throw e;
       }
     }
@@ -707,8 +726,7 @@ static json getCollection(mapObj *map, l
 ** Output stuff...
 */
 
-static void outputJson(const json& j, const char *mimetype)
-{
+static void outputJson(const json &j, const char *mimetype) {
   std::string js;
 
   try {
@@ -723,11 +741,11 @@ static void outputJson(const json& j, co
   msIO_printf("%s\n", js.c_str());
 }
 
-static void outputTemplate(const char *directory, const char *filename, const json& j, const char *mimetype)
-{
+static void outputTemplate(const char *directory, const char *filename,
+                           const json &j, const char *mimetype) {
   std::string _directory(directory);
   std::string _filename(filename);
-  Environment env {_directory}; // catch
+  Environment env{_directory}; // catch
 
   // ERB-style instead of Mustache (we'll see)
   // env.set_expression("<%=", "%>");
@@ -751,16 +769,19 @@ static void outputTemplate(const char *d
 
     msIO_setHeader("Content-Type", "%s", mimetype);
     msIO_sendHeaders();
-    msIO_printf("%s\n", result.c_str()); 
-  } catch(const inja::RenderError &e) {
-    outputError(OGCAPI_CONFIG_ERROR, "Template rendering error. " + std::string(e.what()) + " (" + std::string(filename) + ").");
+    msIO_printf("%s\n", result.c_str());
+  } catch (const inja::RenderError &e) {
+    outputError(OGCAPI_CONFIG_ERROR, "Template rendering error. " +
+                                         std::string(e.what()) + " (" +
+                                         std::string(filename) + ").");
     return;
-  }
-    catch (const inja::InjaError& e) {
-        outputError(OGCAPI_CONFIG_ERROR, "InjaError error. " + std::string(e.what()) + " (" + std::string(filename) + ")."
-            + " (" + std::string(directory) + ").");
-        return;
-  } catch(...) {
+  } catch (const inja::InjaError &e) {
+    outputError(OGCAPI_CONFIG_ERROR, "InjaError error. " +
+                                         std::string(e.what()) + " (" +
+                                         std::string(filename) + ")." + " (" +
+                                         std::string(directory) + ").");
+    return;
+  } catch (...) {
     outputError(OGCAPI_SERVER_ERROR, "General template handling error.");
     return;
   }
@@ -769,19 +790,22 @@ static void outputTemplate(const char *d
 /*
 ** Generic response outputr.
 */
-static void outputResponse(mapObj *map, cgiRequestObj *request, OGCAPIFormat format, const char *filename, const json& response)
-{
+static void outputResponse(mapObj *map, cgiRequestObj *request,
+                           OGCAPIFormat format, const char *filename,
+                           const json &response) {
   const char *path = NULL;
   char fullpath[MS_MAXPATHLEN];
 
-  if(format == OGCAPIFormat::JSON) {
+  if (format == OGCAPIFormat::JSON) {
     outputJson(response, OGCAPI_MIMETYPE_JSON);
-  } else if(format == OGCAPIFormat::GeoJSON) {
+  } else if (format == OGCAPIFormat::GeoJSON) {
     outputJson(response, OGCAPI_MIMETYPE_GEOJSON);
-  } else if(format == OGCAPIFormat::OpenAPI_V3) {
+  } else if (format == OGCAPIFormat::OpenAPI_V3) {
     outputJson(response, OGCAPI_MIMETYPE_OPENAPI_V3);
-  } else if(format == OGCAPIFormat::HTML) {
-    if((path = getTemplateDirectory(map, "html_template_directory", "OGCAPI_HTML_TEMPLATE_DIRECTORY")) == NULL) {
+  } else if (format == OGCAPIFormat::HTML) {
+    if ((path = getTemplateDirectory(map, "html_template_directory",
+                                     "OGCAPI_HTML_TEMPLATE_DIRECTORY")) ==
+        NULL) {
       outputError(OGCAPI_CONFIG_ERROR, "Template directory not set.");
       return; // bail
     }
@@ -789,36 +813,39 @@ static void outputResponse(mapObj *map,
 
     json j;
 
-    j["response"] = response; // nest the response so we could write the whole object in the template
+    j["response"] = response; // nest the response so we could write the whole
+                              // object in the template
 
     // extend the JSON with a few things that we need for templating
-    j["template"] = {
-      { "path", json::array() },
-      { "params", json::object() },
-      { "api_root", getApiRootUrl(map) },
-      { "title", getTitle(map) },
-      { "tags", json::object() }
-    };
+    j["template"] = {{"path", json::array()},
+                     {"params", json::object()},
+                     {"api_root", getApiRootUrl(map)},
+                     {"title", getTitle(map)},
+                     {"tags", json::object()}};
 
     // api path
-    for( int i=0; i<request->api_path_length; i++ )
+    for (int i = 0; i < request->api_path_length; i++)
       j["template"]["path"].push_back(request->api_path[i]);
 
     // parameters (optional)
-    for( int i=0; i<request->NumParams; i++) {
-      if(request->ParamValues[i] && strlen(request->ParamValues[i]) > 0) { // skip empty params
-        j["template"]["params"].update({{ request->ParamNames[i], request->ParamValues[i] }});
+    for (int i = 0; i < request->NumParams; i++) {
+      if (request->ParamValues[i] &&
+          strlen(request->ParamValues[i]) > 0) { // skip empty params
+        j["template"]["params"].update(
+            {{request->ParamNames[i], request->ParamValues[i]}});
       }
     }
 
     // add custom tags (optional)
-    const char *tags = msOWSLookupMetadata(&(map->web.metadata), "A", "html_tags");
-    if(tags) {
+    const char *tags =
+        msOWSLookupMetadata(&(map->web.metadata), "A", "html_tags");
+    if (tags) {
       std::vector<std::string> names = msStringSplit(tags, ',');
-      for(std::string name : names) {
-        const char *value = msOWSLookupMetadata(&(map->web.metadata), "A", ("tag_" + name).c_str());
-        if(value) {
-              j["template"]["tags"].update({{ name, value }}); // add object
+      for (std::string name : names) {
+        const char *value = msOWSLookupMetadata(&(map->web.metadata), "A",
+                                                ("tag_" + name).c_str());
+        if (value) {
+          j["template"]["tags"].update({{name, value}}); // add object
         }
       }
     }
@@ -832,77 +859,72 @@ static void outputResponse(mapObj *map,
 /*
 ** Process stuff...
 */
-static int processLandingRequest(mapObj *map, cgiRequestObj *request, OGCAPIFormat format)
-{
+static int processLandingRequest(mapObj *map, cgiRequestObj *request,
+                                 OGCAPIFormat format) {
   json response;
 
   // define ambiguous elements
-  const char *description = msOWSLookupMetadata(&(map->web.metadata), "A", "description");
-  if(!description) description = msOWSLookupMetadata(&(map->web.metadata), "OF", "abstract"); // fallback on abstract if necessary
+  const char *description =
+      msOWSLookupMetadata(&(map->web.metadata), "A", "description");
+  if (!description)
+    description =
+        msOWSLookupMetadata(&(map->web.metadata), "OF",
+                            "abstract"); // fallback on abstract if necessary
 
   // define api root url
   std::string api_root = getApiRootUrl(map);
 
   // build response object
   //   - consider conditionally excluding links for HTML format
-  response =  {
-    { "title", getTitle(map) },
-    { "description", description?description:"" },
-    { "links", {
-        {
-          { "rel", format==OGCAPIFormat::JSON?"self":"alternate" },
-          { "type", OGCAPI_MIMETYPE_JSON },
-          { "title", "This document as JSON" },
-          { "href", api_root + "?f=json" }
-        },{
-          { "rel", format==OGCAPIFormat::HTML?"self":"alternate" },
-          { "type", OGCAPI_MIMETYPE_HTML },
-          { "title", "This document as HTML" },
-          { "href", api_root + "?f=html" }
-        },{
-          { "rel", "conformance" },
-          { "type", OGCAPI_MIMETYPE_JSON },
-          { "title", "OCG API conformance classes implemented by this server (JSON)" },
-          { "href", api_root + "/conformance?f=json" }
-        },{
-          { "rel", "conformance" },
-          { "type", OGCAPI_MIMETYPE_HTML },
-          { "title", "OCG API conformance classes implemented by this server" },
-          { "href", api_root + "/conformance?f=html" }
-        },{
-          { "rel", "data" },
-          { "type", OGCAPI_MIMETYPE_JSON },
-          { "title", "Information about feature collections available from this server (JSON)" },
-          { "href", api_root + "/collections?f=json" }
-        },{
-          { "rel", "data" },
-          { "type", OGCAPI_MIMETYPE_HTML },
-          { "title", "Information about feature collections available from this server" },
-          { "href", api_root + "/collections?f=html" }
-        },{
-          { "rel", "service-desc" },
-          { "type", OGCAPI_MIMETYPE_OPENAPI_V3 },
-          { "title", "OpenAPI document" },
-          { "href", api_root + "/api?f=json" }
-        },{
-          { "rel", "service-doc" },
-          { "type", OGCAPI_MIMETYPE_HTML },
-          { "title", "API documentation" },
-          { "href", api_root + "/api?f=html" }
-        }
-      }
-    }
-  };
+  response = {
+      {"title", getTitle(map)},
+      {"description", description ? description : ""},
+      {"links",
+       {{{"rel", format == OGCAPIFormat::JSON ? "self" : "alternate"},
+         {"type", OGCAPI_MIMETYPE_JSON},
+         {"title", "This document as JSON"},
+         {"href", api_root + "?f=json"}},
+        {{"rel", format == OGCAPIFormat::HTML ? "self" : "alternate"},
+         {"type", OGCAPI_MIMETYPE_HTML},
+         {"title", "This document as HTML"},
+         {"href", api_root + "?f=html"}},
+        {{"rel", "conformance"},
+         {"type", OGCAPI_MIMETYPE_JSON},
+         {"title",
+          "OCG API conformance classes implemented by this server (JSON)"},
+         {"href", api_root + "/conformance?f=json"}},
+        {{"rel", "conformance"},
+         {"type", OGCAPI_MIMETYPE_HTML},
+         {"title", "OCG API conformance classes implemented by this server"},
+         {"href", api_root + "/conformance?f=html"}},
+        {{"rel", "data"},
+         {"type", OGCAPI_MIMETYPE_JSON},
+         {"title", "Information about feature collections available from this "
+                   "server (JSON)"},
+         {"href", api_root + "/collections?f=json"}},
+        {{"rel", "data"},
+         {"type", OGCAPI_MIMETYPE_HTML},
+         {"title",
+          "Information about feature collections available from this server"},
+         {"href", api_root + "/collections?f=html"}},
+        {{"rel", "service-desc"},
+         {"type", OGCAPI_MIMETYPE_OPENAPI_V3},
+         {"title", "OpenAPI document"},
+         {"href", api_root + "/api?f=json"}},
+        {{"rel", "service-doc"},
+         {"type", OGCAPI_MIMETYPE_HTML},
+         {"title", "API documentation"},
+         {"href", api_root + "/api?f=html"}}}}};
 
   // handle custom links (optional)
   const char *links = msOWSLookupMetadata(&(map->web.metadata), "A", "links");
-  if(links) {
+  if (links) {
     std::vector<std::string> names = msStringSplit(links, ',');
-    for(std::string name : names) {
+    for (std::string name : names) {
       try {
         json link = getLink(&(map->web.metadata), name);
         response["links"].push_back(link);
-      } catch(const std::runtime_error &e) {
+      } catch (const std::runtime_error &e) {
         outputError(OGCAPI_CONFIG_ERROR, std::string(e.what()));
         return MS_SUCCESS;
       }
@@ -913,29 +935,31 @@ static int processLandingRequest(mapObj
   return MS_SUCCESS;
 }
 
-static int processConformanceRequest(mapObj *map, cgiRequestObj *request, OGCAPIFormat format)
-{
+static int processConformanceRequest(mapObj *map, cgiRequestObj *request,
+                                     OGCAPIFormat format) {
   json response;
- 
+
   // build response object
   response = {
-    { "conformsTo", {
-        "http://www.opengis.net/spec/ogcapi-common-1/1.0/conf/core",
-        "http://www.opengis.net/spec/ogcapi-common-2/1.0/conf/collections",
-        "http://www.opengis.net/spec/ogcapi-features-1/1.0/conf/core",
-        "http://www.opengis.net/spec/ogcapi-features-1/1.0/conf/oas30",
-        "http://www.opengis.net/spec/ogcapi-features-1/1.0/conf/html",
-        "http://www.opengis.net/spec/ogcapi-features-1/1.0/conf/geojson",
-      }
-    }
-  };
+      {"conformsTo",
+       {
+           "http://www.opengis.net/spec/ogcapi-common-1/1.0/conf/core",
+           "http://www.opengis.net/spec/ogcapi-common-2/1.0/conf/collections",
+           "http://www.opengis.net/spec/ogcapi-features-1/1.0/conf/core",
+           "http://www.opengis.net/spec/ogcapi-features-1/1.0/conf/oas30",
+           "http://www.opengis.net/spec/ogcapi-features-1/1.0/conf/html",
+           "http://www.opengis.net/spec/ogcapi-features-1/1.0/conf/geojson",
+       }}};
 
-  outputResponse(map, request, format, OGCAPI_TEMPLATE_HTML_CONFORMANCE, response);
+  outputResponse(map, request, format, OGCAPI_TEMPLATE_HTML_CONFORMANCE,
+                 response);
   return MS_SUCCESS;
 }
 
-static int processCollectionItemsRequest(mapObj *map, cgiRequestObj *request, const char *collectionId, const char *featureId, OGCAPIFormat format)
-{
+static int processCollectionItemsRequest(mapObj *map, cgiRequestObj *request,
+                                         const char *collectionId,
+                                         const char *featureId,
+                                         OGCAPIFormat format) {
   json response;
   int i;
   layerObj *layer;
@@ -946,19 +970,20 @@ static int processCollectionItemsRequest
   int numberMatched = 0;
 
   // find the right layer
-  for(i=0; i<map->numlayers; i++) {
-    if(strcmp(map->layers[i]->name, collectionId) == 0) break; // match
+  for (i = 0; i < map->numlayers; i++) {
+    if (strcmp(map->layers[i]->name, collectionId) == 0)
+      break; // match
   }
 
-  if(i == map->numlayers) { // invalid collectionId
+  if (i == map->numlayers) { // invalid collectionId
     outputError(OGCAPI_NOT_FOUND_ERROR, "Invalid collection.");
     return MS_SUCCESS;
   }
 
   layer = map->layers[i]; // for convenience
-  layer->status = MS_ON; // force on (do we need to save and reset?)
+  layer->status = MS_ON;  // force on (do we need to save and reset?)
 
-  if(!includeLayer(map, layer)) {
+  if (!includeLayer(map, layer)) {
     outputError(OGCAPI_NOT_FOUND_ERROR, "Invalid collection.");
     return MS_SUCCESS;
   }
@@ -966,20 +991,21 @@ static int processCollectionItemsRequest
   //
   // handle parameters specific to this endpoint
   //
-  if(getLimit(map, request, layer, &limit) != MS_SUCCESS) {
+  if (getLimit(map, request, layer, &limit) != MS_SUCCESS) {
     outputError(OGCAPI_PARAM_ERROR, "Bad value for limit.");
     return MS_SUCCESS;
   }
 
-  if(!getBbox(map, request, &bbox)) {
+  if (!getBbox(map, request, &bbox)) {
     outputError(OGCAPI_PARAM_ERROR, "Bad value for bbox.");
     return MS_SUCCESS;
   }
 
   int offset = 0;
-  if(featureId) {
-    const char *featureIdItem = msOWSLookupMetadata(&(layer->metadata), "AGFO", "featureid");
-    if(featureIdItem == NULL) {
+  if (featureId) {
+    const char *featureIdItem =
+        msOWSLookupMetadata(&(layer->metadata), "AGFO", "featureid");
+    if (featureIdItem == NULL) {
       outputError(OGCAPI_CONFIG_ERROR, "Missing required featureid metadata.");
       return MS_SUCCESS;
     }
@@ -987,8 +1013,11 @@ static int processCollectionItemsRequest
     // TODO: does featureIdItem exist in the data?
 
     // optional validation
-    const char *featureIdValidation = msLookupHashTable(&(layer->validation), featureIdItem);
-    if(featureIdValidation && msValidateParameter(featureId, featureIdValidation, NULL, NULL, NULL) != MS_SUCCESS) {
+    const char *featureIdValidation =
+        msLookupHashTable(&(layer->validation), featureIdItem);
+    if (featureIdValidation &&
+        msValidateParameter(featureId, featureIdValidation, NULL, NULL, NULL) !=
+            MS_SUCCESS) {
       outputError(OGCAPI_NOT_FOUND_ERROR, "Invalid feature id.");
       return MS_SUCCESS;
     }
@@ -1003,32 +1032,30 @@ static int processCollectionItemsRequest
     map->query.filter.type = MS_STRING;
     map->query.filter.string = strdup(featureId);
 
-    if(msExecuteQuery(map) != MS_SUCCESS) {
+    if (msExecuteQuery(map) != MS_SUCCESS) {
       outputError(OGCAPI_NOT_FOUND_ERROR, "Collection items id query failed.");
       return MS_SUCCESS;
     }
 
-    if(!layer->resultcache || layer->resultcache->numresults != 1) {
+    if (!layer->resultcache || layer->resultcache->numresults != 1) {
       outputError(OGCAPI_NOT_FOUND_ERROR, "Collection items id query failed.");
       return MS_SUCCESS;
     }
   } else { // bbox query
 
-    const char *compliance_mode = msOWSLookupMetadata(&(map->web.metadata), "A", "compliance_mode");
-    if(compliance_mode != NULL && strcasecmp(compliance_mode, "true") == 0) {
-      for(int j=0; j<request->NumParams; j++) {
-        const char* paramName = request->ParamNames[j];
-        if (strcmp(paramName, "f") == 0 ||
-            strcmp(paramName, "bbox") == 0 ||
+    const char *compliance_mode =
+        msOWSLookupMetadata(&(map->web.metadata), "A", "compliance_mode");
+    if (compliance_mode != NULL && strcasecmp(compliance_mode, "true") == 0) {
+      for (int j = 0; j < request->NumParams; j++) {
+        const char *paramName = request->ParamNames[j];
+        if (strcmp(paramName, "f") == 0 || strcmp(paramName, "bbox") == 0 ||
             strcmp(paramName, "datetime") == 0 ||
             strcmp(paramName, "limit") == 0 ||
-            strcmp(paramName, "offset") == 0)
-        {
+            strcmp(paramName, "offset") == 0) {
           // ok
-        }
-        else
-        {
-          outputError(OGCAPI_PARAM_ERROR,
+        } else {
+          outputError(
+              OGCAPI_PARAM_ERROR,
               (std::string("Unknown query parameter: ") + paramName).c_str());
           return MS_SUCCESS;
         }
@@ -1042,51 +1069,49 @@ static int processCollectionItemsRequest
     map->query.only_cache_result_count = MS_TRUE;
 
     // get number matched
-    if(msExecuteQuery(map) != MS_SUCCESS) {
+    if (msExecuteQuery(map) != MS_SUCCESS) {
       outputError(OGCAPI_NOT_FOUND_ERROR, "Collection items query failed.");
       return MS_SUCCESS;
     }
 
-    if(!layer->resultcache) {
+    if (!layer->resultcache) {
       outputError(OGCAPI_NOT_FOUND_ERROR, "Collection items query failed.");
       return MS_SUCCESS;
     }
 
     numberMatched = layer->resultcache->numresults;
 
-    if( numberMatched > 0 ) {
-        map->query.only_cache_result_count = MS_FALSE;
-        map->query.maxfeatures = limit;
-
-        const char* offsetStr = getRequestParameter(request, "offset");
-        if( offsetStr )
-        {
-            if( msStringToInt(offsetStr, &offset, 10) != MS_SUCCESS )
-            {
-              outputError(OGCAPI_PARAM_ERROR, "Bad value for offset.");
-              return MS_SUCCESS;
-            }
-
-            if(offset < 0 || offset >= numberMatched) {
-              outputError(OGCAPI_PARAM_ERROR, "Offset out of range.");
-              return MS_SUCCESS;
-            }
-
-            // msExecuteQuery() use a 1-based offset convention, whereas the API
-            // uses a 0-based offset convention.
-            map->query.startindex = 1 + offset;
-            layer->startindex = 1 + offset;
+    if (numberMatched > 0) {
+      map->query.only_cache_result_count = MS_FALSE;
+      map->query.maxfeatures = limit;
+
+      const char *offsetStr = getRequestParameter(request, "offset");
+      if (offsetStr) {
+        if (msStringToInt(offsetStr, &offset, 10) != MS_SUCCESS) {
+          outputError(OGCAPI_PARAM_ERROR, "Bad value for offset.");
+          return MS_SUCCESS;
         }
 
-        if(msExecuteQuery(map) != MS_SUCCESS) {
-          outputError(OGCAPI_NOT_FOUND_ERROR, "Collection items query failed.");
+        if (offset < 0 || offset >= numberMatched) {
+          outputError(OGCAPI_PARAM_ERROR, "Offset out of range.");
           return MS_SUCCESS;
         }
+
+        // msExecuteQuery() use a 1-based offset convention, whereas the API
+        // uses a 0-based offset convention.
+        map->query.startindex = 1 + offset;
+        layer->startindex = 1 + offset;
+      }
+
+      if (msExecuteQuery(map) != MS_SUCCESS) {
+        outputError(OGCAPI_NOT_FOUND_ERROR, "Collection items query failed.");
+        return MS_SUCCESS;
+      }
     }
   }
 
   // build response object
-  if(!featureId) {
+  if (!featureId) {
     std::string api_root = getApiRootUrl(map);
     const char *id = layer->name;
     char *id_encoded = msEncodeUrl(id); // free after use
@@ -1095,49 +1120,46 @@ static int processCollectionItemsRequest
     extra_kvp += "&offset=" + std::to_string(offset);
 
     response = {
-      { "type", "FeatureCollection" },
-      { "numberMatched", numberMatched },
-      { "numberReturned", layer->resultcache->numresults },
-      { "features", json::array() },
-      { "links", {
-          {
-              { "rel", format==OGCAPIFormat::JSON?"self":"alternate" },
-              { "type", OGCAPI_MIMETYPE_GEOJSON },
-              { "title", "Items for this collection as GeoJSON" },
-              { "href", api_root + "/collections/" + std::string(id_encoded) + "/items?f=json" + extra_kvp }
-          },{
-              { "rel", format==OGCAPIFormat::HTML?"self":"alternate" },
-              { "type", OGCAPI_MIMETYPE_HTML },
-              { "title", "Items for this collection as HTML" },
-              { "href", api_root + "/collections/" + std::string(id_encoded) + "/items?f=html" + extra_kvp }
-          }
-      }}
-    };
-
-    if( offset + layer->resultcache->numresults < numberMatched )
-    {
-        response["links"].push_back({
-            { "rel", "next" },
-            { "type", format==OGCAPIFormat::JSON? OGCAPI_MIMETYPE_GEOJSON : OGCAPI_MIMETYPE_HTML },
-            { "title", "next page" },
-            { "href", api_root + "/collections/" + std::string(id_encoded) +
-                      "/items?f=" + (format==OGCAPIFormat::JSON? "json" : "html") +
-                      "&limit=" + std::to_string(limit) +
-                      "&offset=" + std::to_string(offset + limit) }
-        });
-    }
-
-    if( offset > 0 ) 
-    {
-        response["links"].push_back({
-	    { "rel", "prev" },
-            { "type", format==OGCAPIFormat::JSON? OGCAPI_MIMETYPE_GEOJSON : OGCAPI_MIMETYPE_HTML },
-	    { "title", "previous page" },
-	    { "href", api_root + "/collections/" + std::string(id_encoded) +
-	              "/items?f=" + (format==OGCAPIFormat::JSON? "json" : "html") +
-		      "&limit=" + std::to_string(limit) +
-		      "&offset=" + std::to_string(MS_MAX(0, (offset - limit))) }
-	});
+        {"type", "FeatureCollection"},
+        {"numberMatched", numberMatched},
+        {"numberReturned", layer->resultcache->numresults},
+        {"features", json::array()},
+        {"links",
+         {{{"rel", format == OGCAPIFormat::JSON ? "self" : "alternate"},
+           {"type", OGCAPI_MIMETYPE_GEOJSON},
+           {"title", "Items for this collection as GeoJSON"},
+           {"href", api_root + "/collections/" + std::string(id_encoded) +
+                        "/items?f=json" + extra_kvp}},
+          {{"rel", format == OGCAPIFormat::HTML ? "self" : "alternate"},
+           {"type", OGCAPI_MIMETYPE_HTML},
+           {"title", "Items for this collection as HTML"},
+           {"href", api_root + "/collections/" + std::string(id_encoded) +
+                        "/items?f=html" + extra_kvp}}}}};
+
+    if (offset + layer->resultcache->numresults < numberMatched) {
+      response["links"].push_back(
+          {{"rel", "next"},
+           {"type", format == OGCAPIFormat::JSON ? OGCAPI_MIMETYPE_GEOJSON
+                                                 : OGCAPI_MIMETYPE_HTML},
+           {"title", "next page"},
+           {"href",
+            api_root + "/collections/" + std::string(id_encoded) +
+                "/items?f=" + (format == OGCAPIFormat::JSON ? "json" : "html") +
+                "&limit=" + std::to_string(limit) +
+                "&offset=" + std::to_string(offset + limit)}});
+    }
+
+    if (offset > 0) {
+      response["links"].push_back(
+          {{"rel", "prev"},
+           {"type", format == OGCAPIFormat::JSON ? OGCAPI_MIMETYPE_GEOJSON
+                                                 : OGCAPI_MIMETYPE_HTML},
+           {"title", "previous page"},
+           {"href",
+            api_root + "/collections/" + std::string(id_encoded) +
+                "/items?f=" + (format == OGCAPIFormat::JSON ? "json" : "html") +
+                "&limit=" + std::to_string(limit) +
+                "&offset=" + std::to_string(MS_MAX(0, (offset - limit)))}});
     }
 
     msFree(id_encoded); // done
@@ -1152,10 +1174,11 @@ static int processCollectionItemsRequest
     gmlItemListObj *items = msGMLGetItems(layer, "AG");
     gmlConstantListObj *constants = msGMLGetConstants(layer, "AG");
 
-    if(!items || !constants) {
+    if (!items || !constants) {
       msGMLFreeItems(items);
       msGMLFreeConstants(constants);
-      outputError(OGCAPI_SERVER_ERROR, "Error fetching layer attribute metadata.");
+      outputError(OGCAPI_SERVER_ERROR,
+                  "Error fetching layer attribute metadata.");
       return MS_SUCCESS;
     }
 
@@ -1163,34 +1186,38 @@ static int processCollectionItemsRequest
 
     // reprojection to EPSG:4326 (if necessary)
     reprojectionObj *reprojector = NULL;
-    if(layer->projection.numargs > 0) { 
-      if(msProjectionsDiffer(&(layer->projection), &(map->latlon))) {
-        reprojector = msProjectCreateReprojector(&(layer->projection), &(map->latlon));
-        if(reprojector == NULL) {
+    if (layer->projection.numargs > 0) {
+      if (msProjectionsDiffer(&(layer->projection), &(map->latlon))) {
+        reprojector =
+            msProjectCreateReprojector(&(layer->projection), &(map->latlon));
+        if (reprojector == NULL) {
           msGMLFreeItems(items);
           msGMLFreeConstants(constants);
           outputError(OGCAPI_SERVER_ERROR, "Error creating re-projector.");
           return MS_SUCCESS;
         }
       }
-    } else if(map->projection.numargs > 0) {
-      if(msProjectionsDiffer(&(map->projection), &(map->latlon))) {
-        reprojector = msProjectCreateReprojector(&(map->projection), &(map->latlon));
-        if(reprojector == NULL) {
-	  msGMLFreeItems(items);
+    } else if (map->projection.numargs > 0) {
+      if (msProjectionsDiffer(&(map->projection), &(map->latlon))) {
+        reprojector =
+            msProjectCreateReprojector(&(map->projection), &(map->latlon));
+        if (reprojector == NULL) {
+          msGMLFreeItems(items);
           msGMLFreeConstants(constants);
-	  outputError(OGCAPI_SERVER_ERROR, "Error creating re-projector.");
+          outputError(OGCAPI_SERVER_ERROR, "Error creating re-projector.");
           return MS_SUCCESS;
         }
       }
     } else {
-      outputError(OGCAPI_CONFIG_ERROR, "Unable to transform geometries, no projection defined.");
+      outputError(OGCAPI_CONFIG_ERROR,
+                  "Unable to transform geometries, no projection defined.");
       return MS_SUCCESS;
     }
 
-    for(i=0; i<layer->resultcache->numresults; i++) {
-      int status = msLayerGetShape(layer, &shape, &(layer->resultcache->results[i]));
-      if(status != MS_SUCCESS) {
+    for (i = 0; i < layer->resultcache->numresults; i++) {
+      int status =
+          msLayerGetShape(layer, &shape, &(layer->resultcache->results[i]));
+      if (status != MS_SUCCESS) {
         msGMLFreeItems(items);
         msGMLFreeConstants(constants);
         msProjectDestroyReprojector(reprojector);
@@ -1198,9 +1225,9 @@ static int processCollectionItemsRequest
         return MS_SUCCESS;
       }
 
-      if(reprojector) {
+      if (reprojector) {
         status = msProjectShapeEx(reprojector, &shape);
-        if(status != MS_SUCCESS) {
+        if (status != MS_SUCCESS) {
           msGMLFreeItems(items);
           msGMLFreeConstants(constants);
           msProjectDestroyReprojector(reprojector);
@@ -1211,8 +1238,9 @@ static int processCollectionItemsRequest
       }
 
       try {
-        json feature = getFeature(layer, &shape, items, constants, geometry_precision);
-        if(featureId) {
+        json feature =
+            getFeature(layer, &shape, items, constants, geometry_precision);
+        if (featureId) {
           response = feature;
         } else {
           response["features"].push_back(feature);
@@ -1222,7 +1250,8 @@ static int processCollectionItemsRequest
         msGMLFreeConstants(constants);
         msProjectDestroyReprojector(reprojector);
         msFreeShape(&shape);
-        outputError(OGCAPI_SERVER_ERROR, "Error getting feature. " + std::string(e.what()));
+        outputError(OGCAPI_SERVER_ERROR,
+                    "Error getting feature. " + std::string(e.what()));
         return MS_SUCCESS;
       }
 
@@ -1235,87 +1264,84 @@ static int processCollectionItemsRequest
   }
 
   // extend the response a bit for templating (HERE)
-  if(format == OGCAPIFormat::HTML) {
+  if (format == OGCAPIFormat::HTML) {
     const char *title = getCollectionTitle(layer);
     const char *id = layer->name;
-    response["collection"] = {
-      { "id", id },
-      { "title", title?title:"" }
-    };
+    response["collection"] = {{"id", id}, {"title", title ? title : ""}};
   }
 
-  if(featureId)
-  {
+  if (featureId) {
     std::string api_root = getApiRootUrl(map);
     const char *id = layer->name;
     char *id_encoded = msEncodeUrl(id); // free after use
 
     response["links"] = {
-      {
-          { "rel", format==OGCAPIFormat::JSON?"self":"alternate" },
-          { "type", OGCAPI_MIMETYPE_GEOJSON },
-          { "title", "This document as GeoJSON" },
-          { "href", api_root + "/collections/" + std::string(id_encoded) +
-              "/items/" + featureId + "?f=json" }
-      },{
-          { "rel", format==OGCAPIFormat::HTML?"self":"alternate" },
-          { "type", OGCAPI_MIMETYPE_HTML },
-          { "title", "This document as HTML" },
-          { "href", api_root + "/collections/" + std::string(id_encoded) +
-              "/items/" + featureId + "?f=html" }
-      },{
-          { "rel", "collection" },
-          { "type", OGCAPI_MIMETYPE_JSON },
-          { "title", "This collection as JSON" },
-          { "href", api_root + "/collections/" + std::string(id_encoded) + "?f=json" }
-      },{
-          { "rel", "collection" },
-          { "type", OGCAPI_MIMETYPE_HTML },
-          { "title", "This collection as HTML" },
-          { "href", api_root + "/collections/" + std::string(id_encoded) + "?f=html" }
-      }
-    };
+        {{"rel", format == OGCAPIFormat::JSON ? "self" : "alternate"},
+         {"type", OGCAPI_MIMETYPE_GEOJSON},
+         {"title", "This document as GeoJSON"},
+         {"href", api_root + "/collections/" + std::string(id_encoded) +
+                      "/items/" + featureId + "?f=json"}},
+        {{"rel", format == OGCAPIFormat::HTML ? "self" : "alternate"},
+         {"type", OGCAPI_MIMETYPE_HTML},
+         {"title", "This document as HTML"},
+         {"href", api_root + "/collections/" + std::string(id_encoded) +
+                      "/items/" + featureId + "?f=html"}},
+        {{"rel", "collection"},
+         {"type", OGCAPI_MIMETYPE_JSON},
+         {"title", "This collection as JSON"},
+         {"href",
+          api_root + "/collections/" + std::string(id_encoded) + "?f=json"}},
+        {{"rel", "collection"},
+         {"type", OGCAPI_MIMETYPE_HTML},
+         {"title", "This collection as HTML"},
+         {"href",
+          api_root + "/collections/" + std::string(id_encoded) + "?f=html"}}};
 
     msFree(id_encoded);
 
-    outputResponse(map, request, format, OGCAPI_TEMPLATE_HTML_COLLECTION_ITEM, response);
-  }
-  else
-    outputResponse(map, request, format, OGCAPI_TEMPLATE_HTML_COLLECTION_ITEMS, response);
+    outputResponse(map, request, format, OGCAPI_TEMPLATE_HTML_COLLECTION_ITEM,
+                   response);
+  } else
+    outputResponse(map, request, format, OGCAPI_TEMPLATE_HTML_COLLECTION_ITEMS,
+                   response);
   return MS_SUCCESS;
 }
 
-static int processCollectionRequest(mapObj *map, cgiRequestObj *request, const char *collectionId, OGCAPIFormat format)
-{
+static int processCollectionRequest(mapObj *map, cgiRequestObj *request,
+                                    const char *collectionId,
+                                    OGCAPIFormat format) {
   json response;
   int l;
 
-  for(l=0; l<map->numlayers; l++) {
-    if(strcmp(map->layers[l]->name, collectionId) == 0) break; // match
+  for (l = 0; l < map->numlayers; l++) {
+    if (strcmp(map->layers[l]->name, collectionId) == 0)
+      break; // match
   }
 
-  if(l == map->numlayers) { // invalid collectionId
+  if (l == map->numlayers) { // invalid collectionId
     outputError(OGCAPI_NOT_FOUND_ERROR, "Invalid collection.");
     return MS_SUCCESS;
   }
 
   try {
     response = getCollection(map, map->layers[l], format);
-    if(response.is_null()) { // same as not found
+    if (response.is_null()) { // same as not found
       outputError(OGCAPI_NOT_FOUND_ERROR, "Invalid collection.");
       return MS_SUCCESS;
     }
   } catch (const std::runtime_error &e) {
-    outputError(OGCAPI_CONFIG_ERROR, "Error getting collection. " + std::string(e.what()));
+    outputError(OGCAPI_CONFIG_ERROR,
+                "Error getting collection. " + std::string(e.what()));
     return MS_SUCCESS;
   }
 
-  outputResponse(map, request, format, OGCAPI_TEMPLATE_HTML_COLLECTION, response);
+  outputResponse(map, request, format, OGCAPI_TEMPLATE_HTML_COLLECTION,
+                 response);
   return MS_SUCCESS;
 }
 
-static int processCollectionsRequest(mapObj *map, cgiRequestObj *request, OGCAPIFormat format)
-{
+static int processCollectionsRequest(mapObj *map, cgiRequestObj *request,
+                                     OGCAPIFormat format) {
   json response;
   int i;
 
@@ -1323,297 +1349,326 @@ static int processCollectionsRequest(map
   std::string api_root = getApiRootUrl(map);
 
   // build response object
-  response = {
-    { "links", {
-        {
-          { "rel", format==OGCAPIFormat::JSON?"self":"alternate" },
-          { "type", OGCAPI_MIMETYPE_JSON },
-          { "title", "This document as JSON" },
-          { "href", api_root + "/collections?f=json" }
-        },{
-          { "rel", format==OGCAPIFormat::HTML?"self":"alternate" },
-          { "type", OGCAPI_MIMETYPE_HTML },
-          { "title", "This document as HTML" },
-          { "href", api_root + "/collections?f=html" }
-        }
-      }
-    },{
-      "collections", json::array()
-    }
-  };
+  response = {{"links",
+               {{{"rel", format == OGCAPIFormat::JSON ? "self" : "alternate"},
+                 {"type", OGCAPI_MIMETYPE_JSON},
+                 {"title", "This document as JSON"},
+                 {"href", api_root + "/collections?f=json"}},
+                {{"rel", format == OGCAPIFormat::HTML ? "self" : "alternate"},
+                 {"type", OGCAPI_MIMETYPE_HTML},
+                 {"title", "This document as HTML"},
+                 {"href", api_root + "/collections?f=html"}}}},
+              {"collections", json::array()}};
 
-  for(i=0; i<map->numlayers; i++) {
+  for (i = 0; i < map->numlayers; i++) {
     try {
       json collection = getCollection(map, map->layers[i], format);
-      if(!collection.is_null()) response["collections"].push_back(collection);
+      if (!collection.is_null())
+        response["collections"].push_back(collection);
     } catch (const std::runtime_error &e) {
-      outputError(OGCAPI_CONFIG_ERROR, "Error getting collection." + std::string(e.what()));
+      outputError(OGCAPI_CONFIG_ERROR,
+                  "Error getting collection." + std::string(e.what()));
       return MS_SUCCESS;
     }
   }
 
-  outputResponse(map, request, format, OGCAPI_TEMPLATE_HTML_COLLECTIONS, response);
+  outputResponse(map, request, format, OGCAPI_TEMPLATE_HTML_COLLECTIONS,
+                 response);
   return MS_SUCCESS;
 }
 
-static int processApiRequest(mapObj *map, cgiRequestObj *request, OGCAPIFormat format)
-{
-  // Strongly inspired from https://github.com/geopython/pygeoapi/blob/master/pygeoapi/openapi.py
+static int processApiRequest(mapObj *map, cgiRequestObj *request,
+                             OGCAPIFormat format) {
+  // Strongly inspired from
+  // https://github.com/geopython/pygeoapi/blob/master/pygeoapi/openapi.py
 
   json response;
 
   response = {
-      { "openapi", "3.0.2" },
-      { "tags", json::array() },
+      {"openapi", "3.0.2"},
+      {"tags", json::array()},
   };
 
   response["info"] = {
-      { "title", getTitle(map) },
-      { "version", getWebMetadata(map, "A", "version", "1.0.0") },
+      {"title", getTitle(map)},
+      {"version", getWebMetadata(map, "A", "version", "1.0.0")},
   };
 
-  for( const char* item: { "description", "termsOfService" }) {
-      const char* value = getWebMetadata(map, "AO", item, nullptr);
-      if( value ) {
-          response["info"][item] = value;
-      }
+  for (const char *item : {"description", "termsOfService"}) {
+    const char *value = getWebMetadata(map, "AO", item, nullptr);
+    if (value) {
+      response["info"][item] = value;
+    }
   }
 
-  for( const auto& pair: {
-          std::make_pair("name", "contactperson"),
-          std::make_pair("url", "contacturl"),
-          std::make_pair("email", "contactelectronicmailaddress"),
-        }) {
-      const char* value = getWebMetadata(map, "AO", pair.second, nullptr);
-      if( value ) {
-          response["info"]["contact"][pair.first] = value;
-      }
+  for (const auto &pair : {
+           std::make_pair("name", "contactperson"),
+           std::make_pair("url", "contacturl"),
+           std::make_pair("email", "contactelectronicmailaddress"),
+       }) {
+    const char *value = getWebMetadata(map, "AO", pair.second, nullptr);
+    if (value) {
+      response["info"]["contact"][pair.first] = value;
+    }
   }
 
-  for( const auto& pair: {
-          std::make_pair("name", "licensename"),
-          std::make_pair("url", "licenseurl"),
-        }) {
-      const char* value = getWebMetadata(map, "AO", pair.second, nullptr);
-      if( value ) {
-          response["info"]["license"][pair.first] = value;
-      }
+  for (const auto &pair : {
+           std::make_pair("name", "licensename"),
+           std::make_pair("url", "licenseurl"),
+       }) {
+    const char *value = getWebMetadata(map, "AO", pair.second, nullptr);
+    if (value) {
+      response["info"]["license"][pair.first] = value;
+    }
   }
 
   {
-      const char* value = getWebMetadata(map, "AO", "keywords", nullptr);
-      if( value ) {
-          response["info"]["x-keywords"] = value;
-      }
+    const char *value = getWebMetadata(map, "AO", "keywords", nullptr);
+    if (value) {
+      response["info"]["x-keywords"] = value;
+    }
   }
 
   json server;
   server["url"] = getApiRootUrl(map);
   {
-      const char* value = getWebMetadata(map, "AO", "server_description", nullptr);
-      if( value ) {
-          server["description"] = value;
-      }
+    const char *value =
+        getWebMetadata(map, "AO", "server_description", nullptr);
+    if (value) {
+      server["description"] = value;
+    }
   }
   response["servers"].push_back(server);
 
-  const std::string oapif_yaml_url = "http://schemas.opengis.net/ogcapi/features/part1/1.0/openapi/ogcapi-features-1.yaml";
+  const std::string oapif_yaml_url =
+      "http://schemas.opengis.net/ogcapi/features/part1/1.0/openapi/"
+      "ogcapi-features-1.yaml";
 
   json paths;
 
   paths["/"]["get"] = {
-      { "summary", "Landing page" },
-      { "description", "Landing page" },
-      { "tags", { "server" } },
-      { "operationId", "getLandingPage" },
-        { "parameters", {
-          {{ "$ref", "#/components/parameters/f"}},
-      }},
-      { "responses", {
-          { "200", {{"$ref", oapif_yaml_url + "#/components/responses/LandingPage"}} },
-          { "400", {{"$ref", oapif_yaml_url + "#/components/responses/InvalidParameter"}} },
-          { "500", {{"$ref", oapif_yaml_url + "#/components/responses/ServerError"}} }
-      }}
-  };
+      {"summary", "Landing page"},
+      {"description", "Landing page"},
+      {"tags", {"server"}},
+      {"operationId", "getLandingPage"},
+      {"parameters",
+       {
+           {{"$ref", "#/components/parameters/f"}},
+       }},
+      {"responses",
+       {{"200",
+         {{"$ref", oapif_yaml_url + "#/components/responses/LandingPage"}}},
+        {"400",
+         {{"$ref",
+           oapif_yaml_url + "#/components/responses/InvalidParameter"}}},
+        {"500",
+         {{"$ref", oapif_yaml_url + "#/components/responses/ServerError"}}}}}};
 
   paths["/api"]["get"] = {
-      { "summary", "API documentation" },
-      { "description", "API documentation" },
-      { "tags", { "server" } },
-      { "operationId", "getOpenapi" },
-      { "parameters", {
-          {{ "$ref", "#/components/parameters/f"}},
-      }},
-      { "responses", {
-          { "200", {{"$ref", "#/components/responses/200"}} },
-          { "400", {{"$ref", oapif_yaml_url + "#/components/responses/InvalidParameter"}} },
-          { "default", {{"$ref", "#/components/responses/default"}} }
-      }}
-  };
+      {"summary", "API documentation"},
+      {"description", "API documentation"},
+      {"tags", {"server"}},
+      {"operationId", "getOpenapi"},
+      {"parameters",
+       {
+           {{"$ref", "#/components/parameters/f"}},
+       }},
+      {"responses",
+       {{"200", {{"$ref", "#/components/responses/200"}}},
+        {"400",
+         {{"$ref",
+           oapif_yaml_url + "#/components/responses/InvalidParameter"}}},
+        {"default", {{"$ref", "#/components/responses/default"}}}}}};
 
   paths["/conformance"]["get"] = {
-      { "summary", "API conformance definition" },
-      { "description", "API conformance definition" },
-      { "tags", { "server" } },
-      { "operationId", "getConformanceDeclaration" },
-      { "parameters", {
-          {{ "$ref", "#/components/parameters/f"}},
-      }},
-      { "responses", {
-          { "200", {{"$ref", oapif_yaml_url + "#/components/responses/ConformanceDeclaration"}} },
-          { "400", {{"$ref", oapif_yaml_url + "#/components/responses/InvalidParameter"}} },
-          { "500", {{"$ref", oapif_yaml_url + "#/components/responses/ServerError"}} }
-      }}
-  };
+      {"summary", "API conformance definition"},
+      {"description", "API conformance definition"},
+      {"tags", {"server"}},
+      {"operationId", "getConformanceDeclaration"},
+      {"parameters",
+       {
+           {{"$ref", "#/components/parameters/f"}},
+       }},
+      {"responses",
+       {{"200",
+         {{"$ref",
+           oapif_yaml_url + "#/components/responses/ConformanceDeclaration"}}},
+        {"400",
+         {{"$ref",
+           oapif_yaml_url + "#/components/responses/InvalidParameter"}}},
+        {"500",
+         {{"$ref", oapif_yaml_url + "#/components/responses/ServerError"}}}}}};
 
   paths["/collections"]["get"] = {
-      { "summary", "Collections" },
-      { "description", "Collections" },
-      { "tags", { "server" } },
-      { "operationId", "getCollections" },
-      { "parameters", {
-          {{ "$ref", "#/components/parameters/f"}},
-      }},
-      { "responses", {
-          { "200", {{"$ref", oapif_yaml_url + "#/components/responses/Collections"}} },
-          { "400", {{"$ref", oapif_yaml_url + "#/components/responses/InvalidParameter"}} },
-          { "500", {{"$ref", oapif_yaml_url + "#/components/responses/ServerError"}} }
-      }}
-  };
+      {"summary", "Collections"},
+      {"description", "Collections"},
+      {"tags", {"server"}},
+      {"operationId", "getCollections"},
+      {"parameters",
+       {
+           {{"$ref", "#/components/parameters/f"}},
+       }},
+      {"responses",
+       {{"200",
+         {{"$ref", oapif_yaml_url + "#/components/responses/Collections"}}},
+        {"400",
+         {{"$ref",
+           oapif_yaml_url + "#/components/responses/InvalidParameter"}}},
+        {"500",
+         {{"$ref", oapif_yaml_url + "#/components/responses/ServerError"}}}}}};
+
+  for (int i = 0; i < map->numlayers; i++) {
+    layerObj *layer = map->layers[i];
+    if (!includeLayer(map, layer)) {
+      continue;
+    }
+
+    json collection_get = {
+        {"summary",
+         std::string("Get ") + getCollectionTitle(layer) + " metadata"},
+        {"description", getCollectionDescription(layer)},
+        {"tags", {layer->name}},
+        {"operationId", "describe" + std::string(layer->name) + "Collection"},
+        {"parameters",
+         {
+             {{"$ref", "#/components/parameters/f"}},
+         }},
+        {"responses",
+         {{"200",
+           {{"$ref", oapif_yaml_url + "#/components/responses/Collection"}}},
+          {"400",
+           {{"$ref",
+             oapif_yaml_url + "#/components/responses/InvalidParameter"}}},
+          {"500",
+           {{"$ref",
+             oapif_yaml_url + "#/components/responses/ServerError"}}}}}};
+
+    std::string collectionNamePath("/collections/");
+    collectionNamePath += layer->name;
+    paths[collectionNamePath]["get"] = collection_get;
+
+    // check metadata, layer then map
+    const char *max_limit_str =
+        msOWSLookupMetadata(&(layer->metadata), "A", "max_limit");
+    if (max_limit_str == nullptr)
+      max_limit_str =
+          msOWSLookupMetadata(&(map->web.metadata), "A", "max_limit");
+    const int max_limit =
+        max_limit_str ? atoi(max_limit_str) : OGCAPI_MAX_LIMIT;
+    const int default_limit = getDefaultLimit(map, layer);
+
+    json items_get = {
+        {"summary", std::string("Get ") + getCollectionTitle(layer) + " items"},
+        {"description", getCollectionDescription(layer)},
+        {"tags", {layer->name}},
+        {"operationId", "get" + std::string(layer->name) + "Features"},
+        {"parameters",
+         {
+             {{"$ref", "#/components/parameters/f"}},
+             {{"$ref", oapif_yaml_url + "#/components/parameters/bbox"}},
+             {{"$ref", oapif_yaml_url + "#/components/parameters/datetime"}},
+             {{"$ref", "#/components/parameters/offset"}},
+         }},
+        {"responses",
+         {{"200",
+           {{"$ref", oapif_yaml_url + "#/components/responses/Features"}}},
+          {"400",
+           {{"$ref",
+             oapif_yaml_url + "#/components/responses/InvalidParameter"}}},
+          {"500",
+           {{"$ref",
+             oapif_yaml_url + "#/components/responses/ServerError"}}}}}};
+
+    json param_limit = {
+        {"name", "limit"},
+        {"in", "query"},
+        {"description", "The optional limit parameter limits the number of "
+                        "items that are presented in the response document."},
+        {"required", false},
+        {"schema",
+         {
+             {"type", "integer"},
+             {"minimum", 1},
+             {"maximum", max_limit},
+             {"default", default_limit},
+         }},
+        {"style", "form"},
+        {"explode", false},
+    };
+    items_get["parameters"].emplace_back(param_limit);
 
-  for(int i=0; i<map->numlayers; i++) {
-      layerObj* layer = map->layers[i];
-      if(!includeLayer(map, layer)) {
-          continue;
-      }
+    std::string itemsPath(collectionNamePath + "/items");
+    paths[itemsPath]["get"] = items_get;
 
-      json collection_get = {
-          { "summary", std::string("Get ") + getCollectionTitle(layer) + " metadata" },
-          { "description", getCollectionDescription(layer) },
-          { "tags", { layer->name } },
-          { "operationId", "describe" + std::string(layer->name) + "Collection" },
-          { "parameters", {
-              {{ "$ref", "#/components/parameters/f"}},
-          }},
-          { "responses", {
-              { "200", {{"$ref", oapif_yaml_url + "#/components/responses/Collection"}} },
-              { "400", {{"$ref", oapif_yaml_url + "#/components/responses/InvalidParameter"}} },
-              { "500", {{"$ref", oapif_yaml_url + "#/components/responses/ServerError"}} }
-          }}
-      };
-
-      std::string collectionNamePath("/collections/");
-      collectionNamePath += layer->name;
-      paths[collectionNamePath]["get"] = collection_get;
-
-      // check metadata, layer then map
-      const char* max_limit_str = msOWSLookupMetadata(&(layer->metadata), "A", "max_limit");
-      if(max_limit_str == nullptr)
-          max_limit_str = msOWSLookupMetadata(&(map->web.metadata), "A", "max_limit");
-      const int max_limit = max_limit_str ? atoi(max_limit_str) : OGCAPI_MAX_LIMIT;
-      const int default_limit = getDefaultLimit(map, layer);
-
-      json items_get = {
-          { "summary", std::string("Get ") + getCollectionTitle(layer) + " items" },
-          { "description", getCollectionDescription(layer) },
-          { "tags", { layer->name } },
-          { "operationId", "get" + std::string(layer->name) + "Features" },
-          { "parameters", {
-              {{ "$ref", "#/components/parameters/f"}},
-              {{ "$ref", oapif_yaml_url + "#/components/parameters/bbox"}},
-              {{ "$ref", oapif_yaml_url + "#/components/parameters/datetime"}},
-              {{ "$ref", "#/components/parameters/offset"}},
-          }},
-          { "responses", {
-              { "200", {{"$ref", oapif_yaml_url + "#/components/responses/Features"}} },
-              { "400", {{"$ref", oapif_yaml_url + "#/components/responses/InvalidParameter"}} },
-              { "500", {{"$ref", oapif_yaml_url + "#/components/responses/ServerError"}} }
-          }}
-      };
-
-      json param_limit = {
-        { "name", "limit"},
-        { "in", "query"},
-        { "description", "The optional limit parameter limits the number of items that are presented in the response document."},
-        { "required", false},
-        { "schema", {
-            { "type", "integer"},
-            { "minimum", 1},
-            { "maximum", max_limit},
-            { "default", default_limit},
-        }},
-        { "style", "form" },
-        { "explode", false },
-      };
-      items_get["parameters"].emplace_back(param_limit);
-
-      std::string itemsPath(collectionNamePath + "/items");
-      paths[itemsPath]["get"] = items_get;
-
-      json feature_id_get = {
-          { "summary", std::string("Get ") + getCollectionTitle(layer) + " item by id" },
-          { "description", getCollectionDescription(layer) },
-          { "tags", { layer->name } },
-          { "operationId", "get" + std::string(layer->name) + "Feature" },
-          { "parameters", {
-              {{ "$ref", "#/components/parameters/f"}},
-              {{ "$ref", oapif_yaml_url + "#/components/parameters/featureId"}},
-          }},
-          { "responses", {
-              { "200", {{"$ref", oapif_yaml_url + "#/components/responses/Feature"}} },
-              { "400", {{"$ref", oapif_yaml_url + "#/components/responses/InvalidParameter"}} },
-              { "404", {{"$ref", oapif_yaml_url + "#/components/responses/NotFound"}} },
-              { "500", {{"$ref", oapif_yaml_url + "#/components/responses/ServerError"}} }
-          }}
-      };
-      std::string itemsFeatureIdPath(collectionNamePath + "/items/{featureId}");
-      paths[itemsFeatureIdPath]["get"] = feature_id_get;
+    json feature_id_get = {
+        {"summary",
+         std::string("Get ") + getCollectionTitle(layer) + " item by id"},
+        {"description", getCollectionDescription(layer)},
+        {"tags", {layer->name}},
+        {"operationId", "get" + std::string(layer->name) + "Feature"},
+        {"parameters",
+         {
+             {{"$ref", "#/components/parameters/f"}},
+             {{"$ref", oapif_yaml_url + "#/components/parameters/featureId"}},
+         }},
+        {"responses",
+         {{"200",
+           {{"$ref", oapif_yaml_url + "#/components/responses/Feature"}}},
+          {"400",
+           {{"$ref",
+             oapif_yaml_url + "#/components/responses/InvalidParameter"}}},
+          {"404",
+           {{"$ref", oapif_yaml_url + "#/components/responses/NotFound"}}},
+          {"500",
+           {{"$ref",
+             oapif_yaml_url + "#/components/responses/ServerError"}}}}}};
+    std::string itemsFeatureIdPath(collectionNamePath + "/items/{featureId}");
+    paths[itemsFeatureIdPath]["get"] = feature_id_get;
   }
 
   response["paths"] = paths;
 
   json components;
-  components["responses"]["200"] = {
-      { "description", "successful operation" }
-  };
+  components["responses"]["200"] = {{"description", "successful operation"}};
   components["responses"]["default"] = {
-      { "description", "unexpected error" },
-      { "content", {
-          { "application/json", {
-              { "schema", {
-                  { "$ref", "https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/schemas/exception.yaml" }
-              }}
-          }}
-      }}
-  };
+      {"description", "unexpected error"},
+      {"content",
+       {{"application/json",
+         {{"schema",
+           {{"$ref", "https://raw.githubusercontent.com/opengeospatial/"
+                     "ogcapi-processes/master/core/openapi/schemas/"
+                     "exception.yaml"}}}}}}}};
 
   json parameters;
   parameters["f"] = {
-    { "name", "f"},
-    { "in", "query"},
-    { "description", "The optional f parameter indicates the output format which the server shall provide as part of the response document.  The default format is GeoJSON."},
-    { "required", false},
-    { "schema", {
-        { "type", "string"},
-            {"enum", {"json", "html"}},
-            {"default", "json"}
-    }},
-    { "style", "form" },
-    { "explode", false },
+      {"name", "f"},
+      {"in", "query"},
+      {"description", "The optional f parameter indicates the output format "
+                      "which the server shall provide as part of the response "
+                      "document.  The default format is GeoJSON."},
+      {"required", false},
+      {"schema",
+       {{"type", "string"}, {"enum", {"json", "html"}}, {"default", "json"}}},
+      {"style", "form"},
+      {"explode", false},
   };
 
   parameters["offset"] = {
-    { "name", "offset"},
-    { "in", "query"},
-    { "description", "The optional offset parameter indicates the index within the result set from which the server shall begin presenting results in the response document.  The first element has an index of 0 (default)."},
-    { "required", false},
-    { "schema", {
-        { "type", "integer"},
-        { "minimum", 0},
-        { "default", 0},
-    }},
-    { "style", "form" },
-    { "explode", false },
+      {"name", "offset"},
+      {"in", "query"},
+      {"description",
+       "The optional offset parameter indicates the index within the result "
+       "set from which the server shall begin presenting results in the "
+       "response document.  The first element has an index of 0 (default)."},
+      {"required", false},
+      {"schema",
+       {
+           {"type", "integer"},
+           {"minimum", 0},
+           {"default", 0},
+       }},
+      {"style", "form"},
+      {"explode", false},
   };
 
   components["parameters"] = parameters;
@@ -1623,21 +1678,22 @@ static int processApiRequest(mapObj *map
   // TODO: "tags" array ?
 
   outputResponse(map, request,
-                 format == OGCAPIFormat::JSON ? OGCAPIFormat::OpenAPI_V3 : format,
+                 format == OGCAPIFormat::JSON ? OGCAPIFormat::OpenAPI_V3
+                                              : format,
                  OGCAPI_TEMPLATE_HTML_OPENAPI, response);
   return MS_SUCCESS;
 }
 
 #endif
 
-int msOGCAPIDispatchRequest(mapObj *map, cgiRequestObj *request)
-{
+int msOGCAPIDispatchRequest(mapObj *map, cgiRequestObj *request) {
 #ifdef USE_OGCAPI_SVR
 
   // make sure ogcapi requests are enabled for this map
   int status = msOWSRequestIsEnabled(map, NULL, "AO", "OGCAPI", MS_FALSE);
-  if(status != MS_TRUE) {
-    msSetError(MS_OGCAPIERR, "OGC API requests are not enabled.", "msCGIDispatchAPIRequest()");
+  if (status != MS_TRUE) {
+    msSetError(MS_OGCAPIERR, "OGC API requests are not enabled.",
+               "msCGIDispatchAPIRequest()");
     return MS_FAILURE; // let normal error handling take over
   }
 
@@ -1645,27 +1701,25 @@ int msOGCAPIDispatchRequest(mapObj *map,
   const char *p = getRequestParameter(request, "f");
 
   // if f= query parameter is not specified, use HTTP Accept header if available
-  if( p == nullptr )
-  {
-      const char* accept = getenv("HTTP_ACCEPT");
-      if( accept )
-      {
-          if( strcmp(accept, "*/*") == 0 )
-              p = OGCAPI_MIMETYPE_JSON;
-          else
-              p = accept;
-      }
+  if (p == nullptr) {
+    const char *accept = getenv("HTTP_ACCEPT");
+    if (accept) {
+      if (strcmp(accept, "*/*") == 0)
+        p = OGCAPI_MIMETYPE_JSON;
+      else
+        p = accept;
+    }
   }
 
-  if(p && (strcmp(p, "json") == 0 ||
-           strstr(p, OGCAPI_MIMETYPE_JSON) != nullptr ||
-           strstr(p, OGCAPI_MIMETYPE_GEOJSON) != nullptr ||
-           strstr(p, OGCAPI_MIMETYPE_OPENAPI_V3) != nullptr)) {
+  if (p &&
+      (strcmp(p, "json") == 0 || strstr(p, OGCAPI_MIMETYPE_JSON) != nullptr ||
+       strstr(p, OGCAPI_MIMETYPE_GEOJSON) != nullptr ||
+       strstr(p, OGCAPI_MIMETYPE_OPENAPI_V3) != nullptr)) {
     format = OGCAPIFormat::JSON;
-  } else if(p && (strcmp(p, "html") == 0 ||
-                  strstr(p, OGCAPI_MIMETYPE_HTML) != nullptr)) {
+  } else if (p && (strcmp(p, "html") == 0 ||
+                   strstr(p, OGCAPI_MIMETYPE_HTML) != nullptr)) {
     format = OGCAPIFormat::HTML;
-  } else if(p) {
+  } else if (p) {
     std::string errorMsg("Unsupported format requested: ");
     errorMsg += p;
     outputError(OGCAPI_PARAM_ERROR, errorMsg.c_str());
@@ -1674,47 +1728,57 @@ int msOGCAPIDispatchRequest(mapObj *map,
     format = OGCAPIFormat::HTML; // default for now
   }
 
-  if(request->api_path_length == 2) {
+  if (request->api_path_length == 2) {
 
     return processLandingRequest(map, request, format);
 
-  } else if(request->api_path_length == 3) {
+  } else if (request->api_path_length == 3) {
 
-    if(strcmp(request->api_path[2], "conformance") == 0) {
+    if (strcmp(request->api_path[2], "conformance") == 0) {
       return processConformanceRequest(map, request, format);
-    } else if(strcmp(request->api_path[2], "conformance.html") == 0) {
+    } else if (strcmp(request->api_path[2], "conformance.html") == 0) {
       return processConformanceRequest(map, request, OGCAPIFormat::HTML);
-    } else if(strcmp(request->api_path[2], "collections") == 0) {
+    } else if (strcmp(request->api_path[2], "collections") == 0) {
       return processCollectionsRequest(map, request, format);
-    } else if(strcmp(request->api_path[2], "collections.html") == 0) {
+    } else if (strcmp(request->api_path[2], "collections.html") == 0) {
       return processCollectionsRequest(map, request, OGCAPIFormat::HTML);
-    } else if(strcmp(request->api_path[2], "api") == 0) {
+    } else if (strcmp(request->api_path[2], "api") == 0) {
       return processApiRequest(map, request, format);
     }
 
-  } else if(request->api_path_length == 4) {
+  } else if (request->api_path_length == 4) {
 
-    if(strcmp(request->api_path[2], "collections") == 0) { // next argument (3) is collectionId
-      return processCollectionRequest(map, request, request->api_path[3], format);
+    if (strcmp(request->api_path[2], "collections") ==
+        0) { // next argument (3) is collectionId
+      return processCollectionRequest(map, request, request->api_path[3],
+                                      format);
     }
 
-  } else if(request->api_path_length == 5) {
+  } else if (request->api_path_length == 5) {
 
-    if(strcmp(request->api_path[2], "collections") == 0 && strcmp(request->api_path[4], "items") == 0)  { // middle argument (3) is the collectionId
-      return processCollectionItemsRequest(map, request, request->api_path[3], NULL, format);
+    if (strcmp(request->api_path[2], "collections") == 0 &&
+        strcmp(request->api_path[4], "items") ==
+            0) { // middle argument (3) is the collectionId
+      return processCollectionItemsRequest(map, request, request->api_path[3],
+                                           NULL, format);
     }
 
-  } else if(request->api_path_length == 6) {
+  } else if (request->api_path_length == 6) {
 
-    if(strcmp(request->api_path[2], "collections") == 0 && strcmp(request->api_path[4], "items") == 0)  { // middle argument (3) is the collectionId, last argument (5) is featureId
-      return processCollectionItemsRequest(map, request, request->api_path[3], request->api_path[5], format);
+    if (strcmp(request->api_path[2], "collections") == 0 &&
+        strcmp(request->api_path[4], "items") ==
+            0) { // middle argument (3) is the collectionId, last argument (5)
+                 // is featureId
+      return processCollectionItemsRequest(map, request, request->api_path[3],
+                                           request->api_path[5], format);
     }
   }
 
   outputError(OGCAPI_NOT_FOUND_ERROR, "Invalid API path.");
   return MS_SUCCESS; // avoid any downstream MapServer processing
 #else
-  msSetError(MS_OGCAPIERR, "OGC API server support is not enabled.", "msOGCAPIDispatchRequest()");
+  msSetError(MS_OGCAPIERR, "OGC API server support is not enabled.",
+             "msOGCAPIDispatchRequest()");
   return MS_FAILURE;
 #endif
 }
diff -pruN 8.0.1-5/mapogcapi.h 8.0.2-1/mapogcapi.h
--- 8.0.1-5/mapogcapi.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapogcapi.h	2024-06-11 20:41:34.000000000 +0000
@@ -6,7 +6,7 @@
  * Author:   Steve Lime and the MapServer team.
  *
  **********************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota. 
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
  *
  * Permission is hereby granted, free of charge, to any person obtaining a
  * copy of this software and associated documentation files (the "Software"),
@@ -29,13 +29,13 @@
 #ifndef MAPOGCAPI_H
 #define MAPOGCAPI_H
 
-#ifdef  __cplusplus
+#ifdef __cplusplus
 extern "C" {
 #endif
 
 int msOGCAPIDispatchRequest(mapObj *map, cgiRequestObj *request);
 
-#ifdef  __cplusplus
+#ifdef __cplusplus
 }
 #endif
 
diff -pruN 8.0.1-5/mapogcfilter.cpp 8.0.2-1/mapogcfilter.cpp
--- 8.0.1-5/mapogcfilter.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapogcfilter.cpp	2024-06-11 20:41:34.000000000 +0000
@@ -43,25 +43,26 @@ static int FLTHasUniqueTopLevelDuringFil
 #endif
 
 #if !(defined(_WIN32) && !defined(__CYGWIN__))
-static inline void IGUR_double(double ignored) { (void)ignored; }  /* Ignore GCC Unused Result */
+static inline void IGUR_double(double ignored) {
+  (void)ignored;
+} /* Ignore GCC Unused Result */
 #endif
 
-int FLTIsNumeric(const char *pszValue)
-{
+int FLTIsNumeric(const char *pszValue) {
   if (pszValue != NULL && *pszValue != '\0' && !isspace(*pszValue)) {
     /*the regex seems to have a problem on windows when mapserver is built using
       PHP regex*/
 #if defined(_WIN32) && !defined(__CYGWIN__)
-    int i = 0, nLength=0, bString=0;
+    int i = 0, nLength = 0, bString = 0;
 
     nLength = strlen(pszValue);
-    for (i=0; i<nLength; i++) {
+    for (i = 0; i < nLength; i++) {
       if (i == 0) {
-        if (!isdigit(pszValue[i]) &&  pszValue[i] != '-') {
+        if (!isdigit(pszValue[i]) && pszValue[i] != '-') {
           bString = 1;
           break;
         }
-      } else if (!isdigit(pszValue[i]) &&  pszValue[i] != '.') {
+      } else if (!isdigit(pszValue[i]) && pszValue[i] != '.') {
         bString = 1;
         break;
       }
@@ -69,9 +70,10 @@ int FLTIsNumeric(const char *pszValue)
     if (!bString)
       return MS_TRUE;
 #else
-    char * p;
+    char *p;
     IGUR_double(strtod(pszValue, &p));
-    if ( p != pszValue && *p == '\0') return MS_TRUE;
+    if (p != pszValue && *p == '\0')
+      return MS_TRUE;
 #endif
   }
 
@@ -82,26 +84,27 @@ int FLTIsNumeric(const char *pszValue)
 ** Apply an expression to the layer's filter element.
 **
 */
-int FLTApplyExpressionToLayer(layerObj *lp, const char *pszExpression)
-{
-  char *pszFinalExpression=NULL, *pszBuffer = NULL;
+int FLTApplyExpressionToLayer(layerObj *lp, const char *pszExpression) {
+  char *pszFinalExpression = NULL, *pszBuffer = NULL;
   /*char *escapedTextString=NULL;*/
-  int bConcatWhere=0, bHasAWhere=0;
+  int bConcatWhere = 0, bHasAWhere = 0;
 
   if (lp && pszExpression) {
-    if (lp->connectiontype == MS_POSTGIS || lp->connectiontype ==  MS_ORACLESPATIAL ||
+    if (lp->connectiontype == MS_POSTGIS ||
+        lp->connectiontype == MS_ORACLESPATIAL ||
         lp->connectiontype == MS_PLUGIN) {
       pszFinalExpression = msStrdup("(");
-      pszFinalExpression = msStringConcatenate(pszFinalExpression, pszExpression);
+      pszFinalExpression =
+          msStringConcatenate(pszFinalExpression, pszExpression);
       pszFinalExpression = msStringConcatenate(pszFinalExpression, ")");
     } else if (lp->connectiontype == MS_OGR) {
       pszFinalExpression = msStrdup(pszExpression);
       if (lp->filter.type != MS_EXPRESSION) {
         bConcatWhere = 1;
       } else {
-        if (lp->filter.string && EQUALN(lp->filter.string,"WHERE ",6)) {
+        if (lp->filter.string && EQUALN(lp->filter.string, "WHERE ", 6)) {
           bHasAWhere = 1;
-          bConcatWhere =1;
+          bConcatWhere = 1;
         }
       }
 
@@ -115,7 +118,7 @@ int FLTApplyExpressionToLayer(layerObj *
     if (lp->filter.string && lp->filter.type == MS_EXPRESSION) {
       pszBuffer = msStringConcatenate(pszBuffer, "((");
       if (bHasAWhere)
-        pszBuffer = msStringConcatenate(pszBuffer, lp->filter.string+6);
+        pszBuffer = msStringConcatenate(pszBuffer, lp->filter.string + 6);
       else
         pszBuffer = msStringConcatenate(pszBuffer, lp->filter.string);
       pszBuffer = msStringConcatenate(pszBuffer, ") and ");
@@ -124,7 +127,7 @@ int FLTApplyExpressionToLayer(layerObj *
 
     pszBuffer = msStringConcatenate(pszBuffer, pszFinalExpression);
 
-    if(lp->filter.string && lp->filter.type == MS_EXPRESSION)
+    if (lp->filter.string && lp->filter.type == MS_EXPRESSION)
       pszBuffer = msStringConcatenate(pszBuffer, ")");
 
     /*assuming that expression was properly escaped
@@ -135,7 +138,6 @@ int FLTApplyExpressionToLayer(layerObj *
     */
     msLoadExpressionString(&lp->filter, pszBuffer);
 
-
     msFree(pszFinalExpression);
 
     if (pszBuffer)
@@ -147,26 +149,26 @@ int FLTApplyExpressionToLayer(layerObj *
   return MS_FALSE;
 }
 
-char *FLTGetExpressionForValuesRanges(layerObj *lp, const char *item, const char *value,  int forcecharcter)
-{
+char *FLTGetExpressionForValuesRanges(layerObj *lp, const char *item,
+                                      const char *value, int forcecharcter) {
   int bIscharacter;
-  char *pszExpression = NULL, *pszEscapedStr=NULL, *pszTmpExpression=NULL;
-  char **paszElements = NULL, **papszRangeElements=NULL;
-  int numelements,i,nrangeelements;
+  char *pszExpression = NULL, *pszEscapedStr = NULL, *pszTmpExpression = NULL;
+  char **paszElements = NULL, **papszRangeElements = NULL;
+  int numelements, i, nrangeelements;
 
   /* double minval, maxval; */
   if (lp && item && value) {
     if (strstr(value, "/") == NULL) {
       /*value(s)*/
-      paszElements = msStringSplit (value, ',', &numelements);
+      paszElements = msStringSplit(value, ',', &numelements);
       if (paszElements && numelements > 0) {
         if (forcecharcter)
           bIscharacter = MS_TRUE;
         else
-          bIscharacter= !FLTIsNumeric(paszElements[0]);
+          bIscharacter = !FLTIsNumeric(paszElements[0]);
 
         pszTmpExpression = msStringConcatenate(pszTmpExpression, "(");
-        for (i=0; i<numelements; i++) {
+        for (i = 0; i < numelements; i++) {
           pszTmpExpression = msStringConcatenate(pszTmpExpression, "(");
           {
             if (bIscharacter)
@@ -178,25 +180,26 @@ char *FLTGetExpressionForValuesRanges(la
               pszTmpExpression = msStringConcatenate(pszTmpExpression, "\"");
           }
           if (bIscharacter) {
-              pszTmpExpression = msStringConcatenate(pszTmpExpression, " = \"");
+            pszTmpExpression = msStringConcatenate(pszTmpExpression, " = \"");
           } else
             pszTmpExpression = msStringConcatenate(pszTmpExpression, " = ");
 
           pszEscapedStr = msLayerEscapeSQLParam(lp, paszElements[i]);
-          pszTmpExpression = msStringConcatenate(pszTmpExpression, pszEscapedStr);
+          pszTmpExpression =
+              msStringConcatenate(pszTmpExpression, pszEscapedStr);
 
           if (bIscharacter) {
-              pszTmpExpression = msStringConcatenate(pszTmpExpression, "\"");
+            pszTmpExpression = msStringConcatenate(pszTmpExpression, "\"");
           }
           pszTmpExpression = msStringConcatenate(pszTmpExpression, ")");
 
           msFree(pszEscapedStr);
-          pszEscapedStr=NULL;
+          pszEscapedStr = NULL;
 
           if (pszExpression != NULL)
             pszExpression = msStringConcatenate(pszExpression, " OR ");
 
-          pszExpression =  msStringConcatenate(pszExpression, pszTmpExpression);
+          pszExpression = msStringConcatenate(pszExpression, pszTmpExpression);
 
           msFree(pszTmpExpression);
           pszTmpExpression = NULL;
@@ -206,11 +209,12 @@ char *FLTGetExpressionForValuesRanges(la
       msFreeCharArray(paszElements, numelements);
     } else {
       /*range(s)*/
-      paszElements = msStringSplit (value, ',', &numelements);
+      paszElements = msStringSplit(value, ',', &numelements);
       if (paszElements && numelements > 0) {
         pszTmpExpression = msStringConcatenate(pszTmpExpression, "(");
-        for (i=0; i<numelements; i++) {
-          papszRangeElements = msStringSplit (paszElements[i], '/', &nrangeelements);
+        for (i = 0; i < numelements; i++) {
+          papszRangeElements =
+              msStringSplit(paszElements[i], '/', &nrangeelements);
           if (papszRangeElements && nrangeelements > 0) {
             pszTmpExpression = msStringConcatenate(pszTmpExpression, "(");
             if (nrangeelements == 2 || nrangeelements == 3) {
@@ -227,9 +231,10 @@ char *FLTGetExpressionForValuesRanges(la
               pszTmpExpression = msStringConcatenate(pszTmpExpression, " >= ");
 
               pszEscapedStr = msLayerEscapeSQLParam(lp, papszRangeElements[0]);
-              pszTmpExpression = msStringConcatenate(pszTmpExpression, pszEscapedStr);
+              pszTmpExpression =
+                  msStringConcatenate(pszTmpExpression, pszEscapedStr);
               msFree(pszEscapedStr);
-              pszEscapedStr=NULL;
+              pszEscapedStr = NULL;
 
               pszTmpExpression = msStringConcatenate(pszTmpExpression, " AND ");
 
@@ -242,9 +247,10 @@ char *FLTGetExpressionForValuesRanges(la
               pszTmpExpression = msStringConcatenate(pszTmpExpression, " <= ");
 
               pszEscapedStr = msLayerEscapeSQLParam(lp, papszRangeElements[1]);
-              pszTmpExpression = msStringConcatenate(pszTmpExpression, pszEscapedStr);
+              pszTmpExpression =
+                  msStringConcatenate(pszTmpExpression, pszEscapedStr);
               msFree(pszEscapedStr);
-              pszEscapedStr=NULL;
+              pszEscapedStr = NULL;
 
               pszTmpExpression = msStringConcatenate(pszTmpExpression, ")");
             } else if (nrangeelements == 1) {
@@ -258,9 +264,10 @@ char *FLTGetExpressionForValuesRanges(la
               pszTmpExpression = msStringConcatenate(pszTmpExpression, " = ");
 
               pszEscapedStr = msLayerEscapeSQLParam(lp, papszRangeElements[0]);
-              pszTmpExpression = msStringConcatenate(pszTmpExpression, pszEscapedStr);
+              pszTmpExpression =
+                  msStringConcatenate(pszTmpExpression, pszEscapedStr);
               msFree(pszEscapedStr);
-              pszEscapedStr=NULL;
+              pszEscapedStr = NULL;
 
               pszTmpExpression = msStringConcatenate(pszTmpExpression, ")");
             }
@@ -268,10 +275,10 @@ char *FLTGetExpressionForValuesRanges(la
             if (pszExpression != NULL)
               pszExpression = msStringConcatenate(pszExpression, " OR ");
 
-            pszExpression =  msStringConcatenate(pszExpression, pszTmpExpression);
+            pszExpression =
+                msStringConcatenate(pszExpression, pszTmpExpression);
             msFree(pszTmpExpression);
             pszTmpExpression = NULL;
-
           }
           msFreeCharArray(papszRangeElements, nrangeelements);
         }
@@ -285,21 +292,19 @@ char *FLTGetExpressionForValuesRanges(la
 }
 
 int FLTogrConvertGeometry(OGRGeometryH hGeometry, shapeObj *psShape,
-                          OGRwkbGeometryType nType)
-{
+                          OGRwkbGeometryType nType) {
   return msOGRGeometryToShape(hGeometry, psShape, nType);
 }
 
-static
-int FLTShapeFromGMLTree(CPLXMLNode *psTree, shapeObj *psShape , char **ppszSRS)
-{
+static int FLTShapeFromGMLTree(CPLXMLNode *psTree, shapeObj *psShape,
+                               char **ppszSRS) {
   const char *pszSRS = NULL;
   if (psTree && psShape) {
     CPLXMLNode *psNext = psTree->psNext;
     OGRGeometryH hGeometry = NULL;
 
     psTree->psNext = NULL;
-    hGeometry = OGR_G_CreateFromGMLTree(psTree );
+    hGeometry = OGR_G_CreateFromGMLTree(psTree);
     psTree->psNext = psNext;
 
     if (hGeometry) {
@@ -309,7 +314,7 @@ int FLTShapeFromGMLTree(CPLXMLNode *psTr
         nType = wkbPolygon;
       else if (nType == wkbLineString25D || nType == wkbMultiLineString25D)
         nType = wkbLineString;
-      else if (nType == wkbPoint25D  || nType ==  wkbMultiPoint25D)
+      else if (nType == wkbPoint25D || nType == wkbMultiPoint25D)
         nType = wkbPoint;
       FLTogrConvertGeometry(hGeometry, psShape, nType);
 
@@ -326,8 +331,7 @@ int FLTShapeFromGMLTree(CPLXMLNode *psTr
   return MS_FALSE;
 }
 
-int FLTGetGeosOperator(char *pszValue)
-{
+int FLTGetGeosOperator(char *pszValue) {
   if (!pszValue)
     return -1;
 
@@ -356,8 +360,7 @@ int FLTGetGeosOperator(char *pszValue)
   return -1;
 }
 
-int FLTIsGeosNode(char *pszValue)
-{
+int FLTIsGeosNode(char *pszValue) {
   if (FLTGetGeosOperator(pszValue) == -1)
     return MS_FALSE;
 
@@ -369,8 +372,7 @@ int FLTIsGeosNode(char *pszValue)
 /*                                                                      */
 /*      Filter encoding with only attribute queries                     */
 /************************************************************************/
-int FLTIsSimpleFilterNoSpatial(FilterEncodingNode *psNode)
-{
+int FLTIsSimpleFilterNoSpatial(FilterEncodingNode *psNode) {
   if (FLTIsSimpleFilter(psNode) && FLTNumberOfFilterType(psNode, "BBOX") == 0)
     return MS_TRUE;
 
@@ -381,8 +383,8 @@ int FLTIsSimpleFilterNoSpatial(FilterEnc
 /*                      FLTApplySimpleSQLFilter()                       */
 /************************************************************************/
 
-int FLTApplySimpleSQLFilter(FilterEncodingNode *psNode, mapObj *map, int iLayerIndex)
-{
+int FLTApplySimpleSQLFilter(FilterEncodingNode *psNode, mapObj *map,
+                            int iLayerIndex) {
   layerObj *lp = NULL;
   char *szExpression = NULL;
   rectObj sQueryRect = map->extent;
@@ -390,34 +392,37 @@ int FLTApplySimpleSQLFilter(FilterEncodi
   projectionObj sProjTmp;
   char *pszBuffer = NULL;
   int bConcatWhere = 0;
-  int bHasAWhere =0;
+  int bHasAWhere = 0;
   char *pszTmp = NULL, *pszTmp2 = NULL;
   char *tmpfilename = NULL;
-  const char* pszTimeField = NULL;
-  const char* pszTimeValue = NULL;
+  const char *pszTimeField = NULL;
+  const char *pszTimeValue = NULL;
 
   lp = (GET_LAYER(map, iLayerIndex));
 
   /* if there is a bbox use it */
   szEPSG = FLTGetBBOX(psNode, &sQueryRect);
-  if(szEPSG && map->projection.numargs > 0) {
+  if (szEPSG && map->projection.numargs > 0) {
     msInitProjection(&sProjTmp);
     msProjectionInheritContextFrom(&sProjTmp, &map->projection);
-    /* Use the non EPSG variant since axis swapping is done in FLTDoAxisSwappingIfNecessary */
+    /* Use the non EPSG variant since axis swapping is done in
+     * FLTDoAxisSwappingIfNecessary */
     if (msLoadProjectionString(&sProjTmp, szEPSG) == 0) {
       msProjectRect(&sProjTmp, &map->projection, &sQueryRect);
     }
     msFreeProjection(&sProjTmp);
   }
-  
-  if( lp->connectiontype == MS_OGR ) {
+
+  if (lp->connectiontype == MS_OGR) {
     pszTimeValue = FLTGetDuring(psNode, &pszTimeField);
   }
 
   /* make sure that the layer can be queried*/
-  if (!lp->_template) lp->_template = msStrdup("ttt.html");
+  if (!lp->_template)
+    lp->_template = msStrdup("ttt.html");
 
-  /* if there is no class, create at least one, so that query by rect would work */
+  /* if there is no class, create at least one, so that query by rect would work
+   */
   if (lp->numclasses == 0) {
     if (msGrowLayerClasses(lp) == NULL)
       return MS_FAILURE;
@@ -426,7 +431,8 @@ int FLTApplySimpleSQLFilter(FilterEncodi
 
   bConcatWhere = 0;
   bHasAWhere = 0;
-  if (lp->connectiontype == MS_POSTGIS || lp->connectiontype ==  MS_ORACLESPATIAL ||
+  if (lp->connectiontype == MS_POSTGIS ||
+      lp->connectiontype == MS_ORACLESPATIAL ||
       lp->connectiontype == MS_PLUGIN) {
     szExpression = FLTGetSQLExpression(psNode, lp);
     if (szExpression) {
@@ -440,24 +446,23 @@ int FLTApplySimpleSQLFilter(FilterEncodi
   /* concatenates the WHERE clause for OGR layers. This only applies if
      the expression was empty or not of an expression string. If there
      is an sql type expression, it is assumed to have the WHERE clause.
-     If it is an expression and does not have a WHERE it is assumed to be a mapserver
-     type expression*/
+     If it is an expression and does not have a WHERE it is assumed to be a
+     mapserver type expression*/
   else if (lp->connectiontype == MS_OGR) {
     if (lp->filter.type != MS_EXPRESSION) {
       szExpression = FLTGetSQLExpression(psNode, lp);
       bConcatWhere = 1;
     } else {
-      if (lp->filter.string && EQUALN(lp->filter.string,"WHERE ",6)) {
+      if (lp->filter.string && EQUALN(lp->filter.string, "WHERE ", 6)) {
         szExpression = FLTGetSQLExpression(psNode, lp);
         bHasAWhere = 1;
-        bConcatWhere =1;
+        bConcatWhere = 1;
       } else {
         szExpression = FLTGetCommonExpression(psNode, lp);
       }
     }
   } else {
     szExpression = FLTGetCommonExpression(psNode, lp);
-
   }
 
   if (szExpression) {
@@ -469,7 +474,7 @@ int FLTApplySimpleSQLFilter(FilterEncodi
     if (lp->filter.string && lp->filter.type == MS_EXPRESSION) {
       pszBuffer = msStringConcatenate(pszBuffer, "((");
       if (bHasAWhere)
-        pszBuffer = msStringConcatenate(pszBuffer, lp->filter.string+6);
+        pszBuffer = msStringConcatenate(pszBuffer, lp->filter.string + 6);
       else
         pszBuffer = msStringConcatenate(pszBuffer, lp->filter.string);
       pszBuffer = msStringConcatenate(pszBuffer, ") and ");
@@ -478,15 +483,15 @@ int FLTApplySimpleSQLFilter(FilterEncodi
 
     pszBuffer = msStringConcatenate(pszBuffer, szExpression);
 
-    if(lp->filter.string && lp->filter.type == MS_EXPRESSION)
+    if (lp->filter.string && lp->filter.type == MS_EXPRESSION)
       pszBuffer = msStringConcatenate(pszBuffer, ")");
 
     msLoadExpressionString(&lp->filter, pszBuffer);
     free(szExpression);
   }
-  
+
   if (pszTimeField && pszTimeValue)
-      msLayerSetTimeFilter(lp, pszTimeValue, pszTimeField);
+    msLayerSetTimeFilter(lp, pszTimeValue, pszTimeField);
 
   if (pszBuffer)
     free(pszBuffer);
@@ -496,23 +501,27 @@ int FLTApplySimpleSQLFilter(FilterEncodi
   map->query.layer = lp->index;
   map->query.rect = sQueryRect;
 
-  if(map->debug == MS_DEBUGLEVEL_VVV) {
+  if (map->debug == MS_DEBUGLEVEL_VVV) {
     tmpfilename = msTmpFile(map, map->mappath, NULL, "_filter.map");
     if (tmpfilename == NULL) {
-      tmpfilename = msTmpFile(map, NULL, NULL, "_filter.map" );
+      tmpfilename = msTmpFile(map, NULL, NULL, "_filter.map");
     }
     if (tmpfilename) {
-      msSaveMap(map,tmpfilename);
-      msDebug("FLTApplySimpleSQLFilter(): Map file after Filter was applied %s\n", tmpfilename);
+      msSaveMap(map, tmpfilename);
+      msDebug(
+          "FLTApplySimpleSQLFilter(): Map file after Filter was applied %s\n",
+          tmpfilename);
       msFree(tmpfilename);
     }
   }
 
-  /*for oracle connection, if we have a simple filter with no spatial constraints
-    we should set the connection function to NONE to have a better performance
+  /*for oracle connection, if we have a simple filter with no spatial
+    constraints we should set the connection function to NONE to have a better
+    performance
     (#2725)*/
 
-  if (lp->connectiontype ==  MS_ORACLESPATIAL && FLTIsSimpleFilterNoSpatial(psNode)) {
+  if (lp->connectiontype == MS_ORACLESPATIAL &&
+      FLTIsSimpleFilterNoSpatial(psNode)) {
     if (strcasestr(lp->data, "USING") == 0)
       lp->data = msStringConcatenate(lp->data, " USING NONE");
     else if (strcasestr(lp->data, "NONE") == 0) {
@@ -552,74 +561,66 @@ int FLTApplySimpleSQLFilter(FilterEncodi
 /*                                                                      */
 /*    Split filters separated by parentheses into an array of strings.  */
 /************************************************************************/
-char** FLTSplitFilters(const char* pszStr, int* pnTokens)
-{
-    const char* pszTokenBegin;
-    char** papszRet = NULL;
-    int nTokens = 0;
-    char chStringQuote = '\0';
-    int nXMLIndent = 0;
-    int bInBracket = FALSE;
-
-    if( *pszStr != '(' )
-    {
-        *pnTokens = 0;
-        return NULL;
-    }
-    pszStr ++;
-    pszTokenBegin = pszStr;
-    while( *pszStr != '\0' )
-    {
-        /* Ignore any character until end of quoted string */
-        if( chStringQuote != '\0' )
-        {
-            if( *pszStr == chStringQuote )
-                chStringQuote = 0;
-        }
-        /* Detect begin of quoted string only for an XML attribute, i.e. between < and > */
-        else if( bInBracket && (*pszStr == '\'' || *pszStr == '"') )
-        {
-            chStringQuote = *pszStr;
-        }
-        /* Begin of XML element */
-        else if( *pszStr == '<' )
-        {
-            bInBracket = TRUE;
-            if( pszStr[1] == '/' )
-                nXMLIndent --;
-            else if( pszStr[1] != '!' )
-                nXMLIndent ++;
-        }
-        /* <something /> case */
-        else if (*pszStr == '/' && pszStr[1] == '>' )
-        {
-            bInBracket = FALSE;
-            nXMLIndent --;
-            pszStr ++;
-        }
-        /* End of XML element */
-        else if( *pszStr == '>' )
-        {
-            bInBracket = FALSE;
-        }
-        /* Only detect and of filter when XML indentation goes back to zero */
-        else if( nXMLIndent == 0 && *pszStr == ')' )
-        {
-            papszRet = (char**) msSmallRealloc(papszRet, sizeof(char*) * (nTokens + 1));
-            papszRet[nTokens] = msStrdup(pszTokenBegin);
-            papszRet[nTokens][pszStr - pszTokenBegin] = '\0';
-            nTokens ++;
-            if( pszStr[1] != '(' )
-            {
-                break;
-            }
-            pszStr ++;
-            pszTokenBegin = pszStr + 1;
-        }
-        pszStr ++;
+char **FLTSplitFilters(const char *pszStr, int *pnTokens) {
+  const char *pszTokenBegin;
+  char **papszRet = NULL;
+  int nTokens = 0;
+  char chStringQuote = '\0';
+  int nXMLIndent = 0;
+  int bInBracket = FALSE;
+
+  if (*pszStr != '(') {
+    *pnTokens = 0;
+    return NULL;
+  }
+  pszStr++;
+  pszTokenBegin = pszStr;
+  while (*pszStr != '\0') {
+    /* Ignore any character until end of quoted string */
+    if (chStringQuote != '\0') {
+      if (*pszStr == chStringQuote)
+        chStringQuote = 0;
+    }
+    /* Detect begin of quoted string only for an XML attribute, i.e. between <
+       and > */
+    else if (bInBracket && (*pszStr == '\'' || *pszStr == '"')) {
+      chStringQuote = *pszStr;
+    }
+    /* Begin of XML element */
+    else if (*pszStr == '<') {
+      bInBracket = TRUE;
+      if (pszStr[1] == '/')
+        nXMLIndent--;
+      else if (pszStr[1] != '!')
+        nXMLIndent++;
+    }
+    /* <something /> case */
+    else if (*pszStr == '/' && pszStr[1] == '>') {
+      bInBracket = FALSE;
+      nXMLIndent--;
+      pszStr++;
+    }
+    /* End of XML element */
+    else if (*pszStr == '>') {
+      bInBracket = FALSE;
+    }
+    /* Only detect and of filter when XML indentation goes back to zero */
+    else if (nXMLIndent == 0 && *pszStr == ')') {
+      papszRet =
+          (char **)msSmallRealloc(papszRet, sizeof(char *) * (nTokens + 1));
+      papszRet[nTokens] = msStrdup(pszTokenBegin);
+      papszRet[nTokens][pszStr - pszTokenBegin] = '\0';
+      nTokens++;
+      if (pszStr[1] != '(') {
+        break;
+      }
+      pszStr++;
+      pszTokenBegin = pszStr + 1;
     }
-    *pnTokens = nTokens;
-    return papszRet;
+    pszStr++;
+  }
+  *pnTokens = nTokens;
+  return papszRet;
 }
 
 /************************************************************************/
@@ -627,8 +628,7 @@ char** FLTSplitFilters(const char* pszSt
 /*                                                                      */
 /*      Filter encoding with only attribute queries and only one bbox.  */
 /************************************************************************/
-int FLTIsSimpleFilter(FilterEncodingNode *psNode)
-{
+int FLTIsSimpleFilter(FilterEncodingNode *psNode) {
   if (FLTValidForBBoxFilter(psNode)) {
     if (FLTNumberOfFilterType(psNode, "DWithin") == 0 &&
         FLTNumberOfFilterType(psNode, "Intersect") == 0 &&
@@ -653,18 +653,18 @@ int FLTIsSimpleFilter(FilterEncodingNode
 /*      Use the filter encoding node to create mapserver expressions    */
 /*      and apply it to the layer.                                      */
 /************************************************************************/
-int FLTApplyFilterToLayer(FilterEncodingNode *psNode, mapObj *map, int iLayerIndex)
-{
+int FLTApplyFilterToLayer(FilterEncodingNode *psNode, mapObj *map,
+                          int iLayerIndex) {
   layerObj *layer = GET_LAYER(map, iLayerIndex);
 
-  if ( ! layer->vtable) {
-    int rv =  msInitializeVirtualTable(layer);
+  if (!layer->vtable) {
+    int rv = msInitializeVirtualTable(layer);
     if (rv != MS_SUCCESS)
       return rv;
   }
-  if( !layer->vtable )
-      return MS_FAILURE;
-  return layer->vtable->LayerApplyFilterToLayer(psNode, map,  iLayerIndex);
+  if (!layer->vtable)
+    return MS_FAILURE;
+  return layer->vtable->LayerApplyFilterToLayer(psNode, map, iLayerIndex);
 }
 
 /************************************************************************/
@@ -672,43 +672,38 @@ int FLTApplyFilterToLayer(FilterEncoding
 /*                                                                      */
 /* Helper function for layer virtual table architecture                 */
 /************************************************************************/
-int FLTLayerApplyCondSQLFilterToLayer(FilterEncodingNode *psNode, mapObj *map, int iLayerIndex)
-{
+int FLTLayerApplyCondSQLFilterToLayer(FilterEncodingNode *psNode, mapObj *map,
+                                      int iLayerIndex) {
   return FLTLayerApplyPlainFilterToLayer(psNode, map, iLayerIndex);
 }
 
-
 /************************************************************************/
 /*                           FLTGetTopBBOX                              */
 /*                                                                      */
 /* Return the "top" BBOX if there's a unique one.                       */
 /************************************************************************/
-static int FLTGetTopBBOXInternal(FilterEncodingNode *psNode, FilterEncodingNode** ppsTopBBOX, int *pnCount)
-{
+static int FLTGetTopBBOXInternal(FilterEncodingNode *psNode,
+                                 FilterEncodingNode **ppsTopBBOX,
+                                 int *pnCount) {
   if (psNode->pszValue && strcasecmp(psNode->pszValue, "BBOX") == 0) {
-    (*pnCount) ++;
-    if( *pnCount == 1 )
-    {
+    (*pnCount)++;
+    if (*pnCount == 1) {
       *ppsTopBBOX = psNode;
       return TRUE;
     }
     *ppsTopBBOX = NULL;
     return FALSE;
-  }
-  else if (psNode->pszValue && strcasecmp(psNode->pszValue, "AND") == 0) {
+  } else if (psNode->pszValue && strcasecmp(psNode->pszValue, "AND") == 0) {
     return FLTGetTopBBOXInternal(psNode->psLeftNode, ppsTopBBOX, pnCount) &&
            FLTGetTopBBOXInternal(psNode->psRightNode, ppsTopBBOX, pnCount);
-  }
-  else
-  {
+  } else {
     return TRUE;
   }
 }
 
-static FilterEncodingNode* FLTGetTopBBOX(FilterEncodingNode *psNode)
-{
+static FilterEncodingNode *FLTGetTopBBOX(FilterEncodingNode *psNode) {
   int nCount = 0;
-  FilterEncodingNode* psTopBBOX = NULL;
+  FilterEncodingNode *psTopBBOX = NULL;
   FLTGetTopBBOXInternal(psNode, &psTopBBOX, &nCount);
   return psTopBBOX;
 }
@@ -722,20 +717,18 @@ static FilterEncodingNode* FLTGetTopBBOX
 /*  they should not issue a spatial filter.                             */
 /************************************************************************/
 
-int FLTLayerSetInvalidRectIfSupported(layerObj* lp,
-                                      rectObj* rect)
-{
-    const char* pszUseDefaultExtent = msOWSLookupMetadata(&(lp->metadata), "F",
-                                              "use_default_extent_for_getfeature");
-    if( pszUseDefaultExtent && !CSLTestBoolean(pszUseDefaultExtent) &&
-        (lp->connectiontype == MS_OGR ||
-        ((lp->connectiontype == MS_PLUGIN) && (strstr(lp->plugin_library,"msplugin_mssql2008") != NULL))) )
-    {
-        const rectObj rectInvalid = MS_INIT_INVALID_RECT;
-        *rect = rectInvalid;
-        return MS_TRUE;
-    }
-    return MS_FALSE;
+int FLTLayerSetInvalidRectIfSupported(layerObj *lp, rectObj *rect) {
+  const char *pszUseDefaultExtent = msOWSLookupMetadata(
+      &(lp->metadata), "F", "use_default_extent_for_getfeature");
+  if (pszUseDefaultExtent && !CSLTestBoolean(pszUseDefaultExtent) &&
+      (lp->connectiontype == MS_OGR ||
+       ((lp->connectiontype == MS_PLUGIN) &&
+        (strstr(lp->plugin_library, "msplugin_mssql2008") != NULL)))) {
+    const rectObj rectInvalid = MS_INIT_INVALID_RECT;
+    *rect = rectInvalid;
+    return MS_TRUE;
+  }
+  return MS_FALSE;
 }
 
 /************************************************************************/
@@ -744,38 +737,34 @@ int FLTLayerSetInvalidRectIfSupported(la
 /* Helper function for layer virtual table architecture                 */
 /************************************************************************/
 int FLTLayerApplyPlainFilterToLayer(FilterEncodingNode *psNode, mapObj *map,
-                                    int iLayerIndex)
-{
-  char *pszExpression  =NULL;
-  int status =MS_FALSE;
-  layerObj* lp = GET_LAYER(map, iLayerIndex);
+                                    int iLayerIndex) {
+  char *pszExpression = NULL;
+  int status = MS_FALSE;
+  layerObj *lp = GET_LAYER(map, iLayerIndex);
 
-  pszExpression = FLTGetCommonExpression(psNode,  lp);
+  pszExpression = FLTGetCommonExpression(psNode, lp);
   if (pszExpression) {
-    FilterEncodingNode* psTopBBOX;
+    FilterEncodingNode *psTopBBOX;
     rectObj rect = map->extent;
 
     FLTLayerSetInvalidRectIfSupported(lp, &rect);
 
     psTopBBOX = FLTGetTopBBOX(psNode);
-    if( psTopBBOX )
-    {
+    if (psTopBBOX) {
       int can_remove_expression = MS_TRUE;
-      const char* pszEPSG = FLTGetBBOX(psNode, &rect);
-      if(pszEPSG && map->projection.numargs > 0) {
+      const char *pszEPSG = FLTGetBBOX(psNode, &rect);
+      if (pszEPSG && map->projection.numargs > 0) {
         projectionObj sProjTmp;
         msInitProjection(&sProjTmp);
         msProjectionInheritContextFrom(&sProjTmp, &map->projection);
-        /* Use the non EPSG variant since axis swapping is done in FLTDoAxisSwappingIfNecessary */
+        /* Use the non EPSG variant since axis swapping is done in
+         * FLTDoAxisSwappingIfNecessary */
         if (msLoadProjectionString(&sProjTmp, pszEPSG) == 0) {
           rectObj oldRect = rect;
           msProjectRect(&sProjTmp, &map->projection, &rect);
           /* If reprojection is involved, do not remove the expression */
-          if( rect.minx != oldRect.minx ||
-              rect.miny != oldRect.miny ||
-              rect.maxx != oldRect.maxx ||
-              rect.maxy != oldRect.maxy )
-          {
+          if (rect.minx != oldRect.minx || rect.miny != oldRect.miny ||
+              rect.maxx != oldRect.maxx || rect.maxy != oldRect.maxy) {
             can_remove_expression = MS_FALSE;
           }
         }
@@ -784,19 +773,21 @@ int FLTLayerApplyPlainFilterToLayer(Filt
 
       /* Small optimization: if the query is just a BBOX, then do a */
       /* msQueryByRect() */
-      if( psTopBBOX == psNode && can_remove_expression )
-      {
+      if (psTopBBOX == psNode && can_remove_expression) {
         msFree(pszExpression);
         pszExpression = NULL;
       }
     }
 
-    if(map->debug == MS_DEBUGLEVEL_VVV)
-    {
-      if( pszExpression )
-        msDebug("FLTLayerApplyPlainFilterToLayer(): %s, rect=%.15g,%.15g,%.15g,%.15g\n", pszExpression, rect.minx, rect.miny, rect.maxx, rect.maxy);
+    if (map->debug == MS_DEBUGLEVEL_VVV) {
+      if (pszExpression)
+        msDebug("FLTLayerApplyPlainFilterToLayer(): %s, "
+                "rect=%.15g,%.15g,%.15g,%.15g\n",
+                pszExpression, rect.minx, rect.miny, rect.maxx, rect.maxy);
       else
-        msDebug("FLTLayerApplyPlainFilterToLayer(): rect=%.15g,%.15g,%.15g,%.15g\n", rect.minx, rect.miny, rect.maxx, rect.maxy);
+        msDebug(
+            "FLTLayerApplyPlainFilterToLayer(): rect=%.15g,%.15g,%.15g,%.15g\n",
+            rect.minx, rect.miny, rect.maxx, rect.maxy);
     }
 
     status = FLTApplyFilterToLayerCommonExpressionWithRect(map, iLayerIndex,
@@ -807,8 +798,6 @@ int FLTLayerApplyPlainFilterToLayer(Filt
   return status;
 }
 
-
-
 /************************************************************************/
 /*            FilterNode *FLTPaserFilterEncoding(char *szXMLString)     */
 /*                                                                      */
@@ -819,9 +808,8 @@ int FLTLayerApplyPlainFilterToLayer(Filt
 /*      Calling function should use FreeFilterEncodingNode function     */
 /*      to free memeory.                                                */
 /************************************************************************/
-FilterEncodingNode *FLTParseFilterEncoding(const char *szXMLString)
-{
-  CPLXMLNode *psRoot = NULL, *psChild=NULL, *psFilter=NULL;
+FilterEncodingNode *FLTParseFilterEncoding(const char *szXMLString) {
+  CPLXMLNode *psRoot = NULL, *psChild = NULL, *psFilter = NULL;
   FilterEncodingNode *psFilterNode = NULL;
 
   if (szXMLString == NULL || strlen(szXMLString) == 0 ||
@@ -830,7 +818,7 @@ FilterEncodingNode *FLTParseFilterEncodi
 
   psRoot = CPLParseXMLString(szXMLString);
 
-  if( psRoot == NULL)
+  if (psRoot == NULL)
     return NULL;
 
   /* strip namespaces. We srtip all name spaces (#1350)*/
@@ -840,9 +828,8 @@ FilterEncodingNode *FLTParseFilterEncodi
   /*      get the root element (Filter).                                  */
   /* -------------------------------------------------------------------- */
   psFilter = CPLGetXMLNode(psRoot, "=Filter");
-  if (!psFilter)
-  {
-    CPLDestroyXMLNode( psRoot );
+  if (!psFilter) {
+    CPLDestroyXMLNode(psRoot);
     return NULL;
   }
 
@@ -856,7 +843,7 @@ FilterEncodingNode *FLTParseFilterEncodi
       psChild = psChild->psNext;
   }
 
-  CPLDestroyXMLNode( psRoot );
+  CPLDestroyXMLNode(psRoot);
 
   /* -------------------------------------------------------------------- */
   /*      validate the node tree to make sure that all the nodes are valid.*/
@@ -866,11 +853,9 @@ FilterEncodingNode *FLTParseFilterEncodi
     return NULL;
   }
 
-
   return psFilterNode;
 }
 
-
 /************************************************************************/
 /*      int FLTValidFilterNode(FilterEncodingNode *psFilterNode)        */
 /*                                                                      */
@@ -879,8 +864,7 @@ FilterEncodingNode *FLTParseFilterEncodi
 /*      could be incorrect if the filter string sent is corrupted       */
 /*      (eg missing a value :<PropertyName><PropertyName>)              */
 /************************************************************************/
-int FLTValidFilterNode(FilterEncodingNode *psFilterNode)
-{
+int FLTValidFilterNode(FilterEncodingNode *psFilterNode) {
   if (!psFilterNode)
     return 0;
 
@@ -902,11 +886,10 @@ int FLTValidFilterNode(FilterEncodingNod
 /*                       FLTIsGeometryFilterNodeType                    */
 /************************************************************************/
 
-static int FLTIsGeometryFilterNodeType(int eType)
-{
-    return (eType == FILTER_NODE_TYPE_GEOMETRY_POINT ||
-            eType == FILTER_NODE_TYPE_GEOMETRY_LINE ||
-            eType == FILTER_NODE_TYPE_GEOMETRY_POLYGON);
+static int FLTIsGeometryFilterNodeType(int eType) {
+  return (eType == FILTER_NODE_TYPE_GEOMETRY_POINT ||
+          eType == FILTER_NODE_TYPE_GEOMETRY_LINE ||
+          eType == FILTER_NODE_TYPE_GEOMETRY_POLYGON);
 }
 
 /************************************************************************/
@@ -914,8 +897,7 @@ static int FLTIsGeometryFilterNodeType(i
 /*                                                                      */
 /*      recursive freeing of Filter Encoding nodes.                      */
 /************************************************************************/
-void FLTFreeFilterEncodingNode(FilterEncodingNode *psFilterNode)
-{
+void FLTFreeFilterEncodingNode(FilterEncodingNode *psFilterNode) {
   if (psFilterNode) {
     if (psFilterNode->psLeftNode) {
       FLTFreeFilterEncodingNode(psFilterNode->psLeftNode);
@@ -927,46 +909,43 @@ void FLTFreeFilterEncodingNode(FilterEnc
     }
 
     if (psFilterNode->pszSRS)
-      free( psFilterNode->pszSRS);
+      free(psFilterNode->pszSRS);
 
-    if( psFilterNode->pOther ) {
+    if (psFilterNode->pOther) {
       if (psFilterNode->pszValue != NULL &&
           strcasecmp(psFilterNode->pszValue, "PropertyIsLike") == 0) {
-        FEPropertyIsLike* propIsLike = (FEPropertyIsLike *)psFilterNode->pOther;
-        if( propIsLike->pszWildCard )
-          free( propIsLike->pszWildCard );
-        if( propIsLike->pszSingleChar )
-          free( propIsLike->pszSingleChar );
-        if( propIsLike->pszEscapeChar )
-          free( propIsLike->pszEscapeChar );
+        FEPropertyIsLike *propIsLike = (FEPropertyIsLike *)psFilterNode->pOther;
+        if (propIsLike->pszWildCard)
+          free(propIsLike->pszWildCard);
+        if (propIsLike->pszSingleChar)
+          free(propIsLike->pszSingleChar);
+        if (propIsLike->pszEscapeChar)
+          free(propIsLike->pszEscapeChar);
       } else if (FLTIsGeometryFilterNodeType(psFilterNode->eType)) {
         msFreeShape((shapeObj *)(psFilterNode->pOther));
       }
       /* else */
       /* TODO free pOther special fields */
-      free( psFilterNode->pOther );
+      free(psFilterNode->pOther);
     }
 
     /* Cannot free pszValue before, 'cause we are testing it above */
-    if( psFilterNode->pszValue )
-      free( psFilterNode->pszValue );
+    if (psFilterNode->pszValue)
+      free(psFilterNode->pszValue);
 
     free(psFilterNode);
   }
 }
 
-
 /************************************************************************/
 /*                         FLTCreateFilterEncodingNode                  */
 /*                                                                      */
 /*      return a FilterEncoding node.                                    */
 /************************************************************************/
-FilterEncodingNode *FLTCreateFilterEncodingNode(void)
-{
+FilterEncodingNode *FLTCreateFilterEncodingNode(void) {
   FilterEncodingNode *psFilterNode = NULL;
 
-  psFilterNode =
-  (FilterEncodingNode *)malloc(sizeof (FilterEncodingNode));
+  psFilterNode = (FilterEncodingNode *)malloc(sizeof(FilterEncodingNode));
   psFilterNode->eType = FILTER_NODE_TYPE_UNDEFINED;
   psFilterNode->pszValue = NULL;
   psFilterNode->pOther = NULL;
@@ -977,8 +956,7 @@ FilterEncodingNode *FLTCreateFilterEncod
   return psFilterNode;
 }
 
-FilterEncodingNode *FLTCreateBinaryCompFilterEncodingNode(void)
-{
+FilterEncodingNode *FLTCreateBinaryCompFilterEncodingNode(void) {
   FilterEncodingNode *psFilterNode = NULL;
 
   psFilterNode = FLTCreateFilterEncodingNode();
@@ -990,97 +968,88 @@ FilterEncodingNode *FLTCreateBinaryCompF
   return psFilterNode;
 }
 
-
 /************************************************************************/
 /*                           FLTFindGeometryNode                        */
 /*                                                                      */
 /************************************************************************/
 
-static CPLXMLNode* FLTFindGeometryNode(CPLXMLNode* psXMLNode,
-                                       int* pbPoint,
-                                       int* pbLine,
-                                       int* pbPolygon)
-{
-    CPLXMLNode *psGMLElement = NULL;
-
-    psGMLElement = CPLGetXMLNode(psXMLNode, "Point");
-    if (!psGMLElement)
-        psGMLElement =  CPLGetXMLNode(psXMLNode, "PointType");
+static CPLXMLNode *FLTFindGeometryNode(CPLXMLNode *psXMLNode, int *pbPoint,
+                                       int *pbLine, int *pbPolygon) {
+  CPLXMLNode *psGMLElement = NULL;
+
+  psGMLElement = CPLGetXMLNode(psXMLNode, "Point");
+  if (!psGMLElement)
+    psGMLElement = CPLGetXMLNode(psXMLNode, "PointType");
+  if (psGMLElement)
+    *pbPoint = 1;
+  else {
+    psGMLElement = CPLGetXMLNode(psXMLNode, "Polygon");
     if (psGMLElement)
-        *pbPoint =1;
-    else {
-      psGMLElement= CPLGetXMLNode(psXMLNode, "Polygon");
-      if (psGMLElement)
-        *pbPolygon = 1;
-      else if ((psGMLElement= CPLGetXMLNode(psXMLNode, "MultiPolygon")))
-        *pbPolygon = 1;
-      else if ((psGMLElement= CPLGetXMLNode(psXMLNode, "Surface")))
-        *pbPolygon = 1;
-      else if ((psGMLElement= CPLGetXMLNode(psXMLNode, "MultiSurface")))
-        *pbPolygon = 1;
-      else if ((psGMLElement= CPLGetXMLNode(psXMLNode, "Box")))
-        *pbPolygon = 1;
-      else if ((psGMLElement= CPLGetXMLNode(psXMLNode, "Envelope")))
-        *pbPolygon = 1;
-      else if ((psGMLElement= CPLGetXMLNode(psXMLNode, "LineString")))
-        *pbLine = 1;
-      else if ((psGMLElement= CPLGetXMLNode(psXMLNode, "MultiLineString")))
-        *pbLine = 1;
-      else if ((psGMLElement= CPLGetXMLNode(psXMLNode, "Curve")))
-        *pbLine = 1;
-      else if ((psGMLElement= CPLGetXMLNode(psXMLNode, "MultiCurve")))
-        *pbLine = 1;
-      else if ((psGMLElement= CPLGetXMLNode(psXMLNode, "MultiPoint")))
-        *pbPoint = 1;
-    }
-    return psGMLElement;
+      *pbPolygon = 1;
+    else if ((psGMLElement = CPLGetXMLNode(psXMLNode, "MultiPolygon")))
+      *pbPolygon = 1;
+    else if ((psGMLElement = CPLGetXMLNode(psXMLNode, "Surface")))
+      *pbPolygon = 1;
+    else if ((psGMLElement = CPLGetXMLNode(psXMLNode, "MultiSurface")))
+      *pbPolygon = 1;
+    else if ((psGMLElement = CPLGetXMLNode(psXMLNode, "Box")))
+      *pbPolygon = 1;
+    else if ((psGMLElement = CPLGetXMLNode(psXMLNode, "Envelope")))
+      *pbPolygon = 1;
+    else if ((psGMLElement = CPLGetXMLNode(psXMLNode, "LineString")))
+      *pbLine = 1;
+    else if ((psGMLElement = CPLGetXMLNode(psXMLNode, "MultiLineString")))
+      *pbLine = 1;
+    else if ((psGMLElement = CPLGetXMLNode(psXMLNode, "Curve")))
+      *pbLine = 1;
+    else if ((psGMLElement = CPLGetXMLNode(psXMLNode, "MultiCurve")))
+      *pbLine = 1;
+    else if ((psGMLElement = CPLGetXMLNode(psXMLNode, "MultiPoint")))
+      *pbPoint = 1;
+  }
+  return psGMLElement;
 }
 
 /************************************************************************/
 /*                           FLTGetPropertyName                         */
 /************************************************************************/
-static const char* FLTGetPropertyName(CPLXMLNode* psXMLNode)
-{
-    const char* pszPropertyName;
+static const char *FLTGetPropertyName(CPLXMLNode *psXMLNode) {
+  const char *pszPropertyName;
 
-    pszPropertyName = CPLGetXMLValue(psXMLNode, "PropertyName", NULL);
-    if( pszPropertyName == NULL ) /* FE 2.0 ? */
-        pszPropertyName = CPLGetXMLValue(psXMLNode, "ValueReference", NULL);
-    return pszPropertyName;
+  pszPropertyName = CPLGetXMLValue(psXMLNode, "PropertyName", NULL);
+  if (pszPropertyName == NULL) /* FE 2.0 ? */
+    pszPropertyName = CPLGetXMLValue(psXMLNode, "ValueReference", NULL);
+  return pszPropertyName;
 }
 
 /************************************************************************/
 /*                          FLTGetFirstChildNode                        */
 /************************************************************************/
-static CPLXMLNode* FLTGetFirstChildNode(CPLXMLNode* psXMLNode)
-{
-    if( psXMLNode == NULL )
-        return NULL;
-    psXMLNode = psXMLNode->psChild;
-    while( psXMLNode != NULL )
-    {
-        if( psXMLNode->eType == CXT_Element )
-            return psXMLNode;
-        psXMLNode = psXMLNode->psNext;
-    }
+static CPLXMLNode *FLTGetFirstChildNode(CPLXMLNode *psXMLNode) {
+  if (psXMLNode == NULL)
     return NULL;
+  psXMLNode = psXMLNode->psChild;
+  while (psXMLNode != NULL) {
+    if (psXMLNode->eType == CXT_Element)
+      return psXMLNode;
+    psXMLNode = psXMLNode->psNext;
+  }
+  return NULL;
 }
 
 /************************************************************************/
 /*                        FLTGetNextSibblingNode                        */
 /************************************************************************/
-static CPLXMLNode* FLTGetNextSibblingNode(CPLXMLNode* psXMLNode)
-{
-    if( psXMLNode == NULL )
-        return NULL;
-    psXMLNode = psXMLNode->psNext;
-    while( psXMLNode != NULL )
-    {
-        if( psXMLNode->eType == CXT_Element )
-            return psXMLNode;
-        psXMLNode = psXMLNode->psNext;
-    }
+static CPLXMLNode *FLTGetNextSibblingNode(CPLXMLNode *psXMLNode) {
+  if (psXMLNode == NULL)
     return NULL;
+  psXMLNode = psXMLNode->psNext;
+  while (psXMLNode != NULL) {
+    if (psXMLNode->eType == CXT_Element)
+      return psXMLNode;
+    psXMLNode = psXMLNode->psNext;
+  }
+  return NULL;
 }
 
 /************************************************************************/
@@ -1090,15 +1059,14 @@ static CPLXMLNode* FLTGetNextSibblingNod
 /*      contents into the Filter Encoding node structure.               */
 /************************************************************************/
 void FLTInsertElementInNode(FilterEncodingNode *psFilterNode,
-                            CPLXMLNode *psXMLNode)
-{
+                            CPLXMLNode *psXMLNode) {
   char *pszTmp = NULL;
-  FilterEncodingNode *psCurFilNode= NULL;
+  FilterEncodingNode *psCurFilNode = NULL;
   CPLXMLNode *psCurXMLNode = NULL;
   CPLXMLNode *psTmpNode = NULL;
   CPLXMLNode *psFeatureIdNode = NULL;
-  const char *pszFeatureId=NULL;
-  char *pszFeatureIdList=NULL;
+  const char *pszFeatureId = NULL;
+  char *pszFeatureIdList = NULL;
 
   if (psFilterNode && psXMLNode && psXMLNode->pszValue) {
     psFilterNode->pszValue = msStrdup(psXMLNode->pszValue);
@@ -1125,11 +1093,11 @@ void FLTInsertElementInNode(FilterEncodi
       psFilterNode->eType = FILTER_NODE_TYPE_LOGICAL;
       if (strcasecmp(psFilterNode->pszValue, "AND") == 0 ||
           strcasecmp(psFilterNode->pszValue, "OR") == 0) {
-        CPLXMLNode* psFirstNode = FLTGetFirstChildNode(psXMLNode);
-        CPLXMLNode* psSecondNode = FLTGetNextSibblingNode(psFirstNode);
+        CPLXMLNode *psFirstNode = FLTGetFirstChildNode(psXMLNode);
+        CPLXMLNode *psSecondNode = FLTGetNextSibblingNode(psFirstNode);
         if (psFirstNode && psSecondNode) {
           /*2 operators */
-          CPLXMLNode* psNextNode = FLTGetNextSibblingNode(psSecondNode);
+          CPLXMLNode *psNextNode = FLTGetNextSibblingNode(psSecondNode);
           if (psNextNode == NULL) {
             psFilterNode->psLeftNode = FLTCreateFilterEncodingNode();
             FLTInsertElementInNode(psFilterNode->psLeftNode, psFirstNode);
@@ -1138,14 +1106,15 @@ void FLTInsertElementInNode(FilterEncodi
           } else {
             psCurXMLNode = psFirstNode;
             psCurFilNode = psFilterNode;
-            while(psCurXMLNode) {
+            while (psCurXMLNode) {
               psNextNode = FLTGetNextSibblingNode(psCurXMLNode);
               if (FLTGetNextSibblingNode(psNextNode)) {
                 psCurFilNode->psLeftNode = FLTCreateFilterEncodingNode();
                 FLTInsertElementInNode(psCurFilNode->psLeftNode, psCurXMLNode);
                 psCurFilNode->psRightNode = FLTCreateFilterEncodingNode();
                 psCurFilNode->psRightNode->eType = FILTER_NODE_TYPE_LOGICAL;
-                psCurFilNode->psRightNode->pszValue = msStrdup(psFilterNode->pszValue);
+                psCurFilNode->psRightNode->pszValue =
+                    msStrdup(psFilterNode->pszValue);
 
                 psCurFilNode = psCurFilNode->psRightNode;
                 psCurXMLNode = psNextNode;
@@ -1159,21 +1128,18 @@ void FLTInsertElementInNode(FilterEncodi
               }
             }
           }
-        }
-        else
+        } else
           psFilterNode->eType = FILTER_NODE_TYPE_UNDEFINED;
       } else if (strcasecmp(psFilterNode->pszValue, "NOT") == 0) {
-        CPLXMLNode* psFirstNode = FLTGetFirstChildNode(psXMLNode);
+        CPLXMLNode *psFirstNode = FLTGetFirstChildNode(psXMLNode);
         if (psFirstNode) {
           psFilterNode->psLeftNode = FLTCreateFilterEncodingNode();
-          FLTInsertElementInNode(psFilterNode->psLeftNode,
-                                 psFirstNode);
-        }
-        else
+          FLTInsertElementInNode(psFilterNode->psLeftNode, psFirstNode);
+        } else
           psFilterNode->eType = FILTER_NODE_TYPE_UNDEFINED;
       } else
         psFilterNode->eType = FILTER_NODE_TYPE_UNDEFINED;
-    }/* end if is logical */
+    } /* end if is logical */
     /* -------------------------------------------------------------------- */
     /*      Spatial Filter.                                                 */
     /*      BBOX :                                                          */
@@ -1217,7 +1183,8 @@ void FLTInsertElementInNode(FilterEncodi
     /*                                                                      */
     /*       Intersect                                                      */
     /*                                                                      */
-    /*       type="ogc:BinarySpatialOpType" substitutionGroup="ogc:spatialOps"/>*/
+    /*       type="ogc:BinarySpatialOpType"
+       substitutionGroup="ogc:spatialOps"/>*/
     /*      <xsd:element name="Intersects"                                  */
     /*      type="ogc:BinarySpatialOpType"                                  */
     /*      substitutionGroup="ogc:spatialOps"/>                            */
@@ -1240,9 +1207,9 @@ void FLTInsertElementInNode(FilterEncodi
 
       if (strcasecmp(psXMLNode->pszValue, "BBOX") == 0) {
         char *pszSRS = NULL;
-        const char* pszPropertyName = NULL;
-        CPLXMLNode *psBox = NULL, *psEnvelope=NULL;
-        rectObj sBox = {0,0,0,0};
+        const char *pszPropertyName = NULL;
+        CPLXMLNode *psBox = NULL, *psEnvelope = NULL;
+        rectObj sBox = {0, 0, 0, 0};
 
         int bCoordinatesValid = 0;
 
@@ -1263,12 +1230,12 @@ void FLTInsertElementInNode(FilterEncodi
             psFilterNode->pszSRS = pszSRS;
 
           psFilterNode->psLeftNode = FLTCreateFilterEncodingNode();
-          psFilterNode->psLeftNode->eType =  FILTER_NODE_TYPE_PROPERTYNAME;
+          psFilterNode->psLeftNode->eType = FILTER_NODE_TYPE_PROPERTYNAME;
           /* PropertyName is optional since FE 1.1.0, in which case */
           /* the BBOX must apply to all geometry fields. As we support */
           /* currently only one geometry field, this doesn't make much */
           /* difference to further processing. */
-          if( pszPropertyName != NULL ) {
+          if (pszPropertyName != NULL) {
             psFilterNode->psLeftNode->pszValue = msStrdup(pszPropertyName);
           }
 
@@ -1276,11 +1243,11 @@ void FLTInsertElementInNode(FilterEncodi
           psFilterNode->psRightNode = FLTCreateFilterEncodingNode();
           psFilterNode->psRightNode->eType = FILTER_NODE_TYPE_BBOX;
           psFilterNode->psRightNode->pOther =
-          (rectObj *)msSmallMalloc(sizeof(rectObj));
+              (rectObj *)msSmallMalloc(sizeof(rectObj));
           ((rectObj *)psFilterNode->psRightNode->pOther)->minx = sBox.minx;
           ((rectObj *)psFilterNode->psRightNode->pOther)->miny = sBox.miny;
           ((rectObj *)psFilterNode->psRightNode->pOther)->maxx = sBox.maxx;
-          ((rectObj *)psFilterNode->psRightNode->pOther)->maxy =  sBox.maxy;
+          ((rectObj *)psFilterNode->psRightNode->pOther)->maxy = sBox.maxy;
         } else {
           msFree(pszSRS);
           psFilterNode->eType = FILTER_NODE_TYPE_UNDEFINED;
@@ -1292,27 +1259,27 @@ void FLTInsertElementInNode(FilterEncodi
         shapeObj *psShape = NULL;
         int bPoint = 0, bLine = 0, bPolygon = 0;
         const char *pszUnits = NULL;
-        const char* pszDistance = NULL;
-        const char* pszPropertyName;
+        const char *pszDistance = NULL;
+        const char *pszPropertyName;
         char *pszSRS = NULL;
 
-        CPLXMLNode *psGMLElement = NULL, *psDistance=NULL;
+        CPLXMLNode *psGMLElement = NULL, *psDistance = NULL;
 
         pszPropertyName = FLTGetPropertyName(psXMLNode);
 
-        psGMLElement = FLTFindGeometryNode(psXMLNode, &bPoint, &bLine, &bPolygon);
+        psGMLElement =
+            FLTFindGeometryNode(psXMLNode, &bPoint, &bLine, &bPolygon);
 
         psDistance = CPLGetXMLNode(psXMLNode, "Distance");
-        if( psDistance != NULL )
-            pszDistance = CPLGetXMLValue(psDistance, NULL, NULL );
-        if (pszPropertyName != NULL && psGMLElement && psDistance != NULL ) {
+        if (psDistance != NULL)
+          pszDistance = CPLGetXMLValue(psDistance, NULL, NULL);
+        if (pszPropertyName != NULL && psGMLElement && psDistance != NULL) {
           pszUnits = CPLGetXMLValue(psDistance, "units", NULL);
-          if( pszUnits == NULL ) /* FE 2.0 */
-              pszUnits = CPLGetXMLValue(psDistance, "uom", NULL);
+          if (pszUnits == NULL) /* FE 2.0 */
+            pszUnits = CPLGetXMLValue(psDistance, "uom", NULL);
           psShape = (shapeObj *)msSmallMalloc(sizeof(shapeObj));
           msInitShape(psShape);
-          if (FLTShapeFromGMLTree(psGMLElement, psShape, &pszSRS))
-          {
+          if (FLTShapeFromGMLTree(psGMLElement, psShape, &pszSRS)) {
             /*set the srs if available*/
             if (pszSRS)
               psFilterNode->pszSRS = pszSRS;
@@ -1323,24 +1290,26 @@ void FLTInsertElementInNode(FilterEncodi
 
             psFilterNode->psRightNode = FLTCreateFilterEncodingNode();
             if (bPoint)
-              psFilterNode->psRightNode->eType = FILTER_NODE_TYPE_GEOMETRY_POINT;
+              psFilterNode->psRightNode->eType =
+                  FILTER_NODE_TYPE_GEOMETRY_POINT;
             else if (bLine)
               psFilterNode->psRightNode->eType = FILTER_NODE_TYPE_GEOMETRY_LINE;
             else if (bPolygon)
-              psFilterNode->psRightNode->eType = FILTER_NODE_TYPE_GEOMETRY_POLYGON;
+              psFilterNode->psRightNode->eType =
+                  FILTER_NODE_TYPE_GEOMETRY_POLYGON;
             psFilterNode->psRightNode->pOther = (shapeObj *)psShape;
             /*the value will be distance;units*/
             psFilterNode->psRightNode->pszValue = msStrdup(pszDistance);
             if (pszUnits) {
-              psFilterNode->psRightNode->pszValue= msStringConcatenate(psFilterNode->psRightNode->pszValue, ";");
-              psFilterNode->psRightNode->pszValue= msStringConcatenate(psFilterNode->psRightNode->pszValue, pszUnits);
+              psFilterNode->psRightNode->pszValue =
+                  msStringConcatenate(psFilterNode->psRightNode->pszValue, ";");
+              psFilterNode->psRightNode->pszValue = msStringConcatenate(
+                  psFilterNode->psRightNode->pszValue, pszUnits);
             }
-          }
-          else
-          {
-              free(psShape);
-              msFree(pszSRS);
-              psFilterNode->eType = FILTER_NODE_TYPE_UNDEFINED;
+          } else {
+            free(psShape);
+            msFree(pszSRS);
+            psFilterNode->eType = FILTER_NODE_TYPE_UNDEFINED;
           }
         } else
           psFilterNode->eType = FILTER_NODE_TYPE_UNDEFINED;
@@ -1354,21 +1323,21 @@ void FLTInsertElementInNode(FilterEncodi
                  strcasecmp(psXMLNode->pszValue, "Contains") == 0 ||
                  strcasecmp(psXMLNode->pszValue, "Overlaps") == 0) {
         shapeObj *psShape = NULL;
-        int  bLine = 0, bPolygon = 0, bPoint=0;
+        int bLine = 0, bPolygon = 0, bPoint = 0;
         char *pszSRS = NULL;
-        const char* pszPropertyName;
+        const char *pszPropertyName;
 
         CPLXMLNode *psGMLElement = NULL;
 
         pszPropertyName = FLTGetPropertyName(psXMLNode);
 
-        psGMLElement = FLTFindGeometryNode(psXMLNode, &bPoint, &bLine, &bPolygon);
+        psGMLElement =
+            FLTFindGeometryNode(psXMLNode, &bPoint, &bLine, &bPolygon);
 
         if (pszPropertyName != NULL && psGMLElement) {
           psShape = (shapeObj *)msSmallMalloc(sizeof(shapeObj));
           msInitShape(psShape);
-          if (FLTShapeFromGMLTree(psGMLElement, psShape, &pszSRS))
-          {
+          if (FLTShapeFromGMLTree(psGMLElement, psShape, &pszSRS)) {
             /*set the srs if available*/
             if (pszSRS)
               psFilterNode->pszSRS = pszSRS;
@@ -1379,27 +1348,25 @@ void FLTInsertElementInNode(FilterEncodi
 
             psFilterNode->psRightNode = FLTCreateFilterEncodingNode();
             if (bPoint)
-              psFilterNode->psRightNode->eType = FILTER_NODE_TYPE_GEOMETRY_POINT;
+              psFilterNode->psRightNode->eType =
+                  FILTER_NODE_TYPE_GEOMETRY_POINT;
             else if (bLine)
               psFilterNode->psRightNode->eType = FILTER_NODE_TYPE_GEOMETRY_LINE;
             else if (bPolygon)
-              psFilterNode->psRightNode->eType = FILTER_NODE_TYPE_GEOMETRY_POLYGON;
+              psFilterNode->psRightNode->eType =
+                  FILTER_NODE_TYPE_GEOMETRY_POLYGON;
             psFilterNode->psRightNode->pOther = (shapeObj *)psShape;
 
-          }
-          else
-          {
-              free(psShape);
-              msFree(pszSRS);
-              psFilterNode->eType = FILTER_NODE_TYPE_UNDEFINED;
+          } else {
+            free(psShape);
+            msFree(pszSRS);
+            psFilterNode->eType = FILTER_NODE_TYPE_UNDEFINED;
           }
         } else
           psFilterNode->eType = FILTER_NODE_TYPE_UNDEFINED;
       }
 
-
-    }/* end of is spatial */
-
+    } /* end of is spatial */
 
     /* -------------------------------------------------------------------- */
     /*      Comparison Filter                                               */
@@ -1417,29 +1384,30 @@ void FLTInsertElementInNode(FilterEncodi
       /*      </Filter>                                                       */
       /* -------------------------------------------------------------------- */
       if (FLTIsBinaryComparisonFilterType(psXMLNode->pszValue)) {
-        const char* pszPropertyName = FLTGetPropertyName(psXMLNode);
-        if (pszPropertyName != NULL ) {
+        const char *pszPropertyName = FLTGetPropertyName(psXMLNode);
+        if (pszPropertyName != NULL) {
 
           psFilterNode->psLeftNode = FLTCreateFilterEncodingNode();
           psFilterNode->psLeftNode->eType = FILTER_NODE_TYPE_PROPERTYNAME;
           psFilterNode->psLeftNode->pszValue = msStrdup(pszPropertyName);
 
-          psTmpNode = CPLSearchXMLNode(psXMLNode,  "Literal");
+          psTmpNode = CPLSearchXMLNode(psXMLNode, "Literal");
           if (psTmpNode) {
-            const char* pszLiteral = CPLGetXMLValue(psTmpNode, NULL, NULL);
+            const char *pszLiteral = CPLGetXMLValue(psTmpNode, NULL, NULL);
 
             psFilterNode->psRightNode = FLTCreateBinaryCompFilterEncodingNode();
             psFilterNode->psRightNode->eType = FILTER_NODE_TYPE_LITERAL;
 
             if (pszLiteral != NULL) {
-              const char* pszMatchCase;
+              const char *pszMatchCase;
 
               psFilterNode->psRightNode->pszValue = msStrdup(pszLiteral);
-              
+
               pszMatchCase = CPLGetXMLValue(psXMLNode, "matchCase", NULL);
 
               /*check if the matchCase attribute is set*/
-              if( pszMatchCase != NULL && strcasecmp( pszMatchCase, "false") == 0) {
+              if (pszMatchCase != NULL &&
+                  strcasecmp(pszMatchCase, "false") == 0) {
                 (*(int *)psFilterNode->psRightNode->pOther) = 1;
               }
 
@@ -1451,7 +1419,8 @@ void FLTInsertElementInNode(FilterEncodi
               psFilterNode->psRightNode->pszValue = NULL;
           }
         }
-        if (psFilterNode->psLeftNode == NULL || psFilterNode->psRightNode == NULL)
+        if (psFilterNode->psLeftNode == NULL ||
+            psFilterNode->psRightNode == NULL)
           psFilterNode->eType = FILTER_NODE_TYPE_UNDEFINED;
       }
 
@@ -1474,27 +1443,26 @@ void FLTInsertElementInNode(FilterEncodi
       /*      </PropertyIsBetween>                                            */
       /* -------------------------------------------------------------------- */
       else if (strcasecmp(psXMLNode->pszValue, "PropertyIsBetween") == 0) {
-        const char* pszPropertyName = FLTGetPropertyName(psXMLNode);
-        CPLXMLNode* psLowerBoundary = CPLGetXMLNode(psXMLNode, "LowerBoundary");
-        CPLXMLNode* psUpperBoundary = CPLGetXMLNode(psXMLNode, "UpperBoundary");
-        const char* pszLowerNode = NULL;
-        const char* pszUpperNode = NULL;
-        if( psLowerBoundary != NULL )
-        {
+        const char *pszPropertyName = FLTGetPropertyName(psXMLNode);
+        CPLXMLNode *psLowerBoundary = CPLGetXMLNode(psXMLNode, "LowerBoundary");
+        CPLXMLNode *psUpperBoundary = CPLGetXMLNode(psXMLNode, "UpperBoundary");
+        const char *pszLowerNode = NULL;
+        const char *pszUpperNode = NULL;
+        if (psLowerBoundary != NULL) {
           /* check if the <Literal> is there */
           if (CPLGetXMLNode(psLowerBoundary, "Literal") != NULL)
             pszLowerNode = CPLGetXMLValue(psLowerBoundary, "Literal", NULL);
           else
             pszLowerNode = CPLGetXMLValue(psLowerBoundary, NULL, NULL);
         }
-        if( psUpperBoundary != NULL )
-        {
-           if (CPLGetXMLNode(psUpperBoundary, "Literal") != NULL)
+        if (psUpperBoundary != NULL) {
+          if (CPLGetXMLNode(psUpperBoundary, "Literal") != NULL)
             pszUpperNode = CPLGetXMLValue(psUpperBoundary, "Literal", NULL);
           else
             pszUpperNode = CPLGetXMLValue(psUpperBoundary, NULL, NULL);
         }
-        if (pszPropertyName != NULL && pszLowerNode != NULL && pszUpperNode != NULL) {
+        if (pszPropertyName != NULL && pszLowerNode != NULL &&
+            pszUpperNode != NULL) {
           psFilterNode->psLeftNode = FLTCreateFilterEncodingNode();
 
           psFilterNode->psLeftNode->eType = FILTER_NODE_TYPE_PROPERTYNAME;
@@ -1504,19 +1472,20 @@ void FLTInsertElementInNode(FilterEncodi
           psFilterNode->psRightNode->eType = FILTER_NODE_TYPE_BOUNDARY;
 
           /* adding a ; between bounary values */
-          const int nStrLength = strlen(pszLowerNode) + strlen(pszUpperNode) + 2;
+          const int nStrLength =
+              strlen(pszLowerNode) + strlen(pszUpperNode) + 2;
 
           psFilterNode->psRightNode->pszValue =
-              (char *)malloc(sizeof(char)*(nStrLength));
-          strcpy( psFilterNode->psRightNode->pszValue, pszLowerNode);
+              (char *)malloc(sizeof(char) * (nStrLength));
+          strcpy(psFilterNode->psRightNode->pszValue, pszLowerNode);
           strlcat(psFilterNode->psRightNode->pszValue, ";", nStrLength);
-          strlcat(psFilterNode->psRightNode->pszValue, pszUpperNode, nStrLength);
-
+          strlcat(psFilterNode->psRightNode->pszValue, pszUpperNode,
+                  nStrLength);
 
         } else
           psFilterNode->eType = FILTER_NODE_TYPE_UNDEFINED;
 
-      }/* end of PropertyIsBetween  */
+      } /* end of PropertyIsBetween  */
       /* -------------------------------------------------------------------- */
       /*      PropertyIsLike                                                  */
       /*                                                                      */
@@ -1528,17 +1497,18 @@ void FLTInsertElementInNode(FilterEncodi
       /*      </Filter>                                                       */
       /* -------------------------------------------------------------------- */
       else if (strcasecmp(psXMLNode->pszValue, "PropertyIsLike") == 0) {
-        const char* pszPropertyName = FLTGetPropertyName(psXMLNode);
-        const char* pszLiteral = CPLGetXMLValue(psXMLNode, "Literal", NULL);
-        const char* pszWildCard = CPLGetXMLValue(psXMLNode, "wildCard", NULL);
-        const char* pszSingleChar = CPLGetXMLValue(psXMLNode, "singleChar", NULL);
-        const char* pszEscapeChar = CPLGetXMLValue(psXMLNode, "escape", NULL);
-        if( pszEscapeChar == NULL )
-            pszEscapeChar = CPLGetXMLValue(psXMLNode, "escapeChar", NULL);
+        const char *pszPropertyName = FLTGetPropertyName(psXMLNode);
+        const char *pszLiteral = CPLGetXMLValue(psXMLNode, "Literal", NULL);
+        const char *pszWildCard = CPLGetXMLValue(psXMLNode, "wildCard", NULL);
+        const char *pszSingleChar =
+            CPLGetXMLValue(psXMLNode, "singleChar", NULL);
+        const char *pszEscapeChar = CPLGetXMLValue(psXMLNode, "escape", NULL);
+        if (pszEscapeChar == NULL)
+          pszEscapeChar = CPLGetXMLValue(psXMLNode, "escapeChar", NULL);
         if (pszPropertyName != NULL && pszLiteral != NULL &&
-            pszWildCard != NULL && pszSingleChar != NULL && pszEscapeChar != NULL)
-        {
-          FEPropertyIsLike* propIsLike;
+            pszWildCard != NULL && pszSingleChar != NULL &&
+            pszEscapeChar != NULL) {
+          FEPropertyIsLike *propIsLike;
 
           propIsLike = (FEPropertyIsLike *)malloc(sizeof(FEPropertyIsLike));
 
@@ -1550,11 +1520,13 @@ void FLTInsertElementInNode(FilterEncodi
 
           pszTmp = (char *)CPLGetXMLValue(psXMLNode, "matchCase", NULL);
           if (pszTmp && strcasecmp(pszTmp, "false") == 0) {
-            propIsLike->bCaseInsensitive =1;
+            propIsLike->bCaseInsensitive = 1;
           }
-          /* -------------------------------------------------------------------- */
-          /*      Create left and right node for the attribute and the value.     */
-          /* -------------------------------------------------------------------- */
+          /* --------------------------------------------------------------------
+           */
+          /*      Create left and right node for the attribute and the value. */
+          /* --------------------------------------------------------------------
+           */
           psFilterNode->psLeftNode = FLTCreateFilterEncodingNode();
 
           psFilterNode->psLeftNode->pszValue = msStrdup(pszPropertyName);
@@ -1571,24 +1543,22 @@ void FLTInsertElementInNode(FilterEncodi
       }
 
       else if (strcasecmp(psXMLNode->pszValue, "PropertyIsNull") == 0) {
-        const char* pszPropertyName = FLTGetPropertyName(psXMLNode);
-        if( pszPropertyName != NULL )
-        {
-            psFilterNode->psLeftNode = FLTCreateFilterEncodingNode();
-            psFilterNode->psLeftNode->pszValue = msStrdup(pszPropertyName);
-            psFilterNode->psLeftNode->eType = FILTER_NODE_TYPE_PROPERTYNAME;
-        }  else
+        const char *pszPropertyName = FLTGetPropertyName(psXMLNode);
+        if (pszPropertyName != NULL) {
+          psFilterNode->psLeftNode = FLTCreateFilterEncodingNode();
+          psFilterNode->psLeftNode->pszValue = msStrdup(pszPropertyName);
+          psFilterNode->psLeftNode->eType = FILTER_NODE_TYPE_PROPERTYNAME;
+        } else
           psFilterNode->eType = FILTER_NODE_TYPE_UNDEFINED;
       }
 
       else if (strcasecmp(psXMLNode->pszValue, "PropertyIsNil") == 0) {
-        const char* pszPropertyName = FLTGetPropertyName(psXMLNode);
-        if( pszPropertyName != NULL )
-        {
-            psFilterNode->psLeftNode = FLTCreateFilterEncodingNode();
-            psFilterNode->psLeftNode->pszValue = msStrdup(pszPropertyName);
-            psFilterNode->psLeftNode->eType = FILTER_NODE_TYPE_PROPERTYNAME;
-        }  else
+        const char *pszPropertyName = FLTGetPropertyName(psXMLNode);
+        if (pszPropertyName != NULL) {
+          psFilterNode->psLeftNode = FLTCreateFilterEncodingNode();
+          psFilterNode->psLeftNode->pszValue = msStrdup(pszPropertyName);
+          psFilterNode->psLeftNode->eType = FILTER_NODE_TYPE_PROPERTYNAME;
+        } else
           psFilterNode->eType = FILTER_NODE_TYPE_UNDEFINED;
       }
     }
@@ -1627,19 +1597,20 @@ void FLTInsertElementInNode(FilterEncodi
           if (pszFeatureIdList)
             pszFeatureIdList = msStringConcatenate(pszFeatureIdList, ",");
 
-          pszFeatureIdList = msStringConcatenate(pszFeatureIdList, pszFeatureId);
+          pszFeatureIdList =
+              msStringConcatenate(pszFeatureIdList, pszFeatureId);
         }
         psFeatureIdNode = psFeatureIdNode->psNext;
       }
 
       if (pszFeatureIdList) {
         msFree(psFilterNode->pszValue);
-        psFilterNode->pszValue =  msStrdup(pszFeatureIdList);
+        psFilterNode->pszValue = msStrdup(pszFeatureIdList);
         msFree(pszFeatureIdList);
       } else
         psFilterNode->eType = FILTER_NODE_TYPE_UNDEFINED;
     }
-    
+
     /* -------------------------------------------------------------------- */
     /*      Temporal Filter.                                                */
     /*
@@ -1664,58 +1635,59 @@ void FLTInsertElementInNode(FilterEncodi
       psFilterNode->eType = FILTER_NODE_TYPE_TEMPORAL;
 
       if (strcasecmp(psXMLNode->pszValue, "During") == 0) {
-        const char* pszPropertyName = NULL;
-        const char* pszBeginTime;
-        const char* pszEndTime;
+        const char *pszPropertyName = NULL;
+        const char *pszBeginTime;
+        const char *pszEndTime;
 
         pszPropertyName = FLTGetPropertyName(psXMLNode);
-        pszBeginTime = CPLGetXMLValue(psXMLNode, "TimePeriod.begin.TimeInstant.timePosition", NULL);
-        if( pszBeginTime == NULL )
-            pszBeginTime = CPLGetXMLValue(psXMLNode, "TimePeriod.beginPosition", NULL);
-        pszEndTime = CPLGetXMLValue(psXMLNode, "TimePeriod.end.TimeInstant.timePosition", NULL);
-        if( pszEndTime == NULL )
-            pszEndTime = CPLGetXMLValue(psXMLNode, "TimePeriod.endPosition", NULL);
+        pszBeginTime = CPLGetXMLValue(
+            psXMLNode, "TimePeriod.begin.TimeInstant.timePosition", NULL);
+        if (pszBeginTime == NULL)
+          pszBeginTime =
+              CPLGetXMLValue(psXMLNode, "TimePeriod.beginPosition", NULL);
+        pszEndTime = CPLGetXMLValue(
+            psXMLNode, "TimePeriod.end.TimeInstant.timePosition", NULL);
+        if (pszEndTime == NULL)
+          pszEndTime =
+              CPLGetXMLValue(psXMLNode, "TimePeriod.endPosition", NULL);
 
         if (pszPropertyName && pszBeginTime && pszEndTime &&
-            strchr(pszBeginTime, '\'') == NULL && strchr(pszBeginTime, '\\') == NULL &&
-            strchr(pszEndTime, '\'') == NULL && strchr(pszEndTime, '\\') == NULL &&
+            strchr(pszBeginTime, '\'') == NULL &&
+            strchr(pszBeginTime, '\\') == NULL &&
+            strchr(pszEndTime, '\'') == NULL &&
+            strchr(pszEndTime, '\\') == NULL &&
             msTimeGetResolution(pszBeginTime) >= 0 &&
             msTimeGetResolution(pszEndTime) >= 0) {
 
           psFilterNode->psLeftNode = FLTCreateFilterEncodingNode();
-          psFilterNode->psLeftNode->eType =  FILTER_NODE_TYPE_PROPERTYNAME;
+          psFilterNode->psLeftNode->eType = FILTER_NODE_TYPE_PROPERTYNAME;
           psFilterNode->psLeftNode->pszValue = msStrdup(pszPropertyName);
 
           psFilterNode->psRightNode = FLTCreateFilterEncodingNode();
           psFilterNode->psRightNode->eType = FILTER_NODE_TYPE_TIME_PERIOD;
-          psFilterNode->psRightNode->pszValue = static_cast<char*>(msSmallMalloc( strlen(pszBeginTime) + strlen(pszEndTime) + 2 ));
-          sprintf(psFilterNode->psRightNode->pszValue, "%s/%s", pszBeginTime, pszEndTime);
-        }
-        else
+          psFilterNode->psRightNode->pszValue = static_cast<char *>(
+              msSmallMalloc(strlen(pszBeginTime) + strlen(pszEndTime) + 2));
+          sprintf(psFilterNode->psRightNode->pszValue, "%s/%s", pszBeginTime,
+                  pszEndTime);
+        } else
           psFilterNode->eType = FILTER_NODE_TYPE_UNDEFINED;
       } else {
         psFilterNode->eType = FILTER_NODE_TYPE_UNDEFINED;
       }
 
-    }/* end of is temporal */
-
-
-
+    } /* end of is temporal */
   }
 }
 
-
 /************************************************************************/
 /*            int FLTIsLogicalFilterType((char *pszValue)                  */
 /*                                                                      */
 /*      return TRUE if the value of the node is of logical filter       */
 /*       encoding type.                                                 */
 /************************************************************************/
-int FLTIsLogicalFilterType(const char *pszValue)
-{
+int FLTIsLogicalFilterType(const char *pszValue) {
   if (pszValue) {
-    if (strcasecmp(pszValue, "AND") == 0 ||
-        strcasecmp(pszValue, "OR") == 0 ||
+    if (strcasecmp(pszValue, "AND") == 0 || strcasecmp(pszValue, "OR") == 0 ||
         strcasecmp(pszValue, "NOT") == 0)
       return MS_TRUE;
   }
@@ -1728,8 +1700,7 @@ int FLTIsLogicalFilterType(const char *p
 /*                                                                      */
 /*      Binary comparison filter type.                                  */
 /************************************************************************/
-int FLTIsBinaryComparisonFilterType(const char *pszValue)
-{
+int FLTIsBinaryComparisonFilterType(const char *pszValue) {
   if (pszValue) {
     if (strcasecmp(pszValue, "PropertyIsEqualTo") == 0 ||
         strcasecmp(pszValue, "PropertyIsNotEqualTo") == 0 ||
@@ -1749,8 +1720,7 @@ int FLTIsBinaryComparisonFilterType(cons
 /*      return TRUE if the value of the node is of comparison filter    */
 /*      encoding type.                                                  */
 /************************************************************************/
-int FLTIsComparisonFilterType(const char *pszValue)
-{
+int FLTIsComparisonFilterType(const char *pszValue) {
   if (pszValue) {
     if (FLTIsBinaryComparisonFilterType(pszValue) ||
         strcasecmp(pszValue, "PropertyIsLike") == 0 ||
@@ -1769,8 +1739,7 @@ int FLTIsComparisonFilterType(const char
 /*      return TRUE if the value of the node is of featureid filter     */
 /*      encoding type.                                                  */
 /************************************************************************/
-int FLTIsFeatureIdFilterType(const char *pszValue)
-{
+int FLTIsFeatureIdFilterType(const char *pszValue) {
   if (pszValue && (strcasecmp(pszValue, "FeatureId") == 0 ||
                    strcasecmp(pszValue, "GmlObjectId") == 0 ||
                    strcasecmp(pszValue, "ResourceId") == 0))
@@ -1786,21 +1755,20 @@ int FLTIsFeatureIdFilterType(const char
 /*      return TRUE if the value of the node is of spatial filter       */
 /*      encoding type.                                                  */
 /************************************************************************/
-int FLTIsSpatialFilterType(const char *pszValue)
-{
+int FLTIsSpatialFilterType(const char *pszValue) {
   if (pszValue) {
-    if ( strcasecmp(pszValue, "BBOX") == 0 ||
-         strcasecmp(pszValue, "DWithin") == 0 ||
-         strcasecmp(pszValue, "Intersect") == 0 ||
-         strcasecmp(pszValue, "Intersects") == 0 ||
-         strcasecmp(pszValue, "Equals") == 0 ||
-         strcasecmp(pszValue, "Disjoint") == 0 ||
-         strcasecmp(pszValue, "Touches") == 0 ||
-         strcasecmp(pszValue, "Crosses") == 0 ||
-         strcasecmp(pszValue, "Within") == 0 ||
-         strcasecmp(pszValue, "Contains") == 0 ||
-         strcasecmp(pszValue, "Overlaps") == 0 ||
-         strcasecmp(pszValue, "Beyond") == 0)
+    if (strcasecmp(pszValue, "BBOX") == 0 ||
+        strcasecmp(pszValue, "DWithin") == 0 ||
+        strcasecmp(pszValue, "Intersect") == 0 ||
+        strcasecmp(pszValue, "Intersects") == 0 ||
+        strcasecmp(pszValue, "Equals") == 0 ||
+        strcasecmp(pszValue, "Disjoint") == 0 ||
+        strcasecmp(pszValue, "Touches") == 0 ||
+        strcasecmp(pszValue, "Crosses") == 0 ||
+        strcasecmp(pszValue, "Within") == 0 ||
+        strcasecmp(pszValue, "Contains") == 0 ||
+        strcasecmp(pszValue, "Overlaps") == 0 ||
+        strcasecmp(pszValue, "Beyond") == 0)
       return MS_TRUE;
   }
 
@@ -1813,10 +1781,9 @@ int FLTIsSpatialFilterType(const char *p
 /*      return TRUE if the value of the node is of temporal filter      */
 /*      encoding type.                                                  */
 /************************************************************************/
-int FLTIsTemporalFilterType(const char *pszValue)
-{
+int FLTIsTemporalFilterType(const char *pszValue) {
   if (pszValue) {
-    if ( strcasecmp(pszValue, "During") == 0 )
+    if (strcasecmp(pszValue, "During") == 0)
       return MS_TRUE;
   }
 
@@ -1829,8 +1796,7 @@ int FLTIsTemporalFilterType(const char *
 /*      Verfify if the value of the node is one of the supported        */
 /*      filter type.                                                    */
 /************************************************************************/
-int FLTIsSupportedFilterType(CPLXMLNode *psXMLNode)
-{
+int FLTIsSupportedFilterType(CPLXMLNode *psXMLNode) {
   if (psXMLNode) {
     if (FLTIsLogicalFilterType(psXMLNode->pszValue) ||
         FLTIsSpatialFilterType(psXMLNode->pszValue) ||
@@ -1849,15 +1815,15 @@ int FLTIsSupportedFilterType(CPLXMLNode
 /*      Loop trhough the nodes and return the number of nodes of        */
 /*      specified value.                                                */
 /************************************************************************/
-int FLTNumberOfFilterType(FilterEncodingNode *psFilterNode, const char *szType)
-{
+int FLTNumberOfFilterType(FilterEncodingNode *psFilterNode,
+                          const char *szType) {
   int nCount = 0;
-  int nLeftNode=0 , nRightNode = 0;
+  int nLeftNode = 0, nRightNode = 0;
 
   if (!psFilterNode || !szType || !psFilterNode->pszValue)
     return 0;
 
-  if (strcasecmp(psFilterNode->pszValue, (char*)szType) == 0)
+  if (strcasecmp(psFilterNode->pszValue, (char *)szType) == 0)
     nCount++;
 
   if (psFilterNode->psLeftNode)
@@ -1872,9 +1838,6 @@ int FLTNumberOfFilterType(FilterEncoding
   return nCount;
 }
 
-
-
-
 /************************************************************************/
 /*                          FLTValidForBBoxFilter                       */
 /*                                                                      */
@@ -1886,7 +1849,8 @@ int FLTNumberOfFilterType(FilterEncoding
 /*      eg 1: <Filter>                                                  */
 /*            <BBOX>                                                    */
 /*              <PropertyName>Geometry</PropertyName>                   */
-/*              <gml:Box srsName="http://www.opengis.net/gml/srs/epsg.xml#4326">*/
+/*              <gml:Box
+ * srsName="http://www.opengis.net/gml/srs/epsg.xml#4326">*/
 /*                <gml:coordinates>13.0983,31.5899 35.5472,42.8143</gml:coordinates>*/
 /*              </gml:Box>                                              */
 /*            </BBOX>                                                   */
@@ -1896,7 +1860,8 @@ int FLTNumberOfFilterType(FilterEncoding
 /*              <AND>                                                   */
 /*               <BBOX>                                                 */
 /*                <PropertyName>Geometry</PropertyName>                  */
-/*                <gml:Box srsName="http://www.opengis.net/gml/srs/epsg.xml#4326">*/
+/*                <gml:Box
+ * srsName="http://www.opengis.net/gml/srs/epsg.xml#4326">*/
 /*                  <gml:coordinates>13.0983,31.5899 35.5472,42.8143</gml:coordinates>*/
 /*                </gml:Box>                                            */
 /*               </BBOX>                                                */
@@ -1908,8 +1873,7 @@ int FLTNumberOfFilterType(FilterEncoding
 /*           </Filter>                                                  */
 /*                                                                      */
 /************************************************************************/
-int FLTValidForBBoxFilter(FilterEncodingNode *psFilterNode)
-{
+int FLTValidForBBoxFilter(FilterEncodingNode *psFilterNode) {
   int nCount = 0;
 
   if (!psFilterNode || !psFilterNode->pszValue)
@@ -1962,8 +1926,7 @@ static int FLTHasUniqueTopLevelDuringFil
 }
 #endif
 
-int FLTIsLineFilter(FilterEncodingNode *psFilterNode)
-{
+int FLTIsLineFilter(FilterEncodingNode *psFilterNode) {
   if (!psFilterNode || !psFilterNode->pszValue)
     return 0;
 
@@ -1975,8 +1938,7 @@ int FLTIsLineFilter(FilterEncodingNode *
   return 0;
 }
 
-int FLTIsPolygonFilter(FilterEncodingNode *psFilterNode)
-{
+int FLTIsPolygonFilter(FilterEncodingNode *psFilterNode) {
   if (!psFilterNode || !psFilterNode->pszValue)
     return 0;
 
@@ -1988,8 +1950,7 @@ int FLTIsPolygonFilter(FilterEncodingNod
   return 0;
 }
 
-int FLTIsPointFilter(FilterEncodingNode *psFilterNode)
-{
+int FLTIsPointFilter(FilterEncodingNode *psFilterNode) {
   if (!psFilterNode || !psFilterNode->pszValue)
     return 0;
 
@@ -2001,8 +1962,7 @@ int FLTIsPointFilter(FilterEncodingNode
   return 0;
 }
 
-int FLTIsBBoxFilter(FilterEncodingNode *psFilterNode)
-{
+int FLTIsBBoxFilter(FilterEncodingNode *psFilterNode) {
   if (!psFilterNode || !psFilterNode->pszValue)
     return 0;
 
@@ -2013,8 +1973,7 @@ int FLTIsBBoxFilter(FilterEncodingNode *
 }
 
 shapeObj *FLTGetShape(FilterEncodingNode *psFilterNode, double *pdfDistance,
-                      int *pnUnit)
-{
+                      int *pnUnit) {
   char **tokens = NULL;
   int nTokens = 0;
   FilterEncodingNode *psNode = psFilterNode;
@@ -2033,7 +1992,7 @@ shapeObj *FLTGetShape(FilterEncodingNode
         if unit is there syntax is "URI#unit" (eg http://..../#m)
         or just "unit"
         */
-        tokens = msStringSplit(psNode->pszValue,';', &nTokens);
+        tokens = msStringSplit(psNode->pszValue, ';', &nTokens);
         if (tokens && nTokens >= 1) {
           *pdfDistance = atof(tokens[0]);
 
@@ -2041,41 +2000,40 @@ shapeObj *FLTGetShape(FilterEncodingNode
             szUnitStr = msStrdup(tokens[1]);
             msFreeCharArray(tokens, nTokens);
             nTokens = 0;
-            tokens = msStringSplit(szUnitStr,'#', &nTokens);
+            tokens = msStringSplit(szUnitStr, '#', &nTokens);
             msFree(szUnitStr);
             if (tokens && nTokens >= 1) {
-              if (nTokens ==1)
+              if (nTokens == 1)
                 szUnit = tokens[0];
               else
                 szUnit = tokens[1];
 
-              if (strcasecmp(szUnit,"m") == 0 ||
-                  strcasecmp(szUnit,"meters") == 0 )
+              if (strcasecmp(szUnit, "m") == 0 ||
+                  strcasecmp(szUnit, "meters") == 0)
                 *pnUnit = MS_METERS;
-              else if (strcasecmp(szUnit,"km") == 0 ||
-                       strcasecmp(szUnit,"kilometers") == 0)
+              else if (strcasecmp(szUnit, "km") == 0 ||
+                       strcasecmp(szUnit, "kilometers") == 0)
                 *pnUnit = MS_KILOMETERS;
-              else if (strcasecmp(szUnit,"NM") == 0 ||
-                       strcasecmp(szUnit,"nauticalmiles") == 0)
+              else if (strcasecmp(szUnit, "NM") == 0 ||
+                       strcasecmp(szUnit, "nauticalmiles") == 0)
                 *pnUnit = MS_NAUTICALMILES;
-              else if (strcasecmp(szUnit,"mi") == 0 ||
-                       strcasecmp(szUnit,"miles") == 0)
+              else if (strcasecmp(szUnit, "mi") == 0 ||
+                       strcasecmp(szUnit, "miles") == 0)
                 *pnUnit = MS_MILES;
-              else if (strcasecmp(szUnit,"in") == 0 ||
-                       strcasecmp(szUnit,"inches") == 0)
+              else if (strcasecmp(szUnit, "in") == 0 ||
+                       strcasecmp(szUnit, "inches") == 0)
                 *pnUnit = MS_INCHES;
-              else if (strcasecmp(szUnit,"ft") == 0 ||
-                       strcasecmp(szUnit,"feet") == 0)
+              else if (strcasecmp(szUnit, "ft") == 0 ||
+                       strcasecmp(szUnit, "feet") == 0)
                 *pnUnit = MS_FEET;
-              else if (strcasecmp(szUnit,"deg") == 0 ||
-                       strcasecmp(szUnit,"dd") == 0)
+              else if (strcasecmp(szUnit, "deg") == 0 ||
+                       strcasecmp(szUnit, "dd") == 0)
                 *pnUnit = MS_DD;
-              else if (strcasecmp(szUnit,"px") == 0)
+              else if (strcasecmp(szUnit, "px") == 0)
                 *pnUnit = MS_PIXELS;
-
             }
           }
-        } 
+        }
         msFreeCharArray(tokens, nTokens);
       }
 
@@ -2092,43 +2050,43 @@ shapeObj *FLTGetShape(FilterEncodingNode
 /*      first bbox node found. The retrun value is the epsg code of     */
 /*      the bbox.                                                       */
 /************************************************************************/
-const char *FLTGetBBOX(FilterEncodingNode *psFilterNode, rectObj *psRect)
-{
+const char *FLTGetBBOX(FilterEncodingNode *psFilterNode, rectObj *psRect) {
   const char *pszReturn = NULL;
 
   if (!psFilterNode || !psRect)
     return NULL;
 
-  if (psFilterNode->pszValue && strcasecmp(psFilterNode->pszValue, "BBOX") == 0) {
+  if (psFilterNode->pszValue &&
+      strcasecmp(psFilterNode->pszValue, "BBOX") == 0) {
     if (psFilterNode->psRightNode && psFilterNode->psRightNode->pOther) {
-      rectObj* pRect= (rectObj *)psFilterNode->psRightNode->pOther;
+      rectObj *pRect = (rectObj *)psFilterNode->psRightNode->pOther;
       psRect->minx = pRect->minx;
       psRect->miny = pRect->miny;
       psRect->maxx = pRect->maxx;
       psRect->maxy = pRect->maxy;
 
       return psFilterNode->pszSRS;
-
     }
   } else {
     pszReturn = FLTGetBBOX(psFilterNode->psLeftNode, psRect);
     if (pszReturn)
       return pszReturn;
     else
-      return  FLTGetBBOX(psFilterNode->psRightNode, psRect);
+      return FLTGetBBOX(psFilterNode->psRightNode, psRect);
   }
 
   return pszReturn;
 }
 
-const char* FLTGetDuring(FilterEncodingNode *psFilterNode, const char** ppszTimeField)
-{
+const char *FLTGetDuring(FilterEncodingNode *psFilterNode,
+                         const char **ppszTimeField) {
   const char *pszReturn = NULL;
 
   if (!psFilterNode || !ppszTimeField)
     return NULL;
 
-  if (psFilterNode->pszValue && strcasecmp(psFilterNode->pszValue, "During") == 0) {
+  if (psFilterNode->pszValue &&
+      strcasecmp(psFilterNode->pszValue, "During") == 0) {
     *ppszTimeField = psFilterNode->psLeftNode->pszValue;
     return psFilterNode->psRightNode->pszValue;
   } else {
@@ -2136,7 +2094,7 @@ const char* FLTGetDuring(FilterEncodingN
     if (pszReturn)
       return pszReturn;
     else
-      return  FLTGetDuring(psFilterNode->psRightNode, ppszTimeField);
+      return FLTGetDuring(psFilterNode->psRightNode, ppszTimeField);
   }
 
   return pszReturn;
@@ -2147,59 +2105,52 @@ const char* FLTGetDuring(FilterEncodingN
 /*                                                                      */
 /*      Build SQL expressions from the mapserver nodes.                 */
 /************************************************************************/
-char *FLTGetSQLExpression(FilterEncodingNode *psFilterNode, layerObj *lp)
-{
+char *FLTGetSQLExpression(FilterEncodingNode *psFilterNode, layerObj *lp) {
   char *pszExpression = NULL;
 
   if (psFilterNode == NULL || lp == NULL)
     return NULL;
 
   if (psFilterNode->eType == FILTER_NODE_TYPE_COMPARISON) {
-    if ( psFilterNode->psLeftNode && psFilterNode->psRightNode) {
+    if (psFilterNode->psLeftNode && psFilterNode->psRightNode) {
       if (FLTIsBinaryComparisonFilterType(psFilterNode->pszValue)) {
+        pszExpression = FLTGetBinaryComparisonSQLExpresssion(psFilterNode, lp);
+      } else if (strcasecmp(psFilterNode->pszValue, "PropertyIsBetween") == 0) {
         pszExpression =
-          FLTGetBinaryComparisonSQLExpresssion(psFilterNode, lp);
-      } else if (strcasecmp(psFilterNode->pszValue,
-                            "PropertyIsBetween") == 0) {
-        pszExpression =
-          FLTGetIsBetweenComparisonSQLExpresssion(psFilterNode, lp);
-      } else if (strcasecmp(psFilterNode->pszValue,
-                            "PropertyIsLike") == 0) {
-        pszExpression =
-          FLTGetIsLikeComparisonSQLExpression(psFilterNode, lp);
-
+            FLTGetIsBetweenComparisonSQLExpresssion(psFilterNode, lp);
+      } else if (strcasecmp(psFilterNode->pszValue, "PropertyIsLike") == 0) {
+        pszExpression = FLTGetIsLikeComparisonSQLExpression(psFilterNode, lp);
       }
     }
   } else if (psFilterNode->eType == FILTER_NODE_TYPE_LOGICAL) {
     if (strcasecmp(psFilterNode->pszValue, "AND") == 0 ||
         strcasecmp(psFilterNode->pszValue, "OR") == 0) {
-      pszExpression =
-        FLTGetLogicalComparisonSQLExpresssion(psFilterNode, lp);
+      pszExpression = FLTGetLogicalComparisonSQLExpresssion(psFilterNode, lp);
 
     } else if (strcasecmp(psFilterNode->pszValue, "NOT") == 0) {
-      pszExpression =
-        FLTGetLogicalComparisonSQLExpresssion(psFilterNode, lp);
-
+      pszExpression = FLTGetLogicalComparisonSQLExpresssion(psFilterNode, lp);
     }
   }
 
   else if (psFilterNode->eType == FILTER_NODE_TYPE_SPATIAL) {
     /* TODO */
   } else if (psFilterNode->eType == FILTER_NODE_TYPE_FEATUREID) {
-#if defined(USE_WMS_SVR) || defined (USE_WFS_SVR) || defined (USE_WCS_SVR) || defined(USE_SOS_SVR)
+#if defined(USE_WMS_SVR) || defined(USE_WFS_SVR) || defined(USE_WCS_SVR) ||    \
+    defined(USE_SOS_SVR)
     if (psFilterNode->pszValue) {
-      const char *pszAttribute = msOWSLookupMetadata(&(lp->metadata), "OFG", "featureid");
+      const char *pszAttribute =
+          msOWSLookupMetadata(&(lp->metadata), "OFG", "featureid");
       if (pszAttribute) {
         int nTokens = 0;
-        char **tokens = msStringSplit(psFilterNode->pszValue,',', &nTokens);
+        char **tokens = msStringSplit(psFilterNode->pszValue, ',', &nTokens);
         int bString = 0;
         if (tokens && nTokens > 0) {
-          for (int i=0; i<nTokens; i++) {
+          for (int i = 0; i < nTokens; i++) {
             char *pszEscapedStr = NULL;
-            const char* pszId = tokens[i];
-            const char* pszDot = strchr(pszId, '.');
-            if( pszDot )
-                pszId = pszDot + 1;
+            const char *pszId = tokens[i];
+            const char *pszDot = strchr(pszId, '.');
+            if (pszDot)
+              pszId = pszDot + 1;
 
             if (strlen(pszId) <= 0)
               continue;
@@ -2209,18 +2160,21 @@ char *FLTGetSQLExpression(FilterEncoding
 
             pszEscapedStr = msLayerEscapeSQLParam(lp, pszId);
             char szTmp[256];
-            if (bString)
-            {
-              if( lp->connectiontype == MS_OGR || lp->connectiontype == MS_POSTGIS )
-                snprintf(szTmp, sizeof(szTmp), "(CAST(%s AS CHARACTER(255)) = '%s')" , pszAttribute, pszEscapedStr);
+            if (bString) {
+              if (lp->connectiontype == MS_OGR ||
+                  lp->connectiontype == MS_POSTGIS)
+                snprintf(szTmp, sizeof(szTmp),
+                         "(CAST(%s AS CHARACTER(255)) = '%s')", pszAttribute,
+                         pszEscapedStr);
               else
-                snprintf(szTmp, sizeof(szTmp), "(%s = '%s')" , pszAttribute, pszEscapedStr);
-            }
-            else
-              snprintf(szTmp, sizeof(szTmp), "(%s = %s)" , pszAttribute, pszEscapedStr);
+                snprintf(szTmp, sizeof(szTmp), "(%s = '%s')", pszAttribute,
+                         pszEscapedStr);
+            } else
+              snprintf(szTmp, sizeof(szTmp), "(%s = %s)", pszAttribute,
+                       pszEscapedStr);
 
             msFree(pszEscapedStr);
-            pszEscapedStr=NULL;
+            pszEscapedStr = NULL;
 
             if (pszExpression != NULL)
               pszExpression = msStringConcatenate(pszExpression, " OR ");
@@ -2243,9 +2197,8 @@ char *FLTGetSQLExpression(FilterEncoding
     return NULL;
 #endif
 
-  }
-  else if ( lp->connectiontype != MS_OGR &&
-            psFilterNode->eType == FILTER_NODE_TYPE_TEMPORAL )
+  } else if (lp->connectiontype != MS_OGR &&
+             psFilterNode->eType == FILTER_NODE_TYPE_TEMPORAL)
     pszExpression = msStrdup(FLTGetTimeExpression(psFilterNode, lp).c_str());
 
   return pszExpression;
@@ -2257,8 +2210,7 @@ char *FLTGetSQLExpression(FilterEncoding
 /*      Return the expression for logical comparison expression.        */
 /************************************************************************/
 char *FLTGetLogicalComparisonSQLExpresssion(FilterEncodingNode *psFilterNode,
-    layerObj *lp)
-{
+                                            layerObj *lp) {
   char *pszBuffer = NULL;
   char *pszTmp = NULL;
 
@@ -2286,10 +2238,10 @@ char *FLTGetLogicalComparisonSQLExpresss
   /* ==================================================================== */
   /*      special case for temporal filter node (OGR layer only)          */
   /* ==================================================================== */
-  else if (lp->connectiontype == MS_OGR &&
-      psFilterNode->psLeftNode && psFilterNode->psRightNode &&
-      (psFilterNode->psLeftNode->eType == FILTER_NODE_TYPE_TEMPORAL ||
-       psFilterNode->psRightNode->eType == FILTER_NODE_TYPE_TEMPORAL) ) {
+  else if (lp->connectiontype == MS_OGR && psFilterNode->psLeftNode &&
+           psFilterNode->psRightNode &&
+           (psFilterNode->psLeftNode->eType == FILTER_NODE_TYPE_TEMPORAL ||
+            psFilterNode->psRightNode->eType == FILTER_NODE_TYPE_TEMPORAL)) {
     if (psFilterNode->psLeftNode->eType != FILTER_NODE_TYPE_TEMPORAL)
       pszTmp = FLTGetSQLExpression(psFilterNode->psLeftNode, lp);
     else
@@ -2301,7 +2253,7 @@ char *FLTGetLogicalComparisonSQLExpresss
     pszBuffer = (char *)malloc(sizeof(char) * (strlen(pszTmp) + 1));
     sprintf(pszBuffer, "%s", pszTmp);
   }
-  
+
   /* -------------------------------------------------------------------- */
   /*      OR and AND                                                      */
   /* -------------------------------------------------------------------- */
@@ -2310,9 +2262,8 @@ char *FLTGetLogicalComparisonSQLExpresss
     if (!pszTmp)
       return NULL;
 
-    pszBuffer = (char *)malloc(sizeof(char) *
-                               (strlen(pszTmp) +
-                                strlen(psFilterNode->pszValue) + 5));
+    pszBuffer = (char *)malloc(
+        sizeof(char) * (strlen(pszTmp) + strlen(psFilterNode->pszValue) + 5));
     pszBuffer[0] = '\0';
     strcat(pszBuffer, " (");
     strcat(pszBuffer, pszTmp);
@@ -2320,7 +2271,7 @@ char *FLTGetLogicalComparisonSQLExpresss
     strcat(pszBuffer, psFilterNode->pszValue);
     strcat(pszBuffer, " ");
 
-    free( pszTmp );
+    free(pszTmp);
 
     const size_t nTmp = strlen(pszBuffer);
     pszTmp = FLTGetSQLExpression(psFilterNode->psRightNode, lp);
@@ -2329,8 +2280,8 @@ char *FLTGetLogicalComparisonSQLExpresss
       return NULL;
     }
 
-    pszBuffer = (char *)msSmallRealloc(pszBuffer,
-                                sizeof(char) * (strlen(pszTmp) + nTmp +3));
+    pszBuffer = (char *)msSmallRealloc(
+        pszBuffer, sizeof(char) * (strlen(pszTmp) + nTmp + 3));
     strcat(pszBuffer, pszTmp);
     strcat(pszBuffer, ") ");
   }
@@ -2343,7 +2294,7 @@ char *FLTGetLogicalComparisonSQLExpresss
     if (!pszTmp)
       return NULL;
 
-    pszBuffer = (char *)malloc(sizeof(char) * (strlen(pszTmp) +  9));
+    pszBuffer = (char *)malloc(sizeof(char) * (strlen(pszTmp) + 9));
     pszBuffer[0] = '\0';
 
     strcat(pszBuffer, " (NOT ");
@@ -2355,30 +2306,26 @@ char *FLTGetLogicalComparisonSQLExpresss
   /* -------------------------------------------------------------------- */
   /*      Cleanup.                                                        */
   /* -------------------------------------------------------------------- */
-  if( pszTmp != NULL )
-    free( pszTmp );
+  if (pszTmp != NULL)
+    free(pszTmp);
   return pszBuffer;
-
 }
 
-
 /************************************************************************/
 /*                      FLTGetBinaryComparisonSQLExpresssion            */
 /*                                                                      */
 /*      Return the expression for a binary comparison filter node.      */
 /************************************************************************/
 char *FLTGetBinaryComparisonSQLExpresssion(FilterEncodingNode *psFilterNode,
-    layerObj *lp)
-{
+                                           layerObj *lp) {
   const size_t bufferSize = 1024;
   char szBuffer[1024];
-  int bString=0;
+  int bString = 0;
   char szTmp[256];
-  char* pszEscapedStr = NULL;
+  char *pszEscapedStr = NULL;
 
   szBuffer[0] = '\0';
-  if (!psFilterNode || !
-      FLTIsBinaryComparisonFilterType(psFilterNode->pszValue))
+  if (!psFilterNode || !FLTIsBinaryComparisonFilterType(psFilterNode->pszValue))
     return NULL;
 
   /* -------------------------------------------------------------------- */
@@ -2387,10 +2334,11 @@ char *FLTGetBinaryComparisonSQLExpresssi
   /* -------------------------------------------------------------------- */
   bString = 0;
   if (psFilterNode->psRightNode->pszValue) {
-    const char* pszOFGType;
-    snprintf(szTmp, sizeof(szTmp), "%s_type",  psFilterNode->psLeftNode->pszValue);
+    const char *pszOFGType;
+    snprintf(szTmp, sizeof(szTmp), "%s_type",
+             psFilterNode->psLeftNode->pszValue);
     pszOFGType = msOWSLookupMetadata(&(lp->metadata), "OFG", szTmp);
-    if (pszOFGType!= NULL && strcasecmp(pszOFGType, "Character") == 0)
+    if (pszOFGType != NULL && strcasecmp(pszOFGType, "Character") == 0)
       bString = 1;
 
     else if (FLTIsNumeric(psFilterNode->psRightNode->pszValue) == MS_FALSE)
@@ -2401,21 +2349,18 @@ char *FLTGetBinaryComparisonSQLExpresssi
   if (psFilterNode->psRightNode->pszValue == NULL)
     bString = 1;
 
-
   /*opening bracket*/
   strlcat(szBuffer, " (", bufferSize);
 
-  pszEscapedStr = msLayerEscapePropertyName(lp, psFilterNode->psLeftNode->pszValue);
-
+  pszEscapedStr =
+      msLayerEscapePropertyName(lp, psFilterNode->psLeftNode->pszValue);
 
   /* attribute */
   /*case insensitive set ? */
-  if (bString &&
-      strcasecmp(psFilterNode->pszValue,
-                 "PropertyIsEqualTo") == 0 &&
+  if (bString && strcasecmp(psFilterNode->pszValue, "PropertyIsEqualTo") == 0 &&
       psFilterNode->psRightNode->pOther &&
       (*(int *)psFilterNode->psRightNode->pOther) == 1) {
-    snprintf(szTmp, sizeof(szTmp), "lower(%s) ",  pszEscapedStr);
+    snprintf(szTmp, sizeof(szTmp), "lower(%s) ", pszEscapedStr);
     strlcat(szBuffer, szTmp, bufferSize);
   } else
     strlcat(szBuffer, pszEscapedStr, bufferSize);
@@ -2423,22 +2368,17 @@ char *FLTGetBinaryComparisonSQLExpresssi
   msFree(pszEscapedStr);
   pszEscapedStr = NULL;
 
-
   /* logical operator */
-  if (strcasecmp(psFilterNode->pszValue,
-                 "PropertyIsEqualTo") == 0)
+  if (strcasecmp(psFilterNode->pszValue, "PropertyIsEqualTo") == 0)
     strlcat(szBuffer, "=", bufferSize);
-  else if (strcasecmp(psFilterNode->pszValue,
-                      "PropertyIsNotEqualTo") == 0)
+  else if (strcasecmp(psFilterNode->pszValue, "PropertyIsNotEqualTo") == 0)
     strlcat(szBuffer, "<>", bufferSize);
-  else if (strcasecmp(psFilterNode->pszValue,
-                      "PropertyIsLessThan") == 0)
+  else if (strcasecmp(psFilterNode->pszValue, "PropertyIsLessThan") == 0)
     strlcat(szBuffer, "<", bufferSize);
-  else if (strcasecmp(psFilterNode->pszValue,
-                      "PropertyIsGreaterThan") == 0)
+  else if (strcasecmp(psFilterNode->pszValue, "PropertyIsGreaterThan") == 0)
     strlcat(szBuffer, ">", bufferSize);
-  else if (strcasecmp(psFilterNode->pszValue,
-                      "PropertyIsLessThanOrEqualTo") == 0)
+  else if (strcasecmp(psFilterNode->pszValue, "PropertyIsLessThanOrEqualTo") ==
+           0)
     strlcat(szBuffer, "<=", bufferSize);
   else if (strcasecmp(psFilterNode->pszValue,
                       "PropertyIsGreaterThanOrEqualTo") == 0)
@@ -2448,14 +2388,13 @@ char *FLTGetBinaryComparisonSQLExpresssi
 
   /* value */
 
-  if (bString &&
-      psFilterNode->psRightNode->pszValue &&
-      strcasecmp(psFilterNode->pszValue,
-                 "PropertyIsEqualTo") == 0 &&
+  if (bString && psFilterNode->psRightNode->pszValue &&
+      strcasecmp(psFilterNode->pszValue, "PropertyIsEqualTo") == 0 &&
       psFilterNode->psRightNode->pOther &&
       (*(int *)psFilterNode->psRightNode->pOther) == 1) {
-    char* pszEscapedStr;
-    pszEscapedStr = msLayerEscapeSQLParam(lp, psFilterNode->psRightNode->pszValue);
+    char *pszEscapedStr;
+    pszEscapedStr =
+        msLayerEscapeSQLParam(lp, psFilterNode->psRightNode->pszValue);
     snprintf(szTmp, sizeof(szTmp), "lower('%s') ", pszEscapedStr);
     msFree(pszEscapedStr);
     strlcat(szBuffer, szTmp, bufferSize);
@@ -2465,18 +2404,18 @@ char *FLTGetBinaryComparisonSQLExpresssi
 
     if (psFilterNode->psRightNode->pszValue) {
       if (bString) {
-        char* pszEscapedStr;
-        pszEscapedStr = msLayerEscapeSQLParam(lp, psFilterNode->psRightNode->pszValue);
+        char *pszEscapedStr;
+        pszEscapedStr =
+            msLayerEscapeSQLParam(lp, psFilterNode->psRightNode->pszValue);
         strlcat(szBuffer, pszEscapedStr, bufferSize);
         msFree(pszEscapedStr);
-        pszEscapedStr=NULL;
+        pszEscapedStr = NULL;
       } else
         strlcat(szBuffer, psFilterNode->psRightNode->pszValue, bufferSize);
     }
 
     if (bString)
       strlcat(szBuffer, "'", bufferSize);
-
   }
   /*closing bracket*/
   strlcat(szBuffer, ") ", bufferSize);
@@ -2484,29 +2423,27 @@ char *FLTGetBinaryComparisonSQLExpresssi
   return msStrdup(szBuffer);
 }
 
-
 /************************************************************************/
 /*                    FLTGetIsBetweenComparisonSQLExpresssion           */
 /*                                                                      */
 /*      Build an SQL expresssion for IsBteween Filter.                  */
 /************************************************************************/
 char *FLTGetIsBetweenComparisonSQLExpresssion(FilterEncodingNode *psFilterNode,
-    layerObj *lp)
-{
+                                              layerObj *lp) {
   const size_t bufferSize = 1024;
   char szBuffer[1024];
   char **aszBounds = NULL;
   int nBounds = 0;
-  int bString=0;
+  int bString = 0;
   char szTmp[256];
-  char* pszEscapedStr;
+  char *pszEscapedStr;
 
   szBuffer[0] = '\0';
   if (!psFilterNode ||
       !(strcasecmp(psFilterNode->pszValue, "PropertyIsBetween") == 0))
     return NULL;
 
-  if (!psFilterNode->psLeftNode || !psFilterNode->psRightNode )
+  if (!psFilterNode->psLeftNode || !psFilterNode->psRightNode)
     return NULL;
 
   /* -------------------------------------------------------------------- */
@@ -2523,10 +2460,11 @@ char *FLTGetIsBetweenComparisonSQLExpres
   /* -------------------------------------------------------------------- */
   bString = 0;
   if (aszBounds[0]) {
-    const char* pszOFGType;
-    snprintf(szTmp, sizeof(szTmp), "%s_type",  psFilterNode->psLeftNode->pszValue);
+    const char *pszOFGType;
+    snprintf(szTmp, sizeof(szTmp), "%s_type",
+             psFilterNode->psLeftNode->pszValue);
     pszOFGType = msOWSLookupMetadata(&(lp->metadata), "OFG", szTmp);
-    if (pszOFGType!= NULL && strcasecmp(pszOFGType, "Character") == 0)
+    if (pszOFGType != NULL && strcasecmp(pszOFGType, "Character") == 0)
       bString = 1;
     else if (FLTIsNumeric(aszBounds[0]) == MS_FALSE)
       bString = 1;
@@ -2538,7 +2476,6 @@ char *FLTGetIsBetweenComparisonSQLExpres
     }
   }
 
-
   /* -------------------------------------------------------------------- */
   /*      build expresssion.                                              */
   /* -------------------------------------------------------------------- */
@@ -2546,7 +2483,8 @@ char *FLTGetIsBetweenComparisonSQLExpres
   strlcat(szBuffer, " (", bufferSize);
 
   /* attribute */
-  pszEscapedStr = msLayerEscapePropertyName(lp, psFilterNode->psLeftNode->pszValue);
+  pszEscapedStr =
+      msLayerEscapePropertyName(lp, psFilterNode->psLeftNode->pszValue);
 
   strlcat(szBuffer, pszEscapedStr, bufferSize);
   msFree(pszEscapedStr);
@@ -2557,27 +2495,27 @@ char *FLTGetIsBetweenComparisonSQLExpres
 
   /*bound 1*/
   if (bString)
-    strlcat(szBuffer,"'", bufferSize);
-  pszEscapedStr = msLayerEscapeSQLParam( lp, aszBounds[0]);
+    strlcat(szBuffer, "'", bufferSize);
+  pszEscapedStr = msLayerEscapeSQLParam(lp, aszBounds[0]);
   strlcat(szBuffer, pszEscapedStr, bufferSize);
   msFree(pszEscapedStr);
-  pszEscapedStr=NULL;
+  pszEscapedStr = NULL;
 
   if (bString)
-    strlcat(szBuffer,"'", bufferSize);
+    strlcat(szBuffer, "'", bufferSize);
 
   strlcat(szBuffer, " AND ", bufferSize);
 
   /*bound 2*/
   if (bString)
     strlcat(szBuffer, "'", bufferSize);
-  pszEscapedStr = msLayerEscapeSQLParam( lp, aszBounds[1]);
+  pszEscapedStr = msLayerEscapeSQLParam(lp, aszBounds[1]);
   strlcat(szBuffer, pszEscapedStr, bufferSize);
   msFree(pszEscapedStr);
-  pszEscapedStr=NULL;
+  pszEscapedStr = NULL;
 
   if (bString)
-    strlcat(szBuffer,"'", bufferSize);
+    strlcat(szBuffer, "'", bufferSize);
 
   /*closing paranthesis*/
   strlcat(szBuffer, ")", bufferSize);
@@ -2593,8 +2531,7 @@ char *FLTGetIsBetweenComparisonSQLExpres
 /*      Build an sql expression for IsLike filter.                      */
 /************************************************************************/
 char *FLTGetIsLikeComparisonSQLExpression(FilterEncodingNode *psFilterNode,
-    layerObj *lp)
-{
+                                          layerObj *lp) {
   const size_t bufferSize = 1024;
   char szBuffer[1024];
   char *pszValue = NULL;
@@ -2604,11 +2541,11 @@ char *FLTGetIsLikeComparisonSQLExpressio
   const char *pszEscape = NULL;
   char szTmp[4];
 
-  int nLength=0, i=0, j=0;
-  int  bCaseInsensitive = 0;
+  int nLength = 0, i = 0, j = 0;
+  int bCaseInsensitive = 0;
 
   char *pszEscapedStr = NULL;
-  FEPropertyIsLike* propIsLike;
+  FEPropertyIsLike *propIsLike;
 
   if (!psFilterNode || !psFilterNode->pOther || !psFilterNode->psLeftNode ||
       !psFilterNode->psRightNode || !psFilterNode->psRightNode->pszValue)
@@ -2620,27 +2557,28 @@ char *FLTGetIsLikeComparisonSQLExpressio
   pszEscape = propIsLike->pszEscapeChar;
   bCaseInsensitive = propIsLike->bCaseInsensitive;
 
-  if (!pszWild || strlen(pszWild) == 0 ||
-      !pszSingle || strlen(pszSingle) == 0 ||
-      !pszEscape || strlen(pszEscape) == 0)
+  if (!pszWild || strlen(pszWild) == 0 || !pszSingle ||
+      strlen(pszSingle) == 0 || !pszEscape || strlen(pszEscape) == 0)
     return NULL;
 
   if (pszEscape[0] == '\'') {
     /* This might be valid, but the risk of SQL injection is too high */
     /* and the below code is not ready for that */
     /* Someone who does this has clearly suspect intentions ! */
-    msSetError(MS_MISCERR, "Single quote character is not allowed as an escaping character.",
-               "FLTGetIsLikeComparisonSQLExpression()");
+    msSetError(
+        MS_MISCERR,
+        "Single quote character is not allowed as an escaping character.",
+        "FLTGetIsLikeComparisonSQLExpression()");
     return NULL;
   }
 
-
   szBuffer[0] = '\0';
   /*opening bracket*/
   strlcat(szBuffer, " (", bufferSize);
 
   /* attribute name */
-  pszEscapedStr = msLayerEscapePropertyName(lp, psFilterNode->psLeftNode->pszValue);
+  pszEscapedStr =
+      msLayerEscapePropertyName(lp, psFilterNode->psLeftNode->pszValue);
 
   strlcat(szBuffer, pszEscapedStr, bufferSize);
   msFree(pszEscapedStr);
@@ -2657,13 +2595,11 @@ char *FLTGetIsLikeComparisonSQLExpressio
   pszValue = psFilterNode->psRightNode->pszValue;
   nLength = strlen(pszValue);
 
-  pszEscapedStr = (char*) msSmallMalloc( 3 * nLength + 1);
+  pszEscapedStr = (char *)msSmallMalloc(3 * nLength + 1);
 
-  for (i=0, j=0; i<nLength; i++) {
+  for (i = 0, j = 0; i < nLength; i++) {
     char c = pszValue[i];
-    if (c != pszWild[0] &&
-        c != pszSingle[0] &&
-        c != pszEscape[0]) {
+    if (c != pszWild[0] && c != pszSingle[0] && c != pszEscape[0]) {
       if (c == '\'') {
         pszEscapedStr[j++] = '\'';
         pszEscapedStr[j++] = '\'';
@@ -2672,12 +2608,12 @@ char *FLTGetIsLikeComparisonSQLExpressio
         pszEscapedStr[j++] = '\\';
       } else
         pszEscapedStr[j++] = c;
-    } else if  (c == pszSingle[0]) {
+    } else if (c == pszSingle[0]) {
       pszEscapedStr[j++] = '_';
-    } else if  (c == pszEscape[0]) {
+    } else if (c == pszEscape[0]) {
       pszEscapedStr[j++] = pszEscape[0];
-      if (i+1<nLength) {
-        char nextC = pszValue[i+1];
+      if (i + 1 < nLength) {
+        char nextC = pszValue[i + 1];
         i++;
         if (nextC == '\'') {
           pszEscapedStr[j++] = '\'';
@@ -2696,9 +2632,9 @@ char *FLTGetIsLikeComparisonSQLExpressio
   strlcat(szBuffer, "'", bufferSize);
   if (lp->connectiontype != MS_OGR) {
     if (lp->connectiontype == MS_POSTGIS && pszEscape[0] == '\\')
-        strlcat(szBuffer, " escape E'", bufferSize);
+      strlcat(szBuffer, " escape E'", bufferSize);
     else
-        strlcat(szBuffer, " escape '", bufferSize);
+      strlcat(szBuffer, " escape '", bufferSize);
     szTmp[0] = pszEscape[0];
     if (pszEscape[0] == '\\') {
       szTmp[1] = '\\';
@@ -2709,9 +2645,9 @@ char *FLTGetIsLikeComparisonSQLExpressio
       szTmp[2] = '\0';
     }
 
-    strlcat(szBuffer,  szTmp, bufferSize);
+    strlcat(szBuffer, szTmp, bufferSize);
   }
-  strlcat(szBuffer,  ") ", bufferSize);
+  strlcat(szBuffer, ") ", bufferSize);
 
   return msStrdup(szBuffer);
 }
@@ -2722,8 +2658,7 @@ char *FLTGetIsLikeComparisonSQLExpressio
 /*      Utility function to see if a spatial filter is included in      */
 /*      the node.                                                       */
 /************************************************************************/
-int FLTHasSpatialFilter(FilterEncodingNode *psNode)
-{
+int FLTHasSpatialFilter(FilterEncodingNode *psNode) {
   int bResult = MS_FALSE;
 
   if (!psNode)
@@ -2745,41 +2680,36 @@ int FLTHasSpatialFilter(FilterEncodingNo
              FLTIsLineFilter(psNode) || FLTIsPolygonFilter(psNode))
     return MS_TRUE;
 
-
   return MS_FALSE;
 }
 
-
 /************************************************************************/
 /*                     FLTCreateFeatureIdFilterEncoding                 */
 /*                                                                      */
 /*      Utility function to create a filter node of FeatureId type.     */
 /************************************************************************/
-FilterEncodingNode *FLTCreateFeatureIdFilterEncoding(const char *pszString)
-{
+FilterEncodingNode *FLTCreateFeatureIdFilterEncoding(const char *pszString) {
   FilterEncodingNode *psFilterNode = NULL;
 
   if (pszString) {
     psFilterNode = FLTCreateFilterEncodingNode();
     psFilterNode->eType = FILTER_NODE_TYPE_FEATUREID;
-    psFilterNode->pszValue =  msStrdup(pszString);
+    psFilterNode->pszValue = msStrdup(pszString);
     return psFilterNode;
   }
   return NULL;
 }
 
-
 /************************************************************************/
 /*                              FLTParseGMLBox                          */
 /*                                                                      */
 /*      Parse gml box. Used for FE 1.0                                  */
 /************************************************************************/
-int FLTParseGMLBox(CPLXMLNode *psBox, rectObj *psBbox, char **ppszSRS)
-{
+int FLTParseGMLBox(CPLXMLNode *psBox, rectObj *psBbox, char **ppszSRS) {
   int bCoordinatesValid = 0;
   CPLXMLNode *psCoordinates = NULL;
   CPLXMLNode *psCoord1 = NULL, *psCoord2 = NULL;
-  char **papszCoords=NULL, **papszMin=NULL, **papszMax = NULL;
+  char **papszCoords = NULL, **papszMin = NULL, **papszMax = NULL;
   int nCoords = 0, nCoordsMin = 0, nCoordsMax = 0;
   const char *pszTmpCoord = NULL;
   const char *pszSRS = NULL;
@@ -2794,11 +2724,11 @@ int FLTParseGMLBox(CPLXMLNode *psBox, re
 
     psCoordinates = CPLGetXMLNode(psBox, "coordinates");
     pszTS = CPLGetXMLValue(psCoordinates, "ts", NULL);
-    if( pszTS == NULL )
-        pszTS = " ";
+    if (pszTS == NULL)
+      pszTS = " ";
     pszCS = CPLGetXMLValue(psCoordinates, "cs", NULL);
-    if( pszCS == NULL )
-        pszCS = ",";
+    if (pszCS == NULL)
+      pszCS = ",";
     pszTmpCoord = CPLGetXMLValue(psCoordinates, NULL, NULL);
 
     if (pszTmpCoord) {
@@ -2809,11 +2739,11 @@ int FLTParseGMLBox(CPLXMLNode *psBox, re
           papszMax = msStringSplit(papszCoords[1], pszCS[0], &nCoordsMax);
         }
         if (papszMax && nCoordsMax == 2) {
-          bCoordinatesValid =1;
-          minx =  atof(papszMin[0]);
-          miny =  atof(papszMin[1]);
-          maxx =  atof(papszMax[0]);
-          maxy =  atof(papszMax[1]);
+          bCoordinatesValid = 1;
+          minx = atof(papszMin[0]);
+          miny = atof(papszMin[1]);
+          maxx = atof(papszMax[0]);
+          maxy = atof(papszMax[1]);
         }
 
         msFreeCharArray(papszMin, nCoordsMin);
@@ -2825,8 +2755,8 @@ int FLTParseGMLBox(CPLXMLNode *psBox, re
       psCoord1 = CPLGetXMLNode(psBox, "coord");
       psCoord2 = FLTGetNextSibblingNode(psCoord1);
       if (psCoord1 && psCoord2 && strcmp(psCoord2->pszValue, "coord") == 0) {
-        const char* pszX = CPLGetXMLValue(psCoord1, "X", NULL);
-        const char* pszY = CPLGetXMLValue(psCoord1, "Y", NULL);
+        const char *pszX = CPLGetXMLValue(psCoord1, "X", NULL);
+        const char *pszY = CPLGetXMLValue(psCoord1, "Y", NULL);
         if (pszX && pszY) {
           minx = atof(pszX);
           miny = atof(pszY);
@@ -2840,16 +2770,15 @@ int FLTParseGMLBox(CPLXMLNode *psBox, re
           }
         }
       }
-
     }
   }
 
   if (bCoordinatesValid) {
-    psBbox->minx =  minx;
-    psBbox->miny =  miny;
+    psBbox->minx = minx;
+    psBbox->miny = miny;
 
-    psBbox->maxx =  maxx;
-    psBbox->maxy =  maxy;
+    psBbox->maxx = maxx;
+    psBbox->maxy = maxy;
   }
 
   return bCoordinatesValid;
@@ -2859,21 +2788,20 @@ int FLTParseGMLBox(CPLXMLNode *psBox, re
 /*                                                                      */
 /*      Utility function to parse a gml:Envelope (used for SOS and FE1.1)*/
 /************************************************************************/
-int FLTParseGMLEnvelope(CPLXMLNode *psRoot, rectObj *psBbox, char **ppszSRS)
-{
-  CPLXMLNode *psUpperCorner=NULL, *psLowerCorner=NULL;
-  const char *pszLowerCorner=NULL, *pszUpperCorner=NULL;
+int FLTParseGMLEnvelope(CPLXMLNode *psRoot, rectObj *psBbox, char **ppszSRS) {
+  CPLXMLNode *psUpperCorner = NULL, *psLowerCorner = NULL;
+  const char *pszLowerCorner = NULL, *pszUpperCorner = NULL;
   int bValid = 0;
   char **tokens;
   int n;
 
   if (psRoot && psBbox && psRoot->eType == CXT_Element &&
-      EQUAL(psRoot->pszValue,"Envelope")) {
+      EQUAL(psRoot->pszValue, "Envelope")) {
     /*Get the srs if available*/
     if (ppszSRS) {
-      const char* pszSRS = CPLGetXMLValue(psRoot, "srsName", NULL);
-      if( pszSRS != NULL )
-          *ppszSRS = msStrdup(pszSRS);
+      const char *pszSRS = CPLGetXMLValue(psRoot, "srsName", NULL);
+      if (pszSRS != NULL)
+        *ppszSRS = msStrdup(pszSRS);
     }
     psLowerCorner = CPLSearchXMLNode(psRoot, "lowerCorner");
     psUpperCorner = CPLSearchXMLNode(psRoot, "upperCorner");
@@ -2909,20 +2837,18 @@ int FLTParseGMLEnvelope(CPLXMLNode *psRo
 /*                        FLTNeedSRSSwapping                            */
 /************************************************************************/
 
-static int FLTNeedSRSSwapping( mapObj *map, const char* pszSRS )
-{
-    int bNeedSwapping = MS_FALSE;
-    projectionObj sProjTmp;
-    msInitProjection(&sProjTmp);
-    if( map )
-    {
-        msProjectionInheritContextFrom(&sProjTmp, &map->projection);
-    }
-    if (msLoadProjectionStringEPSG(&sProjTmp, pszSRS) == 0) {
-        bNeedSwapping = msIsAxisInvertedProj(&sProjTmp);
-    }
-    msFreeProjection(&sProjTmp);
-    return bNeedSwapping;
+static int FLTNeedSRSSwapping(mapObj *map, const char *pszSRS) {
+  int bNeedSwapping = MS_FALSE;
+  projectionObj sProjTmp;
+  msInitProjection(&sProjTmp);
+  if (map) {
+    msProjectionInheritContextFrom(&sProjTmp, &map->projection);
+  }
+  if (msLoadProjectionStringEPSG(&sProjTmp, pszSRS) == 0) {
+    bNeedSwapping = msIsAxisInvertedProj(&sProjTmp);
+  }
+  msFreeProjection(&sProjTmp);
+  return bNeedSwapping;
 }
 
 /************************************************************************/
@@ -2934,55 +2860,46 @@ static int FLTNeedSRSSwapping( mapObj *m
 /*      caller will have to determine its value from a more general     */
 /*      context.                                                        */
 /************************************************************************/
-void FLTDoAxisSwappingIfNecessary(mapObj *map, 
-                                  FilterEncodingNode *psFilterNode,
-                                  int bDefaultSRSNeedsAxisSwapping)
-{
-    if( psFilterNode == NULL )
-        return;
+void FLTDoAxisSwappingIfNecessary(mapObj *map, FilterEncodingNode *psFilterNode,
+                                  int bDefaultSRSNeedsAxisSwapping) {
+  if (psFilterNode == NULL)
+    return;
 
-    if( psFilterNode->eType == FILTER_NODE_TYPE_SPATIAL &&
-        psFilterNode->psRightNode->eType == FILTER_NODE_TYPE_BBOX )
-    {
-        rectObj* rect = (rectObj *)psFilterNode->psRightNode->pOther;
-        const char* pszSRS = psFilterNode->pszSRS;
-        if( (pszSRS != NULL && FLTNeedSRSSwapping(map, pszSRS)) ||
-            (pszSRS == NULL && bDefaultSRSNeedsAxisSwapping) )
-        {
-            double tmp;
-
-            tmp = rect->minx;
-            rect->minx = rect->miny;
-            rect->miny = tmp;
-
-            tmp = rect->maxx;
-            rect->maxx = rect->maxy;
-            rect->maxy = tmp;
-        }
-    }
-    else if( psFilterNode->eType == FILTER_NODE_TYPE_SPATIAL &&
-             FLTIsGeometryFilterNodeType(psFilterNode->psRightNode->eType) )
-    {
-        shapeObj* shape = (shapeObj *)(psFilterNode->psRightNode->pOther);
-        const char* pszSRS = psFilterNode->pszSRS;
-        if( (pszSRS != NULL && FLTNeedSRSSwapping(map, pszSRS)) ||
-            (pszSRS == NULL && bDefaultSRSNeedsAxisSwapping) )
-        {
-            msAxisSwapShape(shape);
-        }
-    }
-    else
-    {
-        FLTDoAxisSwappingIfNecessary(map, psFilterNode->psLeftNode, bDefaultSRSNeedsAxisSwapping);
-        FLTDoAxisSwappingIfNecessary(map, psFilterNode->psRightNode, bDefaultSRSNeedsAxisSwapping);
+  if (psFilterNode->eType == FILTER_NODE_TYPE_SPATIAL &&
+      psFilterNode->psRightNode->eType == FILTER_NODE_TYPE_BBOX) {
+    rectObj *rect = (rectObj *)psFilterNode->psRightNode->pOther;
+    const char *pszSRS = psFilterNode->pszSRS;
+    if ((pszSRS != NULL && FLTNeedSRSSwapping(map, pszSRS)) ||
+        (pszSRS == NULL && bDefaultSRSNeedsAxisSwapping)) {
+      double tmp;
+
+      tmp = rect->minx;
+      rect->minx = rect->miny;
+      rect->miny = tmp;
+
+      tmp = rect->maxx;
+      rect->maxx = rect->maxy;
+      rect->maxy = tmp;
+    }
+  } else if (psFilterNode->eType == FILTER_NODE_TYPE_SPATIAL &&
+             FLTIsGeometryFilterNodeType(psFilterNode->psRightNode->eType)) {
+    shapeObj *shape = (shapeObj *)(psFilterNode->psRightNode->pOther);
+    const char *pszSRS = psFilterNode->pszSRS;
+    if ((pszSRS != NULL && FLTNeedSRSSwapping(map, pszSRS)) ||
+        (pszSRS == NULL && bDefaultSRSNeedsAxisSwapping)) {
+      msAxisSwapShape(shape);
     }
+  } else {
+    FLTDoAxisSwappingIfNecessary(map, psFilterNode->psLeftNode,
+                                 bDefaultSRSNeedsAxisSwapping);
+    FLTDoAxisSwappingIfNecessary(map, psFilterNode->psRightNode,
+                                 bDefaultSRSNeedsAxisSwapping);
+  }
 }
 
-
 static void FLTReplacePropertyName(FilterEncodingNode *psFilterNode,
                                    const char *pszOldName,
-                                   const char *pszNewName)
-{
+                                   const char *pszNewName) {
   if (psFilterNode && pszOldName && pszNewName) {
     if (psFilterNode->eType == FILTER_NODE_TYPE_PROPERTYNAME) {
       if (psFilterNode->pszValue &&
@@ -2992,45 +2909,39 @@ static void FLTReplacePropertyName(Filte
       }
     }
     if (psFilterNode->psLeftNode)
-      FLTReplacePropertyName(psFilterNode->psLeftNode, pszOldName,
-                             pszNewName);
+      FLTReplacePropertyName(psFilterNode->psLeftNode, pszOldName, pszNewName);
     if (psFilterNode->psRightNode)
-      FLTReplacePropertyName(psFilterNode->psRightNode, pszOldName,
-                             pszNewName);
+      FLTReplacePropertyName(psFilterNode->psRightNode, pszOldName, pszNewName);
   }
 }
 
-
-static int FLTIsGMLDefaultProperty(const char* pszName)
-{
-    return (strcmp(pszName, "gml:name") == 0 ||
-            strcmp(pszName, "gml:description") == 0 ||
-            strcmp(pszName, "gml:descriptionReference") == 0 ||
-            strcmp(pszName, "gml:identifier") == 0 ||
-            strcmp(pszName, "gml:boundedBy") == 0 ||
-            strcmp(pszName, "@gml:id") == 0);
+static int FLTIsGMLDefaultProperty(const char *pszName) {
+  return (strcmp(pszName, "gml:name") == 0 ||
+          strcmp(pszName, "gml:description") == 0 ||
+          strcmp(pszName, "gml:descriptionReference") == 0 ||
+          strcmp(pszName, "gml:identifier") == 0 ||
+          strcmp(pszName, "gml:boundedBy") == 0 ||
+          strcmp(pszName, "@gml:id") == 0);
 }
 
-static void FLTStripNameSpacesFromPropertyName(FilterEncodingNode *psFilterNode)
-{
-  char **tokens=NULL;
-  int n=0;
+static void
+FLTStripNameSpacesFromPropertyName(FilterEncodingNode *psFilterNode) {
+  char **tokens = NULL;
+  int n = 0;
 
   if (psFilterNode) {
 
     if (psFilterNode->eType == FILTER_NODE_TYPE_COMPARISON &&
         psFilterNode->psLeftNode != NULL &&
         psFilterNode->psLeftNode->eType == FILTER_NODE_TYPE_PROPERTYNAME &&
-        FLTIsGMLDefaultProperty(psFilterNode->psLeftNode->pszValue) )
-    {
-        return;
+        FLTIsGMLDefaultProperty(psFilterNode->psLeftNode->pszValue)) {
+      return;
     }
 
     if (psFilterNode->eType == FILTER_NODE_TYPE_PROPERTYNAME) {
-      if (psFilterNode->pszValue &&
-          strstr(psFilterNode->pszValue, ":")) {
+      if (psFilterNode->pszValue && strstr(psFilterNode->pszValue, ":")) {
         tokens = msStringSplit(psFilterNode->pszValue, ':', &n);
-        if (tokens && n==2) {
+        if (tokens && n == 2) {
           msFree(psFilterNode->pszValue);
           psFilterNode->pszValue = msStrdup(tokens[1]);
         }
@@ -3042,34 +2953,32 @@ static void FLTStripNameSpacesFromProper
     if (psFilterNode->psRightNode)
       FLTStripNameSpacesFromPropertyName(psFilterNode->psRightNode);
   }
-
 }
 
 static void FLTRemoveGroupName(FilterEncodingNode *psFilterNode,
-                               gmlGroupListObj* groupList)
-{
+                               gmlGroupListObj *groupList) {
   int i;
 
   if (psFilterNode) {
 
     if (psFilterNode->eType == FILTER_NODE_TYPE_PROPERTYNAME) {
-      if( psFilterNode->pszValue != NULL )
-      {
-        const char* pszPropertyName = psFilterNode->pszValue;
-        const char* pszSlash = strchr(pszPropertyName, '/');
-        if( pszSlash != NULL ) {
-          const char* pszColon = strchr(pszPropertyName, ':');
-          if( pszColon != NULL && pszColon < pszSlash )
-              pszPropertyName = pszColon + 1;
-          for(i=0;i<groupList->numgroups;i++) {
-            const char* pszGroupName = groupList->groups[i].name;
+      if (psFilterNode->pszValue != NULL) {
+        const char *pszPropertyName = psFilterNode->pszValue;
+        const char *pszSlash = strchr(pszPropertyName, '/');
+        if (pszSlash != NULL) {
+          const char *pszColon = strchr(pszPropertyName, ':');
+          if (pszColon != NULL && pszColon < pszSlash)
+            pszPropertyName = pszColon + 1;
+          for (i = 0; i < groupList->numgroups; i++) {
+            const char *pszGroupName = groupList->groups[i].name;
             size_t nGroupNameLen = strlen(pszGroupName);
-            if(strncasecmp(pszPropertyName, pszGroupName, nGroupNameLen) == 0 &&
-                            pszPropertyName[nGroupNameLen] == '/') {
-              char* pszTmp;
+            if (strncasecmp(pszPropertyName, pszGroupName, nGroupNameLen) ==
+                    0 &&
+                pszPropertyName[nGroupNameLen] == '/') {
+              char *pszTmp;
               pszPropertyName = pszPropertyName + nGroupNameLen + 1;
               pszColon = strchr(pszPropertyName, ':');
-              if( pszColon != NULL )
+              if (pszColon != NULL)
                 pszPropertyName = pszColon + 1;
               pszTmp = msStrdup(pszPropertyName);
               msFree(psFilterNode->pszValue);
@@ -3086,7 +2995,6 @@ static void FLTRemoveGroupName(FilterEnc
     if (psFilterNode->psRightNode)
       FLTRemoveGroupName(psFilterNode->psRightNode, groupList);
   }
-
 }
 
 /************************************************************************/
@@ -3096,10 +3004,11 @@ static void FLTRemoveGroupName(FilterEnc
 /*      with their internal name.                                       */
 /************************************************************************/
 void FLTPreParseFilterForAliasAndGroup(FilterEncodingNode *psFilterNode,
-                               mapObj *map, int i, const char *namespaces)
-{
-#if defined(USE_WMS_SVR) || defined (USE_WFS_SVR) || defined (USE_WCS_SVR) || defined(USE_SOS_SVR)
-  if (psFilterNode && map && i>=0 && i<map->numlayers) {
+                                       mapObj *map, int i,
+                                       const char *namespaces) {
+#if defined(USE_WMS_SVR) || defined(USE_WFS_SVR) || defined(USE_WCS_SVR) ||    \
+    defined(USE_SOS_SVR)
+  if (psFilterNode && map && i >= 0 && i < map->numlayers) {
     /*strip name spaces before hand*/
     FLTStripNameSpacesFromPropertyName(psFilterNode);
 
@@ -3107,24 +3016,26 @@ void FLTPreParseFilterForAliasAndGroup(F
     int layerWasOpened = msLayerIsOpen(lp);
     if (msLayerOpen(lp) == MS_SUCCESS && msLayerGetItems(lp) == MS_SUCCESS) {
 
-      /* Remove group names from property names if using groupname/itemname syntax */
-      gmlGroupListObj* groupList = msGMLGetGroups(lp, namespaces);
-      if( groupList && groupList->numgroups > 0 )
+      /* Remove group names from property names if using groupname/itemname
+       * syntax */
+      gmlGroupListObj *groupList = msGMLGetGroups(lp, namespaces);
+      if (groupList && groupList->numgroups > 0)
         FLTRemoveGroupName(psFilterNode, groupList);
       msGMLFreeGroups(groupList);
 
-      for(i=0; i<lp->numitems; i++) {
+      for (i = 0; i < lp->numitems; i++) {
         if (!lp->items[i] || strlen(lp->items[i]) <= 0)
           continue;
         char szTmp[256];
         snprintf(szTmp, sizeof(szTmp), "%s_alias", lp->items[i]);
-        const char *pszFullName = msOWSLookupMetadata(&(lp->metadata), namespaces, szTmp);
+        const char *pszFullName =
+            msOWSLookupMetadata(&(lp->metadata), namespaces, szTmp);
         if (pszFullName) {
-          FLTReplacePropertyName(psFilterNode, pszFullName,
-                                 lp->items[i]);
+          FLTReplacePropertyName(psFilterNode, pszFullName, lp->items[i]);
         }
       }
-      if (!layerWasOpened) /* do not close the layer if it has been opened somewhere else (paging?) */
+      if (!layerWasOpened) /* do not close the layer if it has been opened
+                              somewhere else (paging?) */
         msLayerClose(lp);
     }
   }
@@ -3141,48 +3052,43 @@ void FLTPreParseFilterForAliasAndGroup(F
 /*      Check that FeatureId filters match features in the active       */
 /*      layer.                                                          */
 /************************************************************************/
-int FLTCheckFeatureIdFilters(FilterEncodingNode *psFilterNode,
-                             mapObj *map, int i)
-{
-    int status = MS_SUCCESS;
-    
-    if (psFilterNode->eType ==  FILTER_NODE_TYPE_FEATUREID)
-    {
-        char** tokens;
-        int nTokens = 0;
-        layerObj* lp;
-        int j;
+int FLTCheckFeatureIdFilters(FilterEncodingNode *psFilterNode, mapObj *map,
+                             int i) {
+  int status = MS_SUCCESS;
 
-        lp = GET_LAYER(map, i);
-        tokens = msStringSplit(psFilterNode->pszValue,',', &nTokens);
-        for (j=0; j<nTokens; j++) {
-            const char* pszId = tokens[j];
-            const char* pszDot = strrchr(pszId, '.');
-            if( pszDot )
-            {
-                if( static_cast<size_t>(pszDot - pszId) != strlen(lp->name) ||
-                    strncasecmp(pszId, lp->name, strlen(lp->name)) != 0 )
-                {
-                    msSetError(MS_MISCERR, "Feature id %s not consistent with feature type name %s.",
-                               "FLTPreParseFilterForAlias()", pszId, lp->name);
-                    status = MS_FAILURE;
-                    break;
-                }
-            }
+  if (psFilterNode->eType == FILTER_NODE_TYPE_FEATUREID) {
+    char **tokens;
+    int nTokens = 0;
+    layerObj *lp;
+    int j;
+
+    lp = GET_LAYER(map, i);
+    tokens = msStringSplit(psFilterNode->pszValue, ',', &nTokens);
+    for (j = 0; j < nTokens; j++) {
+      const char *pszId = tokens[j];
+      const char *pszDot = strrchr(pszId, '.');
+      if (pszDot) {
+        if (static_cast<size_t>(pszDot - pszId) != strlen(lp->name) ||
+            strncasecmp(pszId, lp->name, strlen(lp->name)) != 0) {
+          msSetError(MS_MISCERR,
+                     "Feature id %s not consistent with feature type name %s.",
+                     "FLTPreParseFilterForAlias()", pszId, lp->name);
+          status = MS_FAILURE;
+          break;
         }
-        msFreeCharArray(tokens, nTokens);
+      }
     }
+    msFreeCharArray(tokens, nTokens);
+  }
 
-    if (psFilterNode->psLeftNode)
-    {
-      status = FLTCheckFeatureIdFilters(psFilterNode->psLeftNode, map, i);
-      if( status == MS_SUCCESS )
-      {
-        if (psFilterNode->psRightNode)
-            status = FLTCheckFeatureIdFilters(psFilterNode->psRightNode, map, i);
-      }
+  if (psFilterNode->psLeftNode) {
+    status = FLTCheckFeatureIdFilters(psFilterNode->psLeftNode, map, i);
+    if (status == MS_SUCCESS) {
+      if (psFilterNode->psRightNode)
+        status = FLTCheckFeatureIdFilters(psFilterNode->psRightNode, map, i);
     }
-    return status;
+  }
+  return status;
 }
 
 /************************************************************************/
@@ -3191,33 +3097,29 @@ int FLTCheckFeatureIdFilters(FilterEncod
 /*      Check that the operand of a comparison operator is valid        */
 /*      Currently only detects use of boundedBy in a binary comparison  */
 /************************************************************************/
-int FLTCheckInvalidOperand(FilterEncodingNode *psFilterNode)
-{
-    int status = MS_SUCCESS;
+int FLTCheckInvalidOperand(FilterEncodingNode *psFilterNode) {
+  int status = MS_SUCCESS;
 
-    if (psFilterNode->eType ==  FILTER_NODE_TYPE_COMPARISON &&
-        psFilterNode->psLeftNode != NULL &&
-        psFilterNode->psLeftNode->eType == FILTER_NODE_TYPE_PROPERTYNAME)
-    {
-        if( strcmp(psFilterNode->psLeftNode->pszValue, "gml:boundedBy") == 0 &&
-            strcmp(psFilterNode->pszValue, "PropertyIsNull") != 0 &&
-            strcmp(psFilterNode->pszValue, "PropertyIsNil") != 0 )
-        {
-            msSetError(MS_MISCERR, "Operand '%s' is invalid in comparison.",
-                       "FLTCheckInvalidOperand()", psFilterNode->psLeftNode->pszValue);
-            return MS_FAILURE;
-        }
+  if (psFilterNode->eType == FILTER_NODE_TYPE_COMPARISON &&
+      psFilterNode->psLeftNode != NULL &&
+      psFilterNode->psLeftNode->eType == FILTER_NODE_TYPE_PROPERTYNAME) {
+    if (strcmp(psFilterNode->psLeftNode->pszValue, "gml:boundedBy") == 0 &&
+        strcmp(psFilterNode->pszValue, "PropertyIsNull") != 0 &&
+        strcmp(psFilterNode->pszValue, "PropertyIsNil") != 0) {
+      msSetError(MS_MISCERR, "Operand '%s' is invalid in comparison.",
+                 "FLTCheckInvalidOperand()",
+                 psFilterNode->psLeftNode->pszValue);
+      return MS_FAILURE;
     }
-    if (psFilterNode->psLeftNode)
-    {
-      status = FLTCheckInvalidOperand(psFilterNode->psLeftNode);
-      if( status == MS_SUCCESS )
-      {
-        if (psFilterNode->psRightNode)
-            status = FLTCheckInvalidOperand(psFilterNode->psRightNode);
-      }
+  }
+  if (psFilterNode->psLeftNode) {
+    status = FLTCheckInvalidOperand(psFilterNode->psLeftNode);
+    if (status == MS_SUCCESS) {
+      if (psFilterNode->psRightNode)
+        status = FLTCheckInvalidOperand(psFilterNode->psRightNode);
     }
-    return status;
+  }
+  return status;
 }
 
 /************************************************************************/
@@ -3226,49 +3128,45 @@ int FLTCheckInvalidOperand(FilterEncodin
 /*      HACK for PropertyIsNull processing. PostGIS & Spatialite only   */
 /*      for now.                                                        */
 /************************************************************************/
-int FLTProcessPropertyIsNull(FilterEncodingNode *psFilterNode,
-                            mapObj *map, int i)
-{
-    int status = MS_SUCCESS;
-
-    if (psFilterNode->eType == FILTER_NODE_TYPE_COMPARISON &&
-        psFilterNode->psLeftNode != NULL &&
-        psFilterNode->psLeftNode->eType == FILTER_NODE_TYPE_PROPERTYNAME &&
-        strcmp(psFilterNode->pszValue, "PropertyIsNull") == 0 &&
-        !FLTIsGMLDefaultProperty(psFilterNode->psLeftNode->pszValue) )
-    {
-        layerObj* lp;
-        int layerWasOpened;
-
-        lp = GET_LAYER(map, i);
-        layerWasOpened = msLayerIsOpen(lp);
-
-        /* Horrible HACK to compensate for the lack of null testing in MapServer */
-        if( (lp->connectiontype == MS_POSTGIS ||
-             (lp->connectiontype == MS_OGR && msOGRSupportsIsNull(lp))) &&
-            strcmp(psFilterNode->pszValue, "PropertyIsNull") == 0 )
-        {
-            msFree(psFilterNode->pszValue);
-            psFilterNode->pszValue = msStrdup("PropertyIsEqualTo");
-            psFilterNode->psRightNode = FLTCreateBinaryCompFilterEncodingNode();
-            psFilterNode->psRightNode->eType = FILTER_NODE_TYPE_LITERAL;
-            psFilterNode->psRightNode->pszValue = msStrdup("_MAPSERVER_NULL_");
-        }
-
-        if (!layerWasOpened) /* do not close the layer if it has been opened somewhere else (paging?) */
-          msLayerClose(lp);
-    }
+int FLTProcessPropertyIsNull(FilterEncodingNode *psFilterNode, mapObj *map,
+                             int i) {
+  int status = MS_SUCCESS;
+
+  if (psFilterNode->eType == FILTER_NODE_TYPE_COMPARISON &&
+      psFilterNode->psLeftNode != NULL &&
+      psFilterNode->psLeftNode->eType == FILTER_NODE_TYPE_PROPERTYNAME &&
+      strcmp(psFilterNode->pszValue, "PropertyIsNull") == 0 &&
+      !FLTIsGMLDefaultProperty(psFilterNode->psLeftNode->pszValue)) {
+    layerObj *lp;
+    int layerWasOpened;
+
+    lp = GET_LAYER(map, i);
+    layerWasOpened = msLayerIsOpen(lp);
+
+    /* Horrible HACK to compensate for the lack of null testing in MapServer */
+    if ((lp->connectiontype == MS_POSTGIS ||
+         (lp->connectiontype == MS_OGR && msOGRSupportsIsNull(lp))) &&
+        strcmp(psFilterNode->pszValue, "PropertyIsNull") == 0) {
+      msFree(psFilterNode->pszValue);
+      psFilterNode->pszValue = msStrdup("PropertyIsEqualTo");
+      psFilterNode->psRightNode = FLTCreateBinaryCompFilterEncodingNode();
+      psFilterNode->psRightNode->eType = FILTER_NODE_TYPE_LITERAL;
+      psFilterNode->psRightNode->pszValue = msStrdup("_MAPSERVER_NULL_");
+    }
+
+    if (!layerWasOpened) /* do not close the layer if it has been opened
+                            somewhere else (paging?) */
+      msLayerClose(lp);
+  }
 
-    if (psFilterNode->psLeftNode)
-    {
-      status = FLTProcessPropertyIsNull(psFilterNode->psLeftNode, map, i);
-      if( status == MS_SUCCESS )
-      {
-        if (psFilterNode->psRightNode)
-            status = FLTProcessPropertyIsNull(psFilterNode->psRightNode, map, i);
-      }
+  if (psFilterNode->psLeftNode) {
+    status = FLTProcessPropertyIsNull(psFilterNode->psLeftNode, map, i);
+    if (status == MS_SUCCESS) {
+      if (psFilterNode->psRightNode)
+        status = FLTProcessPropertyIsNull(psFilterNode->psRightNode, map, i);
     }
-    return status;
+  }
+  return status;
 }
 
 /************************************************************************/
@@ -3276,65 +3174,62 @@ int FLTProcessPropertyIsNull(FilterEncod
 /*                                                                      */
 /*      Check that property names are known                             */
 /************************************************************************/
-int FLTCheckInvalidProperty(FilterEncodingNode *psFilterNode,
-                            mapObj *map, int i)
-{
-    int status = MS_SUCCESS;
-
-    if (psFilterNode->eType ==  FILTER_NODE_TYPE_COMPARISON &&
-        psFilterNode->psLeftNode != NULL &&
-        psFilterNode->psLeftNode->eType == FILTER_NODE_TYPE_PROPERTYNAME)
-    {
-        layerObj* lp;
-        int layerWasOpened;
-        int bFound = MS_FALSE;
-
-        if ((strcmp(psFilterNode->pszValue, "PropertyIsNull") == 0 ||
-             strcmp(psFilterNode->pszValue, "PropertyIsNil") == 0) && 
-             FLTIsGMLDefaultProperty(psFilterNode->psLeftNode->pszValue) )
-        {
-            return MS_SUCCESS;
-        }
-
-        lp = GET_LAYER(map, i);
-        layerWasOpened = msLayerIsOpen(lp);
-        if ((layerWasOpened || msLayerOpen(lp) == MS_SUCCESS) 
-             && msLayerGetItems(lp) == MS_SUCCESS) {
-          int i;
-          gmlItemListObj* items = msGMLGetItems(lp, "G");
-          for(i=0; i<items->numitems; i++) {
-            if (!items->items[i].name || strlen(items->items[i].name) == 0 ||
-                !items->items[i].visible)
-              continue;
-            if (strcasecmp(items->items[i].name, psFilterNode->psLeftNode->pszValue) == 0) {
-                bFound = MS_TRUE;
-                break;
-            }
-          }
-          msGMLFreeItems(items);
+int FLTCheckInvalidProperty(FilterEncodingNode *psFilterNode, mapObj *map,
+                            int i) {
+  int status = MS_SUCCESS;
+
+  if (psFilterNode->eType == FILTER_NODE_TYPE_COMPARISON &&
+      psFilterNode->psLeftNode != NULL &&
+      psFilterNode->psLeftNode->eType == FILTER_NODE_TYPE_PROPERTYNAME) {
+    layerObj *lp;
+    int layerWasOpened;
+    int bFound = MS_FALSE;
+
+    if ((strcmp(psFilterNode->pszValue, "PropertyIsNull") == 0 ||
+         strcmp(psFilterNode->pszValue, "PropertyIsNil") == 0) &&
+        FLTIsGMLDefaultProperty(psFilterNode->psLeftNode->pszValue)) {
+      return MS_SUCCESS;
+    }
+
+    lp = GET_LAYER(map, i);
+    layerWasOpened = msLayerIsOpen(lp);
+    if ((layerWasOpened || msLayerOpen(lp) == MS_SUCCESS) &&
+        msLayerGetItems(lp) == MS_SUCCESS) {
+      int i;
+      gmlItemListObj *items = msGMLGetItems(lp, "G");
+      for (i = 0; i < items->numitems; i++) {
+        if (!items->items[i].name || strlen(items->items[i].name) == 0 ||
+            !items->items[i].visible)
+          continue;
+        if (strcasecmp(items->items[i].name,
+                       psFilterNode->psLeftNode->pszValue) == 0) {
+          bFound = MS_TRUE;
+          break;
         }
+      }
+      msGMLFreeItems(items);
+    }
 
-        if (!layerWasOpened) /* do not close the layer if it has been opened somewhere else (paging?) */
-          msLayerClose(lp);
+    if (!layerWasOpened) /* do not close the layer if it has been opened
+                            somewhere else (paging?) */
+      msLayerClose(lp);
 
-        if( !bFound )
-        {
-            msSetError(MS_MISCERR, "Property '%s' is unknown.",
-                       "FLTCheckInvalidProperty()", psFilterNode->psLeftNode->pszValue);
-            return MS_FAILURE;
-        }
+    if (!bFound) {
+      msSetError(MS_MISCERR, "Property '%s' is unknown.",
+                 "FLTCheckInvalidProperty()",
+                 psFilterNode->psLeftNode->pszValue);
+      return MS_FAILURE;
     }
+  }
 
-    if (psFilterNode->psLeftNode)
-    {
-      status = FLTCheckInvalidProperty(psFilterNode->psLeftNode, map, i);
-      if( status == MS_SUCCESS )
-      {
-        if (psFilterNode->psRightNode)
-            status = FLTCheckInvalidProperty(psFilterNode->psRightNode, map, i);
-      }
+  if (psFilterNode->psLeftNode) {
+    status = FLTCheckInvalidProperty(psFilterNode->psLeftNode, map, i);
+    if (status == MS_SUCCESS) {
+      if (psFilterNode->psRightNode)
+        status = FLTCheckInvalidProperty(psFilterNode->psRightNode, map, i);
     }
-    return status;
+  }
+  return status;
 }
 
 /************************************************************************/
@@ -3348,160 +3243,179 @@ int FLTCheckInvalidProperty(FilterEncodi
 /*      that  the filter evaluates to FALSE, or MS_TRUE that it         */
 /*      evaluates to TRUE                                               */
 /************************************************************************/
-FilterEncodingNode* FLTSimplify(FilterEncodingNode *psFilterNode,
-                                int* pnEvaluation)
-{
-    *pnEvaluation = -1;
+FilterEncodingNode *FLTSimplify(FilterEncodingNode *psFilterNode,
+                                int *pnEvaluation) {
+  *pnEvaluation = -1;
+
+  /* There are no nullable or nillable property in WFS currently */
+  /* except gml:name or gml:description that are null */
+  if (psFilterNode->eType == FILTER_NODE_TYPE_COMPARISON &&
+      (strcmp(psFilterNode->pszValue, "PropertyIsNull") == 0 ||
+       strcmp(psFilterNode->pszValue, "PropertyIsNil") == 0) &&
+      psFilterNode->psLeftNode != NULL &&
+      psFilterNode->psLeftNode->eType == FILTER_NODE_TYPE_PROPERTYNAME) {
+    if (strcmp(psFilterNode->pszValue, "PropertyIsNull") == 0 &&
+        FLTIsGMLDefaultProperty(psFilterNode->psLeftNode->pszValue) &&
+        strcmp(psFilterNode->psLeftNode->pszValue, "@gml:id") != 0 &&
+        strcmp(psFilterNode->psLeftNode->pszValue, "gml:boundedBy") != 0)
+      *pnEvaluation = MS_TRUE;
+    else
+      *pnEvaluation = MS_FALSE;
+    FLTFreeFilterEncodingNode(psFilterNode);
+    return NULL;
+  }
 
-    /* There are no nullable or nillable property in WFS currently */
-    /* except gml:name or gml:description that are null */
-    if( psFilterNode->eType ==  FILTER_NODE_TYPE_COMPARISON &&
-        (strcmp(psFilterNode->pszValue, "PropertyIsNull") == 0 ||
-         strcmp(psFilterNode->pszValue, "PropertyIsNil") == 0 ) &&
-        psFilterNode->psLeftNode != NULL &&
-        psFilterNode->psLeftNode->eType == FILTER_NODE_TYPE_PROPERTYNAME )
-    {
-        if( strcmp(psFilterNode->pszValue, "PropertyIsNull") == 0 &&
-            FLTIsGMLDefaultProperty(psFilterNode->psLeftNode->pszValue) &&
-            strcmp(psFilterNode->psLeftNode->pszValue, "@gml:id") != 0  &&
-            strcmp(psFilterNode->psLeftNode->pszValue, "gml:boundedBy") != 0)
-            *pnEvaluation = MS_TRUE;
-        else
-            *pnEvaluation = MS_FALSE;
-        FLTFreeFilterEncodingNode(psFilterNode);
-        return NULL;
+  if (psFilterNode->eType == FILTER_NODE_TYPE_LOGICAL &&
+      strcasecmp(psFilterNode->pszValue, "NOT") == 0 &&
+      psFilterNode->psLeftNode != NULL) {
+    int nEvaluation;
+    psFilterNode->psLeftNode =
+        FLTSimplify(psFilterNode->psLeftNode, &nEvaluation);
+    if (psFilterNode->psLeftNode == NULL) {
+      *pnEvaluation = 1 - nEvaluation;
+      FLTFreeFilterEncodingNode(psFilterNode);
+      return NULL;
     }
+  }
 
-    if( psFilterNode->eType ==  FILTER_NODE_TYPE_LOGICAL &&
-        strcasecmp(psFilterNode->pszValue, "NOT") == 0 &&
-        psFilterNode->psLeftNode != NULL )
-    {
-        int nEvaluation;
-        psFilterNode->psLeftNode = FLTSimplify(psFilterNode->psLeftNode,
-                                               &nEvaluation);
-        if( psFilterNode->psLeftNode == NULL )
-        {
-            *pnEvaluation = 1 - nEvaluation;
-            FLTFreeFilterEncodingNode(psFilterNode);
-            return NULL;
-        }
-    }
+  if (psFilterNode->eType == FILTER_NODE_TYPE_LOGICAL &&
+      (strcasecmp(psFilterNode->pszValue, "AND") == 0 ||
+       strcasecmp(psFilterNode->pszValue, "OR") == 0) &&
+      psFilterNode->psLeftNode != NULL && psFilterNode->psRightNode != NULL) {
+    FilterEncodingNode *psOtherNode;
+    int nEvaluation;
+    int nExpectedValForFastExit;
+    psFilterNode->psLeftNode =
+        FLTSimplify(psFilterNode->psLeftNode, &nEvaluation);
 
-    if( psFilterNode->eType ==  FILTER_NODE_TYPE_LOGICAL &&
-        (strcasecmp(psFilterNode->pszValue, "AND") == 0 ||
-         strcasecmp(psFilterNode->pszValue, "OR") == 0) &&
-        psFilterNode->psLeftNode != NULL &&
-        psFilterNode->psRightNode != NULL )
-    {
-        FilterEncodingNode* psOtherNode;
-        int nEvaluation;
-        int nExpectedValForFastExit;
-        psFilterNode->psLeftNode = FLTSimplify(psFilterNode->psLeftNode,
-                                               &nEvaluation);
+    if (strcasecmp(psFilterNode->pszValue, "AND") == 0)
+      nExpectedValForFastExit = MS_FALSE;
+    else
+      nExpectedValForFastExit = MS_TRUE;
 
-        if( strcasecmp(psFilterNode->pszValue, "AND") == 0 )
-            nExpectedValForFastExit = MS_FALSE;
-        else
-            nExpectedValForFastExit = MS_TRUE;
+    if (psFilterNode->psLeftNode == NULL) {
+      if (nEvaluation == nExpectedValForFastExit) {
+        *pnEvaluation = nEvaluation;
+        FLTFreeFilterEncodingNode(psFilterNode);
+        return NULL;
+      }
+      psOtherNode = psFilterNode->psRightNode;
+      psFilterNode->psRightNode = NULL;
+      FLTFreeFilterEncodingNode(psFilterNode);
+      return FLTSimplify(psOtherNode, pnEvaluation);
+    }
 
-        if( psFilterNode->psLeftNode == NULL )
-        {
-            if( nEvaluation == nExpectedValForFastExit )
-            {
-                *pnEvaluation = nEvaluation;
-                FLTFreeFilterEncodingNode(psFilterNode);
-                return NULL;
-            }
-            psOtherNode = psFilterNode->psRightNode;
-            psFilterNode->psRightNode = NULL;
-            FLTFreeFilterEncodingNode(psFilterNode);
-            return FLTSimplify(psOtherNode, pnEvaluation);
-        }
- 
-        psFilterNode->psRightNode = FLTSimplify(psFilterNode->psRightNode,
-                                                &nEvaluation);
-        if( psFilterNode->psRightNode == NULL )
-        {
-            if( nEvaluation == nExpectedValForFastExit )
-            {
-                *pnEvaluation = nEvaluation;
-                FLTFreeFilterEncodingNode(psFilterNode);
-                return NULL;
-            }
-            psOtherNode = psFilterNode->psLeftNode;
-            psFilterNode->psLeftNode = NULL;
-            FLTFreeFilterEncodingNode(psFilterNode);
-            return FLTSimplify(psOtherNode, pnEvaluation);
-        }
+    psFilterNode->psRightNode =
+        FLTSimplify(psFilterNode->psRightNode, &nEvaluation);
+    if (psFilterNode->psRightNode == NULL) {
+      if (nEvaluation == nExpectedValForFastExit) {
+        *pnEvaluation = nEvaluation;
+        FLTFreeFilterEncodingNode(psFilterNode);
+        return NULL;
+      }
+      psOtherNode = psFilterNode->psLeftNode;
+      psFilterNode->psLeftNode = NULL;
+      FLTFreeFilterEncodingNode(psFilterNode);
+      return FLTSimplify(psOtherNode, pnEvaluation);
     }
+  }
 
-    return psFilterNode;
+  return psFilterNode;
 }
 
-
 #ifdef USE_LIBXML2
 
-xmlNodePtr FLTGetCapabilities(xmlNsPtr psNsParent, xmlNsPtr psNsOgc, int bTemporal)
-{
-  xmlNodePtr psRootNode = NULL, psNode = NULL, psSubNode = NULL, psSubSubNode = NULL;
+xmlNodePtr FLTGetCapabilities(xmlNsPtr psNsParent, xmlNsPtr psNsOgc,
+                              int bTemporal) {
+  xmlNodePtr psRootNode = NULL, psNode = NULL, psSubNode = NULL,
+             psSubSubNode = NULL;
 
   psRootNode = xmlNewNode(psNsParent, BAD_CAST "Filter_Capabilities");
 
-  psNode = xmlNewChild(psRootNode, psNsOgc, BAD_CAST "Spatial_Capabilities", NULL);
+  psNode =
+      xmlNewChild(psRootNode, psNsOgc, BAD_CAST "Spatial_Capabilities", NULL);
 
   psSubNode = xmlNewChild(psNode, psNsOgc, BAD_CAST "GeometryOperands", NULL);
-  xmlNewChild(psSubNode, psNsOgc, BAD_CAST "GeometryOperand", BAD_CAST "gml:Point");
-  xmlNewChild(psSubNode, psNsOgc, BAD_CAST "GeometryOperand", BAD_CAST "gml:LineString");
-  xmlNewChild(psSubNode, psNsOgc, BAD_CAST "GeometryOperand", BAD_CAST "gml:Polygon");
-  xmlNewChild(psSubNode, psNsOgc, BAD_CAST "GeometryOperand", BAD_CAST "gml:Envelope");
+  xmlNewChild(psSubNode, psNsOgc, BAD_CAST "GeometryOperand",
+              BAD_CAST "gml:Point");
+  xmlNewChild(psSubNode, psNsOgc, BAD_CAST "GeometryOperand",
+              BAD_CAST "gml:LineString");
+  xmlNewChild(psSubNode, psNsOgc, BAD_CAST "GeometryOperand",
+              BAD_CAST "gml:Polygon");
+  xmlNewChild(psSubNode, psNsOgc, BAD_CAST "GeometryOperand",
+              BAD_CAST "gml:Envelope");
 
   psSubNode = xmlNewChild(psNode, psNsOgc, BAD_CAST "SpatialOperators", NULL);
 #ifdef USE_GEOS
-  psSubSubNode = xmlNewChild(psSubNode, psNsOgc, BAD_CAST "SpatialOperator", NULL);
+  psSubSubNode =
+      xmlNewChild(psSubNode, psNsOgc, BAD_CAST "SpatialOperator", NULL);
   xmlNewProp(psSubSubNode, BAD_CAST "name", BAD_CAST "Equals");
-  psSubSubNode = xmlNewChild(psSubNode, psNsOgc, BAD_CAST "SpatialOperator", NULL);
+  psSubSubNode =
+      xmlNewChild(psSubNode, psNsOgc, BAD_CAST "SpatialOperator", NULL);
   xmlNewProp(psSubSubNode, BAD_CAST "name", BAD_CAST "Disjoint");
-  psSubSubNode = xmlNewChild(psSubNode, psNsOgc, BAD_CAST "SpatialOperator", NULL);
+  psSubSubNode =
+      xmlNewChild(psSubNode, psNsOgc, BAD_CAST "SpatialOperator", NULL);
   xmlNewProp(psSubSubNode, BAD_CAST "name", BAD_CAST "Touches");
-  psSubSubNode = xmlNewChild(psSubNode, psNsOgc, BAD_CAST "SpatialOperator", NULL);
+  psSubSubNode =
+      xmlNewChild(psSubNode, psNsOgc, BAD_CAST "SpatialOperator", NULL);
   xmlNewProp(psSubSubNode, BAD_CAST "name", BAD_CAST "Within");
-  psSubSubNode = xmlNewChild(psSubNode, psNsOgc, BAD_CAST "SpatialOperator", NULL);
+  psSubSubNode =
+      xmlNewChild(psSubNode, psNsOgc, BAD_CAST "SpatialOperator", NULL);
   xmlNewProp(psSubSubNode, BAD_CAST "name", BAD_CAST "Overlaps");
-  psSubSubNode = xmlNewChild(psSubNode, psNsOgc, BAD_CAST "SpatialOperator", NULL);
+  psSubSubNode =
+      xmlNewChild(psSubNode, psNsOgc, BAD_CAST "SpatialOperator", NULL);
   xmlNewProp(psSubSubNode, BAD_CAST "name", BAD_CAST "Crosses");
-  psSubSubNode = xmlNewChild(psSubNode, psNsOgc, BAD_CAST "SpatialOperator", NULL);
+  psSubSubNode =
+      xmlNewChild(psSubNode, psNsOgc, BAD_CAST "SpatialOperator", NULL);
   xmlNewProp(psSubSubNode, BAD_CAST "name", BAD_CAST "Intersects");
-  psSubSubNode = xmlNewChild(psSubNode, psNsOgc, BAD_CAST "SpatialOperator", NULL);
+  psSubSubNode =
+      xmlNewChild(psSubNode, psNsOgc, BAD_CAST "SpatialOperator", NULL);
   xmlNewProp(psSubSubNode, BAD_CAST "name", BAD_CAST "Contains");
-  psSubSubNode = xmlNewChild(psSubNode, psNsOgc, BAD_CAST "SpatialOperator", NULL);
+  psSubSubNode =
+      xmlNewChild(psSubNode, psNsOgc, BAD_CAST "SpatialOperator", NULL);
   xmlNewProp(psSubSubNode, BAD_CAST "name", BAD_CAST "DWithin");
-  psSubSubNode = xmlNewChild(psSubNode, psNsOgc, BAD_CAST "SpatialOperator", NULL);
+  psSubSubNode =
+      xmlNewChild(psSubNode, psNsOgc, BAD_CAST "SpatialOperator", NULL);
   xmlNewProp(psSubSubNode, BAD_CAST "name", BAD_CAST "Beyond");
 #endif
-  psSubSubNode = xmlNewChild(psSubNode, psNsOgc, BAD_CAST "SpatialOperator", NULL);
+  psSubSubNode =
+      xmlNewChild(psSubNode, psNsOgc, BAD_CAST "SpatialOperator", NULL);
   xmlNewProp(psSubSubNode, BAD_CAST "name", BAD_CAST "BBOX");
 
   if (bTemporal) {
-    psNode = xmlNewChild(psRootNode, psNsOgc, BAD_CAST "Temporal_Capabilities", NULL);
+    psNode = xmlNewChild(psRootNode, psNsOgc, BAD_CAST "Temporal_Capabilities",
+                         NULL);
     psSubNode = xmlNewChild(psNode, psNsOgc, BAD_CAST "TemporalOperands", NULL);
-    xmlNewChild(psSubNode, psNsOgc, BAD_CAST "TemporalOperand", BAD_CAST "gml:TimePeriod");
-    xmlNewChild(psSubNode, psNsOgc, BAD_CAST "TemporalOperand", BAD_CAST "gml:TimeInstant");
-
-    psSubNode = xmlNewChild(psNode, psNsOgc, BAD_CAST "TemporalOperators", NULL);
-    psSubSubNode = xmlNewChild(psSubNode, psNsOgc, BAD_CAST "TemporalOperator", NULL);
+    xmlNewChild(psSubNode, psNsOgc, BAD_CAST "TemporalOperand",
+                BAD_CAST "gml:TimePeriod");
+    xmlNewChild(psSubNode, psNsOgc, BAD_CAST "TemporalOperand",
+                BAD_CAST "gml:TimeInstant");
+
+    psSubNode =
+        xmlNewChild(psNode, psNsOgc, BAD_CAST "TemporalOperators", NULL);
+    psSubSubNode =
+        xmlNewChild(psSubNode, psNsOgc, BAD_CAST "TemporalOperator", NULL);
     xmlNewProp(psSubSubNode, BAD_CAST "name", BAD_CAST "TM_Equals");
   }
-  psNode = xmlNewChild(psRootNode, psNsOgc, BAD_CAST "Scalar_Capabilities", NULL);
+  psNode =
+      xmlNewChild(psRootNode, psNsOgc, BAD_CAST "Scalar_Capabilities", NULL);
   xmlNewChild(psNode, psNsOgc, BAD_CAST "LogicalOperators", NULL);
   psNode = xmlNewChild(psNode, psNsOgc, BAD_CAST "ComparisonOperators", NULL);
-  xmlNewChild(psNode, psNsOgc, BAD_CAST "ComparisonOperator", BAD_CAST "LessThan");
-  xmlNewChild(psNode, psNsOgc, BAD_CAST "ComparisonOperator", BAD_CAST "GreaterThan");
-  xmlNewChild(psNode, psNsOgc, BAD_CAST "ComparisonOperator", BAD_CAST "LessThanEqualTo");
-  xmlNewChild(psNode, psNsOgc, BAD_CAST "ComparisonOperator", BAD_CAST "GreaterThanEqualTo");
-  xmlNewChild(psNode, psNsOgc, BAD_CAST "ComparisonOperator", BAD_CAST "EqualTo");
-  xmlNewChild(psNode, psNsOgc, BAD_CAST "ComparisonOperator", BAD_CAST "NotEqualTo");
+  xmlNewChild(psNode, psNsOgc, BAD_CAST "ComparisonOperator",
+              BAD_CAST "LessThan");
+  xmlNewChild(psNode, psNsOgc, BAD_CAST "ComparisonOperator",
+              BAD_CAST "GreaterThan");
+  xmlNewChild(psNode, psNsOgc, BAD_CAST "ComparisonOperator",
+              BAD_CAST "LessThanEqualTo");
+  xmlNewChild(psNode, psNsOgc, BAD_CAST "ComparisonOperator",
+              BAD_CAST "GreaterThanEqualTo");
+  xmlNewChild(psNode, psNsOgc, BAD_CAST "ComparisonOperator",
+              BAD_CAST "EqualTo");
+  xmlNewChild(psNode, psNsOgc, BAD_CAST "ComparisonOperator",
+              BAD_CAST "NotEqualTo");
   xmlNewChild(psNode, psNsOgc, BAD_CAST "ComparisonOperator", BAD_CAST "Like");
-  xmlNewChild(psNode, psNsOgc, BAD_CAST "ComparisonOperator", BAD_CAST "Between");
+  xmlNewChild(psNode, psNsOgc, BAD_CAST "ComparisonOperator",
+              BAD_CAST "Between");
 
   psNode = xmlNewChild(psRootNode, psNsOgc, BAD_CAST "Id_Capabilities", NULL);
   xmlNewChild(psNode, psNsOgc, BAD_CAST "EID", NULL);
diff -pruN 8.0.1-5/mapogcfilter.h 8.0.2-1/mapogcfilter.h
--- 8.0.1-5/mapogcfilter.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapogcfilter.h	2024-06-11 20:41:34.000000000 +0000
@@ -36,8 +36,8 @@
 
 #ifdef USE_LIBXML2
 
-#include<libxml/parser.h>
-#include<libxml/tree.h>
+#include <libxml/parser.h>
+#include <libxml/tree.h>
 #endif
 
 #ifdef __cplusplus
@@ -48,26 +48,32 @@ typedef struct {
   char *pszWildCard;
   char *pszSingleChar;
   char *pszEscapeChar;
-  int  bCaseInsensitive;
+  int bCaseInsensitive;
 } FEPropertyIsLike;
 
 /* -------------------------------------------------------------------- */
 /*      prototypes.                                                     */
 /* -------------------------------------------------------------------- */
 MS_DLL_EXPORT int FLTIsNumeric(const char *pszValue);
-MS_DLL_EXPORT int FLTApplyExpressionToLayer(layerObj *lp, const char *pszExpression);
-MS_DLL_EXPORT  char *FLTGetExpressionForValuesRanges(layerObj *lp, const char *item, const char *value,  int forcecharcter);
+MS_DLL_EXPORT int FLTApplyExpressionToLayer(layerObj *lp,
+                                            const char *pszExpression);
+MS_DLL_EXPORT char *FLTGetExpressionForValuesRanges(layerObj *lp,
+                                                    const char *item,
+                                                    const char *value,
+                                                    int forcecharcter);
 
-MS_DLL_EXPORT FilterEncodingNode *FLTParseFilterEncoding(const char *szXMLString);
+MS_DLL_EXPORT FilterEncodingNode *
+FLTParseFilterEncoding(const char *szXMLString);
 MS_DLL_EXPORT FilterEncodingNode *FLTCreateFilterEncodingNode(void);
-MS_DLL_EXPORT char** FLTSplitFilters(const char* pszStr, int* pnTokens);
+MS_DLL_EXPORT char **FLTSplitFilters(const char *pszStr, int *pnTokens);
 MS_DLL_EXPORT int FLTApplyFilterToLayer(FilterEncodingNode *psNode, mapObj *map,
                                         int iLayerIndex);
 
-MS_DLL_EXPORT int FLTLayerApplyCondSQLFilterToLayer(FilterEncodingNode *psNode, mapObj *map,
-    int iLayerIndex);
-MS_DLL_EXPORT int FLTLayerApplyPlainFilterToLayer(FilterEncodingNode *psNode, mapObj *map,
-    int iLayerIndex);
+MS_DLL_EXPORT int FLTLayerApplyCondSQLFilterToLayer(FilterEncodingNode *psNode,
+                                                    mapObj *map,
+                                                    int iLayerIndex);
+MS_DLL_EXPORT int FLTLayerApplyPlainFilterToLayer(FilterEncodingNode *psNode,
+                                                  mapObj *map, int iLayerIndex);
 
 MS_DLL_EXPORT void FLTFreeFilterEncodingNode(FilterEncodingNode *psFilterNode);
 
@@ -80,11 +86,12 @@ MS_DLL_EXPORT int FLTIsPointFilter(Filte
 MS_DLL_EXPORT int FLTIsLineFilter(FilterEncodingNode *psFilterNode);
 MS_DLL_EXPORT int FLTIsPolygonFilter(FilterEncodingNode *psFilterNode);
 
-MS_DLL_EXPORT int FLTValidForPropertyIsLikeFilter(FilterEncodingNode *psFilterNode);
+MS_DLL_EXPORT int
+FLTValidForPropertyIsLikeFilter(FilterEncodingNode *psFilterNode);
 MS_DLL_EXPORT int FLTIsOnlyPropertyIsLike(FilterEncodingNode *psFilterNode);
 
 MS_DLL_EXPORT void FLTInsertElementInNode(FilterEncodingNode *psFilterNode,
-    CPLXMLNode *psXMLNode);
+                                          CPLXMLNode *psXMLNode);
 MS_DLL_EXPORT int FLTIsLogicalFilterType(const char *pszValue);
 MS_DLL_EXPORT int FLTIsBinaryComparisonFilterType(const char *pszValue);
 MS_DLL_EXPORT int FLTIsComparisonFilterType(const char *pszValue);
@@ -93,60 +100,81 @@ MS_DLL_EXPORT int FLTIsSpatialFilterType
 MS_DLL_EXPORT int FLTIsTemporalFilterType(const char *pszValue);
 MS_DLL_EXPORT int FLTIsSupportedFilterType(CPLXMLNode *psXMLNode);
 
-MS_DLL_EXPORT const char *FLTGetBBOX(FilterEncodingNode *psFilterNode, rectObj *psRect);
-const char* FLTGetDuring(FilterEncodingNode *psFilterNode, const char** ppszTimeField);
+MS_DLL_EXPORT const char *FLTGetBBOX(FilterEncodingNode *psFilterNode,
+                                     rectObj *psRect);
+const char *FLTGetDuring(FilterEncodingNode *psFilterNode,
+                         const char **ppszTimeField);
 
-MS_DLL_EXPORT shapeObj *FLTGetShape(FilterEncodingNode *psFilterNode, double *pdfDistance,
-                                    int *pnUnit);
+MS_DLL_EXPORT shapeObj *FLTGetShape(FilterEncodingNode *psFilterNode,
+                                    double *pdfDistance, int *pnUnit);
 
 MS_DLL_EXPORT int FLTHasSpatialFilter(FilterEncodingNode *psFilterNode);
 
-
 /*SQL expressions related functions.*/
-MS_DLL_EXPORT int FLTApplySimpleSQLFilter(FilterEncodingNode *psNode, mapObj *map,
-    int iLayerIndex);
-
-MS_DLL_EXPORT char *FLTGetSQLExpression(FilterEncodingNode *psFilterNode,layerObj *lp);
-MS_DLL_EXPORT char *FLTGetBinaryComparisonSQLExpresssion(FilterEncodingNode *psFilterNode, layerObj *lp);
-MS_DLL_EXPORT char *FLTGetIsBetweenComparisonSQLExpresssion(FilterEncodingNode *psFilterNode, layerObj *lp);
-MS_DLL_EXPORT char *FLTGetIsLikeComparisonSQLExpression(FilterEncodingNode *psFilterNode, layerObj *lp);
+MS_DLL_EXPORT int FLTApplySimpleSQLFilter(FilterEncodingNode *psNode,
+                                          mapObj *map, int iLayerIndex);
 
-MS_DLL_EXPORT char *FLTGetLogicalComparisonSQLExpresssion(FilterEncodingNode *psFilterNode,
-    layerObj *lp);
+MS_DLL_EXPORT char *FLTGetSQLExpression(FilterEncodingNode *psFilterNode,
+                                        layerObj *lp);
+MS_DLL_EXPORT char *
+FLTGetBinaryComparisonSQLExpresssion(FilterEncodingNode *psFilterNode,
+                                     layerObj *lp);
+MS_DLL_EXPORT char *
+FLTGetIsBetweenComparisonSQLExpresssion(FilterEncodingNode *psFilterNode,
+                                        layerObj *lp);
+MS_DLL_EXPORT char *
+FLTGetIsLikeComparisonSQLExpression(FilterEncodingNode *psFilterNode,
+                                    layerObj *lp);
+
+MS_DLL_EXPORT char *
+FLTGetLogicalComparisonSQLExpresssion(FilterEncodingNode *psFilterNode,
+                                      layerObj *lp);
 MS_DLL_EXPORT int FLTIsSimpleFilter(FilterEncodingNode *psFilterNode);
 
-MS_DLL_EXPORT FilterEncodingNode *FLTCreateFeatureIdFilterEncoding(const char *pszString);
+MS_DLL_EXPORT FilterEncodingNode *
+FLTCreateFeatureIdFilterEncoding(const char *pszString);
 
-MS_DLL_EXPORT int FLTParseGMLEnvelope(CPLXMLNode *psRoot, rectObj *psBbox, char **ppszSRS);
-MS_DLL_EXPORT  int FLTParseGMLBox(CPLXMLNode *psBox, rectObj *psBbox, char **ppszSRS);
+MS_DLL_EXPORT int FLTParseGMLEnvelope(CPLXMLNode *psRoot, rectObj *psBbox,
+                                      char **ppszSRS);
+MS_DLL_EXPORT int FLTParseGMLBox(CPLXMLNode *psBox, rectObj *psBbox,
+                                 char **ppszSRS);
 
 /*common-expressions*/
-MS_DLL_EXPORT  char *FLTGetCommonExpression(FilterEncodingNode *psFilterNode, layerObj *lp);
-MS_DLL_EXPORT int FLTApplyFilterToLayerCommonExpression(mapObj *map, int iLayerIndex, const char *pszExpression);
+MS_DLL_EXPORT char *FLTGetCommonExpression(FilterEncodingNode *psFilterNode,
+                                           layerObj *lp);
+MS_DLL_EXPORT int
+FLTApplyFilterToLayerCommonExpression(mapObj *map, int iLayerIndex,
+                                      const char *pszExpression);
 
 #ifdef USE_LIBXML2
-MS_DLL_EXPORT xmlNodePtr FLTGetCapabilities(xmlNsPtr psNsParent, xmlNsPtr psNsOgc, int bTemporal);
+MS_DLL_EXPORT xmlNodePtr FLTGetCapabilities(xmlNsPtr psNsParent,
+                                            xmlNsPtr psNsOgc, int bTemporal);
 #endif
 
-void FLTDoAxisSwappingIfNecessary(mapObj *map, FilterEncodingNode *psFilterNode, int bDefaultSRSNeedsAxisSwapping);
+void FLTDoAxisSwappingIfNecessary(mapObj *map, FilterEncodingNode *psFilterNode,
+                                  int bDefaultSRSNeedsAxisSwapping);
 
 void FLTPreParseFilterForAliasAndGroup(FilterEncodingNode *psFilterNode,
-                                       mapObj *map, int i, const char *namespaces);
-int FLTCheckFeatureIdFilters(FilterEncodingNode *psFilterNode,
-                             mapObj *map, int i);
+                                       mapObj *map, int i,
+                                       const char *namespaces);
+int FLTCheckFeatureIdFilters(FilterEncodingNode *psFilterNode, mapObj *map,
+                             int i);
 int FLTCheckInvalidOperand(FilterEncodingNode *psFilterNode);
-int FLTCheckInvalidProperty(FilterEncodingNode *psFilterNode,
-                            mapObj *map, int i);
-FilterEncodingNode* FLTSimplify(FilterEncodingNode *psFilterNode,
-                                int* pnEvaluation);
-int FLTApplyFilterToLayerCommonExpressionWithRect(mapObj *map, int iLayerIndex, const char *pszExpression, rectObj rect);
-int FLTProcessPropertyIsNull(FilterEncodingNode *psFilterNode,
-                            mapObj *map, int i);
-int FLTLayerSetInvalidRectIfSupported(layerObj* lp, rectObj* rect);
+int FLTCheckInvalidProperty(FilterEncodingNode *psFilterNode, mapObj *map,
+                            int i);
+FilterEncodingNode *FLTSimplify(FilterEncodingNode *psFilterNode,
+                                int *pnEvaluation);
+int FLTApplyFilterToLayerCommonExpressionWithRect(mapObj *map, int iLayerIndex,
+                                                  const char *pszExpression,
+                                                  rectObj rect);
+int FLTProcessPropertyIsNull(FilterEncodingNode *psFilterNode, mapObj *map,
+                             int i);
+int FLTLayerSetInvalidRectIfSupported(layerObj *lp, rectObj *rect);
 
 #ifdef __cplusplus
 }
-std::string FLTGetTimeExpression(FilterEncodingNode *psFilterNode, layerObj *lp);
+std::string FLTGetTimeExpression(FilterEncodingNode *psFilterNode,
+                                 layerObj *lp);
 
 #endif
 
diff -pruN 8.0.1-5/mapogcfiltercommon.cpp 8.0.2-1/mapogcfiltercommon.cpp
--- 8.0.1-5/mapogcfiltercommon.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapogcfiltercommon.cpp	2024-06-11 20:41:34.000000000 +0000
@@ -34,22 +34,27 @@
 
 #include <string>
 
-static std::string FLTGetIsLikeComparisonCommonExpression(FilterEncodingNode *psFilterNode)
-{
-  /* From http://pubs.opengroup.org/onlinepubs/009695399/basedefs/xbd_chap09.html#tag_09_04 */
+static std::string
+FLTGetIsLikeComparisonCommonExpression(FilterEncodingNode *psFilterNode) {
+  /* From
+   * http://pubs.opengroup.org/onlinepubs/009695399/basedefs/xbd_chap09.html#tag_09_04
+   */
   /* also add double quote because we are within a string */
-  const char* pszRegexSpecialCharsAndDoubleQuote = "\\^${[().*+?|\"";
+  const char *pszRegexSpecialCharsAndDoubleQuote = "\\^${[().*+?|\"";
 
-  if (!psFilterNode || !psFilterNode->pOther || !psFilterNode->psLeftNode || !psFilterNode->psRightNode || !psFilterNode->psRightNode->pszValue)
+  if (!psFilterNode || !psFilterNode->pOther || !psFilterNode->psLeftNode ||
+      !psFilterNode->psRightNode || !psFilterNode->psRightNode->pszValue)
     return std::string();
 
-  const FEPropertyIsLike* propIsLike = (const FEPropertyIsLike *)psFilterNode->pOther;
-  const char* pszWild = propIsLike->pszWildCard;
-  const char* pszSingle = propIsLike->pszSingleChar;
-  const char* pszEscape = propIsLike->pszEscapeChar;
+  const FEPropertyIsLike *propIsLike =
+      (const FEPropertyIsLike *)psFilterNode->pOther;
+  const char *pszWild = propIsLike->pszWildCard;
+  const char *pszSingle = propIsLike->pszSingleChar;
+  const char *pszEscape = propIsLike->pszEscapeChar;
   const bool bCaseInsensitive = propIsLike->bCaseInsensitive != 0;
 
-  if (!pszWild || strlen(pszWild) == 0 || !pszSingle || strlen(pszSingle) == 0 || !pszEscape || strlen(pszEscape) == 0)
+  if (!pszWild || strlen(pszWild) == 0 || !pszSingle ||
+      strlen(pszSingle) == 0 || !pszEscape || strlen(pszEscape) == 0)
     return std::string();
 
   /* -------------------------------------------------------------------- */
@@ -61,62 +66,61 @@ static std::string FLTGetIsLikeCompariso
   expr += psFilterNode->psLeftNode->pszValue;
 
   /* #3521 */
-  if (bCaseInsensitive )
+  if (bCaseInsensitive)
     expr += "]\" ~* \"";
   else
     expr += "]\" ~ \"";
 
-  const char* pszValue = psFilterNode->psRightNode->pszValue;
+  const char *pszValue = psFilterNode->psRightNode->pszValue;
   const size_t nLength = strlen(pszValue);
 
   if (nLength > 0) {
     expr += '^';
   }
-  for (size_t i=0; i<nLength; i++) {
+  for (size_t i = 0; i < nLength; i++) {
     if (pszValue[i] == pszSingle[0]) {
       expr += '.';
-    /* The Filter escape character is supposed to only escape the single, wildcard and escape character */
-    } else if (pszValue[i] == pszEscape[0] && (
-                    pszValue[i+1] == pszSingle[0] ||
-                    pszValue[i+1] == pszWild[0] ||
-                    pszValue[i+1] == pszEscape[0])) {
-      if( pszValue[i+1] == '\\' )
-      {
-          /* Tricky case: \ must be escaped ncce in the regular expression context
-             so that the regexp matches it as an ordinary character.
-             But as \ is also the escape character for MapServer string, we
-             must escape it again. */
-          expr += "\\" "\\" "\\" "\\";
-      }
-      else
-      {
-        /* If the escaped character is itself a regular expression special character */
+      /* The Filter escape character is supposed to only escape the single,
+       * wildcard and escape character */
+    } else if (pszValue[i] == pszEscape[0] &&
+               (pszValue[i + 1] == pszSingle[0] ||
+                pszValue[i + 1] == pszWild[0] ||
+                pszValue[i + 1] == pszEscape[0])) {
+      if (pszValue[i + 1] == '\\') {
+        /* Tricky case: \ must be escaped ncce in the regular expression context
+           so that the regexp matches it as an ordinary character.
+           But as \ is also the escape character for MapServer string, we
+           must escape it again. */
+        expr += "\\"
+                "\\"
+                "\\"
+                "\\";
+      } else {
+        /* If the escaped character is itself a regular expression special
+         * character */
         /* we need to regular-expression-escape-it ! */
-        if( strchr(pszRegexSpecialCharsAndDoubleQuote, pszValue[i+1]) )
-        {
-            expr += '\\';
+        if (strchr(pszRegexSpecialCharsAndDoubleQuote, pszValue[i + 1])) {
+          expr += '\\';
         }
-        expr += pszValue[i+1];
+        expr += pszValue[i + 1];
       }
       i++;
     } else if (pszValue[i] == pszWild[0]) {
       expr += ".*";
     }
     /* Escape regular expressions special characters and double quote */
-    else if (strchr(pszRegexSpecialCharsAndDoubleQuote, pszValue[i]))
-    {
-      if( pszValue[i] == '\\' )
-      {
-          /* See above explantation */
-          expr += "\\" "\\" "\\" "\\";
-      }
-      else
-      {
+    else if (strchr(pszRegexSpecialCharsAndDoubleQuote, pszValue[i])) {
+      if (pszValue[i] == '\\') {
+        /* See above explantation */
+        expr += "\\"
+                "\\"
+                "\\"
+                "\\";
+      } else {
         expr += '\\';
         expr += pszValue[i];
       }
-    }
-    else {
+    } else {
       expr += pszValue[i];
     }
   }
@@ -127,9 +131,10 @@ static std::string FLTGetIsLikeCompariso
   return expr;
 }
 
-static std::string FLTGetIsBetweenComparisonCommonExpresssion(FilterEncodingNode *psFilterNode, layerObj *lp)
-{
-  if (psFilterNode->psLeftNode == NULL || psFilterNode->psRightNode == NULL )
+static std::string
+FLTGetIsBetweenComparisonCommonExpresssion(FilterEncodingNode *psFilterNode,
+                                           layerObj *lp) {
+  if (psFilterNode->psLeftNode == NULL || psFilterNode->psRightNode == NULL)
     return std::string();
 
   /* -------------------------------------------------------------------- */
@@ -147,8 +152,9 @@ static std::string FLTGetIsBetweenCompar
   bool bString = false;
   bool bDateTime = false;
 
-  const char* pszType = msOWSLookupMetadata(&(lp->metadata), "OFG",
-    (std::string(psFilterNode->psLeftNode->pszValue)+ "_type").c_str());
+  const char *pszType = msOWSLookupMetadata(
+      &(lp->metadata), "OFG",
+      (std::string(psFilterNode->psLeftNode->pszValue) + "_type").c_str());
   if (pszType != NULL && (strcasecmp(pszType, "Character") == 0))
     bString = true;
   else if (pszType != NULL && (strcasecmp(pszType, "Date") == 0))
@@ -157,8 +163,8 @@ static std::string FLTGetIsBetweenCompar
     bString = true;
 
   if (!bString && !bDateTime) {
-      if (FLTIsNumeric(bounds[1].c_str()) == MS_FALSE)
-        bString = true;
+    if (FLTIsNumeric(bounds[1].c_str()) == MS_FALSE)
+      bString = true;
   }
 
   std::string expr;
@@ -182,8 +188,7 @@ static std::string FLTGetIsBetweenCompar
 
   if (bString) {
     expr += '\"';
-  }
-  else if (bDateTime) {
+  } else if (bDateTime) {
     expr += '`';
   }
 
@@ -191,8 +196,7 @@ static std::string FLTGetIsBetweenCompar
 
   if (bString) {
     expr += '\"';
-  }
-  else if (bDateTime) {
+  } else if (bDateTime) {
     expr += '`';
   }
 
@@ -215,8 +219,7 @@ static std::string FLTGetIsBetweenCompar
 
   if (bString) {
     expr += '\"';
-  }
-  else if (bDateTime) {
+  } else if (bDateTime) {
     expr += '`';
   }
 
@@ -224,8 +227,7 @@ static std::string FLTGetIsBetweenCompar
 
   if (bString) {
     expr += '\"';
-  }
-  else if (bDateTime) {
+  } else if (bDateTime) {
     expr += '`';
   }
   expr += ')';
@@ -233,9 +235,9 @@ static std::string FLTGetIsBetweenCompar
   return expr;
 }
 
-static
-std::string FLTGetBinaryComparisonCommonExpression(FilterEncodingNode *psFilterNode, layerObj *lp)
-{
+static std::string
+FLTGetBinaryComparisonCommonExpression(FilterEncodingNode *psFilterNode,
+                                       layerObj *lp) {
   /* -------------------------------------------------------------------- */
   /*      check if the value is a numeric value or alphanumeric. If it    */
   /*      is alphanumeric, add quotes around attribute and values.        */
@@ -243,11 +245,12 @@ std::string FLTGetBinaryComparisonCommon
   bool bString = false;
   bool bDateTime = false;
   if (psFilterNode->psRightNode->pszValue) {
-    const char* pszType = msOWSLookupMetadata(&(lp->metadata), "OFG",
+    const char *pszType = msOWSLookupMetadata(
+        &(lp->metadata), "OFG",
         (std::string(psFilterNode->psLeftNode->pszValue) + "_type").c_str());
-    if (pszType!= NULL && (strcasecmp(pszType, "Character") == 0))
+    if (pszType != NULL && (strcasecmp(pszType, "Character") == 0))
       bString = true;
-    else if (pszType!= NULL && (strcasecmp(pszType, "Date") == 0))
+    else if (pszType != NULL && (strcasecmp(pszType, "Date") == 0))
       bDateTime = true;
     else if (FLTIsNumeric(psFilterNode->psRightNode->pszValue) == MS_FALSE)
       bString = true;
@@ -255,7 +258,8 @@ std::string FLTGetBinaryComparisonCommon
 
   /* specical case to be able to have empty strings in the expression. */
   /* propertyislike is always treated as string */
-  if (psFilterNode->psRightNode->pszValue == NULL || strcasecmp(psFilterNode->pszValue, "PropertyIsLike") == 0)
+  if (psFilterNode->psRightNode->pszValue == NULL ||
+      strcasecmp(psFilterNode->pszValue, "PropertyIsLike") == 0)
     bString = true;
 
   /* attribute */
@@ -265,7 +269,7 @@ std::string FLTGetBinaryComparisonCommon
   else
     expr = "([";
   expr += psFilterNode->psLeftNode->pszValue;
-  
+
   if (bString)
     expr += "]\" ";
   else
@@ -273,7 +277,8 @@ std::string FLTGetBinaryComparisonCommon
 
   if (strcasecmp(psFilterNode->pszValue, "PropertyIsEqualTo") == 0) {
     /* case insensitive set ? */
-    if (psFilterNode->psRightNode->pOther && (*(int *)psFilterNode->psRightNode->pOther) == 1)
+    if (psFilterNode->psRightNode->pOther &&
+        (*(int *)psFilterNode->psRightNode->pOther) == 1)
       expr += "=*";
     else
       expr += "=";
@@ -283,9 +288,11 @@ std::string FLTGetBinaryComparisonCommon
     expr += "<";
   else if (strcasecmp(psFilterNode->pszValue, "PropertyIsGreaterThan") == 0)
     expr += ">";
-  else if (strcasecmp(psFilterNode->pszValue, "PropertyIsLessThanOrEqualTo") == 0)
+  else if (strcasecmp(psFilterNode->pszValue, "PropertyIsLessThanOrEqualTo") ==
+           0)
     expr += "<=";
-  else if (strcasecmp(psFilterNode->pszValue, "PropertyIsGreaterThanOrEqualTo") == 0)
+  else if (strcasecmp(psFilterNode->pszValue,
+                      "PropertyIsGreaterThanOrEqualTo") == 0)
     expr += ">=";
   else if (strcasecmp(psFilterNode->pszValue, "PropertyIsLike") == 0)
     expr += "~";
@@ -294,8 +301,7 @@ std::string FLTGetBinaryComparisonCommon
   /* value */
   if (bString) {
     expr += "\"";
-  }
-  else if (bDateTime) {
+  } else if (bDateTime) {
     expr += "`";
   }
 
@@ -305,8 +311,7 @@ std::string FLTGetBinaryComparisonCommon
 
   if (bString) {
     expr += "\"";
-  }
-  else if (bDateTime) {
+  } else if (bDateTime) {
     expr += "`";
   }
 
@@ -315,15 +320,15 @@ std::string FLTGetBinaryComparisonCommon
   return expr;
 }
 
-static
-std::string FLTGetLogicalComparisonCommonExpression(FilterEncodingNode *psFilterNode, layerObj *lp)
-{
+static std::string
+FLTGetLogicalComparisonCommonExpression(FilterEncodingNode *psFilterNode,
+                                        layerObj *lp) {
   std::string expr;
   /* -------------------------------------------------------------------- */
   /*      OR and AND                                                      */
   /* -------------------------------------------------------------------- */
   if (psFilterNode->psLeftNode && psFilterNode->psRightNode) {
-    char* pszTmp = FLTGetCommonExpression(psFilterNode->psLeftNode, lp);
+    char *pszTmp = FLTGetCommonExpression(psFilterNode->psLeftNode, lp);
     if (!pszTmp)
       return std::string();
 
@@ -346,8 +351,9 @@ std::string FLTGetLogicalComparisonCommo
   /* -------------------------------------------------------------------- */
   /*      NOT                                                             */
   /* -------------------------------------------------------------------- */
-  else if (psFilterNode->psLeftNode && strcasecmp(psFilterNode->pszValue, "NOT") == 0) {
-    char* pszTmp = FLTGetCommonExpression(psFilterNode->psLeftNode, lp);
+  else if (psFilterNode->psLeftNode &&
+           strcasecmp(psFilterNode->pszValue, "NOT") == 0) {
+    char *pszTmp = FLTGetCommonExpression(psFilterNode->psLeftNode, lp);
     if (!pszTmp)
       return std::string();
 
@@ -360,12 +366,12 @@ std::string FLTGetLogicalComparisonCommo
   return expr;
 }
 
-static
-std::string FLTGetSpatialComparisonCommonExpression(FilterEncodingNode *psNode, layerObj *lp)
-{
+static std::string
+FLTGetSpatialComparisonCommonExpression(FilterEncodingNode *psNode,
+                                        layerObj *lp) {
   std::string expr;
   double dfDistance = -1;
-  shapeObj *psTmpShape=NULL;
+  shapeObj *psTmpShape = NULL;
   bool bBBoxQuery = false;
   bool bAlreadyReprojected = false;
 
@@ -379,28 +385,28 @@ std::string FLTGetSpatialComparisonCommo
 
     char szPolygon[512];
     snprintf(szPolygon, sizeof(szPolygon),
-             "POLYGON((%.18f %.18f,%.18f %.18f,%.18f %.18f,%.18f %.18f,%.18f %.18f))",
-             sQueryRect.minx, sQueryRect.miny,
-             sQueryRect.minx, sQueryRect.maxy,
-             sQueryRect.maxx, sQueryRect.maxy,
-             sQueryRect.maxx, sQueryRect.miny,
+             "POLYGON((%.18f %.18f,%.18f %.18f,%.18f %.18f,%.18f %.18f,%.18f "
+             "%.18f))",
+             sQueryRect.minx, sQueryRect.miny, sQueryRect.minx, sQueryRect.maxy,
+             sQueryRect.maxx, sQueryRect.maxy, sQueryRect.maxx, sQueryRect.miny,
              sQueryRect.minx, sQueryRect.miny);
 
     psTmpShape = msShapeFromWKT(szPolygon);
 
-    /* 
+    /*
     ** This is a horrible hack to deal with world-extent requests and
-    ** reprojection. msProjectRect() detects if reprojection from longlat to 
-    ** projected SRS, and in that case it transforms the bbox to -1e-15,-1e-15,1e15,1e15
+    ** reprojection. msProjectRect() detects if reprojection from longlat to
+    ** projected SRS, and in that case it transforms the bbox to
+    *-1e-15,-1e-15,1e15,1e15
     ** to ensure that all features are returned.
     **
-    ** Make wfs_200_cite_filter_bbox_world.xml and wfs_200_cite_postgis_bbox_world.xml pass
+    ** Make wfs_200_cite_filter_bbox_world.xml and
+    *wfs_200_cite_postgis_bbox_world.xml pass
     */
     if (fabs(sQueryRect.minx - -180.0) < 1e-5 &&
         fabs(sQueryRect.miny - -90.0) < 1e-5 &&
         fabs(sQueryRect.maxx - 180.0) < 1e-5 &&
-        fabs(sQueryRect.maxy - 90.0) < 1e-5)
-    {
+        fabs(sQueryRect.maxy - 90.0) < 1e-5) {
       if (lp->projection.numargs > 0) {
         projectionObj sProjTmp;
         if (psNode->pszSRS) {
@@ -408,7 +414,8 @@ std::string FLTGetSpatialComparisonCommo
           msProjectionInheritContextFrom(&sProjTmp, &lp->projection);
         }
         if (psNode->pszSRS) {
-          /* Use the non EPSG variant since axis swapping is done in FLTDoAxisSwappingIfNecessary */
+          /* Use the non EPSG variant since axis swapping is done in
+           * FLTDoAxisSwappingIfNecessary */
           if (msLoadProjectionString(&sProjTmp, psNode->pszSRS) == 0) {
             msProjectRect(&sProjTmp, &lp->projection, &sQueryRect);
           }
@@ -420,7 +427,7 @@ std::string FLTGetSpatialComparisonCommo
       if (sQueryRect.minx <= -1e14) {
         msFreeShape(psTmpShape);
         msFree(psTmpShape);
-        psTmpShape = (shapeObj*) msSmallMalloc(sizeof(shapeObj));
+        psTmpShape = (shapeObj *)msSmallMalloc(sizeof(shapeObj));
         msInitShape(psTmpShape);
         msRectToPolygon(sQueryRect, psTmpShape);
         bAlreadyReprojected = true;
@@ -431,20 +438,27 @@ std::string FLTGetSpatialComparisonCommo
   } else {
     /* other geos type operations */
 
-    /* project shape to layer projection. If the proj is not part of the filter query,
-      assume that the cooredinates are in the map projection */
+    /* project shape to layer projection. If the proj is not part of the filter
+      query, assume that the cooredinates are in the map projection */
 
     int nUnit = -1;
-    shapeObj* psQueryShape = FLTGetShape(psNode, &dfDistance, &nUnit);
+    shapeObj *psQueryShape = FLTGetShape(psNode, &dfDistance, &nUnit);
 
-    if ((strcasecmp(psNode->pszValue, "DWithin") == 0 || strcasecmp(psNode->pszValue, "Beyond") == 0 ) && dfDistance > 0) {
+    if ((strcasecmp(psNode->pszValue, "DWithin") == 0 ||
+         strcasecmp(psNode->pszValue, "Beyond") == 0) &&
+        dfDistance > 0) {
       int nLayerUnit = lp->units;
-      if(nLayerUnit == -1) nLayerUnit = GetMapserverUnitUsingProj(&lp->projection);
-      if(nLayerUnit == -1) nLayerUnit = lp->map->units;
-      if(nLayerUnit == -1) nLayerUnit = GetMapserverUnitUsingProj(&lp->map->projection);
+      if (nLayerUnit == -1)
+        nLayerUnit = GetMapserverUnitUsingProj(&lp->projection);
+      if (nLayerUnit == -1)
+        nLayerUnit = lp->map->units;
+      if (nLayerUnit == -1)
+        nLayerUnit = GetMapserverUnitUsingProj(&lp->map->projection);
 
       if (nUnit >= 0 && nUnit != nLayerUnit)
-        dfDistance *= msInchesPerUnit(nUnit,0)/msInchesPerUnit(nLayerUnit,0); /* target is layer units */
+        dfDistance *=
+            msInchesPerUnit(nUnit, 0) /
+            msInchesPerUnit(nLayerUnit, 0); /* target is layer units */
     }
 
     psTmpShape = psQueryShape;
@@ -462,7 +476,8 @@ std::string FLTGetSpatialComparisonCommo
         msProjectionInheritContextFrom(&sProjTmp, &lp->projection);
       }
       if (psNode->pszSRS) {
-        /* Use the non EPSG variant since axis swapping is done in FLTDoAxisSwappingIfNecessary */
+        /* Use the non EPSG variant since axis swapping is done in
+         * FLTDoAxisSwappingIfNecessary */
         if (msLoadProjectionString(&sProjTmp, psNode->pszSRS) == 0) {
           msProjectShape(&sProjTmp, &lp->projection, psTmpShape);
         }
@@ -486,13 +501,15 @@ std::string FLTGetSpatialComparisonCommo
     expr += "([shape],fromText('";
 
     /* filter geometry */
-    char* pszWktText = msGEOSShapeToWKT(psTmpShape);
+    char *pszWktText = msGEOSShapeToWKT(psTmpShape);
     expr += pszWktText ? pszWktText : "Cannot translate shape to WKT";
     expr += "')";
     msGEOSFreeWKT(pszWktText);
 
-    /* (optional) beyond/dwithin distance, always 0.0 since we apply the distance as a buffer earlier */
-    if ((strcasecmp(psNode->pszValue, "DWithin") == 0 || strcasecmp(psNode->pszValue, "Beyond") == 0)) {
+    /* (optional) beyond/dwithin distance, always 0.0 since we apply the
+     * distance as a buffer earlier */
+    if ((strcasecmp(psNode->pszValue, "DWithin") == 0 ||
+         strcasecmp(psNode->pszValue, "Beyond") == 0)) {
       char szBuffer[256];
       sprintf(szBuffer, ",%g", dfDistance);
       expr += szBuffer;
@@ -513,29 +530,32 @@ std::string FLTGetSpatialComparisonCommo
   return expr;
 }
 
-static std::string FLTGetFeatureIdCommonExpression(FilterEncodingNode *psFilterNode, layerObj *lp)
-{
+static std::string
+FLTGetFeatureIdCommonExpression(FilterEncodingNode *psFilterNode,
+                                layerObj *lp) {
   std::string expr;
 
-#if defined(USE_WMS_SVR) || defined(USE_WFS_SVR) || defined(USE_WCS_SVR) || defined(USE_SOS_SVR)
+#if defined(USE_WMS_SVR) || defined(USE_WFS_SVR) || defined(USE_WCS_SVR) ||    \
+    defined(USE_SOS_SVR)
   if (psFilterNode->pszValue) {
-    const char* pszAttribute = msOWSLookupMetadata(&(lp->metadata), "OFG", "featureid");
+    const char *pszAttribute =
+        msOWSLookupMetadata(&(lp->metadata), "OFG", "featureid");
     if (pszAttribute) {
-      const auto tokens = msStringSplit(psFilterNode->pszValue,',');
+      const auto tokens = msStringSplit(psFilterNode->pszValue, ',');
       if (!tokens.empty()) {
-        for (size_t i=0; i < tokens.size(); i++) {
-          const char* pszId = tokens[i].c_str();
-          const char* pszDot = strrchr(pszId, '.');
-          if( pszDot )
+        for (size_t i = 0; i < tokens.size(); i++) {
+          const char *pszId = tokens[i].c_str();
+          const char *pszDot = strrchr(pszId, '.');
+          if (pszDot)
             pszId = pszDot + 1;
 
           bool bString = false;
           if (i == 0) {
-            if(FLTIsNumeric(pszId) == MS_FALSE)
+            if (FLTIsNumeric(pszId) == MS_FALSE)
               bString = true;
           }
 
-         if (!expr.empty())
+          if (!expr.empty())
             expr += " OR ";
           else
             expr = '(';
@@ -566,14 +586,14 @@ static std::string FLTGetFeatureIdCommon
   return expr;
 }
 
-std::string FLTGetTimeExpression(FilterEncodingNode *psFilterNode, layerObj *lp)
-{
+std::string FLTGetTimeExpression(FilterEncodingNode *psFilterNode,
+                                 layerObj *lp) {
   if (lp == NULL)
     return std::string();
 
   std::string expr;
-  const char* pszTimeField = nullptr;
-  const char* pszTimeValue = FLTGetDuring(psFilterNode, &pszTimeField);
+  const char *pszTimeField = nullptr;
+  const char *pszTimeValue = FLTGetDuring(psFilterNode, &pszTimeField);
   if (pszTimeField && pszTimeValue) {
     expressionObj old_filter;
     msInitExpression(&old_filter);
@@ -589,28 +609,34 @@ std::string FLTGetTimeExpression(FilterE
   return expr;
 }
 
-char *FLTGetCommonExpression(FilterEncodingNode *psFilterNode, layerObj *lp)
-{
+char *FLTGetCommonExpression(FilterEncodingNode *psFilterNode, layerObj *lp) {
   char *pszExpression = NULL;
 
   if (!psFilterNode)
     return NULL;
 
   if (psFilterNode->eType == FILTER_NODE_TYPE_COMPARISON) {
-    if ( psFilterNode->psLeftNode && psFilterNode->psRightNode) {
+    if (psFilterNode->psLeftNode && psFilterNode->psRightNode) {
       if (FLTIsBinaryComparisonFilterType(psFilterNode->pszValue))
-        pszExpression = msStrdup(FLTGetBinaryComparisonCommonExpression(psFilterNode, lp).c_str());
+        pszExpression = msStrdup(
+            FLTGetBinaryComparisonCommonExpression(psFilterNode, lp).c_str());
       else if (strcasecmp(psFilterNode->pszValue, "PropertyIsLike") == 0)
-        pszExpression = msStrdup(FLTGetIsLikeComparisonCommonExpression(psFilterNode).c_str());
+        pszExpression = msStrdup(
+            FLTGetIsLikeComparisonCommonExpression(psFilterNode).c_str());
       else if (strcasecmp(psFilterNode->pszValue, "PropertyIsBetween") == 0)
-        pszExpression = msStrdup(FLTGetIsBetweenComparisonCommonExpresssion(psFilterNode, lp).c_str());
+        pszExpression = msStrdup(
+            FLTGetIsBetweenComparisonCommonExpresssion(psFilterNode, lp)
+                .c_str());
     }
   } else if (psFilterNode->eType == FILTER_NODE_TYPE_LOGICAL) {
-    pszExpression = msStrdup(FLTGetLogicalComparisonCommonExpression(psFilterNode, lp).c_str());
+    pszExpression = msStrdup(
+        FLTGetLogicalComparisonCommonExpression(psFilterNode, lp).c_str());
   } else if (psFilterNode->eType == FILTER_NODE_TYPE_SPATIAL) {
-    pszExpression = msStrdup(FLTGetSpatialComparisonCommonExpression(psFilterNode, lp).c_str());
-  } else if (psFilterNode->eType ==  FILTER_NODE_TYPE_FEATUREID) {
-    pszExpression = msStrdup(FLTGetFeatureIdCommonExpression(psFilterNode, lp).c_str());
+    pszExpression = msStrdup(
+        FLTGetSpatialComparisonCommonExpression(psFilterNode, lp).c_str());
+  } else if (psFilterNode->eType == FILTER_NODE_TYPE_FEATUREID) {
+    pszExpression =
+        msStrdup(FLTGetFeatureIdCommonExpression(psFilterNode, lp).c_str());
   } else if (psFilterNode->eType == FILTER_NODE_TYPE_TEMPORAL) {
     pszExpression = msStrdup(FLTGetTimeExpression(psFilterNode, lp).c_str());
   }
@@ -618,14 +644,16 @@ char *FLTGetCommonExpression(FilterEncod
   return pszExpression;
 }
 
-int FLTApplyFilterToLayerCommonExpression(mapObj *map, int iLayerIndex, const char *pszExpression)
-{
-  return FLTApplyFilterToLayerCommonExpressionWithRect(map, iLayerIndex, pszExpression, map->extent);
+int FLTApplyFilterToLayerCommonExpression(mapObj *map, int iLayerIndex,
+                                          const char *pszExpression) {
+  return FLTApplyFilterToLayerCommonExpressionWithRect(
+      map, iLayerIndex, pszExpression, map->extent);
 }
 
 /* rect must be in map->projection */
-int FLTApplyFilterToLayerCommonExpressionWithRect(mapObj *map, int iLayerIndex, const char *pszExpression, rectObj rect)
-{
+int FLTApplyFilterToLayerCommonExpressionWithRect(mapObj *map, int iLayerIndex,
+                                                  const char *pszExpression,
+                                                  rectObj rect) {
   int retval;
 
   const int save_startindex = map->query.startindex;
@@ -633,7 +661,8 @@ int FLTApplyFilterToLayerCommonExpressio
   const int save_only_cache_result_count = map->query.only_cache_result_count;
   const int save_cache_shapes = map->query.cache_shapes;
   const int save_max_cached_shape_count = map->query.max_cached_shape_count;
-  const int save_max_cached_shape_ram_amount = map->query.max_cached_shape_ram_amount;
+  const int save_max_cached_shape_ram_amount =
+      map->query.max_cached_shape_ram_amount;
   msInitQuery(&(map->query));
   map->query.startindex = save_startindex;
   map->query.maxfeatures = save_maxfeatures;
@@ -647,17 +676,14 @@ int FLTApplyFilterToLayerCommonExpressio
 
   map->query.rect = rect;
 
-  if( pszExpression )
-  {
+  if (pszExpression) {
     map->query.type = MS_QUERY_BY_FILTER;
     msInitExpression(&map->query.filter);
     map->query.filter.string = msStrdup(pszExpression);
     map->query.filter.type = MS_EXPRESSION; /* a logical expression */
 
     retval = msQueryByFilter(map);
-  }
-  else
-  {
+  } else {
     map->query.type = MS_QUERY_BY_RECT;
     retval = msQueryByRect(map);
   }
diff -pruN 8.0.1-5/mapogcsld.c 8.0.2-1/mapogcsld.c
--- 8.0.1-5/mapogcsld.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapogcsld.c	2024-06-11 20:41:34.000000000 +0000
@@ -36,7 +36,9 @@
 extern int yyparse(parseObj *);
 
 #if defined(USE_CURL)
-static inline void IGUR_sizet(size_t ignored) { (void)ignored; }  /* Ignore GCC Unused Result */
+static inline void IGUR_sizet(size_t ignored) {
+  (void)ignored;
+} /* Ignore GCC Unused Result */
 #endif
 
 #define SLD_LINE_SYMBOL_NAME "sld_line_symbol"
@@ -62,56 +64,72 @@ static inline void IGUR_sizet(size_t ign
 /*      used to do the match.                                           */
 /************************************************************************/
 int msSLDApplySLDURL(mapObj *map, const char *szURL, int iLayer,
-                     const char *pszStyleLayerName,  char **ppszLayerNames)
-{
+                     const char *pszStyleLayerName, char **ppszLayerNames) {
   /* needed for libcurl function msHTTPGetFile in maphttp.c */
 #if defined(USE_CURL)
 
   char *pszSLDTmpFile = NULL;
   int status = 0;
-  char *pszSLDbuf=NULL;
+  char *pszSLDbuf = NULL;
   FILE *fp = NULL;
   int nStatus = MS_FAILURE;
 
   if (map && szURL) {
-    map->sldurl = (char*)szURL;
+    map->sldurl = (char *)szURL;
     pszSLDTmpFile = msTmpFile(map, map->mappath, NULL, "sld.xml");
     if (pszSLDTmpFile == NULL) {
-      pszSLDTmpFile = msTmpFile(map, NULL, NULL, "sld.xml" );
+      pszSLDTmpFile = msTmpFile(map, NULL, NULL, "sld.xml");
     }
     if (pszSLDTmpFile == NULL) {
-      msSetError(MS_WMSERR, "Could not determine temporary file. Please make sure that the temporary path is set. The temporary path can be defined for example by setting TEMPPATH in the map file. Please check the MapServer documentation on temporary path settings.", "msSLDApplySLDURL()");
+      msSetError(
+          MS_WMSERR,
+          "Could not determine temporary file. Please make sure that the "
+          "temporary path is set. The temporary path can be defined for "
+          "example by setting TEMPPATH in the map file. Please check the "
+          "MapServer documentation on temporary path settings.",
+          "msSLDApplySLDURL()");
     } else {
       int nMaxRemoteSLDBytes;
-      const char *pszMaxRemoteSLDBytes = msOWSLookupMetadata(&(map->web.metadata), "MO", "remote_sld_max_bytes");
-      if(!pszMaxRemoteSLDBytes) {
-        nMaxRemoteSLDBytes = 1024*1024; /* 1 megaByte */
+      const char *pszMaxRemoteSLDBytes = msOWSLookupMetadata(
+          &(map->web.metadata), "MO", "remote_sld_max_bytes");
+      if (!pszMaxRemoteSLDBytes) {
+        nMaxRemoteSLDBytes = 1024 * 1024; /* 1 megaByte */
       } else {
         nMaxRemoteSLDBytes = atoi(pszMaxRemoteSLDBytes);
       }
-      if (msHTTPGetFile(szURL, pszSLDTmpFile, &status,-1, 0, 0, nMaxRemoteSLDBytes) ==  MS_SUCCESS) {
+      if (msHTTPGetFile(szURL, pszSLDTmpFile, &status, -1, 0, 0,
+                        nMaxRemoteSLDBytes) == MS_SUCCESS) {
         if ((fp = fopen(pszSLDTmpFile, "rb")) != NULL) {
-          int   nBufsize=0;
+          int nBufsize = 0;
           fseek(fp, 0, SEEK_END);
           nBufsize = ftell(fp);
-          if(nBufsize > 0) {
+          if (nBufsize > 0) {
             rewind(fp);
-            pszSLDbuf = (char*)malloc((nBufsize+1)*sizeof(char));
+            pszSLDbuf = (char *)malloc((nBufsize + 1) * sizeof(char));
             IGUR_sizet(fread(pszSLDbuf, 1, nBufsize, fp));
             pszSLDbuf[nBufsize] = '\0';
           } else {
-            msSetError(MS_WMSERR, "Could not open SLD %s as it appears empty", "msSLDApplySLDURL", szURL);
+            msSetError(MS_WMSERR, "Could not open SLD %s as it appears empty",
+                       "msSLDApplySLDURL", szURL);
           }
           fclose(fp);
           unlink(pszSLDTmpFile);
         }
       } else {
         unlink(pszSLDTmpFile);
-        msSetError(MS_WMSERR, "Could not open SLD %s and save it in a temporary file. Please make sure that the sld url is valid and that the temporary path is set. The temporary path can be defined for example by setting TEMPPATH in the map file. Please check the MapServer documentation on temporary path settings.", "msSLDApplySLDURL", szURL);
+        msSetError(
+            MS_WMSERR,
+            "Could not open SLD %s and save it in a temporary file. Please "
+            "make sure that the sld url is valid and that the temporary path "
+            "is set. The temporary path can be defined for example by setting "
+            "TEMPPATH in the map file. Please check the MapServer "
+            "documentation on temporary path settings.",
+            "msSLDApplySLDURL", szURL);
       }
       msFree(pszSLDTmpFile);
       if (pszSLDbuf)
-        nStatus = msSLDApplySLD(map, pszSLDbuf, iLayer, pszStyleLayerName, ppszLayerNames);
+        nStatus = msSLDApplySLD(map, pszSLDbuf, iLayer, pszStyleLayerName,
+                                ppszLayerNames);
     }
     map->sldurl = NULL;
   }
@@ -121,54 +139,58 @@ int msSLDApplySLDURL(mapObj *map, const
   return nStatus;
 
 #else
-  msSetError(MS_MISCERR, "WMS/WFS client support is not enabled .", "msSLDApplySLDURL()");
-  return(MS_FAILURE);
+  msSetError(MS_MISCERR, "WMS/WFS client support is not enabled .",
+             "msSLDApplySLDURL()");
+  return (MS_FAILURE);
 #endif
 }
 
-#if defined(USE_WMS_SVR) || defined (USE_WFS_SVR) || defined (USE_WCS_SVR) || defined(USE_SOS_SVR)
+#if defined(USE_WMS_SVR) || defined(USE_WFS_SVR) || defined(USE_WCS_SVR) ||    \
+    defined(USE_SOS_SVR)
 /* -------------------------------------------------------------------- */
 /*      If the same layer is given more that once, we need to           */
 /*      duplicate it.                                                   */
 /* -------------------------------------------------------------------- */
-static void msSLDApplySLD_DuplicateLayers(mapObj *map, int nSLDLayers, layerObj *pasSLDLayers)
-{
-    int m;
-    for (m=0; m<nSLDLayers; m++) {
-      int l;
-      int nIndex = msGetLayerIndex(map, pasSLDLayers[m].name);
-      if(pasSLDLayers[m].name == NULL) continue;
-      if( nIndex < 0 ) continue;
-      for (l=m+1; l<nSLDLayers; l++) {
-        if(pasSLDLayers[l].name == NULL)
-          continue;
-        if (strcasecmp(pasSLDLayers[m].name, pasSLDLayers[l].name)== 0) {
-          layerObj* psTmpLayer = (layerObj *) malloc(sizeof(layerObj));
-          char tmpId[128];
-
-          initLayer(psTmpLayer, map);
-          msCopyLayer(psTmpLayer, GET_LAYER(map,nIndex));
-          /* open the source layer */
-          if ( !psTmpLayer->vtable) {
-            if( msInitializeVirtualTable(psTmpLayer) != MS_SUCCESS ) {
-                MS_REFCNT_DECR(psTmpLayer);
-                continue;
-            }
+static void msSLDApplySLD_DuplicateLayers(mapObj *map, int nSLDLayers,
+                                          layerObj *pasSLDLayers) {
+  int m;
+  for (m = 0; m < nSLDLayers; m++) {
+    int l;
+    int nIndex = msGetLayerIndex(map, pasSLDLayers[m].name);
+    if (pasSLDLayers[m].name == NULL)
+      continue;
+    if (nIndex < 0)
+      continue;
+    for (l = m + 1; l < nSLDLayers; l++) {
+      if (pasSLDLayers[l].name == NULL)
+        continue;
+      if (strcasecmp(pasSLDLayers[m].name, pasSLDLayers[l].name) == 0) {
+        layerObj *psTmpLayer = (layerObj *)malloc(sizeof(layerObj));
+        char tmpId[128];
+
+        initLayer(psTmpLayer, map);
+        msCopyLayer(psTmpLayer, GET_LAYER(map, nIndex));
+        /* open the source layer */
+        if (!psTmpLayer->vtable) {
+          if (msInitializeVirtualTable(psTmpLayer) != MS_SUCCESS) {
+            MS_REFCNT_DECR(psTmpLayer);
+            continue;
           }
-
-          /*make the name unique*/
-          snprintf(tmpId, sizeof(tmpId), "%lx_%x_%d",(long)time(NULL),(int)getpid(),
-                   map->numlayers);
-          if (psTmpLayer->name)
-            msFree(psTmpLayer->name);
-          psTmpLayer->name = msStrdup(tmpId);
-          msFree(pasSLDLayers[l].name);
-          pasSLDLayers[l].name = msStrdup(tmpId);
-          msInsertLayer(map, psTmpLayer, -1);
-          MS_REFCNT_DECR(psTmpLayer);
         }
+
+        /*make the name unique*/
+        snprintf(tmpId, sizeof(tmpId), "%lx_%x_%d", (long)time(NULL),
+                 (int)getpid(), map->numlayers);
+        if (psTmpLayer->name)
+          msFree(psTmpLayer->name);
+        psTmpLayer->name = msStrdup(tmpId);
+        msFree(pasSLDLayers[l].name);
+        pasSLDLayers[l].name = msStrdup(tmpId);
+        msInsertLayer(map, psTmpLayer, -1);
+        MS_REFCNT_DECR(psTmpLayer);
       }
     }
+  }
 }
 #endif
 
@@ -180,33 +202,34 @@ static void msSLDApplySLD_DuplicateLayer
 /*      they have the same name, copy the classes associated with       */
 /*      the SLD layers onto the map layers.                             */
 /************************************************************************/
-int msSLDApplySLD(mapObj *map, const char *psSLDXML, int iLayer, const char *pszStyleLayerName, char **ppszLayerNames)
-{
-#if defined(USE_WMS_SVR) || defined (USE_WFS_SVR) || defined (USE_WCS_SVR) || defined(USE_SOS_SVR)
+int msSLDApplySLD(mapObj *map, const char *psSLDXML, int iLayer,
+                  const char *pszStyleLayerName, char **ppszLayerNames) {
+#if defined(USE_WMS_SVR) || defined(USE_WFS_SVR) || defined(USE_WCS_SVR) ||    \
+    defined(USE_SOS_SVR)
   int nSLDLayers = 0;
   layerObj *pasSLDLayers = NULL;
   int nStatus = MS_SUCCESS;
   /*const char *pszSLDNotSupported = NULL;*/
 
   pasSLDLayers = msSLDParseSLD(map, psSLDXML, &nSLDLayers);
-  if( pasSLDLayers == NULL ) {
-    errorObj* psError = msGetErrorObj();
-    if( psError && psError->code != MS_NOERR )
+  if (pasSLDLayers == NULL) {
+    errorObj *psError = msGetErrorObj();
+    if (psError && psError->code != MS_NOERR)
       return MS_FAILURE;
   }
 
-  if (pasSLDLayers && nSLDLayers>0) {
+  if (pasSLDLayers && nSLDLayers > 0) {
     int i;
 
     msSLDApplySLD_DuplicateLayers(map, nSLDLayers, pasSLDLayers);
 
-    for (i=0; i<map->numlayers; i++) {
+    for (i = 0; i < map->numlayers; i++) {
       layerObj *lp = NULL;
       const char *pszWMSLayerName = NULL;
       int j;
       int bUseSpecificLayer = 0;
 
-      if (iLayer >=0 && iLayer< map->numlayers) {
+      if (iLayer >= 0 && iLayer < map->numlayers) {
         i = iLayer;
         bUseSpecificLayer = 1;
       }
@@ -216,31 +239,36 @@ int msSLDApplySLD(mapObj *map, const cha
       /* compare layer name to wms_name as well */
       pszWMSLayerName = msOWSLookupMetadata(&(lp->metadata), "MO", "name");
 
-      for (j=0; j<nSLDLayers; j++) {
-        layerObj* sldLayer = &pasSLDLayers[j];
+      for (j = 0; j < nSLDLayers; j++) {
+        layerObj *sldLayer = &pasSLDLayers[j];
 
-        /* -------------------------------------------------------------------- */
-        /*      copy :  - class                                                 */
-        /*              - layer's labelitem                                     */
-        /* -------------------------------------------------------------------- */
+        /* --------------------------------------------------------------------
+         */
+        /*      copy :  - class */
+        /*              - layer's labelitem */
+        /* --------------------------------------------------------------------
+         */
         if ((sldLayer->name && pszStyleLayerName == NULL &&
              ((strcasecmp(lp->name, sldLayer->name) == 0 ||
-               (pszWMSLayerName && strcasecmp(pszWMSLayerName, sldLayer->name) == 0))||
-              (lp->group &&
-               strcasecmp(lp->group, sldLayer->name) == 0))) ||
+               (pszWMSLayerName &&
+                strcasecmp(pszWMSLayerName, sldLayer->name) == 0)) ||
+              (lp->group && strcasecmp(lp->group, sldLayer->name) == 0))) ||
             (bUseSpecificLayer && pszStyleLayerName && sldLayer->name &&
              strcasecmp(sldLayer->name, pszStyleLayerName) == 0)) {
 #ifdef notdef
-          /*this is a test code if we decide to flag some layers as not supporting SLD*/
-          pszSLDNotSupported = msOWSLookupMetadata(&(lp->metadata), "M", "SLD_NOT_SUPPORTED");
+          /*this is a test code if we decide to flag some layers as not
+           * supporting SLD*/
+          pszSLDNotSupported =
+              msOWSLookupMetadata(&(lp->metadata), "M", "SLD_NOT_SUPPORTED");
           if (pszSLDNotSupported) {
-            msSetError(MS_WMSERR, "Layer %s does not support SLD", "msSLDApplySLD", sldLayer->name);
+            msSetError(MS_WMSERR, "Layer %s does not support SLD",
+                       "msSLDApplySLD", sldLayer->name);
             nsStatus = MS_FAILURE;
             goto sld_cleanup;
           }
 #endif
 
-          if ( sldLayer->numclasses > 0) {
+          if (sldLayer->numclasses > 0) {
             int iClass = 0;
             int k;
             int bSLDHasNamedClass = MS_FALSE;
@@ -248,17 +276,17 @@ int msSLDApplySLD(mapObj *map, const cha
             lp->type = sldLayer->type;
             lp->rendermode = MS_ALL_MATCHING_CLASSES;
 
-            for (k=0; k < sldLayer->numclasses; k++) {
-                if( sldLayer->class[k]->group ) {
-                    bSLDHasNamedClass = MS_TRUE;
-                    break;
-                }
+            for (k = 0; k < sldLayer->numclasses; k++) {
+              if (sldLayer->class[k] -> group) {
+                bSLDHasNamedClass = MS_TRUE;
+                break;
+              }
             }
 
-            for(k=0; k<lp->numclasses; k++) {
+            for (k = 0; k < lp->numclasses; k++) {
               if (lp->class[k] != NULL) {
-                lp->class[k]->layer=NULL;
-                if (freeClass(lp->class[k]) == MS_SUCCESS ) {
+                lp->class[k]->layer = NULL;
+                if (freeClass(lp->class[k]) == MS_SUCCESS) {
                   msFree(lp->class[k]);
                   lp->class[k] = NULL;
                 }
@@ -266,48 +294,52 @@ int msSLDApplySLD(mapObj *map, const cha
             }
             lp->numclasses = 0;
 
-            if( bSLDHasNamedClass && sldLayer->classgroup ) {
-                /* Set the class group to the class that has UserStyle.IsDefault */
-                msFree( lp->classgroup);
-                lp->classgroup = msStrdup(sldLayer->classgroup);
-            }
-            else {
-                /*unset the classgroup on the layer if it was set. This allows the layer to render
-                with all the classes defined in the SLD*/
-                msFree(lp->classgroup);
-                lp->classgroup = NULL;
+            if (bSLDHasNamedClass && sldLayer->classgroup) {
+              /* Set the class group to the class that has UserStyle.IsDefault
+               */
+              msFree(lp->classgroup);
+              lp->classgroup = msStrdup(sldLayer->classgroup);
+            } else {
+              /*unset the classgroup on the layer if it was set. This allows the
+              layer to render with all the classes defined in the SLD*/
+              msFree(lp->classgroup);
+              lp->classgroup = NULL;
             }
 
-            for (k=0; k < sldLayer->numclasses; k++) {
+            for (k = 0; k < sldLayer->numclasses; k++) {
               if (msGrowLayerClasses(lp) == NULL)
                 return MS_FAILURE;
 
               initClass(lp->class[iClass]);
-              msCopyClass(lp->class[iClass],
-                          sldLayer->class[k], NULL);
+              msCopyClass(lp->class[iClass], sldLayer -> class[k], NULL);
               lp->class[iClass]->layer = lp;
               lp->numclasses++;
 
-              /*aliases may have been used as part of the sld text symbolizer for
-                label element. Try to process it if that is the case #3114*/
+              /*aliases may have been used as part of the sld text symbolizer
+                for label element. Try to process it if that is the case #3114*/
               if (msLayerOpen(lp) == MS_SUCCESS) {
                 if (msLayerGetItems(lp) == MS_SUCCESS &&
-                    lp->class[iClass]->text.string) {
+                        lp->class[iClass] -> text.string) {
                   int z;
-                  for(z=0; z<lp->numitems; z++) {
-                    const char* pszFullName;
+                  for (z = 0; z < lp->numitems; z++) {
+                    const char *pszFullName;
                     char szTmp[512];
-                    char* pszTmp1;
+                    char *pszTmp1;
                     if (!lp->items[z] || strlen(lp->items[z]) == 0)
                       continue;
                     snprintf(szTmp, sizeof(szTmp), "%s_alias", lp->items[z]);
-                    pszFullName = msOWSLookupMetadata(&(lp->metadata), "G", szTmp);
-                    pszTmp1 = msStrdup( lp->class[iClass]->text.string);
-                    if (pszFullName != NULL && (strstr(pszTmp1, pszFullName) != NULL)) {
-                      char *tmpstr1= msReplaceSubstring(pszTmp1, pszFullName, lp->items[z]);
-                      char* pszTmp2 = (char *)malloc(sizeof(char)*(strlen(tmpstr1)+3));
-                      sprintf(pszTmp2,"(%s)",tmpstr1);
-                      msLoadExpressionString(&(lp->class[iClass]->text), pszTmp2);
+                    pszFullName =
+                        msOWSLookupMetadata(&(lp->metadata), "G", szTmp);
+                    pszTmp1 = msStrdup(lp->class[iClass] -> text.string);
+                    if (pszFullName != NULL &&
+                        (strstr(pszTmp1, pszFullName) != NULL)) {
+                      char *tmpstr1 = msReplaceSubstring(pszTmp1, pszFullName,
+                                                         lp->items[z]);
+                      char *pszTmp2 =
+                          (char *)malloc(sizeof(char) * (strlen(tmpstr1) + 3));
+                      sprintf(pszTmp2, "(%s)", tmpstr1);
+                      msLoadExpressionString(&(lp->class[iClass] -> text),
+                                             pszTmp2);
                       msFree(pszTmp2);
                     }
                     msFree(pszTmp1);
@@ -322,14 +354,14 @@ int msSLDApplySLD(mapObj *map, const cha
             /*this is probably an SLD that uses Named styles*/
             if (sldLayer->classgroup) {
               int k;
-              for (k=0; k<lp->numclasses; k++) {
-                if (lp->class[k]->group &&
-                    strcasecmp(lp->class[k]->group,
-                               sldLayer->classgroup) == 0)
+              for (k = 0; k < lp->numclasses; k++) {
+                if (lp->class[k] -> group &&
+                                        strcasecmp(lp->class[k] -> group,
+                                                   sldLayer -> classgroup) == 0)
                   break;
               }
               if (k < lp->numclasses) {
-                msFree( lp->classgroup);
+                msFree(lp->classgroup);
                 lp->classgroup = msStrdup(sldLayer->classgroup);
               } else {
                 /* TODO  we throw an exception ?*/
@@ -351,79 +383,81 @@ int msSLDApplySLD(mapObj *map, const cha
           }
 
           /* opacity for sld raster */
-          if (lp->type == MS_LAYER_RASTER &&
-              sldLayer->compositer && sldLayer->compositer->opacity != 100)
+          if (lp->type == MS_LAYER_RASTER && sldLayer->compositer &&
+              sldLayer->compositer->opacity != 100)
             msSetLayerOpacity(lp, sldLayer->compositer->opacity);
 
           /* mark as auto-generate SLD */
           if (lp->connectiontype == MS_WMS)
-            msInsertHashTable(&(lp->metadata),
-                              "wms_sld_body", "auto" );
+            msInsertHashTable(&(lp->metadata), "wms_sld_body", "auto");
 
           /* The SLD might have a FeatureTypeConstraint */
-          if( sldLayer->filter.type == MS_EXPRESSION )
-          {
-                if( lp->filter.string && lp->filter.type == MS_EXPRESSION )
-                {
-                    char* pszBuffer = msStringConcatenate(NULL, "((");
-                    pszBuffer = msStringConcatenate(pszBuffer, lp->filter.string);
-                    pszBuffer = msStringConcatenate(pszBuffer, ") AND (");
-                    pszBuffer = msStringConcatenate(pszBuffer, sldLayer->filter.string);
-                    pszBuffer = msStringConcatenate(pszBuffer, "))");
-                    msFreeExpression(&lp->filter);
-                    msInitExpression(&lp->filter);
-                    lp->filter.string = pszBuffer;
-                    lp->filter.type = MS_EXPRESSION;
-                }
-                else
-                {
-                    msFreeExpression(&lp->filter);
-                    msInitExpression(&lp->filter);
-                    lp->filter.string = msStrdup(sldLayer->filter.string);
-                    lp->filter.type = MS_EXPRESSION;
-                }
+          if (sldLayer->filter.type == MS_EXPRESSION) {
+            if (lp->filter.string && lp->filter.type == MS_EXPRESSION) {
+              char *pszBuffer = msStringConcatenate(NULL, "((");
+              pszBuffer = msStringConcatenate(pszBuffer, lp->filter.string);
+              pszBuffer = msStringConcatenate(pszBuffer, ") AND (");
+              pszBuffer =
+                  msStringConcatenate(pszBuffer, sldLayer->filter.string);
+              pszBuffer = msStringConcatenate(pszBuffer, "))");
+              msFreeExpression(&lp->filter);
+              msInitExpression(&lp->filter);
+              lp->filter.string = pszBuffer;
+              lp->filter.type = MS_EXPRESSION;
+            } else {
+              msFreeExpression(&lp->filter);
+              msInitExpression(&lp->filter);
+              lp->filter.string = msStrdup(sldLayer->filter.string);
+              lp->filter.type = MS_EXPRESSION;
+            }
           }
 
-
           /*in some cases it would make sense to concatenate all the class
             expressions and use it to set the filter on the layer. This
             could increase performance. Will do it for db types layers #2840*/
-          if (lp->filter.string == NULL || (lp->filter.string && lp->filter.type == MS_STRING && !lp->filteritem)) {
-              if (lp->connectiontype == MS_POSTGIS || lp->connectiontype ==  MS_ORACLESPATIAL || lp->connectiontype == MS_PLUGIN) {
-                if (lp->numclasses > 0) {
-                  /* check first that all classes have an expression type. That is
-                    the only way we can concatenate them and set the filter
-                    expression */
-                  int k;
-                  for (k=0; k<lp->numclasses; k++) {
-                    if (lp->class[k]->expression.type != MS_EXPRESSION)
-                      break;
+          if (lp->filter.string == NULL ||
+              (lp->filter.string && lp->filter.type == MS_STRING &&
+               !lp->filteritem)) {
+            if (lp->connectiontype == MS_POSTGIS ||
+                lp->connectiontype == MS_ORACLESPATIAL ||
+                lp->connectiontype == MS_PLUGIN) {
+              if (lp->numclasses > 0) {
+                /* check first that all classes have an expression type. That is
+                  the only way we can concatenate them and set the filter
+                  expression */
+                int k;
+                for (k = 0; k < lp->numclasses; k++) {
+                  if (lp->class[k] -> expression.type != MS_EXPRESSION)
+                    break;
+                }
+                if (k == lp->numclasses) {
+                  char szTmp[512];
+                  char *pszBuffer = NULL;
+                  for (k = 0; k < lp->numclasses; k++) {
+                    if (pszBuffer == NULL)
+                      snprintf(szTmp, sizeof(szTmp), "%s",
+                               "(("); /* we a building a string expression,
+                                         explicitly set type below */
+                    else
+                      snprintf(szTmp, sizeof(szTmp), "%s", " OR ");
+
+                    pszBuffer = msStringConcatenate(pszBuffer, szTmp);
+                    pszBuffer = msStringConcatenate(
+                        pszBuffer, lp->class[k] -> expression.string);
                   }
-                  if (k == lp->numclasses) {
-                    char szTmp[512];
-                    char* pszBuffer = NULL;
-                    for (k=0; k<lp->numclasses; k++) {
-                      if (pszBuffer == NULL)
-                        snprintf(szTmp, sizeof(szTmp), "%s", "(("); /* we a building a string expression, explicitly set type below */
-                      else
-                        snprintf(szTmp, sizeof(szTmp), "%s", " OR ");
-
-                      pszBuffer = msStringConcatenate(pszBuffer, szTmp);
-                      pszBuffer = msStringConcatenate(pszBuffer, lp->class[k]->expression.string);
-                    }
 
-                    snprintf(szTmp, sizeof(szTmp), "%s", "))");
-                    pszBuffer =msStringConcatenate(pszBuffer, szTmp);
+                  snprintf(szTmp, sizeof(szTmp), "%s", "))");
+                  pszBuffer = msStringConcatenate(pszBuffer, szTmp);
 
-                    msFreeExpression(&lp->filter);
-                    msInitExpression(&lp->filter);
-                    lp->filter.string = msStrdup(pszBuffer);
-                    lp->filter.type = MS_EXPRESSION;
+                  msFreeExpression(&lp->filter);
+                  msInitExpression(&lp->filter);
+                  lp->filter.string = msStrdup(pszBuffer);
+                  lp->filter.type = MS_EXPRESSION;
 
-                    msFree(pszBuffer);
-                  }
+                  msFree(pszBuffer);
                 }
               }
+            }
           }
           break;
         }
@@ -438,38 +472,36 @@ int msSLDApplySLD(mapObj *map, const cha
     /* -------------------------------------------------------------------- */
     if (ppszLayerNames) {
       char *pszTmp = NULL;
-      for (i=0; i<nSLDLayers; i++) {
+      for (i = 0; i < nSLDLayers; i++) {
         if (pasSLDLayers[i].name) {
-          if (pszTmp !=NULL)
+          if (pszTmp != NULL)
             pszTmp = msStringConcatenate(pszTmp, ",");
           pszTmp = msStringConcatenate(pszTmp, pasSLDLayers[i].name);
-
         }
       }
       *ppszLayerNames = pszTmp;
-
     }
   }
 
   nStatus = MS_SUCCESS;
 
 #ifdef notdef
-sld_cleanup:
+sld_cleanup :
 #endif
-  {
-    int i;
-    for (i=0; i<nSLDLayers; i++)
-        freeLayer(&pasSLDLayers[i]);
-    msFree(pasSLDLayers);
-  }
+{
+  int i;
+  for (i = 0; i < nSLDLayers; i++)
+    freeLayer(&pasSLDLayers[i]);
+  msFree(pasSLDLayers);
+}
 
-  if(map->debug == MS_DEBUGLEVEL_VVV) {
-    char* tmpfilename = msTmpFile(map, map->mappath, NULL, "_sld.map");
+  if (map->debug == MS_DEBUGLEVEL_VVV) {
+    char *tmpfilename = msTmpFile(map, map->mappath, NULL, "_sld.map");
     if (tmpfilename == NULL) {
-      tmpfilename = msTmpFile(map, NULL, NULL, "_sld.map" );
+      tmpfilename = msTmpFile(map, NULL, NULL, "_sld.map");
     }
     if (tmpfilename) {
-      msSaveMap(map,tmpfilename);
+      msSaveMap(map, tmpfilename);
       msDebug("msApplySLD(): Map file after SLD was applied %s", tmpfilename);
       msFree(tmpfilename);
     }
@@ -477,32 +509,26 @@ sld_cleanup:
   return nStatus;
 
 #else
-  msSetError(MS_MISCERR, "OWS support is not available.",
-             "msSLDApplySLD()");
-  return(MS_FAILURE);
+  msSetError(MS_MISCERR, "OWS support is not available.", "msSLDApplySLD()");
+  return (MS_FAILURE);
 #endif
 }
 
-
-
-static CPLXMLNode* FindNextChild(CPLXMLNode* psNode, const char* pszChildName)
-{
-    while( psNode )
-    {
-        if( psNode->eType == CXT_Element &&
-            strcasecmp(psNode->pszValue, pszChildName) == 0 )
-        {
-            return psNode;
-        }
-        psNode = psNode->psNext;
+static CPLXMLNode *FindNextChild(CPLXMLNode *psNode, const char *pszChildName) {
+  while (psNode) {
+    if (psNode->eType == CXT_Element &&
+        strcasecmp(psNode->pszValue, pszChildName) == 0) {
+      return psNode;
     }
-    return NULL;
+    psNode = psNode->psNext;
+  }
+  return NULL;
 }
 
-#define LOOP_ON_CHILD_ELEMENT(psParent_, psChild_, pszChildName_) \
-    for( psChild_ = FindNextChild(psParent_->psChild, pszChildName_); \
-         psChild_ != NULL; \
-         psChild_ = FindNextChild(psChild_->psNext, pszChildName_) )
+#define LOOP_ON_CHILD_ELEMENT(psParent_, psChild_, pszChildName_)              \
+  for (psChild_ = FindNextChild(psParent_->psChild, pszChildName_);            \
+       psChild_ != NULL;                                                       \
+       psChild_ = FindNextChild(psChild_->psNext, pszChildName_))
 
 /************************************************************************/
 /*                              msSLDParseSLD                           */
@@ -513,15 +539,13 @@ static CPLXMLNode* FindNextChild(CPLXMLN
 /*      Returns an array of mapserver layers. The pnLayres if           */
 /*      provided will indicate the size of the returned array.          */
 /************************************************************************/
-layerObj  *msSLDParseSLD(mapObj *map, const char *psSLDXML, int *pnLayers)
-{
+layerObj *msSLDParseSLD(mapObj *map, const char *psSLDXML, int *pnLayers) {
   CPLXMLNode *psRoot = NULL;
   CPLXMLNode *psSLD, *psNamedLayer;
   layerObj *pasLayers = NULL;
   int iLayer = 0;
   int nLayers = 0;
 
-
   if (map == NULL || psSLDXML == NULL || strlen(psSLDXML) == 0 ||
       (strstr(psSLDXML, "StyledLayerDescriptor") == NULL)) {
     msSetError(MS_WMSERR, "Invalid SLD document", "");
@@ -529,7 +553,7 @@ layerObj  *msSLDParseSLD(mapObj *map, co
   }
 
   psRoot = CPLParseXMLString(psSLDXML);
-  if( psRoot == NULL) {
+  if (psRoot == NULL) {
     msSetError(MS_WMSERR, "Invalid SLD document : %s", "", psSLDXML);
     return NULL;
   }
@@ -540,7 +564,6 @@ layerObj  *msSLDParseSLD(mapObj *map, co
   CPLStripXMLNamespace(psRoot, "gml", 1);
   CPLStripXMLNamespace(psRoot, "se", 1);
 
-
   /* -------------------------------------------------------------------- */
   /*      get the root element (StyledLayerDescriptor).                   */
   /* -------------------------------------------------------------------- */
@@ -553,35 +576,31 @@ layerObj  *msSLDParseSLD(mapObj *map, co
   /* -------------------------------------------------------------------- */
   /*      Parse the named layers.                                         */
   /* -------------------------------------------------------------------- */
-  LOOP_ON_CHILD_ELEMENT(psSLD, psNamedLayer, "NamedLayer")
-  {
-    nLayers++;
-  }
+  LOOP_ON_CHILD_ELEMENT(psSLD, psNamedLayer, "NamedLayer") { nLayers++; }
 
   if (nLayers > 0)
-    pasLayers = (layerObj *)malloc(sizeof(layerObj)*nLayers);
+    pasLayers = (layerObj *)malloc(sizeof(layerObj) * nLayers);
   else
     return NULL;
 
-  LOOP_ON_CHILD_ELEMENT(psSLD, psNamedLayer, "NamedLayer")
-  {
-      CPLXMLNode* psName = CPLGetXMLNode(psNamedLayer, "Name");
-      initLayer(&pasLayers[iLayer], map);
-
-      if (psName && psName->psChild &&  psName->psChild->pszValue)
-        pasLayers[iLayer].name = msStrdup(psName->psChild->pszValue);
-
-      if( msSLDParseNamedLayer(psNamedLayer, &pasLayers[iLayer]) != MS_SUCCESS ) {
-        int i;
-        for (i=0; i<=iLayer; i++)
-            freeLayer(&pasLayers[i]);
-        msFree(pasLayers);
-        nLayers = 0;
-        pasLayers = NULL;
-        break;
-      }
+  LOOP_ON_CHILD_ELEMENT(psSLD, psNamedLayer, "NamedLayer") {
+    CPLXMLNode *psName = CPLGetXMLNode(psNamedLayer, "Name");
+    initLayer(&pasLayers[iLayer], map);
+
+    if (psName && psName->psChild && psName->psChild->pszValue)
+      pasLayers[iLayer].name = msStrdup(psName->psChild->pszValue);
+
+    if (msSLDParseNamedLayer(psNamedLayer, &pasLayers[iLayer]) != MS_SUCCESS) {
+      int i;
+      for (i = 0; i <= iLayer; i++)
+        freeLayer(&pasLayers[i]);
+      msFree(pasLayers);
+      nLayers = 0;
+      pasLayers = NULL;
+      break;
+    }
 
-      iLayer++;
+    iLayer++;
   }
 
   if (pnLayers)
@@ -593,89 +612,80 @@ layerObj  *msSLDParseSLD(mapObj *map, co
   return pasLayers;
 }
 
-
 /************************************************************************/
 /*                           _SLDApplyRuleValues                        */
 /*                                                                      */
 /*      Utility function to set the scale, title/name for the          */
 /*      classes created by a Rule.                                      */
 /************************************************************************/
-void  _SLDApplyRuleValues(CPLXMLNode *psRule, layerObj *psLayer,
-                          int nNewClasses)
-{
-  CPLXMLNode *psMinScale=NULL, *psMaxScale=NULL;
-  CPLXMLNode *psName=NULL, *psTitle=NULL;
-  double dfMinScale=0, dfMaxScale=0;
-  char *pszName=NULL, *pszTitle=NULL;
+void _SLDApplyRuleValues(CPLXMLNode *psRule, layerObj *psLayer,
+                         int nNewClasses) {
+  CPLXMLNode *psMinScale = NULL, *psMaxScale = NULL;
+  CPLXMLNode *psName = NULL, *psTitle = NULL;
+  double dfMinScale = 0, dfMaxScale = 0;
+  char *pszName = NULL, *pszTitle = NULL;
 
   if (psRule && psLayer && nNewClasses > 0) {
     /* -------------------------------------------------------------------- */
     /*      parse minscale and maxscale.                                    */
     /* -------------------------------------------------------------------- */
-    psMinScale = CPLGetXMLNode(psRule,
-                               "MinScaleDenominator");
-    if (psMinScale && psMinScale->psChild &&
-        psMinScale->psChild->pszValue)
+    psMinScale = CPLGetXMLNode(psRule, "MinScaleDenominator");
+    if (psMinScale && psMinScale->psChild && psMinScale->psChild->pszValue)
       dfMinScale = atof(psMinScale->psChild->pszValue);
 
-    psMaxScale = CPLGetXMLNode(psRule,
-                               "MaxScaleDenominator");
-    if (psMaxScale && psMaxScale->psChild &&
-        psMaxScale->psChild->pszValue)
+    psMaxScale = CPLGetXMLNode(psRule, "MaxScaleDenominator");
+    if (psMaxScale && psMaxScale->psChild && psMaxScale->psChild->pszValue)
       dfMaxScale = atof(psMaxScale->psChild->pszValue);
 
     /* -------------------------------------------------------------------- */
     /*      parse name and title.                                           */
     /* -------------------------------------------------------------------- */
     psName = CPLGetXMLNode(psRule, "Name");
-    if (psName && psName->psChild &&
-        psName->psChild->pszValue)
+    if (psName && psName->psChild && psName->psChild->pszValue)
       pszName = psName->psChild->pszValue;
 
     psTitle = CPLGetXMLNode(psRule, "Title");
-    if (psTitle && psTitle->psChild &&
-        psTitle->psChild->pszValue)
+    if (psTitle && psTitle->psChild && psTitle->psChild->pszValue)
       pszTitle = psTitle->psChild->pszValue;
 
     /* -------------------------------------------------------------------- */
     /*      set the scale to all the classes created by the rule.           */
     /* -------------------------------------------------------------------- */
     if (dfMinScale > 0 || dfMaxScale > 0) {
-      for (int i=0; i<nNewClasses; i++) {
+      for (int i = 0; i < nNewClasses; i++) {
         if (dfMinScale > 0)
-          psLayer->class[psLayer->numclasses-1-i]->minscaledenom = dfMinScale;
+          psLayer->class[psLayer->numclasses - 1 - i]->minscaledenom =
+              dfMinScale;
         if (dfMaxScale)
-          psLayer->class[psLayer->numclasses-1-i]->maxscaledenom = dfMaxScale;
+          psLayer->class[psLayer->numclasses - 1 - i]->maxscaledenom =
+              dfMaxScale;
       }
     }
     /* -------------------------------------------------------------------- */
     /*      set name and title to the classes created by the rule.          */
     /* -------------------------------------------------------------------- */
-    for (int i=0; i<nNewClasses; i++) {
-      if (!psLayer->class[psLayer->numclasses-1-i]->name) {
+    for (int i = 0; i < nNewClasses; i++) {
+      if (!psLayer->class[psLayer->numclasses - 1 - i] -> name) {
         if (pszName)
-          psLayer->class[psLayer->numclasses-1-i]->name = msStrdup(pszName);
+          psLayer->class[psLayer->numclasses - 1 - i]->name = msStrdup(pszName);
         else if (pszTitle)
-          psLayer->class[psLayer->numclasses-1-i]->name = msStrdup(pszTitle);
-        else
-        {
+          psLayer->class[psLayer->numclasses - 1 - i]->name =
+              msStrdup(pszTitle);
+        else {
           // Build a name from layer and class info
           char szTmp[256];
           snprintf(szTmp, sizeof(szTmp), "%s#%d", psLayer->name,
-              psLayer->numclasses-1-i);
-          psLayer->class[psLayer->numclasses-1-i]->name = msStrdup(szTmp);
+                   psLayer->numclasses - 1 - i);
+          psLayer->class[psLayer->numclasses - 1 - i]->name = msStrdup(szTmp);
         }
       }
     }
     if (pszTitle) {
-      for (int i=0; i<nNewClasses; i++) {
-        psLayer->class[psLayer->numclasses-1-i]->title =
-              msStrdup(pszTitle);
+      for (int i = 0; i < nNewClasses; i++) {
+        psLayer->class[psLayer->numclasses - 1 - i]->title = msStrdup(pszTitle);
       }
     }
-
   }
-
 }
 
 /************************************************************************/
@@ -684,72 +694,72 @@ void  _SLDApplyRuleValues(CPLXMLNode *ps
 /*      Get a common expression valid from the filter valid for the    */
 /*      temporary layer.                                                */
 /************************************************************************/
-static char* msSLDGetCommonExpressionFromFilter(CPLXMLNode* psFilter,
-                                                layerObj *psLayer)
-{
-    char *pszExpression = NULL;
-    CPLXMLNode *psTmpNextNode = NULL;
-    CPLXMLNode *psTmpNode = NULL;
-    FilterEncodingNode *psNode = NULL;
-    char *pszTmpFilter = NULL;
-    layerObj *psCurrentLayer = NULL;
-    const char *pszWmsName=NULL;
-    const char *key=NULL;
-
-    /* clone the tree and set the next node to null */
-    /* so we only have the Filter node */
-    psTmpNode = CPLCloneXMLTree(psFilter);
-    psTmpNextNode = psTmpNode->psNext;
-    psTmpNode->psNext = NULL;
-    pszTmpFilter = CPLSerializeXMLTree(psTmpNode);
-    psTmpNode->psNext = psTmpNextNode;
-    CPLDestroyXMLNode(psTmpNode);
-
-    if (pszTmpFilter) {
-        psNode = FLTParseFilterEncoding(pszTmpFilter);
+static char *msSLDGetCommonExpressionFromFilter(CPLXMLNode *psFilter,
+                                                layerObj *psLayer) {
+  char *pszExpression = NULL;
+  CPLXMLNode *psTmpNextNode = NULL;
+  CPLXMLNode *psTmpNode = NULL;
+  FilterEncodingNode *psNode = NULL;
+  char *pszTmpFilter = NULL;
+  layerObj *psCurrentLayer = NULL;
+  const char *pszWmsName = NULL;
+  const char *key = NULL;
+
+  /* clone the tree and set the next node to null */
+  /* so we only have the Filter node */
+  psTmpNode = CPLCloneXMLTree(psFilter);
+  psTmpNextNode = psTmpNode->psNext;
+  psTmpNode->psNext = NULL;
+  pszTmpFilter = CPLSerializeXMLTree(psTmpNode);
+  psTmpNode->psNext = psTmpNextNode;
+  CPLDestroyXMLNode(psTmpNode);
 
-        CPLFree(pszTmpFilter);
-    }
+  if (pszTmpFilter) {
+    psNode = FLTParseFilterEncoding(pszTmpFilter);
 
-    if (psNode) {
-        int j;
+    CPLFree(pszTmpFilter);
+  }
 
-        /*preparse the filter for possible gml aliases set on the layer's metadata:
-        "gml_NA3DESC_alias" "alias_name" and filter could be
-        <ogc:PropertyName>alias_name</ogc:PropertyName> #3079*/
-        for (j=0; j<psLayer->map->numlayers; j++) {
-            psCurrentLayer = GET_LAYER(psLayer->map, j);
-
-            pszWmsName = msOWSLookupMetadata(&(psCurrentLayer->metadata), "MO", "name");
-
-            if ((psCurrentLayer->name && psLayer->name &&
-                    strcasecmp(psCurrentLayer->name, psLayer->name) == 0) ||
-                (psCurrentLayer->group && psLayer->name &&
-                    strcasecmp(psCurrentLayer->group, psLayer->name) == 0) ||
-                (psLayer->name && pszWmsName &&
-                    strcasecmp(pszWmsName, psLayer->name) == 0))
-                break;
-        }
-        if (j < psLayer->map->numlayers) {
-            /*make sure that the tmp layer has all the metadata that
-            the original layer has, allowing to do parsing for
-            such things as gml_attribute_type #3052*/
-            while (1) {
-                key = msNextKeyFromHashTable(&psCurrentLayer->metadata, key);
-                if (!key)
-                    break;
-                else
-                    msInsertHashTable(&psLayer->metadata, key,
-                                    msLookupHashTable(&psCurrentLayer->metadata, key));
-            }
-            FLTPreParseFilterForAliasAndGroup(psNode, psLayer->map, j, "G");
-        }
+  if (psNode) {
+    int j;
 
-        pszExpression = FLTGetCommonExpression(psNode, psLayer);
-        FLTFreeFilterEncodingNode(psNode);
+    /*preparse the filter for possible gml aliases set on the layer's metadata:
+    "gml_NA3DESC_alias" "alias_name" and filter could be
+    <ogc:PropertyName>alias_name</ogc:PropertyName> #3079*/
+    for (j = 0; j < psLayer->map->numlayers; j++) {
+      psCurrentLayer = GET_LAYER(psLayer->map, j);
+
+      pszWmsName =
+          msOWSLookupMetadata(&(psCurrentLayer->metadata), "MO", "name");
+
+      if ((psCurrentLayer->name && psLayer->name &&
+           strcasecmp(psCurrentLayer->name, psLayer->name) == 0) ||
+          (psCurrentLayer->group && psLayer->name &&
+           strcasecmp(psCurrentLayer->group, psLayer->name) == 0) ||
+          (psLayer->name && pszWmsName &&
+           strcasecmp(pszWmsName, psLayer->name) == 0))
+        break;
+    }
+    if (j < psLayer->map->numlayers) {
+      /*make sure that the tmp layer has all the metadata that
+      the original layer has, allowing to do parsing for
+      such things as gml_attribute_type #3052*/
+      while (1) {
+        key = msNextKeyFromHashTable(&psCurrentLayer->metadata, key);
+        if (!key)
+          break;
+        else
+          msInsertHashTable(&psLayer->metadata, key,
+                            msLookupHashTable(&psCurrentLayer->metadata, key));
+      }
+      FLTPreParseFilterForAliasAndGroup(psNode, psLayer->map, j, "G");
     }
 
-    return pszExpression;
+    pszExpression = FLTGetCommonExpression(psNode, psLayer);
+    FLTFreeFilterEncodingNode(psNode);
+  }
+
+  return pszExpression;
 }
 
 /************************************************************************/
@@ -758,94 +768,85 @@ static char* msSLDGetCommonExpressionFro
 /*      Parse UserStyle node.                                           */
 /************************************************************************/
 
-static void msSLDParseUserStyle(CPLXMLNode* psUserStyle, layerObj *psLayer)
-{
-    CPLXMLNode *psFeatureTypeStyle;
-    const char* pszUserStyleName = CPLGetXMLValue(psUserStyle, "Name", NULL);
-    if( pszUserStyleName )
-    {
-        const char* pszIsDefault = CPLGetXMLValue(psUserStyle, "IsDefault", "0");
-        if( EQUAL(pszIsDefault, "true") || EQUAL(pszIsDefault, "1") )
-        {
-            msFree(psLayer->classgroup);
-            psLayer->classgroup = msStrdup(pszUserStyleName);
-        }
+static void msSLDParseUserStyle(CPLXMLNode *psUserStyle, layerObj *psLayer) {
+  CPLXMLNode *psFeatureTypeStyle;
+  const char *pszUserStyleName = CPLGetXMLValue(psUserStyle, "Name", NULL);
+  if (pszUserStyleName) {
+    const char *pszIsDefault = CPLGetXMLValue(psUserStyle, "IsDefault", "0");
+    if (EQUAL(pszIsDefault, "true") || EQUAL(pszIsDefault, "1")) {
+      msFree(psLayer->classgroup);
+      psLayer->classgroup = msStrdup(pszUserStyleName);
     }
+  }
 
-    LOOP_ON_CHILD_ELEMENT(psUserStyle, psFeatureTypeStyle,
-                          "FeatureTypeStyle")
-    {
-        CPLXMLNode* psRule;
-
-        /* -------------------------------------------------------------------- */
-        /*      Parse rules with no Else filter.                                */
-        /* -------------------------------------------------------------------- */
-        LOOP_ON_CHILD_ELEMENT(psFeatureTypeStyle, psRule, "Rule")
-        {
-          CPLXMLNode *psFilter = NULL;
-          CPLXMLNode *psElseFilter = NULL;
-          int nNewClasses=0, nClassBeforeFilter=0, nClassAfterFilter=0;
-          int nClassAfterRule=0, nClassBeforeRule=0;
-
-          /* used for scale setting */
-          nClassBeforeRule = psLayer->numclasses;
-
-          psElseFilter = CPLGetXMLNode(psRule, "ElseFilter");
-          nClassBeforeFilter = psLayer->numclasses;
-          if (psElseFilter == NULL)
-            msSLDParseRule(psRule, psLayer, pszUserStyleName);
-          nClassAfterFilter = psLayer->numclasses;
-
-          /* -------------------------------------------------------------------- */
-          /*      Parse the filter and apply it to the latest class created by    */
-          /*      the rule.                                                       */
-          /*      NOTE : Spatial Filter is not supported.                         */
-          /* -------------------------------------------------------------------- */
-          psFilter = CPLGetXMLNode(psRule, "Filter");
-          if (psFilter && psFilter->psChild && psFilter->psChild->pszValue) {
-            char* pszExpression = msSLDGetCommonExpressionFromFilter(psFilter,
-                                                                     psLayer);
-            if (pszExpression) {
-                int i;
-                nNewClasses =
-                  nClassAfterFilter - nClassBeforeFilter;
-                for (i=0; i<nNewClasses; i++) {
-                  expressionObj* exp = &(psLayer->
-                                         class[psLayer->numclasses-1-i]->
-                                         expression);
-                  msFreeExpression(exp);
-                  msInitExpression(exp);
-                  exp->string = msStrdup(pszExpression);
-                  exp->type = MS_EXPRESSION;
-                }
-                msFree(pszExpression);
-                pszExpression = NULL;
-            }
-          }
-          nClassAfterRule = psLayer->numclasses;
-          nNewClasses = nClassAfterRule - nClassBeforeRule;
+  LOOP_ON_CHILD_ELEMENT(psUserStyle, psFeatureTypeStyle, "FeatureTypeStyle") {
+    CPLXMLNode *psRule;
 
-          /* apply scale and title to newly created classes */
-          _SLDApplyRuleValues(psRule, psLayer, nNewClasses);
+    /* -------------------------------------------------------------------- */
+    /*      Parse rules with no Else filter.                                */
+    /* -------------------------------------------------------------------- */
+    LOOP_ON_CHILD_ELEMENT(psFeatureTypeStyle, psRule, "Rule") {
+      CPLXMLNode *psFilter = NULL;
+      CPLXMLNode *psElseFilter = NULL;
+      int nNewClasses = 0, nClassBeforeFilter = 0, nClassAfterFilter = 0;
+      int nClassAfterRule = 0, nClassBeforeRule = 0;
+
+      /* used for scale setting */
+      nClassBeforeRule = psLayer->numclasses;
+
+      psElseFilter = CPLGetXMLNode(psRule, "ElseFilter");
+      nClassBeforeFilter = psLayer->numclasses;
+      if (psElseFilter == NULL)
+        msSLDParseRule(psRule, psLayer, pszUserStyleName);
+      nClassAfterFilter = psLayer->numclasses;
 
-          /* TODO : parse legendgraphic */
-        }
-        /* -------------------------------------------------------------------- */
-        /*      First parse rules with the else filter. These rules will        */
-        /*      create the classes that are placed at the end of class          */
-        /*      list. (See how classes are applied to layers in function        */
-        /*      msSLDApplySLD).                                                 */
-        /* -------------------------------------------------------------------- */
-        LOOP_ON_CHILD_ELEMENT(psFeatureTypeStyle, psRule, "Rule")
-        {
-          CPLXMLNode* psElseFilter = CPLGetXMLNode(psRule, "ElseFilter");
-          if (psElseFilter) {
-            msSLDParseRule(psRule, psLayer, pszUserStyleName);
-            _SLDApplyRuleValues(psRule, psLayer, 1);
-            psLayer->class[psLayer->numclasses-1]->isfallback = TRUE;
-          }
+      /* -------------------------------------------------------------------- */
+      /*      Parse the filter and apply it to the latest class created by    */
+      /*      the rule.                                                       */
+      /*      NOTE : Spatial Filter is not supported.                         */
+      /* -------------------------------------------------------------------- */
+      psFilter = CPLGetXMLNode(psRule, "Filter");
+      if (psFilter && psFilter->psChild && psFilter->psChild->pszValue) {
+        char *pszExpression =
+            msSLDGetCommonExpressionFromFilter(psFilter, psLayer);
+        if (pszExpression) {
+          int i;
+          nNewClasses = nClassAfterFilter - nClassBeforeFilter;
+          for (i = 0; i < nNewClasses; i++) {
+            expressionObj *exp =
+                &(psLayer->class[psLayer->numclasses - 1 - i] -> expression);
+            msFreeExpression(exp);
+            msInitExpression(exp);
+            exp->string = msStrdup(pszExpression);
+            exp->type = MS_EXPRESSION;
+          }
+          msFree(pszExpression);
+          pszExpression = NULL;
         }
+      }
+      nClassAfterRule = psLayer->numclasses;
+      nNewClasses = nClassAfterRule - nClassBeforeRule;
+
+      /* apply scale and title to newly created classes */
+      _SLDApplyRuleValues(psRule, psLayer, nNewClasses);
+
+      /* TODO : parse legendgraphic */
+    }
+    /* -------------------------------------------------------------------- */
+    /*      First parse rules with the else filter. These rules will        */
+    /*      create the classes that are placed at the end of class          */
+    /*      list. (See how classes are applied to layers in function        */
+    /*      msSLDApplySLD).                                                 */
+    /* -------------------------------------------------------------------- */
+    LOOP_ON_CHILD_ELEMENT(psFeatureTypeStyle, psRule, "Rule") {
+      CPLXMLNode *psElseFilter = CPLGetXMLNode(psRule, "ElseFilter");
+      if (psElseFilter) {
+        msSLDParseRule(psRule, psLayer, pszUserStyleName);
+        _SLDApplyRuleValues(psRule, psLayer, 1);
+        psLayer->class[psLayer->numclasses - 1]->isfallback = TRUE;
+      }
     }
+  }
 }
 
 /************************************************************************/
@@ -853,8 +854,7 @@ static void msSLDParseUserStyle(CPLXMLNo
 /*                                                                      */
 /*      Parse NamedLayer root.                                          */
 /************************************************************************/
-int msSLDParseNamedLayer(CPLXMLNode *psRoot, layerObj *psLayer)
-{
+int msSLDParseNamedLayer(CPLXMLNode *psRoot, layerObj *psLayer) {
   CPLXMLNode *psLayerFeatureConstraints = NULL;
 
   if (!psRoot || !psLayer)
@@ -862,17 +862,16 @@ int msSLDParseNamedLayer(CPLXMLNode *psR
 
   if (CPLGetXMLNode(psRoot, "UserStyle")) {
     CPLXMLNode *psUserStyle;
-    LOOP_ON_CHILD_ELEMENT(psRoot, psUserStyle, "UserStyle")
-    {
-        msSLDParseUserStyle(psUserStyle, psLayer);
+    LOOP_ON_CHILD_ELEMENT(psRoot, psUserStyle, "UserStyle") {
+      msSLDParseUserStyle(psUserStyle, psLayer);
     }
   }
   /* check for Named styles*/
   else {
-    CPLXMLNode* psNamedStyle = CPLGetXMLNode(psRoot, "NamedStyle");
+    CPLXMLNode *psNamedStyle = CPLGetXMLNode(psRoot, "NamedStyle");
     if (psNamedStyle) {
-      CPLXMLNode* psSLDName = CPLGetXMLNode(psNamedStyle, "Name");
-      if (psSLDName && psSLDName->psChild &&  psSLDName->psChild->pszValue) {
+      CPLXMLNode *psSLDName = CPLGetXMLNode(psNamedStyle, "Name");
+      if (psSLDName && psSLDName->psChild && psSLDName->psChild->pszValue) {
         msFree(psLayer->classgroup);
         psLayer->classgroup = msStrdup(psSLDName->psChild->pszValue);
       }
@@ -881,42 +880,48 @@ int msSLDParseNamedLayer(CPLXMLNode *psR
 
   /* Deal with LayerFeatureConstraints */
   psLayerFeatureConstraints = CPLGetXMLNode(psRoot, "LayerFeatureConstraints");
-  if( psLayerFeatureConstraints != NULL ) {
-    CPLXMLNode* psIter = psLayerFeatureConstraints->psChild;
-    CPLXMLNode* psFeatureTypeConstraint = NULL;
-    for(; psIter != NULL; psIter = psIter->psNext ) {
-      if( psIter->eType == CXT_Element &&
-            strcmp(psIter->pszValue, "FeatureTypeConstraint") == 0 )  {
-        if( psFeatureTypeConstraint == NULL ) {
+  if (psLayerFeatureConstraints != NULL) {
+    CPLXMLNode *psIter = psLayerFeatureConstraints->psChild;
+    CPLXMLNode *psFeatureTypeConstraint = NULL;
+    for (; psIter != NULL; psIter = psIter->psNext) {
+      if (psIter->eType == CXT_Element &&
+          strcmp(psIter->pszValue, "FeatureTypeConstraint") == 0) {
+        if (psFeatureTypeConstraint == NULL) {
           psFeatureTypeConstraint = psIter;
         } else {
-          msSetError(MS_WMSERR, "Only one single FeatureTypeConstraint element "
-                    "per LayerFeatureConstraints is supported", "");
+          msSetError(MS_WMSERR,
+                     "Only one single FeatureTypeConstraint element "
+                     "per LayerFeatureConstraints is supported",
+                     "");
           return MS_FAILURE;
         }
       }
     }
-    if( psFeatureTypeConstraint != NULL ) {
-      CPLXMLNode* psFilter;
-      if( CPLGetXMLNode(psFeatureTypeConstraint, "FeatureTypeName") != NULL ) {
-        msSetError(MS_WMSERR, "FeatureTypeName element is not "
-                    "supported in FeatureTypeConstraint", "");
+    if (psFeatureTypeConstraint != NULL) {
+      CPLXMLNode *psFilter;
+      if (CPLGetXMLNode(psFeatureTypeConstraint, "FeatureTypeName") != NULL) {
+        msSetError(MS_WMSERR,
+                   "FeatureTypeName element is not "
+                   "supported in FeatureTypeConstraint",
+                   "");
         return MS_FAILURE;
       }
-      if( CPLGetXMLNode(psFeatureTypeConstraint, "Extent") != NULL ) {
-        msSetError(MS_WMSERR, "Extent element is not "
-                    "supported in FeatureTypeConstraint", "");
+      if (CPLGetXMLNode(psFeatureTypeConstraint, "Extent") != NULL) {
+        msSetError(MS_WMSERR,
+                   "Extent element is not "
+                   "supported in FeatureTypeConstraint",
+                   "");
         return MS_FAILURE;
       }
       psFilter = CPLGetXMLNode(psFeatureTypeConstraint, "Filter");
       if (psFilter && psFilter->psChild && psFilter->psChild->pszValue) {
-        char* pszExpression = msSLDGetCommonExpressionFromFilter(psFilter,
-                                                                    psLayer);
+        char *pszExpression =
+            msSLDGetCommonExpressionFromFilter(psFilter, psLayer);
         if (pszExpression) {
-            msFreeExpression(&psLayer->filter);
-            msInitExpression(&psLayer->filter);
-            psLayer->filter.string = pszExpression;
-            psLayer->filter.type = MS_EXPRESSION;
+          msFreeExpression(&psLayer->filter);
+          msInitExpression(&psLayer->filter);
+          psLayer->filter.string = pszExpression;
+          psLayer->filter.type = MS_EXPRESSION;
         }
       }
     }
@@ -925,21 +930,20 @@ int msSLDParseNamedLayer(CPLXMLNode *psR
   return MS_SUCCESS;
 }
 
-
 /************************************************************************/
 /*                      msSLDParseRule()                                */
 /*                                                                      */
 /*      Parse a Rule node into classes for a specific layer.            */
 /************************************************************************/
-int msSLDParseRule(CPLXMLNode *psRoot, layerObj *psLayer, const char* pszUserStyleName)
-{
+int msSLDParseRule(CPLXMLNode *psRoot, layerObj *psLayer,
+                   const char *pszUserStyleName) {
   CPLXMLNode *psLineSymbolizer = NULL;
   CPLXMLNode *psPolygonSymbolizer = NULL;
   CPLXMLNode *psPointSymbolizer = NULL;
   CPLXMLNode *psTextSymbolizer = NULL;
   CPLXMLNode *psRasterSymbolizer = NULL;
 
-  int nSymbolizer=0;
+  int nSymbolizer = 0;
 
   if (!psRoot || !psLayer)
     return MS_FAILURE;
@@ -951,52 +955,45 @@ int msSLDParseRule(CPLXMLNode *psRoot, l
   /* ==================================================================== */
 
   /* Raster symbolizer */
-  LOOP_ON_CHILD_ELEMENT(psRoot, psRasterSymbolizer, "RasterSymbolizer")
-  {
+  LOOP_ON_CHILD_ELEMENT(psRoot, psRasterSymbolizer, "RasterSymbolizer") {
     msSLDParseRasterSymbolizer(psRasterSymbolizer, psLayer, pszUserStyleName);
     /* cppcheck-suppress knownConditionTrueFalse */
-    if (nSymbolizer == 0)
-    {
+    if (nSymbolizer == 0) {
       psLayer->type = MS_LAYER_RASTER;
     }
   }
 
   /* Polygon symbolizer */
-  LOOP_ON_CHILD_ELEMENT(psRoot, psPolygonSymbolizer, "PolygonSymbolizer")
-  {
+  LOOP_ON_CHILD_ELEMENT(psRoot, psPolygonSymbolizer, "PolygonSymbolizer") {
     /* cppcheck-suppress knownConditionTrueFalse */
     const int bNewClass = (nSymbolizer == 0);
-    msSLDParsePolygonSymbolizer(psPolygonSymbolizer, psLayer,
-                                bNewClass, pszUserStyleName);
+    msSLDParsePolygonSymbolizer(psPolygonSymbolizer, psLayer, bNewClass,
+                                pszUserStyleName);
     psLayer->type = MS_LAYER_POLYGON;
     nSymbolizer++;
   }
 
   /* line symbolizer */
-  LOOP_ON_CHILD_ELEMENT(psRoot, psLineSymbolizer, "LineSymbolizer")
-  {
+  LOOP_ON_CHILD_ELEMENT(psRoot, psLineSymbolizer, "LineSymbolizer") {
     const int bNewClass = (nSymbolizer == 0);
     msSLDParseLineSymbolizer(psLineSymbolizer, psLayer, bNewClass,
                              pszUserStyleName);
-    if (bNewClass)
-    {
+    if (bNewClass) {
       psLayer->type = MS_LAYER_LINE;
     }
-    if (psLayer->type == MS_LAYER_POLYGON)
-    {
+    if (psLayer->type == MS_LAYER_POLYGON) {
       const int nClassId = psLayer->numclasses - 1;
-      if (nClassId >= 0)
-      {
+      if (nClassId >= 0) {
         const int nStyleId = psLayer->class[nClassId]->numstyles - 1;
-        if (nStyleId >= 0)
-        {
-          styleObj * psStyle = psLayer->class[nClassId]->styles[nStyleId];
+        if (nStyleId >= 0) {
+          styleObj *psStyle = psLayer->class[nClassId]->styles[nStyleId];
           psStyle->outlinecolor = psStyle->color;
-          MS_INIT_COLOR(psStyle->color,-1,-1,-1,255);
-          MS_COPYSTRING(psStyle->exprBindings[MS_STYLE_BINDING_OUTLINECOLOR].string,
+          MS_INIT_COLOR(psStyle->color, -1, -1, -1, 255);
+          MS_COPYSTRING(
+              psStyle->exprBindings[MS_STYLE_BINDING_OUTLINECOLOR].string,
               psStyle->exprBindings[MS_STYLE_BINDING_COLOR].string);
           psStyle->exprBindings[MS_STYLE_BINDING_OUTLINECOLOR].type =
-            psStyle->exprBindings[MS_STYLE_BINDING_COLOR].type;
+              psStyle->exprBindings[MS_STYLE_BINDING_COLOR].type;
           msFreeExpression(&(psStyle->exprBindings[MS_STYLE_BINDING_COLOR]));
           msInitExpression(&(psStyle->exprBindings[MS_STYLE_BINDING_COLOR]));
         }
@@ -1006,26 +1003,20 @@ int msSLDParseRule(CPLXMLNode *psRoot, l
   }
 
   /* Point Symbolizer */
-  LOOP_ON_CHILD_ELEMENT(psRoot, psPointSymbolizer, "PointSymbolizer")
-  {
+  LOOP_ON_CHILD_ELEMENT(psRoot, psPointSymbolizer, "PointSymbolizer") {
     const int bNewClass = (nSymbolizer == 0);
     msSLDParsePointSymbolizer(psPointSymbolizer, psLayer, bNewClass,
                               pszUserStyleName);
-    if (bNewClass)
-    {
+    if (bNewClass) {
       psLayer->type = MS_LAYER_POINT;
     }
-    if (psLayer->type == MS_LAYER_POLYGON
-        || psLayer->type == MS_LAYER_LINE
-        || psLayer->type == MS_LAYER_RASTER)
-    {
+    if (psLayer->type == MS_LAYER_POLYGON || psLayer->type == MS_LAYER_LINE ||
+        psLayer->type == MS_LAYER_RASTER) {
       const int nClassId = psLayer->numclasses - 1;
-      if (nClassId >= 0)
-      {
+      if (nClassId >= 0) {
         const int nStyleId = psLayer->class[nClassId]->numstyles - 1;
-        if (nStyleId >= 0)
-        {
-          styleObj * psStyle = psLayer->class[nClassId]->styles[nStyleId];
+        if (nStyleId >= 0) {
+          styleObj *psStyle = psLayer->class[nClassId]->styles[nStyleId];
           msStyleSetGeomTransform(psStyle, "centroid");
         }
       }
@@ -1044,11 +1035,11 @@ int msSLDParseRule(CPLXMLNode *psRoot, l
   /*        - If there are no other symbolizers, a new class will be      */
   /*      created to contain the label object.                            */
   /* ==================================================================== */
-  LOOP_ON_CHILD_ELEMENT(psRoot, psTextSymbolizer, "TextSymbolizer")
-  {
+  LOOP_ON_CHILD_ELEMENT(psRoot, psTextSymbolizer, "TextSymbolizer") {
     if (nSymbolizer == 0)
       psLayer->type = MS_LAYER_POINT;
-    msSLDParseTextSymbolizer(psTextSymbolizer, psLayer, nSymbolizer > 0, pszUserStyleName);
+    msSLDParseTextSymbolizer(psTextSymbolizer, psLayer, nSymbolizer > 0,
+                             pszUserStyleName);
   }
 
   return MS_SUCCESS;
@@ -1058,56 +1049,57 @@ int msSLDParseRule(CPLXMLNode *psRoot, l
 /*                            getClassId()                              */
 /************************************************************************/
 
-static int getClassId(layerObj *psLayer,
-                      int bNewClass,
-                      const char* pszUserStyleName)
-{
-    int nClassId;
-    if (bNewClass || psLayer->numclasses <= 0) {
-      if (msGrowLayerClasses(psLayer) == NULL)
-        return -1;
-      initClass(psLayer->class[psLayer->numclasses]);
-      nClassId = psLayer->numclasses;
-      if( pszUserStyleName )
-        psLayer->class[nClassId]->group = msStrdup(pszUserStyleName);
-      psLayer->numclasses++;
-    } else {
-      nClassId = psLayer->numclasses-1;
-    }
-    return nClassId;
+static int getClassId(layerObj *psLayer, int bNewClass,
+                      const char *pszUserStyleName) {
+  int nClassId;
+  if (bNewClass || psLayer->numclasses <= 0) {
+    if (msGrowLayerClasses(psLayer) == NULL)
+      return -1;
+    initClass(psLayer->class[psLayer->numclasses]);
+    nClassId = psLayer->numclasses;
+    if (pszUserStyleName)
+      psLayer->class[nClassId]->group = msStrdup(pszUserStyleName);
+    psLayer->numclasses++;
+  } else {
+    nClassId = psLayer->numclasses - 1;
+  }
+  return nClassId;
 }
 
 /************************************************************************/
 /*                      msSLDParseUomAttribute()                        */
 /************************************************************************/
 
-int msSLDParseUomAttribute(CPLXMLNode *node, enum MS_UNITS * sizeunits)
-{
-  const struct
-  {
+int msSLDParseUomAttribute(CPLXMLNode *node, enum MS_UNITS *sizeunits) {
+  const struct {
     enum MS_UNITS unit;
-    char * values[10];
-  } known_uoms[] =
-  {
-    { MS_INCHES, { "inch", "inches", NULL } },
-    { MS_FEET, { "foot", "feet", "http://www.opengeospatial.org/se/units/foot", NULL } },
-    { MS_MILES, { "mile", "miles", NULL } },
-    { MS_METERS, { "meter", "meters", "metre", "metres", "http://www.opengeospatial.org/se/units/metre", NULL } },
-    { MS_KILOMETERS, { "kilometer", "kilometers", "kilometre", "kilometres", NULL } },
-    { MS_DD, { "dd", NULL } },
-    { MS_PIXELS, { "pixel", "pixels", "px", "http://www.opengeospatial.org/se/units/pixel", NULL } },
-    { MS_PERCENTAGES, { "percent", "percents", "percentage", "percentages", NULL } },
-    { MS_NAUTICALMILES, { "nauticalmile", "nauticalmiles", "nautical_mile", "nautical_miles", NULL } },
-    { 0, { NULL } }
-  };
-
-  const char * uom = CPLGetXMLValue(node, "uom", NULL);
-  if (uom)
-  {
-    for (int i=0 ; known_uoms[i].values[0] ; i++)
-      for (int j=0 ; known_uoms[i].values[j] ; j++)
-        if (strcmp(uom,known_uoms[i].values[j]) == 0)
-        {
+    char *values[10];
+  } known_uoms[] = {
+      {MS_INCHES, {"inch", "inches", NULL}},
+      {MS_FEET,
+       {"foot", "feet", "http://www.opengeospatial.org/se/units/foot", NULL}},
+      {MS_MILES, {"mile", "miles", NULL}},
+      {MS_METERS,
+       {"meter", "meters", "metre", "metres",
+        "http://www.opengeospatial.org/se/units/metre", NULL}},
+      {MS_KILOMETERS,
+       {"kilometer", "kilometers", "kilometre", "kilometres", NULL}},
+      {MS_DD, {"dd", NULL}},
+      {MS_PIXELS,
+       {"pixel", "pixels", "px", "http://www.opengeospatial.org/se/units/pixel",
+        NULL}},
+      {MS_PERCENTAGES,
+       {"percent", "percents", "percentage", "percentages", NULL}},
+      {MS_NAUTICALMILES,
+       {"nauticalmile", "nauticalmiles", "nautical_mile", "nautical_miles",
+        NULL}},
+      {0, {NULL}}};
+
+  const char *uom = CPLGetXMLValue(node, "uom", NULL);
+  if (uom) {
+    for (int i = 0; known_uoms[i].values[0]; i++)
+      for (int j = 0; known_uoms[i].values[j]; j++)
+        if (strcmp(uom, known_uoms[i].values[j]) == 0) {
           // Match found
           *sizeunits = known_uoms[i].unit;
           return MS_SUCCESS;
@@ -1120,7 +1112,6 @@ int msSLDParseUomAttribute(CPLXMLNode *n
   return MS_SUCCESS;
 }
 
-
 /************************************************************************/
 /*                 msSLDParseLineSymbolizer()                           */
 /*                                                                      */
@@ -1166,47 +1157,46 @@ int msSLDParseUomAttribute(CPLXMLNode *n
 /*       ...                                                            */
 /************************************************************************/
 int msSLDParseLineSymbolizer(CPLXMLNode *psRoot, layerObj *psLayer,
-                             int bNewClass, const char* pszUserStyleName)
-{
-  CPLXMLNode *psStroke=NULL, *psOffset=NULL;
+                             int bNewClass, const char *pszUserStyleName) {
+  CPLXMLNode *psStroke = NULL, *psOffset = NULL;
 
   if (!psRoot || !psLayer)
     return MS_FAILURE;
 
   // Get uom if any, defaults to MS_PIXELS
   enum MS_UNITS sizeunits = MS_PIXELS;
-  if (msSLDParseUomAttribute(psRoot, &sizeunits) != MS_SUCCESS)
-  {
-    msSetError(MS_WMSERR, "Invalid uom attribute value.", "msSLDParsePolygonSymbolizer()");
+  if (msSLDParseUomAttribute(psRoot, &sizeunits) != MS_SUCCESS) {
+    msSetError(MS_WMSERR, "Invalid uom attribute value.",
+               "msSLDParsePolygonSymbolizer()");
     return MS_FAILURE;
   }
 
-  psStroke =  CPLGetXMLNode(psRoot, "Stroke");
+  psStroke = CPLGetXMLNode(psRoot, "Stroke");
   if (psStroke) {
     int nClassId = getClassId(psLayer, bNewClass, pszUserStyleName);
-    if( nClassId < 0 )
-        return MS_FAILURE;
+    if (nClassId < 0)
+      return MS_FAILURE;
 
     const int iStyle = psLayer->class[nClassId]->numstyles;
     msMaybeAllocateClassStyle(psLayer->class[nClassId], iStyle);
     psLayer->class[nClassId]->styles[iStyle]->sizeunits = sizeunits;
 
-    msSLDParseStroke(psStroke, psLayer->class[nClassId]->styles[iStyle],
-                     psLayer->map, 0);
+    msSLDParseStroke(psStroke, psLayer->class[nClassId] -> styles[iStyle],
+                     psLayer -> map, 0);
 
     /*parse PerpendicularOffset SLD 1.1.10*/
     psOffset = CPLGetXMLNode(psRoot, "PerpendicularOffset");
     if (psOffset && psOffset->psChild && psOffset->psChild->pszValue) {
-      psLayer->class[nClassId]->styles[iStyle]->offsetx = atoi(psOffset->psChild->pszValue);
-      psLayer->class[nClassId]->styles[iStyle]->offsety = MS_STYLE_SINGLE_SIDED_OFFSET;
+      psLayer->class[nClassId]->styles[iStyle]->offsetx =
+          atoi(psOffset->psChild->pszValue);
+      psLayer->class[nClassId]->styles[iStyle]->offsety =
+          MS_STYLE_SINGLE_SIDED_OFFSET;
     }
   }
 
   return MS_SUCCESS;
 }
 
-
-
 /************************************************************************/
 /*           void msSLDParseStroke(CPLXMLNode *psStroke, styleObj       */
 /*      *psStyle, int iColorParam)                                      */
@@ -1217,10 +1207,9 @@ int msSLDParseLineSymbolizer(CPLXMLNode
 /*        0 : for color                                                 */
 /*        1 : outlinecolor                                              */
 /************************************************************************/
-int msSLDParseStroke(CPLXMLNode *psStroke, styleObj *psStyle,
-                     mapObj *map, int iColorParam)
-{
-  CPLXMLNode *psCssParam = NULL, *psGraphicFill=NULL;
+int msSLDParseStroke(CPLXMLNode *psStroke, styleObj *psStyle, mapObj *map,
+                     int iColorParam) {
+  CPLXMLNode *psCssParam = NULL, *psGraphicFill = NULL;
   char *psStrkName = NULL;
   char *pszDashValue = NULL;
 
@@ -1228,54 +1217,54 @@ int msSLDParseStroke(CPLXMLNode *psStrok
     return MS_FAILURE;
 
   /* parse css parameters */
-  psCssParam =  CPLGetXMLNode(psStroke, "CssParameter");
+  psCssParam = CPLGetXMLNode(psStroke, "CssParameter");
   /*sld 1.1 used SvgParameter*/
   if (psCssParam == NULL)
-    psCssParam =  CPLGetXMLNode(psStroke, "SvgParameter");
+    psCssParam = CPLGetXMLNode(psStroke, "SvgParameter");
 
   while (psCssParam && psCssParam->pszValue &&
          (strcasecmp(psCssParam->pszValue, "CssParameter") == 0 ||
           strcasecmp(psCssParam->pszValue, "SvgParameter") == 0)) {
-    psStrkName = (char*)CPLGetXMLValue(psCssParam, "name", NULL);
+    psStrkName = (char *)CPLGetXMLValue(psCssParam, "name", NULL);
 
     if (psStrkName) {
       if (strcasecmp(psStrkName, "stroke") == 0) {
-        if(psCssParam->psChild && psCssParam->psChild->psNext)
-        {
+        if (psCssParam->psChild && psCssParam->psChild->psNext) {
           switch (iColorParam) {
-            case 0:
-              msSLDParseOgcExpression(psCssParam->psChild->psNext,
-                  psStyle, MS_STYLE_BINDING_COLOR, MS_OBJ_STYLE);
-              break;
-            case 1:
-              msSLDParseOgcExpression(psCssParam->psChild->psNext,
-                  psStyle, MS_STYLE_BINDING_OUTLINECOLOR, MS_OBJ_STYLE);
-              break;
+          case 0:
+            msSLDParseOgcExpression(psCssParam->psChild->psNext, psStyle,
+                                    MS_STYLE_BINDING_COLOR, MS_OBJ_STYLE);
+            break;
+          case 1:
+            msSLDParseOgcExpression(psCssParam->psChild->psNext, psStyle,
+                                    MS_STYLE_BINDING_OUTLINECOLOR,
+                                    MS_OBJ_STYLE);
+            break;
           }
         }
       } else if (strcasecmp(psStrkName, "stroke-width") == 0) {
-        if(psCssParam->psChild &&  psCssParam->psChild->psNext)
-        {
+        if (psCssParam->psChild && psCssParam->psChild->psNext) {
           msSLDParseOgcExpression(psCssParam->psChild->psNext, psStyle,
                                   MS_STYLE_BINDING_WIDTH, MS_OBJ_STYLE);
         }
       } else if (strcasecmp(psStrkName, "stroke-dasharray") == 0) {
-        if(psCssParam->psChild && psCssParam->psChild->psNext &&
+        if (psCssParam->psChild && psCssParam->psChild->psNext &&
             psCssParam->psChild->psNext->pszValue) {
           int nDash = 0, i;
           char **aszValues = NULL;
           int nMaxDash;
-          if(pszDashValue) free(pszDashValue); /* free previous if multiple stroke-dasharray attributes were found */
-          pszDashValue =
-            msStrdup(psCssParam->psChild->psNext->pszValue);
+          if (pszDashValue)
+            free(pszDashValue); /* free previous if multiple stroke-dasharray
+                                   attributes were found */
+          pszDashValue = msStrdup(psCssParam->psChild->psNext->pszValue);
           aszValues = msStringSplit(pszDashValue, ' ', &nDash);
           if (nDash > 0) {
             nMaxDash = nDash;
             if (nDash > MS_MAXPATTERNLENGTH)
-              nMaxDash =  MS_MAXPATTERNLENGTH;
+              nMaxDash = MS_MAXPATTERNLENGTH;
 
             psStyle->patternlength = nMaxDash;
-            for (i=0; i<nMaxDash; i++)
+            for (i = 0; i < nMaxDash; i++)
               psStyle->pattern[i] = atof(aszValues[i]);
 
             psStyle->linecap = MS_CJC_BUTT;
@@ -1283,10 +1272,9 @@ int msSLDParseStroke(CPLXMLNode *psStrok
           msFreeCharArray(aszValues, nDash);
         }
       } else if (strcasecmp(psStrkName, "stroke-opacity") == 0) {
-        if(psCssParam->psChild &&  psCssParam->psChild->psNext)
-        {
-          msSLDParseOgcExpression(psCssParam->psChild->psNext,
-              psStyle, MS_STYLE_BINDING_OPACITY, MS_OBJ_STYLE);
+        if (psCssParam->psChild && psCssParam->psChild->psNext) {
+          msSLDParseOgcExpression(psCssParam->psChild->psNext, psStyle,
+                                  MS_STYLE_BINDING_OPACITY, MS_OBJ_STYLE);
         }
       }
     }
@@ -1298,10 +1286,10 @@ int msSLDParseStroke(CPLXMLNode *psStrok
   /* TODO : It seems inconsistent to me since the only difference */
   /* between them seems to be fill (fill) or not fill (stroke). And */
   /* then again the fill parameter can be used inside both elements. */
-  psGraphicFill =  CPLGetXMLNode(psStroke, "GraphicFill");
+  psGraphicFill = CPLGetXMLNode(psStroke, "GraphicFill");
   if (psGraphicFill)
     msSLDParseGraphicFillOrStroke(psGraphicFill, pszDashValue, psStyle, map);
-  psGraphicFill =  CPLGetXMLNode(psStroke, "GraphicStroke");
+  psGraphicFill = CPLGetXMLNode(psStroke, "GraphicStroke");
   if (psGraphicFill)
     msSLDParseGraphicFillOrStroke(psGraphicFill, pszDashValue, psStyle, map);
 
@@ -1311,8 +1299,6 @@ int msSLDParseStroke(CPLXMLNode *psStrok
   return MS_SUCCESS;
 }
 
-
-
 /************************************************************************/
 /*  int msSLDParseOgcExpression(CPLXMLNode *psRoot, styleObj *psStyle,  */
 /*                              enum MS_STYLE_BINDING_ENUM binding)     */
@@ -1320,255 +1306,234 @@ int msSLDParseStroke(CPLXMLNode *psStrok
 /*              Parse an OGC expression in a <SvgParameter>             */
 /************************************************************************/
 int msSLDParseOgcExpression(CPLXMLNode *psRoot, void *psObj, int binding,
-                            enum objType objtype)
-{
+                            enum objType objtype) {
   int status = MS_FAILURE;
-  const char * ops = "Add+Sub-Mul*Div/";
-  styleObj * psStyle = psObj;
-  labelObj * psLabel = psObj;
+  const char *ops = "Add+Sub-Mul*Div/";
+  styleObj *psStyle = psObj;
+  labelObj *psLabel = psObj;
   int lbinding;
   expressionObj *exprBindings;
   int *nexprbindings;
   enum { MS_STYLE_BASE = 0, MS_LABEL_BASE = 100 };
 
-  switch (objtype)
-  {
-    case MS_OBJ_STYLE:
-      lbinding = binding + MS_STYLE_BASE;
-      exprBindings = psStyle->exprBindings;
-      nexprbindings = &psStyle->nexprbindings;
+  switch (objtype) {
+  case MS_OBJ_STYLE:
+    lbinding = binding + MS_STYLE_BASE;
+    exprBindings = psStyle->exprBindings;
+    nexprbindings = &psStyle->nexprbindings;
+    break;
+  case MS_OBJ_LABEL:
+    lbinding = binding + MS_LABEL_BASE;
+    exprBindings = psLabel->exprBindings;
+    nexprbindings = &psLabel->nexprbindings;
+    break;
+  default:
+    return MS_FAILURE;
+    break;
+  }
+
+  switch (psRoot->eType) {
+  case CXT_Text:
+    // Parse a raw value
+    {
+      msStringBuffer *literal = msStringBufferAlloc();
+      msStringBufferAppend(literal, "(");
+      msStringBufferAppend(literal, psRoot->pszValue);
+      msStringBufferAppend(literal, ")");
+      msFreeExpression(&(exprBindings[binding]));
+      msInitExpression(&(exprBindings[binding]));
+      exprBindings[binding].string =
+          msStringBufferReleaseStringAndFree(literal);
+      exprBindings[binding].type = MS_STRING;
+    }
+    switch (lbinding) {
+    case MS_STYLE_BASE + MS_STYLE_BINDING_OFFSET_X:
+      psStyle->offsetx = atoi(psRoot->pszValue);
+      status = MS_SUCCESS;
       break;
-    case MS_OBJ_LABEL:
-      lbinding = binding + MS_LABEL_BASE;
-      exprBindings = psLabel->exprBindings;
-      nexprbindings = &psLabel->nexprbindings;
+    case MS_STYLE_BASE + MS_STYLE_BINDING_OFFSET_Y:
+      psStyle->offsety = atoi(psRoot->pszValue);
+      status = MS_SUCCESS;
       break;
-    default:
-      return MS_FAILURE;
+    case MS_STYLE_BASE + MS_STYLE_BINDING_ANGLE:
+      psStyle->angle = atof(psRoot->pszValue);
+      status = MS_SUCCESS;
       break;
-  }
-
-  switch (psRoot->eType)
-  {
-    case CXT_Text:
-      // Parse a raw value
-      {
-        msStringBuffer * literal = msStringBufferAlloc();
-        msStringBufferAppend(literal, "(");
-        msStringBufferAppend(literal, psRoot->pszValue);
-        msStringBufferAppend(literal, ")");
-        msFreeExpression(&(exprBindings[binding]));
-        msInitExpression(&(exprBindings[binding]));
-        exprBindings[binding].string =
-            msStringBufferReleaseStringAndFree(literal);
-        exprBindings[binding].type = MS_STRING;
+    case MS_STYLE_BASE + MS_STYLE_BINDING_SIZE:
+      psStyle->size = atof(psRoot->pszValue);
+      status = MS_SUCCESS;
+      break;
+    case MS_STYLE_BASE + MS_STYLE_BINDING_WIDTH:
+      psStyle->width = atof(psRoot->pszValue);
+      status = MS_SUCCESS;
+      break;
+    case MS_STYLE_BASE + MS_STYLE_BINDING_OPACITY:
+      psStyle->opacity = atof(psRoot->pszValue) * 100;
+      status = MS_SUCCESS;
+      // Apply opacity as the alpha channel color(s)
+      if (psStyle->opacity < 100) {
+        int alpha = MS_NINT(psStyle->opacity * 2.55);
+        psStyle->color.alpha = alpha;
+        psStyle->outlinecolor.alpha = alpha;
+        psStyle->mincolor.alpha = alpha;
+        psStyle->maxcolor.alpha = alpha;
       }
-      switch (lbinding)
-      {
-        case MS_STYLE_BASE + MS_STYLE_BINDING_OFFSET_X:
-          psStyle->offsetx = atoi(psRoot->pszValue);
-          status = MS_SUCCESS;
-          break;
-        case MS_STYLE_BASE + MS_STYLE_BINDING_OFFSET_Y:
-          psStyle->offsety = atoi(psRoot->pszValue);
-          status = MS_SUCCESS;
-          break;
-        case MS_STYLE_BASE + MS_STYLE_BINDING_ANGLE:
-          psStyle->angle = atof(psRoot->pszValue);
-          status = MS_SUCCESS;
-          break;
-        case MS_STYLE_BASE + MS_STYLE_BINDING_SIZE:
-          psStyle->size = atof(psRoot->pszValue);
-          status = MS_SUCCESS;
-          break;
-        case MS_STYLE_BASE + MS_STYLE_BINDING_WIDTH:
-          psStyle->width = atof(psRoot->pszValue);
-          status = MS_SUCCESS;
-          break;
-        case MS_STYLE_BASE + MS_STYLE_BINDING_OPACITY:
-          psStyle->opacity = atof(psRoot->pszValue)*100;
-          status = MS_SUCCESS;
-          // Apply opacity as the alpha channel color(s)
-          if(psStyle->opacity < 100)
-          {
-            int alpha = MS_NINT(psStyle->opacity*2.55);
-            psStyle->color.alpha = alpha;
-            psStyle->outlinecolor.alpha = alpha;
-            psStyle->mincolor.alpha = alpha;
-            psStyle->maxcolor.alpha = alpha;
-          }
-          break;
-        case MS_STYLE_BASE + MS_STYLE_BINDING_COLOR:
-          if (strlen(psRoot->pszValue) == 7 && psRoot->pszValue[0] == '#')
-          {
-            psStyle->color.red = msHexToInt(psRoot->pszValue+1);
-            psStyle->color.green = msHexToInt(psRoot->pszValue+3);
-            psStyle->color.blue = msHexToInt(psRoot->pszValue+5);
-            status = MS_SUCCESS;
-          }
-          break;
-        case MS_STYLE_BASE + MS_STYLE_BINDING_OUTLINECOLOR:
-          if (strlen(psRoot->pszValue) == 7 && psRoot->pszValue[0] == '#')
-          {
-            psStyle->outlinecolor.red = msHexToInt(psRoot->pszValue+1);
-            psStyle->outlinecolor.green = msHexToInt(psRoot->pszValue+3);
-            psStyle->outlinecolor.blue = msHexToInt(psRoot->pszValue+5);
-            status = MS_SUCCESS;
-          }
-          break;
-
-        case MS_LABEL_BASE + MS_LABEL_BINDING_SIZE:
-          psLabel->size = atof(psRoot->pszValue);
-          if (psLabel->size <= 0.0)
-          {
-            psLabel->size = 10.0;
-          }
-          status = MS_SUCCESS;
-          break;
-        case MS_LABEL_BASE + MS_LABEL_BINDING_ANGLE:
-          psLabel->angle = atof(psRoot->pszValue);
-          status = MS_SUCCESS;
-          break;
-        case MS_LABEL_BASE + MS_LABEL_BINDING_COLOR:
-          if (strlen(psRoot->pszValue) == 7 && psRoot->pszValue[0] == '#')
-          {
-            psLabel->color.red = msHexToInt(psRoot->pszValue+1);
-            psLabel->color.green = msHexToInt(psRoot->pszValue+3);
-            psLabel->color.blue= msHexToInt(psRoot->pszValue+5);
-            status = MS_SUCCESS;
-          }
-          break;
-        case MS_LABEL_BASE + MS_LABEL_BINDING_OUTLINECOLOR:
-          if (strlen(psRoot->pszValue) == 7 && psRoot->pszValue[0] == '#')
-          {
-            psLabel->outlinecolor.red = msHexToInt(psRoot->pszValue+1);
-            psLabel->outlinecolor.green = msHexToInt(psRoot->pszValue+3);
-            psLabel->outlinecolor.blue= msHexToInt(psRoot->pszValue+5);
-            status = MS_SUCCESS;
-          }
-          break;
-        default:
-          break;
+      break;
+    case MS_STYLE_BASE + MS_STYLE_BINDING_COLOR:
+      if (strlen(psRoot->pszValue) == 7 && psRoot->pszValue[0] == '#') {
+        psStyle->color.red = msHexToInt(psRoot->pszValue + 1);
+        psStyle->color.green = msHexToInt(psRoot->pszValue + 3);
+        psStyle->color.blue = msHexToInt(psRoot->pszValue + 5);
+        status = MS_SUCCESS;
       }
       break;
-    case CXT_Element:
-      if (strcasecmp(psRoot->pszValue,"Literal") == 0 && psRoot->psChild)
-      {
-        // Parse a <ogc:Literal> element
-        status = msSLDParseOgcExpression(psRoot->psChild, psObj, binding, objtype);
+    case MS_STYLE_BASE + MS_STYLE_BINDING_OUTLINECOLOR:
+      if (strlen(psRoot->pszValue) == 7 && psRoot->pszValue[0] == '#') {
+        psStyle->outlinecolor.red = msHexToInt(psRoot->pszValue + 1);
+        psStyle->outlinecolor.green = msHexToInt(psRoot->pszValue + 3);
+        psStyle->outlinecolor.blue = msHexToInt(psRoot->pszValue + 5);
+        status = MS_SUCCESS;
       }
-      else if (strcasecmp(psRoot->pszValue,"PropertyName") == 0
-          && psRoot->psChild)
-      {
-        // Parse a <ogc:PropertyName> element
-        msStringBuffer * property = msStringBufferAlloc();
-        const char * strDelim = "";
+      break;
 
-        switch (lbinding)
-        {
-          case MS_STYLE_BASE + MS_STYLE_BINDING_COLOR:
-          case MS_STYLE_BASE + MS_STYLE_BINDING_OUTLINECOLOR:
-          case MS_LABEL_BASE + MS_LABEL_BINDING_COLOR:
-          case MS_LABEL_BASE + MS_LABEL_BINDING_OUTLINECOLOR:
-            strDelim = "\"";
-            /* FALLTHROUGH */
-          default:
-            msStringBufferAppend(property, strDelim);
-            msStringBufferAppend(property, "[");
-            msStringBufferAppend(property, psRoot->psChild->pszValue);
-            msStringBufferAppend(property, "]");
-            msStringBufferAppend(property, strDelim);
-            msInitExpression(&(exprBindings[binding]));
-            exprBindings[binding].string =
-            msStringBufferReleaseStringAndFree(property);
-            exprBindings[binding].type = MS_EXPRESSION;
-            (*nexprbindings)++;
-            break;
-        }
+    case MS_LABEL_BASE + MS_LABEL_BINDING_SIZE:
+      psLabel->size = atof(psRoot->pszValue);
+      if (psLabel->size <= 0.0) {
+        psLabel->size = 10.0;
+      }
+      status = MS_SUCCESS;
+      break;
+    case MS_LABEL_BASE + MS_LABEL_BINDING_ANGLE:
+      psLabel->angle = atof(psRoot->pszValue);
+      status = MS_SUCCESS;
+      break;
+    case MS_LABEL_BASE + MS_LABEL_BINDING_COLOR:
+      if (strlen(psRoot->pszValue) == 7 && psRoot->pszValue[0] == '#') {
+        psLabel->color.red = msHexToInt(psRoot->pszValue + 1);
+        psLabel->color.green = msHexToInt(psRoot->pszValue + 3);
+        psLabel->color.blue = msHexToInt(psRoot->pszValue + 5);
         status = MS_SUCCESS;
       }
-      else if (strcasecmp(psRoot->pszValue,"Function") == 0
-          && psRoot->psChild
-          && CPLGetXMLValue(psRoot,"name",NULL)
-          && psRoot->psChild->psNext)
-      {
-        // Parse a <ogc:Function> element
-        msStringBuffer * function = msStringBufferAlloc();
-
-        // Parse function name
-        const char * funcname = CPLGetXMLValue(psRoot,"name",NULL);
-        msStringBufferAppend(function, funcname);
-        msStringBufferAppend(function, "(");
+      break;
+    case MS_LABEL_BASE + MS_LABEL_BINDING_OUTLINECOLOR:
+      if (strlen(psRoot->pszValue) == 7 && psRoot->pszValue[0] == '#') {
+        psLabel->outlinecolor.red = msHexToInt(psRoot->pszValue + 1);
+        psLabel->outlinecolor.green = msHexToInt(psRoot->pszValue + 3);
+        psLabel->outlinecolor.blue = msHexToInt(psRoot->pszValue + 5);
+        status = MS_SUCCESS;
+      }
+      break;
+    default:
+      break;
+    }
+    break;
+  case CXT_Element:
+    if (strcasecmp(psRoot->pszValue, "Literal") == 0 && psRoot->psChild) {
+      // Parse a <ogc:Literal> element
+      status =
+          msSLDParseOgcExpression(psRoot->psChild, psObj, binding, objtype);
+    } else if (strcasecmp(psRoot->pszValue, "PropertyName") == 0 &&
+               psRoot->psChild) {
+      // Parse a <ogc:PropertyName> element
+      msStringBuffer *property = msStringBufferAlloc();
+      const char *strDelim = "";
+
+      switch (lbinding) {
+      case MS_STYLE_BASE + MS_STYLE_BINDING_COLOR:
+      case MS_STYLE_BASE + MS_STYLE_BINDING_OUTLINECOLOR:
+      case MS_LABEL_BASE + MS_LABEL_BINDING_COLOR:
+      case MS_LABEL_BASE + MS_LABEL_BINDING_OUTLINECOLOR:
+        strDelim = "\"";
+        /* FALLTHROUGH */
+      default:
+        msStringBufferAppend(property, strDelim);
+        msStringBufferAppend(property, "[");
+        msStringBufferAppend(property, psRoot->psChild->pszValue);
+        msStringBufferAppend(property, "]");
+        msStringBufferAppend(property, strDelim);
         msInitExpression(&(exprBindings[binding]));
-
-        // Parse arguments
-        char * sep ="";
-        for (CPLXMLNode * argument = psRoot->psChild->psNext ; argument ; argument = argument->psNext)
-        {
-          status = msSLDParseOgcExpression(argument, psObj, binding, objtype);
-          if (status != MS_SUCCESS)
-            break;
-          msStringBufferAppend(function, sep);
-          msStringBufferAppend(function, exprBindings[binding].string);
-          msFree(exprBindings[binding].string);
-          msInitExpression(&(exprBindings[binding]));
-          sep = ",";
-        }
-        msStringBufferAppend(function, ")");
         exprBindings[binding].string =
-            msStringBufferReleaseStringAndFree(function);
+            msStringBufferReleaseStringAndFree(property);
         exprBindings[binding].type = MS_EXPRESSION;
         (*nexprbindings)++;
-        status = MS_SUCCESS;
+        break;
       }
-      else if (strstr(ops, psRoot->pszValue)
-          && psRoot->psChild && psRoot->psChild->psNext)
-      {
-        // Parse an arithmetic element <ogc:Add>, <ogc:Sub>, <ogc:Mul>, <ogc:Div>
-        const char operator[2] = { *(strstr(ops, psRoot->pszValue)+3), '\0' };
-        msStringBuffer * expression = msStringBufferAlloc();
-
-        // Parse first operand
-        msStringBufferAppend(expression, "(");
+      status = MS_SUCCESS;
+    } else if (strcasecmp(psRoot->pszValue, "Function") == 0 &&
+               psRoot->psChild && CPLGetXMLValue(psRoot, "name", NULL) &&
+               psRoot->psChild->psNext) {
+      // Parse a <ogc:Function> element
+      msStringBuffer *function = msStringBufferAlloc();
+
+      // Parse function name
+      const char *funcname = CPLGetXMLValue(psRoot, "name", NULL);
+      msStringBufferAppend(function, funcname);
+      msStringBufferAppend(function, "(");
+      msInitExpression(&(exprBindings[binding]));
+
+      // Parse arguments
+      char *sep = "";
+      for (CPLXMLNode *argument = psRoot->psChild->psNext; argument;
+           argument = argument->psNext) {
+        status = msSLDParseOgcExpression(argument, psObj, binding, objtype);
+        if (status != MS_SUCCESS)
+          break;
+        msStringBufferAppend(function, sep);
+        msStringBufferAppend(function, exprBindings[binding].string);
+        msFree(exprBindings[binding].string);
         msInitExpression(&(exprBindings[binding]));
-        status = msSLDParseOgcExpression(psRoot->psChild, psObj, binding, objtype);
-
-        // Parse second operand
-        if (status == MS_SUCCESS)
-        {
+        sep = ",";
+      }
+      msStringBufferAppend(function, ")");
+      exprBindings[binding].string =
+          msStringBufferReleaseStringAndFree(function);
+      exprBindings[binding].type = MS_EXPRESSION;
+      (*nexprbindings)++;
+      status = MS_SUCCESS;
+    } else if (strstr(ops, psRoot->pszValue) && psRoot->psChild &&
+               psRoot->psChild->psNext) {
+      // Parse an arithmetic element <ogc:Add>, <ogc:Sub>, <ogc:Mul>, <ogc:Div>
+      const char operator[2] = {*(strstr(ops, psRoot->pszValue) + 3), '\0'};
+      msStringBuffer *expression = msStringBufferAlloc();
+
+      // Parse first operand
+      msStringBufferAppend(expression, "(");
+      msInitExpression(&(exprBindings[binding]));
+      status =
+          msSLDParseOgcExpression(psRoot->psChild, psObj, binding, objtype);
+
+      // Parse second operand
+      if (status == MS_SUCCESS) {
+        msStringBufferAppend(expression, exprBindings[binding].string);
+        msStringBufferAppend(expression, operator);
+        msFree(exprBindings[binding].string);
+        msInitExpression(&(exprBindings[binding]));
+        status = msSLDParseOgcExpression(psRoot->psChild->psNext, psObj,
+                                         binding, objtype);
+        if (status == MS_SUCCESS) {
           msStringBufferAppend(expression, exprBindings[binding].string);
-          msStringBufferAppend(expression, operator);
+          msStringBufferAppend(expression, ")");
           msFree(exprBindings[binding].string);
-          msInitExpression(&(exprBindings[binding]));
-          status = msSLDParseOgcExpression(psRoot->psChild->psNext,
-              psObj, binding, objtype);
-          if (status == MS_SUCCESS)
-          {
-            msStringBufferAppend(expression, exprBindings[binding].string);
-            msStringBufferAppend(expression, ")");
-            msFree(exprBindings[binding].string);
-            exprBindings[binding].string =
-                msStringBufferReleaseStringAndFree(expression);
-            expression = NULL;
-            exprBindings[binding].type = MS_EXPRESSION;
-            (*nexprbindings)++;
-          }
-        }
-        if (expression != NULL)
-        {
-          msStringBufferFree(expression);
-          msInitExpression(&(exprBindings[binding]));
+          exprBindings[binding].string =
+              msStringBufferReleaseStringAndFree(expression);
+          expression = NULL;
+          exprBindings[binding].type = MS_EXPRESSION;
+          (*nexprbindings)++;
         }
       }
-      break;
-    default:
-      break;
+      if (expression != NULL) {
+        msStringBufferFree(expression);
+        msInitExpression(&(exprBindings[binding]));
+      }
+    }
+    break;
+  default:
+    break;
   }
 
   return status;
 }
 
-
 /************************************************************************/
 /*                      msSLDParsePolygonSymbolizer()                   */
 /*                                                                      */
@@ -1594,8 +1559,10 @@ int msSLDParseOgcExpression(CPLXMLNode *
 /*      </xs:element>                                                   */
 /*                                                                      */
 /*      Here, the CssParameter names are fill instead of stroke and     */
-/*      fill-opacity instead of stroke-opacity. None of the other CssParameters*/
-/*      in Stroke are available for filling and the default value for the fill color in this context is 50% gray (value #808080).*/
+/*      fill-opacity instead of stroke-opacity. None of the other
+ * CssParameters*/
+/*      in Stroke are available for filling and the default value for the fill
+ * color in this context is 50% gray (value #808080).*/
 /*                                                                      */
 /*                                                                      */
 /*      <xs:element name="GraphicFill">                                 */
@@ -1623,8 +1590,10 @@ int msSLDParseOgcExpression(CPLXMLNode *
 /*      </xs:complexType>                                               */
 /*      </xs:element>                                                   */
 /*                                                                      */
-/*      The default if neither an ExternalGraphic nor a Mark is specified is to use the default*/
-/*      mark of a square with a 50%-gray fill and a black outline, with a size of 6 pixels.*/
+/*      The default if neither an ExternalGraphic nor a Mark is specified is to
+ * use the default*/
+/*      mark of a square with a 50%-gray fill and a black outline, with a size
+ * of 6 pixels.*/
 /*                                                                      */
 /*                                                                      */
 /*      <xs:element name="Mark">                                        */
@@ -1637,28 +1606,32 @@ int msSLDParseOgcExpression(CPLXMLNode *
 /*      </xs:complexType>                                               */
 /*      <xs:element name="WellKnownName" type="xs:string"/>             */
 /*                                                                      */
-/*      The WellKnownName element gives the well-known name of the shape of the mark.*/
+/*      The WellKnownName element gives the well-known name of the shape of the
+ * mark.*/
 /*      Allowed values include at least square, circle, triangle, star, cross,*/
-/*      and x, though map servers may draw a different symbol instead if they don't have a*/
-/*      shape for all of these. The default WellKnownName is square. Renderings of these*/
-/*      marks may be made solid or hollow depending on Fill and Stroke elements.*/
+/*      and x, though map servers may draw a different symbol instead if they
+ * don't have a*/
+/*      shape for all of these. The default WellKnownName is square. Renderings
+ * of these*/
+/*      marks may be made solid or hollow depending on Fill and Stroke
+ * elements.*/
 /*                                                                      */
 /************************************************************************/
 int msSLDParsePolygonSymbolizer(CPLXMLNode *psRoot, layerObj *psLayer,
-                                int bNewClass, const char* pszUserStyleName)
-{
+                                int bNewClass, const char *pszUserStyleName) {
   CPLXMLNode *psFill, *psStroke;
-  CPLXMLNode *psDisplacement=NULL, *psDisplacementX=NULL, *psDisplacementY=NULL;
-  int nOffsetX=-1, nOffsetY=-1;
+  CPLXMLNode *psDisplacement = NULL, *psDisplacementX = NULL,
+             *psDisplacementY = NULL;
+  int nOffsetX = -1, nOffsetY = -1;
 
   if (!psRoot || !psLayer)
     return MS_FAILURE;
 
   // Get uom if any, defaults to MS_PIXELS
   enum MS_UNITS sizeunits = MS_PIXELS;
-  if (msSLDParseUomAttribute(psRoot, &sizeunits) != MS_SUCCESS)
-  {
-    msSetError(MS_WMSERR, "Invalid uom attribute value.", "msSLDParsePolygonSymbolizer()");
+  if (msSLDParseUomAttribute(psRoot, &sizeunits) != MS_SUCCESS) {
+    msSetError(MS_WMSERR, "Invalid uom attribute value.",
+               "msSLDParsePolygonSymbolizer()");
     return MS_FAILURE;
   }
 
@@ -1668,29 +1641,26 @@ int msSLDParsePolygonSymbolizer(CPLXMLNo
     psDisplacementX = CPLGetXMLNode(psDisplacement, "DisplacementX");
     psDisplacementY = CPLGetXMLNode(psDisplacement, "DisplacementY");
     /* psCssParam->psChild->psNext->pszValue) */
-    if (psDisplacementX &&
-        psDisplacementX->psChild &&
-        psDisplacementX->psChild->pszValue &&
-        psDisplacementY &&
-        psDisplacementY->psChild &&
-        psDisplacementY->psChild->pszValue) {
+    if (psDisplacementX && psDisplacementX->psChild &&
+        psDisplacementX->psChild->pszValue && psDisplacementY &&
+        psDisplacementY->psChild && psDisplacementY->psChild->pszValue) {
       nOffsetX = atoi(psDisplacementX->psChild->pszValue);
       nOffsetY = atoi(psDisplacementY->psChild->pszValue);
     }
   }
 
-  psFill =  CPLGetXMLNode(psRoot, "Fill");
+  psFill = CPLGetXMLNode(psRoot, "Fill");
   if (psFill) {
     const int nClassId = getClassId(psLayer, bNewClass, pszUserStyleName);
-    if( nClassId < 0 )
-        return MS_FAILURE;
+    if (nClassId < 0)
+      return MS_FAILURE;
 
     const int iStyle = psLayer->class[nClassId]->numstyles;
     msMaybeAllocateClassStyle(psLayer->class[nClassId], iStyle);
     psLayer->class[nClassId]->styles[iStyle]->sizeunits = sizeunits;
 
-    msSLDParsePolygonFill(psFill, psLayer->class[nClassId]->styles[iStyle],
-                          psLayer->map);
+    msSLDParsePolygonFill(psFill, psLayer->class[nClassId] -> styles[iStyle],
+                          psLayer -> map);
 
     if (nOffsetX > 0 && nOffsetY > 0) {
       psLayer->class[nClassId]->styles[iStyle]->offsetx = nOffsetX;
@@ -1699,7 +1669,7 @@ int msSLDParsePolygonSymbolizer(CPLXMLNo
   }
   /* stroke which corresponds to the outline in mapserver */
   /* is drawn after the fill */
-  psStroke =  CPLGetXMLNode(psRoot, "Stroke");
+  psStroke = CPLGetXMLNode(psRoot, "Stroke");
   if (psStroke) {
     /* -------------------------------------------------------------------- */
     /*      there was a fill so add a style to the last class created       */
@@ -1708,22 +1678,21 @@ int msSLDParsePolygonSymbolizer(CPLXMLNo
     int nClassId;
     int iStyle;
     if (psFill && psLayer->numclasses > 0) {
-      nClassId =psLayer->numclasses-1;
+      nClassId = psLayer->numclasses - 1;
       iStyle = psLayer->class[nClassId]->numstyles;
       msMaybeAllocateClassStyle(psLayer->class[nClassId], iStyle);
       psLayer->class[nClassId]->styles[iStyle]->sizeunits = sizeunits;
     } else {
       nClassId = getClassId(psLayer, bNewClass, pszUserStyleName);
-      if( nClassId < 0 )
+      if (nClassId < 0)
         return MS_FAILURE;
 
       iStyle = psLayer->class[nClassId]->numstyles;
       msMaybeAllocateClassStyle(psLayer->class[nClassId], iStyle);
       psLayer->class[nClassId]->styles[iStyle]->sizeunits = sizeunits;
-
     }
-    msSLDParseStroke(psStroke, psLayer->class[nClassId]->styles[iStyle],
-                     psLayer->map, 1);
+    msSLDParseStroke(psStroke, psLayer->class[nClassId] -> styles[iStyle],
+                     psLayer -> map, 1);
 
     if (nOffsetX > 0 && nOffsetY > 0) {
       psLayer->class[nClassId]->styles[iStyle]->offsetx = nOffsetX;
@@ -1734,18 +1703,15 @@ int msSLDParsePolygonSymbolizer(CPLXMLNo
   return MS_SUCCESS;
 }
 
-
 /************************************************************************/
 /*    void msSLDParsePolygonFill(CPLXMLNode *psFill, styleObj *psStyle, */
 /*                                 mapObj *map)                         */
 /*                                                                      */
 /*      Parse the Fill node for a polygon into a style.                 */
 /************************************************************************/
-int msSLDParsePolygonFill(CPLXMLNode *psFill, styleObj *psStyle,
-                          mapObj *map)
-{
+int msSLDParsePolygonFill(CPLXMLNode *psFill, styleObj *psStyle, mapObj *map) {
   CPLXMLNode *psCssParam, *psGraphicFill;
-  char *psFillName=NULL;
+  char *psFillName = NULL;
 
   if (!psFill || !psStyle || !map)
     return MS_FAILURE;
@@ -1755,27 +1721,25 @@ int msSLDParsePolygonFill(CPLXMLNode *ps
   psStyle->color.green = 128;
   psStyle->color.blue = 128;
 
-  psCssParam =  CPLGetXMLNode(psFill, "CssParameter");
+  psCssParam = CPLGetXMLNode(psFill, "CssParameter");
   /*sld 1.1 used SvgParameter*/
   if (psCssParam == NULL)
-    psCssParam =  CPLGetXMLNode(psFill, "SvgParameter");
+    psCssParam = CPLGetXMLNode(psFill, "SvgParameter");
 
   while (psCssParam && psCssParam->pszValue &&
          (strcasecmp(psCssParam->pszValue, "CssParameter") == 0 ||
           strcasecmp(psCssParam->pszValue, "SvgParameter") == 0)) {
-    psFillName = (char*)CPLGetXMLValue(psCssParam, "name", NULL);
+    psFillName = (char *)CPLGetXMLValue(psCssParam, "name", NULL);
     if (psFillName) {
       if (strcasecmp(psFillName, "fill") == 0) {
-        if(psCssParam->psChild && psCssParam->psChild->psNext)
-        {
-          msSLDParseOgcExpression(psCssParam->psChild->psNext,
-              psStyle, MS_STYLE_BINDING_COLOR, MS_OBJ_STYLE);
+        if (psCssParam->psChild && psCssParam->psChild->psNext) {
+          msSLDParseOgcExpression(psCssParam->psChild->psNext, psStyle,
+                                  MS_STYLE_BINDING_COLOR, MS_OBJ_STYLE);
         }
       } else if (strcasecmp(psFillName, "fill-opacity") == 0) {
-        if(psCssParam->psChild &&  psCssParam->psChild->psNext)
-        {
-          msSLDParseOgcExpression(psCssParam->psChild->psNext,
-              psStyle, MS_STYLE_BINDING_OPACITY, MS_OBJ_STYLE);
+        if (psCssParam->psChild && psCssParam->psChild->psNext) {
+          msSLDParseOgcExpression(psCssParam->psChild->psNext, psStyle,
+                                  MS_STYLE_BINDING_OPACITY, MS_OBJ_STYLE);
         }
       }
     }
@@ -1786,34 +1750,32 @@ int msSLDParsePolygonFill(CPLXMLNode *ps
   /* TODO : It seems inconsistent to me since the only diffrence */
   /* between them seems to be fill (fill) or not fill (stroke). And */
   /* then again the fill parameter can be used inside both elements. */
-  psGraphicFill =  CPLGetXMLNode(psFill, "GraphicFill");
+  psGraphicFill = CPLGetXMLNode(psFill, "GraphicFill");
   if (psGraphicFill)
     msSLDParseGraphicFillOrStroke(psGraphicFill, NULL, psStyle, map);
-  psGraphicFill =  CPLGetXMLNode(psFill, "GraphicStroke");
+  psGraphicFill = CPLGetXMLNode(psFill, "GraphicStroke");
   if (psGraphicFill)
     msSLDParseGraphicFillOrStroke(psGraphicFill, NULL, psStyle, map);
 
-
   return MS_SUCCESS;
 }
 
-
 /************************************************************************/
 /*                      msSLDParseGraphicFillOrStroke                   */
 /*                                                                      */
 /*      Parse the GraphicFill Or GraphicStroke node : look for a        */
 /*      Marker symbol and set the style for that symbol.                */
 /************************************************************************/
-int msSLDParseGraphicFillOrStroke(CPLXMLNode *psRoot,
-                                  char *pszDashValue_unused,
-                                  styleObj *psStyle, mapObj *map)
-{
+int msSLDParseGraphicFillOrStroke(CPLXMLNode *psRoot, char *pszDashValue_unused,
+                                  styleObj *psStyle, mapObj *map) {
   (void)pszDashValue_unused;
-  CPLXMLNode  *psCssParam, *psGraphic, *psExternalGraphic, *psMark, *psSize, *psGap, *psInitialGap;
+  CPLXMLNode *psCssParam, *psGraphic, *psExternalGraphic, *psMark, *psSize,
+      *psGap, *psInitialGap;
   CPLXMLNode *psWellKnownName, *psStroke, *psFill;
-  CPLXMLNode *psDisplacement=NULL, *psDisplacementX=NULL, *psDisplacementY=NULL;
-  CPLXMLNode *psOpacity=NULL, *psRotation=NULL;
-  char *psName=NULL, *psValue = NULL;
+  CPLXMLNode *psDisplacement = NULL, *psDisplacementX = NULL,
+             *psDisplacementY = NULL;
+  CPLXMLNode *psOpacity = NULL, *psRotation = NULL;
+  char *psName = NULL, *psValue = NULL;
   char *pszSymbolName = NULL;
   int bFilled = 0;
 
@@ -1821,69 +1783,64 @@ int msSLDParseGraphicFillOrStroke(CPLXML
     return MS_FAILURE;
   /* ==================================================================== */
   /*      This a definition taken from the specification (11.3.2) :       */
-  /*      Graphics can either be referenced from an external URL in a common format (such as*/
-  /*      GIF or SVG) or may be derived from a Mark. Multiple external URLs and marks may be*/
-  /*      referenced with the semantic that they all provide the equivalent graphic in different*/
+  /*      Graphics can either be referenced from an external URL in a common
+   * format (such as*/
+  /*      GIF or SVG) or may be derived from a Mark. Multiple external URLs and
+   * marks may be*/
+  /*      referenced with the semantic that they all provide the equivalent
+   * graphic in different*/
   /*      formats.                                                        */
   /*                                                                      */
   /*      For this reason, we only need to support one Mark and one       */
   /*      ExtrnalGraphic ????                                             */
   /* ==================================================================== */
-  psGraphic =  CPLGetXMLNode(psRoot, "Graphic");
+  psGraphic = CPLGetXMLNode(psRoot, "Graphic");
   if (psGraphic) {
     /* extract symbol size */
     psSize = CPLGetXMLNode(psGraphic, "Size");
-    if (psSize && psSize->psChild)
-    {
-      msSLDParseOgcExpression(psSize->psChild,
-          psStyle, MS_STYLE_BINDING_SIZE, MS_OBJ_STYLE);
-    }
-    else {
+    if (psSize && psSize->psChild) {
+      msSLDParseOgcExpression(psSize->psChild, psStyle, MS_STYLE_BINDING_SIZE,
+                              MS_OBJ_STYLE);
+    } else {
       /*do not set a default for external symbols #2305*/
-      psExternalGraphic =  CPLGetXMLNode(psGraphic, "ExternalGraphic");
+      psExternalGraphic = CPLGetXMLNode(psGraphic, "ExternalGraphic");
       if (!psExternalGraphic)
         psStyle->size = 6; /* default value */
     }
 
     /*SLD 1.1.0 extract opacity, rotation, displacement*/
     psOpacity = CPLGetXMLNode(psGraphic, "Opacity");
-    if (psOpacity && psOpacity->psChild)
-    {
-      msSLDParseOgcExpression(psOpacity->psChild,
-          psStyle, MS_STYLE_BINDING_OPACITY, MS_OBJ_STYLE);
+    if (psOpacity && psOpacity->psChild) {
+      msSLDParseOgcExpression(psOpacity->psChild, psStyle,
+                              MS_STYLE_BINDING_OPACITY, MS_OBJ_STYLE);
     }
 
     psRotation = CPLGetXMLNode(psGraphic, "Rotation");
-    if (psRotation && psRotation->psChild)
-    {
-      msSLDParseOgcExpression(psRotation->psChild,
-          psStyle, MS_STYLE_BINDING_ANGLE, MS_OBJ_STYLE);
+    if (psRotation && psRotation->psChild) {
+      msSLDParseOgcExpression(psRotation->psChild, psStyle,
+                              MS_STYLE_BINDING_ANGLE, MS_OBJ_STYLE);
     }
     psDisplacement = CPLGetXMLNode(psGraphic, "Displacement");
-    if (psDisplacement && psDisplacement->psChild)
-    {
+    if (psDisplacement && psDisplacement->psChild) {
       psDisplacementX = CPLGetXMLNode(psDisplacement, "DisplacementX");
-      if (psDisplacementX && psDisplacementX->psChild)
-      {
-        msSLDParseOgcExpression(psDisplacementX->psChild,
-            psStyle, MS_STYLE_BINDING_OFFSET_X, MS_OBJ_STYLE);
+      if (psDisplacementX && psDisplacementX->psChild) {
+        msSLDParseOgcExpression(psDisplacementX->psChild, psStyle,
+                                MS_STYLE_BINDING_OFFSET_X, MS_OBJ_STYLE);
       }
       psDisplacementY = CPLGetXMLNode(psDisplacement, "DisplacementY");
-      if (psDisplacementY && psDisplacementY->psChild)
-      {
-        msSLDParseOgcExpression(psDisplacementY->psChild,
-            psStyle, MS_STYLE_BINDING_OFFSET_Y, MS_OBJ_STYLE);
+      if (psDisplacementY && psDisplacementY->psChild) {
+        msSLDParseOgcExpression(psDisplacementY->psChild, psStyle,
+                                MS_STYLE_BINDING_OFFSET_Y, MS_OBJ_STYLE);
       }
     }
     /* extract symbol */
-    psMark =  CPLGetXMLNode(psGraphic, "Mark");
+    psMark = CPLGetXMLNode(psGraphic, "Mark");
     if (psMark) {
       pszSymbolName = NULL;
-      psWellKnownName =  CPLGetXMLNode(psMark, "WellKnownName");
+      psWellKnownName = CPLGetXMLNode(psMark, "WellKnownName");
       if (psWellKnownName && psWellKnownName->psChild &&
           psWellKnownName->psChild->pszValue)
-        pszSymbolName =
-          msStrdup(psWellKnownName->psChild->pszValue);
+        pszSymbolName = msStrdup(psWellKnownName->psChild->pszValue);
 
       /* default symbol is square */
 
@@ -1894,13 +1851,13 @@ int msSLDParseGraphicFillOrStroke(CPLXML
            strcasecmp(pszSymbolName, "star") != 0 &&
            strcasecmp(pszSymbolName, "cross") != 0 &&
            strcasecmp(pszSymbolName, "x") != 0)) {
-        if (!pszSymbolName || !*pszSymbolName || msGetSymbolIndex(&map->symbolset, pszSymbolName,  MS_FALSE) < 0) {
+        if (!pszSymbolName || !*pszSymbolName ||
+            msGetSymbolIndex(&map->symbolset, pszSymbolName, MS_FALSE) < 0) {
           msFree(pszSymbolName);
           pszSymbolName = msStrdup("square");
         }
       }
 
-
       /* check if the symbol should be filled or not */
       psFill = CPLGetXMLNode(psMark, "Fill");
       psStroke = CPLGetXMLNode(psMark, "Stroke");
@@ -1912,30 +1869,25 @@ int msSLDParseGraphicFillOrStroke(CPLXML
           bFilled = 0;
 
         if (psFill) {
-          psCssParam =  CPLGetXMLNode(psFill, "CssParameter");
+          psCssParam = CPLGetXMLNode(psFill, "CssParameter");
           /*sld 1.1 used SvgParameter*/
           if (psCssParam == NULL)
-            psCssParam =  CPLGetXMLNode(psFill, "SvgParameter");
+            psCssParam = CPLGetXMLNode(psFill, "SvgParameter");
 
           while (psCssParam && psCssParam->pszValue &&
                  (strcasecmp(psCssParam->pszValue, "CssParameter") == 0 ||
                   strcasecmp(psCssParam->pszValue, "SvgParameter") == 0)) {
-            psName =
-              (char*)CPLGetXMLValue(psCssParam, "name", NULL);
-            if (psName &&
-                strcasecmp(psName, "fill") == 0) {
-              if(psCssParam->psChild && psCssParam->psChild->psNext)
-              {
-                msSLDParseOgcExpression(psCssParam->psChild->psNext,
-                    psStyle, MS_STYLE_BINDING_COLOR, MS_OBJ_STYLE);
+            psName = (char *)CPLGetXMLValue(psCssParam, "name", NULL);
+            if (psName && strcasecmp(psName, "fill") == 0) {
+              if (psCssParam->psChild && psCssParam->psChild->psNext) {
+                msSLDParseOgcExpression(psCssParam->psChild->psNext, psStyle,
+                                        MS_STYLE_BINDING_COLOR, MS_OBJ_STYLE);
               }
-            } else if (psName &&
-                       strcasecmp(psName, "fill-opacity") == 0) {
-              if(psCssParam->psChild && psCssParam->psChild->psNext)
-              {
+            } else if (psName && strcasecmp(psName, "fill-opacity") == 0) {
+              if (psCssParam->psChild && psCssParam->psChild->psNext) {
                 psValue = psCssParam->psChild->psNext->pszValue;
                 if (psValue) {
-                  psStyle->color.alpha = (int)(atof(psValue)*255);
+                  psStyle->color.alpha = (int)(atof(psValue) * 255);
                 }
               }
             }
@@ -1944,58 +1896,50 @@ int msSLDParseGraphicFillOrStroke(CPLXML
           }
         }
         if (psStroke) {
-          psCssParam =  CPLGetXMLNode(psStroke, "CssParameter");
+          psCssParam = CPLGetXMLNode(psStroke, "CssParameter");
           /*sld 1.1 used SvgParameter*/
           if (psCssParam == NULL)
-            psCssParam =  CPLGetXMLNode(psStroke, "SvgParameter");
+            psCssParam = CPLGetXMLNode(psStroke, "SvgParameter");
 
           while (psCssParam && psCssParam->pszValue &&
                  (strcasecmp(psCssParam->pszValue, "CssParameter") == 0 ||
                   strcasecmp(psCssParam->pszValue, "SvgParameter") == 0)) {
-            psName =
-              (char*)CPLGetXMLValue(psCssParam, "name", NULL);
-            if (psName &&
-                strcasecmp(psName, "stroke") == 0) {
-              if(psCssParam->psChild && psCssParam->psChild->psNext)
-              {
+            psName = (char *)CPLGetXMLValue(psCssParam, "name", NULL);
+            if (psName && strcasecmp(psName, "stroke") == 0) {
+              if (psCssParam->psChild && psCssParam->psChild->psNext) {
                 if (bFilled) {
-                  msSLDParseOgcExpression(psCssParam->psChild->psNext,
-                      psStyle, MS_STYLE_BINDING_OUTLINECOLOR, MS_OBJ_STYLE);
+                  msSLDParseOgcExpression(psCssParam->psChild->psNext, psStyle,
+                                          MS_STYLE_BINDING_OUTLINECOLOR,
+                                          MS_OBJ_STYLE);
                 } else {
-                  msSLDParseOgcExpression(psCssParam->psChild->psNext,
-                      psStyle, MS_STYLE_BINDING_COLOR, MS_OBJ_STYLE);
+                  msSLDParseOgcExpression(psCssParam->psChild->psNext, psStyle,
+                                          MS_STYLE_BINDING_COLOR, MS_OBJ_STYLE);
                 }
               }
-            } else if (psName &&
-                       strcasecmp(psName, "stroke-opacity") == 0) {
-              if(psCssParam->psChild && psCssParam->psChild->psNext)
-              {
+            } else if (psName && strcasecmp(psName, "stroke-opacity") == 0) {
+              if (psCssParam->psChild && psCssParam->psChild->psNext) {
                 psValue = psCssParam->psChild->psNext->pszValue;
                 if (psValue) {
                   if (bFilled) {
-                    psStyle->outlinecolor.alpha = (int)(atof(psValue)*255);
+                    psStyle->outlinecolor.alpha = (int)(atof(psValue) * 255);
                   } else {
-                    psStyle->color.alpha = (int)(atof(psValue)*255);
+                    psStyle->color.alpha = (int)(atof(psValue) * 255);
                   }
                 }
               }
-            } else if (psName &&
-                       strcasecmp(psName, "stroke-width") == 0) {
-              if(psCssParam->psChild && psCssParam->psChild->psNext)
-              {
-                msSLDParseOgcExpression(psCssParam->psChild->psNext,
-                    psStyle, MS_STYLE_BINDING_WIDTH, MS_OBJ_STYLE);
+            } else if (psName && strcasecmp(psName, "stroke-width") == 0) {
+              if (psCssParam->psChild && psCssParam->psChild->psNext) {
+                msSLDParseOgcExpression(psCssParam->psChild->psNext, psStyle,
+                                        MS_STYLE_BINDING_WIDTH, MS_OBJ_STYLE);
               }
             }
 
             psCssParam = psCssParam->psNext;
           }
         }
-
       }
       /* set the default color if color is not not already set */
-      if ((psStyle->color.red < 0 ||
-           psStyle->color.green == -1 ||
+      if ((psStyle->color.red < 0 || psStyle->color.green == -1 ||
            psStyle->color.blue == -1) &&
           (psStyle->outlinecolor.red == -1 ||
            psStyle->outlinecolor.green == -1 ||
@@ -2005,34 +1949,32 @@ int msSLDParseGraphicFillOrStroke(CPLXML
         psStyle->color.blue = 128;
       }
 
-
       /* Get the corresponding symbol id  */
       psStyle->symbol = msSLDGetMarkSymbol(map, pszSymbolName, bFilled);
-      if (psStyle->symbol > 0 &&
-          psStyle->symbol < map->symbolset.numsymbols)
+      if (psStyle->symbol > 0 && psStyle->symbol < map->symbolset.numsymbols)
         psStyle->symbolname =
-          msStrdup(map->symbolset.symbol[psStyle->symbol]->name);
+            msStrdup(map->symbolset.symbol[psStyle->symbol]->name);
 
     } else {
-      psExternalGraphic =  CPLGetXMLNode(psGraphic, "ExternalGraphic");
+      psExternalGraphic = CPLGetXMLNode(psGraphic, "ExternalGraphic");
       if (psExternalGraphic)
         msSLDParseExternalGraphic(psExternalGraphic, psStyle, map);
     }
     msFree(pszSymbolName);
   }
-  psGap =  CPLGetXMLNode(psRoot, "Gap");
+  psGap = CPLGetXMLNode(psRoot, "Gap");
   if (psGap && psGap->psChild && psGap->psChild->pszValue) {
     psStyle->gap = atof(psGap->psChild->pszValue);
   }
-  psInitialGap =  CPLGetXMLNode(psRoot, "InitialGap");
-  if (psInitialGap && psInitialGap->psChild && psInitialGap->psChild->pszValue) {
+  psInitialGap = CPLGetXMLNode(psRoot, "InitialGap");
+  if (psInitialGap && psInitialGap->psChild &&
+      psInitialGap->psChild->pszValue) {
     psStyle->initialgap = atof(psInitialGap->psChild->pszValue);
   }
 
   return MS_SUCCESS;
 }
 
-
 /************************************************************************/
 /*                            msSLDGetMarkSymbol                        */
 /*                                                                      */
@@ -2040,8 +1982,7 @@ int msSLDParseGraphicFillOrStroke(CPLXML
 /*      square, circle, triangle, star, cross, x.                       */
 /*      If the symbol does not exist add it to the symbol list.        */
 /************************************************************************/
-int msSLDGetMarkSymbol(mapObj *map, char *pszSymbolName, int bFilled)
-{
+int msSLDGetMarkSymbol(mapObj *map, char *pszSymbolName, int bFilled) {
   int nSymbolId = 0;
   symbolObj *psSymbol = NULL;
 
@@ -2051,70 +1992,56 @@ int msSLDGetMarkSymbol(mapObj *map, char
   if (strcasecmp(pszSymbolName, "square") == 0) {
     if (bFilled)
       nSymbolId = msGetSymbolIndex(&map->symbolset,
-                                   SLD_MARK_SYMBOL_SQUARE_FILLED,
-                                   MS_FALSE);
+                                   SLD_MARK_SYMBOL_SQUARE_FILLED, MS_FALSE);
     else
-      nSymbolId = msGetSymbolIndex(&map->symbolset,
-                                   SLD_MARK_SYMBOL_SQUARE,
-                                   MS_FALSE);
+      nSymbolId =
+          msGetSymbolIndex(&map->symbolset, SLD_MARK_SYMBOL_SQUARE, MS_FALSE);
   } else if (strcasecmp(pszSymbolName, "circle") == 0) {
 
     if (bFilled)
       nSymbolId = msGetSymbolIndex(&map->symbolset,
-                                   SLD_MARK_SYMBOL_CIRCLE_FILLED,
-                                   MS_FALSE);
+                                   SLD_MARK_SYMBOL_CIRCLE_FILLED, MS_FALSE);
     else
-      nSymbolId = msGetSymbolIndex(&map->symbolset,
-                                   SLD_MARK_SYMBOL_CIRCLE,
-                                   MS_FALSE);
+      nSymbolId =
+          msGetSymbolIndex(&map->symbolset, SLD_MARK_SYMBOL_CIRCLE, MS_FALSE);
   } else if (strcasecmp(pszSymbolName, "triangle") == 0) {
 
     if (bFilled)
       nSymbolId = msGetSymbolIndex(&map->symbolset,
-                                   SLD_MARK_SYMBOL_TRIANGLE_FILLED,
-                                   MS_FALSE);
+                                   SLD_MARK_SYMBOL_TRIANGLE_FILLED, MS_FALSE);
     else
-      nSymbolId = msGetSymbolIndex(&map->symbolset,
-                                   SLD_MARK_SYMBOL_TRIANGLE,
-                                   MS_FALSE);
+      nSymbolId =
+          msGetSymbolIndex(&map->symbolset, SLD_MARK_SYMBOL_TRIANGLE, MS_FALSE);
   } else if (strcasecmp(pszSymbolName, "star") == 0) {
 
     if (bFilled)
-      nSymbolId = msGetSymbolIndex(&map->symbolset,
-                                   SLD_MARK_SYMBOL_STAR_FILLED,
+      nSymbolId = msGetSymbolIndex(&map->symbolset, SLD_MARK_SYMBOL_STAR_FILLED,
                                    MS_FALSE);
     else
-      nSymbolId = msGetSymbolIndex(&map->symbolset,
-                                   SLD_MARK_SYMBOL_STAR,
-                                   MS_FALSE);
+      nSymbolId =
+          msGetSymbolIndex(&map->symbolset, SLD_MARK_SYMBOL_STAR, MS_FALSE);
   } else if (strcasecmp(pszSymbolName, "cross") == 0) {
 
     if (bFilled)
       nSymbolId = msGetSymbolIndex(&map->symbolset,
-                                   SLD_MARK_SYMBOL_CROSS_FILLED,
-                                   MS_FALSE);
+                                   SLD_MARK_SYMBOL_CROSS_FILLED, MS_FALSE);
     else
-      nSymbolId = msGetSymbolIndex(&map->symbolset,
-                                   SLD_MARK_SYMBOL_CROSS,
-                                   MS_FALSE);
+      nSymbolId =
+          msGetSymbolIndex(&map->symbolset, SLD_MARK_SYMBOL_CROSS, MS_FALSE);
   } else if (strcasecmp(pszSymbolName, "x") == 0) {
 
     if (bFilled)
-      nSymbolId = msGetSymbolIndex(&map->symbolset,
-                                   SLD_MARK_SYMBOL_X_FILLED,
-                                   MS_FALSE);
+      nSymbolId =
+          msGetSymbolIndex(&map->symbolset, SLD_MARK_SYMBOL_X_FILLED, MS_FALSE);
     else
-      nSymbolId = msGetSymbolIndex(&map->symbolset,
-                                   SLD_MARK_SYMBOL_X,
-                                   MS_FALSE);
+      nSymbolId =
+          msGetSymbolIndex(&map->symbolset, SLD_MARK_SYMBOL_X, MS_FALSE);
   } else {
-    nSymbolId = msGetSymbolIndex(&map->symbolset,
-                                 pszSymbolName,
-                                 MS_FALSE);
+    nSymbolId = msGetSymbolIndex(&map->symbolset, pszSymbolName, MS_FALSE);
   }
 
   if (nSymbolId <= 0) {
-    if( (psSymbol = msGrowSymbolSet(&(map->symbolset))) == NULL)
+    if ((psSymbol = msGrowSymbolSet(&(map->symbolset))) == NULL)
       return 0; /* returns 0 for no symbol */
 
     nSymbolId = map->symbolset.numsymbols;
@@ -2280,7 +2207,6 @@ int msSLDGetMarkSymbol(mapObj *map, char
       psSymbol->points[psSymbol->numpoints].y = 0;
       psSymbol->numpoints++;
     }
-
   }
 
   return nSymbolId;
@@ -2292,16 +2218,14 @@ int msSLDGetMarkSymbol(mapObj *map, char
 /*      Create a symbol entry for an inmap pixmap symbol. Returns       */
 /*      the symbol id.                                                  */
 /************************************************************************/
-int msSLDGetGraphicSymbol(mapObj *map, char *pszFileName,  char* extGraphicName,
-                          int nGap_ignored)
-{
+int msSLDGetGraphicSymbol(mapObj *map, char *pszFileName, char *extGraphicName,
+                          int nGap_ignored) {
   (void)nGap_ignored;
   int nSymbolId = 0;
   symbolObj *psSymbol = NULL;
 
-
   if (map && pszFileName) {
-    if( (psSymbol = msGrowSymbolSet(&(map->symbolset))) == NULL)
+    if ((psSymbol = msGrowSymbolSet(&(map->symbolset))) == NULL)
       return 0; /* returns 0 for no symbol */
     nSymbolId = map->symbolset.numsymbols;
     map->symbolset.numsymbols++;
@@ -2315,7 +2239,6 @@ int msSLDGetGraphicSymbol(mapObj *map, c
   return nSymbolId;
 }
 
-
 /************************************************************************/
 /*      msSLDParsePointSymbolizer                                       */
 /*                                                                      */
@@ -2331,8 +2254,7 @@ int msSLDGetGraphicSymbol(mapObj *map, c
 /*      </xs:element>                                                   */
 /************************************************************************/
 int msSLDParsePointSymbolizer(CPLXMLNode *psRoot, layerObj *psLayer,
-                              int bNewClass, const char* pszUserStyleName)
-{
+                              int bNewClass, const char *pszUserStyleName) {
   int nClassId = 0;
   int iStyle = 0;
 
@@ -2340,14 +2262,14 @@ int msSLDParsePointSymbolizer(CPLXMLNode
     return MS_FAILURE;
 
   nClassId = getClassId(psLayer, bNewClass, pszUserStyleName);
-  if( nClassId < 0 )
+  if (nClassId < 0)
     return MS_FAILURE;
 
   // Get uom if any, defaults to MS_PIXELS
   enum MS_UNITS sizeunits = MS_PIXELS;
-  if (msSLDParseUomAttribute(psRoot, &sizeunits) != MS_SUCCESS)
-  {
-    msSetError(MS_WMSERR, "Invalid uom attribute value.", "msSLDParsePolygonSymbolizer()");
+  if (msSLDParseUomAttribute(psRoot, &sizeunits) != MS_SUCCESS) {
+    msSetError(MS_WMSERR, "Invalid uom attribute value.",
+               "msSLDParsePolygonSymbolizer()");
     return MS_FAILURE;
   }
 
@@ -2355,14 +2277,12 @@ int msSLDParsePointSymbolizer(CPLXMLNode
   msMaybeAllocateClassStyle(psLayer->class[nClassId], iStyle);
   psLayer->class[nClassId]->styles[iStyle]->sizeunits = sizeunits;
 
-  msSLDParseGraphicFillOrStroke(psRoot, NULL,
-                                psLayer->class[nClassId]->styles[iStyle],
-                                psLayer->map);
+  msSLDParseGraphicFillOrStroke(
+      psRoot, NULL, psLayer->class[nClassId] -> styles[iStyle], psLayer -> map);
 
   return MS_SUCCESS;
 }
 
-
 /************************************************************************/
 /*                        msSLDParseExternalGraphic                     */
 /*                                                                      */
@@ -2370,12 +2290,11 @@ int msSLDParsePointSymbolizer(CPLXMLNode
 /*      by the URL and create a PIXMAP inmap symbol. Only GIF and       */
 /*      PNG are supported.                                              */
 /************************************************************************/
-int msSLDParseExternalGraphic(CPLXMLNode *psExternalGraphic,
-                              styleObj *psStyle,  mapObj *map)
-{
+int msSLDParseExternalGraphic(CPLXMLNode *psExternalGraphic, styleObj *psStyle,
+                              mapObj *map) {
   char *pszFormat = NULL;
-  CPLXMLNode *psURL=NULL, *psFormat=NULL, *psTmp=NULL;
-  char *pszURL=NULL;
+  CPLXMLNode *psURL = NULL, *psFormat = NULL, *psTmp = NULL;
+  char *pszURL = NULL;
 
   if (!psExternalGraphic || !psStyle || !map)
     return MS_FAILURE;
@@ -2385,32 +2304,31 @@ int msSLDParseExternalGraphic(CPLXMLNode
     pszFormat = psFormat->psChild->pszValue;
 
   /* supports GIF and PNG and SVG */
-  if (pszFormat &&
-      (strcasecmp(pszFormat, "GIF") == 0 ||
-       strcasecmp(pszFormat, "image/gif") == 0 ||
-       strcasecmp(pszFormat, "PNG") == 0 ||
-       strcasecmp(pszFormat, "image/png") == 0 ||
-       strcasecmp(pszFormat, "image/svg+xml") == 0)) {
-
-    /* <OnlineResource xmlns:xlink="http://www.w3.org/1999/xlink" xlink:type="simple" xlink:href="http://www.vendor.com/geosym/2267.svg"/> */
+  if (pszFormat && (strcasecmp(pszFormat, "GIF") == 0 ||
+                    strcasecmp(pszFormat, "image/gif") == 0 ||
+                    strcasecmp(pszFormat, "PNG") == 0 ||
+                    strcasecmp(pszFormat, "image/png") == 0 ||
+                    strcasecmp(pszFormat, "image/svg+xml") == 0)) {
+
+    /* <OnlineResource xmlns:xlink="http://www.w3.org/1999/xlink"
+     * xlink:type="simple" xlink:href="http://www.vendor.com/geosym/2267.svg"/>
+     */
     psURL = CPLGetXMLNode(psExternalGraphic, "OnlineResource");
     if (psURL && psURL->psChild) {
-      psTmp =  psURL->psChild;
-      while (psTmp != NULL &&
-             psTmp->pszValue &&
+      psTmp = psURL->psChild;
+      while (psTmp != NULL && psTmp->pszValue &&
              strcasecmp(psTmp->pszValue, "xlink:href") != 0) {
         psTmp = psTmp->psNext;
       }
       if (psTmp && psTmp->psChild) {
-        pszURL = (char*)psTmp->psChild->pszValue;
+        pszURL = (char *)psTmp->psChild->pszValue;
 
         char *symbolurl = NULL;
         // Handle relative URL for ExternalGraphic
-        if (map->sldurl && !strstr(pszURL,"://"))
-        {
+        if (map->sldurl && !strstr(pszURL, "://")) {
           char *baseurl = NULL;
           char *relpath = NULL;
-          symbolurl = malloc(sizeof(char)*MS_MAXPATHLEN);
+          symbolurl = malloc(sizeof(char) * MS_MAXPATHLEN);
           if (pszURL[0] != '/') {
             // Symbol file is relative to SLD file
             // e.g. SLD   : http://example.com/path/to/sld.xml
@@ -2418,57 +2336,58 @@ int msSLDParseExternalGraphic(CPLXMLNode
             //     lead to: http://example.com/path/to/assets/symbol.svg
             baseurl = msGetPath(map->sldurl);
             relpath = pszURL;
-          }
-          else
-          {
+          } else {
             // Symbol file is relative to the root of SLD server
             // e.g. SLD   : http://example.com/path/to/sld.xml
             //  and symbol: /path/to/assets/symbol.svg
             //     lead to: http://example.com/path/to/assets/symbol.svg
             baseurl = msStrdup(map->sldurl);
-            relpath = pszURL+1;
-            char * sep = strstr(baseurl,"://");
+            relpath = pszURL + 1;
+            char *sep = strstr(baseurl, "://");
             if (sep)
               sep += 3;
             else
               sep = baseurl;
-            sep = strchr(sep,'/');
+            sep = strchr(sep, '/');
             if (!sep)
               sep = baseurl + strlen(baseurl);
             sep[1] = '\0';
           }
-          msBuildPath(symbolurl,baseurl,relpath);
+          msBuildPath(symbolurl, baseurl, relpath);
           msFree(baseurl);
-        }
-        else
-        {
+        } else {
           // Absolute URL
           // e.g. symbol: http://example.com/path/to/assets/symbol.svg
           symbolurl = msStrdup(pszURL);
         }
 
         /* validate the ExternalGraphic parameter */
-        if(msValidateParameter(symbolurl, msLookupHashTable(&(map->web.validation), "sld_external_graphic"),
-                               NULL, NULL, NULL) != MS_SUCCESS) {
-          msSetError(MS_WEBERR, "SLD ExternalGraphic OnlineResource value fails to validate against sld_external_graphic VALIDATION", "mapserv()");
+        if (msValidateParameter(symbolurl,
+                                msLookupHashTable(&(map->web.validation),
+                                                  "sld_external_graphic"),
+                                NULL, NULL, NULL) != MS_SUCCESS) {
+          msSetError(MS_WEBERR,
+                     "SLD ExternalGraphic OnlineResource value fails to "
+                     "validate against sld_external_graphic VALIDATION",
+                     "mapserv()");
           msFree(symbolurl);
           return MS_FAILURE;
         }
 
-
-        /*external symbols using http will be automaticallly downloaded. The file should be
-          saved in a temporary directory (msAddImageSymbol) #2305*/
-        psStyle->symbol = msGetSymbolIndex(&map->symbolset,
-                                           symbolurl,
-                                           MS_TRUE);
+        /*external symbols using http will be automaticallly downloaded. The
+          file should be saved in a temporary directory (msAddImageSymbol)
+          #2305*/
+        psStyle->symbol = msGetSymbolIndex(&map->symbolset, symbolurl, MS_TRUE);
         msFree(symbolurl);
 
         if (psStyle->symbol > 0 && psStyle->symbol < map->symbolset.numsymbols)
-          psStyle->symbolname = msStrdup(map->symbolset.symbol[psStyle->symbol]->name);
+          psStyle->symbolname =
+              msStrdup(map->symbolset.symbol[psStyle->symbol]->name);
 
         /* set the color parameter if not set. Does not make sense */
         /* for pixmap but mapserver needs it. */
-        if (psStyle->color.red == -1 || psStyle->color.green || psStyle->color.blue) {
+        if (psStyle->color.red == -1 || psStyle->color.green ||
+            psStyle->color.blue) {
           psStyle->color.red = 0;
           psStyle->color.green = 0;
           psStyle->color.blue = 0;
@@ -2480,7 +2399,6 @@ int msSLDParseExternalGraphic(CPLXMLNode
   return MS_SUCCESS;
 }
 
-
 /************************************************************************/
 /*                         msSLDParseTextSymbolizer                     */
 /*                                                                      */
@@ -2574,9 +2492,9 @@ int msSLDParseExternalGraphic(CPLXMLNode
 /*      </xs:element>                                                   */
 /************************************************************************/
 int msSLDParseTextSymbolizer(CPLXMLNode *psRoot, layerObj *psLayer,
-                             int bOtherSymboliser, const char* pszUserStyleName)
-{
-  int nStyleId=0, nClassId=0;
+                             int bOtherSymboliser,
+                             const char *pszUserStyleName) {
+  int nStyleId = 0, nClassId = 0;
 
   if (!psRoot || !psLayer)
     return MS_FAILURE;
@@ -2586,26 +2504,23 @@ int msSLDParseTextSymbolizer(CPLXMLNode
       return MS_FAILURE;
     initClass(psLayer->class[psLayer->numclasses]);
     nClassId = psLayer->numclasses;
-    if( pszUserStyleName )
-        psLayer->class[nClassId]->group = msStrdup(pszUserStyleName);
+    if (pszUserStyleName)
+      psLayer->class[nClassId]->group = msStrdup(pszUserStyleName);
     psLayer->numclasses++;
     msMaybeAllocateClassStyle(psLayer->class[nClassId], 0);
     nStyleId = 0;
   } else {
     nClassId = psLayer->numclasses - 1;
-    if (nClassId >= 0)/* should always be true */
-      nStyleId = psLayer->class[nClassId]->numstyles -1;
+    if (nClassId >= 0) /* should always be true */
+      nStyleId = psLayer->class[nClassId]->numstyles - 1;
   }
 
   if (nStyleId >= 0 && nClassId >= 0) /* should always be true */
-    msSLDParseTextParams(psRoot, psLayer,
-                         psLayer->class[nClassId]);
+    msSLDParseTextParams(psRoot, psLayer, psLayer->class[nClassId]);
 
   return MS_SUCCESS;
 }
 
-
-
 /************************************************************************/
 /*                        msSLDParseRasterSymbolizer                    */
 /*                                                                      */
@@ -2645,7 +2560,8 @@ int msSLDParseTextSymbolizer(CPLXMLNode
 /*                                                                      */
 /*      SLD 1.1                                                         */
 /*                                                                      */
-/*      <xsd:element name="RasterSymbolizer" type="se:RasterSymbolizerType" substitutionGroup="se:Symbolizer"/>*/
+/*      <xsd:element name="RasterSymbolizer" type="se:RasterSymbolizerType"
+ * substitutionGroup="se:Symbolizer"/>*/
 /*      <xsd:complexType name="RasterSymbolizerType">                   */
 /*      <xsd:complexContent>                                            */
 /*      <xsd:extension base="se:SymbolizerType">                        */
@@ -2671,7 +2587,8 @@ int msSLDParseTextSymbolizer(CPLXMLNode
 /*      </xsd:choice>                                                   */
 /*      </xsd:complexType>                                              */
 /*                                                                      */
-/*      <xsd:element name="Categorize" type="se:CategorizeType" substitutionGroup="se:Function"/>*/
+/*      <xsd:element name="Categorize" type="se:CategorizeType"
+ * substitutionGroup="se:Function"/>*/
 /*      <xsd:complexType name="CategorizeType">                         */
 /*      <xsd:complexContent>                                            */
 /*      <xsd:extension base="se:FunctionType">                          */
@@ -2683,7 +2600,8 @@ int msSLDParseTextSymbolizer(CPLXMLNode
 /*      <xsd:element ref="se:Value"/>                                   */
 /*      </xsd:sequence>                                                 */
 /*      </xsd:sequence>                                                 */
-/*      <xsd:attribute name="threshholdsBelongTo" type="se:ThreshholdsBelongToType" use="optional"/>*/
+/*      <xsd:attribute name="threshholdsBelongTo"
+ * type="se:ThreshholdsBelongToType" use="optional"/>*/
 /*      </xsd:extension>                                                */
 /*      </xsd:complexContent>                                           */
 /*      </xsd:complexType>                                              */
@@ -2699,21 +2617,20 @@ int msSLDParseTextSymbolizer(CPLXMLNode
 /*                                                                      */
 /************************************************************************/
 int msSLDParseRasterSymbolizer(CPLXMLNode *psRoot, layerObj *psLayer,
-                               const char* pszUserStyleName)
-{
-  CPLXMLNode  *psColorMap = NULL, *psColorEntry = NULL, *psOpacity=NULL;
-  char *pszColor=NULL, *pszQuantity=NULL;
-  char *pszPreviousColor=NULL, *pszPreviousQuality=NULL;
+                               const char *pszUserStyleName) {
+  CPLXMLNode *psColorMap = NULL, *psColorEntry = NULL, *psOpacity = NULL;
+  char *pszColor = NULL, *pszQuantity = NULL;
+  char *pszPreviousColor = NULL, *pszPreviousQuality = NULL;
   colorObj sColor;
   char szExpression[100];
   double dfOpacity = 1.0;
-  char *pszLabel = NULL,  *pszPreviousLabel = NULL;
-  char *pch = NULL, *pchPrevious=NULL;
+  char *pszLabel = NULL, *pszPreviousLabel = NULL;
+  char *pch = NULL, *pchPrevious = NULL;
 
-  CPLXMLNode  *psNode=NULL, *psCategorize=NULL;
+  CPLXMLNode *psNode = NULL, *psCategorize = NULL;
   char *pszTmp = NULL;
-  int nValues=0, nThresholds=0;
-  int i,nMaxValues= 100, nMaxThreshold=100;
+  int nValues = 0, nThresholds = 0;
+  int i, nMaxValues = 100, nMaxThreshold = 100;
 
   if (!psRoot || !psLayer)
     return MS_FAILURE;
@@ -2723,11 +2640,14 @@ int msSLDParseRasterSymbolizer(CPLXMLNod
     if (psOpacity->psChild && psOpacity->psChild->pszValue)
       dfOpacity = atof(psOpacity->psChild->pszValue);
 
-    /* values in sld goes from 0.0 (for transparent) to 1.0 (for full opacity); */
-    if (dfOpacity >=0.0 && dfOpacity <=1.0)
-      msSetLayerOpacity(psLayer,(int)(dfOpacity * 100));
+    /* values in sld goes from 0.0 (for transparent) to 1.0 (for full opacity);
+     */
+    if (dfOpacity >= 0.0 && dfOpacity <= 1.0)
+      msSetLayerOpacity(psLayer, (int)(dfOpacity * 100));
     else {
-      msSetError(MS_WMSERR, "Invalid opacity value. Values should be between 0.0 and 1.0", "msSLDParseRasterSymbolizer()");
+      msSetError(MS_WMSERR,
+                 "Invalid opacity value. Values should be between 0.0 and 1.0",
+                 "msSLDParseRasterSymbolizer()");
       return MS_FAILURE;
     }
   }
@@ -2744,47 +2664,41 @@ int msSLDParseRasterSymbolizer(CPLXMLNod
 
         if (pszColor && pszQuantity) {
           if (pszPreviousColor && pszPreviousQuality) {
-            if (strlen(pszPreviousColor) == 7 &&
-                pszPreviousColor[0] == '#' &&
+            if (strlen(pszPreviousColor) == 7 && pszPreviousColor[0] == '#' &&
                 strlen(pszColor) == 7 && pszColor[0] == '#') {
-              sColor.red = msHexToInt(pszPreviousColor+1);
-              sColor.green= msHexToInt(pszPreviousColor+3);
-              sColor.blue = msHexToInt(pszPreviousColor+5);
+              sColor.red = msHexToInt(pszPreviousColor + 1);
+              sColor.green = msHexToInt(pszPreviousColor + 3);
+              sColor.blue = msHexToInt(pszPreviousColor + 5);
 
               /* pszQuantity and pszPreviousQuality may be integer or float */
-              pchPrevious=strchr(pszPreviousQuality,'.');
-              pch=strchr(pszQuantity,'.');
-              if (pchPrevious==NULL && pch==NULL) {
+              pchPrevious = strchr(pszPreviousQuality, '.');
+              pch = strchr(pszQuantity, '.');
+              if (pchPrevious == NULL && pch == NULL) {
                 snprintf(szExpression, sizeof(szExpression),
                          "([pixel] >= %d AND [pixel] < %d)",
-                         atoi(pszPreviousQuality),
-                         atoi(pszQuantity));
-              } else if (pchPrevious != NULL && pch==NULL) {
+                         atoi(pszPreviousQuality), atoi(pszQuantity));
+              } else if (pchPrevious != NULL && pch == NULL) {
                 snprintf(szExpression, sizeof(szExpression),
                          "([pixel] >= %f AND [pixel] < %d)",
-                         atof(pszPreviousQuality),
-                         atoi(pszQuantity));
+                         atof(pszPreviousQuality), atoi(pszQuantity));
               } else if (pchPrevious == NULL && pch != NULL) {
                 snprintf(szExpression, sizeof(szExpression),
                          "([pixel] >= %d AND [pixel] < %f)",
-                         atoi(pszPreviousQuality),
-                         atof(pszQuantity));
+                         atoi(pszPreviousQuality), atof(pszQuantity));
               } else {
                 snprintf(szExpression, sizeof(szExpression),
                          "([pixel] >= %f AND [pixel] < %f)",
-                         atof(pszPreviousQuality),
-                         atof(pszQuantity));
+                         atof(pszPreviousQuality), atof(pszQuantity));
               }
 
-
               if (msGrowLayerClasses(psLayer) == NULL)
                 return MS_FAILURE;
               else {
                 initClass(psLayer->class[psLayer->numclasses]);
                 psLayer->numclasses++;
-                const int nClassId = psLayer->numclasses-1;
-                if( pszUserStyleName )
-                    psLayer->class[nClassId]->group = msStrdup(pszUserStyleName);
+                const int nClassId = psLayer->numclasses - 1;
+                if (pszUserStyleName)
+                  psLayer->class[nClassId]->group = msStrdup(pszUserStyleName);
 
                 /*set the class name using the label. If label not defined
                   set it with the quantity*/
@@ -2795,52 +2709,46 @@ int msSLDParseRasterSymbolizer(CPLXMLNod
 
                 msMaybeAllocateClassStyle(psLayer->class[nClassId], 0);
 
-                psLayer->class[nClassId]->styles[0]->color.red =
-                      sColor.red;
-              psLayer->class[nClassId]->styles[0]->color.green =
-                      sColor.green;
-              psLayer->class[nClassId]->styles[0]->color.blue =
-                      sColor.blue;
+                psLayer->class[nClassId]->styles[0]->color.red = sColor.red;
+                psLayer->class[nClassId]->styles[0]->color.green = sColor.green;
+                psLayer->class[nClassId]->styles[0]->color.blue = sColor.blue;
 
                 if (psLayer->classitem &&
                     strcasecmp(psLayer->classitem, "[pixel]") != 0)
                   free(psLayer->classitem);
                 psLayer->classitem = msStrdup("[pixel]");
 
-                msLoadExpressionString(&psLayer->class[nClassId]->expression,
+                msLoadExpressionString(&psLayer->class[nClassId] -> expression,
                                        szExpression);
-
-
               }
             } else {
-              msSetError(MS_WMSERR,
-                         "Invalid ColorMap Entry.",
+              msSetError(MS_WMSERR, "Invalid ColorMap Entry.",
                          "msSLDParseRasterSymbolizer()");
               return MS_FAILURE;
             }
-
           }
 
           pszPreviousColor = pszColor;
           pszPreviousQuality = pszQuantity;
           pszPreviousLabel = pszLabel;
-
         }
         psColorEntry = psColorEntry->psNext;
       }
       /* do the last Color Map Entry */
       if (pszColor && pszQuantity) {
         if (strlen(pszColor) == 7 && pszColor[0] == '#') {
-          sColor.red = msHexToInt(pszColor+1);
-          sColor.green= msHexToInt(pszColor+3);
-          sColor.blue = msHexToInt(pszColor+5);
+          sColor.red = msHexToInt(pszColor + 1);
+          sColor.green = msHexToInt(pszColor + 3);
+          sColor.blue = msHexToInt(pszColor + 5);
 
           /* pszQuantity may be integer or float */
-          pch=strchr(pszQuantity,'.');
-          if (pch==NULL) {
-            snprintf(szExpression, sizeof(szExpression), "([pixel] = %d)", atoi(pszQuantity));
+          pch = strchr(pszQuantity, '.');
+          if (pch == NULL) {
+            snprintf(szExpression, sizeof(szExpression), "([pixel] = %d)",
+                     atoi(pszQuantity));
           } else {
-            snprintf(szExpression, sizeof(szExpression), "([pixel] = %f)", atof(pszQuantity));
+            snprintf(szExpression, sizeof(szExpression), "([pixel] = %f)",
+                     atof(pszQuantity));
           }
 
           if (msGrowLayerClasses(psLayer) == NULL)
@@ -2848,9 +2756,9 @@ int msSLDParseRasterSymbolizer(CPLXMLNod
           else {
             initClass(psLayer->class[psLayer->numclasses]);
             psLayer->numclasses++;
-            const int nClassId = psLayer->numclasses-1;
-            if( pszUserStyleName )
-                psLayer->class[nClassId]->group = msStrdup(pszUserStyleName);
+            const int nClassId = psLayer->numclasses - 1;
+            if (pszUserStyleName)
+              psLayer->class[nClassId]->group = msStrdup(pszUserStyleName);
 
             msMaybeAllocateClassStyle(psLayer->class[nClassId], 0);
             if (pszLabel)
@@ -2858,119 +2766,118 @@ int msSLDParseRasterSymbolizer(CPLXMLNod
             else
               psLayer->class[nClassId]->name = msStrdup(pszQuantity);
             psLayer->class[nClassId]->numstyles = 1;
-            psLayer->class[nClassId]->styles[0]->color.red =
-                  sColor.red;
-            psLayer->class[nClassId]->styles[0]->color.green =
-                  sColor.green;
-            psLayer->class[nClassId]->styles[0]->color.blue =
-                  sColor.blue;
+            psLayer->class[nClassId]->styles[0]->color.red = sColor.red;
+            psLayer->class[nClassId]->styles[0]->color.green = sColor.green;
+            psLayer->class[nClassId]->styles[0]->color.blue = sColor.blue;
 
             if (psLayer->classitem &&
                 strcasecmp(psLayer->classitem, "[pixel]") != 0)
               free(psLayer->classitem);
             psLayer->classitem = msStrdup("[pixel]");
 
-            msLoadExpressionString(&psLayer->class[nClassId]->expression,
+            msLoadExpressionString(&psLayer->class[nClassId] -> expression,
                                    szExpression);
           }
         }
       }
     } else if ((psCategorize = CPLGetXMLNode(psColorMap, "Categorize"))) {
-      char** papszValues = (char **)msSmallMalloc(sizeof(char*)*nMaxValues);
-      char** papszThresholds = (char **)msSmallMalloc(sizeof(char*)*nMaxThreshold);
-      psNode =  CPLGetXMLNode(psCategorize, "Value");
-      while (psNode && psNode->pszValue &&
-             psNode->psChild && psNode->psChild->pszValue)
+      char **papszValues = (char **)msSmallMalloc(sizeof(char *) * nMaxValues);
+      char **papszThresholds =
+          (char **)msSmallMalloc(sizeof(char *) * nMaxThreshold);
+      psNode = CPLGetXMLNode(psCategorize, "Value");
+      while (psNode && psNode->pszValue && psNode->psChild &&
+             psNode->psChild->pszValue)
 
       {
         if (strcasecmp(psNode->pszValue, "Value") == 0) {
-          papszValues[nValues] =  psNode->psChild->pszValue;
+          papszValues[nValues] = psNode->psChild->pszValue;
           nValues++;
           if (nValues == nMaxValues) {
-            nMaxValues +=100;
-            papszValues = (char **)msSmallRealloc(papszValues, sizeof(char*)*nMaxValues);
+            nMaxValues += 100;
+            papszValues = (char **)msSmallRealloc(papszValues,
+                                                  sizeof(char *) * nMaxValues);
           }
         } else if (strcasecmp(psNode->pszValue, "Threshold") == 0) {
-          papszThresholds[nThresholds] =  psNode->psChild->pszValue;
+          papszThresholds[nThresholds] = psNode->psChild->pszValue;
           nThresholds++;
           if (nValues == nMaxThreshold) {
             nMaxThreshold += 100;
-            papszThresholds = (char **)msSmallRealloc(papszThresholds, sizeof(char*)*nMaxThreshold);
+            papszThresholds = (char **)msSmallRealloc(
+                papszThresholds, sizeof(char *) * nMaxThreshold);
           }
         }
         psNode = psNode->psNext;
       }
 
-      if (nThresholds > 0 && nValues == nThresholds+1) {
+      if (nThresholds > 0 && nValues == nThresholds + 1) {
         /*free existing classes*/
-        for(i=0; i<psLayer->numclasses; i++) {
+        for (i = 0; i < psLayer->numclasses; i++) {
           if (psLayer->class[i] != NULL) {
-            psLayer->class[i]->layer=NULL;
-            if ( freeClass(psLayer->class[i]) == MS_SUCCESS ) {
+            psLayer->class[i]->layer = NULL;
+            if (freeClass(psLayer->class[i]) == MS_SUCCESS) {
               msFree(psLayer->class[i]);
-              psLayer->class[i]=NULL;
+              psLayer->class[i] = NULL;
             }
           }
         }
-        psLayer->numclasses=0;
-        for (i=0; i<nValues; i++) {
+        psLayer->numclasses = 0;
+        for (i = 0; i < nValues; i++) {
           pszTmp = (papszValues[i]);
           if (pszTmp && strlen(pszTmp) == 7 && pszTmp[0] == '#') {
-            sColor.red = msHexToInt(pszTmp+1);
-            sColor.green= msHexToInt(pszTmp+3);
-            sColor.blue = msHexToInt(pszTmp+5);
+            sColor.red = msHexToInt(pszTmp + 1);
+            sColor.green = msHexToInt(pszTmp + 3);
+            sColor.blue = msHexToInt(pszTmp + 5);
             if (i == 0) {
-              if (strchr(papszThresholds[i],'.'))
-                snprintf(szExpression, sizeof(szExpression), "([pixel] < %f)", atof(papszThresholds[i]));
+              if (strchr(papszThresholds[i], '.'))
+                snprintf(szExpression, sizeof(szExpression), "([pixel] < %f)",
+                         atof(papszThresholds[i]));
               else
-                snprintf(szExpression, sizeof(szExpression), "([pixel] < %d)", atoi(papszThresholds[i]));
+                snprintf(szExpression, sizeof(szExpression), "([pixel] < %d)",
+                         atoi(papszThresholds[i]));
 
-            } else if (i < nValues-1) {
-              if (strchr(papszThresholds[i],'.'))
-                snprintf(szExpression,  sizeof(szExpression),
+            } else if (i < nValues - 1) {
+              if (strchr(papszThresholds[i], '.'))
+                snprintf(szExpression, sizeof(szExpression),
                          "([pixel] >= %f AND [pixel] < %f)",
-                         atof(papszThresholds[i-1]),
+                         atof(papszThresholds[i - 1]),
                          atof(papszThresholds[i]));
               else
                 snprintf(szExpression, sizeof(szExpression),
                          "([pixel] >= %d AND [pixel] < %d)",
-                         atoi(papszThresholds[i-1]),
+                         atoi(papszThresholds[i - 1]),
                          atoi(papszThresholds[i]));
             } else {
-              if (strchr(papszThresholds[i-1],'.'))
-                snprintf(szExpression, sizeof(szExpression), "([pixel] >= %f)", atof(papszThresholds[i-1]));
+              if (strchr(papszThresholds[i - 1], '.'))
+                snprintf(szExpression, sizeof(szExpression), "([pixel] >= %f)",
+                         atof(papszThresholds[i - 1]));
               else
-                snprintf(szExpression, sizeof(szExpression), "([pixel] >= %d)", atoi(papszThresholds[i-1]));
+                snprintf(szExpression, sizeof(szExpression), "([pixel] >= %d)",
+                         atoi(papszThresholds[i - 1]));
             }
             if (msGrowLayerClasses(psLayer)) {
               initClass(psLayer->class[psLayer->numclasses]);
               psLayer->numclasses++;
-              const int nClassId = psLayer->numclasses-1;
-              if( pszUserStyleName )
+              const int nClassId = psLayer->numclasses - 1;
+              if (pszUserStyleName)
                 psLayer->class[nClassId]->group = msStrdup(pszUserStyleName);
               msMaybeAllocateClassStyle(psLayer->class[nClassId], 0);
               psLayer->class[nClassId]->numstyles = 1;
-              psLayer->class[nClassId]->styles[0]->color.red =
-                    sColor.red;
-              psLayer->class[nClassId]->styles[0]->color.green =
-                    sColor.green;
-              psLayer->class[nClassId]->styles[0]->color.blue =
-                    sColor.blue;
+              psLayer->class[nClassId]->styles[0]->color.red = sColor.red;
+              psLayer->class[nClassId]->styles[0]->color.green = sColor.green;
+              psLayer->class[nClassId]->styles[0]->color.blue = sColor.blue;
               if (psLayer->classitem &&
                   strcasecmp(psLayer->classitem, "[pixel]") != 0)
                 free(psLayer->classitem);
               psLayer->classitem = msStrdup("[pixel]");
-              msLoadExpressionString(&psLayer->class[nClassId]->expression,
+              msLoadExpressionString(&psLayer->class[nClassId] -> expression,
                                      szExpression);
             }
-
           }
         }
       }
       msFree(papszValues);
       msFree(papszThresholds);
 
-
     } else {
       msSetError(MS_WMSERR, "Invalid SLD document. msSLDParseRaster", "");
       return MS_FAILURE;
@@ -2985,24 +2892,26 @@ int msSLDParseRasterSymbolizer(CPLXMLNod
 /*      Parse text parameters like font, placement and color.           */
 /************************************************************************/
 int msSLDParseTextParams(CPLXMLNode *psRoot, layerObj *psLayer,
-                         classObj *psClass)
-{
+                         classObj *psClass) {
   char szFontName[100];
 
-  CPLXMLNode *psLabel=NULL, *psFont=NULL;
+  CPLXMLNode *psLabel = NULL, *psFont = NULL;
   CPLXMLNode *psCssParam = NULL;
-  char *pszName=NULL, *pszFontFamily=NULL, *pszFontStyle=NULL;
-  char *pszFontWeight=NULL;
-  CPLXMLNode *psLabelPlacement=NULL, *psPointPlacement=NULL, *psLinePlacement=NULL;
-  CPLXMLNode *psFill = NULL, *psHalo=NULL, *psHaloRadius=NULL, *psHaloFill=NULL;
+  char *pszName = NULL, *pszFontFamily = NULL, *pszFontStyle = NULL;
+  char *pszFontWeight = NULL;
+  CPLXMLNode *psLabelPlacement = NULL, *psPointPlacement = NULL,
+             *psLinePlacement = NULL;
+  CPLXMLNode *psFill = NULL, *psHalo = NULL, *psHaloRadius = NULL,
+             *psHaloFill = NULL;
   labelObj *psLabelObj = NULL;
-  szFontName[0]='\0';
+  szFontName[0] = '\0';
 
   if (!psRoot || !psClass || !psLayer)
     return MS_FAILURE;
 
-  if(psClass->numlabels == 0) {
-    if(msGrowClassLabels(psClass) == NULL) return(MS_FAILURE);
+  if (psClass->numlabels == 0) {
+    if (msGrowClassLabels(psClass) == NULL)
+      return (MS_FAILURE);
     initLabel(psClass->labels[0]);
     psClass->numlabels++;
   }
@@ -3012,59 +2921,54 @@ int msSLDParseTextParams(CPLXMLNode *psR
     modified Label Placement #2806*/
   psLabelObj->anglemode = MS_AUTO;
 
-
   /* label  */
   /* support literal expression  and  propertyname
    - <TextSymbolizer><Label>MY_COLUMN</Label>
-   - <TextSymbolizer><Label><ogc:PropertyName>MY_COLUMN</ogc:PropertyName></Label>
+   -
+  <TextSymbolizer><Label><ogc:PropertyName>MY_COLUMN</ogc:PropertyName></Label>
   Bug 1857 */
   psLabel = CPLGetXMLNode(psRoot, "Label");
-  if (psLabel)
-  {
-    char * sep = "";
-    msStringBuffer * classtext = msStringBufferAlloc();
+  if (psLabel) {
+    char *sep = "";
+    msStringBuffer *classtext = msStringBufferAlloc();
     msStringBufferAppend(classtext, "(");
-    for (CPLXMLNode * psTmpNode = psLabel->psChild ; psTmpNode ; psTmpNode = psTmpNode->psNext)
-    {
-      if (psTmpNode->eType == CXT_Text && psTmpNode->pszValue)
-      {
+    for (CPLXMLNode *psTmpNode = psLabel->psChild; psTmpNode;
+         psTmpNode = psTmpNode->psNext) {
+      if (psTmpNode->eType == CXT_Text && psTmpNode->pszValue) {
         msStringBufferAppend(classtext, sep);
         msStringBufferAppend(classtext, "\"");
         msStringBufferAppend(classtext, psTmpNode->pszValue);
         msStringBufferAppend(classtext, "\"");
         sep = "+";
-      }
-      else if (psTmpNode->eType == CXT_Element
-               && strcasecmp(psTmpNode->pszValue,"Literal") == 0
-               && psTmpNode->psChild)
-      {
+      } else if (psTmpNode->eType == CXT_Element &&
+                 strcasecmp(psTmpNode->pszValue, "Literal") == 0 &&
+                 psTmpNode->psChild) {
         msStringBufferAppend(classtext, sep);
         msStringBufferAppend(classtext, "\"");
         msStringBufferAppend(classtext, psTmpNode->psChild->pszValue);
         msStringBufferAppend(classtext, "\"");
         sep = "+";
-      }
-      else if (psTmpNode->eType == CXT_Element
-               && strcasecmp(psTmpNode->pszValue,"PropertyName") == 0
-               && psTmpNode->psChild)
-      {
+      } else if (psTmpNode->eType == CXT_Element &&
+                 strcasecmp(psTmpNode->pszValue, "PropertyName") == 0 &&
+                 psTmpNode->psChild) {
         msStringBufferAppend(classtext, sep);
         msStringBufferAppend(classtext, "\"[");
         msStringBufferAppend(classtext, psTmpNode->psChild->pszValue);
         msStringBufferAppend(classtext, "]\"");
         sep = "+";
-      }
-      else if (psTmpNode->eType == CXT_Element
-               && strcasecmp(psTmpNode->pszValue,"Function") == 0
-               && psTmpNode->psChild)
-      {
+      } else if (psTmpNode->eType == CXT_Element &&
+                 strcasecmp(psTmpNode->pszValue, "Function") == 0 &&
+                 psTmpNode->psChild) {
         msStringBufferAppend(classtext, sep);
         msStringBufferAppend(classtext, "tostring(");
 
         labelObj tempExpressionCollector;
         initLabel(&tempExpressionCollector);
-        msSLDParseOgcExpression(psTmpNode,&tempExpressionCollector,MS_LABEL_BINDING_SIZE,MS_OBJ_LABEL);
-        msStringBufferAppend(classtext,tempExpressionCollector.exprBindings[MS_LABEL_BINDING_SIZE].string);
+        msSLDParseOgcExpression(psTmpNode, &tempExpressionCollector,
+                                MS_LABEL_BINDING_SIZE, MS_OBJ_LABEL);
+        msStringBufferAppend(
+            classtext,
+            tempExpressionCollector.exprBindings[MS_LABEL_BINDING_SIZE].string);
         freeLabel(&tempExpressionCollector);
 
         msStringBufferAppend(classtext, ",\"%g\")");
@@ -3072,10 +2976,9 @@ int msSLDParseTextParams(CPLXMLNode *psR
       }
     }
     msStringBufferAppend(classtext, ")");
-    const char * expressionstring = msStringBufferGetString(classtext);
-    if (strlen(expressionstring) > 2)
-    {
-      msLoadExpressionString(&psClass->text, (char*)expressionstring);
+    const char *expressionstring = msStringBufferGetString(classtext);
+    if (strlen(expressionstring) > 2) {
+      msLoadExpressionString(&psClass->text, (char *)expressionstring);
     }
     msStringBufferFree(classtext);
 
@@ -3083,39 +2986,38 @@ int msSLDParseTextParams(CPLXMLNode *psR
       /* font */
       psFont = CPLGetXMLNode(psRoot, "Font");
       if (psFont) {
-        psCssParam =  CPLGetXMLNode(psFont, "CssParameter");
+        psCssParam = CPLGetXMLNode(psFont, "CssParameter");
         /*sld 1.1 used SvgParameter*/
         if (psCssParam == NULL)
-          psCssParam =  CPLGetXMLNode(psFont, "SvgParameter");
+          psCssParam = CPLGetXMLNode(psFont, "SvgParameter");
 
         while (psCssParam && psCssParam->pszValue &&
                (strcasecmp(psCssParam->pszValue, "CssParameter") == 0 ||
                 strcasecmp(psCssParam->pszValue, "SvgParameter") == 0)) {
-          pszName = (char*)CPLGetXMLValue(psCssParam, "name", NULL);
+          pszName = (char *)CPLGetXMLValue(psCssParam, "name", NULL);
           if (pszName) {
             if (strcasecmp(pszName, "font-family") == 0) {
-              if(psCssParam->psChild && psCssParam->psChild->psNext &&
+              if (psCssParam->psChild && psCssParam->psChild->psNext &&
                   psCssParam->psChild->psNext->pszValue)
                 pszFontFamily = psCssParam->psChild->psNext->pszValue;
             }
             /* normal, italic, oblique */
             else if (strcasecmp(pszName, "font-style") == 0) {
-              if(psCssParam->psChild && psCssParam->psChild->psNext &&
+              if (psCssParam->psChild && psCssParam->psChild->psNext &&
                   psCssParam->psChild->psNext->pszValue)
                 pszFontStyle = psCssParam->psChild->psNext->pszValue;
             }
             /* normal or bold */
             else if (strcasecmp(pszName, "font-weight") == 0) {
-              if(psCssParam->psChild && psCssParam->psChild->psNext &&
+              if (psCssParam->psChild && psCssParam->psChild->psNext &&
                   psCssParam->psChild->psNext->pszValue)
                 pszFontWeight = psCssParam->psChild->psNext->pszValue;
             }
             /* default is 10 pix */
             else if (strcasecmp(pszName, "font-size") == 0) {
-              if(psCssParam->psChild && psCssParam->psChild->psNext)
-              {
-                msSLDParseOgcExpression(psCssParam->psChild->psNext,
-                    psLabelObj, MS_LABEL_BINDING_SIZE, MS_OBJ_LABEL);
+              if (psCssParam->psChild && psCssParam->psChild->psNext) {
+                msSLDParseOgcExpression(psCssParam->psChild->psNext, psLabelObj,
+                                        MS_LABEL_BINDING_SIZE, MS_OBJ_LABEL);
               }
             }
           }
@@ -3128,10 +3030,8 @@ int msSLDParseTextParams(CPLXMLNode *psR
       /* -------------------------------------------------------------------- */
       psLabelPlacement = CPLGetXMLNode(psRoot, "LabelPlacement");
       if (psLabelPlacement) {
-        psPointPlacement = CPLGetXMLNode(psLabelPlacement,
-                                         "PointPlacement");
-        psLinePlacement = CPLGetXMLNode(psLabelPlacement,
-                                        "LinePlacement");
+        psPointPlacement = CPLGetXMLNode(psLabelPlacement, "PointPlacement");
+        psLinePlacement = CPLGetXMLNode(psLabelPlacement, "LinePlacement");
         if (psPointPlacement)
           ParseTextPointPlacement(psPointPlacement, psClass);
         if (psLinePlacement)
@@ -3156,7 +3056,8 @@ int msSLDParseTextParams(CPLXMLNode *psR
           strlcat(szFontName, pszFontStyle, sizeof(szFontName));
         }
 
-        if ((msLookupHashTable(&(psLayer->map->fontset.fonts), szFontName) !=NULL)) {
+        if ((msLookupHashTable(&(psLayer->map->fontset.fonts), szFontName) !=
+             NULL)) {
           psLabelObj->font = msStrdup(szFontName);
         }
       }
@@ -3166,63 +3067,60 @@ int msSLDParseTextParams(CPLXMLNode *psR
       /* -------------------------------------------------------------------- */
       psHalo = CPLGetXMLNode(psRoot, "Halo");
       if (psHalo) {
-        psHaloRadius =  CPLGetXMLNode(psHalo, "Radius");
-        if (psHaloRadius && psHaloRadius->psChild && psHaloRadius->psChild->pszValue)
+        psHaloRadius = CPLGetXMLNode(psHalo, "Radius");
+        if (psHaloRadius && psHaloRadius->psChild &&
+            psHaloRadius->psChild->pszValue)
           psLabelObj->outlinewidth = atoi(psHaloRadius->psChild->pszValue);
 
-        psHaloFill =  CPLGetXMLNode(psHalo, "Fill");
+        psHaloFill = CPLGetXMLNode(psHalo, "Fill");
         if (psHaloFill) {
-          psCssParam =  CPLGetXMLNode(psHaloFill, "CssParameter");
+          psCssParam = CPLGetXMLNode(psHaloFill, "CssParameter");
           /*sld 1.1 used SvgParameter*/
           if (psCssParam == NULL)
-            psCssParam =  CPLGetXMLNode(psHaloFill, "SvgParameter");
+            psCssParam = CPLGetXMLNode(psHaloFill, "SvgParameter");
 
           while (psCssParam && psCssParam->pszValue &&
                  (strcasecmp(psCssParam->pszValue, "CssParameter") == 0 ||
                   strcasecmp(psCssParam->pszValue, "SvgParameter") == 0)) {
-            pszName = (char*)CPLGetXMLValue(psCssParam, "name", NULL);
+            pszName = (char *)CPLGetXMLValue(psCssParam, "name", NULL);
             if (pszName) {
               if (strcasecmp(pszName, "fill") == 0) {
-                if(psCssParam->psChild && psCssParam->psChild->psNext)
-                {
-                  msSLDParseOgcExpression(psCssParam->psChild->psNext, psLabelObj,
+                if (psCssParam->psChild && psCssParam->psChild->psNext) {
+                  msSLDParseOgcExpression(
+                      psCssParam->psChild->psNext, psLabelObj,
                       MS_LABEL_BINDING_OUTLINECOLOR, MS_OBJ_LABEL);
                 }
               }
             }
             psCssParam = psCssParam->psNext;
           }
-
         }
-
       }
       /* -------------------------------------------------------------------- */
       /*      Parse the color                                                 */
       /* -------------------------------------------------------------------- */
       psFill = CPLGetXMLNode(psRoot, "Fill");
       if (psFill) {
-        psCssParam =  CPLGetXMLNode(psFill, "CssParameter");
+        psCssParam = CPLGetXMLNode(psFill, "CssParameter");
         /*sld 1.1 used SvgParameter*/
         if (psCssParam == NULL)
-          psCssParam =  CPLGetXMLNode(psFill, "SvgParameter");
+          psCssParam = CPLGetXMLNode(psFill, "SvgParameter");
 
         while (psCssParam && psCssParam->pszValue &&
                (strcasecmp(psCssParam->pszValue, "CssParameter") == 0 ||
                 strcasecmp(psCssParam->pszValue, "SvgParameter") == 0)) {
-          pszName = (char*)CPLGetXMLValue(psCssParam, "name", NULL);
+          pszName = (char *)CPLGetXMLValue(psCssParam, "name", NULL);
           if (pszName) {
             if (strcasecmp(pszName, "fill") == 0) {
-              if(psCssParam->psChild && psCssParam->psChild->psNext)
-              {
+              if (psCssParam->psChild && psCssParam->psChild->psNext) {
                 msSLDParseOgcExpression(psCssParam->psChild->psNext, psLabelObj,
-                    MS_LABEL_BINDING_COLOR, MS_OBJ_LABEL);
+                                        MS_LABEL_BINDING_COLOR, MS_OBJ_LABEL);
               }
             }
           }
           psCssParam = psCssParam->psNext;
         }
       }
-
     }
   }
 
@@ -3234,17 +3132,17 @@ int msSLDParseTextParams(CPLXMLNode *psR
 /*                                                                      */
 /*      point placement node for the text symbolizer.                  */
 /************************************************************************/
-int ParseTextPointPlacement(CPLXMLNode *psRoot, classObj *psClass)
-{
+int ParseTextPointPlacement(CPLXMLNode *psRoot, classObj *psClass) {
   CPLXMLNode *psAnchor, *psAnchorX, *psAnchorY;
   CPLXMLNode *psDisplacement, *psDisplacementX, *psDisplacementY;
-  CPLXMLNode *psRotation=NULL;
+  CPLXMLNode *psRotation = NULL;
   labelObj *psLabelObj = NULL;
 
   if (!psRoot || !psClass)
     return MS_FAILURE;
-  if(psClass->numlabels == 0) {
-    if(msGrowClassLabels(psClass) == NULL) return(MS_FAILURE);
+  if (psClass->numlabels == 0) {
+    if (msGrowClassLabels(psClass) == NULL)
+      return (MS_FAILURE);
     initLabel(psClass->labels[0]);
     psClass->numlabels++;
   }
@@ -3262,12 +3160,8 @@ int ParseTextPointPlacement(CPLXMLNode *
     psAnchorX = CPLGetXMLNode(psAnchor, "AnchorPointX");
     psAnchorY = CPLGetXMLNode(psAnchor, "AnchorPointY");
     /* psCssParam->psChild->psNext->pszValue) */
-    if (psAnchorX &&
-        psAnchorX->psChild &&
-        psAnchorX->psChild->pszValue &&
-        psAnchorY &&
-        psAnchorY->psChild &&
-        psAnchorY->psChild->pszValue) {
+    if (psAnchorX && psAnchorX->psChild && psAnchorX->psChild->pszValue &&
+        psAnchorY && psAnchorY->psChild && psAnchorY->psChild->pszValue) {
       const double dfAnchorX = atof(psAnchorX->psChild->pszValue);
       const double dfAnchorY = atof(psAnchorY->psChild->pszValue);
 
@@ -3305,12 +3199,9 @@ int ParseTextPointPlacement(CPLXMLNode *
     psDisplacementX = CPLGetXMLNode(psDisplacement, "DisplacementX");
     psDisplacementY = CPLGetXMLNode(psDisplacement, "DisplacementY");
     /* psCssParam->psChild->psNext->pszValue) */
-    if (psDisplacementX &&
-        psDisplacementX->psChild &&
-        psDisplacementX->psChild->pszValue &&
-        psDisplacementY &&
-        psDisplacementY->psChild &&
-        psDisplacementY->psChild->pszValue) {
+    if (psDisplacementX && psDisplacementX->psChild &&
+        psDisplacementX->psChild->pszValue && psDisplacementY &&
+        psDisplacementY->psChild && psDisplacementY->psChild->pszValue) {
       psLabelObj->offsetx = atoi(psDisplacementX->psChild->pszValue);
       psLabelObj->offsety = atoi(psDisplacementY->psChild->pszValue);
     }
@@ -3320,10 +3211,9 @@ int ParseTextPointPlacement(CPLXMLNode *
   /*      parse rotation.                                                 */
   /* -------------------------------------------------------------------- */
   psRotation = CPLGetXMLNode(psRoot, "Rotation");
-  if (psRotation && psRotation->psChild)
-  {
+  if (psRotation && psRotation->psChild) {
     msSLDParseOgcExpression(psRotation->psChild, psLabelObj,
-        MS_LABEL_BINDING_ANGLE, MS_OBJ_LABEL);
+                            MS_LABEL_BINDING_ANGLE, MS_OBJ_LABEL);
   }
 
   return MS_SUCCESS;
@@ -3334,16 +3224,16 @@ int ParseTextPointPlacement(CPLXMLNode *
 /*                                                                      */
 /*      Lineplacement node fro the text symbolizer.                     */
 /************************************************************************/
-int ParseTextLinePlacement(CPLXMLNode *psRoot, classObj *psClass)
-{
-  CPLXMLNode *psOffset = NULL, *psAligned=NULL;
+int ParseTextLinePlacement(CPLXMLNode *psRoot, classObj *psClass) {
+  CPLXMLNode *psOffset = NULL, *psAligned = NULL;
   labelObj *psLabelObj = NULL;
 
   if (!psRoot || !psClass)
     return MS_FAILURE;
 
-  if(psClass->numlabels == 0) {
-    if(msGrowClassLabels(psClass) == NULL) return(MS_FAILURE);
+  if (psClass->numlabels == 0) {
+    if (msGrowClassLabels(psClass) == NULL)
+      return (MS_FAILURE);
     initLabel(psClass->labels[0]);
     psClass->numlabels++;
   }
@@ -3379,7 +3269,6 @@ int ParseTextLinePlacement(CPLXMLNode *p
   return MS_SUCCESS;
 }
 
-
 /************************************************************************/
 /*           void msSLDSetColorObject(char *psHexColor, colorObj        */
 /*      *psColor)                                                       */
@@ -3388,14 +3277,13 @@ int ParseTextLinePlacement(CPLXMLNode *p
 /*      color string (format is : #aaff08) and set it in the color      */
 /*      object.                                                         */
 /************************************************************************/
-int msSLDSetColorObject(char *psHexColor, colorObj *psColor)
-{
-  if (psHexColor && psColor && strlen(psHexColor)== 7 &&
+int msSLDSetColorObject(char *psHexColor, colorObj *psColor) {
+  if (psHexColor && psColor && strlen(psHexColor) == 7 &&
       psHexColor[0] == '#') {
 
-    psColor->red = msHexToInt(psHexColor+1);
-    psColor->green = msHexToInt(psHexColor+3);
-    psColor->blue= msHexToInt(psHexColor+5);
+    psColor->red = msHexToInt(psHexColor + 1);
+    psColor->green = msHexToInt(psHexColor + 3);
+    psColor->blue = msHexToInt(psHexColor + 5);
   }
 
   return MS_SUCCESS;
@@ -3415,9 +3303,9 @@ int msSLDSetColorObject(char *psHexColor
 /*                                                                      */
 /*      The caller should free the returned string.                     */
 /************************************************************************/
-char *msSLDGenerateSLD(mapObj *map, int iLayer, const char *pszVersion)
-{
-#if defined(USE_WMS_SVR) || defined (USE_WFS_SVR) || defined (USE_WCS_SVR) || defined(USE_SOS_SVR)
+char *msSLDGenerateSLD(mapObj *map, int iLayer, const char *pszVersion) {
+#if defined(USE_WMS_SVR) || defined(USE_WFS_SVR) || defined(USE_WCS_SVR) ||    \
+    defined(USE_SOS_SVR)
 
   char szTmp[500];
   int i = 0;
@@ -3429,24 +3317,42 @@ char *msSLDGenerateSLD(mapObj *map, int
   sld_version = msOWSParseVersionString(pszVersion);
 
   if (sld_version == OWS_VERSION_NOTSET ||
-      (sld_version!= OWS_1_0_0 && sld_version!= OWS_1_1_0))
+      (sld_version != OWS_1_0_0 && sld_version != OWS_1_1_0))
     sld_version = OWS_1_0_0;
 
   if (map) {
     schemalocation = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
-    if (sld_version ==  OWS_1_0_0)
-      snprintf(szTmp, sizeof(szTmp), "<StyledLayerDescriptor version=\"1.0.0\" xmlns=\"http://www.opengis.net/sld\" xmlns:gml=\"http://www.opengis.net/gml\" xmlns:ogc=\"http://www.opengis.net/ogc\" xmlns:xlink=\"http://www.w3.org/1999/xlink\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://www.opengis.net/sld %s/sld/1.0.0/StyledLayerDescriptor.xsd\">\n",schemalocation );
+    if (sld_version == OWS_1_0_0)
+      snprintf(szTmp, sizeof(szTmp),
+               "<StyledLayerDescriptor version=\"1.0.0\" "
+               "xmlns=\"http://www.opengis.net/sld\" "
+               "xmlns:gml=\"http://www.opengis.net/gml\" "
+               "xmlns:ogc=\"http://www.opengis.net/ogc\" "
+               "xmlns:xlink=\"http://www.w3.org/1999/xlink\" "
+               "xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" "
+               "xsi:schemaLocation=\"http://www.opengis.net/sld "
+               "%s/sld/1.0.0/StyledLayerDescriptor.xsd\">\n",
+               schemalocation);
     else
-      snprintf(szTmp, sizeof(szTmp), "<StyledLayerDescriptor version=\"1.1.0\" xsi:schemaLocation=\"http://www.opengis.net/sld %s/sld/1.1.0/StyledLayerDescriptor.xsd\" xmlns=\"http://www.opengis.net/sld\" xmlns:ogc=\"http://www.opengis.net/ogc\" xmlns:se=\"http://www.opengis.net/se\" xmlns:xlink=\"http://www.w3.org/1999/xlink\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\">\n", schemalocation);
+      snprintf(szTmp, sizeof(szTmp),
+               "<StyledLayerDescriptor version=\"1.1.0\" "
+               "xsi:schemaLocation=\"http://www.opengis.net/sld "
+               "%s/sld/1.1.0/StyledLayerDescriptor.xsd\" "
+               "xmlns=\"http://www.opengis.net/sld\" "
+               "xmlns:ogc=\"http://www.opengis.net/ogc\" "
+               "xmlns:se=\"http://www.opengis.net/se\" "
+               "xmlns:xlink=\"http://www.w3.org/1999/xlink\" "
+               "xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\">\n",
+               schemalocation);
 
     free(schemalocation);
 
     pszSLD = msStringConcatenate(pszSLD, szTmp);
-    if (iLayer < 0 || iLayer > map->numlayers -1) {
-      for (i=0; i<map->numlayers; i++) {
+    if (iLayer < 0 || iLayer > map->numlayers - 1) {
+      for (i = 0; i < map->numlayers; i++) {
         pszTmp = msSLDGenerateSLDLayer(GET_LAYER(map, i), sld_version);
         if (pszTmp) {
-          pszSLD= msStringConcatenate(pszSLD, pszTmp);
+          pszSLD = msStringConcatenate(pszSLD, pszTmp);
           free(pszTmp);
         }
       }
@@ -3471,27 +3377,25 @@ char *msSLDGenerateSLD(mapObj *map, int
 #endif
 }
 
-
-
 /************************************************************************/
 /*                            msSLDGetGraphicSLD                        */
 /*                                                                      */
 /*      Get an SLD for a style containing a symbol (Mark or external).  */
 /************************************************************************/
 char *msSLDGetGraphicSLD(styleObj *psStyle, layerObj *psLayer,
-                         int bNeedMarkSybol, int nVersion)
-{
-#if defined(USE_WMS_SVR) || defined (USE_WFS_SVR) || defined (USE_WCS_SVR) || defined(USE_SOS_SVR)
+                         int bNeedMarkSybol, int nVersion) {
+#if defined(USE_WMS_SVR) || defined(USE_WFS_SVR) || defined(USE_WCS_SVR) ||    \
+    defined(USE_SOS_SVR)
 
-  msStringBuffer * sldString = msStringBufferAlloc();
+  msStringBuffer *sldString = msStringBufferAlloc();
   int nSymbol = -1;
   symbolObj *psSymbol = NULL;
   char szTmp[512];
   char szFormat[4];
   int i = 0, nLength = 0;
-  int bColorAvailable=0;
+  int bColorAvailable = 0;
   int bGenerateDefaultSymbol = 0;
-  char *pszSymbolName= NULL;
+  char *pszSymbolName = NULL;
   char sNameSpace[10];
   char sCssParam[30];
 
@@ -3510,17 +3414,17 @@ char *msSLDGetGraphicSLD(styleObj *psSty
     if (psStyle->symbol > 0)
       nSymbol = psStyle->symbol;
     else if (psStyle->symbolname)
-      nSymbol = msGetSymbolIndex(&psLayer->map->symbolset,
-                                 psStyle->symbolname, MS_FALSE);
+      nSymbol = msGetSymbolIndex(&psLayer->map->symbolset, psStyle->symbolname,
+                                 MS_FALSE);
 
     bGenerateDefaultSymbol = 0;
 
     if (bNeedMarkSybol &&
-        (nSymbol <=0 || nSymbol >=  psLayer->map->symbolset.numsymbols))
+        (nSymbol <= 0 || nSymbol >= psLayer->map->symbolset.numsymbols))
       bGenerateDefaultSymbol = 1;
 
     if (nSymbol > 0 && nSymbol < psLayer->map->symbolset.numsymbols) {
-      psSymbol =  psLayer->map->symbolset.symbol[nSymbol];
+      psSymbol = psLayer->map->symbolset.symbol[nSymbol];
       if (psSymbol->type == MS_SYMBOL_VECTOR ||
           psSymbol->type == MS_SYMBOL_ELLIPSE) {
         /* Mark symbol */
@@ -3534,30 +3438,26 @@ char *msSLDGetGraphicSLD(styleObj *psSty
               strcasecmp(psSymbol->name, "cross") == 0 ||
               strcasecmp(psSymbol->name, "x") == 0)
             pszSymbolName = msStrdup(psSymbol->name);
-          else if (strncasecmp(psSymbol->name,
-                               "sld_mark_symbol_square", 22) == 0)
+          else if (strncasecmp(psSymbol->name, "sld_mark_symbol_square", 22) ==
+                   0)
             pszSymbolName = msStrdup("square");
-          else if (strncasecmp(psSymbol->name,
-                               "sld_mark_symbol_triangle", 24) == 0)
+          else if (strncasecmp(psSymbol->name, "sld_mark_symbol_triangle",
+                               24) == 0)
             pszSymbolName = msStrdup("triangle");
-          else if (strncasecmp(psSymbol->name,
-                               "sld_mark_symbol_circle", 22) == 0)
+          else if (strncasecmp(psSymbol->name, "sld_mark_symbol_circle", 22) ==
+                   0)
             pszSymbolName = msStrdup("circle");
-          else if (strncasecmp(psSymbol->name,
-                               "sld_mark_symbol_star", 20) == 0)
+          else if (strncasecmp(psSymbol->name, "sld_mark_symbol_star", 20) == 0)
             pszSymbolName = msStrdup("star");
-          else if (strncasecmp(psSymbol->name,
-                               "sld_mark_symbol_cross", 21) == 0)
+          else if (strncasecmp(psSymbol->name, "sld_mark_symbol_cross", 21) ==
+                   0)
             pszSymbolName = msStrdup("cross");
-          else if (strncasecmp(psSymbol->name,
-                               "sld_mark_symbol_x", 17) == 0)
+          else if (strncasecmp(psSymbol->name, "sld_mark_symbol_x", 17) == 0)
             pszSymbolName = msStrdup("X");
 
-
-
           if (pszSymbolName) {
-            colorObj sTmpFillColor = { 128, 128, 128, 255 };
-            colorObj sTmpStrokeColor = { 0, 0, 0, 255 };
+            colorObj sTmpFillColor = {128, 128, 128, 255};
+            colorObj sTmpStrokeColor = {0, 0, 0, 255};
             int hasFillColor = 0;
             int hasStrokeColor = 0;
 
@@ -3567,14 +3467,13 @@ char *msSLDGetGraphicSLD(styleObj *psSty
             snprintf(szTmp, sizeof(szTmp), "<%sMark>\n", sNameSpace);
             msStringBufferAppend(sldString, szTmp);
 
-            snprintf(szTmp, sizeof(szTmp), "<%sWellKnownName>%s</%sWellKnownName>\n",
-                sNameSpace, pszSymbolName, sNameSpace);
+            snprintf(szTmp, sizeof(szTmp),
+                     "<%sWellKnownName>%s</%sWellKnownName>\n", sNameSpace,
+                     pszSymbolName, sNameSpace);
             msStringBufferAppend(sldString, szTmp);
 
-            if (psStyle->color.red != -1 &&
-                psStyle->color.green != -1 &&
-                psStyle->color.blue != -1)
-            {
+            if (psStyle->color.red != -1 && psStyle->color.green != -1 &&
+                psStyle->color.blue != -1) {
               sTmpFillColor.red = psStyle->color.red;
               sTmpFillColor.green = psStyle->color.green;
               sTmpFillColor.blue = psStyle->color.blue;
@@ -3583,25 +3482,20 @@ char *msSLDGetGraphicSLD(styleObj *psSty
             }
             if (psStyle->outlinecolor.red != -1 &&
                 psStyle->outlinecolor.green != -1 &&
-                psStyle->outlinecolor.blue != -1)
-            {
+                psStyle->outlinecolor.blue != -1) {
               sTmpStrokeColor.red = psStyle->outlinecolor.red;
               sTmpStrokeColor.green = psStyle->outlinecolor.green;
               sTmpStrokeColor.blue = psStyle->outlinecolor.blue;
               sTmpStrokeColor.alpha = psStyle->outlinecolor.alpha;
               hasStrokeColor = 1;
               // Make defaults implicit
-              if (sTmpStrokeColor.red == 0 &&
-                  sTmpStrokeColor.green == 0 &&
-                  sTmpStrokeColor.blue == 0 &&
-                  sTmpStrokeColor.alpha == 255 &&
-                  psStyle->width == 1)
-              {
+              if (sTmpStrokeColor.red == 0 && sTmpStrokeColor.green == 0 &&
+                  sTmpStrokeColor.blue == 0 && sTmpStrokeColor.alpha == 255 &&
+                  psStyle->width == 1) {
                 hasStrokeColor = 0;
               }
             }
-            if (!hasFillColor && !hasStrokeColor)
-            {
+            if (!hasFillColor && !hasStrokeColor) {
               sTmpFillColor.red = 128;
               sTmpFillColor.green = 128;
               sTmpFillColor.blue = 128;
@@ -3612,19 +3506,15 @@ char *msSLDGetGraphicSLD(styleObj *psSty
             if (hasFillColor) {
               snprintf(szTmp, sizeof(szTmp), "<%sFill>\n", sNameSpace);
               msStringBufferAppend(sldString, szTmp);
-              snprintf(szTmp, sizeof(szTmp), "<%s name=\"fill\">#%02x%02x%02x</%s>\n",
-                  sCssParam,
-                  sTmpFillColor.red,
-                  sTmpFillColor.green,
-                  sTmpFillColor.blue,
-                  sCssParam);
+              snprintf(szTmp, sizeof(szTmp),
+                       "<%s name=\"fill\">#%02x%02x%02x</%s>\n", sCssParam,
+                       sTmpFillColor.red, sTmpFillColor.green,
+                       sTmpFillColor.blue, sCssParam);
               msStringBufferAppend(sldString, szTmp);
-              if (sTmpFillColor.alpha != 255 && sTmpFillColor.alpha != -1)
-              {
-                snprintf(szTmp, sizeof(szTmp), "<%s name=\"fill-opacity\">%.2f</%s>\n",
-                    sCssParam,
-                    (float)sTmpFillColor.alpha/255.0,
-                    sCssParam);
+              if (sTmpFillColor.alpha != 255 && sTmpFillColor.alpha != -1) {
+                snprintf(szTmp, sizeof(szTmp),
+                         "<%s name=\"fill-opacity\">%.2f</%s>\n", sCssParam,
+                         (float)sTmpFillColor.alpha / 255.0, sCssParam);
                 msStringBufferAppend(sldString, szTmp);
               }
               snprintf(szTmp, sizeof(szTmp), "</%sFill>\n", sNameSpace);
@@ -3633,27 +3523,21 @@ char *msSLDGetGraphicSLD(styleObj *psSty
             if (hasStrokeColor) {
               snprintf(szTmp, sizeof(szTmp), "<%sStroke>\n", sNameSpace);
               msStringBufferAppend(sldString, szTmp);
-              snprintf(szTmp, sizeof(szTmp), "<%s name=\"stroke\">#%02x%02x%02x</%s>\n",
-                  sCssParam,
-                  sTmpStrokeColor.red,
-                  sTmpStrokeColor.green,
-                  sTmpStrokeColor.blue,
-                  sCssParam);
+              snprintf(szTmp, sizeof(szTmp),
+                       "<%s name=\"stroke\">#%02x%02x%02x</%s>\n", sCssParam,
+                       sTmpStrokeColor.red, sTmpStrokeColor.green,
+                       sTmpStrokeColor.blue, sCssParam);
               msStringBufferAppend(sldString, szTmp);
-              if (psStyle->width > 0)
-              {
-                snprintf(szTmp, sizeof(szTmp), "<%s name=\"stroke-width\">%g</%s>\n",
-                    sCssParam,
-                    psStyle->width,
-                    sCssParam);
+              if (psStyle->width > 0) {
+                snprintf(szTmp, sizeof(szTmp),
+                         "<%s name=\"stroke-width\">%g</%s>\n", sCssParam,
+                         psStyle->width, sCssParam);
                 msStringBufferAppend(sldString, szTmp);
               }
-              if (sTmpStrokeColor.alpha != 255 && sTmpStrokeColor.alpha != -1)
-              {
-                snprintf(szTmp, sizeof(szTmp), "<%s name=\"stroke-opacity\">%.2f</%s>\n",
-                    sCssParam,
-                    (float)sTmpStrokeColor.alpha/255.0,
-                    sCssParam);
+              if (sTmpStrokeColor.alpha != 255 && sTmpStrokeColor.alpha != -1) {
+                snprintf(szTmp, sizeof(szTmp),
+                         "<%s name=\"stroke-opacity\">%.2f</%s>\n", sCssParam,
+                         (float)sTmpStrokeColor.alpha / 255.0, sCssParam);
                 msStringBufferAppend(sldString, szTmp);
               }
               snprintf(szTmp, sizeof(szTmp), "</%sStroke>\n", sNameSpace);
@@ -3665,33 +3549,33 @@ char *msSLDGetGraphicSLD(styleObj *psSty
 
             if (psStyle->size > 0) {
               snprintf(szTmp, sizeof(szTmp), "<%sSize>%g</%sSize>\n",
-                  sNameSpace, psStyle->size, sNameSpace);
+                       sNameSpace, psStyle->size, sNameSpace);
               msStringBufferAppend(sldString, szTmp);
             }
 
-            if (fmod(psStyle->angle, 360))
-            {
+            if (fmod(psStyle->angle, 360)) {
               snprintf(szTmp, sizeof(szTmp), "<%sRotation>%g</%sRotation>\n",
-                  sNameSpace, psStyle->angle, sNameSpace);
+                       sNameSpace, psStyle->angle, sNameSpace);
               msStringBufferAppend(sldString, szTmp);
             }
-         // Style opacity is already reported to alpha channel of color and outlinecolor
-         // if (psStyle->opacity < 100)
-         // {
-         //   snprintf(szTmp, sizeof(szTmp), "<%sOpacity>%g</%sOpacity>\n",
-         //       sNameSpace, psStyle->opacity/100.0, sNameSpace);
-         //   pszSLD = msStringConcatenate(pszSLD, szTmp);
-         // }
+            // Style opacity is already reported to alpha channel of color and
+            // outlinecolor if (psStyle->opacity < 100)
+            // {
+            //   snprintf(szTmp, sizeof(szTmp), "<%sOpacity>%g</%sOpacity>\n",
+            //       sNameSpace, psStyle->opacity/100.0, sNameSpace);
+            //   pszSLD = msStringConcatenate(pszSLD, szTmp);
+            // }
 
-            if (psStyle->offsetx != 0 || psStyle->offsety != 0)
-            {
+            if (psStyle->offsetx != 0 || psStyle->offsety != 0) {
               snprintf(szTmp, sizeof(szTmp), "<%sDisplacement>\n", sNameSpace);
               msStringBufferAppend(sldString, szTmp);
-              snprintf(szTmp, sizeof(szTmp), "<%sDisplacementX>%g</%sDisplacementX>\n",
-                  sNameSpace, psStyle->offsetx, sNameSpace);
+              snprintf(szTmp, sizeof(szTmp),
+                       "<%sDisplacementX>%g</%sDisplacementX>\n", sNameSpace,
+                       psStyle->offsetx, sNameSpace);
               msStringBufferAppend(sldString, szTmp);
-              snprintf(szTmp, sizeof(szTmp), "<%sDisplacementY>%g</%sDisplacementY>\n",
-                  sNameSpace, psStyle->offsety, sNameSpace);
+              snprintf(szTmp, sizeof(szTmp),
+                       "<%sDisplacementY>%g</%sDisplacementY>\n", sNameSpace,
+                       psStyle->offsety, sNameSpace);
               msStringBufferAppend(sldString, szTmp);
               snprintf(szTmp, sizeof(szTmp), "</%sDisplacement>\n", sNameSpace);
               msStringBufferAppend(sldString, szTmp);
@@ -3704,71 +3588,76 @@ char *msSLDGetGraphicSLD(styleObj *psSty
               free(pszSymbolName);
           }
         } else
-          bGenerateDefaultSymbol =1;
-      } else if (psSymbol->type == MS_SYMBOL_PIXMAP || psSymbol->type == MS_SYMBOL_SVG) {
+          bGenerateDefaultSymbol = 1;
+      } else if (psSymbol->type == MS_SYMBOL_PIXMAP ||
+                 psSymbol->type == MS_SYMBOL_SVG) {
         if (psSymbol->name) {
-          const char *pszURL = msLookupHashTable(&(psLayer->metadata), "WMS_SLD_SYMBOL_URL");
+          const char *pszURL =
+              msLookupHashTable(&(psLayer->metadata), "WMS_SLD_SYMBOL_URL");
           if (!pszURL)
-            pszURL = msLookupHashTable(&(psLayer->map->web.metadata), "WMS_SLD_SYMBOL_URL");
+            pszURL = msLookupHashTable(&(psLayer->map->web.metadata),
+                                       "WMS_SLD_SYMBOL_URL");
 
           if (pszURL) {
             snprintf(szTmp, sizeof(szTmp), "<%sGraphic>\n", sNameSpace);
             msStringBufferAppend(sldString, szTmp);
 
-
-
             snprintf(szTmp, sizeof(szTmp), "<%sExternalGraphic>\n", sNameSpace);
             msStringBufferAppend(sldString, szTmp);
 
-            snprintf(szTmp, sizeof(szTmp), "<%sOnlineResource xmlns:xlink=\"http://www.w3.org/1999/xlink\" xlink:type=\"simple\" xlink:href=\"%s%s\"/>\n", sNameSpace,
-                     pszURL,psSymbol->imagepath);
+            snprintf(szTmp, sizeof(szTmp),
+                     "<%sOnlineResource "
+                     "xmlns:xlink=\"http://www.w3.org/1999/xlink\" "
+                     "xlink:type=\"simple\" xlink:href=\"%s%s\"/>\n",
+                     sNameSpace, pszURL, psSymbol->imagepath);
             msStringBufferAppend(sldString, szTmp);
             /* TODO : extract format from symbol */
 
             szFormat[0] = '\0';
             nLength = strlen(psSymbol->imagepath);
             if (nLength > 3) {
-              for (i=0; i<=2; i++)
-                szFormat[2-i] = psSymbol->imagepath[nLength-1-i];
+              for (i = 0; i <= 2; i++)
+                szFormat[2 - i] = psSymbol->imagepath[nLength - 1 - i];
               szFormat[3] = '\0';
             }
-            if (strlen(szFormat) > 0 &&
-                ((strcasecmp (szFormat, "GIF") == 0) ||
-                 (strcasecmp (szFormat, "PNG") == 0))) {
-              if (strcasecmp (szFormat, "GIF") == 0)
-                snprintf(szTmp, sizeof(szTmp), "<%sFormat>image/gif</%sFormat>\n",
-                         sNameSpace, sNameSpace);
+            if (strlen(szFormat) > 0 && ((strcasecmp(szFormat, "GIF") == 0) ||
+                                         (strcasecmp(szFormat, "PNG") == 0))) {
+              if (strcasecmp(szFormat, "GIF") == 0)
+                snprintf(szTmp, sizeof(szTmp),
+                         "<%sFormat>image/gif</%sFormat>\n", sNameSpace,
+                         sNameSpace);
               else
-                snprintf(szTmp, sizeof(szTmp), "<%sFormat>image/png</%sFormat>\n",
-                         sNameSpace, sNameSpace);
+                snprintf(szTmp, sizeof(szTmp),
+                         "<%sFormat>image/png</%sFormat>\n", sNameSpace,
+                         sNameSpace);
             } else
-              snprintf(szTmp, sizeof(szTmp), "<%sFormat>%s</%sFormat>\n", sNameSpace,
-                            (psSymbol->type ==MS_SYMBOL_SVG)?"image/svg+xml":"image/gif",sNameSpace);
+              snprintf(szTmp, sizeof(szTmp), "<%sFormat>%s</%sFormat>\n",
+                       sNameSpace,
+                       (psSymbol->type == MS_SYMBOL_SVG) ? "image/svg+xml"
+                                                         : "image/gif",
+                       sNameSpace);
 
             msStringBufferAppend(sldString, szTmp);
 
-            snprintf(szTmp, sizeof(szTmp), "</%sExternalGraphic>\n",  sNameSpace);
+            snprintf(szTmp, sizeof(szTmp), "</%sExternalGraphic>\n",
+                     sNameSpace);
             msStringBufferAppend(sldString, szTmp);
 
             if (psStyle->size > 0)
-              snprintf(szTmp, sizeof(szTmp), "<%sSize>%g</%sSize>\n", sNameSpace, psStyle->size,
-                       sNameSpace);
+              snprintf(szTmp, sizeof(szTmp), "<%sSize>%g</%sSize>\n",
+                       sNameSpace, psStyle->size, sNameSpace);
             msStringBufferAppend(sldString, szTmp);
 
             snprintf(szTmp, sizeof(szTmp), "</%sGraphic>\n", sNameSpace);
             msStringBufferAppend(sldString, szTmp);
-
           }
         }
-
       }
     }
     if (bGenerateDefaultSymbol) { /* generate a default square symbol */
       snprintf(szTmp, sizeof(szTmp), "<%sGraphic>\n", sNameSpace);
       msStringBufferAppend(sldString, szTmp);
 
-
-
       snprintf(szTmp, sizeof(szTmp), "<%sMark>\n", sNameSpace);
       msStringBufferAppend(sldString, szTmp);
 
@@ -3777,17 +3666,13 @@ char *msSLDGetGraphicSLD(styleObj *psSty
       msStringBufferAppend(sldString, szTmp);
 
       bColorAvailable = 0;
-      if (psStyle->color.red != -1 &&
-          psStyle->color.green != -1 &&
+      if (psStyle->color.red != -1 && psStyle->color.green != -1 &&
           psStyle->color.blue != -1) {
         snprintf(szTmp, sizeof(szTmp), "<%sFill>\n", sNameSpace);
         msStringBufferAppend(sldString, szTmp);
         snprintf(szTmp, sizeof(szTmp), "<%s name=\"fill\">#%02x%02x%02x</%s>\n",
-                 sCssParam,
-                 psStyle->color.red,
-                 psStyle->color.green,
-                 psStyle->color.blue,
-                 sCssParam);
+                 sCssParam, psStyle->color.red, psStyle->color.green,
+                 psStyle->color.blue, sCssParam);
         msStringBufferAppend(sldString, szTmp);
         snprintf(szTmp, sizeof(szTmp), "</%sFill>\n", sNameSpace);
         msStringBufferAppend(sldString, szTmp);
@@ -3798,12 +3683,10 @@ char *msSLDGetGraphicSLD(styleObj *psSty
           psStyle->outlinecolor.blue != -1) {
         snprintf(szTmp, sizeof(szTmp), "<%sStroke>\n", sNameSpace);
         msStringBufferAppend(sldString, szTmp);
-        snprintf(szTmp, sizeof(szTmp), "<%s name=\"Stroke\">#%02x%02x%02x</%s>\n",
-                 sCssParam,
-                 psStyle->outlinecolor.red,
-                 psStyle->outlinecolor.green,
-                 psStyle->outlinecolor.blue,
-                 sCssParam);
+        snprintf(szTmp, sizeof(szTmp),
+                 "<%s name=\"Stroke\">#%02x%02x%02x</%s>\n", sCssParam,
+                 psStyle->outlinecolor.red, psStyle->outlinecolor.green,
+                 psStyle->outlinecolor.blue, sCssParam);
         msStringBufferAppend(sldString, szTmp);
         snprintf(szTmp, sizeof(szTmp), "</%sStroke>\n", sNameSpace);
         msStringBufferAppend(sldString, szTmp);
@@ -3813,9 +3696,8 @@ char *msSLDGetGraphicSLD(styleObj *psSty
         /* default color */
         snprintf(szTmp, sizeof(szTmp), "<%sFill>\n", sNameSpace);
         msStringBufferAppend(sldString, szTmp);
-        snprintf(szTmp, sizeof(szTmp),
-                 "<%s name=\"fill\">%s</%s>\n",
-                 sCssParam, "#808080", sCssParam);
+        snprintf(szTmp, sizeof(szTmp), "<%s name=\"fill\">%s</%s>\n", sCssParam,
+                 "#808080", sCssParam);
         msStringBufferAppend(sldString, szTmp);
         snprintf(szTmp, sizeof(szTmp), "</%sFill>\n", sNameSpace);
         msStringBufferAppend(sldString, szTmp);
@@ -3828,13 +3710,12 @@ char *msSLDGetGraphicSLD(styleObj *psSty
         snprintf(szTmp, sizeof(szTmp), "<%sSize>%g</%sSize>\n", sNameSpace,
                  psStyle->size, sNameSpace);
       else
-        snprintf(szTmp,  sizeof(szTmp), "<%sSize>%d</%sSize>\n", sNameSpace,1,sNameSpace);
+        snprintf(szTmp, sizeof(szTmp), "<%sSize>%d</%sSize>\n", sNameSpace, 1,
+                 sNameSpace);
       msStringBufferAppend(sldString, szTmp);
 
       snprintf(szTmp, sizeof(szTmp), "</%sGraphic>\n", sNameSpace);
       msStringBufferAppend(sldString, szTmp);
-
-
     }
   }
 
@@ -3844,20 +3725,16 @@ char *msSLDGetGraphicSLD(styleObj *psSty
   return NULL;
 
 #endif
-
 }
 
-
-
-
 /************************************************************************/
 /*                           msSLDGenerateLineSLD                       */
 /*                                                                      */
 /*      Generate SLD for a Line layer.                                  */
 /************************************************************************/
-char *msSLDGenerateLineSLD(styleObj *psStyle, layerObj *psLayer, int nVersion)
-{
-#if defined(USE_WMS_SVR) || defined (USE_WFS_SVR) || defined (USE_WCS_SVR) || defined(USE_SOS_SVR)
+char *msSLDGenerateLineSLD(styleObj *psStyle, layerObj *psLayer, int nVersion) {
+#if defined(USE_WMS_SVR) || defined(USE_WFS_SVR) || defined(USE_WCS_SVR) ||    \
+    defined(USE_SOS_SVR)
 
   char *pszSLD = NULL;
   char szTmp[100];
@@ -3870,45 +3747,47 @@ char *msSLDGenerateLineSLD(styleObj *psS
   char sCssParam[30];
   char sNameSpace[10];
 
-  if ( msCheckParentPointer(psLayer->map,"map")==MS_FAILURE )
+  if (msCheckParentPointer(psLayer->map, "map") == MS_FAILURE)
     return NULL;
 
   sCssParam[0] = '\0';
   if (nVersion > OWS_1_0_0)
-    strcpy( sCssParam, "se:SvgParameter");
+    strcpy(sCssParam, "se:SvgParameter");
   else
-    strcpy( sCssParam, "CssParameter");
+    strcpy(sCssParam, "CssParameter");
 
   sNameSpace[0] = '\0';
   if (nVersion > OWS_1_0_0)
     strcpy(sNameSpace, "se:");
 
-  snprintf(szTmp, sizeof(szTmp), "<%sLineSymbolizer>\n",  sNameSpace);
+  snprintf(szTmp, sizeof(szTmp), "<%sLineSymbolizer>\n", sNameSpace);
 
   pszSLD = msStringConcatenate(pszSLD, szTmp);
 
-  snprintf(szTmp, sizeof(szTmp), "<%sStroke>\n",  sNameSpace);
+  snprintf(szTmp, sizeof(szTmp), "<%sStroke>\n", sNameSpace);
 
   pszSLD = msStringConcatenate(pszSLD, szTmp);
 
   pszGraphicSLD = msSLDGetGraphicSLD(psStyle, psLayer, 0, nVersion);
   if (pszGraphicSLD) {
-    snprintf(szTmp, sizeof(szTmp), "<%sGraphicStroke>\n",  sNameSpace);
+    snprintf(szTmp, sizeof(szTmp), "<%sGraphicStroke>\n", sNameSpace);
 
     pszSLD = msStringConcatenate(pszSLD, szTmp);
 
     pszSLD = msStringConcatenate(pszSLD, pszGraphicSLD);
 
-    if(nVersion >= OWS_1_1_0) {
-      if(psStyle->gap > 0) {
-        snprintf(szTmp, sizeof(szTmp), "<%sGap>%.2f</%sGap>\n",  sNameSpace,psStyle->gap,sNameSpace);
+    if (nVersion >= OWS_1_1_0) {
+      if (psStyle->gap > 0) {
+        snprintf(szTmp, sizeof(szTmp), "<%sGap>%.2f</%sGap>\n", sNameSpace,
+                 psStyle->gap, sNameSpace);
       }
-      if(psStyle->initialgap > 0) {
-        snprintf(szTmp, sizeof(szTmp), "<%sInitialGap>%.2f</%sInitialGap>\n",  sNameSpace,psStyle->initialgap,sNameSpace);
+      if (psStyle->initialgap > 0) {
+        snprintf(szTmp, sizeof(szTmp), "<%sInitialGap>%.2f</%sInitialGap>\n",
+                 sNameSpace, psStyle->initialgap, sNameSpace);
       }
     }
 
-    snprintf(szTmp, sizeof(szTmp), "</%sGraphicStroke>\n",  sNameSpace);
+    snprintf(szTmp, sizeof(szTmp), "</%sGraphicStroke>\n", sNameSpace);
 
     pszSLD = msStringConcatenate(pszSLD, szTmp);
 
@@ -3916,37 +3795,33 @@ char *msSLDGenerateLineSLD(styleObj *psS
     pszGraphicSLD = NULL;
   }
 
-  if (psStyle->color.red != -1 &&
-      psStyle->color.green != -1 &&
+  if (psStyle->color.red != -1 && psStyle->color.green != -1 &&
       psStyle->color.blue != -1)
-    sprintf(szHexColor,"%02x%02x%02x",psStyle->color.red,
-            psStyle->color.green,psStyle->color.blue);
+    sprintf(szHexColor, "%02x%02x%02x", psStyle->color.red,
+            psStyle->color.green, psStyle->color.blue);
   else
-    sprintf(szHexColor,"%02x%02x%02x",psStyle->outlinecolor.red,
-            psStyle->outlinecolor.green,psStyle->outlinecolor.blue);
+    sprintf(szHexColor, "%02x%02x%02x", psStyle->outlinecolor.red,
+            psStyle->outlinecolor.green, psStyle->outlinecolor.blue);
 
-  snprintf(szTmp,  sizeof(szTmp),
-           "<%s name=\"stroke\">#%s</%s>\n",
-           sCssParam, szHexColor, sCssParam);
+  snprintf(szTmp, sizeof(szTmp), "<%s name=\"stroke\">#%s</%s>\n", sCssParam,
+           szHexColor, sCssParam);
   pszSLD = msStringConcatenate(pszSLD, szTmp);
 
-  if(psStyle->color.alpha != 255 && psStyle->color.alpha!=-1) {
-    snprintf(szTmp, sizeof(szTmp),
-             "<%s name=\"stroke-opacity\">%.2f</%s>\n",
-             sCssParam, (float)psStyle->color.alpha/255.0, sCssParam);
+  if (psStyle->color.alpha != 255 && psStyle->color.alpha != -1) {
+    snprintf(szTmp, sizeof(szTmp), "<%s name=\"stroke-opacity\">%.2f</%s>\n",
+             sCssParam, (float)psStyle->color.alpha / 255.0, sCssParam);
     pszSLD = msStringConcatenate(pszSLD, szTmp);
   }
 
-
   nSymbol = -1;
 
   if (psStyle->symbol >= 0)
     nSymbol = psStyle->symbol;
   else if (psStyle->symbolname)
-    nSymbol = msGetSymbolIndex(&psLayer->map->symbolset,
-                               psStyle->symbolname, MS_FALSE);
+    nSymbol = msGetSymbolIndex(&psLayer->map->symbolset, psStyle->symbolname,
+                               MS_FALSE);
 
-  if (nSymbol <0)
+  if (nSymbol < 0)
     dfSize = 1.0;
   else {
     if (psStyle->size > 0)
@@ -3957,8 +3832,7 @@ char *msSLDGenerateLineSLD(styleObj *psS
       dfSize = 1;
   }
 
-  snprintf(szTmp, sizeof(szTmp),
-           "<%s name=\"stroke-width\">%.2f</%s>\n",
+  snprintf(szTmp, sizeof(szTmp), "<%s name=\"stroke-width\">%.2f</%s>\n",
            sCssParam, dfSize, sCssParam);
   pszSLD = msStringConcatenate(pszSLD, szTmp);
 
@@ -3966,24 +3840,22 @@ char *msSLDGenerateLineSLD(styleObj *psS
   /*      dash array                                                      */
   /* -------------------------------------------------------------------- */
 
-
   if (psStyle->patternlength > 0) {
-    for (i=0; i<psStyle->patternlength; i++) {
+    for (i = 0; i < psStyle->patternlength; i++) {
       snprintf(szTmp, sizeof(szTmp), "%.2f ", psStyle->pattern[i]);
       pszDashArray = msStringConcatenate(pszDashArray, szTmp);
     }
-    snprintf(szTmp, sizeof(szTmp),
-             "<%s name=\"stroke-dasharray\">%s</%s>\n",
+    snprintf(szTmp, sizeof(szTmp), "<%s name=\"stroke-dasharray\">%s</%s>\n",
              sCssParam, pszDashArray, sCssParam);
     pszSLD = msStringConcatenate(pszSLD, szTmp);
     msFree(pszDashArray);
   }
 
-  snprintf(szTmp, sizeof(szTmp), "</%sStroke>\n",  sNameSpace);
+  snprintf(szTmp, sizeof(szTmp), "</%sStroke>\n", sNameSpace);
 
   pszSLD = msStringConcatenate(pszSLD, szTmp);
 
-  snprintf(szTmp, sizeof(szTmp), "</%sLineSymbolizer>\n",  sNameSpace);
+  snprintf(szTmp, sizeof(szTmp), "</%sLineSymbolizer>\n", sNameSpace);
 
   pszSLD = msStringConcatenate(pszSLD, szTmp);
 
@@ -3994,15 +3866,15 @@ char *msSLDGenerateLineSLD(styleObj *psS
 #endif
 }
 
-
 /************************************************************************/
 /*                         msSLDGeneratePolygonSLD                      */
 /*                                                                      */
 /*       Generate SLD for a Polygon layer.                              */
 /************************************************************************/
-char *msSLDGeneratePolygonSLD(styleObj *psStyle, layerObj *psLayer, int nVersion)
-{
-#if defined(USE_WMS_SVR) || defined (USE_WFS_SVR) || defined (USE_WCS_SVR) || defined(USE_SOS_SVR)
+char *msSLDGeneratePolygonSLD(styleObj *psStyle, layerObj *psLayer,
+                              int nVersion) {
+#if defined(USE_WMS_SVR) || defined(USE_WFS_SVR) || defined(USE_WCS_SVR) ||    \
+    defined(USE_SOS_SVR)
 
   char szTmp[100];
   char *pszSLD = NULL;
@@ -4022,26 +3894,26 @@ char *msSLDGeneratePolygonSLD(styleObj *
   if (nVersion > OWS_1_0_0)
     strcpy(sNameSpace, "se:");
 
-  snprintf(szTmp, sizeof(szTmp), "<%sPolygonSymbolizer>\n",  sNameSpace);
+  snprintf(szTmp, sizeof(szTmp), "<%sPolygonSymbolizer>\n", sNameSpace);
 
   pszSLD = msStringConcatenate(pszSLD, szTmp);
   /* fill */
   if (psStyle->color.red != -1 && psStyle->color.green != -1 &&
       psStyle->color.blue != -1) {
 
-    snprintf(szTmp, sizeof(szTmp), "<%sFill>\n",  sNameSpace);
+    snprintf(szTmp, sizeof(szTmp), "<%sFill>\n", sNameSpace);
 
     pszSLD = msStringConcatenate(pszSLD, szTmp);
 
     pszGraphicSLD = msSLDGetGraphicSLD(psStyle, psLayer, 0, nVersion);
     if (pszGraphicSLD) {
-      snprintf(szTmp, sizeof(szTmp), "<%sGraphicFill>\n",  sNameSpace);
+      snprintf(szTmp, sizeof(szTmp), "<%sGraphicFill>\n", sNameSpace);
 
       pszSLD = msStringConcatenate(pszSLD, szTmp);
 
       pszSLD = msStringConcatenate(pszSLD, pszGraphicSLD);
 
-      snprintf(szTmp, sizeof(szTmp), "</%sGraphicFill>\n",  sNameSpace);
+      snprintf(szTmp, sizeof(szTmp), "</%sGraphicFill>\n", sNameSpace);
 
       pszSLD = msStringConcatenate(pszSLD, szTmp);
 
@@ -4049,46 +3921,40 @@ char *msSLDGeneratePolygonSLD(styleObj *
       pszGraphicSLD = NULL;
     }
 
-    sprintf(szHexColor,"%02x%02x%02x",psStyle->color.red,
-            psStyle->color.green,psStyle->color.blue);
+    sprintf(szHexColor, "%02x%02x%02x", psStyle->color.red,
+            psStyle->color.green, psStyle->color.blue);
 
-    snprintf(szTmp, sizeof(szTmp),
-             "<%s name=\"fill\">#%s</%s>\n",
-             sCssParam, szHexColor, sCssParam);
+    snprintf(szTmp, sizeof(szTmp), "<%s name=\"fill\">#%s</%s>\n", sCssParam,
+             szHexColor, sCssParam);
     pszSLD = msStringConcatenate(pszSLD, szTmp);
 
-    if(psStyle->color.alpha != 255 && psStyle->color.alpha!=-1) {
-      snprintf(szTmp, sizeof(szTmp),
-               "<%s name=\"fill-opacity\">%.2f</%s>\n",
-               sCssParam, (float)psStyle->color.alpha/255, sCssParam);
+    if (psStyle->color.alpha != 255 && psStyle->color.alpha != -1) {
+      snprintf(szTmp, sizeof(szTmp), "<%s name=\"fill-opacity\">%.2f</%s>\n",
+               sCssParam, (float)psStyle->color.alpha / 255, sCssParam);
       pszSLD = msStringConcatenate(pszSLD, szTmp);
     }
 
-
-    snprintf(szTmp, sizeof(szTmp), "</%sFill>\n",  sNameSpace);
+    snprintf(szTmp, sizeof(szTmp), "</%sFill>\n", sNameSpace);
 
     pszSLD = msStringConcatenate(pszSLD, szTmp);
   }
   /* stroke */
-  if (psStyle->outlinecolor.red != -1 &&
-      psStyle->outlinecolor.green != -1 &&
+  if (psStyle->outlinecolor.red != -1 && psStyle->outlinecolor.green != -1 &&
       psStyle->outlinecolor.blue != -1) {
-    snprintf(szTmp, sizeof(szTmp), "<%sStroke>\n",  sNameSpace);
+    snprintf(szTmp, sizeof(szTmp), "<%sStroke>\n", sNameSpace);
     pszSLD = msStringConcatenate(pszSLD, szTmp);
 
-
-
     /* If there is a symbol to be used for stroke, the color in the */
     /* style should be set to -1. Else It won't apply here. */
     if (psStyle->color.red == -1 && psStyle->color.green == -1 &&
         psStyle->color.blue == -1) {
       pszGraphicSLD = msSLDGetGraphicSLD(psStyle, psLayer, 0, nVersion);
       if (pszGraphicSLD) {
-        snprintf(szTmp, sizeof(szTmp), "<%sGraphicFill>\n",  sNameSpace);
+        snprintf(szTmp, sizeof(szTmp), "<%sGraphicFill>\n", sNameSpace);
         pszSLD = msStringConcatenate(pszSLD, szTmp);
 
         pszSLD = msStringConcatenate(pszSLD, pszGraphicSLD);
-        snprintf(szTmp, sizeof(szTmp), "</%sGraphicFill>\n",  sNameSpace);
+        snprintf(szTmp, sizeof(szTmp), "</%sGraphicFill>\n", sNameSpace);
         pszSLD = msStringConcatenate(pszSLD, szTmp);
 
         free(pszGraphicSLD);
@@ -4096,13 +3962,11 @@ char *msSLDGeneratePolygonSLD(styleObj *
       }
     }
 
-    sprintf(szHexColor,"%02x%02x%02x",psStyle->outlinecolor.red,
-            psStyle->outlinecolor.green,
-            psStyle->outlinecolor.blue);
+    sprintf(szHexColor, "%02x%02x%02x", psStyle->outlinecolor.red,
+            psStyle->outlinecolor.green, psStyle->outlinecolor.blue);
 
-    snprintf(szTmp, sizeof(szTmp),
-             "<%s name=\"stroke\">#%s</%s>\n",
-             sCssParam, szHexColor, sCssParam);
+    snprintf(szTmp, sizeof(szTmp), "<%s name=\"stroke\">#%s</%s>\n", sCssParam,
+             szHexColor, sCssParam);
     pszSLD = msStringConcatenate(pszSLD, szTmp);
 
     dfSize = 1.0;
@@ -4111,20 +3975,18 @@ char *msSLDGeneratePolygonSLD(styleObj *
     else if (psStyle->width > 0)
       dfSize = psStyle->width;
 
-    snprintf(szTmp, sizeof(szTmp),
-             "<%s name=\"stroke-width\">%.2f</%s>\n",
-             sCssParam,dfSize,sCssParam);
+    snprintf(szTmp, sizeof(szTmp), "<%s name=\"stroke-width\">%.2f</%s>\n",
+             sCssParam, dfSize, sCssParam);
     pszSLD = msStringConcatenate(pszSLD, szTmp);
 
-    if(psStyle->outlinecolor.alpha != 255 && psStyle->outlinecolor.alpha != -1)
-    {
-      snprintf(szTmp, sizeof(szTmp),
-          "<%s name=\"stroke-opacity\">%.2f</%s>\n",
-          sCssParam, psStyle->outlinecolor.alpha/255.0, sCssParam);
+    if (psStyle->outlinecolor.alpha != 255 &&
+        psStyle->outlinecolor.alpha != -1) {
+      snprintf(szTmp, sizeof(szTmp), "<%s name=\"stroke-opacity\">%.2f</%s>\n",
+               sCssParam, psStyle->outlinecolor.alpha / 255.0, sCssParam);
       pszSLD = msStringConcatenate(pszSLD, szTmp);
     }
 
-    snprintf(szTmp, sizeof(szTmp), "</%sStroke>\n",  sNameSpace);
+    snprintf(szTmp, sizeof(szTmp), "</%sStroke>\n", sNameSpace);
     pszSLD = msStringConcatenate(pszSLD, szTmp);
   }
 
@@ -4143,9 +4005,10 @@ char *msSLDGeneratePolygonSLD(styleObj *
 /*                                                                      */
 /*      Generate SLD for a Point layer.                                 */
 /************************************************************************/
-char *msSLDGeneratePointSLD(styleObj *psStyle, layerObj *psLayer, int nVersion)
-{
-#if defined(USE_WMS_SVR) || defined (USE_WFS_SVR) || defined (USE_WCS_SVR) || defined(USE_SOS_SVR)
+char *msSLDGeneratePointSLD(styleObj *psStyle, layerObj *psLayer,
+                            int nVersion) {
+#if defined(USE_WMS_SVR) || defined(USE_WFS_SVR) || defined(USE_WCS_SVR) ||    \
+    defined(USE_SOS_SVR)
   char *pszSLD = NULL;
   char *pszGraphicSLD = NULL;
   char szTmp[100];
@@ -4155,7 +4018,7 @@ char *msSLDGeneratePointSLD(styleObj *ps
   if (nVersion > OWS_1_0_0)
     strcpy(sNameSpace, "se:");
 
-  snprintf(szTmp, sizeof(szTmp), "<%sPointSymbolizer>\n",  sNameSpace);
+  snprintf(szTmp, sizeof(szTmp), "<%sPointSymbolizer>\n", sNameSpace);
   pszSLD = msStringConcatenate(pszSLD, szTmp);
 
   pszGraphicSLD = msSLDGetGraphicSLD(psStyle, psLayer, 1, nVersion);
@@ -4164,7 +4027,7 @@ char *msSLDGeneratePointSLD(styleObj *ps
     free(pszGraphicSLD);
   }
 
-  snprintf(szTmp, sizeof(szTmp), "</%sPointSymbolizer>\n",  sNameSpace);
+  snprintf(szTmp, sizeof(szTmp), "</%sPointSymbolizer>\n", sNameSpace);
   pszSLD = msStringConcatenate(pszSLD, szTmp);
 
   return pszSLD;
@@ -4175,17 +4038,15 @@ char *msSLDGeneratePointSLD(styleObj *ps
 #endif
 }
 
-
-
 /************************************************************************/
 /*                           msSLDGenerateTextSLD                       */
 /*                                                                      */
 /*      Generate a TextSymboliser SLD xml based on the class's label    */
 /*      object.                                                         */
 /************************************************************************/
-char *msSLDGenerateTextSLD(classObj *psClass, layerObj *psLayer, int nVersion)
-{
-#if defined(USE_WMS_SVR) || defined (USE_WFS_SVR) || defined (USE_WCS_SVR) || defined(USE_SOS_SVR)
+char *msSLDGenerateTextSLD(classObj *psClass, layerObj *psLayer, int nVersion) {
+#if defined(USE_WMS_SVR) || defined(USE_WFS_SVR) || defined(USE_WCS_SVR) ||    \
+    defined(USE_SOS_SVR)
   char *pszSLD = NULL;
 
   char szTmp[1000];
@@ -4209,41 +4070,32 @@ char *msSLDGenerateTextSLD(classObj *psC
   if (nVersion > OWS_1_0_0)
     strcpy(sNameSpace, "se:");
 
+  if (!psLayer || !psClass)
+    return pszSLD;
 
-  if (!psLayer || !psClass) return pszSLD;
-
-  for (lid=0 ; lid < psClass->numlabels ; lid++)
-  {
-    char * psLabelText;
+  for (lid = 0; lid < psClass->numlabels; lid++) {
+    char *psLabelText;
     expressionObj psLabelExpr;
     parseObj p;
 
     msInitExpression(&psLabelExpr);
     psLabelObj = psClass->labels[lid];
 
-    if (psLabelObj->text.string)
-    {
+    if (psLabelObj->text.string) {
       psLabelExpr.string = msStrdup(psLabelObj->text.string);
       psLabelExpr.type = psLabelObj->text.type;
-    }
-    else if (psClass->text.string)
-    {
+    } else if (psClass->text.string) {
       psLabelExpr.string = msStrdup(psClass->text.string);
       psLabelExpr.type = psClass->text.type;
-    }
-    else if (psLayer->labelitem)
-    {
+    } else if (psLayer->labelitem) {
       psLabelExpr.string = msStrdup(psLayer->labelitem);
       psLabelExpr.type = MS_STRING;
-    }
-    else
-    {
+    } else {
       msFreeExpression(&psLabelExpr);
       continue; // Can't find text content for this <Label>
     }
 
-    if (psLabelExpr.type == MS_STRING)
-    {
+    if (psLabelExpr.type == MS_STRING) {
       // Rewrite string to an expression so that literal strings and attributes
       // are explicitely concatenated, e.g.:
       //   "area is: [area]" becomes ("area is: "+"[area]"+"")
@@ -4253,17 +4105,16 @@ char *msSLDGenerateTextSLD(classObj *psC
       result = msStringConcatenate(result, psLabelExpr.string);
       result = msStringConcatenate(result, "\"");
       msTokenizeExpression(&psLabelExpr, NULL, NULL);
-      for (tokenListNodeObjPtr t = psLabelExpr.tokens ; t ; t=t->next)
-      {
+      for (tokenListNodeObjPtr t = psLabelExpr.tokens; t; t = t->next) {
         if (t->token == MS_TOKEN_BINDING_DOUBLE ||
             t->token == MS_TOKEN_BINDING_INTEGER ||
-            t->token == MS_TOKEN_BINDING_STRING)
-        {
-          char * target = msSmallMalloc(strlen(t->tokenval.bindval.item) + 3);
-          char * replacement = msSmallMalloc(strlen(t->tokenval.bindval.item) + 9);
+            t->token == MS_TOKEN_BINDING_STRING) {
+          char *target = msSmallMalloc(strlen(t->tokenval.bindval.item) + 3);
+          char *replacement =
+              msSmallMalloc(strlen(t->tokenval.bindval.item) + 9);
           sprintf(target, "[%s]", t->tokenval.bindval.item);
           sprintf(replacement, "\"+\"[%s]\"+\"", t->tokenval.bindval.item);
-          result = msReplaceSubstring(result,target,replacement);
+          result = msReplaceSubstring(result, target, replacement);
           msFree(target);
           msFree(replacement);
         }
@@ -4284,11 +4135,11 @@ char *msSLDGenerateTextSLD(classObj *psC
     msFree(p.result.strval);
     msFreeExpression(&psLabelExpr);
 
-    snprintf(szTmp, sizeof(szTmp), "<%sTextSymbolizer>\n",  sNameSpace);
+    snprintf(szTmp, sizeof(szTmp), "<%sTextSymbolizer>\n", sNameSpace);
     pszSLD = msStringConcatenate(pszSLD, szTmp);
 
-    snprintf(szTmp, sizeof(szTmp), "<%sLabel>\n%s</%sLabel>\n",
-        sNameSpace, psLabelText, sNameSpace);
+    snprintf(szTmp, sizeof(szTmp), "<%sLabel>\n%s</%sLabel>\n", sNameSpace,
+             psLabelText, sNameSpace);
     pszSLD = msStringConcatenate(pszSLD, szTmp);
 
     /* -------------------------------------------------------------------- */
@@ -4301,141 +4152,134 @@ char *msSLDGenerateTextSLD(classObj *psC
     if (psLabelObj->font) {
       aszFontsParts = msStringSplit(psLabelObj->font, '-', &nFontParts);
       if (nFontParts > 0) {
-        snprintf(szTmp, sizeof(szTmp), "<%sFont>\n",  sNameSpace);
+        snprintf(szTmp, sizeof(szTmp), "<%sFont>\n", sNameSpace);
         pszSLD = msStringConcatenate(pszSLD, szTmp);
 
         /* assuming first one is font-family */
-        snprintf(szTmp, sizeof(szTmp),
-            "<%s name=\"font-family\">%s</%s>\n",
-            sCssParam, aszFontsParts[0], sCssParam);
+        snprintf(szTmp, sizeof(szTmp), "<%s name=\"font-family\">%s</%s>\n",
+                 sCssParam, aszFontsParts[0], sCssParam);
         pszSLD = msStringConcatenate(pszSLD, szTmp);
-        for (i=1; i<nFontParts; i++) {
+        for (i = 1; i < nFontParts; i++) {
           if (strcasecmp(aszFontsParts[i], "italic") == 0 ||
               strcasecmp(aszFontsParts[i], "oblique") == 0) {
-            snprintf(szTmp, sizeof(szTmp),
-                "<%s name=\"font-style\">%s</%s>\n",
-                sCssParam, aszFontsParts[i], sCssParam);
+            snprintf(szTmp, sizeof(szTmp), "<%s name=\"font-style\">%s</%s>\n",
+                     sCssParam, aszFontsParts[i], sCssParam);
             pszSLD = msStringConcatenate(pszSLD, szTmp);
           } else if (strcasecmp(aszFontsParts[i], "bold") == 0) {
-            snprintf(szTmp, sizeof(szTmp),
-                "<%s name=\"font-weight\">%s</%s>\n",
-                sCssParam,
-                aszFontsParts[i], sCssParam);
+            snprintf(szTmp, sizeof(szTmp), "<%s name=\"font-weight\">%s</%s>\n",
+                     sCssParam, aszFontsParts[i], sCssParam);
             pszSLD = msStringConcatenate(pszSLD, szTmp);
           }
         }
         /* size */
         if (psLabelObj->size > 0) {
-          snprintf(szTmp, sizeof(szTmp),
-              "<%s name=\"font-size\">%d</%s>\n",
-              sCssParam, psLabelObj->size, sCssParam);
+          snprintf(szTmp, sizeof(szTmp), "<%s name=\"font-size\">%d</%s>\n",
+                   sCssParam, psLabelObj->size, sCssParam);
           pszSLD = msStringConcatenate(pszSLD, szTmp);
         }
-        snprintf(szTmp, sizeof(szTmp), "</%sFont>\n",  sNameSpace);
+        snprintf(szTmp, sizeof(szTmp), "</%sFont>\n", sNameSpace);
         pszSLD = msStringConcatenate(pszSLD, szTmp);
       }
       msFreeCharArray(aszFontsParts, nFontParts);
     }
 
-
     /* label placement */
     snprintf(szTmp, sizeof(szTmp), "<%sLabelPlacement>\n<%sPointPlacement>\n",
-        sNameSpace, sNameSpace  );
+             sNameSpace, sNameSpace);
     pszSLD = msStringConcatenate(pszSLD, szTmp);
 
     snprintf(szTmp, sizeof(szTmp), "<%sAnchorPoint>\n", sNameSpace);
     pszSLD = msStringConcatenate(pszSLD, szTmp);
 
     if (psLabelObj->position == MS_LL) {
-      dfAnchorX =0;
+      dfAnchorX = 0;
       dfAnchorY = 0;
     } else if (psLabelObj->position == MS_CL) {
-      dfAnchorX =0;
+      dfAnchorX = 0;
       dfAnchorY = 0.5;
     } else if (psLabelObj->position == MS_UL) {
-      dfAnchorX =0;
+      dfAnchorX = 0;
       dfAnchorY = 1;
     }
 
     else if (psLabelObj->position == MS_LC) {
-      dfAnchorX =0.5;
+      dfAnchorX = 0.5;
       dfAnchorY = 0;
     } else if (psLabelObj->position == MS_CC) {
-      dfAnchorX =0.5;
+      dfAnchorX = 0.5;
       dfAnchorY = 0.5;
     } else if (psLabelObj->position == MS_UC) {
-      dfAnchorX =0.5;
+      dfAnchorX = 0.5;
       dfAnchorY = 1;
     }
 
     else if (psLabelObj->position == MS_LR) {
-      dfAnchorX =1;
+      dfAnchorX = 1;
       dfAnchorY = 0;
     } else if (psLabelObj->position == MS_CR) {
-      dfAnchorX =1;
+      dfAnchorX = 1;
       dfAnchorY = 0.5;
     } else if (psLabelObj->position == MS_UR) {
-      dfAnchorX =1;
+      dfAnchorX = 1;
       dfAnchorY = 1;
     }
     snprintf(szTmp, sizeof(szTmp), "<%sAnchorPointX>%.1f</%sAnchorPointX>\n",
-        sNameSpace, dfAnchorX, sNameSpace);
+             sNameSpace, dfAnchorX, sNameSpace);
     pszSLD = msStringConcatenate(pszSLD, szTmp);
-    snprintf(szTmp, sizeof(szTmp), "<%sAnchorPointY>%.1f</%sAnchorPointY>\n", sNameSpace,
-        dfAnchorY, sNameSpace);
+    snprintf(szTmp, sizeof(szTmp), "<%sAnchorPointY>%.1f</%sAnchorPointY>\n",
+             sNameSpace, dfAnchorY, sNameSpace);
     pszSLD = msStringConcatenate(pszSLD, szTmp);
 
-    snprintf(szTmp, sizeof(szTmp), "</%sAnchorPoint>\n",  sNameSpace);
+    snprintf(szTmp, sizeof(szTmp), "</%sAnchorPoint>\n", sNameSpace);
     pszSLD = msStringConcatenate(pszSLD, szTmp);
 
     /* displacement */
     if (psLabelObj->offsetx > 0 || psLabelObj->offsety > 0) {
-      snprintf(szTmp, sizeof(szTmp), "<%sDisplacement>\n",  sNameSpace);
+      snprintf(szTmp, sizeof(szTmp), "<%sDisplacement>\n", sNameSpace);
       pszSLD = msStringConcatenate(pszSLD, szTmp);
 
       if (psLabelObj->offsetx > 0) {
-        snprintf(szTmp, sizeof(szTmp), "<%sDisplacementX>%d</%sDisplacementX>\n",
-            sNameSpace, psLabelObj->offsetx, sNameSpace);
+        snprintf(szTmp, sizeof(szTmp),
+                 "<%sDisplacementX>%d</%sDisplacementX>\n", sNameSpace,
+                 psLabelObj->offsetx, sNameSpace);
         pszSLD = msStringConcatenate(pszSLD, szTmp);
       }
       if (psLabelObj->offsety > 0) {
-        snprintf(szTmp, sizeof(szTmp), "<%sDisplacementY>%d</%sDisplacementY>\n",
-            sNameSpace, psLabelObj->offsety, sNameSpace);
+        snprintf(szTmp, sizeof(szTmp),
+                 "<%sDisplacementY>%d</%sDisplacementY>\n", sNameSpace,
+                 psLabelObj->offsety, sNameSpace);
         pszSLD = msStringConcatenate(pszSLD, szTmp);
       }
 
-      snprintf(szTmp,  sizeof(szTmp), "</%sDisplacement>\n",  sNameSpace);
+      snprintf(szTmp, sizeof(szTmp), "</%sDisplacement>\n", sNameSpace);
       pszSLD = msStringConcatenate(pszSLD, szTmp);
     }
 
     /* rotation */
     if (psLabelObj->angle > 0) {
       snprintf(szTmp, sizeof(szTmp), "<%sRotation>%.2f</%sRotation>\n",
-          sNameSpace, psLabelObj->angle, sNameSpace);
+               sNameSpace, psLabelObj->angle, sNameSpace);
       pszSLD = msStringConcatenate(pszSLD, szTmp);
     }
 
     snprintf(szTmp, sizeof(szTmp), "</%sPointPlacement>\n</%sLabelPlacement>\n",
-        sNameSpace, sNameSpace);
+             sNameSpace, sNameSpace);
     pszSLD = msStringConcatenate(pszSLD, szTmp);
 
     if (psLabelObj->outlinecolor.red != -1 &&
         psLabelObj->outlinecolor.green != -1 &&
-        psLabelObj->outlinecolor.blue != -1)
-    {
+        psLabelObj->outlinecolor.blue != -1) {
       snprintf(szTmp, sizeof(szTmp), "<%sHalo>\n", sNameSpace);
       pszSLD = msStringConcatenate(pszSLD, szTmp);
-      snprintf(szTmp, sizeof(szTmp), "<%sRadius>%d</%sRadius>\n",
-          sNameSpace, psLabelObj->outlinewidth, sNameSpace);
+      snprintf(szTmp, sizeof(szTmp), "<%sRadius>%d</%sRadius>\n", sNameSpace,
+               psLabelObj->outlinewidth, sNameSpace);
       pszSLD = msStringConcatenate(pszSLD, szTmp);
       snprintf(szTmp, sizeof(szTmp), "<%sFill>\n", sNameSpace);
       pszSLD = msStringConcatenate(pszSLD, szTmp);
       snprintf(szTmp, sizeof(szTmp), "<%s name=\"fill\">#%02x%02x%02x</%s>\n",
-          sCssParam,
-          psLabelObj->outlinecolor.red,
-          psLabelObj->outlinecolor.green,
-          psLabelObj->outlinecolor.blue,
-          sCssParam);
+               sCssParam, psLabelObj->outlinecolor.red,
+               psLabelObj->outlinecolor.green, psLabelObj->outlinecolor.blue,
+               sCssParam);
       pszSLD = msStringConcatenate(pszSLD, szTmp);
       snprintf(szTmp, sizeof(szTmp), "</%sFill>\n", sNameSpace);
       pszSLD = msStringConcatenate(pszSLD, szTmp);
@@ -4444,28 +4288,25 @@ char *msSLDGenerateTextSLD(classObj *psC
     }
 
     /* color */
-    if (psLabelObj->color.red != -1 &&
-        psLabelObj->color.green != -1 &&
-        psLabelObj->color.blue != -1)
-    {
-      snprintf(szTmp, sizeof(szTmp), "<%sFill>\n", sNameSpace );
+    if (psLabelObj->color.red != -1 && psLabelObj->color.green != -1 &&
+        psLabelObj->color.blue != -1) {
+      snprintf(szTmp, sizeof(szTmp), "<%sFill>\n", sNameSpace);
       pszSLD = msStringConcatenate(pszSLD, szTmp);
 
-      sprintf(szHexColor,"%02hhx%02hhx%02hhx",
-          (unsigned char)psLabelObj->color.red,
-          (unsigned char)psLabelObj->color.green,
-          (unsigned char)psLabelObj->color.blue);
+      sprintf(szHexColor, "%02hhx%02hhx%02hhx",
+              (unsigned char)psLabelObj->color.red,
+              (unsigned char)psLabelObj->color.green,
+              (unsigned char)psLabelObj->color.blue);
 
-      snprintf(szTmp, sizeof(szTmp),
-          "<%s name=\"fill\">#%s</%s>\n",
-          sCssParam, szHexColor, sCssParam);
+      snprintf(szTmp, sizeof(szTmp), "<%s name=\"fill\">#%s</%s>\n", sCssParam,
+               szHexColor, sCssParam);
       pszSLD = msStringConcatenate(pszSLD, szTmp);
 
-      snprintf(szTmp, sizeof(szTmp), "</%sFill>\n",  sNameSpace);
+      snprintf(szTmp, sizeof(szTmp), "</%sFill>\n", sNameSpace);
       pszSLD = msStringConcatenate(pszSLD, szTmp);
     }
 
-    snprintf(szTmp, sizeof(szTmp), "</%sTextSymbolizer>\n",  sNameSpace);
+    snprintf(szTmp, sizeof(szTmp), "</%sTextSymbolizer>\n", sNameSpace);
     pszSLD = msStringConcatenate(pszSLD, szTmp);
 
     msFree(psLabelText);
@@ -4477,174 +4318,173 @@ char *msSLDGenerateTextSLD(classObj *psC
 #endif
 }
 
-#if (defined(USE_WMS_SVR) || defined (USE_WFS_SVR) || defined (USE_WCS_SVR) || defined(USE_SOS_SVR))
+#if (defined(USE_WMS_SVR) || defined(USE_WFS_SVR) || defined(USE_WCS_SVR) ||   \
+     defined(USE_SOS_SVR))
 
-static void msSLDAppendName(msStringBuffer* sb, const char* pszName, int nVersion)
-{
-    char* pszEncoded = msEncodeHTMLEntities(pszName);
-    msStringBufferAppend(sb, (nVersion > OWS_1_0_0) ? "<se:Name>" : "<Name>");
-    msStringBufferAppend(sb, pszEncoded);
-    msStringBufferAppend(sb, (nVersion > OWS_1_0_0) ? "</se:Name>\n" : "</Name>\n");
-    msFree(pszEncoded);
+static void msSLDAppendName(msStringBuffer *sb, const char *pszName,
+                            int nVersion) {
+  char *pszEncoded = msEncodeHTMLEntities(pszName);
+  msStringBufferAppend(sb, (nVersion > OWS_1_0_0) ? "<se:Name>" : "<Name>");
+  msStringBufferAppend(sb, pszEncoded);
+  msStringBufferAppend(sb,
+                       (nVersion > OWS_1_0_0) ? "</se:Name>\n" : "</Name>\n");
+  msFree(pszEncoded);
 }
 
-static void msSLDGenerateUserStyle(msStringBuffer* sb, layerObj *psLayer, int nVersion,
-                                   const char* pszTargetGroup)
-{
-    const char* pszWfsFilter;
+static void msSLDGenerateUserStyle(msStringBuffer *sb, layerObj *psLayer,
+                                   int nVersion, const char *pszTargetGroup) {
+  const char *pszWfsFilter;
 
-    msStringBufferAppend(sb, "<UserStyle>\n");
+  msStringBufferAppend(sb, "<UserStyle>\n");
 
-    if( pszTargetGroup )
-    {
-        msSLDAppendName(sb, pszTargetGroup, nVersion);
-        if( psLayer->classgroup &&
-            strcmp(psLayer->classgroup, pszTargetGroup) == 0 )
-        {
-            msStringBufferAppend(sb, nVersion > OWS_1_0_0 ?
-                                        "<se:IsDefault>true</se:IsDefault>\n" :
-                                        "<IsDefault>true</IsDefault>\n");
-        }
+  if (pszTargetGroup) {
+    msSLDAppendName(sb, pszTargetGroup, nVersion);
+    if (psLayer->classgroup &&
+        strcmp(psLayer->classgroup, pszTargetGroup) == 0) {
+      msStringBufferAppend(sb, nVersion > OWS_1_0_0
+                                   ? "<se:IsDefault>true</se:IsDefault>\n"
+                                   : "<IsDefault>true</IsDefault>\n");
     }
+  }
 
-    msStringBufferAppend(sb, nVersion > OWS_1_0_0 ?
-        "<se:FeatureTypeStyle>\n" : "<FeatureTypeStyle>\n");
+  msStringBufferAppend(sb, nVersion > OWS_1_0_0 ? "<se:FeatureTypeStyle>\n"
+                                                : "<FeatureTypeStyle>\n");
 
-    pszWfsFilter = msLookupHashTable(&(psLayer->metadata), "wfs_filter");
-    if (psLayer->numclasses > 0) {
-      int i;
-      for (i=0; i<psLayer->numclasses; i++) {
-        char* pszFilter;
-        double dfMinScale =-1, dfMaxScale = -1;
-
-        /* Only write down classes that match the group of interest */
-        if( psLayer->class[i]->group )
-        {
-            if( pszTargetGroup == NULL ||
-                strcmp(psLayer->class[i]->group, pszTargetGroup) != 0 )
-            {
-                continue;
-            }
-        }
-        else if( pszTargetGroup != NULL )
-        {
-            continue;
+  pszWfsFilter = msLookupHashTable(&(psLayer->metadata), "wfs_filter");
+  if (psLayer->numclasses > 0) {
+    int i;
+    for (i = 0; i < psLayer->numclasses; i++) {
+      char *pszFilter;
+      double dfMinScale = -1, dfMaxScale = -1;
+
+      /* Only write down classes that match the group of interest */
+      if (psLayer->class[i] -> group) {
+        if (pszTargetGroup == NULL ||
+            strcmp(psLayer->class[i] -> group, pszTargetGroup) != 0) {
+          continue;
         }
+      } else if (pszTargetGroup != NULL) {
+        continue;
+      }
 
-        msStringBufferAppend(sb, nVersion > OWS_1_0_0 ? "<se:Rule>\n" : "<Rule>\n" );
-
-        /* if class has a name, use it as the RULE name */
-        if (psLayer->class[i]->name) {
-          msSLDAppendName(sb, psLayer->class[i]->name, nVersion);
-        }
-        /* -------------------------------------------------------------------- */
-        /*      get the Filter if there is a class expression.                  */
-        /* -------------------------------------------------------------------- */
-        pszFilter = msSLDGetFilter(psLayer->class[i] ,
-                                   pszWfsFilter);
-
-        if (pszFilter) {
-          msStringBufferAppend(sb, pszFilter);
-          free(pszFilter);
-        }
-        /* -------------------------------------------------------------------- */
-        /*      generate the min/max scale.                                     */
-        /* -------------------------------------------------------------------- */
-        dfMinScale = -1.0;
-        if (psLayer->class[i]->minscaledenom > 0)
-          dfMinScale = psLayer->class[i]->minscaledenom;
-        else if (psLayer->minscaledenom > 0)
-          dfMinScale = psLayer->minscaledenom;
-        else if (psLayer->map && psLayer->map->web.minscaledenom > 0)
-          dfMinScale = psLayer->map->web.minscaledenom;
-        if (dfMinScale > 0) {
-          char szTmp[100];
-          if (nVersion > OWS_1_0_0)
-            snprintf(szTmp, sizeof(szTmp), "<se:MinScaleDenominator>%f</se:MinScaleDenominator>\n",
-                     dfMinScale);
-          else
-            snprintf(szTmp, sizeof(szTmp), "<MinScaleDenominator>%f</MinScaleDenominator>\n",
-                     dfMinScale);
-
-          msStringBufferAppend(sb, szTmp);
-        }
+      msStringBufferAppend(sb,
+                           nVersion > OWS_1_0_0 ? "<se:Rule>\n" : "<Rule>\n");
 
-        dfMaxScale = -1.0;
-        if (psLayer->class[i]->maxscaledenom > 0)
-          dfMaxScale = psLayer->class[i]->maxscaledenom;
-        else if (psLayer->maxscaledenom > 0)
-          dfMaxScale = psLayer->maxscaledenom;
-        else if (psLayer->map && psLayer->map->web.maxscaledenom > 0)
-          dfMaxScale = psLayer->map->web.maxscaledenom;
-        if (dfMaxScale > 0) {
-          char szTmp[100];
-          if (nVersion > OWS_1_0_0)
-            snprintf(szTmp, sizeof(szTmp), "<se:MaxScaleDenominator>%f</se:MaxScaleDenominator>\n",
-                     dfMaxScale);
-          else
-            snprintf(szTmp, sizeof(szTmp), "<MaxScaleDenominator>%f</MaxScaleDenominator>\n",
-                     dfMaxScale);
+      /* if class has a name, use it as the RULE name */
+      if (psLayer->class[i] -> name) {
+        msSLDAppendName(sb, psLayer->class[i] -> name, nVersion);
+      }
+      /* -------------------------------------------------------------------- */
+      /*      get the Filter if there is a class expression.                  */
+      /* -------------------------------------------------------------------- */
+      pszFilter = msSLDGetFilter(psLayer->class[i], pszWfsFilter);
 
-          msStringBufferAppend(sb, szTmp);
-        }
+      if (pszFilter) {
+        msStringBufferAppend(sb, pszFilter);
+        free(pszFilter);
+      }
+      /* -------------------------------------------------------------------- */
+      /*      generate the min/max scale.                                     */
+      /* -------------------------------------------------------------------- */
+      dfMinScale = -1.0;
+      if (psLayer->class[i] -> minscaledenom > 0)
+        dfMinScale = psLayer->class[i]->minscaledenom;
+      else if (psLayer->minscaledenom > 0)
+        dfMinScale = psLayer->minscaledenom;
+      else if (psLayer->map && psLayer->map->web.minscaledenom > 0)
+        dfMinScale = psLayer->map->web.minscaledenom;
+      if (dfMinScale > 0) {
+        char szTmp[100];
+        if (nVersion > OWS_1_0_0)
+          snprintf(szTmp, sizeof(szTmp),
+                   "<se:MinScaleDenominator>%f</se:MinScaleDenominator>\n",
+                   dfMinScale);
+        else
+          snprintf(szTmp, sizeof(szTmp),
+                   "<MinScaleDenominator>%f</MinScaleDenominator>\n",
+                   dfMinScale);
 
+        msStringBufferAppend(sb, szTmp);
+      }
 
+      dfMaxScale = -1.0;
+      if (psLayer->class[i] -> maxscaledenom > 0)
+        dfMaxScale = psLayer->class[i]->maxscaledenom;
+      else if (psLayer->maxscaledenom > 0)
+        dfMaxScale = psLayer->maxscaledenom;
+      else if (psLayer->map && psLayer->map->web.maxscaledenom > 0)
+        dfMaxScale = psLayer->map->web.maxscaledenom;
+      if (dfMaxScale > 0) {
+        char szTmp[100];
+        if (nVersion > OWS_1_0_0)
+          snprintf(szTmp, sizeof(szTmp),
+                   "<se:MaxScaleDenominator>%f</se:MaxScaleDenominator>\n",
+                   dfMaxScale);
+        else
+          snprintf(szTmp, sizeof(szTmp),
+                   "<MaxScaleDenominator>%f</MaxScaleDenominator>\n",
+                   dfMaxScale);
 
-        /* -------------------------------------------------------------------- */
-        /*      Line symbolizer.                                                */
-        /*                                                                      */
-        /*      Right now only generates a stroke element containing css        */
-        /*      parameters.                                                     */
-        /*      Lines using symbols TODO (specially for dash lines)             */
-        /* -------------------------------------------------------------------- */
-        if (psLayer->type == MS_LAYER_LINE) {
-          int j;
-          for (j=0; j<psLayer->class[i]->numstyles; j++) {
-            styleObj* psStyle = psLayer->class[i]->styles[j];
-            char* pszSLD = msSLDGenerateLineSLD(psStyle, psLayer, nVersion);
-            if (pszSLD) {
-              msStringBufferAppend(sb, pszSLD);
-              free(pszSLD);
-            }
-          }
+        msStringBufferAppend(sb, szTmp);
+      }
 
-        } else if (psLayer->type == MS_LAYER_POLYGON) {
-          int j;
-          for (j=0; j<psLayer->class[i]->numstyles; j++) {
-            styleObj* psStyle = psLayer->class[i]->styles[j];
-            char* pszSLD = msSLDGeneratePolygonSLD(psStyle, psLayer, nVersion);
-            if (pszSLD) {
-              msStringBufferAppend(sb, pszSLD);
-              free(pszSLD);
-            }
+      /* -------------------------------------------------------------------- */
+      /*      Line symbolizer.                                                */
+      /*                                                                      */
+      /*      Right now only generates a stroke element containing css        */
+      /*      parameters.                                                     */
+      /*      Lines using symbols TODO (specially for dash lines)             */
+      /* -------------------------------------------------------------------- */
+      if (psLayer->type == MS_LAYER_LINE) {
+        int j;
+        for (j = 0; j < psLayer->class[i] -> numstyles; j++) {
+          styleObj *psStyle = psLayer->class[i]->styles[j];
+          char *pszSLD = msSLDGenerateLineSLD(psStyle, psLayer, nVersion);
+          if (pszSLD) {
+            msStringBufferAppend(sb, pszSLD);
+            free(pszSLD);
           }
+        }
 
-        } else if (psLayer->type == MS_LAYER_POINT) {
-          int j;
-          for (j=0; j<psLayer->class[i]->numstyles; j++) {
-            styleObj* psStyle = psLayer->class[i]->styles[j];
-            char* pszSLD = msSLDGeneratePointSLD(psStyle, psLayer, nVersion);
-            if (pszSLD) {
-              msStringBufferAppend(sb, pszSLD);
-              free(pszSLD);
-            }
+      } else if (psLayer->type == MS_LAYER_POLYGON) {
+        int j;
+        for (j = 0; j < psLayer->class[i] -> numstyles; j++) {
+          styleObj *psStyle = psLayer->class[i]->styles[j];
+          char *pszSLD = msSLDGeneratePolygonSLD(psStyle, psLayer, nVersion);
+          if (pszSLD) {
+            msStringBufferAppend(sb, pszSLD);
+            free(pszSLD);
           }
-
         }
-        {
-          /* label if it exists */
-          char* pszSLD = msSLDGenerateTextSLD(psLayer->class[i], psLayer, nVersion);
+
+      } else if (psLayer->type == MS_LAYER_POINT) {
+        int j;
+        for (j = 0; j < psLayer->class[i] -> numstyles; j++) {
+          styleObj *psStyle = psLayer->class[i]->styles[j];
+          char *pszSLD = msSLDGeneratePointSLD(psStyle, psLayer, nVersion);
           if (pszSLD) {
             msStringBufferAppend(sb, pszSLD);
             free(pszSLD);
           }
         }
-        msStringBufferAppend(sb, nVersion > OWS_1_0_0 ? "</se:Rule>\n" : "</Rule>\n");
       }
+      {
+        /* label if it exists */
+        char *pszSLD =
+            msSLDGenerateTextSLD(psLayer->class[i], psLayer, nVersion);
+        if (pszSLD) {
+          msStringBufferAppend(sb, pszSLD);
+          free(pszSLD);
+        }
+      }
+      msStringBufferAppend(sb,
+                           nVersion > OWS_1_0_0 ? "</se:Rule>\n" : "</Rule>\n");
     }
+  }
 
-    msStringBufferAppend(sb, nVersion > OWS_1_0_0 ? "</se:FeatureTypeStyle>\n" : "</FeatureTypeStyle>\n");
-    msStringBufferAppend(sb, "</UserStyle>\n");
+  msStringBufferAppend(sb, nVersion > OWS_1_0_0 ? "</se:FeatureTypeStyle>\n"
+                                                : "</FeatureTypeStyle>\n");
+  msStringBufferAppend(sb, "</UserStyle>\n");
 }
 
 #endif
@@ -4654,58 +4494,52 @@ static void msSLDGenerateUserStyle(msStr
 /*                                                                      */
 /*      Generate an SLD XML string based on the layer's classes.        */
 /************************************************************************/
-char *msSLDGenerateSLDLayer(layerObj *psLayer, int nVersion)
-{
-#if defined(USE_WMS_SVR) || defined (USE_WFS_SVR) || defined (USE_WCS_SVR) || defined(USE_SOS_SVR)
+char *msSLDGenerateSLDLayer(layerObj *psLayer, int nVersion) {
+#if defined(USE_WMS_SVR) || defined(USE_WFS_SVR) || defined(USE_WCS_SVR) ||    \
+    defined(USE_SOS_SVR)
 
   const char *pszWMSLayerName = NULL;
-  msStringBuffer* sb = msStringBufferAlloc();
+  msStringBuffer *sb = msStringBufferAlloc();
 
-  if (psLayer &&
-      (psLayer->status == MS_ON || psLayer->status == MS_DEFAULT) &&
-      (psLayer->type == MS_LAYER_POINT ||
-       psLayer->type == MS_LAYER_LINE ||
-       psLayer->type == MS_LAYER_POLYGON )) {
+  if (psLayer && (psLayer->status == MS_ON || psLayer->status == MS_DEFAULT) &&
+      (psLayer->type == MS_LAYER_POINT || psLayer->type == MS_LAYER_LINE ||
+       psLayer->type == MS_LAYER_POLYGON)) {
 
     int i;
     int numClassGroupNames = 0;
-    char** papszClassGroupNames =
-                (char**) msSmallMalloc(sizeof(char*) * psLayer->numclasses);
-    for (i=0; i<psLayer->numclasses; i++) {
-        const char* group = psLayer->class[i]->group;
-        int j;
-        for( j = 0; j < numClassGroupNames; j++ )
-        {
-            if( group == NULL )
-            {
-                if( papszClassGroupNames[j] == NULL )
-                    break;
-            }
-            else if( papszClassGroupNames[j] != NULL &&
-                     strcmp(papszClassGroupNames[j], group) == 0 )
-            {
-                break;
-            }
-        }
-        if( j >= numClassGroupNames )
-        {
-            papszClassGroupNames[numClassGroupNames] = group ? msStrdup(group) : NULL;
-            numClassGroupNames ++;
+    char **papszClassGroupNames =
+        (char **)msSmallMalloc(sizeof(char *) * psLayer->numclasses);
+    for (i = 0; i < psLayer->numclasses; i++) {
+      const char *group = psLayer->class[i]->group;
+      int j;
+      for (j = 0; j < numClassGroupNames; j++) {
+        if (group == NULL) {
+          if (papszClassGroupNames[j] == NULL)
+            break;
+        } else if (papszClassGroupNames[j] != NULL &&
+                   strcmp(papszClassGroupNames[j], group) == 0) {
+          break;
         }
+      }
+      if (j >= numClassGroupNames) {
+        papszClassGroupNames[numClassGroupNames] =
+            group ? msStrdup(group) : NULL;
+        numClassGroupNames++;
+      }
     }
 
     msStringBufferAppend(sb, "<NamedLayer>\n");
 
     pszWMSLayerName = msOWSLookupMetadata(&(psLayer->metadata), "MO", "name");
     msSLDAppendName(sb,
-                    pszWMSLayerName ? pszWMSLayerName :
-                    psLayer->name ? psLayer->name :
-                    "NamedLayer",
+                    pszWMSLayerName ? pszWMSLayerName
+                    : psLayer->name ? psLayer->name
+                                    : "NamedLayer",
                     nVersion);
 
-    for (i=0; i<numClassGroupNames; i++) {
-        msSLDGenerateUserStyle(sb, psLayer, nVersion, papszClassGroupNames[i]);
-        msFree(papszClassGroupNames[i]);
+    for (i = 0; i < numClassGroupNames; i++) {
+      msSLDGenerateUserStyle(sb, psLayer, nVersion, papszClassGroupNames[i]);
+      msFree(papszClassGroupNames[i]);
     }
     msFree(papszClassGroupNames);
 
@@ -4720,9 +4554,7 @@ char *msSLDGenerateSLDLayer(layerObj *ps
 #endif
 }
 
-
-char *msSLDGetComparisonValue(char *pszExpression)
-{
+char *msSLDGetComparisonValue(char *pszExpression) {
   char *pszValue = NULL;
   if (!pszExpression)
     return NULL;
@@ -4744,49 +4576,46 @@ char *msSLDGetComparisonValue(char *pszE
   else if (strstr(pszExpression, ">") || strstr(pszExpression, " gt "))
     pszValue = msStrdup("PropertyIsGreaterThan");
 
-
   return pszValue;
 }
 
-char *msSLDGetLogicalOperator(char *pszExpression)
-{
+char *msSLDGetLogicalOperator(char *pszExpression) {
 
   if (!pszExpression)
     return NULL;
 
-  if(strcasestr(pszExpression, " AND ") || strcasestr(pszExpression, "AND("))
+  if (strcasestr(pszExpression, " AND ") || strcasestr(pszExpression, "AND("))
     return msStrdup("And");
 
-  if(strcasestr(pszExpression, " OR ") || strcasestr(pszExpression, "OR("))
+  if (strcasestr(pszExpression, " OR ") || strcasestr(pszExpression, "OR("))
     return msStrdup("Or");
 
-  if(strcasestr(pszExpression, "NOT ") || strcasestr(pszExpression, "NOT("))
+  if (strcasestr(pszExpression, "NOT ") || strcasestr(pszExpression, "NOT("))
     return msStrdup("Not");
 
   return NULL;
 }
 
-char *msSLDGetRightExpressionOfOperator(char *pszExpression)
-{
-  char *pszAnd = NULL, *pszOr = NULL, *pszNot=NULL;
+char *msSLDGetRightExpressionOfOperator(char *pszExpression) {
+  char *pszAnd = NULL, *pszOr = NULL, *pszNot = NULL;
 
   pszAnd = strcasestr(pszExpression, " AND ");
 
-  if (!pszAnd){
-      pszAnd = strcasestr(pszExpression, "AND(");
+  if (!pszAnd) {
+    pszAnd = strcasestr(pszExpression, "AND(");
   }
 
   if (pszAnd)
-    return msStrdup(pszAnd+4);
+    return msStrdup(pszAnd + 4);
   else {
     pszOr = strcasestr(pszExpression, " OR ");
 
-    if (!pszOr){
-        pszOr = strcasestr(pszExpression, "OR(");
+    if (!pszOr) {
+      pszOr = strcasestr(pszExpression, "OR(");
     }
 
     if (pszOr)
-      return msStrdup(pszOr+3);
+      return msStrdup(pszOr + 3);
     else {
       pszNot = strcasestr(pszExpression, "NOT ");
 
@@ -4794,30 +4623,27 @@ char *msSLDGetRightExpressionOfOperator(
         pszNot = strcasestr(pszExpression, "NOT(");
 
       if (pszNot)
-        return msStrdup(pszNot+4);
+        return msStrdup(pszNot + 4);
     }
   }
   return NULL;
-
 }
 
-char *msSLDGetLeftExpressionOfOperator(char *pszExpression)
-{
+char *msSLDGetLeftExpressionOfOperator(char *pszExpression) {
   char *pszReturn = NULL;
-  int nLength = 0, iReturn=0;
+  int nLength = 0, iReturn = 0;
 
-  if (!pszExpression || (nLength = strlen(pszExpression)) <=0)
+  if (!pszExpression || (nLength = strlen(pszExpression)) <= 0)
     return NULL;
 
-  pszReturn = (char *)malloc(sizeof(char)*(nLength+1));
+  pszReturn = (char *)malloc(sizeof(char) * (nLength + 1));
   pszReturn[0] = '\0';
   if (strcasestr(pszExpression, " AND ")) {
-    for (int i=0; i<nLength-5; i++) {
-      if (pszExpression[i] == ' ' &&
-          (toupper(pszExpression[i+1]) == 'A') &&
-          (toupper(pszExpression[i+2]) == 'N') &&
-          (toupper(pszExpression[i+3]) == 'D') &&
-          (pszExpression[i+4] == ' '))
+    for (int i = 0; i < nLength - 5; i++) {
+      if (pszExpression[i] == ' ' && (toupper(pszExpression[i + 1]) == 'A') &&
+          (toupper(pszExpression[i + 2]) == 'N') &&
+          (toupper(pszExpression[i + 3]) == 'D') &&
+          (pszExpression[i + 4] == ' '))
         break;
       else {
         pszReturn[iReturn++] = pszExpression[i];
@@ -4825,11 +4651,11 @@ char *msSLDGetLeftExpressionOfOperator(c
       pszReturn[iReturn] = '\0';
     }
   } else if (strcasestr(pszExpression, "AND(")) {
-    for (int i=0; i<nLength-4; i++) {
+    for (int i = 0; i < nLength - 4; i++) {
       if ((toupper(pszExpression[i]) == 'A') &&
-          (toupper(pszExpression[i+1]) == 'N') &&
-          (toupper(pszExpression[i+2]) == 'D') &&
-          (pszExpression[i+3] == '('))
+          (toupper(pszExpression[i + 1]) == 'N') &&
+          (toupper(pszExpression[i + 2]) == 'D') &&
+          (pszExpression[i + 3] == '('))
         break;
       else {
         pszReturn[iReturn++] = pszExpression[i];
@@ -4837,11 +4663,9 @@ char *msSLDGetLeftExpressionOfOperator(c
       pszReturn[iReturn] = '\0';
     }
   } else if (strcasestr(pszExpression, " OR ")) {
-    for (int i=0; i<nLength-4; i++) {
-      if (pszExpression[i] == ' ' &&
-          (toupper(pszExpression[i+1]) == 'O') &&
-          (toupper(pszExpression[i+2]) == 'R') &&
-          pszExpression[i+3] == ' ')
+    for (int i = 0; i < nLength - 4; i++) {
+      if (pszExpression[i] == ' ' && (toupper(pszExpression[i + 1]) == 'O') &&
+          (toupper(pszExpression[i + 2]) == 'R') && pszExpression[i + 3] == ' ')
         break;
       else {
         pszReturn[iReturn++] = pszExpression[i];
@@ -4849,10 +4673,9 @@ char *msSLDGetLeftExpressionOfOperator(c
       pszReturn[iReturn] = '\0';
     }
   } else if (strcasestr(pszExpression, "OR(")) {
-    for (int i=0; i<nLength-3; i++) {
+    for (int i = 0; i < nLength - 3; i++) {
       if ((toupper(pszExpression[i]) == 'O') &&
-          (toupper(pszExpression[i+1]) == 'R') &&
-          pszExpression[i+2] == '(')
+          (toupper(pszExpression[i + 1]) == 'R') && pszExpression[i + 2] == '(')
         break;
       else {
         pszReturn[iReturn++] = pszExpression[i];
@@ -4867,13 +4690,11 @@ char *msSLDGetLeftExpressionOfOperator(c
   return pszReturn;
 }
 
-
-int msSLDNumberOfLogicalOperators(char *pszExpression)
-{
+int msSLDNumberOfLogicalOperators(char *pszExpression) {
   char *pszAnd = NULL;
   char *pszOr = NULL;
   char *pszNot = NULL;
-  char *pszSecondAnd=NULL, *pszSecondOr=NULL;
+  char *pszSecondAnd = NULL, *pszSecondOr = NULL;
   if (!pszExpression)
     return 0;
 
@@ -4902,11 +4723,11 @@ int msSLDNumberOfLogicalOperators(char *
     return 2;
 
   if (pszAnd) {
-    pszSecondAnd = strcasestr(pszAnd+3, " AND ");
-    pszSecondOr = strcasestr(pszAnd+3, " OR ");
+    pszSecondAnd = strcasestr(pszAnd + 3, " AND ");
+    pszSecondOr = strcasestr(pszAnd + 3, " OR ");
   } else if (pszOr) {
-    pszSecondAnd = strcasestr(pszOr+2, " AND ");
-    pszSecondOr = strcasestr(pszOr+2, " OR ");
+    pszSecondAnd = strcasestr(pszOr + 2, " AND ");
+    pszSecondOr = strcasestr(pszOr + 2, " OR ");
   }
 
   if (!pszSecondAnd && !pszSecondOr)
@@ -4915,37 +4736,33 @@ int msSLDNumberOfLogicalOperators(char *
     return 2;
 }
 
-
-char *msSLDGetAttributeNameOrValue(char *pszExpression,
-                                   char *pszComparionValue,
-                                   int bReturnName)
-{
+char *msSLDGetAttributeNameOrValue(char *pszExpression, char *pszComparionValue,
+                                   int bReturnName) {
   char **aszValues = NULL;
   char *pszAttributeName = NULL;
   char *pszAttributeValue = NULL;
   char cCompare = '=';
   char szCompare[3] = {0};
   char szCompare2[3] = {0};
-  int bOneCharCompare = -1, nTokens = 0, nLength =0;
-  int iValue=0, i=0, iValueIndex =0;
-  int bStartCopy=0, iAtt=0;
-  char *pszFinalAttributeName=NULL, *pszFinalAttributeValue=NULL;
+  int bOneCharCompare = -1, nTokens = 0, nLength = 0;
+  int iValue = 0, i = 0, iValueIndex = 0;
+  int bStartCopy = 0, iAtt = 0;
+  char *pszFinalAttributeName = NULL, *pszFinalAttributeValue = NULL;
   int bSingleQuote = 0, bDoubleQuote = 0;
 
-  if (!pszExpression || !pszComparionValue || strlen(pszExpression) ==0)
+  if (!pszExpression || !pszComparionValue || strlen(pszExpression) == 0)
     return NULL;
 
   szCompare[0] = '\0';
   szCompare2[0] = '\0';
 
-
   if (strcasecmp(pszComparionValue, "PropertyIsEqualTo") == 0) {
     cCompare = '=';
     szCompare[0] = 'e';
     szCompare[1] = 'q';
     szCompare[2] = '\0';
 
-    bOneCharCompare =1;
+    bOneCharCompare = 1;
   }
   if (strcasecmp(pszComparionValue, "PropertyIsNotEqualTo") == 0) {
     szCompare[0] = 'n';
@@ -4956,7 +4773,7 @@ char *msSLDGetAttributeNameOrValue(char
     szCompare2[1] = '=';
     szCompare2[2] = '\0';
 
-    bOneCharCompare =0;
+    bOneCharCompare = 0;
   } else if (strcasecmp(pszComparionValue, "PropertyIsLike") == 0) {
     szCompare[0] = '=';
     szCompare[1] = '~';
@@ -4966,14 +4783,15 @@ char *msSLDGetAttributeNameOrValue(char
     szCompare2[1] = '*';
     szCompare2[2] = '\0';
 
-    bOneCharCompare =0;
+    bOneCharCompare = 0;
   } else if (strcasecmp(pszComparionValue, "PropertyIsLessThan") == 0) {
     cCompare = '<';
     szCompare[0] = 'l';
     szCompare[1] = 't';
     szCompare[2] = '\0';
-    bOneCharCompare =1;
-  } else if (strcasecmp(pszComparionValue, "PropertyIsLessThanOrEqualTo") == 0) {
+    bOneCharCompare = 1;
+  } else if (strcasecmp(pszComparionValue, "PropertyIsLessThanOrEqualTo") ==
+             0) {
     szCompare[0] = 'l';
     szCompare[1] = 'e';
     szCompare[2] = '\0';
@@ -4982,14 +4800,15 @@ char *msSLDGetAttributeNameOrValue(char
     szCompare2[1] = '=';
     szCompare2[2] = '\0';
 
-    bOneCharCompare =0;
+    bOneCharCompare = 0;
   } else if (strcasecmp(pszComparionValue, "PropertyIsGreaterThan") == 0) {
     cCompare = '>';
     szCompare[0] = 'g';
     szCompare[1] = 't';
     szCompare[2] = '\0';
-    bOneCharCompare =1;
-  } else if (strcasecmp(pszComparionValue, "PropertyIsGreaterThanOrEqualTo") == 0) {
+    bOneCharCompare = 1;
+  } else if (strcasecmp(pszComparionValue, "PropertyIsGreaterThanOrEqualTo") ==
+             0) {
     szCompare[0] = 'g';
     szCompare[1] = 'e';
     szCompare[2] = '\0';
@@ -4998,28 +4817,28 @@ char *msSLDGetAttributeNameOrValue(char
     szCompare2[1] = '=';
     szCompare2[2] = '\0';
 
-    bOneCharCompare =0;
+    bOneCharCompare = 0;
   }
 
   if (bOneCharCompare == 1) {
-    aszValues= msStringSplit (pszExpression, cCompare, &nTokens);
+    aszValues = msStringSplit(pszExpression, cCompare, &nTokens);
     if (nTokens > 1) {
       pszAttributeName = msStrdup(aszValues[0]);
-      pszAttributeValue =  msStrdup(aszValues[1]);
+      pszAttributeValue = msStrdup(aszValues[1]);
     } else {
       nLength = strlen(pszExpression);
-      pszAttributeName = (char *)malloc(sizeof(char)*(nLength+1));
+      pszAttributeName = (char *)malloc(sizeof(char) * (nLength + 1));
       iValue = 0;
-      for (i=0; i<nLength-2; i++) {
+      for (i = 0; i < nLength - 2; i++) {
         if (pszExpression[i] != szCompare[0] &&
             pszExpression[i] != toupper(szCompare[0])) {
           pszAttributeName[iValue++] = pszExpression[i];
         } else {
-          if ((pszExpression[i+1] == szCompare[1] ||
-               pszExpression[i+1] == toupper(szCompare[1])) &&
-              (pszExpression[i+2] == ' ')) {
-            iValueIndex = i+3;
-            pszAttributeValue = msStrdup(pszExpression+iValueIndex);
+          if ((pszExpression[i + 1] == szCompare[1] ||
+               pszExpression[i + 1] == toupper(szCompare[1])) &&
+              (pszExpression[i + 2] == ' ')) {
+            iValueIndex = i + 3;
+            pszAttributeValue = msStrdup(pszExpression + iValueIndex);
             break;
           } else
             pszAttributeName[iValue++] = pszExpression[i];
@@ -5030,9 +4849,9 @@ char *msSLDGetAttributeNameOrValue(char
     msFreeCharArray(aszValues, nTokens);
   } else if (bOneCharCompare == 0) {
     nLength = strlen(pszExpression);
-    pszAttributeName = (char *)malloc(sizeof(char)*(nLength+1));
+    pszAttributeName = (char *)malloc(sizeof(char) * (nLength + 1));
     iValue = 0;
-    for (i=0; i<nLength-2; i++) {
+    for (i = 0; i < nLength - 2; i++) {
       if ((pszExpression[i] != szCompare[0] ||
            pszExpression[i] != toupper(szCompare[0])) &&
           (pszExpression[i] != szCompare2[0] ||
@@ -5041,13 +4860,13 @@ char *msSLDGetAttributeNameOrValue(char
       {
         pszAttributeName[iValue++] = pszExpression[i];
       } else {
-        if (((pszExpression[i+1] == szCompare[1] ||
-              pszExpression[i+1] == toupper(szCompare[1])) ||
-             (pszExpression[i+1] == szCompare2[1] ||
-              pszExpression[i+1] == toupper(szCompare2[1]))) &&
-            (pszExpression[i+2] == ' ')) {
-          iValueIndex = i+3;
-          pszAttributeValue = msStrdup(pszExpression+iValueIndex);
+        if (((pszExpression[i + 1] == szCompare[1] ||
+              pszExpression[i + 1] == toupper(szCompare[1])) ||
+             (pszExpression[i + 1] == szCompare2[1] ||
+              pszExpression[i + 1] == toupper(szCompare2[1]))) &&
+            (pszExpression[i + 2] == ' ')) {
+          iValueIndex = i + 3;
+          pszAttributeValue = msStrdup(pszExpression + iValueIndex);
           break;
         } else
           pszAttributeName[iValue++] = pszExpression[i];
@@ -5067,10 +4886,10 @@ char *msSLDGetAttributeNameOrValue(char
     }
 
     nLength = strlen(pszAttributeName);
-    pszFinalAttributeName = (char *)malloc(sizeof(char)*(nLength+1));
-    bStartCopy= 0;
+    pszFinalAttributeName = (char *)malloc(sizeof(char) * (nLength + 1));
+    bStartCopy = 0;
     iAtt = 0;
-    for (i=0; i<nLength; i++) {
+    for (i = 0; i < nLength; i++) {
       if (pszAttributeName[i] == ' ' && bStartCopy == 0)
         continue;
 
@@ -5096,11 +4915,11 @@ char *msSLDGetAttributeNameOrValue(char
       return NULL;
     }
     nLength = strlen(pszAttributeValue);
-    pszFinalAttributeValue = (char *)malloc(sizeof(char)*(nLength+1));
+    pszFinalAttributeValue = (char *)malloc(sizeof(char) * (nLength + 1));
     pszFinalAttributeValue[0] = '\0';
-    bStartCopy= 0;
+    bStartCopy = 0;
     iAtt = 0;
-    for (i=0; i<nLength; i++) {
+    for (i = 0; i < nLength; i++) {
       if (pszAttributeValue[i] == ' ' && bStartCopy == 0)
         continue;
 
@@ -5113,7 +4932,7 @@ char *msSLDGetAttributeNameOrValue(char
         bStartCopy = 1;
         continue;
       } else
-        bStartCopy =1;
+        bStartCopy = 1;
 
       if (bStartCopy) {
         if (pszAttributeValue[i] == '\'' && bSingleQuote)
@@ -5128,23 +4947,27 @@ char *msSLDGetAttributeNameOrValue(char
     }
 
     /*trim  for regular expressions*/
-    if (strlen(pszFinalAttributeValue) > 2 && strcasecmp(pszComparionValue, "PropertyIsLike") == 0) {
+    if (strlen(pszFinalAttributeValue) > 2 &&
+        strcasecmp(pszComparionValue, "PropertyIsLike") == 0) {
       int len = strlen(pszFinalAttributeValue);
       msStringTrimBlanks(pszFinalAttributeValue);
       if (pszFinalAttributeValue[0] == '/' &&
-          (pszFinalAttributeValue[len-1] == '/' ||
-           (pszFinalAttributeValue[len-1] == 'i' &&
-            pszFinalAttributeValue[len-2] == '/'))) {
-        if (pszFinalAttributeValue[len-1] == '/')
-          pszFinalAttributeValue[len-1] = '\0';
+          (pszFinalAttributeValue[len - 1] == '/' ||
+           (pszFinalAttributeValue[len - 1] == 'i' &&
+            pszFinalAttributeValue[len - 2] == '/'))) {
+        if (pszFinalAttributeValue[len - 1] == '/')
+          pszFinalAttributeValue[len - 1] = '\0';
         else
-          pszFinalAttributeValue[len-2] = '\0';
+          pszFinalAttributeValue[len - 2] = '\0';
 
-        memmove(pszFinalAttributeValue, pszFinalAttributeValue +
-                ((pszFinalAttributeValue[1] == '^') ? 2 : 1), len-1);
+        memmove(pszFinalAttributeValue,
+                pszFinalAttributeValue +
+                    ((pszFinalAttributeValue[1] == '^') ? 2 : 1),
+                len - 1);
 
         /*replace wild card string .* with * */
-        pszFinalAttributeValue = msReplaceSubstring(pszFinalAttributeValue, ".*", "*");
+        pszFinalAttributeValue =
+            msReplaceSubstring(pszFinalAttributeValue, ".*", "*");
       }
     }
     msFree(pszAttributeName);
@@ -5153,21 +4976,14 @@ char *msSLDGetAttributeNameOrValue(char
   }
 }
 
-
-char *msSLDGetAttributeName(char *pszExpression,
-                            char *pszComparionValue)
-{
+char *msSLDGetAttributeName(char *pszExpression, char *pszComparionValue) {
   return msSLDGetAttributeNameOrValue(pszExpression, pszComparionValue, 1);
 }
 
-char *msSLDGetAttributeValue(char *pszExpression,
-                             char *pszComparionValue)
-{
+char *msSLDGetAttributeValue(char *pszExpression, char *pszComparionValue) {
   return msSLDGetAttributeNameOrValue(pszExpression, pszComparionValue, 0);
 }
 
-
-
 /************************************************************************/
 /*                           BuildExpressionTree                        */
 /*                                                                      */
@@ -5180,12 +4996,12 @@ char *msSLDGetAttributeValue(char *pszEx
 /*        NOT A                                                         */
 /************************************************************************/
 FilterEncodingNode *BuildExpressionTree(char *pszExpression,
-                                        FilterEncodingNode *psNode)
-{
-  int nOperators=0;
-  char *pszComparionValue=NULL, *pszAttibuteName=NULL;
-  char *pszAttibuteValue=NULL;
-  char *pszLeftExpression=NULL, *pszRightExpression=NULL, *pszOperator=NULL;
+                                        FilterEncodingNode *psNode) {
+  int nOperators = 0;
+  char *pszComparionValue = NULL, *pszAttibuteName = NULL;
+  char *pszAttibuteValue = NULL;
+  char *pszLeftExpression = NULL, *pszRightExpression = NULL,
+       *pszOperator = NULL;
 
   if (!pszExpression || strlen(pszExpression) == 0)
     return NULL;
@@ -5248,10 +5064,10 @@ FilterEncodingNode *BuildExpressionTree(
       if (pszLeftExpression || pszRightExpression) {
         if (pszLeftExpression) {
           pszComparionValue = msSLDGetComparisonValue(pszLeftExpression);
-          pszAttibuteName = msSLDGetAttributeName(pszLeftExpression,
-                                                  pszComparionValue);
-          pszAttibuteValue = msSLDGetAttributeValue(pszLeftExpression,
-                             pszComparionValue);
+          pszAttibuteName =
+              msSLDGetAttributeName(pszLeftExpression, pszComparionValue);
+          pszAttibuteValue =
+              msSLDGetAttributeValue(pszLeftExpression, pszComparionValue);
 
           if (pszComparionValue && pszAttibuteName && pszAttibuteValue) {
             psNode->psLeftNode = FLTCreateFilterEncodingNode();
@@ -5260,14 +5076,14 @@ FilterEncodingNode *BuildExpressionTree(
 
             psNode->psLeftNode->psLeftNode = FLTCreateFilterEncodingNode();
             psNode->psLeftNode->psLeftNode->eType =
-              FILTER_NODE_TYPE_PROPERTYNAME;
-            psNode->psLeftNode->psLeftNode->pszValue = msStrdup(pszAttibuteName);
+                FILTER_NODE_TYPE_PROPERTYNAME;
+            psNode->psLeftNode->psLeftNode->pszValue =
+                msStrdup(pszAttibuteName);
 
             psNode->psLeftNode->psRightNode = FLTCreateFilterEncodingNode();
-            psNode->psLeftNode->psRightNode->eType =
-              FILTER_NODE_TYPE_LITERAL;
+            psNode->psLeftNode->psRightNode->eType = FILTER_NODE_TYPE_LITERAL;
             psNode->psLeftNode->psRightNode->pszValue =
-              msStrdup(pszAttibuteValue);
+                msStrdup(pszAttibuteValue);
 
             free(pszComparionValue);
             free(pszAttibuteName);
@@ -5277,29 +5093,26 @@ FilterEncodingNode *BuildExpressionTree(
         }
         if (pszRightExpression) {
           pszComparionValue = msSLDGetComparisonValue(pszRightExpression);
-          pszAttibuteName = msSLDGetAttributeName(pszRightExpression,
-                                                  pszComparionValue);
-          pszAttibuteValue = msSLDGetAttributeValue(pszRightExpression,
-                             pszComparionValue);
+          pszAttibuteName =
+              msSLDGetAttributeName(pszRightExpression, pszComparionValue);
+          pszAttibuteValue =
+              msSLDGetAttributeValue(pszRightExpression, pszComparionValue);
 
           if (pszComparionValue && pszAttibuteName && pszAttibuteValue) {
             psNode->psRightNode = FLTCreateFilterEncodingNode();
             psNode->psRightNode->eType = FILTER_NODE_TYPE_COMPARISON;
             psNode->psRightNode->pszValue = msStrdup(pszComparionValue);
 
-            psNode->psRightNode->psLeftNode =
-              FLTCreateFilterEncodingNode();
+            psNode->psRightNode->psLeftNode = FLTCreateFilterEncodingNode();
             psNode->psRightNode->psLeftNode->eType =
-              FILTER_NODE_TYPE_PROPERTYNAME;
+                FILTER_NODE_TYPE_PROPERTYNAME;
             psNode->psRightNode->psLeftNode->pszValue =
-              msStrdup(pszAttibuteName);
+                msStrdup(pszAttibuteName);
 
-            psNode->psRightNode->psRightNode =
-              FLTCreateFilterEncodingNode();
-            psNode->psRightNode->psRightNode->eType =
-              FILTER_NODE_TYPE_LITERAL;
+            psNode->psRightNode->psRightNode = FLTCreateFilterEncodingNode();
+            psNode->psRightNode->psRightNode->eType = FILTER_NODE_TYPE_LITERAL;
             psNode->psRightNode->psRightNode->pszValue =
-              msStrdup(pszAttibuteValue);
+                msStrdup(pszAttibuteValue);
 
             free(pszComparionValue);
             free(pszAttibuteName);
@@ -5316,8 +5129,7 @@ FilterEncodingNode *BuildExpressionTree(
   }
 }
 
-char *msSLDBuildFilterEncoding(FilterEncodingNode *psNode)
-{
+char *msSLDBuildFilterEncoding(FilterEncodingNode *psNode) {
   char *pszTmp = NULL;
   char szTmp[200];
   char *pszExpression = NULL;
@@ -5325,15 +5137,16 @@ char *msSLDBuildFilterEncoding(FilterEnc
   if (!psNode)
     return NULL;
 
-  if (psNode->eType == FILTER_NODE_TYPE_COMPARISON &&
-      psNode->pszValue && psNode->psLeftNode && psNode->psLeftNode->pszValue &&
+  if (psNode->eType == FILTER_NODE_TYPE_COMPARISON && psNode->pszValue &&
+      psNode->psLeftNode && psNode->psLeftNode->pszValue &&
       psNode->psRightNode && psNode->psRightNode->pszValue) {
-    snprintf(szTmp, sizeof(szTmp), "<ogc:%s><ogc:PropertyName>%s</ogc:PropertyName><ogc:Literal>%s</ogc:Literal></ogc:%s>",
+    snprintf(szTmp, sizeof(szTmp),
+             "<ogc:%s><ogc:PropertyName>%s</ogc:PropertyName><ogc:Literal>%s</"
+             "ogc:Literal></ogc:%s>",
              psNode->pszValue, psNode->psLeftNode->pszValue,
              psNode->psRightNode->pszValue, psNode->pszValue);
     pszExpression = msStrdup(szTmp);
-  } else if (psNode->eType == FILTER_NODE_TYPE_LOGICAL &&
-             psNode->pszValue &&
+  } else if (psNode->eType == FILTER_NODE_TYPE_LOGICAL && psNode->pszValue &&
              ((psNode->psLeftNode && psNode->psLeftNode->pszValue) ||
               (psNode->psRightNode && psNode->psRightNode->pszValue))) {
     snprintf(szTmp, sizeof(szTmp), "<ogc:%s>", psNode->pszValue);
@@ -5352,21 +5165,19 @@ char *msSLDBuildFilterEncoding(FilterEnc
         free(pszTmp);
       }
     }
-    snprintf(szTmp,  sizeof(szTmp), "</ogc:%s>", psNode->pszValue);
+    snprintf(szTmp, sizeof(szTmp), "</ogc:%s>", psNode->pszValue);
     pszExpression = msStringConcatenate(pszExpression, szTmp);
   }
   return pszExpression;
 }
 
-
-
-char *msSLDParseLogicalExpression(char *pszExpression, const char *pszWfsFilter)
-{
+char *msSLDParseLogicalExpression(char *pszExpression,
+                                  const char *pszWfsFilter) {
   FilterEncodingNode *psNode = NULL;
   char *pszFLTExpression = NULL;
   char *pszTmp = NULL;
 
-  if (!pszExpression || strlen(pszExpression) ==0)
+  if (!pszExpression || strlen(pszExpression) == 0)
     return NULL;
 
   psNode = BuildExpressionTree(pszExpression, NULL);
@@ -5401,8 +5212,7 @@ char *msSLDParseLogicalExpression(char *
 /*      Return an OGC filter for a mapserver logical expression.        */
 /*      TODO : move function to mapogcfilter.c                          */
 /************************************************************************/
-char *msSLDParseExpression(char *pszExpression)
-{
+char *msSLDParseExpression(char *pszExpression) {
   int nElements = 0;
   char **aszElements = NULL;
   char szBuffer[500];
@@ -5410,8 +5220,8 @@ char *msSLDParseExpression(char *pszExpr
   char szFinalValue[40];
   char szAttribute[40];
   char szValue[40];
-  int iVal=0;
-  int bStartCopy=0, bSinglequote=0, bDoublequote=0;
+  int iVal = 0;
+  int bStartCopy = 0, bSinglequote = 0, bDoublequote = 0;
   char *pszFilter = NULL;
 
   if (!pszExpression)
@@ -5421,18 +5231,18 @@ char *msSLDParseExpression(char *pszExpr
 
   szFinalAtt[0] = '\0';
   szFinalValue[0] = '\0';
-  for (int i=0; i<nElements; i++) {
+  for (int i = 0; i < nElements; i++) {
     if (strcasecmp(aszElements[i], "=") == 0 ||
         strcasecmp(aszElements[i], "eq") == 0) {
-      if (i > 0 && i < nElements-1) {
-        snprintf(szAttribute, sizeof(szAttribute), "%s", aszElements[i-1]);
-        snprintf(szValue, sizeof(szValue), "%s", aszElements[i+1]);
+      if (i > 0 && i < nElements - 1) {
+        snprintf(szAttribute, sizeof(szAttribute), "%s", aszElements[i - 1]);
+        snprintf(szValue, sizeof(szValue), "%s", aszElements[i + 1]);
 
         /* parse attribute */
         int nLength = strlen(szAttribute);
         if (nLength > 0) {
           int iAtt = 0;
-          for (i=0; i<nLength; i++) {
+          for (i = 0; i < nLength; i++) {
             if (szAttribute[i] == '[') {
               bStartCopy = 1;
               continue;
@@ -5459,17 +5269,21 @@ char *msSLDParseExpression(char *pszExpr
 
           iVal = 0;
           if (bSinglequote || bDoublequote) {
-            for (i=1; i<nLength-1; i++)
+            for (i = 1; i < nLength - 1; i++)
               szFinalValue[iVal++] = szValue[i];
 
             szFinalValue[iVal] = '\0';
           }
         }
       }
-      if (strlen(szFinalAtt) > 0 && strlen(szFinalValue) >0) {
-        snprintf(szBuffer, sizeof(szBuffer), "<ogc:Filter><ogc:PropertyIsEqualTo><ogc:PropertyName>%s</ogc:PropertyName><ogc:Literal>%s</ogc:Literal></ogc:PropertyIsEqualTo></ogc:Filter>",
+      if (strlen(szFinalAtt) > 0 && strlen(szFinalValue) > 0) {
+        snprintf(szBuffer, sizeof(szBuffer),
+                 "<ogc:Filter><ogc:PropertyIsEqualTo><ogc:PropertyName>%s</"
+                 "ogc:PropertyName><ogc:Literal>%s</ogc:Literal></"
+                 "ogc:PropertyIsEqualTo></ogc:Filter>",
                  szFinalAtt, szFinalValue);
-        msFree(pszFilter); /*FIXME: we are possibly discarding a previously set pszFilter */
+        msFree(pszFilter); /*FIXME: we are possibly discarding a previously set
+                              pszFilter */
         pszFilter = msStrdup(szBuffer);
       }
     }
@@ -5479,7 +5293,6 @@ char *msSLDParseExpression(char *pszExpr
   return pszFilter;
 }
 
-
 /************************************************************************/
 /*                     msSLDConvertRegexExpToOgcIsLike                  */
 /*                                                                      */
@@ -5508,10 +5321,9 @@ char *msSLDParseExpression(char *pszExpr
 /*      converted to T* which is not correct.                           */
 /*                                                                      */
 /************************************************************************/
-char *msSLDConvertRegexExpToOgcIsLike(char *pszRegex)
-{
+char *msSLDConvertRegexExpToOgcIsLike(char *pszRegex) {
   char szBuffer[1024];
-  int iBuffer = 0, i=0;
+  int iBuffer = 0, i = 0;
   int nLength = 0;
 
   if (!pszRegex || strlen(pszRegex) == 0)
@@ -5525,11 +5337,11 @@ char *msSLDConvertRegexExpToOgcIsLike(ch
       szBuffer[iBuffer++] = pszRegex[i];
       i++;
     } else {
-      if (i<nLength-1 && pszRegex[i+1] == '*') {
+      if (i < nLength - 1 && pszRegex[i + 1] == '*') {
         szBuffer[iBuffer++] = '*';
-        i = i+2;
+        i = i + 2;
       } else {
-        szBuffer[iBuffer++] =  pszRegex[i];
+        szBuffer[iBuffer++] = pszRegex[i];
         i++;
       }
     }
@@ -5546,8 +5358,7 @@ char *msSLDConvertRegexExpToOgcIsLike(ch
 /*      expression. TODO : move function to mapogcfilter.c when         */
 /*      finished.                                                       */
 /************************************************************************/
-char *msSLDGetFilter(classObj *psClass, const char *pszWfsFilter)
-{
+char *msSLDGetFilter(classObj *psClass, const char *pszWfsFilter) {
   char *pszFilter = NULL;
   char szBuffer[500];
   char *pszOgcFilter = NULL;
@@ -5557,25 +5368,98 @@ char *msSLDGetFilter(classObj *psClass,
     if (psClass->expression.type == MS_STRING) {
       if (psClass->layer && psClass->layer->classitem) {
         if (pszWfsFilter)
-          snprintf(szBuffer, sizeof(szBuffer), "<ogc:Filter><ogc:And>%s<ogc:PropertyIsEqualTo><ogc:PropertyName>%s</ogc:PropertyName><ogc:Literal>%s</ogc:Literal></ogc:PropertyIsEqualTo></ogc:And></ogc:Filter>\n",
-                   pszWfsFilter, psClass->layer->classitem, psClass->expression.string);
+          snprintf(
+              szBuffer, sizeof(szBuffer),
+              "<ogc:Filter><ogc:And>%s<ogc:PropertyIsEqualTo><ogc:PropertyName>"
+              "%s</ogc:PropertyName><ogc:Literal>%s</ogc:Literal></"
+              "ogc:PropertyIsEqualTo></ogc:And></ogc:Filter>\n",
+              pszWfsFilter, psClass->layer->classitem,
+              psClass->expression.string);
         else
-          snprintf(szBuffer, sizeof(szBuffer), "<ogc:Filter><ogc:PropertyIsEqualTo><ogc:PropertyName>%s</ogc:PropertyName><ogc:Literal>%s</ogc:Literal></ogc:PropertyIsEqualTo></ogc:Filter>\n",
+          snprintf(szBuffer, sizeof(szBuffer),
+                   "<ogc:Filter><ogc:PropertyIsEqualTo><ogc:PropertyName>%s</"
+                   "ogc:PropertyName><ogc:Literal>%s</ogc:Literal></"
+                   "ogc:PropertyIsEqualTo></ogc:Filter>\n",
                    psClass->layer->classitem, psClass->expression.string);
         pszFilter = msStrdup(szBuffer);
       }
     } else if (psClass->expression.type == MS_EXPRESSION) {
-      pszFilter = msSLDParseLogicalExpression(psClass->expression.string, pszWfsFilter);
+      pszFilter =
+          msSLDParseLogicalExpression(psClass->expression.string, pszWfsFilter);
+    } else if (psClass->expression.type == MS_LIST) {
+      if (psClass->layer && psClass->layer->classitem &&
+          psClass->expression.string) {
+
+        char *pszTmp = NULL;
+        char *pszTmpFilters = NULL;
+
+        char **listExpressionValues = NULL;
+        int numListExpressionValues = 0;
+        int i = 0;
+        int tokenCount = 0;
+
+        listExpressionValues = msStringSplit(psClass->expression.string, ',',
+                                             &numListExpressionValues);
+
+        // loop through all values in the list and create a PropertyIsEqualTo
+        // for each value
+        for (i = 0; i < numListExpressionValues; i++) {
+          if (listExpressionValues[i] && listExpressionValues[i][0] != '\0') {
+
+            snprintf(szBuffer, sizeof(szBuffer),
+                     "<ogc:PropertyIsEqualTo><ogc:PropertyName>%s</"
+                     "ogc:PropertyName><ogc:Literal>%s</ogc:Literal></"
+                     "ogc:PropertyIsEqualTo>\n",
+                     psClass->layer->classitem, listExpressionValues[i]);
+
+            pszTmpFilters = msStringConcatenate(pszTmpFilters, szBuffer);
+            tokenCount++;
+          }
+        }
+
+        pszTmp = msStringConcatenate(pszTmp, "<ogc:Filter>");
+
+        // no need for an OR clause if there is only one item in the list
+        if (tokenCount == 1) {
+          pszTmp = msStringConcatenate(pszTmp, pszTmpFilters);
+        } else if (tokenCount > 1) {
+          pszTmp = msStringConcatenate(pszTmp, "<ogc:Or>");
+          pszTmp = msStringConcatenate(pszTmp, pszTmpFilters);
+          pszTmp = msStringConcatenate(pszTmp, "</ogc:Or>");
+        }
+
+        pszTmp = msStringConcatenate(pszTmp, "</ogc:Filter>");
+
+        // don't filter when the list is empty
+        if (tokenCount > 0) {
+          pszFilter = msStrdup(pszTmp);
+        }
+        msFreeCharArray(listExpressionValues, numListExpressionValues);
+        free(pszTmp);
+        free(pszTmpFilters);
+      }
     } else if (psClass->expression.type == MS_REGEX) {
-      if (psClass->layer && psClass->layer->classitem && psClass->expression.string) {
-        pszOgcFilter = msSLDConvertRegexExpToOgcIsLike(psClass->expression.string);
+      if (psClass->layer && psClass->layer->classitem &&
+          psClass->expression.string) {
+        pszOgcFilter =
+            msSLDConvertRegexExpToOgcIsLike(psClass->expression.string);
 
         if (pszWfsFilter)
-          snprintf(szBuffer, sizeof(szBuffer), "<ogc:Filter><ogc:And>%s<ogc:PropertyIsLike wildCard=\"*\" singleChar=\".\" escape=\"\\\"><ogc:PropertyName>%s</ogc:PropertyName><ogc:Literal>%s</ogc:Literal></ogc:PropertyIsLike></ogc:And></ogc:Filter>\n",
+          snprintf(szBuffer, sizeof(szBuffer),
+                   "<ogc:Filter><ogc:And>%s<ogc:PropertyIsLike wildCard=\"*\" "
+                   "singleChar=\".\" "
+                   "escape=\"\\\"><ogc:PropertyName>%s</"
+                   "ogc:PropertyName><ogc:Literal>%s</ogc:Literal></"
+                   "ogc:PropertyIsLike></ogc:And></ogc:Filter>\n",
                    pszWfsFilter, psClass->layer->classitem, pszOgcFilter);
         else
-          snprintf(szBuffer, sizeof(szBuffer), "<ogc:Filter><ogc:PropertyIsLike wildCard=\"*\" singleChar=\".\" escape=\"\\\"><ogc:PropertyName>%s</ogc:PropertyName><ogc:Literal>%s</ogc:Literal></ogc:PropertyIsLike></ogc:Filter>\n",
-                   psClass->layer->classitem, pszOgcFilter);
+          snprintf(
+              szBuffer, sizeof(szBuffer),
+              "<ogc:Filter><ogc:PropertyIsLike wildCard=\"*\" singleChar=\".\" "
+              "escape=\"\\\"><ogc:PropertyName>%s</"
+              "ogc:PropertyName><ogc:Literal>%s</ogc:Literal></"
+              "ogc:PropertyIsLike></ogc:Filter>\n",
+              psClass->layer->classitem, pszOgcFilter);
 
         free(pszOgcFilter);
 
@@ -5583,7 +5467,8 @@ char *msSLDGetFilter(classObj *psClass,
       }
     }
   } else if (pszWfsFilter) {
-    snprintf(szBuffer, sizeof(szBuffer), "<ogc:Filter>%s</ogc:Filter>\n", pszWfsFilter);
+    snprintf(szBuffer, sizeof(szBuffer), "<ogc:Filter>%s</ogc:Filter>\n",
+             pszWfsFilter);
     pszFilter = msStrdup(szBuffer);
   }
   return pszFilter;
diff -pruN 8.0.1-5/mapogcsld.h 8.0.2-1/mapogcsld.h
--- 8.0.1-5/mapogcsld.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapogcsld.h	2024-06-11 20:41:34.000000000 +0000
@@ -32,11 +32,14 @@
 extern "C" {
 #endif
 
-MS_DLL_EXPORT char *msSLDGenerateSLD(mapObj *map, int iLayer, const char *pszVersion);
+MS_DLL_EXPORT char *msSLDGenerateSLD(mapObj *map, int iLayer,
+                                     const char *pszVersion);
 MS_DLL_EXPORT int msSLDApplySLDURL(mapObj *map, const char *szURL, int iLayer,
-                                   const char *pszStyleLayerName, char **ppszLayerNames);
+                                   const char *pszStyleLayerName,
+                                   char **ppszLayerNames);
 MS_DLL_EXPORT int msSLDApplySLD(mapObj *map, const char *psSLDXML, int iLayer,
-                                const char *pszStyleLayerName, char **ppszLayerNames);
+                                const char *pszStyleLayerName,
+                                char **ppszLayerNames);
 
 /* There is a dependency to OGR for the MiniXML parser */
 #include "cpl_minixml.h"
@@ -46,28 +49,29 @@ enum objType { MS_OBJ_STYLE, MS_OBJ_LABE
 /* -------------------------------------------------------------------- */
 /*      prototypes.                                                     */
 /* -------------------------------------------------------------------- */
-layerObj  *msSLDParseSLD(mapObj *map, const char *psSLDXML, int *pnLayers);
+layerObj *msSLDParseSLD(mapObj *map, const char *psSLDXML, int *pnLayers);
 int msSLDParseNamedLayer(CPLXMLNode *psRoot, layerObj *layer);
-int msSLDParseRule(CPLXMLNode *psRoot, layerObj *psLayer, const char* pszUserStyleName);
-int msSLDParseStroke(CPLXMLNode *psStroke, styleObj *psStyle,
-                     mapObj *map, int iColorParam);
+int msSLDParseRule(CPLXMLNode *psRoot, layerObj *psLayer,
+                   const char *pszUserStyleName);
+int msSLDParseStroke(CPLXMLNode *psStroke, styleObj *psStyle, mapObj *map,
+                     int iColorParam);
 int msSLDParseOgcExpression(CPLXMLNode *psRoot, void *psObj, int binding,
                             enum objType objtype);
-int msSLDParsePolygonFill(CPLXMLNode *psFill, styleObj *psStyle,
-                          mapObj *map);
+int msSLDParsePolygonFill(CPLXMLNode *psFill, styleObj *psStyle, mapObj *map);
 
 int msSLDParseLineSymbolizer(CPLXMLNode *psRoot, layerObj *psLayer,
-                             int bNewClass, const char* pszUserStyleName);
+                             int bNewClass, const char *pszUserStyleName);
 int msSLDParsePolygonSymbolizer(CPLXMLNode *psRoot, layerObj *psLayer,
-                                int bNewClass, const char* pszUserStyleName);
+                                int bNewClass, const char *pszUserStyleName);
 int msSLDParsePointSymbolizer(CPLXMLNode *psRoot, layerObj *psLayer,
-                              int bNewClass, const char* pszUserStyleName);
+                              int bNewClass, const char *pszUserStyleName);
 int msSLDParseTextSymbolizer(CPLXMLNode *psRoot, layerObj *psLayer,
-                             int bOtherSymboliser, const char* pszUserStyleName);
-int msSLDParseRasterSymbolizer(CPLXMLNode *psRoot, layerObj *psLayer, const char* pszUserStyleName);
+                             int bOtherSymboliser,
+                             const char *pszUserStyleName);
+int msSLDParseRasterSymbolizer(CPLXMLNode *psRoot, layerObj *psLayer,
+                               const char *pszUserStyleName);
 
-int msSLDParseGraphicFillOrStroke(CPLXMLNode *psGraphicFill,
-                                  char *pszDashValue,
+int msSLDParseGraphicFillOrStroke(CPLXMLNode *psGraphicFill, char *pszDashValue,
                                   styleObj *psStyle, mapObj *map);
 int msSLDParseExternalGraphic(CPLXMLNode *psExternalGraphic, styleObj *psStyle,
                               mapObj *map);
@@ -75,11 +79,13 @@ int msSLDParseExternalGraphic(CPLXMLNode
 int msSLDGetLineSymbol(mapObj *map);
 int msSLDGetDashLineSymbol(mapObj *map, char *pszDashArray);
 int msSLDGetMarkSymbol(mapObj *map, char *pszSymbolName, int bFilled);
-int msSLDGetGraphicSymbol(mapObj *map, char *pszFileName, char *extGraphicName, int nGap);
+int msSLDGetGraphicSymbol(mapObj *map, char *pszFileName, char *extGraphicName,
+                          int nGap);
 
 int msSLDSetColorObject(char *psHexColor, colorObj *psColor);
 
-int msSLDParseTextParams(CPLXMLNode *psRoot, layerObj *psLayer, classObj *psClass);
+int msSLDParseTextParams(CPLXMLNode *psRoot, layerObj *psLayer,
+                         classObj *psClass);
 int ParseTextPointPlacement(CPLXMLNode *psRoot, classObj *psClass);
 int ParseTextLinePlacement(CPLXMLNode *psRoot, classObj *psClass);
 
@@ -87,10 +93,12 @@ char *msSLDGenerateSLDLayer(layerObj *ps
 
 char *msSLDGetFilter(classObj *psClass, const char *pszWfsFilter);
 char *msSLDGenerateLineSLD(styleObj *psStyle, layerObj *psLayer, int nVersion);
-char *msSLDGeneratePolygonSLD(styleObj *psStyle, layerObj *psLayer, int nVersion);
+char *msSLDGeneratePolygonSLD(styleObj *psStyle, layerObj *psLayer,
+                              int nVersion);
 char *msSLDGeneratePointSLD(styleObj *psStyle, layerObj *psLayer, int nVersion);
 char *msSLDGenerateTextSLD(classObj *psClass, layerObj *psLayer, int nVersion);
-FilterEncodingNode *BuildExpressionTree(char *pszExpression, FilterEncodingNode *psNode);
+FilterEncodingNode *BuildExpressionTree(char *pszExpression,
+                                        FilterEncodingNode *psNode);
 
 #ifdef __cplusplus
 } /* extern C */
diff -pruN 8.0.1-5/mapogcsos.c 8.0.2-1/mapogcsos.c
--- 8.0.1-5/mapogcsos.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapogcsos.c	2024-06-11 20:41:34.000000000 +0000
@@ -49,12 +49,13 @@
 #include "libxml/xpath.h"
 #include "libxml/xpathInternals.h"
 
-const char *pszSOSVersion                = "1.0.0";
-const char *pszSOSNamespaceUri           = "http://www.opengis.net/sos/1.0";
-const char *pszSOSNamespacePrefix        = "sos";
-const char *pszOMNamespaceUri            = "http://www.opengis.net/om/1.0";
-const char *pszOMNamespacePrefix         = "om";
-const char *pszSOSDescribeSensorMimeType = "text/xml; subtype=\"sensorML/1.0.0\"";
+const char *pszSOSVersion = "1.0.0";
+const char *pszSOSNamespaceUri = "http://www.opengis.net/sos/1.0";
+const char *pszSOSNamespacePrefix = "sos";
+const char *pszOMNamespaceUri = "http://www.opengis.net/om/1.0";
+const char *pszOMNamespacePrefix = "om";
+const char *pszSOSDescribeSensorMimeType =
+    "text/xml; subtype=\"sensorML/1.0.0\"";
 const char *pszSOSGetObservationMimeType = "text/xml; subtype=\"om/1.0.0\"";
 
 typedef struct {
@@ -62,7 +63,8 @@ typedef struct {
   xmlNodePtr psResultNode;
 } SOSProcedureNode;
 
-int msSOSParseRequest(mapObj *map, cgiRequestObj *request, sosParamsObj *sosparams);
+int msSOSParseRequest(mapObj *map, cgiRequestObj *request,
+                      sosParamsObj *sosparams);
 void msSOSFreeParamsObj(sosParamsObj *sosparams);
 
 /*
@@ -74,31 +76,34 @@ void msSOSFreeParamsObj(sosParamsObj *so
 **
 */
 
-static int msSOSException(mapObj *map, char *locator, char *exceptionCode)
-{
+static int msSOSException(mapObj *map, char *locator, char *exceptionCode) {
   int size = 0;
-  char *errorString     = NULL;
+  char *errorString = NULL;
   char *schemasLocation = NULL;
 
-  xmlDocPtr  psDoc      = NULL;
+  xmlDocPtr psDoc = NULL;
   xmlNodePtr psRootNode = NULL;
-  xmlNsPtr   psNsOws    = NULL;
-  xmlChar *buffer       = NULL;
+  xmlNsPtr psNsOws = NULL;
+  xmlChar *buffer = NULL;
 
-  psNsOws = xmlNewNs(NULL, BAD_CAST "http://www.opengis.net/ows/1.1", BAD_CAST "ows");
+  psNsOws =
+      xmlNewNs(NULL, BAD_CAST "http://www.opengis.net/ows/1.1", BAD_CAST "ows");
 
   errorString = msGetErrorString("\n");
   schemasLocation = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
 
   psDoc = xmlNewDoc(BAD_CAST "1.0");
 
-  psRootNode = msOWSCommonExceptionReport(psNsOws, OWS_1_1_0, schemasLocation, pszSOSVersion, msOWSGetLanguage(map, "exception"), exceptionCode, locator, errorString);
+  psRootNode = msOWSCommonExceptionReport(
+      psNsOws, OWS_1_1_0, schemasLocation, pszSOSVersion,
+      msOWSGetLanguage(map, "exception"), exceptionCode, locator, errorString);
 
   xmlDocSetRootElement(psDoc, psRootNode);
 
-  xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/ows/1.1", BAD_CAST "ows");
+  xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/ows/1.1",
+           BAD_CAST "ows");
 
-  msIO_setHeader("Content-Type","text/xml; charset=UTF-8");
+  msIO_setHeader("Content-Type", "text/xml; charset=UTF-8");
   msIO_sendHeaders();
 
   xmlDocDumpFormatMemoryEnc(psDoc, &buffer, &size, ("UTF-8"), 1);
@@ -119,18 +124,18 @@ static int msSOSException(mapObj *map, c
   */
   {
     errorObj *err = msGetErrorObj();
-    if( err != NULL && err->code != MS_NOERR )
+    if (err != NULL && err->code != MS_NOERR)
       err->isreported = MS_TRUE;
   }
 
   return MS_FAILURE;
 }
 
-static int _IsInList(char **papsProcedures, int nDistinctProcedures, char *pszProcedure)
-{
+static int _IsInList(char **papsProcedures, int nDistinctProcedures,
+                     char *pszProcedure) {
   int i = 0;
   if (papsProcedures && nDistinctProcedures > 0 && pszProcedure) {
-    for (i=0; i<nDistinctProcedures; i++) {
+    for (i = 0; i < nDistinctProcedures; i++) {
       if (papsProcedures[i] && strcmp(papsProcedures[i], pszProcedure) == 0)
         return 1;
     }
@@ -144,14 +149,12 @@ static int _IsInList(char **papsProcedur
 /*      Look if the filter's property names have an equivalent          */
 /*      layre's attribute.                                              */
 /************************************************************************/
-static int msSOSValidateFilter(FilterEncodingNode *psFilterNode,
-                               layerObj *lp)
-{
-  int i=0, bFound =0;
+static int msSOSValidateFilter(FilterEncodingNode *psFilterNode, layerObj *lp) {
+  int i = 0, bFound = 0;
   /* assuming here that the layer is opened*/
   if (psFilterNode && lp) {
     if (psFilterNode->eType == FILTER_NODE_TYPE_PROPERTYNAME) {
-      for (i=0; i<lp->numitems; i++) {
+      for (i = 0; i < lp->numitems; i++) {
         if (strcasecmp(lp->items[i], psFilterNode->pszValue) == 0) {
           bFound = 1;
           break;
@@ -160,11 +163,13 @@ static int msSOSValidateFilter(FilterEnc
       if (!bFound)
         return MS_FALSE;
     }
-    if (psFilterNode->psLeftNode && psFilterNode->eType != FILTER_NODE_TYPE_SPATIAL) {
+    if (psFilterNode->psLeftNode &&
+        psFilterNode->eType != FILTER_NODE_TYPE_SPATIAL) {
       if (msSOSValidateFilter(psFilterNode->psLeftNode, lp) == MS_FALSE)
         return MS_FALSE;
     }
-    if (psFilterNode->psRightNode && psFilterNode->eType != FILTER_NODE_TYPE_SPATIAL) {
+    if (psFilterNode->psRightNode &&
+        psFilterNode->eType != FILTER_NODE_TYPE_SPATIAL) {
       if (msSOSValidateFilter(psFilterNode->psRightNode, lp) == MS_FALSE)
         return MS_FALSE;
     }
@@ -173,8 +178,6 @@ static int msSOSValidateFilter(FilterEnc
   return MS_TRUE;
 }
 
-
-
 /************************************************************************/
 /*                        msSOSAddMetadataChildNode                     */
 /*                                                                      */
@@ -184,8 +187,7 @@ void msSOSAddMetadataChildNode(xmlNodePt
                                xmlNsPtr psNs, hashTableObj *metadata,
                                const char *psNamespaces,
                                const char *psMetadataName,
-                               const char *psDefaultValue)
-{
+                               const char *psDefaultValue) {
   xmlNodePtr psNode = NULL;
   char *psValue = NULL;
 
@@ -193,36 +195,34 @@ void msSOSAddMetadataChildNode(xmlNodePt
     psValue = msOWSGetEncodeMetadata(metadata, psNamespaces, psMetadataName,
                                      psDefaultValue);
     if (psValue) {
-      psNode = xmlNewChild(psParent, NULL, BAD_CAST psNodeName, BAD_CAST psValue);
+      psNode =
+          xmlNewChild(psParent, NULL, BAD_CAST psNodeName, BAD_CAST psValue);
       if (psNs)
-        xmlSetNs(psNode,  psNs);
+        xmlSetNs(psNode, psNs);
       free(psValue);
     }
   }
 }
 
-
 /************************************************************************/
 /*                      msSOSGetFirstLayerForOffering                   */
 /*                                                                      */
 /*      return the first layer for the offering.                        */
 /************************************************************************/
 layerObj *msSOSGetFirstLayerForOffering(mapObj *map, const char *pszOffering,
-                                        const char *pszProperty)
-{
+                                        const char *pszProperty) {
   layerObj *lp = NULL;
   const char *pszTmp = NULL;
   int i = 0;
 
   if (pszOffering && map) {
-    for (i=0; i<map->numlayers; i++) {
-      pszTmp =
-        msOWSLookupMetadata(&(GET_LAYER(map, i)->metadata), "S", "offering_id");
+    for (i = 0; i < map->numlayers; i++) {
+      pszTmp = msOWSLookupMetadata(&(GET_LAYER(map, i)->metadata), "S",
+                                   "offering_id");
       if (pszTmp && (strcasecmp(pszTmp, pszOffering) == 0)) {
         if (pszProperty) {
-          pszTmp =
-            msOWSLookupMetadata(&(GET_LAYER(map, i)->metadata), "S",
-                                "observedproperty_id");
+          pszTmp = msOWSLookupMetadata(&(GET_LAYER(map, i)->metadata), "S",
+                                       "observedproperty_id");
           if (pszTmp && (strcasecmp(pszTmp, pszProperty) == 0)) {
             lp = (GET_LAYER(map, i));
             break;
@@ -237,15 +237,15 @@ layerObj *msSOSGetFirstLayerForOffering(
   return lp;
 }
 
-xmlNodePtr msSOSAddTimeNode(xmlNsPtr psNs, xmlNsPtr psNsGml, char *pszStart, char *pszEnd)
-{
-  xmlNodePtr psNode=NULL;
+xmlNodePtr msSOSAddTimeNode(xmlNsPtr psNs, xmlNsPtr psNsGml, char *pszStart,
+                            char *pszEnd) {
+  xmlNodePtr psNode = NULL;
 
-  char *timeel= NULL;
+  char *timeel = NULL;
 
-  if (strcmp((char *)psNs->prefix,"sos") == 0)
+  if (strcmp((char *)psNs->prefix, "sos") == 0)
     timeel = "time";
-  if (strcmp((char *)psNs->prefix,"om") == 0)
+  if (strcmp((char *)psNs->prefix, "om") == 0)
     timeel = "samplingTime";
   else
     timeel = "time";
@@ -255,23 +255,25 @@ xmlNodePtr msSOSAddTimeNode(xmlNsPtr psN
   return psNode;
 }
 
-void msSOSAddPropertyNode(xmlNsPtr psNsSwe, xmlNsPtr psNsXLink, xmlNodePtr psParent, layerObj *lp, xmlNsPtr psNsGml, char *pszCompositePhenomenonId)
-{
+void msSOSAddPropertyNode(xmlNsPtr psNsSwe, xmlNsPtr psNsXLink,
+                          xmlNodePtr psParent, layerObj *lp, xmlNsPtr psNsGml,
+                          char *pszCompositePhenomenonId) {
   const char *pszValue = NULL;
   char *pszTmpVal = NULL, *pszFullName = NULL;
   xmlNodePtr psCompNode, psNode;
-  int i, j=0;
+  int i, j = 0;
   char szTmp[256];
   const char *pszComponentBase = "urn:ogc:def:property:";
 
   if (psParent && lp) {
     psNode = xmlNewChild(psParent, NULL, BAD_CAST "observedProperty", NULL);
-    psCompNode = xmlNewChild(psNode, psNsSwe, BAD_CAST "CompositePhenomenon", NULL);
-    pszValue = msOWSLookupMetadata(&(lp->metadata), "S",
-                                   "observedproperty_id");
+    psCompNode =
+        xmlNewChild(psNode, psNsSwe, BAD_CAST "CompositePhenomenon", NULL);
+    pszValue = msOWSLookupMetadata(&(lp->metadata), "S", "observedproperty_id");
     pszTmpVal = msStrdup(pszValue);
 
-    if (pszCompositePhenomenonId != NULL) { /* unique value needs to be constructed */
+    if (pszCompositePhenomenonId !=
+        NULL) { /* unique value needs to be constructed */
       pszTmpVal = msStringConcatenate(pszTmpVal, "_");
       pszTmpVal = msStringConcatenate(pszTmpVal, pszCompositePhenomenonId);
     }
@@ -281,17 +283,18 @@ void msSOSAddPropertyNode(xmlNsPtr psNsS
       msFree(pszTmpVal);
     }
 
-    pszValue = msOWSLookupMetadata(&(lp->metadata), "S",
-                                   "observedproperty_name");
+    pszValue =
+        msOWSLookupMetadata(&(lp->metadata), "S", "observedproperty_name");
     if (pszValue)
-      (void) xmlNewTextChild(psCompNode, psNsGml,
-                           BAD_CAST "name", BAD_CAST pszValue);
+      (void)xmlNewTextChild(psCompNode, psNsGml, BAD_CAST "name",
+                            BAD_CAST pszValue);
 
     /* add components */
 
     /*assuming that the layer is opened and msLayerGetItems called*/
-    for(i=0; i<lp->numitems; i++) {
-      pszValue = msOWSLookupMetadata(&(lp->metadata), "S", "observedproperty_authority");
+    for (i = 0; i < lp->numitems; i++) {
+      pszValue = msOWSLookupMetadata(&(lp->metadata), "S",
+                                     "observedproperty_authority");
 
       if (pszValue)
         pszTmpVal = msStrdup(pszValue);
@@ -306,7 +309,8 @@ void msSOSAddPropertyNode(xmlNsPtr psNsS
 
       pszFullName = msStringConcatenate(pszFullName, ":");
 
-      pszValue = msOWSLookupMetadata(&(lp->metadata), "S", "observedproperty_version");
+      pszValue =
+          msOWSLookupMetadata(&(lp->metadata), "S", "observedproperty_version");
 
       if (pszValue)
         pszTmpVal = msStrdup(pszValue);
@@ -349,179 +353,185 @@ void msSOSAddPropertyNode(xmlNsPtr psNsS
 /*      from gmlWriteGeometry_GML2. Should be merged at one point if    */
 /*      possible.                                                       */
 /************************************************************************/
-void  msSOSAddGeometryNode(xmlNsPtr psNsGml, xmlNsPtr psNsMs, xmlNodePtr psParent, mapObj *map, layerObj *lp, shapeObj *psShape,
-                           const char *pszEpsg_in)
-{
+void msSOSAddGeometryNode(xmlNsPtr psNsGml, xmlNsPtr psNsMs,
+                          xmlNodePtr psParent, mapObj *map, layerObj *lp,
+                          shapeObj *psShape, const char *pszEpsg_in) {
   char *pszTmp = NULL;
-  int i,j = 0;
+  int i, j = 0;
   xmlNodePtr psPointNode, psNode, psLineNode, psPolygonNode;
   int *panOuterList = NULL, *panInnerList = NULL;
   const char *pszEpsg = pszEpsg_in;
   char *pszEpsg_buf = NULL;
-  
 
   if (psParent && psShape) {
     if (msProjectionsDiffer(&map->projection, &lp->projection) == MS_TRUE) {
-      if( lp->reprojectorLayerToMap == NULL )
-      {
-        lp->reprojectorLayerToMap = msProjectCreateReprojector(
-            &lp->projection, &map->projection);
-      }
-      if( lp->reprojectorLayerToMap )
-      {
-        msProjectShapeEx(lp->reprojectorLayerToMap, psShape);
+      reprojectionObj *reprojector = msLayerGetReprojectorToMap(lp, map);
+      if (reprojector) {
+        msProjectShapeEx(reprojector, psShape);
       }
-      msOWSGetEPSGProj(&(map->projection), &(lp->metadata), "SO", MS_TRUE, &pszEpsg_buf);
+      msOWSGetEPSGProj(&(map->projection), &(lp->metadata), "SO", MS_TRUE,
+                       &pszEpsg_buf);
       pszEpsg = pszEpsg_buf;
     }
-    switch(psShape->type) {
-      case(MS_SHAPE_POINT):
-        psNode = xmlNewChild(psParent, NULL, BAD_CAST "msGeometry", NULL);
-        xmlSetNs(psNode, psNsMs);
-        if (psShape->line[0].numpoints > 1) {
-          psPointNode = xmlNewChild(psNode, NULL, BAD_CAST "MultiPoint", NULL);
-          xmlSetNs(psPointNode, psNsGml);
-
-          if (pszEpsg)
-            xmlNewProp(psPointNode, BAD_CAST "srsName", BAD_CAST pszEpsg);
-        } else
-          psPointNode= psNode;
-
-        /*add all points */
-        for(i=0; i<psShape->line[0].numpoints; i++) {
-          psNode = xmlAddChild(psPointNode, msGML3Point(psNsGml, pszEpsg, NULL, psShape->line[0].point[i].x, psShape->line[0].point[i].y));
-        }
-        break;
+    switch (psShape->type) {
+    case (MS_SHAPE_POINT):
+      psNode = xmlNewChild(psParent, NULL, BAD_CAST "msGeometry", NULL);
+      xmlSetNs(psNode, psNsMs);
+      if (psShape->line[0].numpoints > 1) {
+        psPointNode = xmlNewChild(psNode, NULL, BAD_CAST "MultiPoint", NULL);
+        xmlSetNs(psPointNode, psNsGml);
+
+        if (pszEpsg)
+          xmlNewProp(psPointNode, BAD_CAST "srsName", BAD_CAST pszEpsg);
+      } else
+        psPointNode = psNode;
+
+      /*add all points */
+      for (i = 0; i < psShape->line[0].numpoints; i++) {
+        psNode =
+            xmlAddChild(psPointNode, msGML3Point(psNsGml, pszEpsg, NULL,
+                                                 psShape->line[0].point[i].x,
+                                                 psShape->line[0].point[i].y));
+      }
+      break;
 
-      case(MS_SHAPE_LINE):
-        psNode = xmlNewChild(psParent, NULL, BAD_CAST "msGeometry", NULL);
-        xmlSetNs(psNode,xmlNewNs(psNode, NULL,  NULL));
-        if (psShape->numlines > 1) {
-          psLineNode = xmlNewChild(psNode, NULL, BAD_CAST "MultiLineString", NULL);
-          xmlSetNs(psLineNode,xmlNewNs(psLineNode,
-                                       BAD_CAST "http://www.opengis.net/gml",
-                                       BAD_CAST "gml"));
-
-          if (pszEpsg)
-            xmlNewProp(psLineNode, BAD_CAST "srsName", BAD_CAST pszEpsg);
-        } else
-          psLineNode= psNode;
-
-        for(i=0; i<psShape->numlines; i++) {
-          if (psShape->numlines > 1) {
-            psNode = xmlNewChild(psLineNode, NULL, BAD_CAST "lineStringMember", NULL);
-            xmlSetNs(psNode,xmlNewNs(psNode,
-                                     BAD_CAST "http://www.opengis.net/gml",
-                                     BAD_CAST "gml"));
-            psNode = xmlNewChild(psNode, NULL, BAD_CAST "LineString", NULL);
-            xmlSetNs(psNode,xmlNewNs(psNode,
-                                     BAD_CAST "http://www.opengis.net/gml",
-                                     BAD_CAST "gml"));
-          } else {
-            psNode = xmlNewChild(psLineNode, NULL, BAD_CAST "LineString", NULL);
-            xmlSetNs(psNode,xmlNewNs(psNode,
-                                     BAD_CAST "http://www.opengis.net/gml",
-                                     BAD_CAST "gml"));
-          }
-          if (pszEpsg)
-            xmlNewProp(psNode, BAD_CAST "srsName", BAD_CAST pszEpsg);
+    case (MS_SHAPE_LINE):
+      psNode = xmlNewChild(psParent, NULL, BAD_CAST "msGeometry", NULL);
+      xmlSetNs(psNode, xmlNewNs(psNode, NULL, NULL));
+      if (psShape->numlines > 1) {
+        psLineNode =
+            xmlNewChild(psNode, NULL, BAD_CAST "MultiLineString", NULL);
+        xmlSetNs(psLineNode,
+                 xmlNewNs(psLineNode, BAD_CAST "http://www.opengis.net/gml",
+                          BAD_CAST "gml"));
+
+        if (pszEpsg)
+          xmlNewProp(psLineNode, BAD_CAST "srsName", BAD_CAST pszEpsg);
+      } else
+        psLineNode = psNode;
 
-          pszTmp = NULL;
-          for(j=0; j<psShape->line[i].numpoints; j++) {
-            char *doubleTmp = msDoubleToString(psShape->line[i].point[j].x, MS_TRUE);
-            pszTmp = msStringConcatenate(pszTmp, doubleTmp);
-            pszTmp = msStringConcatenate(pszTmp, ",");
-            free(doubleTmp);
-            doubleTmp = msDoubleToString(psShape->line[i].point[j].y, MS_TRUE);
-            pszTmp = msStringConcatenate(pszTmp, doubleTmp);
-            pszTmp = msStringConcatenate(pszTmp, ",");
-            free(doubleTmp);
-          }
-          psNode = xmlNewChild(psNode, NULL, BAD_CAST "coordinates", BAD_CAST pszTmp);
-          xmlSetNs(psNode,xmlNewNs(psNode, BAD_CAST "http://www.opengis.net/gml", BAD_CAST "gml"));
-          free(pszTmp);
+      for (i = 0; i < psShape->numlines; i++) {
+        if (psShape->numlines > 1) {
+          psNode =
+              xmlNewChild(psLineNode, NULL, BAD_CAST "lineStringMember", NULL);
+          xmlSetNs(psNode,
+                   xmlNewNs(psNode, BAD_CAST "http://www.opengis.net/gml",
+                            BAD_CAST "gml"));
+          psNode = xmlNewChild(psNode, NULL, BAD_CAST "LineString", NULL);
+          xmlSetNs(psNode,
+                   xmlNewNs(psNode, BAD_CAST "http://www.opengis.net/gml",
+                            BAD_CAST "gml"));
+        } else {
+          psNode = xmlNewChild(psLineNode, NULL, BAD_CAST "LineString", NULL);
+          xmlSetNs(psNode,
+                   xmlNewNs(psNode, BAD_CAST "http://www.opengis.net/gml",
+                            BAD_CAST "gml"));
         }
+        if (pszEpsg)
+          xmlNewProp(psNode, BAD_CAST "srsName", BAD_CAST pszEpsg);
 
-        break;
+        pszTmp = NULL;
+        for (j = 0; j < psShape->line[i].numpoints; j++) {
+          char *doubleTmp =
+              msDoubleToString(psShape->line[i].point[j].x, MS_TRUE);
+          pszTmp = msStringConcatenate(pszTmp, doubleTmp);
+          pszTmp = msStringConcatenate(pszTmp, ",");
+          free(doubleTmp);
+          doubleTmp = msDoubleToString(psShape->line[i].point[j].y, MS_TRUE);
+          pszTmp = msStringConcatenate(pszTmp, doubleTmp);
+          pszTmp = msStringConcatenate(pszTmp, ",");
+          free(doubleTmp);
+        }
+        psNode =
+            xmlNewChild(psNode, NULL, BAD_CAST "coordinates", BAD_CAST pszTmp);
+        xmlSetNs(psNode, xmlNewNs(psNode, BAD_CAST "http://www.opengis.net/gml",
+                                  BAD_CAST "gml"));
+        free(pszTmp);
+      }
 
-      case(MS_SHAPE_POLYGON):
-        psNode = xmlNewChild(psParent, NULL, BAD_CAST "msGeometry", NULL);
-        xmlSetNs(psNode,xmlNewNs(psNode, NULL,  NULL));
-        if (psShape->numlines > 1) {
-          psPolygonNode = xmlNewChild(psNode, NULL, BAD_CAST "MultiPolygon", NULL);
-          xmlSetNs(psPolygonNode,
-                   xmlNewNs(psPolygonNode, BAD_CAST "http://www.opengis.net/gml",
-                            BAD_CAST "gml"));
+      break;
 
-          if (pszEpsg)
-            xmlNewProp(psPolygonNode, BAD_CAST "srsName", BAD_CAST pszEpsg);
-        } else
-          psPolygonNode= psNode;
-
-        panOuterList = msGetOuterList(psShape);
-
-        for(i=0; i<psShape->numlines; i++) {
-          if(panOuterList[i] != MS_TRUE)
-            continue;
-
-          panInnerList = msGetInnerList(psShape, i, panOuterList);
-
-          if (psShape->numlines > 1) {
-            psNode = xmlNewChild(psPolygonNode, NULL, BAD_CAST "polygonMember", NULL);
-            xmlSetNs(psNode,xmlNewNs(psNode, BAD_CAST "http://www.opengis.net/gml",
-                                     BAD_CAST "gml"));
-            psNode = xmlNewChild(psNode, NULL, BAD_CAST "Polygon", NULL);
-            xmlSetNs(psNode,xmlNewNs(psNode, BAD_CAST "http://www.opengis.net/gml",
-                                     BAD_CAST "gml"));
-          } else {
-            psNode = xmlNewChild(psPolygonNode, NULL, BAD_CAST "Polygon", NULL);
-            xmlSetNs(psNode,xmlNewNs(psNode, BAD_CAST "http://www.opengis.net/gml",
-                                     BAD_CAST "gml"));
-          }
-          if (pszEpsg)
-            xmlNewProp(psNode, BAD_CAST "srsName", BAD_CAST pszEpsg);
-
-          psNode = xmlNewChild(psNode, NULL, BAD_CAST "outerBoundaryIs", NULL);
-          xmlSetNs(psNode,xmlNewNs(psNode, BAD_CAST "http://www.opengis.net/gml",
-                                   BAD_CAST "gml"));
-          psNode = xmlNewChild(psNode, NULL, BAD_CAST "LinearRing", NULL);
-          xmlSetNs(psNode,xmlNewNs(psNode, BAD_CAST "http://www.opengis.net/gml",
-                                   BAD_CAST "gml"));
+    case (MS_SHAPE_POLYGON):
+      psNode = xmlNewChild(psParent, NULL, BAD_CAST "msGeometry", NULL);
+      xmlSetNs(psNode, xmlNewNs(psNode, NULL, NULL));
+      if (psShape->numlines > 1) {
+        psPolygonNode =
+            xmlNewChild(psNode, NULL, BAD_CAST "MultiPolygon", NULL);
+        xmlSetNs(psPolygonNode,
+                 xmlNewNs(psPolygonNode, BAD_CAST "http://www.opengis.net/gml",
+                          BAD_CAST "gml"));
+
+        if (pszEpsg)
+          xmlNewProp(psPolygonNode, BAD_CAST "srsName", BAD_CAST pszEpsg);
+      } else
+        psPolygonNode = psNode;
+
+      panOuterList = msGetOuterList(psShape);
+
+      for (i = 0; i < psShape->numlines; i++) {
+        if (panOuterList[i] != MS_TRUE)
+          continue;
 
-          pszTmp = NULL;
-          for(j=0; j<psShape->line[i].numpoints; j++) {
-            char *doubleTmp;
-            doubleTmp = msDoubleToString(psShape->line[i].point[j].x, MS_TRUE);
-            pszTmp = msStringConcatenate(pszTmp, doubleTmp);
-            pszTmp = msStringConcatenate(pszTmp, ",");
-            free(doubleTmp);
-            doubleTmp = msDoubleToString(psShape->line[i].point[j].y, MS_TRUE);
-            pszTmp = msStringConcatenate(pszTmp, doubleTmp);
-            pszTmp = msStringConcatenate(pszTmp, " ");
-            free(doubleTmp);
-          }
-          psNode = xmlNewChild(psNode, NULL, BAD_CAST "coordinates", BAD_CAST pszTmp);
-          xmlSetNs(psNode,xmlNewNs(psNode,
-                                   BAD_CAST "http://www.opengis.net/gml",
-                                   BAD_CAST "gml"));
-          free(pszTmp);
+        panInnerList = msGetInnerList(psShape, i, panOuterList);
 
-          if (panInnerList)
-            free(panInnerList);
+        if (psShape->numlines > 1) {
+          psNode =
+              xmlNewChild(psPolygonNode, NULL, BAD_CAST "polygonMember", NULL);
+          xmlSetNs(psNode,
+                   xmlNewNs(psNode, BAD_CAST "http://www.opengis.net/gml",
+                            BAD_CAST "gml"));
+          psNode = xmlNewChild(psNode, NULL, BAD_CAST "Polygon", NULL);
+          xmlSetNs(psNode,
+                   xmlNewNs(psNode, BAD_CAST "http://www.opengis.net/gml",
+                            BAD_CAST "gml"));
+        } else {
+          psNode = xmlNewChild(psPolygonNode, NULL, BAD_CAST "Polygon", NULL);
+          xmlSetNs(psNode,
+                   xmlNewNs(psNode, BAD_CAST "http://www.opengis.net/gml",
+                            BAD_CAST "gml"));
         }
+        if (pszEpsg)
+          xmlNewProp(psNode, BAD_CAST "srsName", BAD_CAST pszEpsg);
 
-        if (panOuterList)
-          free(panOuterList);
+        psNode = xmlNewChild(psNode, NULL, BAD_CAST "outerBoundaryIs", NULL);
+        xmlSetNs(psNode, xmlNewNs(psNode, BAD_CAST "http://www.opengis.net/gml",
+                                  BAD_CAST "gml"));
+        psNode = xmlNewChild(psNode, NULL, BAD_CAST "LinearRing", NULL);
+        xmlSetNs(psNode, xmlNewNs(psNode, BAD_CAST "http://www.opengis.net/gml",
+                                  BAD_CAST "gml"));
+
+        pszTmp = NULL;
+        for (j = 0; j < psShape->line[i].numpoints; j++) {
+          char *doubleTmp;
+          doubleTmp = msDoubleToString(psShape->line[i].point[j].x, MS_TRUE);
+          pszTmp = msStringConcatenate(pszTmp, doubleTmp);
+          pszTmp = msStringConcatenate(pszTmp, ",");
+          free(doubleTmp);
+          doubleTmp = msDoubleToString(psShape->line[i].point[j].y, MS_TRUE);
+          pszTmp = msStringConcatenate(pszTmp, doubleTmp);
+          pszTmp = msStringConcatenate(pszTmp, " ");
+          free(doubleTmp);
+        }
+        psNode =
+            xmlNewChild(psNode, NULL, BAD_CAST "coordinates", BAD_CAST pszTmp);
+        xmlSetNs(psNode, xmlNewNs(psNode, BAD_CAST "http://www.opengis.net/gml",
+                                  BAD_CAST "gml"));
+        free(pszTmp);
 
-        break;
+        if (panInnerList)
+          free(panInnerList);
+      }
 
-      default:
-        break;
-    }
+      if (panOuterList)
+        free(panOuterList);
 
+      break;
+
+    default:
+      break;
+    }
   }
   msFree(pszEpsg_buf);
-
 }
 
 /************************************************************************/
@@ -530,15 +540,16 @@ void  msSOSAddGeometryNode(xmlNsPtr psNs
 /*                                                                      */
 /*      Add a databalock used for GetObservation request.               */
 /************************************************************************/
-void msSOSAddDataBlockDefinition(xmlNsPtr psNsSwe, xmlNodePtr psParent, layerObj *lp)
-{
+void msSOSAddDataBlockDefinition(xmlNsPtr psNsSwe, xmlNodePtr psParent,
+                                 layerObj *lp) {
   xmlNodePtr psNode, psRecordNode, psCompNode, psSubNode, psEncNode;
-  const char *pszDefinition = NULL, *pszUom=NULL, *pszValue=NULL, *pszName=NULL;
+  const char *pszDefinition = NULL, *pszUom = NULL, *pszValue = NULL,
+             *pszName = NULL;
   char szTmp[100];
-  int i=0;
+  int i = 0;
   char *pszTokenValue = NULL;
   char *pszBlockValue = NULL;
-  const char *pszBlockSep=NULL, *pszTokenSep=NULL;
+  const char *pszBlockSep = NULL, *pszTokenSep = NULL;
 
   if (psParent) {
     psNode = xmlNewChild(psParent, NULL, BAD_CAST "DataBlockDefinition", NULL);
@@ -556,11 +567,12 @@ void msSOSAddDataBlockDefinition(xmlNsPt
       psNode = xmlNewChild(psRecordNode, NULL, BAD_CAST "field", NULL);
       xmlNewNsProp(psNode, NULL, BAD_CAST "name", BAD_CAST "time");
       psNode = xmlNewChild(psNode, NULL, BAD_CAST "Time", NULL);
-      xmlNewNsProp(psNode, NULL, BAD_CAST "definition", BAD_CAST "urn:ogc:phenomenon:time:iso8601");
+      xmlNewNsProp(psNode, NULL, BAD_CAST "definition",
+                   BAD_CAST "urn:ogc:phenomenon:time:iso8601");
     }
     /*add all other fields*/
     /*assuming that the layer is open */
-    for(i=0; i<lp->numitems; i++) {
+    for (i = 0; i < lp->numitems; i++) {
       snprintf(szTmp, sizeof(szTmp), "%s_alias", lp->items[i]);
       pszValue = msOWSLookupMetadata(&(lp->metadata), "S", szTmp);
       if (pszValue) {
@@ -578,22 +590,22 @@ void msSOSAddDataBlockDefinition(xmlNsPt
 
         /* get definition and uom */
         snprintf(szTmp, sizeof(szTmp), "%s_definition", lp->items[i]);
-        pszDefinition =  msOWSLookupMetadata(&(lp->metadata), "S", szTmp);
+        pszDefinition = msOWSLookupMetadata(&(lp->metadata), "S", szTmp);
 
         if (pszDefinition == NULL)
           pszDefinition = "urn:ogc:object:definition";
 
-        xmlNewNsProp(psNode, NULL, BAD_CAST "definition", BAD_CAST pszDefinition);
+        xmlNewNsProp(psNode, NULL, BAD_CAST "definition",
+                     BAD_CAST pszDefinition);
 
         snprintf(szTmp, sizeof(szTmp), "%s_uom", lp->items[i]);
-        pszUom =  msOWSLookupMetadata(&(lp->metadata), "S", szTmp);
+        pszUom = msOWSLookupMetadata(&(lp->metadata), "S", szTmp);
 
         if (pszUom == NULL)
           pszUom = "urn:ogc:object:uom";
 
         psNode = xmlNewChild(psNode, NULL, BAD_CAST "uom", NULL);
         xmlNewNsProp(psNode, NULL, BAD_CAST "code", BAD_CAST pszUom);
-
       }
     }
 
@@ -612,14 +624,16 @@ void msSOSAddDataBlockDefinition(xmlNsPt
     else
       pszTokenValue = msStringConcatenate(pszTokenValue, ",");
 
-    xmlNewNsProp(psSubNode, NULL, BAD_CAST "tokenSeparator", BAD_CAST pszTokenValue);
+    xmlNewNsProp(psSubNode, NULL, BAD_CAST "tokenSeparator",
+                 BAD_CAST pszTokenValue);
 
     if (pszBlockSep)
       pszBlockValue = msStringConcatenate(pszBlockValue, (char *)pszBlockSep);
     else
       pszBlockValue = msStringConcatenate(pszBlockValue, "\n");
 
-    xmlNewNsProp(psSubNode, NULL, BAD_CAST "blockSeparator", BAD_CAST pszBlockValue);
+    xmlNewNsProp(psSubNode, NULL, BAD_CAST "blockSeparator",
+                 BAD_CAST pszBlockValue);
 
     xmlNewNsProp(psSubNode, NULL, BAD_CAST "decimalSeparator", BAD_CAST ".");
 
@@ -635,13 +649,15 @@ void msSOSAddDataBlockDefinition(xmlNsPt
 /*      Assuming that the layer is opened and msLayerGetItems is        */
 /*      called on it.                                                   */
 /************************************************************************/
-void msSOSAddMemberNode(xmlNsPtr psNsGml, xmlNsPtr psNsOm, xmlNsPtr psNsSwe, xmlNsPtr psNsXLink, xmlNsPtr psNsMs, xmlNodePtr psParent, mapObj *map, layerObj *lp,
-                        int iFeatureId, const char *script_url, const char *opLayerName)
-{
+void msSOSAddMemberNode(xmlNsPtr psNsGml, xmlNsPtr psNsOm, xmlNsPtr psNsSwe,
+                        xmlNsPtr psNsXLink, xmlNsPtr psNsMs,
+                        xmlNodePtr psParent, mapObj *map, layerObj *lp,
+                        int iFeatureId, const char *script_url,
+                        const char *opLayerName) {
   xmlNodePtr psObsNode, psNode, psLayerNode = NULL;
   const char *pszValue = NULL;
   char *pszEpsg = NULL;
-  int status,i,j;
+  int status, i, j;
   shapeObj sShape;
   char szTmp[256];
   layerObj *lpfirst = NULL;
@@ -650,31 +666,33 @@ void msSOSAddMemberNode(xmlNsPtr psNsGml
   char *pszOid = NULL;
   char *pszTime = NULL;
   char *pszValueShape = NULL;
-  const char *pszFeatureId  = NULL;
+  const char *pszFeatureId = NULL;
 
   if (psParent) {
     msInitShape(&sShape);
 
-    status = msLayerGetShape(lp, &sShape, &(lp->resultcache->results[iFeatureId]));
-    if(status != MS_SUCCESS) {
+    status =
+        msLayerGetShape(lp, &sShape, &(lp->resultcache->results[iFeatureId]));
+    if (status != MS_SUCCESS) {
       xmlFreeNs(psNsOm);
       return;
     }
 
     psNode = xmlNewChild(psParent, NULL, BAD_CAST "member", NULL);
 
-    psObsNode = xmlNewChild(psNode, NULL, BAD_CAST "Observation", BAD_CAST pszValue);
+    psObsNode =
+        xmlNewChild(psNode, NULL, BAD_CAST "Observation", BAD_CAST pszValue);
 
     pszFeatureId = msOWSLookupMetadata(&(lp->metadata), "OSG", "featureid");
 
-    if(pszFeatureId && msLayerGetItems(lp) == MS_SUCCESS) {
+    if (pszFeatureId && msLayerGetItems(lp) == MS_SUCCESS) {
       /* find the featureid amongst the items for this layer */
-      for(j=0; j<lp->numitems; j++) {
-        if(strcasecmp(lp->items[j], pszFeatureId) == 0) { /* found it  */
+      for (j = 0; j < lp->numitems; j++) {
+        if (strcasecmp(lp->items[j], pszFeatureId) == 0) { /* found it  */
           break;
         }
       }
-      if (j<lp->numitems) {
+      if (j < lp->numitems) {
         pszOid = msStringConcatenate(pszOid, "o_");
         pszOid = msStringConcatenate(pszOid, sShape.values[j]);
         xmlNewNsProp(psObsNode, psNsGml, BAD_CAST "id", BAD_CAST pszOid);
@@ -685,14 +703,14 @@ void msSOSAddMemberNode(xmlNsPtr psNsGml
      featureofinterest, result */
 
     /* time*/
-    pszTimeField =  msOWSLookupMetadata(&(lp->metadata), "SO",
-                                        "timeitem");
+    pszTimeField = msOWSLookupMetadata(&(lp->metadata), "SO", "timeitem");
     if (pszTimeField && sShape.values) {
-      for(i=0; i<lp->numitems; i++) {
+      for (i = 0; i < lp->numitems; i++) {
         if (strcasecmp(lp->items[i], pszTimeField) == 0) {
           if (sShape.values[i] && strlen(sShape.values[i]) > 0) {
             pszTime = msStringConcatenate(pszTime, sShape.values[i]);
-            psNode = xmlNewChild(psObsNode, psNsOm, BAD_CAST "samplingTime", NULL);
+            psNode =
+                xmlNewChild(psObsNode, psNsOm, BAD_CAST "samplingTime", NULL);
             xmlAddChild(psNode, msGML3TimeInstant(psNsGml, pszTime));
             msFree(pszTime);
           }
@@ -704,18 +722,18 @@ void msSOSAddMemberNode(xmlNsPtr psNsGml
 
     /*procedure*/
     /* if a procedure_item is defined, we should extract the value for the
-       attributes. If not dump what is found in the procedure metadata bug 2054*/
-    if ((pszValue =  msOWSLookupMetadata(&(lp->metadata), "S", "procedure_item"))) {
-      lpfirst = msSOSGetFirstLayerForOffering(map,
-                                              msOWSLookupMetadata(&(lp->metadata), "S",
-                                                  "offering_id"),
-                                              msOWSLookupMetadata(&(lp->metadata), "S",
-                                                  "observedproperty_id"));
+       attributes. If not dump what is found in the procedure metadata bug
+       2054*/
+    if ((pszValue =
+             msOWSLookupMetadata(&(lp->metadata), "S", "procedure_item"))) {
+      lpfirst = msSOSGetFirstLayerForOffering(
+          map, msOWSLookupMetadata(&(lp->metadata), "S", "offering_id"),
+          msOWSLookupMetadata(&(lp->metadata), "S", "observedproperty_id"));
 
       if (lp != lpfirst)
         status = msLayerOpen(lpfirst);
       if (status == MS_SUCCESS && msLayerGetItems(lpfirst) == MS_SUCCESS) {
-        for(i=0; i<lpfirst->numitems; i++) {
+        for (i = 0; i < lpfirst->numitems; i++) {
           if (strcasecmp(lpfirst->items[i], pszValue) == 0) {
             break;
           }
@@ -726,7 +744,7 @@ void msSOSAddMemberNode(xmlNsPtr psNsGml
           pszValueShape = msEncodeHTMLEntities(sShape.values[i]);
           pszTmp = msStringConcatenate(pszTmp, pszValueShape);
 
-          psNode =  xmlNewChild(psObsNode, NULL, BAD_CAST "procedure", NULL);
+          psNode = xmlNewChild(psObsNode, NULL, BAD_CAST "procedure", NULL);
           xmlNewNsProp(psNode, psNsXLink, BAD_CAST "href", BAD_CAST pszTmp);
           msFree(pszTmp);
           pszTmp = NULL;
@@ -737,23 +755,29 @@ void msSOSAddMemberNode(xmlNsPtr psNsGml
           msLayerClose(lpfirst);
       }
 
-    } else if ((pszValue = msOWSLookupMetadata(&(lp->metadata), "S", "procedure"))) {
-      if (! msOWSLookupMetadata(&(lp->metadata), "S", "procedure_item"))
-        xmlAddSibling(psNode, xmlNewComment(BAD_CAST "WARNING: Optional metadata \"sos_procedure_item\" missing for sos:procedure.  If you have more than 1 procedures, sos:procedure will output them incorrectly."));
+    } else if ((pszValue =
+                    msOWSLookupMetadata(&(lp->metadata), "S", "procedure"))) {
+      if (!msOWSLookupMetadata(&(lp->metadata), "S", "procedure_item"))
+        xmlAddSibling(
+            psNode,
+            xmlNewComment(
+                BAD_CAST
+                "WARNING: Optional metadata \"sos_procedure_item\" missing for "
+                "sos:procedure.  If you have more than 1 procedures, "
+                "sos:procedure will output them incorrectly."));
 
       snprintf(szTmp, sizeof(szTmp), "%s", "urn:ogc:def:procedure:");
       pszTmp = msStringConcatenate(pszTmp, szTmp);
       pszTmp = msStringConcatenate(pszTmp, (char *)pszValue);
 
-      psNode =  xmlNewChild(psObsNode, NULL, BAD_CAST "procedure", NULL);
+      psNode = xmlNewChild(psObsNode, NULL, BAD_CAST "procedure", NULL);
       xmlNewNsProp(psNode, psNsXLink, BAD_CAST "href", BAD_CAST pszTmp);
       msFree(pszTmp);
       pszTmp = NULL;
     }
 
     /*observed property*/
-    pszValue = msOWSLookupMetadata(&(lp->metadata), "S",
-                                   "observedproperty_id");
+    pszValue = msOWSLookupMetadata(&(lp->metadata), "S", "observedproperty_id");
     if (pszValue)
       msSOSAddPropertyNode(psNsSwe, psNsXLink, psObsNode, lp, psNsGml, pszOid);
     msFree(pszOid);
@@ -761,15 +785,17 @@ void msSOSAddMemberNode(xmlNsPtr psNsGml
 
     /*TODO add featureofinterest*/
 
-    pszTmp = msStringConcatenate(pszTmp, (char *) script_url);
-    pszTmp = msStringConcatenate(pszTmp, "service=WFS&version=1.1.0&request=DescribeFeatureType&typename=");
-    pszTmp = msStringConcatenate(pszTmp, (char *) opLayerName);
+    pszTmp = msStringConcatenate(pszTmp, (char *)script_url);
+    pszTmp = msStringConcatenate(
+        pszTmp,
+        "service=WFS&version=1.1.0&request=DescribeFeatureType&typename=");
+    pszTmp = msStringConcatenate(pszTmp, (char *)opLayerName);
 
-    psNode =  xmlNewChild(psObsNode, psNsOm, BAD_CAST "featureOfInterest", NULL);
+    psNode = xmlNewChild(psObsNode, psNsOm, BAD_CAST "featureOfInterest", NULL);
     xmlNewNsProp(psNode, psNsXLink, BAD_CAST "href", BAD_CAST pszTmp);
 
     msFree(pszTmp);
-    pszTmp=NULL;
+    pszTmp = NULL;
 
     /* add result : gml:featureMember of all selected elements */
     psNode = xmlNewChild(psObsNode, NULL, BAD_CAST "result", NULL);
@@ -777,22 +803,16 @@ void msSOSAddMemberNode(xmlNsPtr psNsGml
     /*TODO should we add soemwhere the units of the value :
       <om:result uom="units.xml#cm">29.00</om:result> */
 
-
-    if(msProjectionsDiffer(&(lp->projection), &(map->projection)))
-    {
-      if( lp->reprojectorLayerToMap == NULL )
-      {
-        lp->reprojectorLayerToMap = msProjectCreateReprojector(
-            &lp->projection, &map->projection);
-      }
-      if( lp->reprojectorLayerToMap )
-      {
-        msProjectShapeEx(lp->reprojectorLayerToMap, &sShape);
+    if (msProjectionsDiffer(&(lp->projection), &(map->projection))) {
+      reprojectionObj *reprojector = msLayerGetReprojectorToMap(lp, map);
+      if (reprojector) {
+        msProjectShapeEx(reprojector, &sShape);
       }
     }
 
     psNode = xmlNewChild(psNode, psNsGml, BAD_CAST "featureMember", NULL);
-    /* xmlSetNs(psNode,xmlNewNs(psNode, BAD_CAST "http://www.opengis.net/gml", BAD_CAST "gml")); */
+    /* xmlSetNs(psNode,xmlNewNs(psNode, BAD_CAST "http://www.opengis.net/gml",
+     * BAD_CAST "gml")); */
 
     /*TODO : add namespaces like wfs " ms and a url to mapserve ? */
     psLayerNode = xmlNewChild(psNode, psNsMs, BAD_CAST lp->name, NULL);
@@ -801,42 +821,48 @@ void msSOSAddMemberNode(xmlNsPtr psNsGml
 
     pszFeatureId = msOWSLookupMetadata(&(lp->metadata), "OSG", "featureid");
 
-    if(pszFeatureId && msLayerOpen(lp) == MS_SUCCESS && msLayerGetItems(lp) == MS_SUCCESS)
+    if (pszFeatureId && msLayerOpen(lp) == MS_SUCCESS &&
+        msLayerGetItems(lp) == MS_SUCCESS)
 
-      xmlSetNs(psLayerNode,psNsMs);
+      xmlSetNs(psLayerNode, psNsMs);
 
     /*bbox*/
 
-    msOWSGetEPSGProj(&(map->projection), &(lp->metadata), "SO", MS_TRUE, &pszEpsg);
+    msOWSGetEPSGProj(&(map->projection), &(lp->metadata), "SO", MS_TRUE,
+                     &pszEpsg);
     if (!pszEpsg)
-      msOWSGetEPSGProj(&(lp->projection), &(lp->metadata), "SO", MS_TRUE, &pszEpsg);
+      msOWSGetEPSGProj(&(lp->projection), &(lp->metadata), "SO", MS_TRUE,
+                       &pszEpsg);
 
     if (msProjectionsDiffer(&map->projection, &lp->projection) == MS_TRUE)
       msProjectRect(&lp->projection, &map->projection, &sShape.bounds);
 
-    psNode = xmlAddChild(psLayerNode, msGML3BoundedBy(psNsGml, sShape.bounds.minx, sShape.bounds.miny, sShape.bounds.maxx, sShape.bounds.maxy, pszEpsg));
+    psNode = xmlAddChild(psLayerNode,
+                         msGML3BoundedBy(psNsGml, sShape.bounds.minx,
+                                         sShape.bounds.miny, sShape.bounds.maxx,
+                                         sShape.bounds.maxy, pszEpsg));
 
     /*geometry*/
-    msSOSAddGeometryNode(psNsGml, psNsMs, psLayerNode, map, lp, &sShape, pszEpsg);
+    msSOSAddGeometryNode(psNsGml, psNsMs, psLayerNode, map, lp, &sShape,
+                         pszEpsg);
     msFree(pszEpsg);
 
     /*attributes */
-    /* TODO only output attributes where there is a sos_%s_alias (to be discussed)*/
+    /* TODO only output attributes where there is a sos_%s_alias (to be
+     * discussed)*/
     /* the first layer is the one that has to have all the metadata defined */
-    lpfirst = msSOSGetFirstLayerForOffering(map,
-                                            msOWSLookupMetadata(&(lp->metadata), "S",
-                                                "offering_id"),
-                                            msOWSLookupMetadata(&(lp->metadata), "S",
-                                                "observedproperty_id"));
+    lpfirst = msSOSGetFirstLayerForOffering(
+        map, msOWSLookupMetadata(&(lp->metadata), "S", "offering_id"),
+        msOWSLookupMetadata(&(lp->metadata), "S", "observedproperty_id"));
 
     if (lpfirst && msLayerOpen(lpfirst) == MS_SUCCESS &&
         msLayerGetItems(lpfirst) == MS_SUCCESS) {
-      for(i=0; i<lpfirst->numitems; i++) {
+      for (i = 0; i < lpfirst->numitems; i++) {
         snprintf(szTmp, sizeof(szTmp), "%s_alias", lpfirst->items[i]);
         pszValue = msOWSLookupMetadata(&(lpfirst->metadata), "S", szTmp);
         if (pszValue) {
-          for (j=0; j<lp->numitems; j++) {
-            if (strcasecmp(lpfirst->items[i],  lpfirst->items[j]) == 0) {
+          for (j = 0; j < lp->numitems; j++) {
+            if (strcasecmp(lpfirst->items[i], lpfirst->items[j]) == 0) {
               /*if there is an alias used, use it to output the
                 parameter name : eg "sos_AMMON_DIS_alias" "Amonia"  */
               snprintf(szTmp, sizeof(szTmp), "%s_alias", lpfirst->items[i]);
@@ -850,14 +876,14 @@ void msSOSAddMemberNode(xmlNsPtr psNsGml
                 free(pszTmp);
               } else {
                 pszTmp = msEncodeHTMLEntities(lpfirst->items[i]);
-                psNode = xmlNewChild(psLayerNode, psNsMs,
-                                     BAD_CAST lpfirst->items[i],
-                                     BAD_CAST pszValueShape);
+                psNode =
+                    xmlNewChild(psLayerNode, psNsMs, BAD_CAST lpfirst->items[i],
+                                BAD_CAST pszValueShape);
                 free(pszTmp);
               }
 
               free(pszValueShape);
-              xmlSetNs(psNode,psNsMs);
+              xmlSetNs(psNode, psNsMs);
               break;
             }
           }
@@ -877,70 +903,69 @@ void msSOSAddMemberNode(xmlNsPtr psNsGml
 /*      GetObservation using "observation" as the response output.      */
 /*      Assuming here that the layer is already opened.                 */
 /************************************************************************/
-char* msSOSReturnMemberResult(layerObj *lp, int iFeatureId, char **ppszProcedure)
-{
+char *msSOSReturnMemberResult(layerObj *lp, int iFeatureId,
+                              char **ppszProcedure) {
   char *pszFinalValue = NULL;
   shapeObj sShape;
   int i, j, status;
   layerObj *lpfirst;
-  const char *pszTimeField = NULL, *pszValue=NULL, *pszProcedureField=NULL;
+  const char *pszTimeField = NULL, *pszValue = NULL, *pszProcedureField = NULL;
   char *pszValueShape = NULL;
   char szTmp[100];
-  const char *pszSep=NULL;
+  const char *pszSep = NULL;
 
   msInitShape(&sShape);
-  status = msLayerGetShape(lp, &sShape, &(lp->resultcache->results[iFeatureId]));
-  if(status != MS_SUCCESS)
+  status =
+      msLayerGetShape(lp, &sShape, &(lp->resultcache->results[iFeatureId]));
+  if (status != MS_SUCCESS)
     return NULL;
 
-  pszTimeField =  msOWSLookupMetadata(&(lp->metadata), "SO", "timeitem");
+  pszTimeField = msOWSLookupMetadata(&(lp->metadata), "SO", "timeitem");
   if (pszTimeField && sShape.values) {
-    for(i=0; i<lp->numitems; i++) {
+    for (i = 0; i < lp->numitems; i++) {
       if (strcasecmp(lp->items[i], pszTimeField) == 0) {
-        pszFinalValue = msStringConcatenate(pszFinalValue,  sShape.values[i]);
+        pszFinalValue = msStringConcatenate(pszFinalValue, sShape.values[i]);
         break;
       }
     }
   }
   if (ppszProcedure && sShape.values) {
-    pszProcedureField = msOWSLookupMetadata(&(lp->metadata), "S", "procedure_item");
-    for(i=0; i<lp->numitems; i++) {
+    pszProcedureField =
+        msOWSLookupMetadata(&(lp->metadata), "S", "procedure_item");
+    for (i = 0; i < lp->numitems; i++) {
       if (strcasecmp(lp->items[i], pszProcedureField) == 0) {
-        (*ppszProcedure) = msStrdup( sShape.values[i]);
+        (*ppszProcedure) = msStrdup(sShape.values[i]);
         break;
       }
     }
   }
 
   /* the first layer is the one that has to have all the metadata defined */
-  lpfirst = msSOSGetFirstLayerForOffering(lp->map,
-                                          msOWSLookupMetadata(&(lp->metadata), "S",
-                                              "offering_id"),
-                                          msOWSLookupMetadata(&(lp->metadata), "S",
-                                              "observedproperty_id"));
-
+  lpfirst = msSOSGetFirstLayerForOffering(
+      lp->map, msOWSLookupMetadata(&(lp->metadata), "S", "offering_id"),
+      msOWSLookupMetadata(&(lp->metadata), "S", "observedproperty_id"));
 
   if (sShape.values &&
       (lp == lpfirst || (lpfirst && msLayerOpen(lpfirst) == MS_SUCCESS &&
-                        msLayerGetItems(lpfirst) == MS_SUCCESS))) {
+                         msLayerGetItems(lpfirst) == MS_SUCCESS))) {
     pszSep = msOWSLookupMetadata(&(lp->map->web.metadata), "S",
                                  "encoding_tokenSeparator");
-    for(i=0; i<lpfirst->numitems; i++) {
+    for (i = 0; i < lpfirst->numitems; i++) {
       snprintf(szTmp, sizeof(szTmp), "%s_alias", lpfirst->items[i]);
       pszValue = msOWSLookupMetadata(&(lpfirst->metadata), "S", szTmp);
       if (pszValue) {
-        for (j=0; j<lp->numitems; j++) {
-          if (strcasecmp(lpfirst->items[i],  lpfirst->items[j]) == 0) {
+        for (j = 0; j < lp->numitems; j++) {
+          if (strcasecmp(lpfirst->items[i], lpfirst->items[j]) == 0) {
             pszValueShape = msEncodeHTMLEntities(sShape.values[j]);
 
-
             if (pszFinalValue) {
               if (pszSep)
-                pszFinalValue = msStringConcatenate(pszFinalValue, (char *)pszSep);
+                pszFinalValue =
+                    msStringConcatenate(pszFinalValue, (char *)pszSep);
               else
                 pszFinalValue = msStringConcatenate(pszFinalValue, ",");
             }
-            pszFinalValue = msStringConcatenate(pszFinalValue,  pszValueShape);
+            pszFinalValue = msStringConcatenate(pszFinalValue, pszValueShape);
 
             msFree(pszValueShape);
           }
@@ -958,36 +983,37 @@ char* msSOSReturnMemberResult(layerObj *
 /*      Add a member node used for getObservation request using         */
 /*      Observation as the result format.                               */
 /************************************************************************/
-static
-xmlNodePtr msSOSAddMemberNodeObservation(xmlNsPtr psNsGml, xmlNsPtr psNsOm, xmlNsPtr psNsSwe, xmlNsPtr psNsXLink, xmlNodePtr psParent, mapObj *map, layerObj *lp, const char *pszProcedure)
-{
+static xmlNodePtr msSOSAddMemberNodeObservation(
+    xmlNsPtr psNsGml, xmlNsPtr psNsOm, xmlNsPtr psNsSwe, xmlNsPtr psNsXLink,
+    xmlNodePtr psParent, mapObj *map, layerObj *lp, const char *pszProcedure) {
   char *pszTmp = NULL;
-  xmlNodePtr psNode=NULL, psObsNode=NULL, psMemberNode=NULL;
+  xmlNodePtr psNode = NULL, psObsNode = NULL, psMemberNode = NULL;
   layerObj *lpfirst;
   const char *value = NULL;
 
-  /*always featch the first layer that has the same offering id and observered propery.
-   This allows to only define all the attributes and components on the first layer if the user
-  wants to present several mapserver layers as the same offering.*/
-  lpfirst = msSOSGetFirstLayerForOffering(map,
-                                          msOWSLookupMetadata(&(lp->metadata), "S",
-                                              "offering_id"),
-                                          msOWSLookupMetadata(&(lp->metadata), "S",
-                                              "observedproperty_id"));
+  /*always featch the first layer that has the same offering id and observered
+  propery. This allows to only define all the attributes and components on the
+  first layer if the user wants to present several mapserver layers as the same
+  offering.*/
+  lpfirst = msSOSGetFirstLayerForOffering(
+      map, msOWSLookupMetadata(&(lp->metadata), "S", "offering_id"),
+      msOWSLookupMetadata(&(lp->metadata), "S", "observedproperty_id"));
   if (psParent) {
     psMemberNode = xmlNewChild(psParent, NULL, BAD_CAST "member", NULL);
     psObsNode = xmlNewChild(psMemberNode, NULL, BAD_CAST "Observation", NULL);
 
     /*time*/
-    /* ??TODO : sampling time is a manadatory element but uses a non mandatory metadata sos_offering_timeextent */
+    /* ??TODO : sampling time is a manadatory element but uses a non mandatory
+     * metadata sos_offering_timeextent */
     value = msOWSLookupMetadata(&(lp->metadata), "S", "offering_timeextent");
     if (value) {
       char **tokens;
       int n;
       char *pszEndTime = NULL;
       tokens = msStringSplit(value, '/', &n);
-      if (tokens==NULL || (n != 1 && n!=2)) {
-        msSetError(MS_SOSERR, "Wrong number of arguments for sos_offering_timeextent.",
+      if (tokens == NULL || (n != 1 && n != 2)) {
+        msSetError(MS_SOSERR,
+                   "Wrong number of arguments for sos_offering_timeextent.",
                    "msSOSGetObservation()");
         msSOSException(map, "sos_offering_timeextent", "InvalidParameterValue");
         return NULL;
@@ -996,37 +1022,48 @@ xmlNodePtr msSOSAddMemberNodeObservation
       if (n == 2) /* end time is empty. It is going to be set as "now*/
         pszEndTime = tokens[1];
 
-      psNode = xmlAddChild(psObsNode, msSOSAddTimeNode(psNsOm, psNsGml, tokens[0], pszEndTime));
+      psNode = xmlAddChild(
+          psObsNode, msSOSAddTimeNode(psNsOm, psNsGml, tokens[0], pszEndTime));
       msFreeCharArray(tokens, n);
-
     }
 
     /* procedure */
-    if (pszProcedure) { /*this should always be true since procedure is a manadtory element*/
-      if (! msOWSLookupMetadata(&(lp->metadata), "S", "procedure_item") && msOWSLookupMetadata(&(lp->metadata), "S", "procedure"))
-        xmlAddSibling(psNode, xmlNewComment(BAD_CAST "WARNING: Optional metadata \"sos_procedure_item\" missing for sos:procedure.  If you have more than 1 procedures, sos:procedure will output them incorrectly."));
+    if (pszProcedure) { /*this should always be true since procedure is a
+                           manadtory element*/
+      if (!msOWSLookupMetadata(&(lp->metadata), "S", "procedure_item") &&
+          msOWSLookupMetadata(&(lp->metadata), "S", "procedure"))
+        xmlAddSibling(
+            psNode,
+            xmlNewComment(
+                BAD_CAST
+                "WARNING: Optional metadata \"sos_procedure_item\" missing for "
+                "sos:procedure.  If you have more than 1 procedures, "
+                "sos:procedure will output them incorrectly."));
 
       pszTmp = msStringConcatenate(pszTmp, "urn:ogc:def:procedure:");
       pszTmp = msStringConcatenate(pszTmp, (char *)pszProcedure);
-      psNode =  xmlNewChild(psObsNode, NULL, BAD_CAST "procedure", NULL);
-      /* xmlNewNsProp(psNode, xmlNewNs(NULL, BAD_CAST "http://www.w3.org/1999/xlink", BAD_CAST "xlink"), BAD_CAST "href", BAD_CAST pszTmp); */
+      psNode = xmlNewChild(psObsNode, NULL, BAD_CAST "procedure", NULL);
+      /* xmlNewNsProp(psNode, xmlNewNs(NULL, BAD_CAST
+       * "http://www.w3.org/1999/xlink", BAD_CAST "xlink"), BAD_CAST "href",
+       * BAD_CAST pszTmp); */
       xmlNewNsProp(psNode, psNsXLink, BAD_CAST "href", BAD_CAST pszTmp);
       msFree(pszTmp);
       pszTmp = NULL;
     }
 
     /*observed propery and components*/
-    if (lp != lpfirst &&
-        msLayerOpen(lpfirst) == MS_SUCCESS && msLayerGetItems(lpfirst) == MS_SUCCESS) {
-      msSOSAddPropertyNode(psNsSwe, psNsXLink, psObsNode, lpfirst, psNsGml, NULL);
+    if (lp != lpfirst && msLayerOpen(lpfirst) == MS_SUCCESS &&
+        msLayerGetItems(lpfirst) == MS_SUCCESS) {
+      msSOSAddPropertyNode(psNsSwe, psNsXLink, psObsNode, lpfirst, psNsGml,
+                           NULL);
       msLayerClose(lpfirst);
     } else
-      msSOSAddPropertyNode(psNsSwe, psNsXLink, psObsNode, lpfirst, psNsGml, NULL);
+      msSOSAddPropertyNode(psNsSwe, psNsXLink, psObsNode, lpfirst, psNsGml,
+                           NULL);
 
     /* result definition*/
     psNode = xmlNewChild(psObsNode, NULL, BAD_CAST "resultDefinition", NULL);
     msSOSAddDataBlockDefinition(psNsSwe, psNode, lpfirst);
-
   }
 
   return psObsNode;
@@ -1051,25 +1088,24 @@ xmlNodePtr msSOSAddMemberNodeObservation
 /*                                                                      */
 /*       The caller of the function should free the return value.       */
 /************************************************************************/
-char *msSOSParseTimeGML(char *pszGmlTime)
-{
+char *msSOSParseTimeGML(char *pszGmlTime) {
   char *pszReturn = NULL, *pszBegin = NULL, *pszEnd = NULL;
-  CPLXMLNode *psRoot=NULL, *psChild=NULL;
-  CPLXMLNode *psTime=NULL, *psBegin=NULL, *psEnd=NULL;
+  CPLXMLNode *psRoot = NULL, *psChild = NULL;
+  CPLXMLNode *psTime = NULL, *psBegin = NULL, *psEnd = NULL;
   struct tm tm_struct;
 
   if (pszGmlTime) {
     psRoot = CPLParseXMLString(pszGmlTime);
-    if(!psRoot)
+    if (!psRoot)
       return NULL;
     CPLStripXMLNamespace(psRoot, "gml", 1);
 
     if (psRoot->eType == CXT_Element &&
-        (EQUAL(psRoot->pszValue,"TimePeriod") ||
-         EQUAL(psRoot->pszValue,"TimeInstant"))) {
-      if (EQUAL(psRoot->pszValue,"TimeInstant")) {
+        (EQUAL(psRoot->pszValue, "TimePeriod") ||
+         EQUAL(psRoot->pszValue, "TimeInstant"))) {
+      if (EQUAL(psRoot->pszValue, "TimeInstant")) {
         psChild = psRoot->psChild;
-        if (psChild && EQUAL(psChild->pszValue,"timePosition")) {
+        if (psChild && EQUAL(psChild->pszValue, "timePosition")) {
           psTime = psChild->psNext;
           if (psTime && psTime->pszValue && psTime->eType == CXT_Text) {
             if (msParseTime(psTime->pszValue, &tm_struct) == MS_TRUE)
@@ -1081,11 +1117,11 @@ char *msSOSParseTimeGML(char *pszGmlTime
         if (psBegin)
           psEnd = psBegin->psNext;
 
-        if (psBegin && EQUAL(psBegin->pszValue, "beginPosition") &&
-            psEnd && EQUAL(psEnd->pszValue, "endPosition")) {
+        if (psBegin && EQUAL(psBegin->pszValue, "beginPosition") && psEnd &&
+            EQUAL(psEnd->pszValue, "endPosition")) {
           if (psBegin->psChild && psBegin->psChild->pszValue &&
               psBegin->psChild->eType == CXT_Text)
-            pszBegin = msStrdup( psBegin->psChild->pszValue);
+            pszBegin = msStrdup(psBegin->psChild->pszValue);
 
           if (psEnd->psChild && psEnd->psChild->pszValue &&
               psEnd->psChild->eType == CXT_Text)
@@ -1109,24 +1145,23 @@ char *msSOSParseTimeGML(char *pszGmlTime
   return pszReturn;
 }
 
-
 /************************************************************************/
 /*                           msSOSGetCapabilities                       */
 /*                                                                      */
 /*      getCapabilities request handler.                                */
 /************************************************************************/
-int msSOSGetCapabilities(mapObj *map, sosParamsObj *sosparams, cgiRequestObj *req, owsRequestObj *ows_request)
-{
-  xmlDocPtr psDoc = NULL;       /* document pointer */
+int msSOSGetCapabilities(mapObj *map, sosParamsObj *sosparams,
+                         cgiRequestObj *req, owsRequestObj *ows_request) {
+  xmlDocPtr psDoc = NULL; /* document pointer */
   xmlNodePtr psRootNode, psMainNode, psNode;
   xmlNodePtr psOfferingNode;
 
   char *schemalocation = NULL;
   char *xsi_schemaLocation = NULL;
-  char *script_url=NULL;
-  const char *updatesequence=NULL;
+  char *script_url = NULL;
+  const char *updatesequence = NULL;
 
-  int i,j,k;
+  int i, j, k;
   layerObj *lp = NULL, *lpTmp = NULL;
   const char *value = NULL;
   char *pszTmp = NULL;
@@ -1135,7 +1170,7 @@ int msSOSGetCapabilities(mapObj *map, so
 
   /* array of offering */
   char **papsOfferings = NULL;
-  int nOfferings  =0, nCurrentOff = -1;
+  int nOfferings = 0, nCurrentOff = -1;
   int nProperties = 0;
   char **papszProperties = NULL;
 
@@ -1148,7 +1183,7 @@ int msSOSGetCapabilities(mapObj *map, so
   int *panOfferingLayers = NULL;
 
   char **papsProcedures = NULL;
-  int nDistinctProcedures =0;
+  int nDistinctProcedures = 0;
 
   xmlNsPtr psNsGml = NULL;
   xmlNsPtr psNsSos = NULL;
@@ -1169,46 +1204,61 @@ int msSOSGetCapabilities(mapObj *map, so
   /* acceptversions: do OWS Common style of version negotiation */
   if (sosparams->pszAcceptVersions) {
     char **tokens;
-    int i, j, k=-1;
+    int i, j, k = -1;
 
     tokens = msStringSplit(sosparams->pszAcceptVersions, ',', &j);
 
-    for (i=0; i<j; i++) {
+    for (i = 0; i < j; i++) {
       int iVersion = 0;
 
       iVersion = msOWSParseVersionString(tokens[i]);
 
       if (iVersion == -1) {
-        msSetError(MS_SOSERR, "Invalid version format : %s.", "msSOSGetCapabilities()", tokens[i]);
+        msSetError(MS_SOSERR, "Invalid version format : %s.",
+                   "msSOSGetCapabilities()", tokens[i]);
         msFreeCharArray(tokens, j);
-        return msSOSException(map, "acceptversions", "VersionNegotiationFailed");
+        return msSOSException(map, "acceptversions",
+                              "VersionNegotiationFailed");
       }
 
       /* negotiate version */
-      k = msOWSCommonNegotiateVersion(iVersion, sosSupportedVersions, sosNumSupportedVersions);
+      k = msOWSCommonNegotiateVersion(iVersion, sosSupportedVersions,
+                                      sosNumSupportedVersions);
 
       if (k != -1)
         break;
     }
     msFreeCharArray(tokens, j);
 
-    if(k == -1) {
-      msSetError(MS_SOSERR, "ACCEPTVERSIONS list (%s) does not match supported versions (%s)", "msSOSGetCapabilities()", sosparams->pszAcceptVersions, pszSOSVersion);
+    if (k == -1) {
+      msSetError(
+          MS_SOSERR,
+          "ACCEPTVERSIONS list (%s) does not match supported versions (%s)",
+          "msSOSGetCapabilities()", sosparams->pszAcceptVersions,
+          pszSOSVersion);
       return msSOSException(map, "acceptversions", "VersionNegotiationFailed");
     }
   }
 
   /* updateSequence */
-  updatesequence = msOWSLookupMetadata(&(map->web.metadata), "SO", "updatesequence");
+  updatesequence =
+      msOWSLookupMetadata(&(map->web.metadata), "SO", "updatesequence");
 
   if (sosparams->pszUpdateSequence != NULL) {
-    i = msOWSNegotiateUpdateSequence(sosparams->pszUpdateSequence, updatesequence);
+    i = msOWSNegotiateUpdateSequence(sosparams->pszUpdateSequence,
+                                     updatesequence);
     if (i == 0) { /* current */
-      msSetError(MS_SOSERR, "UPDATESEQUENCE parameter (%s) is equal to server (%s)", "msSOSGetCapabilities()", sosparams->pszUpdateSequence, updatesequence);
+      msSetError(MS_SOSERR,
+                 "UPDATESEQUENCE parameter (%s) is equal to server (%s)",
+                 "msSOSGetCapabilities()", sosparams->pszUpdateSequence,
+                 updatesequence);
       return msSOSException(map, "updatesequence", "CurrentUpdateSequence");
     }
     if (i > 0) { /* invalid */
-      msSetError(MS_SOSERR, "UPDATESEQUENCE parameter (%s) is higher than server (%s)", "msSOSGetCapabilities()", sosparams->pszUpdateSequence, updatesequence);
+      msSetError(MS_SOSERR,
+                 "UPDATESEQUENCE parameter (%s) is higher than server (%s)",
+                 "msSOSGetCapabilities()", sosparams->pszUpdateSequence,
+                 updatesequence);
       return msSOSException(map, "updatesequence", "InvalidUpdateSequence");
     }
   }
@@ -1219,26 +1269,44 @@ int msSOSGetCapabilities(mapObj *map, so
 
   xmlDocSetRootElement(psDoc, psRootNode);
 
-  psNsGml = xmlNewNs(NULL, BAD_CAST "http://www.opengis.net/gml", BAD_CAST "gml");
-  psNsSos = xmlNewNs(NULL, BAD_CAST pszSOSNamespaceUri, BAD_CAST pszSOSNamespacePrefix);
-  psNsOgc = xmlNewNs(NULL, BAD_CAST MS_OWSCOMMON_OGC_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_OGC_NAMESPACE_PREFIX);
-  psNsSwe = xmlNewNs(NULL, BAD_CAST "http://www.opengis.net/swe/1.0.1", BAD_CAST "swe");
+  psNsGml =
+      xmlNewNs(NULL, BAD_CAST "http://www.opengis.net/gml", BAD_CAST "gml");
+  psNsSos = xmlNewNs(NULL, BAD_CAST pszSOSNamespaceUri,
+                     BAD_CAST pszSOSNamespacePrefix);
+  psNsOgc = xmlNewNs(NULL, BAD_CAST MS_OWSCOMMON_OGC_NAMESPACE_URI,
+                     BAD_CAST MS_OWSCOMMON_OGC_NAMESPACE_PREFIX);
+  psNsSwe = xmlNewNs(NULL, BAD_CAST "http://www.opengis.net/swe/1.0.1",
+                     BAD_CAST "swe");
 
   /* name spaces */
-  xmlSetNs(psRootNode,  xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/gml", BAD_CAST "gml"));
-  xmlSetNs(psRootNode,  xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/om/1.0", BAD_CAST "om"));
-
-  psNsOws = xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/ows/1.1", BAD_CAST "ows");
-  xmlSetNs(psRootNode, psNsOws );
-
-  xmlSetNs(psRootNode,xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/swe/1.0.1", BAD_CAST "swe"));
-
-  psNsXLink = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_PREFIX);
-  xmlSetNs(psRootNode, psNsXLink );
-
-  xmlSetNs(psRootNode,xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX));
-  xmlSetNs(psRootNode, xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OGC_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_OGC_NAMESPACE_PREFIX));
-  xmlSetNs(psRootNode, xmlNewNs(psRootNode, BAD_CAST pszSOSNamespaceUri, BAD_CAST pszSOSNamespacePrefix));
+  xmlSetNs(psRootNode,
+           xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/gml",
+                    BAD_CAST "gml"));
+  xmlSetNs(psRootNode,
+           xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/om/1.0",
+                    BAD_CAST "om"));
+
+  psNsOws = xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/ows/1.1",
+                     BAD_CAST "ows");
+  xmlSetNs(psRootNode, psNsOws);
+
+  xmlSetNs(psRootNode,
+           xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/swe/1.0.1",
+                    BAD_CAST "swe"));
+
+  psNsXLink =
+      xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_URI,
+               BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_PREFIX);
+  xmlSetNs(psRootNode, psNsXLink);
+
+  xmlSetNs(psRootNode,
+           xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI,
+                    BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX));
+  xmlSetNs(psRootNode,
+           xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OGC_NAMESPACE_URI,
+                    BAD_CAST MS_OWSCOMMON_OGC_NAMESPACE_PREFIX));
+  xmlSetNs(psRootNode, xmlNewNs(psRootNode, BAD_CAST pszSOSNamespaceUri,
+                                BAD_CAST pszSOSNamespacePrefix));
 
   /*version fixed for now*/
   xmlNewProp(psRootNode, BAD_CAST "version", BAD_CAST pszSOSVersion);
@@ -1249,25 +1317,30 @@ int msSOSGetCapabilities(mapObj *map, so
     xmlNewProp(psRootNode, BAD_CAST "updateSequence", BAD_CAST value);
 
   /*schema fixed*/
-  schemalocation = msEncodeHTMLEntities( msOWSGetSchemasLocation(map) );
+  schemalocation = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
   xsi_schemaLocation = msStrdup(pszSOSNamespaceUri);
   xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
   xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, schemalocation);
   xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, "/sos/");
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, (char *)pszSOSVersion);
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, "/sosGetCapabilities.xsd");
-  xmlNewNsProp(psRootNode, NULL, BAD_CAST "xsi:schemaLocation", BAD_CAST xsi_schemaLocation);
+  xsi_schemaLocation =
+      msStringConcatenate(xsi_schemaLocation, (char *)pszSOSVersion);
+  xsi_schemaLocation =
+      msStringConcatenate(xsi_schemaLocation, "/sosGetCapabilities.xsd");
+  xmlNewNsProp(psRootNode, NULL, BAD_CAST "xsi:schemaLocation",
+               BAD_CAST xsi_schemaLocation);
 
   /*service identification*/
-  xmlAddChild(psRootNode, msOWSCommonServiceIdentification(psNsOws, map, "SOS", pszSOSVersion, "SO", NULL));
+  xmlAddChild(psRootNode, msOWSCommonServiceIdentification(
+                              psNsOws, map, "SOS", pszSOSVersion, "SO", NULL));
 
   /*service provider*/
-  xmlAddChild(psRootNode, msOWSCommonServiceProvider(psNsOws, psNsXLink, map, "SO", NULL));
+  xmlAddChild(psRootNode,
+              msOWSCommonServiceProvider(psNsOws, psNsXLink, map, "SO", NULL));
 
   /*operation metadata */
 
-  if ((script_url=msOWSGetOnlineResource(map, "SO", "onlineresource", req)) == NULL)
-  {
+  if ((script_url = msOWSGetOnlineResource(map, "SO", "onlineresource", req)) ==
+      NULL) {
     free(xsi_schemaLocation);
     free(schemalocation);
     return msSOSException(map, "NoApplicableCode", "NoApplicableCode");
@@ -1275,43 +1348,96 @@ int msSOSGetCapabilities(mapObj *map, so
 
   psMainNode = xmlAddChild(psRootNode, msOWSCommonOperationsMetadata(psNsOws));
 
-  psNode     = xmlAddChild(psMainNode, msOWSCommonOperationsMetadataOperation(psNsOws,psNsXLink,"GetCapabilities", OWS_METHOD_GETPOST, (char *) script_url));
-  xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,"Parameter", "service", "SOS"));
-  xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,"Parameter", "version", (char *)pszSOSVersion));
+  psNode = xmlAddChild(psMainNode, msOWSCommonOperationsMetadataOperation(
+                                       psNsOws, psNsXLink, "GetCapabilities",
+                                       OWS_METHOD_GETPOST, (char *)script_url));
+  xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
+                          ows_version, psNsOws, "Parameter", "service", "SOS"));
+  xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
+                          ows_version, psNsOws, "Parameter", "version",
+                          (char *)pszSOSVersion));
 
   if (msOWSRequestIsEnabled(map, NULL, "S", "DescribeSensor", MS_TRUE)) {
-    psNode     = xmlAddChild(psMainNode, msOWSCommonOperationsMetadataOperation(psNsOws,psNsXLink,"DescribeSensor", OWS_METHOD_GETPOST, (char *) script_url));
-    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,"Parameter", "service", "SOS"));
-    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,"Parameter", "version", (char *)pszSOSVersion));
-    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,"Parameter", "sensorid", "urn:ogc:object:procedure"));
-    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,"Parameter", "outputFormat", (char *)pszSOSDescribeSensorMimeType));
-  }
-
-  if (msOWSRequestIsEnabled(map, NULL, "S", "DescribeObservationType", MS_TRUE)) {
-    psNode     = xmlAddChild(psMainNode, msOWSCommonOperationsMetadataOperation(psNsOws,psNsXLink,"DescribeObservationType", OWS_METHOD_GETPOST, (char *) script_url));
-    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,"Parameter", "service", "SOS"));
-    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,"Parameter", "version", (char *)pszSOSVersion));
-    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,"Parameter", "observedproperty", "urn:ogc:object:observedproperty"));
+    psNode =
+        xmlAddChild(psMainNode, msOWSCommonOperationsMetadataOperation(
+                                    psNsOws, psNsXLink, "DescribeSensor",
+                                    OWS_METHOD_GETPOST, (char *)script_url));
+    xmlAddChild(psNode,
+                msOWSCommonOperationsMetadataDomainType(
+                    ows_version, psNsOws, "Parameter", "service", "SOS"));
+    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
+                            ows_version, psNsOws, "Parameter", "version",
+                            (char *)pszSOSVersion));
+    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
+                            ows_version, psNsOws, "Parameter", "sensorid",
+                            "urn:ogc:object:procedure"));
+    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
+                            ows_version, psNsOws, "Parameter", "outputFormat",
+                            (char *)pszSOSDescribeSensorMimeType));
+  }
+
+  if (msOWSRequestIsEnabled(map, NULL, "S", "DescribeObservationType",
+                            MS_TRUE)) {
+    psNode = xmlAddChild(psMainNode,
+                         msOWSCommonOperationsMetadataOperation(
+                             psNsOws, psNsXLink, "DescribeObservationType",
+                             OWS_METHOD_GETPOST, (char *)script_url));
+    xmlAddChild(psNode,
+                msOWSCommonOperationsMetadataDomainType(
+                    ows_version, psNsOws, "Parameter", "service", "SOS"));
+    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
+                            ows_version, psNsOws, "Parameter", "version",
+                            (char *)pszSOSVersion));
+    xmlAddChild(psNode,
+                msOWSCommonOperationsMetadataDomainType(
+                    ows_version, psNsOws, "Parameter", "observedproperty",
+                    "urn:ogc:object:observedproperty"));
   }
 
   if (msOWSRequestIsEnabled(map, NULL, "S", "GetObservation", MS_TRUE)) {
-    psNode     = xmlAddChild(psMainNode, msOWSCommonOperationsMetadataOperation(psNsOws,psNsXLink,"GetObservation", OWS_METHOD_GETPOST, (char *) script_url));
-    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,"Parameter", "service", "SOS"));
-    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,"Parameter", "version", (char *)pszSOSVersion));
-    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,"Parameter", "offering", "urn:ogc:object:offering"));
-    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,"Parameter", "observedproperty", "urn:ogc:object:observedproperty"));
-    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,"Parameter", "eventtime", "sos:time"));
-    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,"Parameter", "procedure", "urn:ogc:object:sensor"));
-    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,"Parameter", "featureofinterest", "gml:location"));
-    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,"Parameter", "result", "ogc:Filter"));
-    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,"Parameter", "responseFormat", (char *)pszSOSGetObservationMimeType));
-    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,"Parameter", "resultModel", "Observation,Measurement"));
+    psNode =
+        xmlAddChild(psMainNode, msOWSCommonOperationsMetadataOperation(
+                                    psNsOws, psNsXLink, "GetObservation",
+                                    OWS_METHOD_GETPOST, (char *)script_url));
+    xmlAddChild(psNode,
+                msOWSCommonOperationsMetadataDomainType(
+                    ows_version, psNsOws, "Parameter", "service", "SOS"));
+    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
+                            ows_version, psNsOws, "Parameter", "version",
+                            (char *)pszSOSVersion));
+    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
+                            ows_version, psNsOws, "Parameter", "offering",
+                            "urn:ogc:object:offering"));
+    xmlAddChild(psNode,
+                msOWSCommonOperationsMetadataDomainType(
+                    ows_version, psNsOws, "Parameter", "observedproperty",
+                    "urn:ogc:object:observedproperty"));
+    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
+                            ows_version, psNsOws, "Parameter", "eventtime",
+                            "sos:time"));
+    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
+                            ows_version, psNsOws, "Parameter", "procedure",
+                            "urn:ogc:object:sensor"));
+    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
+                            ows_version, psNsOws, "Parameter",
+                            "featureofinterest", "gml:location"));
+    xmlAddChild(psNode,
+                msOWSCommonOperationsMetadataDomainType(
+                    ows_version, psNsOws, "Parameter", "result", "ogc:Filter"));
+    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
+                            ows_version, psNsOws, "Parameter", "responseFormat",
+                            (char *)pszSOSGetObservationMimeType));
+    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
+                            ows_version, psNsOws, "Parameter", "resultModel",
+                            "Observation,Measurement"));
   }
 
   value = msOWSLookupMetadata(&(map->web.metadata), "SO", "maxfeatures");
 
   if (value) {
-    psNode  = xmlAddChild(psMainNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,"Constraint", "DefaultMaxFeatures", (char *)value));
+    psNode = xmlAddChild(psMainNode, msOWSCommonOperationsMetadataDomainType(
+                                         ows_version, psNsOws, "Constraint",
+                                         "DefaultMaxFeatures", (char *)value));
   }
 
   /*<ogc:Filter_Capabilities> */
@@ -1319,28 +1445,30 @@ int msSOSGetCapabilities(mapObj *map, so
 
   /*Offerings */
   psNode = xmlNewChild(psRootNode, NULL, BAD_CAST "Contents", NULL);
-  psMainNode = xmlNewChild(psNode, NULL, BAD_CAST "ObservationOfferingList", NULL);
+  psMainNode =
+      xmlNewChild(psNode, NULL, BAD_CAST "ObservationOfferingList", NULL);
 
   /*go through the layers and check for metadata sos_offering_id.
     One or more layers could have the same offering id. In that case they
     are adverized as the same offering. The first layer that has*/
 
   if (map->numlayers) {
-    papsOfferings = (char **)malloc(sizeof(char *)*map->numlayers);
-    panOfferingLayers = (int *)malloc(sizeof(int)*map->numlayers);
-    for (i=0; i<map->numlayers; i++)
+    papsOfferings = (char **)malloc(sizeof(char *) * map->numlayers);
+    panOfferingLayers = (int *)malloc(sizeof(int) * map->numlayers);
+    for (i = 0; i < map->numlayers; i++)
       panOfferingLayers[i] = -1;
 
-    for (i=0; i<map->numlayers; i++) {
+    for (i = 0; i < map->numlayers; i++) {
       lp = (GET_LAYER(map, i));
 
       if (lp->status == MS_DELETE)
         continue;
 
       value = msOWSLookupMetadata(&(lp->metadata), "S", "offering_id");
-      if (value && (msIntegerInArray(lp->index, ows_request->enabled_layers, ows_request->numlayers))) {
+      if (value && (msIntegerInArray(lp->index, ows_request->enabled_layers,
+                                     ows_request->numlayers))) {
         nCurrentOff = -1;
-        for (j=0; j<nOfferings; j++) {
+        for (j = 0; j < nOfferings; j++) {
           if (strcasecmp(value, papsOfferings[j]) == 0) {
             nCurrentOff = j;
             break;
@@ -1357,12 +1485,12 @@ int msSOSGetCapabilities(mapObj *map, so
     }
 
     if (nOfferings > 0) {
-      for (i=0; i<nOfferings; i++) {
+      for (i = 0; i < nOfferings; i++) {
         psOfferingNode =
-          xmlNewChild(psMainNode, NULL,BAD_CAST "ObservationOffering", NULL);
-        xmlNewNsProp(psOfferingNode, psNsGml,
-                     BAD_CAST "id", BAD_CAST papsOfferings[i]);
-        for (j=0; j<map->numlayers; j++) {
+            xmlNewChild(psMainNode, NULL, BAD_CAST "ObservationOffering", NULL);
+        xmlNewNsProp(psOfferingNode, psNsGml, BAD_CAST "id",
+                     BAD_CAST papsOfferings[i]);
+        for (j = 0; j < map->numlayers; j++) {
           if (panOfferingLayers[j] == i) /*first layer of the offering */
             break;
         }
@@ -1370,19 +1498,30 @@ int msSOSGetCapabilities(mapObj *map, so
         lp = (GET_LAYER(map, j));
 
         /*description*/
-        value = msOWSLookupMetadata(&(lp->metadata), "S",
-                                    "offering_description");
+        value =
+            msOWSLookupMetadata(&(lp->metadata), "S", "offering_description");
         if (value)
-          psNode = xmlNewChild(psOfferingNode, psNsGml, BAD_CAST "description", BAD_CAST value);
+          psNode = xmlNewChild(psOfferingNode, psNsGml, BAD_CAST "description",
+                               BAD_CAST value);
         else
-          xmlAddSibling(psNode, xmlNewComment(BAD_CAST "WARNING: Optional metadata \"sos_offering_description\" missing for gml:description"));
+          xmlAddSibling(
+              psNode,
+              xmlNewComment(
+                  BAD_CAST
+                  "WARNING: Optional metadata \"sos_offering_description\" "
+                  "missing for gml:description"));
 
         /*name*/
         value = msOWSLookupMetadata(&(lp->metadata), "S", "offering_name");
         if (value)
-          psNode = xmlNewChild(psOfferingNode, psNsGml, BAD_CAST "name", BAD_CAST value);
+          psNode = xmlNewChild(psOfferingNode, psNsGml, BAD_CAST "name",
+                               BAD_CAST value);
         else
-          xmlAddSibling(psNode, xmlNewComment(BAD_CAST "WARNING: Optional metadata \"sos_offering_name\" missing for gml:name"));
+          xmlAddSibling(
+              psNode,
+              xmlNewComment(BAD_CAST
+                            "WARNING: Optional metadata \"sos_offering_name\" "
+                            "missing for gml:name"));
 
         /* srsName */
         value = msOWSLookupMetadata(&(map->web.metadata), "SO", "srs");
@@ -1390,63 +1529,81 @@ int msSOSGetCapabilities(mapObj *map, so
         if (value)
           msLibXml2GenerateList(psOfferingNode, psNsGml, "srsName", value, ' ');
         else
-          xmlAddSibling(psNode, xmlNewComment(BAD_CAST "WARNING: Required metadata \"sos_srs\" missing for gml:srsName"));
+          xmlAddSibling(psNode,
+                        xmlNewComment(BAD_CAST
+                                      "WARNING: Required metadata \"sos_srs\" "
+                                      "missing for gml:srsName"));
 
         /*bounding box */
         /*TODO : if sos_offering_extent does not exist compute extents
                  Check also what happen if epsg not present */
         value = msOWSLookupMetadata(&(lp->metadata), "S", "offering_extent");
         if (value) {
-          char **tokens,*pszLayerEPSG;
+          char **tokens, *pszLayerEPSG;
           int n;
           tokens = msStringSplit(value, ',', &n);
-          if (tokens==NULL || n != 4) {
-            msSetError(MS_SOSERR, "Wrong number of arguments for sos_offering_extent.",
+          if (tokens == NULL || n != 4) {
+            msSetError(MS_SOSERR,
+                       "Wrong number of arguments for sos_offering_extent.",
                        "msSOSGetCapabilities()");
-            return msSOSException(map, "sos_offering_extent", "InvalidParameterValue");
+            return msSOSException(map, "sos_offering_extent",
+                                  "InvalidParameterValue");
           }
-          msOWSGetEPSGProj(&(lp->projection),&(lp->metadata), "SO", MS_TRUE,&pszLayerEPSG);
+          msOWSGetEPSGProj(&(lp->projection), &(lp->metadata), "SO", MS_TRUE,
+                           &pszLayerEPSG);
           if (pszLayerEPSG) {
-            psNode = xmlAddChild(psOfferingNode, msGML3BoundedBy(psNsGml, atof(tokens[0]), atof(tokens[1]), atof(tokens[2]), atof(tokens[3]), pszLayerEPSG));
+            psNode =
+                xmlAddChild(psOfferingNode,
+                            msGML3BoundedBy(psNsGml, atof(tokens[0]),
+                                            atof(tokens[1]), atof(tokens[2]),
+                                            atof(tokens[3]), pszLayerEPSG));
             msFree(pszLayerEPSG);
           }
           msFreeCharArray(tokens, n);
-
         }
 
         /* intended application */
 
-        value = msOWSLookupMetadata(&(lp->metadata), "S", "offering_intendedapplication");
+        value = msOWSLookupMetadata(&(lp->metadata), "S",
+                                    "offering_intendedapplication");
 
         if (value)
-          psNode = xmlNewChild(psOfferingNode, psNsSos, BAD_CAST "intendedApplication", BAD_CAST value);
+          psNode = xmlNewChild(psOfferingNode, psNsSos,
+                               BAD_CAST "intendedApplication", BAD_CAST value);
         else
-          xmlAddSibling(psNode, xmlNewComment(BAD_CAST "WARNING: Optional metadata \"sos_offering_intendedapplication\" missing for sos:intendedApplication"));
+          xmlAddSibling(psNode,
+                        xmlNewComment(BAD_CAST
+                                      "WARNING: Optional metadata "
+                                      "\"sos_offering_intendedapplication\" "
+                                      "missing for sos:intendedApplication"));
 
         /*time*/
-        value = msOWSLookupMetadata(&(lp->metadata), "S",
-                                    "offering_timeextent");
+        value =
+            msOWSLookupMetadata(&(lp->metadata), "S", "offering_timeextent");
         if (value) {
           char **tokens;
           int n;
           char *pszEndTime = NULL;
           tokens = msStringSplit(value, '/', &n);
-          if (tokens==NULL || (n != 1 && n!=2)) {
-            msSetError(MS_SOSERR, "Wrong number of arguments for sos_offering_timeextent.",
+          if (tokens == NULL || (n != 1 && n != 2)) {
+            msSetError(MS_SOSERR,
+                       "Wrong number of arguments for sos_offering_timeextent.",
                        "msSOSGetCapabilities()");
-            return msSOSException(map, "sos_offering_timeextent", "InvalidParameterValue");
+            return msSOSException(map, "sos_offering_timeextent",
+                                  "InvalidParameterValue");
           }
 
           if (n == 2) /* end time is empty. It is going to be set as "now*/
             pszEndTime = tokens[1];
 
-          psNode = xmlAddChild(psOfferingNode, msSOSAddTimeNode(psNsSos, psNsGml, tokens[0], pszEndTime));
+          psNode = xmlAddChild(
+              psOfferingNode,
+              msSOSAddTimeNode(psNsSos, psNsGml, tokens[0], pszEndTime));
           msFreeCharArray(tokens, n);
-
         }
 
         /*procedure : output all procedure links for the offering */
-        for (j=0; j<map->numlayers; j++) {
+        for (j = 0; j < map->numlayers; j++) {
           if (panOfferingLayers[j] == i) {
             value = msOWSLookupMetadata(&(GET_LAYER(map, j)->metadata), "S",
                                         "procedure");
@@ -1455,28 +1612,31 @@ int msSOSGetCapabilities(mapObj *map, so
               char **tokens;
               int n = 0;
               tokens = msStringSplit(value, ' ', &n);
-              for (k=0; k<n; k++) {
+              for (k = 0; k < n; k++) {
                 /*TODO review the urn output */
                 snprintf(szTmp, sizeof(szTmp), "%s", "urn:ogc:def:procedure:");
                 pszTmp = msStringConcatenate(pszTmp, szTmp);
                 pszTmp = msStringConcatenate(pszTmp, tokens[k]);
 
-                psNode =
-                  xmlNewChild(psOfferingNode, NULL, BAD_CAST "procedure", NULL);
-                /* xmlNewNsProp(psNode, xmlNewNs(NULL, BAD_CAST "http://www.w3.org/1999/xlink", BAD_CAST "xlink"), BAD_CAST "href", BAD_CAST pszTmp); */
-                xmlNewNsProp(psNode, psNsXLink, BAD_CAST "href", BAD_CAST pszTmp);
+                psNode = xmlNewChild(psOfferingNode, NULL, BAD_CAST "procedure",
+                                     NULL);
+                /* xmlNewNsProp(psNode, xmlNewNs(NULL, BAD_CAST
+                 * "http://www.w3.org/1999/xlink", BAD_CAST "xlink"), BAD_CAST
+                 * "href", BAD_CAST pszTmp); */
+                xmlNewNsProp(psNode, psNsXLink, BAD_CAST "href",
+                             BAD_CAST pszTmp);
                 msFree(pszTmp);
                 pszTmp = NULL;
               }
               msFreeCharArray(tokens, n);
-            } else if ((value = msOWSLookupMetadata(&(GET_LAYER(map,j)->metadata), "S",
-                                                    "procedure_item"))) {
+            } else if ((value =
+                            msOWSLookupMetadata(&(GET_LAYER(map, j)->metadata),
+                                                "S", "procedure_item"))) {
               /* if a procedure_item is used, it means that the procedure
                  (or sensor) need to be extracted from the data. Thus we need to
                  query the layer and get the values from each feature */
 
-
-              lpTmp = GET_LAYER(map,j);
+              lpTmp = GET_LAYER(map, j);
               if (lpTmp->template == NULL)
                 lpTmp->template = msStrdup("ttt");
 
@@ -1486,77 +1646,89 @@ int msSOSGetCapabilities(mapObj *map, so
               map->query.rect = map->extent;
               msQueryByRect(map);
 
-              /*check if the attribute specified in the procedure_item is available
-                on the layer*/
+              /*check if the attribute specified in the procedure_item is
+                available on the layer*/
               iItemPosition = -1;
-              if (msLayerGetItems(lpTmp) == MS_SUCCESS &&
-                  lpTmp->resultcache && lpTmp->resultcache->numresults > 0) {
-                for(k=0; k<lpTmp->numitems; k++) {
+              if (msLayerGetItems(lpTmp) == MS_SUCCESS && lpTmp->resultcache &&
+                  lpTmp->resultcache->numresults > 0) {
+                for (k = 0; k < lpTmp->numitems; k++) {
                   if (strcasecmp(lpTmp->items[k], value) == 0) {
                     iItemPosition = k;
                     break;
                   }
                 }
                 if (iItemPosition == -1) {
-                  msSetError(MS_SOSERR, "procedure_item %s could not be found on the layer %s",
-                             "msSOSGetCapabilities()", value, lpTmp->name);
+                  msSetError(
+                      MS_SOSERR,
+                      "procedure_item %s could not be found on the layer %s",
+                      "msSOSGetCapabilities()", value, lpTmp->name);
                   return msSOSException(map, "mapserv", "NoApplicableCode");
                 }
 
-                /*for each selected feature, grab the value of the prodedire_item*/
+                /*for each selected feature, grab the value of the
+                 * prodedire_item*/
                 /* do not duplicate sensor ids if they are the same */
 
                 /*keep list of distinct procedures*/
-                papsProcedures =
-                  (char **)malloc(sizeof(char *) * lpTmp->resultcache->numresults);
+                papsProcedures = (char **)malloc(
+                    sizeof(char *) * lpTmp->resultcache->numresults);
                 nDistinctProcedures = 0;
-                for(k=0; k<lpTmp->resultcache->numresults; k++)
+                for (k = 0; k < lpTmp->resultcache->numresults; k++)
                   papsProcedures[k] = NULL;
 
-
-                for(k=0; k<lpTmp->resultcache->numresults; k++) {
+                for (k = 0; k < lpTmp->resultcache->numresults; k++) {
                   msInitShape(&sShape);
-                  status = msLayerGetShape(lp, &sShape, &(lpTmp->resultcache->results[k]));
-                  if(status != MS_SUCCESS)
+                  status = msLayerGetShape(lp, &sShape,
+                                           &(lpTmp->resultcache->results[k]));
+                  if (status != MS_SUCCESS)
                     continue;
 
                   if (sShape.values[iItemPosition]) {
-                    pszProcedure = msStringConcatenate(pszProcedure, sShape.values[iItemPosition]);
-                    if (!_IsInList(papsProcedures, nDistinctProcedures, pszProcedure)) {
-                      papsProcedures[nDistinctProcedures] = msStrdup(pszProcedure);
+                    pszProcedure = msStringConcatenate(
+                        pszProcedure, sShape.values[iItemPosition]);
+                    if (!_IsInList(papsProcedures, nDistinctProcedures,
+                                   pszProcedure)) {
+                      papsProcedures[nDistinctProcedures] =
+                          msStrdup(pszProcedure);
                       nDistinctProcedures++;
-                      snprintf(szTmp, sizeof(szTmp), "%s", "urn:ogc:def:procedure:");
+                      snprintf(szTmp, sizeof(szTmp), "%s",
+                               "urn:ogc:def:procedure:");
                       pszTmp = msStringConcatenate(pszTmp, szTmp);
                       pszTmp = msStringConcatenate(pszTmp, pszProcedure);
 
-                      psNode =
-                        xmlNewChild(psOfferingNode, NULL, BAD_CAST "procedure", NULL);
+                      psNode = xmlNewChild(psOfferingNode, NULL,
+                                           BAD_CAST "procedure", NULL);
                       xmlNewNsProp(psNode,
-                                   xmlNewNs(NULL, BAD_CAST "http://www.w3.org/1999/xlink",
-                                            BAD_CAST "xlink"), BAD_CAST "href", BAD_CAST pszTmp);
+                                   xmlNewNs(NULL,
+                                            BAD_CAST
+                                            "http://www.w3.org/1999/xlink",
+                                            BAD_CAST "xlink"),
+                                   BAD_CAST "href", BAD_CAST pszTmp);
                       msFree(pszTmp);
                       pszTmp = NULL;
-
                     }
                     msFree(pszProcedure);
                     pszProcedure = NULL;
                   }
                 }
-                for(k=0; k<lpTmp->resultcache->numresults; k++)
+                for (k = 0; k < lpTmp->resultcache->numresults; k++)
                   if (papsProcedures[k] != NULL)
                     msFree(papsProcedures[k]);
                 msFree(papsProcedures);
 
               } else {
-                msSetError(MS_SOSERR, "Invalid procedure %s", "msSOSGetCapabilities()", value);
-                return msSOSException(map, "procedure", "InvalidParameterValue");
+                msSetError(MS_SOSERR, "Invalid procedure %s",
+                           "msSOSGetCapabilities()", value);
+                return msSOSException(map, "procedure",
+                                      "InvalidParameterValue");
               }
             } else {
-              msSetError(MS_SOSERR, "Mandatory metadata procedure_item could not be found on the layer %s",
-                         "msSOSGetCapabilities()", GET_LAYER(map,j)->name);
+              msSetError(MS_SOSERR,
+                         "Mandatory metadata procedure_item could not be found "
+                         "on the layer %s",
+                         "msSOSGetCapabilities()", GET_LAYER(map, j)->name);
               return msSOSException(map, "mapserv", "NoApplicableCode");
             }
-
           }
         }
         /*observed property */
@@ -1566,15 +1738,13 @@ int msSOSGetCapabilities(mapObj *map, so
            using the metadata sos_%s_aliasl */
 
         nProperties = 0;
-        papszProperties =
-          (char **)malloc(sizeof(char *)*map->numlayers);
+        papszProperties = (char **)malloc(sizeof(char *) * map->numlayers);
 
-        for (j=0; j<map->numlayers; j++) {
+        for (j = 0; j < map->numlayers; j++) {
           if (panOfferingLayers[j] == i) {
-            if ((value =
-                   msOWSLookupMetadata(&(GET_LAYER(map, j)->metadata), "S",
-                                       "observedproperty_id"))) {
-              for (k=0; k<nProperties; k++) {
+            if ((value = msOWSLookupMetadata(&(GET_LAYER(map, j)->metadata),
+                                             "S", "observedproperty_id"))) {
+              for (k = 0; k < nProperties; k++) {
                 if (strcasecmp(value, papszProperties[k]) == 0)
                   break;
               }
@@ -1582,7 +1752,8 @@ int msSOSGetCapabilities(mapObj *map, so
                 papszProperties[nProperties] = msStrdup(value);
                 nProperties++;
                 lpTmp = GET_LAYER(map, j);
-                if (msLayerOpen(lpTmp) == MS_SUCCESS && msLayerGetItems(lpTmp) == MS_SUCCESS) {
+                if (msLayerOpen(lpTmp) == MS_SUCCESS &&
+                    msLayerGetItems(lpTmp) == MS_SUCCESS) {
                   msSOSAddPropertyNode(psNsSwe, psNsXLink, psOfferingNode,
                                        lpTmp, psNsGml, NULL);
                   msLayerClose(lpTmp);
@@ -1591,12 +1762,14 @@ int msSOSGetCapabilities(mapObj *map, so
             }
           }
         }
-        for (j=0; j<nProperties; j++)
+        for (j = 0; j < nProperties; j++)
           free(papszProperties[j]);
         free(papszProperties);
 
-        psNode = xmlNewChild(psOfferingNode, NULL, BAD_CAST "featureOfInterest", NULL);
-        xmlNewNsProp(psNode, psNsXLink, BAD_CAST "href", BAD_CAST "urn:ogc:def:feature:OGC-SWE:3:transient");
+        psNode = xmlNewChild(psOfferingNode, NULL, BAD_CAST "featureOfInterest",
+                             NULL);
+        xmlNewNsProp(psNode, psNsXLink, BAD_CAST "href",
+                     BAD_CAST "urn:ogc:def:feature:OGC-SWE:3:transient");
 
         psNode = xmlNewChild(psOfferingNode, NULL, BAD_CAST "responseFormat",
                              BAD_CAST pszSOSGetObservationMimeType);
@@ -1607,35 +1780,36 @@ int msSOSGetCapabilities(mapObj *map, so
         psNode = xmlNewChild(psOfferingNode, NULL, BAD_CAST "responseMode",
                              BAD_CAST "inline");
 
-      }/*end of offerings*/
+      } /*end of offerings*/
     }
 
     if (papsOfferings && nOfferings > 0) {
-      for (i=0; i<nOfferings; i++)
+      for (i = 0; i < nOfferings; i++)
         msFree(papsOfferings[i]);
     }
     msFree(papsOfferings);
-    if(panOfferingLayers)
+    if (panOfferingLayers)
       msFree(panOfferingLayers);
 
-  }/* end of offerings */
+  } /* end of offerings */
 
-  if ( msIO_needBinaryStdout() == MS_FAILURE )
+  if (msIO_needBinaryStdout() == MS_FAILURE)
     return MS_FAILURE;
 
-  msIO_setHeader("Content-Type","text/xml; charset=UTF-8");
+  msIO_setHeader("Content-Type", "text/xml; charset=UTF-8");
   msIO_sendHeaders();
 
   /*TODO* : check the encoding validity. Internally libxml2 uses UTF-8
   msOWSPrintEncodeMetadata(stdout, &(map->web.metadata),
                            "SO", "encoding", OWS_NOERR,
-                           "<?xml version='1.0' encoding=\"%s\" standalone=\"no\" ?>\n",
-                           "ISO-8859-1");
+                           "<?xml version='1.0' encoding=\"%s\"
+  standalone=\"no\" ?>\n", "ISO-8859-1");
   */
-  /*xmlDocDumpFormatMemoryEnc(psDoc, &buffer, &size, (encoding ? encoding : "ISO-8859-1"), 1);*/
+  /*xmlDocDumpFormatMemoryEnc(psDoc, &buffer, &size, (encoding ? encoding :
+   * "ISO-8859-1"), 1);*/
 
-  /* xmlDocDump crashs withe the prebuild windows binaries distibutes at the libxml site???.
-   It works with locally build binaries*/
+  /* xmlDocDump crashs withe the prebuild windows binaries distibutes at the
+   libxml site???. It works with locally build binaries*/
 
   context = msIO_getHandler(stdout);
 
@@ -1661,9 +1835,7 @@ int msSOSGetCapabilities(mapObj *map, so
    */
   xmlCleanupParser();
 
-
-  return(MS_SUCCESS);
-
+  return (MS_SUCCESS);
 
   /*
   nSize = sizeof(workbuffer);
@@ -1699,24 +1871,24 @@ int msSOSGetCapabilities(mapObj *map, so
 /*                                                                      */
 /*      GetObservation request handler                                  */
 /************************************************************************/
-int msSOSGetObservation(mapObj *map, sosParamsObj *sosparams, cgiRequestObj *req, owsRequestObj *ows_request)
-{
+int msSOSGetObservation(mapObj *map, sosParamsObj *sosparams,
+                        cgiRequestObj *req, owsRequestObj *ows_request) {
   char *schemalocation = NULL;
   char *xsi_schemaLocation = NULL;
   const char *pszTmp = NULL, *pszTmp2 = NULL;
   const char *user_namespace_uri = "http://mapserver.gis.umn.edu/mapserver";
   const char *user_namespace_prefix = "ms";
-  char *script_url=NULL;
+  char *script_url = NULL;
   int i, j, k, bLayerFound = 0;
   layerObj *lp = NULL, *lpfirst = NULL;
-  const char *pszTimeExtent=NULL, *pszTimeField=NULL, *pszValue=NULL;
+  const char *pszTimeExtent = NULL, *pszTimeField = NULL, *pszValue = NULL;
   FilterEncodingNode *psFilterNode = NULL;
   rectObj sBbox;
 
   xmlDocPtr psDoc = NULL;
-  xmlNodePtr psRootNode,  psNode;
-  char **tokens=NULL, **tokens1;
-  int n=0, n1=0;
+  xmlNodePtr psRootNode, psNode;
+  char **tokens = NULL, **tokens1;
+  int n = 0, n1 = 0;
   xmlNsPtr psNsGml = NULL;
   xmlNsPtr psNsOm = NULL;
   xmlNsPtr psNsSwe = NULL;
@@ -1730,84 +1902,103 @@ int msSOSGetObservation(mapObj *map, sos
   xmlChar *buffer = NULL;
   int size = 0;
   msIOContext *context = NULL;
-  xmlNodePtr psObservationNode = NULL, psResultNode=NULL;
+  xmlNodePtr psObservationNode = NULL, psResultNode = NULL;
   const char *pszProcedure = NULL;
-  const char *pszBlockSep=NULL;
+  const char *pszBlockSep = NULL;
   int nDiffrentProc = 0;
   SOSProcedureNode *paDiffrentProc = NULL;
   int iItemPosition, status;
   shapeObj sShape;
-  char* pszEscapedStr = NULL;
+  char *pszEscapedStr = NULL;
 
   sBbox = map->extent;
 
   /* establish local namespace */
   pszTmp = msOWSLookupMetadata(&(map->web.metadata), "SFO", "namespace_uri");
 
-  if(pszTmp) user_namespace_uri = pszTmp;
+  if (pszTmp)
+    user_namespace_uri = pszTmp;
 
   pszTmp = msOWSLookupMetadata(&(map->web.metadata), "SFO", "namespace_prefix");
-  if(pszTmp) user_namespace_prefix = pszTmp;
+  if (pszTmp)
+    user_namespace_prefix = pszTmp;
 
   /* validates mandatory request elements */
   if (!sosparams->pszOffering) {
-    msSetError(MS_SOSERR, "Missing OFFERING parameter.", "msSOSGetObservation()");
+    msSetError(MS_SOSERR, "Missing OFFERING parameter.",
+               "msSOSGetObservation()");
     return msSOSException(map, "offering", "MissingParameterValue");
   }
 
   if (!sosparams->pszObservedProperty) {
-    msSetError(MS_SOSERR, "Missing OBSERVEDPROPERTY parameter.", "msSOSGetObservation()");
+    msSetError(MS_SOSERR, "Missing OBSERVEDPROPERTY parameter.",
+               "msSOSGetObservation()");
     return msSOSException(map, "observedproperty", "MissingParameterValue");
   }
 
   if (!sosparams->pszResponseFormat) {
-    msSetError(MS_SOSERR, "Missing RESPONSEFORMAT parameter.", "msSOSGetObservation()");
+    msSetError(MS_SOSERR, "Missing RESPONSEFORMAT parameter.",
+               "msSOSGetObservation()");
     return msSOSException(map, "responseformat", "MissingParameterValue");
   }
 
-  if (strcasecmp(sosparams->pszResponseFormat, pszSOSGetObservationMimeType) != 0) {
-    msSetError(MS_SOSERR, "Invalid RESPONSEFORMAT parameter %s.  Allowable values are: %s", "msSOSGetObservation()", sosparams->pszResponseFormat, pszSOSGetObservationMimeType);
+  if (strcasecmp(sosparams->pszResponseFormat, pszSOSGetObservationMimeType) !=
+      0) {
+    msSetError(MS_SOSERR,
+               "Invalid RESPONSEFORMAT parameter %s.  Allowable values are: %s",
+               "msSOSGetObservation()", sosparams->pszResponseFormat,
+               pszSOSGetObservationMimeType);
     return msSOSException(map, "responseformat", "InvalidParameterValue");
   }
 
-  if (sosparams->pszResponseMode && strcasecmp(sosparams->pszResponseMode, "inline") != 0) {
-    msSetError(MS_SOSERR, "Invalid RESPONSEMODE parameter %s.  Allowable values are: \"inline\"", "msSOSGetObservation()", sosparams->pszResponseMode);
+  if (sosparams->pszResponseMode &&
+      strcasecmp(sosparams->pszResponseMode, "inline") != 0) {
+    msSetError(
+        MS_SOSERR,
+        "Invalid RESPONSEMODE parameter %s.  Allowable values are: \"inline\"",
+        "msSOSGetObservation()", sosparams->pszResponseMode);
     return msSOSException(map, "responsemode", "InvalidParameterValue");
   }
 
   /*validate if offering exists*/
-  for (i=0; i<map->numlayers; i++) {
-    pszTmp = msOWSLookupMetadata(&(GET_LAYER(map, i)->metadata), "S", "offering_id");
+  for (i = 0; i < map->numlayers; i++) {
+    pszTmp =
+        msOWSLookupMetadata(&(GET_LAYER(map, i)->metadata), "S", "offering_id");
     if (pszTmp && (strcasecmp(pszTmp, sosparams->pszOffering) == 0) &&
-        (msIntegerInArray(GET_LAYER(map, i)->index, ows_request->enabled_layers, ows_request->numlayers)))
+        (msIntegerInArray(GET_LAYER(map, i)->index, ows_request->enabled_layers,
+                          ows_request->numlayers)))
       break;
   }
 
-  if (i==map->numlayers) {
-    msSetError(MS_SOSERR, "Offering %s not found. A layer might be disabled for \
-this request. Check sos/ows_enable_request settings.", "msSOSGetObservation()", sosparams->pszOffering);
+  if (i == map->numlayers) {
+    msSetError(MS_SOSERR,
+               "Offering %s not found. A layer might be disabled for \
+this request. Check sos/ows_enable_request settings.",
+               "msSOSGetObservation()", sosparams->pszOffering);
     return msSOSException(map, "offering", "InvalidParameterValue");
   }
 
   /*validate if observed property exist*/
-  /* Allow more the 1 oberved property comma separated (specs is unclear on it). If we
-     do it, we need to see if other parameters like result (filter encoding)
-     should be given for each property too) */
+  /* Allow more the 1 oberved property comma separated (specs is unclear on it).
+     If we do it, we need to see if other parameters like result (filter
+     encoding) should be given for each property too) */
 
   bLayerFound = 0;
   tokens = msStringSplit(sosparams->pszObservedProperty, ',', &n);
 
-  for (i=0; i<map->numlayers; i++) {
-    pszTmp = msOWSLookupMetadata(&(GET_LAYER(map, i)->metadata), "S", "offering_id");
-    pszTmp2 = msOWSLookupMetadata(&(GET_LAYER(map, i)->metadata), "S", "observedproperty_id");
+  for (i = 0; i < map->numlayers; i++) {
+    pszTmp =
+        msOWSLookupMetadata(&(GET_LAYER(map, i)->metadata), "S", "offering_id");
+    pszTmp2 = msOWSLookupMetadata(&(GET_LAYER(map, i)->metadata), "S",
+                                  "observedproperty_id");
 
     GET_LAYER(map, i)->status = MS_OFF;
 
     if (pszTmp && pszTmp2) {
       if (strcasecmp(pszTmp, sosparams->pszOffering) == 0) {
         if (tokens && n > 0) {
-          for (j=0; j<n; j++) {
-            if(strcasecmp(pszTmp2, tokens[j]) == 0) {
+          for (j = 0; j < n; j++) {
+            if (strcasecmp(pszTmp2, tokens[j]) == 0) {
               GET_LAYER(map, i)->status = MS_ON;
               /* opLayerName = msStrdup(GET_LAYER(map, i)->name); */
               opLayerName = GET_LAYER(map, i)->name;
@@ -1826,36 +2017,38 @@ this request. Check sos/ows_enable_reque
     msFreeCharArray(tokens, n);
 
   if (bLayerFound == 0) {
-    msSetError(MS_SOSERR, "ObservedProperty %s not found.", "msSOSGetObservation()", sosparams->pszObservedProperty);
+    msSetError(MS_SOSERR, "ObservedProperty %s not found.",
+               "msSOSGetObservation()", sosparams->pszObservedProperty);
     return msSOSException(map, "observedproperty", "InvalidParameterValue");
   }
 
   /* apply procedure : could be a comma separated list.
      set status to on those layers that have the sos_procedure metadata
-     equals to this parameter. Note that the layer should already have it's status at ON
-     by the  offering,observedproperty filter done above */
+     equals to this parameter. Note that the layer should already have it's
+     status at ON by the  offering,observedproperty filter done above */
 
   if (sosparams->pszProcedure) {
     bLayerFound = 0;
     tokens = msStringSplit(sosparams->pszProcedure, ',', &n);
 
     if (tokens && n > 0) {
-      for (i=0; i<map->numlayers; i++) {
-        if(GET_LAYER(map, i)->status == MS_ON) {
-          pszValue =  msOWSLookupMetadata(&(GET_LAYER(map, i)->metadata), "S", "procedure");
+      for (i = 0; i < map->numlayers; i++) {
+        if (GET_LAYER(map, i)->status == MS_ON) {
+          pszValue = msOWSLookupMetadata(&(GET_LAYER(map, i)->metadata), "S",
+                                         "procedure");
 
           if (pszValue) {
             /* the procedure metadata can be a list "sensor1 sensor2..."*/
             tokens1 = msStringSplit(pszValue, ' ', &n1);
 
-            for (j=0; j<n; j++) {
-              for (k=0; k<n1; k++) {
+            for (j = 0; j < n; j++) {
+              for (k = 0; k < n1; k++) {
                 if (strcasecmp(tokens1[k], tokens[j]) == 0) { /* found */
                   bLayerFound = 1;
                   break;
                 }
               }
-              if (k<n1)
+              if (k < n1)
                 break;
             }
             if (j == n) /*not found*/
@@ -1865,7 +2058,8 @@ this request. Check sos/ows_enable_reque
               msFreeCharArray(tokens1, n1);
 
             if (bLayerFound == 0) {
-              msSetError(MS_SOSERR, "Procedure %s not found.", "msSOSGetObservation()", sosparams->pszProcedure);
+              msSetError(MS_SOSERR, "Procedure %s not found.",
+                         "msSOSGetObservation()", sosparams->pszProcedure);
               msFreeCharArray(tokens, n);
               return msSOSException(map, "procedure", "InvalidParameterValue");
             }
@@ -1874,15 +2068,20 @@ this request. Check sos/ows_enable_reque
           /* if there is a procedure_item defined on the layer, we will */
           /* use it to set the filter parameter of the layer */
 
-          if ((GET_LAYER(map, i)->status == MS_ON) && (pszProcedureItem =  msOWSLookupMetadata(&(GET_LAYER(map, i)->metadata), "S", "procedure_item"))) {
+          if ((GET_LAYER(map, i)->status == MS_ON) &&
+              (pszProcedureItem = msOWSLookupMetadata(
+                   &(GET_LAYER(map, i)->metadata), "S", "procedure_item"))) {
 
             lp = GET_LAYER(map, i);
 
             /* HACK BEGIN */
 
-            if (msOWSLookupMetadata(&(GET_LAYER(map,i)->metadata), "S", "procedure") == NULL) {
-              /* if sos_procedure_item is used, and sos_procedure is not, it means that */
-              /* the procedure or sensor) need to be extracted from the data. Thus we */
+            if (msOWSLookupMetadata(&(GET_LAYER(map, i)->metadata), "S",
+                                    "procedure") == NULL) {
+              /* if sos_procedure_item is used, and sos_procedure is not, it
+               * means that */
+              /* the procedure or sensor) need to be extracted from the data.
+               * Thus we */
               /* need to query the layer and get the values from each feature */
 
               if (lp->template == NULL)
@@ -1894,35 +2093,43 @@ this request. Check sos/ows_enable_reque
               map->query.rect = map->extent;
               msQueryByRect(map);
 
-              /*check if the attribute specified in the procedure_item is available */
+              /*check if the attribute specified in the procedure_item is
+               * available */
               /*on the layer*/
               iItemPosition = -1;
-              if (msLayerGetItems(lp) == MS_SUCCESS && lp->resultcache && lp->resultcache->numresults > 0) {
-                for(k=0; k<lp->numitems; k++) {
+              if (msLayerGetItems(lp) == MS_SUCCESS && lp->resultcache &&
+                  lp->resultcache->numresults > 0) {
+                for (k = 0; k < lp->numitems; k++) {
                   if (strcasecmp(lp->items[k], pszProcedureItem) == 0) {
                     iItemPosition = k;
                     break;
                   }
                 }
                 if (iItemPosition == -1) {
-                  msSetError(MS_SOSERR, "sos_procedure_item %s could not be found on the layer %s",
-                             "msSOSGetCapabilities()", pszProcedureItem, lp->name);
+                  msSetError(MS_SOSERR,
+                             "sos_procedure_item %s could not be found on the "
+                             "layer %s",
+                             "msSOSGetCapabilities()", pszProcedureItem,
+                             lp->name);
                   return msSOSException(map, "mapserv", "NoApplicableCode");
                 }
 
-                /*for each selected feature, grab the value of the procedure_item*/
+                /*for each selected feature, grab the value of the
+                 * procedure_item*/
                 bLayerFound = 0;
 
-                for(k=0; k<lp->resultcache->numresults; k++) {
+                for (k = 0; k < lp->resultcache->numresults; k++) {
                   msInitShape(&sShape);
-                  status = msLayerGetShape(lp, &sShape, &(lp->resultcache->results[k]));
-                  if(status != MS_SUCCESS)
+                  status = msLayerGetShape(lp, &sShape,
+                                           &(lp->resultcache->results[k]));
+                  if (status != MS_SUCCESS)
                     continue;
 
                   if (sShape.values[iItemPosition]) {
                     tokens = msStringSplit(sosparams->pszProcedure, ',', &n);
-                    for (j=0; j<n; j++) {
-                      if (strcasecmp(sShape.values[iItemPosition], tokens[j]) == 0) { /* found */
+                    for (j = 0; j < n; j++) {
+                      if (strcasecmp(sShape.values[iItemPosition], tokens[j]) ==
+                          0) { /* found */
                         bLayerFound = 1;
                         break;
                       }
@@ -1934,8 +2141,10 @@ this request. Check sos/ows_enable_reque
                 }
 
                 if (bLayerFound == 0) {
-                  msSetError(MS_SOSERR, "Invalid procedure value %s", "msSOSGetCapabilities()", sosparams->pszProcedure);
-                  return msSOSException(map, "procedure", "InvalidParameterValue");
+                  msSetError(MS_SOSERR, "Invalid procedure value %s",
+                             "msSOSGetCapabilities()", sosparams->pszProcedure);
+                  return msSOSException(map, "procedure",
+                                        "InvalidParameterValue");
                 }
               }
             }
@@ -1948,10 +2157,11 @@ this request. Check sos/ows_enable_reque
             /*The filter should reflect the underlying db*/
             /*for ogr add a where clause */
             bSpatialDB = 0;
-            if (lp->connectiontype == MS_POSTGIS ||  lp->connectiontype == MS_ORACLESPATIAL || lp->connectiontype == MS_OGR)
+            if (lp->connectiontype == MS_POSTGIS ||
+                lp->connectiontype == MS_ORACLESPATIAL ||
+                lp->connectiontype == MS_OGR)
               bSpatialDB = 1;
 
-
             if (bSpatialDB) {
               if (lp->connectiontype != MS_OGR)
                 pszBuffer = msStringConcatenate(pszBuffer, "(");
@@ -1960,7 +2170,7 @@ this request. Check sos/ows_enable_reque
             } else
               pszBuffer = msStringConcatenate(pszBuffer, "(");
 
-            for (j=0; j<n; j++) {
+            for (j = 0; j < n; j++) {
               if (j > 0)
                 pszBuffer = msStringConcatenate(pszBuffer, " OR ");
 
@@ -1968,9 +2178,11 @@ this request. Check sos/ows_enable_reque
 
               if (!bSpatialDB) {
                 pszBuffer = msStringConcatenate(pszBuffer, "'[");
-                pszBuffer = msStringConcatenate(pszBuffer, (char *)pszProcedureItem);
+                pszBuffer =
+                    msStringConcatenate(pszBuffer, (char *)pszProcedureItem);
               } else {
-                pszEscapedStr = msLayerEscapePropertyName(lp, (char *)pszProcedureItem);
+                pszEscapedStr =
+                    msLayerEscapePropertyName(lp, (char *)pszProcedureItem);
                 pszBuffer = msStringConcatenate(pszBuffer, pszEscapedStr);
                 msFree(pszEscapedStr);
                 pszEscapedStr = NULL;
@@ -1981,9 +2193,9 @@ this request. Check sos/ows_enable_reque
 
               pszBuffer = msStringConcatenate(pszBuffer, " = '");
               pszEscapedStr = msLayerEscapeSQLParam(lp, tokens[j]);
-              pszBuffer = msStringConcatenate(pszBuffer,  pszEscapedStr);
+              pszBuffer = msStringConcatenate(pszBuffer, pszEscapedStr);
               msFree(pszEscapedStr);
-              pszBuffer = msStringConcatenate(pszBuffer,  "')");
+              pszBuffer = msStringConcatenate(pszBuffer, "')");
             }
 
             if (!bSpatialDB || lp->connectiontype != MS_OGR)
@@ -2022,12 +2234,14 @@ this request. Check sos/ows_enable_reque
     int numtimes = 0;
     char *pszTimeString = NULL, *pszTmp = NULL;
 
-    /* Because SOS has specific TemporalOperator which extends FES 1.1, the time filter  */
-    /* passed is different than what mapogcfilter (per 1.0.0) supports.                  */
+    /* Because SOS has specific TemporalOperator which extends FES 1.1, the time
+     * filter  */
+    /* passed is different than what mapogcfilter (per 1.0.0) supports. */
     /*                                                                                   */
-    /* Because, in XML POST mode, we traverse directly to gml:TimePeriod|gml:TimeInstant */
-    /* this is passed directly to mapogcfilter.                                          */
-    /* for GET requests, we strip the parent element before passing                      */
+    /* Because, in XML POST mode, we traverse directly to
+     * gml:TimePeriod|gml:TimeInstant */
+    /* this is passed directly to mapogcfilter. */
+    /* for GET requests, we strip the parent element before passing */
 
     pszTmp = msStrdup(sosparams->pszEventTime);
 
@@ -2036,11 +2250,11 @@ this request. Check sos/ows_enable_reque
     pszTmp = msCaseReplaceSubstring(pszTmp, "</ogc:TM_Equals>", "");
     pszTmp = msCaseReplaceSubstring(pszTmp, "</TM_Equals>", "");
 
-    apszTimes = msStringSplit (pszTmp, ',', &numtimes);
+    apszTimes = msStringSplit(pszTmp, ',', &numtimes);
     msFree(pszTmp);
 
-    if (numtimes >=1) {
-      for (i=0; i<numtimes; i++) {
+    if (numtimes >= 1) {
+      for (i = 0; i < numtimes; i++) {
         pszTmp = msSOSParseTimeGML(apszTimes[i]);
         if (pszTmp) {
           if (pszTimeString)
@@ -2052,30 +2266,41 @@ this request. Check sos/ows_enable_reque
       msFreeCharArray(apszTimes, numtimes);
     }
     if (!pszTimeString) {
-      msSetError(MS_SOSERR, "Invalid time value given for the eventTime parameter %s", "msSOSGetObservation()", sosparams->pszEventTime);
+      msSetError(MS_SOSERR,
+                 "Invalid time value given for the eventTime parameter %s",
+                 "msSOSGetObservation()", sosparams->pszEventTime);
       return msSOSException(map, "eventtime", "InvalidParameterValue");
     }
-    for (i=0; i<map->numlayers; i++) {
+    for (i = 0; i < map->numlayers; i++) {
       if (GET_LAYER(map, i)->status == MS_ON) {
         /* the sos_offering_timeextent should be used for time validation*/
         /*TODO : too documented  ?*/
-        lpfirst = msSOSGetFirstLayerForOffering(map, msOWSLookupMetadata(&(GET_LAYER(map, i)->metadata), "S", "offering_id"), NULL);
+        lpfirst = msSOSGetFirstLayerForOffering(
+            map,
+            msOWSLookupMetadata(&(GET_LAYER(map, i)->metadata), "S",
+                                "offering_id"),
+            NULL);
         if (lpfirst)
-          pszTimeExtent = msOWSLookupMetadata(&lpfirst->metadata, "S", "offering_timeextent");
+          pszTimeExtent = msOWSLookupMetadata(&lpfirst->metadata, "S",
+                                              "offering_timeextent");
 
-        pszTimeField =  msOWSLookupMetadata(&(GET_LAYER(map, i)->metadata), "SO", "timeitem");
+        pszTimeField = msOWSLookupMetadata(&(GET_LAYER(map, i)->metadata), "SO",
+                                           "timeitem");
 
         if (pszTimeField) {
           /*validate only if time extent is set.*/
           if (pszTimeExtent) {
             if (msValidateTimeValue(pszTimeString, pszTimeExtent) == MS_TRUE)
-              msLayerSetTimeFilter((GET_LAYER(map, i)), pszTimeString, pszTimeField);
+              msLayerSetTimeFilter((GET_LAYER(map, i)), pszTimeString,
+                                   pszTimeField);
             else {
-              /*we should turn the layer off since the eventTime is not in the time extent*/
+              /*we should turn the layer off since the eventTime is not in the
+               * time extent*/
               GET_LAYER(map, i)->status = MS_OFF;
             }
           } else
-            msLayerSetTimeFilter((GET_LAYER(map, i)), pszTimeString, pszTimeField);
+            msLayerSetTimeFilter((GET_LAYER(map, i)), pszTimeString,
+                                 pszTimeField);
         }
       }
     }
@@ -2093,21 +2318,26 @@ this request. Check sos/ows_enable_reque
 
   if (sosparams->pszFeatureOfInterest) {
     int bValid = 0;
-    CPLXMLNode *psRoot=NULL;
+    CPLXMLNode *psRoot = NULL;
     char *pszSRS = NULL;
 
     psRoot = CPLParseXMLString(sosparams->pszFeatureOfInterest);
-    if(!psRoot) {
-      msSetError(MS_SOSERR, "Invalid gml:Envelope value given for featureOfInterest.", "msSOSGetObservation()");
+    if (!psRoot) {
+      msSetError(MS_SOSERR,
+                 "Invalid gml:Envelope value given for featureOfInterest.",
+                 "msSOSGetObservation()");
       return msSOSException(map, "featureofinterest", "InvalidParameterValue");
     }
 
     CPLStripXMLNamespace(psRoot, "gml", 1);
     bValid = FLTParseGMLEnvelope(psRoot, &sBbox, &pszSRS);
 
-    /* TODO we should reproject the bbox to the map projection if there is an srs defined */
+    /* TODO we should reproject the bbox to the map projection if there is an
+     * srs defined */
     if (!bValid) {
-      msSetError(MS_SOSERR, "Invalid gml:Envelope value given for featureOfInterest %s.", "msSOSGetObservation()", sosparams->pszEventTime);
+      msSetError(MS_SOSERR,
+                 "Invalid gml:Envelope value given for featureOfInterest %s.",
+                 "msSOSGetObservation()", sosparams->pszEventTime);
       return msSOSException(map, "featureofinterest", "InvalidParameterValue");
     }
     map->extent.minx = sBbox.minx;
@@ -2135,7 +2365,7 @@ this request. Check sos/ows_enable_reque
       tokens = msStringSplit(pszSRSList, ' ', &n);
 
       if (tokens && n > 0) {
-        for (k=0; k<n; k++) {
+        for (k = 0; k < n; k++) {
           if (strncasecmp(tokens[k], "EPSG:", strlen("EPSG:")) == 0 &&
               strcasecmp(sosparams->pszSrsName, tokens[k]) == 0) { /* match */
             bFound = 1;
@@ -2144,10 +2374,12 @@ this request. Check sos/ows_enable_reque
             msInitProjection(&po);
             msProjectionInheritContextFrom(&po, &map->projection);
 
-            snprintf(srsbuffer, sizeof(srsbuffer), "+init=epsg:%.20s", sosparams->pszSrsName+strlen("EPSG:"));
+            snprintf(srsbuffer, sizeof(srsbuffer), "+init=epsg:%.20s",
+                     sosparams->pszSrsName + strlen("EPSG:"));
 
             if (msLoadProjectionString(&po, srsbuffer) != 0) {
-              msSetError(MS_SOSERR, "Could not set output projection to \"%s\"", "msSOSGetObservation()", sosparams->pszSrsName);
+              msSetError(MS_SOSERR, "Could not set output projection to \"%s\"",
+                         "msSOSGetObservation()", sosparams->pszSrsName);
               return msSOSException(map, "mapserv", "NoApplicableCode");
             }
 
@@ -2158,7 +2390,8 @@ this request. Check sos/ows_enable_reque
 
             /* set map->projection to this SRS */
             if (msLoadProjectionString(&(map->projection), srsbuffer) != 0) {
-              msSetError(MS_SOSERR, "Could not set output projection to \"%s\"", "msSOSGetObservation()", sosparams->pszSrsName);
+              msSetError(MS_SOSERR, "Could not set output projection to \"%s\"",
+                         "msSOSGetObservation()", sosparams->pszSrsName);
               return msSOSException(map, "mapserv", "NoApplicableCode");
             }
 
@@ -2173,11 +2406,13 @@ this request. Check sos/ows_enable_reque
         msFreeCharArray(tokens, n);
       }
       if (bFound == 0) {
-        msSetError(MS_SOSERR, "srsName value \"%s\" unsupported / invalid", "msSOSGetObservation()", sosparams->pszSrsName);
+        msSetError(MS_SOSERR, "srsName value \"%s\" unsupported / invalid",
+                   "msSOSGetObservation()", sosparams->pszSrsName);
         return msSOSException(map, "srsName", "InvalidParameterValue");
       }
     } else {
-      msSetError(MS_SOSERR, "MAP.WEB.METADATA.sos_srs not set", "msSOSGetObservation()");
+      msSetError(MS_SOSERR, "MAP.WEB.METADATA.sos_srs not set",
+                 "msSOSGetObservation()");
       return msSOSException(map, "mapserv", "NoApplicableCode");
     }
   }
@@ -2187,20 +2422,24 @@ this request. Check sos/ows_enable_reque
     psFilterNode = FLTParseFilterEncoding(sosparams->pszResult);
 
     if (!psFilterNode) {
-      msSetError(MS_SOSERR, "Invalid or Unsupported RESULT in GetObservation: %s", "msSOSGetObservation()", sosparams->pszResult);
+      msSetError(MS_SOSERR,
+                 "Invalid or Unsupported RESULT in GetObservation: %s",
+                 "msSOSGetObservation()", sosparams->pszResult);
       return msSOSException(map, "result", "InvalidParameterValue");
     }
     /* apply the filter to all layers that are on */
-    for (i=0; i<map->numlayers; i++) {
+    for (i = 0; i < map->numlayers; i++) {
       lp = GET_LAYER(map, i);
       if (lp->status == MS_ON) {
         /* preparse parser so that alias for fields can be used */
         FLTPreParseFilterForAliasAndGroup(psFilterNode, map, i, "S");
         /* validate that the property names used are valid
           (there is a corresponding layer attribute) */
-        if (msLayerOpen(lp) == MS_SUCCESS && msLayerGetItems(lp) == MS_SUCCESS) {
-          if (msSOSValidateFilter(psFilterNode, lp)== MS_FALSE) {
-            msSetError(MS_SOSERR, "Invalid component name in RESULT statement", "msSOSGetObservation()");
+        if (msLayerOpen(lp) == MS_SUCCESS &&
+            msLayerGetItems(lp) == MS_SUCCESS) {
+          if (msSOSValidateFilter(psFilterNode, lp) == MS_FALSE) {
+            msSetError(MS_SOSERR, "Invalid component name in RESULT statement",
+                       "msSOSGetObservation()");
             return msSOSException(map, "result", "InvalidParameterValue");
           }
           msLayerClose(lp);
@@ -2212,17 +2451,16 @@ this request. Check sos/ows_enable_reque
     FLTFreeFilterEncodingNode(psFilterNode);
   }
 
-
-
-  /* this is just a fall back if bbox is enetered. The bbox parameter is not supported
-     by the sos specs */
+  /* this is just a fall back if bbox is enetered. The bbox parameter is not
+     supported by the sos specs */
   if (sosparams->pszBBox && !sosparams->pszFeatureOfInterest) {
     char **tokens;
     int n;
 
     tokens = msStringSplit(sosparams->pszBBox, ',', &n);
-    if (tokens==NULL || n != 4) {
-      msSetError(MS_SOSERR, "Wrong number of arguments for bounding box.", "msSOSGetObservation()");
+    if (tokens == NULL || n != 4) {
+      msSetError(MS_SOSERR, "Wrong number of arguments for bounding box.",
+                 "msSOSGetObservation()");
       return msSOSException(map, "bbox", "InvalidParameterValue");
     }
     sBbox.minx = atof(tokens[0]);
@@ -2233,8 +2471,8 @@ this request. Check sos/ows_enable_reque
   }
 
   /* do the query if the filter encoding (pszResult) is not part of the request.
-     If pszResult is available, the query on the layers will be done when the filter
-     is parsed*/
+     If pszResult is available, the query on the layers will be done when the
+     filter is parsed*/
   if (!sosparams->pszResult) {
     map->query.type = MS_QUERY_BY_RECT;
     map->query.mode = MS_QUERY_MULTIPLE;
@@ -2244,8 +2482,9 @@ this request. Check sos/ows_enable_reque
   }
 
   /*get the first layers of the offering*/
-  for (i=0; i<map->numlayers; i++) {
-    pszTmp = msOWSLookupMetadata(&(GET_LAYER(map, i)->metadata), "S", "offering_id");
+  for (i = 0; i < map->numlayers; i++) {
+    pszTmp =
+        msOWSLookupMetadata(&(GET_LAYER(map, i)->metadata), "S", "offering_id");
     if (pszTmp && (strcasecmp(pszTmp, sosparams->pszOffering) == 0)) {
       lp = (GET_LAYER(map, i));
       break;
@@ -2254,58 +2493,89 @@ this request. Check sos/ows_enable_reque
 
   /* build xml return tree*/
 
-  psNsSos = xmlNewNs(NULL, BAD_CAST "http://www.opengis.net/sos/1.0", BAD_CAST "sos");
-  psNsGml = xmlNewNs(NULL, BAD_CAST "http://www.opengis.net/gml", BAD_CAST "gml");
-  psNsOm = xmlNewNs(NULL, BAD_CAST pszOMNamespaceUri, BAD_CAST pszOMNamespacePrefix);
-  psNsSwe = xmlNewNs(NULL, BAD_CAST "http://www.opengis.net/swe/1.0.1", BAD_CAST "swe");
-  psNsXLink = xmlNewNs(NULL, BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_PREFIX);
-  psNsMs = xmlNewNs(NULL, BAD_CAST user_namespace_uri, BAD_CAST user_namespace_prefix);
+  psNsSos =
+      xmlNewNs(NULL, BAD_CAST "http://www.opengis.net/sos/1.0", BAD_CAST "sos");
+  psNsGml =
+      xmlNewNs(NULL, BAD_CAST "http://www.opengis.net/gml", BAD_CAST "gml");
+  psNsOm =
+      xmlNewNs(NULL, BAD_CAST pszOMNamespaceUri, BAD_CAST pszOMNamespacePrefix);
+  psNsSwe = xmlNewNs(NULL, BAD_CAST "http://www.opengis.net/swe/1.0.1",
+                     BAD_CAST "swe");
+  psNsXLink = xmlNewNs(NULL, BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_URI,
+                       BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_PREFIX);
+  psNsMs = xmlNewNs(NULL, BAD_CAST user_namespace_uri,
+                    BAD_CAST user_namespace_prefix);
 
   psDoc = xmlNewDoc(BAD_CAST "1.0");
   psRootNode = xmlNewNode(NULL, BAD_CAST "ObservationCollection");
   xmlDocSetRootElement(psDoc, psRootNode);
 
-  xmlSetNs(psRootNode,  xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/gml", BAD_CAST "gml"));
-  xmlSetNs(psRootNode,  xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/ows/1.1", BAD_CAST "ows"));
-  xmlSetNs(psRootNode,  xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/swe/1.0.1", BAD_CAST "swe"));
-  xmlSetNs(psRootNode,  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_PREFIX));
-  xmlSetNs(psRootNode,  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX));
-  xmlSetNs(psRootNode,  xmlNewNs(psRootNode, BAD_CAST pszSOSNamespaceUri, BAD_CAST pszSOSNamespacePrefix));
-  xmlSetNs(psRootNode,  xmlNewNs(psRootNode, BAD_CAST user_namespace_uri, BAD_CAST user_namespace_prefix));
-  xmlSetNs(psRootNode,  xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/om/1.0", BAD_CAST "om"));
+  xmlSetNs(psRootNode,
+           xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/gml",
+                    BAD_CAST "gml"));
+  xmlSetNs(psRootNode,
+           xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/ows/1.1",
+                    BAD_CAST "ows"));
+  xmlSetNs(psRootNode,
+           xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/swe/1.0.1",
+                    BAD_CAST "swe"));
+  xmlSetNs(psRootNode,
+           xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_URI,
+                    BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_PREFIX));
+  xmlSetNs(psRootNode,
+           xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI,
+                    BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX));
+  xmlSetNs(psRootNode, xmlNewNs(psRootNode, BAD_CAST pszSOSNamespaceUri,
+                                BAD_CAST pszSOSNamespacePrefix));
+  xmlSetNs(psRootNode, xmlNewNs(psRootNode, BAD_CAST user_namespace_uri,
+                                BAD_CAST user_namespace_prefix));
+  xmlSetNs(psRootNode,
+           xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/om/1.0",
+                    BAD_CAST "om"));
 
-  xmlNewNsProp(psRootNode, psNsGml, BAD_CAST "id", BAD_CAST sosparams->pszOffering);
+  xmlNewNsProp(psRootNode, psNsGml, BAD_CAST "id",
+               BAD_CAST sosparams->pszOffering);
 
   schemalocation = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
 
-  if ((script_url=msOWSGetOnlineResource(map, "SO", "onlineresource", req)) == NULL)
-  {
+  if ((script_url = msOWSGetOnlineResource(map, "SO", "onlineresource", req)) ==
+      NULL) {
     free(schemalocation);
     return msSOSException(map, "NoApplicableCode", "NoApplicableCode");
   }
 
   xsi_schemaLocation = msStrdup("http://www.opengis.net/om/1.0 ");
   xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, schemalocation);
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, "/om/1.0.0/om.xsd ");
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, (char *) user_namespace_uri);
+  xsi_schemaLocation =
+      msStringConcatenate(xsi_schemaLocation, "/om/1.0.0/om.xsd ");
+  xsi_schemaLocation =
+      msStringConcatenate(xsi_schemaLocation, (char *)user_namespace_uri);
   xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, (char *) script_url);
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, "service=WFS&version=1.1.0&request=DescribeFeatureType&typename=");
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, (char *) opLayerName);
-  xmlNewNsProp(psRootNode, NULL, BAD_CAST "xsi:schemaLocation", BAD_CAST xsi_schemaLocation);
+  xsi_schemaLocation =
+      msStringConcatenate(xsi_schemaLocation, (char *)script_url);
+  xsi_schemaLocation = msStringConcatenate(
+      xsi_schemaLocation,
+      "service=WFS&version=1.1.0&request=DescribeFeatureType&typename=");
+  xsi_schemaLocation =
+      msStringConcatenate(xsi_schemaLocation, (char *)opLayerName);
+  xmlNewNsProp(psRootNode, NULL, BAD_CAST "xsi:schemaLocation",
+               BAD_CAST xsi_schemaLocation);
 
   /* description */
   pszTmp = msOWSLookupMetadata(&(lp->metadata), "S", "offering_description");
   if (pszTmp) {
-    psNode = xmlNewChild(psRootNode, NULL, BAD_CAST "description", BAD_CAST pszTmp);
-    xmlSetNs(psNode, xmlNewNs(psNode, BAD_CAST "http://www.opengis.net/gml", BAD_CAST "gml"));
+    psNode =
+        xmlNewChild(psRootNode, NULL, BAD_CAST "description", BAD_CAST pszTmp);
+    xmlSetNs(psNode, xmlNewNs(psNode, BAD_CAST "http://www.opengis.net/gml",
+                              BAD_CAST "gml"));
   }
 
   /* name */
   pszTmp = msOWSLookupMetadata(&(lp->metadata), "S", "offering_name");
   if (pszTmp) {
     psNode = xmlNewChild(psRootNode, NULL, BAD_CAST "name", BAD_CAST pszTmp);
-    xmlSetNs(psNode, xmlNewNs(psNode, BAD_CAST "http://www.opengis.net/gml", BAD_CAST "gml"));
+    xmlSetNs(psNode, xmlNewNs(psNode, BAD_CAST "http://www.opengis.net/gml",
+                              BAD_CAST "gml"));
   }
 
   /* extent */
@@ -2317,14 +2587,17 @@ this request. Check sos/ows_enable_reque
     int n;
     rectObj envelope;
 
-    msOWSGetEPSGProj(&(map->projection), &(lp->metadata), "SO", MS_TRUE, &pszMapEpsg);
+    msOWSGetEPSGProj(&(map->projection), &(lp->metadata), "SO", MS_TRUE,
+                     &pszMapEpsg);
 
     tokens = msStringSplit(pszTmp, ',', &n);
-    if (tokens==NULL || n != 4) {
-      msSetError(MS_SOSERR, "Wrong number of arguments for sos_offering_extent.",
+    if (tokens == NULL || n != 4) {
+      msSetError(MS_SOSERR,
+                 "Wrong number of arguments for sos_offering_extent.",
                  "msSOSGetCapabilities()");
       msFree(script_url);
-      return msSOSException(map, "sos_offering_extent", "InvalidParameterValue");
+      return msSOSException(map, "sos_offering_extent",
+                            "InvalidParameterValue");
     }
 
     envelope.minx = atof(tokens[0]);
@@ -2332,15 +2605,23 @@ this request. Check sos/ows_enable_reque
     envelope.maxx = atof(tokens[2]);
     envelope.maxy = atof(tokens[3]);
 
-    if (map && msProjectionsDiffer(&map->projection, &lp->projection) == MS_TRUE) {
-      if (msProjectRect(&lp->projection, &map->projection, &envelope) == MS_FAILURE) {
-        msSetError(MS_SOSERR, "Coordinates transformation failed.  Raised in msProjectRect() of file %s line %d", "msSOSGetCapabilities()", __FILE__, __LINE__);
+    if (map &&
+        msProjectionsDiffer(&map->projection, &lp->projection) == MS_TRUE) {
+      if (msProjectRect(&lp->projection, &map->projection, &envelope) ==
+          MS_FAILURE) {
+        msSetError(MS_SOSERR,
+                   "Coordinates transformation failed.  Raised in "
+                   "msProjectRect() of file %s line %d",
+                   "msSOSGetCapabilities()", __FILE__, __LINE__);
         msFree(script_url);
-        return msSOSException(map, "sos_offering_extent", "InvalidParameterValue");
+        return msSOSException(map, "sos_offering_extent",
+                              "InvalidParameterValue");
       }
     }
 
-    psNode = xmlAddChild(psRootNode, msGML3BoundedBy(psNsGml, envelope.minx, envelope.miny, envelope.maxx, envelope.maxy, pszMapEpsg));
+    psNode = xmlAddChild(
+        psRootNode, msGML3BoundedBy(psNsGml, envelope.minx, envelope.miny,
+                                    envelope.maxx, envelope.maxy, pszMapEpsg));
     msFreeCharArray(tokens, n);
     msFree(pszMapEpsg);
   }
@@ -2354,24 +2635,28 @@ this request. Check sos/ows_enable_reque
       char *pszEndTime = NULL;
       tokens = msStringSplit(pszTmp, '/', &n);
       if (tokens==NULL || (n != 1 && n!=2)) {
-          msSetError(MS_SOSERR, "Wrong number of arguments for sos_offering_timeextent.",
-                     "msSOSGetCapabilities()");
-          return msSOSException(map, "sos_offering_timeextent", "InvalidParameterValue");
+          msSetError(MS_SOSERR, "Wrong number of arguments for
+  sos_offering_timeextent.", "msSOSGetCapabilities()"); return
+  msSOSException(map, "sos_offering_timeextent", "InvalidParameterValue");
       }
   */
   /*    if (n == 2) */ /* end time is empty. It is going to be set as "now" */
   /*      pszEndTime = tokens[1];
 
-        psNode = xmlAddChild(psRootNode, msSOSAddTimeNode(xmlNewNs(NULL, BAD_CAST pszOMNamespaceUri, BAD_CAST pszOMNamespacePrefix), tokens[0], pszEndTime));
-      psNode = xmlAddChild(psRootNode, msSOSAddTimeNode(psNsOm, psNsGml, tokens[0], pszEndTime));
-      msFreeCharArray(tokens, n);
+        psNode = xmlAddChild(psRootNode, msSOSAddTimeNode(xmlNewNs(NULL,
+  BAD_CAST pszOMNamespaceUri, BAD_CAST pszOMNamespacePrefix), tokens[0],
+  pszEndTime)); psNode = xmlAddChild(psRootNode, msSOSAddTimeNode(psNsOm,
+  psNsGml, tokens[0], pszEndTime)); msFreeCharArray(tokens, n);
 
   }
   */
 
-  if (sosparams->pszResultModel && strcasecmp(sosparams->pszResultModel, "om:Measurement") != 0 &&
+  if (sosparams->pszResultModel &&
+      strcasecmp(sosparams->pszResultModel, "om:Measurement") != 0 &&
       strcasecmp(sosparams->pszResultModel, "om:Observation") != 0) {
-    msSetError(MS_SOSERR, "resultModel should be om:Measurement or om:Observation", "msSOSGetObservation()");
+    msSetError(MS_SOSERR,
+               "resultModel should be om:Measurement or om:Observation",
+               "msSOSGetObservation()");
     free(xsi_schemaLocation);
     free(schemalocation);
     msFree(script_url);
@@ -2387,8 +2672,9 @@ this request. Check sos/ows_enable_reque
 
   else {
     /* output result members */
-    for (i=0; i<map->numlayers; i++) {
-      if (GET_LAYER(map, i)->resultcache && GET_LAYER(map, i)->resultcache->numresults > 0) {
+    for (i = 0; i < map->numlayers; i++) {
+      if (GET_LAYER(map, i)->resultcache &&
+          GET_LAYER(map, i)->resultcache->numresults > 0) {
         msLayerGetItems((GET_LAYER(map, i)));
         pszTmp = msOWSLookupMetadata(&(map->web.metadata), "SO", "maxfeatures");
         if (pszTmp != NULL)
@@ -2396,22 +2682,29 @@ this request. Check sos/ows_enable_reque
         else
           n1 = 0;
 
-        if (sosparams->pszResultModel == NULL || strcasecmp(sosparams->pszResultModel, "om:Measurement") == 0) {
-          for(j=0; j<GET_LAYER(map, i)->resultcache->numresults; j++) {
-            msSOSAddMemberNode(psNsGml, psNsOm, psNsSwe, psNsXLink, psNsMs, psRootNode, map, (GET_LAYER(map, i)), j, script_url, opLayerName);
-            if (j == n1-1)
+        if (sosparams->pszResultModel == NULL ||
+            strcasecmp(sosparams->pszResultModel, "om:Measurement") == 0) {
+          for (j = 0; j < GET_LAYER(map, i)->resultcache->numresults; j++) {
+            msSOSAddMemberNode(psNsGml, psNsOm, psNsSwe, psNsXLink, psNsMs,
+                               psRootNode, map, (GET_LAYER(map, i)), j,
+                               script_url, opLayerName);
+            if (j == n1 - 1)
               break;
           }
         } else { /*assuming here that pszResultModel = observation */
           /*layer does not define a procedure_item: this means one procedure per
             layer defined using sos_procedure)*/
-          if (msOWSLookupMetadata(&(GET_LAYER(map, i)->metadata), "S", "procedure_item") == NULL) {
-            pszProcedure = msOWSLookupMetadata(&(lp->metadata), "S", "procedure");
-            psObservationNode = msSOSAddMemberNodeObservation(psNsGml, psNsOm, psNsSwe, psNsXLink, psRootNode, map, (GET_LAYER(map, i)),
-                                pszProcedure);
+          if (msOWSLookupMetadata(&(GET_LAYER(map, i)->metadata), "S",
+                                  "procedure_item") == NULL) {
+            pszProcedure =
+                msOWSLookupMetadata(&(lp->metadata), "S", "procedure");
+            psObservationNode = msSOSAddMemberNodeObservation(
+                psNsGml, psNsOm, psNsSwe, psNsXLink, psRootNode, map,
+                (GET_LAYER(map, i)), pszProcedure);
             /*add a result node*/
-            psResultNode = xmlNewChild(psObservationNode, NULL, BAD_CAST "result", NULL);
-            for(j=0; j<GET_LAYER(map, i)->resultcache->numresults; j++) {
+            psResultNode =
+                xmlNewChild(psObservationNode, NULL, BAD_CAST "result", NULL);
+            for (j = 0; j < GET_LAYER(map, i)->resultcache->numresults; j++) {
               /*add a block separator*/
               if (j > 0) {
                 pszBlockSep = msOWSLookupMetadata(&(map->web.metadata), "S",
@@ -2422,7 +2715,8 @@ this request. Check sos/ows_enable_reque
                   xmlNodeAddContent(psResultNode, BAD_CAST "\n");
               }
               {
-                char* pszResult = msSOSReturnMemberResult((GET_LAYER(map, i)), j, NULL);
+                char *pszResult =
+                    msSOSReturnMemberResult((GET_LAYER(map, i)), j, NULL);
                 if (pszResult) {
                   xmlNodeAddContent(psResultNode, BAD_CAST pszResult);
                   msFree(pszResult);
@@ -2430,56 +2724,63 @@ this request. Check sos/ows_enable_reque
               }
             }
           }
-          /*this is the case where procedure_item is used. Needs more management since
-            the same data on a layer contains different procedures (procedures are
-            one of the fields of the record)*/
+          /*this is the case where procedure_item is used. Needs more management
+            since the same data on a layer contains different procedures
+            (procedures are one of the fields of the record)*/
           else {
 
-            for(j=0; j<GET_LAYER(map, i)->resultcache->numresults; j++) {
-              char* pszProcedureValue = NULL;
-              char* pszResult = msSOSReturnMemberResult((GET_LAYER(map, i)), j, &pszProcedureValue);
-              if (!pszProcedureValue || !pszResult)
-              {
+            for (j = 0; j < GET_LAYER(map, i)->resultcache->numresults; j++) {
+              char *pszProcedureValue = NULL;
+              char *pszResult = msSOSReturnMemberResult((GET_LAYER(map, i)), j,
+                                                        &pszProcedureValue);
+              if (!pszProcedureValue || !pszResult) {
                 msFree(pszProcedureValue);
                 msFree(pszResult);
                 continue;
               }
-              for (k=0; k<nDiffrentProc; k++) {
-                if (strcasecmp(paDiffrentProc[k].pszProcedure, pszProcedureValue) == 0) {
+              for (k = 0; k < nDiffrentProc; k++) {
+                if (strcasecmp(paDiffrentProc[k].pszProcedure,
+                               pszProcedureValue) == 0) {
                   pszBlockSep = msOWSLookupMetadata(&(map->web.metadata), "S",
                                                     "encoding_blockSeparator");
                   if (pszBlockSep)
-                    xmlNodeAddContent(paDiffrentProc[k].psResultNode, BAD_CAST pszBlockSep);
+                    xmlNodeAddContent(paDiffrentProc[k].psResultNode,
+                                      BAD_CAST pszBlockSep);
                   else
-                    xmlNodeAddContent(paDiffrentProc[k].psResultNode, BAD_CAST "\n");
-                  xmlNodeAddContent(paDiffrentProc[k].psResultNode, BAD_CAST pszResult);
+                    xmlNodeAddContent(paDiffrentProc[k].psResultNode,
+                                      BAD_CAST "\n");
+                  xmlNodeAddContent(paDiffrentProc[k].psResultNode,
+                                    BAD_CAST pszResult);
                   break;
                 }
               }
               if (k == nDiffrentProc) { /*a new procedure*/
                 nDiffrentProc++;
                 if (paDiffrentProc == NULL)
-                  paDiffrentProc = (SOSProcedureNode *)malloc(sizeof(SOSProcedureNode));
+                  paDiffrentProc =
+                      (SOSProcedureNode *)malloc(sizeof(SOSProcedureNode));
                 else
-                  paDiffrentProc = (SOSProcedureNode *)realloc(paDiffrentProc,
-                                   sizeof(SOSProcedureNode)
-                                   *nDiffrentProc);
-
-                paDiffrentProc[nDiffrentProc-1].pszProcedure = msStrdup(pszProcedureValue);
-                psObservationNode = msSOSAddMemberNodeObservation(psNsGml, psNsOm, psNsSwe, psNsXLink, psRootNode, map,
-                                    (GET_LAYER(map, i)),
-                                    pszProcedureValue);
-
-                paDiffrentProc[nDiffrentProc-1].psResultNode =
-                  xmlNewChild(psObservationNode, NULL, BAD_CAST "result", NULL);
+                  paDiffrentProc = (SOSProcedureNode *)realloc(
+                      paDiffrentProc, sizeof(SOSProcedureNode) * nDiffrentProc);
 
-                xmlNodeAddContent(paDiffrentProc[nDiffrentProc-1].psResultNode, BAD_CAST pszResult);
+                paDiffrentProc[nDiffrentProc - 1].pszProcedure =
+                    msStrdup(pszProcedureValue);
+                psObservationNode = msSOSAddMemberNodeObservation(
+                    psNsGml, psNsOm, psNsSwe, psNsXLink, psRootNode, map,
+                    (GET_LAYER(map, i)), pszProcedureValue);
+
+                paDiffrentProc[nDiffrentProc - 1].psResultNode = xmlNewChild(
+                    psObservationNode, NULL, BAD_CAST "result", NULL);
+
+                xmlNodeAddContent(
+                    paDiffrentProc[nDiffrentProc - 1].psResultNode,
+                    BAD_CAST pszResult);
               }
               msFree(pszProcedureValue);
               msFree(pszResult);
             }
             if (paDiffrentProc) {
-              for (k=0; k<nDiffrentProc; k++)
+              for (k = 0; k < nDiffrentProc; k++)
                 msFree(paDiffrentProc[k].pszProcedure);
               free(paDiffrentProc);
             }
@@ -2490,7 +2791,7 @@ this request. Check sos/ows_enable_reque
   }
 
   /* output results */
-  msIO_setHeader("Content-Type","text/xml; charset=UTF-8");
+  msIO_setHeader("Content-Type", "text/xml; charset=UTF-8");
   msIO_sendHeaders();
 
   context = msIO_getHandler(stdout);
@@ -2510,63 +2811,69 @@ this request. Check sos/ows_enable_reque
   /*free  document */
   xmlFreeDoc(psDoc);
   /*
-  *Free the global variables that may
-  *have been allocated by the parser.
-  */
+   *Free the global variables that may
+   *have been allocated by the parser.
+   */
   xmlCleanupParser();
 
-
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
-
-
 /************************************************************************/
 /*                           msSOSDescribeSensor                        */
 /*                                                                      */
 /*      Describe sensor request handler.                               */
 /************************************************************************/
-int msSOSDescribeSensor(mapObj *map, sosParamsObj *sosparams, owsRequestObj *ows_request)
-{
+int msSOSDescribeSensor(mapObj *map, sosParamsObj *sosparams,
+                        owsRequestObj *ows_request) {
   char *pszEncodedUrl = NULL;
   const char *pszId = NULL, *pszUrl = NULL;
-  int i = 0, j=0, k=0;
+  int i = 0, j = 0, k = 0;
   layerObj *lp = NULL;
   int iItemPosition = -1;
   shapeObj sShape;
   int status;
-  char *tmpstr = NULL, *pszTmp = NULL, *pszProcedureURI = NULL, *pszProcedureId = NULL;
+  char *tmpstr = NULL, *pszTmp = NULL, *pszProcedureURI = NULL,
+       *pszProcedureId = NULL;
 
   if (!sosparams->pszOutputFormat) {
-    msSetError(MS_SOSERR, "Missing mandatory parameter outputFormat.", "msSOSDescribeSensor()");
+    msSetError(MS_SOSERR, "Missing mandatory parameter outputFormat.",
+               "msSOSDescribeSensor()");
     return msSOSException(map, "outputformat", "MissingParameterValue");
   }
 
-  if (strcasecmp(sosparams->pszOutputFormat, pszSOSDescribeSensorMimeType) != 0) {
-    msSetError(MS_SOSERR, "Invalid outputformat parameter %s.  Allowable values are: %s", "msSOSDescribeSensor()", sosparams->pszOutputFormat, pszSOSDescribeSensorMimeType);
+  if (strcasecmp(sosparams->pszOutputFormat, pszSOSDescribeSensorMimeType) !=
+      0) {
+    msSetError(MS_SOSERR,
+               "Invalid outputformat parameter %s.  Allowable values are: %s",
+               "msSOSDescribeSensor()", sosparams->pszOutputFormat,
+               pszSOSDescribeSensorMimeType);
     return msSOSException(map, "outputformat", "InvalidParameterValue");
   }
 
   if (!sosparams->pszProcedure) {
-    msSetError(MS_SOSERR, "Missing mandatory parameter procedure", "msSOSDescribeSensor()");
+    msSetError(MS_SOSERR, "Missing mandatory parameter procedure",
+               "msSOSDescribeSensor()");
     return msSOSException(map, "procedure", "MissingParameterValue");
   }
 
-  for (i=0; i<map->numlayers; i++) {
+  for (i = 0; i < map->numlayers; i++) {
     lp = GET_LAYER(map, i);
     pszId = msOWSLookupMetadata(&(lp->metadata), "S", "procedure");
     if (pszId && strlen(pszId) > 0) {
       /*procedure could be a list*/
       char **tokens = NULL;
-      int n=0;
+      int n = 0;
       int bFound = 0;
       tokens = msStringSplit(pszId, ' ', &n);
-      for (k=0; k<n; k++) {
+      for (k = 0; k < n; k++) {
         if (tokens[k] && strlen(tokens[k]) > 0) {
           pszProcedureURI = msStrdup("urn:ogc:def:procedure:");
           pszProcedureURI = msStringConcatenate(pszProcedureURI, tokens[k]);
-          if ( (pszProcedureURI && strcasecmp(pszProcedureURI, sosparams->pszProcedure) == 0) &&
-               (msIntegerInArray(lp->index, ows_request->enabled_layers, ows_request->numlayers)) ) {
+          if ((pszProcedureURI &&
+               strcasecmp(pszProcedureURI, sosparams->pszProcedure) == 0) &&
+              (msIntegerInArray(lp->index, ows_request->enabled_layers,
+                                ows_request->numlayers))) {
             bFound = 1;
             pszProcedureId = msStrdup(tokens[k]);
             msFree(pszProcedureURI);
@@ -2577,14 +2884,15 @@ int msSOSDescribeSensor(mapObj *map, sos
       }
       msFreeCharArray(tokens, n);
       if (bFound) {
-        pszUrl = msOWSLookupMetadata(&(lp->metadata), "S", "describesensor_url");
+        pszUrl =
+            msOWSLookupMetadata(&(lp->metadata), "S", "describesensor_url");
         if (pszUrl) {
           pszTmp = msStrdup(pszUrl);
 
           /* %procedure% is the hardcoded variable name to use
              within sos_describesensor_url */
-          tmpstr = (char *)malloc(sizeof(char)*strlen("procedure") + 3);
-          sprintf(tmpstr,"%%%s%%", "procedure");
+          tmpstr = (char *)malloc(sizeof(char) * strlen("procedure") + 3);
+          sprintf(tmpstr, "%%%s%%", "procedure");
           if (strcasestr(pszUrl, tmpstr) != NULL)
             pszTmp = msCaseReplaceSubstring(pszTmp, tmpstr, pszProcedureId);
           msFree(tmpstr);
@@ -2594,16 +2902,21 @@ int msSOSDescribeSensor(mapObj *map, sos
           msFree(pszTmp);
           msFree(pszEncodedUrl);
           msFree(pszProcedureId);
-          return(MS_SUCCESS);
+          return (MS_SUCCESS);
         } else {
-          msSetError(MS_SOSERR, "Missing mandatory metadata sos_describesensor_url on layer %s", "msSOSDescribeSensor()", lp->name);
-          return msSOSException(map, "sos_describesensor_url", "MissingParameterValue");
+          msSetError(
+              MS_SOSERR,
+              "Missing mandatory metadata sos_describesensor_url on layer %s",
+              "msSOSDescribeSensor()", lp->name);
+          return msSOSException(map, "sos_describesensor_url",
+                                "MissingParameterValue");
         }
       }
-    } else if ((pszId = msOWSLookupMetadata(&(lp->metadata), "S", "procedure_item"))) {
+    } else if ((pszId = msOWSLookupMetadata(&(lp->metadata), "S",
+                                            "procedure_item"))) {
       iItemPosition = -1;
       if (msLayerOpen(lp) == MS_SUCCESS && msLayerGetItems(lp) == MS_SUCCESS) {
-        for(j=0; j<lp->numitems; j++) {
+        for (j = 0; j < lp->numitems; j++) {
           if (strcasecmp(lp->items[j], pszId) == 0) {
             iItemPosition = j;
             break;
@@ -2611,7 +2924,7 @@ int msSOSDescribeSensor(mapObj *map, sos
         }
         msLayerClose(lp);
       }
-      if (iItemPosition >=0) {
+      if (iItemPosition >= 0) {
         if (lp->template == NULL)
           lp->template = msStrdup("ttt");
 
@@ -2624,35 +2937,43 @@ int msSOSDescribeSensor(mapObj *map, sos
         msLayerGetItems(lp);
 
         if (lp->resultcache && lp->resultcache->numresults > 0) {
-          for(j=0; j<lp->resultcache->numresults; j++) {
+          for (j = 0; j < lp->resultcache->numresults; j++) {
             msInitShape(&sShape);
-            status = msLayerGetShape(lp, &sShape, &(lp->resultcache->results[j]));
-            if(status != MS_SUCCESS)
+            status =
+                msLayerGetShape(lp, &sShape, &(lp->resultcache->results[j]));
+            if (status != MS_SUCCESS)
               continue;
 
             if (sShape.values[iItemPosition]) {
               pszProcedureURI = msStrdup("urn:ogc:def:procedure:");
-              pszProcedureURI = msStringConcatenate(pszProcedureURI, sShape.values[iItemPosition]);
+              pszProcedureURI = msStringConcatenate(
+                  pszProcedureURI, sShape.values[iItemPosition]);
               if (strcasecmp(pszProcedureURI, sosparams->pszProcedure) == 0) {
-                pszUrl = msOWSLookupMetadata(&(lp->metadata), "S", "describesensor_url");
+                pszUrl = msOWSLookupMetadata(&(lp->metadata), "S",
+                                             "describesensor_url");
                 pszProcedureId = msStrdup(sShape.values[iItemPosition]);
                 if (pszUrl) {
                   pszTmp = msStrdup(pszUrl);
 
                   /* %procedure% is the hardcoded variable names to use
                      within sos_describesensor_url */
-                  tmpstr = (char *)malloc(sizeof(char)*strlen("procedure") + 3);
-                  sprintf(tmpstr,"%%%s%%", "procedure");
+                  tmpstr =
+                      (char *)malloc(sizeof(char) * strlen("procedure") + 3);
+                  sprintf(tmpstr, "%%%s%%", "procedure");
                   if (strcasestr(pszUrl, tmpstr) != NULL)
-                    pszTmp = msCaseReplaceSubstring(pszTmp, tmpstr, pszProcedureId);
+                    pszTmp =
+                        msCaseReplaceSubstring(pszTmp, tmpstr, pszProcedureId);
                   msFree(tmpstr);
 
                   pszEncodedUrl = msEncodeHTMLEntities(pszTmp);
                   msIO_printf("Location: %s\n\n", pszEncodedUrl);
                   msFree(pszTmp);
-                  return(MS_SUCCESS);
+                  return (MS_SUCCESS);
                 } else {
-                  msSetError(MS_SOSERR, "Missing mandatory metadata sos_describesensor_url on layer %s", "msSOSDescribeSensor()", lp->name);
+                  msSetError(MS_SOSERR,
+                             "Missing mandatory metadata "
+                             "sos_describesensor_url on layer %s",
+                             "msSOSDescribeSensor()", lp->name);
                   return msSOSException(map, "mapserv", "NoApplicableCode");
                 }
               }
@@ -2662,7 +2983,8 @@ int msSOSDescribeSensor(mapObj *map, sos
       }
     }
   }
-  msSetError(MS_SOSERR, "procedure %s not found.", "msSOSDescribeSensor()", sosparams->pszProcedure);
+  msSetError(MS_SOSERR, "procedure %s not found.", "msSOSDescribeSensor()",
+             sosparams->pszProcedure);
   return msSOSException(map, "procedure", "InvalidParameterValue");
 }
 
@@ -2671,31 +2993,35 @@ int msSOSDescribeSensor(mapObj *map, sos
 /*                                                                      */
 /*      DescribeObserrvationType request handler                        */
 /************************************************************************/
-int msSOSDescribeObservationType(mapObj *map, sosParamsObj *sosparams, cgiRequestObj *req, owsRequestObj *ows_request)
-{
+int msSOSDescribeObservationType(mapObj *map, sosParamsObj *sosparams,
+                                 cgiRequestObj *req,
+                                 owsRequestObj *ows_request) {
   int i, j, n = 0, bLayerFound = 0;
   char **tokens = NULL;
-  char *script_url=NULL;
+  char *script_url = NULL;
   const char *pszTmp = NULL;
-  char *pszTmp2=NULL;
+  char *pszTmp2 = NULL;
   const char *opLayerName = NULL;
 
   if (!sosparams->pszObservedProperty) {
-    msSetError(MS_SOSERR, "Missing mandatory parameter observedproperty", "msSOSDescribeObservationType()");
+    msSetError(MS_SOSERR, "Missing mandatory parameter observedproperty",
+               "msSOSDescribeObservationType()");
     return msSOSException(map, "observedproperty", "MissingParameterValue");
   }
 
   tokens = msStringSplit(sosparams->pszObservedProperty, ',', &n);
 
-  for (i=0; i<map->numlayers; i++) {
-    if (!msIntegerInArray(GET_LAYER(map, i)->index, ows_request->enabled_layers, ows_request->numlayers))
+  for (i = 0; i < map->numlayers; i++) {
+    if (!msIntegerInArray(GET_LAYER(map, i)->index, ows_request->enabled_layers,
+                          ows_request->numlayers))
       continue;
-    pszTmp = msOWSLookupMetadata(&(GET_LAYER(map, i)->metadata), "S", "observedproperty_id");
+    pszTmp = msOWSLookupMetadata(&(GET_LAYER(map, i)->metadata), "S",
+                                 "observedproperty_id");
     if (pszTmp) {
       if (strcasecmp(pszTmp, sosparams->pszObservedProperty) == 0) {
         if (tokens && n > 0) {
-          for (j=0; j<n; j++) {
-            if(strcasecmp(pszTmp, tokens[j]) == 0) {
+          for (j = 0; j < n; j++) {
+            if (strcasecmp(pszTmp, tokens[j]) == 0) {
               opLayerName = GET_LAYER(map, i)->name;
               bLayerFound = 1;
               break;
@@ -2709,24 +3035,27 @@ int msSOSDescribeObservationType(mapObj
     msFreeCharArray(tokens, n);
 
   if (bLayerFound == 0) {
-    msSetError(MS_SOSERR, "ObservedProperty %s not found.", "msSOSGetObservation()", sosparams->pszObservedProperty);
+    msSetError(MS_SOSERR, "ObservedProperty %s not found.",
+               "msSOSGetObservation()", sosparams->pszObservedProperty);
     return msSOSException(map, "observedproperty", "InvalidParameterValue");
   }
 
-  if ((script_url=msOWSGetOnlineResource(map, "SO", "onlineresource", req)) == NULL)
+  if ((script_url = msOWSGetOnlineResource(map, "SO", "onlineresource", req)) ==
+      NULL)
     return msSOSException(map, "NoApplicableCode", "NoApplicableCode");
 
-  pszTmp2 = msStringConcatenate(pszTmp2, (char *) script_url);
-  pszTmp2 = msStringConcatenate(pszTmp2, "service=WFS&version=1.1.0&request=DescribeFeatureType&typename=");
-  pszTmp2 = msStringConcatenate(pszTmp2, (char *) opLayerName);
+  pszTmp2 = msStringConcatenate(pszTmp2, (char *)script_url);
+  pszTmp2 = msStringConcatenate(
+      pszTmp2,
+      "service=WFS&version=1.1.0&request=DescribeFeatureType&typename=");
+  pszTmp2 = msStringConcatenate(pszTmp2, (char *)opLayerName);
 
   msIO_printf("Location: %s\n\n", pszTmp2);
   msFree(pszTmp2);
   msFree(script_url);
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
-
 #endif /* defined(USE_WCS_SVR) && defined(USE_LIBXML2) */
 
 /*
@@ -2734,8 +3063,7 @@ int msSOSDescribeObservationType(mapObj
 ** - If this is a valid request then it is processed and MS_SUCCESS is returned
 **   on success, or MS_FAILURE on failure.
 */
-int msSOSDispatch(mapObj *map, cgiRequestObj *req, owsRequestObj *ows_request)
-{
+int msSOSDispatch(mapObj *map, cgiRequestObj *req, owsRequestObj *ows_request) {
 #if defined(USE_SOS_SVR) && defined(USE_LIBXML2)
   int returnvalue = MS_DONE;
   sosParamsObj *paramsObj = (sosParamsObj *)calloc(1, sizeof(sosParamsObj));
@@ -2747,7 +3075,8 @@ int msSOSDispatch(mapObj *map, cgiReques
   }
 
   /* SERVICE must be specified and be SOS */
-  if (paramsObj->pszService && strcasecmp(paramsObj->pszService, "SOS") == 0) { /* this is an SOS request */
+  if (paramsObj->pszService && strcasecmp(paramsObj->pszService, "SOS") ==
+                                   0) { /* this is an SOS request */
     if (!paramsObj->pszRequest) {
       msSetError(MS_SOSERR, "Missing REQUEST Parameter", "msSOSDispatch()");
       msSOSFreeParamsObj(paramsObj);
@@ -2758,7 +3087,10 @@ int msSOSDispatch(mapObj *map, cgiReques
 
     msOWSRequestLayersEnabled(map, "S", paramsObj->pszRequest, ows_request);
     if (ows_request->numlayers == 0) {
-      msSetError(MS_SOSERR, "SOS request not enabled. Check sos/ows_enable_request settings.", "msSOSDispatch()");
+      msSetError(
+          MS_SOSERR,
+          "SOS request not enabled. Check sos/ows_enable_request settings.",
+          "msSOSDispatch()");
       msSOSFreeParamsObj(paramsObj);
       free(paramsObj);
       paramsObj = NULL;
@@ -2775,8 +3107,8 @@ int msSOSDispatch(mapObj *map, cgiReques
 
     else if (strcasecmp(paramsObj->pszRequest, "DescribeSensor") == 0 ||
              strcasecmp(paramsObj->pszRequest, "GetObservation") == 0 ||
-             strcasecmp(paramsObj->pszRequest, "DescribeObservationType") == 0
-            ) {
+             strcasecmp(paramsObj->pszRequest, "DescribeObservationType") ==
+                 0) {
       /* check version */
       if (!paramsObj->pszVersion) {
         msSetError(MS_SOSERR, "Missing VERSION parameter", "msSOSDispatch()");
@@ -2787,7 +3119,9 @@ int msSOSDispatch(mapObj *map, cgiReques
       }
 
       if (msOWSParseVersionString(paramsObj->pszVersion) != OWS_1_0_0) {
-        msSetError(MS_SOSERR, "VERSION %s not supported.  Supported versions are: %s.", "msSOSDispatch()", paramsObj->pszVersion, pszSOSVersion);
+        msSetError(MS_SOSERR,
+                   "VERSION %s not supported.  Supported versions are: %s.",
+                   "msSOSDispatch()", paramsObj->pszVersion, pszSOSVersion);
         msSOSFreeParamsObj(paramsObj);
         free(paramsObj);
         paramsObj = NULL;
@@ -2800,15 +3134,18 @@ int msSOSDispatch(mapObj *map, cgiReques
       else if (strcasecmp(paramsObj->pszRequest, "GetObservation") == 0)
         returnvalue = msSOSGetObservation(map, paramsObj, req, ows_request);
 
-      else if (strcasecmp(paramsObj->pszRequest, "DescribeObservationType") == 0)
-        returnvalue = msSOSDescribeObservationType(map, paramsObj, req, ows_request);
+      else if (strcasecmp(paramsObj->pszRequest, "DescribeObservationType") ==
+               0)
+        returnvalue =
+            msSOSDescribeObservationType(map, paramsObj, req, ows_request);
 
       msSOSFreeParamsObj(paramsObj);
       free(paramsObj);
       paramsObj = NULL;
       return returnvalue;
     } else {
-      msSetError(MS_SOSERR, "Invalid REQUEST parameter: %s", "msSOSDispatch()", paramsObj->pszRequest);
+      msSetError(MS_SOSERR, "Invalid REQUEST parameter: %s", "msSOSDispatch()",
+                 paramsObj->pszRequest);
       msSOSFreeParamsObj(paramsObj);
       free(paramsObj);
       paramsObj = NULL;
@@ -2817,18 +3154,18 @@ int msSOSDispatch(mapObj *map, cgiReques
   } else {
     msSOSFreeParamsObj(paramsObj);
     free(paramsObj);
-    return MS_DONE;  /* Not an SOS request */
+    return MS_DONE; /* Not an SOS request */
   }
 #else
   msSetError(MS_SOSERR, "SOS support is not available.", "msSOSDispatch()");
-  return(MS_FAILURE);
+  return (MS_FAILURE);
 #endif
 }
 
 #if defined(USE_SOS_SVR) && defined(USE_LIBXML2)
 
-int msSOSParseRequest(mapObj *map, cgiRequestObj *request, sosParamsObj *sosparams)
-{
+int msSOSParseRequest(mapObj *map, cgiRequestObj *request,
+                      sosParamsObj *sosparams) {
   int i;
   xmlDocPtr doc;
   xmlXPathContextPtr context;
@@ -2837,7 +3174,7 @@ int msSOSParseRequest(mapObj *map, cgiRe
   char *pszTmp = NULL;
 
   if (request->NumParams) { /* this is a GET request */
-    for(i=0; i<request->NumParams; i++) {
+    for (i = 0; i < request->NumParams; i++) {
       if (strcasecmp(request->ParamNames[i], "SERVICE") == 0)
         sosparams->pszService = msStrdup(request->ParamValues[i]);
       else if (strcasecmp(request->ParamNames[i], "VERSION") == 0)
@@ -2848,9 +3185,9 @@ int msSOSParseRequest(mapObj *map, cgiRe
         sosparams->pszRequest = msStrdup(request->ParamValues[i]);
       else if (strcasecmp(request->ParamNames[i], "UPDATESEQUENCE") == 0)
         sosparams->pszUpdateSequence = msStrdup(request->ParamValues[i]);
-      else  if (strcasecmp(request->ParamNames[i], "SENSORID") == 0)
+      else if (strcasecmp(request->ParamNames[i], "SENSORID") == 0)
         sosparams->pszSensorId = msStrdup(request->ParamValues[i]);
-      else  if (strcasecmp(request->ParamNames[i], "PROCEDURE") == 0)
+      else if (strcasecmp(request->ParamNames[i], "PROCEDURE") == 0)
         sosparams->pszProcedure = msStrdup(request->ParamValues[i]);
       else if (strcasecmp(request->ParamNames[i], "OUTPUTFORMAT") == 0)
         sosparams->pszOutputFormat = msStrdup(request->ParamValues[i]);
@@ -2880,24 +3217,32 @@ int msSOSParseRequest(mapObj *map, cgiRe
   if (request->postrequest) { /* this a POST request */
     /* load document */
     doc = xmlParseDoc((xmlChar *)request->postrequest);
-    if (doc == NULL ) {
-      msSetError(MS_SOSERR, "Invalid POST request.  XML is not well-formed", "msSOSParseRequest()");
+    if (doc == NULL) {
+      msSetError(MS_SOSERR, "Invalid POST request.  XML is not well-formed",
+                 "msSOSParseRequest()");
       return msSOSException(map, "request", "InvalidRequest");
     }
 
     /* load context */
     context = xmlXPathNewContext(doc);
     if (context == NULL) {
-      msSetError(MS_SOSERR, "Could not create context (xmlXPathNewContext)", "msSOSParseRequest()");
+      msSetError(MS_SOSERR, "Could not create context (xmlXPathNewContext)",
+                 "msSOSParseRequest()");
       return msSOSException(map, "request", "NoApplicableCode");
     }
 
     /* register namespaces */
-    if(xmlXPathRegisterNs(context, (xmlChar *)"sos", (xmlChar *)"http://www.opengis.net/sos/1.0") != 0 ||
-        xmlXPathRegisterNs(context, (xmlChar *)"ows", (xmlChar *)"http://www.opengis.net/ows/1.1") != 0 ||
-        xmlXPathRegisterNs(context, (xmlChar *)"ogc", (xmlChar *)"http://www.opengis.net/ogc") != 0 ||
-        xmlXPathRegisterNs(context, (xmlChar *)"gml", (xmlChar *)"http://www.opengis.net/gml") != 0) {
-      msSetError(MS_SOSERR, "Could not register namespaces (xmlXPathRegisterNs)", "msSOSParseRequest()");
+    if (xmlXPathRegisterNs(context, (xmlChar *)"sos",
+                           (xmlChar *)"http://www.opengis.net/sos/1.0") != 0 ||
+        xmlXPathRegisterNs(context, (xmlChar *)"ows",
+                           (xmlChar *)"http://www.opengis.net/ows/1.1") != 0 ||
+        xmlXPathRegisterNs(context, (xmlChar *)"ogc",
+                           (xmlChar *)"http://www.opengis.net/ogc") != 0 ||
+        xmlXPathRegisterNs(context, (xmlChar *)"gml",
+                           (xmlChar *)"http://www.opengis.net/gml") != 0) {
+      msSetError(MS_SOSERR,
+                 "Could not register namespaces (xmlXPathRegisterNs)",
+                 "msSOSParseRequest()");
       return msSOSException(map, "request", "NoApplicableCode");
     }
 
@@ -2906,55 +3251,65 @@ int msSOSParseRequest(mapObj *map, cgiRe
 
     if (psXPathTmp) {
       nodeset = psXPathTmp->nodesetval;
-      sosparams->pszService = (char *)xmlNodeListGetString(doc, nodeset->nodeTab[0]->xmlChildrenNode, 1);
+      sosparams->pszService = (char *)xmlNodeListGetString(
+          doc, nodeset->nodeTab[0]->xmlChildrenNode, 1);
     }
 
     xmlXPathFreeObject(psXPathTmp);
 
     /* check for updateSequence*/
-    psXPathTmp = msLibXml2GetXPath(doc, context, (xmlChar *)"/*/@updateSequence");
+    psXPathTmp =
+        msLibXml2GetXPath(doc, context, (xmlChar *)"/*/@updateSequence");
 
     if (psXPathTmp) {
       nodeset = psXPathTmp->nodesetval;
-      sosparams->pszUpdateSequence = (char *)xmlNodeListGetString(doc, nodeset->nodeTab[0]->xmlChildrenNode, 1);
+      sosparams->pszUpdateSequence = (char *)xmlNodeListGetString(
+          doc, nodeset->nodeTab[0]->xmlChildrenNode, 1);
     }
 
     xmlXPathFreeObject(psXPathTmp);
 
     /* check for version */
-    psXPathTmp = msLibXml2GetXPath(doc, context, (xmlChar *)"/*/ows:AcceptVersions/ows:Version|/*/@version");
+    psXPathTmp = msLibXml2GetXPath(
+        doc, context,
+        (xmlChar *)"/*/ows:AcceptVersions/ows:Version|/*/@version");
 
     if (psXPathTmp) {
       nodeset = psXPathTmp->nodesetval;
-      sosparams->pszVersion = (char *)xmlNodeListGetString(doc, nodeset->nodeTab[0]->xmlChildrenNode, 1);
+      sosparams->pszVersion = (char *)xmlNodeListGetString(
+          doc, nodeset->nodeTab[0]->xmlChildrenNode, 1);
     }
 
     xmlXPathFreeObject(psXPathTmp);
 
     /* check for request */
 
-    psXPathTmp = msLibXml2GetXPath(doc, context, (xmlChar *)"/sos:GetCapabilities");
+    psXPathTmp =
+        msLibXml2GetXPath(doc, context, (xmlChar *)"/sos:GetCapabilities");
 
     if (psXPathTmp)
       sosparams->pszRequest = msStrdup("GetCapabilities");
 
     xmlXPathFreeObject(psXPathTmp);
 
-    psXPathTmp = msLibXml2GetXPath(doc, context, (xmlChar *)"/sos:DescribeSensor");
+    psXPathTmp =
+        msLibXml2GetXPath(doc, context, (xmlChar *)"/sos:DescribeSensor");
 
     if (psXPathTmp)
       sosparams->pszRequest = msStrdup("DescribeSensor");
 
     xmlXPathFreeObject(psXPathTmp);
 
-    psXPathTmp = msLibXml2GetXPath(doc, context, (xmlChar *)"/sos:GetObservation");
+    psXPathTmp =
+        msLibXml2GetXPath(doc, context, (xmlChar *)"/sos:GetObservation");
 
     if (psXPathTmp)
       sosparams->pszRequest = msStrdup("GetObservation");
 
     xmlXPathFreeObject(psXPathTmp);
 
-    psXPathTmp = msLibXml2GetXPath(doc, context, (xmlChar *)"/sos:DescribeObservationType");
+    psXPathTmp = msLibXml2GetXPath(doc, context,
+                                   (xmlChar *)"/sos:DescribeObservationType");
 
     if (psXPathTmp)
       sosparams->pszRequest = msStrdup("DescribeObservationType");
@@ -2962,97 +3317,116 @@ int msSOSParseRequest(mapObj *map, cgiRe
     xmlXPathFreeObject(psXPathTmp);
 
     /* check for outputformat */
-    psXPathTmp = msLibXml2GetXPath(doc, context, (xmlChar *)"/sos:DescribeSensor/@outputFormat");
+    psXPathTmp = msLibXml2GetXPath(
+        doc, context, (xmlChar *)"/sos:DescribeSensor/@outputFormat");
 
     if (psXPathTmp) {
       nodeset = psXPathTmp->nodesetval;
-      sosparams->pszOutputFormat = (char *)xmlNodeListGetString(doc, nodeset->nodeTab[0]->xmlChildrenNode, 1);
+      sosparams->pszOutputFormat = (char *)xmlNodeListGetString(
+          doc, nodeset->nodeTab[0]->xmlChildrenNode, 1);
     }
 
     xmlXPathFreeObject(psXPathTmp);
 
     /* check for Procedure */
-    psXPathTmp = msLibXml2GetXPath(doc, context, (xmlChar *)"/sos:DescribeSensor/sos:procedure");
+    psXPathTmp = msLibXml2GetXPath(
+        doc, context, (xmlChar *)"/sos:DescribeSensor/sos:procedure");
 
     if (psXPathTmp) {
       nodeset = psXPathTmp->nodesetval;
-      sosparams->pszProcedure = (char *)xmlNodeListGetString(doc, nodeset->nodeTab[0]->xmlChildrenNode, 1);
+      sosparams->pszProcedure = (char *)xmlNodeListGetString(
+          doc, nodeset->nodeTab[0]->xmlChildrenNode, 1);
     }
 
     xmlXPathFreeObject(psXPathTmp);
 
     /* check for offering */
-    psXPathTmp = msLibXml2GetXPath(doc, context, (xmlChar *)"/sos:GetObservation/sos:offering");
+    psXPathTmp = msLibXml2GetXPath(
+        doc, context, (xmlChar *)"/sos:GetObservation/sos:offering");
 
     if (psXPathTmp) {
       nodeset = psXPathTmp->nodesetval;
-      sosparams->pszOffering = (char *)xmlNodeListGetString(doc, nodeset->nodeTab[0]->xmlChildrenNode, 1);
+      sosparams->pszOffering = (char *)xmlNodeListGetString(
+          doc, nodeset->nodeTab[0]->xmlChildrenNode, 1);
     }
 
     xmlXPathFreeObject(psXPathTmp);
 
     /* check for observedproperty */
-    psXPathTmp = msLibXml2GetXPath(doc, context, (xmlChar *)"/sos:GetObservation/sos:observedProperty");
+    psXPathTmp = msLibXml2GetXPath(
+        doc, context, (xmlChar *)"/sos:GetObservation/sos:observedProperty");
 
     if (psXPathTmp) {
       nodeset = psXPathTmp->nodesetval;
-      sosparams->pszObservedProperty = (char *)xmlNodeListGetString(doc, nodeset->nodeTab[0]->xmlChildrenNode, 1);
+      sosparams->pszObservedProperty = (char *)xmlNodeListGetString(
+          doc, nodeset->nodeTab[0]->xmlChildrenNode, 1);
     }
 
     xmlXPathFreeObject(psXPathTmp);
 
     /* check for procedure */
-    psXPathTmp = msLibXml2GetXPath(doc, context, (xmlChar *)"/sos:GetObservation/sos:procedure");
+    psXPathTmp = msLibXml2GetXPath(
+        doc, context, (xmlChar *)"/sos:GetObservation/sos:procedure");
 
     if (psXPathTmp) {
       nodeset = psXPathTmp->nodesetval;
-      sosparams->pszProcedure = (char *)xmlNodeListGetString(doc, nodeset->nodeTab[0]->xmlChildrenNode, 1);
+      sosparams->pszProcedure = (char *)xmlNodeListGetString(
+          doc, nodeset->nodeTab[0]->xmlChildrenNode, 1);
     }
 
     xmlXPathFreeObject(psXPathTmp);
 
     /* check for responseFormat */
-    psXPathTmp = msLibXml2GetXPath(doc, context, (xmlChar *)"/sos:GetObservation/sos:responseFormat");
+    psXPathTmp = msLibXml2GetXPath(
+        doc, context, (xmlChar *)"/sos:GetObservation/sos:responseFormat");
 
     if (psXPathTmp) {
       nodeset = psXPathTmp->nodesetval;
-      sosparams->pszResponseFormat = (char *)xmlNodeListGetString(doc, nodeset->nodeTab[0]->xmlChildrenNode, 1);
+      sosparams->pszResponseFormat = (char *)xmlNodeListGetString(
+          doc, nodeset->nodeTab[0]->xmlChildrenNode, 1);
     }
 
     xmlXPathFreeObject(psXPathTmp);
 
     /* check for resultModel */
-    psXPathTmp = msLibXml2GetXPath(doc, context, (xmlChar *)"/sos:GetObservation/sos:resultModel");
+    psXPathTmp = msLibXml2GetXPath(
+        doc, context, (xmlChar *)"/sos:GetObservation/sos:resultModel");
 
     if (psXPathTmp) {
       nodeset = psXPathTmp->nodesetval;
-      sosparams->pszResultModel = (char *)xmlNodeListGetString(doc, nodeset->nodeTab[0]->xmlChildrenNode, 1);
+      sosparams->pszResultModel = (char *)xmlNodeListGetString(
+          doc, nodeset->nodeTab[0]->xmlChildrenNode, 1);
     }
 
     xmlXPathFreeObject(psXPathTmp);
 
     /* check for responseMode */
-    psXPathTmp = msLibXml2GetXPath(doc, context, (xmlChar *)"/sos:GetObservation/sos:responseMode");
+    psXPathTmp = msLibXml2GetXPath(
+        doc, context, (xmlChar *)"/sos:GetObservation/sos:responseMode");
 
     if (psXPathTmp) {
       nodeset = psXPathTmp->nodesetval;
-      sosparams->pszResponseMode = (char *)xmlNodeListGetString(doc, nodeset->nodeTab[0]->xmlChildrenNode, 1);
+      sosparams->pszResponseMode = (char *)xmlNodeListGetString(
+          doc, nodeset->nodeTab[0]->xmlChildrenNode, 1);
     }
 
     xmlXPathFreeObject(psXPathTmp);
 
     /* check for srsName */
-    psXPathTmp = msLibXml2GetXPath(doc, context, (xmlChar *)"/sos:GetObservation/@srsName");
+    psXPathTmp = msLibXml2GetXPath(doc, context,
+                                   (xmlChar *)"/sos:GetObservation/@srsName");
 
     if (psXPathTmp) {
       nodeset = psXPathTmp->nodesetval;
-      sosparams->pszSrsName = (char *)xmlNodeListGetString(doc, nodeset->nodeTab[0]->xmlChildrenNode, 1);
+      sosparams->pszSrsName = (char *)xmlNodeListGetString(
+          doc, nodeset->nodeTab[0]->xmlChildrenNode, 1);
     }
 
     xmlXPathFreeObject(psXPathTmp);
 
     /* check for result (chunk of XML) */
-    psXPathTmp = msLibXml2GetXPath(doc, context, (xmlChar *)"/sos:GetObservation/sos:result/child::*");
+    psXPathTmp = msLibXml2GetXPath(
+        doc, context, (xmlChar *)"/sos:GetObservation/sos:result/child::*");
 
     if (psXPathTmp) {
       sosparams->pszResult = msLibXml2GetXPathTree(doc, psXPathTmp);
@@ -3067,16 +3441,23 @@ int msSOSParseRequest(mapObj *map, cgiRe
     xmlXPathFreeObject(psXPathTmp);
 
     /* check for featureOfInterest (chunk of XML) */
-    psXPathTmp = msLibXml2GetXPath(doc, context, (xmlChar *)"/sos:GetObservation/sos:featureOfInterest/ogc:BBOX/gml:Envelope");
+    psXPathTmp = msLibXml2GetXPath(
+        doc, context,
+        (xmlChar *)"/sos:GetObservation/sos:featureOfInterest/ogc:BBOX/"
+                   "gml:Envelope");
 
     if (psXPathTmp) {
-      sosparams->pszFeatureOfInterest = (char *)msLibXml2GetXPathTree(doc, psXPathTmp);
+      sosparams->pszFeatureOfInterest =
+          (char *)msLibXml2GetXPathTree(doc, psXPathTmp);
     }
 
     xmlXPathFreeObject(psXPathTmp);
 
     /* check for eventTime (chunk of XML) */
-    psXPathTmp = msLibXml2GetXPath(doc, context, (xmlChar *)"/sos:GetObservation/sos:eventTime/*/gml:TimeInstant|/sos:GetObservation/sos:eventTime/*/gml:TimePeriod");
+    psXPathTmp = msLibXml2GetXPath(
+        doc, context,
+        (xmlChar *)"/sos:GetObservation/sos:eventTime/*/gml:TimeInstant|/"
+                   "sos:GetObservation/sos:eventTime/*/gml:TimePeriod");
 
     if (psXPathTmp) {
       sosparams->pszEventTime = (char *)msLibXml2GetXPathTree(doc, psXPathTmp);
@@ -3090,8 +3471,7 @@ int msSOSParseRequest(mapObj *map, cgiRe
   return MS_SUCCESS;
 }
 
-void msSOSFreeParamsObj(sosParamsObj *sosparams)
-{
+void msSOSFreeParamsObj(sosParamsObj *sosparams) {
   if (sosparams) {
     if (sosparams->pszService)
       free(sosparams->pszService);
diff -pruN 8.0.1-5/mapogl.cpp 8.0.2-1/mapogl.cpp
--- 8.0.1-5/mapogl.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapogl.cpp	2024-06-11 20:41:34.000000000 +0000
@@ -35,99 +35,95 @@
 #include "mapoglrenderer.h"
 #include "mapoglcontext.h"
 
-
-
-imageObj* createImageObjOgl(OglRenderer* renderer)
-{
-  if (!renderer->isValid()) return NULL;
-  imageObj* pNewImage = (imageObj*)calloc(1, sizeof(imageObj));
+imageObj *createImageObjOgl(OglRenderer *renderer) {
+  if (!renderer->isValid())
+    return NULL;
+  imageObj *pNewImage = (imageObj *)calloc(1, sizeof(imageObj));
   if (!pNewImage)
     return pNewImage;
-  pNewImage->img.plugin = (void *) renderer;
+  pNewImage->img.plugin = (void *)renderer;
   return pNewImage;
 }
 
-OglRenderer* getOglRenderer(imageObj* img)
-{
-  return (OglRenderer*) img->img.plugin;
+OglRenderer *getOglRenderer(imageObj *img) {
+  return (OglRenderer *)img->img.plugin;
 }
 
-int msSaveImageOgl(imageObj *img, mapObj *map, FILE *fp, outputFormatObj *format)
-{
+int msSaveImageOgl(imageObj *img, mapObj *map, FILE *fp,
+                   outputFormatObj *format) {
   rasterBufferObj data;
-  OglRenderer* renderer = getOglRenderer(img);
+  OglRenderer *renderer = getOglRenderer(img);
   renderer->readRasterBuffer(&data);
-  return msSaveRasterBuffer(NULL,&data,fp,img->format );
+  return msSaveRasterBuffer(NULL, &data, fp, img->format);
 }
 
-int msDrawLineOgl(imageObj *img, shapeObj *p, strokeStyleObj *style)
-{
-  OglRenderer* renderer = getOglRenderer(img);
-  renderer->renderPolyline(p, style->color, style->width, style->patternlength, style->pattern);
+int msDrawLineOgl(imageObj *img, shapeObj *p, strokeStyleObj *style) {
+  OglRenderer *renderer = getOglRenderer(img);
+  renderer->renderPolyline(p, style->color, style->width, style->patternlength,
+                           style->pattern);
   return MS_SUCCESS;
 }
 
-int msDrawPolygonOgl(imageObj *img, shapeObj *p, colorObj *color)
-{
-  OglRenderer* renderer = getOglRenderer(img);
+int msDrawPolygonOgl(imageObj *img, shapeObj *p, colorObj *color) {
+  OglRenderer *renderer = getOglRenderer(img);
   renderer->renderPolygon(p, color, NULL, 0);
   return MS_SUCCESS;
 }
 
-//void msFreeTileOgl(imageObj *tile)
+// void msFreeTileOgl(imageObj *tile)
 //{
-//    delete (OglCache*)tile;
-//}
+//     delete (OglCache*)tile;
+// }
 
-int msDrawLineTiledOgl(imageObj *img, shapeObj *p, imageObj *tile)
-{
-  OglRenderer* renderer = getOglRenderer(img);
+int msDrawLineTiledOgl(imageObj *img, shapeObj *p, imageObj *tile) {
+  OglRenderer *renderer = getOglRenderer(img);
   renderer->renderPolylineTile(p, getOglRenderer(tile)->getTexture());
   return MS_SUCCESS;
 }
 
-int msDrawPolygonTiledOgl(imageObj *img, shapeObj *p, imageObj *tile)
-{
-  OglRenderer* renderer = getOglRenderer(img);
-  renderer->renderPolygon(p, NULL, NULL, 0.0, getOglRenderer(tile)->getTexture());
+int msDrawPolygonTiledOgl(imageObj *img, shapeObj *p, imageObj *tile) {
+  OglRenderer *renderer = getOglRenderer(img);
+  renderer->renderPolygon(p, NULL, NULL, 0.0,
+                          getOglRenderer(tile)->getTexture());
   return MS_SUCCESS;
 }
 
-int msRenderPixmapOgl(imageObj *img, double x, double y,
-                      symbolObj *symbol, symbolStyleObj *style)
-{
-  OglRenderer* renderer = getOglRenderer(img);
+int msRenderPixmapOgl(imageObj *img, double x, double y, symbolObj *symbol,
+                      symbolStyleObj *style) {
+  OglRenderer *renderer = getOglRenderer(img);
   renderer->renderPixmap(symbol, x, y, style->rotation, style->scale);
   return MS_SUCCESS;
 }
 
-int msRenderVectorSymbolOgl
-(imageObj *img, double x, double y,
- symbolObj *symbol, symbolStyleObj *style)
-{
-  OglRenderer* renderer = getOglRenderer(img);
-  renderer->renderVectorSymbol(x, y, symbol, style->scale, style->rotation, style->color, style->outlinecolor, style->outlinewidth);
+int msRenderVectorSymbolOgl(imageObj *img, double x, double y,
+                            symbolObj *symbol, symbolStyleObj *style) {
+  OglRenderer *renderer = getOglRenderer(img);
+  renderer->renderVectorSymbol(x, y, symbol, style->scale, style->rotation,
+                               style->color, style->outlinecolor,
+                               style->outlinewidth);
   return MS_SUCCESS;
 }
 
 int msRenderTruetypeSymbolOgl(imageObj *img, double x, double y,
-                              symbolObj *symbol, symbolStyleObj * style)
-{
-  OglRenderer* renderer = getOglRenderer(img);
-  double size = style->scale*72.0;
-  renderer->renderGlyphs(0, 0, style->color, style->outlinecolor, size, symbol->font, symbol->character, style->rotation, NULL, 0, 0);
+                              symbolObj *symbol, symbolStyleObj *style) {
+  OglRenderer *renderer = getOglRenderer(img);
+  double size = style->scale * 72.0;
+  renderer->renderGlyphs(0, 0, style->color, style->outlinecolor, size,
+                         symbol->font, symbol->character, style->rotation, NULL,
+                         0, 0);
   return MS_SUCCESS;
 }
 
-int msRenderTileOgl(imageObj *img, imageObj *tile, double x, double y)
-{
-  OglRenderer* renderer = getOglRenderer(img);
+int msRenderTileOgl(imageObj *img, imageObj *tile, double x, double y) {
+  OglRenderer *renderer = getOglRenderer(img);
   renderer->renderTile(getOglRenderer(tile)->getTexture(), x, y, 0.0);
   return MS_SUCCESS;
 }
 
-int msGetTruetypeTextBBoxOgl(rendererVTableObj *renderer, char **fonts, int numfonts, double size, char *string, rectObj *rect, double **advances, int bAdjustBaseline)
-{
+int msGetTruetypeTextBBoxOgl(rendererVTableObj *renderer, char **fonts,
+                             int numfonts, double size, char *string,
+                             rectObj *rect, double **advances,
+                             int bAdjustBaseline) {
   if (OglRenderer::getStringBBox(fonts[0], size, string, rect, advances)) {
     return MS_SUCCESS;
   } else {
@@ -135,93 +131,89 @@ int msGetTruetypeTextBBoxOgl(rendererVTa
   }
 }
 
-int msRenderGlyphsOgl(imageObj *img, double x, double y,
-                      labelStyleObj *style, char *text)
-{
-  OglRenderer* renderer = getOglRenderer(img);
-  renderer->renderGlyphs(x, y, style->color, style->outlinecolor, style->size, style->fonts[0], text, style->rotation, NULL, 0.0, 0.0);
+int msRenderGlyphsOgl(imageObj *img, double x, double y, labelStyleObj *style,
+                      char *text) {
+  OglRenderer *renderer = getOglRenderer(img);
+  renderer->renderGlyphs(x, y, style->color, style->outlinecolor, style->size,
+                         style->fonts[0], text, style->rotation, NULL, 0.0,
+                         0.0);
   return MS_SUCCESS;
 }
 
-int msMergeRasterBufferOgl(imageObj *dest, rasterBufferObj *overlay, double opacity, int srcX, int srcY, int dstX, int dstY, int width, int height)
-{
-  OglRenderer* renderer = getOglRenderer(dest);
-  renderer->drawRasterBuffer(overlay, opacity, srcX, srcY, dstX, dstY, width, height);
+int msMergeRasterBufferOgl(imageObj *dest, rasterBufferObj *overlay,
+                           double opacity, int srcX, int srcY, int dstX,
+                           int dstY, int width, int height) {
+  OglRenderer *renderer = getOglRenderer(dest);
+  renderer->drawRasterBuffer(overlay, opacity, srcX, srcY, dstX, dstY, width,
+                             height);
   return MS_SUCCESS;
 }
 
-imageObj* msImageCreateOgl(int width, int height, outputFormatObj *format, colorObj* bg)
-{
+imageObj *msImageCreateOgl(int width, int height, outputFormatObj *format,
+                           colorObj *bg) {
   imageObj *pNewImage = NULL;
 
-  if (format->imagemode != MS_IMAGEMODE_RGB && format->imagemode
-      != MS_IMAGEMODE_RGBA) {
-    msSetError(
-      MS_OGLERR, "OpenGL driver only supports RGB or RGBA pixel models.",
-      "msImageCreateOGL()");
+  if (format->imagemode != MS_IMAGEMODE_RGB &&
+      format->imagemode != MS_IMAGEMODE_RGBA) {
+    msSetError(MS_OGLERR,
+               "OpenGL driver only supports RGB or RGBA pixel models.",
+               "msImageCreateOGL()");
     return NULL;
   }
   return createImageObjOgl(new OglRenderer(width, height, bg));
 }
 
-int msRenderEllipseOgl(imageObj *image, double x, double y,
-                       symbolObj *symbol, symbolStyleObj *style)
-{
+int msRenderEllipseOgl(imageObj *image, double x, double y, symbolObj *symbol,
+                       symbolStyleObj *style) {
 
-  OglRenderer* renderer = getOglRenderer(image);
-  renderer->renderEllipse(x, y, style->rotation, symbol->sizex, symbol->sizey, style->color, style->outlinecolor, style->outlinewidth);
+  OglRenderer *renderer = getOglRenderer(image);
+  renderer->renderEllipse(x, y, style->rotation, symbol->sizex, symbol->sizey,
+                          style->color, style->outlinecolor,
+                          style->outlinewidth);
   return MS_SUCCESS;
 }
 
-int msFreeImageOgl(imageObj *img)
-{
-  OglRenderer* renderer = getOglRenderer(img);
+int msFreeImageOgl(imageObj *img) {
+  OglRenderer *renderer = getOglRenderer(img);
   if (renderer) {
     delete renderer;
   }
-  img->img.plugin=NULL;
+  img->img.plugin = NULL;
   return MS_SUCCESS;
 }
 
-int msStartLayerOgl(imageObj *img, mapObj *map, layerObj *layer)
-{
-  getOglRenderer(img)->setTransparency((double)layer->opacity/100);
+int msStartLayerOgl(imageObj *img, mapObj *map, layerObj *layer) {
+  getOglRenderer(img)->setTransparency((double)layer->opacity / 100);
   return MS_SUCCESS;
 }
 
-int msEndLayerOgl(imageObj *img, mapObj *map, layerObj *layer)
-{
+int msEndLayerOgl(imageObj *img, mapObj *map, layerObj *layer) {
   getOglRenderer(img)->setTransparency(1.0);
   return MS_SUCCESS;
 }
 
-int msFreeSymbolOgl(symbolObj *s)
-{
-  return MS_SUCCESS;
-}
+int msFreeSymbolOgl(symbolObj *s) { return MS_SUCCESS; }
 
-int msGetRasterBufferCopyOgl(imageObj *img, rasterBufferObj *rb)
-{
+int msGetRasterBufferCopyOgl(imageObj *img, rasterBufferObj *rb) {
   getOglRenderer(img)->readRasterBuffer(rb);
   return MS_SUCCESS;
 }
 
-int msGetRasterBufferHandleOgl(imageObj *img, rasterBufferObj * rb)
-{
+int msGetRasterBufferHandleOgl(imageObj *img, rasterBufferObj *rb) {
   getOglRenderer(img)->readRasterBuffer(rb);
   return MS_SUCCESS;
 }
 
-int msInitializeRasterBufferOgl(rasterBufferObj *rb, int width, int height, int mode)
-{
-  OglRenderer::initializeRasterBuffer(rb, width, height, mode==MS_IMAGEMODE_RGBA);
+int msInitializeRasterBufferOgl(rasterBufferObj *rb, int width, int height,
+                                int mode) {
+  OglRenderer::initializeRasterBuffer(rb, width, height,
+                                      mode == MS_IMAGEMODE_RGBA);
   return MS_SUCCESS;
 }
 
 #endif /* USE_OGL */
 
-int msPopulateRendererVTableOGL(rendererVTableObj *renderer)
-{
+int msPopulateRendererVTableOGL(rendererVTableObj *renderer) {
 #ifdef USE_OGL
   renderer->supports_transparent_layers = 1;
   renderer->supports_pixel_buffer = 1;
@@ -232,13 +224,12 @@ int msPopulateRendererVTableOGL(renderer
   renderer->startLayer = msStartLayerOgl;
   renderer->endLayer = msEndLayerOgl;
 
-  renderer->createImage=&msImageCreateOgl;
-  renderer->saveImage=&msSaveImageOgl;
-
+  renderer->createImage = &msImageCreateOgl;
+  renderer->saveImage = &msSaveImageOgl;
 
-  renderer->renderLine=&msDrawLineOgl;
-  renderer->renderPolygon=&msDrawPolygonOgl;
-  renderer->renderGlyphs=&msRenderGlyphsOgl;
+  renderer->renderLine = &msDrawLineOgl;
+  renderer->renderPolygon = &msDrawPolygonOgl;
+  renderer->renderGlyphs = &msRenderGlyphsOgl;
   renderer->renderEllipseSymbol = &msRenderEllipseOgl;
   renderer->renderVectorSymbol = &msRenderVectorSymbolOgl;
   renderer->renderPixmapSymbol = &msRenderPixmapOgl;
@@ -257,14 +248,13 @@ int msPopulateRendererVTableOGL(renderer
   renderer->loadImageFromFile = msLoadMSRasterBufferFromFile;
 
   renderer->freeSymbol = &msFreeSymbolOgl;
-  renderer->freeImage=&msFreeImageOgl;
+  renderer->freeImage = &msFreeImageOgl;
 
   return MS_SUCCESS;
 #else
-  msSetError(MS_MISCERR,"OGL driver requested but it is not compiled in this release",
+  msSetError(MS_MISCERR,
+             "OGL driver requested but it is not compiled in this release",
              "msPopulateRendererVTableOGL()");
   return MS_FAILURE;
 #endif
-
 }
-
diff -pruN 8.0.1-5/mapoglcontext.cpp 8.0.2-1/mapoglcontext.cpp
--- 8.0.1-5/mapoglcontext.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapoglcontext.cpp	2024-06-11 20:41:34.000000000 +0000
@@ -33,50 +33,54 @@
 #include "maperror.h"
 #include "mapoglcontext.h"
 
-
-
 #define _T(x) __TEXT(x)
 
 ms_uint32 OglContext::MAX_MULTISAMPLE_SAMPLES = 16;
 ms_uint32 OglContext::MAX_ANISOTROPY = 0;
 ms_uint32 OglContext::MAX_TEXTURE_SIZE = 0;
 ms_uint32 OglContext::MIN_TEXTURE_SIZE = 0;
-OglContext* OglContext::current = NULL;
-
-OglContext::OglContext(ms_uint32 width, ms_uint32 height)
-  : valid(false)
-{
-  if (!window && !initWindow()) return;
-  if (!sharingContext && !initSharingContext()) return;
+OglContext *OglContext::current = NULL;
 
-  if (!(this->width = getTextureSize(GL_TEXTURE_WIDTH, width))) return;
-  if (!(this->height = getTextureSize(GL_TEXTURE_HEIGHT, height))) return;
-
-  if (!createPBuffer(this->width, this->height)) return;
-  if (!makeCurrent()) return;
+OglContext::OglContext(ms_uint32 width, ms_uint32 height) : valid(false) {
+  if (!window && !initWindow())
+    return;
+  if (!sharingContext && !initSharingContext())
+    return;
+
+  if (!(this->width = getTextureSize(GL_TEXTURE_WIDTH, width)))
+    return;
+  if (!(this->height = getTextureSize(GL_TEXTURE_HEIGHT, height)))
+    return;
+
+  if (!createPBuffer(this->width, this->height))
+    return;
+  if (!makeCurrent())
+    return;
   valid = true;
 }
 
-ms_uint32 OglContext::getTextureSize(GLuint dimension, ms_uint32 value)
-{
-  glTexImage2D(GL_PROXY_TEXTURE_2D, 0, GL_RGBA,  value, value, 0, GL_RGBA, GL_UNSIGNED_BYTE, NULL);
+ms_uint32 OglContext::getTextureSize(GLuint dimension, ms_uint32 value) {
+  glTexImage2D(GL_PROXY_TEXTURE_2D, 0, GL_RGBA, value, value, 0, GL_RGBA,
+               GL_UNSIGNED_BYTE, NULL);
   GLint check = 0;
   glGetTexLevelParameteriv(GL_PROXY_TEXTURE_2D, 0, dimension, &check);
 
   if (glGetError() != GL_NO_ERROR) {
-    msSetError(MS_OGLERR, "glGetTexLevelParameteriv failed. glError: %d", "OglContext::getTextureSize()", glGetError());
+    msSetError(MS_OGLERR, "glGetTexLevelParameteriv failed. glError: %d",
+               "OglContext::getTextureSize()", glGetError());
   }
 
   if (check == 0) {
-    return MS_MAX(MS_MIN(NextPowerOf2(value), OglContext::MAX_TEXTURE_SIZE), OglContext::MIN_TEXTURE_SIZE);
+    return MS_MAX(MS_MIN(NextPowerOf2(value), OglContext::MAX_TEXTURE_SIZE),
+                  OglContext::MIN_TEXTURE_SIZE);
   } else {
-    msSetError(MS_OGLERR, "Unable to create opengl texture of map size", "OglContext::getTextureSize()");
+    msSetError(MS_OGLERR, "Unable to create opengl texture of map size",
+               "OglContext::getTextureSize()");
     return value;
   }
 }
 
-GLuint OglContext::NextPowerOf2(GLuint in)
-{
+GLuint OglContext::NextPowerOf2(GLuint in) {
   in -= 1;
 
   in |= in >> 16;
@@ -93,33 +97,28 @@ GLuint OglContext::NextPowerOf2(GLuint i
 HDC OglContext::window = NULL;
 HGLRC OglContext::sharingContext = NULL;
 
-LRESULT CALLBACK WndProc(HWND hWnd,
-                         UINT message,
-                         WPARAM wParam,
-                         LPARAM lParam)
-{
-  return(1L);
+LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam,
+                         LPARAM lParam) {
+  return (1L);
 }
 
-OglContext::~OglContext()
-{
-  //TODO
+OglContext::~OglContext() {
+  // TODO
 }
 
-bool OglContext::makeCurrent()
-{
+bool OglContext::makeCurrent() {
   if (current != this) {
     current = this;
     if (!wglMakeContextCurrentARB(hPBufferDC, hPBufferDC, hPBufferRC)) {
-      msSetError(MS_OGLERR, "Can't Activate The GL Rendering pbuffer.", "OglContext::makeCurrent()");
+      msSetError(MS_OGLERR, "Can't Activate The GL Rendering pbuffer.",
+                 "OglContext::makeCurrent()");
       return FALSE;
     }
   }
   return true;
 }
 
-bool OglContext::initWindow()
-{
+bool OglContext::initWindow() {
   int windowPixelFormat;
   WNDCLASS wc;
   DWORD dwExStyle;
@@ -127,15 +126,15 @@ bool OglContext::initWindow()
   RECT WindowRect;
   HMODULE hInstance = NULL;
   HWND hWnd = NULL;
-  WindowRect.left=(long)0;
-  WindowRect.right=(long)0;
-  WindowRect.top=(long)0;
-  WindowRect.bottom=(long)0;
+  WindowRect.left = (long)0;
+  WindowRect.right = (long)0;
+  WindowRect.top = (long)0;
+  WindowRect.bottom = (long)0;
   hInstance = GetModuleHandle(NULL);
   wc.style = CS_HREDRAW | CS_VREDRAW | CS_OWNDC;
   wc.cbClsExtra = 0;
   wc.cbWndExtra = 0;
-  wc.lpfnWndProc = (WNDPROC) WndProc;
+  wc.lpfnWndProc = (WNDPROC)WndProc;
   wc.hInstance = hInstance;
   wc.hIcon = LoadIcon(NULL, IDI_WINLOGO);
   wc.hCursor = LoadCursor(NULL, IDC_ARROW);
@@ -144,117 +143,131 @@ bool OglContext::initWindow()
   wc.lpszClassName = _T("OpenGL");
 
   if (!RegisterClass(&wc)) {
-    msSetError(MS_OGLERR, "Failed To Register The Window Class.", "OglContext::initWindow()");
+    msSetError(MS_OGLERR, "Failed To Register The Window Class.",
+               "OglContext::initWindow()");
     return FALSE;
   }
-  dwExStyle=WS_EX_APPWINDOW | WS_EX_WINDOWEDGE;
-  dwStyle=WS_OVERLAPPEDWINDOW;
+  dwExStyle = WS_EX_APPWINDOW | WS_EX_WINDOWEDGE;
+  dwStyle = WS_OVERLAPPEDWINDOW;
 
   AdjustWindowRectEx(&WindowRect, dwStyle, FALSE, dwExStyle);
 
-  if (!(hWnd=CreateWindowEx( dwExStyle,
-                             _T("OpenGL"),
-                             _T("temp"),
-                             dwStyle |
-                             WS_CLIPSIBLINGS |
-                             WS_CLIPCHILDREN,
-                             0, 0,
-                             WindowRect.right-WindowRect.left,
-                             WindowRect.bottom-WindowRect.top,
-                             NULL,
-                             NULL,
-                             hInstance,
-                             NULL))) {
+  if (!(hWnd = CreateWindowEx(dwExStyle, _T("OpenGL"), _T("temp"),
+                              dwStyle | WS_CLIPSIBLINGS | WS_CLIPCHILDREN, 0, 0,
+                              WindowRect.right - WindowRect.left,
+                              WindowRect.bottom - WindowRect.top, NULL, NULL,
+                              hInstance, NULL))) {
     msSetError(MS_OGLERR, "Window Creation Error.", "OglContext::initWindow()");
     return FALSE;
   }
 
-  static PIXELFORMATDESCRIPTOR pfd= {
-    sizeof(PIXELFORMATDESCRIPTOR),
-    1,
-    PFD_DRAW_TO_WINDOW |
-    PFD_SUPPORT_OPENGL |
-    PFD_DOUBLEBUFFER,
-    PFD_TYPE_RGBA,
-    24, // Select Our Color Depth
-    0, 0, 0, 0, 0, 0, // Color Bits Ignored
-    8, // Alpha Buffer
-    0, // Shift Bit Ignored
-    0, // No Accumulation Buffer
-    0, 0, 0, 0, // Accumulation Bits Ignored
-    16, // 16Bit Z-Buffer (Depth Buffer)
-    0, // No Stencil Buffer
-    0, // No Auxiliary Buffer
-    PFD_MAIN_PLANE, // Main Drawing Layer
-    0, // Reserved
-    0, 0, 0 // Layer Masks Ignored
+  static PIXELFORMATDESCRIPTOR pfd = {
+      sizeof(PIXELFORMATDESCRIPTOR),
+      1,
+      PFD_DRAW_TO_WINDOW | PFD_SUPPORT_OPENGL | PFD_DOUBLEBUFFER,
+      PFD_TYPE_RGBA,
+      24, // Select Our Color Depth
+      0,
+      0,
+      0,
+      0,
+      0,
+      0, // Color Bits Ignored
+      8, // Alpha Buffer
+      0, // Shift Bit Ignored
+      0, // No Accumulation Buffer
+      0,
+      0,
+      0,
+      0,              // Accumulation Bits Ignored
+      16,             // 16Bit Z-Buffer (Depth Buffer)
+      0,              // No Stencil Buffer
+      0,              // No Auxiliary Buffer
+      PFD_MAIN_PLANE, // Main Drawing Layer
+      0,              // Reserved
+      0,
+      0,
+      0 // Layer Masks Ignored
   };
 
-  if (!(window=GetDC(hWnd))) {
-    msSetError(MS_OGLERR, "Can't Create A GL Device Context.. Last Error: %d", "OglContext::initWindow()", GetLastError());
+  if (!(window = GetDC(hWnd))) {
+    msSetError(MS_OGLERR, "Can't Create A GL Device Context.. Last Error: %d",
+               "OglContext::initWindow()", GetLastError());
     return FALSE;
   }
 
-  if (!(windowPixelFormat=ChoosePixelFormat(window,&pfd))) {
-    msSetError(MS_OGLERR, "Can't Find A Suitable windowPixelFormat. Last Error: %d", "OglContext::initWindow()", GetLastError());
+  if (!(windowPixelFormat = ChoosePixelFormat(window, &pfd))) {
+    msSetError(MS_OGLERR,
+               "Can't Find A Suitable windowPixelFormat. Last Error: %d",
+               "OglContext::initWindow()", GetLastError());
     return FALSE;
   }
 
-  if(!SetPixelFormat(window,windowPixelFormat,&pfd)) {
-    msSetError(MS_OGLERR, "Can't Set The windowPixelFormat. Last Error: %d", "OglContext::initWindow()", GetLastError());
+  if (!SetPixelFormat(window, windowPixelFormat, &pfd)) {
+    msSetError(MS_OGLERR, "Can't Set The windowPixelFormat. Last Error: %d",
+               "OglContext::initWindow()", GetLastError());
     return FALSE;
   }
   return TRUE;
 }
 
-bool OglContext::initSharingContext()
-{
-  if (!(sharingContext=wglCreateContext(window))) {
-    msSetError(MS_OGLERR, "Can't Create A GL Rendering Context.", "OglContext::createContext()");
+bool OglContext::initSharingContext() {
+  if (!(sharingContext = wglCreateContext(window))) {
+    msSetError(MS_OGLERR, "Can't Create A GL Rendering Context.",
+               "OglContext::createContext()");
     return FALSE;
   }
 
-  if(!wglMakeCurrent(window,sharingContext)) {
-    msSetError(MS_OGLERR, "Can't Activate The GL Rendering Context.", "OglContext::createContext()");
+  if (!wglMakeCurrent(window, sharingContext)) {
+    msSetError(MS_OGLERR, "Can't Activate The GL Rendering Context.",
+               "OglContext::createContext()");
     return FALSE;
   }
 
-  if (!(wglChoosePixelFormatARB = (PFNWGLCHOOSEPIXELFORMATARBPROC)wglGetProcAddress("wglChoosePixelFormatARB"))) {
-    msSetError(MS_OGLERR, "unable to retreive wglChoosePixelFormatARB method.", "OglContext::createContext()");
+  if (!(wglChoosePixelFormatARB = (PFNWGLCHOOSEPIXELFORMATARBPROC)
+            wglGetProcAddress("wglChoosePixelFormatARB"))) {
+    msSetError(MS_OGLERR, "unable to retreive wglChoosePixelFormatARB method.",
+               "OglContext::createContext()");
     return FALSE;
   }
 
-  if (!(wglCreatePbufferARB = (PFNWGLCREATEPBUFFERARBPROC)wglGetProcAddress("wglCreatePbufferARB"))) {
-    msSetError(MS_OGLERR, "unable to retreive wglCreatePbufferARB method.", "OglContext::createContext()");
+  if (!(wglCreatePbufferARB = (PFNWGLCREATEPBUFFERARBPROC)wglGetProcAddress(
+            "wglCreatePbufferARB"))) {
+    msSetError(MS_OGLERR, "unable to retreive wglCreatePbufferARB method.",
+               "OglContext::createContext()");
     return FALSE;
   }
 
-  if (!(wglGetPbufferDCARB = (PFNWGLGETPBUFFERDCARBPROC)wglGetProcAddress("wglGetPbufferDCARB"))) {
-    msSetError(MS_OGLERR, "unable to retreive wglGetPbufferDCARB method.", "OglContext::createContext()");
+  if (!(wglGetPbufferDCARB = (PFNWGLGETPBUFFERDCARBPROC)wglGetProcAddress(
+            "wglGetPbufferDCARB"))) {
+    msSetError(MS_OGLERR, "unable to retreive wglGetPbufferDCARB method.",
+               "OglContext::createContext()");
     return FALSE;
   }
 
-  if (!(wglReleasePbufferDCARB = (PFNWGLRELEASEPBUFFERDCARBPROC)wglGetProcAddress("wglReleasePbufferDCARB"))) {
-    msSetError(MS_OGLERR, "unable to retreive wglReleasePbufferDCARB method.", "OglContext::createContext()");
+  if (!(wglReleasePbufferDCARB = (PFNWGLRELEASEPBUFFERDCARBPROC)
+            wglGetProcAddress("wglReleasePbufferDCARB"))) {
+    msSetError(MS_OGLERR, "unable to retreive wglReleasePbufferDCARB method.",
+               "OglContext::createContext()");
     return FALSE;
   }
 
-  if (!(wglMakeContextCurrentARB = (PFNWGLMAKECONTEXTCURRENTARBPROC)wglGetProcAddress("wglMakeContextCurrentARB"))) {
-    msSetError(MS_OGLERR, "unable to retreive wglMakeContextCurrentARB method.", "OglContext::createContext()");
+  if (!(wglMakeContextCurrentARB = (PFNWGLMAKECONTEXTCURRENTARBPROC)
+            wglGetProcAddress("wglMakeContextCurrentARB"))) {
+    msSetError(MS_OGLERR, "unable to retreive wglMakeContextCurrentARB method.",
+               "OglContext::createContext()");
     return FALSE;
   }
 
-  glGetIntegerv(GL_MAX_TEXTURE_MAX_ANISOTROPY_EXT, (GLint*) &MAX_ANISOTROPY);
-  glGetIntegerv(GL_MAX_TEXTURE_SIZE, (GLint*)&MAX_TEXTURE_SIZE);
+  glGetIntegerv(GL_MAX_TEXTURE_MAX_ANISOTROPY_EXT, (GLint *)&MAX_ANISOTROPY);
+  glGetIntegerv(GL_MAX_TEXTURE_SIZE, (GLint *)&MAX_TEXTURE_SIZE);
 
   MIN_TEXTURE_SIZE = 8;
 
-
   return TRUE;
 }
 
-bool OglContext::createPBuffer(ms_uint32 width, ms_uint32 height)
-{
+bool OglContext::createPBuffer(ms_uint32 width, ms_uint32 height) {
   HPBUFFERARB hPBuffer = NULL;
   hPBufferDC = NULL;
   hPBufferRC = NULL;
@@ -262,48 +275,70 @@ bool OglContext::createPBuffer(ms_uint32
   int pixelFormat;
   int valid = false;
   UINT numFormats = 0;
-  float fAttributes[] = {0,0};
+  float fAttributes[] = {0, 0};
   int samples = MAX_MULTISAMPLE_SAMPLES;
 
   while ((!valid || numFormats == 0) && samples >= 0) {
-    int iAttributes[] = {
-      WGL_SAMPLES_ARB,samples,
-      WGL_DRAW_TO_PBUFFER_ARB,GL_TRUE,
-      WGL_SUPPORT_OPENGL_ARB,GL_TRUE,
-      WGL_ACCELERATION_ARB,WGL_FULL_ACCELERATION_ARB,
-      WGL_COLOR_BITS_ARB,24,
-      WGL_ALPHA_BITS_ARB,8,
-      WGL_DEPTH_BITS_ARB,16,
-      WGL_STENCIL_BITS_ARB,0,
-      WGL_SAMPLE_BUFFERS_ARB,GL_TRUE,
-      WGL_PIXEL_TYPE_ARB, WGL_TYPE_RGBA_ARB,
-      0,0
-    };
-
-    valid = wglChoosePixelFormatARB(window,iAttributes,fAttributes,1,&pixelFormat,&numFormats);
-    if (!valid || numFormats == 0) samples -= 2;
-  }
-
-  if(numFormats == 0) {
-    msSetError(MS_OGLERR, "P-buffer Error: Unable to find an acceptable pixel format.", "OglContext::createPBuffer()");
+    int iAttributes[] = {WGL_SAMPLES_ARB,
+                         samples,
+                         WGL_DRAW_TO_PBUFFER_ARB,
+                         GL_TRUE,
+                         WGL_SUPPORT_OPENGL_ARB,
+                         GL_TRUE,
+                         WGL_ACCELERATION_ARB,
+                         WGL_FULL_ACCELERATION_ARB,
+                         WGL_COLOR_BITS_ARB,
+                         24,
+                         WGL_ALPHA_BITS_ARB,
+                         8,
+                         WGL_DEPTH_BITS_ARB,
+                         16,
+                         WGL_STENCIL_BITS_ARB,
+                         0,
+                         WGL_SAMPLE_BUFFERS_ARB,
+                         GL_TRUE,
+                         WGL_PIXEL_TYPE_ARB,
+                         WGL_TYPE_RGBA_ARB,
+                         0,
+                         0};
+
+    valid = wglChoosePixelFormatARB(window, iAttributes, fAttributes, 1,
+                                    &pixelFormat, &numFormats);
+    if (!valid || numFormats == 0)
+      samples -= 2;
+  }
+
+  if (numFormats == 0) {
+    msSetError(MS_OGLERR,
+               "P-buffer Error: Unable to find an acceptable pixel format.",
+               "OglContext::createPBuffer()");
     return FALSE;
   }
 
-  if (!(hPBuffer = wglCreatePbufferARB(window, pixelFormat, width, height, 0))) {
-    msSetError(MS_OGLERR, "P-buffer Error: Unable to create P-buffer. glError: %d", "OglContext::createPBuffer()", glGetError());
+  if (!(hPBuffer =
+            wglCreatePbufferARB(window, pixelFormat, width, height, 0))) {
+    msSetError(MS_OGLERR,
+               "P-buffer Error: Unable to create P-buffer. glError: %d",
+               "OglContext::createPBuffer()", glGetError());
     return FALSE;
   }
   if (!(hPBufferDC = wglGetPbufferDCARB(hPBuffer))) {
-    msSetError(MS_OGLERR, "P-buffer Error: Unable to get P-buffer DC. glError: %d", "OglContext::createPBuffer()", glGetError());
+    msSetError(MS_OGLERR,
+               "P-buffer Error: Unable to get P-buffer DC. glError: %d",
+               "OglContext::createPBuffer()", glGetError());
     return FALSE;
   }
   if (!(hPBufferRC = wglCreateContext(hPBufferDC))) {
-    msSetError(MS_OGLERR, "P-buffer Error: Unable to get P-buffer DC. glError: %d", "OglContext::createPBuffer()", glGetError());
+    msSetError(MS_OGLERR,
+               "P-buffer Error: Unable to get P-buffer DC. glError: %d",
+               "OglContext::createPBuffer()", glGetError());
     return FALSE;
   }
 
-  if (wglShareLists(sharingContext,hPBufferRC) == FALSE) {
-    msSetError(MS_OGLERR, "P-buffer Error: Unable to share display lists. glError: %d", "OglContext::createPBuffer()", glGetError());
+  if (wglShareLists(sharingContext, hPBufferRC) == FALSE) {
+    msSetError(MS_OGLERR,
+               "P-buffer Error: Unable to share display lists. glError: %d",
+               "OglContext::createPBuffer()", glGetError());
     return FALSE;
   }
 
@@ -318,66 +353,76 @@ PFNWGLMAKECONTEXTCURRENTARBPROC OglConte
 
 #else /* UNIX */
 
-Display* OglContext::window = NULL;
+Display *OglContext::window = NULL;
 GLXContext OglContext::sharingContext = NULL;
-GLXFBConfig* OglContext::configs = NULL;
+GLXFBConfig *OglContext::configs = NULL;
 
-OglContext::~OglContext()
-{
-  //TODO
+OglContext::~OglContext() {
+  // TODO
 }
 
-
-bool OglContext::makeCurrent()
-{
+bool OglContext::makeCurrent() {
   if (current != this) {
     current = this;
     if (!glXMakeCurrent(window, pbuffer, sharingContext)) {
-      msSetError(MS_OGLERR, "glXMakeCurrent failed. glError: %d", "OglContext::makeCurrent()", glGetError());
+      msSetError(MS_OGLERR, "glXMakeCurrent failed. glError: %d",
+                 "OglContext::makeCurrent()", glGetError());
       return false;
     }
   }
   return true;
 }
 
-bool OglContext::initSharingContext()
-{
-  int fb_attributes[] = {
-    GLX_SAMPLES_ARB, MAX_MULTISAMPLE_SAMPLES,
-    GLX_RENDER_TYPE, GLX_RGBA_BIT,
-    GLX_DRAWABLE_TYPE, GLX_PBUFFER_BIT,
-    GLX_RED_SIZE, 8,
-    GLX_GREEN_SIZE, 8,
-    GLX_BLUE_SIZE, 8,
-    GLX_ALPHA_SIZE, 8,
-    GLX_DEPTH_SIZE, 16,
-    GLX_DOUBLEBUFFER, 0,
-    GLX_SAMPLE_BUFFERS_ARB, 1,
-    0
-  };
+bool OglContext::initSharingContext() {
+  int fb_attributes[] = {GLX_SAMPLES_ARB,
+                         MAX_MULTISAMPLE_SAMPLES,
+                         GLX_RENDER_TYPE,
+                         GLX_RGBA_BIT,
+                         GLX_DRAWABLE_TYPE,
+                         GLX_PBUFFER_BIT,
+                         GLX_RED_SIZE,
+                         8,
+                         GLX_GREEN_SIZE,
+                         8,
+                         GLX_BLUE_SIZE,
+                         8,
+                         GLX_ALPHA_SIZE,
+                         8,
+                         GLX_DEPTH_SIZE,
+                         16,
+                         GLX_DOUBLEBUFFER,
+                         0,
+                         GLX_SAMPLE_BUFFERS_ARB,
+                         1,
+                         0};
 
   int num_configs = 0;
   while (num_configs == 0 && fb_attributes[1] >= 0) {
-    configs = glXChooseFBConfig(window, DefaultScreen(window), fb_attributes, &num_configs);
+    configs = glXChooseFBConfig(window, DefaultScreen(window), fb_attributes,
+                                &num_configs);
     fb_attributes[1] -= 2;
   }
 
   if (configs == NULL || num_configs == 0) {
-    msSetError(MS_OGLERR, "glXChooseFBConfig could not find any configs. Likely your video card or drivers are not supported. glError: %d", "OglContext::init()", glGetError());
+    msSetError(MS_OGLERR,
+               "glXChooseFBConfig could not find any configs. Likely your "
+               "video card or drivers are not supported. glError: %d",
+               "OglContext::init()", glGetError());
     return false;
   }
 
-  sharingContext = glXCreateNewContext(window, *configs, GLX_RGBA_TYPE, NULL, 1);
+  sharingContext =
+      glXCreateNewContext(window, *configs, GLX_RGBA_TYPE, NULL, 1);
   if (sharingContext == NULL) {
-    msSetError(MS_OGLERR, "glXCreateNewContext failed. glError: %d", "OglContext::initSharingContext()", glGetError());
+    msSetError(MS_OGLERR, "glXCreateNewContext failed. glError: %d",
+               "OglContext::initSharingContext()", glGetError());
     return false;
   }
 
   return true;
 }
 
-bool OglContext::createPBuffer(ms_uint32 width, ms_uint32 height)
-{
+bool OglContext::createPBuffer(ms_uint32 width, ms_uint32 height) {
   int maxHeight, maxWidth;
 
   glXGetFBConfigAttrib(window, *configs, GLX_MAX_PBUFFER_WIDTH, &maxWidth);
@@ -388,27 +433,30 @@ bool OglContext::createPBuffer(ms_uint32
   this->width = MS_MIN(width, uMaxWidth);
   this->height = MS_MIN(height, uMaxHeight);
 
-  int iPbufferAttributes[] = {
-    GLX_PBUFFER_WIDTH, this->width,
-    GLX_PBUFFER_HEIGHT, this->height,
-    GLX_LARGEST_PBUFFER, false,
-    0, 0
-  };
+  int iPbufferAttributes[] = {GLX_PBUFFER_WIDTH,
+                              this->width,
+                              GLX_PBUFFER_HEIGHT,
+                              this->height,
+                              GLX_LARGEST_PBUFFER,
+                              false,
+                              0,
+                              0};
 
   pbuffer = glXCreatePbuffer(window, *configs, iPbufferAttributes);
   if (pbuffer == 0) {
-    msSetError(MS_OGLERR, "glXCreatePbuffer failed. glError: %d", "OglContext::init()", glGetError());
+    msSetError(MS_OGLERR, "glXCreatePbuffer failed. glError: %d",
+               "OglContext::init()", glGetError());
     return false;
   }
 
   return true;
 }
 
-bool OglContext::initWindow()
-{
-  const char* const display_name = getenv("DISPLAY");
+bool OglContext::initWindow() {
+  const char *const display_name = getenv("DISPLAY");
   if (!display_name) {
-    msSetError(MS_OGLERR, "DISPLAY environment variable not set", "OglContext::init()");
+    msSetError(MS_OGLERR, "DISPLAY environment variable not set",
+               "OglContext::init()");
     return false;
   }
 
@@ -418,38 +466,53 @@ bool OglContext::initWindow()
     return false;
   }
 
-  const int fb_attributes[] = {
-    GLX_RENDER_TYPE, GLX_RGBA_BIT,
-    GLX_DRAWABLE_TYPE, GLX_PBUFFER_BIT,
-    GLX_RED_SIZE, 8,
-    GLX_GREEN_SIZE, 8,
-    GLX_BLUE_SIZE, 8,
-    GLX_ALPHA_SIZE, 8,
-    GLX_DEPTH_SIZE, 16,
-    GLX_DOUBLEBUFFER, 0,
-    GLX_SAMPLE_BUFFERS_ARB, 1,
-    0
-  };
+  const int fb_attributes[] = {GLX_RENDER_TYPE,
+                               GLX_RGBA_BIT,
+                               GLX_DRAWABLE_TYPE,
+                               GLX_PBUFFER_BIT,
+                               GLX_RED_SIZE,
+                               8,
+                               GLX_GREEN_SIZE,
+                               8,
+                               GLX_BLUE_SIZE,
+                               8,
+                               GLX_ALPHA_SIZE,
+                               8,
+                               GLX_DEPTH_SIZE,
+                               16,
+                               GLX_DOUBLEBUFFER,
+                               0,
+                               GLX_SAMPLE_BUFFERS_ARB,
+                               1,
+                               0};
 
   int num_configs = 0;
-  GLXFBConfig* tempConfigs = glXChooseFBConfig(window, DefaultScreen(window), fb_attributes, &num_configs);
+  GLXFBConfig *tempConfigs = glXChooseFBConfig(window, DefaultScreen(window),
+                                               fb_attributes, &num_configs);
 
   if (tempConfigs == NULL || num_configs == 0) {
-    msSetError(MS_OGLERR, "glXChooseFBConfig could not find any configs. Likely your video card or drivers are not supported.", "OglContext::initWindow()");
+    msSetError(MS_OGLERR,
+               "glXChooseFBConfig could not find any configs. Likely your "
+               "video card or drivers are not supported.",
+               "OglContext::initWindow()");
     return false;
   }
 
-  GLXContext tempContext = glXCreateNewContext(window, *tempConfigs, GLX_RGBA_TYPE, NULL, 1);
+  GLXContext tempContext =
+      glXCreateNewContext(window, *tempConfigs, GLX_RGBA_TYPE, NULL, 1);
   if (tempContext == NULL) {
-    msSetError(MS_OGLERR, "glXCreateNewContext failed.", "OglContext::initWindow()");
+    msSetError(MS_OGLERR, "glXCreateNewContext failed.",
+               "OglContext::initWindow()");
     return false;
   }
 
-  int iPbufferAttributes[] =    {0, 0};
+  int iPbufferAttributes[] = {0, 0};
 
-  GLXPbuffer tempBuffer = glXCreatePbuffer(window, *tempConfigs, iPbufferAttributes);
+  GLXPbuffer tempBuffer =
+      glXCreatePbuffer(window, *tempConfigs, iPbufferAttributes);
   if (tempBuffer == 0) {
-    msSetError(MS_OGLERR, "glXCreatePbuffer failed.", "OglContext::initWindow()");
+    msSetError(MS_OGLERR, "glXCreatePbuffer failed.",
+               "OglContext::initWindow()");
     return false;
   }
 
@@ -458,9 +521,9 @@ bool OglContext::initWindow()
     return false;
   }
 
-  glGetIntegerv(GL_MAX_SAMPLES_EXT, (GLint*)&MAX_MULTISAMPLE_SAMPLES);
-  glGetIntegerv(GL_MAX_TEXTURE_MAX_ANISOTROPY_EXT, (GLint*) &MAX_ANISOTROPY);
-  glGetIntegerv(GL_MAX_TEXTURE_SIZE, (GLint*)&MAX_TEXTURE_SIZE);
+  glGetIntegerv(GL_MAX_SAMPLES_EXT, (GLint *)&MAX_MULTISAMPLE_SAMPLES);
+  glGetIntegerv(GL_MAX_TEXTURE_MAX_ANISOTROPY_EXT, (GLint *)&MAX_ANISOTROPY);
+  glGetIntegerv(GL_MAX_TEXTURE_SIZE, (GLint *)&MAX_TEXTURE_SIZE);
 
   MIN_TEXTURE_SIZE = 8;
 
diff -pruN 8.0.1-5/mapoglcontext.h 8.0.2-1/mapoglcontext.h
--- 8.0.1-5/mapoglcontext.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapoglcontext.h	2024-06-11 20:41:34.000000000 +0000
@@ -32,12 +32,11 @@
 
 #ifdef USE_OGL
 
-
 #if defined(_WIN32) && !defined(__CYGWIN__)
 
 #include <windows.h>
-#include<GL/gl.h>
-#include<GL/glu.h>
+#include <GL/gl.h>
+#include <GL/glu.h>
 
 #include "opengl/glext.h"
 #include "opengl/wglext.h"
@@ -50,11 +49,11 @@ typedef HGLRC OGL_PBUFFER;
 
 #else
 
-#include<GL/gl.h>
-#include<GL/glx.h>
-#include<GL/glu.h>
+#include <GL/gl.h>
+#include <GL/glx.h>
+#include <GL/glu.h>
 
-typedef Display* OGL_WINDOW;
+typedef Display *OGL_WINDOW;
 typedef GLXContext OGL_CONTEXT;
 typedef GLXPbuffer OGL_PBUFFER;
 
@@ -64,10 +63,9 @@ typedef GLXPbuffer OGL_PBUFFER;
 
 class OglRenderer;
 
-class OglContext
-{
+class OglContext {
 private:
-  static OglContext* current;
+  static OglContext *current;
   static bool initWindow();
   static bool initSharingContext();
   static ms_uint32 getTextureSize(GLuint dimension, ms_uint32 value);
@@ -79,9 +77,9 @@ private:
   HDC hPBufferDC;
   HGLRC hPBufferRC;
 #else
-  static Display* window;
+  static Display *window;
   static GLXContext sharingContext;
-  static GLXFBConfig* configs;
+  static GLXFBConfig *configs;
   GLXPbuffer pbuffer;
 #endif
 
@@ -93,17 +91,12 @@ public:
 
   OglContext(ms_uint32 width, ms_uint32 height);
   ~OglContext();
-  int getHeight() const {
-    return height;
-  }
-  int getWidth() const {
-    return width;
-  }
-  bool isValid() const {
-    return valid;
-  }
+  int getHeight() const { return height; }
+  int getWidth() const { return width; }
+  bool isValid() const { return valid; }
   bool makeCurrent();
   void bindPBufferToTexture();
+
 private:
   bool createPBuffer(ms_uint32 width, ms_uint32 height);
   ms_uint32 width;
diff -pruN 8.0.1-5/mapoglrenderer.cpp 8.0.2-1/mapoglrenderer.cpp
--- 8.0.1-5/mapoglrenderer.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapoglrenderer.cpp	2024-06-11 20:41:34.000000000 +0000
@@ -36,8 +36,6 @@
 #include "maperror.h"
 #include "mapoglrenderer.h"
 
-
-
 using namespace std;
 
 double OglRenderer::SIZE_RES = 100.0 / 72.0;
@@ -55,18 +53,22 @@ std::vector<GLuint> OglRenderer::shapes
 GLvoid CALLBACK beginCallback(GLenum which);
 GLvoid CALLBACK errorCallback(GLenum errorCode);
 GLvoid CALLBACK endCallback(void);
-GLvoid CALLBACK combineDataCallback(GLdouble coords[3], GLdouble* vertex_data[4], GLfloat weight[4], void** dataOut, void* polygon_data);
+GLvoid CALLBACK combineDataCallback(GLdouble coords[3],
+                                    GLdouble *vertex_data[4], GLfloat weight[4],
+                                    void **dataOut, void *polygon_data);
 GLvoid CALLBACK vertexCallback(GLdouble *vertex);
 
-OglRenderer::OglRenderer(ms_uint32 width, ms_uint32 height, colorObj* color)
-  : width(width), height(height), texture(NULL), transparency(1.0), valid(false)
-{
+OglRenderer::OglRenderer(ms_uint32 width, ms_uint32 height, colorObj *color)
+    : width(width), height(height), texture(NULL), transparency(1.0),
+      valid(false) {
   context = new OglContext(width, height);
-  if (!context->isValid()) return;
-  if (!context->makeCurrent()) return;
+  if (!context->isValid())
+    return;
+  if (!context->makeCurrent())
+    return;
 
   int viewPort[4];
-  glGetIntegerv(GL_VIEWPORT ,viewPort);
+  glGetIntegerv(GL_VIEWPORT, viewPort);
   viewportX = viewPort[0];
   viewportY = viewPort[1];
   viewportWidth = viewPort[2];
@@ -79,9 +81,9 @@ OglRenderer::OglRenderer(ms_uint32 width
   glHint(GL_MULTISAMPLE_FILTER_HINT_NV, GL_NICEST);
 
   glEnable(GL_TEXTURE_2D);
-  glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE );
+  glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);
   glEnable(GL_BLEND);
-  glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA );
+  glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
 
   glDisable(GL_DEPTH_TEST);
   glDepthFunc(GL_LEQUAL);
@@ -96,17 +98,17 @@ OglRenderer::OglRenderer(ms_uint32 width
     return;
   }
 
-  gluTessCallback(tess, GLU_TESS_VERTEX, (void (CALLBACK*)(void)) vertexCallback);
-  gluTessCallback(tess, GLU_TESS_BEGIN, (void(CALLBACK*)(void)) beginCallback);
-  gluTessCallback(tess, GLU_TESS_END, (void(CALLBACK*)(void)) endCallback);
-  gluTessCallback(tess, GLU_TESS_ERROR, (void(CALLBACK*)(void)) errorCallback);
-  gluTessCallback(tess, GLU_TESS_COMBINE_DATA, (void(CALLBACK*)(void)) combineDataCallback);
+  gluTessCallback(tess, GLU_TESS_VERTEX,
+                  (void(CALLBACK *)(void))vertexCallback);
+  gluTessCallback(tess, GLU_TESS_BEGIN, (void(CALLBACK *)(void))beginCallback);
+  gluTessCallback(tess, GLU_TESS_END, (void(CALLBACK *)(void))endCallback);
+  gluTessCallback(tess, GLU_TESS_ERROR, (void(CALLBACK *)(void))errorCallback);
+  gluTessCallback(tess, GLU_TESS_COMBINE_DATA,
+                  (void(CALLBACK *)(void))combineDataCallback);
 
   if (color) {
-    glClearColor((double) color->red / 255,
-                 (double) color->green / 255,
-                 (double) color->blue / 255,
-                 (double)color->alpha / 100);
+    glClearColor((double)color->red / 255, (double)color->green / 255,
+                 (double)color->blue / 255, (double)color->alpha / 100);
   } else {
     glClearColor(0.0, 0.0, 0.0, 0.0);
   }
@@ -121,54 +123,55 @@ OglRenderer::OglRenderer(ms_uint32 width
   valid = true;
 }
 
-OglRenderer::~OglRenderer()
-{
+OglRenderer::~OglRenderer() {
   makeCurrent();
   glViewport(viewportX, viewportY, viewportWidth, viewportHeight);
   glPopMatrix();
   delete context;
 }
 
-OglCachePtr OglRenderer::getTexture()
-{
+OglCachePtr OglRenderer::getTexture() {
   if (!texture) {
     makeCurrent();
     texture = new OglCache();
-    texture->texture = createTexture(0,0);//TEXTURE_BORDER/2, TEXTURE_BORDER/2);
+    texture->texture =
+        createTexture(0, 0); // TEXTURE_BORDER/2, TEXTURE_BORDER/2);
     texture->width = this->width;
     texture->height = this->height;
   }
   return texture;
 }
 
-GLuint OglRenderer::createTexture(ms_uint32 offsetX, ms_uint32 offsetY)
-{
+GLuint OglRenderer::createTexture(ms_uint32 offsetX, ms_uint32 offsetY) {
   GLuint texture = 0;
   glGenTextures(1, &texture);
   glBindTexture(GL_TEXTURE_2D, texture);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
   glTexParameteri(GL_TEXTURE_2D, GL_GENERATE_MIPMAP, GL_TRUE);
-  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER,GL_NEAREST);
-  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER,GL_NEAREST);
+  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
+  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
   if (OglContext::MAX_ANISOTROPY != 0) {
-    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAX_ANISOTROPY_EXT, OglContext::MAX_ANISOTROPY);
+    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAX_ANISOTROPY_EXT,
+                    OglContext::MAX_ANISOTROPY);
   }
-  glCopyTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, offsetX, offsetY, context->getWidth(), context->getHeight(), 0);
-  glBindTexture(GL_TEXTURE_2D,0);
+  glCopyTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, offsetX, offsetY,
+                   context->getWidth(), context->getHeight(), 0);
+  glBindTexture(GL_TEXTURE_2D, 0);
   return texture;
 }
 
-bool OglRenderer::getStringBBox(char *font, double size, char *string, rectObj *rect, double** advances)
-{
-  FTFont* face = getFTFont(font, size);
+bool OglRenderer::getStringBBox(char *font, double size, char *string,
+                                rectObj *rect, double **advances) {
+  FTFont *face = getFTFont(font, size);
   if (!face) {
-    msSetError(MS_OGLERR, "Failed to load font (%s).", "OglRenderer::getStringBBox()", font);
+    msSetError(MS_OGLERR, "Failed to load font (%s).",
+               "OglRenderer::getStringBBox()", font);
     return false;
   }
 
-  float llx =0.0f, lly=0.0f, llz=0.0f, urx=0.0f, ury=0.0f, urz=0.0f;
-  glPushAttrib( GL_ALL_ATTRIB_BITS );
+  float llx = 0.0f, lly = 0.0f, llz = 0.0f, urx = 0.0f, ury = 0.0f, urz = 0.0f;
+  glPushAttrib(GL_ALL_ATTRIB_BITS);
   FTBBox boundingBox = face->BBox(string);
   glPopAttrib();
 
@@ -188,31 +191,31 @@ bool OglRenderer::getStringBBox(char *fo
   return true;
 }
 
-void OglRenderer::initializeRasterBuffer(rasterBufferObj * rb, int width, int height, bool useAlpha)
-{
-  unsigned char* buffer = new unsigned char[4 * width * height];
+void OglRenderer::initializeRasterBuffer(rasterBufferObj *rb, int width,
+                                         int height, bool useAlpha) {
+  unsigned char *buffer = new unsigned char[4 * width * height];
   rb->data.rgba.pixels = buffer;
   rb->data.rgba.r = &buffer[2];
   rb->data.rgba.g = &buffer[1];
   rb->data.rgba.b = &buffer[0];
-  if (useAlpha) rb->data.rgba.a = &buffer[3];
+  if (useAlpha)
+    rb->data.rgba.a = &buffer[3];
 
-  rb->type =MS_BUFFER_BYTE_RGBA;
-  rb->data.rgba.row_step = 4*width;
+  rb->type = MS_BUFFER_BYTE_RGBA;
+  rb->data.rgba.row_step = 4 * width;
   rb->data.rgba.pixel_step = 4;
   rb->width = width;
   rb->height = height;
 }
 
-void OglRenderer::readRasterBuffer(rasterBufferObj * rb)
-{
+void OglRenderer::readRasterBuffer(rasterBufferObj *rb) {
   makeCurrent();
-  unsigned char* buffer = new unsigned char[4 * width * height];
+  unsigned char *buffer = new unsigned char[4 * width * height];
   glReadPixels(0, 0, width, height, GL_BGRA, GL_UNSIGNED_BYTE, buffer);
 
-  rb->type =MS_BUFFER_BYTE_RGBA;
+  rb->type = MS_BUFFER_BYTE_RGBA;
   rb->data.rgba.pixels = buffer;
-  rb->data.rgba.row_step = 4*width;
+  rb->data.rgba.row_step = 4 * width;
   rb->data.rgba.pixel_step = 4;
   rb->width = width;
   rb->height = height;
@@ -222,29 +225,30 @@ void OglRenderer::readRasterBuffer(raste
   rb->data.rgba.a = NULL;
 }
 
-void OglRenderer::drawRasterBuffer(rasterBufferObj *overlay, double opacity, int srcX, int srcY, int dstX, int dstY, int width, int height)
-{
-  // todo to support all alpha and srcx/y this needs to be done by creating a texture
+void OglRenderer::drawRasterBuffer(rasterBufferObj *overlay, double opacity,
+                                   int srcX, int srcY, int dstX, int dstY,
+                                   int width, int height) {
+  // todo to support all alpha and srcx/y this needs to be done by creating a
+  // texture
   makeCurrent();
-  glDrawPixels(width, height, GL_BGRA, GL_UNSIGNED_BYTE, overlay->data.rgba.pixels);
+  glDrawPixels(width, height, GL_BGRA, GL_UNSIGNED_BYTE,
+               overlay->data.rgba.pixels);
 }
 
-void OglRenderer::setTransparency(double transparency)
-{
+void OglRenderer::setTransparency(double transparency) {
   this->transparency = transparency;
 }
 
-void OglRenderer::setColor(colorObj *color)
-{
+void OglRenderer::setColor(colorObj *color) {
   if (color && MS_VALID_COLOR(*color)) {
-    glColor4d((double) color->red / 255, (double) color->green / 255, (double) color->blue / 255, transparency);
+    glColor4d((double)color->red / 255, (double)color->green / 255,
+              (double)color->blue / 255, transparency);
   } else {
     glColor4d(0.0, 0.0, 0.0, 1.0);
   }
 }
 
-void OglRenderer::drawVectorLineStrip(symbolObj *symbol, double width)
-{
+void OglRenderer::drawVectorLineStrip(symbolObj *symbol, double width) {
   glPushMatrix();
   glLineWidth(width);
   glBegin(GL_LINE_STRIP);
@@ -261,8 +265,8 @@ void OglRenderer::drawVectorLineStrip(sy
   glPopMatrix();
 }
 
-double OglRenderer::drawTriangles(pointObj* p1, pointObj* p2, double width, double tilelength, double textureStart)
-{
+double OglRenderer::drawTriangles(pointObj *p1, pointObj *p2, double width,
+                                  double tilelength, double textureStart) {
   double dx = p1->x - p2->x;
   double dy = p1->y - p2->y;
   double dist = sqrt(dx * dx + dy * dy);
@@ -289,8 +293,8 @@ double OglRenderer::drawTriangles(pointO
   return dist;
 }
 
-double OglRenderer::drawQuad(pointObj* p1, pointObj* p2, double width, double tilelength, double textureStart)
-{
+double OglRenderer::drawQuad(pointObj *p1, pointObj *p2, double width,
+                             double tilelength, double textureStart) {
   double dx = p1->x - p2->x;
   double dy = p1->y - p2->y;
   double dist = sqrt(dx * dx + dy * dy);
@@ -309,9 +313,11 @@ double OglRenderer::drawQuad(pointObj* p
   glTexCoord2d(textureStart, 1);
   glVertex2d(p1->x, p1->y - width / 2); // Bottom Left Of The Texture and Quad
   glTexCoord2d(textureStart + (dist / tilelength), 1);
-  glVertex2d(p1->x + dist, p1->y - width / 2); // Bottom Right Of The Texture and Quad
+  glVertex2d(p1->x + dist,
+             p1->y - width / 2); // Bottom Right Of The Texture and Quad
   glTexCoord2d(textureStart + (dist / tilelength), 0);
-  glVertex2d(p1->x + dist, p1->y + width / 2); // Top Right Of The Texture and Quad
+  glVertex2d(p1->x + dist,
+             p1->y + width / 2); // Top Right Of The Texture and Quad
   glTexCoord2d(textureStart, 0);
   glVertex2d(p1->x, p1->y + width / 2); // Top Left Of The Texture and Quad
   glEnd();
@@ -321,8 +327,8 @@ double OglRenderer::drawQuad(pointObj* p
   return dist;
 }
 
-void OglRenderer::renderTile(const OglCachePtr& tile, double x, double y, double angle)
-{
+void OglRenderer::renderTile(const OglCachePtr &tile, double x, double y,
+                             double angle) {
   makeCurrent();
   glEnable(GL_SAMPLE_ALPHA_TO_COVERAGE_ARB);
   glBindTexture(GL_TEXTURE_2D, tile->texture);
@@ -334,13 +340,17 @@ void OglRenderer::renderTile(const OglCa
   glTranslated(-x, -y, 0);
   glBegin(GL_QUADS);
   glTexCoord2d(0, 1);
-  glVertex2d( x-(tile->width/2), y+(tile->height/2));    // Bottom Left Of The Texture and Quad
+  glVertex2d(x - (tile->width / 2),
+             y + (tile->height / 2)); // Bottom Left Of The Texture and Quad
   glTexCoord2d(1, 1);
-  glVertex2d( x+(tile->width/2), y+(tile->height/2));    // Bottom Right Of The Texture and Quad
+  glVertex2d(x + (tile->width / 2),
+             y + (tile->height / 2)); // Bottom Right Of The Texture and Quad
   glTexCoord2d(1, 0);
-  glVertex2d( x+(tile->width/2), y-(tile->height/2));    // Top Right Of The Texture and Quad
+  glVertex2d(x + (tile->width / 2),
+             y - (tile->height / 2)); // Top Right Of The Texture and Quad
   glTexCoord2d(0, 0);
-  glVertex2d( x-(tile->width/2), y-(tile->height/2));    // Top Left Of The Texture and Quad
+  glVertex2d(x - (tile->width / 2),
+             y - (tile->height / 2)); // Top Left Of The Texture and Quad
   glEnd();
 
   glPopMatrix();
@@ -348,8 +358,7 @@ void OglRenderer::renderTile(const OglCa
   glDisable(GL_SAMPLE_ALPHA_TO_COVERAGE_ARB);
 }
 
-void OglRenderer::renderPolylineTile(shapeObj *shape, const OglCachePtr& tile)
-{
+void OglRenderer::renderPolylineTile(shapeObj *shape, const OglCachePtr &tile) {
   makeCurrent();
   glBindTexture(GL_TEXTURE_2D, tile->texture); // Select Our Texture
   glBegin(GL_TRIANGLE_STRIP);
@@ -357,25 +366,28 @@ void OglRenderer::renderPolylineTile(sha
   double place = 0.0;
   for (int i = 0; i < shape->numlines; i++) {
     for (int j = 0; j < shape->line[i].numpoints - 1; j++) {
-      double dist = drawTriangles(&shape->line[i].point[j], &shape->line[i].point[j + 1], tile->height, tile->width, place / tile->width);
+      double dist =
+          drawTriangles(&shape->line[i].point[j], &shape->line[i].point[j + 1],
+                        tile->height, tile->width, place / tile->width);
       place = (place + dist);
-      while (place >= tile->width) place -= tile->width;
+      while (place >= tile->width)
+        place -= tile->width;
     }
   }
   glEnd();
   glBindTexture(GL_TEXTURE_2D, 0);
 }
 
-
-void OglRenderer::renderVectorSymbol(double x, double y, symbolObj *symbol, double scale, double angle, colorObj *c, colorObj *oc, double ow)
-{
+void OglRenderer::renderVectorSymbol(double x, double y, symbolObj *symbol,
+                                     double scale, double angle, colorObj *c,
+                                     colorObj *oc, double ow) {
   makeCurrent();
   glPushMatrix();
   glTranslated(x, y, 0);
   glRotated(angle, 0, 0, 1);
   glScaled(scale, scale, 0);
 
-  glTranslated(-symbol->sizex/2, -symbol->sizey/2, 0.0);
+  glTranslated(-symbol->sizex / 2, -symbol->sizey / 2, 0.0);
 
   if (oc != NULL && MS_VALID_COLOR(*oc) && ow > 0) {
     setColor(oc);
@@ -391,9 +403,9 @@ void OglRenderer::renderVectorSymbol(dou
 }
 
 void OglRenderer::renderPolyline(shapeObj *p, colorObj *c, double width,
-                                 int patternlength, double* pattern, int lineCap, int joinStyle,
-                                 colorObj *outlinecolor, double outlinewidth)
-{
+                                 int patternlength, double *pattern,
+                                 int lineCap, int joinStyle,
+                                 colorObj *outlinecolor, double outlinewidth) {
   makeCurrent();
   if (outlinecolor) {
     glEnable(GL_DEPTH_TEST);
@@ -410,7 +422,7 @@ void OglRenderer::renderPolyline(shapeOb
     /* FIXME */
     if (p->renderer_cache == NULL)
       return;
-    OglCache* cache = (OglCache*) p->renderer_cache;
+    OglCache *cache = (OglCache *)p->renderer_cache;
     GLuint texture = cache->texture;
     if (cache->patternDistance > 0) {
       glBindTexture(GL_TEXTURE_2D, texture);
@@ -418,10 +430,9 @@ void OglRenderer::renderPolyline(shapeOb
       glBegin(GL_TRIANGLE_STRIP);
       for (int j = 0; j < p->numlines; j++) {
         for (int i = 0; i < p->line[j].numpoints - 1; i++) {
-          double dist = drawTriangles(&p->line[j].point[i],
-                                      &p->line[j].point[i + 1], width,
-                                      cache->patternDistance, place
-                                      / cache->patternDistance);
+          double dist = drawTriangles(
+              &p->line[j].point[i], &p->line[j].point[i + 1], width,
+              cache->patternDistance, place / cache->patternDistance);
           place = (place + dist);
           while (place >= cache->patternDistance)
             place -= cache->patternDistance; // better than mod, no rounding
@@ -436,22 +447,24 @@ void OglRenderer::renderPolyline(shapeOb
     bool quads = !(width >= widthRange[0] && width <= widthRange[1]);
     double circleScale = width / SHAPE_CIRCLE_RADIUS / 2;
     glLineWidth(width);
-    if (quads || (width > 1.0 && (lineCap == MS_CJC_ROUND || joinStyle == MS_CJC_ROUND))) {
+    if (quads || (width > 1.0 &&
+                  (lineCap == MS_CJC_ROUND || joinStyle == MS_CJC_ROUND))) {
       for (int j = 0; j < p->numlines; j++) {
         for (int i = 0; i < p->line[j].numpoints; i++) {
           if (i != p->line[j].numpoints - 1) {
             if (quads) {
-              drawQuad(&p->line[j].point[i], &p->line[j].point[i
-                       + 1], width);
+              drawQuad(&p->line[j].point[i], &p->line[j].point[i + 1], width);
             } else {
               glBegin(GL_LINES);
               glVertex2f(p->line[j].point[i].x, p->line[j].point[i].y);
-              glVertex2f(p->line[j].point[i + 1].x,p->line[j].point[i + 1].y);
+              glVertex2f(p->line[j].point[i + 1].x, p->line[j].point[i + 1].y);
               glEnd();
             }
           }
-          if ((lineCap == MS_CJC_ROUND && (i == 0 || i == p->line[j].numpoints - 1)) ||
-              (joinStyle == MS_CJC_ROUND && (i > 0 && i < p->line[j].numpoints - 1))) {
+          if ((lineCap == MS_CJC_ROUND &&
+               (i == 0 || i == p->line[j].numpoints - 1)) ||
+              (joinStyle == MS_CJC_ROUND &&
+               (i > 0 && i < p->line[j].numpoints - 1))) {
             glPushMatrix();
             glTranslated(p->line[j].point[i].x, p->line[j].point[i].y, 0);
             glScaled(circleScale, circleScale, 0);
@@ -467,7 +480,6 @@ void OglRenderer::renderPolyline(shapeOb
           glVertex2f(p->line[j].point[i].x, p->line[j].point[i].y);
         }
         glEnd();
-
       }
     }
   }
@@ -477,23 +489,26 @@ void OglRenderer::renderPolyline(shapeOb
     double owidth = MS_MAX(width + OUTLINE_WIDTH, outlinewidth);
     glPushMatrix();
     glTranslated(0, 0, -1);
-    renderPolyline(p, outlinecolor, owidth, patternlength, pattern, lineCap, joinStyle);
+    renderPolyline(p, outlinecolor, owidth, patternlength, pattern, lineCap,
+                   joinStyle);
     glPopMatrix();
     glDisable(GL_DEPTH_TEST);
   }
-
 }
 
-void OglRenderer::renderPolygon(shapeObj *p, colorObj *color, colorObj *outlinecolor, double outlinewidth, const OglCachePtr& tile, int lineCap, int joinStyle)
-{
+void OglRenderer::renderPolygon(shapeObj *p, colorObj *color,
+                                colorObj *outlinecolor, double outlinewidth,
+                                const OglCachePtr &tile, int lineCap,
+                                int joinStyle) {
   /*
-   OpenGL cannot draw complex polygons so we need to use a Tessallator to draw the polygon using a GL_TRIANGLE_FAN
+   OpenGL cannot draw complex polygons so we need to use a Tessallator to draw
+   the polygon using a GL_TRIANGLE_FAN
 
-   ISSUE: There's a problem here. It would seem that changing the dimensions or bounding box area breaks the code.
-   Reports need for a combine callback.
+   ISSUE: There's a problem here. It would seem that changing the dimensions or
+   bounding box area breaks the code. Reports need for a combine callback.
    */
   makeCurrent();
-  std::vector<GLdouble*> pointers;
+  std::vector<GLdouble *> pointers;
   double texWidth = 0;
   double texHeight = 0;
 
@@ -503,12 +518,12 @@ void OglRenderer::renderPolygon(shapeObj
     texHeight = tile->height;
   }
   setColor(color);
-  gluTessBeginPolygon(tess, NULL );
+  gluTessBeginPolygon(tess, NULL);
   for (int j = 0; j < p->numlines; j++) {
     gluTessBeginContour(tess);
     for (int i = 0; i < p->line[j].numpoints; i++) {
       // create temp array and place
-      GLdouble* dbls = new GLdouble[5];
+      GLdouble *dbls = new GLdouble[5];
       pointers.push_back(dbls);
       dbls[0] = p->line[j].point[i].x;
       dbls[1] = p->line[j].point[i].y;
@@ -518,32 +533,33 @@ void OglRenderer::renderPolygon(shapeObj
       gluTessVertex(tess, dbls, dbls);
     }
     gluTessEndContour(tess);
-
   }
   gluTessEndPolygon(tess);
 
   // destroy temp arrays
-  for (std::vector<GLdouble*>::iterator iter = pointers.begin(); iter
-       != pointers.end(); iter++) {
-    delete[] *iter;
+  for (std::vector<GLdouble *>::iterator iter = pointers.begin();
+       iter != pointers.end(); iter++) {
+    delete[] * iter;
   }
 
   glBindTexture(GL_TEXTURE_2D, 0); // Select Our Texture
 
-  if (outlinecolor != NULL && MS_VALID_COLOR(*outlinecolor) && outlinewidth > 0) {
-    renderPolyline(p, outlinecolor, outlinewidth, 0, NULL, lineCap,
-                   joinStyle);
+  if (outlinecolor != NULL && MS_VALID_COLOR(*outlinecolor) &&
+      outlinewidth > 0) {
+    renderPolyline(p, outlinecolor, outlinewidth, 0, NULL, lineCap, joinStyle);
   }
 }
 
 void OglRenderer::renderGlyphs(double x, double y, colorObj *color,
-                               colorObj *outlinecolor, double size, const char* font, char *thechars, double angle,
-                               colorObj *shadowcolor, double shdx, double shdy)
-{
+                               colorObj *outlinecolor, double size,
+                               const char *font, char *thechars, double angle,
+                               colorObj *shadowcolor, double shdx,
+                               double shdy) {
   makeCurrent();
-  FTFont* face = getFTFont(font, size);
+  FTFont *face = getFTFont(font, size);
   if (!face) {
-    msSetError(MS_OGLERR, "Failed to load font (%s).", "OglRenderer::renderGlyphs()", font);
+    msSetError(MS_OGLERR, "Failed to load font (%s).",
+               "OglRenderer::renderGlyphs()", font);
     return;
   }
 
@@ -577,25 +593,26 @@ void OglRenderer::renderGlyphs(double x,
 }
 
 void OglRenderer::renderPixmap(symbolObj *symbol, double x, double y,
-                               double angle, double scale)
-{
+                               double angle, double scale) {
   makeCurrent();
 
   float zoomX, zoomY;
   glGetFloatv(GL_ZOOM_X, &zoomX);
   glGetFloatv(GL_ZOOM_Y, &zoomY);
 
-
-  GLubyte* imgdata = symbol->pixmap_buffer->data.rgba.pixels;
-  glPixelZoom(zoomX*scale, zoomY*scale);
-  glRasterPos2d(x-symbol->pixmap_buffer->width/2, y-symbol->pixmap_buffer->height/2);
-  glDrawPixels(symbol->pixmap_buffer->width, symbol->pixmap_buffer->height, GL_BGRA, GL_UNSIGNED_BYTE, imgdata);
+  GLubyte *imgdata = symbol->pixmap_buffer->data.rgba.pixels;
+  glPixelZoom(zoomX * scale, zoomY * scale);
+  glRasterPos2d(x - symbol->pixmap_buffer->width / 2,
+                y - symbol->pixmap_buffer->height / 2);
+  glDrawPixels(symbol->pixmap_buffer->width, symbol->pixmap_buffer->height,
+               GL_BGRA, GL_UNSIGNED_BYTE, imgdata);
   glPixelZoom(zoomX, zoomY);
 }
 
-void OglRenderer::renderEllipse(double x, double y, double angle, double width, double height,
-                                colorObj *color, colorObj *outlinecolor, double outlinewidth = 1.0)
-{
+void OglRenderer::renderEllipse(double x, double y, double angle, double width,
+                                double height, colorObj *color,
+                                colorObj *outlinecolor,
+                                double outlinewidth = 1.0) {
   makeCurrent();
   if (outlinecolor && MS_VALID_COLOR(*outlinecolor)) {
     glEnable(GL_DEPTH_TEST);
@@ -610,7 +627,8 @@ void OglRenderer::renderEllipse(double x
     glRotated(angle, 0, 0, 1);
   }
   glTranslated(x, y, 0);
-  glScaled(width / SHAPE_CIRCLE_RADIUS / 2, height / SHAPE_CIRCLE_RADIUS / 2, 1);
+  glScaled(width / SHAPE_CIRCLE_RADIUS / 2, height / SHAPE_CIRCLE_RADIUS / 2,
+           1);
   glCallList(shapes[circle]);
   glPopMatrix();
 
@@ -618,16 +636,15 @@ void OglRenderer::renderEllipse(double x
     glPopMatrix();
     glPushMatrix();
     glTranslated(0, 0, -1);
-    renderEllipse(x, y, angle, width + outlinewidth, height, outlinecolor, NULL, 0);
+    renderEllipse(x, y, angle, width + outlinewidth, height, outlinecolor, NULL,
+                  0);
     glPopMatrix();
     glDisable(GL_DEPTH_TEST);
   }
-
 }
 
-bool OglRenderer::loadLine(shapeObj* shape, double width, int patternlength,
-                           double* pattern)
-{
+bool OglRenderer::loadLine(shapeObj *shape, double width, int patternlength,
+                           double *pattern) {
   /*    OglCache* cache = (OglCache*) shape->renderer_cache;
 
       if (cache->patternDistance == 0)
@@ -638,8 +655,9 @@ bool OglRenderer::loadLine(shapeObj* sha
           }
       }
       GLubyte imgdata[TEX_SIZE * TEX_SIZE * 4];
-      int pow2length = min(max(NextPowerOf2(cache->patternDistance), MIN_TEX_SIZE), TEX_SIZE);
-      int pow2width = min(max(NextPowerOf2(width), MIN_TEX_SIZE), TEX_SIZE);
+      int pow2length = min(max(NextPowerOf2(cache->patternDistance),
+     MIN_TEX_SIZE), TEX_SIZE); int pow2width = min(max(NextPowerOf2(width),
+     MIN_TEX_SIZE), TEX_SIZE);
 
       double lengthScale = (double) pow2length / cache->patternDistance;
       glColor3d(0, 0, 0);
@@ -683,42 +701,34 @@ bool OglRenderer::loadLine(shapeObj* sha
   return true;
 }
 
-FTFont* OglRenderer::getFTFont(const char* font, double size)
-{
-  FTFont** face = &fontCache[font][size];
+FTFont *OglRenderer::getFTFont(const char *font, double size) {
+  FTFont **face = &fontCache[font][size];
   if (*face == NULL && ifstream(font)) {
-    *face = new FTGLTextureFont( font );
+    *face = new FTGLTextureFont(font);
     if (*face) {
       (*face)->UseDisplayList(true);
-      (*face)->FaceSize(size*SIZE_RES);
+      (*face)->FaceSize(size * SIZE_RES);
     }
   }
   return *face;
 }
 
-GLvoid CALLBACK beginCallback(GLenum which)
-{
-  glBegin(which);
-}
+GLvoid CALLBACK beginCallback(GLenum which) { glBegin(which); }
 
-GLvoid CALLBACK errorCallback(GLenum errorCode)
-{
+GLvoid CALLBACK errorCallback(GLenum errorCode) {
   const GLubyte *estring;
   estring = gluErrorString(errorCode);
   fprintf(stderr, "Tessellation Error: %d %s\n", errorCode, estring);
   exit(0);
 }
 
-GLvoid CALLBACK endCallback(void)
-{
-  glEnd();
-}
+GLvoid CALLBACK endCallback(void) { glEnd(); }
 
-GLvoid CALLBACK combineDataCallback(GLdouble coords[3], GLdouble* vertex_data[4],
-                                    GLfloat weight[4], void** dataOut, void* polygon_data)
-{
+GLvoid CALLBACK combineDataCallback(GLdouble coords[3],
+                                    GLdouble *vertex_data[4], GLfloat weight[4],
+                                    void **dataOut, void *polygon_data) {
   GLdouble *vertex;
-  vertex = (GLdouble *) malloc(5 * sizeof(GLdouble));
+  vertex = (GLdouble *)malloc(5 * sizeof(GLdouble));
   vertex[0] = coords[0];
   vertex[1] = coords[1];
   vertex[2] = coords[2];
@@ -727,21 +737,21 @@ GLvoid CALLBACK combineDataCallback(GLdo
   *dataOut = vertex;
 }
 
-GLvoid CALLBACK vertexCallback(GLdouble *vertex)
-{
-  if (vertex[3] > 0) glTexCoord2d(vertex[0]/vertex[3], vertex[1]/vertex[4]);
+GLvoid CALLBACK vertexCallback(GLdouble *vertex) {
+  if (vertex[3] > 0)
+    glTexCoord2d(vertex[0] / vertex[3], vertex[1] / vertex[4]);
   glVertex3dv(vertex);
 }
 
-void OglRenderer::createShapes()
-{
+void OglRenderer::createShapes() {
   double da = MS_MIN(OGL_PI / 2, OGL_PI / SHAPE_CIRCLE_RES);
   GLuint circle = glGenLists(1);
   glNewList(circle, GL_COMPILE);
   glBegin(GL_TRIANGLE_FAN);
   glVertex2d(0, 0);
   for (double a = 0.0; a <= 2 * OGL_PI; a += da) {
-    glVertex2d(0 + cos(a) * SHAPE_CIRCLE_RADIUS, 0 + sin(a) * SHAPE_CIRCLE_RADIUS);
+    glVertex2d(0 + cos(a) * SHAPE_CIRCLE_RADIUS,
+               0 + sin(a) * SHAPE_CIRCLE_RADIUS);
   }
   glVertex2d(0 + SHAPE_CIRCLE_RADIUS, 0);
   glEnd();
@@ -750,9 +760,6 @@ void OglRenderer::createShapes()
   shapes.push_back(circle);
 }
 
-void OglRenderer::makeCurrent()
-{
-  context->makeCurrent();
-}
+void OglRenderer::makeCurrent() { context->makeCurrent(); }
 
 #endif
diff -pruN 8.0.1-5/mapoglrenderer.h 8.0.2-1/mapoglrenderer.h
--- 8.0.1-5/mapoglrenderer.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapoglrenderer.h	2024-06-11 20:41:34.000000000 +0000
@@ -42,53 +42,58 @@
 #include <FTGL/ftgl.h>
 #include <FTGL/FTGLTextureFont.h>
 
-
-class OglCache
-{
+class OglCache {
 public:
-  ~OglCache() {
-    glDeleteTextures(1, &texture);
-  }
+  ~OglCache() { glDeleteTextures(1, &texture); }
   GLuint texture;
   ms_uint32 width;
   ms_uint32 height;
   ms_uint32 patternDistance;
 };
 
-typedef OglCache* OglCachePtr;
+typedef OglCache *OglCachePtr;
 
-class OglRenderer
-{
+class OglRenderer {
 public:
-  OglRenderer(ms_uint32 width, ms_uint32 height, colorObj* color = NULL);
+  OglRenderer(ms_uint32 width, ms_uint32 height, colorObj *color = NULL);
   virtual ~OglRenderer();
 
-  void renderPolyline(shapeObj *p, colorObj *c, double width, int patternlength, double* pattern, int lineCap = MS_CJC_ROUND, int joinStyle = MS_CJC_ROUND, colorObj *outlinecolor = NULL, double outlinewidth = 0);
-  void renderPolygon(shapeObj*, colorObj *color, colorObj *outlinecolor, double outlinewidth, const OglCachePtr& tile = OglCachePtr(), int lineCap=MS_CJC_ROUND, int joinStyle=MS_CJC_ROUND);
-  void renderGlyphs(double x, double y, colorObj *color, colorObj *outlinecolor, double size, const char* font, char *thechars, double angle, colorObj *shadowcolor, double shdx, double shdy);
-  void renderPixmap(symbolObj *symbol, double x, double y, double angle, double scale);
-  void renderEllipse(double x, double y, double angle, double w, double h, colorObj *color, colorObj *outlinecolor, double outlinewidth);
-  void renderVectorSymbol(double x, double y, symbolObj *symbol, double scale, double angle, colorObj *c, colorObj *oc, double ow);
-  void renderTile(const OglCachePtr& tile, double x, double y, double angle);
-  void renderPolylineTile(shapeObj *p, const OglCachePtr& tile);
+  void renderPolyline(shapeObj *p, colorObj *c, double width, int patternlength,
+                      double *pattern, int lineCap = MS_CJC_ROUND,
+                      int joinStyle = MS_CJC_ROUND,
+                      colorObj *outlinecolor = NULL, double outlinewidth = 0);
+  void renderPolygon(shapeObj *, colorObj *color, colorObj *outlinecolor,
+                     double outlinewidth,
+                     const OglCachePtr &tile = OglCachePtr(),
+                     int lineCap = MS_CJC_ROUND, int joinStyle = MS_CJC_ROUND);
+  void renderGlyphs(double x, double y, colorObj *color, colorObj *outlinecolor,
+                    double size, const char *font, char *thechars, double angle,
+                    colorObj *shadowcolor, double shdx, double shdy);
+  void renderPixmap(symbolObj *symbol, double x, double y, double angle,
+                    double scale);
+  void renderEllipse(double x, double y, double angle, double w, double h,
+                     colorObj *color, colorObj *outlinecolor,
+                     double outlinewidth);
+  void renderVectorSymbol(double x, double y, symbolObj *symbol, double scale,
+                          double angle, colorObj *c, colorObj *oc, double ow);
+  void renderTile(const OglCachePtr &tile, double x, double y, double angle);
+  void renderPolylineTile(shapeObj *p, const OglCachePtr &tile);
 
-  static bool getStringBBox(char *font, double size, char *string, rectObj *rect, double** advances);
+  static bool getStringBBox(char *font, double size, char *string,
+                            rectObj *rect, double **advances);
   void setTransparency(double transparency);
 
-  void readRasterBuffer(rasterBufferObj * rb);
-  void drawRasterBuffer(rasterBufferObj *overlay, double opacity, int srcX, int srcY, int dstX, int dstY, int width, int height);
-  static void initializeRasterBuffer(rasterBufferObj * rb, int width, int height, bool useAlpha);
+  void readRasterBuffer(rasterBufferObj *rb);
+  void drawRasterBuffer(rasterBufferObj *overlay, double opacity, int srcX,
+                        int srcY, int dstX, int dstY, int width, int height);
+  static void initializeRasterBuffer(rasterBufferObj *rb, int width, int height,
+                                     bool useAlpha);
 
   OglCachePtr getTexture();
-  int getWidth() const {
-    return width;
-  }
-  int getHeight() const {
-    return height;
-  }
-  bool isValid() const {
-    return valid && context->isValid();
-  }
+  int getWidth() const { return width; }
+  int getHeight() const { return height; }
+  bool isValid() const { return valid && context->isValid(); }
+
 protected:
   OglCachePtr texture;
 
@@ -102,15 +107,18 @@ protected:
   GLsizei viewportWidth;
   GLsizei viewportHeight;
 
-  typedef std::map<const char*,std::map<double,FTFont*> > fontCache_t;
-  typedef std::map<symbolObj*,std::map<double,GLuint> > dashCache_t;
+  typedef std::map<const char *, std::map<double, FTFont *>> fontCache_t;
+  typedef std::map<symbolObj *, std::map<double, GLuint>> dashCache_t;
 
-  static FTFont* getFTFont(const char* font, double size);
-  bool loadLine(shapeObj* shape, double width, int patternlength, double *pattern);
-  double drawQuad(pointObj *p1, pointObj *p2, double width, double tilelength = 0.0, double textureStart = 0.0);
-  double drawTriangles(pointObj *p1, pointObj *p2, double width, double tilelength = 0.0, double textureStart = 0.0);
+  static FTFont *getFTFont(const char *font, double size);
+  bool loadLine(shapeObj *shape, double width, int patternlength,
+                double *pattern);
+  double drawQuad(pointObj *p1, pointObj *p2, double width,
+                  double tilelength = 0.0, double textureStart = 0.0);
+  double drawTriangles(pointObj *p1, pointObj *p2, double width,
+                       double tilelength = 0.0, double textureStart = 0.0);
   void drawVectorLineStrip(symbolObj *symbol, double width);
-  void drawFan(pointObj* center, pointObj* from, pointObj* to, int resolution);
+  void drawFan(pointObj *center, pointObj *from, pointObj *to, int resolution);
   void createShapes();
 
   GLuint createTexture(ms_uint32 x, ms_uint32 y);
@@ -119,14 +127,14 @@ protected:
   void setColor(colorObj *color);
 
   GLUtesselator *tess;
-  enum shapes_t { circle = 0};
+  enum shapes_t { circle = 0 };
 
-  OglContext* context;
+  OglContext *context;
 
   static dashCache_t dashCache;
   static fontCache_t fontCache;
   static std::vector<GLuint> shapes;
-  static std::vector<symbolObj*> testSymbols;
+  static std::vector<symbolObj *> testSymbols;
   static ms_uint32 OUTLINE_WIDTH;
   static ms_uint32 FONT_SIZE;
   static ms_uint32 FONT_RES;
@@ -138,4 +146,3 @@ protected:
 
 #endif /* USE_OGL */
 #endif
-
diff -pruN 8.0.1-5/mapogr.cpp 8.0.2-1/mapogr.cpp
--- 8.0.1-5/mapogr.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapogr.cpp	2024-06-11 20:41:34.000000000 +0000
@@ -43,50 +43,52 @@
 
 #include <memory>
 
-#define ACQUIRE_OGR_LOCK       msAcquireLock( TLOCK_OGR )
-#define RELEASE_OGR_LOCK       msReleaseLock( TLOCK_OGR )
+#define ACQUIRE_OGR_LOCK msAcquireLock(TLOCK_OGR)
+#define RELEASE_OGR_LOCK msReleaseLock(TLOCK_OGR)
 
 // GDAL 1.x API
 #include "ogr_api.h"
 
 typedef struct ms_ogr_file_info_t {
-  char        *pszFname;
-  char        *pszLayerDef;
-  int         nLayerIndex;
+  char *pszFname;
+  char *pszLayerDef;
+  int nLayerIndex;
   OGRDataSourceH hDS;
-  OGRLayerH   hLayer;
+  OGRLayerH hLayer;
   OGRFeatureH hLastFeature;
 
-  int         nTileId;                  /* applies on the tiles themselves. */
-  projectionObj sTileProj;              /* applies on the tiles themselves. */
+  int nTileId;             /* applies on the tiles themselves. */
+  projectionObj sTileProj; /* applies on the tiles themselves. */
 
   struct ms_ogr_file_info_t *poCurTile; /* exists on tile index, -> tiles */
-  bool        rect_is_defined;
-  rectObj     rect;                     /* set by TranslateMsExpression (possibly) and WhichShapes */
+  bool rect_is_defined;
+  rectObj rect; /* set by TranslateMsExpression (possibly) and WhichShapes */
 
-  int         last_record_index_read;
+  int last_record_index_read;
 
-  const char* dialect; /* NULL, Spatialite or PostgreSQL */
+  const char *dialect; /* NULL, Spatialite or PostgreSQL */
   char *pszSelect;
   char *pszSpatialFilterTableName;
   char *pszSpatialFilterGeometryColumn;
   char *pszMainTableName;
   char *pszRowId;
-  int   bIsOKForSQLCompose;
-  bool  bHasSpatialIndex; // used only for spatialite for now
-  char* pszTablePrefix; // prefix to qualify field names. used only for spatialite & gpkg for now when a join is done for spatial filtering.
+  int bIsOKForSQLCompose;
+  bool bHasSpatialIndex; // used only for spatialite for now
+  char *pszTablePrefix;  // prefix to qualify field names. used only for
+                         // spatialite & gpkg for now when a join is done for
+                         // spatial filtering.
 
-  int   bPaging;
+  int bPaging;
 
-  char* pszWHERE;
+  char *pszWHERE;
 
 } msOGRFileInfo;
 
 static int msOGRLayerIsOpen(layerObj *layer);
 static int msOGRLayerInitItemInfo(layerObj *layer);
 static int msOGRLayerGetAutoStyle(mapObj *map, layerObj *layer, classObj *c,
-                                  shapeObj* shape);
-static void msOGRCloseConnection( void *conn_handle );
+                                  shapeObj *shape);
+static void msOGRCloseConnection(void *conn_handle);
 
 /* ==================================================================
  * Geometry conversion functions
@@ -99,17 +101,21 @@ static void msOGRCloseConnection( void *
  * allocated large enough for the point to be added, but that numpoints
  * does not include this new point.
  **********************************************************************/
-static void ogrPointsAddPoint(lineObj *line, double dX, double dY, double dZ, int lineindex, rectObj *bounds)
-{
+static void ogrPointsAddPoint(lineObj *line, double dX, double dY, double dZ,
+                              int lineindex, rectObj *bounds) {
   /* Keep track of shape bounds */
   if (line->numpoints == 0 && lineindex == 0) {
     bounds->minx = bounds->maxx = dX;
     bounds->miny = bounds->maxy = dY;
   } else {
-    if (dX < bounds->minx)  bounds->minx = dX;
-    if (dX > bounds->maxx)  bounds->maxx = dX;
-    if (dY < bounds->miny)  bounds->miny = dY;
-    if (dY > bounds->maxy)  bounds->maxy = dY;
+    if (dX < bounds->minx)
+      bounds->minx = dX;
+    if (dX > bounds->maxx)
+      bounds->maxx = dX;
+    if (dY < bounds->miny)
+      bounds->miny = dY;
+    if (dY > bounds->maxy)
+      bounds->maxy = dY;
   }
 
   line->point[line->numpoints].x = dX;
@@ -122,75 +128,66 @@ static void ogrPointsAddPoint(lineObj *l
 /**********************************************************************
  *                     ogrGeomPoints()
  **********************************************************************/
-static int ogrGeomPoints(OGRGeometryH hGeom, shapeObj *outshp)
-{
-  int   i;
-  int   numpoints;
+static int ogrGeomPoints(OGRGeometryH hGeom, shapeObj *outshp) {
+  int i;
+  int numpoints;
 
   if (hGeom == NULL)
     return 0;
 
-  OGRwkbGeometryType eGType =  wkbFlatten( OGR_G_GetGeometryType( hGeom ) );
+  OGRwkbGeometryType eGType = wkbFlatten(OGR_G_GetGeometryType(hGeom));
 
   /* -------------------------------------------------------------------- */
   /*      Container types result in recursive invocation on each          */
   /*      subobject to add a set of points to the current list.           */
   /* -------------------------------------------------------------------- */
-  switch( eGType ) {
-    case wkbGeometryCollection:
-    case wkbMultiLineString:
-    case wkbMultiPolygon:
-    case wkbPolygon: {
-      /* Treat it as GeometryCollection */
-      for (int iGeom=0; iGeom < OGR_G_GetGeometryCount( hGeom ); iGeom++ ) {
-        if( ogrGeomPoints( OGR_G_GetGeometryRef( hGeom, iGeom ),
-                           outshp ) == -1 )
-          return -1;
-      }
-
-      return 0;
+  switch (eGType) {
+  case wkbGeometryCollection:
+  case wkbMultiLineString:
+  case wkbMultiPolygon:
+  case wkbPolygon: {
+    /* Treat it as GeometryCollection */
+    for (int iGeom = 0; iGeom < OGR_G_GetGeometryCount(hGeom); iGeom++) {
+      if (ogrGeomPoints(OGR_G_GetGeometryRef(hGeom, iGeom), outshp) == -1)
+        return -1;
     }
-    break;
 
-    case wkbPoint:
-    case wkbMultiPoint:
-    case wkbLineString:
-    case wkbLinearRing:
-      /* We will handle these directly */
-      break;
+    return 0;
+  } break;
 
-    default:
-      /* There shouldn't be any more cases should there? */
-      msSetError(MS_OGRERR,
-                 "OGRGeometry type `%s' not supported yet.",
-                 "ogrGeomPoints()",
-                 OGR_G_GetGeometryName( hGeom ) );
-      return(-1);
-  }
+  case wkbPoint:
+  case wkbMultiPoint:
+  case wkbLineString:
+  case wkbLinearRing:
+    /* We will handle these directly */
+    break;
 
+  default:
+    /* There shouldn't be any more cases should there? */
+    msSetError(MS_OGRERR, "OGRGeometry type `%s' not supported yet.",
+               "ogrGeomPoints()", OGR_G_GetGeometryName(hGeom));
+    return (-1);
+  }
 
   /* ------------------------------------------------------------------
    * Count total number of points
    * ------------------------------------------------------------------ */
-  if ( eGType == wkbPoint ) {
+  if (eGType == wkbPoint) {
     numpoints = 1;
-  } else if ( eGType == wkbLineString
-              ||  eGType == wkbLinearRing ) {
-    numpoints = OGR_G_GetPointCount( hGeom );
-  } else if ( eGType == wkbMultiPoint ) {
-    numpoints = OGR_G_GetGeometryCount( hGeom );
+  } else if (eGType == wkbLineString || eGType == wkbLinearRing) {
+    numpoints = OGR_G_GetPointCount(hGeom);
+  } else if (eGType == wkbMultiPoint) {
+    numpoints = OGR_G_GetGeometryCount(hGeom);
   } else {
-    msSetError(MS_OGRERR,
-               "OGRGeometry type `%s' not supported yet.",
-               "ogrGeomPoints()",
-               OGR_G_GetGeometryName( hGeom ) );
-    return(-1);
+    msSetError(MS_OGRERR, "OGRGeometry type `%s' not supported yet.",
+               "ogrGeomPoints()", OGR_G_GetGeometryName(hGeom));
+    return (-1);
   }
 
   /* ------------------------------------------------------------------
    * Do we need to allocate a line object to contain all our points?
    * ------------------------------------------------------------------ */
-  if( outshp->numlines == 0 ) {
+  if (outshp->numlines == 0) {
     lineObj newline;
 
     newline.numpoints = 0;
@@ -202,131 +199,128 @@ static int ogrGeomPoints(OGRGeometryH hG
    * Extend the point array for the new of points to add from the
    * current geometry.
    * ------------------------------------------------------------------ */
-  lineObj *line = outshp->line + outshp->numlines-1;
+  lineObj *line = outshp->line + outshp->numlines - 1;
 
-  if( line->point == NULL )
-    line->point = (pointObj *) malloc(sizeof(pointObj) * numpoints);
+  if (line->point == NULL)
+    line->point = (pointObj *)malloc(sizeof(pointObj) * numpoints);
   else
-    line->point = (pointObj *)
-                  realloc(line->point,sizeof(pointObj) * (numpoints+line->numpoints));
+    line->point = (pointObj *)realloc(
+        line->point, sizeof(pointObj) * (numpoints + line->numpoints));
 
-  if(!line->point) {
+  if (!line->point) {
     msSetError(MS_MEMERR, "Unable to allocate temporary point cache.",
                "ogrGeomPoints()");
-    return(-1);
+    return (-1);
   }
 
   /* ------------------------------------------------------------------
    * alloc buffer and filter/transform points
    * ------------------------------------------------------------------ */
-  if( eGType == wkbPoint ) {
-    ogrPointsAddPoint(line, OGR_G_GetX(hGeom, 0), OGR_G_GetY(hGeom, 0), OGR_G_GetZ(hGeom, 0),
-                      outshp->numlines-1, &(outshp->bounds));
-  } else if( eGType == wkbLineString
-             || eGType == wkbLinearRing ) {
-    for(i=0; i<numpoints; i++)
-      ogrPointsAddPoint(line, OGR_G_GetX(hGeom, i), OGR_G_GetY(hGeom, i), OGR_G_GetZ(hGeom, i),
-                        outshp->numlines-1, &(outshp->bounds));
-  } else if( eGType == wkbMultiPoint ) {
-    for(i=0; i<numpoints; i++) {
-      OGRGeometryH hPoint = OGR_G_GetGeometryRef( hGeom, i );
-      ogrPointsAddPoint(line, OGR_G_GetX(hPoint, 0), OGR_G_GetY(hPoint, 0), OGR_G_GetZ(hPoint, 0),
-                        outshp->numlines-1, &(outshp->bounds));
+  if (eGType == wkbPoint) {
+    ogrPointsAddPoint(line, OGR_G_GetX(hGeom, 0), OGR_G_GetY(hGeom, 0),
+                      OGR_G_GetZ(hGeom, 0), outshp->numlines - 1,
+                      &(outshp->bounds));
+  } else if (eGType == wkbLineString || eGType == wkbLinearRing) {
+    for (i = 0; i < numpoints; i++)
+      ogrPointsAddPoint(line, OGR_G_GetX(hGeom, i), OGR_G_GetY(hGeom, i),
+                        OGR_G_GetZ(hGeom, i), outshp->numlines - 1,
+                        &(outshp->bounds));
+  } else if (eGType == wkbMultiPoint) {
+    for (i = 0; i < numpoints; i++) {
+      OGRGeometryH hPoint = OGR_G_GetGeometryRef(hGeom, i);
+      ogrPointsAddPoint(line, OGR_G_GetX(hPoint, 0), OGR_G_GetY(hPoint, 0),
+                        OGR_G_GetZ(hPoint, 0), outshp->numlines - 1,
+                        &(outshp->bounds));
     }
   }
 
   outshp->type = MS_SHAPE_POINT;
 
-  return(0);
+  return (0);
 }
 
-
 /**********************************************************************
  *                     ogrGeomLine()
  *
  * Recursively convert any OGRGeometry into a shapeObj.  Each part becomes
  * a line in the overall shapeObj.
  **********************************************************************/
-static int ogrGeomLine(OGRGeometryH hGeom, shapeObj *outshp,
-                       int bCloseRings)
-{
+static int ogrGeomLine(OGRGeometryH hGeom, shapeObj *outshp, int bCloseRings) {
   if (hGeom == NULL)
     return 0;
 
   /* ------------------------------------------------------------------
    * Use recursive calls for complex geometries
    * ------------------------------------------------------------------ */
-  OGRwkbGeometryType eGType =  wkbFlatten( OGR_G_GetGeometryType( hGeom ) );
-
+  OGRwkbGeometryType eGType = wkbFlatten(OGR_G_GetGeometryType(hGeom));
 
-  if ( eGType == wkbPolygon
-       || eGType == wkbGeometryCollection
-       || eGType == wkbMultiLineString
-       || eGType == wkbMultiPolygon ) {
+  if (eGType == wkbPolygon || eGType == wkbGeometryCollection ||
+      eGType == wkbMultiLineString || eGType == wkbMultiPolygon) {
     if (eGType == wkbPolygon && outshp->type == MS_SHAPE_NULL)
       outshp->type = MS_SHAPE_POLYGON;
 
     /* Treat it as GeometryCollection */
-    for (int iGeom=0; iGeom < OGR_G_GetGeometryCount( hGeom ); iGeom++ ) {
-      if( ogrGeomLine( OGR_G_GetGeometryRef( hGeom, iGeom ),
-                       outshp, bCloseRings ) == -1 )
+    for (int iGeom = 0; iGeom < OGR_G_GetGeometryCount(hGeom); iGeom++) {
+      if (ogrGeomLine(OGR_G_GetGeometryRef(hGeom, iGeom), outshp,
+                      bCloseRings) == -1)
         return -1;
     }
   }
   /* ------------------------------------------------------------------
    * OGRPoint and OGRMultiPoint
    * ------------------------------------------------------------------ */
-  else if ( eGType == wkbPoint || eGType == wkbMultiPoint ) {
+  else if (eGType == wkbPoint || eGType == wkbMultiPoint) {
     /* Hummmm a point when we're drawing lines/polygons... just drop it! */
   }
   /* ------------------------------------------------------------------
    * OGRLinearRing/OGRLineString ... both are of type wkbLineString
    * ------------------------------------------------------------------ */
-  else if ( eGType == wkbLineString ) {
-    int       j, numpoints;
-    lineObj   line= {0,NULL};
-    double    dX, dY;
+  else if (eGType == wkbLineString) {
+    int j, numpoints;
+    lineObj line = {0, NULL};
+    double dX, dY;
 
-    if ((numpoints = OGR_G_GetPointCount( hGeom )) < 2)
+    if ((numpoints = OGR_G_GetPointCount(hGeom)) < 2)
       return 0;
 
     if (outshp->type == MS_SHAPE_NULL)
       outshp->type = MS_SHAPE_LINE;
 
     line.numpoints = 0;
-    line.point = (pointObj *)malloc(sizeof(pointObj)*(numpoints+1));
-    if(!line.point) {
+    line.point = (pointObj *)malloc(sizeof(pointObj) * (numpoints + 1));
+    if (!line.point) {
       msSetError(MS_MEMERR, "Unable to allocate temporary point cache.",
                  "ogrGeomLine");
-      return(-1);
+      return (-1);
     }
 
-    OGR_G_GetPoints(hGeom,
-                    &(line.point[0].x), sizeof(pointObj),
-                    &(line.point[0].y), sizeof(pointObj),
-                    &(line.point[0].z), sizeof(pointObj));
+    OGR_G_GetPoints(hGeom, &(line.point[0].x), sizeof(pointObj),
+                    &(line.point[0].y), sizeof(pointObj), &(line.point[0].z),
+                    sizeof(pointObj));
 
-    for(j=0; j<numpoints; j++) {
-      dX = line.point[j].x = OGR_G_GetX( hGeom, j);
-      dY = line.point[j].y = OGR_G_GetY( hGeom, j);
+    for (j = 0; j < numpoints; j++) {
+      dX = line.point[j].x = OGR_G_GetX(hGeom, j);
+      dY = line.point[j].y = OGR_G_GetY(hGeom, j);
 
       /* Keep track of shape bounds */
       if (j == 0 && outshp->numlines == 0) {
         outshp->bounds.minx = outshp->bounds.maxx = dX;
         outshp->bounds.miny = outshp->bounds.maxy = dY;
       } else {
-        if (dX < outshp->bounds.minx)  outshp->bounds.minx = dX;
-        if (dX > outshp->bounds.maxx)  outshp->bounds.maxx = dX;
-        if (dY < outshp->bounds.miny)  outshp->bounds.miny = dY;
-        if (dY > outshp->bounds.maxy)  outshp->bounds.maxy = dY;
+        if (dX < outshp->bounds.minx)
+          outshp->bounds.minx = dX;
+        if (dX > outshp->bounds.maxx)
+          outshp->bounds.maxx = dX;
+        if (dY < outshp->bounds.miny)
+          outshp->bounds.miny = dY;
+        if (dY > outshp->bounds.maxy)
+          outshp->bounds.maxy = dY;
       }
-
     }
     line.numpoints = numpoints;
 
-    if (bCloseRings &&
-        ( line.point[line.numpoints-1].x != line.point[0].x ||
-          line.point[line.numpoints-1].y != line.point[0].y  ) ) {
+    if (bCloseRings && (line.point[line.numpoints - 1].x != line.point[0].x ||
+                        line.point[line.numpoints - 1].y != line.point[0].y)) {
       line.point[line.numpoints].x = line.point[0].x;
       line.point[line.numpoints].y = line.point[0].y;
       line.point[line.numpoints].z = line.point[0].z;
@@ -335,14 +329,12 @@ static int ogrGeomLine(OGRGeometryH hGeo
 
     msAddLineDirectly(outshp, &line);
   } else {
-    msSetError(MS_OGRERR,
-               "OGRGeometry type `%s' not supported.",
-               "ogrGeomLine()",
-               OGR_G_GetGeometryName( hGeom ) );
-    return(-1);
+    msSetError(MS_OGRERR, "OGRGeometry type `%s' not supported.",
+               "ogrGeomLine()", OGR_G_GetGeometryName(hGeom));
+    return (-1);
   }
 
-  return(0);
+  return (0);
 }
 
 /**********************************************************************
@@ -351,19 +343,18 @@ static int ogrGeomLine(OGRGeometryH hGeo
  * Fetch geometry from OGR feature. If using GDAL 2.0 or later, the geometry
  * might be of curve type, so linearize it.
  **********************************************************************/
-static OGRGeometryH ogrGetLinearGeometry(OGRFeatureH hFeature)
-{
+static OGRGeometryH ogrGetLinearGeometry(OGRFeatureH hFeature) {
 #if GDAL_VERSION_MAJOR >= 2
-    /* Convert in place and reassign to the feature */
-    OGRGeometryH hGeom = OGR_F_StealGeometry(hFeature);
-    if( hGeom != NULL )
-    {
-        hGeom = OGR_G_ForceTo(hGeom, OGR_GT_GetLinear(OGR_G_GetGeometryType(hGeom)), NULL);
-        OGR_F_SetGeometryDirectly(hFeature, hGeom);
-    }
-    return hGeom;
+  /* Convert in place and reassign to the feature */
+  OGRGeometryH hGeom = OGR_F_StealGeometry(hFeature);
+  if (hGeom != NULL) {
+    hGeom = OGR_G_ForceTo(hGeom, OGR_GT_GetLinear(OGR_G_GetGeometryType(hGeom)),
+                          NULL);
+    OGR_F_SetGeometryDirectly(hFeature, hGeom);
+  }
+  return hGeom;
 #else
-    return OGR_F_GetGeometryRef( hFeature );
+  return OGR_F_GetGeometryRef(hFeature);
 #endif
 }
 
@@ -377,8 +368,7 @@ static OGRGeometryH ogrGetLinearGeometry
  * shape->type = MS_SHAPE_NULL
  **********************************************************************/
 static int ogrConvertGeometry(OGRGeometryH hGeom, shapeObj *outshp,
-                              enum MS_LAYER_TYPE layertype)
-{
+                              enum MS_LAYER_TYPE layertype) {
   /* ------------------------------------------------------------------
    * Process geometry according to layer type
    * ------------------------------------------------------------------ */
@@ -389,62 +379,62 @@ static int ogrConvertGeometry(OGRGeometr
     return MS_SUCCESS;
   }
 
-  switch(layertype) {
-      /* ------------------------------------------------------------------
-       *      POINT layer - Any geometry can be converted to point/multipoint
-       * ------------------------------------------------------------------ */
-    case MS_LAYER_POINT:
-      if(ogrGeomPoints(hGeom, outshp) == -1) {
-        nStatus = MS_FAILURE; // Error message already produced.
-      }
-      break;
-      /* ------------------------------------------------------------------
-       *      LINE layer
-       * ------------------------------------------------------------------ */
-    case MS_LAYER_LINE:
-      if(ogrGeomLine(hGeom, outshp, MS_FALSE) == -1) {
+  switch (layertype) {
+    /* ------------------------------------------------------------------
+     *      POINT layer - Any geometry can be converted to point/multipoint
+     * ------------------------------------------------------------------ */
+  case MS_LAYER_POINT:
+    if (ogrGeomPoints(hGeom, outshp) == -1) {
+      nStatus = MS_FAILURE; // Error message already produced.
+    }
+    break;
+    /* ------------------------------------------------------------------
+     *      LINE layer
+     * ------------------------------------------------------------------ */
+  case MS_LAYER_LINE:
+    if (ogrGeomLine(hGeom, outshp, MS_FALSE) == -1) {
+      nStatus = MS_FAILURE; // Error message already produced.
+    }
+    if (outshp->type != MS_SHAPE_LINE && outshp->type != MS_SHAPE_POLYGON)
+      outshp->type = MS_SHAPE_NULL; // Incompatible type for this layer
+    break;
+    /* ------------------------------------------------------------------
+     *      POLYGON layer
+     * ------------------------------------------------------------------ */
+  case MS_LAYER_POLYGON:
+    if (ogrGeomLine(hGeom, outshp, MS_TRUE) == -1) {
+      nStatus = MS_FAILURE; // Error message already produced.
+    }
+    if (outshp->type != MS_SHAPE_POLYGON)
+      outshp->type = MS_SHAPE_NULL; // Incompatible type for this layer
+    break;
+    /* ------------------------------------------------------------------
+     *      Chart or Query layers - return real feature type
+     * ------------------------------------------------------------------ */
+  case MS_LAYER_CHART:
+  case MS_LAYER_QUERY:
+    switch (OGR_G_GetGeometryType(hGeom)) {
+    case wkbPoint:
+    case wkbPoint25D:
+    case wkbMultiPoint:
+    case wkbMultiPoint25D:
+      if (ogrGeomPoints(hGeom, outshp) == -1) {
         nStatus = MS_FAILURE; // Error message already produced.
       }
-      if (outshp->type != MS_SHAPE_LINE && outshp->type != MS_SHAPE_POLYGON)
-        outshp->type = MS_SHAPE_NULL;  // Incompatible type for this layer
       break;
-      /* ------------------------------------------------------------------
-       *      POLYGON layer
-       * ------------------------------------------------------------------ */
-    case MS_LAYER_POLYGON:
-      if(ogrGeomLine(hGeom, outshp, MS_TRUE) == -1) {
+    default:
+      // Handle any non-point types as lines/polygons ... ogrGeomLine()
+      // will decide the shape type
+      if (ogrGeomLine(hGeom, outshp, MS_FALSE) == -1) {
         nStatus = MS_FAILURE; // Error message already produced.
       }
-      if (outshp->type != MS_SHAPE_POLYGON)
-        outshp->type = MS_SHAPE_NULL;  // Incompatible type for this layer
-      break;
-      /* ------------------------------------------------------------------
-       *      Chart or Query layers - return real feature type
-       * ------------------------------------------------------------------ */
-    case MS_LAYER_CHART:
-    case MS_LAYER_QUERY:
-      switch( OGR_G_GetGeometryType( hGeom ) ) {
-        case wkbPoint:
-        case wkbPoint25D:
-        case wkbMultiPoint:
-        case wkbMultiPoint25D:
-          if(ogrGeomPoints(hGeom, outshp) == -1) {
-            nStatus = MS_FAILURE; // Error message already produced.
-          }
-          break;
-        default:
-          // Handle any non-point types as lines/polygons ... ogrGeomLine()
-          // will decide the shape type
-          if(ogrGeomLine(hGeom, outshp, MS_FALSE) == -1) {
-            nStatus = MS_FAILURE; // Error message already produced.
-          }
-      }
-      break;
+    }
+    break;
 
-    default:
-      msSetError(MS_MISCERR, "Unknown or unsupported layer type.",
-                 "msOGRLayerNextShape()");
-      nStatus = MS_FAILURE;
+  default:
+    msSetError(MS_MISCERR, "Unknown or unsupported layer type.",
+               "msOGRLayerNextShape()");
+    nStatus = MS_FAILURE;
   } /* switch layertype */
 
   return nStatus;
@@ -457,22 +447,20 @@ static int ogrConvertGeometry(OGRGeometr
  * object.
  **********************************************************************/
 int msOGRGeometryToShape(OGRGeometryH hGeometry, shapeObj *psShape,
-                         OGRwkbGeometryType nType)
-{
+                         OGRwkbGeometryType nType) {
   if (hGeometry && psShape && nType > 0) {
-    if (nType == wkbPoint || nType == wkbMultiPoint )
-      return ogrConvertGeometry(hGeometry, psShape,  MS_LAYER_POINT);
+    if (nType == wkbPoint || nType == wkbMultiPoint)
+      return ogrConvertGeometry(hGeometry, psShape, MS_LAYER_POINT);
     else if (nType == wkbLineString || nType == wkbMultiLineString)
-      return ogrConvertGeometry(hGeometry, psShape,  MS_LAYER_LINE);
+      return ogrConvertGeometry(hGeometry, psShape, MS_LAYER_LINE);
     else if (nType == wkbPolygon || nType == wkbMultiPolygon)
-      return ogrConvertGeometry(hGeometry, psShape,  MS_LAYER_POLYGON);
+      return ogrConvertGeometry(hGeometry, psShape, MS_LAYER_POLYGON);
     else
       return MS_FAILURE;
   } else
     return MS_FAILURE;
 }
 
-
 /* ==================================================================
  * Attributes handling functions
  * ================================================================== */
@@ -480,64 +468,64 @@ int msOGRGeometryToShape(OGRGeometryH hG
 // Special field index codes for handling text string and angle coming from
 // OGR style strings.
 
-#define MSOGR_FID_INDEX            -99
+#define MSOGR_FID_INDEX -99
 
-#define MSOGR_LABELNUMITEMS        21
-#define MSOGR_LABELFONTNAMENAME    "OGR:LabelFont"
-#define MSOGR_LABELFONTNAMEINDEX   -100
-#define MSOGR_LABELSIZENAME        "OGR:LabelSize"
-#define MSOGR_LABELSIZEINDEX       -101
-#define MSOGR_LABELTEXTNAME        "OGR:LabelText"
-#define MSOGR_LABELTEXTINDEX       -102
-#define MSOGR_LABELANGLENAME       "OGR:LabelAngle"
-#define MSOGR_LABELANGLEINDEX      -103
-#define MSOGR_LABELFCOLORNAME      "OGR:LabelFColor"
-#define MSOGR_LABELFCOLORINDEX     -104
-#define MSOGR_LABELBCOLORNAME      "OGR:LabelBColor"
-#define MSOGR_LABELBCOLORINDEX     -105
-#define MSOGR_LABELPLACEMENTNAME   "OGR:LabelPlacement"
-#define MSOGR_LABELPLACEMENTINDEX  -106
-#define MSOGR_LABELANCHORNAME      "OGR:LabelAnchor"
-#define MSOGR_LABELANCHORINDEX     -107
-#define MSOGR_LABELDXNAME          "OGR:LabelDx"
-#define MSOGR_LABELDXINDEX         -108
-#define MSOGR_LABELDYNAME          "OGR:LabelDy"
-#define MSOGR_LABELDYINDEX         -109
-#define MSOGR_LABELPERPNAME        "OGR:LabelPerp"
-#define MSOGR_LABELPERPINDEX       -110
-#define MSOGR_LABELBOLDNAME        "OGR:LabelBold"
-#define MSOGR_LABELBOLDINDEX       -111
-#define MSOGR_LABELITALICNAME      "OGR:LabelItalic"
-#define MSOGR_LABELITALICINDEX     -112
-#define MSOGR_LABELUNDERLINENAME   "OGR:LabelUnderline"
-#define MSOGR_LABELUNDERLINEINDEX  -113
-#define MSOGR_LABELPRIORITYNAME    "OGR:LabelPriority"
-#define MSOGR_LABELPRIORITYINDEX   -114
-#define MSOGR_LABELSTRIKEOUTNAME   "OGR:LabelStrikeout"
-#define MSOGR_LABELSTRIKEOUTINDEX  -115
-#define MSOGR_LABELSTRETCHNAME     "OGR:LabelStretch"
-#define MSOGR_LABELSTRETCHINDEX    -116
-#define MSOGR_LABELADJHORNAME      "OGR:LabelAdjHor"
-#define MSOGR_LABELADJHORINDEX     -117
-#define MSOGR_LABELADJVERTNAME     "OGR:LabelAdjVert"
-#define MSOGR_LABELADJVERTINDEX    -118
-#define MSOGR_LABELHCOLORNAME      "OGR:LabelHColor"
-#define MSOGR_LABELHCOLORINDEX     -119
-#define MSOGR_LABELOCOLORNAME      "OGR:LabelOColor"
-#define MSOGR_LABELOCOLORINDEX     -120
+#define MSOGR_LABELNUMITEMS 21
+#define MSOGR_LABELFONTNAMENAME "OGR:LabelFont"
+#define MSOGR_LABELFONTNAMEINDEX -100
+#define MSOGR_LABELSIZENAME "OGR:LabelSize"
+#define MSOGR_LABELSIZEINDEX -101
+#define MSOGR_LABELTEXTNAME "OGR:LabelText"
+#define MSOGR_LABELTEXTINDEX -102
+#define MSOGR_LABELANGLENAME "OGR:LabelAngle"
+#define MSOGR_LABELANGLEINDEX -103
+#define MSOGR_LABELFCOLORNAME "OGR:LabelFColor"
+#define MSOGR_LABELFCOLORINDEX -104
+#define MSOGR_LABELBCOLORNAME "OGR:LabelBColor"
+#define MSOGR_LABELBCOLORINDEX -105
+#define MSOGR_LABELPLACEMENTNAME "OGR:LabelPlacement"
+#define MSOGR_LABELPLACEMENTINDEX -106
+#define MSOGR_LABELANCHORNAME "OGR:LabelAnchor"
+#define MSOGR_LABELANCHORINDEX -107
+#define MSOGR_LABELDXNAME "OGR:LabelDx"
+#define MSOGR_LABELDXINDEX -108
+#define MSOGR_LABELDYNAME "OGR:LabelDy"
+#define MSOGR_LABELDYINDEX -109
+#define MSOGR_LABELPERPNAME "OGR:LabelPerp"
+#define MSOGR_LABELPERPINDEX -110
+#define MSOGR_LABELBOLDNAME "OGR:LabelBold"
+#define MSOGR_LABELBOLDINDEX -111
+#define MSOGR_LABELITALICNAME "OGR:LabelItalic"
+#define MSOGR_LABELITALICINDEX -112
+#define MSOGR_LABELUNDERLINENAME "OGR:LabelUnderline"
+#define MSOGR_LABELUNDERLINEINDEX -113
+#define MSOGR_LABELPRIORITYNAME "OGR:LabelPriority"
+#define MSOGR_LABELPRIORITYINDEX -114
+#define MSOGR_LABELSTRIKEOUTNAME "OGR:LabelStrikeout"
+#define MSOGR_LABELSTRIKEOUTINDEX -115
+#define MSOGR_LABELSTRETCHNAME "OGR:LabelStretch"
+#define MSOGR_LABELSTRETCHINDEX -116
+#define MSOGR_LABELADJHORNAME "OGR:LabelAdjHor"
+#define MSOGR_LABELADJHORINDEX -117
+#define MSOGR_LABELADJVERTNAME "OGR:LabelAdjVert"
+#define MSOGR_LABELADJVERTINDEX -118
+#define MSOGR_LABELHCOLORNAME "OGR:LabelHColor"
+#define MSOGR_LABELHCOLORINDEX -119
+#define MSOGR_LABELOCOLORNAME "OGR:LabelOColor"
+#define MSOGR_LABELOCOLORINDEX -120
 // Special codes for the OGR style parameters
-#define MSOGR_LABELPARAMNAME       "OGR:LabelParam"
-#define MSOGR_LABELPARAMNAMELEN    14
-#define MSOGR_LABELPARAMINDEX      -500
-#define MSOGR_BRUSHPARAMNAME       "OGR:BrushParam"
-#define MSOGR_BRUSHPARAMNAMELEN    14
-#define MSOGR_BRUSHPARAMINDEX      -600
-#define MSOGR_PENPARAMNAME         "OGR:PenParam"
-#define MSOGR_PENPARAMNAMELEN      12
-#define MSOGR_PENPARAMINDEX        -700
-#define MSOGR_SYMBOLPARAMNAME      "OGR:SymbolParam"
-#define MSOGR_SYMBOLPARAMNAMELEN   15
-#define MSOGR_SYMBOLPARAMINDEX     -800
+#define MSOGR_LABELPARAMNAME "OGR:LabelParam"
+#define MSOGR_LABELPARAMNAMELEN 14
+#define MSOGR_LABELPARAMINDEX -500
+#define MSOGR_BRUSHPARAMNAME "OGR:BrushParam"
+#define MSOGR_BRUSHPARAMNAMELEN 14
+#define MSOGR_BRUSHPARAMINDEX -600
+#define MSOGR_PENPARAMNAME "OGR:PenParam"
+#define MSOGR_PENPARAMNAMELEN 12
+#define MSOGR_PENPARAMINDEX -700
+#define MSOGR_SYMBOLPARAMNAME "OGR:SymbolParam"
+#define MSOGR_SYMBOLPARAMNAMELEN 15
+#define MSOGR_SYMBOLPARAMINDEX -800
 
 /**********************************************************************
  *                     msOGRGetValues()
@@ -550,31 +538,30 @@ int msOGRGeometryToShape(OGRGeometryH hG
  *  "OGR:TextString"  OGRFeatureStyle's text string if present
  *  "OGR:TextAngle"   OGRFeatureStyle's text angle, or 0 if not set
  **********************************************************************/
-static char **msOGRGetValues(layerObj *layer, OGRFeatureH hFeature)
-{
+static char **msOGRGetValues(layerObj *layer, OGRFeatureH hFeature) {
   char **values;
   const char *pszValue = NULL;
   int i;
 
-  if(layer->numitems == 0)
-    return(NULL);
+  if (layer->numitems == 0)
+    return (NULL);
 
-  if(!layer->iteminfo)  // Should not happen... but just in case!
+  if (!layer->iteminfo) // Should not happen... but just in case!
     if (msOGRLayerInitItemInfo(layer) != MS_SUCCESS)
       return NULL;
 
-  if((values = (char **)malloc(sizeof(char *)*layer->numitems)) == NULL) {
+  if ((values = (char **)malloc(sizeof(char *) * layer->numitems)) == NULL) {
     msSetError(MS_MEMERR, NULL, "msOGRGetValues()");
-    return(NULL);
+    return (NULL);
   }
 
-  OGRStyleMgrH  hStyleMgr = NULL;
+  OGRStyleMgrH hStyleMgr = NULL;
   OGRStyleToolH hLabelStyle = NULL;
   OGRStyleToolH hPenStyle = NULL;
   OGRStyleToolH hBrushStyle = NULL;
   OGRStyleToolH hSymbolStyle = NULL;
 
-  int *itemindexes = (int*)layer->iteminfo;
+  int *itemindexes = (int *)layer->iteminfo;
 
   int nYear;
   int nMonth;
@@ -584,75 +571,85 @@ static char **msOGRGetValues(layerObj *l
   int nSecond;
   int nTZFlag;
 
-  for(i=0; i<layer->numitems; i++) {
+  for (i = 0; i < layer->numitems; i++) {
     if (itemindexes[i] >= 0) {
       // Extract regular attributes
-      const char* pszValue = OGR_F_GetFieldAsString(hFeature, itemindexes[i]);
-      if( pszValue[0] == 0 )
-      {
-          values[i] = msStrdup("");
-      }
-      else
-      {
-          OGRFieldDefnH hFieldDefnRef = OGR_F_GetFieldDefnRef(hFeature, itemindexes[i]);
-          switch(OGR_Fld_GetType(hFieldDefnRef)) {
-          case OFTTime:
-              OGR_F_GetFieldAsDateTime(hFeature, itemindexes[i], &nYear, &nMonth, &nDay, &nHour, &nMinute, &nSecond, &nTZFlag);
-              switch(nTZFlag) {
-              case 0: // Unknown time zone
-              case 1: // Local time zone (not specified)
-                values[i] = msStrdup(CPLSPrintf("%02d:%02d:%02d", nHour, nMinute, nSecond));
-                break;
-              case 100: // GMT
-                values[i] = msStrdup(CPLSPrintf("%02d:%02d:%02dZ", nHour, nMinute, nSecond));
-                break;
-              default: // Offset (in quarter-hour units) from GMT
-                const int TZOffset = std::abs(nTZFlag - 100) * 15;
-                const int TZHour = TZOffset / 60;
-                const int TZMinute = TZOffset % 60;
-                const char TZSign = (nTZFlag > 100) ? '+' : '-';
-                values[i] = msStrdup(CPLSPrintf("%02d:%02d:%02d%c%02d:%02d", nHour, nMinute,
-                  nSecond, TZSign, TZHour, TZMinute));
-              }
-              break;
-          case OFTDate:
-              OGR_F_GetFieldAsDateTime(hFeature, itemindexes[i], &nYear, &nMonth, &nDay, &nHour, &nMinute, &nSecond, &nTZFlag);
-              values[i] = msStrdup(CPLSPrintf("%04d-%02d-%02d", nYear, nMonth, nDay));
-              break;
-          case OFTDateTime:
-              OGR_F_GetFieldAsDateTime(hFeature, itemindexes[i], &nYear, &nMonth, &nDay, &nHour, &nMinute, &nSecond, &nTZFlag);
-              switch(nTZFlag) {
-              case 0: // Unknown time zone
-              case 1: // Local time zone (not specified)
-                values[i] = msStrdup(CPLSPrintf("%04d-%02d-%02dT%02d:%02d:%02d", nYear, nMonth, nDay, nHour, nMinute, nSecond));
-                break;
-              case 100: // GMT
-                values[i] = msStrdup(CPLSPrintf("%04d-%02d-%02dT%02d:%02d:%02dZ", nYear, nMonth, nDay, nHour, nMinute, nSecond));
-                break;
-              default: // Offset (in quarter-hour units) from GMT
-                const int TZOffset = std::abs(nTZFlag - 100) * 15;
-                const int TZHour = TZOffset / 60;
-                const int TZMinute = TZOffset % 60;
-                const char TZSign = (nTZFlag > 100) ? '+' : '-';
-                values[i] = msStrdup(CPLSPrintf("%04d-%02d-%02dT%02d:%02d:%02d%c%02d:%02d", nYear, nMonth, nDay, nHour, nMinute, 
-                  nSecond, TZSign, TZHour, TZMinute));
-              }
-              break;
-          default:
-              values[i] = msStrdup(pszValue);
-              break;
+      const char *pszValue = OGR_F_GetFieldAsString(hFeature, itemindexes[i]);
+      if (pszValue[0] == 0) {
+        values[i] = msStrdup("");
+      } else {
+        OGRFieldDefnH hFieldDefnRef =
+            OGR_F_GetFieldDefnRef(hFeature, itemindexes[i]);
+        switch (OGR_Fld_GetType(hFieldDefnRef)) {
+        case OFTTime:
+          OGR_F_GetFieldAsDateTime(hFeature, itemindexes[i], &nYear, &nMonth,
+                                   &nDay, &nHour, &nMinute, &nSecond, &nTZFlag);
+          switch (nTZFlag) {
+          case 0: // Unknown time zone
+          case 1: // Local time zone (not specified)
+            values[i] =
+                msStrdup(CPLSPrintf("%02d:%02d:%02d", nHour, nMinute, nSecond));
+            break;
+          case 100: // GMT
+            values[i] = msStrdup(
+                CPLSPrintf("%02d:%02d:%02dZ", nHour, nMinute, nSecond));
+            break;
+          default: // Offset (in quarter-hour units) from GMT
+            const int TZOffset = std::abs(nTZFlag - 100) * 15;
+            const int TZHour = TZOffset / 60;
+            const int TZMinute = TZOffset % 60;
+            const char TZSign = (nTZFlag > 100) ? '+' : '-';
+            values[i] =
+                msStrdup(CPLSPrintf("%02d:%02d:%02d%c%02d:%02d", nHour, nMinute,
+                                    nSecond, TZSign, TZHour, TZMinute));
           }
+          break;
+        case OFTDate:
+          OGR_F_GetFieldAsDateTime(hFeature, itemindexes[i], &nYear, &nMonth,
+                                   &nDay, &nHour, &nMinute, &nSecond, &nTZFlag);
+          values[i] =
+              msStrdup(CPLSPrintf("%04d-%02d-%02d", nYear, nMonth, nDay));
+          break;
+        case OFTDateTime:
+          OGR_F_GetFieldAsDateTime(hFeature, itemindexes[i], &nYear, &nMonth,
+                                   &nDay, &nHour, &nMinute, &nSecond, &nTZFlag);
+          switch (nTZFlag) {
+          case 0: // Unknown time zone
+          case 1: // Local time zone (not specified)
+            values[i] =
+                msStrdup(CPLSPrintf("%04d-%02d-%02dT%02d:%02d:%02d", nYear,
+                                    nMonth, nDay, nHour, nMinute, nSecond));
+            break;
+          case 100: // GMT
+            values[i] =
+                msStrdup(CPLSPrintf("%04d-%02d-%02dT%02d:%02d:%02dZ", nYear,
+                                    nMonth, nDay, nHour, nMinute, nSecond));
+            break;
+          default: // Offset (in quarter-hour units) from GMT
+            const int TZOffset = std::abs(nTZFlag - 100) * 15;
+            const int TZHour = TZOffset / 60;
+            const int TZMinute = TZOffset % 60;
+            const char TZSign = (nTZFlag > 100) ? '+' : '-';
+            values[i] = msStrdup(CPLSPrintf(
+                "%04d-%02d-%02dT%02d:%02d:%02d%c%02d:%02d", nYear, nMonth, nDay,
+                nHour, nMinute, nSecond, TZSign, TZHour, TZMinute));
+          }
+          break;
+        default:
+          values[i] = msStrdup(pszValue);
+          break;
+        }
       }
-    } else if (itemindexes[i] == MSOGR_FID_INDEX ) {
-      values[i] = msStrdup(CPLSPrintf(CPL_FRMT_GIB,
-                                      (GIntBig) OGR_F_GetFID(hFeature)));
+    } else if (itemindexes[i] == MSOGR_FID_INDEX) {
+      values[i] =
+          msStrdup(CPLSPrintf(CPL_FRMT_GIB, (GIntBig)OGR_F_GetFID(hFeature)));
     } else {
       // Handle special OGR attributes coming from StyleString
       if (!hStyleMgr) {
         hStyleMgr = OGR_SM_Create(NULL);
         OGR_SM_InitFromFeature(hStyleMgr, hFeature);
         int numParts = OGR_SM_GetPartCount(hStyleMgr, NULL);
-        for(int i=0; i<numParts; i++) {
+        for (int i = 0; i < numParts; i++) {
           OGRStyleToolH hStylePart = OGR_SM_GetPart(hStyleMgr, i, NULL);
           if (hStylePart) {
             if (OGR_ST_GetType(hStylePart) == OGRSTCLabel && !hLabelStyle)
@@ -661,25 +658,26 @@ static char **msOGRGetValues(layerObj *l
               hPenStyle = hStylePart;
             else if (OGR_ST_GetType(hStylePart) == OGRSTCBrush && !hBrushStyle)
               hBrushStyle = hStylePart;
-            else if (OGR_ST_GetType(hStylePart) == OGRSTCSymbol && !hSymbolStyle)
+            else if (OGR_ST_GetType(hStylePart) == OGRSTCSymbol &&
+                     !hSymbolStyle)
               hSymbolStyle = hStylePart;
             else {
               OGR_ST_Destroy(hStylePart);
-              hStylePart =  NULL;
+              hStylePart = NULL;
             }
           }
           /* Setting up the size units according to msOGRLayerGetAutoStyle*/
           if (hStylePart && layer->map)
-            OGR_ST_SetUnit(hStylePart, OGRSTUPixel, 
-              layer->map->cellsize*layer->map->resolution/layer->map->defresolution*72.0*39.37);
+            OGR_ST_SetUnit(hStylePart, OGRSTUPixel,
+                           layer->map->cellsize * layer->map->resolution /
+                               layer->map->defresolution * 72.0 * 39.37);
         }
       }
       int bDefault;
       if (itemindexes[i] == MSOGR_LABELTEXTINDEX) {
-        if (hLabelStyle == NULL
-            || ((pszValue = OGR_ST_GetParamStr(hLabelStyle,
-                                               OGRSTLabelTextString,
-                                               &bDefault)) == NULL))
+        if (hLabelStyle == NULL ||
+            ((pszValue = OGR_ST_GetParamStr(hLabelStyle, OGRSTLabelTextString,
+                                            &bDefault)) == NULL))
           values[i] = msStrdup("");
         else
           values[i] = msStrdup(pszValue);
@@ -687,10 +685,9 @@ static char **msOGRGetValues(layerObj *l
         if (layer->debug >= MS_DEBUGLEVEL_VVV)
           msDebug(MSOGR_LABELTEXTNAME " = \"%s\"\n", values[i]);
       } else if (itemindexes[i] == MSOGR_LABELANGLEINDEX) {
-        if (hLabelStyle == NULL
-            || ((pszValue = OGR_ST_GetParamStr(hLabelStyle,
-                                               OGRSTLabelAngle,
-                                               &bDefault)) == NULL))
+        if (hLabelStyle == NULL ||
+            ((pszValue = OGR_ST_GetParamStr(hLabelStyle, OGRSTLabelAngle,
+                                            &bDefault)) == NULL))
           values[i] = msStrdup("0");
         else
           values[i] = msStrdup(pszValue);
@@ -698,10 +695,9 @@ static char **msOGRGetValues(layerObj *l
         if (layer->debug >= MS_DEBUGLEVEL_VVV)
           msDebug(MSOGR_LABELANGLENAME " = \"%s\"\n", values[i]);
       } else if (itemindexes[i] == MSOGR_LABELSIZEINDEX) {
-        if (hLabelStyle == NULL
-            || ((pszValue = OGR_ST_GetParamStr(hLabelStyle,
-                                               OGRSTLabelSize,
-                                               &bDefault)) == NULL))
+        if (hLabelStyle == NULL ||
+            ((pszValue = OGR_ST_GetParamStr(hLabelStyle, OGRSTLabelSize,
+                                            &bDefault)) == NULL))
           values[i] = msStrdup("0");
         else
           values[i] = msStrdup(pszValue);
@@ -709,21 +705,19 @@ static char **msOGRGetValues(layerObj *l
         if (layer->debug >= MS_DEBUGLEVEL_VVV)
           msDebug(MSOGR_LABELSIZENAME " = \"%s\"\n", values[i]);
       } else if (itemindexes[i] == MSOGR_LABELFCOLORINDEX) {
-        if (hLabelStyle == NULL
-            || ((pszValue = OGR_ST_GetParamStr(hLabelStyle,
-                                               OGRSTLabelFColor,
-                                               &bDefault)) == NULL))
+        if (hLabelStyle == NULL ||
+            ((pszValue = OGR_ST_GetParamStr(hLabelStyle, OGRSTLabelFColor,
+                                            &bDefault)) == NULL))
           values[i] = msStrdup("#000000");
         else
           values[i] = msStrdup(pszValue);
 
         if (layer->debug >= MS_DEBUGLEVEL_VVV)
           msDebug(MSOGR_LABELFCOLORNAME " = \"%s\"\n", values[i]);
-      } else if (itemindexes[i] == MSOGR_LABELFONTNAMEINDEX ) {
-        if (hLabelStyle == NULL
-            || ((pszValue = OGR_ST_GetParamStr(hLabelStyle,
-                                               OGRSTLabelFontName,
-                                               &bDefault)) == NULL))
+      } else if (itemindexes[i] == MSOGR_LABELFONTNAMEINDEX) {
+        if (hLabelStyle == NULL ||
+            ((pszValue = OGR_ST_GetParamStr(hLabelStyle, OGRSTLabelFontName,
+                                            &bDefault)) == NULL))
           values[i] = msStrdup("Arial");
         else
           values[i] = msStrdup(pszValue);
@@ -731,10 +725,9 @@ static char **msOGRGetValues(layerObj *l
         if (layer->debug >= MS_DEBUGLEVEL_VVV)
           msDebug(MSOGR_LABELFONTNAMENAME " =       \"%s\"\n", values[i]);
       } else if (itemindexes[i] == MSOGR_LABELBCOLORINDEX) {
-        if (hLabelStyle == NULL
-            || ((pszValue = OGR_ST_GetParamStr(hLabelStyle,
-                                               OGRSTLabelBColor,
-                                               &bDefault)) == NULL))
+        if (hLabelStyle == NULL ||
+            ((pszValue = OGR_ST_GetParamStr(hLabelStyle, OGRSTLabelBColor,
+                                            &bDefault)) == NULL))
           values[i] = msStrdup("#000000");
         else
           values[i] = msStrdup(pszValue);
@@ -742,10 +735,9 @@ static char **msOGRGetValues(layerObj *l
         if (layer->debug >= MS_DEBUGLEVEL_VVV)
           msDebug(MSOGR_LABELBCOLORNAME " = \"%s\"\n", values[i]);
       } else if (itemindexes[i] == MSOGR_LABELPLACEMENTINDEX) {
-        if (hLabelStyle == NULL
-            || ((pszValue = OGR_ST_GetParamStr(hLabelStyle,
-                                               OGRSTLabelPlacement,
-                                               &bDefault)) == NULL))
+        if (hLabelStyle == NULL ||
+            ((pszValue = OGR_ST_GetParamStr(hLabelStyle, OGRSTLabelPlacement,
+                                            &bDefault)) == NULL))
           values[i] = msStrdup("");
         else
           values[i] = msStrdup(pszValue);
@@ -753,10 +745,9 @@ static char **msOGRGetValues(layerObj *l
         if (layer->debug >= MS_DEBUGLEVEL_VVV)
           msDebug(MSOGR_LABELPLACEMENTNAME " = \"%s\"\n", values[i]);
       } else if (itemindexes[i] == MSOGR_LABELANCHORINDEX) {
-        if (hLabelStyle == NULL
-            || ((pszValue = OGR_ST_GetParamStr(hLabelStyle,
-                                               OGRSTLabelAnchor,
-                                               &bDefault)) == NULL))
+        if (hLabelStyle == NULL ||
+            ((pszValue = OGR_ST_GetParamStr(hLabelStyle, OGRSTLabelAnchor,
+                                            &bDefault)) == NULL))
           values[i] = msStrdup("0");
         else
           values[i] = msStrdup(pszValue);
@@ -764,10 +755,9 @@ static char **msOGRGetValues(layerObj *l
         if (layer->debug >= MS_DEBUGLEVEL_VVV)
           msDebug(MSOGR_LABELANCHORNAME " = \"%s\"\n", values[i]);
       } else if (itemindexes[i] == MSOGR_LABELDXINDEX) {
-        if (hLabelStyle == NULL
-            || ((pszValue = OGR_ST_GetParamStr(hLabelStyle,
-                                               OGRSTLabelDx,
-                                               &bDefault)) == NULL))
+        if (hLabelStyle == NULL ||
+            ((pszValue = OGR_ST_GetParamStr(hLabelStyle, OGRSTLabelDx,
+                                            &bDefault)) == NULL))
           values[i] = msStrdup("0");
         else
           values[i] = msStrdup(pszValue);
@@ -775,10 +765,9 @@ static char **msOGRGetValues(layerObj *l
         if (layer->debug >= MS_DEBUGLEVEL_VVV)
           msDebug(MSOGR_LABELDXNAME " = \"%s\"\n", values[i]);
       } else if (itemindexes[i] == MSOGR_LABELDYINDEX) {
-        if (hLabelStyle == NULL
-            || ((pszValue = OGR_ST_GetParamStr(hLabelStyle,
-                                               OGRSTLabelDy,
-                                               &bDefault)) == NULL))
+        if (hLabelStyle == NULL ||
+            ((pszValue = OGR_ST_GetParamStr(hLabelStyle, OGRSTLabelDy,
+                                            &bDefault)) == NULL))
           values[i] = msStrdup("0");
         else
           values[i] = msStrdup(pszValue);
@@ -786,10 +775,9 @@ static char **msOGRGetValues(layerObj *l
         if (layer->debug >= MS_DEBUGLEVEL_VVV)
           msDebug(MSOGR_LABELDYNAME " = \"%s\"\n", values[i]);
       } else if (itemindexes[i] == MSOGR_LABELPERPINDEX) {
-        if (hLabelStyle == NULL
-            || ((pszValue = OGR_ST_GetParamStr(hLabelStyle,
-                                               OGRSTLabelPerp,
-                                               &bDefault)) == NULL))
+        if (hLabelStyle == NULL ||
+            ((pszValue = OGR_ST_GetParamStr(hLabelStyle, OGRSTLabelPerp,
+                                            &bDefault)) == NULL))
           values[i] = msStrdup("0");
         else
           values[i] = msStrdup(pszValue);
@@ -797,10 +785,9 @@ static char **msOGRGetValues(layerObj *l
         if (layer->debug >= MS_DEBUGLEVEL_VVV)
           msDebug(MSOGR_LABELPERPNAME " = \"%s\"\n", values[i]);
       } else if (itemindexes[i] == MSOGR_LABELBOLDINDEX) {
-        if (hLabelStyle == NULL
-            || ((pszValue = OGR_ST_GetParamStr(hLabelStyle,
-                                               OGRSTLabelBold,
-                                               &bDefault)) == NULL))
+        if (hLabelStyle == NULL ||
+            ((pszValue = OGR_ST_GetParamStr(hLabelStyle, OGRSTLabelBold,
+                                            &bDefault)) == NULL))
           values[i] = msStrdup("0");
         else
           values[i] = msStrdup(pszValue);
@@ -808,10 +795,9 @@ static char **msOGRGetValues(layerObj *l
         if (layer->debug >= MS_DEBUGLEVEL_VVV)
           msDebug(MSOGR_LABELBOLDNAME " = \"%s\"\n", values[i]);
       } else if (itemindexes[i] == MSOGR_LABELITALICINDEX) {
-        if (hLabelStyle == NULL
-            || ((pszValue = OGR_ST_GetParamStr(hLabelStyle,
-                                               OGRSTLabelItalic,
-                                               &bDefault)) == NULL))
+        if (hLabelStyle == NULL ||
+            ((pszValue = OGR_ST_GetParamStr(hLabelStyle, OGRSTLabelItalic,
+                                            &bDefault)) == NULL))
           values[i] = msStrdup("0");
         else
           values[i] = msStrdup(pszValue);
@@ -819,10 +805,9 @@ static char **msOGRGetValues(layerObj *l
         if (layer->debug >= MS_DEBUGLEVEL_VVV)
           msDebug(MSOGR_LABELITALICNAME " = \"%s\"\n", values[i]);
       } else if (itemindexes[i] == MSOGR_LABELUNDERLINEINDEX) {
-        if (hLabelStyle == NULL
-            || ((pszValue = OGR_ST_GetParamStr(hLabelStyle,
-                                               OGRSTLabelUnderline,
-                                               &bDefault)) == NULL))
+        if (hLabelStyle == NULL ||
+            ((pszValue = OGR_ST_GetParamStr(hLabelStyle, OGRSTLabelUnderline,
+                                            &bDefault)) == NULL))
           values[i] = msStrdup("0");
         else
           values[i] = msStrdup(pszValue);
@@ -830,10 +815,9 @@ static char **msOGRGetValues(layerObj *l
         if (layer->debug >= MS_DEBUGLEVEL_VVV)
           msDebug(MSOGR_LABELUNDERLINENAME " = \"%s\"\n", values[i]);
       } else if (itemindexes[i] == MSOGR_LABELPRIORITYINDEX) {
-        if (hLabelStyle == NULL
-            || ((pszValue = OGR_ST_GetParamStr(hLabelStyle,
-                                               OGRSTLabelPriority,
-                                               &bDefault)) == NULL))
+        if (hLabelStyle == NULL ||
+            ((pszValue = OGR_ST_GetParamStr(hLabelStyle, OGRSTLabelPriority,
+                                            &bDefault)) == NULL))
           values[i] = msStrdup("0");
         else
           values[i] = msStrdup(pszValue);
@@ -841,10 +825,9 @@ static char **msOGRGetValues(layerObj *l
         if (layer->debug >= MS_DEBUGLEVEL_VVV)
           msDebug(MSOGR_LABELPRIORITYNAME " = \"%s\"\n", values[i]);
       } else if (itemindexes[i] == MSOGR_LABELSTRIKEOUTINDEX) {
-        if (hLabelStyle == NULL
-            || ((pszValue = OGR_ST_GetParamStr(hLabelStyle,
-                                               OGRSTLabelStrikeout,
-                                               &bDefault)) == NULL))
+        if (hLabelStyle == NULL ||
+            ((pszValue = OGR_ST_GetParamStr(hLabelStyle, OGRSTLabelStrikeout,
+                                            &bDefault)) == NULL))
           values[i] = msStrdup("0");
         else
           values[i] = msStrdup(pszValue);
@@ -852,10 +835,9 @@ static char **msOGRGetValues(layerObj *l
         if (layer->debug >= MS_DEBUGLEVEL_VVV)
           msDebug(MSOGR_LABELSTRIKEOUTNAME " = \"%s\"\n", values[i]);
       } else if (itemindexes[i] == MSOGR_LABELSTRETCHINDEX) {
-        if (hLabelStyle == NULL
-            || ((pszValue = OGR_ST_GetParamStr(hLabelStyle,
-                                               OGRSTLabelStretch,
-                                               &bDefault)) == NULL))
+        if (hLabelStyle == NULL ||
+            ((pszValue = OGR_ST_GetParamStr(hLabelStyle, OGRSTLabelStretch,
+                                            &bDefault)) == NULL))
           values[i] = msStrdup("0");
         else
           values[i] = msStrdup(pszValue);
@@ -863,10 +845,9 @@ static char **msOGRGetValues(layerObj *l
         if (layer->debug >= MS_DEBUGLEVEL_VVV)
           msDebug(MSOGR_LABELSTRETCHNAME " = \"%s\"\n", values[i]);
       } else if (itemindexes[i] == MSOGR_LABELADJHORINDEX) {
-        if (hLabelStyle == NULL
-            || ((pszValue = OGR_ST_GetParamStr(hLabelStyle,
-                                               OGRSTLabelAdjHor,
-                                               &bDefault)) == NULL))
+        if (hLabelStyle == NULL ||
+            ((pszValue = OGR_ST_GetParamStr(hLabelStyle, OGRSTLabelAdjHor,
+                                            &bDefault)) == NULL))
           values[i] = msStrdup("");
         else
           values[i] = msStrdup(pszValue);
@@ -874,10 +855,9 @@ static char **msOGRGetValues(layerObj *l
         if (layer->debug >= MS_DEBUGLEVEL_VVV)
           msDebug(MSOGR_LABELADJHORNAME " = \"%s\"\n", values[i]);
       } else if (itemindexes[i] == MSOGR_LABELADJVERTINDEX) {
-        if (hLabelStyle == NULL
-            || ((pszValue = OGR_ST_GetParamStr(hLabelStyle,
-                                               OGRSTLabelAdjVert,
-                                               &bDefault)) == NULL))
+        if (hLabelStyle == NULL ||
+            ((pszValue = OGR_ST_GetParamStr(hLabelStyle, OGRSTLabelAdjVert,
+                                            &bDefault)) == NULL))
           values[i] = msStrdup("");
         else
           values[i] = msStrdup(pszValue);
@@ -885,79 +865,71 @@ static char **msOGRGetValues(layerObj *l
         if (layer->debug >= MS_DEBUGLEVEL_VVV)
           msDebug(MSOGR_LABELADJVERTNAME " = \"%s\"\n", values[i]);
       } else if (itemindexes[i] == MSOGR_LABELHCOLORINDEX) {
-        if (hLabelStyle == NULL
-            || ((pszValue = OGR_ST_GetParamStr(hLabelStyle,
-                                               OGRSTLabelHColor,
-                                               &bDefault)) == NULL))
+        if (hLabelStyle == NULL ||
+            ((pszValue = OGR_ST_GetParamStr(hLabelStyle, OGRSTLabelHColor,
+                                            &bDefault)) == NULL))
           values[i] = msStrdup("");
         else
           values[i] = msStrdup(pszValue);
 
         if (layer->debug >= MS_DEBUGLEVEL_VVV)
           msDebug(MSOGR_LABELHCOLORNAME " = \"%s\"\n", values[i]);
-      }
-      else if (itemindexes[i] == MSOGR_LABELOCOLORINDEX) {
-        if (hLabelStyle == NULL
-            || ((pszValue = OGR_ST_GetParamStr(hLabelStyle,
-                                               OGRSTLabelOColor,
-                                               &bDefault)) == NULL))
+      } else if (itemindexes[i] == MSOGR_LABELOCOLORINDEX) {
+        if (hLabelStyle == NULL ||
+            ((pszValue = OGR_ST_GetParamStr(hLabelStyle, OGRSTLabelOColor,
+                                            &bDefault)) == NULL))
           values[i] = msStrdup("");
         else
           values[i] = msStrdup(pszValue);
 
         if (layer->debug >= MS_DEBUGLEVEL_VVV)
           msDebug(MSOGR_LABELOCOLORNAME " = \"%s\"\n", values[i]);
-      }
-      else if (itemindexes[i] >= MSOGR_LABELPARAMINDEX) {
-        if (hLabelStyle == NULL
-            || ((pszValue = OGR_ST_GetParamStr(hLabelStyle,
-                                               itemindexes[i] - MSOGR_LABELPARAMINDEX,
-                                               &bDefault)) == NULL))
+      } else if (itemindexes[i] >= MSOGR_LABELPARAMINDEX) {
+        if (hLabelStyle == NULL ||
+            ((pszValue = OGR_ST_GetParamStr(
+                  hLabelStyle, itemindexes[i] - MSOGR_LABELPARAMINDEX,
+                  &bDefault)) == NULL))
           values[i] = msStrdup("");
         else
           values[i] = msStrdup(pszValue);
 
         if (layer->debug >= MS_DEBUGLEVEL_VVV)
           msDebug(MSOGR_LABELPARAMNAME " = \"%s\"\n", values[i]);
-      }
-      else if (itemindexes[i] >= MSOGR_BRUSHPARAMINDEX) {
-        if (hBrushStyle == NULL
-            || ((pszValue = OGR_ST_GetParamStr(hBrushStyle,
-                                               itemindexes[i] - MSOGR_BRUSHPARAMINDEX,
-                                               &bDefault)) == NULL))
+      } else if (itemindexes[i] >= MSOGR_BRUSHPARAMINDEX) {
+        if (hBrushStyle == NULL ||
+            ((pszValue = OGR_ST_GetParamStr(
+                  hBrushStyle, itemindexes[i] - MSOGR_BRUSHPARAMINDEX,
+                  &bDefault)) == NULL))
           values[i] = msStrdup("");
         else
           values[i] = msStrdup(pszValue);
 
         if (layer->debug >= MS_DEBUGLEVEL_VVV)
           msDebug(MSOGR_BRUSHPARAMNAME " = \"%s\"\n", values[i]);
-      }
-      else if (itemindexes[i] >= MSOGR_PENPARAMINDEX) {
-        if (hPenStyle == NULL
-            || ((pszValue = OGR_ST_GetParamStr(hPenStyle,
-                                               itemindexes[i] - MSOGR_PENPARAMINDEX,
-                                               &bDefault)) == NULL))
+      } else if (itemindexes[i] >= MSOGR_PENPARAMINDEX) {
+        if (hPenStyle == NULL ||
+            ((pszValue = OGR_ST_GetParamStr(
+                  hPenStyle, itemindexes[i] - MSOGR_PENPARAMINDEX,
+                  &bDefault)) == NULL))
           values[i] = msStrdup("");
         else
           values[i] = msStrdup(pszValue);
 
         if (layer->debug >= MS_DEBUGLEVEL_VVV)
           msDebug(MSOGR_PENPARAMNAME " = \"%s\"\n", values[i]);
-      }
-      else if (itemindexes[i] >= MSOGR_SYMBOLPARAMINDEX) {
-        if (hSymbolStyle == NULL
-            || ((pszValue = OGR_ST_GetParamStr(hSymbolStyle,
-                                               itemindexes[i] - MSOGR_SYMBOLPARAMINDEX,
-                                               &bDefault)) == NULL))
+      } else if (itemindexes[i] >= MSOGR_SYMBOLPARAMINDEX) {
+        if (hSymbolStyle == NULL ||
+            ((pszValue = OGR_ST_GetParamStr(
+                  hSymbolStyle, itemindexes[i] - MSOGR_SYMBOLPARAMINDEX,
+                  &bDefault)) == NULL))
           values[i] = msStrdup("");
         else
           values[i] = msStrdup(pszValue);
 
         if (layer->debug >= MS_DEBUGLEVEL_VVV)
           msDebug(MSOGR_SYMBOLPARAMNAME " = \"%s\"\n", values[i]);
-      }
-      else {
-        msFreeCharArray(values,i);
+      } else {
+        msFreeCharArray(values, i);
 
         OGR_SM_Destroy(hStyleMgr);
         OGR_ST_Destroy(hLabelStyle);
@@ -965,8 +937,8 @@ static char **msOGRGetValues(layerObj *l
         OGR_ST_Destroy(hBrushStyle);
         OGR_ST_Destroy(hSymbolStyle);
 
-        msSetError(MS_OGRERR,"Invalid field index!?!","msOGRGetValues()");
-        return(NULL);
+        msSetError(MS_OGRERR, "Invalid field index!?!", "msOGRGetValues()");
+        return (NULL);
       }
     }
   }
@@ -977,7 +949,7 @@ static char **msOGRGetValues(layerObj *l
   OGR_ST_Destroy(hBrushStyle);
   OGR_ST_Destroy(hSymbolStyle);
 
-  return(values);
+  return (values);
 }
 
 /**********************************************************************
@@ -989,12 +961,11 @@ static char **msOGRGetValues(layerObj *l
  * Returns MS_SUCCESS/MS_FAILURE
  **********************************************************************/
 static int msOGRSpatialRef2ProjectionObj(OGRSpatialReferenceH hSRS,
-    projectionObj *proj, int debug_flag )
-{
+                                         projectionObj *proj, int debug_flag) {
   // First flush the "auto" name from the projargs[]...
-  msFreeProjectionExceptContext( proj );
+  msFreeProjectionExceptContext(proj);
 
-  if (hSRS == NULL || OSRIsLocal( hSRS ) ) {
+  if (hSRS == NULL || OSRIsLocal(hSRS)) {
     // Dataset had no set projection or is NonEarth (LOCAL_CS)...
     // Nothing else to do. Leave proj empty and no reprojection will happen!
     return MS_SUCCESS;
@@ -1003,19 +974,18 @@ static int msOGRSpatialRef2ProjectionObj
 #if PROJ_VERSION_MAJOR >= 6
   // This could be done also in the < 6 case, but would be useless.
   // Here this helps avoiding going through potentially lossy PROJ4 strings
-  const char* pszAuthName = OSRGetAuthorityName(hSRS, NULL);
-  if( pszAuthName && EQUAL(pszAuthName, "EPSG") )
-  {
-    const char* pszAuthCode = OSRGetAuthorityCode(hSRS, NULL);
-    if( pszAuthCode )
-    {
-        char szInitStr[32];
-        sprintf(szInitStr, "init=epsg:%d", atoi(pszAuthCode));
+  const char *pszAuthName = OSRGetAuthorityName(hSRS, NULL);
+  if (pszAuthName && EQUAL(pszAuthName, "EPSG")) {
+    const char *pszAuthCode = OSRGetAuthorityCode(hSRS, NULL);
+    if (pszAuthCode) {
+      char szInitStr[32];
+      sprintf(szInitStr, "init=epsg:%d", atoi(pszAuthCode));
 
-        if( debug_flag )
-            msDebug( "AUTO = %s\n", szInitStr );
+      if (debug_flag)
+        msDebug("AUTO = %s\n", szInitStr);
 
-        return msLoadProjectionString(proj, szInitStr) == 0 ? MS_SUCCESS : MS_FAILURE;
+      return msLoadProjectionString(proj, szInitStr) == 0 ? MS_SUCCESS
+                                                          : MS_FAILURE;
     }
   }
 #endif
@@ -1023,18 +993,18 @@ static int msOGRSpatialRef2ProjectionObj
   // Export OGR SRS to a PROJ4 string
   char *pszProj = NULL;
 
-  if (OSRExportToProj4( hSRS, &pszProj ) != OGRERR_NONE ||
-      pszProj == NULL || strlen(pszProj) == 0) {
+  if (OSRExportToProj4(hSRS, &pszProj) != OGRERR_NONE || pszProj == NULL ||
+      strlen(pszProj) == 0) {
     msSetError(MS_OGRERR, "Conversion from OGR SRS to PROJ4 failed.",
                "msOGRSpatialRef2ProjectionObj()");
     CPLFree(pszProj);
-    return(MS_FAILURE);
+    return (MS_FAILURE);
   }
 
-  if( debug_flag )
-    msDebug( "AUTO = %s\n", pszProj );
+  if (debug_flag)
+    msDebug("AUTO = %s\n", pszProj);
 
-  if( msLoadProjectionString( proj, pszProj ) != 0 )
+  if (msLoadProjectionString(proj, pszProj) != 0)
     return MS_FAILURE;
 
   CPLFree(pszProj);
@@ -1051,37 +1021,33 @@ static int msOGRSpatialRef2ProjectionObj
  * Returns MS_SUCCESS/MS_FAILURE
  **********************************************************************/
 
-int msOGCWKT2ProjectionObj( const char *pszWKT,
-                            projectionObj *proj,
-                            int debug_flag )
+int msOGCWKT2ProjectionObj(const char *pszWKT, projectionObj *proj,
+                           int debug_flag)
 
 {
-  OGRSpatialReferenceH        hSRS;
-  char      *pszAltWKT = (char *) pszWKT;
-  OGRErr  eErr;
-  int     ms_result;
-
-  hSRS = OSRNewSpatialReference( NULL );
-
-  if( !EQUALN(pszWKT,"GEOGCS",6)
-      && !EQUALN(pszWKT,"PROJCS",6)
-      && !EQUALN(pszWKT,"LOCAL_CS",8) )
-    eErr = OSRSetFromUserInput( hSRS, pszWKT );
+  OGRSpatialReferenceH hSRS;
+  char *pszAltWKT = (char *)pszWKT;
+  OGRErr eErr;
+  int ms_result;
+
+  hSRS = OSRNewSpatialReference(NULL);
+
+  if (!EQUALN(pszWKT, "GEOGCS", 6) && !EQUALN(pszWKT, "PROJCS", 6) &&
+      !EQUALN(pszWKT, "LOCAL_CS", 8))
+    eErr = OSRSetFromUserInput(hSRS, pszWKT);
   else
-    eErr = OSRImportFromWkt( hSRS, &pszAltWKT );
+    eErr = OSRImportFromWkt(hSRS, &pszAltWKT);
 
-  if( eErr != OGRERR_NONE ) {
-    OSRDestroySpatialReference( hSRS );
-    msSetError(MS_OGRERR,
-               "Ingestion of WKT string '%s' failed.",
-               "msOGCWKT2ProjectionObj()",
-               pszWKT );
+  if (eErr != OGRERR_NONE) {
+    OSRDestroySpatialReference(hSRS);
+    msSetError(MS_OGRERR, "Ingestion of WKT string '%s' failed.",
+               "msOGCWKT2ProjectionObj()", pszWKT);
     return MS_FAILURE;
   }
 
-  ms_result = msOGRSpatialRef2ProjectionObj( hSRS, proj, debug_flag );
+  ms_result = msOGRSpatialRef2ProjectionObj(hSRS, proj, debug_flag);
 
-  OSRDestroySpatialReference( hSRS );
+  OSRDestroySpatialReference(hSRS);
   return ms_result;
 }
 
@@ -1103,14 +1069,15 @@ void msOGRInitialize(void)
     ACQUIRE_OGR_LOCK;
 
     OGRRegisterAll();
-    CPLPushErrorHandler( CPLQuietErrorHandler );
+    CPLPushErrorHandler(CPLQuietErrorHandler);
 
     /* ------------------------------------------------------------------
      * Pass config option GML_FIELDTYPES=ALWAYS_STRING to OGR so that all
-     * GML attributes are returned as strings to MapServer. This is most efficient
-     * and prevents problems with autodetection of some attribute types.
+     * GML attributes are returned as strings to MapServer. This is most
+     * efficient and prevents problems with autodetection of some attribute
+     * types.
      * ------------------------------------------------------------------ */
-    CPLSetConfigOption("GML_FIELDTYPES","ALWAYS_STRING");
+    CPLSetConfigOption("GML_FIELDTYPES", "ALWAYS_STRING");
 
     bOGRDriversRegistered = MS_TRUE;
 
@@ -1124,9 +1091,8 @@ void msOGRInitialize(void)
  * layer access.
  * ================================================================== */
 
-static void msOGRFileOpenSpatialite( layerObj *layer, 
-                                     const char *pszLayerDef,
-                                     msOGRFileInfo *psInfo );
+static void msOGRFileOpenSpatialite(layerObj *layer, const char *pszLayerDef,
+                                    msOGRFileInfo *psInfo);
 
 /**********************************************************************
  *                     msOGRFileOpen()
@@ -1134,8 +1100,7 @@ static void msOGRFileOpenSpatialite( lay
  * Open an OGR connection, and initialize a msOGRFileInfo.
  **********************************************************************/
 
-static msOGRFileInfo *
-msOGRFileOpen(layerObj *layer, const char *connection )
+static msOGRFileInfo *msOGRFileOpen(layerObj *layer, const char *connection)
 
 {
   char *conn_decrypted = NULL;
@@ -1148,7 +1113,7 @@ msOGRFileOpen(layerObj *layer, const cha
   if (connection) {
     conn_decrypted = msDecryptStringTokens(layer->map, connection);
     if (conn_decrypted == NULL)
-      return NULL;  /* An error should already have been reported */
+      return NULL; /* An error should already have been reported */
   }
 
   /* ------------------------------------------------------------------
@@ -1156,20 +1121,20 @@ msOGRFileOpen(layerObj *layer, const cha
    * ------------------------------------------------------------------ */
   char *pszDSName = NULL, *pszLayerDef = NULL;
 
-  if( conn_decrypted == NULL ) {
+  if (conn_decrypted == NULL) {
     /* we don't have anything */
-  } else if( layer->data != NULL ) {
+  } else if (layer->data != NULL) {
     pszDSName = CPLStrdup(conn_decrypted);
     pszLayerDef = CPLStrdup(layer->data);
   } else {
     char **papszTokens = NULL;
 
-    papszTokens = CSLTokenizeStringComplex( conn_decrypted, ",", TRUE, FALSE );
+    papszTokens = CSLTokenizeStringComplex(conn_decrypted, ",", TRUE, FALSE);
 
-    if( CSLCount(papszTokens) > 0 )
-      pszDSName = CPLStrdup( papszTokens[0] );
-    if( CSLCount(papszTokens) > 1 )
-      pszLayerDef = CPLStrdup( papszTokens[1] );
+    if (CSLCount(papszTokens) > 0)
+      pszDSName = CPLStrdup(papszTokens[0]);
+    if (CSLCount(papszTokens) > 1)
+      pszLayerDef = CPLStrdup(papszTokens[1]);
 
     CSLDestroy(papszTokens);
   }
@@ -1180,15 +1145,14 @@ msOGRFileOpen(layerObj *layer, const cha
   msFree(conn_decrypted);
   conn_decrypted = NULL;
 
-  if( pszDSName == NULL ) {
+  if (pszDSName == NULL) {
     msSetError(MS_OGRERR,
                "Error parsing OGR connection information in layer `%s'",
-               "msOGRFileOpen()",
-               layer->name?layer->name:"(null)" );
+               "msOGRFileOpen()", layer->name ? layer->name : "(null)");
     return NULL;
   }
 
-  if( pszLayerDef == NULL )
+  if (pszLayerDef == NULL)
     pszLayerDef = CPLStrdup("0");
 
   /* -------------------------------------------------------------------- */
@@ -1196,123 +1160,119 @@ msOGRFileOpen(layerObj *layer, const cha
   /* -------------------------------------------------------------------- */
   OGRDataSourceH hDS;
 
-  hDS = (OGRDataSourceH) msConnPoolRequest( layer );
+  hDS = (OGRDataSourceH)msConnPoolRequest(layer);
 
   /* -------------------------------------------------------------------- */
   /*      If not, open now, and register this connection with the         */
   /*      pool.                                                           */
   /* -------------------------------------------------------------------- */
-  if( hDS == NULL ) {
+  if (hDS == NULL) {
     char szPath[MS_MAXPATHLEN] = "";
     const char *pszDSSelectedName = pszDSName;
 
-    if( layer->debug )
+    if (layer->debug >= MS_DEBUGLEVEL_V) {
       msDebug("msOGRFileOpen(%s)...\n", connection);
+    }
 
     CPLErrorReset();
-    if (msTryBuildPath3(szPath, layer->map->mappath,
-                        layer->map->shapepath, pszDSName) != NULL ||
+    if (msTryBuildPath3(szPath, layer->map->mappath, layer->map->shapepath,
+                        pszDSName) != NULL ||
         msTryBuildPath(szPath, layer->map->mappath, pszDSName) != NULL) {
       /* Use relative path */
       pszDSSelectedName = szPath;
     }
 
-    if( layer->debug )
-      msDebug("OGROPen(%s)\n", pszDSSelectedName);
+    if (layer->debug >= MS_DEBUGLEVEL_V) {
+      msDebug("GDALOpenEx(%s)\n", pszDSSelectedName);
+    }
 
     ACQUIRE_OGR_LOCK;
-    char** connectionoptions = msGetStringListFromHashTable(&(layer->connectionoptions));
-    hDS = (OGRDataSourceH) GDALOpenEx(pszDSSelectedName,
-                                GDAL_OF_VECTOR,
-                                NULL,
-                                (const char* const*)connectionoptions,
-                                NULL);
+    char **connectionoptions =
+        msGetStringListFromHashTable(&(layer->connectionoptions));
+    hDS = (OGRDataSourceH)GDALOpenEx(pszDSSelectedName, GDAL_OF_VECTOR, NULL,
+                                     (const char *const *)connectionoptions,
+                                     NULL);
     CSLDestroy(connectionoptions);
     RELEASE_OGR_LOCK;
 
-    if( hDS == NULL ) {
+    if (hDS == NULL) {
       msSetError(MS_OGRERR,
-                   "Open failed for OGR connection in layer `%s'.  "
-                   "File not found or unsupported format. Check server logs.",
-                   "msOGRFileOpen()",
-                   layer->name?layer->name:"(null)" );
-      if( strlen(CPLGetLastErrorMsg()) == 0 )
+                 "Open failed for OGR connection in layer `%s'.  "
+                 "File not found or unsupported format. Check server logs.",
+                 "msOGRFileOpen()", layer->name ? layer->name : "(null)");
+      if (strlen(CPLGetLastErrorMsg()) == 0)
         msDebug("Open failed for OGR connection in layer `%s'.\n%s\n",
-                   layer->name?layer->name:"(null)",
-                   CPLGetLastErrorMsg() );
-      CPLFree( pszDSName );
-      CPLFree( pszLayerDef );
+                layer->name ? layer->name : "(null)", CPLGetLastErrorMsg());
+      CPLFree(pszDSName);
+      CPLFree(pszLayerDef);
       return NULL;
     }
 
-    msConnPoolRegister( layer, hDS, msOGRCloseConnection );
+    msConnPoolRegister(layer, hDS, msOGRCloseConnection);
   }
 
-  CPLFree( pszDSName );
+  CPLFree(pszDSName);
   pszDSName = NULL;
 
   /* ------------------------------------------------------------------
    * Find the layer selected.
    * ------------------------------------------------------------------ */
 
-  int   nLayerIndex = 0;
-  OGRLayerH     hLayer = NULL;
+  int nLayerIndex = 0;
+  OGRLayerH hLayer = NULL;
 
-  int  iLayer;
+  int iLayer;
 
-  if( EQUALN(pszLayerDef,"SELECT ",7) ) {
+  if (EQUALN(pszLayerDef, "SELECT ", 7)) {
     ACQUIRE_OGR_LOCK;
-    hLayer = OGR_DS_ExecuteSQL( hDS, pszLayerDef, NULL, NULL );
-    if( hLayer == NULL ) {
-      msSetError(MS_OGRERR,
-                 "ExecuteSQL() failed. Check server logs.",
+    hLayer = OGR_DS_ExecuteSQL(hDS, pszLayerDef, NULL, NULL);
+    if (hLayer == NULL) {
+      msSetError(MS_OGRERR, "ExecuteSQL() failed. Check server logs.",
                  "msOGRFileOpen()");
-      if( strlen(CPLGetLastErrorMsg()) == 0 )
-        msDebug("ExecuteSQL(%s) failed.\n%s\n",
-                pszLayerDef, CPLGetLastErrorMsg() );
+      if (strlen(CPLGetLastErrorMsg()) == 0)
+        msDebug("ExecuteSQL(%s) failed.\n%s\n", pszLayerDef,
+                CPLGetLastErrorMsg());
       RELEASE_OGR_LOCK;
-      msConnPoolRelease( layer, hDS );
-      CPLFree( pszLayerDef );
+      msConnPoolRelease(layer, hDS);
+      CPLFree(pszLayerDef);
       return NULL;
     }
     RELEASE_OGR_LOCK;
     nLayerIndex = -1;
   }
 
-  for( iLayer = 0; hLayer == NULL && iLayer < OGR_DS_GetLayerCount(hDS); iLayer++ ) {
-    hLayer = OGR_DS_GetLayer( hDS, iLayer );
-    if( hLayer != NULL
-        && EQUAL(OGR_L_GetName(hLayer),pszLayerDef) )
-    {
+  for (iLayer = 0; hLayer == NULL && iLayer < OGR_DS_GetLayerCount(hDS);
+       iLayer++) {
+    hLayer = OGR_DS_GetLayer(hDS, iLayer);
+    if (hLayer != NULL && EQUAL(OGR_L_GetName(hLayer), pszLayerDef)) {
       nLayerIndex = iLayer;
       break;
     } else
       hLayer = NULL;
   }
 
-  if( hLayer == NULL && (atoi(pszLayerDef) > 0 || EQUAL(pszLayerDef,"0")) ) {
+  if (hLayer == NULL && (atoi(pszLayerDef) > 0 || EQUAL(pszLayerDef, "0"))) {
     nLayerIndex = atoi(pszLayerDef);
-    if( nLayerIndex <  OGR_DS_GetLayerCount(hDS) )
-      hLayer = OGR_DS_GetLayer( hDS, nLayerIndex );
+    if (nLayerIndex < OGR_DS_GetLayerCount(hDS))
+      hLayer = OGR_DS_GetLayer(hDS, nLayerIndex);
   }
 
   if (hLayer == NULL) {
     msSetError(MS_OGRERR, "GetLayer(%s) failed for OGR connection. Check logs.",
-               "msOGRFileOpen()",
-               pszLayerDef);
-    msDebug("GetLayer(%s) failed for OGR connection `%s'.\n",
-            pszLayerDef, connection );
-    CPLFree( pszLayerDef );
-    msConnPoolRelease( layer, hDS );
+               "msOGRFileOpen()", pszLayerDef);
+    msDebug("GetLayer(%s) failed for OGR connection `%s'.\n", pszLayerDef,
+            connection);
+    CPLFree(pszLayerDef);
+    msConnPoolRelease(layer, hDS);
     return NULL;
   }
 
   /* ------------------------------------------------------------------
    * OK... open succeded... alloc and fill msOGRFileInfo inside layer obj
    * ------------------------------------------------------------------ */
-  msOGRFileInfo *psInfo =(msOGRFileInfo*)CPLCalloc(1,sizeof(msOGRFileInfo));
+  msOGRFileInfo *psInfo = (msOGRFileInfo *)CPLCalloc(1, sizeof(msOGRFileInfo));
 
-  psInfo->pszFname = CPLStrdup(OGR_DS_GetName( hDS ));
+  psInfo->pszFname = CPLStrdup(OGR_DS_GetName(hDS));
   psInfo->pszLayerDef = pszLayerDef;
   psInfo->nLayerIndex = nLayerIndex;
   psInfo->hDS = hDS;
@@ -1320,7 +1280,7 @@ msOGRFileOpen(layerObj *layer, const cha
 
   psInfo->nTileId = 0;
   msInitProjection(&(psInfo->sTileProj));
-  msProjectionInheritContextFrom(&(psInfo->sTileProj),&(layer->projection));
+  msProjectionInheritContextFrom(&(psInfo->sTileProj), &(layer->projection));
   psInfo->poCurTile = NULL;
   psInfo->rect_is_defined = false;
   psInfo->rect.minx = psInfo->rect.maxx = 0;
@@ -1339,7 +1299,7 @@ msOGRFileOpen(layerObj *layer, const cha
   psInfo->pszTablePrefix = NULL;
   psInfo->pszWHERE = NULL;
 
-    // GDAL 1.x API
+  // GDAL 1.x API
   OGRSFDriverH dr = OGR_DS_GetDriver(hDS);
   const char *name = OGR_Dr_GetName(dr);
   if (strcmp(name, "SQLite") == 0) {
@@ -1351,29 +1311,36 @@ msOGRFileOpen(layerObj *layer, const cha
     const char *test_spatialite = "SELECT spatialite_version()";
     OGRLayerH l = OGR_DS_ExecuteSQL(hDS, test_spatialite, NULL, NULL);
     if (l) {
-        OGR_DS_ReleaseResultSet(hDS, l);
-        have_spatialite = true;
+      OGR_DS_ReleaseResultSet(hDS, l);
+      have_spatialite = true;
     }
 
     // test for Spatialite enabled db
     if (have_spatialite) {
-        have_spatialite = false;
-        const char *test_sql = "select 1 from sqlite_master where name = 'geometry_columns' and sql LIKE '%spatial_index_enabled%'";
-        OGRLayerH l = OGR_DS_ExecuteSQL(hDS, test_sql, NULL, NULL);
-        if (l) {
-            if (OGR_L_GetFeatureCount(l, TRUE) == 1)
-                have_spatialite = true;
-            OGR_DS_ReleaseResultSet(hDS, l);
-        }
+      have_spatialite = false;
+      const char *test_sql =
+          "select 1 from sqlite_master where name = 'geometry_columns' and sql "
+          "LIKE '%spatial_index_enabled%'";
+      OGRLayerH l = OGR_DS_ExecuteSQL(hDS, test_sql, NULL, NULL);
+      if (l) {
+        if (OGR_L_GetFeatureCount(l, TRUE) == 1)
+          have_spatialite = true;
+        OGR_DS_ReleaseResultSet(hDS, l);
+      }
     }
 
     CPLPopErrorHandler();
     CPLErrorReset();
 
     if (have_spatialite)
-        psInfo->dialect = "Spatialite";
-    else
-        msDebug("msOGRFileOpen: Native SQL not available, no Spatialite support and/or not a Spatialite enabled db\n");
+      psInfo->dialect = "Spatialite";
+    else {
+      if (layer->debug >= MS_DEBUGLEVEL_DEBUG) {
+        msDebug(
+            "msOGRFileOpen: Native SQL not available, no Spatialite support "
+            "and/or not a Spatialite enabled db\n");
+      }
+    }
   } else if (strcmp(name, "PostgreSQL") == 0) {
     psInfo->dialect = "PostgreSQL";
     // todo: PostgreSQL not yet tested
@@ -1382,60 +1349,56 @@ msOGRFileOpen(layerObj *layer, const cha
              atoi(GDALVersionInfo("VERSION_NUM")) >= 2000000) {
 
     bool has_rtree = false;
-    const char* test_rtree =
+    const char *test_rtree =
         CPLSPrintf("SELECT 1 FROM sqlite_master WHERE name = 'rtree_%s_%s'",
                    OGR_L_GetName(hLayer), OGR_L_GetGeometryColumn(hLayer));
     OGRLayerH l = OGR_DS_ExecuteSQL(hDS, test_rtree, NULL, NULL);
-    if( l )
-    {
-        if( OGR_L_GetFeatureCount(l, TRUE) == 1 )
-        {
-            has_rtree = true;
-        }
-        OGR_DS_ReleaseResultSet(hDS, l);
+    if (l) {
+      if (OGR_L_GetFeatureCount(l, TRUE) == 1) {
+        has_rtree = true;
+      }
+      OGR_DS_ReleaseResultSet(hDS, l);
     }
-    if( has_rtree )
-    {
-        bool have_gpkg_spatialite = false;
-
-        CPLPushErrorHandler(CPLQuietErrorHandler);
-
-        // test for Spatialite >= 4.3 support in driver
-        const char *test_spatialite = "SELECT spatialite_version()";
-        l = OGR_DS_ExecuteSQL(hDS, test_spatialite, NULL, NULL);
-        if (l) {
-            OGRFeatureH hFeat = OGR_L_GetNextFeature(l);
-            if( hFeat )
-            {
-                const char* pszVersion = OGR_F_GetFieldAsString(hFeat, 0);
-                have_gpkg_spatialite = atof(pszVersion) >= 4.3;
-                OGR_F_Destroy(hFeat);
-            }
-            OGR_DS_ReleaseResultSet(hDS, l);
-        }
-        CPLPopErrorHandler();
-        CPLErrorReset();
+    if (has_rtree) {
+      bool have_gpkg_spatialite = false;
 
-        if( have_gpkg_spatialite )
-        {
-            psInfo->pszMainTableName = msStrdup( OGR_L_GetName(hLayer) );
-            psInfo->pszTablePrefix = msStrdup( psInfo->pszMainTableName );
-            psInfo->pszSpatialFilterTableName = msStrdup( OGR_L_GetName(hLayer) );
-            psInfo->pszSpatialFilterGeometryColumn = msStrdup( OGR_L_GetGeometryColumn(hLayer) );
-            psInfo->dialect = "GPKG";
-            psInfo->bPaging = true;
-            psInfo->bHasSpatialIndex = true;
+      CPLPushErrorHandler(CPLQuietErrorHandler);
+
+      // test for Spatialite >= 4.3 support in driver
+      const char *test_spatialite = "SELECT spatialite_version()";
+      l = OGR_DS_ExecuteSQL(hDS, test_spatialite, NULL, NULL);
+      if (l) {
+        OGRFeatureH hFeat = OGR_L_GetNextFeature(l);
+        if (hFeat) {
+          const char *pszVersion = OGR_F_GetFieldAsString(hFeat, 0);
+          have_gpkg_spatialite = atof(pszVersion) >= 4.3;
+          OGR_F_Destroy(hFeat);
         }
-        else
-            msDebug("msOGRFileOpen: Spatialite support in GPKG not enabled\n");
-    }
-    else
-    {
+        OGR_DS_ReleaseResultSet(hDS, l);
+      }
+      CPLPopErrorHandler();
+      CPLErrorReset();
+
+      if (have_gpkg_spatialite) {
+        psInfo->pszMainTableName = msStrdup(OGR_L_GetName(hLayer));
+        psInfo->pszTablePrefix = msStrdup(psInfo->pszMainTableName);
+        psInfo->pszSpatialFilterTableName = msStrdup(OGR_L_GetName(hLayer));
+        psInfo->pszSpatialFilterGeometryColumn =
+            msStrdup(OGR_L_GetGeometryColumn(hLayer));
+        psInfo->dialect = "GPKG";
+        psInfo->bPaging = true;
+        psInfo->bHasSpatialIndex = true;
+      } else if (layer->debug >= MS_DEBUGLEVEL_DEBUG) {
+        msDebug("msOGRFileOpen: Spatialite support in GPKG not enabled\n");
+      }
+    } else {
+      if (layer->debug >= MS_DEBUGLEVEL_DEBUG) {
         msDebug("msOGRFileOpen: RTree index not available\n");
+      }
     }
   }
 
-  if( psInfo->dialect != NULL && EQUAL(psInfo->dialect, "Spatialite") )
+  if (psInfo->dialect != NULL && EQUAL(psInfo->dialect, "Spatialite"))
     msOGRFileOpenSpatialite(layer, pszLayerDef, psInfo);
 
   return psInfo;
@@ -1445,254 +1408,242 @@ msOGRFileOpen(layerObj *layer, const cha
 /*                      msOGRFileOpenSpatialite()                       */
 /************************************************************************/
 
-static void msOGRFileOpenSpatialite( layerObj *layer, 
-                                     const char* pszLayerDef,
-                                     msOGRFileInfo *psInfo )
-{
+static void msOGRFileOpenSpatialite(layerObj *layer, const char *pszLayerDef,
+                                    msOGRFileInfo *psInfo) {
   // In the case of a SQLite DB, check that we can identify the
   // underlying table
-  if( psInfo->nLayerIndex == -1 )
-  {
-      psInfo->bIsOKForSQLCompose = false;
-
-      const char* from = strstr( psInfo->pszLayerDef, " from ");
-      if( from == NULL )
-        from = strstr( psInfo->pszLayerDef, " FROM ");
-      if( from )
-      {
-        const char* pszBeginningOfTable = from + strlen(" FROM ");
-        const char* pszIter = pszBeginningOfTable;
-        while( *pszIter && *pszIter != ' ' )
-          pszIter ++;
-        if( strchr(pszIter, ',') == NULL &&
-            strstr(pszIter, " where ") == NULL && strstr(pszIter, " WHERE ") == NULL &&
-            strstr(pszIter, " join ") == NULL && strstr(pszIter, " JOIN ") == NULL &&
-            strstr(pszIter, " order by ") == NULL && strstr(pszIter, " ORDER BY ") == NULL)
-        {
-          psInfo->bIsOKForSQLCompose = true;
-          psInfo->pszMainTableName = msStrdup(pszBeginningOfTable);
-          psInfo->pszMainTableName[pszIter - pszBeginningOfTable] = '\0';
-          psInfo->pszSpatialFilterTableName = msStrdup(psInfo->pszMainTableName);
-          psInfo->pszSpatialFilterGeometryColumn = msStrdup( OGR_L_GetGeometryColumn(psInfo->hLayer) );
-
-          char* pszRequest = NULL;
-          pszRequest = msStringConcatenate(pszRequest,
-              "SELECT name FROM sqlite_master WHERE type = 'table' AND name = lower('");
-          pszRequest = msStringConcatenate(pszRequest, psInfo->pszMainTableName);
-          pszRequest = msStringConcatenate(pszRequest, "')");
-          OGRLayerH hLayer = OGR_DS_ExecuteSQL( psInfo->hDS, pszRequest, NULL, NULL );
-          msFree(pszRequest);
+  if (psInfo->nLayerIndex == -1) {
+    psInfo->bIsOKForSQLCompose = false;
 
-          if( hLayer )
-          {
-              OGRFeatureH hFeature = OGR_L_GetNextFeature(hLayer);
-              psInfo->bIsOKForSQLCompose = (hFeature != NULL);
-              if( hFeature )
-              {
-                msFree(psInfo->pszMainTableName);
-                msFree(psInfo->pszSpatialFilterTableName);
-                psInfo->pszMainTableName = msStrdup( OGR_F_GetFieldAsString( hFeature, 0) );
-                psInfo->pszSpatialFilterTableName = msStrdup( psInfo->pszMainTableName );
-                OGR_F_Destroy(hFeature);
-              }
-              OGR_DS_ReleaseResultSet( psInfo->hDS, hLayer );
-          }
-          if( psInfo->bIsOKForSQLCompose )
-          {
-            psInfo->pszSelect = msStrdup(psInfo->pszLayerDef);
-          }
-          else
-          {
-            // Test if it is a spatial view
-            pszRequest = msStringConcatenate(NULL,
-              "SELECT f_table_name, f_geometry_column, view_rowid FROM views_geometry_columns WHERE view_name = lower('");
-            pszRequest = msStringConcatenate(pszRequest, psInfo->pszMainTableName);
-            pszRequest = msStringConcatenate(pszRequest, "')");
-            CPLPushErrorHandler(CPLQuietErrorHandler);
-            OGRLayerH hLayer = OGR_DS_ExecuteSQL( psInfo->hDS, pszRequest, NULL, NULL );
-            CPLPopErrorHandler();
-            msFree(pszRequest);
-
-            if( hLayer )
-            {
-                OGRFeatureH hFeature = OGR_L_GetNextFeature(hLayer);
-                psInfo->bIsOKForSQLCompose = (hFeature != NULL);
-                if( hFeature )
-                {
-                  psInfo->pszSelect = msStrdup(psInfo->pszLayerDef);
-                  msFree(psInfo->pszSpatialFilterTableName);
-                  psInfo->pszSpatialFilterTableName = msStrdup( OGR_F_GetFieldAsString( hFeature, 0 ) );
-                  CPLFree( psInfo->pszSpatialFilterGeometryColumn );
-                  psInfo->pszSpatialFilterGeometryColumn = msStrdup( OGR_F_GetFieldAsString( hFeature, 1 ) );
-                  psInfo->pszRowId = msStrdup( OGR_F_GetFieldAsString( hFeature, 2 ) );
-                  OGR_F_Destroy(hFeature);
-                }
-                OGR_DS_ReleaseResultSet( psInfo->hDS, hLayer );
-            }
-          }
-        }
-      }
-  }
-  else
-  {
-      psInfo->bIsOKForSQLCompose = false;
+    const char *from = strstr(psInfo->pszLayerDef, " from ");
+    if (from == NULL)
+      from = strstr(psInfo->pszLayerDef, " FROM ");
+    if (from) {
+      const char *pszBeginningOfTable = from + strlen(" FROM ");
+      const char *pszIter = pszBeginningOfTable;
+      while (*pszIter && *pszIter != ' ')
+        pszIter++;
+      if (strchr(pszIter, ',') == NULL && strstr(pszIter, " where ") == NULL &&
+          strstr(pszIter, " WHERE ") == NULL &&
+          strstr(pszIter, " join ") == NULL &&
+          strstr(pszIter, " JOIN ") == NULL &&
+          strstr(pszIter, " order by ") == NULL &&
+          strstr(pszIter, " ORDER BY ") == NULL) {
+        psInfo->bIsOKForSQLCompose = true;
+        psInfo->pszMainTableName = msStrdup(pszBeginningOfTable);
+        psInfo->pszMainTableName[pszIter - pszBeginningOfTable] = '\0';
+        psInfo->pszSpatialFilterTableName = msStrdup(psInfo->pszMainTableName);
+        psInfo->pszSpatialFilterGeometryColumn =
+            msStrdup(OGR_L_GetGeometryColumn(psInfo->hLayer));
 
-      char* pszRequest = NULL;
-      pszRequest = msStringConcatenate(pszRequest,
-          "SELECT * FROM sqlite_master WHERE type = 'table' AND name = lower('");
-      pszRequest = msStringConcatenate(pszRequest, OGR_FD_GetName(OGR_L_GetLayerDefn(psInfo->hLayer)));
-      pszRequest = msStringConcatenate(pszRequest, "')");
-      OGRLayerH hLayer = OGR_DS_ExecuteSQL( psInfo->hDS, pszRequest, NULL, NULL );
-      msFree(pszRequest);
+        char *pszRequest = NULL;
+        pszRequest = msStringConcatenate(pszRequest,
+                                         "SELECT name FROM sqlite_master WHERE "
+                                         "type = 'table' AND name = lower('");
+        pszRequest = msStringConcatenate(pszRequest, psInfo->pszMainTableName);
+        pszRequest = msStringConcatenate(pszRequest, "')");
+        OGRLayerH hLayer =
+            OGR_DS_ExecuteSQL(psInfo->hDS, pszRequest, NULL, NULL);
+        msFree(pszRequest);
 
-      if( hLayer )
-      {
+        if (hLayer) {
           OGRFeatureH hFeature = OGR_L_GetNextFeature(hLayer);
           psInfo->bIsOKForSQLCompose = (hFeature != NULL);
-          if( hFeature )
+          if (hFeature) {
+            msFree(psInfo->pszMainTableName);
+            msFree(psInfo->pszSpatialFilterTableName);
+            psInfo->pszMainTableName =
+                msStrdup(OGR_F_GetFieldAsString(hFeature, 0));
+            psInfo->pszSpatialFilterTableName =
+                msStrdup(psInfo->pszMainTableName);
             OGR_F_Destroy(hFeature);
-          OGR_DS_ReleaseResultSet( psInfo->hDS, hLayer );
-      }
-      if( psInfo->bIsOKForSQLCompose )
-      {
-        psInfo->pszMainTableName = msStrdup(OGR_FD_GetName(OGR_L_GetLayerDefn(psInfo->hLayer)));
-        psInfo->pszSpatialFilterTableName = msStrdup(psInfo->pszMainTableName);
-        psInfo->pszSpatialFilterGeometryColumn = msStrdup( OGR_L_GetGeometryColumn(psInfo->hLayer) );
-      }
-      else
-      {
-        // Test if it is a spatial view
-        pszRequest = msStringConcatenate(NULL,
-          "SELECT f_table_name, f_geometry_column, view_rowid FROM views_geometry_columns WHERE view_name = lower('");
-        pszRequest = msStringConcatenate(pszRequest, OGR_FD_GetName(OGR_L_GetLayerDefn(psInfo->hLayer)));
-        pszRequest = msStringConcatenate(pszRequest, "')");
-        CPLPushErrorHandler(CPLQuietErrorHandler);
-        OGRLayerH hLayer = OGR_DS_ExecuteSQL( psInfo->hDS, pszRequest, NULL, NULL );
-        CPLPopErrorHandler();
-        msFree(pszRequest);
+          }
+          OGR_DS_ReleaseResultSet(psInfo->hDS, hLayer);
+        }
+        if (psInfo->bIsOKForSQLCompose) {
+          psInfo->pszSelect = msStrdup(psInfo->pszLayerDef);
+        } else {
+          // Test if it is a spatial view
+          pszRequest = msStringConcatenate(
+              NULL, "SELECT f_table_name, f_geometry_column, view_rowid FROM "
+                    "views_geometry_columns WHERE view_name = lower('");
+          pszRequest =
+              msStringConcatenate(pszRequest, psInfo->pszMainTableName);
+          pszRequest = msStringConcatenate(pszRequest, "')");
+          CPLPushErrorHandler(CPLQuietErrorHandler);
+          OGRLayerH hLayer =
+              OGR_DS_ExecuteSQL(psInfo->hDS, pszRequest, NULL, NULL);
+          CPLPopErrorHandler();
+          msFree(pszRequest);
 
-        if( hLayer )
-        {
+          if (hLayer) {
             OGRFeatureH hFeature = OGR_L_GetNextFeature(hLayer);
             psInfo->bIsOKForSQLCompose = (hFeature != NULL);
-            if( hFeature )
-            {
-              psInfo->pszMainTableName = msStrdup(OGR_FD_GetName(OGR_L_GetLayerDefn(psInfo->hLayer)));
-              psInfo->pszSpatialFilterTableName = msStrdup( OGR_F_GetFieldAsString( hFeature, 0 ) );
-              psInfo->pszSpatialFilterGeometryColumn = msStrdup( OGR_F_GetFieldAsString( hFeature, 1 ) );
-              psInfo->pszRowId = msStrdup( OGR_F_GetFieldAsString( hFeature, 2 ) );
+            if (hFeature) {
+              psInfo->pszSelect = msStrdup(psInfo->pszLayerDef);
+              msFree(psInfo->pszSpatialFilterTableName);
+              psInfo->pszSpatialFilterTableName =
+                  msStrdup(OGR_F_GetFieldAsString(hFeature, 0));
+              CPLFree(psInfo->pszSpatialFilterGeometryColumn);
+              psInfo->pszSpatialFilterGeometryColumn =
+                  msStrdup(OGR_F_GetFieldAsString(hFeature, 1));
+              psInfo->pszRowId = msStrdup(OGR_F_GetFieldAsString(hFeature, 2));
               OGR_F_Destroy(hFeature);
             }
-            OGR_DS_ReleaseResultSet( psInfo->hDS, hLayer );
+            OGR_DS_ReleaseResultSet(psInfo->hDS, hLayer);
+          }
         }
       }
+    }
+  } else {
+    psInfo->bIsOKForSQLCompose = false;
+
+    char *pszRequest = NULL;
+    pszRequest = msStringConcatenate(
+        pszRequest,
+        "SELECT * FROM sqlite_master WHERE type = 'table' AND name = lower('");
+    pszRequest = msStringConcatenate(
+        pszRequest, OGR_FD_GetName(OGR_L_GetLayerDefn(psInfo->hLayer)));
+    pszRequest = msStringConcatenate(pszRequest, "')");
+    OGRLayerH hLayer = OGR_DS_ExecuteSQL(psInfo->hDS, pszRequest, NULL, NULL);
+    msFree(pszRequest);
+
+    if (hLayer) {
+      OGRFeatureH hFeature = OGR_L_GetNextFeature(hLayer);
+      psInfo->bIsOKForSQLCompose = (hFeature != NULL);
+      if (hFeature)
+        OGR_F_Destroy(hFeature);
+      OGR_DS_ReleaseResultSet(psInfo->hDS, hLayer);
+    }
+    if (psInfo->bIsOKForSQLCompose) {
+      psInfo->pszMainTableName =
+          msStrdup(OGR_FD_GetName(OGR_L_GetLayerDefn(psInfo->hLayer)));
+      psInfo->pszSpatialFilterTableName = msStrdup(psInfo->pszMainTableName);
+      psInfo->pszSpatialFilterGeometryColumn =
+          msStrdup(OGR_L_GetGeometryColumn(psInfo->hLayer));
+    } else {
+      // Test if it is a spatial view
+      pszRequest = msStringConcatenate(
+          NULL, "SELECT f_table_name, f_geometry_column, view_rowid FROM "
+                "views_geometry_columns WHERE view_name = lower('");
+      pszRequest = msStringConcatenate(
+          pszRequest, OGR_FD_GetName(OGR_L_GetLayerDefn(psInfo->hLayer)));
+      pszRequest = msStringConcatenate(pszRequest, "')");
+      CPLPushErrorHandler(CPLQuietErrorHandler);
+      OGRLayerH hLayer = OGR_DS_ExecuteSQL(psInfo->hDS, pszRequest, NULL, NULL);
+      CPLPopErrorHandler();
+      msFree(pszRequest);
+
+      if (hLayer) {
+        OGRFeatureH hFeature = OGR_L_GetNextFeature(hLayer);
+        psInfo->bIsOKForSQLCompose = (hFeature != NULL);
+        if (hFeature) {
+          psInfo->pszMainTableName =
+              msStrdup(OGR_FD_GetName(OGR_L_GetLayerDefn(psInfo->hLayer)));
+          psInfo->pszSpatialFilterTableName =
+              msStrdup(OGR_F_GetFieldAsString(hFeature, 0));
+          psInfo->pszSpatialFilterGeometryColumn =
+              msStrdup(OGR_F_GetFieldAsString(hFeature, 1));
+          psInfo->pszRowId = msStrdup(OGR_F_GetFieldAsString(hFeature, 2));
+          OGR_F_Destroy(hFeature);
+        }
+        OGR_DS_ReleaseResultSet(psInfo->hDS, hLayer);
+      }
+    }
   }
 
   // in the case we cannot handle the native string, go back to the client
   // side evaluation by unsetting it.
-  if( !psInfo->bIsOKForSQLCompose && psInfo->dialect != NULL )
-  {
-      if (layer->debug >= MS_DEBUGLEVEL_VVV)
-      {
-        msDebug("msOGRFileOpen(): Falling back to MapServer only evaluation\n");
-      }
-      psInfo->dialect = NULL;
+  if (!psInfo->bIsOKForSQLCompose && psInfo->dialect != NULL) {
+    if (layer->debug >= MS_DEBUGLEVEL_VVV) {
+      msDebug("msOGRFileOpen(): Falling back to MapServer only evaluation\n");
+    }
+    psInfo->dialect = NULL;
   }
 
   // Check if spatial index has been disabled (testing purposes)
   if (msLayerGetProcessingKey(layer, "USE_SPATIAL_INDEX") != NULL &&
-      !CSLTestBoolean(msLayerGetProcessingKey(layer, "USE_SPATIAL_INDEX")) )
-  {
-      if (layer->debug >= MS_DEBUGLEVEL_VVV)
-      {
-        msDebug("msOGRFileOpen(): Layer %s has spatial index disabled by processing option\n",
-                pszLayerDef);
-      }
+      !CSLTestBoolean(msLayerGetProcessingKey(layer, "USE_SPATIAL_INDEX"))) {
+    if (layer->debug >= MS_DEBUGLEVEL_VVV) {
+      msDebug("msOGRFileOpen(): Layer %s has spatial index disabled by "
+              "processing option\n",
+              pszLayerDef);
+    }
   }
   // Test if spatial index is available
-  else if( psInfo->dialect != NULL )
-  {
-      char* pszRequest = NULL;
-      pszRequest = msStringConcatenate(pszRequest,
-          "SELECT * FROM sqlite_master WHERE type = 'table' AND name = 'idx_");
-      pszRequest = msStringConcatenate(pszRequest,
-                                       psInfo->pszSpatialFilterTableName);
-      pszRequest = msStringConcatenate(pszRequest, "_");
+  else if (psInfo->dialect != NULL) {
+    char *pszRequest = NULL;
+    pszRequest = msStringConcatenate(
+        pszRequest,
+        "SELECT * FROM sqlite_master WHERE type = 'table' AND name = 'idx_");
+    pszRequest =
+        msStringConcatenate(pszRequest, psInfo->pszSpatialFilterTableName);
+    pszRequest = msStringConcatenate(pszRequest, "_");
+    pszRequest = msStringConcatenate(pszRequest,
+                                     OGR_L_GetGeometryColumn(psInfo->hLayer));
+    pszRequest = msStringConcatenate(pszRequest, "'");
+
+    psInfo->bHasSpatialIndex = false;
+    // msDebug("msOGRFileOpen(): %s", pszRequest);
+
+    OGRLayerH hLayer = OGR_DS_ExecuteSQL(psInfo->hDS, pszRequest, NULL, NULL);
+    if (hLayer) {
+      OGRFeatureH hFeature = OGR_L_GetNextFeature(hLayer);
+      if (hFeature) {
+        psInfo->bHasSpatialIndex = true;
+        OGR_F_Destroy(hFeature);
+      }
+      OGR_DS_ReleaseResultSet(psInfo->hDS, hLayer);
+    }
+    msFree(pszRequest);
+    pszRequest = NULL;
+
+    if (!psInfo->bHasSpatialIndex) {
+      if (layer->debug >= MS_DEBUGLEVEL_VVV) {
+        msDebug("msOGRFileOpen(): Layer %s has no spatial index table\n",
+                pszLayerDef);
+      }
+    } else {
+      pszRequest = msStringConcatenate(
+          pszRequest,
+          "SELECT * FROM geometry_columns WHERE f_table_name = lower('");
+      pszRequest =
+          msStringConcatenate(pszRequest, psInfo->pszSpatialFilterTableName);
+      pszRequest =
+          msStringConcatenate(pszRequest, "') AND f_geometry_column = lower('");
       pszRequest = msStringConcatenate(pszRequest,
-                                    OGR_L_GetGeometryColumn(psInfo->hLayer));
-      pszRequest = msStringConcatenate(pszRequest, "'");
+                                       psInfo->pszSpatialFilterGeometryColumn);
+      pszRequest =
+          msStringConcatenate(pszRequest, "') AND spatial_index_enabled = 1");
 
       psInfo->bHasSpatialIndex = false;
-      //msDebug("msOGRFileOpen(): %s", pszRequest);
 
-      OGRLayerH hLayer = OGR_DS_ExecuteSQL( psInfo->hDS, pszRequest, NULL, NULL );
-      if( hLayer )
-      {
+      OGRLayerH hLayer = OGR_DS_ExecuteSQL(psInfo->hDS, pszRequest, NULL, NULL);
+      if (hLayer) {
         OGRFeatureH hFeature = OGR_L_GetNextFeature(hLayer);
-        if( hFeature )
-        {
-            psInfo->bHasSpatialIndex = true;
-            OGR_F_Destroy(hFeature);
+        if (hFeature) {
+          psInfo->bHasSpatialIndex = true;
+          OGR_F_Destroy(hFeature);
         }
-        OGR_DS_ReleaseResultSet( psInfo->hDS, hLayer );
+        OGR_DS_ReleaseResultSet(psInfo->hDS, hLayer);
       }
       msFree(pszRequest);
       pszRequest = NULL;
 
-      if( !psInfo->bHasSpatialIndex )
-      {
-          if (layer->debug >= MS_DEBUGLEVEL_VVV)
-          {
-            msDebug("msOGRFileOpen(): Layer %s has no spatial index table\n",
-                    pszLayerDef);
-          }
-      }
-      else
-      {
-          pszRequest = msStringConcatenate(pszRequest,
-            "SELECT * FROM geometry_columns WHERE f_table_name = lower('");
-          pszRequest = msStringConcatenate(pszRequest,
-                                       psInfo->pszSpatialFilterTableName);
-          pszRequest = msStringConcatenate(pszRequest, "') AND f_geometry_column = lower('");
-          pszRequest = msStringConcatenate(pszRequest,
-                                       psInfo->pszSpatialFilterGeometryColumn);
-          pszRequest = msStringConcatenate(pszRequest, "') AND spatial_index_enabled = 1");
-
-          psInfo->bHasSpatialIndex = false;
-
-          OGRLayerH hLayer = OGR_DS_ExecuteSQL( psInfo->hDS, pszRequest, NULL, NULL );
-          if( hLayer )
-          {
-            OGRFeatureH hFeature = OGR_L_GetNextFeature(hLayer);
-            if( hFeature )
-            {
-                psInfo->bHasSpatialIndex = true;
-                OGR_F_Destroy(hFeature);
-            }
-            OGR_DS_ReleaseResultSet( psInfo->hDS, hLayer );
-          }
-          msFree(pszRequest);
-          pszRequest = NULL;
-
-          if( !psInfo->bHasSpatialIndex )
-          {
-            if (layer->debug >= MS_DEBUGLEVEL_VVV)
-            {
-              msDebug("msOGRFileOpen(): Layer %s has spatial index disabled\n",
-                      pszLayerDef);
-            }
-          }
-          else
-          {
-            if (layer->debug >= MS_DEBUGLEVEL_VVV)
-            {
-              msDebug("msOGRFileOpen(): Layer %s has spatial index enabled\n",
-                      pszLayerDef);
-            }
+      if (!psInfo->bHasSpatialIndex) {
+        if (layer->debug >= MS_DEBUGLEVEL_VVV) {
+          msDebug("msOGRFileOpen(): Layer %s has spatial index disabled\n",
+                  pszLayerDef);
+        }
+      } else {
+        if (layer->debug >= MS_DEBUGLEVEL_VVV) {
+          msDebug("msOGRFileOpen(): Layer %s has spatial index enabled\n",
+                  pszLayerDef);
+        }
 
-            psInfo->pszTablePrefix = msStrdup( psInfo->pszMainTableName );
-          }
+        psInfo->pszTablePrefix = msStrdup(psInfo->pszMainTableName);
       }
+    }
   }
 
   psInfo->bPaging = (psInfo->dialect != NULL);
@@ -1705,47 +1656,45 @@ static void msOGRFileOpenSpatialite( lay
 /*      connection.                                                     */
 /************************************************************************/
 
-static void msOGRCloseConnection( void *conn_handle )
+static void msOGRCloseConnection(void *conn_handle)
 
 {
-  OGRDataSourceH hDS = (OGRDataSourceH) conn_handle;
+  OGRDataSourceH hDS = (OGRDataSourceH)conn_handle;
 
   ACQUIRE_OGR_LOCK;
-  OGR_DS_Destroy( hDS );
+  OGR_DS_Destroy(hDS);
   RELEASE_OGR_LOCK;
 }
 
 /**********************************************************************
  *                     msOGRFileClose()
  **********************************************************************/
-static int msOGRFileClose(layerObj *layer, msOGRFileInfo *psInfo )
-{
+static int msOGRFileClose(layerObj *layer, msOGRFileInfo *psInfo) {
   if (!psInfo)
     return MS_SUCCESS;
 
-  if( layer->debug )
-    msDebug("msOGRFileClose(%s,%d).\n",
-            psInfo->pszFname, psInfo->nLayerIndex);
+  if (layer->debug)
+    msDebug("msOGRFileClose(%s,%d).\n", psInfo->pszFname, psInfo->nLayerIndex);
 
   CPLFree(psInfo->pszFname);
   CPLFree(psInfo->pszLayerDef);
 
   ACQUIRE_OGR_LOCK;
   if (psInfo->hLastFeature)
-    OGR_F_Destroy( psInfo->hLastFeature );
+    OGR_F_Destroy(psInfo->hLastFeature);
 
   /* If nLayerIndex == -1 then the layer is an SQL result ... free it */
-  if( psInfo->nLayerIndex == -1 )
-    OGR_DS_ReleaseResultSet( psInfo->hDS, psInfo->hLayer );
+  if (psInfo->nLayerIndex == -1)
+    OGR_DS_ReleaseResultSet(psInfo->hDS, psInfo->hLayer);
 
   // Release (potentially close) the datasource connection.
   // Make sure we aren't holding the lock when the callback may need it.
   RELEASE_OGR_LOCK;
-  msConnPoolRelease( layer, psInfo->hDS );
+  msConnPoolRelease(layer, psInfo->hDS);
 
   // Free current tile if there is one.
-  if( psInfo->poCurTile != NULL )
-    msOGRFileClose( layer, psInfo->poCurTile );
+  if (psInfo->poCurTile != NULL)
+    msOGRFileClose(layer, psInfo->poCurTile);
 
   msFreeProjection(&(psInfo->sTileProj));
   msFree(psInfo->pszSelect);
@@ -1764,12 +1713,11 @@ static int msOGRFileClose(layerObj *laye
 /************************************************************************/
 /*                           msOGREscapeSQLParam                        */
 /************************************************************************/
-static char *msOGREscapeSQLParam(layerObj *layer, const char *pszString)
-{
-  char* pszEscapedStr =NULL;
-  if(layer && pszString) {
-    char* pszEscapedOGRStr =  CPLEscapeString(pszString, strlen(pszString),
-                              CPLES_SQL );
+static char *msOGREscapeSQLParam(layerObj *layer, const char *pszString) {
+  char *pszEscapedStr = NULL;
+  if (layer && pszString) {
+    char *pszEscapedOGRStr =
+        CPLEscapeString(pszString, strlen(pszString), CPLES_SQL);
     pszEscapedStr = msStrdup(pszEscapedOGRStr);
     CPLFree(pszEscapedOGRStr);
   }
@@ -1779,66 +1727,63 @@ static char *msOGREscapeSQLParam(layerOb
 // http://www.sqlite.org/lang_expr.html
 // http://www.gaia-gis.it/gaia-sins/spatialite-sql-4.3.0.html
 
-static char* msOGRGetQuotedItem(layerObj* layer, const char* pszItem )
-{
-    msOGRFileInfo *psInfo = (msOGRFileInfo *)layer->layerinfo;
-    char* ret = NULL;
-    char* escapedItem = msLayerEscapePropertyName(layer, pszItem);
-    if( psInfo->pszTablePrefix)
-    {
-        char* escapedTable = msLayerEscapePropertyName(layer, psInfo->pszTablePrefix);
-        ret = msStringConcatenate(ret, "\"");
-        ret = msStringConcatenate(ret, escapedTable);
-        ret = msStringConcatenate(ret, "\".\"");
-        ret = msStringConcatenate(ret, escapedItem);
-        ret = msStringConcatenate(ret, "\"");
-        msFree(escapedTable);
-    }
-    else
-    {
-        ret = msStringConcatenate(ret, "\"");
-        ret = msStringConcatenate(ret, escapedItem);
-        ret = msStringConcatenate(ret, "\"");
-    }
-    msFree(escapedItem);
-    return ret;
-}
-
-static
-char *msOGRGetToken(layerObj* layer, tokenListNodeObjPtr *node) {
-    msOGRFileInfo *info = (msOGRFileInfo *)layer->layerinfo;
-    tokenListNodeObjPtr n = *node;
-    if (!n) return NULL;
-    char *out = NULL;
-    size_t nOutSize;
-
-    switch(n->token) {
-    case MS_TOKEN_LOGICAL_AND:
-        out = msStrdup(" AND ");
-        break;
-    case MS_TOKEN_LOGICAL_OR:
-        out = msStrdup(" OR ");
-        break;
-    case MS_TOKEN_LOGICAL_NOT:
-        out = msStrdup(" NOT ");
-        break;
-    case MS_TOKEN_LITERAL_NUMBER:
-        nOutSize = 32;
-        out = (char *)msSmallMalloc(nOutSize);
-        snprintf(out, nOutSize, "%.18g", n->tokenval.dblval);
-        break;
-    case MS_TOKEN_LITERAL_STRING: {
-        char *stresc = msOGREscapeSQLParam(layer, n->tokenval.strval);
-        nOutSize = strlen(stresc)+3;
-        out = (char *)msSmallMalloc(nOutSize);
-        snprintf(out, nOutSize, "'%s'", stresc);
-        msFree(stresc);
-        break;
-    }
-    case MS_TOKEN_LITERAL_TIME:
-        // seems to require METADATA gml_types => auto
-        nOutSize = 80;
-        out = (char *)msSmallMalloc(nOutSize);
+static char *msOGRGetQuotedItem(layerObj *layer, const char *pszItem) {
+  msOGRFileInfo *psInfo = (msOGRFileInfo *)layer->layerinfo;
+  char *ret = NULL;
+  char *escapedItem = msLayerEscapePropertyName(layer, pszItem);
+  if (psInfo->pszTablePrefix) {
+    char *escapedTable =
+        msLayerEscapePropertyName(layer, psInfo->pszTablePrefix);
+    ret = msStringConcatenate(ret, "\"");
+    ret = msStringConcatenate(ret, escapedTable);
+    ret = msStringConcatenate(ret, "\".\"");
+    ret = msStringConcatenate(ret, escapedItem);
+    ret = msStringConcatenate(ret, "\"");
+    msFree(escapedTable);
+  } else {
+    ret = msStringConcatenate(ret, "\"");
+    ret = msStringConcatenate(ret, escapedItem);
+    ret = msStringConcatenate(ret, "\"");
+  }
+  msFree(escapedItem);
+  return ret;
+}
+
+static char *msOGRGetToken(layerObj *layer, tokenListNodeObjPtr *node) {
+  msOGRFileInfo *info = (msOGRFileInfo *)layer->layerinfo;
+  tokenListNodeObjPtr n = *node;
+  if (!n)
+    return NULL;
+  char *out = NULL;
+  size_t nOutSize;
+
+  switch (n->token) {
+  case MS_TOKEN_LOGICAL_AND:
+    out = msStrdup(" AND ");
+    break;
+  case MS_TOKEN_LOGICAL_OR:
+    out = msStrdup(" OR ");
+    break;
+  case MS_TOKEN_LOGICAL_NOT:
+    out = msStrdup(" NOT ");
+    break;
+  case MS_TOKEN_LITERAL_NUMBER:
+    nOutSize = 32;
+    out = (char *)msSmallMalloc(nOutSize);
+    snprintf(out, nOutSize, "%.18g", n->tokenval.dblval);
+    break;
+  case MS_TOKEN_LITERAL_STRING: {
+    char *stresc = msOGREscapeSQLParam(layer, n->tokenval.strval);
+    nOutSize = strlen(stresc) + 3;
+    out = (char *)msSmallMalloc(nOutSize);
+    snprintf(out, nOutSize, "'%s'", stresc);
+    msFree(stresc);
+    break;
+  }
+  case MS_TOKEN_LITERAL_TIME:
+    // seems to require METADATA gml_types => auto
+    nOutSize = 80;
+    out = (char *)msSmallMalloc(nOutSize);
 #if 0
         // FIXME? or perhaps just remove me. tm_zone is not supported on Windows, and not used anywhere else in the code base
         if (n->tokenval.tmval.tm_zone)
@@ -1848,312 +1793,300 @@ char *msOGRGetToken(layerObj* layer, tok
                      n->tokenval.tmval.tm_zone);
         else
 #endif
-            snprintf(out, nOutSize, "'%d-%02d-%02dT%02d:%02d:%02d'",  
-                     n->tokenval.tmval.tm_year+1900, n->tokenval.tmval.tm_mon+1, n->tokenval.tmval.tm_mday,
-                     n->tokenval.tmval.tm_hour, n->tokenval.tmval.tm_min, n->tokenval.tmval.tm_sec);
-        break;
-    case MS_TOKEN_LITERAL_SHAPE: {
-        // assumed to be in right srs after FLTGetSpatialComparisonCommonExpression
-        char *wkt = msShapeToWKT(n->tokenval.shpval);
-        char *stresc = msOGRGetQuotedItem(layer, OGR_L_GetGeometryColumn(info->hLayer)); // which geom field??
-        nOutSize = strlen(wkt)+strlen(stresc)+35;
-        out = (char *)msSmallMalloc(nOutSize);
-        snprintf(out, nOutSize, "ST_GeomFromText('%s',ST_SRID(%s))", wkt, stresc);
-        msFree(wkt);
-        msFree(stresc);
-        break;
+    snprintf(out, nOutSize, "'%d-%02d-%02dT%02d:%02d:%02d'",
+             n->tokenval.tmval.tm_year + 1900, n->tokenval.tmval.tm_mon + 1,
+             n->tokenval.tmval.tm_mday, n->tokenval.tmval.tm_hour,
+             n->tokenval.tmval.tm_min, n->tokenval.tmval.tm_sec);
+    break;
+  case MS_TOKEN_LITERAL_SHAPE: {
+    // assumed to be in right srs after FLTGetSpatialComparisonCommonExpression
+    char *wkt = msShapeToWKT(n->tokenval.shpval);
+    char *stresc = msOGRGetQuotedItem(
+        layer, OGR_L_GetGeometryColumn(info->hLayer)); // which geom field??
+    nOutSize = strlen(wkt) + strlen(stresc) + 35;
+    out = (char *)msSmallMalloc(nOutSize);
+    snprintf(out, nOutSize, "ST_GeomFromText('%s',ST_SRID(%s))", wkt, stresc);
+    msFree(wkt);
+    msFree(stresc);
+    break;
+  }
+  case MS_TOKEN_LITERAL_BOOLEAN:
+    out = msStrdup(n->tokenval.dblval == 0 ? "FALSE" : "TRUE");
+    break;
+  case MS_TOKEN_COMPARISON_EQ:
+    if (n->next != NULL && n->next->token == MS_TOKEN_LITERAL_STRING &&
+        strcmp(n->next->tokenval.strval, "_MAPSERVER_NULL_") == 0) {
+      out = msStrdup(" IS NULL");
+      n = n->next;
+      break;
     }
-    case MS_TOKEN_LITERAL_BOOLEAN:
-        out = msStrdup(n->tokenval.dblval == 0 ? "FALSE" : "TRUE");
-        break;
-    case MS_TOKEN_COMPARISON_EQ:
-        if(n->next != NULL && n->next->token == MS_TOKEN_LITERAL_STRING &&
-           strcmp(n->next->tokenval.strval, "_MAPSERVER_NULL_") == 0 )
-        {
-            out = msStrdup(" IS NULL");
-            n = n->next;
-            break;
-        }
-
-        out = msStrdup(" = ");
-        break;
-    case MS_TOKEN_COMPARISON_NE:
-        out = msStrdup(" != ");
-        break;
-    case MS_TOKEN_COMPARISON_GT:
-        out = msStrdup(" > ");
-        break;
-    case MS_TOKEN_COMPARISON_LT:
-        out = msStrdup(" < ");
-        break;
-    case MS_TOKEN_COMPARISON_LE:
-        out = msStrdup(" <= ");
-        break;
-    case MS_TOKEN_COMPARISON_GE:
-        out = msStrdup(" >= ");
-        break;
-    case MS_TOKEN_COMPARISON_IEQ:
-        out = msStrdup(" = ");
-        break;
-    case MS_TOKEN_COMPARISON_IN:
-        out = msStrdup(" IN ");
-        break;
-    // the origin may be mapfile (complex regexes, layer->map.query.filter.string == NULL, regex may have //) or 
-    // OGC Filter (simple patterns only, layer->map.query.filter.string != NULL)
-    case MS_TOKEN_COMPARISON_RE: 
-    case MS_TOKEN_COMPARISON_IRE: 
-    case MS_TOKEN_COMPARISON_LIKE: {
-        int case_sensitive = n->token == MS_TOKEN_COMPARISON_RE || n->token == MS_TOKEN_COMPARISON_LIKE;
-        // in PostgreSQL and OGR: LIKE (case sensitive) and ILIKE (case insensitive)
-        // in SQLite: LIKE (case insensitive) and GLOB (case sensitive)
-        const char *op = case_sensitive ? "LIKE" : "ILIKE";
-        char wild_any =  '%';
-        char wild_one = '_';
-
-        if (EQUAL(info->dialect, "Spatialite") || EQUAL(info->dialect, "GPKG")) {
-            if (case_sensitive) {
-                op = "GLOB";
-                wild_any = '*';
-                wild_one = '?';
-            } else {
-                op = "LIKE";
-            }
-        }
 
-        n = n->next;
-        if (n->token != MS_TOKEN_LITERAL_STRING) return NULL;
-
-        char *regex = msStrdup(n->tokenval.strval);
-        int complex_regex = *n->tokenval.strval == '/'; // could be non-complex but that is soo corner case
-
-        // PostgreSQL has POSIX regexes, SQLite does not by default, OGR does not
-        if (complex_regex) {
-            if (!EQUAL(info->dialect, "PostgreSQL")) {
-                msFree(regex);
-                return NULL;
-            }
-            // remove //
-            regex++;
-            regex[strlen(regex) - 1] = '\0';
-            if (case_sensitive)
-                op = "~";
-            else
-                op = "~*";
-        }
-
-        const size_t regex_len = strlen(regex);
-        char *re = (char *) msSmallMalloc(2 * regex_len+3);
-        size_t i = 0, j = 0;
-        re[j++] = '\'';
-        while (i < regex_len) {
-            char c = regex[i];
-            char c_next = regex[i+1];
-                
-            if (c == '.' && c_next == '*') {
-                i++;
-                c = wild_any;
-            }
-            else if (c == '.')
-                c = wild_one;
-            else if (i == 0 && c == '^') {
-                i++;
-                continue;
-            }
-            else if( c == '$' && c_next == 0 ) {
-                break;
-            }
-            else if( c == '\'' )
-            {
-                re[j++] = '\'';
-            }
-            else if( c == '\\' )
-            {
-                if( c_next == 0 ) {
-                    break;
-                }
-                i++;
-                c = c_next;
-            }
+    out = msStrdup(" = ");
+    break;
+  case MS_TOKEN_COMPARISON_NE:
+    out = msStrdup(" != ");
+    break;
+  case MS_TOKEN_COMPARISON_GT:
+    out = msStrdup(" > ");
+    break;
+  case MS_TOKEN_COMPARISON_LT:
+    out = msStrdup(" < ");
+    break;
+  case MS_TOKEN_COMPARISON_LE:
+    out = msStrdup(" <= ");
+    break;
+  case MS_TOKEN_COMPARISON_GE:
+    out = msStrdup(" >= ");
+    break;
+  case MS_TOKEN_COMPARISON_IEQ:
+    out = msStrdup(" = ");
+    break;
+  case MS_TOKEN_COMPARISON_IN:
+    out = msStrdup(" IN ");
+    break;
+  // the origin may be mapfile (complex regexes, layer->map.query.filter.string
+  // == NULL, regex may have //) or OGC Filter (simple patterns only,
+  // layer->map.query.filter.string != NULL)
+  case MS_TOKEN_COMPARISON_RE:
+  case MS_TOKEN_COMPARISON_IRE:
+  case MS_TOKEN_COMPARISON_LIKE: {
+    int case_sensitive = n->token == MS_TOKEN_COMPARISON_RE ||
+                         n->token == MS_TOKEN_COMPARISON_LIKE;
+    // in PostgreSQL and OGR: LIKE (case sensitive) and ILIKE (case insensitive)
+    // in SQLite: LIKE (case insensitive) and GLOB (case sensitive)
+    const char *op = case_sensitive ? "LIKE" : "ILIKE";
+    char wild_any = '%';
+    char wild_one = '_';
+
+    if (EQUAL(info->dialect, "Spatialite") || EQUAL(info->dialect, "GPKG")) {
+      if (case_sensitive) {
+        op = "GLOB";
+        wild_any = '*';
+        wild_one = '?';
+      } else {
+        op = "LIKE";
+      }
+    }
 
-            re[j++] = c;
-            i++;
-                
-        }
-        re[j++] = '\'';
-        re[j] = '\0';
+    n = n->next;
+    if (n->token != MS_TOKEN_LITERAL_STRING)
+      return NULL;
 
-        nOutSize = 1 + strlen(op)+ 1 + strlen(re) + 1;
-        out = (char *)msSmallMalloc(nOutSize);
-        snprintf(out, nOutSize, " %s %s", op, re);
-        msFree(re);
+    char *regex = msStrdup(n->tokenval.strval);
+    int complex_regex = *n->tokenval.strval ==
+                        '/'; // could be non-complex but that is soo corner case
+
+    // PostgreSQL has POSIX regexes, SQLite does not by default, OGR does not
+    if (complex_regex) {
+      if (!EQUAL(info->dialect, "PostgreSQL")) {
         msFree(regex);
-        break;
+        return NULL;
+      }
+      // remove //
+      regex++;
+      regex[strlen(regex) - 1] = '\0';
+      if (case_sensitive)
+        op = "~";
+      else
+        op = "~*";
     }
-    case MS_TOKEN_COMPARISON_INTERSECTS:
-        out = msStrdup("ST_Intersects");
-        break;
-    case MS_TOKEN_COMPARISON_DISJOINT:
-        out = msStrdup("ST_Disjoint");
-        break;
-    case MS_TOKEN_COMPARISON_TOUCHES:
-        out = msStrdup("ST_Touches");
-        break;
-    case MS_TOKEN_COMPARISON_OVERLAPS:
-        out = msStrdup("ST_Overlaps");
-        break;
-    case MS_TOKEN_COMPARISON_CROSSES:
-        out = msStrdup("ST_Crosses");
-        break;
-    case MS_TOKEN_COMPARISON_WITHIN:
-        out = msStrdup("ST_Within");
-        break;
-    case MS_TOKEN_COMPARISON_DWITHIN:
-        out = msStrdup("ST_Distance");
-        break;
-    case MS_TOKEN_COMPARISON_BEYOND:
-        out = msStrdup("ST_Distance");
-        break;
-    case MS_TOKEN_COMPARISON_CONTAINS:
-        out = msStrdup("ST_Contains");
-        break;
-    case MS_TOKEN_COMPARISON_EQUALS:
-        out = msStrdup("ST_Equals");
-        break;
-    case MS_TOKEN_FUNCTION_LENGTH:
-        out = msStrdup("ST_Length");
-        break;
-    case MS_TOKEN_FUNCTION_AREA:
-        out = msStrdup("ST_Area");
-        break;
-    case MS_TOKEN_BINDING_DOUBLE: {
-        char *stresc = msOGRGetQuotedItem(layer, n->tokenval.bindval.item);
-        nOutSize = strlen(stresc)+ + 30;
-        out = (char *)msSmallMalloc(nOutSize);
 
-        char md_item_name[256];
-        snprintf( md_item_name, sizeof(md_item_name), "gml_%s_type",
-                  n->tokenval.bindval.item );
-        const char* type = msLookupHashTable(&(layer->metadata), md_item_name);
-        // Do not cast if the variable is of the appropriate type as it can
-        // prevent using database indexes, such as for SQlite
-        if( type != NULL && (EQUAL(type, "Integer") ||
-                             EQUAL(type, "Long") ||
-                             EQUAL(type, "Real")) )
-        {
-             snprintf(out, nOutSize, "%s", stresc);
-        }
-        else
-        {
-            const char *SQLtype = "float(16)";
-            if (EQUAL(info->dialect, "Spatialite") || EQUAL(info->dialect, "GPKG"))
-                SQLtype = "REAL";
-            else if (EQUAL(info->dialect, "PostgreSQL"))
-                SQLtype = "double precision";
-            snprintf(out, nOutSize, "CAST(%s AS %s)", stresc, SQLtype);
-        }
-        msFree(stresc);
+    const size_t regex_len = strlen(regex);
+    char *re = (char *)msSmallMalloc(2 * regex_len + 3);
+    size_t i = 0, j = 0;
+    re[j++] = '\'';
+    while (i < regex_len) {
+      char c = regex[i];
+      char c_next = regex[i + 1];
+
+      if (c == '.' && c_next == '*') {
+        i++;
+        c = wild_any;
+      } else if (c == '.')
+        c = wild_one;
+      else if (i == 0 && c == '^') {
+        i++;
+        continue;
+      } else if (c == '$' && c_next == 0) {
         break;
-    }
-    case MS_TOKEN_BINDING_INTEGER: {
-        char *stresc = msOGRGetQuotedItem(layer, n->tokenval.bindval.item);
-        nOutSize = strlen(stresc)+ 20;
-        out = (char *)msSmallMalloc(nOutSize);
-
-        char md_item_name[256];
-        snprintf( md_item_name, sizeof(md_item_name), "gml_%s_type",
-                  n->tokenval.bindval.item );
-        const char* type = msLookupHashTable(&(layer->metadata), md_item_name);
-        // Do not cast if the variable is of the appropriate type as it can
-        // prevent using database indexes, such as for SQlite
-        if( type != NULL && (EQUAL(type, "Integer") ||
-                             EQUAL(type, "Long") ||
-                             EQUAL(type, "Real")) )
-        {
-            snprintf(out, nOutSize, "%s", stresc);
-        }
-        else
-        {
-            snprintf(out, nOutSize, "CAST(%s AS integer)", stresc);
+      } else if (c == '\'') {
+        re[j++] = '\'';
+      } else if (c == '\\') {
+        if (c_next == 0) {
+          break;
         }
-        msFree(stresc);
-        break;
+        i++;
+        c = c_next;
+      }
+
+      re[j++] = c;
+      i++;
     }
-    case MS_TOKEN_BINDING_STRING: {
-        char *stresc = msOGRGetQuotedItem(layer, n->tokenval.bindval.item);
-        nOutSize = strlen(stresc) + 30;
-        out = (char *)msSmallMalloc(nOutSize);
+    re[j++] = '\'';
+    re[j] = '\0';
 
-        char md_item_name[256];
-        snprintf( md_item_name, sizeof(md_item_name), "gml_%s_type",
-                  n->tokenval.bindval.item );
-        const char* type = msLookupHashTable(&(layer->metadata), md_item_name);
-        // Do not cast if the variable is of the appropriate type as it can
-        // prevent using database indexes, such as for SQlite
-        if( type != NULL && EQUAL(type, "Character") )
-        {
-            snprintf(out, nOutSize, "%s", stresc);
-        }
-        else
-        {
-            snprintf(out, nOutSize, "CAST(%s AS text)", stresc);
-        }
-        msFree(stresc);
-        break;
+    nOutSize = 1 + strlen(op) + 1 + strlen(re) + 1;
+    out = (char *)msSmallMalloc(nOutSize);
+    snprintf(out, nOutSize, " %s %s", op, re);
+    msFree(re);
+    msFree(regex);
+    break;
+  }
+  case MS_TOKEN_COMPARISON_INTERSECTS:
+    out = msStrdup("ST_Intersects");
+    break;
+  case MS_TOKEN_COMPARISON_DISJOINT:
+    out = msStrdup("ST_Disjoint");
+    break;
+  case MS_TOKEN_COMPARISON_TOUCHES:
+    out = msStrdup("ST_Touches");
+    break;
+  case MS_TOKEN_COMPARISON_OVERLAPS:
+    out = msStrdup("ST_Overlaps");
+    break;
+  case MS_TOKEN_COMPARISON_CROSSES:
+    out = msStrdup("ST_Crosses");
+    break;
+  case MS_TOKEN_COMPARISON_WITHIN:
+    out = msStrdup("ST_Within");
+    break;
+  case MS_TOKEN_COMPARISON_DWITHIN:
+    out = msStrdup("ST_Distance");
+    break;
+  case MS_TOKEN_COMPARISON_BEYOND:
+    out = msStrdup("ST_Distance");
+    break;
+  case MS_TOKEN_COMPARISON_CONTAINS:
+    out = msStrdup("ST_Contains");
+    break;
+  case MS_TOKEN_COMPARISON_EQUALS:
+    out = msStrdup("ST_Equals");
+    break;
+  case MS_TOKEN_FUNCTION_LENGTH:
+    out = msStrdup("ST_Length");
+    break;
+  case MS_TOKEN_FUNCTION_AREA:
+    out = msStrdup("ST_Area");
+    break;
+  case MS_TOKEN_BINDING_DOUBLE: {
+    char *stresc = msOGRGetQuotedItem(layer, n->tokenval.bindval.item);
+    nOutSize = strlen(stresc) + +30;
+    out = (char *)msSmallMalloc(nOutSize);
+
+    char md_item_name[256];
+    snprintf(md_item_name, sizeof(md_item_name), "gml_%s_type",
+             n->tokenval.bindval.item);
+    const char *type = msLookupHashTable(&(layer->metadata), md_item_name);
+    // Do not cast if the variable is of the appropriate type as it can
+    // prevent using database indexes, such as for SQlite
+    if (type != NULL && (EQUAL(type, "Integer") || EQUAL(type, "Long") ||
+                         EQUAL(type, "Real"))) {
+      snprintf(out, nOutSize, "%s", stresc);
+    } else {
+      const char *SQLtype = "float(16)";
+      if (EQUAL(info->dialect, "Spatialite") || EQUAL(info->dialect, "GPKG"))
+        SQLtype = "REAL";
+      else if (EQUAL(info->dialect, "PostgreSQL"))
+        SQLtype = "double precision";
+      snprintf(out, nOutSize, "CAST(%s AS %s)", stresc, SQLtype);
     }
-    case MS_TOKEN_BINDING_TIME: {
-        // won't get here unless col is parsed as time and they are not
-        char *stresc = msOGRGetQuotedItem(layer, n->tokenval.bindval.item);
-        nOutSize = strlen(stresc)+ 10;
-        out = (char *)msSmallMalloc(nOutSize);
-        snprintf(out, nOutSize, "%s", stresc);
-        msFree(stresc);
-        break;
+    msFree(stresc);
+    break;
+  }
+  case MS_TOKEN_BINDING_INTEGER: {
+    char *stresc = msOGRGetQuotedItem(layer, n->tokenval.bindval.item);
+    nOutSize = strlen(stresc) + 20;
+    out = (char *)msSmallMalloc(nOutSize);
+
+    char md_item_name[256];
+    snprintf(md_item_name, sizeof(md_item_name), "gml_%s_type",
+             n->tokenval.bindval.item);
+    const char *type = msLookupHashTable(&(layer->metadata), md_item_name);
+    // Do not cast if the variable is of the appropriate type as it can
+    // prevent using database indexes, such as for SQlite
+    if (type != NULL && (EQUAL(type, "Integer") || EQUAL(type, "Long") ||
+                         EQUAL(type, "Real"))) {
+      snprintf(out, nOutSize, "%s", stresc);
+    } else {
+      snprintf(out, nOutSize, "CAST(%s AS integer)", stresc);
     }
-    case MS_TOKEN_BINDING_SHAPE: {
-        char *stresc = msOGRGetQuotedItem(layer, OGR_L_GetGeometryColumn(info->hLayer)); // which geom field??
-        nOutSize = strlen(stresc)+ 10;
-        out = (char *)msSmallMalloc(nOutSize);
-        snprintf(out, nOutSize, "%s", stresc);
-        msFree(stresc);
-        break;
+    msFree(stresc);
+    break;
+  }
+  case MS_TOKEN_BINDING_STRING: {
+    char *stresc = msOGRGetQuotedItem(layer, n->tokenval.bindval.item);
+    nOutSize = strlen(stresc) + 30;
+    out = (char *)msSmallMalloc(nOutSize);
+
+    char md_item_name[256];
+    snprintf(md_item_name, sizeof(md_item_name), "gml_%s_type",
+             n->tokenval.bindval.item);
+    const char *type = msLookupHashTable(&(layer->metadata), md_item_name);
+    // Do not cast if the variable is of the appropriate type as it can
+    // prevent using database indexes, such as for SQlite
+    if (type != NULL && EQUAL(type, "Character")) {
+      snprintf(out, nOutSize, "%s", stresc);
+    } else {
+      snprintf(out, nOutSize, "CAST(%s AS text)", stresc);
     }
+    msFree(stresc);
+    break;
+  }
+  case MS_TOKEN_BINDING_TIME: {
+    // won't get here unless col is parsed as time and they are not
+    char *stresc = msOGRGetQuotedItem(layer, n->tokenval.bindval.item);
+    nOutSize = strlen(stresc) + 10;
+    out = (char *)msSmallMalloc(nOutSize);
+    snprintf(out, nOutSize, "%s", stresc);
+    msFree(stresc);
+    break;
+  }
+  case MS_TOKEN_BINDING_SHAPE: {
+    char *stresc = msOGRGetQuotedItem(
+        layer, OGR_L_GetGeometryColumn(info->hLayer)); // which geom field??
+    nOutSize = strlen(stresc) + 10;
+    out = (char *)msSmallMalloc(nOutSize);
+    snprintf(out, nOutSize, "%s", stresc);
+    msFree(stresc);
+    break;
+  }
 
     // unhandled below until default
 
-    case MS_TOKEN_FUNCTION_TOSTRING:
-    case MS_TOKEN_FUNCTION_COMMIFY:
-    case MS_TOKEN_FUNCTION_ROUND:
-    case MS_TOKEN_FUNCTION_FROMTEXT:
-    case MS_TOKEN_FUNCTION_BUFFER:
-    case MS_TOKEN_FUNCTION_DIFFERENCE:
-    case MS_TOKEN_FUNCTION_SIMPLIFY:
-    case MS_TOKEN_FUNCTION_SIMPLIFYPT:
-    case MS_TOKEN_FUNCTION_GENERALIZE:
-    case MS_TOKEN_FUNCTION_SMOOTHSIA:
-    case MS_TOKEN_FUNCTION_JAVASCRIPT:
-    case MS_TOKEN_FUNCTION_UPPER:
-    case MS_TOKEN_FUNCTION_LOWER:
-    case MS_TOKEN_FUNCTION_INITCAP:
-    case MS_TOKEN_FUNCTION_FIRSTCAP:
-    case MS_TOKEN_BINDING_MAP_CELLSIZE:
-    case MS_TOKEN_BINDING_DATA_CELLSIZE:
-    case MS_PARSE_TYPE_BOOLEAN:
-    case MS_PARSE_TYPE_STRING:
-    case MS_PARSE_TYPE_SHAPE:
-        break;
+  case MS_TOKEN_FUNCTION_TOSTRING:
+  case MS_TOKEN_FUNCTION_COMMIFY:
+  case MS_TOKEN_FUNCTION_ROUND:
+  case MS_TOKEN_FUNCTION_FROMTEXT:
+  case MS_TOKEN_FUNCTION_BUFFER:
+  case MS_TOKEN_FUNCTION_DIFFERENCE:
+  case MS_TOKEN_FUNCTION_SIMPLIFY:
+  case MS_TOKEN_FUNCTION_SIMPLIFYPT:
+  case MS_TOKEN_FUNCTION_GENERALIZE:
+  case MS_TOKEN_FUNCTION_SMOOTHSIA:
+  case MS_TOKEN_FUNCTION_JAVASCRIPT:
+  case MS_TOKEN_FUNCTION_UPPER:
+  case MS_TOKEN_FUNCTION_LOWER:
+  case MS_TOKEN_FUNCTION_INITCAP:
+  case MS_TOKEN_FUNCTION_FIRSTCAP:
+  case MS_TOKEN_BINDING_MAP_CELLSIZE:
+  case MS_TOKEN_BINDING_DATA_CELLSIZE:
+  case MS_PARSE_TYPE_BOOLEAN:
+  case MS_PARSE_TYPE_STRING:
+  case MS_PARSE_TYPE_SHAPE:
+    break;
 
-    default:
-        if (n->token < 128) {
-            char c = n->token;
-            out = (char *)msSmallMalloc(2);
-            sprintf(out, "%c", c);
-        }
-        break;
+  default:
+    if (n->token < 128) {
+      char c = n->token;
+      out = (char *)msSmallMalloc(2);
+      sprintf(out, "%c", c);
     }
+    break;
+  }
 
-    n = n->next;
-    *node = n;
-    return out;
+  n = n->next;
+  *node = n;
+  return out;
 }
 
 /*
@@ -2162,39 +2095,37 @@ char *msOGRGetToken(layerObj* layer, tok
  * Returns the content of a SQL ORDER BY clause from the sortBy member of
  * the layer. The string does not contain the "ORDER BY" keywords itself.
  */
-static char* msOGRLayerBuildSQLOrderBy(layerObj *layer, msOGRFileInfo *psInfo)
-{
-  char* strOrderBy = NULL;
-  if( layer->sortBy.nProperties > 0 ) {
+static char *msOGRLayerBuildSQLOrderBy(layerObj *layer, msOGRFileInfo *psInfo) {
+  char *strOrderBy = NULL;
+  if (layer->sortBy.nProperties > 0) {
     int i;
-    for(i=0;i<layer->sortBy.nProperties;i++) {
-      if( i > 0 )
+    for (i = 0; i < layer->sortBy.nProperties; i++) {
+      if (i > 0)
         strOrderBy = msStringConcatenate(strOrderBy, ", ");
-      char* escapedItem = msLayerEscapePropertyName(layer, layer->sortBy.properties[i].item);
-      if( psInfo->pszTablePrefix)
-      {
-          char* escapedTable = msLayerEscapePropertyName(layer, psInfo->pszTablePrefix);
-          strOrderBy = msStringConcatenate(strOrderBy, "\"");
-          strOrderBy = msStringConcatenate(strOrderBy, escapedTable);
-          strOrderBy = msStringConcatenate(strOrderBy, "\".\"");
-          strOrderBy = msStringConcatenate(strOrderBy, escapedItem);
-          strOrderBy = msStringConcatenate(strOrderBy, "\"");
-          msFree(escapedTable);
-      }
-      else
-      {
+      char *escapedItem =
+          msLayerEscapePropertyName(layer, layer->sortBy.properties[i].item);
+      if (psInfo->pszTablePrefix) {
+        char *escapedTable =
+            msLayerEscapePropertyName(layer, psInfo->pszTablePrefix);
+        strOrderBy = msStringConcatenate(strOrderBy, "\"");
+        strOrderBy = msStringConcatenate(strOrderBy, escapedTable);
+        strOrderBy = msStringConcatenate(strOrderBy, "\".\"");
+        strOrderBy = msStringConcatenate(strOrderBy, escapedItem);
+        strOrderBy = msStringConcatenate(strOrderBy, "\"");
+        msFree(escapedTable);
+      } else {
 #if GDAL_VERSION_MAJOR < 2
-          // Old GDAL don't like quoted identifiers in ORDER BY
-          strOrderBy = msStringConcatenate(strOrderBy,
-                                           layer->sortBy.properties[i].item);
+        // Old GDAL don't like quoted identifiers in ORDER BY
+        strOrderBy =
+            msStringConcatenate(strOrderBy, layer->sortBy.properties[i].item);
 #else
-          strOrderBy = msStringConcatenate(strOrderBy, "\"");
-          strOrderBy = msStringConcatenate(strOrderBy, escapedItem);
-          strOrderBy = msStringConcatenate(strOrderBy, "\"");
+        strOrderBy = msStringConcatenate(strOrderBy, "\"");
+        strOrderBy = msStringConcatenate(strOrderBy, escapedItem);
+        strOrderBy = msStringConcatenate(strOrderBy, "\"");
 #endif
       }
       msFree(escapedItem);
-      if( layer->sortBy.properties[i].sortOrder == SORT_DESC )
+      if (layer->sortBy.properties[i].sortOrder == SORT_DESC)
         strOrderBy = msStringConcatenate(strOrderBy, " DESC");
     }
   }
@@ -2209,491 +2140,485 @@ static char* msOGRLayerBuildSQLOrderBy(l
  * Returns MS_SUCCESS/MS_FAILURE, or MS_DONE if no shape matching the
  * layer's FILTER overlaps the selected region.
  **********************************************************************/
-static int msOGRFileWhichShapes(layerObj *layer, rectObj rect, msOGRFileInfo *psInfo)
-{
-    // rect is from BBOX parameter in query (In lieu of a FEATUREID or FILTER) or mapfile somehow
-    if (psInfo == NULL || psInfo->hLayer == NULL) {
-        msSetError(MS_MISCERR, "Assertion failed: OGR layer not opened!!!", "msOGRFileWhichShapes()");
-        return(MS_FAILURE);
-    }
-
-    char *select = (psInfo->pszSelect) ? msStrdup(psInfo->pszSelect) : NULL;
-    const rectObj rectInvalid = MS_INIT_INVALID_RECT;
-    bool bIsValidRect = memcmp(&rect, &rectInvalid, sizeof(rect)) != 0;
-
-    // we'll go strictly two possible ways: 
-    // 1) GetLayer + SetFilter
-    // 2) ExecuteSQL (psInfo->hLayer is an SQL result OR sortBy was requested OR have native_string
-    // and start from the second
-
-    if ( psInfo->bIsOKForSQLCompose && (psInfo->nLayerIndex == -1 ||
-                                        layer->sortBy.nProperties > 0 ||
-                                        layer->filter.native_string ||
-                                        (psInfo->bPaging && layer->maxfeatures > 0)) ) {
-
-        const bool bHasGeometry = 
-                                OGR_L_GetGeomType( psInfo->hLayer ) != wkbNone;
-
-        if( psInfo->nLayerIndex == -1 && select == NULL ) {
-            select = msStrdup(psInfo->pszLayerDef);
-            /* If nLayerIndex == -1 then the layer is an SQL result ... free it */
-            OGR_DS_ReleaseResultSet( psInfo->hDS, psInfo->hLayer );
-            psInfo->hLayer = NULL;
-        }
-        else if( select == NULL ) {
-            const char* pszGeometryColumn;
-            int i;
-            select = msStringConcatenate(select, "SELECT ");
-            for(i = 0; i < layer->numitems; i++) {
-                if( i > 0 )
-                    select = msStringConcatenate(select, ", ");
-                char* escaped = msOGRGetQuotedItem(layer, layer->items[i]);
-                select = msStringConcatenate(select, escaped);
-                msFree(escaped);
-                if( psInfo->pszTablePrefix )
-                {
-                    select = msStringConcatenate(select, " AS \"");
-                    escaped = msLayerEscapePropertyName(layer, layer->items[i]);
-                    select = msStringConcatenate(select, escaped);
-                    msFree(escaped);
-                    select = msStringConcatenate(select, "\"");
-                }
-            }
-            if( layer->numitems > 0 )
-                select = msStringConcatenate(select, ", ");
-            pszGeometryColumn = OGR_L_GetGeometryColumn(psInfo->hLayer);
-            if( pszGeometryColumn != NULL && pszGeometryColumn[0] != '\0' ) {
-                char* escaped = msOGRGetQuotedItem(layer, pszGeometryColumn);
-                select = msStringConcatenate(select, escaped);
-                msFree(escaped);
-                if( psInfo->pszTablePrefix )
-                {
-                    select = msStringConcatenate(select, " AS \"");
-                    escaped = msLayerEscapePropertyName(layer, pszGeometryColumn);
-                    select = msStringConcatenate(select, escaped);
-                    msFree(escaped);
-                    select = msStringConcatenate(select, "\"");
-                }
-            } else {
-                /* Add ", *" so that we still have an hope to get the geometry */
-                if( psInfo->pszTablePrefix )
-                {
-                    select = msStringConcatenate(select, "\"");
-                    char* escaped = msLayerEscapePropertyName(layer, psInfo->pszTablePrefix);
-                    select = msStringConcatenate(select, escaped);
-                    msFree(escaped);
-                    select = msStringConcatenate(select, "\".");
-                }
-                select = msStringConcatenate(select, "*");
-            }
-            select = msStringConcatenate(select, " FROM ");
-            if( psInfo->nLayerIndex == -1 )
-            {
-              select = msStringConcatenate(select, "(");
-              select = msStringConcatenate(select, psInfo->pszLayerDef);
-              select = msStringConcatenate(select, ") MSSUBSELECT");
-            }
-            else
-            {
-              select = msStringConcatenate(select, "\"");
-              char* escaped = msLayerEscapePropertyName(layer, OGR_FD_GetName(OGR_L_GetLayerDefn(psInfo->hLayer)));
-              select = msStringConcatenate(select, escaped);
-              msFree(escaped);
-              select = msStringConcatenate(select, "\"");
-            }
-        }
+static int msOGRFileWhichShapes(layerObj *layer, rectObj rect,
+                                msOGRFileInfo *psInfo) {
+  // rect is from BBOX parameter in query (In lieu of a FEATUREID or FILTER) or
+  // mapfile somehow
+  if (psInfo == NULL || psInfo->hLayer == NULL) {
+    msSetError(MS_MISCERR, "Assertion failed: OGR layer not opened!!!",
+               "msOGRFileWhichShapes()");
+    return (MS_FAILURE);
+  }
 
-        char *filter = NULL;
-        if (msLayerGetProcessingKey(layer, "NATIVE_FILTER") != NULL) {
-            filter = msStringConcatenate(filter, "(");
-            filter = msStringConcatenate(filter, msLayerGetProcessingKey(layer, "NATIVE_FILTER"));
-            filter = msStringConcatenate(filter, ")");
+  char *select = (psInfo->pszSelect) ? msStrdup(psInfo->pszSelect) : NULL;
+  const rectObj rectInvalid = MS_INIT_INVALID_RECT;
+  bool bIsValidRect = memcmp(&rect, &rectInvalid, sizeof(rect)) != 0;
+
+  // we'll go strictly two possible ways:
+  // 1) GetLayer + SetFilter
+  // 2) ExecuteSQL (psInfo->hLayer is an SQL result OR sortBy was requested OR
+  // have native_string and start from the second
+
+  if (psInfo->bIsOKForSQLCompose &&
+      (psInfo->nLayerIndex == -1 || layer->sortBy.nProperties > 0 ||
+       layer->filter.native_string ||
+       (psInfo->bPaging && layer->maxfeatures > 0))) {
+
+    const bool bHasGeometry = OGR_L_GetGeomType(psInfo->hLayer) != wkbNone;
+
+    if (psInfo->nLayerIndex == -1 && select == NULL) {
+      select = msStrdup(psInfo->pszLayerDef);
+      /* If nLayerIndex == -1 then the layer is an SQL result ... free it */
+      OGR_DS_ReleaseResultSet(psInfo->hDS, psInfo->hLayer);
+      psInfo->hLayer = NULL;
+    } else if (select == NULL) {
+      const char *pszGeometryColumn;
+      int i;
+      select = msStringConcatenate(select, "SELECT ");
+      for (i = 0; i < layer->numitems; i++) {
+        if (i > 0)
+          select = msStringConcatenate(select, ", ");
+        char *escaped = msOGRGetQuotedItem(layer, layer->items[i]);
+        select = msStringConcatenate(select, escaped);
+        msFree(escaped);
+        if (psInfo->pszTablePrefix) {
+          select = msStringConcatenate(select, " AS \"");
+          escaped = msLayerEscapePropertyName(layer, layer->items[i]);
+          select = msStringConcatenate(select, escaped);
+          msFree(escaped);
+          select = msStringConcatenate(select, "\"");
+        }
+      }
+      if (layer->numitems > 0)
+        select = msStringConcatenate(select, ", ");
+      pszGeometryColumn = OGR_L_GetGeometryColumn(psInfo->hLayer);
+      if (pszGeometryColumn != NULL && pszGeometryColumn[0] != '\0') {
+        char *escaped = msOGRGetQuotedItem(layer, pszGeometryColumn);
+        select = msStringConcatenate(select, escaped);
+        msFree(escaped);
+        if (psInfo->pszTablePrefix) {
+          select = msStringConcatenate(select, " AS \"");
+          escaped = msLayerEscapePropertyName(layer, pszGeometryColumn);
+          select = msStringConcatenate(select, escaped);
+          msFree(escaped);
+          select = msStringConcatenate(select, "\"");
         }
+      } else {
+        /* Add ", *" so that we still have an hope to get the geometry */
+        if (psInfo->pszTablePrefix) {
+          select = msStringConcatenate(select, "\"");
+          char *escaped =
+              msLayerEscapePropertyName(layer, psInfo->pszTablePrefix);
+          select = msStringConcatenate(select, escaped);
+          msFree(escaped);
+          select = msStringConcatenate(select, "\".");
+        }
+        select = msStringConcatenate(select, "*");
+      }
+      select = msStringConcatenate(select, " FROM ");
+      if (psInfo->nLayerIndex == -1) {
+        select = msStringConcatenate(select, "(");
+        select = msStringConcatenate(select, psInfo->pszLayerDef);
+        select = msStringConcatenate(select, ") MSSUBSELECT");
+      } else {
+        select = msStringConcatenate(select, "\"");
+        char *escaped = msLayerEscapePropertyName(
+            layer, OGR_FD_GetName(OGR_L_GetLayerDefn(psInfo->hLayer)));
+        select = msStringConcatenate(select, escaped);
+        msFree(escaped);
+        select = msStringConcatenate(select, "\"");
+      }
+    }
 
-        /* ------------------------------------------------------------------
-         * Set Spatial filter... this may result in no features being returned
-         * if layer does not overlap current view.
-         *
-         * __TODO__ We should return MS_DONE if no shape overlaps the selected
-         * region and matches the layer's FILTER expression, but there is currently
-         * no _efficient_ way to do that with OGR.
-         * ------------------------------------------------------------------ */
-        if (psInfo->rect_is_defined) {
-            rect.minx = MAX(psInfo->rect.minx, rect.minx);
-            rect.miny = MAX(psInfo->rect.miny, rect.miny);
-            rect.maxx = MIN(psInfo->rect.maxx, rect.maxx);
-            rect.maxy = MIN(psInfo->rect.maxy, rect.maxy);
-            bIsValidRect = true;
-        }
-        psInfo->rect = rect;
+    char *filter = NULL;
+    if (msLayerGetProcessingKey(layer, "NATIVE_FILTER") != NULL) {
+      filter = msStringConcatenate(filter, "(");
+      filter = msStringConcatenate(
+          filter, msLayerGetProcessingKey(layer, "NATIVE_FILTER"));
+      filter = msStringConcatenate(filter, ")");
+    }
 
-        bool bSpatialiteOrGPKGAddOrderByFID = false;
+    /* ------------------------------------------------------------------
+     * Set Spatial filter... this may result in no features being returned
+     * if layer does not overlap current view.
+     *
+     * __TODO__ We should return MS_DONE if no shape overlaps the selected
+     * region and matches the layer's FILTER expression, but there is currently
+     * no _efficient_ way to do that with OGR.
+     * ------------------------------------------------------------------ */
+    if (psInfo->rect_is_defined) {
+      rect.minx = MAX(psInfo->rect.minx, rect.minx);
+      rect.miny = MAX(psInfo->rect.miny, rect.miny);
+      rect.maxx = MIN(psInfo->rect.maxx, rect.maxx);
+      rect.maxy = MIN(psInfo->rect.maxy, rect.maxy);
+      bIsValidRect = true;
+    }
+    psInfo->rect = rect;
+
+    bool bSpatialiteOrGPKGAddOrderByFID = false;
+
+    const char *sql = layer->filter.native_string;
+    if (psInfo->dialect && sql && *sql != '\0' &&
+        (EQUAL(psInfo->dialect, "Spatialite") ||
+         EQUAL(psInfo->dialect, "GPKG") ||
+         EQUAL(psInfo->dialect, "PostgreSQL"))) {
+      if (filter)
+        filter = msStringConcatenate(filter, " AND ");
+      filter = msStringConcatenate(filter, "(");
+      filter = msStringConcatenate(filter, sql);
+      filter = msStringConcatenate(filter, ")");
+    } else if (psInfo->pszWHERE) {
+      if (filter)
+        filter = msStringConcatenate(filter, " AND ");
+      filter = msStringConcatenate(filter, "(");
+      filter = msStringConcatenate(filter, psInfo->pszWHERE);
+      filter = msStringConcatenate(filter, ")");
+    }
+
+    // use spatial index
+    if (psInfo->dialect && bIsValidRect) {
+      if (EQUAL(psInfo->dialect, "PostgreSQL")) {
+        if (filter)
+          filter = msStringConcatenate(filter, " AND");
+        const char *col =
+            OGR_L_GetGeometryColumn(psInfo->hLayer); // which geom field??
+        filter = msStringConcatenate(filter, " (\"");
+        char *escaped = msLayerEscapePropertyName(layer, col);
+        filter = msStringConcatenate(filter, escaped);
+        msFree(escaped);
+        filter = msStringConcatenate(filter, "\" && ST_MakeEnvelope(");
+        char *points = (char *)msSmallMalloc(30 * 2 * 5);
+        snprintf(points, 30 * 4, "%lf,%lf,%lf,%lf", rect.minx, rect.miny,
+                 rect.maxx, rect.maxy);
+        filter = msStringConcatenate(filter, points);
+        msFree(points);
+        filter = msStringConcatenate(filter, "))");
+      } else if (psInfo->dialect &&
+                 (EQUAL(psInfo->dialect, "Spatialite") ||
+                  EQUAL(psInfo->dialect, "GPKG")) &&
+                 psInfo->pszMainTableName != NULL) {
+        if ((EQUAL(psInfo->dialect, "Spatialite") &&
+             psInfo->bHasSpatialIndex) ||
+            EQUAL(psInfo->dialect, "GPKG")) {
+          if (filter)
+            filter = msStringConcatenate(filter, " AND ");
+          char *pszEscapedMainTableName =
+              msLayerEscapePropertyName(layer, psInfo->pszMainTableName);
+          filter = msStringConcatenate(filter, "\"");
+          filter = msStringConcatenate(filter, pszEscapedMainTableName);
+          msFree(pszEscapedMainTableName);
+          filter = msStringConcatenate(filter, "\".");
+          if (psInfo->pszRowId) {
+            char *pszEscapedRowId =
+                msLayerEscapePropertyName(layer, psInfo->pszRowId);
+            filter = msStringConcatenate(filter, "\"");
+            filter = msStringConcatenate(filter, pszEscapedRowId);
+            filter = msStringConcatenate(filter, "\"");
+            msFree(pszEscapedRowId);
+          } else
+            filter = msStringConcatenate(filter, "ROWID");
+
+          filter = msStringConcatenate(filter, " IN ");
+          filter = msStringConcatenate(filter, "(");
+          filter = msStringConcatenate(filter, "SELECT ");
 
-        const char *sql = layer->filter.native_string;
-        if (psInfo->dialect && sql && *sql != '\0' &&
-            (EQUAL(psInfo->dialect, "Spatialite") ||
-             EQUAL(psInfo->dialect, "GPKG") ||
-             EQUAL(psInfo->dialect, "PostgreSQL")) )
-        {
-            if (filter) filter = msStringConcatenate(filter, " AND ");
-            filter = msStringConcatenate(filter, "(");
-            filter = msStringConcatenate(filter, sql);
-            filter = msStringConcatenate(filter, ")");
-        }
-        else if( psInfo->pszWHERE )
-        {
-            if (filter) filter = msStringConcatenate(filter, " AND ");
-            filter = msStringConcatenate(filter, "(");
-            filter = msStringConcatenate(filter, psInfo->pszWHERE);
-            filter = msStringConcatenate(filter, ")");
-        }
+          if (EQUAL(psInfo->dialect, "Spatialite"))
+            filter = msStringConcatenate(filter, "ms_spat_idx.pkid");
+          else
+            filter = msStringConcatenate(filter, "ms_spat_idx.id");
 
-        // use spatial index
-        if (psInfo->dialect && bIsValidRect ) {
-            if (EQUAL(psInfo->dialect, "PostgreSQL")) {
-                if (filter) filter = msStringConcatenate(filter, " AND");
-                const char *col = OGR_L_GetGeometryColumn(psInfo->hLayer); // which geom field??
-                filter = msStringConcatenate(filter, " (\"");
-                char* escaped = msLayerEscapePropertyName(layer, col);
-                filter = msStringConcatenate(filter, escaped);
-                msFree(escaped);
-                filter = msStringConcatenate(filter, "\" && ST_MakeEnvelope(");
-                char *points = (char *)msSmallMalloc(30*2*5);
-                snprintf(points, 30*4, "%lf,%lf,%lf,%lf", rect.minx, rect.miny, rect.maxx, rect.maxy);
-                filter = msStringConcatenate(filter, points);
-                msFree(points);
-                filter = msStringConcatenate(filter, "))");
-            }
-            else if( psInfo->dialect &&
-                     (EQUAL(psInfo->dialect, "Spatialite") ||
-                      EQUAL(psInfo->dialect, "GPKG")) &&
-                     psInfo->pszMainTableName != NULL )
-            {
-                if( (EQUAL(psInfo->dialect, "Spatialite") && psInfo->bHasSpatialIndex)
-                      || EQUAL(psInfo->dialect, "GPKG") )
-                {
-                    if (filter) filter = msStringConcatenate(filter, " AND ");
-                    char* pszEscapedMainTableName = msLayerEscapePropertyName(
-                                                    layer, psInfo->pszMainTableName);
-                    filter = msStringConcatenate(filter, "\"");
-                    filter = msStringConcatenate(filter, pszEscapedMainTableName);
-                    msFree(pszEscapedMainTableName);
-                    filter = msStringConcatenate(filter, "\".");
-                    if( psInfo->pszRowId )
-                    {
-                        char* pszEscapedRowId = msLayerEscapePropertyName(
-                                                            layer, psInfo->pszRowId);
-                        filter = msStringConcatenate(filter, "\"");
-                        filter = msStringConcatenate(filter, pszEscapedRowId);
-                        filter = msStringConcatenate(filter, "\"");
-                        msFree(pszEscapedRowId);
-                    }
-                    else
-                        filter = msStringConcatenate(filter, "ROWID");
-                    
-                    filter = msStringConcatenate(filter, " IN ");
-                    filter = msStringConcatenate(filter, "(");
-                    filter = msStringConcatenate(filter, "SELECT ");
-
-                    if( EQUAL(psInfo->dialect, "Spatialite") )
-                        filter = msStringConcatenate(filter, "ms_spat_idx.pkid");
-                    else
-                        filter = msStringConcatenate(filter, "ms_spat_idx.id");
-
-                    filter = msStringConcatenate(filter, " FROM ");
-
-                    char szSpatialIndexName[256];
-                    snprintf( szSpatialIndexName, sizeof(szSpatialIndexName),
-                                "%s_%s_%s",
-                                EQUAL(psInfo->dialect, "Spatialite") ? "idx" : "rtree",
-                                psInfo->pszSpatialFilterTableName,
-                                psInfo->pszSpatialFilterGeometryColumn );
-                    char* pszEscapedSpatialIndexName = msLayerEscapePropertyName(
-                                                    layer, szSpatialIndexName);
-
-                    filter = msStringConcatenate(filter, "\"");
-                    filter = msStringConcatenate(filter, pszEscapedSpatialIndexName);
-                    msFree(pszEscapedSpatialIndexName);
-                    
-                    filter = msStringConcatenate(filter, "\" ms_spat_idx WHERE ");
-
-                    char szCond[256];
-                    if( EQUAL(psInfo->dialect, "Spatialite") )
-                    {
-                        snprintf(szCond, sizeof(szCond),
-                                "ms_spat_idx.xmin <= %.15g AND ms_spat_idx.xmax >= %.15g AND "
-                                "ms_spat_idx.ymin <= %.15g AND ms_spat_idx.ymax >= %.15g",
-                                rect.maxx, rect.minx, rect.maxy, rect.miny);
-                    }
-                    else
-                    {
-                        snprintf(szCond, sizeof(szCond),
-                                "ms_spat_idx.minx <= %.15g AND ms_spat_idx.maxx >= %.15g AND "
-                                "ms_spat_idx.miny <= %.15g AND ms_spat_idx.maxy >= %.15g",
-                                rect.maxx, rect.minx, rect.maxy, rect.miny);
-                    }
-                    filter = msStringConcatenate(filter, szCond);
-        
-                    filter = msStringConcatenate(filter, ")");
-
-                    bSpatialiteOrGPKGAddOrderByFID = true;
-                }
-
-                const bool isGPKG = EQUAL(psInfo->dialect, "GPKG");
-                if (filter) filter = msStringConcatenate(filter, " AND");
-                const char *col = OGR_L_GetGeometryColumn(psInfo->hLayer); // which geom field??
-                filter = msStringConcatenate(filter, " Intersects(");
-                if( isGPKG )
-                {
-                    // Casting GeoPackage geometries to spatialie ones is done
-                    // automatically normally, since GDAL enables the
-                    // "amphibious" mode, but without it
-                    // explicilty specified, spatialite 4.3.0a does an
-                    // out-of-bounds access.
-                    filter = msStringConcatenate(filter, "GeomFromGPB(");
-                }
-                filter = msStringConcatenate(filter, "\"");
-                char* escaped = msLayerEscapePropertyName(layer, col);
-                filter = msStringConcatenate(filter, escaped);
-                msFree(escaped);
-                filter = msStringConcatenate(filter, "\"");
-                if( isGPKG )
-                    filter = msStringConcatenate(filter, ")");
-                char *points = (char *)msSmallMalloc(30*2*5);
-                if( rect.minx == rect.maxx && rect.miny == rect.maxy ) {
-                  filter = msStringConcatenate(filter, ",  ST_GeomFromText(");
-                  snprintf(points, 30*4, "'POINT(%lf %lf)'", rect.minx, rect.miny);
-                } else {
-                  filter = msStringConcatenate(filter, ", BuildMbr(");
-                  snprintf(points, 30*4, "%lf,%lf,%lf,%lf", rect.minx, rect.miny, rect.maxx, rect.maxy);
-                }
-                filter = msStringConcatenate(filter, points);
-                msFree(points);
-                filter = msStringConcatenate(filter, "))");
-            }
-        }
+          filter = msStringConcatenate(filter, " FROM ");
 
-        /* get sortBy */
-        char *sort = NULL;
-        if( layer->sortBy.nProperties > 0) {
-
-            char *strOrderBy = msOGRLayerBuildSQLOrderBy(layer, psInfo);
-            if (strOrderBy) {
-                if( psInfo->nLayerIndex == -1 ) {
-                    if( strcasestr(psInfo->pszLayerDef, " ORDER BY ") == NULL )
-                        sort = msStringConcatenate(sort, " ORDER BY ");
-                    else
-                        sort = msStringConcatenate(sort, ", ");
-                } else {
-                    sort = msStringConcatenate(sort, " ORDER BY ");
-                }
-                sort = msStringConcatenate(sort, strOrderBy);
-                msFree(strOrderBy);
-            }
-        }
+          char szSpatialIndexName[256];
+          snprintf(szSpatialIndexName, sizeof(szSpatialIndexName), "%s_%s_%s",
+                   EQUAL(psInfo->dialect, "Spatialite") ? "idx" : "rtree",
+                   psInfo->pszSpatialFilterTableName,
+                   psInfo->pszSpatialFilterGeometryColumn);
+          char *pszEscapedSpatialIndexName =
+              msLayerEscapePropertyName(layer, szSpatialIndexName);
+
+          filter = msStringConcatenate(filter, "\"");
+          filter = msStringConcatenate(filter, pszEscapedSpatialIndexName);
+          msFree(pszEscapedSpatialIndexName);
+
+          filter = msStringConcatenate(filter, "\" ms_spat_idx WHERE ");
+
+          char szCond[256];
+          if (EQUAL(psInfo->dialect, "Spatialite")) {
+            snprintf(
+                szCond, sizeof(szCond),
+                "ms_spat_idx.xmin <= %.15g AND ms_spat_idx.xmax >= %.15g AND "
+                "ms_spat_idx.ymin <= %.15g AND ms_spat_idx.ymax >= %.15g",
+                rect.maxx, rect.minx, rect.maxy, rect.miny);
+          } else {
+            snprintf(
+                szCond, sizeof(szCond),
+                "ms_spat_idx.minx <= %.15g AND ms_spat_idx.maxx >= %.15g AND "
+                "ms_spat_idx.miny <= %.15g AND ms_spat_idx.maxy >= %.15g",
+                rect.maxx, rect.minx, rect.maxy, rect.miny);
+          }
+          filter = msStringConcatenate(filter, szCond);
 
-        if( bSpatialiteOrGPKGAddOrderByFID )
-        {
-            if( sort == NULL )
-                sort = msStringConcatenate(NULL, " ORDER BY ");
-            else
-                sort = msStringConcatenate(sort, ", ");
-            char* pszEscapedMainTableName = msLayerEscapePropertyName(
-                                            layer, psInfo->pszMainTableName);
-            sort = msStringConcatenate(sort, "\"");
-            sort = msStringConcatenate(sort, pszEscapedMainTableName);
-            sort = msStringConcatenate(sort, "\".");
-            msFree(pszEscapedMainTableName);
-            if( psInfo->pszRowId )
-            {
-                char* pszEscapedRowId = msLayerEscapePropertyName(
-                                                    layer, psInfo->pszRowId);
-                sort = msStringConcatenate(sort, "\"");
-                sort = msStringConcatenate(sort, pszEscapedRowId);
-                sort = msStringConcatenate(sort, "\"");
-                msFree(pszEscapedRowId);
-            }
-            else
-                sort = msStringConcatenate(sort, "ROWID");
-        }
+          filter = msStringConcatenate(filter, ")");
 
-        // compose SQL
-        if (filter) {
-            select = msStringConcatenate(select, " WHERE ");
-            select = msStringConcatenate(select, filter);
-            msFree(filter);
-        }
-        if (sort) {
-            select = msStringConcatenate(select, " ");
-            select = msStringConcatenate(select, sort);
-            msFree(sort);
+          bSpatialiteOrGPKGAddOrderByFID = true;
         }
 
-        if ( psInfo->bPaging && layer->maxfeatures >= 0 ) {
-            char szLimit[50];
-            snprintf(szLimit, sizeof(szLimit), " LIMIT %d", layer->maxfeatures);
-            select = msStringConcatenate(select, szLimit);
+        const bool isGPKG = EQUAL(psInfo->dialect, "GPKG");
+        if (filter)
+          filter = msStringConcatenate(filter, " AND");
+        const char *col =
+            OGR_L_GetGeometryColumn(psInfo->hLayer); // which geom field??
+        filter = msStringConcatenate(filter, " Intersects(");
+        if (isGPKG) {
+          // Casting GeoPackage geometries to spatialie ones is done
+          // automatically normally, since GDAL enables the
+          // "amphibious" mode, but without it
+          // explicilty specified, spatialite 4.3.0a does an
+          // out-of-bounds access.
+          filter = msStringConcatenate(filter, "GeomFromGPB(");
+        }
+        filter = msStringConcatenate(filter, "\"");
+        char *escaped = msLayerEscapePropertyName(layer, col);
+        filter = msStringConcatenate(filter, escaped);
+        msFree(escaped);
+        filter = msStringConcatenate(filter, "\"");
+        if (isGPKG)
+          filter = msStringConcatenate(filter, ")");
+        char *points = (char *)msSmallMalloc(30 * 2 * 5);
+        if (rect.minx == rect.maxx && rect.miny == rect.maxy) {
+          filter = msStringConcatenate(filter, ",  ST_GeomFromText(");
+          snprintf(points, 30 * 4, "'POINT(%lf %lf)'", rect.minx, rect.miny);
+        } else {
+          filter = msStringConcatenate(filter, ", BuildMbr(");
+          snprintf(points, 30 * 4, "%lf,%lf,%lf,%lf", rect.minx, rect.miny,
+                   rect.maxx, rect.maxy);
         }
+        filter = msStringConcatenate(filter, points);
+        msFree(points);
+        filter = msStringConcatenate(filter, "))");
+      }
+    }
+
+    /* get sortBy */
+    char *sort = NULL;
+    if (layer->sortBy.nProperties > 0) {
 
-        if ( psInfo->bPaging && layer->startindex > 0 ) {
-            char szOffset[50];
-            snprintf(szOffset, sizeof(szOffset), " OFFSET %d", layer->startindex-1);
-            select = msStringConcatenate(select, szOffset);
+      char *strOrderBy = msOGRLayerBuildSQLOrderBy(layer, psInfo);
+      if (strOrderBy) {
+        if (psInfo->nLayerIndex == -1) {
+          if (strcasestr(psInfo->pszLayerDef, " ORDER BY ") == NULL)
+            sort = msStringConcatenate(sort, " ORDER BY ");
+          else
+            sort = msStringConcatenate(sort, ", ");
+        } else {
+          sort = msStringConcatenate(sort, " ORDER BY ");
         }
+        sort = msStringConcatenate(sort, strOrderBy);
+        msFree(strOrderBy);
+      }
+    }
 
-        if( layer->debug )
-            msDebug("msOGRFileWhichShapes: SQL = %s.\n", select);
+    if (bSpatialiteOrGPKGAddOrderByFID) {
+      if (sort == NULL)
+        sort = msStringConcatenate(NULL, " ORDER BY ");
+      else
+        sort = msStringConcatenate(sort, ", ");
+      char *pszEscapedMainTableName =
+          msLayerEscapePropertyName(layer, psInfo->pszMainTableName);
+      sort = msStringConcatenate(sort, "\"");
+      sort = msStringConcatenate(sort, pszEscapedMainTableName);
+      sort = msStringConcatenate(sort, "\".");
+      msFree(pszEscapedMainTableName);
+      if (psInfo->pszRowId) {
+        char *pszEscapedRowId =
+            msLayerEscapePropertyName(layer, psInfo->pszRowId);
+        sort = msStringConcatenate(sort, "\"");
+        sort = msStringConcatenate(sort, pszEscapedRowId);
+        sort = msStringConcatenate(sort, "\"");
+        msFree(pszEscapedRowId);
+      } else
+        sort = msStringConcatenate(sort, "ROWID");
+    }
+
+    // compose SQL
+    if (filter) {
+      select = msStringConcatenate(select, " WHERE ");
+      select = msStringConcatenate(select, filter);
+      msFree(filter);
+    }
+    if (sort) {
+      select = msStringConcatenate(select, " ");
+      select = msStringConcatenate(select, sort);
+      msFree(sort);
+    }
+
+    if (psInfo->bPaging && layer->maxfeatures >= 0) {
+      char szLimit[50];
+      snprintf(szLimit, sizeof(szLimit), " LIMIT %d", layer->maxfeatures);
+      select = msStringConcatenate(select, szLimit);
+    }
+
+    if (psInfo->bPaging && layer->startindex > 0) {
+      char szOffset[50];
+      snprintf(szOffset, sizeof(szOffset), " OFFSET %d", layer->startindex - 1);
+      select = msStringConcatenate(select, szOffset);
+    }
 
-        ACQUIRE_OGR_LOCK;
-        if( psInfo->nLayerIndex == -1 && psInfo->hLayer != NULL )
-        {
-          OGR_DS_ReleaseResultSet( psInfo->hDS, psInfo->hLayer );
-        }
+    if (layer->debug)
+      msDebug("msOGRFileWhichShapes: SQL = %s.\n", select);
 
-        OGRGeometryH hGeom = NULL;
-        if( psInfo->dialect == NULL &&
-            bHasGeometry && bIsValidRect ) {
-            if (rect.minx == rect.maxx && rect.miny == rect.maxy) {
-                hGeom = OGR_G_CreateGeometry( wkbPoint );
-                OGR_G_SetPoint_2D( hGeom, 0, rect.minx, rect.miny );
-            } else if (rect.minx == rect.maxx || rect.miny == rect.maxy) {
-                hGeom = OGR_G_CreateGeometry( wkbLineString );
-                OGR_G_AddPoint_2D( hGeom, rect.minx, rect.miny );
-                OGR_G_AddPoint_2D( hGeom, rect.maxx, rect.maxy );
-            } else {
-                hGeom = OGR_G_CreateGeometry( wkbPolygon );
-                OGRGeometryH hRing = OGR_G_CreateGeometry( wkbLinearRing );
-
-                OGR_G_AddPoint_2D( hRing, rect.minx, rect.miny);
-                OGR_G_AddPoint_2D( hRing, rect.maxx, rect.miny);
-                OGR_G_AddPoint_2D( hRing, rect.maxx, rect.maxy);
-                OGR_G_AddPoint_2D( hRing, rect.minx, rect.maxy);
-                OGR_G_AddPoint_2D( hRing, rect.minx, rect.miny);
-                OGR_G_AddGeometryDirectly( hGeom, hRing );
-            }
+    ACQUIRE_OGR_LOCK;
+    if (psInfo->nLayerIndex == -1 && psInfo->hLayer != NULL) {
+      OGR_DS_ReleaseResultSet(psInfo->hDS, psInfo->hLayer);
+    }
 
-            if (layer->debug >= MS_DEBUGLEVEL_VVV)
-            {
-                msDebug("msOGRFileWhichShapes: Setting spatial filter to %.15g %.15g %.15g %.15g\n",
-                        rect.minx, rect.miny, rect.maxx, rect.maxy );
-            }
-        }
+    OGRGeometryH hGeom = NULL;
+    if (psInfo->dialect == NULL && bHasGeometry && bIsValidRect) {
+      if (rect.minx == rect.maxx && rect.miny == rect.maxy) {
+        hGeom = OGR_G_CreateGeometry(wkbPoint);
+        OGR_G_SetPoint_2D(hGeom, 0, rect.minx, rect.miny);
+      } else if (rect.minx == rect.maxx || rect.miny == rect.maxy) {
+        hGeom = OGR_G_CreateGeometry(wkbLineString);
+        OGR_G_AddPoint_2D(hGeom, rect.minx, rect.miny);
+        OGR_G_AddPoint_2D(hGeom, rect.maxx, rect.maxy);
+      } else {
+        hGeom = OGR_G_CreateGeometry(wkbPolygon);
+        OGRGeometryH hRing = OGR_G_CreateGeometry(wkbLinearRing);
 
-        psInfo->hLayer = OGR_DS_ExecuteSQL( psInfo->hDS, select, hGeom, NULL );
-        psInfo->nLayerIndex = -1;
-        if( hGeom != NULL )
-            OGR_G_DestroyGeometry(hGeom);
-
-        if( psInfo->hLayer == NULL ) {
-            RELEASE_OGR_LOCK;
-            msSetError(MS_OGRERR, "ExecuteSQL() failed. Check logs.", "msOGRFileWhichShapes()");
-            msDebug("ExecuteSQL(%s) failed.\n%s\n", select, CPLGetLastErrorMsg());
-            msFree(select);
-            return MS_FAILURE;
-        }
+        OGR_G_AddPoint_2D(hRing, rect.minx, rect.miny);
+        OGR_G_AddPoint_2D(hRing, rect.maxx, rect.miny);
+        OGR_G_AddPoint_2D(hRing, rect.maxx, rect.maxy);
+        OGR_G_AddPoint_2D(hRing, rect.minx, rect.maxy);
+        OGR_G_AddPoint_2D(hRing, rect.minx, rect.miny);
+        OGR_G_AddGeometryDirectly(hGeom, hRing);
+      }
 
-        // Update itemindexes / layer->iteminfo
-        msOGRLayerInitItemInfo(layer);
-    } 
-    else {
+      if (layer->debug >= MS_DEBUGLEVEL_VVV) {
+        msDebug("msOGRFileWhichShapes: Setting spatial filter to %.15g %.15g "
+                "%.15g %.15g\n",
+                rect.minx, rect.miny, rect.maxx, rect.maxy);
+      }
+    }
 
-        // case of 1) GetLayer + SetFilter
+    psInfo->hLayer = OGR_DS_ExecuteSQL(psInfo->hDS, select, hGeom, NULL);
+    psInfo->nLayerIndex = -1;
+    if (hGeom != NULL)
+      OGR_G_DestroyGeometry(hGeom);
 
-        char *pszOGRFilter = NULL;
-        if (msLayerGetProcessingKey(layer, "NATIVE_FILTER") != NULL) {
-            pszOGRFilter = msStringConcatenate(pszOGRFilter, "(");
-            pszOGRFilter = msStringConcatenate(pszOGRFilter, msLayerGetProcessingKey(layer, "NATIVE_FILTER"));
-            pszOGRFilter = msStringConcatenate(pszOGRFilter, ")");
-        }
+    if (psInfo->hLayer == NULL) {
+      RELEASE_OGR_LOCK;
+      msSetError(MS_OGRERR, "ExecuteSQL() failed. Check logs.",
+                 "msOGRFileWhichShapes()");
+      msDebug("ExecuteSQL(%s) failed.\n%s\n", select, CPLGetLastErrorMsg());
+      msFree(select);
+      return MS_FAILURE;
+    }
 
-        if( psInfo->pszWHERE )
-        {
-            if( pszOGRFilter )
-            {
-                pszOGRFilter = msStringConcatenate(pszOGRFilter, " AND (");
-                pszOGRFilter = msStringConcatenate(pszOGRFilter, psInfo->pszWHERE);
-                pszOGRFilter = msStringConcatenate(pszOGRFilter, ")");
-            }
-            else
-            {
-                pszOGRFilter = msStringConcatenate(pszOGRFilter, psInfo->pszWHERE);
-            }
-        }
+    // Update itemindexes / layer->iteminfo
+    msOGRLayerInitItemInfo(layer);
+  } else {
 
-        ACQUIRE_OGR_LOCK;
+    // case of 1) GetLayer + SetFilter
 
-        if( OGR_L_GetGeomType( psInfo->hLayer ) != wkbNone && bIsValidRect ) {
-            if (rect.minx == rect.maxx && rect.miny == rect.maxy) {
-                OGRGeometryH hSpatialFilterPoint = OGR_G_CreateGeometry( wkbPoint );
-
-                OGR_G_SetPoint_2D( hSpatialFilterPoint, 0, rect.minx, rect.miny );    
-                OGR_L_SetSpatialFilter( psInfo->hLayer, hSpatialFilterPoint );
-                OGR_G_DestroyGeometry( hSpatialFilterPoint );
-            } else if (rect.minx == rect.maxx || rect.miny == rect.maxy) {
-                OGRGeometryH hSpatialFilterLine = OGR_G_CreateGeometry( wkbLineString );
-
-                OGR_G_AddPoint_2D( hSpatialFilterLine, rect.minx, rect.miny );
-                OGR_G_AddPoint_2D( hSpatialFilterLine, rect.maxx, rect.maxy );
-                OGR_L_SetSpatialFilter( psInfo->hLayer, hSpatialFilterLine );
-                OGR_G_DestroyGeometry( hSpatialFilterLine );
-            } else {
-                OGRGeometryH hSpatialFilterPolygon = OGR_G_CreateGeometry( wkbPolygon );
-                OGRGeometryH hRing = OGR_G_CreateGeometry( wkbLinearRing );
-
-                OGR_G_AddPoint_2D( hRing, rect.minx, rect.miny);
-                OGR_G_AddPoint_2D( hRing, rect.maxx, rect.miny);
-                OGR_G_AddPoint_2D( hRing, rect.maxx, rect.maxy);
-                OGR_G_AddPoint_2D( hRing, rect.minx, rect.maxy);
-                OGR_G_AddPoint_2D( hRing, rect.minx, rect.miny);
-                OGR_G_AddGeometryDirectly( hSpatialFilterPolygon, hRing );
-                OGR_L_SetSpatialFilter( psInfo->hLayer, hSpatialFilterPolygon );
-                OGR_G_DestroyGeometry( hSpatialFilterPolygon );
-            }
+    char *pszOGRFilter = NULL;
+    if (msLayerGetProcessingKey(layer, "NATIVE_FILTER") != NULL) {
+      pszOGRFilter = msStringConcatenate(pszOGRFilter, "(");
+      pszOGRFilter = msStringConcatenate(
+          pszOGRFilter, msLayerGetProcessingKey(layer, "NATIVE_FILTER"));
+      pszOGRFilter = msStringConcatenate(pszOGRFilter, ")");
+    }
 
-            if (layer->debug >= MS_DEBUGLEVEL_VVV)
-            {
-                msDebug("msOGRFileWhichShapes: Setting spatial filter to %.15g %.15g %.15g %.15g\n", rect.minx, rect.miny, rect.maxx, rect.maxy );
-            }
-        }
+    if (psInfo->pszWHERE) {
+      if (pszOGRFilter) {
+        pszOGRFilter = msStringConcatenate(pszOGRFilter, " AND (");
+        pszOGRFilter = msStringConcatenate(pszOGRFilter, psInfo->pszWHERE);
+        pszOGRFilter = msStringConcatenate(pszOGRFilter, ")");
+      } else {
+        pszOGRFilter = msStringConcatenate(pszOGRFilter, psInfo->pszWHERE);
+      }
+    }
 
-        psInfo->rect = rect;
+    ACQUIRE_OGR_LOCK;
 
-        /* ------------------------------------------------------------------
-         * Apply an attribute filter if we have one prefixed with a WHERE
-         * keyword in the filter string.  Otherwise, ensure the attribute
-         * filter is clear.
-         * ------------------------------------------------------------------ */
-        if( pszOGRFilter != NULL ) {
-
-            if (layer->debug >= MS_DEBUGLEVEL_VVV)
-                msDebug("msOGRFileWhichShapes: Setting attribute filter to %s\n", pszOGRFilter );
-
-            CPLErrorReset();
-            if( OGR_L_SetAttributeFilter( psInfo->hLayer, pszOGRFilter ) != OGRERR_NONE ) {
-                msSetError(MS_OGRERR, "SetAttributeFilter() failed on layer %s. Check logs.", "msOGRFileWhichShapes()", layer->name?layer->name:"(null)");
-                msDebug("SetAttributeFilter(%s) failed on layer %s.\n%s\n", pszOGRFilter, layer->name?layer->name:"(null)", CPLGetLastErrorMsg() );
-                RELEASE_OGR_LOCK;
-                msFree(pszOGRFilter);
-                msFree(select);
-                return MS_FAILURE;
-            }
-            msFree(pszOGRFilter);
-        } else
-            OGR_L_SetAttributeFilter( psInfo->hLayer, NULL );
-        
+    if (OGR_L_GetGeomType(psInfo->hLayer) != wkbNone && bIsValidRect) {
+      if (rect.minx == rect.maxx && rect.miny == rect.maxy) {
+        OGRGeometryH hSpatialFilterPoint = OGR_G_CreateGeometry(wkbPoint);
+
+        OGR_G_SetPoint_2D(hSpatialFilterPoint, 0, rect.minx, rect.miny);
+        OGR_L_SetSpatialFilter(psInfo->hLayer, hSpatialFilterPoint);
+        OGR_G_DestroyGeometry(hSpatialFilterPoint);
+      } else if (rect.minx == rect.maxx || rect.miny == rect.maxy) {
+        OGRGeometryH hSpatialFilterLine = OGR_G_CreateGeometry(wkbLineString);
+
+        OGR_G_AddPoint_2D(hSpatialFilterLine, rect.minx, rect.miny);
+        OGR_G_AddPoint_2D(hSpatialFilterLine, rect.maxx, rect.maxy);
+        OGR_L_SetSpatialFilter(psInfo->hLayer, hSpatialFilterLine);
+        OGR_G_DestroyGeometry(hSpatialFilterLine);
+      } else {
+        OGRGeometryH hSpatialFilterPolygon = OGR_G_CreateGeometry(wkbPolygon);
+        OGRGeometryH hRing = OGR_G_CreateGeometry(wkbLinearRing);
+
+        OGR_G_AddPoint_2D(hRing, rect.minx, rect.miny);
+        OGR_G_AddPoint_2D(hRing, rect.maxx, rect.miny);
+        OGR_G_AddPoint_2D(hRing, rect.maxx, rect.maxy);
+        OGR_G_AddPoint_2D(hRing, rect.minx, rect.maxy);
+        OGR_G_AddPoint_2D(hRing, rect.minx, rect.miny);
+        OGR_G_AddGeometryDirectly(hSpatialFilterPolygon, hRing);
+        OGR_L_SetSpatialFilter(psInfo->hLayer, hSpatialFilterPolygon);
+        OGR_G_DestroyGeometry(hSpatialFilterPolygon);
+      }
+
+      if (layer->debug >= MS_DEBUGLEVEL_VVV) {
+        msDebug("msOGRFileWhichShapes: Setting spatial filter to %.15g %.15g "
+                "%.15g %.15g\n",
+                rect.minx, rect.miny, rect.maxx, rect.maxy);
+      }
     }
 
-    msFree(select);
+    psInfo->rect = rect;
 
     /* ------------------------------------------------------------------
-     * Reset current feature pointer
+     * Apply an attribute filter if we have one prefixed with a WHERE
+     * keyword in the filter string.  Otherwise, ensure the attribute
+     * filter is clear.
      * ------------------------------------------------------------------ */
-    OGR_L_ResetReading( psInfo->hLayer );
-    psInfo->last_record_index_read = -1;
-    
-    RELEASE_OGR_LOCK;
-  
-    return MS_SUCCESS;
+    if (pszOGRFilter != NULL) {
+
+      if (layer->debug >= MS_DEBUGLEVEL_VVV)
+        msDebug("msOGRFileWhichShapes: Setting attribute filter to %s\n",
+                pszOGRFilter);
+
+      CPLErrorReset();
+      if (OGR_L_SetAttributeFilter(psInfo->hLayer, pszOGRFilter) !=
+          OGRERR_NONE) {
+        msSetError(
+            MS_OGRERR, "SetAttributeFilter() failed on layer %s. Check logs.",
+            "msOGRFileWhichShapes()", layer->name ? layer->name : "(null)");
+        msDebug("SetAttributeFilter(%s) failed on layer %s.\n%s\n",
+                pszOGRFilter, layer->name ? layer->name : "(null)",
+                CPLGetLastErrorMsg());
+        RELEASE_OGR_LOCK;
+        msFree(pszOGRFilter);
+        msFree(select);
+        return MS_FAILURE;
+      }
+      msFree(pszOGRFilter);
+    } else
+      OGR_L_SetAttributeFilter(psInfo->hLayer, NULL);
+  }
+
+  msFree(select);
+
+  /* ------------------------------------------------------------------
+   * Reset current feature pointer
+   * ------------------------------------------------------------------ */
+  OGR_L_ResetReading(psInfo->hLayer);
+  psInfo->last_record_index_read = -1;
+
+  RELEASE_OGR_LOCK;
+
+  return MS_SUCCESS;
 }
 
 /**********************************************************************
@@ -2704,69 +2629,70 @@ static int msOGRFileWhichShapes(layerObj
  * defining fields.
  **********************************************************************/
 
-static void
-msOGRPassThroughFieldDefinitions( layerObj *layer, msOGRFileInfo *psInfo )
+static void msOGRPassThroughFieldDefinitions(layerObj *layer,
+                                             msOGRFileInfo *psInfo)
 
 {
-  OGRFeatureDefnH hDefn = OGR_L_GetLayerDefn( psInfo->hLayer );
+  OGRFeatureDefnH hDefn = OGR_L_GetLayerDefn(psInfo->hLayer);
   int numitems, i;
 
-  numitems = OGR_FD_GetFieldCount( hDefn );
+  numitems = OGR_FD_GetFieldCount(hDefn);
 
-  for(i=0; i<numitems; i++) {
-    OGRFieldDefnH hField = OGR_FD_GetFieldDefn( hDefn, i );
+  for (i = 0; i < numitems; i++) {
+    OGRFieldDefnH hField = OGR_FD_GetFieldDefn(hDefn, i);
     char gml_width[32], gml_precision[32];
     const char *gml_type = NULL;
-    const char *item = OGR_Fld_GetNameRef( hField );
+    const char *item = OGR_Fld_GetNameRef(hField);
 
     gml_width[0] = '\0';
     gml_precision[0] = '\0';
 
-    switch( OGR_Fld_GetType( hField ) ) {
-      case OFTInteger:
-        gml_type = "Integer";
-        if( OGR_Fld_GetWidth( hField) > 0 )
-          sprintf( gml_width, "%d", OGR_Fld_GetWidth( hField) );
-        break;
+    switch (OGR_Fld_GetType(hField)) {
+    case OFTInteger:
+      gml_type = "Integer";
+      if (OGR_Fld_GetWidth(hField) > 0)
+        sprintf(gml_width, "%d", OGR_Fld_GetWidth(hField));
+      break;
 
 #if GDAL_VERSION_MAJOR >= 2
-      case OFTInteger64:
-        gml_type = "Long";
-        if( OGR_Fld_GetWidth( hField) > 0 )
-          sprintf( gml_width, "%d", OGR_Fld_GetWidth( hField) );
-        break;
+    case OFTInteger64:
+      gml_type = "Long";
+      if (OGR_Fld_GetWidth(hField) > 0)
+        sprintf(gml_width, "%d", OGR_Fld_GetWidth(hField));
+      break;
 #endif
 
-      case OFTReal:
-        gml_type = "Real";
-        if( OGR_Fld_GetWidth( hField) > 0 )
-          sprintf( gml_width, "%d", OGR_Fld_GetWidth( hField) );
-        if( OGR_Fld_GetPrecision( hField ) > 0 )
-          sprintf( gml_precision, "%d", OGR_Fld_GetPrecision( hField) );
-        break;
+    case OFTReal:
+      gml_type = "Real";
+      if (OGR_Fld_GetWidth(hField) > 0)
+        sprintf(gml_width, "%d", OGR_Fld_GetWidth(hField));
+      if (OGR_Fld_GetPrecision(hField) > 0)
+        sprintf(gml_precision, "%d", OGR_Fld_GetPrecision(hField));
+      break;
 
-      case OFTString:
-        gml_type = "Character";
-        if( OGR_Fld_GetWidth( hField) > 0 )
-          sprintf( gml_width, "%d", OGR_Fld_GetWidth( hField) );
-        break;
+    case OFTString:
+      gml_type = "Character";
+      if (OGR_Fld_GetWidth(hField) > 0)
+        sprintf(gml_width, "%d", OGR_Fld_GetWidth(hField));
+      break;
 
-      case OFTDate:
-        gml_type = "Date";
-        break;
-      case OFTTime:
-        gml_type = "Time";
-        break;
-      case OFTDateTime:
-        gml_type = "DateTime";
-        break;
+    case OFTDate:
+      gml_type = "Date";
+      break;
+    case OFTTime:
+      gml_type = "Time";
+      break;
+    case OFTDateTime:
+      gml_type = "DateTime";
+      break;
 
-      default:
-        gml_type = "Character";
-        break;
+    default:
+      gml_type = "Character";
+      break;
     }
 
-    msUpdateGMLFieldMetadata(layer, item, gml_type, gml_width, gml_precision, 0);
+    msUpdateGMLFieldMetadata(layer, item, gml_type, gml_width, gml_precision,
+                             0);
   }
 
   /* Should we try to address style items, or other special items? */
@@ -2777,70 +2703,68 @@ msOGRPassThroughFieldDefinitions( layerO
  *
  * Returns a list of field names in a NULL terminated list of strings.
  **********************************************************************/
-static char **msOGRFileGetItems(layerObj *layer, msOGRFileInfo *psInfo )
-{
+static char **msOGRFileGetItems(layerObj *layer, msOGRFileInfo *psInfo) {
   OGRFeatureDefnH hDefn;
-  int i, numitems,totalnumitems;
+  int i, numitems, totalnumitems;
   int numStyleItems = MSOGR_LABELNUMITEMS;
   char **items;
   const char *getShapeStyleItems, *value;
 
-  if((hDefn = OGR_L_GetLayerDefn( psInfo->hLayer )) == NULL) {
+  if ((hDefn = OGR_L_GetLayerDefn(psInfo->hLayer)) == NULL) {
     msSetError(MS_OGRERR,
                "OGR Connection for layer `%s' contains no field definition.",
-               "msOGRFileGetItems()",
-               layer->name?layer->name:"(null)" );
+               "msOGRFileGetItems()", layer->name ? layer->name : "(null)");
     return NULL;
   }
 
-  totalnumitems = numitems = OGR_FD_GetFieldCount( hDefn );
+  totalnumitems = numitems = OGR_FD_GetFieldCount(hDefn);
 
-  getShapeStyleItems = msLayerGetProcessingKey( layer, "GETSHAPE_STYLE_ITEMS" );
+  getShapeStyleItems = msLayerGetProcessingKey(layer, "GETSHAPE_STYLE_ITEMS");
   if (getShapeStyleItems && EQUAL(getShapeStyleItems, "all"))
     totalnumitems += numStyleItems;
 
-  if((items = (char**)malloc(sizeof(char *)*(totalnumitems+1))) == NULL) {
+  if ((items = (char **)malloc(sizeof(char *) * (totalnumitems + 1))) == NULL) {
     msSetError(MS_MEMERR, NULL, "msOGRFileGetItems()");
     return NULL;
   }
 
-  for(i=0; i<numitems; i++) {
-    OGRFieldDefnH hField = OGR_FD_GetFieldDefn( hDefn, i );
-    items[i] = msStrdup( OGR_Fld_GetNameRef( hField ));
+  for (i = 0; i < numitems; i++) {
+    OGRFieldDefnH hField = OGR_FD_GetFieldDefn(hDefn, i);
+    items[i] = msStrdup(OGR_Fld_GetNameRef(hField));
   }
 
   if (getShapeStyleItems && EQUAL(getShapeStyleItems, "all")) {
     assert(numStyleItems == 21);
-    items[i++] = msStrdup( MSOGR_LABELFONTNAMENAME );
-    items[i++] = msStrdup( MSOGR_LABELSIZENAME );
-    items[i++] = msStrdup( MSOGR_LABELTEXTNAME );
-    items[i++] = msStrdup( MSOGR_LABELANGLENAME );
-    items[i++] = msStrdup( MSOGR_LABELFCOLORNAME );
-    items[i++] = msStrdup( MSOGR_LABELBCOLORNAME );
-    items[i++] = msStrdup( MSOGR_LABELPLACEMENTNAME );
-    items[i++] = msStrdup( MSOGR_LABELANCHORNAME );
-    items[i++] = msStrdup( MSOGR_LABELDXNAME );
-    items[i++] = msStrdup( MSOGR_LABELDYNAME );
-    items[i++] = msStrdup( MSOGR_LABELPERPNAME );
-    items[i++] = msStrdup( MSOGR_LABELBOLDNAME );
-    items[i++] = msStrdup( MSOGR_LABELITALICNAME );
-    items[i++] = msStrdup( MSOGR_LABELUNDERLINENAME );
-    items[i++] = msStrdup( MSOGR_LABELPRIORITYNAME );
-    items[i++] = msStrdup( MSOGR_LABELSTRIKEOUTNAME );
-    items[i++] = msStrdup( MSOGR_LABELSTRETCHNAME );
-    items[i++] = msStrdup( MSOGR_LABELADJHORNAME );
-    items[i++] = msStrdup( MSOGR_LABELADJVERTNAME );
-    items[i++] = msStrdup( MSOGR_LABELHCOLORNAME );
-    items[i++] = msStrdup( MSOGR_LABELOCOLORNAME );
+    items[i++] = msStrdup(MSOGR_LABELFONTNAMENAME);
+    items[i++] = msStrdup(MSOGR_LABELSIZENAME);
+    items[i++] = msStrdup(MSOGR_LABELTEXTNAME);
+    items[i++] = msStrdup(MSOGR_LABELANGLENAME);
+    items[i++] = msStrdup(MSOGR_LABELFCOLORNAME);
+    items[i++] = msStrdup(MSOGR_LABELBCOLORNAME);
+    items[i++] = msStrdup(MSOGR_LABELPLACEMENTNAME);
+    items[i++] = msStrdup(MSOGR_LABELANCHORNAME);
+    items[i++] = msStrdup(MSOGR_LABELDXNAME);
+    items[i++] = msStrdup(MSOGR_LABELDYNAME);
+    items[i++] = msStrdup(MSOGR_LABELPERPNAME);
+    items[i++] = msStrdup(MSOGR_LABELBOLDNAME);
+    items[i++] = msStrdup(MSOGR_LABELITALICNAME);
+    items[i++] = msStrdup(MSOGR_LABELUNDERLINENAME);
+    items[i++] = msStrdup(MSOGR_LABELPRIORITYNAME);
+    items[i++] = msStrdup(MSOGR_LABELSTRIKEOUTNAME);
+    items[i++] = msStrdup(MSOGR_LABELSTRETCHNAME);
+    items[i++] = msStrdup(MSOGR_LABELADJHORNAME);
+    items[i++] = msStrdup(MSOGR_LABELADJVERTNAME);
+    items[i++] = msStrdup(MSOGR_LABELHCOLORNAME);
+    items[i++] = msStrdup(MSOGR_LABELOCOLORNAME);
   }
   items[i++] = NULL;
 
   /* -------------------------------------------------------------------- */
   /*      consider populating the field definitions in metadata.          */
   /* -------------------------------------------------------------------- */
-  if((value = msOWSLookupMetadata(&(layer->metadata), "G", "types")) != NULL
-      && strcasecmp(value,"auto") == 0 )
-    msOGRPassThroughFieldDefinitions( layer, psInfo );
+  if ((value = msOWSLookupMetadata(&(layer->metadata), "G", "types")) != NULL &&
+      strcasecmp(value, "auto") == 0)
+    msOGRPassThroughFieldDefinitions(layer, psInfo);
 
   return items;
 }
@@ -2853,16 +2777,14 @@ static char **msOGRFileGetItems(layerObj
  *
  * Returns MS_SUCCESS/MS_FAILURE
  **********************************************************************/
-static int
-msOGRFileNextShape(layerObj *layer, shapeObj *shape,
-                   msOGRFileInfo *psInfo )
-{
+static int msOGRFileNextShape(layerObj *layer, shapeObj *shape,
+                              msOGRFileInfo *psInfo) {
   OGRFeatureH hFeature = NULL;
 
   if (psInfo == NULL || psInfo->hLayer == NULL) {
     msSetError(MS_MISCERR, "Assertion failed: OGR layer not opened!!!",
                "msOGRFileNextShape()");
-    return(MS_FAILURE);
+    return (MS_FAILURE);
   }
 
   /* ------------------------------------------------------------------
@@ -2874,55 +2796,60 @@ msOGRFileNextShape(layerObj *layer, shap
 
   ACQUIRE_OGR_LOCK;
   while (shape->type == MS_SHAPE_NULL) {
-    if( hFeature )
-      OGR_F_Destroy( hFeature );
+    if (hFeature)
+      OGR_F_Destroy(hFeature);
 
-    if( (hFeature = OGR_L_GetNextFeature( psInfo->hLayer )) == NULL ) {
+    if ((hFeature = OGR_L_GetNextFeature(psInfo->hLayer)) == NULL) {
       psInfo->last_record_index_read = -1;
-      if( CPLGetLastErrorType() == CE_Failure ) {
+      if (CPLGetLastErrorType() == CE_Failure) {
         msSetError(MS_OGRERR, "OGR GetNextFeature() error'd. Check logs.",
                    "msOGRFileNextShape()");
-        msDebug("msOGRFileNextShape(): %s\n",
-                CPLGetLastErrorMsg() );
+        msDebug("msOGRFileNextShape(): %s\n", CPLGetLastErrorMsg());
         RELEASE_OGR_LOCK;
         return MS_FAILURE;
       } else {
         RELEASE_OGR_LOCK;
         if (layer->debug >= MS_DEBUGLEVEL_VV)
-          msDebug("msOGRFileNextShape: Returning MS_DONE (no more shapes)\n" );
-        return MS_DONE;  // No more features to read
+          msDebug("msOGRFileNextShape: Returning MS_DONE (no more shapes)\n");
+        return MS_DONE; // No more features to read
       }
     }
 
     psInfo->last_record_index_read++;
 
-    if(layer->numitems > 0) {
-      if (shape->values) msFreeCharArray(shape->values, shape->numvalues);
+    if (layer->numitems > 0) {
+      if (shape->values)
+        msFreeCharArray(shape->values, shape->numvalues);
       shape->values = msOGRGetValues(layer, hFeature);
       shape->numvalues = layer->numitems;
-      if(!shape->values) {
-        OGR_F_Destroy( hFeature );
+      if (!shape->values) {
+        OGR_F_Destroy(hFeature);
         RELEASE_OGR_LOCK;
-        return(MS_FAILURE);
+        return (MS_FAILURE);
       }
     }
 
     // Feature matched filter expression... process geometry
     // shape->type will be set if geom is compatible with layer type
-    if (ogrConvertGeometry(ogrGetLinearGeometry( hFeature ), shape,
+    if (ogrConvertGeometry(ogrGetLinearGeometry(hFeature), shape,
                            layer->type) == MS_SUCCESS) {
       if (shape->type != MS_SHAPE_NULL)
         break; // Shape is ready to be returned!
 
       if (layer->debug >= MS_DEBUGLEVEL_VVV)
-        msDebug("msOGRFileNextShape: Rejecting feature (shapeid = " CPL_FRMT_GIB ", tileid=%d) of incompatible type for this layer (feature wkbType %d, layer type %d)\n",
-                (GIntBig)OGR_F_GetFID( hFeature ), psInfo->nTileId,
-                OGR_F_GetGeometryRef( hFeature )==NULL ? wkbFlatten(wkbUnknown):wkbFlatten( OGR_G_GetGeometryType( OGR_F_GetGeometryRef( hFeature ) ) ),
+        msDebug("msOGRFileNextShape: Rejecting feature (shapeid = " CPL_FRMT_GIB
+                ", tileid=%d) of incompatible type for this layer (feature "
+                "wkbType %d, layer type %d)\n",
+                (GIntBig)OGR_F_GetFID(hFeature), psInfo->nTileId,
+                OGR_F_GetGeometryRef(hFeature) == NULL
+                    ? wkbFlatten(wkbUnknown)
+                    : wkbFlatten(OGR_G_GetGeometryType(
+                          OGR_F_GetGeometryRef(hFeature))),
                 layer->type);
 
     } else {
       msFreeShape(shape);
-      OGR_F_Destroy( hFeature );
+      OGR_F_Destroy(hFeature);
       RELEASE_OGR_LOCK;
       return MS_FAILURE; // Error message already produced.
     }
@@ -2932,17 +2859,18 @@ msOGRFileNextShape(layerObj *layer, shap
     shape->type = MS_SHAPE_NULL;
   }
 
-  shape->index =  (int)OGR_F_GetFID( hFeature ); // FIXME? GetFID() is a 64bit integer in GDAL 2.0
+  shape->index = (int)OGR_F_GetFID(
+      hFeature); // FIXME? GetFID() is a 64bit integer in GDAL 2.0
   shape->resultindex = psInfo->last_record_index_read;
   shape->tileindex = psInfo->nTileId;
 
   if (layer->debug >= MS_DEBUGLEVEL_VVV)
-    msDebug("msOGRFileNextShape: Returning shape=%ld, tile=%d\n",
-            shape->index, shape->tileindex );
+    msDebug("msOGRFileNextShape: Returning shape=%ld, tile=%d\n", shape->index,
+            shape->tileindex);
 
   // Keep ref. to last feature read in case we need style info.
   if (psInfo->hLastFeature)
-    OGR_F_Destroy( psInfo->hLastFeature );
+    OGR_F_Destroy(psInfo->hLastFeature);
   psInfo->hLastFeature = hFeature;
 
   RELEASE_OGR_LOCK;
@@ -2957,16 +2885,14 @@ msOGRFileNextShape(layerObj *layer, shap
  *
  * Returns MS_SUCCESS/MS_FAILURE
  **********************************************************************/
-static int
-msOGRFileGetShape(layerObj *layer, shapeObj *shape, long record,
-                  msOGRFileInfo *psInfo, int record_is_fid )
-{
+static int msOGRFileGetShape(layerObj *layer, shapeObj *shape, long record,
+                             msOGRFileInfo *psInfo, int record_is_fid) {
   OGRFeatureH hFeature;
 
   if (psInfo == NULL || psInfo->hLayer == NULL) {
     msSetError(MS_MISCERR, "Assertion failed: OGR layer not opened!!!",
                "msOGRFileNextShape()");
-    return(MS_FAILURE);
+    return (MS_FAILURE);
   }
 
   /* -------------------------------------------------------------------- */
@@ -2978,9 +2904,9 @@ msOGRFileGetShape(layerObj *layer, shape
   /* -------------------------------------------------------------------- */
   /*      Support reading feature by fid.                                 */
   /* -------------------------------------------------------------------- */
-  if( record_is_fid ) {
+  if (record_is_fid) {
     ACQUIRE_OGR_LOCK;
-    if( (hFeature = OGR_L_GetFeature( psInfo->hLayer, record )) == NULL ) {
+    if ((hFeature = OGR_L_GetFeature(psInfo->hLayer, record)) == NULL) {
       RELEASE_OGR_LOCK;
       return MS_FAILURE;
     }
@@ -2992,19 +2918,19 @@ msOGRFileGetShape(layerObj *layer, shape
   /* -------------------------------------------------------------------- */
   else {
     ACQUIRE_OGR_LOCK;
-    if( record <= psInfo->last_record_index_read
-        || psInfo->last_record_index_read == -1 ) {
-      OGR_L_ResetReading( psInfo->hLayer );
+    if (record <= psInfo->last_record_index_read ||
+        psInfo->last_record_index_read == -1) {
+      OGR_L_ResetReading(psInfo->hLayer);
       psInfo->last_record_index_read = -1;
     }
 
     hFeature = NULL;
-    while( psInfo->last_record_index_read < record ) {
-      if( hFeature != NULL ) {
-        OGR_F_Destroy( hFeature );
+    while (psInfo->last_record_index_read < record) {
+      if (hFeature != NULL) {
+        OGR_F_Destroy(hFeature);
         hFeature = NULL;
       }
-      if( (hFeature = OGR_L_GetNextFeature( psInfo->hLayer )) == NULL ) {
+      if ((hFeature = OGR_L_GetNextFeature(psInfo->hLayer)) == NULL) {
         RELEASE_OGR_LOCK;
         return MS_FAILURE;
       }
@@ -3016,15 +2942,14 @@ msOGRFileGetShape(layerObj *layer, shape
    * Handle shape geometry...
    * ------------------------------------------------------------------ */
   // shape->type will be set if geom is compatible with layer type
-  if (ogrConvertGeometry(ogrGetLinearGeometry( hFeature ), shape,
-                         layer->type) != MS_SUCCESS) {
+  if (ogrConvertGeometry(ogrGetLinearGeometry(hFeature), shape, layer->type) !=
+      MS_SUCCESS) {
     RELEASE_OGR_LOCK;
     return MS_FAILURE; // Error message already produced.
   }
 
   if (shape->type == MS_SHAPE_NULL) {
-    msSetError(MS_OGRERR,
-               "Requested feature is incompatible with layer type",
+    msSetError(MS_OGRERR, "Requested feature is incompatible with layer type",
                "msOGRLayerGetShape()");
     RELEASE_OGR_LOCK;
     return MS_FAILURE;
@@ -3033,21 +2958,21 @@ msOGRFileGetShape(layerObj *layer, shape
   /* ------------------------------------------------------------------
    * Process shape attributes
    * ------------------------------------------------------------------ */
-  if(layer->numitems > 0) {
+  if (layer->numitems > 0) {
     shape->values = msOGRGetValues(layer, hFeature);
     shape->numvalues = layer->numitems;
-    if(!shape->values) {
+    if (!shape->values) {
       RELEASE_OGR_LOCK;
-      return(MS_FAILURE);
+      return (MS_FAILURE);
     }
-
   }
 
   if (record_is_fid) {
     shape->index = record;
     shape->resultindex = -1;
   } else {
-    shape->index = (int)OGR_F_GetFID( hFeature ); // FIXME? GetFID() is a 64bit integer in GDAL 2.0
+    shape->index = (int)OGR_F_GetFID(
+        hFeature); // FIXME? GetFID() is a 64bit integer in GDAL 2.0
     shape->resultindex = record;
   }
 
@@ -3055,7 +2980,7 @@ msOGRFileGetShape(layerObj *layer, shape
 
   // Keep ref. to last feature read in case we need style info.
   if (psInfo->hLastFeature)
-    OGR_F_Destroy( psInfo->hLastFeature );
+    OGR_F_Destroy(psInfo->hLastFeature);
   psInfo->hLastFeature = hFeature;
 
   RELEASE_OGR_LOCK;
@@ -3075,8 +3000,8 @@ msOGRFileGetShape(layerObj *layer, shape
 /*      the current rectangle.                                          */
 /************************************************************************/
 
-int msOGRFileReadTile( layerObj *layer, msOGRFileInfo *psInfo,
-                       int targetTile = -1 )
+int msOGRFileReadTile(layerObj *layer, msOGRFileInfo *psInfo,
+                      int targetTile = -1)
 
 {
   int nFeatureId;
@@ -3084,8 +3009,8 @@ int msOGRFileReadTile( layerObj *layer,
   /* -------------------------------------------------------------------- */
   /*      Close old tile if one is open.                                  */
   /* -------------------------------------------------------------------- */
-  if( psInfo->poCurTile != NULL ) {
-    msOGRFileClose( layer, psInfo->poCurTile );
+  if (psInfo->poCurTile != NULL) {
+    msOGRFileClose(layer, psInfo->poCurTile);
     psInfo->poCurTile = NULL;
   }
 
@@ -3095,15 +3020,15 @@ int msOGRFileReadTile( layerObj *layer,
   /*      shared between layers or renders.                               */
   /* -------------------------------------------------------------------- */
   ACQUIRE_OGR_LOCK;
-  if( targetTile == -2 ) {
-    OGR_L_ResetReading( psInfo->hLayer );
+  if (targetTile == -2) {
+    OGR_L_ResetReading(psInfo->hLayer);
   }
 
   /* -------------------------------------------------------------------- */
   /*      Get the name (connection string really) of the next tile.       */
   /* -------------------------------------------------------------------- */
   OGRFeatureH hFeature;
-  char       *connection = NULL;
+  char *connection = NULL;
   msOGRFileInfo *psTileInfo = NULL;
   int status;
 
@@ -3111,68 +3036,61 @@ int msOGRFileReadTile( layerObj *layer,
 NextFile:
 #endif
 
-  if( targetTile < 0 )
-    hFeature = OGR_L_GetNextFeature( psInfo->hLayer );
+  if (targetTile < 0)
+    hFeature = OGR_L_GetNextFeature(psInfo->hLayer);
 
   else
-    hFeature = OGR_L_GetFeature( psInfo->hLayer, targetTile );
+    hFeature = OGR_L_GetFeature(psInfo->hLayer, targetTile);
 
-  if( hFeature == NULL ) {
+  if (hFeature == NULL) {
     RELEASE_OGR_LOCK;
-    if( targetTile == -1 )
+    if (targetTile == -1)
       return MS_DONE;
     else
       return MS_FAILURE;
-
   }
 
-  connection = msStrdup( OGR_F_GetFieldAsString( hFeature,
-                         layer->tileitemindex ));
+  connection = msStrdup(OGR_F_GetFieldAsString(hFeature, layer->tileitemindex));
 
-  char* pszSRS = NULL;
-  if( layer->tilesrs != NULL )
-  {
-      int idx = OGR_F_GetFieldIndex( hFeature, layer->tilesrs);
-      if( idx >= 0 )
-      {
-          pszSRS = msStrdup( OGR_F_GetFieldAsString( hFeature, idx ));
-      }
+  char *pszSRS = NULL;
+  if (layer->tilesrs != NULL) {
+    int idx = OGR_F_GetFieldIndex(hFeature, layer->tilesrs);
+    if (idx >= 0) {
+      pszSRS = msStrdup(OGR_F_GetFieldAsString(hFeature, idx));
+    }
   }
 
-  nFeatureId = (int)OGR_F_GetFID( hFeature ); // FIXME? GetFID() is a 64bit integer in GDAL 2.0
+  nFeatureId = (int)OGR_F_GetFID(
+      hFeature); // FIXME? GetFID() is a 64bit integer in GDAL 2.0
 
-  OGR_F_Destroy( hFeature );
+  OGR_F_Destroy(hFeature);
 
   RELEASE_OGR_LOCK;
 
   /* -------------------------------------------------------------------- */
   /*      Open the new tile file.                                         */
   /* -------------------------------------------------------------------- */
-  psTileInfo = msOGRFileOpen( layer, connection );
+  psTileInfo = msOGRFileOpen(layer, connection);
 
-  free( connection );
+  free(connection);
 
 #ifndef IGNORE_MISSING_DATA
-  if( psTileInfo == NULL && targetTile == -1 )
-  {
+  if (psTileInfo == NULL && targetTile == -1) {
     msFree(pszSRS);
     goto NextFile;
   }
 #endif
 
-  if( psTileInfo == NULL )
-  {
+  if (psTileInfo == NULL) {
     msFree(pszSRS);
     return MS_FAILURE;
   }
-  
-  if( pszSRS != NULL )
-  {
-    if( msOGCWKT2ProjectionObj( pszSRS, &(psInfo->sTileProj),
-                                layer->debug ) != MS_SUCCESS )
-    {
-        msFree(pszSRS);
-        return MS_FAILURE;
+
+  if (pszSRS != NULL) {
+    if (msOGCWKT2ProjectionObj(pszSRS, &(psInfo->sTileProj), layer->debug) !=
+        MS_SUCCESS) {
+      msFree(pszSRS);
+      return MS_FAILURE;
     }
     msFree(pszSRS);
   }
@@ -3182,16 +3100,15 @@ NextFile:
   /* -------------------------------------------------------------------- */
   /*      Initialize the spatial query on this file.                      */
   /* -------------------------------------------------------------------- */
-  if( psInfo->rect.minx != 0 || psInfo->rect.maxx != 0 ) {
+  if (psInfo->rect.minx != 0 || psInfo->rect.maxx != 0) {
     rectObj rect = psInfo->rect;
 
-    if( layer->tileindex != NULL && psInfo->sTileProj.numargs > 0 )
-    {
+    if (layer->tileindex != NULL && psInfo->sTileProj.numargs > 0) {
       msProjectRect(&(layer->projection), &(psInfo->sTileProj), &rect);
     }
 
-    status = msOGRFileWhichShapes( layer, rect, psTileInfo );
-    if( status != MS_SUCCESS )
+    status = msOGRFileWhichShapes(layer, rect, psTileInfo);
+    if (status != MS_SUCCESS)
       return status;
   }
 
@@ -3201,7 +3118,7 @@ NextFile:
   /*      Update the iteminfo in case this layer has a different field    */
   /*      list.                                                           */
   /* -------------------------------------------------------------------- */
-  msOGRLayerInitItemInfo( layer );
+  msOGRLayerInitItemInfo(layer);
 
   return MS_SUCCESS;
 }
@@ -3210,48 +3127,42 @@ NextFile:
 /*                               msExprNode                             */
 /************************************************************************/
 
-class msExprNode
-{
-    public:
-        std::vector<std::unique_ptr<msExprNode>> m_aoChildren{};
-        int         m_nToken = 0;
-        std::string m_osVal{};
-        double      m_dfVal = 0;
-        struct tm   m_tmVal{};
+class msExprNode {
+public:
+  std::vector<std::unique_ptr<msExprNode>> m_aoChildren{};
+  int m_nToken = 0;
+  std::string m_osVal{};
+  double m_dfVal = 0;
+  struct tm m_tmVal {};
 };
 
-
 /************************************************************************/
 /*                        exprGetPriority()                             */
 /************************************************************************/
 
-static int exprGetPriority(int token)
-{
-    if (token == MS_TOKEN_LOGICAL_NOT)
-        return 9;
-    else if (token == '*' || token == '/' || token == '%' )
-        return 8;
-    else if (token == '+' || token == '-' )
-        return 7;
-    else if (token == MS_TOKEN_COMPARISON_GE ||
-             token == MS_TOKEN_COMPARISON_GT ||
-             token == MS_TOKEN_COMPARISON_LE ||
-             token == MS_TOKEN_COMPARISON_LT ||
-             token == MS_TOKEN_COMPARISON_IN)
-        return 6;
-    else if (token == MS_TOKEN_COMPARISON_EQ ||
-             token == MS_TOKEN_COMPARISON_IEQ ||
-             token == MS_TOKEN_COMPARISON_LIKE ||
-             token == MS_TOKEN_COMPARISON_RE ||
-             token == MS_TOKEN_COMPARISON_IRE ||
-             token == MS_TOKEN_COMPARISON_NE)
-        return 5;
-    else if (token == MS_TOKEN_LOGICAL_AND)
-        return 4;
-    else if (token == MS_TOKEN_LOGICAL_OR)
-        return 3;
-    else
-        return 0;
+static int exprGetPriority(int token) {
+  if (token == MS_TOKEN_LOGICAL_NOT)
+    return 9;
+  else if (token == '*' || token == '/' || token == '%')
+    return 8;
+  else if (token == '+' || token == '-')
+    return 7;
+  else if (token == MS_TOKEN_COMPARISON_GE || token == MS_TOKEN_COMPARISON_GT ||
+           token == MS_TOKEN_COMPARISON_LE || token == MS_TOKEN_COMPARISON_LT ||
+           token == MS_TOKEN_COMPARISON_IN)
+    return 6;
+  else if (token == MS_TOKEN_COMPARISON_EQ ||
+           token == MS_TOKEN_COMPARISON_IEQ ||
+           token == MS_TOKEN_COMPARISON_LIKE ||
+           token == MS_TOKEN_COMPARISON_RE ||
+           token == MS_TOKEN_COMPARISON_IRE || token == MS_TOKEN_COMPARISON_NE)
+    return 5;
+  else if (token == MS_TOKEN_LOGICAL_AND)
+    return 4;
+  else if (token == MS_TOKEN_LOGICAL_OR)
+    return 3;
+  else
+    return 0;
 }
 
 /************************************************************************/
@@ -3259,297 +3170,254 @@ static int exprGetPriority(int token)
 /************************************************************************/
 
 static std::unique_ptr<msExprNode> BuildExprTree(tokenListNodeObjPtr node,
-                                 tokenListNodeObjPtr* pNodeNext,
-                                 int nParenthesisLevel)
-{
-    std::vector<std::unique_ptr<msExprNode>> aoStackOp, aoStackVal;
-    while( node != NULL )
-    {
-        if( node->token == '(' )
-        {
-            auto subExpr = BuildExprTree(node->next, &node,
-                                                nParenthesisLevel + 1);
-            if( subExpr == NULL )
-            {
-                return nullptr;
-            }
-            aoStackVal.emplace_back(std::move(subExpr));
-            continue;
-        }
-        else if( node->token == ')' )
-        {
-            if( nParenthesisLevel > 0 )
-            {
-                break;
-            }
+                                                 tokenListNodeObjPtr *pNodeNext,
+                                                 int nParenthesisLevel) {
+  std::vector<std::unique_ptr<msExprNode>> aoStackOp, aoStackVal;
+  while (node != NULL) {
+    if (node->token == '(') {
+      auto subExpr = BuildExprTree(node->next, &node, nParenthesisLevel + 1);
+      if (subExpr == NULL) {
+        return nullptr;
+      }
+      aoStackVal.emplace_back(std::move(subExpr));
+      continue;
+    } else if (node->token == ')') {
+      if (nParenthesisLevel > 0) {
+        break;
+      }
+      return nullptr;
+    } else if (node->token == '+' || node->token == '-' || node->token == '*' ||
+               node->token == '/' || node->token == '%' ||
+               node->token == MS_TOKEN_LOGICAL_NOT ||
+               node->token == MS_TOKEN_LOGICAL_AND ||
+               node->token == MS_TOKEN_LOGICAL_OR ||
+               node->token == MS_TOKEN_COMPARISON_GE ||
+               node->token == MS_TOKEN_COMPARISON_GT ||
+               node->token == MS_TOKEN_COMPARISON_LE ||
+               node->token == MS_TOKEN_COMPARISON_LT ||
+               node->token == MS_TOKEN_COMPARISON_EQ ||
+               node->token == MS_TOKEN_COMPARISON_IEQ ||
+               node->token == MS_TOKEN_COMPARISON_LIKE ||
+               node->token == MS_TOKEN_COMPARISON_NE ||
+               node->token == MS_TOKEN_COMPARISON_RE ||
+               node->token == MS_TOKEN_COMPARISON_IRE ||
+               node->token == MS_TOKEN_COMPARISON_IN) {
+      while (!aoStackOp.empty() &&
+             exprGetPriority(node->token) <=
+                 exprGetPriority(aoStackOp.back()->m_nToken)) {
+        std::unique_ptr<msExprNode> val1;
+        std::unique_ptr<msExprNode> val2;
+        if (aoStackOp.back()->m_nToken != MS_TOKEN_LOGICAL_NOT) {
+          if (aoStackVal.empty())
             return nullptr;
+          val2.reset(aoStackVal.back().release());
+          aoStackVal.pop_back();
         }
-        else if( node->token == '+' ||
-                 node->token == '-' ||
-                 node->token == '*' ||
-                 node->token == '/' ||
-                 node->token == '%' ||
-                 node->token == MS_TOKEN_LOGICAL_NOT ||
-                 node->token == MS_TOKEN_LOGICAL_AND ||
-                 node->token == MS_TOKEN_LOGICAL_OR  ||
-                 node->token == MS_TOKEN_COMPARISON_GE ||
-                 node->token == MS_TOKEN_COMPARISON_GT ||
-                 node->token == MS_TOKEN_COMPARISON_LE ||
-                 node->token == MS_TOKEN_COMPARISON_LT ||
-                 node->token == MS_TOKEN_COMPARISON_EQ ||
-                 node->token == MS_TOKEN_COMPARISON_IEQ ||
-                 node->token == MS_TOKEN_COMPARISON_LIKE ||
-                 node->token == MS_TOKEN_COMPARISON_NE ||
-                 node->token == MS_TOKEN_COMPARISON_RE ||
-                 node->token == MS_TOKEN_COMPARISON_IRE ||
-                 node->token == MS_TOKEN_COMPARISON_IN )
-        {
-            while( !aoStackOp.empty() &&
-                   exprGetPriority(node->token) <=
-                        exprGetPriority(aoStackOp.back()->m_nToken))
-            {
-                std::unique_ptr<msExprNode> val1;
-                std::unique_ptr<msExprNode> val2;
-                if (aoStackOp.back()->m_nToken != MS_TOKEN_LOGICAL_NOT)
-                {
-                    if( aoStackVal.empty() )
-                        return nullptr;
-                    val2.reset(aoStackVal.back().release());
-                    aoStackVal.pop_back();
-                }
-                if( aoStackVal.empty() )
-                    return nullptr;
-                val1.reset(aoStackVal.back().release());
-                aoStackVal.pop_back();
-
-                std::unique_ptr<msExprNode> newNode(new msExprNode);
-                newNode->m_nToken = aoStackOp.back()->m_nToken;
-                newNode->m_aoChildren.emplace_back(std::move(val1));
-                if( val2 )
-                    newNode->m_aoChildren.emplace_back(std::move(val2));
-                aoStackVal.emplace_back(std::move(newNode));
-                aoStackOp.pop_back();
-            }
-
-            std::unique_ptr<msExprNode> newNode(new msExprNode);
-            newNode->m_nToken = node->token;
-            aoStackOp.emplace_back(std::move(newNode));
-        }
-        else if( node->token == ',' )
-        {
-        }
-        else if( node->token == MS_TOKEN_COMPARISON_INTERSECTS ||
-                 node->token == MS_TOKEN_COMPARISON_DISJOINT ||
-                 node->token == MS_TOKEN_COMPARISON_TOUCHES ||
-                 node->token == MS_TOKEN_COMPARISON_OVERLAPS ||
-                 node->token == MS_TOKEN_COMPARISON_CROSSES ||
-                 node->token == MS_TOKEN_COMPARISON_DWITHIN ||
-                 node->token == MS_TOKEN_COMPARISON_BEYOND ||
-                 node->token == MS_TOKEN_COMPARISON_WITHIN ||
-                 node->token == MS_TOKEN_COMPARISON_CONTAINS ||
-                 node->token == MS_TOKEN_COMPARISON_EQUALS ||
-                 node->token == MS_TOKEN_FUNCTION_LENGTH ||
-                 node->token == MS_TOKEN_FUNCTION_TOSTRING ||
-                 node->token == MS_TOKEN_FUNCTION_COMMIFY ||
-                 node->token == MS_TOKEN_FUNCTION_AREA ||
-                 node->token == MS_TOKEN_FUNCTION_ROUND ||
-                 node->token == MS_TOKEN_FUNCTION_FROMTEXT ||
-                 node->token == MS_TOKEN_FUNCTION_BUFFER ||
-                 node->token == MS_TOKEN_FUNCTION_DIFFERENCE ||
-                 node->token == MS_TOKEN_FUNCTION_SIMPLIFY ||
-                 node->token == MS_TOKEN_FUNCTION_SIMPLIFYPT ||
-                 node->token == MS_TOKEN_FUNCTION_GENERALIZE ||
-                 node->token == MS_TOKEN_FUNCTION_SMOOTHSIA ||
-                 node->token == MS_TOKEN_FUNCTION_JAVASCRIPT ||
-                 node->token == MS_TOKEN_FUNCTION_UPPER ||
-                 node->token == MS_TOKEN_FUNCTION_LOWER ||
-                 node->token == MS_TOKEN_FUNCTION_INITCAP ||
-                 node->token == MS_TOKEN_FUNCTION_FIRSTCAP )
-        {
-            if( node->next && node->next->token == '(' )
-            {
-                int node_token = node->token;
-                auto subExpr = BuildExprTree(node->next->next, &node,
-                                                    nParenthesisLevel + 1);
-                if( subExpr == NULL )
-                {
-                    return nullptr;
-                }
-                std::unique_ptr<msExprNode> newNode(new msExprNode);
-                newNode->m_nToken = node_token;
-                if( subExpr->m_nToken == 0 )
-                {
-                    newNode->m_aoChildren = std::move(subExpr->m_aoChildren);
-                }
-                else
-                {
-                    newNode->m_aoChildren.emplace_back(std::move(subExpr));
-                }
-                aoStackVal.emplace_back(std::move(newNode));
-                continue;
-            }
-            else
-                return nullptr;
-        }
-        else if( node->token == MS_TOKEN_LITERAL_NUMBER ||
-                 node->token == MS_TOKEN_LITERAL_BOOLEAN )
-        {
-            std::unique_ptr<msExprNode> newNode(new msExprNode);
-            newNode->m_nToken = node->token;
-            newNode->m_dfVal = node->tokenval.dblval;
-            aoStackVal.emplace_back(std::move(newNode));
-        }
-        else if( node->token == MS_TOKEN_LITERAL_STRING )
-        {
-            std::unique_ptr<msExprNode> newNode(new msExprNode);
-            newNode->m_nToken = node->token;
-            newNode->m_osVal = node->tokenval.strval;
-            aoStackVal.emplace_back(std::move(newNode));
-        }
-        else if( node->token == MS_TOKEN_LITERAL_TIME )
-        {
-            std::unique_ptr<msExprNode> newNode(new msExprNode);
-            newNode->m_nToken = node->token;
-            newNode->m_tmVal = node->tokenval.tmval;
-            aoStackVal.emplace_back(std::move(newNode));
-        }
-        else if( node->token == MS_TOKEN_LITERAL_SHAPE )
-        {
-            std::unique_ptr<msExprNode> newNode(new msExprNode);
-            newNode->m_nToken = node->token;
-            char *wkt = msShapeToWKT(node->tokenval.shpval);
-            newNode->m_osVal = wkt;
-            msFree(wkt);
-            aoStackVal.emplace_back(std::move(newNode));
-        }
-        else if( node->token == MS_TOKEN_BINDING_DOUBLE ||
-                 node->token == MS_TOKEN_BINDING_INTEGER ||
-                 node->token == MS_TOKEN_BINDING_STRING ||
-                 node->token == MS_TOKEN_BINDING_TIME )
-        {
-            std::unique_ptr<msExprNode> newNode(new msExprNode);
-            newNode->m_nToken = node->token;
-            newNode->m_osVal = node->tokenval.bindval.item;
-            aoStackVal.emplace_back(std::move(newNode));
-        }
-        else
-        {
-            std::unique_ptr<msExprNode> newNode(new msExprNode);
-            newNode->m_nToken = node->token;
-            aoStackVal.emplace_back(std::move(newNode));
-        }
-
-        node = node->next;
-    }
-
-    while( !aoStackOp.empty() )
-    {
-        std::unique_ptr<msExprNode> val1 = NULL;
-        std::unique_ptr<msExprNode> val2 = NULL;
-        if (aoStackOp.back()->m_nToken != MS_TOKEN_LOGICAL_NOT)
-        {
-            if( aoStackVal.empty() )
-                return nullptr;
-            val2.reset(aoStackVal.back().release());
-            aoStackVal.pop_back();
-        }
-        if( aoStackVal.empty() )
-            return nullptr;
+        if (aoStackVal.empty())
+          return nullptr;
         val1.reset(aoStackVal.back().release());
         aoStackVal.pop_back();
 
         std::unique_ptr<msExprNode> newNode(new msExprNode);
         newNode->m_nToken = aoStackOp.back()->m_nToken;
         newNode->m_aoChildren.emplace_back(std::move(val1));
-        if( val2 )
-            newNode->m_aoChildren.emplace_back(std::move(val2));
+        if (val2)
+          newNode->m_aoChildren.emplace_back(std::move(val2));
         aoStackVal.emplace_back(std::move(newNode));
         aoStackOp.pop_back();
+      }
+
+      std::unique_ptr<msExprNode> newNode(new msExprNode);
+      newNode->m_nToken = node->token;
+      aoStackOp.emplace_back(std::move(newNode));
+    } else if (node->token == ',') {
+    } else if (node->token == MS_TOKEN_COMPARISON_INTERSECTS ||
+               node->token == MS_TOKEN_COMPARISON_DISJOINT ||
+               node->token == MS_TOKEN_COMPARISON_TOUCHES ||
+               node->token == MS_TOKEN_COMPARISON_OVERLAPS ||
+               node->token == MS_TOKEN_COMPARISON_CROSSES ||
+               node->token == MS_TOKEN_COMPARISON_DWITHIN ||
+               node->token == MS_TOKEN_COMPARISON_BEYOND ||
+               node->token == MS_TOKEN_COMPARISON_WITHIN ||
+               node->token == MS_TOKEN_COMPARISON_CONTAINS ||
+               node->token == MS_TOKEN_COMPARISON_EQUALS ||
+               node->token == MS_TOKEN_FUNCTION_LENGTH ||
+               node->token == MS_TOKEN_FUNCTION_TOSTRING ||
+               node->token == MS_TOKEN_FUNCTION_COMMIFY ||
+               node->token == MS_TOKEN_FUNCTION_AREA ||
+               node->token == MS_TOKEN_FUNCTION_ROUND ||
+               node->token == MS_TOKEN_FUNCTION_FROMTEXT ||
+               node->token == MS_TOKEN_FUNCTION_BUFFER ||
+               node->token == MS_TOKEN_FUNCTION_DIFFERENCE ||
+               node->token == MS_TOKEN_FUNCTION_SIMPLIFY ||
+               node->token == MS_TOKEN_FUNCTION_SIMPLIFYPT ||
+               node->token == MS_TOKEN_FUNCTION_GENERALIZE ||
+               node->token == MS_TOKEN_FUNCTION_SMOOTHSIA ||
+               node->token == MS_TOKEN_FUNCTION_JAVASCRIPT ||
+               node->token == MS_TOKEN_FUNCTION_UPPER ||
+               node->token == MS_TOKEN_FUNCTION_LOWER ||
+               node->token == MS_TOKEN_FUNCTION_INITCAP ||
+               node->token == MS_TOKEN_FUNCTION_FIRSTCAP) {
+      if (node->next && node->next->token == '(') {
+        int node_token = node->token;
+        auto subExpr =
+            BuildExprTree(node->next->next, &node, nParenthesisLevel + 1);
+        if (subExpr == NULL) {
+          return nullptr;
+        }
+        std::unique_ptr<msExprNode> newNode(new msExprNode);
+        newNode->m_nToken = node_token;
+        if (subExpr->m_nToken == 0) {
+          newNode->m_aoChildren = std::move(subExpr->m_aoChildren);
+        } else {
+          newNode->m_aoChildren.emplace_back(std::move(subExpr));
+        }
+        aoStackVal.emplace_back(std::move(newNode));
+        continue;
+      } else
+        return nullptr;
+    } else if (node->token == MS_TOKEN_LITERAL_NUMBER ||
+               node->token == MS_TOKEN_LITERAL_BOOLEAN) {
+      std::unique_ptr<msExprNode> newNode(new msExprNode);
+      newNode->m_nToken = node->token;
+      newNode->m_dfVal = node->tokenval.dblval;
+      aoStackVal.emplace_back(std::move(newNode));
+    } else if (node->token == MS_TOKEN_LITERAL_STRING) {
+      std::unique_ptr<msExprNode> newNode(new msExprNode);
+      newNode->m_nToken = node->token;
+      newNode->m_osVal = node->tokenval.strval;
+      aoStackVal.emplace_back(std::move(newNode));
+    } else if (node->token == MS_TOKEN_LITERAL_TIME) {
+      std::unique_ptr<msExprNode> newNode(new msExprNode);
+      newNode->m_nToken = node->token;
+      newNode->m_tmVal = node->tokenval.tmval;
+      aoStackVal.emplace_back(std::move(newNode));
+    } else if (node->token == MS_TOKEN_LITERAL_SHAPE) {
+      std::unique_ptr<msExprNode> newNode(new msExprNode);
+      newNode->m_nToken = node->token;
+      char *wkt = msShapeToWKT(node->tokenval.shpval);
+      newNode->m_osVal = wkt;
+      msFree(wkt);
+      aoStackVal.emplace_back(std::move(newNode));
+    } else if (node->token == MS_TOKEN_BINDING_DOUBLE ||
+               node->token == MS_TOKEN_BINDING_INTEGER ||
+               node->token == MS_TOKEN_BINDING_STRING ||
+               node->token == MS_TOKEN_BINDING_TIME) {
+      std::unique_ptr<msExprNode> newNode(new msExprNode);
+      newNode->m_nToken = node->token;
+      newNode->m_osVal = node->tokenval.bindval.item;
+      aoStackVal.emplace_back(std::move(newNode));
+    } else {
+      std::unique_ptr<msExprNode> newNode(new msExprNode);
+      newNode->m_nToken = node->token;
+      aoStackVal.emplace_back(std::move(newNode));
     }
 
-    std::unique_ptr<msExprNode> poRet;
-    if( aoStackVal.size() == 1 )
-        poRet.reset(aoStackVal.back().release());
-    else if( aoStackVal.size() > 1 )
-    {
-        poRet.reset(new msExprNode);
-        poRet->m_aoChildren = std::move(aoStackVal);
+    node = node->next;
+  }
+
+  while (!aoStackOp.empty()) {
+    std::unique_ptr<msExprNode> val1 = NULL;
+    std::unique_ptr<msExprNode> val2 = NULL;
+    if (aoStackOp.back()->m_nToken != MS_TOKEN_LOGICAL_NOT) {
+      if (aoStackVal.empty())
+        return nullptr;
+      val2.reset(aoStackVal.back().release());
+      aoStackVal.pop_back();
     }
+    if (aoStackVal.empty())
+      return nullptr;
+    val1.reset(aoStackVal.back().release());
+    aoStackVal.pop_back();
+
+    std::unique_ptr<msExprNode> newNode(new msExprNode);
+    newNode->m_nToken = aoStackOp.back()->m_nToken;
+    newNode->m_aoChildren.emplace_back(std::move(val1));
+    if (val2)
+      newNode->m_aoChildren.emplace_back(std::move(val2));
+    aoStackVal.emplace_back(std::move(newNode));
+    aoStackOp.pop_back();
+  }
+
+  std::unique_ptr<msExprNode> poRet;
+  if (aoStackVal.size() == 1)
+    poRet.reset(aoStackVal.back().release());
+  else if (aoStackVal.size() > 1) {
+    poRet.reset(new msExprNode);
+    poRet->m_aoChildren = std::move(aoStackVal);
+  }
 
-    if( pNodeNext )
-        *pNodeNext = node ? node->next : NULL;
+  if (pNodeNext)
+    *pNodeNext = node ? node->next : NULL;
 
-    return poRet;
+  return poRet;
 }
 
 /**********************************************************************
  *                 msOGRExtractTopSpatialFilter()
- * 
+ *
  * Recognize expressions like "Intersects([shape], wkt) == TRUE [AND ....]"
  **********************************************************************/
-static int  msOGRExtractTopSpatialFilter( msOGRFileInfo *info,
-                                          const msExprNode* expr,
-                                          const msExprNode** pSpatialFilterNode )
-{
-  if( expr == NULL )
-      return MS_FALSE;
+static int msOGRExtractTopSpatialFilter(msOGRFileInfo *info,
+                                        const msExprNode *expr,
+                                        const msExprNode **pSpatialFilterNode) {
+  if (expr == NULL)
+    return MS_FALSE;
 
-  if( expr->m_nToken == MS_TOKEN_COMPARISON_EQ &&
+  if (expr->m_nToken == MS_TOKEN_COMPARISON_EQ &&
       expr->m_aoChildren.size() == 2 &&
       expr->m_aoChildren[1]->m_nToken == MS_TOKEN_LITERAL_BOOLEAN &&
-      expr->m_aoChildren[1]->m_dfVal == 1.0 )
-  {
-      return msOGRExtractTopSpatialFilter(info, expr->m_aoChildren[0].get(),
-                                          pSpatialFilterNode);
-  }
-
-  if( (((expr->m_nToken == MS_TOKEN_COMPARISON_INTERSECTS ||
-      expr->m_nToken == MS_TOKEN_COMPARISON_OVERLAPS ||
-      expr->m_nToken == MS_TOKEN_COMPARISON_CROSSES ||
-      expr->m_nToken == MS_TOKEN_COMPARISON_WITHIN ||
-      expr->m_nToken == MS_TOKEN_COMPARISON_CONTAINS) &&
-      expr->m_aoChildren.size() == 2) ||
-      (expr->m_nToken == MS_TOKEN_COMPARISON_DWITHIN && expr->m_aoChildren.size() == 3)) &&
-      expr->m_aoChildren[1]->m_nToken == MS_TOKEN_LITERAL_SHAPE )
-  {
-        if( info->rect_is_defined )
-        {
-            // Several intersects...
-            *pSpatialFilterNode = NULL;
-            info->rect_is_defined = MS_FALSE;
-            return MS_FALSE;
-        }
-        OGRGeometryH hSpatialFilter = NULL;
-        char* wkt = const_cast<char*>(expr->m_aoChildren[1]->m_osVal.c_str());
-        OGRErr e = OGR_G_CreateFromWkt(&wkt, NULL, &hSpatialFilter);
-        if (e == OGRERR_NONE) {
-            OGREnvelope env;
-            if( expr->m_nToken == MS_TOKEN_COMPARISON_DWITHIN ) {
-                OGRGeometryH hBuffer = OGR_G_Buffer(hSpatialFilter, expr->m_aoChildren[2]->m_dfVal, 30);
-                OGR_G_GetEnvelope(hBuffer ? hBuffer : hSpatialFilter, &env);
-                OGR_G_DestroyGeometry(hBuffer);
-            } else {
-                OGR_G_GetEnvelope(hSpatialFilter, &env);
-            }
-            info->rect.minx = env.MinX;
-            info->rect.miny = env.MinY;
-            info->rect.maxx = env.MaxX;
-            info->rect.maxy = env.MaxY;
-            info->rect_is_defined = true;
-            *pSpatialFilterNode = expr;
-            OGR_G_DestroyGeometry(hSpatialFilter);
-            return MS_TRUE;
-        }
-        return MS_FALSE;
-  }
-
-  if( expr->m_nToken == MS_TOKEN_LOGICAL_AND &&
-      expr->m_aoChildren.size() == 2 )
-  {
-      return msOGRExtractTopSpatialFilter(info, expr->m_aoChildren[0].get(),
-                                          pSpatialFilterNode) &&
-             msOGRExtractTopSpatialFilter(info, expr->m_aoChildren[1].get(),
-                                          pSpatialFilterNode);
+      expr->m_aoChildren[1]->m_dfVal == 1.0) {
+    return msOGRExtractTopSpatialFilter(info, expr->m_aoChildren[0].get(),
+                                        pSpatialFilterNode);
+  }
+
+  if ((((expr->m_nToken == MS_TOKEN_COMPARISON_INTERSECTS ||
+         expr->m_nToken == MS_TOKEN_COMPARISON_OVERLAPS ||
+         expr->m_nToken == MS_TOKEN_COMPARISON_CROSSES ||
+         expr->m_nToken == MS_TOKEN_COMPARISON_WITHIN ||
+         expr->m_nToken == MS_TOKEN_COMPARISON_CONTAINS) &&
+        expr->m_aoChildren.size() == 2) ||
+       (expr->m_nToken == MS_TOKEN_COMPARISON_DWITHIN &&
+        expr->m_aoChildren.size() == 3)) &&
+      expr->m_aoChildren[1]->m_nToken == MS_TOKEN_LITERAL_SHAPE) {
+    if (info->rect_is_defined) {
+      // Several intersects...
+      *pSpatialFilterNode = NULL;
+      info->rect_is_defined = MS_FALSE;
+      return MS_FALSE;
+    }
+    OGRGeometryH hSpatialFilter = NULL;
+    char *wkt = const_cast<char *>(expr->m_aoChildren[1]->m_osVal.c_str());
+    OGRErr e = OGR_G_CreateFromWkt(&wkt, NULL, &hSpatialFilter);
+    if (e == OGRERR_NONE) {
+      OGREnvelope env;
+      if (expr->m_nToken == MS_TOKEN_COMPARISON_DWITHIN) {
+        OGRGeometryH hBuffer =
+            OGR_G_Buffer(hSpatialFilter, expr->m_aoChildren[2]->m_dfVal, 30);
+        OGR_G_GetEnvelope(hBuffer ? hBuffer : hSpatialFilter, &env);
+        OGR_G_DestroyGeometry(hBuffer);
+      } else {
+        OGR_G_GetEnvelope(hSpatialFilter, &env);
+      }
+      info->rect.minx = env.MinX;
+      info->rect.miny = env.MinY;
+      info->rect.maxx = env.MaxX;
+      info->rect.maxy = env.MaxY;
+      info->rect_is_defined = true;
+      *pSpatialFilterNode = expr;
+      OGR_G_DestroyGeometry(hSpatialFilter);
+      return MS_TRUE;
+    }
+    return MS_FALSE;
+  }
+
+  if (expr->m_nToken == MS_TOKEN_LOGICAL_AND &&
+      expr->m_aoChildren.size() == 2) {
+    return msOGRExtractTopSpatialFilter(info, expr->m_aoChildren[0].get(),
+                                        pSpatialFilterNode) &&
+           msOGRExtractTopSpatialFilter(info, expr->m_aoChildren[1].get(),
+                                        pSpatialFilterNode);
   }
 
   return MS_TRUE;
@@ -3561,260 +3429,221 @@ static int  msOGRExtractTopSpatialFilter
  * Tries to partially translate a mapserver expression to SQL
  **********************************************************************/
 
-static std::string msOGRGetTokenText(int nToken)
-{
-    switch( nToken )
-    {
-        case '*':
-        case '+':
-        case '-':
-        case '/':
-        case '%':
-            return std::string(1, static_cast<char>(nToken));
-
-        case MS_TOKEN_COMPARISON_GE: return ">=";
-        case MS_TOKEN_COMPARISON_GT: return ">";
-        case MS_TOKEN_COMPARISON_LE: return "<=";
-        case MS_TOKEN_COMPARISON_LT: return "<";
-        case MS_TOKEN_COMPARISON_EQ: return "=";
-        case MS_TOKEN_COMPARISON_NE: return "!=";
-        case MS_TOKEN_COMPARISON_LIKE: return "LIKE";
-
-        default:
-            return std::string();
-    }
+static std::string msOGRGetTokenText(int nToken) {
+  switch (nToken) {
+  case '*':
+  case '+':
+  case '-':
+  case '/':
+  case '%':
+    return std::string(1, static_cast<char>(nToken));
+
+  case MS_TOKEN_COMPARISON_GE:
+    return ">=";
+  case MS_TOKEN_COMPARISON_GT:
+    return ">";
+  case MS_TOKEN_COMPARISON_LE:
+    return "<=";
+  case MS_TOKEN_COMPARISON_LT:
+    return "<";
+  case MS_TOKEN_COMPARISON_EQ:
+    return "=";
+  case MS_TOKEN_COMPARISON_NE:
+    return "!=";
+  case MS_TOKEN_COMPARISON_LIKE:
+    return "LIKE";
+
+  default:
+    return std::string();
+  }
 }
 
-static std::string msOGRTranslatePartialInternal(layerObj* layer,
-                                                 const msExprNode* expr,
-                                                 const msExprNode* spatialFilterNode,
-                                                 bool& bPartialFilter)
-{
-    switch( expr->m_nToken )
-    {
-        case MS_TOKEN_LOGICAL_NOT:
-        {
-            std::string osTmp(msOGRTranslatePartialInternal(
-                layer, expr->m_aoChildren[0].get(), spatialFilterNode, bPartialFilter ));
-            if( osTmp.empty() )
-                return std::string();
-            return "(NOT " + osTmp + ")";
-        }
-
-        case MS_TOKEN_LOGICAL_AND:
-        {
-            // We can deal with partially translated children
-            std::string osTmp1(msOGRTranslatePartialInternal(
-                layer, expr->m_aoChildren[0].get(), spatialFilterNode, bPartialFilter ));
-            std::string osTmp2(msOGRTranslatePartialInternal( 
-                layer, expr->m_aoChildren[1].get(), spatialFilterNode, bPartialFilter ));
-            if( !osTmp1.empty() && !osTmp2.empty() )
-            {
-                return "(" + osTmp1 + " AND " + osTmp2 + ")";
-            }
-            else if( !osTmp1.empty() )
-                return osTmp1;
-            else
-                return osTmp2;
-        }
+static std::string
+msOGRTranslatePartialInternal(layerObj *layer, const msExprNode *expr,
+                              const msExprNode *spatialFilterNode,
+                              bool &bPartialFilter) {
+  switch (expr->m_nToken) {
+  case MS_TOKEN_LOGICAL_NOT: {
+    std::string osTmp(msOGRTranslatePartialInternal(
+        layer, expr->m_aoChildren[0].get(), spatialFilterNode, bPartialFilter));
+    if (osTmp.empty())
+      return std::string();
+    return "(NOT " + osTmp + ")";
+  }
+
+  case MS_TOKEN_LOGICAL_AND: {
+    // We can deal with partially translated children
+    std::string osTmp1(msOGRTranslatePartialInternal(
+        layer, expr->m_aoChildren[0].get(), spatialFilterNode, bPartialFilter));
+    std::string osTmp2(msOGRTranslatePartialInternal(
+        layer, expr->m_aoChildren[1].get(), spatialFilterNode, bPartialFilter));
+    if (!osTmp1.empty() && !osTmp2.empty()) {
+      return "(" + osTmp1 + " AND " + osTmp2 + ")";
+    } else if (!osTmp1.empty())
+      return osTmp1;
+    else
+      return osTmp2;
+  }
 
-        case MS_TOKEN_LOGICAL_OR:
-        {
-            // We can NOT deal with partially translated children
-            std::string osTmp1(msOGRTranslatePartialInternal(
-                layer, expr->m_aoChildren[0].get(), spatialFilterNode, bPartialFilter ));
-            std::string osTmp2(msOGRTranslatePartialInternal(
-                layer, expr->m_aoChildren[1].get(), spatialFilterNode, bPartialFilter ));
-            if( !osTmp1.empty() && !osTmp2.empty() )
-            {
-                return "(" + osTmp1 + " OR " + osTmp2 + ")";
-            }
-            else
-                return std::string();
-        }
+  case MS_TOKEN_LOGICAL_OR: {
+    // We can NOT deal with partially translated children
+    std::string osTmp1(msOGRTranslatePartialInternal(
+        layer, expr->m_aoChildren[0].get(), spatialFilterNode, bPartialFilter));
+    std::string osTmp2(msOGRTranslatePartialInternal(
+        layer, expr->m_aoChildren[1].get(), spatialFilterNode, bPartialFilter));
+    if (!osTmp1.empty() && !osTmp2.empty()) {
+      return "(" + osTmp1 + " OR " + osTmp2 + ")";
+    } else
+      return std::string();
+  }
 
-        case '*':
-        case '+':
-        case '-':
-        case '/':
-        case '%':
-        case MS_TOKEN_COMPARISON_GE:
-        case MS_TOKEN_COMPARISON_GT:
-        case MS_TOKEN_COMPARISON_LE:
-        case MS_TOKEN_COMPARISON_LT:
-        case MS_TOKEN_COMPARISON_EQ:
-        case MS_TOKEN_COMPARISON_NE:
-        {
-            std::string osTmp1(msOGRTranslatePartialInternal(
-                layer, expr->m_aoChildren[0].get(), spatialFilterNode, bPartialFilter ));
-            std::string osTmp2(msOGRTranslatePartialInternal(
-                layer, expr->m_aoChildren[1].get(), spatialFilterNode, bPartialFilter ));
-            if( !osTmp1.empty() && !osTmp2.empty() )
-            {
-                if( expr->m_nToken == MS_TOKEN_COMPARISON_EQ &&
-                    osTmp2 == "'_MAPSERVER_NULL_'" )
-                {
-                    return "(" + osTmp1 + " IS NULL )";
-                }
-                if( expr->m_aoChildren[1]->m_nToken == MS_TOKEN_LITERAL_STRING )
-                {
-                    char md_item_name[256];
-                    snprintf( md_item_name, sizeof(md_item_name), "gml_%s_type",
-                              expr->m_aoChildren[0]->m_osVal.c_str() );
-                    const char* type =
-                        msLookupHashTable(&(layer->metadata), md_item_name);
-                    // Cast if needed (or unsure)
-                    if( type == NULL || !EQUAL(type, "Character") )
-                    {
-                        osTmp1 = "CAST(" + osTmp1 + " AS CHARACTER(4096))";
-                    }
-                }
-                return "(" + osTmp1 + " " + msOGRGetTokenText(expr->m_nToken) +
-                       " " + osTmp2 + ")";
-            }
-            else
-                return std::string();
+  case '*':
+  case '+':
+  case '-':
+  case '/':
+  case '%':
+  case MS_TOKEN_COMPARISON_GE:
+  case MS_TOKEN_COMPARISON_GT:
+  case MS_TOKEN_COMPARISON_LE:
+  case MS_TOKEN_COMPARISON_LT:
+  case MS_TOKEN_COMPARISON_EQ:
+  case MS_TOKEN_COMPARISON_NE: {
+    std::string osTmp1(msOGRTranslatePartialInternal(
+        layer, expr->m_aoChildren[0].get(), spatialFilterNode, bPartialFilter));
+    std::string osTmp2(msOGRTranslatePartialInternal(
+        layer, expr->m_aoChildren[1].get(), spatialFilterNode, bPartialFilter));
+    if (!osTmp1.empty() && !osTmp2.empty()) {
+      if (expr->m_nToken == MS_TOKEN_COMPARISON_EQ &&
+          osTmp2 == "'_MAPSERVER_NULL_'") {
+        return "(" + osTmp1 + " IS NULL )";
+      }
+      if (expr->m_aoChildren[1]->m_nToken == MS_TOKEN_LITERAL_STRING) {
+        char md_item_name[256];
+        snprintf(md_item_name, sizeof(md_item_name), "gml_%s_type",
+                 expr->m_aoChildren[0]->m_osVal.c_str());
+        const char *type = msLookupHashTable(&(layer->metadata), md_item_name);
+        // Cast if needed (or unsure)
+        if (type == NULL || !EQUAL(type, "Character")) {
+          osTmp1 = "CAST(" + osTmp1 + " AS CHARACTER(4096))";
         }
+      }
+      return "(" + osTmp1 + " " + msOGRGetTokenText(expr->m_nToken) + " " +
+             osTmp2 + ")";
+    } else
+      return std::string();
+  }
 
-        case MS_TOKEN_COMPARISON_RE:
-        {
-            std::string osTmp1(msOGRTranslatePartialInternal(
-                layer, expr->m_aoChildren[0].get(), spatialFilterNode, bPartialFilter ));
-            if( expr->m_aoChildren[1]->m_nToken != MS_TOKEN_LITERAL_STRING )
-            {
-                return std::string();
-            }
-            std::string osRE("'");
-            const size_t nSize = expr->m_aoChildren[1]->m_osVal.size();
-            bool bHasUsedEscape = false;
-            for( size_t i=0; i<nSize;i++ )
-            {
-                if( i == 0 && expr->m_aoChildren[1]->m_osVal[i] == '^' )
-                    continue;
-                if( i == nSize-1 && expr->m_aoChildren[1]->m_osVal[i] == '$' )
-                    break;
-                if( expr->m_aoChildren[1]->m_osVal[i] == '.' )
-                {
-                    if( i+1<nSize &&
-                        expr->m_aoChildren[1]->m_osVal[i+1] == '*' )
-                    {
-                        osRE += "%";
-                        i++;
-                    }
-                    else
-                    {
-                        osRE += "_";
-                    }
-                }
-                else if( expr->m_aoChildren[1]->m_osVal[i] == '\\' &&
-                         i+1<nSize )
-                {
-                    bHasUsedEscape = true;
-                    osRE += 'X';
-                    osRE += expr->m_aoChildren[1]->m_osVal[i+1];
-                    i++;
-                }
-                else if( expr->m_aoChildren[1]->m_osVal[i] == 'X' ||
-                         expr->m_aoChildren[1]->m_osVal[i] == '%' ||
-                         expr->m_aoChildren[1]->m_osVal[i] == '_' )
-                {
-                    bHasUsedEscape = true;
-                    osRE += 'X';
-                    osRE += expr->m_aoChildren[1]->m_osVal[i];
-                }
-                else
-                {
-                    osRE += expr->m_aoChildren[1]->m_osVal[i];
-                }
-            }
-            osRE += "'";
-            char md_item_name[256];
-            snprintf( md_item_name, sizeof(md_item_name), "gml_%s_type",
-                        expr->m_aoChildren[0]->m_osVal.c_str() );
-            const char* type =
-                        msLookupHashTable(&(layer->metadata), md_item_name);
-            // Cast if needed (or unsure)
-            if( type == NULL || !EQUAL(type, "Character") )
-            {
-                osTmp1 = "CAST(" + osTmp1 + " AS CHARACTER(4096))";
-            }
-            std::string osRet( "(" + osTmp1 + " LIKE " + osRE );
-            if( bHasUsedEscape )
-                osRet += " ESCAPE 'X'";
-            osRet += ")";
-            return osRet;
+  case MS_TOKEN_COMPARISON_RE: {
+    std::string osTmp1(msOGRTranslatePartialInternal(
+        layer, expr->m_aoChildren[0].get(), spatialFilterNode, bPartialFilter));
+    if (expr->m_aoChildren[1]->m_nToken != MS_TOKEN_LITERAL_STRING) {
+      return std::string();
+    }
+    std::string osRE("'");
+    const size_t nSize = expr->m_aoChildren[1]->m_osVal.size();
+    bool bHasUsedEscape = false;
+    for (size_t i = 0; i < nSize; i++) {
+      if (i == 0 && expr->m_aoChildren[1]->m_osVal[i] == '^')
+        continue;
+      if (i == nSize - 1 && expr->m_aoChildren[1]->m_osVal[i] == '$')
+        break;
+      if (expr->m_aoChildren[1]->m_osVal[i] == '.') {
+        if (i + 1 < nSize && expr->m_aoChildren[1]->m_osVal[i + 1] == '*') {
+          osRE += "%";
+          i++;
+        } else {
+          osRE += "_";
         }
+      } else if (expr->m_aoChildren[1]->m_osVal[i] == '\\' && i + 1 < nSize) {
+        bHasUsedEscape = true;
+        osRE += 'X';
+        osRE += expr->m_aoChildren[1]->m_osVal[i + 1];
+        i++;
+      } else if (expr->m_aoChildren[1]->m_osVal[i] == 'X' ||
+                 expr->m_aoChildren[1]->m_osVal[i] == '%' ||
+                 expr->m_aoChildren[1]->m_osVal[i] == '_') {
+        bHasUsedEscape = true;
+        osRE += 'X';
+        osRE += expr->m_aoChildren[1]->m_osVal[i];
+      } else {
+        osRE += expr->m_aoChildren[1]->m_osVal[i];
+      }
+    }
+    osRE += "'";
+    char md_item_name[256];
+    snprintf(md_item_name, sizeof(md_item_name), "gml_%s_type",
+             expr->m_aoChildren[0]->m_osVal.c_str());
+    const char *type = msLookupHashTable(&(layer->metadata), md_item_name);
+    // Cast if needed (or unsure)
+    if (type == NULL || !EQUAL(type, "Character")) {
+      osTmp1 = "CAST(" + osTmp1 + " AS CHARACTER(4096))";
+    }
+    std::string osRet("(" + osTmp1 + " LIKE " + osRE);
+    if (bHasUsedEscape)
+      osRet += " ESCAPE 'X'";
+    osRet += ")";
+    return osRet;
+  }
 
-        case MS_TOKEN_COMPARISON_IN:
-        {
-            std::string osTmp1(msOGRTranslatePartialInternal(
-                layer, expr->m_aoChildren[0].get(), spatialFilterNode, bPartialFilter ));
-            std::string osRet = "(" + osTmp1 + " IN (";
-            for( size_t i=0; i< expr->m_aoChildren[1]->m_aoChildren.size(); ++i )
-            {
-                if( i > 0 )
-                    osRet += ", ";
-                osRet += msOGRTranslatePartialInternal(
-                            layer, expr->m_aoChildren[1]->m_aoChildren[i].get(),
-                            spatialFilterNode, bPartialFilter );
-            }
-            osRet += ")";
-            return osRet;
-        }
+  case MS_TOKEN_COMPARISON_IN: {
+    std::string osTmp1(msOGRTranslatePartialInternal(
+        layer, expr->m_aoChildren[0].get(), spatialFilterNode, bPartialFilter));
+    std::string osRet = "(" + osTmp1 + " IN (";
+    for (size_t i = 0; i < expr->m_aoChildren[1]->m_aoChildren.size(); ++i) {
+      if (i > 0)
+        osRet += ", ";
+      osRet += msOGRTranslatePartialInternal(
+          layer, expr->m_aoChildren[1]->m_aoChildren[i].get(),
+          spatialFilterNode, bPartialFilter);
+    }
+    osRet += ")";
+    return osRet;
+  }
 
-        case MS_TOKEN_LITERAL_NUMBER:
-        case MS_TOKEN_LITERAL_BOOLEAN:
-        {
-            return std::string(CPLSPrintf("%.18g", expr->m_dfVal));
-        }
+  case MS_TOKEN_LITERAL_NUMBER:
+  case MS_TOKEN_LITERAL_BOOLEAN: {
+    return std::string(CPLSPrintf("%.18g", expr->m_dfVal));
+  }
 
-        case MS_TOKEN_LITERAL_STRING:
-        {
-            char *stresc = msOGREscapeSQLParam(layer, expr->m_osVal.c_str());
-            std::string osRet("'" + std::string(stresc) + "'");
-            msFree(stresc);
-            return osRet;
-        }
+  case MS_TOKEN_LITERAL_STRING: {
+    char *stresc = msOGREscapeSQLParam(layer, expr->m_osVal.c_str());
+    std::string osRet("'" + std::string(stresc) + "'");
+    msFree(stresc);
+    return osRet;
+  }
 
-        case MS_TOKEN_LITERAL_TIME:
-        {
+  case MS_TOKEN_LITERAL_TIME: {
 #ifdef notdef
-            // Breaks tests in msautotest/wxs/wfs_time_ogr.map
-            return std::string(CPLSPrintf("'%04d/%02d/%02d %02d:%02d:%02d'",
-                     expr->m_tmVal.tm_year+1900,
-                     expr->m_tmVal.tm_mon+1,
-                     expr->m_tmVal.tm_mday,
-                     expr->m_tmVal.tm_hour,
-                     expr->m_tmVal.tm_min,
-                     expr->m_tmVal.tm_sec));
+    // Breaks tests in msautotest/wxs/wfs_time_ogr.map
+    return std::string(CPLSPrintf(
+        "'%04d/%02d/%02d %02d:%02d:%02d'", expr->m_tmVal.tm_year + 1900,
+        expr->m_tmVal.tm_mon + 1, expr->m_tmVal.tm_mday, expr->m_tmVal.tm_hour,
+        expr->m_tmVal.tm_min, expr->m_tmVal.tm_sec));
 #endif
-            return std::string();
-        }
+    return std::string();
+  }
 
-        case MS_TOKEN_BINDING_DOUBLE:
-        case MS_TOKEN_BINDING_INTEGER:
-        case MS_TOKEN_BINDING_STRING:
-        case MS_TOKEN_BINDING_TIME:
-        {
-            char* pszTmp = msOGRGetQuotedItem(layer, expr->m_osVal.c_str());
-            std::string osRet(pszTmp);
-            msFree(pszTmp);
-            return osRet;
-        }
+  case MS_TOKEN_BINDING_DOUBLE:
+  case MS_TOKEN_BINDING_INTEGER:
+  case MS_TOKEN_BINDING_STRING:
+  case MS_TOKEN_BINDING_TIME: {
+    char *pszTmp = msOGRGetQuotedItem(layer, expr->m_osVal.c_str());
+    std::string osRet(pszTmp);
+    msFree(pszTmp);
+    return osRet;
+  }
 
-        case MS_TOKEN_COMPARISON_INTERSECTS:
-        {
-            if( expr != spatialFilterNode )
-                bPartialFilter = true;
-            return std::string();
-        }
+  case MS_TOKEN_COMPARISON_INTERSECTS: {
+    if (expr != spatialFilterNode)
+      bPartialFilter = true;
+    return std::string();
+  }
 
-        default:
-        {
-            bPartialFilter = true;
-            return std::string();
-        }
-    }
+  default: {
+    bPartialFilter = true;
+    return std::string();
+  }
+  }
 }
 
 /* ==================================================================
@@ -3826,200 +3655,192 @@ static std::string msOGRTranslatePartial
  *
  * Tries to translate a mapserver expression to OGR or driver native SQL
  **********************************************************************/
-static int msOGRTranslateMsExpressionToOGRSQL(layerObj* layer,
-                                              expressionObj* psFilter,
-                                              char *filteritem)
-{
-    msOGRFileInfo *info = (msOGRFileInfo *)layer->layerinfo;
-
-    msFree(layer->filter.native_string);
-    layer->filter.native_string = NULL;
+static int msOGRTranslateMsExpressionToOGRSQL(layerObj *layer,
+                                              expressionObj *psFilter,
+                                              char *filteritem) {
+  msOGRFileInfo *info = (msOGRFileInfo *)layer->layerinfo;
+
+  msFree(layer->filter.native_string);
+  layer->filter.native_string = NULL;
+
+  msFree(info->pszWHERE);
+  info->pszWHERE = NULL;
+
+  // reasons to not produce native string: not simple layer, or an explicit deny
+  const char *do_this =
+      msLayerGetProcessingKey(layer, "NATIVE_SQL"); // default is YES
+  if (do_this && strcmp(do_this, "NO") == 0) {
+    return MS_SUCCESS;
+  }
 
-    msFree(info->pszWHERE);
-    info->pszWHERE = NULL;
+  tokenListNodeObjPtr node = psFilter->tokens;
+  auto expr = BuildExprTree(node, NULL, 0);
+  info->rect_is_defined = MS_FALSE;
+  const msExprNode *spatialFilterNode = NULL;
+  if (expr)
+    msOGRExtractTopSpatialFilter(info, expr.get(), &spatialFilterNode);
 
-    // reasons to not produce native string: not simple layer, or an explicit deny
-    const char *do_this = msLayerGetProcessingKey(layer, "NATIVE_SQL"); // default is YES
-    if (do_this && strcmp(do_this, "NO") == 0) {
-        return MS_SUCCESS;
-    }
-
-    tokenListNodeObjPtr node = psFilter->tokens;
-    auto expr = BuildExprTree(node, NULL, 0);
-    info->rect_is_defined = MS_FALSE;
-    const msExprNode* spatialFilterNode = NULL;
-    if( expr )
-        msOGRExtractTopSpatialFilter( info, expr.get(), &spatialFilterNode );
-
-    // more reasons to not produce native string: not a recognized driver
-    if (!info->dialect)
-    {
-        // in which case we might still want to try to get a partial WHERE clause
-        if( filteritem == NULL && expr )
-        {
-            bool bPartialFilter = false;
-            std::string osSQL( msOGRTranslatePartialInternal(layer, expr.get(),
-                                                             spatialFilterNode,
-                                                             bPartialFilter) );
-            if( !osSQL.empty() )
-            {
-                info->pszWHERE = msStrdup(osSQL.c_str());
-                if( bPartialFilter )
-                {
-                    msDebug("Full filter has only been partially "
-                            "translated to OGR filter %s\n",
-                            info->pszWHERE);
-                }
-            }
-            else if( bPartialFilter )
-            {
-                msDebug("Filter could not be translated to OGR filter\n");
-            }
+  // more reasons to not produce native string: not a recognized driver
+  if (!info->dialect) {
+    // in which case we might still want to try to get a partial WHERE clause
+    if (filteritem == NULL && expr) {
+      bool bPartialFilter = false;
+      std::string osSQL(msOGRTranslatePartialInternal(
+          layer, expr.get(), spatialFilterNode, bPartialFilter));
+      if (!osSQL.empty()) {
+        info->pszWHERE = msStrdup(osSQL.c_str());
+        if (bPartialFilter) {
+          msDebug("Full filter has only been partially "
+                  "translated to OGR filter %s\n",
+                  info->pszWHERE);
         }
-        return MS_SUCCESS;
+      } else if (bPartialFilter) {
+        msDebug("Filter could not be translated to OGR filter\n");
+      }
     }
+    return MS_SUCCESS;
+  }
 
-    char *sql = NULL;
+  char *sql = NULL;
 
-    // node may be NULL if layer->filter.string != NULL and filteritem != NULL
-    // this is simple filter but string is regex
-    if (node == NULL && filteritem != NULL && layer->filter.string != NULL) {
-        sql = msStringConcatenate(sql, "\"");
-        sql = msStringConcatenate(sql, filteritem);
-        sql = msStringConcatenate(sql, "\"");
-        if (EQUAL(info->dialect, "PostgreSQL") ) {
-            sql = msStringConcatenate(sql, " ~ ");
-        } else {
-            sql = msStringConcatenate(sql, " LIKE ");
-        }
-        sql = msStringConcatenate(sql, "'");
-        sql = msStringConcatenate(sql, layer->filter.string);
-        sql = msStringConcatenate(sql, "'");
-    }
-
-    while (node != NULL) {
-
-        if (node->next && node->next->token == MS_TOKEN_COMPARISON_IEQ) {
-            char *left = msOGRGetToken(layer, &node);
-            node = node->next; // skip =
-            char *right = msOGRGetToken(layer, &node);
-            sql = msStringConcatenate(sql, "upper(");
-            sql = msStringConcatenate(sql, left);
-            sql = msStringConcatenate(sql, ")");
-            sql = msStringConcatenate(sql, "=");
-            sql = msStringConcatenate(sql, "upper(");
-            sql = msStringConcatenate(sql, right);
-            sql = msStringConcatenate(sql, ")");
-            int ok = left && right;
-            msFree(left);
-            msFree(right);
-            if (!ok) {
-                goto fail;
-            }
-            continue;
-        }
+  // node may be NULL if layer->filter.string != NULL and filteritem != NULL
+  // this is simple filter but string is regex
+  if (node == NULL && filteritem != NULL && layer->filter.string != NULL) {
+    sql = msStringConcatenate(sql, "\"");
+    sql = msStringConcatenate(sql, filteritem);
+    sql = msStringConcatenate(sql, "\"");
+    if (EQUAL(info->dialect, "PostgreSQL")) {
+      sql = msStringConcatenate(sql, " ~ ");
+    } else {
+      sql = msStringConcatenate(sql, " LIKE ");
+    }
+    sql = msStringConcatenate(sql, "'");
+    sql = msStringConcatenate(sql, layer->filter.string);
+    sql = msStringConcatenate(sql, "'");
+  }
+
+  while (node != NULL) {
+
+    if (node->next && node->next->token == MS_TOKEN_COMPARISON_IEQ) {
+      char *left = msOGRGetToken(layer, &node);
+      node = node->next; // skip =
+      char *right = msOGRGetToken(layer, &node);
+      sql = msStringConcatenate(sql, "upper(");
+      sql = msStringConcatenate(sql, left);
+      sql = msStringConcatenate(sql, ")");
+      sql = msStringConcatenate(sql, "=");
+      sql = msStringConcatenate(sql, "upper(");
+      sql = msStringConcatenate(sql, right);
+      sql = msStringConcatenate(sql, ")");
+      int ok = left && right;
+      msFree(left);
+      msFree(right);
+      if (!ok) {
+        goto fail;
+      }
+      continue;
+    }
 
-        switch(node->token) {
-        case MS_TOKEN_COMPARISON_INTERSECTS:
-        case MS_TOKEN_COMPARISON_DISJOINT:
-        case MS_TOKEN_COMPARISON_TOUCHES:
-        case MS_TOKEN_COMPARISON_OVERLAPS:
-        case MS_TOKEN_COMPARISON_CROSSES:
-        case MS_TOKEN_COMPARISON_DWITHIN:
-        case MS_TOKEN_COMPARISON_BEYOND:
-        case MS_TOKEN_COMPARISON_WITHIN:
-        case MS_TOKEN_COMPARISON_CONTAINS:
-        case MS_TOKEN_COMPARISON_EQUALS:{
-            int token = node->token;
-            char *fct = msOGRGetToken(layer, &node);
-            node = node->next; // skip (
-            char *a1 = msOGRGetToken(layer, &node);
-            node = node->next; // skip ,
-            char *a2 = msOGRGetToken(layer, &node);
-            char *a3 = NULL;
-            if (token == MS_TOKEN_COMPARISON_DWITHIN || token == MS_TOKEN_COMPARISON_BEYOND) {
-                node = node->next; // skip ,
-                a3 = msOGRGetToken(layer, &node);
-            }
-            node = node->next; // skip )
-            char *eq = msOGRGetToken(layer, &node);
-            char *rval = msOGRGetToken(layer, &node);
-            if ((eq && strcmp(eq, " != ") == 0) || (rval && strcmp(rval, "FALSE") == 0)) {
-                sql = msStringConcatenate(sql, "NOT ");
-            }
-            // FIXME: case rval is more complex
-            sql = msStringConcatenate(sql, fct);
-            sql = msStringConcatenate(sql, "(");
-            sql = msStringConcatenate(sql, a1);
-            sql = msStringConcatenate(sql, ",");
-            sql = msStringConcatenate(sql, a2);
-            if (token == MS_TOKEN_COMPARISON_DWITHIN || token == MS_TOKEN_COMPARISON_BEYOND) {
-                sql = msStringConcatenate(sql, ")");
-                if (token == MS_TOKEN_COMPARISON_DWITHIN)
-                    sql = msStringConcatenate(sql, "<=");
-                else 
-                    sql = msStringConcatenate(sql, ">");
-                sql = msStringConcatenate(sql, a3);
-            } else {
-                sql = msStringConcatenate(sql, ")");
-            }
-            int ok = fct && a1 && a2 && eq && rval;
-            if (token == MS_TOKEN_COMPARISON_DWITHIN) {
-                ok = ok && a3;
-            }
-            msFree(fct);
-            msFree(a1);
-            msFree(a2);
-            msFree(a3);
-            msFree(eq);
-            msFree(rval);
-            if (!ok) {
-                goto fail;
-            }
-            break;
-        }
-        default: {
-            char *token = msOGRGetToken(layer, &node);
-            if (!token) {
-                goto fail;
-            }
-            sql = msStringConcatenate(sql, token);
-            msFree(token);
-        }
-        }
+    switch (node->token) {
+    case MS_TOKEN_COMPARISON_INTERSECTS:
+    case MS_TOKEN_COMPARISON_DISJOINT:
+    case MS_TOKEN_COMPARISON_TOUCHES:
+    case MS_TOKEN_COMPARISON_OVERLAPS:
+    case MS_TOKEN_COMPARISON_CROSSES:
+    case MS_TOKEN_COMPARISON_DWITHIN:
+    case MS_TOKEN_COMPARISON_BEYOND:
+    case MS_TOKEN_COMPARISON_WITHIN:
+    case MS_TOKEN_COMPARISON_CONTAINS:
+    case MS_TOKEN_COMPARISON_EQUALS: {
+      int token = node->token;
+      char *fct = msOGRGetToken(layer, &node);
+      node = node->next; // skip (
+      char *a1 = msOGRGetToken(layer, &node);
+      node = node->next; // skip ,
+      char *a2 = msOGRGetToken(layer, &node);
+      char *a3 = NULL;
+      if (token == MS_TOKEN_COMPARISON_DWITHIN ||
+          token == MS_TOKEN_COMPARISON_BEYOND) {
+        node = node->next; // skip ,
+        a3 = msOGRGetToken(layer, &node);
+      }
+      node = node->next; // skip )
+      char *eq = msOGRGetToken(layer, &node);
+      char *rval = msOGRGetToken(layer, &node);
+      if ((eq && strcmp(eq, " != ") == 0) ||
+          (rval && strcmp(rval, "FALSE") == 0)) {
+        sql = msStringConcatenate(sql, "NOT ");
+      }
+      // FIXME: case rval is more complex
+      sql = msStringConcatenate(sql, fct);
+      sql = msStringConcatenate(sql, "(");
+      sql = msStringConcatenate(sql, a1);
+      sql = msStringConcatenate(sql, ",");
+      sql = msStringConcatenate(sql, a2);
+      if (token == MS_TOKEN_COMPARISON_DWITHIN ||
+          token == MS_TOKEN_COMPARISON_BEYOND) {
+        sql = msStringConcatenate(sql, ")");
+        if (token == MS_TOKEN_COMPARISON_DWITHIN)
+          sql = msStringConcatenate(sql, "<=");
+        else
+          sql = msStringConcatenate(sql, ">");
+        sql = msStringConcatenate(sql, a3);
+      } else {
+        sql = msStringConcatenate(sql, ")");
+      }
+      int ok = fct && a1 && a2 && eq && rval;
+      if (token == MS_TOKEN_COMPARISON_DWITHIN) {
+        ok = ok && a3;
+      }
+      msFree(fct);
+      msFree(a1);
+      msFree(a2);
+      msFree(a3);
+      msFree(eq);
+      msFree(rval);
+      if (!ok) {
+        goto fail;
+      }
+      break;
     }
+    default: {
+      char *token = msOGRGetToken(layer, &node);
+      if (!token) {
+        goto fail;
+      }
+      sql = msStringConcatenate(sql, token);
+      msFree(token);
+    }
+    }
+  }
 
-    layer->filter.native_string = sql;
-    return MS_SUCCESS;
+  layer->filter.native_string = sql;
+  return MS_SUCCESS;
 fail:
-    // error producing native string
-    msDebug("Note: Error parsing token list, could produce only: %s. Trying in partial mode\n", sql);
-    msFree(sql);
-
-    // in which case we might still want to try to get a partial WHERE clause
-    if( expr )
-    {
-        bool bPartialFilter = false;
-        std::string osSQL( msOGRTranslatePartialInternal(layer, expr.get(),
-                                                            spatialFilterNode,
-                                                            bPartialFilter) );
-        if( !osSQL.empty() )
-        {
-            info->pszWHERE = msStrdup(osSQL.c_str());
-            if( bPartialFilter )
-            {
-                msDebug("Full filter has only been partially "
-                        "translated to OGR filter %s\n",
-                        info->pszWHERE);
-            }
-        }
-        else if( bPartialFilter )
-        {
-            msDebug("Filter could not be translated to OGR filter\n");
-        }
+  // error producing native string
+  msDebug("Note: Error parsing token list, could produce only: %s. Trying in "
+          "partial mode\n",
+          sql);
+  msFree(sql);
+
+  // in which case we might still want to try to get a partial WHERE clause
+  if (expr) {
+    bool bPartialFilter = false;
+    std::string osSQL(msOGRTranslatePartialInternal(
+        layer, expr.get(), spatialFilterNode, bPartialFilter));
+    if (!osSQL.empty()) {
+      info->pszWHERE = msStrdup(osSQL.c_str());
+      if (bPartialFilter) {
+        msDebug("Full filter has only been partially "
+                "translated to OGR filter %s\n",
+                info->pszWHERE);
+      }
+    } else if (bPartialFilter) {
+      msDebug("Filter could not be translated to OGR filter\n");
     }
+  }
 
-    return MS_SUCCESS;
+  return MS_SUCCESS;
 }
 
 /**********************************************************************
@@ -4041,25 +3862,23 @@ fail:
  *
  * Returns MS_SUCCESS/MS_FAILURE
  **********************************************************************/
-int msOGRLayerOpen(layerObj *layer, const char *pszOverrideConnection)
-{
+int msOGRLayerOpen(layerObj *layer, const char *pszOverrideConnection) {
   msOGRFileInfo *psInfo;
 
   if (layer->layerinfo != NULL) {
-    return MS_SUCCESS;  // Nothing to do... layer is already opened
+    return MS_SUCCESS; // Nothing to do... layer is already opened
   }
 
   /* -------------------------------------------------------------------- */
   /*      If this is not a tiled layer, just directly open the target.    */
   /* -------------------------------------------------------------------- */
-  if( layer->tileindex == NULL ) {
-    psInfo = msOGRFileOpen( layer,
-                            (pszOverrideConnection ? pszOverrideConnection:
-                             layer->connection) );
+  if (layer->tileindex == NULL) {
+    psInfo = msOGRFileOpen(layer, (pszOverrideConnection ? pszOverrideConnection
+                                                         : layer->connection));
     layer->layerinfo = psInfo;
     layer->tileitemindex = -1;
 
-    if( layer->layerinfo == NULL )
+    if (layer->layerinfo == NULL)
       return MS_FAILURE;
   }
 
@@ -4071,46 +3890,42 @@ int msOGRLayerOpen(layerObj *layer, cons
   else {
     // Open tile index
 
-    psInfo = msOGRFileOpen( layer, layer->tileindex );
+    psInfo = msOGRFileOpen(layer, layer->tileindex);
     layer->layerinfo = psInfo;
 
-    if( layer->layerinfo == NULL )
+    if (layer->layerinfo == NULL)
       return MS_FAILURE;
 
     // Identify TILEITEM
-    OGRFeatureDefnH hDefn = OGR_L_GetLayerDefn( psInfo->hLayer );
+    OGRFeatureDefnH hDefn = OGR_L_GetLayerDefn(psInfo->hLayer);
     layer->tileitemindex = OGR_FD_GetFieldIndex(hDefn, layer->tileitem);
-    if( layer->tileitemindex < 0 ) {
+    if (layer->tileitemindex < 0) {
       msSetError(MS_OGRERR,
                  "Can't identify TILEITEM %s field in TILEINDEX `%s'.",
-                 "msOGRLayerOpen()",
-                 layer->tileitem, layer->tileindex );
-      msOGRFileClose( layer, psInfo );
+                 "msOGRLayerOpen()", layer->tileitem, layer->tileindex);
+      msOGRFileClose(layer, psInfo);
       layer->layerinfo = NULL;
       return MS_FAILURE;
     }
 
     // Identify TILESRS
-    if( layer->tilesrs != NULL &&
-        OGR_FD_GetFieldIndex(hDefn, layer->tilesrs) < 0 ) {
+    if (layer->tilesrs != NULL &&
+        OGR_FD_GetFieldIndex(hDefn, layer->tilesrs) < 0) {
       msSetError(MS_OGRERR,
                  "Can't identify TILESRS %s field in TILEINDEX `%s'.",
-                 "msOGRLayerOpen()",
-                 layer->tilesrs, layer->tileindex );
-      msOGRFileClose( layer, psInfo );
+                 "msOGRLayerOpen()", layer->tilesrs, layer->tileindex);
+      msOGRFileClose(layer, psInfo);
       layer->layerinfo = NULL;
       return MS_FAILURE;
     }
-    if( layer->tilesrs != NULL && layer->projection.numargs == 0 )
-    {
-        msSetError(MS_OGRERR,
+    if (layer->tilesrs != NULL && layer->projection.numargs == 0) {
+      msSetError(MS_OGRERR,
                  "A layer with TILESRS set in TILEINDEX `%s' must have a "
                  "projection set on itself.",
-                 "msOGRLayerOpen()",
-                 layer->tileindex );
-        msOGRFileClose( layer, psInfo );
-        layer->layerinfo = NULL;
-        return MS_FAILURE;
+                 "msOGRLayerOpen()", layer->tileindex);
+      msOGRFileClose(layer, psInfo);
+      layer->layerinfo = NULL;
+      return MS_FAILURE;
     }
   }
 
@@ -4121,11 +3936,10 @@ int msOGRLayerOpen(layerObj *layer, cons
   if (layer->projection.numargs > 0 &&
       EQUAL(layer->projection.args[0], "auto")) {
     ACQUIRE_OGR_LOCK;
-    OGRSpatialReferenceH hSRS = OGR_L_GetSpatialRef( psInfo->hLayer );
+    OGRSpatialReferenceH hSRS = OGR_L_GetSpatialRef(psInfo->hLayer);
 
-    if (msOGRSpatialRef2ProjectionObj(hSRS,
-                                      &(layer->projection),
-                                      layer->debug ) != MS_SUCCESS) {
+    if (msOGRSpatialRef2ProjectionObj(hSRS, &(layer->projection),
+                                      layer->debug) != MS_SUCCESS) {
       errorObj *ms_error = msGetErrorObj();
 
       RELEASE_OGR_LOCK;
@@ -4133,12 +3947,11 @@ int msOGRLayerOpen(layerObj *layer, cons
                  "%s  "
                  "PROJECTION AUTO cannot be used for this "
                  "OGR connection (in layer `%s').",
-                 "msOGRLayerOpen()",
-                 ms_error->message,
-                 layer->name?layer->name:"(null)" );
-      msOGRFileClose( layer, psInfo );
+                 "msOGRLayerOpen()", ms_error->message,
+                 layer->name ? layer->name : "(null)");
+      msOGRFileClose(layer, psInfo);
       layer->layerinfo = NULL;
-      return(MS_FAILURE);
+      return (MS_FAILURE);
     }
     RELEASE_OGR_LOCK;
   }
@@ -4151,23 +3964,21 @@ int msOGRLayerOpen(layerObj *layer, cons
  *
  * Overloaded version of msOGRLayerOpen for virtual table architecture
  **********************************************************************/
-static int msOGRLayerOpenVT(layerObj *layer)
-{
+static int msOGRLayerOpenVT(layerObj *layer) {
   return msOGRLayerOpen(layer, NULL);
 }
 
 /**********************************************************************
  *                     msOGRLayerClose()
  **********************************************************************/
-int msOGRLayerClose(layerObj *layer)
-{
-  msOGRFileInfo *psInfo =(msOGRFileInfo*)layer->layerinfo;
+int msOGRLayerClose(layerObj *layer) {
+  msOGRFileInfo *psInfo = (msOGRFileInfo *)layer->layerinfo;
 
   if (psInfo) {
-    if( layer->debug )
+    if (layer->debug)
       msDebug("msOGRLayerClose(%s).\n", layer->connection);
 
-    msOGRFileClose( layer, psInfo );
+    msOGRFileClose(layer, psInfo);
     layer->layerinfo = NULL;
   }
 
@@ -4177,24 +3988,24 @@ int msOGRLayerClose(layerObj *layer)
 /**********************************************************************
  *                     msOGRLayerIsOpen()
  **********************************************************************/
-static int msOGRLayerIsOpen(layerObj *layer)
-{
+static int msOGRLayerIsOpen(layerObj *layer) {
   if (layer->layerinfo)
     return MS_TRUE;
 
   return MS_FALSE;
 }
 
-int msOGRSupportsIsNull(layerObj* layer)
-{
-  msOGRFileInfo *psInfo =(msOGRFileInfo*)layer->layerinfo;
+int msOGRSupportsIsNull(layerObj *layer) {
+  msOGRFileInfo *psInfo = (msOGRFileInfo *)layer->layerinfo;
   if (psInfo && psInfo->dialect &&
-      (EQUAL(psInfo->dialect, "Spatialite") || EQUAL(psInfo->dialect, "GPKG")))
-  {
-    // reasons to not produce native string: not simple layer, or an explicit deny
-    const char *do_this = msLayerGetProcessingKey(layer, "NATIVE_SQL"); // default is YES
+      (EQUAL(psInfo->dialect, "Spatialite") ||
+       EQUAL(psInfo->dialect, "GPKG"))) {
+    // reasons to not produce native string: not simple layer, or an explicit
+    // deny
+    const char *do_this =
+        msLayerGetProcessingKey(layer, "NATIVE_SQL"); // default is YES
     if (do_this && strcmp(do_this, "NO") == 0) {
-        return MS_FALSE;
+      return MS_FALSE;
     }
     return MS_TRUE;
   }
@@ -4202,7 +4013,6 @@ int msOGRSupportsIsNull(layerObj* layer)
   return MS_FALSE;
 }
 
-
 /**********************************************************************
  *                     msOGRLayerWhichShapes()
  *
@@ -4211,26 +4021,25 @@ int msOGRSupportsIsNull(layerObj* layer)
  * Returns MS_SUCCESS/MS_FAILURE, or MS_DONE if no shape matching the
  * layer's FILTER overlaps the selected region.
  **********************************************************************/
-int msOGRLayerWhichShapes(layerObj *layer, rectObj rect, int /*isQuery*/)
-{
-  msOGRFileInfo *psInfo =(msOGRFileInfo*)layer->layerinfo;
-  int   status;
+int msOGRLayerWhichShapes(layerObj *layer, rectObj rect, int /*isQuery*/) {
+  msOGRFileInfo *psInfo = (msOGRFileInfo *)layer->layerinfo;
+  int status;
 
   if (psInfo == NULL || psInfo->hLayer == NULL) {
     msSetError(MS_MISCERR, "Assertion failed: OGR layer not opened!!!",
                "msOGRLayerWhichShapes()");
-    return(MS_FAILURE);
+    return (MS_FAILURE);
   }
 
-  status = msOGRFileWhichShapes( layer, rect, psInfo );
+  status = msOGRFileWhichShapes(layer, rect, psInfo);
 
-  if( status != MS_SUCCESS || layer->tileindex == NULL )
+  if (status != MS_SUCCESS || layer->tileindex == NULL)
     return status;
 
   // If we are using a tile index, we need to advance to the first
   // tile matching the spatial query, and load it.
 
-  return msOGRFileReadTile( layer, psInfo );
+  return msOGRFileReadTile(layer, psInfo);
 }
 
 /**********************************************************************
@@ -4240,19 +4049,18 @@ int msOGRLayerWhichShapes(layerObj *laye
  * with a tiled layer, ensure a tile is loaded and use it for the items.
  * It is implicitly assumed that the schemas will match on all tiles.
  **********************************************************************/
-int msOGRLayerGetItems(layerObj *layer)
-{
-  msOGRFileInfo *psInfo =(msOGRFileInfo*)layer->layerinfo;
+int msOGRLayerGetItems(layerObj *layer) {
+  msOGRFileInfo *psInfo = (msOGRFileInfo *)layer->layerinfo;
 
   if (psInfo == NULL || psInfo->hLayer == NULL) {
     msSetError(MS_MISCERR, "Assertion failed: OGR layer not opened!!!",
                "msOGRLayerGetItems()");
-    return(MS_FAILURE);
+    return (MS_FAILURE);
   }
 
-  if( layer->tileindex != NULL ) {
-    if( psInfo->poCurTile == NULL
-        && msOGRFileReadTile( layer, psInfo ) != MS_SUCCESS )
+  if (layer->tileindex != NULL) {
+    if (psInfo->poCurTile == NULL &&
+        msOGRFileReadTile(layer, psInfo) != MS_SUCCESS)
       return MS_FAILURE;
 
     psInfo = psInfo->poCurTile;
@@ -4260,10 +4068,10 @@ int msOGRLayerGetItems(layerObj *layer)
 
   layer->numitems = 0;
   layer->items = msOGRFileGetItems(layer, psInfo);
-  if( layer->items == NULL )
+  if (layer->items == NULL)
     return MS_FAILURE;
 
-  while( layer->items[layer->numitems] != NULL )
+  while (layer->items[layer->numitems] != NULL)
     layer->numitems++;
 
   return msOGRLayerInitItemInfo(layer);
@@ -4274,18 +4082,17 @@ int msOGRLayerGetItems(layerObj *layer)
  *
  * Init the itemindexes array after items[] has been reset in a layer.
  **********************************************************************/
-static int msOGRLayerInitItemInfo(layerObj *layer)
-{
-  msOGRFileInfo *psInfo =(msOGRFileInfo*)layer->layerinfo;
-  int   i;
+static int msOGRLayerInitItemInfo(layerObj *layer) {
+  msOGRFileInfo *psInfo = (msOGRFileInfo *)layer->layerinfo;
+  int i;
   OGRFeatureDefnH hDefn;
 
   if (layer->numitems == 0)
     return MS_SUCCESS;
 
-  if( layer->tileindex != NULL ) {
-    if( psInfo->poCurTile == NULL
-        && msOGRFileReadTile( layer, psInfo, -2 ) != MS_SUCCESS )
+  if (layer->tileindex != NULL) {
+    if (psInfo->poCurTile == NULL &&
+        msOGRFileReadTile(layer, psInfo, -2) != MS_SUCCESS)
       return MS_FAILURE;
 
     psInfo = psInfo->poCurTile;
@@ -4294,24 +4101,25 @@ static int msOGRLayerInitItemInfo(layerO
   if (psInfo == NULL || psInfo->hLayer == NULL) {
     msSetError(MS_MISCERR, "Assertion failed: OGR layer not opened!!!",
                "msOGRLayerInitItemInfo()");
-    return(MS_FAILURE);
+    return (MS_FAILURE);
   }
 
-  if((hDefn = OGR_L_GetLayerDefn( psInfo->hLayer )) == NULL) {
+  if ((hDefn = OGR_L_GetLayerDefn(psInfo->hLayer)) == NULL) {
     msSetError(MS_OGRERR, "Layer contains no fields.",
                "msOGRLayerInitItemInfo()");
-    return(MS_FAILURE);
+    return (MS_FAILURE);
   }
 
   if (layer->iteminfo)
     free(layer->iteminfo);
-  if((layer->iteminfo = (int *)malloc(sizeof(int)*layer->numitems))== NULL) {
+  if ((layer->iteminfo = (int *)malloc(sizeof(int) * layer->numitems)) ==
+      NULL) {
     msSetError(MS_MEMERR, NULL, "msOGRLayerInitItemInfo()");
-    return(MS_FAILURE);
+    return (MS_FAILURE);
   }
 
-  int *itemindexes = (int*)layer->iteminfo;
-  for(i=0; i<layer->numitems; i++) {
+  int *itemindexes = (int *)layer->iteminfo;
+  for (i = 0; i < layer->numitems; i++) {
     // Special case for handling text string and angle coming from
     // OGR style strings.  We use special attribute snames.
     if (EQUAL(layer->items[i], MSOGR_LABELFONTNAMENAME))
@@ -4356,39 +4164,38 @@ static int msOGRLayerInitItemInfo(layerO
       itemindexes[i] = MSOGR_LABELHCOLORINDEX;
     else if (EQUAL(layer->items[i], MSOGR_LABELOCOLORNAME))
       itemindexes[i] = MSOGR_LABELOCOLORINDEX;
-    else if (EQUALN(layer->items[i], MSOGR_LABELPARAMNAME, MSOGR_LABELPARAMNAMELEN))
-        itemindexes[i] = MSOGR_LABELPARAMINDEX 
-                          + atoi(layer->items[i] + MSOGR_LABELPARAMNAMELEN);
-    else if (EQUALN(layer->items[i], MSOGR_BRUSHPARAMNAME, MSOGR_BRUSHPARAMNAMELEN))
-        itemindexes[i] = MSOGR_BRUSHPARAMINDEX 
-                          + atoi(layer->items[i] + MSOGR_BRUSHPARAMNAMELEN);
+    else if (EQUALN(layer->items[i], MSOGR_LABELPARAMNAME,
+                    MSOGR_LABELPARAMNAMELEN))
+      itemindexes[i] = MSOGR_LABELPARAMINDEX +
+                       atoi(layer->items[i] + MSOGR_LABELPARAMNAMELEN);
+    else if (EQUALN(layer->items[i], MSOGR_BRUSHPARAMNAME,
+                    MSOGR_BRUSHPARAMNAMELEN))
+      itemindexes[i] = MSOGR_BRUSHPARAMINDEX +
+                       atoi(layer->items[i] + MSOGR_BRUSHPARAMNAMELEN);
     else if (EQUALN(layer->items[i], MSOGR_PENPARAMNAME, MSOGR_PENPARAMNAMELEN))
-        itemindexes[i] = MSOGR_PENPARAMINDEX 
-                          + atoi(layer->items[i] + MSOGR_PENPARAMNAMELEN);
-    else if (EQUALN(layer->items[i], MSOGR_SYMBOLPARAMNAME, MSOGR_SYMBOLPARAMNAMELEN))
-        itemindexes[i] = MSOGR_SYMBOLPARAMINDEX 
-                          + atoi(layer->items[i] + MSOGR_SYMBOLPARAMNAMELEN);
-    else
-    {
-      itemindexes[i] = OGR_FD_GetFieldIndex( hDefn, layer->items[i] );
-      if( itemindexes[i] == -1 )
-      {
-          if( EQUAL( layer->items[i], OGR_L_GetFIDColumn( psInfo->hLayer ) ) )
-          {
-              itemindexes[i] = MSOGR_FID_INDEX;
-          }
+      itemindexes[i] =
+          MSOGR_PENPARAMINDEX + atoi(layer->items[i] + MSOGR_PENPARAMNAMELEN);
+    else if (EQUALN(layer->items[i], MSOGR_SYMBOLPARAMNAME,
+                    MSOGR_SYMBOLPARAMNAMELEN))
+      itemindexes[i] = MSOGR_SYMBOLPARAMINDEX +
+                       atoi(layer->items[i] + MSOGR_SYMBOLPARAMNAMELEN);
+    else {
+      itemindexes[i] = OGR_FD_GetFieldIndex(hDefn, layer->items[i]);
+      if (itemindexes[i] == -1) {
+        if (EQUAL(layer->items[i], OGR_L_GetFIDColumn(psInfo->hLayer))) {
+          itemindexes[i] = MSOGR_FID_INDEX;
+        }
       }
     }
-    if(itemindexes[i] == -1) {
-      msSetError(MS_OGRERR,
-                 "Invalid Field name: %s in layer `%s'",
-                 "msOGRLayerInitItemInfo()",
-                 layer->items[i], layer->name ? layer->name : "(null)");
-      return(MS_FAILURE);
+    if (itemindexes[i] == -1) {
+      msSetError(MS_OGRERR, "Invalid Field name: %s in layer `%s'",
+                 "msOGRLayerInitItemInfo()", layer->items[i],
+                 layer->name ? layer->name : "(null)");
+      return (MS_FAILURE);
     }
   }
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
 /**********************************************************************
@@ -4396,15 +4203,13 @@ static int msOGRLayerInitItemInfo(layerO
  *
  * Free the itemindexes array in a layer.
  **********************************************************************/
-void msOGRLayerFreeItemInfo(layerObj *layer)
-{
+void msOGRLayerFreeItemInfo(layerObj *layer) {
 
   if (layer->iteminfo)
     free(layer->iteminfo);
   layer->iteminfo = NULL;
 }
 
-
 /**********************************************************************
  *                     msOGRLayerNextShape()
  *
@@ -4413,34 +4218,31 @@ void msOGRLayerFreeItemInfo(layerObj *la
  *
  * Returns MS_SUCCESS/MS_FAILURE
  **********************************************************************/
-int msOGRLayerNextShape(layerObj *layer, shapeObj *shape)
-{
-  msOGRFileInfo *psInfo =(msOGRFileInfo*)layer->layerinfo;
-  int  status;
+int msOGRLayerNextShape(layerObj *layer, shapeObj *shape) {
+  msOGRFileInfo *psInfo = (msOGRFileInfo *)layer->layerinfo;
+  int status;
 
   if (psInfo == NULL || psInfo->hLayer == NULL) {
     msSetError(MS_MISCERR, "Assertion failed: OGR layer not opened!!!",
                "msOGRLayerNextShape()");
-    return(MS_FAILURE);
+    return (MS_FAILURE);
   }
 
-  if( layer->tileindex == NULL )
-    return msOGRFileNextShape( layer, shape, psInfo );
+  if (layer->tileindex == NULL)
+    return msOGRFileNextShape(layer, shape, psInfo);
 
   // Do we need to load the first tile?
-  if( psInfo->poCurTile == NULL ) {
-    status = msOGRFileReadTile( layer, psInfo );
-    if( status != MS_SUCCESS )
+  if (psInfo->poCurTile == NULL) {
+    status = msOGRFileReadTile(layer, psInfo);
+    if (status != MS_SUCCESS)
       return status;
   }
 
   do {
     // Try getting a shape from this tile.
-    status = msOGRFileNextShape( layer, shape, psInfo->poCurTile );
-    if( status != MS_DONE )
-    {
-      if( psInfo->sTileProj.numargs > 0 )
-      {
+    status = msOGRFileNextShape(layer, shape, psInfo->poCurTile);
+    if (status != MS_DONE) {
+      if (psInfo->sTileProj.numargs > 0) {
         msProjectShape(&(psInfo->sTileProj), &(layer->projection), shape);
       }
 
@@ -4448,11 +4250,11 @@ int msOGRLayerNextShape(layerObj *layer,
     }
 
     // try next tile.
-    status = msOGRFileReadTile( layer, psInfo );
-    if( status != MS_SUCCESS )
+    status = msOGRFileReadTile(layer, psInfo);
+    if (status != MS_SUCCESS)
       return status;
-  } while( status == MS_SUCCESS );
-  return status; //make compiler happy. this is never reached however
+  } while (status == MS_SUCCESS);
+  return status; // make compiler happy. this is never reached however
 }
 
 /**********************************************************************
@@ -4462,9 +4264,8 @@ int msOGRLayerNextShape(layerObj *layer,
  *
  * Returns MS_SUCCESS/MS_FAILURE
  **********************************************************************/
-int msOGRLayerGetShape(layerObj *layer, shapeObj *shape, resultObj *record)
-{
-  msOGRFileInfo *psInfo =(msOGRFileInfo*)layer->layerinfo;
+int msOGRLayerGetShape(layerObj *layer, shapeObj *shape, resultObj *record) {
+  msOGRFileInfo *psInfo = (msOGRFileInfo *)layer->layerinfo;
 
   long shapeindex = record->shapeindex;
   int tileindex = record->tileindex;
@@ -4478,22 +4279,22 @@ int msOGRLayerGetShape(layerObj *layer,
   }
 
   if (psInfo == NULL || psInfo->hLayer == NULL) {
-    msSetError(MS_MISCERR, "Assertion failed: OGR layer not opened!!!", "msOGRLayerGetShape()");
-    return(MS_FAILURE);
+    msSetError(MS_MISCERR, "Assertion failed: OGR layer not opened!!!",
+               "msOGRLayerGetShape()");
+    return (MS_FAILURE);
   }
 
-  if( layer->tileindex == NULL )
-    return msOGRFileGetShape(layer, shape, shapeindex, psInfo, record_is_fid );
+  if (layer->tileindex == NULL)
+    return msOGRFileGetShape(layer, shape, shapeindex, psInfo, record_is_fid);
   else {
-    if( psInfo->poCurTile == NULL
-        || psInfo->poCurTile->nTileId != tileindex ) {
-      if( msOGRFileReadTile( layer, psInfo, tileindex ) != MS_SUCCESS )
+    if (psInfo->poCurTile == NULL || psInfo->poCurTile->nTileId != tileindex) {
+      if (msOGRFileReadTile(layer, psInfo, tileindex) != MS_SUCCESS)
         return MS_FAILURE;
     }
 
-    int status = msOGRFileGetShape(layer, shape, shapeindex, psInfo->poCurTile, record_is_fid );
-    if( status == MS_SUCCESS && psInfo->sTileProj.numargs > 0 )
-    {
+    int status = msOGRFileGetShape(layer, shape, shapeindex, psInfo->poCurTile,
+                                   record_is_fid);
+    if (status == MS_SUCCESS && psInfo->sTileProj.numargs > 0) {
       msProjectShape(&(psInfo->sTileProj), &(layer->projection), shape);
     }
     return status;
@@ -4507,15 +4308,14 @@ int msOGRLayerGetShape(layerObj *layer,
  *
  * Returns MS_SUCCESS/MS_FAILURE
  **********************************************************************/
-int msOGRLayerGetExtent(layerObj *layer, rectObj *extent)
-{
-  msOGRFileInfo *psInfo =(msOGRFileInfo*)layer->layerinfo;
+int msOGRLayerGetExtent(layerObj *layer, rectObj *extent) {
+  msOGRFileInfo *psInfo = (msOGRFileInfo *)layer->layerinfo;
   OGREnvelope oExtent;
 
   if (psInfo == NULL || psInfo->hLayer == NULL) {
     msSetError(MS_MISCERR, "Assertion failed: OGR layer not opened!!!",
                "msOGRLayerGetExtent()");
-    return(MS_FAILURE);
+    return (MS_FAILURE);
   }
 
   /* ------------------------------------------------------------------
@@ -4526,11 +4326,11 @@ int msOGRLayerGetExtent(layerObj *layer,
    * extents of the tile index.
    * ------------------------------------------------------------------ */
   ACQUIRE_OGR_LOCK;
-  if (OGR_L_GetExtent( psInfo->hLayer, &oExtent, TRUE) != OGRERR_NONE) {
+  if (OGR_L_GetExtent(psInfo->hLayer, &oExtent, TRUE) != OGRERR_NONE) {
     RELEASE_OGR_LOCK;
     msSetError(MS_MISCERR, "Unable to get extents for this layer.",
                "msOGRLayerGetExtent()");
-    return(MS_FAILURE);
+    return (MS_FAILURE);
   }
   RELEASE_OGR_LOCK;
 
@@ -4543,32 +4343,31 @@ int msOGRLayerGetExtent(layerObj *layer,
 }
 
 /**********************************************************************
-*                     msOGRLayerGetNumFeatures()
-*
-* Returns the layer feature count.
-*
-* Returns the number of features on success, -1 on error
-**********************************************************************/
-int msOGRLayerGetNumFeatures(layerObj *layer)
-{
-    msOGRFileInfo *psInfo = (msOGRFileInfo*)layer->layerinfo;
-    int result;
+ *                     msOGRLayerGetNumFeatures()
+ *
+ * Returns the layer feature count.
+ *
+ * Returns the number of features on success, -1 on error
+ **********************************************************************/
+int msOGRLayerGetNumFeatures(layerObj *layer) {
+  msOGRFileInfo *psInfo = (msOGRFileInfo *)layer->layerinfo;
+  int result;
 
-    if (psInfo == NULL || psInfo->hLayer == NULL) {
-        msSetError(MS_MISCERR, "Assertion failed: OGR layer not opened!!!",
-            "msOGRLayerGetNumFeatures()");
-        return -1;
-    }
+  if (psInfo == NULL || psInfo->hLayer == NULL) {
+    msSetError(MS_MISCERR, "Assertion failed: OGR layer not opened!!!",
+               "msOGRLayerGetNumFeatures()");
+    return -1;
+  }
 
-    /* ------------------------------------------------------------------
-    * Call OGR's GetFeatureCount()... note that for some formats this will
-    * result in a scan of the whole layer and can be an expensive call.
-    * ------------------------------------------------------------------ */
-    ACQUIRE_OGR_LOCK;
-    result = (int)OGR_L_GetFeatureCount(psInfo->hLayer, TRUE);
-    RELEASE_OGR_LOCK;
+  /* ------------------------------------------------------------------
+   * Call OGR's GetFeatureCount()... note that for some formats this will
+   * result in a scan of the whole layer and can be an expensive call.
+   * ------------------------------------------------------------------ */
+  ACQUIRE_OGR_LOCK;
+  result = (int)OGR_L_GetFeatureCount(psInfo->hLayer, TRUE);
+  RELEASE_OGR_LOCK;
 
-    return result;
+  return result;
 }
 
 /**********************************************************************
@@ -4579,28 +4378,28 @@ int msOGRLayerGetNumFeatures(layerObj *l
  * default symbol name, and if not found return 0.
  **********************************************************************/
 static int msOGRGetSymbolId(symbolSetObj *symbolset, const char *pszSymbolId,
-                            const char *pszDefaultSymbol, int try_addimage_if_notfound)
-{
+                            const char *pszDefaultSymbol,
+                            int try_addimage_if_notfound) {
   // Symbol name mapping:
   // First look for the native symbol name, then the ogr-...
   // generic name, and in last resort try pszDefaultSymbol if
   // provided by user.
-  char  **params;
-  int   numparams;
-  int   nSymbol = -1;
+  char **params;
+  int numparams;
+  int nSymbol = -1;
 
   if (pszSymbolId && pszSymbolId[0] != '\0') {
     params = msStringSplit(pszSymbolId, ',', &numparams);
     if (params != NULL) {
-      for(int j=0; j<numparams && nSymbol == -1; j++) {
-        nSymbol = msGetSymbolIndex(symbolset, params[j],
-                                   try_addimage_if_notfound);
+      for (int j = 0; j < numparams && nSymbol == -1; j++) {
+        nSymbol =
+            msGetSymbolIndex(symbolset, params[j], try_addimage_if_notfound);
       }
       msFreeCharArray(params, numparams);
     }
   }
   if (nSymbol == -1 && pszDefaultSymbol) {
-    nSymbol = msGetSymbolIndex(symbolset,(char*)pszDefaultSymbol,
+    nSymbol = msGetSymbolIndex(symbolset, (char *)pszDefaultSymbol,
                                try_addimage_if_notfound);
   }
   if (nSymbol == -1)
@@ -4612,20 +4411,23 @@ static int msOGRGetSymbolId(symbolSetObj
 static int msOGRUpdateStyleParseLabel(mapObj *map, layerObj *layer, classObj *c,
                                       OGRStyleToolH hLabelStyle);
 static int msOGRUpdateStyleParsePen(mapObj *map, layerObj *layer, styleObj *s,
-                                    OGRStyleToolH hPenStyle, int bIsBrush, int* pbPriority);
+                                    OGRStyleToolH hPenStyle, int bIsBrush,
+                                    int *pbPriority);
 static int msOGRUpdateStyleParseBrush(mapObj *map, layerObj *layer, styleObj *s,
-                                      OGRStyleToolH hBrushStyle, int* pbIsBrush, int* pbPriority);
+                                      OGRStyleToolH hBrushStyle, int *pbIsBrush,
+                                      int *pbPriority);
 static int msOGRUpdateStyleParseSymbol(mapObj *map, styleObj *s,
-                                       OGRStyleToolH hSymbolStyle, int* pbPriority);
-static int msOGRAddBgColorStyleParseBrush(styleObj* s, OGRStyleToolH hSymbolStyle);
+                                       OGRStyleToolH hSymbolStyle,
+                                       int *pbPriority);
+static int msOGRAddBgColorStyleParseBrush(styleObj *s,
+                                          OGRStyleToolH hSymbolStyle);
 
-static int msOGRUpdateStyleCheckPenBrushOnly(OGRStyleMgrH hStyleMgr)
-{
+static int msOGRUpdateStyleCheckPenBrushOnly(OGRStyleMgrH hStyleMgr) {
   int numParts = OGR_SM_GetPartCount(hStyleMgr, NULL);
   int countPen = 0, countBrush = 0;
   int bIsNull;
 
-  for(int i=0; i<numParts; i++) {
+  for (int i = 0; i < numParts; i++) {
     OGRSTClassId eStylePartType;
     OGRStyleToolH hStylePart = OGR_SM_GetPart(hStyleMgr, i, NULL);
     if (!hStylePart)
@@ -4633,22 +4435,20 @@ static int msOGRUpdateStyleCheckPenBrush
 
     eStylePartType = OGR_ST_GetType(hStylePart);
     if (eStylePartType == OGRSTCPen) {
-      countPen ++;
+      countPen++;
       OGR_ST_GetParamNum(hStylePart, OGRSTPenPriority, &bIsNull);
-      if( !bIsNull ) {
+      if (!bIsNull) {
         OGR_ST_Destroy(hStylePart);
         return MS_FALSE;
       }
-    }
-    else if (eStylePartType == OGRSTCBrush) {
-      countBrush ++;
+    } else if (eStylePartType == OGRSTCBrush) {
+      countBrush++;
       OGR_ST_GetParamNum(hStylePart, OGRSTBrushPriority, &bIsNull);
-      if( !bIsNull ) {
+      if (!bIsNull) {
         OGR_ST_Destroy(hStylePart);
         return MS_FALSE;
       }
-    }
-    else if (eStylePartType == OGRSTCSymbol) {
+    } else if (eStylePartType == OGRSTCSymbol) {
       OGR_ST_Destroy(hStylePart);
       return MS_FALSE;
     }
@@ -4665,33 +4465,34 @@ static int msOGRUpdateStyleCheckPenBrush
  * msOGRUpdateStyleFromString
  **********************************************************************/
 
-typedef struct
-{
-    int nPriority; /* the explicit priority as specified by the 'l' option of PEN, BRUSH and SYMBOL tools */
-    int nApparitionIndex; /* the index of the tool as parsed from the OGR feature style string */
+typedef struct {
+  int nPriority; /* the explicit priority as specified by the 'l' option of PEN,
+                    BRUSH and SYMBOL tools */
+  int nApparitionIndex; /* the index of the tool as parsed from the OGR feature
+                           style string */
 } StyleSortStruct;
 
-static int msOGRUpdateStyleSortFct(const void* pA, const void* pB)
-{
-    StyleSortStruct* sssa = (StyleSortStruct*)pA;
-    StyleSortStruct* sssb = (StyleSortStruct*)pB;
-    if( sssa->nPriority < sssb->nPriority )
-        return -1;
-    else if( sssa->nPriority > sssb->nPriority )
-        return 1;
-    else if( sssa->nApparitionIndex < sssb->nApparitionIndex )
-        return -1;
-    else
-        return 1;
+static int msOGRUpdateStyleSortFct(const void *pA, const void *pB) {
+  StyleSortStruct *sssa = (StyleSortStruct *)pA;
+  StyleSortStruct *sssb = (StyleSortStruct *)pB;
+  if (sssa->nPriority < sssb->nPriority)
+    return -1;
+  else if (sssa->nPriority > sssb->nPriority)
+    return 1;
+  else if (sssa->nApparitionIndex < sssb->nApparitionIndex)
+    return -1;
+  else
+    return 1;
 }
 
-static int msOGRUpdateStyle(OGRStyleMgrH hStyleMgr, mapObj *map, layerObj *layer, classObj *c)
-{
-  GBool bIsBrush=MS_FALSE;
+static int msOGRUpdateStyle(OGRStyleMgrH hStyleMgr, mapObj *map,
+                            layerObj *layer, classObj *c) {
+  GBool bIsBrush = MS_FALSE;
   int numParts = OGR_SM_GetPartCount(hStyleMgr, NULL);
   int nPriority;
   int bIsPenBrushOnly = msOGRUpdateStyleCheckPenBrushOnly(hStyleMgr);
-  StyleSortStruct* pasSortStruct = (StyleSortStruct*) msSmallMalloc(sizeof(StyleSortStruct) * numParts);
+  StyleSortStruct *pasSortStruct =
+      (StyleSortStruct *)msSmallMalloc(sizeof(StyleSortStruct) * numParts);
   int iSortStruct = 0;
   int iBaseStyleIndex = c->numstyles;
   int i;
@@ -4700,7 +4501,7 @@ static int msOGRUpdateStyle(OGRStyleMgrH
    * Handle each part
    * ------------------------------------------------------------------ */
 
-  for(i=0; i<numParts; i++) {
+  for (i = 0; i < numParts; i++) {
     OGRSTClassId eStylePartType;
     OGRStyleToolH hStylePart = OGR_SM_GetPart(hStyleMgr, i, NULL);
     if (!hStylePart)
@@ -4718,35 +4519,35 @@ static int msOGRUpdateStyle(OGRStyleMgrH
     // as long as use the same assumptions everywhere)
     // That gives scale = cellsize*72*39.37
 
-    OGR_ST_SetUnit(hStylePart, OGRSTUPixel, 
-      map->cellsize*map->resolution/map->defresolution*72.0*39.37);
+    OGR_ST_SetUnit(hStylePart, OGRSTUPixel,
+                   map->cellsize * map->resolution / map->defresolution * 72.0 *
+                       39.37);
 
     if (eStylePartType == OGRSTCLabel) {
       int ret = msOGRUpdateStyleParseLabel(map, layer, c, hStylePart);
-      if( ret != MS_SUCCESS ) {
+      if (ret != MS_SUCCESS) {
         OGR_ST_Destroy(hStylePart);
         msFree(pasSortStruct);
         return ret;
       }
     } else if (eStylePartType == OGRSTCPen) {
-      styleObj* s;
+      styleObj *s;
       int nIndex;
-      if( bIsPenBrushOnly ) {
+      if (bIsPenBrushOnly) {
         /* Historic behaviour when there is a PEN and BRUSH only */
         if (bIsBrush || layer->type == MS_LAYER_POLYGON)
-            // This is a multipart symbology, so pen defn goes in the
-            // overlaysymbol params
-            nIndex = c->numstyles + 1;
+          // This is a multipart symbology, so pen defn goes in the
+          // overlaysymbol params
+          nIndex = c->numstyles + 1;
         else
-            nIndex = c->numstyles;
-      }
-      else
+          nIndex = c->numstyles;
+      } else
         nIndex = c->numstyles;
 
       if (msMaybeAllocateClassStyle(c, nIndex)) {
         OGR_ST_Destroy(hStylePart);
         msFree(pasSortStruct);
-        return(MS_FAILURE);
+        return (MS_FAILURE);
       }
       s = c->styles[nIndex];
 
@@ -4754,7 +4555,7 @@ static int msOGRUpdateStyle(OGRStyleMgrH
 
     } else if (eStylePartType == OGRSTCBrush) {
 
-      styleObj* s;
+      styleObj *s;
       int nIndex = 0;
 
       GBool bBgColorIsNull = MS_TRUE;
@@ -4762,10 +4563,10 @@ static int msOGRUpdateStyle(OGRStyleMgrH
 
       if (!bBgColorIsNull) {
 
-       if (msMaybeAllocateClassStyle(c, nIndex)) {
-            OGR_ST_Destroy(hStylePart);
-            msFree(pasSortStruct);
-            return(MS_FAILURE);
+        if (msMaybeAllocateClassStyle(c, nIndex)) {
+          OGR_ST_Destroy(hStylePart);
+          msFree(pasSortStruct);
+          return (MS_FAILURE);
         }
 
         // add a backgroundcolor as a separate style
@@ -4773,521 +4574,491 @@ static int msOGRUpdateStyle(OGRStyleMgrH
         msOGRAddBgColorStyleParseBrush(s, hStylePart);
       }
 
-
-      nIndex = ( bIsPenBrushOnly ) ? nIndex : c->numstyles;
+      nIndex = (bIsPenBrushOnly) ? nIndex : c->numstyles;
 
       if (!bBgColorIsNull) {
-          // if we have a bgcolor style we need to increase the index
-          nIndex += 1;
+        // if we have a bgcolor style we need to increase the index
+        nIndex += 1;
       }
 
       /* We need 1 style */
       if (msMaybeAllocateClassStyle(c, nIndex)) {
         OGR_ST_Destroy(hStylePart);
         msFree(pasSortStruct);
-        return(MS_FAILURE);
+        return (MS_FAILURE);
       }
       s = c->styles[nIndex];
 
-      msOGRUpdateStyleParseBrush(map, layer, s, hStylePart, &bIsBrush, &nPriority);
+      msOGRUpdateStyleParseBrush(map, layer, s, hStylePart, &bIsBrush,
+                                 &nPriority);
 
     } else if (eStylePartType == OGRSTCSymbol) {
-      styleObj* s;
+      styleObj *s;
       /* We need 1 style */
       int nIndex = c->numstyles;
       if (msMaybeAllocateClassStyle(c, nIndex)) {
         OGR_ST_Destroy(hStylePart);
         msFree(pasSortStruct);
-        return(MS_FAILURE);
+        return (MS_FAILURE);
       }
       s = c->styles[nIndex];
 
       msOGRUpdateStyleParseSymbol(map, s, hStylePart, &nPriority);
     }
 
-    /* Memorize the explicit priority and apparition order of the parsed tool/style */
-    if( !bIsPenBrushOnly &&
+    /* Memorize the explicit priority and apparition order of the parsed
+     * tool/style */
+    if (!bIsPenBrushOnly &&
         (eStylePartType == OGRSTCPen || eStylePartType == OGRSTCBrush ||
-         eStylePartType == OGRSTCSymbol) ) {
-        pasSortStruct[iSortStruct].nPriority = nPriority;
-        pasSortStruct[iSortStruct].nApparitionIndex = iSortStruct;
-        iSortStruct++;
+         eStylePartType == OGRSTCSymbol)) {
+      pasSortStruct[iSortStruct].nPriority = nPriority;
+      pasSortStruct[iSortStruct].nApparitionIndex = iSortStruct;
+      iSortStruct++;
     }
 
     OGR_ST_Destroy(hStylePart);
-
   }
 
-  if( iSortStruct > 1 && !bIsPenBrushOnly ) {
-      /* Compute style order based on their explicit priority and apparition order */
-      qsort(pasSortStruct, iSortStruct, sizeof(StyleSortStruct), msOGRUpdateStyleSortFct);
-
-      /* Now reorder styles in c->styles */
-      styleObj** ppsStyleTmp = (styleObj**)msSmallMalloc( iSortStruct * sizeof(styleObj*) );
-      memcpy( ppsStyleTmp, c->styles + iBaseStyleIndex, iSortStruct * sizeof(styleObj*) );
-      for( i = 0; i < iSortStruct; i++)
-      {
-          c->styles[iBaseStyleIndex + i] = ppsStyleTmp[pasSortStruct[i].nApparitionIndex];
-      }
-      msFree(ppsStyleTmp);
+  if (iSortStruct > 1 && !bIsPenBrushOnly) {
+    /* Compute style order based on their explicit priority and apparition order
+     */
+    qsort(pasSortStruct, iSortStruct, sizeof(StyleSortStruct),
+          msOGRUpdateStyleSortFct);
+
+    /* Now reorder styles in c->styles */
+    styleObj **ppsStyleTmp =
+        (styleObj **)msSmallMalloc(iSortStruct * sizeof(styleObj *));
+    memcpy(ppsStyleTmp, c->styles + iBaseStyleIndex,
+           iSortStruct * sizeof(styleObj *));
+    for (i = 0; i < iSortStruct; i++) {
+      c->styles[iBaseStyleIndex + i] =
+          ppsStyleTmp[pasSortStruct[i].nApparitionIndex];
+    }
+    msFree(ppsStyleTmp);
   }
-  
+
   msFree(pasSortStruct);
-  
+
   return MS_SUCCESS;
 }
 
 static int msOGRUpdateStyleParseLabel(mapObj *map, layerObj *layer, classObj *c,
-                                      OGRStyleToolH hLabelStyle)
-{
+                                      OGRStyleToolH hLabelStyle) {
   GBool bIsNull;
-  int r=0,g=0,b=0,t=0;
-
-      // Enclose the text string inside quotes to make sure it is seen
-      // as a string by the parser inside loadExpression(). (bug185)
-      /* See bug 3481 about the isalnum hack */
-      const char *labelTextString = OGR_ST_GetParamStr(hLabelStyle,
-                                    OGRSTLabelTextString,
-                                    &bIsNull);
-
-      if (c->numlabels == 0) {
-        /* allocate a new label object */
-        if(msGrowClassLabels(c) == NULL) 
-          return MS_FAILURE;
-        c->numlabels++;
-        initLabel(c->labels[0]);
-      }
-      msFreeExpression(&c->labels[0]->text);
-      c->labels[0]->text.type = MS_STRING;
-      c->labels[0]->text.string = msStrdup(labelTextString);
-
-      c->labels[0]->angle = OGR_ST_GetParamDbl(hLabelStyle,
-                            OGRSTLabelAngle, &bIsNull);
-
-      c->labels[0]->size = OGR_ST_GetParamDbl(hLabelStyle,
-                                              OGRSTLabelSize, &bIsNull);
-      if( c->labels[0]->size < 1 ) /* no point dropping to zero size */
-        c->labels[0]->size = 1;
+  int r = 0, g = 0, b = 0, t = 0;
 
-      // OGR default is anchor point = LL, so label is at UR of anchor
+  // Enclose the text string inside quotes to make sure it is seen
+  // as a string by the parser inside loadExpression(). (bug185)
+  /* See bug 3481 about the isalnum hack */
+  const char *labelTextString =
+      OGR_ST_GetParamStr(hLabelStyle, OGRSTLabelTextString, &bIsNull);
+
+  if (c->numlabels == 0) {
+    /* allocate a new label object */
+    if (msGrowClassLabels(c) == NULL)
+      return MS_FAILURE;
+    c->numlabels++;
+    initLabel(c->labels[0]);
+  }
+  msFreeExpression(&c->labels[0]->text);
+  c->labels[0]->text.type = MS_STRING;
+  c->labels[0]->text.string = msStrdup(labelTextString);
+
+  c->labels[0]->angle =
+      OGR_ST_GetParamDbl(hLabelStyle, OGRSTLabelAngle, &bIsNull);
+
+  c->labels[0]->size =
+      OGR_ST_GetParamDbl(hLabelStyle, OGRSTLabelSize, &bIsNull);
+  if (c->labels[0]->size < 1) /* no point dropping to zero size */
+    c->labels[0]->size = 1;
+
+  // OGR default is anchor point = LL, so label is at UR of anchor
+  c->labels[0]->position = MS_UR;
+
+  int nPosition = OGR_ST_GetParamNum(hLabelStyle, OGRSTLabelAnchor, &bIsNull);
+  if (!bIsNull) {
+    switch (nPosition) {
+    case 1:
       c->labels[0]->position = MS_UR;
+      break;
+    case 2:
+      c->labels[0]->position = MS_UC;
+      break;
+    case 3:
+      c->labels[0]->position = MS_UL;
+      break;
+    case 4:
+      c->labels[0]->position = MS_CR;
+      break;
+    case 5:
+      c->labels[0]->position = MS_CC;
+      break;
+    case 6:
+      c->labels[0]->position = MS_CL;
+      break;
+    case 7:
+      c->labels[0]->position = MS_LR;
+      break;
+    case 8:
+      c->labels[0]->position = MS_LC;
+      break;
+    case 9:
+      c->labels[0]->position = MS_LL;
+      break;
+    case 10:
+      c->labels[0]->position = MS_UR;
+      break; /*approximate*/
+    case 11:
+      c->labels[0]->position = MS_UC;
+      break;
+    case 12:
+      c->labels[0]->position = MS_UL;
+      break;
+    default:
+      break;
+    }
+  }
 
-      int nPosition = OGR_ST_GetParamNum(hLabelStyle,
-                                         OGRSTLabelAnchor,
-                                         &bIsNull);
-      if( !bIsNull ) {
-        switch( nPosition ) {
-          case 1:
-            c->labels[0]->position = MS_UR;
-            break;
-          case 2:
-            c->labels[0]->position = MS_UC;
-            break;
-          case 3:
-            c->labels[0]->position = MS_UL;
-            break;
-          case 4:
-            c->labels[0]->position = MS_CR;
-            break;
-          case 5:
-            c->labels[0]->position = MS_CC;
-            break;
-          case 6:
-            c->labels[0]->position = MS_CL;
-            break;
-          case 7:
-            c->labels[0]->position = MS_LR;
-            break;
-          case 8:
-            c->labels[0]->position = MS_LC;
-            break;
-          case 9:
-            c->labels[0]->position = MS_LL;
-            break;
-          case 10:
-            c->labels[0]->position = MS_UR;
-            break; /*approximate*/
-          case 11:
-            c->labels[0]->position = MS_UC;
-            break;
-          case 12:
-            c->labels[0]->position = MS_UL;
-            break;
-          default:
-            break;
-        }
-      }
-
-      const char *pszColor = OGR_ST_GetParamStr(hLabelStyle,
-                             OGRSTLabelFColor,
-                             &bIsNull);
-      if (!bIsNull && OGR_ST_GetRGBFromString(hLabelStyle, pszColor,
-                                              &r, &g, &b, &t)) {
-        MS_INIT_COLOR(c->labels[0]->color, r, g, b, t);
-      }
-
-      pszColor = OGR_ST_GetParamStr(hLabelStyle,
-                                    OGRSTLabelHColor,
-                                    &bIsNull);
-      if (!bIsNull && OGR_ST_GetRGBFromString(hLabelStyle, pszColor,
-                                              &r, &g, &b, &t)) {
-        MS_INIT_COLOR(c->labels[0]->shadowcolor, r, g, b, t);
-      }
-
-      pszColor = OGR_ST_GetParamStr(hLabelStyle,
-                                    OGRSTLabelOColor,
-                                    &bIsNull);
-      if (!bIsNull && OGR_ST_GetRGBFromString(hLabelStyle, pszColor,
-                                              &r, &g, &b, &t)) {
-        MS_INIT_COLOR(c->labels[0]->outlinecolor, r, g, b, t);
-      }
-
-      const char *pszBold = OGR_ST_GetParamNum(hLabelStyle,
-                            OGRSTLabelBold,
-                            &bIsNull) ? "-bold" : "";
-      const char *pszItalic = OGR_ST_GetParamNum(hLabelStyle,
-                              OGRSTLabelItalic,
-                              &bIsNull) ? "-italic" : "";
-      const char *pszFontName = OGR_ST_GetParamStr(hLabelStyle,
-                                OGRSTLabelFontName,
-                                &bIsNull);
-      /* replace spaces with hyphens to allow mapping to a valid hashtable entry*/
-      char* pszFontNameEscaped = NULL;
-      if (pszFontName != NULL) {
-          pszFontNameEscaped = msStrdup(pszFontName);
-          msReplaceChar(pszFontNameEscaped, ' ', '-');
-      }
-
-      bool bFont = true;
-
-      if (pszFontNameEscaped != NULL && !bIsNull && pszFontNameEscaped[0] != '\0') {
-        const char *pszName = CPLSPrintf("%s%s%s", pszFontNameEscaped, pszBold, pszItalic);
-        if (msLookupHashTable(&(map->fontset.fonts), (char*)pszName) != NULL) {
-          c->labels[0]->font = msStrdup(pszName);
-          if (layer->debug >= MS_DEBUGLEVEL_VVV)
-            msDebug("** Using '%s' TTF font **\n", pszName);
-        } else if ( (strcmp(pszFontNameEscaped,pszName) != 0) &&
-                    msLookupHashTable(&(map->fontset.fonts), (char*)pszFontNameEscaped) != NULL) {
-          c->labels[0]->font = msStrdup(pszFontNameEscaped);
-          if (layer->debug >= MS_DEBUGLEVEL_VVV)
-            msDebug("** Using '%s' TTF font **\n", pszFontNameEscaped);
-        } else if (msLookupHashTable(&(map->fontset.fonts),"default") != NULL) {
-          c->labels[0]->font = msStrdup("default");
-          if (layer->debug >= MS_DEBUGLEVEL_VVV)
-            msDebug("** Using 'default' TTF font **\n");
-        } else
-          bFont = false;
-      }
+  const char *pszColor =
+      OGR_ST_GetParamStr(hLabelStyle, OGRSTLabelFColor, &bIsNull);
+  if (!bIsNull &&
+      OGR_ST_GetRGBFromString(hLabelStyle, pszColor, &r, &g, &b, &t)) {
+    MS_INIT_COLOR(c->labels[0]->color, r, g, b, t);
+  }
+
+  pszColor = OGR_ST_GetParamStr(hLabelStyle, OGRSTLabelHColor, &bIsNull);
+  if (!bIsNull &&
+      OGR_ST_GetRGBFromString(hLabelStyle, pszColor, &r, &g, &b, &t)) {
+    MS_INIT_COLOR(c->labels[0]->shadowcolor, r, g, b, t);
+  }
+
+  pszColor = OGR_ST_GetParamStr(hLabelStyle, OGRSTLabelOColor, &bIsNull);
+  if (!bIsNull &&
+      OGR_ST_GetRGBFromString(hLabelStyle, pszColor, &r, &g, &b, &t)) {
+    MS_INIT_COLOR(c->labels[0]->outlinecolor, r, g, b, t);
+  }
+
+  const char *pszBold =
+      OGR_ST_GetParamNum(hLabelStyle, OGRSTLabelBold, &bIsNull) ? "-bold" : "";
+  const char *pszItalic =
+      OGR_ST_GetParamNum(hLabelStyle, OGRSTLabelItalic, &bIsNull) ? "-italic"
+                                                                  : "";
+  const char *pszFontName =
+      OGR_ST_GetParamStr(hLabelStyle, OGRSTLabelFontName, &bIsNull);
+  /* replace spaces with hyphens to allow mapping to a valid hashtable entry*/
+  char *pszFontNameEscaped = NULL;
+  if (pszFontName != NULL) {
+    pszFontNameEscaped = msStrdup(pszFontName);
+    msReplaceChar(pszFontNameEscaped, ' ', '-');
+  }
+
+  bool bFont = true;
+
+  if (pszFontNameEscaped != NULL && !bIsNull && pszFontNameEscaped[0] != '\0') {
+    const char *pszName =
+        CPLSPrintf("%s%s%s", pszFontNameEscaped, pszBold, pszItalic);
+    if (msLookupHashTable(&(map->fontset.fonts), (char *)pszName) != NULL) {
+      c->labels[0]->font = msStrdup(pszName);
+      if (layer->debug >= MS_DEBUGLEVEL_VVV)
+        msDebug("** Using '%s' TTF font **\n", pszName);
+    } else if ((strcmp(pszFontNameEscaped, pszName) != 0) &&
+               msLookupHashTable(&(map->fontset.fonts),
+                                 (char *)pszFontNameEscaped) != NULL) {
+      c->labels[0]->font = msStrdup(pszFontNameEscaped);
+      if (layer->debug >= MS_DEBUGLEVEL_VVV)
+        msDebug("** Using '%s' TTF font **\n", pszFontNameEscaped);
+    } else if (msLookupHashTable(&(map->fontset.fonts), "default") != NULL) {
+      c->labels[0]->font = msStrdup("default");
+      if (layer->debug >= MS_DEBUGLEVEL_VVV)
+        msDebug("** Using 'default' TTF font **\n");
+    } else
+      bFont = false;
+  }
 
-      msFree(pszFontNameEscaped);
+  msFree(pszFontNameEscaped);
 
-      if (!bFont) {
-        c->labels[0]->size = MS_MEDIUM;
-      }
+  if (!bFont) {
+    c->labels[0]->size = MS_MEDIUM;
+  }
 
-      return MS_SUCCESS;
+  return MS_SUCCESS;
 }
 
 static int msOGRUpdateStyleParsePen(mapObj *map, layerObj *layer, styleObj *s,
                                     OGRStyleToolH hPenStyle, int bIsBrush,
-                                    int* pbPriority)
-{
+                                    int *pbPriority) {
   GBool bIsNull;
-  int r=0,g=0,b=0,t=0;
+  int r = 0, g = 0, b = 0, t = 0;
 
-      const char *pszPenName, *pszPattern, *pszCap, *pszJoin;
-      colorObj oPenColor;
-      int nPenSymbol = 0;
-      int nPenSize = 1;
-      t =-1;
-      double pattern[MS_MAXPATTERNLENGTH];
-      int patternlength = 0;
-      int linecap = MS_CJC_DEFAULT_CAPS;
-      int linejoin = MS_CJC_DEFAULT_JOINS;
-      double offsetx = 0.0;
-      double offsety = 0.0;
-
-      // Make sure pen is always initialized
-      MS_INIT_COLOR(oPenColor, -1, -1, -1,255);
-
-      pszPenName = OGR_ST_GetParamStr(hPenStyle,
-                               OGRSTPenId,
-                               &bIsNull);
-      if (bIsNull) pszPenName = NULL;
-      // Check for Pen Pattern "ogr-pen-1": the invisible pen
-      // If that's what we have then set pen color to -1
-      if (pszPenName && strstr(pszPenName, "ogr-pen-1") != NULL) {
-        MS_INIT_COLOR(oPenColor, -1, -1, -1,255);
-      } else {
-        const char *pszColor = OGR_ST_GetParamStr(hPenStyle,
-                               OGRSTPenColor,
-                               &bIsNull);
-        if (!bIsNull && OGR_ST_GetRGBFromString(hPenStyle, pszColor,
-                                                &r, &g, &b, &t)) {
-          MS_INIT_COLOR(oPenColor, r, g, b, t);
-          if (layer->debug >= MS_DEBUGLEVEL_VVV)
-            msDebug("** PEN COLOR = %d %d %d **\n", r,g,b);
-        }
+  const char *pszPenName, *pszPattern, *pszCap, *pszJoin;
+  colorObj oPenColor;
+  int nPenSymbol = 0;
+  int nPenSize = 1;
+  t = -1;
+  double pattern[MS_MAXPATTERNLENGTH];
+  int patternlength = 0;
+  int linecap = MS_CJC_DEFAULT_CAPS;
+  int linejoin = MS_CJC_DEFAULT_JOINS;
+  double offsetx = 0.0;
+  double offsety = 0.0;
+
+  // Make sure pen is always initialized
+  MS_INIT_COLOR(oPenColor, -1, -1, -1, 255);
+
+  pszPenName = OGR_ST_GetParamStr(hPenStyle, OGRSTPenId, &bIsNull);
+  if (bIsNull)
+    pszPenName = NULL;
+  // Check for Pen Pattern "ogr-pen-1": the invisible pen
+  // If that's what we have then set pen color to -1
+  if (pszPenName && strstr(pszPenName, "ogr-pen-1") != NULL) {
+    MS_INIT_COLOR(oPenColor, -1, -1, -1, 255);
+  } else {
+    const char *pszColor =
+        OGR_ST_GetParamStr(hPenStyle, OGRSTPenColor, &bIsNull);
+    if (!bIsNull &&
+        OGR_ST_GetRGBFromString(hPenStyle, pszColor, &r, &g, &b, &t)) {
+      MS_INIT_COLOR(oPenColor, r, g, b, t);
+      if (layer->debug >= MS_DEBUGLEVEL_VVV)
+        msDebug("** PEN COLOR = %d %d %d **\n", r, g, b);
+    }
 
-        nPenSize = OGR_ST_GetParamNum(hPenStyle,
-                                      OGRSTPenWidth, &bIsNull);
-        if (bIsNull)
-          nPenSize = 1;
-        if (pszPenName!=NULL) {
-          // Try to match pen name in symbol file
-          nPenSymbol = msOGRGetSymbolId(&(map->symbolset),
-                                        pszPenName, NULL, MS_FALSE);
-        }
-      }
+    nPenSize = OGR_ST_GetParamNum(hPenStyle, OGRSTPenWidth, &bIsNull);
+    if (bIsNull)
+      nPenSize = 1;
+    if (pszPenName != NULL) {
+      // Try to match pen name in symbol file
+      nPenSymbol =
+          msOGRGetSymbolId(&(map->symbolset), pszPenName, NULL, MS_FALSE);
+    }
+  }
 
-      if (layer->debug >= MS_DEBUGLEVEL_VVV)
-        msDebug("** PEN COLOR = %d %d %d **\n", oPenColor.red,oPenColor.green,oPenColor.blue);
+  if (layer->debug >= MS_DEBUGLEVEL_VVV)
+    msDebug("** PEN COLOR = %d %d %d **\n", oPenColor.red, oPenColor.green,
+            oPenColor.blue);
 
-      pszPattern = OGR_ST_GetParamStr(hPenStyle, OGRSTPenPattern, &bIsNull);
-      if (bIsNull) pszPattern = NULL;
-      if( pszPattern != NULL )
-      {
-          char** papszTokens = CSLTokenizeStringComplex(pszPattern, " ", FALSE, FALSE);
-          int nTokenCount = CSLCount(papszTokens);
-          int bValidFormat = TRUE;
-          if( nTokenCount >= 2 && nTokenCount <= MS_MAXPATTERNLENGTH)
-          {
-              for(int i=0;i<nTokenCount;i++)
-              {
-                  if( strlen(papszTokens[i]) > 2 &&
-                      strcmp(papszTokens[i] + strlen(papszTokens[i]) - 2, "px") == 0 )
-                  {
-                      pattern[patternlength++] = CPLAtof(papszTokens[i]);
-                  }
-                  else
-                  {
-                      bValidFormat = FALSE;
-                      patternlength = 0;
-                      break;
-                  }
-              }
-          }
-          else
-              bValidFormat = FALSE;
-          if( !bValidFormat && layer->debug >= MS_DEBUGLEVEL_VVV)
-            msDebug("Invalid/unhandled pen pattern format = %s\n", pszPattern);
-          CSLDestroy(papszTokens);
-      }
-      
-      pszCap = OGR_ST_GetParamStr(hPenStyle, OGRSTPenCap, &bIsNull);
-      if (bIsNull) pszCap = NULL;
-      if( pszCap != NULL )
-      {
-          /* Note: the default in OGR Feature style is BUTT, but the MapServer */
-          /* default is ROUND. Currently use MapServer default. */
-          if( strcmp(pszCap, "b") == 0 ) /* BUTT */
-              linecap = MS_CJC_BUTT;
-          else if( strcmp(pszCap, "r") == 0 ) /* ROUND */
-              linecap = MS_CJC_ROUND;
-          else if( strcmp(pszCap, "p") == 0 ) /* PROJECTING */
-              linecap = MS_CJC_SQUARE;
-          else if( layer->debug >= MS_DEBUGLEVEL_VVV)
-            msDebug("Invalid/unhandled pen cap = %s\n", pszCap);
-      }
-      
-      pszJoin = OGR_ST_GetParamStr(hPenStyle, OGRSTPenJoin, &bIsNull);
-      if (bIsNull) pszJoin = NULL;
-      if( pszJoin != NULL )
-      {
-          /* Note: the default in OGR Feature style is MITER, but the MapServer */
-          /* default is NONE. Currently use MapServer default. */
-          if( strcmp(pszJoin, "m") == 0 ) /* MITTER */
-              linejoin = MS_CJC_MITER;
-          else if( strcmp(pszJoin, "r") == 0 ) /* ROUND */
-              linejoin = MS_CJC_ROUND;
-          else if( strcmp(pszJoin, "b") == 0 ) /* BEVEL */
-              linejoin = MS_CJC_BEVEL;
-          else if( layer->debug >= MS_DEBUGLEVEL_VVV)
-            msDebug("Invalid/unhandled pen join = %s\n", pszJoin);
-      }
-
-      offsetx = OGR_ST_GetParamDbl(hPenStyle, OGRSTPenPerOffset, &bIsNull);
-      if( bIsNull ) offsetx = 0;
-      if( offsetx != 0.0 )
-      {
-          /* OGR feature style and MapServer conventions related to offset */
-          /* sign are the same : negative values for left of line, positive for */
-          /* right of line */
-          offsety = MS_STYLE_SINGLE_SIDED_OFFSET;
-      }
-
-      if (bIsBrush || layer->type == MS_LAYER_POLYGON) {
-        // This is a multipart symbology, so pen defn goes in the
-        // overlaysymbol params
-        s->outlinecolor = oPenColor;
-      } else {
-        // Single part symbology
-        s->color = oPenColor;
+  pszPattern = OGR_ST_GetParamStr(hPenStyle, OGRSTPenPattern, &bIsNull);
+  if (bIsNull)
+    pszPattern = NULL;
+  if (pszPattern != NULL) {
+    char **papszTokens =
+        CSLTokenizeStringComplex(pszPattern, " ", FALSE, FALSE);
+    int nTokenCount = CSLCount(papszTokens);
+    int bValidFormat = TRUE;
+    if (nTokenCount >= 2 && nTokenCount <= MS_MAXPATTERNLENGTH) {
+      for (int i = 0; i < nTokenCount; i++) {
+        if (strlen(papszTokens[i]) > 2 &&
+            strcmp(papszTokens[i] + strlen(papszTokens[i]) - 2, "px") == 0) {
+          pattern[patternlength++] = CPLAtof(papszTokens[i]);
+        } else {
+          bValidFormat = FALSE;
+          patternlength = 0;
+          break;
+        }
       }
+    } else
+      bValidFormat = FALSE;
+    if (!bValidFormat && layer->debug >= MS_DEBUGLEVEL_VVV)
+      msDebug("Invalid/unhandled pen pattern format = %s\n", pszPattern);
+    CSLDestroy(papszTokens);
+  }
 
-      s->symbol = nPenSymbol;
-      s->size = nPenSize;
-      s->width = nPenSize;
-      s->linecap = linecap;
-      s->linejoin = linejoin;
-      s->offsetx = offsetx;
-      s->offsety = offsety;
-      s->patternlength = patternlength;
-      if( patternlength > 0 )
-          memcpy(s->pattern, pattern, sizeof(double) * patternlength);
+  pszCap = OGR_ST_GetParamStr(hPenStyle, OGRSTPenCap, &bIsNull);
+  if (bIsNull)
+    pszCap = NULL;
+  if (pszCap != NULL) {
+    /* Note: the default in OGR Feature style is BUTT, but the MapServer */
+    /* default is ROUND. Currently use MapServer default. */
+    if (strcmp(pszCap, "b") == 0) /* BUTT */
+      linecap = MS_CJC_BUTT;
+    else if (strcmp(pszCap, "r") == 0) /* ROUND */
+      linecap = MS_CJC_ROUND;
+    else if (strcmp(pszCap, "p") == 0) /* PROJECTING */
+      linecap = MS_CJC_SQUARE;
+    else if (layer->debug >= MS_DEBUGLEVEL_VVV)
+      msDebug("Invalid/unhandled pen cap = %s\n", pszCap);
+  }
+
+  pszJoin = OGR_ST_GetParamStr(hPenStyle, OGRSTPenJoin, &bIsNull);
+  if (bIsNull)
+    pszJoin = NULL;
+  if (pszJoin != NULL) {
+    /* Note: the default in OGR Feature style is MITER, but the MapServer */
+    /* default is NONE. Currently use MapServer default. */
+    if (strcmp(pszJoin, "m") == 0) /* MITTER */
+      linejoin = MS_CJC_MITER;
+    else if (strcmp(pszJoin, "r") == 0) /* ROUND */
+      linejoin = MS_CJC_ROUND;
+    else if (strcmp(pszJoin, "b") == 0) /* BEVEL */
+      linejoin = MS_CJC_BEVEL;
+    else if (layer->debug >= MS_DEBUGLEVEL_VVV)
+      msDebug("Invalid/unhandled pen join = %s\n", pszJoin);
+  }
+
+  offsetx = OGR_ST_GetParamDbl(hPenStyle, OGRSTPenPerOffset, &bIsNull);
+  if (bIsNull)
+    offsetx = 0;
+  if (offsetx != 0.0) {
+    /* OGR feature style and MapServer conventions related to offset */
+    /* sign are the same : negative values for left of line, positive for */
+    /* right of line */
+    offsety = MS_STYLE_SINGLE_SIDED_OFFSET;
+  }
+
+  if (bIsBrush || layer->type == MS_LAYER_POLYGON) {
+    // This is a multipart symbology, so pen defn goes in the
+    // overlaysymbol params
+    s->outlinecolor = oPenColor;
+  } else {
+    // Single part symbology
+    s->color = oPenColor;
+  }
 
-      int nPriority = OGR_ST_GetParamNum(hPenStyle, OGRSTPenPriority, &bIsNull);
-      if( !bIsNull )
-          *pbPriority = nPriority;
+  s->symbol = nPenSymbol;
+  s->size = nPenSize;
+  s->width = nPenSize;
+  s->linecap = linecap;
+  s->linejoin = linejoin;
+  s->offsetx = offsetx;
+  s->offsety = offsety;
+  s->patternlength = patternlength;
+  if (patternlength > 0)
+    memcpy(s->pattern, pattern, sizeof(double) * patternlength);
+
+  int nPriority = OGR_ST_GetParamNum(hPenStyle, OGRSTPenPriority, &bIsNull);
+  if (!bIsNull)
+    *pbPriority = nPriority;
 
-      return MS_SUCCESS;
+  return MS_SUCCESS;
 }
 
-static int msOGRAddBgColorStyleParseBrush(styleObj* s, OGRStyleToolH hBrushStyle)
-{
-    GBool bIsNull;
-    int r = 0, g = 0, b = 0, t = 0;
-    const char* pszColor = OGR_ST_GetParamStr(hBrushStyle,
-        OGRSTBrushBColor, &bIsNull);
-
-    if (!bIsNull && OGR_ST_GetRGBFromString(hBrushStyle,
-        pszColor,
-        &r, &g, &b, &t)) {
-        MS_INIT_COLOR(s->color, r, g, b, t);
-    }
-    return MS_SUCCESS;
+static int msOGRAddBgColorStyleParseBrush(styleObj *s,
+                                          OGRStyleToolH hBrushStyle) {
+  GBool bIsNull;
+  int r = 0, g = 0, b = 0, t = 0;
+  const char *pszColor =
+      OGR_ST_GetParamStr(hBrushStyle, OGRSTBrushBColor, &bIsNull);
+
+  if (!bIsNull &&
+      OGR_ST_GetRGBFromString(hBrushStyle, pszColor, &r, &g, &b, &t)) {
+    MS_INIT_COLOR(s->color, r, g, b, t);
+  }
+  return MS_SUCCESS;
 }
 
 static int msOGRUpdateStyleParseBrush(mapObj *map, layerObj *layer, styleObj *s,
-                                      OGRStyleToolH hBrushStyle, int* pbIsBrush,
-                                      int* pbPriority)
-{
+                                      OGRStyleToolH hBrushStyle, int *pbIsBrush,
+                                      int *pbPriority) {
   GBool bIsNull;
-  int r=0,g=0,b=0,t=0;
+  int r = 0, g = 0, b = 0, t = 0;
 
-      const char *pszBrushName = OGR_ST_GetParamStr(hBrushStyle,
-                                 OGRSTBrushId,
-                                 &bIsNull);
-      if (bIsNull) pszBrushName = NULL;
-
-      // Check for Brush Pattern "ogr-brush-1": the invisible fill
-      // If that's what we have then set fill color to -1
-      if (pszBrushName && strstr(pszBrushName, "ogr-brush-1") != NULL) {
-        MS_INIT_COLOR(s->color, -1, -1, -1, 255);
-      } else {
-        *pbIsBrush = TRUE;
-        const char *pszColor = OGR_ST_GetParamStr(hBrushStyle,
-                               OGRSTBrushFColor,
-                               &bIsNull);
-        if (!bIsNull && OGR_ST_GetRGBFromString(hBrushStyle,
-                                                pszColor,
-                                                &r, &g, &b, &t)) {
-          MS_INIT_COLOR(s->color, r, g, b, t);
+  const char *pszBrushName =
+      OGR_ST_GetParamStr(hBrushStyle, OGRSTBrushId, &bIsNull);
+  if (bIsNull)
+    pszBrushName = NULL;
+
+  // Check for Brush Pattern "ogr-brush-1": the invisible fill
+  // If that's what we have then set fill color to -1
+  if (pszBrushName && strstr(pszBrushName, "ogr-brush-1") != NULL) {
+    MS_INIT_COLOR(s->color, -1, -1, -1, 255);
+  } else {
+    *pbIsBrush = TRUE;
+    const char *pszColor =
+        OGR_ST_GetParamStr(hBrushStyle, OGRSTBrushFColor, &bIsNull);
+    if (!bIsNull &&
+        OGR_ST_GetRGBFromString(hBrushStyle, pszColor, &r, &g, &b, &t)) {
+      MS_INIT_COLOR(s->color, r, g, b, t);
 
-          if (layer->debug >= MS_DEBUGLEVEL_VVV)
-            msDebug("** BRUSH COLOR = %d %d %d **\n", r,g,b);
-        }
+      if (layer->debug >= MS_DEBUGLEVEL_VVV)
+        msDebug("** BRUSH COLOR = %d %d %d **\n", r, g, b);
+    }
 
-        // Symbol name mapping:
-        // First look for the native symbol name, then the ogr-...
-        // generic name.
-        // If none provided or found then use 0: solid fill
-
-        const char *pszName = OGR_ST_GetParamStr(hBrushStyle,
-                              OGRSTBrushId,
-                              &bIsNull);
-        s->symbol = msOGRGetSymbolId(&(map->symbolset),
-                                                pszName, NULL, MS_FALSE);
-
-        double angle = OGR_ST_GetParamDbl(hBrushStyle, OGRSTBrushAngle, &bIsNull);
-        if( !bIsNull )
-            s->angle = angle;
-        
-        double size = OGR_ST_GetParamDbl(hBrushStyle, OGRSTBrushSize, &bIsNull);
-        if( !bIsNull )
-            s->size = size;
-        
-        double spacingx = OGR_ST_GetParamDbl(hBrushStyle, OGRSTBrushDx, &bIsNull);
-        if( !bIsNull )
-        {
-            double spacingy = OGR_ST_GetParamDbl(hBrushStyle, OGRSTBrushDy, &bIsNull);
-            if( !bIsNull )
-            {
-                if( spacingx == spacingy )
-                    s->gap = spacingx;
-                else if( layer->debug >= MS_DEBUGLEVEL_VVV )
-                    msDebug("Ignoring brush dx and dy since they don't have the same value\n");
-            }
-        }
+    // Symbol name mapping:
+    // First look for the native symbol name, then the ogr-...
+    // generic name.
+    // If none provided or found then use 0: solid fill
+
+    const char *pszName =
+        OGR_ST_GetParamStr(hBrushStyle, OGRSTBrushId, &bIsNull);
+    s->symbol = msOGRGetSymbolId(&(map->symbolset), pszName, NULL, MS_FALSE);
+
+    double angle = OGR_ST_GetParamDbl(hBrushStyle, OGRSTBrushAngle, &bIsNull);
+    if (!bIsNull)
+      s->angle = angle;
+
+    double size = OGR_ST_GetParamDbl(hBrushStyle, OGRSTBrushSize, &bIsNull);
+    if (!bIsNull)
+      s->size = size;
+
+    double spacingx = OGR_ST_GetParamDbl(hBrushStyle, OGRSTBrushDx, &bIsNull);
+    if (!bIsNull) {
+      double spacingy = OGR_ST_GetParamDbl(hBrushStyle, OGRSTBrushDy, &bIsNull);
+      if (!bIsNull) {
+        if (spacingx == spacingy)
+          s->gap = spacingx;
+        else if (layer->debug >= MS_DEBUGLEVEL_VVV)
+          msDebug("Ignoring brush dx and dy since they don't have the same "
+                  "value\n");
       }
+    }
+  }
 
-      int nPriority = OGR_ST_GetParamNum(hBrushStyle, OGRSTBrushPriority, &bIsNull);
-      if( !bIsNull )
-          *pbPriority = nPriority;
+  int nPriority = OGR_ST_GetParamNum(hBrushStyle, OGRSTBrushPriority, &bIsNull);
+  if (!bIsNull)
+    *pbPriority = nPriority;
 
-      return MS_SUCCESS;
+  return MS_SUCCESS;
 }
 
 static int msOGRUpdateStyleParseSymbol(mapObj *map, styleObj *s,
                                        OGRStyleToolH hSymbolStyle,
-                                       int* pbPriority)
-{
+                                       int *pbPriority) {
   GBool bIsNull;
-  int r=0,g=0,b=0,t=0;
+  int r = 0, g = 0, b = 0, t = 0;
 
-      const char *pszColor = OGR_ST_GetParamStr(hSymbolStyle,
-                             OGRSTSymbolColor,
-                             &bIsNull);
-      if (!bIsNull && OGR_ST_GetRGBFromString(hSymbolStyle,
-                                              pszColor,
-                                              &r, &g, &b, &t)) {
-        MS_INIT_COLOR(s->color, r, g, b, t);
-      }
-
-      pszColor = OGR_ST_GetParamStr(hSymbolStyle,
-                                    OGRSTSymbolOColor,
-                                    &bIsNull);
-      if (!bIsNull && OGR_ST_GetRGBFromString(hSymbolStyle,
-                                              pszColor,
-                                              &r, &g, &b, &t)) {
-        MS_INIT_COLOR(s->outlinecolor, r, g, b, t);
-      }
-
-      s->angle = OGR_ST_GetParamNum(hSymbolStyle,
-                            OGRSTSymbolAngle,
-                            &bIsNull);
-      double dfTmp = OGR_ST_GetParamNum(hSymbolStyle, OGRSTSymbolSize, &bIsNull);
-      if (!bIsNull)
-        s->size = dfTmp;
-
-      // Symbol name mapping:
-      // First look for the native symbol name, then the ogr-...
-      // generic name, and in last resort try "default-marker" if
-      // provided by user.
-      const char *pszName = OGR_ST_GetParamStr(hSymbolStyle,
-                            OGRSTSymbolId,
-                            &bIsNull);
-      if (bIsNull)
-        pszName = NULL;
+  const char *pszColor =
+      OGR_ST_GetParamStr(hSymbolStyle, OGRSTSymbolColor, &bIsNull);
+  if (!bIsNull &&
+      OGR_ST_GetRGBFromString(hSymbolStyle, pszColor, &r, &g, &b, &t)) {
+    MS_INIT_COLOR(s->color, r, g, b, t);
+  }
+
+  pszColor = OGR_ST_GetParamStr(hSymbolStyle, OGRSTSymbolOColor, &bIsNull);
+  if (!bIsNull &&
+      OGR_ST_GetRGBFromString(hSymbolStyle, pszColor, &r, &g, &b, &t)) {
+    MS_INIT_COLOR(s->outlinecolor, r, g, b, t);
+  }
+
+  s->angle = OGR_ST_GetParamNum(hSymbolStyle, OGRSTSymbolAngle, &bIsNull);
+  double dfTmp = OGR_ST_GetParamNum(hSymbolStyle, OGRSTSymbolSize, &bIsNull);
+  if (!bIsNull)
+    s->size = dfTmp;
 
-      int try_addimage_if_notfound = MS_FALSE;
+  // Symbol name mapping:
+  // First look for the native symbol name, then the ogr-...
+  // generic name, and in last resort try "default-marker" if
+  // provided by user.
+  const char *pszName =
+      OGR_ST_GetParamStr(hSymbolStyle, OGRSTSymbolId, &bIsNull);
+  if (bIsNull)
+    pszName = NULL;
+
+  int try_addimage_if_notfound = MS_FALSE;
 #ifdef USE_CURL
-      if (pszName && strncasecmp(pszName, "http", 4) == 0)
-        try_addimage_if_notfound =MS_TRUE;
+  if (pszName && strncasecmp(pszName, "http", 4) == 0)
+    try_addimage_if_notfound = MS_TRUE;
 #endif
-      if (!s->symbolname)
-        s->symbol = msOGRGetSymbolId(&(map->symbolset),
-                                                pszName,
-                                                "default-marker",  try_addimage_if_notfound);
-
-      int nPriority = OGR_ST_GetParamNum(hSymbolStyle, OGRSTSymbolPriority, &bIsNull);
-      if( !bIsNull )
-          *pbPriority = nPriority;
+  if (!s->symbolname)
+    s->symbol = msOGRGetSymbolId(&(map->symbolset), pszName, "default-marker",
+                                 try_addimage_if_notfound);
+
+  int nPriority =
+      OGR_ST_GetParamNum(hSymbolStyle, OGRSTSymbolPriority, &bIsNull);
+  if (!bIsNull)
+    *pbPriority = nPriority;
 
-      return MS_SUCCESS;
+  return MS_SUCCESS;
 }
 
-
 /**********************************************************************
  *                     msOGRLayerGetAutoStyle()
  *
@@ -5300,19 +5071,19 @@ static int msOGRUpdateStyleParseSymbol(m
  * the next call and that shouldn't be freed by the caller.
  **********************************************************************/
 static int msOGRLayerGetAutoStyle(mapObj *map, layerObj *layer, classObj *c,
-                                  shapeObj* shape)
-{
-  msOGRFileInfo *psInfo =(msOGRFileInfo*)layer->layerinfo;
+                                  shapeObj *shape) {
+  msOGRFileInfo *psInfo = (msOGRFileInfo *)layer->layerinfo;
 
   if (psInfo == NULL || psInfo->hLayer == NULL) {
     msSetError(MS_MISCERR, "Assertion failed: OGR layer not opened!!!",
                "msOGRLayerGetAutoStyle()");
-    return(MS_FAILURE);
+    return (MS_FAILURE);
   }
 
-  if( layer->tileindex != NULL ) {
-    if( (psInfo->poCurTile == NULL || shape->tileindex != psInfo->poCurTile->nTileId)
-        && msOGRFileReadTile( layer, psInfo ) != MS_SUCCESS )
+  if (layer->tileindex != NULL) {
+    if ((psInfo->poCurTile == NULL ||
+         shape->tileindex != psInfo->poCurTile->nTileId) &&
+        msOGRFileReadTile(layer, psInfo) != MS_SUCCESS)
       return MS_FAILURE;
 
     psInfo = psInfo->poCurTile;
@@ -5328,7 +5099,7 @@ static int msOGRLayerGetAutoStyle(mapObj
     msSetError(MS_MISCERR,
                "Assertion failed: AutoStyle not requested on loaded shape.",
                "msOGRLayerGetAutoStyle()");
-    return(MS_FAILURE);
+    return (MS_FAILURE);
   }
 
   /* ------------------------------------------------------------------
@@ -5338,7 +5109,7 @@ static int msOGRLayerGetAutoStyle(mapObj
   resetClassStyle(c);
   if (msMaybeAllocateClassStyle(c, 0)) {
     RELEASE_OGR_LOCK;
-    return(MS_FAILURE);
+    return (MS_FAILURE);
   }
 
   // __TODO__ label cache incompatible with styleitem feature.
@@ -5356,7 +5127,6 @@ static int msOGRLayerGetAutoStyle(mapObj
   return nRetVal;
 }
 
-
 /**********************************************************************
  *                     msOGRUpdateStyleFromString()
  *
@@ -5369,15 +5139,14 @@ static int msOGRLayerGetAutoStyle(mapObj
  * the next call and that shouldn't be freed by the caller.
  **********************************************************************/
 int msOGRUpdateStyleFromString(mapObj *map, layerObj *layer, classObj *c,
-                               const char *stylestring)
-{
+                               const char *stylestring) {
   /* ------------------------------------------------------------------
    * Reset style info in the class to defaults
    * the only members we don't touch are name, expression, and join/query stuff
    * ------------------------------------------------------------------ */
   resetClassStyle(c);
   if (msMaybeAllocateClassStyle(c, 0)) {
-    return(MS_FAILURE);
+    return (MS_FAILURE);
   }
 
   // __TODO__ label cache incompatible with styleitem feature.
@@ -5400,11 +5169,11 @@ int msOGRUpdateStyleFromString(mapObj *m
 /*                           msOGRLCleanup()                            */
 /************************************************************************/
 
-void msOGRCleanup( void )
+void msOGRCleanup(void)
 
 {
   ACQUIRE_OGR_LOCK;
-  if( bOGRDriversRegistered == MS_TRUE ) {
+  if (bOGRDriversRegistered == MS_TRUE) {
     CPLPopErrorHandler();
     bOGRDriversRegistered = MS_FALSE;
   }
@@ -5414,71 +5183,58 @@ void msOGRCleanup( void )
 /************************************************************************/
 /*                           msOGREscapeSQLParam                        */
 /************************************************************************/
-char *msOGREscapePropertyName(layerObj *layer, const char *pszString)
-{
-  char* pszEscapedStr =NULL;
-  if(layer && pszString && strlen(pszString) > 0) {
-    pszEscapedStr = (char*) msSmallMalloc( strlen(pszString) * 2 + 1 );
+char *msOGREscapePropertyName(layerObj *layer, const char *pszString) {
+  char *pszEscapedStr = NULL;
+  if (layer && pszString && strlen(pszString) > 0) {
+    pszEscapedStr = (char *)msSmallMalloc(strlen(pszString) * 2 + 1);
     int j = 0;
-    for( int i = 0; pszString[i] != '\0'; ++i )
-    {
-        if( pszString[i] == '"' )
-        {
-            pszEscapedStr[j++] = '"';
-            pszEscapedStr[j++] = '"';
-        }
-        else
-            pszEscapedStr[j++] = pszString[i];
+    for (int i = 0; pszString[i] != '\0'; ++i) {
+      if (pszString[i] == '"') {
+        pszEscapedStr[j++] = '"';
+        pszEscapedStr[j++] = '"';
+      } else
+        pszEscapedStr[j++] = pszString[i];
     }
     pszEscapedStr[j] = 0;
   }
   return pszEscapedStr;
 }
 
-static int msOGRLayerSupportsCommonFilters(layerObj *)
-{
-  return MS_FALSE;
-}
+static int msOGRLayerSupportsCommonFilters(layerObj *) { return MS_FALSE; }
 
-static void msOGREnablePaging(layerObj *layer, int value)
-{
+static void msOGREnablePaging(layerObj *layer, int value) {
   msOGRFileInfo *layerinfo = NULL;
 
   if (layer->debug) {
     msDebug("msOGREnablePaging(%d) called.\n", value);
   }
 
-  if(!msOGRLayerIsOpen(layer))
-  {
-    if(msOGRLayerOpenVT(layer) != MS_SUCCESS)
-    {
+  if (!msOGRLayerIsOpen(layer)) {
+    if (msOGRLayerOpenVT(layer) != MS_SUCCESS) {
       return;
     }
   }
 
-  assert( layer->layerinfo != NULL);
+  assert(layer->layerinfo != NULL);
 
   layerinfo = (msOGRFileInfo *)layer->layerinfo;
   layerinfo->bPaging = value;
 }
 
-static int msOGRGetPaging(layerObj *layer)
-{
+static int msOGRGetPaging(layerObj *layer) {
   msOGRFileInfo *layerinfo = NULL;
 
   if (layer->debug) {
     msDebug("msOGRGetPaging called.\n");
   }
 
-  if(!msOGRLayerIsOpen(layer))
-  {
-    if(msOGRLayerOpenVT(layer) != MS_SUCCESS)
-    {
+  if (!msOGRLayerIsOpen(layer)) {
+    if (msOGRLayerOpenVT(layer) != MS_SUCCESS) {
       return FALSE;
     }
   }
 
-  assert( layer->layerinfo != NULL);
+  assert(layer->layerinfo != NULL);
 
   layerinfo = (msOGRFileInfo *)layer->layerinfo;
   return layerinfo->bPaging;
@@ -5487,8 +5243,7 @@ static int msOGRGetPaging(layerObj *laye
 /************************************************************************/
 /*                  msOGRLayerInitializeVirtualTable()                  */
 /************************************************************************/
-int msOGRLayerInitializeVirtualTable(layerObj *layer)
-{
+int msOGRLayerInitializeVirtualTable(layerObj *layer) {
   assert(layer != NULL);
   assert(layer->vtable != NULL);
 
@@ -5524,37 +5279,35 @@ int msOGRLayerInitializeVirtualTable(lay
 /************************************************************************/
 /*                         msOGRShapeFromWKT()                          */
 /************************************************************************/
-shapeObj *msOGRShapeFromWKT(const char *string)
-{
+shapeObj *msOGRShapeFromWKT(const char *string) {
 
   OGRGeometryH hGeom = NULL;
-  shapeObj *shape=NULL;
+  shapeObj *shape = NULL;
 
-  if(!string)
+  if (!string)
     return NULL;
 
-  if( OGR_G_CreateFromWkt( (char **)&string, NULL, &hGeom ) != OGRERR_NONE ) {
-    msSetError(MS_OGRERR, "Failed to parse WKT string.",
-               "msOGRShapeFromWKT()" );
+  if (OGR_G_CreateFromWkt((char **)&string, NULL, &hGeom) != OGRERR_NONE) {
+    msSetError(MS_OGRERR, "Failed to parse WKT string.", "msOGRShapeFromWKT()");
     return NULL;
   }
 
   /* Initialize a corresponding shapeObj */
 
-  shape = (shapeObj *) malloc(sizeof(shapeObj));
+  shape = (shapeObj *)malloc(sizeof(shapeObj));
   msInitShape(shape);
 
   /* translate WKT into an OGRGeometry. */
 
-  if( msOGRGeometryToShape( hGeom, shape,
-                            wkbFlatten(OGR_G_GetGeometryType(hGeom)) )
-      == MS_FAILURE ) {
+  if (msOGRGeometryToShape(hGeom, shape,
+                           wkbFlatten(OGR_G_GetGeometryType(hGeom))) ==
+      MS_FAILURE) {
     msFreeShape(shape);
-    free( shape );
+    free(shape);
     shape = NULL;
   }
 
-  OGR_G_DestroyGeometry( hGeom );
+  OGR_G_DestroyGeometry(hGeom);
 
   return shape;
 }
@@ -5562,82 +5315,76 @@ shapeObj *msOGRShapeFromWKT(const char *
 /************************************************************************/
 /*                          msOGRShapeToWKT()                           */
 /************************************************************************/
-char *msOGRShapeToWKT(shapeObj *shape)
-{
+char *msOGRShapeToWKT(shapeObj *shape) {
   OGRGeometryH hGeom = NULL;
-  int          i;
-  char        *wkt = NULL;
+  int i;
+  char *wkt = NULL;
 
-  if(!shape)
+  if (!shape)
     return NULL;
 
-  if( shape->type == MS_SHAPE_POINT && shape->numlines == 1
-      && shape->line[0].numpoints == 1 ) {
-    hGeom = OGR_G_CreateGeometry( wkbPoint );
-    OGR_G_SetPoint_2D( hGeom, 0,
-                       shape->line[0].point[0].x,
-                       shape->line[0].point[0].y );
-  } else if( shape->type == MS_SHAPE_POINT && shape->numlines == 1
-             && shape->line[0].numpoints > 1 ) {
-    hGeom = OGR_G_CreateGeometry( wkbMultiPoint );
-    for( i = 0; i < shape->line[0].numpoints; i++ ) {
+  if (shape->type == MS_SHAPE_POINT && shape->numlines == 1 &&
+      shape->line[0].numpoints == 1) {
+    hGeom = OGR_G_CreateGeometry(wkbPoint);
+    OGR_G_SetPoint_2D(hGeom, 0, shape->line[0].point[0].x,
+                      shape->line[0].point[0].y);
+  } else if (shape->type == MS_SHAPE_POINT && shape->numlines == 1 &&
+             shape->line[0].numpoints > 1) {
+    hGeom = OGR_G_CreateGeometry(wkbMultiPoint);
+    for (i = 0; i < shape->line[0].numpoints; i++) {
       OGRGeometryH hPoint;
 
-      hPoint = OGR_G_CreateGeometry( wkbPoint );
-      OGR_G_SetPoint_2D( hPoint, 0,
-                         shape->line[0].point[i].x,
-                         shape->line[0].point[i].y );
-      OGR_G_AddGeometryDirectly( hGeom, hPoint );
-    }
-  } else if( shape->type == MS_SHAPE_LINE && shape->numlines == 1 ) {
-    hGeom = OGR_G_CreateGeometry( wkbLineString );
-    for( i = 0; i < shape->line[0].numpoints; i++ ) {
-      OGR_G_AddPoint_2D( hGeom,
-                         shape->line[0].point[i].x,
-                         shape->line[0].point[i].y );
+      hPoint = OGR_G_CreateGeometry(wkbPoint);
+      OGR_G_SetPoint_2D(hPoint, 0, shape->line[0].point[i].x,
+                        shape->line[0].point[i].y);
+      OGR_G_AddGeometryDirectly(hGeom, hPoint);
+    }
+  } else if (shape->type == MS_SHAPE_LINE && shape->numlines == 1) {
+    hGeom = OGR_G_CreateGeometry(wkbLineString);
+    for (i = 0; i < shape->line[0].numpoints; i++) {
+      OGR_G_AddPoint_2D(hGeom, shape->line[0].point[i].x,
+                        shape->line[0].point[i].y);
     }
-  } else if( shape->type == MS_SHAPE_LINE && shape->numlines > 1 ) {
-    OGRGeometryH hMultiLine = OGR_G_CreateGeometry( wkbMultiLineString );
+  } else if (shape->type == MS_SHAPE_LINE && shape->numlines > 1) {
+    OGRGeometryH hMultiLine = OGR_G_CreateGeometry(wkbMultiLineString);
     int iLine;
 
-    for( iLine = 0; iLine < shape->numlines; iLine++ ) {
-      hGeom = OGR_G_CreateGeometry( wkbLineString );
-      for( i = 0; i < shape->line[iLine].numpoints; i++ ) {
-        OGR_G_AddPoint_2D( hGeom,
-                           shape->line[iLine].point[i].x,
-                           shape->line[iLine].point[i].y );
+    for (iLine = 0; iLine < shape->numlines; iLine++) {
+      hGeom = OGR_G_CreateGeometry(wkbLineString);
+      for (i = 0; i < shape->line[iLine].numpoints; i++) {
+        OGR_G_AddPoint_2D(hGeom, shape->line[iLine].point[i].x,
+                          shape->line[iLine].point[i].y);
       }
 
-      OGR_G_AddGeometryDirectly( hMultiLine, hGeom );
+      OGR_G_AddGeometryDirectly(hMultiLine, hGeom);
     }
 
     hGeom = hMultiLine;
-  } else if( shape->type == MS_SHAPE_POLYGON ) {
+  } else if (shape->type == MS_SHAPE_POLYGON) {
     int iLine;
 
     /* actually, it is pretty hard to be sure rings 1+ are interior */
-    hGeom = OGR_G_CreateGeometry( wkbPolygon );
-    for( iLine = 0; iLine < shape->numlines; iLine++ ) {
+    hGeom = OGR_G_CreateGeometry(wkbPolygon);
+    for (iLine = 0; iLine < shape->numlines; iLine++) {
       OGRGeometryH hRing;
-      hRing = OGR_G_CreateGeometry( wkbLinearRing );
+      hRing = OGR_G_CreateGeometry(wkbLinearRing);
 
-      for( i = 0; i < shape->line[iLine].numpoints; i++ ) {
-        OGR_G_AddPoint_2D( hRing,
-                           shape->line[iLine].point[i].x,
-                           shape->line[iLine].point[i].y );
+      for (i = 0; i < shape->line[iLine].numpoints; i++) {
+        OGR_G_AddPoint_2D(hRing, shape->line[iLine].point[i].x,
+                          shape->line[iLine].point[i].y);
       }
-      OGR_G_AddGeometryDirectly( hGeom, hRing );
+      OGR_G_AddGeometryDirectly(hGeom, hRing);
     }
   } else {
     msSetError(MS_OGRERR, "OGR support is not available.", "msOGRShapeToWKT()");
   }
 
-  if( hGeom != NULL ) {
+  if (hGeom != NULL) {
     char *pszOGRWkt;
 
-    OGR_G_ExportToWkt( hGeom, &pszOGRWkt );
-    wkt = msStrdup( pszOGRWkt );
-    CPLFree( pszOGRWkt );
+    OGR_G_ExportToWkt(hGeom, &pszOGRWkt);
+    wkt = msStrdup(pszOGRWkt);
+    CPLFree(pszOGRWkt);
   }
 
   return wkt;
diff -pruN 8.0.1-5/mapogroutput.cpp 8.0.2-1/mapogroutput.cpp
--- 8.0.1-5/mapogroutput.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapogroutput.cpp	2024-06-11 20:41:34.000000000 +0000
@@ -45,10 +45,10 @@
 /*                   msInitDefaultOGROutputFormat()                     */
 /************************************************************************/
 
-int msInitDefaultOGROutputFormat( outputFormatObj *format )
+int msInitDefaultOGROutputFormat(outputFormatObj *format)
 
 {
-  OGRSFDriverH   hDriver;
+  OGRSFDriverH hDriver;
 
   msOGRInitialize();
 
@@ -57,16 +57,16 @@ int msInitDefaultOGROutputFormat( output
   /*      be pretty threadsafe so don't bother acquiring the GDAL         */
   /*      lock.                                                           */
   /* -------------------------------------------------------------------- */
-  hDriver = OGRGetDriverByName( format->driver+4 );
-  if( hDriver == NULL ) {
-    msSetError( MS_MISCERR, "No OGR driver named `%s' available.",
-                "msInitDefaultOGROutputFormat()", format->driver+4 );
+  hDriver = OGRGetDriverByName(format->driver + 4);
+  if (hDriver == NULL) {
+    msSetError(MS_MISCERR, "No OGR driver named `%s' available.",
+               "msInitDefaultOGROutputFormat()", format->driver + 4);
     return MS_FAILURE;
   }
 
-  if( !OGR_Dr_TestCapability( hDriver, ODrCCreateDataSource ) ) {
-    msSetError( MS_MISCERR, "OGR `%s' driver does not support output.",
-                "msInitDefaultOGROutputFormat()", format->driver+4 );
+  if (!OGR_Dr_TestCapability(hDriver, ODrCCreateDataSource)) {
+    msSetError(MS_MISCERR, "OGR `%s' driver does not support output.",
+               "msInitDefaultOGROutputFormat()", format->driver + 4);
     return MS_FAILURE;
   }
 
@@ -86,15 +86,13 @@ int msInitDefaultOGROutputFormat( output
 /*                        msCSLConcatenate()                            */
 /************************************************************************/
 
-static char** msCSLConcatenate( char** papszResult, char** papszToBeAdded )
-{
-    char** papszIter = papszToBeAdded;
-    while( papszIter && *papszIter )
-    {
-        papszResult = CSLAddString(papszResult, *papszIter);
-        papszIter ++;
-    }
-    return papszResult;
+static char **msCSLConcatenate(char **papszResult, char **papszToBeAdded) {
+  char **papszIter = papszToBeAdded;
+  while (papszIter && *papszIter) {
+    papszResult = CSLAddString(papszResult, *papszIter);
+    papszIter++;
+  }
+  return papszResult;
 }
 
 /************************************************************************/
@@ -104,13 +102,12 @@ static char** msCSLConcatenate( char** p
 /*      including those in subdirectories.                              */
 /************************************************************************/
 
-char **msOGRRecursiveFileList( const char *path )
-{
+char **msOGRRecursiveFileList(const char *path) {
   char **file_list;
   char **result_list = NULL;
   int i, count, change;
 
-  file_list = CPLReadDir( path );
+  file_list = CPLReadDir(path);
   count = CSLCount(file_list);
 
   /* -------------------------------------------------------------------- */
@@ -119,45 +116,44 @@ char **msOGRRecursiveFileList( const cha
   /* -------------------------------------------------------------------- */
   do {
     change = 0;
-    for( i = 0; i < count-1; i++ ) {
-      if( strcasecmp(file_list[i],file_list[i+1]) > 0 ) {
+    for (i = 0; i < count - 1; i++) {
+      if (strcasecmp(file_list[i], file_list[i + 1]) > 0) {
         char *temp = file_list[i];
-        file_list[i] = file_list[i+1];
-        file_list[i+1] = temp;
+        file_list[i] = file_list[i + 1];
+        file_list[i + 1] = temp;
         change = 1;
       }
     }
-  } while( change );
+  } while (change);
 
   /* -------------------------------------------------------------------- */
   /*      collect names we want and process subdirectories.               */
   /* -------------------------------------------------------------------- */
-  for( i = 0; i < count; i++ ) {
+  for (i = 0; i < count; i++) {
     char full_filename[MS_MAXPATHLEN];
-    VSIStatBufL  sStatBuf;
+    VSIStatBufL sStatBuf;
 
-    if( EQUAL(file_list[i],".") || EQUAL(file_list[i],"..") )
+    if (EQUAL(file_list[i], ".") || EQUAL(file_list[i], ".."))
       continue;
 
-    strlcpy( full_filename,
-             CPLFormFilename( path, file_list[i], NULL ),
-             sizeof(full_filename) );
+    strlcpy(full_filename, CPLFormFilename(path, file_list[i], NULL),
+            sizeof(full_filename));
 
-    if( VSIStatL( full_filename, &sStatBuf ) != 0 )
-        continue;
+    if (VSIStatL(full_filename, &sStatBuf) != 0)
+      continue;
 
-    if( VSI_ISREG( sStatBuf.st_mode ) ) {
-      result_list = CSLAddString( result_list, full_filename );
-    } else if( VSI_ISDIR( sStatBuf.st_mode ) ) {
-      char **subfiles = msOGRRecursiveFileList( full_filename );
+    if (VSI_ISREG(sStatBuf.st_mode)) {
+      result_list = CSLAddString(result_list, full_filename);
+    } else if (VSI_ISDIR(sStatBuf.st_mode)) {
+      char **subfiles = msOGRRecursiveFileList(full_filename);
 
-      result_list = msCSLConcatenate( result_list, subfiles );
+      result_list = msCSLConcatenate(result_list, subfiles);
 
-      CSLDestroy( subfiles );
+      CSLDestroy(subfiles);
     }
   }
 
-  CSLDestroy( file_list );
+  CSLDestroy(file_list);
 
   return result_list;
 }
@@ -165,83 +161,74 @@ char **msOGRRecursiveFileList( const cha
 /************************************************************************/
 /*                           msOGRCleanupDS()                           */
 /************************************************************************/
-static void msOGRCleanupDS( const char *datasource_name )
+static void msOGRCleanupDS(const char *datasource_name)
 
 {
   char **file_list;
   char path[MS_MAXPATHLEN];
   int i;
   VSIStatBufL sStatBuf;
-  
-  if( VSIStatL( datasource_name, &sStatBuf ) != 0 )
+
+  if (VSIStatL(datasource_name, &sStatBuf) != 0)
     return;
-  if( VSI_ISDIR( sStatBuf.st_mode ) )
-    strlcpy( path, datasource_name, sizeof(path) );
+  if (VSI_ISDIR(sStatBuf.st_mode))
+    strlcpy(path, datasource_name, sizeof(path));
   else
-    strlcpy( path, CPLGetPath( datasource_name ), sizeof(path) );
+    strlcpy(path, CPLGetPath(datasource_name), sizeof(path));
 
-  file_list = CPLReadDir( path );
+  file_list = CPLReadDir(path);
 
-  for( i = 0; file_list != NULL && file_list[i] != NULL; i++ ) {
+  for (i = 0; file_list != NULL && file_list[i] != NULL; i++) {
     char full_filename[MS_MAXPATHLEN];
-    VSIStatBufL  sStatBuf;
+    VSIStatBufL sStatBuf;
 
-    if( EQUAL(file_list[i],".") || EQUAL(file_list[i],"..") )
+    if (EQUAL(file_list[i], ".") || EQUAL(file_list[i], ".."))
       continue;
 
-    strlcpy( full_filename,
-             CPLFormFilename( path, file_list[i], NULL ),
-             sizeof(full_filename) );
+    strlcpy(full_filename, CPLFormFilename(path, file_list[i], NULL),
+            sizeof(full_filename));
 
-    if( VSIStatL( full_filename, &sStatBuf ) != 0 )
+    if (VSIStatL(full_filename, &sStatBuf) != 0)
       continue;
 
-    if( VSI_ISREG( sStatBuf.st_mode ) ) {
-      VSIUnlink( full_filename );
-    } else if( VSI_ISDIR( sStatBuf.st_mode ) ) {
-      msOGRCleanupDS( full_filename );
+    if (VSI_ISREG(sStatBuf.st_mode)) {
+      VSIUnlink(full_filename);
+    } else if (VSI_ISDIR(sStatBuf.st_mode)) {
+      msOGRCleanupDS(full_filename);
     }
   }
 
-  CSLDestroy( file_list );
+  CSLDestroy(file_list);
 
-  VSIRmdir( path );
+  VSIRmdir(path);
 }
 
 /************************************************************************/
 /*                          msOGRSetPoints()                            */
 /************************************************************************/
 
-static void msOGRSetPoints( OGRGeometryH hGeom, lineObj *line, int bWant2DOutput)
-{
-    int i;
-    if( bWant2DOutput )
-    {
-      for( i = 0; i < line->numpoints; i++ ) {
-        OGR_G_SetPoint_2D( hGeom, i,
-                           line->point[i].x,
-                           line->point[i].y );
-      }
+static void msOGRSetPoints(OGRGeometryH hGeom, lineObj *line,
+                           int bWant2DOutput) {
+  int i;
+  if (bWant2DOutput) {
+    for (i = 0; i < line->numpoints; i++) {
+      OGR_G_SetPoint_2D(hGeom, i, line->point[i].x, line->point[i].y);
     }
-    else {
-      for( i = 0; i < line->numpoints; i++ ) {
-        OGR_G_SetPoint( hGeom, i,
-                        line->point[i].x,
-                        line->point[i].y,
-                        line->point[i].z
-                      );
-      }
+  } else {
+    for (i = 0; i < line->numpoints; i++) {
+      OGR_G_SetPoint(hGeom, i, line->point[i].x, line->point[i].y,
+                     line->point[i].z);
     }
+  }
 }
 
 /************************************************************************/
 /*                          msOGRWriteShape()                           */
 /************************************************************************/
 
-static int msOGRWriteShape( OGRLayerH hOGRLayer,
-                            shapeObj *shape, gmlItemListObj *item_list,
-                            int nFirstOGRFieldIndex, const char *pszFeatureid,
-                            bool geomTypeForced )
+static int msOGRWriteShape(OGRLayerH hOGRLayer, shapeObj *shape,
+                           gmlItemListObj *item_list, int nFirstOGRFieldIndex,
+                           const char *pszFeatureid, bool geomTypeForced)
 
 {
   OGRGeometryH hGeom = NULL;
@@ -252,7 +239,7 @@ static int msOGRWriteShape( OGRLayerH hO
   OGRFeatureDefnH hLayerDefn;
   int bWant2DOutput;
 
-  hLayerDefn = OGR_L_GetLayerDefn( hOGRLayer );
+  hLayerDefn = OGR_L_GetLayerDefn(hOGRLayer);
   eLayerGType = OGR_FD_GetGeomType(hLayerDefn);
   eFlattenLayerGType = wkbFlatten(eLayerGType);
   bWant2DOutput = (eLayerGType == eFlattenLayerGType);
@@ -260,64 +247,50 @@ static int msOGRWriteShape( OGRLayerH hO
   /* -------------------------------------------------------------------- */
   /*      Transform point geometry.                                       */
   /* -------------------------------------------------------------------- */
-  if( shape->type == MS_SHAPE_POINT ) {
+  if (shape->type == MS_SHAPE_POINT) {
     OGRGeometryH hMP = NULL;
     int j;
 
-    if( shape->numlines == 1 && shape->line[0].numpoints > 1 )
-    {
-      hGeom = OGR_G_CreateGeometry( wkbMultiPoint );
-      for( j = 0; j < shape->line[0].numpoints; j++ ) {
-        OGRGeometryH hPoint = OGR_G_CreateGeometry( wkbPoint );
-        if( bWant2DOutput ) {
-            OGR_G_SetPoint_2D( hPoint, 0,
-                            shape->line[0].point[j].x,
-                            shape->line[0].point[j].y );
-        }
-        else {
-            OGR_G_SetPoint( hPoint, 0,
-                            shape->line[0].point[j].x,
-                            shape->line[0].point[j].y,
-                            shape->line[0].point[j].z
-                            );
+    if (shape->numlines == 1 && shape->line[0].numpoints > 1) {
+      hGeom = OGR_G_CreateGeometry(wkbMultiPoint);
+      for (j = 0; j < shape->line[0].numpoints; j++) {
+        OGRGeometryH hPoint = OGR_G_CreateGeometry(wkbPoint);
+        if (bWant2DOutput) {
+          OGR_G_SetPoint_2D(hPoint, 0, shape->line[0].point[j].x,
+                            shape->line[0].point[j].y);
+        } else {
+          OGR_G_SetPoint(hPoint, 0, shape->line[0].point[j].x,
+                         shape->line[0].point[j].y, shape->line[0].point[j].z);
         }
 
-        OGR_G_AddGeometryDirectly( hGeom, hPoint );
+        OGR_G_AddGeometryDirectly(hGeom, hPoint);
       }
-    }
-    else
-    {
-      if( shape->numlines > 1 )
-        hMP = OGR_G_CreateGeometry( wkbMultiPoint );
-
-      for( j = 0; j < shape->numlines; j++ ) {
-        if( shape->line[j].numpoints != 1 ) {
-          msSetError(MS_MISCERR,
-                    "Failed on odd point geometry.",
-                    "msOGRWriteShape()");
+    } else {
+      if (shape->numlines > 1)
+        hMP = OGR_G_CreateGeometry(wkbMultiPoint);
+
+      for (j = 0; j < shape->numlines; j++) {
+        if (shape->line[j].numpoints != 1) {
+          msSetError(MS_MISCERR, "Failed on odd point geometry.",
+                     "msOGRWriteShape()");
           return MS_FAILURE;
         }
 
-        hGeom = OGR_G_CreateGeometry( wkbPoint );
-        if( bWant2DOutput ) {
-            OGR_G_SetPoint_2D( hGeom, 0,
-                            shape->line[j].point[0].x,
-                            shape->line[j].point[0].y );
-        }
-        else {
-            OGR_G_SetPoint( hGeom, 0,
-                            shape->line[j].point[0].x,
-                            shape->line[j].point[0].y,
-                            shape->line[j].point[0].z
-                            );
+        hGeom = OGR_G_CreateGeometry(wkbPoint);
+        if (bWant2DOutput) {
+          OGR_G_SetPoint_2D(hGeom, 0, shape->line[j].point[0].x,
+                            shape->line[j].point[0].y);
+        } else {
+          OGR_G_SetPoint(hGeom, 0, shape->line[j].point[0].x,
+                         shape->line[j].point[0].y, shape->line[j].point[0].z);
         }
 
-        if( hMP != NULL ) {
-            OGR_G_AddGeometryDirectly( hMP, hGeom );
+        if (hMP != NULL) {
+          OGR_G_AddGeometryDirectly(hMP, hGeom);
         }
       }
-      
-      if( hMP != NULL )
+
+      if (hMP != NULL)
         hGeom = hMP;
     }
   }
@@ -325,28 +298,27 @@ static int msOGRWriteShape( OGRLayerH hO
   /* -------------------------------------------------------------------- */
   /*      Transform line geometry.                                        */
   /* -------------------------------------------------------------------- */
-  else if(  shape->type == MS_SHAPE_LINE ) {
+  else if (shape->type == MS_SHAPE_LINE) {
     OGRGeometryH hML = NULL;
     int j;
 
-    if( shape->numlines > 1 )
-      hML = OGR_G_CreateGeometry( wkbMultiLineString );
+    if (shape->numlines > 1)
+      hML = OGR_G_CreateGeometry(wkbMultiLineString);
 
-    for( j = 0; j < shape->numlines; j++ ) {
+    for (j = 0; j < shape->numlines; j++) {
 
-      if( shape->line[j].numpoints < 2 ) {
-        msSetError(MS_MISCERR,
-                   "Failed on odd line geometry.",
+      if (shape->line[j].numpoints < 2) {
+        msSetError(MS_MISCERR, "Failed on odd line geometry.",
                    "msOGRWriteShape()");
         return MS_FAILURE;
       }
 
-      hGeom = OGR_G_CreateGeometry( wkbLineString );
+      hGeom = OGR_G_CreateGeometry(wkbLineString);
 
-      msOGRSetPoints( hGeom, &(shape->line[j]), bWant2DOutput);
+      msOGRSetPoints(hGeom, &(shape->line[j]), bWant2DOutput);
 
-      if( hML != NULL ) {
-        OGR_G_AddGeometryDirectly( hML, hGeom );
+      if (hML != NULL) {
+        OGR_G_AddGeometryDirectly(hML, hGeom);
         hGeom = hML;
       }
     }
@@ -355,66 +327,62 @@ static int msOGRWriteShape( OGRLayerH hO
   /* -------------------------------------------------------------------- */
   /*      Transform polygon geometry.                                     */
   /* -------------------------------------------------------------------- */
-  else if( shape->type == MS_SHAPE_POLYGON ) {
+  else if (shape->type == MS_SHAPE_POLYGON) {
     int iRing, iOuter;
     int *outer_flags;
     OGRGeometryH hMP = NULL;
 
-    outer_flags = msGetOuterList( shape );
+    outer_flags = msGetOuterList(shape);
 
-    for( iOuter = 0; iOuter < shape->numlines; iOuter++ ) {
+    for (iOuter = 0; iOuter < shape->numlines; iOuter++) {
       int *inner_flags;
       OGRGeometryH hRing;
 
-      if( !outer_flags[iOuter] )
+      if (!outer_flags[iOuter])
         continue;
 
-      if( hGeom != nullptr )
-      {
-          assert( hMP == nullptr );
-          hMP = OGR_G_CreateGeometry( wkbMultiPolygon );
-          OGR_G_AddGeometryDirectly( hMP, hGeom );
+      if (hGeom != nullptr) {
+        assert(hMP == nullptr);
+        hMP = OGR_G_CreateGeometry(wkbMultiPolygon);
+        OGR_G_AddGeometryDirectly(hMP, hGeom);
       }
-      hGeom = OGR_G_CreateGeometry( wkbPolygon );
+      hGeom = OGR_G_CreateGeometry(wkbPolygon);
 
       /* handle outer ring */
 
-      hRing = OGR_G_CreateGeometry( wkbLinearRing );
+      hRing = OGR_G_CreateGeometry(wkbLinearRing);
 
-      msOGRSetPoints( hRing, &(shape->line[iOuter]), bWant2DOutput);
-
-      OGR_G_AddGeometryDirectly( hGeom, hRing );
+      msOGRSetPoints(hRing, &(shape->line[iOuter]), bWant2DOutput);
 
+      OGR_G_AddGeometryDirectly(hGeom, hRing);
 
       /* handle inner rings (holes) */
-      inner_flags = msGetInnerList( shape, iOuter, outer_flags );
+      inner_flags = msGetInnerList(shape, iOuter, outer_flags);
 
-      for( iRing = 0; iRing < shape->numlines; iRing++ ) {
-        if( !inner_flags[iRing] )
+      for (iRing = 0; iRing < shape->numlines; iRing++) {
+        if (!inner_flags[iRing])
           continue;
 
-        hRing = OGR_G_CreateGeometry( wkbLinearRing );
+        hRing = OGR_G_CreateGeometry(wkbLinearRing);
 
-        msOGRSetPoints( hRing, &(shape->line[iRing]), bWant2DOutput);
+        msOGRSetPoints(hRing, &(shape->line[iRing]), bWant2DOutput);
 
-        OGR_G_AddGeometryDirectly( hGeom, hRing );
+        OGR_G_AddGeometryDirectly(hGeom, hRing);
       }
 
       free(inner_flags);
 
-      if( hMP )
-      {
-          OGR_G_AddGeometryDirectly( hMP, hGeom );
-          hGeom = nullptr;
+      if (hMP) {
+        OGR_G_AddGeometryDirectly(hMP, hGeom);
+        hGeom = nullptr;
       }
     }
 
     free(outer_flags);
 
-    if( hMP != nullptr )
-    {
-        assert( hGeom == nullptr );
-        hGeom = hMP;
+    if (hMP != nullptr) {
+      assert(hGeom == nullptr);
+      hGeom = hMP;
     }
   }
 
@@ -422,22 +390,22 @@ static int msOGRWriteShape( OGRLayerH hO
   /*      Consider trying to force the geometry to a new type if it       */
   /*      doesn't match the layer.                                        */
   /* -------------------------------------------------------------------- */
-  if( hGeom != NULL ) {
+  if (hGeom != NULL) {
     OGRwkbGeometryType eFlattenFeatureGType =
-        wkbFlatten(OGR_G_GetGeometryType( hGeom ));
+        wkbFlatten(OGR_G_GetGeometryType(hGeom));
 
-    if( eFlattenFeatureGType != eFlattenLayerGType ) {
-      if( eFlattenLayerGType == wkbPolygon && geomTypeForced )
-        hGeom = OGR_G_ForceToPolygon( hGeom );
+    if (eFlattenFeatureGType != eFlattenLayerGType) {
+      if (eFlattenLayerGType == wkbPolygon && geomTypeForced)
+        hGeom = OGR_G_ForceToPolygon(hGeom);
 
-      else if( eFlattenLayerGType == wkbMultiPolygon )
-        hGeom = OGR_G_ForceToMultiPolygon( hGeom );
+      else if (eFlattenLayerGType == wkbMultiPolygon)
+        hGeom = OGR_G_ForceToMultiPolygon(hGeom);
 
-      else if( eFlattenLayerGType == wkbMultiPoint )
-        hGeom = OGR_G_ForceToMultiPoint( hGeom );
+      else if (eFlattenLayerGType == wkbMultiPoint)
+        hGeom = OGR_G_ForceToMultiPoint(hGeom);
 
-      else if( eFlattenLayerGType == wkbMultiLineString )
-        hGeom = OGR_G_ForceToMultiLineString( hGeom );
+      else if (eFlattenLayerGType == wkbMultiLineString)
+        hGeom = OGR_G_ForceToMultiLineString(hGeom);
     }
   }
 
@@ -448,71 +416,66 @@ static int msOGRWriteShape( OGRLayerH hO
   /*      OGR_G_SetPoint_2D is properly honoured.                         */
   /* -------------------------------------------------------------------- */
 
-  if( bWant2DOutput && hGeom != NULL ) {
-    OGRwkbGeometryType eFeatureGType = OGR_G_GetGeometryType( hGeom );
-    if( eFeatureGType != wkbFlatten(eFeatureGType) )
-      OGR_G_FlattenTo2D( hGeom );
+  if (bWant2DOutput && hGeom != NULL) {
+    OGRwkbGeometryType eFeatureGType = OGR_G_GetGeometryType(hGeom);
+    if (eFeatureGType != wkbFlatten(eFeatureGType))
+      OGR_G_FlattenTo2D(hGeom);
   }
 
   /* -------------------------------------------------------------------- */
   /*      Create the feature, and attach the geometry.                    */
   /* -------------------------------------------------------------------- */
-  hFeat = OGR_F_Create( hLayerDefn );
+  hFeat = OGR_F_Create(hLayerDefn);
 
-  OGR_F_SetGeometryDirectly( hFeat, hGeom );
+  OGR_F_SetGeometryDirectly(hFeat, hGeom);
 
   /* -------------------------------------------------------------------- */
   /*      Set attributes.                                                 */
   /* -------------------------------------------------------------------- */
   out_field = nFirstOGRFieldIndex;
-  for( i = 0; i < item_list->numitems; i++ ) {
+  for (i = 0; i < item_list->numitems; i++) {
     gmlItemObj *item = item_list->items + i;
 
-    if(pszFeatureid && !strcmp(pszFeatureid, item->name)) {
+    if (pszFeatureid && !strcmp(pszFeatureid, item->name)) {
       char *endptr;
-      long feature_id = strtol(shape->values[i],&endptr,10);
-      if(endptr && *endptr==0) {
+      long feature_id = strtol(shape->values[i], &endptr, 10);
+      if (endptr && *endptr == 0) {
         /* only set the featureid if it is numeric */
         OGR_F_SetFID(hFeat, feature_id);
       }
     }
 
-    if( !item->visible )
+    if (!item->visible)
       continue;
 
     /* Avoid setting empty strings for numeric fields, so that OGR */
     /* doesn't take them as 0. (#4633) */
-    if( shape->values[i][0] == '\0' ) {
+    if (shape->values[i][0] == '\0') {
       OGRFieldDefnH hFieldDefn = OGR_FD_GetFieldDefn(hLayerDefn, out_field);
       OGRFieldType eFieldType = OGR_Fld_GetType(hFieldDefn);
-      if( eFieldType == OFTInteger || eFieldType == OFTReal
-          || eFieldType == OFTInteger64
-          )
-      {
+      if (eFieldType == OFTInteger || eFieldType == OFTReal ||
+          eFieldType == OFTInteger64) {
         out_field++;
         continue;
       }
     }
 
-    OGR_F_SetFieldString( hFeat, out_field++, shape->values[i] );
+    OGR_F_SetFieldString(hFeat, out_field++, shape->values[i]);
   }
 
   /* -------------------------------------------------------------------- */
   /*      Write out and cleanup.                                          */
   /* -------------------------------------------------------------------- */
-  eErr = OGR_L_CreateFeature( hOGRLayer, hFeat );
+  eErr = OGR_L_CreateFeature(hOGRLayer, hFeat);
 
-  OGR_F_Destroy( hFeat );
+  OGR_F_Destroy(hFeat);
 
-  if( eErr != OGRERR_NONE ) {
-    msSetError( MS_OGRERR,
-                "Attempt to write feature failed (code=%d):\n%s",
-                "msOGRWriteShape()",
-                (int) eErr,
-                CPLGetLastErrorMsg() );
+  if (eErr != OGRERR_NONE) {
+    msSetError(MS_OGRERR, "Attempt to write feature failed (code=%d):\n%s",
+               "msOGRWriteShape()", (int)eErr, CPLGetLastErrorMsg());
   }
 
-  if( eErr == OGRERR_NONE )
+  if (eErr == OGRERR_NONE)
     return MS_SUCCESS;
   else
     return MS_FAILURE;
@@ -523,10 +486,10 @@ static int msOGRWriteShape( OGRLayerH hO
 /************************************************************************/
 
 /* Used by /vsistdout/ */
-static size_t msOGRStdoutWriteFunction(const void* ptr, size_t size, size_t nmemb, FILE* stream)
-{
-    msIOContext *ioctx = (msIOContext*) stream;
-    return msIO_contextWrite(ioctx, ptr, size * nmemb ) / size;
+static size_t msOGRStdoutWriteFunction(const void *ptr, size_t size,
+                                       size_t nmemb, FILE *stream) {
+  msIOContext *ioctx = (msIOContext *)stream;
+  return msIO_contextWrite(ioctx, ptr, size * nmemb) / size;
 }
 
 /************************************************************************/
@@ -537,115 +500,93 @@ static size_t msOGRStdoutWriteFunction(c
 /************************************************************************/
 
 /* Result to be freed with CSLDestroy() */
-static char** msOGROutputGetAdditonalFiles( mapObj *map )
-{
-    int i;
-    hashTableObj* hSetAdditionalFiles;
-    char** papszFiles = NULL;
-
-    hSetAdditionalFiles = msCreateHashTable();
-
-    for( i = -1; i < map->numlayers; i++ )
-    {
-        const char* value;
-        if( i < 0 )
-        {
-            value = msOWSLookupMetadata(&(map->web.metadata), "FO", "additional_files_in_output");
-        }
-        else
-        {
-            layerObj *layer = GET_LAYER(map, i);
-            if( !layer->resultcache || layer->resultcache->numresults == 0 )
-                continue;
-            value = msOWSLookupMetadata(&(layer->metadata), "FO", "additional_files_in_output");
-        }
+static char **msOGROutputGetAdditonalFiles(mapObj *map) {
+  int i;
+  hashTableObj *hSetAdditionalFiles;
+  char **papszFiles = NULL;
+
+  hSetAdditionalFiles = msCreateHashTable();
+
+  for (i = -1; i < map->numlayers; i++) {
+    const char *value;
+    if (i < 0) {
+      value = msOWSLookupMetadata(&(map->web.metadata), "FO",
+                                  "additional_files_in_output");
+    } else {
+      layerObj *layer = GET_LAYER(map, i);
+      if (!layer->resultcache || layer->resultcache->numresults == 0)
+        continue;
+      value = msOWSLookupMetadata(&(layer->metadata), "FO",
+                                  "additional_files_in_output");
+    }
 
-        if( value != NULL )
-        {
-            char** papszList = CSLTokenizeString2( value, ",", CSLT_HONOURSTRINGS );
-            char** papszListIter = papszList;
-            while( papszListIter && *papszListIter )
-            {
-                const char* file = *papszListIter;
-                VSIStatBufL sStat;
-
-                if( strncmp(file, "http://", strlen("http://")) == 0 ||
-                    strncmp(file, "https://", strlen("https://")) == 0 )
-                {
-                    /* Remote file ? We will use /vsicurl_streaming/ to read it */
-                    if( msLookupHashTable(hSetAdditionalFiles, file) == NULL )
-                    {
-                        msInsertHashTable(hSetAdditionalFiles, file, "YES");
-                        papszFiles = CSLAddString(papszFiles, CPLSPrintf("/vsicurl_streaming/%s", file));
-                    }
-                }
-                else
-                {
-                    int nLen = (int)strlen(file);
-                    char filename[MS_MAXPATHLEN];
-
-                    if( CPLIsFilenameRelative(file) )
-                    {
-                        if( !map->shapepath )
-                            msTryBuildPath(filename, map->mappath, file);
-                        else
-                            msTryBuildPath3(filename, map->mappath, map->shapepath, file);
-                    }
-                    else
-                        strlcpy(filename, file, MS_MAXPATHLEN);
-
-                    if( nLen > 2 && (
-                            strcmp(file + nLen - 1, "/") == 0 ||
-                            strcmp(file + nLen - 2, "/*") == 0 ) )
-                    {
-                        *strrchr(filename, '/') = '\0';
-                    }
-                    else if( nLen > 2 && (
-                            strcmp(file + nLen - 1, "\\") == 0 ||
-                            strcmp(file + nLen - 2, "\\*") == 0 ) )
-                    {
-                        *strrchr(filename, '\\') = '\0';
-                    }
-
-                    if( msLookupHashTable(hSetAdditionalFiles, filename) == NULL )
-                    {
-                        msInsertHashTable(hSetAdditionalFiles, filename, "YES");
-                        if( VSIStatL( filename, &sStat ) == 0 )
-                        {
-                            if( VSI_ISDIR( sStat.st_mode ) )
-                            {
-                                char** papszDirContent = msOGRRecursiveFileList(filename);
-                                papszFiles = msCSLConcatenate(papszFiles, papszDirContent);
-                                CSLDestroy(papszDirContent);
-                            }
-                            else
-                            {
-                                papszFiles = CSLAddString(papszFiles, filename);
-                            }
-                        }
-                        else
-                        {
-                            msDebug("File %s does not exist.\n", filename);
-                        }
-                    }
-                }
+    if (value != NULL) {
+      char **papszList = CSLTokenizeString2(value, ",", CSLT_HONOURSTRINGS);
+      char **papszListIter = papszList;
+      while (papszListIter && *papszListIter) {
+        const char *file = *papszListIter;
+        VSIStatBufL sStat;
+
+        if (strncmp(file, "http://", strlen("http://")) == 0 ||
+            strncmp(file, "https://", strlen("https://")) == 0) {
+          /* Remote file ? We will use /vsicurl_streaming/ to read it */
+          if (msLookupHashTable(hSetAdditionalFiles, file) == NULL) {
+            msInsertHashTable(hSetAdditionalFiles, file, "YES");
+            papszFiles = CSLAddString(
+                papszFiles, CPLSPrintf("/vsicurl_streaming/%s", file));
+          }
+        } else {
+          int nLen = (int)strlen(file);
+          char filename[MS_MAXPATHLEN];
+
+          if (CPLIsFilenameRelative(file)) {
+            if (!map->shapepath)
+              msTryBuildPath(filename, map->mappath, file);
+            else
+              msTryBuildPath3(filename, map->mappath, map->shapepath, file);
+          } else
+            strlcpy(filename, file, MS_MAXPATHLEN);
+
+          if (nLen > 2 && (strcmp(file + nLen - 1, "/") == 0 ||
+                           strcmp(file + nLen - 2, "/*") == 0)) {
+            *strrchr(filename, '/') = '\0';
+          } else if (nLen > 2 && (strcmp(file + nLen - 1, "\\") == 0 ||
+                                  strcmp(file + nLen - 2, "\\*") == 0)) {
+            *strrchr(filename, '\\') = '\0';
+          }
 
-                papszListIter ++;
+          if (msLookupHashTable(hSetAdditionalFiles, filename) == NULL) {
+            msInsertHashTable(hSetAdditionalFiles, filename, "YES");
+            if (VSIStatL(filename, &sStat) == 0) {
+              if (VSI_ISDIR(sStat.st_mode)) {
+                char **papszDirContent = msOGRRecursiveFileList(filename);
+                papszFiles = msCSLConcatenate(papszFiles, papszDirContent);
+                CSLDestroy(papszDirContent);
+              } else {
+                papszFiles = CSLAddString(papszFiles, filename);
+              }
+            } else {
+              msDebug("File %s does not exist.\n", filename);
             }
-            CSLDestroy(papszList);
+          }
         }
+
+        papszListIter++;
+      }
+      CSLDestroy(papszList);
     }
-    
-    msFreeHashTable(hSetAdditionalFiles);
-    
-    return papszFiles;
+  }
+
+  msFreeHashTable(hSetAdditionalFiles);
+
+  return papszFiles;
 }
 
 /************************************************************************/
 /*                        msOGRWriteFromQuery()                         */
 /************************************************************************/
 
-int msOGRWriteFromQuery( mapObj *map, outputFormatObj *format, int sendheaders )
+int msOGRWriteFromQuery(mapObj *map, outputFormatObj *format, int sendheaders)
 
 {
   /* -------------------------------------------------------------------- */
@@ -665,91 +606,85 @@ int msOGRWriteFromQuery( mapObj *map, ou
   int iLayer, i;
   int bDataSourceNameIsRequestDir = FALSE;
   int bUseFeatureId = MS_FALSE;
-  const char* pszMatchingFeatures;
+  const char *pszMatchingFeatures;
   int nMatchingFeatures = -1;
-  const char* pszFormatName = format->driver+4;
-  
-  pszMatchingFeatures = msGetOutputFormatOption(format, "_matching_features_", "");
-  if( pszMatchingFeatures[0] != '\0' )
-      nMatchingFeatures = atoi(pszMatchingFeatures);
+  const char *pszFormatName = format->driver + 4;
+
+  pszMatchingFeatures =
+      msGetOutputFormatOption(format, "_matching_features_", "");
+  if (pszMatchingFeatures[0] != '\0')
+    nMatchingFeatures = atoi(pszMatchingFeatures);
 
   /* -------------------------------------------------------------------- */
   /*      Fetch the output format driver.                                 */
   /* -------------------------------------------------------------------- */
   msOGRInitialize();
 
-  hDriver = OGRGetDriverByName( pszFormatName );
-  if( hDriver == NULL ) {
-    msSetError( MS_MISCERR, "No OGR driver named `%s' available.",
-                "msOGRWriteFromQuery()", pszFormatName );
+  hDriver = OGRGetDriverByName(pszFormatName);
+  if (hDriver == NULL) {
+    msSetError(MS_MISCERR, "No OGR driver named `%s' available.",
+               "msOGRWriteFromQuery()", pszFormatName);
     return MS_FAILURE;
   }
 
   /* -------------------------------------------------------------------- */
   /*      Capture datasource and layer creation options.                  */
   /* -------------------------------------------------------------------- */
-  for( i=0; i < format->numformatoptions; i++ ) {
-    if( strncasecmp(format->formatoptions[i],"LCO:",4) == 0 )
-      layer_options = CSLAddString( layer_options,
-                                    format->formatoptions[i] + 4 );
-    if( strncasecmp(format->formatoptions[i],"DSCO:",5) == 0 )
-      ds_options = CSLAddString( ds_options,
-                                 format->formatoptions[i] + 5 );
-  }
-  if( EQUAL(pszFormatName, "GeoJSON") && nMatchingFeatures >= 0 )
-  {
-      const char* pszNativeData =
+  for (i = 0; i < format->numformatoptions; i++) {
+    if (strncasecmp(format->formatoptions[i], "LCO:", 4) == 0)
+      layer_options = CSLAddString(layer_options, format->formatoptions[i] + 4);
+    if (strncasecmp(format->formatoptions[i], "DSCO:", 5) == 0)
+      ds_options = CSLAddString(ds_options, format->formatoptions[i] + 5);
+  }
+  if (EQUAL(pszFormatName, "GeoJSON") && nMatchingFeatures >= 0) {
+    const char *pszNativeData =
         CSLFetchNameValueDef(layer_options, "NATIVE_DATA", "{}");
-      if( pszNativeData[strlen(pszNativeData)-1] == '}' )
-      {
-          std::string tmpl(pszNativeData);
-          tmpl.resize(tmpl.size() - 1);
-          if( strlen(pszNativeData) > 2 )
-              tmpl += ',';
-          tmpl += "\"numberMatched\":";
-          tmpl += std::to_string(nMatchingFeatures);
-          tmpl += '}';
-          layer_options = CSLSetNameValue(layer_options,
-                                          "NATIVE_MEDIA_TYPE",
-                                          "application/vnd.geo+json");
-          layer_options = CSLSetNameValue(layer_options,
-                                          "NATIVE_DATA",
-                                          tmpl.c_str());
-      }
+    if (pszNativeData[strlen(pszNativeData) - 1] == '}') {
+      std::string tmpl(pszNativeData);
+      tmpl.resize(tmpl.size() - 1);
+      if (strlen(pszNativeData) > 2)
+        tmpl += ',';
+      tmpl += "\"numberMatched\":";
+      tmpl += std::to_string(nMatchingFeatures);
+      tmpl += '}';
+      layer_options = CSLSetNameValue(layer_options, "NATIVE_MEDIA_TYPE",
+                                      "application/vnd.geo+json");
+      layer_options =
+          CSLSetNameValue(layer_options, "NATIVE_DATA", tmpl.c_str());
+    }
   }
-  if(!strcasecmp("true",msGetOutputFormatOption(format,"USE_FEATUREID","false"))) {
+  if (!strcasecmp("true",
+                  msGetOutputFormatOption(format, "USE_FEATUREID", "false"))) {
     bUseFeatureId = MS_TRUE;
   }
 
   /* ==================================================================== */
   /*      Determine the output datasource name to use.                    */
   /* ==================================================================== */
-  storage = msGetOutputFormatOption( format, "STORAGE", "filesystem" );
-  if( EQUAL(storage,"stream") && !msIO_isStdContext() ) {
-    msIOContext *ioctx = msIO_getHandler (stdout);
-    if( ioctx != NULL )
-        VSIStdoutSetRedirection( msOGRStdoutWriteFunction, (FILE*)ioctx );
+  storage = msGetOutputFormatOption(format, "STORAGE", "filesystem");
+  if (EQUAL(storage, "stream") && !msIO_isStdContext()) {
+    msIOContext *ioctx = msIO_getHandler(stdout);
+    if (ioctx != NULL)
+      VSIStdoutSetRedirection(msOGRStdoutWriteFunction, (FILE *)ioctx);
     else
-    /* bug #4858, streaming output won't work if standard output has been
-     * redirected, we switch to memory output in this case
-     */
-    storage = "memory";
+      /* bug #4858, streaming output won't work if standard output has been
+       * redirected, we switch to memory output in this case
+       */
+      storage = "memory";
   }
 
   /* -------------------------------------------------------------------- */
   /*      Where are we putting stuff?                                     */
   /* -------------------------------------------------------------------- */
-  if( EQUAL(storage,"filesystem") ) {
-    base_dir[0] = '\0' ;
-  } else if( EQUAL(storage,"memory") ) {
-    strcpy( base_dir, "/vsimem/ogr_out/" );
-  } else if( EQUAL(storage,"stream") ) {
+  if (EQUAL(storage, "filesystem")) {
+    base_dir[0] = '\0';
+  } else if (EQUAL(storage, "memory")) {
+    strcpy(base_dir, "/vsimem/ogr_out/");
+  } else if (EQUAL(storage, "stream")) {
     /* handled later */
   } else {
-    msSetError( MS_MISCERR,
-                "STORAGE=%s value not supported.",
-                "msOGRWriteFromQuery()",
-                storage );
+    msSetError(MS_MISCERR, "STORAGE=%s value not supported.",
+               "msOGRWriteFromQuery()", storage);
     CSLDestroy(layer_options);
     CSLDestroy(ds_options);
     return MS_FAILURE;
@@ -758,29 +693,27 @@ int msOGRWriteFromQuery( mapObj *map, ou
   /* -------------------------------------------------------------------- */
   /*      Create a subdirectory to handle this request.                   */
   /* -------------------------------------------------------------------- */
-  if( !EQUAL(storage,"stream") ) {
-    const char* dir_to_create;
+  if (!EQUAL(storage, "stream")) {
+    const char *dir_to_create;
     if (strlen(base_dir) > 0)
-      request_dir = msTmpFile(map, NULL, base_dir, "" );
+      request_dir = msTmpFile(map, NULL, base_dir, "");
     else
-      request_dir = msTmpFile(map, NULL, NULL, "" );
+      request_dir = msTmpFile(map, NULL, NULL, "");
 
-    if( request_dir[strlen(request_dir)-1] == '.' )
-      request_dir[strlen(request_dir)-1] = '\0';
+    if (request_dir[strlen(request_dir) - 1] == '.')
+      request_dir[strlen(request_dir) - 1] = '\0';
 
     dir_to_create = request_dir;
     /* Workaround issue in GDAL versions released at this time :
      * GDAL issue fixed per https://trac.osgeo.org/gdal/ticket/6991 */
-    if( EQUAL(storage,"memory") && EQUAL(format->driver+4, "ESRI Shapefile") )
-    {
-        dir_to_create = base_dir;
+    if (EQUAL(storage, "memory") &&
+        EQUAL(format->driver + 4, "ESRI Shapefile")) {
+      dir_to_create = base_dir;
     }
 
-    if( VSIMkdir( dir_to_create, 0777 ) != 0 ) {
-      msSetError( MS_MISCERR,
-                  "Attempt to create directory '%s' failed.",
-                  "msOGRWriteFromQuery()",
-                  dir_to_create );
+    if (VSIMkdir(dir_to_create, 0777) != 0) {
+      msSetError(MS_MISCERR, "Attempt to create directory '%s' failed.",
+                 "msOGRWriteFromQuery()", dir_to_create);
       msFree(request_dir);
       CSLDestroy(layer_options);
       CSLDestroy(ds_options);
@@ -792,84 +725,83 @@ int msOGRWriteFromQuery( mapObj *map, ou
   /* -------------------------------------------------------------------- */
   /*      Setup the full datasource name.                                 */
   /* -------------------------------------------------------------------- */
-  form = msGetOutputFormatOption( format, "FORM", "zip" );
+  form = msGetOutputFormatOption(format, "FORM", "zip");
 
-  if( EQUAL(form,"zip") )
-    fo_filename = msGetOutputFormatOption( format, "FILENAME", "result.zip" );
+  if (EQUAL(form, "zip"))
+    fo_filename = msGetOutputFormatOption(format, "FILENAME", "result.zip");
   else
-    fo_filename = msGetOutputFormatOption( format, "FILENAME", "result.dat" );
+    fo_filename = msGetOutputFormatOption(format, "FILENAME", "result.dat");
 
   /* Validate that the filename does not contain any directory */
   /* information, which might lead to removal of unwanted files. (#4086) */
-  if( strchr(fo_filename, '/') != NULL || strchr(fo_filename, ':') != NULL ||
-        strchr(fo_filename, '\\') != NULL ) {
-    msSetError( MS_MISCERR,
-           "Invalid value for FILENAME option. "
-           "It must not contain any directory information.",
-           "msOGRWriteFromQuery()" );
+  if (strchr(fo_filename, '/') != NULL || strchr(fo_filename, ':') != NULL ||
+      strchr(fo_filename, '\\') != NULL) {
+    msSetError(MS_MISCERR,
+               "Invalid value for FILENAME option. "
+               "It must not contain any directory information.",
+               "msOGRWriteFromQuery()");
     msFree(request_dir);
     CSLDestroy(layer_options);
     CSLDestroy(ds_options);
     return MS_FAILURE;
   }
 
-  if( !EQUAL(storage,"stream") )
-  {
-    msBuildPath( datasource_name, request_dir, fo_filename );
+  if (!EQUAL(storage, "stream")) {
+    if (!msBuildPath(datasource_name, request_dir, fo_filename)) {
+      msFree(request_dir);
+      CSLDestroy(layer_options);
+      CSLDestroy(ds_options);
+      return MS_FAILURE;
+    }
 
-    if( EQUAL(form,"zip") )
-    {
+    if (EQUAL(form, "zip")) {
       /* if generating a zip file, remove the zip extension for the internal */
       /* filename */
-      if( EQUAL(CPLGetExtension(datasource_name), "zip") ) {
+      if (EQUAL(CPLGetExtension(datasource_name), "zip")) {
         *strrchr(datasource_name, '.') = '\0';
       }
 
       /* and add .dat extension if user didn't provide another extension */
-      if( EQUAL(CPLGetExtension(datasource_name), "") ) {
-        strcat(datasource_name, ".dat");
+      if (EQUAL(CPLGetExtension(datasource_name), "")) {
+        strlcat(datasource_name, ".dat", sizeof(datasource_name));
       }
     }
 
     /* Shapefile and MapInfo driver only properly work with multiple layers */
     /* if the output dataset name is a directory */
-    if( EQUAL(format->driver+4, "ESRI Shapefile") ||
-        EQUAL(format->driver+4, "MapInfo File") )
-    {
-        bDataSourceNameIsRequestDir = TRUE;
-        strcpy(datasource_name, request_dir);
+    if (EQUAL(format->driver + 4, "ESRI Shapefile") ||
+        EQUAL(format->driver + 4, "MapInfo File")) {
+      bDataSourceNameIsRequestDir = TRUE;
+      strcpy(datasource_name, request_dir);
     }
-  }
-  else
-    strcpy( datasource_name, "/vsistdout/" );
+  } else
+    strcpy(datasource_name, "/vsistdout/");
 
-  msFree( request_dir );
+  msFree(request_dir);
   request_dir = NULL;
 
   /* -------------------------------------------------------------------- */
   /*      Emit content type headers for stream output now.                */
   /* -------------------------------------------------------------------- */
-  if( EQUAL(storage,"stream") ) {
-    if( sendheaders && format->mimetype ) {
-      msIO_setHeader("Content-Type","%s",format->mimetype);
+  if (EQUAL(storage, "stream")) {
+    if (sendheaders && format->mimetype) {
+      msIO_setHeader("Content-Type", "%s", format->mimetype);
       msIO_sendHeaders();
     } else
-      msIO_fprintf( stdout, "%c", 10 );
+      msIO_fprintf(stdout, "%c", 10);
   }
 
   /* ==================================================================== */
   /*      Create the datasource.                                          */
   /* ==================================================================== */
-  hDS = OGR_Dr_CreateDataSource( hDriver,  datasource_name, ds_options );
-  CSLDestroy( ds_options );
+  hDS = OGR_Dr_CreateDataSource(hDriver, datasource_name, ds_options);
+  CSLDestroy(ds_options);
 
-  if( hDS == NULL ) {
-    msOGRCleanupDS( datasource_name );
-    msSetError( MS_MISCERR,
-                "OGR CreateDataSource failed for '%s' with driver '%s'.",
-                "msOGRWriteFromQuery()",
-                datasource_name,
-                format->driver+4 );
+  if (hDS == NULL) {
+    msOGRCleanupDS(datasource_name);
+    msSetError(MS_MISCERR,
+               "OGR CreateDataSource failed for '%s' with driver '%s'.",
+               "msOGRWriteFromQuery()", datasource_name, format->driver + 4);
     CSLDestroy(layer_options);
     return MS_FAILURE;
   }
@@ -877,7 +809,7 @@ int msOGRWriteFromQuery( mapObj *map, ou
   /* ==================================================================== */
   /*      Process each layer with a resultset.                            */
   /* ==================================================================== */
-  for( iLayer = 0; iLayer < map->numlayers; iLayer++ ) {
+  for (iLayer = 0; iLayer < map->numlayers; iLayer++) {
     int status = 0;
     layerObj *layer = GET_LAYER(map, iLayer);
     shapeObj resultshape;
@@ -887,18 +819,18 @@ int msOGRWriteFromQuery( mapObj *map, ou
     gmlItemListObj *item_list = NULL;
     const char *value;
     char *pszWKT;
-    int  nFirstOGRFieldIndex = -1;
+    int nFirstOGRFieldIndex = -1;
     const char *pszFeatureid = NULL;
 
-    if( !layer->resultcache )
+    if (!layer->resultcache)
       continue;
 
     /* -------------------------------------------------------------------- */
     /*      Will we need to reproject?                                      */
     /* -------------------------------------------------------------------- */
-    if(layer->transform == MS_TRUE)
-        layer->project = msProjectionsDiffer(&(layer->projection),
-                               &(layer->map->projection));
+    if (layer->transform == MS_TRUE)
+      layer->project =
+          msProjectionsDiffer(&(layer->projection), &(layer->map->projection));
 
     /* -------------------------------------------------------------------- */
     /*      Establish the geometry type to use for the created layer.       */
@@ -907,53 +839,54 @@ int msOGRWriteFromQuery( mapObj *map, ou
     /* -------------------------------------------------------------------- */
     value = msOWSLookupMetadata(&(layer->metadata), "FOG", "geomtype");
     bool geomTypeForced = true;
-    if( value == NULL ) {
+    if (value == NULL) {
       geomTypeForced = false;
-      if( layer->type == MS_LAYER_POINT )
+      if (layer->type == MS_LAYER_POINT)
         value = "Point";
-      else if( layer->type == MS_LAYER_LINE )
+      else if (layer->type == MS_LAYER_LINE)
         value = "LineString";
-      else if( layer->type == MS_LAYER_POLYGON )
+      else if (layer->type == MS_LAYER_POLYGON)
         value = "Polygon";
       else
         value = "Geometry";
     }
 
-    if(bUseFeatureId)
-      pszFeatureid = msOWSLookupMetadata(&(layer->metadata), "FOG", "featureid");
+    if (bUseFeatureId)
+      pszFeatureid =
+          msOWSLookupMetadata(&(layer->metadata), "FOG", "featureid");
 
-    if( strcasecmp(value,"Point") == 0 )
+    if (strcasecmp(value, "Point") == 0)
       eGeomType = wkbPoint;
-    else if( strcasecmp(value,"LineString") == 0 )
+    else if (strcasecmp(value, "LineString") == 0)
       eGeomType = wkbLineString;
-    else if( strcasecmp(value,"Polygon") == 0 )
+    else if (strcasecmp(value, "Polygon") == 0)
       eGeomType = wkbPolygon;
-    else if( strcasecmp(value,"MultiPoint") == 0 )
+    else if (strcasecmp(value, "MultiPoint") == 0)
       eGeomType = wkbMultiPoint;
-    else if( strcasecmp(value,"MultiLineString") == 0 )
+    else if (strcasecmp(value, "MultiLineString") == 0)
       eGeomType = wkbMultiLineString;
-    else if( strcasecmp(value,"MultiPolygon") == 0 )
+    else if (strcasecmp(value, "MultiPolygon") == 0)
       eGeomType = wkbMultiPolygon;
-    else if( strcasecmp(value,"GeometryCollection") == 0 )
+    else if (strcasecmp(value, "GeometryCollection") == 0)
       eGeomType = wkbGeometryCollection;
-    else if( strcasecmp(value,"Point25D") == 0 )
+    else if (strcasecmp(value, "Point25D") == 0)
       eGeomType = wkbPoint25D;
-    else if( strcasecmp(value,"LineString25D") == 0 )
+    else if (strcasecmp(value, "LineString25D") == 0)
       eGeomType = wkbLineString25D;
-    else if( strcasecmp(value,"Polygon25D") == 0 )
+    else if (strcasecmp(value, "Polygon25D") == 0)
       eGeomType = wkbPolygon25D;
-    else if( strcasecmp(value,"MultiPoint25D") == 0 )
+    else if (strcasecmp(value, "MultiPoint25D") == 0)
       eGeomType = wkbMultiPoint25D;
-    else if( strcasecmp(value,"MultiLineString25D") == 0 )
+    else if (strcasecmp(value, "MultiLineString25D") == 0)
       eGeomType = wkbMultiLineString25D;
-    else if( strcasecmp(value,"MultiPolygon25D") == 0 )
+    else if (strcasecmp(value, "MultiPolygon25D") == 0)
       eGeomType = wkbMultiPolygon25D;
-    else if( strcasecmp(value,"GeometryCollection25D") == 0 )
+    else if (strcasecmp(value, "GeometryCollection25D") == 0)
       eGeomType = wkbGeometryCollection25D;
-    else if( strcasecmp(value,"Unknown") == 0
-             || strcasecmp(value,"Geometry") == 0 )
+    else if (strcasecmp(value, "Unknown") == 0 ||
+             strcasecmp(value, "Geometry") == 0)
       eGeomType = wkbUnknown;
-    else if( strcasecmp(value,"None") == 0 )
+    else if (strcasecmp(value, "None") == 0)
       eGeomType = wkbNone;
     else
       eGeomType = wkbUnknown;
@@ -961,114 +894,112 @@ int msOGRWriteFromQuery( mapObj *map, ou
     /* -------------------------------------------------------------------- */
     /*      Create a spatial reference.                                     */
     /* -------------------------------------------------------------------- */
-    pszWKT = msProjectionObj2OGCWKT( &(map->projection) );
-    if( pszWKT != NULL ) {
-      srs = OSRNewSpatialReference( pszWKT );
-      msFree( pszWKT );
+    pszWKT = msProjectionObj2OGCWKT(&(map->projection));
+    if (pszWKT != NULL) {
+      srs = OSRNewSpatialReference(pszWKT);
+      msFree(pszWKT);
     }
 
     /* -------------------------------------------------------------------- */
     /*      Create the corresponding OGR Layer.                             */
     /* -------------------------------------------------------------------- */
-    hOGRLayer = OGR_DS_CreateLayer( hDS, layer->name, srs, eGeomType,
-                                    layer_options );
-    if( hOGRLayer == NULL ) {
-      OGR_DS_Destroy( hDS );
-      msOGRCleanupDS( datasource_name );
-      msSetError( MS_MISCERR,
-                  "OGR OGR_DS_CreateLayer failed for layer '%s' with driver '%s'.",
-                  "msOGRWriteFromQuery()",
-                  layer->name,
-                  format->driver+4 );
+    hOGRLayer =
+        OGR_DS_CreateLayer(hDS, layer->name, srs, eGeomType, layer_options);
+    if (hOGRLayer == NULL) {
+      OGR_DS_Destroy(hDS);
+      msOGRCleanupDS(datasource_name);
+      msSetError(
+          MS_MISCERR,
+          "OGR OGR_DS_CreateLayer failed for layer '%s' with driver '%s'.",
+          "msOGRWriteFromQuery()", layer->name, format->driver + 4);
       CSLDestroy(layer_options);
       return MS_FAILURE;
     }
 
-    if( srs != NULL )
-      OSRRelease( srs );
+    if (srs != NULL)
+      OSRRelease(srs);
 
     /* -------------------------------------------------------------------- */
     /*      Create appropriate attributes on this layer.                    */
     /* -------------------------------------------------------------------- */
-    item_list = msGMLGetItems( layer, "G" );
-    assert( item_list->numitems == layer->numitems );
+    item_list = msGMLGetItems(layer, "G");
+    assert(item_list->numitems == layer->numitems);
 
-    for( i = 0; i < layer->numitems; i++ ) {
+    for (i = 0; i < layer->numitems; i++) {
       OGRFieldDefnH hFldDefn;
       OGRErr eErr;
       const char *name;
       gmlItemObj *item = item_list->items + i;
       OGRFieldType eType;
 
-      if( !item->visible )
+      if (!item->visible)
         continue;
 
-      if( item->alias )
+      if (item->alias)
         name = item->alias;
       else
         name = item->name;
 
-      if( item->type == NULL )
+      if (item->type == NULL)
         eType = OFTString;
-      else if( EQUAL(item->type,"Integer") )
+      else if (EQUAL(item->type, "Integer"))
         eType = OFTInteger;
-      else if( EQUAL(item->type,"Long") )
+      else if (EQUAL(item->type, "Long"))
         eType = OFTInteger64;
-      else if( EQUAL(item->type,"Real") )
+      else if (EQUAL(item->type, "Real"))
         eType = OFTReal;
-      else if( EQUAL(item->type,"Character") )
+      else if (EQUAL(item->type, "Character"))
         eType = OFTString;
-      else if( EQUAL(item->type,"Date") )
+      else if (EQUAL(item->type, "Date"))
         eType = OFTDate;
-      else if( EQUAL(item->type,"Time") )
+      else if (EQUAL(item->type, "Time"))
         eType = OFTTime;
-      else if( EQUAL(item->type,"DateTime") )
+      else if (EQUAL(item->type, "DateTime"))
         eType = OFTDateTime;
-      else if( EQUAL(item->type,"Boolean") )
+      else if (EQUAL(item->type, "Boolean"))
         eType = OFTInteger;
       else
         eType = OFTString;
 
-      hFldDefn = OGR_Fld_Create( name, eType );
+      hFldDefn = OGR_Fld_Create(name, eType);
 
-      if( item->width != 0 )
-        OGR_Fld_SetWidth( hFldDefn, item->width );
-      if( item->precision != 0 )
-        OGR_Fld_SetPrecision( hFldDefn, item->precision );
-
-      eErr = OGR_L_CreateField( hOGRLayer, hFldDefn, TRUE );
-      OGR_Fld_Destroy( hFldDefn );
-
-      if( eErr != OGRERR_NONE ) {
-        msSetError( MS_OGRERR,
-                    "Failed to create field '%s' in output feature schema:\n%s",
-                    "msOGRWriteFromQuery()",
-                    layer->items[i],
-                    CPLGetLastErrorMsg() );
+      if (item->width != 0)
+        OGR_Fld_SetWidth(hFldDefn, item->width);
+      if (item->precision != 0)
+        OGR_Fld_SetPrecision(hFldDefn, item->precision);
+
+      eErr = OGR_L_CreateField(hOGRLayer, hFldDefn, TRUE);
+      OGR_Fld_Destroy(hFldDefn);
+
+      if (eErr != OGRERR_NONE) {
+        msSetError(MS_OGRERR,
+                   "Failed to create field '%s' in output feature schema:\n%s",
+                   "msOGRWriteFromQuery()", layer->items[i],
+                   CPLGetLastErrorMsg());
 
-        OGR_DS_Destroy( hDS );
-        msOGRCleanupDS( datasource_name );
+        OGR_DS_Destroy(hDS);
+        msOGRCleanupDS(datasource_name);
         msGMLFreeItems(item_list);
         CSLDestroy(layer_options);
         return MS_FAILURE;
       }
 
       /* The index of the first field we create is not necessarily 0 */
-      if( nFirstOGRFieldIndex < 0 )
-          nFirstOGRFieldIndex = OGR_FD_GetFieldCount(
-                                        OGR_L_GetLayerDefn( hOGRLayer ) ) - 1;
+      if (nFirstOGRFieldIndex < 0)
+        nFirstOGRFieldIndex =
+            OGR_FD_GetFieldCount(OGR_L_GetLayerDefn(hOGRLayer)) - 1;
     }
 
     /* -------------------------------------------------------------------- */
     /*      Setup joins if needed.  This is likely untested.                */
     /* -------------------------------------------------------------------- */
-    if(layer->numjoins > 0) {
+    if (layer->numjoins > 0) {
       int j;
-      for(j=0; j<layer->numjoins; j++) {
+      for (j = 0; j < layer->numjoins; j++) {
         status = msJoinConnect(layer, &(layer->joins[j]));
-        if(status != MS_SUCCESS) {
-          OGR_DS_Destroy( hDS );
-          msOGRCleanupDS( datasource_name );
+        if (status != MS_SUCCESS) {
+          OGR_DS_Destroy(hDS);
+          msOGRCleanupDS(datasource_name);
           msGMLFreeItems(item_list);
           CSLDestroy(layer_options);
           return status;
@@ -1076,89 +1007,88 @@ int msOGRWriteFromQuery( mapObj *map, ou
       }
     }
 
-    msInitShape( &resultshape );
+    msInitShape(&resultshape);
 
     /* -------------------------------------------------------------------- */
     /*      Loop over all the shapes in the resultcache.                    */
     /* -------------------------------------------------------------------- */
-    for(i=0; i < layer->resultcache->numresults; i++) {
+    for (i = 0; i < layer->resultcache->numresults; i++) {
 
       msFreeShape(&resultshape); /* init too */
 
       /*
       ** Read the shape.
       */
-      if( layer->resultcache->results[i].shape )
-      {
-          /* msDebug("Using cached shape %ld\n", layer->resultcache->results[i].shapeindex); */
-          status = msCopyShape(layer->resultcache->results[i].shape, &resultshape);
+      if (layer->resultcache->results[i].shape) {
+        /* msDebug("Using cached shape %ld\n",
+         * layer->resultcache->results[i].shapeindex); */
+        status =
+            msCopyShape(layer->resultcache->results[i].shape, &resultshape);
+      } else {
+        status = msLayerGetShape(layer, &resultshape,
+                                 &(layer->resultcache->results[i]));
       }
-      else
-      {
-          status = msLayerGetShape(layer, &resultshape, &(layer->resultcache->results[i]));
+
+      if (status != MS_SUCCESS) {
+        OGR_DS_Destroy(hDS);
+        msOGRCleanupDS(datasource_name);
+        msGMLFreeItems(item_list);
+        msFreeShape(&resultshape);
+        CSLDestroy(layer_options);
+        return status;
       }
-      
-      if(status != MS_SUCCESS) {
-          OGR_DS_Destroy( hDS );
-          msOGRCleanupDS( datasource_name );
-          msGMLFreeItems(item_list);
-          msFreeShape(&resultshape);
-          CSLDestroy(layer_options);
-          return status;
-      }      
 
       /*
       ** Perform classification, and some annotation related magic.
       */
       resultshape.classindex =
-        msShapeGetClass(layer, map, &resultshape, NULL, -1);
+          msShapeGetClass(layer, map, &resultshape, NULL, -1);
 
-      if( resultshape.classindex >= 0
-          && (layer->_class[resultshape.classindex]->text.string
-              || layer->labelitem)
-          && layer->_class[resultshape.classindex]->numlabels > 0
-          && layer->_class[resultshape.classindex]->labels[0]->size != -1 ) {
-        resultshape.text = msShapeGetLabelAnnotation(layer,&resultshape,layer->_class[resultshape.classindex]->labels[0]);
+      if (resultshape.classindex >= 0 &&
+          (layer->_class[resultshape.classindex]->text.string ||
+           layer->labelitem) &&
+          layer->_class[resultshape.classindex]->numlabels > 0 &&
+          layer->_class[resultshape.classindex]->labels[0]->size != -1) {
+        resultshape.text = msShapeGetLabelAnnotation(
+            layer, &resultshape,
+            layer->_class[resultshape.classindex]->labels[0]);
       }
 
       /*
       ** prepare any necessary JOINs here (one-to-one only)
       */
-      if( layer->numjoins > 0) {
+      if (layer->numjoins > 0) {
         int j;
 
-        for(j=0; j < layer->numjoins; j++) {
-          if(layer->joins[j].type == MS_JOIN_ONE_TO_ONE) {
+        for (j = 0; j < layer->numjoins; j++) {
+          if (layer->joins[j].type == MS_JOIN_ONE_TO_ONE) {
             msJoinPrepare(&(layer->joins[j]), &resultshape);
             msJoinNext(&(layer->joins[j])); /* fetch the first row */
           }
         }
       }
 
-      if( layer->project && resultshape.type != MS_SHAPE_NULL) {
-        if( layer->reprojectorLayerToMap == NULL )
-        {
-            layer->reprojectorLayerToMap = msProjectCreateReprojector(
-                &layer->projection, &layer->map->projection);
-        }
-        if( layer->reprojectorLayerToMap )
-            status = msProjectShapeEx(layer->reprojectorLayerToMap, &resultshape);
+      if (layer->project && resultshape.type != MS_SHAPE_NULL) {
+        reprojectionObj *reprojector =
+            msLayerGetReprojectorToMap(layer, layer->map);
+        if (reprojector)
+          status = msProjectShapeEx(reprojector, &resultshape);
         else
-            status = MS_FAILURE;
+          status = MS_FAILURE;
       }
 
       /*
       ** Write out the feature to OGR.
       */
 
-      if( status == MS_SUCCESS )
-        status = msOGRWriteShape( hOGRLayer, &resultshape,
-                                  item_list, nFirstOGRFieldIndex, pszFeatureid,
-                                  geomTypeForced );
-
-      if(status != MS_SUCCESS) {
-        OGR_DS_Destroy( hDS );
-        msOGRCleanupDS( datasource_name );
+      if (status == MS_SUCCESS)
+        status =
+            msOGRWriteShape(hOGRLayer, &resultshape, item_list,
+                            nFirstOGRFieldIndex, pszFeatureid, geomTypeForced);
+
+      if (status != MS_SUCCESS) {
+        OGR_DS_Destroy(hDS);
+        msOGRCleanupDS(datasource_name);
         msGMLFreeItems(item_list);
         msFreeShape(&resultshape);
         CSLDestroy(layer_options);
@@ -1173,25 +1103,24 @@ int msOGRWriteFromQuery( mapObj *map, ou
   /* -------------------------------------------------------------------- */
   /*      Close the datasource.                                           */
   /* -------------------------------------------------------------------- */
-  OGR_DS_Destroy( hDS );
+  OGR_DS_Destroy(hDS);
 
-  CSLDestroy( layer_options );
+  CSLDestroy(layer_options);
 
   /* -------------------------------------------------------------------- */
   /*      Get list of resulting files.                                    */
   /* -------------------------------------------------------------------- */
 
-  if( EQUAL(form,"simple") ) {
-    file_list = CSLAddString( NULL, datasource_name );
+  if (EQUAL(form, "simple")) {
+    file_list = CSLAddString(NULL, datasource_name);
   } else {
     char datasource_path[MS_MAXPATHLEN];
 
-    if( bDataSourceNameIsRequestDir )
-        file_list = msOGRRecursiveFileList( datasource_name );
-    else
-    {
-        strncpy( datasource_path, CPLGetPath( datasource_name ), MS_MAXPATHLEN-1 );
-        file_list = msOGRRecursiveFileList( datasource_path );
+    if (bDataSourceNameIsRequestDir)
+      file_list = msOGRRecursiveFileList(datasource_name);
+    else {
+      strncpy(datasource_path, CPLGetPath(datasource_name), MS_MAXPATHLEN - 1);
+      file_list = msOGRRecursiveFileList(datasource_path);
     }
   }
 
@@ -1199,179 +1128,173 @@ int msOGRWriteFromQuery( mapObj *map, ou
   /*      If our "storage" is stream then the output has already been     */
   /*      sent back to the client and we don't need to copy it now.       */
   /* -------------------------------------------------------------------- */
-  if( EQUAL(storage,"stream") ) {
+  if (EQUAL(storage, "stream")) {
     /* already done */
   }
 
   /* -------------------------------------------------------------------- */
   /*      Handle case of simple file written to stdout.                   */
   /* -------------------------------------------------------------------- */
-  else if( EQUAL(form,"simple") ) {
+  else if (EQUAL(form, "simple")) {
     char buffer[1024];
-    int  bytes_read;
+    int bytes_read;
     VSILFILE *fp;
     const char *jsonp;
 
-    jsonp = msGetOutputFormatOption( format, "JSONP", NULL );
-    if( sendheaders ) {
-      if( !jsonp )
-      msIO_setHeader("Content-Disposition","attachment; filename=%s",
-                     CPLGetFilename( file_list[0] ) );
-      if( format->mimetype )
-        msIO_setHeader("Content-Type","%s",format->mimetype);
+    jsonp = msGetOutputFormatOption(format, "JSONP", NULL);
+    if (sendheaders) {
+      if (!jsonp)
+        msIO_setHeader("Content-Disposition", "attachment; filename=%s",
+                       CPLGetFilename(file_list[0]));
+      if (format->mimetype)
+        msIO_setHeader("Content-Type", "%s", format->mimetype);
       msIO_sendHeaders();
     } else
-      msIO_fprintf( stdout, "%c", 10 );
+      msIO_fprintf(stdout, "%c", 10);
 
-    fp = VSIFOpenL( file_list[0], "r" );
-    if( fp == NULL ) {
-      msSetError( MS_MISCERR,
-                  "Failed to open result file '%s'.",
-                  "msOGRWriteFromQuery()",
-                  file_list[0] );
-      msOGRCleanupDS( datasource_name );
+    fp = VSIFOpenL(file_list[0], "r");
+    if (fp == NULL) {
+      msSetError(MS_MISCERR, "Failed to open result file '%s'.",
+                 "msOGRWriteFromQuery()", file_list[0]);
+      msOGRCleanupDS(datasource_name);
       return MS_FAILURE;
     }
 
-    if( jsonp != NULL ) msIO_fprintf( stdout, "%s(", jsonp );
+    if (jsonp != NULL)
+      msIO_fprintf(stdout, "%s(", jsonp);
 
-    while( (bytes_read = VSIFReadL( buffer, 1, sizeof(buffer), fp )) > 0 )
-      msIO_fwrite( buffer, 1, bytes_read, stdout );
-    VSIFCloseL( fp );
+    while ((bytes_read = VSIFReadL(buffer, 1, sizeof(buffer), fp)) > 0)
+      msIO_fwrite(buffer, 1, bytes_read, stdout);
+    VSIFCloseL(fp);
 
-    if (jsonp != NULL) msIO_fprintf( stdout, ");\n" );
+    if (jsonp != NULL)
+      msIO_fprintf(stdout, ");\n");
   }
 
   /* -------------------------------------------------------------------- */
   /*      Handle the case of a multi-part result.                         */
   /* -------------------------------------------------------------------- */
-  else if( EQUAL(form,"multipart") ) {
+  else if (EQUAL(form, "multipart")) {
     char **papszAdditionalFiles;
     static const char *boundary = "xxOGRBoundaryxx";
-    msIO_setHeader("Content-Type","multipart/mixed; boundary=%s",boundary);
+    msIO_setHeader("Content-Type", "multipart/mixed; boundary=%s", boundary);
     msIO_sendHeaders();
-    msIO_fprintf(stdout,"--%s\r\n",boundary );
+    msIO_fprintf(stdout, "--%s\r\n", boundary);
 
     papszAdditionalFiles = msOGROutputGetAdditonalFiles(map);
     file_list = msCSLConcatenate(file_list, papszAdditionalFiles);
     CSLDestroy(papszAdditionalFiles);
 
-    for( i = 0; file_list != NULL && file_list[i] != NULL; i++ ) {
+    for (i = 0; file_list != NULL && file_list[i] != NULL; i++) {
       VSILFILE *fp;
       int bytes_read;
       char buffer[1024];
 
-      if( sendheaders )
-        msIO_fprintf( stdout,
-                      "Content-Disposition: attachment; filename=%s\r\n"
-                      "Content-Type: application/binary\r\n"
-                      "Content-Transfer-Encoding: binary\r\n\r\n",
-                      CPLGetFilename( file_list[i] ));
-
-
-      fp = VSIFOpenL( file_list[i], "r" );
-      if( fp == NULL ) {
-        msSetError( MS_MISCERR,
-                    "Failed to open result file '%s'.",
-                    "msOGRWriteFromQuery()",
-                    file_list[0] );
-        msOGRCleanupDS( datasource_name );
+      if (sendheaders)
+        msIO_fprintf(stdout,
+                     "Content-Disposition: attachment; filename=%s\r\n"
+                     "Content-Type: application/binary\r\n"
+                     "Content-Transfer-Encoding: binary\r\n\r\n",
+                     CPLGetFilename(file_list[i]));
+
+      fp = VSIFOpenL(file_list[i], "r");
+      if (fp == NULL) {
+        msSetError(MS_MISCERR, "Failed to open result file '%s'.",
+                   "msOGRWriteFromQuery()", file_list[0]);
+        msOGRCleanupDS(datasource_name);
         return MS_FAILURE;
       }
 
-      while( (bytes_read = VSIFReadL( buffer, 1, sizeof(buffer), fp )) > 0 )
-        msIO_fwrite( buffer, 1, bytes_read, stdout );
-      VSIFCloseL( fp );
+      while ((bytes_read = VSIFReadL(buffer, 1, sizeof(buffer), fp)) > 0)
+        msIO_fwrite(buffer, 1, bytes_read, stdout);
+      VSIFCloseL(fp);
 
-      if (file_list[i+1] == NULL)
-        msIO_fprintf( stdout, "\r\n--%s--\r\n", boundary );
+      if (file_list[i + 1] == NULL)
+        msIO_fprintf(stdout, "\r\n--%s--\r\n", boundary);
       else
-        msIO_fprintf( stdout, "\r\n--%s\r\n", boundary );
+        msIO_fprintf(stdout, "\r\n--%s\r\n", boundary);
     }
   }
 
   /* -------------------------------------------------------------------- */
   /*      Handle the case of a zip file result.                           */
   /* -------------------------------------------------------------------- */
-  else if( EQUAL(form,"zip") ) {
+  else if (EQUAL(form, "zip")) {
     VSILFILE *fp;
-    char *zip_filename = msTmpFile(map, NULL, "/vsimem/ogrzip/", "zip" );
+    char *zip_filename = msTmpFile(map, NULL, "/vsimem/ogrzip/", "zip");
     void *hZip;
     int bytes_read;
     char buffer[1024];
     char **papszAdditionalFiles;
 
-    hZip = CPLCreateZip( zip_filename, NULL );
+    hZip = CPLCreateZip(zip_filename, NULL);
 
     papszAdditionalFiles = msOGROutputGetAdditonalFiles(map);
     file_list = msCSLConcatenate(file_list, papszAdditionalFiles);
     CSLDestroy(papszAdditionalFiles);
 
-    for( i = 0; file_list != NULL && file_list[i] != NULL; i++ ) {
+    for (i = 0; file_list != NULL && file_list[i] != NULL; i++) {
 
-      CPLCreateFileInZip( hZip, CPLGetFilename(file_list[i]), NULL );
+      CPLCreateFileInZip(hZip, CPLGetFilename(file_list[i]), NULL);
 
-      fp = VSIFOpenL( file_list[i], "r" );
-      if( fp == NULL ) {
-        CPLCloseZip( hZip );
-        msSetError( MS_MISCERR,
-                    "Failed to open result file '%s'.",
-                    "msOGRWriteFromQuery()",
-                    file_list[0] );
-        msOGRCleanupDS( datasource_name );
+      fp = VSIFOpenL(file_list[i], "r");
+      if (fp == NULL) {
+        CPLCloseZip(hZip);
+        msSetError(MS_MISCERR, "Failed to open result file '%s'.",
+                   "msOGRWriteFromQuery()", file_list[0]);
+        msOGRCleanupDS(datasource_name);
         return MS_FAILURE;
       }
 
-      while( (bytes_read = VSIFReadL( buffer, 1, sizeof(buffer), fp )) > 0 ) {
-        CPLWriteFileInZip( hZip, buffer, bytes_read );
+      while ((bytes_read = VSIFReadL(buffer, 1, sizeof(buffer), fp)) > 0) {
+        CPLWriteFileInZip(hZip, buffer, bytes_read);
       }
-      VSIFCloseL( fp );
+      VSIFCloseL(fp);
 
-      CPLCloseFileInZip( hZip );
+      CPLCloseFileInZip(hZip);
     }
-    CPLCloseZip( hZip );
+    CPLCloseZip(hZip);
 
-    if( sendheaders ) {
-      const char* zip_filename = fo_filename;
+    if (sendheaders) {
+      const char *zip_filename = fo_filename;
       /* Make sure the filename is ended by .zip */
-      if( !EQUAL(CPLGetExtension(zip_filename), "zip") &&
-          !EQUAL(CPLGetExtension(zip_filename), "kmz") )
-          zip_filename = CPLFormFilename(NULL, fo_filename, "zip");
-      msIO_setHeader("Content-Disposition","attachment; filename=%s",zip_filename);
-      msIO_setHeader("Content-Type","application/zip");
+      if (!EQUAL(CPLGetExtension(zip_filename), "zip") &&
+          !EQUAL(CPLGetExtension(zip_filename), "kmz"))
+        zip_filename = CPLFormFilename(NULL, fo_filename, "zip");
+      msIO_setHeader("Content-Disposition", "attachment; filename=%s",
+                     zip_filename);
+      msIO_setHeader("Content-Type", "application/zip");
       msIO_sendHeaders();
     }
 
-    fp = VSIFOpenL( zip_filename, "r" );
-    if( fp == NULL ) {
-      msSetError( MS_MISCERR,
-                  "Failed to open zip file '%s'.",
-                  "msOGRWriteFromQuery()",
-                  file_list[0] );
-      msOGRCleanupDS( datasource_name );
+    fp = VSIFOpenL(zip_filename, "r");
+    if (fp == NULL) {
+      msSetError(MS_MISCERR, "Failed to open zip file '%s'.",
+                 "msOGRWriteFromQuery()", file_list[0]);
+      msOGRCleanupDS(datasource_name);
       return MS_FAILURE;
     }
 
-    while( (bytes_read = VSIFReadL( buffer, 1, sizeof(buffer), fp )) > 0 )
-      msIO_fwrite( buffer, 1, bytes_read, stdout );
-    VSIFCloseL( fp );
+    while ((bytes_read = VSIFReadL(buffer, 1, sizeof(buffer), fp)) > 0)
+      msIO_fwrite(buffer, 1, bytes_read, stdout);
+    VSIFCloseL(fp);
 
-    msFree( zip_filename );
+    msFree(zip_filename);
   }
 
   /* -------------------------------------------------------------------- */
   /*      Handle illegal form value.                                      */
   /* -------------------------------------------------------------------- */
   else {
-    msSetError( MS_MISCERR, "Unsupported FORM=%s value.",
-                "msOGRWriteFromQuery()", form );
-    msOGRCleanupDS( datasource_name );
+    msSetError(MS_MISCERR, "Unsupported FORM=%s value.",
+               "msOGRWriteFromQuery()", form);
+    msOGRCleanupDS(datasource_name);
     return MS_FAILURE;
   }
 
-  msOGRCleanupDS( datasource_name );
+  msOGRCleanupDS(datasource_name);
 
-  CSLDestroy( file_list );
+  CSLDestroy(file_list);
 
   return MS_SUCCESS;
 }
@@ -1380,8 +1303,7 @@ int msOGRWriteFromQuery( mapObj *map, ou
 /*                     msPopulateRenderVTableOGR()                      */
 /************************************************************************/
 
-int msPopulateRendererVTableOGR( rendererVTableObj *renderer )
-{
+int msPopulateRendererVTableOGR(rendererVTableObj *renderer) {
   (void)renderer;
   /* we aren't really a normal renderer so we leave everything default */
   return MS_SUCCESS;
diff -pruN 8.0.1-5/maporaclespatial.c 8.0.2-1/maporaclespatial.c
--- 8.0.1-5/maporaclespatial.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/maporaclespatial.c	2024-06-11 20:41:34.000000000 +0000
@@ -41,40 +41,36 @@
 #include "mapows.h"
 #include <assert.h>
 
-
-
 #if defined(USE_ORACLESPATIAL) || defined(USE_ORACLE_PLUGIN)
 
 #include <oci.h>
 #include <ctype.h>
 
-#define ARRAY_SIZE                 1024
-#define QUERY_SIZE                 1
-#define TEXT_SIZE                  4000 /* ticket #2260 */
-#define TYPE_OWNER                 "MDSYS"
-#define SDO_GEOMETRY               TYPE_OWNER".SDO_GEOMETRY"
-#define SDO_ORDINATE_ARRAY         TYPE_OWNER".SDO_ORDINATE_ARRAY"
-#define SDO_GEOMETRY_LEN           strlen( SDO_GEOMETRY )
-#define FUNCTION_FILTER            1
-#define FUNCTION_RELATE            2
-#define FUNCTION_GEOMRELATE        3
-#define FUNCTION_NONE              4
-#define VERSION_8i                 1
-#define VERSION_9i                 2
-#define VERSION_10g                3
-#define TOLERANCE                  0.001
-#define NULLERRCODE                1405
-#define TABLE_NAME_SIZE            2000
+#define ARRAY_SIZE 1024
+#define QUERY_SIZE 1
+#define TEXT_SIZE 4000 /* ticket #2260 */
+#define TYPE_OWNER "MDSYS"
+#define SDO_GEOMETRY TYPE_OWNER ".SDO_GEOMETRY"
+#define SDO_ORDINATE_ARRAY TYPE_OWNER ".SDO_ORDINATE_ARRAY"
+#define SDO_GEOMETRY_LEN strlen(SDO_GEOMETRY)
+#define FUNCTION_FILTER 1
+#define FUNCTION_RELATE 2
+#define FUNCTION_GEOMRELATE 3
+#define FUNCTION_NONE 4
+#define VERSION_8i 1
+#define VERSION_9i 2
+#define VERSION_10g 3
+#define TOLERANCE 0.001
+#define NULLERRCODE 1405
+#define TABLE_NAME_SIZE 2000
 
-typedef
-struct {
+typedef struct {
   OCINumber x;
   OCINumber y;
   OCINumber z;
 } SDOPointObj;
 
-typedef
-struct {
+typedef struct {
   OCINumber gtype;
   OCINumber srid;
   SDOPointObj point;
@@ -82,16 +78,14 @@ struct {
   OCIArray *ordinates;
 } SDOGeometryObj;
 
-typedef
-struct {
+typedef struct {
   OCIInd _atomic;
   OCIInd x;
   OCIInd y;
   OCIInd z;
 } SDOPointInd;
 
-typedef
-struct {
+typedef struct {
   OCIInd _atomic;
   OCIInd gtype;
   OCIInd srid;
@@ -100,59 +94,52 @@ struct {
   OCIInd ordinates;
 } SDOGeometryInd;
 
-typedef
-text item_text[TEXT_SIZE];
+typedef text item_text[TEXT_SIZE];
 
-typedef
-item_text item_text_array[ARRAY_SIZE];
+typedef item_text item_text_array[ARRAY_SIZE];
 
-typedef
-item_text item_text_array_query[QUERY_SIZE];
+typedef item_text item_text_array_query[QUERY_SIZE];
 
-typedef
-ub2 query_dtype[ARRAY_SIZE];
+typedef ub2 query_dtype[ARRAY_SIZE];
 
-typedef
-struct {
+typedef struct {
   /*Oracle handlers (global to connection)*/
   OCIEnv *envhp;
   OCIError *errhp;
   OCISvcCtx *svchp;
   int last_oci_status;
   text last_oci_error[2048];
-  /* This references counter is to avoid the cache freed if there are other layers that could use it */
+  /* This references counter is to avoid the cache freed if there are other
+   * layers that could use it */
   int ref_count;
 } msOracleSpatialHandler;
 
-typedef
-struct {
+typedef struct {
   /* Oracle data handlers (global to connection) */
   OCIDescribe *dschp;
   OCIType *tdo;
 } msOracleSpatialDataHandler;
 
-typedef
-struct {
+typedef struct {
   OCIStmt *stmthp;
 
   /* fetch data buffer */
-  ub4 rows_count; /* total number of rows (so far) within cursor */
-  ub4 row_num; /* current row index within cursor results */
+  ub4 rows_count;   /* total number of rows (so far) within cursor */
+  ub4 row_num;      /* current row index within cursor results */
   ub4 rows_fetched; /* total number of rows fetched into our buffer */
-  ub4 row; /* current row index within our buffer */
+  ub4 row;          /* current row index within our buffer */
 
-  item_text_array *items; /* items buffer */
+  item_text_array *items;             /* items buffer */
   item_text_array_query *items_query; /* items buffer */
-  SDOGeometryObj *obj[ARRAY_SIZE]; /* spatial object buffer */
-  SDOGeometryInd *ind[ARRAY_SIZE]; /* object indicator (null) buffer */
-
-  int uniqueidindex; /*allows to keep which attribute id index is used as unique id*/
+  SDOGeometryObj *obj[ARRAY_SIZE];    /* spatial object buffer */
+  SDOGeometryInd *ind[ARRAY_SIZE];    /* object indicator (null) buffer */
 
+  int uniqueidindex; /*allows to keep which attribute id index is used as unique
+                        id*/
 
 } msOracleSpatialStatement;
 
-typedef
-struct {
+typedef struct {
   /* oracle handlers */
   msOracleSpatialHandler *orahandlers;
 
@@ -170,90 +157,123 @@ struct {
 
 } msOracleSpatialLayerInfo;
 
-static OCIType  *ordinates_tdo = NULL;
+static OCIType *ordinates_tdo = NULL;
 static OCIArray *ordinates;
 
-
-
-
-
 /* local prototypes */
-static int TRY( msOracleSpatialHandler *hand, sword status );
-static int ERROR( char *routine, msOracleSpatialHandler *hand, msOracleSpatialDataHandler *dthand );
-static void msSplitLogin( char *connection, mapObj *map, char **username, char **password, char **dblink );
-static int msSplitData( char *data, char **geometry_column_name, char **table_name, char **unique, char **srid, char **indexfield, int *function, int * version);
-static void msOCICloseConnection( void *layerinfo );
-static msOracleSpatialHandler *msOCISetHandlers( char *username, char *password, char *dblink );
-static int msOCISetDataHandlers( msOracleSpatialHandler *hand, msOracleSpatialDataHandler *dthand );
-static void msOCICloseDataHandlers ( msOracleSpatialDataHandler *dthand );
-static void msOCICloseHandlers( msOracleSpatialHandler *hand );
-static void msOCIClearLayerInfo( msOracleSpatialLayerInfo *layerinfo );
-static int msOCIOpenStatement( msOracleSpatialHandler *hand, msOracleSpatialStatement *sthand );
-static void msOCIFinishStatement( msOracleSpatialStatement *sthand );
-static int msOCIGet2DOrdinates( msOracleSpatialHandler *hand, SDOGeometryObj *obj, int s, int e, pointObj *pt );
-static int msOCIGet3DOrdinates( msOracleSpatialHandler *hand, SDOGeometryObj *obj, int s, int e, pointObj *pt );
-static int msOCIGet4DOrdinates( msOracleSpatialHandler *hand, SDOGeometryObj *obj, int s, int e, pointObj *pt );
-static int msOCIConvertCircle( pointObj *pt );
-static char * osFilteritem(layerObj *layer, int function, char *query_str, int mode);
-static char * osAggrGetExtent(layerObj *layer, char *query_str, char *geom_column_name, char *table_name);
-static char * osGeodeticData(int function, char *query_str, char *geom_column_name, char *index_column_name);
-static char * osNoGeodeticData(int function, int version, char *query_str, char *geom_column_name, char *index_column_name);
+static int TRY(msOracleSpatialHandler *hand, sword status);
+static int ERROR(char *routine, msOracleSpatialHandler *hand,
+                 msOracleSpatialDataHandler *dthand);
+static void msSplitLogin(char *connection, mapObj *map, char **username,
+                         char **password, char **dblink);
+static int msSplitData(char *data, char **geometry_column_name,
+                       char **table_name, char **unique, char **srid,
+                       char **indexfield, int *function, int *version);
+static void msOCICloseConnection(void *layerinfo);
+static msOracleSpatialHandler *msOCISetHandlers(char *username, char *password,
+                                                char *dblink);
+static int msOCISetDataHandlers(msOracleSpatialHandler *hand,
+                                msOracleSpatialDataHandler *dthand);
+static void msOCICloseDataHandlers(msOracleSpatialDataHandler *dthand);
+static void msOCICloseHandlers(msOracleSpatialHandler *hand);
+static void msOCIClearLayerInfo(msOracleSpatialLayerInfo *layerinfo);
+static int msOCIOpenStatement(msOracleSpatialHandler *hand,
+                              msOracleSpatialStatement *sthand);
+static void msOCIFinishStatement(msOracleSpatialStatement *sthand);
+static int msOCIGet2DOrdinates(msOracleSpatialHandler *hand,
+                               SDOGeometryObj *obj, int s, int e, pointObj *pt);
+static int msOCIGet3DOrdinates(msOracleSpatialHandler *hand,
+                               SDOGeometryObj *obj, int s, int e, pointObj *pt);
+static int msOCIGet4DOrdinates(msOracleSpatialHandler *hand,
+                               SDOGeometryObj *obj, int s, int e, pointObj *pt);
+static int msOCIConvertCircle(pointObj *pt);
+static char *osFilteritem(layerObj *layer, int function, char *query_str,
+                          int mode);
+static char *osAggrGetExtent(layerObj *layer, char *query_str,
+                             char *geom_column_name, char *table_name);
+static char *osGeodeticData(int function, char *query_str,
+                            char *geom_column_name, char *index_column_name);
+static char *osNoGeodeticData(int function, int version, char *query_str,
+                              char *geom_column_name, char *index_column_name);
 static double osCalculateArcRadius(pointObj *pnt);
-static void osCalculateArc(pointObj *pnt, int data3d, int data4d, double radius, double npoints, int side, lineObj arcline, shapeObj *shape);
-static void osGenerateArc(shapeObj *shape, lineObj arcline, lineObj points, int i, int data3d, int data4d);
-static void osShapeBounds ( shapeObj *shp );
-static void osCloneShape(shapeObj *shape, shapeObj *newshape, int data3d, int data4d);
-static void osPointCluster(msOracleSpatialHandler *hand, shapeObj *shape, SDOGeometryObj *obj, int start, int end, lineObj points, int interpretation, int data3d, int data4d);
-static void osPoint(msOracleSpatialHandler *hand, shapeObj *shape, SDOGeometryObj *obj, int start, int end, lineObj points, pointObj *pnt, int data3d, int data4d);
-static void osClosedPolygon(msOracleSpatialHandler *hand, shapeObj *shape, SDOGeometryObj *obj, int start, int end, lineObj points, int elem_type, int data3d, int data4d);
-static void osRectangle(msOracleSpatialHandler *hand, shapeObj *shape, SDOGeometryObj *obj, int start, int end, lineObj points, pointObj *pnt, int data3d, int data4d);
-static void osCircle(msOracleSpatialHandler *hand, shapeObj *shape, SDOGeometryObj *obj, int start, int end, lineObj points, pointObj *pnt, int data3d, int data4d);
-static void osArcPolygon(msOracleSpatialHandler *hand, shapeObj *shape, SDOGeometryObj *obj, int start, int end, lineObj arcpoints,int elem_type,int data3d, int data4d);
-static int osGetOrdinates(msOracleSpatialDataHandler *dthand, msOracleSpatialHandler *hand, shapeObj *shape, SDOGeometryObj *obj, SDOGeometryInd *ind);
+static void osCalculateArc(pointObj *pnt, int data3d, int data4d, double radius,
+                           double npoints, int side, lineObj arcline,
+                           shapeObj *shape);
+static void osGenerateArc(shapeObj *shape, lineObj arcline, lineObj points,
+                          int i, int data3d, int data4d);
+static void osShapeBounds(shapeObj *shp);
+static void osCloneShape(shapeObj *shape, shapeObj *newshape, int data3d,
+                         int data4d);
+static void osPointCluster(msOracleSpatialHandler *hand, shapeObj *shape,
+                           SDOGeometryObj *obj, int start, int end,
+                           lineObj points, int interpretation, int data3d,
+                           int data4d);
+static void osPoint(msOracleSpatialHandler *hand, shapeObj *shape,
+                    SDOGeometryObj *obj, int start, int end, lineObj points,
+                    pointObj *pnt, int data3d, int data4d);
+static void osClosedPolygon(msOracleSpatialHandler *hand, shapeObj *shape,
+                            SDOGeometryObj *obj, int start, int end,
+                            lineObj points, int elem_type, int data3d,
+                            int data4d);
+static void osRectangle(msOracleSpatialHandler *hand, shapeObj *shape,
+                        SDOGeometryObj *obj, int start, int end, lineObj points,
+                        pointObj *pnt, int data3d, int data4d);
+static void osCircle(msOracleSpatialHandler *hand, shapeObj *shape,
+                     SDOGeometryObj *obj, int start, int end, lineObj points,
+                     pointObj *pnt, int data3d, int data4d);
+static void osArcPolygon(msOracleSpatialHandler *hand, shapeObj *shape,
+                         SDOGeometryObj *obj, int start, int end,
+                         lineObj arcpoints, int elem_type, int data3d,
+                         int data4d);
+static int osGetOrdinates(msOracleSpatialDataHandler *dthand,
+                          msOracleSpatialHandler *hand, shapeObj *shape,
+                          SDOGeometryObj *obj, SDOGeometryInd *ind);
 static int osCheck2DGtype(int pIntGtype);
 static int osCheck3DGtype(int pIntGtype);
 static int osCheck4DGtype(int pIntGtype);
 
-
-
 /******************************************************************************
  *                          Local Helper Functions                            *
  ******************************************************************************/
 
-
-/* if an error ocurred call msSetError, sets last_oci_status to MS_FAILURE and return 0;
- * otherwise returns 1 */
-static int TRY( msOracleSpatialHandler *hand, sword status )
-{
+/* if an error ocurred call msSetError, sets last_oci_status to MS_FAILURE and
+ * return 0; otherwise returns 1 */
+static int TRY(msOracleSpatialHandler *hand, sword status) {
   sb4 errcode = 0;
 
   if (hand->last_oci_status == MS_FAILURE)
     return 0; /* error from previous call */
 
   switch (status) {
-    case OCI_SUCCESS_WITH_INFO:
-    case OCI_ERROR:
-      OCIErrorGet((dvoid *)hand->errhp, (ub4)1, (text *)NULL, &errcode, hand->last_oci_error, (ub4)sizeof(hand->last_oci_error), OCI_HTYPE_ERROR );
-      if (errcode == NULLERRCODE) {
-        hand->last_oci_error[0] = (text)'\0';
-        return 1;
-      }
-      hand->last_oci_error[sizeof(hand->last_oci_error)-1] = 0; /* terminate string!? */
-      break;
-    case OCI_NEED_DATA:
-      strlcpy( (char *)hand->last_oci_error, "OCI_NEED_DATA", sizeof(hand->last_oci_error));
-      break;
-    case OCI_INVALID_HANDLE:
-      strlcpy( (char *)hand->last_oci_error, "OCI_INVALID_HANDLE", sizeof(hand->last_oci_error));
-      break;
-    case OCI_STILL_EXECUTING:
-      ((char*)hand->last_oci_error)[sizeof(hand->last_oci_error)-1] = 0;
-      break;
-    case OCI_CONTINUE:
-      strlcpy( (char *)hand->last_oci_error, "OCI_CONTINUE", sizeof(hand->last_oci_error));
-      break;
-    default:
-      return 1; /* no error */
+  case OCI_SUCCESS_WITH_INFO:
+  case OCI_ERROR:
+    OCIErrorGet((dvoid *)hand->errhp, (ub4)1, (text *)NULL, &errcode,
+                hand->last_oci_error, (ub4)sizeof(hand->last_oci_error),
+                OCI_HTYPE_ERROR);
+    if (errcode == NULLERRCODE) {
+      hand->last_oci_error[0] = (text)'\0';
+      return 1;
+    }
+    hand->last_oci_error[sizeof(hand->last_oci_error) - 1] =
+        0; /* terminate string!? */
+    break;
+  case OCI_NEED_DATA:
+    strlcpy((char *)hand->last_oci_error, "OCI_NEED_DATA",
+            sizeof(hand->last_oci_error));
+    break;
+  case OCI_INVALID_HANDLE:
+    strlcpy((char *)hand->last_oci_error, "OCI_INVALID_HANDLE",
+            sizeof(hand->last_oci_error));
+    break;
+  case OCI_STILL_EXECUTING:
+    ((char *)hand->last_oci_error)[sizeof(hand->last_oci_error) - 1] = 0;
+    break;
+  case OCI_CONTINUE:
+    strlcpy((char *)hand->last_oci_error, "OCI_CONTINUE",
+            sizeof(hand->last_oci_error));
+    break;
+  default:
+    return 1; /* no error */
   }
 
   /* if I got here, there was an error */
@@ -262,18 +282,27 @@ static int TRY( msOracleSpatialHandler *
   return 0; /* error! */
 }
 
-OCIType *get_tdo(char *typename, msOracleSpatialHandler *hand, msOracleSpatialDataHandler *dthand )
-{
+OCIType *get_tdo(char *typename, msOracleSpatialHandler *hand,
+                 msOracleSpatialDataHandler *dthand) {
   OCIParam *paramp = NULL;
   OCIRef *type_ref = NULL;
   OCIType *tdoe = NULL;
   int success = 0;
 
-
-  success = TRY( hand, OCIDescribeAny(hand->svchp, hand->errhp, (text *)typename,  (ub4)strlen((char *)typename), OCI_OTYPE_NAME, (ub1)1, (ub1)OCI_PTYPE_TYPE, dthand->dschp))
-            &&TRY( hand, OCIAttrGet((dvoid *)dthand->dschp, (ub4)OCI_HTYPE_DESCRIBE, (dvoid *)&paramp, (ub4 *)0, (ub4)OCI_ATTR_PARAM, hand->errhp))
-            &&TRY( hand, OCIAttrGet((dvoid *)paramp, (ub4)OCI_DTYPE_PARAM, (dvoid *)&type_ref, (ub4 *)0, (ub4)OCI_ATTR_REF_TDO, hand->errhp))
-            &&TRY( hand, OCIObjectPin(hand->envhp, hand->errhp, type_ref, (OCIComplexObject *)0, OCI_PIN_ANY, OCI_DURATION_SESSION, OCI_LOCK_NONE, (dvoid **)&tdoe));
+  success =
+      TRY(hand, OCIDescribeAny(hand->svchp, hand->errhp, (text *)typename,
+                               (ub4)strlen((char *)typename), OCI_OTYPE_NAME,
+                               (ub1)1, (ub1)OCI_PTYPE_TYPE, dthand->dschp)) &&
+      TRY(hand, OCIAttrGet((dvoid *)dthand->dschp, (ub4)OCI_HTYPE_DESCRIBE,
+                           (dvoid *)&paramp, (ub4 *)0, (ub4)OCI_ATTR_PARAM,
+                           hand->errhp)) &&
+      TRY(hand,
+          OCIAttrGet((dvoid *)paramp, (ub4)OCI_DTYPE_PARAM, (dvoid *)&type_ref,
+                     (ub4 *)0, (ub4)OCI_ATTR_REF_TDO, hand->errhp)) &&
+      TRY(hand,
+          OCIObjectPin(hand->envhp, hand->errhp, type_ref,
+                       (OCIComplexObject *)0, OCI_PIN_ANY, OCI_DURATION_SESSION,
+                       OCI_LOCK_NONE, (dvoid **)&tdoe));
   if (success)
     return tdoe;
 
@@ -281,16 +310,19 @@ OCIType *get_tdo(char *typename, msOracl
   return NULL;
 }
 
-
-/* check last_oci_status for MS_FAILURE (set by TRY()) if an error ocurred return 1;
- * otherwise, returns 0 */
-static int ERROR( char *routine, msOracleSpatialHandler *hand, msOracleSpatialDataHandler *dthand )
-{
+/* check last_oci_status for MS_FAILURE (set by TRY()) if an error ocurred
+ * return 1; otherwise, returns 0 */
+static int ERROR(char *routine, msOracleSpatialHandler *hand,
+                 msOracleSpatialDataHandler *dthand) {
   (void)dthand;
   if (hand->last_oci_status == MS_FAILURE) {
     /* there was an error */
-    msSetError( MS_ORACLESPATIALERR, "OracleSpatial server returned an error, check logs for more details", routine );
-    msDebug("OracleSpatial server returned an error in funtion (%s): %s.\n", routine, (char*)hand->last_oci_error );
+    msSetError(
+        MS_ORACLESPATIALERR,
+        "OracleSpatial server returned an error, check logs for more details",
+        routine);
+    msDebug("OracleSpatial server returned an error in funtion (%s): %s.\n",
+            routine, (char *)hand->last_oci_error);
 
     /* reset error flag */
     hand->last_oci_status = MS_SUCCESS;
@@ -300,36 +332,39 @@ static int ERROR( char *routine, msOracl
     return 0; /* no error */
 }
 
-/* break layer->connection (username/password@dblink) into username, password and dblink */
-static void msSplitLogin( char *connection, mapObj *map, char **username, char **password, char **dblink )
-{
+/* break layer->connection (username/password@dblink) into username, password
+ * and dblink */
+static void msSplitLogin(char *connection, mapObj *map, char **username,
+                         char **password, char **dblink) {
   char *src, *tgt, *conn_decrypted;
   size_t buffer_size = 0;
 
   /* bad 'connection' */
-  if (connection == NULL) return;
+  if (connection == NULL)
+    return;
 
-  buffer_size = strlen(connection)+1;
-  *username = (char*)malloc(buffer_size);
-  *password = (char*)malloc(buffer_size);
-  *dblink = (char*)malloc(buffer_size);
+  buffer_size = strlen(connection) + 1;
+  *username = (char *)malloc(buffer_size);
+  *password = (char *)malloc(buffer_size);
+  *dblink = (char *)malloc(buffer_size);
 
   /* clearup */
   **username = **password = **dblink = 0;
 
   /* Decrypt any encrypted token */
   conn_decrypted = msDecryptStringTokens(map, connection);
-  if (conn_decrypted == NULL) return;
+  if (conn_decrypted == NULL)
+    return;
 
   /* ok, split connection */
-  for( tgt=*username, src=conn_decrypted; *src; src++, tgt++ )
-    if (*src=='/' || *src=='@')
+  for (tgt = *username, src = conn_decrypted; *src; src++, tgt++)
+    if (*src == '/' || *src == '@')
       break;
     else
       *tgt = *src;
   *tgt = 0;
   if (*src == '/') {
-    for( tgt=*password, ++src; *src; src++, tgt++ )
+    for (tgt = *password, ++src; *src; src++, tgt++)
       if (*src == '@')
         break;
       else
@@ -337,20 +372,21 @@ static void msSplitLogin( char *connecti
     *tgt = 0;
   }
   if (*src == '@') {
-    strlcpy( *dblink, ++src, buffer_size);
+    strlcpy(*dblink, ++src, buffer_size);
   }
 
   msFree(conn_decrypted);
 }
 
 /* break layer->data into geometry_column_name, table_name and srid */
-static int msSplitData( char *data, char **geometry_column_name, char **table_name, char **unique, char **srid, char **indexfield, int *function, int *version )
-{
+static int msSplitData(char *data, char **geometry_column_name,
+                       char **table_name, char **unique, char **srid,
+                       char **indexfield, int *function, int *version) {
   char *tok_from = "from";
   char *tok_using = "using";
   char *tok_unique = "unique";
   char *tok_srid = "srid";
-  char *tok_indexfield="indexfield";
+  char *tok_indexfield = "indexfield";
   char *tok_version = "version";
   char data_version[4] = "";
   char tok_function[11] = "";
@@ -363,77 +399,88 @@ static int msSplitData( char *data, char
   if (data == NULL)
     return 0;
 
-  buffer_size = strlen(data)+1;
-  *geometry_column_name = (char*)malloc(buffer_size);
-  *unique = (char*)malloc(buffer_size);
-  *srid = (char*)malloc(buffer_size);
-  *indexfield=(char*)malloc(buffer_size);
-
+  buffer_size = strlen(data) + 1;
+  *geometry_column_name = (char *)malloc(buffer_size);
+  *unique = (char *)malloc(buffer_size);
+  *srid = (char *)malloc(buffer_size);
+  *indexfield = (char *)malloc(buffer_size);
 
   /* clearup */
   **geometry_column_name = **table_name = 0;
 
   /* parsing 'geometry_column_name' */
-  for( ; *src && isspace( *src ); src++ ); /* skip blanks */
-  for( tgt=*geometry_column_name; *src; src++, tgt++ )
-    if (isspace( *src ))
+  for (; *src && isspace(*src); src++)
+    ; /* skip blanks */
+  for (tgt = *geometry_column_name; *src; src++, tgt++)
+    if (isspace(*src))
       break;
     else
       *tgt = *src;
   *tgt = 0;
 
   /* parsing 'from' */
-  for( ; *src && isspace( *src ); src++ ) ; /* skip blanks */
-  for( ; *src && *tok_from && tolower(*src)==*tok_from; src++, tok_from++ );
+  for (; *src && isspace(*src); src++)
+    ; /* skip blanks */
+  for (; *src && *tok_from && tolower(*src) == *tok_from; src++, tok_from++)
+    ;
   if (*tok_from != '\0')
     return 0;
 
   /* parsing 'table_name' or '(SELECT stmt)' */
   i = 0;
-  for( ; *src && isspace( *src ); src++ ); /* skip blanks */
-  for( tgt=*table_name, parenthesis=0; *src; src++, tgt++, ++i ) {
+  for (; *src && isspace(*src); src++)
+    ; /* skip blanks */
+  for (tgt = *table_name, parenthesis = 0; *src; src++, tgt++, ++i) {
     if (*src == '(')
       parenthesis++;
     else if (*src == ')')
       parenthesis--;
-    else if (parenthesis==0 && isspace( *src ))
+    else if (parenthesis == 0 && isspace(*src))
       break; /* stop on spaces */
     /* double the size of the table_name array if necessary */
     if (i == table_name_size) {
       size_t tgt_offset = tgt - *table_name;
       table_name_size *= 2;
-      *table_name = (char *) realloc(*table_name,sizeof(char *) * table_name_size);
+      *table_name =
+          (char *)realloc(*table_name, sizeof(char *) * table_name_size);
       tgt = *table_name + tgt_offset;
     }
     *tgt = *src;
   }
   *tgt = 0;
 
-  strlcpy( *unique, "", buffer_size);
-  strlcpy( *srid, "NULL", buffer_size);
-  strlcpy( *indexfield, "", buffer_size);
+  strlcpy(*unique, "", buffer_size);
+  strlcpy(*srid, "NULL", buffer_size);
+  strlcpy(*indexfield, "", buffer_size);
 
   *function = -1;
   *version = -1;
 
   /* parsing 'unique' */
-  for( ; *src && isspace( *src ); src++ ) ; /* skip blanks */
+  for (; *src && isspace(*src); src++)
+    ; /* skip blanks */
   if (*src != '\0') {
     /* parse 'using' */
-    for( ; *src && *tok_using && tolower(*src)==*tok_using; src++, tok_using++ );
+    for (; *src && *tok_using && tolower(*src) == *tok_using;
+         src++, tok_using++)
+      ;
     if (*tok_using != '\0')
       return 0;
 
     /* parsing 'unique' */
-    for( ; *src && isspace( *src ); src++ ); /* skip blanks */
-    for( ; *src && *tok_unique && tolower(*src)==*tok_unique; src++, tok_unique++ );
+    for (; *src && isspace(*src); src++)
+      ; /* skip blanks */
+    for (; *src && *tok_unique && tolower(*src) == *tok_unique;
+         src++, tok_unique++)
+      ;
 
     if (*tok_unique == '\0') {
-      for( ; *src && isspace( *src ); src++ ); /* skip blanks */
+      for (; *src && isspace(*src); src++)
+        ; /* skip blanks */
       if (*src == '\0')
         return 0;
-      for( tgt=*unique; *src; src++, tgt++ )
-        if (isspace( *src ))
+      for (tgt = *unique; *src; src++, tgt++)
+        if (isspace(*src))
           break;
         else
           *tgt = *src;
@@ -444,14 +491,17 @@ static int msSplitData( char *data, char
     }
 
     /* parsing 'srid' */
-    for( ; *src && isspace( *src ); src++ ); /* skip blanks */
-    for( ; *src && *tok_srid && tolower(*src)==*tok_srid; src++, tok_srid++ );
+    for (; *src && isspace(*src); src++)
+      ; /* skip blanks */
+    for (; *src && *tok_srid && tolower(*src) == *tok_srid; src++, tok_srid++)
+      ;
     if (*tok_srid == '\0') {
-      for( ; *src && isspace( *src ); src++ ); /* skip blanks */
+      for (; *src && isspace(*src); src++)
+        ; /* skip blanks */
       if (*src == '\0')
         return 0;
-      for( tgt=*srid; *src; src++, tgt++ )
-        if (isspace( *src ))
+      for (tgt = *srid; *src; src++, tgt++)
+        if (isspace(*src))
           break;
         else
           *tgt = *src;
@@ -462,15 +512,19 @@ static int msSplitData( char *data, char
     }
 
     /* parsing 'indexfield' */
-    for( ; *src && isspace( *src ); src++ ); /* skip blanks */
-    for( ; *src && *tok_indexfield && tolower(*src)==*tok_indexfield; src++, tok_indexfield++ );
+    for (; *src && isspace(*src); src++)
+      ; /* skip blanks */
+    for (; *src && *tok_indexfield && tolower(*src) == *tok_indexfield;
+         src++, tok_indexfield++)
+      ;
 
     if (*tok_indexfield == '\0') {
-      for( ; *src && isspace( *src ); src++ ); /* skip blanks */
+      for (; *src && isspace(*src); src++)
+        ; /* skip blanks */
       if (*src == '\0')
         return 0;
-      for( tgt=*indexfield; *src; src++, tgt++ )
-        if (isspace( *src ))
+      for (tgt = *indexfield; *src; src++, tgt++)
+        if (isspace(*src))
           break;
         else
           *tgt = *src;
@@ -481,10 +535,11 @@ static int msSplitData( char *data, char
     }
 
     /*parsing function/version */
-    for( ; *src && isspace( *src ); src++ );
+    for (; *src && isspace(*src); src++)
+      ;
     if (*src != '\0') {
-      for( tgt=tok_function; *src; src++, tgt++ )
-        if (isspace( *src ))
+      for (tgt = tok_function; *src; src++, tgt++)
+        if (isspace(*src))
           break;
         else
           *tgt = *src;
@@ -492,17 +547,17 @@ static int msSplitData( char *data, char
     }
 
     /*Upcase conversion for the FUNCTION/VERSION token*/
-    for (i=0; tok_function[i] != '\0'; i++)
+    for (i = 0; tok_function[i] != '\0'; i++)
       tok_function[i] = toupper(tok_function[i]);
 
     if (strcmp(tok_function, "VERSION")) {
       if (!strcmp(tok_function, "FILTER") || !strcmp(tok_function, ""))
         *function = FUNCTION_FILTER;
-      else if(!strcmp(tok_function, "RELATE"))
+      else if (!strcmp(tok_function, "RELATE"))
         *function = FUNCTION_RELATE;
-      else if (!strcmp(tok_function,"GEOMRELATE"))
+      else if (!strcmp(tok_function, "GEOMRELATE"))
         *function = FUNCTION_GEOMRELATE;
-      else if (!strcmp(tok_function,"NONE"))
+      else if (!strcmp(tok_function, "NONE"))
         *function = FUNCTION_NONE;
       else {
         *function = -1;
@@ -510,57 +565,64 @@ static int msSplitData( char *data, char
       }
 
       /*parsing VERSION token when user defined one function*/
-      for( ; *src && isspace( *src ); src++ );
-      for( ; *src && *tok_version && tolower(*src)==*tok_version; src++, tok_version++ );
+      for (; *src && isspace(*src); src++)
+        ;
+      for (; *src && *tok_version && tolower(*src) == *tok_version;
+           src++, tok_version++)
+        ;
     } else {
-      for(tgt = "VERSION"; *tgt && *tok_version && toupper(*tgt)==toupper(*tok_version); tgt++, tok_version++ );
+      for (tgt = "VERSION";
+           *tgt && *tok_version && toupper(*tgt) == toupper(*tok_version);
+           tgt++, tok_version++)
+        ;
       *function = FUNCTION_FILTER;
     }
 
     /*parsing version*/
     if (*tok_version == '\0') {
-      for( ; *src && isspace( *src ); src++ ); /* skip blanks */
-      for( tgt=data_version; *src; src++, tgt++ )
-        if (isspace( *src ))
+      for (; *src && isspace(*src); src++)
+        ; /* skip blanks */
+      for (tgt = data_version; *src; src++, tgt++)
+        if (isspace(*src))
           break;
         else
           *tgt = *src;
       *tgt = 0;
 
-      for (i=0; data_version[i] != '\0'; i++)
+      for (i = 0; data_version[i] != '\0'; i++)
         data_version[i] = tolower(data_version[i]);
 
       if (!strcmp(data_version, "8i"))
         *version = VERSION_8i;
-      else if(!strcmp(data_version, "9i"))
+      else if (!strcmp(data_version, "9i"))
         *version = VERSION_9i;
       else if (!strcmp(data_version, "10g"))
         *version = VERSION_10g;
       else
         return 0;
-
     }
-
   }
   /* finish parsing */
-  for( ; *src && isspace( *src ); src++ ); /* skip blanks */
+  for (; *src && isspace(*src); src++)
+    ; /* skip blanks */
 
   return (*src == '\0');
 }
 
-
 /******************************************************************************
  *                          OCI Helper Functions                              *
  ******************************************************************************/
 
 /* create statement handle from database connection */
-static int msOCIOpenStatement( msOracleSpatialHandler *hand, msOracleSpatialStatement *sthand)
-{
+static int msOCIOpenStatement(msOracleSpatialHandler *hand,
+                              msOracleSpatialStatement *sthand) {
   int success = 0;
-  char * cmd  = "";
+  char *cmd = "";
 
   /* allocate stmthp */
-  success = TRY( hand, OCIHandleAlloc( (dvoid *)hand->envhp, (dvoid **)&sthand->stmthp, (ub4)OCI_HTYPE_STMT, (size_t)0, (dvoid **)0 ) );
+  success =
+      TRY(hand, OCIHandleAlloc((dvoid *)hand->envhp, (dvoid **)&sthand->stmthp,
+                               (ub4)OCI_HTYPE_STMT, (size_t)0, (dvoid **)0));
 
   sthand->rows_count = 0;
   sthand->row_num = 0;
@@ -572,21 +634,40 @@ static int msOCIOpenStatement( msOracleS
   /* setting environment values to enable time parsing */
 
   cmd = "alter session set NLS_DATE_FORMAT='yyyy-mm-dd hh24:mi:ss'";
-  success = TRY(hand, OCIStmtPrepare( sthand->stmthp, hand->errhp, (const OraText*)cmd, (ub4) strlen(cmd), (ub4) OCI_NTV_SYNTAX, (ub4) OCI_DEFAULT));
-  success = TRY(hand, OCIStmtExecute( hand->svchp, sthand->stmthp, hand->errhp, (ub4)ARRAY_SIZE, (ub4)0, (OCISnapshot *)NULL, (OCISnapshot *)NULL, (ub4)OCI_DEFAULT ) );
+  success = TRY(hand, OCIStmtPrepare(sthand->stmthp, hand->errhp,
+                                     (const OraText *)cmd, (ub4)strlen(cmd),
+                                     (ub4)OCI_NTV_SYNTAX, (ub4)OCI_DEFAULT));
+  success =
+      TRY(hand, OCIStmtExecute(hand->svchp, sthand->stmthp, hand->errhp,
+                               (ub4)ARRAY_SIZE, (ub4)0, (OCISnapshot *)NULL,
+                               (OCISnapshot *)NULL, (ub4)OCI_DEFAULT));
 
   cmd = "alter session set NLS_TIMESTAMP_TZ_FORMAT='yyyy-mm-dd hh24:mi:ss'";
-  success = TRY(hand, OCIStmtPrepare( sthand->stmthp, hand->errhp, (const OraText*)cmd, (ub4) strlen(cmd), (ub4) OCI_NTV_SYNTAX, (ub4) OCI_DEFAULT));
-  success = TRY(hand, OCIStmtExecute( hand->svchp, sthand->stmthp, hand->errhp, (ub4)ARRAY_SIZE, (ub4)0, (OCISnapshot *)NULL, (OCISnapshot *)NULL, (ub4)OCI_DEFAULT ) );
+  success = TRY(hand, OCIStmtPrepare(sthand->stmthp, hand->errhp,
+                                     (const OraText *)cmd, (ub4)strlen(cmd),
+                                     (ub4)OCI_NTV_SYNTAX, (ub4)OCI_DEFAULT));
+  success =
+      TRY(hand, OCIStmtExecute(hand->svchp, sthand->stmthp, hand->errhp,
+                               (ub4)ARRAY_SIZE, (ub4)0, (OCISnapshot *)NULL,
+                               (OCISnapshot *)NULL, (ub4)OCI_DEFAULT));
 
   cmd = "alter session set NLS_TIMESTAMP_FORMAT = 'yyyy-mm-dd hh24:mi:ss'";
-  success = TRY(hand, OCIStmtPrepare( sthand->stmthp, hand->errhp, (const OraText*)cmd, (ub4) strlen(cmd), (ub4) OCI_NTV_SYNTAX, (ub4) OCI_DEFAULT));
-  success = TRY(hand, OCIStmtExecute( hand->svchp, sthand->stmthp, hand->errhp, (ub4)ARRAY_SIZE, (ub4)0, (OCISnapshot *)NULL, (OCISnapshot *)NULL, (ub4)OCI_DEFAULT ) );
+  success = TRY(hand, OCIStmtPrepare(sthand->stmthp, hand->errhp,
+                                     (const OraText *)cmd, (ub4)strlen(cmd),
+                                     (ub4)OCI_NTV_SYNTAX, (ub4)OCI_DEFAULT));
+  success =
+      TRY(hand, OCIStmtExecute(hand->svchp, sthand->stmthp, hand->errhp,
+                               (ub4)ARRAY_SIZE, (ub4)0, (OCISnapshot *)NULL,
+                               (OCISnapshot *)NULL, (ub4)OCI_DEFAULT));
 
   cmd = "alter session set time_zone = 'GMT'";
-  success = TRY(hand, OCIStmtPrepare( sthand->stmthp, hand->errhp, (const OraText*)cmd, (ub4) strlen(cmd), (ub4) OCI_NTV_SYNTAX, (ub4) OCI_DEFAULT));
-  success = TRY(hand, OCIStmtExecute( hand->svchp, sthand->stmthp, hand->errhp, (ub4)ARRAY_SIZE, (ub4)0, (OCISnapshot *)NULL, (OCISnapshot *)NULL, (ub4)OCI_DEFAULT ) );
-
+  success = TRY(hand, OCIStmtPrepare(sthand->stmthp, hand->errhp,
+                                     (const OraText *)cmd, (ub4)strlen(cmd),
+                                     (ub4)OCI_NTV_SYNTAX, (ub4)OCI_DEFAULT));
+  success =
+      TRY(hand, OCIStmtExecute(hand->svchp, sthand->stmthp, hand->errhp,
+                               (ub4)ARRAY_SIZE, (ub4)0, (OCISnapshot *)NULL,
+                               (OCISnapshot *)NULL, (ub4)OCI_DEFAULT));
 
   /* fprintf(stderr, "Creating statement handle at %p\n", sthand->stmthp); */
 
@@ -594,270 +675,298 @@ static int msOCIOpenStatement( msOracleS
 }
 
 /* create statement handle from database connection */
-static void msOCIFinishStatement( msOracleSpatialStatement *sthand )
-{
-  if(sthand != NULL) {
+static void msOCIFinishStatement(msOracleSpatialStatement *sthand) {
+  if (sthand != NULL) {
     /* fprintf(stderr, "Freeing statement handle at %p\n", sthand->stmthp); */
 
     if (sthand->stmthp != NULL)
-      OCIHandleFree( (dvoid *)sthand->stmthp, (ub4)OCI_HTYPE_STMT );
+      OCIHandleFree((dvoid *)sthand->stmthp, (ub4)OCI_HTYPE_STMT);
     if (sthand->items != NULL)
-      free( sthand->items );
+      free(sthand->items);
     if (sthand->items_query != NULL)
-      free( sthand->items_query );
-    memset(sthand, 0, sizeof( msOracleSpatialStatement ) );
+      free(sthand->items_query);
+    memset(sthand, 0, sizeof(msOracleSpatialStatement));
     free(sthand);
   }
 }
 
-static int msOCISetDataHandlers(msOracleSpatialHandler *hand, msOracleSpatialDataHandler *dthand)
-{
+static int msOCISetDataHandlers(msOracleSpatialHandler *hand,
+                                msOracleSpatialDataHandler *dthand) {
   int success = 0;
   OCIParam *paramp = NULL;
   OCIRef *type_ref = NULL;
 
-  success = TRY( hand,
-                 /* allocate dschp */
-                 OCIHandleAlloc( hand->envhp, (dvoid **)&dthand->dschp, (ub4)OCI_HTYPE_DESCRIBE, (size_t)0, (dvoid **)0 ) )
-            && TRY( hand,
-                    /* describe SDO_GEOMETRY in svchp (dschp) */
-                    OCIDescribeAny( hand->svchp, hand->errhp, (text *)SDO_GEOMETRY, (ub4)SDO_GEOMETRY_LEN, OCI_OTYPE_NAME, (ub1)1, (ub1)OCI_PTYPE_TYPE, dthand->dschp ) )
-            && TRY( hand,
-                    /* get param for SDO_GEOMETRY */
-                    OCIAttrGet( (dvoid *)dthand->dschp, (ub4)OCI_HTYPE_DESCRIBE, (dvoid *)&paramp, (ub4 *)0,  (ub4)OCI_ATTR_PARAM, hand->errhp ) )
-            && TRY( hand,
-                    /* get type_ref for SDO_GEOMETRY */
-                    OCIAttrGet( (dvoid *)paramp, (ub4)OCI_DTYPE_PARAM, (dvoid *)&type_ref, (ub4 *)0, (ub4)OCI_ATTR_REF_TDO, hand->errhp ) )
-            && TRY( hand,
-                    /* get TDO for SDO_GEOMETRY */
-                    OCIObjectPin( hand->envhp, hand->errhp, type_ref, (OCIComplexObject *)0, OCI_PIN_ANY, OCI_DURATION_SESSION, OCI_LOCK_NONE, (dvoid **)&dthand->tdo ) );
+  success =
+      TRY(hand,
+          /* allocate dschp */
+          OCIHandleAlloc(hand->envhp, (dvoid **)&dthand->dschp,
+                         (ub4)OCI_HTYPE_DESCRIBE, (size_t)0, (dvoid **)0)) &&
+      TRY(hand,
+          /* describe SDO_GEOMETRY in svchp (dschp) */
+          OCIDescribeAny(hand->svchp, hand->errhp, (text *)SDO_GEOMETRY,
+                         (ub4)SDO_GEOMETRY_LEN, OCI_OTYPE_NAME, (ub1)1,
+                         (ub1)OCI_PTYPE_TYPE, dthand->dschp)) &&
+      TRY(hand,
+          /* get param for SDO_GEOMETRY */
+          OCIAttrGet((dvoid *)dthand->dschp, (ub4)OCI_HTYPE_DESCRIBE,
+                     (dvoid *)&paramp, (ub4 *)0, (ub4)OCI_ATTR_PARAM,
+                     hand->errhp)) &&
+      TRY(hand,
+          /* get type_ref for SDO_GEOMETRY */
+          OCIAttrGet((dvoid *)paramp, (ub4)OCI_DTYPE_PARAM, (dvoid *)&type_ref,
+                     (ub4 *)0, (ub4)OCI_ATTR_REF_TDO, hand->errhp)) &&
+      TRY(hand,
+          /* get TDO for SDO_GEOMETRY */
+          OCIObjectPin(hand->envhp, hand->errhp, type_ref,
+                       (OCIComplexObject *)0, OCI_PIN_ANY, OCI_DURATION_SESSION,
+                       OCI_LOCK_NONE, (dvoid **)&dthand->tdo));
 
   return success;
 }
 
 /* connect to database */
-static msOracleSpatialHandler *msOCISetHandlers( char *username, char *password, char *dblink )
-{
+static msOracleSpatialHandler *msOCISetHandlers(char *username, char *password,
+                                                char *dblink) {
   int success;
 
   msOracleSpatialHandler *hand = NULL;
 
-  hand = (msOracleSpatialHandler *) malloc( sizeof(msOracleSpatialHandler));
+  hand = (msOracleSpatialHandler *)malloc(sizeof(msOracleSpatialHandler));
   if (hand == NULL) {
     msSetError(MS_MEMERR, NULL, "msOCISetHandlers()");
     return NULL;
   }
-  memset( hand, 0, sizeof(msOracleSpatialHandler) );
+  memset(hand, 0, sizeof(msOracleSpatialHandler));
 
   hand->ref_count = 1;
   hand->last_oci_status = MS_SUCCESS;
   hand->last_oci_error[0] = (text)'\0';
 
-  success = TRY( hand,
-                 /* allocate envhp */
+  success = TRY(hand,
+  /* allocate envhp */
 #ifdef USE_THREAD
-                 OCIEnvCreate( &hand->envhp, OCI_OBJECT|OCI_THREADED, (dvoid *)0, 0, 0, 0, (size_t) 0, (dvoid **)0 ) )
+                OCIEnvCreate(&hand->envhp, OCI_OBJECT | OCI_THREADED,
+                             (dvoid *)0, 0, 0, 0, (size_t)0, (dvoid **)0))
 #else
-                 OCIEnvCreate( &hand->envhp, OCI_OBJECT, (dvoid *)0, 0, 0, 0, (size_t) 0, (dvoid **)0 ) )
+                OCIEnvCreate(&hand->envhp, OCI_OBJECT, (dvoid *)0, 0, 0, 0,
+                             (size_t)0, (dvoid **)0))
 #endif
-            && TRY( hand,
-                    /* allocate errhp */
-                    OCIHandleAlloc( (dvoid *)hand->envhp, (dvoid **)&hand->errhp, (ub4)OCI_HTYPE_ERROR, (size_t)0, (dvoid **)0 ) )
-            && TRY( hand,
-                    /* logon */
-                    OCILogon( hand->envhp, hand->errhp, &hand->svchp, (text *)username, strlen(username), (text *)password, strlen(password), (text *)dblink, strlen(dblink) ) );
-
-  if ( !success ) {
-    msDebug(   "Cannot create OCI Handlers. "
-                "Connection failure."
-                "Error: %s."
-                "msOracleSpatialLayerOpen()\n", hand->last_oci_error);
-    msSetError( MS_ORACLESPATIALERR,
-                "Cannot create OCI Handlers. "
-                "Connection failure. Check your logs and the connection string. ",
-                "msOracleSpatialLayerOpen()");
+            &&
+            TRY(hand,
+                /* allocate errhp */
+                OCIHandleAlloc((dvoid *)hand->envhp, (dvoid **)&hand->errhp,
+                               (ub4)OCI_HTYPE_ERROR, (size_t)0, (dvoid **)0)) &&
+            TRY(hand,
+                /* logon */
+                OCILogon(hand->envhp, hand->errhp, &hand->svchp,
+                         (text *)username, strlen(username), (text *)password,
+                         strlen(password), (text *)dblink, strlen(dblink)));
+
+  if (!success) {
+    msDebug("Cannot create OCI Handlers. "
+            "Connection failure."
+            "Error: %s."
+            "msOracleSpatialLayerOpen()\n",
+            hand->last_oci_error);
+    msSetError(
+        MS_ORACLESPATIALERR,
+        "Cannot create OCI Handlers. "
+        "Connection failure. Check your logs and the connection string. ",
+        "msOracleSpatialLayerOpen()");
 
     msOCICloseHandlers(hand);
     return NULL;
   }
 
   return hand;
-
 }
 
 /* disconnect from database */
-static void msOCICloseHandlers( msOracleSpatialHandler *hand )
-{
+static void msOCICloseHandlers(msOracleSpatialHandler *hand) {
   if (hand->svchp != NULL)
-    OCILogoff( hand->svchp, hand->errhp );
+    OCILogoff(hand->svchp, hand->errhp);
   if (hand->errhp != NULL)
-    OCIHandleFree( (dvoid *)hand->errhp, (ub4)OCI_HTYPE_ERROR );
+    OCIHandleFree((dvoid *)hand->errhp, (ub4)OCI_HTYPE_ERROR);
   if (hand->envhp != NULL)
-    OCIHandleFree( (dvoid *)hand->envhp, (ub4)OCI_HTYPE_ENV );
+    OCIHandleFree((dvoid *)hand->envhp, (ub4)OCI_HTYPE_ENV);
   if (hand != NULL)
-    memset( hand, 0, sizeof (msOracleSpatialHandler));
+    memset(hand, 0, sizeof(msOracleSpatialHandler));
   free(hand);
 }
 
-static void msOCICloseDataHandlers( msOracleSpatialDataHandler *dthand )
-{
+static void msOCICloseDataHandlers(msOracleSpatialDataHandler *dthand) {
   if (dthand->dschp != NULL)
-    OCIHandleFree( (dvoid *)dthand->dschp, (ub4)OCI_HTYPE_DESCRIBE );
+    OCIHandleFree((dvoid *)dthand->dschp, (ub4)OCI_HTYPE_DESCRIBE);
   if (dthand != NULL)
-    memset( dthand, 0, sizeof (msOracleSpatialDataHandler));
+    memset(dthand, 0, sizeof(msOracleSpatialDataHandler));
   free(dthand);
 }
 
-static void msOCIClearLayerInfo( msOracleSpatialLayerInfo *layerinfo )
-{
+static void msOCIClearLayerInfo(msOracleSpatialLayerInfo *layerinfo) {
   if (layerinfo != NULL) {
-    memset( layerinfo, 0, sizeof( msOracleSpatialLayerInfo ) );
+    memset(layerinfo, 0, sizeof(msOracleSpatialLayerInfo));
     free(layerinfo);
   }
 }
 
 /*function that creates the correct sql for geoditical srid for version 9i*/
-static char * osGeodeticData(int function, char *query_str, char *geom_column_name, char *index_column_name)
-{
-  char *filter_field=index_column_name[0]=='\0' ? geom_column_name : index_column_name;
+static char *osGeodeticData(int function, char *query_str,
+                            char *geom_column_name, char *index_column_name) {
+  char *filter_field =
+      index_column_name[0] == '\0' ? geom_column_name : index_column_name;
   switch (function) {
-    case FUNCTION_FILTER: {
-      query_str = msStringConcatenate(query_str, "SDO_FILTER( ");
-      query_str = msStringConcatenate(query_str, filter_field);
-      query_str = msStringConcatenate(query_str, ", SDO_CS.VIEWPORT_TRANSFORM(MDSYS.SDO_GEOMETRY("
-                "2003, 0, NULL,"
-                "MDSYS.SDO_ELEM_INFO_ARRAY(1,1003,3),"
-                ":ordinates ), :srid),"
-                "'querytype=window') = 'TRUE'");
-      break;
-    }
-    case FUNCTION_RELATE: {
-      query_str = msStringConcatenate(query_str, "SDO_RELATE( ");
-      query_str = msStringConcatenate(query_str, filter_field);
-      query_str = msStringConcatenate(query_str, ", SDO_CS.VIEWPORT_TRANSFORM(MDSYS.SDO_GEOMETRY("
-                "2003, 0, NULL,"
-                "MDSYS.SDO_ELEM_INFO_ARRAY(1,1003,3),"
-                ":ordinates ), :srid),"
-                "'mask=anyinteract querytype=window') = 'TRUE'");
-      break;
-    }
-    case FUNCTION_GEOMRELATE: {
-      char tmpFloat[256];
-      snprintf(tmpFloat, sizeof(tmpFloat), "%f", TOLERANCE);
-
-      query_str = msStringConcatenate(query_str, "SDO_GEOM.RELATE( ");
-      query_str = msStringConcatenate(query_str, filter_field);
-      query_str = msStringConcatenate(query_str, ", SDO_CS.VIEWPORT_TRANSFORM(MDSYS.SDO_GEOMETRY("
-                "2003, 0, NULL,"
-                "MDSYS.SDO_ELEM_INFO_ARRAY(1,1003,3),"
-                ":ordinates), :srid),");
-      query_str = msStringConcatenate(query_str, tmpFloat);
-      query_str = msStringConcatenate(query_str,  ") = 'TRUE' AND ");
-      query_str = msStringConcatenate(query_str, geom_column_name);
-      query_str = msStringConcatenate(query_str,  " IS NOT NULL");
-      break;
-    }
-    case FUNCTION_NONE: {
-      break;
-    }
-    default: {
-      query_str = msStringConcatenate(query_str, "SDO_FILTER( ");
-      query_str = msStringConcatenate(query_str, filter_field);
-      query_str = msStringConcatenate(query_str, ", SDO_CS.VIEWPORT_TRANSFORM(MDSYS.SDO_GEOMETRY("
-                "2003, 0, NULL,"
-                "MDSYS.SDO_ELEM_INFO_ARRAY(1,1003,3),"
-                ":ordinates), :srid),"
-                "'querytype=window') = 'TRUE'");
-    }
+  case FUNCTION_FILTER: {
+    query_str = msStringConcatenate(query_str, "SDO_FILTER( ");
+    query_str = msStringConcatenate(query_str, filter_field);
+    query_str = msStringConcatenate(
+        query_str, ", SDO_CS.VIEWPORT_TRANSFORM(MDSYS.SDO_GEOMETRY("
+                   "2003, 0, NULL,"
+                   "MDSYS.SDO_ELEM_INFO_ARRAY(1,1003,3),"
+                   ":ordinates ), :srid),"
+                   "'querytype=window') = 'TRUE'");
+    break;
+  }
+  case FUNCTION_RELATE: {
+    query_str = msStringConcatenate(query_str, "SDO_RELATE( ");
+    query_str = msStringConcatenate(query_str, filter_field);
+    query_str = msStringConcatenate(
+        query_str, ", SDO_CS.VIEWPORT_TRANSFORM(MDSYS.SDO_GEOMETRY("
+                   "2003, 0, NULL,"
+                   "MDSYS.SDO_ELEM_INFO_ARRAY(1,1003,3),"
+                   ":ordinates ), :srid),"
+                   "'mask=anyinteract querytype=window') = 'TRUE'");
+    break;
+  }
+  case FUNCTION_GEOMRELATE: {
+    char tmpFloat[256];
+    snprintf(tmpFloat, sizeof(tmpFloat), "%f", TOLERANCE);
+
+    query_str = msStringConcatenate(query_str, "SDO_GEOM.RELATE( ");
+    query_str = msStringConcatenate(query_str, filter_field);
+    query_str = msStringConcatenate(
+        query_str, ", SDO_CS.VIEWPORT_TRANSFORM(MDSYS.SDO_GEOMETRY("
+                   "2003, 0, NULL,"
+                   "MDSYS.SDO_ELEM_INFO_ARRAY(1,1003,3),"
+                   ":ordinates), :srid),");
+    query_str = msStringConcatenate(query_str, tmpFloat);
+    query_str = msStringConcatenate(query_str, ") = 'TRUE' AND ");
+    query_str = msStringConcatenate(query_str, geom_column_name);
+    query_str = msStringConcatenate(query_str, " IS NOT NULL");
+    break;
+  }
+  case FUNCTION_NONE: {
+    break;
+  }
+  default: {
+    query_str = msStringConcatenate(query_str, "SDO_FILTER( ");
+    query_str = msStringConcatenate(query_str, filter_field);
+    query_str = msStringConcatenate(
+        query_str, ", SDO_CS.VIEWPORT_TRANSFORM(MDSYS.SDO_GEOMETRY("
+                   "2003, 0, NULL,"
+                   "MDSYS.SDO_ELEM_INFO_ARRAY(1,1003,3),"
+                   ":ordinates), :srid),"
+                   "'querytype=window') = 'TRUE'");
+  }
   }
   return query_str;
 }
 
 /*function that generate the correct sql for no geoditic srid's*/
-static char * osNoGeodeticData(int function, int version, char *query_str, char *geom_column_name, char *index_column_name)
-{
-   char *filter_field= index_column_name[0]=='\0' ? geom_column_name : index_column_name;
-   switch (function) {
-    case FUNCTION_FILTER: {
-      query_str = msStringConcatenate(query_str, "SDO_FILTER( ");
+static char *osNoGeodeticData(int function, int version, char *query_str,
+                              char *geom_column_name, char *index_column_name) {
+  char *filter_field =
+      index_column_name[0] == '\0' ? geom_column_name : index_column_name;
+  switch (function) {
+  case FUNCTION_FILTER: {
+    query_str = msStringConcatenate(query_str, "SDO_FILTER( ");
+    query_str = msStringConcatenate(query_str, filter_field);
+    query_str = msStringConcatenate(
+        query_str, ", MDSYS.SDO_GEOMETRY("
+                   "2003, :srid, NULL,"
+                   "MDSYS.SDO_ELEM_INFO_ARRAY(1,1003,3),"
+                   /*   "MDSYS.SDO_ORDINATE_ARRAY(%.9g,%.9g,%.9g,%.9g)" */
+                   ":ordinates"
+                   " ),'querytype=window') = 'TRUE'");
+    break;
+  }
+  case FUNCTION_RELATE: {
+    if (version == VERSION_10g) {
+      query_str = msStringConcatenate(query_str, "SDO_ANYINTERACT( ");
       query_str = msStringConcatenate(query_str, filter_field);
-      query_str = msStringConcatenate(query_str, ", MDSYS.SDO_GEOMETRY("
-                "2003, :srid, NULL,"
-                "MDSYS.SDO_ELEM_INFO_ARRAY(1,1003,3),"
-                /*   "MDSYS.SDO_ORDINATE_ARRAY(%.9g,%.9g,%.9g,%.9g)" */
-                ":ordinates"
-                " ),'querytype=window') = 'TRUE'");
-      break;
-    }
-    case FUNCTION_RELATE: {
-      if (version == VERSION_10g) {
-        query_str = msStringConcatenate(query_str, "SDO_ANYINTERACT( ");
-        query_str = msStringConcatenate(query_str, filter_field);
-        query_str = msStringConcatenate(query_str, ", MDSYS.SDO_GEOMETRY("
-                  "2003, :srid, NULL,"
-                  "MDSYS.SDO_ELEM_INFO_ARRAY(1,1003,3),"
-                  ":ordinates)) = 'TRUE'");
-      } else {
+      query_str =
+          msStringConcatenate(query_str, ", MDSYS.SDO_GEOMETRY("
+                                         "2003, :srid, NULL,"
+                                         "MDSYS.SDO_ELEM_INFO_ARRAY(1,1003,3),"
+                                         ":ordinates)) = 'TRUE'");
+    } else {
 
-        query_str = msStringConcatenate(query_str, "SDO_RELATE( ");
-        query_str = msStringConcatenate(query_str, geom_column_name);
-        query_str = msStringConcatenate(query_str, ", MDSYS.SDO_GEOMETRY("
-                  "2003, :srid, NULL,"
-                  "MDSYS.SDO_ELEM_INFO_ARRAY(1,1003,3),"
-                  ":ordinates),"
-                  "'mask=anyinteract querytype=window') = 'TRUE'");
-      }
-      break;
-    }
-    case FUNCTION_GEOMRELATE: {
-      char tmpFloat[256];
-      snprintf(tmpFloat, sizeof(tmpFloat), "%f", TOLERANCE);
-
-      query_str = msStringConcatenate(query_str, "SDO_GEOM.RELATE( ");
-      query_str = msStringConcatenate(query_str, index_column_name);
-      query_str = msStringConcatenate(query_str, ", 'anyinteract', MDSYS.SDO_GEOMETRY("
-                "2003, :srid, NULL,"
-                "MDSYS.SDO_ELEM_INFO_ARRAY(1,1003,3),"
-                ":ordinates),");
-      query_str = msStringConcatenate(query_str, tmpFloat);
-      query_str = msStringConcatenate(query_str, ") = 'TRUE' AND ");
+      query_str = msStringConcatenate(query_str, "SDO_RELATE( ");
       query_str = msStringConcatenate(query_str, geom_column_name);
-      query_str = msStringConcatenate(query_str, " IS NOT NULL");
-      break;
-    }
-    case FUNCTION_NONE: {
-      break;
-    }
-    default: {
-      query_str = msStringConcatenate(query_str, "SDO_FILTER( ");
-      query_str = msStringConcatenate(query_str, filter_field);
-      query_str = msStringConcatenate(query_str, ", MDSYS.SDO_GEOMETRY("
-                "2003, :srid, NULL,"
-                "MDSYS.SDO_ELEM_INFO_ARRAY(1,1003,3),"
-                ":ordinates),"
-                "'querytype=window') = 'TRUE'");
+      query_str = msStringConcatenate(
+          query_str, ", MDSYS.SDO_GEOMETRY("
+                     "2003, :srid, NULL,"
+                     "MDSYS.SDO_ELEM_INFO_ARRAY(1,1003,3),"
+                     ":ordinates),"
+                     "'mask=anyinteract querytype=window') = 'TRUE'");
     }
+    break;
+  }
+  case FUNCTION_GEOMRELATE: {
+    char tmpFloat[256];
+    snprintf(tmpFloat, sizeof(tmpFloat), "%f", TOLERANCE);
+
+    query_str = msStringConcatenate(query_str, "SDO_GEOM.RELATE( ");
+    query_str = msStringConcatenate(query_str, index_column_name);
+    query_str =
+        msStringConcatenate(query_str, ", 'anyinteract', MDSYS.SDO_GEOMETRY("
+                                       "2003, :srid, NULL,"
+                                       "MDSYS.SDO_ELEM_INFO_ARRAY(1,1003,3),"
+                                       ":ordinates),");
+    query_str = msStringConcatenate(query_str, tmpFloat);
+    query_str = msStringConcatenate(query_str, ") = 'TRUE' AND ");
+    query_str = msStringConcatenate(query_str, geom_column_name);
+    query_str = msStringConcatenate(query_str, " IS NOT NULL");
+    break;
+  }
+  case FUNCTION_NONE: {
+    break;
+  }
+  default: {
+    query_str = msStringConcatenate(query_str, "SDO_FILTER( ");
+    query_str = msStringConcatenate(query_str, filter_field);
+    query_str =
+        msStringConcatenate(query_str, ", MDSYS.SDO_GEOMETRY("
+                                       "2003, :srid, NULL,"
+                                       "MDSYS.SDO_ELEM_INFO_ARRAY(1,1003,3),"
+                                       ":ordinates),"
+                                       "'querytype=window') = 'TRUE'");
+  }
   }
   return query_str;
 }
 
 /* get ordinates from SDO buffer */
-static int msOCIGet2DOrdinates( msOracleSpatialHandler *hand, SDOGeometryObj *obj, int s, int e, pointObj *pt )
-{
+static int msOCIGet2DOrdinates(msOracleSpatialHandler *hand,
+                               SDOGeometryObj *obj, int s, int e,
+                               pointObj *pt) {
   double x, y;
   int i, n, success = 1;
   boolean exists;
   OCINumber *oci_number;
 
-  for( i=s, n=0; i < e && success; i+=2, n++ ) {
-    success = TRY( hand,
-                   OCICollGetElem( hand->envhp, hand->errhp, (OCIColl *)obj->ordinates, (sb4)i, (boolean *)&exists, (dvoid *)&oci_number, (dvoid **)0 ) )
-              && TRY( hand,
-                      OCINumberToReal( hand->errhp, oci_number, (uword)sizeof(double), (dvoid *)&x ) )
-              && TRY( hand,
-                      OCICollGetElem( hand->envhp, hand->errhp, (OCIColl *)obj->ordinates, (sb4)i+1, (boolean *)&exists, (dvoid *)&oci_number, (dvoid **)0 ) )
-              && TRY( hand,
-                      OCINumberToReal( hand->errhp, oci_number, (uword)sizeof(double), (dvoid *)&y ) );
+  for (i = s, n = 0; i < e && success; i += 2, n++) {
+    success = TRY(hand, OCICollGetElem(hand->envhp, hand->errhp,
+                                       (OCIColl *)obj->ordinates, (sb4)i,
+                                       (boolean *)&exists, (dvoid *)&oci_number,
+                                       (dvoid **)0)) &&
+              TRY(hand, OCINumberToReal(hand->errhp, oci_number,
+                                        (uword)sizeof(double), (dvoid *)&x)) &&
+              TRY(hand, OCICollGetElem(hand->envhp, hand->errhp,
+                                       (OCIColl *)obj->ordinates, (sb4)i + 1,
+                                       (boolean *)&exists, (dvoid *)&oci_number,
+                                       (dvoid **)0)) &&
+              TRY(hand, OCINumberToReal(hand->errhp, oci_number,
+                                        (uword)sizeof(double), (dvoid *)&y));
 
     if (success) {
       pt[n].x = x;
@@ -868,8 +977,9 @@ static int msOCIGet2DOrdinates( msOracle
   return success ? n : 0;
 }
 
-static int msOCIGet3DOrdinates( msOracleSpatialHandler *hand, SDOGeometryObj *obj, int s, int e, pointObj *pt )
-{
+static int msOCIGet3DOrdinates(msOracleSpatialHandler *hand,
+                               SDOGeometryObj *obj, int s, int e,
+                               pointObj *pt) {
   double x, y;
   int i, n, success = 1;
   boolean exists;
@@ -877,25 +987,35 @@ static int msOCIGet3DOrdinates( msOracle
   boolean numnull;
   OCINumber *oci_number;
 
-  for( i=s, n=0; i < e && success; i+=3, n++ ) {
-    success = TRY( hand,
-                   OCICollGetElem( hand->envhp, hand->errhp, (OCIColl *)obj->ordinates, (sb4)i, (boolean *)&exists, (dvoid *)&oci_number, (dvoid **)0 ) )
-              && TRY( hand,
-                      OCINumberToReal( hand->errhp, oci_number, (uword)sizeof(double), (dvoid *)&x ) )
-              && TRY( hand,
-                      OCICollGetElem( hand->envhp, hand->errhp, (OCIColl *)obj->ordinates, (sb4)i+1, (boolean *)&exists, (dvoid *)&oci_number, (dvoid **)0 ) )
-              && TRY( hand,
-                      OCINumberToReal( hand->errhp, oci_number, (uword)sizeof(double), (dvoid *)&y ) )
-              && TRY( hand,
-                      OCICollGetElem( hand->envhp, hand->errhp, (OCIColl *)obj->ordinates, (sb4)i+2, (boolean *)&exists, (dvoid *)&oci_number, (dvoid **)0 ) )
-              ;
+  for (i = s, n = 0; i < e && success; i += 3, n++) {
+    success = TRY(hand, OCICollGetElem(hand->envhp, hand->errhp,
+                                       (OCIColl *)obj->ordinates, (sb4)i,
+                                       (boolean *)&exists, (dvoid *)&oci_number,
+                                       (dvoid **)0)) &&
+              TRY(hand, OCINumberToReal(hand->errhp, oci_number,
+                                        (uword)sizeof(double), (dvoid *)&x)) &&
+              TRY(hand, OCICollGetElem(hand->envhp, hand->errhp,
+                                       (OCIColl *)obj->ordinates, (sb4)i + 1,
+                                       (boolean *)&exists, (dvoid *)&oci_number,
+                                       (dvoid **)0)) &&
+              TRY(hand, OCINumberToReal(hand->errhp, oci_number,
+                                        (uword)sizeof(double), (dvoid *)&y)) &&
+              TRY(hand, OCICollGetElem(hand->envhp, hand->errhp,
+                                       (OCIColl *)obj->ordinates, (sb4)i + 2,
+                                       (boolean *)&exists, (dvoid *)&oci_number,
+                                       (dvoid **)0));
     if (success) {
-      success = TRY(hand, OCINumberIsZero( hand->errhp, oci_number, (boolean *)&numnull));
+      success = TRY(
+          hand, OCINumberIsZero(hand->errhp, oci_number, (boolean *)&numnull));
       if (success) {
-        success = TRY( hand, OCINumberToReal( hand->errhp, oci_number, (uword)sizeof(double), (dvoid *)&z ) );
+        success =
+            TRY(hand, OCINumberToReal(hand->errhp, oci_number,
+                                      (uword)sizeof(double), (dvoid *)&z));
       } else {
         hand->last_oci_status = MS_SUCCESS;
-        strlcpy( (char *)hand->last_oci_error, "Retrieve z value, but NULL value for z. Setting z to 0.", sizeof(hand->last_oci_error));
+        strlcpy((char *)hand->last_oci_error,
+                "Retrieve z value, but NULL value for z. Setting z to 0.",
+                sizeof(hand->last_oci_error));
         z = 0;
         success = 1;
       }
@@ -910,8 +1030,9 @@ static int msOCIGet3DOrdinates( msOracle
   return success ? n : 0;
 }
 
-static int msOCIGet4DOrdinates( msOracleSpatialHandler *hand, SDOGeometryObj *obj, int s, int e, pointObj *pt )
-{
+static int msOCIGet4DOrdinates(msOracleSpatialHandler *hand,
+                               SDOGeometryObj *obj, int s, int e,
+                               pointObj *pt) {
   double x, y;
   int i, n, success = 1;
   boolean exists;
@@ -919,26 +1040,36 @@ static int msOCIGet4DOrdinates( msOracle
   boolean numnull;
   OCINumber *oci_number;
 
-  for( i=s, n=0; i < e && success; i+=4, n++ ) {
-    success = TRY( hand,
-                   OCICollGetElem( hand->envhp, hand->errhp, (OCIColl *)obj->ordinates, (sb4)i, (boolean *)&exists, (dvoid *)&oci_number, (dvoid **)0 ) )
-              && TRY( hand,
-                      OCINumberToReal( hand->errhp, oci_number, (uword)sizeof(double), (dvoid *)&x ) )
-              && TRY( hand,
-                      OCICollGetElem( hand->envhp, hand->errhp, (OCIColl *)obj->ordinates, (sb4)i+1, (boolean *)&exists, (dvoid *)&oci_number, (dvoid **)0 ) )
-              && TRY( hand,
-                      OCINumberToReal( hand->errhp, oci_number, (uword)sizeof(double), (dvoid *)&y ) )
-              && TRY( hand,
-                      OCICollGetElem( hand->envhp, hand->errhp, (OCIColl *)obj->ordinates, (sb4)i+2, (boolean *)&exists, (dvoid *)&oci_number, (dvoid **)0 ) )
-              ;
+  for (i = s, n = 0; i < e && success; i += 4, n++) {
+    success = TRY(hand, OCICollGetElem(hand->envhp, hand->errhp,
+                                       (OCIColl *)obj->ordinates, (sb4)i,
+                                       (boolean *)&exists, (dvoid *)&oci_number,
+                                       (dvoid **)0)) &&
+              TRY(hand, OCINumberToReal(hand->errhp, oci_number,
+                                        (uword)sizeof(double), (dvoid *)&x)) &&
+              TRY(hand, OCICollGetElem(hand->envhp, hand->errhp,
+                                       (OCIColl *)obj->ordinates, (sb4)i + 1,
+                                       (boolean *)&exists, (dvoid *)&oci_number,
+                                       (dvoid **)0)) &&
+              TRY(hand, OCINumberToReal(hand->errhp, oci_number,
+                                        (uword)sizeof(double), (dvoid *)&y)) &&
+              TRY(hand, OCICollGetElem(hand->envhp, hand->errhp,
+                                       (OCIColl *)obj->ordinates, (sb4)i + 2,
+                                       (boolean *)&exists, (dvoid *)&oci_number,
+                                       (dvoid **)0));
 
     if (success) {
-      success = TRY(hand, OCINumberIsZero( hand->errhp, oci_number, (boolean *)&numnull));
+      success = TRY(
+          hand, OCINumberIsZero(hand->errhp, oci_number, (boolean *)&numnull));
       if (success) {
-        success = TRY( hand, OCINumberToReal( hand->errhp, oci_number, (uword)sizeof(double), (dvoid *)&z ) );
+        success =
+            TRY(hand, OCINumberToReal(hand->errhp, oci_number,
+                                      (uword)sizeof(double), (dvoid *)&z));
       } else {
         hand->last_oci_status = MS_SUCCESS;
-        strlcpy( (char *)hand->last_oci_error, "Retrieve z value, but NULL value for z. Setting z to 0.", sizeof(hand->last_oci_error));
+        strlcpy((char *)hand->last_oci_error,
+                "Retrieve z value, but NULL value for z. Setting z to 0.",
+                sizeof(hand->last_oci_error));
         z = 0;
         success = 1;
       }
@@ -954,8 +1085,7 @@ static int msOCIGet4DOrdinates( msOracle
 }
 
 /* convert three-point circle to two-point rectangular bounds */
-static int msOCIConvertCircle( pointObj *pt )
-{
+static int msOCIConvertCircle(pointObj *pt) {
   pointObj ptaux;
   double dXa, dXb;
   double ma, mb;
@@ -963,44 +1093,46 @@ static int msOCIConvertCircle( pointObj
   int success;
 
   dXa = pt[1].x - pt[0].x;
-  success = (fabs( dXa ) > 1e-8);
+  success = (fabs(dXa) > 1e-8);
   if (!success) {
     /* switch points 1 & 2 */
     ptaux = pt[1];
     pt[1] = pt[2];
     pt[2] = ptaux;
     dXa = pt[1].x - pt[0].x;
-    success = (fabs( dXa ) > 1e-8);
+    success = (fabs(dXa) > 1e-8);
   }
   if (success) {
     dXb = pt[2].x - pt[1].x;
-    success = (fabs( dXb ) > 1e-8);
+    success = (fabs(dXb) > 1e-8);
     if (!success) {
       /* insert point 2 before point 0 */
       ptaux = pt[2];
       pt[2] = pt[1];
       pt[1] = pt[0];
       pt[0] = ptaux;
-      dXb = dXa; /* segment A has become B */
+      dXb = dXa;               /* segment A has become B */
       dXa = pt[1].x - pt[0].x; /* recalculate new segment A */
-      success = (fabs( dXa ) > 1e-8);
+      success = (fabs(dXa) > 1e-8);
     }
   }
   if (success) {
-    ma = (pt[1].y - pt[0].y)/dXa;
-    mb = (pt[2].y - pt[1].y)/dXb;
-    success = (fabs( mb - ma ) > 1e-8);
+    ma = (pt[1].y - pt[0].y) / dXa;
+    mb = (pt[2].y - pt[1].y) / dXb;
+    success = (fabs(mb - ma) > 1e-8);
   }
   if (!success)
     return 0;
 
   /* calculate center and radius */
-  cx = (ma*mb*(pt[0].y - pt[2].y) + mb*(pt[0].x + pt[1].x) - ma*(pt[1].x + pt[2].x))/(2*(mb - ma));
-  cy = (fabs( ma ) > 1e-8)
-       ? ((pt[0].y + pt[1].y)/2 - (cx - (pt[0].x + pt[1].x)/2)/ma)
-       : ((pt[1].y + pt[2].y)/2 - (cx - (pt[1].x + pt[2].x)/2)/mb);
+  cx = (ma * mb * (pt[0].y - pt[2].y) + mb * (pt[0].x + pt[1].x) -
+        ma * (pt[1].x + pt[2].x)) /
+       (2 * (mb - ma));
+  cy = (fabs(ma) > 1e-8)
+           ? ((pt[0].y + pt[1].y) / 2 - (cx - (pt[0].x + pt[1].x) / 2) / ma)
+           : ((pt[1].y + pt[2].y) / 2 - (cx - (pt[1].x + pt[2].x) / 2) / mb);
 
-  r  = sqrt( pow( pt[0].x - cx, 2 ) + pow( pt[0].y - cy, 2 ) );
+  r = sqrt(pow(pt[0].x - cx, 2) + pow(pt[0].y - cy, 2));
 
   /* update pt buffer with rectangular bounds */
   pt[0].x = cx - r;
@@ -1012,16 +1144,17 @@ static int msOCIConvertCircle( pointObj
 }
 
 /*function that creates the correct sql for filter and filteritem*/
-static char * osFilteritem(layerObj *layer, int function, char *query_str, int mode)
-{
+static char *osFilteritem(layerObj *layer, int function, char *query_str,
+                          int mode) {
   if (layer->filter.native_string != NULL) {
     if (mode == 1) {
       query_str = msStringConcatenate(query_str, " WHERE ");
     } else {
       query_str = msStringConcatenate(query_str, " AND ");
     }
-    size_t tmpBufSize = (strlen(layer->filter.native_string) + 3) * sizeof(char);
-    char * tmpBuf = (char *) msSmallMalloc(tmpBufSize);
+    size_t tmpBufSize =
+        (strlen(layer->filter.native_string) + 3) * sizeof(char);
+    char *tmpBuf = (char *)msSmallMalloc(tmpBufSize);
     snprintf(tmpBuf, tmpBufSize, " %s ", layer->filter.native_string);
 
     query_str = msStringConcatenate(query_str, tmpBuf);
@@ -1037,51 +1170,53 @@ static char * osFilteritem(layerObj *lay
   }
 
   /* Handle a native filter set as a PROCESSING option (#5001). */
-  if ( msLayerGetProcessingKey(layer, "NATIVE_FILTER") != NULL ) {
-     if ((function == FUNCTION_NONE)&&(layer->filter.native_string == NULL)) {
-        query_str = msStringConcatenate(query_str, " WHERE ");
-     }
-     if ((function == FUNCTION_NONE)&&(layer->filter.native_string != NULL)) {
-        query_str = msStringConcatenate(query_str, " AND ");
-     }
-     size_t tmpSz;
-
-     const char * native_filter = msLayerGetProcessingKey(layer, "NATIVE_FILTER");
-     char * tmpBuf = NULL;
-
-     tmpSz = sizeof(char) * (strlen(native_filter) + 2 + 1);
-     tmpBuf = msSmallMalloc(tmpSz);
-
-     snprintf(tmpBuf, tmpSz, " %s ", native_filter);
-     query_str = msStringConcatenate(query_str, tmpBuf);
-     msFree(tmpBuf);
+  if (msLayerGetProcessingKey(layer, "NATIVE_FILTER") != NULL) {
+    if ((function == FUNCTION_NONE) && (layer->filter.native_string == NULL)) {
+      query_str = msStringConcatenate(query_str, " WHERE ");
+    }
+    if ((function == FUNCTION_NONE) && (layer->filter.native_string != NULL)) {
+      query_str = msStringConcatenate(query_str, " AND ");
+    }
+    size_t tmpSz;
+
+    const char *native_filter = msLayerGetProcessingKey(layer, "NATIVE_FILTER");
+    char *tmpBuf = NULL;
+
+    tmpSz = sizeof(char) * (strlen(native_filter) + 2 + 1);
+    tmpBuf = msSmallMalloc(tmpSz);
+
+    snprintf(tmpBuf, tmpSz, " %s ", native_filter);
+    query_str = msStringConcatenate(query_str, tmpBuf);
+    msFree(tmpBuf);
 
-     if (function != FUNCTION_NONE) {
+    if (function != FUNCTION_NONE) {
       query_str = msStringConcatenate(query_str, " AND ");
-     }
+    }
   }
   return query_str;
 }
 
-static char * osAggrGetExtent(layerObj *layer, char *query_str, char *geom_column_name, char *table_name)
-{
-  char * query_str2 = NULL;
+static char *osAggrGetExtent(layerObj *layer, char *query_str,
+                             char *geom_column_name, char *table_name) {
+  char *query_str2 = NULL;
   int i = 0;
 
   query_str2 = msStringConcatenate(query_str2, "(SELECT");
 
   for (i = 0; i < layer->numitems; ++i) {
-      size_t tmpSize = sizeof(char) * (strlen(layer->items[i]) + 1 /* '\0' */ + 2 /* " ", "," */);
-      char * tmpItem = (char *) msSmallMalloc(tmpSize);
-      snprintf(tmpItem, tmpSize, " %s,", layer->items[i]);
+    size_t tmpSize = sizeof(char) * (strlen(layer->items[i]) + 1 /* '\0' */ +
+                                     2 /* " ", "," */);
+    char *tmpItem = (char *)msSmallMalloc(tmpSize);
+    snprintf(tmpItem, tmpSize, " %s,", layer->items[i]);
 
-      query_str2 = msStringConcatenate(query_str2, tmpItem);
+    query_str2 = msStringConcatenate(query_str2, tmpItem);
 
-      msFree(tmpItem);
+    msFree(tmpItem);
   }
 
-  size_t tmpFromSize = sizeof(char) * (7 + strlen(geom_column_name) + strlen(table_name) + 1);
-  char * tmpFrom = msSmallMalloc(tmpFromSize);
+  size_t tmpFromSize =
+      sizeof(char) * (7 + strlen(geom_column_name) + strlen(table_name) + 1);
+  char *tmpFrom = msSmallMalloc(tmpFromSize);
   snprintf(tmpFrom, tmpFromSize, "%s FROM %s", geom_column_name, table_name);
 
   query_str2 = msStringConcatenate(query_str2, tmpFrom);
@@ -1104,33 +1239,34 @@ static char * osAggrGetExtent(layerObj *
   return query_str;
 }
 
-static double osCalculateArcRadius(pointObj *pnt)
-{
+static double osCalculateArcRadius(pointObj *pnt) {
   double rc;
   double r1, r2, r3;
 
-  r1 = sqrt( pow(pnt[0].x-pnt[1].x,2) + pow(pnt[0].y-pnt[1].y,2) );
-  r2 = sqrt( pow(pnt[1].x-pnt[2].x,2) + pow(pnt[1].y-pnt[2].y,2) );
-  r3 = sqrt( pow(pnt[2].x-pnt[0].x,2) + pow(pnt[2].y-pnt[0].y,2) );
-  rc = ( r1+r2+r3 )/2;
+  r1 = sqrt(pow(pnt[0].x - pnt[1].x, 2) + pow(pnt[0].y - pnt[1].y, 2));
+  r2 = sqrt(pow(pnt[1].x - pnt[2].x, 2) + pow(pnt[1].y - pnt[2].y, 2));
+  r3 = sqrt(pow(pnt[2].x - pnt[0].x, 2) + pow(pnt[2].y - pnt[0].y, 2));
+  rc = (r1 + r2 + r3) / 2;
 
-  return ( ( r1*r2*r3 )/( 4*sqrt( rc * (rc-r1) * (rc-r2) * (rc-r3) ) ) );
+  return ((r1 * r2 * r3) / (4 * sqrt(rc * (rc - r1) * (rc - r2) * (rc - r3))));
 }
 
-static void osCalculateArc(pointObj *pnt, int data3d, int data4d, double radius, double npoints, int side, lineObj arcline, shapeObj *shape)
-{
+static void osCalculateArc(pointObj *pnt, int data3d, int data4d, double radius,
+                           double npoints, int side, lineObj arcline,
+                           shapeObj *shape) {
   double length, ctrl, angle;
   double divbas, plusbas, cosbas, sinbas = 0;
   double zrange = 0;
   int i = 0;
 
-  if ( npoints > 0 ) {
-    length = sqrt(((pnt[1].x-pnt[0].x)*(pnt[1].x-pnt[0].x))+((pnt[1].y-pnt[0].y)*(pnt[1].y-pnt[0].y)));
-    ctrl = length/(2*radius);
+  if (npoints > 0) {
+    length = sqrt(((pnt[1].x - pnt[0].x) * (pnt[1].x - pnt[0].x)) +
+                  ((pnt[1].y - pnt[0].y) * (pnt[1].y - pnt[0].y)));
+    ctrl = length / (2 * radius);
 
-    if (data3d||data4d) {
+    if (data3d || data4d) {
       /* is this cast (long) legit... ? */
-      zrange = labs((long)(pnt[0].z-pnt[1].z))/npoints;
+      zrange = labs((long)(pnt[0].z - pnt[1].z)) / npoints;
       if ((pnt[0].z > pnt[1].z) && side == 1)
         zrange *= -1;
       else if ((pnt[0].z < pnt[1].z) && side == 1)
@@ -1141,69 +1277,73 @@ static void osCalculateArc(pointObj *pnt
         zrange = zrange;
     }
 
-    if( ctrl <= 1 ) {
+    if (ctrl <= 1) {
       divbas = 2 * asin(ctrl);
-      plusbas = divbas/(npoints);
-      cosbas = (pnt[0].x-pnt[3].x)/radius;
-      sinbas = (pnt[0].y-pnt[3].y)/radius;
+      plusbas = divbas / (npoints);
+      cosbas = (pnt[0].x - pnt[3].x) / radius;
+      sinbas = (pnt[0].y - pnt[3].y) / radius;
       angle = plusbas;
 
-      arcline.point = (pointObj *)malloc(sizeof(pointObj)*(npoints+1));
+      arcline.point = (pointObj *)malloc(sizeof(pointObj) * (npoints + 1));
       arcline.point[0].x = pnt[0].x;
       arcline.point[0].y = pnt[0].y;
-      if (data3d||data4d)
+      if (data3d || data4d)
         arcline.point[0].z = pnt[0].z;
 
       for (i = 1; i <= npoints; i++) {
-        if( side == 1) {
-          arcline.point[i].x = pnt[3].x + radius * ((cosbas*cos(angle))-(sinbas*sin(angle)));
-          arcline.point[i].y = pnt[3].y + radius * ((sinbas*cos(angle))+(cosbas*sin(angle)));
-          if (data3d||data4d)
-            arcline.point[i].z = pnt[0].z + (zrange*i);
+        if (side == 1) {
+          arcline.point[i].x = pnt[3].x + radius * ((cosbas * cos(angle)) -
+                                                    (sinbas * sin(angle)));
+          arcline.point[i].y = pnt[3].y + radius * ((sinbas * cos(angle)) +
+                                                    (cosbas * sin(angle)));
+          if (data3d || data4d)
+            arcline.point[i].z = pnt[0].z + (zrange * i);
         } else {
-          if ( side == -1) {
-            arcline.point[i].x = pnt[3].x + radius * ((cosbas*cos(angle))+(sinbas*sin(angle)));
-            arcline.point[i].y = pnt[3].y + radius * ((sinbas*cos(angle))-(cosbas*sin(angle)));
-            if (data3d||data4d)
-              arcline.point[i].z = pnt[0].z + (zrange*i);
+          if (side == -1) {
+            arcline.point[i].x = pnt[3].x + radius * ((cosbas * cos(angle)) +
+                                                      (sinbas * sin(angle)));
+            arcline.point[i].y = pnt[3].y + radius * ((sinbas * cos(angle)) -
+                                                      (cosbas * sin(angle)));
+            if (data3d || data4d)
+              arcline.point[i].z = pnt[0].z + (zrange * i);
           } else {
             arcline.point[i].x = pnt[0].x;
             arcline.point[i].y = pnt[0].y;
-            if (data3d||data4d)
+            if (data3d || data4d)
               arcline.point[i].z = pnt[0].z;
           }
         }
         angle += plusbas;
       }
 
-      arcline.numpoints = npoints+1;
-      msAddLine( shape, &arcline );
-      free (arcline.point);
+      arcline.numpoints = npoints + 1;
+      msAddLine(shape, &arcline);
+      free(arcline.point);
     }
   } else {
-    arcline.point = (pointObj *)malloc(sizeof(pointObj)*(2));
+    arcline.point = (pointObj *)malloc(sizeof(pointObj) * (2));
     arcline.point[0].x = pnt[0].x;
     arcline.point[0].y = pnt[0].y;
     arcline.point[1].x = pnt[1].x;
     arcline.point[1].y = pnt[1].y;
 
-    if(data3d||data4d) {
+    if (data3d || data4d) {
       arcline.point[0].z = pnt[0].z;
       arcline.point[1].z = pnt[1].z;
     }
 
     arcline.numpoints = 2;
 
-    msAddLine( shape, &arcline );
-    free (arcline.point);
+    msAddLine(shape, &arcline);
+    free(arcline.point);
   }
 }
 
 /* Part of this function was based on Terralib function TeGenerateArc
  * found in TeGeometryAlgorith.cpp (www.terralib.org).
  * Part of this function was based on Dr. Ialo (Univali/Cttmar) functions. */
-static void osGenerateArc(shapeObj *shape, lineObj arcline, lineObj points, int i, int data3d, int data4d)
-{
+static void osGenerateArc(shapeObj *shape, lineObj arcline, lineObj points,
+                          int i, int data3d, int data4d) {
   double mult, plus1, plus2, plus3, bpoint;
   double cx, cy;
   double radius, side, area, npoints;
@@ -1211,94 +1351,102 @@ static void osGenerateArc(shapeObj *shap
   double dist2 = 0;
   pointObj point5[4];
 
-  mult = ( points.point[i+1].x - points.point[i].x )
-         * ( points.point[i+2].y - points.point[i].y )
-         - ( points.point[i+1].y - points.point[i].y )
-         * ( points.point[i+2].x - points.point[i].x );
+  mult = (points.point[i + 1].x - points.point[i].x) *
+             (points.point[i + 2].y - points.point[i].y) -
+         (points.point[i + 1].y - points.point[i].y) *
+             (points.point[i + 2].x - points.point[i].x);
 
   if (mult) {
     /*point5 = (pointObj *)malloc(sizeof(pointObj)*(4));*/
 
-    plus1 = points.point[i].x * points.point[i].x + points.point[i].y * points.point[i].y;
-    plus2 = points.point[i+1].x * points.point[i+1].x + points.point[i+1].y * points.point[i+1].y;
-    plus3 = points.point[i+2].x * points.point[i+2].x + points.point[i+2].y * points.point[i+2].y;
-
-    bpoint = plus1 * ( points.point[i+1].y - points.point[i+2].y )
-             + plus2 * ( points.point[i+2].y - points.point[i].y )
-             + plus3 * ( points.point[i].y - points.point[i+1].y );
+    plus1 = points.point[i].x * points.point[i].x +
+            points.point[i].y * points.point[i].y;
+    plus2 = points.point[i + 1].x * points.point[i + 1].x +
+            points.point[i + 1].y * points.point[i + 1].y;
+    plus3 = points.point[i + 2].x * points.point[i + 2].x +
+            points.point[i + 2].y * points.point[i + 2].y;
+
+    bpoint = plus1 * (points.point[i + 1].y - points.point[i + 2].y) +
+             plus2 * (points.point[i + 2].y - points.point[i].y) +
+             plus3 * (points.point[i].y - points.point[i + 1].y);
 
     cx = bpoint / (2.0 * mult);
 
-    bpoint = plus1 * ( points.point[i+2].x - points.point[i+1].x )
-             + plus2 * ( points.point[i].x - points.point[i+2].x )
-             + plus3 * ( points.point[i+1].x - points.point[i].x );
+    bpoint = plus1 * (points.point[i + 2].x - points.point[i + 1].x) +
+             plus2 * (points.point[i].x - points.point[i + 2].x) +
+             plus3 * (points.point[i + 1].x - points.point[i].x);
 
     cy = bpoint / (2.0 * mult);
 
-    dist1 = (points.point[i+1].x - points.point[i].x) * (cy - points.point[i].y);
-    dist2 = (points.point[i+1].y - points.point[i].y) * (cx - points.point[i].x);
+    dist1 =
+        (points.point[i + 1].x - points.point[i].x) * (cy - points.point[i].y);
+    dist2 =
+        (points.point[i + 1].y - points.point[i].y) * (cx - points.point[i].x);
     side = 0;
 
-    if((dist1-dist2) > 0)
+    if ((dist1 - dist2) > 0)
       side = 1;
     else {
-      if((dist1-dist2) < 0)
+      if ((dist1 - dist2) < 0)
         side = -1;
     }
 
     point5[0] = points.point[i];
-    point5[1] = points.point[i+1];
-    point5[2] = points.point[i+2];
+    point5[1] = points.point[i + 1];
+    point5[2] = points.point[i + 2];
     point5[3].x = cx;
     point5[3].y = cy;
 
     radius = osCalculateArcRadius(point5);
 
-    area = ((points.point[i].x + points.point[i+1].x) * (points.point[i+1].y - points.point[i].y))
-           + ((points.point[i+1].x + points.point[i+2].x) * (points.point[i+2].y - points.point[i+1].y));
+    area = ((points.point[i].x + points.point[i + 1].x) *
+            (points.point[i + 1].y - points.point[i].y)) +
+           ((points.point[i + 1].x + points.point[i + 2].x) *
+            (points.point[i + 2].y - points.point[i + 1].y));
 
-    npoints = labs((long)(area/radius));
+    npoints = labs((long)(area / radius));
 
     point5[0] = points.point[i];
-    point5[1] = points.point[i+1];
-    osCalculateArc(point5, data3d, data4d, radius, (npoints>1000)?1000:npoints, side, arcline, shape);
-
-    point5[0] = points.point[i+1];
-    point5[1] = points.point[i+2];
-    osCalculateArc(point5, data3d, data4d, radius, (npoints>1000)?1000:npoints, side, arcline, shape);
+    point5[1] = points.point[i + 1];
+    osCalculateArc(point5, data3d, data4d, radius,
+                   (npoints > 1000) ? 1000 : npoints, side, arcline, shape);
+
+    point5[0] = points.point[i + 1];
+    point5[1] = points.point[i + 2];
+    osCalculateArc(point5, data3d, data4d, radius,
+                   (npoints > 1000) ? 1000 : npoints, side, arcline, shape);
 
   } else {
-    arcline.point = (pointObj *)malloc(sizeof(pointObj)*(2));
+    arcline.point = (pointObj *)malloc(sizeof(pointObj) * (2));
     arcline.point[0].x = points.point[i].x;
     arcline.point[0].y = points.point[i].y;
-    arcline.point[1].x = points.point[i+2].x;
-    arcline.point[1].y = points.point[i+2].y;
+    arcline.point[1].x = points.point[i + 2].x;
+    arcline.point[1].y = points.point[i + 2].y;
 
-    if (data3d||data4d) {
+    if (data3d || data4d) {
       arcline.point[0].z = points.point[i].z;
-      arcline.point[1].z = points.point[i+2].z;
+      arcline.point[1].z = points.point[i + 2].z;
     }
 
     arcline.numpoints = 2;
 
-    msAddLine( shape, &arcline );
-    free (arcline.point);
+    msAddLine(shape, &arcline);
+    free(arcline.point);
   }
 }
 
-static void osShapeBounds ( shapeObj *shp )
-{
+static void osShapeBounds(shapeObj *shp) {
   int i, f;
 
-  if ( (shp->numlines > 0) && (shp->line[0].numpoints > 0) ) {
+  if ((shp->numlines > 0) && (shp->line[0].numpoints > 0)) {
     shp->bounds.minx = shp->line[0].point[0].x;
     shp->bounds.maxx = shp->line[0].point[0].x;
     shp->bounds.miny = shp->line[0].point[0].y;
     shp->bounds.maxy = shp->line[0].point[0].y;
   }
 
-  for ( i = 0 ; i < shp->numlines; i++) {
-    for( f = 0; f < shp->line[i].numpoints; f++) {
+  for (i = 0; i < shp->numlines; i++) {
+    for (f = 0; f < shp->line[i].numpoints; f++) {
       if (shp->line[i].point[f].x < shp->bounds.minx)
         shp->bounds.minx = shp->line[i].point[f].x;
       if (shp->line[i].point[f].x > shp->bounds.maxx)
@@ -1311,184 +1459,196 @@ static void osShapeBounds ( shapeObj *sh
   }
 }
 
-static void osCloneShape(shapeObj *shape, shapeObj *newshape, int data3d, int data4d)
-{
+static void osCloneShape(shapeObj *shape, shapeObj *newshape, int data3d,
+                         int data4d) {
   int max_points = 0;
-  int i,f,g;
+  int i, f, g;
   lineObj shapeline = {0, NULL};
 
   for (i = 0; i < shape->numlines; i++)
     max_points += shape->line[i].numpoints;
 
   if (max_points > 0)
-    shapeline.point = (pointObj *)malloc( sizeof(pointObj)*max_points );
+    shapeline.point = (pointObj *)malloc(sizeof(pointObj) * max_points);
 
   g = 0;
-  for ( i = 0 ; i < shape->numlines; i++) {
-    for( f = 0; f < shape->line[i].numpoints && g <= max_points; f++, g++) {
+  for (i = 0; i < shape->numlines; i++) {
+    for (f = 0; f < shape->line[i].numpoints && g <= max_points; f++, g++) {
       shapeline.point[g].x = shape->line[i].point[f].x;
       shapeline.point[g].y = shape->line[i].point[f].y;
-      if (data3d||data4d)
+      if (data3d || data4d)
         shapeline.point[g].z = shape->line[i].point[f].z;
     }
   }
 
   if (g) {
     shapeline.numpoints = g;
-    newshape->type = shape->type; /* jimk: 2009/09/23 Fixes compound linestrings being converted to polygons */
-    msAddLine( newshape, &shapeline );
+    newshape->type = shape->type; /* jimk: 2009/09/23 Fixes compound linestrings
+                                     being converted to polygons */
+    msAddLine(newshape, &shapeline);
   }
 }
 
-static void osPointCluster(msOracleSpatialHandler *hand, shapeObj *shape, SDOGeometryObj *obj, int start, int end, lineObj points, int interpretation, int data3d, int data4d)
-{
+static void osPointCluster(msOracleSpatialHandler *hand, shapeObj *shape,
+                           SDOGeometryObj *obj, int start, int end,
+                           lineObj points, int interpretation, int data3d,
+                           int data4d) {
   int n;
 
-  n = (end - start)/2;
+  n = (end - start) / 2;
   /* n = interpretation; */
 
   /* if (n == interpretation) { */
-  points.point = (pointObj *)malloc( sizeof(pointObj)*n );
+  points.point = (pointObj *)malloc(sizeof(pointObj) * n);
 
   if (data3d)
-    n = msOCIGet3DOrdinates( hand, obj, start, end, points.point );
+    n = msOCIGet3DOrdinates(hand, obj, start, end, points.point);
   else if (data4d)
-    n = msOCIGet4DOrdinates( hand, obj, start, end, points.point );
+    n = msOCIGet4DOrdinates(hand, obj, start, end, points.point);
   else
-    n = msOCIGet2DOrdinates( hand, obj, start, end, points.point );
+    n = msOCIGet2DOrdinates(hand, obj, start, end, points.point);
 
-  if (n == interpretation && n>0) {
+  if (n == interpretation && n > 0) {
     shape->type = MS_SHAPE_POINT;
     points.numpoints = n;
-    msAddLine( shape, &points );
+    msAddLine(shape, &points);
   }
-  free( points.point );
+  free(points.point);
   /* } */
 }
 
-static void osPoint(msOracleSpatialHandler *hand, shapeObj *shape, SDOGeometryObj *obj, int start, int end, lineObj points, pointObj *pnt, int data3d, int data4d)
-{
+static void osPoint(msOracleSpatialHandler *hand, shapeObj *shape,
+                    SDOGeometryObj *obj, int start, int end, lineObj points,
+                    pointObj *pnt, int data3d, int data4d) {
   int n;
 
   if (data3d)
-    n = msOCIGet3DOrdinates( hand, obj, start, end, pnt );
+    n = msOCIGet3DOrdinates(hand, obj, start, end, pnt);
   else if (data4d)
-    n = msOCIGet4DOrdinates( hand, obj, start, end,  pnt );
+    n = msOCIGet4DOrdinates(hand, obj, start, end, pnt);
   else
-    n = msOCIGet2DOrdinates( hand, obj, start, end, pnt ); /* n must be < 5 */
+    n = msOCIGet2DOrdinates(hand, obj, start, end, pnt); /* n must be < 5 */
 
   if (n == 1) {
     shape->type = MS_SHAPE_POINT;
     points.numpoints = 1;
     points.point = pnt;
-    msAddLine( shape, &points );
+    msAddLine(shape, &points);
   }
 }
 
-static void osClosedPolygon(msOracleSpatialHandler *hand, shapeObj *shape, SDOGeometryObj *obj, int start, int end, lineObj points, int elem_type, int data3d, int data4d)
-{
+static void osClosedPolygon(msOracleSpatialHandler *hand, shapeObj *shape,
+                            SDOGeometryObj *obj, int start, int end,
+                            lineObj points, int elem_type, int data3d,
+                            int data4d) {
   int n;
 
-  n = (end - start)/2;
-  points.point = (pointObj *)malloc( sizeof(pointObj)*n );
+  n = (end - start) / 2;
+  points.point = (pointObj *)malloc(sizeof(pointObj) * n);
 
   if (data3d)
-    n = msOCIGet3DOrdinates( hand, obj, start, end, points.point );
+    n = msOCIGet3DOrdinates(hand, obj, start, end, points.point);
   else if (data4d)
-    n = msOCIGet4DOrdinates( hand, obj, start, end, points.point );
+    n = msOCIGet4DOrdinates(hand, obj, start, end, points.point);
   else
-    n = msOCIGet2DOrdinates( hand, obj, start, end, points.point );
+    n = msOCIGet2DOrdinates(hand, obj, start, end, points.point);
 
   if (n > 0) {
-    shape->type = (elem_type==21) ? MS_SHAPE_LINE : MS_SHAPE_POLYGON;
+    shape->type = (elem_type == 21) ? MS_SHAPE_LINE : MS_SHAPE_POLYGON;
     points.numpoints = n;
-    msAddLine( shape, &points );
+    msAddLine(shape, &points);
   }
-  free( points.point );
+  free(points.point);
 }
 
-static void osRectangle(msOracleSpatialHandler *hand, shapeObj *shape, SDOGeometryObj *obj, int start, int end, lineObj points, pointObj *pnt, int data3d, int data4d)
-{
+static void osRectangle(msOracleSpatialHandler *hand, shapeObj *shape,
+                        SDOGeometryObj *obj, int start, int end, lineObj points,
+                        pointObj *pnt, int data3d, int data4d) {
   int n;
 
   if (data3d)
-    n = msOCIGet3DOrdinates( hand, obj, start, end, pnt ); /* n must be < 5 */
+    n = msOCIGet3DOrdinates(hand, obj, start, end, pnt); /* n must be < 5 */
   else if (data4d)
-    n = msOCIGet4DOrdinates( hand, obj, start, end, pnt ); /* n must be < 5 */
+    n = msOCIGet4DOrdinates(hand, obj, start, end, pnt); /* n must be < 5 */
   else
-    n = msOCIGet2DOrdinates( hand, obj, start, end, pnt ); /* n must be < 5 */
+    n = msOCIGet2DOrdinates(hand, obj, start, end, pnt); /* n must be < 5 */
 
   if (n == 2) {
     shape->type = MS_SHAPE_POLYGON;
     points.numpoints = 5;
     points.point = pnt;
 
-    /* point5 [0] & [1] contains the lower-left and upper-right points of the rectangle */
+    /* point5 [0] & [1] contains the lower-left and upper-right points of the
+     * rectangle */
     pnt[2] = pnt[1];
     pnt[1].x = pnt[0].x;
     pnt[3].x = pnt[2].x;
     pnt[3].y = pnt[0].y;
     pnt[4] = pnt[0];
-    if (data3d||data4d) {
+    if (data3d || data4d) {
       pnt[1].z = pnt[0].z;
       pnt[3].z = pnt[2].z;
     }
 
-    msAddLine( shape, &points );
+    msAddLine(shape, &points);
   }
 }
 
-static void osCircle(msOracleSpatialHandler *hand, shapeObj *shape, SDOGeometryObj *obj, int start, int end, lineObj points, pointObj *pnt, int data3d, int data4d)
-{
+static void osCircle(msOracleSpatialHandler *hand, shapeObj *shape,
+                     SDOGeometryObj *obj, int start, int end, lineObj points,
+                     pointObj *pnt, int data3d, int data4d) {
   int n;
 
   if (data3d)
-    n = msOCIGet3DOrdinates( hand, obj, start, end, pnt ); /* n must be < 5 */
+    n = msOCIGet3DOrdinates(hand, obj, start, end, pnt); /* n must be < 5 */
   else if (data4d)
-    n = msOCIGet4DOrdinates( hand, obj, start, end, pnt ); /* n must be < 5 */
+    n = msOCIGet4DOrdinates(hand, obj, start, end, pnt); /* n must be < 5 */
   else
-    n = msOCIGet2DOrdinates( hand, obj, start, end, pnt ); /* n must be < 5 */
+    n = msOCIGet2DOrdinates(hand, obj, start, end, pnt); /* n must be < 5 */
 
   if (n == 3) {
-    if (msOCIConvertCircle( pnt )) {
+    if (msOCIConvertCircle(pnt)) {
       shape->type = MS_SHAPE_POINT;
       points.numpoints = 2;
       points.point = pnt;
-      msAddLine( shape, &points );
+      msAddLine(shape, &points);
     } else {
-      strlcpy( (char *)hand->last_oci_error, "Points in circle object are colinear", sizeof(hand->last_oci_error));
+      strlcpy((char *)hand->last_oci_error,
+              "Points in circle object are colinear",
+              sizeof(hand->last_oci_error));
       hand->last_oci_status = MS_FAILURE;
     }
   }
 }
 
-static void osArcPolygon(msOracleSpatialHandler *hand, shapeObj *shape, SDOGeometryObj *obj, int start, int end, lineObj arcpoints, int elem_type, int data3d, int data4d)
-{
+static void osArcPolygon(msOracleSpatialHandler *hand, shapeObj *shape,
+                         SDOGeometryObj *obj, int start, int end,
+                         lineObj arcpoints, int elem_type, int data3d,
+                         int data4d) {
   int n, i;
   lineObj points = {0, NULL};
 
-  n = (end - start)/2;
-  points.point = (pointObj *)malloc( sizeof(pointObj)*n );
+  n = (end - start) / 2;
+  points.point = (pointObj *)malloc(sizeof(pointObj) * n);
 
   if (data3d)
-    n = msOCIGet3DOrdinates( hand, obj, start, end, points.point );
+    n = msOCIGet3DOrdinates(hand, obj, start, end, points.point);
   else if (data4d)
-    n = msOCIGet4DOrdinates( hand, obj, start, end, points.point );
+    n = msOCIGet4DOrdinates(hand, obj, start, end, points.point);
   else
-    n = msOCIGet2DOrdinates( hand, obj, start, end, points.point );
+    n = msOCIGet2DOrdinates(hand, obj, start, end, points.point);
 
   if (n > 2) {
-    shape->type = (elem_type==32) ? MS_SHAPE_POLYGON : MS_SHAPE_LINE;
+    shape->type = (elem_type == 32) ? MS_SHAPE_POLYGON : MS_SHAPE_LINE;
     points.numpoints = n;
 
-    for (i = 0; i < n-2; i = i+2)
+    for (i = 0; i < n - 2; i = i + 2)
       osGenerateArc(shape, arcpoints, points, i, data3d, data4d);
   }
-  free (points.point);
+  free(points.point);
 }
 
-static int osCheck2DGtype(int pIntGtype)
-{
+static int osCheck2DGtype(int pIntGtype) {
   if (pIntGtype > 2000 && pIntGtype < 2008) {
     if (pIntGtype != 2004)
       return MS_TRUE;
@@ -1497,42 +1657,38 @@ static int osCheck2DGtype(int pIntGtype)
   return MS_FALSE;
 }
 
-static int osCheck3DGtype(int pIntGtype)
-{
+static int osCheck3DGtype(int pIntGtype) {
   if (pIntGtype > 3000 && pIntGtype < 3308) {
     if (pIntGtype > 3007)
-      pIntGtype-= 300;
+      pIntGtype -= 300;
 
     if (pIntGtype <= 3007 && pIntGtype != 3004)
       return MS_TRUE;
   }
   /*
-  * Future version, untested
-  * return (pIntGtype & 2208 && (pIntGtype & 3000 || pIntGtype & 3296) && pIntGtype & 3);
-  */
+   * Future version, untested
+   * return (pIntGtype & 2208 && (pIntGtype & 3000 || pIntGtype & 3296) &&
+   * pIntGtype & 3);
+   */
   return MS_FALSE;
 }
 
-static int osCheck4DGtype(int pIntGtype)
-{
+static int osCheck4DGtype(int pIntGtype) {
 
   if (pIntGtype > 4000 && pIntGtype < 4408) {
     if (pIntGtype > 4007)
-      pIntGtype-= 400;
+      pIntGtype -= 400;
 
     if (pIntGtype <= 4007 && pIntGtype != 4004)
       return MS_TRUE;
-
-
   }
 
   return MS_FALSE;
 }
 
-
-
-static int osGetOrdinates(msOracleSpatialDataHandler *dthand, msOracleSpatialHandler *hand, shapeObj *shape, SDOGeometryObj *obj, SDOGeometryInd *ind)
-{
+static int osGetOrdinates(msOracleSpatialDataHandler *dthand,
+                          msOracleSpatialHandler *hand, shapeObj *shape,
+                          SDOGeometryObj *obj, SDOGeometryInd *ind) {
   int gtype, elem_type, compound_type;
   float compound_lenght, compound_count;
   ub4 etype;
@@ -1546,7 +1702,7 @@ static int osGetOrdinates(msOracleSpatia
   int success;
   lineObj points = {0, NULL};
   pointObj point5[5]; /* for quick access */
-  shapeObj newshape; /* for compound polygons */
+  shapeObj newshape;  /* for compound polygons */
 
   /*stat the variables for compound polygons*/
   compound_lenght = 0;
@@ -1557,32 +1713,49 @@ static int osGetOrdinates(msOracleSpatia
 
   if (ind->_atomic != OCI_IND_NULL) { /* not a null object */
     nelems = nords = 0;
-    success = TRY( hand, OCICollSize( hand->envhp, hand->errhp, (OCIColl *)obj->elem_info, &nelems ) )
-              && TRY( hand, OCICollSize( hand->envhp, hand->errhp, (OCIColl *)obj->ordinates, &nords ) )
-              && TRY( hand, OCINumberToInt( hand->errhp, &(obj->gtype), (uword)sizeof(int), OCI_NUMBER_SIGNED, (dvoid *)&gtype ) );
-    /*&& (nords%2==0 && nelems%3==0);*/ /* check %2==0 for 2D geometries; and %3==0 for element info triplets */
+    success =
+        TRY(hand, OCICollSize(hand->envhp, hand->errhp,
+                              (OCIColl *)obj->elem_info, &nelems)) &&
+        TRY(hand, OCICollSize(hand->envhp, hand->errhp,
+                              (OCIColl *)obj->ordinates, &nords)) &&
+        TRY(hand, OCINumberToInt(hand->errhp, &(obj->gtype), (uword)sizeof(int),
+                                 OCI_NUMBER_SIGNED, (dvoid *)&gtype));
+    /*&& (nords%2==0 && nelems%3==0);*/ /* check %2==0 for 2D geometries; and
+                                           %3==0 for element info triplets */
 
     if (success && osCheck2DGtype(gtype)) {
-      success = (nords%2==0 && nelems%3==0)?1:0; /* check %2==0 for 2D geometries; and %3==0 for element info triplets */
+      success = (nords % 2 == 0 && nelems % 3 == 0)
+                    ? 1
+                    : 0; /* check %2==0 for 2D geometries; and %3==0 for element
+                            info triplets */
     } else if (success && osCheck3DGtype(gtype)) {
-      success = (nords%3==0 && nelems%3==0)?1:0; /* check %2==0 for 2D geometries; and %3==0 for element info triplets */
+      success = (nords % 3 == 0 && nelems % 3 == 0)
+                    ? 1
+                    : 0; /* check %2==0 for 2D geometries; and %3==0 for element
+                            info triplets */
       data3d = 1;
 
     } else if (success && osCheck4DGtype(gtype)) {
-      success = (nords%4==0 && nelems%3==0)?1:0; /* check %2==0 for 2D geometries; and %3==0 for element info triplets */
+      success = (nords % 4 == 0 && nelems % 3 == 0)
+                    ? 1
+                    : 0; /* check %2==0 for 2D geometries; and %3==0 for element
+                            info triplets */
       data4d = 1;
     }
 
-
     if (success) {
       /* reading SDO_POINT from SDO_GEOMETRY for a 2D/3D point geometry */
-      if ((gtype==2001 || gtype==3001 || gtype==4001 ) && ind->point._atomic == OCI_IND_NOTNULL && ind->point.x == OCI_IND_NOTNULL && ind->point.y == OCI_IND_NOTNULL) {
-
-
-        success = TRY( hand, OCINumberToReal( hand->errhp, &(obj->point.x), (uword)sizeof(double), (dvoid *)&x ) )
-                  && TRY( hand, OCINumberToReal( hand->errhp, &(obj->point.y), (uword)sizeof(double), (dvoid *)&y ) );
+      if ((gtype == 2001 || gtype == 3001 || gtype == 4001) &&
+          ind->point._atomic == OCI_IND_NOTNULL &&
+          ind->point.x == OCI_IND_NOTNULL && ind->point.y == OCI_IND_NOTNULL) {
+
+        success =
+            TRY(hand, OCINumberToReal(hand->errhp, &(obj->point.x),
+                                      (uword)sizeof(double), (dvoid *)&x)) &&
+            TRY(hand, OCINumberToReal(hand->errhp, &(obj->point.y),
+                                      (uword)sizeof(double), (dvoid *)&y));
 
-        if (ERROR( "osGetOrdinates()", hand, dthand ))
+        if (ERROR("osGetOrdinates()", hand, dthand))
           return MS_FAILURE;
 
         shape->type = MS_SHAPE_POINT;
@@ -1593,87 +1766,131 @@ static int osGetOrdinates(msOracleSpatia
         point5[0].y = y;
         if (data3d || data4d) {
           if (ind->point.z == OCI_IND_NOTNULL) {
-            success = TRY( hand, OCINumberToReal( hand->errhp, &(obj->point.z), (uword)sizeof(double), (dvoid *)&z ));
-            if (ERROR( "osGetOrdinates()", hand, dthand ))
+            success =
+                TRY(hand, OCINumberToReal(hand->errhp, &(obj->point.z),
+                                          (uword)sizeof(double), (dvoid *)&z));
+            if (ERROR("osGetOrdinates()", hand, dthand))
               return MS_FAILURE;
             else
               point5[0].z = z;
           } else
             point5[0].z = z;
         }
-        msAddLine( shape, &points );
+        msAddLine(shape, &points);
         return MS_SUCCESS;
       }
-      /* if SDO_POINT not fetched, proceed reading elements (element info/ordinates) */
-      success = TRY( hand, OCICollGetElem( hand->envhp, hand->errhp, (OCIColl *)obj->elem_info,(sb4)0, (boolean *)&exists, (dvoid *)&oci_number, (dvoid **)0 ) )
-                && TRY( hand, OCINumberToInt( hand->errhp, oci_number, (uword)sizeof(ub4), OCI_NUMBER_SIGNED, (dvoid *)&ord_end ) );
+      /* if SDO_POINT not fetched, proceed reading elements (element
+       * info/ordinates) */
+      success =
+          TRY(hand, OCICollGetElem(hand->envhp, hand->errhp,
+                                   (OCIColl *)obj->elem_info, (sb4)0,
+                                   (boolean *)&exists, (dvoid *)&oci_number,
+                                   (dvoid **)0)) &&
+          TRY(hand, OCINumberToInt(hand->errhp, oci_number, (uword)sizeof(ub4),
+                                   OCI_NUMBER_SIGNED, (dvoid *)&ord_end));
 
       elem = 0;
       ord_end--; /* shifts offset from 1..n to 0..n-1 */
 
       do {
         ord_start = ord_end;
-        if (elem+3 >= nelems) { /* processing last element */
+        if (elem + 3 >= nelems) { /* processing last element */
           ord_end = nords;
           success = 1;
-        } else { /* get start ordinate position for next element which is ord_end for this element */
-          success = TRY( hand, OCICollGetElem( hand->envhp, hand->errhp, (OCIColl *)obj->elem_info, (sb4)elem+3, (boolean *)&exists, (dvoid *)&oci_number, (dvoid **)0 ) )
-                    && TRY( hand, OCINumberToInt( hand->errhp, oci_number, (uword)sizeof(ub4), OCI_NUMBER_SIGNED, (dvoid *)&ord_end ) );
+        } else { /* get start ordinate position for next element which is
+                    ord_end for this element */
+          success =
+              TRY(hand, OCICollGetElem(hand->envhp, hand->errhp,
+                                       (OCIColl *)obj->elem_info, (sb4)elem + 3,
+                                       (boolean *)&exists, (dvoid *)&oci_number,
+                                       (dvoid **)0)) &&
+              TRY(hand,
+                  OCINumberToInt(hand->errhp, oci_number, (uword)sizeof(ub4),
+                                 OCI_NUMBER_SIGNED, (dvoid *)&ord_end));
 
           ord_end--; /* shifts offset from 1..n to 0..n-1 */
         }
-        success = (success
-                   && TRY( hand, OCICollGetElem( hand->envhp, hand->errhp, (OCIColl *)obj->elem_info, (sb4)elem+1, (boolean *)&exists, (dvoid *)&oci_number, (dvoid **)0) )
-                   && TRY( hand, OCINumberToInt( hand->errhp, oci_number, (uword)sizeof(ub4), OCI_NUMBER_UNSIGNED, (dvoid *)&etype ) )
-                   && TRY( hand, OCICollGetElem( hand->envhp, hand->errhp, (OCIColl *)obj->elem_info, (sb4)elem+2, (boolean *)&exists, (dvoid *)&oci_number, (dvoid **)0 ) )
-                   && TRY( hand, OCINumberToInt( hand->errhp, oci_number, (uword)sizeof(ub4), OCI_NUMBER_UNSIGNED, (dvoid *)&interpretation ) ));
+        success =
+            (success &&
+             TRY(hand, OCICollGetElem(hand->envhp, hand->errhp,
+                                      (OCIColl *)obj->elem_info, (sb4)elem + 1,
+                                      (boolean *)&exists, (dvoid *)&oci_number,
+                                      (dvoid **)0)) &&
+             TRY(hand,
+                 OCINumberToInt(hand->errhp, oci_number, (uword)sizeof(ub4),
+                                OCI_NUMBER_UNSIGNED, (dvoid *)&etype)) &&
+             TRY(hand, OCICollGetElem(hand->envhp, hand->errhp,
+                                      (OCIColl *)obj->elem_info, (sb4)elem + 2,
+                                      (boolean *)&exists, (dvoid *)&oci_number,
+                                      (dvoid **)0)) &&
+             TRY(hand, OCINumberToInt(hand->errhp, oci_number,
+                                      (uword)sizeof(ub4), OCI_NUMBER_UNSIGNED,
+                                      (dvoid *)&interpretation)));
 
-        if (ERROR( "osGetOrdinates()", hand, dthand ))
+        if (ERROR("osGetOrdinates()", hand, dthand))
           return MS_FAILURE;
 
-        if ( etype == 1005 || etype == 2005  || etype == 4 ) {
+        if (etype == 1005 || etype == 2005 || etype == 4) {
           compound_type = 1;
           compound_lenght = interpretation;
           compound_count = 0;
           msInitShape(&newshape);
         }
 
-        elem_type = (etype == 1 && interpretation > 1) ? 10 : ((etype%10)*10 + interpretation);
+        elem_type = (etype == 1 && interpretation > 1)
+                        ? 10
+                        : ((etype % 10) * 10 + interpretation);
 
-
-        /* msDebug("osGetOrdinates shape->index = %ld\telem_type =  %d\n",shape->index, elem_type); */
+        /* msDebug("osGetOrdinates shape->index = %ld\telem_type =
+         * %d\n",shape->index, elem_type); */
 
         switch (elem_type) {
-          case 10: /* point cluster with 'interpretation'-points */
-            osPointCluster (hand, shape, obj, ord_start, ord_end, points, interpretation, data3d, data4d);
-            break;
-          case 11: /* point type */
-            osPoint(hand, shape, obj, ord_start, ord_end, points, point5, data3d, data4d);
-            break;
-          case 21: /* line string whose vertices are connected by straight line segments */
-            if (compound_type)
-              osClosedPolygon(hand, &newshape, obj, ord_start, (compound_count<compound_lenght)?ord_end+2:ord_end, points, elem_type, data3d, data4d);
-            else
-              osClosedPolygon(hand, shape, obj, ord_start, ord_end, points, elem_type, data3d, data4d);
-            break;
-          case 22: /* compound type */
-            if (compound_type)
-              osArcPolygon(hand, &newshape, obj, ord_start, (compound_count<compound_lenght)?ord_end+2:ord_end , points, elem_type, data3d, data4d);
-            else
-              osArcPolygon(hand, shape, obj, ord_start, ord_end, points, elem_type, data3d, data4d);
-            break;
-          case 31: /* simple polygon with n points, last point equals the first one */
-            osClosedPolygon(hand, shape, obj, ord_start, ord_end, points, elem_type, data3d, data4d);
-            break;
-          case 32: /* Polygon with arcs */
-            osArcPolygon(hand, shape, obj, ord_start, ord_end, points, elem_type, data3d, data4d);
-            break;
-          case 33: /* rectangle defined by 2 points */
-            osRectangle(hand, shape, obj, ord_start, ord_end, points, point5, data3d, data4d);
-            break;
-          case 34: /* circle defined by 3 points */
-            osCircle(hand, shape, obj, ord_start, ord_end, points, point5, data3d, data4d);
-            break;
+        case 10: /* point cluster with 'interpretation'-points */
+          osPointCluster(hand, shape, obj, ord_start, ord_end, points,
+                         interpretation, data3d, data4d);
+          break;
+        case 11: /* point type */
+          osPoint(hand, shape, obj, ord_start, ord_end, points, point5, data3d,
+                  data4d);
+          break;
+        case 21: /* line string whose vertices are connected by straight line
+                    segments */
+          if (compound_type)
+            osClosedPolygon(hand, &newshape, obj, ord_start,
+                            (compound_count < compound_lenght) ? ord_end + 2
+                                                               : ord_end,
+                            points, elem_type, data3d, data4d);
+          else
+            osClosedPolygon(hand, shape, obj, ord_start, ord_end, points,
+                            elem_type, data3d, data4d);
+          break;
+        case 22: /* compound type */
+          if (compound_type)
+            osArcPolygon(hand, &newshape, obj, ord_start,
+                         (compound_count < compound_lenght) ? ord_end + 2
+                                                            : ord_end,
+                         points, elem_type, data3d, data4d);
+          else
+            osArcPolygon(hand, shape, obj, ord_start, ord_end, points,
+                         elem_type, data3d, data4d);
+          break;
+        case 31: /* simple polygon with n points, last point equals the first
+                    one */
+          osClosedPolygon(hand, shape, obj, ord_start, ord_end, points,
+                          elem_type, data3d, data4d);
+          break;
+        case 32: /* Polygon with arcs */
+          osArcPolygon(hand, shape, obj, ord_start, ord_end, points, elem_type,
+                       data3d, data4d);
+          break;
+        case 33: /* rectangle defined by 2 points */
+          osRectangle(hand, shape, obj, ord_start, ord_end, points, point5,
+                      data3d, data4d);
+          break;
+        case 34: /* circle defined by 3 points */
+          osCircle(hand, shape, obj, ord_start, ord_end, points, point5, data3d,
+                   data4d);
+          break;
         }
 
         if (compound_count >= compound_lenght) {
@@ -1681,7 +1898,7 @@ static int osGetOrdinates(msOracleSpatia
           msFreeShape(&newshape);
         }
 
-        if (ERROR( "osGetOrdinates()", hand, dthand ))
+        if (ERROR("osGetOrdinates()", hand, dthand))
           return MS_FAILURE;
 
         /* prepare for next cycle */
@@ -1692,10 +1909,10 @@ static int osGetOrdinates(msOracleSpatia
           compound_count++;
 
       } while (elem < nelems); /* end of element loop */
-    } /* end of gtype big-if */
-  } /* end of not-null-object if */
+    }                          /* end of gtype big-if */
+  }                            /* end of not-null-object if */
 
-  if (compound_type){
+  if (compound_type) {
     if (gtype == 2003 || gtype == 2007)
       shape->type = MS_SHAPE_POLYGON;
     msFreeShape(&newshape);
@@ -1704,97 +1921,111 @@ static int osGetOrdinates(msOracleSpatia
   return MS_SUCCESS;
 }
 
-static void msOCICloseConnection( void *hand )
-{
-  msOCICloseHandlers( (msOracleSpatialHandler *)hand );
+static void msOCICloseConnection(void *hand) {
+  msOCICloseHandlers((msOracleSpatialHandler *)hand);
 }
 
-/* opens a layer by connecting to db with username/password@database stored in layer->connection */
-int msOracleSpatialLayerOpen( layerObj *layer )
-{
-  char *username = NULL, *password = NULL, *dblink =  NULL;
+/* opens a layer by connecting to db with username/password@database stored in
+ * layer->connection */
+int msOracleSpatialLayerOpen(layerObj *layer) {
+  char *username = NULL, *password = NULL, *dblink = NULL;
 
   msOracleSpatialLayerInfo *layerinfo = NULL;
   msOracleSpatialDataHandler *dthand = NULL;
   msOracleSpatialStatement *sthand = NULL, *sthand2 = NULL;
   msOracleSpatialHandler *hand = NULL;
 
-  if (layer->debug >=2)
-    msDebug("msOracleSpatialLayerOpen called with: %s (Layer pointer %p)\n",layer->data, layer);
+  if (layer->debug >= 2)
+    msDebug("msOracleSpatialLayerOpen called with: %s (Layer pointer %p)\n",
+            layer->data, layer);
 
   if (layer->layerinfo != NULL) /* Skip if layer is already open */
     return MS_SUCCESS;
 
   if (layer->data == NULL) {
-    msDebug(    "Error parsing OracleSpatial DATA variable. Must be:"
-                "'geometry_column FROM table_name [USING UNIQUE <column> SRID srid# FUNCTION]' or "
-                "'geometry_column FROM (SELECT stmt) [USING UNIQUE <column> SRID srid# FUNCTION]'."
-                "If want to set the FUNCTION statement you can use: FILTER, RELATE, GEOMRELATE or NONE.\n");
-    msSetError( MS_ORACLESPATIALERR,
-                "Error parsing OracleSpatial DATA variable. More info in server logs", "msOracleSpatialLayerOpen()");
+    msDebug("Error parsing OracleSpatial DATA variable. Must be:"
+            "'geometry_column FROM table_name [USING UNIQUE <column> SRID "
+            "srid# FUNCTION]' or "
+            "'geometry_column FROM (SELECT stmt) [USING UNIQUE <column> SRID "
+            "srid# FUNCTION]'."
+            "If want to set the FUNCTION statement you can use: FILTER, "
+            "RELATE, GEOMRELATE or NONE.\n");
+    msSetError(
+        MS_ORACLESPATIALERR,
+        "Error parsing OracleSpatial DATA variable. More info in server logs",
+        "msOracleSpatialLayerOpen()");
 
     return MS_FAILURE;
   }
 
-  layerinfo = (msOracleSpatialLayerInfo *)malloc(sizeof(msOracleSpatialLayerInfo));
-  dthand = (msOracleSpatialDataHandler *)malloc(sizeof(msOracleSpatialDataHandler));
+  layerinfo =
+      (msOracleSpatialLayerInfo *)malloc(sizeof(msOracleSpatialLayerInfo));
+  dthand =
+      (msOracleSpatialDataHandler *)malloc(sizeof(msOracleSpatialDataHandler));
   sthand = (msOracleSpatialStatement *)malloc(sizeof(msOracleSpatialStatement));
-  sthand2 = (msOracleSpatialStatement *)malloc(sizeof(msOracleSpatialStatement));
+  sthand2 =
+      (msOracleSpatialStatement *)malloc(sizeof(msOracleSpatialStatement));
 
   if ((dthand == NULL) || (layerinfo == NULL)) {
     msSetError(MS_MEMERR, NULL, "msOracleSpatialLayerOpen()");
     return MS_FAILURE;
   }
 
-  memset( dthand, 0, sizeof(msOracleSpatialDataHandler) );
-  memset( sthand, 0, sizeof(msOracleSpatialStatement) );
-  memset( sthand2, 0, sizeof(msOracleSpatialStatement) );
-  memset( layerinfo, 0, sizeof(msOracleSpatialLayerInfo) );
+  memset(dthand, 0, sizeof(msOracleSpatialDataHandler));
+  memset(sthand, 0, sizeof(msOracleSpatialStatement));
+  memset(sthand2, 0, sizeof(msOracleSpatialStatement));
+  memset(layerinfo, 0, sizeof(msOracleSpatialLayerInfo));
   layerinfo->paging = MS_TRUE;
 
-  msSplitLogin( layer->connection, layer->map, &username, &password, &dblink );
+  msSplitLogin(layer->connection, layer->map, &username, &password, &dblink);
 
-  hand = (msOracleSpatialHandler *) msConnPoolRequest( layer );
+  hand = (msOracleSpatialHandler *)msConnPoolRequest(layer);
 
-  if( hand == NULL ) {
+  if (hand == NULL) {
 
-    hand = msOCISetHandlers( username, password, dblink );
+    hand = msOCISetHandlers(username, password, dblink);
 
     if (hand == NULL) {
-      msOCICloseDataHandlers( dthand );
-      msOCIFinishStatement( sthand );
-      msOCIFinishStatement( sthand2 );
-      msOCIClearLayerInfo( layerinfo );
-
-      if (username) free(username);
-      if (password) free(password);
-      if (dblink) free(dblink);
+      msOCICloseDataHandlers(dthand);
+      msOCIFinishStatement(sthand);
+      msOCIFinishStatement(sthand2);
+      msOCIClearLayerInfo(layerinfo);
+
+      if (username)
+        free(username);
+      if (password)
+        free(password);
+      if (dblink)
+        free(dblink);
 
       return MS_FAILURE;
     }
 
-    if ( layer->debug >=2)
-      msDebug("msOracleSpatialLayerOpen. Shared connection not available. Creating one.\n");
+    if (layer->debug >= 2)
+      msDebug("msOracleSpatialLayerOpen. Shared connection not available. "
+              "Creating one.\n");
 
-    msConnPoolRegister( layer, hand, msOCICloseConnection );
+    msConnPoolRegister(layer, hand, msOCICloseConnection);
   } else {
     hand->ref_count++;
     hand->last_oci_status = MS_SUCCESS;
     hand->last_oci_error[0] = (text)'\0';
   }
 
-  if (!(msOCISetDataHandlers(hand, dthand) & msOCIOpenStatement(hand, sthand) & msOCIOpenStatement(hand, sthand2))) {
-    msSetError( MS_ORACLESPATIALERR,
-                "Cannot create OCI LayerInfo. "
-                "Connection failure.",
-                "msOracleSpatialLayerOpen()");
-
-    if (layer->debug>=2)
-      msDebug("msOracleSpatialLayerOpen. Cannot create OCI LayerInfo. Connection failure.\n");
-
-    msOCICloseDataHandlers ( dthand );
-    msOCICloseHandlers( hand );
-    msOCIClearLayerInfo( layerinfo );
+  if (!(msOCISetDataHandlers(hand, dthand) & msOCIOpenStatement(hand, sthand) &
+        msOCIOpenStatement(hand, sthand2))) {
+    msSetError(MS_ORACLESPATIALERR,
+               "Cannot create OCI LayerInfo. "
+               "Connection failure.",
+               "msOracleSpatialLayerOpen()");
+
+    if (layer->debug >= 2)
+      msDebug("msOracleSpatialLayerOpen. Cannot create OCI LayerInfo. "
+              "Connection failure.\n");
+
+    msOCICloseDataHandlers(dthand);
+    msOCICloseHandlers(hand);
+    msOCIClearLayerInfo(layerinfo);
   }
   layerinfo->orahandlers = hand;
   layerinfo->oradatahandlers = dthand;
@@ -1802,30 +2033,34 @@ int msOracleSpatialLayerOpen( layerObj *
   layerinfo->orastmt2 = sthand2;
   layer->layerinfo = layerinfo;
 
-  if (username) free(username);
-  if (password) free(password);
-  if (dblink) free(dblink);
+  if (username)
+    free(username);
+  if (password)
+    free(password);
+  if (dblink)
+    free(dblink);
 
   return layer->layerinfo != NULL ? MS_SUCCESS : MS_FAILURE;
 }
 
 /* return MS_TRUE if layer is open, MS_FALSE otherwise.*/
-int msOracleSpatialLayerIsOpen(layerObj *layer)
-{
+int msOracleSpatialLayerIsOpen(layerObj *layer) {
   if (layer->layerinfo != NULL)
     return MS_TRUE;
 
   return MS_FALSE;
 }
 
-/* closes the layer, disconnecting from db if connected. layer->layerinfo is freed */
-int msOracleSpatialLayerClose( layerObj *layer )
-{
-  msOracleSpatialLayerInfo *layerinfo = (msOracleSpatialLayerInfo *)layer->layerinfo;
+/* closes the layer, disconnecting from db if connected. layer->layerinfo is
+ * freed */
+int msOracleSpatialLayerClose(layerObj *layer) {
+  msOracleSpatialLayerInfo *layerinfo =
+      (msOracleSpatialLayerInfo *)layer->layerinfo;
   /*int lIntSuccessFree = 0;*/
 
-  if (layer->debug>=2)
-    msDebug("msOracleSpatialLayerClose was called. Layer: %p, Layer name: %s\n", layer, layer->name);
+  if (layer->debug >= 2)
+    msDebug("msOracleSpatialLayerClose was called. Layer: %p, Layer name: %s\n",
+            layer, layer->name);
 
   if (layerinfo != NULL) {
 
@@ -1834,9 +2069,11 @@ int msOracleSpatialLayerClose( layerObj
      * If uncomment draw mode will work but no query modes
      * Need to investigate the error cause
      */
-    /*lIntSuccessFree = TRY (layerinfo->orahandlers, OCIObjectFree(layerinfo->orahandlers->envhp, layerinfo->orahandlers->errhp, (dvoid *)layerinfo->obj, (ub2)OCI_OBJECTFREE_FORCE));
-     *if (!lIntSuccessFree)
-     *  msDebug("Error: %s\n", layerinfo->orahandlers->last_oci_error);
+    /*lIntSuccessFree = TRY (layerinfo->orahandlers,
+     *OCIObjectFree(layerinfo->orahandlers->envhp,
+     *layerinfo->orahandlers->errhp, (dvoid *)layerinfo->obj,
+     *(ub2)OCI_OBJECTFREE_FORCE)); if (!lIntSuccessFree) msDebug("Error: %s\n",
+     *layerinfo->orahandlers->last_oci_error);
      */
     /* Release Statement Handles */
     if (layerinfo->orastmt != NULL) {
@@ -1849,25 +2086,26 @@ int msOracleSpatialLayerClose( layerObj
     }
 
     /* Release Datahandlers */
-    if (layer->debug>=4)
+    if (layer->debug >= 4)
       msDebug("msOracleSpatialLayerClose. Cleaning layerinfo handlers.\n");
-    msOCICloseDataHandlers( layerinfo->oradatahandlers );
+    msOCICloseDataHandlers(layerinfo->oradatahandlers);
     layerinfo->oradatahandlers = NULL;
 
     /* Free the OCI cache only if there is no more layer that could use it */
     layerinfo->orahandlers->ref_count--;
     if (layerinfo->orahandlers->ref_count == 0)
-      OCICacheFree (layerinfo->orahandlers->envhp, layerinfo->orahandlers->errhp, layerinfo->orahandlers->svchp);
+      OCICacheFree(layerinfo->orahandlers->envhp, layerinfo->orahandlers->errhp,
+                   layerinfo->orahandlers->svchp);
 
     /* Release Mapserver Pool */
-    if (layer->debug>=4)
+    if (layer->debug >= 4)
       msDebug("msOracleSpatialLayerClose. Release the Oracle Pool.\n");
-    msConnPoolRelease( layer, layerinfo->orahandlers );
+    msConnPoolRelease(layer, layerinfo->orahandlers);
 
     /* Release Layerinfo */
     layerinfo->orahandlers = NULL;
 
-    msOCIClearLayerInfo( layerinfo );
+    msOCIClearLayerInfo(layerinfo);
     layer->layerinfo = NULL;
   }
 
@@ -1876,38 +2114,40 @@ int msOracleSpatialLayerClose( layerObj
 
 /* create SQL statement for retrieving shapes */
 /* Sets up cursor for use in *NextShape and *GetShape */
-int msOracleSpatialLayerWhichShapes( layerObj *layer, rectObj rect, int isQuery)
-{
+int msOracleSpatialLayerWhichShapes(layerObj *layer, rectObj rect,
+                                    int isQuery) {
   int success, i;
   int function = 0;
   int version = 0;
-  char * query_str = NULL;
+  char *query_str = NULL;
   char query_str2[256];
-  char *tmp_str=NULL, *tmp1_str=NULL;
+  char *tmp_str = NULL, *tmp1_str = NULL;
   char *table_name;
-  char *geom_column_name = NULL, *unique = NULL, *srid = NULL, *indexfield=NULL;
+  char *geom_column_name = NULL, *unique = NULL, *srid = NULL,
+       *indexfield = NULL;
   OCIDefine *adtp = NULL;
   OCIDefine **items = NULL;
   OCINumber oci_number;
-  OCIBind *bnd1p = NULL,  *bnd2p = NULL;
+  OCIBind *bnd1p = NULL, *bnd2p = NULL;
 
   int existunique = MS_FALSE;
   int rownumisuniquekey = MS_FALSE;
   int numitemsinselect = 0;
 
   /* get layerinfo */
-  msOracleSpatialLayerInfo *layerinfo = (msOracleSpatialLayerInfo *)layer->layerinfo;
+  msOracleSpatialLayerInfo *layerinfo =
+      (msOracleSpatialLayerInfo *)layer->layerinfo;
   msOracleSpatialDataHandler *dthand = NULL;
   msOracleSpatialHandler *hand = NULL;
   msOracleSpatialStatement *sthand = NULL;
 
-  if (layer->debug>=3)
+  if (layer->debug >= 3)
     msDebug("msOracleSpatialLayerWhichShapes was called.\n");
 
   if (layerinfo == NULL) {
-    msSetError( MS_ORACLESPATIALERR,
-                "msOracleSpatialLayerWhichShapes called on unopened layer",
-                "msOracleSpatialLayerWhichShapes()" );
+    msSetError(MS_ORACLESPATIALERR,
+               "msOracleSpatialLayerWhichShapes called on unopened layer",
+               "msOracleSpatialLayerWhichShapes()");
 
     return MS_FAILURE;
   } else {
@@ -1917,25 +2157,35 @@ int msOracleSpatialLayerWhichShapes( lay
   }
 
   /*init uniqueindex field*/
-  sthand->uniqueidindex=0;
+  sthand->uniqueidindex = 0;
 
-  table_name = (char *) malloc(sizeof(char) * TABLE_NAME_SIZE);
+  table_name = (char *)malloc(sizeof(char) * TABLE_NAME_SIZE);
   /* parse geom_column_name and table_name */
-  if (!msSplitData( layer->data, &geom_column_name, &table_name, &unique, &srid, &indexfield, &function, &version)) {
-    msDebug( "Error parsing OracleSpatial DATA variable. Must be:"
-                "'geometry_column FROM table_name [USING UNIQUE <column> SRID srid# FUNCTION]' or "
-                "'geometry_column FROM (SELECT stmt) [USING UNIQUE <column> SRID srid# FUNCTION]'."
-                "If want to set the FUNCTION statement you can use: FILTER, RELATE, GEOMRELATE or NONE."
-                "Your data statement: (%s)"
-                "in msOracleSpatialLayerWhichShapes()\n", layer->data );
-    msSetError( MS_ORACLESPATIALERR,
-                "Error parsing OracleSpatial DATA variable. More info in server logs",
-                "msOracleSpatialLayerWhichShapes()" );
-
-    if (geom_column_name) free(geom_column_name);
-    if (srid) free(srid);
-    if (unique) free(unique);
-    if (indexfield) free(indexfield);
+  if (!msSplitData(layer->data, &geom_column_name, &table_name, &unique, &srid,
+                   &indexfield, &function, &version)) {
+    msDebug("Error parsing OracleSpatial DATA variable. Must be:"
+            "'geometry_column FROM table_name [USING UNIQUE <column> SRID "
+            "srid# FUNCTION]' or "
+            "'geometry_column FROM (SELECT stmt) [USING UNIQUE <column> SRID "
+            "srid# FUNCTION]'."
+            "If want to set the FUNCTION statement you can use: FILTER, "
+            "RELATE, GEOMRELATE or NONE."
+            "Your data statement: (%s)"
+            "in msOracleSpatialLayerWhichShapes()\n",
+            layer->data);
+    msSetError(
+        MS_ORACLESPATIALERR,
+        "Error parsing OracleSpatial DATA variable. More info in server logs",
+        "msOracleSpatialLayerWhichShapes()");
+
+    if (geom_column_name)
+      free(geom_column_name);
+    if (srid)
+      free(srid);
+    if (unique)
+      free(unique);
+    if (indexfield)
+      free(indexfield);
     free(table_name);
     return MS_FAILURE;
   }
@@ -1945,15 +2195,15 @@ int msOracleSpatialLayerWhichShapes( lay
   rownumisuniquekey = MS_TRUE;
   /*Define the unique*/
   if (unique[0] == '\0')
-    strcpy( unique, "rownum" );
+    strcpy(unique, "rownum");
   else
     rownumisuniquekey = MS_FALSE;
 
   /* Check if the unique field is already in the items list */
   existunique = MS_FALSE;
   if (unique) {
-    for( i=0; i < layer->numitems; ++i ) {
-      if (strcasecmp(unique, layer->items[i])==0) {
+    for (i = 0; i < layer->numitems; ++i) {
+      if (strcasecmp(unique, layer->items[i]) == 0) {
         sthand->uniqueidindex = i;
         existunique = MS_TRUE;
         break;
@@ -1962,8 +2212,8 @@ int msOracleSpatialLayerWhichShapes( lay
   }
 
   /* If no SRID is provided, set it to -1 (NULL) for binding */
-  if (strcmp(srid,"NULL") == 0)
-    strcpy(srid,"-1");
+  if (strcmp(srid, "NULL") == 0)
+    strcpy(srid, "-1");
 
   query_str = msStringConcatenate(query_str, "SELECT ");
   numitemsinselect = layer->numitems;
@@ -1972,50 +2222,64 @@ int msOracleSpatialLayerWhichShapes( lay
     /*we will always add a rownumber in the selection*/
     numitemsinselect++;
 
-    /*if unique key in the data is specfied and is not part of the current item lists,
-      we should add it to the select*/
-    if(existunique == MS_FALSE && rownumisuniquekey == MS_FALSE)
+    /*if unique key in the data is specfied and is not part of the current item
+      lists, we should add it to the select*/
+    if (existunique == MS_FALSE && rownumisuniquekey == MS_FALSE)
       numitemsinselect++;
 
-    /*the usinque index is there was no uniqueid given or the uniqueid given was not part of the items lists*/
+    /*the usinque index is there was no uniqueid given or the uniqueid given was
+     * not part of the items lists*/
     if (existunique == MS_FALSE)
       sthand->uniqueidindex = layer->numitems;
 
-    sthand->items = (item_text_array *)malloc( sizeof(item_text_array) * (numitemsinselect) );
+    sthand->items =
+        (item_text_array *)malloc(sizeof(item_text_array) * (numitemsinselect));
     if (sthand->items == NULL) {
-      msSetError( MS_ORACLESPATIALERR,"Cannot allocate layerinfo->items buffer","msOracleSpatialLayerWhichShapes()" );
-      if (geom_column_name) free(geom_column_name);
-      if (srid) free(srid);
-      if (unique) free(unique);
-      if(indexfield) free(indexfield);
-      if (query_str) free(query_str);
+      msSetError(MS_ORACLESPATIALERR, "Cannot allocate layerinfo->items buffer",
+                 "msOracleSpatialLayerWhichShapes()");
+      if (geom_column_name)
+        free(geom_column_name);
+      if (srid)
+        free(srid);
+      if (unique)
+        free(unique);
+      if (indexfield)
+        free(indexfield);
+      if (query_str)
+        free(query_str);
       free(table_name);
       return MS_FAILURE;
     }
 
-    items = (OCIDefine **)malloc(sizeof(OCIDefine *)*(numitemsinselect));
+    items = (OCIDefine **)malloc(sizeof(OCIDefine *) * (numitemsinselect));
     if (items == NULL) {
-      msSetError( MS_ORACLESPATIALERR,"Cannot allocate items buffer","msOracleSpatialLayerWhichShapes()" );
-      if (geom_column_name) free(geom_column_name);
-      if (srid) free(srid);
-      if (unique) free(unique);
-      if(indexfield) free(indexfield);
+      msSetError(MS_ORACLESPATIALERR, "Cannot allocate items buffer",
+                 "msOracleSpatialLayerWhichShapes()");
+      if (geom_column_name)
+        free(geom_column_name);
+      if (srid)
+        free(srid);
+      if (unique)
+        free(unique);
+      if (indexfield)
+        free(indexfield);
       free(table_name);
-      if (query_str) free(query_str);
+      if (query_str)
+        free(query_str);
       return MS_FAILURE;
     }
-    memset(items ,0,sizeof(OCIDefine *)*(numitemsinselect));
+    memset(items, 0, sizeof(OCIDefine *) * (numitemsinselect));
   }
 
   /* define SQL query */
-  for( i=0; i < layer->numitems; ++i ) {
-      query_str = msStringConcatenate(query_str, "\"");
-      query_str = msStringConcatenate(query_str, layer->items[i]);
-      query_str = msStringConcatenate(query_str, "\", ");
+  for (i = 0; i < layer->numitems; ++i) {
+    query_str = msStringConcatenate(query_str, "\"");
+    query_str = msStringConcatenate(query_str, layer->items[i]);
+    query_str = msStringConcatenate(query_str, "\", ");
   }
 
   /*we add the uniqueid if it was not part of the current item list*/
-  if(existunique == MS_FALSE && rownumisuniquekey == MS_FALSE) {
+  if (existunique == MS_FALSE && rownumisuniquekey == MS_FALSE) {
     query_str = msStringConcatenate(query_str, unique);
     query_str = msStringConcatenate(query_str, ",");
   }
@@ -2032,7 +2296,8 @@ int msOracleSpatialLayerWhichShapes( lay
   if (layerinfo->paging && layer->maxfeatures > 0 && layer->startindex < 0) {
     if (function == FUNCTION_NONE && layer->filter.native_string == NULL) {
       query_str = msStringConcatenate(query_str, " WHERE ");
-    } else if (function == FUNCTION_NONE && layer->filter.native_string != NULL) {
+    } else if (function == FUNCTION_NONE &&
+               layer->filter.native_string != NULL) {
       query_str = msStringConcatenate(query_str, " AND ");
     }
     // avoiding an allocation on the heap here sounds acceptable
@@ -2045,168 +2310,222 @@ int msOracleSpatialLayerWhichShapes( lay
     }
   }
 
-  if ((((atol(srid) >= 8192) && (atol(srid) <= 8330))
-   || (atol(srid) == 2) || (atol(srid) == 5242888)
-    || (atol(srid) == 2000001)) && (version == VERSION_9i)) {
-    query_str = osGeodeticData(function, query_str, geom_column_name, indexfield);
-  }
-  else {
-    query_str = osNoGeodeticData(function, version, query_str, geom_column_name, indexfield);
-  }
-
-  if( layer->sortBy.nProperties > 0 ) {
-      msDebug("Layer sorting is requested\n");
-      tmp1_str = msLayerBuildSQLOrderBy(layer);
-      query_str = msStringConcatenate(query_str, " ORDER BY ");
-      query_str = msStringConcatenate(query_str, tmp1_str);
-      query_str = msStringConcatenate(query_str, "  ");
-      msFree(tmp1_str);
-    }
+  if ((((atol(srid) >= 8192) && (atol(srid) <= 8330)) || (atol(srid) == 2) ||
+       (atol(srid) == 5242888) || (atol(srid) == 2000001)) &&
+      (version == VERSION_9i)) {
+    query_str =
+        osGeodeticData(function, query_str, geom_column_name, indexfield);
+  } else {
+    query_str = osNoGeodeticData(function, version, query_str, geom_column_name,
+                                 indexfield);
+  }
+
+  if (layer->sortBy.nProperties > 0) {
+    msDebug("Layer sorting is requested\n");
+    tmp1_str = msLayerBuildSQLOrderBy(layer);
+    query_str = msStringConcatenate(query_str, " ORDER BY ");
+    query_str = msStringConcatenate(query_str, tmp1_str);
+    query_str = msStringConcatenate(query_str, "  ");
+    msFree(tmp1_str);
+  }
 
   /*assuming startindex starts at 1*/
   if (layerinfo->paging && layer->startindex > 0) {
     tmp1_str = msStrdup("SELECT * from (SELECT atmp.*, ROWNUM rnum from (");
-    tmp_str = msStringConcatenate(tmp_str,  tmp1_str);
+    tmp_str = msStringConcatenate(tmp_str, tmp1_str);
     msFree(tmp1_str);
     tmp_str = msStringConcatenate(tmp_str, query_str);
-    /*oder by rowid does not seem to work with function using the spatial filter, at least
-      on layers loaded using ogr in a 11g database*/
-    if (function == FUNCTION_NONE  || function == FUNCTION_RELATE || function == FUNCTION_GEOMRELATE)
-      tmp1_str = msStrdup( "order by rowid");
+    /*oder by rowid does not seem to work with function using the spatial
+      filter, at least on layers loaded using ogr in a 11g database*/
+    if (function == FUNCTION_NONE || function == FUNCTION_RELATE ||
+        function == FUNCTION_GEOMRELATE)
+      tmp1_str = msStrdup("order by rowid");
     /* Populate strOrderBy, if necessary */
     else
       tmp1_str = msStrdup("");
 
     if (layer->maxfeatures > 0) {
-      snprintf(query_str2, sizeof(query_str2),  " %s) atmp where ROWNUM<=%d) where rnum >=%d",   tmp1_str,
-               layer->maxfeatures+layer->startindex-1,  layer->startindex);
+      snprintf(query_str2, sizeof(query_str2),
+               " %s) atmp where ROWNUM<=%d) where rnum >=%d", tmp1_str,
+               layer->maxfeatures + layer->startindex - 1, layer->startindex);
     } else {
-      snprintf( query_str2, sizeof(query_str2),  " %s) atmp) where rnum >=%d",  tmp1_str, layer->startindex);
+      snprintf(query_str2, sizeof(query_str2), " %s) atmp) where rnum >=%d",
+               tmp1_str, layer->startindex);
     }
     msFree(tmp1_str);
 
-    tmp_str = msStringConcatenate(tmp_str,  query_str2);
-    memset(query_str,0,strlen(query_str));
+    tmp_str = msStringConcatenate(tmp_str, query_str2);
+    memset(query_str, 0, strlen(query_str));
     query_str = msStringConcatenate(query_str, tmp_str);
     msFree(tmp_str);
   }
 
-
   if (layer->debug)
-    msDebug("msOracleSpatialLayerWhichShapes. Using this Sql to retrieve the data: %s\n", query_str);
+    msDebug("msOracleSpatialLayerWhichShapes. Using this Sql to retrieve the "
+            "data: %s\n",
+            query_str);
 
   if (layer->debug)
-    msDebug("msOracleSpatialLayerWhichShapes. Bind values: srid:%s   minx:%f   miny:%f  maxx:%f   maxy:%f \n", srid, rect.minx, rect.miny, rect.maxx, rect.maxy);
+    msDebug("msOracleSpatialLayerWhichShapes. Bind values: srid:%s   minx:%f   "
+            "miny:%f  maxx:%f   maxy:%f \n",
+            srid, rect.minx, rect.miny, rect.maxx, rect.maxy);
 
   /* prepare */
-  success = TRY( hand, OCIStmtPrepare( sthand->stmthp, hand->errhp, (text *)query_str, (ub4)strlen(query_str), (ub4)OCI_NTV_SYNTAX, (ub4)OCI_DEFAULT) );
+  success = TRY(hand, OCIStmtPrepare(sthand->stmthp, hand->errhp,
+                                     (text *)query_str, (ub4)strlen(query_str),
+                                     (ub4)OCI_NTV_SYNTAX, (ub4)OCI_DEFAULT));
 
-  if (layer->debug>=4)
+  if (layer->debug >= 4)
     msDebug("msOracleSpatialLayerWhichShapes getting ordinate definition.\n");
 
   /* get the object definition of the ordinate array */
-  ordinates_tdo = get_tdo(SDO_ORDINATE_ARRAY, hand, dthand );
+  ordinates_tdo = get_tdo(SDO_ORDINATE_ARRAY, hand, dthand);
 
-  if (layer->debug>=4)
+  if (layer->debug >= 4)
     msDebug("msOracleSpatialLayerWhichShapes converting to OCIColl.\n");
 
   /* initialized the collection array */
-  success = TRY( hand, OCIObjectNew(hand->envhp, hand->errhp, hand->svchp, OCI_TYPECODE_VARRAY, ordinates_tdo, (dvoid *)NULL, OCI_DURATION_SESSION, FALSE, (dvoid **)&ordinates) );
+  success = TRY(hand, OCIObjectNew(hand->envhp, hand->errhp, hand->svchp,
+                                   OCI_TYPECODE_VARRAY, ordinates_tdo,
+                                   (dvoid *)NULL, OCI_DURATION_SESSION, FALSE,
+                                   (dvoid **)&ordinates));
 
   /* convert it to a OCI number and then append minx...maxy to the collection */
-  success = TRY ( hand, OCINumberFromReal(hand->errhp, (dvoid *)&(rect.minx), (uword)sizeof(double),(dvoid *)&oci_number))
-            &&TRY ( hand, OCICollAppend(hand->envhp, hand->errhp,(dvoid *) &oci_number,(dvoid *)0, (OCIColl *)ordinates))
-            &&TRY ( hand, OCINumberFromReal(hand->errhp, (dvoid *)&(rect.miny), (uword)sizeof(double),(dvoid *)&oci_number))
-            &&TRY ( hand, OCICollAppend(hand->envhp, hand->errhp,(dvoid *) &oci_number,(dvoid *)0, (OCIColl *)ordinates))
-            &&TRY ( hand, OCINumberFromReal(hand->errhp, (dvoid *)&(rect.maxx), (uword)sizeof(double),(dvoid *)&oci_number))
-            &&TRY ( hand, OCICollAppend(hand->envhp, hand->errhp,(dvoid *) &oci_number,(dvoid *)0, (OCIColl *)ordinates))
-            &&TRY ( hand, OCINumberFromReal(hand->errhp, (dvoid *)&(rect.maxy), (uword)sizeof(double),(dvoid *)&oci_number))
-            &&TRY ( hand, OCICollAppend(hand->envhp, hand->errhp,(dvoid *) &oci_number,(dvoid *)0, (OCIColl *)ordinates));
-
+  success =
+      TRY(hand,
+          OCINumberFromReal(hand->errhp, (dvoid *)&(rect.minx),
+                            (uword)sizeof(double), (dvoid *)&oci_number)) &&
+      TRY(hand, OCICollAppend(hand->envhp, hand->errhp, (dvoid *)&oci_number,
+                              (dvoid *)0, (OCIColl *)ordinates)) &&
+      TRY(hand,
+          OCINumberFromReal(hand->errhp, (dvoid *)&(rect.miny),
+                            (uword)sizeof(double), (dvoid *)&oci_number)) &&
+      TRY(hand, OCICollAppend(hand->envhp, hand->errhp, (dvoid *)&oci_number,
+                              (dvoid *)0, (OCIColl *)ordinates)) &&
+      TRY(hand,
+          OCINumberFromReal(hand->errhp, (dvoid *)&(rect.maxx),
+                            (uword)sizeof(double), (dvoid *)&oci_number)) &&
+      TRY(hand, OCICollAppend(hand->envhp, hand->errhp, (dvoid *)&oci_number,
+                              (dvoid *)0, (OCIColl *)ordinates)) &&
+      TRY(hand,
+          OCINumberFromReal(hand->errhp, (dvoid *)&(rect.maxy),
+                            (uword)sizeof(double), (dvoid *)&oci_number)) &&
+      TRY(hand, OCICollAppend(hand->envhp, hand->errhp, (dvoid *)&oci_number,
+                              (dvoid *)0, (OCIColl *)ordinates));
 
-  if (layer->debug>=3)
+  if (layer->debug >= 3)
     msDebug("msOracleSpatialLayerWhichShapes bind by name and object.\n");
 
   /* do the actual binding */
 
   if (success && function != FUNCTION_NONE) {
-    success = TRY( hand,
-                   /* bind in srid */
-                   OCIBindByName( sthand->stmthp, &bnd2p,  hand->errhp, (text *) ":srid", strlen(":srid"),(ub1 *) srid,  strlen(srid)+1, SQLT_STR,
-                                  (dvoid *) 0, (ub2 *) 0, (ub2) 0, (ub4) 0, (ub4 *) 0, OCI_DEFAULT) )
-              && TRY(hand,
-                     /* bind in rect by name */
-                     OCIBindByName( sthand->stmthp, &bnd1p,  hand->errhp,  (text *)":ordinates", -1, (dvoid *)0, (sb4)0, SQLT_NTY, (dvoid *)0, (ub2 *)0,(ub2 *)0, (ub4)0, (ub4 *)0, (ub4)OCI_DEFAULT))
-              && TRY(hand,
-                     /* bind in rect object */
-                     OCIBindObject(bnd1p, hand->errhp, ordinates_tdo, (dvoid **)&ordinates, (ub4 *)0, (dvoid **)0, (ub4 *)0));
+    success =
+        TRY(hand,
+            /* bind in srid */
+            OCIBindByName(sthand->stmthp, &bnd2p, hand->errhp, (text *)":srid",
+                          strlen(":srid"), (ub1 *)srid, strlen(srid) + 1,
+                          SQLT_STR, (dvoid *)0, (ub2 *)0, (ub2)0, (ub4)0,
+                          (ub4 *)0, OCI_DEFAULT)) &&
+        TRY(hand,
+            /* bind in rect by name */
+            OCIBindByName(sthand->stmthp, &bnd1p, hand->errhp,
+                          (text *)":ordinates", -1, (dvoid *)0, (sb4)0,
+                          SQLT_NTY, (dvoid *)0, (ub2 *)0, (ub2 *)0, (ub4)0,
+                          (ub4 *)0, (ub4)OCI_DEFAULT)) &&
+        TRY(hand,
+            /* bind in rect object */
+            OCIBindObject(bnd1p, hand->errhp, ordinates_tdo,
+                          (dvoid **)&ordinates, (ub4 *)0, (dvoid **)0,
+                          (ub4 *)0));
 
     /* bind the variables from the bindvals hash */
-    const char* bind_key = msFirstKeyFromHashTable(&layer->bindvals);
-    while(bind_key != NULL) {
-      const char* bind_value = msLookupHashTable(&layer->bindvals, bind_key);
-      char* bind_tag = (char*)malloc(sizeof(char) * strlen(bind_key) + 2);
+    const char *bind_key = msFirstKeyFromHashTable(&layer->bindvals);
+    while (bind_key != NULL) {
+      const char *bind_value = msLookupHashTable(&layer->bindvals, bind_key);
+      char *bind_tag = (char *)malloc(sizeof(char) * strlen(bind_key) + 2);
       sprintf(bind_tag, ":%s", bind_key);
 
-      success = success && TRY(hand, OCIBindByName( sthand->stmthp, &bnd2p,  hand->errhp, (text *)bind_tag, strlen(bind_tag),(ub1 *) bind_value,  strlen(bind_value)+1, SQLT_STR,
-                               (dvoid *) 0, (ub2 *) 0, (ub2) 0, (ub4) 0, (ub4 *) 0, OCI_DEFAULT));
+      success =
+          success &&
+          TRY(hand, OCIBindByName(sthand->stmthp, &bnd2p, hand->errhp,
+                                  (text *)bind_tag, strlen(bind_tag),
+                                  (ub1 *)bind_value, strlen(bind_value) + 1,
+                                  SQLT_STR, (dvoid *)0, (ub2 *)0, (ub2)0,
+                                  (ub4)0, (ub4 *)0, OCI_DEFAULT));
       bind_key = msNextKeyFromHashTable(&layer->bindvals, bind_key);
     }
   }
 
-
-  if (layer->debug>=3)
+  if (layer->debug >= 3)
     msDebug("msOracleSpatialLayerWhichShapes name and object now bound.\n");
 
-
   if (success && layer->numitems >= 0) {
-    for( i=0; i < numitemsinselect && success; ++i ){
-      if (i< numitemsinselect -1) {
-        //msDebug("Defining by POS, for %s\n", layer->items[i]);
-        //msDebug("datatype retrieved is %i\n", layer->iteminfo);
+    for (i = 0; i < numitemsinselect && success; ++i) {
+      if (i < numitemsinselect - 1) {
+        // msDebug("Defining by POS, for %s\n", layer->items[i]);
+        // msDebug("datatype retrieved is %i\n", layer->iteminfo);
       }
-      success = TRY( hand, OCIDefineByPos( sthand->stmthp, &items[i], hand->errhp, (ub4)i+1, (dvoid *)sthand->items[i], (sb4)TEXT_SIZE, SQLT_STR, (dvoid *)0, (ub2 *)0, (ub2 *)0, (ub4)OCI_DEFAULT ) );
+      success = TRY(hand, OCIDefineByPos(sthand->stmthp, &items[i], hand->errhp,
+                                         (ub4)i + 1, (dvoid *)sthand->items[i],
+                                         (sb4)TEXT_SIZE, SQLT_STR, (dvoid *)0,
+                                         (ub2 *)0, (ub2 *)0, (ub4)OCI_DEFAULT));
     }
   }
 
-
   if (success) {
     int cursor_type = OCI_DEFAULT;
-    if(isQuery) cursor_type =OCI_STMT_SCROLLABLE_READONLY;
+    if (isQuery)
+      cursor_type = OCI_STMT_SCROLLABLE_READONLY;
 
-    success = TRY( hand,
-                   /* define spatial position adtp ADT object */
-                   OCIDefineByPos( sthand->stmthp, &adtp, hand->errhp, (ub4)numitemsinselect+1, (dvoid *)0, (sb4)0, SQLT_NTY, (dvoid *)0, (ub2 *)0, (ub2 *)0, (ub4)OCI_DEFAULT) )
-              && TRY( hand,
-                      /* define object tdo from adtp */
-                      OCIDefineObject( adtp, hand->errhp, dthand->tdo, (dvoid **)sthand->obj, (ub4 *)0, (dvoid **)sthand->ind, (ub4 *)0 ) )
-              && TRY(hand,
-                     /* execute */
-                     OCIStmtExecute( hand->svchp, sthand->stmthp, hand->errhp, (ub4)ARRAY_SIZE, (ub4)0, (OCISnapshot *)NULL, (OCISnapshot *)NULL, (ub4)cursor_type ) )
-              &&  TRY( hand,
-                       /* get rows fetched */
-                       OCIAttrGet( (dvoid *)sthand->stmthp, (ub4)OCI_HTYPE_STMT, (dvoid *)&sthand->rows_fetched, (ub4 *)0, (ub4)OCI_ATTR_ROWS_FETCHED, hand->errhp ) )
-              && TRY( hand,
-                      /* get rows count */
-                      OCIAttrGet( (dvoid *)sthand->stmthp, (ub4)OCI_HTYPE_STMT, (dvoid *)&sthand->rows_count, (ub4 *)0, (ub4)OCI_ATTR_ROW_COUNT, hand->errhp ) );
+    success = TRY(hand,
+                  /* define spatial position adtp ADT object */
+                  OCIDefineByPos(sthand->stmthp, &adtp, hand->errhp,
+                                 (ub4)numitemsinselect + 1, (dvoid *)0, (sb4)0,
+                                 SQLT_NTY, (dvoid *)0, (ub2 *)0, (ub2 *)0,
+                                 (ub4)OCI_DEFAULT)) &&
+              TRY(hand,
+                  /* define object tdo from adtp */
+                  OCIDefineObject(adtp, hand->errhp, dthand->tdo,
+                                  (dvoid **)sthand->obj, (ub4 *)0,
+                                  (dvoid **)sthand->ind, (ub4 *)0)) &&
+              TRY(hand,
+                  /* execute */
+                  OCIStmtExecute(hand->svchp, sthand->stmthp, hand->errhp,
+                                 (ub4)ARRAY_SIZE, (ub4)0, (OCISnapshot *)NULL,
+                                 (OCISnapshot *)NULL, (ub4)cursor_type)) &&
+              TRY(hand,
+                  /* get rows fetched */
+                  OCIAttrGet((dvoid *)sthand->stmthp, (ub4)OCI_HTYPE_STMT,
+                             (dvoid *)&sthand->rows_fetched, (ub4 *)0,
+                             (ub4)OCI_ATTR_ROWS_FETCHED, hand->errhp)) &&
+              TRY(hand,
+                  /* get rows count */
+                  OCIAttrGet((dvoid *)sthand->stmthp, (ub4)OCI_HTYPE_STMT,
+                             (dvoid *)&sthand->rows_count, (ub4 *)0,
+                             (ub4)OCI_ATTR_ROW_COUNT, hand->errhp));
   }
 
   if (!success) {
-    msDebug( "Error: %s . "
-                "Query statement: %s . "
-                "Check your data statement."
-                "msOracleSpatialLayerWhichShapes()\n", hand->last_oci_error, query_str );
-    msSetError( MS_ORACLESPATIALERR,
-                "Check your data statement and server logs",
-                "msOracleSpatialLayerWhichShapes()");
+    msDebug("Error: %s . "
+            "Query statement: %s . "
+            "Check your data statement."
+            "msOracleSpatialLayerWhichShapes()\n",
+            hand->last_oci_error, query_str);
+    msSetError(MS_ORACLESPATIALERR, "Check your data statement and server logs",
+               "msOracleSpatialLayerWhichShapes()");
 
     /* clean items */
     free(items);
-    if (geom_column_name) free(geom_column_name);
-    if (srid) free(srid);
-    if (unique) free(unique);
-    if (indexfield) free(indexfield);
-    if (query_str) free(query_str);
+    if (geom_column_name)
+      free(geom_column_name);
+    if (srid)
+      free(srid);
+    if (unique)
+      free(unique);
+    if (indexfield)
+      free(indexfield);
+    if (query_str)
+      free(query_str);
     free(table_name);
 
     return MS_FAILURE;
@@ -2218,32 +2537,38 @@ int msOracleSpatialLayerWhichShapes( lay
   /* clean items */
   free(items);
   // TODO why not msFree() instead to avoid if statements ?
-  if (geom_column_name) free(geom_column_name);
-  if (srid) free(srid);
-  if (unique) free(unique);
-  if (indexfield) free(indexfield);
-  if (query_str) free(query_str);
+  if (geom_column_name)
+    free(geom_column_name);
+  if (srid)
+    free(srid);
+  if (unique)
+    free(unique);
+  if (indexfield)
+    free(indexfield);
+  if (query_str)
+    free(query_str);
   free(table_name);
 
   return MS_SUCCESS;
 }
 
 /* fetch next shape from previous SELECT stmt (see *WhichShape()) */
-int msOracleSpatialLayerNextShape( layerObj *layer, shapeObj *shape )
-{
+int msOracleSpatialLayerNextShape(layerObj *layer, shapeObj *shape) {
   SDOGeometryObj *obj;
   SDOGeometryInd *ind;
   int success, /*lIntSuccessFree,*/ i;
 
   /* get layerinfo */
-  msOracleSpatialLayerInfo *layerinfo = (msOracleSpatialLayerInfo *)layer->layerinfo;
+  msOracleSpatialLayerInfo *layerinfo =
+      (msOracleSpatialLayerInfo *)layer->layerinfo;
   msOracleSpatialDataHandler *dthand = NULL;
   msOracleSpatialHandler *hand = NULL;
   msOracleSpatialStatement *sthand = NULL;
 
-
   if (layerinfo == NULL) {
-    msSetError( MS_ORACLESPATIALERR, "msOracleSpatialLayerWhichShapes called on unopened layer", "msOracleSpatialLayerNextShape()" );
+    msSetError(MS_ORACLESPATIALERR,
+               "msOracleSpatialLayerWhichShapes called on unopened layer",
+               "msOracleSpatialLayerNextShape()");
     return MS_FAILURE;
   } else {
     dthand = (msOracleSpatialDataHandler *)layerinfo->oradatahandlers;
@@ -2255,51 +2580,67 @@ int msOracleSpatialLayerNextShape( layer
   if (sthand->rows_fetched == 0)
     return MS_DONE;
 
-  if(layer->debug >=5 )
-    msDebug("msOracleSpatialLayerNextShape on layer %p, row_num: %d\n", layer, sthand->row_num);
+  if (layer->debug >= 5)
+    msDebug("msOracleSpatialLayerNextShape on layer %p, row_num: %d\n", layer,
+            sthand->row_num);
 
   do {
     /* is buffer empty? */
     if (sthand->row >= sthand->rows_fetched) {
       /* fetch more */
-      success = TRY( hand, OCIStmtFetch2( sthand->stmthp, hand->errhp, (ub4)ARRAY_SIZE, (ub2)OCI_FETCH_NEXT, (sb4)0, (ub4)OCI_DEFAULT ) )
-                && TRY( hand, OCIAttrGet( (dvoid *)sthand->stmthp, (ub4)OCI_HTYPE_STMT, (dvoid *)&sthand->rows_fetched, (ub4 *)0, (ub4)OCI_ATTR_ROWS_FETCHED, hand->errhp ) )
-                && TRY( hand, OCIAttrGet( (dvoid *)sthand->stmthp, (ub4)OCI_HTYPE_STMT, (dvoid *)&sthand->rows_count, (ub4 *)0, (ub4)OCI_ATTR_ROW_COUNT, hand->errhp ) );
-
+      success =
+          TRY(hand,
+              OCIStmtFetch2(sthand->stmthp, hand->errhp, (ub4)ARRAY_SIZE,
+                            (ub2)OCI_FETCH_NEXT, (sb4)0, (ub4)OCI_DEFAULT)) &&
+          TRY(hand, OCIAttrGet((dvoid *)sthand->stmthp, (ub4)OCI_HTYPE_STMT,
+                               (dvoid *)&sthand->rows_fetched, (ub4 *)0,
+                               (ub4)OCI_ATTR_ROWS_FETCHED, hand->errhp)) &&
+          TRY(hand, OCIAttrGet((dvoid *)sthand->stmthp, (ub4)OCI_HTYPE_STMT,
+                               (dvoid *)&sthand->rows_count, (ub4 *)0,
+                               (ub4)OCI_ATTR_ROW_COUNT, hand->errhp));
 
-      if (!success || sthand->rows_fetched == 0 || sthand->row_num >= sthand->rows_count) {
-        hand->last_oci_status=MS_SUCCESS;
+      if (!success || sthand->rows_fetched == 0 ||
+          sthand->row_num >= sthand->rows_count) {
+        hand->last_oci_status = MS_SUCCESS;
         return MS_DONE;
       }
-      if(layer->debug >= 4 )
-        msDebug("msOracleSpatialLayerNextShape on layer %p, Fetched %d more rows (%d total)\n", layer, sthand->rows_fetched, sthand->rows_count);
+      if (layer->debug >= 4)
+        msDebug("msOracleSpatialLayerNextShape on layer %p, Fetched %d more "
+                "rows (%d total)\n",
+                layer, sthand->rows_fetched, sthand->rows_count);
 
       sthand->row = 0; /* reset buffer row index */
     }
 
     /* set obj & ind for current row */
-    obj = sthand->obj[ sthand->row ];
-    ind = sthand->ind[ sthand->row ];
+    obj = sthand->obj[sthand->row];
+    ind = sthand->ind[sthand->row];
 
     /* get the items for the shape */
-    shape->index = atol( (char *)(sthand->items[sthand->uniqueidindex][ sthand->row ])); /* Primary Key */
+    shape->index = atol((char *)(sthand->items[sthand->uniqueidindex]
+                                              [sthand->row])); /* Primary Key */
     shape->resultindex = sthand->row_num;
     shape->numvalues = layer->numitems;
 
-    shape->values = (char **)malloc( sizeof(char*) * shape->numvalues );
+    shape->values = (char **)malloc(sizeof(char *) * shape->numvalues);
     if (shape->values == NULL) {
-      msSetError( MS_ORACLESPATIALERR, "No memory avaliable to allocate the values", "msOracleSpatialLayerNextShape()" );
+      msSetError(MS_ORACLESPATIALERR,
+                 "No memory avaliable to allocate the values",
+                 "msOracleSpatialLayerNextShape()");
       return MS_FAILURE;
     }
 
-    for( i=0; i < shape->numvalues; ++i ) {
-      shape->values[i] = (char *)malloc(strlen((char *)sthand->items[i][ sthand->row ])+1);
+    for (i = 0; i < shape->numvalues; ++i) {
+      shape->values[i] =
+          (char *)malloc(strlen((char *)sthand->items[i][sthand->row]) + 1);
       if (shape->values[i] == NULL) {
-        msSetError( MS_ORACLESPATIALERR, "No memory avaliable to allocate the items", "msOracleSpatialLayerNextShape()" );
+        msSetError(MS_ORACLESPATIALERR,
+                   "No memory avaliable to allocate the items",
+                   "msOracleSpatialLayerNextShape()");
         return MS_FAILURE;
       } else {
-        strcpy(shape->values[i], (char *)sthand->items[i][ sthand->row ]);
-        shape->values[i][strlen((char *)sthand->items[i][ sthand->row ])] = '\0';
+        strcpy(shape->values[i], (char *)sthand->items[i][sthand->row]);
+        shape->values[i][strlen((char *)sthand->items[i][sthand->row])] = '\0';
       }
     }
 
@@ -2315,13 +2656,13 @@ int msOracleSpatialLayerNextShape( layer
     }
 
     osShapeBounds(shape);
-  } while(shape->type == MS_SHAPE_NULL);
+  } while (shape->type == MS_SHAPE_NULL);
 
   return MS_SUCCESS;
 }
 
-int msOracleSpatialLayerGetShape( layerObj *layer, shapeObj *shape, resultObj *record)
-{
+int msOracleSpatialLayerGetShape(layerObj *layer, shapeObj *shape,
+                                 resultObj *record) {
   int success, i;
   SDOGeometryObj *obj;
   SDOGeometryInd *ind;
@@ -2333,19 +2674,25 @@ int msOracleSpatialLayerGetShape( layerO
   long shapeindex = record->shapeindex;
   int resultindex = record->resultindex;
 
-  if(layer == NULL) {
-    msSetError( MS_ORACLESPATIALERR, "msOracleSpatialLayerGetShape called on unopened layer","msOracleSpatialLayerGetShape()" );
+  if (layer == NULL) {
+    msSetError(MS_ORACLESPATIALERR,
+               "msOracleSpatialLayerGetShape called on unopened layer",
+               "msOracleSpatialLayerGetShape()");
     return MS_FAILURE;
   }
 
   layerinfo = (msOracleSpatialLayerInfo *)layer->layerinfo;
 
   if (layerinfo == NULL) {
-    msSetError( MS_ORACLESPATIALERR, "msOracleSpatialLayerGetShape called on unopened layer (layerinfo)","msOracleSpatialLayerGetShape()" );
+    msSetError(
+        MS_ORACLESPATIALERR,
+        "msOracleSpatialLayerGetShape called on unopened layer (layerinfo)",
+        "msOracleSpatialLayerGetShape()");
     return MS_FAILURE;
   }
 
-  /* If resultindex is set, fetch the shape from the resultcache, otherwise fetch it from the DB  */
+  /* If resultindex is set, fetch the shape from the resultcache, otherwise
+   * fetch it from the DB  */
   if (resultindex >= 0) {
     long buffer_first_row_num, buffer_last_row_num;
 
@@ -2355,72 +2702,103 @@ int msOracleSpatialLayerGetShape( layerO
     sthand = (msOracleSpatialStatement *)layerinfo->orastmt2;
 
     if (layer->resultcache == NULL) {
-      msSetError( MS_ORACLESPATIALERR, "msOracleSpatialLayerGetShape called before msOracleSpatialLayerWhichShapes()","msOracleSpatialLayerGetShape()" );
+      msSetError(MS_ORACLESPATIALERR,
+                 "msOracleSpatialLayerGetShape called before "
+                 "msOracleSpatialLayerWhichShapes()",
+                 "msOracleSpatialLayerGetShape()");
       return MS_FAILURE;
     }
 
     if ((unsigned)resultindex >= sthand->rows_count) {
       if (layer->debug >= 5)
-               msDebug("msOracleSpatialLayerGetShape problem with cursor. Trying to fetch record = %d of %d, falling back to GetShape\n", resultindex, sthand->rows_count);
-
-      msSetError( MS_ORACLESPATIALERR, "msOracleSpatialLayerGetShape record out of range","msOracleSpatialLayerGetShape()" );
+        msDebug("msOracleSpatialLayerGetShape problem with cursor. Trying to "
+                "fetch record = %d of %d, falling back to GetShape\n",
+                resultindex, sthand->rows_count);
+
+      msSetError(MS_ORACLESPATIALERR,
+                 "msOracleSpatialLayerGetShape record out of range",
+                 "msOracleSpatialLayerGetShape()");
       return MS_FAILURE;
     }
 
     if (layer->debug >= 5)
-      msDebug("msOracleSpatialLayerGetShape was called. Using the record = %d of %d. (shape: %ld should equal pkey: %ld)\n",
-              resultindex, layer->resultcache->numresults, layer->resultcache->results[resultindex].shapeindex, shapeindex);
+      msDebug("msOracleSpatialLayerGetShape was called. Using the record = %d "
+              "of %d. (shape: %ld should equal pkey: %ld)\n",
+              resultindex, layer->resultcache->numresults,
+              layer->resultcache->results[resultindex].shapeindex, shapeindex);
 
-    /* NOTE: with the way the resultcache works, we should see items in increasing order, but some may have been filtered out. */
+    /* NOTE: with the way the resultcache works, we should see items in
+     * increasing order, but some may have been filtered out. */
     /* Best case: item in buffer */
     /* Next best case: item is in next fetch block */
     /* Worst case: item is random access */
-    buffer_first_row_num = sthand->row_num - sthand->row; /* cursor id of first item in buffer */
-    buffer_last_row_num  = buffer_first_row_num + sthand->rows_fetched - 1; /* cursor id of last item in buffer */
-    if(resultindex >= buffer_first_row_num && resultindex <= buffer_last_row_num) { /* Item is in buffer. Calculate position in buffer */
-      sthand->row += resultindex - sthand->row_num; /* move sthand row an row_num by offset from last call */
+    buffer_first_row_num =
+        sthand->row_num - sthand->row; /* cursor id of first item in buffer */
+    buffer_last_row_num = buffer_first_row_num + sthand->rows_fetched -
+                          1; /* cursor id of last item in buffer */
+    if (resultindex >= buffer_first_row_num &&
+        resultindex <= buffer_last_row_num) { /* Item is in buffer. Calculate
+                                                 position in buffer */
+      sthand->row +=
+          resultindex - sthand->row_num; /* move sthand row an row_num by offset
+                                            from last call */
       sthand->row_num += resultindex - sthand->row_num;
     } else { /* Item is not in buffer. Fetch item from Oracle */
       if (layer->debug >= 4)
-        msDebug("msOracleSpatialLayerGetShape: Fetching result from DB start: %ld end:%ld record: %d\n", buffer_first_row_num, buffer_last_row_num, resultindex);
-
-      success = TRY( hand, OCIStmtFetch2( sthand->stmthp, hand->errhp, (ub4)ARRAY_SIZE, (ub2)OCI_FETCH_ABSOLUTE, (sb4)resultindex+1, (ub4)OCI_DEFAULT ) )
-                && TRY( hand, OCIAttrGet( (dvoid *)sthand->stmthp, (ub4)OCI_HTYPE_STMT, (dvoid *)&sthand->rows_fetched, (ub4 *)0, (ub4)OCI_ATTR_ROWS_FETCHED, hand->errhp ) );
+        msDebug("msOracleSpatialLayerGetShape: Fetching result from DB start: "
+                "%ld end:%ld record: %d\n",
+                buffer_first_row_num, buffer_last_row_num, resultindex);
+
+      success =
+          TRY(hand, OCIStmtFetch2(sthand->stmthp, hand->errhp, (ub4)ARRAY_SIZE,
+                                  (ub2)OCI_FETCH_ABSOLUTE, (sb4)resultindex + 1,
+                                  (ub4)OCI_DEFAULT)) &&
+          TRY(hand, OCIAttrGet((dvoid *)sthand->stmthp, (ub4)OCI_HTYPE_STMT,
+                               (dvoid *)&sthand->rows_fetched, (ub4 *)0,
+                               (ub4)OCI_ATTR_ROWS_FETCHED, hand->errhp));
 
       sthand->row_num = resultindex;
       sthand->row = 0; /* reset row index */
 
-      if(ERROR("msOracleSpatialLayerGetShape", hand, dthand))
-          return MS_FAILURE;
+      if (ERROR("msOracleSpatialLayerGetShape", hand, dthand))
+        return MS_FAILURE;
 
       if (!success || sthand->rows_fetched == 0) {
-        msSetError( MS_ORACLESPATIALERR, "msOracleSpatialLayerGetShape could not fetch specified record.", "msOracleSpatialLayerGetShape()" );
+        msSetError(
+            MS_ORACLESPATIALERR,
+            "msOracleSpatialLayerGetShape could not fetch specified record.",
+            "msOracleSpatialLayerGetShape()");
         return MS_FAILURE;
       }
     }
 
     /* set obj & ind for current row */
-    obj = sthand->obj[ sthand->row ];
-    ind = sthand->ind[ sthand->row ];
+    obj = sthand->obj[sthand->row];
+    ind = sthand->ind[sthand->row];
 
     /* get the items for the shape */
     shape->index = shapeindex; /* By definition this is what we asked for */
     shape->numvalues = layer->numitems;
 
-    shape->values = (char **)malloc( sizeof(char*) * shape->numvalues );
+    shape->values = (char **)malloc(sizeof(char *) * shape->numvalues);
     if (shape->values == NULL) {
-      msSetError( MS_ORACLESPATIALERR, "No memory avaliable to allocate the values", "msOracleSpatialLayerNextShape()" );
+      msSetError(MS_ORACLESPATIALERR,
+                 "No memory avaliable to allocate the values",
+                 "msOracleSpatialLayerNextShape()");
       return MS_FAILURE;
     }
 
-    for( i=0; i < shape->numvalues; ++i ) {
-      shape->values[i] = (char *)malloc(strlen((char *)sthand->items[i][ sthand->row ])+1);
+    for (i = 0; i < shape->numvalues; ++i) {
+      shape->values[i] =
+          (char *)malloc(strlen((char *)sthand->items[i][sthand->row]) + 1);
       if (shape->values[i] == NULL) {
-        msSetError( MS_ORACLESPATIALERR, "No memory avaliable to allocate the items", "msOracleSpatialLayerNextShape()" );
+        msSetError(MS_ORACLESPATIALERR,
+                   "No memory avaliable to allocate the items",
+                   "msOracleSpatialLayerNextShape()");
         return MS_FAILURE;
       } else {
-        strcpy(shape->values[i], (char *)sthand->items[i][ sthand->row ]);
-        shape->values[i][strlen((char *)sthand->items[i][ sthand->row ])] = '\0';
+        strcpy(shape->values[i], (char *)sthand->items[i][sthand->row]);
+        shape->values[i][strlen((char *)sthand->items[i][sthand->row])] = '\0';
       }
     }
 
@@ -2428,73 +2806,92 @@ int msOracleSpatialLayerGetShape( layerO
     success = osGetOrdinates(dthand, hand, shape, obj, ind);
 
     if (success != MS_SUCCESS) {
-      msSetError( MS_ORACLESPATIALERR, "Call to osGetOrdinates failed.", "msOracleSpatialLayerGetShape()" );
+      msSetError(MS_ORACLESPATIALERR, "Call to osGetOrdinates failed.",
+                 "msOracleSpatialLayerGetShape()");
       return MS_FAILURE;
     }
 
     osShapeBounds(shape);
-    if(shape->type == MS_SHAPE_NULL)  {
-      msSetError( MS_ORACLESPATIALERR, "Shape type is null... this probably means a record number was requested that could not have beeen in a result set (as returned by NextShape).", "msOracleSpatialLayerGetShape()" );
+    if (shape->type == MS_SHAPE_NULL) {
+      msSetError(MS_ORACLESPATIALERR,
+                 "Shape type is null... this probably means a record number "
+                 "was requested that could not have beeen in a result set (as "
+                 "returned by NextShape).",
+                 "msOracleSpatialLayerGetShape()");
       return MS_FAILURE;
     }
 
     return (MS_SUCCESS);
   } else { /* no resultindex, fetch the shape from the DB */
     char *table_name;
-    char *query_str = NULL, *geom_column_name = NULL, *unique = NULL, *srid = NULL, *indexfield = NULL;
+    char *query_str = NULL, *geom_column_name = NULL, *unique = NULL,
+         *srid = NULL, *indexfield = NULL;
     int function = 0;
     int version = 0;
     sb2 *nullind = NULL;
     /*OCIDefine *adtp = NULL, *items[QUERY_SIZE] = { NULL };*/
     OCIDefine *adtp = NULL;
-    OCIDefine  **items = NULL;
+    OCIDefine **items = NULL;
 
-    if (layer->debug>=4)
-      msDebug("msOracleSpatialLayerGetShape was called. Using the record = %ld.\n", shapeindex);
+    if (layer->debug >= 4)
+      msDebug(
+          "msOracleSpatialLayerGetShape was called. Using the record = %ld.\n",
+          shapeindex);
 
     dthand = (msOracleSpatialDataHandler *)layerinfo->oradatahandlers;
     hand = (msOracleSpatialHandler *)layerinfo->orahandlers;
-    sthand = (msOracleSpatialStatement *) layerinfo->orastmt;
+    sthand = (msOracleSpatialStatement *)layerinfo->orastmt;
 
     /* allocate enough space for items */
     if (layer->numitems > 0) {
       if (sthand->items_query == NULL)
-        sthand->items_query = (item_text_array_query *)malloc( sizeof(item_text_array_query) * (layer->numitems) );
+        sthand->items_query = (item_text_array_query *)malloc(
+            sizeof(item_text_array_query) * (layer->numitems));
 
       if (sthand->items_query == NULL) {
-        msSetError( MS_ORACLESPATIALERR, "Cannot allocate layerinfo->items_query buffer", "msOracleSpatialLayerGetShape()" );
+        msSetError(MS_ORACLESPATIALERR,
+                   "Cannot allocate layerinfo->items_query buffer",
+                   "msOracleSpatialLayerGetShape()");
         return MS_FAILURE;
       }
 
-      nullind = (sb2 *)malloc( sizeof(sb2) * (layer->numitems) );
+      nullind = (sb2 *)malloc(sizeof(sb2) * (layer->numitems));
       if (nullind == NULL) {
-        msSetError( MS_ORACLESPATIALERR, "Cannot allocate nullind buffer", "msOracleSpatialLayerGetShape()" );
+        msSetError(MS_ORACLESPATIALERR, "Cannot allocate nullind buffer",
+                   "msOracleSpatialLayerGetShape()");
         return MS_FAILURE;
       }
-      memset(nullind ,0, sizeof(sb2) * (layer->numitems) );
+      memset(nullind, 0, sizeof(sb2) * (layer->numitems));
 
-      items = (OCIDefine **)malloc(sizeof(OCIDefine *)*layer->numitems);
+      items = (OCIDefine **)malloc(sizeof(OCIDefine *) * layer->numitems);
       if (items == NULL) {
-        msSetError( MS_ORACLESPATIALERR,"Cannot allocate items buffer","msOracleSpatialLayerWhichShapes()" );
+        msSetError(MS_ORACLESPATIALERR, "Cannot allocate items buffer",
+                   "msOracleSpatialLayerWhichShapes()");
 
         /* clean nullind  */
         free(nullind);
 
         return MS_FAILURE;
       }
-      memset(items ,0,sizeof(OCIDefine *)*layer->numitems);
+      memset(items, 0, sizeof(OCIDefine *) * layer->numitems);
     }
 
-    table_name = (char *) malloc(sizeof(char) * TABLE_NAME_SIZE);
-    if (!msSplitData( layer->data, &geom_column_name, &table_name, &unique, &srid, &indexfield, &function, &version )) {
-      msDebug( "Error parsing OracleSpatial DATA variable. Must be: "
-                  "'geometry_column FROM table_name [USING UNIQUE <column> SRID srid# FUNCTION]' or "
-                  "'geometry_column FROM (SELECT stmt) [USING UNIQUE <column> SRID srid# FUNCTION]'. "
-                  "If want to set the FUNCTION statement you can use: FILTER, RELATE, GEOMRELATE or NONE. "
-                  "Your data statement: (%s) msOracleSpatialLayerGetShape()\n", layer->data );
-      msSetError( MS_ORACLESPATIALERR,
-                  "Error parsing OracleSpatial DATA variable. Check server logs. ",
-                  "msOracleSpatialLayerGetShape()");
+    table_name = (char *)malloc(sizeof(char) * TABLE_NAME_SIZE);
+    if (!msSplitData(layer->data, &geom_column_name, &table_name, &unique,
+                     &srid, &indexfield, &function, &version)) {
+      msDebug("Error parsing OracleSpatial DATA variable. Must be: "
+              "'geometry_column FROM table_name [USING UNIQUE <column> SRID "
+              "srid# FUNCTION]' or "
+              "'geometry_column FROM (SELECT stmt) [USING UNIQUE <column> SRID "
+              "srid# FUNCTION]'. "
+              "If want to set the FUNCTION statement you can use: FILTER, "
+              "RELATE, GEOMRELATE or NONE. "
+              "Your data statement: (%s) msOracleSpatialLayerGetShape()\n",
+              layer->data);
+      msSetError(
+          MS_ORACLESPATIALERR,
+          "Error parsing OracleSpatial DATA variable. Check server logs. ",
+          "msOracleSpatialLayerGetShape()");
 
       /* clean nullind  */
       free(nullind);
@@ -2502,10 +2899,14 @@ int msOracleSpatialLayerGetShape( layerO
       /* clean items */
       free(items);
 
-      if (geom_column_name) free(geom_column_name);
-      if (srid) free(srid);
-      if (unique) free(unique);
-      if (indexfield) free(indexfield);
+      if (geom_column_name)
+        free(geom_column_name);
+      if (srid)
+        free(srid);
+      if (unique)
+        free(unique);
+      if (indexfield)
+        free(indexfield);
       free(table_name);
 
       return MS_FAILURE;
@@ -2513,11 +2914,12 @@ int msOracleSpatialLayerGetShape( layerO
 
     /*Define the first query to retrive itens*/
     if (unique[0] == '\0') {
-      msSetError( MS_ORACLESPATIALERR,
-                  "Error parsing OracleSpatial DATA variable for query. To execute "
-                  "query functions you need to define one "
-                  "unique column [USING UNIQUE <#column>]",
-                  "msOracleSpatialLayerGetShape()" );
+      msSetError(
+          MS_ORACLESPATIALERR,
+          "Error parsing OracleSpatial DATA variable for query. To execute "
+          "query functions you need to define one "
+          "unique column [USING UNIQUE <#column>]",
+          "msOracleSpatialLayerGetShape()");
 
       /* clean nullind  */
       free(nullind);
@@ -2525,10 +2927,14 @@ int msOracleSpatialLayerGetShape( layerO
       /* clean items */
       free(items);
 
-      if (geom_column_name) free(geom_column_name);
-      if (srid) free(srid);
-      if (unique) free(unique);
-      if (indexfield) free(indexfield);
+      if (geom_column_name)
+        free(geom_column_name);
+      if (srid)
+        free(srid);
+      if (unique)
+        free(unique);
+      if (indexfield)
+        free(indexfield);
       free(table_name);
 
       return MS_FAILURE;
@@ -2536,7 +2942,7 @@ int msOracleSpatialLayerGetShape( layerO
       query_str = msStringConcatenate(query_str, "SELECT");
     }
     /*Define the query*/
-    for( i = 0; i < layer->numitems; ++i ) {
+    for (i = 0; i < layer->numitems; ++i) {
       msStringConcatenate(query_str, " ");
       msStringConcatenate(query_str, layer->items[i]);
       msStringConcatenate(query_str, ",");
@@ -2553,27 +2959,35 @@ int msOracleSpatialLayerGetShape( layerO
     query_str = msStringConcatenate(query_str, tmpBuf);
 
     /*if (layer->filter.native_string != NULL)
-      sprintf( query_str + strlen(query_str), " AND %s", (layer->filter.string));*/
+      sprintf( query_str + strlen(query_str), " AND %s",
+      (layer->filter.string));*/
     query_str = osFilteritem(layer, FUNCTION_NONE, query_str, 2);
 
-
     if (layer->debug)
       msDebug("msOracleSpatialLayerGetShape. Sql: %s\n", query_str);
 
     /*Prepare the handlers to the query*/
-    success = TRY( hand,OCIStmtPrepare( sthand->stmthp, hand->errhp, (text *)query_str, (ub4)strlen(query_str), (ub4)OCI_NTV_SYNTAX, (ub4)OCI_DEFAULT) );
+    success =
+        TRY(hand, OCIStmtPrepare(sthand->stmthp, hand->errhp, (text *)query_str,
+                                 (ub4)strlen(query_str), (ub4)OCI_NTV_SYNTAX,
+                                 (ub4)OCI_DEFAULT));
 
     if (success && layer->numitems > 0) {
-      for( i = 0; i < layer->numitems && success; i++ )
-        success = TRY( hand, OCIDefineByPos( sthand->stmthp, &items[i], hand->errhp, (ub4)i+1, (dvoid *)sthand->items_query[i], (sb4)TEXT_SIZE, SQLT_STR, (sb2 *)&nullind[i], (ub2 *)0, (ub2 *)0, (ub4)OCI_DEFAULT ) );
+      for (i = 0; i < layer->numitems && success; i++)
+        success = TRY(
+            hand, OCIDefineByPos(sthand->stmthp, &items[i], hand->errhp,
+                                 (ub4)i + 1, (dvoid *)sthand->items_query[i],
+                                 (sb4)TEXT_SIZE, SQLT_STR, (sb2 *)&nullind[i],
+                                 (ub2 *)0, (ub2 *)0, (ub4)OCI_DEFAULT));
     }
 
-    if(!success) {
-      msSetError( MS_ORACLESPATIALERR,
-                  "Error: %s . "
-                  "Query statement: %s . "
-                  "Check your data statement.",
-                  "msOracleSpatialLayerGetShape()\n", hand->last_oci_error, query_str );
+    if (!success) {
+      msSetError(MS_ORACLESPATIALERR,
+                 "Error: %s . "
+                 "Query statement: %s . "
+                 "Check your data statement.",
+                 "msOracleSpatialLayerGetShape()\n", hand->last_oci_error,
+                 query_str);
 
       /* clean nullind  */
       free(nullind);
@@ -2581,31 +2995,47 @@ int msOracleSpatialLayerGetShape( layerO
       /* clean items */
       free(items);
 
-      if (geom_column_name) free(geom_column_name);
-      if (srid) free(srid);
-      if (unique) free(unique);
-      if (indexfield) free(indexfield);
-      if (query_str) free(query_str);
+      if (geom_column_name)
+        free(geom_column_name);
+      if (srid)
+        free(srid);
+      if (unique)
+        free(unique);
+      if (indexfield)
+        free(indexfield);
+      if (query_str)
+        free(query_str);
       free(table_name);
 
       return MS_FAILURE;
     }
 
     if (success) {
-      success = TRY( hand, OCIDefineByPos( sthand->stmthp, &adtp, hand->errhp, (ub4)layer->numitems+1, (dvoid *)0, (sb4)0, SQLT_NTY, (dvoid *)0, (ub2 *)0, (ub2 *)0, (ub4)OCI_DEFAULT) )
-                && TRY( hand, OCIDefineObject( adtp, hand->errhp, dthand->tdo, (dvoid **)sthand->obj, (ub4 *)0, (dvoid **)sthand->ind, (ub4 *)0 ) )
-                && TRY (hand, OCIStmtExecute( hand->svchp, sthand->stmthp, hand->errhp, (ub4)QUERY_SIZE, (ub4)0, (OCISnapshot *)NULL, (OCISnapshot *)NULL, (ub4)OCI_DEFAULT ))
-                && TRY (hand, OCIAttrGet( (dvoid *)sthand->stmthp, (ub4)OCI_HTYPE_STMT, (dvoid *)&sthand->rows_fetched, (ub4 *)0, (ub4)OCI_ATTR_ROW_COUNT, hand->errhp ));
-
+      success =
+          TRY(hand, OCIDefineByPos(sthand->stmthp, &adtp, hand->errhp,
+                                   (ub4)layer->numitems + 1, (dvoid *)0, (sb4)0,
+                                   SQLT_NTY, (dvoid *)0, (ub2 *)0, (ub2 *)0,
+                                   (ub4)OCI_DEFAULT)) &&
+          TRY(hand, OCIDefineObject(adtp, hand->errhp, dthand->tdo,
+                                    (dvoid **)sthand->obj, (ub4 *)0,
+                                    (dvoid **)sthand->ind, (ub4 *)0)) &&
+          TRY(hand, OCIStmtExecute(hand->svchp, sthand->stmthp, hand->errhp,
+                                   (ub4)QUERY_SIZE, (ub4)0, (OCISnapshot *)NULL,
+                                   (OCISnapshot *)NULL, (ub4)OCI_DEFAULT)) &&
+          TRY(hand, OCIAttrGet((dvoid *)sthand->stmthp, (ub4)OCI_HTYPE_STMT,
+                               (dvoid *)&sthand->rows_fetched, (ub4 *)0,
+                               (ub4)OCI_ATTR_ROW_COUNT, hand->errhp));
     }
 
-    if(!success) {
-      msDebug( "Error: %s . "
-                  "Query statement: %s ."
-                  "Check your data statement."
-                  "in msOracleSpatialLayerGetShape()\n", hand->last_oci_error, query_str );
-      msSetError( MS_ORACLESPATIALERR,
-                  "Error in Query statement. Check your server logs","msOracleSpatialLayerGetShape()");
+    if (!success) {
+      msDebug("Error: %s . "
+              "Query statement: %s ."
+              "Check your data statement."
+              "in msOracleSpatialLayerGetShape()\n",
+              hand->last_oci_error, query_str);
+      msSetError(MS_ORACLESPATIALERR,
+                 "Error in Query statement. Check your server logs",
+                 "msOracleSpatialLayerGetShape()");
 
       /* clean nullind  */
       free(nullind);
@@ -2613,11 +3043,16 @@ int msOracleSpatialLayerGetShape( layerO
       /* clean items */
       free(items);
 
-      if (geom_column_name) free(geom_column_name);
-      if (srid) free(srid);
-      if (unique) free(unique);
-      if (indexfield) free(indexfield);
-      if (query_str) free(query_str);
+      if (geom_column_name)
+        free(geom_column_name);
+      if (srid)
+        free(srid);
+      if (unique)
+        free(unique);
+      if (indexfield)
+        free(indexfield);
+      if (query_str)
+        free(query_str);
       free(table_name);
 
       return MS_FAILURE;
@@ -2633,24 +3068,31 @@ int msOracleSpatialLayerGetShape( layerO
       /* clean items */
       free(items);
 
-      if (geom_column_name) free(geom_column_name);
-      if (srid) free(srid);
-      if (unique) free(unique);
-      if (indexfield) free(indexfield);
-      if (query_str) free(query_str);
+      if (geom_column_name)
+        free(geom_column_name);
+      if (srid)
+        free(srid);
+      if (unique)
+        free(unique);
+      if (indexfield)
+        free(indexfield);
+      if (query_str)
+        free(query_str);
       free(table_name);
 
       return (MS_DONE);
     }
 
-    obj = sthand->obj[ sthand->row ];
-    ind = sthand->ind[ sthand->row ];
+    obj = sthand->obj[sthand->row];
+    ind = sthand->ind[sthand->row];
 
     /* get the items for the shape */
     shape->numvalues = layer->numitems;
-    shape->values = (char **) malloc(sizeof(char *) * layer->numitems);
+    shape->values = (char **)malloc(sizeof(char *) * layer->numitems);
     if (shape->values == NULL) {
-      msSetError( MS_ORACLESPATIALERR, "No memory avaliable to allocate the values.", "msOracleSpatialLayerGetShape()" );
+      msSetError(MS_ORACLESPATIALERR,
+                 "No memory avaliable to allocate the values.",
+                 "msOracleSpatialLayerGetShape()");
 
       /* clean nullind  */
       free(nullind);
@@ -2658,11 +3100,16 @@ int msOracleSpatialLayerGetShape( layerO
       /* clean items */
       free(items);
 
-      if (geom_column_name) free(geom_column_name);
-      if (srid) free(srid);
-      if (unique) free(unique);
-      if (indexfield) free(indexfield);
-      if (query_str) free(query_str);
+      if (geom_column_name)
+        free(geom_column_name);
+      if (srid)
+        free(srid);
+      if (unique)
+        free(unique);
+      if (indexfield)
+        free(indexfield);
+      if (query_str)
+        free(query_str);
       free(table_name);
 
       return MS_FAILURE;
@@ -2670,11 +3117,14 @@ int msOracleSpatialLayerGetShape( layerO
 
     shape->index = shapeindex;
 
-    for( i = 0; i < layer->numitems; ++i ) {
-      shape->values[i] = (char *)malloc(strlen((char *)sthand->items_query[sthand->row][i])+1);
+    for (i = 0; i < layer->numitems; ++i) {
+      shape->values[i] = (char *)malloc(
+          strlen((char *)sthand->items_query[sthand->row][i]) + 1);
 
       if (shape->values[i] == NULL) {
-        msSetError( MS_ORACLESPATIALERR, "No memory avaliable to allocate the items buffer.", "msOracleSpatialLayerGetShape()" );
+        msSetError(MS_ORACLESPATIALERR,
+                   "No memory avaliable to allocate the items buffer.",
+                   "msOracleSpatialLayerGetShape()");
 
         /* clean nullind  */
         free(nullind);
@@ -2682,18 +3132,25 @@ int msOracleSpatialLayerGetShape( layerO
         /* clean items */
         free(items);
 
-        if (geom_column_name) free(geom_column_name);
-        if (srid) free(srid);
-        if (unique) free(unique);
-        if (indexfield) free(indexfield);
-        if (query_str) free(query_str);
+        if (geom_column_name)
+          free(geom_column_name);
+        if (srid)
+          free(srid);
+        if (unique)
+          free(unique);
+        if (indexfield)
+          free(indexfield);
+        if (query_str)
+          free(query_str);
         free(table_name);
 
         return MS_FAILURE;
       } else {
         if (nullind[i] != OCI_IND_NULL) {
           strcpy(shape->values[i], (char *)sthand->items_query[sthand->row][i]);
-          shape->values[i][strlen((char *)sthand->items_query[sthand->row][i])] = '\0';
+          shape
+              ->values[i][strlen((char *)sthand->items_query[sthand->row][i])] =
+              '\0';
         } else {
           shape->values[i][0] = '\0';
         }
@@ -2707,7 +3164,8 @@ int msOracleSpatialLayerGetShape( layerO
     /* fetch a layer->type object */
     success = osGetOrdinates(dthand, hand, shape, obj, ind);
     if (success != MS_SUCCESS) {
-      msSetError( MS_ORACLESPATIALERR, "Cannot execute query", "msOracleSpatialLayerGetShape()" );
+      msSetError(MS_ORACLESPATIALERR, "Cannot execute query",
+                 "msOracleSpatialLayerGetShape()");
 
       /* clean nullind  */
       free(nullind);
@@ -2715,11 +3173,16 @@ int msOracleSpatialLayerGetShape( layerO
       /* clean items */
       free(items);
 
-      if (geom_column_name) free(geom_column_name);
-      if (srid) free(srid);
-      if (unique) free(unique);
-      if (indexfield) free(indexfield);
-      if (query_str) free(query_str);
+      if (geom_column_name)
+        free(geom_column_name);
+      if (srid)
+        free(srid);
+      if (unique)
+        free(unique);
+      if (indexfield)
+        free(indexfield);
+      if (query_str)
+        free(query_str);
       free(table_name);
 
       return MS_FAILURE;
@@ -2733,42 +3196,46 @@ int msOracleSpatialLayerGetShape( layerO
     /* clean items */
     free(items);
 
-    if (geom_column_name) free(geom_column_name);
-    if (srid) free(srid);
-    if (unique) free(unique);
-    if (indexfield) free(indexfield);
-    if (query_str) free(query_str);
+    if (geom_column_name)
+      free(geom_column_name);
+    if (srid)
+      free(srid);
+    if (unique)
+      free(unique);
+    if (indexfield)
+      free(indexfield);
+    if (query_str)
+      free(query_str);
     free(table_name);
 
     return (MS_SUCCESS);
   }
 }
 
-int msOracleSpatialLayerInitItemInfo( layerObj *layer )
-{
+int msOracleSpatialLayerInitItemInfo(layerObj *layer) {
   int i;
-  int *itemindexes ;
+  int *itemindexes;
 
-  if (layer->debug>=3)
+  if (layer->debug >= 3)
     msDebug("msOracleSpatialLayerInitItemInfo was called.\n");
 
   if (layer->numitems == 0)
     return MS_SUCCESS;
 
   if (layer->iteminfo)
-    free( layer->iteminfo );
+    free(layer->iteminfo);
 
-  if ((layer->iteminfo = (long *)malloc(sizeof(int)*layer->numitems))== NULL) {
+  if ((layer->iteminfo = (long *)malloc(sizeof(int) * layer->numitems)) ==
+      NULL) {
     msSetError(MS_MEMERR, NULL, "msOracleSpatialLayerInitItemInfo()");
     return MS_FAILURE;
   }
 
-  itemindexes = (int*)layer->iteminfo;
-
+  itemindexes = (int *)layer->iteminfo;
 
-
-  for(i=0; i < layer->numitems; i++){
-    itemindexes[i] = i;  /*last one is always the geometry one - the rest are non-geom*/
+  for (i = 0; i < layer->numitems; i++) {
+    itemindexes[i] =
+        i; /*last one is always the geometry one - the rest are non-geom*/
   }
 
   return MS_SUCCESS;
@@ -2777,104 +3244,153 @@ int msOracleSpatialLayerInitItemInfo( la
 /* AutoProjection Support for RFC 37 #3333
  * TODO: Needs testing
  */
-int msOracleSpatialLayerGetAutoProjection( layerObj *layer, projectionObj *projection )
-{
+int msOracleSpatialLayerGetAutoProjection(layerObj *layer,
+                                          projectionObj *projection) {
   char *table_name;
-  char *query_str, *geom_column_name = NULL, *unique = NULL, *srid = NULL, *indexfield=NULL;
+  char *query_str, *geom_column_name = NULL, *unique = NULL, *srid = NULL,
+                   *indexfield = NULL;
   int success;
   int function = 0;
   int version = 0;
   char wktext[4000];
 
   OCIDefine *def1p = NULL;
-  OCIBind *bnd1p = NULL,  *bnd2p = NULL;
+  OCIBind *bnd1p = NULL, *bnd2p = NULL;
 
-  msOracleSpatialLayerInfo *layerinfo = (msOracleSpatialLayerInfo *)layer->layerinfo;
+  msOracleSpatialLayerInfo *layerinfo =
+      (msOracleSpatialLayerInfo *)layer->layerinfo;
   msOracleSpatialHandler *hand = NULL;
   msOracleSpatialStatement *sthand = NULL;
 
-  if (layer->debug>=3)
+  if (layer->debug >= 3)
     msDebug("msOracleSpatialLayerGetAutoProjection was called.\n");
 
   if (layerinfo == NULL) {
-    msSetError( MS_ORACLESPATIALERR, "msOracleSpatialLayerGetAutoProjection called on unopened layer","msOracleSpatialLayerGetAutoProjection()");
+    msSetError(MS_ORACLESPATIALERR,
+               "msOracleSpatialLayerGetAutoProjection called on unopened layer",
+               "msOracleSpatialLayerGetAutoProjection()");
     return MS_FAILURE;
   } else {
     hand = (msOracleSpatialHandler *)layerinfo->orahandlers;
-    sthand = (msOracleSpatialStatement *) layerinfo->orastmt;
+    sthand = (msOracleSpatialStatement *)layerinfo->orastmt;
   }
 
-  table_name = (char *) malloc(sizeof(char) * TABLE_NAME_SIZE);
-  if (!msSplitData( layer->data, &geom_column_name, &table_name, &unique, &srid, &indexfield, &function, &version )) {
-    msDebug(  "Error parsing OracleSpatial DATA variable. Must be: "
-                "'geometry_column FROM table_name [USING UNIQUE <column> SRID srid# FUNCTION]' or "
-                "'geometry_column FROM (SELECT stmt) [USING UNIQUE <column> SRID srid# FUNCTION]'. "
-                "If want to set the FUNCTION statement you can use: FILTER, RELATE, GEOMRELATE or NONE. "
-                "Your data statement: (%s) "
-                "in msOracleSpatialLayerGetAutoProjection()\n", layer->data );
-
-    msSetError( MS_ORACLESPATIALERR,
-                "Error parsing OracleSpatial DATA variable",
-                "msOracleSpatialLayerGetAutoProjection()");
-
-    if (geom_column_name) free(geom_column_name);
-    if (srid) free(srid);
-    if (unique) free(unique);
-    if (indexfield) free(indexfield);
+  table_name = (char *)malloc(sizeof(char) * TABLE_NAME_SIZE);
+  if (!msSplitData(layer->data, &geom_column_name, &table_name, &unique, &srid,
+                   &indexfield, &function, &version)) {
+    msDebug("Error parsing OracleSpatial DATA variable. Must be: "
+            "'geometry_column FROM table_name [USING UNIQUE <column> SRID "
+            "srid# FUNCTION]' or "
+            "'geometry_column FROM (SELECT stmt) [USING UNIQUE <column> SRID "
+            "srid# FUNCTION]'. "
+            "If want to set the FUNCTION statement you can use: FILTER, "
+            "RELATE, GEOMRELATE or NONE. "
+            "Your data statement: (%s) "
+            "in msOracleSpatialLayerGetAutoProjection()\n",
+            layer->data);
+
+    msSetError(MS_ORACLESPATIALERR, "Error parsing OracleSpatial DATA variable",
+               "msOracleSpatialLayerGetAutoProjection()");
+
+    if (geom_column_name)
+      free(geom_column_name);
+    if (srid)
+      free(srid);
+    if (unique)
+      free(unique);
+    if (indexfield)
+      free(indexfield);
     free(table_name);
 
     return MS_FAILURE;
   }
 
-  query_str = "SELECT wktext FROM mdsys.all_sdo_geom_metadata m, mdsys.cs_srs c WHERE c.srid = m.srid and m.owner||'.'||m.table_name = :table_name and m.column_name = :geo_col_name "
-              "UNION SELECT wktext from mdsys.user_sdo_geom_metadata m, mdsys.cs_srs c WHERE c.srid = m.srid and m.table_name = :table_name and m.column_name = :geo_col_name";
-
-  if (layer->debug>=2)
-    msDebug("msOracleSpatialLayerGetAutoProjection. Using this Sql to retrieve the projection: %s.\n", query_str);
+  query_str = "SELECT wktext FROM mdsys.all_sdo_geom_metadata m, mdsys.cs_srs "
+              "c WHERE c.srid = m.srid and m.owner||'.'||m.table_name = "
+              ":table_name and m.column_name = :geo_col_name "
+              "UNION SELECT wktext from mdsys.user_sdo_geom_metadata m, "
+              "mdsys.cs_srs c WHERE c.srid = m.srid and m.table_name = "
+              ":table_name and m.column_name = :geo_col_name";
+
+  if (layer->debug >= 2)
+    msDebug("msOracleSpatialLayerGetAutoProjection. Using this Sql to retrieve "
+            "the projection: %s.\n",
+            query_str);
 
   /*Prepare the handlers to the query*/
-  success = TRY( hand, OCIStmtPrepare( sthand->stmthp, hand->errhp, (text *)query_str, (ub4)strlen(query_str), (ub4)OCI_NTV_SYNTAX, (ub4)OCI_DEFAULT ) )
-            && TRY( hand, OCIBindByName( sthand->stmthp, &bnd2p, hand->errhp, (text *) ":table_name", strlen(":table_name"), (ub1*) table_name, strlen(table_name)+1, SQLT_STR, (dvoid *) 0, (ub2 *) 0, (ub2) 0, (ub4) 0, (ub4 *) 0, OCI_DEFAULT ) )
-            && TRY( hand, OCIBindByName( sthand->stmthp, &bnd1p, hand->errhp, (text *) ":geo_col_name", strlen(":geo_col_name"), (ub1*) geom_column_name, strlen(geom_column_name)+1, SQLT_STR, (dvoid *) 0, (ub2 *) 0, (ub2) 0, (ub4) 0, (ub4 *) 0, OCI_DEFAULT ) )
-            && TRY( hand, OCIDefineByPos( sthand->stmthp, &def1p, hand->errhp, (ub4)1, (dvoid *)wktext, (sb4)4000, SQLT_STR, (dvoid *)0, (ub2 *)0, (ub2 *)0, (ub4)OCI_DEFAULT ) )
-            && TRY( hand, OCIStmtExecute( hand->svchp, sthand->stmthp, hand->errhp, (ub4)0, (ub4)0, (OCISnapshot *)NULL, (OCISnapshot *)NULL, (ub4)OCI_DEFAULT ) )
-            && TRY( hand, OCIAttrGet( (dvoid *)sthand->stmthp, (ub4)OCI_HTYPE_STMT, (dvoid *)&sthand->rows_fetched, (ub4 *)0, (ub4)OCI_ATTR_ROWS_FETCHED, hand->errhp ) );
-
-  if(!success) {
-    msDebug( "Error: %s . "
-                "Query statement: %s . "
-                "Check your data statement."
-                "in msOracleSpatialLayerGetAutoProjection()\n", hand->last_oci_error, query_str );
-    msSetError( MS_ORACLESPATIALERR,
-                "Error "
-                "Check your data statement and server logs",
-                "msOracleSpatialLayerGetAutoProjection()" );
-
-    if (geom_column_name) free(geom_column_name);
-    if (srid) free(srid);
-    if (unique) free(unique);
-    if (indexfield) free(indexfield);
+  success =
+      TRY(hand, OCIStmtPrepare(sthand->stmthp, hand->errhp, (text *)query_str,
+                               (ub4)strlen(query_str), (ub4)OCI_NTV_SYNTAX,
+                               (ub4)OCI_DEFAULT)) &&
+      TRY(hand, OCIBindByName(sthand->stmthp, &bnd2p, hand->errhp,
+                              (text *)":table_name", strlen(":table_name"),
+                              (ub1 *)table_name, strlen(table_name) + 1,
+                              SQLT_STR, (dvoid *)0, (ub2 *)0, (ub2)0, (ub4)0,
+                              (ub4 *)0, OCI_DEFAULT)) &&
+      TRY(hand,
+          OCIBindByName(sthand->stmthp, &bnd1p, hand->errhp,
+                        (text *)":geo_col_name", strlen(":geo_col_name"),
+                        (ub1 *)geom_column_name, strlen(geom_column_name) + 1,
+                        SQLT_STR, (dvoid *)0, (ub2 *)0, (ub2)0, (ub4)0,
+                        (ub4 *)0, OCI_DEFAULT)) &&
+      TRY(hand, OCIDefineByPos(sthand->stmthp, &def1p, hand->errhp, (ub4)1,
+                               (dvoid *)wktext, (sb4)4000, SQLT_STR, (dvoid *)0,
+                               (ub2 *)0, (ub2 *)0, (ub4)OCI_DEFAULT)) &&
+      TRY(hand, OCIStmtExecute(hand->svchp, sthand->stmthp, hand->errhp, (ub4)0,
+                               (ub4)0, (OCISnapshot *)NULL, (OCISnapshot *)NULL,
+                               (ub4)OCI_DEFAULT)) &&
+      TRY(hand, OCIAttrGet((dvoid *)sthand->stmthp, (ub4)OCI_HTYPE_STMT,
+                           (dvoid *)&sthand->rows_fetched, (ub4 *)0,
+                           (ub4)OCI_ATTR_ROWS_FETCHED, hand->errhp));
+
+  if (!success) {
+    msDebug("Error: %s . "
+            "Query statement: %s . "
+            "Check your data statement."
+            "in msOracleSpatialLayerGetAutoProjection()\n",
+            hand->last_oci_error, query_str);
+    msSetError(MS_ORACLESPATIALERR,
+               "Error "
+               "Check your data statement and server logs",
+               "msOracleSpatialLayerGetAutoProjection()");
+
+    if (geom_column_name)
+      free(geom_column_name);
+    if (srid)
+      free(srid);
+    if (unique)
+      free(unique);
+    if (indexfield)
+      free(indexfield);
     free(table_name);
     return MS_FAILURE;
   }
   do {
-    success = TRY( hand, OCIStmtFetch( sthand->stmthp, hand->errhp, (ub4)1, (ub2)OCI_FETCH_NEXT, (ub4)OCI_DEFAULT ) )
-              && TRY( hand, OCIAttrGet( (dvoid *)sthand->stmthp, (ub4)OCI_HTYPE_STMT, (dvoid *)&sthand->rows_fetched, (ub4 *)0, (ub4)OCI_ATTR_ROWS_FETCHED, hand->errhp ) );
+    success = TRY(hand, OCIStmtFetch(sthand->stmthp, hand->errhp, (ub4)1,
+                                     (ub2)OCI_FETCH_NEXT, (ub4)OCI_DEFAULT)) &&
+              TRY(hand, OCIAttrGet((dvoid *)sthand->stmthp, (ub4)OCI_HTYPE_STMT,
+                                   (dvoid *)&sthand->rows_fetched, (ub4 *)0,
+                                   (ub4)OCI_ATTR_ROWS_FETCHED, hand->errhp));
     if (success && sthand->rows_fetched > 0) {
 
-      if( layer->debug )
+      if (layer->debug)
         msDebug("Found WKT projection for table %s: %s\n", table_name, wktext);
 
-      if(wktext != NULL && projection != NULL)
-        if(msOGCWKT2ProjectionObj(wktext, projection, layer->debug) == MS_FAILURE)
-          return(MS_FAILURE);
+      if (wktext != NULL && projection != NULL)
+        if (msOGCWKT2ProjectionObj(wktext, projection, layer->debug) ==
+            MS_FAILURE)
+          return (MS_FAILURE);
     }
   } while (sthand->rows_fetched > 0);
 
-  if (geom_column_name) free(geom_column_name);
-  if (srid) free(srid);
-  if (unique) free(unique);
-  if (indexfield) free(indexfield);
+  if (geom_column_name)
+    free(geom_column_name);
+  if (srid)
+    free(srid);
+  if (unique)
+    free(unique);
+  if (indexfield)
+    free(indexfield);
   free(table_name);
   return MS_SUCCESS;
 }
@@ -2886,11 +3402,9 @@ int msOracleSpatialLayerGetAutoProjectio
  * "gml_[item]_{type,width,precision}" set of metadata items for
  * defining fields.
  **********************************************************************/
-static void
-msOracleSpatialGetFieldDefn( layerObj *layer,
-                             msOracleSpatialHandler *hand,
-                             const char *item,
-                             OCIParam *pard )
+static void msOracleSpatialGetFieldDefn(layerObj *layer,
+                                        msOracleSpatialHandler *hand,
+                                        const char *item, OCIParam *pard)
 
 {
   const char *gml_type = "Character";
@@ -2904,82 +3418,77 @@ msOracleSpatialGetFieldDefn( layerObj *l
   /* -------------------------------------------------------------------- */
   /*      Get basic parameter details.                                    */
   /* -------------------------------------------------------------------- */
-  success =
-    TRY( hand, OCIAttrGet ((dvoid *) pard,(ub4) OCI_DTYPE_PARAM,
-                           (dvoid*)&rzttype,(ub4 *)0,
-                           (ub4) OCI_ATTR_DATA_TYPE, hand->errhp ))
-    && TRY( hand, OCIAttrGet ((dvoid *) pard,(ub4) OCI_DTYPE_PARAM,
-                              (dvoid*)&nOCILen ,(ub4 *)0,
-                              (ub4) OCI_ATTR_DATA_SIZE, hand->errhp ));
+  success = TRY(hand, OCIAttrGet((dvoid *)pard, (ub4)OCI_DTYPE_PARAM,
+                                 (dvoid *)&rzttype, (ub4 *)0,
+                                 (ub4)OCI_ATTR_DATA_TYPE, hand->errhp)) &&
+            TRY(hand, OCIAttrGet((dvoid *)pard, (ub4)OCI_DTYPE_PARAM,
+                                 (dvoid *)&nOCILen, (ub4 *)0,
+                                 (ub4)OCI_ATTR_DATA_SIZE, hand->errhp));
 
-  if( !success )
+  if (!success)
     return;
 
-  switch( rzttype ) {
-    case SQLT_CHR:
-    case SQLT_AFC:
-      gml_type = "Character";
-      if( nOCILen <= 4000 )
-        sprintf( gml_width, "%d", nOCILen );
-      break;
-
-    case SQLT_NUM: {
-      /* NOTE: OCI docs say this should be ub1 type, but we have
-         determined that oracle is actually returning a short so we
-         use that type and try to compensate for possible problems by
-         initializing, and dividing by 256 if it is large. */
-      unsigned short byPrecision = 0;
-      sb1 nScale = 0;
-
-      if( !TRY( hand, OCIAttrGet ((dvoid *) pard,(ub4) OCI_DTYPE_PARAM,
-                                  (dvoid*)&byPrecision ,(ub4 *)0,
-                                  (ub4) OCI_ATTR_PRECISION,
-                                  hand->errhp ))
-          || !TRY( hand, OCIAttrGet ((dvoid *) pard,(ub4) OCI_DTYPE_PARAM,
-                                     (dvoid*)&nScale,(ub4 *)0,
-                                     (ub4) OCI_ATTR_SCALE,
-                                     hand->errhp )) )
-        return;
-      if( byPrecision > 255 )
-        byPrecision = byPrecision / 256;
-
-      if( nScale > 0 ) {
-        gml_type = "Real";
-        sprintf( gml_width, "%d", byPrecision );
-        sprintf( gml_precision, "%d", nScale );
-      } else if( nScale < 0 )
-        gml_type = "Real";
-      else {
-        gml_type = "Integer";
-        if( byPrecision < 38 )
-          sprintf( gml_width, "%d", byPrecision );
-      }
-    }
+  switch (rzttype) {
+  case SQLT_CHR:
+  case SQLT_AFC:
+    gml_type = "Character";
+    if (nOCILen <= 4000)
+      sprintf(gml_width, "%d", nOCILen);
     break;
 
-    case SQLT_DAT:
-    case SQLT_DATE:
-      gml_type = "Date";
-      break;
-    case SQLT_TIMESTAMP:
-    case SQLT_TIMESTAMP_TZ:
-    case SQLT_TIMESTAMP_LTZ:
-      gml_type = "DateTime";
-      break;
-    case SQLT_TIME:
-    case SQLT_TIME_TZ:
-      gml_type = "Time";
-      break;
+  case SQLT_NUM: {
+    /* NOTE: OCI docs say this should be ub1 type, but we have
+       determined that oracle is actually returning a short so we
+       use that type and try to compensate for possible problems by
+       initializing, and dividing by 256 if it is large. */
+    unsigned short byPrecision = 0;
+    sb1 nScale = 0;
+
+    if (!TRY(hand, OCIAttrGet((dvoid *)pard, (ub4)OCI_DTYPE_PARAM,
+                              (dvoid *)&byPrecision, (ub4 *)0,
+                              (ub4)OCI_ATTR_PRECISION, hand->errhp)) ||
+        !TRY(hand,
+             OCIAttrGet((dvoid *)pard, (ub4)OCI_DTYPE_PARAM, (dvoid *)&nScale,
+                        (ub4 *)0, (ub4)OCI_ATTR_SCALE, hand->errhp)))
+      return;
+    if (byPrecision > 255)
+      byPrecision = byPrecision / 256;
+
+    if (nScale > 0) {
+      gml_type = "Real";
+      sprintf(gml_width, "%d", byPrecision);
+      sprintf(gml_precision, "%d", nScale);
+    } else if (nScale < 0)
+      gml_type = "Real";
+    else {
+      gml_type = "Integer";
+      if (byPrecision < 38)
+        sprintf(gml_width, "%d", byPrecision);
+    }
+  } break;
+
+  case SQLT_DAT:
+  case SQLT_DATE:
+    gml_type = "Date";
+    break;
+  case SQLT_TIMESTAMP:
+  case SQLT_TIMESTAMP_TZ:
+  case SQLT_TIMESTAMP_LTZ:
+    gml_type = "DateTime";
+    break;
+  case SQLT_TIME:
+  case SQLT_TIME_TZ:
+    gml_type = "Time";
+    break;
 
-    default:
-      gml_type = "Character";
+  default:
+    gml_type = "Character";
   }
 
-    msUpdateGMLFieldMetadata(layer, item, gml_type, gml_width, gml_precision, 0);
+  msUpdateGMLFieldMetadata(layer, item, gml_type, gml_width, gml_precision, 0);
 }
 
-int msOracleSpatialLayerGetItems( layerObj *layer )
-{
+int msOracleSpatialLayerGetItems(layerObj *layer) {
   char *rzt = "";
   ub2 rzttype = 0;
   char *flk = "";
@@ -2988,95 +3497,133 @@ int msOracleSpatialLayerGetItems( layerO
   int existgeom;
   int count_item, flk_len, success, i;
   char *table_name;
-  char * query_str = NULL, *geom_column_name = NULL, *unique = NULL, *srid = NULL, *indexfield=NULL;
-  OCIParam *pard = (OCIParam *) 0;
+  char *query_str = NULL, *geom_column_name = NULL, *unique = NULL,
+       *srid = NULL, *indexfield = NULL;
+  OCIParam *pard = (OCIParam *)0;
 
-  msOracleSpatialLayerInfo *layerinfo = (msOracleSpatialLayerInfo *) layer->layerinfo;
+  msOracleSpatialLayerInfo *layerinfo =
+      (msOracleSpatialLayerInfo *)layer->layerinfo;
   msOracleSpatialHandler *hand = NULL;
   msOracleSpatialStatement *sthand = NULL;
   int get_field_details = 0;
   const char *value;
 
-  if (layer->debug>=3)
+  if (layer->debug >= 3)
     msDebug("msOracleSpatialLayerGetItems was called.\n");
 
   if (layerinfo == NULL) {
-    msSetError( MS_ORACLESPATIALERR, "msOracleSpatialLayerGetItems called on unopened layer", "msOracleSpatialLayerGetItems()" );
+    msSetError(MS_ORACLESPATIALERR,
+               "msOracleSpatialLayerGetItems called on unopened layer",
+               "msOracleSpatialLayerGetItems()");
     return MS_FAILURE;
   } else {
     hand = (msOracleSpatialHandler *)layerinfo->orahandlers;
-    sthand = (msOracleSpatialStatement *) layerinfo->orastmt;
+    sthand = (msOracleSpatialStatement *)layerinfo->orastmt;
   }
 
   /* Will we want to capture the field details? */
-  if((value = msOWSLookupMetadata(&(layer->metadata), "G", "types")) != NULL
-      && strcasecmp(value,"auto") == 0 )
+  if ((value = msOWSLookupMetadata(&(layer->metadata), "G", "types")) != NULL &&
+      strcasecmp(value, "auto") == 0)
     get_field_details = 1;
 
-  table_name = (char *) malloc(sizeof(char) * TABLE_NAME_SIZE);
-  if (!msSplitData(layer->data, &geom_column_name, &table_name, &unique, &srid, &indexfield, &function, &version)) {
-    msDebug(   "Error parsing OracleSpatial DATA variable. Must be: "
-                "'geometry_column FROM table_name [USING UNIQUE <column> SRID srid# FUNCTION]' or "
-                "'geometry_column FROM (SELECT stmt) [USING UNIQUE <column> SRID srid# FUNCTION]'. "
-                "If want to set the FUNCTION statement you can use: FILTER, RELATE, GEOMRELATE or NONE. "
-                "Your data statement: (%s)"
-                "in msOracleSpatialLayerGetItems()\n", layer->data );
-    msSetError( MS_ORACLESPATIALERR,
-                "Error parsing OracleSpatial DATA variable. Check server logs. ",
-                "msOracleSpatialLayerGetItems()");
-
-    if (geom_column_name) free(geom_column_name);
-    if (srid) free(srid);
-    if (unique) free(unique);
-    if (indexfield) free(indexfield);
+  table_name = (char *)malloc(sizeof(char) * TABLE_NAME_SIZE);
+  if (!msSplitData(layer->data, &geom_column_name, &table_name, &unique, &srid,
+                   &indexfield, &function, &version)) {
+    msDebug("Error parsing OracleSpatial DATA variable. Must be: "
+            "'geometry_column FROM table_name [USING UNIQUE <column> SRID "
+            "srid# FUNCTION]' or "
+            "'geometry_column FROM (SELECT stmt) [USING UNIQUE <column> SRID "
+            "srid# FUNCTION]'. "
+            "If want to set the FUNCTION statement you can use: FILTER, "
+            "RELATE, GEOMRELATE or NONE. "
+            "Your data statement: (%s)"
+            "in msOracleSpatialLayerGetItems()\n",
+            layer->data);
+    msSetError(MS_ORACLESPATIALERR,
+               "Error parsing OracleSpatial DATA variable. Check server logs. ",
+               "msOracleSpatialLayerGetItems()");
+
+    if (geom_column_name)
+      free(geom_column_name);
+    if (srid)
+      free(srid);
+    if (unique)
+      free(unique);
+    if (indexfield)
+      free(indexfield);
     free(table_name);
     return MS_FAILURE;
   }
   query_str = msStringConcatenate(query_str, "SELECT * FROM ");
   query_str = msStringConcatenate(query_str, table_name);
 
-  success =  TRY( hand, OCIStmtPrepare( sthand->stmthp, hand->errhp, (text *)query_str, (ub4)strlen(query_str), (ub4)OCI_NTV_SYNTAX, (ub4)OCI_DESCRIBE_ONLY) )
-             && TRY( hand, OCIStmtExecute( hand->svchp, sthand->stmthp, hand->errhp, (ub4)QUERY_SIZE, (ub4)0, (OCISnapshot *)NULL, (OCISnapshot *)NULL, (ub4)OCI_DESCRIBE_ONLY ) )
-             && TRY( hand, OCIAttrGet( (dvoid *)sthand->stmthp, (ub4)OCI_HTYPE_STMT, (dvoid *)&layer->numitems, (ub4 *)0, OCI_ATTR_PARAM_COUNT, hand->errhp) );
-
+  success =
+      TRY(hand, OCIStmtPrepare(sthand->stmthp, hand->errhp, (text *)query_str,
+                               (ub4)strlen(query_str), (ub4)OCI_NTV_SYNTAX,
+                               (ub4)OCI_DESCRIBE_ONLY)) &&
+      TRY(hand, OCIStmtExecute(hand->svchp, sthand->stmthp, hand->errhp,
+                               (ub4)QUERY_SIZE, (ub4)0, (OCISnapshot *)NULL,
+                               (OCISnapshot *)NULL, (ub4)OCI_DESCRIBE_ONLY)) &&
+      TRY(hand, OCIAttrGet((dvoid *)sthand->stmthp, (ub4)OCI_HTYPE_STMT,
+                           (dvoid *)&layer->numitems, (ub4 *)0,
+                           OCI_ATTR_PARAM_COUNT, hand->errhp));
 
   if (!success) {
-    msSetError( MS_QUERYERR, "Cannot retrieve column list", "msOracleSpatialLayerGetItems()" );
-    if (geom_column_name) free(geom_column_name);
-    if (srid) free(srid);
-    if (unique) free(unique);
-    if (indexfield) free(indexfield);
-    if (query_str) free(query_str);
+    msSetError(MS_QUERYERR, "Cannot retrieve column list",
+               "msOracleSpatialLayerGetItems()");
+    if (geom_column_name)
+      free(geom_column_name);
+    if (srid)
+      free(srid);
+    if (unique)
+      free(unique);
+    if (indexfield)
+      free(indexfield);
+    if (query_str)
+      free(query_str);
     free(table_name);
     return MS_FAILURE;
   }
 
   sthand->row_num = sthand->row = 0;
-  layer->numitems = layer->numitems-1;
+  layer->numitems = layer->numitems - 1;
 
-  layer->items = malloc (sizeof(char *) * (layer->numitems));
+  layer->items = malloc(sizeof(char *) * (layer->numitems));
   if (layer->items == NULL) {
-    msSetError( MS_ORACLESPATIALERR,"Cannot allocate items", "msOracleSpatialLayerGetItems()" );
-    if (geom_column_name) free(geom_column_name);
-    if (srid) free(srid);
-    if (unique) free(unique);
-    if (indexfield) free(indexfield);
-    if (query_str) free(query_str);
+    msSetError(MS_ORACLESPATIALERR, "Cannot allocate items",
+               "msOracleSpatialLayerGetItems()");
+    if (geom_column_name)
+      free(geom_column_name);
+    if (srid)
+      free(srid);
+    if (unique)
+      free(unique);
+    if (indexfield)
+      free(indexfield);
+    if (query_str)
+      free(query_str);
     free(table_name);
     return MS_FAILURE;
   }
 
   if (layer->numitems > 0) {
     if (sthand->items_query == NULL)
-      sthand->items_query = (item_text_array_query *)malloc( sizeof(item_text_array_query) * (layer->numitems) );
+      sthand->items_query = (item_text_array_query *)malloc(
+          sizeof(item_text_array_query) * (layer->numitems));
 
     if (sthand->items_query == NULL) {
-      msSetError( MS_ORACLESPATIALERR,"Cannot allocate items buffer", "msOracleSpatialLayerGetItems()" );
-      if (geom_column_name) free(geom_column_name);
-      if (srid) free(srid);
-      if (unique) free(unique);
-      if (indexfield) free(indexfield);
-      if (query_str) free(query_str);
+      msSetError(MS_ORACLESPATIALERR, "Cannot allocate items buffer",
+                 "msOracleSpatialLayerGetItems()");
+      if (geom_column_name)
+        free(geom_column_name);
+      if (srid)
+        free(srid);
+      if (unique)
+        free(unique);
+      if (indexfield)
+        free(indexfield);
+      if (query_str)
+        free(query_str);
       free(table_name);
       return MS_FAILURE;
     }
@@ -3086,43 +3633,62 @@ int msOracleSpatialLayerGetItems( layerO
   existgeom = 0;
 
   /*Upcase conversion for the geom_column_name*/
-  for (i=0; geom_column_name[i] != '\0'; i++)
+  for (i = 0; geom_column_name[i] != '\0'; i++)
     geom_column_name[i] = toupper(geom_column_name[i]);
 
   /*Retrive columns name from the user table*/
   for (i = 0; i <= layer->numitems; i++) {
 
-    success = TRY( hand, OCIParamGet ((dvoid*) sthand->stmthp, (ub4)OCI_HTYPE_STMT,hand->errhp,(dvoid*)&pard, (ub4)i+1))
-              && TRY( hand, OCIAttrGet ((dvoid *) pard,(ub4) OCI_DTYPE_PARAM,(dvoid*)&rzttype,(ub4 *)0, (ub4) OCI_ATTR_DATA_TYPE, hand->errhp ))
-              && TRY( hand, OCIParamGet ((dvoid*) sthand->stmthp, (ub4)OCI_HTYPE_STMT,hand->errhp,(dvoid*)&pard, (ub4)i+1))
-              && TRY( hand, OCIAttrGet ((dvoid *) pard,(ub4) OCI_DTYPE_PARAM,(dvoid*)&rzt,(ub4 *)&flk_len, (ub4) OCI_ATTR_NAME, hand->errhp ));
-
-     /*  if (layer->debug)
-            msDebug("msOracleSpatialLayerGetItems checking type. Column = %s Type = %d\n", rzt, rzttype);  */
-    flk = (char *)malloc(sizeof(char*) * flk_len+1);
+    success =
+        TRY(hand, OCIParamGet((dvoid *)sthand->stmthp, (ub4)OCI_HTYPE_STMT,
+                              hand->errhp, (dvoid *)&pard, (ub4)i + 1)) &&
+        TRY(hand,
+            OCIAttrGet((dvoid *)pard, (ub4)OCI_DTYPE_PARAM, (dvoid *)&rzttype,
+                       (ub4 *)0, (ub4)OCI_ATTR_DATA_TYPE, hand->errhp)) &&
+        TRY(hand, OCIParamGet((dvoid *)sthand->stmthp, (ub4)OCI_HTYPE_STMT,
+                              hand->errhp, (dvoid *)&pard, (ub4)i + 1)) &&
+        TRY(hand, OCIAttrGet((dvoid *)pard, (ub4)OCI_DTYPE_PARAM, (dvoid *)&rzt,
+                             (ub4 *)&flk_len, (ub4)OCI_ATTR_NAME, hand->errhp));
+
+    /*  if (layer->debug)
+           msDebug("msOracleSpatialLayerGetItems checking type. Column = %s Type
+       = %d\n", rzt, rzttype);  */
+    flk = (char *)malloc(sizeof(char *) * flk_len + 1);
     if (flk == NULL) {
-      msSetError( MS_ORACLESPATIALERR, "No memory avaliable to allocate the items", "msOracleSpatialLayerGetItems()" );
-      if (geom_column_name) free(geom_column_name);
-      if (srid) free(srid);
-      if (unique) free(unique);
-      if (query_str) free(query_str);
+      msSetError(MS_ORACLESPATIALERR,
+                 "No memory avaliable to allocate the items",
+                 "msOracleSpatialLayerGetItems()");
+      if (geom_column_name)
+        free(geom_column_name);
+      if (srid)
+        free(srid);
+      if (unique)
+        free(unique);
+      if (query_str)
+        free(query_str);
       free(table_name);
       return MS_FAILURE;
     } else {
-      //layer->iteminfo->dtype[i]= 1;
-      strlcpy(flk, rzt, flk_len+1);
+      // layer->iteminfo->dtype[i]= 1;
+      strlcpy(flk, rzt, flk_len + 1);
     }
 
     /*Comapre the column name (flk) with geom_column_name and ignore with true*/
     if (strcmp(flk, geom_column_name) != 0) {
-      if (rzttype!=OCI_TYPECODE_BLOB) {
-        layer->items[count_item] = (char *)malloc(sizeof(char) * flk_len+1);
+      if (rzttype != OCI_TYPECODE_BLOB) {
+        layer->items[count_item] = (char *)malloc(sizeof(char) * flk_len + 1);
         if (layer->items[count_item] == NULL) {
-          msSetError( MS_ORACLESPATIALERR, "No memory avaliable to allocate the items buffer", "msOracleSpatialLayerGetItems()" );
-          if (geom_column_name) free(geom_column_name);
-          if (srid) free(srid);
-          if (unique) free(unique);
-          if (query_str) free(query_str);
+          msSetError(MS_ORACLESPATIALERR,
+                     "No memory avaliable to allocate the items buffer",
+                     "msOracleSpatialLayerGetItems()");
+          if (geom_column_name)
+            free(geom_column_name);
+          if (srid)
+            free(srid);
+          if (unique)
+            free(unique);
+          if (query_str)
+            free(query_str);
           free(table_name);
           return MS_FAILURE;
         }
@@ -3130,15 +3696,14 @@ int msOracleSpatialLayerGetItems( layerO
         strcpy(layer->items[count_item], flk);
         count_item++;
 
-       if( get_field_details )
-          msOracleSpatialGetFieldDefn( layer, hand,
-                                       layer->items[count_item-1],
-                                       pard );
+        if (get_field_details)
+          msOracleSpatialGetFieldDefn(layer, hand, layer->items[count_item - 1],
+                                      pard);
       }
     } else
       existgeom = 1;
 
-    strcpy( rzt, "" );
+    strcpy(rzt, "");
     free(flk); /* Better?!*/
     flk_len = 0;
   }
@@ -3146,29 +3711,40 @@ int msOracleSpatialLayerGetItems( layerO
   layer->numitems = count_item;
 
   if (!(existgeom)) {
-    msSetError (MS_ORACLESPATIALERR, "No geometry column, check stmt", "msOracleSpatialLayerGetItems()" );
-    if (geom_column_name) free(geom_column_name);
-    if (srid) free(srid);
-    if (unique) free(unique);
-    if (indexfield) free(indexfield);
-    if (query_str) free(query_str);
+    msSetError(MS_ORACLESPATIALERR, "No geometry column, check stmt",
+               "msOracleSpatialLayerGetItems()");
+    if (geom_column_name)
+      free(geom_column_name);
+    if (srid)
+      free(srid);
+    if (unique)
+      free(unique);
+    if (indexfield)
+      free(indexfield);
+    if (query_str)
+      free(query_str);
     free(table_name);
     return MS_FAILURE;
   }
 
-  if (geom_column_name) free(geom_column_name);
-  if (srid) free(srid);
-  if (unique) free(unique);
-  if (indexfield) free(indexfield);
-  if (query_str) free(query_str);
+  if (geom_column_name)
+    free(geom_column_name);
+  if (srid)
+    free(srid);
+  if (unique)
+    free(unique);
+  if (indexfield)
+    free(indexfield);
+  if (query_str)
+    free(query_str);
   free(table_name);
-  return msOracleSpatialLayerInitItemInfo( layer );
+  return msOracleSpatialLayerInitItemInfo(layer);
 }
 
-int msOracleSpatialLayerGetExtent(layerObj *layer, rectObj *extent)
-{
+int msOracleSpatialLayerGetExtent(layerObj *layer, rectObj *extent) {
   char *table_name;
-  char * query_str = NULL, *geom_column_name = NULL, *unique = NULL, *srid = NULL, *indexfield=NULL;
+  char *query_str = NULL, *geom_column_name = NULL, *unique = NULL,
+       *srid = NULL, *indexfield = NULL;
   int success, i;
   int function = 0;
   int version = 0;
@@ -3180,56 +3756,71 @@ int msOracleSpatialLayerGetExtent(layerO
   OCIDefine *adtp = NULL;
   OCIDefine **items = NULL;
 
-  msOracleSpatialLayerInfo *layerinfo = (msOracleSpatialLayerInfo *)layer->layerinfo;
+  msOracleSpatialLayerInfo *layerinfo =
+      (msOracleSpatialLayerInfo *)layer->layerinfo;
   msOracleSpatialDataHandler *dthand = NULL;
   msOracleSpatialHandler *hand = NULL;
   msOracleSpatialStatement *sthand = NULL;
 
-  if (layer->debug>=3)
+  if (layer->debug >= 3)
     msDebug("msOracleSpatialLayerGetExtent was called.\n");
 
   if (layerinfo == NULL) {
-    msSetError( MS_ORACLESPATIALERR, "msOracleSpatialLayerGetExtent called on unopened layer","msOracleSpatialLayerGetExtent()");
+    msSetError(MS_ORACLESPATIALERR,
+               "msOracleSpatialLayerGetExtent called on unopened layer",
+               "msOracleSpatialLayerGetExtent()");
     return MS_FAILURE;
   } else {
     dthand = (msOracleSpatialDataHandler *)layerinfo->oradatahandlers;
     hand = (msOracleSpatialHandler *)layerinfo->orahandlers;
-    sthand = (msOracleSpatialStatement *) layerinfo->orastmt;
+    sthand = (msOracleSpatialStatement *)layerinfo->orastmt;
   }
 
   /* allocate enough space for items */
   if (layer->numitems > 0) {
-    sthand->items_query = (item_text_array_query *)malloc( sizeof(item_text_array_query) * (layer->numitems) );
+    sthand->items_query = (item_text_array_query *)malloc(
+        sizeof(item_text_array_query) * (layer->numitems));
     if (sthand->items_query == NULL) {
-      msSetError( MS_ORACLESPATIALERR, "Cannot allocate layerinfo->items buffer", "msOracleSpatialLayerGetExtent()" );
+      msSetError(MS_ORACLESPATIALERR, "Cannot allocate layerinfo->items buffer",
+                 "msOracleSpatialLayerGetExtent()");
       return MS_FAILURE;
     }
-    items = (OCIDefine **)malloc(sizeof(OCIDefine *)*layer->numitems);
+    items = (OCIDefine **)malloc(sizeof(OCIDefine *) * layer->numitems);
     if (items == NULL) {
-      msSetError( MS_ORACLESPATIALERR,"Cannot allocate items buffer","msOracleSpatialLayerWhichShapes()" );
+      msSetError(MS_ORACLESPATIALERR, "Cannot allocate items buffer",
+                 "msOracleSpatialLayerWhichShapes()");
       return MS_FAILURE;
     }
-    memset(items ,0,sizeof(OCIDefine *)*layer->numitems);
+    memset(items, 0, sizeof(OCIDefine *) * layer->numitems);
   }
 
-  table_name = (char *) malloc(sizeof(char) * TABLE_NAME_SIZE);
-  if (!msSplitData( layer->data, &geom_column_name, &table_name, &unique, &srid, &indexfield, &function, &version )) {
-    msDebug(   "Error parsing OracleSpatial DATA variable. Must be: "
-                "'geometry_column FROM table_name [USING UNIQUE <column> SRID srid# FUNCTION]' or "
-                "'geometry_column FROM (SELECT stmt) [USING UNIQUE <column> SRID srid# FUNCTION]'. "
-                "If want to set the FUNCTION statement you can use: FILTER, RELATE, GEOMRELATE or NONE. "
-                "Your data statement: (%s) "
-                "in msOracleSpatialLayerGetExtent()\n", layer->data );
-    msSetError( MS_ORACLESPATIALERR,
-                "Error parsing OracleSpatial DATA variable. Check server logs. ",
-                "msOracleSpatialLayerGetExtent()");
+  table_name = (char *)malloc(sizeof(char) * TABLE_NAME_SIZE);
+  if (!msSplitData(layer->data, &geom_column_name, &table_name, &unique, &srid,
+                   &indexfield, &function, &version)) {
+    msDebug("Error parsing OracleSpatial DATA variable. Must be: "
+            "'geometry_column FROM table_name [USING UNIQUE <column> SRID "
+            "srid# FUNCTION]' or "
+            "'geometry_column FROM (SELECT stmt) [USING UNIQUE <column> SRID "
+            "srid# FUNCTION]'. "
+            "If want to set the FUNCTION statement you can use: FILTER, "
+            "RELATE, GEOMRELATE or NONE. "
+            "Your data statement: (%s) "
+            "in msOracleSpatialLayerGetExtent()\n",
+            layer->data);
+    msSetError(MS_ORACLESPATIALERR,
+               "Error parsing OracleSpatial DATA variable. Check server logs. ",
+               "msOracleSpatialLayerGetExtent()");
     /* clean items */
     free(items);
 
-    if (geom_column_name) free(geom_column_name);
-    if (srid) free(srid);
-    if (unique) free(unique);
-    if (indexfield) free(indexfield);
+    if (geom_column_name)
+      free(geom_column_name);
+    if (srid)
+      free(srid);
+    if (unique)
+      free(unique);
+    if (indexfield)
+      free(indexfield);
     free(table_name);
 
     return MS_FAILURE;
@@ -3237,65 +3828,92 @@ int msOracleSpatialLayerGetExtent(layerO
 
   query_str = osAggrGetExtent(layer, query_str, geom_column_name, table_name);
 
-  if (layer->debug>=3)
-    msDebug("msOracleSpatialLayerGetExtent. Using this Sql to retrieve the extent: %s.\n", query_str);
+  if (layer->debug >= 3)
+    msDebug("msOracleSpatialLayerGetExtent. Using this Sql to retrieve the "
+            "extent: %s.\n",
+            query_str);
 
   /*Prepare the handlers to the query*/
-  success = TRY( hand,OCIStmtPrepare( sthand->stmthp, hand->errhp, (text *)query_str, (ub4)strlen(query_str), (ub4)OCI_NTV_SYNTAX, (ub4)OCI_DEFAULT) );
+  success = TRY(hand, OCIStmtPrepare(sthand->stmthp, hand->errhp,
+                                     (text *)query_str, (ub4)strlen(query_str),
+                                     (ub4)OCI_NTV_SYNTAX, (ub4)OCI_DEFAULT));
 
   if (success && layer->numitems > 0) {
-    for( i = 0; i < layer->numitems && success; ++i )
-      success = TRY( hand, OCIDefineByPos( sthand->stmthp, &items[i], hand->errhp, (ub4)i+1, (dvoid *)sthand->items_query[i], (sb4)TEXT_SIZE, SQLT_STR, (dvoid *)0, (ub2 *)0, (ub2 *)0, (ub4)OCI_DEFAULT ) );
+    for (i = 0; i < layer->numitems && success; ++i)
+      success =
+          TRY(hand, OCIDefineByPos(sthand->stmthp, &items[i], hand->errhp,
+                                   (ub4)i + 1, (dvoid *)sthand->items_query[i],
+                                   (sb4)TEXT_SIZE, SQLT_STR, (dvoid *)0,
+                                   (ub2 *)0, (ub2 *)0, (ub4)OCI_DEFAULT));
   }
 
-  if(!success) {
-    msDebug(   "Error: %s . "
-                "Query statement: %s . "
-                "Check your data statement."
-                "in msOracleSpatialLayerGetExtent()\n", hand->last_oci_error, query_str );
-
-    msSetError( MS_ORACLESPATIALERR,
-                "Check your data statement and server logs",
-                "msOracleSpatialLayerGetExtent()" );
+  if (!success) {
+    msDebug("Error: %s . "
+            "Query statement: %s . "
+            "Check your data statement."
+            "in msOracleSpatialLayerGetExtent()\n",
+            hand->last_oci_error, query_str);
+
+    msSetError(MS_ORACLESPATIALERR, "Check your data statement and server logs",
+               "msOracleSpatialLayerGetExtent()");
 
     /* clean items */
     free(items);
 
-    if (query_str) free(query_str);
+    if (query_str)
+      free(query_str);
 
-    if (geom_column_name) free(geom_column_name);
-    if (srid) free(srid);
-    if (unique) free(unique);
-    if (indexfield) free(indexfield);
+    if (geom_column_name)
+      free(geom_column_name);
+    if (srid)
+      free(srid);
+    if (unique)
+      free(unique);
+    if (indexfield)
+      free(indexfield);
     free(table_name);
 
     return MS_FAILURE;
   }
 
   if (success) {
-    success = TRY( hand, OCIDefineByPos( sthand->stmthp, &adtp, hand->errhp, (ub4)layer->numitems+1, (dvoid *)0, (sb4)0, SQLT_NTY, (dvoid *)0, (ub2 *)0, (ub2 *)0, (ub4)OCI_DEFAULT) )
-              && TRY( hand, OCIDefineObject( adtp, hand->errhp, dthand->tdo, (dvoid **)sthand->obj, (ub4 *)0, (dvoid **)sthand->ind, (ub4 *)0 ) )
-              && TRY (hand, OCIStmtExecute( hand->svchp, sthand->stmthp, hand->errhp, (ub4)QUERY_SIZE, (ub4)0, (OCISnapshot *)NULL, (OCISnapshot *)NULL, (ub4)OCI_DEFAULT ))
-              && TRY (hand, OCIAttrGet( (dvoid *)sthand->stmthp, (ub4)OCI_HTYPE_STMT, (dvoid *)&sthand->rows_fetched, (ub4 *)0, (ub4)OCI_ATTR_ROW_COUNT, hand->errhp ));
-
+    success =
+        TRY(hand, OCIDefineByPos(sthand->stmthp, &adtp, hand->errhp,
+                                 (ub4)layer->numitems + 1, (dvoid *)0, (sb4)0,
+                                 SQLT_NTY, (dvoid *)0, (ub2 *)0, (ub2 *)0,
+                                 (ub4)OCI_DEFAULT)) &&
+        TRY(hand, OCIDefineObject(adtp, hand->errhp, dthand->tdo,
+                                  (dvoid **)sthand->obj, (ub4 *)0,
+                                  (dvoid **)sthand->ind, (ub4 *)0)) &&
+        TRY(hand, OCIStmtExecute(hand->svchp, sthand->stmthp, hand->errhp,
+                                 (ub4)QUERY_SIZE, (ub4)0, (OCISnapshot *)NULL,
+                                 (OCISnapshot *)NULL, (ub4)OCI_DEFAULT)) &&
+        TRY(hand, OCIAttrGet((dvoid *)sthand->stmthp, (ub4)OCI_HTYPE_STMT,
+                             (dvoid *)&sthand->rows_fetched, (ub4 *)0,
+                             (ub4)OCI_ATTR_ROW_COUNT, hand->errhp));
   }
 
-  if(!success) {
-    msDebug(    "Error: %s . "
-                "Query statement: %s ."
-                "Check your data statement."
-                "in msOracleSpatialLayerGetExtent()\n", hand->last_oci_error, query_str );
-    msSetError( MS_ORACLESPATIALERR,
-                "Check your data statement and server logs",
-                "msOracleSpatialLayerGetExtent()" );
+  if (!success) {
+    msDebug("Error: %s . "
+            "Query statement: %s ."
+            "Check your data statement."
+            "in msOracleSpatialLayerGetExtent()\n",
+            hand->last_oci_error, query_str);
+    msSetError(MS_ORACLESPATIALERR, "Check your data statement and server logs",
+               "msOracleSpatialLayerGetExtent()");
 
     /* clean items */
     free(items);
-    if (query_str) free(query_str);
-    if (geom_column_name) free(geom_column_name);
-    if (srid) free(srid);
-    if (unique) free(unique);
-    if (indexfield) free(indexfield);
+    if (query_str)
+      free(query_str);
+    if (geom_column_name)
+      free(geom_column_name);
+    if (srid)
+      free(srid);
+    if (unique)
+      free(unique);
+    if (indexfield)
+      free(indexfield);
     free(table_name);
 
     return MS_FAILURE;
@@ -3303,16 +3921,21 @@ int msOracleSpatialLayerGetExtent(layerO
 
   /* should begin processing first row */
   sthand->row_num = sthand->row = 0;
-  msInitShape( &shape );
+  msInitShape(&shape);
   do {
     /* is buffer empty? */
     if (sthand->row_num >= sthand->rows_fetched) {
       /* fetch more */
-      success = TRY( hand, OCIStmtFetch( sthand->stmthp, hand->errhp, (ub4)ARRAY_SIZE, (ub2)OCI_FETCH_NEXT, (ub4)OCI_DEFAULT ) )
-                && TRY( hand, OCIAttrGet( (dvoid *)sthand->stmthp, (ub4)OCI_HTYPE_STMT, (dvoid *)&sthand->rows_fetched, (ub4 *)0, (ub4)OCI_ATTR_ROW_COUNT, hand->errhp ) );
+      success =
+          TRY(hand, OCIStmtFetch(sthand->stmthp, hand->errhp, (ub4)ARRAY_SIZE,
+                                 (ub2)OCI_FETCH_NEXT, (ub4)OCI_DEFAULT)) &&
+          TRY(hand, OCIAttrGet((dvoid *)sthand->stmthp, (ub4)OCI_HTYPE_STMT,
+                               (dvoid *)&sthand->rows_fetched, (ub4 *)0,
+                               (ub4)OCI_ATTR_ROW_COUNT, hand->errhp));
 
-      if (!success || sthand->rows_fetched == 0 || sthand->row_num >= sthand->rows_fetched) {
-        hand->last_oci_status=MS_SUCCESS;
+      if (!success || sthand->rows_fetched == 0 ||
+          sthand->row_num >= sthand->rows_fetched) {
+        hand->last_oci_status = MS_SUCCESS;
         break;
       }
 
@@ -3323,45 +3946,61 @@ int msOracleSpatialLayerGetExtent(layerO
     if (sthand->rows_fetched == 0)
       break;
 
-    obj = sthand->obj[ sthand->row ];
-    ind = sthand->ind[ sthand->row ];
+    obj = sthand->obj[sthand->row];
+    ind = sthand->ind[sthand->row];
 
     /* get the items for the shape */
     shape.numvalues = layer->numitems;
-    shape.values = (char **) malloc(sizeof(char *) * layer->numitems);
+    shape.values = (char **)malloc(sizeof(char *) * layer->numitems);
     if (shape.values == NULL) {
-      msSetError( MS_ORACLESPATIALERR, "No memory avaliable to allocate the values.", "msOracleSpatialLayerGetExtent()" );
-      if (geom_column_name) free(geom_column_name);
-      if (srid) free(srid);
-      if (unique) free(unique);
-      if (indexfield) free(indexfield);
-      if (query_str) free(query_str);
+      msSetError(MS_ORACLESPATIALERR,
+                 "No memory avaliable to allocate the values.",
+                 "msOracleSpatialLayerGetExtent()");
+      if (geom_column_name)
+        free(geom_column_name);
+      if (srid)
+        free(srid);
+      if (unique)
+        free(unique);
+      if (indexfield)
+        free(indexfield);
+      if (query_str)
+        free(query_str);
       free(table_name);
       return MS_FAILURE;
     }
 
     shape.index = sthand->row_num;
 
-    for( i = 0; i < layer->numitems; ++i ) {
-      shape.values[i] = (char *)malloc(strlen((char *)sthand->items_query[sthand->row][i])+1);
+    for (i = 0; i < layer->numitems; ++i) {
+      shape.values[i] = (char *)malloc(
+          strlen((char *)sthand->items_query[sthand->row][i]) + 1);
 
       if (shape.values[i] == NULL) {
-        msSetError( MS_ORACLESPATIALERR, "No memory avaliable to allocate the items buffer.", "msOracleSpatialLayerGetExtent()" );
+        msSetError(MS_ORACLESPATIALERR,
+                   "No memory avaliable to allocate the items buffer.",
+                   "msOracleSpatialLayerGetExtent()");
 
         /* clean items */
         free(items);
 
-        if (geom_column_name) free(geom_column_name);
-        if (srid) free(srid);
-        if (unique) free(unique);
-        if (indexfield) free(indexfield);
-        if (query_str) free(query_str);
+        if (geom_column_name)
+          free(geom_column_name);
+        if (srid)
+          free(srid);
+        if (unique)
+          free(unique);
+        if (indexfield)
+          free(indexfield);
+        if (query_str)
+          free(query_str);
         free(table_name);
 
         return MS_FAILURE;
       } else {
         strcpy(shape.values[i], (char *)sthand->items_query[sthand->row][i]);
-        shape.values[i][strlen((char *)sthand->items_query[sthand->row][i])] = '\0';
+        shape.values[i][strlen((char *)sthand->items_query[sthand->row][i])] =
+            '\0';
       }
     }
 
@@ -3372,22 +4011,28 @@ int msOracleSpatialLayerGetExtent(layerO
     /* fetch a layer->type object */
     success = osGetOrdinates(dthand, hand, &shape, obj, ind);
     if (success != MS_SUCCESS) {
-      msSetError( MS_ORACLESPATIALERR, "Cannot execute query", "msOracleSpatialLayerGetExtent()" );
+      msSetError(MS_ORACLESPATIALERR, "Cannot execute query",
+                 "msOracleSpatialLayerGetExtent()");
 
       /* clean items */
       free(items);
 
-      if (geom_column_name) free(geom_column_name);
-      if (srid) free(srid);
-      if (unique) free(unique);
-      if (indexfield) free(indexfield);
-      if (query_str) free(query_str);
+      if (geom_column_name)
+        free(geom_column_name);
+      if (srid)
+        free(srid);
+      if (unique)
+        free(unique);
+      if (indexfield)
+        free(indexfield);
+      if (query_str)
+        free(query_str);
       free(table_name);
 
       return MS_FAILURE;
     }
 
-  } while(sthand->row <= sthand->rows_fetched);
+  } while (sthand->row <= sthand->rows_fetched);
 
   sthand->row = sthand->row_num = 0;
 
@@ -3404,19 +4049,23 @@ int msOracleSpatialLayerGetExtent(layerO
   /* clean items */
   free(items);
 
-  if (geom_column_name) free(geom_column_name);
-  if (srid) free(srid);
-  if (unique) free(unique);
-  if (indexfield) free(indexfield);
-  if (query_str) free(query_str);
+  if (geom_column_name)
+    free(geom_column_name);
+  if (srid)
+    free(srid);
+  if (unique)
+    free(unique);
+  if (indexfield)
+    free(indexfield);
+  if (query_str)
+    free(query_str);
   free(table_name);
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
-void msOracleSpatialLayerFreeItemInfo( layerObj *layer )
-{
-  if (layer->debug>=3)
+void msOracleSpatialLayerFreeItemInfo(layerObj *layer) {
+  if (layer->debug >= 3)
     msDebug("msOracleSpatialLayerFreeItemInfo was called.\n");
 
   if (layer->iteminfo)
@@ -3426,13 +4075,14 @@ void msOracleSpatialLayerFreeItemInfo( l
   /* nothing to do */
 }
 
-int msOracleSpatialLayerGetAutoStyle( mapObj *map, layerObj *layer, classObj *c, shapeObj *shape )
-{
+int msOracleSpatialLayerGetAutoStyle(mapObj *map, layerObj *layer, classObj *c,
+                                     shapeObj *shape) {
   (void)map;
   (void)layer;
   (void)c;
   (void)shape;
-  msSetError( MS_ORACLESPATIALERR, "Function not implemented yet", "msLayerGetAutoStyle()" );
+  msSetError(MS_ORACLESPATIALERR, "Function not implemented yet",
+             "msLayerGetAutoStyle()");
   return MS_FAILURE;
 }
 
@@ -3441,67 +4091,62 @@ int msOracleSpatialLayerGetAutoStyle( ma
 /*                                                                      */
 /*      Return the property name in a properly escaped and quoted form. */
 /************************************************************************/
-char *msOracleSpatialEscapePropertyName(layerObj *layer, const char* pszString)
-{
-  char* pszEscapedStr=NULL;
+char *msOracleSpatialEscapePropertyName(layerObj *layer,
+                                        const char *pszString) {
+  char *pszEscapedStr = NULL;
   int i, j = 0;
 
   if (layer && pszString && strlen(pszString) > 0) {
     int nLength = strlen(pszString);
 
-    pszEscapedStr = (char*) msSmallMalloc( 1 + 2 * nLength + 1 + 1);
-    //pszEscapedStr[j++] = '';
+    pszEscapedStr = (char *)msSmallMalloc(1 + 2 * nLength + 1 + 1);
+    // pszEscapedStr[j++] = '';
 
-    for (i=0; i<nLength; i++) {
+    for (i = 0; i < nLength; i++) {
       char c = pszString[i];
       if (c == '"') {
         pszEscapedStr[j++] = '"';
-        pszEscapedStr[j++] ='"';
+        pszEscapedStr[j++] = '"';
       } else if (c == '\\') {
         pszEscapedStr[j++] = '\\';
         pszEscapedStr[j++] = '\\';
       } else
         pszEscapedStr[j++] = c;
     }
-    //pszEscapedStr[j++] = '';
+    // pszEscapedStr[j++] = '';
     pszEscapedStr[j++] = 0;
-
   }
   return pszEscapedStr;
 }
 
-int msOracleSpatialGetPaging(layerObj *layer)
-{
+int msOracleSpatialGetPaging(layerObj *layer) {
   msOracleSpatialLayerInfo *layerinfo = NULL;
 
-  //if (layer->debug)
-  //  msDebug("msOracleSpatialLayerGetPaging was called.\n");
+  // if (layer->debug)
+  //   msDebug("msOracleSpatialLayerGetPaging was called.\n");
 
-  if(!msOracleSpatialLayerIsOpen(layer))
+  if (!msOracleSpatialLayerIsOpen(layer))
     return MS_TRUE;
 
-  assert( layer->layerinfo != NULL);
+  assert(layer->layerinfo != NULL);
   layerinfo = (msOracleSpatialLayerInfo *)layer->layerinfo;
 
   return layerinfo->paging;
 }
 
-void msOracleSpatialEnablePaging(layerObj *layer, int value)
-{
+void msOracleSpatialEnablePaging(layerObj *layer, int value) {
   msOracleSpatialLayerInfo *layerinfo = NULL;
 
-  if (layer->debug>=3)
+  if (layer->debug >= 3)
     msDebug("msOracleSpatialLayerEnablePaging was called.\n");
 
-  if(!msOracleSpatialLayerIsOpen(layer))
-  {
-    if(msOracleSpatialLayerOpen(layer) != MS_SUCCESS)
-    {
+  if (!msOracleSpatialLayerIsOpen(layer)) {
+    if (msOracleSpatialLayerOpen(layer) != MS_SUCCESS) {
       return;
     }
   }
 
-  assert( layer->layerinfo != NULL);
+  assert(layer->layerinfo != NULL);
   layerinfo = (msOracleSpatialLayerInfo *)layer->layerinfo;
 
   layerinfo->paging = value;
@@ -3509,55 +4154,74 @@ void msOracleSpatialEnablePaging(layerOb
   return;
 }
 
-int msOracleSpatialLayerTranslateFilter(layerObj *layer, expressionObj *filter, char *filteritem)
-{
+int msOracleSpatialLayerTranslateFilter(layerObj *layer, expressionObj *filter,
+                                        char *filteritem) {
   char *native_string = NULL;
 
   int nodeCount = 0;
 
-  int function = 0, version = 0, dwithin = 0, regexp_like = 0, case_ins = 0, ieq = 0;
+  int function = 0, version = 0, dwithin = 0, regexp_like = 0, case_ins = 0,
+      ieq = 0;
   char *table_name = NULL;
-  char *geom_column_name = NULL, *unique = NULL, *srid = NULL, *indexfield=NULL;
+  char *geom_column_name = NULL, *unique = NULL, *srid = NULL,
+       *indexfield = NULL;
   char *snippet = NULL;
   char *strtmpl = NULL;
   double dfDistance = -1;
 
-  table_name = (char *) malloc(sizeof(char) * TABLE_NAME_SIZE);
-  if (!msSplitData( layer->data, &geom_column_name, &table_name, &unique, &srid, &indexfield, &function, &version )) {
-    msDebug(   "Error parsing OracleSpatial DATA variable. Must be: "
-                "'geometry_column FROM table_name [USING UNIQUE <column> SRID srid# FUNCTION]' or "
-                "'geometry_column FROM (SELECT stmt) [USING UNIQUE <column> SRID srid# FUNCTION]'. "
-                "If want to set the FUNCTION statement you can use: FILTER, RELATE, GEOMRELATE or NONE. "
-                "Your data statement: (%s)"
-                "in msOracleSpatialLayerGetExtent()\n", layer->data );
-    msSetError( MS_ORACLESPATIALERR,
-                "Error parsing OracleSpatial DATA variable. Check server logs. ",
-                "msOracleSpatialLayerGetExtent()");
+  table_name = (char *)malloc(sizeof(char) * TABLE_NAME_SIZE);
+  if (!msSplitData(layer->data, &geom_column_name, &table_name, &unique, &srid,
+                   &indexfield, &function, &version)) {
+    msDebug("Error parsing OracleSpatial DATA variable. Must be: "
+            "'geometry_column FROM table_name [USING UNIQUE <column> SRID "
+            "srid# FUNCTION]' or "
+            "'geometry_column FROM (SELECT stmt) [USING UNIQUE <column> SRID "
+            "srid# FUNCTION]'. "
+            "If want to set the FUNCTION statement you can use: FILTER, "
+            "RELATE, GEOMRELATE or NONE. "
+            "Your data statement: (%s)"
+            "in msOracleSpatialLayerGetExtent()\n",
+            layer->data);
+    msSetError(MS_ORACLESPATIALERR,
+               "Error parsing OracleSpatial DATA variable. Check server logs. ",
+               "msOracleSpatialLayerGetExtent()");
     /* clean items */
 
-    if (geom_column_name) free(geom_column_name);
-    if (srid) free(srid);
-    if (unique) free(unique);
-    if (indexfield) free(indexfield);
-    if (table_name) free(table_name);
+    if (geom_column_name)
+      free(geom_column_name);
+    if (srid)
+      free(srid);
+    if (unique)
+      free(unique);
+    if (indexfield)
+      free(indexfield);
+    if (table_name)
+      free(table_name);
 
     return MS_FAILURE;
   }
 
-  //msDebug("filter.string was set: %s\n",filter->string);
-  if(!filter->string) {
-    if (geom_column_name) free(geom_column_name);
-    if (srid) free(srid);
-    if (unique) free(unique);
-    if (indexfield) free(indexfield);
-    if (table_name) free(table_name);
+  // msDebug("filter.string was set: %s\n",filter->string);
+  if (!filter->string) {
+    if (geom_column_name)
+      free(geom_column_name);
+    if (srid)
+      free(srid);
+    if (unique)
+      free(unique);
+    if (indexfield)
+      free(indexfield);
+    if (table_name)
+      free(table_name);
 
     return MS_SUCCESS;
   }
-  /* for backwards compatibility we continue to allow SQL snippets as a string */
+  /* for backwards compatibility we continue to allow SQL snippets as a string
+   */
 
- if(filter->type == MS_STRING && filter->string && filteritem) { /* item/value pair */
-    if(filter->flags & MS_EXP_INSENSITIVE) {
+  if (filter->type == MS_STRING && filter->string &&
+      filteritem) { /* item/value pair */
+    if (filter->flags & MS_EXP_INSENSITIVE) {
       native_string = msStringConcatenate(native_string, "upper(");
       native_string = msStringConcatenate(native_string, filteritem);
       native_string = msStringConcatenate(native_string, ") = upper(");
@@ -3566,471 +4230,525 @@ int msOracleSpatialLayerTranslateFilter(
       native_string = msStringConcatenate(native_string, " = ");
     }
 
-    strtmpl = "'%s'";  /* don't have a type for the righthand literal so assume it's a string and we quote */
-    snippet = (char *) msSmallMalloc(strlen(strtmpl) + strlen(filter->string));
-    sprintf(snippet, strtmpl, filter->string);  // TODO: escape filter->string (msPostGISEscapeSQLParam)
+    strtmpl = "'%s'"; /* don't have a type for the righthand literal so assume
+                         it's a string and we quote */
+    snippet = (char *)msSmallMalloc(strlen(strtmpl) + strlen(filter->string));
+    sprintf(snippet, strtmpl, filter->string); // TODO: escape filter->string
+                                               // (msPostGISEscapeSQLParam)
     native_string = msStringConcatenate(native_string, snippet);
     free(snippet);
 
-    if(filter->flags & MS_EXP_INSENSITIVE) native_string = msStringConcatenate(native_string, ")");
+    if (filter->flags & MS_EXP_INSENSITIVE)
+      native_string = msStringConcatenate(native_string, ")");
 
-    if (layer->debug>=2) msDebug("msOracleSpatialLayerTranslateFilter: **item/value combo: %s\n", native_string);
-  } else if(filter->type == MS_REGEX && filter->string && filteritem) { /* item/regex pair */
+    if (layer->debug >= 2)
+      msDebug("msOracleSpatialLayerTranslateFilter: **item/value combo: %s\n",
+              native_string);
+  } else if (filter->type == MS_REGEX && filter->string &&
+             filteritem) { /* item/regex pair */
     native_string = msStringConcatenate(native_string, "REGEXP_LIKE (");
     native_string = msStrdup(filteritem);
     native_string = msStringConcatenate(native_string, ", ");
     strtmpl = "'%s'";
-    snippet = (char *) msSmallMalloc(strlen(strtmpl) + strlen(filter->string));
-    sprintf(snippet, strtmpl, filter->string); // TODO: escape filter->string (msPostGISEscapeSQLParam)
+    snippet = (char *)msSmallMalloc(strlen(strtmpl) + strlen(filter->string));
+    sprintf(snippet, strtmpl, filter->string); // TODO: escape filter->string
+                                               // (msPostGISEscapeSQLParam)
     native_string = msStringConcatenate(native_string, snippet);
 
-    if(filter->flags & MS_EXP_INSENSITIVE) {
+    if (filter->flags & MS_EXP_INSENSITIVE) {
       native_string = msStringConcatenate(native_string, ",i ");
     }
     native_string = msStringConcatenate(native_string, " )");
     free(snippet);
-  } else if(filter->type == MS_EXPRESSION) {
+  } else if (filter->type == MS_EXPRESSION) {
 
     tokenListNodeObjPtr node = NULL;
-    //tokenListNodeObjPtr nextNode = NULL;
+    // tokenListNodeObjPtr nextNode = NULL;
 
-    if (layer->debug>2)
-      msDebug("msOracleSpatialLayerTranslateFilter. String: %s \n", filter->string);
-    if (layer->debug>2 && !filter->tokens)
+    if (layer->debug > 2)
+      msDebug("msOracleSpatialLayerTranslateFilter. String: %s \n",
+              filter->string);
+    if (layer->debug > 2 && !filter->tokens)
       msDebug("msOracleSpatialLayerTranslateFilter. No tokens to process\n");
 
-    if(!filter->tokens) return MS_SUCCESS; /* nothing to work from */
+    if (!filter->tokens)
+      return MS_SUCCESS; /* nothing to work from */
 
-    if (layer->debug>2)
-      msDebug("msOracleSpatialLayerTranslateFilter. There are tokens to process \n");
+    if (layer->debug > 2)
+      msDebug("msOracleSpatialLayerTranslateFilter. There are tokens to "
+              "process \n");
 
     /* try to convert tokens */
     node = filter->tokens;
     while (node != NULL) {
-      //msDebug("token count :%i, token is %i\n", nodeCount, node->token);
-      switch(node->token) {
-        case '(':
-          // if (buffer == MS_FALSE)
-           native_string = msStringConcatenate(native_string, "( ");
-           break;
-        case ')':
-           if (regexp_like == MS_TRUE) {
-            if (case_ins == MS_TRUE) {
-              native_string = msStringConcatenate(native_string, ",'i' ");
-              case_ins = MS_FALSE;
-            }
-           regexp_like = MS_FALSE;
-           native_string = msStringConcatenate(native_string, " )");
-           msDebug("closing RE comparison\n");
-           }
-           native_string = msStringConcatenate(native_string, " )");
-           break;
-        case MS_TOKEN_LITERAL_NUMBER:
-        {
-          char buffer[32];
-          if (dwithin == MS_TRUE) {
-            dfDistance = node->tokenval.dblval;
-            if (layer->units == MS_DD){
-              dfDistance *= msInchesPerUnit(MS_DD,0)/msInchesPerUnit(MS_METERS,0);
-              //msDebug("Converted Distance value is %lf\n", dfDistance);
-            }
-            snprintf(buffer, sizeof(buffer), "%.18g", dfDistance);
-            native_string = msStringConcatenate(native_string, "'distance=");
-            native_string = msStringConcatenate(native_string, buffer);
-            native_string = msStringConcatenate(native_string, "'");
-          } else {
-            snprintf(buffer, sizeof(buffer), "%.18g", node->tokenval.dblval);
-            native_string = msStringConcatenate(native_string, buffer);
+      // msDebug("token count :%i, token is %i\n", nodeCount, node->token);
+      switch (node->token) {
+      case '(':
+        // if (buffer == MS_FALSE)
+        native_string = msStringConcatenate(native_string, "( ");
+        break;
+      case ')':
+        if (regexp_like == MS_TRUE) {
+          if (case_ins == MS_TRUE) {
+            native_string = msStringConcatenate(native_string, ",'i' ");
+            case_ins = MS_FALSE;
           }
-          break;
+          regexp_like = MS_FALSE;
+          native_string = msStringConcatenate(native_string, " )");
+          msDebug("closing RE comparison\n");
         }
-        case MS_TOKEN_LITERAL_STRING:
-          strtmpl = "%s";
-          snippet = (char *) msSmallMalloc(strlen(strtmpl) + strlen(node->tokenval.strval));
-          sprintf(snippet, strtmpl, node->tokenval.strval);  // TODO: escape strval
-          snippet = msReplaceSubstring(snippet,"'","''");
-          native_string = msStringConcatenate(native_string, "'");
-          if (ieq == MS_TRUE) {
-            native_string = msStringConcatenate(native_string, "^");
-          }
-          native_string = msStringConcatenate(native_string, snippet);
-          if (ieq == MS_TRUE) {
-            native_string = msStringConcatenate(native_string, "$");
-            ieq = MS_FALSE;
-          }
-          native_string = msStringConcatenate(native_string, "'");
-          msFree(snippet);
-           break;
-        case MS_TOKEN_LITERAL_BOOLEAN:
-          if(node->tokenval.dblval == MS_TRUE)
-            native_string = msStringConcatenate(native_string, "'TRUE'");
-          else
-             native_string = msStringConcatenate(native_string, "'FALSE'");
-           break;
-        case MS_TOKEN_LITERAL_TIME:
-        {
-          int resolution = msTimeGetResolution(node->tokensrc);
-          snippet = (char *) msSmallMalloc(128);
-          switch(resolution) {
-            case TIME_RESOLUTION_YEAR:
-              strtmpl = "to_date('%d-01','YYYY-MM')";
-              sprintf(snippet, strtmpl, (node->tokenval.tmval.tm_year+1900));
-              break;
-            case TIME_RESOLUTION_MONTH:
-              strtmpl = "to_date('%d-%02d','YYYY-MM')";
-              sprintf(snippet, strtmpl, (node->tokenval.tmval.tm_year+1900), (node->tokenval.tmval.tm_mon+1));
-              break;
-            case TIME_RESOLUTION_DAY:
-              strtmpl = "to_date('%d-%02d-%02d','YYYY-MM-DD') ";
-              sprintf(snippet, strtmpl, (node->tokenval.tmval.tm_year+1900), (node->tokenval.tmval.tm_mon+1), node->tokenval.tmval.tm_mday);
-              break;
-            case TIME_RESOLUTION_HOUR:
-              strtmpl = "to_timestamp('%d-%02d-%02d %02d','YYYY-MM-DD hh24')";
-              sprintf(snippet, strtmpl, (node->tokenval.tmval.tm_year+1900), (node->tokenval.tmval.tm_mon+1), node->tokenval.tmval.tm_mday, node->tokenval.tmval.tm_hour);
-              break;
-            case TIME_RESOLUTION_MINUTE:
-              strtmpl = "to_timestamp('%d-%02d-%02d %02d:%02d','YYYY-MM-DD hh24:mi')";
-              sprintf(snippet, strtmpl, (node->tokenval.tmval.tm_year+1900), (node->tokenval.tmval.tm_mon+1), node->tokenval.tmval.tm_mday, node->tokenval.tmval.tm_hour, node->tokenval.tmval.tm_min);
-              break;
-            case TIME_RESOLUTION_SECOND:
-              strtmpl = "to_timestamp('%d-%02d-%02d %02d:%02d:%02d','YYYY-MM-DD hh24:mi:ss')";
-              sprintf(snippet, strtmpl, (node->tokenval.tmval.tm_year+1900), (node->tokenval.tmval.tm_mon+1), node->tokenval.tmval.tm_mday, node->tokenval.tmval.tm_hour, node->tokenval.tmval.tm_min, node->tokenval.tmval.tm_sec);
-              break;
+        native_string = msStringConcatenate(native_string, " )");
+        break;
+      case MS_TOKEN_LITERAL_NUMBER: {
+        char buffer[32];
+        if (dwithin == MS_TRUE) {
+          dfDistance = node->tokenval.dblval;
+          if (layer->units == MS_DD) {
+            dfDistance *=
+                msInchesPerUnit(MS_DD, 0) / msInchesPerUnit(MS_METERS, 0);
+            // msDebug("Converted Distance value is %lf\n", dfDistance);
           }
-          native_string = msStringConcatenate(native_string, snippet);
-          msFree(snippet);
-          break;
-        }
-        case MS_TOKEN_LITERAL_SHAPE:
-          native_string = msStringConcatenate(native_string, " SDO_GEOMETRY('");
-          native_string = msStringConcatenate(native_string, msShapeToWKT(node->tokenval.shpval));
+          snprintf(buffer, sizeof(buffer), "%.18g", dfDistance);
+          native_string = msStringConcatenate(native_string, "'distance=");
+          native_string = msStringConcatenate(native_string, buffer);
           native_string = msStringConcatenate(native_string, "'");
-          if(srid && strcmp(srid, "") != 0) {
-            native_string = msStringConcatenate(native_string, ", ");
-            native_string = msStringConcatenate(native_string, srid);
-          }
-          native_string = msStringConcatenate(native_string, ") ");
-          //msDebug("------> srid node value: %s", node->tokenval.shpval);
-          break;
-        case MS_TOKEN_BINDING_DOUBLE:
-          native_string = msStringConcatenate(native_string, node->tokenval.bindval.item);
-          break;
-        case MS_TOKEN_BINDING_INTEGER:
-          native_string = msStringConcatenate(native_string, node->tokenval.bindval.item);
-          break;
-        case MS_TOKEN_BINDING_STRING:
-         if (node->next->token == MS_TOKEN_COMPARISON_RE || node->next->token == MS_TOKEN_COMPARISON_IRE
-          || node->next->token == MS_TOKEN_COMPARISON_IEQ ) {
-              native_string = msStringConcatenate(native_string, "REGEXP_LIKE( ");
-          }
-          strtmpl = "%s";
-          snippet = (char *) msSmallMalloc(strlen(strtmpl) + strlen(node->tokenval.strval));
-          sprintf(snippet, strtmpl, node->tokenval.strval);  // TODO: escape strval (msPostGISEscapeSQLParam)
-          native_string = msStringConcatenate(native_string, snippet);
-          free(snippet);
-          break;
-        case MS_TOKEN_BINDING_TIME:
-          native_string = msStringConcatenate(native_string, node->tokenval.bindval.item);
-          break;
-        case MS_TOKEN_BINDING_SHAPE:
-          native_string = msStringConcatenate(native_string, geom_column_name);
-          break;
-        case MS_TOKEN_BINDING_MAP_CELLSIZE:
-        {
-          char buffer[32];
-          snprintf(buffer, sizeof(buffer), "%.18g", layer->map->cellsize);
+        } else {
+          snprintf(buffer, sizeof(buffer), "%.18g", node->tokenval.dblval);
           native_string = msStringConcatenate(native_string, buffer);
-          break;
         }
-        case MS_TOKEN_LOGICAL_AND:
-          native_string = msStringConcatenate(native_string, " AND ");
-          break;
-        case MS_TOKEN_LOGICAL_OR:
-          native_string = msStringConcatenate(native_string, " OR ");
-          break;
-        case MS_TOKEN_LOGICAL_NOT:
-          native_string = msStringConcatenate(native_string, " NOT ");
-          break;
-        case MS_TOKEN_COMPARISON_EQ:
-          native_string = msStringConcatenate(native_string, " = ");
-          break;
-        case MS_TOKEN_COMPARISON_NE:
-          native_string = msStringConcatenate(native_string, " != ");
-          break;
-        case MS_TOKEN_COMPARISON_GT:
-          native_string = msStringConcatenate(native_string, " > ");
-          break;
-        case MS_TOKEN_COMPARISON_GE:
-          native_string = msStringConcatenate(native_string, " >= ");
-          break;
-        case MS_TOKEN_COMPARISON_LT:
-          native_string = msStringConcatenate(native_string, " < ");
-          break;
-        case MS_TOKEN_COMPARISON_LE:
-          native_string = msStringConcatenate(native_string, " <= ");
-          break;
-        case MS_TOKEN_COMPARISON_IEQ:
-          // this is for  case insensitve equals check
-          msDebug("got a IEQ comparison\n");
-          regexp_like = MS_TRUE;
-          case_ins = MS_TRUE;
-          ieq = MS_TRUE;
-          native_string = msStringConcatenate(native_string, ", ");
-          break;
-        case MS_TOKEN_COMPARISON_RE:
-          // the regex formats that MS uses as Oracle users are different so just return and eval the regex's in MS
-          //return MS_SUCCESS;
-          msDebug("got a RE comparison\n");
-          regexp_like = MS_TRUE;
-          native_string = msStringConcatenate(native_string, ", ");
+        break;
+      }
+      case MS_TOKEN_LITERAL_STRING:
+        strtmpl = "%s";
+        snippet = (char *)msSmallMalloc(strlen(strtmpl) +
+                                        strlen(node->tokenval.strval));
+        sprintf(snippet, strtmpl, node->tokenval.strval); // TODO: escape strval
+        snippet = msReplaceSubstring(snippet, "'", "''");
+        native_string = msStringConcatenate(native_string, "'");
+        if (ieq == MS_TRUE) {
+          native_string = msStringConcatenate(native_string, "^");
+        }
+        native_string = msStringConcatenate(native_string, snippet);
+        if (ieq == MS_TRUE) {
+          native_string = msStringConcatenate(native_string, "$");
+        }
+        native_string = msStringConcatenate(native_string, "'");
+        if (ieq == MS_TRUE) {
+          native_string = msStringConcatenate(native_string, ")");
+          ieq = MS_FALSE;
+        }
+        msFree(snippet);
+        break;
+      case MS_TOKEN_LITERAL_BOOLEAN:
+        if (node->tokenval.dblval == MS_TRUE)
+          native_string = msStringConcatenate(native_string, "'TRUE'");
+        else
+          native_string = msStringConcatenate(native_string, "'FALSE'");
+        break;
+      case MS_TOKEN_LITERAL_TIME: {
+        int resolution = msTimeGetResolution(node->tokensrc);
+        snippet = (char *)msSmallMalloc(128);
+        switch (resolution) {
+        case TIME_RESOLUTION_YEAR:
+          strtmpl = "to_date('%d-01','YYYY-MM')";
+          sprintf(snippet, strtmpl, (node->tokenval.tmval.tm_year + 1900));
+          break;
+        case TIME_RESOLUTION_MONTH:
+          strtmpl = "to_date('%d-%02d','YYYY-MM')";
+          sprintf(snippet, strtmpl, (node->tokenval.tmval.tm_year + 1900),
+                  (node->tokenval.tmval.tm_mon + 1));
+          break;
+        case TIME_RESOLUTION_DAY:
+          strtmpl = "to_date('%d-%02d-%02d','YYYY-MM-DD') ";
+          sprintf(snippet, strtmpl, (node->tokenval.tmval.tm_year + 1900),
+                  (node->tokenval.tmval.tm_mon + 1),
+                  node->tokenval.tmval.tm_mday);
+          break;
+        case TIME_RESOLUTION_HOUR:
+          strtmpl = "to_timestamp('%d-%02d-%02d %02d','YYYY-MM-DD hh24')";
+          sprintf(snippet, strtmpl, (node->tokenval.tmval.tm_year + 1900),
+                  (node->tokenval.tmval.tm_mon + 1),
+                  node->tokenval.tmval.tm_mday, node->tokenval.tmval.tm_hour);
+          break;
+        case TIME_RESOLUTION_MINUTE:
+          strtmpl =
+              "to_timestamp('%d-%02d-%02d %02d:%02d','YYYY-MM-DD hh24:mi')";
+          sprintf(snippet, strtmpl, (node->tokenval.tmval.tm_year + 1900),
+                  (node->tokenval.tmval.tm_mon + 1),
+                  node->tokenval.tmval.tm_mday, node->tokenval.tmval.tm_hour,
+                  node->tokenval.tmval.tm_min);
+          break;
+        case TIME_RESOLUTION_SECOND:
+          strtmpl = "to_timestamp('%d-%02d-%02d %02d:%02d:%02d','YYYY-MM-DD "
+                    "hh24:mi:ss')";
+          sprintf(snippet, strtmpl, (node->tokenval.tmval.tm_year + 1900),
+                  (node->tokenval.tmval.tm_mon + 1),
+                  node->tokenval.tmval.tm_mday, node->tokenval.tmval.tm_hour,
+                  node->tokenval.tmval.tm_min, node->tokenval.tmval.tm_sec);
           break;
-        case MS_TOKEN_COMPARISON_IRE:
-          // the regex formats that MS uses as Oracle users are different so just return and eval the regex's in MS
-          regexp_like = MS_TRUE;
-          case_ins = MS_TRUE;
+        }
+        native_string = msStringConcatenate(native_string, snippet);
+        msFree(snippet);
+        break;
+      }
+      case MS_TOKEN_LITERAL_SHAPE:
+        native_string = msStringConcatenate(native_string, " SDO_GEOMETRY('");
+        native_string = msStringConcatenate(
+            native_string, msShapeToWKT(node->tokenval.shpval));
+        native_string = msStringConcatenate(native_string, "'");
+        if (srid && strcmp(srid, "") != 0) {
           native_string = msStringConcatenate(native_string, ", ");
-          break;
-        case MS_TOKEN_COMPARISON_IN:
-          native_string = msStringConcatenate(native_string, " IN ");
-          break;
-        case MS_TOKEN_COMPARISON_LIKE:
-          native_string = msStringConcatenate(native_string, " LIKE ");
-          break;
-        case MS_TOKEN_COMPARISON_INTERSECTS:
-          native_string = msStringConcatenate(native_string, " ST_INTERSECTS ");
-          break;
-        case MS_TOKEN_COMPARISON_DISJOINT:
-          native_string = msStringConcatenate(native_string, " NOT ST_INTERSECTS ");
-          break;
-        case MS_TOKEN_COMPARISON_TOUCHES:
-          native_string = msStringConcatenate(native_string, " ST_TOUCH ");
-          break;
-        case MS_TOKEN_COMPARISON_OVERLAPS:
-          native_string = msStringConcatenate(native_string, " ST_OVERLAPS ");
-          break;
-        case MS_TOKEN_COMPARISON_CROSSES:
-          native_string = msStringConcatenate(native_string, " SDO_OVERLAPBDYDISJOINT ");
-          break;
-        case MS_TOKEN_COMPARISON_WITHIN:
-          native_string = msStringConcatenate(native_string, " ST_INSIDE ");
-          break;
-        case MS_TOKEN_COMPARISON_CONTAINS:
-          native_string = msStringConcatenate(native_string, " SDO_CONTAINS ");
-          break;
-        case MS_TOKEN_COMPARISON_EQUALS:
-          native_string = msStringConcatenate(native_string, " SDO_EQUAL ");
-          break;
-        case MS_TOKEN_COMPARISON_BEYOND:
-          //support for the wfs case
-          dwithin = MS_TRUE;
-          native_string = msStringConcatenate(native_string, "NOT SDO_WITHIN_DISTANCE ");
-          break;
-        case MS_TOKEN_COMPARISON_DWITHIN:
-          dwithin = MS_TRUE;
-          native_string = msStringConcatenate(native_string, "SDO_WITHIN_DISTANCE ");
-          break;
-        case MS_TOKEN_FUNCTION_LENGTH:
-          break;
-        case MS_TOKEN_FUNCTION_TOSTRING:
-          break;
-        case MS_TOKEN_FUNCTION_COMMIFY:
-          break;
-        case MS_TOKEN_FUNCTION_AREA:
-          native_string = msStringConcatenate(native_string, "SDO_GEOM.SDO_AREA ");
-          break;
-        case MS_TOKEN_FUNCTION_ROUND:
-          native_string = msStringConcatenate(native_string, "ROUND ");
-          break;
-        case MS_TOKEN_FUNCTION_FROMTEXT:
-          native_string = msStringConcatenate(native_string, "SDO_GEOMETRY ");
-          break;
-        case MS_TOKEN_FUNCTION_BUFFER:
-           // native_string = msStringConcatenate(native_string, " SDO_BUFFER ");
-           //buffer = MS_TRUE;
-          break;
-        case MS_TOKEN_FUNCTION_DIFFERENCE:
-          native_string = msStringConcatenate(native_string, "ST_DIFFERENCE ");
-          break;
-        case MS_TOKEN_FUNCTION_SIMPLIFY:
-          native_string = msStringConcatenate(native_string, "SDO_UTIL.SIMPLIFY ");
-          break;
-        case MS_TOKEN_FUNCTION_SIMPLIFYPT:
-          break;
-        case MS_TOKEN_FUNCTION_GENERALIZE:
-          native_string = msStringConcatenate(native_string, "SDO_UTIL.SIMPLIFY ");
-          break;
-        case ',':
-          native_string = msStringConcatenate(native_string, ",");
-          break;
-        case '~':
-          break;
-        default:
-          fprintf(stderr, "Translation to native SQL failed.\n");
-          msFree(native_string);
-          if (layer->debug) {
-            msDebug("Token not caught, exiting: Token is %i\n", node->token);
-          }
+          native_string = msStringConcatenate(native_string, srid);
+        }
+        native_string = msStringConcatenate(native_string, ") ");
+        // msDebug("------> srid node value: %s", node->tokenval.shpval);
+        break;
+      case MS_TOKEN_BINDING_DOUBLE:
+        native_string =
+            msStringConcatenate(native_string, node->tokenval.bindval.item);
+        break;
+      case MS_TOKEN_BINDING_INTEGER:
+        native_string =
+            msStringConcatenate(native_string, node->tokenval.bindval.item);
+        break;
+      case MS_TOKEN_BINDING_STRING:
+        if (node->next->token == MS_TOKEN_COMPARISON_RE ||
+            node->next->token == MS_TOKEN_COMPARISON_IRE ||
+            node->next->token == MS_TOKEN_COMPARISON_IEQ) {
+          native_string = msStringConcatenate(native_string, "REGEXP_LIKE( ");
+        }
+        strtmpl = "%s";
+        snippet = (char *)msSmallMalloc(strlen(strtmpl) +
+                                        strlen(node->tokenval.strval));
+        sprintf(snippet, strtmpl,
+                node->tokenval
+                    .strval); // TODO: escape strval (msPostGISEscapeSQLParam)
+        native_string = msStringConcatenate(native_string, snippet);
+        free(snippet);
+        break;
+      case MS_TOKEN_BINDING_TIME:
+        native_string =
+            msStringConcatenate(native_string, node->tokenval.bindval.item);
+        break;
+      case MS_TOKEN_BINDING_SHAPE:
+        native_string = msStringConcatenate(native_string, geom_column_name);
+        break;
+      case MS_TOKEN_BINDING_MAP_CELLSIZE: {
+        char buffer[32];
+        snprintf(buffer, sizeof(buffer), "%.18g", layer->map->cellsize);
+        native_string = msStringConcatenate(native_string, buffer);
+        break;
+      }
+      case MS_TOKEN_LOGICAL_AND:
+        native_string = msStringConcatenate(native_string, " AND ");
+        break;
+      case MS_TOKEN_LOGICAL_OR:
+        native_string = msStringConcatenate(native_string, " OR ");
+        break;
+      case MS_TOKEN_LOGICAL_NOT:
+        native_string = msStringConcatenate(native_string, " NOT ");
+        break;
+      case MS_TOKEN_COMPARISON_EQ:
+        native_string = msStringConcatenate(native_string, " = ");
+        break;
+      case MS_TOKEN_COMPARISON_NE:
+        native_string = msStringConcatenate(native_string, " != ");
+        break;
+      case MS_TOKEN_COMPARISON_GT:
+        native_string = msStringConcatenate(native_string, " > ");
+        break;
+      case MS_TOKEN_COMPARISON_GE:
+        native_string = msStringConcatenate(native_string, " >= ");
+        break;
+      case MS_TOKEN_COMPARISON_LT:
+        native_string = msStringConcatenate(native_string, " < ");
+        break;
+      case MS_TOKEN_COMPARISON_LE:
+        native_string = msStringConcatenate(native_string, " <= ");
+        break;
+      case MS_TOKEN_COMPARISON_IEQ:
+        // this is for  case insensitve equals check
+        msDebug("got a IEQ comparison\n");
+        regexp_like = MS_TRUE;
+        case_ins = MS_TRUE;
+        ieq = MS_TRUE;
+        native_string = msStringConcatenate(native_string, ", ");
+        break;
+      case MS_TOKEN_COMPARISON_RE:
+        // the regex formats that MS uses as Oracle users are different so just
+        // return and eval the regex's in MS
+        // return MS_SUCCESS;
+        msDebug("got a RE comparison\n");
+        regexp_like = MS_TRUE;
+        native_string = msStringConcatenate(native_string, ", ");
+        break;
+      case MS_TOKEN_COMPARISON_IRE:
+        // the regex formats that MS uses as Oracle users are different so just
+        // return and eval the regex's in MS
+        regexp_like = MS_TRUE;
+        case_ins = MS_TRUE;
+        native_string = msStringConcatenate(native_string, ", ");
+        break;
+      case MS_TOKEN_COMPARISON_IN:
+        native_string = msStringConcatenate(native_string, " IN ");
+        break;
+      case MS_TOKEN_COMPARISON_LIKE:
+        native_string = msStringConcatenate(native_string, " LIKE ");
+        break;
+      case MS_TOKEN_COMPARISON_INTERSECTS:
+        native_string = msStringConcatenate(native_string, " ST_INTERSECTS ");
+        break;
+      case MS_TOKEN_COMPARISON_DISJOINT:
+        native_string =
+            msStringConcatenate(native_string, " NOT ST_INTERSECTS ");
+        break;
+      case MS_TOKEN_COMPARISON_TOUCHES:
+        native_string = msStringConcatenate(native_string, " ST_TOUCH ");
+        break;
+      case MS_TOKEN_COMPARISON_OVERLAPS:
+        native_string = msStringConcatenate(native_string, " ST_OVERLAPS ");
+        break;
+      case MS_TOKEN_COMPARISON_CROSSES:
+        native_string =
+            msStringConcatenate(native_string, " SDO_OVERLAPBDYDISJOINT ");
+        break;
+      case MS_TOKEN_COMPARISON_WITHIN:
+        native_string = msStringConcatenate(native_string, " ST_INSIDE ");
+        break;
+      case MS_TOKEN_COMPARISON_CONTAINS:
+        native_string = msStringConcatenate(native_string, " SDO_CONTAINS ");
+        break;
+      case MS_TOKEN_COMPARISON_EQUALS:
+        native_string = msStringConcatenate(native_string, " SDO_EQUAL ");
+        break;
+      case MS_TOKEN_COMPARISON_BEYOND:
+        // support for the wfs case
+        dwithin = MS_TRUE;
+        native_string =
+            msStringConcatenate(native_string, "NOT SDO_WITHIN_DISTANCE ");
+        break;
+      case MS_TOKEN_COMPARISON_DWITHIN:
+        dwithin = MS_TRUE;
+        native_string =
+            msStringConcatenate(native_string, "SDO_WITHIN_DISTANCE ");
+        break;
+      case MS_TOKEN_FUNCTION_LENGTH:
+        break;
+      case MS_TOKEN_FUNCTION_TOSTRING:
+        break;
+      case MS_TOKEN_FUNCTION_COMMIFY:
+        break;
+      case MS_TOKEN_FUNCTION_AREA:
+        native_string =
+            msStringConcatenate(native_string, "SDO_GEOM.SDO_AREA ");
+        break;
+      case MS_TOKEN_FUNCTION_ROUND:
+        native_string = msStringConcatenate(native_string, "ROUND ");
+        break;
+      case MS_TOKEN_FUNCTION_FROMTEXT:
+        native_string = msStringConcatenate(native_string, "SDO_GEOMETRY ");
+        break;
+      case MS_TOKEN_FUNCTION_BUFFER:
+        // native_string = msStringConcatenate(native_string, " SDO_BUFFER ");
+        // buffer = MS_TRUE;
+        break;
+      case MS_TOKEN_FUNCTION_DIFFERENCE:
+        native_string = msStringConcatenate(native_string, "ST_DIFFERENCE ");
+        break;
+      case MS_TOKEN_FUNCTION_SIMPLIFY:
+        native_string =
+            msStringConcatenate(native_string, "SDO_UTIL.SIMPLIFY ");
+        break;
+      case MS_TOKEN_FUNCTION_SIMPLIFYPT:
+        break;
+      case MS_TOKEN_FUNCTION_GENERALIZE:
+        native_string =
+            msStringConcatenate(native_string, "SDO_UTIL.SIMPLIFY ");
+        break;
+      case ',':
+        native_string = msStringConcatenate(native_string, ",");
+        break;
+      case '~':
+        break;
+      default:
+        fprintf(stderr, "Translation to native SQL failed.\n");
+        msFree(native_string);
+        if (layer->debug) {
+          msDebug("Token not caught, exiting: Token is %i\n", node->token);
+        }
 
-          if (geom_column_name) free(geom_column_name);
-          if (srid) free(srid);
-          if (unique) free(unique);
-          if (indexfield) free(indexfield);
-          if (table_name) free(table_name);
+        if (geom_column_name)
+          free(geom_column_name);
+        if (srid)
+          free(srid);
+        if (unique)
+          free(unique);
+        if (indexfield)
+          free(indexfield);
+        if (table_name)
+          free(table_name);
 
-          return MS_SUCCESS; /* not an error */
-        }
+        return MS_SUCCESS; /* not an error */
+      }
       nodeCount++;
       node = node->next;
 
-      //fprintf(stderr, "native filter: %s\n", native_string);
+      // fprintf(stderr, "native filter: %s\n", native_string);
     }
 
     filter->native_string = msStrdup(native_string);
-    if (layer->debug>=4)
+    if (layer->debug >= 4)
       msDebug("total filter tokens are %i\n,", nodeCount);
     msFree(native_string);
   }
 
-  if (geom_column_name) free(geom_column_name);
-  if (srid) free(srid);
-  if (unique) free(unique);
-  if (indexfield) free(indexfield);
-  if (table_name) free(table_name);
-  
+  if (geom_column_name)
+    free(geom_column_name);
+  if (srid)
+    free(srid);
+  if (unique)
+    free(unique);
+  if (indexfield)
+    free(indexfield);
+  if (table_name)
+    free(table_name);
+
   return MS_SUCCESS;
 }
 
-
 #else
 /* OracleSpatial "not-supported" procedures */
 
-int msOracleSpatialLayerOpen(layerObj *layer)
-{
+int msOracleSpatialLayerOpen(layerObj *layer) {
   (void)layer;
-  msSetError( MS_ORACLESPATIALERR, "OracleSpatial is not supported", "msOracleSpatialLayerOpen()" );
+  msSetError(MS_ORACLESPATIALERR, "OracleSpatial is not supported",
+             "msOracleSpatialLayerOpen()");
   return MS_FAILURE;
 }
 
-int msOracleSpatialLayerIsOpen(layerObj *layer)
-{
+int msOracleSpatialLayerIsOpen(layerObj *layer) {
   (void)layer;
-  msSetError( MS_ORACLESPATIALERR, "OracleSpatial is not supported", "msOracleSpatialLayerIsOpen()" );
+  msSetError(MS_ORACLESPATIALERR, "OracleSpatial is not supported",
+             "msOracleSpatialLayerIsOpen()");
   return MS_FALSE;
 }
 
-int msOracleSpatialLayerClose(layerObj *layer)
-{
+int msOracleSpatialLayerClose(layerObj *layer) {
   (void)layer;
-  msSetError( MS_ORACLESPATIALERR, "OracleSpatial is not supported", "msOracleSpatialLayerClose()" );
+  msSetError(MS_ORACLESPATIALERR, "OracleSpatial is not supported",
+             "msOracleSpatialLayerClose()");
   return MS_FAILURE;
 }
 
-int msOracleSpatialLayerWhichShapes(layerObj *layer, rectObj rect, int isQuery)
-{
+int msOracleSpatialLayerWhichShapes(layerObj *layer, rectObj rect,
+                                    int isQuery) {
   (void)layer;
   (void)rect;
   (void)isQuery;
-  msSetError( MS_ORACLESPATIALERR, "OracleSpatial is not supported", "msOracleSpatialLayerWhichShapes()" );
+  msSetError(MS_ORACLESPATIALERR, "OracleSpatial is not supported",
+             "msOracleSpatialLayerWhichShapes()");
   return MS_FAILURE;
 }
 
-int msOracleSpatialLayerNextShape(layerObj *layer, shapeObj *shape)
-{
+int msOracleSpatialLayerNextShape(layerObj *layer, shapeObj *shape) {
   (void)layer;
   (void)shape;
-  msSetError( MS_ORACLESPATIALERR, "OracleSpatial is not supported", "msOracleSpatialLayerNextShape()" );
+  msSetError(MS_ORACLESPATIALERR, "OracleSpatial is not supported",
+             "msOracleSpatialLayerNextShape()");
   return MS_FAILURE;
 }
 
-int msOracleSpatialLayerGetItems(layerObj *layer)
-{
+int msOracleSpatialLayerGetItems(layerObj *layer) {
   (void)layer;
-  msSetError( MS_ORACLESPATIALERR, "OracleSpatial is not supported", "msOracleSpatialLayerGetItems()" );
+  msSetError(MS_ORACLESPATIALERR, "OracleSpatial is not supported",
+             "msOracleSpatialLayerGetItems()");
   return MS_FAILURE;
 }
 
-int msOracleSpatialLayerGetShape( layerObj *layer, shapeObj *shape, resultObj *record )
-{
+int msOracleSpatialLayerGetShape(layerObj *layer, shapeObj *shape,
+                                 resultObj *record) {
   (void)layer;
   (void)shape;
   (void)record;
-  msSetError( MS_ORACLESPATIALERR, "OracleSpatial is not supported", "msOracleSpatialLayerGetShape()" );
+  msSetError(MS_ORACLESPATIALERR, "OracleSpatial is not supported",
+             "msOracleSpatialLayerGetShape()");
   return MS_FAILURE;
 }
 
-int msOracleSpatialLayerGetExtent(layerObj *layer, rectObj *extent)
-{
+int msOracleSpatialLayerGetExtent(layerObj *layer, rectObj *extent) {
   (void)layer;
   (void)extent;
-  msSetError( MS_ORACLESPATIALERR, "OracleSpatial is not supported", "msOracleSpatialLayerGetExtent()" );
+  msSetError(MS_ORACLESPATIALERR, "OracleSpatial is not supported",
+             "msOracleSpatialLayerGetExtent()");
   return MS_FAILURE;
 }
 
-int msOracleSpatialLayerInitItemInfo(layerObj *layer)
-{
+int msOracleSpatialLayerInitItemInfo(layerObj *layer) {
   (void)layer;
-  msSetError( MS_ORACLESPATIALERR, "OracleSpatial is not supported", "msOracleSpatialLayerInitItemInfo()" );
+  msSetError(MS_ORACLESPATIALERR, "OracleSpatial is not supported",
+             "msOracleSpatialLayerInitItemInfo()");
   return MS_FAILURE;
 }
 
-void msOracleSpatialLayerFreeItemInfo(layerObj *layer)
-{
+void msOracleSpatialLayerFreeItemInfo(layerObj *layer) {
   (void)layer;
-  msSetError( MS_ORACLESPATIALERR, "OracleSpatial is not supported", "msOracleSpatialLayerFreeItemInfo()" );
+  msSetError(MS_ORACLESPATIALERR, "OracleSpatial is not supported",
+             "msOracleSpatialLayerFreeItemInfo()");
 }
 
-int msOracleSpatialLayerGetAutoStyle( mapObj *map, layerObj *layer, classObj *c, shapeObj *shape )
-{
+int msOracleSpatialLayerGetAutoStyle(mapObj *map, layerObj *layer, classObj *c,
+                                     shapeObj *shape) {
   (void)map;
   (void)layer;
   (void)c;
   (void)shape;
-  msSetError( MS_ORACLESPATIALERR, "OracleSpatial is not supported", "msLayerGetAutoStyle()" );
+  msSetError(MS_ORACLESPATIALERR, "OracleSpatial is not supported",
+             "msLayerGetAutoStyle()");
   return MS_FAILURE;
 }
 
-void msOracleSpatialEnablePaging(layerObj *layer, int value)
-{
+void msOracleSpatialEnablePaging(layerObj *layer, int value) {
   (void)layer;
   (void)value;
-  msSetError( MS_ORACLESPATIALERR, "OracleSpatial is not supported", "msLayerEnablePaging()" );
+  msSetError(MS_ORACLESPATIALERR, "OracleSpatial is not supported",
+             "msLayerEnablePaging()");
   return;
 }
 
-int msOracleSpatialGetPaging(layerObj *layer)
-{
+int msOracleSpatialGetPaging(layerObj *layer) {
   (void)layer;
-  msSetError( MS_ORACLESPATIALERR, "OracleSpatial is not supported", "msLayerGetPaging()" );
+  msSetError(MS_ORACLESPATIALERR, "OracleSpatial is not supported",
+             "msLayerGetPaging()");
   return MS_FAILURE;
 }
 
-int msOracleSpatialLayerTranslateFilter(layerObj *layer, expressionObj *filter, char *filteritem)
-{
+int msOracleSpatialLayerTranslateFilter(layerObj *layer, expressionObj *filter,
+                                        char *filteritem) {
   (void)layer;
   (void)filter;
   (void)filteritem;
-  msSetError( MS_ORACLESPATIALERR, "OracleSpatial is not supported", "msLayerTranslateFilter()" );
+  msSetError(MS_ORACLESPATIALERR, "OracleSpatial is not supported",
+             "msLayerTranslateFilter()");
   return MS_FAILURE;
 }
 
-char *msOracleSpatialEscapePropertyName(layerObj *layer, const char* pszString)
-{
+char *msOracleSpatialEscapePropertyName(layerObj *layer,
+                                        const char *pszString) {
   (void)layer;
-  msSetError( MS_ORACLESPATIALERR, "OracleSpatial is not supported", "msLayerEscapePropertyName()" );
+  msSetError(MS_ORACLESPATIALERR, "OracleSpatial is not supported",
+             "msLayerEscapePropertyName()");
   return msStrdup(pszString);
 }
 #endif
 
 #if defined USE_ORACLE_PLUGIN
-MS_DLL_EXPORT  int
-PluginInitializeVirtualTable(layerVTableObj* vtable, layerObj *layer)
-{
+MS_DLL_EXPORT int PluginInitializeVirtualTable(layerVTableObj *vtable,
+                                               layerObj *layer) {
   assert(layer != NULL);
   assert(vtable != NULL);
 
   vtable->LayerTranslateFilter = msOracleSpatialLayerTranslateFilter;
 
-
   vtable->LayerInitItemInfo = msOracleSpatialLayerInitItemInfo;
   vtable->LayerFreeItemInfo = msOracleSpatialLayerFreeItemInfo;
   vtable->LayerOpen = msOracleSpatialLayerOpen;
@@ -4046,26 +4764,25 @@ PluginInitializeVirtualTable(layerVTable
   vtable->LayerCloseConnection = msOracleSpatialLayerClose;
   vtable->LayerApplyFilterToLayer = msLayerApplyCondSQLFilterToLayer;
   vtable->LayerSetTimeFilter = msLayerMakeBackticsTimeFilter;
-  //vtable->LayerSetTimeFilter = msOracleSpatialLayerSetTimeFilter;
-  //vtable->LayerEscapePropertyName = msOracleSpatialEscapePropertyName;
+  // vtable->LayerSetTimeFilter = msOracleSpatialLayerSetTimeFilter;
+  // vtable->LayerEscapePropertyName = msOracleSpatialEscapePropertyName;
   /* layer->vtable->LayerGetNumFeatures, use default */
-  /* layer->vtable->LayerGetAutoProjection = msOracleSpatialLayerGetAutoProjection; Disabled until tested */
+  /* layer->vtable->LayerGetAutoProjection =
+   * msOracleSpatialLayerGetAutoProjection; Disabled until tested */
   vtable->LayerEnablePaging = msOracleSpatialEnablePaging;
   vtable->LayerGetPaging = msOracleSpatialGetPaging;
 
   return MS_SUCCESS;
 }
 
-#else /*if ORACLE_PLUGIN is defined, then this file is not used by libmapserver
-        and therefre there is no need to include this function */
-int msOracleSpatialLayerInitializeVirtualTable(layerObj *layer)
-{
+#else /*if ORACLE_PLUGIN is defined, then this file is not used by             \
+        libmapserver and therefre there is no need to include this function */
+int msOracleSpatialLayerInitializeVirtualTable(layerObj *layer) {
   assert(layer != NULL);
   assert(layer->vtable != NULL);
 
   layer->vtable->LayerTranslateFilter = msOracleSpatialLayerTranslateFilter;
 
-
   layer->vtable->LayerInitItemInfo = msOracleSpatialLayerInitItemInfo;
   layer->vtable->LayerFreeItemInfo = msOracleSpatialLayerFreeItemInfo;
   layer->vtable->LayerOpen = msOracleSpatialLayerOpen;
@@ -4081,11 +4798,12 @@ int msOracleSpatialLayerInitializeVirtua
   layer->vtable->LayerCloseConnection = msOracleSpatialLayerClose;
   layer->vtable->LayerApplyFilterToLayer = msLayerApplyCondSQLFilterToLayer;
   layer->vtable->LayerSetTimeFilter = msLayerMakeBackticsTimeFilter;
-  //layer->vtable->LayerSetTimeFilter = msOracleSpatialLayerSetTimeFilter;
-  //layer->vtable->LayerEscapePropertyName = msOracleSpatialEscapePropertyName;
+  // layer->vtable->LayerSetTimeFilter = msOracleSpatialLayerSetTimeFilter;
+  // layer->vtable->LayerEscapePropertyName = msOracleSpatialEscapePropertyName;
   /* layer->vtable->LayerCreateItems, use default */
   /* layer->vtable->LayerGetNumFeatures, use default */
-  /* layer->vtable->LayerGetAutoProjection = msOracleSpatialLayerGetAutoProjection; Disabled until tested */
+  /* layer->vtable->LayerGetAutoProjection =
+   * msOracleSpatialLayerGetAutoProjection; Disabled until tested */
   layer->vtable->LayerEnablePaging = msOracleSpatialEnablePaging;
   layer->vtable->LayerGetPaging = msOracleSpatialGetPaging;
 
diff -pruN 8.0.1-5/mapoutput.c 8.0.2-1/mapoutput.c
--- 8.0.1-5/mapoutput.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapoutput.c	2024-06-11 20:41:34.000000000 +0000
@@ -31,10 +31,8 @@
 #include "mapserver.h"
 #include "mapows.h"
 
-
-
-static outputFormatObj *msAllocOutputFormat( mapObj *map, const char *name,
-    const char *driver );
+static outputFormatObj *msAllocOutputFormat(mapObj *map, const char *name,
+                                            const char *driver);
 
 /*************************************************************************
 
@@ -95,67 +93,64 @@ typedef struct {
 
  *************************************************************************/
 
-
 struct defaultOutputFormatEntry {
   const char *name;
   const char *driver;
   const char *mimetype;
-} ;
+};
 
 struct defaultOutputFormatEntry defaultoutputformats[] = {
-  {"png","AGG/PNG","image/png"},
-  {"jpeg","AGG/JPEG","image/jpeg"},
-  {"png8","AGG/PNG8","image/png; mode=8bit"},
-  {"png24","AGG/PNG","image/png; mode=24bit"},
-  {"jpegpng", "AGG/MIXED", "image/vnd.jpeg-png"},
-  {"jpegpng8", "AGG/MIXED", "image/vnd.jpeg-png8"},
+    {"png", "AGG/PNG", "image/png"},
+    {"jpeg", "AGG/JPEG", "image/jpeg"},
+    {"png8", "AGG/PNG8", "image/png; mode=8bit"},
+    {"png24", "AGG/PNG", "image/png; mode=24bit"},
+    {"jpegpng", "AGG/MIXED", "image/vnd.jpeg-png"},
+    {"jpegpng8", "AGG/MIXED", "image/vnd.jpeg-png8"},
 #ifdef USE_CAIRO
-  {"pdf","CAIRO/PDF","application/x-pdf"},
-  {"svg","CAIRO/SVG","image/svg+xml"},
-  {"cairopng","CAIRO/PNG","image/png"},
+    {"pdf", "CAIRO/PDF", "application/x-pdf"},
+    {"svg", "CAIRO/SVG", "image/svg+xml"},
+    {"cairopng", "CAIRO/PNG", "image/png"},
 #endif
-  {"GTiff","GDAL/GTiff","image/tiff"},
+    {"GTiff", "GDAL/GTiff", "image/tiff"},
 #ifdef USE_KML
-  {"kml","KML","application/vnd.google-earth.kml+xml"},
-  {"kmz","KMZ","application/vnd.google-earth.kmz"},
+    {"kml", "KML", "application/vnd.google-earth.kml+xml"},
+    {"kmz", "KMZ", "application/vnd.google-earth.kmz"},
 #endif
 #ifdef USE_PBF
-  {"mvt","MVT","application/vnd.mapbox-vector-tile"},
-  // The following format is added to keep backward compatibility
-  // for the application/x-protobuf media type
-  {"mvtxprotobuf","MVT","application/x-protobuf"},
+    {"mvt", "MVT", "application/vnd.mapbox-vector-tile"},
+    // The following format is added to keep backward compatibility
+    // for the application/x-protobuf media type
+    {"mvtxprotobuf", "MVT", "application/x-protobuf"},
 #endif
-  {"json","UTFGrid","application/json"},
-  {NULL,NULL,NULL}
-};
+    {"json", "UTFGrid", "application/json"},
+    {NULL, NULL, NULL}};
 
 /************************************************************************/
 /*                  msPostMapParseOutputFormatSetup()                   */
 /************************************************************************/
 
-int msPostMapParseOutputFormatSetup( mapObj *map )
+int msPostMapParseOutputFormatSetup(mapObj *map)
 
 {
   outputFormatObj *format;
 
   /* If IMAGETYPE not set use the first user defined OUTPUTFORMAT.
      If none, use the first default format. */
-  if( map->imagetype == NULL && map->numoutputformats > 0 )
+  if (map->imagetype == NULL && map->numoutputformats > 0)
     map->imagetype = msStrdup(map->outputformatlist[0]->name);
-  if( map->imagetype == NULL)
+  if (map->imagetype == NULL)
     map->imagetype = msStrdup(defaultoutputformats[0].name);
 
   /* select the current outputformat into map->outputformat */
-  format = msSelectOutputFormat( map, map->imagetype );
-  if( format == NULL ) {
-    msSetError(MS_MISCERR,
-               "Unable to select IMAGETYPE `%s'.",
+  format = msSelectOutputFormat(map, map->imagetype);
+  if (format == NULL) {
+    msSetError(MS_MISCERR, "Unable to select IMAGETYPE `%s'.",
                "msPostMapParseOutputFormatSetup()",
-               map->imagetype ? map->imagetype : "(null)" );
+               map->imagetype ? map->imagetype : "(null)");
     return MS_FAILURE;
   }
 
-  msApplyOutputFormat( &(map->outputformat), format, MS_NOOVERRIDE);
+  msApplyOutputFormat(&(map->outputformat), format, MS_NOOVERRIDE);
 
   return MS_SUCCESS;
 }
@@ -164,59 +159,63 @@ int msPostMapParseOutputFormatSetup( map
 /*                    msCreateDefaultOutputFormat()                     */
 /************************************************************************/
 
-outputFormatObj *msCreateDefaultOutputFormat( mapObj *map,
-    const char *driver,
-    const char *name,
-    const char *mimetype )
+outputFormatObj *msCreateDefaultOutputFormat(mapObj *map, const char *driver,
+                                             const char *name,
+                                             const char *mimetype)
 
 {
 
   outputFormatObj *format = NULL;
-  if( strncasecmp(driver,"GD/",3) == 0 ) {
-    return msCreateDefaultOutputFormat( map, "AGG/PNG8", name, mimetype );
+  if (strncasecmp(driver, "GD/", 3) == 0) {
+    return msCreateDefaultOutputFormat(map, "AGG/PNG8", name, mimetype);
   }
 
-  if( strcasecmp(driver,"UTFGRID") == 0 ) {
-    if(!name) name="utfgrid";
-    format = msAllocOutputFormat( map, name, driver );
+  if (strcasecmp(driver, "UTFGRID") == 0) {
+    if (!name)
+      name = "utfgrid";
+    format = msAllocOutputFormat(map, name, driver);
     format->mimetype = msStrdup("application/json");
     format->imagemode = MS_IMAGEMODE_RGB;
     format->extension = msStrdup("json");
     format->renderer = MS_RENDER_WITH_UTFGRID;
   }
 
-  else if( strcasecmp(driver,"AGG/PNG") == 0 ) {
-    if(!name) name="png";
-    format = msAllocOutputFormat( map, name, driver );
+  else if (strcasecmp(driver, "AGG/PNG") == 0) {
+    if (!name)
+      name = "png";
+    format = msAllocOutputFormat(map, name, driver);
     format->mimetype = msStrdup("image/png");
     format->imagemode = MS_IMAGEMODE_RGB;
     format->extension = msStrdup("png");
     format->renderer = MS_RENDER_WITH_AGG;
   }
 
-  else if( strcasecmp(driver,"AGG/PNG8") == 0 ) {
-    if(!name) name="png8";
-    format = msAllocOutputFormat( map, name, driver );
+  else if (strcasecmp(driver, "AGG/PNG8") == 0) {
+    if (!name)
+      name = "png8";
+    format = msAllocOutputFormat(map, name, driver);
     format->mimetype = msStrdup("image/png; mode=8bit");
     format->imagemode = MS_IMAGEMODE_RGB;
     format->extension = msStrdup("png");
     format->renderer = MS_RENDER_WITH_AGG;
-    msSetOutputFormatOption( format, "QUANTIZE_FORCE", "on");
-    msSetOutputFormatOption( format, "QUANTIZE_COLORS", "256");
+    msSetOutputFormatOption(format, "QUANTIZE_FORCE", "on");
+    msSetOutputFormatOption(format, "QUANTIZE_COLORS", "256");
   }
 
-  else if( strcasecmp(driver,"AGG/JPEG") == 0 ) {
-    if(!name) name="jpeg";
-    format = msAllocOutputFormat( map, name, driver );
+  else if (strcasecmp(driver, "AGG/JPEG") == 0) {
+    if (!name)
+      name = "jpeg";
+    format = msAllocOutputFormat(map, name, driver);
     format->mimetype = msStrdup("image/jpeg");
     format->imagemode = MS_IMAGEMODE_RGB;
     format->extension = msStrdup("jpg");
     format->renderer = MS_RENDER_WITH_AGG;
   }
 #if defined(USE_PBF)
-  else if( strcasecmp(driver,"MVT") == 0 ) {
-    if(!name) name="mvt";
-    format = msAllocOutputFormat( map, name, driver );
+  else if (strcasecmp(driver, "MVT") == 0) {
+    if (!name)
+      name = "mvt";
+    format = msAllocOutputFormat(map, name, driver);
     if (mimetype) {
       format->mimetype = msStrdup(mimetype);
     } else {
@@ -229,31 +228,32 @@ outputFormatObj *msCreateDefaultOutputFo
   }
 #endif
 
-  else if( strcasecmp(driver,"AGG/MIXED") == 0 &&
-           name != NULL && strcasecmp(name,"jpegpng") == 0 ) {
-    format = msAllocOutputFormat( map, name, driver );
+  else if (strcasecmp(driver, "AGG/MIXED") == 0 && name != NULL &&
+           strcasecmp(name, "jpegpng") == 0) {
+    format = msAllocOutputFormat(map, name, driver);
     format->mimetype = msStrdup("image/vnd.jpeg-png");
     format->imagemode = MS_IMAGEMODE_RGBA;
     format->extension = msStrdup("XXX");
     format->renderer = MS_RENDER_WITH_AGG;
-    msSetOutputFormatOption( format, "OPAQUE_FORMAT", "jpeg");
-    msSetOutputFormatOption( format, "TRANSPARENT_FORMAT", "png24");
+    msSetOutputFormatOption(format, "OPAQUE_FORMAT", "jpeg");
+    msSetOutputFormatOption(format, "TRANSPARENT_FORMAT", "png24");
   }
 
-  else if( strcasecmp(driver,"AGG/MIXED") == 0 &&
-           name != NULL && strcasecmp(name,"jpegpng8") == 0 ) {
-    format = msAllocOutputFormat( map, name, driver );
+  else if (strcasecmp(driver, "AGG/MIXED") == 0 && name != NULL &&
+           strcasecmp(name, "jpegpng8") == 0) {
+    format = msAllocOutputFormat(map, name, driver);
     format->mimetype = msStrdup("image/vnd.jpeg-png8");
     format->imagemode = MS_IMAGEMODE_RGBA;
     format->extension = msStrdup("XXX");
     format->renderer = MS_RENDER_WITH_AGG;
-    msSetOutputFormatOption( format, "OPAQUE_FORMAT", "jpeg");
-    msSetOutputFormatOption( format, "TRANSPARENT_FORMAT", "png8");
+    msSetOutputFormatOption(format, "OPAQUE_FORMAT", "jpeg");
+    msSetOutputFormatOption(format, "TRANSPARENT_FORMAT", "png8");
   }
 
-  else if( strcasecmp(driver,"AGG/MIXED") == 0 ) {
-    if(!name) name="mixed";
-    format = msAllocOutputFormat( map, name, driver );
+  else if (strcasecmp(driver, "AGG/MIXED") == 0) {
+    if (!name)
+      name = "mixed";
+    format = msAllocOutputFormat(map, name, driver);
     format->mimetype = msStrdup("image/mixed");
     format->imagemode = MS_IMAGEMODE_RGBA;
     format->extension = msStrdup("XXX");
@@ -261,50 +261,52 @@ outputFormatObj *msCreateDefaultOutputFo
   }
 
 #if defined(USE_CAIRO)
-  else if( strcasecmp(driver,"CAIRO/PNG") == 0 ) {
-    if(!name) name="cairopng";
-    format = msAllocOutputFormat( map, name, driver );
+  else if (strcasecmp(driver, "CAIRO/PNG") == 0) {
+    if (!name)
+      name = "cairopng";
+    format = msAllocOutputFormat(map, name, driver);
     format->mimetype = msStrdup("image/png; mode=24bit");
     format->imagemode = MS_IMAGEMODE_RGB;
     format->extension = msStrdup("png");
     format->renderer = MS_RENDER_WITH_CAIRO_RASTER;
-  }
-  else if( strcasecmp(driver,"CAIRO/JPEG") == 0 ) {
-    if(!name) name="cairojpeg";
-    format = msAllocOutputFormat( map, name, driver );
+  } else if (strcasecmp(driver, "CAIRO/JPEG") == 0) {
+    if (!name)
+      name = "cairojpeg";
+    format = msAllocOutputFormat(map, name, driver);
     format->mimetype = msStrdup("image/jpeg");
     format->imagemode = MS_IMAGEMODE_RGB;
     format->extension = msStrdup("jpg");
     format->renderer = MS_RENDER_WITH_CAIRO_RASTER;
-  }
-  else if( strcasecmp(driver,"CAIRO/PDF") == 0 ) {
-    if(!name) name="pdf";
-    format = msAllocOutputFormat( map, name, driver );
+  } else if (strcasecmp(driver, "CAIRO/PDF") == 0) {
+    if (!name)
+      name = "pdf";
+    format = msAllocOutputFormat(map, name, driver);
     format->mimetype = msStrdup("application/x-pdf");
     format->imagemode = MS_IMAGEMODE_RGB;
     format->extension = msStrdup("pdf");
     format->renderer = MS_RENDER_WITH_CAIRO_PDF;
-  }
-  else if( strcasecmp(driver,"CAIRO/SVG") == 0 ) {
-    if(!name) name="svg";
-    format = msAllocOutputFormat( map, name, driver );
+  } else if (strcasecmp(driver, "CAIRO/SVG") == 0) {
+    if (!name)
+      name = "svg";
+    format = msAllocOutputFormat(map, name, driver);
     format->mimetype = msStrdup("image/svg+xml");
     format->imagemode = MS_IMAGEMODE_RGB;
     format->extension = msStrdup("svg");
     format->renderer = MS_RENDER_WITH_CAIRO_SVG;
   }
 #ifdef _WIN32
-  else if( strcasecmp(driver,"CAIRO/WINGDI") == 0 ) {
-    if(!name) name="cairowinGDI";
-    format = msAllocOutputFormat( map, name, driver );
+  else if (strcasecmp(driver, "CAIRO/WINGDI") == 0) {
+    if (!name)
+      name = "cairowinGDI";
+    format = msAllocOutputFormat(map, name, driver);
     format->mimetype = msStrdup("");
     format->imagemode = MS_IMAGEMODE_RGB;
     format->extension = msStrdup("");
     format->renderer = MS_RENDER_WITH_CAIRO_RASTER;
-  }
-  else if( strcasecmp(driver,"CAIRO/WINGDIPRINT") == 0 ) {
-    if(!name) name="cairowinGDIPrint";
-    format = msAllocOutputFormat( map, name, driver );
+  } else if (strcasecmp(driver, "CAIRO/WINGDIPRINT") == 0) {
+    if (!name)
+      name = "cairowinGDIPrint";
+    format = msAllocOutputFormat(map, name, driver);
     format->mimetype = msStrdup("");
     format->imagemode = MS_IMAGEMODE_RGB;
     format->extension = msStrdup("");
@@ -314,9 +316,10 @@ outputFormatObj *msCreateDefaultOutputFo
 #endif
 
 #if defined(USE_OGL)
-  else if( strcasecmp(driver,"OGL/PNG") == 0 ) {
-    if(!name) name="oglpng24";
-    format = msAllocOutputFormat( map, name, driver );
+  else if (strcasecmp(driver, "OGL/PNG") == 0) {
+    if (!name)
+      name = "oglpng24";
+    format = msAllocOutputFormat(map, name, driver);
     format->mimetype = msStrdup("image/png; mode=24bit");
     format->imagemode = MS_IMAGEMODE_RGB;
     format->extension = msStrdup("png");
@@ -325,78 +328,80 @@ outputFormatObj *msCreateDefaultOutputFo
 #endif
 
 #if defined(USE_KML)
-  else if( strcasecmp(driver,"KML") == 0 ) {
-    if(!name) name="kml";
-    format = msAllocOutputFormat( map, name, driver );
+  else if (strcasecmp(driver, "KML") == 0) {
+    if (!name)
+      name = "kml";
+    format = msAllocOutputFormat(map, name, driver);
     format->mimetype = msStrdup("application/vnd.google-earth.kml+xml");
     format->imagemode = MS_IMAGEMODE_RGB;
     format->extension = msStrdup("kml");
     format->renderer = MS_RENDER_WITH_KML;
-    msSetOutputFormatOption( format, "ATTACHMENT", "mapserver.kml");
-  }
-  else if( strcasecmp(driver,"KMZ") == 0 ) {
-    if(!name) name="kmz";
-    format = msAllocOutputFormat( map, name, driver );
+    msSetOutputFormatOption(format, "ATTACHMENT", "mapserver.kml");
+  } else if (strcasecmp(driver, "KMZ") == 0) {
+    if (!name)
+      name = "kmz";
+    format = msAllocOutputFormat(map, name, driver);
     format->mimetype = msStrdup("application/vnd.google-earth.kmz");
     format->imagemode = MS_IMAGEMODE_RGB;
     format->extension = msStrdup("kmz");
     format->renderer = MS_RENDER_WITH_KML;
-    msSetOutputFormatOption( format, "ATTACHMENT", "mapserver.kmz");
+    msSetOutputFormatOption(format, "ATTACHMENT", "mapserver.kmz");
   }
 #endif
 
-
-
-  else if( strncasecmp(driver,"gdal/",5) == 0 ) {
-    if(!name) name=driver+5;
-    format = msAllocOutputFormat( map, name, driver );
-    if( msInitDefaultGDALOutputFormat( format ) == MS_FAILURE ) {
-      if( map != NULL ) {
+  else if (strncasecmp(driver, "gdal/", 5) == 0) {
+    if (!name)
+      name = driver + 5;
+    format = msAllocOutputFormat(map, name, driver);
+    if (msInitDefaultGDALOutputFormat(format) == MS_FAILURE) {
+      if (map != NULL) {
         map->numoutputformats--;
         map->outputformatlist[map->numoutputformats] = NULL;
       }
 
-      msFreeOutputFormat( format );
+      msFreeOutputFormat(format);
       format = NULL;
     }
   }
 
-  else if( strncasecmp(driver,"ogr/",4) == 0 ) {
-    if(!name) name=driver+4;
-    format = msAllocOutputFormat( map, name, driver );
-    if( msInitDefaultOGROutputFormat( format ) == MS_FAILURE ) {
-      if( map != NULL ) {
+  else if (strncasecmp(driver, "ogr/", 4) == 0) {
+    if (!name)
+      name = driver + 4;
+    format = msAllocOutputFormat(map, name, driver);
+    if (msInitDefaultOGROutputFormat(format) == MS_FAILURE) {
+      if (map != NULL) {
         map->numoutputformats--;
         map->outputformatlist[map->numoutputformats] = NULL;
       }
 
-      msFreeOutputFormat( format );
+      msFreeOutputFormat(format);
       format = NULL;
     }
   }
 
-  else if( strcasecmp(driver,"imagemap") == 0 ) {
-    if(!name) name="imagemap";
-    format = msAllocOutputFormat( map, name, driver );
+  else if (strcasecmp(driver, "imagemap") == 0) {
+    if (!name)
+      name = "imagemap";
+    format = msAllocOutputFormat(map, name, driver);
     format->mimetype = msStrdup("text/html; driver=imagemap");
     format->extension = msStrdup("html");
     format->imagemode = MS_IMAGEMODE_NULL;
     format->renderer = MS_RENDER_WITH_IMAGEMAP;
   }
 
-  else if( strcasecmp(driver,"template") == 0 ) {
-    if(!name) name="template";
-    format = msAllocOutputFormat( map, name, driver );
+  else if (strcasecmp(driver, "template") == 0) {
+    if (!name)
+      name = "template";
+    format = msAllocOutputFormat(map, name, driver);
     format->mimetype = msStrdup("text/html");
     format->extension = msStrdup("html");
     format->imagemode = MS_IMAGEMODE_FEATURE;
     format->renderer = MS_RENDER_WITH_TEMPLATE;
   }
 
-  if( format != NULL )
+  if (format != NULL)
     format->inmapfile = MS_FALSE;
 
-
   return format;
 }
 
@@ -404,25 +409,24 @@ outputFormatObj *msCreateDefaultOutputFo
 /*                    msApplyDefaultOutputFormats()                     */
 /************************************************************************/
 
-
-void msApplyDefaultOutputFormats( mapObj *map )
-{
+void msApplyDefaultOutputFormats(mapObj *map) {
   char *saved_imagetype;
   struct defaultOutputFormatEntry *defEntry;
 
-  if( map->imagetype == NULL )
+  if (map->imagetype == NULL)
     saved_imagetype = NULL;
   else
     saved_imagetype = msStrdup(map->imagetype);
 
   defEntry = defaultoutputformats;
-  while(defEntry->name) {
-    if( msSelectOutputFormat( map, defEntry->name ) == NULL )
-      msCreateDefaultOutputFormat( map, defEntry->driver, defEntry->name, defEntry->mimetype );
+  while (defEntry->name) {
+    if (msSelectOutputFormat(map, defEntry->name) == NULL)
+      msCreateDefaultOutputFormat(map, defEntry->driver, defEntry->name,
+                                  defEntry->mimetype);
     defEntry++;
   }
-  if( map->imagetype != NULL )
-    free( map->imagetype );
+  if (map->imagetype != NULL)
+    free(map->imagetype);
   map->imagetype = saved_imagetype;
 }
 
@@ -430,33 +434,33 @@ void msApplyDefaultOutputFormats( mapObj
 /*                         msFreeOutputFormat()                         */
 /************************************************************************/
 
-void msFreeOutputFormat( outputFormatObj *format )
+void msFreeOutputFormat(outputFormatObj *format)
 
 {
-  if( format == NULL )
+  if (format == NULL)
     return;
-  if( MS_REFCNT_DECR_IS_NOT_ZERO(format) ) {
+  if (MS_REFCNT_DECR_IS_NOT_ZERO(format)) {
     return;
   }
 
-  if(MS_RENDERER_PLUGIN(format) && format->vtable) {
+  if (MS_RENDERER_PLUGIN(format) && format->vtable) {
     format->vtable->cleanup(MS_RENDERER_CACHE(format->vtable));
-    free( format->vtable );
+    free(format->vtable);
   }
-  msFree( format->name );
-  msFree( format->mimetype );
-  msFree( format->driver );
-  msFree( format->extension );
-  msFreeCharArray( format->formatoptions, format->numformatoptions );
-  msFree( format );
+  msFree(format->name);
+  msFree(format->mimetype);
+  msFree(format->driver);
+  msFree(format->extension);
+  msFreeCharArray(format->formatoptions, format->numformatoptions);
+  msFree(format);
 }
 
 /************************************************************************/
 /*                        msAllocOutputFormat()                         */
 /************************************************************************/
 
-static outputFormatObj *msAllocOutputFormat( mapObj *map, const char *name,
-    const char *driver )
+static outputFormatObj *msAllocOutputFormat(mapObj *map, const char *name,
+                                            const char *driver)
 
 {
   outputFormatObj *format;
@@ -464,9 +468,9 @@ static outputFormatObj *msAllocOutputFor
   /* -------------------------------------------------------------------- */
   /*      Allocate the format object.                                     */
   /* -------------------------------------------------------------------- */
-  format = (outputFormatObj *) calloc(1,sizeof(outputFormatObj));
-  if( format == NULL ) {
-    msSetError( MS_MEMERR, NULL, "msAllocOutputFormat()" );
+  format = (outputFormatObj *)calloc(1, sizeof(outputFormatObj));
+  if (format == NULL) {
+    msSetError(MS_MEMERR, NULL, "msAllocOutputFormat()");
     return NULL;
   }
 
@@ -484,16 +488,15 @@ static outputFormatObj *msAllocOutputFor
   /* -------------------------------------------------------------------- */
   /*      Attach to map.                                                  */
   /* -------------------------------------------------------------------- */
-  if( map != NULL ) {
+  if (map != NULL) {
     map->numoutputformats++;
-    if( map->outputformatlist == NULL )
-      map->outputformatlist = (outputFormatObj **) malloc(sizeof(void*));
+    if (map->outputformatlist == NULL)
+      map->outputformatlist = (outputFormatObj **)malloc(sizeof(void *));
     else
-      map->outputformatlist = (outputFormatObj **)
-                              realloc(map->outputformatlist,
-                                      sizeof(void*) * map->numoutputformats );
+      map->outputformatlist = (outputFormatObj **)realloc(
+          map->outputformatlist, sizeof(void *) * map->numoutputformats);
 
-    map->outputformatlist[map->numoutputformats-1] = format;
+    map->outputformatlist[map->numoutputformats - 1] = format;
     format->refcount++;
   }
 
@@ -506,21 +509,19 @@ static outputFormatObj *msAllocOutputFor
 /*      Add an output format  .                                         */
 /*      http://mapserver.gis.umn.edu/bugs/show_bug.cgi?id=511           */
 /************************************************************************/
-int msAppendOutputFormat(mapObj *map, outputFormatObj *format)
-{
+int msAppendOutputFormat(mapObj *map, outputFormatObj *format) {
   /* -------------------------------------------------------------------- */
   /*      Attach to map.                                                  */
   /* -------------------------------------------------------------------- */
   assert(map);
   map->numoutputformats++;
   if (map->outputformatlist == NULL)
-    map->outputformatlist = (outputFormatObj **) malloc(sizeof(void*));
+    map->outputformatlist = (outputFormatObj **)malloc(sizeof(void *));
   else
-    map->outputformatlist = (outputFormatObj **)
-                            realloc(map->outputformatlist,
-                                    sizeof(void*) * map->numoutputformats );
+    map->outputformatlist = (outputFormatObj **)realloc(
+        map->outputformatlist, sizeof(void *) * map->numoutputformats);
 
-  map->outputformatlist[map->numoutputformats-1] = format;
+  map->outputformatlist[map->numoutputformats - 1] = format;
   MS_REFCNT_INCR(format);
 
   return map->numoutputformats;
@@ -532,30 +533,29 @@ int msAppendOutputFormat(mapObj *map, ou
 /*      Remove an output format (by name).                              */
 /*      http://mapserver.gis.umn.edu/bugs/show_bug.cgi?id=511           */
 /************************************************************************/
-int msRemoveOutputFormat(mapObj *map, const char *name)
-{
+int msRemoveOutputFormat(mapObj *map, const char *name) {
   int i, j;
   /* -------------------------------------------------------------------- */
   /*      Detach from map.                                                */
   /* -------------------------------------------------------------------- */
   if (map != NULL) {
     if (map->outputformatlist == NULL) {
-      msSetError(MS_CHILDERR, "Can't remove format from empty outputformatlist", "msRemoveOutputFormat()");
+      msSetError(MS_CHILDERR, "Can't remove format from empty outputformatlist",
+                 "msRemoveOutputFormat()");
       return MS_FAILURE;
     } else {
       i = msGetOutputFormatIndex(map, name);
       if (i >= 0) {
         map->numoutputformats--;
-	if(MS_REFCNT_DECR_IS_ZERO(map->outputformatlist[i]))
-           msFreeOutputFormat( map->outputformatlist[i] );
+        if (MS_REFCNT_DECR_IS_ZERO(map->outputformatlist[i]))
+          msFreeOutputFormat(map->outputformatlist[i]);
 
-        for (j=i; j<map->numoutputformats-1; j++) {
-          map->outputformatlist[j] = map->outputformatlist[j+1];
+        for (j = i; j < map->numoutputformats - 1; j++) {
+          map->outputformatlist[j] = map->outputformatlist[j + 1];
         }
       }
-      map->outputformatlist = (outputFormatObj **)
-                              realloc(map->outputformatlist,
-                                      sizeof(void*) * (map->numoutputformats) );
+      map->outputformatlist = (outputFormatObj **)realloc(
+          map->outputformatlist, sizeof(void *) * (map->numoutputformats));
       return MS_SUCCESS;
     }
   }
@@ -568,22 +568,20 @@ int msRemoveOutputFormat(mapObj *map, co
 /*      Pulled this out of msSelectOutputFormat for use in other cases. */
 /************************************************************************/
 
-int msGetOutputFormatIndex(mapObj *map, const char *imagetype)
-{
+int msGetOutputFormatIndex(mapObj *map, const char *imagetype) {
   int i;
   /* -------------------------------------------------------------------- */
   /*      Try to find the format in the maps list of formats, first by    */
   /*      mime type, and then by output format name.                      */
   /* -------------------------------------------------------------------- */
   for (i = 0; i < map->numoutputformats; i++) {
-    if (map->outputformatlist[i]->mimetype != NULL
-        && strcasecmp(imagetype,
-                      map->outputformatlist[i]->mimetype) == 0 )
+    if (map->outputformatlist[i]->mimetype != NULL &&
+        strcasecmp(imagetype, map->outputformatlist[i]->mimetype) == 0)
       return i;
   }
 
-  for( i = 0; i < map->numoutputformats; i++ ) {
-    if( strcasecmp(imagetype,map->outputformatlist[i]->name) == 0 )
+  for (i = 0; i < map->numoutputformats; i++) {
+    if (strcasecmp(imagetype, map->outputformatlist[i]->name) == 0)
       return i;
   }
 
@@ -594,16 +592,13 @@ int msGetOutputFormatIndex(mapObj *map,
 /*                        msSelectOutputFormat()                        */
 /************************************************************************/
 
-
-
-outputFormatObj *msSelectOutputFormat( mapObj *map,
-                                       const char *imagetype )
+outputFormatObj *msSelectOutputFormat(mapObj *map, const char *imagetype)
 
 {
   int index;
   outputFormatObj *format = NULL;
 
-  if( map == NULL || imagetype == NULL || strlen(imagetype) == 0 )
+  if (map == NULL || imagetype == NULL || strlen(imagetype) == 0)
     return NULL;
 
   /* -------------------------------------------------------------------- */
@@ -615,14 +610,15 @@ outputFormatObj *msSelectOutputFormat( m
     format = map->outputformatlist[index];
   } else {
     struct defaultOutputFormatEntry *formatEntry = defaultoutputformats;
-    while(formatEntry->name) {
-      if(!strcasecmp(imagetype,formatEntry->name) || !strcasecmp(imagetype,formatEntry->mimetype)) {
-        format = msCreateDefaultOutputFormat( map, formatEntry->driver, formatEntry->name, formatEntry->mimetype );
+    while (formatEntry->name) {
+      if (!strcasecmp(imagetype, formatEntry->name) ||
+          !strcasecmp(imagetype, formatEntry->mimetype)) {
+        format = msCreateDefaultOutputFormat(
+            map, formatEntry->driver, formatEntry->name, formatEntry->mimetype);
         break;
       }
       formatEntry++;
     }
-
   }
 
   if (format) {
@@ -631,8 +627,8 @@ outputFormatObj *msSelectOutputFormat( m
     map->imagetype = msStrdup(format->name);
   }
 
-  if( format != NULL )
-    msOutputFormatValidate( format, MS_FALSE );
+  if (format != NULL)
+    msOutputFormatValidate(format, MS_FALSE);
 
   return format;
 }
@@ -641,81 +637,79 @@ outputFormatObj *msSelectOutputFormat( m
 /*                        msApplyOutputFormat()                         */
 /************************************************************************/
 
-void msApplyOutputFormat( outputFormatObj **target,
-                          outputFormatObj *format,
-                          int transparent)
+void msApplyOutputFormat(outputFormatObj **target, outputFormatObj *format,
+                         int transparent)
 
 {
-  int       change_needed = MS_FALSE;
+  int change_needed = MS_FALSE;
   outputFormatObj *formatToFree = NULL;
 
-  assert( target != NULL );
+  assert(target != NULL);
 
-  if( *target != NULL && MS_REFCNT_DECR_IS_ZERO( (*target) ) ) {
+  if (*target != NULL && MS_REFCNT_DECR_IS_ZERO((*target))) {
     formatToFree = *target;
     *target = NULL;
   }
 
-  if( format == NULL ) {
-    if( formatToFree )
-      msFreeOutputFormat( formatToFree );
+  if (format == NULL) {
+    if (formatToFree)
+      msFreeOutputFormat(formatToFree);
     *target = NULL;
     return;
   }
 
-  msOutputFormatValidate( format, MS_FALSE );
+  msOutputFormatValidate(format, MS_FALSE);
 
   /* -------------------------------------------------------------------- */
   /*      Do we need to change any values?  If not, then just apply       */
   /*      and return.                                                     */
   /* -------------------------------------------------------------------- */
-  if( transparent != MS_NOOVERRIDE && !format->transparent != !transparent )
-      change_needed = MS_TRUE;
+  if (transparent != MS_NOOVERRIDE && !format->transparent != !transparent)
+    change_needed = MS_TRUE;
 
-  if( change_needed ) {
+  if (change_needed) {
 
-    if( format->refcount > 0 )
-      format = msCloneOutputFormat( format );
+    if (format->refcount > 0)
+      format = msCloneOutputFormat(format);
 
-    if( transparent != MS_NOOVERRIDE ) {
-        format->transparent = transparent;
-        if( format->imagemode == MS_IMAGEMODE_RGB )
-            format->imagemode = MS_IMAGEMODE_RGBA;
+    if (transparent != MS_NOOVERRIDE) {
+      format->transparent = transparent;
+      if (format->imagemode == MS_IMAGEMODE_RGB)
+        format->imagemode = MS_IMAGEMODE_RGBA;
     }
   }
 
   *target = format;
   format->refcount++;
-  if( MS_RENDERER_PLUGIN(format) ) {
+  if (MS_RENDERER_PLUGIN(format)) {
     msInitializeRendererVTable(format);
   }
 
-
-  if( formatToFree )
-    msFreeOutputFormat( formatToFree );
+  if (formatToFree)
+    msFreeOutputFormat(formatToFree);
 }
 
 /************************************************************************/
 /*                        msCloneOutputFormat()                         */
 /************************************************************************/
 
-outputFormatObj *msCloneOutputFormat( outputFormatObj *src )
+outputFormatObj *msCloneOutputFormat(outputFormatObj *src)
 
 {
   outputFormatObj *dst;
-  int             i;
+  int i;
 
-  dst = msAllocOutputFormat( NULL, src->name, src->driver );
+  dst = msAllocOutputFormat(NULL, src->name, src->driver);
 
-  msFree( dst->mimetype );
-  if( src->mimetype )
-    dst->mimetype = msStrdup( src->mimetype );
+  msFree(dst->mimetype);
+  if (src->mimetype)
+    dst->mimetype = msStrdup(src->mimetype);
   else
     dst->mimetype = NULL;
 
-  msFree( dst->extension );
-  if( src->extension )
-    dst->extension = msStrdup( src->extension );
+  msFree(dst->extension);
+  if (src->extension)
+    dst->extension = msStrdup(src->extension);
   else
     dst->extension = NULL;
 
@@ -726,10 +720,9 @@ outputFormatObj *msCloneOutputFormat( ou
   dst->bands = src->bands;
 
   dst->numformatoptions = src->numformatoptions;
-  dst->formatoptions = (char **)
-                       malloc(sizeof(char *) * src->numformatoptions );
+  dst->formatoptions = (char **)malloc(sizeof(char *) * src->numformatoptions);
 
-  for( i = 0; i < src->numformatoptions; i++ )
+  for (i = 0; i < src->numformatoptions; i++)
     dst->formatoptions[i] = msStrdup(src->formatoptions[i]);
 
   dst->inmapfile = src->inmapfile;
@@ -744,16 +737,16 @@ outputFormatObj *msCloneOutputFormat( ou
 /*      options are in "KEY=VALUE" format.                              */
 /************************************************************************/
 
-const char *msGetOutputFormatOption( outputFormatObj *format,
-                                     const char *optionkey,
-                                     const char *defaultresult )
+const char *msGetOutputFormatOption(outputFormatObj *format,
+                                    const char *optionkey,
+                                    const char *defaultresult)
 
 {
-  int    i, len = strlen(optionkey);
+  int i, len = strlen(optionkey);
 
-  for( i = 0; i < format->numformatoptions; i++ ) {
-    if( strncasecmp(format->formatoptions[i],optionkey,len) == 0
-        && format->formatoptions[i][len] == '=' )
+  for (i = 0; i < format->numformatoptions; i++) {
+    if (strncasecmp(format->formatoptions[i], optionkey, len) == 0 &&
+        format->formatoptions[i][len] == '=')
       return format->formatoptions[i] + len + 1;
   }
 
@@ -764,36 +757,36 @@ const char *msGetOutputFormatOption( out
 /*                      msSetOutputFormatOption()                       */
 /************************************************************************/
 
-void msSetOutputFormatOption( outputFormatObj *format,
-                              const char *key, const char *value )
+void msSetOutputFormatOption(outputFormatObj *format, const char *key,
+                             const char *value)
 
 {
   char *newline;
-  int   i, len;
+  int i, len;
 
-  if( value == NULL )
+  if (value == NULL)
     return;
 
   /* -------------------------------------------------------------------- */
   /*      Format the name=value pair into a newly allocated string.       */
   /* -------------------------------------------------------------------- */
-  newline = (char *) malloc(strlen(key)+strlen(value)+2);
-  if( newline == NULL ) {
-    assert( newline != NULL );
+  newline = (char *)malloc(strlen(key) + strlen(value) + 2);
+  if (newline == NULL) {
+    assert(newline != NULL);
     return;
   }
 
-  sprintf( newline, "%s=%s", key, value );
+  sprintf(newline, "%s=%s", key, value);
 
   /* -------------------------------------------------------------------- */
   /*      Does this key already occur?  If so replace it.                 */
   /* -------------------------------------------------------------------- */
   len = strlen(key);
 
-  for( i = 0; i < format->numformatoptions; i++ ) {
-    if( strncasecmp(format->formatoptions[i],key,len) == 0
-        && format->formatoptions[i][len] == '=' ) {
-      free( format->formatoptions[i] );
+  for (i = 0; i < format->numformatoptions; i++) {
+    if (strncasecmp(format->formatoptions[i], key, len) == 0 &&
+        format->formatoptions[i][len] == '=') {
+      free(format->formatoptions[i]);
       format->formatoptions[i] = newline;
       return;
     }
@@ -803,16 +796,15 @@ void msSetOutputFormatOption( outputForm
   /*      otherwise, we need to grow the list.                            */
   /* -------------------------------------------------------------------- */
   format->numformatoptions++;
-  format->formatoptions = (char **)
-                          realloc( format->formatoptions,
-                                   sizeof(char*) * format->numformatoptions );
+  format->formatoptions = (char **)realloc(
+      format->formatoptions, sizeof(char *) * format->numformatoptions);
 
-  format->formatoptions[format->numformatoptions-1] = newline;
+  format->formatoptions[format->numformatoptions - 1] = newline;
 
   /* -------------------------------------------------------------------- */
   /*      Capture generic value(s) we are interested in.                  */
   /* -------------------------------------------------------------------- */
-  if( strcasecmp(key,"BAND_COUNT") == 0 )
+  if (strcasecmp(key, "BAND_COUNT") == 0)
     format->bands = atoi(value);
 }
 
@@ -820,77 +812,77 @@ void msSetOutputFormatOption( outputForm
 /*                     msGetOutputFormatMimeList()                      */
 /************************************************************************/
 
-void msGetOutputFormatMimeList( mapObj *map, char **mime_list, int max_mime )
+void msGetOutputFormatMimeList(mapObj *map, char **mime_list, int max_mime)
 
 {
   int mime_count = 0, i;
 
   msApplyDefaultOutputFormats(map);
-  for( i = 0; i < map->numoutputformats && mime_count < max_mime; i++ ) {
-    int  j;
+  for (i = 0; i < map->numoutputformats && mime_count < max_mime; i++) {
+    int j;
 
-    if( map->outputformatlist[i]->mimetype == NULL )
+    if (map->outputformatlist[i]->mimetype == NULL)
       continue;
 
-    for( j = 0; j < mime_count; j++ ) {
-      if( strcasecmp(mime_list[j],
-                     map->outputformatlist[i]->mimetype) == 0 )
+    for (j = 0; j < mime_count; j++) {
+      if (strcasecmp(mime_list[j], map->outputformatlist[i]->mimetype) == 0)
         break;
     }
 
-    if( j == mime_count )
+    if (j == mime_count)
       mime_list[mime_count++] = map->outputformatlist[i]->mimetype;
   }
 
-  if( mime_count < max_mime )
+  if (mime_count < max_mime)
     mime_list[mime_count] = NULL;
 }
 
 /************************************************************************/
 /*                     msGetOutputFormatMimeList()                      */
 /************************************************************************/
-void msGetOutputFormatMimeListImg( mapObj *map, const char **mime_list, int max_mime )
+void msGetOutputFormatMimeListImg(mapObj *map, const char **mime_list,
+                                  int max_mime)
 
 {
-  int mime_count = 0, i,j;
+  int mime_count = 0, i, j;
   const char *format_list = NULL;
   char **tokens = NULL;
   int numtokens = 0;
   outputFormatObj *format;
 
   msApplyDefaultOutputFormats(map);
-  format_list = msOWSLookupMetadata(&(map->web.metadata), "M","getlegendgraphic_formatlist");
-  if ( format_list && strlen(format_list) > 0)
-    tokens = msStringSplit(format_list,  ',', &numtokens);
+  format_list = msOWSLookupMetadata(&(map->web.metadata), "M",
+                                    "getlegendgraphic_formatlist");
+  if (format_list && strlen(format_list) > 0)
+    tokens = msStringSplit(format_list, ',', &numtokens);
 
   if (tokens && numtokens > 0) {
-    for(j = 0; j < numtokens; j++ ) {
+    for (j = 0; j < numtokens; j++) {
       format = msSelectOutputFormat(map, tokens[j]);
       if (format != NULL) {
         mime_list[mime_count++] = format->mimetype;
       }
     }
   } else
-    for( i = 0; i < map->numoutputformats && mime_count < max_mime; i++ ) {
-      int  j;
+    for (i = 0; i < map->numoutputformats && mime_count < max_mime; i++) {
+      int j;
 
-      if( map->outputformatlist[i]->mimetype == NULL )
+      if (map->outputformatlist[i]->mimetype == NULL)
         continue;
 
-      for( j = 0; j < mime_count; j++ ) {
-        if( strcasecmp(mime_list[j],
-                       map->outputformatlist[i]->mimetype) == 0 )
+      for (j = 0; j < mime_count; j++) {
+        if (strcasecmp(mime_list[j], map->outputformatlist[i]->mimetype) == 0)
           break;
       }
 
-      if( j == mime_count && map->outputformatlist[i]->driver &&
-          strncasecmp(map->outputformatlist[i]->driver, "AGG/", 4)==0)
+      if (j == mime_count && map->outputformatlist[i]->driver &&
+          strncasecmp(map->outputformatlist[i]->driver, "AGG/", 4) == 0)
         mime_list[mime_count++] = map->outputformatlist[i]->mimetype;
     }
 
-  if( mime_count < max_mime )
+  if (mime_count < max_mime)
     mime_list[mime_count] = NULL;
-  if(tokens)
+  if (tokens)
     msFreeCharArray(tokens, numtokens);
 }
 
@@ -898,58 +890,56 @@ void msGetOutputFormatMimeListImg( mapOb
 /*                  msGetOutputFormatMimeListWMS()                      */
 /************************************************************************/
 
-void msGetOutputFormatMimeListWMS( mapObj *map, const char **mime_list, int max_mime )
-{
-  int mime_count = 0, i,j;
+void msGetOutputFormatMimeListWMS(mapObj *map, const char **mime_list,
+                                  int max_mime) {
+  int mime_count = 0, i, j;
   const char *format_list = NULL;
   char **tokens = NULL;
   int numtokens = 0;
   outputFormatObj *format;
   msApplyDefaultOutputFormats(map);
-  format_list = msOWSLookupMetadata(&(map->web.metadata), "M","getmap_formatlist");
-  if ( format_list && strlen(format_list) > 0)
-    tokens = msStringSplit(format_list,  ',', &numtokens);
+  format_list =
+      msOWSLookupMetadata(&(map->web.metadata), "M", "getmap_formatlist");
+  if (format_list && strlen(format_list) > 0)
+    tokens = msStringSplit(format_list, ',', &numtokens);
 
   if (tokens && numtokens > 0) {
-    for(j = 0; j < numtokens; j++ ) {
+    for (j = 0; j < numtokens; j++) {
       format = msSelectOutputFormat(map, tokens[j]);
       if (format != NULL) {
         mime_list[mime_count++] = format->mimetype;
       }
     }
   } else {
-    for( i = 0; i < map->numoutputformats && mime_count < max_mime; i++ ) {
-      int  j;
+    for (i = 0; i < map->numoutputformats && mime_count < max_mime; i++) {
+      int j;
 
-      if( map->outputformatlist[i]->mimetype == NULL )
+      if (map->outputformatlist[i]->mimetype == NULL)
         continue;
 
-      for( j = 0; j < mime_count; j++ ) {
-        if( strcasecmp(mime_list[j],
-                       map->outputformatlist[i]->mimetype) == 0 )
+      for (j = 0; j < mime_count; j++) {
+        if (strcasecmp(mime_list[j], map->outputformatlist[i]->mimetype) == 0)
           break;
       }
 
-      if( j == mime_count && map->outputformatlist[i]->driver &&
-          (
-            strncasecmp(map->outputformatlist[i]->driver, "GDAL/", 5)==0 ||
-            strncasecmp(map->outputformatlist[i]->driver, "AGG/", 4)==0 ||
-            strcasecmp(map->outputformatlist[i]->driver, "CAIRO/SVG")==0 ||
-            strcasecmp(map->outputformatlist[i]->driver, "CAIRO/PDF")==0 ||
-            strcasecmp(map->outputformatlist[i]->driver, "kml")==0 ||
-            strcasecmp(map->outputformatlist[i]->driver, "kmz")==0 ||
-            strcasecmp(map->outputformatlist[i]->driver, "mvt")==0 ||
-            strcasecmp(map->outputformatlist[i]->driver, "UTFGRID")==0))
+      if (j == mime_count && map->outputformatlist[i]->driver &&
+          (strncasecmp(map->outputformatlist[i]->driver, "GDAL/", 5) == 0 ||
+           strncasecmp(map->outputformatlist[i]->driver, "AGG/", 4) == 0 ||
+           strcasecmp(map->outputformatlist[i]->driver, "CAIRO/SVG") == 0 ||
+           strcasecmp(map->outputformatlist[i]->driver, "CAIRO/PDF") == 0 ||
+           strcasecmp(map->outputformatlist[i]->driver, "kml") == 0 ||
+           strcasecmp(map->outputformatlist[i]->driver, "kmz") == 0 ||
+           strcasecmp(map->outputformatlist[i]->driver, "mvt") == 0 ||
+           strcasecmp(map->outputformatlist[i]->driver, "UTFGRID") == 0))
         mime_list[mime_count++] = map->outputformatlist[i]->mimetype;
     }
   }
-  if( mime_count < max_mime )
+  if (mime_count < max_mime)
     mime_list[mime_count] = NULL;
-  if(tokens)
+  if (tokens)
     msFreeCharArray(tokens, numtokens);
 }
 
-
 /************************************************************************/
 /*                       msOutputFormatValidate()                       */
 /*                                                                      */
@@ -958,104 +948,107 @@ void msGetOutputFormatMimeListWMS( mapOb
 /*      possible.                                                       */
 /************************************************************************/
 
-int msOutputFormatValidate( outputFormatObj *format, int issue_error )
+int msOutputFormatValidate(outputFormatObj *format, int issue_error)
 
 {
   int result = MS_TRUE;
   char *driver_ext;
 
-  format->bands = atoi(msGetOutputFormatOption( format, "BAND_COUNT", "1" ));
+  format->bands = atoi(msGetOutputFormatOption(format, "BAND_COUNT", "1"));
 
   /* Enforce the requirement that JPEG be RGB and TRANSPARENT=OFF */
-  driver_ext = strstr(format->driver,"/");
-  if( driver_ext && ++driver_ext && !strcasecmp(driver_ext,"JPEG")) {
-    if( format->transparent ) {
-      if( issue_error )
-        msSetError( MS_MISCERR,
-                    "JPEG OUTPUTFORMAT %s has TRANSPARENT set ON, but this is not supported.\n"
-                    "It has been disabled.\n",
-                    "msOutputFormatValidate()", format->name );
+  driver_ext = strstr(format->driver, "/");
+  if (driver_ext && ++driver_ext && !strcasecmp(driver_ext, "JPEG")) {
+    if (format->transparent) {
+      if (issue_error)
+        msSetError(MS_MISCERR,
+                   "JPEG OUTPUTFORMAT %s has TRANSPARENT set ON, but this is "
+                   "not supported.\n"
+                   "It has been disabled.\n",
+                   "msOutputFormatValidate()", format->name);
       else
-        msDebug( "JPEG OUTPUTFORMAT %s has TRANSPARENT set ON, but this is not supported.\n"
-                 "It has been disabled.\n",
-                 format->name );
+        msDebug("JPEG OUTPUTFORMAT %s has TRANSPARENT set ON, but this is not "
+                "supported.\n"
+                "It has been disabled.\n",
+                format->name);
 
       format->transparent = MS_FALSE;
       result = MS_FALSE;
     }
-    if( format->imagemode == MS_IMAGEMODE_RGBA ) {
-      if( issue_error )
-        msSetError( MS_MISCERR,
-                    "JPEG OUTPUTFORMAT %s has IMAGEMODE RGBA, but this is not supported.\n"
-                    "IMAGEMODE forced to RGB.\n",
-                    "msOutputFormatValidate()", format->name );
+    if (format->imagemode == MS_IMAGEMODE_RGBA) {
+      if (issue_error)
+        msSetError(MS_MISCERR,
+                   "JPEG OUTPUTFORMAT %s has IMAGEMODE RGBA, but this is not "
+                   "supported.\n"
+                   "IMAGEMODE forced to RGB.\n",
+                   "msOutputFormatValidate()", format->name);
       else
-        msDebug( "JPEG OUTPUTFORMAT %s has IMAGEMODE RGBA, but this is not supported.\n"
-                 "IMAGEMODE forced to RGB.\n",
-                 format->name );
+        msDebug("JPEG OUTPUTFORMAT %s has IMAGEMODE RGBA, but this is not "
+                "supported.\n"
+                "IMAGEMODE forced to RGB.\n",
+                format->name);
 
       format->imagemode = MS_IMAGEMODE_RGB;
       result = MS_FALSE;
     }
   }
 
-  if( format->transparent && format->imagemode == MS_IMAGEMODE_RGB ) {
-    if( issue_error )
-      msSetError( MS_MISCERR,
-                  "OUTPUTFORMAT %s has TRANSPARENT set ON, but an IMAGEMODE\n"
-                  "of RGB instead of RGBA.  Changing imagemode to RGBA.\n",
-                  "msOutputFormatValidate()", format->name );
+  if (format->transparent && format->imagemode == MS_IMAGEMODE_RGB) {
+    if (issue_error)
+      msSetError(MS_MISCERR,
+                 "OUTPUTFORMAT %s has TRANSPARENT set ON, but an IMAGEMODE\n"
+                 "of RGB instead of RGBA.  Changing imagemode to RGBA.\n",
+                 "msOutputFormatValidate()", format->name);
     else
       msDebug("OUTPUTFORMAT %s has TRANSPARENT set ON, but an IMAGEMODE\n"
               "of RGB instead of RGBA.  Changing imagemode to RGBA.\n",
-              format->name );
+              format->name);
 
     format->imagemode = MS_IMAGEMODE_RGBA;
     result = MS_FALSE;
   }
 
   /* Special checking around RAWMODE image modes. */
-  if( format->imagemode == MS_IMAGEMODE_INT16
-      || format->imagemode == MS_IMAGEMODE_FLOAT32
-      || format->imagemode == MS_IMAGEMODE_BYTE ) {
-    if( strncmp(format->driver,"GDAL/",5) != 0 ) {
+  if (format->imagemode == MS_IMAGEMODE_INT16 ||
+      format->imagemode == MS_IMAGEMODE_FLOAT32 ||
+      format->imagemode == MS_IMAGEMODE_BYTE) {
+    if (strncmp(format->driver, "GDAL/", 5) != 0) {
       result = MS_FALSE;
-      if( issue_error )
-        msSetError( MS_MISCERR,
-                    "OUTPUTFORMAT %s has IMAGEMODE BYTE/INT16/FLOAT32, but this is only supported for GDAL drivers.",
-                    "msOutputFormatValidate()", format->name );
+      if (issue_error)
+        msSetError(MS_MISCERR,
+                   "OUTPUTFORMAT %s has IMAGEMODE BYTE/INT16/FLOAT32, but this "
+                   "is only supported for GDAL drivers.",
+                   "msOutputFormatValidate()", format->name);
       else
-        msDebug( "OUTPUTFORMAT %s has IMAGEMODE BYTE/INT16/FLOAT32, but this is only supported for GDAL drivers.",
-                 format->name );
+        msDebug("OUTPUTFORMAT %s has IMAGEMODE BYTE/INT16/FLOAT32, but this is "
+                "only supported for GDAL drivers.",
+                format->name);
     }
 
-    if( format->renderer != MS_RENDER_WITH_RAWDATA ) /* see bug 724 */
+    if (format->renderer != MS_RENDER_WITH_RAWDATA) /* see bug 724 */
       format->renderer = MS_RENDER_WITH_RAWDATA;
   }
 
-  if( !strcasecmp(format->driver,"AGG/MIXED") )
-  {
-    if( !msGetOutputFormatOption(format, "TRANSPARENT_FORMAT", NULL) )
-    {
+  if (!strcasecmp(format->driver, "AGG/MIXED")) {
+    if (!msGetOutputFormatOption(format, "TRANSPARENT_FORMAT", NULL)) {
       result = MS_FALSE;
-      if( issue_error )
-        msSetError( MS_MISCERR,
-                    "OUTPUTFORMAT %s lacks a 'TRANSPARENT_FORMAT' FORMATOPTION.",
-                    "msOutputFormatValidate()", format->name );
+      if (issue_error)
+        msSetError(MS_MISCERR,
+                   "OUTPUTFORMAT %s lacks a 'TRANSPARENT_FORMAT' FORMATOPTION.",
+                   "msOutputFormatValidate()", format->name);
       else
-        msDebug( "OUTPUTFORMAT %s lacks a 'TRANSPARENT_FORMAT' FORMATOPTION.",
-                 format->name );
+        msDebug("OUTPUTFORMAT %s lacks a 'TRANSPARENT_FORMAT' FORMATOPTION.",
+                format->name);
     }
-    if( !msGetOutputFormatOption(format, "OPAQUE_FORMAT", NULL) )
-    {
+    if (!msGetOutputFormatOption(format, "OPAQUE_FORMAT", NULL)) {
       result = MS_FALSE;
-      if( issue_error )
-        msSetError( MS_MISCERR,
-                    "OUTPUTFORMAT %s lacks a 'OPAQUE_FORMAT' FORMATOPTION.",
-                    "msOutputFormatValidate()", format->name );
+      if (issue_error)
+        msSetError(MS_MISCERR,
+                   "OUTPUTFORMAT %s lacks a 'OPAQUE_FORMAT' FORMATOPTION.",
+                   "msOutputFormatValidate()", format->name);
       else
-        msDebug( "OUTPUTFORMAT %s lacks a 'OPAQUE_FORMAT' FORMATOPTION.",
-                 format->name );
+        msDebug("OUTPUTFORMAT %s lacks a 'OPAQUE_FORMAT' FORMATOPTION.",
+                format->name);
     }
   }
 
@@ -1066,49 +1059,48 @@ int msOutputFormatValidate( outputFormat
 /*                     msInitializeRendererVTable()                     */
 /************************************************************************/
 
-int msInitializeRendererVTable(outputFormatObj *format)
-{
+int msInitializeRendererVTable(outputFormatObj *format) {
   assert(format);
-  if(format->vtable) {
+  if (format->vtable) {
     return MS_SUCCESS;
   }
-  format->vtable = (rendererVTableObj*)calloc(1,sizeof(rendererVTableObj));
+  format->vtable = (rendererVTableObj *)calloc(1, sizeof(rendererVTableObj));
 
   msInitializeDummyRenderer(format->vtable);
 
-  switch(format->renderer) {
-    case MS_RENDER_WITH_AGG:
-      return msPopulateRendererVTableAGG(format->vtable);
-    case MS_RENDER_WITH_UTFGRID:
-      return msPopulateRendererVTableUTFGrid(format->vtable);
+  switch (format->renderer) {
+  case MS_RENDER_WITH_AGG:
+    return msPopulateRendererVTableAGG(format->vtable);
+  case MS_RENDER_WITH_UTFGRID:
+    return msPopulateRendererVTableUTFGrid(format->vtable);
 #ifdef USE_PBF
-    case MS_RENDER_WITH_MVT:
-      return msPopulateRendererVTableMVT(format->vtable);
+  case MS_RENDER_WITH_MVT:
+    return msPopulateRendererVTableMVT(format->vtable);
 #endif
 #ifdef USE_CAIRO
-    case MS_RENDER_WITH_CAIRO_RASTER:
-      return msPopulateRendererVTableCairoRaster(format->vtable);
-    case MS_RENDER_WITH_CAIRO_PDF:
-      return msPopulateRendererVTableCairoPDF(format->vtable);
-    case MS_RENDER_WITH_CAIRO_SVG:
-      return msPopulateRendererVTableCairoSVG(format->vtable);
+  case MS_RENDER_WITH_CAIRO_RASTER:
+    return msPopulateRendererVTableCairoRaster(format->vtable);
+  case MS_RENDER_WITH_CAIRO_PDF:
+    return msPopulateRendererVTableCairoPDF(format->vtable);
+  case MS_RENDER_WITH_CAIRO_SVG:
+    return msPopulateRendererVTableCairoSVG(format->vtable);
 #endif
 #ifdef USE_OGL
-    case MS_RENDER_WITH_OGL:
-      return msPopulateRendererVTableOGL(format->vtable);
+  case MS_RENDER_WITH_OGL:
+    return msPopulateRendererVTableOGL(format->vtable);
 #endif
 #ifdef USE_KML
-    case MS_RENDER_WITH_KML:
-      return msPopulateRendererVTableKML(format->vtable);
+  case MS_RENDER_WITH_KML:
+    return msPopulateRendererVTableKML(format->vtable);
 #endif
 
-    case MS_RENDER_WITH_OGR:
-      return msPopulateRendererVTableOGR(format->vtable);
+  case MS_RENDER_WITH_OGR:
+    return msPopulateRendererVTableOGR(format->vtable);
 
-    default:
-      msSetError(MS_MISCERR, "unsupported RendererVtable renderer %d",
-                 "msInitializeRendererVTable()",format->renderer);
-      return MS_FAILURE;
+  default:
+    msSetError(MS_MISCERR, "unsupported RendererVtable renderer %d",
+               "msInitializeRendererVTable()", format->renderer);
+    return MS_FAILURE;
   }
   /* this code should never be executed */
   return MS_FAILURE;
@@ -1118,80 +1110,74 @@ int msInitializeRendererVTable(outputFor
 /*                    msOutputFormatResolveFromImage()                  */
 /************************************************************************/
 
-void msOutputFormatResolveFromImage( mapObj *map, imageObj* img )
-{
-  outputFormatObj* format = map->outputformat;
-  assert( img->format == format );
-  assert( img->format->refcount >= 2 );
+void msOutputFormatResolveFromImage(mapObj *map, imageObj *img) {
+  outputFormatObj *format = map->outputformat;
+  assert(img->format == format);
+  assert(img->format->refcount >= 2);
 
-  if( format->renderer == MS_RENDER_WITH_AGG &&
+  if (format->renderer == MS_RENDER_WITH_AGG &&
       strcmp(format->driver, "AGG/MIXED") == 0 &&
       (format->imagemode == MS_IMAGEMODE_RGB ||
-       format->imagemode == MS_IMAGEMODE_RGBA) )
-  {
-    outputFormatObj * new_format;
+       format->imagemode == MS_IMAGEMODE_RGBA)) {
+    outputFormatObj *new_format;
     int has_non_opaque_pixels = MS_FALSE;
-    const char* underlying_driver_type = NULL;
-    const char* underlying_driver_name = NULL;
+    const char *underlying_driver_type = NULL;
+    const char *underlying_driver_name = NULL;
 
     // Check if the image has non opaque pixels
-    if( format->imagemode == MS_IMAGEMODE_RGBA )
-    {
+    if (format->imagemode == MS_IMAGEMODE_RGBA) {
       rasterBufferObj rb;
       int ret;
 
-      ret = format->vtable->getRasterBufferHandle(img,&rb);
-      assert( ret == MS_SUCCESS );
+      ret = format->vtable->getRasterBufferHandle(img, &rb);
+      assert(ret == MS_SUCCESS);
       (void)ret;
-      if( rb.data.rgba.a )
-      {
-        for(unsigned row=0; row<rb.height && !has_non_opaque_pixels; row++) {
+      if (rb.data.rgba.a) {
+        for (unsigned row = 0; row < rb.height && !has_non_opaque_pixels;
+             row++) {
           unsigned char *a;
-          a=rb.data.rgba.a+row*rb.data.rgba.row_step;
-          for(unsigned col=0; col<rb.width && !has_non_opaque_pixels; col++) {
-            if(*a < 255) {
+          a = rb.data.rgba.a + row * rb.data.rgba.row_step;
+          for (unsigned col = 0; col < rb.width && !has_non_opaque_pixels;
+               col++) {
+            if (*a < 255) {
               has_non_opaque_pixels = MS_TRUE;
             }
-            a+=rb.data.rgba.pixel_step;
+            a += rb.data.rgba.pixel_step;
           }
         }
       }
     }
 
-    underlying_driver_type = ( has_non_opaque_pixels ) ?
-                                    "TRANSPARENT_FORMAT" : "OPAQUE_FORMAT";
-    underlying_driver_name = msGetOutputFormatOption(format, underlying_driver_type,
-                                                NULL);
-    if( underlying_driver_name == NULL ) {
-      msSetError(MS_MISCERR,
-                 "Missing %s format option on %s.",
-                 "msOutputFormatResolveFromImage()",
-                 underlying_driver_type, format->name );
+    underlying_driver_type =
+        (has_non_opaque_pixels) ? "TRANSPARENT_FORMAT" : "OPAQUE_FORMAT";
+    underlying_driver_name =
+        msGetOutputFormatOption(format, underlying_driver_type, NULL);
+    if (underlying_driver_name == NULL) {
+      msSetError(MS_MISCERR, "Missing %s format option on %s.",
+                 "msOutputFormatResolveFromImage()", underlying_driver_type,
+                 format->name);
       return;
     }
-    new_format = msSelectOutputFormat( map, underlying_driver_name );
-    if( new_format == NULL ) {
-      msSetError(MS_MISCERR,
-                 "Cannot find %s output format.",
-                 "msOutputFormatResolveFromImage()",
-                 underlying_driver_name );
+    new_format = msSelectOutputFormat(map, underlying_driver_name);
+    if (new_format == NULL) {
+      msSetError(MS_MISCERR, "Cannot find %s output format.",
+                 "msOutputFormatResolveFromImage()", underlying_driver_name);
       return;
     }
-    if( new_format->renderer != MS_RENDER_WITH_AGG )
-    {
-      msSetError(MS_MISCERR,
-                 "%s cannot be used as the %s format of %s since it is not AGG based.",
-                 "msOutputFormatResolveFromImage()",
-                 underlying_driver_name, underlying_driver_type, format->name );
+    if (new_format->renderer != MS_RENDER_WITH_AGG) {
+      msSetError(
+          MS_MISCERR,
+          "%s cannot be used as the %s format of %s since it is not AGG based.",
+          "msOutputFormatResolveFromImage()", underlying_driver_name,
+          underlying_driver_type, format->name);
       return;
     }
 
-    msApplyOutputFormat( &(map->outputformat),
-                         new_format,
-                         has_non_opaque_pixels);
+    msApplyOutputFormat(&(map->outputformat), new_format,
+                        has_non_opaque_pixels);
 
-    msFreeOutputFormat( format );
+    msFreeOutputFormat(format);
     img->format = map->outputformat;
-    img->format->refcount ++;
+    img->format->refcount++;
   }
 }
diff -pruN 8.0.1-5/mapows.c 8.0.2-1/mapows.c
--- 8.0.1-5/mapows.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapows.c	2024-06-11 20:41:34.000000000 +0000
@@ -44,14 +44,11 @@
 #include <stdarg.h>
 #include <assert.h>
 
-
-
 /*
 ** msOWSInitRequestObj() initializes an owsRequestObj; i.e: sets
 ** all internal pointers to NULL.
 */
-void msOWSInitRequestObj(owsRequestObj *ows_request)
-{
+void msOWSInitRequestObj(owsRequestObj *ows_request) {
   ows_request->numlayers = 0;
   ows_request->numwmslayerargs = 0;
   ows_request->enabled_layers = NULL;
@@ -67,14 +64,13 @@ void msOWSInitRequestObj(owsRequestObj *
 ** msOWSClearRequestObj() releases all resources associated with an
 ** owsRequestObj.
 */
-void msOWSClearRequestObj(owsRequestObj *ows_request)
-{
+void msOWSClearRequestObj(owsRequestObj *ows_request) {
   msFree(ows_request->enabled_layers);
   msFree(ows_request->layerwmsfilterindex);
   msFree(ows_request->service);
   msFree(ows_request->version);
   msFree(ows_request->request);
-  if(ows_request->document) {
+  if (ows_request->document) {
 #if defined(USE_LIBXML2)
     xmlFreeDoc(ows_request->document);
     xmlCleanupParser();
@@ -86,12 +82,10 @@ void msOWSClearRequestObj(owsRequestObj
 
 #if defined(USE_LIBXML2) && LIBXML_VERSION < 20900
 static int bExternalEntityAsked = MS_FALSE;
-static xmlParserInputPtr  dummyEntityLoader(const char * URL, 
-                                           const char * ID, 
-                                           xmlParserCtxtPtr context )
-{
-    bExternalEntityAsked = MS_TRUE;
-    return NULL;
+static xmlParserInputPtr dummyEntityLoader(const char *URL, const char *ID,
+                                           xmlParserCtxtPtr context) {
+  bExternalEntityAsked = MS_TRUE;
+  return NULL;
 }
 #endif
 
@@ -108,11 +102,12 @@ static xmlParserInputPtr  dummyEntityLoa
 ** or MS_DONE, if the service could not be determined.
 */
 static int msOWSPreParseRequest(cgiRequestObj *request,
-                                owsRequestObj *ows_request)
-{
+                                owsRequestObj *ows_request) {
   /* decide if KVP or XML */
-  if (request->type == MS_GET_REQUEST || (request->type == MS_POST_REQUEST 
-    && request->contenttype && strncmp(request->contenttype, "application/x-www-form-urlencoded", strlen("application/x-www-form-urlencoded")) == 0)) {
+  if (request->type == MS_GET_REQUEST ||
+      (request->type == MS_POST_REQUEST && request->contenttype &&
+       strncmp(request->contenttype, "application/x-www-form-urlencoded",
+               strlen("application/x-www-form-urlencoded")) == 0)) {
     int i;
     /* parse KVP parameters service, version and request */
     for (i = 0; i < request->NumParams; ++i) {
@@ -120,8 +115,8 @@ static int msOWSPreParseRequest(cgiReque
           EQUAL(request->ParamNames[i], "SERVICE")) {
         ows_request->service = msStrdup(request->ParamValues[i]);
       } else if (ows_request->version == NULL &&
-                 (EQUAL(request->ParamNames[i], "VERSION")
-                 || EQUAL(request->ParamNames[i], "WMTVER"))) { /* for WMS */
+                 (EQUAL(request->ParamNames[i], "VERSION") ||
+                  EQUAL(request->ParamNames[i], "WMTVER"))) { /* for WMS */
         ows_request->version = msStrdup(request->ParamValues[i]);
       } else if (ows_request->request == NULL &&
                  EQUAL(request->ParamNames[i], "REQUEST")) {
@@ -129,7 +124,8 @@ static int msOWSPreParseRequest(cgiReque
       }
 
       /* stop if we have all necessary parameters */
-      if(ows_request->service && ows_request->version && ows_request->request) {
+      if (ows_request->service && ows_request->version &&
+          ows_request->request) {
         break;
       }
     }
@@ -143,66 +139,62 @@ static int msOWSPreParseRequest(cgiReque
     CPLXMLNode *temp;
 #endif
     if (!request->postrequest || !strlen(request->postrequest)) {
-      msSetError(MS_OWSERR, "POST request is empty.",
-                 "msOWSPreParseRequest()");
+      msSetError(MS_OWSERR, "POST request is empty.", "msOWSPreParseRequest()");
       return MS_FAILURE;
     }
 #if defined(USE_LIBXML2)
 #if LIBXML_VERSION < 20900
     oldExternalEntityLoader = xmlGetExternalEntityLoader();
     /* to avoid  XML External Entity vulnerability with libxml2 < 2.9 */
-    xmlSetExternalEntityLoader (dummyEntityLoader); 
+    xmlSetExternalEntityLoader(dummyEntityLoader);
     bExternalEntityAsked = MS_FALSE;
 #endif
     /* parse to DOM-Structure with libxml2 and get the root element */
-    ows_request->document = xmlParseMemory(request->postrequest,
-                                           strlen(request->postrequest));
+    ows_request->document =
+        xmlParseMemory(request->postrequest, strlen(request->postrequest));
 #if LIBXML_VERSION < 20900
-    xmlSetExternalEntityLoader (oldExternalEntityLoader); 
-    if( bExternalEntityAsked )
-    {
-        msSetError(MS_OWSERR, "XML parsing error: %s",
-                 "msOWSPreParseRequest()", "External entity fetch");
-        return MS_FAILURE;
+    xmlSetExternalEntityLoader(oldExternalEntityLoader);
+    if (bExternalEntityAsked) {
+      msSetError(MS_OWSERR, "XML parsing error: %s", "msOWSPreParseRequest()",
+                 "External entity fetch");
+      return MS_FAILURE;
     }
 #endif
-    if (ows_request->document == NULL
-        || (root = xmlDocGetRootElement(ows_request->document)) == NULL) {
-      xmlErrorPtr error = xmlGetLastError();
-      msSetError(MS_OWSERR, "XML parsing error: %s",
-                 "msOWSPreParseRequest()", error->message);
+    if (ows_request->document == NULL ||
+        (root = xmlDocGetRootElement(ows_request->document)) == NULL) {
+      const xmlError *error = xmlGetLastError();
+      msSetError(MS_OWSERR, "XML parsing error: %s", "msOWSPreParseRequest()",
+                 error->message);
       return MS_FAILURE;
     }
 
     /* Get service, version and request from root */
-    xmlChar* serviceTmp = xmlGetProp(root, BAD_CAST "service");
+    xmlChar *serviceTmp = xmlGetProp(root, BAD_CAST "service");
     if (serviceTmp != NULL) {
-        ows_request->service = msStrdup((char *) serviceTmp);
-        xmlFree(serviceTmp);
+      ows_request->service = msStrdup((char *)serviceTmp);
+      xmlFree(serviceTmp);
     }
 
-    xmlChar* versionTmp = xmlGetProp(root, BAD_CAST "version");
+    xmlChar *versionTmp = xmlGetProp(root, BAD_CAST "version");
     if (versionTmp != NULL) {
-        ows_request->version = msStrdup((char *) versionTmp);
-        xmlFree(versionTmp);
+      ows_request->version = msStrdup((char *)versionTmp);
+      xmlFree(versionTmp);
     }
 
-    ows_request->request = msStrdup((char *) root->name);
+    ows_request->request = msStrdup((char *)root->name);
 
 #else
     /* parse with CPLXML */
     ows_request->document = CPLParseXMLString(request->postrequest);
     if (ows_request->document == NULL) {
-      msSetError(MS_OWSERR, "XML parsing error: %s",
-                 "msOWSPreParseRequest()", CPLGetLastErrorMsg());
+      msSetError(MS_OWSERR, "XML parsing error: %s", "msOWSPreParseRequest()",
+                 CPLGetLastErrorMsg());
       return MS_FAILURE;
     }
 
     /* remove all namespaces */
     CPLStripXMLNamespace(ows_request->document, NULL, 1);
-    for (temp = ows_request->document;
-         temp != NULL;
-         temp = temp->psNext) {
+    for (temp = ows_request->document; temp != NULL; temp = temp->psNext) {
 
       if (temp->eType == CXT_Element) {
         const char *service, *version;
@@ -226,10 +218,9 @@ static int msOWSPreParseRequest(cgiReque
 
   /* certain WMS requests do not require the service parameter */
   /* see: http://trac.osgeo.org/mapserver/ticket/2531          */
-  if (ows_request->service == NULL
-      && ows_request->request != NULL) {
-    if (EQUAL(ows_request->request, "GetMap")
-        || EQUAL(ows_request->request, "GetFeatureInfo")) {
+  if (ows_request->service == NULL && ows_request->request != NULL) {
+    if (EQUAL(ows_request->request, "GetMap") ||
+        EQUAL(ows_request->request, "GetFeatureInfo")) {
       ows_request->service = msStrdup("WMS");
     } else { /* service could not be determined */
       return MS_DONE;
@@ -249,8 +240,7 @@ static int msOWSPreParseRequest(cgiReque
 **   request then MS_DONE is returned and MapServer is expected to process
 **   this as a regular MapServer (traditional CGI) request.
 */
-int msOWSDispatch(mapObj *map, cgiRequestObj *request, int ows_mode)
-{
+int msOWSDispatch(mapObj *map, cgiRequestObj *request, int ows_mode) {
   int status = MS_DONE, force_ows_mode = 0;
   owsRequestObj ows_request;
 
@@ -261,13 +251,13 @@ int msOWSDispatch(mapObj *map, cgiReques
   force_ows_mode = (ows_mode == OWS || ows_mode == WFS);
 
   msOWSInitRequestObj(&ows_request);
-  switch(msOWSPreParseRequest(request, &ows_request)) {
-    case MS_FAILURE: /* a severe error occurred */
-      return MS_FAILURE;
-    case MS_DONE:
-      /* OWS Service could not be determined              */
-      /* continue for now                                 */
-      status = MS_DONE;
+  switch (msOWSPreParseRequest(request, &ows_request)) {
+  case MS_FAILURE: /* a severe error occurred */
+    return MS_FAILURE;
+  case MS_DONE:
+    /* OWS Service could not be determined              */
+    /* continue for now                                 */
+    status = MS_DONE;
   }
 
   if (ows_request.service == NULL) {
@@ -279,57 +269,64 @@ int msOWSDispatch(mapObj *map, cgiReques
     }
 #endif
 #ifdef USE_WFS_SVR
-    if( msOWSLookupMetadata(&(map->web.metadata), "FO", "cite_wfs2") != NULL ) {
-      status = msWFSException(map, "service", MS_OWS_ERROR_MISSING_PARAMETER_VALUE, NULL );
-    }
-    else
+    if (msOWSLookupMetadata(&(map->web.metadata), "FO", "cite_wfs2") != NULL) {
+      status = msWFSException(map, "service",
+                              MS_OWS_ERROR_MISSING_PARAMETER_VALUE, NULL);
+    } else
 #endif
 
-    /* exit if service is not set */
-    if(force_ows_mode) {
-      msSetError( MS_MISCERR,
-                  "OWS Common exception: exceptionCode=MissingParameterValue, locator=SERVICE, ExceptionText=SERVICE parameter missing.",
-                  "msOWSDispatch()");
-      status = MS_FAILURE;
-    } else {
-      status = MS_DONE;
-    }
+      /* exit if service is not set */
+      if (force_ows_mode) {
+        msSetError(MS_MISCERR,
+                   "OWS Common exception: exceptionCode=MissingParameterValue, "
+                   "locator=SERVICE, ExceptionText=SERVICE parameter missing.",
+                   "msOWSDispatch()");
+        status = MS_FAILURE;
+      } else {
+        status = MS_DONE;
+      }
   } else if (EQUAL(ows_request.service, "WMS")) {
 #ifdef USE_WMS_SVR
     status = msWMSDispatch(map, request, &ows_request, MS_FALSE);
 #else
-    msSetError( MS_WMSERR,
-                "SERVICE=WMS requested, but WMS support not configured in MapServer.",
-                "msOWSDispatch()" );
+    msSetError(
+        MS_WMSERR,
+        "SERVICE=WMS requested, but WMS support not configured in MapServer.",
+        "msOWSDispatch()");
 #endif
   } else if (EQUAL(ows_request.service, "WFS")) {
 #ifdef USE_WFS_SVR
     status = msWFSDispatch(map, request, &ows_request, (ows_mode == WFS));
 #else
-    msSetError( MS_WFSERR,
-                "SERVICE=WFS requested, but WFS support not configured in MapServer.",
-                "msOWSDispatch()" );
+    msSetError(
+        MS_WFSERR,
+        "SERVICE=WFS requested, but WFS support not configured in MapServer.",
+        "msOWSDispatch()");
 #endif
   } else if (EQUAL(ows_request.service, "WCS")) {
 #ifdef USE_WCS_SVR
     status = msWCSDispatch(map, request, &ows_request);
 #else
-    msSetError( MS_WCSERR,
-                "SERVICE=WCS requested, but WCS support not configured in MapServer.",
-                "msOWSDispatch()" );
+    msSetError(
+        MS_WCSERR,
+        "SERVICE=WCS requested, but WCS support not configured in MapServer.",
+        "msOWSDispatch()");
 #endif
   } else if (EQUAL(ows_request.service, "SOS")) {
 #ifdef USE_SOS_SVR
     status = msSOSDispatch(map, request, &ows_request);
 #else
-    msSetError( MS_SOSERR,
-                "SERVICE=SOS requested, but SOS support not configured in MapServer.",
-                "msOWSDispatch()" );
+    msSetError(
+        MS_SOSERR,
+        "SERVICE=SOS requested, but SOS support not configured in MapServer.",
+        "msOWSDispatch()");
 #endif
-  } else if(force_ows_mode) {
-    msSetError( MS_MISCERR,
-                "OWS Common exception: exceptionCode=InvalidParameterValue, locator=SERVICE, ExceptionText=SERVICE parameter value invalid.",
-                "msOWSDispatch()");
+  } else if (force_ows_mode) {
+    msSetError(
+        MS_MISCERR,
+        "OWS Common exception: exceptionCode=InvalidParameterValue, "
+        "locator=SERVICE, ExceptionText=SERVICE parameter value invalid.",
+        "msOWSDispatch()");
     status = MS_FAILURE;
   }
 
@@ -346,13 +343,12 @@ int msOWSDispatch(mapObj *map, cgiReques
 **
 ** Returns the parsed of the IP (4 or 16).
 */
-int msOWSIpParse(const char* ip, unsigned char* ip1, unsigned char* mask)
-{
+int msOWSIpParse(const char *ip, unsigned char *ip1, unsigned char *mask) {
   int len = 0, masklen, seps;
-  
-  if (msCountChars((char*)ip, '.') == 3) {
+
+  if (msCountChars((char *)ip, '.') == 3) {
     /* ipv4 */
-    unsigned char* val = ip1;
+    unsigned char *val = ip1;
     len = 1;
     masklen = 32;
     *val = 0;
@@ -363,15 +359,12 @@ int msOWSIpParse(const char* ip, unsigne
         ++val;
         *val = 0;
         ++len;
-      }
-      else if (*ip == '/')
-      {
-        masklen = atoi(ip+1);
+      } else if (*ip == '/') {
+        masklen = atoi(ip + 1);
         if (masklen > 32)
           masklen = 32;
         break;
-      }
-      else 
+      } else
         break;
       ++ip;
     }
@@ -385,18 +378,16 @@ int msOWSIpParse(const char* ip, unsigne
         if (masklen >= 8) {
           *val = 0xff;
           masklen -= 8;
-        }
-        else {
-          *val = - ((unsigned char)pow(2, 8 - masklen));
+        } else {
+          *val = -((unsigned char)pow(2, 8 - masklen));
           break;
         }
         ++val;
       }
     }
-  }
-  else if ((seps = msCountChars((char*)ip, ':')) > 1 && seps < 8) {
+  } else if ((seps = msCountChars((char *)ip, ':')) > 1 && seps < 8) {
     /* ipv6 */
-    unsigned short* val = (unsigned short*)ip1;
+    unsigned short *val = (unsigned short *)ip1;
     len = 2;
     masklen = 128;
     *val = 0;
@@ -420,18 +411,14 @@ int msOWSIpParse(const char* ip, unsigne
             *val = 0;
             ++seps;
           }
-        }
-        else
+        } else
           continue;
-      }
-      else if (*ip == '/')
-      {
-        masklen = atoi(ip+1);
+      } else if (*ip == '/') {
+        masklen = atoi(ip + 1);
         if (masklen > 128)
           masklen = 128;
         break;
-      }
-      else
+      } else
         break;
       ++ip;
     }
@@ -440,14 +427,13 @@ int msOWSIpParse(const char* ip, unsigne
     /* write mask */
     if (mask) {
       memset(mask, 0, len);
-      val = (unsigned short*)mask;
+      val = (unsigned short *)mask;
       while (masklen) {
         if (masklen >= 16) {
           *val = 0xffff;
           masklen -= 16;
-        }
-        else {
-          *val = - ((unsigned short)pow(2, 16 - masklen));
+        } else {
+          *val = -((unsigned short)pow(2, 16 - masklen));
           break;
         }
         ++val;
@@ -467,24 +453,23 @@ int msOWSIpParse(const char* ip, unsigne
 **
 ** Returns MS_TRUE if the IP is found.
 */
-int msOWSIpInList(const char *ip_list, const char* ip)
-{
+int msOWSIpInList(const char *ip_list, const char *ip) {
   int i, j, numips, iplen;
   unsigned char ip1[16];
   unsigned char ip2[16];
   unsigned char mask[16];
-  char** ips;
+  char **ips;
 
   /* Parse input IP */
-  iplen = msOWSIpParse(ip, (unsigned char*)&ip1, NULL);
+  iplen = msOWSIpParse(ip, (unsigned char *)&ip1, NULL);
   if (iplen != 4 && iplen != 16) /* ipv4 or ipv6 */
     return MS_FALSE;
 
   ips = msStringSplit(ip_list, ' ', &numips);
   if (ips) {
     for (i = 0; i < numips; i++) {
-      if (msOWSIpParse(ips[i], (unsigned char*)&ip2, (unsigned char*)&mask) == iplen)
-      {
+      if (msOWSIpParse(ips[i], (unsigned char *)&ip2, (unsigned char *)&mask) ==
+          iplen) {
         for (j = 0; j < iplen; j++) {
           if ((ip1[j] & mask[j]) != (ip2[j] & mask[j]))
             break;
@@ -508,29 +493,27 @@ int msOWSIpInList(const char *ip_list, c
 **
 ** Returns MS_TRUE if the IP is found.
 */
-int msOWSIpInMetadata(const char *ip_list, const char* ip)
-{
+int msOWSIpInMetadata(const char *ip_list, const char *ip) {
   FILE *stream;
   char buffer[MS_BUFFER_LENGTH];
   int found = MS_FALSE;
-  
+
   if (strncasecmp(ip_list, "file:", 5) == 0) {
     stream = fopen(ip_list + 5, "r");
-    if(stream) {
+    if (stream) {
       found = MS_FALSE;
-      while(fgets(buffer, MS_BUFFER_LENGTH, stream)) {
-        if(msOWSIpInList(buffer, ip)) {
+      while (fgets(buffer, MS_BUFFER_LENGTH, stream)) {
+        if (msOWSIpInList(buffer, ip)) {
           found = MS_TRUE;
           break;
         }
       }
       fclose(stream);
-    }  
-  }
-  else {
-    if(msOWSIpInList(ip_list, ip))
+    }
+  } else {
+    if (msOWSIpInList(ip_list, ip))
       found = MS_TRUE;
-  }  
+  }
   return found;
 }
 
@@ -546,8 +529,8 @@ int msOWSIpInMetadata(const char *ip_lis
 **
 ** Returns the disabled flag.
 */
-int msOWSIpDisabled(hashTableObj *metadata, const char *namespaces, const char* ip)
-{
+int msOWSIpDisabled(hashTableObj *metadata, const char *namespaces,
+                    const char *ip) {
   const char *ip_list;
   int disabled = MS_FALSE;
 
@@ -583,10 +566,10 @@ int msOWSIpDisabled(hashTableObj *metada
 ** the order they should be looked up. e.g. "MO" to lookup wms_ and ows_ If
 ** namespaces is NULL then this function just does a regular metadata
 ** lookup. If check_all_layers is set to MS_TRUE, the function will check
-** all layers to see if the request is enable. (returns as soon as one is found) */
-int msOWSRequestIsEnabled(mapObj *map, layerObj *layer,
-                          const char *namespaces, const char *request, int check_all_layers)
-{
+** all layers to see if the request is enable. (returns as soon as one is found)
+*/
+int msOWSRequestIsEnabled(mapObj *map, layerObj *layer, const char *namespaces,
+                          const char *request, int check_all_layers) {
   int disabled = MS_FALSE; /* explicitly disabled flag */
   const char *enable_request;
   const char *remote_ip;
@@ -598,15 +581,19 @@ int msOWSRequestIsEnabled(mapObj *map, l
 
   /* First, we check in the layer metadata */
   if (layer && check_all_layers == MS_FALSE) {
-    enable_request = msOWSLookupMetadata(&layer->metadata, namespaces, "enable_request");
+    enable_request =
+        msOWSLookupMetadata(&layer->metadata, namespaces, "enable_request");
     if (msOWSParseRequestMetadata(enable_request, request, &disabled))
       return MS_TRUE;
-    if (disabled) return MS_FALSE;
+    if (disabled)
+      return MS_FALSE;
 
-    enable_request = msOWSLookupMetadata(&layer->metadata, "O", "enable_request");
+    enable_request =
+        msOWSLookupMetadata(&layer->metadata, "O", "enable_request");
     if (msOWSParseRequestMetadata(enable_request, request, &disabled))
       return MS_TRUE;
-    if (disabled) return MS_FALSE;
+    if (disabled)
+      return MS_FALSE;
 
     if (msOWSIpDisabled(&layer->metadata, namespaces, remote_ip))
       return MS_FALSE;
@@ -614,15 +601,19 @@ int msOWSRequestIsEnabled(mapObj *map, l
 
   if (map && (check_all_layers == MS_FALSE || map->numlayers == 0)) {
     /* then we check in the map metadata */
-    enable_request = msOWSLookupMetadata(&map->web.metadata, namespaces, "enable_request");
+    enable_request =
+        msOWSLookupMetadata(&map->web.metadata, namespaces, "enable_request");
     if (msOWSParseRequestMetadata(enable_request, request, &disabled))
       return MS_TRUE;
-    if (disabled) return MS_FALSE;
+    if (disabled)
+      return MS_FALSE;
 
-    enable_request = msOWSLookupMetadata(&map->web.metadata, "O", "enable_request");
+    enable_request =
+        msOWSLookupMetadata(&map->web.metadata, "O", "enable_request");
     if (msOWSParseRequestMetadata(enable_request, request, &disabled))
       return MS_TRUE;
-    if (disabled) return MS_FALSE;
+    if (disabled)
+      return MS_FALSE;
 
     if (msOWSIpDisabled(&map->web.metadata, namespaces, remote_ip))
       return MS_FALSE;
@@ -630,33 +621,44 @@ int msOWSRequestIsEnabled(mapObj *map, l
 
   if (map && check_all_layers == MS_TRUE) {
     int i, globally_enabled = MS_FALSE;
-    enable_request = msOWSLookupMetadata(&map->web.metadata, namespaces, "enable_request");
-    globally_enabled = msOWSParseRequestMetadata(enable_request, request, &disabled);
+    enable_request =
+        msOWSLookupMetadata(&map->web.metadata, namespaces, "enable_request");
+    globally_enabled =
+        msOWSParseRequestMetadata(enable_request, request, &disabled);
 
     if (!globally_enabled && !disabled) {
-      enable_request = msOWSLookupMetadata(&map->web.metadata, "O", "enable_request");
-      globally_enabled = msOWSParseRequestMetadata(enable_request, request, &disabled);
+      enable_request =
+          msOWSLookupMetadata(&map->web.metadata, "O", "enable_request");
+      globally_enabled =
+          msOWSParseRequestMetadata(enable_request, request, &disabled);
     }
 
-    if (globally_enabled && msOWSIpDisabled(&map->web.metadata, namespaces, remote_ip))
+    if (globally_enabled &&
+        msOWSIpDisabled(&map->web.metadata, namespaces, remote_ip))
       globally_enabled = MS_FALSE;
 
     /* Check all layers */
-    for(i=0; i<map->numlayers; i++) {
+    for (i = 0; i < map->numlayers; i++) {
       int result = MS_FALSE;
       layerObj *lp;
       lp = (GET_LAYER(map, i));
 
-      enable_request = msOWSLookupMetadata(&lp->metadata, namespaces, "enable_request");
+      enable_request =
+          msOWSLookupMetadata(&lp->metadata, namespaces, "enable_request");
       result = msOWSParseRequestMetadata(enable_request, request, &disabled);
-      if (!result && disabled) continue; /* if the request has been explicitly set to disabled, continue */
+      if (!result && disabled)
+        continue; /* if the request has been explicitly set to disabled,
+                     continue */
 
-      if (!result && !disabled) { /* if the request has not been found in the wms metadata, */
+      if (!result && !disabled) { /* if the request has not been found in the
+                                     wms metadata, */
         /* check the ows namespace  */
 
-        enable_request = msOWSLookupMetadata(&lp->metadata, "O", "enable_request");
+        enable_request =
+            msOWSLookupMetadata(&lp->metadata, "O", "enable_request");
         result = msOWSParseRequestMetadata(enable_request, request, &disabled);
-        if (!result && disabled) continue;
+        if (!result && disabled)
+          continue;
       }
 
       if (msOWSIpDisabled(&lp->metadata, namespaces, remote_ip))
@@ -667,7 +669,7 @@ int msOWSRequestIsEnabled(mapObj *map, l
     }
 
     if (!disabled && globally_enabled)
-        return MS_TRUE;
+      return MS_TRUE;
   }
 
   return MS_FALSE;
@@ -686,8 +688,8 @@ int msOWSRequestIsEnabled(mapObj *map, l
 ** Generates an array of the layer ids enabled.
 */
 void msOWSRequestLayersEnabled(mapObj *map, const char *namespaces,
-                               const char *request, owsRequestObj *ows_request)
-{
+                               const char *request,
+                               owsRequestObj *ows_request) {
   int disabled = MS_FALSE; /* explicitly disabled flag */
   int globally_enabled = MS_FALSE;
   const char *enable_request;
@@ -704,41 +706,54 @@ void msOWSRequestLayersEnabled(mapObj *m
 
   remote_ip = getenv("REMOTE_ADDR");
 
-  enable_request = msOWSLookupMetadata(&map->web.metadata, namespaces, "enable_request");
-  globally_enabled = msOWSParseRequestMetadata(enable_request, request, &disabled);
+  enable_request =
+      msOWSLookupMetadata(&map->web.metadata, namespaces, "enable_request");
+  globally_enabled =
+      msOWSParseRequestMetadata(enable_request, request, &disabled);
 
   if (!globally_enabled && !disabled) {
-    enable_request = msOWSLookupMetadata(&map->web.metadata, "O", "enable_request");
-    globally_enabled = msOWSParseRequestMetadata(enable_request, request, &disabled);
+    enable_request =
+        msOWSLookupMetadata(&map->web.metadata, "O", "enable_request");
+    globally_enabled =
+        msOWSParseRequestMetadata(enable_request, request, &disabled);
   }
 
-  if (globally_enabled && msOWSIpDisabled(&map->web.metadata, namespaces, remote_ip))
-      globally_enabled = MS_FALSE;
+  if (globally_enabled &&
+      msOWSIpDisabled(&map->web.metadata, namespaces, remote_ip))
+    globally_enabled = MS_FALSE;
 
   if (map->numlayers) {
-    int i, layers_size = map->numlayers; /* for most of cases, this will be relatively small */
+    int i, layers_size = map->numlayers; /* for most of cases, this will be
+                                            relatively small */
 
-    ows_request->enabled_layers = (int*)msSmallMalloc(sizeof(int)*layers_size);
+    ows_request->enabled_layers =
+        (int *)msSmallMalloc(sizeof(int) * layers_size);
 
-    for(i=0; i<map->numlayers; i++) {
+    for (i = 0; i < map->numlayers; i++) {
       int result = MS_FALSE;
       layerObj *lp;
       lp = (GET_LAYER(map, i));
 
-      enable_request = msOWSLookupMetadata(&lp->metadata, namespaces, "enable_request");
+      enable_request =
+          msOWSLookupMetadata(&lp->metadata, namespaces, "enable_request");
       result = msOWSParseRequestMetadata(enable_request, request, &disabled);
-      if (!result && disabled) continue; /* if the request has been explicitly set to disabled, continue */
+      if (!result && disabled)
+        continue; /* if the request has been explicitly set to disabled,
+                     continue */
 
-      if (!result && !disabled) { /* if the request has not been found in the wms metadata, */
+      if (!result && !disabled) { /* if the request has not been found in the
+                                     wms metadata, */
         /* check the ows namespace  */
 
-        enable_request = msOWSLookupMetadata(&lp->metadata, "O", "enable_request");
+        enable_request =
+            msOWSLookupMetadata(&lp->metadata, "O", "enable_request");
         result = msOWSParseRequestMetadata(enable_request, request, &disabled);
-        if (!result && disabled) continue;
+        if (!result && disabled)
+          continue;
       }
 
       if (msOWSIpDisabled(&lp->metadata, namespaces, remote_ip))
-          continue;
+        continue;
 
       if (result || (!disabled && globally_enabled)) {
         ows_request->enabled_layers[ows_request->numlayers] = lp->index;
@@ -758,8 +773,8 @@ void msOWSRequestLayersEnabled(mapObj *m
  * This function parse a enable_request metadata string and check if the
  * given request is present and enabled.
  */
-int msOWSParseRequestMetadata(const char *metadata, const char *request, int *disabled)
-{
+int msOWSParseRequestMetadata(const char *metadata, const char *request,
+                              int *disabled) {
   char requestBuffer[32];
   int wordFlag = MS_FALSE;
   int disableFlag = MS_FALSE;
@@ -771,12 +786,12 @@ int msOWSParseRequestMetadata(const char
   if (metadata == NULL)
     return MS_FALSE;
 
-  ptr = (char*)metadata;
+  ptr = (char *)metadata;
   const size_t len = strlen(ptr);
   requestBuffer[0] = '\0';
   bufferPtr = requestBuffer;
 
-  for (size_t i=0; i<=len; ++i,++ptr) {
+  for (size_t i = 0; i <= len; ++i, ++ptr) {
 
     if (!wordFlag && isspace(*ptr))
       continue;
@@ -786,7 +801,8 @@ int msOWSParseRequestMetadata(const char
     if (*ptr == '!') {
       disableFlag = MS_TRUE;
       continue;
-    } else if ( (*ptr == ' ') || (*ptr != '\0' && ptr[1] == '\0')) { /* end of word */
+    } else if ((*ptr == ' ') ||
+               (*ptr != '\0' && ptr[1] == '\0')) { /* end of word */
       if (ptr[1] == '\0' && *ptr != ' ') {
         *bufferPtr = *ptr;
         ++bufferPtr;
@@ -794,13 +810,15 @@ int msOWSParseRequestMetadata(const char
 
       *bufferPtr = '\0';
       if (strcasecmp(request, requestBuffer) == 0) {
-        *disabled =  MS_TRUE; /* explicitly found, will stop the process in msOWSRequestIsEnabled() */
-        return (disableFlag ? MS_FALSE:MS_TRUE);
+        *disabled = MS_TRUE; /* explicitly found, will stop the process in
+                                msOWSRequestIsEnabled() */
+        return (disableFlag ? MS_FALSE : MS_TRUE);
       } else {
-        if (strcmp("*", requestBuffer) == 0) { /* check if we read the all flag */
+        if (strcmp("*", requestBuffer) ==
+            0) { /* check if we read the all flag */
           if (disableFlag)
-            *disabled =  MS_TRUE;
-          allFlag = disableFlag ? MS_FALSE:MS_TRUE;
+            *disabled = MS_TRUE;
+          allFlag = disableFlag ? MS_FALSE : MS_TRUE;
         }
         /* reset flags */
         wordFlag = MS_FALSE;
@@ -822,29 +840,32 @@ int msOWSParseRequestMetadata(const char
 ** Return the metadata name prefix from a character identifying the OWS
 ** namespace.
 */
-static
-const char* msOWSGetPrefixFromNamespace(char chNamespace)
-{
-    // Return should be a 3 character string, otherwise breaks assumption
-    // in msOWSLookupMetadata()
-    switch( chNamespace )
-    {
-        case 'O': return "ows";
-        case 'A': return "oga"; /* oga_... (OGC Geospatial API) */
-        case 'M': return "wms";
-        case 'F': return "wfs";
-        case 'C': return "wcs";
-        case 'G': return "gml";
-        case 'S': return "sos";
-        default:
-          /* We should never get here unless an invalid code (typo) is */
-          /* present in the code, but since this happened before... */
-          msSetError(MS_WMSERR,
-                     "Unsupported metadata namespace code (%c).",
-                     "msOWSGetPrefixFromNamespace()", chNamespace );
-          assert(MS_FALSE);
-          return NULL;
-    }
+static const char *msOWSGetPrefixFromNamespace(char chNamespace) {
+  // Return should be a 3 character string, otherwise breaks assumption
+  // in msOWSLookupMetadata()
+  switch (chNamespace) {
+  case 'O':
+    return "ows";
+  case 'A':
+    return "oga"; /* oga_... (OGC Geospatial API) */
+  case 'M':
+    return "wms";
+  case 'F':
+    return "wfs";
+  case 'C':
+    return "wcs";
+  case 'G':
+    return "gml";
+  case 'S':
+    return "sos";
+  default:
+    /* We should never get here unless an invalid code (typo) is */
+    /* present in the code, but since this happened before... */
+    msSetError(MS_WMSERR, "Unsupported metadata namespace code (%c).",
+               "msOWSGetPrefixFromNamespace()", chNamespace);
+    assert(MS_FALSE);
+    return NULL;
+  }
 }
 
 /*
@@ -857,22 +878,21 @@ const char* msOWSGetPrefixFromNamespace(
 ** If namespaces is NULL then this function just does a regular metadata
 ** lookup.
 */
-const char *msOWSLookupMetadata(hashTableObj *metadata,
-                                const char *namespaces, const char *name)
-{
+const char *msOWSLookupMetadata(hashTableObj *metadata, const char *namespaces,
+                                const char *name) {
   const char *value = NULL;
 
   if (namespaces == NULL) {
-    value = msLookupHashTable(metadata, (char*)name);
+    value = msLookupHashTable(metadata, (char *)name);
   } else {
     char buf[100] = "ows_";
 
-    strlcpy(buf+4, name, 96);
+    strlcpy(buf + 4, name, 96);
 
     while (value == NULL && *namespaces != '\0') {
-      const char* prefix = msOWSGetPrefixFromNamespace(*namespaces);
-      if( prefix == NULL )
-          return NULL;
+      const char *prefix = msOWSGetPrefixFromNamespace(*namespaces);
+      if (prefix == NULL)
+        return NULL;
       assert(strlen(prefix) == 3);
       memcpy(buf, prefix, 3);
       value = msLookupHashTable(metadata, buf);
@@ -883,7 +903,6 @@ const char *msOWSLookupMetadata(hashTabl
   return value;
 }
 
-
 /*
 ** msOWSLookupMetadataWithLanguage()
 **
@@ -891,23 +910,23 @@ const char *msOWSLookupMetadata(hashTabl
 ** for a specific language.
 */
 const char *msOWSLookupMetadataWithLanguage(hashTableObj *metadata,
-    const char *namespaces, const char *name, const char* validated_language)
-{
+                                            const char *namespaces,
+                                            const char *name,
+                                            const char *validated_language) {
   const char *value = NULL;
 
-  if ( name && validated_language && validated_language[0] ) {
-    size_t bufferSize = strlen(name)+strlen(validated_language)+2;
-    char *name2 = (char *) msSmallMalloc( bufferSize );
+  if (name && validated_language && validated_language[0]) {
+    size_t bufferSize = strlen(name) + strlen(validated_language) + 2;
+    char *name2 = (char *)msSmallMalloc(bufferSize);
     snprintf(name2, bufferSize, "%s.%s", name, validated_language);
     value = msOWSLookupMetadata(metadata, namespaces, name2);
     free(name2);
   }
 
-  if ( name && !value ) {
+  if (name && !value) {
     value = msOWSLookupMetadata(metadata, namespaces, name);
   }
 
-
   return value;
 }
 
@@ -924,11 +943,8 @@ const char *msOWSLookupMetadataWithLangu
 ** If namespaces is NULL then this function just does a regular metadata
 ** lookup.
 */
-const char *msOWSLookupMetadata2(hashTableObj *pri,
-                                 hashTableObj *sec,
-                                 const char *namespaces,
-                                 const char *name)
-{
+const char *msOWSLookupMetadata2(hashTableObj *pri, hashTableObj *sec,
+                                 const char *namespaces, const char *name) {
   const char *result;
 
   if ((result = msOWSLookupMetadata(pri, namespaces, name)) == NULL) {
@@ -939,7 +955,6 @@ const char *msOWSLookupMetadata2(hashTab
   return result;
 }
 
-
 /* msOWSParseVersionString()
 **
 ** Parse a version string in the format "a.b.c" or "a.b" and return an
@@ -948,8 +963,7 @@ const char *msOWSLookupMetadata2(hashTab
 ** Returns one of OWS_VERSION_NOTSET or OWS_VERSION_BADFORMAT if version
 ** could not be parsed.
 */
-int msOWSParseVersionString(const char *pszVersion)
-{
+int msOWSParseVersionString(const char *pszVersion) {
   char **digits = NULL;
   int numDigits = 0;
 
@@ -966,8 +980,8 @@ int msOWSParseVersionString(const char *
       return OWS_VERSION_BADFORMAT;
     }
 
-    nVersion = atoi(digits[0])*0x010000;
-    nVersion += atoi(digits[1])*0x0100;
+    nVersion = atoi(digits[0]) * 0x010000;
+    nVersion += atoi(digits[1]) * 0x0100;
     if (numDigits > 2)
       nVersion += atoi(digits[2]);
 
@@ -987,17 +1001,16 @@ int msOWSParseVersionString(const char *
 ** Fills in the pszBuffer and returns a reference to it. Recommended buffer
 ** size is OWS_VERSION_MAXLEN chars.
 */
-const char *msOWSGetVersionString(int nVersion, char *pszBuffer)
-{
+const char *msOWSGetVersionString(int nVersion, char *pszBuffer) {
 
   if (pszBuffer)
-    snprintf(pszBuffer, OWS_VERSION_MAXLEN-1, "%d.%d.%d",
-             (nVersion/0x10000)%0x100, (nVersion/0x100)%0x100, nVersion%0x100);
+    snprintf(pszBuffer, OWS_VERSION_MAXLEN - 1, "%d.%d.%d",
+             (nVersion / 0x10000) % 0x100, (nVersion / 0x100) % 0x100,
+             nVersion % 0x100);
 
   return pszBuffer;
 }
 
-
 /*
 ** msOWSGetEPSGProj()
 **
@@ -1010,34 +1023,41 @@ const char *msOWSGetVersionString(int nV
 ** then only the first one (which is assumed to be the layer's default
 ** projection) is returned.
 */
-void msOWSGetEPSGProj(projectionObj *proj, hashTableObj *metadata, const char *namespaces, int bReturnOnlyFirstOne, char **epsgCode)
-{
+void msOWSGetEPSGProj(projectionObj *proj, hashTableObj *metadata,
+                      const char *namespaces, int bReturnOnlyFirstOne,
+                      char **epsgCode) {
   const char *value;
   *epsgCode = NULL;
 
   /* metadata value should already be in format "EPSG:n" or "AUTO:..." */
-  if (metadata && ((value = msOWSLookupMetadata(metadata, namespaces, "srs")) != NULL)) {
+  if (metadata &&
+      ((value = msOWSLookupMetadata(metadata, namespaces, "srs")) != NULL)) {
     const char *space_ptr;
-    if (!bReturnOnlyFirstOne || (space_ptr = strchr(value,' ')) == NULL) {
+    if (!bReturnOnlyFirstOne || (space_ptr = strchr(value, ' ')) == NULL) {
       *epsgCode = msStrdup(value);
       return;
     }
-    
 
-    *epsgCode = msSmallMalloc((space_ptr - value + 1)*sizeof(char));
-    /* caller requested only first projection code, copy up to the first space character*/
-    strlcpy(*epsgCode, value, space_ptr - value + 1) ;
+    *epsgCode = msSmallMalloc((space_ptr - value + 1) * sizeof(char));
+    /* caller requested only first projection code, copy up to the first space
+     * character*/
+    strlcpy(*epsgCode, value, space_ptr - value + 1);
     return;
-  } else if (proj && proj->numargs > 0 && (value = strstr(proj->args[0], "init=epsg:")) != NULL) {
-    *epsgCode = msSmallMalloc((strlen("EPSG:")+strlen(value+10)+1)*sizeof(char));
-    sprintf(*epsgCode, "EPSG:%s", value+10);
+  } else if (proj && proj->numargs > 0 &&
+             (value = strstr(proj->args[0], "init=epsg:")) != NULL) {
+    *epsgCode = msSmallMalloc((strlen("EPSG:") + strlen(value + 10) + 1) *
+                              sizeof(char));
+    sprintf(*epsgCode, "EPSG:%s", value + 10);
     return;
-  } else if (proj && proj->numargs > 0 && (value = strstr(proj->args[0], "init=crs:")) != NULL) {
-    *epsgCode = msSmallMalloc((strlen("CRS:")+strlen(value+9)+1)*sizeof(char));
-    sprintf(*epsgCode, "CRS:%s", value+9);
+  } else if (proj && proj->numargs > 0 &&
+             (value = strstr(proj->args[0], "init=crs:")) != NULL) {
+    *epsgCode =
+        msSmallMalloc((strlen("CRS:") + strlen(value + 9) + 1) * sizeof(char));
+    sprintf(*epsgCode, "CRS:%s", value + 9);
     return;
-  } else if (proj && proj->numargs > 0 && (strncasecmp(proj->args[0], "AUTO:", 5) == 0 ||
-             strncasecmp(proj->args[0], "AUTO2:", 6) == 0)) {
+  } else if (proj && proj->numargs > 0 &&
+             (strncasecmp(proj->args[0], "AUTO:", 5) == 0 ||
+              strncasecmp(proj->args[0], "AUTO2:", 6) == 0)) {
     *epsgCode = msStrdup(proj->args[0]);
     return;
   }
@@ -1049,8 +1069,7 @@ void msOWSGetEPSGProj(projectionObj *pro
 ** Reprojects the extent to WGS84.
 **
 */
-void msOWSProjectToWGS84(projectionObj *srcproj, rectObj *ext)
-{
+void msOWSProjectToWGS84(projectionObj *srcproj, rectObj *ext) {
   if (srcproj->proj && !msProjIsGeographicCRS(srcproj)) {
     projectionObj wgs84;
     msInitProjection(&wgs84);
@@ -1068,14 +1087,13 @@ void msOWSProjectToWGS84(projectionObj *
 ** Use value of "ows_language" metadata, if not set then
 ** return "undefined" as a default
 */
-const char *msOWSGetLanguage(mapObj *map, const char *context)
-{
+const char *msOWSGetLanguage(mapObj *map, const char *context) {
   const char *language;
 
   /* if this is an exception, MapServer always returns Exception
      messages in en-US
   */
-  if (strcmp(context,"exception") == 0) {
+  if (strcmp(context, "exception") == 0) {
     language = MS_ERROR_LANGUAGE;
   }
   /* if not, fetch language from mapfile metadata */
@@ -1098,12 +1116,11 @@ const char *msOWSGetLanguage(mapObj *map
 ** Use value of "ows_schemas_location" metadata, if not set then
 ** return ".." as a default
 */
-const char *msOWSGetSchemasLocation(mapObj *map)
-{
+const char *msOWSGetSchemasLocation(mapObj *map) {
   const char *schemas_location;
 
-  schemas_location = msLookupHashTable(&(map->web.metadata),
-                                       "ows_schemas_location");
+  schemas_location =
+      msLookupHashTable(&(map->web.metadata), "ows_schemas_location");
   if (schemas_location == NULL)
     schemas_location = OWS_DEFAULT_SCHEMAS_LOCATION;
 
@@ -1113,19 +1130,18 @@ const char *msOWSGetSchemasLocation(mapO
 /*
 ** msOWSGetExpandedMetadataKey()
 */
-static
-char* msOWSGetExpandedMetadataKey(const char *namespaces, const char *metadata_name)
-{
-  char* pszRet = msStringConcatenate(NULL, "");
-  for( int i = 0; namespaces[i] != '\0'; ++i )
-  {
-      if( i > 0 )
-          pszRet = msStringConcatenate(pszRet, " or ");
-      pszRet = msStringConcatenate(pszRet, "\"");
-      pszRet = msStringConcatenate(pszRet, msOWSGetPrefixFromNamespace(namespaces[i]));
-      pszRet = msStringConcatenate(pszRet, "_");
-      pszRet = msStringConcatenate(pszRet, metadata_name);
-      pszRet = msStringConcatenate(pszRet, "\"");
+static char *msOWSGetExpandedMetadataKey(const char *namespaces,
+                                         const char *metadata_name) {
+  char *pszRet = msStringConcatenate(NULL, "");
+  for (int i = 0; namespaces[i] != '\0'; ++i) {
+    if (i > 0)
+      pszRet = msStringConcatenate(pszRet, " or ");
+    pszRet = msStringConcatenate(pszRet, "\"");
+    pszRet =
+        msStringConcatenate(pszRet, msOWSGetPrefixFromNamespace(namespaces[i]));
+    pszRet = msStringConcatenate(pszRet, "_");
+    pszRet = msStringConcatenate(pszRet, metadata_name);
+    pszRet = msStringConcatenate(pszRet, "\"");
   }
   return pszRet;
 }
@@ -1139,9 +1155,8 @@ char* msOWSGetExpandedMetadataKey(const
 ** Returns a newly allocated string that should be freed by the caller or
 ** NULL in case of error.
 */
-char * msOWSGetOnlineResource(mapObj *map, const char *namespaces, const char *metadata_name,
-                              cgiRequestObj *req)
-{
+char *msOWSGetOnlineResource(mapObj *map, const char *namespaces,
+                             const char *metadata_name, cgiRequestObj *req) {
   const char *value;
   char *online_resource = NULL;
 
@@ -1150,12 +1165,15 @@ char * msOWSGetOnlineResource(mapObj *ma
   /* set then build it: "http://$(SERVER_NAME):$(SERVER_PORT)$(SCRIPT_NAME)?" */
   /* (+append the map=... param if it was explicitly passed in QUERY_STRING) */
   /*  */
-  if ((value = msOWSLookupMetadata(&(map->web.metadata), namespaces, metadata_name))) {
+  if ((value = msOWSLookupMetadata(&(map->web.metadata), namespaces,
+                                   metadata_name))) {
     online_resource = msOWSTerminateOnlineResource(value);
   } else {
     if ((online_resource = msBuildOnlineResource(map, req)) == NULL) {
-      char* pszExpandedMetadataKey = msOWSGetExpandedMetadataKey(namespaces, metadata_name);
-      msSetError(MS_CGIERR, "Please set %s metadata.", "msOWSGetOnlineResource()", pszExpandedMetadataKey);
+      char *pszExpandedMetadataKey =
+          msOWSGetExpandedMetadataKey(namespaces, metadata_name);
+      msSetError(MS_CGIERR, "Please set %s metadata.",
+                 "msOWSGetOnlineResource()", pszExpandedMetadataKey);
       msFree(pszExpandedMetadataKey);
       return NULL;
     }
@@ -1174,16 +1192,15 @@ char * msOWSGetOnlineResource(mapObj *ma
 ** Returns a newly allocated string that should be freed by the caller or
 ** NULL in case of error.
 */
-char * msOWSTerminateOnlineResource(const char *src_url)
-{
+char *msOWSTerminateOnlineResource(const char *src_url) {
   char *online_resource = NULL;
   size_t buffer_size = 0;
 
   if (src_url == NULL)
     return NULL;
 
-  buffer_size = strlen(src_url)+2;
-  online_resource = (char*) malloc(buffer_size);
+  buffer_size = strlen(src_url) + 2;
+  online_resource = (char *)malloc(buffer_size);
 
   if (online_resource == NULL) {
     msSetError(MS_MEMERR, NULL, "msOWSTerminateOnlineResource()");
@@ -1197,9 +1214,9 @@ char * msOWSTerminateOnlineResource(cons
     strlcat(online_resource, "?", buffer_size);
   else {
     char *c;
-    c = online_resource+strlen(online_resource)-1;
+    c = online_resource + strlen(online_resource) - 1;
     if (*c != '?' && *c != '&')
-      strlcpy(c+1, "&", buffer_size-strlen(online_resource));
+      strlcpy(c + 1, "&", buffer_size - strlen(online_resource));
   }
 
   return online_resource;
@@ -1212,43 +1229,43 @@ char * msOWSTerminateOnlineResource(cons
 /*      been set. Nullable is not implemented for all drivers           */
 /*      and can be set to 0 if unknown                                  */
 /************************************************************************/
-int msUpdateGMLFieldMetadata(layerObj *layer, const char *field_name, const char *gml_type,
-                             const char *gml_width, const char *gml_precision, const short nullable)
-{
+int msUpdateGMLFieldMetadata(layerObj *layer, const char *field_name,
+                             const char *gml_type, const char *gml_width,
+                             const char *gml_precision, const short nullable) {
 
-    char md_item_name[256];
+  char md_item_name[256];
 
-    snprintf( md_item_name, sizeof(md_item_name), "gml_%s_type", field_name );
-    if( msLookupHashTable(&(layer->metadata), md_item_name) == NULL )
-    msInsertHashTable(&(layer->metadata), md_item_name, gml_type );
-
-    snprintf( md_item_name, sizeof(md_item_name), "gml_%s_width", field_name );
-    if( strlen(gml_width) > 0
-        && msLookupHashTable(&(layer->metadata), md_item_name) == NULL )
-    msInsertHashTable(&(layer->metadata), md_item_name, gml_width );
-
-    snprintf( md_item_name, sizeof(md_item_name), "gml_%s_precision", field_name );
-    if( strlen(gml_precision) > 0
-        && msLookupHashTable(&(layer->metadata), md_item_name) == NULL )
-    msInsertHashTable(&(layer->metadata), md_item_name, gml_precision );
-
-    snprintf( md_item_name, sizeof(md_item_name), "gml_%s_nillable", field_name );
-    if( nullable > 0 
-        && msLookupHashTable(&(layer->metadata), md_item_name) == NULL )
-    msInsertHashTable(&(layer->metadata), md_item_name, "true" );
+  snprintf(md_item_name, sizeof(md_item_name), "gml_%s_type", field_name);
+  if (msLookupHashTable(&(layer->metadata), md_item_name) == NULL)
+    msInsertHashTable(&(layer->metadata), md_item_name, gml_type);
 
-    return MS_TRUE;
+  snprintf(md_item_name, sizeof(md_item_name), "gml_%s_width", field_name);
+  if (strlen(gml_width) > 0 &&
+      msLookupHashTable(&(layer->metadata), md_item_name) == NULL)
+    msInsertHashTable(&(layer->metadata), md_item_name, gml_width);
+
+  snprintf(md_item_name, sizeof(md_item_name), "gml_%s_precision", field_name);
+  if (strlen(gml_precision) > 0 &&
+      msLookupHashTable(&(layer->metadata), md_item_name) == NULL)
+    msInsertHashTable(&(layer->metadata), md_item_name, gml_precision);
+
+  snprintf(md_item_name, sizeof(md_item_name), "gml_%s_nillable", field_name);
+  if (nullable > 0 &&
+      msLookupHashTable(&(layer->metadata), md_item_name) == NULL)
+    msInsertHashTable(&(layer->metadata), md_item_name, "true");
+
+  return MS_TRUE;
 }
 
-#if defined(USE_WMS_SVR) || defined (USE_WFS_SVR) || defined (USE_WCS_SVR) || defined(USE_SOS_SVR) || defined(USE_WMS_LYR) || defined(USE_WFS_LYR)
+#if defined(USE_WMS_SVR) || defined(USE_WFS_SVR) || defined(USE_WCS_SVR) ||    \
+    defined(USE_SOS_SVR) || defined(USE_WMS_LYR) || defined(USE_WFS_LYR)
 
 /*
 ** msRenameLayer()
 */
-static int msRenameLayer(layerObj *lp, int count)
-{
+static int msRenameLayer(layerObj *lp, int count) {
   char *newname;
-  newname = (char*)malloc((strlen(lp->name)+5)*sizeof(char));
+  newname = (char *)malloc((strlen(lp->name) + 5) * sizeof(char));
   if (!newname) {
     msSetError(MS_MEMERR, NULL, "msRenameLayer()");
     return MS_FAILURE;
@@ -1263,14 +1280,13 @@ static int msRenameLayer(layerObj *lp, i
 /*
 ** msOWSMakeAllLayersUnique()
 */
-int msOWSMakeAllLayersUnique(mapObj *map)
-{
+int msOWSMakeAllLayersUnique(mapObj *map) {
   int i, j;
 
   /* Make sure all layers in the map file have valid and unique names */
-  for(i=0; i<map->numlayers; i++) {
-    int count=1;
-    for(j=i+1; j<map->numlayers; j++) {
+  for (i = 0; i < map->numlayers; i++) {
+    int count = 1;
+    for (j = i + 1; j < map->numlayers; j++) {
       if (GET_LAYER(map, i)->name == NULL || GET_LAYER(map, j)->name == NULL) {
         continue;
       }
@@ -1300,19 +1316,21 @@ int msOWSMakeAllLayersUnique(mapObj *map
 **
 */
 
-int msOWSNegotiateVersion(int requested_version, const int supported_versions[], int num_supported_versions)
-{
+int msOWSNegotiateVersion(int requested_version, const int supported_versions[],
+                          int num_supported_versions) {
   int i;
 
   /* if version is not set return highest version */
-  if (! requested_version)
+  if (!requested_version)
     return supported_versions[0];
 
-  /* if the requested version is lower than the lowest version return the lowest version  */
-  if (requested_version < supported_versions[num_supported_versions-1])
-    return supported_versions[num_supported_versions-1];
+  /* if the requested version is lower than the lowest version return the lowest
+   * version  */
+  if (requested_version < supported_versions[num_supported_versions - 1])
+    return supported_versions[num_supported_versions - 1];
 
-  /* return the first entry that's lower than or equal to the requested version */
+  /* return the first entry that's lower than or equal to the requested version
+   */
   for (i = 0; i < num_supported_versions; i++) {
     if (supported_versions[i] <= requested_version)
       return supported_versions[i];
@@ -1329,15 +1347,20 @@ int msOWSNegotiateVersion(int requested_
 ** Returns a newly allocated string that should be freed by the caller or
 ** NULL in case of error.
 */
-char * msOWSGetOnlineResource2(mapObj *map, const char *namespaces, const char *metadata_name,
-                               cgiRequestObj *req, const char* validated_language)
-{
-  char *online_resource = msOWSGetOnlineResource(map, namespaces, metadata_name, req);
+char *msOWSGetOnlineResource2(mapObj *map, const char *namespaces,
+                              const char *metadata_name, cgiRequestObj *req,
+                              const char *validated_language) {
+  char *online_resource =
+      msOWSGetOnlineResource(map, namespaces, metadata_name, req);
 
-  if ( online_resource && validated_language && validated_language[0] ) {
-    /* online_resource is already terminated, so we can simply add language=...& */
-    /* but first we need to make sure that online_resource has enough capacity */
-    online_resource = (char *)msSmallRealloc(online_resource, strlen(online_resource) + strlen(validated_language) +  11);
+  if (online_resource && validated_language && validated_language[0]) {
+    /* online_resource is already terminated, so we can simply add language=...&
+     */
+    /* but first we need to make sure that online_resource has enough capacity
+     */
+    online_resource = (char *)msSmallRealloc(
+        online_resource,
+        strlen(online_resource) + strlen(validated_language) + 11);
     strcat(online_resource, "language=");
     strcat(online_resource, validated_language);
     strcat(online_resource, "&");
@@ -1354,12 +1377,11 @@ char * msOWSGetOnlineResource2(mapObj *m
 **
 ** Use value of "inspire_schemas_location" metadata
 */
-const char *msOWSGetInspireSchemasLocation(mapObj *map)
-{
+const char *msOWSGetInspireSchemasLocation(mapObj *map) {
   const char *schemas_location;
 
-  schemas_location = msLookupHashTable(&(map->web.metadata),
-                                       "inspire_schemas_location");
+  schemas_location =
+      msLookupHashTable(&(map->web.metadata), "inspire_schemas_location");
   if (schemas_location == NULL)
     schemas_location = "http://inspire.ec.europa.eu/schemas";
 
@@ -1375,12 +1397,13 @@ const char *msOWSGetInspireSchemasLocati
 ** Returns a malloced char** of length numitems which must be freed
 ** by the caller, or NULL (with numitems = 0)
 */
-char **msOWSGetLanguageList(mapObj *map, const char *namespaces, int *numitems)
-{
+char **msOWSGetLanguageList(mapObj *map, const char *namespaces,
+                            int *numitems) {
 
   const char *languages = NULL;
 
-  languages = msOWSLookupMetadata(&(map->web.metadata), namespaces, "languages");
+  languages =
+      msOWSLookupMetadata(&(map->web.metadata), namespaces, "languages");
   if (languages && strlen(languages) > 0) {
     return msStringSplit(languages, ',', numitems);
   } else {
@@ -1401,14 +1424,15 @@ char **msOWSGetLanguageList(mapObj *map,
 **
 ** Returns a malloced char* which must be freed by the caller, or NULL
 */
-char *msOWSGetLanguageFromList(mapObj *map, const char *namespaces, const char *requested_language)
-{
+char *msOWSGetLanguageFromList(mapObj *map, const char *namespaces,
+                               const char *requested_language) {
   int num_items = 0;
   char **languages = msOWSGetLanguageList(map, namespaces, &num_items);
   char *language = NULL;
 
-  if( languages && num_items > 0 ) {
-    if ( !requested_language || !msStringInArray( requested_language, languages, num_items) ) {
+  if (languages && num_items > 0) {
+    if (!requested_language ||
+        !msStringInArray(requested_language, languages, num_items)) {
       language = msStrdup(languages[0]);
     } else {
       language = msStrdup(requested_language);
@@ -1419,15 +1443,16 @@ char *msOWSGetLanguageFromList(mapObj *m
   return language;
 }
 
-
 /* msOWSLanguageNegotiation
 **
-** Returns a language according to the accepted languages requested by the client
+** Returns a language according to the accepted languages requested by the
+*client
 **
 ** Returns a malloced char* which must be freed by the caller, or NULL
 */
-char *msOWSLanguageNegotiation(mapObj *map, const char *namespaces, char **accept_languages, int num_accept_languages)
-{
+char *msOWSLanguageNegotiation(mapObj *map, const char *namespaces,
+                               char **accept_languages,
+                               int num_accept_languages) {
   int num_languages = 0;
   char **languages = NULL;
   char *result_language = NULL;
@@ -1458,7 +1483,6 @@ char *msOWSLanguageNegotiation(mapObj *m
   return result_language;
 }
 
-
 /* msOWSPrintInspireCommonExtendedCapabilities
 **
 ** Output INSPIRE common extended capabilities items to stream
@@ -1472,21 +1496,23 @@ char *msOWSLanguageNegotiation(mapObj *m
 **
 ** Returns a status code; MS_NOERR if all ok, action_if_not_found otherwise
 */
-int msOWSPrintInspireCommonExtendedCapabilities(FILE *stream, mapObj *map, const char *namespaces,
-    int action_if_not_found, const char *tag_name, const char* tag_ns,
-    const char *validated_language, const OWSServiceType service)
-{
+int msOWSPrintInspireCommonExtendedCapabilities(
+    FILE *stream, mapObj *map, const char *namespaces, int action_if_not_found,
+    const char *tag_name, const char *tag_ns, const char *validated_language,
+    const OWSServiceType service) {
 
   int metadataStatus = 0;
   int languageStatus = 0;
 
-  if( tag_ns )
+  if (tag_ns)
     msIO_fprintf(stream, "  <%s %s>\n", tag_name, tag_ns);
   else
     msIO_fprintf(stream, "  <%s>\n", tag_name);
 
-  metadataStatus = msOWSPrintInspireCommonMetadata(stream, map, namespaces, action_if_not_found, service);
-  languageStatus = msOWSPrintInspireCommonLanguages(stream, map, namespaces, action_if_not_found, validated_language);
+  metadataStatus = msOWSPrintInspireCommonMetadata(
+      stream, map, namespaces, action_if_not_found, service);
+  languageStatus = msOWSPrintInspireCommonLanguages(
+      stream, map, namespaces, action_if_not_found, validated_language);
 
   msIO_fprintf(stream, "  </%s>\n", tag_name);
 
@@ -1499,60 +1525,126 @@ int msOWSPrintInspireCommonExtendedCapab
 **
 ** Returns a status code; MS_NOERR if all OK, action_if_not_found otherwise
 */
-int msOWSPrintInspireCommonMetadata(FILE *stream, mapObj *map, const char *namespaces,
-                                    int action_if_not_found, const OWSServiceType service)
-{
+int msOWSPrintInspireCommonMetadata(FILE *stream, mapObj *map,
+                                    const char *namespaces,
+                                    int action_if_not_found,
+                                    const OWSServiceType service) {
 
   int status = MS_NOERR;
   const char *inspire_capabilities = NULL;
 
-  inspire_capabilities = msOWSLookupMetadata(&(map->web.metadata), namespaces, "inspire_capabilities");
+  inspire_capabilities = msOWSLookupMetadata(&(map->web.metadata), namespaces,
+                                             "inspire_capabilities");
 
-  if(!inspire_capabilities) {
+  if (!inspire_capabilities) {
     if (OWS_WARN == action_if_not_found) {
-      msIO_fprintf(stream, "<!-- WARNING: missing metadata entry for 'inspire_capabilities', one of 'embed' and 'url' must be supplied. -->\n");
+      msIO_fprintf(
+          stream,
+          "<!-- WARNING: missing metadata entry for 'inspire_capabilities', "
+          "one of 'embed' and 'url' must be supplied. -->\n");
     }
     return action_if_not_found;
   }
-  if (strcasecmp("url",inspire_capabilities) == 0) {
-    if ( msOWSLookupMetadata(&(map->web.metadata), namespaces, "inspire_metadataurl_href") != NULL ) {
-      msIO_fprintf(stream, "    <inspire_common:MetadataUrl xsi:type=\"inspire_common:resourceLocatorType\">\n");
-      msOWSPrintEncodeMetadata(stream, &(map->web.metadata), namespaces, "inspire_metadataurl_href", OWS_WARN, "      <inspire_common:URL>%s</inspire_common:URL>\n", "");
-      msOWSPrintEncodeMetadata(stream, &(map->web.metadata), namespaces, "inspire_metadataurl_format", OWS_WARN, "      <inspire_common:MediaType>%s</inspire_common:MediaType>\n", "");
+  if (strcasecmp("url", inspire_capabilities) == 0) {
+    if (msOWSLookupMetadata(&(map->web.metadata), namespaces,
+                            "inspire_metadataurl_href") != NULL) {
+      msIO_fprintf(stream,
+                   "    <inspire_common:MetadataUrl "
+                   "xsi:type=\"inspire_common:resourceLocatorType\">\n");
+      msOWSPrintEncodeMetadata(
+          stream, &(map->web.metadata), namespaces, "inspire_metadataurl_href",
+          OWS_WARN, "      <inspire_common:URL>%s</inspire_common:URL>\n", "");
+      msOWSPrintEncodeMetadata(
+          stream, &(map->web.metadata), namespaces,
+          "inspire_metadataurl_format", OWS_WARN,
+          "      <inspire_common:MediaType>%s</inspire_common:MediaType>\n",
+          "");
       msIO_fprintf(stream, "    </inspire_common:MetadataUrl>\n");
     } else {
       status = action_if_not_found;
       if (OWS_WARN == action_if_not_found) {
-        char* pszExpandedMetadataKey = msOWSGetExpandedMetadataKey(namespaces, "inspire_metadataurl_href");
-        msIO_fprintf(stream, "<!-- WARNING: Mandatory metadata %s was missing in this context. -->\n", pszExpandedMetadataKey);
+        char *pszExpandedMetadataKey =
+            msOWSGetExpandedMetadataKey(namespaces, "inspire_metadataurl_href");
+        msIO_fprintf(stream,
+                     "<!-- WARNING: Mandatory metadata %s was missing in this "
+                     "context. -->\n",
+                     pszExpandedMetadataKey);
         msFree(pszExpandedMetadataKey);
       }
     }
-  } else if (strcasecmp("embed",inspire_capabilities) == 0) {
-    msOWSPrintEncodeMetadata(stream, &(map->web.metadata), namespaces, "inspire_resourcelocator", OWS_WARN, "    <inspire_common:ResourceLocator>\n      <inspire_common:URL>%s</inspire_common:URL>\n    </inspire_common:ResourceLocator>\n", NULL);
-    msIO_fprintf(stream,"    <inspire_common:ResourceType>service</inspire_common:ResourceType>\n");
-    msOWSPrintEncodeMetadata(stream, &(map->web.metadata), namespaces, "inspire_temporal_reference", OWS_WARN, "    <inspire_common:TemporalReference>\n      <inspire_common:DateOfLastRevision>%s</inspire_common:DateOfLastRevision>\n    </inspire_common:TemporalReference>\n", "");
+  } else if (strcasecmp("embed", inspire_capabilities) == 0) {
+    msOWSPrintEncodeMetadata(stream, &(map->web.metadata), namespaces,
+                             "inspire_resourcelocator", OWS_WARN,
+                             "    <inspire_common:ResourceLocator>\n      "
+                             "<inspire_common:URL>%s</inspire_common:URL>\n    "
+                             "</inspire_common:ResourceLocator>\n",
+                             NULL);
+    msIO_fprintf(
+        stream,
+        "    "
+        "<inspire_common:ResourceType>service</inspire_common:ResourceType>\n");
+    msOWSPrintEncodeMetadata(stream, &(map->web.metadata), namespaces,
+                             "inspire_temporal_reference", OWS_WARN,
+                             "    <inspire_common:TemporalReference>\n      "
+                             "<inspire_common:DateOfLastRevision>%s</"
+                             "inspire_common:DateOfLastRevision>\n    "
+                             "</inspire_common:TemporalReference>\n",
+                             "");
     msIO_fprintf(stream, "    <inspire_common:Conformity>\n");
     msIO_fprintf(stream, "      <inspire_common:Specification>\n");
-    msIO_fprintf(stream, "        <inspire_common:Title>-</inspire_common:Title>\n");
-    msOWSPrintEncodeMetadata(stream, &(map->web.metadata), namespaces, "inspire_temporal_reference", OWS_NOERR, "        <inspire_common:DateOfLastRevision>%s</inspire_common:DateOfLastRevision>\n", "");
+    msIO_fprintf(stream,
+                 "        <inspire_common:Title>-</inspire_common:Title>\n");
+    msOWSPrintEncodeMetadata(stream, &(map->web.metadata), namespaces,
+                             "inspire_temporal_reference", OWS_NOERR,
+                             "        "
+                             "<inspire_common:DateOfLastRevision>%s</"
+                             "inspire_common:DateOfLastRevision>\n",
+                             "");
     msIO_fprintf(stream, "      </inspire_common:Specification>\n");
-    msIO_fprintf(stream, "      <inspire_common:Degree>notEvaluated</inspire_common:Degree>\n");
+    msIO_fprintf(
+        stream,
+        "      <inspire_common:Degree>notEvaluated</inspire_common:Degree>\n");
     msIO_fprintf(stream, "    </inspire_common:Conformity>\n");
     msIO_fprintf(stream, "    <inspire_common:MetadataPointOfContact>\n");
-    msOWSPrintEncodeMetadata(stream, &(map->web.metadata), namespaces, "inspire_mpoc_name", OWS_WARN, "      <inspire_common:OrganisationName>%s</inspire_common:OrganisationName>\n", "");
-    msOWSPrintEncodeMetadata(stream, &(map->web.metadata), namespaces, "inspire_mpoc_email", OWS_WARN, "      <inspire_common:EmailAddress>%s</inspire_common:EmailAddress>\n", "");
+    msOWSPrintEncodeMetadata(stream, &(map->web.metadata), namespaces,
+                             "inspire_mpoc_name", OWS_WARN,
+                             "      "
+                             "<inspire_common:OrganisationName>%s</"
+                             "inspire_common:OrganisationName>\n",
+                             "");
+    msOWSPrintEncodeMetadata(
+        stream, &(map->web.metadata), namespaces, "inspire_mpoc_email",
+        OWS_WARN,
+        "      <inspire_common:EmailAddress>%s</inspire_common:EmailAddress>\n",
+        "");
     msIO_fprintf(stream, "    </inspire_common:MetadataPointOfContact>\n");
-    msOWSPrintEncodeMetadata(stream, &(map->web.metadata), namespaces, "inspire_metadatadate", OWS_WARN, "      <inspire_common:MetadataDate>%s</inspire_common:MetadataDate>\n", "");
-    if( service == OWS_WFS || service == OWS_WCS )
-        msIO_fprintf(stream,"    <inspire_common:SpatialDataServiceType>download</inspire_common:SpatialDataServiceType>\n");
+    msOWSPrintEncodeMetadata(
+        stream, &(map->web.metadata), namespaces, "inspire_metadatadate",
+        OWS_WARN,
+        "      <inspire_common:MetadataDate>%s</inspire_common:MetadataDate>\n",
+        "");
+    if (service == OWS_WFS || service == OWS_WCS)
+      msIO_fprintf(stream, "    "
+                           "<inspire_common:SpatialDataServiceType>download</"
+                           "inspire_common:SpatialDataServiceType>\n");
     else
-        msIO_fprintf(stream,"    <inspire_common:SpatialDataServiceType>view</inspire_common:SpatialDataServiceType>\n");
-    msOWSPrintEncodeMetadata(stream, &(map->web.metadata), namespaces, "inspire_keyword", OWS_WARN, "    <inspire_common:MandatoryKeyword>\n      <inspire_common:KeywordValue>%s</inspire_common:KeywordValue>\n    </inspire_common:MandatoryKeyword>\n", "");
+      msIO_fprintf(stream, "    "
+                           "<inspire_common:SpatialDataServiceType>view</"
+                           "inspire_common:SpatialDataServiceType>\n");
+    msOWSPrintEncodeMetadata(
+        stream, &(map->web.metadata), namespaces, "inspire_keyword", OWS_WARN,
+        "    <inspire_common:MandatoryKeyword>\n      "
+        "<inspire_common:KeywordValue>%s</inspire_common:KeywordValue>\n    "
+        "</inspire_common:MandatoryKeyword>\n",
+        "");
   } else {
     status = action_if_not_found;
     if (OWS_WARN == action_if_not_found) {
-      msIO_fprintf(stream, "<!-- WARNING: invalid value '%s' for 'inspire_capabilities', only 'embed' and 'url' are supported. -->\n", inspire_capabilities);
+      msIO_fprintf(
+          stream,
+          "<!-- WARNING: invalid value '%s' for 'inspire_capabilities', only "
+          "'embed' and 'url' are supported. -->\n",
+          inspire_capabilities);
     }
   }
 
@@ -1565,36 +1657,50 @@ int msOWSPrintInspireCommonMetadata(FILE
 **
 ** Returns a status code; MS_NOERR if all OK; action_if_not_found otherwise
 */
-int msOWSPrintInspireCommonLanguages(FILE *stream, mapObj *map, const char *namespaces,
-                                     int action_if_not_found, const char *validated_language)
-{
-  char *buffer = NULL; /* temp variable for malloced strings that will need freeing */
+int msOWSPrintInspireCommonLanguages(FILE *stream, mapObj *map,
+                                     const char *namespaces,
+                                     int action_if_not_found,
+                                     const char *validated_language) {
+  char *buffer =
+      NULL; /* temp variable for malloced strings that will need freeing */
   int status = MS_NOERR;
 
   char *default_language = msOWSGetLanguageFromList(map, namespaces, NULL);
 
-  if(validated_language && validated_language[0] && default_language) {
+  if (validated_language && validated_language[0] && default_language) {
     msIO_fprintf(stream, "    <inspire_common:SupportedLanguages>\n");
-    msIO_fprintf(stream, "      <inspire_common:DefaultLanguage><inspire_common:Language>%s"
-                 "</inspire_common:Language></inspire_common:DefaultLanguage>\n",
-                 buffer = msEncodeHTMLEntities(default_language));
+    msIO_fprintf(
+        stream,
+        "      <inspire_common:DefaultLanguage><inspire_common:Language>%s"
+        "</inspire_common:Language></inspire_common:DefaultLanguage>\n",
+        buffer = msEncodeHTMLEntities(default_language));
     msFree(buffer);
-    
-    /* append _exclude to our default_language*/
-    default_language = msSmallRealloc(default_language,strlen(default_language)+strlen("_exclude")+1);
-    strcat(default_language,"_exclude");
 
-    msOWSPrintEncodeMetadataList(stream, &(map->web.metadata), namespaces, "languages", NULL, NULL,
-                                 "      <inspire_common:SupportedLanguage><inspire_common:Language>%s"
-                                 "</inspire_common:Language></inspire_common:SupportedLanguage>\n", default_language);
+    /* append _exclude to our default_language*/
+    default_language = msSmallRealloc(
+        default_language, strlen(default_language) + strlen("_exclude") + 1);
+    strcat(default_language, "_exclude");
+
+    msOWSPrintEncodeMetadataList(
+        stream, &(map->web.metadata), namespaces, "languages", NULL, NULL,
+        "      <inspire_common:SupportedLanguage><inspire_common:Language>%s"
+        "</inspire_common:Language></inspire_common:SupportedLanguage>\n",
+        default_language);
     msIO_fprintf(stream, "    </inspire_common:SupportedLanguages>\n");
-    msIO_fprintf(stream, "    <inspire_common:ResponseLanguage><inspire_common:Language>%s"
-                 "</inspire_common:Language></inspire_common:ResponseLanguage>\n", validated_language);
+    msIO_fprintf(
+        stream,
+        "    <inspire_common:ResponseLanguage><inspire_common:Language>%s"
+        "</inspire_common:Language></inspire_common:ResponseLanguage>\n",
+        validated_language);
   } else {
     status = action_if_not_found;
     if (OWS_WARN == action_if_not_found) {
-      char* pszExpandedMetadataKey = msOWSGetExpandedMetadataKey(namespaces, "languages");
-      msIO_fprintf(stream, "<!-- WARNING: Mandatory metadata %s was missing in this context. -->\n", pszExpandedMetadataKey);
+      char *pszExpandedMetadataKey =
+          msOWSGetExpandedMetadataKey(namespaces, "languages");
+      msIO_fprintf(stream,
+                   "<!-- WARNING: Mandatory metadata %s was missing in this "
+                   "context. -->\n",
+                   pszExpandedMetadataKey);
       msFree(pszExpandedMetadataKey);
     }
   }
@@ -1616,17 +1722,20 @@ int msOWSPrintInspireCommonLanguages(FIL
 int msOWSPrintMetadata(FILE *stream, hashTableObj *metadata,
                        const char *namespaces, const char *name,
                        int action_if_not_found, const char *format,
-                       const char *default_value)
-{
+                       const char *default_value) {
   const char *value = NULL;
   int status = MS_NOERR;
 
-  if((value = msOWSLookupMetadata(metadata, namespaces, name)) != NULL) {
+  if ((value = msOWSLookupMetadata(metadata, namespaces, name)) != NULL) {
     msIO_fprintf(stream, format, value);
   } else {
     if (action_if_not_found == OWS_WARN) {
-      char* pszExpandedMetadataKey = msOWSGetExpandedMetadataKey(namespaces, name);
-      msIO_fprintf(stream, "<!-- WARNING: Mandatory metadata %s was missing in this context. -->\n", pszExpandedMetadataKey);
+      char *pszExpandedMetadataKey =
+          msOWSGetExpandedMetadataKey(namespaces, name);
+      msIO_fprintf(stream,
+                   "<!-- WARNING: Mandatory metadata %s was missing in this "
+                   "context. -->\n",
+                   pszExpandedMetadataKey);
       msFree(pszExpandedMetadataKey);
       status = action_if_not_found;
     }
@@ -1638,7 +1747,6 @@ int msOWSPrintMetadata(FILE *stream, has
   return status;
 }
 
-
 /*
 ** msOWSPrintEncodeMetadata()
 **
@@ -1651,13 +1759,13 @@ int msOWSPrintMetadata(FILE *stream, has
 
 int msOWSPrintEncodeMetadata(FILE *stream, hashTableObj *metadata,
                              const char *namespaces, const char *name,
-                             int action_if_not_found,
-                             const char *format, const char *default_value)
-{
-  return msOWSPrintEncodeMetadata2(stream, metadata, namespaces, name, action_if_not_found, format, default_value, NULL);
+                             int action_if_not_found, const char *format,
+                             const char *default_value) {
+  return msOWSPrintEncodeMetadata2(stream, metadata, namespaces, name,
+                                   action_if_not_found, format, default_value,
+                                   NULL);
 }
 
-
 /*
 ** msOWSPrintEncodeMetadata2()
 **
@@ -1666,28 +1774,32 @@ int msOWSPrintEncodeMetadata(FILE *strea
 */
 int msOWSPrintEncodeMetadata2(FILE *stream, hashTableObj *metadata,
                               const char *namespaces, const char *name,
-                              int action_if_not_found,
-                              const char *format, const char *default_value,
-                              const char *validated_language)
-{
+                              int action_if_not_found, const char *format,
+                              const char *default_value,
+                              const char *validated_language) {
   const char *value;
-  char * pszEncodedValue=NULL;
+  char *pszEncodedValue = NULL;
   int status = MS_NOERR;
 
-  if((value = msOWSLookupMetadataWithLanguage(metadata, namespaces, name, validated_language))) {
+  if ((value = msOWSLookupMetadataWithLanguage(metadata, namespaces, name,
+                                               validated_language))) {
     pszEncodedValue = msEncodeHTMLEntities(value);
     msIO_fprintf(stream, format, pszEncodedValue);
     free(pszEncodedValue);
   } else {
     if (action_if_not_found == OWS_WARN) {
-      char* pszExpandedName = msStringConcatenate(NULL, name);
-      if( validated_language && validated_language[0] )
-      {
-          pszExpandedName = msStringConcatenate(pszExpandedName, ".");
-          pszExpandedName = msStringConcatenate(pszExpandedName, validated_language);
-      }
-      char* pszExpandedMetadataKey = msOWSGetExpandedMetadataKey(namespaces, pszExpandedName);
-      msIO_fprintf(stream, "<!-- WARNING: Mandatory metadata %s was missing in this context. -->\n", pszExpandedMetadataKey);
+      char *pszExpandedName = msStringConcatenate(NULL, name);
+      if (validated_language && validated_language[0]) {
+        pszExpandedName = msStringConcatenate(pszExpandedName, ".");
+        pszExpandedName =
+            msStringConcatenate(pszExpandedName, validated_language);
+      }
+      char *pszExpandedMetadataKey =
+          msOWSGetExpandedMetadataKey(namespaces, pszExpandedName);
+      msIO_fprintf(stream,
+                   "<!-- WARNING: Mandatory metadata %s was missing in this "
+                   "context. -->\n",
+                   pszExpandedMetadataKey);
       msFree(pszExpandedName);
       msFree(pszExpandedMetadataKey);
       status = action_if_not_found;
@@ -1703,7 +1815,6 @@ int msOWSPrintEncodeMetadata2(FILE *stre
   return status;
 }
 
-
 /*
 ** msOWSGetEncodeMetadata()
 **
@@ -1711,13 +1822,11 @@ int msOWSPrintEncodeMetadata2(FILE *stre
 ** metadata or the default value.
 ** Caller should free the returned string.
 */
-char *msOWSGetEncodeMetadata(hashTableObj *metadata,
-                             const char *namespaces, const char *name,
-                             const char *default_value)
-{
+char *msOWSGetEncodeMetadata(hashTableObj *metadata, const char *namespaces,
+                             const char *name, const char *default_value) {
   const char *value;
-  char * pszEncodedValue=NULL;
-  if((value = msOWSLookupMetadata(metadata, namespaces, name)))
+  char *pszEncodedValue = NULL;
+  if ((value = msOWSLookupMetadata(metadata, namespaces, name)))
     pszEncodedValue = msEncodeHTMLEntities(value);
   else if (default_value)
     pszEncodedValue = msEncodeHTMLEntities(default_value);
@@ -1725,7 +1834,6 @@ char *msOWSGetEncodeMetadata(hashTableOb
   return pszEncodedValue;
 }
 
-
 /*
 ** msOWSPrintValidateMetadata()
 **
@@ -1738,29 +1846,36 @@ char *msOWSGetEncodeMetadata(hashTableOb
 
 int msOWSPrintValidateMetadata(FILE *stream, hashTableObj *metadata,
                                const char *namespaces, const char *name,
-                               int action_if_not_found,
-                               const char *format, const char *default_value)
-{
+                               int action_if_not_found, const char *format,
+                               const char *default_value) {
   const char *value;
   int status = MS_NOERR;
 
-  if((value = msOWSLookupMetadata(metadata, namespaces, name))) {
-    if(msIsXMLTagValid(value) == MS_FALSE)
-      msIO_fprintf(stream, "<!-- WARNING: The value '%s' is not valid in a "
-                   "XML tag context. -->\n", value);
+  if ((value = msOWSLookupMetadata(metadata, namespaces, name))) {
+    if (msIsXMLTagValid(value) == MS_FALSE)
+      msIO_fprintf(stream,
+                   "<!-- WARNING: The value '%s' is not valid in a "
+                   "XML tag context. -->\n",
+                   value);
     msIO_fprintf(stream, format, value);
   } else {
     if (action_if_not_found == OWS_WARN) {
-      char* pszExpandedMetadataKey = msOWSGetExpandedMetadataKey(namespaces, name);
-      msIO_fprintf(stream, "<!-- WARNING: Mandatory metadata %s was missing in this context. -->\n", pszExpandedMetadataKey);
+      char *pszExpandedMetadataKey =
+          msOWSGetExpandedMetadataKey(namespaces, name);
+      msIO_fprintf(stream,
+                   "<!-- WARNING: Mandatory metadata %s was missing in this "
+                   "context. -->\n",
+                   pszExpandedMetadataKey);
       msFree(pszExpandedMetadataKey);
       status = action_if_not_found;
     }
 
     if (default_value) {
-      if(msIsXMLTagValid(default_value) == MS_FALSE)
-        msIO_fprintf(stream, "<!-- WARNING: The value '%s' is not valid "
-                     "in a XML tag context. -->\n", default_value);
+      if (msIsXMLTagValid(default_value) == MS_FALSE)
+        msIO_fprintf(stream,
+                     "<!-- WARNING: The value '%s' is not valid "
+                     "in a XML tag context. -->\n",
+                     default_value);
       msIO_fprintf(stream, format, default_value);
     }
   }
@@ -1776,12 +1891,13 @@ int msOWSPrintValidateMetadata(FILE *str
 ** If a default value is provided and metadata is absent then the
 ** default will be used.
 */
-int msOWSPrintGroupMetadata(FILE *stream, mapObj *map, char* pszGroupName,
+int msOWSPrintGroupMetadata(FILE *stream, mapObj *map, char *pszGroupName,
                             const char *namespaces, const char *name,
-                            int action_if_not_found,
-                            const char *format, const char *default_value)
-{
-  return msOWSPrintGroupMetadata2(stream, map, pszGroupName, namespaces, name, action_if_not_found, format, default_value, NULL);
+                            int action_if_not_found, const char *format,
+                            const char *default_value) {
+  return msOWSPrintGroupMetadata2(stream, map, pszGroupName, namespaces, name,
+                                  action_if_not_found, format, default_value,
+                                  NULL);
 }
 
 /*
@@ -1790,20 +1906,23 @@ int msOWSPrintGroupMetadata(FILE *stream
 ** Attempt to output a capability item in the requested language.
 ** Fallback using no language parameter.
 */
-int msOWSPrintGroupMetadata2(FILE *stream, mapObj *map, char* pszGroupName,
+int msOWSPrintGroupMetadata2(FILE *stream, mapObj *map, char *pszGroupName,
                              const char *namespaces, const char *name,
-                             int action_if_not_found,
-                             const char *format, const char *default_value,
-                             const char *validated_language)
-{
+                             int action_if_not_found, const char *format,
+                             const char *default_value,
+                             const char *validated_language) {
   const char *value;
   char *encoded;
   int status = MS_NOERR;
   int i;
 
-  for (i=0; i<map->numlayers; i++) {
-    if (GET_LAYER(map, i)->group && (strcmp(GET_LAYER(map, i)->group, pszGroupName) == 0) && &(GET_LAYER(map, i)->metadata)) {
-      if((value = msOWSLookupMetadataWithLanguage(&(GET_LAYER(map, i)->metadata), namespaces, name, validated_language))) {
+  for (i = 0; i < map->numlayers; i++) {
+    if (GET_LAYER(map, i)->group &&
+        (strcmp(GET_LAYER(map, i)->group, pszGroupName) == 0) &&
+        &(GET_LAYER(map, i)->metadata)) {
+      if ((value = msOWSLookupMetadataWithLanguage(
+               &(GET_LAYER(map, i)->metadata), namespaces, name,
+               validated_language))) {
         encoded = msEncodeHTMLEntities(value);
         msIO_fprintf(stream, format, encoded);
         msFree(encoded);
@@ -1813,8 +1932,12 @@ int msOWSPrintGroupMetadata2(FILE *strea
   }
 
   if (action_if_not_found == OWS_WARN) {
-    char* pszExpandedMetadataKey = msOWSGetExpandedMetadataKey(namespaces, name);
-    msIO_fprintf(stream, "<!-- WARNING: Mandatory metadata %s was missing in this context. -->\n", pszExpandedMetadataKey);
+    char *pszExpandedMetadataKey =
+        msOWSGetExpandedMetadataKey(namespaces, name);
+    msIO_fprintf(stream,
+                 "<!-- WARNING: Mandatory metadata %s was missing in this "
+                 "context. -->\n",
+                 pszExpandedMetadataKey);
     msFree(pszExpandedMetadataKey);
     status = action_if_not_found;
   }
@@ -1872,77 +1995,79 @@ int msOWSPrintURLType(FILE *stream, hash
                       int href_is_mandatory, const char *default_type,
                       const char *default_width, const char *default_height,
                       const char *default_urlfrmt, const char *default_href,
-                      const char *tabspace)
-{
+                      const char *tabspace) {
   const char *value;
   char *metadata_name;
   char *encoded;
   int status = MS_NOERR;
-  char *type=NULL, *width=NULL, *height=NULL, *urlfrmt=NULL, *href=NULL;
+  char *type = NULL, *width = NULL, *height = NULL, *urlfrmt = NULL,
+       *href = NULL;
 
-  const size_t buffer_size = strlen(name)+10;
-  metadata_name = (char*)malloc(buffer_size);
+  const size_t buffer_size = strlen(name) + 10;
+  metadata_name = (char *)malloc(buffer_size);
 
   /* Get type */
-  if(type_format != NULL) {
+  if (type_format != NULL) {
     snprintf(metadata_name, buffer_size, "%s_type", name);
     value = msOWSLookupMetadata(metadata, namespaces, metadata_name);
-    if(value != NULL) {
+    if (value != NULL) {
       encoded = msEncodeHTMLEntities(value);
-      const size_t buffer_size_tmp = strlen(type_format)+strlen(encoded)+1;
-      type = (char*)malloc(buffer_size_tmp);
+      const size_t buffer_size_tmp = strlen(type_format) + strlen(encoded) + 1;
+      type = (char *)malloc(buffer_size_tmp);
       snprintf(type, buffer_size_tmp, type_format, encoded);
       msFree(encoded);
     }
   }
 
   /* Get width */
-  if(width_format != NULL) {
+  if (width_format != NULL) {
     snprintf(metadata_name, buffer_size, "%s_width", name);
     value = msOWSLookupMetadata(metadata, namespaces, metadata_name);
-    if(value != NULL) {
+    if (value != NULL) {
       encoded = msEncodeHTMLEntities(value);
-      const size_t buffer_size_tmp = strlen(width_format)+strlen(encoded)+1;
-      width = (char*)malloc(buffer_size_tmp);
+      const size_t buffer_size_tmp = strlen(width_format) + strlen(encoded) + 1;
+      width = (char *)malloc(buffer_size_tmp);
       snprintf(width, buffer_size_tmp, width_format, encoded);
       msFree(encoded);
     }
   }
 
   /* Get height */
-  if(height_format != NULL) {
+  if (height_format != NULL) {
     snprintf(metadata_name, buffer_size, "%s_height", name);
     value = msOWSLookupMetadata(metadata, namespaces, metadata_name);
-    if(value != NULL) {
+    if (value != NULL) {
       encoded = msEncodeHTMLEntities(value);
-      const size_t buffer_size_tmp = strlen(height_format)+strlen(encoded)+1;
-      height = (char*)malloc(buffer_size_tmp);
+      const size_t buffer_size_tmp =
+          strlen(height_format) + strlen(encoded) + 1;
+      height = (char *)malloc(buffer_size_tmp);
       snprintf(height, buffer_size_tmp, height_format, encoded);
       msFree(encoded);
     }
   }
 
   /* Get format */
-  if(urlfrmt_format != NULL) {
+  if (urlfrmt_format != NULL) {
     snprintf(metadata_name, buffer_size, "%s_format", name);
     value = msOWSLookupMetadata(metadata, namespaces, metadata_name);
-    if(value != NULL) {
+    if (value != NULL) {
       encoded = msEncodeHTMLEntities(value);
-      const size_t buffer_size_tmp = strlen(urlfrmt_format)+strlen(encoded)+1;
-      urlfrmt = (char*)malloc(buffer_size_tmp);
+      const size_t buffer_size_tmp =
+          strlen(urlfrmt_format) + strlen(encoded) + 1;
+      urlfrmt = (char *)malloc(buffer_size_tmp);
       snprintf(urlfrmt, buffer_size_tmp, urlfrmt_format, encoded);
       msFree(encoded);
     }
   }
 
   /* Get href */
-  if(href_format != NULL) {
+  if (href_format != NULL) {
     snprintf(metadata_name, buffer_size, "%s_href", name);
     value = msOWSLookupMetadata(metadata, namespaces, metadata_name);
-    if(value != NULL) {
+    if (value != NULL) {
       encoded = msEncodeHTMLEntities(value);
-      const size_t buffer_size_tmp = strlen(href_format)+strlen(encoded)+1;
-      href = (char*)malloc(buffer_size_tmp);
+      const size_t buffer_size_tmp = strlen(href_format) + strlen(encoded) + 1;
+      href = (char *)malloc(buffer_size_tmp);
       snprintf(href, buffer_size_tmp, href_format, encoded);
       msFree(encoded);
     }
@@ -1950,58 +2075,68 @@ int msOWSPrintURLType(FILE *stream, hash
 
   msFree(metadata_name);
 
-  if(type || width || height || urlfrmt || href ||
+  if (type || width || height || urlfrmt || href ||
       (!metadata && (default_type || default_width || default_height ||
                      default_urlfrmt || default_href))) {
-    if((!type && type_is_mandatory) || (!width && width_is_mandatory) ||
-        (!height && height_is_mandatory) ||
-        (!urlfrmt && format_is_mandatory) || (!href && href_is_mandatory)) {
-      msIO_fprintf(stream, "<!-- WARNING: Some mandatory elements for '%s' are missing in this context. -->\n", tag_name);
+    if ((!type && type_is_mandatory) || (!width && width_is_mandatory) ||
+        (!height && height_is_mandatory) || (!urlfrmt && format_is_mandatory) ||
+        (!href && href_is_mandatory)) {
+      msIO_fprintf(stream,
+                   "<!-- WARNING: Some mandatory elements for '%s' are missing "
+                   "in this context. -->\n",
+                   tag_name);
       if (action_if_not_found == OWS_WARN) {
-        char* pszExpandedMetadataKey = msOWSGetExpandedMetadataKey(namespaces, name);
-        msIO_fprintf(stream, "<!-- WARNING: Mandatory metadata %s was missing in this context. -->\n", pszExpandedMetadataKey);
+        char *pszExpandedMetadataKey =
+            msOWSGetExpandedMetadataKey(namespaces, name);
+        msIO_fprintf(stream,
+                     "<!-- WARNING: Mandatory metadata %s was missing in this "
+                     "context. -->\n",
+                     pszExpandedMetadataKey);
         msFree(pszExpandedMetadataKey);
         status = action_if_not_found;
       }
     } else {
-      if(!type && type_format && default_type) {
-        const size_t buffer_size_tmp = strlen(type_format) + strlen(default_type) + 2;
-        type = (char*) malloc(buffer_size_tmp);
+      if (!type && type_format && default_type) {
+        const size_t buffer_size_tmp =
+            strlen(type_format) + strlen(default_type) + 2;
+        type = (char *)malloc(buffer_size_tmp);
         snprintf(type, buffer_size_tmp, type_format, default_type);
-      } else if(!type)
+      } else if (!type)
         type = msStrdup("");
-      if(!width && width_format && default_width) {
-        const size_t buffer_size_tmp = strlen(width_format) + strlen(default_width) + 2;
-        width = (char*) malloc(buffer_size_tmp);
+      if (!width && width_format && default_width) {
+        const size_t buffer_size_tmp =
+            strlen(width_format) + strlen(default_width) + 2;
+        width = (char *)malloc(buffer_size_tmp);
         snprintf(width, buffer_size_tmp, width_format, default_width);
-      } else if(!width)
+      } else if (!width)
         width = msStrdup("");
-      if(!height && height_format && default_height) {
-        const size_t buffer_size_tmp =  strlen(height_format) + strlen(default_height) + 2;
-        height = (char*) malloc(buffer_size_tmp);
+      if (!height && height_format && default_height) {
+        const size_t buffer_size_tmp =
+            strlen(height_format) + strlen(default_height) + 2;
+        height = (char *)malloc(buffer_size_tmp);
         snprintf(height, buffer_size_tmp, height_format, default_height);
-      } else if(!height)
+      } else if (!height)
         height = msStrdup("");
-      if(!urlfrmt && urlfrmt_format && default_urlfrmt) {
-        const size_t buffer_size_tmp = strlen(urlfrmt_format) + strlen(default_urlfrmt) + 2;
-        urlfrmt = (char*) malloc(buffer_size_tmp);
+      if (!urlfrmt && urlfrmt_format && default_urlfrmt) {
+        const size_t buffer_size_tmp =
+            strlen(urlfrmt_format) + strlen(default_urlfrmt) + 2;
+        urlfrmt = (char *)malloc(buffer_size_tmp);
         snprintf(urlfrmt, buffer_size_tmp, urlfrmt_format, default_urlfrmt);
-      } else if(!urlfrmt)
+      } else if (!urlfrmt)
         urlfrmt = msStrdup("");
-      if(!href && href_format && default_href) {
-        const size_t buffer_size_tmp = strlen(href_format) + strlen(default_href) + 2;
-        href = (char*) malloc(buffer_size_tmp);
+      if (!href && href_format && default_href) {
+        const size_t buffer_size_tmp =
+            strlen(href_format) + strlen(default_href) + 2;
+        href = (char *)malloc(buffer_size_tmp);
         snprintf(href, buffer_size_tmp, href_format, default_href);
-      } else if(!href)
+      } else if (!href)
         href = msStrdup("");
 
-      if(tag_format == NULL)
-        msIO_fprintf(stream, "%s<%s%s%s%s%s>%s</%s>\n", tabspace,
-                     tag_name, type, width, height, urlfrmt, href,
-                     tag_name);
+      if (tag_format == NULL)
+        msIO_fprintf(stream, "%s<%s%s%s%s%s>%s</%s>\n", tabspace, tag_name,
+                     type, width, height, urlfrmt, href, tag_name);
       else
-        msIO_fprintf(stream, tag_format,
-                     type, width, height, urlfrmt, href);
+        msIO_fprintf(stream, tag_format, type, width, height, urlfrmt, href);
     }
 
     msFree(type);
@@ -2011,8 +2146,12 @@ int msOWSPrintURLType(FILE *stream, hash
     msFree(href);
   } else {
     if (action_if_not_found == OWS_WARN) {
-      char* pszExpandedMetadataKey = msOWSGetExpandedMetadataKey(namespaces, name);
-      msIO_fprintf(stream, "<!-- WARNING: Mandatory metadata %s was missing in this context. -->\n", pszExpandedMetadataKey);
+      char *pszExpandedMetadataKey =
+          msOWSGetExpandedMetadataKey(namespaces, name);
+      msIO_fprintf(stream,
+                   "<!-- WARNING: Mandatory metadata %s was missing in this "
+                   "context. -->\n",
+                   pszExpandedMetadataKey);
       msFree(pszExpandedMetadataKey);
       status = action_if_not_found;
     }
@@ -2027,15 +2166,17 @@ int msOWSPrintURLType(FILE *stream, hash
 **/
 int msOWSPrintParam(FILE *stream, const char *name, const char *value,
                     int action_if_not_found, const char *format,
-                    const char *default_value)
-{
+                    const char *default_value) {
   int status = MS_NOERR;
 
-  if(value && strlen(value) > 0) {
+  if (value && strlen(value) > 0) {
     msIO_fprintf(stream, format, value);
   } else {
     if (action_if_not_found == OWS_WARN) {
-      msIO_fprintf(stream, "<!-- WARNING: Mandatory mapfile parameter '%s' was missing in this context. -->\n", name);
+      msIO_fprintf(stream,
+                   "<!-- WARNING: Mandatory mapfile parameter '%s' was missing "
+                   "in this context. -->\n",
+                   name);
       status = action_if_not_found;
     }
 
@@ -2052,18 +2193,20 @@ int msOWSPrintParam(FILE *stream, const
 **/
 int msOWSPrintEncodeParam(FILE *stream, const char *name, const char *value,
                           int action_if_not_found, const char *format,
-                          const char *default_value)
-{
+                          const char *default_value) {
   int status = MS_NOERR;
   char *encode;
 
-  if(value && strlen(value) > 0) {
+  if (value && strlen(value) > 0) {
     encode = msEncodeHTMLEntities(value);
     msIO_fprintf(stream, format, encode);
     msFree(encode);
   } else {
     if (action_if_not_found == OWS_WARN) {
-      msIO_fprintf(stream, "<!-- WARNING: Mandatory mapfile parameter '%s' was missing in this context. -->\n", name);
+      msIO_fprintf(stream,
+                   "<!-- WARNING: Mandatory mapfile parameter '%s' was missing "
+                   "in this context. -->\n",
+                   name);
       status = action_if_not_found;
     }
 
@@ -2087,36 +2230,38 @@ int msOWSPrintEncodeParam(FILE *stream,
 **/
 int msOWSPrintMetadataList(FILE *stream, hashTableObj *metadata,
                            const char *namespaces, const char *name,
-                           const char *startTag,
-                           const char *endTag, const char *itemFormat,
-                           const char *default_value)
-{
+                           const char *startTag, const char *endTag,
+                           const char *itemFormat, const char *default_value) {
   const char *value;
 
   value = msOWSLookupMetadata(metadata, namespaces, name);
 
-  if(value == NULL) {
+  if (value == NULL) {
     value = default_value;
     default_value = NULL;
   }
 
-  if(value != NULL) {
+  if (value != NULL) {
     char **keywords;
     int numkeywords;
 
     keywords = msStringSplit(value, ',', &numkeywords);
-    if(keywords && numkeywords > 0) {
+    if (keywords && numkeywords > 0) {
       int kw;
-      if(startTag) msIO_fprintf(stream, "%s", startTag);
-      for(kw=0; kw<numkeywords; kw++) {
-        if (default_value != NULL
-            && strncasecmp(keywords[kw],default_value,strlen(keywords[kw])) == 0
-            && strncasecmp("_exclude",default_value+strlen(default_value)-8,8) == 0)
+      if (startTag)
+        msIO_fprintf(stream, "%s", startTag);
+      for (kw = 0; kw < numkeywords; kw++) {
+        if (default_value != NULL &&
+            strncasecmp(keywords[kw], default_value, strlen(keywords[kw])) ==
+                0 &&
+            strncasecmp("_exclude", default_value + strlen(default_value) - 8,
+                        8) == 0)
           continue;
 
         msIO_fprintf(stream, itemFormat, keywords[kw]);
       }
-      if(endTag) msIO_fprintf(stream, "%s", endTag);
+      if (endTag)
+        msIO_fprintf(stream, "%s", endTag);
     }
     msFreeCharArray(keywords, numkeywords);
     return MS_TRUE;
@@ -2135,43 +2280,45 @@ int msOWSPrintMetadataList(FILE *stream,
 **/
 int msOWSPrintEncodeMetadataList(FILE *stream, hashTableObj *metadata,
                                  const char *namespaces, const char *name,
-                                 const char *startTag,
-                                 const char *endTag, const char *itemFormat,
-                                 const char *default_value)
-{
+                                 const char *startTag, const char *endTag,
+                                 const char *itemFormat,
+                                 const char *default_value) {
   const char *value;
   char *encoded;
   size_t default_value_len = 0;
 
   value = msOWSLookupMetadata(metadata, namespaces, name);
 
-  if(value == NULL) {
+  if (value == NULL) {
     value = default_value;
     default_value = NULL;
   }
-  if( default_value )
-      default_value_len = strlen(default_value);
+  if (default_value)
+    default_value_len = strlen(default_value);
 
-  if(value != NULL) {
+  if (value != NULL) {
     char **keywords;
     int numkeywords;
 
     keywords = msStringSplit(value, ',', &numkeywords);
-    if(keywords && numkeywords > 0) {
+    if (keywords && numkeywords > 0) {
       int kw;
-      if(startTag) msIO_fprintf(stream, "%s", startTag);
-      for(kw=0; kw<numkeywords; kw++) {
-        if (default_value != NULL
-            && default_value_len > 8
-            && strncasecmp(keywords[kw],default_value,strlen(keywords[kw])) == 0
-            && strncasecmp("_exclude",default_value+default_value_len-8,8) == 0)
+      if (startTag)
+        msIO_fprintf(stream, "%s", startTag);
+      for (kw = 0; kw < numkeywords; kw++) {
+        if (default_value != NULL && default_value_len > 8 &&
+            strncasecmp(keywords[kw], default_value, strlen(keywords[kw])) ==
+                0 &&
+            strncasecmp("_exclude", default_value + default_value_len - 8, 8) ==
+                0)
           continue;
 
         encoded = msEncodeHTMLEntities(keywords[kw]);
         msIO_fprintf(stream, itemFormat, encoded);
         msFree(encoded);
       }
-      if(endTag) msIO_fprintf(stream, "%s", endTag);
+      if (endTag)
+        msIO_fprintf(stream, "%s", endTag);
     }
     msFreeCharArray(keywords, numkeywords);
     return MS_TRUE;
@@ -2183,22 +2330,23 @@ int msOWSPrintEncodeMetadataList(FILE *s
 **
 ** Same as msOWSPrintEncodeMetadataList() but applied to mapfile parameters.
 **/
-int msOWSPrintEncodeParamList(FILE *stream, const char *name,
-                              const char *value, int action_if_not_found,
-                              char delimiter, const char *startTag,
-                              const char *endTag, const char *format,
-                              const char *default_value)
-{
+int msOWSPrintEncodeParamList(FILE *stream, const char *name, const char *value,
+                              int action_if_not_found, char delimiter,
+                              const char *startTag, const char *endTag,
+                              const char *format, const char *default_value) {
   int status = MS_NOERR;
   char *encoded;
   char **items = NULL;
   int numitems = 0, i;
 
-  if(value && strlen(value) > 0)
+  if (value && strlen(value) > 0)
     items = msStringSplit(value, delimiter, &numitems);
   else {
     if (action_if_not_found == OWS_WARN) {
-      msIO_fprintf(stream, "<!-- WARNING: Mandatory mapfile parameter '%s' was missing in this context. -->\n", name);
+      msIO_fprintf(stream,
+                   "<!-- WARNING: Mandatory mapfile parameter '%s' was missing "
+                   "in this context. -->\n",
+                   name);
       status = action_if_not_found;
     }
 
@@ -2206,21 +2354,22 @@ int msOWSPrintEncodeParamList(FILE *stre
       items = msStringSplit(default_value, delimiter, &numitems);
   }
 
-  if(items && numitems > 0) {
-    if(startTag) msIO_fprintf(stream, "%s", startTag);
-    for(i=0; i<numitems; i++) {
+  if (items && numitems > 0) {
+    if (startTag)
+      msIO_fprintf(stream, "%s", startTag);
+    for (i = 0; i < numitems; i++) {
       encoded = msEncodeHTMLEntities(items[i]);
       msIO_fprintf(stream, format, encoded);
       msFree(encoded);
     }
-    if(endTag) msIO_fprintf(stream, "%s", endTag);
+    if (endTag)
+      msIO_fprintf(stream, "%s", endTag);
   }
   msFreeCharArray(items, numitems);
 
   return status;
 }
 
-
 /*
 ** msOWSPrintEX_GeographicBoundingBox()
 **
@@ -2231,7 +2380,7 @@ void msOWSPrintEX_GeographicBoundingBox(
                                         rectObj *extent, projectionObj *srcproj)
 
 {
-  const char *pszTag = "EX_GeographicBoundingBox";  /* The default for WMS */
+  const char *pszTag = "EX_GeographicBoundingBox"; /* The default for WMS */
   rectObj ext;
 
   ext = *extent;
@@ -2240,14 +2389,18 @@ void msOWSPrintEX_GeographicBoundingBox(
   msOWSProjectToWGS84(srcproj, &ext);
 
   msIO_fprintf(stream, "%s<%s>\n", tabspace, pszTag);
-  msIO_fprintf(stream, "%s    <westBoundLongitude>%.6f</westBoundLongitude>\n", tabspace, ext.minx);
-  msIO_fprintf(stream, "%s    <eastBoundLongitude>%.6f</eastBoundLongitude>\n", tabspace, ext.maxx);
-  msIO_fprintf(stream, "%s    <southBoundLatitude>%.6f</southBoundLatitude>\n", tabspace, ext.miny);
-  msIO_fprintf(stream, "%s    <northBoundLatitude>%.6f</northBoundLatitude>\n", tabspace, ext.maxy);
+  msIO_fprintf(stream, "%s    <westBoundLongitude>%.6f</westBoundLongitude>\n",
+               tabspace, ext.minx);
+  msIO_fprintf(stream, "%s    <eastBoundLongitude>%.6f</eastBoundLongitude>\n",
+               tabspace, ext.maxx);
+  msIO_fprintf(stream, "%s    <southBoundLatitude>%.6f</southBoundLatitude>\n",
+               tabspace, ext.miny);
+  msIO_fprintf(stream, "%s    <northBoundLatitude>%.6f</northBoundLatitude>\n",
+               tabspace, ext.maxy);
   msIO_fprintf(stream, "%s</%s>\n", tabspace, pszTag);
 
-  /* msIO_fprintf(stream, "%s<%s minx=\"%g\" miny=\"%g\" maxx=\"%g\" maxy=\"%g\" />\n",
-                  tabspace, pszTag, ext.minx, ext.miny, ext.maxx, ext.maxy); */
+  /* msIO_fprintf(stream, "%s<%s minx=\"%g\" miny=\"%g\" maxx=\"%g\" maxy=\"%g\"
+     />\n", tabspace, pszTag, ext.minx, ext.miny, ext.maxx, ext.maxy); */
 }
 
 /*
@@ -2259,16 +2412,17 @@ void msOWSPrintEX_GeographicBoundingBox(
 */
 void msOWSPrintLatLonBoundingBox(FILE *stream, const char *tabspace,
                                  rectObj *extent, projectionObj *srcproj,
-                                 projectionObj *wfsproj, OWSServiceType nService)
-{
-  const char *pszTag = "LatLonBoundingBox";  /* The default for WMS */
+                                 projectionObj *wfsproj,
+                                 OWSServiceType nService) {
+  const char *pszTag = "LatLonBoundingBox"; /* The default for WMS */
   rectObj ext;
 
   ext = *extent;
 
   if (nService == OWS_WMS) { /* always project to lat long */
     msOWSProjectToWGS84(srcproj, &ext);
-  } else if (nService == OWS_WFS) { /* called from wfs 1.0.0 only: project to map srs, if set */
+  } else if (nService == OWS_WFS) { /* called from wfs 1.0.0 only: project to
+                                       map srs, if set */
     pszTag = "LatLongBoundingBox";
     if (wfsproj) {
       if (msProjectionsDiffer(srcproj, wfsproj) == MS_TRUE)
@@ -2276,8 +2430,10 @@ void msOWSPrintLatLonBoundingBox(FILE *s
     }
   }
 
-  msIO_fprintf(stream, "%s<%s minx=\"%.6f\" miny=\"%.6f\" maxx=\"%.6f\" maxy=\"%.6f\" />\n",
-               tabspace, pszTag, ext.minx, ext.miny, ext.maxx, ext.maxy);
+  msIO_fprintf(
+      stream,
+      "%s<%s minx=\"%.6f\" miny=\"%.6f\" maxx=\"%.6f\" maxy=\"%.6f\" />\n",
+      tabspace, pszTag, ext.minx, ext.miny, ext.maxx, ext.maxy);
 }
 
 /*
@@ -2291,26 +2447,23 @@ void msOWSPrintLatLonBoundingBox(FILE *s
 ** if there is no such metadata at the layer level.
 ** (These settings make more sense at the global/map level anyways)
 */
-void msOWSPrintBoundingBox(FILE *stream, const char *tabspace,
-                           rectObj *extent,
-                           projectionObj *srcproj,
-                           hashTableObj *layer_meta,
-                           hashTableObj *map_meta,
-                           const char *namespaces,
-                           int wms_version)
-{
-  const char    *value, *resx, *resy, *wms_bbox_extended;
+void msOWSPrintBoundingBox(FILE *stream, const char *tabspace, rectObj *extent,
+                           projectionObj *srcproj, hashTableObj *layer_meta,
+                           hashTableObj *map_meta, const char *namespaces,
+                           int wms_version) {
+  const char *value, *resx, *resy, *wms_bbox_extended;
   char *encoded, *encoded_resx, *encoded_resy, *epsg_str;
   char **epsgs;
   int i, num_epsgs;
   projectionObj proj;
   rectObj ext;
 
-  wms_bbox_extended = msOWSLookupMetadata2(layer_meta, map_meta, namespaces, "bbox_extended");
-  if( wms_bbox_extended && strncasecmp(wms_bbox_extended, "true", 5) == 0 ) {
+  wms_bbox_extended =
+      msOWSLookupMetadata2(layer_meta, map_meta, namespaces, "bbox_extended");
+  if (wms_bbox_extended && strncasecmp(wms_bbox_extended, "true", 5) == 0) {
     /* get a list of all projections from the metadata
        try the layer metadata first, otherwise use the map's */
-    if( msOWSLookupMetadata(layer_meta, namespaces, "srs") ) {
+    if (msOWSLookupMetadata(layer_meta, namespaces, "srs")) {
       msOWSGetEPSGProj(srcproj, layer_meta, namespaces, MS_FALSE, &epsg_str);
     } else {
       msOWSGetEPSGProj(srcproj, map_meta, namespaces, MS_FALSE, &epsg_str);
@@ -2318,17 +2471,18 @@ void msOWSPrintBoundingBox(FILE *stream,
     epsgs = msStringSplit(epsg_str, ' ', &num_epsgs);
     msFree(epsg_str);
   } else {
-    /* Look for EPSG code in PROJECTION block only.  "wms_srs" metadata cannot be
-     * used to establish the native projection of a layer for BoundingBox purposes.
+    /* Look for EPSG code in PROJECTION block only.  "wms_srs" metadata cannot
+     * be used to establish the native projection of a layer for BoundingBox
+     * purposes.
      */
-    epsgs = (char **) msSmallMalloc(sizeof(char *));
+    epsgs = (char **)msSmallMalloc(sizeof(char *));
     num_epsgs = 1;
     msOWSGetEPSGProj(srcproj, layer_meta, namespaces, MS_TRUE, &(epsgs[0]));
   }
 
-  for( i = 0; i < num_epsgs; i++) {
+  for (i = 0; i < num_epsgs; i++) {
     value = epsgs[i];
-    if( value && *value) {
+    if (value && *value) {
       memcpy(&ext, extent, sizeof(rectObj));
 
       /* reproject the extents for each SRS's bounding box */
@@ -2341,56 +2495,53 @@ void msOWSPrintBoundingBox(FILE *stream,
         /*for wms 1.3.0 we need to make sure that we present the BBOX with
           a reversed axes for some espg codes*/
         if (wms_version >= OWS_1_3_0 && strncasecmp(value, "EPSG:", 5) == 0) {
-          msAxisNormalizePoints( &proj, 1, &(ext.minx), &(ext.miny) );
-          msAxisNormalizePoints( &proj, 1, &(ext.maxx), &(ext.maxy) );
+          msAxisNormalizePoints(&proj, 1, &(ext.minx), &(ext.miny));
+          msAxisNormalizePoints(&proj, 1, &(ext.maxx), &(ext.maxy));
         }
       }
 
       encoded = msEncodeHTMLEntities(value);
-      if (msProjIsGeographicCRS(&proj) )
-        msIO_fprintf(stream, "%s<BoundingBox %s=\"%s\"\n"
-                     "%s            minx=\"%.6f\" miny=\"%.6f\" maxx=\"%.6f\" maxy=\"%.6f\"",
-                     tabspace,
-                     (wms_version >= OWS_1_3_0) ? "CRS" : "SRS",
-                     encoded,
-                     tabspace, ext.minx, ext.miny,
-                     ext.maxx, ext.maxy);
+      if (msProjIsGeographicCRS(&proj))
+        msIO_fprintf(stream,
+                     "%s<BoundingBox %s=\"%s\"\n"
+                     "%s            minx=\"%.6f\" miny=\"%.6f\" maxx=\"%.6f\" "
+                     "maxy=\"%.6f\"",
+                     tabspace, (wms_version >= OWS_1_3_0) ? "CRS" : "SRS",
+                     encoded, tabspace, ext.minx, ext.miny, ext.maxx, ext.maxy);
       else
-        msIO_fprintf(stream, "%s<BoundingBox %s=\"%s\"\n"
-                     "%s            minx=\"%g\" miny=\"%g\" maxx=\"%g\" maxy=\"%g\"",
-                     tabspace,
-                     (wms_version >= OWS_1_3_0) ? "CRS" : "SRS",
-                     encoded,
-                     tabspace, ext.minx, ext.miny,
-                     ext.maxx, ext.maxy);
+        msIO_fprintf(
+            stream,
+            "%s<BoundingBox %s=\"%s\"\n"
+            "%s            minx=\"%g\" miny=\"%g\" maxx=\"%g\" maxy=\"%g\"",
+            tabspace, (wms_version >= OWS_1_3_0) ? "CRS" : "SRS", encoded,
+            tabspace, ext.minx, ext.miny, ext.maxx, ext.maxy);
 
       msFree(encoded);
-      msFreeProjection( &proj );
+      msFreeProjection(&proj);
 
-      if( (resx = msOWSLookupMetadata2( layer_meta, map_meta, "MFO", "resx" )) != NULL &&
-          (resy = msOWSLookupMetadata2( layer_meta, map_meta, "MFO", "resy" )) != NULL ) {
+      if ((resx = msOWSLookupMetadata2(layer_meta, map_meta, "MFO", "resx")) !=
+              NULL &&
+          (resy = msOWSLookupMetadata2(layer_meta, map_meta, "MFO", "resy")) !=
+              NULL) {
         encoded_resx = msEncodeHTMLEntities(resx);
         encoded_resy = msEncodeHTMLEntities(resy);
-        msIO_fprintf( stream, "\n%s            resx=\"%s\" resy=\"%s\"",
-                      tabspace, encoded_resx, encoded_resy );
+        msIO_fprintf(stream, "\n%s            resx=\"%s\" resy=\"%s\"",
+                     tabspace, encoded_resx, encoded_resy);
         msFree(encoded_resx);
         msFree(encoded_resy);
       }
 
-      msIO_fprintf( stream, " />\n" );
+      msIO_fprintf(stream, " />\n");
     }
   }
   msFreeCharArray(epsgs, num_epsgs);
 }
 
-
 /*
 ** Print the contact information
 */
-void msOWSPrintContactInfo( FILE *stream, const char *tabspace,
-                            int nVersion, hashTableObj *metadata,
-                            const char *namespaces )
-{
+void msOWSPrintContactInfo(FILE *stream, const char *tabspace, int nVersion,
+                           hashTableObj *metadata, const char *namespaces) {
   /* contact information is a required element in 1.0.7 but the */
   /* sub-elements such as ContactPersonPrimary, etc. are not! */
   /* In 1.1.0, ContactInformation becomes optional. */
@@ -2400,68 +2551,76 @@ void msOWSPrintContactInfo( FILE *stream
     /* ContactPersonPrimary is optional, but when present then all its  */
     /* sub-elements are mandatory */
 
-    if(msOWSLookupMetadata(metadata, namespaces, "contactperson") ||
+    if (msOWSLookupMetadata(metadata, namespaces, "contactperson") ||
         msOWSLookupMetadata(metadata, namespaces, "contactorganization")) {
       msIO_fprintf(stream, "%s  <ContactPersonPrimary>\n", tabspace);
 
-      msOWSPrintEncodeMetadata(stream, metadata, namespaces, "contactperson",
-                               OWS_WARN, "      <ContactPerson>%s</ContactPerson>\n", NULL);
-      msOWSPrintEncodeMetadata(stream, metadata, namespaces, "contactorganization",
-                               OWS_WARN, "      <ContactOrganization>%s</ContactOrganization>\n",
-                               NULL);
+      msOWSPrintEncodeMetadata(
+          stream, metadata, namespaces, "contactperson", OWS_WARN,
+          "      <ContactPerson>%s</ContactPerson>\n", NULL);
+      msOWSPrintEncodeMetadata(
+          stream, metadata, namespaces, "contactorganization", OWS_WARN,
+          "      <ContactOrganization>%s</ContactOrganization>\n", NULL);
       msIO_fprintf(stream, "%s  </ContactPersonPrimary>\n", tabspace);
     }
 
-    if(msOWSLookupMetadata(metadata, namespaces, "contactposition")) {
-      msOWSPrintEncodeMetadata(stream, metadata, namespaces, "contactposition",
-                               OWS_NOERR, "      <ContactPosition>%s</ContactPosition>\n",
-                               NULL);
+    if (msOWSLookupMetadata(metadata, namespaces, "contactposition")) {
+      msOWSPrintEncodeMetadata(
+          stream, metadata, namespaces, "contactposition", OWS_NOERR,
+          "      <ContactPosition>%s</ContactPosition>\n", NULL);
     }
 
     /* ContactAdress is optional, but when present then all its  */
     /* sub-elements are mandatory */
-    if(msOWSLookupMetadata( metadata, namespaces, "addresstype" ) ||
-        msOWSLookupMetadata( metadata, namespaces, "address" ) ||
-        msOWSLookupMetadata( metadata, namespaces, "city" ) ||
-        msOWSLookupMetadata( metadata, namespaces, "stateorprovince" ) ||
-        msOWSLookupMetadata( metadata, namespaces, "postcode" ) ||
-        msOWSLookupMetadata( metadata, namespaces, "country" )) {
+    if (msOWSLookupMetadata(metadata, namespaces, "addresstype") ||
+        msOWSLookupMetadata(metadata, namespaces, "address") ||
+        msOWSLookupMetadata(metadata, namespaces, "city") ||
+        msOWSLookupMetadata(metadata, namespaces, "stateorprovince") ||
+        msOWSLookupMetadata(metadata, namespaces, "postcode") ||
+        msOWSLookupMetadata(metadata, namespaces, "country")) {
       msIO_fprintf(stream, "%s  <ContactAddress>\n", tabspace);
 
-      msOWSPrintEncodeMetadata(stream, metadata, namespaces,"addresstype", OWS_WARN,
+      msOWSPrintEncodeMetadata(stream, metadata, namespaces, "addresstype",
+                               OWS_WARN,
                                "        <AddressType>%s</AddressType>\n", NULL);
-      msOWSPrintEncodeMetadata(stream, metadata, namespaces, "address", OWS_WARN,
-                               "        <Address>%s</Address>\n", NULL);
+      msOWSPrintEncodeMetadata(stream, metadata, namespaces, "address",
+                               OWS_WARN, "        <Address>%s</Address>\n",
+                               NULL);
       msOWSPrintEncodeMetadata(stream, metadata, namespaces, "city", OWS_WARN,
                                "        <City>%s</City>\n", NULL);
-      msOWSPrintEncodeMetadata(stream, metadata, namespaces, "stateorprovince",
-                               OWS_WARN,"        <StateOrProvince>%s</StateOrProvince>\n", NULL);
-      msOWSPrintEncodeMetadata(stream, metadata, namespaces, "postcode", OWS_WARN,
-                               "        <PostCode>%s</PostCode>\n", NULL);
-      msOWSPrintEncodeMetadata(stream, metadata, namespaces, "country", OWS_WARN,
-                               "        <Country>%s</Country>\n", NULL);
-      msIO_fprintf(stream, "%s  </ContactAddress>\n", tabspace);
-    }
-
-    if(msOWSLookupMetadata(metadata, namespaces, "contactvoicetelephone")) {
-      msOWSPrintEncodeMetadata(stream, metadata, namespaces,
-                               "contactvoicetelephone", OWS_NOERR,
-                               "      <ContactVoiceTelephone>%s</ContactVoiceTelephone>\n",
+      msOWSPrintEncodeMetadata(
+          stream, metadata, namespaces, "stateorprovince", OWS_WARN,
+          "        <StateOrProvince>%s</StateOrProvince>\n", NULL);
+      msOWSPrintEncodeMetadata(stream, metadata, namespaces, "postcode",
+                               OWS_WARN, "        <PostCode>%s</PostCode>\n",
                                NULL);
-    }
-
-    if(msOWSLookupMetadata(metadata, namespaces, "contactfacsimiletelephone")) {
-      msOWSPrintEncodeMetadata(stream, metadata,
-                               namespaces, "contactfacsimiletelephone", OWS_NOERR,
-                               "      <ContactFacsimileTelephone>%s</ContactFacsimileTelephone>\n",
+      msOWSPrintEncodeMetadata(stream, metadata, namespaces, "country",
+                               OWS_WARN, "        <Country>%s</Country>\n",
                                NULL);
+      msIO_fprintf(stream, "%s  </ContactAddress>\n", tabspace);
     }
 
-    if(msOWSLookupMetadata(metadata, namespaces, "contactelectronicmailaddress")) {
-      msOWSPrintEncodeMetadata(stream, metadata,
-                               namespaces, "contactelectronicmailaddress", OWS_NOERR,
-                               "  <ContactElectronicMailAddress>%s</ContactElectronicMailAddress>\n",
-                               NULL);
+    if (msOWSLookupMetadata(metadata, namespaces, "contactvoicetelephone")) {
+      msOWSPrintEncodeMetadata(
+          stream, metadata, namespaces, "contactvoicetelephone", OWS_NOERR,
+          "      <ContactVoiceTelephone>%s</ContactVoiceTelephone>\n", NULL);
+    }
+
+    if (msOWSLookupMetadata(metadata, namespaces,
+                            "contactfacsimiletelephone")) {
+      msOWSPrintEncodeMetadata(
+          stream, metadata, namespaces, "contactfacsimiletelephone", OWS_NOERR,
+          "      <ContactFacsimileTelephone>%s</ContactFacsimileTelephone>\n",
+          NULL);
+    }
+
+    if (msOWSLookupMetadata(metadata, namespaces,
+                            "contactelectronicmailaddress")) {
+      msOWSPrintEncodeMetadata(
+          stream, metadata, namespaces, "contactelectronicmailaddress",
+          OWS_NOERR,
+          "  <ContactElectronicMailAddress>%s</ContactElectronicMailAddress>\n",
+          NULL);
     }
     msIO_fprintf(stream, "%s</ContactInformation>\n", tabspace);
   }
@@ -2475,17 +2634,18 @@ void msOWSPrintContactInfo( FILE *stream
 ** layer->extent member, and if not found will open layer to read extent.
 **
 */
-int msOWSGetLayerExtent(mapObj *map, layerObj *lp, const char *namespaces, rectObj *ext)
-{
+int msOWSGetLayerExtent(mapObj *map, layerObj *lp, const char *namespaces,
+                        rectObj *ext) {
   (void)map;
   const char *value;
 
-  if ((value = msOWSLookupMetadata(&(lp->metadata), namespaces, "extent")) != NULL) {
+  if ((value = msOWSLookupMetadata(&(lp->metadata), namespaces, "extent")) !=
+      NULL) {
     char **tokens;
     int n;
 
     tokens = msStringSplit(value, ' ', &n);
-    if (tokens==NULL || n != 4) {
+    if (tokens == NULL || n != 4) {
       msSetError(MS_WMSERR, "Wrong number of arguments for EXTENT metadata.",
                  "msOWSGetLayerExtent()");
       return MS_FAILURE;
@@ -2504,7 +2664,6 @@ int msOWSGetLayerExtent(mapObj *map, lay
   return MS_FAILURE;
 }
 
-
 /**********************************************************************
  *                          msOWSExecuteRequests()
  *
@@ -2512,22 +2671,23 @@ int msOWSGetLayerExtent(mapObj *map, lay
  * update layerObj information with the result of the requests.
  **********************************************************************/
 int msOWSExecuteRequests(httpRequestObj *pasReqInfo, int numRequests,
-                         mapObj *map, int bCheckLocalCache)
-{
+                         mapObj *map, int bCheckLocalCache) {
   int nStatus, iReq;
 
   /* Execute requests */
 #if defined(USE_CURL)
   nStatus = msHTTPExecuteRequests(pasReqInfo, numRequests, bCheckLocalCache);
 #else
-  msSetError(MS_WMSERR, "msOWSExecuteRequests() called apparently without libcurl configured, msHTTPExecuteRequests() not available.",
+  msSetError(MS_WMSERR,
+             "msOWSExecuteRequests() called apparently without libcurl "
+             "configured, msHTTPExecuteRequests() not available.",
              "msOWSExecuteRequests()");
   return MS_FAILURE;
 #endif
 
   /* Scan list of layers and call the handler for each layer type to */
   /* pass them the request results. */
-  for(iReq=0; iReq<numRequests; iReq++) {
+  for (iReq = 0; iReq < numRequests; iReq++) {
     if (pasReqInfo[iReq].nLayerId >= 0 &&
         pasReqInfo[iReq].nLayerId < map->numlayers) {
       layerObj *lp;
@@ -2546,32 +2706,31 @@ int msOWSExecuteRequests(httpRequestObj
  *                          msOWSProcessException()
  *
  **********************************************************************/
-void msOWSProcessException(layerObj *lp, const char *pszFname,
-                           int nErrorCode, const char *pszFuncName)
-{
+void msOWSProcessException(layerObj *lp, const char *pszFname, int nErrorCode,
+                           const char *pszFuncName) {
   FILE *fp;
 
   if ((fp = fopen(pszFname, "r")) != NULL) {
-    char *pszBuf=NULL;
-    int   nBufSize=0;
+    char *pszBuf = NULL;
+    int nBufSize = 0;
     char *pszStart, *pszEnd;
 
     fseek(fp, 0, SEEK_END);
     nBufSize = ftell(fp);
-    if(nBufSize < 0) {
+    if (nBufSize < 0) {
       msSetError(MS_IOERR, NULL, "msOWSProcessException()");
       fclose(fp);
       return;
     }
     rewind(fp);
-    pszBuf = (char*)malloc((nBufSize+1)*sizeof(char));
+    pszBuf = (char *)malloc((nBufSize + 1) * sizeof(char));
     if (pszBuf == NULL) {
       msSetError(MS_MEMERR, NULL, "msOWSProcessException()");
       fclose(fp);
       return;
     }
 
-    if ((int) fread(pszBuf, 1, nBufSize, fp) != nBufSize) {
+    if ((int)fread(pszBuf, 1, nBufSize, fp) != nBufSize) {
       msSetError(MS_IOERR, NULL, "msOWSProcessException()");
       free(pszBuf);
       fclose(fp);
@@ -2580,21 +2739,22 @@ void msOWSProcessException(layerObj *lp,
 
     pszBuf[nBufSize] = '\0';
 
-
     /* OK, got the data in the buffer.  Look for the <Message> tags */
-    if ((strstr(pszBuf, "<WFS_Exception>") &&            /* WFS style */
+    if ((strstr(pszBuf, "<WFS_Exception>") && /* WFS style */
          (pszStart = strstr(pszBuf, "<Message>")) &&
-         (pszEnd = strstr(pszStart, "</Message>")) ) ||
-        (strstr(pszBuf, "<ServiceExceptionReport>") &&   /* WMS style */
+         (pszEnd = strstr(pszStart, "</Message>"))) ||
+        (strstr(pszBuf, "<ServiceExceptionReport>") && /* WMS style */
          (pszStart = strstr(pszBuf, "<ServiceException>")) &&
-         (pszEnd = strstr(pszStart, "</ServiceException>")) )) {
-      pszStart = strchr(pszStart, '>')+1;
+         (pszEnd = strstr(pszStart, "</ServiceException>")))) {
+      pszStart = strchr(pszStart, '>') + 1;
       *pszEnd = '\0';
       msSetError(nErrorCode, "Got Remote Server Exception for layer %s: %s",
-                 pszFuncName, lp->name?lp->name:"(null)", pszStart);
+                 pszFuncName, lp->name ? lp->name : "(null)", pszStart);
     } else {
-      msSetError(MS_WFSCONNERR, "Unable to parse Remote Server Exception Message for layer %s.",
-                 pszFuncName, lp->name?lp->name:"(null)");
+      msSetError(
+          MS_WFSCONNERR,
+          "Unable to parse Remote Server Exception Message for layer %s.",
+          pszFuncName, lp->name ? lp->name : "(null)");
     }
 
     free(pszBuf);
@@ -2612,18 +2772,16 @@ void msOWSProcessException(layerObj *lp,
  * NULL in case of error.
  **********************************************************************/
 char *msOWSBuildURLFilename(const char *pszPath, const char *pszURL,
-                            const char *pszExt)
-{
+                            const char *pszExt) {
   char *pszBuf, *pszPtr;
-  int  i;
+  int i;
   size_t nBufLen = 0;
 
-
-  nBufLen = strlen(pszURL) + strlen(pszExt) +2;
+  nBufLen = strlen(pszURL) + strlen(pszExt) + 2;
   if (pszPath)
-    nBufLen += (strlen(pszPath)+1);
+    nBufLen += (strlen(pszPath) + 1);
 
-  pszBuf = (char*)malloc(nBufLen);
+  pszBuf = (char *)malloc(nBufLen);
   if (pszBuf == NULL) {
     msSetError(MS_MEMERR, NULL, "msOWSBuildURLFilename()");
     return NULL;
@@ -2632,13 +2790,13 @@ char *msOWSBuildURLFilename(const char *
 
   if (pszPath) {
 #ifdef _WIN32
-    if (pszPath[strlen(pszPath) -1] != '/' &&
-        pszPath[strlen(pszPath) -1] != '\\')
+    if (pszPath[strlen(pszPath) - 1] != '/' &&
+        pszPath[strlen(pszPath) - 1] != '\\')
       snprintf(pszBuf, nBufLen, "%s\\", pszPath);
     else
       snprintf(pszBuf, nBufLen, "%s", pszPath);
 #else
-    if (pszPath[strlen(pszPath) -1] != '/')
+    if (pszPath[strlen(pszPath) - 1] != '/')
       snprintf(pszBuf, nBufLen, "%s/", pszPath);
     else
       snprintf(pszBuf, nBufLen, "%s", pszPath);
@@ -2647,7 +2805,7 @@ char *msOWSBuildURLFilename(const char *
 
   pszPtr = pszBuf + strlen(pszBuf);
 
-  for(i=0; pszURL[i] != '\0'; i++) {
+  for (i = 0; pszURL[i] != '\0'; i++) {
     if (isalnum(pszURL[i]))
       *pszPtr = pszURL[i];
     else
@@ -2668,19 +2826,18 @@ char *msOWSBuildURLFilename(const char *
 ** The returned buffer is dynamically allocated, and must be freed by the
 ** caller.
 */
-char *msOWSGetProjURN(projectionObj *proj, hashTableObj *metadata, const char *namespaces, int bReturnOnlyFirstOne)
-{
+char *msOWSGetProjURN(projectionObj *proj, hashTableObj *metadata,
+                      const char *namespaces, int bReturnOnlyFirstOne) {
   char *result;
   char **tokens;
   int numtokens, i;
   char *oldStyle = NULL;
-  
-  msOWSGetEPSGProj( proj, metadata, namespaces, bReturnOnlyFirstOne, &oldStyle );
 
-  if( oldStyle == NULL ||
-      strncmp(oldStyle,"CRS:",4) == 0 ||
-      strncmp(oldStyle,"AUTO:",5) == 0 ||
-      strncmp(oldStyle,"AUTO2:",6) == 0 ) {
+  msOWSGetEPSGProj(proj, metadata, namespaces, bReturnOnlyFirstOne, &oldStyle);
+
+  if (oldStyle == NULL || strncmp(oldStyle, "CRS:", 4) == 0 ||
+      strncmp(oldStyle, "AUTO:", 5) == 0 ||
+      strncmp(oldStyle, "AUTO2:", 6) == 0) {
     msFree(oldStyle);
     return NULL;
   }
@@ -2689,39 +2846,39 @@ char *msOWSGetProjURN(projectionObj *pro
 
   tokens = msStringSplit(oldStyle, ' ', &numtokens);
   msFree(oldStyle);
-  for(i=0; tokens != NULL && i<numtokens; i++) {
+  for (i = 0; tokens != NULL && i < numtokens; i++) {
     char urn[100];
-    char* colon = strchr(tokens[i], ':');
+    char *colon = strchr(tokens[i], ':');
 
-    if( colon != NULL && strchr(colon + 1, ':') == NULL ) {
+    if (colon != NULL && strchr(colon + 1, ':') == NULL) {
       *colon = 0;
-      snprintf( urn, sizeof(urn), "urn:ogc:def:crs:%s::%s", tokens[i], colon + 1 );
-    }
-    else if( strcasecmp(tokens[i],"imageCRS") == 0 )
-      snprintf( urn, sizeof(urn), "urn:ogc:def:crs:OGC::imageCRS" );
-    else if( strncmp(tokens[i],"urn:ogc:def:crs:",16) == 0 ) {
-      strlcpy( urn, tokens[i], sizeof(urn));
+      snprintf(urn, sizeof(urn), "urn:ogc:def:crs:%s::%s", tokens[i],
+               colon + 1);
+    } else if (strcasecmp(tokens[i], "imageCRS") == 0)
+      snprintf(urn, sizeof(urn), "urn:ogc:def:crs:OGC::imageCRS");
+    else if (strncmp(tokens[i], "urn:ogc:def:crs:", 16) == 0) {
+      strlcpy(urn, tokens[i], sizeof(urn));
     } else {
-      strlcpy( urn, "", sizeof(urn));
+      strlcpy(urn, "", sizeof(urn));
     }
 
-    if( strlen(urn) > 0 ) {
-      const size_t bufferSize = strlen(result)+strlen(urn)+2;
-      result = (char *) msSmallRealloc(result, bufferSize);
+    if (strlen(urn) > 0) {
+      const size_t bufferSize = strlen(result) + strlen(urn) + 2;
+      result = (char *)msSmallRealloc(result, bufferSize);
 
-      if( strlen(result) > 0 )
-        strlcat( result, " ", bufferSize);
-      strlcat( result, urn , bufferSize);
+      if (strlen(result) > 0)
+        strlcat(result, " ", bufferSize);
+      strlcat(result, urn, bufferSize);
     } else {
-      msDebug( "msOWSGetProjURN(): Failed to process SRS '%s', ignored.",
-               tokens[i] );
+      msDebug("msOWSGetProjURN(): Failed to process SRS '%s', ignored.",
+              tokens[i]);
     }
   }
 
   msFreeCharArray(tokens, numtokens);
 
-  if( strlen(result) == 0 ) {
-    msFree( result );
+  if (strlen(result) == 0) {
+    msFree(result);
     return NULL;
   } else
     return result;
@@ -2731,20 +2888,21 @@ char *msOWSGetProjURN(projectionObj *pro
 ** msOWSGetProjURI()
 **
 ** Fetch an OGC URI for this layer or map.  Similar to msOWSGetEPSGProj()
-** but returns the result in the form "http://www.opengis.net/def/crs/EPSG/0/27700".
+** but returns the result in the form
+*"http://www.opengis.net/def/crs/EPSG/0/27700".
 ** The returned buffer is dynamically allocated, and must be freed by the
 ** caller.
 */
-char *msOWSGetProjURI(projectionObj *proj, hashTableObj *metadata, const char *namespaces, int bReturnOnlyFirstOne)
-{
+char *msOWSGetProjURI(projectionObj *proj, hashTableObj *metadata,
+                      const char *namespaces, int bReturnOnlyFirstOne) {
   char *result;
   char **tokens;
   int numtokens, i;
   char *oldStyle = NULL;
-  
-  msOWSGetEPSGProj( proj, metadata, namespaces, bReturnOnlyFirstOne, &oldStyle);
 
-  if( oldStyle == NULL || !EQUALN(oldStyle,"EPSG:",5) ) {
+  msOWSGetEPSGProj(proj, metadata, namespaces, bReturnOnlyFirstOne, &oldStyle);
+
+  if (oldStyle == NULL || !EQUALN(oldStyle, "EPSG:", 5)) {
     msFree(oldStyle); // avoid leak
     return NULL;
   }
@@ -2753,40 +2911,41 @@ char *msOWSGetProjURI(projectionObj *pro
 
   tokens = msStringSplit(oldStyle, ' ', &numtokens);
   msFree(oldStyle);
-  for(i=0; tokens != NULL && i<numtokens; i++) {
+  for (i = 0; tokens != NULL && i < numtokens; i++) {
     char urn[100];
 
-    if( strncmp(tokens[i],"EPSG:",5) == 0 )
-      snprintf( urn, sizeof(urn), "http://www.opengis.net/def/crs/EPSG/0/%s", tokens[i]+5 );
-    else if( strcasecmp(tokens[i],"imageCRS") == 0 )
-      snprintf( urn, sizeof(urn), "http://www.opengis.net/def/crs/OGC/0/imageCRS" );
-    else if( strncmp(tokens[i],"http://www.opengis.net/def/crs/",16) == 0 )
-      snprintf( urn, sizeof(urn), "%s", tokens[i] );
+    if (strncmp(tokens[i], "EPSG:", 5) == 0)
+      snprintf(urn, sizeof(urn), "http://www.opengis.net/def/crs/EPSG/0/%s",
+               tokens[i] + 5);
+    else if (strcasecmp(tokens[i], "imageCRS") == 0)
+      snprintf(urn, sizeof(urn),
+               "http://www.opengis.net/def/crs/OGC/0/imageCRS");
+    else if (strncmp(tokens[i], "http://www.opengis.net/def/crs/", 16) == 0)
+      snprintf(urn, sizeof(urn), "%s", tokens[i]);
     else
-      strlcpy( urn, "", sizeof(urn) );
+      strlcpy(urn, "", sizeof(urn));
 
-    if( strlen(urn) > 0 ) {
-      result = (char *) msSmallRealloc(result,strlen(result)+strlen(urn)+2);
+    if (strlen(urn) > 0) {
+      result = (char *)msSmallRealloc(result, strlen(result) + strlen(urn) + 2);
 
-      if( strlen(result) > 0 )
-        strcat( result, " " );
-      strcat( result, urn );
+      if (strlen(result) > 0)
+        strcat(result, " ");
+      strcat(result, urn);
     } else {
-      msDebug( "msOWSGetProjURI(): Failed to process SRS '%s', ignored.",
-               tokens[i] );
+      msDebug("msOWSGetProjURI(): Failed to process SRS '%s', ignored.",
+              tokens[i]);
     }
   }
 
   msFreeCharArray(tokens, numtokens);
 
-  if( strlen(result) == 0 ) {
-    msFree( result );
+  if (strlen(result) == 0) {
+    msFree(result);
     return NULL;
   } else
     return result;
 }
 
-
 /*
 ** msOWSGetDimensionInfo()
 **
@@ -2804,67 +2963,71 @@ void msOWSGetDimensionInfo(layerObj *lay
                            const char **papszDimDefault,
                            const char **papszDimNearValue,
                            const char **papszDimUnitSymbol,
-                           const char **papszDimMultiValue)
-{
+                           const char **papszDimMultiValue) {
   char *pszDimensionItem;
   size_t bufferSize = 0;
 
-  if(pszDimension == NULL || layer == NULL)
+  if (pszDimension == NULL || layer == NULL)
     return;
 
-  bufferSize = strlen(pszDimension)+50;
-  pszDimensionItem = (char*)malloc(bufferSize);
+  bufferSize = strlen(pszDimension) + 50;
+  pszDimensionItem = (char *)malloc(bufferSize);
 
   /* units (mandatory in map context) */
-  if(papszDimUnits != NULL) {
-    snprintf(pszDimensionItem, bufferSize, "dimension_%s_units",          pszDimension);
-    *papszDimUnits = msOWSLookupMetadata(&(layer->metadata), "MO",
-                                         pszDimensionItem);
+  if (papszDimUnits != NULL) {
+    snprintf(pszDimensionItem, bufferSize, "dimension_%s_units", pszDimension);
+    *papszDimUnits =
+        msOWSLookupMetadata(&(layer->metadata), "MO", pszDimensionItem);
   }
   /* unitSymbol (mandatory in map context) */
-  if(papszDimUnitSymbol != NULL) {
-    snprintf(pszDimensionItem, bufferSize, "dimension_%s_unitsymbol",     pszDimension);
-    *papszDimUnitSymbol = msOWSLookupMetadata(&(layer->metadata), "MO",
-                          pszDimensionItem);
+  if (papszDimUnitSymbol != NULL) {
+    snprintf(pszDimensionItem, bufferSize, "dimension_%s_unitsymbol",
+             pszDimension);
+    *papszDimUnitSymbol =
+        msOWSLookupMetadata(&(layer->metadata), "MO", pszDimensionItem);
   }
   /* userValue (mandatory in map context) */
-  if(papszDimUserValue != NULL) {
-    snprintf(pszDimensionItem, bufferSize, "dimension_%s_uservalue",      pszDimension);
-    *papszDimUserValue = msOWSLookupMetadata(&(layer->metadata), "MO",
-                         pszDimensionItem);
+  if (papszDimUserValue != NULL) {
+    snprintf(pszDimensionItem, bufferSize, "dimension_%s_uservalue",
+             pszDimension);
+    *papszDimUserValue =
+        msOWSLookupMetadata(&(layer->metadata), "MO", pszDimensionItem);
   }
   /* default */
-  if(papszDimDefault != NULL) {
-    snprintf(pszDimensionItem, bufferSize, "dimension_%s_default",        pszDimension);
-    *papszDimDefault = msOWSLookupMetadata(&(layer->metadata), "MO",
-                                           pszDimensionItem);
+  if (papszDimDefault != NULL) {
+    snprintf(pszDimensionItem, bufferSize, "dimension_%s_default",
+             pszDimension);
+    *papszDimDefault =
+        msOWSLookupMetadata(&(layer->metadata), "MO", pszDimensionItem);
   }
   /* multipleValues */
-  if(papszDimMultiValue != NULL) {
-    snprintf(pszDimensionItem, bufferSize, "dimension_%s_multiplevalues", pszDimension);
-    *papszDimMultiValue = msOWSLookupMetadata(&(layer->metadata), "MO",
-                          pszDimensionItem);
+  if (papszDimMultiValue != NULL) {
+    snprintf(pszDimensionItem, bufferSize, "dimension_%s_multiplevalues",
+             pszDimension);
+    *papszDimMultiValue =
+        msOWSLookupMetadata(&(layer->metadata), "MO", pszDimensionItem);
   }
   /* nearestValue */
-  if(papszDimNearValue != NULL) {
-    snprintf(pszDimensionItem, bufferSize, "dimension_%s_nearestvalue",   pszDimension);
-    *papszDimNearValue = msOWSLookupMetadata(&(layer->metadata), "MO",
-                         pszDimensionItem);
+  if (papszDimNearValue != NULL) {
+    snprintf(pszDimensionItem, bufferSize, "dimension_%s_nearestvalue",
+             pszDimension);
+    *papszDimNearValue =
+        msOWSLookupMetadata(&(layer->metadata), "MO", pszDimensionItem);
   }
 
   /* Use default time value if necessary */
-  if(strcasecmp(pszDimension, "time") == 0) {
-    if(papszDimUserValue != NULL && *papszDimUserValue == NULL)
-      *papszDimUserValue = msOWSLookupMetadata(&(layer->metadata),
-                           "MO", "time");
-    if(papszDimDefault != NULL && *papszDimDefault == NULL)
-      *papszDimDefault = msOWSLookupMetadata(&(layer->metadata),
-                                             "MO", "timedefault");
-    if(papszDimUnits != NULL && *papszDimUnits == NULL)
+  if (strcasecmp(pszDimension, "time") == 0) {
+    if (papszDimUserValue != NULL && *papszDimUserValue == NULL)
+      *papszDimUserValue =
+          msOWSLookupMetadata(&(layer->metadata), "MO", "time");
+    if (papszDimDefault != NULL && *papszDimDefault == NULL)
+      *papszDimDefault =
+          msOWSLookupMetadata(&(layer->metadata), "MO", "timedefault");
+    if (papszDimUnits != NULL && *papszDimUnits == NULL)
       *papszDimUnits = "ISO8601";
-    if(papszDimUnitSymbol != NULL && *papszDimUnitSymbol == NULL)
+    if (papszDimUnitSymbol != NULL && *papszDimUnitSymbol == NULL)
       *papszDimUnitSymbol = "t";
-    if(papszDimNearValue != NULL && *papszDimNearValue == NULL)
+    if (papszDimNearValue != NULL && *papszDimNearValue == NULL)
       *papszDimNearValue = "0";
   }
 
@@ -2887,8 +3050,8 @@ void msOWSGetDimensionInfo(layerObj *lay
  *  0: equal
  */
 
-int msOWSNegotiateUpdateSequence(const char *requested_updatesequence, const char *updatesequence)
-{
+int msOWSNegotiateUpdateSequence(const char *requested_updatesequence,
+                                 const char *updatesequence) {
   int i;
   int valtype1 = 1; /* default datatype for updatesequence passed by client */
   int valtype2 = 1; /* default datatype for updatesequence set by server */
@@ -2896,10 +3059,11 @@ int msOWSNegotiateUpdateSequence(const c
 
   /* if not specified by client, or set by server,
      server responds with latest Capabilities XML */
-  if (! requested_updatesequence || ! updatesequence)
+  if (!requested_updatesequence || !updatesequence)
     return -1;
 
-  /* test to see if server value is an integer (1), string (2) or timestamp (3) */
+  /* test to see if server value is an integer (1), string (2) or timestamp (3)
+   */
   if (msStringIsInteger(updatesequence) == MS_FAILURE)
     valtype1 = 2;
 
@@ -2910,13 +3074,15 @@ int msOWSNegotiateUpdateSequence(const c
     msResetErrorList();
   }
 
-  /* test to see if client value is an integer (1), string (2) or timestamp (3) */
+  /* test to see if client value is an integer (1), string (2) or timestamp (3)
+   */
   if (msStringIsInteger(requested_updatesequence) == MS_FAILURE)
     valtype2 = 2;
 
   if (valtype2 == 2) { /* test if timestamp */
     msTimeInit(&tm_requested_updatesequence);
-    if (msParseTime(requested_updatesequence, &tm_requested_updatesequence) == MS_TRUE)
+    if (msParseTime(requested_updatesequence, &tm_requested_updatesequence) ==
+        MS_TRUE)
       valtype2 = 3;
     msResetErrorList();
   }
@@ -2950,37 +3116,36 @@ int msOWSNegotiateUpdateSequence(const c
   return -1;
 }
 
-
 /************************************************************************/
 /*                         msOwsIsOutputFormatValid                     */
 /*                                                                      */
 /*      Utlity function to parse a comma separated list in a            */
 /*      metedata object and select and outputformat.                    */
 /************************************************************************/
-outputFormatObj* msOwsIsOutputFormatValid(mapObj *map, const char *format,
-    hashTableObj *metadata,
-    const char *namespaces, const char *name)
-{
-  char **tokens=NULL;
-  int i,n;
+outputFormatObj *msOwsIsOutputFormatValid(mapObj *map, const char *format,
+                                          hashTableObj *metadata,
+                                          const char *namespaces,
+                                          const char *name) {
+  char **tokens = NULL;
+  int i, n;
   outputFormatObj *psFormat = NULL;
-  const char * format_list=NULL;
+  const char *format_list = NULL;
 
   if (map && format && metadata && namespaces && name) {
     msApplyDefaultOutputFormats(map);
     format_list = msOWSLookupMetadata(metadata, namespaces, name);
     n = 0;
-    if ( format_list)
-      tokens = msStringSplit(format_list,  ',', &n);
+    if (format_list)
+      tokens = msStringSplit(format_list, ',', &n);
 
     if (tokens && n > 0) {
-      for (i=0; i<n; i++) {
-        int iFormat = msGetOutputFormatIndex( map, tokens[i]);
+      for (i = 0; i < n; i++) {
+        int iFormat = msGetOutputFormatIndex(map, tokens[i]);
         const char *mimetype;
-        if( iFormat == -1 )
+        if (iFormat == -1)
           continue;
 
-        mimetype =  map->outputformatlist[iFormat]->mimetype;
+        mimetype = map->outputformatlist[iFormat]->mimetype;
 
         msStringTrim(tokens[i]);
         if (strcasecmp(tokens[i], format) == 0)
@@ -2989,13 +3154,15 @@ outputFormatObj* msOwsIsOutputFormatVali
           break;
       }
       if (i < n)
-        psFormat = msSelectOutputFormat( map, format);
+        psFormat = msSelectOutputFormat(map, format);
     }
-    if(tokens)
+    if (tokens)
       msFreeCharArray(tokens, n);
   }
 
   return psFormat;
 }
 
-#endif /* defined(USE_WMS_SVR) || defined (USE_WFS_SVR) || defined (USE_WCS_SVR) || defined(USE_SOS_SVR) || defined(USE_WMS_LYR) || defined(USE_WFS_LYR) */
+#endif /* defined(USE_WMS_SVR) || defined (USE_WFS_SVR) || defined             \
+          (USE_WCS_SVR) || defined(USE_SOS_SVR) || defined(USE_WMS_LYR) ||     \
+          defined(USE_WFS_LYR) */
diff -pruN 8.0.1-5/mapows.h 8.0.2-1/mapows.h
--- 8.0.1-5/mapows.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapows.h	2024-06-11 20:41:34.000000000 +0000
@@ -27,7 +27,6 @@
  * DEALINGS IN THE SOFTWARE.
  ****************************************************************************/
 
-
 #ifndef MAPOWS_H
 #define MAPOWS_H
 
@@ -38,17 +37,16 @@
  * default for OGC services unless the ows_schemas_lcoation web metadata
  * is set in the mapfile.
  */
-#define OWS_DEFAULT_SCHEMAS_LOCATION   "http://schemas.opengis.net"
+#define OWS_DEFAULT_SCHEMAS_LOCATION "http://schemas.opengis.net"
 
 #if defined USE_LIBXML2 && defined USE_WFS_SVR
-#include<libxml/tree.h>
+#include <libxml/tree.h>
 #endif
 
 #ifdef __cplusplus
 extern "C" {
 #endif
 
-
 /*====================================================================
  *   mapows.c
  *====================================================================*/
@@ -72,12 +70,14 @@ typedef struct {
   int nStartIndex;
   char *pszAcceptVersions;
   char *pszSections;
-  char *pszSortBy; /* Not implemented yet */
-  char *pszLanguage; /* Inspire extension */
+  char *pszSortBy;         /* Not implemented yet */
+  char *pszLanguage;       /* Inspire extension */
   char *pszValueReference; /* For GetValueReference */
-  char *pszStoredQueryId; /* For DescribeStoredQueries */
-  int   countGetFeatureById; /* Number of urn:ogc:def:query:OGC-WFS::GetFeatureById GetFeature requests */
-  int   bHasPostStoredQuery; /* TRUE if a XML GetFeature StoredQuery is present */
+  char *pszStoredQueryId;  /* For DescribeStoredQueries */
+  int countGetFeatureById; /* Number of
+                              urn:ogc:def:query:OGC-WFS::GetFeatureById
+                              GetFeature requests */
+  int bHasPostStoredQuery; /* TRUE if a XML GetFeature StoredQuery is present */
 } wfsParamsObj;
 
 /*
@@ -112,14 +112,15 @@ typedef struct {
  * Used to preprocess WMS request parameters and combine layers that can
  * be comined in a GetMap request.
  */
-typedef  struct {
-  char        *onlineresource;
+typedef struct {
+  char *onlineresource;
   hashTableObj *params;
-  int          numparams;
-  char         *httpcookiedata;
+  int numparams;
+  char *httpcookiedata;
 } wmsParamsObj;
 
-/* metadataParamsObj: Represent a metadata specific request with its enabled layers */
+/* metadataParamsObj: Represent a metadata specific request with its enabled
+ * layers */
 typedef struct {
   char *pszRequest;
   char *pszLayer;
@@ -139,122 +140,146 @@ typedef struct {
   void *document; /* xmlDocPtr or CPLXMLNode* */
 } owsRequestObj;
 
-MS_DLL_EXPORT int msOWSDispatch(mapObj *map, cgiRequestObj *request, int ows_mode);
-
-MS_DLL_EXPORT const char * msOWSLookupMetadata(hashTableObj *metadata,
-    const char *namespaces, const char *name);
-MS_DLL_EXPORT const char * msOWSLookupMetadataWithLanguage(hashTableObj *metadata,
-    const char *namespaces, const char *name, const char *validated_language);
-MS_DLL_EXPORT const char * msOWSLookupMetadata2(hashTableObj *pri,
-    hashTableObj *sec,
-    const char *namespaces,
-    const char *name);
+MS_DLL_EXPORT int msOWSDispatch(mapObj *map, cgiRequestObj *request,
+                                int ows_mode);
 
-MS_DLL_EXPORT int msUpdateGMLFieldMetadata(layerObj *layer, const char *field_name,
-    const char *gml_type, const char *gml_width, const char *gml_precision, const short nullable);
+MS_DLL_EXPORT const char *msOWSLookupMetadata(hashTableObj *metadata,
+                                              const char *namespaces,
+                                              const char *name);
+MS_DLL_EXPORT const char *
+msOWSLookupMetadataWithLanguage(hashTableObj *metadata, const char *namespaces,
+                                const char *name,
+                                const char *validated_language);
+MS_DLL_EXPORT const char *msOWSLookupMetadata2(hashTableObj *pri,
+                                               hashTableObj *sec,
+                                               const char *namespaces,
+                                               const char *name);
+
+MS_DLL_EXPORT int
+msUpdateGMLFieldMetadata(layerObj *layer, const char *field_name,
+                         const char *gml_type, const char *gml_width,
+                         const char *gml_precision, const short nullable);
 
 void msOWSInitRequestObj(owsRequestObj *ows_request);
 void msOWSClearRequestObj(owsRequestObj *ows_request);
 
 MS_DLL_EXPORT int msOWSRequestIsEnabled(mapObj *map, layerObj *layer,
-                                        const char *namespaces, const char *name, int check_all_layers);
-MS_DLL_EXPORT void msOWSRequestLayersEnabled(mapObj *map, const char *namespaces,
-    const char *request, owsRequestObj *request_layers);
-MS_DLL_EXPORT int msOWSParseRequestMetadata(const char *metadata, const char *request,
-    int *disabled);
+                                        const char *namespaces,
+                                        const char *name, int check_all_layers);
+MS_DLL_EXPORT void msOWSRequestLayersEnabled(mapObj *map,
+                                             const char *namespaces,
+                                             const char *request,
+                                             owsRequestObj *request_layers);
+MS_DLL_EXPORT int msOWSParseRequestMetadata(const char *metadata,
+                                            const char *request, int *disabled);
 
 /* Constants for OWS Service version numbers */
-#define OWS_0_1_2   0x000102
-#define OWS_0_1_4   0x000104
-#define OWS_0_1_6   0x000106
-#define OWS_0_1_7   0x000107
-#define OWS_1_0_0   0x010000
-#define OWS_1_0_1   0x010001
-#define OWS_1_0_6   0x010006
-#define OWS_1_0_7   0x010007
-#define OWS_1_0_8   0x010008
-#define OWS_1_1_0   0x010100
-#define OWS_1_1_1   0x010101
-#define OWS_1_1_2   0x010102
-#define OWS_1_3_0   0x010300
-#define OWS_2_0_0   0x020000
-#define OWS_2_0_1   0x020001
-#define OWS_VERSION_MAXLEN   20  /* Buffer size for msOWSGetVersionString() */
-#define OWS_VERSION_NOTSET    -1
+#define OWS_0_1_2 0x000102
+#define OWS_0_1_4 0x000104
+#define OWS_0_1_6 0x000106
+#define OWS_0_1_7 0x000107
+#define OWS_1_0_0 0x010000
+#define OWS_1_0_1 0x010001
+#define OWS_1_0_6 0x010006
+#define OWS_1_0_7 0x010007
+#define OWS_1_0_8 0x010008
+#define OWS_1_1_0 0x010100
+#define OWS_1_1_1 0x010101
+#define OWS_1_1_2 0x010102
+#define OWS_1_3_0 0x010300
+#define OWS_2_0_0 0x020000
+#define OWS_2_0_1 0x020001
+#define OWS_VERSION_MAXLEN 20 /* Buffer size for msOWSGetVersionString() */
+#define OWS_VERSION_NOTSET -1
 #define OWS_VERSION_BADFORMAT -2
 
 MS_DLL_EXPORT int msOWSParseVersionString(const char *pszVersion);
 MS_DLL_EXPORT const char *msOWSGetVersionString(int nVersion, char *pszBuffer);
 
 MS_DLL_EXPORT const char *msOWSGetLanguage(mapObj *map, const char *context);
-MS_DLL_EXPORT char *msOWSGetOnlineResource(mapObj *map, const char *namespaces, const char *metadata_name, cgiRequestObj *req);
+MS_DLL_EXPORT char *msOWSGetOnlineResource(mapObj *map, const char *namespaces,
+                                           const char *metadata_name,
+                                           cgiRequestObj *req);
 MS_DLL_EXPORT const char *msOWSGetSchemasLocation(mapObj *map);
 MS_DLL_EXPORT char *msOWSTerminateOnlineResource(const char *src_url);
 
-void msOWSGetEPSGProj(projectionObj *proj, hashTableObj *metadata, const char *namespaces, int bReturnOnlyFirstOne, char **epsgProj);
+void msOWSGetEPSGProj(projectionObj *proj, hashTableObj *metadata,
+                      const char *namespaces, int bReturnOnlyFirstOne,
+                      char **epsgProj);
 void msOWSProjectToWGS84(projectionObj *srcproj, rectObj *ext);
 
-#if defined(USE_WMS_SVR) || defined (USE_WFS_SVR) || defined (USE_WCS_SVR) || defined(USE_SOS_SVR) || defined(USE_WMS_LYR) || defined(USE_WFS_LYR)
+#if defined(USE_WMS_SVR) || defined(USE_WFS_SVR) || defined(USE_WCS_SVR) ||    \
+    defined(USE_SOS_SVR) || defined(USE_WMS_LYR) || defined(USE_WFS_LYR)
 
 MS_DLL_EXPORT int msOWSMakeAllLayersUnique(mapObj *map);
-MS_DLL_EXPORT int msOWSNegotiateVersion(int requested_version, const int supported_versions[], int num_supported_versions);
-MS_DLL_EXPORT char *msOWSGetOnlineResource2(mapObj *map, const char *namespaces, const char *metadata_name, cgiRequestObj *req, const char *validated_language);
+MS_DLL_EXPORT int msOWSNegotiateVersion(int requested_version,
+                                        const int supported_versions[],
+                                        int num_supported_versions);
+MS_DLL_EXPORT char *msOWSGetOnlineResource2(mapObj *map, const char *namespaces,
+                                            const char *metadata_name,
+                                            cgiRequestObj *req,
+                                            const char *validated_language);
 MS_DLL_EXPORT const char *msOWSGetInspireSchemasLocation(mapObj *map);
-MS_DLL_EXPORT char **msOWSGetLanguageList(mapObj *map, const char *namespaces, int *numitems);
-MS_DLL_EXPORT char *msOWSGetLanguageFromList(mapObj *map, const char *namespaces, const char *requested_language);
-MS_DLL_EXPORT char *msOWSLanguageNegotiation(mapObj *map, const char *namespaces, char **accept_languages, int num_accept_languages);
-
+MS_DLL_EXPORT char **msOWSGetLanguageList(mapObj *map, const char *namespaces,
+                                          int *numitems);
+MS_DLL_EXPORT char *msOWSGetLanguageFromList(mapObj *map,
+                                             const char *namespaces,
+                                             const char *requested_language);
+MS_DLL_EXPORT char *msOWSLanguageNegotiation(mapObj *map,
+                                             const char *namespaces,
+                                             char **accept_languages,
+                                             int num_accept_languages);
 
 /* OWS_NOERR and OWS_WARN passed as action_if_not_found to printMetadata() */
-#define OWS_NOERR   0
-#define OWS_WARN    1
+#define OWS_NOERR 0
+#define OWS_WARN 1
 
 /* OWS_WMS and OWS_WFS used for functions that differ in behavior between */
 /* WMS and WFS services (e.g. msOWSPrintLatLonBoundingBox()) */
-typedef enum
-{
-    OWS_WMS = 1,
-    OWS_WFS = 2,
-    OWS_WCS = 3
-} OWSServiceType;
-
-MS_DLL_EXPORT int msOWSPrintInspireCommonExtendedCapabilities(FILE *stream, mapObj *map, const char *namespaces,
-    int action_if_not_found, const char *tag_name, const char* tag_ns,
-    const char *validated_language, const OWSServiceType service);
-int msOWSPrintInspireCommonMetadata(FILE *stream, mapObj *map, const char *namespaces,
-                                    int action_if_not_found, const OWSServiceType service);
-int msOWSPrintInspireCommonLanguages(FILE *stream, mapObj *map, const char *namespaces,
-                                     int action_if_not_found, const char *validated_language);
+typedef enum { OWS_WMS = 1, OWS_WFS = 2, OWS_WCS = 3 } OWSServiceType;
+
+MS_DLL_EXPORT int msOWSPrintInspireCommonExtendedCapabilities(
+    FILE *stream, mapObj *map, const char *namespaces, int action_if_not_found,
+    const char *tag_name, const char *tag_ns, const char *validated_language,
+    const OWSServiceType service);
+int msOWSPrintInspireCommonMetadata(FILE *stream, mapObj *map,
+                                    const char *namespaces,
+                                    int action_if_not_found,
+                                    const OWSServiceType service);
+int msOWSPrintInspireCommonLanguages(FILE *stream, mapObj *map,
+                                     const char *namespaces,
+                                     int action_if_not_found,
+                                     const char *validated_language);
 
 MS_DLL_EXPORT int msOWSPrintMetadata(FILE *stream, hashTableObj *metadata,
                                      const char *namespaces, const char *name,
-                                     int action_if_not_found, const char *format,
+                                     int action_if_not_found,
+                                     const char *format,
                                      const char *default_value);
 int msOWSPrintEncodeMetadata(FILE *stream, hashTableObj *metadata,
                              const char *namespaces, const char *name,
-                             int action_if_not_found,
-                             const char *format, const char *default_value) ;
+                             int action_if_not_found, const char *format,
+                             const char *default_value);
 int msOWSPrintEncodeMetadata2(FILE *stream, hashTableObj *metadata,
                               const char *namespaces, const char *name,
-                              int action_if_not_found,
-                              const char *format, const char *default_value,
+                              int action_if_not_found, const char *format,
+                              const char *default_value,
                               const char *validated_language);
-char *msOWSGetEncodeMetadata(hashTableObj *metadata,
-                             const char *namespaces, const char *name,
-                             const char *default_value);
+char *msOWSGetEncodeMetadata(hashTableObj *metadata, const char *namespaces,
+                             const char *name, const char *default_value);
 
 int msOWSPrintValidateMetadata(FILE *stream, hashTableObj *metadata,
                                const char *namespaces, const char *name,
-                               int action_if_not_found,
-                               const char *format, const char *default_value);
-int msOWSPrintGroupMetadata(FILE *stream, mapObj *map, char* pszGroupName,
+                               int action_if_not_found, const char *format,
+                               const char *default_value);
+int msOWSPrintGroupMetadata(FILE *stream, mapObj *map, char *pszGroupName,
                             const char *namespaces, const char *name,
-                            int action_if_not_found,
-                            const char *format, const char *default_value);
-int msOWSPrintGroupMetadata2(FILE *stream, mapObj *map, char* pszGroupName,
+                            int action_if_not_found, const char *format,
+                            const char *default_value);
+int msOWSPrintGroupMetadata2(FILE *stream, mapObj *map, char *pszGroupName,
                              const char *namespaces, const char *name,
-                             int action_if_not_found,
-                             const char *format, const char *default_value,
+                             int action_if_not_found, const char *format,
+                             const char *default_value,
                              const char *validated_language);
 int msOWSPrintURLType(FILE *stream, hashTableObj *metadata,
                       const char *namespaces, const char *name,
@@ -276,70 +301,70 @@ int msOWSPrintEncodeParam(FILE *stream,
                           const char *default_value);
 int msOWSPrintMetadataList(FILE *stream, hashTableObj *metadata,
                            const char *namespaces, const char *name,
-                           const char *startTag,
-                           const char *endTag, const char *itemFormat,
-                           const char *default_value);
+                           const char *startTag, const char *endTag,
+                           const char *itemFormat, const char *default_value);
 int msOWSPrintEncodeMetadataList(FILE *stream, hashTableObj *metadata,
                                  const char *namespaces, const char *name,
-                                 const char *startTag,
-                                 const char *endTag, const char *itemFormat,
+                                 const char *startTag, const char *endTag,
+                                 const char *itemFormat,
                                  const char *default_value);
-int msOWSPrintEncodeParamList(FILE *stream, const char *name,
-                              const char *value, int action_if_not_found,
-                              char delimiter, const char *startTag,
-                              const char *endTag, const char *format,
-                              const char *default_value);
+int msOWSPrintEncodeParamList(FILE *stream, const char *name, const char *value,
+                              int action_if_not_found, char delimiter,
+                              const char *startTag, const char *endTag,
+                              const char *format, const char *default_value);
 void msOWSPrintLatLonBoundingBox(FILE *stream, const char *tabspace,
                                  rectObj *extent, projectionObj *srcproj,
-                                 projectionObj *wfsproj, OWSServiceType nService);
+                                 projectionObj *wfsproj,
+                                 OWSServiceType nService);
 void msOWSPrintEX_GeographicBoundingBox(FILE *stream, const char *tabspace,
-                                        rectObj *extent, projectionObj *srcproj);
+                                        rectObj *extent,
+                                        projectionObj *srcproj);
 
-void msOWSPrintBoundingBox(FILE *stream, const char *tabspace,
-                           rectObj *extent,
-                           projectionObj *srcproj,
-                           hashTableObj *layer_meta,
-                           hashTableObj *map_meta,
-                           const char *namespaces,
+void msOWSPrintBoundingBox(FILE *stream, const char *tabspace, rectObj *extent,
+                           projectionObj *srcproj, hashTableObj *layer_meta,
+                           hashTableObj *map_meta, const char *namespaces,
                            int wms_version);
-void msOWSPrintContactInfo( FILE *stream, const char *tabspace,
-                            int nVersion, hashTableObj *metadata,
-                            const char *namespaces  );
-int msOWSGetLayerExtent(mapObj *map, layerObj *lp, const char *namespaces, rectObj *ext);
+void msOWSPrintContactInfo(FILE *stream, const char *tabspace, int nVersion,
+                           hashTableObj *metadata, const char *namespaces);
+int msOWSGetLayerExtent(mapObj *map, layerObj *lp, const char *namespaces,
+                        rectObj *ext);
 
 int msOWSExecuteRequests(httpRequestObj *pasReqInfo, int numRequests,
                          mapObj *map, int bCheckLocalCache);
 
-void msOWSProcessException(layerObj *lp, const char *pszFname,
-                           int nErrorCode, const char *pszFuncName);
+void msOWSProcessException(layerObj *lp, const char *pszFname, int nErrorCode,
+                           const char *pszFuncName);
 char *msOWSBuildURLFilename(const char *pszPath, const char *pszURL,
                             const char *pszExt);
-char *msOWSGetProjURN(projectionObj *proj, hashTableObj *metadata, const char *namespaces, int bReturnOnlyFirstOne);
-char *msOWSGetProjURI(projectionObj *proj, hashTableObj *metadata, const char *namespaces, int bReturnOnlyFirstOne);
+char *msOWSGetProjURN(projectionObj *proj, hashTableObj *metadata,
+                      const char *namespaces, int bReturnOnlyFirstOne);
+char *msOWSGetProjURI(projectionObj *proj, hashTableObj *metadata,
+                      const char *namespaces, int bReturnOnlyFirstOne);
 
 void msOWSGetDimensionInfo(layerObj *layer, const char *pszDimension,
                            const char **pszDimUserValue,
-                           const char **pszDimUnits,
-                           const char **pszDimDefault,
+                           const char **pszDimUnits, const char **pszDimDefault,
                            const char **pszDimNearValue,
                            const char **pszDimUnitSymbol,
                            const char **pszDimMultiValue);
 
-int msOWSNegotiateUpdateSequence(const char *requested_updateSequence, const char *updatesequence);
+int msOWSNegotiateUpdateSequence(const char *requested_updateSequence,
+                                 const char *updatesequence);
 
-outputFormatObj *msOwsIsOutputFormatValid(mapObj *map, const char *format, hashTableObj *metadata,
-    const char *namespaces, const char *name);
+outputFormatObj *msOwsIsOutputFormatValid(mapObj *map, const char *format,
+                                          hashTableObj *metadata,
+                                          const char *namespaces,
+                                          const char *name);
 #endif /* #if any wxs service enabled */
 
 /*====================================================================
  *   mapgml.c
  *====================================================================*/
 
-typedef enum
-{
-    OWS_GML2, /* 2.1.2 */
-    OWS_GML3, /* 3.1.1 */
-    OWS_GML32 /* 3.2.1 */
+typedef enum {
+  OWS_GML2, /* 2.1.2 */
+  OWS_GML3, /* 3.1.1 */
+  OWS_GML32 /* 3.2.1 */
 } OWSGMLVersion;
 
 #define OWS_WFS_FEATURE_COLLECTION_NAME "msFeatureCollection"
@@ -349,20 +374,27 @@ typedef enum
 /* TODO, there must be a better way to generalize these lists of objects... */
 
 typedef struct {
-  char *name;     /* name of the item */
-  char *alias;    /* is the item aliased for presentation? (NULL if not) */
-  char *type;     /* raw type for this item (NULL for a "string") (TODO: should this be a lookup table instead?) */
+  char *name;  /* name of the item */
+  char *alias; /* is the item aliased for presentation? (NULL if not) */
+  char *type; /* raw type for this item (NULL for a "string") (TODO: should this
+                 be a lookup table instead?) */
 #ifndef __cplusplus
-  char *template;  /* presentation string for this item, needs to be a complete XML tag */
+  char *template; /* presentation string for this item, needs to be a complete
+                     XML tag */
 #else
-  char *_template;  /* presentation string for this item, needs to be a complete XML tag */
+  char *_template; /* presentation string for this item, needs to be a complete
+                      XML tag */
 #endif
-  int encode;     /* should the value be HTML encoded? Default is MS_TRUE */
-  int visible;    /* should this item be output, default is MS_FALSE */
-  int width;      /* field width, zero if unknown */
-  int precision;  /* field precision (decimal places), zero if unknown or N/A */
-  int outputByDefault; /* whether this should be output in a GetFeature without PropertyName. MS_TRUE by default, unless gml_default_items is specified and the item name is not in it */
-  int minOccurs;  /* 0 by default. Can be set to 1 by specifying item name in gml_mandatory_items */
+  int encode;    /* should the value be HTML encoded? Default is MS_TRUE */
+  int visible;   /* should this item be output, default is MS_FALSE */
+  int width;     /* field width, zero if unknown */
+  int precision; /* field precision (decimal places), zero if unknown or N/A */
+  int outputByDefault; /* whether this should be output in a GetFeature without
+                          PropertyName. MS_TRUE by default, unless
+                          gml_default_items is specified and the item name is
+                          not in it */
+  int minOccurs; /* 0 by default. Can be set to 1 by specifying item name in
+                    gml_mandatory_items */
 } gmlItemObj;
 
 typedef struct {
@@ -371,9 +403,10 @@ typedef struct {
 } gmlItemListObj;
 
 typedef struct {
-  char *name;     /* name of the constant */
-  char *type;     /* raw type for this item (NULL for a "string") */
-  char *value;    /* output value for this constant (output will look like: <name>value</name>) */
+  char *name;  /* name of the constant */
+  char *type;  /* raw type for this item (NULL for a "string") */
+  char *value; /* output value for this constant (output will look like:
+                  <name>value</name>) */
 } gmlConstantObj;
 
 typedef struct {
@@ -382,9 +415,10 @@ typedef struct {
 } gmlConstantListObj;
 
 typedef struct {
-  char *name;     /* name of the geometry (type of GML property) */
-  char *type;     /* raw type for these geometries (point|multipoint|line|multiline|polygon|multipolygon */
-  int occurmin, occurmax;   /* number of occurances (default 0,1) */
+  char *name;             /* name of the geometry (type of GML property) */
+  char *type;             /* raw type for these geometries
+                             (point|multipoint|line|multiline|polygon|multipolygon */
+  int occurmin, occurmax; /* number of occurances (default 0,1) */
 } gmlGeometryObj;
 
 typedef struct {
@@ -393,10 +427,10 @@ typedef struct {
 } gmlGeometryListObj;
 
 typedef struct {
-  char *name;     /* name of the group */
-  char **items;   /* list of items in the group */
-  int numitems;   /* number of items */
-  char *type;     /* name of the complex type */
+  char *name;   /* name of the group */
+  char **items; /* list of items in the group */
+  int numitems; /* number of items */
+  char *type;   /* name of the complex type */
 } gmlGroupObj;
 
 typedef struct {
@@ -415,52 +449,62 @@ typedef struct {
   int numnamespaces;
 } gmlNamespaceListObj;
 
-MS_DLL_EXPORT gmlItemListObj *msGMLGetItems(layerObj *layer, const char *metadata_namespaces);
+MS_DLL_EXPORT gmlItemListObj *msGMLGetItems(layerObj *layer,
+                                            const char *metadata_namespaces);
 MS_DLL_EXPORT void msGMLFreeItems(gmlItemListObj *itemList);
 
-#if defined(USE_WMS_SVR) || defined (USE_WFS_SVR)
+#if defined(USE_WMS_SVR) || defined(USE_WFS_SVR)
 
 MS_DLL_EXPORT int msItemInGroups(const char *name, gmlGroupListObj *groupList);
-MS_DLL_EXPORT gmlConstantListObj *msGMLGetConstants(layerObj *layer, const char *metadata_namespaces);
+MS_DLL_EXPORT gmlConstantListObj *
+msGMLGetConstants(layerObj *layer, const char *metadata_namespaces);
 MS_DLL_EXPORT void msGMLFreeConstants(gmlConstantListObj *constantList);
-MS_DLL_EXPORT gmlGeometryListObj *msGMLGetGeometries(layerObj *layer, const char *metadata_namespaces, int bWithDefaultGeom);
+MS_DLL_EXPORT gmlGeometryListObj *
+msGMLGetGeometries(layerObj *layer, const char *metadata_namespaces,
+                   int bWithDefaultGeom);
 MS_DLL_EXPORT void msGMLFreeGeometries(gmlGeometryListObj *geometryList);
-MS_DLL_EXPORT gmlNamespaceListObj *msGMLGetNamespaces(webObj *web, const char *metadata_namespaces);
+MS_DLL_EXPORT gmlNamespaceListObj *
+msGMLGetNamespaces(webObj *web, const char *metadata_namespaces);
 MS_DLL_EXPORT void msGMLFreeNamespaces(gmlNamespaceListObj *namespaceList);
 #endif
 
-MS_DLL_EXPORT gmlGroupListObj *msGMLGetGroups(layerObj *layer, const char *metadata_namespaces);
+MS_DLL_EXPORT gmlGroupListObj *msGMLGetGroups(layerObj *layer,
+                                              const char *metadata_namespaces);
 MS_DLL_EXPORT void msGMLFreeGroups(gmlGroupListObj *groupList);
 
 /* export to fix bug 851 */
-MS_DLL_EXPORT int msGMLWriteQuery(mapObj *map, char *filename, const char *namespaces);
-
+MS_DLL_EXPORT int msGMLWriteQuery(mapObj *map, char *filename,
+                                  const char *namespaces);
 
 #ifdef USE_WFS_SVR
 
 void msGMLWriteWFSBounds(mapObj *map, FILE *stream, const char *tab,
-                         OWSGMLVersion outputformat, int nWFSVersion, int bUseURN);
+                         OWSGMLVersion outputformat, int nWFSVersion,
+                         int bUseURN);
 
-MS_DLL_EXPORT int msGMLWriteWFSQuery(mapObj *map, FILE *stream, const char *wfs_namespace,
-                                     OWSGMLVersion outputformat, int nWFSVersion, int bUseURN,
+MS_DLL_EXPORT int msGMLWriteWFSQuery(mapObj *map, FILE *stream,
+                                     const char *wfs_namespace,
+                                     OWSGMLVersion outputformat,
+                                     int nWFSVersion, int bUseURN,
                                      int bGetPropertyValueRequest);
 #endif
 
-
 /*====================================================================
  *   mapwms.c
  *====================================================================*/
-int msWMSDispatch(mapObj *map, cgiRequestObj *req, owsRequestObj *ows_request, int force_wms_mode);
-MS_DLL_EXPORT int msWMSLoadGetMapParams(mapObj *map, int nVersion,
-                                        char **names, char **values, int numentries,
-                                        const char *wms_exception_format, const char *wms_request, owsRequestObj *ows_request);
-
+int msWMSDispatch(mapObj *map, cgiRequestObj *req, owsRequestObj *ows_request,
+                  int force_wms_mode);
+MS_DLL_EXPORT int msWMSLoadGetMapParams(mapObj *map, int nVersion, char **names,
+                                        char **values, int numentries,
+                                        const char *wms_exception_format,
+                                        const char *wms_request,
+                                        owsRequestObj *ows_request);
 
 /*====================================================================
  *   mapwmslayer.c
  *====================================================================*/
 
-#define WMS_GETMAP         1
+#define WMS_GETMAP 1
 #define WMS_GETFEATUREINFO 2
 #define WMS_GETLEGENDGRAPHIC 3
 
@@ -468,18 +512,21 @@ int msInitWmsParamsObj(wmsParamsObj *wms
 void msFreeWmsParamsObj(wmsParamsObj *wmsparams);
 
 int msPrepareWMSLayerRequest(int nLayerId, mapObj *map, layerObj *lp,
-                             int nRequestType, enum MS_CONNECTION_TYPE lastconnectiontype,
-                             wmsParamsObj *psLastWMSParams,
-                             int nClickX, int nClickY, int nFeatureCount, const char *pszInfoFormat,
+                             int nRequestType,
+                             enum MS_CONNECTION_TYPE lastconnectiontype,
+                             wmsParamsObj *psLastWMSParams, int nClickX,
+                             int nClickY, int nFeatureCount,
+                             const char *pszInfoFormat,
                              httpRequestObj *pasReqInfo, int *numRequests);
-int msDrawWMSLayerLow(int nLayerId, httpRequestObj *pasReqInfo,
-                      int numRequests, mapObj *map, layerObj *lp,
-                      imageObj *img);
+int msDrawWMSLayerLow(int nLayerId, httpRequestObj *pasReqInfo, int numRequests,
+                      mapObj *map, layerObj *lp, imageObj *img);
 MS_DLL_EXPORT char *msWMSGetFeatureInfoURL(mapObj *map, layerObj *lp,
-    int nClickX, int nClickY, int nFeatureCount,
-    const char *pszInfoFormat);
-int msWMSLayerExecuteRequest(mapObj *map, int nOWSLayers, int nClickX, int nClickY,
-                             int nFeatureCount, const char *pszInfoFormat, int type);
+                                           int nClickX, int nClickY,
+                                           int nFeatureCount,
+                                           const char *pszInfoFormat);
+int msWMSLayerExecuteRequest(mapObj *map, int nOWSLayers, int nClickX,
+                             int nClickY, int nFeatureCount,
+                             const char *pszInfoFormat, int type);
 
 /*====================================================================
  *   mapmetadata.c
@@ -497,7 +544,8 @@ void msMetadataSetGetMetadataURL(layerOb
 MS_DLL_EXPORT int msWFSDispatch(mapObj *map, cgiRequestObj *requestobj,
                                 owsRequestObj *ows_request, int force_wfs_mode);
 wfsParamsObj *msWFSCreateParamsObj(void);
-int msWFSHandleUpdateSequence(mapObj *map, wfsParamsObj *wfsparams, const char* pszFunction);
+int msWFSHandleUpdateSequence(mapObj *map, wfsParamsObj *wfsparams,
+                              const char *pszFunction);
 void msWFSFreeParamsObj(wfsParamsObj *wfsparams);
 int msWFSIsLayerSupported(layerObj *lp);
 int msWFSException(mapObj *map, const char *locator, const char *code,
@@ -512,7 +560,7 @@ int msWFSGetCapabilities11(mapObj *map,
                            cgiRequestObj *req, owsRequestObj *ows_request);
 #ifdef USE_LIBXML2
 xmlNodePtr msWFSDumpLayer11(mapObj *map, layerObj *lp, xmlNsPtr psNsOws,
-                            int nWFSVersion, const char* validate_language,
+                            int nWFSVersion, const char *validate_language,
                             char *script_url);
 #endif
 char *msWFSGetOutputFormatList(mapObj *map, layerObj *layer, int nWFSVersion);
@@ -524,10 +572,8 @@ int msWFSGetCapabilities20(mapObj *map,
 int msWFSListStoredQueries20(mapObj *map, owsRequestObj *ows_request);
 int msWFSDescribeStoredQueries20(mapObj *map, wfsParamsObj *params,
                                  owsRequestObj *ows_request);
-char* msWFSGetResolvedStoredQuery20(mapObj *map,
-                                    wfsParamsObj *wfsparams,
-                                    const char* id,
-                                    hashTableObj* hashTable);
+char *msWFSGetResolvedStoredQuery20(mapObj *map, wfsParamsObj *wfsparams,
+                                    const char *id, hashTableObj *hashTable);
 
 #endif
 
@@ -538,8 +584,8 @@ char* msWFSGetResolvedStoredQuery20(mapO
 int msPrepareWFSLayerRequest(int nLayerId, mapObj *map, layerObj *lp,
                              httpRequestObj *pasReqInfo, int *numRequests);
 void msWFSUpdateRequestInfo(layerObj *lp, httpRequestObj *pasReqInfo);
-int msWFSLayerOpen(layerObj *lp,
-                   const char *pszGMLFilename, rectObj *defaultBBOX);
+int msWFSLayerOpen(layerObj *lp, const char *pszGMLFilename,
+                   rectObj *defaultBBOX);
 int msWFSLayerIsOpen(layerObj *lp);
 int msWFSLayerInitItemInfo(layerObj *layer);
 int msWFSLayerGetItems(layerObj *layer);
@@ -553,27 +599,27 @@ MS_DLL_EXPORT char *msWFSExecuteGetFeatu
 
 MS_DLL_EXPORT int msWriteMapContext(mapObj *map, FILE *stream);
 MS_DLL_EXPORT int msSaveMapContext(mapObj *map, char *filename);
-MS_DLL_EXPORT int msLoadMapContext(mapObj *map, const char *filename, int unique_layer_names);
-MS_DLL_EXPORT int msLoadMapContextURL(mapObj *map, char *urlfilename, int unique_layer_names);
-
+MS_DLL_EXPORT int msLoadMapContext(mapObj *map, const char *filename,
+                                   int unique_layer_names);
+MS_DLL_EXPORT int msLoadMapContextURL(mapObj *map, char *urlfilename,
+                                      int unique_layer_names);
 
 /*====================================================================
  *   mapwcs.c
  *====================================================================*/
 
-int msWCSDispatch(mapObj *map, cgiRequestObj *requestobj, owsRequestObj *ows_request); /* only 1 public function */
-
-
+int msWCSDispatch(mapObj *map, cgiRequestObj *requestobj,
+                  owsRequestObj *ows_request); /* only 1 public function */
 
 /*====================================================================
  *   mapogsos.c
  *====================================================================*/
 
-int msSOSDispatch(mapObj *map, cgiRequestObj *requestobj, owsRequestObj *ows_request); /* only 1 public function */
+int msSOSDispatch(mapObj *map, cgiRequestObj *requestobj,
+                  owsRequestObj *ows_request); /* only 1 public function */
 
 #ifdef __cplusplus
 } /* extern "C" */
 #endif
 
 #endif /* MAPOWS_H */
-
diff -pruN 8.0.1-5/mapowscommon.c 8.0.2-1/mapowscommon.c
--- 8.0.1-5/mapowscommon.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapowscommon.c	2024-06-11 20:41:34.000000000 +0000
@@ -36,16 +36,12 @@
 
 #ifdef USE_LIBXML2
 
-#include<libxml/parser.h>
-#include<libxml/tree.h>
+#include <libxml/parser.h>
+#include <libxml/tree.h>
 
 #include "mapowscommon.h"
 #include "maplibxml2.h"
 
-
-
-
-
 /**
  * msOWSCommonServiceIdentification()
  *
@@ -66,38 +62,50 @@ xmlNodePtr msOWSCommonServiceIdentificat
                                             const char *servicetype,
                                             const char *supported_versions,
                                             const char *namespaces,
-                                            const char *validated_language)
-{
-  const char *value    = NULL;
+                                            const char *validated_language) {
+  const char *value = NULL;
 
-  xmlNodePtr   psRootNode = NULL;
-  xmlNodePtr   psNode     = NULL;
+  xmlNodePtr psRootNode = NULL;
+  xmlNodePtr psNode = NULL;
 
   if (_validateNamespace(psNsOws) == MS_FAILURE)
-    psNsOws = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_PREFIX);
+    psNsOws = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_URI,
+                       BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_PREFIX);
 
   /* create element name */
   psRootNode = xmlNewNode(psNsOws, BAD_CAST "ServiceIdentification");
 
   /* add child elements */
 
-  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces, "title", validated_language);
+  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces,
+                                          "title", validated_language);
 
-  psNode = xmlNewTextChild(psRootNode, psNsOws, BAD_CAST "Title", BAD_CAST value);
+  psNode =
+      xmlNewTextChild(psRootNode, psNsOws, BAD_CAST "Title", BAD_CAST value);
 
   if (!value) {
-    xmlAddSibling(psNode, xmlNewComment(BAD_CAST "WARNING: Optional metadata \"ows_title\" missing for ows:Title"));
+    xmlAddSibling(
+        psNode,
+        xmlNewComment(
+            BAD_CAST
+            "WARNING: Optional metadata \"ows_title\" missing for ows:Title"));
   }
 
-  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces, "abstract", validated_language);
+  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces,
+                                          "abstract", validated_language);
 
-  psNode = xmlNewTextChild(psRootNode, psNsOws, BAD_CAST "Abstract", BAD_CAST value);
+  psNode =
+      xmlNewTextChild(psRootNode, psNsOws, BAD_CAST "Abstract", BAD_CAST value);
 
   if (!value) {
-    xmlAddSibling(psNode, xmlNewComment(BAD_CAST "WARNING: Optional metadata \"ows_abstract\" was missing for ows:Abstract"));
+    xmlAddSibling(psNode,
+                  xmlNewComment(BAD_CAST
+                                "WARNING: Optional metadata \"ows_abstract\" "
+                                "was missing for ows:Abstract"));
   }
 
-  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces, "keywordlist", validated_language);
+  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces,
+                                          "keywordlist", validated_language);
 
   if (value) {
     psNode = xmlNewTextChild(psRootNode, psNsOws, BAD_CAST "Keywords", NULL);
@@ -105,29 +113,46 @@ xmlNodePtr msOWSCommonServiceIdentificat
   }
 
   else {
-    xmlAddSibling(psNode, xmlNewComment(BAD_CAST "WARNING: Optional metadata \"ows_keywordlist\" was missing for ows:KeywordList"));
+    xmlAddSibling(
+        psNode,
+        xmlNewComment(BAD_CAST "WARNING: Optional metadata \"ows_keywordlist\" "
+                               "was missing for ows:KeywordList"));
   }
 
-  psNode = xmlNewTextChild(psRootNode, psNsOws, BAD_CAST "ServiceType", BAD_CAST servicetype);
+  psNode = xmlNewTextChild(psRootNode, psNsOws, BAD_CAST "ServiceType",
+                           BAD_CAST servicetype);
 
   xmlNewProp(psNode, BAD_CAST "codeSpace", BAD_CAST MS_OWSCOMMON_OGC_CODESPACE);
 
-  msLibXml2GenerateList(psRootNode, psNsOws, "ServiceTypeVersion", supported_versions, ',');
+  msLibXml2GenerateList(psRootNode, psNsOws, "ServiceTypeVersion",
+                        supported_versions, ',');
 
-  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces, "fees", validated_language);
+  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces,
+                                          "fees", validated_language);
 
-  psNode = xmlNewTextChild(psRootNode, psNsOws, BAD_CAST "Fees", BAD_CAST value);
+  psNode =
+      xmlNewTextChild(psRootNode, psNsOws, BAD_CAST "Fees", BAD_CAST value);
 
   if (!value) {
-    xmlAddSibling(psNode, xmlNewComment(BAD_CAST "WARNING: Optional metadata \"ows_fees\" was missing for ows:Fees"));
+    xmlAddSibling(psNode,
+                  xmlNewComment(BAD_CAST
+                                "WARNING: Optional metadata \"ows_fees\" was "
+                                "missing for ows:Fees"));
   }
 
-  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces, "accessconstraints", validated_language);
+  value =
+      msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces,
+                                      "accessconstraints", validated_language);
 
-  psNode = xmlNewTextChild(psRootNode, psNsOws, BAD_CAST "AccessConstraints", BAD_CAST value);
+  psNode = xmlNewTextChild(psRootNode, psNsOws, BAD_CAST "AccessConstraints",
+                           BAD_CAST value);
 
   if (!value) {
-    xmlAddSibling(psNode, xmlNewComment(BAD_CAST "WARNING: Optional metadata \"ows_accessconstraints\" was missing for ows:AccessConstraints"));
+    xmlAddSibling(
+        psNode,
+        xmlNewComment(BAD_CAST
+                      "WARNING: Optional metadata \"ows_accessconstraints\" "
+                      "was missing for ows:AccessConstraints"));
   }
 
   return psRootNode;
@@ -150,169 +175,268 @@ xmlNodePtr msOWSCommonServiceIdentificat
 
 xmlNodePtr msOWSCommonServiceProvider(xmlNsPtr psNsOws, xmlNsPtr psNsXLink,
                                       mapObj *map, const char *namespaces,
-                                      const char *validated_language)
-{
+                                      const char *validated_language) {
   const char *value = NULL;
 
-  xmlNodePtr   psNode          = NULL;
-  xmlNodePtr   psRootNode      = NULL;
-  xmlNodePtr   psSubNode       = NULL;
-  xmlNodePtr   psSubSubNode    = NULL;
-  xmlNodePtr   psSubSubSubNode = NULL;
+  xmlNodePtr psNode = NULL;
+  xmlNodePtr psRootNode = NULL;
+  xmlNodePtr psSubNode = NULL;
+  xmlNodePtr psSubSubNode = NULL;
+  xmlNodePtr psSubSubSubNode = NULL;
 
   if (_validateNamespace(psNsOws) == MS_FAILURE)
-    psNsOws = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_PREFIX);
+    psNsOws = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_URI,
+                       BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_PREFIX);
 
   psRootNode = xmlNewNode(psNsOws, BAD_CAST "ServiceProvider");
 
   /* add child elements */
 
-  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces, "contactorganization", validated_language);
-
-  psNode = xmlNewTextChild(psRootNode, psNsOws, BAD_CAST "ProviderName", BAD_CAST value);
+  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces,
+                                          "contactorganization",
+                                          validated_language);
+
+  psNode = xmlNewTextChild(psRootNode, psNsOws, BAD_CAST "ProviderName",
+                           BAD_CAST value);
 
   if (!value) {
-    xmlAddSibling(psNode, xmlNewComment(BAD_CAST "WARNING: Mandatory metadata \"ows_contactorganization\" was missing for ows:ProviderName"));
+    xmlAddSibling(
+        psNode,
+        xmlNewComment(BAD_CAST
+                      "WARNING: Mandatory metadata \"ows_contactorganization\" "
+                      "was missing for ows:ProviderName"));
   }
 
   psNode = xmlNewTextChild(psRootNode, psNsOws, BAD_CAST "ProviderSite", NULL);
 
   xmlNewNsProp(psNode, psNsXLink, BAD_CAST "type", BAD_CAST "simple");
 
-  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces, "service_onlineresource", validated_language);
+  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces,
+                                          "service_onlineresource",
+                                          validated_language);
 
   xmlNewNsProp(psNode, psNsXLink, BAD_CAST "href", BAD_CAST value);
 
   if (!value) {
-    xmlAddSibling(psNode, xmlNewComment(BAD_CAST "WARNING: Optional metadata \"ows_service_onlineresource\" was missing for ows:ProviderSite/@xlink:href"));
+    xmlAddSibling(
+        psNode, xmlNewComment(
+                    BAD_CAST
+                    "WARNING: Optional metadata \"ows_service_onlineresource\" "
+                    "was missing for ows:ProviderSite/@xlink:href"));
   }
 
-  psNode = xmlNewTextChild(psRootNode, psNsOws, BAD_CAST "ServiceContact", NULL);
+  psNode =
+      xmlNewTextChild(psRootNode, psNsOws, BAD_CAST "ServiceContact", NULL);
 
-  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces, "contactperson", validated_language);
+  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces,
+                                          "contactperson", validated_language);
 
-  psSubNode = xmlNewTextChild(psNode, psNsOws, BAD_CAST "IndividualName", BAD_CAST  value);
+  psSubNode = xmlNewTextChild(psNode, psNsOws, BAD_CAST "IndividualName",
+                              BAD_CAST value);
 
   if (!value) {
-    xmlAddSibling(psSubNode, xmlNewComment(BAD_CAST "WARNING: Optional metadata \"ows_contactperson\" was missing for ows:IndividualName"));
+    xmlAddSibling(
+        psSubNode,
+        xmlNewComment(BAD_CAST
+                      "WARNING: Optional metadata \"ows_contactperson\" was "
+                      "missing for ows:IndividualName"));
   }
 
-  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces, "contactposition", validated_language);
+  value = msOWSLookupMetadataWithLanguage(
+      &(map->web.metadata), namespaces, "contactposition", validated_language);
 
-  psSubNode = xmlNewTextChild(psNode, psNsOws, BAD_CAST "PositionName", BAD_CAST value);
+  psSubNode =
+      xmlNewTextChild(psNode, psNsOws, BAD_CAST "PositionName", BAD_CAST value);
 
   if (!value) {
-    xmlAddSibling(psSubNode, xmlNewComment(BAD_CAST "WARNING: Optional metadata \"ows_contactposition\" was missing for ows:PositionName"));
+    xmlAddSibling(
+        psSubNode,
+        xmlNewComment(BAD_CAST
+                      "WARNING: Optional metadata \"ows_contactposition\" was "
+                      "missing for ows:PositionName"));
   }
 
   psSubNode = xmlNewTextChild(psNode, psNsOws, BAD_CAST "ContactInfo", NULL);
 
   psSubSubNode = xmlNewTextChild(psSubNode, psNsOws, BAD_CAST "Phone", NULL);
 
-  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces, "contactvoicetelephone", validated_language);
+  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces,
+                                          "contactvoicetelephone",
+                                          validated_language);
 
-  psSubSubSubNode = xmlNewTextChild(psSubSubNode, psNsOws, BAD_CAST "Voice", BAD_CAST value);
+  psSubSubSubNode =
+      xmlNewTextChild(psSubSubNode, psNsOws, BAD_CAST "Voice", BAD_CAST value);
 
   if (!value) {
-    xmlAddSibling(psSubSubSubNode, xmlNewComment(BAD_CAST "WARNING: Optional metadata \"ows_contactvoicetelephone\" was missing for ows:Voice"));
+    xmlAddSibling(
+        psSubSubSubNode,
+        xmlNewComment(
+            BAD_CAST "WARNING: Optional metadata \"ows_contactvoicetelephone\" "
+                     "was missing for ows:Voice"));
   }
 
-  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces, "contactfacsimiletelephone", validated_language);
+  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces,
+                                          "contactfacsimiletelephone",
+                                          validated_language);
 
-  psSubSubSubNode = xmlNewTextChild(psSubSubNode, psNsOws, BAD_CAST "Facsimile", BAD_CAST value);
+  psSubSubSubNode = xmlNewTextChild(psSubSubNode, psNsOws, BAD_CAST "Facsimile",
+                                    BAD_CAST value);
 
   if (!value) {
-    xmlAddSibling(psSubSubSubNode, xmlNewComment(BAD_CAST "WARNING: Optional metadata \"ows_contactfacsimiletelephone\" was missing for ows:Facsimile"));
+    xmlAddSibling(
+        psSubSubSubNode,
+        xmlNewComment(
+            BAD_CAST
+            "WARNING: Optional metadata \"ows_contactfacsimiletelephone\" was "
+            "missing for ows:Facsimile"));
   }
 
   psSubSubNode = xmlNewTextChild(psSubNode, psNsOws, BAD_CAST "Address", NULL);
 
-  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces, "address", validated_language);
+  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces,
+                                          "address", validated_language);
 
-  psSubSubSubNode = xmlNewTextChild(psSubSubNode, psNsOws, BAD_CAST "DeliveryPoint", BAD_CAST value);
+  psSubSubSubNode = xmlNewTextChild(psSubSubNode, psNsOws,
+                                    BAD_CAST "DeliveryPoint", BAD_CAST value);
 
   if (!value) {
-    xmlAddSibling(psSubSubSubNode, xmlNewComment(BAD_CAST "WARNING: Optional metadata \"ows_address\" was missing for ows:DeliveryPoint"));
+    xmlAddSibling(
+        psSubSubSubNode,
+        xmlNewComment(BAD_CAST "WARNING: Optional metadata \"ows_address\" was "
+                               "missing for ows:DeliveryPoint"));
   }
 
-  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces, "city", validated_language);
+  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces,
+                                          "city", validated_language);
 
-  psSubSubSubNode = xmlNewTextChild(psSubSubNode, psNsOws, BAD_CAST "City", BAD_CAST value);
+  psSubSubSubNode =
+      xmlNewTextChild(psSubSubNode, psNsOws, BAD_CAST "City", BAD_CAST value);
 
   if (!value) {
-    xmlAddSibling(psSubSubSubNode, xmlNewComment(BAD_CAST "WARNING: Optional metadata \"ows_city\" was missing for ows:City"));
+    xmlAddSibling(psSubSubSubNode,
+                  xmlNewComment(BAD_CAST
+                                "WARNING: Optional metadata \"ows_city\" was "
+                                "missing for ows:City"));
   }
 
-  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces, "stateorprovince", validated_language);
+  value = msOWSLookupMetadataWithLanguage(
+      &(map->web.metadata), namespaces, "stateorprovince", validated_language);
 
-  psSubSubSubNode = xmlNewTextChild(psSubSubNode, psNsOws, BAD_CAST "AdministrativeArea", BAD_CAST value);
+  psSubSubSubNode = xmlNewTextChild(
+      psSubSubNode, psNsOws, BAD_CAST "AdministrativeArea", BAD_CAST value);
 
   if (!value) {
-    xmlAddSibling(psSubSubSubNode, xmlNewComment(BAD_CAST "WARNING: Optional metadata \"ows_stateorprovince\" was missing for ows:AdministrativeArea"));
+    xmlAddSibling(
+        psSubSubSubNode,
+        xmlNewComment(BAD_CAST
+                      "WARNING: Optional metadata \"ows_stateorprovince\" was "
+                      "missing for ows:AdministrativeArea"));
   }
 
-  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces, "postcode", validated_language);
+  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces,
+                                          "postcode", validated_language);
 
-  psSubSubSubNode = xmlNewTextChild(psSubSubNode, psNsOws, BAD_CAST "PostalCode", BAD_CAST value);
+  psSubSubSubNode = xmlNewTextChild(psSubSubNode, psNsOws,
+                                    BAD_CAST "PostalCode", BAD_CAST value);
 
   if (!value) {
-    xmlAddSibling(psSubSubSubNode, xmlNewComment(BAD_CAST "WARNING: Optional metadata \"ows_postcode\" was missing for ows:PostalCode"));
+    xmlAddSibling(psSubSubSubNode,
+                  xmlNewComment(BAD_CAST
+                                "WARNING: Optional metadata \"ows_postcode\" "
+                                "was missing for ows:PostalCode"));
   }
 
-  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces, "country", validated_language);
+  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces,
+                                          "country", validated_language);
 
-  psSubSubSubNode = xmlNewTextChild(psSubSubNode, psNsOws, BAD_CAST "Country", BAD_CAST value);
+  psSubSubSubNode = xmlNewTextChild(psSubSubNode, psNsOws, BAD_CAST "Country",
+                                    BAD_CAST value);
 
   if (!value) {
-    xmlAddSibling(psSubSubSubNode, xmlNewComment(BAD_CAST "WARNING: Optional metadata \"ows_country\" was missing for ows:Country"));
+    xmlAddSibling(
+        psSubSubSubNode,
+        xmlNewComment(BAD_CAST "WARNING: Optional metadata \"ows_country\" was "
+                               "missing for ows:Country"));
   }
 
-  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces, "contactelectronicmailaddress", validated_language);
+  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces,
+                                          "contactelectronicmailaddress",
+                                          validated_language);
 
-  psSubSubSubNode = xmlNewTextChild(psSubSubNode, psNsOws, BAD_CAST "ElectronicMailAddress", BAD_CAST value);
+  psSubSubSubNode = xmlNewTextChild(
+      psSubSubNode, psNsOws, BAD_CAST "ElectronicMailAddress", BAD_CAST value);
 
   if (!value) {
-    xmlAddSibling(psSubSubSubNode, xmlNewComment(BAD_CAST "WARNING: Optional metadata \"ows_contactelectronicmailaddress\" was missing for ows:ElectronicMailAddress"));
+    xmlAddSibling(
+        psSubSubSubNode,
+        xmlNewComment(
+            BAD_CAST
+            "WARNING: Optional metadata \"ows_contactelectronicmailaddress\" "
+            "was missing for ows:ElectronicMailAddress"));
   }
 
-  psSubSubNode = xmlNewTextChild(psSubNode, psNsOws, BAD_CAST "OnlineResource", NULL);
+  psSubSubNode =
+      xmlNewTextChild(psSubNode, psNsOws, BAD_CAST "OnlineResource", NULL);
 
   xmlNewNsProp(psSubSubNode, psNsXLink, BAD_CAST "type", BAD_CAST "simple");
 
-  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces, "service_onlineresource", validated_language);
+  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces,
+                                          "service_onlineresource",
+                                          validated_language);
 
   xmlNewNsProp(psSubSubNode, psNsXLink, BAD_CAST "href", BAD_CAST value);
 
   if (!value) {
-    xmlAddSibling(psSubSubNode, xmlNewComment(BAD_CAST "WARNING: Optional metadata \"ows_service_onlineresource\" was missing for ows:OnlineResource/@xlink:href"));
+    xmlAddSibling(
+        psSubSubNode,
+        xmlNewComment(
+            BAD_CAST
+            "WARNING: Optional metadata \"ows_service_onlineresource\" was "
+            "missing for ows:OnlineResource/@xlink:href"));
   }
 
-  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces, "hoursofservice", validated_language);
+  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces,
+                                          "hoursofservice", validated_language);
 
-  psSubSubNode = xmlNewTextChild(psSubNode, psNsOws, BAD_CAST "HoursOfService", BAD_CAST value);
+  psSubSubNode = xmlNewTextChild(psSubNode, psNsOws, BAD_CAST "HoursOfService",
+                                 BAD_CAST value);
 
   if (!value) {
-    xmlAddSibling(psSubSubNode, xmlNewComment(BAD_CAST "WARNING: Optional metadata \"ows_hoursofservice\" was missing for ows:HoursOfService"));
+    xmlAddSibling(
+        psSubSubNode,
+        xmlNewComment(BAD_CAST
+                      "WARNING: Optional metadata \"ows_hoursofservice\" was "
+                      "missing for ows:HoursOfService"));
   }
 
-  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces, "contactinstructions", validated_language);
+  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces,
+                                          "contactinstructions",
+                                          validated_language);
 
-  psSubSubNode = xmlNewTextChild(psSubNode, psNsOws, BAD_CAST "ContactInstructions", BAD_CAST value);
+  psSubSubNode = xmlNewTextChild(
+      psSubNode, psNsOws, BAD_CAST "ContactInstructions", BAD_CAST value);
 
   if (!value) {
-    xmlAddSibling(psSubSubNode, xmlNewComment(BAD_CAST "WARNING: Optional metadata \"ows_contactinstructions\" was missing for ows:ContactInstructions"));
+    xmlAddSibling(
+        psSubSubNode,
+        xmlNewComment(BAD_CAST
+                      "WARNING: Optional metadata \"ows_contactinstructions\" "
+                      "was missing for ows:ContactInstructions"));
   }
 
-  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces, "role", validated_language);
+  value = msOWSLookupMetadataWithLanguage(&(map->web.metadata), namespaces,
+                                          "role", validated_language);
 
   psSubNode = xmlNewTextChild(psNode, psNsOws, BAD_CAST "Role", BAD_CAST value);
 
   if (!value) {
-    xmlAddSibling(psSubNode, xmlNewComment(BAD_CAST "WARNING: Optional metadata \"ows_role\" was missing for ows:Role"));
+    xmlAddSibling(psSubNode,
+                  xmlNewComment(BAD_CAST
+                                "WARNING: Optional metadata \"ows_role\" was "
+                                "missing for ows:Role"));
   }
 
   return psRootNode;
-
 }
 
 /**
@@ -327,12 +451,12 @@ xmlNodePtr msOWSCommonServiceProvider(xm
  *
  */
 
-xmlNodePtr msOWSCommonOperationsMetadata(xmlNsPtr psNsOws)
-{
+xmlNodePtr msOWSCommonOperationsMetadata(xmlNsPtr psNsOws) {
   xmlNodePtr psRootNode = NULL;
 
   if (_validateNamespace(psNsOws) == MS_FAILURE)
-    psNsOws = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_PREFIX);
+    psNsOws = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_URI,
+                       BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_PREFIX);
 
   psRootNode = xmlNewNode(psNsOws, BAD_CAST "OperationsMetadata");
   return psRootNode;
@@ -347,22 +471,25 @@ xmlNodePtr msOWSCommonOperationsMetadata
  * 1.1.0 subclause 7.4.6
  *
  * @param name name of the Operation
- * @param method HTTP method: OWS_METHOD_GET, OWS_METHOD_POST or OWS_METHOD_GETPOST)
+ * @param method HTTP method: OWS_METHOD_GET, OWS_METHOD_POST or
+ * OWS_METHOD_GETPOST)
  * @param url online resource URL
  *
  * @return psRootNode xmlNodePtr pointer of XML construct
  */
 
-xmlNodePtr msOWSCommonOperationsMetadataOperation(xmlNsPtr psNsOws, xmlNsPtr psXLinkNs, const char *name, int method, const char *url)
-{
-  xmlNodePtr psRootNode      = NULL;
-  xmlNodePtr psNode          = NULL;
-  xmlNodePtr psSubNode       = NULL;
-  xmlNodePtr psSubSubNode    = NULL;
+xmlNodePtr msOWSCommonOperationsMetadataOperation(xmlNsPtr psNsOws,
+                                                  xmlNsPtr psXLinkNs,
+                                                  const char *name, int method,
+                                                  const char *url) {
+  xmlNodePtr psRootNode = NULL;
+  xmlNodePtr psNode = NULL;
+  xmlNodePtr psSubNode = NULL;
+  xmlNodePtr psSubSubNode = NULL;
 
   if (_validateNamespace(psNsOws) == MS_FAILURE)
-    psNsOws = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_PREFIX);
-
+    psNsOws = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_URI,
+                       BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_PREFIX);
 
   psRootNode = xmlNewNode(psNsOws, BAD_CAST "Operation");
 
@@ -372,13 +499,13 @@ xmlNodePtr msOWSCommonOperationsMetadata
 
   psSubNode = xmlNewChild(psNode, psNsOws, BAD_CAST "HTTP", NULL);
 
-  if (method  == OWS_METHOD_GET || method == OWS_METHOD_GETPOST ) {
+  if (method == OWS_METHOD_GET || method == OWS_METHOD_GETPOST) {
     psSubSubNode = xmlNewChild(psSubNode, psNsOws, BAD_CAST "Get", NULL);
     xmlNewNsProp(psSubSubNode, psXLinkNs, BAD_CAST "type", BAD_CAST "simple");
     xmlNewNsProp(psSubSubNode, psXLinkNs, BAD_CAST "href", BAD_CAST url);
   }
 
-  if (method == OWS_METHOD_POST || method == OWS_METHOD_GETPOST ) {
+  if (method == OWS_METHOD_POST || method == OWS_METHOD_GETPOST) {
     psSubSubNode = xmlNewChild(psSubNode, psNsOws, BAD_CAST "Post", NULL);
     xmlNewNsProp(psSubSubNode, psXLinkNs, BAD_CAST "type", BAD_CAST "simple");
     xmlNewNsProp(psSubSubNode, psXLinkNs, BAD_CAST "href", BAD_CAST url);
@@ -405,13 +532,17 @@ xmlNodePtr msOWSCommonOperationsMetadata
  *
  */
 
-xmlNodePtr msOWSCommonOperationsMetadataDomainType(int version, xmlNsPtr psNsOws, const char *elname, const char *name, const char *values)
-{
+xmlNodePtr msOWSCommonOperationsMetadataDomainType(int version,
+                                                   xmlNsPtr psNsOws,
+                                                   const char *elname,
+                                                   const char *name,
+                                                   const char *values) {
   xmlNodePtr psRootNode = NULL;
   xmlNodePtr psNode = NULL;
 
   if (_validateNamespace(psNsOws) == MS_FAILURE)
-    psNsOws = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_PREFIX);
+    psNsOws = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_URI,
+                       BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_PREFIX);
 
   psRootNode = xmlNewNode(psNsOws, BAD_CAST elname);
 
@@ -437,7 +568,8 @@ xmlNodePtr msOWSCommonOperationsMetadata
  * @param schemas_location URL to OGC Schemas Location base
  * @param version the version of the calling specification
  * @param language ISO3166 code of language
- * @param exceptionCode a code from the calling specification's list of exceptions, or from OWS Common
+ * @param exceptionCode a code from the calling specification's list of
+ * exceptions, or from OWS Common
  * @param locator where the exception was encountered (i.e. "layers" keyword)
  * @param ExceptionText the actual error message
  *
@@ -445,18 +577,23 @@ xmlNodePtr msOWSCommonOperationsMetadata
  *
  */
 
-xmlNodePtr msOWSCommonExceptionReport(xmlNsPtr psNsOws, int ows_version, const char *schemas_location, const char *version, const char *language, const char *exceptionCode, const char *locator, const char *ExceptionText)
-{
+xmlNodePtr msOWSCommonExceptionReport(xmlNsPtr psNsOws, int ows_version,
+                                      const char *schemas_location,
+                                      const char *version, const char *language,
+                                      const char *exceptionCode,
+                                      const char *locator,
+                                      const char *ExceptionText) {
   char *xsi_schemaLocation = NULL;
   char szVersionBuf[OWS_VERSION_MAXLEN];
 
-  xmlNsPtr     psNsXsi     = NULL;
-  xmlNodePtr   psRootNode  = NULL;
-  xmlNodePtr   psMainNode  = NULL;
+  xmlNsPtr psNsXsi = NULL;
+  xmlNodePtr psRootNode = NULL;
+  xmlNodePtr psMainNode = NULL;
 
   psRootNode = xmlNewNode(psNsOws, BAD_CAST "ExceptionReport");
 
-  psNsXsi = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX);
+  psNsXsi = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI,
+                     BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX);
 
   /* add attributes to root element */
   xmlNewProp(psRootNode, BAD_CAST "version", BAD_CAST version);
@@ -470,13 +607,18 @@ xmlNodePtr msOWSCommonExceptionReport(xm
 
   xsi_schemaLocation = msStrdup((char *)psNsOws->href);
   xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, (char *)schemas_location);
+  xsi_schemaLocation =
+      msStringConcatenate(xsi_schemaLocation, (char *)schemas_location);
   xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, "/ows/");
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, (char *)msOWSGetVersionString(ows_version, szVersionBuf));
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, "/owsExceptionReport.xsd");
+  xsi_schemaLocation = msStringConcatenate(
+      xsi_schemaLocation,
+      (char *)msOWSGetVersionString(ows_version, szVersionBuf));
+  xsi_schemaLocation =
+      msStringConcatenate(xsi_schemaLocation, "/owsExceptionReport.xsd");
 
   /* add namespace'd attributes to root element */
-  xmlNewNsProp(psRootNode, psNsXsi, BAD_CAST "schemaLocation", BAD_CAST xsi_schemaLocation);
+  xmlNewNsProp(psRootNode, psNsXsi, BAD_CAST "schemaLocation",
+               BAD_CAST xsi_schemaLocation);
 
   /* add child element */
   psMainNode = xmlNewChild(psRootNode, NULL, BAD_CAST "Exception", NULL);
@@ -489,7 +631,8 @@ xmlNodePtr msOWSCommonExceptionReport(xm
   }
 
   if (ExceptionText != NULL) {
-    xmlNewTextChild(psMainNode, NULL, BAD_CAST "ExceptionText", BAD_CAST ExceptionText);
+    xmlNewTextChild(psMainNode, NULL, BAD_CAST "ExceptionText",
+                    BAD_CAST ExceptionText);
   }
 
   free(xsi_schemaLocation);
@@ -515,28 +658,29 @@ xmlNodePtr msOWSCommonExceptionReport(xm
  * @return psRootNode xmlNodePtr pointer of XML construct
  */
 
-xmlNodePtr msOWSCommonBoundingBox(xmlNsPtr psNsOws, const char *crs, int dimensions, double minx, double miny, double maxx, double maxy)
-{
+xmlNodePtr msOWSCommonBoundingBox(xmlNsPtr psNsOws, const char *crs,
+                                  int dimensions, double minx, double miny,
+                                  double maxx, double maxy) {
   char LowerCorner[100];
   char UpperCorner[100];
   char dim_string[100];
   xmlNodePtr psRootNode = NULL;
 
   /* Do we need to reorient tuple axes? */
-  if(crs && strstr(crs, "imageCRS") == NULL) {
+  if (crs && strstr(crs, "imageCRS") == NULL) {
     projectionObj proj;
 
-    msInitProjection( &proj );
-    if( msLoadProjectionString( &proj, (char *) crs ) == 0 ) {
-      msAxisNormalizePoints( &proj, 1, &minx, &miny );
-      msAxisNormalizePoints( &proj, 1, &maxx, &maxy );
+    msInitProjection(&proj);
+    if (msLoadProjectionString(&proj, (char *)crs) == 0) {
+      msAxisNormalizePoints(&proj, 1, &minx, &miny);
+      msAxisNormalizePoints(&proj, 1, &maxx, &maxy);
     }
-    msFreeProjection( &proj );
+    msFreeProjection(&proj);
   }
 
-
   if (_validateNamespace(psNsOws) == MS_FAILURE)
-    psNsOws = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_PREFIX);
+    psNsOws = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_URI,
+                       BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_PREFIX);
 
   /* create element name */
   psRootNode = xmlNewNode(psNsOws, BAD_CAST "BoundingBox");
@@ -544,15 +688,17 @@ xmlNodePtr msOWSCommonBoundingBox(xmlNsP
   /* add attributes to the root element */
   xmlNewProp(psRootNode, BAD_CAST "crs", BAD_CAST crs);
 
-  snprintf( dim_string, sizeof(dim_string), "%d", dimensions );
+  snprintf(dim_string, sizeof(dim_string), "%d", dimensions);
   xmlNewProp(psRootNode, BAD_CAST "dimensions", BAD_CAST dim_string);
 
   snprintf(LowerCorner, sizeof(LowerCorner), "%.15g %.15g", minx, miny);
   snprintf(UpperCorner, sizeof(UpperCorner), "%.15g %.15g", maxx, maxy);
 
   /* add child elements */
-  xmlNewChild(psRootNode, psNsOws,BAD_CAST "LowerCorner",BAD_CAST LowerCorner);
-  xmlNewChild(psRootNode, psNsOws,BAD_CAST "UpperCorner",BAD_CAST UpperCorner);
+  xmlNewChild(psRootNode, psNsOws, BAD_CAST "LowerCorner",
+              BAD_CAST LowerCorner);
+  xmlNewChild(psRootNode, psNsOws, BAD_CAST "UpperCorner",
+              BAD_CAST UpperCorner);
 
   return psRootNode;
 }
@@ -572,8 +718,9 @@ xmlNodePtr msOWSCommonBoundingBox(xmlNsP
  * @return psRootNode xmlNodePtr pointer of XML construct
  */
 
-xmlNodePtr msOWSCommonWGS84BoundingBox(xmlNsPtr psNsOws, int dimensions, double minx, double miny, double maxx, double maxy)
-{
+xmlNodePtr msOWSCommonWGS84BoundingBox(xmlNsPtr psNsOws, int dimensions,
+                                       double minx, double miny, double maxx,
+                                       double maxy) {
   char LowerCorner[100];
   char UpperCorner[100];
   char dim_string[100];
@@ -581,20 +728,23 @@ xmlNodePtr msOWSCommonWGS84BoundingBox(x
   xmlNodePtr psRootNode = NULL;
 
   if (_validateNamespace(psNsOws) == MS_FAILURE)
-    psNsOws = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_PREFIX);
+    psNsOws = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_URI,
+                       BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_PREFIX);
 
   /* create element name */
   psRootNode = xmlNewNode(psNsOws, BAD_CAST "WGS84BoundingBox");
 
-  snprintf( dim_string, sizeof(dim_string), "%d", dimensions );
+  snprintf(dim_string, sizeof(dim_string), "%d", dimensions);
   xmlNewProp(psRootNode, BAD_CAST "dimensions", BAD_CAST dim_string);
 
   snprintf(LowerCorner, sizeof(LowerCorner), "%.6f %.6f", minx, miny);
   snprintf(UpperCorner, sizeof(UpperCorner), "%.6f %.6f", maxx, maxy);
 
   /* add child elements */
-  xmlNewChild(psRootNode, psNsOws,BAD_CAST "LowerCorner",BAD_CAST LowerCorner);
-  xmlNewChild(psRootNode, psNsOws,BAD_CAST "UpperCorner",BAD_CAST UpperCorner);
+  xmlNewChild(psRootNode, psNsOws, BAD_CAST "LowerCorner",
+              BAD_CAST LowerCorner);
+  xmlNewChild(psRootNode, psNsOws, BAD_CAST "UpperCorner",
+              BAD_CAST UpperCorner);
 
   return psRootNode;
 }
@@ -610,8 +760,7 @@ xmlNodePtr msOWSCommonWGS84BoundingBox(x
  *
  */
 
-int _validateNamespace(xmlNsPtr psNsOws)
-{
+int _validateNamespace(xmlNsPtr psNsOws) {
   char namespace_prefix[10];
   snprintf(namespace_prefix, sizeof(namespace_prefix), "%s", psNsOws->prefix);
   if (strcmp(namespace_prefix, MS_OWSCOMMON_OWS_NAMESPACE_PREFIX) == 0)
@@ -622,11 +771,11 @@ int _validateNamespace(xmlNsPtr psNsOws)
 
 /*
  * Valid an xml string against an XML schema
- * Inpired from: http://xml.developpez.com/sources/?page=validation#validate_XSD_CppCLI_2
+ * Inpired from:
+ * http://xml.developpez.com/sources/?page=validation#validate_XSD_CppCLI_2
  * taken from tinyows.org
  */
-int msOWSSchemaValidation(const char* xml_schema, const char* xml)
-{
+int msOWSSchemaValidation(const char *xml_schema, const char *xml) {
   xmlSchemaPtr schema;
   xmlSchemaParserCtxtPtr ctxt;
   xmlSchemaValidCtxtPtr validctxt;
@@ -642,57 +791,65 @@ int msOWSSchemaValidation(const char* xm
 
   /* To valide WFS 2.0 requests, we might need to explicitely import */
   /* GML and FES 2.0 */
-  if( strlen(xml_schema) > strlen(MS_OWSCOMMON_WFS_20_SCHEMA_LOCATION) &&
+  if (strlen(xml_schema) > strlen(MS_OWSCOMMON_WFS_20_SCHEMA_LOCATION) &&
       strcmp(xml_schema + strlen(xml_schema) -
-            strlen(MS_OWSCOMMON_WFS_20_SCHEMA_LOCATION), MS_OWSCOMMON_WFS_20_SCHEMA_LOCATION) == 0 )
-  {
-    const size_t nLenBaseLocation = strlen(xml_schema) - strlen(MS_OWSCOMMON_WFS_20_SCHEMA_LOCATION);
-    char* pszInMemSchema = NULL;
-    char* pszBaseLocation = (char*)msSmallMalloc(nLenBaseLocation + 1);
+                 strlen(MS_OWSCOMMON_WFS_20_SCHEMA_LOCATION),
+             MS_OWSCOMMON_WFS_20_SCHEMA_LOCATION) == 0) {
+    const size_t nLenBaseLocation =
+        strlen(xml_schema) - strlen(MS_OWSCOMMON_WFS_20_SCHEMA_LOCATION);
+    char *pszInMemSchema = NULL;
+    char *pszBaseLocation = (char *)msSmallMalloc(nLenBaseLocation + 1);
     memcpy(pszBaseLocation, xml_schema, nLenBaseLocation);
     pszBaseLocation[nLenBaseLocation] = '\0';
 
-    pszInMemSchema = msStringConcatenate(pszInMemSchema,
+    pszInMemSchema = msStringConcatenate(
+        pszInMemSchema,
         "<schema elementFormDefault=\"qualified\" version=\"1.0.0\" "
         "xmlns=\"http://www.w3.org/2001/XMLSchema\">\n");
 
-    pszInMemSchema = msStringConcatenate(pszInMemSchema,
-        "<import namespace=\"" MS_OWSCOMMON_WFS_20_NAMESPACE_URI "\" schemaLocation=\"");
+    pszInMemSchema = msStringConcatenate(
+        pszInMemSchema, "<import namespace=\"" MS_OWSCOMMON_WFS_20_NAMESPACE_URI
+                        "\" schemaLocation=\"");
     pszInMemSchema = msStringConcatenate(pszInMemSchema, xml_schema);
     pszInMemSchema = msStringConcatenate(pszInMemSchema, "\" />\n");
 
-    if( strstr(xml, MS_OWSCOMMON_FES_20_NAMESPACE_URI) != NULL )
-    {
-        pszInMemSchema = msStringConcatenate(pszInMemSchema,
-            "<import namespace=\"" MS_OWSCOMMON_FES_20_NAMESPACE_URI "\" schemaLocation=\"");
-        pszInMemSchema = msStringConcatenate(pszInMemSchema, pszBaseLocation);
-        pszInMemSchema = msStringConcatenate(pszInMemSchema, MS_OWSCOMMON_FES_20_SCHEMA_LOCATION "\" />\n");
+    if (strstr(xml, MS_OWSCOMMON_FES_20_NAMESPACE_URI) != NULL) {
+      pszInMemSchema = msStringConcatenate(
+          pszInMemSchema,
+          "<import namespace=\"" MS_OWSCOMMON_FES_20_NAMESPACE_URI
+          "\" schemaLocation=\"");
+      pszInMemSchema = msStringConcatenate(pszInMemSchema, pszBaseLocation);
+      pszInMemSchema = msStringConcatenate(
+          pszInMemSchema, MS_OWSCOMMON_FES_20_SCHEMA_LOCATION "\" />\n");
     }
 
-    if( strstr(xml, MS_OWSCOMMON_GML_32_NAMESPACE_URI) != NULL )
-    {
-        pszInMemSchema = msStringConcatenate(pszInMemSchema,
-            "<import namespace=\"" MS_OWSCOMMON_GML_32_NAMESPACE_URI "\" schemaLocation=\"");
+    if (strstr(xml, MS_OWSCOMMON_GML_32_NAMESPACE_URI) != NULL) {
+      pszInMemSchema = msStringConcatenate(
+          pszInMemSchema,
+          "<import namespace=\"" MS_OWSCOMMON_GML_32_NAMESPACE_URI
+          "\" schemaLocation=\"");
+      pszInMemSchema = msStringConcatenate(pszInMemSchema, pszBaseLocation);
+      pszInMemSchema = msStringConcatenate(
+          pszInMemSchema, MS_OWSCOMMON_GML_321_SCHEMA_LOCATION "\" />\n");
+
+    } else if (strstr(xml, MS_OWSCOMMON_GML_NAMESPACE_URI) != NULL) {
+      if (strstr(xml, MS_OWSCOMMON_GML_212_SCHEMA_LOCATION) != NULL) {
+        pszInMemSchema = msStringConcatenate(
+            pszInMemSchema,
+            "<import namespace=\"" MS_OWSCOMMON_GML_NAMESPACE_URI
+            "\" schemaLocation=\"");
         pszInMemSchema = msStringConcatenate(pszInMemSchema, pszBaseLocation);
-        pszInMemSchema = msStringConcatenate(pszInMemSchema, MS_OWSCOMMON_GML_321_SCHEMA_LOCATION "\" />\n");
-
-    }
-    else if( strstr(xml, MS_OWSCOMMON_GML_NAMESPACE_URI) != NULL )
-    {
-        if( strstr(xml, MS_OWSCOMMON_GML_212_SCHEMA_LOCATION) != NULL )
-        {
-            pszInMemSchema = msStringConcatenate(pszInMemSchema,
-                "<import namespace=\"" MS_OWSCOMMON_GML_NAMESPACE_URI "\" schemaLocation=\"");
-            pszInMemSchema = msStringConcatenate(pszInMemSchema, pszBaseLocation);
-            pszInMemSchema = msStringConcatenate(pszInMemSchema, MS_OWSCOMMON_GML_212_SCHEMA_LOCATION "\" />\n");
-        }
-        else if( strstr(xml, MS_OWSCOMMON_GML_311_SCHEMA_LOCATION) != NULL )
-        {
-            pszInMemSchema = msStringConcatenate(pszInMemSchema,
-                "<import namespace=\"" MS_OWSCOMMON_GML_NAMESPACE_URI "\" schemaLocation=\"");
-            pszInMemSchema = msStringConcatenate(pszInMemSchema, pszBaseLocation);
-            pszInMemSchema = msStringConcatenate(pszInMemSchema, MS_OWSCOMMON_GML_311_SCHEMA_LOCATION "\" />\n");
-        }
+        pszInMemSchema = msStringConcatenate(
+            pszInMemSchema, MS_OWSCOMMON_GML_212_SCHEMA_LOCATION "\" />\n");
+      } else if (strstr(xml, MS_OWSCOMMON_GML_311_SCHEMA_LOCATION) != NULL) {
+        pszInMemSchema = msStringConcatenate(
+            pszInMemSchema,
+            "<import namespace=\"" MS_OWSCOMMON_GML_NAMESPACE_URI
+            "\" schemaLocation=\"");
+        pszInMemSchema = msStringConcatenate(pszInMemSchema, pszBaseLocation);
+        pszInMemSchema = msStringConcatenate(
+            pszInMemSchema, MS_OWSCOMMON_GML_311_SCHEMA_LOCATION "\" />\n");
+      }
     }
 
     pszInMemSchema = msStringConcatenate(pszInMemSchema, "</schema>\n");
@@ -700,9 +857,7 @@ int msOWSSchemaValidation(const char* xm
     ctxt = xmlSchemaNewMemParserCtxt(pszInMemSchema, strlen(pszInMemSchema));
     msFree(pszInMemSchema);
     msFree(pszBaseLocation);
-  }
-  else
-  {
+  } else {
     /* Open XML Schema File */
     ctxt = xmlSchemaNewParserCtxt(xml_schema);
   }
@@ -710,7 +865,8 @@ int msOWSSchemaValidation(const char* xm
   /*
   xmlSchemaSetParserErrors(ctxt,
                            (xmlSchemaValidityErrorFunc) libxml2_callback,
-                           (xmlSchemaValidityWarningFunc) libxml2_callback, stderr);
+                           (xmlSchemaValidityWarningFunc) libxml2_callback,
+  stderr);
   */
 
   schema = xmlSchemaParse(ctxt);
@@ -731,7 +887,8 @@ int msOWSSchemaValidation(const char* xm
     /*
     xmlSchemaSetValidErrors(validctxt,
                             (xmlSchemaValidityErrorFunc) libxml2_callback,
-                            (xmlSchemaValidityWarningFunc) libxml2_callback, stderr);
+                            (xmlSchemaValidityWarningFunc) libxml2_callback,
+    stderr);
     */
     /* validation */
     ret = xmlSchemaValidateDoc(validctxt, doc);
@@ -747,7 +904,6 @@ int msOWSSchemaValidation(const char* xm
 
 #endif /* defined(USE_LIBXML2) */
 
-
 /**
  * msOWSCommonNegotiateVersion()
  *
@@ -761,12 +917,13 @@ int msOWSSchemaValidation(const char* xm
  *
  */
 
-int msOWSCommonNegotiateVersion(int requested_version, const int supported_versions[], int num_supported_versions)
-{
+int msOWSCommonNegotiateVersion(int requested_version,
+                                const int supported_versions[],
+                                int num_supported_versions) {
   int i;
 
   /* if version is not set return error */
-  if (! requested_version)
+  if (!requested_version)
     return -1;
 
   /* return the first entry that's equal to the requested version */
diff -pruN 8.0.1-5/mapowscommon.h 8.0.2-1/mapowscommon.h
--- 8.0.1-5/mapowscommon.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapowscommon.h	2024-06-11 20:41:34.000000000 +0000
@@ -32,34 +32,35 @@
 
 #ifdef USE_LIBXML2
 
-#include<libxml/parser.h>
-#include<libxml/tree.h>
+#include <libxml/parser.h>
+#include <libxml/tree.h>
 
 #endif
 
 /* W3C namespaces */
 
-#define MS_OWSCOMMON_W3C_XLINK_NAMESPACE_URI      "http://www.w3.org/1999/xlink"
-#define MS_OWSCOMMON_W3C_XLINK_NAMESPACE_PREFIX   "xlink"
+#define MS_OWSCOMMON_W3C_XLINK_NAMESPACE_URI "http://www.w3.org/1999/xlink"
+#define MS_OWSCOMMON_W3C_XLINK_NAMESPACE_PREFIX "xlink"
 
-#define MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI        "http://www.w3.org/2001/XMLSchema-instance"
-#define MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX     "xsi"
+#define MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI                                     \
+  "http://www.w3.org/2001/XMLSchema-instance"
+#define MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX "xsi"
 
-#define MS_OWSCOMMON_W3C_XS_NAMESPACE_URI         "http://www.w3.org/2001/XMLSchema"
-#define MS_OWSCOMMON_W3C_XS_NAMESPACE_PREFIX      "xs"
+#define MS_OWSCOMMON_W3C_XS_NAMESPACE_URI "http://www.w3.org/2001/XMLSchema"
+#define MS_OWSCOMMON_W3C_XS_NAMESPACE_PREFIX "xs"
 
 /* OGC namespaces */
 
-#define MS_OWSCOMMON_OGC_NAMESPACE_URI      "http://www.opengis.net/ogc"
-#define MS_OWSCOMMON_OGC_NAMESPACE_PREFIX   "ogc"
+#define MS_OWSCOMMON_OGC_NAMESPACE_URI "http://www.opengis.net/ogc"
+#define MS_OWSCOMMON_OGC_NAMESPACE_PREFIX "ogc"
 
-#define MS_OWSCOMMON_OWS_NAMESPACE_URI      "http://www.opengis.net/ows"
-#define MS_OWSCOMMON_OWS_NAMESPACE_PREFIX   "ows"
+#define MS_OWSCOMMON_OWS_NAMESPACE_URI "http://www.opengis.net/ows"
+#define MS_OWSCOMMON_OWS_NAMESPACE_PREFIX "ows"
 
-#define MS_OWSCOMMON_OWS_110_NAMESPACE_URI      "http://www.opengis.net/ows/1.1"
+#define MS_OWSCOMMON_OWS_110_NAMESPACE_URI "http://www.opengis.net/ows/1.1"
 
-#define MS_OWSCOMMON_OWS_20_NAMESPACE_URI   "http://www.opengis.net/ows/2.0"
-#define MS_OWSCOMMON_OWS_20_SCHEMAS_LOCATION    "/ows/2.0/owsAll.xsd"
+#define MS_OWSCOMMON_OWS_20_NAMESPACE_URI "http://www.opengis.net/ows/2.0"
+#define MS_OWSCOMMON_OWS_20_SCHEMAS_LOCATION "/ows/2.0/owsAll.xsd"
 
 /* OGC URNs */
 
@@ -75,79 +76,80 @@
 
 /* WCS namespaces */
 
-#define MS_OWSCOMMON_WCS_20_NAMESPACE_URI   "http://www.opengis.net/wcs/2.0"
-#define MS_OWSCOMMON_WCS_20_SCHEMAS_LOCATION    "/wcs/2.0/wcsAll.xsd"
-#define MS_OWSCOMMON_WCS_NAMESPACE_PREFIX   "wcs"
+#define MS_OWSCOMMON_WCS_20_NAMESPACE_URI "http://www.opengis.net/wcs/2.0"
+#define MS_OWSCOMMON_WCS_20_SCHEMAS_LOCATION "/wcs/2.0/wcsAll.xsd"
+#define MS_OWSCOMMON_WCS_NAMESPACE_PREFIX "wcs"
 
 /* GML namespaces */
 
-#define MS_OWSCOMMON_GML_NAMESPACE_URI      "http://www.opengis.net/gml"
-#define MS_OWSCOMMON_GML_NAMESPACE_PREFIX   "gml"
+#define MS_OWSCOMMON_GML_NAMESPACE_URI "http://www.opengis.net/gml"
+#define MS_OWSCOMMON_GML_NAMESPACE_PREFIX "gml"
 
-#define MS_OWSCOMMON_GML_32_NAMESPACE_URI   "http://www.opengis.net/gml/3.2"
+#define MS_OWSCOMMON_GML_32_NAMESPACE_URI "http://www.opengis.net/gml/3.2"
 
-#define MS_OWSCOMMON_GML_212_SCHEMA_LOCATION       "/gml/2.1.2/feature.xsd"
-#define MS_OWSCOMMON_GML_311_SCHEMA_LOCATION       "/gml/3.1.1/base/gml.xsd"
-#define MS_OWSCOMMON_GML_321_SCHEMA_LOCATION       "/gml/3.2.1/gml.xsd"
+#define MS_OWSCOMMON_GML_212_SCHEMA_LOCATION "/gml/2.1.2/feature.xsd"
+#define MS_OWSCOMMON_GML_311_SCHEMA_LOCATION "/gml/3.1.1/base/gml.xsd"
+#define MS_OWSCOMMON_GML_321_SCHEMA_LOCATION "/gml/3.2.1/gml.xsd"
 
 /* WFS namespaces */
 
-#define MS_OWSCOMMON_WFS_NAMESPACE_PREFIX          "wfs"
-#define MS_OWSCOMMON_WFS_NAMESPACE_URI             "http://www.opengis.net/wfs"
-#define MS_OWSCOMMON_WFS_20_NAMESPACE_URI          "http://www.opengis.net/wfs/2.0"
-
-#define MS_OWSCOMMON_WFS_10_SCHEMA_LOCATION        "/wfs/1.0.0/WFS-basic.xsd"
-#define MS_OWSCOMMON_WFS_11_SCHEMA_LOCATION        "/wfs/1.1.0/wfs.xsd"
-#define MS_OWSCOMMON_WFS_20_SCHEMA_LOCATION        "/wfs/2.0/wfs.xsd"
+#define MS_OWSCOMMON_WFS_NAMESPACE_PREFIX "wfs"
+#define MS_OWSCOMMON_WFS_NAMESPACE_URI "http://www.opengis.net/wfs"
+#define MS_OWSCOMMON_WFS_20_NAMESPACE_URI "http://www.opengis.net/wfs/2.0"
+
+#define MS_OWSCOMMON_WFS_10_SCHEMA_LOCATION "/wfs/1.0.0/WFS-basic.xsd"
+#define MS_OWSCOMMON_WFS_11_SCHEMA_LOCATION "/wfs/1.1.0/wfs.xsd"
+#define MS_OWSCOMMON_WFS_20_SCHEMA_LOCATION "/wfs/2.0/wfs.xsd"
 
 /* FES namespaces */
 
-#define MS_OWSCOMMON_FES_20_NAMESPACE_PREFIX       "fes"
-#define MS_OWSCOMMON_FES_20_NAMESPACE_URI          "http://www.opengis.net/fes/2.0"
+#define MS_OWSCOMMON_FES_20_NAMESPACE_PREFIX "fes"
+#define MS_OWSCOMMON_FES_20_NAMESPACE_URI "http://www.opengis.net/fes/2.0"
 
-#define MS_OWSCOMMON_FES_20_SCHEMA_LOCATION        "/filter/2.0/filterAll.xsd"
+#define MS_OWSCOMMON_FES_20_SCHEMA_LOCATION "/filter/2.0/filterAll.xsd"
 
 /* GMLCov namespaces */
 
-#define MS_OWSCOMMON_GMLCOV_10_NAMESPACE_URI    "http://www.opengis.net/gmlcov/1.0"
-#define MS_OWSCOMMON_GMLCOV_NAMESPACE_PREFIX    "gmlcov"
+#define MS_OWSCOMMON_GMLCOV_10_NAMESPACE_URI "http://www.opengis.net/gmlcov/1.0"
+#define MS_OWSCOMMON_GMLCOV_NAMESPACE_PREFIX "gmlcov"
 
 /* SWE namespaces */
-#define MS_OWSCOMMON_SWE_20_NAMESPACE_URI   "http://www.opengis.net/swe/2.0"
-#define MS_OWSCOMMON_SWE_NAMESPACE_PREFIX   "swe"
+#define MS_OWSCOMMON_SWE_20_NAMESPACE_URI "http://www.opengis.net/swe/2.0"
+#define MS_OWSCOMMON_SWE_NAMESPACE_PREFIX "swe"
 
 /* Inspire namespaces */
 
-#define MS_INSPIRE_COMMON_NAMESPACE_URI     "http://inspire.ec.europa.eu/schemas/common/1.0"
-#define MS_INSPIRE_COMMON_NAMESPACE_PREFIX  "inspire_common"
-#define MS_INSPIRE_COMMON_SCHEMA_LOCATION   "/common/1.0/common.xsd"
-
-#define MS_INSPIRE_VS_NAMESPACE_URI         "http://inspire.ec.europa.eu/schemas/inspire_vs/1.0"
-#define MS_INSPIRE_VS_NAMESPACE_PREFIX      "inspire_vs"
-#define MS_INSPIRE_VS_SCHEMA_LOCATION       "/inspire_vs/1.0/inspire_vs.xsd"
-
-#define MS_INSPIRE_DLS_NAMESPACE_URI        "http://inspire.ec.europa.eu/schemas/inspire_dls/1.0"
-#define MS_INSPIRE_DLS_NAMESPACE_PREFIX     "inspire_dls"
-#define MS_INSPIRE_DLS_SCHEMA_LOCATION      "/inspire_dls/1.0/inspire_dls.xsd"
-
+#define MS_INSPIRE_COMMON_NAMESPACE_URI                                        \
+  "http://inspire.ec.europa.eu/schemas/common/1.0"
+#define MS_INSPIRE_COMMON_NAMESPACE_PREFIX "inspire_common"
+#define MS_INSPIRE_COMMON_SCHEMA_LOCATION "/common/1.0/common.xsd"
+
+#define MS_INSPIRE_VS_NAMESPACE_URI                                            \
+  "http://inspire.ec.europa.eu/schemas/inspire_vs/1.0"
+#define MS_INSPIRE_VS_NAMESPACE_PREFIX "inspire_vs"
+#define MS_INSPIRE_VS_SCHEMA_LOCATION "/inspire_vs/1.0/inspire_vs.xsd"
+
+#define MS_INSPIRE_DLS_NAMESPACE_URI                                           \
+  "http://inspire.ec.europa.eu/schemas/inspire_dls/1.0"
+#define MS_INSPIRE_DLS_NAMESPACE_PREFIX "inspire_dls"
+#define MS_INSPIRE_DLS_SCHEMA_LOCATION "/inspire_dls/1.0/inspire_dls.xsd"
 
 /* MapServer namespaces */
-#define MS_DEFAULT_NAMESPACE_PREFIX         "ms"
-#define MS_DEFAULT_NAMESPACE_URI            "http://mapserver.gis.umn.edu/mapserver"
-
+#define MS_DEFAULT_NAMESPACE_PREFIX "ms"
+#define MS_DEFAULT_NAMESPACE_URI "http://mapserver.gis.umn.edu/mapserver"
 
 /* OWS errors */
 
 /* OWS 1.1.0 Table 25 */
-#define MS_OWS_ERROR_OPERATION_NOT_SUPPORTED    "OperationNotSupported"
-#define MS_OWS_ERROR_MISSING_PARAMETER_VALUE    "MissingParameterValue"
-#define MS_OWS_ERROR_INVALID_PARAMETER_VALUE    "InvalidParameterValue"
+#define MS_OWS_ERROR_OPERATION_NOT_SUPPORTED "OperationNotSupported"
+#define MS_OWS_ERROR_MISSING_PARAMETER_VALUE "MissingParameterValue"
+#define MS_OWS_ERROR_INVALID_PARAMETER_VALUE "InvalidParameterValue"
 #define MS_OWS_ERROR_VERSION_NEGOTIATION_FAILED "VersionNegotiationFailed"
-#define MS_OWS_ERROR_INVALID_UPDATE_SEQUENCE    "InvalidUpdateSequence"
-#define MS_OWS_ERROR_OPTION_NOT_SUPPORTED       "OptionNotSupported"
-#define MS_OWS_ERROR_NO_APPLICABLE_CODE         "NoApplicableCode"
+#define MS_OWS_ERROR_INVALID_UPDATE_SEQUENCE "InvalidUpdateSequence"
+#define MS_OWS_ERROR_OPTION_NOT_SUPPORTED "OptionNotSupported"
+#define MS_OWS_ERROR_NO_APPLICABLE_CODE "NoApplicableCode"
 
-#define MS_OWS_ERROR_NOT_FOUND                  "NotFound"
+#define MS_OWS_ERROR_NOT_FOUND "NotFound"
 
 #define MS_WFS_ERROR_OPERATION_PROCESSING_FAILED "OperationProcessingFailed"
 
@@ -159,42 +161,57 @@ extern "C" {
 
 /* function prototypes */
 
-
 xmlNodePtr msOWSCommonServiceIdentification(xmlNsPtr psNsOws, mapObj *map,
                                             const char *servicetype,
                                             const char *version,
                                             const char *namespaces,
                                             const char *validated_language);
 
-xmlNodePtr msOWSCommonServiceProvider(xmlNsPtr psNsOws,
-                                      xmlNsPtr psXLinkNs,
-                                      mapObj *map,
-                                      const char *namespaces,
+xmlNodePtr msOWSCommonServiceProvider(xmlNsPtr psNsOws, xmlNsPtr psXLinkNs,
+                                      mapObj *map, const char *namespaces,
                                       const char *validated_language);
 
 xmlNodePtr msOWSCommonOperationsMetadata(xmlNsPtr psNsOws);
 
-#define OWS_METHOD_GET     1
-#define OWS_METHOD_POST    2
+#define OWS_METHOD_GET 1
+#define OWS_METHOD_POST 2
 #define OWS_METHOD_GETPOST 3
 
-xmlNodePtr msOWSCommonOperationsMetadataOperation(xmlNsPtr psNsOws, xmlNsPtr psXLinkNs, const char *name, int method, const char *url);
-
-xmlNodePtr msOWSCommonOperationsMetadataDomainType(int version, xmlNsPtr psNsOws, const char *elname, const char *name, const char *values);
-
-xmlNodePtr msOWSCommonExceptionReport(xmlNsPtr psNsOws, int ows_version, const char *schemas_location, const char *version, const char *language, const char *exceptionCode, const char *locator, const char *ExceptionText);
-
-xmlNodePtr msOWSCommonBoundingBox(xmlNsPtr psNsOws, const char *crs, int dimensions, double minx, double miny, double maxx, double maxy);
-
-xmlNodePtr msOWSCommonWGS84BoundingBox(xmlNsPtr psNsOws, int dimensions, double minx, double miny, double maxx, double maxy);
+xmlNodePtr msOWSCommonOperationsMetadataOperation(xmlNsPtr psNsOws,
+                                                  xmlNsPtr psXLinkNs,
+                                                  const char *name, int method,
+                                                  const char *url);
+
+xmlNodePtr msOWSCommonOperationsMetadataDomainType(int version,
+                                                   xmlNsPtr psNsOws,
+                                                   const char *elname,
+                                                   const char *name,
+                                                   const char *values);
+
+xmlNodePtr msOWSCommonExceptionReport(xmlNsPtr psNsOws, int ows_version,
+                                      const char *schemas_location,
+                                      const char *version, const char *language,
+                                      const char *exceptionCode,
+                                      const char *locator,
+                                      const char *ExceptionText);
+
+xmlNodePtr msOWSCommonBoundingBox(xmlNsPtr psNsOws, const char *crs,
+                                  int dimensions, double minx, double miny,
+                                  double maxx, double maxy);
+
+xmlNodePtr msOWSCommonWGS84BoundingBox(xmlNsPtr psNsOws, int dimensions,
+                                       double minx, double miny, double maxx,
+                                       double maxy);
 
 int _validateNamespace(xmlNsPtr psNsOws);
 
-int msOWSSchemaValidation(const char* xml_schema, const char* xml);
+int msOWSSchemaValidation(const char *xml_schema, const char *xml);
 
 #endif /* defined(USE_LIBXML2) */
 
-int msOWSCommonNegotiateVersion(int requested_version, const int supported_versions[], int num_supported_versions);
+int msOWSCommonNegotiateVersion(int requested_version,
+                                const int supported_versions[],
+                                int num_supported_versions);
 
 #ifdef __cplusplus
 } /* extern C */
diff -pruN 8.0.1-5/mappluginlayer.c 8.0.2-1/mappluginlayer.c
--- 8.0.1-5/mappluginlayer.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mappluginlayer.c	2024-06-11 20:41:34.000000000 +0000
@@ -30,8 +30,6 @@
 #include "mapserver.h"
 #include "mapthread.h"
 
-
-
 typedef struct {
   char *name;
   layerVTableObj vtable;
@@ -40,15 +38,12 @@ typedef struct {
 typedef struct {
   unsigned int size;
   unsigned int first_free;
-  VTFactoryItemObj ** vtItems;
+  VTFactoryItemObj **vtItems;
 } VTFactoryObj;
 
 static VTFactoryObj gVirtualTableFactory = {0, 0, NULL};
 
-
-static VTFactoryItemObj *
-createVTFItem(const char *name)
-{
+static VTFactoryItemObj *createVTFItem(const char *name) {
   VTFactoryItemObj *pVTFI;
 
   pVTFI = (VTFactoryItemObj *)malloc(sizeof(VTFactoryItemObj));
@@ -60,9 +55,7 @@ createVTFItem(const char *name)
   return pVTFI;
 }
 
-static void
-destroyVTFItem(VTFactoryItemObj **pVTFI)
-{
+static void destroyVTFItem(VTFactoryItemObj **pVTFI) {
   free((*pVTFI)->name);
   (*pVTFI)->name = NULL;
   memset(&(*pVTFI)->vtable, 0, sizeof(layerVTableObj));
@@ -70,13 +63,10 @@ destroyVTFItem(VTFactoryItemObj **pVTFI)
   *pVTFI = NULL;
 }
 
-
-static VTFactoryItemObj *
-lookupVTFItem(VTFactoryObj *VTFactory,
-              const char *key)
-{
+static VTFactoryItemObj *lookupVTFItem(VTFactoryObj *VTFactory,
+                                       const char *key) {
   unsigned int i;
-  for (i=0; i < VTFactory->size && VTFactory->vtItems[i]; ++i) {
+  for (i = 0; i < VTFactory->size && VTFactory->vtItems[i]; ++i) {
     if (0 == strcasecmp(key, VTFactory->vtItems[i]->name)) {
       return VTFactory->vtItems[i];
     }
@@ -84,24 +74,24 @@ lookupVTFItem(VTFactoryObj *VTFactory,
   return NULL;
 }
 
-static int
-insertNewVTFItem(VTFactoryObj *pVTFactory,
-                 VTFactoryItemObj *pVTFI)
-{
+static int insertNewVTFItem(VTFactoryObj *pVTFactory, VTFactoryItemObj *pVTFI) {
   /* Ensure there is room for one more item in the array
    * (safe to use for initial alloc of the array as well)
    */
   if (pVTFactory->first_free == pVTFactory->size) {
     VTFactoryItemObj **vtItemPtr;
-    vtItemPtr = (VTFactoryItemObj**)realloc(pVTFactory->vtItems,
-                                            (pVTFactory->size+MS_LAYER_ALLOCSIZE)*sizeof(VTFactoryItemObj*));
-    MS_CHECK_ALLOC(vtItemPtr, (pVTFactory->size+MS_LAYER_ALLOCSIZE)*sizeof(VTFactoryItemObj*), MS_FAILURE);
-
+    vtItemPtr = (VTFactoryItemObj **)realloc(
+        pVTFactory->vtItems,
+        (pVTFactory->size + MS_LAYER_ALLOCSIZE) * sizeof(VTFactoryItemObj *));
+    MS_CHECK_ALLOC(vtItemPtr,
+                   (pVTFactory->size + MS_LAYER_ALLOCSIZE) *
+                       sizeof(VTFactoryItemObj *),
+                   MS_FAILURE);
 
     pVTFactory->size += MS_LAYER_ALLOCSIZE;
     pVTFactory->vtItems = vtItemPtr;
 
-    for (unsigned i=pVTFactory->first_free; i<pVTFactory->size; i++)
+    for (unsigned i = pVTFactory->first_free; i < pVTFactory->size; i++)
       pVTFactory->vtItems[i] = NULL;
   }
 
@@ -112,27 +102,29 @@ insertNewVTFItem(VTFactoryObj *pVTFactor
   return MS_SUCCESS;
 }
 
-static VTFactoryItemObj *
-loadCustomLayerDLL(layerObj *layer, const char *library_path)
-{
+static VTFactoryItemObj *loadCustomLayerDLL(layerObj *layer,
+                                            const char *library_path) {
   int (*pfnPluginInitVTable)(layerVTableObj *, layerObj *);
 
   VTFactoryItemObj *pVTFI;
 
-  pfnPluginInitVTable = msGetSymbol(library_path, "PluginInitializeVirtualTable");
-  if ( ! pfnPluginInitVTable) {
-    msSetError(MS_MISCERR, "Failed to load dynamic Layer LIB: %s", "loadCustomLayerDLL", library_path);
+  pfnPluginInitVTable =
+      msGetSymbol(library_path, "PluginInitializeVirtualTable");
+  if (!pfnPluginInitVTable) {
+    msSetError(MS_MISCERR, "Failed to load dynamic Layer LIB: %s",
+               "loadCustomLayerDLL", library_path);
     return NULL;
   }
 
   pVTFI = createVTFItem(library_path);
-  if ( ! pVTFI) {
+  if (!pVTFI) {
     return NULL;
   }
 
   if (pfnPluginInitVTable(&pVTFI->vtable, layer)) {
     destroyVTFItem(&pVTFI);
-    msSetError(MS_MISCERR, "Failed to initialize dynamic Layer: %s", "loadCustomLayerDLL", library_path);
+    msSetError(MS_MISCERR, "Failed to initialize dynamic Layer: %s",
+               "loadCustomLayerDLL", library_path);
     return NULL;
   }
   return pVTFI;
@@ -149,53 +141,80 @@ loadCustomLayerDLL(layerObj *layer, cons
  * Because of that, it is possible for plugin layer to use default
  * layer API default functions,  just leave those function pointers to NULL.
  */
-static void
-copyVirtualTable(layerVTableObj *dest,
-                 const layerVTableObj *src)
-{
-  dest->LayerTranslateFilter = src->LayerTranslateFilter ? src->LayerTranslateFilter : dest->LayerTranslateFilter;
-  dest->LayerSupportsCommonFilters = src->LayerSupportsCommonFilters ? src->LayerSupportsCommonFilters : dest->LayerSupportsCommonFilters;
-  dest->LayerInitItemInfo = src->LayerInitItemInfo ? src->LayerInitItemInfo : dest->LayerInitItemInfo;
-  dest->LayerFreeItemInfo = src->LayerFreeItemInfo ? src->LayerFreeItemInfo : dest->LayerFreeItemInfo;
+static void copyVirtualTable(layerVTableObj *dest, const layerVTableObj *src) {
+  dest->LayerTranslateFilter = src->LayerTranslateFilter
+                                   ? src->LayerTranslateFilter
+                                   : dest->LayerTranslateFilter;
+  dest->LayerSupportsCommonFilters = src->LayerSupportsCommonFilters
+                                         ? src->LayerSupportsCommonFilters
+                                         : dest->LayerSupportsCommonFilters;
+  dest->LayerInitItemInfo =
+      src->LayerInitItemInfo ? src->LayerInitItemInfo : dest->LayerInitItemInfo;
+  dest->LayerFreeItemInfo =
+      src->LayerFreeItemInfo ? src->LayerFreeItemInfo : dest->LayerFreeItemInfo;
   dest->LayerOpen = src->LayerOpen ? src->LayerOpen : dest->LayerOpen;
   dest->LayerIsOpen = src->LayerIsOpen ? src->LayerIsOpen : dest->LayerIsOpen;
-  dest->LayerWhichShapes = src->LayerWhichShapes ? src->LayerWhichShapes : dest->LayerWhichShapes;
-  dest->LayerNextShape = src->LayerNextShape ? src->LayerNextShape : dest->LayerNextShape;
-  dest->LayerGetShape = src->LayerGetShape ? src->LayerGetShape : dest->LayerGetShape;
-  /* dest->LayerResultsGetShape = src->LayerResultsGetShape ? src->LayerResultsGetShape : dest->LayerResultsGetShape; */
-  dest->LayerGetShapeCount = src->LayerGetShapeCount ? src->LayerGetShapeCount : dest->LayerGetShapeCount;
+  dest->LayerWhichShapes =
+      src->LayerWhichShapes ? src->LayerWhichShapes : dest->LayerWhichShapes;
+  dest->LayerNextShape =
+      src->LayerNextShape ? src->LayerNextShape : dest->LayerNextShape;
+  dest->LayerGetShape =
+      src->LayerGetShape ? src->LayerGetShape : dest->LayerGetShape;
+  /* dest->LayerResultsGetShape = src->LayerResultsGetShape ?
+   * src->LayerResultsGetShape : dest->LayerResultsGetShape; */
+  dest->LayerGetShapeCount = src->LayerGetShapeCount ? src->LayerGetShapeCount
+                                                     : dest->LayerGetShapeCount;
   dest->LayerClose = src->LayerClose ? src->LayerClose : dest->LayerClose;
-  dest->LayerGetItems = src->LayerGetItems ? src->LayerGetItems : dest->LayerGetItems;
-  dest->LayerGetExtent = src->LayerGetExtent ? src->LayerGetExtent : dest->LayerGetExtent;
-  dest->LayerGetAutoStyle = src->LayerGetAutoStyle ? src->LayerGetAutoStyle : dest->LayerGetAutoStyle;
-  dest->LayerCloseConnection = src->LayerCloseConnection ? src->LayerCloseConnection : dest->LayerCloseConnection;
-  dest->LayerSetTimeFilter = src->LayerSetTimeFilter ? src->LayerSetTimeFilter : dest->LayerSetTimeFilter;
-  dest->LayerApplyFilterToLayer = src->LayerApplyFilterToLayer ? src->LayerApplyFilterToLayer : dest->LayerApplyFilterToLayer;
-  dest->LayerCreateItems = src->LayerCreateItems ? src->LayerCreateItems : dest->LayerCreateItems;
-  dest->LayerGetNumFeatures = src->LayerGetNumFeatures ? src->LayerGetNumFeatures : dest->LayerGetNumFeatures;
-  dest->LayerGetAutoProjection = src->LayerGetAutoProjection ? src->LayerGetAutoProjection: dest->LayerGetAutoProjection;
-  dest->LayerEscapeSQLParam = src->LayerEscapeSQLParam ? src->LayerEscapeSQLParam: dest->LayerEscapeSQLParam;
-  dest->LayerEscapePropertyName = src->LayerEscapePropertyName ? src->LayerEscapePropertyName: dest->LayerEscapePropertyName;
-  dest->LayerEscapeSQLParam = src->LayerEscapeSQLParam ? src->LayerEscapeSQLParam: dest->LayerEscapeSQLParam;
-  dest->LayerEnablePaging = src->LayerEnablePaging ? src->LayerEnablePaging: dest->LayerEnablePaging;
-  dest->LayerGetPaging = src->LayerGetPaging ? src->LayerGetPaging: dest->LayerGetPaging;
-}
-
-int
-msPluginLayerInitializeVirtualTable(layerObj *layer)
-{
+  dest->LayerGetItems =
+      src->LayerGetItems ? src->LayerGetItems : dest->LayerGetItems;
+  dest->LayerGetExtent =
+      src->LayerGetExtent ? src->LayerGetExtent : dest->LayerGetExtent;
+  dest->LayerGetAutoStyle =
+      src->LayerGetAutoStyle ? src->LayerGetAutoStyle : dest->LayerGetAutoStyle;
+  dest->LayerCloseConnection = src->LayerCloseConnection
+                                   ? src->LayerCloseConnection
+                                   : dest->LayerCloseConnection;
+  dest->LayerSetTimeFilter = src->LayerSetTimeFilter ? src->LayerSetTimeFilter
+                                                     : dest->LayerSetTimeFilter;
+  dest->LayerApplyFilterToLayer = src->LayerApplyFilterToLayer
+                                      ? src->LayerApplyFilterToLayer
+                                      : dest->LayerApplyFilterToLayer;
+  dest->LayerCreateItems =
+      src->LayerCreateItems ? src->LayerCreateItems : dest->LayerCreateItems;
+  dest->LayerGetNumFeatures = src->LayerGetNumFeatures
+                                  ? src->LayerGetNumFeatures
+                                  : dest->LayerGetNumFeatures;
+  dest->LayerGetAutoProjection = src->LayerGetAutoProjection
+                                     ? src->LayerGetAutoProjection
+                                     : dest->LayerGetAutoProjection;
+  dest->LayerEscapeSQLParam = src->LayerEscapeSQLParam
+                                  ? src->LayerEscapeSQLParam
+                                  : dest->LayerEscapeSQLParam;
+  dest->LayerEscapePropertyName = src->LayerEscapePropertyName
+                                      ? src->LayerEscapePropertyName
+                                      : dest->LayerEscapePropertyName;
+  dest->LayerEscapeSQLParam = src->LayerEscapeSQLParam
+                                  ? src->LayerEscapeSQLParam
+                                  : dest->LayerEscapeSQLParam;
+  dest->LayerEnablePaging =
+      src->LayerEnablePaging ? src->LayerEnablePaging : dest->LayerEnablePaging;
+  dest->LayerGetPaging =
+      src->LayerGetPaging ? src->LayerGetPaging : dest->LayerGetPaging;
+}
+
+int msPluginLayerInitializeVirtualTable(layerObj *layer) {
   VTFactoryItemObj *pVTFI;
 
-  if (!layer->plugin_library){
-      return MS_FAILURE;
+  if (!layer->plugin_library) {
+    return MS_FAILURE;
   }
 
   msAcquireLock(TLOCK_LAYER_VTABLE);
 
   pVTFI = lookupVTFItem(&gVirtualTableFactory, layer->plugin_library);
-  if ( ! pVTFI) {
+  if (!pVTFI) {
     pVTFI = loadCustomLayerDLL(layer, layer->plugin_library);
-    if ( ! pVTFI) {
+    if (!pVTFI) {
       msReleaseLock(TLOCK_LAYER_VTABLE);
       return MS_FAILURE;
     }
@@ -214,12 +233,10 @@ msPluginLayerInitializeVirtualTable(laye
 /* msPluginFreeVirtualTableFactory()
 ** Called by msCleanup() to free the virtual table factory
 */
-void
-msPluginFreeVirtualTableFactory()
-{
+void msPluginFreeVirtualTableFactory() {
   msAcquireLock(TLOCK_LAYER_VTABLE);
 
-  for (unsigned i=0; i<gVirtualTableFactory.size; i++) {
+  for (unsigned i = 0; i < gVirtualTableFactory.size; i++) {
     if (gVirtualTableFactory.vtItems[i])
       destroyVTFItem(&(gVirtualTableFactory.vtItems[i]));
   }
diff -pruN 8.0.1-5/mappool.c 8.0.2-1/mappool.c
--- 8.0.1-5/mappool.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mappool.c	2024-06-11 20:41:34.000000000 +0000
@@ -66,7 +66,8 @@ on exit if called).  This case is called
 The CLOSE_CONNECTION=ALWAYS setting provides to suppress the connection pooling
 for a particular layer. In this case the MS_LIFE_SINGLE setting is used, which
 ensures that a new connection is created for each request and it is always
-closed when the connection is released. This kind of connection cannot be reused.
+closed when the connection is released. This kind of connection cannot be
+reused.
 
 The callback is a function provided with the connection handle when it is
 registered.  It takes a single "void *" argument which is the connection
@@ -134,29 +135,27 @@ o The connection pooling API will let a
 #include "mapserver.h"
 #include "mapthread.h"
 
-
-
 /* defines for lifetime.
    A positive number is a time-from-last use in seconds */
 
-#define MS_LIFE_FOREVER       -1
-#define MS_LIFE_ZEROREF       -2
-#define MS_LIFE_SINGLE        -3
+#define MS_LIFE_FOREVER -1
+#define MS_LIFE_ZEROREF -2
+#define MS_LIFE_SINGLE -3
 
 typedef struct {
   enum MS_CONNECTION_TYPE connectiontype;
   char *connection;
 
-  int   lifespan;
-  int   ref_count;
-  void*   thread_id;
-  int   debug;
+  int lifespan;
+  int ref_count;
+  void *thread_id;
+  int debug;
 
   time_t last_used;
 
-  void  *conn_handle;
+  void *conn_handle;
 
-  void  (*close)( void * );
+  void (*close)(void *);
 } connectionObj;
 
 /*
@@ -173,35 +172,30 @@ static connectionObj *connections = NULL
 /*      Register a new connection with the connection pool tracker.     */
 /************************************************************************/
 
-void msConnPoolRegister( layerObj *layer,
-                         void *conn_handle,
-                         void (*close_func)( void * ) )
+void msConnPoolRegister(layerObj *layer, void *conn_handle,
+                        void (*close_func)(void *))
 
 {
   const char *close_connection = NULL;
   connectionObj *conn = NULL;
 
-  if( layer->debug )
-    msDebug( "msConnPoolRegister(%s,%s,%p)\n",
-             layer->name, layer->connection, conn_handle );
+  if (layer->debug)
+    msDebug("msConnPoolRegister(%s,%s,%p)\n", layer->name, layer->connection,
+            conn_handle);
 
   /* -------------------------------------------------------------------- */
   /*      We can't meaningful keep a connection with no connection or     */
   /*      connection type string on the layer.                            */
   /* -------------------------------------------------------------------- */
-  if( layer->connection == NULL ) {
-    if( layer->tileindex != NULL
-        && layer->connectiontype == MS_OGR ) {
+  if (layer->connection == NULL) {
+    if (layer->tileindex != NULL && layer->connectiontype == MS_OGR) {
       /* this is ok, no need to make a fuss */
     } else {
-      msDebug( "%s: Missing CONNECTION on layer %s.\n",
-               "msConnPoolRegister()",
-               layer->name );
-
-      msSetError( MS_MISCERR,
-                  "Missing CONNECTION on layer %s.",
-                  "msConnPoolRegister()",
-                  layer->name );
+      msDebug("%s: Missing CONNECTION on layer %s.\n", "msConnPoolRegister()",
+              layer->name);
+
+      msSetError(MS_MISCERR, "Missing CONNECTION on layer %s.",
+                 "msConnPoolRegister()", layer->name);
     }
     return;
   }
@@ -209,16 +203,15 @@ void msConnPoolRegister( layerObj *layer
   /* -------------------------------------------------------------------- */
   /*      Grow the array of connection information objects if needed.     */
   /* -------------------------------------------------------------------- */
-  msAcquireLock( TLOCK_POOL );
+  msAcquireLock(TLOCK_POOL);
 
-  if( connectionCount == connectionMax ) {
+  if (connectionCount == connectionMax) {
     connectionMax += 10;
-    connectionObj* newConnections = (connectionObj *)
-                  realloc(connections,
-                          sizeof(connectionObj) * connectionMax );
-    if( newConnections == NULL ) {
+    connectionObj *newConnections = (connectionObj *)realloc(
+        connections, sizeof(connectionObj) * connectionMax);
+    if (newConnections == NULL) {
       msSetError(MS_MEMERR, NULL, "msConnPoolRegister()");
-      msReleaseLock( TLOCK_POOL );
+      msReleaseLock(TLOCK_POOL);
       return;
     }
     connections = newConnections;
@@ -232,7 +225,7 @@ void msConnPoolRegister( layerObj *layer
   connectionCount++;
 
   conn->connectiontype = layer->connectiontype;
-  conn->connection = msStrdup( layer->connection );
+  conn->connection = msStrdup(layer->connection);
   conn->close = close_func;
   conn->ref_count = 1;
   conn->thread_id = msGetThreadId();
@@ -243,30 +236,28 @@ void msConnPoolRegister( layerObj *layer
   /* -------------------------------------------------------------------- */
   /*      Categorize the connection handling information.                 */
   /* -------------------------------------------------------------------- */
-  close_connection =
-    msLayerGetProcessingKey( layer, "CLOSE_CONNECTION" );
+  close_connection = msLayerGetProcessingKey(layer, "CLOSE_CONNECTION");
 
-  if( close_connection == NULL )
+  if (close_connection == NULL)
     close_connection = "NORMAL";
 
-  if( strcasecmp(close_connection,"NORMAL") == 0 )
+  if (strcasecmp(close_connection, "NORMAL") == 0)
     conn->lifespan = MS_LIFE_ZEROREF;
-  else if( strcasecmp(close_connection,"DEFER") == 0 )
+  else if (strcasecmp(close_connection, "DEFER") == 0)
     conn->lifespan = MS_LIFE_FOREVER;
-  else if( strcasecmp(close_connection,"ALWAYS") == 0 )
+  else if (strcasecmp(close_connection, "ALWAYS") == 0)
     conn->lifespan = MS_LIFE_SINGLE;
   else {
     msDebug("msConnPoolRegister(): "
             "Unrecognised CLOSE_CONNECTION value '%s'\n",
-            close_connection );
+            close_connection);
 
-    msSetError( MS_MISCERR, "Unrecognised CLOSE_CONNECTION value '%s'",
-                "msConnPoolRegister()",
-                close_connection );
+    msSetError(MS_MISCERR, "Unrecognised CLOSE_CONNECTION value '%s'",
+               "msConnPoolRegister()", close_connection);
     conn->lifespan = MS_LIFE_ZEROREF;
   }
 
-  msReleaseLock( TLOCK_POOL );
+  msReleaseLock(TLOCK_POOL);
 }
 
 /************************************************************************/
@@ -277,45 +268,40 @@ void msConnPoolRegister( layerObj *layer
 /*      well.                                                           */
 /************************************************************************/
 
-static void msConnPoolClose( int conn_index )
+static void msConnPoolClose(int conn_index)
 
 {
   connectionObj *conn = connections + conn_index;
 
-  if( conn->ref_count > 0 ) {
-    if( conn->debug )
-      msDebug( "msConnPoolClose(): "
-               "Closing connection %s even though ref_count=%d.\n",
-               conn->connection, conn->ref_count );
-
-    msSetError( MS_MISCERR,
-                "Closing connection %s even though ref_count=%d.",
-                "msConnPoolClose()",
-                conn->connection,
-                conn->ref_count );
+  if (conn->ref_count > 0) {
+    if (conn->debug)
+      msDebug("msConnPoolClose(): "
+              "Closing connection %s even though ref_count=%d.\n",
+              conn->connection, conn->ref_count);
+
+    msSetError(MS_MISCERR, "Closing connection %s even though ref_count=%d.",
+               "msConnPoolClose()", conn->connection, conn->ref_count);
   }
 
-  if( conn->debug )
-    msDebug( "msConnPoolClose(%s,%p)\n",
-             conn->connection, conn->conn_handle );
+  if (conn->debug)
+    msDebug("msConnPoolClose(%s,%p)\n", conn->connection, conn->conn_handle);
 
-  if( conn->close != NULL )
-    conn->close( conn->conn_handle );
+  if (conn->close != NULL)
+    conn->close(conn->conn_handle);
 
   /* free malloced() stuff in this connection */
-  free( conn->connection );
+  free(conn->connection);
 
   connectionCount--;
-  if( connectionCount == 0 ) {
+  if (connectionCount == 0) {
     /* if there are no connections left we will "cleanup".  */
     connectionMax = 0;
-    free( connections );
+    free(connections);
     connections = NULL;
   } else {
     /* move the last connection in place of our now closed one */
-    memcpy( connections + conn_index,
-            connections + connectionCount,
-            sizeof(connectionObj) );
+    memcpy(connections + conn_index, connections + connectionCount,
+           sizeof(connectionObj));
   }
 }
 
@@ -328,48 +314,48 @@ static void msConnPoolClose( int conn_in
 /*      return NULL.                                                    */
 /************************************************************************/
 
-void *msConnPoolRequest( layerObj *layer )
+void *msConnPoolRequest(layerObj *layer)
 
 {
-  int  i;
-  const char* close_connection;
+  int i;
+  const char *close_connection;
 
-  if( layer->connection == NULL )
+  if (layer->connection == NULL)
     return NULL;
 
   /* check if we must always create a new connection */
-  close_connection = msLayerGetProcessingKey( layer, "CLOSE_CONNECTION" );
-  if( close_connection && strcasecmp(close_connection,"ALWAYS") == 0 )
+  close_connection = msLayerGetProcessingKey(layer, "CLOSE_CONNECTION");
+  if (close_connection && strcasecmp(close_connection, "ALWAYS") == 0)
     return NULL;
 
-  msAcquireLock( TLOCK_POOL );
-  for( i = 0; i < connectionCount; i++ ) {
+  msAcquireLock(TLOCK_POOL);
+  for (i = 0; i < connectionCount; i++) {
     connectionObj *conn = connections + i;
 
-    if( layer->connectiontype == conn->connectiontype
-        && strcasecmp( layer->connection, conn->connection ) == 0
-        && (conn->ref_count == 0 || conn->thread_id == msGetThreadId())
-        && conn->lifespan != MS_LIFE_SINGLE) {
+    if (layer->connectiontype == conn->connectiontype &&
+        strcasecmp(layer->connection, conn->connection) == 0 &&
+        (conn->ref_count == 0 || conn->thread_id == msGetThreadId()) &&
+        conn->lifespan != MS_LIFE_SINGLE) {
       void *conn_handle = NULL;
 
       conn->ref_count++;
       conn->thread_id = msGetThreadId();
       conn->last_used = time(NULL);
 
-      if( layer->debug ) {
-        msDebug( "msConnPoolRequest(%s,%s) -> got %p\n",
-                 layer->name, layer->connection, conn->conn_handle );
+      if (layer->debug) {
+        msDebug("msConnPoolRequest(%s,%s) -> got %p\n", layer->name,
+                layer->connection, conn->conn_handle);
         conn->debug = layer->debug;
       }
 
       conn_handle = conn->conn_handle;
 
-      msReleaseLock( TLOCK_POOL );
+      msReleaseLock(TLOCK_POOL);
       return conn_handle;
     }
   }
 
-  msReleaseLock( TLOCK_POOL );
+  msReleaseLock(TLOCK_POOL);
 
   return NULL;
 }
@@ -383,49 +369,47 @@ void *msConnPoolRequest( layerObj *layer
 /*      acquired the pool lock.                                         */
 /************************************************************************/
 
-void msConnPoolRelease( layerObj *layer, void *conn_handle )
+void msConnPoolRelease(layerObj *layer, void *conn_handle)
 
 {
-  int  i;
+  int i;
 
-  if( layer->debug )
-    msDebug( "msConnPoolRelease(%s,%s,%p)\n",
-             layer->name, layer->connection, conn_handle );
+  if (layer->debug)
+    msDebug("msConnPoolRelease(%s,%s,%p)\n", layer->name, layer->connection,
+            conn_handle);
 
-  if( layer->connection == NULL )
+  if (layer->connection == NULL)
     return;
 
-  msAcquireLock( TLOCK_POOL );
-  for( i = 0; i < connectionCount; i++ ) {
+  msAcquireLock(TLOCK_POOL);
+  for (i = 0; i < connectionCount; i++) {
     connectionObj *conn = connections + i;
 
-    if( layer->connectiontype == conn->connectiontype
-        && strcasecmp( layer->connection, conn->connection ) == 0
-        && conn->conn_handle == conn_handle ) {
+    if (layer->connectiontype == conn->connectiontype &&
+        strcasecmp(layer->connection, conn->connection) == 0 &&
+        conn->conn_handle == conn_handle) {
       conn->ref_count--;
       conn->last_used = time(NULL);
 
-      if( conn->ref_count == 0 )
+      if (conn->ref_count == 0)
         conn->thread_id = 0;
 
-      if( conn->ref_count == 0 && (conn->lifespan == MS_LIFE_ZEROREF || conn->lifespan == MS_LIFE_SINGLE) )
-        msConnPoolClose( i );
+      if (conn->ref_count == 0 && (conn->lifespan == MS_LIFE_ZEROREF ||
+                                   conn->lifespan == MS_LIFE_SINGLE))
+        msConnPoolClose(i);
 
-      msReleaseLock( TLOCK_POOL );
+      msReleaseLock(TLOCK_POOL);
       return;
     }
   }
 
-  msReleaseLock( TLOCK_POOL );
+  msReleaseLock(TLOCK_POOL);
+
+  msDebug("%s: Unable to find handle for layer '%s'.\n", "msConnPoolRelease()",
+          layer->name);
 
-  msDebug( "%s: Unable to find handle for layer '%s'.\n",
-           "msConnPoolRelease()",
-           layer->name );
-
-  msSetError( MS_MISCERR,
-              "Unable to find handle for layer '%s'.",
-              "msConnPoolRelease()",
-              layer->name );
+  msSetError(MS_MISCERR, "Unable to find handle for layer '%s'.",
+             "msConnPoolRelease()", layer->name);
 }
 
 /************************************************************************/
@@ -437,22 +421,22 @@ void msConnPoolRelease( layerObj *layer,
 void msConnPoolCloseUnreferenced()
 
 {
-  int  i;
+  int i;
 
   /* this really needs to be commented out before commiting.  */
   /* msDebug( "msConnPoolCloseUnreferenced()\n" ); */
 
-  msAcquireLock( TLOCK_POOL );
-  for( i = connectionCount - 1; i >= 0; i-- ) {
+  msAcquireLock(TLOCK_POOL);
+  for (i = connectionCount - 1; i >= 0; i--) {
     connectionObj *conn = connections + i;
 
-    if( conn->ref_count == 0 ) {
+    if (conn->ref_count == 0) {
       /* for now we don't assume the locks are re-entrant, so release */
       /* it so msConnPoolClose() can get it.  */
-      msConnPoolClose( i );
+      msConnPoolClose(i);
     }
   }
-  msReleaseLock( TLOCK_POOL );
+  msReleaseLock(TLOCK_POOL);
 }
 
 /************************************************************************/
@@ -468,8 +452,8 @@ void msConnPoolFinalCleanup()
   /* this really needs to be commented out before commiting.  */
   /* msDebug( "msConnPoolFinalCleanup()\n" ); */
 
-  msAcquireLock( TLOCK_POOL );
-  while( connectionCount > 0 )
-    msConnPoolClose( 0 );
-  msReleaseLock( TLOCK_POOL );
+  msAcquireLock(TLOCK_POOL);
+  while (connectionCount > 0)
+    msConnPoolClose(0);
+  msReleaseLock(TLOCK_POOL);
 }
diff -pruN 8.0.1-5/mappostgis.cpp 8.0.2-1/mappostgis.cpp
--- 8.0.1-5/mappostgis.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mappostgis.cpp	2024-06-11 20:41:34.000000000 +0000
@@ -45,7 +45,8 @@
 ** as the client endianness.
 **
 ** msPostGISLayerWhichShapes creates SQL based on DATA and LAYER state,
-** executes it, and places the un-read PGresult handle in the layerinfo->pgresult,
+** executes it, and places the un-read PGresult handle in the
+*layerinfo->pgresult,
 ** setting the layerinfo->rownum to 0.
 **
 ** msPostGISNextShape reads a row, increments layerinfo->rownum, and returns
@@ -67,7 +68,7 @@
 #include <vector>
 
 #define FP_EPSILON 1e-12
-#define FP_EQ(a, b) (fabs((a)-(b)) < FP_EPSILON)
+#define FP_EQ(a, b) (fabs((a) - (b)) < FP_EPSILON)
 #define FP_LEFT -1
 #define FP_RIGHT 1
 #define FP_COLINEAR 0
@@ -78,8 +79,8 @@
 #define WKBZOFFSET_NONISO 0x80000000
 #define WKBMOFFSET_NONISO 0x40000000
 
-#define HAS_Z   0x1
-#define HAS_M   0x2
+#define HAS_Z 0x1
+#define HAS_M 0x2
 
 #if TRANSFER_ENCODING == 256
 #define RESULTSET_TYPE 1
@@ -91,43 +92,44 @@
 /* They were copied from pg_type.h in src/include/catalog/pg_type.h */
 
 #ifndef BOOLOID
-#define BOOLOID                 16
-#define BYTEAOID                17
-#define CHAROID                 18
-#define NAMEOID                 19
-#define INT8OID                 20
-#define INT2OID                 21
-#define INT2VECTOROID           22
-#define INT4OID                 23
-#define REGPROCOID              24
-#define TEXTOID                 25
-#define OIDOID                  26
-#define TIDOID                  27
-#define XIDOID                  28
-#define CIDOID                  29
-#define OIDVECTOROID            30
-#define FLOAT4OID               700
-#define FLOAT8OID               701
-#define INT4ARRAYOID            1007
-#define TEXTARRAYOID            1009
-#define BPCHARARRAYOID          1014
-#define VARCHARARRAYOID         1015
-#define FLOAT4ARRAYOID          1021
-#define FLOAT8ARRAYOID          1022
-#define BPCHAROID   1042
-#define VARCHAROID    1043
-#define DATEOID     1082
-#define TIMEOID     1083
-#define TIMETZOID     1266
-#define TIMESTAMPOID          1114
-#define TIMESTAMPTZOID          1184
-#define NUMERICOID              1700
+#define BOOLOID 16
+#define BYTEAOID 17
+#define CHAROID 18
+#define NAMEOID 19
+#define INT8OID 20
+#define INT2OID 21
+#define INT2VECTOROID 22
+#define INT4OID 23
+#define REGPROCOID 24
+#define TEXTOID 25
+#define OIDOID 26
+#define TIDOID 27
+#define XIDOID 28
+#define CIDOID 29
+#define OIDVECTOROID 30
+#define FLOAT4OID 700
+#define FLOAT8OID 701
+#define INT4ARRAYOID 1007
+#define TEXTARRAYOID 1009
+#define BPCHARARRAYOID 1014
+#define VARCHARARRAYOID 1015
+#define FLOAT4ARRAYOID 1021
+#define FLOAT8ARRAYOID 1022
+#define BPCHAROID 1042
+#define VARCHAROID 1043
+#define DATEOID 1082
+#define TIMEOID 1083
+#define TIMETZOID 1266
+#define TIMESTAMPOID 1114
+#define TIMESTAMPTZOID 1184
+#define NUMERICOID 1700
 #endif
 
 #ifdef USE_POSTGIS
 
 static int wkbConvGeometryToShape(wkbObj *w, shapeObj *shape);
-static int arcStrokeCircularString(wkbObj *w, double segment_angle, lineObj *line, int nZMFlag);
+static int arcStrokeCircularString(wkbObj *w, double segment_angle,
+                                   lineObj *line, int nZMFlag);
 
 /*
 ** msPostGISCloseConnection()
@@ -135,16 +137,14 @@ static int arcStrokeCircularString(wkbOb
 ** Handler registered witih msConnPoolRegister so that Mapserver
 ** can clean up open connections during a shutdown.
 */
-static void msPostGISCloseConnection(void *pgconn)
-{
-  PQfinish((PGconn*)pgconn);
+static void msPostGISCloseConnection(void *pgconn) {
+  PQfinish((PGconn *)pgconn);
 }
 
 /*
 ** msPostGISCreateLayerInfo()
 */
-static msPostGISLayerInfo *msPostGISCreateLayerInfo(void)
-{
+static msPostGISLayerInfo *msPostGISCreateLayerInfo(void) {
   msPostGISLayerInfo *layerinfo = new msPostGISLayerInfo;
   layerinfo->paging = MS_TRUE;
   layerinfo->force2d = MS_FALSE;
@@ -154,38 +154,35 @@ static msPostGISLayerInfo *msPostGISCrea
 /*
 ** msPostGISFreeLayerInfo()
 */
-static void msPostGISFreeLayerInfo(layerObj *layer)
-{
-  msPostGISLayerInfo *layerinfo = (msPostGISLayerInfo*)layer->layerinfo;
-  if ( layerinfo->pgresult ) PQclear(layerinfo->pgresult);
-  if ( layerinfo->pgconn ) msConnPoolRelease(layer, layerinfo->pgconn);
+static void msPostGISFreeLayerInfo(layerObj *layer) {
+  msPostGISLayerInfo *layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
+  if (layerinfo->pgresult)
+    PQclear(layerinfo->pgresult);
+  if (layerinfo->pgconn)
+    msConnPoolRelease(layer, layerinfo->pgconn);
   delete layerinfo;
   layer->layerinfo = nullptr;
 }
 
-
 /*
 ** postgresqlNoticeHandler()
 **
 ** Propagate messages from the database to the Mapserver log,
 ** set in PQsetNoticeProcessor during layer open.
 */
-static void postresqlNoticeHandler(void *arg, const char *message)
-{
-  layerObj *lp = (layerObj*)arg;
+static void postresqlNoticeHandler(void *arg, const char *message) {
+  layerObj *lp = (layerObj *)arg;
 
   if (lp->debug) {
     msDebug("%s\n", message);
   }
 }
 
-
 /*
 ** Expandable pointObj array. The lineObj unfortunately
 ** is not useful for this purpose, so we have this one.
 */
-static std::vector<pointObj> pointArrayNew(int maxpoints)
-{
+static std::vector<pointObj> pointArrayNew(int maxpoints) {
   auto v = std::vector<pointObj>();
   v.reserve(maxpoints);
   return v;
@@ -194,9 +191,7 @@ static std::vector<pointObj> pointArrayN
 /*
 ** Add a pointObj to the pointObjArray.
 */
-static void
-pointArrayAddPoint(std::vector<pointObj>& v, const pointObj& p)
-{
+static void pointArrayAddPoint(std::vector<pointObj> &v, const pointObj &p) {
   v.push_back(p);
 }
 
@@ -205,44 +200,37 @@ pointArrayAddPoint(std::vector<pointObj>
 ** type map array to handle the pre-2.0 incorrect WKB types
 */
 
-static int
-wkbTypeMap(wkbObj *w, int type, int* pnZMFlag)
-{
+static int wkbTypeMap(wkbObj *w, int type, int *pnZMFlag) {
   *pnZMFlag = 0;
   /* PostGIS >= 2 : ISO SQL/MM style Z types ? */
-  if( type >= 1000 && type < 2000 )
-  {
+  if (type >= 1000 && type < 2000) {
     type -= 1000;
     *pnZMFlag = HAS_Z;
   }
   /* PostGIS >= 2 : ISO SQL/MM style M types ? */
-  else if( type >= 2000 && type < 3000 )
-  {
+  else if (type >= 2000 && type < 3000) {
     type -= 2000;
     *pnZMFlag = HAS_M;
   }
   /* PostGIS >= 2 : ISO SQL/MM style ZM types ? */
-  else if( type >= 3000 && type < 4000 )
-  {
+  else if (type >= 3000 && type < 4000) {
     type -= 3000;
     *pnZMFlag = HAS_Z | HAS_M;
   }
   /* PostGIS 1.X EWKB : Extended WKB Z or ZM ? */
-  else if( (type & WKBZOFFSET_NONISO) != 0 )
-  {
-    if( (type & WKBMOFFSET_NONISO) != 0 )
-        *pnZMFlag = HAS_Z | HAS_M;
+  else if ((type & WKBZOFFSET_NONISO) != 0) {
+    if ((type & WKBMOFFSET_NONISO) != 0)
+      *pnZMFlag = HAS_Z | HAS_M;
     else
-        *pnZMFlag = HAS_Z;
+      *pnZMFlag = HAS_Z;
     type &= 0x00FFFFFF;
   }
   /* PostGIS 1.X EWKB: Extended WKB M ? */
-  else if( (type & WKBMOFFSET_NONISO) != 0 )
-  {
+  else if ((type & WKBMOFFSET_NONISO) != 0) {
     *pnZMFlag = HAS_M;
     type &= 0x00FFFFFF;
   }
-  if ( type >= 0 && type < WKB_TYPE_COUNT )
+  if (type >= 0 && type < WKB_TYPE_COUNT)
     return w->typemap[type];
   else
     return 0;
@@ -252,32 +240,26 @@ wkbTypeMap(wkbObj *w, int type, int* pnZ
 ** Read the WKB type number from a wkbObj without
 ** advancing the read pointer.
 */
-static int
-wkbType(wkbObj *w, int* pnZMFlag)
-{
+static int wkbType(wkbObj *w, int *pnZMFlag) {
   int t;
   memcpy(&t, (w->ptr + 1), sizeof(int));
-  return wkbTypeMap(w,t, pnZMFlag);
+  return wkbTypeMap(w, t, pnZMFlag);
 }
 
 /*
 ** Read the type number of the first element of a
 ** collection without advancing the read pointer.
 */
-static int
-wkbCollectionSubType(wkbObj *w, int* pnZMFlag)
-{
+static int wkbCollectionSubType(wkbObj *w, int *pnZMFlag) {
   int t;
   memcpy(&t, (w->ptr + 1 + 4 + 4 + 1), sizeof(int));
-  return wkbTypeMap(w,t, pnZMFlag);
+  return wkbTypeMap(w, t, pnZMFlag);
 }
 
 /*
 ** Read one byte from the WKB and advance the read pointer
 */
-static char
-wkbReadChar(wkbObj *w)
-{
+static char wkbReadChar(wkbObj *w) {
   char c;
   memcpy(&c, w->ptr, sizeof(char));
   w->ptr += sizeof(char);
@@ -288,9 +270,7 @@ wkbReadChar(wkbObj *w)
 ** Read one integer from the WKB and advance the read pointer.
 ** We assume the endianess of the WKB is the same as this machine.
 */
-static inline int
-wkbReadInt(wkbObj *w)
-{
+static inline int wkbReadInt(wkbObj *w) {
   int i;
   memcpy(&i, w->ptr, sizeof(int));
   w->ptr += sizeof(int);
@@ -301,30 +281,22 @@ wkbReadInt(wkbObj *w)
 ** Read one pointObj (two doubles) from the WKB and advance the read pointer.
 ** We assume the endianess of the WKB is the same as this machine.
 */
-static inline void
-wkbReadPointP(wkbObj *w, pointObj *p, int nZMFlag)
-{
+static inline void wkbReadPointP(wkbObj *w, pointObj *p, int nZMFlag) {
   memcpy(&(p->x), w->ptr, sizeof(double));
   w->ptr += sizeof(double);
   memcpy(&(p->y), w->ptr, sizeof(double));
   w->ptr += sizeof(double);
-  if( nZMFlag & HAS_Z )
-  {
-      memcpy(&(p->z), w->ptr, sizeof(double));
-      w->ptr += sizeof(double);
-  }
-  else
-  {
-      p->z = 0;
-  }
-  if( nZMFlag & HAS_M )
-  {
-      memcpy(&(p->m), w->ptr, sizeof(double));
-      w->ptr += sizeof(double);
+  if (nZMFlag & HAS_Z) {
+    memcpy(&(p->z), w->ptr, sizeof(double));
+    w->ptr += sizeof(double);
+  } else {
+    p->z = 0;
   }
-  else
-  {
-      p->m = 0;
+  if (nZMFlag & HAS_M) {
+    memcpy(&(p->m), w->ptr, sizeof(double));
+    w->ptr += sizeof(double);
+  } else {
+    p->m = 0;
   }
 }
 
@@ -332,9 +304,7 @@ wkbReadPointP(wkbObj *w, pointObj *p, in
 ** Read one pointObj (two doubles) from the WKB and advance the read pointer.
 ** We assume the endianess of the WKB is the same as this machine.
 */
-static inline pointObj
-wkbReadPoint(wkbObj *w, int nZMFlag)
-{
+static inline pointObj wkbReadPoint(wkbObj *w, int nZMFlag) {
   pointObj p;
   wkbReadPointP(w, &p, nZMFlag);
   return p;
@@ -347,17 +317,15 @@ wkbReadPoint(wkbObj *w, int nZMFlag)
 ** Linestrings, circular strings, polygon rings, all show this
 ** form.
 */
-static void
-wkbReadLine(wkbObj *w, lineObj *line, int nZMFlag)
-{
+static void wkbReadLine(wkbObj *w, lineObj *line, int nZMFlag) {
   pointObj p;
   const int npoints = wkbReadInt(w);
-  if( npoints > (int)((w->size - (w->ptr - w->wkb)) / 16) )
+  if (npoints > (int)((w->size - (w->ptr - w->wkb)) / 16))
     return;
 
   line->numpoints = npoints;
-  line->point =(pointObj*) msSmallMalloc(npoints * sizeof(pointObj));
-  for ( int i = 0; i < npoints; i++ ) {
+  line->point = (pointObj *)msSmallMalloc(npoints * sizeof(pointObj));
+  for (int i = 0; i < npoints; i++) {
     wkbReadPointP(w, &p, nZMFlag);
     line->point[i] = p;
   }
@@ -367,68 +335,67 @@ wkbReadLine(wkbObj *w, lineObj *line, in
 ** Advance the read pointer past a geometry without returning any
 ** values. Used for skipping un-drawable elements in a collection.
 */
-static void
-wkbSkipGeometry(wkbObj *w)
-{
-  /*endian = */wkbReadChar(w);
+static void wkbSkipGeometry(wkbObj *w) {
+  /*endian = */ wkbReadChar(w);
   int nZMFlag;
-  const int type = wkbTypeMap(w,wkbReadInt(w), &nZMFlag);
-  const int nCoordDim = 2 + (((nZMFlag & HAS_Z) != 0) ? 1 : 0) + (((nZMFlag & HAS_M) != 0) ? 1 : 0);
-  switch(type) {
-    case WKB_POINT:
-      w->ptr += nCoordDim * sizeof(double);
-      break;
-    case WKB_CIRCULARSTRING:
-    case WKB_LINESTRING: {
+  const int type = wkbTypeMap(w, wkbReadInt(w), &nZMFlag);
+  const int nCoordDim = 2 + (((nZMFlag & HAS_Z) != 0) ? 1 : 0) +
+                        (((nZMFlag & HAS_M) != 0) ? 1 : 0);
+  switch (type) {
+  case WKB_POINT:
+    w->ptr += nCoordDim * sizeof(double);
+    break;
+  case WKB_CIRCULARSTRING:
+  case WKB_LINESTRING: {
+    const int npoints = wkbReadInt(w);
+    w->ptr += npoints * nCoordDim * sizeof(double);
+    break;
+  }
+  case WKB_POLYGON: {
+    const int nrings = wkbReadInt(w);
+    if (nrings > (int)((w->size - (w->ptr - w->wkb)) / 4))
+      return;
+    for (int i = 0; i < nrings; i++) {
       const int npoints = wkbReadInt(w);
       w->ptr += npoints * nCoordDim * sizeof(double);
-      break;
-    }
-    case WKB_POLYGON: {
-      const int nrings = wkbReadInt(w);
-      if( nrings > (int)((w->size - (w->ptr - w->wkb)) / 4) )
-        return;
-      for ( int i = 0; i < nrings; i++ ) {
-        const int npoints = wkbReadInt(w);
-        w->ptr += npoints * nCoordDim * sizeof(double);
-      }
-      break;
     }
-    case WKB_MULTIPOINT:
-    case WKB_MULTILINESTRING:
-    case WKB_MULTIPOLYGON:
-    case WKB_GEOMETRYCOLLECTION:
-    case WKB_COMPOUNDCURVE:
-    case WKB_CURVEPOLYGON:
-    case WKB_MULTICURVE:
-    case WKB_MULTISURFACE: {
-      const int ngeoms = wkbReadInt(w);
-      if( ngeoms > (int)((w->size - (w->ptr - w->wkb)) / 4) )
-        return;
-      for ( int i = 0; i < ngeoms; i++ ) {
-        wkbSkipGeometry(w);
-      }
-      break;
+    break;
+  }
+  case WKB_MULTIPOINT:
+  case WKB_MULTILINESTRING:
+  case WKB_MULTIPOLYGON:
+  case WKB_GEOMETRYCOLLECTION:
+  case WKB_COMPOUNDCURVE:
+  case WKB_CURVEPOLYGON:
+  case WKB_MULTICURVE:
+  case WKB_MULTISURFACE: {
+    const int ngeoms = wkbReadInt(w);
+    if (ngeoms > (int)((w->size - (w->ptr - w->wkb)) / 4))
+      return;
+    for (int i = 0; i < ngeoms; i++) {
+      wkbSkipGeometry(w);
     }
+    break;
+  }
   }
 }
 
 /*
 ** Convert a WKB point to a shapeObj, advancing the read pointer as we go.
 */
-static int
-wkbConvPointToShape(wkbObj *w, shapeObj *shape)
-{
-  /*endian = */wkbReadChar(w);
+static int wkbConvPointToShape(wkbObj *w, shapeObj *shape) {
+  /*endian = */ wkbReadChar(w);
   int nZMFlag;
-  const int type = wkbTypeMap(w,wkbReadInt(w),&nZMFlag);
+  const int type = wkbTypeMap(w, wkbReadInt(w), &nZMFlag);
 
-  if( type != WKB_POINT ) return MS_FAILURE;
+  if (type != WKB_POINT)
+    return MS_FAILURE;
 
-  if( ! (shape->type == MS_SHAPE_POINT) ) return MS_FAILURE;
+  if (!(shape->type == MS_SHAPE_POINT))
+    return MS_FAILURE;
   lineObj line;
   line.numpoints = 1;
-  line.point = (pointObj*) msSmallMalloc(sizeof(pointObj));
+  line.point = (pointObj *)msSmallMalloc(sizeof(pointObj));
   line.point[0] = wkbReadPoint(w, nZMFlag);
   msAddLineDirectly(shape, &line);
   return MS_SUCCESS;
@@ -437,17 +404,16 @@ wkbConvPointToShape(wkbObj *w, shapeObj
 /*
 ** Convert a WKB line string to a shapeObj, advancing the read pointer as we go.
 */
-static int
-wkbConvLineStringToShape(wkbObj *w, shapeObj *shape)
-{
-  /*endian = */wkbReadChar(w);
+static int wkbConvLineStringToShape(wkbObj *w, shapeObj *shape) {
+  /*endian = */ wkbReadChar(w);
   int nZMFlag;
-  const int type = wkbTypeMap(w,wkbReadInt(w), &nZMFlag);
+  const int type = wkbTypeMap(w, wkbReadInt(w), &nZMFlag);
 
-  if( type != WKB_LINESTRING ) return MS_FAILURE;
+  if (type != WKB_LINESTRING)
+    return MS_FAILURE;
 
   lineObj line;
-  wkbReadLine(w,&line, nZMFlag);
+  wkbReadLine(w, &line, nZMFlag);
   msAddLineDirectly(shape, &line);
 
   return MS_SUCCESS;
@@ -456,24 +422,23 @@ wkbConvLineStringToShape(wkbObj *w, shap
 /*
 ** Convert a WKB polygon to a shapeObj, advancing the read pointer as we go.
 */
-static int
-wkbConvPolygonToShape(wkbObj *w, shapeObj *shape)
-{
-  /*endian = */wkbReadChar(w);
+static int wkbConvPolygonToShape(wkbObj *w, shapeObj *shape) {
+  /*endian = */ wkbReadChar(w);
   int nZMFlag;
-  const int type = wkbTypeMap(w,wkbReadInt(w), &nZMFlag);
+  const int type = wkbTypeMap(w, wkbReadInt(w), &nZMFlag);
 
-  if( type != WKB_POLYGON ) return MS_FAILURE;
+  if (type != WKB_POLYGON)
+    return MS_FAILURE;
 
   /* How many rings? */
   const int nrings = wkbReadInt(w);
-  if( nrings > (int)((w->size - (w->ptr - w->wkb)) / 4) )
+  if (nrings > (int)((w->size - (w->ptr - w->wkb)) / 4))
     return MS_FAILURE;
 
   /* Add each ring to the shape */
   lineObj line;
-  for( int i = 0; i < nrings; i++ ) {
-    wkbReadLine(w,&line, nZMFlag);
+  for (int i = 0; i < nrings; i++) {
+    wkbReadLine(w, &line, nZMFlag);
     msAddLineDirectly(shape, &line);
   }
 
@@ -481,69 +446,72 @@ wkbConvPolygonToShape(wkbObj *w, shapeOb
 }
 
 /*
-** Convert a WKB curve polygon to a shapeObj, advancing the read pointer as we go.
+** Convert a WKB curve polygon to a shapeObj, advancing the read pointer as we
+*go.
 ** The arc portions of the rings will be stroked to linestrings as they
 ** are read by the underlying circular string handling.
 */
-static int
-wkbConvCurvePolygonToShape(wkbObj *w, shapeObj *shape)
-{
-  const int was_poly = ( shape->type == MS_SHAPE_POLYGON );
+static int wkbConvCurvePolygonToShape(wkbObj *w, shapeObj *shape) {
+  const int was_poly = (shape->type == MS_SHAPE_POLYGON);
 
-  /*endian = */wkbReadChar(w);
+  /*endian = */ wkbReadChar(w);
   int nZMFlag;
-  const int type = wkbTypeMap(w,wkbReadInt(w), &nZMFlag);
-  if( type != WKB_CURVEPOLYGON ) return MS_FAILURE;
+  const int type = wkbTypeMap(w, wkbReadInt(w), &nZMFlag);
+  if (type != WKB_CURVEPOLYGON)
+    return MS_FAILURE;
 
   const int ncomponents = wkbReadInt(w);
-  if( ncomponents > (int)((w->size - (w->ptr - w->wkb)) / 4) )
+  if (ncomponents > (int)((w->size - (w->ptr - w->wkb)) / 4))
     return MS_FAILURE;
 
   /* Lower the allowed dimensionality so we can
-  *  catch the linear ring components */
+   *  catch the linear ring components */
   shape->type = MS_SHAPE_LINE;
 
   int failures = 0;
-  for ( int i = 0; i < ncomponents; i++ ) {
-    if ( wkbConvGeometryToShape(w, shape) == MS_FAILURE ) {
+  for (int i = 0; i < ncomponents; i++) {
+    if (wkbConvGeometryToShape(w, shape) == MS_FAILURE) {
       wkbSkipGeometry(w);
       failures++;
     }
   }
 
   /* Go back to expected dimensionality */
-  if ( was_poly) shape->type = MS_SHAPE_POLYGON;
+  if (was_poly)
+    shape->type = MS_SHAPE_POLYGON;
 
-  if ( failures == ncomponents )
+  if (failures == ncomponents)
     return MS_FAILURE;
   else
     return MS_SUCCESS;
 }
 
 /*
-** Convert a WKB circular string to a shapeObj, advancing the read pointer as we go.
+** Convert a WKB circular string to a shapeObj, advancing the read pointer as we
+*go.
 ** Arcs will be stroked to linestrings.
 */
-static int
-wkbConvCircularStringToShape(wkbObj *w, shapeObj *shape)
-{
-  /*endian = */wkbReadChar(w);
+static int wkbConvCircularStringToShape(wkbObj *w, shapeObj *shape) {
+  /*endian = */ wkbReadChar(w);
   int nZMFlag;
-  const int type = wkbTypeMap(w,wkbReadInt(w), &nZMFlag);
+  const int type = wkbTypeMap(w, wkbReadInt(w), &nZMFlag);
 
-  if( type != WKB_CIRCULARSTRING ) return MS_FAILURE;
+  if (type != WKB_CIRCULARSTRING)
+    return MS_FAILURE;
 
   lineObj line = {0, nullptr};
   /* Stroke the string into a point array */
-  if ( arcStrokeCircularString(w, SEGMENT_ANGLE, &line, nZMFlag) == MS_FAILURE ) {
-    if(line.point) free(line.point);
+  if (arcStrokeCircularString(w, SEGMENT_ANGLE, &line, nZMFlag) == MS_FAILURE) {
+    if (line.point)
+      free(line.point);
     return MS_FAILURE;
   }
 
   /* Fill in the lineObj */
-  if ( line.numpoints > 0 ) {
+  if (line.numpoints > 0) {
     msAddLine(shape, &line);
-    if(line.point) free(line.point);
+    if (line.point)
+      free(line.point);
   }
 
   return MS_SUCCESS;
@@ -556,52 +524,52 @@ wkbConvCircularStringToShape(wkbObj *w,
 ** allows compound curves to serve as closed rings in
 ** curve polygons.
 */
-static int
-wkbConvCompoundCurveToShape(wkbObj *w, shapeObj *shape)
-{
-  /*endian = */wkbReadChar(w);
+static int wkbConvCompoundCurveToShape(wkbObj *w, shapeObj *shape) {
+  /*endian = */ wkbReadChar(w);
   int nZMFlag;
-  const int type = wkbTypeMap(w,wkbReadInt(w), &nZMFlag);
+  const int type = wkbTypeMap(w, wkbReadInt(w), &nZMFlag);
 
   /* Init our shape buffer */
   shapeObj shapebuf;
   msInitShape(&shapebuf);
 
-  if( type != WKB_COMPOUNDCURVE ) return MS_FAILURE;
+  if (type != WKB_COMPOUNDCURVE)
+    return MS_FAILURE;
 
   /* How many components in the compound curve? */
   const int ncomponents = wkbReadInt(w);
-  if( ncomponents > (int)((w->size - (w->ptr - w->wkb)) / 4) )
+  if (ncomponents > (int)((w->size - (w->ptr - w->wkb)) / 4))
     return MS_FAILURE;
 
   /* We'll load each component onto a line in a shape */
-  for( int i = 0; i < ncomponents; i++ )
+  for (int i = 0; i < ncomponents; i++)
     wkbConvGeometryToShape(w, &shapebuf);
 
   /* Do nothing on empty */
-  if ( shapebuf.numlines == 0 )
+  if (shapebuf.numlines == 0)
     return MS_FAILURE;
 
   /* Count the total number of points */
   int npoints = 0;
-  for( int i = 0; i < shapebuf.numlines; i++ )
+  for (int i = 0; i < shapebuf.numlines; i++)
     npoints += shapebuf.line[i].numpoints;
 
   /* Do nothing on empty */
-  if ( npoints == 0 )
+  if (npoints == 0)
     return MS_FAILURE;
 
   lineObj line;
   line.numpoints = npoints;
-  line.point = (pointObj*) msSmallMalloc(sizeof(pointObj) * npoints);
+  line.point = (pointObj *)msSmallMalloc(sizeof(pointObj) * npoints);
 
   /* Copy in the points */
   npoints = 0;
-  for ( int i = 0; i < shapebuf.numlines; i++ ) {
-    for ( int j = 0; j < shapebuf.line[i].numpoints; j++ ) {
+  for (int i = 0; i < shapebuf.numlines; i++) {
+    for (int j = 0; j < shapebuf.line[i].numpoints; j++) {
       /* Don't add a start point that duplicates an endpoint */
-      if( j == 0 && i > 0 &&
-          memcmp(&(line.point[npoints - 1]),&(shapebuf.line[i].point[j]),sizeof(pointObj)) == 0 ) {
+      if (j == 0 && i > 0 &&
+          memcmp(&(line.point[npoints - 1]), &(shapebuf.line[i].point[j]),
+                 sizeof(pointObj)) == 0) {
         continue;
       }
       line.point[npoints++] = shapebuf.line[i].point[j];
@@ -619,34 +587,34 @@ wkbConvCompoundCurveToShape(wkbObj *w, s
 }
 
 /*
-** Convert a WKB collection string to a shapeObj, advancing the read pointer as we go.
+** Convert a WKB collection string to a shapeObj, advancing the read pointer as
+*we go.
 ** Many WKB types (MultiPoint, MultiLineString, MultiPolygon, MultiSurface,
 ** MultiCurve, GeometryCollection) can be treated identically as collections
-** (they start with endian, type number and count of sub-elements, then provide the
+** (they start with endian, type number and count of sub-elements, then provide
+*the
 ** subelements as WKB) so are handled with this one function.
 */
-static int
-wkbConvCollectionToShape(wkbObj *w, shapeObj *shape)
-{
-  /*endian = */wkbReadChar(w);
+static int wkbConvCollectionToShape(wkbObj *w, shapeObj *shape) {
+  /*endian = */ wkbReadChar(w);
   int nZMFlag;
-  /*type = */wkbTypeMap(w,wkbReadInt(w), &nZMFlag);
+  /*type = */ wkbTypeMap(w, wkbReadInt(w), &nZMFlag);
   const int ncomponents = wkbReadInt(w);
-  if( ncomponents > (int)((w->size - (w->ptr - w->wkb)) / 4) )
+  if (ncomponents > (int)((w->size - (w->ptr - w->wkb)) / 4))
     return MS_FAILURE;
 
   /*
-  * If we can draw any portion of the collection, we will,
-  * but if all the components fail, we will draw nothing.
-  */
+   * If we can draw any portion of the collection, we will,
+   * but if all the components fail, we will draw nothing.
+   */
   int failures = 0;
-  for ( int i = 0; i < ncomponents; i++ ) {
-    if ( wkbConvGeometryToShape(w, shape) == MS_FAILURE ) {
+  for (int i = 0; i < ncomponents; i++) {
+    if (wkbConvGeometryToShape(w, shape) == MS_FAILURE) {
       wkbSkipGeometry(w);
       failures++;
     }
   }
-  if ( failures == ncomponents || ncomponents == 0)
+  if (failures == ncomponents || ncomponents == 0)
     return MS_FAILURE;
   else
     return MS_SUCCESS;
@@ -659,71 +627,69 @@ wkbConvCollectionToShape(wkbObj *w, shap
 ** a MS_SHAPE_LINE layer, so if the type is WKB_POINT and the layer is
 ** MS_SHAPE_LINE, we exit before converting.
 */
-static int
-wkbConvGeometryToShape(wkbObj *w, shapeObj *shape)
-{
+static int wkbConvGeometryToShape(wkbObj *w, shapeObj *shape) {
   int nZMFlag;
   const int wkbtype = wkbType(w, &nZMFlag); /* Peak at the type number */
 
-  switch(wkbtype) {
-      /* Recurse into anonymous collections */
-    case WKB_GEOMETRYCOLLECTION:
-      return wkbConvCollectionToShape(w, shape);
-      /* Handle area types */
-    case WKB_POLYGON:
-      return wkbConvPolygonToShape(w, shape);
-    case WKB_MULTIPOLYGON:
-      return wkbConvCollectionToShape(w, shape);
-    case WKB_CURVEPOLYGON:
-      return wkbConvCurvePolygonToShape(w, shape);
-    case WKB_MULTISURFACE:
-      return wkbConvCollectionToShape(w, shape);
+  switch (wkbtype) {
+    /* Recurse into anonymous collections */
+  case WKB_GEOMETRYCOLLECTION:
+    return wkbConvCollectionToShape(w, shape);
+    /* Handle area types */
+  case WKB_POLYGON:
+    return wkbConvPolygonToShape(w, shape);
+  case WKB_MULTIPOLYGON:
+    return wkbConvCollectionToShape(w, shape);
+  case WKB_CURVEPOLYGON:
+    return wkbConvCurvePolygonToShape(w, shape);
+  case WKB_MULTISURFACE:
+    return wkbConvCollectionToShape(w, shape);
   }
 
   /* We can't convert any of the following types into polygons */
-  if ( shape->type == MS_SHAPE_POLYGON ) return MS_FAILURE;
+  if (shape->type == MS_SHAPE_POLYGON)
+    return MS_FAILURE;
 
   /* Handle linear types */
-  switch(wkbtype) {
-    case WKB_LINESTRING:
-      return wkbConvLineStringToShape(w, shape);
-    case WKB_CIRCULARSTRING:
-      return wkbConvCircularStringToShape(w, shape);
-    case WKB_COMPOUNDCURVE:
-      return wkbConvCompoundCurveToShape(w, shape);
-    case WKB_MULTILINESTRING:
-      return wkbConvCollectionToShape(w, shape);
-    case WKB_MULTICURVE:
-      return wkbConvCollectionToShape(w, shape);
+  switch (wkbtype) {
+  case WKB_LINESTRING:
+    return wkbConvLineStringToShape(w, shape);
+  case WKB_CIRCULARSTRING:
+    return wkbConvCircularStringToShape(w, shape);
+  case WKB_COMPOUNDCURVE:
+    return wkbConvCompoundCurveToShape(w, shape);
+  case WKB_MULTILINESTRING:
+    return wkbConvCollectionToShape(w, shape);
+  case WKB_MULTICURVE:
+    return wkbConvCollectionToShape(w, shape);
   }
 
   /* We can't convert any of the following types into lines */
-  if ( shape->type == MS_SHAPE_LINE ) return MS_FAILURE;
+  if (shape->type == MS_SHAPE_LINE)
+    return MS_FAILURE;
 
   /* Handle point types */
-  switch(wkbtype) {
-    case WKB_POINT:
-      return wkbConvPointToShape(w, shape);
-    case WKB_MULTIPOINT:
-      return wkbConvCollectionToShape(w, shape);
+  switch (wkbtype) {
+  case WKB_POINT:
+    return wkbConvPointToShape(w, shape);
+  case WKB_MULTIPOINT:
+    return wkbConvCollectionToShape(w, shape);
   }
 
   /* This is a WKB type we don't know about! */
   return MS_FAILURE;
 }
 
-
 /*
 ** What side of p1->p2 is q on?
 */
-static inline int
-arcSegmentSide(const pointObj &p1, const pointObj &p2, const pointObj &q)
-{
-  double side = ( (q.x - p1.x) * (p2.y - p1.y) - (p2.x - p1.x) * (q.y - p1.y) );
-  if ( FP_EQ(side,0.0) ) {
+static inline int arcSegmentSide(const pointObj &p1, const pointObj &p2,
+                                 const pointObj &q) {
+  double side = ((q.x - p1.x) * (p2.y - p1.y) - (p2.x - p1.x) * (q.y - p1.y));
+  if (FP_EQ(side, 0.0)) {
     return FP_COLINEAR;
   } else {
-    if ( side < 0.0 )
+    if (side < 0.0)
       return FP_LEFT;
     else
       return FP_RIGHT;
@@ -732,22 +698,23 @@ arcSegmentSide(const pointObj &p1, const
 
 /*
 ** Calculate the center of the circle defined by three points.
-** Using matrix approach from http://mathforum.org/library/drmath/view/55239.html
+** Using matrix approach from
+*http://mathforum.org/library/drmath/view/55239.html
 */
-static int
-arcCircleCenter(const pointObj& p1, const pointObj& p2, const pointObj& p3, pointObj *center, double *radius)
-{
+static int arcCircleCenter(const pointObj &p1, const pointObj &p2,
+                           const pointObj &p3, pointObj *center,
+                           double *radius) {
   pointObj c{}; // initialize
   double r;
 
   /* Circle is closed, so p2 must be opposite p1 & p3. */
-  if ((fabs(p1.x - p3.x) < FP_EPSILON) && (fabs(p1.y-p3.y) < FP_EPSILON)) {
+  if ((fabs(p1.x - p3.x) < FP_EPSILON) && (fabs(p1.y - p3.y) < FP_EPSILON)) {
     c.x = p1.x + (p2.x - p1.x) / 2.0;
     c.y = p1.y + (p2.y - p1.y) / 2.0;
     r = sqrt(pow(c.x - p1.x, 2.0) + pow(c.y - p1.y, 2.0));
   }
   /* There is no circle here, the points are actually co-linear */
-  else if ( arcSegmentSide(p1, p3, p2) == FP_COLINEAR ) {
+  else if (arcSegmentSide(p1, p3, p2) == FP_COLINEAR) {
     return MS_FAILURE;
   }
   /* Calculate the center and radius. */
@@ -762,7 +729,8 @@ arcCircleCenter(const pointObj& p1, cons
     const double h21 = pow(dx21, 2.0) + pow(dy21, 2.0);
     const double h31 = pow(dx31, 2.0) + pow(dy31, 2.0);
 
-    /* 2 * |Cross product|, d<0 means clockwise and d>0 counterclockwise sweeping angle */
+    /* 2 * |Cross product|, d<0 means clockwise and d>0 counterclockwise
+     * sweeping angle */
     const double d = 2 * (dx21 * dy31 - dx31 * dy21);
 
     c.x = p1.x + (h21 * dy31 - h31 * dy21) / d;
@@ -770,33 +738,36 @@ arcCircleCenter(const pointObj& p1, cons
     r = sqrt(pow(c.x - p1.x, 2) + pow(c.y - p1.y, 2));
   }
 
-  if ( radius ) *radius = r;
-  if ( center ) *center = c;
+  if (radius)
+    *radius = r;
+  if (center)
+    *center = c;
 
   return MS_SUCCESS;
 }
 
 /*
 ** Write a stroked version of the circle defined by three points into a
-** point buffer. The segment_angle (degrees) is the coverage of each stroke segment,
+** point buffer. The segment_angle (degrees) is the coverage of each stroke
+*segment,
 ** and depending on whether this is the first arc in a circularstring,
 ** you might want to include_first
 */
-static int
-arcStrokeCircle(const pointObj& p1, const pointObj& p2, const pointObj& p3,
-                double segment_angle, int include_first, std::vector<pointObj>& pa)
-{
-  const int side = arcSegmentSide(p1, p3, p2); /* What side of p1,p3 is the middle point? */
+static int arcStrokeCircle(const pointObj &p1, const pointObj &p2,
+                           const pointObj &p3, double segment_angle,
+                           int include_first, std::vector<pointObj> &pa) {
+  const int side =
+      arcSegmentSide(p1, p3, p2); /* What side of p1,p3 is the middle point? */
   int is_closed = MS_FALSE;
 
   /* We need to know if we're dealing with a circle early */
-  if ( FP_EQ(p1.x, p3.x) && FP_EQ(p1.y, p3.y) )
+  if (FP_EQ(p1.x, p3.x) && FP_EQ(p1.y, p3.y))
     is_closed = MS_TRUE;
 
   /* Check if the "arc" is actually straight */
-  if ( ! is_closed && side == FP_COLINEAR ) {
+  if (!is_closed && side == FP_COLINEAR) {
     /* We just need to write in the end points */
-    if ( include_first )
+    if (include_first)
       pointArrayAddPoint(pa, p1);
     pointArrayAddPoint(pa, p3);
     return MS_SUCCESS;
@@ -804,8 +775,8 @@ arcStrokeCircle(const pointObj& p1, cons
 
   /* We should always be able to find the center of a non-linear arc */
   pointObj center; /* Center of our circular arc */
-  double radius; /* Radius of our circular arc */
-  if ( arcCircleCenter(p1, p2, p3, &center, &radius) == MS_FAILURE )
+  double radius;   /* Radius of our circular arc */
+  if (arcCircleCenter(p1, p2, p3, &center, &radius) == MS_FAILURE)
     return MS_FAILURE;
 
   /* Calculate the angles relative to center that our three points represent */
@@ -814,23 +785,24 @@ arcStrokeCircle(const pointObj& p1, cons
   a2 = atan2(p2.y - center.y, p2.x - center.x);
    */
   const double a3 = atan2(p3.y - center.y, p3.x - center.x);
-  double segment_angle_r = M_PI * segment_angle / 180.0; /* Segment angle in radians */
+  double segment_angle_r =
+      M_PI * segment_angle / 180.0; /* Segment angle in radians */
 
   double sweep_angle_r; /* Total angular size of our circular arc in radians */
   /* Closed-circle case, we sweep the whole circle! */
-  if ( is_closed ) {
+  if (is_closed) {
     sweep_angle_r = 2.0 * M_PI;
   }
   /* Clockwise sweep direction */
-  else if ( side == FP_LEFT ) {
-    if ( a3 > a1 ) /* Wrapping past 180? */
+  else if (side == FP_LEFT) {
+    if (a3 > a1) /* Wrapping past 180? */
       sweep_angle_r = a1 + (2.0 * M_PI - a3);
     else
       sweep_angle_r = a1 - a3;
   }
   /* Counter-clockwise sweep direction */
-  else if ( side == FP_RIGHT ) {
-    if ( a3 > a1 ) /* Wrapping past 180? */
+  else if (side == FP_RIGHT) {
+    if (a3 > a1) /* Wrapping past 180? */
       sweep_angle_r = a3 - a1;
     else
       sweep_angle_r = a3 + (2.0 * M_PI - a1);
@@ -838,30 +810,30 @@ arcStrokeCircle(const pointObj& p1, cons
     sweep_angle_r = 0.0;
 
   /* We don't have enough resolution, let's invert our strategy. */
-  if ( (sweep_angle_r / segment_angle_r) < SEGMENT_MINPOINTS ) {
+  if ((sweep_angle_r / segment_angle_r) < SEGMENT_MINPOINTS) {
     segment_angle_r = sweep_angle_r / (SEGMENT_MINPOINTS + 1);
   }
 
   /* We don't have enough resolution to stroke this arc,
-  *  so just join the start to the end. */
-  if ( sweep_angle_r < segment_angle_r ) {
-    if ( include_first )
+   *  so just join the start to the end. */
+  if (sweep_angle_r < segment_angle_r) {
+    if (include_first)
       pointArrayAddPoint(pa, p1);
     pointArrayAddPoint(pa, p3);
     return MS_SUCCESS;
   }
 
   /* How many edges to generate (we add the final edge
-  *  by sticking on the last point */
+   *  by sticking on the last point */
   int num_edges = floor(sweep_angle_r / fabs(segment_angle_r));
 
   /* Go backwards (negative angular steps) if we are stroking clockwise */
-  if ( side == FP_LEFT )
+  if (side == FP_LEFT)
     segment_angle_r *= -1;
 
   /* What point should we start with? */
   double current_angle_r; /* What angle are we generating now (radians)? */
-  if( include_first ) {
+  if (include_first) {
     current_angle_r = a1;
   } else {
     current_angle_r = a1 + segment_angle_r;
@@ -869,14 +841,14 @@ arcStrokeCircle(const pointObj& p1, cons
   }
 
   /* For each edge, increment or decrement by our segment angle */
-  for( int i = 0; i < num_edges; i++ ) {
+  for (int i = 0; i < num_edges; i++) {
     if (segment_angle_r > 0.0 && current_angle_r > M_PI)
-      current_angle_r -= 2*M_PI;
-    if (segment_angle_r < 0.0 && current_angle_r < -1*M_PI)
-      current_angle_r -= 2*M_PI;
+      current_angle_r -= 2 * M_PI;
+    if (segment_angle_r < 0.0 && current_angle_r < -1 * M_PI)
+      current_angle_r -= 2 * M_PI;
     pointObj p;
-    p.x = center.x + radius*cos(current_angle_r);
-    p.y = center.y + radius*sin(current_angle_r);
+    p.x = center.x + radius * cos(current_angle_r);
+    p.y = center.y + radius * sin(current_angle_r);
     pointArrayAddPoint(pa, p);
     current_angle_r += segment_angle_r;
   }
@@ -892,31 +864,32 @@ arcStrokeCircle(const pointObj& p1, cons
 ** is stroked into a linestring and appended into the lineObj
 ** argument.
 */
-static int
-arcStrokeCircularString(wkbObj *w, double segment_angle, lineObj *line, int nZMFlag)
-{
-  if ( ! w || ! line ) return MS_FAILURE;
+static int arcStrokeCircularString(wkbObj *w, double segment_angle,
+                                   lineObj *line, int nZMFlag) {
+  if (!w || !line)
+    return MS_FAILURE;
 
   const int npoints = wkbReadInt(w);
   const int nedges = npoints / 2;
 
   /* All CircularStrings have an odd number of points */
-  if ( npoints < 3 || npoints % 2 != 1 )
+  if (npoints < 3 || npoints % 2 != 1)
     return MS_FAILURE;
 
   /* Make a large guess at how much space we'll need */
   auto pa = pointArrayNew(nedges * 180 / segment_angle);
 
   pointObj p1, p2, p3;
-  wkbReadPointP(w,&p3,nZMFlag);
+  wkbReadPointP(w, &p3, nZMFlag);
 
   /* Fill out the point array with stroked arcs */
   int edge = 0;
-  while( edge < nedges ) {
+  while (edge < nedges) {
     p1 = p3;
-    wkbReadPointP(w,&p2,nZMFlag);
-    wkbReadPointP(w,&p3,nZMFlag);
-    if ( arcStrokeCircle(p1, p2, p3, segment_angle, edge ? 0 : 1, pa) == MS_FAILURE ) {
+    wkbReadPointP(w, &p2, nZMFlag);
+    wkbReadPointP(w, &p3, nZMFlag);
+    if (arcStrokeCircle(p1, p2, p3, segment_angle, edge ? 0 : 1, pa) ==
+        MS_FAILURE) {
       return MS_FAILURE;
     }
     edge++;
@@ -924,13 +897,12 @@ arcStrokeCircularString(wkbObj *w, doubl
 
   /* Copy the point array into the line */
   line->numpoints = static_cast<int>(pa.size());
-  line->point = (pointObj*) msSmallMalloc(line->numpoints * sizeof(pointObj));
+  line->point = (pointObj *)msSmallMalloc(line->numpoints * sizeof(pointObj));
   memcpy(line->point, pa.data(), line->numpoints * sizeof(pointObj));
 
   return MS_SUCCESS;
 }
 
-
 /*
 ** For LAYER types that are not the usual ones (charts,
 ** annotations, etc) we will convert to a shape type
@@ -938,36 +910,34 @@ arcStrokeCircularString(wkbObj *w, doubl
 ** by peaking at the type number of the first collection
 ** sub-element.
 */
-static int
-msPostGISFindBestType(wkbObj *w, shapeObj *shape)
-{
+static int msPostGISFindBestType(wkbObj *w, shapeObj *shape) {
   /* What kind of geometry is this? */
   int nZMFlag;
   int wkbtype = wkbType(w, &nZMFlag);
 
   /* Generic collection, we need to look a little deeper. */
-  if ( wkbtype == WKB_GEOMETRYCOLLECTION )
+  if (wkbtype == WKB_GEOMETRYCOLLECTION)
     wkbtype = wkbCollectionSubType(w, &nZMFlag);
 
-  switch ( wkbtype ) {
-    case WKB_POLYGON:
-    case WKB_CURVEPOLYGON:
-    case WKB_MULTIPOLYGON:
-      shape->type = MS_SHAPE_POLYGON;
-      break;
-    case WKB_LINESTRING:
-    case WKB_CIRCULARSTRING:
-    case WKB_COMPOUNDCURVE:
-    case WKB_MULTICURVE:
-    case WKB_MULTILINESTRING:
-      shape->type = MS_SHAPE_LINE;
-      break;
-    case WKB_POINT:
-    case WKB_MULTIPOINT:
-      shape->type = MS_SHAPE_POINT;
-      break;
-    default:
-      return MS_FAILURE;
+  switch (wkbtype) {
+  case WKB_POLYGON:
+  case WKB_CURVEPOLYGON:
+  case WKB_MULTIPOLYGON:
+    shape->type = MS_SHAPE_POLYGON;
+    break;
+  case WKB_LINESTRING:
+  case WKB_CIRCULARSTRING:
+  case WKB_COMPOUNDCURVE:
+  case WKB_MULTICURVE:
+  case WKB_MULTILINESTRING:
+    shape->type = MS_SHAPE_LINE;
+    break;
+  case WKB_POINT:
+  case WKB_MULTIPOINT:
+    shape->type = MS_SHAPE_POINT;
+    break;
+  default:
+    return MS_FAILURE;
   }
 
   return wkbConvGeometryToShape(w, shape);
@@ -977,42 +947,44 @@ msPostGISFindBestType(wkbObj *w, shapeOb
 ** Get the PostGIS version number from the database as integer.
 ** Versions are multiplied out as with PgSQL: 1.5.2 -> 10502, 2.0.0 -> 20000.
 */
-static int
-msPostGISRetrieveVersion(PGconn *pgconn)
-{
-  static const char* sql = "SELECT postgis_version()";
-  if ( ! pgconn ) {
-    msSetError(MS_QUERYERR, "No open connection.", "msPostGISRetrieveVersion()");
+static int msPostGISRetrieveVersion(PGconn *pgconn) {
+  static const char *sql = "SELECT postgis_version()";
+  if (!pgconn) {
+    msSetError(MS_QUERYERR, "No open connection.",
+               "msPostGISRetrieveVersion()");
     return MS_FAILURE;
   }
 
-  PGresult* pgresult = PQexecParams(pgconn, sql,0, nullptr, nullptr, nullptr, nullptr, 0);
+  PGresult *pgresult =
+      PQexecParams(pgconn, sql, 0, nullptr, nullptr, nullptr, nullptr, 0);
 
-  if ( !pgresult || PQresultStatus(pgresult) != PGRES_TUPLES_OK) {
+  if (!pgresult || PQresultStatus(pgresult) != PGRES_TUPLES_OK) {
     msDebug("Error executing SQL: (%s) in msPostGISRetrieveVersion()", sql);
-    msSetError(MS_QUERYERR, "Error executing SQL. check server logs.", "msPostGISRetrieveVersion()");
+    msSetError(MS_QUERYERR, "Error executing SQL. check server logs.",
+               "msPostGISRetrieveVersion()");
     return MS_FAILURE;
   }
 
   if (PQgetisnull(pgresult, 0, 0)) {
     PQclear(pgresult);
-    msSetError(MS_QUERYERR,"Null result returned.","msPostGISRetrieveVersion()");
+    msSetError(MS_QUERYERR, "Null result returned.",
+               "msPostGISRetrieveVersion()");
     return MS_FAILURE;
   }
 
   std::string strVersion = PQgetvalue(pgresult, 0, 0);
   PQclear(pgresult);
 
-  char* ptr = &strVersion[0];
-  char *strParts[3] = { nullptr, nullptr, nullptr };
+  char *ptr = &strVersion[0];
+  char *strParts[3] = {nullptr, nullptr, nullptr};
   int j = 0;
   strParts[j++] = &strVersion[0];
-  while( *ptr != '\0' && j < 3 ) {
-    if ( *ptr == '.' ) {
+  while (*ptr != '\0' && j < 3) {
+    if (*ptr == '.') {
       *ptr = '\0';
       strParts[j++] = ptr + 1;
     }
-    if ( *ptr == ' ' ) {
+    if (*ptr == ' ') {
       *ptr = '\0';
       break;
     }
@@ -1021,7 +993,7 @@ msPostGISRetrieveVersion(PGconn *pgconn)
 
   int version = 0;
   int factor = 10000;
-  for( int i = 0; i < j; i++ ) {
+  for (int i = 0; i < j; i++) {
     version += factor * atoi(strParts[i]);
     factor = factor / 100;
   }
@@ -1033,26 +1005,29 @@ msPostGISRetrieveVersion(PGconn *pgconn)
 ** Get the PostgreSQL server version number from the database as integer.
 ** 12.7.1 ==> 120701
 */
-static int
-msPostGISRetrievePostgreSQLVersion(PGconn *pgconn)
-{
-  static const char* sql = "SELECT version()";
-  if ( ! pgconn ) {
-    msSetError(MS_QUERYERR, "No open connection.", "msPostGISRetrievePostgreSQLVersion()");
+static int msPostGISRetrievePostgreSQLVersion(PGconn *pgconn) {
+  static const char *sql = "SELECT version()";
+  if (!pgconn) {
+    msSetError(MS_QUERYERR, "No open connection.",
+               "msPostGISRetrievePostgreSQLVersion()");
     return MS_FAILURE;
   }
 
-  PGresult* pgresult = PQexecParams(pgconn, sql,0, nullptr, nullptr, nullptr, nullptr, 0);
+  PGresult *pgresult =
+      PQexecParams(pgconn, sql, 0, nullptr, nullptr, nullptr, nullptr, 0);
 
-  if ( !pgresult || PQresultStatus(pgresult) != PGRES_TUPLES_OK) {
-    msDebug("Error executing SQL: (%s) in msPostGISRetrievePostgreSQLVersion()", sql);
-    msSetError(MS_QUERYERR, "Error executing SQL. check server logs.", "msPostGISRetrievePostgreSQLVersion()");
+  if (!pgresult || PQresultStatus(pgresult) != PGRES_TUPLES_OK) {
+    msDebug("Error executing SQL: (%s) in msPostGISRetrievePostgreSQLVersion()",
+            sql);
+    msSetError(MS_QUERYERR, "Error executing SQL. check server logs.",
+               "msPostGISRetrievePostgreSQLVersion()");
     return MS_FAILURE;
   }
 
   if (PQgetisnull(pgresult, 0, 0)) {
     PQclear(pgresult);
-    msSetError(MS_QUERYERR,"Null result returned.","msPostGISRetrievePostgreSQLVersion()");
+    msSetError(MS_QUERYERR, "Null result returned.",
+               "msPostGISRetrievePostgreSQLVersion()");
     return MS_FAILURE;
   }
 
@@ -1061,19 +1036,19 @@ msPostGISRetrievePostgreSQLVersion(PGcon
 
   // Skip leading "PostgreSQL " (or other vendorized name)
   auto nPos = strVersion.find(' ');
-  if( nPos == std::string::npos )
-      return 0;
+  if (nPos == std::string::npos)
+    return 0;
 
-  char* ptr = &strVersion[nPos + 1];
-  char *strParts[3] = { nullptr, nullptr, nullptr };
+  char *ptr = &strVersion[nPos + 1];
+  char *strParts[3] = {nullptr, nullptr, nullptr};
   int j = 0;
   strParts[j++] = ptr;
-  while( *ptr != '\0' && j < 3 ) {
-    if ( *ptr == '.' ) {
+  while (*ptr != '\0' && j < 3) {
+    if (*ptr == '.') {
       *ptr = '\0';
       strParts[j++] = ptr + 1;
     }
-    if ( *ptr == ' ' ) {
+    if (*ptr == ' ') {
       *ptr = '\0';
       break;
     }
@@ -1082,7 +1057,7 @@ msPostGISRetrievePostgreSQLVersion(PGcon
 
   int version = 0;
   int factor = 10000;
-  for( int i = 0; i < j; i++ ) {
+  for (int i = 0; i < j; i++) {
     version += factor * atoi(strParts[i]);
     factor = factor / 100;
   }
@@ -1097,20 +1072,18 @@ msPostGISRetrievePostgreSQLVersion(PGcon
 ** The layerinfo->fromsource must already be populated and
 ** must not be a subquery.
 */
-static int
-msPostGISRetrievePK(layerObj *layer)
-{
+static int msPostGISRetrievePK(layerObj *layer) {
   char *sql = nullptr;
 
   if (layer->debug) {
     msDebug("msPostGISRetrievePK called.\n");
   }
 
-  msPostGISLayerInfo *layerinfo = (msPostGISLayerInfo *) layer->layerinfo;
-
+  msPostGISLayerInfo *layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
 
   if (layerinfo->pgconn == nullptr) {
-    msSetError(MS_QUERYERR, "Layer does not have a postgis connection.", "msPostGISRetrievePK()");
+    msSetError(MS_QUERYERR, "Layer does not have a postgis connection.",
+               "msPostGISRetrievePK()");
     return MS_FAILURE;
   }
 
@@ -1124,7 +1097,8 @@ msPostGISRetrievePK(layerObj *layer)
       table = layerinfo->fromsource.substr(pos_sep + 1);
 
       if (layer->debug) {
-        msDebug("msPostGISRetrievePK(): Found schema %s, table %s.\n", schema.c_str(), table.c_str());
+        msDebug("msPostGISRetrievePK(): Found schema %s, table %s.\n",
+                schema.c_str(), table.c_str());
       }
     }
     /*
@@ -1133,12 +1107,27 @@ msPostGISRetrievePK(layerObj *layer)
     ** pks are explicitly excluded from the query.
     */
     if (!schema.empty()) {
-      static const char *v73sql = "select attname from pg_attribute, pg_constraint, pg_class, pg_namespace where pg_constraint.conrelid = pg_class.oid and pg_class.oid = pg_attribute.attrelid and pg_constraint.contype = 'p' and pg_constraint.conkey[1] = pg_attribute.attnum and pg_class.relname = '%s' and pg_class.relnamespace = pg_namespace.oid and pg_namespace.nspname = '%s' and pg_constraint.conkey[2] is null";
-      sql = (char*) msSmallMalloc(schema.size() + table.size() + strlen(v73sql) + 1);
+      static const char *v73sql =
+          "select attname from pg_attribute, pg_constraint, pg_class, "
+          "pg_namespace where pg_constraint.conrelid = pg_class.oid and "
+          "pg_class.oid = pg_attribute.attrelid and pg_constraint.contype = "
+          "'p' and pg_constraint.conkey[1] = pg_attribute.attnum and "
+          "pg_class.relname = '%s' and pg_class.relnamespace = "
+          "pg_namespace.oid and pg_namespace.nspname = '%s' and "
+          "pg_constraint.conkey[2] is null";
+      sql = (char *)msSmallMalloc(schema.size() + table.size() +
+                                  strlen(v73sql) + 1);
       sprintf(sql, v73sql, table.c_str(), schema.c_str());
     } else {
-      static const char *v73sql = "select attname from pg_attribute, pg_constraint, pg_class where pg_constraint.conrelid = pg_class.oid and pg_class.oid = pg_attribute.attrelid and pg_constraint.contype = 'p' and pg_constraint.conkey[1] = pg_attribute.attnum and pg_class.relname = '%s' and pg_table_is_visible(pg_class.oid) and pg_constraint.conkey[2] is null";
-      sql = (char*) msSmallMalloc(layerinfo->fromsource.size() + strlen(v73sql) + 1);
+      static const char *v73sql =
+          "select attname from pg_attribute, pg_constraint, pg_class where "
+          "pg_constraint.conrelid = pg_class.oid and pg_class.oid = "
+          "pg_attribute.attrelid and pg_constraint.contype = 'p' and "
+          "pg_constraint.conkey[1] = pg_attribute.attnum and pg_class.relname "
+          "= '%s' and pg_table_is_visible(pg_class.oid) and "
+          "pg_constraint.conkey[2] is null";
+      sql = (char *)msSmallMalloc(layerinfo->fromsource.size() +
+                                  strlen(v73sql) + 1);
       sprintf(sql, v73sql, layerinfo->fromsource.c_str());
     }
   }
@@ -1147,16 +1136,18 @@ msPostGISRetrievePK(layerObj *layer)
     msDebug("msPostGISRetrievePK: %s\n", sql);
   }
 
-  layerinfo = (msPostGISLayerInfo *) layer->layerinfo;
+  layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
 
   if (layerinfo->pgconn == nullptr) {
-    msSetError(MS_QUERYERR, "Layer does not have a postgis connection.", "msPostGISRetrievePK()");
+    msSetError(MS_QUERYERR, "Layer does not have a postgis connection.",
+               "msPostGISRetrievePK()");
     free(sql);
     return MS_FAILURE;
   }
 
-  PGresult *pgresult = PQexecParams(layerinfo->pgconn, sql, 0, nullptr, nullptr, nullptr, nullptr, 0);
-  if ( !pgresult || PQresultStatus(pgresult) != PGRES_TUPLES_OK) {
+  PGresult *pgresult = PQexecParams(layerinfo->pgconn, sql, 0, nullptr, nullptr,
+                                    nullptr, nullptr, 0);
+  if (!pgresult || PQresultStatus(pgresult) != PGRES_TUPLES_OK) {
     msSetError(MS_QUERYERR, "%s", "msPostGISRetrievePK()",
                (std::string("Error executing SQL: ") + sql).c_str());
     return MS_FAILURE;
@@ -1195,32 +1186,34 @@ msPostGISRetrievePK(layerObj *layer)
   return MS_SUCCESS;
 }
 
-
 /*
 ** msPostGISParseData()
 **
 ** Parse the DATA string for geometry column name, table name,
 ** unique id column, srid, and SQL string.
 */
-static int msPostGISParseData(layerObj *layer)
-{
+static int msPostGISParseData(layerObj *layer) {
   assert(layer != nullptr);
   assert(layer->layerinfo != nullptr);
 
-  msPostGISLayerInfo* layerinfo = (msPostGISLayerInfo*)(layer->layerinfo);
+  msPostGISLayerInfo *layerinfo = (msPostGISLayerInfo *)(layer->layerinfo);
 
   if (layer->debug) {
     msDebug("msPostGISParseData called.\n");
   }
 
   if (!layer->data) {
-    msSetError(MS_QUERYERR, "Missing DATA clause. DATA statement must contain 'geometry_column from table_name' or 'geometry_column from (sub-query) as sub'.", "msPostGISParseData()");
+    msSetError(
+        MS_QUERYERR,
+        "Missing DATA clause. DATA statement must contain 'geometry_column "
+        "from table_name' or 'geometry_column from (sub-query) as sub'.",
+        "msPostGISParseData()");
     return MS_FAILURE;
   }
 
   std::string data(layer->data);
-  for( char& ch: data ) {
-    if( ch == '\t' || ch == '\r' || ch == '\n' ) {
+  for (char &ch : data) {
+    if (ch == '\t' || ch == '\r' || ch == '\n') {
       ch = ' ';
     }
   }
@@ -1236,53 +1229,57 @@ static int msPostGISParseData(layerObj *
   /*
   ** Look for the optional ' using ' clauses.
   */
-  const char* pos_srid = nullptr;
-  const char* pos_uid = nullptr;
-  const char* pos_use_1st = nullptr;
-  const char* pos_use_2nd = nullptr;
+  const char *pos_srid = nullptr;
+  const char *pos_uid = nullptr;
+  const char *pos_use_1st = nullptr;
+  const char *pos_use_2nd = nullptr;
   {
-    const char* tmp = strcasestr(data.c_str(), " using ");
-    while ( tmp )
-    {
+    const char *tmp = strcasestr(data.c_str(), " using ");
+    while (tmp) {
       pos_use_1st = pos_use_2nd;
       pos_use_2nd = tmp + 1;
-      tmp = strcasestr(tmp+1, " using ");
+      tmp = strcasestr(tmp + 1, " using ");
     }
   }
 
   /*
   ** What clause appear after 2nd 'using', if set?
   */
-  if ( pos_use_2nd )
-  {
-    const char* tmp;
-    for ( tmp = pos_use_2nd + 5; *tmp == ' '; tmp++ );
-    if ( strncasecmp ( tmp, "unique ", 7 ) == 0 )
-      for ( pos_uid = tmp + 7; *pos_uid == ' '; pos_uid++ );
-    if ( strncasecmp ( tmp, "srid=", 5 ) == 0 ) pos_srid = tmp + 5;
+  if (pos_use_2nd) {
+    const char *tmp;
+    for (tmp = pos_use_2nd + 5; *tmp == ' '; tmp++)
+      ;
+    if (strncasecmp(tmp, "unique ", 7) == 0)
+      for (pos_uid = tmp + 7; *pos_uid == ' '; pos_uid++)
+        ;
+    if (strncasecmp(tmp, "srid=", 5) == 0)
+      pos_srid = tmp + 5;
   };
 
   /*
   ** What clause appear after 1st 'using', if set?
   */
-  if ( pos_use_1st )
-  {
-    const char* tmp;
-    for ( tmp = pos_use_1st + 5; *tmp == ' '; tmp++ );
-    if ( strncasecmp ( tmp, "unique ", 7 ) == 0 )
-    {
-      if ( pos_uid )
-      {
-        msSetError(MS_QUERYERR, "Error parsing PostGIS DATA variable. Too many 'USING UNIQUE' found! %s", "msPostGISParseData()", layer->data);
+  if (pos_use_1st) {
+    const char *tmp;
+    for (tmp = pos_use_1st + 5; *tmp == ' '; tmp++)
+      ;
+    if (strncasecmp(tmp, "unique ", 7) == 0) {
+      if (pos_uid) {
+        msSetError(MS_QUERYERR,
+                   "Error parsing PostGIS DATA variable. Too many 'USING "
+                   "UNIQUE' found! %s",
+                   "msPostGISParseData()", layer->data);
         return MS_FAILURE;
       };
-      for ( pos_uid = tmp + 7; *pos_uid == ' '; pos_uid++ );
+      for (pos_uid = tmp + 7; *pos_uid == ' '; pos_uid++)
+        ;
     };
-    if ( strncasecmp ( tmp, "srid=", 5 ) == 0 )
-    {
-      if ( pos_srid )
-      {
-        msSetError(MS_QUERYERR, "Error parsing PostGIS DATA variable. Too many 'USING SRID' found! %s", "msPostGISParseData()", layer->data);
+    if (strncasecmp(tmp, "srid=", 5) == 0) {
+      if (pos_srid) {
+        msSetError(MS_QUERYERR,
+                   "Error parsing PostGIS DATA variable. Too many 'USING SRID' "
+                   "found! %s",
+                   "msPostGISParseData()", layer->data);
         return MS_FAILURE;
       }
       pos_srid = tmp + 5;
@@ -1294,7 +1291,7 @@ static int msPostGISParseData(layerObj *
   */
   if (pos_uid) {
     /* Find the end of this case 'using unique ftab_id using srid=33' */
-    const char* tmp = strstr(pos_uid, " ");
+    const char *tmp = strstr(pos_uid, " ");
     /* Find the end of this case 'using srid=33 using unique ftab_id' */
     if (!tmp) {
       tmp = pos_uid + strlen(pos_uid);
@@ -1309,7 +1306,10 @@ static int msPostGISParseData(layerObj *
   if (pos_srid) {
     const int slength = strspn(pos_srid, "-0123456789");
     if (!slength) {
-      msSetError(MS_QUERYERR, "Error parsing PostGIS DATA variable. You specified 'USING SRID' but didn't have any numbers! %s", "msPostGISParseData()", layer->data);
+      msSetError(MS_QUERYERR,
+                 "Error parsing PostGIS DATA variable. You specified 'USING "
+                 "SRID' but didn't have any numbers! %s",
+                 "msPostGISParseData()", layer->data);
       return MS_FAILURE;
     } else {
       layerinfo->srid.assign(pos_srid, slength);
@@ -1318,21 +1318,20 @@ static int msPostGISParseData(layerObj *
   }
 
   /*
-  * This is a little hack so the rest of the code works.
-  * pos_opt should point to the start of the optional blocks.
-  *
-  * If they are both set, return the smaller one.
-  * If pos_use_1st set, then it smaller.
-  * If one or none is set, return the larger one.
-  */
-  const char* pos_opt = pos_use_1st ? pos_use_1st : pos_use_2nd;
+   * This is a little hack so the rest of the code works.
+   * pos_opt should point to the start of the optional blocks.
+   *
+   * If they are both set, return the smaller one.
+   * If pos_use_1st set, then it smaller.
+   * If one or none is set, return the larger one.
+   */
+  const char *pos_opt = pos_use_1st ? pos_use_1st : pos_use_2nd;
   /* No pos_opt? Move it to the end of the string. */
   if (!pos_opt) {
     pos_opt = data.c_str() + data.size();
   }
   /* Back after the last non-space character. */
-  while( ( pos_opt > data.c_str() ) && ( *(pos_opt-1) == ' ' ) )
-  {
+  while ((pos_opt > data.c_str()) && (*(pos_opt - 1) == ' ')) {
     --pos_opt;
   }
 
@@ -1341,15 +1340,17 @@ static int msPostGISParseData(layerObj *
   */
 
   /* Find the first non-white character to start from */
-  const char* pos_geom;
-  for ( pos_geom = data.c_str(); *pos_geom == ' '; pos_geom++ )
-  {
+  const char *pos_geom;
+  for (pos_geom = data.c_str(); *pos_geom == ' '; pos_geom++) {
   }
 
   /* Find the end of the geom column name */
-  const char* pos_scn = strcasestr(data.c_str(), " from ");
+  const char *pos_scn = strcasestr(data.c_str(), " from ");
   if (!pos_scn) {
-    msSetError(MS_QUERYERR, "Error parsing PostGIS DATA variable. Must contain 'geometry from table' or 'geometry from (subselect) as foo'. %s", "msPostGISParseData()", layer->data);
+    msSetError(MS_QUERYERR,
+               "Error parsing PostGIS DATA variable. Must contain 'geometry "
+               "from table' or 'geometry from (subselect) as foo'. %s",
+               "msPostGISParseData()", layer->data);
     return MS_FAILURE;
   }
 
@@ -1358,18 +1359,26 @@ static int msPostGISParseData(layerObj *
   msStringTrim(layerinfo->geomcolumn);
 
   /* Copy the table name or sub-select clause */
-  for ( pos_scn += 6; *pos_scn == ' '; pos_scn++ );
-  if ( pos_opt - pos_scn < 1 )
-  {
-    msSetError(MS_QUERYERR, "Error parsing PostGIS DATA variable.  Must contain 'geometry from table' or 'geometry from (subselect) as foo'. %s", "msPostGISParseData()", layer->data);
+  for (pos_scn += 6; *pos_scn == ' '; pos_scn++)
+    ;
+  if (pos_opt - pos_scn < 1) {
+    msSetError(MS_QUERYERR,
+               "Error parsing PostGIS DATA variable.  Must contain 'geometry "
+               "from table' or 'geometry from (subselect) as foo'. %s",
+               "msPostGISParseData()", layer->data);
     return MS_FAILURE;
   };
-  layerinfo->fromsource.assign(layer->data + (pos_scn - data.c_str()), pos_opt - pos_scn);
+  layerinfo->fromsource.assign(layer->data + (pos_scn - data.c_str()),
+                               pos_opt - pos_scn);
   msStringTrim(layerinfo->fromsource);
 
-  /* Something is wrong, our goemetry column and table references are not there. */
+  /* Something is wrong, our goemetry column and table references are not there.
+   */
   if (layerinfo->fromsource.empty() || layerinfo->geomcolumn.empty()) {
-    msSetError(MS_QUERYERR, "Error parsing PostGIS DATA variable.  Must contain 'geometry from table' or 'geometry from (subselect) as foo'. %s", "msPostGISParseData()", layer->data);
+    msSetError(MS_QUERYERR,
+               "Error parsing PostGIS DATA variable.  Must contain 'geometry "
+               "from table' or 'geometry from (subselect) as foo'. %s",
+               "msPostGISParseData()", layer->data);
     return MS_FAILURE;
   }
 
@@ -1377,14 +1386,20 @@ static int msPostGISParseData(layerObj *
   ** We didn't find a ' using unique ' in the DATA string so try and find a
   ** primary key on the table.
   */
-  if ( layerinfo->uid.empty() ) {
-    if ( strstr(layerinfo->fromsource.c_str(), " ") ) {
-      msSetError(MS_QUERYERR, "Error parsing PostGIS DATA variable.  You must specify 'using unique' when supplying a subselect in the data definition.", "msPostGISParseData()");
+  if (layerinfo->uid.empty()) {
+    if (strstr(layerinfo->fromsource.c_str(), " ")) {
+      msSetError(
+          MS_QUERYERR,
+          "Error parsing PostGIS DATA variable.  You must specify 'using "
+          "unique' when supplying a subselect in the data definition.",
+          "msPostGISParseData()");
       return MS_FAILURE;
     }
-    if ( msPostGISRetrievePK(layer) != MS_SUCCESS ) {
-      if( layerinfo->pgconn && msPostGISRetrievePostgreSQLVersion(layerinfo->pgconn) < 120000 ) {
-        /* For PostgreSQL < 12: No user specified unique id so we will use the PostgreSQL oid */
+    if (msPostGISRetrievePK(layer) != MS_SUCCESS) {
+      if (layerinfo->pgconn &&
+          msPostGISRetrievePostgreSQLVersion(layerinfo->pgconn) < 120000) {
+        /* For PostgreSQL < 12: No user specified unique id so we will use the
+         * PostgreSQL oid */
         layerinfo->uid = "oid";
       } else {
         msSetError(MS_QUERYERR,
@@ -1398,7 +1413,10 @@ static int msPostGISParseData(layerObj *
   }
 
   if (layer->debug) {
-    msDebug("msPostGISParseData: unique_column=%s, srid=%s, geom_column_name=%s, table_name=%s\n", layerinfo->uid.c_str(), layerinfo->srid.c_str(), layerinfo->geomcolumn.c_str(), layerinfo->fromsource.c_str());
+    msDebug("msPostGISParseData: unique_column=%s, srid=%s, "
+            "geom_column_name=%s, table_name=%s\n",
+            layerinfo->uid.c_str(), layerinfo->srid.c_str(),
+            layerinfo->geomcolumn.c_str(), layerinfo->fromsource.c_str());
   }
   return MS_SUCCESS;
 }
@@ -1411,58 +1429,53 @@ static int msPostGISParseData(layerObj *
 ** Decode a hex character.
 */
 static const unsigned char msPostGISHexDecodeChar[256] = {
-  /* not Hex characters */
-  64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,
-  64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,
-  64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,
-  /* 0-9 */
-  0,1,2,3,4,5,6,7,8,9,
-  /* not Hex characters */
-  64,64,64,64,64,64,64,
-  /* A-F */
-  10,11,12,13,14,15,
-  /* not Hex characters */
-  64,64,64,64,64,64,64,64,64,
-  64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,
-  64,
-  /* a-f */
-  10,11,12,13,14,15,
-  64,64,64,64,64,64,64,64,64,
-  64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,
-  /* not Hex characters (upper 128 characters) */
-  64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,
-  64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,
-  64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,
-  64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,
-  64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,
-  64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,
-  64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,
-  64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64
-};
+    /* not Hex characters */
+    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
+    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
+    64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
+    /* 0-9 */
+    0, 1, 2, 3, 4, 5, 6, 7, 8, 9,
+    /* not Hex characters */
+    64, 64, 64, 64, 64, 64, 64,
+    /* A-F */
+    10, 11, 12, 13, 14, 15,
+    /* not Hex characters */
+    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
+    64, 64, 64, 64, 64, 64, 64,
+    /* a-f */
+    10, 11, 12, 13, 14, 15, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
+    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
+    /* not Hex characters (upper 128 characters) */
+    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
+    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
+    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
+    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
+    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
+    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
+    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64};
 
 /*
 ** Decode hex string "src" (null terminated)
 ** into "dest" (not null terminated).
 ** Returns length of decoded array or 0 on failure.
 */
-static int msPostGISHexDecode(unsigned char *dest, const char *src, int srclen)
-{
+static int msPostGISHexDecode(unsigned char *dest, const char *src,
+                              int srclen) {
 
-  if (src && *src && (srclen % 2 == 0) ) {
+  if (src && *src && (srclen % 2 == 0)) {
 
     unsigned char *p = dest;
     int i;
 
-    for ( i=0; i<srclen; i+=2 ) {
+    for (i = 0; i < srclen; i += 2) {
       const unsigned char c1 = src[i];
       const unsigned char c2 = src[i + 1];
       const unsigned char b1 = msPostGISHexDecodeChar[c1];
       const unsigned char b2 = msPostGISHexDecodeChar[c2];
 
       *p++ = (b1 << 4) | b2;
-
     }
-    return(p-dest);
+    return (p - dest);
   }
   return 0;
 }
@@ -1471,75 +1484,76 @@ static int msPostGISHexDecode(unsigned c
 ** Decode a base64 character.
 */
 static const unsigned char msPostGISBase64DecodeChar[256] = {
-  /* not Base64 characters */
-  64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,
-  64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,
-  64,64,64,64,64,64,64,64,64,64,64,
-  /*  +  */
-  62,
-  /* not Base64 characters */
-  64,64,64,
-  /*  /  */
-  63,
-  /* 0-9 */
-  52,53,54,55,56,57,58,59,60,61,
-  /* not Base64 characters */
-  64,64,64,64,64,64,64,
-  /* A-Z */
-  0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,
-  /* not Base64 characters */
-  64,64,64,64,64,64,
-  /* a-z */
-  26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,
-  /* not Base64 characters */
-  64,64,64,64,64,
-  /* not Base64 characters (upper 128 characters) */
-  64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,
-  64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,
-  64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,
-  64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,
-  64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,
-  64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,
-  64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,
-  64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64
-};
+    /* not Base64 characters */
+    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
+    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
+    64, 64, 64, 64, 64,
+    /*  +  */
+    62,
+    /* not Base64 characters */
+    64, 64, 64,
+    /*  /  */
+    63,
+    /* 0-9 */
+    52, 53, 54, 55, 56, 57, 58, 59, 60, 61,
+    /* not Base64 characters */
+    64, 64, 64, 64, 64, 64, 64,
+    /* A-Z */
+    0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20,
+    21, 22, 23, 24, 25,
+    /* not Base64 characters */
+    64, 64, 64, 64, 64, 64,
+    /* a-z */
+    26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44,
+    45, 46, 47, 48, 49, 50, 51,
+    /* not Base64 characters */
+    64, 64, 64, 64, 64,
+    /* not Base64 characters (upper 128 characters) */
+    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
+    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
+    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
+    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
+    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
+    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
+    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64};
 
 /*
 ** Decode base64 string "src" (null terminated)
 ** into "dest" (not null terminated).
 ** Returns length of decoded array or 0 on failure.
 */
-static int msPostGISBase64Decode(unsigned char *dest, const char *src, int srclen)
-{
+static int msPostGISBase64Decode(unsigned char *dest, const char *src,
+                                 int srclen) {
 
   if (src && *src) {
 
     unsigned char *p = dest;
     int i, j, k;
-    unsigned char *buf = (unsigned char*) calloc(srclen + 1, sizeof(unsigned char));
+    unsigned char *buf =
+        (unsigned char *)calloc(srclen + 1, sizeof(unsigned char));
 
     /* Drop illegal chars first */
-    for (i=0, j=0; src[i]; i++) {
+    for (i = 0, j = 0; src[i]; i++) {
       unsigned char c = src[i];
-      if ( (msPostGISBase64DecodeChar[c] != 64) || (c == '=') ) {
+      if ((msPostGISBase64DecodeChar[c] != 64) || (c == '=')) {
         buf[j++] = c;
       }
     }
 
-    for (k=0; k<j; k+=4) {
-      unsigned char c1='A', c2='A', c3='A', c4='A';
-      unsigned char b1=0, b2=0, b3=0, b4=0;
+    for (k = 0; k < j; k += 4) {
+      unsigned char c1 = 'A', c2 = 'A', c3 = 'A', c4 = 'A';
+      unsigned char b1 = 0, b2 = 0, b3 = 0, b4 = 0;
 
       c1 = buf[k];
 
-      if (k+1<j) {
-        c2 = buf[k+1];
+      if (k + 1 < j) {
+        c2 = buf[k + 1];
       }
-      if (k+2<j) {
-        c3 = buf[k+2];
+      if (k + 2 < j) {
+        c3 = buf[k + 2];
       }
-      if (k+3<j) {
-        c4 = buf[k+3];
+      if (k + 3 < j) {
+        c4 = buf[k + 3];
       }
 
       b1 = msPostGISBase64DecodeChar[c1];
@@ -1547,16 +1561,16 @@ static int msPostGISBase64Decode(unsigne
       b3 = msPostGISBase64DecodeChar[c3];
       b4 = msPostGISBase64DecodeChar[c4];
 
-      *p++=((b1<<2)|(b2>>4) );
+      *p++ = ((b1 << 2) | (b2 >> 4));
       if (c3 != '=') {
-        *p++=(((b2&0xf)<<4)|(b3>>2) );
+        *p++ = (((b2 & 0xf) << 4) | (b3 >> 2));
       }
       if (c4 != '=') {
-        *p++=(((b3&0x3)<<6)|b4 );
+        *p++ = (((b3 & 0x3) << 6) | b4);
       }
     }
     free(buf);
-    return(p-dest);
+    return (p - dest);
   }
   return 0;
 }
@@ -1568,8 +1582,8 @@ static int msPostGISBase64Decode(unsigne
 **
 ** Returns malloc'ed char* that must be freed by caller.
 */
-static char *msPostGISBuildSQLBox(layerObj *layer, const rectObj *rect, const char *strSRID)
-{
+static char *msPostGISBuildSQLBox(layerObj *layer, const rectObj *rect,
+                                  const char *strSRID) {
 
   char *strBox = nullptr;
   size_t sz;
@@ -1580,67 +1594,72 @@ static char *msPostGISBuildSQLBox(layerO
 
   const bool bIsPoint = rect->minx == rect->maxx && rect->miny == rect->maxy;
 
-  if ( strSRID ) {
-    static const char *strBoxTemplate = "ST_GeomFromText('POLYGON((%.15g %.15g,%.15g %.15g,%.15g %.15g,%.15g %.15g,%.15g %.15g))',%s)";
-    static const char *strBoxTemplatePoint = "ST_GeomFromText('POINT(%.15g %.15g)',%s)";
+  if (strSRID) {
+    static const char *strBoxTemplate =
+        "ST_GeomFromText('POLYGON((%.15g %.15g,%.15g %.15g,%.15g %.15g,%.15g "
+        "%.15g,%.15g %.15g))',%s)";
+    static const char *strBoxTemplatePoint =
+        "ST_GeomFromText('POINT(%.15g %.15g)',%s)";
     /* 10 doubles + 1 integer + template characters */
     sz = 10 * 22 + strlen(strSRID) + strlen(strBoxTemplate);
-    strBox = (char*)msSmallMalloc(sz+1); /* add space for terminating NULL */
-    if ( (bIsPoint && sz <= static_cast<size_t>(snprintf(strBox, sz, strBoxTemplatePoint,
-                        rect->minx, rect->miny, strSRID))) ||
-         (!bIsPoint && sz <= static_cast<size_t>(snprintf(strBox, sz, strBoxTemplate,
-                        rect->minx, rect->miny,
-                        rect->minx, rect->maxy,
-                        rect->maxx, rect->maxy,
-                        rect->maxx, rect->miny,
-                        rect->minx, rect->miny,
-                        strSRID))) ) {
-      msSetError(MS_MISCERR,"Bounding box digits truncated.","msPostGISBuildSQLBox");
+    strBox = (char *)msSmallMalloc(sz + 1); /* add space for terminating NULL */
+    if ((bIsPoint && sz <= static_cast<size_t>(
+                               snprintf(strBox, sz, strBoxTemplatePoint,
+                                        rect->minx, rect->miny, strSRID))) ||
+        (!bIsPoint &&
+         sz <= static_cast<size_t>(snprintf(
+                   strBox, sz, strBoxTemplate, rect->minx, rect->miny,
+                   rect->minx, rect->maxy, rect->maxx, rect->maxy, rect->maxx,
+                   rect->miny, rect->minx, rect->miny, strSRID)))) {
+      msSetError(MS_MISCERR, "Bounding box digits truncated.",
+                 "msPostGISBuildSQLBox");
       return nullptr;
     }
   } else {
-    static const char *strBoxTemplate = "ST_GeomFromText('POLYGON((%.15g %.15g,%.15g %.15g,%.15g %.15g,%.15g %.15g,%.15g %.15g))')";
-    static const char *strBoxTemplatePoint = "ST_GeomFromText('POINT(%.15g %.15g)')";
+    static const char *strBoxTemplate =
+        "ST_GeomFromText('POLYGON((%.15g %.15g,%.15g %.15g,%.15g %.15g,%.15g "
+        "%.15g,%.15g %.15g))')";
+    static const char *strBoxTemplatePoint =
+        "ST_GeomFromText('POINT(%.15g %.15g)')";
     /* 10 doubles + template characters */
     sz = 10 * 22 + strlen(strBoxTemplate);
-    strBox = (char*)msSmallMalloc(sz+1); /* add space for terminating NULL */
-    if ( (bIsPoint && sz <= static_cast<size_t>(snprintf(strBox, sz, strBoxTemplatePoint,
-                        rect->minx, rect->miny))) ||
-         (!bIsPoint && sz <= static_cast<size_t>(snprintf(strBox, sz, strBoxTemplate,
-                        rect->minx, rect->miny,
-                        rect->minx, rect->maxy,
-                        rect->maxx, rect->maxy,
-                        rect->maxx, rect->miny,
-                        rect->minx, rect->miny))) ) {
-      msSetError(MS_MISCERR,"Bounding box digits truncated.","msPostGISBuildSQLBox");
+    strBox = (char *)msSmallMalloc(sz + 1); /* add space for terminating NULL */
+    if ((bIsPoint &&
+         sz <= static_cast<size_t>(snprintf(strBox, sz, strBoxTemplatePoint,
+                                            rect->minx, rect->miny))) ||
+        (!bIsPoint &&
+         sz <= static_cast<size_t>(
+                   snprintf(strBox, sz, strBoxTemplate, rect->minx, rect->miny,
+                            rect->minx, rect->maxy, rect->maxx, rect->maxy,
+                            rect->maxx, rect->miny, rect->minx, rect->miny)))) {
+      msSetError(MS_MISCERR, "Bounding box digits truncated.",
+                 "msPostGISBuildSQLBox");
       return nullptr;
     }
   }
 
   return strBox;
-
 }
 
-
 /*
 ** msPostGISBuildSQLItems()
 **
 ** Returns malloc'ed char* that must be freed by caller.
 */
-static std::string msPostGISBuildSQLItems(layerObj *layer)
-{
+static std::string msPostGISBuildSQLItems(layerObj *layer) {
 
   const char *strEndian = nullptr;
   if (layer->debug) {
     msDebug("msPostGISBuildSQLItems called.\n");
   }
 
-  assert( layer->layerinfo != nullptr);
+  assert(layer->layerinfo != nullptr);
 
-  msPostGISLayerInfo* layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
+  msPostGISLayerInfo *layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
 
-  if ( layerinfo->geomcolumn.empty() ) {
-    msSetError(MS_MISCERR, "layerinfo->geomcolumn is not initialized.", "msPostGISBuildSQLItems()");
+  if (layerinfo->geomcolumn.empty()) {
+    msSetError(MS_MISCERR, "layerinfo->geomcolumn is not initialized.",
+               "msPostGISBuildSQLItems()");
     return std::string();
   }
 
@@ -1665,36 +1684,41 @@ static std::string msPostGISBuildSQLItem
     */
     const char *force2d = "";
 #if TRANSFER_ENCODING == 64
-    const char *strGeomTemplate = "encode(ST_AsBinary(%s(\"%s\"),'%s'),'base64') as geom,\"%s\"";
+    const char *strGeomTemplate =
+        "encode(ST_AsBinary(%s(\"%s\"),'%s'),'base64') as geom,\"%s\"";
 #elif TRANSFER_ENCODING == 256
-    const char *strGeomTemplate = "ST_AsBinary(%s(\"%s\"),'%s') as geom,\"%s\"::text";
+    const char *strGeomTemplate =
+        "ST_AsBinary(%s(\"%s\"),'%s') as geom,\"%s\"::text";
 #else
-    const char *strGeomTemplate = "encode(ST_AsBinary(%s(\"%s\"),'%s'),'hex') as geom,\"%s\"";
+    const char *strGeomTemplate =
+        "encode(ST_AsBinary(%s(\"%s\"),'%s'),'hex') as geom,\"%s\"";
 #endif
-    if( layerinfo->force2d ) {
-      if( layerinfo->version >= 20100 )
+    if (layerinfo->force2d) {
+      if (layerinfo->version >= 20100)
         force2d = "ST_Force2D";
       else
         force2d = "ST_Force_2D";
-    }
-    else if( layerinfo->version < 20000 )
-    {
-        /* Use AsEWKB() to get 3D */
+    } else if (layerinfo->version < 20000) {
+      /* Use AsEWKB() to get 3D */
 #if TRANSFER_ENCODING == 64
-        strGeomTemplate = "encode(AsEWKB(%s(\"%s\"),'%s'),'base64') as geom,\"%s\"";
+      strGeomTemplate =
+          "encode(AsEWKB(%s(\"%s\"),'%s'),'base64') as geom,\"%s\"";
 #elif TRANSFER_ENCODING == 256
-        strGeomTemplate = "AsEWKB(%s(\"%s\"),'%s') as geom,\"%s\"::text";
+      strGeomTemplate = "AsEWKB(%s(\"%s\"),'%s') as geom,\"%s\"::text";
 #else
-        strGeomTemplate = "encode(AsEWKB(%s(\"%s\"),'%s'),'hex') as geom,\"%s\"";
+      strGeomTemplate = "encode(AsEWKB(%s(\"%s\"),'%s'),'hex') as geom,\"%s\"";
 #endif
     }
-    strGeom.resize(strlen(strGeomTemplate) + strlen(force2d) + strlen(strEndian) + layerinfo->geomcolumn.size() + layerinfo->uid.size());
-    snprintf(&strGeom[0], strGeom.size(), strGeomTemplate, force2d, layerinfo->geomcolumn.c_str(), strEndian, layerinfo->uid.c_str());
+    strGeom.resize(strlen(strGeomTemplate) + strlen(force2d) +
+                   strlen(strEndian) + layerinfo->geomcolumn.size() +
+                   layerinfo->uid.size());
+    snprintf(&strGeom[0], strGeom.size(), strGeomTemplate, force2d,
+             layerinfo->geomcolumn.c_str(), strEndian, layerinfo->uid.c_str());
     strGeom.resize(strlen(strGeom.data()));
   }
 
-  if( layer->debug > 1 ) {
-    msDebug("msPostGISBuildSQLItems: %d items requested.\n",layer->numitems);
+  if (layer->debug > 1) {
+    msDebug("msPostGISBuildSQLItems: %d items requested.\n", layer->numitems);
   }
 
   /*
@@ -1704,13 +1728,13 @@ static std::string msPostGISBuildSQLItem
   /*
   ** Build SQL to pull all the items.
   */
-  for ( int t = 0; t < layer->numitems; t++ ) {
-      strItems +=  "\"";
-      strItems += layer->items[t];
+  for (int t = 0; t < layer->numitems; t++) {
+    strItems += "\"";
+    strItems += layer->items[t];
 #if TRANSFER_ENCODING == 256
-      strItems += "\"::text,";
+    strItems += "\"::text,";
 #else
-      strItems += "\",";
+    strItems += "\",";
 #endif
   }
   strItems += strGeom;
@@ -1718,43 +1742,40 @@ static std::string msPostGISBuildSQLItem
   return strItems;
 }
 
-
 /*
 ** msPostGISFindTableName()
 */
-static std::string msPostGISFindTableName(const char* fromsource)
-{
+static std::string msPostGISFindTableName(const char *fromsource) {
   std::string f_table_name;
   const char *pos = strchr(fromsource, ' ');
- 
-  if ( ! pos ) {
+
+  if (!pos) {
     /* target table is one word */
     f_table_name = fromsource;
   } else {
     /* target table is hiding in sub-select clause */
     pos = strcasestr(fromsource, " from ");
-    if ( pos ) {
+    if (pos) {
       pos += 6; /* should be start of table name */
-      const char* pos_paren = strstr(pos, ")"); /* first ) after table name */
-      const char* pos_space = strstr(pos, " "); /* first space after table name */
-      if ( pos_space < pos_paren ) {
+      const char *pos_paren = strstr(pos, ")"); /* first ) after table name */
+      const char *pos_space =
+          strstr(pos, " "); /* first space after table name */
+      if (pos_space < pos_paren) {
         /* found space first */
         f_table_name.assign(pos, pos_space - pos);
       } else {
         /* found ) first */
-        f_table_name.assign( pos, pos_paren - pos);
+        f_table_name.assign(pos, pos_paren - pos);
       }
     }
   }
   return f_table_name;
 }
 
-
 /*
 ** msPostGISBuildSQLSRID()
 */
-static std::string msPostGISBuildSQLSRID(layerObj *layer)
-{
+static std::string msPostGISBuildSQLSRID(layerObj *layer) {
 
   std::string strSRID;
 
@@ -1762,14 +1783,14 @@ static std::string msPostGISBuildSQLSRID
     msDebug("msPostGISBuildSQLSRID called.\n");
   }
 
-  assert( layer->layerinfo != nullptr);
+  assert(layer->layerinfo != nullptr);
 
-  msPostGISLayerInfo* layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
+  msPostGISLayerInfo *layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
 
   /* An SRID was already provided in the DATA line. */
-  if ( !layerinfo->srid.empty() ) {
+  if (!layerinfo->srid.empty()) {
     strSRID = layerinfo->srid;
-    if( layer->debug > 1 ) {
+    if (layer->debug > 1) {
       msDebug("msPostGISBuildSQLSRID: SRID provided (%s)\n", strSRID.c_str());
     }
   }
@@ -1779,7 +1800,7 @@ static std::string msPostGISBuildSQLSRID
   ** or "(select ... from thetable where ...)".
   */
   else {
-    if( layer->debug > 1 ) {
+    if (layer->debug > 1) {
       msDebug("msPostGISBuildSQLSRID: Building find_srid line.\n");
     }
 
@@ -1792,70 +1813,71 @@ static std::string msPostGISBuildSQLSRID
   return strSRID;
 }
 
-
 /*
 ** msPostGISReplaceBoxToken()
 **
-** Convert a fromsource data statement into something usable by replacing the !BOX! token.
+** Convert a fromsource data statement into something usable by replacing the
+*!BOX! token.
 */
-static std::string msPostGISReplaceBoxToken(layerObj *layer, const rectObj *rect, const char *fromsource)
-{
+static std::string msPostGISReplaceBoxToken(layerObj *layer,
+                                            const rectObj *rect,
+                                            const char *fromsource) {
   std::string result(fromsource);
-  
-  if( layer->debug > 1 ) {
+
+  if (layer->debug > 1) {
     msDebug("msPostGISReplaceBoxToken called.\n");
-  }  
+  }
 
-  if ( strstr(fromsource, BOXTOKEN) && rect ) {
+  if (strstr(fromsource, BOXTOKEN) && rect) {
     char *strBox = nullptr;
 
     /* We see to set the SRID on the box, but to what SRID? */
     const std::string strSRID = msPostGISBuildSQLSRID(layer);
-    if ( strSRID.empty() ) {
+    if (strSRID.empty()) {
       return std::string();
     }
 
     /* Create a suitable SQL string from the rectangle and SRID. */
     strBox = msPostGISBuildSQLBox(layer, rect, strSRID.c_str());
-    if ( ! strBox ) {
-      msSetError(MS_MISCERR, "Unable to build box SQL.", "msPostGISReplaceBoxToken()");
+    if (!strBox) {
+      msSetError(MS_MISCERR, "Unable to build box SQL.",
+                 "msPostGISReplaceBoxToken()");
       return std::string();
     }
 
     /* Do the substitution. */
     size_t pos = 0;
-    while( true ) {
-        pos = result.find(BOXTOKEN, pos);
-        if( pos == std::string::npos ) {
-            break;
-        }
-        const auto resultAfter(result.substr(pos + BOXTOKENLENGTH));
-        result.resize(pos);
-        result += strBox;
-        result += resultAfter;
+    while (true) {
+      pos = result.find(BOXTOKEN, pos);
+      if (pos == std::string::npos) {
+        break;
+      }
+      const auto resultAfter(result.substr(pos + BOXTOKENLENGTH));
+      result.resize(pos);
+      result += strBox;
+      result += resultAfter;
     }
 
     free(strBox);
   }
   return result;
-
 }
 
 /*
 ** msPostGISBuildSQLFrom()
 */
-static std::string msPostGISBuildSQLFrom(layerObj *layer, const rectObj *rect)
-{
+static std::string msPostGISBuildSQLFrom(layerObj *layer, const rectObj *rect) {
   if (layer->debug) {
     msDebug("msPostGISBuildSQLFrom called.\n");
   }
 
-  assert( layer->layerinfo != nullptr);
+  assert(layer->layerinfo != nullptr);
 
-  msPostGISLayerInfo* layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
+  msPostGISLayerInfo *layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
 
-  if ( layerinfo->fromsource.empty() ) {
-    msSetError(MS_MISCERR, "Layerinfo->fromsource is not initialized.", "msPostGISBuildSQLFrom()");
+  if (layerinfo->fromsource.empty()) {
+    msSetError(MS_MISCERR, "Layerinfo->fromsource is not initialized.",
+               "msPostGISBuildSQLFrom()");
     return std::string();
   }
 
@@ -1869,82 +1891,82 @@ static std::string msPostGISBuildSQLFrom
 /*
 ** msPostGISBuildSQLWhere()
 */
-static std::string msPostGISBuildSQLWhere(layerObj *layer, const rectObj *rect, const long *uid, const rectObj *rectInOtherSRID, int otherSRID)
-{
+static std::string msPostGISBuildSQLWhere(layerObj *layer, const rectObj *rect,
+                                          const long *uid,
+                                          const rectObj *rectInOtherSRID,
+                                          int otherSRID) {
   if (layer->debug) {
     msDebug("msPostGISBuildSQLWhere called.\n");
   }
 
-  assert( layer->layerinfo != nullptr);
+  assert(layer->layerinfo != nullptr);
 
-  msPostGISLayerInfo* layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
+  msPostGISLayerInfo *layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
 
-  if ( layerinfo->fromsource.empty() ) {
-    msSetError(MS_MISCERR, "Layerinfo->fromsource is not initialized.", "msPostGISBuildSQLWhere()");
+  if (layerinfo->fromsource.empty()) {
+    msSetError(MS_MISCERR, "Layerinfo->fromsource is not initialized.",
+               "msPostGISBuildSQLWhere()");
     return std::string();
   }
 
   /* Populate strRect, if necessary. */
   std::string strRect;
-  if ( rect && !layerinfo->geomcolumn.empty() ) {
+  if (rect && !layerinfo->geomcolumn.empty()) {
     /* We see to set the SRID on the box, but to what SRID? */
     const std::string strSRID = msPostGISBuildSQLSRID(layer);
-    if ( strSRID.empty() ) {
+    if (strSRID.empty()) {
       return std::string();
     }
 
-    char* strBox = msPostGISBuildSQLBox(layer, rect, strSRID.c_str());
+    char *strBox = msPostGISBuildSQLBox(layer, rect, strSRID.c_str());
 
-    if ( !strBox ) {
-      msSetError(MS_MISCERR, "Unable to build box SQL.", "msPostGISBuildSQLWhere()");
+    if (!strBox) {
+      msSetError(MS_MISCERR, "Unable to build box SQL.",
+                 "msPostGISBuildSQLWhere()");
       return std::string();
     }
 
-    if( strSRID.find("find_srid(") == std::string::npos )
-    {
-        // If the SRID is known, we can safely use ST_Intersects()
-        // otherwise if find_srid() would return 0, ST_Intersects() would not
-        // work at all, which breaks the msautotest/query/query_postgis.map
-        // tests, related to bdry_counpy2 layer that has no SRID
-        if( layerinfo->version >= 20500 )
-        {
-            strRect = "ST_Intersects(\"";
-            strRect += layerinfo->geomcolumn;
-            strRect += "\", ";
-            strRect += strBox;
-            strRect += ')';
-        }
-        else
-        {
-            // ST_Intersects() before PostGIS 2.5 doesn't support collections
-            // See https://github.com/MapServer/MapServer/pull/6355#issuecomment-877355007
-            strRect = "(\"";
-            strRect += layerinfo->geomcolumn;
-            strRect += "\" && ";
-            strRect += strBox;
-            strRect += ") AND ST_Distance(\"";
-            strRect += layerinfo->geomcolumn;
-            strRect += "\", ";
-            strRect += strBox;
-            strRect += ") = 0";
-        }
-    }
-    else
-    {
-        strRect = '"';
+    if (strSRID.find("find_srid(") == std::string::npos) {
+      // If the SRID is known, we can safely use ST_Intersects()
+      // otherwise if find_srid() would return 0, ST_Intersects() would not
+      // work at all, which breaks the msautotest/query/query_postgis.map
+      // tests, related to bdry_counpy2 layer that has no SRID
+      if (layerinfo->version >= 20500) {
+        strRect = "ST_Intersects(\"";
+        strRect += layerinfo->geomcolumn;
+        strRect += "\", ";
+        strRect += strBox;
+        strRect += ')';
+      } else {
+        // ST_Intersects() before PostGIS 2.5 doesn't support collections
+        // See
+        // https://github.com/MapServer/MapServer/pull/6355#issuecomment-877355007
+        strRect = "(\"";
         strRect += layerinfo->geomcolumn;
         strRect += "\" && ";
         strRect += strBox;
+        strRect += ") AND ST_Distance(\"";
+        strRect += layerinfo->geomcolumn;
+        strRect += "\", ";
+        strRect += strBox;
+        strRect += ") = 0";
+      }
+    } else {
+      strRect = '"';
+      strRect += layerinfo->geomcolumn;
+      strRect += "\" && ";
+      strRect += strBox;
     }
     free(strBox);
 
     /* Combine with other rectangle  expressed in another SRS */
     /* (generally equivalent to the above in current code paths) */
-    if( rectInOtherSRID != nullptr && otherSRID > 0 )
-    {
-      strBox = msPostGISBuildSQLBox(layer, rectInOtherSRID, std::to_string(otherSRID).c_str());
-      if ( !strBox ) {
-        msSetError(MS_MISCERR, "Unable to build box SQL.", "msPostGISBuildSQLWhere()");
+    if (rectInOtherSRID != nullptr && otherSRID > 0) {
+      strBox = msPostGISBuildSQLBox(layer, rectInOtherSRID,
+                                    std::to_string(otherSRID).c_str());
+      if (!strBox) {
+        msSetError(MS_MISCERR, "Unable to build box SQL.",
+                   "msPostGISBuildSQLWhere()");
         return std::string();
       }
 
@@ -1965,17 +1987,17 @@ static std::string msPostGISBuildSQLWher
       strTmp += ')';
 
       strRect = std::move(strTmp);
-    }
-    else if( rectInOtherSRID != nullptr && otherSRID < 0 )
-    {
+    } else if (rectInOtherSRID != nullptr && otherSRID < 0) {
       const std::string strSRID = msPostGISBuildSQLSRID(layer);
-      if ( strSRID.empty() ) {
+      if (strSRID.empty()) {
         return std::string();
       }
-      char* strBox = msPostGISBuildSQLBox(layer, rectInOtherSRID, strSRID.c_str());
+      char *strBox =
+          msPostGISBuildSQLBox(layer, rectInOtherSRID, strSRID.c_str());
 
-      if ( !strBox ) {
-        msSetError(MS_MISCERR, "Unable to build box SQL.", "msPostGISBuildSQLWhere()");
+      if (!strBox) {
+        msSetError(MS_MISCERR, "Unable to build box SQL.",
+                   "msPostGISBuildSQLWhere()");
         return std::string();
       }
 
@@ -1999,14 +2021,14 @@ static std::string msPostGISBuildSQLWher
 
   bool insert_and = false;
   std::string strWhere;
-  if ( !strRect.empty() ) {
+  if (!strRect.empty()) {
     strWhere += strRect;
     insert_and = true;
   }
 
   /* Handle a translated filter (RFC91). */
-  if ( layer->filter.native_string ) {
-    if ( insert_and ) {
+  if (layer->filter.native_string) {
+    if (insert_and) {
       strWhere += " AND ";
       insert_and = true;
     }
@@ -2017,8 +2039,8 @@ static std::string msPostGISBuildSQLWher
 
   /* Handle a native filter set as a PROCESSING option (#5001). */
   const char *native_filter = msLayerGetProcessingKey(layer, "NATIVE_FILTER");
-  if ( native_filter ) {
-    if ( insert_and ) {
+  if (native_filter) {
+    if (insert_and) {
       strWhere += " AND ";
       insert_and = true;
     }
@@ -2027,8 +2049,8 @@ static std::string msPostGISBuildSQLWher
     strWhere += ')';
   }
 
-  if ( uid ) {
-    if ( insert_and ) {
+  if (uid) {
+    if (insert_and) {
       strWhere += " AND ";
     }
     strWhere += '"';
@@ -2037,27 +2059,27 @@ static std::string msPostGISBuildSQLWher
     strWhere += std::to_string(*uid);
   }
 
-  if( layer->sortBy.nProperties > 0 ) {
-    char* pszTmp = msLayerBuildSQLOrderBy(layer);
+  if (layer->sortBy.nProperties > 0) {
+    char *pszTmp = msLayerBuildSQLOrderBy(layer);
     strWhere += " ORDER BY ";
     strWhere += pszTmp;
     msFree(pszTmp);
   }
 
-  if ( layerinfo->paging && layer->maxfeatures >= 0 ) {
+  if (layerinfo->paging && layer->maxfeatures >= 0) {
     strWhere += " LIMIT ";
     strWhere += std::to_string(layer->maxfeatures);
   }
 
   /* Populate strOffset, if necessary. */
-  if ( layerinfo->paging && layer->startindex > 0 ) {
+  if (layerinfo->paging && layer->startindex > 0) {
     strWhere += " OFFSET ";
-    strWhere += std::to_string(layer->startindex-1);
+    strWhere += std::to_string(layer->startindex - 1);
   }
 
   if (strWhere.empty()) {
-      // return all records
-      strWhere = "true";
+    // return all records
+    strWhere = "true";
   }
 
   return strWhere;
@@ -2068,44 +2090,51 @@ static std::string msPostGISBuildSQLWher
 **
 ** rect is the search rectangle in layer SRS. It can be set to NULL
 ** uid can be set to NULL
-** rectInOtherSRID is an additional rectangle potentially in another SRS. It can be set to NULL.
+** rectInOtherSRID is an additional rectangle potentially in another SRS. It can
+*be set to NULL.
 ** Only used if rect != NULL
 ** otherSRID is the SRID of the additional rectangle. It can be set to -1 if
 ** rectInOtherSRID is in the SRID of the layer.
 */
-static std::string msPostGISBuildSQL(layerObj *layer, const rectObj *rect, const long *uid, const rectObj *rectInOtherSRID, int otherSRID)
-{
+static std::string msPostGISBuildSQL(layerObj *layer, const rectObj *rect,
+                                     const long *uid,
+                                     const rectObj *rectInOtherSRID,
+                                     int otherSRID) {
   if (layer->debug) {
     msDebug("msPostGISBuildSQL called.\n");
   }
 
-  assert( layer->layerinfo != nullptr);
+  assert(layer->layerinfo != nullptr);
 
-  msPostGISLayerInfo* layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
+  msPostGISLayerInfo *layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
 
   const std::string strItems = msPostGISBuildSQLItems(layer);
-  if ( strItems.empty() ) {
+  if (strItems.empty()) {
     msSetError(MS_MISCERR, "Failed to build SQL items.", "msPostGISBuildSQL()");
     return std::string();
   }
 
   const std::string strFrom = msPostGISBuildSQLFrom(layer, rect);
-  if ( strFrom.empty() ) {
-    msSetError(MS_MISCERR, "Failed to build SQL 'from'.", "msPostGISBuildSQL()");
+  if (strFrom.empty()) {
+    msSetError(MS_MISCERR, "Failed to build SQL 'from'.",
+               "msPostGISBuildSQL()");
     return std::string();
   }
 
-  /* If there's BOX hackery going on, we don't want to append a box index test at
-     the end of the query, the user is going to be responsible for making things
-     work with their hackery. */
+  /* If there's BOX hackery going on, we don't want to append a box index test
+     at the end of the query, the user is going to be responsible for making
+     things work with their hackery. */
   std::string strWhere;
-  if ( strstr(layerinfo->fromsource.c_str(), BOXTOKEN) )
-    strWhere = msPostGISBuildSQLWhere(layer, nullptr, uid, rectInOtherSRID, otherSRID);
+  if (strstr(layerinfo->fromsource.c_str(), BOXTOKEN))
+    strWhere =
+        msPostGISBuildSQLWhere(layer, nullptr, uid, rectInOtherSRID, otherSRID);
   else
-    strWhere = msPostGISBuildSQLWhere(layer, rect, uid, rectInOtherSRID, otherSRID);
+    strWhere =
+        msPostGISBuildSQLWhere(layer, rect, uid, rectInOtherSRID, otherSRID);
 
-  if ( strWhere.empty() ) {
-    msSetError(MS_MISCERR, "Failed to build SQL 'where'.", "msPostGISBuildSQL()");
+  if (strWhere.empty()) {
+    msSetError(MS_MISCERR, "Failed to build SQL 'where'.",
+               "msPostGISBuildSQL()");
     return std::string();
   }
 
@@ -2120,28 +2149,30 @@ static std::string msPostGISBuildSQL(lay
 }
 
 #define wkbstaticsize 4096
-static int msPostGISReadShape(layerObj *layer, shapeObj *shape)
-{
+static int msPostGISReadShape(layerObj *layer, shapeObj *shape) {
   if (layer->debug) {
     msDebug("msPostGISReadShape called.\n");
   }
 
   assert(layer->layerinfo != nullptr);
-  msPostGISLayerInfo* layerinfo = (msPostGISLayerInfo*) layer->layerinfo;
+  msPostGISLayerInfo *layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
 
   /* Retrieve the geometry. */
-  const char* wkbstr = PQgetvalue(layerinfo->pgresult, layerinfo->rownum, layer->numitems );
-  const int wkbstrlen = PQgetlength(layerinfo->pgresult, layerinfo->rownum, layer->numitems);
+  const char *wkbstr =
+      PQgetvalue(layerinfo->pgresult, layerinfo->rownum, layer->numitems);
+  const int wkbstrlen =
+      PQgetlength(layerinfo->pgresult, layerinfo->rownum, layer->numitems);
 
-  if ( ! wkbstr ) {
+  if (!wkbstr) {
     msSetError(MS_QUERYERR, "WKB returned is null!", "msPostGISReadShape()");
     return MS_FAILURE;
   }
 
   unsigned char wkbstatic[wkbstaticsize];
   unsigned char *wkb = nullptr;
-  if(wkbstrlen > wkbstaticsize) {
-    wkb = static_cast<unsigned char*>(calloc(wkbstrlen, sizeof(unsigned char)));
+  if (wkbstrlen > wkbstaticsize) {
+    wkb =
+        static_cast<unsigned char *>(calloc(wkbstrlen, sizeof(unsigned char)));
   } else {
     wkb = wkbstatic;
   }
@@ -2150,9 +2181,10 @@ static int msPostGISReadShape(layerObj *
   int result = 0;
 #if TRANSFER_ENCODING == 64
   result = msPostGISBase64Decode(wkb, wkbstr, wkbstrlen - 1);
-  w.size = (wkbstrlen - 1)/2;
-  if( ! result ) {
-    if(wkb!=wkbstatic) free(wkb);
+  w.size = (wkbstrlen - 1) / 2;
+  if (!result) {
+    if (wkb != wkbstatic)
+      free(wkb);
     return MS_FAILURE;
   }
 #elif TRANSFER_ENCODING == 256
@@ -2160,131 +2192,134 @@ static int msPostGISReadShape(layerObj *
   w.size = wkbstrlen;
 #else
   result = msPostGISHexDecode(wkb, wkbstr, wkbstrlen);
-  w.size = (wkbstrlen - 1)/2;
-  if( ! result ) {
-    if(wkb!=wkbstatic) free(wkb);
+  w.size = (wkbstrlen - 1) / 2;
+  if (!result) {
+    if (wkb != wkbstatic)
+      free(wkb);
     return MS_FAILURE;
   }
 #endif
 
   /* Initialize our wkbObj */
-  w.wkb = (char*)wkb;
+  w.wkb = (char *)wkb;
   w.ptr = w.wkb;
 
-  /* Set the type map according to what version of PostGIS we are dealing with */
-  if( layerinfo->version >= 20000 ) /* PostGIS 2.0+ */
+  /* Set the type map according to what version of PostGIS we are dealing with
+   */
+  if (layerinfo->version >= 20000) /* PostGIS 2.0+ */
     w.typemap = wkb_postgis20;
-  else
-  {
+  else {
     w.typemap = wkb_postgis15;
-    if( layerinfo->force2d == MS_FALSE )
-    {
-        /* Is there SRID ? Skip it */
-        if( w.size >= 9 && (w.ptr[4] & 0x20) != 0 )
-        {
-            w.ptr[5] = w.ptr[1];
-            w.ptr[6] = w.ptr[2];
-            w.ptr[7] = w.ptr[3];
-            w.ptr[8] = w.ptr[4] & ~(0x20);
-            w.ptr[4] = 1;
-            w.ptr += 4;
-            w.size -= 4;
-        }
+    if (layerinfo->force2d == MS_FALSE) {
+      /* Is there SRID ? Skip it */
+      if (w.size >= 9 && (w.ptr[4] & 0x20) != 0) {
+        w.ptr[5] = w.ptr[1];
+        w.ptr[6] = w.ptr[2];
+        w.ptr[7] = w.ptr[3];
+        w.ptr[8] = w.ptr[4] & ~(0x20);
+        w.ptr[4] = 1;
+        w.ptr += 4;
+        w.size -= 4;
+      }
     }
   }
 
   switch (layer->type) {
 
-    case MS_LAYER_POINT:
-      shape->type = MS_SHAPE_POINT;
-      result = wkbConvGeometryToShape(&w, shape);
-      break;
+  case MS_LAYER_POINT:
+    shape->type = MS_SHAPE_POINT;
+    result = wkbConvGeometryToShape(&w, shape);
+    break;
 
-    case MS_LAYER_LINE:
-      shape->type = MS_SHAPE_LINE;
-      result = wkbConvGeometryToShape(&w, shape);
-      break;
+  case MS_LAYER_LINE:
+    shape->type = MS_SHAPE_LINE;
+    result = wkbConvGeometryToShape(&w, shape);
+    break;
 
-    case MS_LAYER_POLYGON:
-      shape->type = MS_SHAPE_POLYGON;
-      result = wkbConvGeometryToShape(&w, shape);
-      break;
+  case MS_LAYER_POLYGON:
+    shape->type = MS_SHAPE_POLYGON;
+    result = wkbConvGeometryToShape(&w, shape);
+    break;
 
-    case MS_LAYER_QUERY:
-    case MS_LAYER_CHART:
-      result = msPostGISFindBestType(&w, shape);
-      break;
+  case MS_LAYER_QUERY:
+  case MS_LAYER_CHART:
+    result = msPostGISFindBestType(&w, shape);
+    break;
 
-    case MS_LAYER_RASTER:
-      msDebug("Ignoring MS_LAYER_RASTER in msPostGISReadShape.\n");
-      break;
+  case MS_LAYER_RASTER:
+    msDebug("Ignoring MS_LAYER_RASTER in msPostGISReadShape.\n");
+    break;
 
-    case MS_LAYER_CIRCLE:
-      msDebug("Ignoring MS_LAYER_RASTER in msPostGISReadShape.\n");
-      break;
+  case MS_LAYER_CIRCLE:
+    msDebug("Ignoring MS_LAYER_RASTER in msPostGISReadShape.\n");
+    break;
 
-    default:
-      msDebug("Unsupported layer type in msPostGISReadShape()!\n");
-      break;
+  default:
+    msDebug("Unsupported layer type in msPostGISReadShape()!\n");
+    break;
   }
 
   /* All done with WKB geometry, free it! */
-  if(wkb!=wkbstatic) free(wkb);
+  if (wkb != wkbstatic)
+    free(wkb);
 
   if (result != MS_FAILURE) {
     /* Found a drawable shape, so now retreive the attributes. */
 
-    shape->values = (char**) msSmallMalloc(sizeof(char*) * layer->numitems);
-    for ( int t = 0; t < layer->numitems; t++) {
+    shape->values = (char **)msSmallMalloc(sizeof(char *) * layer->numitems);
+    for (int t = 0; t < layer->numitems; t++) {
       const int size = PQgetlength(layerinfo->pgresult, layerinfo->rownum, t);
       const char *val = PQgetvalue(layerinfo->pgresult, layerinfo->rownum, t);
       const int isnull = PQgetisnull(layerinfo->pgresult, layerinfo->rownum, t);
-      if ( isnull ) {
+      if (isnull) {
         shape->values[t] = msStrdup("");
       } else {
-        shape->values[t] = (char*) msSmallMalloc(size + 1);
+        shape->values[t] = (char *)msSmallMalloc(size + 1);
         memcpy(shape->values[t], val, size);
         shape->values[t][size] = '\0'; /* null terminate it */
 
         // From https://www.postgresql.org/docs/9.0/datatype-character.html
         // fields of type Char are blank padded, but this blank is semantically
         // insignificant, so let's trim it
-        if( PQftype(layerinfo->pgresult, t) == CHAROID )
-            msStringTrimBlanks(shape->values[t]);
+        if (PQftype(layerinfo->pgresult, t) == CHAROID)
+          msStringTrimBlanks(shape->values[t]);
       }
-      if( layer->debug > 4 ) {
+      if (layer->debug > 4) {
         msDebug("msPostGISReadShape: PQgetlength = %d\n", size);
       }
-      if( layer->debug > 1 ) {
-        msDebug("msPostGISReadShape: [%s] \"%s\"\n", layer->items[t], shape->values[t]);
+      if (layer->debug > 1) {
+        msDebug("msPostGISReadShape: [%s] \"%s\"\n", layer->items[t],
+                shape->values[t]);
       }
     }
 
     /* layer->numitems is the geometry, layer->numitems+1 is the uid */
-    const char* tmp = PQgetvalue(layerinfo->pgresult, layerinfo->rownum, layer->numitems + 1);
+    const char *tmp =
+        PQgetvalue(layerinfo->pgresult, layerinfo->rownum, layer->numitems + 1);
     long uid = 0;
-    if( tmp ) {
-      uid = strtol( tmp, nullptr, 10 );
+    if (tmp) {
+      uid = strtol(tmp, nullptr, 10);
     }
-    if( layer->debug > 4 ) {
+    if (layer->debug > 4) {
       msDebug("msPostGISReadShape: Setting shape->index = %ld\n", uid);
-      msDebug("msPostGISReadShape: Setting shape->resultindex = %ld\n", layerinfo->rownum);
+      msDebug("msPostGISReadShape: Setting shape->resultindex = %ld\n",
+              layerinfo->rownum);
     }
     shape->index = uid;
     shape->resultindex = layerinfo->rownum;
 
-    if( layer->debug > 2 ) {
-      msDebug("msPostGISReadShape: [index] %ld\n",  shape->index);
+    if (layer->debug > 2) {
+      msDebug("msPostGISReadShape: [index] %ld\n", shape->index);
     }
 
     shape->numvalues = layer->numitems;
 
     msComputeBounds(shape);
   } else {
-     shape->type = MS_SHAPE_NULL;
+    shape->type = MS_SHAPE_NULL;
   }
 
-  if( layer->debug > 2 ) {
+  if (layer->debug > 2) {
     char *tmp = msShapeToWKT(shape);
     msDebug("msPostGISReadShape: [shape] %s\n", tmp);
     free(tmp);
@@ -2295,14 +2330,12 @@ static int msPostGISReadShape(layerObj *
 
 #endif /* USE_POSTGIS */
 
-
 /*
 ** msPostGISLayerOpen()
 **
 ** Registered vtable->LayerOpen function.
 */
-static int msPostGISLayerOpen(layerObj *layer)
-{
+static int msPostGISLayerOpen(layerObj *layer) {
 #ifdef USE_POSTGIS
   assert(layer != nullptr);
 
@@ -2314,21 +2347,22 @@ static int msPostGISLayerOpen(layerObj *
     if (layer->debug) {
       msDebug("msPostGISLayerOpen: Layer is already open!\n");
     }
-    return MS_SUCCESS;  /* already open */
+    return MS_SUCCESS; /* already open */
   }
 
   if (!layer->data) {
-    msSetError(MS_QUERYERR, "Nothing specified in DATA statement.", "msPostGISLayerOpen()");
+    msSetError(MS_QUERYERR, "Nothing specified in DATA statement.",
+               "msPostGISLayerOpen()");
     return MS_FAILURE;
   }
 
   /*
   ** Initialize the layerinfo
   **/
-  msPostGISLayerInfo* layerinfo = msPostGISCreateLayerInfo();
+  msPostGISLayerInfo *layerinfo = msPostGISCreateLayerInfo();
 
   int order_test = 1;
-  if (((char*) &order_test)[0] == 1) {
+  if (((char *)&order_test)[0] == 1) {
     layerinfo->endian = LITTLE_ENDIAN;
   } else {
     layerinfo->endian = BIG_ENDIAN;
@@ -2337,16 +2371,18 @@ static int msPostGISLayerOpen(layerObj *
   /*
   ** Get a database connection from the pool.
   */
-  layerinfo->pgconn = (PGconn *) msConnPoolRequest(layer);
+  layerinfo->pgconn = (PGconn *)msConnPoolRequest(layer);
 
   /* No connection in the pool, so set one up. */
   if (!layerinfo->pgconn) {
     if (layer->debug) {
-      msDebug("msPostGISLayerOpen: No connection in pool, creating a fresh one.\n");
+      msDebug(
+          "msPostGISLayerOpen: No connection in pool, creating a fresh one.\n");
     }
 
     if (!layer->connection) {
-      msSetError(MS_MISCERR, "Missing CONNECTION keyword.", "msPostGISLayerOpen()");
+      msSetError(MS_MISCERR, "Missing CONNECTION keyword.",
+                 "msPostGISLayerOpen()");
       delete layerinfo;
       return MS_FAILURE;
     }
@@ -2354,10 +2390,10 @@ static int msPostGISLayerOpen(layerObj *
     /*
     ** Decrypt any encrypted token in connection string and attempt to connect.
     */
-    char* conn_decrypted = msDecryptStringTokens(layer->map, layer->connection);
+    char *conn_decrypted = msDecryptStringTokens(layer->map, layer->connection);
     if (conn_decrypted == nullptr) {
       delete layerinfo;
-      return MS_FAILURE;  /* An error should already have been produced */
+      return MS_FAILURE; /* An error should already have been produced */
     }
     layerinfo->pgconn = PQconnectdb(conn_decrypted);
     msFree(conn_decrypted);
@@ -2370,32 +2406,49 @@ static int msPostGISLayerOpen(layerObj *
       if (layer->debug)
         msDebug("msPostGISLayerOpen: Connection failure.\n");
 
-      msDebug( "Database connection failed (%s) with connect string '%s'\nIs the database running? Is it allowing connections? Does the specified user exist? Is the password valid? Is the database on the standard port? in msPostGISLayerOpen()", PQerrorMessage(layerinfo->pgconn), layer->connection);
-      msSetError(MS_QUERYERR, "Database connection failed. Check server logs for more details.Is the database running? Is it allowing connections? Does the specified user exist? Is the password valid? Is the database on the standard port?", "msPostGISLayerOpen()");
+      msDebug("Database connection failed (%s) with connect string '%s'\nIs "
+              "the database running? Is it allowing connections? Does the "
+              "specified user exist? Is the password valid? Is the database on "
+              "the standard port? in msPostGISLayerOpen()",
+              PQerrorMessage(layerinfo->pgconn), layer->connection);
+      msSetError(MS_QUERYERR,
+                 "Database connection failed. Check server logs for more "
+                 "details.Is the database running? Is it allowing connections? "
+                 "Does the specified user exist? Is the password valid? Is the "
+                 "database on the standard port?",
+                 "msPostGISLayerOpen()");
 
-      if(layerinfo->pgconn) PQfinish(layerinfo->pgconn);
+      if (layerinfo->pgconn)
+        PQfinish(layerinfo->pgconn);
       delete layerinfo;
       return MS_FAILURE;
     }
 
     /* Register to receive notifications from the database. */
-    PQsetNoticeProcessor(layerinfo->pgconn, postresqlNoticeHandler, (void *) layer);
+    PQsetNoticeProcessor(layerinfo->pgconn, postresqlNoticeHandler,
+                         (void *)layer);
 
     /* Save this connection in the pool for later. */
     msConnPoolRegister(layer, layerinfo->pgconn, msPostGISCloseConnection);
   } else {
     /* Connection in the pool should be tested to see if backend is alive. */
-    if( PQstatus(layerinfo->pgconn) != CONNECTION_OK ) {
+    if (PQstatus(layerinfo->pgconn) != CONNECTION_OK) {
       /* Uh oh, bad connection. Can we reset it? */
       PQreset(layerinfo->pgconn);
-      if( PQstatus(layerinfo->pgconn) != CONNECTION_OK ) {
+      if (PQstatus(layerinfo->pgconn) != CONNECTION_OK) {
         /* Nope, time to bail out. */
-        msSetError(MS_QUERYERR, "PostgreSQL database connection. Check server logs for more details", "msPostGISLayerOpen()");
-        msDebug( "PostgreSQL database connection gone bad (%s) in msPostGISLayerOpen()", PQerrorMessage(layerinfo->pgconn));
+        msSetError(MS_QUERYERR,
+                   "PostgreSQL database connection. Check server logs for more "
+                   "details",
+                   "msPostGISLayerOpen()");
+        msDebug("PostgreSQL database connection gone bad (%s) in "
+                "msPostGISLayerOpen()",
+                PQerrorMessage(layerinfo->pgconn));
         delete layerinfo;
-        /* FIXME: we should also release the connection from the pool in this case, but it is stale...
-         * for the time being we do not release it so it can never be used again. If this happens multiple
-         * times there will be a leak... */
+        /* FIXME: we should also release the connection from the pool in this
+         * case, but it is stale... for the time being we do not release it so
+         * it can never be used again. If this happens multiple times there will
+         * be a leak... */
         return MS_FAILURE;
       }
     }
@@ -2403,32 +2456,32 @@ static int msPostGISLayerOpen(layerObj *
 
   /* Get the PostGIS version number from the database */
   layerinfo->version = msPostGISRetrieveVersion(layerinfo->pgconn);
-  if( layerinfo->version == MS_FAILURE ) {
+  if (layerinfo->version == MS_FAILURE) {
     msConnPoolRelease(layer, layerinfo->pgconn);
     delete layerinfo;
     return MS_FAILURE;
   }
   if (layer->debug)
-    msDebug("msPostGISLayerOpen: Got PostGIS version %d.\n", layerinfo->version);
+    msDebug("msPostGISLayerOpen: Got PostGIS version %d.\n",
+            layerinfo->version);
 
-  const char* force2d_processing = msLayerGetProcessingKey( layer, "FORCE2D" );
-  if(force2d_processing && !strcasecmp(force2d_processing,"no")) {
+  const char *force2d_processing = msLayerGetProcessingKey(layer, "FORCE2D");
+  if (force2d_processing && !strcasecmp(force2d_processing, "no")) {
     layerinfo->force2d = MS_FALSE;
-  }
-  else if(force2d_processing && !strcasecmp(force2d_processing,"yes")) {
+  } else if (force2d_processing && !strcasecmp(force2d_processing, "yes")) {
     layerinfo->force2d = MS_TRUE;
   }
   if (layer->debug)
-    msDebug("msPostGISLayerOpen: Forcing 2D geometries: %s.\n", (layerinfo->force2d)?"yes":"no");
+    msDebug("msPostGISLayerOpen: Forcing 2D geometries: %s.\n",
+            (layerinfo->force2d) ? "yes" : "no");
 
   /* Save the layerinfo in the layerObj. */
-  layer->layerinfo = (void*)layerinfo;
+  layer->layerinfo = (void *)layerinfo;
 
   return MS_SUCCESS;
 #else
-  msSetError( MS_MISCERR,
-              "PostGIS support is not available.",
-              "msPostGISLayerOpen()");
+  msSetError(MS_MISCERR, "PostGIS support is not available.",
+             "msPostGISLayerOpen()");
   return MS_FAILURE;
 #endif
 }
@@ -2438,35 +2491,31 @@ static int msPostGISLayerOpen(layerObj *
 **
 ** Registered vtable->LayerClose function.
 */
-static int msPostGISLayerClose(layerObj *layer)
-{
+static int msPostGISLayerClose(layerObj *layer) {
 #ifdef USE_POSTGIS
 
   if (layer->debug) {
     msDebug("msPostGISLayerClose called: %s\n", layer->data);
   }
 
-  if( layer->layerinfo ) {
+  if (layer->layerinfo) {
     msPostGISFreeLayerInfo(layer);
   }
 
   return MS_SUCCESS;
 #else
-  msSetError( MS_MISCERR,
-              "PostGIS support is not available.",
-              "msPostGISLayerClose()");
+  msSetError(MS_MISCERR, "PostGIS support is not available.",
+             "msPostGISLayerClose()");
   return MS_FAILURE;
 #endif
 }
 
-
 /*
 ** msPostGISLayerIsOpen()
 **
 ** Registered vtable->LayerIsOpen function.
 */
-static int msPostGISLayerIsOpen(layerObj *layer)
-{
+static int msPostGISLayerIsOpen(layerObj *layer) {
 #ifdef USE_POSTGIS
 
   if (layer->debug) {
@@ -2478,21 +2527,18 @@ static int msPostGISLayerIsOpen(layerObj
   else
     return MS_FALSE;
 #else
-  msSetError( MS_MISCERR,
-              "PostGIS support is not available.",
-              "msPostGISLayerIsOpen()");
+  msSetError(MS_MISCERR, "PostGIS support is not available.",
+             "msPostGISLayerIsOpen()");
   return MS_FAILURE;
 #endif
 }
 
-
 /*
 ** msPostGISLayerFreeItemInfo()
 **
 ** Registered vtable->LayerFreeItemInfo function.
 */
-static void msPostGISLayerFreeItemInfo(layerObj *layer)
-{
+static void msPostGISLayerFreeItemInfo(layerObj *layer) {
 #ifdef USE_POSTGIS
   if (layer->debug) {
     msDebug("msPostGISLayerFreeItemInfo called.\n");
@@ -2511,8 +2557,7 @@ static void msPostGISLayerFreeItemInfo(l
 ** Registered vtable->LayerInitItemInfo function.
 ** Our iteminfo is list of indexes from 1..numitems.
 */
-static int msPostGISLayerInitItemInfo(layerObj *layer)
-{
+static int msPostGISLayerInitItemInfo(layerObj *layer) {
 #ifdef USE_POSTGIS
   if (layer->debug) {
     msDebug("msPostGISLayerInitItemInfo called.\n");
@@ -2532,47 +2577,52 @@ static int msPostGISLayerInitItemInfo(la
     return MS_FAILURE;
   }
 
-  int* itemindexes = (int*)layer->iteminfo;
+  int *itemindexes = (int *)layer->iteminfo;
   for (int i = 0; i < layer->numitems; i++) {
-    itemindexes[i] = i; /* Last item is always the geometry. The rest are non-geometry. */
+    itemindexes[i] =
+        i; /* Last item is always the geometry. The rest are non-geometry. */
   }
 
   return MS_SUCCESS;
 #else
-  msSetError( MS_MISCERR,
-              "PostGIS support is not available.",
-              "msPostGISLayerInitItemInfo()");
+  msSetError(MS_MISCERR, "PostGIS support is not available.",
+             "msPostGISLayerInitItemInfo()");
   return MS_FAILURE;
 #endif
 }
 
 #ifdef USE_POSTGIS
-static std::vector<const char*> buildBindValues(layerObj *layer)
-{
+static std::vector<const char *> buildBindValues(layerObj *layer) {
   /* try to get the first bind value */
-  const char* bind_value = msLookupHashTable(&layer->bindvals, "1");
-  std::vector<const char*> layer_bind_values;
-  while(bind_value != nullptr) {
+  const char *bind_value = msLookupHashTable(&layer->bindvals, "1");
+  std::vector<const char *> layer_bind_values;
+  while (bind_value != nullptr) {
     /* put the bind value on the stack */
     layer_bind_values.push_back(bind_value);
     /* get the bind_value */
-    bind_value = msLookupHashTable(&layer->bindvals,
-        std::to_string(static_cast<size_t>(layer_bind_values.size())+1).c_str());
+    bind_value = msLookupHashTable(
+        &layer->bindvals,
+        std::to_string(static_cast<size_t>(layer_bind_values.size()) + 1)
+            .c_str());
   }
   return layer_bind_values;
 }
 
-static PGresult* runPQexecParamsWithBindSubstitution(layerObj *layer, const char* strSQL, int binary)
-{
+static PGresult *runPQexecParamsWithBindSubstitution(layerObj *layer,
+                                                     const char *strSQL,
+                                                     int binary) {
   PGresult *pgresult = nullptr;
-  msPostGISLayerInfo* layerinfo = (msPostGISLayerInfo*) layer->layerinfo;
+  msPostGISLayerInfo *layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
 
   const auto layer_bind_values = buildBindValues(layer);
 
-  if( !layer_bind_values.empty() ) {
-    pgresult = PQexecParams(layerinfo->pgconn, strSQL, static_cast<int>(layer_bind_values.size()), nullptr, layer_bind_values.data(), nullptr, nullptr, binary);
+  if (!layer_bind_values.empty()) {
+    pgresult = PQexecParams(layerinfo->pgconn, strSQL,
+                            static_cast<int>(layer_bind_values.size()), nullptr,
+                            layer_bind_values.data(), nullptr, nullptr, binary);
   } else {
-    pgresult = PQexecParams(layerinfo->pgconn, strSQL, 0, nullptr, nullptr, nullptr, nullptr, binary);
+    pgresult = PQexecParams(layerinfo->pgconn, strSQL, 0, nullptr, nullptr,
+                            nullptr, nullptr, binary);
   }
 
   return pgresult;
@@ -2585,8 +2635,8 @@ static PGresult* runPQexecParamsWithBind
 ** Registered vtable->LayerWhichShapes function.
 */
 // cppcheck-suppress passedByValue
-static int msPostGISLayerWhichShapes(layerObj *layer, rectObj rect, int isQuery)
-{
+static int msPostGISLayerWhichShapes(layerObj *layer, rectObj rect,
+                                     int isQuery) {
   (void)isQuery;
 #ifdef USE_POSTGIS
   assert(layer != nullptr);
@@ -2597,7 +2647,7 @@ static int msPostGISLayerWhichShapes(lay
   }
 
   /* Fill out layerinfo with our current DATA state. */
-  if ( msPostGISParseData(layer) != MS_SUCCESS) {
+  if (msPostGISParseData(layer) != MS_SUCCESS) {
     return MS_FAILURE;
   }
 
@@ -2605,12 +2655,14 @@ static int msPostGISLayerWhichShapes(lay
   ** This comes *after* parsedata, because parsedata fills in
   ** layer->layerinfo.
   */
-  msPostGISLayerInfo* layerinfo = (msPostGISLayerInfo*) layer->layerinfo;
+  msPostGISLayerInfo *layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
 
   /* Build a SQL query based on our current state. */
-  const std::string strSQL = msPostGISBuildSQL(layer, &rect, nullptr, nullptr, -1);
-  if ( strSQL.empty() ) {
-    msSetError(MS_QUERYERR, "Failed to build query SQL.", "msPostGISLayerWhichShapes()");
+  const std::string strSQL =
+      msPostGISBuildSQL(layer, &rect, nullptr, nullptr, -1);
+  if (strSQL.empty()) {
+    msSetError(MS_QUERYERR, "Failed to build query SQL.",
+               "msPostGISLayerWhichShapes()");
     return MS_FAILURE;
   }
 
@@ -2618,28 +2670,34 @@ static int msPostGISLayerWhichShapes(lay
     msDebug("msPostGISLayerWhichShapes query: %s\n", strSQL.c_str());
   }
 
-  PGresult* pgresult = runPQexecParamsWithBindSubstitution(layer, strSQL.c_str(), RESULTSET_TYPE);
+  PGresult *pgresult = runPQexecParamsWithBindSubstitution(
+      layer, strSQL.c_str(), RESULTSET_TYPE);
 
-  if ( layer->debug > 1 ) {
-    msDebug("msPostGISLayerWhichShapes query status: %s (%d)\n", PQresStatus(PQresultStatus(pgresult)), PQresultStatus(pgresult));
+  if (layer->debug > 1) {
+    msDebug("msPostGISLayerWhichShapes query status: %s (%d)\n",
+            PQresStatus(PQresultStatus(pgresult)), PQresultStatus(pgresult));
   }
 
   /* Something went wrong. */
   if (!pgresult || PQresultStatus(pgresult) != PGRES_TUPLES_OK) {
-    msDebug("msPostGISLayerWhichShapes(): Error (%s) executing query: %s\n", PQerrorMessage(layerinfo->pgconn), strSQL.c_str());
-    msSetError(MS_QUERYERR, "Error executing query. Check server logs","msPostGISLayerWhichShapes()");
+    msDebug("msPostGISLayerWhichShapes(): Error (%s) executing query: %s\n",
+            PQerrorMessage(layerinfo->pgconn), strSQL.c_str());
+    msSetError(MS_QUERYERR, "Error executing query. Check server logs",
+               "msPostGISLayerWhichShapes()");
     if (pgresult) {
       PQclear(pgresult);
     }
     return MS_FAILURE;
   }
 
-  if ( layer->debug ) {
-    msDebug("msPostGISLayerWhichShapes got %d records in result.\n", PQntuples(pgresult));
+  if (layer->debug) {
+    msDebug("msPostGISLayerWhichShapes got %d records in result.\n",
+            PQntuples(pgresult));
   }
 
   /* Clean any existing pgresult before storing current one. */
-  if(layerinfo->pgresult) PQclear(layerinfo->pgresult);
+  if (layerinfo->pgresult)
+    PQclear(layerinfo->pgresult);
   layerinfo->pgresult = pgresult;
 
   layerinfo->sql = strSQL;
@@ -2648,9 +2706,8 @@ static int msPostGISLayerWhichShapes(lay
 
   return MS_SUCCESS;
 #else
-  msSetError( MS_MISCERR,
-              "PostGIS support is not available.",
-              "msPostGISLayerWhichShapes()");
+  msSetError(MS_MISCERR, "PostGIS support is not available.",
+             "msPostGISLayerWhichShapes()");
   return MS_FAILURE;
 #endif
 }
@@ -2660,8 +2717,7 @@ static int msPostGISLayerWhichShapes(lay
 **
 ** Registered vtable->LayerNextShape function.
 */
-static int msPostGISLayerNextShape(layerObj *layer, shapeObj *shape)
-{
+static int msPostGISLayerNextShape(layerObj *layer, shapeObj *shape) {
 #ifdef USE_POSTGIS
   if (layer->debug) {
     msDebug("msPostGISLayerNextShape called.\n");
@@ -2670,7 +2726,7 @@ static int msPostGISLayerNextShape(layer
   assert(layer != nullptr);
   assert(layer->layerinfo != nullptr);
 
-  msPostGISLayerInfo* layerinfo = (msPostGISLayerInfo*) layer->layerinfo;
+  msPostGISLayerInfo *layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
 
   shape->type = MS_SHAPE_NULL;
 
@@ -2681,7 +2737,7 @@ static int msPostGISLayerNextShape(layer
     if (layerinfo->rownum < PQntuples(layerinfo->pgresult)) {
       /* Retrieve this shape, cursor access mode. */
       msPostGISReadShape(layer, shape);
-      if( shape->type != MS_SHAPE_NULL ) {
+      if (shape->type != MS_SHAPE_NULL) {
         (layerinfo->rownum)++; /* move to next shape */
         return MS_SUCCESS;
       } else {
@@ -2697,9 +2753,8 @@ static int msPostGISLayerNextShape(layer
 
   return MS_FAILURE;
 #else
-  msSetError( MS_MISCERR,
-              "PostGIS support is not available.",
-              "msPostGISLayerNextShape()");
+  msSetError(MS_MISCERR, "PostGIS support is not available.",
+             "msPostGISLayerNextShape()");
   return MS_FAILURE;
 #endif
 }
@@ -2707,10 +2762,10 @@ static int msPostGISLayerNextShape(layer
 /*
 ** msPostGISLayerGetShape()
 **
- */
+*/
 // cppcheck-suppress passedByValue
-static int msPostGISLayerGetShapeCount(layerObj *layer, rectObj rect, projectionObj *rectProjection)
-{
+static int msPostGISLayerGetShapeCount(layerObj *layer, rectObj rect,
+                                       projectionObj *rectProjection) {
 #ifdef USE_POSTGIS
   int rectSRID = -1;
   rectObj searchrectInLayerProj = rect;
@@ -2722,34 +2777,36 @@ static int msPostGISLayerGetShapeCount(l
     msDebug("msPostGISLayerGetShapeCount called.\n");
   }
 
-
-  // Special processing if the specified projection for the rect is different from the layer projection
-  // We want to issue a WHERE that includes
-  // ((the_geom && rect_reprojected_in_layer_SRID) AND NOT ST_Disjoint(ST_Transform(the_geom, rect_SRID), rect))
-  if( rectProjection != NULL && layer->project &&
-      msProjectionsDiffer(&(layer->projection), rectProjection) )
-  {
+  // Special processing if the specified projection for the rect is different
+  // from the layer projection We want to issue a WHERE that includes
+  // ((the_geom && rect_reprojected_in_layer_SRID) AND NOT
+  // ST_Disjoint(ST_Transform(the_geom, rect_SRID), rect))
+  if (rectProjection != NULL && layer->project &&
+      msProjectionsDiffer(&(layer->projection), rectProjection)) {
     // If we cannot guess the EPSG code of the rectProjection, we cannot
     // use ST_Transform, so fallback on slow implementation
-    if( rectProjection->numargs < 1 ||
-        strncasecmp(rectProjection->args[0], "init=epsg:", strlen("init=epsg:")) != 0 )
-    {
+    if (rectProjection->numargs < 1 ||
+        strncasecmp(rectProjection->args[0],
+                    "init=epsg:", strlen("init=epsg:")) != 0) {
       if (layer->debug) {
-        msDebug("msPostGISLayerGetShapeCount(): cannot find EPSG code of rectProjection. Falling back on client-side feature count.\n");
+        msDebug("msPostGISLayerGetShapeCount(): cannot find EPSG code of "
+                "rectProjection. Falling back on client-side feature count.\n");
       }
       return LayerDefaultGetShapeCount(layer, rect, rectProjection);
     }
 
     // Reproject the passed rect into the layer projection and get
     // the SRID from the rectProjection
-    msProjectRect(rectProjection, &(layer->projection), &searchrectInLayerProj); /* project the searchrect to source coords */
+    msProjectRect(
+        rectProjection, &(layer->projection),
+        &searchrectInLayerProj); /* project the searchrect to source coords */
     rectSRID = atoi(rectProjection->args[0] + strlen("init=epsg:"));
   }
 
   msLayerTranslateFilter(layer, &layer->filter, layer->filteritem);
 
   /* Fill out layerinfo with our current DATA state. */
-  if ( msPostGISParseData(layer) != MS_SUCCESS) {
+  if (msPostGISParseData(layer) != MS_SUCCESS) {
     return -1;
   }
 
@@ -2757,13 +2814,14 @@ static int msPostGISLayerGetShapeCount(l
   ** This comes *after* parsedata, because parsedata fills in
   ** layer->layerinfo.
   */
-  msPostGISLayerInfo* layerinfo = (msPostGISLayerInfo*) layer->layerinfo;
+  msPostGISLayerInfo *layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
 
   /* Build a SQL query based on our current state. */
-  const std::string strSQL = msPostGISBuildSQL(layer, &searchrectInLayerProj, nullptr,
-                             &rect, rectSRID);
-  if ( strSQL.empty() ) {
-    msSetError(MS_QUERYERR, "Failed to build query SQL.", "msPostGISLayerGetShapeCount()");
+  const std::string strSQL = msPostGISBuildSQL(layer, &searchrectInLayerProj,
+                                               nullptr, &rect, rectSRID);
+  if (strSQL.empty()) {
+    msSetError(MS_QUERYERR, "Failed to build query SQL.",
+               "msPostGISLayerGetShapeCount()");
     return -1;
   }
 
@@ -2775,9 +2833,10 @@ static int msPostGISLayerGetShapeCount(l
     msDebug("msPostGISLayerGetShapeCount query: %s\n", strSQLCount.c_str());
   }
 
-  PGresult* pgresult = runPQexecParamsWithBindSubstitution(layer, strSQLCount.c_str(), 0);
+  PGresult *pgresult =
+      runPQexecParamsWithBindSubstitution(layer, strSQLCount.c_str(), 0);
 
-  if ( layer->debug > 1 ) {
+  if (layer->debug > 1) {
     msDebug("msPostGISLayerWhichShapes query status: %s (%d)\n",
             PQresStatus(PQresultStatus(pgresult)), PQresultStatus(pgresult));
   }
@@ -2793,31 +2852,29 @@ static int msPostGISLayerGetShapeCount(l
     return LayerDefaultGetShapeCount(layer, rect, rectProjection);
   }
 
-  const int nCount = atoi(PQgetvalue(pgresult, 0, 0 ));
+  const int nCount = atoi(PQgetvalue(pgresult, 0, 0));
 
-  if ( layer->debug ) {
+  if (layer->debug) {
     msDebug("msPostGISLayerWhichShapes return: %d.\n", nCount);
   }
   PQclear(pgresult);
 
   return nCount;
 #else
-  msSetError( MS_MISCERR,
-              "PostGIS support is not available.",
-              "msPostGISLayerGetShapeCount()");
+  msSetError(MS_MISCERR, "PostGIS support is not available.",
+             "msPostGISLayerGetShapeCount()");
   return -1;
 #endif
 }
 
-
 /*
 ** msPostGISLayerGetShape()
 **
 ** Registered vtable->LayerGetShape function. For pulling from a prepared and
 ** undisposed result set.
 */
-static int msPostGISLayerGetShape(layerObj *layer, shapeObj *shape, resultObj *record)
-{
+static int msPostGISLayerGetShape(layerObj *layer, shapeObj *shape,
+                                  resultObj *record) {
 #ifdef USE_POSTGIS
 
   long shapeindex = record->shapeindex;
@@ -2830,35 +2887,36 @@ static int msPostGISLayerGetShape(layerO
     msDebug("msPostGISLayerGetShape called for record = %i\n", resultindex);
   }
 
-  /* If resultindex is set, fetch the shape from the resultcache, otherwise fetch it from the DB  */
+  /* If resultindex is set, fetch the shape from the resultcache, otherwise
+   * fetch it from the DB  */
   if (resultindex >= 0) {
-    msPostGISLayerInfo* layerinfo = (msPostGISLayerInfo*) layer->layerinfo;
+    msPostGISLayerInfo *layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
 
     /* Check the validity of the open result. */
-    PGresult* pgresult = layerinfo->pgresult;
-    if ( ! pgresult ) {
-      msSetError( MS_MISCERR,
-                  "PostgreSQL result set is null.",
-                  "msPostGISLayerGetShape()");
+    PGresult *pgresult = layerinfo->pgresult;
+    if (!pgresult) {
+      msSetError(MS_MISCERR, "PostgreSQL result set is null.",
+                 "msPostGISLayerGetShape()");
       return MS_FAILURE;
     }
     ExecStatusType status = PQresultStatus(pgresult);
-    if ( layer->debug > 1 ) {
-      msDebug("msPostGISLayerGetShape query status: %s (%d)\n", PQresStatus(status), (int)status);
-    }
-    if( ! ( status == PGRES_COMMAND_OK || status == PGRES_TUPLES_OK) ) {
-      msSetError( MS_MISCERR,
-                  "PostgreSQL result set is not ready.",
-                  "msPostGISLayerGetShape()");
+    if (layer->debug > 1) {
+      msDebug("msPostGISLayerGetShape query status: %s (%d)\n",
+              PQresStatus(status), (int)status);
+    }
+    if (!(status == PGRES_COMMAND_OK || status == PGRES_TUPLES_OK)) {
+      msSetError(MS_MISCERR, "PostgreSQL result set is not ready.",
+                 "msPostGISLayerGetShape()");
       return MS_FAILURE;
     }
 
     /* Check the validity of the requested record number. */
-    if( resultindex >= PQntuples(pgresult) ) {
-      msDebug("msPostGISLayerGetShape got request for (%d) but only has %d tuples.\n", resultindex, PQntuples(pgresult));
-      msSetError( MS_MISCERR,
-                  "Got request larger than result set.",
-                  "msPostGISLayerGetShape()");
+    if (resultindex >= PQntuples(pgresult)) {
+      msDebug("msPostGISLayerGetShape got request for (%d) but only has %d "
+              "tuples.\n",
+              resultindex, PQntuples(pgresult));
+      msSetError(MS_MISCERR, "Got request larger than result set.",
+                 "msPostGISLayerGetShape()");
       return MS_FAILURE;
     }
 
@@ -2875,7 +2933,7 @@ static int msPostGISLayerGetShape(layerO
     int num_tuples;
 
     /* Fill out layerinfo with our current DATA state. */
-    if ( msPostGISParseData(layer) != MS_SUCCESS) {
+    if (msPostGISParseData(layer) != MS_SUCCESS) {
       return MS_FAILURE;
     }
 
@@ -2883,12 +2941,14 @@ static int msPostGISLayerGetShape(layerO
     ** This comes *after* parsedata, because parsedata fills in
     ** layer->layerinfo.
     */
-    msPostGISLayerInfo* layerinfo = (msPostGISLayerInfo*) layer->layerinfo;
+    msPostGISLayerInfo *layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
 
     /* Build a SQL query based on our current state. */
-    const std::string strSQL = msPostGISBuildSQL(layer, nullptr, &shapeindex, nullptr, -1);
-    if ( strSQL.empty() ) {
-      msSetError(MS_QUERYERR, "Failed to build query SQL.", "msPostGISLayerGetShape()");
+    const std::string strSQL =
+        msPostGISBuildSQL(layer, nullptr, &shapeindex, nullptr, -1);
+    if (strSQL.empty()) {
+      msSetError(MS_QUERYERR, "Failed to build query SQL.",
+                 "msPostGISLayerGetShape()");
       return MS_FAILURE;
     }
 
@@ -2896,12 +2956,15 @@ static int msPostGISLayerGetShape(layerO
       msDebug("msPostGISLayerGetShape query: %s\n", strSQL.c_str());
     }
 
-    PGresult* pgresult = runPQexecParamsWithBindSubstitution(layer, strSQL.c_str(), RESULTSET_TYPE);
+    PGresult *pgresult = runPQexecParamsWithBindSubstitution(
+        layer, strSQL.c_str(), RESULTSET_TYPE);
 
     /* Something went wrong. */
-    if ( (!pgresult) || (PQresultStatus(pgresult) != PGRES_TUPLES_OK) ) {
-      msDebug("msPostGISLayerGetShape(): Error (%s) executing SQL: %s\n", PQerrorMessage(layerinfo->pgconn), strSQL.c_str() );
-      msSetError(MS_QUERYERR, "Error executing SQL. Check server logs.","msPostGISLayerGetShape()");
+    if ((!pgresult) || (PQresultStatus(pgresult) != PGRES_TUPLES_OK)) {
+      msDebug("msPostGISLayerGetShape(): Error (%s) executing SQL: %s\n",
+              PQerrorMessage(layerinfo->pgconn), strSQL.c_str());
+      msSetError(MS_QUERYERR, "Error executing SQL. Check server logs.",
+                 "msPostGISLayerGetShape()");
 
       if (pgresult) {
         PQclear(pgresult);
@@ -2910,7 +2973,8 @@ static int msPostGISLayerGetShape(layerO
     }
 
     /* Clean any existing pgresult before storing current one. */
-    if(layerinfo->pgresult) PQclear(layerinfo->pgresult);
+    if (layerinfo->pgresult)
+      PQclear(layerinfo->pgresult);
     layerinfo->pgresult = pgresult;
 
     /* Clean any existing SQL before storing current. */
@@ -2931,12 +2995,13 @@ static int msPostGISLayerGetShape(layerO
       msPostGISReadShape(layer, shape);
     }
 
-    return (shape->type == MS_SHAPE_NULL) ? MS_FAILURE : ( (num_tuples > 0) ? MS_SUCCESS : MS_DONE );
+    return (shape->type == MS_SHAPE_NULL)
+               ? MS_FAILURE
+               : ((num_tuples > 0) ? MS_SUCCESS : MS_DONE);
   }
 #else
-  msSetError( MS_MISCERR,
-              "PostGIS support is not available.",
-              "msPostGISLayerGetShape()");
+  msSetError(MS_MISCERR, "PostGIS support is not available.",
+             "msPostGISLayerGetShape()");
   return MS_FAILURE;
 #endif
 }
@@ -2950,66 +3015,66 @@ static int msPostGISLayerGetShape(layerO
  **********************************************************************/
 
 #ifdef USE_POSTGIS
-static void
-msPostGISPassThroughFieldDefinitions( layerObj *layer,
-                                      PGresult *pgresult )
+static void msPostGISPassThroughFieldDefinitions(layerObj *layer,
+                                                 PGresult *pgresult)
 
 {
   const int numitems = PQnfields(pgresult);
-  msPostGISLayerInfo *layerinfo = static_cast<msPostGISLayerInfo*>(layer->layerinfo);
+  msPostGISLayerInfo *layerinfo =
+      static_cast<msPostGISLayerInfo *>(layer->layerinfo);
 
-  for(int i=0; i<numitems; i++) {
+  for (int i = 0; i < numitems; i++) {
     const char *gml_type = "Character";
-    const char *item = PQfname(pgresult,i);
+    const char *item = PQfname(pgresult, i);
     std::string gml_width;
     std::string gml_precision;
 
     /* skip geometry column */
-    if( item == layerinfo->geomcolumn )
+    if (item == layerinfo->geomcolumn)
       continue;
 
-    const int oid = PQftype(pgresult,i);
-    const int fmod = PQfmod(pgresult,i);
+    const int oid = PQftype(pgresult, i);
+    const int fmod = PQfmod(pgresult, i);
 
-    if( (oid == BPCHAROID || oid == VARCHAROID) && fmod >= 4 ) {
-      gml_width = std::to_string( fmod-4 );
+    if ((oid == BPCHAROID || oid == VARCHAROID) && fmod >= 4) {
+      gml_width = std::to_string(fmod - 4);
 
-    } else if( oid == BOOLOID ) {
+    } else if (oid == BOOLOID) {
       gml_type = "Boolean";
 
-    } else if( oid == INT2OID ) {
+    } else if (oid == INT2OID) {
       gml_type = "Integer";
       gml_width = '5';
 
-    } else if( oid == INT4OID ) {
+    } else if (oid == INT4OID) {
       gml_type = "Integer";
 
-    } else if( oid == INT8OID ) {
+    } else if (oid == INT8OID) {
       gml_type = "Long";
 
-    } else if( oid == FLOAT4OID || oid == FLOAT8OID ) {
+    } else if (oid == FLOAT4OID || oid == FLOAT8OID) {
       gml_type = "Real";
 
-    } else if( oid == NUMERICOID ) {
+    } else if (oid == NUMERICOID) {
       gml_type = "Real";
 
-      if( fmod >= 4 && ((fmod - 4) & 0xFFFF) == 0 ) {
+      if (fmod >= 4 && ((fmod - 4) & 0xFFFF) == 0) {
         gml_type = "Integer";
-        gml_width = std::to_string( (fmod - 4) >> 16 );
-      } else if( fmod >= 4 ) {
-        gml_width = std::to_string( (fmod - 4) >> 16 );
-        gml_precision = std::to_string( (fmod-4) & 0xFFFF );
+        gml_width = std::to_string((fmod - 4) >> 16);
+      } else if (fmod >= 4) {
+        gml_width = std::to_string((fmod - 4) >> 16);
+        gml_precision = std::to_string((fmod - 4) & 0xFFFF);
       }
-    } else if( oid == DATEOID ) {
+    } else if (oid == DATEOID) {
       gml_type = "Date";
-    } else if( oid == TIMEOID || oid == TIMETZOID ) {
+    } else if (oid == TIMEOID || oid == TIMETZOID) {
       gml_type = "Time";
-    } else if( oid == TIMESTAMPOID || oid == TIMESTAMPTZOID ) {
+    } else if (oid == TIMESTAMPOID || oid == TIMESTAMPTZOID) {
       gml_type = "DateTime";
     }
 
-    msUpdateGMLFieldMetadata(layer, item, gml_type, gml_width.c_str(), gml_precision.c_str(), 0);
-
+    msUpdateGMLFieldMetadata(layer, item, gml_type, gml_width.c_str(),
+                             gml_precision.c_str(), 0);
   }
 }
 #endif /* defined(USE_POSTGIS) */
@@ -3022,8 +3087,7 @@ msPostGISPassThroughFieldDefinitions( la
 ** system tables, we just run a zero-cost query and read out of the
 ** result header.
 */
-static int msPostGISLayerGetItems(layerObj *layer)
-{
+static int msPostGISLayerGetItems(layerObj *layer) {
 #ifdef USE_POSTGIS
   rectObj rect;
 
@@ -3033,7 +3097,7 @@ static int msPostGISLayerGetItems(layerO
   assert(layer != nullptr);
   assert(layer->layerinfo != nullptr);
 
-  msPostGISLayerInfo* layerinfo = (msPostGISLayerInfo*) layer->layerinfo;
+  msPostGISLayerInfo *layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
 
   assert(layerinfo->pgconn);
 
@@ -3042,11 +3106,11 @@ static int msPostGISLayerGetItems(layerO
   }
 
   /* Fill out layerinfo with our current DATA state. */
-  if ( msPostGISParseData(layer) != MS_SUCCESS) {
+  if (msPostGISParseData(layer) != MS_SUCCESS) {
     return MS_FAILURE;
   }
 
-  layerinfo = (msPostGISLayerInfo*) layer->layerinfo;
+  layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
 
   /*
   ** Both the "table" and "(select ...) as sub" cases can be handled with the
@@ -3060,26 +3124,33 @@ static int msPostGISLayerGetItems(layerO
     msDebug("msPostGISLayerGetItems executing SQL: %s\n", sql.c_str());
   }
 
-  PGresult* pgresult = runPQexecParamsWithBindSubstitution(layer, sql.c_str(), 0);
+  PGresult *pgresult =
+      runPQexecParamsWithBindSubstitution(layer, sql.c_str(), 0);
 
-  if ( (!pgresult) || (PQresultStatus(pgresult) != PGRES_TUPLES_OK) ) {
-    msDebug("msPostGISLayerGetItems(): Error (%s) executing SQL: %s\n", PQerrorMessage(layerinfo->pgconn), sql.c_str());
-    msSetError(MS_QUERYERR, "Error executing SQL. Check server logs","msPostGISLayerGetItems()");
+  if ((!pgresult) || (PQresultStatus(pgresult) != PGRES_TUPLES_OK)) {
+    msDebug("msPostGISLayerGetItems(): Error (%s) executing SQL: %s\n",
+            PQerrorMessage(layerinfo->pgconn), sql.c_str());
+    msSetError(MS_QUERYERR, "Error executing SQL. Check server logs",
+               "msPostGISLayerGetItems()");
     if (pgresult) {
       PQclear(pgresult);
     }
     return MS_FAILURE;
   }
 
-  layer->numitems = PQnfields(pgresult) - 1; /* dont include the geometry column (last entry)*/
-  layer->items = static_cast<char**>(msSmallMalloc(sizeof(char*) * (layer->numitems + 1))); /* +1 in case there is a problem finding geometry column */
+  layer->numitems = PQnfields(pgresult) -
+                    1; /* dont include the geometry column (last entry)*/
+  layer->items = static_cast<char **>(msSmallMalloc(
+      sizeof(char *) *
+      (layer->numitems +
+       1))); /* +1 in case there is a problem finding geometry column */
 
   bool found_geom = false; /* havent found the geom field */
   int item_num = 0;
 
   for (int t = 0; t < PQnfields(pgresult); t++) {
-    const char* col = PQfname(pgresult, t);
-    if ( col != layerinfo->geomcolumn) {
+    const char *col = PQfname(pgresult, t);
+    if (col != layerinfo->geomcolumn) {
       /* this isnt the geometry column */
       layer->items[item_num] = msStrdup(col);
       item_num++;
@@ -3091,9 +3162,9 @@ static int msPostGISLayerGetItems(layerO
   /*
   ** consider populating the field definitions in metadata.
   */
-  const char* value =  msOWSLookupMetadata(&(layer->metadata), "G", "types");
-  if(value != nullptr && strcasecmp(value,"auto") == 0 )
-    msPostGISPassThroughFieldDefinitions( layer, pgresult );
+  const char *value = msOWSLookupMetadata(&(layer->metadata), "G", "types");
+  if (value != nullptr && strcasecmp(value, "auto") == 0)
+    msPostGISPassThroughFieldDefinitions(layer, pgresult);
 
   /*
   ** Cleanup
@@ -3101,52 +3172,54 @@ static int msPostGISLayerGetItems(layerO
   PQclear(pgresult);
 
   if (!found_geom) {
-    msSetError(MS_QUERYERR, "Tried to find the geometry column in the database, but couldn't find it.  Is it mis-capitalized? '%s'", "msPostGISLayerGetItems()", layerinfo->geomcolumn.c_str());
+    msSetError(MS_QUERYERR,
+               "Tried to find the geometry column in the database, but "
+               "couldn't find it.  Is it mis-capitalized? '%s'",
+               "msPostGISLayerGetItems()", layerinfo->geomcolumn.c_str());
     return MS_FAILURE;
   }
 
   return msPostGISLayerInitItemInfo(layer);
 #else
-  msSetError( MS_MISCERR,
-              "PostGIS support is not available.",
-              "msPostGISLayerGetItems()");
+  msSetError(MS_MISCERR, "PostGIS support is not available.",
+             "msPostGISLayerGetItems()");
   return MS_FAILURE;
 #endif
 }
 
 #ifdef USE_POSTGIS
-static std::string addTableNameAndFilterToSelectFrom(layerObj *layer,
-                                            const std::string& selectFrom)
-{
-    auto layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
-    /* if we have !BOX! substitution then we use just the table name */
-    std::string f_table_name;
-    if (strstr(layerinfo->fromsource.c_str(), BOXTOKEN))
-        f_table_name = msPostGISFindTableName(layerinfo->fromsource.c_str());
-    else
-        f_table_name = layerinfo->fromsource;
+static std::string
+addTableNameAndFilterToSelectFrom(layerObj *layer,
+                                  const std::string &selectFrom) {
+  auto layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
+  /* if we have !BOX! substitution then we use just the table name */
+  std::string f_table_name;
+  if (strstr(layerinfo->fromsource.c_str(), BOXTOKEN))
+    f_table_name = msPostGISFindTableName(layerinfo->fromsource.c_str());
+  else
+    f_table_name = layerinfo->fromsource;
 
-    std::string strSQL = selectFrom;
-    strSQL += f_table_name;
+  std::string strSQL = selectFrom;
+  strSQL += f_table_name;
 
-    /* Handle a translated filter (RFC91). */
-    if (layer->filter.native_string) {
-        strSQL += " WHERE (";
-        strSQL += layer->filter.native_string;
-        strSQL += ')';
-    }
-
-    /* Handle a native filter set as a PROCESSING option (#5001). */
-    const char* native_filter = msLayerGetProcessingKey(layer, "NATIVE_FILTER");
-    if (native_filter) {
-        if( layer->filter.native_string )
-            strSQL += " AND (";
-        else
-            strSQL += " WHERE (";
-        strSQL += native_filter;
-        strSQL += ')';
-    }
-    return strSQL;
+  /* Handle a translated filter (RFC91). */
+  if (layer->filter.native_string) {
+    strSQL += " WHERE (";
+    strSQL += layer->filter.native_string;
+    strSQL += ')';
+  }
+
+  /* Handle a native filter set as a PROCESSING option (#5001). */
+  const char *native_filter = msLayerGetProcessingKey(layer, "NATIVE_FILTER");
+  if (native_filter) {
+    if (layer->filter.native_string)
+      strSQL += " AND (";
+    else
+      strSQL += " WHERE (";
+    strSQL += native_filter;
+    strSQL += ')';
+  }
+  return strSQL;
 }
 #endif
 
@@ -3156,33 +3229,35 @@ static std::string addTableNameAndFilter
 ** Registered vtable->LayerGetExtent function. Query the database for
 ** the extent of the requested layer.
 */
-static int msPostGISLayerGetExtent(layerObj *layer, rectObj *extent)
-{
+static int msPostGISLayerGetExtent(layerObj *layer, rectObj *extent) {
 #ifdef USE_POSTGIS
   if (layer->debug) {
     msDebug("msPostGISLayerGetExtent called.\n");
   }
 
-  assert( layer->layerinfo != nullptr);
+  assert(layer->layerinfo != nullptr);
 
-  if ( msPostGISParseData(layer) != MS_SUCCESS) {
+  if (msPostGISParseData(layer) != MS_SUCCESS) {
     return MS_FAILURE;
   }
 
   auto layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
-  const std::string strSQL(addTableNameAndFilterToSelectFrom(layer,
-    "SELECT ST_Extent(" + layerinfo->geomcolumn + ") FROM "));
+  const std::string strSQL(addTableNameAndFilterToSelectFrom(
+      layer, "SELECT ST_Extent(" + layerinfo->geomcolumn + ") FROM "));
 
   if (layer->debug) {
     msDebug("msPostGISLayerGetExtent executing SQL: %s\n", strSQL.c_str());
   }
 
   /* executing the query */
-  PGresult* pgresult = runPQexecParamsWithBindSubstitution(layer, strSQL.c_str(), 0);
+  PGresult *pgresult =
+      runPQexecParamsWithBindSubstitution(layer, strSQL.c_str(), 0);
 
-  if ( (!pgresult) || (PQresultStatus(pgresult) != PGRES_TUPLES_OK) ) {
-    msDebug("Error executing SQL: (%s) in msPostGISLayerGetExtent()", PQerrorMessage(layerinfo->pgconn));
-    msSetError(MS_MISCERR, "Error executing SQL. Check server logs.","msPostGISLayerGetExtent()");
+  if ((!pgresult) || (PQresultStatus(pgresult) != PGRES_TUPLES_OK)) {
+    msDebug("Error executing SQL: (%s) in msPostGISLayerGetExtent()",
+            PQerrorMessage(layerinfo->pgconn));
+    msSetError(MS_MISCERR, "Error executing SQL. Check server logs.",
+               "msPostGISLayerGetExtent()");
     if (pgresult)
       PQclear(pgresult);
 
@@ -3191,22 +3266,23 @@ static int msPostGISLayerGetExtent(layer
 
   /* process results */
   if (PQntuples(pgresult) < 1) {
-    msSetError(MS_MISCERR, "msPostGISLayerGetExtent: No results found.", 
-        "msPostGISLayerGetExtent()");
+    msSetError(MS_MISCERR, "msPostGISLayerGetExtent: No results found.",
+               "msPostGISLayerGetExtent()");
     PQclear(pgresult);
     return MS_FAILURE;
   }
-  
+
   if (PQgetisnull(pgresult, 0, 0)) {
-    msSetError(MS_MISCERR, "msPostGISLayerGetExtent: Null result returned.", 
-        "msPostGISLayerGetExtent()");
+    msSetError(MS_MISCERR, "msPostGISLayerGetExtent: Null result returned.",
+               "msPostGISLayerGetExtent()");
     PQclear(pgresult);
     return MS_FAILURE;
   }
 
-  if (sscanf(PQgetvalue(pgresult, 0, 0), "BOX(%lf %lf,%lf %lf)", 
-         &extent->minx, &extent->miny, &extent->maxx, &extent->maxy) != 4) {
-    msSetError(MS_MISCERR, "Failed to process result data.", "msPostGISLayerGetExtent()");
+  if (sscanf(PQgetvalue(pgresult, 0, 0), "BOX(%lf %lf,%lf %lf)", &extent->minx,
+             &extent->miny, &extent->maxx, &extent->maxy) != 4) {
+    msSetError(MS_MISCERR, "Failed to process result data.",
+               "msPostGISLayerGetExtent()");
     PQclear(pgresult);
     return MS_FAILURE;
   }
@@ -3216,7 +3292,8 @@ static int msPostGISLayerGetExtent(layer
 
   return MS_SUCCESS;
 #else
-  msSetError( MS_MISCERR, "PostGIS support is not available.", "msPostGISLayerGetExtent()");
+  msSetError(MS_MISCERR, "PostGIS support is not available.",
+             "msPostGISLayerGetExtent()");
   return MS_FAILURE;
 #endif
 }
@@ -3227,66 +3304,70 @@ static int msPostGISLayerGetExtent(layer
 ** Registered vtable->LayerGetNumFeatures function. Query the database for
 ** the feature count of the requested layer.
 */
-static int msPostGISLayerGetNumFeatures(layerObj *layer)
-{
+static int msPostGISLayerGetNumFeatures(layerObj *layer) {
 #ifdef USE_POSTGIS
-    if (layer->debug) {
-        msDebug("msPostGISLayerGetNumFeatures called.\n");
-    }
-
-    assert(layer->layerinfo != nullptr);
+  if (layer->debug) {
+    msDebug("msPostGISLayerGetNumFeatures called.\n");
+  }
 
-    if (msPostGISParseData(layer) != MS_SUCCESS) {
-        return -1;
-    }
+  assert(layer->layerinfo != nullptr);
 
-    auto layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
-    const std::string strSQL(addTableNameAndFilterToSelectFrom(
-        layer, "SELECT count(*) FROM "));
-    if (layer->debug) {
-        msDebug("msPostGISLayerGetNumFeatures executing SQL: %s\n", strSQL.c_str());
-    }
+  if (msPostGISParseData(layer) != MS_SUCCESS) {
+    return -1;
+  }
 
-    /* executing the query */
-    PGresult* pgresult = runPQexecParamsWithBindSubstitution(layer, strSQL.c_str(), 0);
+  auto layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
+  const std::string strSQL(
+      addTableNameAndFilterToSelectFrom(layer, "SELECT count(*) FROM "));
+  if (layer->debug) {
+    msDebug("msPostGISLayerGetNumFeatures executing SQL: %s\n", strSQL.c_str());
+  }
 
-    if ((!pgresult) || (PQresultStatus(pgresult) != PGRES_TUPLES_OK)) {
-        msDebug("Error executing SQL: (%s) in msPostGISLayerGetNumFeatures()", PQerrorMessage(layerinfo->pgconn));
-        msSetError(MS_MISCERR, "Error executing SQL. Check server logs.", "msPostGISLayerGetNumFeatures()");
-        if (pgresult)
-            PQclear(pgresult);
-
-        return -1;
-    }
+  /* executing the query */
+  PGresult *pgresult =
+      runPQexecParamsWithBindSubstitution(layer, strSQL.c_str(), 0);
 
-    /* process results */
-    if (PQntuples(pgresult) < 1) {
-        msSetError(MS_MISCERR, "msPostGISLayerGetNumFeatures: No results found.",
-            "msPostGISLayerGetNumFeatures()");
-        PQclear(pgresult);
-        return -1;
-    }
+  if ((!pgresult) || (PQresultStatus(pgresult) != PGRES_TUPLES_OK)) {
+    msDebug("Error executing SQL: (%s) in msPostGISLayerGetNumFeatures()",
+            PQerrorMessage(layerinfo->pgconn));
+    msSetError(MS_MISCERR, "Error executing SQL. Check server logs.",
+               "msPostGISLayerGetNumFeatures()");
+    if (pgresult)
+      PQclear(pgresult);
 
-    if (PQgetisnull(pgresult, 0, 0)) {
-        msSetError(MS_MISCERR, "msPostGISLayerGetNumFeatures: Null result returned.",
-            "msPostGISLayerGetNumFeatures()");
-        PQclear(pgresult);
-        return -1;
-    }
+    return -1;
+  }
 
-    const char* tmp = PQgetvalue(pgresult, 0, 0);
-    int result = 0;
-    if (tmp) {
-        result = strtol(tmp, nullptr, 10);
-    }
+  /* process results */
+  if (PQntuples(pgresult) < 1) {
+    msSetError(MS_MISCERR, "msPostGISLayerGetNumFeatures: No results found.",
+               "msPostGISLayerGetNumFeatures()");
+    PQclear(pgresult);
+    return -1;
+  }
 
-    /* cleanup */
+  if (PQgetisnull(pgresult, 0, 0)) {
+    msSetError(MS_MISCERR,
+               "msPostGISLayerGetNumFeatures: Null result returned.",
+               "msPostGISLayerGetNumFeatures()");
     PQclear(pgresult);
+    return -1;
+  }
 
-    return result;
+  const char *tmp = PQgetvalue(pgresult, 0, 0);
+  int result = 0;
+  if (tmp) {
+    result = strtol(tmp, nullptr, 10);
+  }
+
+  /* cleanup */
+  PQclear(pgresult);
+
+  return result;
 #else
-    msSetError(MS_MISCERR, "PostGIS support is not available.", "msPostGISLayerGetNumFeatures()");
-    return -1;
+  msSetError(MS_MISCERR, "PostGIS support is not available.",
+             "msPostGISLayerGetNumFeatures()");
+  return -1;
 #endif
 }
 
@@ -3299,74 +3380,73 @@ static int msPostGISLayerGetNumFeatures(
  * - if the resolluion is hour or minute (2004-01-01 15), a
  * complete time is 2004-01-01 15:00:00
  */
-static int postgresTimeStampForTimeString(const char *timestring, char *dest, size_t destsize)
-{
+static int postgresTimeStampForTimeString(const char *timestring, char *dest,
+                                          size_t destsize) {
   int nlength = strlen(timestring);
   int timeresolution = msTimeGetResolution(timestring);
   int bNoDate = (*timestring == 'T');
   if (timeresolution < 0)
     return MS_FALSE;
- 
-  switch(timeresolution) {
-    case TIME_RESOLUTION_YEAR:
-      if (timestring[nlength-1] != '-') {
-        snprintf(dest, destsize,"date '%s-01-01'",timestring);
-      } else {
-        snprintf(dest, destsize,"date '%s01-01'",timestring);
-      }
-      break;
-    case TIME_RESOLUTION_MONTH:
-      if (timestring[nlength-1] != '-') {
-        snprintf(dest, destsize,"date '%s-01'",timestring);
-      } else {
-        snprintf(dest, destsize,"date '%s01'",timestring);
-      }
-      break;
-    case TIME_RESOLUTION_DAY:
-      snprintf(dest, destsize,"date '%s'",timestring);
-      break;
-    case TIME_RESOLUTION_HOUR:
-      if (timestring[nlength-1] != ':') {
-        if(bNoDate)
-          snprintf(dest, destsize,"time '%s:00:00'", timestring);
-        else
-          snprintf(dest, destsize,"timestamp '%s:00:00'", timestring);
-      } else {
-        if(bNoDate)
-          snprintf(dest, destsize,"time '%s00:00'", timestring);
-        else
-          snprintf(dest, destsize,"timestamp '%s00:00'", timestring);
-      }
-      break;
-    case TIME_RESOLUTION_MINUTE:
-      if (timestring[nlength-1] != ':') {
-        if(bNoDate)
-          snprintf(dest, destsize,"time '%s:00'", timestring);
-        else
-          snprintf(dest, destsize,"timestamp '%s:00'", timestring);
-      } else {
-        if(bNoDate)
-          snprintf(dest, destsize,"time '%s00'", timestring);
-        else
-          snprintf(dest, destsize,"timestamp '%s00'", timestring);
-      }
-      break;
-    case TIME_RESOLUTION_SECOND:
-      if(bNoDate)
-         snprintf(dest, destsize,"time '%s'", timestring);
+
+  switch (timeresolution) {
+  case TIME_RESOLUTION_YEAR:
+    if (timestring[nlength - 1] != '-') {
+      snprintf(dest, destsize, "date '%s-01-01'", timestring);
+    } else {
+      snprintf(dest, destsize, "date '%s01-01'", timestring);
+    }
+    break;
+  case TIME_RESOLUTION_MONTH:
+    if (timestring[nlength - 1] != '-') {
+      snprintf(dest, destsize, "date '%s-01'", timestring);
+    } else {
+      snprintf(dest, destsize, "date '%s01'", timestring);
+    }
+    break;
+  case TIME_RESOLUTION_DAY:
+    snprintf(dest, destsize, "date '%s'", timestring);
+    break;
+  case TIME_RESOLUTION_HOUR:
+    if (timestring[nlength - 1] != ':') {
+      if (bNoDate)
+        snprintf(dest, destsize, "time '%s:00:00'", timestring);
       else
-         snprintf(dest, destsize,"timestamp '%s'", timestring);
-      break;
-    default:
-      return MS_FAILURE;
+        snprintf(dest, destsize, "timestamp '%s:00:00'", timestring);
+    } else {
+      if (bNoDate)
+        snprintf(dest, destsize, "time '%s00:00'", timestring);
+      else
+        snprintf(dest, destsize, "timestamp '%s00:00'", timestring);
+    }
+    break;
+  case TIME_RESOLUTION_MINUTE:
+    if (timestring[nlength - 1] != ':') {
+      if (bNoDate)
+        snprintf(dest, destsize, "time '%s:00'", timestring);
+      else
+        snprintf(dest, destsize, "timestamp '%s:00'", timestring);
+    } else {
+      if (bNoDate)
+        snprintf(dest, destsize, "time '%s00'", timestring);
+      else
+        snprintf(dest, destsize, "timestamp '%s00'", timestring);
+    }
+    break;
+  case TIME_RESOLUTION_SECOND:
+    if (bNoDate)
+      snprintf(dest, destsize, "time '%s'", timestring);
+    else
+      snprintf(dest, destsize, "timestamp '%s'", timestring);
+    break;
+  default:
+    return MS_FAILURE;
   }
   return MS_SUCCESS;
-
 }
 
 /*
- * create a postgresql where clause for the given timestring, taking into account
- * the resolution (e.g. second, day, month...) of the given timestring
+ * create a postgresql where clause for the given timestring, taking into
+ * account the resolution (e.g. second, day, month...) of the given timestring
  * we apply the date_trunc function on the given timestring and not on the time
  * column in order for postgres to take advantage of an eventual index on the
  * time column
@@ -3379,51 +3459,56 @@ static int postgresTimeStampForTimeStrin
  *    timecol < date_trunc(timestring,resolution) + interval '1 resolution'
  * )
  */
-static int createPostgresTimeCompareEquals(const char *timestring, char *dest, size_t destsize)
-{
+static int createPostgresTimeCompareEquals(const char *timestring, char *dest,
+                                           size_t destsize) {
   int timeresolution = msTimeGetResolution(timestring);
   char timeStamp[100];
   const char *interval;
-  if (timeresolution < 0) return MS_FALSE;
+  if (timeresolution < 0)
+    return MS_FALSE;
 
-  postgresTimeStampForTimeString(timestring,timeStamp,100);
+  postgresTimeStampForTimeString(timestring, timeStamp, 100);
 
-  switch(timeresolution) {
-    case TIME_RESOLUTION_YEAR:
-      interval = "year";
-      break;
-    case TIME_RESOLUTION_MONTH:
-      interval = "month";
-      break;
-    case TIME_RESOLUTION_DAY:
-      interval = "day";
-      break;
-    case TIME_RESOLUTION_HOUR:
-      interval = "hour";
-      break;
-    case TIME_RESOLUTION_MINUTE:
-      interval = "minute";
-      break;
-    case TIME_RESOLUTION_SECOND:
-      interval = "second";
-      break;
-    default:
-      return MS_FAILURE;
+  switch (timeresolution) {
+  case TIME_RESOLUTION_YEAR:
+    interval = "year";
+    break;
+  case TIME_RESOLUTION_MONTH:
+    interval = "month";
+    break;
+  case TIME_RESOLUTION_DAY:
+    interval = "day";
+    break;
+  case TIME_RESOLUTION_HOUR:
+    interval = "hour";
+    break;
+  case TIME_RESOLUTION_MINUTE:
+    interval = "minute";
+    break;
+  case TIME_RESOLUTION_SECOND:
+    interval = "second";
+    break;
+  default:
+    return MS_FAILURE;
   }
-  snprintf(dest, destsize, " between date_trunc('%s',%s) and date_trunc('%s',%s) + interval '1 %s' - interval '1 second'", interval, timeStamp, interval, timeStamp, interval);
+  snprintf(dest, destsize,
+           " between date_trunc('%s',%s) and date_trunc('%s',%s) + interval '1 "
+           "%s' - interval '1 second'",
+           interval, timeStamp, interval, timeStamp, interval);
   return MS_SUCCESS;
 }
 
-static int createPostgresTimeCompareGreaterThan(const char *timestring, char *dest, size_t destsize)
-{
+static int createPostgresTimeCompareGreaterThan(const char *timestring,
+                                                char *dest, size_t destsize) {
   int timeresolution = msTimeGetResolution(timestring);
   char timestamp[100];
   const char *interval;
-  if (timeresolution < 0) return MS_FALSE;
- 
-  postgresTimeStampForTimeString(timestring,timestamp,100);
+  if (timeresolution < 0)
+    return MS_FALSE;
+
+  postgresTimeStampForTimeString(timestring, timestamp, 100);
 
-  switch(timeresolution) {
+  switch (timeresolution) {
   case TIME_RESOLUTION_YEAR:
     interval = "year";
     break;
@@ -3446,79 +3531,82 @@ static int createPostgresTimeCompareGrea
     return MS_FAILURE;
   }
 
-  snprintf(dest, destsize,"date_trunc('%s',%s)", interval, timestamp);
+  snprintf(dest, destsize, "date_trunc('%s',%s)", interval, timestamp);
   return MS_SUCCESS;
 }
 
 /*
- * create a postgresql where clause for the range given by the two input timestring,
- * taking into account the resolution (e.g. second, day, month...) of each of the
- * given timestrings (both timestrings can have different resolutions, although I don't
- * know if that's a valid TIME range
- * we apply the date_trunc function on the given timestrings and not on the time
- * column in order for postgres to take advantage of an eventual index on the
- * time column
+ * create a postgresql where clause for the range given by the two input
+ * timestring, taking into account the resolution (e.g. second, day, month...)
+ * of each of the given timestrings (both timestrings can have different
+ * resolutions, although I don't know if that's a valid TIME range we apply the
+ * date_trunc function on the given timestrings and not on the time column in
+ * order for postgres to take advantage of an eventual index on the time column
  *
  * the generated sql is
  *
  * (
  *    timecol >= date_trunc(mintimestring,minresolution)
  *      and
- *    timecol < date_trunc(maxtimestring,maxresolution) + interval '1 maxresolution'
+ *    timecol < date_trunc(maxtimestring,maxresolution) + interval '1
+ * maxresolution'
  * )
  */
-static int createPostgresTimeCompareLessThan(const char *timestring, char *dest, size_t destsize)
-{
+static int createPostgresTimeCompareLessThan(const char *timestring, char *dest,
+                                             size_t destsize) {
   int timeresolution = msTimeGetResolution(timestring);
   char timestamp[100];
   const char *interval;
-  if (timeresolution < 0)return MS_FALSE;
+  if (timeresolution < 0)
+    return MS_FALSE;
 
-  postgresTimeStampForTimeString(timestring,timestamp,100);
+  postgresTimeStampForTimeString(timestring, timestamp, 100);
 
-  switch(timeresolution) {
-    case TIME_RESOLUTION_YEAR:
-      interval = "year";
-      break;
-    case TIME_RESOLUTION_MONTH:
-      interval = "month";
-      break;
-    case TIME_RESOLUTION_DAY:
-      interval = "day";
-      break;
-    case TIME_RESOLUTION_HOUR:
-      interval = "hour";
-      break;
-    case TIME_RESOLUTION_MINUTE:
-      interval = "minute";
-      break;
-    case TIME_RESOLUTION_SECOND:
-      interval = "second";
-      break;
-    default:
-      return MS_FAILURE;
+  switch (timeresolution) {
+  case TIME_RESOLUTION_YEAR:
+    interval = "year";
+    break;
+  case TIME_RESOLUTION_MONTH:
+    interval = "month";
+    break;
+  case TIME_RESOLUTION_DAY:
+    interval = "day";
+    break;
+  case TIME_RESOLUTION_HOUR:
+    interval = "hour";
+    break;
+  case TIME_RESOLUTION_MINUTE:
+    interval = "minute";
+    break;
+  case TIME_RESOLUTION_SECOND:
+    interval = "second";
+    break;
+  default:
+    return MS_FAILURE;
   }
-  snprintf(dest, destsize,"(date_trunc('%s',%s) + interval '1 %s' - interval '1 second')", interval, timestamp, interval);
+  snprintf(dest, destsize,
+           "(date_trunc('%s',%s) + interval '1 %s' - interval '1 second')",
+           interval, timestamp, interval);
   return MS_SUCCESS;
 }
 #endif
 
-static char *msPostGISEscapeSQLParam(layerObj *layer, const char *pszString)
-{
+static char *msPostGISEscapeSQLParam(layerObj *layer, const char *pszString) {
 #ifdef USE_POSTGIS
-  char* pszEscapedStr =nullptr;
+  char *pszEscapedStr = nullptr;
 
   if (layer && pszString) {
-    if(!msPostGISLayerIsOpen(layer))
+    if (!msPostGISLayerIsOpen(layer))
       msPostGISLayerOpen(layer);
 
     assert(layer->layerinfo != nullptr);
 
-    msPostGISLayerInfo* layerinfo = (msPostGISLayerInfo *) layer->layerinfo;
+    msPostGISLayerInfo *layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
     size_t nSrcLen = strlen(pszString);
-    pszEscapedStr = (char*) msSmallMalloc( 2 * nSrcLen + 1);
+    pszEscapedStr = (char *)msSmallMalloc(2 * nSrcLen + 1);
     int nError = 0;
-      PQescapeStringConn (layerinfo->pgconn, pszEscapedStr, pszString, nSrcLen, &nError);
+    PQescapeStringConn(layerinfo->pgconn, pszEscapedStr, pszString, nSrcLen,
+                       &nError);
     if (nError != 0) {
       free(pszEscapedStr);
       pszEscapedStr = nullptr;
@@ -3526,59 +3614,52 @@ static char *msPostGISEscapeSQLParam(lay
   }
   return pszEscapedStr;
 #else
-  msSetError( MS_MISCERR,
-              "PostGIS support is not available.",
-              "msPostGISEscapeSQLParam()");
+  msSetError(MS_MISCERR, "PostGIS support is not available.",
+             "msPostGISEscapeSQLParam()");
   return NULL;
 #endif
 }
 
-static void msPostGISEnablePaging(layerObj *layer, int value)
-{
+static void msPostGISEnablePaging(layerObj *layer, int value) {
 #ifdef USE_POSTGIS
   if (layer->debug) {
     msDebug("msPostGISEnablePaging called.\n");
   }
 
-  if(!msPostGISLayerIsOpen(layer))
-  {
-    if(msPostGISLayerOpen(layer) != MS_SUCCESS)
-    {
+  if (!msPostGISLayerIsOpen(layer)) {
+    if (msPostGISLayerOpen(layer) != MS_SUCCESS) {
       return;
     }
   }
 
-  assert( layer->layerinfo != nullptr);
+  assert(layer->layerinfo != nullptr);
 
-  msPostGISLayerInfo* layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
+  msPostGISLayerInfo *layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
   layerinfo->paging = value;
 
 #else
-  msSetError( MS_MISCERR,
-              "PostGIS support is not available.",
-              "msPostGISEnablePaging()");
+  msSetError(MS_MISCERR, "PostGIS support is not available.",
+             "msPostGISEnablePaging()");
 #endif
   return;
 }
 
-static int msPostGISGetPaging(layerObj *layer)
-{
+static int msPostGISGetPaging(layerObj *layer) {
 #ifdef USE_POSTGIS
   if (layer->debug) {
     msDebug("msPostGISGetPaging called.\n");
   }
 
-  if(!msPostGISLayerIsOpen(layer))
+  if (!msPostGISLayerIsOpen(layer))
     return MS_TRUE;
 
-  assert( layer->layerinfo != nullptr);
+  assert(layer->layerinfo != nullptr);
 
-  msPostGISLayerInfo* layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
+  msPostGISLayerInfo *layerinfo = (msPostGISLayerInfo *)layer->layerinfo;
   return layerinfo->paging;
 #else
-  msSetError( MS_MISCERR,
-              "PostGIS support is not available.",
-              "msPostGISEnablePaging()");
+  msSetError(MS_MISCERR, "PostGIS support is not available.",
+             "msPostGISEnablePaging()");
   return MS_FAILURE;
 #endif
 }
@@ -3588,8 +3669,8 @@ static int msPostGISGetPaging(layerObj *
 **
 ** Registered vtable->LayerTranslateFilter function.
 */
-static int msPostGISLayerTranslateFilter(layerObj *layer, expressionObj *filter, char *filteritem)
-{
+static int msPostGISLayerTranslateFilter(layerObj *layer, expressionObj *filter,
+                                         char *filteritem) {
 #ifdef USE_POSTGIS
   tokenListNodeObjPtr node = nullptr;
 
@@ -3598,19 +3679,23 @@ static int msPostGISLayerTranslateFilter
   int comparisonToken = -1;
   int bindingToken = -1;
 
-  msPostGISLayerInfo *layerinfo = static_cast<msPostGISLayerInfo*>(layer->layerinfo);
+  msPostGISLayerInfo *layerinfo =
+      static_cast<msPostGISLayerInfo *>(layer->layerinfo);
 
-  if(!filter->string) return MS_SUCCESS; /* not an error, just nothing to do */
+  if (!filter->string)
+    return MS_SUCCESS; /* not an error, just nothing to do */
 
-  // fprintf(stderr, "input: %s, %s, %d\n", filter->string, filteritem, filter->type);
+  // fprintf(stderr, "input: %s, %s, %d\n", filter->string, filteritem,
+  // filter->type);
 
   /*
   ** FILTERs use MapServer syntax *only* (#5001).
   */
-  if(filter->type == MS_STRING && filter->string && filteritem) { /* item/value pair - add escaping */
+  if (filter->type == MS_STRING && filter->string &&
+      filteritem) { /* item/value pair - add escaping */
 
-    char* stresc = msLayerEscapePropertyName(layer, filteritem);
-    if(filter->flags & MS_EXP_INSENSITIVE) {
+    char *stresc = msLayerEscapePropertyName(layer, filteritem);
+    if (filter->flags & MS_EXP_INSENSITIVE) {
       native_string += "upper(";
       native_string += stresc;
       native_string += "::text) = upper(";
@@ -3620,19 +3705,22 @@ static int msPostGISLayerTranslateFilter
     }
     msFree(stresc);
 
-    /* don't have a type for the righthand literal so assume it's a string and we quote */
+    /* don't have a type for the righthand literal so assume it's a string and
+     * we quote */
     stresc = msPostGISEscapeSQLParam(layer, filter->string);
     native_string += '\'';
     native_string += stresc;
     native_string += '\'';
     msFree(stresc);
 
-    if(filter->flags & MS_EXP_INSENSITIVE) native_string += ")";
-  } else if(filter->type == MS_REGEX && filter->string && filteritem) { /* item/regex pair  - add escaping */
+    if (filter->flags & MS_EXP_INSENSITIVE)
+      native_string += ")";
+  } else if (filter->type == MS_REGEX && filter->string &&
+             filteritem) { /* item/regex pair  - add escaping */
 
-    char* stresc = msLayerEscapePropertyName(layer, filteritem);
+    char *stresc = msLayerEscapePropertyName(layer, filteritem);
     native_string += stresc;
-    if(filter->flags & MS_EXP_INSENSITIVE) {
+    if (filter->flags & MS_EXP_INSENSITIVE) {
       native_string += "::text ~* ";
     } else {
       native_string += "::text ~ ";
@@ -3644,14 +3732,19 @@ static int msPostGISLayerTranslateFilter
     native_string += stresc;
     native_string += '\'';
     msFree(stresc);
-  } else if(filter->type == MS_EXPRESSION) {
+  } else if (filter->type == MS_EXPRESSION) {
     int ieq_expected = MS_FALSE;
 
-    if(msPostGISParseData(layer) != MS_SUCCESS) return MS_FAILURE;
+    if (msPostGISParseData(layer) != MS_SUCCESS)
+      return MS_FAILURE;
 
-    if(layer->debug >= 2) msDebug("msPostGISLayerTranslateFilter. String: %s.\n", filter->string);
-    if(!filter->tokens) return MS_SUCCESS;
-    if(layer->debug >= 2) msDebug("msPostGISLayerTranslateFilter. There are tokens to process... \n");
+    if (layer->debug >= 2)
+      msDebug("msPostGISLayerTranslateFilter. String: %s.\n", filter->string);
+    if (!filter->tokens)
+      return MS_SUCCESS;
+    if (layer->debug >= 2)
+      msDebug(
+          "msPostGISLayerTranslateFilter. There are tokens to process... \n");
 
     node = filter->tokens;
     while (node != nullptr) {
@@ -3659,221 +3752,225 @@ static int msPostGISLayerTranslateFilter
       /*
       ** Do any token caching/tracking here, easier to have it in one place.
       */
-      if(node->token == MS_TOKEN_BINDING_TIME) {
+      if (node->token == MS_TOKEN_BINDING_TIME) {
         bindingToken = node->token;
-      } else if(node->token == MS_TOKEN_COMPARISON_EQ ||
-         node->token == MS_TOKEN_COMPARISON_IEQ ||
-         node->token == MS_TOKEN_COMPARISON_NE ||
-         node->token == MS_TOKEN_COMPARISON_GT || node->token == MS_TOKEN_COMPARISON_GE ||
-         node->token == MS_TOKEN_COMPARISON_LT || node->token == MS_TOKEN_COMPARISON_LE ||
-         node->token == MS_TOKEN_COMPARISON_IN) {
+      } else if (node->token == MS_TOKEN_COMPARISON_EQ ||
+                 node->token == MS_TOKEN_COMPARISON_IEQ ||
+                 node->token == MS_TOKEN_COMPARISON_NE ||
+                 node->token == MS_TOKEN_COMPARISON_GT ||
+                 node->token == MS_TOKEN_COMPARISON_GE ||
+                 node->token == MS_TOKEN_COMPARISON_LT ||
+                 node->token == MS_TOKEN_COMPARISON_LE ||
+                 node->token == MS_TOKEN_COMPARISON_IN) {
         comparisonToken = node->token;
       }
 
-      switch(node->token) {
+      switch (node->token) {
 
-        /* literal tokens */
-        case MS_TOKEN_LITERAL_BOOLEAN:
-          if(node->tokenval.dblval == MS_TRUE)
-            native_string += "TRUE";
-          else
-            native_string += "FALSE";
-          break;
-        case MS_TOKEN_LITERAL_NUMBER:
-        {
-          if( node->tokenval.dblval >= INT_MIN &&
-              node->tokenval.dblval <= INT_MAX &&
-              node->tokenval.dblval == (int)node->tokenval.dblval )
-              native_string += std::to_string((int)node->tokenval.dblval);
-          else {
-              char buffer[32];
-              snprintf(buffer, sizeof(buffer), "%.18g", node->tokenval.dblval);
-              native_string += buffer;
-          }
-          break;
+      /* literal tokens */
+      case MS_TOKEN_LITERAL_BOOLEAN:
+        if (node->tokenval.dblval == MS_TRUE)
+          native_string += "TRUE";
+        else
+          native_string += "FALSE";
+        break;
+      case MS_TOKEN_LITERAL_NUMBER: {
+        if (node->tokenval.dblval >= INT_MIN &&
+            node->tokenval.dblval <= INT_MAX &&
+            node->tokenval.dblval == (int)node->tokenval.dblval)
+          native_string += std::to_string((int)node->tokenval.dblval);
+        else {
+          char buffer[32];
+          snprintf(buffer, sizeof(buffer), "%.18g", node->tokenval.dblval);
+          native_string += buffer;
         }
-        case MS_TOKEN_LITERAL_STRING:
-
-          if(comparisonToken == MS_TOKEN_COMPARISON_IN) { /* issue 5490 */
-            int nstrings=0;
-	    char** strings = msStringSplit(node->tokenval.strval, ',', &nstrings);
-            if(nstrings > 0) {
-	      native_string += "(";
-              for(int i=0; i<nstrings; i++) {
-                if(i != 0) native_string += ",";
-                char* stresc = msPostGISEscapeSQLParam(layer, strings[i]);
-                native_string += '\'';
-                native_string += stresc;
-                native_string += '\'';
-                msFree(stresc);
-              }
-              native_string += ")";
-            }
+        break;
+      }
+      case MS_TOKEN_LITERAL_STRING:
 
-            msFreeCharArray(strings, nstrings);
-          } else {
-            const char* strbegin;
-            const char* strend;
-            if(comparisonToken == MS_TOKEN_COMPARISON_IEQ) {
-                strbegin = "lower('";
-                strend = "')";
+        if (comparisonToken == MS_TOKEN_COMPARISON_IN) { /* issue 5490 */
+          int nstrings = 0;
+          char **strings = msStringSplit(node->tokenval.strval, ',', &nstrings);
+          if (nstrings > 0) {
+            native_string += "(";
+            for (int i = 0; i < nstrings; i++) {
+              if (i != 0)
+                native_string += ",";
+              char *stresc = msPostGISEscapeSQLParam(layer, strings[i]);
+              native_string += '\'';
+              native_string += stresc;
+              native_string += '\'';
+              msFree(stresc);
             }
-            else {
-                strbegin = "'";
-                strend = "'";
-            }
-            char* stresc = msPostGISEscapeSQLParam(layer, node->tokenval.strval);
-            native_string += strbegin;
-            native_string += stresc;
-            native_string += strend;
-            msFree(stresc);
+            native_string += ")";
           }
 
-          break;
-        case MS_TOKEN_LITERAL_TIME: {
-          char* snippet = (char *) msSmallMalloc(512);
-          if(comparisonToken == MS_TOKEN_COMPARISON_EQ) { // TODO: support !=
-            createPostgresTimeCompareEquals(node->tokensrc, snippet, 512);
-          } else if(comparisonToken == MS_TOKEN_COMPARISON_GT || comparisonToken == MS_TOKEN_COMPARISON_GE) {
-            createPostgresTimeCompareGreaterThan(node->tokensrc, snippet, 512);
-          } else if(comparisonToken == MS_TOKEN_COMPARISON_LT || comparisonToken == MS_TOKEN_COMPARISON_LE) {
-            createPostgresTimeCompareLessThan(node->tokensrc, snippet, 512);
+          msFreeCharArray(strings, nstrings);
+        } else {
+          const char *strbegin;
+          const char *strend;
+          if (comparisonToken == MS_TOKEN_COMPARISON_IEQ) {
+            strbegin = "lower('";
+            strend = "')";
           } else {
-            msFree(snippet);
-            goto cleanup;
-          }
-
-          comparisonToken = -1; bindingToken = -1; /* reset */
-          native_string += snippet;
-          msFree(snippet);
-          break;
-  	}
-        case MS_TOKEN_LITERAL_SHAPE:
-        {
-          char* wkt = msShapeToWKT(node->tokenval.shpval);
-          native_string += "ST_GeomFromText('";
-          native_string += wkt;
-          msFree(wkt);
-          native_string += "'";
-          if( !layerinfo->srid.empty() ) {
-            native_string += ",";
-            native_string += layerinfo->srid;
-          }
-          native_string += ")";
-          break;
-        }
-
-	/* data binding tokens */
-        case MS_TOKEN_BINDING_TIME:
-        case MS_TOKEN_BINDING_DOUBLE:
-        case MS_TOKEN_BINDING_INTEGER:
-        case MS_TOKEN_BINDING_STRING:
-        {
-          const char* strbegin = "";
-          const char* strend = "";
-          if (node->token == MS_TOKEN_BINDING_STRING && node->next->token == MS_TOKEN_COMPARISON_IEQ ) {
-            strbegin = "lower(";
-            strend = "::text)";
-            ieq_expected = MS_TRUE;
+            strbegin = "'";
+            strend = "'";
           }
-          else if(node->token == MS_TOKEN_BINDING_STRING || node->next->token == MS_TOKEN_COMPARISON_RE || node->next->token == MS_TOKEN_COMPARISON_IRE)
-            strend = "::text"; /* explicit cast necessary for certain operators */
-
-          char* stresc = msLayerEscapePropertyName(layer, node->tokenval.bindval.item);
+          char *stresc = msPostGISEscapeSQLParam(layer, node->tokenval.strval);
           native_string += strbegin;
           native_string += stresc;
           native_string += strend;
           msFree(stresc);
-          break;
-        }
-        case MS_TOKEN_BINDING_SHAPE:
-          native_string += layerinfo->geomcolumn;
-          break;
-        case MS_TOKEN_BINDING_MAP_CELLSIZE:
-        {
-          char buffer[32];
-          snprintf(buffer, sizeof(buffer), "%.18g", layer->map->cellsize);
-          native_string += buffer;
-	  break;
         }
 
-	/* spatial comparison tokens */
-        case MS_TOKEN_COMPARISON_INTERSECTS:
-        case MS_TOKEN_COMPARISON_DISJOINT:
-        case MS_TOKEN_COMPARISON_TOUCHES:
-        case MS_TOKEN_COMPARISON_OVERLAPS:
-        case MS_TOKEN_COMPARISON_CROSSES:
-        case MS_TOKEN_COMPARISON_WITHIN:
-        case MS_TOKEN_COMPARISON_CONTAINS:
-        case MS_TOKEN_COMPARISON_EQUALS:
-        case MS_TOKEN_COMPARISON_DWITHIN:
-        {
-          if(node->next->token != '(') goto cleanup;
-          native_string += "st_";
-          const char* str = msExpressionTokenToString(node->token);
-          if( str == nullptr )
-              goto cleanup;
-          native_string += str;
-          break;
+        break;
+      case MS_TOKEN_LITERAL_TIME: {
+        char *snippet = (char *)msSmallMalloc(512);
+        if (comparisonToken == MS_TOKEN_COMPARISON_EQ) { // TODO: support !=
+          createPostgresTimeCompareEquals(node->tokensrc, snippet, 512);
+        } else if (comparisonToken == MS_TOKEN_COMPARISON_GT ||
+                   comparisonToken == MS_TOKEN_COMPARISON_GE) {
+          createPostgresTimeCompareGreaterThan(node->tokensrc, snippet, 512);
+        } else if (comparisonToken == MS_TOKEN_COMPARISON_LT ||
+                   comparisonToken == MS_TOKEN_COMPARISON_LE) {
+          createPostgresTimeCompareLessThan(node->tokensrc, snippet, 512);
+        } else {
+          msFree(snippet);
+          goto cleanup;
         }
 
-	/* functions */
-        case MS_TOKEN_FUNCTION_LENGTH:
-        case MS_TOKEN_FUNCTION_AREA:
-        case MS_TOKEN_FUNCTION_BUFFER:
-        case MS_TOKEN_FUNCTION_DIFFERENCE:
-        {
-          native_string += "st_";
-          const char* str = msExpressionTokenToString(node->token);
-          if( str == nullptr )
-              goto cleanup;
-          native_string += str;
-          break;
+        comparisonToken = -1;
+        bindingToken = -1; /* reset */
+        native_string += snippet;
+        msFree(snippet);
+        break;
+      }
+      case MS_TOKEN_LITERAL_SHAPE: {
+        char *wkt = msShapeToWKT(node->tokenval.shpval);
+        native_string += "ST_GeomFromText('";
+        native_string += wkt;
+        msFree(wkt);
+        native_string += "'";
+        if (!layerinfo->srid.empty()) {
+          native_string += ",";
+          native_string += layerinfo->srid;
         }
+        native_string += ")";
+        break;
+      }
 
-	case MS_TOKEN_COMPARISON_IEQ:
-            if( ieq_expected )
-            {
-                native_string += "=";
-                ieq_expected = MS_FALSE;
-            }
-            else
-            {
-                goto cleanup;
-            }
-            break;
+        /* data binding tokens */
+      case MS_TOKEN_BINDING_TIME:
+      case MS_TOKEN_BINDING_DOUBLE:
+      case MS_TOKEN_BINDING_INTEGER:
+      case MS_TOKEN_BINDING_STRING: {
+        const char *strbegin = "";
+        const char *strend = "";
+        if (node->token == MS_TOKEN_BINDING_STRING &&
+            node->next->token == MS_TOKEN_COMPARISON_IEQ) {
+          strbegin = "lower(";
+          strend = "::text)";
+          ieq_expected = MS_TRUE;
+        } else if (node->token == MS_TOKEN_BINDING_STRING ||
+                   node->next->token == MS_TOKEN_COMPARISON_RE ||
+                   node->next->token == MS_TOKEN_COMPARISON_IRE)
+          strend = "::text"; /* explicit cast necessary for certain operators */
+
+        char *stresc =
+            msLayerEscapePropertyName(layer, node->tokenval.bindval.item);
+        native_string += strbegin;
+        native_string += stresc;
+        native_string += strend;
+        msFree(stresc);
+        break;
+      }
+      case MS_TOKEN_BINDING_SHAPE:
+        native_string += layerinfo->geomcolumn;
+        break;
+      case MS_TOKEN_BINDING_MAP_CELLSIZE: {
+        char buffer[32];
+        snprintf(buffer, sizeof(buffer), "%.18g", layer->map->cellsize);
+        native_string += buffer;
+        break;
+      }
+
+        /* spatial comparison tokens */
+      case MS_TOKEN_COMPARISON_INTERSECTS:
+      case MS_TOKEN_COMPARISON_DISJOINT:
+      case MS_TOKEN_COMPARISON_TOUCHES:
+      case MS_TOKEN_COMPARISON_OVERLAPS:
+      case MS_TOKEN_COMPARISON_CROSSES:
+      case MS_TOKEN_COMPARISON_WITHIN:
+      case MS_TOKEN_COMPARISON_CONTAINS:
+      case MS_TOKEN_COMPARISON_EQUALS:
+      case MS_TOKEN_COMPARISON_DWITHIN: {
+        if (node->next->token != '(')
+          goto cleanup;
+        native_string += "st_";
+        const char *str = msExpressionTokenToString(node->token);
+        if (str == nullptr)
+          goto cleanup;
+        native_string += str;
+        break;
+      }
 
-	/* unsupported tokens */
-        case MS_TOKEN_COMPARISON_BEYOND:
-	case MS_TOKEN_FUNCTION_TOSTRING:
-	case MS_TOKEN_FUNCTION_ROUND:
-	case MS_TOKEN_FUNCTION_SIMPLIFY:
-        case MS_TOKEN_FUNCTION_SIMPLIFYPT:        
-        case MS_TOKEN_FUNCTION_GENERALIZE:
+        /* functions */
+      case MS_TOKEN_FUNCTION_LENGTH:
+      case MS_TOKEN_FUNCTION_AREA:
+      case MS_TOKEN_FUNCTION_BUFFER:
+      case MS_TOKEN_FUNCTION_DIFFERENCE: {
+        native_string += "st_";
+        const char *str = msExpressionTokenToString(node->token);
+        if (str == nullptr)
           goto cleanup;
-          break;
+        native_string += str;
+        break;
+      }
 
-        default:
-        {
-          /* by default accept the general token to string conversion */
-
-          if(node->token == MS_TOKEN_COMPARISON_EQ && node->next != nullptr && node->next->token == MS_TOKEN_LITERAL_TIME) break; /* skip, handled with the next token */
-          if(bindingToken == MS_TOKEN_BINDING_TIME && (node->token == MS_TOKEN_COMPARISON_EQ || node->token == MS_TOKEN_COMPARISON_NE)) break; /* skip, handled elsewhere */
-          if(node->token == MS_TOKEN_COMPARISON_EQ && node->next != nullptr && node->next->token == MS_TOKEN_LITERAL_STRING &&
-             strcmp(node->next->tokenval.strval, "_MAPSERVER_NULL_") == 0 )
-          {
-              native_string += " IS NULL";
-              node = node->next;
-              break;
-          }
+      case MS_TOKEN_COMPARISON_IEQ:
+        if (ieq_expected) {
+          native_string += "=";
+          ieq_expected = MS_FALSE;
+        } else {
+          goto cleanup;
+        }
+        break;
 
-          const char* str = msExpressionTokenToString(node->token);
-          if( str == nullptr )
-              goto cleanup;
-          native_string += str;
+        /* unsupported tokens */
+      case MS_TOKEN_COMPARISON_BEYOND:
+      case MS_TOKEN_FUNCTION_TOSTRING:
+      case MS_TOKEN_FUNCTION_ROUND:
+      case MS_TOKEN_FUNCTION_SIMPLIFY:
+      case MS_TOKEN_FUNCTION_SIMPLIFYPT:
+      case MS_TOKEN_FUNCTION_GENERALIZE:
+        goto cleanup;
+        break;
+
+      default: {
+        /* by default accept the general token to string conversion */
+
+        if (node->token == MS_TOKEN_COMPARISON_EQ && node->next != nullptr &&
+            node->next->token == MS_TOKEN_LITERAL_TIME)
+          break; /* skip, handled with the next token */
+        if (bindingToken == MS_TOKEN_BINDING_TIME &&
+            (node->token == MS_TOKEN_COMPARISON_EQ ||
+             node->token == MS_TOKEN_COMPARISON_NE))
+          break; /* skip, handled elsewhere */
+        if (node->token == MS_TOKEN_COMPARISON_EQ && node->next != nullptr &&
+            node->next->token == MS_TOKEN_LITERAL_STRING &&
+            strcmp(node->next->tokenval.strval, "_MAPSERVER_NULL_") == 0) {
+          native_string += " IS NULL";
+          node = node->next;
           break;
         }
-        }
+
+        const char *str = msExpressionTokenToString(node->token);
+        if (str == nullptr)
+          goto cleanup;
+        native_string += str;
+        break;
+      }
+      }
 
       node = node->next;
     }
@@ -3881,21 +3978,22 @@ static int msPostGISLayerTranslateFilter
 
   filter->native_string = msStrdup(native_string.c_str());
 
-  // fprintf(stderr, "output: %s\n", filter->native_string); 
+  // fprintf(stderr, "output: %s\n", filter->native_string);
 
   return MS_SUCCESS;
 
 cleanup:
-  msSetError(MS_MISCERR, "Translation to native SQL failed.", "msPostGISLayerTranslateFilter()");
+  msSetError(MS_MISCERR, "Translation to native SQL failed.",
+             "msPostGISLayerTranslateFilter()");
   return MS_FAILURE;
 #else
-  msSetError(MS_MISCERR, "PostGIS support is not available.", "msPostGISLayerTranslateFilter()");
+  msSetError(MS_MISCERR, "PostGIS support is not available.",
+             "msPostGISLayerTranslateFilter()");
   return MS_FAILURE;
 #endif
 }
 
-int msPostGISLayerInitializeVirtualTable(layerObj *layer)
-{
+int msPostGISLayerInitializeVirtualTable(layerObj *layer) {
   assert(layer != nullptr);
   assert(layer->vtable != nullptr);
 
diff -pruN 8.0.1-5/mappostgis.h 8.0.2-1/mappostgis.h
--- 8.0.1-5/mappostgis.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mappostgis.h	2024-06-11 20:41:34.000000000 +0000
@@ -54,30 +54,31 @@
 ** Specific information needed for managing this layer.
 */
 typedef struct {
-  std::string sql{};                 /* SQL query to send to database */
-  PGconn      *pgconn = nullptr;     /* Connection to database */
-  long        rownum = 0;            /* What row is the next to be read (for random access) */
-  PGresult    *pgresult = nullptr;   /* For fetching rows from the database */
-  std::string uid{};                 /* Name of user-specified unique identifier, if set */
-  std::string srid{};                /* Name of user-specified SRID: zero-length => calculate; non-zero => use this value! */
-  std::string geomcolumn{};          /* Specified geometry column, eg "THEGEOM from thetable" */
-  std::string fromsource{};          /* Specified record source, ed "thegeom from THETABLE" or "thegeom from (SELECT..) AS FOO" */
-  int         endian = 0;            /* Endianness of the mapserver host */
-  int         version = 0;           /* PostGIS version of the database */
-  int         paging = 0;            /* Driver handling of pagination, enabled by default */
-  int         force2d = 0;           /* Pass geometry through ST_Force2D */
-}
-msPostGISLayerInfo;
-
+  std::string sql{};        /* SQL query to send to database */
+  PGconn *pgconn = nullptr; /* Connection to database */
+  long rownum = 0; /* What row is the next to be read (for random access) */
+  PGresult *pgresult = nullptr; /* For fetching rows from the database */
+  std::string uid{};  /* Name of user-specified unique identifier, if set */
+  std::string srid{}; /* Name of user-specified SRID: zero-length => calculate;
+                         non-zero => use this value! */
+  std::string
+      geomcolumn{}; /* Specified geometry column, eg "THEGEOM from thetable" */
+  std::string fromsource{}; /* Specified record source, ed "thegeom from
+                               THETABLE" or "thegeom from (SELECT..) AS FOO" */
+  int endian = 0;           /* Endianness of the mapserver host */
+  int version = 0;          /* PostGIS version of the database */
+  int paging = 0;  /* Driver handling of pagination, enabled by default */
+  int force2d = 0; /* Pass geometry through ST_Force2D */
+} msPostGISLayerInfo;
 
 /*
 ** Utility structure for handling the WKB returned by the database while
 ** reading.
 */
 typedef struct {
-  char *wkb; /* Pointer to front of WKB */
-  char *ptr; /* Pointer to current write point */
-  size_t size; /* Size of allocated space */
+  char *wkb;          /* Pointer to front of WKB */
+  char *ptr;          /* Pointer to current write point */
+  size_t size;        /* Size of allocated space */
   const int *typemap; /* Look-up array to valid OGC types */
 } wkbObj;
 
@@ -85,18 +86,18 @@ typedef struct {
 ** All the WKB type numbers from the OGC
 */
 typedef enum {
-  WKB_POINT=1,
-  WKB_LINESTRING=2,
-  WKB_POLYGON=3,
-  WKB_MULTIPOINT=4,
-  WKB_MULTILINESTRING=5,
-  WKB_MULTIPOLYGON=6,
-  WKB_GEOMETRYCOLLECTION=7,
-  WKB_CIRCULARSTRING=8,
-  WKB_COMPOUNDCURVE=9,
-  WKB_CURVEPOLYGON=10,
-  WKB_MULTICURVE=11,
-  WKB_MULTISURFACE=12
+  WKB_POINT = 1,
+  WKB_LINESTRING = 2,
+  WKB_POLYGON = 3,
+  WKB_MULTIPOINT = 4,
+  WKB_MULTILINESTRING = 5,
+  WKB_MULTIPOLYGON = 6,
+  WKB_GEOMETRYCOLLECTION = 7,
+  WKB_CIRCULARSTRING = 8,
+  WKB_COMPOUNDCURVE = 9,
+  WKB_CURVEPOLYGON = 10,
+  WKB_MULTICURVE = 11,
+  WKB_MULTISURFACE = 12
 } wkb_typenum;
 
 /*
@@ -108,43 +109,42 @@ typedef enum {
 ** Map the WKB type numbers returned by PostGIS < 2.0 to the
 ** valid OGC numbers
 */
-static const int wkb_postgis15[WKB_TYPE_COUNT] = {
-  0,
-  WKB_POINT,
-  WKB_LINESTRING,
-  WKB_POLYGON,
-  WKB_MULTIPOINT,
-  WKB_MULTILINESTRING,
-  WKB_MULTIPOLYGON,
-  WKB_GEOMETRYCOLLECTION,
-  WKB_CIRCULARSTRING,
-  WKB_COMPOUNDCURVE,
-  0,0,0,
-  WKB_CURVEPOLYGON,
-  WKB_MULTICURVE,
-  WKB_MULTISURFACE
-};
+static const int wkb_postgis15[WKB_TYPE_COUNT] = {0,
+                                                  WKB_POINT,
+                                                  WKB_LINESTRING,
+                                                  WKB_POLYGON,
+                                                  WKB_MULTIPOINT,
+                                                  WKB_MULTILINESTRING,
+                                                  WKB_MULTIPOLYGON,
+                                                  WKB_GEOMETRYCOLLECTION,
+                                                  WKB_CIRCULARSTRING,
+                                                  WKB_COMPOUNDCURVE,
+                                                  0,
+                                                  0,
+                                                  0,
+                                                  WKB_CURVEPOLYGON,
+                                                  WKB_MULTICURVE,
+                                                  WKB_MULTISURFACE};
 
 /*
 ** Map the WKB type numbers returned by PostGIS >= 2.0 to the
 ** valid OGC numbers
 */
-static const int wkb_postgis20[WKB_TYPE_COUNT] = {
-  0,
-  WKB_POINT,
-  WKB_LINESTRING,
-  WKB_POLYGON,
-  WKB_MULTIPOINT,
-  WKB_MULTILINESTRING,
-  WKB_MULTIPOLYGON,
-  WKB_GEOMETRYCOLLECTION,
-  WKB_CIRCULARSTRING,
-  WKB_COMPOUNDCURVE,
-  WKB_CURVEPOLYGON,
-  WKB_MULTICURVE,
-  WKB_MULTISURFACE,
-  0,0,0
-};
+static const int wkb_postgis20[WKB_TYPE_COUNT] = {0,
+                                                  WKB_POINT,
+                                                  WKB_LINESTRING,
+                                                  WKB_POLYGON,
+                                                  WKB_MULTIPOINT,
+                                                  WKB_MULTILINESTRING,
+                                                  WKB_MULTIPOLYGON,
+                                                  WKB_GEOMETRYCOLLECTION,
+                                                  WKB_CIRCULARSTRING,
+                                                  WKB_COMPOUNDCURVE,
+                                                  WKB_CURVEPOLYGON,
+                                                  WKB_MULTICURVE,
+                                                  WKB_MULTISURFACE,
+                                                  0,
+                                                  0,
+                                                  0};
 
 #endif /* USE_POSTGIS */
-
diff -pruN 8.0.1-5/mappostgresql.c 8.0.2-1/mappostgresql.c
--- 8.0.1-5/mappostgresql.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mappostgresql.c	2024-06-11 20:41:34.000000000 +0000
@@ -27,7 +27,6 @@
  * DEALINGS IN THE SOFTWARE.
  ****************************************************************************/
 
-
 /* $Id$ */
 #include <assert.h>
 #include "mapserver.h"
@@ -50,17 +49,14 @@
 #include <string.h>
 #include <ctype.h> /* tolower() */
 
-
-
-
 typedef struct {
-  PGconn      *conn;          /* connection to db */
-  long        row_num;        /* what row is the NEXT to be read (for random access) */
-  PGresult    *query_result;  /* for fetching rows from the db */
-  int         from_index;
-  char        *to_column;
-  char        *from_value;
-  int         layer_debug;    /* there's no debug on the join, so use the layer */
+  PGconn *conn; /* connection to db */
+  long row_num; /* what row is the NEXT to be read (for random access) */
+  PGresult *query_result; /* for fetching rows from the db */
+  int from_index;
+  char *to_column;
+  char *from_value;
+  int layer_debug; /* there's no debug on the join, so use the layer */
 } msPOSTGRESQLJoinInfo;
 
 /************************************************************************/
@@ -72,19 +68,18 @@ typedef struct {
 /* pooled connections with joins.                                       */
 /************************************************************************/
 
-int msPOSTGRESQLJoinConnect(layerObj *layer, joinObj *join)
-{
+int msPOSTGRESQLJoinConnect(layerObj *layer, joinObj *join) {
   char *maskeddata, *temp, *sql, *column;
   char *conn_decrypted;
   int i, test;
   PGresult *query_result;
   msPOSTGRESQLJoinInfo *joininfo;
 
-  if(join->joininfo)
+  if (join->joininfo)
     return MS_SUCCESS;
 
   joininfo = (msPOSTGRESQLJoinInfo *)malloc(sizeof(msPOSTGRESQLJoinInfo));
-  if(!joininfo) {
+  if (!joininfo) {
     msSetError(MS_MEMERR, "Error allocating join info struct.",
                "msPOSTGRESQLJoinConnect()");
     return MS_FAILURE;
@@ -102,17 +97,17 @@ int msPOSTGRESQLJoinConnect(layerObj *la
    * We need three things at a minimum, the connection string, a table
    * name, and a column to join on.
    */
-  if(!join->connection) {
+  if (!join->connection) {
     msSetError(MS_QUERYERR, "No connection information provided.",
                "MSPOSTGRESQLJoinConnect()");
     return MS_FAILURE;
   }
-  if(!join->table) {
+  if (!join->table) {
     msSetError(MS_QUERYERR, "No join table name found.",
                "msPOSTGRESQLJoinConnect()");
     return MS_FAILURE;
   }
-  if(!joininfo->to_column) {
+  if (!joininfo->to_column) {
     msSetError(MS_QUERYERR, "No join to column name found.",
                "msPOSTGRESQLJoinConnect()");
     return MS_FAILURE;
@@ -124,11 +119,11 @@ int msPOSTGRESQLJoinConnect(layerObj *la
     joininfo->conn = PQconnectdb(conn_decrypted);
     free(conn_decrypted);
   }
-  if(!joininfo->conn || PQstatus(joininfo->conn) == CONNECTION_BAD) {
+  if (!joininfo->conn || PQstatus(joininfo->conn) == CONNECTION_BAD) {
     maskeddata = (char *)malloc(strlen(layer->connection) + 1);
     strcpy(maskeddata, join->connection);
     temp = strstr(maskeddata, "password=");
-    if(temp) {
+    if (temp) {
       temp = (char *)(temp + 9);
       while (*temp != '\0' && *temp != ' ') {
         *temp = '*';
@@ -136,11 +131,12 @@ int msPOSTGRESQLJoinConnect(layerObj *la
       }
     }
     msSetError(MS_QUERYERR,
-               "Unable to connect to PostgreSQL using the string %s.\n  Error reported: %s\n",
-               "msPOSTGRESQLJoinConnect()",
-               maskeddata, PQerrorMessage(joininfo->conn));
+               "Unable to connect to PostgreSQL using the string %s.\n  Error "
+               "reported: %s\n",
+               "msPOSTGRESQLJoinConnect()", maskeddata,
+               PQerrorMessage(joininfo->conn));
     free(maskeddata);
-    if(!joininfo->conn) {
+    if (!joininfo->conn) {
       free(joininfo->conn);
     }
     free(joininfo);
@@ -152,15 +148,15 @@ int msPOSTGRESQLJoinConnect(layerObj *la
   sql = (char *)malloc(36 + strlen(join->table) + 1);
   sprintf(sql, "SELECT * FROM %s WHERE false LIMIT 0", join->table);
 
-  if(joininfo->layer_debug) {
+  if (joininfo->layer_debug) {
     msDebug("msPOSTGRESQLJoinConnect(): executing %s.\n", sql);
   }
 
   query_result = PQexec(joininfo->conn, sql);
-  if(!query_result || PQresultStatus(query_result) != PGRES_TUPLES_OK) {
+  if (!query_result || PQresultStatus(query_result) != PGRES_TUPLES_OK) {
     msSetError(MS_QUERYERR, "Error determining join items: %s.",
                "msPOSTGRESQLJoinConnect()", PQerrorMessage(joininfo->conn));
-    if(query_result) {
+    if (query_result) {
       PQclear(query_result);
       query_result = NULL;
     }
@@ -173,9 +169,9 @@ int msPOSTGRESQLJoinConnect(layerObj *la
 
   /* We want the join-to column to be first in the list. */
   test = 1;
-  for(i = 0; i < join->numitems; i++) {
+  for (i = 0; i < join->numitems; i++) {
     column = PQfname(query_result, i);
-    if(strcmp(column, joininfo->to_column) != 0) {
+    if (strcmp(column, joininfo->to_column) != 0) {
       join->items[i + test] = (char *)malloc(strlen(column) + 1);
       strcpy(join->items[i + test], column);
     } else {
@@ -186,27 +182,28 @@ int msPOSTGRESQLJoinConnect(layerObj *la
   }
   PQclear(query_result);
   query_result = NULL;
-  if(test == 1) {
+  if (test == 1) {
     msSetError(MS_QUERYERR, "Unable to find join to column: %s",
                "msPOSTGRESQLJoinConnect()", joininfo->to_column);
     return MS_FAILURE;
   }
 
-  if(joininfo->layer_debug) {
-    for(i = 0; i < join->numitems; i++) {
-      msDebug("msPOSTGRESQLJoinConnect(): Column %d named %s\n", i, join->items[i]);
+  if (joininfo->layer_debug) {
+    for (i = 0; i < join->numitems; i++) {
+      msDebug("msPOSTGRESQLJoinConnect(): Column %d named %s\n", i,
+              join->items[i]);
     }
   }
 
   /* Determine the index of the join from column. */
-  for(i = 0; i < layer->numitems; i++) {
-    if(strcasecmp(layer->items[i], join->from) == 0) {
+  for (i = 0; i < layer->numitems; i++) {
+    if (strcasecmp(layer->items[i], join->from) == 0) {
       joininfo->from_index = i;
       break;
     }
   }
 
-  if(i == layer->numitems) {
+  if (i == layer->numitems) {
     msSetError(MS_JOINERR, "Item %s not found in layer %s.",
                "msPOSTGRESQLJoinConnect()", join->from, layer->name);
     return MS_FAILURE;
@@ -223,34 +220,37 @@ int msPOSTGRESQLJoinConnect(layerObj *la
 /* resources, and setting the next value to join to.                    */
 /************************************************************************/
 
-int msPOSTGRESQLJoinPrepare(joinObj *join, shapeObj *shape)
-{
+int msPOSTGRESQLJoinPrepare(joinObj *join, shapeObj *shape) {
 
   /* We need a connection, and a shape with values to join to. */
   msPOSTGRESQLJoinInfo *joininfo = join->joininfo;
-  if(!joininfo) {
-    msSetError(MS_JOINERR, "Join has not been connected.", "msPOSTGRESQLJoinPrepare()");
+  if (!joininfo) {
+    msSetError(MS_JOINERR, "Join has not been connected.",
+               "msPOSTGRESQLJoinPrepare()");
     return MS_FAILURE;
   }
 
-  if(!shape) {
-    msSetError(MS_JOINERR, "Null shape provided for join.", "msPOSTGRESQLJoinPrepare()");
+  if (!shape) {
+    msSetError(MS_JOINERR, "Null shape provided for join.",
+               "msPOSTGRESQLJoinPrepare()");
     return MS_FAILURE;
   }
 
-  if(!shape->values) {
-    msSetError(MS_JOINERR, "Shape has no attributes.  Kinda hard to join against.", "msPOSTGRESQLJoinPrepare()");
+  if (!shape->values) {
+    msSetError(MS_JOINERR,
+               "Shape has no attributes.  Kinda hard to join against.",
+               "msPOSTGRESQLJoinPrepare()");
     return MS_FAILURE;
   }
   joininfo->row_num = 0;
 
   /* Free the previous join value, if any. */
-  if(joininfo->from_value) {
+  if (joininfo->from_value) {
     free(joininfo->from_value);
   }
 
   /* Free the previous results, if any. */
-  if(joininfo->query_result) {
+  if (joininfo->query_result) {
     PQclear(joininfo->query_result);
     joininfo->query_result = NULL;
   }
@@ -258,7 +258,7 @@ int msPOSTGRESQLJoinPrepare(joinObj *joi
   /* Copy the next join value from the shape. */
   joininfo->from_value = msStrdup(shape->values[joininfo->from_index]);
 
-  if(joininfo->layer_debug) {
+  if (joininfo->layer_debug) {
     msDebug("msPOSTGRESQLJoinPrepare() preping for value %s.\n",
             joininfo->from_value);
   }
@@ -277,52 +277,50 @@ int msPOSTGRESQLJoinPrepare(joinObj *joi
 /* we store the next row number and query results in the joininfo and   */
 /* process the next tuple on each call.                                 */
 /************************************************************************/
-int msPOSTGRESQLJoinNext(joinObj *join)
-{
+int msPOSTGRESQLJoinNext(joinObj *join) {
   msPOSTGRESQLJoinInfo *joininfo = join->joininfo;
   int i, length, row_count;
   char *sql, *columns;
 
   /* We need a connection, and a join value. */
-  if(!joininfo || !joininfo->conn) {
+  if (!joininfo || !joininfo->conn) {
     msSetError(MS_JOINERR, "Join has not been connected.\n",
                "msPOSTGRESQLJoinNext()");
     return MS_FAILURE;
   }
 
-  if(!joininfo->from_value) {
+  if (!joininfo->from_value) {
     msSetError(MS_JOINERR, "Join has not been prepared.\n",
                "msPOSTGRESQLJoinNext()");
     return MS_FAILURE;
   }
 
   /* Free the previous results. */
-  if(join->values) {
+  if (join->values) {
     msFreeCharArray(join->values, join->numitems);
     join->values = NULL;
   }
 
   /* We only need to execute the query if no results exist. */
-  if(!joininfo->query_result) {
+  if (!joininfo->query_result) {
     /* Write the list of column names. */
     length = 0;
-    for(i = 0; i < join->numitems; i++) {
+    for (i = 0; i < join->numitems; i++) {
       length += 8 + strlen(join->items[i]) + 2;
     }
 
     columns = (char *)malloc(length);
-    if(!columns) {
-      msSetError(MS_MEMERR, "Failure to malloc.\n",
-                 "msPOSTGRESQLJoinNext()");
+    if (!columns) {
+      msSetError(MS_MEMERR, "Failure to malloc.\n", "msPOSTGRESQLJoinNext()");
       return MS_FAILURE;
     }
 
     strcpy(columns, "");
-    for(i = 0; i < join->numitems; i++) {
+    for (i = 0; i < join->numitems; i++) {
       strcat(columns, "\"");
       strcat(columns, join->items[i]);
       strcat(columns, "\"::text");
-      if(i != join->numitems - 1) {
+      if (i != join->numitems - 1) {
         strcat(columns, ", ");
       }
     }
@@ -330,13 +328,13 @@ int msPOSTGRESQLJoinNext(joinObj *join)
     /* Create the query string. */
     sql = (char *)malloc(26 + strlen(columns) + strlen(join->table) +
                          strlen(join->to) + strlen(joininfo->from_value));
-    if(!sql) {
-      msSetError(MS_MEMERR, "Failure to malloc.\n",
-                 "msPOSTGRESQLJoinNext()");
+    if (!sql) {
+      msSetError(MS_MEMERR, "Failure to malloc.\n", "msPOSTGRESQLJoinNext()");
       return MS_FAILURE;
     }
-    sprintf(sql, "SELECT %s FROM %s WHERE %s = '%s'", columns, join->table, join->to, joininfo->from_value);
-    if(joininfo->layer_debug) {
+    sprintf(sql, "SELECT %s FROM %s WHERE %s = '%s'", columns, join->table,
+            join->to, joininfo->from_value);
+    if (joininfo->layer_debug) {
       msDebug("msPOSTGRESQLJoinNext(): executing %s.\n", sql);
     }
 
@@ -344,12 +342,11 @@ int msPOSTGRESQLJoinNext(joinObj *join)
 
     joininfo->query_result = PQexec(joininfo->conn, sql);
 
-    if(!joininfo->query_result ||
+    if (!joininfo->query_result ||
         PQresultStatus(joininfo->query_result) != PGRES_TUPLES_OK) {
       msSetError(MS_QUERYERR, "Error executing queri %s: %s\n",
-                 "msPOSTGRESQLJoinNext()", sql,
-                 PQerrorMessage(joininfo->conn));
-      if(joininfo->query_result) {
+                 "msPOSTGRESQLJoinNext()", sql, PQerrorMessage(joininfo->conn));
+      if (joininfo->query_result) {
         PQclear(joininfo->query_result);
         joininfo->query_result = NULL;
       }
@@ -361,19 +358,18 @@ int msPOSTGRESQLJoinNext(joinObj *join)
   row_count = PQntuples(joininfo->query_result);
 
   /* see if we're done processing this set */
-  if(joininfo->row_num >= row_count) {
-    return(MS_DONE);
+  if (joininfo->row_num >= row_count) {
+    return (MS_DONE);
   }
-  if(joininfo->layer_debug) {
-    msDebug("msPOSTGRESQLJoinNext(): fetching row %ld.\n",
-            joininfo->row_num);
+  if (joininfo->layer_debug) {
+    msDebug("msPOSTGRESQLJoinNext(): fetching row %ld.\n", joininfo->row_num);
   }
 
   /* Copy the resulting values into the joinObj. */
   join->values = (char **)malloc(sizeof(char *) * join->numitems);
-  for(i = 0; i < join->numitems; i++) {
-    join->values[i] = msStrdup(PQgetvalue(
-                                 joininfo->query_result, joininfo->row_num, i));
+  for (i = 0; i < join->numitems; i++) {
+    join->values[i] =
+        msStrdup(PQgetvalue(joininfo->query_result, joininfo->row_num, i));
   }
 
   joininfo->row_num++;
@@ -387,22 +383,21 @@ int msPOSTGRESQLJoinNext(joinObj *join)
 /* Closes the connection and frees the resources used by the joininfo.  */
 /************************************************************************/
 
-int msPOSTGRESQLJoinClose(joinObj *join)
-{
+int msPOSTGRESQLJoinClose(joinObj *join) {
   msPOSTGRESQLJoinInfo *joininfo = join->joininfo;
 
-  if(!joininfo) {
+  if (!joininfo) {
     msDebug("msPOSTGRESQLJoinClose() already close or never opened.\n");
     return MS_SUCCESS;
   }
 
-  if(joininfo->query_result) {
+  if (joininfo->query_result) {
     msDebug("msPOSTGRESQLJoinClose(): clearing query_result.\n");
     PQclear(joininfo->query_result);
     joininfo->query_result = NULL;
   }
 
-  if(joininfo->conn) {
+  if (joininfo->conn) {
     msDebug("msPOSTGRESQLJoinClose(): closing connection.\n");
     PQfinish(joininfo->conn);
     joininfo->conn = NULL;
@@ -410,7 +405,7 @@ int msPOSTGRESQLJoinClose(joinObj *join)
 
   /* removed free(joininfo->to_column), see bug #2936 */
 
-  if(joininfo->from_value) {
+  if (joininfo->from_value) {
     free(joininfo->from_value);
   }
 
@@ -420,31 +415,28 @@ int msPOSTGRESQLJoinClose(joinObj *join)
   return MS_SUCCESS;
 }
 
-#else  /* not USE_POSTGIS */
-int msPOSTGRESQLJoinConnect(layerObj *layer, joinObj *join)
-{
-  msSetError(MS_QUERYERR, "PostgreSQL support not available.", "msPOSTGRESQLJoinConnect()");
+#else /* not USE_POSTGIS */
+int msPOSTGRESQLJoinConnect(layerObj *layer, joinObj *join) {
+  msSetError(MS_QUERYERR, "PostgreSQL support not available.",
+             "msPOSTGRESQLJoinConnect()");
   return MS_FAILURE;
 }
 
-int msPOSTGRESQLJoinPrepare(joinObj *join, shapeObj *shape)
-{
-  msSetError(MS_QUERYERR, "PostgreSQL support not available.", "msPOSTGRESQLJoinPrepare()");
+int msPOSTGRESQLJoinPrepare(joinObj *join, shapeObj *shape) {
+  msSetError(MS_QUERYERR, "PostgreSQL support not available.",
+             "msPOSTGRESQLJoinPrepare()");
   return MS_FAILURE;
-
 }
 
-int msPOSTGRESQLJoinNext(joinObj *join)
-{
-  msSetError(MS_QUERYERR, "PostgreSQL support not available.", "msPOSTGRESQLJoinNext()");
+int msPOSTGRESQLJoinNext(joinObj *join) {
+  msSetError(MS_QUERYERR, "PostgreSQL support not available.",
+             "msPOSTGRESQLJoinNext()");
   return MS_FAILURE;
-
 }
 
-int msPOSTGRESQLJoinClose(joinObj *join)
-{
-  msSetError(MS_QUERYERR, "PostgreSQL support not available.", "msPOSTGRESQLJoinClose()");
+int msPOSTGRESQLJoinClose(joinObj *join) {
+  msSetError(MS_QUERYERR, "PostgreSQL support not available.",
+             "msPOSTGRESQLJoinClose()");
   return MS_FAILURE;
-
 }
 #endif
diff -pruN 8.0.1-5/mapprimitive.c 8.0.2-1/mapprimitive.c
--- 8.0.1-5/mapprimitive.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapprimitive.c	2024-06-11 20:41:34.000000000 +0000
@@ -32,34 +32,36 @@
 #include <locale.h>
 #include "fontcache.h"
 
+typedef enum { CLIP_LEFT, CLIP_MIDDLE, CLIP_RIGHT } CLIP_STATE;
 
-typedef enum {CLIP_LEFT, CLIP_MIDDLE, CLIP_RIGHT} CLIP_STATE;
-
-#define CLIP_CHECK(min, a, max) ((a) < (min) ? CLIP_LEFT : ((a) > (max) ? CLIP_RIGHT : CLIP_MIDDLE));
-#define ROUND(a)       ( (a) + 0.5 )
-#define SWAP( a, b, t) ( (t) = (a), (a) = (b), (b) = (t) )
-#define EDGE_CHECK( x0, x, x1) ((x) < MS_MIN( (x0), (x1)) ? CLIP_LEFT : ((x) > MS_MAX( (x0), (x1)) ? CLIP_RIGHT : CLIP_MIDDLE ))
+#define CLIP_CHECK(min, a, max)                                                \
+  ((a) < (min) ? CLIP_LEFT : ((a) > (max) ? CLIP_RIGHT : CLIP_MIDDLE));
+#define ROUND(a) ((a) + 0.5)
+#define SWAP(a, b, t) ((t) = (a), (a) = (b), (b) = (t))
+#define EDGE_CHECK(x0, x, x1)                                                  \
+  ((x) < MS_MIN((x0), (x1))                                                    \
+       ? CLIP_LEFT                                                             \
+       : ((x) > MS_MAX((x0), (x1)) ? CLIP_RIGHT : CLIP_MIDDLE))
 
 #ifndef INFINITY
 #define INFINITY (1.0e+30)
 #endif
 #define NEARZERO (1.0e-30) /* 1/INFINITY */
 
-void msPrintShape(shapeObj *p)
-{
-  int i,j;
+void msPrintShape(shapeObj *p) {
+  int i, j;
 
-  msDebug("Shape contains %d parts.\n",  p->numlines);
-  for (i=0; i<p->numlines; i++) {
+  msDebug("Shape contains %d parts.\n", p->numlines);
+  for (i = 0; i < p->numlines; i++) {
     msDebug("\tPart %d contains %d points.\n", i, p->line[i].numpoints);
-    for (j=0; j<p->line[i].numpoints; j++) {
-      msDebug("\t\t%d: (%f, %f)\n", j, p->line[i].point[j].x, p->line[i].point[j].y);
+    for (j = 0; j < p->line[i].numpoints; j++) {
+      msDebug("\t\t%d: (%f, %f)\n", j, p->line[i].point[j].x,
+              p->line[i].point[j].y);
     }
   }
 }
 
-shapeObj *msShapeFromWKT(const char *string)
-{
+shapeObj *msShapeFromWKT(const char *string) {
 #ifdef USE_GEOS
   return msGEOSShapeFromWKT(string);
 #else
@@ -67,11 +69,10 @@ shapeObj *msShapeFromWKT(const char *str
 #endif
 }
 
-char *msShapeToWKT(shapeObj *shape)
-{
+char *msShapeToWKT(shapeObj *shape) {
 #ifdef USE_GEOS
-  char* pszGEOSStr;
-  char* pszStr;
+  char *pszGEOSStr;
+  char *pszStr;
   pszGEOSStr = msGEOSShapeToWKT(shape);
   pszStr = (pszGEOSStr) ? msStrdup(pszGEOSStr) : NULL;
   msGEOSFreeWKT(pszGEOSStr);
@@ -81,8 +82,7 @@ char *msShapeToWKT(shapeObj *shape)
 #endif
 }
 
-void msInitShape(shapeObj *shape)
-{
+void msInitShape(shapeObj *shape) {
   /* spatial component */
   shape->line = NULL;
   shape->numlines = 0;
@@ -107,13 +107,13 @@ void msInitShape(shapeObj *shape)
   shape->scratch = MS_FALSE; /* not a temporary/scratch shape */
 }
 
-int msCopyShape(const shapeObj *from, shapeObj *to)
-{
+int msCopyShape(const shapeObj *from, shapeObj *to) {
   int i;
 
-  if(!from || !to) return(-1);
+  if (!from || !to)
+    return (-1);
 
-  for(i=0; i<from->numlines; i++)
+  for (i = 0; i < from->numlines; i++)
     msAddLine(to, &(from->line[i])); /* copy each line */
 
   to->type = from->type;
@@ -123,17 +123,19 @@ int msCopyShape(const shapeObj *from, sh
   to->bounds.maxx = from->bounds.maxx;
   to->bounds.maxy = from->bounds.maxy;
 
-  if(from->text) to->text = msStrdup(from->text);
+  if (from->text)
+    to->text = msStrdup(from->text);
 
   to->classindex = from->classindex;
   to->index = from->index;
   to->tileindex = from->tileindex;
   to->resultindex = from->resultindex;
 
-  if(from->values) {
-    if (to->values) msFreeCharArray(to->values, to->numvalues);
-    to->values = (char **)msSmallMalloc(sizeof(char *)*from->numvalues);
-    for(i=0; i<from->numvalues; i++)
+  if (from->values) {
+    if (to->values)
+      msFreeCharArray(to->values, to->numvalues);
+    to->values = (char **)msSmallMalloc(sizeof(char *) * from->numvalues);
+    for (i = 0; i < from->numvalues; i++)
       to->values[i] = msStrdup(from->values[i]);
     to->numvalues = from->numvalues;
   }
@@ -141,21 +143,24 @@ int msCopyShape(const shapeObj *from, sh
   to->geometry = NULL; /* GEOS code will build automatically if necessary */
   to->scratch = from->scratch;
 
-  return(0);
+  return (0);
 }
 
-void msFreeShape(shapeObj *shape)
-{
+void msFreeShape(shapeObj *shape) {
   int c;
 
-  if(!shape) return; /* for safety */
+  if (!shape)
+    return; /* for safety */
 
-  for (c= 0; c < shape->numlines; c++)
+  for (c = 0; c < shape->numlines; c++)
     free(shape->line[c].point);
 
-  if (shape->line) free(shape->line);
-  if(shape->values) msFreeCharArray(shape->values, shape->numvalues);
-  if(shape->text) free(shape->text);
+  if (shape->line)
+    free(shape->line);
+  if (shape->values)
+    msFreeCharArray(shape->values, shape->numvalues);
+  if (shape->text)
+    free(shape->text);
 
 #ifdef USE_GEOS
   msGEOSFreeGeometry(shape);
@@ -164,150 +169,161 @@ void msFreeShape(shapeObj *shape)
   msInitShape(shape); /* now reset */
 }
 
-int msGetShapeRAMSize(shapeObj* shape)
-{
-    int i;
-    int size = 0;
-    size += sizeof(shapeObj);
-    size += shape->numlines * sizeof(lineObj);
-    for (i = 0; i < shape->numlines; i++)
-    {
-        size += shape->line[i].numpoints * sizeof(pointObj);
-    }
-    size += shape->numvalues * sizeof(char*);
-    for( i = 0; i < shape->numvalues; i++ )
-    {
-        if( shape->values[i] )
-            size += strlen( shape->values[i] ) + 1;
-    }
-    if( shape->text )
-        size += strlen( shape->text ) + 1;
-    return size;
+int msGetShapeRAMSize(shapeObj *shape) {
+  int i;
+  int size = 0;
+  size += sizeof(shapeObj);
+  size += shape->numlines * sizeof(lineObj);
+  for (i = 0; i < shape->numlines; i++) {
+    size += shape->line[i].numpoints * sizeof(pointObj);
+  }
+  size += shape->numvalues * sizeof(char *);
+  for (i = 0; i < shape->numvalues; i++) {
+    if (shape->values[i])
+      size += strlen(shape->values[i]) + 1;
+  }
+  if (shape->text)
+    size += strlen(shape->text) + 1;
+  return size;
 }
 
-void msFreeLabelPathObj(labelPathObj *path)
-{
+void msFreeLabelPathObj(labelPathObj *path) {
   msFreeShape(&(path->bounds));
   msFree(path->path.point);
   msFree(path->angles);
   msFree(path);
 }
 
-void msShapeDeleteLine( shapeObj *shape, int line )
-{
-  if( line < 0 || line >= shape->numlines ) {
-    assert( 0 );
+void msShapeDeleteLine(shapeObj *shape, int line) {
+  if (line < 0 || line >= shape->numlines) {
+    assert(0);
     return;
   }
 
-  free( shape->line[line].point );
-  if( line < shape->numlines - 1 ) {
-    memmove( shape->line + line,
-             shape->line + line + 1,
-             sizeof(lineObj) * (shape->numlines - line - 1) );
+  free(shape->line[line].point);
+  if (line < shape->numlines - 1) {
+    memmove(shape->line + line, shape->line + line + 1,
+            sizeof(lineObj) * (shape->numlines - line - 1));
   }
   shape->numlines--;
 }
 
-void msComputeBounds(shapeObj *shape)
-{
+void msComputeBounds(shapeObj *shape) {
   int i, j;
-  if(shape->numlines <= 0) return;
-  for(i=0; i<shape->numlines; i++) {
-    if(shape->line[i].numpoints > 0) {
+  if (shape->numlines <= 0)
+    return;
+  for (i = 0; i < shape->numlines; i++) {
+    if (shape->line[i].numpoints > 0) {
       shape->bounds.minx = shape->bounds.maxx = shape->line[i].point[0].x;
       shape->bounds.miny = shape->bounds.maxy = shape->line[i].point[0].y;
       break;
     }
   }
-  if(i == shape->numlines) return;
+  if (i == shape->numlines)
+    return;
 
-  for( i=0; i<shape->numlines; i++ ) {
-    for( j=0; j<shape->line[i].numpoints; j++ ) {
-      shape->bounds.minx = MS_MIN(shape->bounds.minx, shape->line[i].point[j].x);
-      shape->bounds.maxx = MS_MAX(shape->bounds.maxx, shape->line[i].point[j].x);
-      shape->bounds.miny = MS_MIN(shape->bounds.miny, shape->line[i].point[j].y);
-      shape->bounds.maxy = MS_MAX(shape->bounds.maxy, shape->line[i].point[j].y);
+  for (i = 0; i < shape->numlines; i++) {
+    for (j = 0; j < shape->line[i].numpoints; j++) {
+      shape->bounds.minx =
+          MS_MIN(shape->bounds.minx, shape->line[i].point[j].x);
+      shape->bounds.maxx =
+          MS_MAX(shape->bounds.maxx, shape->line[i].point[j].x);
+      shape->bounds.miny =
+          MS_MIN(shape->bounds.miny, shape->line[i].point[j].y);
+      shape->bounds.maxy =
+          MS_MAX(shape->bounds.maxy, shape->line[i].point[j].y);
     }
   }
 }
 
 /* checks to see if ring r is an outer ring of shape */
-int msIsOuterRing(shapeObj *shape, int r)
-{
-  int i, status=MS_TRUE;
+int msIsOuterRing(shapeObj *shape, int r) {
+  int i, status = MS_TRUE;
   int result1, result2;
 
-  if(!shape) return MS_FALSE ;
-  if(shape->numlines == 1) return MS_TRUE;
-  if(r < 0 || r >= shape->numlines) return MS_FALSE; /* bad ring index */
+  if (!shape)
+    return MS_FALSE;
+  if (shape->numlines == 1)
+    return MS_TRUE;
+  if (r < 0 || r >= shape->numlines)
+    return MS_FALSE; /* bad ring index */
 
-  for(i=0; i<shape->numlines; i++) {
-    if(i == r) continue;
+  for (i = 0; i < shape->numlines; i++) {
+    if (i == r)
+      continue;
 
     /*
-    ** We have to test 2, or perhaps 3 points on the shape against the ring because
-    ** it is possible that at most one point could touch the ring and the function
+    ** We have to test 2, or perhaps 3 points on the shape against the ring
+    *because
+    ** it is possible that at most one point could touch the ring and the
+    *function
     ** msPointInPolygon() is indeterminite in that case. (bug #2434)
     */
     result1 = msPointInPolygon(&(shape->line[r].point[0]), &(shape->line[i]));
     result2 = msPointInPolygon(&(shape->line[r].point[1]), &(shape->line[i]));
-    if(result1 == result2) { /* same result twice, neither point was on the edge */
-      if(result1 == MS_TRUE) status = !status;
-    } else { /* one of the first 2 points were on the edge of the ring, the next one isn't */
-      if(msPointInPolygon(&(shape->line[r].point[2]), &(shape->line[i])) == MS_TRUE)
+    if (result1 ==
+        result2) { /* same result twice, neither point was on the edge */
+      if (result1 == MS_TRUE)
+        status = !status;
+    } else { /* one of the first 2 points were on the edge of the ring, the next
+                one isn't */
+      if (msPointInPolygon(&(shape->line[r].point[2]), &(shape->line[i])) ==
+          MS_TRUE)
         status = !status;
     }
-
   }
 
-  return(status);
+  return (status);
 }
 
 /*
-** Returns a list of outer rings for shape (the list has one entry for each ring,
+** Returns a list of outer rings for shape (the list has one entry for each
+*ring,
 ** MS_TRUE for outer rings).
 */
-int *msGetOuterList(shapeObj *shape)
-{
+int *msGetOuterList(shapeObj *shape) {
   int i;
   int *list;
 
-  if(!shape) return NULL;
+  if (!shape)
+    return NULL;
 
-  list = (int *)malloc(sizeof(int)*shape->numlines);
-  MS_CHECK_ALLOC(list, sizeof(int)*shape->numlines, NULL);
+  list = (int *)malloc(sizeof(int) * shape->numlines);
+  MS_CHECK_ALLOC(list, sizeof(int) * shape->numlines, NULL);
 
-  for(i=0; i<shape->numlines; i++)
+  for (i = 0; i < shape->numlines; i++)
     list[i] = msIsOuterRing(shape, i);
 
   return list;
 }
 
 /*
-** Returns a list of inner rings for ring r in shape (given a list of outer rings).
+** Returns a list of inner rings for ring r in shape (given a list of outer
+*rings).
 */
-int *msGetInnerList(shapeObj *shape, int r, int *outerlist)
-{
+int *msGetInnerList(shapeObj *shape, int r, int *outerlist) {
   int i;
   int *list;
 
-  if(!shape || !outerlist) return NULL;
-  if(r < 0 || r >= shape->numlines) return NULL; /* bad ring index */
+  if (!shape || !outerlist)
+    return NULL;
+  if (r < 0 || r >= shape->numlines)
+    return NULL; /* bad ring index */
 
-  list = (int *)malloc(sizeof(int)*shape->numlines);
-  MS_CHECK_ALLOC(list, sizeof(int)*shape->numlines, NULL);
+  list = (int *)malloc(sizeof(int) * shape->numlines);
+  MS_CHECK_ALLOC(list, sizeof(int) * shape->numlines, NULL);
 
-  for(i=0; i<shape->numlines; i++) { /* test all rings against the ring */
+  for (i = 0; i < shape->numlines; i++) { /* test all rings against the ring */
 
-    if(outerlist[i] == MS_TRUE) { /* ring is an outer and can't be an inner */
+    if (outerlist[i] == MS_TRUE) { /* ring is an outer and can't be an inner */
       list[i] = MS_FALSE;
       continue;
     }
 
     /* A valid inner ring may touch its outer ring at most one point. */
     /* In the case the first point matches a vertex of an outer ring, */
-    /* msPointInPolygon() might return 0 or 1 (depending on coordinate values, */
+    /* msPointInPolygon() might return 0 or 1 (depending on coordinate values,
+     */
     /* see msGetOuterList()), so test a second point if the first test */
     /* returned that the point is not inside the outer ring. */
     /* Fixes #5299 */
@@ -318,7 +334,7 @@ int *msGetInnerList(shapeObj *shape, int
               msPointInPolygon(&(shape->line[i].point[1]), &(shape->line[r]));
   }
 
-  return(list);
+  return (list);
 }
 
 /*
@@ -330,58 +346,58 @@ int *msGetInnerList(shapeObj *shape, int
 ** then call msAddLine() to add it to a shape.
 */
 
-int msAddPointToLine(lineObj *line, pointObj *point )
-{
+int msAddPointToLine(lineObj *line, pointObj *point) {
   line->numpoints += 1;
 
-  line->point = (pointObj *) msSmallRealloc(line->point, sizeof(pointObj) * line->numpoints);
-  line->point[line->numpoints-1] = *point;
+  line->point = (pointObj *)msSmallRealloc(line->point,
+                                           sizeof(pointObj) * line->numpoints);
+  line->point[line->numpoints - 1] = *point;
 
   return MS_SUCCESS;
 }
 
-int msAddLine(shapeObj *p, const lineObj *new_line)
-{
+int msAddLine(shapeObj *p, const lineObj *new_line) {
   lineObj lineCopy;
 
   lineCopy.numpoints = new_line->numpoints;
-  lineCopy.point = (pointObj *) malloc(new_line->numpoints*sizeof(pointObj));
-  MS_CHECK_ALLOC(lineCopy.point, new_line->numpoints*sizeof(pointObj), MS_FAILURE);
-
-  if( new_line->point )
-      memcpy( lineCopy.point, new_line->point, sizeof(pointObj) * new_line->numpoints );
+  lineCopy.point = (pointObj *)malloc(new_line->numpoints * sizeof(pointObj));
+  MS_CHECK_ALLOC(lineCopy.point, new_line->numpoints * sizeof(pointObj),
+                 MS_FAILURE);
+
+  if (new_line->point)
+    memcpy(lineCopy.point, new_line->point,
+           sizeof(pointObj) * new_line->numpoints);
 
   // cppcheck-suppress memleak
-  return msAddLineDirectly( p, &lineCopy );
+  return msAddLineDirectly(p, &lineCopy);
 }
 
 /*
 ** Same as msAddLine(), except that this version "seizes" the points
 ** array from the passed in line and uses it instead of copying it.
 */
-int msAddLineDirectly(shapeObj *p, lineObj *new_line)
-{
+int msAddLineDirectly(shapeObj *p, lineObj *new_line) {
   int c;
 
-  if( p->numlines == 0 ) {
-    p->line = (lineObj *) malloc(sizeof(lineObj));
+  if (p->numlines == 0) {
+    p->line = (lineObj *)malloc(sizeof(lineObj));
   } else {
-    lineObj* newline = (lineObj *) realloc(p->line, (p->numlines+1)*sizeof(lineObj));
-    if( !newline ) {
-        free(p->line);
+    lineObj *newline =
+        (lineObj *)realloc(p->line, (p->numlines + 1) * sizeof(lineObj));
+    if (!newline) {
+      free(p->line);
     }
     p->line = newline;
   }
-  if( !p->line )
-  {
-    free(new_line->point );
+  if (!p->line) {
+    free(new_line->point);
     new_line->point = NULL;
     new_line->numpoints = 0;
   }
-  MS_CHECK_ALLOC(p->line, (p->numlines+1)*sizeof(lineObj), MS_FAILURE);
+  MS_CHECK_ALLOC(p->line, (p->numlines + 1) * sizeof(lineObj), MS_FAILURE);
 
   /* Copy the new line onto the end of the extended line array */
-  c= p->numlines;
+  c = p->numlines;
   p->line[c].numpoints = new_line->numpoints;
   p->line[c].point = new_line->point;
 
@@ -392,22 +408,27 @@ int msAddLineDirectly(shapeObj *p, lineO
   /* Update the polygon information */
   p->numlines++;
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
 /*
-** Converts a rect array to a shapeObj structure. Note order is CW assuming y origin
-** is in the lower left corner (normal cartesian coordinate system). Also polygon is
-** is closed (i.e. first=last). This conforms to the shapefile specification. For image
-** coordinate systems (i.e. GD) this is back-ass-ward, which is fine cause the function
-** that calculates direction assumes min y = lower left, this way it'll still work. Drawing
-** functions are independent of direction. Orientation problems can cause some nasty bugs.
+** Converts a rect array to a shapeObj structure. Note order is CW assuming y
+*origin
+** is in the lower left corner (normal cartesian coordinate system). Also
+*polygon is
+** is closed (i.e. first=last). This conforms to the shapefile specification.
+*For image
+** coordinate systems (i.e. GD) this is back-ass-ward, which is fine cause the
+*function
+** that calculates direction assumes min y = lower left, this way it'll still
+*work. Drawing
+** functions are independent of direction. Orientation problems can cause some
+*nasty bugs.
 */
-void msRectToPolygon(rectObj rect, shapeObj *poly)
-{
-  lineObj line= {0,NULL};
+void msRectToPolygon(rectObj rect, shapeObj *poly) {
+  lineObj line = {0, NULL};
 
-  line.point = (pointObj *)msSmallMalloc(sizeof(pointObj)*5);
+  line.point = (pointObj *)msSmallMalloc(sizeof(pointObj) * 5);
 
   line.point[0].x = rect.minx;
   line.point[0].y = rect.miny;
@@ -423,7 +444,7 @@ void msRectToPolygon(rectObj rect, shape
   line.numpoints = 5;
 
   msAddLine(poly, &line);
-  if(poly->numlines == 1) { /* poly was empty to begin with */
+  if (poly->numlines == 1) { /* poly was empty to begin with */
     poly->type = MS_SHAPE_POLYGON;
     poly->bounds = rect;
   } else
@@ -436,23 +457,23 @@ void msRectToPolygon(rectObj rect, shape
 ** "Getting Graphic: Programming Fundamentals in C and C++" by Mark Finlay
 ** and John Petritis. (pages 179-182)
 */
-static int clipLine(double *x1, double *y1, double *x2, double *y2, rectObj rect)
-{
+static int clipLine(double *x1, double *y1, double *x2, double *y2,
+                    rectObj rect) {
   double x, y;
   double slope;
   CLIP_STATE check1, check2;
 
-  if(*x1 < rect.minx && *x2 < rect.minx)
-    return(MS_FALSE);
-  if(*x1 > rect.maxx && *x2 > rect.maxx)
-    return(MS_FALSE);
+  if (*x1 < rect.minx && *x2 < rect.minx)
+    return (MS_FALSE);
+  if (*x1 > rect.maxx && *x2 > rect.maxx)
+    return (MS_FALSE);
 
   check1 = CLIP_CHECK(rect.minx, *x1, rect.maxx);
   check2 = CLIP_CHECK(rect.minx, *x2, rect.maxx);
-  if(check1 == CLIP_LEFT || check2 == CLIP_LEFT) {
-    slope = (*y2 - *y1)/(*x2 - *x1);
-    y = *y1 + (rect.minx - *x1)*slope;
-    if(check1 == CLIP_LEFT) {
+  if (check1 == CLIP_LEFT || check2 == CLIP_LEFT) {
+    slope = (*y2 - *y1) / (*x2 - *x1);
+    y = *y1 + (rect.minx - *x1) * slope;
+    if (check1 == CLIP_LEFT) {
       *x1 = rect.minx;
       *y1 = y;
     } else {
@@ -460,10 +481,10 @@ static int clipLine(double *x1, double *
       *y2 = y;
     }
   }
-  if(check1 == CLIP_RIGHT || check2 == CLIP_RIGHT) {
-    slope = (*y2 - *y1)/(*x2 - *x1);
-    y = *y1 + (rect.maxx - *x1)*slope;
-    if(check1 == CLIP_RIGHT) {
+  if (check1 == CLIP_RIGHT || check2 == CLIP_RIGHT) {
+    slope = (*y2 - *y1) / (*x2 - *x1);
+    y = *y1 + (rect.maxx - *x1) * slope;
+    if (check1 == CLIP_RIGHT) {
       *x1 = rect.maxx;
       *y1 = y;
     } else {
@@ -472,17 +493,17 @@ static int clipLine(double *x1, double *
     }
   }
 
-  if(*y1 < rect.miny && *y2 < rect.miny)
-    return(MS_FALSE);
-  if(*y1 > rect.maxy && *y2 > rect.maxy)
-    return(MS_FALSE);
+  if (*y1 < rect.miny && *y2 < rect.miny)
+    return (MS_FALSE);
+  if (*y1 > rect.maxy && *y2 > rect.maxy)
+    return (MS_FALSE);
 
   check1 = CLIP_CHECK(rect.miny, *y1, rect.maxy);
   check2 = CLIP_CHECK(rect.miny, *y2, rect.maxy);
-  if(check1 == CLIP_LEFT || check2 == CLIP_LEFT) {
-    slope = (*x2 - *x1)/(*y2 - *y1);
-    x = *x1 + (rect.miny - *y1)*slope;
-    if(check1 == CLIP_LEFT) {
+  if (check1 == CLIP_LEFT || check2 == CLIP_LEFT) {
+    slope = (*x2 - *x1) / (*y2 - *y1);
+    x = *x1 + (rect.miny - *y1) * slope;
+    if (check1 == CLIP_LEFT) {
       *x1 = x;
       *y1 = rect.miny;
     } else {
@@ -490,10 +511,10 @@ static int clipLine(double *x1, double *
       *y2 = rect.miny;
     }
   }
-  if(check1 == CLIP_RIGHT || check2 == CLIP_RIGHT) {
-    slope = (*x2 - *x1)/(*y2 - *y1);
-    x = *x1 + (rect.maxy - *y1)*slope;
-    if(check1 == CLIP_RIGHT) {
+  if (check1 == CLIP_RIGHT || check2 == CLIP_RIGHT) {
+    slope = (*x2 - *x1) / (*y2 - *y1);
+    x = *x1 + (rect.maxy - *y1) * slope;
+    if (check1 == CLIP_RIGHT) {
       *x1 = x;
       *y1 = rect.maxy;
     } else {
@@ -502,24 +523,23 @@ static int clipLine(double *x1, double *
     }
   }
 
-  return(MS_TRUE);
+  return (MS_TRUE);
 }
 
 /*
 ** Routine for clipping a polyline, stored in a shapeObj struct, to a
 ** rectangle. Uses clipLine() function to create a new shapeObj.
 */
-void msClipPolylineRect(shapeObj *shape, rectObj rect)
-{
-  int i,j;
-  lineObj line= {0,NULL};
+void msClipPolylineRect(shapeObj *shape, rectObj rect) {
+  int i, j;
+  lineObj line = {0, NULL};
   double x1, x2, y1, y2;
   shapeObj tmp;
 
-  if(!shape || shape->numlines == 0) /* nothing to clip */
+  if (!shape || shape->numlines == 0) /* nothing to clip */
     return;
 
-  memset( &tmp, 0, sizeof(shapeObj) );
+  memset(&tmp, 0, sizeof(shapeObj));
 
   /*
   ** Don't do any clip processing of shapes completely within the
@@ -528,26 +548,25 @@ void msClipPolylineRect(shapeObj *shape,
   ** since the spatial query at the layer read level has generally already
   ** discarded all shapes completely outside the rect.
   */
-  if( shape->bounds.maxx <= rect.maxx
-      && shape->bounds.minx >= rect.minx
-      && shape->bounds.maxy <= rect.maxy
-      && shape->bounds.miny >= rect.miny ) {
+  if (shape->bounds.maxx <= rect.maxx && shape->bounds.minx >= rect.minx &&
+      shape->bounds.maxy <= rect.maxy && shape->bounds.miny >= rect.miny) {
     return;
   }
 
-  for(i=0; i<shape->numlines; i++) {
+  for (i = 0; i < shape->numlines; i++) {
 
-    line.point = (pointObj *)msSmallMalloc(sizeof(pointObj)*shape->line[i].numpoints);
+    line.point =
+        (pointObj *)msSmallMalloc(sizeof(pointObj) * shape->line[i].numpoints);
     line.numpoints = 0;
 
     x1 = shape->line[i].point[0].x;
     y1 = shape->line[i].point[0].y;
-    for(j=1; j<shape->line[i].numpoints; j++) {
+    for (j = 1; j < shape->line[i].numpoints; j++) {
       x2 = shape->line[i].point[j].x;
       y2 = shape->line[i].point[j].y;
 
-      if(clipLine(&x1,&y1,&x2,&y2,rect) == MS_TRUE) {
-        if(line.numpoints == 0) { /* first segment, add both points */
+      if (clipLine(&x1, &y1, &x2, &y2, rect) == MS_TRUE) {
+        if (line.numpoints == 0) { /* first segment, add both points */
           line.point[0].x = x1;
           line.point[0].y = y1;
           line.point[1].x = x2;
@@ -559,7 +578,8 @@ void msClipPolylineRect(shapeObj *shape,
           line.numpoints++;
         }
 
-        if((x2 != shape->line[i].point[j].x) || (y2 != shape->line[i].point[j].y)) {
+        if ((x2 != shape->line[i].point[j].x) ||
+            (y2 != shape->line[i].point[j].y)) {
           msAddLine(&tmp, &line);
           line.numpoints = 0; /* new line */
         }
@@ -569,7 +589,7 @@ void msClipPolylineRect(shapeObj *shape,
       y1 = shape->line[i].point[j].y;
     }
 
-    if(line.numpoints > 0) {
+    if (line.numpoints > 0) {
       msAddLineDirectly(&tmp, &line);
     } else {
       free(line.point);
@@ -577,7 +597,8 @@ void msClipPolylineRect(shapeObj *shape,
     }
   }
 
-  for (i=0; i<shape->numlines; i++) free(shape->line[i].point);
+  for (i = 0; i < shape->numlines; i++)
+    free(shape->line[i].point);
   free(shape->line);
 
   shape->line = tmp.line;
@@ -588,17 +609,16 @@ void msClipPolylineRect(shapeObj *shape,
 /*
 ** Slightly modified version of the Liang-Barsky polygon clipping algorithm
 */
-void msClipPolygonRect(shapeObj *shape, rectObj rect)
-{
+void msClipPolygonRect(shapeObj *shape, rectObj rect) {
   int i, j;
-  double deltax, deltay, xin,xout,  yin,yout;
-  double tinx,tiny,  toutx,touty,  tin1, tin2,  tout;
-  double x1,y1, x2,y2;
+  double deltax, deltay, xin, xout, yin, yout;
+  double tinx, tiny, toutx, touty, tin1, tin2, tout;
+  double x1, y1, x2, y2;
 
   shapeObj tmp;
-  lineObj line= {0,NULL};
+  lineObj line = {0, NULL};
 
-  if(!shape || shape->numlines == 0) /* nothing to clip */
+  if (!shape || shape->numlines == 0) /* nothing to clip */
     return;
 
   msInitShape(&tmp);
@@ -610,32 +630,33 @@ void msClipPolygonRect(shapeObj *shape,
   ** since the spatial query at the layer read level has generally already
   ** discarded all shapes completely outside the rect.
   */
-  if( shape->bounds.maxx <= rect.maxx
-      && shape->bounds.minx >= rect.minx
-      && shape->bounds.maxy <= rect.maxy
-      && shape->bounds.miny >= rect.miny ) {
+  if (shape->bounds.maxx <= rect.maxx && shape->bounds.minx >= rect.minx &&
+      shape->bounds.maxy <= rect.maxy && shape->bounds.miny >= rect.miny) {
     return;
   }
 
-  for(j=0; j<shape->numlines; j++) {
+  for (j = 0; j < shape->numlines; j++) {
 
-    line.point = (pointObj *)msSmallMalloc(sizeof(pointObj)*2*shape->line[j].numpoints+1); /* worst case scenario, +1 allows us to duplicate the 1st and last point */
+    line.point = (pointObj *)msSmallMalloc(
+        sizeof(pointObj) * 2 * shape->line[j].numpoints +
+        1); /* worst case scenario, +1 allows us to duplicate the 1st and last
+               point */
     line.numpoints = 0;
 
-    for (i = 0; i < shape->line[j].numpoints-1; i++) {
+    for (i = 0; i < shape->line[j].numpoints - 1; i++) {
 
       x1 = shape->line[j].point[i].x;
       y1 = shape->line[j].point[i].y;
-      x2 = shape->line[j].point[i+1].x;
-      y2 = shape->line[j].point[i+1].y;
+      x2 = shape->line[j].point[i + 1].x;
+      y2 = shape->line[j].point[i + 1].y;
 
-      deltax = x2-x1;
+      deltax = x2 - x1;
       if (deltax == 0) { /* bump off of the vertical */
-        deltax = (x1 > rect.minx) ? -NEARZERO : NEARZERO ;
+        deltax = (x1 > rect.minx) ? -NEARZERO : NEARZERO;
       }
-      deltay = y2-y1;
+      deltay = y2 - y1;
       if (deltay == 0) { /* bump off of the horizontal */
-        deltay = (y1 > rect.miny) ? -NEARZERO : NEARZERO ;
+        deltay = (y1 > rect.miny) ? -NEARZERO : NEARZERO;
       }
 
       if (deltax > 0) { /*  points to right */
@@ -653,13 +674,13 @@ void msClipPolygonRect(shapeObj *shape,
         yout = rect.miny;
       }
 
-      tinx = (xin - x1)/deltax;
-      tiny = (yin - y1)/deltay;
+      tinx = (xin - x1) / deltax;
+      tiny = (yin - y1) / deltay;
 
       if (tinx < tiny) { /* hits x first */
         tin1 = tinx;
         tin2 = tiny;
-      } else {            /* hits y first */
+      } else { /* hits y first */
         tin1 = tiny;
         tin2 = tinx;
       }
@@ -671,20 +692,20 @@ void msClipPolygonRect(shapeObj *shape,
           line.numpoints++;
         }
         if (1 >= tin2) {
-          toutx = (xout - x1)/deltax;
-          touty = (yout - y1)/deltay;
+          toutx = (xout - x1) / deltax;
+          touty = (yout - y1) / deltay;
 
-          tout = (toutx < touty) ? toutx : touty ;
+          tout = (toutx < touty) ? toutx : touty;
 
           if (0 < tin2 || 0 < tout) {
             if (tin2 <= tout) {
               if (0 < tin2) {
                 if (tinx > tiny) {
                   line.point[line.numpoints].x = xin;
-                  line.point[line.numpoints].y = y1 + tinx*deltay;
+                  line.point[line.numpoints].y = y1 + tinx * deltay;
                   line.numpoints++;
                 } else {
-                  line.point[line.numpoints].x = x1 + tiny*deltax;
+                  line.point[line.numpoints].x = x1 + tiny * deltax;
                   line.point[line.numpoints].y = yin;
                   line.numpoints++;
                 }
@@ -692,10 +713,10 @@ void msClipPolygonRect(shapeObj *shape,
               if (1 > tout) {
                 if (toutx < touty) {
                   line.point[line.numpoints].x = xout;
-                  line.point[line.numpoints].y = y1 + toutx*deltay;
+                  line.point[line.numpoints].y = y1 + toutx * deltay;
                   line.numpoints++;
                 } else {
-                  line.point[line.numpoints].x = x1 + touty*deltax;
+                  line.point[line.numpoints].x = x1 + touty * deltax;
                   line.point[line.numpoints].y = yout;
                   line.numpoints++;
                 }
@@ -720,7 +741,7 @@ void msClipPolygonRect(shapeObj *shape,
       }
     }
 
-    if(line.numpoints > 0) {
+    if (line.numpoints > 0) {
       line.point[line.numpoints].x = line.point[0].x; /* force closure */
       line.point[line.numpoints].y = line.point[0].y;
       line.numpoints++;
@@ -730,7 +751,8 @@ void msClipPolygonRect(shapeObj *shape,
     }
   } /* next line */
 
-  for (i=0; i<shape->numlines; i++) free(shape->line[i].point);
+  for (i = 0; i < shape->numlines; i++)
+    free(shape->line[i].point);
   free(shape->line);
 
   shape->line = tmp.line;
@@ -743,55 +765,55 @@ void msClipPolygonRect(shapeObj *shape,
 /*
 ** offsets a point relative to an image position
 */
-void msOffsetPointRelativeTo(pointObj *point, layerObj *layer)
-{
-  double x=0, y=0;
-  if ( msCheckParentPointer(layer->map,"map")==MS_FAILURE )
+void msOffsetPointRelativeTo(pointObj *point, layerObj *layer) {
+  double x = 0, y = 0;
+  if (msCheckParentPointer(layer->map, "map") == MS_FAILURE)
     return;
 
+  if (layer->transform == MS_TRUE)
+    return; /* nothing to do */
 
-  if(layer->transform == MS_TRUE) return; /* nothing to do */
-
-  if(layer->units == MS_PERCENTAGES) {
-    point->x *= (layer->map->width-1);
-    point->y *= (layer->map->height-1);
-  }
-
-  if(layer->transform == MS_FALSE || layer->transform == MS_UL) return; /* done */
-
-  switch(layer->transform) {
-    case MS_UC:
-      x = (layer->map->width-1)/2;
-      y = 0;
-      break;
-    case MS_UR:
-      x = layer->map->width-1;
-      y = 0;
-      break;
-    case MS_CL:
-      x = 0;
-      y = layer->map->height/2;
-      break;
-    case MS_CC:
-      x = layer->map->width/2;
-      y = layer->map->height/2;
-      break;
-    case MS_CR:
-      x = layer->map->width-1;
-      y = layer->map->height/2;
-      break;
-    case MS_LL:
-      x = 0;
-      y = layer->map->height-1;
-      break;
-    case MS_LC:
-      x = layer->map->width/2;
-      y = layer->map->height-1;
-      break;
-    case MS_LR:
-      x = layer->map->width-1;
-      y = layer->map->height-1;
-      break;
+  if (layer->units == MS_PERCENTAGES) {
+    point->x *= (layer->map->width - 1);
+    point->y *= (layer->map->height - 1);
+  }
+
+  if (layer->transform == MS_FALSE || layer->transform == MS_UL)
+    return; /* done */
+
+  switch (layer->transform) {
+  case MS_UC:
+    x = (layer->map->width - 1) / 2;
+    y = 0;
+    break;
+  case MS_UR:
+    x = layer->map->width - 1;
+    y = 0;
+    break;
+  case MS_CL:
+    x = 0;
+    y = layer->map->height / 2;
+    break;
+  case MS_CC:
+    x = layer->map->width / 2;
+    y = layer->map->height / 2;
+    break;
+  case MS_CR:
+    x = layer->map->width - 1;
+    y = layer->map->height / 2;
+    break;
+  case MS_LL:
+    x = 0;
+    y = layer->map->height - 1;
+    break;
+  case MS_LC:
+    x = layer->map->width / 2;
+    y = layer->map->height - 1;
+    break;
+  case MS_LR:
+    x = layer->map->width - 1;
+    y = layer->map->height - 1;
+    break;
   }
 
   point->x += x;
@@ -803,64 +825,64 @@ void msOffsetPointRelativeTo(pointObj *p
 /*
 ** offsets a shape relative to an image position
 */
-void msOffsetShapeRelativeTo(shapeObj *shape, layerObj *layer)
-{
+void msOffsetShapeRelativeTo(shapeObj *shape, layerObj *layer) {
   int i, j;
-  double x=0, y=0;
+  double x = 0, y = 0;
 
-  if(layer->transform == MS_TRUE) return; /* nothing to do */
-  if ( msCheckParentPointer(layer->map,"map")==MS_FAILURE )
+  if (layer->transform == MS_TRUE)
+    return; /* nothing to do */
+  if (msCheckParentPointer(layer->map, "map") == MS_FAILURE)
     return;
 
-
-  if(layer->units == MS_PERCENTAGES) {
-    for (i=0; i<shape->numlines; i++) {
-      for (j=0; j<shape->line[i].numpoints; j++) {
-        shape->line[i].point[j].x *= (layer->map->width-1);
-        shape->line[i].point[j].y *= (layer->map->height-1);
+  if (layer->units == MS_PERCENTAGES) {
+    for (i = 0; i < shape->numlines; i++) {
+      for (j = 0; j < shape->line[i].numpoints; j++) {
+        shape->line[i].point[j].x *= (layer->map->width - 1);
+        shape->line[i].point[j].y *= (layer->map->height - 1);
       }
     }
   }
 
-  if(layer->transform == MS_FALSE || layer->transform == MS_UL) return; /* done */
-
-  switch(layer->transform) {
-    case MS_UC:
-      x = (layer->map->width-1)/2;
-      y = 0;
-      break;
-    case MS_UR:
-      x = layer->map->width-1;
-      y = 0;
-      break;
-    case MS_CL:
-      x = 0;
-      y = layer->map->height/2;
-      break;
-    case MS_CC:
-      x = layer->map->width/2;
-      y = layer->map->height/2;
-      break;
-    case MS_CR:
-      x = layer->map->width-1;
-      y = layer->map->height/2;
-      break;
-    case MS_LL:
-      x = 0;
-      y = layer->map->height-1;
-      break;
-    case MS_LC:
-      x = layer->map->width/2;
-      y = layer->map->height-1;
-      break;
-    case MS_LR:
-      x = layer->map->width-1;
-      y = layer->map->height-1;
-      break;
+  if (layer->transform == MS_FALSE || layer->transform == MS_UL)
+    return; /* done */
+
+  switch (layer->transform) {
+  case MS_UC:
+    x = (layer->map->width - 1) / 2;
+    y = 0;
+    break;
+  case MS_UR:
+    x = layer->map->width - 1;
+    y = 0;
+    break;
+  case MS_CL:
+    x = 0;
+    y = layer->map->height / 2;
+    break;
+  case MS_CC:
+    x = layer->map->width / 2;
+    y = layer->map->height / 2;
+    break;
+  case MS_CR:
+    x = layer->map->width - 1;
+    y = layer->map->height / 2;
+    break;
+  case MS_LL:
+    x = 0;
+    y = layer->map->height - 1;
+    break;
+  case MS_LC:
+    x = layer->map->width / 2;
+    y = layer->map->height - 1;
+    break;
+  case MS_LR:
+    x = layer->map->width - 1;
+    y = layer->map->height - 1;
+    break;
   }
 
-  for (i=0; i<shape->numlines; i++) {
-    for (j=0; j<shape->line[i].numpoints; j++) {
+  for (i = 0; i < shape->numlines; i++) {
+    for (j = 0; j < shape->line[i].numpoints; j++) {
       shape->line[i].point[j].x += x;
       shape->line[i].point[j].y += y;
     }
@@ -869,16 +891,17 @@ void msOffsetShapeRelativeTo(shapeObj *s
   return;
 }
 
-void msTransformShapeSimplify(shapeObj *shape, rectObj extent, double cellsize)
-{
-  int i,j,k,beforelast; /* loop counters */
-  double dx,dy;
+void msTransformShapeSimplify(shapeObj *shape, rectObj extent,
+                              double cellsize) {
+  int i, j, k, beforelast; /* loop counters */
+  double dx, dy;
   pointObj *point;
   double inv_cs = 1.0 / cellsize; /* invert and multiply much faster */
   int ok = 0;
-  if(shape->numlines == 0) return; /* nothing to transform */
+  if (shape->numlines == 0)
+    return; /* nothing to transform */
 
-  if(shape->type == MS_SHAPE_LINE) {
+  if (shape->type == MS_SHAPE_LINE) {
     /*
      * loop through the shape's lines, and do naive simplification
      * to discard the points that are too close to one another.
@@ -887,41 +910,42 @@ void msTransformShapeSimplify(shapeObj *
      * the simplified line is guaranteed to contain at
      * least its first and last point
      */
-    for(i=0; i<shape->numlines; i++) { /* for each part */
-      if(shape->line[i].numpoints<2) {
-        shape->line[i].numpoints=0;
+    for (i = 0; i < shape->numlines; i++) { /* for each part */
+      if (shape->line[i].numpoints < 2) {
+        shape->line[i].numpoints = 0;
         continue; /*skip degenerate lines*/
       }
-      point=shape->line[i].point;
+      point = shape->line[i].point;
       /*always keep first point*/
       point[0].x = MS_MAP2IMAGE_X_IC_DBL(point[0].x, extent.minx, inv_cs);
       point[0].y = MS_MAP2IMAGE_Y_IC_DBL(point[0].y, extent.maxy, inv_cs);
-      beforelast=shape->line[i].numpoints-1;
-      for(j=1,k=1; j < beforelast; j++ ) { /*loop from second point to first-before-last point*/
+      beforelast = shape->line[i].numpoints - 1;
+      for (j = 1, k = 1; j < beforelast;
+           j++) { /*loop from second point to first-before-last point*/
         point[k].x = MS_MAP2IMAGE_X_IC_DBL(point[j].x, extent.minx, inv_cs);
         point[k].y = MS_MAP2IMAGE_Y_IC_DBL(point[j].y, extent.maxy, inv_cs);
-        dx=(point[k].x-point[k-1].x);
-        dy=(point[k].y-point[k-1].y);
-        if(dx*dx+dy*dy>1)
+        dx = (point[k].x - point[k - 1].x);
+        dy = (point[k].y - point[k - 1].y);
+        if (dx * dx + dy * dy > 1)
           k++;
       }
       /* try to keep last point */
       point[k].x = MS_MAP2IMAGE_X_IC_DBL(point[j].x, extent.minx, inv_cs);
       point[k].y = MS_MAP2IMAGE_Y_IC_DBL(point[j].y, extent.maxy, inv_cs);
       /* discard last point if equal to the one before it */
-      if(point[k].x!=point[k-1].x || point[k].y!=point[k-1].y) {
-        shape->line[i].numpoints=k+1;
+      if (point[k].x != point[k - 1].x || point[k].y != point[k - 1].y) {
+        shape->line[i].numpoints = k + 1;
       } else {
-        shape->line[i].numpoints=k;
+        shape->line[i].numpoints = k;
       }
       /* skip degenerate line once more */
-      if(shape->line[i].numpoints<2) {
-        shape->line[i].numpoints=0;
+      if (shape->line[i].numpoints < 2) {
+        shape->line[i].numpoints = 0;
       } else {
         ok = 1; /* we have at least one line with more than two points */
       }
     }
-  } else if(shape->type == MS_SHAPE_POLYGON) {
+  } else if (shape->type == MS_SHAPE_POLYGON) {
     /*
      * loop through the shape's lines, and do naive simplification
      * to discard the points that are too close to one another.
@@ -930,69 +954,74 @@ void msTransformShapeSimplify(shapeObj *
      * the simplified polygon is guaranteed to contain at
      * least its first, second and last point
      */
-    for(i=0; i<shape->numlines; i++) { /* for each part */
-      if(shape->line[i].numpoints<4) {
-        shape->line[i].numpoints=0;
+    for (i = 0; i < shape->numlines; i++) { /* for each part */
+      if (shape->line[i].numpoints < 4) {
+        shape->line[i].numpoints = 0;
         continue; /*skip degenerate lines*/
       }
-      point=shape->line[i].point;
+      point = shape->line[i].point;
       /*always keep first and second point*/
       point[0].x = MS_MAP2IMAGE_X_IC_DBL(point[0].x, extent.minx, inv_cs);
       point[0].y = MS_MAP2IMAGE_Y_IC_DBL(point[0].y, extent.maxy, inv_cs);
       point[1].x = MS_MAP2IMAGE_X_IC_DBL(point[1].x, extent.minx, inv_cs);
       point[1].y = MS_MAP2IMAGE_Y_IC_DBL(point[1].y, extent.maxy, inv_cs);
-      beforelast=shape->line[i].numpoints-2;
-      for(j=2,k=2; j < beforelast; j++ ) { /*loop from second point to second-before-last point*/
+      beforelast = shape->line[i].numpoints - 2;
+      for (j = 2, k = 2; j < beforelast;
+           j++) { /*loop from second point to second-before-last point*/
         point[k].x = MS_MAP2IMAGE_X_IC_DBL(point[j].x, extent.minx, inv_cs);
         point[k].y = MS_MAP2IMAGE_Y_IC_DBL(point[j].y, extent.maxy, inv_cs);
-        dx=(point[k].x-point[k-1].x);
-        dy=(point[k].y-point[k-1].y);
-        if(dx*dx+dy*dy>1)
+        dx = (point[k].x - point[k - 1].x);
+        dy = (point[k].y - point[k - 1].y);
+        if (dx * dx + dy * dy > 1)
           k++;
       }
       /*always keep last two points (the last point is the repetition of the
        * first one */
       point[k].x = MS_MAP2IMAGE_X_IC_DBL(point[j].x, extent.minx, inv_cs);
       point[k].y = MS_MAP2IMAGE_Y_IC_DBL(point[j].y, extent.maxy, inv_cs);
-      point[k+1].x = MS_MAP2IMAGE_X_IC_DBL(point[j+1].x, extent.minx, inv_cs);
-      point[k+1].y = MS_MAP2IMAGE_Y_IC_DBL(point[j+1].y, extent.maxy, inv_cs);
-      shape->line[i].numpoints = k+2;
+      point[k + 1].x =
+          MS_MAP2IMAGE_X_IC_DBL(point[j + 1].x, extent.minx, inv_cs);
+      point[k + 1].y =
+          MS_MAP2IMAGE_Y_IC_DBL(point[j + 1].y, extent.maxy, inv_cs);
+      shape->line[i].numpoints = k + 2;
       ok = 1;
     }
-  } else { /* only for untyped shapes, as point layers don't go through this function */
-    for(i=0; i<shape->numlines; i++) {
-      point=shape->line[i].point;
-      for(j=0; j<shape->line[i].numpoints; j++) {
+  } else { /* only for untyped shapes, as point layers don't go through this
+              function */
+    for (i = 0; i < shape->numlines; i++) {
+      point = shape->line[i].point;
+      for (j = 0; j < shape->line[i].numpoints; j++) {
         point[j].x = MS_MAP2IMAGE_X_IC_DBL(point[j].x, extent.minx, inv_cs);
         point[j].y = MS_MAP2IMAGE_Y_IC_DBL(point[j].y, extent.maxy, inv_cs);
       }
     }
     ok = 1;
   }
-  if(!ok) {
-    for(i=0; i<shape->numlines; i++) {
+  if (!ok) {
+    for (i = 0; i < shape->numlines; i++) {
       free(shape->line[i].point);
     }
-    shape->numlines = 0 ;
+    shape->numlines = 0;
   }
 }
 
 /**
  * Generic function to transorm the shape coordinates to output coordinates
  */
-void  msTransformShape(shapeObj *shape, rectObj extent, double cellsize, imageObj *image)
-{
+void msTransformShape(shapeObj *shape, rectObj extent, double cellsize,
+                      imageObj *image) {
   if (image != NULL && MS_RENDERER_PLUGIN(image->format)) {
     rendererVTableObj *renderer = MS_IMAGE_RENDERER(image);
-    if(renderer->transform_mode == MS_TRANSFORM_SNAPTOGRID) {
-      msTransformShapeToPixelSnapToGrid(shape, extent, cellsize, renderer->approximation_scale);
-    } else if(renderer->transform_mode == MS_TRANSFORM_SIMPLIFY) {
+    if (renderer->transform_mode == MS_TRANSFORM_SNAPTOGRID) {
+      msTransformShapeToPixelSnapToGrid(shape, extent, cellsize,
+                                        renderer->approximation_scale);
+    } else if (renderer->transform_mode == MS_TRANSFORM_SIMPLIFY) {
       msTransformShapeSimplify(shape, extent, cellsize);
-    } else if(renderer->transform_mode == MS_TRANSFORM_ROUND) {
+    } else if (renderer->transform_mode == MS_TRANSFORM_ROUND) {
       msTransformShapeToPixelRound(shape, extent, cellsize);
-    } else if(renderer->transform_mode == MS_TRANSFORM_FULLRESOLUTION) {
-      msTransformShapeToPixelDoublePrecision(shape,extent,cellsize);
-    } else if(renderer->transform_mode == MS_TRANSFORM_NONE) {
+    } else if (renderer->transform_mode == MS_TRANSFORM_FULLRESOLUTION) {
+      msTransformShapeToPixelDoublePrecision(shape, extent, cellsize);
+    } else if (renderer->transform_mode == MS_TRANSFORM_NONE) {
       /* nothing to do */
       return;
     }
@@ -1002,142 +1031,184 @@ void  msTransformShape(shapeObj *shape,
   msTransformShapeToPixelRound(shape, extent, cellsize);
 }
 
-void msTransformShapeToPixelSnapToGrid(shapeObj *shape, rectObj extent, double cellsize, double grid_resolution)
-{
-  int i,j,k; /* loop counters */
+void msTransformShapeToPixelSnapToGrid(shapeObj *shape, rectObj extent,
+                                       double cellsize,
+                                       double grid_resolution) {
+  int i, j, k; /* loop counters */
   double inv_cs;
-  if(shape->numlines == 0) return;
+  if (shape->numlines == 0)
+    return;
   inv_cs = 1.0 / cellsize; /* invert and multiply much faster */
 
-
-  if(shape->type == MS_SHAPE_LINE || shape->type == MS_SHAPE_POLYGON) { /* remove duplicate vertices */
-    for(i=0; i<shape->numlines; i++) { /* for each part */
+  if (shape->type == MS_SHAPE_LINE ||
+      shape->type == MS_SHAPE_POLYGON) {    /* remove duplicate vertices */
+    for (i = 0; i < shape->numlines; i++) { /* for each part */
       int snap = 1;
-      const double x0 = MS_MAP2IMAGE_X_IC_SNAP(shape->line[i].point[0].x, extent.minx, inv_cs, grid_resolution);
-      const double y0 = MS_MAP2IMAGE_Y_IC_SNAP(shape->line[i].point[0].y, extent.maxy, inv_cs, grid_resolution);
+      const double x0 = MS_MAP2IMAGE_X_IC_SNAP(
+          shape->line[i].point[0].x, extent.minx, inv_cs, grid_resolution);
+      const double y0 = MS_MAP2IMAGE_Y_IC_SNAP(
+          shape->line[i].point[0].y, extent.maxy, inv_cs, grid_resolution);
 
       /*do a quick heuristic: will we risk having a degenerate shape*/
-      if(shape->type == MS_SHAPE_LINE) {
-        /*a line is degenerate if it has a single pixel. we check that the first and last pixel are different*/
-        const double x1 = MS_MAP2IMAGE_X_IC_SNAP(shape->line[i].point[shape->line[i].numpoints-1].x, extent.minx, inv_cs, grid_resolution);
-        const double y1 = MS_MAP2IMAGE_Y_IC_SNAP(shape->line[i].point[shape->line[i].numpoints-1].y, extent.maxy, inv_cs, grid_resolution);
-        if(x0 == x1 && y0 == y1) {
+      if (shape->type == MS_SHAPE_LINE) {
+        /*a line is degenerate if it has a single pixel. we check that the first
+         * and last pixel are different*/
+        const double x1 = MS_MAP2IMAGE_X_IC_SNAP(
+            shape->line[i].point[shape->line[i].numpoints - 1].x, extent.minx,
+            inv_cs, grid_resolution);
+        const double y1 = MS_MAP2IMAGE_Y_IC_SNAP(
+            shape->line[i].point[shape->line[i].numpoints - 1].y, extent.maxy,
+            inv_cs, grid_resolution);
+        if (x0 == x1 && y0 == y1) {
           snap = 0;
         }
       } else /* if(shape->type == MS_SHAPE_POLYGON) */ {
-        const double x1 = MS_MAP2IMAGE_X_IC_SNAP(shape->line[i].point[shape->line[i].numpoints/3].x, extent.minx, inv_cs, grid_resolution);
-        const double y1 = MS_MAP2IMAGE_Y_IC_SNAP(shape->line[i].point[shape->line[i].numpoints/3].y, extent.maxy, inv_cs, grid_resolution);
-        const double x2 = MS_MAP2IMAGE_X_IC_SNAP(shape->line[i].point[shape->line[i].numpoints/3*2].x, extent.minx, inv_cs, grid_resolution);
-        const double y2 = MS_MAP2IMAGE_Y_IC_SNAP(shape->line[i].point[shape->line[i].numpoints/3*2].y, extent.maxy, inv_cs, grid_resolution);
-        if((x0 == x1 && y0 == y1) ||
-            (x0 == x2 && y0 == y2) ||
+        const double x1 = MS_MAP2IMAGE_X_IC_SNAP(
+            shape->line[i].point[shape->line[i].numpoints / 3].x, extent.minx,
+            inv_cs, grid_resolution);
+        const double y1 = MS_MAP2IMAGE_Y_IC_SNAP(
+            shape->line[i].point[shape->line[i].numpoints / 3].y, extent.maxy,
+            inv_cs, grid_resolution);
+        const double x2 = MS_MAP2IMAGE_X_IC_SNAP(
+            shape->line[i].point[shape->line[i].numpoints / 3 * 2].x,
+            extent.minx, inv_cs, grid_resolution);
+        const double y2 = MS_MAP2IMAGE_Y_IC_SNAP(
+            shape->line[i].point[shape->line[i].numpoints / 3 * 2].y,
+            extent.maxy, inv_cs, grid_resolution);
+        if ((x0 == x1 && y0 == y1) || (x0 == x2 && y0 == y2) ||
             (x1 == x2 && y1 == y2)) {
           snap = 0;
         }
       }
 
-      if(snap) {
+      if (snap) {
         shape->line[i].point[0].x = x0;
         shape->line[i].point[0].y = y0;
-        for(j=1, k=1; j < shape->line[i].numpoints; j++ ) {
-          shape->line[i].point[k].x = MS_MAP2IMAGE_X_IC_SNAP(shape->line[i].point[j].x, extent.minx, inv_cs, grid_resolution);
-          shape->line[i].point[k].y = MS_MAP2IMAGE_Y_IC_SNAP(shape->line[i].point[j].y, extent.maxy, inv_cs, grid_resolution);
-          if(shape->line[i].point[k].x!=shape->line[i].point[k-1].x || shape->line[i].point[k].y!=shape->line[i].point[k-1].y)
+        for (j = 1, k = 1; j < shape->line[i].numpoints; j++) {
+          shape->line[i].point[k].x = MS_MAP2IMAGE_X_IC_SNAP(
+              shape->line[i].point[j].x, extent.minx, inv_cs, grid_resolution);
+          shape->line[i].point[k].y = MS_MAP2IMAGE_Y_IC_SNAP(
+              shape->line[i].point[j].y, extent.maxy, inv_cs, grid_resolution);
+          if (shape->line[i].point[k].x != shape->line[i].point[k - 1].x ||
+              shape->line[i].point[k].y != shape->line[i].point[k - 1].y)
             k++;
         }
-        shape->line[i].numpoints=k;
+        shape->line[i].numpoints = k;
       } else {
-        if(shape->type == MS_SHAPE_LINE) {
-          shape->line[i].point[0].x = MS_MAP2IMAGE_X_IC_DBL(shape->line[i].point[0].x, extent.minx, inv_cs);
-          shape->line[i].point[0].y = MS_MAP2IMAGE_Y_IC_DBL(shape->line[i].point[0].y, extent.maxy, inv_cs);
-          shape->line[i].point[1].x = MS_MAP2IMAGE_X_IC_DBL(shape->line[i].point[shape->line[i].numpoints-1].x, extent.minx, inv_cs);
-          shape->line[i].point[1].y = MS_MAP2IMAGE_Y_IC_DBL(shape->line[i].point[shape->line[i].numpoints-1].y, extent.maxy, inv_cs);
+        if (shape->type == MS_SHAPE_LINE) {
+          shape->line[i].point[0].x = MS_MAP2IMAGE_X_IC_DBL(
+              shape->line[i].point[0].x, extent.minx, inv_cs);
+          shape->line[i].point[0].y = MS_MAP2IMAGE_Y_IC_DBL(
+              shape->line[i].point[0].y, extent.maxy, inv_cs);
+          shape->line[i].point[1].x = MS_MAP2IMAGE_X_IC_DBL(
+              shape->line[i].point[shape->line[i].numpoints - 1].x, extent.minx,
+              inv_cs);
+          shape->line[i].point[1].y = MS_MAP2IMAGE_Y_IC_DBL(
+              shape->line[i].point[shape->line[i].numpoints - 1].y, extent.maxy,
+              inv_cs);
           shape->line[i].numpoints = 2;
         } else {
-          for(j=0; j < shape->line[i].numpoints; j++ ) {
-            shape->line[i].point[j].x = MS_MAP2IMAGE_X_IC_DBL(shape->line[i].point[j].x, extent.minx, inv_cs);
-            shape->line[i].point[j].y = MS_MAP2IMAGE_Y_IC_DBL(shape->line[i].point[j].y, extent.maxy, inv_cs);
+          for (j = 0; j < shape->line[i].numpoints; j++) {
+            shape->line[i].point[j].x = MS_MAP2IMAGE_X_IC_DBL(
+                shape->line[i].point[j].x, extent.minx, inv_cs);
+            shape->line[i].point[j].y = MS_MAP2IMAGE_Y_IC_DBL(
+                shape->line[i].point[j].y, extent.maxy, inv_cs);
           }
         }
       }
     }
-  } else { /* points or untyped shapes */
-    for(i=0; i<shape->numlines; i++) { /* for each part */
-      for(j=1; j < shape->line[i].numpoints; j++ ) {
-        shape->line[i].point[j].x = MS_MAP2IMAGE_X_IC_DBL(shape->line[i].point[j].x, extent.minx, inv_cs);
-        shape->line[i].point[j].y = MS_MAP2IMAGE_Y_IC_DBL(shape->line[i].point[j].y, extent.maxy, inv_cs);
+  } else {                                  /* points or untyped shapes */
+    for (i = 0; i < shape->numlines; i++) { /* for each part */
+      for (j = 1; j < shape->line[i].numpoints; j++) {
+        shape->line[i].point[j].x = MS_MAP2IMAGE_X_IC_DBL(
+            shape->line[i].point[j].x, extent.minx, inv_cs);
+        shape->line[i].point[j].y = MS_MAP2IMAGE_Y_IC_DBL(
+            shape->line[i].point[j].y, extent.maxy, inv_cs);
       }
     }
   }
-
 }
 
-void msTransformShapeToPixelRound(shapeObj *shape, rectObj extent, double cellsize)
-{
-  int i,j,k; /* loop counters */
+void msTransformShapeToPixelRound(shapeObj *shape, rectObj extent,
+                                  double cellsize) {
+  int i, j, k; /* loop counters */
   double inv_cs;
-  if(shape->numlines == 0) return;
+  if (shape->numlines == 0)
+    return;
   inv_cs = 1.0 / cellsize; /* invert and multiply much faster */
-  if(shape->type == MS_SHAPE_LINE || shape->type == MS_SHAPE_POLYGON) { /* remove duplicate vertices */
-    for(i=0; i<shape->numlines; i++) { /* for each part */
-      shape->line[i].point[0].x = MS_MAP2IMAGE_X_IC(shape->line[i].point[0].x, extent.minx, inv_cs);;
-      shape->line[i].point[0].y = MS_MAP2IMAGE_Y_IC(shape->line[i].point[0].y, extent.maxy, inv_cs);
-      for(j=1, k=1; j < shape->line[i].numpoints; j++ ) {
-        shape->line[i].point[k].x = MS_MAP2IMAGE_X_IC(shape->line[i].point[j].x, extent.minx, inv_cs);
-        shape->line[i].point[k].y = MS_MAP2IMAGE_Y_IC(shape->line[i].point[j].y, extent.maxy, inv_cs);
-        if(shape->line[i].point[k].x!=shape->line[i].point[k-1].x || shape->line[i].point[k].y!=shape->line[i].point[k-1].y)
+  if (shape->type == MS_SHAPE_LINE ||
+      shape->type == MS_SHAPE_POLYGON) {    /* remove duplicate vertices */
+    for (i = 0; i < shape->numlines; i++) { /* for each part */
+      shape->line[i].point[0].x =
+          MS_MAP2IMAGE_X_IC(shape->line[i].point[0].x, extent.minx, inv_cs);
+      ;
+      shape->line[i].point[0].y =
+          MS_MAP2IMAGE_Y_IC(shape->line[i].point[0].y, extent.maxy, inv_cs);
+      for (j = 1, k = 1; j < shape->line[i].numpoints; j++) {
+        shape->line[i].point[k].x =
+            MS_MAP2IMAGE_X_IC(shape->line[i].point[j].x, extent.minx, inv_cs);
+        shape->line[i].point[k].y =
+            MS_MAP2IMAGE_Y_IC(shape->line[i].point[j].y, extent.maxy, inv_cs);
+        if (shape->line[i].point[k].x != shape->line[i].point[k - 1].x ||
+            shape->line[i].point[k].y != shape->line[i].point[k - 1].y)
           k++;
       }
-      shape->line[i].numpoints=k;
+      shape->line[i].numpoints = k;
     }
-  } else { /* points or untyped shapes */
-    for(i=0; i<shape->numlines; i++) { /* for each part */
-      for(j=0; j < shape->line[i].numpoints; j++ ) {
-        shape->line[i].point[j].x = MS_MAP2IMAGE_X_IC(shape->line[i].point[j].x, extent.minx, inv_cs);
-        shape->line[i].point[j].y = MS_MAP2IMAGE_Y_IC(shape->line[i].point[j].y, extent.maxy, inv_cs);
+  } else {                                  /* points or untyped shapes */
+    for (i = 0; i < shape->numlines; i++) { /* for each part */
+      for (j = 0; j < shape->line[i].numpoints; j++) {
+        shape->line[i].point[j].x =
+            MS_MAP2IMAGE_X_IC(shape->line[i].point[j].x, extent.minx, inv_cs);
+        shape->line[i].point[j].y =
+            MS_MAP2IMAGE_Y_IC(shape->line[i].point[j].y, extent.maxy, inv_cs);
       }
     }
   }
-
 }
 
-void msTransformShapeToPixelDoublePrecision(shapeObj *shape, rectObj extent, double cellsize)
-{
-  int i,j; /* loop counters */
+void msTransformShapeToPixelDoublePrecision(shapeObj *shape, rectObj extent,
+                                            double cellsize) {
+  int i, j;                       /* loop counters */
   double inv_cs = 1.0 / cellsize; /* invert and multiply much faster */
-  for(i=0; i<shape->numlines; i++) {
-    for(j=0; j<shape->line[i].numpoints; j++) {
-      shape->line[i].point[j].x = MS_MAP2IMAGE_X_IC_DBL(shape->line[i].point[j].x, extent.minx, inv_cs);
-      shape->line[i].point[j].y = MS_MAP2IMAGE_Y_IC_DBL(shape->line[i].point[j].y, extent.maxy, inv_cs);
+  for (i = 0; i < shape->numlines; i++) {
+    for (j = 0; j < shape->line[i].numpoints; j++) {
+      shape->line[i].point[j].x =
+          MS_MAP2IMAGE_X_IC_DBL(shape->line[i].point[j].x, extent.minx, inv_cs);
+      shape->line[i].point[j].y =
+          MS_MAP2IMAGE_Y_IC_DBL(shape->line[i].point[j].y, extent.maxy, inv_cs);
     }
   }
 }
 
-
-
 /*
 ** Converts from map coordinates to image coordinates
 */
-void msTransformPixelToShape(shapeObj *shape, rectObj extent, double cellsize)
-{
-  int i,j; /* loop counters */
-
-  if(shape->numlines == 0) return; /* nothing to transform */
-
-  if(shape->type == MS_SHAPE_LINE || shape->type == MS_SHAPE_POLYGON) { /* remove co-linear vertices */
-
-    for(i=0; i<shape->numlines; i++) { /* for each part */
-      for(j=0; j < shape->line[i].numpoints; j++ ) {
-        shape->line[i].point[j].x = MS_IMAGE2MAP_X(shape->line[i].point[j].x, extent.minx, cellsize);
-        shape->line[i].point[j].y = MS_IMAGE2MAP_Y(shape->line[i].point[j].y, extent.maxy, cellsize);
+void msTransformPixelToShape(shapeObj *shape, rectObj extent, double cellsize) {
+  int i, j; /* loop counters */
+
+  if (shape->numlines == 0)
+    return; /* nothing to transform */
+
+  if (shape->type == MS_SHAPE_LINE ||
+      shape->type == MS_SHAPE_POLYGON) { /* remove co-linear vertices */
+
+    for (i = 0; i < shape->numlines; i++) { /* for each part */
+      for (j = 0; j < shape->line[i].numpoints; j++) {
+        shape->line[i].point[j].x =
+            MS_IMAGE2MAP_X(shape->line[i].point[j].x, extent.minx, cellsize);
+        shape->line[i].point[j].y =
+            MS_IMAGE2MAP_Y(shape->line[i].point[j].y, extent.maxy, cellsize);
       }
     }
   } else { /* points or untyped shapes */
 
-    for(i=0; i<shape->numlines; i++) { /* for each part */
-      for(j=1; j < shape->line[i].numpoints; j++ ) {
-        shape->line[i].point[j].x = MS_IMAGE2MAP_X(shape->line[i].point[j].x, extent.minx, cellsize);
-        shape->line[i].point[j].y = MS_IMAGE2MAP_Y(shape->line[i].point[j].y, extent.maxy, cellsize);
+    for (i = 0; i < shape->numlines; i++) { /* for each part */
+      for (j = 1; j < shape->line[i].numpoints; j++) {
+        shape->line[i].point[j].x =
+            MS_IMAGE2MAP_X(shape->line[i].point[j].x, extent.minx, cellsize);
+        shape->line[i].point[j].y =
+            MS_IMAGE2MAP_Y(shape->line[i].point[j].y, extent.maxy, cellsize);
       }
     }
   }
@@ -1146,30 +1217,32 @@ void msTransformPixelToShape(shapeObj *s
 }
 
 /*
-** Not a generic intersection test, we KNOW the lines aren't parallel or coincident. To be used with the next
-** buffering code only. See code in mapsearch.c for a boolean test for intersection.
+** Not a generic intersection test, we KNOW the lines aren't parallel or
+*coincident. To be used with the next
+** buffering code only. See code in mapsearch.c for a boolean test for
+*intersection.
 */
-static pointObj generateLineIntersection(pointObj a, pointObj b, pointObj c, pointObj d)
-{
+static pointObj generateLineIntersection(pointObj a, pointObj b, pointObj c,
+                                         pointObj d) {
   pointObj p = {0}; // initialize
   double r;
   double denominator, numerator;
 
-  if(b.x == c.x && b.y == c.y) return(b);
+  if (b.x == c.x && b.y == c.y)
+    return (b);
 
-  numerator = ((a.y-c.y)*(d.x-c.x) - (a.x-c.x)*(d.y-c.y));
-  denominator = ((b.x-a.x)*(d.y-c.y) - (b.y-a.y)*(d.x-c.x));
+  numerator = ((a.y - c.y) * (d.x - c.x) - (a.x - c.x) * (d.y - c.y));
+  denominator = ((b.x - a.x) * (d.y - c.y) - (b.y - a.y) * (d.x - c.x));
 
-  r = numerator/denominator;
+  r = numerator / denominator;
 
-  p.x = MS_NINT(a.x + r*(b.x-a.x));
-  p.y = MS_NINT(a.y + r*(b.y-a.y));
+  p.x = MS_NINT(a.x + r * (b.x - a.x));
+  p.y = MS_NINT(a.y + r * (b.y - a.y));
 
-  return(p);
+  return (p);
 }
 
-void bufferPolyline(shapeObj *p, shapeObj *op, int w)
-{
+void bufferPolyline(shapeObj *p, shapeObj *op, int w) {
   int i, j;
   pointObj a = {0};
   lineObj inside, outside;
@@ -1178,19 +1251,25 @@ void bufferPolyline(shapeObj *p, shapeOb
 
   for (i = 0; i < p->numlines; i++) {
 
-    inside.point = (pointObj *)msSmallMalloc(sizeof(pointObj)*p->line[i].numpoints);
-    outside.point = (pointObj *)msSmallMalloc(sizeof(pointObj)*p->line[i].numpoints);
+    inside.point =
+        (pointObj *)msSmallMalloc(sizeof(pointObj) * p->line[i].numpoints);
+    outside.point =
+        (pointObj *)msSmallMalloc(sizeof(pointObj) * p->line[i].numpoints);
     inside.numpoints = outside.numpoints = p->line[i].numpoints;
 
-    angle = asin(MS_ABS(p->line[i].point[1].x - p->line[i].point[0].x)/sqrt((((p->line[i].point[1].x - p->line[i].point[0].x)*(p->line[i].point[1].x - p->line[i].point[0].x)) + ((p->line[i].point[1].y - p->line[i].point[0].y)*(p->line[i].point[1].y - p->line[i].point[0].y)))));
-    if(p->line[i].point[0].x < p->line[i].point[1].x)
-      dy = sin(angle) * (w/2);
+    angle = asin(MS_ABS(p->line[i].point[1].x - p->line[i].point[0].x) /
+                 sqrt((((p->line[i].point[1].x - p->line[i].point[0].x) *
+                        (p->line[i].point[1].x - p->line[i].point[0].x)) +
+                       ((p->line[i].point[1].y - p->line[i].point[0].y) *
+                        (p->line[i].point[1].y - p->line[i].point[0].y)))));
+    if (p->line[i].point[0].x < p->line[i].point[1].x)
+      dy = sin(angle) * (w / 2);
     else
-      dy = -sin(angle) * (w/2);
-    if(p->line[i].point[0].y < p->line[i].point[1].y)
-      dx = -cos(angle) * (w/2);
+      dy = -sin(angle) * (w / 2);
+    if (p->line[i].point[0].y < p->line[i].point[1].y)
+      dx = -cos(angle) * (w / 2);
     else
-      dx = cos(angle) * (w/2);
+      dx = cos(angle) * (w / 2);
 
     inside.point[0].x = p->line[i].point[0].x + dx;
     inside.point[1].x = p->line[i].point[1].x + dx;
@@ -1202,32 +1281,40 @@ void bufferPolyline(shapeObj *p, shapeOb
     outside.point[0].y = p->line[i].point[0].y - dy;
     outside.point[1].y = p->line[i].point[1].y - dy;
 
-    for(j=2; j<p->line[i].numpoints; j++) {
+    for (j = 2; j < p->line[i].numpoints; j++) {
 
-      angle = asin(MS_ABS(p->line[i].point[j].x - p->line[i].point[j-1].x)/sqrt((((p->line[i].point[j].x - p->line[i].point[j-1].x)*(p->line[i].point[j].x - p->line[i].point[j-1].x)) + ((p->line[i].point[j].y - p->line[i].point[j-1].y)*(p->line[i].point[j].y - p->line[i].point[j-1].y)))));
-      if(p->line[i].point[j-1].x < p->line[i].point[j].x)
-        dy = sin(angle) * (w/2);
+      angle =
+          asin(MS_ABS(p->line[i].point[j].x - p->line[i].point[j - 1].x) /
+               sqrt((((p->line[i].point[j].x - p->line[i].point[j - 1].x) *
+                      (p->line[i].point[j].x - p->line[i].point[j - 1].x)) +
+                     ((p->line[i].point[j].y - p->line[i].point[j - 1].y) *
+                      (p->line[i].point[j].y - p->line[i].point[j - 1].y)))));
+      if (p->line[i].point[j - 1].x < p->line[i].point[j].x)
+        dy = sin(angle) * (w / 2);
       else
-        dy = -sin(angle) * (w/2);
-      if(p->line[i].point[j-1].y < p->line[i].point[j].y)
-        dx = -cos(angle) * (w/2);
+        dy = -sin(angle) * (w / 2);
+      if (p->line[i].point[j - 1].y < p->line[i].point[j].y)
+        dx = -cos(angle) * (w / 2);
       else
-        dx = cos(angle) * (w/2);
+        dx = cos(angle) * (w / 2);
 
-      a.x = p->line[i].point[j-1].x + dx;
+      a.x = p->line[i].point[j - 1].x + dx;
       inside.point[j].x = p->line[i].point[j].x + dx;
-      a.y = p->line[i].point[j-1].y + dy;
+      a.y = p->line[i].point[j - 1].y + dy;
       inside.point[j].y = p->line[i].point[j].y + dy;
-      inside.point[j-1] = generateLineIntersection(inside.point[j-2], inside.point[j-1], a, inside.point[j]);
+      inside.point[j - 1] = generateLineIntersection(
+          inside.point[j - 2], inside.point[j - 1], a, inside.point[j]);
 
-      a.x = p->line[i].point[j-1].x - dx;
+      a.x = p->line[i].point[j - 1].x - dx;
       outside.point[j].x = p->line[i].point[j].x - dx;
-      a.y = p->line[i].point[j-1].y - dy;
+      a.y = p->line[i].point[j - 1].y - dy;
       outside.point[j].y = p->line[i].point[j].y - dy;
-      outside.point[j-1] = generateLineIntersection(outside.point[j-2], outside.point[j-1], a, outside.point[j]);
+      outside.point[j - 1] = generateLineIntersection(
+          outside.point[j - 2], outside.point[j - 1], a, outside.point[j]);
     }
 
-    /* need a touch of code if 1st point equals last point in p (find intersection) */
+    /* need a touch of code if 1st point equals last point in p (find
+     * intersection) */
 
     msAddLine(op, &inside);
     msAddLine(op, &outside);
@@ -1239,26 +1326,26 @@ void bufferPolyline(shapeObj *p, shapeOb
   return;
 }
 
-static double getRingArea(lineObj *ring)
-{
+static double getRingArea(lineObj *ring) {
   int i;
-  double s=0;
+  double s = 0;
 
-  for(i=0; i<ring->numpoints-1; i++)
-    s += (ring->point[i].x*ring->point[i+1].y - ring->point[i+1].x*ring->point[i].y);
+  for (i = 0; i < ring->numpoints - 1; i++)
+    s += (ring->point[i].x * ring->point[i + 1].y -
+          ring->point[i + 1].x * ring->point[i].y);
 
-  return (MS_ABS(s/2));
+  return (MS_ABS(s / 2));
 }
 
-double msGetPolygonArea(shapeObj *p)
-{
+double msGetPolygonArea(shapeObj *p) {
   int i;
-  double area=0;
+  double area = 0;
 
-  if(!p) return 0;
+  if (!p)
+    return 0;
 
-  for(i=0; i<p->numlines; i++) {
-    if(msIsOuterRing(p, i))
+  for (i = 0; i < p->numlines; i++) {
+    if (msIsOuterRing(p, i))
       area += getRingArea(&(p->line[i]));
     else
       area -= getRingArea(&(p->line[i])); /* hole */
@@ -1268,79 +1355,82 @@ double msGetPolygonArea(shapeObj *p)
 }
 
 /*
-** Computes the center of gravity for a polygon based on it's largest outer ring only.
+** Computes the center of gravity for a polygon based on it's largest outer ring
+*only.
 */
-static int getPolygonCenterOfGravity(shapeObj *p, pointObj *lp)
-{
-  double sx=0, sy=0; /* sums */
-  double largestArea=0;
+static int getPolygonCenterOfGravity(shapeObj *p, pointObj *lp) {
+  double sx = 0, sy = 0; /* sums */
+  double largestArea = 0;
 
-  for(int i=0; i<p->numlines; i++) {
+  for (int i = 0; i < p->numlines; i++) {
     double tsx = 0;
     double tsy = 0;
     double s = 0; /* reset the ring sums */
-    for(int j=0; j<p->line[i].numpoints-1; j++) {
-      double a = p->line[i].point[j].x*p->line[i].point[j+1].y - p->line[i].point[j+1].x*p->line[i].point[j].y;
+    for (int j = 0; j < p->line[i].numpoints - 1; j++) {
+      double a = p->line[i].point[j].x * p->line[i].point[j + 1].y -
+                 p->line[i].point[j + 1].x * p->line[i].point[j].y;
       s += a;
-      tsx += (p->line[i].point[j].x + p->line[i].point[j+1].x)*a;
-      tsy += (p->line[i].point[j].y + p->line[i].point[j+1].y)*a;
+      tsx += (p->line[i].point[j].x + p->line[i].point[j + 1].x) * a;
+      tsy += (p->line[i].point[j].y + p->line[i].point[j + 1].y) * a;
     }
-    double area = MS_ABS(s/2);
+    double area = MS_ABS(s / 2);
 
-    if(area > largestArea) {
+    if (area > largestArea) {
       largestArea = area;
-      sx = s>0?tsx:-tsx;
-      sy = s>0?tsy:-tsy;
+      sx = s > 0 ? tsx : -tsx;
+      sy = s > 0 ? tsy : -tsy;
     }
   }
-  if(largestArea == 0) /*degenerate polygon*/
+  if (largestArea == 0) /*degenerate polygon*/
     return MS_FAILURE;
 
-  lp->x = sx/(6*largestArea);
-  lp->y = sy/(6*largestArea);
+  lp->x = sx / (6 * largestArea);
+  lp->y = sy / (6 * largestArea);
 
   return MS_SUCCESS;
 }
 
-int msGetPolygonCentroid(shapeObj *p, pointObj *lp, double *miny, double *maxy)
-{
-  int i,j;
-  double cent_weight_x=0.0, cent_weight_y=0.0;
-  double len, total_len=0;
+int msGetPolygonCentroid(shapeObj *p, pointObj *lp, double *miny,
+                         double *maxy) {
+  int i, j;
+  double cent_weight_x = 0.0, cent_weight_y = 0.0;
+  double len, total_len = 0;
 
   *miny = *maxy = p->line[0].point[0].y;
-  for(i=0; i<p->numlines; i++) {
-    for(j=1; j<p->line[i].numpoints; j++) {
+  for (i = 0; i < p->numlines; i++) {
+    for (j = 1; j < p->line[i].numpoints; j++) {
       *miny = MS_MIN(*miny, p->line[i].point[j].y);
       *maxy = MS_MAX(*maxy, p->line[i].point[j].y);
-      len = msDistancePointToPoint(&(p->line[i].point[j-1]), &(p->line[i].point[j]));
-      cent_weight_x += len * ((p->line[i].point[j-1].x + p->line[i].point[j].x)/2);
-      cent_weight_y += len * ((p->line[i].point[j-1].y + p->line[i].point[j].y)/2);
+      len = msDistancePointToPoint(&(p->line[i].point[j - 1]),
+                                   &(p->line[i].point[j]));
+      cent_weight_x +=
+          len * ((p->line[i].point[j - 1].x + p->line[i].point[j].x) / 2);
+      cent_weight_y +=
+          len * ((p->line[i].point[j - 1].y + p->line[i].point[j].y) / 2);
       total_len += len;
     }
   }
 
-  if(total_len == 0)
-    return(MS_FAILURE);
+  if (total_len == 0)
+    return (MS_FAILURE);
 
   lp->x = cent_weight_x / total_len;
   lp->y = cent_weight_y / total_len;
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
 /*
 ** Find a label point in a polygon.
 */
-int msPolygonLabelPoint(shapeObj *p, pointObj *lp, double min_dimension)
-{
+int msPolygonLabelPoint(shapeObj *p, pointObj *lp, double min_dimension) {
   double slope;
-  pointObj *point1=NULL, *point2=NULL, cp;
+  pointObj *point1 = NULL, *point2 = NULL, cp;
   int i, j, nfound;
   double x, y, *intersect, temp;
   double min, max;
   int wrong_order, n;
-  double len, max_len=0;
+  double len, max_len = 0;
   double minx, maxx, maxy, miny;
 
 #ifdef notdef
@@ -1353,43 +1443,49 @@ int msPolygonLabelPoint(shapeObj *p, poi
   maxx = p->bounds.maxx;
   maxy = p->bounds.maxy;
 
-  if(min_dimension > 0)
-    if(MS_MIN(maxx-minx,maxy-miny) < min_dimension) return(MS_FAILURE);
+  if (min_dimension > 0)
+    if (MS_MIN(maxx - minx, maxy - miny) < min_dimension)
+      return (MS_FAILURE);
 
-  cp.x = (maxx+minx)/2.0;
-  cp.y = (maxy+miny)/2.0;
+  cp.x = (maxx + minx) / 2.0;
+  cp.y = (maxy + miny) / 2.0;
 
 #ifdef notdef
   switch (method) {
-    case 0: /* MBR */
-      lp->x = cp.x;
-      lp->y = cp.y;
-      break;
-    case 1: /* centroid */
-      if(msGetPolygonCentroid(p, lp, &miny, &maxy) != MS_SUCCESS) return(MS_FAILURE);
-      break;
-    case 2: /* center of gravity */
-      if(getPolygonCenterOfGravity(p, lp) != MS_SUCCESS) return(MS_FAILURE);
-      break;
+  case 0: /* MBR */
+    lp->x = cp.x;
+    lp->y = cp.y;
+    break;
+  case 1: /* centroid */
+    if (msGetPolygonCentroid(p, lp, &miny, &maxy) != MS_SUCCESS)
+      return (MS_FAILURE);
+    break;
+  case 2: /* center of gravity */
+    if (getPolygonCenterOfGravity(p, lp) != MS_SUCCESS)
+      return (MS_FAILURE);
+    break;
   }
 #else
-  if(getPolygonCenterOfGravity(p, lp) != MS_SUCCESS) return(MS_FAILURE);
+  if (getPolygonCenterOfGravity(p, lp) != MS_SUCCESS)
+    return (MS_FAILURE);
 #endif
 
-  if(msIntersectPointPolygon(lp, p) == MS_TRUE) {
-    double dist, min_dist=-1;
+  if (msIntersectPointPolygon(lp, p) == MS_TRUE) {
+    double dist, min_dist = -1;
 
     /* compute a distance to the polygon */
-    for(j=0; j<p->numlines; j++) {
-      for(i=1; i<p->line[j].numpoints; i++) {
-        dist = msSquareDistancePointToSegment(lp, &(p->line[j].point[i-1]), &(p->line[j].point[i]));
-        if((dist < min_dist) || (min_dist < 0)) min_dist = dist;
+    for (j = 0; j < p->numlines; j++) {
+      for (i = 1; i < p->line[j].numpoints; i++) {
+        dist = msSquareDistancePointToSegment(lp, &(p->line[j].point[i - 1]),
+                                              &(p->line[j].point[i]));
+        if ((dist < min_dist) || (min_dist < 0))
+          min_dist = dist;
       }
     }
     min_dist = sqrt(min_dist);
 
-    if(min_dist > .1*MS_MAX(maxx-minx, maxy-miny))
-      return(MS_SUCCESS); /* point is not too close to the edge */
+    if (min_dist > .1 * MS_MAX(maxx - minx, maxy - miny))
+      return (MS_SUCCESS); /* point is not too close to the edge */
   }
 
   /* printf("label: %s\n", p->text);
@@ -1400,63 +1496,67 @@ int msPolygonLabelPoint(shapeObj *p, poi
      printf("    distance to parent shape: %g\n", min_dist);
      return MS_SUCCESS; */
 
-  n=0;
-  for(j=0; j<p->numlines; j++) /* count total number of points */
+  n = 0;
+  for (j = 0; j < p->numlines; j++) /* count total number of points */
     n += p->line[j].numpoints;
-  intersect = (double *) calloc(n, sizeof(double));
-  MS_CHECK_ALLOC(intersect, n*sizeof(double), MS_FAILURE);
-
+  intersect = (double *)calloc(n, sizeof(double));
+  MS_CHECK_ALLOC(intersect, n * sizeof(double), MS_FAILURE);
 
-  if(MS_ABS((int)lp->x - (int)cp.x) > MS_ABS((int)lp->y - (int)cp.y)) { /* center horizontally, fix y */
+  if (MS_ABS((int)lp->x - (int)cp.x) >
+      MS_ABS((int)lp->y - (int)cp.y)) { /* center horizontally, fix y */
 
     y = lp->y;
 
     /* need to find a y that won't intersect any vertices exactly */
-    max = y - 1; /* first initializing min, max to be any 2 pnts on either side of y */
+    max = y - 1; /* first initializing min, max to be any 2 pnts on either side
+                    of y */
     min = y + 1;
-    for(j=0; j<p->numlines; j++) {
-      if((min < y) && (max >= y))  break;
-      for(i=0; i < p->line[j].numpoints; i++) {
-        if((min < y) && (max >= y))  break;
-        if(p->line[j].point[i].y < y)
+    for (j = 0; j < p->numlines; j++) {
+      if ((min < y) && (max >= y))
+        break;
+      for (i = 0; i < p->line[j].numpoints; i++) {
+        if ((min < y) && (max >= y))
+          break;
+        if (p->line[j].point[i].y < y)
           min = p->line[j].point[i].y;
-        if(p->line[j].point[i].y >= y)
+        if (p->line[j].point[i].y >= y)
           max = p->line[j].point[i].y;
       }
     }
 
-    n=0;
-    for(j=0; j<p->numlines; j++) {
-      for(i=0; i < p->line[j].numpoints; i++) {
-        if((p->line[j].point[i].y < y) && ((y - p->line[j].point[i].y) < (y - min)))
+    n = 0;
+    for (j = 0; j < p->numlines; j++) {
+      for (i = 0; i < p->line[j].numpoints; i++) {
+        if ((p->line[j].point[i].y < y) &&
+            ((y - p->line[j].point[i].y) < (y - min)))
           min = p->line[j].point[i].y;
-        if((p->line[j].point[i].y >= y) && ((p->line[j].point[i].y - y) < (max - y)))
+        if ((p->line[j].point[i].y >= y) &&
+            ((p->line[j].point[i].y - y) < (max - y)))
           max = p->line[j].point[i].y;
       }
     }
 
-    if(min == max) { 
+    if (min == max) {
       msFree(intersect);
       return (MS_FAILURE);
-    }
-    else
-      y = (max + min)/2.0;
+    } else
+      y = (max + min) / 2.0;
 
     nfound = 0;
-    for(j=0; j<p->numlines; j++) { /* for each line */
+    for (j = 0; j < p->numlines; j++) { /* for each line */
 
-      point1 = &( p->line[j].point[p->line[j].numpoints-1] );
-      for(i=0; i < p->line[j].numpoints; i++) {
-        point2 = &( p->line[j].point[i] );
+      point1 = &(p->line[j].point[p->line[j].numpoints - 1]);
+      for (i = 0; i < p->line[j].numpoints; i++) {
+        point2 = &(p->line[j].point[i]);
 
-        if(EDGE_CHECK(point1->y, y, point2->y) == CLIP_MIDDLE) {
+        if (EDGE_CHECK(point1->y, y, point2->y) == CLIP_MIDDLE) {
 
-          if(point1->y == point2->y)
+          if (point1->y == point2->y)
             continue; /* ignore horizontal edges */
           else
             slope = (point2->x - point1->x) / (point2->y - point1->y);
 
-          x = point1->x + (y - point1->y)*slope;
+          x = point1->x + (y - point1->y) * slope;
           intersect[nfound++] = x;
         } /* end checking this edge */
 
@@ -1467,20 +1567,20 @@ int msPolygonLabelPoint(shapeObj *p, poi
     /* sort the intersections */
     do {
       wrong_order = 0;
-      for(i=0; i < nfound-1; i++) {
-        if(intersect[i] > intersect[i+1]) {
+      for (i = 0; i < nfound - 1; i++) {
+        if (intersect[i] > intersect[i + 1]) {
           wrong_order = 1;
-          SWAP(intersect[i], intersect[i+1], temp);
+          SWAP(intersect[i], intersect[i + 1], temp);
         }
       }
-    } while(wrong_order);
+    } while (wrong_order);
 
     /* find longest span */
-    for(i=0; i < nfound; i += 2) {
-      len = fabs(intersect[i] - intersect[i+1]);
-      if(len > max_len) {
+    for (i = 0; i < nfound; i += 2) {
+      len = fabs(intersect[i] - intersect[i + 1]);
+      if (len > max_len) {
         max_len = len;
-        lp->x = (intersect[i] + intersect[i+1])/2;
+        lp->x = (intersect[i] + intersect[i + 1]) / 2;
         lp->y = y;
       }
     }
@@ -1488,52 +1588,56 @@ int msPolygonLabelPoint(shapeObj *p, poi
     x = lp->x;
 
     /* need to find a x that won't intersect any vertices exactly */
-    max = x - 1; /* first initializing min, max to be any 2 pnts on either side of x */
+    max = x - 1; /* first initializing min, max to be any 2 pnts on either side
+                    of x */
     min = x + 1;
-    for(j=0; j<p->numlines; j++) {
-      if((min < x) && (max >= x))  break;
-      for(i=0; i < p->line[j].numpoints; i++) {
-        if((min < x) && (max >= x))  break;
-        if(p->line[j].point[i].x < x)
+    for (j = 0; j < p->numlines; j++) {
+      if ((min < x) && (max >= x))
+        break;
+      for (i = 0; i < p->line[j].numpoints; i++) {
+        if ((min < x) && (max >= x))
+          break;
+        if (p->line[j].point[i].x < x)
           min = p->line[j].point[i].x;
-        if(p->line[j].point[i].x >= x)
+        if (p->line[j].point[i].x >= x)
           max = p->line[j].point[i].x;
       }
     }
 
-    n=0;
-    for(j=0; j<p->numlines; j++) {
-      for(i=0; i < p->line[j].numpoints; i++) {
-        if((p->line[j].point[i].x < x) && ((x - p->line[j].point[i].x) < (x - min)))
+    n = 0;
+    for (j = 0; j < p->numlines; j++) {
+      for (i = 0; i < p->line[j].numpoints; i++) {
+        if ((p->line[j].point[i].x < x) &&
+            ((x - p->line[j].point[i].x) < (x - min)))
           min = p->line[j].point[i].x;
-        if((p->line[j].point[i].x >= x) && ((p->line[j].point[i].x - x) < (max - x)))
+        if ((p->line[j].point[i].x >= x) &&
+            ((p->line[j].point[i].x - x) < (max - x)))
           max = p->line[j].point[i].x;
       }
     }
 
-    if(min == max) {
+    if (min == max) {
       msFree(intersect);
       return (MS_FAILURE);
-    }
-    else
-      x = (max + min)/2.0;
+    } else
+      x = (max + min) / 2.0;
 
     nfound = 0;
-    for(j=0; j<p->numlines; j++) { /* for each line */
+    for (j = 0; j < p->numlines; j++) { /* for each line */
 
-      point1 = &( p->line[j].point[p->line[j].numpoints-1] );
-      for(i=0; i < p->line[j].numpoints; i++) {
-        point2 = &( p->line[j].point[i] );
+      point1 = &(p->line[j].point[p->line[j].numpoints - 1]);
+      for (i = 0; i < p->line[j].numpoints; i++) {
+        point2 = &(p->line[j].point[i]);
 
-        if(EDGE_CHECK(point1->x, x, point2->x) == CLIP_MIDDLE) {
+        if (EDGE_CHECK(point1->x, x, point2->x) == CLIP_MIDDLE) {
 
-          if(point1->x == point2->x)
+          if (point1->x == point2->x)
             continue; /* ignore vertical edges */
-          else if(point1->y == point2->y)
+          else if (point1->y == point2->y)
             y = point1->y; /* for a horizontal edge we know y */
           else {
             slope = (point2->x - point1->x) / (point2->y - point1->y);
-            y = (x - point1->x)/slope + point1->y;
+            y = (x - point1->x) / slope + point1->y;
           }
 
           intersect[nfound++] = y;
@@ -1546,20 +1650,20 @@ int msPolygonLabelPoint(shapeObj *p, poi
     /* sort the intersections */
     do {
       wrong_order = 0;
-      for(i=0; i < nfound-1; i++) {
-        if(intersect[i] > intersect[i+1]) {
+      for (i = 0; i < nfound - 1; i++) {
+        if (intersect[i] > intersect[i + 1]) {
           wrong_order = 1;
-          SWAP(intersect[i], intersect[i+1], temp);
+          SWAP(intersect[i], intersect[i + 1], temp);
         }
       }
-    } while(wrong_order);
+    } while (wrong_order);
 
     /* find longest span */
-    for(i=0; i < nfound; i += 2) {
-      len = fabs(intersect[i] - intersect[i+1]);
-      if(len > max_len) {
+    for (i = 0; i < nfound; i += 2) {
+      len = fabs(intersect[i] - intersect[i + 1]);
+      if (len > max_len) {
         max_len = len;
-        lp->y = (intersect[i] + intersect[i+1])/2;
+        lp->y = (intersect[i] + intersect[i + 1]) / 2;
         lp->x = x;
       }
     }
@@ -1567,46 +1671,51 @@ int msPolygonLabelPoint(shapeObj *p, poi
 
   free(intersect);
 
-  if(max_len > 0)
-    return(MS_SUCCESS);
+  if (max_len > 0)
+    return (MS_SUCCESS);
   else
-    return(MS_FAILURE);
+    return (MS_FAILURE);
 }
 
-/* Compute all the lineString/segment lengths and determine the longest lineString of a multiLineString
- * shape: in paramater, the multiLineString to compute.
- * struct polyline_lengths pll: out parameter, all line and segment lengths
-*/
-void msPolylineComputeLineSegments(shapeObj *shape, struct polyline_lengths *pll)
-{
+/* Compute all the lineString/segment lengths and determine the longest
+ * lineString of a multiLineString shape: in paramater, the multiLineString to
+ * compute. struct polyline_lengths pll: out parameter, all line and segment
+ * lengths
+ */
+void msPolylineComputeLineSegments(shapeObj *shape,
+                                   struct polyline_lengths *pll) {
   int i, j;
-  double max_line_length=-1, max_segment_length=-1, segment_length;
+  double max_line_length = -1, max_segment_length = -1, segment_length;
 
   pll->ll = msSmallMalloc(shape->numlines * sizeof(struct line_lengths));
   pll->total_length = 0;
   pll->longest_line_index = 0;
 
-
-  for(i=0; i<shape->numlines; i++) {
+  for (i = 0; i < shape->numlines; i++) {
     struct line_lengths *ll = &pll->ll[i];
     double max_subline_segment_length = -1;
-    
-    if(shape->line[i].numpoints > 1) {
-      ll->segment_lengths = (double*) msSmallMalloc(sizeof(double) * (shape->line[i].numpoints - 1));
+
+    if (shape->line[i].numpoints > 1) {
+      ll->segment_lengths = (double *)msSmallMalloc(
+          sizeof(double) * (shape->line[i].numpoints - 1));
     } else {
       ll->segment_lengths = NULL;
     }
     ll->total_length = 0;
-    
-    for(j=1; j<shape->line[i].numpoints; j++) {
-      segment_length = sqrt((((shape->line[i].point[j].x-shape->line[i].point[j-1].x)*(shape->line[i].point[j].x-shape->line[i].point[j-1].x)) + ((shape->line[i].point[j].y-shape->line[i].point[j-1].y)*(shape->line[i].point[j].y-shape->line[i].point[j-1].y))));
+
+    for (j = 1; j < shape->line[i].numpoints; j++) {
+      segment_length =
+          sqrt((((shape->line[i].point[j].x - shape->line[i].point[j - 1].x) *
+                 (shape->line[i].point[j].x - shape->line[i].point[j - 1].x)) +
+                ((shape->line[i].point[j].y - shape->line[i].point[j - 1].y) *
+                 (shape->line[i].point[j].y - shape->line[i].point[j - 1].y))));
       ll->total_length += segment_length;
-      ll->segment_lengths[j-1] = segment_length;
-      if(segment_length > max_subline_segment_length) {
+      ll->segment_lengths[j - 1] = segment_length;
+      if (segment_length > max_subline_segment_length) {
         max_subline_segment_length = segment_length;
         ll->longest_segment_index = j;
       }
-      if(segment_length > max_segment_length) {
+      if (segment_length > max_segment_length) {
         max_segment_length = segment_length;
         pll->longest_segment_line_index = i;
         pll->longest_segment_point_index = j;
@@ -1614,7 +1723,7 @@ void msPolylineComputeLineSegments(shape
     }
     pll->total_length += ll->total_length;
 
-    if(ll->total_length > max_line_length) {
+    if (ll->total_length > max_line_length) {
       max_line_length = ll->total_length;
       pll->longest_line_index = i;
     }
@@ -1622,76 +1731,83 @@ void msPolylineComputeLineSegments(shape
 }
 
 /*
-** If no repeatdistance, find center of longest segment in polyline p. The polyline must have been converted
+** If no repeatdistance, find center of longest segment in polyline p. The
+*polyline must have been converted
 ** to image coordinates before calling this function.
 */
-int msPolylineLabelPoint(mapObj *map, shapeObj *p, textSymbolObj *ts, labelObj *label, struct label_auto_result *lar, double resolutionfactor)
-{
+int msPolylineLabelPoint(mapObj *map, shapeObj *p, textSymbolObj *ts,
+                         labelObj *label, struct label_auto_result *lar,
+                         double resolutionfactor) {
   struct polyline_lengths pll;
   int i, ret = MS_SUCCESS;
   double minfeaturesize = -1;
   assert(ts == NULL || ts->annotext);
 
-
-  if(label && ts) {
-    if(label->autominfeaturesize) {
-      if(!ts->textpath) {
-        if(MS_UNLIKELY(MS_FAILURE == msComputeTextPath(map,ts)))
+  if (label && ts) {
+    if (label->autominfeaturesize) {
+      if (!ts->textpath) {
+        if (MS_UNLIKELY(MS_FAILURE == msComputeTextPath(map, ts)))
           return MS_FAILURE;
       }
-      if(!ts->textpath)
+      if (!ts->textpath)
         return MS_FAILURE;
       minfeaturesize = ts->textpath->bounds.bbox.maxx;
-    } else if(label->minfeaturesize) {
+    } else if (label->minfeaturesize) {
       minfeaturesize = label->minfeaturesize * resolutionfactor;
     }
   }
 
   /* compute line lengths, in order to:
     - extract the longest line if we're not repeating
-    - check that each line is longer than the text length if using minfeaturesize auto
+    - check that each line is longer than the text length if using
+    minfeaturesize auto
     - check that each line is long enough if using minfeaturesize
    */
   msPolylineComputeLineSegments(p, &pll);
 
-  if(label && label->repeatdistance > 0) {
-    for(i=0; i<p->numlines; i++) {
-      if(pll.ll[i].total_length > minfeaturesize) {
-        ret = msLineLabelPoint(map,&p->line[i], ts, &pll.ll[i],lar, label, resolutionfactor);
+  if (label && label->repeatdistance > 0) {
+    for (i = 0; i < p->numlines; i++) {
+      if (pll.ll[i].total_length > minfeaturesize) {
+        ret = msLineLabelPoint(map, &p->line[i], ts, &pll.ll[i], lar, label,
+                               resolutionfactor);
       }
     }
   } else {
     i = pll.longest_line_index;
-    if(pll.ll[i].total_length > minfeaturesize) {
-      ret = msLineLabelPoint(map,&p->line[i], ts, &pll.ll[i],lar, label, resolutionfactor);
+    if (pll.ll[i].total_length > minfeaturesize) {
+      ret = msLineLabelPoint(map, &p->line[i], ts, &pll.ll[i], lar, label,
+                             resolutionfactor);
     }
   }
 
   /* freeing memory: allocated by msPolylineComputeLineSegments */
-  for ( i = 0; i < p->numlines; i++ ) {
+  for (i = 0; i < p->numlines; i++) {
     free(pll.ll[i].segment_lengths);
   }
   free(pll.ll);
-  
+
   return ret;
 }
 
-int msLineLabelPoint(mapObj *map, lineObj *p, textSymbolObj *ts, struct line_lengths *ll, struct label_auto_result *lar, labelObj *label, double resolutionfactor)
-{
+int msLineLabelPoint(mapObj *map, lineObj *p, textSymbolObj *ts,
+                     struct line_lengths *ll, struct label_auto_result *lar,
+                     labelObj *label, double resolutionfactor) {
   (void)map;
   int j, l, n, point_repeat;
   double t, theta, fwd_length, point_distance;
-  double center_point_position, left_point_position, right_point_position, point_position;
+  double center_point_position, left_point_position, right_point_position,
+      point_position;
   double repeat_distance = -1;
-  if(label) {
+  if (label) {
     repeat_distance = label->repeatdistance * resolutionfactor;
   }
 
-  if(MS_UNLIKELY(p->numpoints < 2))
+  if (MS_UNLIKELY(p->numpoints < 2))
     return MS_FAILURE;
   point_distance = 0;
   point_repeat = 1;
-  left_point_position = right_point_position = center_point_position = ll->total_length / 2.0;
+  left_point_position = right_point_position = center_point_position =
+      ll->total_length / 2.0;
 
   if (repeat_distance > 0) {
     point_repeat = ll->total_length / repeat_distance;
@@ -1699,19 +1815,21 @@ int msLineLabelPoint(mapObj *map, lineOb
     if (point_repeat > 1) {
       if (point_repeat % 2 == 0)
         point_repeat -= 1;
-      point_distance = (ll->total_length / point_repeat); /* buffer allowed per point */
+      point_distance =
+          (ll->total_length / point_repeat); /* buffer allowed per point */
 
       /* initial point position */
-      left_point_position -= ((point_repeat-1)/2 * point_distance);
-      right_point_position += ((point_repeat-1)/2 * point_distance);
+      left_point_position -= ((point_repeat - 1) / 2 * point_distance);
+      right_point_position += ((point_repeat - 1) / 2 * point_distance);
 
-      point_repeat = (point_repeat-1)/2+1;
+      point_repeat = (point_repeat - 1) / 2 + 1;
     } else
       point_repeat = 1;
   }
 
-  for (l=0; l < point_repeat; ++l) {
-    if (l == point_repeat-1) { /* last point to place is always the center point */
+  for (l = 0; l < point_repeat; ++l) {
+    if (l ==
+        point_repeat - 1) { /* last point to place is always the center point */
       point_position = center_point_position;
       n = 1;
     } else {
@@ -1720,34 +1838,42 @@ int msLineLabelPoint(mapObj *map, lineOb
     }
 
     do {
-      lar->angles = msSmallRealloc(lar->angles, (lar->num_label_points+1)*sizeof(double));
-      lar->label_points = msSmallRealloc(lar->label_points, (lar->num_label_points+1)*sizeof(pointObj));
-
-      /* if there is only 1 label to place... put it in the middle of the current segment (as old behavior) */
-      if ( point_repeat == 1 ) {
+      lar->angles = msSmallRealloc(lar->angles, (lar->num_label_points + 1) *
+                                                    sizeof(double));
+      lar->label_points = msSmallRealloc(
+          lar->label_points, (lar->num_label_points + 1) * sizeof(pointObj));
+
+      /* if there is only 1 label to place... put it in the middle of the
+       * current segment (as old behavior) */
+      if (point_repeat == 1) {
         j = ll->longest_segment_index;
-        lar->label_points[lar->num_label_points].x = (p->point[j-1].x + p->point[j].x)/2.0;
-        lar->label_points[lar->num_label_points].y = (p->point[j-1].y + p->point[j].y)/2.0;
+        lar->label_points[lar->num_label_points].x =
+            (p->point[j - 1].x + p->point[j].x) / 2.0;
+        lar->label_points[lar->num_label_points].y =
+            (p->point[j - 1].y + p->point[j].y) / 2.0;
       } else {
-        j=0;
+        j = 0;
         fwd_length = 0;
         while (fwd_length < point_position) {
           fwd_length += ll->segment_lengths[j++];
         }
-        assert(j>0);
+        assert(j > 0);
 
-        t = 1 - (fwd_length - point_position) / ll->segment_lengths[j-1];
-        lar->label_points[lar->num_label_points].x = t * (p->point[j].x - p->point[j-1].x) + p->point[j-1].x;
-        lar->label_points[lar->num_label_points].y = t * (p->point[j].y - p->point[j-1].y) + p->point[j-1].y;
+        t = 1 - (fwd_length - point_position) / ll->segment_lengths[j - 1];
+        lar->label_points[lar->num_label_points].x =
+            t * (p->point[j].x - p->point[j - 1].x) + p->point[j - 1].x;
+        lar->label_points[lar->num_label_points].y =
+            t * (p->point[j].y - p->point[j - 1].y) + p->point[j - 1].y;
       }
 
-      if(label && ts) {
-        if(label->anglemode != MS_NONE) {
-          theta = atan2(p->point[j].x - p->point[j-1].x, p->point[j].y - p->point[j-1].y);
-          if(label->anglemode == MS_AUTO2) {
+      if (label && ts) {
+        if (label->anglemode != MS_NONE) {
+          theta = atan2(p->point[j].x - p->point[j - 1].x,
+                        p->point[j].y - p->point[j - 1].y);
+          if (label->anglemode == MS_AUTO2) {
             theta -= MS_PI2;
-          } else { /* AUTO, FOLLOW */
-            if(p->point[j-1].x < p->point[j].x) { /* i.e. to the left */
+          } else {                                   /* AUTO, FOLLOW */
+            if (p->point[j - 1].x < p->point[j].x) { /* i.e. to the left */
               theta -= MS_PI2;
             } else {
               theta += MS_PI2;
@@ -1764,7 +1890,7 @@ int msLineLabelPoint(mapObj *map, lineOb
 
       point_position = left_point_position;
       n++;
-    } while (n<2); /* we place the right point then the left point. */
+    } while (n < 2); /* we place the right point then the left point. */
 
     right_point_position -= point_distance;
     left_point_position += point_distance;
@@ -1773,148 +1899,165 @@ int msLineLabelPoint(mapObj *map, lineOb
   return MS_SUCCESS;
 }
 
-
-/* Calculate the labelpath for each line if repeatdistance is enabled, else the labelpath of the longest line segment */
-int msPolylineLabelPath(mapObj *map, imageObj *image, shapeObj *p, textSymbolObj *ts, labelObj *label, struct label_follow_result *lfr)
-{
+/* Calculate the labelpath for each line if repeatdistance is enabled, else the
+ * labelpath of the longest line segment */
+int msPolylineLabelPath(mapObj *map, imageObj *image, shapeObj *p,
+                        textSymbolObj *ts, labelObj *label,
+                        struct label_follow_result *lfr) {
   struct polyline_lengths pll;
-  int i,ret = MS_SUCCESS;
+  int i, ret = MS_SUCCESS;
   double minfeaturesize = -1;
   assert(ts->annotext);
   lfr->num_follow_labels = lfr->lar.num_label_points = 0;
 
   /* we first offset the line if we want an offsetted label */
-  if(label->offsetx != 0 && IS_PERPENDICULAR_OFFSET(label->offsety)) {
+  if (label->offsetx != 0 && IS_PERPENDICULAR_OFFSET(label->offsety)) {
     double offset;
-    if(label->offsetx > 0) {
-      offset = label->offsetx + label->size/2;
+    if (label->offsetx > 0) {
+      offset = label->offsetx + label->size / 2;
     } else {
-      offset = label->offsetx - label->size/2;
+      offset = label->offsetx - label->size / 2;
     }
-    if(label->offsety == MS_LABEL_PERPENDICULAR_TOP_OFFSET && p->numlines>0 && p->line[0].numpoints > 0) {
+    if (label->offsety == MS_LABEL_PERPENDICULAR_TOP_OFFSET &&
+        p->numlines > 0 && p->line[0].numpoints > 0) {
       /* is the line mostly left-to-right or right-to-left ?
-       * FIXME this should be done line by line, by stepping through shape->lines, however
-       * the OffsetPolyline function works on shapeObjs, not lineObjs
-       * we only check the first line
+       * FIXME this should be done line by line, by stepping through
+       * shape->lines, however the OffsetPolyline function works on shapeObjs,
+       * not lineObjs we only check the first line
        */
-      if(p->line[0].point[0].x < p->line[0].point[p->line[0].numpoints-1].x) {
+      if (p->line[0].point[0].x <
+          p->line[0].point[p->line[0].numpoints - 1].x) {
         /* line is left to right */
-          offset = -offset;
+        offset = -offset;
       }
     }
-    p = msOffsetPolyline(p,offset, MS_STYLE_SINGLE_SIDED_OFFSET);
-    if(!p) return MS_FAILURE;
+    p = msOffsetPolyline(p, offset, MS_STYLE_SINGLE_SIDED_OFFSET);
+    if (!p)
+      return MS_FAILURE;
   }
 
   /* compute line lengths, in order to:
     - extract the longest line if we're not repeating
-    - check that each line is longer than the text length if using minfeaturesize auto
+    - check that each line is longer than the text length if using
+    minfeaturesize auto
     - check that each line is long enough if using minfeaturesize
    */
   msPolylineComputeLineSegments(p, &pll);
- 
-  if(label->autominfeaturesize) {
-    if(!ts->textpath) {
-      if(MS_UNLIKELY(MS_FAILURE == msComputeTextPath(map,ts))) {
+
+  if (label->autominfeaturesize) {
+    if (!ts->textpath) {
+      if (MS_UNLIKELY(MS_FAILURE == msComputeTextPath(map, ts))) {
         return MS_FAILURE;
       }
     }
-    if(!ts->textpath)
+    if (!ts->textpath)
       return MS_FAILURE;
     minfeaturesize = ts->textpath->bounds.bbox.maxx;
-  } else if(label->minfeaturesize) {
+  } else if (label->minfeaturesize) {
     minfeaturesize = label->minfeaturesize * image->resolutionfactor;
   }
 
-  if(label->repeatdistance > 0) {
-    for(i=0; i<p->numlines; i++) {
-      if(pll.ll[i].total_length > minfeaturesize) {
-        ret = msLineLabelPath(map,image,&p->line[i], ts, &pll.ll[i],lfr, label);
+  if (label->repeatdistance > 0) {
+    for (i = 0; i < p->numlines; i++) {
+      if (pll.ll[i].total_length > minfeaturesize) {
+        ret = msLineLabelPath(map, image, &p->line[i], ts, &pll.ll[i], lfr,
+                              label);
       }
     }
   } else {
     i = pll.longest_line_index;
-    if(pll.ll[i].total_length > minfeaturesize) {
-      ret = msLineLabelPath(map,image,&p->line[i], ts, &pll.ll[i],lfr, label);
+    if (pll.ll[i].total_length > minfeaturesize) {
+      ret =
+          msLineLabelPath(map, image, &p->line[i], ts, &pll.ll[i], lfr, label);
     }
   }
 
   /* freeing memory: allocated by msPolylineComputeLineSegments */
-  for ( i = 0; i < p->numlines; i++ ) {
+  for (i = 0; i < p->numlines; i++) {
     free(pll.ll[i].segment_lengths);
   }
   free(pll.ll);
-  
-  if(IS_PERPENDICULAR_OFFSET(label->offsety) && label->offsetx != 0) {
-     msFreeShape(p);
-     msFree(p);
+
+  if (IS_PERPENDICULAR_OFFSET(label->offsety) && label->offsetx != 0) {
+    msFreeShape(p);
+    msFree(p);
   }
   return ret;
 }
 
-static double compute_retry_offset(textSymbolObj *ts, int fail_idx, double retried_offset, double max_dec_offset, double max_inc_offset) {
-/* fail_idx: the glyph index in the textpath that originally failed (i.e. before any displacement was tested */
-/* retried_offset: the last offset that was tried and is failing, so we can return the next one (or 0 if none left)*/
-  int inc = 1,dec_found=0, inc_found=0;
+static double compute_retry_offset(textSymbolObj *ts, int fail_idx,
+                                   double retried_offset, double max_dec_offset,
+                                   double max_inc_offset) {
+  /* fail_idx: the glyph index in the textpath that originally failed (i.e.
+   * before any displacement was tested */
+  /* retried_offset: the last offset that was tried and is failing, so we can
+   * return the next one (or 0 if none left)*/
+  int inc = 1, dec_found = 0, inc_found = 0;
   double inc_offset = 0, dec_offset = 0;
 
   retried_offset = fabs(retried_offset);
   do {
-    if(fail_idx - inc - 1 >= 0) {
+    if (fail_idx - inc - 1 >= 0) {
       dec_offset += ts->textpath->glyphs[fail_idx - inc].glyph->metrics.advance;
-      if(dec_offset > max_dec_offset)
+      if (dec_offset > max_dec_offset)
         break;
-      if(dec_offset > retried_offset && msIsGlyphASpace(&ts->textpath->glyphs[fail_idx - inc - 1])) {
+      if (dec_offset > retried_offset &&
+          msIsGlyphASpace(&ts->textpath->glyphs[fail_idx - inc - 1])) {
         dec_found = 1;
-        dec_offset += ts->textpath->glyphs[fail_idx - inc -1].glyph->metrics.advance / 2.0;
+        dec_offset +=
+            ts->textpath->glyphs[fail_idx - inc - 1].glyph->metrics.advance /
+            2.0;
         break;
       }
     }
     inc++;
-  } while(dec_offset<max_dec_offset && fail_idx-inc>0);
-  
-  if(!dec_found) {
+  } while (dec_offset < max_dec_offset && fail_idx - inc > 0);
+
+  if (!dec_found) {
     /* try the starting position */
     dec_offset += ts->textpath->glyphs[0].glyph->metrics.advance;
-    if(dec_offset > retried_offset && dec_offset<max_dec_offset) {
+    if (dec_offset > retried_offset && dec_offset < max_dec_offset) {
       dec_found = 1;
     }
   }
-  
+
   inc = 1;
   inc_offset = ts->textpath->glyphs[fail_idx].glyph->metrics.advance;
-  do{
-    if(fail_idx + inc < ts->textpath->numglyphs - 1) {
-      if(inc_offset > retried_offset && msIsGlyphASpace(&ts->textpath->glyphs[fail_idx + inc])) {
-        inc_offset += ts->textpath->glyphs[fail_idx + inc].glyph->metrics.advance / 2;
-        if(inc_offset < max_inc_offset)
+  do {
+    if (fail_idx + inc < ts->textpath->numglyphs - 1) {
+      if (inc_offset > retried_offset &&
+          msIsGlyphASpace(&ts->textpath->glyphs[fail_idx + inc])) {
+        inc_offset +=
+            ts->textpath->glyphs[fail_idx + inc].glyph->metrics.advance / 2;
+        if (inc_offset < max_inc_offset)
           inc_found = 1;
         break;
       }
       inc_offset += ts->textpath->glyphs[fail_idx + inc].glyph->metrics.advance;
     }
     inc++;
-  } while(inc_offset<max_inc_offset && fail_idx+inc<ts->textpath->numglyphs-1);
-  if(!inc_found) {
-    inc_offset += ts->textpath->glyphs[ts->textpath->numglyphs-1].glyph->metrics.advance;
-    if(inc_offset > retried_offset && inc_offset<max_inc_offset) {
+  } while (inc_offset < max_inc_offset &&
+           fail_idx + inc < ts->textpath->numglyphs - 1);
+  if (!inc_found) {
+    inc_offset += ts->textpath->glyphs[ts->textpath->numglyphs - 1]
+                      .glyph->metrics.advance;
+    if (inc_offset > retried_offset && inc_offset < max_inc_offset) {
       inc_found = 1;
     }
   }
-  
-  if(!inc_found && !dec_found)
+
+  if (!inc_found && !dec_found)
     return 0.0;
-  if(inc_found && dec_found) {
-    if(inc_offset<dec_offset)
+  if (inc_found && dec_found) {
+    if (inc_offset < dec_offset)
       return -inc_offset;
     else
       return dec_offset;
   }
-  if(inc_found)
+  if (inc_found)
     return -inc_offset;
   else
     return dec_offset;
-            
 }
 /*
  * Calculate a series of label points for each character in the label for a
@@ -1923,14 +2066,17 @@ static double compute_retry_offset(textS
  * are allocated in this function.  The polyline must be converted to image
  * coordinates before calling this function.
  */
-int msLineLabelPath(mapObj *map, imageObj *img, lineObj *p, textSymbolObj *ts, struct line_lengths *ll, struct label_follow_result *lfr, labelObj *label)
-{
+int msLineLabelPath(mapObj *map, imageObj *img, lineObj *p, textSymbolObj *ts,
+                    struct line_lengths *ll, struct label_follow_result *lfr,
+                    labelObj *label) {
   double distance_along_segment;
   double repeat_distance = label->repeatdistance * ts->resolutionfactor;
-  double segment_length, fwd_line_length, rev_line_length, text_length, text_start_length, label_buffer, text_end_length, cur_label_position, first_label_position;
+  double segment_length, fwd_line_length, rev_line_length, text_length,
+      text_start_length, label_buffer, text_end_length, cur_label_position,
+      first_label_position;
   double max_retry_offset;
 
-  int j,k,l,inc, final_j, label_repeat;
+  int j, k, l, inc, final_j, label_repeat;
   double direction;
   rectObj bbox;
   lineObj *bounds;
@@ -1941,29 +2087,32 @@ int msLineLabelPath(mapObj *map, imageOb
   double dx, dy, w, cos_t, sin_t;
 
   const double letterspacing = 1.00;
-  /* As per RFC 60, if label->maxoverlapangle == 0 then fall back on pre-6.0 behavior
-     which was to use maxoverlapangle = 0.4*MS_PI ( 40% of 180 degrees ) */
+  /* As per RFC 60, if label->maxoverlapangle == 0 then fall back on pre-6.0
+     behavior which was to use maxoverlapangle = 0.4*MS_PI ( 40% of 180 degrees
+     ) */
   double maxoverlapangle = 0.4 * MS_PI;
 
-  if(p->numpoints < 2) { /* degenerate */
+  if (p->numpoints < 2) { /* degenerate */
     return MS_FAILURE;
   }
-  if(p->numpoints == 2) /* use the regular angled text algorithm */
-    return msLineLabelPoint(map,p,ts,ll,&lfr->lar,label, img->resolutionfactor);
-  
-  if(!ts->textpath) {
-    if(MS_UNLIKELY(MS_FAILURE == msComputeTextPath(map,ts))) {
+  if (p->numpoints == 2) /* use the regular angled text algorithm */
+    return msLineLabelPoint(map, p, ts, ll, &lfr->lar, label,
+                            img->resolutionfactor);
+
+  if (!ts->textpath) {
+    if (MS_UNLIKELY(MS_FAILURE == msComputeTextPath(map, ts))) {
       return MS_FAILURE;
     }
   }
-  if(!ts->textpath) {
+  if (!ts->textpath) {
     return MS_FAILURE;
   }
-  
-  /* skip the label and use the normal algorithm if it has fewer than 2 characters */
-  if(ts->textpath->numglyphs < 2)
-    return msLineLabelPoint(map,p,ts,ll,&lfr->lar,label, img->resolutionfactor);
 
+  /* skip the label and use the normal algorithm if it has fewer than 2
+   * characters */
+  if (ts->textpath->numglyphs < 2)
+    return msLineLabelPoint(map, p, ts, ll, &lfr->lar, label,
+                            img->resolutionfactor);
 
   text_length = letterspacing * ts->textpath->bounds.bbox.maxx;
 
@@ -1971,8 +2120,8 @@ int msLineLabelPath(mapObj *map, imageOb
   ** if the text length is way longer than the line, skip adding the
   ** label if it isn't forced (long extrapolated labels tend to be ugly)
   */
-  if ( text_length > 1.5 * ll->total_length ) {
-    if(ts->label->force == MS_FALSE ) {
+  if (text_length > 1.5 * ll->total_length) {
+    if (ts->label->force == MS_FALSE) {
       return MS_SUCCESS;
     } else {
       repeat_distance = 0; /* disable repetition */
@@ -1983,8 +2132,10 @@ int msLineLabelPath(mapObj *map, imageOb
      - space occupied by one label
      - plus N times space occupied by one label + repeat_distance interspacing
    */
-  label_buffer = text_length + repeat_distance; /* distance occupied by one label + inter-repeat spacing */
-  if( repeat_distance > 0 && ll->total_length > text_length) {
+  label_buffer =
+      text_length + repeat_distance; /* distance occupied by one label +
+                                        inter-repeat spacing */
+  if (repeat_distance > 0 && ll->total_length > text_length) {
     label_repeat = 1 + (int)((ll->total_length - text_length) / label_buffer);
     max_retry_offset = repeat_distance / 2.1;
   } else {
@@ -1992,11 +2143,13 @@ int msLineLabelPath(mapObj *map, imageOb
     max_retry_offset = (ll->total_length - text_length) / 2.1;
   }
   /* compute the starting point of where we'll be placing the first label */
-  if(label_repeat % 2) {
-    /* odd number of labels: account for the center label that will be centered on the line
+  if (label_repeat % 2) {
+    /* odd number of labels: account for the center label that will be centered
+     * on the line
      * ----llll_____llll_____llll----
      */
-    first_label_position = (ll->total_length - text_length) / 2.0 - (label_repeat / 2) * label_buffer;
+    first_label_position = (ll->total_length - text_length) / 2.0 -
+                           (label_repeat / 2) * label_buffer;
   } else {
     /* even number of labels:
      * repeat_distance is centered on the line
@@ -2005,211 +2158,227 @@ int msLineLabelPath(mapObj *map, imageOb
      * ----llll_____llll----
      * --llll_____llll_____llll_____llll--
      */
-    first_label_position = (ll->total_length - repeat_distance) / 2.0 - text_length - (label_repeat/2 - 1) * label_buffer;
+    first_label_position = (ll->total_length - repeat_distance) / 2.0 -
+                           text_length - (label_repeat / 2 - 1) * label_buffer;
   }
-  if(label->maxoverlapangle > 0)
+  if (label->maxoverlapangle > 0)
     maxoverlapangle = label->maxoverlapangle * MS_DEG_TO_RAD; /* radian */
-  
+
   cur_label_position = first_label_position;
-  for (l=0; l < label_repeat; l++) {
-    
+  for (l = 0; l < label_repeat; l++) {
+
     double retry_offset = 0.0;
     int first_retry_idx = 0;
-    //max_dec_retry_offset = max_inc_retry_offset = max_retry_offset;
-    textPathObj *tp = msSmallCalloc(1,sizeof(textPathObj));
-    /* copy the textPath, we will be overriding the copy's positions and angles */
-    msCopyTextPath(tp,ts->textpath);
+    // max_dec_retry_offset = max_inc_retry_offset = max_retry_offset;
+    textPathObj *tp = msSmallCalloc(1, sizeof(textPathObj));
+    /* copy the textPath, we will be overriding the copy's positions and angles
+     */
+    msCopyTextPath(tp, ts->textpath);
     tp->bounds.poly = msSmallMalloc(sizeof(lineObj));
     bounds = tp->bounds.poly;
 
-
     /*
     ** The bounds will have two points for each character plus an endpoint:
     ** the UL corners of each bbox will be tied together and the LL corners
     ** will be tied together.
     */
-    bounds->numpoints = 2*tp->numglyphs + 1;
-    bounds->point = (pointObj *) msSmallMalloc(sizeof(pointObj) * bounds->numpoints);
+    bounds->numpoints = 2 * tp->numglyphs + 1;
+    bounds->point =
+        (pointObj *)msSmallMalloc(sizeof(pointObj) * bounds->numpoints);
 
     do {
       int overlap_collision_detected = 0;
       text_start_length = cur_label_position + retry_offset;
       text_end_length = 0;
-      
-      for(k=0;k<tp->numglyphs;k++) {
+
+      for (k = 0; k < tp->numglyphs; k++) {
         tp->glyphs[k].pnt.x = 0;
         tp->glyphs[k].pnt.y = 0;
       }
-      
-      /* the points start at (line_length - text_length) / 2 in order to be centred */
+
+      /* the points start at (line_length - text_length) / 2 in order to be
+       * centred */
       /* text_start_length = (line_length - text_length) / 2.0; */
-      
+
       j = 0;
       fwd_line_length = 0;
-      if(text_start_length >= 0.0) {
-        while ( fwd_line_length < text_start_length )
+      if (text_start_length >= 0.0) {
+        while (fwd_line_length < text_start_length)
           fwd_line_length += ll->segment_lengths[j++];
-        
+
         j--;
       }
       final_j = p->numpoints - 1;
       rev_line_length = 0;
-      if(text_start_length+text_length <= ll->total_length) {
+      if (text_start_length + text_length <= ll->total_length) {
         text_end_length = ll->total_length - (text_start_length + text_length);
-        while(rev_line_length < text_end_length) {
+        while (rev_line_length < text_end_length) {
           rev_line_length += ll->segment_lengths[final_j - 1];
           final_j--;
         }
         final_j++;
       }
-      
-      if(final_j == 0)
+
+      if (final_j == 0)
         final_j = 1;
-      
+
       /* determine if the line is mostly left to right or right to left,
        see bug 1620 discussion by Steve Woodbridge */
       direction = p->point[final_j].x - p->point[j].x;
-      
-      if(direction > 0) {
+
+      if (direction > 0) {
         inc = 1; /* j is already correct */
-        
+
         /* length of the segment containing the starting point */
         segment_length = ll->segment_lengths[j];
-        
+
         /* determine how far along the segment we need to go */
-        if(text_start_length < 0.0)
+        if (text_start_length < 0.0)
           t = text_start_length / segment_length;
         else
           t = 1 - (fwd_line_length - text_start_length) / segment_length;
       } else {
         j = final_j;
         inc = -1;
-        
+
         /* length of the segment containing the starting point */
-        segment_length = ll->segment_lengths[j-1];
-        if(text_start_length < 0.0)
+        segment_length = ll->segment_lengths[j - 1];
+        if (text_start_length < 0.0)
           t = text_start_length / segment_length;
         else
           t = 1 - (rev_line_length - text_end_length) / segment_length;
       }
-      
+
       distance_along_segment = t * segment_length; /* starting point */
-      
+
       theta = 0;
       k = 0;
       w = 0;
-      while ( k < tp->numglyphs ) {
-        double x,y;
-        
-        x = t * (p->point[j+inc].x - p->point[j].x) + p->point[j].x;
-        y = t * (p->point[j+inc].y - p->point[j].y) + p->point[j].y;
+      while (k < tp->numglyphs) {
+        double x, y;
+
+        x = t * (p->point[j + inc].x - p->point[j].x) + p->point[j].x;
+        y = t * (p->point[j + inc].y - p->point[j].y) + p->point[j].y;
         tp->glyphs[k].pnt.x = x;
         tp->glyphs[k].pnt.y = y;
-        
-        
-        w = letterspacing*tp->glyphs[k].glyph->metrics.advance;
-        
+
+        w = letterspacing * tp->glyphs[k].glyph->metrics.advance;
+
         /* add the character's width to the distance along the line */
         distance_along_segment += w;
-        
-        /* if we still have segments left and we've past the current segment, move to the next one */
-        if(inc == 1 && j < p->numpoints - 2) {
-          
-          while ( j < p->numpoints - 2 && distance_along_segment > ll->segment_lengths[j] ) {
+
+        /* if we still have segments left and we've past the current segment,
+         * move to the next one */
+        if (inc == 1 && j < p->numpoints - 2) {
+
+          while (j < p->numpoints - 2 &&
+                 distance_along_segment > ll->segment_lengths[j]) {
             distance_along_segment -= ll->segment_lengths[j];
             j += inc; /* move to next segment */
           }
-          
+
           segment_length = ll->segment_lengths[j];
-          
-        } else if( inc == -1 && j > 1 ) {
-          
-          while ( j > 1 && distance_along_segment > ll->segment_lengths[j-1] ) {
-            distance_along_segment -= ll->segment_lengths[j-1];
+
+        } else if (inc == -1 && j > 1) {
+
+          while (j > 1 && distance_along_segment > ll->segment_lengths[j - 1]) {
+            distance_along_segment -= ll->segment_lengths[j - 1];
             j += inc; /* move to next segment */
           }
-          
-          segment_length = ll->segment_lengths[j-1];
+
+          segment_length = ll->segment_lengths[j - 1];
         }
-        
+
         /* Recalculate interpolation parameter */
         t = distance_along_segment / segment_length;
-        
+
         k++;
       }
-      
-      /* pre-calc the character's centre y value.  Used for rotation adjustment. */
+
+      /* pre-calc the character's centre y value.  Used for rotation adjustment.
+       */
       cy = -ts->textpath->glyph_size / 2.0;
 #ifdef USE_KERNEL
       tp->glyphs[0].pnt.x /= kernel_normal;
       tp->glyphs[0].pnt.y /= kernel_normal;
 #endif
-      
+
       /* Average the points and calculate each angle */
       overlap_collision_detected = 0;
       for (k = 1; k <= tp->numglyphs; k++) {
         double anglediff;
-        if ( k < tp->numglyphs ) {
+        if (k < tp->numglyphs) {
 #ifdef USE_KERNEL
           tp->glyphs[k].pnt.x /= kernel_normal;
           tp->glyphs[k].pnt.y /= kernel_normal;
 #endif
-          dx = tp->glyphs[k].pnt.x - tp->glyphs[k-1].pnt.x;
-          dy = tp->glyphs[k].pnt.y - tp->glyphs[k-1].pnt.y;
+          dx = tp->glyphs[k].pnt.x - tp->glyphs[k - 1].pnt.x;
+          dy = tp->glyphs[k].pnt.y - tp->glyphs[k - 1].pnt.y;
         } else {
           /* Handle the last character */
-          dx = t * (p->point[j+inc].x - p->point[j].x) + p->point[j].x - tp->glyphs[k-1].pnt.x;
-          dy = t * (p->point[j+inc].y - p->point[j].y) + p->point[j].y - tp->glyphs[k-1].pnt.y;
+          dx = t * (p->point[j + inc].x - p->point[j].x) + p->point[j].x -
+               tp->glyphs[k - 1].pnt.x;
+          dy = t * (p->point[j + inc].y - p->point[j].y) + p->point[j].y -
+               tp->glyphs[k - 1].pnt.y;
         }
-        
-        
-        if(dx || dy || k==1) {
-          
-          theta = -atan2(dy,dx);
-          
+
+        if (dx || dy || k == 1) {
+
+          theta = -atan2(dy, dx);
+
           if (maxoverlapangle > 0 && k > 1) {
-            /* no use testing for overlap if glyph or previous glyph is a space */
-            if(!msIsGlyphASpace(&tp->glyphs[k-1]) && !msIsGlyphASpace(&tp->glyphs[k-2])) {
-              /* If the difference between the last char angle and the current one
-               is greater than the MAXOVERLAPANGLE value (set at 80% of 180deg by default)
-               , bail the label */
-              anglediff = fabs(theta - tp->glyphs[k-2].rot);
+            /* no use testing for overlap if glyph or previous glyph is a space
+             */
+            if (!msIsGlyphASpace(&tp->glyphs[k - 1]) &&
+                !msIsGlyphASpace(&tp->glyphs[k - 2])) {
+              /* If the difference between the last char angle and the current
+               one is greater than the MAXOVERLAPANGLE value (set at 80% of
+               180deg by default) , bail the label */
+              anglediff = fabs(theta - tp->glyphs[k - 2].rot);
               anglediff = MS_MIN(anglediff, MS_2PI - anglediff);
-              if(anglediff > maxoverlapangle ) {
+              if (anglediff > maxoverlapangle) {
                 double max_dec_retry_offset;
                 double max_inc_retry_offset;
-                if(label_repeat == 1) {
-                  max_dec_retry_offset = max_inc_retry_offset = first_label_position;
-                } else if(l==0) {
-                  if(direction>0) {
-                    max_inc_retry_offset = MS_MIN(first_label_position, max_retry_offset);
+                if (label_repeat == 1) {
+                  max_dec_retry_offset = max_inc_retry_offset =
+                      first_label_position;
+                } else if (l == 0) {
+                  if (direction > 0) {
+                    max_inc_retry_offset =
+                        MS_MIN(first_label_position, max_retry_offset);
                     max_dec_retry_offset = max_retry_offset;
                   } else {
                     max_inc_retry_offset = max_retry_offset;
-                    max_dec_retry_offset = MS_MIN(first_label_position, max_retry_offset);
+                    max_dec_retry_offset =
+                        MS_MIN(first_label_position, max_retry_offset);
                   }
-                } else if(l == label_repeat-1) {
-                  if(direction>0) {
-                    max_dec_retry_offset = MS_MIN(first_label_position, max_retry_offset);
+                } else if (l == label_repeat - 1) {
+                  if (direction > 0) {
+                    max_dec_retry_offset =
+                        MS_MIN(first_label_position, max_retry_offset);
                     max_inc_retry_offset = max_retry_offset;
                   } else {
                     max_dec_retry_offset = max_retry_offset;
-                    max_inc_retry_offset = MS_MIN(first_label_position, max_retry_offset);
+                    max_inc_retry_offset =
+                        MS_MIN(first_label_position, max_retry_offset);
                   }
                 } else {
-                  max_dec_retry_offset = max_inc_retry_offset = max_retry_offset;
+                  max_dec_retry_offset = max_inc_retry_offset =
+                      max_retry_offset;
                 }
 
                 overlap_collision_detected = 1;
-                if(retry_offset == 0.0) {
-                  first_retry_idx = k-1;
+                if (retry_offset == 0.0) {
+                  first_retry_idx = k - 1;
                 }
-                retry_offset = compute_retry_offset(ts, first_retry_idx, retry_offset, max_dec_retry_offset, max_inc_retry_offset);
-                if(retry_offset == 0.0) { /* no offsetted position to try */
+                retry_offset = compute_retry_offset(
+                    ts, first_retry_idx, retry_offset, max_dec_retry_offset,
+                    max_inc_retry_offset);
+                if (retry_offset == 0.0) { /* no offsetted position to try */
                   freeTextPath(tp);
                   free(tp);
                 } else {
-                  if(direction<0) {
+                  if (direction < 0) {
                     retry_offset = -retry_offset;
                   }
                 }
@@ -2219,159 +2388,170 @@ int msLineLabelPath(mapObj *map, imageOb
           }
         } else {
           /*
-           * handle the 0-advance case, as the complex text shaping may have placed multiple
-           * glyphs at the same position
+           * handle the 0-advance case, as the complex text shaping may have
+           * placed multiple glyphs at the same position
            */
-          theta = tp->glyphs[k-2].rot;
+          theta = tp->glyphs[k - 2].rot;
         }
-        
-        /* msDebug("s: %c (x,y): (%0.2f,%0.2f) t: %0.2f\n", string[k-1], labelpath->path.point[k-1].x, labelpath->path.point[k-1].y, theta); */
-        
-        tp->glyphs[k-1].rot = theta;
-        
-        
+
+        /* msDebug("s: %c (x,y): (%0.2f,%0.2f) t: %0.2f\n", string[k-1],
+         * labelpath->path.point[k-1].x, labelpath->path.point[k-1].y, theta);
+         */
+
+        tp->glyphs[k - 1].rot = theta;
+
         /* Move the previous point so that when the character is rotated and
          placed it is centred on the line */
         cos_t = cos(theta);
         sin_t = sin(theta);
-        
-        w = letterspacing*tp->glyphs[k-1].glyph->metrics.advance;
-        
+
+        w = letterspacing * tp->glyphs[k - 1].glyph->metrics.advance;
+
         cx = 0; /* Center the character vertically only */
-        
-        dx = - (cx * cos_t + cy * sin_t);
-        dy = - (cy * cos_t - cx * sin_t);
-        
-        tp->glyphs[k-1].pnt.x += dx;
-        tp->glyphs[k-1].pnt.y += dy;
-        
+
+        dx = -(cx * cos_t + cy * sin_t);
+        dy = -(cy * cos_t - cx * sin_t);
+
+        tp->glyphs[k - 1].pnt.x += dx;
+        tp->glyphs[k - 1].pnt.y += dy;
+
         /* Calculate the bounds */
         bbox.minx = 0;
         bbox.maxx = w;
         bbox.maxy = 0;
         bbox.miny = -ts->textpath->glyph_size;
-        
+
         /* Add the label buffer to the bounds */
         bbox.maxx += ts->label->buffer * ts->resolutionfactor;
         bbox.maxy += ts->label->buffer * ts->resolutionfactor;
         bbox.minx -= ts->label->buffer * ts->resolutionfactor;
         bbox.miny -= ts->label->buffer * ts->resolutionfactor;
-        
-        if ( k < tp->numglyphs ) {
+
+        if (k < tp->numglyphs) {
           /* Transform the bbox too.  We take the UL and LL corners and rotate
            then translate them. */
-          bounds->point[k-1].x = (bbox.minx * cos_t + bbox.maxy * sin_t) + tp->glyphs[k-1].pnt.x;
-          bounds->point[k-1].y = (bbox.maxy * cos_t - bbox.minx * sin_t) + tp->glyphs[k-1].pnt.y;
-          
+          bounds->point[k - 1].x =
+              (bbox.minx * cos_t + bbox.maxy * sin_t) + tp->glyphs[k - 1].pnt.x;
+          bounds->point[k - 1].y =
+              (bbox.maxy * cos_t - bbox.minx * sin_t) + tp->glyphs[k - 1].pnt.y;
+
           /* Start at end and work towards the half way point */
-          bounds->point[bounds->numpoints - k - 1].x = (bbox.minx * cos_t + bbox.miny * sin_t) + tp->glyphs[k-1].pnt.x;
-          bounds->point[bounds->numpoints - k - 1].y = (bbox.miny * cos_t - bbox.minx * sin_t) + tp->glyphs[k-1].pnt.y;
-          
+          bounds->point[bounds->numpoints - k - 1].x =
+              (bbox.minx * cos_t + bbox.miny * sin_t) + tp->glyphs[k - 1].pnt.x;
+          bounds->point[bounds->numpoints - k - 1].y =
+              (bbox.miny * cos_t - bbox.minx * sin_t) + tp->glyphs[k - 1].pnt.y;
+
         } else {
-          
+
           /* This is the last character in the string so we take the UR and LR
            corners of the bbox */
-          bounds->point[k-1].x = (bbox.maxx * cos_t + bbox.maxy * sin_t) + tp->glyphs[k-1].pnt.x;
-          bounds->point[k-1].y = (bbox.maxy * cos_t - bbox.maxx * sin_t) + tp->glyphs[k-1].pnt.y;
-          
-          bounds->point[bounds->numpoints - k - 1].x = (bbox.maxx * cos_t + bbox.miny * sin_t) + tp->glyphs[k-1].pnt.x;
-          bounds->point[bounds->numpoints - k - 1].y = (bbox.miny * cos_t - bbox.maxx * sin_t) + tp->glyphs[k-1].pnt.y;
+          bounds->point[k - 1].x =
+              (bbox.maxx * cos_t + bbox.maxy * sin_t) + tp->glyphs[k - 1].pnt.x;
+          bounds->point[k - 1].y =
+              (bbox.maxy * cos_t - bbox.maxx * sin_t) + tp->glyphs[k - 1].pnt.y;
+
+          bounds->point[bounds->numpoints - k - 1].x =
+              (bbox.maxx * cos_t + bbox.miny * sin_t) + tp->glyphs[k - 1].pnt.x;
+          bounds->point[bounds->numpoints - k - 1].y =
+              (bbox.miny * cos_t - bbox.maxx * sin_t) + tp->glyphs[k - 1].pnt.y;
         }
       }
-      if(overlap_collision_detected) {
+      if (overlap_collision_detected) {
         continue;
       }
-      
-      
+
       /* Close the bounds */
       bounds->point[bounds->numpoints - 1].x = bounds->point[0].x;
       bounds->point[bounds->numpoints - 1].y = bounds->point[0].y;
-      
+
       /* compute the bounds */
-      fastComputeBounds(bounds,&tp->bounds.bbox);
-      
-      
+      fastComputeBounds(bounds, &tp->bounds.bbox);
+
       {
         textPathObj *tmptp;
         textSymbolObj *tsnew;
         lfr->num_follow_labels++;
-        lfr->follow_labels = msSmallRealloc(lfr->follow_labels,lfr->num_follow_labels * sizeof(textSymbolObj*));
+        lfr->follow_labels =
+            msSmallRealloc(lfr->follow_labels,
+                           lfr->num_follow_labels * sizeof(textSymbolObj *));
         tmptp = ts->textpath;
         ts->textpath = NULL;
-        lfr->follow_labels[lfr->num_follow_labels - 1] = msSmallMalloc(sizeof(textSymbolObj));
+        lfr->follow_labels[lfr->num_follow_labels - 1] =
+            msSmallMalloc(sizeof(textSymbolObj));
         tsnew = lfr->follow_labels[lfr->num_follow_labels - 1];
         initTextSymbol(tsnew);
-        msCopyTextSymbol(tsnew,ts);
+        msCopyTextSymbol(tsnew, ts);
         ts->textpath = tmptp;
         tsnew->textpath = tp;
         tsnew->textpath->absolute = 1;
       }
-      
+
       cur_label_position += label_buffer;
       retry_offset = 0;
-    } while(retry_offset);
+    } while (retry_offset);
   }
   return MS_SUCCESS;
-
-
 }
 
 /* ===========================================================================
    Pretty printing of primitive objects
    ======================================================================== */
 
-void msRectToFormattedString(rectObj *rect, char *format, char *buffer, int buffer_length)
-{
-  snprintf(buffer, buffer_length, format, rect->minx, rect->miny, rect->maxx, rect->maxy);
+void msRectToFormattedString(rectObj *rect, char *format, char *buffer,
+                             int buffer_length) {
+  snprintf(buffer, buffer_length, format, rect->minx, rect->miny, rect->maxx,
+           rect->maxy);
 }
 
-void msPointToFormattedString(pointObj *point, const char *format, char *buffer, int buffer_length)
-{
-  snprintf(buffer, buffer_length, format, point->x, point->y, point->z, point->m);
+void msPointToFormattedString(pointObj *point, const char *format, char *buffer,
+                              int buffer_length) {
+  snprintf(buffer, buffer_length, format, point->x, point->y, point->z,
+           point->m);
 }
 
 /* Returns true if a shape contains only degenerate parts */
-int msIsDegenerateShape(shapeObj *shape)
-{
+int msIsDegenerateShape(shapeObj *shape) {
   int i;
   int non_degenerate_parts = 0;
-  for(i=0; i<shape->numlines; i++) { /* e.g. part */
+  for (i = 0; i < shape->numlines; i++) { /* e.g. part */
 
     /* skip degenerate parts, really should only happen with pixel output */
-    if((shape->type == MS_SHAPE_LINE && shape->line[i].numpoints < 2) ||
+    if ((shape->type == MS_SHAPE_LINE && shape->line[i].numpoints < 2) ||
         (shape->type == MS_SHAPE_POLYGON && shape->line[i].numpoints < 3))
       continue;
 
     non_degenerate_parts++;
   }
-  return( non_degenerate_parts == 0 );
+  return (non_degenerate_parts == 0);
 }
 
 shapeObj *msRings2Shape(shapeObj *shape, int outer) {
   shapeObj *shape2;
-  int i, rv, *outerList=NULL;
+  int i, rv, *outerList = NULL;
 
-  if(!shape) return NULL;
-  if(shape->type != MS_SHAPE_POLYGON) return NULL;
+  if (!shape)
+    return NULL;
+  if (shape->type != MS_SHAPE_POLYGON)
+    return NULL;
 
-  outer = (outer)?1:0; // set explicitly to 1 or 0
+  outer = (outer) ? 1 : 0; // set explicitly to 1 or 0
 
-  shape2 = (shapeObj *) malloc(sizeof(shapeObj));
+  shape2 = (shapeObj *)malloc(sizeof(shapeObj));
   MS_CHECK_ALLOC(shape2, sizeof(shapeObj), NULL);
   msInitShape(shape2);
   shape2->type = shape->type;
 
   outerList = msGetOuterList(shape);
-  if(!outerList) {
+  if (!outerList) {
     msFreeShape(shape2);
     free(shape2);
     return NULL;
   }
 
-  for(i=0; i<shape->numlines; i++) {
-    if(outerList[i] == outer) { // else inner
+  for (i = 0; i < shape->numlines; i++) {
+    if (outerList[i] == outer) { // else inner
       rv = msAddLine(shape2, &(shape->line[i]));
-      if(rv != MS_SUCCESS) {
+      if (rv != MS_SUCCESS) {
         msFreeShape(shape2);
         free(shape2);
         free(outerList);
@@ -2385,44 +2565,56 @@ shapeObj *msRings2Shape(shapeObj *shape,
 }
 
 shapeObj *msDensify(shapeObj *shape, double tolerance) {
-  int i, j, k, l; // counters                                                                                                                                                
+  int i, j, k, l; // counters
   int n;
   shapeObj *shape2;
   lineObj line;
   double distance, length, c;
 
-  if(!shape) return NULL;
-  if(shape->type != MS_SHAPE_POLYGON && shape->type != MS_SHAPE_LINE) return NULL;
-  if(tolerance <= 0) return NULL; // must be positive
+  if (!shape)
+    return NULL;
+  if (shape->type != MS_SHAPE_POLYGON && shape->type != MS_SHAPE_LINE)
+    return NULL;
+  if (tolerance <= 0)
+    return NULL; // must be positive
 
-  shape2 = (shapeObj *) malloc(sizeof(shapeObj));
+  shape2 = (shapeObj *)malloc(sizeof(shapeObj));
   MS_CHECK_ALLOC(shape2, sizeof(shapeObj), NULL);
   msInitShape(shape2);
   shape2->type = shape->type; // POLGYON or LINE
 
-  for(i=0; i<shape->numlines; i++) {
+  for (i = 0; i < shape->numlines; i++) {
 
     line.numpoints = shape->line[i].numpoints;
-    line.point = (pointObj *) malloc(sizeof(pointObj)*line.numpoints); // best case we don't have to add any points
-    MS_CHECK_ALLOC(line.point, sizeof(pointObj)*line.numpoints, NULL);
+    line.point = (pointObj *)malloc(
+        sizeof(pointObj) *
+        line.numpoints); // best case we don't have to add any points
+    MS_CHECK_ALLOC(line.point, sizeof(pointObj) * line.numpoints, NULL);
 
-    for(j=0, l=0; j<shape->line[i].numpoints-1; j++, l++) {
+    for (j = 0, l = 0; j < shape->line[i].numpoints - 1; j++, l++) {
       line.point[l] = shape->line[i].point[j];
 
-      distance = msDistancePointToPoint(&(shape->line[i].point[j]), &(shape->line[i].point[j+1]));
-      if(distance > tolerance) {
-        n = (int) floor(distance/tolerance); // number of new points, n+1 is the number of new segments
-        length = distance/(n+1); // segment length
+      distance = msDistancePointToPoint(&(shape->line[i].point[j]),
+                                        &(shape->line[i].point[j + 1]));
+      if (distance > tolerance) {
+        n = (int)floor(distance / tolerance); // number of new points, n+1 is
+                                              // the number of new segments
+        length = distance / (n + 1);          // segment length
 
         line.numpoints += n;
-        line.point = (pointObj *) realloc(line.point, sizeof(pointObj)*line.numpoints);
-        MS_CHECK_ALLOC(line.point, sizeof(pointObj)*line.numpoints, NULL);
+        line.point =
+            (pointObj *)realloc(line.point, sizeof(pointObj) * line.numpoints);
+        MS_CHECK_ALLOC(line.point, sizeof(pointObj) * line.numpoints, NULL);
 
-        for(k=0; k<n; k++) {
-          c = (k+1)*length/distance;
+        for (k = 0; k < n; k++) {
+          c = (k + 1) * length / distance;
           l++;
-          line.point[l].x = shape->line[i].point[j].x + c*(shape->line[i].point[j+1].x - shape->line[i].point[j].x);
-          line.point[l].y = shape->line[i].point[j].y + c*(shape->line[i].point[j+1].y - shape->line[i].point[j].y);
+          line.point[l].x =
+              shape->line[i].point[j].x +
+              c * (shape->line[i].point[j + 1].x - shape->line[i].point[j].x);
+          line.point[l].y =
+              shape->line[i].point[j].y +
+              c * (shape->line[i].point[j + 1].y - shape->line[i].point[j].y);
         }
       }
     }
diff -pruN 8.0.1-5/mapprimitive.h 8.0.2-1/mapprimitive.h
--- 8.0.1-5/mapprimitive.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapprimitive.h	2024-06-11 20:41:34.000000000 +0000
@@ -30,10 +30,11 @@
 #ifndef MAPPRIMITIVE_H
 #define MAPPRIMITIVE_H
 
- /**
- A rectObj represents a rectangle or bounding box.
- A rectObj may be a lone object or an attribute of another object and has no other associations.
- */
+/**
+A rectObj represents a rectangle or bounding box.
+A rectObj may be a lone object or an attribute of another object and has no
+other associations.
+*/
 typedef struct {
   double minx; ///< Minimum easting
   double miny; ///< Minimum northing
@@ -76,21 +77,22 @@ typedef struct {
 } lineObj;
 
 /**
-Each feature of a layer's data is a :class:`shapeObj`. Each part of the shape is a closed :class:`lineObj`.
+Each feature of a layer's data is a :class:`shapeObj`. Each part of the shape is
+a closed :class:`lineObj`.
 */
 typedef struct {
 
 #ifndef SWIG
-    lineObj *line;
-    char **values;
-    void *geometry;
-    void *renderer_cache;
+  lineObj *line;
+  char **values;
+  void *geometry;
+  void *renderer_cache;
 #endif
 
 #ifdef SWIG
   %immutable;
 #endif
-  int numlines; ///< Number of parts
+  int numlines;  ///< Number of parts
   int numvalues; ///< Number of shape attributes
 
 #ifdef SWIG
@@ -98,11 +100,12 @@ typedef struct {
 #endif
 
   rectObj bounds; ///< Bounding box of shape
-  int type; ///< MS_SHAPE_POINT, MS_SHAPE_LINE, MS_SHAPE_POLYGON, or MS_SHAPE_NULL
-  long index; ///< Feature index within the layer
-  int tileindex; ///< Index of tiled file for tile-indexed layers
+  int type;       ///< MS_SHAPE_POINT, MS_SHAPE_LINE, MS_SHAPE_POLYGON, or
+                  ///< MS_SHAPE_NULL
+  long index;     ///< Feature index within the layer
+  int tileindex;  ///< Index of tiled file for tile-indexed layers
   int classindex; ///< The class index for features of a classified layer
-  char *text; ///< Shape annotation
+  char *text;     ///< Shape annotation
 
   int scratch;
   int resultindex; ///< Index within a query result set
@@ -123,7 +126,7 @@ typedef struct {
 
 #ifndef SWIG
 typedef struct {
-  int  need_geotransform;
+  int need_geotransform;
   double rotation_angle;
   double geotransform[6];    /* Pixel/line to georef. */
   double invgeotransform[6]; /* georef to pixel/line */
diff -pruN 8.0.1-5/mapproject.c 8.0.2-1/mapproject.c
--- 8.0.1-5/mapproject.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapproject.c	2024-06-11 20:41:34.000000000 +0000
@@ -46,20 +46,18 @@ static unsigned ms_proj_data_change_coun
 #endif
 
 typedef struct LinkedListOfProjContext LinkedListOfProjContext;
-struct LinkedListOfProjContext
-{
-    LinkedListOfProjContext* next;
-    projectionContext* context;
+struct LinkedListOfProjContext {
+  LinkedListOfProjContext *next;
+  projectionContext *context;
 };
 
-static LinkedListOfProjContext* headOfLinkedListOfProjContext = NULL;
-
-static int msTestNeedWrap( pointObj pt1, pointObj pt2, pointObj pt2_geo,
-                           reprojectionObj* reprojector );
+static LinkedListOfProjContext *headOfLinkedListOfProjContext = NULL;
 
+static int msTestNeedWrap(pointObj pt1, pointObj pt2, pointObj pt2_geo,
+                          reprojectionObj *reprojector);
 
-static projectionContext* msProjectionContextCreate(void);
-static void msProjectionContextUnref(projectionContext* ctx);
+static projectionContext *msProjectionContextCreate(void);
+static void msProjectionContextUnref(projectionContext *ctx);
 
 #if PROJ_VERSION_MAJOR >= 6
 
@@ -70,20 +68,18 @@ static void msProjectionContextUnref(pro
 /* output SRS */
 #define PJ_CACHE_ENTRY_SIZE 32
 
-typedef struct
-{
-    char* inStr;
-    char* outStr;
-    PJ* pj;
+typedef struct {
+  char *inStr;
+  char *outStr;
+  PJ *pj;
 } pjCacheEntry;
 
-struct projectionContext
-{
-    PJ_CONTEXT* proj_ctx;
-    unsigned ms_proj_data_change_counter;
-    int ref_count;
-    pjCacheEntry pj_cache[PJ_CACHE_ENTRY_SIZE];
-    int pj_cache_size;
+struct projectionContext {
+  PJ_CONTEXT *proj_ctx;
+  unsigned ms_proj_data_change_counter;
+  int ref_count;
+  pjCacheEntry pj_cache[PJ_CACHE_ENTRY_SIZE];
+  int pj_cache_size;
 };
 
 /************************************************************************/
@@ -91,39 +87,33 @@ struct projectionContext
 /************************************************************************/
 
 static int msProjectHasLonWrapOrOver(projectionObj *in) {
-    int i;
-    for( i = 0; i < in->numargs; i++ )
-    {
-        if( strncmp(in->args[i], "lon_wrap=", strlen("lon_wrap=")) == 0 ||
-            strcmp(in->args[i], "+over") == 0 ||
-            strcmp(in->args[i], "over") == 0 )
-        {
-            return MS_TRUE;
-        }
+  int i;
+  for (i = 0; i < in->numargs; i++) {
+    if (strncmp(in->args[i], "lon_wrap=", strlen("lon_wrap=")) == 0 ||
+        strcmp(in->args[i], "+over") == 0 || strcmp(in->args[i], "over") == 0) {
+      return MS_TRUE;
     }
-    return MS_FALSE;
+  }
+  return MS_FALSE;
 }
 
-static char* getStringFromArgv(int argc, char** args)
-{
-    int i;
-    int len = 0;
-    for( i = 0; i < argc; i++ )
-    {
-        len += strlen(args[i]) + 1;
-    }
-    char* str = msSmallMalloc(len + 1);
-    len = 0;
-    for( i = 0; i < argc; i++ )
-    {
-        size_t arglen = strlen(args[i]);
-        memcpy(str + len, args[i], arglen);
-        len += arglen;
-        str[len] = ' ';
-        len ++;
-    }
-    str[len] = 0;
-    return str;
+static char *getStringFromArgv(int argc, char **args) {
+  int i;
+  int len = 0;
+  for (i = 0; i < argc; i++) {
+    len += strlen(args[i]) + 1;
+  }
+  char *str = msSmallMalloc(len + 1);
+  len = 0;
+  for (i = 0; i < argc; i++) {
+    size_t arglen = strlen(args[i]);
+    memcpy(str + len, args[i], arglen);
+    len += arglen;
+    str[len] = ' ';
+    len++;
+  }
+  str[len] = 0;
+  return str;
 }
 
 /************************************************************************/
@@ -131,174 +121,170 @@ static char* getStringFromArgv(int argc,
 /************************************************************************/
 
 /* Return to be freed with proj_destroy() if *pbFreePJ = TRUE */
-static PJ* createNormalizedPJ(projectionObj *in, projectionObj *out, int* pbFreePJ)
-{
-    if( in->proj == out->proj )
-    {
-        /* Special case to avoid out_str below to cause in_str to become invalid */
-        *pbFreePJ = TRUE;
+static PJ *createNormalizedPJ(projectionObj *in, projectionObj *out,
+                              int *pbFreePJ) {
+  if (in->proj == out->proj) {
+    /* Special case to avoid out_str below to cause in_str to become invalid */
+    *pbFreePJ = TRUE;
 #if PROJ_VERSION_MAJOR == 6 && PROJ_VERSION_MINOR == 0
-        /* 6.0 didn't support proj=noop */
-        return proj_create(in->proj_ctx->proj_ctx, "+proj=affine");
+    /* 6.0 didn't support proj=noop */
+    return proj_create(in->proj_ctx->proj_ctx, "+proj=affine");
 #else
-        return proj_create(in->proj_ctx->proj_ctx, "+proj=noop");
+    return proj_create(in->proj_ctx->proj_ctx, "+proj=noop");
 #endif
-    }
+  }
 
-    const char* const wkt_options[] = { "MULTILINE=NO", NULL };
-    const char* in_str = msProjectHasLonWrapOrOver(in) ?
-        proj_as_proj_string(in->proj_ctx->proj_ctx, in->proj, PJ_PROJ_4, NULL) :
-        proj_as_wkt(in->proj_ctx->proj_ctx, in->proj, PJ_WKT2_2018, wkt_options);
-    const char* out_str = msProjectHasLonWrapOrOver(out) ?
-        proj_as_proj_string(out->proj_ctx->proj_ctx, out->proj, PJ_PROJ_4, NULL) :
-        proj_as_wkt(out->proj_ctx->proj_ctx, out->proj, PJ_WKT2_2018, wkt_options);
-    PJ* pj_raw;
-    PJ* pj_normalized;
-    if( !in_str || !out_str )
-        return NULL;
-    char* in_str_for_cache = getStringFromArgv(in->numargs, in->args);
-    char* out_str_for_cache = getStringFromArgv(out->numargs, out->args);
+  const char *const wkt_options[] = {"MULTILINE=NO", NULL};
+  const char *in_str = msProjectHasLonWrapOrOver(in)
+                           ? proj_as_proj_string(in->proj_ctx->proj_ctx,
+                                                 in->proj, PJ_PROJ_4, NULL)
+                           : proj_as_wkt(in->proj_ctx->proj_ctx, in->proj,
+                                         PJ_WKT2_2018, wkt_options);
+  const char *out_str = msProjectHasLonWrapOrOver(out)
+                            ? proj_as_proj_string(out->proj_ctx->proj_ctx,
+                                                  out->proj, PJ_PROJ_4, NULL)
+                            : proj_as_wkt(out->proj_ctx->proj_ctx, out->proj,
+                                          PJ_WKT2_2018, wkt_options);
+  PJ *pj_raw;
+  PJ *pj_normalized;
+  if (!in_str || !out_str)
+    return NULL;
+  char *in_str_for_cache = getStringFromArgv(in->numargs, in->args);
+  char *out_str_for_cache = getStringFromArgv(out->numargs, out->args);
 
-    if( in->proj_ctx->proj_ctx == out->proj_ctx->proj_ctx )
-    {
-        int i;
-        pjCacheEntry* pj_cache = in->proj_ctx->pj_cache;
-        for( i = 0; i < in->proj_ctx->pj_cache_size; i++ )
-        {
-            if (strcmp(pj_cache[i].inStr, in_str_for_cache) == 0 &&
-                strcmp(pj_cache[i].outStr, out_str_for_cache) == 0 )
-            {
-                PJ* ret = pj_cache[i].pj;
-                if( i != 0 )
-                {
-                    /* Move entry to top */
-                    pjCacheEntry tmp;
-                    memcpy(&tmp, &pj_cache[i], sizeof(pjCacheEntry));
-                    memmove(&pj_cache[1], &pj_cache[0], i * sizeof(pjCacheEntry));
-                    memcpy(&pj_cache[0], &tmp, sizeof(pjCacheEntry));
-                }
+  if (in->proj_ctx->proj_ctx == out->proj_ctx->proj_ctx) {
+    int i;
+    pjCacheEntry *pj_cache = in->proj_ctx->pj_cache;
+    for (i = 0; i < in->proj_ctx->pj_cache_size; i++) {
+      if (strcmp(pj_cache[i].inStr, in_str_for_cache) == 0 &&
+          strcmp(pj_cache[i].outStr, out_str_for_cache) == 0) {
+        PJ *ret = pj_cache[i].pj;
+        if (i != 0) {
+          /* Move entry to top */
+          pjCacheEntry tmp;
+          memcpy(&tmp, &pj_cache[i], sizeof(pjCacheEntry));
+          memmove(&pj_cache[1], &pj_cache[0], i * sizeof(pjCacheEntry));
+          memcpy(&pj_cache[0], &tmp, sizeof(pjCacheEntry));
+        }
 #ifdef notdef
-                fprintf(stderr, "cache hit!\n");
+        fprintf(stderr, "cache hit!\n");
 #endif
-                *pbFreePJ = FALSE;
-                msFree(in_str_for_cache);
-                msFree(out_str_for_cache);
-                return ret;
-            }
-        }
+        *pbFreePJ = FALSE;
+        msFree(in_str_for_cache);
+        msFree(out_str_for_cache);
+        return ret;
+      }
     }
+  }
 
 #ifdef notdef
-    fprintf(stderr, "%s -> %s\n", in_str, out_str);
-    fprintf(stderr, "%p -> %p\n", in->proj_ctx->proj_ctx, out->proj_ctx->proj_ctx);
-    fprintf(stderr, "cache miss!\n");
+  fprintf(stderr, "%s -> %s\n", in_str, out_str);
+  fprintf(stderr, "%p -> %p\n", in->proj_ctx->proj_ctx,
+          out->proj_ctx->proj_ctx);
+  fprintf(stderr, "cache miss!\n");
 #endif
 
 #if PROJ_VERSION_MAJOR == 6 && PROJ_VERSION_MINOR < 2
-    if( strstr(in_str, "+proj=") && strstr(in_str, "+over") &&
-        strstr(out_str, "+proj=") && strstr(out_str, "+over") &&
-        strlen(in_str) < 400 && strlen(out_str) < 400 )
-    {
-        // Fixed per PROJ commit
-        // https://github.com/OSGeo/PROJ/commit/78302efb70eb4b49610cda6a60bf9ce39b82264f
-        // and
-        // https://github.com/OSGeo/PROJ/commit/ae70b26b9cbae85a38d5b26533ba06da0ea13940
-        // Fix for wcs_get_capabilities_tileindexmixedsrs_26711.xml and wcs_20_getcov_bands_name_new_reproject.dat
-        char szPipeline[1024];
-        strcpy(szPipeline, "+proj=pipeline");
-        if( msProjIsGeographicCRS(in) )
-        {
-            strcat(szPipeline, " +step +proj=unitconvert +xy_in=deg +xy_out=rad");
-        }
-        strcat(szPipeline, " +step +inv ");
-        strcat(szPipeline, in_str);
-        strcat(szPipeline, " +step ");
-        strcat(szPipeline, out_str);
-        if( msProjIsGeographicCRS(out) )
-        {
-            strcat(szPipeline, " +step +proj=unitconvert +xy_in=rad +xy_out=deg");
-        }
-        /* We do not want datum=NAD83 to imply a transformation with towgs84=0,0,0 */
-        {
-            char* ptr = szPipeline;
-            while(1)
-            {
-                ptr = strstr(ptr, " +datum=NAD83");
-                if( !ptr )
-                    break;
-                memcpy(ptr, " +ellps=GRS80", 13);
-            }
-        }
-
-        /* Remove +nadgrids=@null as it doesn't work if going outside of [-180,180] */
-        /* Fixed per https://github.com/OSGeo/PROJ/commit/10a30bb539be1afb25952b19af8bbe72e1b13b56 */
-        {
-            char* ptr = strstr(szPipeline, " +nadgrids=@null");
-            if( ptr )
-                memcpy(ptr, "                ", 16);
-        }
+  if (strstr(in_str, "+proj=") && strstr(in_str, "+over") &&
+      strstr(out_str, "+proj=") && strstr(out_str, "+over") &&
+      strlen(in_str) < 400 && strlen(out_str) < 400) {
+    // Fixed per PROJ commit
+    // https://github.com/OSGeo/PROJ/commit/78302efb70eb4b49610cda6a60bf9ce39b82264f
+    // and
+    // https://github.com/OSGeo/PROJ/commit/ae70b26b9cbae85a38d5b26533ba06da0ea13940
+    // Fix for wcs_get_capabilities_tileindexmixedsrs_26711.xml and
+    // wcs_20_getcov_bands_name_new_reproject.dat
+    char szPipeline[1024];
+    strcpy(szPipeline, "+proj=pipeline");
+    if (msProjIsGeographicCRS(in)) {
+      strcat(szPipeline, " +step +proj=unitconvert +xy_in=deg +xy_out=rad");
+    }
+    strcat(szPipeline, " +step +inv ");
+    strcat(szPipeline, in_str);
+    strcat(szPipeline, " +step ");
+    strcat(szPipeline, out_str);
+    if (msProjIsGeographicCRS(out)) {
+      strcat(szPipeline, " +step +proj=unitconvert +xy_in=rad +xy_out=deg");
+    }
+    /* We do not want datum=NAD83 to imply a transformation with towgs84=0,0,0
+     */
+    {
+      char *ptr = szPipeline;
+      while (1) {
+        ptr = strstr(ptr, " +datum=NAD83");
+        if (!ptr)
+          break;
+        memcpy(ptr, " +ellps=GRS80", 13);
+      }
+    }
 
-        pj_normalized = proj_create(in->proj_ctx->proj_ctx, szPipeline);
+    /* Remove +nadgrids=@null as it doesn't work if going outside of [-180,180]
+     */
+    /* Fixed per
+     * https://github.com/OSGeo/PROJ/commit/10a30bb539be1afb25952b19af8bbe72e1b13b56
+     */
+    {
+      char *ptr = strstr(szPipeline, " +nadgrids=@null");
+      if (ptr)
+        memcpy(ptr, "                ", 16);
     }
-    else
+
+    pj_normalized = proj_create(in->proj_ctx->proj_ctx, szPipeline);
+  } else
 #endif
-    {
-#if PROJ_VERSION_MAJOR > 6 || (PROJ_VERSION_MAJOR == 6 && PROJ_VERSION_MINOR >= 2)
-        pj_raw = proj_create_crs_to_crs_from_pj(in->proj_ctx->proj_ctx, in->proj, out->proj, NULL, NULL);
+  {
+#if PROJ_VERSION_MAJOR > 6 ||                                                  \
+    (PROJ_VERSION_MAJOR == 6 && PROJ_VERSION_MINOR >= 2)
+    pj_raw = proj_create_crs_to_crs_from_pj(in->proj_ctx->proj_ctx, in->proj,
+                                            out->proj, NULL, NULL);
 #else
-        pj_raw = proj_create_crs_to_crs(in->proj_ctx->proj_ctx, in_str, out_str, NULL);
+    pj_raw =
+        proj_create_crs_to_crs(in->proj_ctx->proj_ctx, in_str, out_str, NULL);
 #endif
-        if( !pj_raw )
-        {
-            msFree(in_str_for_cache);
-            msFree(out_str_for_cache);
-            return NULL;
-        }
-        pj_normalized = proj_normalize_for_visualization(in->proj_ctx->proj_ctx, pj_raw);
-        proj_destroy(pj_raw);
-    }
-    if( !pj_normalized )
-    {
-        msFree(in_str_for_cache);
-        msFree(out_str_for_cache);
-        return NULL;
-    }
-
-    if( in->proj_ctx->proj_ctx == out->proj_ctx->proj_ctx )
-    {
-        /* Insert entry into cache */
-        int i;
-        pjCacheEntry* pj_cache = in->proj_ctx->pj_cache;
-        if( in->proj_ctx->pj_cache_size < PJ_CACHE_ENTRY_SIZE )
-        {
-            i = in->proj_ctx->pj_cache_size;
-            assert ( pj_cache[i].inStr == NULL );
-            in->proj_ctx->pj_cache_size ++;
-        }
-        else
-        {
-            i = 0;
-            /* Evict oldest entry */
-            msFree(pj_cache[PJ_CACHE_ENTRY_SIZE - 1].inStr);
-            msFree(pj_cache[PJ_CACHE_ENTRY_SIZE - 1].outStr);
-            proj_destroy(pj_cache[PJ_CACHE_ENTRY_SIZE - 1].pj);
-            memmove(&pj_cache[1], &pj_cache[0],
-                    (PJ_CACHE_ENTRY_SIZE - 1) * sizeof(pjCacheEntry));
-        }
-        pj_cache[i].inStr = msStrdup(in_str_for_cache);
-        pj_cache[i].outStr = msStrdup(out_str_for_cache);
-        pj_cache[i].pj = pj_normalized;
-        *pbFreePJ = FALSE;
-    }
-    else
-    {
-        *pbFreePJ = TRUE;
-    }
-
+    if (!pj_raw) {
+      msFree(in_str_for_cache);
+      msFree(out_str_for_cache);
+      return NULL;
+    }
+    pj_normalized =
+        proj_normalize_for_visualization(in->proj_ctx->proj_ctx, pj_raw);
+    proj_destroy(pj_raw);
+  }
+  if (!pj_normalized) {
     msFree(in_str_for_cache);
     msFree(out_str_for_cache);
+    return NULL;
+  }
 
-    return pj_normalized;
+  if (in->proj_ctx->proj_ctx == out->proj_ctx->proj_ctx) {
+    /* Insert entry into cache */
+    int i;
+    pjCacheEntry *pj_cache = in->proj_ctx->pj_cache;
+    if (in->proj_ctx->pj_cache_size < PJ_CACHE_ENTRY_SIZE) {
+      i = in->proj_ctx->pj_cache_size;
+      assert(pj_cache[i].inStr == NULL);
+      in->proj_ctx->pj_cache_size++;
+    } else {
+      i = 0;
+      /* Evict oldest entry */
+      msFree(pj_cache[PJ_CACHE_ENTRY_SIZE - 1].inStr);
+      msFree(pj_cache[PJ_CACHE_ENTRY_SIZE - 1].outStr);
+      proj_destroy(pj_cache[PJ_CACHE_ENTRY_SIZE - 1].pj);
+      memmove(&pj_cache[1], &pj_cache[0],
+              (PJ_CACHE_ENTRY_SIZE - 1) * sizeof(pjCacheEntry));
+    }
+    pj_cache[i].inStr = msStrdup(in_str_for_cache);
+    pj_cache[i].outStr = msStrdup(out_str_for_cache);
+    pj_cache[i].pj = pj_normalized;
+    *pbFreePJ = FALSE;
+  } else {
+    *pbFreePJ = TRUE;
+  }
+
+  msFree(in_str_for_cache);
+  msFree(out_str_for_cache);
+
+  return pj_normalized;
 }
 
 /************************************************************************/
@@ -306,219 +292,205 @@ static PJ* createNormalizedPJ(projection
 /************************************************************************/
 
 /* Return to be freed with proj_destroy() */
-static PJ* getBaseGeographicCRS(projectionObj* in)
-{
-    PJ_CONTEXT* ctxt;
-    PJ_TYPE type;
-    assert(in && in->proj);
-    ctxt = in->proj_ctx->proj_ctx;
-    type = proj_get_type(in->proj);
-    if( type == PJ_TYPE_PROJECTED_CRS )
-    {
-        return proj_get_source_crs(ctxt, in->proj);
-    }
-    if( type == PJ_TYPE_BOUND_CRS )
-    {
-        /* If it is a boundCRS of a projectedCRS, extract the geographicCRS
-         * from the projectedCRS, and rewrap it in a boundCRS */
-        PJ* source_crs = proj_get_source_crs(ctxt, in->proj);
-        PJ* geog_source_crs;
-        PJ* hub_crs;
-        PJ* transf;
-        PJ* ret;
-        if( proj_get_type(source_crs) != PJ_TYPE_PROJECTED_CRS )
-        {
-            proj_destroy(source_crs);
-            return NULL;
-        }
-        geog_source_crs = proj_get_source_crs(ctxt, source_crs);
-        proj_destroy(source_crs);
-        hub_crs = proj_get_target_crs(ctxt, in->proj);
-        transf = proj_crs_get_coordoperation(ctxt, in->proj);
-        ret = proj_crs_create_bound_crs(ctxt, geog_source_crs,
-                                        hub_crs, transf);
-        proj_destroy(geog_source_crs);
-        proj_destroy(hub_crs);
-        proj_destroy(transf);
-        return ret;
-
-    }
-    return NULL;
+static PJ *getBaseGeographicCRS(projectionObj *in) {
+  PJ_CONTEXT *ctxt;
+  PJ_TYPE type;
+  assert(in && in->proj);
+  ctxt = in->proj_ctx->proj_ctx;
+  type = proj_get_type(in->proj);
+  if (type == PJ_TYPE_PROJECTED_CRS) {
+    return proj_get_source_crs(ctxt, in->proj);
+  }
+  if (type == PJ_TYPE_BOUND_CRS) {
+    /* If it is a boundCRS of a projectedCRS, extract the geographicCRS
+     * from the projectedCRS, and rewrap it in a boundCRS */
+    PJ *source_crs = proj_get_source_crs(ctxt, in->proj);
+    PJ *geog_source_crs;
+    PJ *hub_crs;
+    PJ *transf;
+    PJ *ret;
+    if (proj_get_type(source_crs) != PJ_TYPE_PROJECTED_CRS) {
+      proj_destroy(source_crs);
+      return NULL;
+    }
+    geog_source_crs = proj_get_source_crs(ctxt, source_crs);
+    proj_destroy(source_crs);
+    hub_crs = proj_get_target_crs(ctxt, in->proj);
+    transf = proj_crs_get_coordoperation(ctxt, in->proj);
+    ret = proj_crs_create_bound_crs(ctxt, geog_source_crs, hub_crs, transf);
+    proj_destroy(geog_source_crs);
+    proj_destroy(hub_crs);
+    proj_destroy(transf);
+    return ret;
+  }
+  return NULL;
 }
 
 /************************************************************************/
 /*                          msProjErrorLogger()                         */
 /************************************************************************/
 
-static void msProjErrorLogger(void * user_data,
-                             int level, const char * message)
-{
-    (void)user_data;
-#if PROJ_VERSION_MAJOR >= 6    
-    if( level == PJ_LOG_ERROR && msGetGlobalDebugLevel() >= MS_DEBUGLEVEL_VV )
+static void msProjErrorLogger(void *user_data, int level, const char *message) {
+  (void)user_data;
+#if PROJ_VERSION_MAJOR >= 6
+  if (level == PJ_LOG_ERROR && msGetGlobalDebugLevel() >= MS_DEBUGLEVEL_VV)
 #else
-    if( level == PJ_LOG_ERROR )
+  if (level == PJ_LOG_ERROR)
 #endif
-    {
-        msDebug( "PROJ: Error: %s\n", message );
-    }
-    else if( level == PJ_LOG_DEBUG )
-    {
-        msDebug( "PROJ: Debug: %s\n", message );
-    }
+  {
+    msDebug("PROJ: Error: %s\n", message);
+  } else if (level == PJ_LOG_DEBUG) {
+    msDebug("PROJ: Debug: %s\n", message);
+  }
 }
 
 /************************************************************************/
 /*                        msProjectionContextCreate()                   */
 /************************************************************************/
 
-projectionContext* msProjectionContextCreate(void)
-{
-    projectionContext* ctx = (projectionContext*)msSmallCalloc(1, sizeof(projectionContext));
-    ctx->proj_ctx = proj_context_create();
-    if( ctx->proj_ctx == NULL )
-    {
-        msFree(ctx);
-        return NULL;
-    }
-    ctx->ref_count = 1;
-    proj_context_use_proj4_init_rules(ctx->proj_ctx, TRUE);
-    proj_log_func (ctx->proj_ctx, NULL, msProjErrorLogger);
-    return ctx;
+projectionContext *msProjectionContextCreate(void) {
+  projectionContext *ctx =
+      (projectionContext *)msSmallCalloc(1, sizeof(projectionContext));
+  ctx->proj_ctx = proj_context_create();
+  if (ctx->proj_ctx == NULL) {
+    msFree(ctx);
+    return NULL;
+  }
+  ctx->ref_count = 1;
+  proj_context_use_proj4_init_rules(ctx->proj_ctx, TRUE);
+  proj_log_func(ctx->proj_ctx, NULL, msProjErrorLogger);
+  return ctx;
 }
 
 /************************************************************************/
 /*                        msProjectionContextUnref()                    */
 /************************************************************************/
 
-void msProjectionContextUnref(projectionContext* ctx)
-{
-    if( !ctx )
-        return;
-    --ctx->ref_count;
-    if( ctx->ref_count == 0 )
-    {
-        int i;
-        for( i = 0; i < ctx->pj_cache_size; i++ )
-        {
-            msFree(ctx->pj_cache[i].inStr);
-            msFree(ctx->pj_cache[i].outStr);
-            proj_destroy(ctx->pj_cache[i].pj);
-        }
-        proj_context_destroy(ctx->proj_ctx);
-        msFree(ctx);
+void msProjectionContextUnref(projectionContext *ctx) {
+  if (!ctx)
+    return;
+  --ctx->ref_count;
+  if (ctx->ref_count == 0) {
+    int i;
+    for (i = 0; i < ctx->pj_cache_size; i++) {
+      msFree(ctx->pj_cache[i].inStr);
+      msFree(ctx->pj_cache[i].outStr);
+      proj_destroy(ctx->pj_cache[i].pj);
     }
+    proj_context_destroy(ctx->proj_ctx);
+    msFree(ctx);
+  }
 }
 
 /************************************************************************/
 /*                        msProjectCreateReprojector()                  */
 /************************************************************************/
 
-reprojectionObj* msProjectCreateReprojector(projectionObj* in, projectionObj* out)
-{
-    reprojectionObj* obj = (reprojectionObj*)msSmallCalloc(1, sizeof(reprojectionObj));
-    obj->in = in;
-    obj->out = out;
-    obj->lineCuttingCase = LINE_CUTTING_UNKNOWN;
+/* The pointed objects need to remain valid during the lifetime of the
+ * reprojector, as only their pointer is stored.
+ *
+ * If the *content* of in and/or out is changed, then the reprojector is
+ * no longer valid. This can be detected with msProjectIsReprojectorStillValid()
+ */
+reprojectionObj *msProjectCreateReprojector(projectionObj *in,
+                                            projectionObj *out) {
+  reprojectionObj *obj =
+      (reprojectionObj *)msSmallCalloc(1, sizeof(reprojectionObj));
+  obj->in = in;
+  obj->out = out;
+  obj->generation_number_in = in ? in->generation_number : 0;
+  obj->generation_number_out = out ? out->generation_number : 0;
+  obj->lineCuttingCase = LINE_CUTTING_UNKNOWN;
 
-    /* -------------------------------------------------------------------- */
-    /*      If the source and destination are simple and equal, then do     */
-    /*      nothing.                                                        */
-    /* -------------------------------------------------------------------- */
-    if( in && in->numargs == 1 && out && out->numargs == 1
-        && strcmp(in->args[0],out->args[0]) == 0 ) {
-        /* do nothing, no transformation required */
-    }
-    /* -------------------------------------------------------------------- */
-    /*      If we have a fully defined input coordinate system and          */
-    /*      output coordinate system, then we will use createNormalizedPJ   */
-    /* -------------------------------------------------------------------- */
-    else if( in && in->proj && out && out->proj ) {
-        PJ* pj = createNormalizedPJ(in, out, &(obj->bFreePJ));
-        if( !pj )
-        {
-            msFree(obj);
-            return NULL;
-        }
-        obj->pj = pj;
+  /* -------------------------------------------------------------------- */
+  /*      If the source and destination are simple and equal, then do     */
+  /*      nothing.                                                        */
+  /* -------------------------------------------------------------------- */
+  if (in && in->numargs == 1 && out && out->numargs == 1 &&
+      strcmp(in->args[0], out->args[0]) == 0) {
+    /* do nothing, no transformation required */
+  }
+  /* -------------------------------------------------------------------- */
+  /*      If we have a fully defined input coordinate system and          */
+  /*      output coordinate system, then we will use createNormalizedPJ   */
+  /* -------------------------------------------------------------------- */
+  else if (in && in->proj && out && out->proj) {
+    PJ *pj = createNormalizedPJ(in, out, &(obj->bFreePJ));
+    if (!pj) {
+      msFree(obj);
+      return NULL;
     }
+    obj->pj = pj;
+  }
 
-    /* nothing to do if the other coordinate system is also lat/long */
-    else if( (in == NULL || in->proj == NULL) &&
-             (out == NULL || out->proj == NULL || msProjIsGeographicCRS(out) ))
-    {
-        /* do nothing */
-    }
-    else if( out == NULL && in != NULL && msProjIsGeographicCRS(in) )
-    {
-        /* do nothing */
-    }
+  /* nothing to do if the other coordinate system is also lat/long */
+  else if ((in == NULL || in->proj == NULL) &&
+           (out == NULL || out->proj == NULL || msProjIsGeographicCRS(out))) {
+    /* do nothing */
+  } else if (out == NULL && in != NULL && msProjIsGeographicCRS(in)) {
+    /* do nothing */
+  }
 
-    /* -------------------------------------------------------------------- */
-    /*      Otherwise we assume that the NULL projectionObj is supposed to be */
-    /*      lat/long in the same datum as the other projectionObj.  This    */
-    /*      is essentially a backwards compatibility mode.                  */
-    /* -------------------------------------------------------------------- */
-    else {
-        PJ* pj = NULL;
+  /* -------------------------------------------------------------------- */
+  /*      Otherwise we assume that the NULL projectionObj is supposed to be */
+  /*      lat/long in the same datum as the other projectionObj.  This    */
+  /*      is essentially a backwards compatibility mode.                  */
+  /* -------------------------------------------------------------------- */
+  else {
+    PJ *pj = NULL;
 
-        if( (in==NULL || in->proj==NULL) && out && out->proj) { /* input coordinates are lat/lon */
-            PJ* source_crs = getBaseGeographicCRS(out);
-            projectionObj in_modified;
-            memset(&in_modified, 0, sizeof(in_modified));
-
-            in_modified.proj_ctx = out->proj_ctx;
-            in_modified.proj = source_crs;
-            pj = createNormalizedPJ(&in_modified, out, &(obj->bFreePJ));
-            proj_destroy(source_crs);
-        } else if( /* (out==NULL || out->proj==NULL) && */ in && in->proj )  {
-            PJ* target_crs = getBaseGeographicCRS(in);
-            projectionObj out_modified;
-            memset(&out_modified, 0, sizeof(out_modified));
-
-            out_modified.proj_ctx = in->proj_ctx;
-            out_modified.proj = target_crs;
-            pj = createNormalizedPJ(in, &out_modified, &(obj->bFreePJ));
-            proj_destroy(target_crs);
-        }
-        if( !pj )
-        {
-            msFree(obj);
-            return NULL;
-        }
-        obj->pj = pj;
+    if ((in == NULL || in->proj == NULL) && out &&
+        out->proj) { /* input coordinates are lat/lon */
+      PJ *source_crs = getBaseGeographicCRS(out);
+      projectionObj in_modified;
+      memset(&in_modified, 0, sizeof(in_modified));
+
+      in_modified.proj_ctx = out->proj_ctx;
+      in_modified.proj = source_crs;
+      pj = createNormalizedPJ(&in_modified, out, &(obj->bFreePJ));
+      proj_destroy(source_crs);
+    } else if (/* (out==NULL || out->proj==NULL) && */ in && in->proj) {
+      PJ *target_crs = getBaseGeographicCRS(in);
+      projectionObj out_modified;
+      memset(&out_modified, 0, sizeof(out_modified));
+
+      out_modified.proj_ctx = in->proj_ctx;
+      out_modified.proj = target_crs;
+      pj = createNormalizedPJ(in, &out_modified, &(obj->bFreePJ));
+      proj_destroy(target_crs);
+    }
+    if (!pj) {
+      msFree(obj);
+      return NULL;
     }
+    obj->pj = pj;
+  }
 
-    return obj;
+  return obj;
 }
 
 /************************************************************************/
 /*                      msProjectDestroyReprojector()                   */
 /************************************************************************/
 
-void msProjectDestroyReprojector(reprojectionObj* reprojector)
-{
-    if( !reprojector )
-        return;
-    if( reprojector->bFreePJ )
-        proj_destroy(reprojector->pj);
-    msFreeShape(&(reprojector->splitShape));
-    msFree(reprojector);
+void msProjectDestroyReprojector(reprojectionObj *reprojector) {
+  if (!reprojector)
+    return;
+  if (reprojector->bFreePJ)
+    proj_destroy(reprojector->pj);
+  msFreeShape(&(reprojector->splitShape));
+  msFree(reprojector);
 }
 
 /************************************************************************/
 /*                       msProjectTransformPoints()                     */
 /************************************************************************/
 
-int msProjectTransformPoints( reprojectionObj* reprojector,
-                              int npoints, double* x, double* y )
-{
-    proj_trans_generic (reprojector->pj, PJ_FWD,
-                        x, sizeof(double), npoints,
-                        y, sizeof(double), npoints,
-                        NULL, 0, 0,
-                        NULL, 0, 0 );
-    return MS_SUCCESS;
+int msProjectTransformPoints(reprojectionObj *reprojector, int npoints,
+                             double *x, double *y) {
+  proj_trans_generic(reprojector->pj, PJ_FWD, x, sizeof(double), npoints, y,
+                     sizeof(double), npoints, NULL, 0, 0, NULL, 0, 0);
+  return MS_SUCCESS;
 }
 
 #else
@@ -527,84 +499,72 @@ int msProjectTransformPoints( reprojecti
 /*                        msProjectionContextCreate()                   */
 /************************************************************************/
 
-projectionContext* msProjectionContextCreate(void)
-{
-    return NULL;
-}
+projectionContext *msProjectionContextCreate(void) { return NULL; }
 
 /************************************************************************/
 /*                        msProjectionContextUnref()                    */
 /************************************************************************/
 
-void msProjectionContextUnref(projectionContext* ctx)
-{
-    (void)ctx;
-}
+void msProjectionContextUnref(projectionContext *ctx) { (void)ctx; }
 
 /************************************************************************/
 /*                        msProjectCreateReprojector()                  */
 /************************************************************************/
 
-reprojectionObj* msProjectCreateReprojector(projectionObj* in, projectionObj* out)
-{
-    reprojectionObj* obj;
-    obj = (reprojectionObj*)msSmallCalloc(1, sizeof(reprojectionObj));
-    obj->in = in;
-    obj->out = out;
-    obj->lineCuttingCase = LINE_CUTTING_UNKNOWN;
+reprojectionObj *msProjectCreateReprojector(projectionObj *in,
+                                            projectionObj *out) {
+  reprojectionObj *obj;
+  obj = (reprojectionObj *)msSmallCalloc(1, sizeof(reprojectionObj));
+  obj->in = in;
+  obj->out = out;
+  obj->generation_number_in = in ? in->generation_number : 0;
+  obj->generation_number_out = out ? out->generation_number : 0;
+  obj->lineCuttingCase = LINE_CUTTING_UNKNOWN;
 
-    /* -------------------------------------------------------------------- */
-    /*      If the source and destination are equal, then do nothing.       */
-    /* -------------------------------------------------------------------- */
-    if( in && out && in->numargs == out->numargs && in->numargs > 0
-        && strcmp(in->args[0],out->args[0]) == 0 )
-    {
-        int i;
-        obj->no_op = MS_TRUE;
-        for( i = 1; i < in->numargs; i++ )
-        {
-            if( strcmp(in->args[i],out->args[i]) != 0 ) {
-                obj->no_op = MS_FALSE;
-                break;
-            }
-        }
+  /* -------------------------------------------------------------------- */
+  /*      If the source and destination are equal, then do nothing.       */
+  /* -------------------------------------------------------------------- */
+  if (in && out && in->numargs == out->numargs && in->numargs > 0 &&
+      strcmp(in->args[0], out->args[0]) == 0) {
+    int i;
+    obj->no_op = MS_TRUE;
+    for (i = 1; i < in->numargs; i++) {
+      if (strcmp(in->args[i], out->args[i]) != 0) {
+        obj->no_op = MS_FALSE;
+        break;
+      }
     }
+  }
 
-    /* -------------------------------------------------------------------- */
-    /*      If we have a fully defined input coordinate system and          */
-    /*      output coordinate system, then we will use pj_transform         */
-    /* -------------------------------------------------------------------- */
-    else if( in && in->proj && out && out->proj ) {
-        /* do nothing for now */
-    }
-    /* nothing to do if the other coordinate system is also lat/long */
-    else if( in == NULL && (out == NULL || msProjIsGeographicCRS(out) ))
-    {
-        obj->no_op = MS_TRUE;
-    }
-    else if( out == NULL && in != NULL && msProjIsGeographicCRS(in) )
-    {
-        obj->no_op = MS_TRUE;
-    }
-    else if( (in == NULL || in->proj == NULL) &&
-             (out == NULL || out->proj == NULL) )
-    {
-        msProjectDestroyReprojector(obj);
-        return NULL;
-    }
-    return obj;
+  /* -------------------------------------------------------------------- */
+  /*      If we have a fully defined input coordinate system and          */
+  /*      output coordinate system, then we will use pj_transform         */
+  /* -------------------------------------------------------------------- */
+  else if (in && in->proj && out && out->proj) {
+    /* do nothing for now */
+  }
+  /* nothing to do if the other coordinate system is also lat/long */
+  else if (in == NULL && (out == NULL || msProjIsGeographicCRS(out))) {
+    obj->no_op = MS_TRUE;
+  } else if (out == NULL && in != NULL && msProjIsGeographicCRS(in)) {
+    obj->no_op = MS_TRUE;
+  } else if ((in == NULL || in->proj == NULL) &&
+             (out == NULL || out->proj == NULL)) {
+    msProjectDestroyReprojector(obj);
+    return NULL;
+  }
+  return obj;
 }
 
 /************************************************************************/
 /*                      msProjectDestroyReprojector()                   */
 /************************************************************************/
 
-void msProjectDestroyReprojector(reprojectionObj* reprojector)
-{
-    if( !reprojector )
-        return;
-    msFreeShape(&(reprojector->splitShape));
-    msFree(reprojector);
+void msProjectDestroyReprojector(reprojectionObj *reprojector) {
+  if (!reprojector)
+    return;
+  msFreeShape(&(reprojector->splitShape));
+  msFree(reprojector);
 }
 
 #endif
@@ -612,37 +572,36 @@ void msProjectDestroyReprojector(reproje
 /*
 ** Initialize, load and free a projectionObj structure
 */
-int msInitProjection(projectionObj *p)
-{
+int msInitProjection(projectionObj *p) {
   p->gt.need_geotransform = MS_FALSE;
   p->numargs = 0;
   p->args = NULL;
   p->wellknownprojection = wkp_none;
   p->proj = NULL;
-  p->args = (char **)malloc(MS_MAXPROJARGS*sizeof(char *));
-  MS_CHECK_ALLOC(p->args, MS_MAXPROJARGS*sizeof(char *), -1);
+  p->args = (char **)malloc(MS_MAXPROJARGS * sizeof(char *));
+  MS_CHECK_ALLOC(p->args, MS_MAXPROJARGS * sizeof(char *), -1);
 #if PROJ_VERSION_MAJOR >= 6
   p->proj_ctx = NULL;
 #elif PJ_VERSION >= 480
   p->proj_ctx = NULL;
 #endif
-  return(0);
+  p->generation_number = 0;
+  return (0);
 }
 
-void msFreeProjection(projectionObj *p)
-{
+void msFreeProjection(projectionObj *p) {
 #if PROJ_VERSION_MAJOR >= 6
   proj_destroy(p->proj);
   p->proj = NULL;
   msProjectionContextUnref(p->proj_ctx);
   p->proj_ctx = NULL;
 #else
-  if(p->proj) {
+  if (p->proj) {
     pj_free(p->proj);
     p->proj = NULL;
   }
 #if PJ_VERSION >= 480
-  if(p->proj_ctx) {
+  if (p->proj_ctx) {
     pj_ctx_free(p->proj_ctx);
     p->proj_ctx = NULL;
   }
@@ -654,12 +613,12 @@ void msFreeProjection(projectionObj *p)
   msFreeCharArray(p->args, p->numargs);
   p->args = NULL;
   p->numargs = 0;
+  p->generation_number++;
 }
 
-void msFreeProjectionExceptContext(projectionObj *p)
-{
+void msFreeProjectionExceptContext(projectionObj *p) {
 #if PROJ_VERSION_MAJOR >= 6
-  projectionContext* ctx = p->proj_ctx;
+  projectionContext *ctx = p->proj_ctx;
   p->proj_ctx = NULL;
   msFreeProjection(p);
   p->proj_ctx = ctx;
@@ -672,17 +631,16 @@ void msFreeProjectionExceptContext(proje
 /*                 msProjectionInheritContextFrom()                     */
 /************************************************************************/
 
-void msProjectionInheritContextFrom(projectionObj *pDst, const projectionObj* pSrc)
-{
+void msProjectionInheritContextFrom(projectionObj *pDst,
+                                    const projectionObj *pSrc) {
 #if PROJ_VERSION_MAJOR >= 6
-    if( pDst->proj_ctx == NULL && pSrc->proj_ctx != NULL)
-    {
-        pDst->proj_ctx = pSrc->proj_ctx;
-        pDst->proj_ctx->ref_count ++;
-    }
+  if (pDst->proj_ctx == NULL && pSrc->proj_ctx != NULL) {
+    pDst->proj_ctx = pSrc->proj_ctx;
+    pDst->proj_ctx->ref_count++;
+  }
 #else
-    (void)pDst;
-    (void)pSrc;
+  (void)pDst;
+  (void)pSrc;
 #endif
 }
 
@@ -690,17 +648,15 @@ void msProjectionInheritContextFrom(proj
 /*                      msProjectionSetContext()                        */
 /************************************************************************/
 
-void msProjectionSetContext(projectionObj *p, projectionContext* ctx)
-{
+void msProjectionSetContext(projectionObj *p, projectionContext *ctx) {
 #if PROJ_VERSION_MAJOR >= 6
-    if( p->proj_ctx == NULL && ctx != NULL)
-    {
-        p->proj_ctx = ctx;
-        p->proj_ctx->ref_count ++;
-    }
+  if (p->proj_ctx == NULL && ctx != NULL) {
+    p->proj_ctx = ctx;
+    p->proj_ctx->ref_count++;
+  }
 #else
-    (void)p;
-    (void)ctx;
+  (void)p;
+  (void)ctx;
 #endif
 }
 
@@ -709,37 +665,35 @@ void msProjectionSetContext(projectionOb
 **    "AUTO:proj_id,units_id,lon0,lat0"
 */
 
-static int _msProcessAutoProjection(projectionObj *p)
-{
+static int _msProcessAutoProjection(projectionObj *p) {
   char **args;
   int numargs, nProjId, nUnitsId, nZone;
   double dLat0, dLon0;
   const char *pszUnits = "m";
-  char szProjBuf[512]="";
+  char szProjBuf[512] = "";
 
   /* WMS/WFS AUTO projection: "AUTO:proj_id,units_id,lon0,lat0" */
   args = msStringSplit(p->args[0], ',', &numargs);
-  if (numargs != 4 ||
-      (strncasecmp(args[0], "AUTO:", 5) != 0 &&
-       strncasecmp(args[0], "AUTO2:", 6) != 0)) {
+  if (numargs != 4 || (strncasecmp(args[0], "AUTO:", 5) != 0 &&
+                       strncasecmp(args[0], "AUTO2:", 6) != 0)) {
     msSetError(MS_PROJERR,
                "WMS/WFS AUTO/AUTO2 PROJECTION must be in the format "
-               "'AUTO:proj_id,units_id,lon0,lat0' or 'AUTO2:crs_id,factor,lon0,lat0'(got '%s').\n",
+               "'AUTO:proj_id,units_id,lon0,lat0' or "
+               "'AUTO2:crs_id,factor,lon0,lat0'(got '%s').\n",
                "_msProcessAutoProjection()", p->args[0]);
     msFreeCharArray(args, numargs);
     return -1;
   }
 
-  if (strncasecmp(args[0], "AUTO:", 5)==0)
-    nProjId = atoi(args[0]+5);
+  if (strncasecmp(args[0], "AUTO:", 5) == 0)
+    nProjId = atoi(args[0] + 5);
   else
-    nProjId = atoi(args[0]+6);
+    nProjId = atoi(args[0] + 6);
 
   nUnitsId = atoi(args[1]);
   dLon0 = atof(args[2]);
   dLat0 = atof(args[3]);
 
-
   /*There is no unit parameter for AUTO2. The 2nd parameter is
    factor. Set the units to always be meter*/
   if (strncasecmp(args[0], "AUTO2:", 6) == 0)
@@ -748,15 +702,15 @@ static int _msProcessAutoProjection(proj
   msFreeCharArray(args, numargs);
 
   /* Handle EPSG Units.  Only meters for now. */
-  switch(nUnitsId) {
-    case 9001:  /* Meters */
-      pszUnits = "m";
-      break;
-    default:
-      msSetError(MS_PROJERR,
-                 "WMS/WFS AUTO PROJECTION: EPSG Units %d not supported.\n",
-                 "_msProcessAutoProjection()", nUnitsId);
-      return -1;
+  switch (nUnitsId) {
+  case 9001: /* Meters */
+    pszUnits = "m";
+    break;
+  default:
+    msSetError(MS_PROJERR,
+               "WMS/WFS AUTO PROJECTION: EPSG Units %d not supported.\n",
+               "_msProcessAutoProjection()", nUnitsId);
+    return -1;
   }
 
   /* Build PROJ4 definition.
@@ -765,49 +719,44 @@ static int _msProcessAutoProjection(proj
    * The conversion from the original WKT definitions to PROJ4 format was
    * done using the MapScript setWKTProjection() function (based on OGR).
    */
-  switch(nProjId) {
-    case 42001: /** WGS 84 / Auto UTM **/
-      nZone = (int) floor( (dLon0 + 180.0) / 6.0 ) + 1;
-      sprintf( szProjBuf,
-               "+proj=tmerc+lat_0=0+lon_0=%.16g+k=0.999600+x_0=500000"
-               "+y_0=%.16g+ellps=WGS84+datum=WGS84+units=%s+type=crs",
-               -183.0 + nZone * 6.0,
-               (dLat0 >= 0.0) ? 0.0 : 10000000.0,
-               pszUnits);
-      break;
-    case 42002: /** WGS 84 / Auto Tr. Mercator **/
-      sprintf( szProjBuf,
-               "+proj=tmerc+lat_0=0+lon_0=%.16g+k=0.999600+x_0=500000"
-               "+y_0=%.16g+ellps=WGS84+datum=WGS84+units=%s+type=crs",
-               dLon0,
-               (dLat0 >= 0.0) ? 0.0 : 10000000.0,
-               pszUnits);
-      break;
-    case 42003: /** WGS 84 / Auto Orthographic **/
-      sprintf( szProjBuf,
-               "+proj=ortho+lon_0=%.16g+lat_0=%.16g+x_0=0+y_0=0"
-               "+ellps=WGS84+datum=WGS84+units=%s+type=crs",
-               dLon0, dLat0, pszUnits );
-      break;
-    case 42004: /** WGS 84 / Auto Equirectangular **/
-      /* Note that we have to pass lon_0 as lon_ts for this one to */
-      /* work.  Either a PROJ4 bug or a PROJ4 documentation issue. */
-      sprintf( szProjBuf,
-               "+proj=eqc+lon_ts=%.16g+lat_ts=%.16g+x_0=0+y_0=0"
-               "+ellps=WGS84+datum=WGS84+units=%s+type=crs",
-               dLon0, dLat0, pszUnits);
-      break;
-    case 42005: /** WGS 84 / Auto Mollweide **/
-      sprintf( szProjBuf,
-               "+proj=moll+lon_0=%.16g+x_0=0+y_0=0+ellps=WGS84"
-               "+datum=WGS84+units=%s+type=crs",
-               dLon0, pszUnits);
-      break;
-    default:
-      msSetError(MS_PROJERR,
-                 "WMS/WFS AUTO PROJECTION %d not supported.\n",
-                 "_msProcessAutoProjection()", nProjId);
-      return -1;
+  switch (nProjId) {
+  case 42001: /** WGS 84 / Auto UTM **/
+    nZone = (int)floor((dLon0 + 180.0) / 6.0) + 1;
+    sprintf(szProjBuf,
+            "+proj=tmerc+lat_0=0+lon_0=%.16g+k=0.999600+x_0=500000"
+            "+y_0=%.16g+ellps=WGS84+datum=WGS84+units=%s+type=crs",
+            -183.0 + nZone * 6.0, (dLat0 >= 0.0) ? 0.0 : 10000000.0, pszUnits);
+    break;
+  case 42002: /** WGS 84 / Auto Tr. Mercator **/
+    sprintf(szProjBuf,
+            "+proj=tmerc+lat_0=0+lon_0=%.16g+k=0.999600+x_0=500000"
+            "+y_0=%.16g+ellps=WGS84+datum=WGS84+units=%s+type=crs",
+            dLon0, (dLat0 >= 0.0) ? 0.0 : 10000000.0, pszUnits);
+    break;
+  case 42003: /** WGS 84 / Auto Orthographic **/
+    sprintf(szProjBuf,
+            "+proj=ortho+lon_0=%.16g+lat_0=%.16g+x_0=0+y_0=0"
+            "+ellps=WGS84+datum=WGS84+units=%s+type=crs",
+            dLon0, dLat0, pszUnits);
+    break;
+  case 42004: /** WGS 84 / Auto Equirectangular **/
+    /* Note that we have to pass lon_0 as lon_ts for this one to */
+    /* work.  Either a PROJ4 bug or a PROJ4 documentation issue. */
+    sprintf(szProjBuf,
+            "+proj=eqc+lon_ts=%.16g+lat_ts=%.16g+x_0=0+y_0=0"
+            "+ellps=WGS84+datum=WGS84+units=%s+type=crs",
+            dLon0, dLat0, pszUnits);
+    break;
+  case 42005: /** WGS 84 / Auto Mollweide **/
+    sprintf(szProjBuf,
+            "+proj=moll+lon_0=%.16g+x_0=0+y_0=0+ellps=WGS84"
+            "+datum=WGS84+units=%s+type=crs",
+            dLon0, pszUnits);
+    break;
+  default:
+    msSetError(MS_PROJERR, "WMS/WFS AUTO PROJECTION %d not supported.\n",
+               "_msProcessAutoProjection()", nProjId);
+    return -1;
   }
 
   /* msDebug("%s = %s\n", p->args[0], szProjBuf); */
@@ -816,43 +765,45 @@ static int _msProcessAutoProjection(proj
   args = msStringSplit(szProjBuf, '+', &numargs);
 
 #if PROJ_VERSION_MAJOR >= 6
-  if( !(p->proj = proj_create_argv(p->proj_ctx->proj_ctx, numargs, args)) ) {
-    int l_pj_errno = proj_context_errno (p->proj_ctx->proj_ctx);
+  if (!(p->proj = proj_create_argv(p->proj_ctx->proj_ctx, numargs, args))) {
+    int l_pj_errno = proj_context_errno(p->proj_ctx->proj_ctx);
     msSetError(MS_PROJERR, "proj error \"%s\" for \"%s\"",
-               "msProcessProjection()", proj_errno_string(l_pj_errno), szProjBuf) ;
+               "msProcessProjection()", proj_errno_string(l_pj_errno),
+               szProjBuf);
     msFreeCharArray(args, numargs);
-    return(-1);
+    return (-1);
   }
 #else
-  msAcquireLock( TLOCK_PROJ );
-  if( !(p->proj = pj_init(numargs, args)) ) {
+  msAcquireLock(TLOCK_PROJ);
+  if (!(p->proj = pj_init(numargs, args))) {
     int *pj_errno_ref = pj_get_errno_ref();
-    msReleaseLock( TLOCK_PROJ );
+    msReleaseLock(TLOCK_PROJ);
     msSetError(MS_PROJERR, "proj error \"%s\" for \"%s\"",
-               "msProcessProjection()", pj_strerrno(*pj_errno_ref), szProjBuf) ;
+               "msProcessProjection()", pj_strerrno(*pj_errno_ref), szProjBuf);
     msFreeCharArray(args, numargs);
-    return(-1);
+    return (-1);
   }
-  msReleaseLock( TLOCK_PROJ );
+  msReleaseLock(TLOCK_PROJ);
 #endif
 
   msFreeCharArray(args, numargs);
 
-  return(0);
+  return (0);
 }
 
-int msProcessProjection(projectionObj *p)
-{
-  assert( p->proj == NULL );
+int msProcessProjection(projectionObj *p) {
+  assert(p->proj == NULL);
+
+  p->generation_number++;
 
-  if( strcasecmp(p->args[0],"GEOGRAPHIC") == 0 ) {
+  if (strcasecmp(p->args[0], "GEOGRAPHIC") == 0) {
     msSetError(MS_PROJERR,
                "PROJECTION 'GEOGRAPHIC' no longer supported.\n"
                "Provide explicit definition.\n"
                "ie. proj=latlong\n"
                "    ellps=clrk66\n",
                "msProcessProjection()");
-    return(-1);
+    return (-1);
   }
 
   if (strcasecmp(p->args[0], "AUTO") == 0) {
@@ -861,38 +812,32 @@ int msProcessProjection(projectionObj *p
   }
 
 #if PROJ_VERSION_MAJOR >= 6
-  if( p->proj_ctx == NULL )
-  {
+  if (p->proj_ctx == NULL) {
     p->proj_ctx = msProjectionContextCreate();
-    if( p->proj_ctx == NULL )
-    {
-        return -1;
+    if (p->proj_ctx == NULL) {
+      return -1;
     }
   }
-  if( p->proj_ctx->ms_proj_data_change_counter != ms_proj_data_change_counter )
-  {
-    msAcquireLock( TLOCK_PROJ );
+  if (p->proj_ctx->ms_proj_data_change_counter != ms_proj_data_change_counter) {
+    msAcquireLock(TLOCK_PROJ);
     p->proj_ctx->ms_proj_data_change_counter = ms_proj_data_change_counter;
     {
-        if( ms_proj_data )
-        {
-            int num_tokens = 0;
+      if (ms_proj_data) {
+        int num_tokens = 0;
 #ifdef _WIN32
-            char sep = ';';
+        char sep = ';';
 #else
-            char sep = ':';
+        char sep = ':';
 #endif
-            char** paths = msStringSplit(ms_proj_data, sep, &num_tokens);
-            proj_context_set_search_paths(p->proj_ctx->proj_ctx, num_tokens,
-                                          (const char* const*)paths);
-            msFreeCharArray(paths, num_tokens);
-        }
-        else
-        {
-            proj_context_set_search_paths(p->proj_ctx->proj_ctx, 0, NULL);
-        }
+        char **paths = msStringSplit(ms_proj_data, sep, &num_tokens);
+        proj_context_set_search_paths(p->proj_ctx->proj_ctx, num_tokens,
+                                      (const char *const *)paths);
+        msFreeCharArray(paths, num_tokens);
+      } else {
+        proj_context_set_search_paths(p->proj_ctx->proj_ctx, 0, NULL);
+      }
     }
-    msReleaseLock( TLOCK_PROJ );
+    msReleaseLock(TLOCK_PROJ);
   }
 #endif
 
@@ -904,91 +849,94 @@ int msProcessProjection(projectionObj *p
   }
 
 #if PROJ_VERSION_MAJOR >= 6
-  if( p->numargs == 1 && strncmp(p->args[0], "init=", 5) != 0 )
-  {
-      /* Deal e.g. with EPSG:XXXX or ESRI:XXXX */
-      if( !(p->proj = proj_create_argv(p->proj_ctx->proj_ctx, p->numargs, p->args)) ) {
-          int l_pj_errno = proj_context_errno (p->proj_ctx->proj_ctx);
-          msSetError(MS_PROJERR, "proj error \"%s\" for \"%s\"",
-                     "msProcessProjection()", proj_errno_string(l_pj_errno), p->args[0]) ;
-          return(-1);
-      }
-  }
-  else
-  {
-      char** args = (char**)msSmallMalloc(sizeof(char*) * (p->numargs+1));
-      memcpy(args, p->args, sizeof(char*) * p->numargs);
+  if (p->numargs == 1 && strncmp(p->args[0], "init=", 5) != 0) {
+    /* Deal e.g. with EPSG:XXXX or ESRI:XXXX */
+    if (!(p->proj =
+              proj_create_argv(p->proj_ctx->proj_ctx, p->numargs, p->args))) {
+      int l_pj_errno = proj_context_errno(p->proj_ctx->proj_ctx);
+      msSetError(MS_PROJERR, "proj error \"%s\" for \"%s\"",
+                 "msProcessProjection()", proj_errno_string(l_pj_errno),
+                 p->args[0]);
+      return (-1);
+    }
+  } else {
+    char **args = (char **)msSmallMalloc(sizeof(char *) * (p->numargs + 1));
+    memcpy(args, p->args, sizeof(char *) * p->numargs);
 
 #if PROJ_VERSION_MAJOR == 6 && PROJ_VERSION_MINOR < 2
-      /* PROJ lookups are faster with EPSG in uppercase. Fixed in PROJ 6.2 */
-      /* Do that only for those versions, as it can create confusion if using */
-      /* a real old-style 'epsg' file... */
-      char szTemp[24];
-      if( p->numargs && strncmp(args[0], "init=epsg:", strlen("init=epsg:")) == 0 &&
-          strlen(args[0]) < 24)
-      {
-          strcpy(szTemp, "init=EPSG:");
-          strcat(szTemp, args[0] + strlen("init=epsg:"));
-          args[0] = szTemp;
-      }
+    /* PROJ lookups are faster with EPSG in uppercase. Fixed in PROJ 6.2 */
+    /* Do that only for those versions, as it can create confusion if using */
+    /* a real old-style 'epsg' file... */
+    char szTemp[24];
+    if (p->numargs &&
+        strncmp(args[0], "init=epsg:", strlen("init=epsg:")) == 0 &&
+        strlen(args[0]) < 24) {
+      strcpy(szTemp, "init=EPSG:");
+      strcat(szTemp, args[0] + strlen("init=epsg:"));
+      args[0] = szTemp;
+    }
 #endif
 
-      args[p->numargs] = (char*) "type=crs";
+    args[p->numargs] = (char *)"type=crs";
 #if 0
       for( int i = 0; i <  p->numargs + 1; i++ )
           fprintf(stderr, "%s ", args[i]);
       fprintf(stderr, "\n");
 #endif
-      if( !(p->proj = proj_create_argv(p->proj_ctx->proj_ctx, p->numargs + 1, args)) ) {
-          int l_pj_errno = proj_context_errno (p->proj_ctx->proj_ctx);
-          if(p->numargs>1) {
-            msSetError(MS_PROJERR, "proj error \"%s\" for \"%s:%s\"",
-                        "msProcessProjection()", proj_errno_string(l_pj_errno), p->args[0],p->args[1]) ;
-          } else {
-            msSetError(MS_PROJERR, "proj error \"%s\" for \"%s\"",
-                        "msProcessProjection()", proj_errno_string(l_pj_errno), p->args[0]) ;
-          }
-          free(args);
-          return(-1);
+    if (!(p->proj =
+              proj_create_argv(p->proj_ctx->proj_ctx, p->numargs + 1, args))) {
+      int l_pj_errno = proj_context_errno(p->proj_ctx->proj_ctx);
+      if (p->numargs > 1) {
+        msSetError(MS_PROJERR, "proj error \"%s\" for \"%s:%s\"",
+                   "msProcessProjection()", proj_errno_string(l_pj_errno),
+                   p->args[0], p->args[1]);
+      } else {
+        msSetError(MS_PROJERR, "proj error \"%s\" for \"%s\"",
+                   "msProcessProjection()", proj_errno_string(l_pj_errno),
+                   p->args[0]);
       }
       free(args);
+      return (-1);
+    }
+    free(args);
   }
 #else
-  msAcquireLock( TLOCK_PROJ );
+  msAcquireLock(TLOCK_PROJ);
 #if PJ_VERSION < 480
-  if( !(p->proj = pj_init(p->numargs, p->args)) ) {
+  if (!(p->proj = pj_init(p->numargs, p->args))) {
 #else
   p->proj_ctx = pj_ctx_alloc();
-  if( !(p->proj=pj_init_ctx(p->proj_ctx, p->numargs, p->args)) ) {
+  if (!(p->proj = pj_init_ctx(p->proj_ctx, p->numargs, p->args))) {
 #endif
 
     int *pj_errno_ref = pj_get_errno_ref();
-    msReleaseLock( TLOCK_PROJ );
-    if(p->numargs>1) {
+    msReleaseLock(TLOCK_PROJ);
+    if (p->numargs > 1) {
       msSetError(MS_PROJERR, "proj error \"%s\" for \"%s:%s\"",
-                 "msProcessProjection()", pj_strerrno(*pj_errno_ref), p->args[0],p->args[1]) ;
+                 "msProcessProjection()", pj_strerrno(*pj_errno_ref),
+                 p->args[0], p->args[1]);
     } else {
       msSetError(MS_PROJERR, "proj error \"%s\" for \"%s\"",
-                 "msProcessProjection()", pj_strerrno(*pj_errno_ref), p->args[0]) ;
+                 "msProcessProjection()", pj_strerrno(*pj_errno_ref),
+                 p->args[0]);
     }
-    return(-1);
+    return (-1);
   }
 
-  msReleaseLock( TLOCK_PROJ );
+  msReleaseLock(TLOCK_PROJ);
 #endif
 
 #ifdef USE_PROJ_FASTPATHS
-  if(strcasestr(p->args[0],"epsg:4326")) {
+  if (strcasestr(p->args[0], "epsg:4326")) {
     p->wellknownprojection = wkp_lonlat;
-  } else if(strcasestr(p->args[0],"epsg:3857")) {
+  } else if (strcasestr(p->args[0], "epsg:3857")) {
     p->wellknownprojection = wkp_gmerc;
   } else {
     p->wellknownprojection = wkp_none;
   }
 #endif
 
-
-  return(0);
+  return (0);
 }
 
 /************************************************************************/
@@ -996,15 +944,15 @@ int msProcessProjection(projectionObj *p
 /*      Check to see if we should invert the axis.                       */
 /*                                                                      */
 /************************************************************************/
-int msIsAxisInverted(int epsg_code)
-{
-  if( epsg_code < 0 )
+int msIsAxisInverted(int epsg_code) {
+  if (epsg_code < 0)
     return MS_FALSE;
   const unsigned int row = epsg_code / 8;
   const unsigned char index = epsg_code % 8;
 
   /*check the static table*/
-  if ((row < sizeof(axisOrientationEpsgCodes)) && (axisOrientationEpsgCodes[row] & (1 << index)))
+  if ((row < sizeof(axisOrientationEpsgCodes)) &&
+      (axisOrientationEpsgCodes[row] & (1 << index)))
     return MS_TRUE;
   else
     return MS_FALSE;
@@ -1013,55 +961,51 @@ int msIsAxisInverted(int epsg_code)
 /************************************************************************/
 /*                           msProjectPoint()                           */
 /************************************************************************/
-int msProjectPoint(projectionObj *in, projectionObj *out, pointObj *point)
-{
-    int ret;
-    reprojectionObj* reprojector = msProjectCreateReprojector(in, out);
-    if( !reprojector )
-        return MS_FAILURE;
-    ret = msProjectPointEx(reprojector, point);
-    msProjectDestroyReprojector(reprojector);
-    return ret;
+int msProjectPoint(projectionObj *in, projectionObj *out, pointObj *point) {
+  int ret;
+  reprojectionObj *reprojector = msProjectCreateReprojector(in, out);
+  if (!reprojector)
+    return MS_FAILURE;
+  ret = msProjectPointEx(reprojector, point);
+  msProjectDestroyReprojector(reprojector);
+  return ret;
 }
 
 /************************************************************************/
 /*                           msProjectPointEx()                         */
 /************************************************************************/
-int msProjectPointEx(reprojectionObj* reprojector, pointObj *point)
-{
-  projectionObj* in = reprojector->in;
-  projectionObj* out = reprojector->out;
+int msProjectPointEx(reprojectionObj *reprojector, pointObj *point) {
+  projectionObj *in = reprojector->in;
+  projectionObj *out = reprojector->out;
 
-  if( in && in->gt.need_geotransform ) {
+  if (in && in->gt.need_geotransform) {
     double x_out, y_out;
 
-    x_out = in->gt.geotransform[0]
-            + in->gt.geotransform[1] * point->x
-            + in->gt.geotransform[2] * point->y;
-    y_out = in->gt.geotransform[3]
-            + in->gt.geotransform[4] * point->x
-            + in->gt.geotransform[5] * point->y;
+    x_out = in->gt.geotransform[0] + in->gt.geotransform[1] * point->x +
+            in->gt.geotransform[2] * point->y;
+    y_out = in->gt.geotransform[3] + in->gt.geotransform[4] * point->x +
+            in->gt.geotransform[5] * point->y;
 
     point->x = x_out;
     point->y = y_out;
   }
 
 #if PROJ_VERSION_MAJOR >= 6
-  if( reprojector->pj ) {
+  if (reprojector->pj) {
     PJ_COORD c;
     c.xyzt.x = point->x;
     c.xyzt.y = point->y;
     c.xyzt.z = 0;
     c.xyzt.t = 0;
-    c = proj_trans (reprojector->pj, PJ_FWD, c);
-    if( c.xyzt.x == HUGE_VAL || c.xyzt.y == HUGE_VAL ) {
+    c = proj_trans(reprojector->pj, PJ_FWD, c);
+    if (c.xyzt.x == HUGE_VAL || c.xyzt.y == HUGE_VAL) {
       return MS_FAILURE;
     }
     point->x = c.xyzt.x;
     point->y = c.xyzt.y;
   }
 #else
-  if( reprojector->no_op ) {
+  if (reprojector->no_op) {
     /* do nothing, no transformation required */
   }
 
@@ -1069,30 +1013,31 @@ int msProjectPointEx(reprojectionObj* re
   /*      If we have a fully defined input coordinate system and          */
   /*      output coordinate system, then we will use pj_transform.        */
   /* -------------------------------------------------------------------- */
-  else if( in && in->proj && out && out->proj ) {
+  else if (in && in->proj && out && out->proj) {
     int error;
-    double  z = 0.0;
+    double z = 0.0;
 
-    if( pj_is_latlong(in->proj) ) {
+    if (pj_is_latlong(in->proj)) {
       point->x *= DEG_TO_RAD;
       point->y *= DEG_TO_RAD;
     }
 
 #if PJ_VERSION < 480
-    msAcquireLock( TLOCK_PROJ );
+    msAcquireLock(TLOCK_PROJ);
 #endif
-    error = pj_transform( in->proj, out->proj, 1, 0,
-                          &(point->x), &(point->y), &z );
+    error =
+        pj_transform(in->proj, out->proj, 1, 0, &(point->x), &(point->y), &z);
 #if PJ_VERSION < 480
-    msReleaseLock( TLOCK_PROJ );
+    msReleaseLock(TLOCK_PROJ);
 #endif
 
-    if( error || point->x == HUGE_VAL || point->y == HUGE_VAL ) {
-//      msSetError(MS_PROJERR,"proj says: %s","msProjectPoint()",pj_strerrno(error));
+    if (error || point->x == HUGE_VAL || point->y == HUGE_VAL) {
+      //      msSetError(MS_PROJERR,"proj says:
+      //      %s","msProjectPoint()",pj_strerrno(error));
       return MS_FAILURE;
     }
 
-    if( pj_is_latlong(out->proj) ) {
+    if (pj_is_latlong(out->proj)) {
       point->x *= RAD_TO_DEG;
       point->y *= RAD_TO_DEG;
     }
@@ -1110,11 +1055,12 @@ int msProjectPointEx(reprojectionObj* re
     p.u = point->x;
     p.v = point->y;
 
-    if(in==NULL || in->proj==NULL) { /* input coordinates are lat/lon */
-      p.u *= DEG_TO_RAD; /* convert to radians */
+    if (in == NULL || in->proj == NULL) { /* input coordinates are lat/lon */
+      p.u *= DEG_TO_RAD;                  /* convert to radians */
       p.v *= DEG_TO_RAD;
       p = pj_fwd(p, out->proj);
-    } else /* if(out==NULL || out->proj==NULL) */ { /* output coordinates are lat/lon */
+    } else /* if(out==NULL || out->proj==NULL) */ { /* output coordinates are
+                                                       lat/lon */
       p = pj_inv(p, in->proj);
       p.u *= RAD_TO_DEG; /* convert to decimal degrees */
       p.v *= RAD_TO_DEG;
@@ -1122,42 +1068,39 @@ int msProjectPointEx(reprojectionObj* re
 
     point->x = p.u;
     point->y = p.v;
-    if( point->x == HUGE_VAL || point->y == HUGE_VAL ) {
+    if (point->x == HUGE_VAL || point->y == HUGE_VAL) {
       return MS_FAILURE;
     }
   }
 #endif
 
-  if( out && out->gt.need_geotransform ) {
+  if (out && out->gt.need_geotransform) {
     double x_out, y_out;
 
-    x_out = out->gt.invgeotransform[0]
-            + out->gt.invgeotransform[1] * point->x
-            + out->gt.invgeotransform[2] * point->y;
-    y_out = out->gt.invgeotransform[3]
-            + out->gt.invgeotransform[4] * point->x
-            + out->gt.invgeotransform[5] * point->y;
+    x_out = out->gt.invgeotransform[0] + out->gt.invgeotransform[1] * point->x +
+            out->gt.invgeotransform[2] * point->y;
+    y_out = out->gt.invgeotransform[3] + out->gt.invgeotransform[4] * point->x +
+            out->gt.invgeotransform[5] * point->y;
 
     point->x = x_out;
     point->y = y_out;
   }
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
 /************************************************************************/
 /*                         msProjectGrowRect()                          */
 /************************************************************************/
-static void msProjectGrowRect(reprojectionObj* reprojector,
-                              rectObj *prj_rect,
-                              pointObj *prj_point, int *failure )
+static void msProjectGrowRect(reprojectionObj *reprojector, rectObj *prj_rect,
+                              pointObj *prj_point, int *failure)
 
 {
-  if( msProjectPointEx(reprojector, prj_point) == MS_SUCCESS ) {
-      prj_rect->miny = MS_MIN(prj_rect->miny, prj_point->y);
-      prj_rect->maxy = MS_MAX(prj_rect->maxy, prj_point->y);
-      prj_rect->minx = MS_MIN(prj_rect->minx, prj_point->x);
-      prj_rect->maxx = MS_MAX(prj_rect->maxx, prj_point->x);
+  if (msProjectPointEx(reprojector, prj_point) == MS_SUCCESS) {
+    prj_rect->miny = MS_MIN(prj_rect->miny, prj_point->y);
+    prj_rect->maxy = MS_MAX(prj_rect->maxy, prj_point->y);
+    prj_rect->minx = MS_MIN(prj_rect->minx, prj_point->x);
+    prj_rect->maxx = MS_MAX(prj_rect->maxx, prj_point->x);
   } else
     (*failure)++;
 }
@@ -1168,8 +1111,8 @@ static void msProjectGrowRect(reprojecti
 /*      Interpolate along a line segment for which one end              */
 /*      reprojects and the other end does not.  Finds the horizon.      */
 /************************************************************************/
-static int msProjectSegment( reprojectionObj* reprojector,
-                             pointObj *start, pointObj *end )
+static int msProjectSegment(reprojectionObj *reprojector, pointObj *start,
+                            pointObj *end)
 
 {
   pointObj testPoint, subStart, subEnd;
@@ -1180,12 +1123,12 @@ static int msProjectSegment( reprojectio
   /*      then re-call with the points reversed.                          */
   /* -------------------------------------------------------------------- */
   testPoint = *start;
-  if( msProjectPointEx( reprojector, &testPoint ) == MS_FAILURE ) {
+  if (msProjectPointEx(reprojector, &testPoint) == MS_FAILURE) {
     testPoint = *end;
-    if( msProjectPointEx( reprojector, &testPoint ) == MS_FAILURE )
+    if (msProjectPointEx(reprojector, &testPoint) == MS_FAILURE)
       return MS_FAILURE;
     else
-      return msProjectSegment( reprojector, end, start );
+      return msProjectSegment(reprojector, end, start);
   }
 
   /* -------------------------------------------------------------------- */
@@ -1197,8 +1140,8 @@ static int msProjectSegment( reprojectio
 
 #define TOLERANCE 0.01
 
-  while( fabs(subStart.x - subEnd.x)
-         + fabs(subStart.y - subEnd.y) > TOLERANCE ) {
+  while (fabs(subStart.x - subEnd.x) + fabs(subStart.y - subEnd.y) >
+         TOLERANCE) {
     pointObj midPoint = {0};
 
     midPoint.x = (subStart.x + subEnd.x) * 0.5;
@@ -1206,13 +1149,12 @@ static int msProjectSegment( reprojectio
 
     testPoint = midPoint;
 
-    if( msProjectPointEx( reprojector, &testPoint ) == MS_FAILURE ) {
+    if (msProjectPointEx(reprojector, &testPoint) == MS_FAILURE) {
       if (midPoint.x == subEnd.x && midPoint.y == subEnd.y)
         return MS_FAILURE; /* break infinite loop */
 
       subEnd = midPoint;
-    }
-    else {
+    } else {
       if (midPoint.x == subStart.x && midPoint.y == subStart.y)
         return MS_FAILURE; /* break infinite loop */
 
@@ -1225,8 +1167,8 @@ static int msProjectSegment( reprojectio
   /* -------------------------------------------------------------------- */
   *end = subStart;
 
-  if( msProjectPointEx( reprojector, end ) == MS_FAILURE
-      || msProjectPointEx( reprojector, start ) == MS_FAILURE )
+  if (msProjectPointEx(reprojector, end) == MS_FAILURE ||
+      msProjectPointEx(reprojector, start) == MS_FAILURE)
     return MS_FAILURE;
   else
     return MS_SUCCESS;
@@ -1239,135 +1181,140 @@ static int msProjectSegment( reprojectio
 /* Detect projecting from north polar stereographic to longlat or EPSG:3857 */
 /* or from lonlat lon_wrap = 0 */
 #ifdef USE_GEOS
-static msLineCuttingCase msProjectGetLineCuttingCase(reprojectionObj* reprojector)
-{
-    if( reprojector->lineCuttingCase != LINE_CUTTING_UNKNOWN)
-        return reprojector->lineCuttingCase;
-
-    projectionObj *in = reprojector->in;
-    projectionObj *out = reprojector->out;
-    const double EPS = 1e-10;
+static msLineCuttingCase
+msProjectGetLineCuttingCase(reprojectionObj *reprojector) {
+  if (reprojector->lineCuttingCase != LINE_CUTTING_UNKNOWN)
+    return reprojector->lineCuttingCase;
 
-    if( !in->gt.need_geotransform && msProjIsGeographicCRS(in) )
-    {
-        int i;
-        for( i = 0; i < in->numargs; i++ )
-        {
-            if( strncmp(in->args[i], "lon_wrap=", strlen("lon_wrap=")) == 0 &&
-                atof(in->args[i] + strlen("lon_wrap=")) == 0.0 )
-            {
-                reprojector->lineCuttingCase = LINE_CUTTING_FROM_LONGLAT_WRAP0;
-
-                msInitShape(&(reprojector->splitShape));
-                reprojector->splitShape.type = MS_SHAPE_POLYGON;
-                int j;
-                for( j = -1; j <= 1; j += 2 )
-                {
-                    const double x = j * 180;
-                    pointObj p = {0}; // initialize
-                    lineObj newLine = {0,NULL};
-                    p.x = x - EPS;
-                    p.y = 90;
-                    msAddPointToLine(&newLine, &p );
-                    p.x = x + EPS;
-                    p.y = 90;
-                    msAddPointToLine(&newLine, &p );
-                    p.x = x + EPS;
-                    p.y = -90;
-                    msAddPointToLine(&newLine, &p );
-                    p.x = x - EPS;
-                    p.y = -90;
-                    msAddPointToLine(&newLine, &p );
-                    p.x = x - EPS;
-                    p.y = 90;
-                    msAddPointToLine(&newLine, &p );
-                    msAddLineDirectly(&(reprojector->splitShape), &newLine);
-                }
+  projectionObj *in = reprojector->in;
+  projectionObj *out = reprojector->out;
+  const double EPS = 1e-10;
 
-                return reprojector->lineCuttingCase;
-            }
+  if (!in->gt.need_geotransform && msProjIsGeographicCRS(in)) {
+    int i;
+    for (i = 0; i < in->numargs; i++) {
+      if (strncmp(in->args[i], "lon_wrap=", strlen("lon_wrap=")) == 0 &&
+          atof(in->args[i] + strlen("lon_wrap=")) == 0.0) {
+        reprojector->lineCuttingCase = LINE_CUTTING_FROM_LONGLAT_WRAP0;
+
+        msInitShape(&(reprojector->splitShape));
+        reprojector->splitShape.type = MS_SHAPE_POLYGON;
+        int j;
+        for (j = -1; j <= 1; j += 2) {
+          const double x = j * 180;
+          pointObj p = {0}; // initialize
+          lineObj newLine = {0, NULL};
+          p.x = x - EPS;
+          p.y = 90;
+          msAddPointToLine(&newLine, &p);
+          p.x = x + EPS;
+          p.y = 90;
+          msAddPointToLine(&newLine, &p);
+          p.x = x + EPS;
+          p.y = -90;
+          msAddPointToLine(&newLine, &p);
+          p.x = x - EPS;
+          p.y = -90;
+          msAddPointToLine(&newLine, &p);
+          p.x = x - EPS;
+          p.y = 90;
+          msAddPointToLine(&newLine, &p);
+          msAddLineDirectly(&(reprojector->splitShape), &newLine);
         }
-    }
 
-    if( !(!in->gt.need_geotransform && !msProjIsGeographicCRS(in) &&
-            (msProjIsGeographicCRS(out) ||
-            (out->numargs == 1 && strcmp(out->args[0], "init=epsg:3857") == 0))) )
-    {
-        reprojector->lineCuttingCase = LINE_CUTTING_NONE;
-        return reprojector->lineCuttingCase;
-    }
-
-    int srcIsPolar;
-    double extremeLongEasting;
-    if( msProjIsGeographicCRS(out) )
-    {
-        pointObj p;
-        double gt3 = out->gt.need_geotransform ? out->gt.geotransform[3] : 0.0;
-        double gt4 = out->gt.need_geotransform ? out->gt.geotransform[4] : 0.0;
-        double gt5 = out->gt.need_geotransform ? out->gt.geotransform[5] : 1.0;
-        p.x = 0.0;
-        p.y = 0.0;
-        srcIsPolar =  msProjectPointEx(reprojector, &p) == MS_SUCCESS &&
-                        fabs(gt3 + p.x * gt4 + p.y * gt5 - 90) < 1e-8;
-        extremeLongEasting = 180;
-    }
-    else
-    {
-        pointObj p1;
-        pointObj p2;
-        double gt1 = out->gt.need_geotransform ? out->gt.geotransform[1] : 1.0;
-        p1.x = 0.0;
-        p1.y = -0.1;
-        p2.x = 0.0;
-        p2.y = 0.1;
-        srcIsPolar =  msProjectPointEx(reprojector, &p1) == MS_SUCCESS &&
-                      msProjectPointEx(reprojector, &p2) == MS_SUCCESS &&
-                     fabs((p1.x - p2.x) * gt1) > 20e6;
-        extremeLongEasting = 20037508.3427892;
-    }
-    if( !srcIsPolar )
-    {
-        reprojector->lineCuttingCase = LINE_CUTTING_NONE;
         return reprojector->lineCuttingCase;
+      }
     }
+  }
 
-    pointObj p = {0}; // initialize
-    double invgt0 = out->gt.need_geotransform ? out->gt.invgeotransform[0] : 0.0;
-    double invgt1 = out->gt.need_geotransform ? out->gt.invgeotransform[1] : 1.0;
-    double invgt3 = out->gt.need_geotransform ? out->gt.invgeotransform[3] : 0.0;
-    double invgt4 = out->gt.need_geotransform ? out->gt.invgeotransform[4] : 0.0;
-
-    lineObj newLine = {0,NULL};
-
-    p.x = invgt0 + -extremeLongEasting * (1 - EPS) * invgt1;
-    p.y = invgt3 + -extremeLongEasting * (1 - EPS) * invgt4;
-    /* coverity[swapped_arguments] */
-    msProjectPoint(out, in, &p);
-    pointObj first = p;
-    msAddPointToLine(&newLine, &p );
-
-    p.x = invgt0 + extremeLongEasting * (1 - EPS) * invgt1;
-    p.y = invgt3 + extremeLongEasting * (1 - EPS) * invgt4;
-    /* coverity[swapped_arguments] */
-    msProjectPoint(out, in, &p);
-    msAddPointToLine(&newLine, &p );
-
-    p.x = 0;
-    p.y = 0;
-    msAddPointToLine(&newLine, &p );
-
-    msAddPointToLine(&newLine, &first );
-
-    msInitShape(&(reprojector->splitShape));
-    reprojector->splitShape.type = MS_SHAPE_POLYGON;
-    msAddLineDirectly(&(reprojector->splitShape), &newLine);
+  if (!(!in->gt.need_geotransform && !msProjIsGeographicCRS(in) &&
+        (msProjIsGeographicCRS(out) ||
+         (out->numargs == 1 && strcmp(out->args[0], "init=epsg:3857") == 0)))) {
+    reprojector->lineCuttingCase = LINE_CUTTING_NONE;
+    return reprojector->lineCuttingCase;
+  }
 
-    reprojector->lineCuttingCase = LINE_CUTTING_FROM_POLAR;
+  int srcIsPolar;
+  double extremeLongEasting;
+  if (msProjIsGeographicCRS(out)) {
+    pointObj p;
+    double gt3 = out->gt.need_geotransform ? out->gt.geotransform[3] : 0.0;
+    double gt4 = out->gt.need_geotransform ? out->gt.geotransform[4] : 0.0;
+    double gt5 = out->gt.need_geotransform ? out->gt.geotransform[5] : 1.0;
+    p.x = 0.0;
+    p.y = 0.0;
+    srcIsPolar = msProjectPointEx(reprojector, &p) == MS_SUCCESS &&
+                 fabs(gt3 + p.x * gt4 + p.y * gt5 - 90) < 1e-8;
+    extremeLongEasting = 180;
+  } else {
+    pointObj p1;
+    pointObj p2;
+    double gt1 = out->gt.need_geotransform ? out->gt.geotransform[1] : 1.0;
+    p1.x = 0.0;
+    p1.y = -0.1;
+    p2.x = 0.0;
+    p2.y = 0.1;
+    srcIsPolar = msProjectPointEx(reprojector, &p1) == MS_SUCCESS &&
+                 msProjectPointEx(reprojector, &p2) == MS_SUCCESS &&
+                 fabs((p1.x - p2.x) * gt1) > 20e6;
+    extremeLongEasting = 20037508.3427892;
+  }
+  if (!srcIsPolar) {
+    reprojector->lineCuttingCase = LINE_CUTTING_NONE;
     return reprojector->lineCuttingCase;
+  }
+
+  pointObj p = {0}; // initialize
+  double invgt0 = out->gt.need_geotransform ? out->gt.invgeotransform[0] : 0.0;
+  double invgt1 = out->gt.need_geotransform ? out->gt.invgeotransform[1] : 1.0;
+  double invgt3 = out->gt.need_geotransform ? out->gt.invgeotransform[3] : 0.0;
+  double invgt4 = out->gt.need_geotransform ? out->gt.invgeotransform[4] : 0.0;
+
+  lineObj newLine = {0, NULL};
+
+  p.x = invgt0 + -extremeLongEasting * (1 - EPS) * invgt1;
+  p.y = invgt3 + -extremeLongEasting * (1 - EPS) * invgt4;
+  /* coverity[swapped_arguments] */
+  msProjectPoint(out, in, &p);
+  pointObj first = p;
+  msAddPointToLine(&newLine, &p);
+
+  p.x = invgt0 + extremeLongEasting * (1 - EPS) * invgt1;
+  p.y = invgt3 + extremeLongEasting * (1 - EPS) * invgt4;
+  /* coverity[swapped_arguments] */
+  msProjectPoint(out, in, &p);
+  msAddPointToLine(&newLine, &p);
+
+  p.x = 0;
+  p.y = 0;
+  msAddPointToLine(&newLine, &p);
+
+  msAddPointToLine(&newLine, &first);
+
+  msInitShape(&(reprojector->splitShape));
+  reprojector->splitShape.type = MS_SHAPE_POLYGON;
+  msAddLineDirectly(&(reprojector->splitShape), &newLine);
+
+  reprojector->lineCuttingCase = LINE_CUTTING_FROM_POLAR;
+  return reprojector->lineCuttingCase;
 }
 #endif
 
 /************************************************************************/
+/*                msProjectIsReprojectorStillValid()                    */
+/************************************************************************/
+
+int msProjectIsReprojectorStillValid(reprojectionObj *reprojector) {
+  if (reprojector->in &&
+      reprojector->in->generation_number != reprojector->generation_number_in)
+    return MS_FALSE;
+  if (reprojector->out &&
+      reprojector->out->generation_number != reprojector->generation_number_out)
+    return MS_FALSE;
+  return MS_TRUE;
+}
+
+/************************************************************************/
 /*                         msProjectShapeLine()                         */
 /*                                                                      */
 /*      Reproject a single linestring, potentially splitting into       */
@@ -1379,13 +1326,12 @@ static msLineCuttingCase msProjectGetLin
 /*      over the horizon point to the come back over the horizon point. */
 /************************************************************************/
 
-static int
-msProjectShapeLine(reprojectionObj* reprojector,
-                   shapeObj *shape, int line_index)
+static int msProjectShapeLine(reprojectionObj *reprojector, shapeObj *shape,
+                              int line_index)
 
 {
   int i;
-  pointObj  lastPoint, thisPoint, wrkPoint;
+  pointObj lastPoint, thisPoint, wrkPoint;
   lineObj *line = shape->line + line_index;
   lineObj *line_out = line;
   int valid_flag = 0; /* 1=true, -1=false, 0=unknown */
@@ -1401,29 +1347,39 @@ msProjectShapeLine(reprojectionObj* repr
 #define MAXEXTENTby180 111319.4907777777777777777
 #define p_x line->point[i].x
 #define p_y line->point[i].y
-  if(in->wellknownprojection == wkp_lonlat && out->wellknownprojection == wkp_gmerc) {
-    for( i = line->numpoints-1; i >= 0; i-- ) {
+  if (in->wellknownprojection == wkp_lonlat &&
+      out->wellknownprojection == wkp_gmerc) {
+    for (i = line->numpoints - 1; i >= 0; i--) {
       p_x *= MAXEXTENTby180;
       p_y = log(tan((90 + p_y) * M_PIby360)) * MS_RAD_TO_DEG;
       p_y *= MAXEXTENTby180;
-      if (p_x > MAXEXTENT) p_x = MAXEXTENT;
-      if (p_x < -MAXEXTENT) p_x = -MAXEXTENT;
-      if (p_y > MAXEXTENT) p_y = MAXEXTENT;
-      if (p_y < -MAXEXTENT) p_y = -MAXEXTENT;
+      if (p_x > MAXEXTENT)
+        p_x = MAXEXTENT;
+      if (p_x < -MAXEXTENT)
+        p_x = -MAXEXTENT;
+      if (p_y > MAXEXTENT)
+        p_y = MAXEXTENT;
+      if (p_y < -MAXEXTENT)
+        p_y = -MAXEXTENT;
     }
     return MS_SUCCESS;
   }
-  if(in->wellknownprojection == wkp_gmerc && out->wellknownprojection == wkp_lonlat) {
-    for( i = line->numpoints-1; i >= 0; i-- ) {
-      if (p_x > MAXEXTENT) p_x = MAXEXTENT;
-      else if (p_x < -MAXEXTENT) p_x = -MAXEXTENT;
-      if (p_y > MAXEXTENT) p_y = MAXEXTENT;
-      else if (p_y < -MAXEXTENT) p_y = -MAXEXTENT;
+  if (in->wellknownprojection == wkp_gmerc &&
+      out->wellknownprojection == wkp_lonlat) {
+    for (i = line->numpoints - 1; i >= 0; i--) {
+      if (p_x > MAXEXTENT)
+        p_x = MAXEXTENT;
+      else if (p_x < -MAXEXTENT)
+        p_x = -MAXEXTENT;
+      if (p_y > MAXEXTENT)
+        p_y = MAXEXTENT;
+      else if (p_y < -MAXEXTENT)
+        p_y = -MAXEXTENT;
       p_x = (p_x / MAXEXTENT) * 180;
       p_y = (p_y / MAXEXTENT) * 180;
       p_y = MS_RAD_TO_DEG * (2 * atan(exp(p_y * MS_DEG_TO_RAD)) - MS_PI2);
     }
-    msComputeBounds( shape ); /* fixes bug 1586 */
+    msComputeBounds(shape); /* fixes bug 1586 */
     return MS_SUCCESS;
   }
 #undef p_x
@@ -1433,115 +1389,103 @@ msProjectShapeLine(reprojectionObj* repr
 #ifdef USE_GEOS
   int use_splitShape = MS_FALSE;
   int use_splitShape_check_intersects = MS_FALSE;
-  if( shape->type == MS_SHAPE_LINE &&
-      msProjectGetLineCuttingCase(reprojector) == LINE_CUTTING_FROM_POLAR )
-  {
+  if (shape->type == MS_SHAPE_LINE &&
+      msProjectGetLineCuttingCase(reprojector) == LINE_CUTTING_FROM_POLAR) {
     use_splitShape = MS_TRUE;
     use_splitShape_check_intersects = MS_TRUE;
-  }
-  else if( shape->type == MS_SHAPE_LINE &&
-           msProjectGetLineCuttingCase(reprojector) == LINE_CUTTING_FROM_LONGLAT_WRAP0 )
-  {
-      for( i=0; i < numpoints_in; i++ )
-      {
-          if( fabs(line->point[i].x) > 180 )
-          {
-              use_splitShape = MS_TRUE;
-              break;
-          }
+  } else if (shape->type == MS_SHAPE_LINE &&
+             msProjectGetLineCuttingCase(reprojector) ==
+                 LINE_CUTTING_FROM_LONGLAT_WRAP0) {
+    for (i = 0; i < numpoints_in; i++) {
+      if (fabs(line->point[i].x) > 180) {
+        use_splitShape = MS_TRUE;
+        break;
       }
+    }
   }
 
-  if( use_splitShape )
-  {
+  if (use_splitShape) {
     shapeObj tmpShapeInputLine;
     msInitShape(&tmpShapeInputLine);
     tmpShapeInputLine.type = MS_SHAPE_LINE;
     tmpShapeInputLine.numlines = 1;
     tmpShapeInputLine.line = line;
 
-    shapeObj* diff = NULL;
-    if( use_splitShape_check_intersects == MS_FALSE ||
-        msGEOSIntersects(&tmpShapeInputLine, &(reprojector->splitShape)) )
-    {
-        diff = msGEOSDifference(&tmpShapeInputLine, &(reprojector->splitShape));
+    shapeObj *diff = NULL;
+    if (use_splitShape_check_intersects == MS_FALSE ||
+        msGEOSIntersects(&tmpShapeInputLine, &(reprojector->splitShape))) {
+      diff = msGEOSDifference(&tmpShapeInputLine, &(reprojector->splitShape));
     }
 
     tmpShapeInputLine.numlines = 0;
     tmpShapeInputLine.line = NULL;
     msFreeShape(&tmpShapeInputLine);
 
-    if( diff )
-    {
-        for(int j = 0; j < diff->numlines; j++ )
-        {
-            for( i=0; i < diff->line[j].numpoints; i++ ) {
-                msProjectPointEx(reprojector, &(diff->line[j].point[i]));
-            }
-            if( j == 0 )
-            {
-                line_out->numpoints = diff->line[j].numpoints;
-                memcpy(line_out->point, diff->line[0].point, sizeof(pointObj) * line_out->numpoints);
-            }
-            else
-            {
-                msAddLineDirectly(shape, &(diff->line[j]));
-            }
+    if (diff) {
+      for (int j = 0; j < diff->numlines; j++) {
+        for (i = 0; i < diff->line[j].numpoints; i++) {
+          msProjectPointEx(reprojector, &(diff->line[j].point[i]));
+        }
+        if (j == 0) {
+          line_out->numpoints = diff->line[j].numpoints;
+          memcpy(line_out->point, diff->line[0].point,
+                 sizeof(pointObj) * line_out->numpoints);
+        } else {
+          msAddLineDirectly(shape, &(diff->line[j]));
         }
-        msFreeShape(diff);
-        msFree(diff);
-        return MS_SUCCESS;
+      }
+      msFreeShape(diff);
+      msFree(diff);
+      return MS_SUCCESS;
     }
   }
 #endif
 
-  wrap_test = out != NULL && out->proj != NULL && msProjIsGeographicCRS(out)
-              && !msProjIsGeographicCRS(in);
+  wrap_test = out != NULL && out->proj != NULL && msProjIsGeographicCRS(out) &&
+              !msProjIsGeographicCRS(in);
 
   line->numpoints = 0;
 
-  memset( &lastPoint, 0, sizeof(lastPoint) );
+  memset(&lastPoint, 0, sizeof(lastPoint));
 
   /* -------------------------------------------------------------------- */
   /*      Loop over all input points in linestring.                       */
   /* -------------------------------------------------------------------- */
-  for( i=0; i < numpoints_in; i++ ) {
+  for (i = 0; i < numpoints_in; i++) {
     int ms_err;
     wrkPoint = thisPoint = line->point[i];
 
-    ms_err = msProjectPointEx(reprojector, &wrkPoint );
+    ms_err = msProjectPointEx(reprojector, &wrkPoint);
 
     /* -------------------------------------------------------------------- */
     /*      Apply wrap logic.                                               */
     /* -------------------------------------------------------------------- */
-    if( wrap_test && i > 0 && ms_err != MS_FAILURE ) {
+    if (wrap_test && i > 0 && ms_err != MS_FAILURE) {
       double dist;
       pointObj pt1Geo;
 
-      if( line_out->numpoints > 0 )
-        pt1Geo = line_out->point[line_out->numpoints-1];
+      if (line_out->numpoints > 0)
+        pt1Geo = line_out->point[line_out->numpoints - 1];
       else
         pt1Geo = wrkPoint; /* this is a cop out */
 
-      if( out->gt.need_geotransform && out->gt.geotransform[2] == 0 ) {
+      if (out->gt.need_geotransform && out->gt.geotransform[2] == 0) {
         dist = out->gt.geotransform[1] * (wrkPoint.x - pt1Geo.x);
       } else {
         dist = wrkPoint.x - pt1Geo.x;
       }
 
-      if( fabs(dist) > 180.0
-          && msTestNeedWrap( thisPoint, lastPoint,
-                             pt1Geo, reprojector ) ) {
-        if( out->gt.need_geotransform && out->gt.geotransform[2] == 0 ) {
-          if( dist > 0.0 )
+      if (fabs(dist) > 180.0 &&
+          msTestNeedWrap(thisPoint, lastPoint, pt1Geo, reprojector)) {
+        if (out->gt.need_geotransform && out->gt.geotransform[2] == 0) {
+          if (dist > 0.0)
             wrkPoint.x -= 360.0 * out->gt.invgeotransform[1];
-          else if( dist < 0.0 )
+          else if (dist < 0.0)
             wrkPoint.x += 360.0 * out->gt.invgeotransform[1];
-        }
-        else {
-          if( dist > 0.0 )
+        } else {
+          if (dist > 0.0)
             wrkPoint.x -= 360.0;
-          else if( dist < 0.0 )
+          else if (dist < 0.0)
             wrkPoint.x += 360.0;
         }
       }
@@ -1551,40 +1495,40 @@ msProjectShapeLine(reprojectionObj* repr
     /*      Put result into output line with appropriate logic for          */
     /*      failure breaking lines, etc.                                    */
     /* -------------------------------------------------------------------- */
-    if( ms_err == MS_FAILURE ) {
+    if (ms_err == MS_FAILURE) {
       /* We have started out invalid */
-      if( i == 0 ) {
+      if (i == 0) {
         valid_flag = -1;
       }
 
       /* valid data has ended, we need to work out the horizon */
-      else if( valid_flag == 1 ) {
+      else if (valid_flag == 1) {
         pointObj startPoint, endPoint;
 
         startPoint = lastPoint;
         endPoint = thisPoint;
-        if( msProjectSegment( reprojector, &startPoint, &endPoint )
-            == MS_SUCCESS ) {
+        if (msProjectSegment(reprojector, &startPoint, &endPoint) ==
+            MS_SUCCESS) {
           line_out->point[line_out->numpoints++] = endPoint;
         }
         valid_flag = -1;
       }
 
       /* Still invalid ... */
-      else if( valid_flag == -1 ) {
+      else if (valid_flag == -1) {
         /* do nothing */
       }
     }
 
     else {
       /* starting out valid. */
-      if( i == 0 ) {
+      if (i == 0) {
         line_out->point[line_out->numpoints++] = wrkPoint;
         valid_flag = 1;
       }
 
       /* Still valid, nothing special */
-      else if( valid_flag == 1 ) {
+      else if (valid_flag == 1) {
         line_out->point[line_out->numpoints++] = wrkPoint;
       }
 
@@ -1594,33 +1538,31 @@ msProjectShapeLine(reprojectionObj* repr
 
         startPoint = lastPoint;
         endPoint = thisPoint;
-        if( msProjectSegment( reprojector, &endPoint, &startPoint )
-            == MS_SUCCESS ) {
+        if (msProjectSegment(reprojector, &endPoint, &startPoint) ==
+            MS_SUCCESS) {
           lineObj newLine;
 
           /* force pre-allocation of lots of points room */
-          if( line_out->numpoints > 0
-              && shape->type == MS_SHAPE_LINE ) {
+          if (line_out->numpoints > 0 && shape->type == MS_SHAPE_LINE) {
             newLine.numpoints = numpoints_in - i + 1;
             newLine.point = line->point;
-            msAddLine( shape, &newLine );
+            msAddLine(shape, &newLine);
 
             /* new line is now lineout, but start without any points */
-            line_out = shape->line + shape->numlines-1;
+            line_out = shape->line + shape->numlines - 1;
 
             line_out->numpoints = 0;
 
             /* the shape->line array is realloc, refetch "line" */
             line = shape->line + line_index;
-          } else if( line_out == line
-                     && line->numpoints >= i-2 ) {
+          } else if (line_out == line && line->numpoints >= i - 2) {
             newLine.numpoints = numpoints_in;
             newLine.point = line->point;
-            msAddLine( shape, &newLine );
+            msAddLine(shape, &newLine);
 
             line = shape->line + line_index;
 
-            line_out = shape->line + shape->numlines-1;
+            line_out = shape->line + shape->numlines - 1;
             line_out->numpoints = line->numpoints;
             line->numpoints = 0;
 
@@ -1630,9 +1572,8 @@ msProjectShapeLine(reprojectionObj* repr
              */
             line_alloc = line_alloc * 2;
 
-            line_out->point = (pointObj *)
-                              realloc(line_out->point,
-                                      sizeof(pointObj) * line_alloc);
+            line_out->point = (pointObj *)realloc(
+                line_out->point, sizeof(pointObj) * line_alloc);
           }
 
           line_out->point[line_out->numpoints++] = startPoint;
@@ -1649,71 +1590,78 @@ msProjectShapeLine(reprojectionObj* repr
   /*      Make sure that polygons are closed, even if the trip over       */
   /*      the horizon left them unclosed.                                 */
   /* -------------------------------------------------------------------- */
-  if( shape->type == MS_SHAPE_POLYGON
-      && line_out->numpoints > 2
-      && (line_out->point[0].x != line_out->point[line_out->numpoints-1].x
-          || line_out->point[0].y != line_out->point[line_out->numpoints-1].y) ) {
+  if (shape->type == MS_SHAPE_POLYGON && line_out->numpoints > 2 &&
+      (line_out->point[0].x != line_out->point[line_out->numpoints - 1].x ||
+       line_out->point[0].y != line_out->point[line_out->numpoints - 1].y)) {
     /* make a copy because msAddPointToLine can realloc the array */
     pointObj sFirstPoint = line_out->point[0];
-    msAddPointToLine( line_out, &sFirstPoint );
+    msAddPointToLine(line_out, &sFirstPoint);
   }
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
 /************************************************************************/
 /*                           msProjectShape()                           */
 /************************************************************************/
-int msProjectShape(projectionObj *in, projectionObj *out, shapeObj *shape)
-{
-    int ret;
-    reprojectionObj* reprojector = msProjectCreateReprojector(in, out);
-    if( !reprojector )
-        return MS_FAILURE;
-    ret = msProjectShapeEx(reprojector, shape);
-    msProjectDestroyReprojector(reprojector);
-    return ret;
+int msProjectShape(projectionObj *in, projectionObj *out, shapeObj *shape) {
+  int ret;
+  reprojectionObj *reprojector = msProjectCreateReprojector(in, out);
+  if (!reprojector)
+    return MS_FAILURE;
+  ret = msProjectShapeEx(reprojector, shape);
+  msProjectDestroyReprojector(reprojector);
+  return ret;
 }
 
 /************************************************************************/
 /*                          msProjectShapeEx()                          */
 /************************************************************************/
-int msProjectShapeEx(reprojectionObj* reprojector, shapeObj *shape)
-{
+int msProjectShapeEx(reprojectionObj *reprojector, shapeObj *shape) {
   int i;
 #ifdef USE_PROJ_FASTPATHS
   int j;
 
 #define p_x shape->line[i].point[j].x
 #define p_y shape->line[i].point[j].y
-  if(in->wellknownprojection == wkp_lonlat && out->wellknownprojection == wkp_gmerc) {
-    for( i = shape->numlines-1; i >= 0; i-- ) {
-      for( j = shape->line[i].numpoints-1; j >= 0; j-- ) {
+  if (in->wellknownprojection == wkp_lonlat &&
+      out->wellknownprojection == wkp_gmerc) {
+    for (i = shape->numlines - 1; i >= 0; i--) {
+      for (j = shape->line[i].numpoints - 1; j >= 0; j--) {
         p_x *= MAXEXTENTby180;
         p_y = log(tan((90 + p_y) * M_PIby360)) * MS_RAD_TO_DEG;
         p_y *= MAXEXTENTby180;
-        if (p_x > MAXEXTENT) p_x = MAXEXTENT;
-        else if (p_x < -MAXEXTENT) p_x = -MAXEXTENT;
-        if (p_y > MAXEXTENT) p_y = MAXEXTENT;
-        else if (p_y < -MAXEXTENT) p_y = -MAXEXTENT;
+        if (p_x > MAXEXTENT)
+          p_x = MAXEXTENT;
+        else if (p_x < -MAXEXTENT)
+          p_x = -MAXEXTENT;
+        if (p_y > MAXEXTENT)
+          p_y = MAXEXTENT;
+        else if (p_y < -MAXEXTENT)
+          p_y = -MAXEXTENT;
       }
     }
-    msComputeBounds( shape ); /* fixes bug 1586 */
+    msComputeBounds(shape); /* fixes bug 1586 */
     return MS_SUCCESS;
   }
-  if(in->wellknownprojection == wkp_gmerc && out->wellknownprojection == wkp_lonlat) {
-    for( i = shape->numlines-1; i >= 0; i-- ) {
-      for( j = shape->line[i].numpoints-1; j >= 0; j-- ) {
-        if (p_x > MAXEXTENT) p_x = MAXEXTENT;
-        else if (p_x < -MAXEXTENT) p_x = -MAXEXTENT;
-        if (p_y > MAXEXTENT) p_y = MAXEXTENT;
-        else if (p_y < -MAXEXTENT) p_y = -MAXEXTENT;
+  if (in->wellknownprojection == wkp_gmerc &&
+      out->wellknownprojection == wkp_lonlat) {
+    for (i = shape->numlines - 1; i >= 0; i--) {
+      for (j = shape->line[i].numpoints - 1; j >= 0; j--) {
+        if (p_x > MAXEXTENT)
+          p_x = MAXEXTENT;
+        else if (p_x < -MAXEXTENT)
+          p_x = -MAXEXTENT;
+        if (p_y > MAXEXTENT)
+          p_y = MAXEXTENT;
+        else if (p_y < -MAXEXTENT)
+          p_y = -MAXEXTENT;
         p_x = (p_x / MAXEXTENT) * 180;
         p_y = (p_y / MAXEXTENT) * 180;
         p_y = MS_RAD_TO_DEG * (2 * atan(exp(p_y * MS_DEG_TO_RAD)) - MS_PI2);
       }
     }
-    msComputeBounds( shape ); /* fixes bug 1586 */
+    msComputeBounds(shape); /* fixes bug 1586 */
     return MS_SUCCESS;
   }
 #undef p_x
@@ -1721,28 +1669,27 @@ int msProjectShapeEx(reprojectionObj* re
 #endif
 
   if (shape->numlines == 0) {
-      // don't attempt to project any NULL geometries
-      // but if we want to return the record's attributes we won't free the shape
-      // and throw an error
-      shape->type = MS_SHAPE_NULL;
-      return MS_SUCCESS;
+    // don't attempt to project any NULL geometries
+    // but if we want to return the record's attributes we won't free the shape
+    // and throw an error
+    shape->type = MS_SHAPE_NULL;
+    return MS_SUCCESS;
   } else {
-    for( i = shape->numlines-1; i >= 0; i-- ) {
-      if( shape->type == MS_SHAPE_LINE || shape->type == MS_SHAPE_POLYGON ) {
-        if( msProjectShapeLine( reprojector, shape, i ) == MS_FAILURE )
-          msShapeDeleteLine( shape, i );
-      } else if( msProjectLineEx(reprojector, shape->line+i ) == MS_FAILURE ) {
-        msShapeDeleteLine( shape, i );
+    for (i = shape->numlines - 1; i >= 0; i--) {
+      if (shape->type == MS_SHAPE_LINE || shape->type == MS_SHAPE_POLYGON) {
+        if (msProjectShapeLine(reprojector, shape, i) == MS_FAILURE)
+          msShapeDeleteLine(shape, i);
+      } else if (msProjectLineEx(reprojector, shape->line + i) == MS_FAILURE) {
+        msShapeDeleteLine(shape, i);
       }
     }
 
-    if ( shape->numlines == 0 ) {
-        msFreeShape(shape);
-        return MS_FAILURE;
-    }
-    else {
-        msComputeBounds(shape); /* fixes bug 1586 */
-        return(MS_SUCCESS);
+    if (shape->numlines == 0) {
+      msFreeShape(shape);
+      return MS_FAILURE;
+    } else {
+      msComputeBounds(shape); /* fixes bug 1586 */
+      return (MS_SUCCESS);
     }
   }
 }
@@ -1750,15 +1697,14 @@ int msProjectShapeEx(reprojectionObj* re
 /************************************************************************/
 /*                           msProjectLine()                            */
 /************************************************************************/
-int msProjectLine(projectionObj *in, projectionObj *out, lineObj *line)
-{
-    int ret;
-    reprojectionObj* reprojector = msProjectCreateReprojector(in, out);
-    if( !reprojector )
-        return MS_FAILURE;
-    ret = msProjectLineEx(reprojector, line);
-    msProjectDestroyReprojector(reprojector);
-    return ret;
+int msProjectLine(projectionObj *in, projectionObj *out, lineObj *line) {
+  int ret;
+  reprojectionObj *reprojector = msProjectCreateReprojector(in, out);
+  if (!reprojector)
+    return MS_FAILURE;
+  ret = msProjectLineEx(reprojector, line);
+  msProjectDestroyReprojector(reprojector);
+  return ret;
 }
 
 /************************************************************************/
@@ -1769,19 +1715,18 @@ int msProjectLine(projectionObj *in, pro
 /*      lots of logic to handle horizon crossing.                       */
 /************************************************************************/
 
-int msProjectLineEx(reprojectionObj* reprojector, lineObj *line)
-{
+int msProjectLineEx(reprojectionObj *reprojector, lineObj *line) {
   int be_careful = reprojector->out->proj != NULL &&
-                 msProjIsGeographicCRS(reprojector->out)
-                 && !msProjIsGeographicCRS(reprojector->in);
+                   msProjIsGeographicCRS(reprojector->out) &&
+                   !msProjIsGeographicCRS(reprojector->in);
 
-  if( be_careful ) {
-    pointObj  startPoint, thisPoint; /* locations in projected space */
+  if (be_careful) {
+    pointObj startPoint, thisPoint; /* locations in projected space */
 
     startPoint = line->point[0];
 
-    for(int i=0; i<line->numpoints; i++) {
-      double  dist;
+    for (int i = 0; i < line->numpoints; i++) {
+      double dist;
 
       thisPoint = line->point[i];
 
@@ -1790,29 +1735,28 @@ int msProjectLineEx(reprojectionObj* rep
       ** this dateline wrapping logic.
       */
       msProjectPointEx(reprojector, &(line->point[i]));
-      if( i > 0 ) {
+      if (i > 0) {
         dist = line->point[i].x - line->point[0].x;
-        if( fabs(dist) > 180.0 ) {
-          if( msTestNeedWrap( thisPoint, startPoint,
-                              line->point[0], reprojector ) ) {
-            if( dist > 0.0 ) {
+        if (fabs(dist) > 180.0) {
+          if (msTestNeedWrap(thisPoint, startPoint, line->point[0],
+                             reprojector)) {
+            if (dist > 0.0) {
               line->point[i].x -= 360.0;
-            } else if( dist < 0.0 ) {
+            } else if (dist < 0.0) {
               line->point[i].x += 360.0;
             }
           }
         }
-
       }
     }
   } else {
-    for(int i=0; i<line->numpoints; i++) {
-      if( msProjectPointEx(reprojector, &(line->point[i])) == MS_FAILURE )
+    for (int i = 0; i < line->numpoints; i++) {
+      if (msProjectPointEx(reprojector, &(line->point[i])) == MS_FAILURE)
         return MS_FAILURE;
     }
   }
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
 /************************************************************************/
@@ -1821,13 +1765,11 @@ int msProjectLineEx(reprojectionObj* rep
 
 #define NUMBER_OF_SAMPLE_POINTS 100
 
-static
-int msProjectRectGrid(reprojectionObj* reprojector, rectObj *rect)
-{
+static int msProjectRectGrid(reprojectionObj *reprojector, rectObj *rect) {
   pointObj prj_point;
   rectObj prj_rect;
-  int     failure=0;
-  int     ix, iy;
+  int failure = 0;
+  int ix, iy;
 
   double dx, dy;
   double x, y;
@@ -1837,8 +1779,8 @@ int msProjectRectGrid(reprojectionObj* r
   prj_rect.maxx = -DBL_MAX;
   prj_rect.maxy = -DBL_MAX;
 
-  dx = (rect->maxx - rect->minx)/NUMBER_OF_SAMPLE_POINTS;
-  dy = (rect->maxy - rect->miny)/NUMBER_OF_SAMPLE_POINTS;
+  dx = (rect->maxx - rect->minx) / NUMBER_OF_SAMPLE_POINTS;
+  dy = (rect->maxy - rect->miny) / NUMBER_OF_SAMPLE_POINTS;
 
   /* first ensure the top left corner is processed, even if the rect
      turns out to be degenerate. */
@@ -1848,35 +1790,35 @@ int msProjectRectGrid(reprojectionObj* r
   prj_point.z = 0.0;
   prj_point.m = 0.0;
 
-  msProjectGrowRect(reprojector,&prj_rect,&prj_point,
-                    &failure);
+  msProjectGrowRect(reprojector, &prj_rect, &prj_point, &failure);
 
   failure = 0;
-  for(ix = 0; ix <= NUMBER_OF_SAMPLE_POINTS; ix++ ) {
+  for (ix = 0; ix <= NUMBER_OF_SAMPLE_POINTS; ix++) {
     x = rect->minx + ix * dx;
 
-    for(iy = 0; iy <= NUMBER_OF_SAMPLE_POINTS; iy++ ) {
+    for (iy = 0; iy <= NUMBER_OF_SAMPLE_POINTS; iy++) {
       y = rect->miny + iy * dy;
 
       prj_point.x = x;
       prj_point.y = y;
-      msProjectGrowRect(reprojector,&prj_rect,&prj_point,
-                        &failure);
+      msProjectGrowRect(reprojector, &prj_rect, &prj_point, &failure);
     }
   }
 
-  if( prj_rect.minx > prj_rect.maxx ) {
+  if (prj_rect.minx > prj_rect.maxx) {
     rect->minx = 0;
     rect->maxx = 0;
     rect->miny = 0;
     rect->maxy = 0;
 
-    msSetError(MS_PROJERR, "All points failed to reproject.", "msProjectRect()");
+    msSetError(MS_PROJERR, "All points failed to reproject.",
+               "msProjectRect()");
     return MS_FAILURE;
   }
 
-  if( failure ) {
-      msDebug( "msProjectRect(): some points failed to reproject, doing internal sampling.\n" );
+  if (failure) {
+    msDebug("msProjectRect(): some points failed to reproject, doing internal "
+            "sampling.\n");
   }
 
   rect->minx = prj_rect.minx;
@@ -1884,27 +1826,26 @@ int msProjectRectGrid(reprojectionObj* r
   rect->maxx = prj_rect.maxx;
   rect->maxy = prj_rect.maxy;
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
 /************************************************************************/
 /*                       msProjectRectAsPolygon()                       */
 /************************************************************************/
 
-int msProjectRectAsPolygon(reprojectionObj* reprojector, rectObj *rect)
-{
+int msProjectRectAsPolygon(reprojectionObj *reprojector, rectObj *rect) {
   shapeObj polygonObj;
-  lineObj  ring;
+  lineObj ring;
   /*  pointObj ringPoints[NUMBER_OF_SAMPLE_POINTS*4+4]; */
   pointObj *ringPoints;
-  int     ix, iy, ixy;
+  int ix, iy, ixy;
 
   double dx, dy;
 
   /* If projecting from longlat to projected */
   /* This hack was introduced for WFS 2.0 compliance testing, but is far */
   /* from being perfect */
-  if( reprojector->out && !msProjIsGeographicCRS(reprojector->out) &&
+  if (reprojector->out && !msProjIsGeographicCRS(reprojector->out) &&
       reprojector->in && msProjIsGeographicCRS(reprojector->in) &&
       fabs(rect->minx - -180.0) < 1e-5 && fabs(rect->miny - -90.0) < 1e-5 &&
       fabs(rect->maxx - 180.0) < 1e-5 && fabs(rect->maxy - 90.0) < 1e-5) {
@@ -1915,19 +1856,17 @@ int msProjectRectAsPolygon(reprojectionO
     /* Detect if we are reprojecting from EPSG:4326 to EPSG:3857 */
     /* and if so use more plausible bounds to avoid issues with computed */
     /* resolution for WCS */
-    if (fabs(pointTest.x - -20037508.3427892) < 1e-5 && fabs(pointTest.y - 19971868.8804086) )
-    {
-        rect->minx = -20037508.3427892;
-        rect->miny = -20037508.3427892;
-        rect->maxx = 20037508.3427892;
-        rect->maxy = 20037508.3427892;
-    }
-    else
-    {
-        rect->minx = -1e15;
-        rect->miny = -1e15;
-        rect->maxx = 1e15;
-        rect->maxy = 1e15;
+    if (fabs(pointTest.x - -20037508.3427892) < 1e-5 &&
+        fabs(pointTest.y - 19971868.8804086)) {
+      rect->minx = -20037508.3427892;
+      rect->miny = -20037508.3427892;
+      rect->maxx = 20037508.3427892;
+      rect->maxy = 20037508.3427892;
+    } else {
+      rect->minx = -1e15;
+      rect->miny = -1e15;
+      rect->maxx = 1e15;
+      rect->maxy = 1e15;
     }
     return MS_SUCCESS;
   }
@@ -1936,77 +1875,82 @@ int msProjectRectAsPolygon(reprojectionO
   /*      Build polygon as steps around the source rectangle              */
   /*      and possibly its diagonal.                                      */
   /* -------------------------------------------------------------------- */
-  dx = (rect->maxx - rect->minx)/NUMBER_OF_SAMPLE_POINTS;
-  dy = (rect->maxy - rect->miny)/NUMBER_OF_SAMPLE_POINTS;
+  dx = (rect->maxx - rect->minx) / NUMBER_OF_SAMPLE_POINTS;
+  dy = (rect->maxy - rect->miny) / NUMBER_OF_SAMPLE_POINTS;
 
-  if(dx==0 && dy==0) {
+  if (dx == 0 && dy == 0) {
     pointObj foo;
-    msDebug( "msProjectRect(): Warning: degenerate rect {%f,%f,%f,%f}\n",rect->minx,rect->miny,rect->minx,rect->miny );
+    msDebug("msProjectRect(): Warning: degenerate rect {%f,%f,%f,%f}\n",
+            rect->minx, rect->miny, rect->minx, rect->miny);
     foo.x = rect->minx;
     foo.y = rect->miny;
-    msProjectPointEx(reprojector,&foo);
-    rect->minx=rect->maxx=foo.x;
-    rect->miny=rect->maxy=foo.y;
+    msProjectPointEx(reprojector, &foo);
+    rect->minx = rect->maxx = foo.x;
+    rect->miny = rect->maxy = foo.y;
     return MS_SUCCESS;
   }
-  
-  /* If there is more than two sample points we will also get samples from the diagonal line */
-  ringPoints = (pointObj*) calloc(sizeof(pointObj),NUMBER_OF_SAMPLE_POINTS*5+3);
+
+  /* If there is more than two sample points we will also get samples from the
+   * diagonal line */
+  ringPoints =
+      (pointObj *)calloc(sizeof(pointObj), NUMBER_OF_SAMPLE_POINTS * 5 + 3);
   ring.point = ringPoints;
   ring.numpoints = 0;
 
-  msInitShape( &polygonObj );
+  msInitShape(&polygonObj);
   polygonObj.type = MS_SHAPE_POLYGON;
 
   /* sample along top */
-  if(dx != 0) {
-    for(ix = 0; ix <= NUMBER_OF_SAMPLE_POINTS; ix++ ) {
+  if (dx != 0) {
+    for (ix = 0; ix <= NUMBER_OF_SAMPLE_POINTS; ix++) {
       ringPoints[ring.numpoints].x = rect->minx + ix * dx;
       ringPoints[ring.numpoints++].y = rect->miny;
     }
   }
 
   /* sample along right side */
-  if(dy != 0) {
-    for(iy = 1; iy <= NUMBER_OF_SAMPLE_POINTS; iy++ ) {
+  if (dy != 0) {
+    for (iy = 1; iy <= NUMBER_OF_SAMPLE_POINTS; iy++) {
       ringPoints[ring.numpoints].x = rect->maxx;
       ringPoints[ring.numpoints++].y = rect->miny + iy * dy;
     }
   }
 
   /* sample along bottom */
-  if(dx != 0) {
-    for(ix = NUMBER_OF_SAMPLE_POINTS-1; ix >= 0; ix-- ) {
+  if (dx != 0) {
+    for (ix = NUMBER_OF_SAMPLE_POINTS - 1; ix >= 0; ix--) {
       ringPoints[ring.numpoints].x = rect->minx + ix * dx;
       ringPoints[ring.numpoints++].y = rect->maxy;
     }
   }
 
   /* sample along left side */
-  if(dy != 0) {
-    for(iy = NUMBER_OF_SAMPLE_POINTS-1; iy >= 0; iy-- ) {
+  if (dy != 0) {
+    for (iy = NUMBER_OF_SAMPLE_POINTS - 1; iy >= 0; iy--) {
       ringPoints[ring.numpoints].x = rect->minx;
       ringPoints[ring.numpoints++].y = rect->miny + iy * dy;
     }
   }
 
   /* sample along diagonal line */
-  /* This is done to handle cases where reprojection from world covering projection to one */
-  /* which isn't could cause min and max values of the projected rectangle to be invalid */
-  if(dy != 0 && dx != 0) {
+  /* This is done to handle cases where reprojection from world covering
+   * projection to one */
+  /* which isn't could cause min and max values of the projected rectangle to be
+   * invalid */
+  if (dy != 0 && dx != 0) {
     /* No need to compute corners as they've already been computed */
-    for(ixy = NUMBER_OF_SAMPLE_POINTS-2; ixy >= 1; ixy-- ) {
+    for (ixy = NUMBER_OF_SAMPLE_POINTS - 2; ixy >= 1; ixy--) {
       ringPoints[ring.numpoints].x = rect->minx + ixy * dx;
       ringPoints[ring.numpoints++].y = rect->miny + ixy * dy;
     }
   }
 
-  msAddLineDirectly( &polygonObj, &ring );
+  msAddLineDirectly(&polygonObj, &ring);
 
 #ifdef notdef
-  FILE *wkt = fopen("/tmp/www-before.wkt","w");
+  FILE *wkt = fopen("/tmp/www-before.wkt", "w");
   char *tmp = msShapeToWKT(&polygonObj);
-  fprintf(wkt,"%s\n", tmp);
+  fprintf(wkt, "%s\n", tmp);
   free(tmp);
   fclose(wkt);
 #endif
@@ -2014,18 +1958,18 @@ int msProjectRectAsPolygon(reprojectionO
   /* -------------------------------------------------------------------- */
   /*      Attempt to reproject.                                           */
   /* -------------------------------------------------------------------- */
-  msProjectShapeLine( reprojector, &polygonObj, 0 );
+  msProjectShapeLine(reprojector, &polygonObj, 0);
 
   /* If no points reprojected, try a grid sampling */
-  if( polygonObj.numlines == 0 || polygonObj.line[0].numpoints == 0 ) {
-    msFreeShape( &polygonObj );
-    return msProjectRectGrid( reprojector, rect );
+  if (polygonObj.numlines == 0 || polygonObj.line[0].numpoints == 0) {
+    msFreeShape(&polygonObj);
+    return msProjectRectGrid(reprojector, rect);
   }
 
 #ifdef notdef
-  wkt = fopen("/tmp/www-after.wkt","w");
+  wkt = fopen("/tmp/www-after.wkt", "w");
   tmp = msShapeToWKT(&polygonObj);
-  fprintf(wkt,"%s\n", tmp);
+  fprintf(wkt, "%s\n", tmp);
   free(tmp);
   fclose(wkt);
 #endif
@@ -2036,16 +1980,16 @@ int msProjectRectAsPolygon(reprojectionO
   rect->minx = rect->maxx = polygonObj.line[0].point[0].x;
   rect->miny = rect->maxy = polygonObj.line[0].point[0].y;
 
-  for( ix = 1; ix < polygonObj.line[0].numpoints; ix++ ) {
-    pointObj  *pnt = polygonObj.line[0].point + ix;
+  for (ix = 1; ix < polygonObj.line[0].numpoints; ix++) {
+    pointObj *pnt = polygonObj.line[0].point + ix;
 
-    rect->minx = MS_MIN(rect->minx,pnt->x);
-    rect->maxx = MS_MAX(rect->maxx,pnt->x);
-    rect->miny = MS_MIN(rect->miny,pnt->y);
-    rect->maxy = MS_MAX(rect->maxy,pnt->y);
+    rect->minx = MS_MIN(rect->minx, pnt->x);
+    rect->maxx = MS_MAX(rect->maxx, pnt->x);
+    rect->miny = MS_MIN(rect->miny, pnt->y);
+    rect->maxy = MS_MAX(rect->maxy, pnt->y);
   }
 
-  msFreeShape( &polygonObj );
+  msFreeShape(&polygonObj);
 
   /* -------------------------------------------------------------------- */
   /*      Special case to handle reprojection from "more than the         */
@@ -2053,10 +1997,10 @@ int msProjectRectAsPolygon(reprojectionO
   /*      region greater than 360 degrees wide due to various wrapping    */
   /*      logic.                                                          */
   /* -------------------------------------------------------------------- */
-  if( reprojector->out && msProjIsGeographicCRS(reprojector->out) &&
-      reprojector->in && !msProjIsGeographicCRS(reprojector->in)
-      && rect->maxx - rect->minx > 360.0 &&
-      !reprojector->out->gt.need_geotransform ) {
+  if (reprojector->out && msProjIsGeographicCRS(reprojector->out) &&
+      reprojector->in && !msProjIsGeographicCRS(reprojector->in) &&
+      rect->maxx - rect->minx > 360.0 &&
+      !reprojector->out->gt.need_geotransform) {
     rect->maxx = 180;
     rect->minx = -180;
   }
@@ -2068,264 +2012,239 @@ int msProjectRectAsPolygon(reprojectionO
 /*                        msProjectHasLonWrap()                         */
 /************************************************************************/
 
-int msProjectHasLonWrap(projectionObj *in, double* pdfLonWrap)
-{
-    int i;
-    if( pdfLonWrap )
-        *pdfLonWrap = 0;
+int msProjectHasLonWrap(projectionObj *in, double *pdfLonWrap) {
+  int i;
+  if (pdfLonWrap)
+    *pdfLonWrap = 0;
 
-    if( !msProjIsGeographicCRS(in) )
-        return MS_FALSE;
+  if (!msProjIsGeographicCRS(in))
+    return MS_FALSE;
 
-    for( i = 0; i < in->numargs; i++ )
-    {
-        if( strncmp(in->args[i], "lon_wrap=",
-                    strlen("lon_wrap=")) == 0 )
-        {
-            if( pdfLonWrap )
-                *pdfLonWrap = atof(in->args[i] + strlen("lon_wrap="));
-            return MS_TRUE;
-        }
+  for (i = 0; i < in->numargs; i++) {
+    if (strncmp(in->args[i], "lon_wrap=", strlen("lon_wrap=")) == 0) {
+      if (pdfLonWrap)
+        *pdfLonWrap = atof(in->args[i] + strlen("lon_wrap="));
+      return MS_TRUE;
     }
-    return MS_FALSE;
+  }
+  return MS_FALSE;
 }
 
 /************************************************************************/
 /*                           msProjectRect()                            */
 /************************************************************************/
 
-int msProjectRect(projectionObj *in, projectionObj *out, rectObj *rect)
-{
+int msProjectRect(projectionObj *in, projectionObj *out, rectObj *rect) {
   char *over = "+over";
   int ret;
   int bFreeInOver = MS_FALSE;
   int bFreeOutOver = MS_FALSE;
-  projectionObj in_over,out_over,*inp,*outp;
+  projectionObj in_over, out_over, *inp, *outp;
   double dfLonWrap = 0.0;
-  reprojectionObj* reprojector = NULL;
+  reprojectionObj *reprojector = NULL;
 
   /* Detect projecting from polar stereographic to longlat */
-  if( in && !in->gt.need_geotransform &&
-      out && !out->gt.need_geotransform &&
-      !msProjIsGeographicCRS(in) && msProjIsGeographicCRS(out) )
-  {
-      reprojector = msProjectCreateReprojector(in, out);
-      for( int sign = 1; sign >= -1; sign -= 2 )
-      {
-          pointObj p;
-          p.x = 0.0;
-          p.y = 0.0;
-          if( reprojector &&
-              msProjectPointEx(reprojector, &p) == MS_SUCCESS &&
-              fabs(p.y - sign * 90) < 1e-8 )
-          {
-            /* Is the pole in the rectangle ? */
-            if( 0 >= rect->minx && 0 >= rect->miny &&
-                0 <= rect->maxx && 0 <= rect->maxy )
-            {
-                if( msProjectRectAsPolygon(reprojector, rect ) == MS_SUCCESS )
-                {
-                    rect->minx = -180.0;
-                    rect->maxx = 180.0;
-                    rect->maxy = sign * 90.0;
-                    msProjectDestroyReprojector(reprojector);
-                    return MS_SUCCESS;
-                }
-            }
-            /* Are we sure the dateline is not enclosed ? */
-            else if( rect->maxy < 0 || rect->maxx < 0 || rect->minx > 0 )
-            {
-                ret = msProjectRectAsPolygon(reprojector, rect );
-                msProjectDestroyReprojector(reprojector);
-                return ret;
-            }
+  if (in && !in->gt.need_geotransform && out && !out->gt.need_geotransform &&
+      !msProjIsGeographicCRS(in) && msProjIsGeographicCRS(out)) {
+    reprojector = msProjectCreateReprojector(in, out);
+    for (int sign = 1; sign >= -1; sign -= 2) {
+      pointObj p;
+      p.x = 0.0;
+      p.y = 0.0;
+      if (reprojector && msProjectPointEx(reprojector, &p) == MS_SUCCESS &&
+          fabs(p.y - sign * 90) < 1e-8) {
+        /* Is the pole in the rectangle ? */
+        if (0 >= rect->minx && 0 >= rect->miny && 0 <= rect->maxx &&
+            0 <= rect->maxy) {
+          if (msProjectRectAsPolygon(reprojector, rect) == MS_SUCCESS) {
+            rect->minx = -180.0;
+            rect->maxx = 180.0;
+            rect->maxy = sign * 90.0;
+            msProjectDestroyReprojector(reprojector);
+            return MS_SUCCESS;
           }
+        }
+        /* Are we sure the dateline is not enclosed ? */
+        else if (rect->maxy < 0 || rect->maxx < 0 || rect->minx > 0) {
+          ret = msProjectRectAsPolygon(reprojector, rect);
+          msProjectDestroyReprojector(reprojector);
+          return ret;
+        }
       }
+    }
   }
 
   /* Detect projecting from polar stereographic to another projected system */
-  else if( in && !in->gt.need_geotransform &&
-      out && !out->gt.need_geotransform &&
-      !msProjIsGeographicCRS(in) && !msProjIsGeographicCRS(out) )
-  {
-      reprojectionObj* reprojectorToLongLat = msProjectCreateReprojector(in, NULL);
-      for( int sign = 1; sign >= -1; sign -= 2 )
-      {
-          pointObj p;
-          p.x = 0.0;
-          p.y = 0.0;
-          if( reprojectorToLongLat &&
-              msProjectPointEx(reprojectorToLongLat, &p) == MS_SUCCESS &&
-              fabs(p.y - 90) < 1e-8 )
-          {
-            reprojector = msProjectCreateReprojector(in, out);
-            /* Is the pole in the rectangle ? */
-            if( 0 >= rect->minx && 0 >= rect->miny &&
-                0 <= rect->maxx && 0 <= rect->maxy )
-            {
-                if( msProjectRectAsPolygon(reprojector, rect ) == MS_SUCCESS )
-                {
-                    msProjectDestroyReprojector(reprojector);
-                    msProjectDestroyReprojector(reprojectorToLongLat);
-                    return MS_SUCCESS;
-                }
-            }
-            /* Are we sure the dateline is not enclosed ? */
-            else if( rect->maxy < 0 || rect->maxx < 0 || rect->minx > 0 )
-            {
-                ret = msProjectRectAsPolygon(reprojector, rect );
-                msProjectDestroyReprojector(reprojector);
-                msProjectDestroyReprojector(reprojectorToLongLat);
-                return ret;
-            }
+  else if (in && !in->gt.need_geotransform && out &&
+           !out->gt.need_geotransform && !msProjIsGeographicCRS(in) &&
+           !msProjIsGeographicCRS(out)) {
+    reprojectionObj *reprojectorToLongLat =
+        msProjectCreateReprojector(in, NULL);
+    for (int sign = 1; sign >= -1; sign -= 2) {
+      pointObj p;
+      p.x = 0.0;
+      p.y = 0.0;
+      if (reprojectorToLongLat &&
+          msProjectPointEx(reprojectorToLongLat, &p) == MS_SUCCESS &&
+          fabs(p.y - 90) < 1e-8) {
+        reprojector = msProjectCreateReprojector(in, out);
+        /* Is the pole in the rectangle ? */
+        if (0 >= rect->minx && 0 >= rect->miny && 0 <= rect->maxx &&
+            0 <= rect->maxy) {
+          if (msProjectRectAsPolygon(reprojector, rect) == MS_SUCCESS) {
+            msProjectDestroyReprojector(reprojector);
+            msProjectDestroyReprojector(reprojectorToLongLat);
+            return MS_SUCCESS;
           }
+        }
+        /* Are we sure the dateline is not enclosed ? */
+        else if (rect->maxy < 0 || rect->maxx < 0 || rect->minx > 0) {
+          ret = msProjectRectAsPolygon(reprojector, rect);
+          msProjectDestroyReprojector(reprojector);
+          msProjectDestroyReprojector(reprojectorToLongLat);
+          return ret;
+        }
       }
-      msProjectDestroyReprojector(reprojectorToLongLat);
+    }
+    msProjectDestroyReprojector(reprojectorToLongLat);
   }
 
-
-  if(in && msProjectHasLonWrap(in, &dfLonWrap) && dfLonWrap == 180.0) {
+  if (in && msProjectHasLonWrap(in, &dfLonWrap) && dfLonWrap == 180.0) {
     inp = in;
     outp = out;
-    if( rect->maxx > 180.0 ) {
+    if (rect->maxx > 180.0) {
       rect->minx = -180.0;
       rect->maxx = 180.0;
     }
   }
-  /* 
-   * Issue #4892: When projecting a rectangle we do not want proj to wrap resulting
-   * coordinates around the dateline, as in practice a requested bounding box of
-   * -22.000.000, -YYY, 22.000.000, YYY should be projected as
-   * -190,-YYY,190,YYY rather than 170,-YYY,-170,YYY as would happen when wrapping (and
-   *  vice-versa when projecting from lonlat to metric).
-   *  To enforce this, we clone the input projections and add the "+over" proj 
-   *  parameter in order to disable dateline wrapping.
-   */ 
+  /*
+   * Issue #4892: When projecting a rectangle we do not want proj to wrap
+   * resulting coordinates around the dateline, as in practice a requested
+   * bounding box of -22.000.000, -YYY, 22.000.000, YYY should be projected as
+   * -190,-YYY,190,YYY rather than 170,-YYY,-170,YYY as would happen when
+   * wrapping (and vice-versa when projecting from lonlat to metric). To enforce
+   * this, we clone the input projections and add the "+over" proj parameter in
+   * order to disable dateline wrapping.
+   */
   else {
     int apply_over = MS_TRUE;
 #if PROJ_VERSION_MAJOR >= 6 && PROJ_VERSION_MAJOR < 9
-    // Workaround PROJ [6,9[ bug (fixed per https://github.com/OSGeo/PROJ/pull/3055)
-    // that prevents datum shifts from being applied when +over is added to +init=epsg:XXXX
-    // This is far from being bullet proof but it should work for most common use cases
-    if(in && in->proj)
-    {
-        if( in->numargs == 1 && EQUAL(in->args[0], "init=epsg:4326") &&
-            rect->minx >= -180 && rect->maxx <= 180 )
-        {
-            apply_over = MS_FALSE;
-        }
-        else if( in->numargs == 1 && EQUAL(in->args[0], "init=epsg:3857") &&
-                 rect->minx >= -20037508.3427892 && rect->maxx <= 20037508.3427892 )
-        {
-            apply_over = MS_FALSE;
-        }
+    // Workaround PROJ [6,9[ bug (fixed per
+    // https://github.com/OSGeo/PROJ/pull/3055) that prevents datum shifts from
+    // being applied when +over is added to +init=epsg:XXXX This is far from
+    // being bullet proof but it should work for most common use cases
+    if (in && in->proj) {
+      if (in->numargs == 1 && EQUAL(in->args[0], "init=epsg:4326") &&
+          rect->minx >= -180 && rect->maxx <= 180) {
+        apply_over = MS_FALSE;
+      } else if (in->numargs == 1 && EQUAL(in->args[0], "init=epsg:3857") &&
+                 rect->minx >= -20037508.3427892 &&
+                 rect->maxx <= 20037508.3427892) {
+        apply_over = MS_FALSE;
+      }
     }
 #endif
-    if(out && apply_over && out->numargs > 0 &&
-        (strncmp(out->args[0], "init=", 5) == 0 || strncmp(out->args[0], "proj=", 5) == 0)) {
+    if (out && apply_over && out->numargs > 0 &&
+        (strncmp(out->args[0], "init=", 5) == 0 ||
+         strncmp(out->args[0], "proj=", 5) == 0)) {
       bFreeOutOver = MS_TRUE;
       msInitProjection(&out_over);
-      msCopyProjectionExtended(&out_over,out,&over,1);
+      msCopyProjectionExtended(&out_over, out, &over, 1);
       outp = &out_over;
-      if( reprojector ) {
-          msProjectDestroyReprojector(reprojector);
-          reprojector = NULL;
+      if (reprojector) {
+        msProjectDestroyReprojector(reprojector);
+        reprojector = NULL;
       }
     } else {
       outp = out;
     }
-    if(in && apply_over && in->numargs > 0 &&
-        (strncmp(in->args[0], "init=", 5) == 0 || strncmp(in->args[0], "proj=", 5) == 0)) {
+    if (in && apply_over && in->numargs > 0 &&
+        (strncmp(in->args[0], "init=", 5) == 0 ||
+         strncmp(in->args[0], "proj=", 5) == 0)) {
       bFreeInOver = MS_TRUE;
       msInitProjection(&in_over);
-      msCopyProjectionExtended(&in_over,in,&over,1);
+      msCopyProjectionExtended(&in_over, in, &over, 1);
       inp = &in_over;
       /* coverity[dead_error_begin] */
-      if( reprojector ) {
-          msProjectDestroyReprojector(reprojector);
-          reprojector = NULL;
+      if (reprojector) {
+        msProjectDestroyReprojector(reprojector);
+        reprojector = NULL;
       }
     } else {
       inp = in;
     }
   }
-  if( reprojector == NULL )
-  {
-     reprojector = msProjectCreateReprojector(inp, outp);
+  if (reprojector == NULL) {
+    reprojector = msProjectCreateReprojector(inp, outp);
   }
-  ret = reprojector ? msProjectRectAsPolygon(reprojector, rect ) : MS_FAILURE;
+  ret = reprojector ? msProjectRectAsPolygon(reprojector, rect) : MS_FAILURE;
   msProjectDestroyReprojector(reprojector);
-  if(bFreeInOver)
+  if (bFreeInOver)
     msFreeProjection(&in_over);
-  if(bFreeOutOver)
+  if (bFreeOutOver)
     msFreeProjection(&out_over);
   return ret;
 }
 
 #if PROJ_VERSION_MAJOR < 6
 
-static int msProjectSortString(const void* firstelt, const void* secondelt)
-{
-    char* firststr = *(char**)firstelt;
-    char* secondstr = *(char**)secondelt;
-    return strcmp(firststr, secondstr);
+static int msProjectSortString(const void *firstelt, const void *secondelt) {
+  char *firststr = *(char **)firstelt;
+  char *secondstr = *(char **)secondelt;
+  return strcmp(firststr, secondstr);
 }
 
 /************************************************************************/
 /*                        msGetProjectNormalized()                      */
 /************************************************************************/
 
-static projectionObj* msGetProjectNormalized( const projectionObj* p )
-{
+static projectionObj *msGetProjectNormalized(const projectionObj *p) {
   int i;
 #if PROJ_VERSION_MAJOR >= 6
-  const char* pszNewProj4Def;
+  const char *pszNewProj4Def;
 #else
-  char* pszNewProj4Def;
+  char *pszNewProj4Def;
 #endif
-  projectionObj* pnew;
+  projectionObj *pnew;
 
-  pnew = (projectionObj*)msSmallMalloc(sizeof(projectionObj));
+  pnew = (projectionObj *)msSmallMalloc(sizeof(projectionObj));
   msInitProjection(pnew);
-  msCopyProjection(pnew, (projectionObj*)p);
+  msCopyProjection(pnew, (projectionObj *)p);
 
-  if(p->proj == NULL )
-      return pnew;
+  if (p->proj == NULL)
+    return pnew;
 
-  /* Normalize definition so that msProjectDiffers() works better */
+    /* Normalize definition so that msProjectDiffers() works better */
 #if PROJ_VERSION_MAJOR >= 6
-  pszNewProj4Def = proj_as_proj_string(p->proj_ctx->proj_ctx, p->proj, PJ_PROJ_4, NULL);
+  pszNewProj4Def =
+      proj_as_proj_string(p->proj_ctx->proj_ctx, p->proj, PJ_PROJ_4, NULL);
 #else
-  pszNewProj4Def = pj_get_def( p->proj, 0 );
+  pszNewProj4Def = pj_get_def(p->proj, 0);
 #endif
   msFreeCharArray(pnew->args, pnew->numargs);
-  pnew->args = msStringSplit(pszNewProj4Def,'+', &pnew->numargs);
-  for(i = 0; i < pnew->numargs; i++)
-  {
-      /* Remove trailing space */
-      if( strlen(pnew->args[i]) > 0 && pnew->args[i][strlen(pnew->args[i])-1] == ' ' )
-          pnew->args[i][strlen(pnew->args[i])-1] = '\0';
-      /* Remove spurious no_defs or init= */
-      if( strcmp(pnew->args[i], "no_defs") == 0 ||
-          strncmp(pnew->args[i], "init=", 5) == 0 )
-      {
-          if( i < pnew->numargs - 1 )
-          {
-              msFree(pnew->args[i]);
-              memmove(pnew->args + i, pnew->args + i + 1,
-                      sizeof(char*) * (pnew->numargs - 1 -i ));
-          }
-          else 
-          {
-              msFree(pnew->args[i]);
-          }
-          pnew->numargs --;
-          i --;
-          continue;
+  pnew->args = msStringSplit(pszNewProj4Def, '+', &pnew->numargs);
+  for (i = 0; i < pnew->numargs; i++) {
+    /* Remove trailing space */
+    if (strlen(pnew->args[i]) > 0 &&
+        pnew->args[i][strlen(pnew->args[i]) - 1] == ' ')
+      pnew->args[i][strlen(pnew->args[i]) - 1] = '\0';
+    /* Remove spurious no_defs or init= */
+    if (strcmp(pnew->args[i], "no_defs") == 0 ||
+        strncmp(pnew->args[i], "init=", 5) == 0) {
+      if (i < pnew->numargs - 1) {
+        msFree(pnew->args[i]);
+        memmove(pnew->args + i, pnew->args + i + 1,
+                sizeof(char *) * (pnew->numargs - 1 - i));
+      } else {
+        msFree(pnew->args[i]);
       }
+      pnew->numargs--;
+      i--;
+      continue;
+    }
   }
   /* Sort the strings so they can be compared */
-  qsort(pnew->args, pnew->numargs, sizeof(char*), msProjectSortString);
+  qsort(pnew->args, pnew->numargs, sizeof(char *), msProjectSortString);
   /*{
       fprintf(stderr, "'%s' =\n", pszNewProj4Def);
       for(i = 0; i < p->numargs; i++)
@@ -2355,55 +2274,53 @@ static projectionObj* msGetProjectNormal
 ** has no arguments, since reprojection won't work anyways.
 */
 
-static int msProjectionsDifferInternal( projectionObj *proj1, projectionObj *proj2 )
+static int msProjectionsDifferInternal(projectionObj *proj1,
+                                       projectionObj *proj2)
 
 {
-  int   i;
+  int i;
 
-  if( proj1->numargs == 0 || proj2->numargs == 0 )
+  if (proj1->numargs == 0 || proj2->numargs == 0)
     return MS_FALSE;
 
-  if( proj1->numargs != proj2->numargs )
+  if (proj1->numargs != proj2->numargs)
     return MS_TRUE;
 
   /* This test should be more rigerous. */
-  if( proj1->gt.need_geotransform
-      || proj2->gt.need_geotransform )
+  if (proj1->gt.need_geotransform || proj2->gt.need_geotransform)
     return MS_TRUE;
 
-  for( i = 0; i < proj1->numargs; i++ ) {
-    if( strcmp(proj1->args[i],proj2->args[i]) != 0 )
+  for (i = 0; i < proj1->numargs; i++) {
+    if (strcmp(proj1->args[i], proj2->args[i]) != 0)
       return MS_TRUE;
   }
 
   return MS_FALSE;
 }
 
-int msProjectionsDiffer( projectionObj *proj1, projectionObj *proj2 )
-{
-    int ret;
+int msProjectionsDiffer(projectionObj *proj1, projectionObj *proj2) {
+  int ret;
 
-    ret = msProjectionsDifferInternal(proj1, proj2);
+  ret = msProjectionsDifferInternal(proj1, proj2);
 #if PROJ_VERSION_MAJOR < 6
-    if( ret &&
-        /* to speed up things, do normalization only if one proj is */
-        /* likely of the form init=epsg:XXX and the other proj=XXX datum=YYY... */
-        ( (proj1->numargs == 1 && proj2->numargs > 1) ||
-          (proj1->numargs > 1 && proj2->numargs == 1) ) )
-    {
-        projectionObj* p1normalized;
-        projectionObj* p2normalized;
-
-        p1normalized = msGetProjectNormalized( proj1 );
-        p2normalized = msGetProjectNormalized( proj2 );
-        ret = msProjectionsDifferInternal(p1normalized, p2normalized);
-        msFreeProjection(p1normalized);
-        msFree(p1normalized);
-        msFreeProjection(p2normalized);
-        msFree(p2normalized);
-    }
+  if (ret &&
+      /* to speed up things, do normalization only if one proj is */
+      /* likely of the form init=epsg:XXX and the other proj=XXX datum=YYY... */
+      ((proj1->numargs == 1 && proj2->numargs > 1) ||
+       (proj1->numargs > 1 && proj2->numargs == 1))) {
+    projectionObj *p1normalized;
+    projectionObj *p2normalized;
+
+    p1normalized = msGetProjectNormalized(proj1);
+    p2normalized = msGetProjectNormalized(proj2);
+    ret = msProjectionsDifferInternal(p1normalized, p2normalized);
+    msFreeProjection(p1normalized);
+    msFree(p1normalized);
+    msFreeProjection(p2normalized);
+    msFree(p2normalized);
+  }
 #endif
-    return ret;
+  return ret;
 }
 
 /************************************************************************/
@@ -2476,30 +2393,30 @@ reprojected to geographic space.  Howeve
 
 */
 
-static int msTestNeedWrap( pointObj pt1, pointObj pt2, pointObj pt2_geo,
-                           reprojectionObj* reprojector )
+static int msTestNeedWrap(pointObj pt1, pointObj pt2, pointObj pt2_geo,
+                          reprojectionObj *reprojector)
 
 {
-  pointObj  middle;
-  projectionObj* out = reprojector->out;
+  pointObj middle;
+  projectionObj *out = reprojector->out;
 
   middle.x = (pt1.x + pt2.x) * 0.5;
   middle.y = (pt1.y + pt2.y) * 0.5;
 
-  if( msProjectPointEx( reprojector, &pt1 ) == MS_FAILURE
-      || msProjectPointEx( reprojector, &pt2 ) == MS_FAILURE
-      || msProjectPointEx( reprojector, &middle ) == MS_FAILURE )
+  if (msProjectPointEx(reprojector, &pt1) == MS_FAILURE ||
+      msProjectPointEx(reprojector, &pt2) == MS_FAILURE ||
+      msProjectPointEx(reprojector, &middle) == MS_FAILURE)
     return 0;
 
   /*
    * If the last point was moved, then we are considered due for a
    * move to.
    */
-  if( out->gt.need_geotransform && out->gt.geotransform[2] == 0 ) {
-    if( fabs( (pt2_geo.x-pt2.x) * out->gt.geotransform[1] ) > 180.0 )
+  if (out->gt.need_geotransform && out->gt.geotransform[2] == 0) {
+    if (fabs((pt2_geo.x - pt2.x) * out->gt.geotransform[1]) > 180.0)
       return 1;
   } else {
-    if( fabs(pt2_geo.x-pt2.x) > 180.0 )
+    if (fabs(pt2_geo.x - pt2.x) > 180.0)
       return 1;
   }
 
@@ -2508,8 +2425,8 @@ static int msTestNeedWrap( pointObj pt1,
    * to be between the end points. If yes, no wrapping is needed.
    * Otherwise wrapping is needed.
    */
-  if( (middle.x < pt1.x && middle.x < pt2_geo.x)
-      || (middle.x > pt1.x && middle.x > pt2_geo.x) )
+  if ((middle.x < pt1.x && middle.x < pt2_geo.x) ||
+      (middle.x > pt1.x && middle.x > pt2_geo.x))
     return 1;
   else
     return 0;
@@ -2522,20 +2439,20 @@ static int msTestNeedWrap( pointObj pt1,
 #if PROJ_VERSION_MAJOR < 6
 static char *last_filename = NULL;
 
-static const char *msProjFinder( const char *filename)
+static const char *msProjFinder(const char *filename)
 
 {
-  if( last_filename != NULL )
-    free( last_filename );
+  if (last_filename != NULL)
+    free(last_filename);
 
-  if( filename == NULL )
+  if (filename == NULL)
     return NULL;
 
-  if( ms_proj_data == NULL )
+  if (ms_proj_data == NULL)
     return filename;
 
-  last_filename = (char *) malloc(strlen(filename)+strlen(ms_proj_data)+2);
-  sprintf( last_filename, "%s/%s", ms_proj_data, filename );
+  last_filename = (char *)malloc(strlen(filename) + strlen(ms_proj_data) + 2);
+  sprintf(last_filename, "%s/%s", ms_proj_data, filename);
 
   return last_filename;
 }
@@ -2544,12 +2461,11 @@ static const char *msProjFinder( const c
 /************************************************************************/
 /*                       msProjDataInitFromEnv()                        */
 /************************************************************************/
-void msProjDataInitFromEnv()
-{
+void msProjDataInitFromEnv() {
   const char *val;
 
-  if( (val=CPLGetConfigOption( "PROJ_DATA", NULL )) != NULL ||
-      (val=CPLGetConfigOption( "PROJ_LIB", NULL )) != NULL ) {
+  if ((val = CPLGetConfigOption("PROJ_DATA", NULL)) != NULL ||
+      (val = CPLGetConfigOption("PROJ_LIB", NULL)) != NULL) {
     msSetPROJ_DATA(val, NULL);
   }
 }
@@ -2557,90 +2473,81 @@ void msProjDataInitFromEnv()
 /************************************************************************/
 /*                           msSetPROJ_DATA()                           */
 /************************************************************************/
-void msSetPROJ_DATA( const char *proj_data, const char *pszRelToPath )
+void msSetPROJ_DATA(const char *proj_data, const char *pszRelToPath)
 
 {
   char *extended_path = NULL;
 
   /* Handle relative path if applicable */
-  if( proj_data && pszRelToPath
-      && proj_data[0] != '/'
-      && proj_data[0] != '\\'
-      && !(proj_data[0] != '\0' && proj_data[1] == ':') ) {
+  if (proj_data && pszRelToPath && proj_data[0] != '/' &&
+      proj_data[0] != '\\' && !(proj_data[0] != '\0' && proj_data[1] == ':')) {
     struct stat stat_buf;
-    extended_path = (char*) msSmallMalloc(strlen(pszRelToPath)
-                                          + strlen(proj_data) + 10);
-    sprintf( extended_path, "%s/%s", pszRelToPath, proj_data );
+    extended_path =
+        (char *)msSmallMalloc(strlen(pszRelToPath) + strlen(proj_data) + 10);
+    sprintf(extended_path, "%s/%s", pszRelToPath, proj_data);
 
 #ifndef S_ISDIR
-#  define S_ISDIR(x) ((x) & S_IFDIR)
+#define S_ISDIR(x) ((x)&S_IFDIR)
 #endif
 
-    if( stat( extended_path, &stat_buf ) == 0
-        && S_ISDIR(stat_buf.st_mode) )
+    if (stat(extended_path, &stat_buf) == 0 && S_ISDIR(stat_buf.st_mode))
       proj_data = extended_path;
   }
 
-
-  msAcquireLock( TLOCK_PROJ );
+  msAcquireLock(TLOCK_PROJ);
 #if PROJ_VERSION_MAJOR >= 6
-  if( proj_data == NULL && ms_proj_data == NULL )
-  {
-     /* do nothing */
-  }
-  else if( proj_data != NULL && ms_proj_data != NULL &&
-           strcmp(proj_data, ms_proj_data) == 0 )
-  {
+  if (proj_data == NULL && ms_proj_data == NULL) {
     /* do nothing */
-  }
-  else
-  {
+  } else if (proj_data != NULL && ms_proj_data != NULL &&
+             strcmp(proj_data, ms_proj_data) == 0) {
+    /* do nothing */
+  } else {
     ms_proj_data_change_counter++;
-    free( ms_proj_data );
+    free(ms_proj_data);
     ms_proj_data = proj_data ? msStrdup(proj_data) : NULL;
   }
 #else
   {
     static int finder_installed = 0;
-    if( finder_installed == 0 && proj_data != NULL) {
+    if (finder_installed == 0 && proj_data != NULL) {
       finder_installed = 1;
-      pj_set_finder( msProjFinder );
+      pj_set_finder(msProjFinder);
     }
   }
 
-  if (proj_data == NULL) pj_set_finder(NULL);
+  if (proj_data == NULL)
+    pj_set_finder(NULL);
 
-  if( ms_proj_data != NULL ) {
-    free( ms_proj_data );
+  if (ms_proj_data != NULL) {
+    free(ms_proj_data);
     ms_proj_data = NULL;
   }
 
-  if( last_filename != NULL ) {
-    free( last_filename );
+  if (last_filename != NULL) {
+    free(last_filename);
     last_filename = NULL;
   }
 
-  if( proj_data != NULL )
-    ms_proj_data = msStrdup( proj_data );
+  if (proj_data != NULL)
+    ms_proj_data = msStrdup(proj_data);
 #endif
-  msReleaseLock( TLOCK_PROJ );
+  msReleaseLock(TLOCK_PROJ);
 
 #if GDAL_VERSION_MAJOR >= 3
-  if( ms_proj_data != NULL )
-  {
+  if (ms_proj_data != NULL) {
 #ifdef _WIN32
-    const char* sep = ";";
+    const char *sep = ";";
 #else
-    const char* sep = ":";
+    const char *sep = ":";
 #endif
-    char** papszPaths = CSLTokenizeString2(ms_proj_data, sep, 0);
-    OSRSetPROJSearchPaths((const char* const *)papszPaths);
+    char **papszPaths = CSLTokenizeString2(ms_proj_data, sep, 0);
+    OSRSetPROJSearchPaths((const char *const *)papszPaths);
     CSLDestroy(papszPaths);
   }
 #endif
 
-  if ( extended_path )
-    msFree( extended_path );
+  if (extended_path)
+    msFree(extended_path);
 }
 
 /************************************************************************/
@@ -2649,27 +2556,26 @@ void msSetPROJ_DATA( const char *proj_da
 /*      Return the projection string.                                   */
 /************************************************************************/
 
-char *msGetProjectionString(projectionObj *proj)
-{
-  char        *pszProjString = NULL;
-  int         nLen = 0;
+char *msGetProjectionString(projectionObj *proj) {
+  char *pszProjString = NULL;
+  int nLen = 0;
 
   if (proj) {
     /* -------------------------------------------------------------------- */
     /*      Alloc buffer large enough to hold the whole projection defn     */
     /* -------------------------------------------------------------------- */
-    for (int i=0; i<proj->numargs; i++) {
+    for (int i = 0; i < proj->numargs; i++) {
       if (proj->args[i])
         nLen += (strlen(proj->args[i]) + 2);
     }
 
-    pszProjString = (char*)malloc(sizeof(char) * nLen+1);
+    pszProjString = (char *)malloc(sizeof(char) * nLen + 1);
     pszProjString[0] = '\0';
 
     /* -------------------------------------------------------------------- */
     /*      Plug each arg into the string with a '+' prefix                 */
     /* -------------------------------------------------------------------- */
-    for (int i=0; i<proj->numargs; i++) {
+    for (int i = 0; i < proj->numargs; i++) {
       if (!proj->args[i] || strlen(proj->args[i]) == 0)
         continue;
       if (pszProjString[0] == '\0') {
@@ -2695,30 +2601,28 @@ char *msGetProjectionString(projectionOb
 /*      Return MS_TRUE is the proj object has epgsaxis=ne               */
 /************************************************************************/
 
-int msIsAxisInvertedProj( projectionObj *proj )
-{
+int msIsAxisInvertedProj(projectionObj *proj) {
   int i;
   const char *axis = NULL;
 
-  for( i = 0; i < proj->numargs; i++ ) {
-    if( strstr(proj->args[i],"epsgaxis=") != NULL ) {
-      axis = strstr(proj->args[i],"=") + 1;
+  for (i = 0; i < proj->numargs; i++) {
+    if (strstr(proj->args[i], "epsgaxis=") != NULL) {
+      axis = strstr(proj->args[i], "=") + 1;
       break;
     }
   }
 
-  if( axis == NULL )
+  if (axis == NULL)
     return MS_FALSE;
 
-  if( strcasecmp(axis,"en") == 0 )
+  if (strcasecmp(axis, "en") == 0)
     return MS_FALSE;
 
-  if( strcasecmp(axis,"ne") != 0 ) {
-    msDebug( "msIsAxisInvertedProj(): odd +epsgaxis= value: '%s'.",
-             axis );
+  if (strcasecmp(axis, "ne") != 0) {
+    msDebug("msIsAxisInvertedProj(): odd +epsgaxis= value: '%s'.", axis);
     return MS_FALSE;
   }
-  
+
   return MS_TRUE;
 }
 
@@ -2729,16 +2633,15 @@ int msIsAxisInvertedProj( projectionObj
 /*      orientation if they are not already.                            */
 /************************************************************************/
 
-void msAxisNormalizePoints( projectionObj *proj, int count,
-                            double *x, double *y )
+void msAxisNormalizePoints(projectionObj *proj, int count, double *x, double *y)
 
 {
   int i;
-  if( !msIsAxisInvertedProj(proj ) )
-      return;
+  if (!msIsAxisInvertedProj(proj))
+    return;
 
   /* Switch axes */
-  for( i = 0; i < count; i++ ) {
+  for (i = 0; i < count; i++) {
     double tmp;
 
     tmp = x[i];
@@ -2747,22 +2650,19 @@ void msAxisNormalizePoints( projectionOb
   }
 }
 
-
-
 /************************************************************************/
 /*                             msAxisSwapShape                          */
 /*                                                                      */
 /*      Utility function to swap x and y coordiatesn Use for now for    */
 /*      WFS 1.1.x                                                       */
 /************************************************************************/
-void msAxisSwapShape(shapeObj *shape)
-{
+void msAxisSwapShape(shapeObj *shape) {
   double tmp;
-  int i,j;
+  int i, j;
 
   if (shape) {
-    for(i=0; i<shape->numlines; i++) {
-      for( j=0; j<shape->line[i].numpoints; j++ ) {
+    for (i = 0; i < shape->numlines; i++) {
+      for (j = 0; j < shape->line[i].numpoints; j++) {
         tmp = shape->line[i].point[j].x;
         shape->line[i].point[j].x = shape->line[i].point[j].y;
         shape->line[i].point[j].y = tmp;
@@ -2787,12 +2687,12 @@ void msAxisSwapShape(shapeObj *shape)
 /*      preferred epsg orientation of this projectionObj.               */
 /************************************************************************/
 
-void msAxisDenormalizePoints( projectionObj *proj, int count,
-                              double *x, double *y )
+void msAxisDenormalizePoints(projectionObj *proj, int count, double *x,
+                             double *y)
 
 {
   /* For how this is essentially identical to normalizing */
-  msAxisNormalizePoints( proj, count, x, y );
+  msAxisNormalizePoints(proj, count, x, y);
 }
 
 /************************************************************************/
@@ -2801,25 +2701,24 @@ void msAxisDenormalizePoints( projection
 /*      Returns whether a CRS is a geographic one.                      */
 /************************************************************************/
 
-int msProjIsGeographicCRS(projectionObj* proj)
-{
+int msProjIsGeographicCRS(projectionObj *proj) {
 #if PROJ_VERSION_MAJOR >= 6
-    PJ_TYPE type;
-    if( !proj->proj )
-        return FALSE;
-    type = proj_get_type(proj->proj);
-    if( type == PJ_TYPE_GEOGRAPHIC_2D_CRS || type == PJ_TYPE_GEOGRAPHIC_3D_CRS )
-        return TRUE;
-    if( type == PJ_TYPE_BOUND_CRS )
-    {
-        PJ* base_crs = proj_get_source_crs(proj->proj_ctx->proj_ctx, proj->proj);
-        type = proj_get_type(base_crs);
-        proj_destroy(base_crs);
-        return type == PJ_TYPE_GEOGRAPHIC_2D_CRS || type == PJ_TYPE_GEOGRAPHIC_3D_CRS;
-    }
+  PJ_TYPE type;
+  if (!proj->proj)
     return FALSE;
+  type = proj_get_type(proj->proj);
+  if (type == PJ_TYPE_GEOGRAPHIC_2D_CRS || type == PJ_TYPE_GEOGRAPHIC_3D_CRS)
+    return TRUE;
+  if (type == PJ_TYPE_BOUND_CRS) {
+    PJ *base_crs = proj_get_source_crs(proj->proj_ctx->proj_ctx, proj->proj);
+    type = proj_get_type(base_crs);
+    proj_destroy(base_crs);
+    return type == PJ_TYPE_GEOGRAPHIC_2D_CRS ||
+           type == PJ_TYPE_GEOGRAPHIC_3D_CRS;
+  }
+  return FALSE;
 #else
-    return proj->proj != NULL && pj_is_latlong(proj->proj);
+  return proj->proj != NULL && pj_is_latlong(proj->proj);
 #endif
 }
 
@@ -2830,17 +2729,19 @@ int msProjIsGeographicCRS(projectionObj*
 /*      unit passed as argument.                                        */
 /*       Please refer to ./src/pj_units.c file in the Proj.4 module.    */
 /************************************************************************/
-static int ConvertProjUnitStringToMS(const char *pszProjUnit)
-{
-  if (strcmp(pszProjUnit, "m") ==0) {
+static int ConvertProjUnitStringToMS(const char *pszProjUnit) {
+  if (strcmp(pszProjUnit, "m") == 0) {
     return MS_METERS;
-  } else if (strcmp(pszProjUnit, "km") ==0) {
+  } else if (strcmp(pszProjUnit, "km") == 0) {
     return MS_KILOMETERS;
-  } else if (strcmp(pszProjUnit, "mi") ==0 || strcmp(pszProjUnit, "us-mi") ==0) {
+  } else if (strcmp(pszProjUnit, "mi") == 0 ||
+             strcmp(pszProjUnit, "us-mi") == 0) {
     return MS_MILES;
-  } else if (strcmp(pszProjUnit, "in") ==0 || strcmp(pszProjUnit, "us-in") ==0 ) {
+  } else if (strcmp(pszProjUnit, "in") == 0 ||
+             strcmp(pszProjUnit, "us-in") == 0) {
     return MS_INCHES;
-  } else if (strcmp(pszProjUnit, "ft") ==0 || strcmp(pszProjUnit, "us-ft") ==0) {
+  } else if (strcmp(pszProjUnit, "ft") == 0 ||
+             strcmp(pszProjUnit, "us-ft") == 0) {
     return MS_FEET;
   } else if (strcmp(pszProjUnit, "kmi") == 0) {
     return MS_NAUTICALMILES;
@@ -2855,82 +2756,82 @@ static int ConvertProjUnitStringToMS(con
 /*      Return a mapserver unit corresponding to the projection         */
 /*      passed. Retunr -1 on failure                                    */
 /************************************************************************/
-int GetMapserverUnitUsingProj(projectionObj *psProj)
-{
+int GetMapserverUnitUsingProj(projectionObj *psProj) {
 #if PROJ_VERSION_MAJOR >= 6
   const char *proj_str;
 #else
   char *proj_str;
 #endif
 
-  if( msProjIsGeographicCRS( psProj ) )
+  if (msProjIsGeographicCRS(psProj))
     return MS_DD;
 
 #if PROJ_VERSION_MAJOR >= 6
-  proj_str = proj_as_proj_string(psProj->proj_ctx->proj_ctx, psProj->proj, PJ_PROJ_4, NULL);
+  proj_str = proj_as_proj_string(psProj->proj_ctx->proj_ctx, psProj->proj,
+                                 PJ_PROJ_4, NULL);
 #else
-  proj_str = pj_get_def( psProj->proj, 0 );
+  proj_str = pj_get_def(psProj->proj, 0);
 #endif
-  if( proj_str == NULL )
+  if (proj_str == NULL)
     return -1;
 
   /* -------------------------------------------------------------------- */
   /*      Handle case of named units.                                     */
   /* -------------------------------------------------------------------- */
-  if( strstr(proj_str,"units=") != NULL ) {
+  if (strstr(proj_str, "units=") != NULL) {
     char units[32];
     char *blank;
 
-    strlcpy( units, (strstr(proj_str,"units=")+6), sizeof(units) );
+    strlcpy(units, (strstr(proj_str, "units=") + 6), sizeof(units));
 #if PROJ_VERSION_MAJOR < 6
-    pj_dalloc( proj_str );
+    pj_dalloc(proj_str);
 #endif
 
     blank = strchr(units, ' ');
-    if( blank != NULL )
+    if (blank != NULL)
       *blank = '\0';
 
-    return ConvertProjUnitStringToMS( units );
+    return ConvertProjUnitStringToMS(units);
   }
 
   /* -------------------------------------------------------------------- */
   /*      Handle case of to_meter value.                                  */
   /* -------------------------------------------------------------------- */
-  if( strstr(proj_str,"to_meter=") != NULL ) {
+  if (strstr(proj_str, "to_meter=") != NULL) {
     char to_meter_str[32];
     char *blank;
     double to_meter;
 
-    strlcpy(to_meter_str,(strstr(proj_str,"to_meter=")+9),
+    strlcpy(to_meter_str, (strstr(proj_str, "to_meter=") + 9),
             sizeof(to_meter_str));
 #if PROJ_VERSION_MAJOR < 6
-    pj_dalloc( proj_str );
+    pj_dalloc(proj_str);
 #endif
 
     blank = strchr(to_meter_str, ' ');
-    if( blank != NULL )
+    if (blank != NULL)
       *blank = '\0';
 
     to_meter = atof(to_meter_str);
 
-    if( fabs(to_meter-1.0) < 0.0000001 )
+    if (fabs(to_meter - 1.0) < 0.0000001)
       return MS_METERS;
-    else if( fabs(to_meter-1000.0) < 0.00001 )
+    else if (fabs(to_meter - 1000.0) < 0.00001)
       return MS_KILOMETERS;
-    else if( fabs(to_meter-0.3048) < 0.0001 )
+    else if (fabs(to_meter - 0.3048) < 0.0001)
       return MS_FEET;
-    else if( fabs(to_meter-0.0254) < 0.0001 )
+    else if (fabs(to_meter - 0.0254) < 0.0001)
       return MS_INCHES;
-    else if( fabs(to_meter-1609.344) < 0.001 )
+    else if (fabs(to_meter - 1609.344) < 0.001)
       return MS_MILES;
-    else if( fabs(to_meter-1852.0) < 0.1 )
+    else if (fabs(to_meter - 1852.0) < 0.1)
       return MS_NAUTICALMILES;
     else
       return -1;
   }
 
 #if PROJ_VERSION_MAJOR < 6
-  pj_dalloc( proj_str );
+  pj_dalloc(proj_str);
 #endif
   return -1;
 }
@@ -2944,58 +2845,51 @@ int GetMapserverUnitUsingProj(projection
 /*       msProjectionContextReleaseToPool()                             */
 /************************************************************************/
 
-projectionContext* msProjectionContextGetFromPool()
-{
-    projectionContext* context;
-    msAcquireLock( TLOCK_PROJ );
-
-    if( headOfLinkedListOfProjContext )
-    {
-        LinkedListOfProjContext* next = headOfLinkedListOfProjContext->next;
-        context = headOfLinkedListOfProjContext->context;
-        msFree(headOfLinkedListOfProjContext);
-        headOfLinkedListOfProjContext = next;
-    }
-    else
-    {
-        context = msProjectionContextCreate();
-    }
+projectionContext *msProjectionContextGetFromPool() {
+  projectionContext *context;
+  msAcquireLock(TLOCK_PROJ);
+
+  if (headOfLinkedListOfProjContext) {
+    LinkedListOfProjContext *next = headOfLinkedListOfProjContext->next;
+    context = headOfLinkedListOfProjContext->context;
+    msFree(headOfLinkedListOfProjContext);
+    headOfLinkedListOfProjContext = next;
+  } else {
+    context = msProjectionContextCreate();
+  }
 
-    msReleaseLock( TLOCK_PROJ );
-    return context;
+  msReleaseLock(TLOCK_PROJ);
+  return context;
 }
 
 /************************************************************************/
 /*                  msProjectionContextReleaseToPool()                  */
 /************************************************************************/
 
-void msProjectionContextReleaseToPool(projectionContext* ctx)
-{
-    LinkedListOfProjContext* link =
-        (LinkedListOfProjContext*)msSmallMalloc(sizeof(LinkedListOfProjContext));
-    link->context = ctx;
-    msAcquireLock( TLOCK_PROJ );
-    link->next = headOfLinkedListOfProjContext;
-    headOfLinkedListOfProjContext = link;
-    msReleaseLock( TLOCK_PROJ );
+void msProjectionContextReleaseToPool(projectionContext *ctx) {
+  LinkedListOfProjContext *link =
+      (LinkedListOfProjContext *)msSmallMalloc(sizeof(LinkedListOfProjContext));
+  link->context = ctx;
+  msAcquireLock(TLOCK_PROJ);
+  link->next = headOfLinkedListOfProjContext;
+  headOfLinkedListOfProjContext = link;
+  msReleaseLock(TLOCK_PROJ);
 }
 
 /************************************************************************/
 /*                   msProjectionContextPoolCleanup()                   */
 /************************************************************************/
 
-void msProjectionContextPoolCleanup()
-{
-    LinkedListOfProjContext* link;
-    msAcquireLock( TLOCK_PROJ );
-    link = headOfLinkedListOfProjContext;
-    while( link )
-    {
-        LinkedListOfProjContext* next = link->next;
-        msProjectionContextUnref(link->context);
-        msFree(link);
-        link = next;
-    }
-    headOfLinkedListOfProjContext = NULL;
-    msReleaseLock( TLOCK_PROJ );
+void msProjectionContextPoolCleanup() {
+  LinkedListOfProjContext *link;
+  msAcquireLock(TLOCK_PROJ);
+  link = headOfLinkedListOfProjContext;
+  while (link) {
+    LinkedListOfProjContext *next = link->next;
+    msProjectionContextUnref(link->context);
+    msFree(link);
+    link = next;
+  }
+  headOfLinkedListOfProjContext = NULL;
+  msReleaseLock(TLOCK_PROJ);
 }
diff -pruN 8.0.1-5/mapproject.h 8.0.2-1/mapproject.h
--- 8.0.1-5/mapproject.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapproject.h	2024-06-11 20:41:34.000000000 +0000
@@ -38,14 +38,14 @@ extern "C" {
 #endif
 
 #if PROJ_VERSION_MAJOR >= 6
-#  include <proj.h>
+#include <proj.h>
 #if PROJ_VERSION_MAJOR == 6 && PROJ_VERSION_MINOR == 0
 #error "PROJ 6.0 is not supported. Use PROJ 6.1 or later"
 #endif
 #else
-#  include <proj_api.h>
+#include <proj_api.h>
 #if PJ_VERSION >= 470 && PJ_VERSION < 480
-   void pj_clear_initcache();
+void pj_clear_initcache();
 #endif
 #endif
 
@@ -56,119 +56,144 @@ extern "C" {
 typedef struct projectionContext projectionContext;
 
 #ifndef SWIG
-typedef enum
-{
-    LINE_CUTTING_UNKNOWN = -1,
-    LINE_CUTTING_NONE = 0,
-    LINE_CUTTING_FROM_POLAR = 1,
-    LINE_CUTTING_FROM_LONGLAT_WRAP0 = 2
+typedef enum {
+  LINE_CUTTING_UNKNOWN = -1,
+  LINE_CUTTING_NONE = 0,
+  LINE_CUTTING_FROM_POLAR = 1,
+  LINE_CUTTING_FROM_LONGLAT_WRAP0 = 2
 } msLineCuttingCase;
 #endif
 
 /**
 The :ref:`PROJECTION <projection>` object
-MapServer's Maps and Layers have Projection attributes, and these are C projectionObj structures, 
-but are not directly exposed by the mapscript module
+MapServer's Maps and Layers have Projection attributes, and these are C
+projectionObj structures, but are not directly exposed by the mapscript module
 */
-  typedef struct {
+typedef struct {
 #ifndef SWIG
-      char **args; /* variable number of projection args */
+  char **args; /* variable number of projection args */
 #if PROJ_VERSION_MAJOR >= 6
-      PJ* proj;
-      projectionContext* proj_ctx;
+  PJ *proj;
+  projectionContext *proj_ctx;
 #else
-      projPJ proj; /* a projection structure for the PROJ package */
+  projPJ proj; /* a projection structure for the PROJ package */
 #if PJ_VERSION >= 480
-      projCtx proj_ctx;
+  projCtx proj_ctx;
 #endif
 #endif
-      geotransformObj gt; /* extra transformation to apply */
+  geotransformObj gt; /* extra transformation to apply */
 #endif
 
 #ifdef SWIG
     %immutable;
 #endif
-    int numargs; ///< Actual number of projection args
-    int automatic; ///< Projection object was to fetched from the layer
+  int numargs;     ///< Actual number of projection args
+  short automatic; ///< Projection object was to fetched from the layer
+  unsigned short
+      generation_number; ///< To be incremented when the content of the object
+                         ///< changes, so that a reprojector can be invalidated
 #ifdef SWIG
     %mutable;
 #endif
 
-    int wellknownprojection; ///< One of ``wkp_none 0``, ``wkp_lonlat 1``, or ``wkp_gmerc 2``
-  } projectionObj;
+  int wellknownprojection; ///< One of ``wkp_none 0``, ``wkp_lonlat 1``, or
+                           ///< ``wkp_gmerc 2``
+} projectionObj;
 
-  typedef struct {
+/**
+A holder object for projection coordinate transformations, introduced in RFC
+126. This allows caching of reprojections improving performance.
+*/
+typedef struct {
 #if PROJ_VERSION_MAJOR >= 6
 #ifndef SWIG
-    projectionObj* in;
-    projectionObj* out;
-    PJ* pj;
-    msLineCuttingCase lineCuttingCase;
-    shapeObj splitShape;
-    int bFreePJ;
+  projectionObj *in;
+  projectionObj *out;
+  PJ *pj;
+  msLineCuttingCase lineCuttingCase;
+  shapeObj splitShape;
+  int bFreePJ;
 #endif
 #else
 #ifndef SWIG
-    projectionObj* in;
-    projectionObj* out;
-    msLineCuttingCase lineCuttingCase;
-    shapeObj splitShape;
-    int no_op;
+  projectionObj *in;
+  projectionObj *out;
+  msLineCuttingCase lineCuttingCase;
+  shapeObj splitShape;
+  int no_op;
 #endif
 #endif
-  } reprojectionObj;
+  unsigned short generation_number_in;  ///< A counter that is incremented when
+                                        ///< the input projectionObj changes
+  unsigned short generation_number_out; ///< A counter that is incremented when
+                                        ///< the output projectionObj changes
+} reprojectionObj;
 
 #ifndef SWIG
 
-  MS_DLL_EXPORT reprojectionObj* msProjectCreateReprojector(projectionObj* in, projectionObj* out);
-  MS_DLL_EXPORT void msProjectDestroyReprojector(reprojectionObj* reprojector);
-
-  MS_DLL_EXPORT projectionContext* msProjectionContextGetFromPool(void);
-  MS_DLL_EXPORT void msProjectionContextReleaseToPool(projectionContext* ctx);
-  MS_DLL_EXPORT void msProjectionContextPoolCleanup(void);
-
-  MS_DLL_EXPORT int msIsAxisInverted(int epsg_code);
-  MS_DLL_EXPORT int msProjectPoint(projectionObj *in, projectionObj *out, pointObj *point); /* legacy interface */
-  MS_DLL_EXPORT int msProjectPointEx(reprojectionObj* reprojector, pointObj *point);
-  MS_DLL_EXPORT int msProjectShape(projectionObj *in, projectionObj *out, shapeObj *shape); /* legacy interface */
-  MS_DLL_EXPORT int msProjectShapeEx(reprojectionObj* reprojector, shapeObj *shape);
-  MS_DLL_EXPORT int msProjectLine(projectionObj *in, projectionObj *out, lineObj *line); /* legacy interface */
-  MS_DLL_EXPORT int msProjectLineEx(reprojectionObj* reprojector, lineObj *line);
-  MS_DLL_EXPORT int msProjectRect(projectionObj *in, projectionObj *out, rectObj *rect); /* legacy interface */
-  MS_DLL_EXPORT int msProjectRectAsPolygon(reprojectionObj* reprojector, rectObj *rect);
-  MS_DLL_EXPORT int msProjectionsDiffer(projectionObj *, projectionObj *);
-  MS_DLL_EXPORT int msOGCWKT2ProjectionObj( const char *pszWKT, projectionObj *proj, int debug_flag );
-  MS_DLL_EXPORT char *msProjectionObj2OGCWKT( projectionObj *proj );
-
-  MS_DLL_EXPORT void msFreeProjection(projectionObj *p);
-  MS_DLL_EXPORT void msFreeProjectionExceptContext(projectionObj *p);
-  MS_DLL_EXPORT int msInitProjection(projectionObj *p);
-  MS_DLL_EXPORT void msProjectionInheritContextFrom(projectionObj *pDst, const projectionObj* pSrc);
-  MS_DLL_EXPORT void msProjectionSetContext(projectionObj *p, projectionContext* ctx);
-  MS_DLL_EXPORT int msProcessProjection(projectionObj *p);
-  MS_DLL_EXPORT int msLoadProjectionString(projectionObj *p, const char *value);
-  MS_DLL_EXPORT int msLoadProjectionStringEPSG(projectionObj *p, const char *value);
-  MS_DLL_EXPORT char *msGetProjectionString(projectionObj *proj);
-  int msIsAxisInvertedProj( projectionObj *proj );
-  void msAxisSwapShape(shapeObj *shape);
-  MS_DLL_EXPORT void msAxisNormalizePoints( projectionObj *proj, int count,
-      double *x, double *y );
-  MS_DLL_EXPORT void msAxisDenormalizePoints( projectionObj *proj, int count,
-      double *x, double *y );
+MS_DLL_EXPORT reprojectionObj *msProjectCreateReprojector(projectionObj *in,
+                                                          projectionObj *out);
+MS_DLL_EXPORT void msProjectDestroyReprojector(reprojectionObj *reprojector);
+MS_DLL_EXPORT int
+msProjectIsReprojectorStillValid(reprojectionObj *reprojector);
+
+MS_DLL_EXPORT projectionContext *msProjectionContextGetFromPool(void);
+MS_DLL_EXPORT void msProjectionContextReleaseToPool(projectionContext *ctx);
+MS_DLL_EXPORT void msProjectionContextPoolCleanup(void);
+
+MS_DLL_EXPORT int msIsAxisInverted(int epsg_code);
+MS_DLL_EXPORT int msProjectPoint(projectionObj *in, projectionObj *out,
+                                 pointObj *point); /* legacy interface */
+MS_DLL_EXPORT int msProjectPointEx(reprojectionObj *reprojector,
+                                   pointObj *point);
+MS_DLL_EXPORT int msProjectShape(projectionObj *in, projectionObj *out,
+                                 shapeObj *shape); /* legacy interface */
+MS_DLL_EXPORT int msProjectShapeEx(reprojectionObj *reprojector,
+                                   shapeObj *shape);
+MS_DLL_EXPORT int msProjectLine(projectionObj *in, projectionObj *out,
+                                lineObj *line); /* legacy interface */
+MS_DLL_EXPORT int msProjectLineEx(reprojectionObj *reprojector, lineObj *line);
+MS_DLL_EXPORT int msProjectRect(projectionObj *in, projectionObj *out,
+                                rectObj *rect); /* legacy interface */
+MS_DLL_EXPORT int msProjectRectAsPolygon(reprojectionObj *reprojector,
+                                         rectObj *rect);
+MS_DLL_EXPORT int msProjectionsDiffer(projectionObj *, projectionObj *);
+MS_DLL_EXPORT int msOGCWKT2ProjectionObj(const char *pszWKT,
+                                         projectionObj *proj, int debug_flag);
+MS_DLL_EXPORT char *msProjectionObj2OGCWKT(projectionObj *proj);
+
+MS_DLL_EXPORT void msFreeProjection(projectionObj *p);
+MS_DLL_EXPORT void msFreeProjectionExceptContext(projectionObj *p);
+MS_DLL_EXPORT int msInitProjection(projectionObj *p);
+MS_DLL_EXPORT void msProjectionInheritContextFrom(projectionObj *pDst,
+                                                  const projectionObj *pSrc);
+MS_DLL_EXPORT void msProjectionSetContext(projectionObj *p,
+                                          projectionContext *ctx);
+MS_DLL_EXPORT int msProcessProjection(projectionObj *p);
+MS_DLL_EXPORT int msLoadProjectionString(projectionObj *p, const char *value);
+MS_DLL_EXPORT int msLoadProjectionStringEPSG(projectionObj *p,
+                                             const char *value);
+MS_DLL_EXPORT char *msGetProjectionString(projectionObj *proj);
+int msIsAxisInvertedProj(projectionObj *proj);
+void msAxisSwapShape(shapeObj *shape);
+MS_DLL_EXPORT void msAxisNormalizePoints(projectionObj *proj, int count,
+                                         double *x, double *y);
+MS_DLL_EXPORT void msAxisDenormalizePoints(projectionObj *proj, int count,
+                                           double *x, double *y);
 
-  MS_DLL_EXPORT void msSetPROJ_DATA( const char *, const char * );
-  MS_DLL_EXPORT void msProjDataInitFromEnv();
+MS_DLL_EXPORT void msSetPROJ_DATA(const char *, const char *);
+MS_DLL_EXPORT void msProjDataInitFromEnv();
 
-  int msProjIsGeographicCRS(projectionObj* proj);
+int msProjIsGeographicCRS(projectionObj *proj);
 #if PROJ_VERSION_MAJOR >= 6
-  int msProjectTransformPoints( reprojectionObj* reprojector,
-                                int npoints, double* x, double* y );
+int msProjectTransformPoints(reprojectionObj *reprojector, int npoints,
+                             double *x, double *y);
 #endif
 
-  /*utility functions */
-  MS_DLL_EXPORT int GetMapserverUnitUsingProj(projectionObj *psProj);
+/*utility functions */
+MS_DLL_EXPORT int GetMapserverUnitUsingProj(projectionObj *psProj);
 
-  int msProjectHasLonWrap(projectionObj *in, double* pdfLonWrap);
+int msProjectHasLonWrap(projectionObj *in, double *pdfLonWrap);
 #endif
 
 #ifdef __cplusplus
diff -pruN 8.0.1-5/mapquantization.c 8.0.2-1/mapquantization.c
--- 8.0.1-5/mapquantization.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapquantization.c	2024-06-11 20:41:34.000000000 +0000
@@ -51,17 +51,21 @@
 #define PAM_GETG(p) ((p).g)
 #define PAM_GETB(p) ((p).b)
 #define PAM_GETA(p) ((p).a)
-#define PAM_ASSIGN(p,red,grn,blu,alf) \
-    do { (p).r = (red); (p).g = (grn); (p).b = (blu); (p).a = (alf); } while (0)
-#define PAM_EQUAL(p,q) \
-    ((p).r == (q).r && (p).g == (q).g && (p).b == (q).b && (p).a == (q).a)
-#define PAM_DEPTH(newp,p,oldmaxval,newmaxval) \
-    PAM_ASSIGN( (newp), \
-            ( (int) PAM_GETR(p) * (newmaxval) + (oldmaxval) / 2 ) / (oldmaxval), \
-            ( (int) PAM_GETG(p) * (newmaxval) + (oldmaxval) / 2 ) / (oldmaxval), \
-            ( (int) PAM_GETB(p) * (newmaxval) + (oldmaxval) / 2 ) / (oldmaxval), \
-            ( (int) PAM_GETA(p) * (newmaxval) + (oldmaxval) / 2 ) / (oldmaxval) )
-
+#define PAM_ASSIGN(p, red, grn, blu, alf)                                      \
+  do {                                                                         \
+    (p).r = (red);                                                             \
+    (p).g = (grn);                                                             \
+    (p).b = (blu);                                                             \
+    (p).a = (alf);                                                             \
+  } while (0)
+#define PAM_EQUAL(p, q)                                                        \
+  ((p).r == (q).r && (p).g == (q).g && (p).b == (q).b && (p).a == (q).a)
+#define PAM_DEPTH(newp, p, oldmaxval, newmaxval)                               \
+  PAM_ASSIGN((newp),                                                           \
+             ((int)PAM_GETR(p) * (newmaxval) + (oldmaxval) / 2) / (oldmaxval), \
+             ((int)PAM_GETG(p) * (newmaxval) + (oldmaxval) / 2) / (oldmaxval), \
+             ((int)PAM_GETB(p) * (newmaxval) + (oldmaxval) / 2) / (oldmaxval), \
+             ((int)PAM_GETA(p) * (newmaxval) + (oldmaxval) / 2) / (oldmaxval))
 
 /* from pamcmap.h */
 
@@ -79,7 +83,7 @@ struct acolorhist_list_item {
 
 typedef acolorhist_list *acolorhash_table;
 
-#define MAXCOLORS  32767
+#define MAXCOLORS 32767
 
 #define LARGE_NORM
 #define REP_AVERAGE_PIXELS
@@ -91,54 +95,58 @@ struct box {
   int sum;
 };
 
-static acolorhist_vector mediancut
-(acolorhist_vector achv, int colors, int sum, unsigned char maxval, int newcolors);
-static int redcompare (const void *ch1, const void *ch2);
-static int greencompare (const void *ch1, const void *ch2);
-static int bluecompare (const void *ch1, const void *ch2);
-static int alphacompare (const void *ch1, const void *ch2);
-static int sumcompare (const void *b1, const void *b2);
-
-static acolorhist_vector pam_acolorhashtoacolorhist
-(acolorhash_table acht, int maxacolors);
-static acolorhist_vector pam_computeacolorhist
-(rgbaPixel **apixels, int cols, int rows, int maxacolors, int* acolorsP);
-static acolorhash_table pam_computeacolorhash
-(rgbaPixel** apixels, int cols, int rows, int maxacolors, int* acolorsP);
-static acolorhash_table pam_allocacolorhash (void);
-static int pam_addtoacolorhash
-(acolorhash_table acht, rgbaPixel *acolorP, int value);
-static int pam_lookupacolor (acolorhash_table acht, rgbaPixel* acolorP);
-static void pam_freeacolorhist (acolorhist_vector achv);
-static void pam_freeacolorhash (acolorhash_table acht);
-
+static acolorhist_vector mediancut(acolorhist_vector achv, int colors, int sum,
+                                   unsigned char maxval, int newcolors);
+static int redcompare(const void *ch1, const void *ch2);
+static int greencompare(const void *ch1, const void *ch2);
+static int bluecompare(const void *ch1, const void *ch2);
+static int alphacompare(const void *ch1, const void *ch2);
+static int sumcompare(const void *b1, const void *b2);
+
+static acolorhist_vector pam_acolorhashtoacolorhist(acolorhash_table acht,
+                                                    int maxacolors);
+static acolorhist_vector pam_computeacolorhist(rgbaPixel **apixels, int cols,
+                                               int rows, int maxacolors,
+                                               int *acolorsP);
+static acolorhash_table pam_computeacolorhash(rgbaPixel **apixels, int cols,
+                                              int rows, int maxacolors,
+                                              int *acolorsP);
+static acolorhash_table pam_allocacolorhash(void);
+static int pam_addtoacolorhash(acolorhash_table acht, rgbaPixel *acolorP,
+                               int value);
+static int pam_lookupacolor(acolorhash_table acht, rgbaPixel *acolorP);
+static void pam_freeacolorhist(acolorhist_vector achv);
+static void pam_freeacolorhash(acolorhash_table acht);
 
 /**
- * Compute a palette for the given RGBA rasterBuffer using a median cut quantization.
+ * Compute a palette for the given RGBA rasterBuffer using a median cut
+ * quantization.
  * - rb: the rasterBuffer to quantize
- * - reqcolors: the desired number of colors the palette should contain. will be set
- *   with the actual number of entries in the computed palette
+ * - reqcolors: the desired number of colors the palette should contain. will be
+ * set with the actual number of entries in the computed palette
  * - forced_palette: entries that should appear in the computed palette
- * - num_forced_palette_entries: number of entries contained in "force_palette". if 0,
- *   "force_palette" can be NULL
- * - palette_scaling_maxval: the quantization process may have to reduce the image depth
- *   by iteratively dividing the pixels by 2. In case palette_scaling_maxval is set to
- *   something different than 255, the returned palette colors have to be scaled back up to
- *   255, and rb's pixels will have been scaled down to maxsize (see bug #3848)
+ * - num_forced_palette_entries: number of entries contained in "force_palette".
+ * if 0, "force_palette" can be NULL
+ * - palette_scaling_maxval: the quantization process may have to reduce the
+ * image depth by iteratively dividing the pixels by 2. In case
+ * palette_scaling_maxval is set to something different than 255, the returned
+ * palette colors have to be scaled back up to 255, and rb's pixels will have
+ * been scaled down to maxsize (see bug #3848)
  */
-int msQuantizeRasterBuffer(rasterBufferObj *rb,
-                           unsigned int *reqcolors, rgbaPixel *palette,
-                           rgbaPixel *forced_palette_ignored, int num_forced_palette_entries_ignored,
-                           unsigned int *palette_scaling_maxval)
-{
+int msQuantizeRasterBuffer(rasterBufferObj *rb, unsigned int *reqcolors,
+                           rgbaPixel *palette,
+                           rgbaPixel *forced_palette_ignored,
+                           int num_forced_palette_entries_ignored,
+                           unsigned int *palette_scaling_maxval) {
   (void)forced_palette_ignored;
   (void)num_forced_palette_entries_ignored;
-  rgbaPixel **apixels=NULL; /* pointer to the start rows of truecolor pixels */
+  rgbaPixel **apixels =
+      NULL; /* pointer to the start rows of truecolor pixels */
 
   register rgbaPixel *pP;
 
   unsigned char newmaxval;
-  acolorhist_vector achv, acolormap=NULL;
+  acolorhist_vector achv, acolormap = NULL;
 
   int colors;
   int newcolors = 0;
@@ -150,10 +158,11 @@ int msQuantizeRasterBuffer(rasterBufferO
 
   *palette_scaling_maxval = 255;
 
-  apixels=(rgbaPixel**)msSmallMalloc(rb->height*sizeof(rgbaPixel*));
+  apixels = (rgbaPixel **)msSmallMalloc(rb->height * sizeof(rgbaPixel *));
 
-  for(unsigned row=0; row<rb->height; row++) {
-    apixels[row]=(rgbaPixel*)(&(rb->data.rgba.pixels[row * rb->data.rgba.row_step]));
+  for (unsigned row = 0; row < rb->height; row++) {
+    apixels[row] =
+        (rgbaPixel *)(&(rb->data.rgba.pixels[row * rb->data.rgba.row_step]));
   }
 
   /*
@@ -163,28 +172,26 @@ int msQuantizeRasterBuffer(rasterBufferO
    ** maxval at worst 15, since 32^3 is approximately MAXCOLORS.
                 [GRR POSSIBLE BUG:  what about 32^4 ?]
    */
-  for ( ; ; ) {
-    achv = pam_computeacolorhist(
-             apixels, rb->width, rb->height, MAXCOLORS, &colors );
-    if ( achv != (acolorhist_vector) 0 )
+  for (;;) {
+    achv = pam_computeacolorhist(apixels, rb->width, rb->height, MAXCOLORS,
+                                 &colors);
+    if (achv != (acolorhist_vector)0)
       break;
     newmaxval = *palette_scaling_maxval / 2;
-    for ( unsigned row = 0; row < rb->height; ++row )
-    {
+    for (unsigned row = 0; row < rb->height; ++row) {
       pP = apixels[row];
-      for (unsigned col = 0 ; col < rb->width; ++col, ++pP )
-        PAM_DEPTH( *pP, *pP, *palette_scaling_maxval, newmaxval );
+      for (unsigned col = 0; col < rb->width; ++col, ++pP)
+        PAM_DEPTH(*pP, *pP, *palette_scaling_maxval, newmaxval);
     }
     *palette_scaling_maxval = newmaxval;
   }
   newcolors = MS_MIN(colors, (int)*reqcolors);
-  acolormap = mediancut(achv, colors, rb->width*rb->height, *palette_scaling_maxval, newcolors);
+  acolormap = mediancut(achv, colors, rb->width * rb->height,
+                        *palette_scaling_maxval, newcolors);
   pam_freeacolorhist(achv);
 
-
   *reqcolors = newcolors;
 
-
   for (x = 0; x < newcolors; ++x) {
     palette[x].r = acolormap[x].acolor.r;
     palette[x].g = acolormap[x].acolor.g;
@@ -197,11 +204,9 @@ int msQuantizeRasterBuffer(rasterBufferO
   return MS_SUCCESS;
 }
 
-
-int msClassifyRasterBuffer(rasterBufferObj *rb, rasterBufferObj *qrb)
-{
+int msClassifyRasterBuffer(rasterBufferObj *rb, rasterBufferObj *qrb) {
   register int ind;
-  unsigned char *outrow,*pQ;
+  unsigned char *outrow, *pQ;
   register rgbaPixel *pP;
   acolorhash_table acht;
   int usehash;
@@ -209,44 +214,44 @@ int msClassifyRasterBuffer(rasterBufferO
    ** Step 4: map the colors in the image to their closest match in the
    ** new colormap, and write 'em out.
    */
-  acht = pam_allocacolorhash( );
+  acht = pam_allocacolorhash();
   usehash = 1;
 
-  for ( unsigned row = 0; row < qrb->height; ++row ) {
-    outrow = &(qrb->data.palette.pixels[row*qrb->width]);
+  for (unsigned row = 0; row < qrb->height; ++row) {
+    outrow = &(qrb->data.palette.pixels[row * qrb->width]);
     unsigned col = 0;
-    pP = (rgbaPixel*)(&(rb->data.rgba.pixels[row * rb->data.rgba.row_step]));;
+    pP = (rgbaPixel *)(&(rb->data.rgba.pixels[row * rb->data.rgba.row_step]));
+    ;
     pQ = outrow;
     do {
       /* Check hash table to see if we have already matched this color. */
-      ind = pam_lookupacolor( acht, pP );
-      if ( ind == -1 ) {
+      ind = pam_lookupacolor(acht, pP);
+      if (ind == -1) {
         /* No; search acolormap for closest match. */
         register int r1, g1, b1, a1, r2, g2, b2, a2;
         register long dist, newdist;
 
-        r1 = PAM_GETR( *pP );
-        g1 = PAM_GETG( *pP );
-        b1 = PAM_GETB( *pP );
-        a1 = PAM_GETA( *pP );
+        r1 = PAM_GETR(*pP);
+        g1 = PAM_GETG(*pP);
+        b1 = PAM_GETB(*pP);
+        a1 = PAM_GETA(*pP);
         dist = 2000000000;
-        for ( unsigned i = 0; i < qrb->data.palette.num_entries; ++i ) {
-          r2 = PAM_GETR( qrb->data.palette.palette[i] );
-          g2 = PAM_GETG( qrb->data.palette.palette[i] );
-          b2 = PAM_GETB( qrb->data.palette.palette[i] );
-          a2 = PAM_GETA( qrb->data.palette.palette[i] );
+        for (unsigned i = 0; i < qrb->data.palette.num_entries; ++i) {
+          r2 = PAM_GETR(qrb->data.palette.palette[i]);
+          g2 = PAM_GETG(qrb->data.palette.palette[i]);
+          b2 = PAM_GETB(qrb->data.palette.palette[i]);
+          a2 = PAM_GETA(qrb->data.palette.palette[i]);
           /* GRR POSSIBLE BUG */
-          newdist = ( r1 - r2 ) * ( r1 - r2 ) +  /* may overflow? */
-                    ( g1 - g2 ) * ( g1 - g2 ) +
-                    ( b1 - b2 ) * ( b1 - b2 ) +
-                    ( a1 - a2 ) * ( a1 - a2 );
-          if ( newdist < dist ) {
+          newdist = (r1 - r2) * (r1 - r2) + /* may overflow? */
+                    (g1 - g2) * (g1 - g2) + (b1 - b2) * (b1 - b2) +
+                    (a1 - a2) * (a1 - a2);
+          if (newdist < dist) {
             ind = i;
             dist = newdist;
           }
         }
-        if ( usehash ) {
-          if ( pam_addtoacolorhash( acht, pP, ind ) < 0 ) {
+        if (usehash) {
+          if (pam_addtoacolorhash(acht, pP, ind) < 0) {
             usehash = 0;
           }
         }
@@ -259,39 +264,36 @@ int msClassifyRasterBuffer(rasterBufferO
       ++pP;
       ++pQ;
 
-    } while ( col != rb->width );
+    } while (col != rb->width);
   }
   pam_freeacolorhash(acht);
 
   return MS_SUCCESS;
 }
 
-
-
 /*
  ** Here is the fun part, the median-cut colormap generator.  This is based
  ** on Paul Heckbert's paper, "Color Image Quantization for Frame Buffer
  ** Display," SIGGRAPH 1982 Proceedings, page 297.
  */
 
-static acolorhist_vector
-mediancut( acolorhist_vector achv, int colors, int sum, unsigned char maxval, int newcolors )
-{
+static acolorhist_vector mediancut(acolorhist_vector achv, int colors, int sum,
+                                   unsigned char maxval, int newcolors) {
   acolorhist_vector acolormap;
   box_vector bv;
   register int bi, i;
   int boxes;
 
-  bv = (box_vector) malloc( sizeof(struct box) * newcolors );
+  bv = (box_vector)malloc(sizeof(struct box) * newcolors);
   acolormap =
-    (acolorhist_vector) malloc( sizeof(struct acolorhist_item) * newcolors);
-  if ( bv == (box_vector) 0 || acolormap == (acolorhist_vector) 0 ) {
-    fprintf( stderr, "  out of memory allocating box vector\n" );
+      (acolorhist_vector)malloc(sizeof(struct acolorhist_item) * newcolors);
+  if (bv == (box_vector)0 || acolormap == (acolorhist_vector)0) {
+    fprintf(stderr, "  out of memory allocating box vector\n");
     fflush(stderr);
     exit(6);
   }
-  for ( i = 0; i < newcolors; ++i )
-    PAM_ASSIGN( acolormap[i].acolor, 0, 0, 0, 0 );
+  for (i = 0; i < newcolors; ++i)
+    PAM_ASSIGN(acolormap[i].acolor, 0, 0, 0, 0);
 
   /*
    ** Set up the initial box.
@@ -304,7 +306,7 @@ mediancut( acolorhist_vector achv, int c
   /*
    ** Main loop: split boxes until we have enough.
    */
-  while ( boxes < newcolors ) {
+  while (boxes < newcolors) {
     register int indx, clrs;
     int sm;
     register int minr, maxr, ming, mina, maxg, minb, maxb, maxa, v;
@@ -313,11 +315,11 @@ mediancut( acolorhist_vector achv, int c
     /*
      ** Find the first splittable box.
      */
-    for ( bi = 0; bi < boxes; ++bi )
-      if ( bv[bi].colors >= 2 )
+    for (bi = 0; bi < boxes; ++bi)
+      if (bv[bi].colors >= 2)
         break;
-    if ( bi == boxes )
-      break;        /* ran out of colors! */
+    if (bi == boxes)
+      break; /* ran out of colors! */
     indx = bv[bi].ind;
     clrs = bv[bi].colors;
     sm = bv[bi].sum;
@@ -326,23 +328,31 @@ mediancut( acolorhist_vector achv, int c
      ** Go through the box finding the minimum and maximum of each
      ** component - the boundaries of the box.
      */
-    minr = maxr = PAM_GETR( achv[indx].acolor );
-    ming = maxg = PAM_GETG( achv[indx].acolor );
-    minb = maxb = PAM_GETB( achv[indx].acolor );
-    mina = maxa = PAM_GETA( achv[indx].acolor );
-    for ( i = 1; i < clrs; ++i ) {
-      v = PAM_GETR( achv[indx + i].acolor );
-      if ( v < minr ) minr = v;
-      if ( v > maxr ) maxr = v;
-      v = PAM_GETG( achv[indx + i].acolor );
-      if ( v < ming ) ming = v;
-      if ( v > maxg ) maxg = v;
-      v = PAM_GETB( achv[indx + i].acolor );
-      if ( v < minb ) minb = v;
-      if ( v > maxb ) maxb = v;
-      v = PAM_GETA( achv[indx + i].acolor );
-      if ( v < mina ) mina = v;
-      if ( v > maxa ) maxa = v;
+    minr = maxr = PAM_GETR(achv[indx].acolor);
+    ming = maxg = PAM_GETG(achv[indx].acolor);
+    minb = maxb = PAM_GETB(achv[indx].acolor);
+    mina = maxa = PAM_GETA(achv[indx].acolor);
+    for (i = 1; i < clrs; ++i) {
+      v = PAM_GETR(achv[indx + i].acolor);
+      if (v < minr)
+        minr = v;
+      if (v > maxr)
+        maxr = v;
+      v = PAM_GETG(achv[indx + i].acolor);
+      if (v < ming)
+        ming = v;
+      if (v > maxg)
+        maxg = v;
+      v = PAM_GETB(achv[indx + i].acolor);
+      if (v < minb)
+        minb = v;
+      if (v > maxb)
+        maxb = v;
+      v = PAM_GETA(achv[indx + i].acolor);
+      if (v < mina)
+        mina = v;
+      if (v > maxa)
+        maxa = v;
     }
 
     /*
@@ -354,22 +364,19 @@ mediancut( acolorhist_vector achv, int c
      ** the LARGE_ defines at the beginning of this source file.
      */
 #ifdef LARGE_NORM
-    if ( maxa - mina >= maxr - minr && maxa - mina >= maxg - ming && maxa - mina >= maxb - minb )
-      qsort(
-        (char*) &(achv[indx]), clrs, sizeof(struct acolorhist_item),
-        alphacompare );
-    else if ( maxr - minr >= maxg - ming && maxr - minr >= maxb - minb )
-      qsort(
-        (char*) &(achv[indx]), clrs, sizeof(struct acolorhist_item),
-        redcompare );
-    else if ( maxg - ming >= maxb - minb )
-      qsort(
-        (char*) &(achv[indx]), clrs, sizeof(struct acolorhist_item),
-        greencompare );
+    if (maxa - mina >= maxr - minr && maxa - mina >= maxg - ming &&
+        maxa - mina >= maxb - minb)
+      qsort((char *)&(achv[indx]), clrs, sizeof(struct acolorhist_item),
+            alphacompare);
+    else if (maxr - minr >= maxg - ming && maxr - minr >= maxb - minb)
+      qsort((char *)&(achv[indx]), clrs, sizeof(struct acolorhist_item),
+            redcompare);
+    else if (maxg - ming >= maxb - minb)
+      qsort((char *)&(achv[indx]), clrs, sizeof(struct acolorhist_item),
+            greencompare);
     else
-      qsort(
-        (char*) &(achv[indx]), clrs, sizeof(struct acolorhist_item),
-        bluecompare );
+      qsort((char *)&(achv[indx]), clrs, sizeof(struct acolorhist_item),
+            bluecompare);
 #endif /*LARGE_NORM*/
 #ifdef LARGE_LUM
     {
@@ -391,22 +398,18 @@ mediancut( acolorhist_vector achv, int c
       [probably should read Heckbert's paper to decide]
        */
 
-      if ( al >= rl && al >= gl && al >= bl )
-        qsort(
-          (char*) &(achv[indx]), clrs, sizeof(struct acolorhist_item),
-          alphacompare );
-      else if ( rl >= gl && rl >= bl )
-        qsort(
-          (char*) &(achv[indx]), clrs, sizeof(struct acolorhist_item),
-          redcompare );
-      else if ( gl >= bl )
-        qsort(
-          (char*) &(achv[indx]), clrs, sizeof(struct acolorhist_item),
-          greencompare );
+      if (al >= rl && al >= gl && al >= bl)
+        qsort((char *)&(achv[indx]), clrs, sizeof(struct acolorhist_item),
+              alphacompare);
+      else if (rl >= gl && rl >= bl)
+        qsort((char *)&(achv[indx]), clrs, sizeof(struct acolorhist_item),
+              redcompare);
+      else if (gl >= bl)
+        qsort((char *)&(achv[indx]), clrs, sizeof(struct acolorhist_item),
+              greencompare);
       else
-        qsort(
-          (char*) &(achv[indx]), clrs, sizeof(struct acolorhist_item),
-          bluecompare );
+        qsort((char *)&(achv[indx]), clrs, sizeof(struct acolorhist_item),
+              bluecompare);
     }
 #endif /*LARGE_LUM*/
 
@@ -416,8 +419,8 @@ mediancut( acolorhist_vector achv, int c
      */
     lowersum = achv[indx].value;
     halfsum = sm / 2;
-    for ( i = 1; i < clrs - 1; ++i ) {
-      if ( lowersum >= halfsum )
+    for (i = 1; i < clrs - 1; ++i) {
+      if (lowersum >= halfsum)
         break;
       lowersum += achv[indx + i].value;
     }
@@ -431,7 +434,7 @@ mediancut( acolorhist_vector achv, int c
     bv[boxes].colors = clrs - i;
     bv[boxes].sum = sm - lowersum;
     ++boxes;
-    qsort( (char*) bv, boxes, sizeof(struct box), sumcompare );
+    qsort((char *)bv, boxes, sizeof(struct box), sumcompare);
   }
 
   /*
@@ -444,77 +447,81 @@ mediancut( acolorhist_vector achv, int c
    ** method is used by switching the commenting on the REP_ defines at
    ** the beginning of this source file.
    */
-  for ( bi = 0; bi < boxes; ++bi ) {
+  for (bi = 0; bi < boxes; ++bi) {
 #ifdef REP_CENTER_BOX
     register int indx = bv[bi].ind;
     register int clrs = bv[bi].colors;
     register int minr, maxr, ming, maxg, minb, maxb, mina, maxa, v;
 
-    minr = maxr = PAM_GETR( achv[indx].acolor );
-    ming = maxg = PAM_GETG( achv[indx].acolor );
-    minb = maxb = PAM_GETB( achv[indx].acolor );
-    mina = maxa = PAM_GETA( achv[indx].acolor );
-    for ( i = 1; i < clrs; ++i ) {
-      v = PAM_GETR( achv[indx + i].acolor );
-      minr = min( minr, v );
-      maxr = max( maxr, v );
-      v = PAM_GETG( achv[indx + i].acolor );
-      ming = min( ming, v );
-      maxg = max( maxg, v );
-      v = PAM_GETB( achv[indx + i].acolor );
-      minb = min( minb, v );
-      maxb = max( maxb, v );
-      v = PAM_GETA( achv[indx + i].acolor );
-      mina = min( mina, v );
-      maxa = max( maxa, v );
-    }
-    PAM_ASSIGN(
-      acolormap[bi].acolor, ( minr + maxr ) / 2, ( ming + maxg ) / 2,
-      ( minb + maxb ) / 2, ( mina + maxa ) / 2 );
+    minr = maxr = PAM_GETR(achv[indx].acolor);
+    ming = maxg = PAM_GETG(achv[indx].acolor);
+    minb = maxb = PAM_GETB(achv[indx].acolor);
+    mina = maxa = PAM_GETA(achv[indx].acolor);
+    for (i = 1; i < clrs; ++i) {
+      v = PAM_GETR(achv[indx + i].acolor);
+      minr = min(minr, v);
+      maxr = max(maxr, v);
+      v = PAM_GETG(achv[indx + i].acolor);
+      ming = min(ming, v);
+      maxg = max(maxg, v);
+      v = PAM_GETB(achv[indx + i].acolor);
+      minb = min(minb, v);
+      maxb = max(maxb, v);
+      v = PAM_GETA(achv[indx + i].acolor);
+      mina = min(mina, v);
+      maxa = max(maxa, v);
+    }
+    PAM_ASSIGN(acolormap[bi].acolor, (minr + maxr) / 2, (ming + maxg) / 2,
+               (minb + maxb) / 2, (mina + maxa) / 2);
 #endif /*REP_CENTER_BOX*/
 #ifdef REP_AVERAGE_COLORS
     register int indx = bv[bi].ind;
     register int clrs = bv[bi].colors;
     register long r = 0, g = 0, b = 0, a = 0;
 
-    for ( i = 0; i < clrs; ++i ) {
-      r += PAM_GETR( achv[indx + i].acolor );
-      g += PAM_GETG( achv[indx + i].acolor );
-      b += PAM_GETB( achv[indx + i].acolor );
-      a += PAM_GETA( achv[indx + i].acolor );
+    for (i = 0; i < clrs; ++i) {
+      r += PAM_GETR(achv[indx + i].acolor);
+      g += PAM_GETG(achv[indx + i].acolor);
+      b += PAM_GETB(achv[indx + i].acolor);
+      a += PAM_GETA(achv[indx + i].acolor);
     }
     r = r / clrs;
     g = g / clrs;
     b = b / clrs;
     a = a / clrs;
-    PAM_ASSIGN( acolormap[bi].acolor, r, g, b, a );
+    PAM_ASSIGN(acolormap[bi].acolor, r, g, b, a);
 #endif /*REP_AVERAGE_COLORS*/
 #ifdef REP_AVERAGE_PIXELS
     register int indx = bv[bi].ind;
     register int clrs = bv[bi].colors;
     register long r = 0, g = 0, b = 0, a = 0, sum = 0;
 
-    for ( i = 0; i < clrs; ++i ) {
-      r += (long)PAM_GETR( achv[indx + i].acolor ) * achv[indx + i].value;
-      g += (long)PAM_GETG( achv[indx + i].acolor ) * achv[indx + i].value;
-      b += (long)PAM_GETB( achv[indx + i].acolor ) * achv[indx + i].value;
-      a += (long)PAM_GETA( achv[indx + i].acolor ) * achv[indx + i].value;
+    for (i = 0; i < clrs; ++i) {
+      r += (long)PAM_GETR(achv[indx + i].acolor) * achv[indx + i].value;
+      g += (long)PAM_GETG(achv[indx + i].acolor) * achv[indx + i].value;
+      b += (long)PAM_GETB(achv[indx + i].acolor) * achv[indx + i].value;
+      a += (long)PAM_GETA(achv[indx + i].acolor) * achv[indx + i].value;
       sum += achv[indx + i].value;
     }
-    if(sum>0) {
+    if (sum > 0) {
       r = r / sum;
-      if ( r > maxval ) r = maxval;        /* avoid math errors */
+      if (r > maxval)
+        r = maxval; /* avoid math errors */
       g = g / sum;
-      if ( g > maxval ) g = maxval;
+      if (g > maxval)
+        g = maxval;
       b = b / sum;
-      if ( b > maxval ) b = maxval;
+      if (b > maxval)
+        b = maxval;
       a = a / sum;
-      if ( a > maxval ) a = maxval;
+      if (a > maxval)
+        a = maxval;
     } else {
       r = g = b = a = maxval;
     }
     /* GRR 20001228:  added casts to quiet warnings; 255 DEPENDENCY */
-    PAM_ASSIGN( acolormap[bi].acolor, (unsigned char)r, (unsigned char)g, (unsigned char)b, (unsigned char)a );
+    PAM_ASSIGN(acolormap[bi].acolor, (unsigned char)r, (unsigned char)g,
+               (unsigned char)b, (unsigned char)a);
 #endif /*REP_AVERAGE_PIXELS*/
   }
 
@@ -525,45 +532,32 @@ mediancut( acolorhist_vector achv, int c
   return acolormap;
 }
 
-static int
-redcompare( const void *ch1, const void *ch2 )
-{
-  return (int) PAM_GETR( ((acolorhist_vector)ch1)->acolor ) -
-         (int) PAM_GETR( ((acolorhist_vector)ch2)->acolor );
+static int redcompare(const void *ch1, const void *ch2) {
+  return (int)PAM_GETR(((acolorhist_vector)ch1)->acolor) -
+         (int)PAM_GETR(((acolorhist_vector)ch2)->acolor);
 }
 
-static int
-greencompare( const void *ch1, const void *ch2 )
-{
-  return (int) PAM_GETG( ((acolorhist_vector)ch1)->acolor ) -
-         (int) PAM_GETG( ((acolorhist_vector)ch2)->acolor );
+static int greencompare(const void *ch1, const void *ch2) {
+  return (int)PAM_GETG(((acolorhist_vector)ch1)->acolor) -
+         (int)PAM_GETG(((acolorhist_vector)ch2)->acolor);
 }
 
-static int
-bluecompare( const void *ch1, const void *ch2 )
-{
-  return (int) PAM_GETB( ((acolorhist_vector)ch1)->acolor ) -
-         (int) PAM_GETB( ((acolorhist_vector)ch2)->acolor );
+static int bluecompare(const void *ch1, const void *ch2) {
+  return (int)PAM_GETB(((acolorhist_vector)ch1)->acolor) -
+         (int)PAM_GETB(((acolorhist_vector)ch2)->acolor);
 }
 
-static int
-alphacompare( const void *ch1, const void *ch2 )
-{
-  return (int) PAM_GETA( ((acolorhist_vector)ch1)->acolor ) -
-         (int) PAM_GETA( ((acolorhist_vector)ch2)->acolor );
+static int alphacompare(const void *ch1, const void *ch2) {
+  return (int)PAM_GETA(((acolorhist_vector)ch1)->acolor) -
+         (int)PAM_GETA(((acolorhist_vector)ch2)->acolor);
 }
 
-static int
-sumcompare( const void *b1, const void *b2 )
-{
-  return ((box_vector)b2)->sum -
-         ((box_vector)b1)->sum;
+static int sumcompare(const void *b1, const void *b2) {
+  return ((box_vector)b2)->sum - ((box_vector)b1)->sum;
 }
 
-
 /*===========================================================================*/
 
-
 /* libpam3.c - pam (portable alpha map) utility library part 3
  **
  ** Colormap routines.
@@ -586,62 +580,60 @@ sumcompare( const void *b1, const void *
 
 #define HASH_SIZE 20023
 
-#define pam_hashapixel(p) ( ( ( (long) PAM_GETR(p) * 33023 + \
-    (long) PAM_GETG(p) * 30013 + \
-    (long) PAM_GETB(p) * 27011 + \
-    (long) PAM_GETA(p) * 24007 ) \
-    & 0x7fffffff ) % HASH_SIZE )
-
-static acolorhist_vector
-pam_computeacolorhist( apixels, cols, rows, maxacolors, acolorsP )
-rgbaPixel** apixels;
+#define pam_hashapixel(p)                                                      \
+  ((((long)PAM_GETR(p) * 33023 + (long)PAM_GETG(p) * 30013 +                   \
+     (long)PAM_GETB(p) * 27011 + (long)PAM_GETA(p) * 24007) &                  \
+    0x7fffffff) %                                                              \
+   HASH_SIZE)
+
+static acolorhist_vector pam_computeacolorhist(apixels, cols, rows, maxacolors,
+                                               acolorsP)
+rgbaPixel **apixels;
 int cols, rows, maxacolors;
-int* acolorsP;
+int *acolorsP;
 {
   acolorhash_table acht;
   acolorhist_vector achv;
 
-  acht = pam_computeacolorhash( apixels, cols, rows, maxacolors, acolorsP );
-  if ( acht == (acolorhash_table) 0 )
-    return (acolorhist_vector) 0;
-  achv = pam_acolorhashtoacolorhist( acht, maxacolors );
-  pam_freeacolorhash( acht );
+  acht = pam_computeacolorhash(apixels, cols, rows, maxacolors, acolorsP);
+  if (acht == (acolorhash_table)0)
+    return (acolorhist_vector)0;
+  achv = pam_acolorhashtoacolorhist(acht, maxacolors);
+  pam_freeacolorhash(acht);
   return achv;
 }
 
-
-
-static acolorhash_table
-pam_computeacolorhash( apixels, cols, rows, maxacolors, acolorsP )
-rgbaPixel** apixels;
+static acolorhash_table pam_computeacolorhash(apixels, cols, rows, maxacolors,
+                                              acolorsP)
+rgbaPixel **apixels;
 int cols, rows, maxacolors;
-int* acolorsP;
+int *acolorsP;
 {
   acolorhash_table acht;
-  register rgbaPixel* pP;
+  register rgbaPixel *pP;
   acolorhist_list achl;
   int col, row, hash;
 
-  acht = pam_allocacolorhash( );
+  acht = pam_allocacolorhash();
   *acolorsP = 0;
 
   /* Go through the entire image, building a hash table of colors. */
-  for ( row = 0; row < rows; ++row )
-    for ( col = 0, pP = apixels[row]; col < cols; ++col, ++pP ) {
-      hash = pam_hashapixel( *pP );
-      for ( achl = acht[hash]; achl != (acolorhist_list) 0; achl = achl->next )
-        if ( PAM_EQUAL( achl->ch.acolor, *pP ) )
+  for (row = 0; row < rows; ++row)
+    for (col = 0, pP = apixels[row]; col < cols; ++col, ++pP) {
+      hash = pam_hashapixel(*pP);
+      for (achl = acht[hash]; achl != (acolorhist_list)0; achl = achl->next)
+        if (PAM_EQUAL(achl->ch.acolor, *pP))
           break;
-      if ( achl != (acolorhist_list) 0 )
+      if (achl != (acolorhist_list)0)
         ++(achl->ch.value);
       else {
-        if ( ++(*acolorsP) > maxacolors ) {
-          pam_freeacolorhash( acht );
-          return (acolorhash_table) 0;
+        if (++(*acolorsP) > maxacolors) {
+          pam_freeacolorhash(acht);
+          return (acolorhash_table)0;
         }
-        achl = (acolorhist_list) malloc( sizeof(struct acolorhist_list_item) );
-        if ( achl == 0 ) {
-          fprintf( stderr, "  out of memory computing hash table\n" );
+        achl = (acolorhist_list)malloc(sizeof(struct acolorhist_list_item));
+        if (achl == 0) {
+          fprintf(stderr, "  out of memory computing hash table\n");
           exit(7);
         }
         achl->ch.acolor = *pP;
@@ -654,40 +646,33 @@ int* acolorsP;
   return acht;
 }
 
-
-
-static acolorhash_table
-pam_allocacolorhash( )
-{
+static acolorhash_table pam_allocacolorhash() {
   acolorhash_table acht;
   int i;
 
-  acht = (acolorhash_table) malloc( HASH_SIZE * sizeof(acolorhist_list) );
-  if ( acht == 0 ) {
-    fprintf( stderr, "  out of memory allocating hash table\n" );
+  acht = (acolorhash_table)malloc(HASH_SIZE * sizeof(acolorhist_list));
+  if (acht == 0) {
+    fprintf(stderr, "  out of memory allocating hash table\n");
     exit(8);
   }
 
-  for ( i = 0; i < HASH_SIZE; ++i )
-    acht[i] = (acolorhist_list) 0;
+  for (i = 0; i < HASH_SIZE; ++i)
+    acht[i] = (acolorhist_list)0;
 
   return acht;
 }
 
-
-
-static int
-pam_addtoacolorhash( acht, acolorP, value )
+static int pam_addtoacolorhash(acht, acolorP, value)
 acolorhash_table acht;
-rgbaPixel* acolorP;
+rgbaPixel *acolorP;
 int value;
 {
   register int hash;
   register acolorhist_list achl;
 
-  achl = (acolorhist_list) msSmallMalloc( sizeof(struct acolorhist_list_item) );
+  achl = (acolorhist_list)msSmallMalloc(sizeof(struct acolorhist_list_item));
 
-  hash = pam_hashapixel( *acolorP );
+  hash = pam_hashapixel(*acolorP);
   achl->ch.acolor = *acolorP;
   achl->ch.value = value;
   achl->next = acht[hash];
@@ -695,10 +680,7 @@ int value;
   return 0;
 }
 
-
-
-static acolorhist_vector
-pam_acolorhashtoacolorhist( acht, maxacolors )
+static acolorhist_vector pam_acolorhashtoacolorhist(acht, maxacolors)
 acolorhash_table acht;
 int maxacolors;
 {
@@ -707,17 +689,17 @@ int maxacolors;
   int i, j;
 
   /* Now collate the hash table into a simple acolorhist array. */
-  achv = (acolorhist_vector) malloc( maxacolors * sizeof(struct acolorhist_item) );
+  achv = (acolorhist_vector)malloc(maxacolors * sizeof(struct acolorhist_item));
   /* (Leave room for expansion by caller.) */
-  if ( achv == (acolorhist_vector) 0 ) {
-    fprintf( stderr, "  out of memory generating histogram\n" );
+  if (achv == (acolorhist_vector)0) {
+    fprintf(stderr, "  out of memory generating histogram\n");
     exit(9);
   }
 
   /* Loop through the hash table. */
   j = 0;
-  for ( i = 0; i < HASH_SIZE; ++i )
-    for ( achl = acht[i]; achl != (acolorhist_list) 0; achl = achl->next ) {
+  for (i = 0; i < HASH_SIZE; ++i)
+    for (achl = acht[i]; achl != (acolorhist_list)0; achl = achl->next) {
       /* Add the new entry. */
       achv[j] = achl->ch;
       ++j;
@@ -727,49 +709,33 @@ int maxacolors;
   return achv;
 }
 
-
-
-static int
-pam_lookupacolor( acht, acolorP )
+static int pam_lookupacolor(acht, acolorP)
 acolorhash_table acht;
-rgbaPixel* acolorP;
+rgbaPixel *acolorP;
 {
   int hash;
   acolorhist_list achl;
 
-  hash = pam_hashapixel( *acolorP );
-  for ( achl = acht[hash]; achl != (acolorhist_list) 0; achl = achl->next )
-    if ( PAM_EQUAL( achl->ch.acolor, *acolorP ) )
+  hash = pam_hashapixel(*acolorP);
+  for (achl = acht[hash]; achl != (acolorhist_list)0; achl = achl->next)
+    if (PAM_EQUAL(achl->ch.acolor, *acolorP))
       return achl->ch.value;
 
   return -1;
 }
 
+static void pam_freeacolorhist(achv) acolorhist_vector achv;
+{ free((char *)achv); }
 
-
-static void
-pam_freeacolorhist( achv )
-acolorhist_vector achv;
-{
-  free( (char*) achv );
-}
-
-
-
-static void
-pam_freeacolorhash( acht )
-acolorhash_table acht;
+static void pam_freeacolorhash(acht) acolorhash_table acht;
 {
   int i;
   acolorhist_list achl, achlnext;
 
-  for ( i = 0; i < HASH_SIZE; ++i )
-    for ( achl = acht[i]; achl != (acolorhist_list) 0; achl = achlnext ) {
+  for (i = 0; i < HASH_SIZE; ++i)
+    for (achl = acht[i]; achl != (acolorhist_list)0; achl = achlnext) {
       achlnext = achl->next;
-      free( (char*) achl );
+      free((char *)achl);
     }
-  free( (char*) acht );
+  free((char *)acht);
 }
-
-
-
diff -pruN 8.0.1-5/mapquery.c 8.0.2-1/mapquery.c
--- 8.0.1-5/mapquery.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapquery.c	2024-06-11 20:41:34.000000000 +0000
@@ -34,21 +34,21 @@
 
 /* This object is used by the various mapQueryXXXXX() functions. It stores
  * the total amount of shapes and their RAM footprint, when they are cached
- * in the resultCacheObj* of layers. This is the total number accross all queried
- * layers. However this is isn't persistant accross several calls to
+ * in the resultCacheObj* of layers. This is the total number accross all
+ * queried layers. However this is isn't persistant accross several calls to
  * mapQueryXXXXX(), if the resultCacheObj* objects weren't cleaned up. This
  * is not needed in the context of WFS, for which this is used for now.
  */
-typedef struct
-{
-    int cachedShapeCountWarningEmitted;
-    int cachedShapeCount;
-    int cachedShapeRAMWarningEmitted;
-    int cachedShapeRAM;
+typedef struct {
+  int cachedShapeCountWarningEmitted;
+  int cachedShapeCount;
+  int cachedShapeRAMWarningEmitted;
+  int cachedShapeRAM;
 } queryCacheObj;
 
 int msInitQuery(queryObj *query) {
-  if(!query) return MS_FAILURE;
+  if (!query)
+    return MS_FAILURE;
 
   msFreeQuery(query); /* clean up anything previously allocated */
 
@@ -61,19 +61,21 @@ int msInitQuery(queryObj *query) {
   query->buffer = 0.0;
   query->maxresults = 0; /* only used by msQueryByPoint() apparently */
 
-  query->rect.minx = query->rect.miny = query->rect.maxx = query->rect.maxy = -1;
+  query->rect.minx = query->rect.miny = query->rect.maxx = query->rect.maxy =
+      -1;
   query->shape = NULL;
 
   query->shapeindex = query->tileindex = -1;
-  query->clear_resultcache = MS_TRUE; /* index queries allow the old results to persist */
+  query->clear_resultcache =
+      MS_TRUE; /* index queries allow the old results to persist */
 
   query->maxfeatures = -1;
   query->startindex = -1;
   query->only_cache_result_count = 0;
-  
+
   query->filteritem = NULL;
   msInitExpression(&query->filter);
-  
+
   query->cache_shapes = MS_FALSE;
   query->max_cached_shape_count = 0;
   query->max_cached_shape_ram_amount = 0;
@@ -81,54 +83,55 @@ int msInitQuery(queryObj *query) {
   return MS_SUCCESS;
 }
 
-void msFreeQuery(queryObj *query)
-{
-  if(query->shape) {
+void msFreeQuery(queryObj *query) {
+  if (query->shape) {
     msFreeShape(query->shape);
     free(query->shape);
   }
 
-  if(query->filteritem) free(query->filteritem);
+  if (query->filteritem)
+    free(query->filteritem);
   msFreeExpression(&query->filter);
 }
 
 /*
-** Wrapper for all query functions, just feed is a mapObj with a populated queryObj...
+** Wrapper for all query functions, just feed is a mapObj with a populated
+*queryObj...
 */
-int msExecuteQuery(mapObj *map)
-{
-  int tmp=-1, status;
+int msExecuteQuery(mapObj *map) {
+  int tmp = -1, status;
 
   /* handle slayer/qlayer management for feature queries */
-  if(map->query.slayer >= 0) {
+  if (map->query.slayer >= 0) {
     tmp = map->query.layer;
     map->query.layer = map->query.slayer;
   }
 
-  switch(map->query.type) {
-    case MS_QUERY_BY_POINT:
-      status = msQueryByPoint(map);
-      break;
-    case MS_QUERY_BY_RECT:
-      status = msQueryByRect(map);
-      break;
-    case MS_QUERY_BY_FILTER:
-      status = msQueryByFilter(map);
-      break;
-    case MS_QUERY_BY_SHAPE:
-      status = msQueryByShape(map);
-      break;
-    case MS_QUERY_BY_INDEX:
-      status = msQueryByIndex(map);
-      break;
-    default:
-      msSetError(MS_QUERYERR, "Malformed queryObj.", "msExecuteQuery()");
-      return(MS_FAILURE);
+  switch (map->query.type) {
+  case MS_QUERY_BY_POINT:
+    status = msQueryByPoint(map);
+    break;
+  case MS_QUERY_BY_RECT:
+    status = msQueryByRect(map);
+    break;
+  case MS_QUERY_BY_FILTER:
+    status = msQueryByFilter(map);
+    break;
+  case MS_QUERY_BY_SHAPE:
+    status = msQueryByShape(map);
+    break;
+  case MS_QUERY_BY_INDEX:
+    status = msQueryByIndex(map);
+    break;
+  default:
+    msSetError(MS_QUERYERR, "Malformed queryObj.", "msExecuteQuery()");
+    return (MS_FAILURE);
   }
 
-  if(map->query.slayer >= 0) {
+  if (map->query.slayer >= 0) {
     map->query.layer = tmp; /* restore layer */
-    if(status == MS_SUCCESS) status = msQueryByFeatures(map);
+    if (status == MS_SUCCESS)
+      status = msQueryByFeatures(map);
   }
 
   return status;
@@ -137,89 +140,89 @@ int msExecuteQuery(mapObj *map)
 /*
 ** msIsLayerQueryable()  returns MS_TRUE/MS_FALSE
 */
-int msIsLayerQueryable(layerObj *lp)
-{
+int msIsLayerQueryable(layerObj *lp) {
   int i;
 
-  if ( lp->type == MS_LAYER_TILEINDEX )
+  if (lp->type == MS_LAYER_TILEINDEX)
     return MS_FALSE;
 
-  if(lp->template && strlen(lp->template) > 0) return MS_TRUE;
+  if (lp->template && strlen(lp->template) > 0)
+    return MS_TRUE;
 
-  for(i=0; i<lp->numclasses; i++) {
-    if(lp->class[i]->template && strlen(lp->class[i]->template) > 0)
+  for (i = 0; i < lp->numclasses; i++) {
+    if (lp->class[i] -> template &&strlen(lp->class[i] -> template) > 0)
       return MS_TRUE;
   }
 
   return MS_FALSE;
 }
 
-static void initQueryCache(queryCacheObj* queryCache)
-{
-    queryCache->cachedShapeCountWarningEmitted = MS_FALSE;
-    queryCache->cachedShapeCount = 0;
-    queryCache->cachedShapeRAMWarningEmitted = MS_FALSE;
-    queryCache->cachedShapeRAM = 0;
+static void initQueryCache(queryCacheObj *queryCache) {
+  queryCache->cachedShapeCountWarningEmitted = MS_FALSE;
+  queryCache->cachedShapeCount = 0;
+  queryCache->cachedShapeRAMWarningEmitted = MS_FALSE;
+  queryCache->cachedShapeRAM = 0;
 }
 
 /** Check whether we should store the shape in resultCacheObj* given the
  * limits allowed in map->query.max_cached_shape_count and
  * map->query.max_cached_shape_ram_amount.
  */
-static int canCacheShape(mapObj* map, queryCacheObj *queryCache, int shape_ram_size)
-{
-  if( !map->query.cache_shapes )
-      return MS_FALSE;
-  if( queryCache->cachedShapeCountWarningEmitted ||
+static int canCacheShape(mapObj *map, queryCacheObj *queryCache,
+                         int shape_ram_size) {
+  if (!map->query.cache_shapes)
+    return MS_FALSE;
+  if (queryCache->cachedShapeCountWarningEmitted ||
       (map->query.max_cached_shape_count > 0 &&
-      queryCache->cachedShapeCount >= map->query.max_cached_shape_count) )
-  {
-      if( !queryCache->cachedShapeCountWarningEmitted )
-      {
-          queryCache->cachedShapeCountWarningEmitted = MS_TRUE;
-          if (map->debug >= MS_DEBUGLEVEL_V) {
-              msDebug("map->query.max_cached_shape_count = %d reached. "
-                  "Next features will not be cached.\n",
-                  map->query.max_cached_shape_count);
-          }
+       queryCache->cachedShapeCount >= map->query.max_cached_shape_count)) {
+    if (!queryCache->cachedShapeCountWarningEmitted) {
+      queryCache->cachedShapeCountWarningEmitted = MS_TRUE;
+      if (map->debug >= MS_DEBUGLEVEL_V) {
+        msDebug("map->query.max_cached_shape_count = %d reached. "
+                "Next features will not be cached.\n",
+                map->query.max_cached_shape_count);
       }
-      return MS_FALSE;
+    }
+    return MS_FALSE;
   }
-  if( queryCache->cachedShapeRAMWarningEmitted ||
+  if (queryCache->cachedShapeRAMWarningEmitted ||
       (map->query.max_cached_shape_ram_amount > 0 &&
-       queryCache->cachedShapeRAM + shape_ram_size > map->query.max_cached_shape_ram_amount) )
-  {
-      if( !queryCache->cachedShapeRAMWarningEmitted )
-      {
-          queryCache->cachedShapeRAMWarningEmitted = MS_TRUE;
-          if (map->debug >= MS_DEBUGLEVEL_V) {
-              msDebug("map->query.max_cached_shape_ram_amount = %d reached after %d cached features. "
-                  "Next features will not be cached.\n",
-                  map->query.max_cached_shape_ram_amount,
-                  queryCache->cachedShapeCount);
-          }
+       queryCache->cachedShapeRAM + shape_ram_size >
+           map->query.max_cached_shape_ram_amount)) {
+    if (!queryCache->cachedShapeRAMWarningEmitted) {
+      queryCache->cachedShapeRAMWarningEmitted = MS_TRUE;
+      if (map->debug >= MS_DEBUGLEVEL_V) {
+        msDebug("map->query.max_cached_shape_ram_amount = %d reached after %d "
+                "cached features. "
+                "Next features will not be cached.\n",
+                map->query.max_cached_shape_ram_amount,
+                queryCache->cachedShapeCount);
       }
-      return MS_FALSE;
+    }
+    return MS_FALSE;
   }
   return MS_TRUE;
 }
 
-static int addResult(mapObj* map, resultCacheObj *cache,
-                     queryCacheObj* queryCache, shapeObj *shape)
-{
+static int addResult(mapObj *map, resultCacheObj *cache,
+                     queryCacheObj *queryCache, shapeObj *shape) {
   int i;
-  int shape_ram_size = (map->query.max_cached_shape_ram_amount > 0) ? 
-                                            msGetShapeRAMSize( shape ) : 0;
-  int store_shape = canCacheShape (map, queryCache, shape_ram_size);
-
-  if(cache->numresults == cache->cachesize) { /* just add it to the end */
-    if(cache->cachesize == 0)
-      cache->results = (resultObj *) malloc(sizeof(resultObj)*MS_RESULTCACHEINCREMENT);
+  int shape_ram_size = (map->query.max_cached_shape_ram_amount > 0)
+                           ? msGetShapeRAMSize(shape)
+                           : 0;
+  int store_shape = canCacheShape(map, queryCache, shape_ram_size);
+
+  if (cache->numresults == cache->cachesize) { /* just add it to the end */
+    if (cache->cachesize == 0)
+      cache->results =
+          (resultObj *)malloc(sizeof(resultObj) * MS_RESULTCACHEINCREMENT);
     else
-      cache->results = (resultObj *) realloc(cache->results, sizeof(resultObj)*(cache->cachesize+MS_RESULTCACHEINCREMENT));
-    if(!cache->results) {
+      cache->results = (resultObj *)realloc(
+          cache->results,
+          sizeof(resultObj) * (cache->cachesize + MS_RESULTCACHEINCREMENT));
+    if (!cache->results) {
       msSetError(MS_MEMERR, "Realloc() error.", "addResult()");
-      return(MS_FAILURE);
+      return (MS_FAILURE);
     }
     cache->cachesize += MS_RESULTCACHEINCREMENT;
   }
@@ -230,61 +233,64 @@ static int addResult(mapObj* map, result
   cache->results[i].tileindex = shape->tileindex;
   cache->results[i].shapeindex = shape->index;
   cache->results[i].resultindex = shape->resultindex;
-  if( store_shape )
-  {
-      cache->results[i].shape = (shapeObj*)msSmallMalloc(sizeof(shapeObj));
-      msInitShape(cache->results[i].shape);
-      msCopyShape(shape, cache->results[i].shape);
-      queryCache->cachedShapeCount ++;
-      queryCache->cachedShapeRAM += shape_ram_size;
-  }
-  else
-      cache->results[i].shape = NULL;
+  if (store_shape) {
+    cache->results[i].shape = (shapeObj *)msSmallMalloc(sizeof(shapeObj));
+    msInitShape(cache->results[i].shape);
+    msCopyShape(shape, cache->results[i].shape);
+    queryCache->cachedShapeCount++;
+    queryCache->cachedShapeRAM += shape_ram_size;
+  } else
+    cache->results[i].shape = NULL;
   cache->numresults++;
 
   cache->previousBounds = cache->bounds;
-  if(cache->numresults == 1)
+  if (cache->numresults == 1)
     cache->bounds = shape->bounds;
   else
     msMergeRect(&(cache->bounds), &(shape->bounds));
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
 /*
 ** Serialize a query result set to disk.
 */
-static int saveQueryResults(mapObj *map, char *filename)
-{
+static int saveQueryResults(mapObj *map, char *filename) {
   FILE *stream;
-  int i, j, n=0;
+  int i, j, n = 0;
 
-  if(!filename) {
-    msSetError(MS_MISCERR, "No filename provided to save query results to.", "saveQueryResults()");
+  if (!filename) {
+    msSetError(MS_MISCERR, "No filename provided to save query results to.",
+               "saveQueryResults()");
     return MS_FAILURE;
   }
 
   stream = fopen(filename, "w");
-  if(!stream) {
+  if (!stream) {
     msSetError(MS_IOERR, "(%s)", "saveQueryResults()", filename);
     return MS_FAILURE;
   }
 
-  fprintf(stream, "%s - Generated by msSaveQuery()\n", MS_QUERY_RESULTS_MAGIC_STRING);
+  fprintf(stream, "%s - Generated by msSaveQuery()\n",
+          MS_QUERY_RESULTS_MAGIC_STRING);
 
   /* count the number of layers with results */
-  for(i=0; i<map->numlayers; i++)
-    if(GET_LAYER(map, i)->resultcache) n++;
+  for (i = 0; i < map->numlayers; i++)
+    if (GET_LAYER(map, i)->resultcache)
+      n++;
   fwrite(&n, sizeof(int), 1, stream);
 
   /* now write the result set for each layer */
-  for(i=0; i<map->numlayers; i++) {
-    if(GET_LAYER(map, i)->resultcache) {
+  for (i = 0; i < map->numlayers; i++) {
+    if (GET_LAYER(map, i)->resultcache) {
       fwrite(&i, sizeof(int), 1, stream); /* layer index */
-      fwrite(&(GET_LAYER(map, i)->resultcache->numresults), sizeof(int), 1, stream); /* number of results */
-      fwrite(&(GET_LAYER(map, i)->resultcache->bounds), sizeof(rectObj), 1, stream); /* bounding box */
-      for(j=0; j<GET_LAYER(map, i)->resultcache->numresults; j++)
-        fwrite(&(GET_LAYER(map, i)->resultcache->results[j]), sizeof(resultObj), 1, stream); /* each result */
+      fwrite(&(GET_LAYER(map, i)->resultcache->numresults), sizeof(int), 1,
+             stream); /* number of results */
+      fwrite(&(GET_LAYER(map, i)->resultcache->bounds), sizeof(rectObj), 1,
+             stream); /* bounding box */
+      for (j = 0; j < GET_LAYER(map, i)->resultcache->numresults; j++)
+        fwrite(&(GET_LAYER(map, i)->resultcache->results[j]), sizeof(resultObj),
+               1, stream); /* each result */
     }
   }
 
@@ -292,65 +298,87 @@ static int saveQueryResults(mapObj *map,
   return MS_SUCCESS;
 }
 
-static int loadQueryResults(mapObj *map, FILE *stream)
-{
-  int i, j, k, n=0;
+static int loadQueryResults(mapObj *map, FILE *stream) {
+  int i, j, k, n = 0;
 
-  if(1 != fread(&n, sizeof(int), 1, stream) || n > INT_MAX - 1) {
-    msSetError(MS_MISCERR,"failed to read query count from query file stream", "loadQueryResults()");
+  if (1 != fread(&n, sizeof(int), 1, stream) || n > INT_MAX - 1) {
+    msSetError(MS_MISCERR, "failed to read query count from query file stream",
+               "loadQueryResults()");
     return MS_FAILURE;
   }
 
   /* now load the result set for each layer found in the query file */
-  for(i=0; i<n; i++) {
-    if(1 != fread(&j, sizeof(int), 1, stream)) { /* layer index */
-      msSetError(MS_MISCERR,"failed to read layer index from query file stream", "loadQueryResults()");
+  for (i = 0; i < n; i++) {
+    if (1 != fread(&j, sizeof(int), 1, stream)) { /* layer index */
+      msSetError(MS_MISCERR,
+                 "failed to read layer index from query file stream",
+                 "loadQueryResults()");
       return MS_FAILURE;
     }
 
-    if(j<0 || j>map->numlayers) {
-      msSetError(MS_MISCERR, "Invalid layer index loaded from query file.", "loadQueryResults()");
+    if (j < 0 || j > map->numlayers) {
+      msSetError(MS_MISCERR, "Invalid layer index loaded from query file.",
+                 "loadQueryResults()");
       return MS_FAILURE;
     }
 
     /* inialize the results for this layer */
-    GET_LAYER(map, j)->resultcache = (resultCacheObj *)malloc(sizeof(resultCacheObj)); /* allocate and initialize the result cache */
-    MS_CHECK_ALLOC(GET_LAYER(map, j)->resultcache, sizeof(resultCacheObj), MS_FAILURE);
-
-    if(1 != fread(&(GET_LAYER(map, j)->resultcache->numresults), sizeof(int), 1, stream) || (GET_LAYER(map, j)->resultcache->numresults < 0)) { /* number of results */
-      msSetError(MS_MISCERR,"failed to read number of results from query file stream", "loadQueryResults()");
+    GET_LAYER(map, j)->resultcache = (resultCacheObj *)malloc(
+        sizeof(resultCacheObj)); /* allocate and initialize the result cache */
+    MS_CHECK_ALLOC(GET_LAYER(map, j)->resultcache, sizeof(resultCacheObj),
+                   MS_FAILURE);
+
+    if (1 != fread(&(GET_LAYER(map, j)->resultcache->numresults), sizeof(int),
+                   1, stream) ||
+        (GET_LAYER(map, j)->resultcache->numresults <
+         0)) { /* number of results */
+      msSetError(MS_MISCERR,
+                 "failed to read number of results from query file stream",
+                 "loadQueryResults()");
       free(GET_LAYER(map, j)->resultcache);
       GET_LAYER(map, j)->resultcache = NULL;
       return MS_FAILURE;
     }
-    GET_LAYER(map, j)->resultcache->cachesize = GET_LAYER(map, j)->resultcache->numresults;
+    GET_LAYER(map, j)->resultcache->cachesize =
+        GET_LAYER(map, j)->resultcache->numresults;
 
-    if(1 != fread(&(GET_LAYER(map, j)->resultcache->bounds), sizeof(rectObj), 1, stream)) { /* bounding box */
-      msSetError(MS_MISCERR,"failed to read bounds from query file stream", "loadQueryResults()");
+    if (1 != fread(&(GET_LAYER(map, j)->resultcache->bounds), sizeof(rectObj),
+                   1, stream)) { /* bounding box */
+      msSetError(MS_MISCERR, "failed to read bounds from query file stream",
+                 "loadQueryResults()");
       free(GET_LAYER(map, j)->resultcache);
       GET_LAYER(map, j)->resultcache = NULL;
       return MS_FAILURE;
     }
 
-    GET_LAYER(map, j)->resultcache->results = (resultObj *) malloc(sizeof(resultObj)*GET_LAYER(map, j)->resultcache->numresults);
+    GET_LAYER(map, j)->resultcache->results = (resultObj *)malloc(
+        sizeof(resultObj) * GET_LAYER(map, j)->resultcache->numresults);
     if (GET_LAYER(map, j)->resultcache->results == NULL) {
-      msSetError(MS_MEMERR, "%s: %d: Out of memory allocating %u bytes.\n", "loadQueryResults()",
-                 __FILE__, __LINE__, (unsigned int)(sizeof(resultObj)*GET_LAYER(map, j)->resultcache->numresults));
+      msSetError(MS_MEMERR, "%s: %d: Out of memory allocating %u bytes.\n",
+                 "loadQueryResults()", __FILE__, __LINE__,
+                 (unsigned int)(sizeof(resultObj) *
+                                GET_LAYER(map, j)->resultcache->numresults));
       free(GET_LAYER(map, j)->resultcache);
       GET_LAYER(map, j)->resultcache = NULL;
       return MS_FAILURE;
     }
 
-    for(k=0; k<GET_LAYER(map, j)->resultcache->numresults; k++) {
-      if(1 != fread(&(GET_LAYER(map, j)->resultcache->results[k]), sizeof(resultObj), 1, stream)) { /* each result */
-        msSetError(MS_MISCERR,"failed to read result %d from query file stream", "loadQueryResults()", k);
+    for (k = 0; k < GET_LAYER(map, j)->resultcache->numresults; k++) {
+      if (1 != fread(&(GET_LAYER(map, j)->resultcache->results[k]),
+                     sizeof(resultObj), 1, stream)) { /* each result */
+        msSetError(MS_MISCERR,
+                   "failed to read result %d from query file stream",
+                   "loadQueryResults()", k);
         free(GET_LAYER(map, j)->resultcache->results);
         free(GET_LAYER(map, j)->resultcache);
         GET_LAYER(map, j)->resultcache = NULL;
         return MS_FAILURE;
       }
-      if(!GET_LAYER(map, j)->tileindex) GET_LAYER(map, j)->resultcache->results[k].tileindex = -1; /* reset the tile index for non-tiled layers */
-      GET_LAYER(map, j)->resultcache->results[k].resultindex = -1; /* all results loaded this way have a -1 result (set) index */
+      if (!GET_LAYER(map, j)->tileindex)
+        GET_LAYER(map, j)->resultcache->results[k].tileindex =
+            -1; /* reset the tile index for non-tiled layers */
+      GET_LAYER(map, j)->resultcache->results[k].resultindex =
+          -1; /* all results loaded this way have a -1 result (set) index */
     }
   }
 
@@ -358,43 +386,54 @@ static int loadQueryResults(mapObj *map,
 }
 
 /*
-** Serialize the parameters necessary to duplicate a query to disk. (TODO: add filter query...)
+** Serialize the parameters necessary to duplicate a query to disk. (TODO: add
+*filter query...)
 */
-static int saveQueryParams(mapObj *map, char *filename)
-{
+static int saveQueryParams(mapObj *map, char *filename) {
   FILE *stream;
 
-  if(!filename) {
-    msSetError(MS_MISCERR, "No filename provided to save query to.", "saveQueryParams()");
+  if (!filename) {
+    msSetError(MS_MISCERR, "No filename provided to save query to.",
+               "saveQueryParams()");
     return MS_FAILURE;
   }
 
   stream = fopen(filename, "w");
-  if(!stream) {
+  if (!stream) {
     msSetError(MS_IOERR, "(%s)", "saveQueryParams()", filename);
     return MS_FAILURE;
   }
 
-  fprintf(stream, "%s - Generated by msSaveQuery()\n", MS_QUERY_PARAMS_MAGIC_STRING);
+  fprintf(stream, "%s - Generated by msSaveQuery()\n",
+          MS_QUERY_PARAMS_MAGIC_STRING);
 
-  fprintf(stream, "%d %d %d %d\n", map->query.mode, map->query.type, map->query.layer, map->query.slayer); /* all queries */
-  fprintf(stream, "%.15g %.15g %g %d\n", map->query.point.x, map->query.point.y, map->query.buffer, map->query.maxresults); /* by point */
-  fprintf(stream, "%.15g %.15g %.15g %.15g\n", map->query.rect.minx, map->query.rect.miny, map->query.rect.maxx, map->query.rect.maxy); /* by rect */
-  fprintf(stream, "%ld %ld %d\n", map->query.shapeindex, map->query.tileindex, map->query.clear_resultcache); /* by index */
+  fprintf(stream, "%d %d %d %d\n", map->query.mode, map->query.type,
+          map->query.layer, map->query.slayer); /* all queries */
+  fprintf(stream, "%.15g %.15g %g %d\n", map->query.point.x, map->query.point.y,
+          map->query.buffer, map->query.maxresults); /* by point */
+  fprintf(stream, "%.15g %.15g %.15g %.15g\n", map->query.rect.minx,
+          map->query.rect.miny, map->query.rect.maxx,
+          map->query.rect.maxy); /* by rect */
+  fprintf(stream, "%ld %ld %d\n", map->query.shapeindex, map->query.tileindex,
+          map->query.clear_resultcache); /* by index */
+
+  fprintf(stream, "%s\n",
+          (map->query.filteritem) ? map->query.filteritem
+                                  : "NULL"); /* by filter */
+  fprintf(stream, "%s\n",
+          (map->query.filter.string) ? map->query.filter.string : "NULL");
 
-  fprintf(stream, "%s\n", (map->query.filteritem)?map->query.filteritem:"NULL"); /* by filter */
-  fprintf(stream, "%s\n", (map->query.filter.string)?map->query.filter.string:"NULL");
-
-  if(map->query.shape) { /* by shape */
+  if (map->query.shape) { /* by shape */
     int i, j;
     shapeObj *s = map->query.shape;
 
     fprintf(stream, "%d\n", s->type);
     fprintf(stream, "%d\n", s->numlines);
-    for(i=0; i<s->numlines; i++) {
+    for (i = 0; i < s->numlines; i++) {
       fprintf(stream, "%d\n", s->line[i].numpoints);
-      for(j=0; j<s->line[i].numpoints; j++)
-        fprintf(stream, "%.15g %.15g\n", s->line[i].point[j].x, s->line[i].point[j].y);
+      for (j = 0; j < s->line[i].numpoints; j++)
+        fprintf(stream, "%.15g %.15g\n", s->line[i].point[j].x,
+                s->line[i].point[j].y);
     }
   } else {
     fprintf(stream, "%d\n", MS_SHAPE_NULL); /* NULL shape */
@@ -404,8 +443,7 @@ static int saveQueryParams(mapObj *map,
   return MS_SUCCESS;
 }
 
-static int loadQueryParams(mapObj *map, FILE *stream)
-{
+static int loadQueryParams(mapObj *map, FILE *stream) {
   char buffer[MS_BUFFER_LENGTH];
   int lineno;
 
@@ -414,60 +452,78 @@ static int loadQueryParams(mapObj *map,
   msInitQuery(&(map->query)); /* this will free any previous query as well */
 
   lineno = 2; /* line 1 is the magic string */
-  while(fgets(buffer, MS_BUFFER_LENGTH, stream) != NULL) {
-    switch(lineno) {
-      case 2:
-        if(sscanf(buffer, "%d %d %d %d\n", &(map->query.mode), &(map->query.type), &(map->query.layer), &(map->query.slayer)) != 4) goto parse_error;
-        break;
-      case 3:
-        if(sscanf(buffer, "%lf %lf %lf %d\n", &map->query.point.x, &map->query.point.y, &map->query.buffer, &map->query.maxresults) != 4) goto parse_error;
-        break;
-      case 4:
-        if(sscanf(buffer, "%lf %lf %lf %lf\n", &map->query.rect.minx, &map->query.rect.miny, &map->query.rect.maxx, &map->query.rect.maxy) != 4) goto parse_error;
-        break;
-      case 5:
-        if(sscanf(buffer, "%ld %ld %d\n", &map->query.shapeindex, &map->query.tileindex, &map->query.clear_resultcache) != 3) goto parse_error;
-        break;
-      case 6:
-        if(strncmp(buffer, "NULL", 4) != 0) {
-          map->query.filteritem = msStrdup(buffer);
-          msStringChop(map->query.filteritem);
-        }
-        break;
-      case 7:
-        if(strncmp(buffer, "NULL", 4) != 0)
-	  msLoadExpressionString(&map->query.filter, buffer); /* chop buffer */
-        break;
-      case 8:
-        if(sscanf(buffer, "%d\n", &shapetype) != 1) goto parse_error;
-
-        if(shapetype != MS_SHAPE_NULL) { /* load the rest of the shape */
-          int i, j;
-          lineObj line;
-
-          map->query.shape = (shapeObj *) msSmallMalloc(sizeof(shapeObj));
-          msInitShape(map->query.shape);
-          map->query.shape->type = shapetype;
-
-          if(fscanf(stream, "%d\n", &numlines) != 1) goto parse_error;
-          if( numlines > INT_MAX - 1 ) goto parse_error;
-          for(i=0; i<numlines; i++) {
-            if(fscanf(stream, "%d\n", &numpoints) != 1 || numpoints<0 ||
-                numpoints > INT_MAX / (int)sizeof(pointObj)) goto parse_error;
-
-            line.numpoints = numpoints;
-            line.point = (pointObj *) msSmallMalloc(line.numpoints*sizeof(pointObj));
-
-            for(j=0; j<numpoints; j++)
-              if(fscanf(stream, "%lf %lf\n", &line.point[j].x, &line.point[j].y) != 2) goto parse_error;
+  while (fgets(buffer, MS_BUFFER_LENGTH, stream) != NULL) {
+    switch (lineno) {
+    case 2:
+      if (sscanf(buffer, "%d %d %d %d\n", &(map->query.mode),
+                 &(map->query.type), &(map->query.layer),
+                 &(map->query.slayer)) != 4)
+        goto parse_error;
+      break;
+    case 3:
+      if (sscanf(buffer, "%lf %lf %lf %d\n", &map->query.point.x,
+                 &map->query.point.y, &map->query.buffer,
+                 &map->query.maxresults) != 4)
+        goto parse_error;
+      break;
+    case 4:
+      if (sscanf(buffer, "%lf %lf %lf %lf\n", &map->query.rect.minx,
+                 &map->query.rect.miny, &map->query.rect.maxx,
+                 &map->query.rect.maxy) != 4)
+        goto parse_error;
+      break;
+    case 5:
+      if (sscanf(buffer, "%ld %ld %d\n", &map->query.shapeindex,
+                 &map->query.tileindex, &map->query.clear_resultcache) != 3)
+        goto parse_error;
+      break;
+    case 6:
+      if (strncmp(buffer, "NULL", 4) != 0) {
+        map->query.filteritem = msStrdup(buffer);
+        msStringChop(map->query.filteritem);
+      }
+      break;
+    case 7:
+      if (strncmp(buffer, "NULL", 4) != 0)
+        msLoadExpressionString(&map->query.filter, buffer); /* chop buffer */
+      break;
+    case 8:
+      if (sscanf(buffer, "%d\n", &shapetype) != 1)
+        goto parse_error;
+
+      if (shapetype != MS_SHAPE_NULL) { /* load the rest of the shape */
+        int i, j;
+        lineObj line;
+
+        map->query.shape = (shapeObj *)msSmallMalloc(sizeof(shapeObj));
+        msInitShape(map->query.shape);
+        map->query.shape->type = shapetype;
+
+        if (fscanf(stream, "%d\n", &numlines) != 1)
+          goto parse_error;
+        if (numlines > INT_MAX - 1)
+          goto parse_error;
+        for (i = 0; i < numlines; i++) {
+          if (fscanf(stream, "%d\n", &numpoints) != 1 || numpoints < 0 ||
+              numpoints > INT_MAX / (int)sizeof(pointObj))
+            goto parse_error;
+
+          line.numpoints = numpoints;
+          line.point =
+              (pointObj *)msSmallMalloc(line.numpoints * sizeof(pointObj));
+
+          for (j = 0; j < numpoints; j++)
+            if (fscanf(stream, "%lf %lf\n", &line.point[j].x,
+                       &line.point[j].y) != 2)
+              goto parse_error;
 
-            msAddLine(map->query.shape, &line);
-            free(line.point);
-          }
+          msAddLine(map->query.shape, &line);
+          free(line.point);
         }
-        break;
-      default:
-        break;
+      }
+      break;
+    default:
+      break;
     }
 
     lineno++;
@@ -476,49 +532,55 @@ static int loadQueryParams(mapObj *map,
   /* TODO: should we throw an error if lineno != 10? */
 
   /* force layer and slayer on */
-  if(map->query.layer >= 0 && map->query.layer < map->numlayers) GET_LAYER(map, map->query.layer)->status = MS_ON;
-  if(map->query.slayer >= 0 && map->query.slayer < map->numlayers) GET_LAYER(map, map->query.slayer)->status = MS_ON;
+  if (map->query.layer >= 0 && map->query.layer < map->numlayers)
+    GET_LAYER(map, map->query.layer)->status = MS_ON;
+  if (map->query.slayer >= 0 && map->query.slayer < map->numlayers)
+    GET_LAYER(map, map->query.slayer)->status = MS_ON;
 
   /* now execute the query */
   return msExecuteQuery(map);
 
 parse_error:
-  msSetError(MS_MISCERR, "Parse error line %d.", "loadQueryParameters()", lineno);
+  msSetError(MS_MISCERR, "Parse error line %d.", "loadQueryParameters()",
+             lineno);
   return MS_FAILURE;
 }
 
 /*
-** Save (serialize) a query to disk. There are two methods, one saves the query parameters and the other saves
-** all the shape indexes. Note the latter can be very slow against certain data sources but has a certain usefulness
+** Save (serialize) a query to disk. There are two methods, one saves the query
+*parameters and the other saves
+** all the shape indexes. Note the latter can be very slow against certain data
+*sources but has a certain usefulness
 ** on occation.
 */
-int msSaveQuery(mapObj *map, char *filename, int results)
-{
-  if(results)
+int msSaveQuery(mapObj *map, char *filename, int results) {
+  if (results)
     return saveQueryResults(map, filename);
   else
     return saveQueryParams(map, filename);
 }
 
 /*
-** Loads a query file contained either serialized 1) query parameters or 2) query results (e.g. indexes).
+** Loads a query file contained either serialized 1) query parameters or 2)
+*query results (e.g. indexes).
 */
-int msLoadQuery(mapObj *map, char *filename)
-{
+int msLoadQuery(mapObj *map, char *filename) {
   FILE *stream;
   char buffer[MS_BUFFER_LENGTH];
-  int retval=MS_FAILURE;
+  int retval = MS_FAILURE;
 
-  if(!filename) {
-    msSetError(MS_MISCERR, "No filename provided to load query from.", "msLoadQuery()");
+  if (!filename) {
+    msSetError(MS_MISCERR, "No filename provided to load query from.",
+               "msLoadQuery()");
     return MS_FAILURE;
   }
 
   /*
   ** Make sure the file at least has the right extension.
   */
-  if(msEvalRegex("\\.qy$", filename) != MS_TRUE) {
-    msSetError(MS_MISCERR, "Queryfile %s has incorrect file extension.",  "msLoadQuery()", filename);
+  if (msEvalRegex("\\.qy$", filename) != MS_TRUE) {
+    msSetError(MS_MISCERR, "Queryfile %s has incorrect file extension.",
+               "msLoadQuery()", filename);
     return MS_FAILURE;
   }
 
@@ -526,25 +588,31 @@ int msLoadQuery(mapObj *map, char *filen
   ** Open the file and inspect the first line.
   */
   stream = fopen(filename, "r");
-  if(!stream) {
+  if (!stream) {
     msSetError(MS_IOERR, "(%s)", "msLoadQuery()", filename);
     return MS_FAILURE;
   }
 
-  if(fgets(buffer, MS_BUFFER_LENGTH, stream) != NULL) {
+  if (fgets(buffer, MS_BUFFER_LENGTH, stream) != NULL) {
     /*
     ** Call correct reader based on the magic string.
     */
-    if(strncasecmp(buffer, MS_QUERY_RESULTS_MAGIC_STRING, strlen(MS_QUERY_RESULTS_MAGIC_STRING)) == 0) {
+    if (strncasecmp(buffer, MS_QUERY_RESULTS_MAGIC_STRING,
+                    strlen(MS_QUERY_RESULTS_MAGIC_STRING)) == 0) {
       retval = loadQueryResults(map, stream);
-    } else if(strncasecmp(buffer, MS_QUERY_PARAMS_MAGIC_STRING, strlen(MS_QUERY_PARAMS_MAGIC_STRING)) == 0) {
+    } else if (strncasecmp(buffer, MS_QUERY_PARAMS_MAGIC_STRING,
+                           strlen(MS_QUERY_PARAMS_MAGIC_STRING)) == 0) {
       retval = loadQueryParams(map, stream);
     } else {
-      msSetError(MS_WEBERR, "Missing magic string, %s doesn't look like a MapServer query file.", "msLoadQuery()", filename);
+      msSetError(
+          MS_WEBERR,
+          "Missing magic string, %s doesn't look like a MapServer query file.",
+          "msLoadQuery()", filename);
       retval = MS_FAILURE;
     }
   } else {
-    msSetError(MS_WEBERR, "Empty file or failed read for %s.", "msLoadQuery()", filename);
+    msSetError(MS_WEBERR, "Empty file or failed read for %s.", "msLoadQuery()",
+               filename);
     retval = MS_FAILURE;
   }
 
@@ -552,8 +620,7 @@ int msLoadQuery(mapObj *map, char *filen
   return retval;
 }
 
-int msQueryByIndex(mapObj *map)
-{
+int msQueryByIndex(mapObj *map) {
   layerObj *lp;
   int status;
 
@@ -565,25 +632,27 @@ int msQueryByIndex(mapObj *map)
 
   initQueryCache(&queryCache);
 
-  if(map->query.type != MS_QUERY_BY_INDEX) {
-    msSetError(MS_QUERYERR, "The query is not properly defined.", "msQueryByIndex()");
-    return(MS_FAILURE);
+  if (map->query.type != MS_QUERY_BY_INDEX) {
+    msSetError(MS_QUERYERR, "The query is not properly defined.",
+               "msQueryByIndex()");
+    return (MS_FAILURE);
   }
 
-  if(map->query.layer < 0 || map->query.layer >= map->numlayers) {
+  if (map->query.layer < 0 || map->query.layer >= map->numlayers) {
     msSetError(MS_QUERYERR, "No query layer defined.", "msQueryByIndex()");
-    return(MS_FAILURE);
+    return (MS_FAILURE);
   }
 
   lp = (GET_LAYER(map, map->query.layer));
 
-  if(!msIsLayerQueryable(lp)) {
-    msSetError(MS_QUERYERR, "Requested layer has no templates defined.", "msQueryByIndex()");
-    return(MS_FAILURE);
+  if (!msIsLayerQueryable(lp)) {
+    msSetError(MS_QUERYERR, "Requested layer has no templates defined.",
+               "msQueryByIndex()");
+    return (MS_FAILURE);
   }
 
-  if(map->query.clear_resultcache) {
-    if(lp->resultcache) {
+  if (map->query.clear_resultcache) {
+    if (lp->resultcache) {
       cleanupResultCache(lp->resultcache);
       free(lp->resultcache);
       lp->resultcache = NULL;
@@ -592,18 +661,21 @@ int msQueryByIndex(mapObj *map)
 
   msLayerClose(lp); /* reset */
   status = msLayerOpen(lp);
-  if(status != MS_SUCCESS) return(MS_FAILURE);
+  if (status != MS_SUCCESS)
+    return (MS_FAILURE);
   /* disable driver paging */
   msLayerEnablePaging(lp, MS_FALSE);
 
   /* build item list, we want *all* items */
   status = msLayerWhichItems(lp, MS_TRUE, NULL);
-  if(status != MS_SUCCESS) return(MS_FAILURE);
+  if (status != MS_SUCCESS)
+    return (MS_FAILURE);
 
-  if(map->query.clear_resultcache || lp->resultcache == NULL) {
-    lp->resultcache = (resultCacheObj *)malloc(sizeof(resultCacheObj)); /* allocate and initialize the result cache */
+  if (map->query.clear_resultcache || lp->resultcache == NULL) {
+    lp->resultcache = (resultCacheObj *)malloc(
+        sizeof(resultCacheObj)); /* allocate and initialize the result cache */
     MS_CHECK_ALLOC(lp->resultcache, sizeof(resultCacheObj), MS_FAILURE);
-    initResultCache( lp->resultcache);
+    initResultCache(lp->resultcache);
   }
 
   msInitShape(&shape);
@@ -613,9 +685,9 @@ int msQueryByIndex(mapObj *map)
   record.tileindex = map->query.tileindex;
 
   status = msLayerGetShape(lp, &shape, &record);
-  if(status != MS_SUCCESS) {
+  if (status != MS_SUCCESS) {
     msSetError(MS_NOTFOUND, "Not valid record request.", "msQueryByIndex()");
-    return(MS_FAILURE);
+    return (MS_FAILURE);
   }
 
   /*
@@ -625,7 +697,9 @@ int msQueryByIndex(mapObj *map)
    * thus useless as the index in the result cache. See #4926 #4076. Only shape
    * files and flatgeobuf are considered to have consistent row numbers.
    */
-  if ( !(lp->connectiontype == MS_SHAPEFILE || lp->connectiontype == MS_TILED_SHAPEFILE || lp->connectiontype == MS_FLATGEOBUF) ) {
+  if (!(lp->connectiontype == MS_SHAPEFILE ||
+        lp->connectiontype == MS_TILED_SHAPEFILE ||
+        lp->connectiontype == MS_FLATGEOBUF)) {
     shape.resultindex = -1;
   }
 
@@ -633,63 +707,75 @@ int msQueryByIndex(mapObj *map)
     minfeaturesize = Pix2LayerGeoref(map, lp, lp->minfeaturesize);
 
   /* Check if the shape size is ok to be drawn */
-  if ( (shape.type == MS_SHAPE_LINE || shape.type == MS_SHAPE_POLYGON) && (minfeaturesize > 0) ) {
+  if ((shape.type == MS_SHAPE_LINE || shape.type == MS_SHAPE_POLYGON) &&
+      (minfeaturesize > 0)) {
 
     if (msShapeCheckSize(&shape, minfeaturesize) == MS_FALSE) {
-      msSetError(MS_NOTFOUND, "Requested shape not valid against layer minfeaturesize.", "msQueryByIndex()");
+      msSetError(MS_NOTFOUND,
+                 "Requested shape not valid against layer minfeaturesize.",
+                 "msQueryByIndex()");
       msFreeShape(&shape);
       msLayerClose(lp);
-      return(MS_FAILURE);
+      return (MS_FAILURE);
     }
   }
 
   shape.classindex = msShapeGetClass(lp, map, &shape, NULL, 0);
-  if(!(lp->template) && ((shape.classindex == -1) || (lp->class[shape.classindex]->status == MS_OFF))) { /* not a valid shape */
-    msSetError(MS_NOTFOUND, "Requested shape not valid against layer classification scheme.", "msQueryByIndex()");
+  if (!(lp->template) &&
+      ((shape.classindex == -1) ||
+       (lp->class[shape.classindex] -> status ==
+                                           MS_OFF))) { /* not a valid shape */
+    msSetError(MS_NOTFOUND,
+               "Requested shape not valid against layer classification scheme.",
+               "msQueryByIndex()");
     msFreeShape(&shape);
     msLayerClose(lp);
-    return(MS_FAILURE);
+    return (MS_FAILURE);
   }
 
-  if(!(lp->template) && !(lp->class[shape.classindex]->template)) { /* no valid template */
-    msSetError(MS_NOTFOUND, "Requested shape does not have a valid template, no way to present results.", "msQueryByIndex()");
+  if (!(lp->template) &&
+      !(lp->class[shape.classindex] -> template)) { /* no valid template */
+    msSetError(MS_NOTFOUND,
+               "Requested shape does not have a valid template, no way to "
+               "present results.",
+               "msQueryByIndex()");
     msFreeShape(&shape);
     msLayerClose(lp);
-    return(MS_FAILURE);
+    return (MS_FAILURE);
   }
-  
+
   addResult(map, lp->resultcache, &queryCache, &shape);
 
   msFreeShape(&shape);
   /* msLayerClose(lp); */
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
 static char *filterTranslateToLogical(expressionObj *filter, char *filteritem) {
   char *string = NULL;
 
-  if(filter->type == MS_STRING && filteritem) {
+  if (filter->type == MS_STRING && filteritem) {
     string = msStrdup("'[");
     string = msStringConcatenate(string, filteritem);
     string = msStringConcatenate(string, "]'");
-    if(filter->flags & MS_EXP_INSENSITIVE)
+    if (filter->flags & MS_EXP_INSENSITIVE)
       string = msStringConcatenate(string, " =* '");
     else
       string = msStringConcatenate(string, " = '");
     string = msStringConcatenate(string, filter->string);
     string = msStringConcatenate(string, "'");
-  } else if(filter->type == MS_REGEX && filteritem) {
+  } else if (filter->type == MS_REGEX && filteritem) {
     string = msStrdup("'[");
     string = msStringConcatenate(string, filteritem);
     string = msStringConcatenate(string, "]'");
-    if(filter->flags & MS_EXP_INSENSITIVE)
+    if (filter->flags & MS_EXP_INSENSITIVE)
       string = msStringConcatenate(string, " ~* '");
     else
       string = msStringConcatenate(string, " ~ '");
     string = msStringConcatenate(string, filter->string);
     string = msStringConcatenate(string, "'");
-  } else if(filter->type == MS_EXPRESSION) {
+  } else if (filter->type == MS_EXPRESSION) {
     string = msStrdup(filter->string);
   } else {
     /* native expression, nothing we can do - sigh */
@@ -698,20 +784,22 @@ static char *filterTranslateToLogical(ex
   return string;
 }
 
-static expressionObj mergeFilters(expressionObj *filter1, char *filteritem1, expressionObj *filter2, char *filteritem2) {
+static expressionObj mergeFilters(expressionObj *filter1, char *filteritem1,
+                                  expressionObj *filter2, char *filteritem2) {
   expressionObj filter;
 
-  char *tmpstr1=NULL;
-  char *tmpstr2=NULL;
+  char *tmpstr1 = NULL;
+  char *tmpstr2 = NULL;
 
   msInitExpression(&filter);
   filter.type = MS_EXPRESSION; /* we're building a logical expression */
 
   tmpstr1 = filterTranslateToLogical(filter1, filteritem1);
-  if(!tmpstr1) return filter; /* should only happen if the filter was a native filter */  
+  if (!tmpstr1)
+    return filter; /* should only happen if the filter was a native filter */
 
   tmpstr2 = filterTranslateToLogical(filter2, filteritem2);
-  if(!tmpstr2) {
+  if (!tmpstr2) {
     msFree(tmpstr1);
     return filter; /* should only happen if the filter was a native filter */
   }
@@ -729,16 +817,15 @@ static expressionObj mergeFilters(expres
 /*
 ** Query using common expression syntax.
 */
-int msQueryByFilter(mapObj *map)
-{
+int msQueryByFilter(mapObj *map) {
   int l;
-  int start, stop=0;
+  int start, stop = 0;
 
   layerObj *lp;
 
   char status;
 
-  char *old_filteritem=NULL;
+  char *old_filteritem = NULL;
   expressionObj old_filter;
 
   rectObj search_rect;
@@ -754,26 +841,28 @@ int msQueryByFilter(mapObj *map)
 
   initQueryCache(&queryCache);
 
-  if(map->query.type != MS_QUERY_BY_FILTER) {
-    msSetError(MS_QUERYERR, "The query is not properly defined.", "msQueryByFilter()");
-    return(MS_FAILURE);
+  if (map->query.type != MS_QUERY_BY_FILTER) {
+    msSetError(MS_QUERYERR, "The query is not properly defined.",
+               "msQueryByFilter()");
+    return (MS_FAILURE);
   }
-  if(!map->query.filter.string) {
+  if (!map->query.filter.string) {
     msSetError(MS_QUERYERR, "Filter is not set.", "msQueryByFilter()");
-    return(MS_FAILURE);
+    return (MS_FAILURE);
   }
 
-  // fprintf(stderr, "in msQueryByFilter: filter=%s, filteritem=%s\n", map->query.filter.string, map->query.filteritem);
+  // fprintf(stderr, "in msQueryByFilter: filter=%s, filteritem=%s\n",
+  // map->query.filter.string, map->query.filteritem);
 
   msInitShape(&shape);
 
-  if(map->query.layer < 0 || map->query.layer >= map->numlayers)
-    start = map->numlayers-1;
+  if (map->query.layer < 0 || map->query.layer >= map->numlayers)
+    start = map->numlayers - 1;
   else
     start = stop = map->query.layer;
 
-  for(l=start; l>=stop; l--) {
-    reprojectionObj* reprojector = NULL;
+  for (l = start; l >= stop; l--) {
+    reprojectionObj *reprojector = NULL;
 
     lp = (GET_LAYER(map, l));
     if (map->query.maxfeatures == 0)
@@ -784,114 +873,132 @@ int msQueryByFilter(mapObj *map)
     /* using mapscript, the map->query.startindex will be unset... */
     if (lp->startindex > 1 && map->query.startindex < 0)
       map->query.startindex = lp->startindex;
-    
+
     /* conditions may have changed since this layer last drawn, so set
        layer->project true to recheck projection needs (Bug #673) */
     lp->project = MS_TRUE;
 
-    /* free any previous search results, do it now in case one of the next few tests fail */
-    if(lp->resultcache) {
-      if(lp->resultcache->results) free(lp->resultcache->results);
+    /* free any previous search results, do it now in case one of the next few
+     * tests fail */
+    if (lp->resultcache) {
+      if (lp->resultcache->results)
+        free(lp->resultcache->results);
       free(lp->resultcache);
       lp->resultcache = NULL;
     }
 
-    if(!msIsLayerQueryable(lp)) continue;
-    if(lp->status == MS_OFF) continue;
-    if(lp->type == MS_LAYER_RASTER) continue; /* ok to skip? */
-
-    if(map->scaledenom > 0) {
-      if((lp->maxscaledenom > 0) && (map->scaledenom > lp->maxscaledenom)) continue;
-      if((lp->minscaledenom > 0) && (map->scaledenom <= lp->minscaledenom)) continue;
+    if (!msIsLayerQueryable(lp))
+      continue;
+    if (lp->status == MS_OFF)
+      continue;
+    if (lp->type == MS_LAYER_RASTER)
+      continue; /* ok to skip? */
+
+    if (map->scaledenom > 0) {
+      if ((lp->maxscaledenom > 0) && (map->scaledenom > lp->maxscaledenom))
+        continue;
+      if ((lp->minscaledenom > 0) && (map->scaledenom <= lp->minscaledenom))
+        continue;
     }
 
     if (lp->maxscaledenom <= 0 && lp->minscaledenom <= 0) {
-      if((lp->maxgeowidth > 0) && ((map->extent.maxx - map->extent.minx) > lp->maxgeowidth)) continue;
-      if((lp->mingeowidth > 0) && ((map->extent.maxx - map->extent.minx) < lp->mingeowidth)) continue;
+      if ((lp->maxgeowidth > 0) &&
+          ((map->extent.maxx - map->extent.minx) > lp->maxgeowidth))
+        continue;
+      if ((lp->mingeowidth > 0) &&
+          ((map->extent.maxx - map->extent.minx) < lp->mingeowidth))
+        continue;
     }
 
     paging = msLayerGetPaging(lp);
     msLayerClose(lp); /* reset */
     status = msLayerOpen(lp);
-    if(status != MS_SUCCESS) return MS_FAILURE;
+    if (status != MS_SUCCESS)
+      return MS_FAILURE;
     msLayerEnablePaging(lp, paging);
 
     /* disable driver paging */
     // msLayerEnablePaging(lp, MS_FALSE);
-        
+
     old_filteritem = lp->filteritem; /* cache the existing filter/filteritem */
     msInitExpression(&old_filter);
     msCopyExpression(&old_filter, &lp->filter);
-        
+
     /*
-    ** Set the lp->filter and lp->filteritem (may need to merge). Remember filters are *always* MapServer syntax.
+    ** Set the lp->filter and lp->filteritem (may need to merge). Remember
+    *filters are *always* MapServer syntax.
     */
     lp->filteritem = map->query.filteritem; /* re-point lp->filteritem */
-    if(old_filter.string != NULL) { /* need to merge filters to create one logical expression */
+    if (old_filter.string !=
+        NULL) { /* need to merge filters to create one logical expression */
       msFreeExpression(&lp->filter);
-      lp->filter = mergeFilters(&map->query.filter, map->query.filteritem, &old_filter, old_filteritem);      
-      if(!lp->filter.string) {
-	msSetError(MS_MISCERR, "Filter merge failed, able to process query.", "msQueryByFilter()");
+      lp->filter = mergeFilters(&map->query.filter, map->query.filteritem,
+                                &old_filter, old_filteritem);
+      if (!lp->filter.string) {
+        msSetError(MS_MISCERR, "Filter merge failed, able to process query.",
+                   "msQueryByFilter()");
         goto restore_old_filter;
-      }      
+      }
     } else {
       msCopyExpression(&lp->filter, &map->query.filter); /* apply new filter */
     }
 
-    /* build item list, we want *all* items, note this *also* build tokens for the layer filter */
+    /* build item list, we want *all* items, note this *also* build tokens for
+     * the layer filter */
     status = msLayerWhichItems(lp, MS_TRUE, NULL);
-    if(status != MS_SUCCESS) goto restore_old_filter;
+    if (status != MS_SUCCESS)
+      goto restore_old_filter;
 
     search_rect = map->query.rect;
 
     /* If only result count is needed, we can use msLayerGetShapeCount() */
     /* that has optimizations to avoid retrieving individual features */
-    if( map->query.only_cache_result_count &&
+    if (map->query.only_cache_result_count &&
         lp->template != NULL && /* always TRUE for WFS case */
-        lp->minfeaturesize <= 0 )
-    {
+        lp->minfeaturesize <= 0) {
       int bUseLayerSRS = MS_FALSE;
       int numFeatures = -1;
 
-#if defined(USE_WMS_SVR) || defined (USE_WFS_SVR) || defined (USE_WCS_SVR) || defined(USE_SOS_SVR) || defined(USE_WMS_LYR) || defined(USE_WFS_LYR)
+#if defined(USE_WMS_SVR) || defined(USE_WFS_SVR) || defined(USE_WCS_SVR) ||    \
+    defined(USE_SOS_SVR) || defined(USE_WMS_LYR) || defined(USE_WFS_LYR)
       /* Optimization to detect the case where a WFS query uses in fact the */
-      /* whole layer extent, but expressed in a map SRS different from the layer SRS */
-      /* In the case, we can directly request against the layer extent in its native SRS */
-      if( lp->project &&
-          memcmp( &search_rect, &invalid_rect, sizeof(search_rect) ) != 0 &&
-          msProjectionsDiffer(&(lp->projection), &(map->projection)) )
-      {
+      /* whole layer extent, but expressed in a map SRS different from the layer
+       * SRS */
+      /* In the case, we can directly request against the layer extent in its
+       * native SRS */
+      if (lp->project &&
+          memcmp(&search_rect, &invalid_rect, sizeof(search_rect)) != 0 &&
+          msProjectionsDiffer(&(lp->projection), &(map->projection))) {
         rectObj layerExtent;
-        if ( msOWSGetLayerExtent(map, lp, "FO", &layerExtent) == MS_SUCCESS)
-        {
-            rectObj ext = layerExtent;
-            ext.minx -= 1e-5;
-            ext.miny -= 1e-5;
-            ext.maxx += 1e-5;
-            ext.maxy += 1e-5;
-            msProjectRect(&(lp->projection), &(map->projection), &ext);
-            if( fabs(ext.minx - search_rect.minx) <= 2e-5 &&
-                fabs(ext.miny - search_rect.miny) <= 2e-5 &&
-                fabs(ext.maxx - search_rect.maxx) <= 2e-5 &&
-                fabs(ext.maxy - search_rect.maxy) <= 2e-5 )
-            {
-              bUseLayerSRS = MS_TRUE;
-              numFeatures = msLayerGetShapeCount(lp, layerExtent, &(lp->projection));
-            }
+        if (msOWSGetLayerExtent(map, lp, "FO", &layerExtent) == MS_SUCCESS) {
+          rectObj ext = layerExtent;
+          ext.minx -= 1e-5;
+          ext.miny -= 1e-5;
+          ext.maxx += 1e-5;
+          ext.maxy += 1e-5;
+          msProjectRect(&(lp->projection), &(map->projection), &ext);
+          if (fabs(ext.minx - search_rect.minx) <= 2e-5 &&
+              fabs(ext.miny - search_rect.miny) <= 2e-5 &&
+              fabs(ext.maxx - search_rect.maxx) <= 2e-5 &&
+              fabs(ext.maxy - search_rect.maxy) <= 2e-5) {
+            bUseLayerSRS = MS_TRUE;
+            numFeatures =
+                msLayerGetShapeCount(lp, layerExtent, &(lp->projection));
+          }
         }
       }
 #endif
 
-      if( !bUseLayerSRS )
-          numFeatures = msLayerGetShapeCount(lp, search_rect, &(map->projection));
-      if( numFeatures >= 0 )
-      {
-        lp->resultcache = (resultCacheObj *)malloc(sizeof(resultCacheObj)); /* allocate and initialize the result cache */
+      if (!bUseLayerSRS)
+        numFeatures = msLayerGetShapeCount(lp, search_rect, &(map->projection));
+      if (numFeatures >= 0) {
+        lp->resultcache = (resultCacheObj *)malloc(sizeof(
+            resultCacheObj)); /* allocate and initialize the result cache */
         MS_CHECK_ALLOC(lp->resultcache, sizeof(resultCacheObj), MS_FAILURE);
-        initResultCache( lp->resultcache);
+        initResultCache(lp->resultcache);
         lp->resultcache->numresults = numFeatures;
         if (!msLayerGetPaging(lp) && map->query.startindex > 1) {
-           lp->resultcache->numresults -= (map->query.startindex-1);
+          lp->resultcache->numresults -= (map->query.startindex - 1);
         }
 
         lp->filteritem = old_filteritem; /* point back to original value */
@@ -904,20 +1011,24 @@ int msQueryByFilter(mapObj *map)
     }
 
     lp->project = msProjectionsDiffer(&(lp->projection), &(map->projection));
-    if(lp->project && memcmp( &search_rect, &invalid_rect, sizeof(search_rect) ) != 0 )
-      msProjectRect(&(map->projection), &(lp->projection), &search_rect); /* project the searchrect to source coords */
+    if (lp->project &&
+        memcmp(&search_rect, &invalid_rect, sizeof(search_rect)) != 0)
+      msProjectRect(&(map->projection), &(lp->projection),
+                    &search_rect); /* project the searchrect to source coords */
 
     status = msLayerWhichShapes(lp, search_rect, MS_TRUE);
-    if(status == MS_DONE) { /* no overlap */
+    if (status == MS_DONE) {           /* no overlap */
       lp->filteritem = old_filteritem; /* point back to original value */
       msCopyExpression(&lp->filter, &old_filter); /* restore old filter */
       msFreeExpression(&old_filter);
       msLayerClose(lp);
       continue;
-    } else if(status != MS_SUCCESS) goto restore_old_filter;
+    } else if (status != MS_SUCCESS)
+      goto restore_old_filter;
 
-    lp->resultcache = (resultCacheObj *)malloc(sizeof(resultCacheObj)); /* allocate and initialize the result cache */
-    initResultCache( lp->resultcache);
+    lp->resultcache = (resultCacheObj *)malloc(
+        sizeof(resultCacheObj)); /* allocate and initialize the result cache */
+    initResultCache(lp->resultcache);
 
     nclasses = 0;
     classgroup = NULL;
@@ -927,37 +1038,46 @@ int msQueryByFilter(mapObj *map)
     if (lp->minfeaturesize > 0)
       minfeaturesize = Pix2LayerGeoref(map, lp, lp->minfeaturesize);
 
-    while((status = msLayerNextShape(lp, &shape)) == MS_SUCCESS) { /* step through the shapes - if necessary the filter is applied in msLayerNextShape(...) */
+    while ((status = msLayerNextShape(lp, &shape)) ==
+           MS_SUCCESS) { /* step through the shapes - if necessary the filter is
+                            applied in msLayerNextShape(...) */
 
-       /* Check if the shape size is ok to be drawn */
-      if ( (shape.type == MS_SHAPE_LINE || shape.type == MS_SHAPE_POLYGON) && (minfeaturesize > 0) ) {
+      /* Check if the shape size is ok to be drawn */
+      if ((shape.type == MS_SHAPE_LINE || shape.type == MS_SHAPE_POLYGON) &&
+          (minfeaturesize > 0)) {
         if (msShapeCheckSize(&shape, minfeaturesize) == MS_FALSE) {
-          if( lp->debug >= MS_DEBUGLEVEL_V )
-            msDebug("msQueryByFilter(): Skipping shape (%ld) because LAYER::MINFEATURESIZE is bigger than shape size\n", shape.index);
+          if (lp->debug >= MS_DEBUGLEVEL_V)
+            msDebug("msQueryByFilter(): Skipping shape (%ld) because "
+                    "LAYER::MINFEATURESIZE is bigger than shape size\n",
+                    shape.index);
           msFreeShape(&shape);
           continue;
         }
       }
 
       shape.classindex = msShapeGetClass(lp, map, &shape, classgroup, nclasses);
-      if(!(lp->template) && ((shape.classindex == -1) || (lp->class[shape.classindex]->status == MS_OFF))) { /* not a valid shape */
+      if (!(lp->template) && ((shape.classindex == -1) ||
+                              (lp->class[shape.classindex]
+                               -> status == MS_OFF))) { /* not a valid shape */
         msFreeShape(&shape);
         continue;
       }
 
-      if(!(lp->template) && !(lp->class[shape.classindex]->template)) { /* no valid template */
+      if (!(lp->template) &&
+          !(lp->class[shape.classindex] -> template)) { /* no valid template */
         msFreeShape(&shape);
         continue;
       }
 
-      if(lp->project) {
-        if( reprojector == NULL ) {
-            reprojector = msProjectCreateReprojector(&(lp->projection), &(map->projection));
-            if( reprojector == NULL ) {
-              msFreeShape(&shape);
-              status = MS_FAILURE;
-              break;
-            }
+      if (lp->project) {
+        if (reprojector == NULL) {
+          reprojector =
+              msProjectCreateReprojector(&(lp->projection), &(map->projection));
+          if (reprojector == NULL) {
+            msFreeShape(&shape);
+            status = MS_FAILURE;
+            break;
+          }
         }
         msProjectShapeEx(reprojector, &shape);
       }
@@ -968,26 +1088,29 @@ int msQueryByFilter(mapObj *map)
         msFreeShape(&shape);
         continue;
       }
-    
-      if( map->query.only_cache_result_count )
-        lp->resultcache->numresults ++;
+
+      if (map->query.only_cache_result_count)
+        lp->resultcache->numresults++;
       else
         addResult(map, lp->resultcache, &queryCache, &shape);
       msFreeShape(&shape);
 
-      if(map->query.mode == MS_QUERY_SINGLE) { /* no need to look any further */
-	status = MS_DONE;
-	break;
+      if (map->query.mode ==
+          MS_QUERY_SINGLE) { /* no need to look any further */
+        status = MS_DONE;
+        break;
       }
 
       /* check shape count */
-      if(lp->maxfeatures > 0 && lp->maxfeatures == lp->resultcache->numresults) {
+      if (lp->maxfeatures > 0 &&
+          lp->maxfeatures == lp->resultcache->numresults) {
         status = MS_DONE;
         break;
       }
     } /* next shape */
 
-    if(classgroup) msFree(classgroup);
+    if (classgroup)
+      msFree(classgroup);
 
     lp->filteritem = old_filteritem; /* point back to original value */
     msCopyExpression(&lp->filter, &old_filter); /* restore old filter */
@@ -995,21 +1118,23 @@ int msQueryByFilter(mapObj *map)
 
     msProjectDestroyReprojector(reprojector);
 
-    if(status != MS_DONE) return MS_FAILURE;
-    if(!map->query.only_cache_result_count && lp->resultcache->numresults == 0) 
+    if (status != MS_DONE)
+      return MS_FAILURE;
+    if (!map->query.only_cache_result_count && lp->resultcache->numresults == 0)
       msLayerClose(lp); /* no need to keep the layer open */
-  } /* next layer */
+  }                     /* next layer */
 
   /* was anything found? */
-  for(l=start; l>=stop; l--) {
-    if(GET_LAYER(map, l)->resultcache && GET_LAYER(map, l)->resultcache->numresults > 0)
+  for (l = start; l >= stop; l--) {
+    if (GET_LAYER(map, l)->resultcache &&
+        GET_LAYER(map, l)->resultcache->numresults > 0)
       return MS_SUCCESS;
   }
 
   if (map->debug >= MS_DEBUGLEVEL_V) {
-      msDebug("msQueryByFilter(): No matching record(s) found.");
+    msDebug("msQueryByFilter(): No matching record(s) found.");
   }
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 
 restore_old_filter:
   lp->filteritem = old_filteritem;
@@ -1019,10 +1144,9 @@ restore_old_filter:
   return MS_FAILURE;
 }
 
-int msQueryByRect(mapObj *map)
-{
+int msQueryByRect(mapObj *map) {
   int l; /* counters */
-  int start, stop=0;
+  int start, stop = 0;
 
   layerObj *lp;
 
@@ -1040,21 +1164,22 @@ int msQueryByRect(mapObj *map)
 
   initQueryCache(&queryCache);
 
-  if(map->query.type != MS_QUERY_BY_RECT) {
-    msSetError(MS_QUERYERR, "The query is not properly defined.", "msQueryByRect()");
-    return(MS_FAILURE);
+  if (map->query.type != MS_QUERY_BY_RECT) {
+    msSetError(MS_QUERYERR, "The query is not properly defined.",
+               "msQueryByRect()");
+    return (MS_FAILURE);
   }
 
   msInitShape(&shape);
   msInitShape(&searchshape);
 
-  if(map->query.layer < 0 || map->query.layer >= map->numlayers)
-    start = map->numlayers-1;
+  if (map->query.layer < 0 || map->query.layer >= map->numlayers)
+    start = map->numlayers - 1;
   else
     start = stop = map->query.layer;
 
-  for(l=start; l>=stop; l--) {
-    reprojectionObj* reprojector = NULL;
+  for (l = start; l >= stop; l--) {
+    reprojectionObj *reprojector = NULL;
     lp = (GET_LAYER(map, l));
     /* Set the global maxfeatures */
     if (map->query.maxfeatures == 0)
@@ -1065,39 +1190,51 @@ int msQueryByRect(mapObj *map)
     /* using mapscript, the map->query.startindex will be unset... */
     if (lp->startindex > 1 && map->query.startindex < 0)
       map->query.startindex = lp->startindex;
-    
+
     /* conditions may have changed since this layer last drawn, so set
        layer->project true to recheck projection needs (Bug #673) */
     lp->project = MS_TRUE;
 
-    /* free any previous search results, do it now in case one of the next few tests fail */
-    if(lp->resultcache) {
-      if(lp->resultcache->results) free(lp->resultcache->results);
+    /* free any previous search results, do it now in case one of the next few
+     * tests fail */
+    if (lp->resultcache) {
+      if (lp->resultcache->results)
+        free(lp->resultcache->results);
       free(lp->resultcache);
       lp->resultcache = NULL;
     }
 
-    if(!msIsLayerQueryable(lp)) continue;
-    if(lp->status == MS_OFF) continue;
+    if (!msIsLayerQueryable(lp))
+      continue;
+    if (lp->status == MS_OFF)
+      continue;
 
-    if(map->scaledenom > 0) {
-      if((lp->maxscaledenom > 0) && (map->scaledenom > lp->maxscaledenom)) continue;
-      if((lp->minscaledenom > 0) && (map->scaledenom <= lp->minscaledenom)) continue;
+    if (map->scaledenom > 0) {
+      if ((lp->maxscaledenom > 0) && (map->scaledenom > lp->maxscaledenom))
+        continue;
+      if ((lp->minscaledenom > 0) && (map->scaledenom <= lp->minscaledenom))
+        continue;
     }
 
     if (lp->maxscaledenom <= 0 && lp->minscaledenom <= 0) {
-      if((lp->maxgeowidth > 0) && ((map->extent.maxx - map->extent.minx) > lp->maxgeowidth)) continue;
-      if((lp->mingeowidth > 0) && ((map->extent.maxx - map->extent.minx) < lp->mingeowidth)) continue;
+      if ((lp->maxgeowidth > 0) &&
+          ((map->extent.maxx - map->extent.minx) > lp->maxgeowidth))
+        continue;
+      if ((lp->mingeowidth > 0) &&
+          ((map->extent.maxx - map->extent.minx) < lp->mingeowidth))
+        continue;
     }
 
     searchrect = map->query.rect;
-    if(lp->tolerance > 0) {
+    if (lp->tolerance > 0) {
       layer_tolerance = lp->tolerance;
 
-      if(lp->toleranceunits == MS_PIXELS)
-        tolerance = layer_tolerance * msAdjustExtent(&(map->extent), map->width, map->height);
+      if (lp->toleranceunits == MS_PIXELS)
+        tolerance = layer_tolerance *
+                    msAdjustExtent(&(map->extent), map->width, map->height);
       else
-        tolerance = layer_tolerance * (msInchesPerUnit(lp->toleranceunits,0)/msInchesPerUnit(map->units,0));
+        tolerance = layer_tolerance * (msInchesPerUnit(lp->toleranceunits, 0) /
+                                       msInchesPerUnit(map->units, 0));
 
       searchrect.minx -= tolerance;
       searchrect.maxx += tolerance;
@@ -1109,8 +1246,8 @@ int msQueryByRect(mapObj *map)
     msRectToPolygon(searchrect, &searchshape);
 
     /* Raster layers are handled specially. */
-    if( lp->type == MS_LAYER_RASTER ) {
-      if( msRasterQueryByRect( map, lp, searchrect ) == MS_FAILURE)
+    if (lp->type == MS_LAYER_RASTER) {
+      if (msRasterQueryByRect(map, lp, searchrect) == MS_FAILURE)
         return MS_FAILURE;
 
       continue;
@@ -1120,68 +1257,68 @@ int msQueryByRect(mapObj *map)
     paging = msLayerGetPaging(lp);
     msLayerClose(lp); /* reset */
     status = msLayerOpen(lp);
-    if(status != MS_SUCCESS) {
+    if (status != MS_SUCCESS) {
       msFreeShape(&searchshape);
-      return(MS_FAILURE);
+      return (MS_FAILURE);
     }
     msLayerEnablePaging(lp, paging);
 
     /* build item list, we want *all* items */
     status = msLayerWhichItems(lp, MS_TRUE, NULL);
 
-    if(status != MS_SUCCESS) {
+    if (status != MS_SUCCESS) {
       msFreeShape(&searchshape);
-      return(MS_FAILURE);
+      return (MS_FAILURE);
     }
 
     /* If only result count is needed, we can use msLayerGetShapeCount() */
     /* that has optimizations to avoid retrieving individual features */
-    if( map->query.only_cache_result_count &&
+    if (map->query.only_cache_result_count &&
         lp->template != NULL && /* always TRUE for WFS case */
-        lp->minfeaturesize <= 0 )
-    {
+        lp->minfeaturesize <= 0) {
       int bUseLayerSRS = MS_FALSE;
       int numFeatures = -1;
 
-#if defined(USE_WMS_SVR) || defined (USE_WFS_SVR) || defined (USE_WCS_SVR) || defined(USE_SOS_SVR) || defined(USE_WMS_LYR) || defined(USE_WFS_LYR)
+#if defined(USE_WMS_SVR) || defined(USE_WFS_SVR) || defined(USE_WCS_SVR) ||    \
+    defined(USE_SOS_SVR) || defined(USE_WMS_LYR) || defined(USE_WFS_LYR)
       /* Optimization to detect the case where a WFS query uses in fact the */
-      /* whole layer extent, but expressed in a map SRS different from the layer SRS */
-      /* In the case, we can directly request against the layer extent in its native SRS */
-      if( lp->project &&
-          memcmp( &searchrect, &invalid_rect, sizeof(searchrect) ) != 0 &&
-          msProjectionsDiffer(&(lp->projection), &(map->projection)) )
-      {
+      /* whole layer extent, but expressed in a map SRS different from the layer
+       * SRS */
+      /* In the case, we can directly request against the layer extent in its
+       * native SRS */
+      if (lp->project &&
+          memcmp(&searchrect, &invalid_rect, sizeof(searchrect)) != 0 &&
+          msProjectionsDiffer(&(lp->projection), &(map->projection))) {
         rectObj layerExtent;
-        if ( msOWSGetLayerExtent(map, lp, "FO", &layerExtent) == MS_SUCCESS)
-        {
-            rectObj ext = layerExtent;
-            ext.minx -= 1e-5;
-            ext.miny -= 1e-5;
-            ext.maxx += 1e-5;
-            ext.maxy += 1e-5;
-            msProjectRect(&(lp->projection), &(map->projection), &ext);
-            if( fabs(ext.minx - searchrect.minx) <= 2e-5 &&
-                fabs(ext.miny - searchrect.miny) <= 2e-5 &&
-                fabs(ext.maxx - searchrect.maxx) <= 2e-5 &&
-                fabs(ext.maxy - searchrect.maxy) <= 2e-5 )
-            {
-              bUseLayerSRS = MS_TRUE;
-              numFeatures = msLayerGetShapeCount(lp, layerExtent, &(lp->projection));
-            }
+        if (msOWSGetLayerExtent(map, lp, "FO", &layerExtent) == MS_SUCCESS) {
+          rectObj ext = layerExtent;
+          ext.minx -= 1e-5;
+          ext.miny -= 1e-5;
+          ext.maxx += 1e-5;
+          ext.maxy += 1e-5;
+          msProjectRect(&(lp->projection), &(map->projection), &ext);
+          if (fabs(ext.minx - searchrect.minx) <= 2e-5 &&
+              fabs(ext.miny - searchrect.miny) <= 2e-5 &&
+              fabs(ext.maxx - searchrect.maxx) <= 2e-5 &&
+              fabs(ext.maxy - searchrect.maxy) <= 2e-5) {
+            bUseLayerSRS = MS_TRUE;
+            numFeatures =
+                msLayerGetShapeCount(lp, layerExtent, &(lp->projection));
+          }
         }
       }
 #endif
 
-      if( !bUseLayerSRS )
-          numFeatures = msLayerGetShapeCount(lp, searchrect, &(map->projection));
-      if( numFeatures >= 0 )
-      {
-        lp->resultcache = (resultCacheObj *)malloc(sizeof(resultCacheObj)); /* allocate and initialize the result cache */
+      if (!bUseLayerSRS)
+        numFeatures = msLayerGetShapeCount(lp, searchrect, &(map->projection));
+      if (numFeatures >= 0) {
+        lp->resultcache = (resultCacheObj *)malloc(sizeof(
+            resultCacheObj)); /* allocate and initialize the result cache */
         MS_CHECK_ALLOC(lp->resultcache, sizeof(resultCacheObj), MS_FAILURE);
-        initResultCache( lp->resultcache);
+        initResultCache(lp->resultcache);
         lp->resultcache->numresults = numFeatures;
         if (!paging && map->query.startindex > 1) {
-           lp->resultcache->numresults -= (map->query.startindex-1);
+          lp->resultcache->numresults -= (map->query.startindex - 1);
         }
         msFreeShape(&searchshape);
         continue;
@@ -1190,23 +1327,25 @@ int msQueryByRect(mapObj *map)
     }
 
     lp->project = msProjectionsDiffer(&(lp->projection), &(map->projection));
-    if(lp->project &&
-       memcmp( &searchrect, &invalid_rect, sizeof(searchrect) ) != 0 )
-      msProjectRect(&(map->projection), &(lp->projection), &searchrect); /* project the searchrect to source coords */
+    if (lp->project &&
+        memcmp(&searchrect, &invalid_rect, sizeof(searchrect)) != 0)
+      msProjectRect(&(map->projection), &(lp->projection),
+                    &searchrect); /* project the searchrect to source coords */
 
     status = msLayerWhichShapes(lp, searchrect, MS_TRUE);
-    if(status == MS_DONE) { /* no overlap */
+    if (status == MS_DONE) { /* no overlap */
       msLayerClose(lp);
       continue;
-    } else if(status != MS_SUCCESS) {
+    } else if (status != MS_SUCCESS) {
       msLayerClose(lp);
       msFreeShape(&searchshape);
-      return(MS_FAILURE);
+      return (MS_FAILURE);
     }
 
-    lp->resultcache = (resultCacheObj *)malloc(sizeof(resultCacheObj)); /* allocate and initialize the result cache */
+    lp->resultcache = (resultCacheObj *)malloc(
+        sizeof(resultCacheObj)); /* allocate and initialize the result cache */
     MS_CHECK_ALLOC(lp->resultcache, sizeof(resultCacheObj), MS_FAILURE);
-    initResultCache( lp->resultcache);
+    initResultCache(lp->resultcache);
 
     nclasses = 0;
     classgroup = NULL;
@@ -1216,86 +1355,97 @@ int msQueryByRect(mapObj *map)
     if (lp->minfeaturesize > 0)
       minfeaturesize = Pix2LayerGeoref(map, lp, lp->minfeaturesize);
 
-    while((status = msLayerNextShape(lp, &shape)) == MS_SUCCESS) { /* step through the shapes */
+    while ((status = msLayerNextShape(lp, &shape)) ==
+           MS_SUCCESS) { /* step through the shapes */
 
       /* Check if the shape size is ok to be drawn */
-      if ( (shape.type == MS_SHAPE_LINE || shape.type == MS_SHAPE_POLYGON) && (minfeaturesize > 0) ) {
+      if ((shape.type == MS_SHAPE_LINE || shape.type == MS_SHAPE_POLYGON) &&
+          (minfeaturesize > 0)) {
         if (msShapeCheckSize(&shape, minfeaturesize) == MS_FALSE) {
-          if( lp->debug >= MS_DEBUGLEVEL_V )
-            msDebug("msQueryByRect(): Skipping shape (%ld) because LAYER::MINFEATURESIZE is bigger than shape size\n", shape.index);
+          if (lp->debug >= MS_DEBUGLEVEL_V)
+            msDebug("msQueryByRect(): Skipping shape (%ld) because "
+                    "LAYER::MINFEATURESIZE is bigger than shape size\n",
+                    shape.index);
           msFreeShape(&shape);
           continue;
         }
       }
 
       shape.classindex = msShapeGetClass(lp, map, &shape, classgroup, nclasses);
-      if(!(lp->template) && ((shape.classindex == -1) || (lp->class[shape.classindex]->status == MS_OFF))) { /* not a valid shape */
+      if (!(lp->template) && ((shape.classindex == -1) ||
+                              (lp->class[shape.classindex]
+                               -> status == MS_OFF))) { /* not a valid shape */
         msFreeShape(&shape);
         continue;
       }
 
-      if(!(lp->template) && !(lp->class[shape.classindex]->template)) { /* no valid template */
+      if (!(lp->template) &&
+          !(lp->class[shape.classindex] -> template)) { /* no valid template */
         msFreeShape(&shape);
         continue;
       }
 
-      if(lp->project) {
-        if( reprojector == NULL ) {
-            reprojector = msProjectCreateReprojector(&(lp->projection), &(map->projection));
-            if( reprojector == NULL ) {
-              msFreeShape(&shape);
-              status = MS_FAILURE;
-              break;
-            }
+      if (lp->project) {
+        if (reprojector == NULL) {
+          reprojector =
+              msProjectCreateReprojector(&(lp->projection), &(map->projection));
+          if (reprojector == NULL) {
+            msFreeShape(&shape);
+            status = MS_FAILURE;
+            break;
+          }
         }
-        if( msProjectShapeEx(reprojector, &shape) != MS_SUCCESS ) {
-            // msProjectShapeEx() calls msFreeShape() on error
-            continue;
+        if (msProjectShapeEx(reprojector, &shape) != MS_SUCCESS) {
+          // msProjectShapeEx() calls msFreeShape() on error
+          continue;
         }
       }
 
-      if(msRectContained(&shape.bounds, &searchrectInMapProj) == MS_TRUE) { /* if the whole shape is in, don't intersect */
+      if (msRectContained(&shape.bounds, &searchrectInMapProj) ==
+          MS_TRUE) { /* if the whole shape is in, don't intersect */
         status = MS_TRUE;
       } else {
-        switch(shape.type) { /* make sure shape actually intersects the qrect (ADD FUNCTIONS SPECIFIC TO RECTOBJ) */
-          case MS_SHAPE_POINT:
-            status = msIntersectMultipointPolygon(&shape, &searchshape);
-            break;
-          case MS_SHAPE_LINE:
-            status = msIntersectPolylinePolygon(&shape, &searchshape);
-            break;
-          case MS_SHAPE_POLYGON:
-            status = msIntersectPolygons(&shape, &searchshape);
-            break;
-          case MS_SHAPE_NULL:
-              status = MS_TRUE;
-              break;
-          default:
-            break;
+        switch (shape.type) { /* make sure shape actually intersects the qrect
+                                 (ADD FUNCTIONS SPECIFIC TO RECTOBJ) */
+        case MS_SHAPE_POINT:
+          status = msIntersectMultipointPolygon(&shape, &searchshape);
+          break;
+        case MS_SHAPE_LINE:
+          status = msIntersectPolylinePolygon(&shape, &searchshape);
+          break;
+        case MS_SHAPE_POLYGON:
+          status = msIntersectPolygons(&shape, &searchshape);
+          break;
+        case MS_SHAPE_NULL:
+          status = MS_TRUE;
+          break;
+        default:
+          break;
         }
       }
 
-      if(status == MS_TRUE) {
+      if (status == MS_TRUE) {
         /* Should we skip this feature? */
         if (!paging && map->query.startindex > 1) {
           --map->query.startindex;
           msFreeShape(&shape);
           continue;
         }
-        if( map->query.only_cache_result_count )
-            lp->resultcache->numresults ++;
+        if (map->query.only_cache_result_count)
+          lp->resultcache->numresults++;
         else
-            addResult(map, lp->resultcache, &queryCache, &shape);
+          addResult(map, lp->resultcache, &queryCache, &shape);
         --map->query.maxfeatures;
       }
       msFreeShape(&shape);
 
       /* check shape count */
-      if(lp->maxfeatures > 0 && lp->maxfeatures == lp->resultcache->numresults) {
+      if (lp->maxfeatures > 0 &&
+          lp->maxfeatures == lp->resultcache->numresults) {
         status = MS_DONE;
         break;
       }
-      
+
     } /* next shape */
 
     if (classgroup)
@@ -1303,43 +1453,45 @@ int msQueryByRect(mapObj *map)
 
     msProjectDestroyReprojector(reprojector);
 
-    if(status != MS_DONE) {
-        msFreeShape(&searchshape);
-        return(MS_FAILURE);
+    if (status != MS_DONE) {
+      msFreeShape(&searchshape);
+      return (MS_FAILURE);
     }
 
-    if( !map->query.only_cache_result_count &&
-        lp->resultcache->numresults == 0) msLayerClose(lp); /* no need to keep the layer open */
-  } /* next layer */
+    if (!map->query.only_cache_result_count && lp->resultcache->numresults == 0)
+      msLayerClose(lp); /* no need to keep the layer open */
+  }                     /* next layer */
 
   msFreeShape(&searchshape);
 
   /* was anything found? */
-  for(l=start; l>=stop; l--) {
-    if(GET_LAYER(map, l)->resultcache && GET_LAYER(map, l)->resultcache->numresults > 0)
-      return(MS_SUCCESS);
+  for (l = start; l >= stop; l--) {
+    if (GET_LAYER(map, l)->resultcache &&
+        GET_LAYER(map, l)->resultcache->numresults > 0)
+      return (MS_SUCCESS);
   }
 
   if (map->debug >= MS_DEBUGLEVEL_V) {
-      msDebug("msQueryByRect(): No matching record(s) found.");
+    msDebug("msQueryByRect(): No matching record(s) found.");
   }
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
-static int is_duplicate(resultCacheObj *resultcache, int shapeindex, int tileindex)
-{
+static int is_duplicate(resultCacheObj *resultcache, int shapeindex,
+                        int tileindex) {
   int i;
 
-  for(i=0; i<resultcache->numresults; i++)
-    if(resultcache->results[i].shapeindex == shapeindex && resultcache->results[i].tileindex == tileindex) return(MS_TRUE);
+  for (i = 0; i < resultcache->numresults; i++)
+    if (resultcache->results[i].shapeindex == shapeindex &&
+        resultcache->results[i].tileindex == tileindex)
+      return (MS_TRUE);
 
-  return(MS_FALSE);
+  return (MS_FALSE);
 }
 
-int msQueryByFeatures(mapObj *map)
-{
+int msQueryByFeatures(mapObj *map) {
   int i, l;
-  int start, stop=0;
+  int start, stop = 0;
   layerObj *lp, *slp;
   char status;
 
@@ -1355,25 +1507,28 @@ int msQueryByFeatures(mapObj *map)
 
   initQueryCache(&queryCache);
 
-  if(map->debug) msDebug("in msQueryByFeatures()\n");
+  if (map->debug)
+    msDebug("in msQueryByFeatures()\n");
 
   /* is the selection layer valid and has it been queried */
-  if(map->query.slayer < 0 || map->query.slayer >= map->numlayers) {
-    msSetError(MS_QUERYERR, "Invalid selection layer index.", "msQueryByFeatures()");
-    return(MS_FAILURE);
+  if (map->query.slayer < 0 || map->query.slayer >= map->numlayers) {
+    msSetError(MS_QUERYERR, "Invalid selection layer index.",
+               "msQueryByFeatures()");
+    return (MS_FAILURE);
   }
   slp = (GET_LAYER(map, map->query.slayer));
-  if(!slp->resultcache) {
-    msSetError(MS_QUERYERR, "Selection layer has not been queried.", "msQueryByFeatures()");
-    return(MS_FAILURE);
+  if (!slp->resultcache) {
+    msSetError(MS_QUERYERR, "Selection layer has not been queried.",
+               "msQueryByFeatures()");
+    return (MS_FAILURE);
   }
 
   /* conditions may have changed since this layer last drawn, so set
      layer->project true to recheck projection needs (Bug #673) */
   slp->project = msProjectionsDiffer(&(slp->projection), &(map->projection));
 
-  if(map->query.layer < 0 || map->query.layer >= map->numlayers)
-    start = map->numlayers-1;
+  if (map->query.layer < 0 || map->query.layer >= map->numlayers)
+    start = map->numlayers - 1;
   else
     start = stop = map->query.layer;
 
@@ -1384,9 +1539,10 @@ int msQueryByFeatures(mapObj *map)
   msInitShape(&shape); /* initialize a few things */
   msInitShape(&selectshape);
 
-  for(l=start; l>=stop; l--) {
-    reprojectionObj* reprojector = NULL;
-    if(l == map->query.slayer) continue; /* skip the selection layer */
+  for (l = start; l >= stop; l--) {
+    reprojectionObj *reprojector = NULL;
+    if (l == map->query.slayer)
+      continue; /* skip the selection layer */
 
     lp = (GET_LAYER(map, l));
     if (map->query.maxfeatures == 0)
@@ -1402,95 +1558,117 @@ int msQueryByFeatures(mapObj *map)
        layer->project true to recheck projection needs (Bug #673) */
     lp->project = msProjectionsDiffer(&(lp->projection), &(map->projection));
 
-    /* free any previous search results, do it now in case one of the next few tests fail */
-    if(lp->resultcache) {
-      if(lp->resultcache->results) free(lp->resultcache->results);
+    /* free any previous search results, do it now in case one of the next few
+     * tests fail */
+    if (lp->resultcache) {
+      if (lp->resultcache->results)
+        free(lp->resultcache->results);
       free(lp->resultcache);
       lp->resultcache = NULL;
     }
 
-    if(!msIsLayerQueryable(lp)) continue;
-    if(lp->status == MS_OFF) continue;
+    if (!msIsLayerQueryable(lp))
+      continue;
+    if (lp->status == MS_OFF)
+      continue;
 
-    if(map->scaledenom > 0) {
-      if((lp->maxscaledenom > 0) && (map->scaledenom > lp->maxscaledenom)) continue;
-      if((lp->minscaledenom > 0) && (map->scaledenom <= lp->minscaledenom)) continue;
+    if (map->scaledenom > 0) {
+      if ((lp->maxscaledenom > 0) && (map->scaledenom > lp->maxscaledenom))
+        continue;
+      if ((lp->minscaledenom > 0) && (map->scaledenom <= lp->minscaledenom))
+        continue;
     }
 
     if (lp->maxscaledenom <= 0 && lp->minscaledenom <= 0) {
-      if((lp->maxgeowidth > 0) && ((map->extent.maxx - map->extent.minx) > lp->maxgeowidth)) continue;
-      if((lp->mingeowidth > 0) && ((map->extent.maxx - map->extent.minx) < lp->mingeowidth)) continue;
+      if ((lp->maxgeowidth > 0) &&
+          ((map->extent.maxx - map->extent.minx) > lp->maxgeowidth))
+        continue;
+      if ((lp->mingeowidth > 0) &&
+          ((map->extent.maxx - map->extent.minx) < lp->mingeowidth))
+        continue;
     }
 
-    /* Get the layer tolerance default is 3 for point and line layers, 0 for others */
-    if(lp->tolerance == -1) {
-      if(lp->type == MS_LAYER_POINT || lp->type == MS_LAYER_LINE)
+    /* Get the layer tolerance default is 3 for point and line layers, 0 for
+     * others */
+    if (lp->tolerance == -1) {
+      if (lp->type == MS_LAYER_POINT || lp->type == MS_LAYER_LINE)
         layer_tolerance = 3;
       else
         layer_tolerance = 0;
     } else
       layer_tolerance = lp->tolerance;
 
-    if(lp->toleranceunits == MS_PIXELS)
-      tolerance = layer_tolerance * msAdjustExtent(&(map->extent), map->width, map->height);
+    if (lp->toleranceunits == MS_PIXELS)
+      tolerance = layer_tolerance *
+                  msAdjustExtent(&(map->extent), map->width, map->height);
     else
-      tolerance = layer_tolerance * (msInchesPerUnit(lp->toleranceunits,0)/msInchesPerUnit(map->units,0));
+      tolerance = layer_tolerance * (msInchesPerUnit(lp->toleranceunits, 0) /
+                                     msInchesPerUnit(map->units, 0));
 
     msLayerClose(lp); /* reset */
     status = msLayerOpen(lp);
-    if(status != MS_SUCCESS) return(MS_FAILURE);
+    if (status != MS_SUCCESS)
+      return (MS_FAILURE);
     msLayerEnablePaging(lp, MS_FALSE);
 
     /* build item list, we want *all* items */
     status = msLayerWhichItems(lp, MS_TRUE, NULL);
-    if(status != MS_SUCCESS) return(MS_FAILURE);
+    if (status != MS_SUCCESS)
+      return (MS_FAILURE);
 
     /* for each selection shape */
-    for(i=0; i<slp->resultcache->numresults; i++) {
+    for (i = 0; i < slp->resultcache->numresults; i++) {
 
-      status = msLayerGetShape(slp, &selectshape, &(slp->resultcache->results[i]));
-      if(status != MS_SUCCESS) {
+      status =
+          msLayerGetShape(slp, &selectshape, &(slp->resultcache->results[i]));
+      if (status != MS_SUCCESS) {
         msLayerClose(lp);
         msLayerClose(slp);
-        return(MS_FAILURE);
+        return (MS_FAILURE);
       }
 
-      if(selectshape.type != MS_SHAPE_POLYGON && selectshape.type != MS_SHAPE_LINE) {
+      if (selectshape.type != MS_SHAPE_POLYGON &&
+          selectshape.type != MS_SHAPE_LINE) {
         msLayerClose(lp);
         msLayerClose(slp);
-        msSetError(MS_QUERYERR, "Selection features MUST be polygons or lines.", "msQueryByFeatures()");
-        return(MS_FAILURE);
+        msSetError(MS_QUERYERR, "Selection features MUST be polygons or lines.",
+                   "msQueryByFeatures()");
+        return (MS_FAILURE);
       }
 
-      if(slp->project)
+      if (slp->project)
         msProjectShape(&(slp->projection), &(map->projection), &selectshape);
 
       /* identify target shapes */
       searchrect = selectshape.bounds;
 
-      searchrect.minx -= tolerance; /* expand the search box to account for layer tolerances (e.g. buffered searches) */
+      searchrect.minx -=
+          tolerance; /* expand the search box to account for layer tolerances
+                        (e.g. buffered searches) */
       searchrect.maxx += tolerance;
       searchrect.miny -= tolerance;
       searchrect.maxy += tolerance;
 
-      if(lp->project)
-        msProjectRect(&(map->projection), &(lp->projection), &searchrect); /* project the searchrect to source coords */
+      if (lp->project)
+        msProjectRect(
+            &(map->projection), &(lp->projection),
+            &searchrect); /* project the searchrect to source coords */
 
       status = msLayerWhichShapes(lp, searchrect, MS_TRUE);
-      if(status == MS_DONE) { /* no overlap */
+      if (status == MS_DONE) { /* no overlap */
         msLayerClose(lp);
         break; /* next layer */
-      } else if(status != MS_SUCCESS) {
+      } else if (status != MS_SUCCESS) {
         msLayerClose(lp);
         msLayerClose(slp);
-        return(MS_FAILURE);
+        return (MS_FAILURE);
       }
 
-      if(i == 0) {
-        lp->resultcache = (resultCacheObj *)malloc(sizeof(resultCacheObj)); /* allocate and initialize the result cache */
+      if (i == 0) {
+        lp->resultcache = (resultCacheObj *)malloc(sizeof(
+            resultCacheObj)); /* allocate and initialize the result cache */
         MS_CHECK_ALLOC(lp->resultcache, sizeof(resultCacheObj), MS_FAILURE);
-        initResultCache( lp->resultcache);
-
+        initResultCache(lp->resultcache);
       }
 
       nclasses = 0;
@@ -1501,114 +1679,136 @@ int msQueryByFeatures(mapObj *map)
       if (lp->minfeaturesize > 0)
         minfeaturesize = Pix2LayerGeoref(map, lp, lp->minfeaturesize);
 
-      while((status = msLayerNextShape(lp, &shape)) == MS_SUCCESS) { /* step through the shapes */
+      while ((status = msLayerNextShape(lp, &shape)) ==
+             MS_SUCCESS) { /* step through the shapes */
 
         /* check for dups when there are multiple selection shapes */
-        if(i > 0 && is_duplicate(lp->resultcache, shape.index, shape.tileindex)) continue;
-
+        if (i > 0 &&
+            is_duplicate(lp->resultcache, shape.index, shape.tileindex))
+          continue;
 
         /* Check if the shape size is ok to be drawn */
-        if ( (shape.type == MS_SHAPE_LINE || shape.type == MS_SHAPE_POLYGON) && (minfeaturesize > 0) ) {
+        if ((shape.type == MS_SHAPE_LINE || shape.type == MS_SHAPE_POLYGON) &&
+            (minfeaturesize > 0)) {
           if (msShapeCheckSize(&shape, minfeaturesize) == MS_FALSE) {
-            if( lp->debug >= MS_DEBUGLEVEL_V )
-              msDebug("msQueryByFeature(): Skipping shape (%ld) because LAYER::MINFEATURESIZE is bigger than shape size\n", shape.index);
+            if (lp->debug >= MS_DEBUGLEVEL_V)
+              msDebug("msQueryByFeature(): Skipping shape (%ld) because "
+                      "LAYER::MINFEATURESIZE is bigger than shape size\n",
+                      shape.index);
             msFreeShape(&shape);
             continue;
           }
         }
 
-        shape.classindex = msShapeGetClass(lp, map, &shape, classgroup, nclasses);
-        if(!(lp->template) && ((shape.classindex == -1) || (lp->class[shape.classindex]->status == MS_OFF))) { /* not a valid shape */
+        shape.classindex =
+            msShapeGetClass(lp, map, &shape, classgroup, nclasses);
+        if (!(lp->template) &&
+            ((shape.classindex == -1) ||
+             (lp->class[shape.classindex]
+              -> status == MS_OFF))) { /* not a valid shape */
           msFreeShape(&shape);
           continue;
         }
 
-        if(!(lp->template) && !(lp->class[shape.classindex]->template)) { /* no valid template */
+        if (!(lp->template) && !(lp->class[shape.classindex]
+                                 -> template)) { /* no valid template */
           msFreeShape(&shape);
           continue;
         }
 
-        if(lp->project) {
-            if( reprojector == NULL ) {
-                reprojector = msProjectCreateReprojector(&(lp->projection), &(map->projection));
-                if( reprojector == NULL ) {
-                    msFreeShape(&shape);
-                    status = MS_FAILURE;
-                    break;
-                }
+        if (lp->project) {
+          if (reprojector == NULL) {
+            reprojector = msProjectCreateReprojector(&(lp->projection),
+                                                     &(map->projection));
+            if (reprojector == NULL) {
+              msFreeShape(&shape);
+              status = MS_FAILURE;
+              break;
             }
-            msProjectShapeEx(reprojector, &shape);
+          }
+          msProjectShapeEx(reprojector, &shape);
         }
 
-        switch(selectshape.type) { /* may eventually support types other than polygon on line */
+        switch (selectshape.type) { /* may eventually support types other than
+                                       polygon on line */
+        case MS_SHAPE_POLYGON:
+          switch (shape.type) { /* make sure shape actually intersects the
+                                   selectshape */
+          case MS_SHAPE_POINT:
+            if (tolerance == 0) /* just test for intersection */
+              status = msIntersectMultipointPolygon(&shape, &selectshape);
+            else { /* check distance, distance=0 means they intersect */
+              distance = msDistanceShapeToShape(&selectshape, &shape);
+              if (distance < tolerance)
+                status = MS_TRUE;
+            }
+            break;
+          case MS_SHAPE_LINE:
+            if (tolerance == 0) { /* just test for intersection */
+              status = msIntersectPolylinePolygon(&shape, &selectshape);
+            } else { /* check distance, distance=0 means they intersect */
+              distance = msDistanceShapeToShape(&selectshape, &shape);
+              if (distance < tolerance)
+                status = MS_TRUE;
+            }
+            break;
           case MS_SHAPE_POLYGON:
-            switch(shape.type) { /* make sure shape actually intersects the selectshape */
-              case MS_SHAPE_POINT:
-                if(tolerance == 0) /* just test for intersection */
-                  status = msIntersectMultipointPolygon(&shape, &selectshape);
-                else { /* check distance, distance=0 means they intersect */
-                  distance = msDistanceShapeToShape(&selectshape, &shape);
-                  if(distance < tolerance) status = MS_TRUE;
-                }
-                break;
-              case MS_SHAPE_LINE:
-                if(tolerance == 0) { /* just test for intersection */
-                  status = msIntersectPolylinePolygon(&shape, &selectshape);
-                } else { /* check distance, distance=0 means they intersect */
-                  distance = msDistanceShapeToShape(&selectshape, &shape);
-                  if(distance < tolerance) status = MS_TRUE;
-                }
-                break;
-              case MS_SHAPE_POLYGON:
-                if(tolerance == 0) /* just test for intersection */
-                  status = msIntersectPolygons(&shape, &selectshape);
-                else { /* check distance, distance=0 means they intersect */
-                  distance = msDistanceShapeToShape(&selectshape, &shape);
-                  if(distance < tolerance) status = MS_TRUE;
-                }
-                break;
-              default:
-                status = MS_FALSE;
-                break;
+            if (tolerance == 0) /* just test for intersection */
+              status = msIntersectPolygons(&shape, &selectshape);
+            else { /* check distance, distance=0 means they intersect */
+              distance = msDistanceShapeToShape(&selectshape, &shape);
+              if (distance < tolerance)
+                status = MS_TRUE;
+            }
+            break;
+          default:
+            status = MS_FALSE;
+            break;
+          }
+          break;
+        case MS_SHAPE_LINE:
+          switch (shape.type) { /* make sure shape actually intersects the
+                                   selectshape */
+          case MS_SHAPE_POINT:
+            if (tolerance == 0) { /* just test for intersection */
+              distance = msDistanceShapeToShape(&selectshape, &shape);
+              if (distance == 0)
+                status = MS_TRUE;
+            } else {
+              distance = msDistanceShapeToShape(&selectshape, &shape);
+              if (distance < tolerance)
+                status = MS_TRUE;
             }
             break;
           case MS_SHAPE_LINE:
-            switch(shape.type) { /* make sure shape actually intersects the selectshape */
-              case MS_SHAPE_POINT:
-                if(tolerance == 0) { /* just test for intersection */
-                  distance = msDistanceShapeToShape(&selectshape, &shape);
-                  if(distance == 0) status = MS_TRUE;
-                } else {
-                  distance = msDistanceShapeToShape(&selectshape, &shape);
-                  if(distance < tolerance) status = MS_TRUE;
-                }
-                break;
-              case MS_SHAPE_LINE:
-                if(tolerance == 0) { /* just test for intersection */
-                  status = msIntersectPolylines(&shape, &selectshape);
-                } else { /* check distance, distance=0 means they intersect */
-                  distance = msDistanceShapeToShape(&selectshape, &shape);
-                  if(distance < tolerance) status = MS_TRUE;
-                }
-                break;
-              case MS_SHAPE_POLYGON:
-                if(tolerance == 0) /* just test for intersection */
-                  status = msIntersectPolylinePolygon(&selectshape, &shape);
-                else { /* check distance, distance=0 means they intersect */
-                  distance = msDistanceShapeToShape(&selectshape, &shape);
-                  if(distance < tolerance) status = MS_TRUE;
-                }
-                break;
-              default:
-                status = MS_FALSE;
-                break;
+            if (tolerance == 0) { /* just test for intersection */
+              status = msIntersectPolylines(&shape, &selectshape);
+            } else { /* check distance, distance=0 means they intersect */
+              distance = msDistanceShapeToShape(&selectshape, &shape);
+              if (distance < tolerance)
+                status = MS_TRUE;
+            }
+            break;
+          case MS_SHAPE_POLYGON:
+            if (tolerance == 0) /* just test for intersection */
+              status = msIntersectPolylinePolygon(&selectshape, &shape);
+            else { /* check distance, distance=0 means they intersect */
+              distance = msDistanceShapeToShape(&selectshape, &shape);
+              if (distance < tolerance)
+                status = MS_TRUE;
             }
             break;
           default:
-            break; /* should never get here as we test for selection shape type explicitly earlier */
+            status = MS_FALSE;
+            break;
+          }
+          break;
+        default:
+          break; /* should never get here as we test for selection shape type
+                    explicitly earlier */
         }
 
-        if(status == MS_TRUE) {
+        if (status == MS_TRUE) {
           /* Should we skip this feature? */
           if (!msLayerGetPaging(lp) && map->query.startindex > 1) {
             --map->query.startindex;
@@ -1620,7 +1820,8 @@ int msQueryByFeatures(mapObj *map)
         msFreeShape(&shape);
 
         /* check shape count */
-        if(lp->maxfeatures > 0 && lp->maxfeatures == lp->resultcache->numresults) {
+        if (lp->maxfeatures > 0 &&
+            lp->maxfeatures == lp->resultcache->numresults) {
           status = MS_DONE;
           break;
         }
@@ -1633,23 +1834,28 @@ int msQueryByFeatures(mapObj *map)
 
       msFreeShape(&selectshape);
 
-      if(status != MS_DONE) return(MS_FAILURE);
+      if (status != MS_DONE)
+        return (MS_FAILURE);
 
     } /* next selection shape */
 
-    if(lp->resultcache == NULL || lp->resultcache->numresults == 0) msLayerClose(lp); /* no need to keep the layer open */
-  } /* next layer */
+    if (lp->resultcache == NULL || lp->resultcache->numresults == 0)
+      msLayerClose(lp); /* no need to keep the layer open */
+  }                     /* next layer */
 
   /* was anything found? */
-  for(l=start; l>=stop; l--) {
-    if(l == map->query.slayer) continue; /* skip the selection layer */
-    if(GET_LAYER(map, l)->resultcache && GET_LAYER(map, l)->resultcache->numresults > 0) return(MS_SUCCESS);
+  for (l = start; l >= stop; l--) {
+    if (l == map->query.slayer)
+      continue; /* skip the selection layer */
+    if (GET_LAYER(map, l)->resultcache &&
+        GET_LAYER(map, l)->resultcache->numresults > 0)
+      return (MS_SUCCESS);
   }
 
   if (map->debug >= MS_DEBUGLEVEL_V) {
-      msDebug("msQueryByFeatures(): No matching record(s) found.");
+    msDebug("msQueryByFeatures(): No matching record(s) found.");
   }
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
 /* msQueryByPoint()
@@ -1666,10 +1872,9 @@ int msQueryByFeatures(mapObj *map)
  *     returned are the first ones found in each layer and are not necessarily
  *     the closest ones).
  */
-int msQueryByPoint(mapObj *map)
-{
+int msQueryByPoint(mapObj *map) {
   int l;
-  int start, stop=0;
+  int start, stop = 0;
 
   double d, t;
   double layer_tolerance;
@@ -1688,20 +1893,21 @@ int msQueryByPoint(mapObj *map)
 
   initQueryCache(&queryCache);
 
-  if(map->query.type != MS_QUERY_BY_POINT) {
-    msSetError(MS_QUERYERR, "The query is not properly defined.", "msQueryByPoint()");
-    return(MS_FAILURE);
+  if (map->query.type != MS_QUERY_BY_POINT) {
+    msSetError(MS_QUERYERR, "The query is not properly defined.",
+               "msQueryByPoint()");
+    return (MS_FAILURE);
   }
 
   msInitShape(&shape);
 
-  if(map->query.layer < 0 || map->query.layer >= map->numlayers)
-    start = map->numlayers-1;
+  if (map->query.layer < 0 || map->query.layer >= map->numlayers)
+    start = map->numlayers - 1;
   else
     start = stop = map->query.layer;
 
-  for(l=start; l>=stop; l--) {
-    reprojectionObj* reprojector = NULL;
+  for (l = start; l >= stop; l--) {
+    reprojectionObj *reprojector = NULL;
     lp = (GET_LAYER(map, l));
     if (map->query.maxfeatures == 0)
       break; /* nothing else to do */
@@ -1711,53 +1917,69 @@ int msQueryByPoint(mapObj *map)
     /* using mapscript, the map->query.startindex will be unset... */
     if (lp->startindex > 1 && map->query.startindex < 0)
       map->query.startindex = lp->startindex;
-    
+
     /* conditions may have changed since this layer last drawn, so set
        layer->project true to recheck projection needs (Bug #673) */
     lp->project = MS_TRUE;
 
-    /* free any previous search results, do it now in case one of the next few tests fail */
-    if(lp->resultcache) {
-      if(lp->resultcache->results) free(lp->resultcache->results);
+    /* free any previous search results, do it now in case one of the next few
+     * tests fail */
+    if (lp->resultcache) {
+      if (lp->resultcache->results)
+        free(lp->resultcache->results);
       free(lp->resultcache);
       lp->resultcache = NULL;
     }
 
-    if(!msIsLayerQueryable(lp)) continue;
-    if(lp->status == MS_OFF) continue;
+    if (!msIsLayerQueryable(lp))
+      continue;
+    if (lp->status == MS_OFF)
+      continue;
 
-    if(map->scaledenom > 0) {
-      if((lp->maxscaledenom > 0) && (map->scaledenom > lp->maxscaledenom)) continue;
-      if((lp->minscaledenom > 0) && (map->scaledenom <= lp->minscaledenom)) continue;
+    if (map->scaledenom > 0) {
+      if ((lp->maxscaledenom > 0) && (map->scaledenom > lp->maxscaledenom))
+        continue;
+      if ((lp->minscaledenom > 0) && (map->scaledenom <= lp->minscaledenom))
+        continue;
     }
 
     if (lp->maxscaledenom <= 0 && lp->minscaledenom <= 0) {
-      if((lp->maxgeowidth > 0) && ((map->extent.maxx - map->extent.minx) > lp->maxgeowidth)) continue;
-      if((lp->mingeowidth > 0) && ((map->extent.maxx - map->extent.minx) < lp->mingeowidth)) continue;
+      if ((lp->maxgeowidth > 0) &&
+          ((map->extent.maxx - map->extent.minx) > lp->maxgeowidth))
+        continue;
+      if ((lp->mingeowidth > 0) &&
+          ((map->extent.maxx - map->extent.minx) < lp->mingeowidth))
+        continue;
     }
 
     /* Raster layers are handled specially.  */
-    if( lp->type == MS_LAYER_RASTER ) {
-      if( msRasterQueryByPoint( map, lp, map->query.mode, map->query.point, map->query.buffer, map->query.maxresults ) == MS_FAILURE )
+    if (lp->type == MS_LAYER_RASTER) {
+      if (msRasterQueryByPoint(map, lp, map->query.mode, map->query.point,
+                               map->query.buffer,
+                               map->query.maxresults) == MS_FAILURE)
         return MS_FAILURE;
       continue;
     }
 
-    /* Get the layer tolerance default is 3 for point and line layers, 0 for others */
-    if(lp->tolerance == -1) {
-      if(lp->type == MS_LAYER_POINT || lp->type == MS_LAYER_LINE)
+    /* Get the layer tolerance default is 3 for point and line layers, 0 for
+     * others */
+    if (lp->tolerance == -1) {
+      if (lp->type == MS_LAYER_POINT || lp->type == MS_LAYER_LINE)
         layer_tolerance = 3;
       else
         layer_tolerance = 0;
     } else
       layer_tolerance = lp->tolerance;
 
-    if(map->query.buffer <= 0) { /* use layer tolerance */
-      if(lp->toleranceunits == MS_PIXELS)
-        t = layer_tolerance * MS_MAX(MS_CELLSIZE(map->extent.minx, map->extent.maxx, map->width),
-                                     MS_CELLSIZE(map->extent.miny, map->extent.maxy, map->height));
+    if (map->query.buffer <= 0) { /* use layer tolerance */
+      if (lp->toleranceunits == MS_PIXELS)
+        t = layer_tolerance *
+            MS_MAX(
+                MS_CELLSIZE(map->extent.minx, map->extent.maxx, map->width),
+                MS_CELLSIZE(map->extent.miny, map->extent.maxy, map->height));
       else
-        t = layer_tolerance * (msInchesPerUnit(lp->toleranceunits,0)/msInchesPerUnit(map->units,0));
+        t = layer_tolerance * (msInchesPerUnit(lp->toleranceunits, 0) /
+                               msInchesPerUnit(map->units, 0));
     } else /* use buffer distance */
       t = map->query.buffer;
 
@@ -1770,31 +1992,35 @@ int msQueryByPoint(mapObj *map)
     paging = msLayerGetPaging(lp);
     msLayerClose(lp); /* reset */
     status = msLayerOpen(lp);
-    if(status != MS_SUCCESS) return(MS_FAILURE);
+    if (status != MS_SUCCESS)
+      return (MS_FAILURE);
     msLayerEnablePaging(lp, paging);
 
     /* build item list, we want *all* items */
     status = msLayerWhichItems(lp, MS_TRUE, NULL);
-    if(status != MS_SUCCESS) return(MS_FAILURE);
+    if (status != MS_SUCCESS)
+      return (MS_FAILURE);
 
     /* identify target shapes */
     searchrect = rect;
     lp->project = msProjectionsDiffer(&(lp->projection), &(map->projection));
-    if(lp->project)
-      msProjectRect(&(map->projection), &(lp->projection), &searchrect); /* project the searchrect to source coords */
+    if (lp->project)
+      msProjectRect(&(map->projection), &(lp->projection),
+                    &searchrect); /* project the searchrect to source coords */
 
     status = msLayerWhichShapes(lp, searchrect, MS_TRUE);
-    if(status == MS_DONE) { /* no overlap */
+    if (status == MS_DONE) { /* no overlap */
       msLayerClose(lp);
       continue;
-    } else if(status != MS_SUCCESS) {
+    } else if (status != MS_SUCCESS) {
       msLayerClose(lp);
-      return(MS_FAILURE);
+      return (MS_FAILURE);
     }
 
-    lp->resultcache = (resultCacheObj *)malloc(sizeof(resultCacheObj)); /* allocate and initialize the result cache */
+    lp->resultcache = (resultCacheObj *)malloc(
+        sizeof(resultCacheObj)); /* allocate and initialize the result cache */
     MS_CHECK_ALLOC(lp->resultcache, sizeof(resultCacheObj), MS_FAILURE);
-    initResultCache( lp->resultcache);
+    initResultCache(lp->resultcache);
 
     nclasses = 0;
     classgroup = NULL;
@@ -1804,43 +2030,51 @@ int msQueryByPoint(mapObj *map)
     if (lp->minfeaturesize > 0)
       minfeaturesize = Pix2LayerGeoref(map, lp, lp->minfeaturesize);
 
-    while((status = msLayerNextShape(lp, &shape)) == MS_SUCCESS) { /* step through the shapes */
+    while ((status = msLayerNextShape(lp, &shape)) ==
+           MS_SUCCESS) { /* step through the shapes */
 
       /* Check if the shape size is ok to be drawn */
-      if ( (shape.type == MS_SHAPE_LINE || shape.type == MS_SHAPE_POLYGON) && (minfeaturesize > 0) ) {
+      if ((shape.type == MS_SHAPE_LINE || shape.type == MS_SHAPE_POLYGON) &&
+          (minfeaturesize > 0)) {
         if (msShapeCheckSize(&shape, minfeaturesize) == MS_FALSE) {
-          if( lp->debug >= MS_DEBUGLEVEL_V )
-            msDebug("msQueryByPoint(): Skipping shape (%ld) because LAYER::MINFEATURESIZE is bigger than shape size\n", shape.index);
+          if (lp->debug >= MS_DEBUGLEVEL_V)
+            msDebug("msQueryByPoint(): Skipping shape (%ld) because "
+                    "LAYER::MINFEATURESIZE is bigger than shape size\n",
+                    shape.index);
           msFreeShape(&shape);
           continue;
         }
       }
 
       shape.classindex = msShapeGetClass(lp, map, &shape, classgroup, nclasses);
-      if(!(lp->template) && ((shape.classindex == -1) || (lp->class[shape.classindex]->status == MS_OFF))) { /* not a valid shape */
+      if (!(lp->template) && ((shape.classindex == -1) ||
+                              (lp->class[shape.classindex]
+                               -> status == MS_OFF))) { /* not a valid shape */
         msFreeShape(&shape);
         continue;
       }
 
-      if(!(lp->template) && !(lp->class[shape.classindex]->template)) { /* no valid template */
+      if (!(lp->template) &&
+          !(lp->class[shape.classindex] -> template)) { /* no valid template */
         msFreeShape(&shape);
         continue;
       }
 
-      if(lp->project) {
-        if( reprojector == NULL ) {
-            reprojector = msProjectCreateReprojector(&(lp->projection), &(map->projection));
-            if( reprojector == NULL ) {
-              msFreeShape(&shape);
-              status = MS_FAILURE;
-              break;
-            }
+      if (lp->project) {
+        if (reprojector == NULL) {
+          reprojector =
+              msProjectCreateReprojector(&(lp->projection), &(map->projection));
+          if (reprojector == NULL) {
+            msFreeShape(&shape);
+            status = MS_FAILURE;
+            break;
+          }
         }
         msProjectShapeEx(reprojector, &shape);
       }
 
       d = msDistancePointToShape(&(map->query.point), &shape);
-      if( d <= t ) { /* found one */
+      if (d <= t) { /* found one */
 
         /* Should we skip this feature? */
         if (!paging && map->query.startindex > 1) {
@@ -1849,7 +2083,7 @@ int msQueryByPoint(mapObj *map)
           continue;
         }
 
-        if(map->query.mode == MS_QUERY_SINGLE) {
+        if (map->query.mode == MS_QUERY_SINGLE) {
           cleanupResultCache(lp->resultcache);
           initQueryCache(&queryCache);
           addResult(map, lp->resultcache, &queryCache, &shape);
@@ -1861,13 +2095,15 @@ int msQueryByPoint(mapObj *map)
 
       msFreeShape(&shape);
 
-      if(map->query.mode == MS_QUERY_MULTIPLE && map->query.maxresults > 0 && lp->resultcache->numresults == map->query.maxresults) {
-        status = MS_DONE;   /* got enough results for this layer */
+      if (map->query.mode == MS_QUERY_MULTIPLE && map->query.maxresults > 0 &&
+          lp->resultcache->numresults == map->query.maxresults) {
+        status = MS_DONE; /* got enough results for this layer */
         break;
       }
 
       /* check shape count */
-      if(lp->maxfeatures > 0 && lp->maxfeatures == lp->resultcache->numresults) {
+      if (lp->maxfeatures > 0 &&
+          lp->maxfeatures == lp->resultcache->numresults) {
         status = MS_DONE;
         break;
       }
@@ -1878,30 +2114,33 @@ int msQueryByPoint(mapObj *map)
 
     msProjectDestroyReprojector(reprojector);
 
-    if(status != MS_DONE) return(MS_FAILURE);
+    if (status != MS_DONE)
+      return (MS_FAILURE);
 
-    if(lp->resultcache->numresults == 0) msLayerClose(lp); /* no need to keep the layer open */
+    if (lp->resultcache->numresults == 0)
+      msLayerClose(lp); /* no need to keep the layer open */
 
-    if((lp->resultcache->numresults > 0) && (map->query.mode == MS_QUERY_SINGLE) && (map->query.maxresults == 0))
-      break;   /* no need to search any further */
-  } /* next layer */
+    if ((lp->resultcache->numresults > 0) &&
+        (map->query.mode == MS_QUERY_SINGLE) && (map->query.maxresults == 0))
+      break; /* no need to search any further */
+  }          /* next layer */
 
   /* was anything found? */
-  for(l=start; l>=stop; l--) {
-    if(GET_LAYER(map, l)->resultcache && GET_LAYER(map, l)->resultcache->numresults > 0)
-      return(MS_SUCCESS);
+  for (l = start; l >= stop; l--) {
+    if (GET_LAYER(map, l)->resultcache &&
+        GET_LAYER(map, l)->resultcache->numresults > 0)
+      return (MS_SUCCESS);
   }
 
   if (map->debug >= MS_DEBUGLEVEL_V) {
-      msDebug("msQueryByPoint(): No matching record(s) found.");
+    msDebug("msQueryByPoint(): No matching record(s) found.");
   }
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
-int msQueryByShape(mapObj *map)
-{
-  int start, stop=0, l;
-  shapeObj shape, *qshape=NULL;
+int msQueryByShape(mapObj *map) {
+  int start, stop = 0, l;
+  shapeObj shape, *qshape = NULL;
   layerObj *lp;
   char status;
   double distance, tolerance, layer_tolerance;
@@ -1914,32 +2153,36 @@ int msQueryByShape(mapObj *map)
 
   initQueryCache(&queryCache);
 
-  if(map->query.type != MS_QUERY_BY_SHAPE) {
-    msSetError(MS_QUERYERR, "The query is not properly defined.", "msQueryByShape()");
-    return(MS_FAILURE);
+  if (map->query.type != MS_QUERY_BY_SHAPE) {
+    msSetError(MS_QUERYERR, "The query is not properly defined.",
+               "msQueryByShape()");
+    return (MS_FAILURE);
   }
 
-  if(!(map->query.shape)) {
+  if (!(map->query.shape)) {
     msSetError(MS_QUERYERR, "Query shape is not defined.", "msQueryByShape()");
-    return(MS_FAILURE);
+    return (MS_FAILURE);
   }
-  if(map->query.shape->type != MS_SHAPE_POLYGON && map->query.shape->type != MS_SHAPE_LINE && map->query.shape->type != MS_SHAPE_POINT) {
-    msSetError(MS_QUERYERR, "Query shape MUST be a polygon, line or point.", "msQueryByShape()");
-    return(MS_FAILURE);
+  if (map->query.shape->type != MS_SHAPE_POLYGON &&
+      map->query.shape->type != MS_SHAPE_LINE &&
+      map->query.shape->type != MS_SHAPE_POINT) {
+    msSetError(MS_QUERYERR, "Query shape MUST be a polygon, line or point.",
+               "msQueryByShape()");
+    return (MS_FAILURE);
   }
 
   msInitShape(&shape);
   qshape = map->query.shape; /* for brevity */
 
-  if(map->query.layer < 0 || map->query.layer >= map->numlayers)
-    start = map->numlayers-1;
+  if (map->query.layer < 0 || map->query.layer >= map->numlayers)
+    start = map->numlayers - 1;
   else
     start = stop = map->query.layer;
 
   msComputeBounds(qshape); /* make sure an accurate extent exists */
 
-  for(l=start; l>=stop; l--) { /* each layer */
-    reprojectionObj* reprojector = NULL;
+  for (l = start; l >= stop; l--) { /* each layer */
+    reprojectionObj *reprojector = NULL;
     lp = (GET_LAYER(map, l));
     if (map->query.maxfeatures == 0)
       break; /* nothing else to do */
@@ -1954,81 +2197,99 @@ int msQueryByShape(mapObj *map)
        layer->project true to recheck projection needs (Bug #673) */
     lp->project = MS_TRUE;
 
-    /* free any previous search results, do it now in case one of the next few tests fail */
-    if(lp->resultcache) {
-      if(lp->resultcache->results) free(lp->resultcache->results);
+    /* free any previous search results, do it now in case one of the next few
+     * tests fail */
+    if (lp->resultcache) {
+      if (lp->resultcache->results)
+        free(lp->resultcache->results);
       free(lp->resultcache);
       lp->resultcache = NULL;
     }
 
-    if(!msIsLayerQueryable(lp)) continue;
-    if(lp->status == MS_OFF) continue;
+    if (!msIsLayerQueryable(lp))
+      continue;
+    if (lp->status == MS_OFF)
+      continue;
 
-    if(map->scaledenom > 0) {
-      if((lp->maxscaledenom > 0) && (map->scaledenom > lp->maxscaledenom)) continue;
-      if((lp->minscaledenom > 0) && (map->scaledenom <= lp->minscaledenom)) continue;
+    if (map->scaledenom > 0) {
+      if ((lp->maxscaledenom > 0) && (map->scaledenom > lp->maxscaledenom))
+        continue;
+      if ((lp->minscaledenom > 0) && (map->scaledenom <= lp->minscaledenom))
+        continue;
     }
 
     if (lp->maxscaledenom <= 0 && lp->minscaledenom <= 0) {
-      if((lp->maxgeowidth > 0) && ((map->extent.maxx - map->extent.minx) > lp->maxgeowidth)) continue;
-      if((lp->mingeowidth > 0) && ((map->extent.maxx - map->extent.minx) < lp->mingeowidth)) continue;
+      if ((lp->maxgeowidth > 0) &&
+          ((map->extent.maxx - map->extent.minx) > lp->maxgeowidth))
+        continue;
+      if ((lp->mingeowidth > 0) &&
+          ((map->extent.maxx - map->extent.minx) < lp->mingeowidth))
+        continue;
     }
 
     /* Raster layers are handled specially. */
-    if( lp->type == MS_LAYER_RASTER ) {
-      if( msRasterQueryByShape(map, lp, qshape) == MS_FAILURE )
+    if (lp->type == MS_LAYER_RASTER) {
+      if (msRasterQueryByShape(map, lp, qshape) == MS_FAILURE)
         return MS_FAILURE;
       continue;
     }
 
-    /* Get the layer tolerance default is 3 for point and line layers, 0 for others */
-    if(lp->tolerance == -1) {
-      if(lp->type == MS_LAYER_POINT || lp->type == MS_LAYER_LINE)
+    /* Get the layer tolerance default is 3 for point and line layers, 0 for
+     * others */
+    if (lp->tolerance == -1) {
+      if (lp->type == MS_LAYER_POINT || lp->type == MS_LAYER_LINE)
         layer_tolerance = 3;
       else
         layer_tolerance = 0;
     } else
       layer_tolerance = lp->tolerance;
 
-    if(lp->toleranceunits == MS_PIXELS)
-      tolerance = layer_tolerance * msAdjustExtent(&(map->extent), map->width, map->height);
+    if (lp->toleranceunits == MS_PIXELS)
+      tolerance = layer_tolerance *
+                  msAdjustExtent(&(map->extent), map->width, map->height);
     else
-      tolerance = layer_tolerance * (msInchesPerUnit(lp->toleranceunits,0)/msInchesPerUnit(map->units,0));
+      tolerance = layer_tolerance * (msInchesPerUnit(lp->toleranceunits, 0) /
+                                     msInchesPerUnit(map->units, 0));
 
     msLayerClose(lp); /* reset */
     status = msLayerOpen(lp);
-    if(status != MS_SUCCESS) return(MS_FAILURE);
+    if (status != MS_SUCCESS)
+      return (MS_FAILURE);
     /* disable driver paging */
     msLayerEnablePaging(lp, MS_FALSE);
 
     /* build item list, we want *all* items */
     status = msLayerWhichItems(lp, MS_TRUE, NULL);
-    if(status != MS_SUCCESS) return(MS_FAILURE);
+    if (status != MS_SUCCESS)
+      return (MS_FAILURE);
 
     /* identify target shapes */
     searchrect = qshape->bounds;
 
-    searchrect.minx -= tolerance; /* expand the search box to account for layer tolerances (e.g. buffered searches) */
+    searchrect.minx -= tolerance; /* expand the search box to account for layer
+                                     tolerances (e.g. buffered searches) */
     searchrect.maxx += tolerance;
     searchrect.miny -= tolerance;
     searchrect.maxy += tolerance;
 
     lp->project = msProjectionsDiffer(&(lp->projection), &(map->projection));
-    if(lp->project)
-      msProjectRect(&(map->projection), &(lp->projection), &searchrect); /* project the searchrect to source coords */
+    if (lp->project)
+      msProjectRect(&(map->projection), &(lp->projection),
+                    &searchrect); /* project the searchrect to source coords */
 
     status = msLayerWhichShapes(lp, searchrect, MS_TRUE);
-    if(status == MS_DONE) { /* no overlap */
+    if (status == MS_DONE) { /* no overlap */
       msLayerClose(lp);
       continue;
-    } else if(status != MS_SUCCESS) {
+    } else if (status != MS_SUCCESS) {
       msLayerClose(lp);
-      return(MS_FAILURE);
+      return (MS_FAILURE);
     }
 
-    lp->resultcache = (resultCacheObj *)malloc(sizeof(resultCacheObj)); /* allocate and initialize the result cache */
+    lp->resultcache = (resultCacheObj *)malloc(
+        sizeof(resultCacheObj)); /* allocate and initialize the result cache */
     MS_CHECK_ALLOC(lp->resultcache, sizeof(resultCacheObj), MS_FAILURE);
-    initResultCache( lp->resultcache);
+    initResultCache(lp->resultcache);
 
     nclasses = 0;
     if (lp->classgroup && lp->numclasses > 0)
@@ -2037,115 +2298,136 @@ int msQueryByShape(mapObj *map)
     if (lp->minfeaturesize > 0)
       minfeaturesize = Pix2LayerGeoref(map, lp, lp->minfeaturesize);
 
-    while((status = msLayerNextShape(lp, &shape)) == MS_SUCCESS) { /* step through the shapes */
+    while ((status = msLayerNextShape(lp, &shape)) ==
+           MS_SUCCESS) { /* step through the shapes */
 
       /* Check if the shape size is ok to be drawn */
-      if ( (shape.type == MS_SHAPE_LINE || shape.type == MS_SHAPE_POLYGON) && (minfeaturesize > 0) ) {
+      if ((shape.type == MS_SHAPE_LINE || shape.type == MS_SHAPE_POLYGON) &&
+          (minfeaturesize > 0)) {
         if (msShapeCheckSize(&shape, minfeaturesize) == MS_FALSE) {
-          if( lp->debug >= MS_DEBUGLEVEL_V )
-            msDebug("msQueryByShape(): Skipping shape (%ld) because LAYER::MINFEATURESIZE is bigger than shape size\n", shape.index);
+          if (lp->debug >= MS_DEBUGLEVEL_V)
+            msDebug("msQueryByShape(): Skipping shape (%ld) because "
+                    "LAYER::MINFEATURESIZE is bigger than shape size\n",
+                    shape.index);
           msFreeShape(&shape);
           continue;
         }
       }
 
       shape.classindex = msShapeGetClass(lp, map, &shape, classgroup, nclasses);
-      if(!(lp->template) && ((shape.classindex == -1) || (lp->class[shape.classindex]->status == MS_OFF))) { /* not a valid shape */
+      if (!(lp->template) && ((shape.classindex == -1) ||
+                              (lp->class[shape.classindex]
+                               -> status == MS_OFF))) { /* not a valid shape */
         msFreeShape(&shape);
         continue;
       }
 
-      if(!(lp->template) && !(lp->class[shape.classindex]->template)) { /* no valid template */
+      if (!(lp->template) &&
+          !(lp->class[shape.classindex] -> template)) { /* no valid template */
         msFreeShape(&shape);
         continue;
       }
 
-      if(lp->project) {
-        if( reprojector == NULL ) {
-            reprojector = msProjectCreateReprojector(&(lp->projection), &(map->projection));
-            if( reprojector == NULL ) {
-              msFreeShape(&shape);
-              status = MS_FAILURE;
-              break;
-            }
+      if (lp->project) {
+        if (reprojector == NULL) {
+          reprojector =
+              msProjectCreateReprojector(&(lp->projection), &(map->projection));
+          if (reprojector == NULL) {
+            msFreeShape(&shape);
+            status = MS_FAILURE;
+            break;
+          }
         }
         msProjectShapeEx(reprojector, &shape);
       }
 
-      switch(qshape->type) { /* may eventually support types other than polygon or line */
-        case MS_SHAPE_POLYGON:
-          switch(shape.type) { /* make sure shape actually intersects the shape */
-            case MS_SHAPE_POINT:
-              if(tolerance == 0) /* just test for intersection */
-                status = msIntersectMultipointPolygon(&shape, qshape);
-              else { /* check distance, distance=0 means they intersect */
-                distance = msDistanceShapeToShape(qshape, &shape);
-                if(distance < tolerance) status = MS_TRUE;
-              }
-              break;
-            case MS_SHAPE_LINE:
-              if(tolerance == 0) { /* just test for intersection */
-                status = msIntersectPolylinePolygon(&shape, qshape);
-              } else { /* check distance, distance=0 means they intersect */
-                distance = msDistanceShapeToShape(qshape, &shape);
-                if(distance < tolerance) status = MS_TRUE;
-              }
-              break;
-            case MS_SHAPE_POLYGON:
-              if(tolerance == 0) /* just test for intersection */
-                status = msIntersectPolygons(&shape, qshape);
-              else { /* check distance, distance=0 means they intersect */
-                distance = msDistanceShapeToShape(qshape, &shape);
-                if(distance < tolerance) status = MS_TRUE;
-              }
-              break;
-            default:
-              break;
+      switch (qshape->type) { /* may eventually support types other than polygon
+                                 or line */
+      case MS_SHAPE_POLYGON:
+        switch (
+            shape.type) { /* make sure shape actually intersects the shape */
+        case MS_SHAPE_POINT:
+          if (tolerance == 0) /* just test for intersection */
+            status = msIntersectMultipointPolygon(&shape, qshape);
+          else { /* check distance, distance=0 means they intersect */
+            distance = msDistanceShapeToShape(qshape, &shape);
+            if (distance < tolerance)
+              status = MS_TRUE;
           }
           break;
         case MS_SHAPE_LINE:
-          switch(shape.type) { /* make sure shape actually intersects the selectshape */
-            case MS_SHAPE_POINT:
-              if(tolerance == 0) { /* just test for intersection */
-                distance = msDistanceShapeToShape(qshape, &shape);
-                if(distance == 0) status = MS_TRUE;
-              } else {
-                distance = msDistanceShapeToShape(qshape, &shape);
-                if(distance < tolerance) status = MS_TRUE;
-              }
-              break;
-            case MS_SHAPE_LINE:
-              if(tolerance == 0) { /* just test for intersection */
-                status = msIntersectPolylines(&shape, qshape);
-              } else { /* check distance, distance=0 means they intersect */
-                distance = msDistanceShapeToShape(qshape, &shape);
-                if(distance < tolerance) status = MS_TRUE;
-              }
-              break;
-            case MS_SHAPE_POLYGON:
-              if(tolerance == 0) /* just test for intersection */
-                status = msIntersectPolylinePolygon(qshape, &shape);
-              else { /* check distance, distance=0 means they intersect */
-                distance = msDistanceShapeToShape(qshape, &shape);
-                if(distance < tolerance) status = MS_TRUE;
-              }
-              break;
-            default:
-              status = MS_FALSE;
-              break;
+          if (tolerance == 0) { /* just test for intersection */
+            status = msIntersectPolylinePolygon(&shape, qshape);
+          } else { /* check distance, distance=0 means they intersect */
+            distance = msDistanceShapeToShape(qshape, &shape);
+            if (distance < tolerance)
+              status = MS_TRUE;
+          }
+          break;
+        case MS_SHAPE_POLYGON:
+          if (tolerance == 0) /* just test for intersection */
+            status = msIntersectPolygons(&shape, qshape);
+          else { /* check distance, distance=0 means they intersect */
+            distance = msDistanceShapeToShape(qshape, &shape);
+            if (distance < tolerance)
+              status = MS_TRUE;
           }
           break;
+        default:
+          break;
+        }
+        break;
+      case MS_SHAPE_LINE:
+        switch (shape.type) { /* make sure shape actually intersects the
+                                 selectshape */
         case MS_SHAPE_POINT:
-          distance = msDistanceShapeToShape(qshape, &shape);
-          status = MS_FALSE;
-          if(tolerance == 0 && distance == 0) status = MS_TRUE; /* shapes intersect */
-          else if(distance < tolerance) status = MS_TRUE; /* shapes are close enough */
+          if (tolerance == 0) { /* just test for intersection */
+            distance = msDistanceShapeToShape(qshape, &shape);
+            if (distance == 0)
+              status = MS_TRUE;
+          } else {
+            distance = msDistanceShapeToShape(qshape, &shape);
+            if (distance < tolerance)
+              status = MS_TRUE;
+          }
+          break;
+        case MS_SHAPE_LINE:
+          if (tolerance == 0) { /* just test for intersection */
+            status = msIntersectPolylines(&shape, qshape);
+          } else { /* check distance, distance=0 means they intersect */
+            distance = msDistanceShapeToShape(qshape, &shape);
+            if (distance < tolerance)
+              status = MS_TRUE;
+          }
+          break;
+        case MS_SHAPE_POLYGON:
+          if (tolerance == 0) /* just test for intersection */
+            status = msIntersectPolylinePolygon(qshape, &shape);
+          else { /* check distance, distance=0 means they intersect */
+            distance = msDistanceShapeToShape(qshape, &shape);
+            if (distance < tolerance)
+              status = MS_TRUE;
+          }
           break;
         default:
-          break; /* should never get here as we test for selection shape type explicitly earlier */
+          status = MS_FALSE;
+          break;
+        }
+        break;
+      case MS_SHAPE_POINT:
+        distance = msDistanceShapeToShape(qshape, &shape);
+        status = MS_FALSE;
+        if (tolerance == 0 && distance == 0)
+          status = MS_TRUE; /* shapes intersect */
+        else if (distance < tolerance)
+          status = MS_TRUE; /* shapes are close enough */
+        break;
+      default:
+        break; /* should never get here as we test for selection shape type
+                  explicitly earlier */
       }
 
-      if(status == MS_TRUE) {
+      if (status == MS_TRUE) {
         /* Should we skip this feature? */
         if (!msLayerGetPaging(lp) && map->query.startindex > 1) {
           --map->query.startindex;
@@ -2157,7 +2439,8 @@ int msQueryByShape(mapObj *map)
       msFreeShape(&shape);
 
       /* check shape count */
-      if(lp->maxfeatures > 0 && lp->maxfeatures == lp->resultcache->numresults) {
+      if (lp->maxfeatures > 0 &&
+          lp->maxfeatures == lp->resultcache->numresults) {
         status = MS_DONE;
         break;
       }
@@ -2168,23 +2451,25 @@ int msQueryByShape(mapObj *map)
 
     msProjectDestroyReprojector(reprojector);
 
-    if(status != MS_DONE) {
-      return(MS_FAILURE);
+    if (status != MS_DONE) {
+      return (MS_FAILURE);
     }
 
-    if(lp->resultcache->numresults == 0) msLayerClose(lp); /* no need to keep the layer open */
-  } /* next layer */
+    if (lp->resultcache->numresults == 0)
+      msLayerClose(lp); /* no need to keep the layer open */
+  }                     /* next layer */
 
   /* was anything found? */
-  for(l=start; l>=stop; l--) {
-    if(GET_LAYER(map, l)->resultcache && GET_LAYER(map, l)->resultcache->numresults > 0)
-      return(MS_SUCCESS);
+  for (l = start; l >= stop; l--) {
+    if (GET_LAYER(map, l)->resultcache &&
+        GET_LAYER(map, l)->resultcache->numresults > 0)
+      return (MS_SUCCESS);
   }
 
   if (map->debug >= MS_DEBUGLEVEL_V) {
-      msDebug("msQueryByShape(): No matching record(s) found.");
+    msDebug("msQueryByShape(): No matching record(s) found.");
   }
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
 /* msGetQueryResultBounds()
@@ -2193,22 +2478,23 @@ int msQueryByShape(mapObj *map)
  * that contained query results and were included in the BBOX.
  * i.e. if we return 0 then the value in bounds is invalid.
  */
-int msGetQueryResultBounds(mapObj *map, rectObj *bounds)
-{
-  int i, found=0;
+int msGetQueryResultBounds(mapObj *map, rectObj *bounds) {
+  int i, found = 0;
   rectObj tmpBounds;
 
-  for(i=0; i<map->numlayers; i++) {
+  for (i = 0; i < map->numlayers; i++) {
 
     layerObj *lp;
     lp = (GET_LAYER(map, i));
 
-    if(!lp->resultcache) continue;
-    if(lp->resultcache->numresults <= 0) continue;
+    if (!lp->resultcache)
+      continue;
+    if (lp->resultcache->numresults <= 0)
+      continue;
 
     tmpBounds = lp->resultcache->bounds;
 
-    if(found == 0) {
+    if (found == 0) {
       *bounds = tmpBounds;
     } else {
       msMergeRect(bounds, &tmpBounds);
@@ -2225,22 +2511,21 @@ int msGetQueryResultBounds(mapObj *map,
  *
  * Free layer's query results. If qlayer == -1, all layers will be treated.
  */
-void msQueryFree(mapObj *map, int qlayer)
-{
+void msQueryFree(mapObj *map, int qlayer) {
   int l; /* counters */
-  int start, stop=0;
+  int start, stop = 0;
   layerObj *lp;
 
-  if(qlayer < 0 || qlayer >= map->numlayers)
-    start = map->numlayers-1;
+  if (qlayer < 0 || qlayer >= map->numlayers)
+    start = map->numlayers - 1;
   else
     start = stop = qlayer;
 
-  for(l=start; l>=stop; l--) {
+  for (l = start; l >= stop; l--) {
     lp = (GET_LAYER(map, l));
 
-    if(lp->resultcache) {
-      if(lp->resultcache->results)
+    if (lp->resultcache) {
+      if (lp->resultcache->results)
         free(lp->resultcache->results);
       free(lp->resultcache);
       lp->resultcache = NULL;
diff -pruN 8.0.1-5/mapraster.c 8.0.2-1/mapraster.c
--- 8.0.1-5/mapraster.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapraster.c	2024-06-11 20:41:34.000000000 +0000
@@ -35,8 +35,6 @@
 #include "mapresample.h"
 #include "mapthread.h"
 
-
-
 extern int msyylex_destroy(void);
 extern int yyparse(parseObj *);
 
@@ -58,37 +56,36 @@ extern parseResultObj yypresult; /* resu
 /*                         msGetClass_String()                          */
 /************************************************************************/
 
-static int msGetClass_String( layerObj *layer, colorObj *color, const char *pixel_value, int firstClassToTry )
+static int msGetClass_String(layerObj *layer, colorObj *color,
+                             const char *pixel_value, int firstClassToTry)
 
 {
   int i;
-  const char *tmpstr1=NULL;
+  const char *tmpstr1 = NULL;
   int numitems;
-  char *item_names[4] = { "pixel", "red", "green", "blue" };
+  char *item_names[4] = {"pixel", "red", "green", "blue"};
   char *item_values[4];
   char red_value[8], green_value[8], blue_value[8];
 
   /* -------------------------------------------------------------------- */
   /*      No need to do a lookup in the case of one default class.        */
   /* -------------------------------------------------------------------- */
-  if((layer->numclasses == 1) && !(layer->class[0]->expression.string)) /* no need to do lookup */
-    return(0);
+  if ((layer->numclasses == 1) &&
+      !(layer->class[0] -> expression.string)) /* no need to do lookup */
+    return (0);
 
   /* -------------------------------------------------------------------- */
   /*      Setup values list for expressions.                              */
   /* -------------------------------------------------------------------- */
   numitems = 4;
-  if( color->red == -1 && color->green == -1 && color->blue == -1 )
-  {
+  if (color->red == -1 && color->green == -1 && color->blue == -1) {
     strcpy(red_value, "-1");
     strcpy(green_value, "-1");
     strcpy(blue_value, "-1");
-  }
-  else
-  {
-    sprintf( red_value, "%d", color->red );
-    sprintf( green_value, "%d", color->green );
-    sprintf( blue_value, "%d", color->blue );
+  } else {
+    sprintf(red_value, "%d", color->red);
+    sprintf(green_value, "%d", color->green);
+    sprintf(blue_value, "%d", color->blue);
   }
 
   item_values[0] = (char *)pixel_value;
@@ -99,101 +96,109 @@ static int msGetClass_String( layerObj *
   /* -------------------------------------------------------------------- */
   /*      Loop over classes till we find a match.                         */
   /* -------------------------------------------------------------------- */
-  if( firstClassToTry >= layer->numclasses )
-      firstClassToTry = -1;
-  for(i=0; i<layer->numclasses; i++) {
-
-    const int idx = firstClassToTry < 0 ? i :
-                    i == 0 ? firstClassToTry :
-                    i <= firstClassToTry ? i - 1:
-                    i;
+  if (firstClassToTry >= layer->numclasses)
+    firstClassToTry = -1;
+  for (i = 0; i < layer->numclasses; i++) {
+
+    const int idx = firstClassToTry < 0    ? i
+                    : i == 0               ? firstClassToTry
+                    : i <= firstClassToTry ? i - 1
+                                           : i;
 
     /* check for correct classgroup, if set */
-    if ( layer->class[idx]->group && layer->classgroup &&
-         strcasecmp(layer->class[idx]->group, layer->classgroup) != 0 )
+    if (layer->class[idx] -> group && layer -> classgroup &&strcasecmp(
+                                                   layer->class[idx] -> group,
+                                                   layer -> classgroup) != 0)
       continue;
 
     /* Empty expression - always matches */
-    if (layer->class[idx]->expression.string == NULL)
-      return(i);
+    if (layer->class[idx] -> expression.string == NULL)
+      return (i);
 
-    switch(layer->class[idx]->expression.type) {
+    switch (layer->class[idx] -> expression.type) {
 
-        /* -------------------------------------------------------------------- */
-        /*      Simple string match                                             */
-        /* -------------------------------------------------------------------- */
-      case(MS_STRING):
-        /* trim junk white space */
-        tmpstr1= pixel_value;
-        while( *tmpstr1 == ' ' )
-          tmpstr1++;
+      /* -------------------------------------------------------------------- */
+      /*      Simple string match                                             */
+      /* -------------------------------------------------------------------- */
+    case (MS_STRING):
+      /* trim junk white space */
+      tmpstr1 = pixel_value;
+      while (*tmpstr1 == ' ')
+        tmpstr1++;
 
-        if(strcmp(layer->class[idx]->expression.string, tmpstr1) == 0) return(idx); /* matched */
-        break;
+      if (strcmp(layer->class[idx] -> expression.string, tmpstr1) == 0)
+        return (idx); /* matched */
+      break;
 
-        /* -------------------------------------------------------------------- */
-        /*      Regular expression.  Rarely used for raster.                    */
-        /* -------------------------------------------------------------------- */
-      case(MS_REGEX):
-        if(!layer->class[idx]->expression.compiled) {
-          if(ms_regcomp(&(layer->class[idx]->expression.regex), layer->class[idx]->expression.string, MS_REG_EXTENDED|MS_REG_NOSUB) != 0) { /* compile the expression  */
-            msSetError(MS_REGEXERR, "Invalid regular expression.", "msGetClass()");
-            return(-1);
-          }
-          layer->class[idx]->expression.compiled = MS_TRUE;
+      /* -------------------------------------------------------------------- */
+      /*      Regular expression.  Rarely used for raster.                    */
+      /* -------------------------------------------------------------------- */
+    case (MS_REGEX):
+      if (!layer->class[idx] -> expression.compiled) {
+        if (ms_regcomp(&(layer->class[idx] -> expression.regex),
+                       layer->class[idx] -> expression.string,
+                       MS_REG_EXTENDED | MS_REG_NOSUB) !=
+            0) { /* compile the expression  */
+          msSetError(MS_REGEXERR, "Invalid regular expression.",
+                     "msGetClass()");
+          return (-1);
         }
+        layer->class[idx]->expression.compiled = MS_TRUE;
+      }
 
-        if(ms_regexec(&(layer->class[idx]->expression.regex), pixel_value, 0, NULL, 0) == 0) return(idx); /* got a match */
-        break;
+      if (ms_regexec(&(layer->class[idx] -> expression.regex), pixel_value, 0,
+                     NULL, 0) == 0)
+        return (idx); /* got a match */
+      break;
 
-        /* -------------------------------------------------------------------- */
-        /*      Parsed expression.                                              */
-        /* -------------------------------------------------------------------- */
-      case(MS_EXPRESSION): {
-        int status;
-        parseObj p;
-        shapeObj dummy_shape;
-        expressionObj *expression = &(layer->class[idx]->expression);
-
-        dummy_shape.numvalues = numitems;
-        dummy_shape.values = item_values;
-
-        if( expression->tokens == NULL )
-          msTokenizeExpression( expression, item_names, &numitems );
-
-        p.shape = &dummy_shape;
-        p.expr = expression;
-        p.expr->curtoken = p.expr->tokens; /* reset */
-        p.type = MS_PARSE_TYPE_BOOLEAN;
-
-        status = yyparse(&p);
-
-        if (status != 0) {
-          msSetError(MS_PARSEERR, "Failed to parse expression: %s", "msGetClass_FloatRGB", expression->string);
-          return -1;
-        }
+      /* -------------------------------------------------------------------- */
+      /*      Parsed expression.                                              */
+      /* -------------------------------------------------------------------- */
+    case (MS_EXPRESSION): {
+      int status;
+      parseObj p;
+      shapeObj dummy_shape;
+      expressionObj *expression = &(layer->class[idx] -> expression);
 
-        if( p.result.intval )
-          return idx;
-        break;
+      dummy_shape.numvalues = numitems;
+      dummy_shape.values = item_values;
+
+      if (expression->tokens == NULL)
+        msTokenizeExpression(expression, item_names, &numitems);
+
+      p.shape = &dummy_shape;
+      p.expr = expression;
+      p.expr->curtoken = p.expr->tokens; /* reset */
+      p.type = MS_PARSE_TYPE_BOOLEAN;
+
+      status = yyparse(&p);
+
+      if (status != 0) {
+        msSetError(MS_PARSEERR, "Failed to parse expression: %s",
+                   "msGetClass_FloatRGB", expression->string);
+        return -1;
       }
+
+      if (p.result.intval)
+        return idx;
+      break;
+    }
     }
   }
 
-  return(-1); /* not found */
+  return (-1); /* not found */
 }
 
 /************************************************************************/
 /*                             msGetClass()                             */
 /************************************************************************/
 
-int msGetClass(layerObj *layer, colorObj *color, int colormap_index)
-{
+int msGetClass(layerObj *layer, colorObj *color, int colormap_index) {
   char pixel_value[12];
 
-  snprintf( pixel_value, sizeof(pixel_value), "%d", colormap_index );
+  snprintf(pixel_value, sizeof(pixel_value), "%d", colormap_index);
 
-  return msGetClass_String( layer, color, pixel_value, -1 );
+  return msGetClass_String(layer, color, pixel_value, -1);
 }
 
 /************************************************************************/
@@ -203,15 +208,15 @@ int msGetClass(layerObj *layer, colorObj
 /*      pixel value.                                                    */
 /************************************************************************/
 
-int msGetClass_FloatRGB(layerObj *layer, float fValue, int red, int green, int blue )
-{
-    return msGetClass_FloatRGB_WithFirstClassToTry(
-                layer, fValue, red, green, blue, -1);
+int msGetClass_FloatRGB(layerObj *layer, float fValue, int red, int green,
+                        int blue) {
+  return msGetClass_FloatRGB_WithFirstClassToTry(layer, fValue, red, green,
+                                                 blue, -1);
 }
 
-
-int msGetClass_FloatRGB_WithFirstClassToTry(layerObj *layer, float fValue, int red, int green, int blue, int firstClassToTry )
-{
+int msGetClass_FloatRGB_WithFirstClassToTry(layerObj *layer, float fValue,
+                                            int red, int green, int blue,
+                                            int firstClassToTry) {
   char pixel_value[100];
   colorObj color;
 
@@ -219,9 +224,9 @@ int msGetClass_FloatRGB_WithFirstClassTo
   color.green = green;
   color.blue = blue;
 
-  snprintf( pixel_value, sizeof(pixel_value), "%18g", fValue );
+  snprintf(pixel_value, sizeof(pixel_value), "%18g", fValue);
 
-  return msGetClass_String( layer, &color, pixel_value, firstClassToTry );
+  return msGetClass_String(layer, &color, pixel_value, firstClassToTry);
 }
 
 /************************************************************************/
@@ -231,142 +236,140 @@ int msGetClass_FloatRGB_WithFirstClassTo
 /************************************************************************/
 
 int msDrawRasterSetupTileLayer(mapObj *map, layerObj *layer,
-                               rectObj* psearchrect,
-                               int is_query,
-                               int* ptilelayerindex, /* output */
-                               int* ptileitemindex, /* output */
-                               int* ptilesrsindex, /* output */
-                               layerObj **ptlp  /* output */ )
-{
-    int i;
-    char* requested_fields;
-    int status;
-    layerObj* tlp = NULL;
-
-    *ptilelayerindex = msGetLayerIndex(layer->map, layer->tileindex);
-    if(*ptilelayerindex == -1) { /* the tileindex references a file, not a layer */
-
-      /* so we create a temporary layer */
-      tlp = (layerObj *) malloc(sizeof(layerObj));
-      MS_CHECK_ALLOC(tlp, sizeof(layerObj), MS_FAILURE);
-
-      initLayer(tlp, map);
-      *ptlp = tlp;
-
-      /* set a few parameters for a very basic shapefile-based layer */
-      tlp->name = msStrdup("TILE");
-      tlp->type = MS_LAYER_TILEINDEX;
-      tlp->data = msStrdup(layer->tileindex);
-
-      if( is_query )
-      {
-        tlp->map = map;  /*needed when scaletokens are applied, to extract current map scale */
-        for(i = 0; i < layer->numscaletokens; i++) {
-          if(msGrowLayerScaletokens(tlp) == NULL) {
-            return MS_FAILURE;
-          }
-          initScaleToken(&tlp->scaletokens[i]);
-          msCopyScaleToken(&layer->scaletokens[i],&tlp->scaletokens[i]);
-          tlp->numscaletokens++;
+                               rectObj *psearchrect, int is_query,
+                               int *ptilelayerindex, /* output */
+                               int *ptileitemindex,  /* output */
+                               int *ptilesrsindex,   /* output */
+                               layerObj **ptlp /* output */) {
+  int i;
+  char *requested_fields;
+  int status;
+  layerObj *tlp = NULL;
+
+  *ptilelayerindex = msGetLayerIndex(layer->map, layer->tileindex);
+  if (*ptilelayerindex ==
+      -1) { /* the tileindex references a file, not a layer */
+
+    /* so we create a temporary layer */
+    tlp = (layerObj *)malloc(sizeof(layerObj));
+    MS_CHECK_ALLOC(tlp, sizeof(layerObj), MS_FAILURE);
+
+    initLayer(tlp, map);
+    *ptlp = tlp;
+
+    /* set a few parameters for a very basic shapefile-based layer */
+    tlp->name = msStrdup("TILE");
+    tlp->type = MS_LAYER_TILEINDEX;
+    tlp->data = msStrdup(layer->tileindex);
+
+    if (is_query) {
+      tlp->map = map; /*needed when scaletokens are applied, to extract current
+                         map scale */
+      for (i = 0; i < layer->numscaletokens; i++) {
+        if (msGrowLayerScaletokens(tlp) == NULL) {
+          return MS_FAILURE;
         }
+        initScaleToken(&tlp->scaletokens[i]);
+        msCopyScaleToken(&layer->scaletokens[i], &tlp->scaletokens[i]);
+        tlp->numscaletokens++;
       }
+    }
 
-      if (layer->projection.numargs > 0 &&
-        EQUAL(layer->projection.args[0], "auto"))
-      {
-          tlp->projection.numargs = 1;
-          tlp->projection.args[0] = msStrdup("auto");
-      }
-
-      if (layer->filteritem)
-        tlp->filteritem = msStrdup(layer->filteritem);
-      if (layer->filter.string) {
-        if (layer->filter.type == MS_EXPRESSION) {
-          char* pszTmp =
-            (char *)msSmallMalloc(sizeof(char)*(strlen(layer->filter.string)+3));
-          sprintf(pszTmp,"(%s)",layer->filter.string);
-          msLoadExpressionString(&tlp->filter, pszTmp);
-          free(pszTmp);
-        } else if (layer->filter.type == MS_REGEX ||
-                   layer->filter.type == MS_IREGEX) {
-          char* pszTmp =
-            (char *)msSmallMalloc(sizeof(char)*(strlen(layer->filter.string)+3));
-          sprintf(pszTmp,"/%s/",layer->filter.string);
-          msLoadExpressionString(&tlp->filter, pszTmp);
-          free(pszTmp);
-        } else
-          msLoadExpressionString(&tlp->filter, layer->filter.string);
+    if (layer->projection.numargs > 0 &&
+        EQUAL(layer->projection.args[0], "auto")) {
+      tlp->projection.numargs = 1;
+      tlp->projection.args[0] = msStrdup("auto");
+    }
 
-        tlp->filter.type = layer->filter.type;
-      }
+    if (layer->filteritem)
+      tlp->filteritem = msStrdup(layer->filteritem);
+    if (layer->filter.string) {
+      if (layer->filter.type == MS_EXPRESSION) {
+        char *pszTmp = (char *)msSmallMalloc(
+            sizeof(char) * (strlen(layer->filter.string) + 3));
+        sprintf(pszTmp, "(%s)", layer->filter.string);
+        msLoadExpressionString(&tlp->filter, pszTmp);
+        free(pszTmp);
+      } else if (layer->filter.type == MS_REGEX ||
+                 layer->filter.type == MS_IREGEX) {
+        char *pszTmp = (char *)msSmallMalloc(
+            sizeof(char) * (strlen(layer->filter.string) + 3));
+        sprintf(pszTmp, "/%s/", layer->filter.string);
+        msLoadExpressionString(&tlp->filter, pszTmp);
+        free(pszTmp);
+      } else
+        msLoadExpressionString(&tlp->filter, layer->filter.string);
 
-    } else {
-      if ( msCheckParentPointer(layer->map,"map")==MS_FAILURE )
-        return MS_FAILURE;
-      tlp = (GET_LAYER(layer->map, *ptilelayerindex));
-      *ptlp = tlp;
-    }
-    status = msLayerOpen(tlp);
-    if(status != MS_SUCCESS) {
-      return status;
+      tlp->filter.type = layer->filter.type;
     }
 
-    /* fetch tileitem and tilesrs fields */
-    requested_fields = (char*) msSmallMalloc(sizeof(char)*(strlen(layer->tileitem)+1+
-                                    (layer->tilesrs ? strlen(layer->tilesrs) : 0) + 1));
-    if( layer->tilesrs != NULL )
-        sprintf(requested_fields, "%s,%s", layer->tileitem, layer->tilesrs);
-    else
-        strcpy(requested_fields, layer->tileitem);
-    status = msLayerWhichItems(tlp, MS_FALSE, requested_fields);
-    msFree(requested_fields);
-    if(status != MS_SUCCESS) {
-      return status;
-    }
+  } else {
+    if (msCheckParentPointer(layer->map, "map") == MS_FAILURE)
+      return MS_FAILURE;
+    tlp = (GET_LAYER(layer->map, *ptilelayerindex));
+    *ptlp = tlp;
+  }
+  status = msLayerOpen(tlp);
+  if (status != MS_SUCCESS) {
+    return status;
+  }
 
-    /* get the tileitem and tilesrs index */
-    for(i=0; i<tlp->numitems; i++) {
-      if(strcasecmp(tlp->items[i], layer->tileitem) == 0) {
-        *ptileitemindex = i;
-      }
-      if(layer->tilesrs != NULL &&
-         strcasecmp(tlp->items[i], layer->tilesrs) == 0) {
-        *ptilesrsindex = i;
-      }
+  /* fetch tileitem and tilesrs fields */
+  requested_fields = (char *)msSmallMalloc(
+      sizeof(char) * (strlen(layer->tileitem) + 1 +
+                      (layer->tilesrs ? strlen(layer->tilesrs) : 0) + 1));
+  if (layer->tilesrs != NULL)
+    sprintf(requested_fields, "%s,%s", layer->tileitem, layer->tilesrs);
+  else
+    strcpy(requested_fields, layer->tileitem);
+  status = msLayerWhichItems(tlp, MS_FALSE, requested_fields);
+  msFree(requested_fields);
+  if (status != MS_SUCCESS) {
+    return status;
+  }
+
+  /* get the tileitem and tilesrs index */
+  for (i = 0; i < tlp->numitems; i++) {
+    if (strcasecmp(tlp->items[i], layer->tileitem) == 0) {
+      *ptileitemindex = i;
+    }
+    if (layer->tilesrs != NULL &&
+        strcasecmp(tlp->items[i], layer->tilesrs) == 0) {
+      *ptilesrsindex = i;
     }
-    if(*ptileitemindex < 0) { /* didn't find it */
-      msSetError(MS_MEMERR,
-                 "Could not find attribute %s in tileindex.",
-                 "msDrawRasterLayerLow()",
-                 layer->tileitem);
+  }
+  if (*ptileitemindex < 0) { /* didn't find it */
+    msSetError(MS_MEMERR, "Could not find attribute %s in tileindex.",
+               "msDrawRasterLayerLow()", layer->tileitem);
+    return MS_FAILURE;
+  }
+  if (layer->tilesrs != NULL && *ptilesrsindex < 0) { /* didn't find it */
+    msSetError(MS_MEMERR, "Could not find attribute %s in tileindex.",
+               "msDrawRasterLayerLow()", layer->tilesrs);
+    return MS_FAILURE;
+  }
+
+  /* if necessary, project the searchrect to source coords */
+  if ((map->projection.numargs > 0) && (layer->projection.numargs > 0) &&
+      !EQUAL(layer->projection.args[0], "auto")) {
+    if (msProjectRect(&map->projection, &layer->projection, psearchrect) !=
+        MS_SUCCESS) {
+      msDebug("msDrawRasterLayerLow(%s): unable to reproject map request "
+              "rectangle into layer projection, canceling.\n",
+              layer->name);
       return MS_FAILURE;
     }
-    if(layer->tilesrs != NULL && *ptilesrsindex < 0) { /* didn't find it */
-      msSetError(MS_MEMERR,
-                 "Could not find attribute %s in tileindex.",
-                 "msDrawRasterLayerLow()",
-                 layer->tilesrs);
+  } else if ((map->projection.numargs > 0) && (tlp->projection.numargs > 0) &&
+             !EQUAL(tlp->projection.args[0], "auto")) {
+    if (msProjectRect(&map->projection, &tlp->projection, psearchrect) !=
+        MS_SUCCESS) {
+      msDebug("msDrawRasterLayerLow(%s): unable to reproject map request "
+              "rectangle into layer projection, canceling.\n",
+              layer->name);
       return MS_FAILURE;
     }
-
-    /* if necessary, project the searchrect to source coords */
-    if((map->projection.numargs > 0) && (layer->projection.numargs > 0) &&
-        !EQUAL(layer->projection.args[0], "auto")) {
-      if( msProjectRect(&map->projection, &layer->projection, psearchrect)
-          != MS_SUCCESS ) {
-        msDebug( "msDrawRasterLayerLow(%s): unable to reproject map request rectangle into layer projection, canceling.\n", layer->name );
-        return MS_FAILURE;
-      }
-    }
-    else if((map->projection.numargs > 0) && (tlp->projection.numargs > 0) &&
-        !EQUAL(tlp->projection.args[0], "auto")) {
-      if( msProjectRect(&map->projection, &tlp->projection, psearchrect)
-          != MS_SUCCESS ) {
-        msDebug( "msDrawRasterLayerLow(%s): unable to reproject map request rectangle into layer projection, canceling.\n", layer->name );
-        return MS_FAILURE;
-      }
-    }
-    return msLayerWhichShapes(tlp, *psearchrect, MS_FALSE);
+  }
+  return msLayerWhichShapes(tlp, *psearchrect, MS_FALSE);
 }
 
 /************************************************************************/
@@ -375,14 +378,12 @@ int msDrawRasterSetupTileLayer(mapObj *m
 /*      Cleanup the tile layer.                                         */
 /************************************************************************/
 
-void msDrawRasterCleanupTileLayer(layerObj* tlp,
-                                  int tilelayerindex)
-{
-    msLayerClose(tlp);
-    if(tilelayerindex == -1) {
-      freeLayer(tlp);
-      free(tlp);
-    }
+void msDrawRasterCleanupTileLayer(layerObj *tlp, int tilelayerindex) {
+  msLayerClose(tlp);
+  if (tilelayerindex == -1) {
+    freeLayer(tlp);
+    free(tlp);
+  }
 }
 
 /************************************************************************/
@@ -391,39 +392,38 @@ void msDrawRasterCleanupTileLayer(layerO
 /*      Iterate over the tile layer.                                    */
 /************************************************************************/
 
-int msDrawRasterIterateTileIndex(layerObj *layer,
-                                 layerObj* tlp,
-                                 shapeObj* ptshp, /* input-output */
-                                 int tileitemindex,
-                                 int tilesrsindex,
-                                 char* tilename, /* output */
+int msDrawRasterIterateTileIndex(layerObj *layer, layerObj *tlp,
+                                 shapeObj *ptshp, /* input-output */
+                                 int tileitemindex, int tilesrsindex,
+                                 char *tilename, /* output */
                                  size_t sizeof_tilename,
-                                 char* tilesrsname, /* output */
-                                 size_t sizeof_tilesrsname)
-{
-      int status;
-
-      status = msLayerNextShape(tlp, ptshp);
-      if( status == MS_FAILURE || status == MS_DONE ) {
-        return status;
-      }
-
-      if(layer->data == NULL || strlen(layer->data) == 0 ) { /* assume whole filename is in attribute field */
-        strlcpy( tilename, ptshp->values[tileitemindex], sizeof_tilename);
-      } else
-        snprintf(tilename, sizeof_tilename, "%s/%s", ptshp->values[tileitemindex], layer->data);
-
-      tilesrsname[0] = '\0';
+                                 char *tilesrsname, /* output */
+                                 size_t sizeof_tilesrsname) {
+  int status;
+
+  status = msLayerNextShape(tlp, ptshp);
+  if (status == MS_FAILURE || status == MS_DONE) {
+    return status;
+  }
 
-      if( tilesrsindex >= 0 )
-      {
-        if(ptshp->values[tilesrsindex] != NULL )
-          strlcpy( tilesrsname, ptshp->values[tilesrsindex], sizeof_tilesrsname );
-      }
+  if (layer->data == NULL ||
+      strlen(layer->data) ==
+          0) { /* assume whole filename is in attribute field */
+    strlcpy(tilename, ptshp->values[tileitemindex], sizeof_tilename);
+  } else
+    snprintf(tilename, sizeof_tilename, "%s/%s", ptshp->values[tileitemindex],
+             layer->data);
+
+  tilesrsname[0] = '\0';
+
+  if (tilesrsindex >= 0) {
+    if (ptshp->values[tilesrsindex] != NULL)
+      strlcpy(tilesrsname, ptshp->values[tilesrsindex], sizeof_tilesrsname);
+  }
 
-      msFreeShape(ptshp); /* done with the shape */
+  msFreeShape(ptshp); /* done with the shape */
 
-      return status;
+  return status;
 }
 
 /************************************************************************/
@@ -433,25 +433,26 @@ int msDrawRasterIterateTileIndex(layerOb
 /************************************************************************/
 
 int msDrawRasterBuildRasterPath(mapObj *map, layerObj *layer,
-                                const char* filename,
-                                char szPath[MS_MAXPATHLEN] /* output */)
-{
-    /*
-    ** If using a tileindex then build the path relative to that file if SHAPEPATH is not set.
-    */
-    if(layer->tileindex && !map->shapepath) {
-      char tiAbsFilePath[MS_MAXPATHLEN];
-      char *tiAbsDirPath = NULL;
-
-      msTryBuildPath(tiAbsFilePath, map->mappath, layer->tileindex); /* absolute path to tileindex file */
-      tiAbsDirPath = msGetPath(tiAbsFilePath); /* tileindex file's directory */
-      msBuildPath(szPath, tiAbsDirPath, filename);
-      free(tiAbsDirPath);
-    } else {
-      msTryBuildPath3(szPath, map->mappath, map->shapepath, filename);
-    }
+                                const char *filename,
+                                char szPath[MS_MAXPATHLEN] /* output */) {
+  /*
+  ** If using a tileindex then build the path relative to that file if SHAPEPATH
+  *is not set.
+  */
+  if (layer->tileindex && !map->shapepath) {
+    char tiAbsFilePath[MS_MAXPATHLEN];
+    char *tiAbsDirPath = NULL;
+
+    msTryBuildPath(tiAbsFilePath, map->mappath,
+                   layer->tileindex); /* absolute path to tileindex file */
+    tiAbsDirPath = msGetPath(tiAbsFilePath); /* tileindex file's directory */
+    msBuildPath(szPath, tiAbsDirPath, filename);
+    free(tiAbsDirPath);
+  } else {
+    msTryBuildPath3(szPath, map->mappath, map->shapepath, filename);
+  }
 
-    return MS_SUCCESS;
+  return MS_SUCCESS;
 }
 
 /************************************************************************/
@@ -460,27 +461,25 @@ int msDrawRasterBuildRasterPath(mapObj *
 /*      Return the CPL error message, and filter out sensitive info.    */
 /************************************************************************/
 
-const char* msDrawRasterGetCPLErrorMsg(const char* decrypted_path,
-                                       const char* szPath)
-{
-      const char *cpl_error_msg = CPLGetLastErrorMsg();
-
-      /* we wish to avoid reporting decrypted paths */
-      if( cpl_error_msg != NULL
-          && strstr(cpl_error_msg,decrypted_path) != NULL
-          && strcmp(decrypted_path,szPath) != 0 )
-        cpl_error_msg = NULL;
-
-      /* we wish to avoid reporting the stock GDALOpen error messages */
-      if( cpl_error_msg != NULL
-          && (strstr(cpl_error_msg,"not recognised as a supported") != NULL
-              || strstr(cpl_error_msg,"does not exist") != NULL) )
-        cpl_error_msg = NULL;
+const char *msDrawRasterGetCPLErrorMsg(const char *decrypted_path,
+                                       const char *szPath) {
+  const char *cpl_error_msg = CPLGetLastErrorMsg();
+
+  /* we wish to avoid reporting decrypted paths */
+  if (cpl_error_msg != NULL && strstr(cpl_error_msg, decrypted_path) != NULL &&
+      strcmp(decrypted_path, szPath) != 0)
+    cpl_error_msg = NULL;
+
+  /* we wish to avoid reporting the stock GDALOpen error messages */
+  if (cpl_error_msg != NULL &&
+      (strstr(cpl_error_msg, "not recognised as a supported") != NULL ||
+       strstr(cpl_error_msg, "does not exist") != NULL))
+    cpl_error_msg = NULL;
 
-      if( cpl_error_msg == NULL )
-        cpl_error_msg = "";
+  if (cpl_error_msg == NULL)
+    cpl_error_msg = "";
 
-      return cpl_error_msg;
+  return cpl_error_msg;
 }
 
 /************************************************************************/
@@ -489,175 +488,164 @@ const char* msDrawRasterGetCPLErrorMsg(c
 /*      Handle TILESRS or PROJECTION AUTO for each tile.                */
 /************************************************************************/
 
-int msDrawRasterLoadProjection(layerObj *layer,
-                               GDALDatasetH hDS,
-                               const char* filename,
-                               int tilesrsindex,
-                               const char* tilesrsname)
-{
-    /*
-    ** Generate the projection information if using TILESRS.
-    */
-    if( tilesrsindex >= 0 )
-    {
-        const char *pszWKT;
-        if( tilesrsname[0] != '\0' )
-            pszWKT = tilesrsname;
-        else
-            pszWKT = GDALGetProjectionRef( hDS );
-        if( pszWKT != NULL && strlen(pszWKT) > 0 ) {
-          if( msOGCWKT2ProjectionObj(pszWKT, &(layer->projection),
-                                    layer->debug ) != MS_SUCCESS ) {
-          char  szLongMsg[MESSAGELENGTH*2];
-          errorObj *ms_error = msGetErrorObj();
-
-          snprintf( szLongMsg, sizeof(szLongMsg),
-                    "%s\n"
-                    "PROJECTION '%s' cannot be used for this "
-                    "GDAL raster (`%s').",
-                    ms_error->message, pszWKT, filename);
-          szLongMsg[MESSAGELENGTH-1] = '\0';
+int msDrawRasterLoadProjection(layerObj *layer, GDALDatasetH hDS,
+                               const char *filename, int tilesrsindex,
+                               const char *tilesrsname) {
+  /*
+  ** Generate the projection information if using TILESRS.
+  */
+  if (tilesrsindex >= 0) {
+    const char *pszWKT;
+    if (tilesrsname[0] != '\0')
+      pszWKT = tilesrsname;
+    else
+      pszWKT = GDALGetProjectionRef(hDS);
+    if (pszWKT != NULL && strlen(pszWKT) > 0) {
+      if (msOGCWKT2ProjectionObj(pszWKT, &(layer->projection), layer->debug) !=
+          MS_SUCCESS) {
+        char szLongMsg[MESSAGELENGTH * 2];
+        errorObj *ms_error = msGetErrorObj();
+
+        snprintf(szLongMsg, sizeof(szLongMsg),
+                 "%s\n"
+                 "PROJECTION '%s' cannot be used for this "
+                 "GDAL raster (`%s').",
+                 ms_error->message, pszWKT, filename);
+        szLongMsg[MESSAGELENGTH - 1] = '\0';
 
-          msSetError(MS_OGRERR, "%s","msDrawRasterLayer()",
-                     szLongMsg);
+        msSetError(MS_OGRERR, "%s", "msDrawRasterLayer()", szLongMsg);
 
-          return MS_FAILURE;
-        }
+        return MS_FAILURE;
       }
     }
-    /*
-    ** Generate the projection information if using AUTO.
-    */
-    else if (layer->projection.numargs > 0 &&
-        EQUAL(layer->projection.args[0], "auto")) {
-      const char *pszWKT;
-
-      pszWKT = GDALGetProjectionRef( hDS );
-
-      if( pszWKT != NULL && strlen(pszWKT) > 0 ) {
-        if( msOGCWKT2ProjectionObj(pszWKT, &(layer->projection),
-                                   layer->debug ) != MS_SUCCESS ) {
-          char  szLongMsg[MESSAGELENGTH*2];
-          errorObj *ms_error = msGetErrorObj();
-
-          snprintf( szLongMsg, sizeof(szLongMsg),
-                    "%s\n"
-                    "PROJECTION AUTO cannot be used for this "
-                    "GDAL raster (`%s').",
-                    ms_error->message, filename);
-          szLongMsg[MESSAGELENGTH-1] = '\0';
+  }
+  /*
+  ** Generate the projection information if using AUTO.
+  */
+  else if (layer->projection.numargs > 0 &&
+           EQUAL(layer->projection.args[0], "auto")) {
+    const char *pszWKT;
+
+    pszWKT = GDALGetProjectionRef(hDS);
+
+    if (pszWKT != NULL && strlen(pszWKT) > 0) {
+      if (msOGCWKT2ProjectionObj(pszWKT, &(layer->projection), layer->debug) !=
+          MS_SUCCESS) {
+        char szLongMsg[MESSAGELENGTH * 2];
+        errorObj *ms_error = msGetErrorObj();
+
+        snprintf(szLongMsg, sizeof(szLongMsg),
+                 "%s\n"
+                 "PROJECTION AUTO cannot be used for this "
+                 "GDAL raster (`%s').",
+                 ms_error->message, filename);
+        szLongMsg[MESSAGELENGTH - 1] = '\0';
 
-          msSetError(MS_OGRERR, "%s","msDrawRasterLayer()",
-                     szLongMsg);
+        msSetError(MS_OGRERR, "%s", "msDrawRasterLayer()", szLongMsg);
 
-          return MS_FAILURE;
-        }
+        return MS_FAILURE;
       }
     }
+  }
 
-    return MS_SUCCESS;
+  return MS_SUCCESS;
 }
 
-typedef enum
-{
-    CDRT_OK,
-    CDRT_RETURN_MS_FAILURE,
-    CDRT_CONTINUE_NEXT_TILE
+typedef enum {
+  CDRT_OK,
+  CDRT_RETURN_MS_FAILURE,
+  CDRT_CONTINUE_NEXT_TILE
 } CheckDatasetReturnType;
 
 /************************************************************************/
 /*              msDrawRasterLayerLowCheckDataset()                      */
 /************************************************************************/
 
-static
-CheckDatasetReturnType msDrawRasterLayerLowCheckDataset(mapObj *map,
-                                     layerObj *layer,
-                                     GDALDatasetH hDS,
-                                     const char* decrypted_path,
-                                     const char* szPath)
-{
-    /*
-    ** If GDAL doesn't recognise it, and it wasn't successfully opened
-    ** Generate an error.
-    */
-    if(hDS == NULL) {
-      int ignore_missing = msMapIgnoreMissingData(map);
-      const char *cpl_error_msg = msDrawRasterGetCPLErrorMsg(decrypted_path, szPath);
-
-      if(ignore_missing == MS_MISSING_DATA_FAIL) {
-        msSetError(MS_IOERR, "Corrupt, empty or missing file '%s' for layer '%s'. %s", "msDrawRasterLayerLow()", szPath, layer->name, cpl_error_msg );
-        return(CDRT_RETURN_MS_FAILURE);
-      } else if( ignore_missing == MS_MISSING_DATA_LOG ) {
-        if( layer->debug || layer->map->debug ) {
-          msDebug( "Corrupt, empty or missing file '%s' for layer '%s' ... ignoring this missing data.  %s\n", szPath, layer->name, cpl_error_msg );
-        }
-        return(CDRT_CONTINUE_NEXT_TILE);
-      } else if( ignore_missing == MS_MISSING_DATA_IGNORE ) {
-        return(CDRT_CONTINUE_NEXT_TILE);
-      } else {
-        /* never get here */
-        msSetError(MS_IOERR, "msIgnoreMissingData returned unexpected value.", "msDrawRasterLayerLow()");
-        return(CDRT_RETURN_MS_FAILURE);
-      }
+static CheckDatasetReturnType
+msDrawRasterLayerLowCheckDataset(mapObj *map, layerObj *layer, GDALDatasetH hDS,
+                                 const char *decrypted_path,
+                                 const char *szPath) {
+  /*
+  ** If GDAL doesn't recognise it, and it wasn't successfully opened
+  ** Generate an error.
+  */
+  if (hDS == NULL) {
+    int ignore_missing = msMapIgnoreMissingData(map);
+    const char *cpl_error_msg =
+        msDrawRasterGetCPLErrorMsg(decrypted_path, szPath);
+
+    if (ignore_missing == MS_MISSING_DATA_FAIL) {
+      msSetError(MS_IOERR,
+                 "Corrupt, empty or missing file '%s' for layer '%s'. %s",
+                 "msDrawRasterLayerLow()", szPath, layer->name, cpl_error_msg);
+      return (CDRT_RETURN_MS_FAILURE);
+    } else if (ignore_missing == MS_MISSING_DATA_LOG) {
+      if (layer->debug || layer->map->debug) {
+        msDebug("Corrupt, empty or missing file '%s' for layer '%s' ... "
+                "ignoring this missing data.  %s\n",
+                szPath, layer->name, cpl_error_msg);
+      }
+      return (CDRT_CONTINUE_NEXT_TILE);
+    } else if (ignore_missing == MS_MISSING_DATA_IGNORE) {
+      return (CDRT_CONTINUE_NEXT_TILE);
+    } else {
+      /* never get here */
+      msSetError(MS_IOERR, "msIgnoreMissingData returned unexpected value.",
+                 "msDrawRasterLayerLow()");
+      return (CDRT_RETURN_MS_FAILURE);
     }
+  }
 
-    return CDRT_OK;
+  return CDRT_OK;
 }
 
 /************************************************************************/
 /*              msDrawRasterLayerLowOpenDataset()                       */
 /************************************************************************/
 
-void* msDrawRasterLayerLowOpenDataset(mapObj *map, layerObj *layer,
-                                      const char* filename,
+void *msDrawRasterLayerLowOpenDataset(mapObj *map, layerObj *layer,
+                                      const char *filename,
                                       char szPath[MS_MAXPATHLEN],
-                                      char** p_decrypted_path)
-{
-  const char* pszPath;
+                                      char **p_decrypted_path) {
+  const char *pszPath;
 
   msGDALInitialize();
 
-  if(layer->debug)
-    msDebug( "msDrawRasterLayerLow(%s): Filename is: %s\n", layer->name, filename);
+  if (layer->debug)
+    msDebug("msDrawRasterLayerLow(%s): Filename is: %s\n", layer->name,
+            filename);
 
-  if( strncmp(filename, "<VRTDataset", strlen("<VRTDataset")) == 0 )
-  {
+  if (strncmp(filename, "<VRTDataset", strlen("<VRTDataset")) == 0) {
     pszPath = filename;
-  }
-  else
-  {
+  } else {
     msDrawRasterBuildRasterPath(map, layer, filename, szPath);
     pszPath = szPath;
   }
-  if(layer->debug)
+  if (layer->debug)
     msDebug("msDrawRasterLayerLow(%s): Path is: %s\n", layer->name, pszPath);
 
-    /*
-    ** Note: because we do decryption after the above path expansion
-    ** which depends on actually finding a file, it essentially means that
-    ** fancy path manipulation is essentially disabled when using encrypted
-    ** components. But that is mostly ok, since stuff like sde,postgres and
-    ** oracle georaster do not use real paths.
-    */
-  *p_decrypted_path = msDecryptStringTokens( map, pszPath );
-  if( *p_decrypted_path == NULL )
+  /*
+  ** Note: because we do decryption after the above path expansion
+  ** which depends on actually finding a file, it essentially means that
+  ** fancy path manipulation is essentially disabled when using encrypted
+  ** components. But that is mostly ok, since stuff like sde,postgres and
+  ** oracle georaster do not use real paths.
+  */
+  *p_decrypted_path = msDecryptStringTokens(map, pszPath);
+  if (*p_decrypted_path == NULL)
     return NULL;
 
-  msAcquireLock( TLOCK_GDAL );
-  if( !layer->tileindex )
-  {
-    char** connectionoptions = msGetStringListFromHashTable(&(layer->connectionoptions));
-    GDALDatasetH hDS = GDALOpenEx( *p_decrypted_path,
-                                   GDAL_OF_RASTER | GDAL_OF_SHARED,
-                                   NULL,
-                                   (const char* const*)connectionoptions,
-                                   NULL);
+  msAcquireLock(TLOCK_GDAL);
+  if (!layer->tileindex) {
+    char **connectionoptions =
+        msGetStringListFromHashTable(&(layer->connectionoptions));
+    GDALDatasetH hDS =
+        GDALOpenEx(*p_decrypted_path, GDAL_OF_RASTER | GDAL_OF_SHARED, NULL,
+                   (const char *const *)connectionoptions, NULL);
     CSLDestroy(connectionoptions);
     return hDS;
-  }
-  else
-  {
-    return GDALOpenShared( *p_decrypted_path, GA_ReadOnly );
+  } else {
+    return GDALOpenShared(*p_decrypted_path, GA_ReadOnly);
   }
 }
 
@@ -665,84 +653,96 @@ void* msDrawRasterLayerLowOpenDataset(ma
 /*                msDrawRasterLayerLowCloseDataset()                    */
 /************************************************************************/
 
-void msDrawRasterLayerLowCloseDataset(layerObj *layer, void* hDS)
-{
-    if( hDS )
+void msDrawRasterLayerLowCloseDataset(layerObj *layer, void *hDS) {
+  if (hDS) {
+    const char *close_connection;
+    close_connection = msLayerGetProcessingKey(layer, "CLOSE_CONNECTION");
+
+    if (close_connection == NULL && layer->tileindex == NULL)
+      close_connection = "DEFER";
+
     {
-      const char *close_connection;
-      close_connection = msLayerGetProcessingKey( layer,
-                       "CLOSE_CONNECTION" );
-
-      if( close_connection == NULL && layer->tileindex == NULL )
-        close_connection = "DEFER";
-
-      {
-        /* Due to how GDAL processes OVERVIEW_LEVEL, datasets returned are */
-        /* not shared, despite being asked to, so close them for real */
-        char** connectionoptions = msGetStringListFromHashTable(&(layer->connectionoptions));
-        if( CSLFetchNameValue(connectionoptions, "OVERVIEW_LEVEL") )
-            close_connection = NULL;
-        CSLDestroy(connectionoptions);
-      }
+      /* Due to how GDAL processes OVERVIEW_LEVEL, datasets returned are */
+      /* not shared, despite being asked to, so close them for real */
+      char **connectionoptions =
+          msGetStringListFromHashTable(&(layer->connectionoptions));
+      if (CSLFetchNameValue(connectionoptions, "OVERVIEW_LEVEL"))
+        close_connection = NULL;
+      CSLDestroy(connectionoptions);
+    }
 
-      if( close_connection != NULL
-          && strcasecmp(close_connection,"DEFER") == 0 ) {
-        GDALDereferenceDataset( (GDALDatasetH)hDS );
-      } else {
-        GDALClose( (GDALDatasetH)hDS );
-      }
-      msReleaseLock( TLOCK_GDAL );
+    if (close_connection != NULL &&
+        strcasecmp(close_connection, "DEFER") == 0) {
+      GDALDereferenceDataset((GDALDatasetH)hDS);
+    } else {
+      GDALClose((GDALDatasetH)hDS);
     }
+    msReleaseLock(TLOCK_GDAL);
+  }
 }
 
-
 /************************************************************************/
 /*                msDrawRasterLayerLowCheckIfMustDraw()                 */
 /*                                                                      */
 /*      Return 1 if the layer should be drawn.                          */
 /************************************************************************/
 
-int msDrawRasterLayerLowCheckIfMustDraw(mapObj *map, layerObj *layer)
-{
-  if(!layer->data && !layer->tileindex && !(layer->connectiontype==MS_KERNELDENSITY || layer->connectiontype==MS_IDW)) {
-    if(layer->debug)
-      msDebug( "msDrawRasterLayerLow(%s): layer data and tileindex NULL ... doing nothing.", layer->name );
-    return(0);
-  }
-
-  if((layer->status != MS_ON) && (layer->status != MS_DEFAULT)) {
-    if(layer->debug)
-      msDebug( "msDrawRasterLayerLow(%s): not status ON or DEFAULT, doing nothing.", layer->name );
-    return(0);
-  }
-
-  if(map->scaledenom > 0) {
-    if((layer->maxscaledenom > 0) && (map->scaledenom > layer->maxscaledenom)) {
-      if(layer->debug)
-        msDebug( "msDrawRasterLayerLow(%s): skipping, map scale %.2g > MAXSCALEDENOM=%g\n",
-                 layer->name, map->scaledenom, layer->maxscaledenom );
-      return(0);
-    }
-    if((layer->minscaledenom > 0) && (map->scaledenom <= layer->minscaledenom)) {
-      if(layer->debug)
-        msDebug( "msDrawRasterLayerLow(%s): skipping, map scale %.2g < MINSCALEDENOM=%g\n",
-                 layer->name, map->scaledenom, layer->minscaledenom );
-      return(0);
+int msDrawRasterLayerLowCheckIfMustDraw(mapObj *map, layerObj *layer) {
+  if (!layer->data && !layer->tileindex &&
+      !(layer->connectiontype == MS_KERNELDENSITY ||
+        layer->connectiontype == MS_IDW)) {
+    if (layer->debug)
+      msDebug("msDrawRasterLayerLow(%s): layer data and tileindex NULL ... "
+              "doing nothing.",
+              layer->name);
+    return (0);
+  }
+
+  if ((layer->status != MS_ON) && (layer->status != MS_DEFAULT)) {
+    if (layer->debug)
+      msDebug(
+          "msDrawRasterLayerLow(%s): not status ON or DEFAULT, doing nothing.",
+          layer->name);
+    return (0);
+  }
+
+  if (map->scaledenom > 0) {
+    if ((layer->maxscaledenom > 0) &&
+        (map->scaledenom > layer->maxscaledenom)) {
+      if (layer->debug)
+        msDebug("msDrawRasterLayerLow(%s): skipping, map scale %.2g > "
+                "MAXSCALEDENOM=%g\n",
+                layer->name, map->scaledenom, layer->maxscaledenom);
+      return (0);
+    }
+    if ((layer->minscaledenom > 0) &&
+        (map->scaledenom <= layer->minscaledenom)) {
+      if (layer->debug)
+        msDebug("msDrawRasterLayerLow(%s): skipping, map scale %.2g < "
+                "MINSCALEDENOM=%g\n",
+                layer->name, map->scaledenom, layer->minscaledenom);
+      return (0);
     }
   }
 
-  if(layer->maxscaledenom <= 0 && layer->minscaledenom <= 0) {
-    if((layer->maxgeowidth > 0) && ((map->extent.maxx - map->extent.minx) > layer->maxgeowidth)) {
-      if(layer->debug)
-        msDebug( "msDrawRasterLayerLow(%s): skipping, map width %.2g > MAXSCALEDENOM=%g\n", layer->name,
-                 (map->extent.maxx - map->extent.minx), layer->maxgeowidth );
-      return(0);
-    }
-    if((layer->mingeowidth > 0) && ((map->extent.maxx - map->extent.minx) < layer->mingeowidth)) {
-      if(layer->debug)
-        msDebug( "msDrawRasterLayerLow(%s): skipping, map width %.2g < MINSCALEDENOM=%g\n", layer->name,
-                 (map->extent.maxx - map->extent.minx), layer->mingeowidth );
-      return(0);
+  if (layer->maxscaledenom <= 0 && layer->minscaledenom <= 0) {
+    if ((layer->maxgeowidth > 0) &&
+        ((map->extent.maxx - map->extent.minx) > layer->maxgeowidth)) {
+      if (layer->debug)
+        msDebug("msDrawRasterLayerLow(%s): skipping, map width %.2g > "
+                "MAXSCALEDENOM=%g\n",
+                layer->name, (map->extent.maxx - map->extent.minx),
+                layer->maxgeowidth);
+      return (0);
+    }
+    if ((layer->mingeowidth > 0) &&
+        ((map->extent.maxx - map->extent.minx) < layer->mingeowidth)) {
+      if (layer->debug)
+        msDebug("msDrawRasterLayerLow(%s): skipping, map width %.2g < "
+                "MINSCALEDENOM=%g\n",
+                layer->name, (map->extent.maxx - map->extent.minx),
+                layer->mingeowidth);
+      return (0);
     }
   }
 
@@ -757,56 +757,50 @@ int msDrawRasterLayerLowCheckIfMustDraw(
 /************************************************************************/
 
 int msDrawRasterLayerLow(mapObj *map, layerObj *layer, imageObj *image,
-                         rasterBufferObj *rb )
-{
-    return msDrawRasterLayerLowWithDataset(map, layer, image, rb, NULL);
+                         rasterBufferObj *rb) {
+  return msDrawRasterLayerLowWithDataset(map, layer, image, rb, NULL);
 }
 
-int msDrawRasterLayerLowWithDataset(mapObj *map, layerObj *layer, imageObj *image,
-                                    rasterBufferObj *rb, void* hDatasetIn )
-{
+int msDrawRasterLayerLowWithDataset(mapObj *map, layerObj *layer,
+                                    imageObj *image, rasterBufferObj *rb,
+                                    void *hDatasetIn) {
   /* -------------------------------------------------------------------- */
   /*      As of MapServer 6.0 GDAL is required for rendering raster       */
   /*      imagery.                                                        */
   /* -------------------------------------------------------------------- */
   int status, done;
-  char *filename=NULL, tilename[MS_MAXPATHLEN], tilesrsname[1024];
+  char *filename = NULL, tilename[MS_MAXPATHLEN], tilesrsname[1024];
 
-  layerObj *tlp=NULL; /* pointer to the tile layer either real or temporary */
-  int tileitemindex=-1, tilelayerindex=-1, tilesrsindex=-1;
+  layerObj *tlp = NULL; /* pointer to the tile layer either real or temporary */
+  int tileitemindex = -1, tilelayerindex = -1, tilesrsindex = -1;
   shapeObj tshp;
 
-  char szPath[MS_MAXPATHLEN] = { 0 };
+  char szPath[MS_MAXPATHLEN] = {0};
   char *decrypted_path = NULL;
   int final_status = MS_SUCCESS;
 
   rectObj searchrect;
-  GDALDatasetH  hDS;
-  double  adfGeoTransform[6];
+  GDALDatasetH hDS;
+  double adfGeoTransform[6];
   void *kernel_density_cleanup_ptr = NULL;
 
-  if(layer->debug > 0 || map->debug > 1)
-    msDebug( "msDrawRasterLayerLow(%s): entering.\n", layer->name );
+  if (layer->debug > 0 || map->debug > 1)
+    msDebug("msDrawRasterLayerLow(%s): entering.\n", layer->name);
 
-  if( hDatasetIn == NULL &&
-      !msDrawRasterLayerLowCheckIfMustDraw(map, layer) ) {
+  if (hDatasetIn == NULL && !msDrawRasterLayerLowCheckIfMustDraw(map, layer)) {
     return MS_SUCCESS;
   }
 
   msGDALInitialize();
 
-  if(layer->tileindex) { /* we have an index file */
+  if (layer->tileindex) { /* we have an index file */
     msInitShape(&tshp);
     searchrect = map->extent;
 
-    status = msDrawRasterSetupTileLayer(map, layer,
-                           &searchrect,
-                           MS_FALSE,
-                           &tilelayerindex,
-                           &tileitemindex,
-                           &tilesrsindex,
-                           &tlp);
-    if(status != MS_SUCCESS) {
+    status = msDrawRasterSetupTileLayer(map, layer, &searchrect, MS_FALSE,
+                                        &tilelayerindex, &tileitemindex,
+                                        &tilesrsindex, &tlp);
+    if (status != MS_SUCCESS) {
       if (status != MS_DONE)
         final_status = status;
       goto cleanup;
@@ -814,91 +808,89 @@ int msDrawRasterLayerLowWithDataset(mapO
   }
 
   done = MS_FALSE;
-  while(done != MS_TRUE) {
+  while (done != MS_TRUE) {
 
-    if(layer->tileindex) {
-      status = msDrawRasterIterateTileIndex(layer, tlp, &tshp,
-                                            tileitemindex, tilesrsindex,
-                                            tilename, sizeof(tilename),
-                                            tilesrsname, sizeof(tilesrsname));
-      if( status == MS_FAILURE) {
+    if (layer->tileindex) {
+      status = msDrawRasterIterateTileIndex(
+          layer, tlp, &tshp, tileitemindex, tilesrsindex, tilename,
+          sizeof(tilename), tilesrsname, sizeof(tilesrsname));
+      if (status == MS_FAILURE) {
         final_status = MS_FAILURE;
         break;
       }
 
-      if(status == MS_DONE) break; /* no more tiles/images */
+      if (status == MS_DONE)
+        break; /* no more tiles/images */
       filename = tilename;
     } else {
       filename = layer->data;
       done = MS_TRUE; /* only one image so we're done after this */
     }
-    
-    if(layer->connectiontype == MS_KERNELDENSITY || layer->connectiontype == MS_IDW) {
-      msAcquireLock( TLOCK_GDAL );
-      status = msInterpolationDataset(map, image, layer, &hDS, &kernel_density_cleanup_ptr);
-      if(status != MS_SUCCESS) {
-        msReleaseLock( TLOCK_GDAL );
+
+    if (layer->connectiontype == MS_KERNELDENSITY ||
+        layer->connectiontype == MS_IDW) {
+      msAcquireLock(TLOCK_GDAL);
+      status = msInterpolationDataset(map, image, layer, &hDS,
+                                      &kernel_density_cleanup_ptr);
+      if (status != MS_SUCCESS) {
+        msReleaseLock(TLOCK_GDAL);
         final_status = status;
         goto cleanup;
       }
       done = MS_TRUE;
-      if(msProjectionsDiffer(&map->projection,&layer->projection)) {
+      if (msProjectionsDiffer(&map->projection, &layer->projection)) {
         char *mapProjStr = msGetProjectionString(&(map->projection));
 
         /* Set the projection to the map file projection */
         if (msLoadProjectionString(&(layer->projection), mapProjStr) != 0) {
-          GDALClose( hDS );
-          msReleaseLock( TLOCK_GDAL );
-          msSetError(MS_CGIERR, "Unable to set projection on interpolation layer.", "msDrawRasterLayerLow()");
-          return(MS_FAILURE);
+          GDALClose(hDS);
+          msReleaseLock(TLOCK_GDAL);
+          msSetError(MS_CGIERR,
+                     "Unable to set projection on interpolation layer.",
+                     "msDrawRasterLayerLow()");
+          return (MS_FAILURE);
         }
         free(mapProjStr);
       }
     } else {
-      if(strlen(filename) == 0) continue;
-      if( hDatasetIn )
-      {
+      if (strlen(filename) == 0)
+        continue;
+      if (hDatasetIn) {
         hDS = (GDALDatasetH)hDatasetIn;
-      }
-      else
-      {
+      } else {
         hDS = (GDALDatasetH)msDrawRasterLayerLowOpenDataset(
-                                map, layer, filename, szPath, &decrypted_path);
+            map, layer, filename, szPath, &decrypted_path);
       }
     }
 
-    if( hDatasetIn == NULL )
-    {
-        CheckDatasetReturnType eRet =
-            msDrawRasterLayerLowCheckDataset(map,layer,hDS,decrypted_path,szPath);
+    if (hDatasetIn == NULL) {
+      CheckDatasetReturnType eRet = msDrawRasterLayerLowCheckDataset(
+          map, layer, hDS, decrypted_path, szPath);
 
-        msFree( decrypted_path );
-        decrypted_path = NULL;
+      msFree(decrypted_path);
+      decrypted_path = NULL;
 
-        if( eRet == CDRT_CONTINUE_NEXT_TILE )
-        {
-            msReleaseLock( TLOCK_GDAL );
-            continue;
-        }
-        if( eRet == CDRT_RETURN_MS_FAILURE )
-        {
-            msReleaseLock( TLOCK_GDAL );
-            return MS_FAILURE;
-        }
+      if (eRet == CDRT_CONTINUE_NEXT_TILE) {
+        msReleaseLock(TLOCK_GDAL);
+        continue;
+      }
+      if (eRet == CDRT_RETURN_MS_FAILURE) {
+        msReleaseLock(TLOCK_GDAL);
+        return MS_FAILURE;
+      }
     }
 
-    if( msDrawRasterLoadProjection(layer, hDS, filename, tilesrsindex, tilesrsname) != MS_SUCCESS )
-    {
-        if( hDatasetIn == NULL )
-        {
-          GDALClose( hDS );
-          msReleaseLock( TLOCK_GDAL );
-        }
-        final_status = MS_FAILURE;
-        break;
+    if (msDrawRasterLoadProjection(layer, hDS, filename, tilesrsindex,
+                                   tilesrsname) != MS_SUCCESS) {
+      if (hDatasetIn == NULL) {
+        GDALClose(hDS);
+        msReleaseLock(TLOCK_GDAL);
+      }
+      final_status = MS_FAILURE;
+      break;
     }
 
-    msGetGDALGeoTransform( hDS, map, layer, adfGeoTransform );
+    msGetGDALGeoTransform(hDS, map, layer, adfGeoTransform);
 
     /*
     ** We want to resample if the source image is rotated, if
@@ -906,33 +898,27 @@ int msDrawRasterLayerLowWithDataset(mapO
     ** requested, or if the image has north-down instead of north-up.
     */
 
-    if( ((adfGeoTransform[2] != 0.0 || adfGeoTransform[4] != 0.0
-          || adfGeoTransform[5] > 0.0 || adfGeoTransform[1] < 0.0 )
-         && layer->transform )
-        || msProjectionsDiffer( &(map->projection),
-                                &(layer->projection) )
-        || CSLFetchNameValue( layer->processing, "RESAMPLE" ) != NULL ) {
-      status = msResampleGDALToMap( map, layer, image, rb, hDS );
-    }
-    else
-    {
-      if( adfGeoTransform[2] != 0.0 || adfGeoTransform[4] != 0.0 ) {
-        if( layer->debug || map->debug )
-          msDebug(
-            "Layer %s has rotational coefficients but we\n"
-            "are unable to use them, projections support\n"
-            "needs to be built in.",
-            layer->name );
-
-      }
-      status = msDrawRasterLayerGDAL(map, layer, image, rb, hDS );
+    if (((adfGeoTransform[2] != 0.0 || adfGeoTransform[4] != 0.0 ||
+          adfGeoTransform[5] > 0.0 || adfGeoTransform[1] < 0.0) &&
+         layer->transform) ||
+        msProjectionsDiffer(&(map->projection), &(layer->projection)) ||
+        CSLFetchNameValue(layer->processing, "RESAMPLE") != NULL) {
+      status = msResampleGDALToMap(map, layer, image, rb, hDS);
+    } else {
+      if (adfGeoTransform[2] != 0.0 || adfGeoTransform[4] != 0.0) {
+        if (layer->debug || map->debug)
+          msDebug("Layer %s has rotational coefficients but we\n"
+                  "are unable to use them, projections support\n"
+                  "needs to be built in.",
+                  layer->name);
+      }
+      status = msDrawRasterLayerGDAL(map, layer, image, rb, hDS);
     }
 
-    if( status == -1 ) {
-      if( hDatasetIn == NULL )
-      {
-        GDALClose( hDS );
-        msReleaseLock( TLOCK_GDAL );
+    if (status == -1) {
+      if (hDatasetIn == NULL) {
+        GDALClose(hDS);
+        msReleaseLock(TLOCK_GDAL);
       }
       final_status = MS_FAILURE;
       break;
@@ -943,32 +929,36 @@ int msDrawRasterLayerLowWithDataset(mapO
     ** default to keeping open for single data files, and
     ** to closing for tile indexes
     */
-    if(layer->connectiontype == MS_KERNELDENSITY || layer->connectiontype == MS_IDW) {
+    if (layer->connectiontype == MS_KERNELDENSITY ||
+        layer->connectiontype == MS_IDW) {
       /*
       ** Fix issue #5330
-      ** The in-memory kernel density heatmap gdal dataset handle (hDS) gets re-used
-      ** but the associated rasterband cache doesn't get flushed, which causes old data
-      ** to be rendered instead of the newly generated imagery. To fix, simply close the
+      ** The in-memory kernel density heatmap gdal dataset handle (hDS) gets
+      *re-used
+      ** but the associated rasterband cache doesn't get flushed, which causes
+      *old data
+      ** to be rendered instead of the newly generated imagery. To fix, simply
+      *close the
       ** the handle and prevent further re-use.
-      ** Note that instead of this workaround, we could explicitely set 
+      ** Note that instead of this workaround, we could explicitely set
       ** CLOSE_CONNECTION=ALWAYS on the kerneldensity layer.
       */
-      GDALClose( hDS );
-      msReleaseLock( TLOCK_GDAL );
-    }
-    else {
-      if( hDatasetIn == NULL)
+      GDALClose(hDS);
+      msReleaseLock(TLOCK_GDAL);
+    } else {
+      if (hDatasetIn == NULL)
         msDrawRasterLayerLowCloseDataset(layer, hDS);
     }
 
   } /* next tile */
 
 cleanup:
-  if(layer->tileindex) { /* tiling clean-up */
+  if (layer->tileindex) { /* tiling clean-up */
     msDrawRasterCleanupTileLayer(tlp, tilelayerindex);
   }
-  if(kernel_density_cleanup_ptr) {
-    msCleanupInterpolationDataset(map, image, layer, kernel_density_cleanup_ptr);
+  if (kernel_density_cleanup_ptr) {
+    msCleanupInterpolationDataset(map, image, layer,
+                                  kernel_density_cleanup_ptr);
   }
 
   return final_status;
@@ -978,10 +968,9 @@ cleanup:
 /*                         msDrawReferenceMap()                         */
 /************************************************************************/
 
-imageObj *msDrawReferenceMap(mapObj *map)
-{
+imageObj *msDrawReferenceMap(mapObj *map) {
   double cellsize;
-  int x1,y1,x2,y2;
+  int x1, y1, x2, y2;
   char szPath[MS_MAXPATHLEN];
   int status = MS_SUCCESS;
 
@@ -989,44 +978,51 @@ imageObj *msDrawReferenceMap(mapObj *map
   styleObj style;
 
   /* check to see if we have enough information to actually proceed */
-  if(!map->reference.image || map->reference.height == 0 || map->reference.width == 0) {
-    msSetError(MS_MISCERR, "Reference map configuration error.", "msDrawReferenceMap()");
+  if (!map->reference.image || map->reference.height == 0 ||
+      map->reference.width == 0) {
+    msSetError(MS_MISCERR, "Reference map configuration error.",
+               "msDrawReferenceMap()");
     return NULL;
   }
 
   rendererVTableObj *renderer = MS_MAP_RENDERER(map);
-  rasterBufferObj *refImage = (rasterBufferObj*)calloc(1,sizeof(rasterBufferObj));
+  rasterBufferObj *refImage =
+      (rasterBufferObj *)calloc(1, sizeof(rasterBufferObj));
   MS_CHECK_ALLOC(refImage, sizeof(rasterBufferObj), NULL);
 
-  if(MS_SUCCESS != renderer->loadImageFromFile(msBuildPath(szPath, map->mappath, map->reference.image),refImage)) {
-    msSetError(MS_MISCERR,"Error loading reference image %s.","msDrawReferenceMap()",szPath);
+  if (MS_SUCCESS !=
+      renderer->loadImageFromFile(
+          msBuildPath(szPath, map->mappath, map->reference.image), refImage)) {
+    msSetError(MS_MISCERR, "Error loading reference image %s.",
+               "msDrawReferenceMap()", szPath);
     free(refImage);
     return NULL;
   }
 
   image = msImageCreate(refImage->width, refImage->height, map->outputformat,
-                        map->web.imagepath, map->web.imageurl, map->resolution, map->defresolution, &(map->reference.color));
-  if(!image)
-  {
-      free(refImage);
-      return NULL;
+                        map->web.imagepath, map->web.imageurl, map->resolution,
+                        map->defresolution, &(map->reference.color));
+  if (!image) {
+    free(refImage);
+    return NULL;
   }
 
-  status = renderer->mergeRasterBuffer(image,refImage,1.0,0,0,0,0,refImage->width, refImage->height);
+  status = renderer->mergeRasterBuffer(image, refImage, 1.0, 0, 0, 0, 0,
+                                       refImage->width, refImage->height);
   msFreeRasterBuffer(refImage);
   free(refImage);
-  if(MS_UNLIKELY(status == MS_FAILURE))
+  if (MS_UNLIKELY(status == MS_FAILURE))
     return NULL;
 
   /* make sure the extent given in mapfile fits the image */
-  cellsize = msAdjustExtent(&(map->reference.extent),
-                            image->width, image->height);
+  cellsize =
+      msAdjustExtent(&(map->reference.extent), image->width, image->height);
 
   /* convert map extent to reference image coordinates */
-  x1 = MS_MAP2IMAGE_X(map->extent.minx,  map->reference.extent.minx, cellsize);
-  x2 = MS_MAP2IMAGE_X(map->extent.maxx,  map->reference.extent.minx, cellsize);
-  y1 = MS_MAP2IMAGE_Y(map->extent.maxy,  map->reference.extent.maxy, cellsize);
-  y2 = MS_MAP2IMAGE_Y(map->extent.miny,  map->reference.extent.maxy, cellsize);
+  x1 = MS_MAP2IMAGE_X(map->extent.minx, map->reference.extent.minx, cellsize);
+  x2 = MS_MAP2IMAGE_X(map->extent.maxx, map->reference.extent.minx, cellsize);
+  y1 = MS_MAP2IMAGE_Y(map->extent.maxy, map->reference.extent.maxy, cellsize);
+  y2 = MS_MAP2IMAGE_Y(map->extent.miny, map->reference.extent.maxy, cellsize);
 
   initStyle(&style);
   style.color = map->reference.color;
@@ -1034,8 +1030,8 @@ imageObj *msDrawReferenceMap(mapObj *map
 
   /* if extent are smaller than minbox size */
   /* draw that extent on the reference image */
-  if( (abs(x2 - x1) > map->reference.minboxsize) ||
-      (abs(y2 - y1) > map->reference.minboxsize) ) {
+  if ((abs(x2 - x1) > map->reference.minboxsize) ||
+      (abs(y2 - y1) > map->reference.minboxsize)) {
     shapeObj rect;
     lineObj line;
     pointObj points[5];
@@ -1060,34 +1056,37 @@ imageObj *msDrawReferenceMap(mapObj *map
 
     line.numpoints = 5;
 
-    if( map->reference.maxboxsize == 0 ||
+    if (map->reference.maxboxsize == 0 ||
         ((abs(x2 - x1) < map->reference.maxboxsize) &&
-         (abs(y2 - y1) < map->reference.maxboxsize)) ) {
-      if(MS_UNLIKELY(MS_FAILURE == msDrawShadeSymbol(map, image, &rect, &style, 1.0))) {
+         (abs(y2 - y1) < map->reference.maxboxsize))) {
+      if (MS_UNLIKELY(MS_FAILURE ==
+                      msDrawShadeSymbol(map, image, &rect, &style, 1.0))) {
         msFreeImage(image);
         return NULL;
       }
     }
 
   } else { /* else draw the marker symbol */
-    if( map->reference.maxboxsize == 0 ||
+    if (map->reference.maxboxsize == 0 ||
         ((abs(x2 - x1) < map->reference.maxboxsize) &&
-         (abs(y2 - y1) < map->reference.maxboxsize)) ) {
+         (abs(y2 - y1) < map->reference.maxboxsize))) {
       style.size = map->reference.markersize;
 
       /* if the marker symbol is specify draw this symbol else draw a cross */
-      if(map->reference.marker || map->reference.markername) {
+      if (map->reference.marker || map->reference.markername) {
         pointObj point;
-        point.x = (double)(x1 + x2)/2;
-        point.y = (double)(y1 + y2)/2;
+        point.x = (double)(x1 + x2) / 2;
+        point.y = (double)(y1 + y2) / 2;
 
-        if(map->reference.marker) {
+        if (map->reference.marker) {
           style.symbol = map->reference.marker;
         } else {
-          style.symbol = msGetSymbolIndex(&map->symbolset,  map->reference.markername, MS_TRUE);
+          style.symbol = msGetSymbolIndex(&map->symbolset,
+                                          map->reference.markername, MS_TRUE);
         }
 
-        if(MS_UNLIKELY(MS_FAILURE == msDrawMarkerSymbol(map, image, &point, &style, 1.0))) {
+        if (MS_UNLIKELY(MS_FAILURE ==
+                        msDrawMarkerSymbol(map, image, &point, &style, 1.0))) {
           msFreeImage(image);
           return NULL;
         }
@@ -1098,35 +1097,36 @@ imageObj *msDrawReferenceMap(mapObj *map
         pointObj point[8];
         int i;
         /* determine the center point */
-        x21 = MS_NINT((x1 + x2)/2);
-        y21 = MS_NINT((y1 + y2)/2);
+        x21 = MS_NINT((x1 + x2) / 2);
+        y21 = MS_NINT((y1 + y2) / 2);
 
         msInitShape(&cross);
         cross.numlines = 4;
         cross.line = lines;
-        for(i=0; i<4; i++) {
+        for (i = 0; i < 4; i++) {
           cross.line[i].numpoints = 2;
-          cross.line[i].point = &(point[2*i]);
+          cross.line[i].point = &(point[2 * i]);
         }
         /* draw a cross */
-        cross.line[0].point[0].x = x21-8;
+        cross.line[0].point[0].x = x21 - 8;
         cross.line[0].point[0].y = y21;
-        cross.line[0].point[1].x = x21-3;
+        cross.line[0].point[1].x = x21 - 3;
         cross.line[0].point[1].y = y21;
         cross.line[1].point[0].x = x21;
-        cross.line[1].point[0].y = y21-8;
+        cross.line[1].point[0].y = y21 - 8;
         cross.line[1].point[1].x = x21;
-        cross.line[1].point[1].y = y21-3;
+        cross.line[1].point[1].y = y21 - 3;
         cross.line[2].point[0].x = x21;
-        cross.line[2].point[0].y = y21+3;
+        cross.line[2].point[0].y = y21 + 3;
         cross.line[2].point[1].x = x21;
-        cross.line[2].point[1].y = y21+8;
-        cross.line[3].point[0].x = x21+3;
+        cross.line[2].point[1].y = y21 + 8;
+        cross.line[3].point[0].x = x21 + 3;
         cross.line[3].point[0].y = y21;
-        cross.line[3].point[1].x = x21+8;
+        cross.line[3].point[1].x = x21 + 8;
         cross.line[3].point[1].y = y21;
 
-        if(MS_UNLIKELY(MS_FAILURE == msDrawLineSymbol(map,image,&cross,&style,1.0))) {
+        if (MS_UNLIKELY(MS_FAILURE ==
+                        msDrawLineSymbol(map, image, &cross, &style, 1.0))) {
           msFreeImage(image);
           return NULL;
         }
@@ -1134,5 +1134,5 @@ imageObj *msDrawReferenceMap(mapObj *map
     }
   }
 
-  return(image);
+  return (image);
 }
diff -pruN 8.0.1-5/mapraster.h 8.0.2-1/mapraster.h
--- 8.0.1-5/mapraster.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapraster.h	2024-06-11 20:41:34.000000000 +0000
@@ -29,39 +29,32 @@
 #ifndef MAPRASTER_H
 #define MAPRASTER_H
 
-
-  int msDrawRasterSetupTileLayer(mapObj *map, layerObj *layer,
-                                 rectObj* psearchrect,
-                                 int is_query,
-                                 int* ptilelayerindex, /* output */
-                                 int* ptileitemindex, /* output */
-                                 int* ptilesrsindex, /* output */
-                                 layerObj **ptlp  /* output */ );
-
-  void msDrawRasterCleanupTileLayer(layerObj* tlp,
-                                    int tilelayerindex);
-
-  int msDrawRasterIterateTileIndex(layerObj *layer,
-                                   layerObj* tlp,
-                                   shapeObj* ptshp, /* input-output */
-                                   int tileitemindex,
-                                   int tilesrsindex,
-                                   char* tilename, /* output */
-                                   size_t sizeof_tilename,
-                                   char* tilesrsname, /* output */
-                                   size_t sizeof_tilesrsname);
-
-  int msDrawRasterBuildRasterPath(mapObj *map, layerObj *layer,
-                                  const char* filename,
-                                  char szPath[MS_MAXPATHLEN]);
-
-  const char* msDrawRasterGetCPLErrorMsg(const char* decrypted_path,
-                                         const char* szPath);
-
-  int msDrawRasterLoadProjection(layerObj *layer,
-                                 GDALDatasetH hDS,
-                                 const char* filename,
-                                 int tilesrsindex,
-                                 const char* tilesrsname);
+int msDrawRasterSetupTileLayer(mapObj *map, layerObj *layer,
+                               rectObj *psearchrect, int is_query,
+                               int *ptilelayerindex, /* output */
+                               int *ptileitemindex,  /* output */
+                               int *ptilesrsindex,   /* output */
+                               layerObj **ptlp /* output */);
+
+void msDrawRasterCleanupTileLayer(layerObj *tlp, int tilelayerindex);
+
+int msDrawRasterIterateTileIndex(layerObj *layer, layerObj *tlp,
+                                 shapeObj *ptshp, /* input-output */
+                                 int tileitemindex, int tilesrsindex,
+                                 char *tilename, /* output */
+                                 size_t sizeof_tilename,
+                                 char *tilesrsname, /* output */
+                                 size_t sizeof_tilesrsname);
+
+int msDrawRasterBuildRasterPath(mapObj *map, layerObj *layer,
+                                const char *filename,
+                                char szPath[MS_MAXPATHLEN]);
+
+const char *msDrawRasterGetCPLErrorMsg(const char *decrypted_path,
+                                       const char *szPath);
+
+int msDrawRasterLoadProjection(layerObj *layer, GDALDatasetH hDS,
+                               const char *filename, int tilesrsindex,
+                               const char *tilesrsname);
 
 #endif /* MAPRASTER_H */
diff -pruN 8.0.1-5/maprasterquery.c 8.0.2-1/maprasterquery.c
--- 8.0.1-5/maprasterquery.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/maprasterquery.c	2024-06-11 20:41:34.000000000 +0000
@@ -33,7 +33,6 @@
 #include "mapthread.h"
 #include "mapraster.h"
 
-
 int msRASTERLayerGetShape(layerObj *layer, shapeObj *shape, resultObj *record);
 int msRASTERLayerGetItems(layerObj *layer);
 
@@ -54,41 +53,41 @@ typedef struct {
   int refcount;
 
   rectObj which_rect;
-  int     next_shape;
+  int next_shape;
 
   double *qc_x;
   double *qc_y;
   double *qc_x_reproj;
   double *qc_y_reproj;
   float *qc_values;
-  int    *qc_class;
-  int    *qc_red;
-  int    *qc_green;
-  int    *qc_blue;
-  int    *qc_count;
-  int    *qc_tileindex;
+  int *qc_class;
+  int *qc_red;
+  int *qc_green;
+  int *qc_blue;
+  int *qc_count;
+  int *qc_tileindex;
 
   /* query bound in force */
   shapeObj *searchshape;
 
   /* Only nearest result to this point. */
-  int      range_mode; /* MS_QUERY_SINGLE, MS_QUERY_MULTIPLE or -1 (skip test) */
-  double   range_dist;
+  int range_mode; /* MS_QUERY_SINGLE, MS_QUERY_MULTIPLE or -1 (skip test) */
+  double range_dist;
   pointObj target_point;
 
   GDALColorTableH hCT;
 
-  double   shape_tolerance;
+  double shape_tolerance;
 
 } rasterLayerInfo;
 
-#define RQM_UNKNOWN               0
-#define RQM_ENTRY_PER_PIXEL       1
-#define RQM_HIST_ON_CLASS         2
-#define RQM_HIST_ON_VALUE         3
+#define RQM_UNKNOWN 0
+#define RQM_ENTRY_PER_PIXEL 1
+#define RQM_HIST_ON_CLASS 2
+#define RQM_HIST_ON_VALUE 3
 
-extern int InvGeoTransform( double *gt_in, double *gt_out );
-#define GEO_TRANS(tr,x,y)  ((tr)[0]+(tr)[1]*(x)+(tr)[2]*(y))
+extern int InvGeoTransform(double *gt_in, double *gt_out);
+#define GEO_TRANS(tr, x, y) ((tr)[0] + (tr)[1] * (x) + (tr)[2] * (y))
 
 /************************************************************************/
 /*                             addResult()                              */
@@ -97,18 +96,21 @@ extern int InvGeoTransform( double *gt_i
 /*      a small public API for managing results caches?                 */
 /************************************************************************/
 
-static int addResult(resultCacheObj *cache, int classindex, int shapeindex, int tileindex)
-{
+static int addResult(resultCacheObj *cache, int classindex, int shapeindex,
+                     int tileindex) {
   int i;
 
-  if(cache->numresults == cache->cachesize) { /* just add it to the end */
-    if(cache->cachesize == 0)
-      cache->results = (resultObj *) malloc(sizeof(resultObj)*MS_RESULTCACHEINCREMENT);
+  if (cache->numresults == cache->cachesize) { /* just add it to the end */
+    if (cache->cachesize == 0)
+      cache->results =
+          (resultObj *)malloc(sizeof(resultObj) * MS_RESULTCACHEINCREMENT);
     else
-      cache->results = (resultObj *) realloc(cache->results, sizeof(resultObj)*(cache->cachesize+MS_RESULTCACHEINCREMENT));
-    if(!cache->results) {
+      cache->results = (resultObj *)realloc(
+          cache->results,
+          sizeof(resultObj) * (cache->cachesize + MS_RESULTCACHEINCREMENT));
+    if (!cache->results) {
       msSetError(MS_MEMERR, "Realloc() error.", "addResult()");
-      return(MS_FAILURE);
+      return (MS_FAILURE);
     }
     cache->cachesize += MS_RESULTCACHEINCREMENT;
   }
@@ -122,48 +124,48 @@ static int addResult(resultCacheObj *cac
   cache->results[i].shape = NULL;
   cache->numresults++;
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
 /************************************************************************/
 /*                       msRasterLayerInfoFree()                        */
 /************************************************************************/
 
-static void msRasterLayerInfoFree( layerObj *layer )
+static void msRasterLayerInfoFree(layerObj *layer)
 
 {
-  rasterLayerInfo *rlinfo = (rasterLayerInfo *) layer->layerinfo;
+  rasterLayerInfo *rlinfo = (rasterLayerInfo *)layer->layerinfo;
 
-  if( rlinfo == NULL )
+  if (rlinfo == NULL)
     return;
 
-  if( rlinfo->qc_x != NULL ) {
-    free( rlinfo->qc_x );
-    free( rlinfo->qc_y );
-    free( rlinfo->qc_x_reproj );
-    free( rlinfo->qc_y_reproj );
+  if (rlinfo->qc_x != NULL) {
+    free(rlinfo->qc_x);
+    free(rlinfo->qc_y);
+    free(rlinfo->qc_x_reproj);
+    free(rlinfo->qc_y_reproj);
   }
 
-  if( rlinfo->qc_values )
-    free( rlinfo->qc_values );
+  if (rlinfo->qc_values)
+    free(rlinfo->qc_values);
 
-  if( rlinfo->qc_class ) {
-    free( rlinfo->qc_class );
+  if (rlinfo->qc_class) {
+    free(rlinfo->qc_class);
   }
 
-  if( rlinfo->qc_red ) {
-    free( rlinfo->qc_red );
-    free( rlinfo->qc_green );
-    free( rlinfo->qc_blue );
+  if (rlinfo->qc_red) {
+    free(rlinfo->qc_red);
+    free(rlinfo->qc_green);
+    free(rlinfo->qc_blue);
   }
 
-  if( rlinfo->qc_count != NULL )
-    free( rlinfo->qc_count );
+  if (rlinfo->qc_count != NULL)
+    free(rlinfo->qc_count);
 
-  if( rlinfo->qc_tileindex != NULL )
-    free( rlinfo->qc_tileindex );
+  if (rlinfo->qc_tileindex != NULL)
+    free(rlinfo->qc_tileindex);
 
-  free( rlinfo );
+  free(rlinfo);
 
   layer->layerinfo = NULL;
 }
@@ -172,15 +174,15 @@ static void msRasterLayerInfoFree( layer
 /*                    msRasterLayerInfoInitialize()                     */
 /************************************************************************/
 
-static void msRasterLayerInfoInitialize( layerObj *layer )
+static void msRasterLayerInfoInitialize(layerObj *layer)
 
 {
-  rasterLayerInfo *rlinfo = (rasterLayerInfo *) layer->layerinfo;
+  rasterLayerInfo *rlinfo = (rasterLayerInfo *)layer->layerinfo;
 
-  if( rlinfo != NULL )
+  if (rlinfo != NULL)
     return;
 
-  rlinfo = (rasterLayerInfo *) msSmallCalloc(1,sizeof(rasterLayerInfo));
+  rlinfo = (rasterLayerInfo *)msSmallCalloc(1, sizeof(rasterLayerInfo));
   layer->layerinfo = rlinfo;
 
   rlinfo->band_count = -1;
@@ -192,15 +194,15 @@ static void msRasterLayerInfoInitialize(
   /* We need to do this or the layer->layerinfo will be interpreted */
   /* as shapefile access info because the default connectiontype is */
   /* MS_SHAPEFILE. */
-  if (layer->connectiontype != MS_WMS && layer->connectiontype != MS_KERNELDENSITY)
+  if (layer->connectiontype != MS_WMS &&
+      layer->connectiontype != MS_KERNELDENSITY)
     layer->connectiontype = MS_RASTER;
 
   rlinfo->query_result_hard_max = 1000000;
 
-  if( CSLFetchNameValue( layer->processing, "RASTER_QUERY_MAX_RESULT" )
-      != NULL ) {
+  if (CSLFetchNameValue(layer->processing, "RASTER_QUERY_MAX_RESULT") != NULL) {
     rlinfo->query_result_hard_max =
-      atoi(CSLFetchNameValue( layer->processing, "RASTER_QUERY_MAX_RESULT" ));
+        atoi(CSLFetchNameValue(layer->processing, "RASTER_QUERY_MAX_RESULT"));
   }
 }
 
@@ -208,57 +210,55 @@ static void msRasterLayerInfoInitialize(
 /*                       msRasterQueryAddPixel()                        */
 /************************************************************************/
 
-static void msRasterQueryAddPixel( layerObj *layer, pointObj *location,
-                                   pointObj *reprojectedLocation,
-                                   float *values )
+static void msRasterQueryAddPixel(layerObj *layer, pointObj *location,
+                                  pointObj *reprojectedLocation, float *values)
 
 {
-  rasterLayerInfo *rlinfo = (rasterLayerInfo *) layer->layerinfo;
+  rasterLayerInfo *rlinfo = (rasterLayerInfo *)layer->layerinfo;
   int red = 0, green = 0, blue = 0, nodata = FALSE;
   int p_class = -1;
 
-  if( rlinfo->query_results == rlinfo->query_result_hard_max )
+  if (rlinfo->query_results == rlinfo->query_result_hard_max)
     return;
 
   /* -------------------------------------------------------------------- */
   /*      Is this our first time in?  If so, do an initial allocation     */
   /*      for the data arrays suitable to our purposes.                   */
   /* -------------------------------------------------------------------- */
-  if( rlinfo->query_alloc_max == 0 ) {
+  if (rlinfo->query_alloc_max == 0) {
     rlinfo->query_alloc_max = 2;
 
-    switch( rlinfo->raster_query_mode ) {
-      case RQM_ENTRY_PER_PIXEL:
-        rlinfo->qc_x = (double *)
-                       msSmallCalloc(sizeof(double),rlinfo->query_alloc_max);
-        rlinfo->qc_y = (double *)
-                       msSmallCalloc(sizeof(double),rlinfo->query_alloc_max);
-        rlinfo->qc_x_reproj = (double *)
-                       msSmallCalloc(sizeof(double),rlinfo->query_alloc_max);
-        rlinfo->qc_y_reproj = (double *)
-                       msSmallCalloc(sizeof(double),rlinfo->query_alloc_max);
-        rlinfo->qc_values = (float *)
-                            msSmallCalloc(sizeof(float),
-                                          rlinfo->query_alloc_max*rlinfo->band_count);
-        rlinfo->qc_red = (int *)
-                         msSmallCalloc(sizeof(int),rlinfo->query_alloc_max);
-        rlinfo->qc_green = (int *)
-                           msSmallCalloc(sizeof(int),rlinfo->query_alloc_max);
-        rlinfo->qc_blue = (int *)
-                          msSmallCalloc(sizeof(int),rlinfo->query_alloc_max);
-        if( layer->numclasses > 0 )
-          rlinfo->qc_class = (int *)
-                             msSmallCalloc(sizeof(int),rlinfo->query_alloc_max);
-        break;
+    switch (rlinfo->raster_query_mode) {
+    case RQM_ENTRY_PER_PIXEL:
+      rlinfo->qc_x =
+          (double *)msSmallCalloc(sizeof(double), rlinfo->query_alloc_max);
+      rlinfo->qc_y =
+          (double *)msSmallCalloc(sizeof(double), rlinfo->query_alloc_max);
+      rlinfo->qc_x_reproj =
+          (double *)msSmallCalloc(sizeof(double), rlinfo->query_alloc_max);
+      rlinfo->qc_y_reproj =
+          (double *)msSmallCalloc(sizeof(double), rlinfo->query_alloc_max);
+      rlinfo->qc_values = (float *)msSmallCalloc(
+          sizeof(float), rlinfo->query_alloc_max * rlinfo->band_count);
+      rlinfo->qc_red =
+          (int *)msSmallCalloc(sizeof(int), rlinfo->query_alloc_max);
+      rlinfo->qc_green =
+          (int *)msSmallCalloc(sizeof(int), rlinfo->query_alloc_max);
+      rlinfo->qc_blue =
+          (int *)msSmallCalloc(sizeof(int), rlinfo->query_alloc_max);
+      if (layer->numclasses > 0)
+        rlinfo->qc_class =
+            (int *)msSmallCalloc(sizeof(int), rlinfo->query_alloc_max);
+      break;
 
-      case RQM_HIST_ON_CLASS:
-        break;
+    case RQM_HIST_ON_CLASS:
+      break;
 
-      case RQM_HIST_ON_VALUE:
-        break;
+    case RQM_HIST_ON_VALUE:
+      break;
 
-      default:
-        assert( FALSE );
+    default:
+      assert(FALSE);
     }
   }
 
@@ -266,59 +266,58 @@ static void msRasterQueryAddPixel( layer
   /*      Reallocate the data arrays larger if they are near the max      */
   /*      now.                                                            */
   /* -------------------------------------------------------------------- */
-  if( rlinfo->query_results == rlinfo->query_alloc_max ) {
+  if (rlinfo->query_results == rlinfo->query_alloc_max) {
     rlinfo->query_alloc_max = rlinfo->query_alloc_max * 2 + 100;
 
-    if( rlinfo->qc_x != NULL )
+    if (rlinfo->qc_x != NULL)
       rlinfo->qc_x = msSmallRealloc(rlinfo->qc_x,
                                     sizeof(double) * rlinfo->query_alloc_max);
-    if( rlinfo->qc_y != NULL )
+    if (rlinfo->qc_y != NULL)
       rlinfo->qc_y = msSmallRealloc(rlinfo->qc_y,
                                     sizeof(double) * rlinfo->query_alloc_max);
-    if( rlinfo->qc_x_reproj != NULL )
-      rlinfo->qc_x_reproj = msSmallRealloc(rlinfo->qc_x_reproj,
-                                    sizeof(double) * rlinfo->query_alloc_max);
-    if( rlinfo->qc_y_reproj != NULL )
-      rlinfo->qc_y_reproj = msSmallRealloc(rlinfo->qc_y_reproj,
-                                    sizeof(double) * rlinfo->query_alloc_max);
-    if( rlinfo->qc_values != NULL )
-      rlinfo->qc_values =
-        msSmallRealloc(rlinfo->qc_values,
-                       sizeof(float) * rlinfo->query_alloc_max
-                       * rlinfo->band_count );
-    if( rlinfo->qc_class != NULL )
+    if (rlinfo->qc_x_reproj != NULL)
+      rlinfo->qc_x_reproj = msSmallRealloc(
+          rlinfo->qc_x_reproj, sizeof(double) * rlinfo->query_alloc_max);
+    if (rlinfo->qc_y_reproj != NULL)
+      rlinfo->qc_y_reproj = msSmallRealloc(
+          rlinfo->qc_y_reproj, sizeof(double) * rlinfo->query_alloc_max);
+    if (rlinfo->qc_values != NULL)
+      rlinfo->qc_values = msSmallRealloc(
+          rlinfo->qc_values,
+          sizeof(float) * rlinfo->query_alloc_max * rlinfo->band_count);
+    if (rlinfo->qc_class != NULL)
       rlinfo->qc_class = msSmallRealloc(rlinfo->qc_class,
                                         sizeof(int) * rlinfo->query_alloc_max);
-    if( rlinfo->qc_red != NULL )
-      rlinfo->qc_red = msSmallRealloc(rlinfo->qc_red,
-                                      sizeof(int) * rlinfo->query_alloc_max);
-    if( rlinfo->qc_green != NULL )
+    if (rlinfo->qc_red != NULL)
+      rlinfo->qc_red =
+          msSmallRealloc(rlinfo->qc_red, sizeof(int) * rlinfo->query_alloc_max);
+    if (rlinfo->qc_green != NULL)
       rlinfo->qc_green = msSmallRealloc(rlinfo->qc_green,
                                         sizeof(int) * rlinfo->query_alloc_max);
-    if( rlinfo->qc_blue != NULL )
+    if (rlinfo->qc_blue != NULL)
       rlinfo->qc_blue = msSmallRealloc(rlinfo->qc_blue,
                                        sizeof(int) * rlinfo->query_alloc_max);
-    if( rlinfo->qc_count != NULL )
+    if (rlinfo->qc_count != NULL)
       rlinfo->qc_count = msSmallRealloc(rlinfo->qc_count,
                                         sizeof(int) * rlinfo->query_alloc_max);
-    if( rlinfo->qc_tileindex != NULL )
-      rlinfo->qc_tileindex = msSmallRealloc(rlinfo->qc_tileindex,
-                                            sizeof(int) * rlinfo->query_alloc_max);
+    if (rlinfo->qc_tileindex != NULL)
+      rlinfo->qc_tileindex = msSmallRealloc(
+          rlinfo->qc_tileindex, sizeof(int) * rlinfo->query_alloc_max);
   }
 
   /* -------------------------------------------------------------------- */
   /*      Handle colormap                                                 */
   /* -------------------------------------------------------------------- */
-  if( rlinfo->hCT != NULL ) {
-    int pct_index = (int) floor(values[0]);
+  if (rlinfo->hCT != NULL) {
+    int pct_index = (int)floor(values[0]);
     GDALColorEntry sEntry;
 
-    if( GDALGetColorEntryAsRGB( rlinfo->hCT, pct_index, &sEntry ) ) {
+    if (GDALGetColorEntryAsRGB(rlinfo->hCT, pct_index, &sEntry)) {
       red = sEntry.c1;
       green = sEntry.c2;
       blue = sEntry.c3;
 
-      if( sEntry.c4 == 0 )
+      if (sEntry.c4 == 0)
         nodata = TRUE;
     } else
       nodata = TRUE;
@@ -328,12 +327,12 @@ static void msRasterQueryAddPixel( layer
   /*      Color derived from greyscale value.                             */
   /* -------------------------------------------------------------------- */
   else {
-    if( rlinfo->band_count >= 3 ) {
-      red = (int) MS_MAX(0,MS_MIN(255,values[0]));
-      green = (int) MS_MAX(0,MS_MIN(255,values[1]));
-      blue = (int) MS_MAX(0,MS_MIN(255,values[2]));
+    if (rlinfo->band_count >= 3) {
+      red = (int)MS_MAX(0, MS_MIN(255, values[0]));
+      green = (int)MS_MAX(0, MS_MIN(255, values[1]));
+      blue = (int)MS_MAX(0, MS_MIN(255, values[2]));
     } else {
-      red = green = blue = (int) MS_MAX(0,MS_MIN(255,values[0]));
+      red = green = blue = (int)MS_MAX(0, MS_MIN(255, values[0]));
     }
   }
 
@@ -345,19 +344,18 @@ static void msRasterQueryAddPixel( layer
   /*      described in:                                                   */
   /*       http://mapserver.gis.umn.edu/bugs/show_bug.cgi?id=1021         */
   /* -------------------------------------------------------------------- */
-  if( rlinfo->qc_class != NULL ) {
-    p_class = msGetClass_FloatRGB(layer, values[0],
-                                  red, green, blue );
+  if (rlinfo->qc_class != NULL) {
+    p_class = msGetClass_FloatRGB(layer, values[0], red, green, blue);
 
-    if( p_class == -1 )
+    if (p_class == -1)
       nodata = TRUE;
     else {
       nodata = FALSE;
       rlinfo->qc_class[rlinfo->query_results] = p_class;
-      if( layer->class[p_class]->numstyles > 0 ) {
-        red   = layer->class[p_class]->styles[0]->color.red;
+      if (layer->class[p_class] -> numstyles > 0) {
+        red = layer->class[p_class]->styles[0]->color.red;
         green = layer->class[p_class]->styles[0]->color.green;
-        blue  = layer->class[p_class]->styles[0]->color.blue;
+        blue = layer->class[p_class]->styles[0]->color.blue;
       } else {
         red = green = blue = 0;
       }
@@ -374,7 +372,7 @@ static void msRasterQueryAddPixel( layer
   /* -------------------------------------------------------------------- */
   /*      Record spatial location.                                        */
   /* -------------------------------------------------------------------- */
-  if( rlinfo->qc_x != NULL ) {
+  if (rlinfo->qc_x != NULL) {
     rlinfo->qc_x[rlinfo->query_results] = location->x;
     rlinfo->qc_y[rlinfo->query_results] = location->y;
     rlinfo->qc_x_reproj[rlinfo->query_results] = reprojectedLocation->x;
@@ -384,15 +382,15 @@ static void msRasterQueryAddPixel( layer
   /* -------------------------------------------------------------------- */
   /*      Record actual pixel value(s).                                   */
   /* -------------------------------------------------------------------- */
-  if( rlinfo->qc_values != NULL )
-    memcpy( rlinfo->qc_values + rlinfo->query_results * rlinfo->band_count,
-            values, sizeof(float) * rlinfo->band_count );
+  if (rlinfo->qc_values != NULL)
+    memcpy(rlinfo->qc_values + rlinfo->query_results * rlinfo->band_count,
+           values, sizeof(float) * rlinfo->band_count);
 
   /* -------------------------------------------------------------------- */
   /*      Add to the results cache.                                       */
   /* -------------------------------------------------------------------- */
-  if( ! nodata ) {
-    addResult( layer->resultcache, p_class, rlinfo->query_results, 0 );
+  if (!nodata) {
+    addResult(layer->resultcache, p_class, rlinfo->query_results, 0);
     rlinfo->query_results++;
   }
 }
@@ -401,33 +399,33 @@ static void msRasterQueryAddPixel( layer
 /*                       msRasterQueryByRectLow()                       */
 /************************************************************************/
 
-static int
-msRasterQueryByRectLow(mapObj *map, layerObj *layer, GDALDatasetH hDS,
-                       rectObj queryRect)
+static int msRasterQueryByRectLow(mapObj *map, layerObj *layer,
+                                  GDALDatasetH hDS, rectObj queryRect)
 
 {
-  double  adfGeoTransform[6], adfInvGeoTransform[6];
-  double      dfXMin, dfYMin, dfXMax, dfYMax, dfX, dfY, dfAdjustedRange;
-  int         nWinXOff, nWinYOff, nWinXSize, nWinYSize;
-  int         nRXSize, nRYSize;
-  float       *pafRaster;
-  int         nBandCount, *panBandMap, iPixel, iLine;
-  CPLErr      eErr;
+  double adfGeoTransform[6], adfInvGeoTransform[6];
+  double dfXMin, dfYMin, dfXMax, dfYMax, dfX, dfY, dfAdjustedRange;
+  int nWinXOff, nWinYOff, nWinXSize, nWinYSize;
+  int nRXSize, nRYSize;
+  float *pafRaster;
+  int nBandCount, *panBandMap, iPixel, iLine;
+  CPLErr eErr;
   rasterLayerInfo *rlinfo;
-  rectObj     searchrect;
+  rectObj searchrect;
 #if PROJ_VERSION_MAJOR < 6
-  int         mayNeedLonWrapAdjustment = MS_FALSE;
+  int mayNeedLonWrapAdjustment = MS_FALSE;
 #endif
 
-  rlinfo = (rasterLayerInfo *) layer->layerinfo;
+  rlinfo = (rasterLayerInfo *)layer->layerinfo;
 
   /* -------------------------------------------------------------------- */
   /*      Reproject the search rect into the projection of this           */
   /*      layer/file if needed.                                           */
   /* -------------------------------------------------------------------- */
   searchrect = queryRect;
-  layer->project = msProjectionsDiffer(&(layer->projection), &(map->projection));
-  if(layer->project)
+  layer->project =
+      msProjectionsDiffer(&(layer->projection), &(map->projection));
+  if (layer->project)
     msProjectRect(&(map->projection), &(layer->projection), &searchrect);
 
   /* -------------------------------------------------------------------- */
@@ -435,72 +433,70 @@ msRasterQueryByRectLow(mapObj *map, laye
   /*      pixel/line extents on the file.  Process all 4 corners, to      */
   /*      build extents.                                                  */
   /* -------------------------------------------------------------------- */
-  nRXSize = GDALGetRasterXSize( hDS );
-  nRYSize = GDALGetRasterYSize( hDS );
+  nRXSize = GDALGetRasterXSize(hDS);
+  nRYSize = GDALGetRasterYSize(hDS);
 
-  msGetGDALGeoTransform( hDS, map, layer, adfGeoTransform );
-  InvGeoTransform( adfGeoTransform, adfInvGeoTransform );
+  msGetGDALGeoTransform(hDS, map, layer, adfGeoTransform);
+  InvGeoTransform(adfGeoTransform, adfInvGeoTransform);
 
   /* top left */
-  dfXMin = dfXMax = GEO_TRANS(adfInvGeoTransform,
-                              searchrect.minx, searchrect.maxy);
-  dfYMin = dfYMax = GEO_TRANS(adfInvGeoTransform+3,
-                              searchrect.minx, searchrect.maxy);
+  dfXMin = dfXMax =
+      GEO_TRANS(adfInvGeoTransform, searchrect.minx, searchrect.maxy);
+  dfYMin = dfYMax =
+      GEO_TRANS(adfInvGeoTransform + 3, searchrect.minx, searchrect.maxy);
 
   /* top right */
-  dfX = GEO_TRANS(adfInvGeoTransform  , searchrect.maxx, searchrect.maxy);
-  dfY = GEO_TRANS(adfInvGeoTransform+3, searchrect.maxx, searchrect.maxy);
-  dfXMin = MS_MIN(dfXMin,dfX);
-  dfXMax = MS_MAX(dfXMax,dfX);
-  dfYMin = MS_MIN(dfYMin,dfY);
-  dfYMax = MS_MAX(dfYMax,dfY);
+  dfX = GEO_TRANS(adfInvGeoTransform, searchrect.maxx, searchrect.maxy);
+  dfY = GEO_TRANS(adfInvGeoTransform + 3, searchrect.maxx, searchrect.maxy);
+  dfXMin = MS_MIN(dfXMin, dfX);
+  dfXMax = MS_MAX(dfXMax, dfX);
+  dfYMin = MS_MIN(dfYMin, dfY);
+  dfYMax = MS_MAX(dfYMax, dfY);
 
   /* bottom left */
-  dfX = GEO_TRANS(adfInvGeoTransform  , searchrect.minx, searchrect.miny);
-  dfY = GEO_TRANS(adfInvGeoTransform+3, searchrect.minx, searchrect.miny);
-  dfXMin = MS_MIN(dfXMin,dfX);
-  dfXMax = MS_MAX(dfXMax,dfX);
-  dfYMin = MS_MIN(dfYMin,dfY);
-  dfYMax = MS_MAX(dfYMax,dfY);
+  dfX = GEO_TRANS(adfInvGeoTransform, searchrect.minx, searchrect.miny);
+  dfY = GEO_TRANS(adfInvGeoTransform + 3, searchrect.minx, searchrect.miny);
+  dfXMin = MS_MIN(dfXMin, dfX);
+  dfXMax = MS_MAX(dfXMax, dfX);
+  dfYMin = MS_MIN(dfYMin, dfY);
+  dfYMax = MS_MAX(dfYMax, dfY);
 
   /* bottom right */
-  dfX = GEO_TRANS(adfInvGeoTransform  , searchrect.maxx, searchrect.miny);
-  dfY = GEO_TRANS(adfInvGeoTransform+3, searchrect.maxx, searchrect.miny);
-  dfXMin = MS_MIN(dfXMin,dfX);
-  dfXMax = MS_MAX(dfXMax,dfX);
-  dfYMin = MS_MIN(dfYMin,dfY);
-  dfYMax = MS_MAX(dfYMax,dfY);
+  dfX = GEO_TRANS(adfInvGeoTransform, searchrect.maxx, searchrect.miny);
+  dfY = GEO_TRANS(adfInvGeoTransform + 3, searchrect.maxx, searchrect.miny);
+  dfXMin = MS_MIN(dfXMin, dfX);
+  dfXMax = MS_MAX(dfXMax, dfX);
+  dfYMin = MS_MIN(dfYMin, dfY);
+  dfYMax = MS_MAX(dfYMax, dfY);
 
   /* -------------------------------------------------------------------- */
   /*      Trim the rectangle to the area of the file itself, but out      */
   /*      to the edges of the touched edge pixels.                        */
   /* -------------------------------------------------------------------- */
-  dfXMin = MS_MAX(0.0,MS_MIN(nRXSize,floor(dfXMin)));
-  dfYMin = MS_MAX(0.0,MS_MIN(nRYSize,floor(dfYMin)));
-  dfXMax = MS_MAX(0.0,MS_MIN(nRXSize,ceil(dfXMax)));
-  dfYMax = MS_MAX(0.0,MS_MIN(nRYSize,ceil(dfYMax)));
+  dfXMin = MS_MAX(0.0, MS_MIN(nRXSize, floor(dfXMin)));
+  dfYMin = MS_MAX(0.0, MS_MIN(nRYSize, floor(dfYMin)));
+  dfXMax = MS_MAX(0.0, MS_MIN(nRXSize, ceil(dfXMax)));
+  dfYMax = MS_MAX(0.0, MS_MIN(nRYSize, ceil(dfYMax)));
 
   /* -------------------------------------------------------------------- */
   /*      Convert to integer offset/size values.                          */
   /* -------------------------------------------------------------------- */
-  nWinXOff = (int) dfXMin;
-  nWinYOff = (int) dfYMin;
-  nWinXSize = (int) (dfXMax - dfXMin);
-  nWinYSize = (int) (dfYMax - dfYMin);
+  nWinXOff = (int)dfXMin;
+  nWinYOff = (int)dfYMin;
+  nWinXSize = (int)(dfXMax - dfXMin);
+  nWinYSize = (int)(dfYMax - dfYMin);
 
   /* -------------------------------------------------------------------- */
   /*      What bands are we operating on?                                 */
   /* -------------------------------------------------------------------- */
-  panBandMap = msGetGDALBandList( layer, hDS, 0, &nBandCount );
+  panBandMap = msGetGDALBandList(layer, hDS, 0, &nBandCount);
 
-  if( rlinfo->band_count == -1 )
+  if (rlinfo->band_count == -1)
     rlinfo->band_count = nBandCount;
 
-  if( nBandCount != rlinfo->band_count ) {
-    msSetError( MS_IMGERR,
-                "Got %d bands, but expected %d bands.",
-                "msRasterQueryByRectLow()",
-                nBandCount, rlinfo->band_count );
+  if (nBandCount != rlinfo->band_count) {
+    msSetError(MS_IMGERR, "Got %d bands, but expected %d bands.",
+               "msRasterQueryByRectLow()", nBandCount, rlinfo->band_count);
 
     return -1;
   }
@@ -510,33 +506,30 @@ msRasterQueryByRectLow(mapObj *map, laye
   /*      band in the file.  Later we will deal with the various band     */
   /*      selection criteria.                                             */
   /* -------------------------------------------------------------------- */
-  pafRaster = (float *)
-              calloc(sizeof(float),nWinXSize*nWinYSize*nBandCount);
-  MS_CHECK_ALLOC(pafRaster, sizeof(float)*nWinXSize*nWinYSize*nBandCount, -1);
-
-  eErr = GDALDatasetRasterIO( hDS, GF_Read,
-                              nWinXOff, nWinYOff, nWinXSize, nWinYSize,
-                              pafRaster, nWinXSize, nWinYSize, GDT_Float32,
-                              nBandCount, panBandMap,
-                              4 * nBandCount,
-                              4 * nBandCount * nWinXSize,
-                              4 );
-
-  if( eErr != CE_None ) {
-    msSetError( MS_IOERR, "GDALDatasetRasterIO() failed: %s",
-                "msRasterQueryByRectLow()", CPLGetLastErrorMsg() );
+  pafRaster =
+      (float *)calloc(sizeof(float), nWinXSize * nWinYSize * nBandCount);
+  MS_CHECK_ALLOC(pafRaster, sizeof(float) * nWinXSize * nWinYSize * nBandCount,
+                 -1);
+
+  eErr = GDALDatasetRasterIO(hDS, GF_Read, nWinXOff, nWinYOff, nWinXSize,
+                             nWinYSize, pafRaster, nWinXSize, nWinYSize,
+                             GDT_Float32, nBandCount, panBandMap,
+                             4 * nBandCount, 4 * nBandCount * nWinXSize, 4);
+
+  if (eErr != CE_None) {
+    msSetError(MS_IOERR, "GDALDatasetRasterIO() failed: %s",
+               "msRasterQueryByRectLow()", CPLGetLastErrorMsg());
 
-    free( pafRaster );
+    free(pafRaster);
     return -1;
   }
 
   /* -------------------------------------------------------------------- */
   /*      Fetch color table for intepreting colors if needed.             */
   /* -------------------------------------------------------------------- */
-  rlinfo->hCT = GDALGetRasterColorTable(
-                  GDALGetRasterBand( hDS, panBandMap[0] ) );
+  rlinfo->hCT = GDALGetRasterColorTable(GDALGetRasterBand(hDS, panBandMap[0]));
 
-  free( panBandMap );
+  free(panBandMap);
 
   /* -------------------------------------------------------------------- */
   /*      When computing whether pixels are within range we do it         */
@@ -546,47 +539,44 @@ msRasterQueryByRectLow(mapObj *map, laye
   /*      add a fudge factor so that a range of zero will find the        */
   /*      pixel the target falls in at least.                             */
   /* -------------------------------------------------------------------- */
-  dfAdjustedRange =
-    sqrt(adfGeoTransform[1] * adfGeoTransform[1]
-         + adfGeoTransform[2] * adfGeoTransform[2]
-         + adfGeoTransform[4] * adfGeoTransform[4]
-         + adfGeoTransform[5] * adfGeoTransform[5]) * 0.5 * 1.41421356237
-    + sqrt( rlinfo->range_dist );
+  dfAdjustedRange = sqrt(adfGeoTransform[1] * adfGeoTransform[1] +
+                         adfGeoTransform[2] * adfGeoTransform[2] +
+                         adfGeoTransform[4] * adfGeoTransform[4] +
+                         adfGeoTransform[5] * adfGeoTransform[5]) *
+                        0.5 * 1.41421356237 +
+                    sqrt(rlinfo->range_dist);
   dfAdjustedRange = dfAdjustedRange * dfAdjustedRange;
 
 #if PROJ_VERSION_MAJOR < 6
-    if( layer->project &&
-        msProjIsGeographicCRS(&(layer->projection)) &&
-        msProjIsGeographicCRS(&(map->projection)) )
-    {
-        double dfLonWrap = 0;
-        mayNeedLonWrapAdjustment = msProjectHasLonWrap(&(layer->projection), &dfLonWrap);
-    }
+  if (layer->project && msProjIsGeographicCRS(&(layer->projection)) &&
+      msProjIsGeographicCRS(&(map->projection))) {
+    double dfLonWrap = 0;
+    mayNeedLonWrapAdjustment =
+        msProjectHasLonWrap(&(layer->projection), &dfLonWrap);
+  }
 #endif
 
-  reprojectionObj* reprojector = NULL;
-  if( layer->project )
-  {
-      reprojector = msProjectCreateReprojector(&(layer->projection), &(map->projection));
+  reprojectionObj *reprojector = NULL;
+  if (layer->project) {
+    reprojector =
+        msProjectCreateReprojector(&(layer->projection), &(map->projection));
   }
 
   /* -------------------------------------------------------------------- */
   /*      Loop over all pixels determining which are "in".                */
   /* -------------------------------------------------------------------- */
-  for( iLine = 0; iLine < nWinYSize; iLine++ ) {
-    for( iPixel = 0; iPixel < nWinXSize; iPixel++ ) {
-      pointObj  sPixelLocation = {0};
+  for (iLine = 0; iLine < nWinYSize; iLine++) {
+    for (iPixel = 0; iPixel < nWinXSize; iPixel++) {
+      pointObj sPixelLocation = {0};
 
-      if( rlinfo->query_results == rlinfo->query_result_hard_max )
+      if (rlinfo->query_results == rlinfo->query_result_hard_max)
         break;
 
       /* transform pixel/line to georeferenced */
-      sPixelLocation.x =
-        GEO_TRANS(adfGeoTransform,
-                  iPixel + nWinXOff + 0.5, iLine + nWinYOff + 0.5 );
-      sPixelLocation.y =
-        GEO_TRANS(adfGeoTransform+3,
-                  iPixel + nWinXOff + 0.5, iLine + nWinYOff + 0.5 );
+      sPixelLocation.x = GEO_TRANS(adfGeoTransform, iPixel + nWinXOff + 0.5,
+                                   iLine + nWinYOff + 0.5);
+      sPixelLocation.y = GEO_TRANS(adfGeoTransform + 3, iPixel + nWinXOff + 0.5,
+                                   iLine + nWinYOff + 0.5);
 
       /* If projections differ, convert this back into the map  */
       /* projection for distance testing, and comprison to the  */
@@ -594,80 +584,79 @@ msRasterQueryByRectLow(mapObj *map, laye
       /* in sPixelLocationInLayerSRS, so that we can return those */
       /* coordinates if we have a hit */
       pointObj sReprojectedPixelLocation = sPixelLocation;
-      if( reprojector )
-      {
+      if (reprojector) {
 #if PROJ_VERSION_MAJOR < 6
         /* Works around a bug in PROJ < 6 when reprojecting from a lon_wrap */
         /* geogCRS to a geogCRS, and the input abs(longitude) is > 180. Then */
-        /* lon_wrap was ignored and the output longitude remained as the source */
-        if( mayNeedLonWrapAdjustment )
-        {
-            if( rlinfo->target_point.x < sReprojectedPixelLocation.x - 180 )
-                sReprojectedPixelLocation.x -= 360;
-            else if( rlinfo->target_point.x > sReprojectedPixelLocation.x + 180 )
-                sReprojectedPixelLocation.x += 360;
+        /* lon_wrap was ignored and the output longitude remained as the source
+         */
+        if (mayNeedLonWrapAdjustment) {
+          if (rlinfo->target_point.x < sReprojectedPixelLocation.x - 180)
+            sReprojectedPixelLocation.x -= 360;
+          else if (rlinfo->target_point.x > sReprojectedPixelLocation.x + 180)
+            sReprojectedPixelLocation.x += 360;
         }
 #endif
 
-        msProjectPointEx( reprojector, &sReprojectedPixelLocation);
+        msProjectPointEx(reprojector, &sReprojectedPixelLocation);
       }
 
       /* If we are doing QueryByShape, check against the shape now */
-      if( rlinfo->searchshape != NULL ) {
-        if( rlinfo->shape_tolerance == 0.0
-            && rlinfo->searchshape->type == MS_SHAPE_POLYGON ) {
-          if( msIntersectPointPolygon(
-                &sReprojectedPixelLocation, rlinfo->searchshape ) == MS_FALSE )
+      if (rlinfo->searchshape != NULL) {
+        if (rlinfo->shape_tolerance == 0.0 &&
+            rlinfo->searchshape->type == MS_SHAPE_POLYGON) {
+          if (msIntersectPointPolygon(&sReprojectedPixelLocation,
+                                      rlinfo->searchshape) == MS_FALSE)
             continue;
         } else {
-          shapeObj  tempShape;
-          lineObj   tempLine;
+          shapeObj tempShape;
+          lineObj tempLine;
 
-          memset( &tempShape, 0, sizeof(shapeObj) );
+          memset(&tempShape, 0, sizeof(shapeObj));
           tempShape.type = MS_SHAPE_POINT;
           tempShape.numlines = 1;
           tempShape.line = &tempLine;
           tempLine.numpoints = 1;
           tempLine.point = &sReprojectedPixelLocation;
 
-          if( msDistanceShapeToShape(rlinfo->searchshape, &tempShape)
-              > rlinfo->shape_tolerance )
+          if (msDistanceShapeToShape(rlinfo->searchshape, &tempShape) >
+              rlinfo->shape_tolerance)
             continue;
         }
       }
 
-      if( rlinfo->range_mode >= 0 ) {
+      if (rlinfo->range_mode >= 0) {
         double dist;
 
-        dist = (rlinfo->target_point.x - sReprojectedPixelLocation.x)
-               * (rlinfo->target_point.x - sReprojectedPixelLocation.x)
-               + (rlinfo->target_point.y - sReprojectedPixelLocation.y)
-               * (rlinfo->target_point.y - sReprojectedPixelLocation.y);
+        dist = (rlinfo->target_point.x - sReprojectedPixelLocation.x) *
+                   (rlinfo->target_point.x - sReprojectedPixelLocation.x) +
+               (rlinfo->target_point.y - sReprojectedPixelLocation.y) *
+                   (rlinfo->target_point.y - sReprojectedPixelLocation.y);
 
-        if( dist >= dfAdjustedRange )
+        if (dist >= dfAdjustedRange)
           continue;
 
         /* If we can only have one feature, trim range and clear */
         /* previous result.  */
-        if( rlinfo->range_mode == MS_QUERY_SINGLE ) {
+        if (rlinfo->range_mode == MS_QUERY_SINGLE) {
           rlinfo->range_dist = dist;
           rlinfo->query_results = 0;
         }
       }
 
-      msRasterQueryAddPixel( layer,
-			                       &sPixelLocation, // return coords in layer SRS
-                             &sReprojectedPixelLocation,
-                             pafRaster
-                             + (iLine*nWinXSize + iPixel) * nBandCount );
+      msRasterQueryAddPixel(layer,
+                            &sPixelLocation, // return coords in layer SRS
+                            &sReprojectedPixelLocation,
+                            pafRaster +
+                                (iLine * nWinXSize + iPixel) * nBandCount);
     }
   }
 
   /* -------------------------------------------------------------------- */
   /*      Cleanup.                                                        */
   /* -------------------------------------------------------------------- */
-  free( pafRaster );
-  msProjectDestroyReprojector( reprojector );
+  free(pafRaster);
+  msProjectDestroyReprojector(reprojector);
 
   return MS_SUCCESS;
 }
@@ -680,13 +669,13 @@ int msRasterQueryByRect(mapObj *map, lay
 
 {
   int status = MS_SUCCESS;
-  char *filename=NULL;
+  char *filename = NULL;
 
-  layerObj *tlp=NULL; /* pointer to the tile layer either real or temporary */
-  int tileitemindex=-1, tilelayerindex=-1, tilesrsindex=-1;
+  layerObj *tlp = NULL; /* pointer to the tile layer either real or temporary */
+  int tileitemindex = -1, tilelayerindex = -1, tilesrsindex = -1;
   shapeObj tshp;
   char tilename[MS_PATH_LENGTH], tilesrsname[1024];
-  int  done, destroy_on_failure;
+  int done, destroy_on_failure;
 
   char szPath[MS_MAXPATHLEN];
   rectObj searchrect;
@@ -695,19 +684,20 @@ int msRasterQueryByRect(mapObj *map, lay
   /* -------------------------------------------------------------------- */
   /*      Get the layer info.                                             */
   /* -------------------------------------------------------------------- */
-  if(!layer->layerinfo) {
-    msRasterLayerInfoInitialize( layer );
+  if (!layer->layerinfo) {
+    msRasterLayerInfoInitialize(layer);
     destroy_on_failure = 1;
   } else {
     destroy_on_failure = 0;
   }
-  rlinfo = (rasterLayerInfo *) layer->layerinfo;
+  rlinfo = (rasterLayerInfo *)layer->layerinfo;
 
   /* -------------------------------------------------------------------- */
   /*      Clear old results cache.                                        */
   /* -------------------------------------------------------------------- */
-  if(layer->resultcache) {
-    if(layer->resultcache->results) free(layer->resultcache->results);
+  if (layer->resultcache) {
+    if (layer->resultcache->results)
+      free(layer->resultcache->results);
     free(layer->resultcache);
     layer->resultcache = NULL;
   }
@@ -718,50 +708,49 @@ int msRasterQueryByRect(mapObj *map, lay
   layer->resultcache = (resultCacheObj *)msSmallMalloc(sizeof(resultCacheObj));
   layer->resultcache->results = NULL;
   layer->resultcache->numresults = layer->resultcache->cachesize = 0;
-  layer->resultcache->bounds.minx =
-    layer->resultcache->bounds.miny =
-      layer->resultcache->bounds.maxx =
-        layer->resultcache->bounds.maxy = -1;
+  layer->resultcache->bounds.minx = layer->resultcache->bounds.miny =
+      layer->resultcache->bounds.maxx = layer->resultcache->bounds.maxy = -1;
 
   /* -------------------------------------------------------------------- */
   /*      Check if we should really be acting on this layer and           */
   /*      provide debug info in various cases.                            */
   /* -------------------------------------------------------------------- */
-  if(layer->debug > 0 || map->debug > 1)
-    msDebug( "msRasterQueryByRect(%s): entering.\n", layer->name );
+  if (layer->debug > 0 || map->debug > 1)
+    msDebug("msRasterQueryByRect(%s): entering.\n", layer->name);
 
-  if(!layer->data && !layer->tileindex) {
-    if(layer->debug > 0 || map->debug > 0 )
-      msDebug( "msRasterQueryByRect(%s): layer data and tileindex NULL ... doing nothing.", layer->name );
+  if (!layer->data && !layer->tileindex) {
+    if (layer->debug > 0 || map->debug > 0)
+      msDebug("msRasterQueryByRect(%s): layer data and tileindex NULL ... "
+              "doing nothing.",
+              layer->name);
     return MS_SUCCESS;
   }
 
-  if((layer->status != MS_ON) && layer->status != MS_DEFAULT ) {
-    if(layer->debug > 0 )
-      msDebug( "msRasterQueryByRect(%s): not status ON or DEFAULT, doing nothing.", layer->name );
+  if ((layer->status != MS_ON) && layer->status != MS_DEFAULT) {
+    if (layer->debug > 0)
+      msDebug(
+          "msRasterQueryByRect(%s): not status ON or DEFAULT, doing nothing.",
+          layer->name);
     return MS_SUCCESS;
   }
 
   /* ==================================================================== */
   /*      Handle setting up tileindex layer.                              */
   /* ==================================================================== */
-  if(layer->tileindex) { /* we have an index file */
+  if (layer->tileindex) { /* we have an index file */
     msInitShape(&tshp);
     searchrect = queryRect;
 
-    status = msDrawRasterSetupTileLayer(map, layer,
-                           &searchrect,
-                           MS_TRUE,
-                           &tilelayerindex,
-                           &tileitemindex,
-                           &tilesrsindex,
-                           &tlp);
+    status = msDrawRasterSetupTileLayer(map, layer, &searchrect, MS_TRUE,
+                                        &tilelayerindex, &tileitemindex,
+                                        &tilesrsindex, &tlp);
     if (status != MS_SUCCESS) {
       goto cleanup;
     }
   } else {
-    /* we have to manually apply to scaletoken logic as we're not going through msLayerOpen() */
-    status = msLayerApplyScaletokens(layer,map->scaledenom);
+    /* we have to manually apply to scaletoken logic as we're not going through
+     * msLayerOpen() */
+    status = msLayerApplyScaletokens(layer, map->scaledenom);
     if (status != MS_SUCCESS) {
       goto cleanup;
     }
@@ -771,31 +760,32 @@ int msRasterQueryByRect(mapObj *map, lay
   /*      Iterate over all tiles (just one in untiled case).              */
   /* -------------------------------------------------------------------- */
   done = MS_FALSE;
-  while( done == MS_FALSE && status == MS_SUCCESS ) {
+  while (done == MS_FALSE && status == MS_SUCCESS) {
 
-    GDALDatasetH  hDS;
+    GDALDatasetH hDS;
     char *decrypted_path = NULL;
 
     /* -------------------------------------------------------------------- */
     /*      Get filename.                                                   */
     /* -------------------------------------------------------------------- */
-    if(layer->tileindex) {
-      status = msDrawRasterIterateTileIndex(layer, tlp, &tshp,
-                                            tileitemindex, tilesrsindex,
-                                            tilename, sizeof(tilename),
-                                            tilesrsname, sizeof(tilesrsname));
-      if( status == MS_FAILURE) {
+    if (layer->tileindex) {
+      status = msDrawRasterIterateTileIndex(
+          layer, tlp, &tshp, tileitemindex, tilesrsindex, tilename,
+          sizeof(tilename), tilesrsname, sizeof(tilesrsname));
+      if (status == MS_FAILURE) {
         break;
       }
 
-      if(status == MS_DONE) break; /* no more tiles/images */
+      if (status == MS_DONE)
+        break; /* no more tiles/images */
       filename = tilename;
     } else {
       filename = layer->data;
       done = MS_TRUE; /* only one image so we're done after this */
     }
 
-    if(strlen(filename) == 0) continue;
+    if (strlen(filename) == 0)
+      continue;
 
     /* -------------------------------------------------------------------- */
     /*      Open the file.                                                  */
@@ -804,72 +794,69 @@ int msRasterQueryByRect(mapObj *map, lay
 
     msDrawRasterBuildRasterPath(map, layer, filename, szPath);
 
-    decrypted_path = msDecryptStringTokens( map, szPath );
-    if( !decrypted_path ) {
+    decrypted_path = msDecryptStringTokens(map, szPath);
+    if (!decrypted_path) {
       status = MS_FAILURE;
       goto cleanup;
     }
 
-    msAcquireLock( TLOCK_GDAL );
-    if( !layer->tileindex )
-    {
-        char** connectionoptions = msGetStringListFromHashTable(&(layer->connectionoptions));
-        hDS = GDALOpenEx(decrypted_path,
-                                    GDAL_OF_RASTER,
-                                    NULL,
-                                    (const char* const*)connectionoptions,
-                                    NULL);
-        CSLDestroy(connectionoptions);
-    }
-    else
-    {
-        hDS = GDALOpen(decrypted_path, GA_ReadOnly );
+    msAcquireLock(TLOCK_GDAL);
+    if (!layer->tileindex) {
+      char **connectionoptions =
+          msGetStringListFromHashTable(&(layer->connectionoptions));
+      hDS = GDALOpenEx(decrypted_path, GDAL_OF_RASTER, NULL,
+                       (const char *const *)connectionoptions, NULL);
+      CSLDestroy(connectionoptions);
+    } else {
+      hDS = GDALOpen(decrypted_path, GA_ReadOnly);
     }
 
-    if( hDS == NULL ) {
-      int ignore_missing = msMapIgnoreMissingData( map );
-      const char *cpl_error_msg = msDrawRasterGetCPLErrorMsg(decrypted_path, szPath);
+    if (hDS == NULL) {
+      int ignore_missing = msMapIgnoreMissingData(map);
+      const char *cpl_error_msg =
+          msDrawRasterGetCPLErrorMsg(decrypted_path, szPath);
 
-      msFree( decrypted_path );
+      msFree(decrypted_path);
       decrypted_path = NULL;
 
-      msReleaseLock( TLOCK_GDAL );
+      msReleaseLock(TLOCK_GDAL);
 
-      if ( ignore_missing == MS_MISSING_DATA_FAIL ) {
-        if( layer->debug || map->debug )
-          msSetError( MS_IMGERR,
-                      "Unable to open file %s for layer %s ... fatal error.\n%s",
-                      "msRasterQueryByRect()",
-                      szPath, layer->name, cpl_error_msg);
+      if (ignore_missing == MS_MISSING_DATA_FAIL) {
+        if (layer->debug || map->debug)
+          msSetError(MS_IMGERR,
+                     "Unable to open file %s for layer %s ... fatal error.\n%s",
+                     "msRasterQueryByRect()", szPath, layer->name,
+                     cpl_error_msg);
         status = MS_FAILURE;
         goto cleanup;
       }
-      if( ignore_missing == MS_MISSING_DATA_LOG ) {
-        if( layer->debug || map->debug )
-          msDebug( "Unable to open file %s for layer %s ... ignoring this missing data.\n%s",
-                   filename, layer->name, cpl_error_msg );
+      if (ignore_missing == MS_MISSING_DATA_LOG) {
+        if (layer->debug || map->debug)
+          msDebug("Unable to open file %s for layer %s ... ignoring this "
+                  "missing data.\n%s",
+                  filename, layer->name, cpl_error_msg);
       }
       continue;
     }
 
-    msFree( decrypted_path );
+    msFree(decrypted_path);
     decrypted_path = NULL;
 
-    if( msDrawRasterLoadProjection(layer, hDS, filename, tilesrsindex, tilesrsname) != MS_SUCCESS )
-    {
-        msReleaseLock( TLOCK_GDAL );
-        status = MS_FAILURE;
-        goto cleanup;
+    if (msDrawRasterLoadProjection(layer, hDS, filename, tilesrsindex,
+                                   tilesrsname) != MS_SUCCESS) {
+      msReleaseLock(TLOCK_GDAL);
+      status = MS_FAILURE;
+      goto cleanup;
     }
 
     /* -------------------------------------------------------------------- */
     /*      Perform actual query on this file.                              */
     /* -------------------------------------------------------------------- */
-    if( status == MS_SUCCESS )
-      status = msRasterQueryByRectLow( map, layer, hDS, queryRect );
+    if (status == MS_SUCCESS)
+      status = msRasterQueryByRectLow(map, layer, hDS, queryRect);
 
-    GDALClose( hDS );
-    msReleaseLock( TLOCK_GDAL );
+    GDALClose(hDS);
+    msReleaseLock(TLOCK_GDAL);
 
   } /* next tile */
 
@@ -877,7 +864,7 @@ int msRasterQueryByRect(mapObj *map, lay
   /*      Cleanup tileindex if it is open.                                */
   /* -------------------------------------------------------------------- */
 cleanup:
-  if(layer->tileindex) { /* tiling clean-up */
+  if (layer->tileindex) { /* tiling clean-up */
     msDrawRasterCleanupTileLayer(tlp, tilelayerindex);
   } else {
     msLayerRestoreFromScaletokens(layer);
@@ -887,9 +874,9 @@ cleanup:
   /*      On failure, or empty result set, cleanup the rlinfo since we    */
   /*      likely won't ever have it accessed or cleaned up later.         */
   /* -------------------------------------------------------------------- */
-  if( status == MS_FAILURE || rlinfo->query_results == 0 ) {
-    if(destroy_on_failure) {
-      msRasterLayerInfoFree( layer );
+  if (status == MS_FAILURE || rlinfo->query_results == 0) {
+    if (destroy_on_failure) {
+      msRasterLayerInfoFree(layer);
     }
   } else {
     /* populate the items/numitems layer-level values */
@@ -911,14 +898,14 @@ int msRasterQueryByShape(mapObj *map, la
   double tolerance;
   rectObj searchrect;
 
-  msRasterLayerInfoInitialize( layer );
+  msRasterLayerInfoInitialize(layer);
 
-  rlinfo = (rasterLayerInfo *) layer->layerinfo;
+  rlinfo = (rasterLayerInfo *)layer->layerinfo;
 
   /* If the selection shape is point or line we use the default tolerance of
      3, but for polygons we require an exact hit. */
-  if(layer->tolerance == -1) {
-    if(selectshape->type == MS_SHAPE_POINT ||
+  if (layer->tolerance == -1) {
+    if (selectshape->type == MS_SHAPE_POINT ||
         selectshape->type == MS_SHAPE_LINE)
       tolerance = 3;
     else
@@ -926,26 +913,26 @@ int msRasterQueryByShape(mapObj *map, la
   } else
     tolerance = layer->tolerance;
 
-  if(layer->toleranceunits == MS_PIXELS)
-    tolerance = tolerance
-                * msAdjustExtent(&(map->extent), map->width, map->height);
+  if (layer->toleranceunits == MS_PIXELS)
+    tolerance =
+        tolerance * msAdjustExtent(&(map->extent), map->width, map->height);
   else
-    tolerance = tolerance
-                * (msInchesPerUnit(layer->toleranceunits,0)
-                   / msInchesPerUnit(map->units,0));
+    tolerance = tolerance * (msInchesPerUnit(layer->toleranceunits, 0) /
+                             msInchesPerUnit(map->units, 0));
 
   rlinfo->searchshape = selectshape;
   rlinfo->shape_tolerance = tolerance;
 
-  msComputeBounds( selectshape );
+  msComputeBounds(selectshape);
   searchrect = selectshape->bounds;
 
-  searchrect.minx -= tolerance; /* expand the search box to account for layer tolerances (e.g. buffered searches) */
+  searchrect.minx -= tolerance; /* expand the search box to account for layer
+                                   tolerances (e.g. buffered searches) */
   searchrect.maxx += tolerance;
   searchrect.miny -= tolerance;
   searchrect.maxy += tolerance;
 
-  status = msRasterQueryByRect( map, layer, searchrect );
+  status = msRasterQueryByRect(map, layer, searchrect);
 
   rlinfo->searchshape = NULL;
 
@@ -957,16 +944,15 @@ int msRasterQueryByShape(mapObj *map, la
 /************************************************************************/
 
 int msRasterQueryByPoint(mapObj *map, layerObj *layer, int mode, pointObj p,
-                         double buffer, int maxresults)
-{
+                         double buffer, int maxresults) {
   int result;
   double layer_tolerance;
   rectObj bufferRect;
   rasterLayerInfo *rlinfo = NULL;
 
-  msRasterLayerInfoInitialize( layer );
+  msRasterLayerInfoInitialize(layer);
 
-  rlinfo = (rasterLayerInfo *) layer->layerinfo;
+  rlinfo = (rasterLayerInfo *)layer->layerinfo;
 
   /* -------------------------------------------------------------------- */
   /*      If the buffer is not set, then use layer tolerances             */
@@ -976,19 +962,18 @@ int msRasterQueryByPoint(mapObj *map, la
   /*      clear that there is any way of requesting a buffer size in      */
   /*      underlying pixels.                                              */
   /* -------------------------------------------------------------------- */
-  if(buffer <= 0) { /* use layer tolerance */
-    if(layer->tolerance == -1)
+  if (buffer <= 0) { /* use layer tolerance */
+    if (layer->tolerance == -1)
       layer_tolerance = 3;
     else
       layer_tolerance = layer->tolerance;
 
-    if(layer->toleranceunits == MS_PIXELS)
-      buffer = layer_tolerance
-               * msAdjustExtent(&(map->extent), map->width, map->height);
+    if (layer->toleranceunits == MS_PIXELS)
+      buffer = layer_tolerance *
+               msAdjustExtent(&(map->extent), map->width, map->height);
     else
-      buffer = layer_tolerance
-               * (msInchesPerUnit(layer->toleranceunits,0)
-                  / msInchesPerUnit(map->units,0));
+      buffer = layer_tolerance * (msInchesPerUnit(layer->toleranceunits, 0) /
+                                  msInchesPerUnit(map->units, 0));
   }
 
   /* -------------------------------------------------------------------- */
@@ -1005,7 +990,7 @@ int msRasterQueryByPoint(mapObj *map, la
   /*      point.  This will potentially be must more efficient than       */
   /*      processing all pixels within the tolerance.                     */
   /* -------------------------------------------------------------------- */
-  if( mode == MS_QUERY_SINGLE ) {
+  if (mode == MS_QUERY_SINGLE) {
     rectObj pointRect;
 
     pointRect.minx = p.x;
@@ -1014,8 +999,8 @@ int msRasterQueryByPoint(mapObj *map, la
     pointRect.maxy = p.y;
 
     rlinfo->range_mode = MS_QUERY_SINGLE;
-    result = msRasterQueryByRect( map, layer, pointRect );
-    if( rlinfo->query_results > 0 )
+    result = msRasterQueryByRect(map, layer, pointRect);
+    if (rlinfo->query_results > 0)
       return result;
   }
 
@@ -1030,13 +1015,13 @@ int msRasterQueryByPoint(mapObj *map, la
 
   rlinfo->range_mode = mode;
 
-  if( maxresults != 0 ) {
+  if (maxresults != 0) {
     const int previous_maxresults = rlinfo->query_result_hard_max;
     rlinfo->query_result_hard_max = maxresults;
-    result = msRasterQueryByRect( map, layer, bufferRect );
+    result = msRasterQueryByRect(map, layer, bufferRect);
     rlinfo->query_result_hard_max = previous_maxresults;
   } else {
-    result = msRasterQueryByRect( map, layer, bufferRect );
+    result = msRasterQueryByRect(map, layer, bufferRect);
   }
 
   return result;
@@ -1055,17 +1040,16 @@ int msRasterQueryByPoint(mapObj *map, la
 /*                         msRASTERLayerOpen()                          */
 /************************************************************************/
 
-int msRASTERLayerOpen(layerObj *layer)
-{
+int msRASTERLayerOpen(layerObj *layer) {
   rasterLayerInfo *rlinfo;
 
   /* If we don't have info, initialize an empty one now */
-  if( layer->layerinfo == NULL )
-    msRasterLayerInfoInitialize( layer );
-  if( layer->layerinfo == NULL )
+  if (layer->layerinfo == NULL)
+    msRasterLayerInfoInitialize(layer);
+  if (layer->layerinfo == NULL)
     return MS_FAILURE;
 
-  rlinfo = (rasterLayerInfo *) layer->layerinfo;
+  rlinfo = (rasterLayerInfo *)layer->layerinfo;
 
   rlinfo->refcount = rlinfo->refcount + 1;
 
@@ -1076,21 +1060,16 @@ int msRASTERLayerOpen(layerObj *layer)
 /*                         msRASTERIsLayerOpen()                        */
 /************************************************************************/
 
-int msRASTERLayerIsOpen(layerObj *layer)
-{
+int msRASTERLayerIsOpen(layerObj *layer) {
   if (layer->layerinfo)
     return MS_TRUE;
   return MS_FALSE;
 }
 
-
 /************************************************************************/
 /*                     msRASTERLayerFreeItemInfo()                      */
 /************************************************************************/
-void msRASTERLayerFreeItemInfo(layerObj *layer)
-{
-  (void)layer;
-}
+void msRASTERLayerFreeItemInfo(layerObj *layer) { (void)layer; }
 
 /************************************************************************/
 /*                     msRASTERLayerInitItemInfo()                      */
@@ -1098,8 +1077,7 @@ void msRASTERLayerFreeItemInfo(layerObj
 /*      Perhaps we should be validating the requested items here?       */
 /************************************************************************/
 
-int msRASTERLayerInitItemInfo(layerObj *layer)
-{
+int msRASTERLayerInitItemInfo(layerObj *layer) {
   (void)layer;
   return MS_SUCCESS;
 }
@@ -1111,7 +1089,7 @@ int msRASTERLayerWhichShapes(layerObj *l
 
 {
   (void)isQuery;
-  rasterLayerInfo *rlinfo = (rasterLayerInfo *) layer->layerinfo;
+  rasterLayerInfo *rlinfo = (rasterLayerInfo *)layer->layerinfo;
 
   rlinfo->which_rect = rect;
   rlinfo->next_shape = 0;
@@ -1123,15 +1101,14 @@ int msRASTERLayerWhichShapes(layerObj *l
 /*                         msRASTERLayerClose()                         */
 /************************************************************************/
 
-int msRASTERLayerClose(layerObj *layer)
-{
-  rasterLayerInfo *rlinfo = (rasterLayerInfo *) layer->layerinfo;
+int msRASTERLayerClose(layerObj *layer) {
+  rasterLayerInfo *rlinfo = (rasterLayerInfo *)layer->layerinfo;
 
-  if( rlinfo != NULL ) {
+  if (rlinfo != NULL) {
     rlinfo->refcount--;
 
-    if( rlinfo->refcount < 0 )
-      msRasterLayerInfoFree( layer );
+    if (rlinfo->refcount < 0)
+      msRasterLayerInfoFree(layer);
   }
   return MS_SUCCESS;
 }
@@ -1140,12 +1117,10 @@ int msRASTERLayerClose(layerObj *layer)
 /*                       msRASTERLayerNextShape()                       */
 /************************************************************************/
 
-int msRASTERLayerNextShape(layerObj *layer, shapeObj *shape)
-{
-  rasterLayerInfo *rlinfo = (rasterLayerInfo *) layer->layerinfo;
+int msRASTERLayerNextShape(layerObj *layer, shapeObj *shape) {
+  rasterLayerInfo *rlinfo = (rasterLayerInfo *)layer->layerinfo;
 
-  if( rlinfo->next_shape < 0
-      || rlinfo->next_shape >= rlinfo->query_results ) {
+  if (rlinfo->next_shape < 0 || rlinfo->next_shape >= rlinfo->query_results) {
     msFreeShape(shape);
     shape->type = MS_SHAPE_NULL;
     return MS_DONE;
@@ -1156,7 +1131,7 @@ int msRASTERLayerNextShape(layerObj *lay
     record.tileindex = 0;
     record.classindex = record.resultindex = -1;
 
-    return msRASTERLayerGetShape( layer, shape, &record);
+    return msRASTERLayerGetShape(layer, shape, &record);
   }
 }
 
@@ -1164,9 +1139,8 @@ int msRASTERLayerNextShape(layerObj *lay
 /*                       msRASTERLayerGetShape()                        */
 /************************************************************************/
 
-int msRASTERLayerGetShape(layerObj *layer, shapeObj *shape, resultObj *record)
-{
-  rasterLayerInfo *rlinfo = (rasterLayerInfo *) layer->layerinfo;
+int msRASTERLayerGetShape(layerObj *layer, shapeObj *shape, resultObj *record) {
+  rasterLayerInfo *rlinfo = (rasterLayerInfo *)layer->layerinfo;
   int i;
 
   long shapeindex = record->shapeindex;
@@ -1177,19 +1151,18 @@ int msRASTERLayerGetShape(layerObj *laye
   /* -------------------------------------------------------------------- */
   /*      Validate requested record id.                                   */
   /* -------------------------------------------------------------------- */
-  if( shapeindex < 0 || shapeindex >= rlinfo->query_results ) {
+  if (shapeindex < 0 || shapeindex >= rlinfo->query_results) {
     msSetError(MS_MISCERR,
                "Out of range shape index requested.  Requested %ld\n"
                "but only %d shapes available.",
-               "msRASTERLayerGetShape()",
-               shapeindex, rlinfo->query_results );
+               "msRASTERLayerGetShape()", shapeindex, rlinfo->query_results);
     return MS_FAILURE;
   }
 
   /* -------------------------------------------------------------------- */
   /*      Apply the geometry.                                             */
   /* -------------------------------------------------------------------- */
-  if( rlinfo->qc_x != NULL ) {
+  if (rlinfo->qc_x != NULL) {
     lineObj line;
     pointObj point;
 
@@ -1202,56 +1175,55 @@ int msRASTERLayerGetShape(layerObj *laye
     point.y = rlinfo->qc_y[shapeindex];
     point.m = 0.0;
 
-    msAddLine( shape, &line );
-    msComputeBounds( shape );
+    msAddLine(shape, &line);
+    msComputeBounds(shape);
   }
 
   /* -------------------------------------------------------------------- */
   /*      Apply the requested items.                                      */
   /* -------------------------------------------------------------------- */
-  if( layer->numitems > 0 ) {
-    shape->values = (char **) msSmallMalloc(sizeof(char *) * layer->numitems);
+  if (layer->numitems > 0) {
+    shape->values = (char **)msSmallMalloc(sizeof(char *) * layer->numitems);
     shape->numvalues = layer->numitems;
 
-    for( i = 0; i < layer->numitems; i++ ) {
+    for (i = 0; i < layer->numitems; i++) {
       const size_t bufferSize = 1000;
       char szWork[1000];
 
       szWork[0] = '\0';
-      if( EQUAL(layer->items[i],"x") && rlinfo->qc_x_reproj )
-        snprintf( szWork, bufferSize, "%.8g", rlinfo->qc_x_reproj[shapeindex] );
-      else if( EQUAL(layer->items[i],"y") && rlinfo->qc_y_reproj )
-        snprintf( szWork, bufferSize, "%.8g", rlinfo->qc_y_reproj[shapeindex] );
+      if (EQUAL(layer->items[i], "x") && rlinfo->qc_x_reproj)
+        snprintf(szWork, bufferSize, "%.8g", rlinfo->qc_x_reproj[shapeindex]);
+      else if (EQUAL(layer->items[i], "y") && rlinfo->qc_y_reproj)
+        snprintf(szWork, bufferSize, "%.8g", rlinfo->qc_y_reproj[shapeindex]);
 
-      else if( EQUAL(layer->items[i],"value_list") && rlinfo->qc_values ) {
+      else if (EQUAL(layer->items[i], "value_list") && rlinfo->qc_values) {
         int iValue;
 
-        for( iValue = 0; iValue < rlinfo->band_count; iValue++ ) {
-          if( iValue != 0 )
-            strlcat( szWork, ",", bufferSize);
-
-          snprintf( szWork+strlen(szWork), bufferSize-strlen(szWork), "%.8g",
-                    rlinfo->qc_values[shapeindex * rlinfo->band_count
-                                      + iValue] );
+        for (iValue = 0; iValue < rlinfo->band_count; iValue++) {
+          if (iValue != 0)
+            strlcat(szWork, ",", bufferSize);
+
+          snprintf(szWork + strlen(szWork), bufferSize - strlen(szWork), "%.8g",
+                   rlinfo->qc_values[shapeindex * rlinfo->band_count + iValue]);
         }
-      } else if( EQUALN(layer->items[i],"value_",6) && rlinfo->qc_values ) {
-        int iValue = atoi(layer->items[i]+6);
-        snprintf( szWork, bufferSize, "%.8g",
-                  rlinfo->qc_values[shapeindex*rlinfo->band_count+iValue] );
-      } else if( EQUAL(layer->items[i],"class") && rlinfo->qc_class ) {
+      } else if (EQUALN(layer->items[i], "value_", 6) && rlinfo->qc_values) {
+        int iValue = atoi(layer->items[i] + 6);
+        snprintf(szWork, bufferSize, "%.8g",
+                 rlinfo->qc_values[shapeindex * rlinfo->band_count + iValue]);
+      } else if (EQUAL(layer->items[i], "class") && rlinfo->qc_class) {
         int p_class = rlinfo->qc_class[shapeindex];
-        if( layer->class[p_class]->name != NULL )
-          snprintf( szWork, bufferSize, "%.999s", layer->class[p_class]->name );
+        if (layer->class[p_class] -> name != NULL)
+          snprintf(szWork, bufferSize, "%.999s", layer->class[p_class] -> name);
         else
-          snprintf( szWork, bufferSize, "%d", p_class );
-      } else if( EQUAL(layer->items[i],"red") && rlinfo->qc_red )
-        snprintf( szWork, bufferSize, "%d", rlinfo->qc_red[shapeindex] );
-      else if( EQUAL(layer->items[i],"green") && rlinfo->qc_green )
-        snprintf( szWork, bufferSize, "%d", rlinfo->qc_green[shapeindex] );
-      else if( EQUAL(layer->items[i],"blue") && rlinfo->qc_blue )
-        snprintf( szWork, bufferSize, "%d", rlinfo->qc_blue[shapeindex] );
-      else if( EQUAL(layer->items[i],"count") && rlinfo->qc_count )
-        snprintf( szWork, bufferSize, "%d", rlinfo->qc_count[shapeindex] );
+          snprintf(szWork, bufferSize, "%d", p_class);
+      } else if (EQUAL(layer->items[i], "red") && rlinfo->qc_red)
+        snprintf(szWork, bufferSize, "%d", rlinfo->qc_red[shapeindex]);
+      else if (EQUAL(layer->items[i], "green") && rlinfo->qc_green)
+        snprintf(szWork, bufferSize, "%d", rlinfo->qc_green[shapeindex]);
+      else if (EQUAL(layer->items[i], "blue") && rlinfo->qc_blue)
+        snprintf(szWork, bufferSize, "%d", rlinfo->qc_blue[shapeindex]);
+      else if (EQUAL(layer->items[i], "count") && rlinfo->qc_count)
+        snprintf(szWork, bufferSize, "%d", rlinfo->qc_count[shapeindex]);
 
       shape->values[i] = msStrdup(szWork);
     }
@@ -1269,40 +1241,39 @@ int msRASTERLayerGetShape(layerObj *laye
 /*                       msRASTERLayerGetItems()                        */
 /************************************************************************/
 
-int msRASTERLayerGetItems(layerObj *layer)
-{
+int msRASTERLayerGetItems(layerObj *layer) {
   int maxnumitems = 0;
-  rasterLayerInfo *rlinfo = (rasterLayerInfo *) layer->layerinfo;
+  rasterLayerInfo *rlinfo = (rasterLayerInfo *)layer->layerinfo;
 
-  if( rlinfo == NULL )
+  if (rlinfo == NULL)
     return MS_FAILURE;
 
-  maxnumitems = 8 + (rlinfo->qc_values?rlinfo->band_count:0);
-  layer->items = (char **) msSmallCalloc(sizeof(char *),maxnumitems);
+  maxnumitems = 8 + (rlinfo->qc_values ? rlinfo->band_count : 0);
+  layer->items = (char **)msSmallCalloc(sizeof(char *), maxnumitems);
 
   layer->numitems = 0;
-  if( rlinfo->qc_x_reproj )
+  if (rlinfo->qc_x_reproj)
     layer->items[layer->numitems++] = msStrdup("x");
-  if( rlinfo->qc_y_reproj )
+  if (rlinfo->qc_y_reproj)
     layer->items[layer->numitems++] = msStrdup("y");
-  if( rlinfo->qc_values ) {
+  if (rlinfo->qc_values) {
     int i;
-    for( i = 0; i < rlinfo->band_count; i++ ) {
+    for (i = 0; i < rlinfo->band_count; i++) {
       char szName[100];
-      snprintf( szName, sizeof(szName), "value_%d", i );
+      snprintf(szName, sizeof(szName), "value_%d", i);
       layer->items[layer->numitems++] = msStrdup(szName);
     }
     layer->items[layer->numitems++] = msStrdup("value_list");
   }
-  if( rlinfo->qc_class )
+  if (rlinfo->qc_class)
     layer->items[layer->numitems++] = msStrdup("class");
-  if( rlinfo->qc_red )
+  if (rlinfo->qc_red)
     layer->items[layer->numitems++] = msStrdup("red");
-  if( rlinfo->qc_green )
+  if (rlinfo->qc_green)
     layer->items[layer->numitems++] = msStrdup("green");
-  if( rlinfo->qc_blue )
+  if (rlinfo->qc_blue)
     layer->items[layer->numitems++] = msStrdup("blue");
-  if( rlinfo->qc_count )
+  if (rlinfo->qc_count)
     layer->items[layer->numitems++] = msStrdup("count");
 
   assert(layer->numitems <= maxnumitems);
@@ -1321,27 +1292,32 @@ int msRASTERLayerGetExtent(layerObj *lay
   mapObj *map = layer->map;
   shapefileObj *tileshpfile;
 
-  if( (!layer->data || strlen(layer->data) == 0)
-      && layer->tileindex == NULL) {
+  if ((!layer->data || strlen(layer->data) == 0) && layer->tileindex == NULL) {
     /* should we be issuing a specific error about not supporting
        extents for tileindexed raster layers? */
     return MS_FAILURE;
   }
 
-  if( map == NULL )
+  if (map == NULL)
     return MS_FAILURE;
 
-  /* If the layer use a tileindex, return the extent of the tileindex shapefile/referenced layer */
+  /* If the layer use a tileindex, return the extent of the tileindex
+   * shapefile/referenced layer */
   if (layer->tileindex) {
     const int tilelayerindex = msGetLayerIndex(map, layer->tileindex);
-    if(tilelayerindex != -1) /* does the tileindex reference another layer */
+    if (tilelayerindex != -1) /* does the tileindex reference another layer */
       return msLayerGetExtent(GET_LAYER(map, tilelayerindex), extent);
     else {
-      tileshpfile = (shapefileObj *) malloc(sizeof(shapefileObj));
+      tileshpfile = (shapefileObj *)malloc(sizeof(shapefileObj));
       MS_CHECK_ALLOC(tileshpfile, sizeof(shapefileObj), MS_FAILURE);
 
-      if(msShapefileOpen(tileshpfile, "rb", msBuildPath3(szPath, map->mappath, map->shapepath, layer->tileindex), MS_TRUE) == -1)
-        if(msShapefileOpen(tileshpfile, "rb", msBuildPath(szPath, map->mappath, layer->tileindex), MS_TRUE) == -1)
+      if (msShapefileOpen(tileshpfile, "rb",
+                          msBuildPath3(szPath, map->mappath, map->shapepath,
+                                       layer->tileindex),
+                          MS_TRUE) == -1)
+        if (msShapefileOpen(tileshpfile, "rb",
+                            msBuildPath(szPath, map->mappath, layer->tileindex),
+                            MS_TRUE) == -1)
           return MS_FAILURE;
 
       *extent = tileshpfile->bounds;
@@ -1352,34 +1328,32 @@ int msRASTERLayerGetExtent(layerObj *lay
   }
 
   msTryBuildPath3(szPath, map->mappath, map->shapepath, layer->data);
-  char* decrypted_path = msDecryptStringTokens( map, szPath );
-  if( !decrypted_path )
-      return MS_FAILURE;
-
-  char** connectionoptions = msGetStringListFromHashTable(&(layer->connectionoptions));
-  GDALDatasetH hDS = GDALOpenEx(decrypted_path,
-                                GDAL_OF_RASTER,
-                                NULL,
-                                (const char* const*)connectionoptions,
-                                NULL);
+  char *decrypted_path = msDecryptStringTokens(map, szPath);
+  if (!decrypted_path)
+    return MS_FAILURE;
+
+  char **connectionoptions =
+      msGetStringListFromHashTable(&(layer->connectionoptions));
+  GDALDatasetH hDS = GDALOpenEx(decrypted_path, GDAL_OF_RASTER, NULL,
+                                (const char *const *)connectionoptions, NULL);
   CSLDestroy(connectionoptions);
-  msFree( decrypted_path );
-  if( hDS == NULL ) {
+  msFree(decrypted_path);
+  if (hDS == NULL) {
     return MS_FAILURE;
   }
 
-  const int nXSize = GDALGetRasterXSize( hDS );
-  const int nYSize = GDALGetRasterYSize( hDS );
+  const int nXSize = GDALGetRasterXSize(hDS);
+  const int nYSize = GDALGetRasterYSize(hDS);
   double adfGeoTransform[6] = {0};
-  const CPLErr eErr = GDALGetGeoTransform( hDS, adfGeoTransform );
-  if( eErr != CE_None ) {
-    GDALClose( hDS );
+  const CPLErr eErr = GDALGetGeoTransform(hDS, adfGeoTransform);
+  if (eErr != CE_None) {
+    GDALClose(hDS);
     return MS_FAILURE;
   }
 
   /* If this appears to be an ungeoreferenced raster than flip it for
      mapservers purposes. */
-  if( adfGeoTransform[5] == 1.0 && adfGeoTransform[3] == 0.0 ) {
+  if (adfGeoTransform[5] == 1.0 && adfGeoTransform[3] == 0.0) {
     adfGeoTransform[5] = -1.0;
     adfGeoTransform[3] = nYSize;
   }
@@ -1393,7 +1367,6 @@ int msRASTERLayerGetExtent(layerObj *lay
   return MS_SUCCESS;
 }
 
-
 /************************************************************************/
 /*                     msRASTERLayerSetTimeFilter()                     */
 /*                                                                      */
@@ -1410,14 +1383,13 @@ int msRASTERLayerGetExtent(layerObj *lay
 /************************************************************************/
 
 int msRASTERLayerSetTimeFilter(layerObj *layer, const char *timestring,
-                               const char *timefield)
-{
+                               const char *timefield) {
   int tilelayerindex;
 
   /* -------------------------------------------------------------------- */
   /*      If we don't have a tileindex the time filter has no effect.     */
   /* -------------------------------------------------------------------- */
-  if( layer->tileindex == NULL )
+  if (layer->tileindex == NULL)
     return MS_SUCCESS;
 
   /* -------------------------------------------------------------------- */
@@ -1432,26 +1404,24 @@ int msRASTERLayerSetTimeFilter(layerObj
   /*      This is propogated to the "working layer" created for the       */
   /*      tileindex by code in mapraster.c.                               */
   /* -------------------------------------------------------------------- */
-  if( tilelayerindex == -1 )
-    return msLayerMakeBackticsTimeFilter( layer, timestring, timefield );
+  if (tilelayerindex == -1)
+    return msLayerMakeBackticsTimeFilter(layer, timestring, timefield);
 
   /* -------------------------------------------------------------------- */
   /*      Otherwise we invoke the tileindex layers SetTimeFilter          */
   /*      method.                                                         */
   /* -------------------------------------------------------------------- */
-  if ( msCheckParentPointer(layer->map,"map")==MS_FAILURE )
+  if (msCheckParentPointer(layer->map, "map") == MS_FAILURE)
     return MS_FAILURE;
-  return msLayerSetTimeFilter( layer->GET_LAYER(map,tilelayerindex),
-                               timestring, timefield );
+  return msLayerSetTimeFilter(layer->GET_LAYER(map, tilelayerindex), timestring,
+                              timefield);
 }
 
 /************************************************************************/
 /*                msRASTERLayerInitializeVirtualTable()                 */
 /************************************************************************/
 
-int
-msRASTERLayerInitializeVirtualTable(layerObj *layer)
-{
+int msRASTERLayerInitializeVirtualTable(layerObj *layer) {
   assert(layer != NULL);
   assert(layer->vtable != NULL);
 
@@ -1476,4 +1446,3 @@ msRASTERLayerInitializeVirtualTable(laye
 
   return MS_SUCCESS;
 }
-
diff -pruN 8.0.1-5/mapregex.c 8.0.2-1/mapregex.c
--- 8.0.1-5/mapregex.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapregex.c	2024-06-11 20:41:34.000000000 +0000
@@ -46,38 +46,51 @@
   doesn't #define away our ms_*/
 
 #if defined(_WIN32) && !defined(__CYGWIN__) && _MSC_VER < 1900
-#define off_t  long
+#define off_t long
 #endif
 
 #include "mapserver.h"
 #include "mapregex.h"
 #include <regex.h>
 
-MS_API_EXPORT(int) ms_regcomp(ms_regex_t *regex, const char *expr, int cflags)
-{
+MS_API_EXPORT(int) ms_regcomp(ms_regex_t *regex, const char *expr, int cflags) {
   /* Must free in regfree() */
-  regex_t* sys_regex = (regex_t*) msSmallMalloc(sizeof(regex_t));
-  regex->sys_regex = (void*) sys_regex;
-  return regcomp(sys_regex, expr, cflags);
+  int reg_cflags = 0;
+  regex_t *sys_regex = (regex_t *)msSmallMalloc(sizeof(regex_t));
+  regex->sys_regex = (void *)sys_regex;
+  if (cflags & MS_REG_EXTENDED)
+    reg_cflags |= REG_EXTENDED;
+  if (cflags & MS_REG_ICASE)
+    reg_cflags |= REG_ICASE;
+  if (cflags & MS_REG_NOSUB)
+    reg_cflags |= REG_NOSUB;
+  if (cflags & MS_REG_NEWLINE)
+    reg_cflags |= REG_NEWLINE;
+  int ret = regcomp(sys_regex, expr, reg_cflags);
+  if (ret != 0) {
+    free(regex->sys_regex);
+    regex->sys_regex = NULL;
+  }
+  return ret;
 }
 
-MS_API_EXPORT(size_t) ms_regerror(int errcode, const ms_regex_t *regex, char *errbuf, size_t errbuf_size)
-{
-  return regerror(errcode, (regex_t*)(regex->sys_regex), errbuf, errbuf_size);
+MS_API_EXPORT(size_t)
+ms_regerror(int errcode, const ms_regex_t *regex, char *errbuf,
+            size_t errbuf_size) {
+  return regerror(errcode, (regex_t *)(regex->sys_regex), errbuf, errbuf_size);
 }
 
-MS_API_EXPORT(int) ms_regexec(const ms_regex_t *regex, const char *string, size_t nmatch, ms_regmatch_t pmatch[], int eflags)
-{
+MS_API_EXPORT(int)
+ms_regexec(const ms_regex_t *regex, const char *string, size_t nmatch,
+           ms_regmatch_t pmatch[], int eflags) {
   /*This next line only works because we know that regmatch_t
     and ms_regmatch_t are exactly alike (POSIX STANDARD)*/
-  return regexec((const regex_t*)(regex->sys_regex),
-                 string, nmatch,
-                 (regmatch_t*) pmatch, eflags);
+  return regexec((const regex_t *)(regex->sys_regex), string, nmatch,
+                 (regmatch_t *)pmatch, eflags);
 }
 
-MS_API_EXPORT(void) ms_regfree(ms_regex_t *regex)
-{
-  regfree((regex_t*)(regex->sys_regex));
+MS_API_EXPORT(void) ms_regfree(ms_regex_t *regex) {
+  regfree((regex_t *)(regex->sys_regex));
   free(regex->sys_regex);
   return;
 }
diff -pruN 8.0.1-5/mapregex.h 8.0.2-1/mapregex.h
--- 8.0.1-5/mapregex.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapregex.h	2024-06-11 20:41:34.000000000 +0000
@@ -34,77 +34,74 @@
 extern "C" {
 #endif
 
-  /* We want these to match the POSIX standard, so we need these*/
-  /* === regex2.h === */
+/* We want these to match the POSIX standard, so we need these*/
+/* === regex2.h === */
 #ifdef _WIN32
-#define MS_API_EXPORT(type)  __declspec(dllexport) type __stdcall
+#define MS_API_EXPORT(type) __declspec(dllexport) type __stdcall
 #elif defined(__GNUC__) && __GNUC__ >= 4
-#define MS_API_EXPORT(type)  __attribute__ ((visibility("default"))) type
+#define MS_API_EXPORT(type) __attribute__((visibility("default"))) type
 #else
-#define MS_API_EXPORT(type)  type
+#define MS_API_EXPORT(type) type
 #endif
 
-  typedef struct {
-    void* sys_regex;
-  } ms_regex_t;
-
-  typedef int ms_regoff_t;
-  typedef struct {
-    ms_regoff_t rm_so;  /* Byte offset from string's start to substring's start.  */
-    ms_regoff_t rm_eo;  /* Byte offset from string's start to substring's end.  */
-  } ms_regmatch_t;
-
-  MS_API_EXPORT(int) ms_regcomp(ms_regex_t *, const char *, int);
-  MS_API_EXPORT(size_t) ms_regerror(int, const ms_regex_t *, char *, size_t);
-  MS_API_EXPORT(int) ms_regexec(const ms_regex_t *, const char *, size_t, ms_regmatch_t [], int);
-  MS_API_EXPORT(void) ms_regfree(ms_regex_t *);
+typedef struct {
+  void *sys_regex;
+} ms_regex_t;
+
+typedef int ms_regoff_t;
+typedef struct {
+  ms_regoff_t rm_so; /* Byte offset from string's start to substring's start. */
+  ms_regoff_t rm_eo; /* Byte offset from string's start to substring's end.  */
+} ms_regmatch_t;
+
+MS_API_EXPORT(int) ms_regcomp(ms_regex_t *, const char *, int);
+MS_API_EXPORT(size_t) ms_regerror(int, const ms_regex_t *, char *, size_t);
+MS_API_EXPORT(int)
+ms_regexec(const ms_regex_t *, const char *, size_t, ms_regmatch_t[], int);
+MS_API_EXPORT(void) ms_regfree(ms_regex_t *);
 
 #ifndef BUILDING_REGEX_PROXY
 
-  /* === regcomp.c === */
-#define MS_REG_BASIC  0000
+/* === regcomp.c === */
+#define MS_REG_BASIC 0000
 #define MS_REG_EXTENDED 0001
-#define MS_REG_ICASE  0002
-#define MS_REG_NOSUB  0004
-#define MS_REG_NEWLINE  0010
-#define MS_REG_NOSPEC 0020
-#define MS_REG_PEND 0040
-#define MS_REG_DUMP 0200
-
-
-  /* === regerror.c === */
-#define MS_REG_OKAY  0
-#define MS_REG_NOMATCH   1
-#define MS_REG_BADPAT  2
-#define MS_REG_ECOLLATE  3
-#define MS_REG_ECTYPE  4
-#define MS_REG_EESCAPE   5
-#define MS_REG_ESUBREG   6
-#define MS_REG_EBRACK  7
-#define MS_REG_EPAREN  8
-#define MS_REG_EBRACE  9
-#define MS_REG_BADBR  10
+#define MS_REG_ICASE 0002
+// WARNING: GNU regex has REG_NOSUB = (1 << 3) = 8
+#define MS_REG_NOSUB 0004
+// WARNING: GNU regex has REG_NEWLINE = (1 << 2) = 4
+#define MS_REG_NEWLINE 0010
+
+/* === regerror.c === */
+#define MS_REG_OKAY 0
+#define MS_REG_NOMATCH 1
+#define MS_REG_BADPAT 2
+#define MS_REG_ECOLLATE 3
+#define MS_REG_ECTYPE 4
+#define MS_REG_EESCAPE 5
+#define MS_REG_ESUBREG 6
+#define MS_REG_EBRACK 7
+#define MS_REG_EPAREN 8
+#define MS_REG_EBRACE 9
+#define MS_REG_BADBR 10
 #define MS_REG_ERANGE 11
 #define MS_REG_ESPACE 12
 #define MS_REG_BADRPT 13
-#define MS_REG_EMPTY  14
+#define MS_REG_EMPTY 14
 #define MS_REG_ASSERT 15
 #define MS_REG_INVARG 16
-#define MS_REG_ATOI 255 /* convert name to number (!) */
-#define MS_REG_ITOA 0400  /* convert number to name (!) */
+#define MS_REG_ATOI 255  /* convert name to number (!) */
+#define MS_REG_ITOA 0400 /* convert number to name (!) */
 
-
-  /* === regexec.c === */
+/* === regexec.c === */
 #define MS_REG_NOTBOL 00001
 #define MS_REG_NOTEOL 00002
 #define MS_REG_STARTEND 00004
-#define MS_REG_TRACE  00400 /* tracing of execution */
-#define MS_REG_LARGE  01000 /* force large representation */
-#define MS_REG_BACKR  02000 /* force use of backref code */
+#define MS_REG_TRACE 00400 /* tracing of execution */
+#define MS_REG_LARGE 01000 /* force large representation */
+#define MS_REG_BACKR 02000 /* force use of backref code */
 
 #endif
 
-
 #ifdef __cplusplus
 }
 #endif
diff -pruN 8.0.1-5/maprendering.c 8.0.2-1/maprendering.c
--- 8.0.1-5/maprendering.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/maprendering.c	2024-06-11 20:41:34.000000000 +0000
@@ -33,42 +33,41 @@
 #include "mapcopy.h"
 #include "fontcache.h"
 
-void computeSymbolStyle(symbolStyleObj *s, styleObj *src, symbolObj *symbol, double scalefactor,
-    double resolutionfactor)
-{
+void computeSymbolStyle(symbolStyleObj *s, styleObj *src, symbolObj *symbol,
+                        double scalefactor, double resolutionfactor) {
   double default_size;
   double target_size;
   double style_size;
 
   default_size = msSymbolGetDefaultSize(symbol);
-  style_size = (src->size==-1)?default_size:src->size;
+  style_size = (src->size == -1) ? default_size : src->size;
 
   INIT_SYMBOL_STYLE(*s);
-  if(symbol->type == MS_SYMBOL_PIXMAP) {
+  if (symbol->type == MS_SYMBOL_PIXMAP) {
     s->color = s->outlinecolor = NULL;
-  } else if(symbol->filled || symbol->type == MS_SYMBOL_TRUETYPE) {
-    if(MS_VALID_COLOR(src->color))
+  } else if (symbol->filled || symbol->type == MS_SYMBOL_TRUETYPE) {
+    if (MS_VALID_COLOR(src->color))
       s->color = &src->color;
-    if(MS_VALID_COLOR(src->outlinecolor))
+    if (MS_VALID_COLOR(src->outlinecolor))
       s->outlinecolor = &src->outlinecolor;
   } else {
-    if(MS_VALID_COLOR(src->color))
+    if (MS_VALID_COLOR(src->color))
       s->outlinecolor = &(src->color);
-    else if(MS_VALID_COLOR(src->outlinecolor))
+    else if (MS_VALID_COLOR(src->outlinecolor))
       s->outlinecolor = &(src->outlinecolor);
     s->color = NULL;
   }
 
   target_size = style_size * scalefactor;
-  target_size = MS_MAX(target_size, src->minsize*resolutionfactor);
-  target_size = MS_MIN(target_size, src->maxsize*resolutionfactor);
+  target_size = MS_MAX(target_size, src->minsize * resolutionfactor);
+  target_size = MS_MIN(target_size, src->maxsize * resolutionfactor);
   s->scale = target_size / default_size;
   s->gap = src->gap * target_size / style_size;
 
-  if(s->outlinecolor) {
-    s->outlinewidth =  src->width * scalefactor;
-    s->outlinewidth = MS_MAX(s->outlinewidth, src->minwidth*resolutionfactor);
-    s->outlinewidth = MS_MIN(s->outlinewidth, src->maxwidth*resolutionfactor);
+  if (s->outlinecolor) {
+    s->outlinewidth = src->width * scalefactor;
+    s->outlinewidth = MS_MAX(s->outlinewidth, src->minwidth * resolutionfactor);
+    s->outlinewidth = MS_MIN(s->outlinewidth, src->maxwidth * resolutionfactor);
   } else {
     s->outlinewidth = 0;
   }
@@ -76,35 +75,32 @@ void computeSymbolStyle(symbolStyleObj *
   s->rotation = src->angle * MS_DEG_TO_RAD;
 }
 
+#define COMPARE_COLORS(a, b)                                                   \
+  (((a).red == (b).red) && ((a).green == (b).green) &&                         \
+   ((a).blue == (b).blue) && ((a).alpha == (b).alpha))
 
-#define COMPARE_COLORS(a,b) (\
-    ((a).red==(b).red) && \
-    ((a).green==(b).green) && \
-    ((a).blue==(b).blue) && \
-    ((a).alpha==(b).alpha))
-
-tileCacheObj *searchTileCache(imageObj *img, symbolObj *symbol, symbolStyleObj *s, int width, int height)
-{
+tileCacheObj *searchTileCache(imageObj *img, symbolObj *symbol,
+                              symbolStyleObj *s, int width, int height) {
   tileCacheObj *cur = img->tilecache;
-  while(cur != NULL) {
-    if( cur->width == width
-        && cur->height == height
-        && cur->symbol == symbol
-        && cur->outlinewidth == s->outlinewidth
-        && cur->rotation == s->rotation
-        && cur->scale == s->scale
-        && (!s->color || COMPARE_COLORS(cur->color,*s->color))
-        && (!s->backgroundcolor || COMPARE_COLORS(cur->backgroundcolor,*s->backgroundcolor))
-        && (!s->outlinecolor || COMPARE_COLORS(cur->outlinecolor,*s->outlinecolor)))
+  while (cur != NULL) {
+    if (cur->width == width && cur->height == height && cur->symbol == symbol &&
+        cur->outlinewidth == s->outlinewidth && cur->rotation == s->rotation &&
+        cur->scale == s->scale &&
+        (!s->color || COMPARE_COLORS(cur->color, *s->color)) &&
+        (!s->backgroundcolor ||
+         COMPARE_COLORS(cur->backgroundcolor, *s->backgroundcolor)) &&
+        (!s->outlinecolor ||
+         COMPARE_COLORS(cur->outlinecolor, *s->outlinecolor)))
       return cur;
     cur = cur->next;
   }
   return NULL;
 }
 
-int preloadSymbol(symbolSetObj *symbolset, symbolObj *symbol, rendererVTableObj *renderer) {
+int preloadSymbol(symbolSetObj *symbolset, symbolObj *symbol,
+                  rendererVTableObj *renderer) {
   (void)symbolset;
-  switch(symbol->type) {
+  switch (symbol->type) {
   case MS_SYMBOL_VECTOR:
   case MS_SYMBOL_ELLIPSE:
   case MS_SYMBOL_SIMPLE:
@@ -114,36 +110,38 @@ int preloadSymbol(symbolSetObj *symbolse
 #if defined(USE_SVG_CAIRO) || defined(USE_RSVG)
     return msPreloadSVGSymbol(symbol);
 #else
-    msSetError(MS_SYMERR, "SVG symbol support is not enabled.", "preloadSymbol()");
+    msSetError(MS_SYMERR, "SVG symbol support is not enabled.",
+               "preloadSymbol()");
     return MS_FAILURE;
 #endif
     break;
   case (MS_SYMBOL_PIXMAP): {
-    if(!symbol->pixmap_buffer) {
-      if(MS_SUCCESS != msPreloadImageSymbol(renderer,symbol))
+    if (!symbol->pixmap_buffer) {
+      if (MS_SUCCESS != msPreloadImageSymbol(renderer, symbol))
         return MS_FAILURE;
     }
-  }
-  break;
+  } break;
   default:
-    msSetError(MS_MISCERR,"unsupported symbol type %d", "preloadSymbol()", symbol->type);
+    msSetError(MS_MISCERR, "unsupported symbol type %d", "preloadSymbol()",
+               symbol->type);
     return MS_FAILURE;
   }
   return MS_SUCCESS;
 }
 
 /* add a cached tile to the current image's cache */
-tileCacheObj *addTileCache(imageObj *img,
-                           imageObj *tile, symbolObj *symbol, symbolStyleObj *style, int width, int height)
-{
+tileCacheObj *addTileCache(imageObj *img, imageObj *tile, symbolObj *symbol,
+                           symbolStyleObj *style, int width, int height) {
   tileCacheObj *cachep;
 
-  if(img->ntiles >= MS_IMAGECACHESIZE) { /* remove last element, size stays the same */
+  if (img->ntiles >=
+      MS_IMAGECACHESIZE) { /* remove last element, size stays the same */
     cachep = img->tilecache;
 
     /*go to the before last cache object*/
-    while(cachep->next && cachep->next->next) cachep = cachep->next;
-    assert( cachep->next );
+    while (cachep->next && cachep->next->next)
+      cachep = cachep->next;
+    assert(cachep->next);
 
     /*free the last tile's data*/
     msFreeImage(cachep->next->image);
@@ -158,7 +156,7 @@ tileCacheObj *addTileCache(imageObj *img
 
   } else {
     img->ntiles += 1;
-    cachep = (tileCacheObj*)malloc(sizeof(tileCacheObj));
+    cachep = (tileCacheObj *)malloc(sizeof(tileCacheObj));
     MS_CHECK_ALLOC(cachep, sizeof(tileCacheObj), NULL);
     cachep->next = img->tilecache;
     img->tilecache = cachep;
@@ -170,23 +168,27 @@ tileCacheObj *addTileCache(imageObj *img
   cachep->outlinewidth = style->outlinewidth;
   cachep->scale = style->scale;
   cachep->rotation = style->rotation;
-  if(style->color) MS_COPYCOLOR(&cachep->color,style->color);
-  if(style->outlinecolor) MS_COPYCOLOR(&cachep->outlinecolor,style->outlinecolor);
+  if (style->color)
+    MS_COPYCOLOR(&cachep->color, style->color);
+  if (style->outlinecolor)
+    MS_COPYCOLOR(&cachep->outlinecolor, style->outlinecolor);
   cachep->width = width;
   cachep->height = height;
   cachep->symbol = symbol;
-  return(cachep);
+  return (cachep);
 }
 
 /* helper function to center glyph on the desired point */
-static int drawGlyphMarker(imageObj *img, face_element *face, glyph_element *glyphc, double px, double py, int size, double rotation,
-    colorObj *clr, colorObj *oclr, int olwidth)
-{
+static int drawGlyphMarker(imageObj *img, face_element *face,
+                           glyph_element *glyphc, double px, double py,
+                           int size, double rotation, colorObj *clr,
+                           colorObj *oclr, int olwidth) {
   double ox, oy;
   textPathObj path;
   glyphObj glyph;
   rendererVTableObj *renderer = img->format->vtable;
-  if(!renderer->renderGlyphs) return MS_FAILURE;
+  if (!renderer->renderGlyphs)
+    return MS_FAILURE;
   path.numglyphs = 1;
   glyph.glyph = glyphc;
   glyph.face = face;
@@ -195,9 +197,9 @@ static int drawGlyphMarker(imageObj *img
   glyph.rot = rotation;
   ox = (glyphc->metrics.maxx + glyphc->metrics.minx) / 2.0;
   oy = (glyphc->metrics.maxy + glyphc->metrics.miny) / 2.0;
-  if(rotation != 0) {
+  if (rotation != 0) {
     double sina, cosa;
-    double rox,roy;
+    double rox, roy;
     sina = sin(rotation);
     cosa = cos(rotation);
     rox = ox * cosa - oy * sina;
@@ -216,210 +218,238 @@ static int drawGlyphMarker(imageObj *img
   return renderer->renderGlyphs(img, &ts, clr, oclr, olwidth, MS_TRUE);
 }
 
-
-imageObj *getTile(imageObj *img, symbolObj *symbol,  symbolStyleObj *s, int width, int height,
-                  int seamlessmode)
-{
+imageObj *getTile(imageObj *img, symbolObj *symbol, symbolStyleObj *s,
+                  int width, int height, int seamlessmode) {
   tileCacheObj *tile;
   int status = MS_SUCCESS;
   rendererVTableObj *renderer = img->format->vtable;
-  if(width==-1 || height == -1) {
-    width=height=MS_MAX(symbol->sizex,symbol->sizey);
+  if (width == -1 || height == -1) {
+    width = height = MS_MAX(symbol->sizex, symbol->sizey);
   }
-  tile = searchTileCache(img,symbol,s,width,height);
+  tile = searchTileCache(img, symbol, s, width, height);
 
-  if(tile==NULL) {
+  if (tile == NULL) {
     imageObj *tileimg;
-    double p_x,p_y;
-    tileimg = msImageCreate(width,height,img->format,NULL,NULL,img->resolution, img->resolution, NULL);
-    if(MS_UNLIKELY(!tileimg)) {
+    double p_x, p_y;
+    tileimg = msImageCreate(width, height, img->format, NULL, NULL,
+                            img->resolution, img->resolution, NULL);
+    if (MS_UNLIKELY(!tileimg)) {
       return NULL;
     }
-    if(!seamlessmode) {
-      p_x = width/2.0;
-      p_y = height/2.0;
-      switch(symbol->type) {
-        case (MS_SYMBOL_TRUETYPE):
-        {
-          unsigned int unicode;
-          glyph_element *glyphc;
-          face_element *face = msGetFontFace(symbol->font, &img->map->fontset);
-          if(MS_UNLIKELY(!face)) { status = MS_FAILURE; break; }
-          msUTF8ToUniChar(symbol->character, &unicode);
-          unicode = msGetGlyphIndex(face,unicode);
-          glyphc = msGetGlyphByIndex(face, MS_MAX(MS_NINT(s->scale),1), unicode);
-          if(MS_UNLIKELY(!glyphc)) { status = MS_FAILURE; break; }
-          status = drawGlyphMarker(tileimg, face, glyphc, p_x, p_y, s->scale, s->rotation,
-                s->color, s->outlinecolor, s->outlinewidth);
-        }
-          break;
-        case (MS_SYMBOL_PIXMAP):
-          status = msPreloadImageSymbol(renderer,symbol);
-          if(MS_UNLIKELY(status == MS_FAILURE)) { break; }
-          status = renderer->renderPixmapSymbol(tileimg, p_x, p_y, symbol, s);
+    if (!seamlessmode) {
+      p_x = width / 2.0;
+      p_y = height / 2.0;
+      switch (symbol->type) {
+      case (MS_SYMBOL_TRUETYPE): {
+        unsigned int unicode;
+        glyph_element *glyphc;
+        face_element *face = msGetFontFace(symbol->font, &img->map->fontset);
+        if (MS_UNLIKELY(!face)) {
+          status = MS_FAILURE;
           break;
-        case (MS_SYMBOL_ELLIPSE):
-          status = renderer->renderEllipseSymbol(tileimg, p_x, p_y,symbol, s);
+        }
+        msUTF8ToUniChar(symbol->character, &unicode);
+        unicode = msGetGlyphIndex(face, unicode);
+        glyphc = msGetGlyphByIndex(face, MS_MAX(MS_NINT(s->scale), 1), unicode);
+        if (MS_UNLIKELY(!glyphc)) {
+          status = MS_FAILURE;
           break;
-        case (MS_SYMBOL_VECTOR):
-          status = renderer->renderVectorSymbol(tileimg, p_x, p_y, symbol, s);
+        }
+        status = drawGlyphMarker(tileimg, face, glyphc, p_x, p_y, s->scale,
+                                 s->rotation, s->color, s->outlinecolor,
+                                 s->outlinewidth);
+      } break;
+      case (MS_SYMBOL_PIXMAP):
+        status = msPreloadImageSymbol(renderer, symbol);
+        if (MS_UNLIKELY(status == MS_FAILURE)) {
           break;
+        }
+        status = renderer->renderPixmapSymbol(tileimg, p_x, p_y, symbol, s);
+        break;
+      case (MS_SYMBOL_ELLIPSE):
+        status = renderer->renderEllipseSymbol(tileimg, p_x, p_y, symbol, s);
+        break;
+      case (MS_SYMBOL_VECTOR):
+        status = renderer->renderVectorSymbol(tileimg, p_x, p_y, symbol, s);
+        break;
 
-        case (MS_SYMBOL_SVG):
+      case (MS_SYMBOL_SVG):
 #if defined(USE_SVG_CAIRO) || defined(USE_RSVG)
-          status = msPreloadSVGSymbol(symbol);
-          if(MS_LIKELY(status == MS_SUCCESS)) {
-            if (renderer->supports_svg) {
-              status = renderer->renderSVGSymbol(tileimg, p_x, p_y, symbol, s);
-            } else {
-              status = msRenderRasterizedSVGSymbol(tileimg,p_x,p_y,symbol, s);
-            }
+        status = msPreloadSVGSymbol(symbol);
+        if (MS_LIKELY(status == MS_SUCCESS)) {
+          if (renderer->supports_svg) {
+            status = renderer->renderSVGSymbol(tileimg, p_x, p_y, symbol, s);
+          } else {
+            status = msRenderRasterizedSVGSymbol(tileimg, p_x, p_y, symbol, s);
           }
+        }
 #else
-          msSetError(MS_SYMERR, "SVG symbol support is not enabled.", "getTile()");
-          status = MS_FAILURE;
+        msSetError(MS_SYMERR, "SVG symbol support is not enabled.",
+                   "getTile()");
+        status = MS_FAILURE;
 #endif
-          break;
-        default:
-          msSetError(MS_SYMERR, "Unknown symbol type %d", "getTile()", symbol->type);
-          status = MS_FAILURE;
-          break;
+        break;
+      default:
+        msSetError(MS_SYMERR, "Unknown symbol type %d", "getTile()",
+                   symbol->type);
+        status = MS_FAILURE;
+        break;
       }
-      if(MS_UNLIKELY(status == MS_FAILURE)) {
+      if (MS_UNLIKELY(status == MS_FAILURE)) {
         msFreeImage(tileimg);
         return NULL;
       }
     } else {
       /*
-       * in seamless mode, we render the the symbol 9 times on a 3x3 grid to account for
-       * antialiasing blending from one tile to the next. We finally keep the center tile
+       * in seamless mode, we render the the symbol 9 times on a 3x3 grid to
+       * account for antialiasing blending from one tile to the next. We finally
+       * keep the center tile
        */
-      imageObj *tile3img = msImageCreate(width*3,height*3,img->format,NULL,NULL,
-                                         img->resolution, img->resolution, NULL);
-      int i,j;
+      imageObj *tile3img =
+          msImageCreate(width * 3, height * 3, img->format, NULL, NULL,
+                        img->resolution, img->resolution, NULL);
+      int i, j;
       rasterBufferObj tmpraster;
-      for(i=1; i<=3; i++) {
-        p_x = (i+0.5)*width;
-        for(j=1; j<=3; j++) {
-          p_y = (j+0.5) * height;
-          switch(symbol->type) {
-            case (MS_SYMBOL_TRUETYPE):
-            {
-              unsigned int unicode;
-              glyph_element *glyphc;
-              face_element *face = msGetFontFace(symbol->font, &img->map->fontset);
-              if(MS_UNLIKELY(!face)) { status = MS_FAILURE; break; }
-              msUTF8ToUniChar(symbol->character, &unicode);
-              unicode = msGetGlyphIndex(face,unicode);
-              glyphc = msGetGlyphByIndex(face, MS_MAX(MS_NINT(s->scale),1), unicode);
-              if(MS_UNLIKELY(!glyphc)) { status = MS_FAILURE; break; }
-              status = drawGlyphMarker(tileimg, face, glyphc, p_x, p_y, s->scale, s->rotation,
-                    s->color, s->outlinecolor, s->outlinewidth);
-            }
-              break;
-            case (MS_SYMBOL_PIXMAP):
-              status = msPreloadImageSymbol(renderer,symbol);
-              if(MS_UNLIKELY(status == MS_FAILURE)) { break; }
-              status = renderer->renderPixmapSymbol(tile3img, p_x, p_y, symbol, s);
+      for (i = 1; i <= 3; i++) {
+        p_x = (i + 0.5) * width;
+        for (j = 1; j <= 3; j++) {
+          p_y = (j + 0.5) * height;
+          switch (symbol->type) {
+          case (MS_SYMBOL_TRUETYPE): {
+            unsigned int unicode;
+            glyph_element *glyphc;
+            face_element *face =
+                msGetFontFace(symbol->font, &img->map->fontset);
+            if (MS_UNLIKELY(!face)) {
+              status = MS_FAILURE;
               break;
-            case (MS_SYMBOL_ELLIPSE):
-              status = renderer->renderEllipseSymbol(tile3img, p_x, p_y,symbol, s);
+            }
+            msUTF8ToUniChar(symbol->character, &unicode);
+            unicode = msGetGlyphIndex(face, unicode);
+            glyphc =
+                msGetGlyphByIndex(face, MS_MAX(MS_NINT(s->scale), 1), unicode);
+            if (MS_UNLIKELY(!glyphc)) {
+              status = MS_FAILURE;
               break;
-            case (MS_SYMBOL_VECTOR):
-              status = renderer->renderVectorSymbol(tile3img, p_x, p_y, symbol, s);
+            }
+            status = drawGlyphMarker(tileimg, face, glyphc, p_x, p_y, s->scale,
+                                     s->rotation, s->color, s->outlinecolor,
+                                     s->outlinewidth);
+          } break;
+          case (MS_SYMBOL_PIXMAP):
+            status = msPreloadImageSymbol(renderer, symbol);
+            if (MS_UNLIKELY(status == MS_FAILURE)) {
               break;
-            default:
-              msSetError(MS_SYMERR, "BUG: Seamless mode is only for vector symbols", "getTile()");
-              return NULL;
+            }
+            status =
+                renderer->renderPixmapSymbol(tile3img, p_x, p_y, symbol, s);
+            break;
+          case (MS_SYMBOL_ELLIPSE):
+            status =
+                renderer->renderEllipseSymbol(tile3img, p_x, p_y, symbol, s);
+            break;
+          case (MS_SYMBOL_VECTOR):
+            status =
+                renderer->renderVectorSymbol(tile3img, p_x, p_y, symbol, s);
+            break;
+          default:
+            msSetError(MS_SYMERR,
+                       "BUG: Seamless mode is only for vector symbols",
+                       "getTile()");
+            return NULL;
           }
-          if(MS_UNLIKELY(status == MS_FAILURE)) {
+          if (MS_UNLIKELY(status == MS_FAILURE)) {
             msFreeImage(tile3img);
             return NULL;
           }
         }
       }
 
-      status = MS_IMAGE_RENDERER(tile3img)->getRasterBufferHandle(tile3img,&tmpraster);
-      if(MS_UNLIKELY(status == MS_FAILURE)) {
+      status = MS_IMAGE_RENDERER(tile3img)->getRasterBufferHandle(tile3img,
+                                                                  &tmpraster);
+      if (MS_UNLIKELY(status == MS_FAILURE)) {
         msFreeImage(tile3img);
         return NULL;
       }
-      status = renderer->mergeRasterBuffer(tileimg,
-                                  &tmpraster,
-                                  1.0,width,height,0,0,width,height
-                                 );
+      status = renderer->mergeRasterBuffer(tileimg, &tmpraster, 1.0, width,
+                                           height, 0, 0, width, height);
       msFreeImage(tile3img);
     }
-    if(MS_UNLIKELY(status == MS_FAILURE)) {
+    if (MS_UNLIKELY(status == MS_FAILURE)) {
       msFreeImage(tileimg);
       return NULL;
     }
-    tile = addTileCache(img,tileimg,symbol,s,width,height);
+    tile = addTileCache(img, tileimg, symbol, s, width, height);
   }
   return tile->image;
 }
 
 int msImagePolylineMarkers(imageObj *image, shapeObj *p, symbolObj *symbol,
                            symbolStyleObj *style, double spacing,
-                           double initialgap, int auto_angle)
-{
+                           double initialgap, int auto_angle) {
   rendererVTableObj *renderer = MS_IMAGE_RENDERER(image);
-  int i,j;
+  int i, j;
   pointObj point;
   double original_rotation = style->rotation;
-  double symbol_width,symbol_height;
+  double symbol_width, symbol_height;
   glyph_element *glyphc = NULL;
   face_element *face = NULL;
   int ret = MS_SUCCESS;
-  if(symbol->type != MS_SYMBOL_TRUETYPE) {
-    symbol_width = MS_MAX(1,symbol->sizex*style->scale);
-    symbol_height = MS_MAX(1,symbol->sizey*style->scale);
+  if (symbol->type != MS_SYMBOL_TRUETYPE) {
+    symbol_width = MS_MAX(1, symbol->sizex * style->scale);
+    symbol_height = MS_MAX(1, symbol->sizey * style->scale);
   } else {
     unsigned int unicode;
     msUTF8ToUniChar(symbol->character, &unicode);
     face = msGetFontFace(symbol->font, &image->map->fontset);
-    if(MS_UNLIKELY(!face)) return MS_FAILURE;
-    unicode = msGetGlyphIndex(face,unicode);
-    glyphc = msGetGlyphByIndex(face, MS_MAX(MS_NINT(style->scale),1), unicode);
-    if(MS_UNLIKELY(!glyphc)) return MS_FAILURE;
+    if (MS_UNLIKELY(!face))
+      return MS_FAILURE;
+    unicode = msGetGlyphIndex(face, unicode);
+    glyphc = msGetGlyphByIndex(face, MS_MAX(MS_NINT(style->scale), 1), unicode);
+    if (MS_UNLIKELY(!glyphc))
+      return MS_FAILURE;
     symbol_width = glyphc->metrics.maxx - glyphc->metrics.minx;
     symbol_height = glyphc->metrics.maxy - glyphc->metrics.miny;
   }
-  for(i=0; i<p->numlines; i++) {
+  for (i = 0; i < p->numlines; i++) {
     int line_in = 0;
-    double line_length=0;
+    double line_length = 0;
     double current_length;
-    if(initialgap < 0) {
-      current_length = spacing/2.0; /* initial padding for each line */
+    if (initialgap < 0) {
+      current_length = spacing / 2.0; /* initial padding for each line */
     } else {
       current_length = initialgap; /* initial padding for each line */
     }
-    for(j=1; j<p->line[i].numpoints; j++) {
-      double rx,ry,theta,length;
-      length = sqrt((pow((p->line[i].point[j].x - p->line[i].point[j-1].x),2) + pow((p->line[i].point[j].y - p->line[i].point[j-1].y),2)));
+    for (j = 1; j < p->line[i].numpoints; j++) {
+      double rx, ry, theta, length;
+      length =
+          sqrt((pow((p->line[i].point[j].x - p->line[i].point[j - 1].x), 2) +
+                pow((p->line[i].point[j].y - p->line[i].point[j - 1].y), 2)));
       line_length += length;
-      if(length==0)continue;
-      rx = (p->line[i].point[j].x - p->line[i].point[j-1].x)/length;
-      ry = (p->line[i].point[j].y - p->line[i].point[j-1].y)/length;
+      if (length == 0)
+        continue;
+      rx = (p->line[i].point[j].x - p->line[i].point[j - 1].x) / length;
+      ry = (p->line[i].point[j].y - p->line[i].point[j - 1].y) / length;
 
       if (auto_angle) {
         theta = asin(ry);
-        if(rx < 0) {
+        if (rx < 0) {
           theta += MS_PI;
-        } else theta = -theta;
+        } else
+          theta = -theta;
         style->rotation = original_rotation + theta;
       }
       while (current_length <= length) {
 
         point.x = p->line[i].point[j - 1].x + current_length * rx;
         point.y = p->line[i].point[j - 1].y + current_length * ry;
-        if(symbol->anchorpoint_x != 0.5 || symbol->anchorpoint_y != 0.5) {
+        if (symbol->anchorpoint_x != 0.5 || symbol->anchorpoint_y != 0.5) {
           double ox, oy;
           ox = (0.5 - symbol->anchorpoint_x) * symbol_width;
           oy = (0.5 - symbol->anchorpoint_y) * symbol_height;
-          if(style->rotation != 0) {
-            double sina,cosa;
-            double rox,roy;
+          if (style->rotation != 0) {
+            double sina, cosa;
+            double rox, roy;
             sina = sin(-style->rotation);
             cosa = cos(-style->rotation);
             rox = ox * cosa - oy * sina;
@@ -433,44 +463,53 @@ int msImagePolylineMarkers(imageObj *ima
         }
 
         /* if the point is not in the map extent, skip it. (POLYLINE_NO_CLIP) */
-        if ( (point.x < -(symbol_width) || point.x > (image->width+symbol_width)) ||
-             (point.y < -(symbol_height) || point.y > (image->height+symbol_height)) ) {
+        if ((point.x < -(symbol_width) ||
+             point.x > (image->width + symbol_width)) ||
+            (point.y < -(symbol_height) ||
+             point.y > (image->height + symbol_height))) {
           current_length += spacing;
-          line_in=1;          
+          line_in = 1;
           continue;
         }
-          
+
         switch (symbol->type) {
-          case MS_SYMBOL_PIXMAP:
-            ret = renderer->renderPixmapSymbol(image, point.x, point.y, symbol, style);
-            break;
-          case MS_SYMBOL_ELLIPSE:
-            ret = renderer->renderEllipseSymbol(image, point.x, point.y, symbol, style);
-            break;
-          case MS_SYMBOL_VECTOR:
-            ret = renderer->renderVectorSymbol(image, point.x, point.y, symbol, style);
-            break;
-          case MS_SYMBOL_TRUETYPE:
-            ret = drawGlyphMarker(image, face, glyphc, point.x, point.y, style->scale, style->rotation,
-                style->color, style->outlinecolor, style->outlinewidth);
-            break;
-          case (MS_SYMBOL_SVG):
+        case MS_SYMBOL_PIXMAP:
+          ret = renderer->renderPixmapSymbol(image, point.x, point.y, symbol,
+                                             style);
+          break;
+        case MS_SYMBOL_ELLIPSE:
+          ret = renderer->renderEllipseSymbol(image, point.x, point.y, symbol,
+                                              style);
+          break;
+        case MS_SYMBOL_VECTOR:
+          ret = renderer->renderVectorSymbol(image, point.x, point.y, symbol,
+                                             style);
+          break;
+        case MS_SYMBOL_TRUETYPE:
+          ret = drawGlyphMarker(image, face, glyphc, point.x, point.y,
+                                style->scale, style->rotation, style->color,
+                                style->outlinecolor, style->outlinewidth);
+          break;
+        case (MS_SYMBOL_SVG):
 #if defined(USE_SVG_CAIRO) || defined(USE_RSVG)
-              if (renderer->supports_svg) {
-                ret = renderer->renderSVGSymbol(image, point.x, point.y, symbol, style);
-              } else {
-                ret = msRenderRasterizedSVGSymbol(image,point.x,point.y,symbol, style);
-              }
+          if (renderer->supports_svg) {
+            ret = renderer->renderSVGSymbol(image, point.x, point.y, symbol,
+                                            style);
+          } else {
+            ret = msRenderRasterizedSVGSymbol(image, point.x, point.y, symbol,
+                                              style);
+          }
 #else
-              msSetError(MS_SYMERR, "SVG symbol support is not enabled.", "msImagePolylineMarkers()()");
-              ret = MS_FAILURE;
+          msSetError(MS_SYMERR, "SVG symbol support is not enabled.",
+                     "msImagePolylineMarkers()()");
+          ret = MS_FAILURE;
 #endif
-              break;
+          break;
         }
-        if( ret != MS_SUCCESS)
+        if (ret != MS_SUCCESS)
           return ret;
         current_length += spacing;
-        line_in=1;
+        line_in = 1;
       }
 
       current_length -= length;
@@ -481,76 +520,84 @@ int msImagePolylineMarkers(imageObj *ima
      * specified,  add one now we don't add the symbol if the line is shorter
      * than the length of the symbol itself
      */
-    if(initialgap < 0 && !line_in && line_length>symbol_width) {
+    if (initialgap < 0 && !line_in && line_length > symbol_width) {
 
       /* total lengths of beginnning and end of current segment */
-      double before_length=0,after_length=0;
+      double before_length = 0, after_length = 0;
 
       /*optimize*/
       line_length /= 2.0;
 
-      for(j=1; j<p->line[i].numpoints; j++) {
+      for (j = 1; j < p->line[i].numpoints; j++) {
         double length;
-        length = sqrt((pow((p->line[i].point[j].x - p->line[i].point[j-1].x),2) + pow((p->line[i].point[j].y - p->line[i].point[j-1].y),2)));
+        length =
+            sqrt((pow((p->line[i].point[j].x - p->line[i].point[j - 1].x), 2) +
+                  pow((p->line[i].point[j].y - p->line[i].point[j - 1].y), 2)));
         after_length += length;
-        if(after_length>line_length) {
-          double rx,ry,theta;
+        if (after_length > line_length) {
+          double rx, ry, theta;
           /* offset where the symbol should be drawn on the current
            * segment */
           double offset = line_length - before_length;
 
-          rx = (p->line[i].point[j].x - p->line[i].point[j-1].x)/length;
-          ry = (p->line[i].point[j].y - p->line[i].point[j-1].y)/length;
+          rx = (p->line[i].point[j].x - p->line[i].point[j - 1].x) / length;
+          ry = (p->line[i].point[j].y - p->line[i].point[j - 1].y) / length;
           if (auto_angle) {
             theta = asin(ry);
-            if(rx < 0) {
+            if (rx < 0) {
               theta += MS_PI;
-            } else theta = -theta;
+            } else
+              theta = -theta;
             style->rotation = original_rotation + theta;
           }
 
           point.x = p->line[i].point[j - 1].x + offset * rx;
           point.y = p->line[i].point[j - 1].y + offset * ry;
           switch (symbol->type) {
-            case MS_SYMBOL_PIXMAP:
-              ret = renderer->renderPixmapSymbol(image, point.x, point.y, symbol, style);
-              break;
-            case MS_SYMBOL_ELLIPSE:
-              ret = renderer->renderEllipseSymbol(image, point.x, point.y, symbol, style);
-              break;
-            case MS_SYMBOL_VECTOR:
-              ret = renderer->renderVectorSymbol(image, point.x, point.y, symbol, style);
-              break;
-            case MS_SYMBOL_TRUETYPE:
-              ret = drawGlyphMarker(image, face, glyphc, point.x, point.y, style->scale, style->rotation,
-                  style->color, style->outlinecolor, style->outlinewidth);
-              break;
-            case (MS_SYMBOL_SVG):
+          case MS_SYMBOL_PIXMAP:
+            ret = renderer->renderPixmapSymbol(image, point.x, point.y, symbol,
+                                               style);
+            break;
+          case MS_SYMBOL_ELLIPSE:
+            ret = renderer->renderEllipseSymbol(image, point.x, point.y, symbol,
+                                                style);
+            break;
+          case MS_SYMBOL_VECTOR:
+            ret = renderer->renderVectorSymbol(image, point.x, point.y, symbol,
+                                               style);
+            break;
+          case MS_SYMBOL_TRUETYPE:
+            ret = drawGlyphMarker(image, face, glyphc, point.x, point.y,
+                                  style->scale, style->rotation, style->color,
+                                  style->outlinecolor, style->outlinewidth);
+            break;
+          case (MS_SYMBOL_SVG):
 #if defined(USE_SVG_CAIRO) || defined(USE_RSVG)
-              if (renderer->supports_svg) {
-                ret = renderer->renderSVGSymbol(image, point.x, point.y, symbol, style);
-              } else {
-                ret = msRenderRasterizedSVGSymbol(image,point.x,point.y,symbol, style);
-              }
+            if (renderer->supports_svg) {
+              ret = renderer->renderSVGSymbol(image, point.x, point.y, symbol,
+                                              style);
+            } else {
+              ret = msRenderRasterizedSVGSymbol(image, point.x, point.y, symbol,
+                                                style);
+            }
 #else
-              msSetError(MS_SYMERR, "SVG symbol support is not enabled.", "msImagePolylineMarkers()()");
-              ret = MS_FAILURE;
+            msSetError(MS_SYMERR, "SVG symbol support is not enabled.",
+                       "msImagePolylineMarkers()()");
+            ret = MS_FAILURE;
 #endif
-              break;
+            break;
           }
           break; /* we have rendered the single marker for this line */
         }
         before_length += length;
       }
     }
-
   }
   return ret;
 }
 
-int msDrawLineSymbol(mapObj *map, imageObj *image, shapeObj *p,
-                     styleObj *style, double scalefactor)
-{
+int msDrawLineSymbol(mapObj *map, imageObj *image, shapeObj *p, styleObj *style,
+                     double scalefactor) {
   int status = MS_SUCCESS;
   if (image) {
     if (MS_RENDERER_PLUGIN(image->format)) {
@@ -572,23 +619,25 @@ int msDrawLineSymbol(mapObj *map, imageO
       symbol->renderer = renderer;
 
       width = style->width * scalefactor;
-      width = MS_MIN(width,style->maxwidth*image->resolutionfactor);
-      width = MS_MAX(width,style->minwidth*image->resolutionfactor);
-      if(style->width != 0) {
+      width = MS_MIN(width, style->maxwidth * image->resolutionfactor);
+      width = MS_MAX(width, style->minwidth * image->resolutionfactor);
+      if (style->width != 0) {
         finalscalefactor = width / style->width;
       } else {
         finalscalefactor = 1.0;
       }
 
-      if(style->offsety==MS_STYLE_SINGLE_SIDED_OFFSET) {
-        offsetLine = msOffsetPolyline(p,style->offsetx * finalscalefactor ,MS_STYLE_SINGLE_SIDED_OFFSET);
-      } else if(style->offsety==MS_STYLE_DOUBLE_SIDED_OFFSET) {
-        offsetLine = msOffsetPolyline(p,style->offsetx * finalscalefactor ,MS_STYLE_DOUBLE_SIDED_OFFSET);
-      } else if(style->offsetx!=0 || style->offsety!=0) {
+      if (style->offsety == MS_STYLE_SINGLE_SIDED_OFFSET) {
+        offsetLine = msOffsetPolyline(p, style->offsetx * finalscalefactor,
+                                      MS_STYLE_SINGLE_SIDED_OFFSET);
+      } else if (style->offsety == MS_STYLE_DOUBLE_SIDED_OFFSET) {
+        offsetLine = msOffsetPolyline(p, style->offsetx * finalscalefactor,
+                                      MS_STYLE_DOUBLE_SIDED_OFFSET);
+      } else if (style->offsetx != 0 || style->offsety != 0) {
         offsetLine = msOffsetPolyline(p, style->offsetx * finalscalefactor,
                                       style->offsety * finalscalefactor);
       }
-      if(style->symbol == 0 || (symbol->type==MS_SYMBOL_SIMPLE)) {
+      if (style->symbol == 0 || (symbol->type == MS_SYMBOL_SIMPLE)) {
         strokeStyleObj s;
         s.linecap = style->linecap;
         s.linejoin = style->linejoin;
@@ -596,72 +645,82 @@ int msDrawLineSymbol(mapObj *map, imageO
         s.antialiased = style->antialiased;
         s.width = width;
         s.patternlength = style->patternlength;
-        for(i=0; i<s.patternlength; i++)
+        for (i = 0; i < s.patternlength; i++)
           s.pattern[i] = style->pattern[i] * finalscalefactor;
-        s.patternoffset = (style->initialgap<=0) ? 0 : (style->initialgap * finalscalefactor);
+        s.patternoffset = (style->initialgap <= 0)
+                              ? 0
+                              : (style->initialgap * finalscalefactor);
 
-        if(MS_VALID_COLOR(style->color))
+        if (MS_VALID_COLOR(style->color))
           s.color = &style->color;
-        else if(MS_VALID_COLOR(style->outlinecolor))
+        else if (MS_VALID_COLOR(style->outlinecolor))
           s.color = &style->outlinecolor;
         else {
-          /* msSetError(MS_MISCERR,"no color defined for line styling","msDrawLineSymbol()");
-           * not really an error */
+          /* msSetError(MS_MISCERR,"no color defined for line
+           * styling","msDrawLineSymbol()"); not really an error */
           status = MS_SUCCESS;
           goto line_cleanup;
         }
-        status = renderer->renderLine(image,offsetLine,&s);
+        status = renderer->renderLine(image, offsetLine, &s);
       } else {
         symbolStyleObj s;
-        if(preloadSymbol(&map->symbolset, symbol, renderer) != MS_SUCCESS) {
+        if (preloadSymbol(&map->symbolset, symbol, renderer) != MS_SUCCESS) {
           status = MS_FAILURE;
           goto line_cleanup;
         }
 
         INIT_SYMBOL_STYLE(s);
-        computeSymbolStyle(&s,style,symbol,scalefactor,image->resolutionfactor);
+        computeSymbolStyle(&s, style, symbol, scalefactor,
+                           image->resolutionfactor);
         s.style = style;
 
         /* compute a markerStyle and use it on the line */
-        if(style->gap<0) {
-          /* special function that treats any other symbol used as a marker, not a brush */
-          status = msImagePolylineMarkers(image,offsetLine,symbol,&s,-s.gap,
-                                 style->initialgap * finalscalefactor, 1);
-        } else if(style->gap>0) {
-          status = msImagePolylineMarkers(image,offsetLine,symbol,&s,s.gap,
-                                 style->initialgap * finalscalefactor,0);
+        if (style->gap < 0) {
+          /* special function that treats any other symbol used as a marker, not
+           * a brush */
+          status =
+              msImagePolylineMarkers(image, offsetLine, symbol, &s, -s.gap,
+                                     style->initialgap * finalscalefactor, 1);
+        } else if (style->gap > 0) {
+          status =
+              msImagePolylineMarkers(image, offsetLine, symbol, &s, s.gap,
+                                     style->initialgap * finalscalefactor, 0);
         } else {
-          if(renderer->renderLineTiled != NULL) {
-            int pw,ph;
-            imageObj* tile=NULL;
-            if(s.scale != 1) {
+          if (renderer->renderLineTiled != NULL) {
+            int pw, ph;
+            imageObj *tile = NULL;
+            if (s.scale != 1) {
               pw = MS_NINT(symbol->sizex * s.scale);
               ph = MS_NINT(symbol->sizey * s.scale);
             } else {
               pw = symbol->sizex;
               ph = symbol->sizey;
             }
-            if(pw<1) pw=1;
-            if(ph<1) ph=1;
-            tile = getTile(image, symbol,&s,pw,ph,0);
+            if (pw < 1)
+              pw = 1;
+            if (ph < 1)
+              ph = 1;
+            tile = getTile(image, symbol, &s, pw, ph, 0);
             status = renderer->renderLineTiled(image, offsetLine, tile);
           } else {
-            msSetError(MS_RENDERERERR, "renderer does not support brushed lines", "msDrawLineSymbol()");
+            msSetError(MS_RENDERERERR,
+                       "renderer does not support brushed lines",
+                       "msDrawLineSymbol()");
             status = MS_FAILURE;
           }
         }
       }
 
-line_cleanup:
-      if(offsetLine!=p) {
+    line_cleanup:
+      if (offsetLine != p) {
         msFreeShape(offsetLine);
         msFree(offsetLine);
       }
       return status;
-    } else if( MS_RENDERER_IMAGEMAP(image->format) )
+    } else if (MS_RENDERER_IMAGEMAP(image->format))
       msDrawLineSymbolIM(map, image, p, style, scalefactor);
     else {
-      msSetError(MS_RENDERERERR, "unsupported renderer", "msDrawShadeSymbol()");
+      msSetError(MS_RENDERERERR, "unsupported renderer", "msDrawLineSymbol()");
       status = MS_FAILURE;
     }
   } else {
@@ -670,8 +729,8 @@ line_cleanup:
   return status;
 }
 
-int msDrawShadeSymbol(mapObj *map, imageObj *image, shapeObj *p, styleObj *style, double scalefactor)
-{
+int msDrawShadeSymbol(mapObj *map, imageObj *image, shapeObj *p,
+                      styleObj *style, double scalefactor) {
   int ret = MS_SUCCESS;
   symbolObj *symbol;
   if (!p)
@@ -690,9 +749,9 @@ int msDrawShadeSymbol(mapObj *map, image
    * this behavior is kind of a mapfile hack, and must be
    * kept for backwards compatibility
    */
-  if (symbol->type != MS_SYMBOL_PIXMAP && symbol->type != MS_SYMBOL_SVG ) {
+  if (symbol->type != MS_SYMBOL_PIXMAP && symbol->type != MS_SYMBOL_SVG) {
     if (!MS_VALID_COLOR(style->color)) {
-      if(MS_VALID_COLOR(style->outlinecolor))
+      if (MS_VALID_COLOR(style->outlinecolor))
         return msDrawLineSymbol(map, image, p, style, scalefactor);
       else {
         /* just do nothing if no color has been set */
@@ -705,128 +764,140 @@ int msDrawShadeSymbol(mapObj *map, image
       rendererVTableObj *renderer = image->format->vtable;
       shapeObj *offsetPolygon = NULL;
       /* store a reference to the renderer to be used for freeing */
-      if(style->symbol)
+      if (style->symbol)
         symbol->renderer = renderer;
 
       if (style->offsetx != 0 || style->offsety != 0) {
-        if(style->offsety==MS_STYLE_SINGLE_SIDED_OFFSET) {
-          offsetPolygon = msOffsetPolyline(p, style->offsetx*scalefactor, MS_STYLE_SINGLE_SIDED_OFFSET);
-        } else if(style->offsety==MS_STYLE_DOUBLE_SIDED_OFFSET) {
-          offsetPolygon = msOffsetPolyline(p,style->offsetx * scalefactor ,MS_STYLE_DOUBLE_SIDED_OFFSET);
+        if (style->offsety == MS_STYLE_SINGLE_SIDED_OFFSET) {
+          offsetPolygon = msOffsetPolyline(p, style->offsetx * scalefactor,
+                                           MS_STYLE_SINGLE_SIDED_OFFSET);
+        } else if (style->offsety == MS_STYLE_DOUBLE_SIDED_OFFSET) {
+          offsetPolygon = msOffsetPolyline(p, style->offsetx * scalefactor,
+                                           MS_STYLE_DOUBLE_SIDED_OFFSET);
         } else {
-          offsetPolygon = msOffsetPolyline(p, style->offsetx*scalefactor,style->offsety*scalefactor);
+          offsetPolygon = msOffsetPolyline(p, style->offsetx * scalefactor,
+                                           style->offsety * scalefactor);
         }
       } else {
-        offsetPolygon=p;
+        offsetPolygon = p;
       }
       /* simple polygon drawing, without any specific symbol.
        * also draws an optional outline */
-      if(style->symbol == 0 || symbol->type == MS_SYMBOL_SIMPLE) {
-        ret = renderer->renderPolygon(image,offsetPolygon,&style->color);
-        if(ret != MS_SUCCESS) goto cleanup;
-        if(MS_VALID_COLOR(style->outlinecolor)) {
+      if (style->symbol == 0 || symbol->type == MS_SYMBOL_SIMPLE) {
+        ret = renderer->renderPolygon(image, offsetPolygon, &style->color);
+        if (ret != MS_SUCCESS)
+          goto cleanup;
+        if (MS_VALID_COLOR(style->outlinecolor)) {
           strokeStyleObj s;
           INIT_STROKE_STYLE(s);
           s.color = &style->outlinecolor;
           s.color->alpha = style->color.alpha;
-          s.width = (style->width == 0)?scalefactor:style->width*scalefactor;
+          s.width =
+              (style->width == 0) ? scalefactor : style->width * scalefactor;
           s.width = MS_MIN(s.width, style->maxwidth);
           s.width = MS_MAX(s.width, style->minwidth);
-          ret = renderer->renderLine(image,offsetPolygon,&s);
+          ret = renderer->renderLine(image, offsetPolygon, &s);
         }
         goto cleanup; /*finished plain polygon*/
-      } else if(symbol->type == MS_SYMBOL_HATCH) {
+      } else if (symbol->type == MS_SYMBOL_HATCH) {
         double width, spacing;
         double pattern[MS_MAXPATTERNLENGTH];
         int i;
 
-        width = (style->width <= 0)?scalefactor:style->width*scalefactor;
-        width = MS_MIN(width, style->maxwidth*image->resolutionfactor);
-        width = MS_MAX(width, style->minwidth*image->resolutionfactor);
-        spacing = (style->size <= 0)?scalefactor:style->size*scalefactor;
-        spacing = MS_MIN(spacing, style->maxsize*image->resolutionfactor);
-        spacing = MS_MAX(spacing, style->minsize*image->resolutionfactor);
+        width = (style->width <= 0) ? scalefactor : style->width * scalefactor;
+        width = MS_MIN(width, style->maxwidth * image->resolutionfactor);
+        width = MS_MAX(width, style->minwidth * image->resolutionfactor);
+        spacing = (style->size <= 0) ? scalefactor : style->size * scalefactor;
+        spacing = MS_MIN(spacing, style->maxsize * image->resolutionfactor);
+        spacing = MS_MAX(spacing, style->minsize * image->resolutionfactor);
 
         /* scale the pattern by the factor applied to the width */
-        for(i=0; i<style->patternlength; i++) {
-          pattern[i] = style->pattern[i]*width/style->width;
+        for (i = 0; i < style->patternlength; i++) {
+          pattern[i] = style->pattern[i] * width / style->width;
         }
 
-        ret = msHatchPolygon(image,offsetPolygon,spacing,width,pattern,style->patternlength,style->angle, &style->color);
+        ret = msHatchPolygon(image, offsetPolygon, spacing, width, pattern,
+                             style->patternlength, style->angle, &style->color);
         goto cleanup;
       } else {
         symbolStyleObj s;
-        int pw,ph;
+        int pw, ph;
         imageObj *tile;
         int seamless = 0;
 
-        if(preloadSymbol(&map->symbolset,symbol,renderer) != MS_SUCCESS) {
+        if (preloadSymbol(&map->symbolset, symbol, renderer) != MS_SUCCESS) {
           ret = MS_FAILURE;
           goto cleanup;
         }
 
         INIT_SYMBOL_STYLE(s);
-        computeSymbolStyle(&s,style,symbol,scalefactor,image->resolutionfactor);
+        computeSymbolStyle(&s, style, symbol, scalefactor,
+                           image->resolutionfactor);
         s.style = style;
 
-        if (!s.color && !s.outlinecolor && symbol->type != MS_SYMBOL_PIXMAP && symbol->type != MS_SYMBOL_SVG) {
-          ret = MS_SUCCESS; /* nothing to do (colors are required except for PIXMAP symbols */
+        if (!s.color && !s.outlinecolor && symbol->type != MS_SYMBOL_PIXMAP &&
+            symbol->type != MS_SYMBOL_SVG) {
+          ret = MS_SUCCESS; /* nothing to do (colors are required except for
+                               PIXMAP symbols */
           goto cleanup;
         }
 
-        if(s.backgroundcolor) {
-          ret = renderer->renderPolygon(image,offsetPolygon, s.backgroundcolor);
-          if(ret != MS_SUCCESS) goto cleanup;
+        if (s.backgroundcolor) {
+          ret =
+              renderer->renderPolygon(image, offsetPolygon, s.backgroundcolor);
+          if (ret != MS_SUCCESS)
+            goto cleanup;
         }
 
-        if(s.scale != 1) {
+        if (s.scale != 1) {
           if (s.gap > 0) {
-            pw = MS_MAX(MS_NINT(s.gap),symbol->sizex * s.scale);
-            ph = MS_MAX(MS_NINT(s.gap),symbol->sizey * s.scale);
+            pw = MS_MAX(MS_NINT(s.gap), symbol->sizex * s.scale);
+            ph = MS_MAX(MS_NINT(s.gap), symbol->sizey * s.scale);
           } else {
             pw = MS_NINT(symbol->sizex * s.scale);
             ph = MS_NINT(symbol->sizey * s.scale);
           }
         } else {
           if (s.gap > 0) {
-            pw = MS_MAX(s.gap,symbol->sizex);
-            ph = MS_MAX(s.gap,symbol->sizey);
+            pw = MS_MAX(s.gap, symbol->sizex);
+            ph = MS_MAX(s.gap, symbol->sizey);
           } else {
             pw = symbol->sizex;
             ph = symbol->sizey;
           }
         }
-        if(pw<1) pw=1;
-        if(ph<1) ph=1;
-
-        /* if we're doing vector symbols with an antialiased pixel rendererer, we want to enable
-         * seamless mode, i.e. comute a tile that accounts for the blending of neighbouring
-         * tiles at the tile border
+        if (pw < 1)
+          pw = 1;
+        if (ph < 1)
+          ph = 1;
+
+        /* if we're doing vector symbols with an antialiased pixel rendererer,
+         * we want to enable seamless mode, i.e. comute a tile that accounts for
+         * the blending of neighbouring tiles at the tile border
          */
-        if(symbol->type == MS_SYMBOL_VECTOR && style->gap == 0 &&
+        if (symbol->type == MS_SYMBOL_VECTOR && style->gap == 0 &&
             (image->format->renderer == MS_RENDER_WITH_AGG ||
              image->format->renderer == MS_RENDER_WITH_CAIRO_RASTER)) {
           seamless = 1;
         }
-        tile = getTile(image,symbol,&s,pw,ph,seamless);
-        ret = renderer->renderPolygonTiled(image,offsetPolygon, tile);
+        tile = getTile(image, symbol, &s, pw, ph, seamless);
+        ret = renderer->renderPolygonTiled(image, offsetPolygon, tile);
       }
 
-cleanup:
+    cleanup:
       if (offsetPolygon != p) {
         msFreeShape(offsetPolygon);
         msFree(offsetPolygon);
       }
       return ret;
-    } else if( MS_RENDERER_IMAGEMAP(image->format) )
+    } else if (MS_RENDERER_IMAGEMAP(image->format))
       msDrawShadeSymbolIM(map, image, p, style, scalefactor);
   }
   return ret;
 }
 
-int msDrawMarkerSymbol(mapObj *map, imageObj *image, pointObj *p, styleObj *style,
-                       double scalefactor)
-{
+int msDrawMarkerSymbol(mapObj *map, imageObj *image, pointObj *p,
+                       styleObj *style, double scalefactor) {
   int ret = MS_SUCCESS;
   if (!p)
     return MS_SUCCESS;
@@ -834,29 +905,29 @@ int msDrawMarkerSymbol(mapObj *map, imag
     return MS_SUCCESS; /* no such symbol, 0 is OK   */
 
   if (image) {
-    if(MS_RENDERER_PLUGIN(image->format)) {
+    if (MS_RENDERER_PLUGIN(image->format)) {
       rendererVTableObj *renderer = image->format->vtable;
       symbolStyleObj s;
-      double p_x,p_y;
+      double p_x, p_y;
       symbolObj *symbol = map->symbolset.symbol[style->symbol];
       /* store a reference to the renderer to be used for freeing */
       symbol->renderer = renderer;
-      if(preloadSymbol(&map->symbolset,symbol,renderer) != MS_SUCCESS) {
+      if (preloadSymbol(&map->symbolset, symbol, renderer) != MS_SUCCESS) {
         return MS_FAILURE;
       }
 
-      computeSymbolStyle(&s,style,symbol,scalefactor,image->resolutionfactor);
+      computeSymbolStyle(&s, style, symbol, scalefactor,
+                         image->resolutionfactor);
       s.style = style;
       if (!s.color && !s.outlinecolor && symbol->type != MS_SYMBOL_PIXMAP &&
           symbol->type != MS_SYMBOL_SVG) {
-        return MS_SUCCESS; // nothing to do if no color, except for pixmap symbols
+        return MS_SUCCESS; // nothing to do if no color, except for pixmap
+                           // symbols
       }
-      if(s.scale == 0) {
+      if (s.scale == 0) {
         return MS_SUCCESS;
       }
 
-
-
       /* TODO: skip the drawing of the symbol if it's smaller than a pixel ?
       if (s.size < 1)
        return; // size too small
@@ -865,27 +936,27 @@ int msDrawMarkerSymbol(mapObj *map, imag
       p_x = p->x;
       p_y = p->y;
 
-      if (style->polaroffsetpixel != 0 ||
-          style->polaroffsetangle != 0) {
+      if (style->polaroffsetpixel != 0 || style->polaroffsetangle != 0) {
         double angle = style->polaroffsetangle * MS_DEG_TO_RAD;
-        p_x +=  (style->polaroffsetpixel * cos(-angle)) * scalefactor;
-        p_y +=  (style->polaroffsetpixel * sin(-angle)) * scalefactor;
+        p_x += (style->polaroffsetpixel * cos(-angle)) * scalefactor;
+        p_y += (style->polaroffsetpixel * sin(-angle)) * scalefactor;
       }
 
-      p_x +=  style->offsetx * scalefactor;
-      p_y +=  style->offsety * scalefactor;
+      p_x += style->offsetx * scalefactor;
+      p_y += style->offsety * scalefactor;
 
-      if(symbol->anchorpoint_x != 0.5 || symbol->anchorpoint_y != 0.5) {
-        double sx,sy;
+      if (symbol->anchorpoint_x != 0.5 || symbol->anchorpoint_y != 0.5) {
+        double sx, sy;
         double ox, oy;
-        if(MS_UNLIKELY(MS_FAILURE == msGetMarkerSize(map, style, &sx, &sy, scalefactor))) {
+        if (MS_UNLIKELY(MS_FAILURE ==
+                        msGetMarkerSize(map, style, &sx, &sy, scalefactor))) {
           return MS_FAILURE;
         }
         ox = (0.5 - symbol->anchorpoint_x) * sx;
         oy = (0.5 - symbol->anchorpoint_y) * sy;
-        if(s.rotation != 0) {
+        if (s.rotation != 0) {
           double sina, cosa;
-          double rox,roy;
+          double rox, roy;
           sina = sin(-s.rotation);
           cosa = cos(-s.rotation);
           rox = ox * cosa - oy * sina;
@@ -898,77 +969,76 @@ int msDrawMarkerSymbol(mapObj *map, imag
         }
       }
 
-      if(renderer->use_imagecache) {
-        imageObj *tile = getTile(image, symbol, &s, -1, -1,0);
-        if(tile!=NULL)
+      if (renderer->use_imagecache) {
+        imageObj *tile = getTile(image, symbol, &s, -1, -1, 0);
+        if (tile != NULL)
           return renderer->renderTile(image, tile, p_x, p_y);
         else {
-          msSetError(MS_RENDERERERR, "problem creating cached tile", "msDrawMarkerSymbol()");
+          msSetError(MS_RENDERERERR, "problem creating cached tile",
+                     "msDrawMarkerSymbol()");
           return MS_FAILURE;
         }
       }
       switch (symbol->type) {
-        case (MS_SYMBOL_TRUETYPE): {
-          unsigned int unicode;
-          glyph_element *glyphc;
-          face_element *face = msGetFontFace(symbol->font, &map->fontset);
-          if(MS_UNLIKELY(!face)) return MS_FAILURE;
-          msUTF8ToUniChar(symbol->character,&unicode);
-          unicode = msGetGlyphIndex(face,unicode);
-          glyphc = msGetGlyphByIndex(face, MS_MAX(MS_NINT(s.scale),1), unicode);
-          if(MS_UNLIKELY(!glyphc)) return MS_FAILURE;
-          ret = drawGlyphMarker(image, face, glyphc, p_x, p_y, s.scale, s.rotation, s.color, s.outlinecolor, s.outlinewidth);
-        }
-        break;
-        case (MS_SYMBOL_PIXMAP): {
-          assert(symbol->pixmap_buffer);
-          ret = renderer->renderPixmapSymbol(image,p_x,p_y,symbol,&s);
-        }
-        break;
-        case (MS_SYMBOL_ELLIPSE): {
-          ret = renderer->renderEllipseSymbol(image, p_x, p_y,symbol, &s);
-        }
-        break;
-        case (MS_SYMBOL_VECTOR): {
-          ret = renderer->renderVectorSymbol(image, p_x, p_y, symbol, &s);
-        }
-        break;
-        case (MS_SYMBOL_SVG): {
-          if (renderer->supports_svg) {
-            ret = renderer->renderSVGSymbol(image, p_x, p_y, symbol, &s);
-          } else {
+      case (MS_SYMBOL_TRUETYPE): {
+        unsigned int unicode;
+        glyph_element *glyphc;
+        face_element *face = msGetFontFace(symbol->font, &map->fontset);
+        if (MS_UNLIKELY(!face))
+          return MS_FAILURE;
+        msUTF8ToUniChar(symbol->character, &unicode);
+        unicode = msGetGlyphIndex(face, unicode);
+        glyphc = msGetGlyphByIndex(face, MS_MAX(MS_NINT(s.scale), 1), unicode);
+        if (MS_UNLIKELY(!glyphc))
+          return MS_FAILURE;
+        ret =
+            drawGlyphMarker(image, face, glyphc, p_x, p_y, s.scale, s.rotation,
+                            s.color, s.outlinecolor, s.outlinewidth);
+      } break;
+      case (MS_SYMBOL_PIXMAP): {
+        assert(symbol->pixmap_buffer);
+        ret = renderer->renderPixmapSymbol(image, p_x, p_y, symbol, &s);
+      } break;
+      case (MS_SYMBOL_ELLIPSE): {
+        ret = renderer->renderEllipseSymbol(image, p_x, p_y, symbol, &s);
+      } break;
+      case (MS_SYMBOL_VECTOR): {
+        ret = renderer->renderVectorSymbol(image, p_x, p_y, symbol, &s);
+      } break;
+      case (MS_SYMBOL_SVG): {
+        if (renderer->supports_svg) {
+          ret = renderer->renderSVGSymbol(image, p_x, p_y, symbol, &s);
+        } else {
 #if defined(USE_SVG_CAIRO) || defined(USE_RSVG)
-            ret = msRenderRasterizedSVGSymbol(image, p_x,p_y, symbol, &s);
+          ret = msRenderRasterizedSVGSymbol(image, p_x, p_y, symbol, &s);
 #else
-            msSetError(MS_SYMERR, "SVG symbol support is not enabled.", "msDrawMarkerSymbol()");
-            return MS_FAILURE;
+          msSetError(MS_SYMERR, "SVG symbol support is not enabled.",
+                     "msDrawMarkerSymbol()");
+          return MS_FAILURE;
 #endif
-          }
         }
+      } break;
+      default:
         break;
-        default:
-          break;
       }
       return ret;
-    } else if( MS_RENDERER_IMAGEMAP(image->format) )
+    } else if (MS_RENDERER_IMAGEMAP(image->format))
       msDrawMarkerSymbolIM(map, image, p, style, scalefactor);
-
   }
   return ret;
 }
 
-
-int msDrawLabelBounds(mapObj *map, imageObj *image, label_bounds *bnds, styleObj *style, double scalefactor)
-{
+int msDrawLabelBounds(mapObj *map, imageObj *image, label_bounds *bnds,
+                      styleObj *style, double scalefactor) {
   /*
-   * helper function to draw label bounds, where we might have only a rectObj and not
-   * a lineObj/shapeObj
+   * helper function to draw label bounds, where we might have only a rectObj
+   * and not a lineObj/shapeObj
    */
   shapeObj shape;
   shape.numlines = 1;
-  if(bnds->poly) {
+  if (bnds->poly) {
     shape.line = bnds->poly;
-    return msDrawShadeSymbol(map,image,&shape,style,scalefactor);
+    return msDrawShadeSymbol(map, image, &shape, style, scalefactor);
   } else {
     pointObj pnts1[5];
     lineObj l;
@@ -978,34 +1048,40 @@ int msDrawLabelBounds(mapObj *map, image
     pnts1[2].x = pnts1[3].x = bnds->bbox.maxx;
     pnts1[0].y = pnts1[3].y = pnts1[4].y = bnds->bbox.miny;
     pnts1[1].y = pnts1[2].y = bnds->bbox.maxy;
-    (void)pnts1[0].x; (void)pnts1[0].y;
-    (void)pnts1[1].x; (void)pnts1[1].y;
-    (void)pnts1[2].x; (void)pnts1[2].y;
-    (void)pnts1[3].x; (void)pnts1[3].y;
-    (void)pnts1[4].x; (void)pnts1[4].y;
+    (void)pnts1[0].x;
+    (void)pnts1[0].y;
+    (void)pnts1[1].x;
+    (void)pnts1[1].y;
+    (void)pnts1[2].x;
+    (void)pnts1[2].y;
+    (void)pnts1[3].x;
+    (void)pnts1[3].y;
+    (void)pnts1[4].x;
+    (void)pnts1[4].y;
     shape.line = &l; // must return from this block
-    return msDrawShadeSymbol(map,image,&shape,style,scalefactor);
+    return msDrawShadeSymbol(map, image, &shape, style, scalefactor);
   }
 }
 
-int msDrawTextSymbol(mapObj *map, imageObj *image, pointObj labelPnt, textSymbolObj *ts)
-{
+int msDrawTextSymbol(mapObj *map, imageObj *image, pointObj labelPnt,
+                     textSymbolObj *ts) {
   (void)map;
   rendererVTableObj *renderer = image->format->vtable;
   colorObj *c = NULL, *oc = NULL;
   int ow;
   assert(ts->textpath);
-  if(!renderer->renderGlyphs) return MS_FAILURE;
+  if (!renderer->renderGlyphs)
+    return MS_FAILURE;
 
-  if(!ts->textpath->absolute) {
+  if (!ts->textpath->absolute) {
     int g;
-    double cosa,sina;
+    double cosa, sina;
     double x = labelPnt.x;
     double y = labelPnt.y;
-    if(ts->rotation != 0) {
+    if (ts->rotation != 0) {
       cosa = cos(ts->rotation);
       sina = sin(ts->rotation);
-      for(g=0;g<ts->textpath->numglyphs;g++) {
+      for (g = 0; g < ts->textpath->numglyphs; g++) {
         double ox = ts->textpath->glyphs[g].pnt.x;
         double oy = ts->textpath->glyphs[g].pnt.y;
         ts->textpath->glyphs[g].pnt.x = ox * cosa + oy * sina + x;
@@ -1013,100 +1089,106 @@ int msDrawTextSymbol(mapObj *map, imageO
         ts->textpath->glyphs[g].rot = ts->rotation;
       }
     } else {
-      for(g=0;g<ts->textpath->numglyphs;g++) {
+      for (g = 0; g < ts->textpath->numglyphs; g++) {
         ts->textpath->glyphs[g].pnt.x += x;
         ts->textpath->glyphs[g].pnt.y += y;
       }
     }
   }
 
-  if(MS_VALID_COLOR(ts->label->shadowcolor)) {
+  if (MS_VALID_COLOR(ts->label->shadowcolor)) {
     textSymbolObj *ts_shadow;
     int g;
     double ox, oy;
-    double cosa,sina;
+    double cosa, sina;
     int ret;
-    if(ts->rotation != 0) {
+    if (ts->rotation != 0) {
       cosa = cos(ts->rotation);
       sina = sin(ts->rotation);
-      ox = ts->scalefactor * (cosa * ts->label->shadowsizex + 
-          sina * ts->label->shadowsizey);
-      oy = ts->scalefactor * (-sina * ts->label->shadowsizex + 
-          cosa * ts->label->shadowsizey);
-    }
-    else {
+      ox = ts->scalefactor *
+           (cosa * ts->label->shadowsizex + sina * ts->label->shadowsizey);
+      oy = ts->scalefactor *
+           (-sina * ts->label->shadowsizex + cosa * ts->label->shadowsizey);
+    } else {
       ox = ts->scalefactor * ts->label->shadowsizex;
       oy = ts->scalefactor * ts->label->shadowsizey;
     }
 
     ts_shadow = msSmallMalloc(sizeof(textSymbolObj));
     initTextSymbol(ts_shadow);
-    msCopyTextSymbol(ts_shadow,ts);
+    msCopyTextSymbol(ts_shadow, ts);
 
-    for(g=0;g<ts_shadow->textpath->numglyphs;g++) {
+    for (g = 0; g < ts_shadow->textpath->numglyphs; g++) {
       ts_shadow->textpath->glyphs[g].pnt.x += ox;
       ts_shadow->textpath->glyphs[g].pnt.y += oy;
     }
 
-    ret = renderer->renderGlyphs(image,ts_shadow,&ts->label->shadowcolor,NULL,0, MS_FALSE);
+    ret = renderer->renderGlyphs(image, ts_shadow, &ts->label->shadowcolor,
+                                 NULL, 0, MS_FALSE);
     freeTextSymbol(ts_shadow);
     msFree(ts_shadow);
-    if( ret != MS_SUCCESS )
+    if (ret != MS_SUCCESS)
       return ret;
   }
 
-  if(MS_VALID_COLOR(ts->label->color))
+  if (MS_VALID_COLOR(ts->label->color))
     c = &ts->label->color;
-  if(MS_VALID_COLOR(ts->label->outlinecolor))
+  if (MS_VALID_COLOR(ts->label->outlinecolor))
     oc = &ts->label->outlinecolor;
-  ow = MS_NINT((double)ts->label->outlinewidth * ((double)ts->textpath->glyph_size / (double)ts->label->size));
-  return renderer->renderGlyphs(image,ts,c,oc,ow, MS_FALSE);
-  
+  ow = MS_NINT((double)ts->label->outlinewidth *
+               ((double)ts->textpath->glyph_size / (double)ts->label->size));
+  return renderer->renderGlyphs(image, ts, c, oc, ow, MS_FALSE);
 }
 
 /************************************************************************/
 /*                          msCircleDrawLineSymbol                      */
 /*                                                                      */
 /************************************************************************/
-int msCircleDrawLineSymbol(mapObj *map, imageObj *image, pointObj *p, double r, styleObj *style, double scalefactor)
-{
+int msCircleDrawLineSymbol(mapObj *map, imageObj *image, pointObj *p, double r,
+                           styleObj *style, double scalefactor) {
   shapeObj *circle;
   int status;
-  if (!image) return MS_FAILURE;
+  if (!image)
+    return MS_FAILURE;
   circle = msRasterizeArc(p->x, p->y, r, 0, 360, 0);
-  if (!circle) return MS_FAILURE;
+  if (!circle)
+    return MS_FAILURE;
   status = msDrawLineSymbol(map, image, circle, style, scalefactor);
   msFreeShape(circle);
   msFree(circle);
   return status;
 }
 
-int msCircleDrawShadeSymbol(mapObj *map, imageObj *image, pointObj *p, double r, styleObj *style, double scalefactor)
-{
+int msCircleDrawShadeSymbol(mapObj *map, imageObj *image, pointObj *p, double r,
+                            styleObj *style, double scalefactor) {
   shapeObj *circle;
   int status;
-  if (!image) return MS_FAILURE;
+  if (!image)
+    return MS_FAILURE;
   circle = msRasterizeArc(p->x, p->y, r, 0, 360, 0);
-  if (!circle) return MS_FAILURE;
+  if (!circle)
+    return MS_FAILURE;
   status = msDrawShadeSymbol(map, image, circle, style, scalefactor);
   msFreeShape(circle);
   msFree(circle);
   return status;
 }
 
-int msDrawPieSlice(mapObj *map, imageObj *image, pointObj *p, styleObj *style, double radius, double start, double end)
-{
+int msDrawPieSlice(mapObj *map, imageObj *image, pointObj *p, styleObj *style,
+                   double radius, double start, double end) {
   int status;
   shapeObj *circle;
   double center_x = p->x;
   double center_y = p->y;
-  if (!image) return MS_FAILURE;
-  if(style->offsetx>0) {
-    center_x+=style->offsetx*cos(((-start-end)*MS_PI/360.));
-    center_y-=style->offsetx*sin(((-start-end)*MS_PI/360.));
+  if (!image)
+    return MS_FAILURE;
+  if (style->offsetx > 0) {
+    center_x += style->offsetx * cos(((-start - end) * MS_PI / 360.));
+    center_y -= style->offsetx * sin(((-start - end) * MS_PI / 360.));
   }
   circle = msRasterizeArc(center_x, center_y, radius, start, end, 1);
-  if (!circle) return MS_FAILURE;
+  if (!circle)
+    return MS_FAILURE;
   status = msDrawShadeSymbol(map, image, circle, style, 1.0);
   msFreeShape(circle);
   msFree(circle);
@@ -1122,16 +1204,19 @@ int msDrawPieSlice(mapObj *map, imageObj
  *    caching mechanism
  */
 
-void msOutlineRenderingPrepareStyle(styleObj *pStyle, mapObj *map, layerObj *layer, imageObj *image)
-{
+void msOutlineRenderingPrepareStyle(styleObj *pStyle, mapObj *map,
+                                    layerObj *layer, imageObj *image) {
   colorObj tmp;
 
   if (pStyle->outlinewidth > 0) {
     /* adapt width (must take scalefactor into account) */
-    pStyle->width += (pStyle->outlinewidth / (layer->scalefactor/image->resolutionfactor)) * 2;
+    pStyle->width += (pStyle->outlinewidth /
+                      (layer->scalefactor / image->resolutionfactor)) *
+                     2;
     pStyle->minwidth += pStyle->outlinewidth * 2;
     pStyle->maxwidth += pStyle->outlinewidth * 2;
-    pStyle->size += (pStyle->outlinewidth/layer->scalefactor*(map->resolution/map->defresolution));
+    pStyle->size += (pStyle->outlinewidth / layer->scalefactor *
+                     (map->resolution / map->defresolution));
 
     /*swap color and outlinecolor*/
     tmp = pStyle->color;
@@ -1146,16 +1231,19 @@ void msOutlineRenderingPrepareStyle(styl
  * second pass of the caching mechanism
  */
 
-void msOutlineRenderingRestoreStyle(styleObj *pStyle, mapObj *map, layerObj *layer, imageObj *image)
-{
+void msOutlineRenderingRestoreStyle(styleObj *pStyle, mapObj *map,
+                                    layerObj *layer, imageObj *image) {
   colorObj tmp;
 
   if (pStyle->outlinewidth > 0) {
     /* reset widths to original state */
-    pStyle->width -= (pStyle->outlinewidth / (layer->scalefactor/image->resolutionfactor)) * 2;
+    pStyle->width -= (pStyle->outlinewidth /
+                      (layer->scalefactor / image->resolutionfactor)) *
+                     2;
     pStyle->minwidth -= pStyle->outlinewidth * 2;
     pStyle->maxwidth -= pStyle->outlinewidth * 2;
-    pStyle->size -= (pStyle->outlinewidth/layer->scalefactor*(map->resolution/map->defresolution));
+    pStyle->size -= (pStyle->outlinewidth / layer->scalefactor *
+                     (map->resolution / map->defresolution));
 
     /*reswap colors to original state*/
     tmp = pStyle->color;
diff -pruN 8.0.1-5/mapresample.c 8.0.2-1/mapresample.c
--- 8.0.1-5/mapresample.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapresample.c	2024-06-11 20:41:34.000000000 +0000
@@ -31,9 +31,9 @@
 #include "mapresample.h"
 #include "mapthread.h"
 
-
-
-#define SKIP_MASK(x,y) (mask_rb && !*(mask_rb->data.rgba.a+(y)*mask_rb->data.rgba.row_step+(x)*mask_rb->data.rgba.pixel_step))
+#define SKIP_MASK(x, y)                                                        \
+  (mask_rb && !*(mask_rb->data.rgba.a + (y)*mask_rb->data.rgba.row_step +      \
+                 (x)*mask_rb->data.rgba.pixel_step))
 
 /************************************************************************/
 /*                          InvGeoTransform()                           */
@@ -42,10 +42,10 @@
 /*      implicit [1 0 0] final row.                                     */
 /************************************************************************/
 
-int InvGeoTransform( double *gt_in, double *gt_out )
+int InvGeoTransform(double *gt_in, double *gt_out)
 
 {
-  double  det, inv_det;
+  double det, inv_det;
 
   /* we assume a 3rd row that is [1 0 0] */
 
@@ -53,20 +53,20 @@ int InvGeoTransform( double *gt_in, doub
 
   det = gt_in[1] * gt_in[5] - gt_in[2] * gt_in[4];
 
-  if( fabs(det) < 0.000000000000001 )
+  if (fabs(det) < 0.000000000000001)
     return 0;
 
   inv_det = 1.0 / det;
 
   /* compute adjoint, and devide by determinate */
 
-  gt_out[1] =  gt_in[5] * inv_det;
+  gt_out[1] = gt_in[5] * inv_det;
   gt_out[4] = -gt_in[4] * inv_det;
 
   gt_out[2] = -gt_in[2] * inv_det;
-  gt_out[5] =  gt_in[1] * inv_det;
+  gt_out[5] = gt_in[1] * inv_det;
 
-  gt_out[0] = ( gt_in[2] * gt_in[3] - gt_in[0] * gt_in[5]) * inv_det;
+  gt_out[0] = (gt_in[2] * gt_in[3] - gt_in[0] * gt_in[5]) * inv_det;
   gt_out[3] = (-gt_in[1] * gt_in[3] + gt_in[0] * gt_in[4]) * inv_det;
 
   return 1;
@@ -76,133 +76,121 @@ int InvGeoTransform( double *gt_in, doub
 /*                      msNearestRasterResample()                       */
 /************************************************************************/
 
-static int
-msNearestRasterResampler( imageObj *psSrcImage, rasterBufferObj *src_rb,
-                          imageObj *psDstImage, rasterBufferObj *dst_rb,
-                          SimpleTransformer pfnTransform, void *pCBData,
-                          int debug, rasterBufferObj *mask_rb,
-                          int bWrapAtLeftRight )
+static int msNearestRasterResampler(
+    imageObj *psSrcImage, rasterBufferObj *src_rb, imageObj *psDstImage,
+    rasterBufferObj *dst_rb, SimpleTransformer pfnTransform, void *pCBData,
+    int debug, rasterBufferObj *mask_rb, int bWrapAtLeftRight)
 
 {
-  double  *x, *y;
-  int   nDstX, nDstY;
-  int         *panSuccess;
-  int   nDstXSize = psDstImage->width;
-  int   nDstYSize = psDstImage->height;
-  int   nSrcXSize = psSrcImage->width;
-  int   nSrcYSize = psSrcImage->height;
-  int   nFailedPoints = 0, nSetPoints = 0;
-  assert(!MS_RENDERER_PLUGIN(psSrcImage->format) || src_rb->type == MS_BUFFER_BYTE_RGBA);
-
-
-  x = (double *) msSmallMalloc( sizeof(double) * nDstXSize );
-  y = (double *) msSmallMalloc( sizeof(double) * nDstXSize );
-  panSuccess = (int *) msSmallMalloc( sizeof(int) * nDstXSize );
+  double *x, *y;
+  int nDstX, nDstY;
+  int *panSuccess;
+  int nDstXSize = psDstImage->width;
+  int nDstYSize = psDstImage->height;
+  int nSrcXSize = psSrcImage->width;
+  int nSrcYSize = psSrcImage->height;
+  int nFailedPoints = 0, nSetPoints = 0;
+  assert(!MS_RENDERER_PLUGIN(psSrcImage->format) ||
+         src_rb->type == MS_BUFFER_BYTE_RGBA);
+
+  x = (double *)msSmallMalloc(sizeof(double) * nDstXSize);
+  y = (double *)msSmallMalloc(sizeof(double) * nDstXSize);
+  panSuccess = (int *)msSmallMalloc(sizeof(int) * nDstXSize);
 
-  for( nDstY = 0; nDstY < nDstYSize; nDstY++ ) {
-    for( nDstX = 0; nDstX < nDstXSize; nDstX++ ) {
+  for (nDstY = 0; nDstY < nDstYSize; nDstY++) {
+    for (nDstX = 0; nDstX < nDstXSize; nDstX++) {
       x[nDstX] = nDstX + 0.5;
       y[nDstX] = nDstY + 0.5;
     }
 
-    pfnTransform( pCBData, nDstXSize, x, y, panSuccess );
+    pfnTransform(pCBData, nDstXSize, x, y, panSuccess);
 
-    for( nDstX = 0; nDstX < nDstXSize; nDstX++ ) {
-      int   nSrcX, nSrcY;
-      if(SKIP_MASK(nDstX,nDstY))
+    for (nDstX = 0; nDstX < nDstXSize; nDstX++) {
+      int nSrcX, nSrcY;
+      if (SKIP_MASK(nDstX, nDstY))
         continue;
 
-      if( !panSuccess[nDstX] ) {
+      if (!panSuccess[nDstX]) {
         nFailedPoints++;
         continue;
       }
 
-      nSrcX = (int) x[nDstX];
-      nSrcY = (int) y[nDstX];
+      nSrcX = (int)x[nDstX];
+      nSrcY = (int)y[nDstX];
 
-      if( bWrapAtLeftRight && nSrcX >= nSrcXSize && nSrcX < 2 * nSrcXSize )
-          nSrcX -= nSrcXSize;
+      if (bWrapAtLeftRight && nSrcX >= nSrcXSize && nSrcX < 2 * nSrcXSize)
+        nSrcX -= nSrcXSize;
 
       /*
        * We test the original floating point values to
        * avoid errors related to asymmetric rounding around zero.
        * (Also note bug #3120 regarding nearly redundent x/y < 0 checks).
        */
-      if( x[nDstX] < 0.0 || y[nDstX] < 0.0
-          || nSrcX < 0 || nSrcY < 0
-          || nSrcX >= nSrcXSize || nSrcY >= nSrcYSize ) {
+      if (x[nDstX] < 0.0 || y[nDstX] < 0.0 || nSrcX < 0 || nSrcY < 0 ||
+          nSrcX >= nSrcXSize || nSrcY >= nSrcYSize) {
         continue;
       }
 
-      if( MS_RENDERER_PLUGIN(psSrcImage->format) ) {
+      if (MS_RENDERER_PLUGIN(psSrcImage->format)) {
         int src_rb_off;
-        rgbaArrayObj *src,*dst;
-        assert( src_rb && dst_rb );
-        assert( src_rb->type == MS_BUFFER_BYTE_RGBA );
+        rgbaArrayObj *src, *dst;
+        assert(src_rb && dst_rb);
+        assert(src_rb->type == MS_BUFFER_BYTE_RGBA);
         src = &src_rb->data.rgba;
         dst = &dst_rb->data.rgba;
-        src_rb_off = nSrcX * src->pixel_step
-                      + nSrcY * src->row_step;
+        src_rb_off = nSrcX * src->pixel_step + nSrcY * src->row_step;
 
-        if( src->a == NULL || src->a[src_rb_off] == 255 ) {
+        if (src->a == NULL || src->a[src_rb_off] == 255) {
           int dst_rb_off;
 
-          dst_rb_off = nDstX * dst->pixel_step
-                        + nDstY * dst->row_step;
+          dst_rb_off = nDstX * dst->pixel_step + nDstY * dst->row_step;
 
           nSetPoints++;
 
           dst->r[dst_rb_off] = src->r[src_rb_off];
           dst->g[dst_rb_off] = src->g[src_rb_off];
           dst->b[dst_rb_off] = src->b[src_rb_off];
-          if( dst->a )
+          if (dst->a)
             dst->a[dst_rb_off] = 255;
-        } else if( src->a[src_rb_off] != 0 ) {
+        } else if (src->a[src_rb_off] != 0) {
           int dst_rb_off;
 
-          dst_rb_off = nDstX * dst->pixel_step
-                        + nDstY * dst->row_step;
+          dst_rb_off = nDstX * dst->pixel_step + nDstY * dst->row_step;
 
           nSetPoints++;
 
           /* actual alpha blending is required */
-          msAlphaBlendPM( src->r[src_rb_off],
-                          src->g[src_rb_off],
-                          src->b[src_rb_off],
-                          src->a[src_rb_off],
-                          dst->r + dst_rb_off,
-                          dst->g + dst_rb_off,
-                          dst->b + dst_rb_off,
-                          dst->a ? dst->a + dst_rb_off : NULL  );
-
+          msAlphaBlendPM(
+              src->r[src_rb_off], src->g[src_rb_off], src->b[src_rb_off],
+              src->a[src_rb_off], dst->r + dst_rb_off, dst->g + dst_rb_off,
+              dst->b + dst_rb_off, dst->a ? dst->a + dst_rb_off : NULL);
         }
-      } else if( MS_RENDERER_RAWDATA(psSrcImage->format) ) {
+      } else if (MS_RENDERER_RAWDATA(psSrcImage->format)) {
         int band, src_off, dst_off;
 
         src_off = nSrcX + nSrcY * psSrcImage->width;
 
-        if( !MS_GET_BIT(psSrcImage->img_mask,src_off) )
+        if (!MS_GET_BIT(psSrcImage->img_mask, src_off))
           continue;
 
         nSetPoints++;
 
         dst_off = nDstX + nDstY * psDstImage->width;
 
-        MS_SET_BIT(psDstImage->img_mask,dst_off);
+        MS_SET_BIT(psDstImage->img_mask, dst_off);
 
-        for( band = 0; band < psSrcImage->format->bands; band++ ) {
-          if( psSrcImage->format->imagemode == MS_IMAGEMODE_INT16 ) {
-            psDstImage->img.raw_16bit[dst_off]
-              = psSrcImage->img.raw_16bit[src_off];
-          } else if( psSrcImage->format->imagemode
-                     == MS_IMAGEMODE_FLOAT32) {
-            psDstImage->img.raw_float[dst_off]
-              = psSrcImage->img.raw_float[src_off];
-          } else if(psSrcImage->format->imagemode == MS_IMAGEMODE_BYTE) {
-            psDstImage->img.raw_byte[dst_off]
-              = psSrcImage->img.raw_byte[src_off];
+        for (band = 0; band < psSrcImage->format->bands; band++) {
+          if (psSrcImage->format->imagemode == MS_IMAGEMODE_INT16) {
+            psDstImage->img.raw_16bit[dst_off] =
+                psSrcImage->img.raw_16bit[src_off];
+          } else if (psSrcImage->format->imagemode == MS_IMAGEMODE_FLOAT32) {
+            psDstImage->img.raw_float[dst_off] =
+                psSrcImage->img.raw_float[src_off];
+          } else if (psSrcImage->format->imagemode == MS_IMAGEMODE_BYTE) {
+            psDstImage->img.raw_byte[dst_off] =
+                psSrcImage->img.raw_byte[src_off];
           } else {
-            assert( 0 );
+            assert(0);
           }
           src_off += psSrcImage->width * psSrcImage->height;
           dst_off += psDstImage->width * psDstImage->height;
@@ -211,17 +199,17 @@ msNearestRasterResampler( imageObj *psSr
     }
   }
 
-  free( panSuccess );
-  free( x );
-  free( y );
+  free(panSuccess);
+  free(x);
+  free(y);
 
   /* -------------------------------------------------------------------- */
   /*      Some debugging output.                                          */
   /* -------------------------------------------------------------------- */
-  if( nFailedPoints > 0 && debug ) {
-    msDebug( "msNearestRasterResampler: "
-             "%d failed to transform, %d actually set.\n",
-             nFailedPoints, nSetPoints );
+  if (nFailedPoints > 0 && debug) {
+    msDebug("msNearestRasterResampler: "
+            "%d failed to transform, %d actually set.\n",
+            nFailedPoints, nSetPoints);
   }
 
   return 0;
@@ -231,59 +219,58 @@ msNearestRasterResampler( imageObj *psSr
 /*                            msSourceSample()                          */
 /************************************************************************/
 
-static void msSourceSample( imageObj *psSrcImage, rasterBufferObj *rb,
-                            int iSrcX, int iSrcY, double *padfPixelSum,
-                            double dfWeight, double *pdfWeightSum )
+static void msSourceSample(imageObj *psSrcImage, rasterBufferObj *rb, int iSrcX,
+                           int iSrcY, double *padfPixelSum, double dfWeight,
+                           double *pdfWeightSum)
 
 {
-  if( MS_RENDERER_PLUGIN(psSrcImage->format) ) {
+  if (MS_RENDERER_PLUGIN(psSrcImage->format)) {
     rgbaArrayObj *rgba;
     int rb_off;
     assert(rb && rb->type == MS_BUFFER_BYTE_RGBA);
     rgba = &(rb->data.rgba);
     rb_off = iSrcX * rgba->pixel_step + iSrcY * rgba->row_step;
 
-    if( rgba->a == NULL || rgba->a[rb_off] > 1 ) {
+    if (rgba->a == NULL || rgba->a[rb_off] > 1) {
       padfPixelSum[0] += rgba->r[rb_off] * dfWeight;
       padfPixelSum[1] += rgba->g[rb_off] * dfWeight;
       padfPixelSum[2] += rgba->b[rb_off] * dfWeight;
 
-      if( rgba->a == NULL )
+      if (rgba->a == NULL)
         *pdfWeightSum += dfWeight;
       else
         *pdfWeightSum += dfWeight * (rgba->a[rb_off] / 255.0);
     }
-  } else if( MS_RENDERER_RAWDATA(psSrcImage->format) ) {
+  } else if (MS_RENDERER_RAWDATA(psSrcImage->format)) {
     int band;
     int src_off;
 
     src_off = iSrcX + iSrcY * psSrcImage->width;
 
-    if( !MS_GET_BIT(psSrcImage->img_mask,src_off) )
+    if (!MS_GET_BIT(psSrcImage->img_mask, src_off))
       return;
 
-    for( band = 0; band < psSrcImage->format->bands; band++ ) {
-      if( psSrcImage->format->imagemode == MS_IMAGEMODE_INT16 ) {
+    for (band = 0; band < psSrcImage->format->bands; band++) {
+      if (psSrcImage->format->imagemode == MS_IMAGEMODE_INT16) {
         int nValue;
 
         nValue = psSrcImage->img.raw_16bit[src_off];
 
         padfPixelSum[band] += dfWeight * nValue;
-      } else if( psSrcImage->format->imagemode
-                 == MS_IMAGEMODE_FLOAT32) {
+      } else if (psSrcImage->format->imagemode == MS_IMAGEMODE_FLOAT32) {
         float fValue;
 
         fValue = psSrcImage->img.raw_float[src_off];
 
         padfPixelSum[band] += fValue * dfWeight;
-      } else if(psSrcImage->format->imagemode == MS_IMAGEMODE_BYTE) {
+      } else if (psSrcImage->format->imagemode == MS_IMAGEMODE_BYTE) {
         int nValue;
 
         nValue = psSrcImage->img.raw_byte[src_off];
 
         padfPixelSum[band] += nValue * dfWeight;
       } else {
-        assert( 0 );
+        assert(0);
         return;
       }
 
@@ -297,56 +284,53 @@ static void msSourceSample( imageObj *ps
 /*                      msBilinearRasterResample()                      */
 /************************************************************************/
 
-static int
-msBilinearRasterResampler( imageObj *psSrcImage, rasterBufferObj *src_rb,
-                           imageObj *psDstImage, rasterBufferObj *dst_rb,
-                           SimpleTransformer pfnTransform, void *pCBData,
-                           int debug, rasterBufferObj *mask_rb,
-                           int bWrapAtLeftRight )
+static int msBilinearRasterResampler(
+    imageObj *psSrcImage, rasterBufferObj *src_rb, imageObj *psDstImage,
+    rasterBufferObj *dst_rb, SimpleTransformer pfnTransform, void *pCBData,
+    int debug, rasterBufferObj *mask_rb, int bWrapAtLeftRight)
 
 {
-  double  *x, *y;
-  int   nDstX, nDstY, i;
-  int         *panSuccess;
-  int   nDstXSize = psDstImage->width;
-  int   nDstYSize = psDstImage->height;
-  int   nSrcXSize = psSrcImage->width;
-  int   nSrcYSize = psSrcImage->height;
-  int   nFailedPoints = 0, nSetPoints = 0;
-  double     *padfPixelSum;
-  int         bandCount = MS_MAX(4,psSrcImage->format->bands);
-
-  padfPixelSum = (double *) msSmallMalloc(sizeof(double) * bandCount);
-
-
+  double *x, *y;
+  int nDstX, nDstY, i;
+  int *panSuccess;
+  int nDstXSize = psDstImage->width;
+  int nDstYSize = psDstImage->height;
+  int nSrcXSize = psSrcImage->width;
+  int nSrcYSize = psSrcImage->height;
+  int nFailedPoints = 0, nSetPoints = 0;
+  double *padfPixelSum;
+  int bandCount = MS_MAX(4, psSrcImage->format->bands);
+
+  padfPixelSum = (double *)msSmallMalloc(sizeof(double) * bandCount);
+
+  x = (double *)msSmallMalloc(sizeof(double) * nDstXSize);
+  y = (double *)msSmallMalloc(sizeof(double) * nDstXSize);
+  panSuccess = (int *)msSmallMalloc(sizeof(int) * nDstXSize);
 
-  x = (double *) msSmallMalloc( sizeof(double) * nDstXSize );
-  y = (double *) msSmallMalloc( sizeof(double) * nDstXSize );
-  panSuccess = (int *) msSmallMalloc( sizeof(int) * nDstXSize );
-
-  for( nDstY = 0; nDstY < nDstYSize; nDstY++ ) {
-    for( nDstX = 0; nDstX < nDstXSize; nDstX++ ) {
+  for (nDstY = 0; nDstY < nDstYSize; nDstY++) {
+    for (nDstX = 0; nDstX < nDstXSize; nDstX++) {
       x[nDstX] = nDstX + 0.5;
       y[nDstX] = nDstY + 0.5;
     }
 
-    pfnTransform( pCBData, nDstXSize, x, y, panSuccess );
+    pfnTransform(pCBData, nDstXSize, x, y, panSuccess);
 
-    for( nDstX = 0; nDstX < nDstXSize; nDstX++ ) {
-      int   nSrcX, nSrcY, nSrcX2, nSrcY2;
-      double      dfRatioX2, dfRatioY2, dfWeightSum = 0.0;
-      if(SKIP_MASK(nDstX,nDstY)) continue;
+    for (nDstX = 0; nDstX < nDstXSize; nDstX++) {
+      int nSrcX, nSrcY, nSrcX2, nSrcY2;
+      double dfRatioX2, dfRatioY2, dfWeightSum = 0.0;
+      if (SKIP_MASK(nDstX, nDstY))
+        continue;
 
-      if( !panSuccess[nDstX] ) {
+      if (!panSuccess[nDstX]) {
         nFailedPoints++;
         continue;
       }
 
       /* If we are right off the source, skip this pixel */
-      nSrcX = (int) floor(x[nDstX]);
-      nSrcY = (int) floor(y[nDstX]);
-      if( nSrcX < 0 || (!bWrapAtLeftRight && nSrcX >= nSrcXSize)
-          || nSrcY  < 0 || nSrcY >= nSrcYSize )
+      nSrcX = (int)floor(x[nDstX]);
+      nSrcY = (int)floor(y[nDstX]);
+      if (nSrcX < 0 || (!bWrapAtLeftRight && nSrcX >= nSrcXSize) || nSrcY < 0 ||
+          nSrcY >= nSrcYSize)
         continue;
 
       /*
@@ -356,106 +340,102 @@ msBilinearRasterResampler( imageObj *psS
       x[nDstX] -= 0.5;
       y[nDstX] -= 0.5;
 
-      nSrcX = (int) floor(x[nDstX]);
-      nSrcY = (int) floor(y[nDstX]);
+      nSrcX = (int)floor(x[nDstX]);
+      nSrcY = (int)floor(y[nDstX]);
 
-      nSrcX2 = nSrcX+1;
-      nSrcY2 = nSrcY+1;
+      nSrcX2 = nSrcX + 1;
+      nSrcY2 = nSrcY + 1;
 
       dfRatioX2 = x[nDstX] - nSrcX;
       dfRatioY2 = y[nDstX] - nSrcY;
 
       /* Trim in stuff one pixel off the edge */
-      nSrcX = MS_MAX(nSrcX,0);
-      nSrcY = MS_MAX(nSrcY,0);
-      if( !bWrapAtLeftRight )
-        nSrcX2 = MS_MIN(nSrcX2,nSrcXSize-1);
-      nSrcY2 = MS_MIN(nSrcY2,nSrcYSize-1);
-
-      memset( padfPixelSum, 0, sizeof(double) * bandCount);
-
-      msSourceSample( psSrcImage, src_rb, nSrcX % nSrcXSize, nSrcY, padfPixelSum,
-                      (1.0 - dfRatioX2) * (1.0 - dfRatioY2),
-                      &dfWeightSum );
-
-      msSourceSample( psSrcImage, src_rb, nSrcX2 % nSrcXSize, nSrcY, padfPixelSum,
-                      (dfRatioX2) * (1.0 - dfRatioY2),
-                      &dfWeightSum );
-
-      msSourceSample( psSrcImage, src_rb, nSrcX % nSrcXSize, nSrcY2, padfPixelSum,
-                      (1.0 - dfRatioX2) * (dfRatioY2),
-                      &dfWeightSum );
-
-      msSourceSample( psSrcImage, src_rb, nSrcX2 % nSrcXSize, nSrcY2, padfPixelSum,
-                      (dfRatioX2) * (dfRatioY2),
-                      &dfWeightSum );
+      nSrcX = MS_MAX(nSrcX, 0);
+      nSrcY = MS_MAX(nSrcY, 0);
+      if (!bWrapAtLeftRight)
+        nSrcX2 = MS_MIN(nSrcX2, nSrcXSize - 1);
+      nSrcY2 = MS_MIN(nSrcY2, nSrcYSize - 1);
 
-      if( dfWeightSum == 0.0 )
+      memset(padfPixelSum, 0, sizeof(double) * bandCount);
+
+      msSourceSample(psSrcImage, src_rb, nSrcX % nSrcXSize, nSrcY, padfPixelSum,
+                     (1.0 - dfRatioX2) * (1.0 - dfRatioY2), &dfWeightSum);
+
+      msSourceSample(psSrcImage, src_rb, nSrcX2 % nSrcXSize, nSrcY,
+                     padfPixelSum, (dfRatioX2) * (1.0 - dfRatioY2),
+                     &dfWeightSum);
+
+      msSourceSample(psSrcImage, src_rb, nSrcX % nSrcXSize, nSrcY2,
+                     padfPixelSum, (1.0 - dfRatioX2) * (dfRatioY2),
+                     &dfWeightSum);
+
+      msSourceSample(psSrcImage, src_rb, nSrcX2 % nSrcXSize, nSrcY2,
+                     padfPixelSum, (dfRatioX2) * (dfRatioY2), &dfWeightSum);
+
+      if (dfWeightSum == 0.0)
         continue;
 
-      if( MS_RENDERER_PLUGIN(psSrcImage->format) ) {
+      if (MS_RENDERER_PLUGIN(psSrcImage->format)) {
         assert(src_rb && dst_rb);
-        assert( src_rb->type == MS_BUFFER_BYTE_RGBA );
-        assert( src_rb->type == dst_rb->type );
-
+        assert(src_rb->type == MS_BUFFER_BYTE_RGBA);
+        assert(src_rb->type == dst_rb->type);
 
         nSetPoints++;
 
-        if( dfWeightSum > 0.001 ) {
-          int dst_rb_off = nDstX * dst_rb->data.rgba.pixel_step + nDstY * dst_rb->data.rgba.row_step;
+        if (dfWeightSum > 0.001) {
+          int dst_rb_off = nDstX * dst_rb->data.rgba.pixel_step +
+                           nDstY * dst_rb->data.rgba.row_step;
           unsigned char red, green, blue, alpha;
 
-          red   = (unsigned char) MS_MAX(0,MS_MIN(255,padfPixelSum[0]));
-          green = (unsigned char) MS_MAX(0,MS_MIN(255,padfPixelSum[1]));
-          blue  = (unsigned char) MS_MAX(0,MS_MIN(255,padfPixelSum[2]));
-          alpha = (unsigned char)MS_MAX(0,MS_MIN(255,255.5*dfWeightSum));
-
-          msAlphaBlendPM( red, green, blue, alpha,
-                          dst_rb->data.rgba.r + dst_rb_off,
-                          dst_rb->data.rgba.g + dst_rb_off,
-                          dst_rb->data.rgba.b + dst_rb_off,
-                          (dst_rb->data.rgba.a == NULL) ? NULL : dst_rb->data.rgba.a + dst_rb_off );
+          red = (unsigned char)MS_MAX(0, MS_MIN(255, padfPixelSum[0]));
+          green = (unsigned char)MS_MAX(0, MS_MIN(255, padfPixelSum[1]));
+          blue = (unsigned char)MS_MAX(0, MS_MIN(255, padfPixelSum[2]));
+          alpha = (unsigned char)MS_MAX(0, MS_MIN(255, 255.5 * dfWeightSum));
+
+          msAlphaBlendPM(
+              red, green, blue, alpha, dst_rb->data.rgba.r + dst_rb_off,
+              dst_rb->data.rgba.g + dst_rb_off,
+              dst_rb->data.rgba.b + dst_rb_off,
+              (dst_rb->data.rgba.a == NULL) ? NULL
+                                            : dst_rb->data.rgba.a + dst_rb_off);
         }
-      } else if( MS_RENDERER_RAWDATA(psSrcImage->format) ) {
+      } else if (MS_RENDERER_RAWDATA(psSrcImage->format)) {
         int band;
         int dst_off = nDstX + nDstY * psDstImage->width;
 
-        for( i = 0; i < bandCount; i++ )
-            padfPixelSum[i] /= dfWeightSum;
+        for (i = 0; i < bandCount; i++)
+          padfPixelSum[i] /= dfWeightSum;
 
-        MS_SET_BIT(psDstImage->img_mask,dst_off);
+        MS_SET_BIT(psDstImage->img_mask, dst_off);
 
-        for( band = 0; band < psSrcImage->format->bands; band++ ) {
-          if( psSrcImage->format->imagemode == MS_IMAGEMODE_INT16 ) {
-            psDstImage->img.raw_16bit[dst_off]
-              = (short) padfPixelSum[band];
-          } else if( psSrcImage->format->imagemode == MS_IMAGEMODE_FLOAT32) {
-            psDstImage->img.raw_float[dst_off]
-              = (float) padfPixelSum[band];
-          } else if( psSrcImage->format->imagemode == MS_IMAGEMODE_BYTE ) {
-            psDstImage->img.raw_byte[dst_off]
-              = (unsigned char)MS_MAX(0,MS_MIN(255,padfPixelSum[band]));
+        for (band = 0; band < psSrcImage->format->bands; band++) {
+          if (psSrcImage->format->imagemode == MS_IMAGEMODE_INT16) {
+            psDstImage->img.raw_16bit[dst_off] = (short)padfPixelSum[band];
+          } else if (psSrcImage->format->imagemode == MS_IMAGEMODE_FLOAT32) {
+            psDstImage->img.raw_float[dst_off] = (float)padfPixelSum[band];
+          } else if (psSrcImage->format->imagemode == MS_IMAGEMODE_BYTE) {
+            psDstImage->img.raw_byte[dst_off] =
+                (unsigned char)MS_MAX(0, MS_MIN(255, padfPixelSum[band]));
           }
 
-          dst_off += psDstImage->width*psDstImage->height;
+          dst_off += psDstImage->width * psDstImage->height;
         }
       }
     }
   }
 
-  free( padfPixelSum );
-  free( panSuccess );
-  free( x );
-  free( y );
+  free(padfPixelSum);
+  free(panSuccess);
+  free(x);
+  free(y);
 
   /* -------------------------------------------------------------------- */
   /*      Some debugging output.                                          */
   /* -------------------------------------------------------------------- */
-  if( nFailedPoints > 0 && debug )
-  {
-    msDebug( "msBilinearRasterResampler: "
-             "%d failed to transform, %d actually set.\n",
-             nFailedPoints, nSetPoints );
+  if (nFailedPoints > 0 && debug) {
+    msDebug("msBilinearRasterResampler: "
+            "%d failed to transform, %d actually set.\n",
+            nFailedPoints, nSetPoints);
   }
 
   return 0;
@@ -465,48 +445,47 @@ msBilinearRasterResampler( imageObj *psS
 /*                          msAverageSample()                           */
 /************************************************************************/
 
-static int
-msAverageSample( imageObj *psSrcImage, rasterBufferObj *src_rb,
-                 double dfXMin, double dfYMin, double dfXMax, double dfYMax,
-                 double *padfPixelSum,
-                 double *pdfAlpha01 )
+static int msAverageSample(imageObj *psSrcImage, rasterBufferObj *src_rb,
+                           double dfXMin, double dfYMin, double dfXMax,
+                           double dfYMax, double *padfPixelSum,
+                           double *pdfAlpha01)
 
 {
   int nXMin, nXMax, nYMin, nYMax, iX, iY;
   double dfWeightSum = 0.0;
   double dfMaxWeight = 0.0;
 
-  nXMin = (int) dfXMin;
-  nYMin = (int) dfYMin;
-  nXMax = (int) ceil(dfXMax);
-  nYMax = (int) ceil(dfYMax);
+  nXMin = (int)dfXMin;
+  nYMin = (int)dfYMin;
+  nXMax = (int)ceil(dfXMax);
+  nYMax = (int)ceil(dfYMax);
 
   *pdfAlpha01 = 0.0;
 
-  for( iY = nYMin; iY < nYMax; iY++ ) {
+  for (iY = nYMin; iY < nYMax; iY++) {
     double dfYCellMin, dfYCellMax;
 
-    dfYCellMin = MS_MAX(iY,dfYMin);
-    dfYCellMax = MS_MIN(iY+1,dfYMax);
+    dfYCellMin = MS_MAX(iY, dfYMin);
+    dfYCellMax = MS_MIN(iY + 1, dfYMax);
 
-    for( iX = nXMin; iX < nXMax; iX++ ) {
+    for (iX = nXMin; iX < nXMax; iX++) {
       double dfXCellMin, dfXCellMax, dfWeight;
 
-      dfXCellMin = MS_MAX(iX,dfXMin);
-      dfXCellMax = MS_MIN(iX+1,dfXMax);
+      dfXCellMin = MS_MAX(iX, dfXMin);
+      dfXCellMax = MS_MIN(iX + 1, dfXMax);
 
-      dfWeight = (dfXCellMax-dfXCellMin) * (dfYCellMax-dfYCellMin);
+      dfWeight = (dfXCellMax - dfXCellMin) * (dfYCellMax - dfYCellMin);
 
-      msSourceSample( psSrcImage, src_rb, iX, iY, padfPixelSum,
-                      dfWeight, &dfWeightSum );
+      msSourceSample(psSrcImage, src_rb, iX, iY, padfPixelSum, dfWeight,
+                     &dfWeightSum);
       dfMaxWeight += dfWeight;
     }
   }
 
-  if( dfWeightSum == 0.0 )
+  if (dfWeightSum == 0.0)
     return MS_FALSE;
 
-  for( iX = 0; iX < 4; iX++ )
+  for (iX = 0; iX < 4; iX++)
     padfPixelSum[iX] /= dfWeightSum;
 
   *pdfAlpha01 = dfWeightSum / dfMaxWeight;
@@ -519,115 +498,107 @@ msAverageSample( imageObj *psSrcImage, r
 /************************************************************************/
 
 static int
-msAverageRasterResampler( imageObj *psSrcImage, rasterBufferObj *src_rb,
-                          imageObj *psDstImage, rasterBufferObj *dst_rb,
-                          SimpleTransformer pfnTransform, void *pCBData,
-                          int debug, rasterBufferObj *mask_rb )
+msAverageRasterResampler(imageObj *psSrcImage, rasterBufferObj *src_rb,
+                         imageObj *psDstImage, rasterBufferObj *dst_rb,
+                         SimpleTransformer pfnTransform, void *pCBData,
+                         int debug, rasterBufferObj *mask_rb)
 
 {
-  double  *x1, *y1, *x2, *y2;
-  int   nDstX, nDstY;
-  int         *panSuccess1, *panSuccess2;
-  int   nDstXSize = psDstImage->width;
-  int   nDstYSize = psDstImage->height;
-  int   nFailedPoints = 0, nSetPoints = 0;
-  double     *padfPixelSum;
+  double *x1, *y1, *x2, *y2;
+  int nDstX, nDstY;
+  int *panSuccess1, *panSuccess2;
+  int nDstXSize = psDstImage->width;
+  int nDstYSize = psDstImage->height;
+  int nFailedPoints = 0, nSetPoints = 0;
+  double *padfPixelSum;
+
+  int bandCount = MS_MAX(4, psSrcImage->format->bands);
+
+  padfPixelSum = (double *)msSmallMalloc(sizeof(double) * bandCount);
+
+  x1 = (double *)msSmallMalloc(sizeof(double) * (nDstXSize + 1));
+  y1 = (double *)msSmallMalloc(sizeof(double) * (nDstXSize + 1));
+  x2 = (double *)msSmallMalloc(sizeof(double) * (nDstXSize + 1));
+  y2 = (double *)msSmallMalloc(sizeof(double) * (nDstXSize + 1));
+  panSuccess1 = (int *)msSmallMalloc(sizeof(int) * (nDstXSize + 1));
+  panSuccess2 = (int *)msSmallMalloc(sizeof(int) * (nDstXSize + 1));
 
-  int         bandCount = MS_MAX(4,psSrcImage->format->bands);
-
-  padfPixelSum = (double *) msSmallMalloc(sizeof(double) * bandCount);
-
-
-
-  x1 = (double *) msSmallMalloc( sizeof(double) * (nDstXSize+1) );
-  y1 = (double *) msSmallMalloc( sizeof(double) * (nDstXSize+1) );
-  x2 = (double *) msSmallMalloc( sizeof(double) * (nDstXSize+1) );
-  y2 = (double *) msSmallMalloc( sizeof(double) * (nDstXSize+1) );
-  panSuccess1 = (int *) msSmallMalloc( sizeof(int) * (nDstXSize+1) );
-  panSuccess2 = (int *) msSmallMalloc( sizeof(int) * (nDstXSize+1) );
-
-  for( nDstY = 0; nDstY < nDstYSize; nDstY++ ) {
-    for( nDstX = 0; nDstX <= nDstXSize; nDstX++ ) {
+  for (nDstY = 0; nDstY < nDstYSize; nDstY++) {
+    for (nDstX = 0; nDstX <= nDstXSize; nDstX++) {
       x1[nDstX] = nDstX;
       y1[nDstX] = nDstY;
       x2[nDstX] = nDstX;
-      y2[nDstX] = nDstY+1;
+      y2[nDstX] = nDstY + 1;
     }
 
-    pfnTransform( pCBData, nDstXSize+1, x1, y1, panSuccess1 );
-    pfnTransform( pCBData, nDstXSize+1, x2, y2, panSuccess2 );
+    pfnTransform(pCBData, nDstXSize + 1, x1, y1, panSuccess1);
+    pfnTransform(pCBData, nDstXSize + 1, x2, y2, panSuccess2);
 
-    for( nDstX = 0; nDstX < nDstXSize; nDstX++ ) {
-      double  dfXMin, dfYMin, dfXMax, dfYMax;
-      double  dfAlpha01;
-      if(SKIP_MASK(nDstX,nDstY)) continue;
+    for (nDstX = 0; nDstX < nDstXSize; nDstX++) {
+      double dfXMin, dfYMin, dfXMax, dfYMax;
+      double dfAlpha01;
+      if (SKIP_MASK(nDstX, nDstY))
+        continue;
 
       /* Do not generate a pixel unless all four corners transformed */
-      if( !panSuccess1[nDstX] || !panSuccess1[nDstX+1]
-          || !panSuccess2[nDstX] || !panSuccess2[nDstX+1] ) {
+      if (!panSuccess1[nDstX] || !panSuccess1[nDstX + 1] ||
+          !panSuccess2[nDstX] || !panSuccess2[nDstX + 1]) {
         nFailedPoints++;
         continue;
       }
 
-      dfXMin = MS_MIN(MS_MIN(x1[nDstX],x1[nDstX+1]),
-                   MS_MIN(x2[nDstX],x2[nDstX+1]));
-      dfYMin = MS_MIN(MS_MIN(y1[nDstX],y1[nDstX+1]),
-                   MS_MIN(y2[nDstX],y2[nDstX+1]));
-      dfXMax = MS_MAX(MS_MAX(x1[nDstX],x1[nDstX+1]),
-                   MS_MAX(x2[nDstX],x2[nDstX+1]));
-      dfYMax = MS_MAX(MS_MAX(y1[nDstX],y1[nDstX+1]),
-                   MS_MAX(y2[nDstX],y2[nDstX+1]));
-
-      dfXMin = MS_MIN(MS_MAX(dfXMin,0),psSrcImage->width+1);
-      dfYMin = MS_MIN(MS_MAX(dfYMin,0),psSrcImage->height+1);
-      dfXMax = MS_MIN(MS_MAX(-1,dfXMax),psSrcImage->width);
-      dfYMax = MS_MIN(MS_MAX(-1,dfYMax),psSrcImage->height);
-
-      memset( padfPixelSum, 0, sizeof(double)*bandCount );
-
-      if( !msAverageSample( psSrcImage, src_rb,
-                            dfXMin, dfYMin, dfXMax, dfYMax,
-                            padfPixelSum, &dfAlpha01 ) )
+      dfXMin = MS_MIN(MS_MIN(x1[nDstX], x1[nDstX + 1]),
+                      MS_MIN(x2[nDstX], x2[nDstX + 1]));
+      dfYMin = MS_MIN(MS_MIN(y1[nDstX], y1[nDstX + 1]),
+                      MS_MIN(y2[nDstX], y2[nDstX + 1]));
+      dfXMax = MS_MAX(MS_MAX(x1[nDstX], x1[nDstX + 1]),
+                      MS_MAX(x2[nDstX], x2[nDstX + 1]));
+      dfYMax = MS_MAX(MS_MAX(y1[nDstX], y1[nDstX + 1]),
+                      MS_MAX(y2[nDstX], y2[nDstX + 1]));
+
+      dfXMin = MS_MIN(MS_MAX(dfXMin, 0), psSrcImage->width + 1);
+      dfYMin = MS_MIN(MS_MAX(dfYMin, 0), psSrcImage->height + 1);
+      dfXMax = MS_MIN(MS_MAX(-1, dfXMax), psSrcImage->width);
+      dfYMax = MS_MIN(MS_MAX(-1, dfYMax), psSrcImage->height);
+
+      memset(padfPixelSum, 0, sizeof(double) * bandCount);
+
+      if (!msAverageSample(psSrcImage, src_rb, dfXMin, dfYMin, dfXMax, dfYMax,
+                           padfPixelSum, &dfAlpha01))
         continue;
 
-      if( MS_RENDERER_PLUGIN(psSrcImage->format) ) {
+      if (MS_RENDERER_PLUGIN(psSrcImage->format)) {
         assert(dst_rb && src_rb);
-        assert( dst_rb->type == MS_BUFFER_BYTE_RGBA );
-        assert( src_rb->type == dst_rb ->type );
+        assert(dst_rb->type == MS_BUFFER_BYTE_RGBA);
+        assert(src_rb->type == dst_rb->type);
 
         nSetPoints++;
 
-        if( dfAlpha01 > 0 ) {
+        if (dfAlpha01 > 0) {
           unsigned char red, green, blue, alpha;
 
-          red   = (unsigned char)
-                  MS_MAX(0,MS_MIN(255,padfPixelSum[0]+0.5));
-          green = (unsigned char)
-                  MS_MAX(0,MS_MIN(255,padfPixelSum[1]+0.5));
-          blue  = (unsigned char)
-                  MS_MAX(0,MS_MIN(255,padfPixelSum[2]+0.5));
-          alpha = (unsigned char)
-                  MS_MAX(0,MS_MIN(255,255*dfAlpha01+0.5));
+          red = (unsigned char)MS_MAX(0, MS_MIN(255, padfPixelSum[0] + 0.5));
+          green = (unsigned char)MS_MAX(0, MS_MIN(255, padfPixelSum[1] + 0.5));
+          blue = (unsigned char)MS_MAX(0, MS_MIN(255, padfPixelSum[2] + 0.5));
+          alpha = (unsigned char)MS_MAX(0, MS_MIN(255, 255 * dfAlpha01 + 0.5));
 
-          RB_MIX_PIXEL(dst_rb,nDstX,nDstY,
-                       red, green, blue, alpha );
+          RB_MIX_PIXEL(dst_rb, nDstX, nDstY, red, green, blue, alpha);
         }
-      } else if( MS_RENDERER_RAWDATA(psSrcImage->format) ) {
+      } else if (MS_RENDERER_RAWDATA(psSrcImage->format)) {
         int band;
         int dst_off = nDstX + nDstY * psDstImage->width;
 
-        MS_SET_BIT(psDstImage->img_mask,dst_off);
+        MS_SET_BIT(psDstImage->img_mask, dst_off);
 
-        for( band = 0; band < psSrcImage->format->bands; band++ ) {
-          if( psSrcImage->format->imagemode == MS_IMAGEMODE_INT16 ) {
-            psDstImage->img.raw_16bit[dst_off]
-              = (short) (padfPixelSum[band]+0.5);
-          } else if( psSrcImage->format->imagemode == MS_IMAGEMODE_FLOAT32) {
-            psDstImage->img.raw_float[dst_off]
-              = (float) padfPixelSum[band];
-          } else if( psSrcImage->format->imagemode == MS_IMAGEMODE_BYTE ) {
-            psDstImage->img.raw_byte[dst_off]
-              = (unsigned char) padfPixelSum[band];
+        for (band = 0; band < psSrcImage->format->bands; band++) {
+          if (psSrcImage->format->imagemode == MS_IMAGEMODE_INT16) {
+            psDstImage->img.raw_16bit[dst_off] =
+                (short)(padfPixelSum[band] + 0.5);
+          } else if (psSrcImage->format->imagemode == MS_IMAGEMODE_FLOAT32) {
+            psDstImage->img.raw_float[dst_off] = (float)padfPixelSum[band];
+          } else if (psSrcImage->format->imagemode == MS_IMAGEMODE_BYTE) {
+            psDstImage->img.raw_byte[dst_off] =
+                (unsigned char)padfPixelSum[band];
           }
 
           dst_off += psDstImage->width * psDstImage->height;
@@ -636,22 +607,21 @@ msAverageRasterResampler( imageObj *psSr
     }
   }
 
-  free( padfPixelSum );
-  free( panSuccess1 );
-  free( x1 );
-  free( y1 );
-  free( panSuccess2 );
-  free( x2 );
-  free( y2 );
+  free(padfPixelSum);
+  free(panSuccess1);
+  free(x1);
+  free(y1);
+  free(panSuccess2);
+  free(x2);
+  free(y2);
 
   /* -------------------------------------------------------------------- */
   /*      Some debugging output.                                          */
   /* -------------------------------------------------------------------- */
-  if( nFailedPoints > 0 && debug )
-  {
-    msDebug( "msAverageRasterResampler: "
-             "%d failed to transform, %d actually set.\n",
-             nFailedPoints, nSetPoints );
+  if (nFailedPoints > 0 && debug) {
+    msDebug("msAverageRasterResampler: "
+            "%d failed to transform, %d actually set.\n",
+            nFailedPoints, nSetPoints);
   }
 
   return 0;
@@ -672,9 +642,9 @@ typedef struct {
   int bDstIsGeographic;
   double adfDstGeoTransform[6];
 
-  int  bUseProj;
+  int bUseProj;
 #if PROJ_VERSION_MAJOR >= 6
-  reprojectionObj* pReprojectionDstToSrc;
+  reprojectionObj *pReprojectionDstToSrc;
 #endif
 } msProjTransformInfo;
 
@@ -682,17 +652,16 @@ typedef struct {
 /*                       msInitProjTransformer()                        */
 /************************************************************************/
 
-void *msInitProjTransformer( projectionObj *psSrc,
-                             double *padfSrcGeoTransform,
-                             projectionObj *psDst,
-                             double *padfDstGeoTransform )
+void *msInitProjTransformer(projectionObj *psSrc, double *padfSrcGeoTransform,
+                            projectionObj *psDst, double *padfDstGeoTransform)
 
 {
   int backup_src_need_gt;
   int backup_dst_need_gt;
   msProjTransformInfo *psPTInfo;
 
-  psPTInfo = (msProjTransformInfo *) msSmallCalloc(1,sizeof(msProjTransformInfo));
+  psPTInfo =
+      (msProjTransformInfo *)msSmallCalloc(1, sizeof(msProjTransformInfo));
 
   /* -------------------------------------------------------------------- */
   /*      We won't even use PROJ.4 if either coordinate system is         */
@@ -702,9 +671,8 @@ void *msInitProjTransformer( projectionO
   psSrc->gt.need_geotransform = 0;
   backup_dst_need_gt = psDst->gt.need_geotransform;
   psDst->gt.need_geotransform = 0;
-  psPTInfo->bUseProj =
-    (psSrc->proj != NULL && psDst->proj != NULL
-     && msProjectionsDiffer( psSrc, psDst ) );
+  psPTInfo->bUseProj = (psSrc->proj != NULL && psDst->proj != NULL &&
+                        msProjectionsDiffer(psSrc, psDst));
   psSrc->gt.need_geotransform = backup_src_need_gt;
   psDst->gt.need_geotransform = backup_dst_need_gt;
 
@@ -714,13 +682,12 @@ void *msInitProjTransformer( projectionO
   /*      the transformer.                                                */
   /* -------------------------------------------------------------------- */
   psPTInfo->psSrcProjObj = psSrc;
-  if( psPTInfo->bUseProj )
+  if (psPTInfo->bUseProj)
     psPTInfo->bSrcIsGeographic = msProjIsGeographicCRS(psSrc);
   else
     psPTInfo->bSrcIsGeographic = MS_FALSE;
 
-  if( !InvGeoTransform(padfSrcGeoTransform,
-                       psPTInfo->adfInvSrcGeoTransform) ) {
+  if (!InvGeoTransform(padfSrcGeoTransform, psPTInfo->adfInvSrcGeoTransform)) {
     free(psPTInfo);
     return NULL;
   }
@@ -729,22 +696,19 @@ void *msInitProjTransformer( projectionO
   /*      Record destination image information.                           */
   /* -------------------------------------------------------------------- */
   psPTInfo->psDstProjObj = psDst;
-  if( psPTInfo->bUseProj )
+  if (psPTInfo->bUseProj)
     psPTInfo->bDstIsGeographic = msProjIsGeographicCRS(psDst);
   else
     psPTInfo->bDstIsGeographic = MS_FALSE;
-  memcpy( psPTInfo->adfDstGeoTransform, padfDstGeoTransform,
-          sizeof(double) * 6 );
+  memcpy(psPTInfo->adfDstGeoTransform, padfDstGeoTransform, sizeof(double) * 6);
 
 #if PROJ_VERSION_MAJOR >= 6
-  if( psPTInfo->bUseProj )
-  {
-    psPTInfo->pReprojectionDstToSrc =
-        msProjectCreateReprojector( psPTInfo->psDstProjObj, psPTInfo->psSrcProjObj );
-    if( !psPTInfo->pReprojectionDstToSrc )
-    {
-        free(psPTInfo);
-        return NULL;
+  if (psPTInfo->bUseProj) {
+    psPTInfo->pReprojectionDstToSrc = msProjectCreateReprojector(
+        psPTInfo->psDstProjObj, psPTInfo->psSrcProjObj);
+    if (!psPTInfo->pReprojectionDstToSrc) {
+      free(psPTInfo);
+      return NULL;
     }
   }
 #endif
@@ -756,57 +720,56 @@ void *msInitProjTransformer( projectionO
 /*                       msFreeProjTransformer()                        */
 /************************************************************************/
 
-void msFreeProjTransformer( void * pCBData )
+void msFreeProjTransformer(void *pCBData)
 
 {
 #if PROJ_VERSION_MAJOR >= 6
-  if( pCBData )
-  {
-      msProjTransformInfo *psPTInfo = (msProjTransformInfo *)pCBData;
-      msProjectDestroyReprojector(psPTInfo->pReprojectionDstToSrc);
+  if (pCBData) {
+    msProjTransformInfo *psPTInfo = (msProjTransformInfo *)pCBData;
+    msProjectDestroyReprojector(psPTInfo->pReprojectionDstToSrc);
   }
 #endif
-  free( pCBData );
+  free(pCBData);
 }
 
 /************************************************************************/
 /*                          msProjTransformer                           */
 /************************************************************************/
 
-int msProjTransformer( void *pCBData, int nPoints,
-                       double *x, double *y, int *panSuccess )
+int msProjTransformer(void *pCBData, int nPoints, double *x, double *y,
+                      int *panSuccess)
 
 {
-  int   i;
-  msProjTransformInfo *psPTInfo = (msProjTransformInfo*) pCBData;
-  double  x_out;
+  int i;
+  msProjTransformInfo *psPTInfo = (msProjTransformInfo *)pCBData;
+  double x_out;
 
   /* -------------------------------------------------------------------- */
   /*      Transform into destination georeferenced space.                 */
   /* -------------------------------------------------------------------- */
-  for( i = 0; i < nPoints; i++ ) {
-    x_out = psPTInfo->adfDstGeoTransform[0]
-            + psPTInfo->adfDstGeoTransform[1] * x[i]
-            + psPTInfo->adfDstGeoTransform[2] * y[i];
-    y[i] = psPTInfo->adfDstGeoTransform[3]
-           + psPTInfo->adfDstGeoTransform[4] * x[i]
-           + psPTInfo->adfDstGeoTransform[5] * y[i];
+  for (i = 0; i < nPoints; i++) {
+    x_out = psPTInfo->adfDstGeoTransform[0] +
+            psPTInfo->adfDstGeoTransform[1] * x[i] +
+            psPTInfo->adfDstGeoTransform[2] * y[i];
+    y[i] = psPTInfo->adfDstGeoTransform[3] +
+           psPTInfo->adfDstGeoTransform[4] * x[i] +
+           psPTInfo->adfDstGeoTransform[5] * y[i];
     x[i] = x_out;
 
     panSuccess[i] = 1;
   }
 
 #if PROJ_VERSION_MAJOR >= 6
-  if( psPTInfo->bUseProj ) {
-    if( msProjectTransformPoints( psPTInfo->pReprojectionDstToSrc,
-                                  nPoints, x, y ) != MS_SUCCESS ) {
-      for( i = 0; i < nPoints; i++ )
+  if (psPTInfo->bUseProj) {
+    if (msProjectTransformPoints(psPTInfo->pReprojectionDstToSrc, nPoints, x,
+                                 y) != MS_SUCCESS) {
+      for (i = 0; i < nPoints; i++)
         panSuccess[i] = 0;
 
       return MS_FALSE;
     }
-    for( i = 0; i < nPoints; i++ ) {
-      if( x[i] == HUGE_VAL || y[i] == HUGE_VAL )
+    for (i = 0; i < nPoints; i++) {
+      if (x[i] == HUGE_VAL || y[i] == HUGE_VAL)
         panSuccess[i] = 0;
     }
   }
@@ -814,8 +777,8 @@ int msProjTransformer( void *pCBData, in
   /* -------------------------------------------------------------------- */
   /*      Transform from degrees to radians if geographic.                */
   /* -------------------------------------------------------------------- */
-  if( psPTInfo->bDstIsGeographic ) {
-    for( i = 0; i < nPoints; i++ ) {
+  if (psPTInfo->bDstIsGeographic) {
+    for (i = 0; i < nPoints; i++) {
       x[i] = x[i] * DEG_TO_RAD;
       y[i] = y[i] * DEG_TO_RAD;
     }
@@ -824,28 +787,28 @@ int msProjTransformer( void *pCBData, in
   /* -------------------------------------------------------------------- */
   /*      Transform back to source projection space.                      */
   /* -------------------------------------------------------------------- */
-  if( psPTInfo->bUseProj ) {
+  if (psPTInfo->bUseProj) {
     double *z;
     int tr_result;
 
-    z = (double *) msSmallCalloc(sizeof(double),nPoints);
+    z = (double *)msSmallCalloc(sizeof(double), nPoints);
 
-    msAcquireLock( TLOCK_PROJ );
-    tr_result = pj_transform( psPTInfo->psDstProjObj->proj, psPTInfo->psSrcProjObj->proj,
-                              nPoints, 1, x, y,  z);
-    msReleaseLock( TLOCK_PROJ );
-
-    if( tr_result != 0 ) {
-      free( z );
-      for( i = 0; i < nPoints; i++ )
+    msAcquireLock(TLOCK_PROJ);
+    tr_result = pj_transform(psPTInfo->psDstProjObj->proj,
+                             psPTInfo->psSrcProjObj->proj, nPoints, 1, x, y, z);
+    msReleaseLock(TLOCK_PROJ);
+
+    if (tr_result != 0) {
+      free(z);
+      for (i = 0; i < nPoints; i++)
         panSuccess[i] = 0;
 
       return MS_FALSE;
     }
-    free( z );
+    free(z);
 
-    for( i = 0; i < nPoints; i++ ) {
-      if( x[i] == HUGE_VAL || y[i] == HUGE_VAL )
+    for (i = 0; i < nPoints; i++) {
+      if (x[i] == HUGE_VAL || y[i] == HUGE_VAL)
         panSuccess[i] = 0;
     }
   }
@@ -853,9 +816,9 @@ int msProjTransformer( void *pCBData, in
   /* -------------------------------------------------------------------- */
   /*      Transform back to degrees if source is geographic.              */
   /* -------------------------------------------------------------------- */
-  if( psPTInfo->bSrcIsGeographic ) {
-    for( i = 0; i < nPoints; i++ ) {
-      if( panSuccess[i] ) {
+  if (psPTInfo->bSrcIsGeographic) {
+    for (i = 0; i < nPoints; i++) {
+      if (panSuccess[i]) {
         x[i] = x[i] * RAD_TO_DEG;
         y[i] = y[i] * RAD_TO_DEG;
       }
@@ -866,14 +829,14 @@ int msProjTransformer( void *pCBData, in
   /* -------------------------------------------------------------------- */
   /*      Transform to source raster space.                               */
   /* -------------------------------------------------------------------- */
-  for( i = 0; i < nPoints; i++ ) {
-    if( panSuccess[i] ) {
-      x_out = psPTInfo->adfInvSrcGeoTransform[0]
-              + psPTInfo->adfInvSrcGeoTransform[1] * x[i]
-              + psPTInfo->adfInvSrcGeoTransform[2] * y[i];
-      y[i] = psPTInfo->adfInvSrcGeoTransform[3]
-             + psPTInfo->adfInvSrcGeoTransform[4] * x[i]
-             + psPTInfo->adfInvSrcGeoTransform[5] * y[i];
+  for (i = 0; i < nPoints; i++) {
+    if (panSuccess[i]) {
+      x_out = psPTInfo->adfInvSrcGeoTransform[0] +
+              psPTInfo->adfInvSrcGeoTransform[1] * x[i] +
+              psPTInfo->adfInvSrcGeoTransform[2] * y[i];
+      y[i] = psPTInfo->adfInvSrcGeoTransform[3] +
+             psPTInfo->adfInvSrcGeoTransform[4] * x[i] +
+             psPTInfo->adfInvSrcGeoTransform[5] * y[i];
       x[i] = x_out;
     } else {
       x[i] = -1;
@@ -892,23 +855,23 @@ int msProjTransformer( void *pCBData, in
 
 typedef struct {
   SimpleTransformer pfnBaseTransformer;
-  void             *pBaseCBData;
+  void *pBaseCBData;
 
-  double        dfMaxError;
+  double dfMaxError;
 } msApproxTransformInfo;
 
 /************************************************************************/
 /*                      msInitApproxTransformer()                       */
 /************************************************************************/
 
-static void *msInitApproxTransformer( SimpleTransformer pfnBaseTransformer,
-                                      void *pBaseCBData,
-                                      double dfMaxError )
+static void *msInitApproxTransformer(SimpleTransformer pfnBaseTransformer,
+                                     void *pBaseCBData, double dfMaxError)
 
 {
   msApproxTransformInfo *psATInfo;
 
-  psATInfo = (msApproxTransformInfo *) msSmallMalloc(sizeof(msApproxTransformInfo));
+  psATInfo =
+      (msApproxTransformInfo *)msSmallMalloc(sizeof(msApproxTransformInfo));
   psATInfo->pfnBaseTransformer = pfnBaseTransformer;
   psATInfo->pBaseCBData = pBaseCBData;
   psATInfo->dfMaxError = dfMaxError;
@@ -920,35 +883,34 @@ static void *msInitApproxTransformer( Si
 /*                      msFreeApproxTransformer()                       */
 /************************************************************************/
 
-static void msFreeApproxTransformer( void * pCBData )
+static void msFreeApproxTransformer(void *pCBData)
 
 {
-  free( pCBData );
+  free(pCBData);
 }
 
 /************************************************************************/
 /*                         msApproxTransformer                          */
 /************************************************************************/
 
-static int msApproxTransformer( void *pCBData, int nPoints,
-                                double *x, double *y, int *panSuccess )
+static int msApproxTransformer(void *pCBData, int nPoints, double *x, double *y,
+                               int *panSuccess)
 
 {
-  msApproxTransformInfo *psATInfo = (msApproxTransformInfo *) pCBData;
+  msApproxTransformInfo *psATInfo = (msApproxTransformInfo *)pCBData;
   double x2[3], y2[3], dfDeltaX, dfDeltaY, dfError, dfDist;
   int nMiddle, anSuccess2[3], i, bSuccess;
 
-  nMiddle = (nPoints-1)/2;
+  nMiddle = (nPoints - 1) / 2;
 
   /* -------------------------------------------------------------------- */
   /*      Bail if our preconditions are not met, or if error is not       */
   /*      acceptable.                                                     */
   /* -------------------------------------------------------------------- */
-  if( y[0] != y[nPoints-1] || y[0] != y[nMiddle]
-      || x[0] == x[nPoints-1] || x[0] == x[nMiddle]
-      || psATInfo->dfMaxError == 0.0 || nPoints <= 5 ) {
-    return psATInfo->pfnBaseTransformer( psATInfo->pBaseCBData, nPoints,
-                                         x, y, panSuccess );
+  if (y[0] != y[nPoints - 1] || y[0] != y[nMiddle] || x[0] == x[nPoints - 1] ||
+      x[0] == x[nMiddle] || psATInfo->dfMaxError == 0.0 || nPoints <= 5) {
+    return psATInfo->pfnBaseTransformer(psATInfo->pBaseCBData, nPoints, x, y,
+                                        panSuccess);
   }
 
   /* -------------------------------------------------------------------- */
@@ -958,44 +920,39 @@ static int msApproxTransformer( void *pC
   y2[0] = y[0];
   x2[1] = x[nMiddle];
   y2[1] = y[nMiddle];
-  x2[2] = x[nPoints-1];
-  y2[2] = y[nPoints-1];
+  x2[2] = x[nPoints - 1];
+  y2[2] = y[nPoints - 1];
 
-  bSuccess =
-    psATInfo->pfnBaseTransformer( psATInfo->pBaseCBData, 3, x2, y2,
-                                  anSuccess2 );
-  if( !bSuccess || !anSuccess2[0] || !anSuccess2[1] || !anSuccess2[2] )
-    return psATInfo->pfnBaseTransformer( psATInfo->pBaseCBData, nPoints,
-                                         x, y, panSuccess );
+  bSuccess = psATInfo->pfnBaseTransformer(psATInfo->pBaseCBData, 3, x2, y2,
+                                          anSuccess2);
+  if (!bSuccess || !anSuccess2[0] || !anSuccess2[1] || !anSuccess2[2])
+    return psATInfo->pfnBaseTransformer(psATInfo->pBaseCBData, nPoints, x, y,
+                                        panSuccess);
 
   /* -------------------------------------------------------------------- */
   /*      Is the error at the middle acceptable relative to an            */
   /*      interpolation of the middle position?                           */
   /* -------------------------------------------------------------------- */
-  dfDeltaX = (x2[2] - x2[0]) / (x[nPoints-1] - x[0]);
-  dfDeltaY = (y2[2] - y2[0]) / (x[nPoints-1] - x[0]);
+  dfDeltaX = (x2[2] - x2[0]) / (x[nPoints - 1] - x[0]);
+  dfDeltaY = (y2[2] - y2[0]) / (x[nPoints - 1] - x[0]);
+
+  dfError = fabs((x2[0] + dfDeltaX * (x[nMiddle] - x[0])) - x2[1]) +
+            fabs((y2[0] + dfDeltaY * (x[nMiddle] - x[0])) - y2[1]);
 
-  dfError = fabs((x2[0] + dfDeltaX * (x[nMiddle] - x[0])) - x2[1])
-            + fabs((y2[0] + dfDeltaY * (x[nMiddle] - x[0])) - y2[1]);
+  if (dfError > psATInfo->dfMaxError) {
+    bSuccess = msApproxTransformer(psATInfo, nMiddle, x, y, panSuccess);
 
-  if( dfError > psATInfo->dfMaxError ) {
-    bSuccess =
-      msApproxTransformer( psATInfo, nMiddle, x, y, panSuccess );
-
-    if( !bSuccess ) {
-      return psATInfo->pfnBaseTransformer( psATInfo->pBaseCBData,
-                                           nPoints,
-                                           x, y, panSuccess );
-    }
-
-    bSuccess =
-      msApproxTransformer( psATInfo, nPoints - nMiddle,
-                           x+nMiddle, y+nMiddle, panSuccess+nMiddle );
-
-    if( !bSuccess ) {
-      return psATInfo->pfnBaseTransformer( psATInfo->pBaseCBData,
-                                           nPoints,
-                                           x, y, panSuccess );
+    if (!bSuccess) {
+      return psATInfo->pfnBaseTransformer(psATInfo->pBaseCBData, nPoints, x, y,
+                                          panSuccess);
+    }
+
+    bSuccess = msApproxTransformer(psATInfo, nPoints - nMiddle, x + nMiddle,
+                                   y + nMiddle, panSuccess + nMiddle);
+
+    if (!bSuccess) {
+      return psATInfo->pfnBaseTransformer(psATInfo->pBaseCBData, nPoints, x, y,
+                                          panSuccess);
     }
 
     return 1;
@@ -1004,7 +961,7 @@ static int msApproxTransformer( void *pC
   /* -------------------------------------------------------------------- */
   /*      Error is OK, linearly interpolate all points along line.        */
   /* -------------------------------------------------------------------- */
-  for( i = nPoints-1; i >= 0; i-- ) {
+  for (i = nPoints - 1; i >= 0; i--) {
     dfDist = (x[i] - x[0]);
     y[i] = y2[0] + dfDeltaY * dfDist;
     x[i] = x2[0] + dfDeltaX * dfDist;
@@ -1021,24 +978,21 @@ static int msApproxTransformer( void *pC
 /*      onto the source raster.                                         */
 /************************************************************************/
 
-static int msTransformMapToSource( int nDstXSize, int nDstYSize,
-                                   double * adfDstGeoTransform,
-                                   projectionObj *psDstProj,
-                                   int nSrcXSize, int nSrcYSize,
-                                   double * adfInvSrcGeoTransform,
-                                   projectionObj *psSrcProj,
-                                   rectObj *psSrcExtent,
-                                   int bUseGrid )
+static int
+msTransformMapToSource(int nDstXSize, int nDstYSize, double *adfDstGeoTransform,
+                       projectionObj *psDstProj, int nSrcXSize, int nSrcYSize,
+                       double *adfInvSrcGeoTransform, projectionObj *psSrcProj,
+                       rectObj *psSrcExtent, int bUseGrid)
 
 {
   int nFailures = 0;
 
-#define EDGE_STEPS    10
-#define MAX_SIZE      ((EDGE_STEPS+1)*(EDGE_STEPS+1))
+#define EDGE_STEPS 10
+#define MAX_SIZE ((EDGE_STEPS + 1) * (EDGE_STEPS + 1))
 
-  int   i, nSamples = 0, bOutInit = 0;
-  double      dfRatio;
-  double  x[MAX_SIZE], y[MAX_SIZE];
+  int i, nSamples = 0, bOutInit = 0;
+  double dfRatio;
+  double x[MAX_SIZE], y[MAX_SIZE];
 #if PROJ_VERSION_MAJOR < 6
   double z[MAX_SIZE];
 #endif
@@ -1046,16 +1000,16 @@ static int msTransformMapToSource( int n
   /* -------------------------------------------------------------------- */
   /*      Collect edges in map image pixel/line coordinates               */
   /* -------------------------------------------------------------------- */
-  if( !bUseGrid ) {
-    for( dfRatio = 0.0; dfRatio <= 1.001; dfRatio += (1.0/EDGE_STEPS) ) {
-      assert( nSamples < MAX_SIZE );
-      x[nSamples  ] = dfRatio * nDstXSize;
+  if (!bUseGrid) {
+    for (dfRatio = 0.0; dfRatio <= 1.001; dfRatio += (1.0 / EDGE_STEPS)) {
+      assert(nSamples < MAX_SIZE);
+      x[nSamples] = dfRatio * nDstXSize;
       y[nSamples++] = 0.0;
-      x[nSamples  ] = dfRatio * nDstXSize;
+      x[nSamples] = dfRatio * nDstXSize;
       y[nSamples++] = nDstYSize;
-      x[nSamples  ] = 0.0;
+      x[nSamples] = 0.0;
       y[nSamples++] = dfRatio * nDstYSize;
-      x[nSamples  ] = nDstXSize;
+      x[nSamples] = nDstXSize;
       y[nSamples++] = dfRatio * nDstYSize;
     }
   }
@@ -1066,10 +1020,10 @@ static int msTransformMapToSource( int n
   else {
     double dfRatio2;
 
-    for( dfRatio = 0.0; dfRatio <= 1.001; dfRatio += (1.0/EDGE_STEPS) ) {
-      for( dfRatio2=0.0; dfRatio2 <= 1.001; dfRatio2 += (1.0/EDGE_STEPS)) {
-        assert( nSamples < MAX_SIZE );
-        x[nSamples  ] = dfRatio2 * nDstXSize;
+    for (dfRatio = 0.0; dfRatio <= 1.001; dfRatio += (1.0 / EDGE_STEPS)) {
+      for (dfRatio2 = 0.0; dfRatio2 <= 1.001; dfRatio2 += (1.0 / EDGE_STEPS)) {
+        assert(nSamples < MAX_SIZE);
+        x[nSamples] = dfRatio2 * nDstXSize;
         y[nSamples++] = dfRatio * nDstYSize;
       }
     }
@@ -1078,16 +1032,14 @@ static int msTransformMapToSource( int n
   /* -------------------------------------------------------------------- */
   /*      transform to map georeferenced units                            */
   /* -------------------------------------------------------------------- */
-  for( i = 0; i < nSamples; i++ ) {
-    double    x_out, y_out;
+  for (i = 0; i < nSamples; i++) {
+    double x_out, y_out;
 
-    x_out = adfDstGeoTransform[0]
-            + x[i] * adfDstGeoTransform[1]
-            + y[i] * adfDstGeoTransform[2];
-
-    y_out = adfDstGeoTransform[3]
-            + x[i] * adfDstGeoTransform[4]
-            + y[i] * adfDstGeoTransform[5];
+    x_out = adfDstGeoTransform[0] + x[i] * adfDstGeoTransform[1] +
+            y[i] * adfDstGeoTransform[2];
+
+    y_out = adfDstGeoTransform[3] + x[i] * adfDstGeoTransform[4] +
+            y[i] * adfDstGeoTransform[5];
 
     x[i] = x_out;
     y[i] = y_out;
@@ -1099,36 +1051,37 @@ static int msTransformMapToSource( int n
   /* -------------------------------------------------------------------- */
   /*      Transform to layer georeferenced coordinates.                   */
   /* -------------------------------------------------------------------- */
-  if( psDstProj->proj && psSrcProj->proj ) {
+  if (psDstProj->proj && psSrcProj->proj) {
 #if PROJ_VERSION_MAJOR >= 6
-    reprojectionObj* reprojector = msProjectCreateReprojector(psDstProj, psSrcProj);
-    if( !reprojector )
-        return MS_FALSE;
-    if( msProjectTransformPoints( reprojector, nSamples, x, y ) != MS_SUCCESS ) {
+    reprojectionObj *reprojector =
+        msProjectCreateReprojector(psDstProj, psSrcProj);
+    if (!reprojector)
+      return MS_FALSE;
+    if (msProjectTransformPoints(reprojector, nSamples, x, y) != MS_SUCCESS) {
       msProjectDestroyReprojector(reprojector);
       return MS_FALSE;
     }
     msProjectDestroyReprojector(reprojector);
 #else
     int tr_result;
-    if( msProjIsGeographicCRS(psDstProj) ) {
-      for( i = 0; i < nSamples; i++ ) {
+    if (msProjIsGeographicCRS(psDstProj)) {
+      for (i = 0; i < nSamples; i++) {
         x[i] = x[i] * DEG_TO_RAD;
         y[i] = y[i] * DEG_TO_RAD;
       }
     }
 
-    msAcquireLock( TLOCK_PROJ );
-    tr_result = pj_transform( psDstProj->proj, psSrcProj->proj,
-                              nSamples, 1, x, y, z );
-    msReleaseLock( TLOCK_PROJ );
+    msAcquireLock(TLOCK_PROJ);
+    tr_result =
+        pj_transform(psDstProj->proj, psSrcProj->proj, nSamples, 1, x, y, z);
+    msReleaseLock(TLOCK_PROJ);
 
-    if( tr_result != 0 )
+    if (tr_result != 0)
       return MS_FALSE;
 
-    if( msProjIsGeographicCRS(psSrcProj) ) {
-      for( i = 0; i < nSamples; i++ ) {
-        if( x[i] != HUGE_VAL && y[i] != HUGE_VAL ) {
+    if (msProjIsGeographicCRS(psSrcProj)) {
+      for (i = 0; i < nSamples; i++) {
+        if (x[i] != HUGE_VAL && y[i] != HUGE_VAL) {
           x[i] = x[i] * RAD_TO_DEG;
           y[i] = y[i] * RAD_TO_DEG;
         }
@@ -1141,14 +1094,12 @@ static int msTransformMapToSource( int n
   /*      If we just using the edges (not a grid) and we go some          */
   /*      errors, then we need to restart using a grid pattern.           */
   /* -------------------------------------------------------------------- */
-  if( !bUseGrid ) {
-    for( i = 0; i < nSamples; i++ ) {
-      if( x[i] == HUGE_VAL || y[i] == HUGE_VAL ) {
-        return msTransformMapToSource( nDstXSize, nDstYSize,
-                                       adfDstGeoTransform, psDstProj,
-                                       nSrcXSize, nSrcYSize,
-                                       adfInvSrcGeoTransform,psSrcProj,
-                                       psSrcExtent, 1 );
+  if (!bUseGrid) {
+    for (i = 0; i < nSamples; i++) {
+      if (x[i] == HUGE_VAL || y[i] == HUGE_VAL) {
+        return msTransformMapToSource(
+            nDstXSize, nDstYSize, adfDstGeoTransform, psDstProj, nSrcXSize,
+            nSrcYSize, adfInvSrcGeoTransform, psSrcProj, psSrcExtent, 1);
       }
     }
   }
@@ -1156,22 +1107,20 @@ static int msTransformMapToSource( int n
   /* -------------------------------------------------------------------- */
   /*      transform to layer raster coordinates, and collect bounds.      */
   /* -------------------------------------------------------------------- */
-  for( i = 0; i < nSamples; i++ ) {
-    double    x_out, y_out;
+  for (i = 0; i < nSamples; i++) {
+    double x_out, y_out;
 
-    if( x[i] == HUGE_VAL || y[i] == HUGE_VAL ) {
+    if (x[i] == HUGE_VAL || y[i] == HUGE_VAL) {
       nFailures++;
       continue;
     }
 
-    x_out =      adfInvSrcGeoTransform[0]
-                 +   x[i]*adfInvSrcGeoTransform[1]
-                 +   y[i]*adfInvSrcGeoTransform[2];
-    y_out =      adfInvSrcGeoTransform[3]
-                 +   x[i]*adfInvSrcGeoTransform[4]
-                 +   y[i]*adfInvSrcGeoTransform[5];
+    x_out = adfInvSrcGeoTransform[0] + x[i] * adfInvSrcGeoTransform[1] +
+            y[i] * adfInvSrcGeoTransform[2];
+    y_out = adfInvSrcGeoTransform[3] + x[i] * adfInvSrcGeoTransform[4] +
+            y[i] * adfInvSrcGeoTransform[5];
 
-    if( !bOutInit ) {
+    if (!bOutInit) {
       psSrcExtent->minx = psSrcExtent->maxx = x_out;
       psSrcExtent->miny = psSrcExtent->maxy = y_out;
       bOutInit = 1;
@@ -1188,142 +1137,136 @@ static int msTransformMapToSource( int n
   /*      projection. In that case we must check if the points at         */
   /*      lon_wrap +/- 180deg are in the output raster.                   */
   /* -------------------------------------------------------------------- */
-  if( bOutInit && msProjIsGeographicCRS(psSrcProj) )
-  {
-      double dfLonWrap = 0;
-      int bHasLonWrap = msProjectHasLonWrap(psSrcProj, &dfLonWrap);
+  if (bOutInit && msProjIsGeographicCRS(psSrcProj)) {
+    double dfLonWrap = 0;
+    int bHasLonWrap = msProjectHasLonWrap(psSrcProj, &dfLonWrap);
 
-      if( bHasLonWrap )
-      {
-          double x2[2], y2[2];
+    if (bHasLonWrap) {
+      double x2[2], y2[2];
 #if PROJ_VERSION_MAJOR < 6
-          double z2[2];
+      double z2[2];
 #endif
-          int nCountY = 0;
-          double dfY = 0.0;
-          double dfXMinOut = 0.0;
-          double dfYMinOut = 0.0;
-          double dfXMaxOut = 0.0;
-          double dfYMaxOut = 0.0;
-          const double dfHalfRes = adfDstGeoTransform[1] / 2;
-
-          /* Find out average y coordinate in src projection */
-          for( i = 0; i < nSamples; i++ ) {
-              if( y[i] != HUGE_VAL ) {
-                  dfY += y[i];
-                  nCountY ++;
-              }
-          }
-          dfY /= nCountY;
+      int nCountY = 0;
+      double dfY = 0.0;
+      double dfXMinOut = 0.0;
+      double dfYMinOut = 0.0;
+      double dfXMaxOut = 0.0;
+      double dfYMaxOut = 0.0;
+      const double dfHalfRes = adfDstGeoTransform[1] / 2;
+
+      /* Find out average y coordinate in src projection */
+      for (i = 0; i < nSamples; i++) {
+        if (y[i] != HUGE_VAL) {
+          dfY += y[i];
+          nCountY++;
+        }
+      }
+      dfY /= nCountY;
 
-          /* Compute bounds of output raster */
-          for( i = 0; i < 4; i ++ )
-          {
-              double dfX = adfDstGeoTransform[0] +
-                ((i == 1 || i == 2) ? nDstXSize : 0) * adfDstGeoTransform[1] +
-                ((i == 1 || i == 3 ) ? nDstYSize : 0) * adfDstGeoTransform[2];
-              double dfY = adfDstGeoTransform[3] +
-                ((i == 1 || i == 2) ? nDstXSize : 0) * adfDstGeoTransform[4] +
-                ((i == 1 || i == 3 ) ? nDstYSize : 0) * adfDstGeoTransform[5];
-              if( i == 0 || dfX < dfXMinOut ) dfXMinOut = dfX;
-              if( i == 0 || dfY < dfYMinOut ) dfYMinOut = dfY;
-              if( i == 0 || dfX > dfXMaxOut ) dfXMaxOut = dfX;
-              if( i == 0 || dfY > dfYMaxOut ) dfYMaxOut = dfY;
-          }
+      /* Compute bounds of output raster */
+      for (i = 0; i < 4; i++) {
+        double dfX =
+            adfDstGeoTransform[0] +
+            ((i == 1 || i == 2) ? nDstXSize : 0) * adfDstGeoTransform[1] +
+            ((i == 1 || i == 3) ? nDstYSize : 0) * adfDstGeoTransform[2];
+        double dfY =
+            adfDstGeoTransform[3] +
+            ((i == 1 || i == 2) ? nDstXSize : 0) * adfDstGeoTransform[4] +
+            ((i == 1 || i == 3) ? nDstYSize : 0) * adfDstGeoTransform[5];
+        if (i == 0 || dfX < dfXMinOut)
+          dfXMinOut = dfX;
+        if (i == 0 || dfY < dfYMinOut)
+          dfYMinOut = dfY;
+        if (i == 0 || dfX > dfXMaxOut)
+          dfXMaxOut = dfX;
+        if (i == 0 || dfY > dfYMaxOut)
+          dfYMaxOut = dfY;
+      }
 
-          x2[0] = dfLonWrap-180+1e-7;
-          y2[0] = dfY;
+      x2[0] = dfLonWrap - 180 + 1e-7;
+      y2[0] = dfY;
 
-          x2[1] = dfLonWrap+180-1e-7;
-          y2[1] = dfY;
+      x2[1] = dfLonWrap + 180 - 1e-7;
+      y2[1] = dfY;
 
 #if PROJ_VERSION_MAJOR >= 6
-          {
-            reprojectionObj* reprojector = msProjectCreateReprojector(psSrcProj, psDstProj);
-            if( reprojector )
-            {
-              msProjectTransformPoints( reprojector, 2, x2, y2 );
-              msProjectDestroyReprojector(reprojector);
-            }
-          }
+      {
+        reprojectionObj *reprojector =
+            msProjectCreateReprojector(psSrcProj, psDstProj);
+        if (reprojector) {
+          msProjectTransformPoints(reprojector, 2, x2, y2);
+          msProjectDestroyReprojector(reprojector);
+        }
+      }
 #else
-          z2[0] = 0.0;
-          z2[1] = 0.0;
-          msAcquireLock( TLOCK_PROJ );
-          pj_transform( psSrcProj->proj, psDstProj->proj,
-                        2, 1, x2, y2, z2 );
-          msReleaseLock( TLOCK_PROJ );
+      z2[0] = 0.0;
+      z2[1] = 0.0;
+      msAcquireLock(TLOCK_PROJ);
+      pj_transform(psSrcProj->proj, psDstProj->proj, 2, 1, x2, y2, z2);
+      msReleaseLock(TLOCK_PROJ);
 #endif
 
-          if( x2[0] >= dfXMinOut - dfHalfRes && x2[0] <= dfXMaxOut + dfHalfRes &&
-              y2[0] >= dfYMinOut && y2[0] <= dfYMaxOut )
-          {
-                double x_out =      adfInvSrcGeoTransform[0]
-                            +   (dfLonWrap-180)*adfInvSrcGeoTransform[1]
-                            +   dfY*adfInvSrcGeoTransform[2];
-                double y_out =      adfInvSrcGeoTransform[3]
-                            +   (dfLonWrap-180)*adfInvSrcGeoTransform[4]
-                            +   dfY*adfInvSrcGeoTransform[5];
-
-                /* Does the raster cover, at least, a whole 360 deg range ? */
-                if( nSrcXSize >= (int)(adfInvSrcGeoTransform[1] * 360) )
-                {
-                    psSrcExtent->minx = 0;
-                    psSrcExtent->maxx = nSrcXSize;
-                }
-                else
-                {
-                    psSrcExtent->minx = MS_MIN(psSrcExtent->minx, x_out);
-                    psSrcExtent->maxx = MS_MAX(psSrcExtent->maxx, x_out);
-                }
-                psSrcExtent->miny = MS_MIN(psSrcExtent->miny, y_out);
-                psSrcExtent->maxy = MS_MAX(psSrcExtent->maxy, y_out);
-          }
+      if (x2[0] >= dfXMinOut - dfHalfRes && x2[0] <= dfXMaxOut + dfHalfRes &&
+          y2[0] >= dfYMinOut && y2[0] <= dfYMaxOut) {
+        double x_out = adfInvSrcGeoTransform[0] +
+                       (dfLonWrap - 180) * adfInvSrcGeoTransform[1] +
+                       dfY * adfInvSrcGeoTransform[2];
+        double y_out = adfInvSrcGeoTransform[3] +
+                       (dfLonWrap - 180) * adfInvSrcGeoTransform[4] +
+                       dfY * adfInvSrcGeoTransform[5];
+
+        /* Does the raster cover, at least, a whole 360 deg range ? */
+        if (nSrcXSize >= (int)(adfInvSrcGeoTransform[1] * 360)) {
+          psSrcExtent->minx = 0;
+          psSrcExtent->maxx = nSrcXSize;
+        } else {
+          psSrcExtent->minx = MS_MIN(psSrcExtent->minx, x_out);
+          psSrcExtent->maxx = MS_MAX(psSrcExtent->maxx, x_out);
+        }
+        psSrcExtent->miny = MS_MIN(psSrcExtent->miny, y_out);
+        psSrcExtent->maxy = MS_MAX(psSrcExtent->maxy, y_out);
+      }
 
-          if( x2[1] >= dfXMinOut - dfHalfRes && x2[1] <= dfXMaxOut + dfHalfRes &&
-              y2[1] >= dfYMinOut && y2[1] <= dfYMaxOut )
-          {
-                double x_out =      adfInvSrcGeoTransform[0]
-                            +   (dfLonWrap+180)*adfInvSrcGeoTransform[1]
-                            +   dfY*adfInvSrcGeoTransform[2];
-                double y_out =      adfInvSrcGeoTransform[3]
-                            +   (dfLonWrap+180)*adfInvSrcGeoTransform[4]
-                            +   dfY*adfInvSrcGeoTransform[5];
-
-                /* Does the raster cover, at least, a whole 360 deg range ? */
-                if( nSrcXSize >= (int)(adfInvSrcGeoTransform[1] * 360) )
-                {
-                    psSrcExtent->minx = 0;
-                    psSrcExtent->maxx = nSrcXSize;
-                }
-                else
-                {
-                    psSrcExtent->minx = MS_MIN(psSrcExtent->minx, x_out);
-                    psSrcExtent->maxx = MS_MAX(psSrcExtent->maxx, x_out);
-                }
-                psSrcExtent->miny = MS_MIN(psSrcExtent->miny, y_out);
-                psSrcExtent->maxy = MS_MAX(psSrcExtent->maxy, y_out);
-          }
+      if (x2[1] >= dfXMinOut - dfHalfRes && x2[1] <= dfXMaxOut + dfHalfRes &&
+          y2[1] >= dfYMinOut && y2[1] <= dfYMaxOut) {
+        double x_out = adfInvSrcGeoTransform[0] +
+                       (dfLonWrap + 180) * adfInvSrcGeoTransform[1] +
+                       dfY * adfInvSrcGeoTransform[2];
+        double y_out = adfInvSrcGeoTransform[3] +
+                       (dfLonWrap + 180) * adfInvSrcGeoTransform[4] +
+                       dfY * adfInvSrcGeoTransform[5];
+
+        /* Does the raster cover, at least, a whole 360 deg range ? */
+        if (nSrcXSize >= (int)(adfInvSrcGeoTransform[1] * 360)) {
+          psSrcExtent->minx = 0;
+          psSrcExtent->maxx = nSrcXSize;
+        } else {
+          psSrcExtent->minx = MS_MIN(psSrcExtent->minx, x_out);
+          psSrcExtent->maxx = MS_MAX(psSrcExtent->maxx, x_out);
+        }
+        psSrcExtent->miny = MS_MIN(psSrcExtent->miny, y_out);
+        psSrcExtent->maxy = MS_MAX(psSrcExtent->maxy, y_out);
       }
+    }
   }
 
-  if( !bOutInit )
+  if (!bOutInit)
     return MS_FALSE;
 
   /* -------------------------------------------------------------------- */
   /*      If we had some failures, we need to expand the region to        */
   /*      represent our very coarse sampling grid.                        */
   /* -------------------------------------------------------------------- */
-  if( nFailures > 0 ) {
-    int nGrowAmountX = (int)
-                       (psSrcExtent->maxx - psSrcExtent->minx)/EDGE_STEPS + 1;
-    int nGrowAmountY = (int)
-                       (psSrcExtent->maxy - psSrcExtent->miny)/EDGE_STEPS + 1;
-
-    psSrcExtent->minx = MS_MAX(psSrcExtent->minx - nGrowAmountX,0);
-    psSrcExtent->miny = MS_MAX(psSrcExtent->miny - nGrowAmountY,0);
-    psSrcExtent->maxx = MS_MIN(psSrcExtent->maxx + nGrowAmountX,nSrcXSize);
-    psSrcExtent->maxy = MS_MIN(psSrcExtent->maxy + nGrowAmountY,nSrcYSize);
+  if (nFailures > 0) {
+    int nGrowAmountX =
+        (int)(psSrcExtent->maxx - psSrcExtent->minx) / EDGE_STEPS + 1;
+    int nGrowAmountY =
+        (int)(psSrcExtent->maxy - psSrcExtent->miny) / EDGE_STEPS + 1;
+
+    psSrcExtent->minx = MS_MAX(psSrcExtent->minx - nGrowAmountX, 0);
+    psSrcExtent->miny = MS_MAX(psSrcExtent->miny - nGrowAmountY, 0);
+    psSrcExtent->maxx = MS_MIN(psSrcExtent->maxx + nGrowAmountX, nSrcXSize);
+    psSrcExtent->maxy = MS_MIN(psSrcExtent->maxy + nGrowAmountY, nSrcYSize);
   }
 
   return MS_TRUE;
@@ -1333,45 +1276,45 @@ static int msTransformMapToSource( int n
 /*                        msResampleGDALToMap()                         */
 /************************************************************************/
 
-int msResampleGDALToMap( mapObj *map, layerObj *layer, imageObj *image,
-                         rasterBufferObj *rb, GDALDatasetH hDS )
+int msResampleGDALToMap(mapObj *map, layerObj *layer, imageObj *image,
+                        rasterBufferObj *rb, GDALDatasetH hDS)
 
 {
-  int   nSrcXSize, nSrcYSize, nDstXSize, nDstYSize;
-  int   result, bSuccess;
-  double  adfSrcGeoTransform[6], adfDstGeoTransform[6];
-  double      adfInvSrcGeoTransform[6], dfNominalCellSize;
+  int nSrcXSize, nSrcYSize, nDstXSize, nDstYSize;
+  int result, bSuccess;
+  double adfSrcGeoTransform[6], adfDstGeoTransform[6];
+  double adfInvSrcGeoTransform[6], dfNominalCellSize;
   rectObj sSrcExtent = {0}, sOrigSrcExtent;
-  mapObj  sDummyMap;
-  imageObj   *srcImage;
-  void  *pTCBData;
-  void  *pACBData;
-  char       **papszAlteredProcessing = NULL;
-  int         nLoadImgXSize, nLoadImgYSize;
-  double      dfOversampleRatio;
+  mapObj sDummyMap;
+  imageObj *srcImage;
+  void *pTCBData;
+  void *pACBData;
+  char **papszAlteredProcessing = NULL;
+  int nLoadImgXSize, nLoadImgYSize;
+  double dfOversampleRatio;
   rasterBufferObj src_rb, *psrc_rb = NULL, *mask_rb = NULL;
-  int         bAddPixelMargin = MS_TRUE;
-  int         bWrapAtLeftRight = MS_FALSE;
+  int bAddPixelMargin = MS_TRUE;
+  int bWrapAtLeftRight = MS_FALSE;
 
+  const char *resampleMode = CSLFetchNameValue(layer->processing, "RESAMPLE");
 
-  const char *resampleMode = CSLFetchNameValue( layer->processing,
-                             "RESAMPLE" );
-
-  if( resampleMode == NULL )
+  if (resampleMode == NULL)
     resampleMode = "NEAREST";
-  
-  if(layer->mask) {
+
+  if (layer->mask) {
     int ret, maskLayerIdx;
     layerObj *maskLayer;
-    maskLayerIdx = msGetLayerIndex(map,layer->mask);
-    if(maskLayerIdx == -1) {
-      msSetError(MS_MISCERR, "Invalid mask layer specified", "msResampleGDALToMap()");
+    maskLayerIdx = msGetLayerIndex(map, layer->mask);
+    if (maskLayerIdx == -1) {
+      msSetError(MS_MISCERR, "Invalid mask layer specified",
+                 "msResampleGDALToMap()");
       return -1;
     }
     maskLayer = GET_LAYER(map, maskLayerIdx);
-    mask_rb = msSmallCalloc(1,sizeof(rasterBufferObj)); 
-    ret = MS_IMAGE_RENDERER(maskLayer->maskimage)->getRasterBufferHandle(maskLayer->maskimage,mask_rb);
-    if(ret != MS_SUCCESS) {
+    mask_rb = msSmallCalloc(1, sizeof(rasterBufferObj));
+    ret = MS_IMAGE_RENDERER(maskLayer->maskimage)
+              ->getRasterBufferHandle(maskLayer->maskimage, mask_rb);
+    if (ret != MS_SUCCESS) {
       free(mask_rb);
       return -1;
     }
@@ -1381,11 +1324,10 @@ int msResampleGDALToMap( mapObj *map, la
   /*      We will require source and destination to have a valid          */
   /*      projection object.                                              */
   /* -------------------------------------------------------------------- */
-  if( map->projection.proj == NULL
-      || layer->projection.proj == NULL ) {
-    if( layer->debug )
-      msDebug( "msResampleGDALToMap(): "
-               "Either map or layer projection is NULL, assuming compatible.\n" );
+  if (map->projection.proj == NULL || layer->projection.proj == NULL) {
+    if (layer->debug)
+      msDebug("msResampleGDALToMap(): "
+              "Either map or layer projection is NULL, assuming compatible.\n");
   }
 
   /* -------------------------------------------------------------------- */
@@ -1394,14 +1336,14 @@ int msResampleGDALToMap( mapObj *map, la
   nDstXSize = image->width;
   nDstYSize = image->height;
 
-  memcpy( adfDstGeoTransform, map->gt.geotransform, sizeof(double)*6 );
+  memcpy(adfDstGeoTransform, map->gt.geotransform, sizeof(double) * 6);
 
-  msGetGDALGeoTransform( hDS, map, layer, adfSrcGeoTransform );
+  msGetGDALGeoTransform(hDS, map, layer, adfSrcGeoTransform);
 
-  nSrcXSize = GDALGetRasterXSize( hDS );
-  nSrcYSize = GDALGetRasterYSize( hDS );
+  nSrcXSize = GDALGetRasterXSize(hDS);
+  nSrcYSize = GDALGetRasterYSize(hDS);
 
-  InvGeoTransform( adfSrcGeoTransform, adfInvSrcGeoTransform );
+  InvGeoTransform(adfSrcGeoTransform, adfInvSrcGeoTransform);
 
   /* -------------------------------------------------------------------- */
   /*      We need to find the extents in the source layer projection      */
@@ -1409,46 +1351,43 @@ int msResampleGDALToMap( mapObj *map, la
   /*      collecting the extents of a region around the edge of the       */
   /*      destination chunk.                                              */
   /* -------------------------------------------------------------------- */
-  if( CSLFetchBoolean( layer->processing, "LOAD_WHOLE_IMAGE", FALSE ) )
+  if (CSLFetchBoolean(layer->processing, "LOAD_WHOLE_IMAGE", FALSE))
     bSuccess = FALSE;
   else {
-    bSuccess =
-      msTransformMapToSource( nDstXSize, nDstYSize, adfDstGeoTransform,
-                              &(map->projection),
-                              nSrcXSize, nSrcYSize,adfInvSrcGeoTransform,
-                              &(layer->projection),
-                              &sSrcExtent, FALSE );
-      if (bSuccess) {
-    /* -------------------------------------------------------------------- */
-    /*      Repeat transformation for a rectangle interior to the output    */
-    /*      requested region.  If the latter results in a more extreme y    */
-    /*      extent, then extend extents in source layer projection to       */
-    /*      southern/northing bounds and entire x extent.                   */
-    /* -------------------------------------------------------------------- */
-      memcpy( &sOrigSrcExtent, &sSrcExtent, sizeof(sSrcExtent) );
+    bSuccess = msTransformMapToSource(nDstXSize, nDstYSize, adfDstGeoTransform,
+                                      &(map->projection), nSrcXSize, nSrcYSize,
+                                      adfInvSrcGeoTransform,
+                                      &(layer->projection), &sSrcExtent, FALSE);
+    if (bSuccess) {
+      /* -------------------------------------------------------------------- */
+      /*      Repeat transformation for a rectangle interior to the output    */
+      /*      requested region.  If the latter results in a more extreme y    */
+      /*      extent, then extend extents in source layer projection to       */
+      /*      southern/northing bounds and entire x extent.                   */
+      /* -------------------------------------------------------------------- */
+      memcpy(&sOrigSrcExtent, &sSrcExtent, sizeof(sSrcExtent));
       adfDstGeoTransform[0] = adfDstGeoTransform[0] + adfDstGeoTransform[1];
       adfDstGeoTransform[3] = adfDstGeoTransform[3] + adfDstGeoTransform[5];
-      bSuccess =
-          msTransformMapToSource( nDstXSize-2, nDstYSize-2, adfDstGeoTransform,
-                                  &(map->projection),
-                                  nSrcXSize, nSrcYSize,adfInvSrcGeoTransform,
-                                  &(layer->projection),
-                                  &sSrcExtent, FALSE );
+      bSuccess = msTransformMapToSource(
+          nDstXSize - 2, nDstYSize - 2, adfDstGeoTransform, &(map->projection),
+          nSrcXSize, nSrcYSize, adfInvSrcGeoTransform, &(layer->projection),
+          &sSrcExtent, FALSE);
       /* Reset this array to its original value! */
-      memcpy( adfDstGeoTransform, map->gt.geotransform, sizeof(double)*6 );
+      memcpy(adfDstGeoTransform, map->gt.geotransform, sizeof(double) * 6);
 
       if (bSuccess) {
-          if (sSrcExtent.maxy > sOrigSrcExtent.maxy || sSrcExtent.miny < sOrigSrcExtent.miny) {
-              msDebug( "msTransformMapToSource(): extending bounds.\n");
-              sOrigSrcExtent.minx = 0;
-              sOrigSrcExtent.maxx = nSrcXSize;
-              if (sSrcExtent.maxy > sOrigSrcExtent.maxy)
-                  sOrigSrcExtent.maxy = nSrcYSize;
-              if (sSrcExtent.miny < sOrigSrcExtent.miny)
-                  sOrigSrcExtent.miny = 0;
-          }
+        if (sSrcExtent.maxy > sOrigSrcExtent.maxy ||
+            sSrcExtent.miny < sOrigSrcExtent.miny) {
+          msDebug("msTransformMapToSource(): extending bounds.\n");
+          sOrigSrcExtent.minx = 0;
+          sOrigSrcExtent.maxx = nSrcXSize;
+          if (sSrcExtent.maxy > sOrigSrcExtent.maxy)
+            sOrigSrcExtent.maxy = nSrcYSize;
+          if (sSrcExtent.miny < sOrigSrcExtent.miny)
+            sOrigSrcExtent.miny = 0;
+        }
       }
-      memcpy( &sSrcExtent, &sOrigSrcExtent, sizeof(sOrigSrcExtent) );
+      memcpy(&sSrcExtent, &sOrigSrcExtent, sizeof(sOrigSrcExtent));
       bSuccess = TRUE;
     }
   }
@@ -1460,14 +1399,15 @@ int msResampleGDALToMap( mapObj *map, la
   /*      result in the raster being loaded at a higher resolution        */
   /*      than really needed but should give decent results.              */
   /* -------------------------------------------------------------------- */
-  if( !bSuccess ) {
-    if( layer->debug ) {
-      if( CSLFetchBoolean( layer->processing, "LOAD_WHOLE_IMAGE", FALSE ))
-        msDebug( "msResampleGDALToMap(): "
-                 "LOAD_WHOLE_IMAGE set, loading whole image.\n" );
+  if (!bSuccess) {
+    if (layer->debug) {
+      if (CSLFetchBoolean(layer->processing, "LOAD_WHOLE_IMAGE", FALSE))
+        msDebug("msResampleGDALToMap(): "
+                "LOAD_WHOLE_IMAGE set, loading whole image.\n");
       else
-        msDebug( "msTransformMapToSource(): "
-                 "pj_transform() failed.  Out of bounds?  Loading whole image.\n" );
+        msDebug(
+            "msTransformMapToSource(): "
+            "pj_transform() failed.  Out of bounds?  Loading whole image.\n");
     }
 
     sSrcExtent.minx = 0;
@@ -1485,72 +1425,70 @@ int msResampleGDALToMap( mapObj *map, la
   /*      and that the underlying raster is tiled and share the same      */
   /*      tiling scheme as the queried tile mode.                         */
   /* -------------------------------------------------------------------- */
-#define IS_ALMOST_INTEGER(x, eps)        (fabs((x)-(int)((x)+0.5)) < (eps))
+#define IS_ALMOST_INTEGER(x, eps) (fabs((x) - (int)((x) + 0.5)) < (eps))
 
-  if( adfSrcGeoTransform[1] > 0.0 && adfSrcGeoTransform[2] == 0.0 &&
+  if (adfSrcGeoTransform[1] > 0.0 && adfSrcGeoTransform[2] == 0.0 &&
       adfSrcGeoTransform[4] == 0.0 && adfSrcGeoTransform[5] < 0.0 &&
       IS_ALMOST_INTEGER(sSrcExtent.minx, 0.1) &&
       IS_ALMOST_INTEGER(sSrcExtent.miny, 0.1) &&
       IS_ALMOST_INTEGER(sSrcExtent.maxx, 0.1) &&
       IS_ALMOST_INTEGER(sSrcExtent.maxy, 0.1) &&
-      !msProjectionsDiffer( &(map->projection), &(layer->projection)) ) 
-  {
-      double dfXFactor, dfYFactor;
+      !msProjectionsDiffer(&(map->projection), &(layer->projection))) {
+    double dfXFactor, dfYFactor;
 
-      sSrcExtent.minx = (int)(sSrcExtent.minx + 0.5);
-      sSrcExtent.miny = (int)(sSrcExtent.miny + 0.5);
-      sSrcExtent.maxx = (int)(sSrcExtent.maxx + 0.5);
-      sSrcExtent.maxy = (int)(sSrcExtent.maxy + 0.5);
-      
-      if( (int)(sSrcExtent.maxx - sSrcExtent.minx + 0.5) == nDstXSize &&
-          (int)(sSrcExtent.maxy - sSrcExtent.miny + 0.5) == nDstYSize )
-      {
-            if( layer->debug )
-                msDebug( "msResampleGDALToMap(): Request matching raster resolution and pixel boundaries. "
-                         "No need to do resampling/reprojection.\n" );
-            msFree(mask_rb);
-            return msDrawRasterLayerGDAL( map, layer, image, rb, hDS );
-      }
+    sSrcExtent.minx = (int)(sSrcExtent.minx + 0.5);
+    sSrcExtent.miny = (int)(sSrcExtent.miny + 0.5);
+    sSrcExtent.maxx = (int)(sSrcExtent.maxx + 0.5);
+    sSrcExtent.maxy = (int)(sSrcExtent.maxy + 0.5);
+
+    if ((int)(sSrcExtent.maxx - sSrcExtent.minx + 0.5) == nDstXSize &&
+        (int)(sSrcExtent.maxy - sSrcExtent.miny + 0.5) == nDstYSize) {
+      if (layer->debug)
+        msDebug("msResampleGDALToMap(): Request matching raster resolution and "
+                "pixel boundaries. "
+                "No need to do resampling/reprojection.\n");
+      msFree(mask_rb);
+      return msDrawRasterLayerGDAL(map, layer, image, rb, hDS);
+    }
 
-      dfXFactor = (sSrcExtent.maxx - sSrcExtent.minx) / nDstXSize;
-      dfYFactor = (sSrcExtent.maxy - sSrcExtent.miny) / nDstYSize;
-      if( IS_ALMOST_INTEGER(dfXFactor, 1e-5) &&
-          IS_ALMOST_INTEGER(dfYFactor, 1e-5) &&
-          IS_ALMOST_INTEGER(sSrcExtent.minx/dfXFactor, 0.1) &&
-          IS_ALMOST_INTEGER(sSrcExtent.miny/dfXFactor, 0.1) &&
-          IS_ALMOST_INTEGER(sSrcExtent.maxx/dfYFactor, 0.1) &&
-          IS_ALMOST_INTEGER(sSrcExtent.maxy/dfYFactor, 0.1) )
-      {
-          bAddPixelMargin = MS_FALSE;
-          if( layer->debug )
-            msDebug( "msResampleGDALToMap(): Request matching raster resolution "
-                     "and pixel boundaries matching an integral subsampling factor\n" );
-      }
+    dfXFactor = (sSrcExtent.maxx - sSrcExtent.minx) / nDstXSize;
+    dfYFactor = (sSrcExtent.maxy - sSrcExtent.miny) / nDstYSize;
+    if (IS_ALMOST_INTEGER(dfXFactor, 1e-5) &&
+        IS_ALMOST_INTEGER(dfYFactor, 1e-5) &&
+        IS_ALMOST_INTEGER(sSrcExtent.minx / dfXFactor, 0.1) &&
+        IS_ALMOST_INTEGER(sSrcExtent.miny / dfXFactor, 0.1) &&
+        IS_ALMOST_INTEGER(sSrcExtent.maxx / dfYFactor, 0.1) &&
+        IS_ALMOST_INTEGER(sSrcExtent.maxy / dfYFactor, 0.1)) {
+      bAddPixelMargin = MS_FALSE;
+      if (layer->debug)
+        msDebug(
+            "msResampleGDALToMap(): Request matching raster resolution "
+            "and pixel boundaries matching an integral subsampling factor\n");
+    }
   }
 
   /* -------------------------------------------------------------------- */
   /*      Project desired extents out by 2 pixels, and then strip to      */
   /*      available data.                                                 */
   /* -------------------------------------------------------------------- */
-  memcpy( &sOrigSrcExtent, &sSrcExtent, sizeof(sSrcExtent) );
-
-  if( bAddPixelMargin )
-  {
-    sSrcExtent.minx = floor(sSrcExtent.minx-1.0);
-    sSrcExtent.maxx = ceil (sSrcExtent.maxx+1.0);
-    sSrcExtent.miny = floor(sSrcExtent.miny-1.0);
-    sSrcExtent.maxy = ceil (sSrcExtent.maxy+1.0);
-  }
+  memcpy(&sOrigSrcExtent, &sSrcExtent, sizeof(sSrcExtent));
 
-  sSrcExtent.minx = MS_MAX(0,sSrcExtent.minx);
-  sSrcExtent.maxx = MS_MIN(sSrcExtent.maxx, nSrcXSize );
-  sSrcExtent.miny = MS_MAX(sSrcExtent.miny, 0 );
-  sSrcExtent.maxy = MS_MIN(sSrcExtent.maxy, nSrcYSize );
-
-  if( sSrcExtent.maxx <= sSrcExtent.minx
-      || sSrcExtent.maxy <= sSrcExtent.miny ) {
-    if( layer->debug )
-      msDebug( "msResampleGDALToMap(): no overlap ... no result.\n" );
+  if (bAddPixelMargin) {
+    sSrcExtent.minx = floor(sSrcExtent.minx - 1.0);
+    sSrcExtent.maxx = ceil(sSrcExtent.maxx + 1.0);
+    sSrcExtent.miny = floor(sSrcExtent.miny - 1.0);
+    sSrcExtent.maxy = ceil(sSrcExtent.maxy + 1.0);
+  }
+
+  sSrcExtent.minx = MS_MAX(0, sSrcExtent.minx);
+  sSrcExtent.maxx = MS_MIN(sSrcExtent.maxx, nSrcXSize);
+  sSrcExtent.miny = MS_MAX(sSrcExtent.miny, 0);
+  sSrcExtent.maxy = MS_MIN(sSrcExtent.maxy, nSrcYSize);
+
+  if (sSrcExtent.maxx <= sSrcExtent.minx ||
+      sSrcExtent.maxy <= sSrcExtent.miny) {
+    if (layer->debug)
+      msDebug("msResampleGDALToMap(): no overlap ... no result.\n");
     msFree(mask_rb);
     return 0;
   }
@@ -1561,9 +1499,9 @@ int msResampleGDALToMap( mapObj *map, la
   /* -------------------------------------------------------------------- */
   dfOversampleRatio = 2.0;
 
-  if( CSLFetchNameValue( layer->processing, "OVERSAMPLE_RATIO" ) != NULL ) {
+  if (CSLFetchNameValue(layer->processing, "OVERSAMPLE_RATIO") != NULL) {
     dfOversampleRatio =
-      atof(CSLFetchNameValue( layer->processing, "OVERSAMPLE_RATIO" ));
+        atof(CSLFetchNameValue(layer->processing, "OVERSAMPLE_RATIO"));
   }
 
   /* -------------------------------------------------------------------- */
@@ -1572,9 +1510,8 @@ int msResampleGDALToMap( mapObj *map, la
   /*      at near to full resolution.  Otherwise we will read the data    */
   /*      at twice the resolution of the eventual map.                    */
   /* -------------------------------------------------------------------- */
-  dfNominalCellSize =
-    sqrt(adfSrcGeoTransform[1] * adfSrcGeoTransform[1]
-         + adfSrcGeoTransform[2] * adfSrcGeoTransform[2]);
+  dfNominalCellSize = sqrt(adfSrcGeoTransform[1] * adfSrcGeoTransform[1] +
+                           adfSrcGeoTransform[2] * adfSrcGeoTransform[2]);
 
   /* Check first that the requested extent is not well beyond than the source */
   /* raster. This might be the case for example if asking to visualize */
@@ -1582,21 +1519,24 @@ int msResampleGDALToMap( mapObj *map, la
   /* But restrict that to rasters of modest size, otherwise we may end up */
   /* requesting very large dimensions in other legit reprojection cases */
   /* See https://github.com/mapserver/mapserver/issues/5402 */
-  if( !(sOrigSrcExtent.minx <= -4 * nSrcXSize  && sOrigSrcExtent.miny <= -4 * nSrcYSize &&
-        sOrigSrcExtent.maxx >= 5 * nSrcXSize && sOrigSrcExtent.maxy >= 5 * nSrcYSize &&
-        nSrcXSize < 4000 && nSrcYSize < 4000)
-      && (sOrigSrcExtent.maxx - sOrigSrcExtent.minx) > dfOversampleRatio * nDstXSize
-      && !CSLFetchBoolean( layer->processing, "LOAD_FULL_RES_IMAGE", FALSE ))
+  if (!(sOrigSrcExtent.minx <= -4 * nSrcXSize &&
+        sOrigSrcExtent.miny <= -4 * nSrcYSize &&
+        sOrigSrcExtent.maxx >= 5 * nSrcXSize &&
+        sOrigSrcExtent.maxy >= 5 * nSrcYSize && nSrcXSize < 4000 &&
+        nSrcYSize < 4000) &&
+      (sOrigSrcExtent.maxx - sOrigSrcExtent.minx) >
+          dfOversampleRatio * nDstXSize &&
+      !CSLFetchBoolean(layer->processing, "LOAD_FULL_RES_IMAGE", FALSE))
     sDummyMap.cellsize =
-      (dfNominalCellSize * (sOrigSrcExtent.maxx - sOrigSrcExtent.minx))
-      / (dfOversampleRatio * nDstXSize);
+        (dfNominalCellSize * (sOrigSrcExtent.maxx - sOrigSrcExtent.minx)) /
+        (dfOversampleRatio * nDstXSize);
   else
     sDummyMap.cellsize = dfNominalCellSize;
 
-  nLoadImgXSize = MS_MAX(1, (int) (sSrcExtent.maxx - sSrcExtent.minx)
-                      * (dfNominalCellSize / sDummyMap.cellsize));
-  nLoadImgYSize = MS_MAX(1, (int) (sSrcExtent.maxy - sSrcExtent.miny)
-                      * (dfNominalCellSize / sDummyMap.cellsize));
+  nLoadImgXSize = MS_MAX(1, (int)(sSrcExtent.maxx - sSrcExtent.minx) *
+                                (dfNominalCellSize / sDummyMap.cellsize));
+  nLoadImgYSize = MS_MAX(1, (int)(sSrcExtent.maxy - sSrcExtent.miny) *
+                                (dfNominalCellSize / sDummyMap.cellsize));
 
   /*
   ** Because the previous calculation involved some round off, we need
@@ -1604,50 +1544,44 @@ int msResampleGDALToMap( mapObj *map, la
   ** RAW_WINDOW (at least in X).  Re: bug 1715.
   */
   sDummyMap.cellsize =
-    ((sSrcExtent.maxx - sSrcExtent.minx) * dfNominalCellSize)
-    / nLoadImgXSize;
+      ((sSrcExtent.maxx - sSrcExtent.minx) * dfNominalCellSize) / nLoadImgXSize;
 
-  if( layer->debug )
-    msDebug( "msResampleGDALToMap in effect: cellsize = %f\n",
-             sDummyMap.cellsize );
-
-  adfSrcGeoTransform[0] +=
-    + adfSrcGeoTransform[1] * sSrcExtent.minx
-    + adfSrcGeoTransform[2] * sSrcExtent.miny;
+  if (layer->debug)
+    msDebug("msResampleGDALToMap in effect: cellsize = %f\n",
+            sDummyMap.cellsize);
+
+  adfSrcGeoTransform[0] += +adfSrcGeoTransform[1] * sSrcExtent.minx +
+                           adfSrcGeoTransform[2] * sSrcExtent.miny;
   adfSrcGeoTransform[1] *= (sDummyMap.cellsize / dfNominalCellSize);
   adfSrcGeoTransform[2] *= (sDummyMap.cellsize / dfNominalCellSize);
 
-  adfSrcGeoTransform[3] +=
-    + adfSrcGeoTransform[4] * sSrcExtent.minx
-    + adfSrcGeoTransform[5] * sSrcExtent.miny;
+  adfSrcGeoTransform[3] += +adfSrcGeoTransform[4] * sSrcExtent.minx +
+                           adfSrcGeoTransform[5] * sSrcExtent.miny;
   adfSrcGeoTransform[4] *= (sDummyMap.cellsize / dfNominalCellSize);
   adfSrcGeoTransform[5] *= (sDummyMap.cellsize / dfNominalCellSize);
 
   /* In the non-rotated case, make sure that the geotransform exactly */
   /* matches the sSrcExtent, even if that generates non-square pixels (#1715) */
   /* The rotated case should ideally be dealt with, but not for now... */
-  if( adfSrcGeoTransform[2] == 0 && adfSrcGeoTransform[4] == 0 &&
+  if (adfSrcGeoTransform[2] == 0 && adfSrcGeoTransform[4] == 0 &&
       adfSrcGeoTransform[5] < 0 &&
       /* But do that only if the pixels were square before, otherwise */
       /* this is going to mess with source rasters whose pixels aren't at */
       /* all square (#5445) */
       fabs(fabs(adfSrcGeoTransform[1]) - fabs(adfSrcGeoTransform[5])) <
-                                        0.01 * fabs(adfSrcGeoTransform[1]) )
-  {
-      adfSrcGeoTransform[1] = (sSrcExtent.maxx - sSrcExtent.minx) *
-                                            dfNominalCellSize / nLoadImgXSize;
-      adfSrcGeoTransform[5] = -(sSrcExtent.maxy - sSrcExtent.miny) *
-                                            dfNominalCellSize / nLoadImgYSize;
+          0.01 * fabs(adfSrcGeoTransform[1])) {
+    adfSrcGeoTransform[1] =
+        (sSrcExtent.maxx - sSrcExtent.minx) * dfNominalCellSize / nLoadImgXSize;
+    adfSrcGeoTransform[5] = -(sSrcExtent.maxy - sSrcExtent.miny) *
+                            dfNominalCellSize / nLoadImgYSize;
   }
 
-  papszAlteredProcessing = CSLDuplicate( layer->processing );
-  papszAlteredProcessing =
-    CSLSetNameValue( papszAlteredProcessing, "RAW_WINDOW",
-                     CPLSPrintf( "%d %d %d %d",
-                                 (int) sSrcExtent.minx,
-                                 (int) sSrcExtent.miny,
-                                 (int) (sSrcExtent.maxx-sSrcExtent.minx),
-                                 (int) (sSrcExtent.maxy-sSrcExtent.miny)));
+  papszAlteredProcessing = CSLDuplicate(layer->processing);
+  papszAlteredProcessing = CSLSetNameValue(
+      papszAlteredProcessing, "RAW_WINDOW",
+      CPLSPrintf("%d %d %d %d", (int)sSrcExtent.minx, (int)sSrcExtent.miny,
+                 (int)(sSrcExtent.maxx - sSrcExtent.minx),
+                 (int)(sSrcExtent.maxy - sSrcExtent.miny)));
 
   /* -------------------------------------------------------------------- */
   /*      We clone this without referencing it knowing that the           */
@@ -1660,7 +1594,7 @@ int msResampleGDALToMap( mapObj *map, la
   /*      We make a copy so we can easily modify the outputformat used    */
   /*      for the temporary image to include transparentency support.     */
   /* -------------------------------------------------------------------- */
-  sDummyMap.outputformat = msCloneOutputFormat( image->format );
+  sDummyMap.outputformat = msCloneOutputFormat(image->format);
   sDummyMap.width = nLoadImgXSize;
   sDummyMap.height = nLoadImgYSize;
   sDummyMap.mappath = map->mappath;
@@ -1673,40 +1607,45 @@ int msResampleGDALToMap( mapObj *map, la
   /*      as our transparent color, but ensure it is initalized in the    */
   /*      map so that normal transparent avoidance will apply.            */
   /* -------------------------------------------------------------------- */
-  if( MS_RENDERER_PLUGIN(sDummyMap.outputformat) ) {
+  if (MS_RENDERER_PLUGIN(sDummyMap.outputformat)) {
     assert(rb);
     msInitializeRendererVTable(sDummyMap.outputformat);
-    assert( sDummyMap.outputformat->imagemode == MS_IMAGEMODE_RGB
-            || sDummyMap.outputformat->imagemode == MS_IMAGEMODE_RGBA );
+    assert(sDummyMap.outputformat->imagemode == MS_IMAGEMODE_RGB ||
+           sDummyMap.outputformat->imagemode == MS_IMAGEMODE_RGBA);
 
     sDummyMap.outputformat->transparent = MS_TRUE;
     sDummyMap.outputformat->imagemode = MS_IMAGEMODE_RGBA;
-    MS_INIT_COLOR(sDummyMap.imagecolor,-1,-1,-1,255);
+    MS_INIT_COLOR(sDummyMap.imagecolor, -1, -1, -1, 255);
   }
 
   /* -------------------------------------------------------------------- */
   /*      Setup a dummy map object we can use to read from the source     */
   /*      raster, with the newly established extents, and resolution.     */
   /* -------------------------------------------------------------------- */
-  srcImage = msImageCreate( nLoadImgXSize, nLoadImgYSize,
-                            sDummyMap.outputformat, NULL, NULL,
-                            map->resolution, map->defresolution, &(sDummyMap.imagecolor));
+  srcImage = msImageCreate(nLoadImgXSize, nLoadImgYSize, sDummyMap.outputformat,
+                           NULL, NULL, map->resolution, map->defresolution,
+                           &(sDummyMap.imagecolor));
 
   if (srcImage == NULL) {
     msFree(mask_rb);
     return -1; /* msSetError() should have been called already */
   }
 
-  if( MS_RENDERER_PLUGIN( srcImage->format ) ) {
+  if (MS_RENDERER_PLUGIN(srcImage->format)) {
     psrc_rb = &src_rb;
-    memset( psrc_rb, 0, sizeof(rasterBufferObj) );
-    if( srcImage->format->vtable->supports_pixel_buffer ) {
-      if(MS_UNLIKELY(MS_FAILURE == srcImage->format->vtable->getRasterBufferHandle( srcImage, psrc_rb ))) {
+    memset(psrc_rb, 0, sizeof(rasterBufferObj));
+    if (srcImage->format->vtable->supports_pixel_buffer) {
+      if (MS_UNLIKELY(MS_FAILURE ==
+                      srcImage->format->vtable->getRasterBufferHandle(
+                          srcImage, psrc_rb))) {
         msFree(mask_rb);
         return -1;
       }
     } else {
-      if(MS_UNLIKELY(MS_FAILURE == srcImage->format->vtable->initializeRasterBuffer(psrc_rb,nLoadImgXSize, nLoadImgYSize,MS_IMAGEMODE_RGBA))) {
+      if (MS_UNLIKELY(
+              MS_FAILURE ==
+              srcImage->format->vtable->initializeRasterBuffer(
+                  psrc_rb, nLoadImgXSize, nLoadImgYSize, MS_IMAGEMODE_RGBA))) {
         msFree(mask_rb);
         return -1;
       }
@@ -1719,22 +1658,22 @@ int msResampleGDALToMap( mapObj *map, la
   /* -------------------------------------------------------------------- */
   {
     char **papszSavedProcessing = layer->processing;
-    char* origMask = layer->mask;
+    char *origMask = layer->mask;
     layer->mask = NULL;
     layer->processing = papszAlteredProcessing;
 
-    result = msDrawRasterLayerGDAL( &sDummyMap, layer, srcImage,
-                                    psrc_rb, hDS );
+    result = msDrawRasterLayerGDAL(&sDummyMap, layer, srcImage, psrc_rb, hDS);
 
     layer->processing = papszSavedProcessing;
     layer->mask = origMask;
-    CSLDestroy( papszAlteredProcessing );
+    CSLDestroy(papszAlteredProcessing);
 
-    if( result ) {
-      if( MS_RENDERER_PLUGIN( srcImage->format ) && !srcImage->format->vtable->supports_pixel_buffer)
+    if (result) {
+      if (MS_RENDERER_PLUGIN(srcImage->format) &&
+          !srcImage->format->vtable->supports_pixel_buffer)
         msFreeRasterBuffer(psrc_rb);
 
-      msFreeImage( srcImage );
+      msFreeImage(srcImage);
       msFree(mask_rb);
 
       return result;
@@ -1745,17 +1684,16 @@ int msResampleGDALToMap( mapObj *map, la
   /*      Setup transformations between our source image, and the         */
   /*      target map image.                                               */
   /* -------------------------------------------------------------------- */
-  pTCBData = msInitProjTransformer( &(layer->projection),
-                                    adfSrcGeoTransform,
-                                    &(map->projection),
-                                    adfDstGeoTransform );
-
-  if( pTCBData == NULL ) {
-    if( layer->debug )
-      msDebug( "msInitProjTransformer() returned NULL.\n" );
-    if( MS_RENDERER_PLUGIN( srcImage->format ) && !srcImage->format->vtable->supports_pixel_buffer)
+  pTCBData = msInitProjTransformer(&(layer->projection), adfSrcGeoTransform,
+                                   &(map->projection), adfDstGeoTransform);
+
+  if (pTCBData == NULL) {
+    if (layer->debug)
+      msDebug("msInitProjTransformer() returned NULL.\n");
+    if (MS_RENDERER_PLUGIN(srcImage->format) &&
+        !srcImage->format->vtable->supports_pixel_buffer)
       msFreeRasterBuffer(psrc_rb);
-    msFreeImage( srcImage );
+    msFreeImage(srcImage);
     msFree(mask_rb);
     return MS_PROJERR;
   }
@@ -1764,44 +1702,41 @@ int msResampleGDALToMap( mapObj *map, la
   /*      It is cheaper to use linear approximations as long as our       */
   /*      error is modest (less than 0.333 pixels).                       */
   /* -------------------------------------------------------------------- */
-  pACBData = msInitApproxTransformer( msProjTransformer, pTCBData, 0.333 );
+  pACBData = msInitApproxTransformer(msProjTransformer, pTCBData, 0.333);
 
-  if( msProjIsGeographicCRS(&(layer->projection)) )
-  {
-      /* Does the raster cover a whole 360 deg range ? */
-      if( nSrcXSize == (int)(adfInvSrcGeoTransform[1] * 360 + 0.5) )
-          bWrapAtLeftRight = MS_TRUE;
+  if (msProjIsGeographicCRS(&(layer->projection))) {
+    /* Does the raster cover a whole 360 deg range ? */
+    if (nSrcXSize == (int)(adfInvSrcGeoTransform[1] * 360 + 0.5))
+      bWrapAtLeftRight = MS_TRUE;
   }
 
   /* -------------------------------------------------------------------- */
   /*      Perform the resampling.                                         */
   /* -------------------------------------------------------------------- */
-  if( EQUAL(resampleMode,"AVERAGE") )
-    result =
-      msAverageRasterResampler( srcImage, psrc_rb, image, rb,
-                                msApproxTransformer, pACBData,
-                                layer->debug, mask_rb );
-  else if( EQUAL(resampleMode,"BILINEAR") )
-    result =
-      msBilinearRasterResampler( srcImage, psrc_rb, image, rb,
-                                 msApproxTransformer, pACBData,
-                                 layer->debug, mask_rb, bWrapAtLeftRight );
+  if (EQUAL(resampleMode, "AVERAGE"))
+    result = msAverageRasterResampler(srcImage, psrc_rb, image, rb,
+                                      msApproxTransformer, pACBData,
+                                      layer->debug, mask_rb);
+  else if (EQUAL(resampleMode, "BILINEAR"))
+    result = msBilinearRasterResampler(srcImage, psrc_rb, image, rb,
+                                       msApproxTransformer, pACBData,
+                                       layer->debug, mask_rb, bWrapAtLeftRight);
   else
-    result =
-      msNearestRasterResampler( srcImage, psrc_rb, image, rb,
-                                msApproxTransformer, pACBData,
-                                layer->debug, mask_rb, bWrapAtLeftRight );
+    result = msNearestRasterResampler(srcImage, psrc_rb, image, rb,
+                                      msApproxTransformer, pACBData,
+                                      layer->debug, mask_rb, bWrapAtLeftRight);
 
   /* -------------------------------------------------------------------- */
   /*      cleanup                                                         */
   /* -------------------------------------------------------------------- */
   msFree(mask_rb);
-  if( MS_RENDERER_PLUGIN( srcImage->format ) && !srcImage->format->vtable->supports_pixel_buffer)
+  if (MS_RENDERER_PLUGIN(srcImage->format) &&
+      !srcImage->format->vtable->supports_pixel_buffer)
     msFreeRasterBuffer(psrc_rb);
-  msFreeImage( srcImage );
+  msFreeImage(srcImage);
 
-  msFreeProjTransformer( pTCBData );
-  msFreeApproxTransformer( pACBData );
+  msFreeProjTransformer(pTCBData);
+  msFreeApproxTransformer(pACBData);
 
   return result;
 }
diff -pruN 8.0.1-5/mapresample.h 8.0.2-1/mapresample.h
--- 8.0.1-5/mapresample.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapresample.h	2024-06-11 20:41:34.000000000 +0000
@@ -36,19 +36,16 @@
 #include <gdal.h>
 #include <cpl_string.h>
 
-typedef int (*SimpleTransformer)( void *pCBData, int nPoints,
-                                  double *x, double *y, int *panSuccess );
+typedef int (*SimpleTransformer)(void *pCBData, int nPoints, double *x,
+                                 double *y, int *panSuccess);
 
-void *msInitProjTransformer( projectionObj *psSrc,
-                             double *padfSrcGeoTransform,
-                             projectionObj *psDst,
-                             double *padfDstGeoTransform );
-void msFreeProjTransformer( void * );
-int msProjTransformer( void *pCBData, int nPoints,
-                       double *x, double *y, int *panSuccess );
+void *msInitProjTransformer(projectionObj *psSrc, double *padfSrcGeoTransform,
+                            projectionObj *psDst, double *padfDstGeoTransform);
+void msFreeProjTransformer(void *);
+int msProjTransformer(void *pCBData, int nPoints, double *x, double *y,
+                      int *panSuccess);
 
-int msResampleGDALToMap( mapObj *map, layerObj *layer,
-                         imageObj *image, rasterBufferObj *rb,
-                         GDALDatasetH hDS );
+int msResampleGDALToMap(mapObj *map, layerObj *layer, imageObj *image,
+                        rasterBufferObj *rb, GDALDatasetH hDS);
 
 #endif /* ndef RESAMPLE_H */
diff -pruN 8.0.1-5/mapscale.c 8.0.2-1/mapscale.c
--- 8.0.1-5/mapscale.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapscale.c	2024-06-11 20:41:34.000000000 +0000
@@ -29,127 +29,134 @@
 
 #include "mapserver.h"
 
-
-
 #define VMARGIN 3 /* buffer around the scalebar */
 #define HMARGIN 3
 #define VSPACING .8 /* spacing (% of font height) between scalebar and text */
-#define VSLOP 5 /* makes things fit a bit better vertically */
+#define VSLOP 5     /* makes things fit a bit better vertically */
 
 /*
 ** Match this with with unit enumerations is mapserver.h
 */
-static char *unitText[9]= {"in", "ft", "mi", "m", "km", "dd", "??", "??", "NM"}; /* MS_PIXEL and MS_PERCENTAGE not used */
-double inchesPerUnit[9]= {1, 12, 63360.0, 39.3701, 39370.1, 4374754, 1, 1, 72913.3858 };
-
-static double roundInterval(double d)
-{
-  if(d<.001)
-    return(MS_NINT(d*10000)/10000.0);
-  if(d<.01)
-    return(MS_NINT(d*1000)/1000.0);
-  if(d<.1)
-    return(MS_NINT(d*100)/100.0);
-  if(d<1)
-    return(MS_NINT(d*10)/10.0);
-  if(d<100)
-    return(MS_NINT(d));
-  if(d<1000)
-    return(MS_NINT(d/10) * 10);
-  if(d<10000)
-    return(MS_NINT(d/100) * 100);
-  if(d<100000)
-    return(MS_NINT(d/1000) * 1000);
-  if(d<1000000)
-    return(MS_NINT(d/10000) * 10000);
-  if(d<10000000)
-    return(MS_NINT(d/100000) * 100000);
-  if(d<100000000)
-    return(MS_NINT(d/1000000) * 1000000);
+static char *unitText[9] = {
+    "in", "ft", "mi", "m", "km",
+    "dd", "??", "??", "NM"}; /* MS_PIXEL and MS_PERCENTAGE not used */
+double inchesPerUnit[9] = {1,       12, 63360.0, 39.3701,   39370.1,
+                           4374754, 1,  1,       72913.3858};
+
+static double roundInterval(double d) {
+  if (d < .001)
+    return (MS_NINT(d * 10000) / 10000.0);
+  if (d < .01)
+    return (MS_NINT(d * 1000) / 1000.0);
+  if (d < .1)
+    return (MS_NINT(d * 100) / 100.0);
+  if (d < 1)
+    return (MS_NINT(d * 10) / 10.0);
+  if (d < 100)
+    return (MS_NINT(d));
+  if (d < 1000)
+    return (MS_NINT(d / 10) * 10);
+  if (d < 10000)
+    return (MS_NINT(d / 100) * 100);
+  if (d < 100000)
+    return (MS_NINT(d / 1000) * 1000);
+  if (d < 1000000)
+    return (MS_NINT(d / 10000) * 10000);
+  if (d < 10000000)
+    return (MS_NINT(d / 100000) * 100000);
+  if (d < 100000000)
+    return (MS_NINT(d / 1000000) * 1000000);
 
-  return(-1);
+  return (-1);
 }
 
 /*
-** Calculate the approximate scale based on a few parameters. Note that this assumes the scale is
-** the same in the x direction as in the y direction, so run msAdjustExtent(...) first.
+** Calculate the approximate scale based on a few parameters. Note that this
+*assumes the scale is
+** the same in the x direction as in the y direction, so run msAdjustExtent(...)
+*first.
 */
-int msCalculateScale(rectObj extent, int units, int width, int height, double resolution, double *scale)
-{
+int msCalculateScale(rectObj extent, int units, int width, int height,
+                     double resolution, double *scale) {
   double md, gd, center_y;
 
   /* if((extent.maxx == extent.minx) || (extent.maxy == extent.miny))   */
-  if(!MS_VALID_EXTENT(extent)) {
-    msSetError(MS_MISCERR, "Invalid image extent, minx=%lf, miny=%lf, maxx=%lf, maxy=%lf.", "msCalculateScale()", extent.minx, extent.miny, extent.maxx, extent.maxy);
-    return(MS_FAILURE);
+  if (!MS_VALID_EXTENT(extent)) {
+    msSetError(MS_MISCERR,
+               "Invalid image extent, minx=%lf, miny=%lf, maxx=%lf, maxy=%lf.",
+               "msCalculateScale()", extent.minx, extent.miny, extent.maxx,
+               extent.maxy);
+    return (MS_FAILURE);
   }
 
-  if((width <= 0) || (height <= 0)) {
-    msSetError(MS_MISCERR, "Invalid image width or height.", "msCalculateScale()");
-    return(MS_FAILURE);
+  if ((width <= 0) || (height <= 0)) {
+    msSetError(MS_MISCERR, "Invalid image width or height.",
+               "msCalculateScale()");
+    return (MS_FAILURE);
   }
 
   switch (units) {
-    case(MS_DD):
-    case(MS_METERS):
-    case(MS_KILOMETERS):
-    case(MS_MILES):
-    case(MS_NAUTICALMILES):
-    case(MS_INCHES):
-    case(MS_FEET):
-      center_y = (extent.miny+extent.maxy)/2.0;
-      md = (width-1)/(resolution*msInchesPerUnit(units, center_y)); /* remember, we use a pixel-center to pixel-center extent, hence the width-1 */
-      gd = extent.maxx - extent.minx;
-      *scale = gd/md;
-      break;
-    default:
-      *scale = -1; /* this is not an error */
-      break;
+  case (MS_DD):
+  case (MS_METERS):
+  case (MS_KILOMETERS):
+  case (MS_MILES):
+  case (MS_NAUTICALMILES):
+  case (MS_INCHES):
+  case (MS_FEET):
+    center_y = (extent.miny + extent.maxy) / 2.0;
+    md = (width - 1) /
+         (resolution *
+          msInchesPerUnit(
+              units, center_y)); /* remember, we use a pixel-center to
+                                    pixel-center extent, hence the width-1 */
+    gd = extent.maxx - extent.minx;
+    *scale = gd / md;
+    break;
+  default:
+    *scale = -1; /* this is not an error */
+    break;
   }
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
-double msInchesPerUnit(int units, double center_lat)
-{
+double msInchesPerUnit(int units, double center_lat) {
   (void)center_lat;
   double lat_adj = 1.0, ipu = 1.0;
 
   switch (units) {
-    case(MS_METERS):
-    case(MS_KILOMETERS):
-    case(MS_MILES):
-    case(MS_NAUTICALMILES):
-    case(MS_INCHES):
-    case(MS_FEET):
-      ipu = inchesPerUnit[units];
-      break;
-    case(MS_DD):
-      /* With geographical (DD) coordinates, we adjust the inchesPerUnit
-       * based on the latitude of the center of the view. For this we assume
-       * we have a perfect sphere and just use cos(lat) in our calculation.
-       */
+  case (MS_METERS):
+  case (MS_KILOMETERS):
+  case (MS_MILES):
+  case (MS_NAUTICALMILES):
+  case (MS_INCHES):
+  case (MS_FEET):
+    ipu = inchesPerUnit[units];
+    break;
+  case (MS_DD):
+    /* With geographical (DD) coordinates, we adjust the inchesPerUnit
+     * based on the latitude of the center of the view. For this we assume
+     * we have a perfect sphere and just use cos(lat) in our calculation.
+     */
 #ifdef ENABLE_VARIABLE_INCHES_PER_DEGREE
-      if (center_lat != 0.0) {
-        double cos_lat;
-        cos_lat = cos(MS_PI*center_lat/180.0);
-        lat_adj = sqrt(1+cos_lat*cos_lat)/sqrt(2.0);
-      }
+    if (center_lat != 0.0) {
+      double cos_lat;
+      cos_lat = cos(MS_PI * center_lat / 180.0);
+      lat_adj = sqrt(1 + cos_lat * cos_lat) / sqrt(2.0);
+    }
 #endif
-      ipu = inchesPerUnit[units]*lat_adj;
-      break;
-    default:
-      break;
+    ipu = inchesPerUnit[units] * lat_adj;
+    break;
+  default:
+    break;
   }
 
   return ipu;
 }
 
-
 #define X_STEP_SIZE 5
 
-imageObj *msDrawScalebar(mapObj *map)
-{
+imageObj *msDrawScalebar(mapObj *map) {
   int status;
   char label[32];
   double i, msx;
@@ -157,7 +164,7 @@ imageObj *msDrawScalebar(mapObj *map)
   int isx, sx, sy, ox, oy, state, dsx;
   pointObj p;
   rectObj r;
-  imageObj      *image = NULL;
+  imageObj *image = NULL;
   double fontWidth, fontHeight;
   outputFormatObj *format = NULL;
   strokeStyleObj strokeStyle = {0};
@@ -167,232 +174,252 @@ imageObj *msDrawScalebar(mapObj *map)
   textSymbolObj ts;
   rendererVTableObj *renderer;
 
-  strokeStyle.patternlength=0;
+  strokeStyle.patternlength = 0;
   initTextSymbol(&ts);
 
-  if((int)map->units == -1) {
+  if ((int)map->units == -1) {
     msSetError(MS_MISCERR, "Map units not set.", "msDrawScalebar()");
-    return(NULL);
+    return (NULL);
   }
 
   renderer = MS_MAP_RENDERER(map);
-  if(!renderer || !MS_MAP_RENDERER(map)->supports_pixel_buffer) {
-    msSetError(MS_MISCERR, "Outputformat not supported for scalebar", "msDrawScalebar()");
-    return(NULL);
+  if (!renderer || !MS_MAP_RENDERER(map)->supports_pixel_buffer) {
+    msSetError(MS_MISCERR, "Outputformat not supported for scalebar",
+               "msDrawScalebar()");
+    return (NULL);
   }
-  
-  msPopulateTextSymbolForLabelAndString(&ts,&map->scalebar.label,msStrdup("0123456789"),1.0,map->resolution/map->defresolution, 0);
+
+  msPopulateTextSymbolForLabelAndString(
+      &ts, &map->scalebar.label, msStrdup("0123456789"), 1.0,
+      map->resolution / map->defresolution, 0);
 
   /*
-   *  A string containing the ten decimal digits is rendered to compute an average cell size
-   *  for each number, which is used later to place labels on the scalebar.
+   *  A string containing the ten decimal digits is rendered to compute an
+   * average cell size for each number, which is used later to place labels on
+   * the scalebar.
    */
-  
 
-  if(msGetTextSymbolSize(map,&ts,&r) != MS_SUCCESS) {
+  if (msGetTextSymbolSize(map, &ts, &r) != MS_SUCCESS) {
     return NULL;
   }
-  fontWidth = (r.maxx-r.minx)/10.0;
-  fontHeight = r.maxy -r.miny;
+  fontWidth = (r.maxx - r.minx) / 10.0;
+  fontHeight = r.maxy - r.miny;
 
   map->cellsize = msAdjustExtent(&(map->extent), map->width, map->height);
-  status = msCalculateScale(map->extent, map->units, map->width, map->height, map->resolution, &map->scaledenom);
-  if(status != MS_SUCCESS) {
-    return(NULL);
+  status = msCalculateScale(map->extent, map->units, map->width, map->height,
+                            map->resolution, &map->scaledenom);
+  if (status != MS_SUCCESS) {
+    return (NULL);
   }
-  dsx = map->scalebar.width - 2*HMARGIN;
+  dsx = map->scalebar.width - 2 * HMARGIN;
   do {
-    msx = (map->cellsize * dsx)/(msInchesPerUnit(map->scalebar.units,0)/msInchesPerUnit(map->units,0));
-    i = roundInterval(msx/map->scalebar.intervals);
-    snprintf(label, sizeof(label), "%g", map->scalebar.intervals*i); /* last label */
-    isx = MS_NINT((i/(msInchesPerUnit(map->units,0)/msInchesPerUnit(map->scalebar.units,0)))/map->cellsize);
-    sx = (map->scalebar.intervals*isx) + MS_NINT((1.5 + strlen(label)/2.0 + strlen(unitText[map->scalebar.units]))*fontWidth);
-
-    if(sx <= (map->scalebar.width - 2*HMARGIN)) break; /* it will fit */
-
-    dsx -= X_STEP_SIZE; /* change the desired size in hopes that it will fit in user supplied width */
-  } while(1);
+    msx = (map->cellsize * dsx) / (msInchesPerUnit(map->scalebar.units, 0) /
+                                   msInchesPerUnit(map->units, 0));
+    i = roundInterval(msx / map->scalebar.intervals);
+    snprintf(label, sizeof(label), "%g",
+             map->scalebar.intervals * i); /* last label */
+    isx = MS_NINT((i / (msInchesPerUnit(map->units, 0) /
+                        msInchesPerUnit(map->scalebar.units, 0))) /
+                  map->cellsize);
+    sx = (map->scalebar.intervals * isx) +
+         MS_NINT((1.5 + strlen(label) / 2.0 +
+                  strlen(unitText[map->scalebar.units])) *
+                 fontWidth);
+
+    if (sx <= (map->scalebar.width - 2 * HMARGIN))
+      break; /* it will fit */
+
+    dsx -= X_STEP_SIZE; /* change the desired size in hopes that it will fit in
+                           user supplied width */
+  } while (1);
 
-  sy = (2*VMARGIN) + MS_NINT(VSPACING*fontHeight) + fontHeight + map->scalebar.height - VSLOP;
+  sy = (2 * VMARGIN) + MS_NINT(VSPACING * fontHeight) + fontHeight +
+       map->scalebar.height - VSLOP;
 
   /*Ensure we have an image format representing the options for the scalebar.*/
-  msApplyOutputFormat( &format, map->outputformat, map->scalebar.transparent);
+  msApplyOutputFormat(&format, map->outputformat, map->scalebar.transparent);
 
-  if(map->scalebar.transparent == MS_OFF) {
-    if(!MS_VALID_COLOR(map->scalebar.imagecolor))
-      MS_INIT_COLOR(map->scalebar.imagecolor,255,255,255,255);
-  }
-  image = msImageCreate(map->scalebar.width, sy, format,
-                        map->web.imagepath, map->web.imageurl, map->resolution, map->defresolution, &map->scalebar.imagecolor);
+  if (map->scalebar.transparent == MS_OFF) {
+    if (!MS_VALID_COLOR(map->scalebar.imagecolor))
+      MS_INIT_COLOR(map->scalebar.imagecolor, 255, 255, 255, 255);
+  }
+  image = msImageCreate(map->scalebar.width, sy, format, map->web.imagepath,
+                        map->web.imageurl, map->resolution, map->defresolution,
+                        &map->scalebar.imagecolor);
 
   /* did we succeed in creating the image? */
-  if(!image) {
+  if (!image) {
     msSetError(MS_MISCERR, "Unable to initialize image.", "msDrawScalebar()");
     return NULL;
   }
   image->map = map;
 
   /* drop this reference to output format */
-  msApplyOutputFormat( &format, NULL, MS_NOOVERRIDE);
+  msApplyOutputFormat(&format, NULL, MS_NOOVERRIDE);
 
-  switch(map->scalebar.align) {
-    case(MS_ALIGN_LEFT):
-      ox = HMARGIN;
-      break;
-    case(MS_ALIGN_RIGHT):
-      ox = MS_NINT((map->scalebar.width - sx) + fontWidth);
-      break;
-    default:
-      ox = MS_NINT((map->scalebar.width - sx)/2.0 + fontWidth/2.0); /* center the computed scalebar */
+  switch (map->scalebar.align) {
+  case (MS_ALIGN_LEFT):
+    ox = HMARGIN;
+    break;
+  case (MS_ALIGN_RIGHT):
+    ox = MS_NINT((map->scalebar.width - sx) + fontWidth);
+    break;
+  default:
+    ox = MS_NINT((map->scalebar.width - sx) / 2.0 +
+                 fontWidth / 2.0); /* center the computed scalebar */
   }
   oy = VMARGIN;
 
-  switch(map->scalebar.style) {
-    case(0): {
-
-      line.numpoints = 5;
-      line.point = points;
-      shape.line = &line;
-      shape.numlines = 1;
-      if(MS_VALID_COLOR(map->scalebar.color)) {
-        INIT_STROKE_STYLE(strokeStyle);
-        strokeStyle.color = &map->scalebar.outlinecolor;
-        strokeStyle.color->alpha = 255;
-        strokeStyle.width = 1;
-      }
-      map->scalebar.backgroundcolor.alpha = 255;
-      map->scalebar.color.alpha = 255;
-      state = 1; /* 1 means filled */
-      for(j=0; j<map->scalebar.intervals; j++) {
-        points[0].x = points[4].x = points[3].x = ox + j*isx + 0.5;
-        points[0].y = points[4].y = points[1].y = oy + 0.5;
-        points[1].x = points[2].x = ox + (j+1)*isx + 0.5;
-        points[2].y = points[3].y = oy + map->scalebar.height + 0.5;
-        if(state == 1 && MS_VALID_COLOR(map->scalebar.color))
-          status = renderer->renderPolygon(image,&shape,&map->scalebar.color);
-        else if(MS_VALID_COLOR(map->scalebar.backgroundcolor))
-          status = renderer->renderPolygon(image,&shape,&map->scalebar.backgroundcolor);
+  switch (map->scalebar.style) {
+  case (0): {
 
-        if(MS_UNLIKELY(status == MS_FAILURE)) {
-          goto scale_cleanup;
-        }
+    line.numpoints = 5;
+    line.point = points;
+    shape.line = &line;
+    shape.numlines = 1;
+    if (MS_VALID_COLOR(map->scalebar.color)) {
+      INIT_STROKE_STYLE(strokeStyle);
+      strokeStyle.color = &map->scalebar.outlinecolor;
+      strokeStyle.color->alpha = 255;
+      strokeStyle.width = 1;
+    }
+    map->scalebar.backgroundcolor.alpha = 255;
+    map->scalebar.color.alpha = 255;
+    state = 1; /* 1 means filled */
+    for (j = 0; j < map->scalebar.intervals; j++) {
+      points[0].x = points[4].x = points[3].x = ox + j * isx + 0.5;
+      points[0].y = points[4].y = points[1].y = oy + 0.5;
+      points[1].x = points[2].x = ox + (j + 1) * isx + 0.5;
+      points[2].y = points[3].y = oy + map->scalebar.height + 0.5;
+      if (state == 1 && MS_VALID_COLOR(map->scalebar.color))
+        status = renderer->renderPolygon(image, &shape, &map->scalebar.color);
+      else if (MS_VALID_COLOR(map->scalebar.backgroundcolor))
+        status = renderer->renderPolygon(image, &shape,
+                                         &map->scalebar.backgroundcolor);
 
-        if(strokeStyle.color) {
-          status = renderer->renderLine(image,&shape,&strokeStyle);
+      if (MS_UNLIKELY(status == MS_FAILURE)) {
+        goto scale_cleanup;
+      }
 
-          if(MS_UNLIKELY(status == MS_FAILURE)) {
-            goto scale_cleanup;
-          }
-        }
+      if (strokeStyle.color) {
+        status = renderer->renderLine(image, &shape, &strokeStyle);
 
-        sprintf(label, "%g", j*i);
-        map->scalebar.label.position = MS_CC;
-        p.x = ox + j*isx; /* + MS_NINT(fontPtr->w/2); */
-        p.y = oy + map->scalebar.height + MS_NINT(VSPACING*fontHeight);
-        status = msDrawLabel(map,image,p,msStrdup(label),&map->scalebar.label,1.0);
-        if(MS_UNLIKELY(status == MS_FAILURE)) {
+        if (MS_UNLIKELY(status == MS_FAILURE)) {
           goto scale_cleanup;
         }
-        state = -state;
       }
-      sprintf(label, "%g", j*i);
-      ox = ox + j*isx - MS_NINT((strlen(label)*fontWidth)/2.0);
-      sprintf(label, "%g %s", j*i, unitText[map->scalebar.units]);
-      map->scalebar.label.position = MS_CR;
-      p.x = ox; /* + MS_NINT(fontPtr->w/2); */
-      p.y = oy + map->scalebar.height + MS_NINT(VSPACING*fontHeight);
-      status = msDrawLabel(map,image,p,msStrdup(label),&map->scalebar.label,1.0);
-      if(MS_UNLIKELY(status == MS_FAILURE)) {
+
+      sprintf(label, "%g", j * i);
+      map->scalebar.label.position = MS_CC;
+      p.x = ox + j * isx; /* + MS_NINT(fontPtr->w/2); */
+      p.y = oy + map->scalebar.height + MS_NINT(VSPACING * fontHeight);
+      status = msDrawLabel(map, image, p, msStrdup(label), &map->scalebar.label,
+                           1.0);
+      if (MS_UNLIKELY(status == MS_FAILURE)) {
         goto scale_cleanup;
       }
-      break;
+      state = -state;
+    }
+    sprintf(label, "%g", j * i);
+    ox = ox + j * isx - MS_NINT((strlen(label) * fontWidth) / 2.0);
+    sprintf(label, "%g %s", j * i, unitText[map->scalebar.units]);
+    map->scalebar.label.position = MS_CR;
+    p.x = ox; /* + MS_NINT(fontPtr->w/2); */
+    p.y = oy + map->scalebar.height + MS_NINT(VSPACING * fontHeight);
+    status =
+        msDrawLabel(map, image, p, msStrdup(label), &map->scalebar.label, 1.0);
+    if (MS_UNLIKELY(status == MS_FAILURE)) {
+      goto scale_cleanup;
+    }
+    break;
+  }
+  case (1): {
+    line.numpoints = 2;
+    line.point = points;
+    shape.line = &line;
+    shape.numlines = 1;
+    if (MS_VALID_COLOR(map->scalebar.color)) {
+      strokeStyle.width = 1;
+      strokeStyle.color = &map->scalebar.color;
     }
-    case(1): {
-      line.numpoints = 2;
-      line.point = points;
-      shape.line = &line;
-      shape.numlines = 1;
-      if(MS_VALID_COLOR(map->scalebar.color)) {
-        strokeStyle.width = 1;
-        strokeStyle.color = &map->scalebar.color;
-      }
 
-      points[0].y = points[1].y = oy;
-      points[0].x = ox;
-      points[1].x = ox + isx*map->scalebar.intervals;
-      status = renderer->renderLine(image,&shape,&strokeStyle);
-      if(MS_UNLIKELY(status == MS_FAILURE)) {
+    points[0].y = points[1].y = oy;
+    points[0].x = ox;
+    points[1].x = ox + isx * map->scalebar.intervals;
+    status = renderer->renderLine(image, &shape, &strokeStyle);
+    if (MS_UNLIKELY(status == MS_FAILURE)) {
+      goto scale_cleanup;
+    }
+
+    points[0].y = oy;
+    points[1].y = oy + map->scalebar.height;
+    p.y = oy + map->scalebar.height + MS_NINT(VSPACING * fontHeight);
+    for (j = 0; j <= map->scalebar.intervals; j++) {
+      points[0].x = points[1].x = ox + j * isx;
+      status = renderer->renderLine(image, &shape, &strokeStyle);
+      if (MS_UNLIKELY(status == MS_FAILURE)) {
         goto scale_cleanup;
       }
 
-      points[0].y = oy;
-      points[1].y = oy + map->scalebar.height;
-      p.y = oy + map->scalebar.height + MS_NINT(VSPACING*fontHeight);
-      for(j=0; j<=map->scalebar.intervals; j++) {
-        points[0].x = points[1].x = ox + j*isx;
-        status = renderer->renderLine(image,&shape,&strokeStyle);
-        if(MS_UNLIKELY(status == MS_FAILURE)) {
-          goto scale_cleanup;
-        }
-
-        sprintf(label, "%g", j*i);
-        if(j!=map->scalebar.intervals) {
-          map->scalebar.label.position = MS_CC;
-          p.x = ox + j*isx; /* + MS_NINT(fontPtr->w/2); */
-        } else {
-          sprintf(label, "%g %s", j*i, unitText[map->scalebar.units]);
-          map->scalebar.label.position = MS_CR;
-          p.x = ox + j*isx - MS_NINT((strlen(label)*fontWidth)/2.0);
-        }
-        status = msDrawLabel(map,image,p,msStrdup(label),&map->scalebar.label,1.0);
-        if(MS_UNLIKELY(status == MS_FAILURE)) {
-          goto scale_cleanup;
-        }
+      sprintf(label, "%g", j * i);
+      if (j != map->scalebar.intervals) {
+        map->scalebar.label.position = MS_CC;
+        p.x = ox + j * isx; /* + MS_NINT(fontPtr->w/2); */
+      } else {
+        sprintf(label, "%g %s", j * i, unitText[map->scalebar.units]);
+        map->scalebar.label.position = MS_CR;
+        p.x = ox + j * isx - MS_NINT((strlen(label) * fontWidth) / 2.0);
+      }
+      status = msDrawLabel(map, image, p, msStrdup(label), &map->scalebar.label,
+                           1.0);
+      if (MS_UNLIKELY(status == MS_FAILURE)) {
+        goto scale_cleanup;
       }
-      break;
     }
-    default:
-      msSetError(MS_MISCERR, "Unsupported scalebar style.", "msDrawScalebar()");
-      return(NULL);
+    break;
+  }
+  default:
+    msSetError(MS_MISCERR, "Unsupported scalebar style.", "msDrawScalebar()");
+    return (NULL);
   }
 
 scale_cleanup:
   freeTextSymbol(&ts);
-  if(MS_UNLIKELY(status == MS_FAILURE)) {
+  if (MS_UNLIKELY(status == MS_FAILURE)) {
     msFreeImage(image);
     return NULL;
   }
-  return(image);
-
+  return (image);
 }
 
-int msEmbedScalebar(mapObj *map, imageObj *img)
-{
-  int l,index,s,status = MS_SUCCESS;
+int msEmbedScalebar(mapObj *map, imageObj *img) {
+  int l, index, s, status = MS_SUCCESS;
   pointObj point;
   imageObj *image = NULL;
   rendererVTableObj *renderer;
   symbolObj *embededSymbol;
-  char* imageType = NULL;
+  char *imageType = NULL;
 
   index = msGetSymbolIndex(&(map->symbolset), "scalebar", MS_FALSE);
-  if(index != -1)
-    msRemoveSymbol(&(map->symbolset), index); /* remove cached symbol in case the function is called multiple
-                      times with different zoom levels */
+  if (index != -1)
+    msRemoveSymbol(&(map->symbolset),
+                   index); /* remove cached symbol in case the function is
+   called multiple times with different zoom levels */
 
-  if((embededSymbol=msGrowSymbolSet(&map->symbolset)) == NULL)
+  if ((embededSymbol = msGrowSymbolSet(&map->symbolset)) == NULL)
     return MS_FAILURE;
 
   s = map->symbolset.numsymbols;
   map->symbolset.numsymbols++;
 
-  if(!MS_RENDERER_PLUGIN(map->outputformat) || !MS_MAP_RENDERER(map)->supports_pixel_buffer) {
+  if (!MS_RENDERER_PLUGIN(map->outputformat) ||
+      !MS_MAP_RENDERER(map)->supports_pixel_buffer) {
     imageType = msStrdup(map->imagetype); /* save format */
-    if MS_DRIVER_CAIRO(map->outputformat)
-      map->outputformat = msSelectOutputFormat( map, "cairopng" );
+    if MS_DRIVER_CAIRO (map->outputformat)
+      map->outputformat = msSelectOutputFormat(map, "cairopng");
     else
-      map->outputformat = msSelectOutputFormat( map, "png" );
-    
+      map->outputformat = msSelectOutputFormat(map, "png");
+
     msInitializeRendererVTable(map->outputformat);
   }
   renderer = MS_MAP_RENDERER(map);
@@ -400,17 +427,20 @@ int msEmbedScalebar(mapObj *map, imageOb
   image = msDrawScalebar(map);
 
   if (imageType) {
-    map->outputformat = msSelectOutputFormat( map, imageType ); /* restore format */
+    map->outputformat =
+        msSelectOutputFormat(map, imageType); /* restore format */
     msFree(imageType);
   }
 
-  if(!image) {
+  if (!image) {
     return MS_FAILURE;
   }
-  embededSymbol->pixmap_buffer = calloc(1,sizeof(rasterBufferObj));
-  MS_CHECK_ALLOC(embededSymbol->pixmap_buffer, sizeof(rasterBufferObj), MS_FAILURE);
+  embededSymbol->pixmap_buffer = calloc(1, sizeof(rasterBufferObj));
+  MS_CHECK_ALLOC(embededSymbol->pixmap_buffer, sizeof(rasterBufferObj),
+                 MS_FAILURE);
 
-  if(MS_SUCCESS != renderer->getRasterBufferCopy(image,embededSymbol->pixmap_buffer)) {
+  if (MS_SUCCESS !=
+      renderer->getRasterBufferCopy(image, embededSymbol->pixmap_buffer)) {
     return MS_FAILURE;
   }
 
@@ -418,52 +448,67 @@ int msEmbedScalebar(mapObj *map, imageOb
   embededSymbol->name = msStrdup("scalebar");
   embededSymbol->sizex = embededSymbol->pixmap_buffer->width;
   embededSymbol->sizey = embededSymbol->pixmap_buffer->height;
-  if(map->scalebar.transparent) {
+  if (map->scalebar.transparent) {
     embededSymbol->transparent = MS_TRUE;
     embededSymbol->transparentcolor = 0;
   }
 
-  switch(map->scalebar.position) {
-    case(MS_LL):
-      point.x = MS_NINT(embededSymbol->pixmap_buffer->width/2.0) + map->scalebar.offsetx;
-      point.y = map->height - MS_NINT(embededSymbol->pixmap_buffer->height/2.0) - map->scalebar.offsety;
-      break;
-    case(MS_LR):
-      point.x = map->width - MS_NINT(embededSymbol->pixmap_buffer->width/2.0) - map->scalebar.offsetx;
-      point.y = map->height - MS_NINT(embededSymbol->pixmap_buffer->height/2.0) - map->scalebar.offsety;
-      break;
-    case(MS_LC):
-      point.x = MS_NINT(map->width/2.0) + map->scalebar.offsetx;
-      point.y = map->height - MS_NINT(embededSymbol->pixmap_buffer->height/2.0) - map->scalebar.offsety;
-      break;
-    case(MS_UR):
-      point.x = map->width - MS_NINT(embededSymbol->pixmap_buffer->width/2.0) - map->scalebar.offsetx;
-      point.y = MS_NINT(embededSymbol->pixmap_buffer->height/2.0) + map->scalebar.offsety;
-      break;
-    case(MS_UL):
-      point.x = MS_NINT(embededSymbol->pixmap_buffer->width/2.0) + map->scalebar.offsetx;
-      point.y = MS_NINT(embededSymbol->pixmap_buffer->height/2.0) + map->scalebar.offsety;
-      break;
-    case(MS_UC):
-      point.x = MS_NINT(map->width/2.0) + map->scalebar.offsetx;
-      point.y = MS_NINT(embededSymbol->pixmap_buffer->height/2.0) + map->scalebar.offsety;
-      break;
+  switch (map->scalebar.position) {
+  case (MS_LL):
+    point.x = MS_NINT(embededSymbol->pixmap_buffer->width / 2.0) +
+              map->scalebar.offsetx;
+    point.y = map->height -
+              MS_NINT(embededSymbol->pixmap_buffer->height / 2.0) -
+              map->scalebar.offsety;
+    break;
+  case (MS_LR):
+    point.x = map->width - MS_NINT(embededSymbol->pixmap_buffer->width / 2.0) -
+              map->scalebar.offsetx;
+    point.y = map->height -
+              MS_NINT(embededSymbol->pixmap_buffer->height / 2.0) -
+              map->scalebar.offsety;
+    break;
+  case (MS_LC):
+    point.x = MS_NINT(map->width / 2.0) + map->scalebar.offsetx;
+    point.y = map->height -
+              MS_NINT(embededSymbol->pixmap_buffer->height / 2.0) -
+              map->scalebar.offsety;
+    break;
+  case (MS_UR):
+    point.x = map->width - MS_NINT(embededSymbol->pixmap_buffer->width / 2.0) -
+              map->scalebar.offsetx;
+    point.y = MS_NINT(embededSymbol->pixmap_buffer->height / 2.0) +
+              map->scalebar.offsety;
+    break;
+  case (MS_UL):
+    point.x = MS_NINT(embededSymbol->pixmap_buffer->width / 2.0) +
+              map->scalebar.offsetx;
+    point.y = MS_NINT(embededSymbol->pixmap_buffer->height / 2.0) +
+              map->scalebar.offsety;
+    break;
+  case (MS_UC):
+    point.x = MS_NINT(map->width / 2.0) + map->scalebar.offsetx;
+    point.y = MS_NINT(embededSymbol->pixmap_buffer->height / 2.0) +
+              map->scalebar.offsety;
+    break;
   }
 
   l = msGetLayerIndex(map, "__embed__scalebar");
-  if(l == -1) {
+  if (l == -1) {
     if (msGrowMapLayers(map) == NULL)
-      return(-1);
+      return (-1);
     l = map->numlayers;
     map->numlayers++;
-    if(initLayer((GET_LAYER(map, l)), map) == -1) return(-1);
+    if (initLayer((GET_LAYER(map, l)), map) == -1)
+      return (-1);
     GET_LAYER(map, l)->name = msStrdup("__embed__scalebar");
     GET_LAYER(map, l)->type = MS_LAYER_POINT;
 
-    if (msGrowLayerClasses( GET_LAYER(map, l) ) == NULL)
-      return(-1);
+    if (msGrowLayerClasses(GET_LAYER(map, l)) == NULL)
+      return (-1);
 
-    if(initClass(GET_LAYER(map, l)->class[0]) == -1) return(-1);
+    if (initClass(GET_LAYER(map, l)->class[0]) == -1)
+      return (-1);
     GET_LAYER(map, l)->numclasses = 1; /* so we make sure to free it */
 
     /* update the layer order list with the layer's index. */
@@ -471,41 +516,48 @@ int msEmbedScalebar(mapObj *map, imageOb
   }
 
   GET_LAYER(map, l)->status = MS_ON;
-  if(map->scalebar.postlabelcache) { /* add it directly to the image */
-    if(msMaybeAllocateClassStyle(GET_LAYER(map, l)->class[0], 0)==MS_FAILURE) return MS_FAILURE;
+  if (map->scalebar.postlabelcache) { /* add it directly to the image */
+    if (msMaybeAllocateClassStyle(GET_LAYER(map, l)->class[0], 0) == MS_FAILURE)
+      return MS_FAILURE;
     GET_LAYER(map, l)->class[0]->styles[0]->symbol = s;
-    status = msDrawMarkerSymbol(map, img, &point, GET_LAYER(map, l)->class[0]->styles[0], 1.0);
-    if(MS_UNLIKELY(status == MS_FAILURE)) {
+    status = msDrawMarkerSymbol(map, img, &point,
+                                GET_LAYER(map, l)->class[0] -> styles[0], 1.0);
+    if (MS_UNLIKELY(status == MS_FAILURE)) {
       goto embed_cleanup;
     }
   } else {
-    if(!GET_LAYER(map, l)->class[0]->labels) {
-      if(msGrowClassLabels(GET_LAYER(map, l)->class[0]) == NULL) return MS_FAILURE;
-      initLabel(GET_LAYER(map, l)->class[0]->labels[0]);
+    if (!GET_LAYER(map, l)->class[0] -> labels) {
+      if (msGrowClassLabels(GET_LAYER(map, l)->class[0]) == NULL)
+        return MS_FAILURE;
+      initLabel(GET_LAYER(map, l)->class[0] -> labels[0]);
       GET_LAYER(map, l)->class[0]->numlabels = 1;
       GET_LAYER(map, l)->class[0]->labels[0]->force = MS_TRUE;
-      GET_LAYER(map, l)->class[0]->labels[0]->size = MS_MEDIUM; /* must set a size to have a valid label definition */
+      GET_LAYER(map, l)->class[0]->labels[0]->size =
+          MS_MEDIUM; /* must set a size to have a valid label definition */
       GET_LAYER(map, l)->class[0]->labels[0]->priority = MS_MAX_LABEL_PRIORITY;
     }
-    if(GET_LAYER(map, l)->class[0]->labels[0]->numstyles == 0) {
-      if(msGrowLabelStyles(GET_LAYER(map,l)->class[0]->labels[0]) == NULL)
-        return(MS_FAILURE);
-      GET_LAYER(map,l)->class[0]->labels[0]->numstyles = 1;
-      initStyle(GET_LAYER(map,l)->class[0]->labels[0]->styles[0]);
-      GET_LAYER(map,l)->class[0]->labels[0]->styles[0]->_geomtransform.type = MS_GEOMTRANSFORM_LABELPOINT;
-    }
-    GET_LAYER(map,l)->class[0]->labels[0]->styles[0]->symbol = s;
-    status = msAddLabel(map, img, GET_LAYER(map, l)->class[0]->labels[0], l, 0, NULL, &point, -1, NULL);
-    if(MS_UNLIKELY(status == MS_FAILURE)) {
+    if (GET_LAYER(map, l)->class[0] -> labels[0] -> numstyles == 0) {
+      if (msGrowLabelStyles(GET_LAYER(map, l)->class[0] -> labels[0]) == NULL)
+        return (MS_FAILURE);
+      GET_LAYER(map, l)->class[0]->labels[0]->numstyles = 1;
+      initStyle(GET_LAYER(map, l)->class[0] -> labels[0] -> styles[0]);
+      GET_LAYER(map, l)->class[0]->labels[0]->styles[0]->_geomtransform.type =
+          MS_GEOMTRANSFORM_LABELPOINT;
+    }
+    GET_LAYER(map, l)->class[0]->labels[0]->styles[0]->symbol = s;
+    status = msAddLabel(map, img, GET_LAYER(map, l)->class[0] -> labels[0], l,
+                        0, NULL, &point, -1, NULL);
+    if (MS_UNLIKELY(status == MS_FAILURE)) {
       goto embed_cleanup;
     }
   }
 
 embed_cleanup:
-  /* Mark layer as deleted so that it doesn't interfere with html legends or with saving maps */
+  /* Mark layer as deleted so that it doesn't interfere with html legends or
+   * with saving maps */
   GET_LAYER(map, l)->status = MS_DELETE;
 
-  msFreeImage( image );
+  msFreeImage(image);
   return status;
 }
 
@@ -523,29 +575,30 @@ embed_cleanup:
 /*                                                                      */
 /*      Base on the function msCalculateScale (mapscale.c)              */
 /************************************************************************/
-double GetDeltaExtentsUsingScale(double scale, int units, double centerLat, int width, double resolution)
-{
+double GetDeltaExtentsUsingScale(double scale, int units, double centerLat,
+                                 int width, double resolution) {
   double md = 0.0;
   double dfDelta = -1.0;
 
-  if (scale <= 0 || width <=0)
+  if (scale <= 0 || width <= 0)
     return -1;
 
   switch (units) {
-    case(MS_DD):
-    case(MS_METERS):
-    case(MS_KILOMETERS):
-    case(MS_MILES):
-    case(MS_NAUTICALMILES):
-    case(MS_INCHES):
-    case(MS_FEET):
-      /* remember, we use a pixel-center to pixel-center extent, hence the width-1 */
-      md = (width-1)/(resolution*msInchesPerUnit(units,centerLat));
-      dfDelta = md * scale;
-      break;
+  case (MS_DD):
+  case (MS_METERS):
+  case (MS_KILOMETERS):
+  case (MS_MILES):
+  case (MS_NAUTICALMILES):
+  case (MS_INCHES):
+  case (MS_FEET):
+    /* remember, we use a pixel-center to pixel-center extent, hence the width-1
+     */
+    md = (width - 1) / (resolution * msInchesPerUnit(units, centerLat));
+    dfDelta = md * scale;
+    break;
 
-    default:
-      break;
+  default:
+    break;
   }
 
   return dfDelta;
@@ -561,10 +614,9 @@ double GetDeltaExtentsUsingScale(double
 /*      considered to be the Y origin.                                  */
 /*                                                                      */
 /************************************************************************/
-double Pix2Georef(int nPixPos, int nPixMin, int nPixMax,
-                  double dfGeoMin, double dfGeoMax, int bULisYOrig)
-{
-  double      dfPosGeo = 0.0;
+double Pix2Georef(int nPixPos, int nPixMin, int nPixMax, double dfGeoMin,
+                  double dfGeoMax, int bULisYOrig) {
+  double dfPosGeo = 0.0;
 
   const double dfWidthGeo = dfGeoMax - dfGeoMin;
   const int nWidthPix = nPixMax - nPixMin;
@@ -586,18 +638,20 @@ double Pix2Georef(int nPixPos, int nPixM
 }
 
 /* This function converts a pixel value in geo ref. The return value is in
- * layer units. This function has been added for the purpose of the ticket #1340 */
+ * layer units. This function has been added for the purpose of the ticket #1340
+ */
 
-double Pix2LayerGeoref(mapObj *map, layerObj *layer, int value)
-{
-  double cellsize = MS_MAX(MS_CELLSIZE(map->extent.minx, map->extent.maxx, map->width),
-                           MS_CELLSIZE(map->extent.miny, map->extent.maxy, map->height));
+double Pix2LayerGeoref(mapObj *map, layerObj *layer, int value) {
+  double cellsize =
+      MS_MAX(MS_CELLSIZE(map->extent.minx, map->extent.maxx, map->width),
+             MS_CELLSIZE(map->extent.miny, map->extent.maxy, map->height));
 
-  double resolutionFactor = map->resolution/map->defresolution;
+  double resolutionFactor = map->resolution / map->defresolution;
   double unitsFactor = 1;
 
   if (layer->sizeunits != MS_PIXELS)
-    unitsFactor = msInchesPerUnit(map->units,0)/msInchesPerUnit(layer->sizeunits,0);
+    unitsFactor =
+        msInchesPerUnit(map->units, 0) / msInchesPerUnit(layer->sizeunits, 0);
 
-  return value*cellsize*resolutionFactor*unitsFactor;
+  return value * cellsize * resolutionFactor * unitsFactor;
 }
diff -pruN 8.0.1-5/mapscript/README.md 8.0.2-1/mapscript/README.md
--- 8.0.1-5/mapscript/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 8.0.2-1/mapscript/README.md	2024-06-11 20:41:34.000000000 +0000
@@ -0,0 +1,57 @@
+MapServer MapScript Modules
+===========================
+
+Much of MapServer's functionality is accessible from Java, Perl, PHP, Python,
+Ruby, C#, and Tcl.  MapScript is not a language like JavaScript or Python, it
+is a loadable module that brings MapServer capabilities to your favorite 
+high-level programming language.
+
+MapScript Family
+----------------------------------
+
+The MapScript family tree looks like this:
+
+```
+
+               MapServer
+                   | 
+                   |    
+                   | 
+              SWIGMapScript
+                   |
+   +----+-----+----+----+--+--+-----------+
+   |    |     |    |    |  |  |           |
+ Perl Python Ruby Java C# Tcl PHPNG ...
+```                 
+
+
+The SWIGMapScript modules are generated by [SWIG](http://www.swig.org). 
+
+SWIG MapScript
+--------------
+
+Installation instructions are located in the individual languages
+directories such as ``mapscript/perl``, ``mapscript/python``. 
+
+The main MapScript SWIG interface file is ``mapscript/mapscript.i``.  This
+file includes specific class interface files from ``mapscript/swiginc`` and
+language specific code from the language directories.
+
+Note the **v8** folder contains files for [V8 MapScript Support](https://mapserver.org/installation/v8.html). 
+This is not a JavaScript version of MapScript, but provides support for the use of JavaScript
+in [STYLEITEM](https://mapserver.org/mapfile/styleitem.html#styleitemjs) and 
+[GEOTRANSFORM](https://mapserver.org/mapfile/geomtransform.html#geomtransformjs). 
+
+API Documentation can be found at the [Shared SWIG MapScript Documentation](https://mapserver.org/mapscript/index.html) 
+page. 
+
+PHPNG (SWIG) MapScript
+----------------------
+
+PHP support ("PHPNG") is included in the [SWIG API](https://mapserver.org/mapscript/index.html) 
+since the MapServer 7.4.0 release.  You can specify `WITH_PHPNG=ON` at your 
+CMake commandline, to compile PHPNG support for MapServer.
+
+The old native PHPMapScript module developed using the PHP C API was removed in 
+the MapServer 8.0.0 release. 
+
diff -pruN 8.0.1-5/mapscript/README.rst 8.0.2-1/mapscript/README.rst
--- 8.0.1-5/mapscript/README.rst	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapscript/README.rst	1970-01-01 00:00:00.000000000 +0000
@@ -1,55 +0,0 @@
-MapServer MapScript Modules
-===========================
-
-Much of MapServer's functionality is accessible from Java, Perl, PHP, Python,
-Ruby, C#, and Tcl.  MapScript is not a language like JavaScript or Python. It
-is a loadable module that brings MapServer capabilities to your favorite high
-level programming language.
-
-PHP and SWIG Branches of MapScript
-----------------------------------
-
-The MapScript family tree looks like this:
-
-::
-
-               MapServer
-                  /\ 
-                 /  \    
-                /    \ 
-     PHPMapScript     \  SWIGMapScript
-         PHP5/7    +----+-----+----+----+--+----+------------+
-                   |    |     |    |    |  |    |            |
-                 Perl Python Ruby Java C# Tcl  PHP7 (PHPNG) ...
-                 
-
-
-The SWIGMapScript modules are generated by `SWIG <http://www.swig.org>`_. 
-The PHPMapScript module is developed using the PHP C API without using SWIG. 
-PHP users therefore have a choice of using the SWIG generated module or the 
-custom written PHP module. 
-
-PHPMapScript
-------------
-
-Source code, detailed installation instructions are located in the ``mapscript/php``
-folder. Documentation can be found in the `PHP MapScript Documentation <https://www.mapserver.org/mapscript/php/index.html>`_
-section. 
-
-SWIG MapScript
---------------
-
-Installation instructions are located in the individual languages
-directories such as ``mapscript/perl``, ``mapscript/python``. 
-
-The main MapScript SWIG interface file is ``mapscript/mapscript.i``.  This
-file includes specific class interface files from ``mapscript/swiginc`` and
-language specific code from the language directories.
-
-Note the **v8** folder contains files for `V8 MapScript Support <https://mapserver.org/installation/v8.html>`_. 
-This is not a JavaScript version of MapScript, but provides support for the use of JavaScript
-in `STYLEITEM <https://mapserver.org/mapfile/styleitem.html#styleitemjs>`_ and 
-`GEOTRANSFORM <https://mapserver.org/mapfile/geomtransform.html#geomtransformjs>`_. 
-
-API Documentation can be found at the `Shared SWIG MapScript Documentation <https://mapserver.org/mapscript/index.html>`_ 
-page. 
diff -pruN 8.0.1-5/mapscript/php/README 8.0.2-1/mapscript/php/README
--- 8.0.1-5/mapscript/php/README	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapscript/php/README	1970-01-01 00:00:00.000000000 +0000
@@ -1,4 +0,0 @@
-Old native (and unmaintained) PHP MapScript was removed for the 
-MapServer 8.0 release.  Please see the /mapscript/phpng/ folder 
-for the maintained PHP MapScript support through SWIG, or the 
-documentation at https://mapserver.org/mapscript/mapscript.html .
diff -pruN 8.0.1-5/mapscript/php/README.md 8.0.2-1/mapscript/php/README.md
--- 8.0.1-5/mapscript/php/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 8.0.2-1/mapscript/php/README.md	2024-06-11 20:41:34.000000000 +0000
@@ -0,0 +1,4 @@
+Old native (and unmaintained) PHP MapScript was removed for the 
+MapServer 8.0 release.  Please see the /mapscript/phpng/ folder 
+for the maintained PHP MapScript support through SWIG, or the 
+documentation at https://mapserver.org/mapscript/mapscript.html .
diff -pruN 8.0.1-5/mapscript/python/CMakeLists.txt 8.0.2-1/mapscript/python/CMakeLists.txt
--- 8.0.1-5/mapscript/python/CMakeLists.txt	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapscript/python/CMakeLists.txt	2024-06-11 20:41:34.000000000 +0000
@@ -10,8 +10,9 @@ include_directories(${PROJECT_SOURCE_DIR
 
 set(SwigFile ${PROJECT_SOURCE_DIR}/mapscript/mapscript.i)
 
-# add annotations to py file output - requires >= SWIG 4.1
+# add and comments annotations to py file output - requires >= SWIG 4.1
 if (WITH_PYMAPSCRIPT_ANNOTATIONS AND ${Python_VERSION_MAJOR} GREATER_EQUAL 3)
+  set_property(SOURCE ${SwigFile} APPEND PROPERTY SWIG_FLAGS -doxygen)
   if (${Python_VERSION_MINOR} GREATER_EQUAL 6)
      set_property(SOURCE ${SwigFile} APPEND PROPERTY SWIG_FLAGS -features python:annotations=c)
   else ()
diff -pruN 8.0.1-5/mapscript/python/examples/project_csv.py 8.0.2-1/mapscript/python/examples/project_csv.py
--- 8.0.1-5/mapscript/python/examples/project_csv.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapscript/python/examples/project_csv.py	2024-06-11 20:41:34.000000000 +0000
@@ -9,9 +9,10 @@ project_csv.py cities.csv 2 1 EPSG:4326
 
 """
 
-import sys
 import csv
+import sys
 from io import open
+
 import mapscript
 
 
@@ -22,7 +23,7 @@ def main(input_file, x_field_idx, y_fiel
     proj_out = mapscript.projectionObj(output_proj)
 
     # open file
-    with open(input_file, encoding='utf-8') as f:
+    with open(input_file, encoding="utf-8") as f:
         # read csv
         csv_in = csv.reader(f)
         headers = next(csv_in)
@@ -48,13 +49,16 @@ def usage():
     """
     Display usage if program is used incorrectly
     """
-    print("Syntax: %s <csvfile> <x_col> <y_col> <epsg_code_in> <epsg_code_out>" % sys.argv[0])
+    print(
+        "Syntax: %s <csvfile> <x_col> <y_col> <epsg_code_in> <epsg_code_out>"
+        % sys.argv[0]
+    )
     sys.exit(2)
 
 
 # check input parameters
 
-if (len(sys.argv) != 6):
+if len(sys.argv) != 6:
     usage()
 
 
@@ -67,6 +71,6 @@ y_field_idx = int(sys.argv[3])
 
 # get projection codes
 
-input_proj = "init="+sys.argv[4].lower()
-output_proj = "init="+sys.argv[5].lower()
+input_proj = "init=" + sys.argv[4].lower()
+output_proj = "init=" + sys.argv[5].lower()
 main(input_file, x_field_idx, y_field_idx, input_proj, output_proj)
diff -pruN 8.0.1-5/mapscript/python/examples/shpdump.py 8.0.2-1/mapscript/python/examples/shpdump.py
--- 8.0.1-5/mapscript/python/examples/shpdump.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapscript/python/examples/shpdump.py	2024-06-11 20:41:34.000000000 +0000
@@ -9,9 +9,10 @@ python shpdump.py polygon.shp
 
 """
 
-import mapscript
-import sys
 import os
+import sys
+
+import mapscript
 
 
 def plural(x):
@@ -21,8 +22,8 @@ def plural(x):
     Useful in print statements to avoid something like 'point(s)'
     """
     if x > 1:
-        return 's'
-    return ''
+        return "s"
+    return ""
 
 
 def get_shapefile_object(sf_path):
@@ -56,7 +57,15 @@ def main(sf_path):
         # get the object at index i
         sf_obj.get(i, s_obj)
         print("Shape %i has %i part%s" % (i, s_obj.numlines, plural(s_obj.numlines)))
-        print("Bounds (%f, %f) (%f, %f)" % (s_obj.bounds.minx, s_obj.bounds.miny, s_obj.bounds.maxx, s_obj.bounds.maxy))
+        print(
+            "Bounds (%f, %f) (%f, %f)"
+            % (
+                s_obj.bounds.minx,
+                s_obj.bounds.miny,
+                s_obj.bounds.maxx,
+                s_obj.bounds.maxy,
+            )
+        )
 
         # loop through parts of each shape
 
@@ -65,7 +74,9 @@ def main(sf_path):
             # get the jth part of the ith object
 
             part = s_obj.get(j)
-            print("Part %i has %i point%s" % (j, part.numpoints, plural(part.numpoints)))
+            print(
+                "Part %i has %i point%s" % (j, part.numpoints, plural(part.numpoints))
+            )
 
             # loop through points in each part
 
diff -pruN 8.0.1-5/mapscript/python/examples/shpinfo.py 8.0.2-1/mapscript/python/examples/shpinfo.py
--- 8.0.1-5/mapscript/python/examples/shpinfo.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapscript/python/examples/shpinfo.py	2024-06-11 20:41:34.000000000 +0000
@@ -8,9 +8,10 @@ Usage:
 python shpinfo.py point.shp
 
 """
-import mapscript
-import sys
 import os
+import sys
+
+import mapscript
 
 
 def get_shapefile_object(sf_path):
@@ -31,30 +32,33 @@ def get_shapefile_details(sf_obj):
     # dictionary of shapefile types
 
     types = {
-              mapscript.MS_SHAPEFILE_POINT: 'Point',
-              mapscript.MS_SHAPEFILE_ARC: 'Line',
-              mapscript.MS_SHAPEFILE_POLYGON: 'Polygon',
-              mapscript.MS_SHAPEFILE_MULTIPOINT: 'Multipoint',
-
-              mapscript.MS_SHP_POINTZ: 'PointZ',
-              mapscript.MS_SHP_ARCZ: 'LineZ',
-              mapscript.MS_SHP_POLYGONZ: 'PolygonZ',
-              mapscript.MS_SHP_MULTIPOINTZ: 'MultipointZ',
-
-              mapscript.MS_SHP_POINTM: 'Multipoint',
-              mapscript.MS_SHP_ARCM: 'LineM',
-              mapscript.MS_SHP_POLYGONM: 'PolygonM',
-              mapscript.MS_SHP_MULTIPOINTM: 'MultipointM'
-            }
+        mapscript.MS_SHAPEFILE_POINT: "Point",
+        mapscript.MS_SHAPEFILE_ARC: "Line",
+        mapscript.MS_SHAPEFILE_POLYGON: "Polygon",
+        mapscript.MS_SHAPEFILE_MULTIPOINT: "Multipoint",
+        mapscript.MS_SHP_POINTZ: "PointZ",
+        mapscript.MS_SHP_ARCZ: "LineZ",
+        mapscript.MS_SHP_POLYGONZ: "PolygonZ",
+        mapscript.MS_SHP_MULTIPOINTZ: "MultipointZ",
+        mapscript.MS_SHP_POINTM: "Multipoint",
+        mapscript.MS_SHP_ARCM: "LineM",
+        mapscript.MS_SHP_POLYGONM: "PolygonM",
+        mapscript.MS_SHP_MULTIPOINTM: "MultipointM",
+    }
 
     # print out basic information that is part of the shapefile object
 
     print("\tType: %s" % types[sf_obj.type])
 
-    print("\tBounds: (%f, %f) (%f, %f)" % (sf_obj.bounds.minx,
-                                           sf_obj.bounds.miny,
-                                           sf_obj.bounds.maxx,
-                                           sf_obj.bounds.maxy))
+    print(
+        "\tBounds: (%f, %f) (%f, %f)"
+        % (
+            sf_obj.bounds.minx,
+            sf_obj.bounds.miny,
+            sf_obj.bounds.maxx,
+            sf_obj.bounds.maxy,
+        )
+    )
 
     print("\tNumber of features: %i" % sf_obj.numshapes)
 
@@ -70,14 +74,21 @@ def get_dbf_details(sf_obj):
     print("\tNumber of records in DBF: %i" % dbf_obj.nRecords)
     print("\tNumber of fields: %i" % dbf_obj.nFields)
     print("")
-    print("\t%-20s %12s %8s %10s" % ("Name", "Type",  "Length", "Decimals"))
+    print("\t%-20s %12s %8s %10s" % ("Name", "Type", "Length", "Decimals"))
     print("\t-----------------------------------------------------")
 
     # print out field characteristics
 
     for idx in range(0, dbf_obj.nFields):
-        print("\t%-20s %12s %8d %10d" % (dbf_obj.getFieldName(idx), dbf_obj.getFieldType(idx),
-                                         dbf_obj.getFieldWidth(idx), dbf_obj.getFieldDecimals(idx)))
+        print(
+            "\t%-20s %12s %8d %10d"
+            % (
+                dbf_obj.getFieldName(idx),
+                dbf_obj.getFieldType(idx),
+                dbf_obj.getFieldWidth(idx),
+                dbf_obj.getFieldDecimals(idx),
+            )
+        )
 
 
 def main(sf_path):
diff -pruN 8.0.1-5/mapscript/python/examples/wxs.py 8.0.2-1/mapscript/python/examples/wxs.py
--- 8.0.1-5/mapscript/python/examples/wxs.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapscript/python/examples/wxs.py	2024-06-11 20:41:34.000000000 +0000
@@ -10,6 +10,7 @@ python wxs.py test.map
 """
 import sys
 import xml.dom.minidom
+
 import mapscript
 
 
@@ -36,8 +37,10 @@ def main(map_file):
     result = mapscript.msIO_getStdoutBufferBytes()
 
     # [('Content-Type', 'application/vnd.ogc.wms_xml; charset=UTF-8'), ('Content-Length', '11385')]
-    response_headers = [('Content-Type', content_type),
-                        ('Content-Length', str(len(result)))]
+    response_headers = [
+        ("Content-Type", content_type),
+        ("Content-Length", str(len(result))),
+    ]
 
     assert int(response_headers[1][1]) > 0
 
diff -pruN 8.0.1-5/mapscript/python/mapscript/__init__.py 8.0.2-1/mapscript/python/mapscript/__init__.py
--- 8.0.1-5/mapscript/python/mapscript/__init__.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapscript/python/mapscript/__init__.py	2024-06-11 20:41:34.000000000 +0000
@@ -1,7 +1,7 @@
-import sys
-import platform
-import os
 import inspect
+import os
+import platform
+import sys
 
 # As of Python 3.8 PATH can no longer be used to resolve the MapServer
 # DLLs on Windows. Instead users will be required to set a new MAPSERVER_DLL_PATH
@@ -17,27 +17,26 @@ def add_dll_path(pth):
         os.add_dll_directory(pth)
     else:
         # add the directory to the Windows path for earlier Python version
-        os.environ['PATH'] = pth + ';' + os.environ['PATH']
+        os.environ["PATH"] = pth + ";" + os.environ["PATH"]
 
 
-if platform.system() == 'Windows':
-    mapserver_dll_path = os.getenv('MAPSERVER_DLL_PATH', '')
-    dll_paths = list(filter(os.path.exists, mapserver_dll_path.split(';')))
+if platform.system() == "Windows":
+    mapserver_dll_path = os.getenv("MAPSERVER_DLL_PATH", "")
+    dll_paths = list(filter(os.path.exists, mapserver_dll_path.split(";")))
     # add paths in the order listed in the string
     dll_paths.reverse()
     for pth in dll_paths:
         add_dll_path(pth)
 
 
-from .mapscript import *
-
+from .mapscript import *  # NOQA
 
 # change all the class module names from mapscript.mapscript to mapscript
 
 for key, value in globals().copy().items():
-    if inspect.isclass(value) and value.__module__.startswith('mapscript.'):
-        value.__module__= 'mapscript'
+    if inspect.isclass(value) and value.__module__.startswith("mapscript."):
+        value.__module__ = "mapscript"
 
 # remove the submodule name
 
-del mapscript
+del mapscript  # NOQA
diff -pruN 8.0.1-5/mapscript/python/tests/cases/class_test.py 8.0.2-1/mapscript/python/tests/cases/class_test.py
--- 8.0.1-5/mapscript/python/tests/cases/class_test.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapscript/python/tests/cases/class_test.py	2024-06-11 20:41:34.000000000 +0000
@@ -25,12 +25,13 @@
 # ===========================================================================
 
 import unittest
+
 import mapscript
+
 from .testing import MapTestCase
 
 
 class ClassObjTestCase(unittest.TestCase):
-
     def testConstructorNoArg(self):
         c = mapscript.classObj()
         assert c.thisown == 1
@@ -39,7 +40,7 @@ class ClassObjTestCase(unittest.TestCase
 
     def testConstructorWithArg(self):
         lyr = mapscript.layerObj()
-        lyr.name = 'foo'
+        lyr.name = "foo"
         c = mapscript.classObj(lyr)
         assert c.thisown == 1
         assert c.layer.name == lyr.name
@@ -48,14 +49,14 @@ class ClassObjTestCase(unittest.TestCase
     def testGetSetAttributes(self):
         c = mapscript.classObj()
 
-        val = '/tmp/legend.png'
+        val = "/tmp/legend.png"
         c.keyimage = val
         assert c.keyimage == val
 
         c.debug = mapscript.MS_TRUE
         assert c.debug == mapscript.MS_TRUE
 
-        val = 'Group1'
+        val = "Group1"
         c.group = val
         assert c.group == val
 
@@ -71,24 +72,23 @@ class ClassObjTestCase(unittest.TestCase
         c.minscaledenom = val
         assert c.minscaledenom == val
 
-        val = 'Class1'
+        val = "Class1"
         c.name = val
         assert c.name == val
 
         c.status = mapscript.MS_OFF
         assert c.status == mapscript.MS_OFF
 
-        val = 'template.html'
+        val = "template.html"
         c.template = val
         assert c.template == val
 
-        val = 'Title1'
+        val = "Title1"
         c.title = val
         assert c.title == val
 
 
 class ClassCloningTestCase(unittest.TestCase):
-
     def testCloneClass(self):
         """check attributes of a cloned class"""
         c = mapscript.classObj()
@@ -103,42 +103,42 @@ class ClassIconTestCase(MapTestCase):
     """testing for bug 1250"""
 
     def testAlphaTransparentPixmap(self):
-        lo = self.map.getLayerByName('INLINE-PIXMAP-RGBA')
+        lo = self.map.getLayerByName("INLINE-PIXMAP-RGBA")
         co = lo.getClass(0)
-        self.map.selectOutputFormat('PNG')
+        self.map.selectOutputFormat("PNG")
         im = co.createLegendIcon(self.map, lo, 48, 48)
-        im.save('testAlphaTransparentPixmapIcon.png')
+        im.save("testAlphaTransparentPixmapIcon.png")
 
     def testAlphaTransparentPixmapPNG24(self):
-        lo = self.map.getLayerByName('INLINE-PIXMAP-RGBA')
+        lo = self.map.getLayerByName("INLINE-PIXMAP-RGBA")
         co = lo.getClass(0)
-        self.map.selectOutputFormat('PNG24')
+        self.map.selectOutputFormat("PNG24")
         im = co.createLegendIcon(self.map, lo, 48, 48)
-        im.save('testAlphaTransparentPixmapIcon24.png')
+        im.save("testAlphaTransparentPixmapIcon24.png")
 
     def testAlphaTransparentPixmapJPG(self):
-        lo = self.map.getLayerByName('INLINE-PIXMAP-RGBA')
+        lo = self.map.getLayerByName("INLINE-PIXMAP-RGBA")
         co = lo.getClass(0)
-        self.map.selectOutputFormat('JPEG')
+        self.map.selectOutputFormat("JPEG")
         im = co.createLegendIcon(self.map, lo, 48, 48)
-        im.save('testAlphaTransparentPixmapIcon.jpg')
+        im.save("testAlphaTransparentPixmapIcon.jpg")
 
     def testIndexedTransparentPixmap(self):
-        lo = self.map.getLayerByName('INLINE-PIXMAP-PCT')
+        lo = self.map.getLayerByName("INLINE-PIXMAP-PCT")
         lo.type = mapscript.MS_LAYER_POINT
         co = lo.getClass(0)
-        self.map.selectOutputFormat('PNG')
+        self.map.selectOutputFormat("PNG")
         im = co.createLegendIcon(self.map, lo, 32, 32)
-        im.save('testIndexedTransparentPixmapIcon.png')
+        im.save("testIndexedTransparentPixmapIcon.png")
 
     def testIndexedTransparentPixmapJPG(self):
-        lo = self.map.getLayerByName('INLINE-PIXMAP-PCT')
+        lo = self.map.getLayerByName("INLINE-PIXMAP-PCT")
         lo.type = mapscript.MS_LAYER_POINT
         co = lo.getClass(0)
-        self.map.selectOutputFormat('JPEG')
+        self.map.selectOutputFormat("JPEG")
         im = co.createLegendIcon(self.map, lo, 32, 32)
-        im.save('testIndexedTransparentPixmapIcon.jpg')
+        im.save("testIndexedTransparentPixmapIcon.jpg")
 
 
-if __name__ == '__main__':
+if __name__ == "__main__":
     unittest.main()
diff -pruN 8.0.1-5/mapscript/python/tests/cases/clone_test.py 8.0.2-1/mapscript/python/tests/cases/clone_test.py
--- 8.0.1-5/mapscript/python/tests/cases/clone_test.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapscript/python/tests/cases/clone_test.py	2024-06-11 20:41:34.000000000 +0000
@@ -25,7 +25,9 @@
 # ===========================================================================
 
 import unittest
+
 import mapscript
+
 from .testing import TESTMAPFILE
 
 
@@ -42,7 +44,6 @@ class MapCloneTestCase(unittest.TestCase
 
 
 class MapCloningTestCase(MapCloneTestCase):
-
     def testClonedName(self):
         """MapCloningTestCase.testClonedName: the name of a cloned map equals the original"""
         assert self.mapobj_clone.name == self.mapobj_orig.name
@@ -50,8 +51,7 @@ class MapCloningTestCase(MapCloneTestCas
     def testClonedLayers(self):
         """MapCloningTestCase.testClonedLayers: the layers of a cloned map equal the original"""
         assert self.mapobj_clone.numlayers == self.mapobj_orig.numlayers
-        assert self.mapobj_clone.getLayer(0).data \
-            == self.mapobj_orig.getLayer(0).data
+        assert self.mapobj_clone.getLayer(0).data == self.mapobj_orig.getLayer(0).data
 
     def testSetFontSet(self):
         """MapCloningTestCase.testSetFontSet: the number of fonts in a cloned map equal original"""
@@ -66,33 +66,33 @@ class MapCloningTestCase(MapCloneTestCas
         """drawing a cloned map works properly"""
         msimg = self.mapobj_clone.draw()
         assert msimg.thisown == 1
-        filename = 'testClone.png'
-        fh = open(filename, 'wb')
+        filename = "testClone.png"
+        fh = open(filename, "wb")
         msimg.write(fh)
         fh.close()
 
     def testDrawCloneJPEG(self):
         """drawing a cloned map works properly"""
-        self.mapobj_clone.selectOutputFormat('JPEG')
-        self.mapobj_clone.getLayerByName('INLINE-PIXMAP-RGBA').status = mapscript.MS_ON
+        self.mapobj_clone.selectOutputFormat("JPEG")
+        self.mapobj_clone.getLayerByName("INLINE-PIXMAP-RGBA").status = mapscript.MS_ON
         msimg = self.mapobj_clone.draw()
         assert msimg.thisown == 1
-        filename = 'testClone.jpg'
-        fh = open(filename, 'wb')
+        filename = "testClone.jpg"
+        fh = open(filename, "wb")
         msimg.write(fh)
         fh.close()
 
     def testDrawClonePNG24(self):
         """drawing a cloned map works properly"""
-        self.mapobj_clone.selectOutputFormat('PNG24')
-        self.mapobj_clone.getLayerByName('INLINE-PIXMAP-RGBA').status = mapscript.MS_ON
+        self.mapobj_clone.selectOutputFormat("PNG24")
+        self.mapobj_clone.getLayerByName("INLINE-PIXMAP-RGBA").status = mapscript.MS_ON
         msimg = self.mapobj_clone.draw()
         assert msimg.thisown == 1
-        filename = 'testClonePNG24.png'
-        fh = open(filename, 'wb')
+        filename = "testClonePNG24.png"
+        fh = open(filename, "wb")
         msimg.write(fh)
         fh.close()
 
 
-if __name__ == '__main__':
+if __name__ == "__main__":
     unittest.main()
diff -pruN 8.0.1-5/mapscript/python/tests/cases/cluster_test.py 8.0.2-1/mapscript/python/tests/cases/cluster_test.py
--- 8.0.1-5/mapscript/python/tests/cases/cluster_test.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapscript/python/tests/cases/cluster_test.py	2024-06-11 20:41:34.000000000 +0000
@@ -25,18 +25,18 @@
 # ===========================================================================
 
 import unittest
+
 import mapscript
 
 
 class ClusterObjTestCase(unittest.TestCase):
-
     def testClusterObjUpdateFromString(self):
         """a cluster can be updated from a string"""
         c = mapscript.clusterObj()
         c.updateFromString("CLUSTER \n MAXDISTANCE 5 \n REGION \n 'rectangle' END")
 
         assert c.maxdistance == 5
-        assert c.region == 'rectangle'
+        assert c.region == "rectangle"
 
         s = c.convertToString()
         assert s == 'CLUSTER\n  MAXDISTANCE 5\n  REGION "rectangle"\nEND # CLUSTER\n'
@@ -44,17 +44,17 @@ class ClusterObjTestCase(unittest.TestCa
     def testClusterObjGetSetFilter(self):
         """a cluster filter can be set and read"""
         c = mapscript.clusterObj()
-        filter = '[attr1] > 5'
+        filter = "[attr1] > 5"
         c.setFilter(filter)
         assert '"{}"'.format(filter) == c.getFilterString()
 
     def testClusterObjGetSetGroup(self):
         """a cluster filter can be set and read"""
         c = mapscript.clusterObj()
-        exp = '100'  # TODO not sure what would be a relevant expression here
+        exp = "100"  # TODO not sure what would be a relevant expression here
         c.setGroup(exp)
         assert '"{}"'.format(exp) == c.getGroupString()
 
 
-if __name__ == '__main__':
+if __name__ == "__main__":
     unittest.main()
diff -pruN 8.0.1-5/mapscript/python/tests/cases/color_test.py 8.0.2-1/mapscript/python/tests/cases/color_test.py
--- 8.0.1-5/mapscript/python/tests/cases/color_test.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapscript/python/tests/cases/color_test.py	2024-06-11 20:41:34.000000000 +0000
@@ -25,11 +25,11 @@
 # ===========================================================================
 
 import unittest
+
 import mapscript
 
 
 class ColorObjTestCase(unittest.TestCase):
-
     def testColorObjConstructorNoArgs(self):
         """a color can be initialized with no arguments"""
         c = mapscript.colorObj()
@@ -43,7 +43,7 @@ class ColorObjTestCase(unittest.TestCase
     def testColorObjToHex(self):
         """a color can be outputted as hex"""
         c = mapscript.colorObj(255, 255, 255)
-        assert c.toHex() == '#ffffff'
+        assert c.toHex() == "#ffffff"
 
     def testColorObjToHexBadly(self):
         """raise an error in the case of an undefined color"""
@@ -59,20 +59,20 @@ class ColorObjTestCase(unittest.TestCase
     def testColorObjSetHexLower(self):
         """a color can be set using lower case hex"""
         c = mapscript.colorObj()
-        c.setHex('#ffffff64')
+        c.setHex("#ffffff64")
         assert (c.red, c.green, c.blue, c.alpha) == (255, 255, 255, 100)
 
     def testColorObjSetHexUpper(self):
         """a color can be set using upper case hex"""
         c = mapscript.colorObj()
-        c.setHex('#FFFFFF')
+        c.setHex("#FFFFFF")
         assert (c.red, c.green, c.blue) == (255, 255, 255)
 
     def testColorObjSetHexBadly(self):
         """invalid hex color string raises proper error"""
         c = mapscript.colorObj()
-        self.assertRaises(mapscript.MapServerError, c.setHex, '#fffffg')
+        self.assertRaises(mapscript.MapServerError, c.setHex, "#fffffg")
 
 
-if __name__ == '__main__':
+if __name__ == "__main__":
     unittest.main()
diff -pruN 8.0.1-5/mapscript/python/tests/cases/config_test.py 8.0.2-1/mapscript/python/tests/cases/config_test.py
--- 8.0.1-5/mapscript/python/tests/cases/config_test.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapscript/python/tests/cases/config_test.py	2024-06-11 20:41:34.000000000 +0000
@@ -25,12 +25,13 @@
 # ===========================================================================
 
 import unittest
+
 import mapscript
+
 from .testing import TESTCONFIGFILE
 
 
 class ConfigConstructorTestCase(unittest.TestCase):
-
     def testConfigConstructorFilenameArg(self):
         """ConfigConstructorTestCase.testConfigConstructorFilenameArg: map constructor with filename argument"""
         test_config = mapscript.configObj(TESTCONFIGFILE)
@@ -39,7 +40,6 @@ class ConfigConstructorTestCase(unittest
 
 
 class ConfigHashTableTests(unittest.TestCase):
-
     def testGetEnv(self):
 
         test_config = mapscript.configObj(TESTCONFIGFILE)
@@ -59,5 +59,5 @@ class ConfigHashTableTests(unittest.Test
         assert test_config.plugins.numitems == 0
 
 
-if __name__ == '__main__':
+if __name__ == "__main__":
     unittest.main()
diff -pruN 8.0.1-5/mapscript/python/tests/cases/font_test.py 8.0.2-1/mapscript/python/tests/cases/font_test.py
--- 8.0.1-5/mapscript/python/tests/cases/font_test.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapscript/python/tests/cases/font_test.py	2024-06-11 20:41:34.000000000 +0000
@@ -26,17 +26,17 @@
 
 import os
 import unittest
+
 import mapscript
+
 from .testing import TESTS_PATH
 
 
 class FontTestCase(unittest.TestCase):
-
     def testSettingFonts(self):
         mo = mapscript.mapObj()
         assert mo.fontset.numfonts == 0
-        mo.fontset.fonts.set('Vera', os.path.join(TESTS_PATH, 'vera',
-                                                  'Vera.ttf'))
+        mo.fontset.fonts.set("Vera", os.path.join(TESTS_PATH, "vera", "Vera.ttf"))
         # NB: this does *not* increment the fonset.numfonts -- new bug
 
         mo.setSize(300, 300)
@@ -50,14 +50,14 @@ class FontTestCase(unittest.TestCase):
         co = mapscript.classObj()
         lbl = mapscript.labelObj()
         lbl.type = mapscript.MS_TRUETYPE
-        lbl.font = 'Vera'
+        lbl.font = "Vera"
         lbl.size = 10
-        lbl.color.setHex('#000000')
+        lbl.color.setHex("#000000")
         co.addLabel(lbl)
 
         so = mapscript.styleObj()
         so.symbol = 0
-        so.color.setHex('#000000')
+        so.color.setHex("#000000")
 
         co.insertStyle(so)
         lo.insertClass(co)
@@ -70,7 +70,7 @@ class FontTestCase(unittest.TestCase):
         shape = mapscript.shapeObj(lo.type)
         shape.add(line)
         shape.setBounds()
-        shape.text = 'Foo'
+        shape.text = "Foo"
         shape.classindex = 0
 
         lo.addFeature(shape)
@@ -78,8 +78,8 @@ class FontTestCase(unittest.TestCase):
 
         # im = mo.prepareImage()
         # shape.draw(mo, lo, im)
-        im.save('testSettingFonts.png')
+        im.save("testSettingFonts.png")
 
 
-if __name__ == '__main__':
+if __name__ == "__main__":
     unittest.main()
diff -pruN 8.0.1-5/mapscript/python/tests/cases/hash_test.py 8.0.2-1/mapscript/python/tests/cases/hash_test.py
--- 8.0.1-5/mapscript/python/tests/cases/hash_test.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapscript/python/tests/cases/hash_test.py	2024-06-11 20:41:34.000000000 +0000
@@ -25,24 +25,26 @@
 # ===========================================================================
 
 import unittest
+
 import mapscript
-from .testing import MapTestCase
 
+from .testing import MapTestCase
 
 # ===========================================================================
 # Base class for hashtable tests.  Derived classes use these tests, but
 # defined different values for self.table.
 
+
 class HashTableBaseTestCase(object):
 
-    keys = ['key1', 'key2', 'key3', 'key4']
-    values = ['value1', 'value2', 'value3', 'value4']
+    keys = ["key1", "key2", "key3", "key4"]
+    values = ["value1", "value2", "value3", "value4"]
 
     def testUseNonExistentKey(self):
-        assert self.table.get('bogus') is None
+        assert self.table.get("bogus") is None
 
     def testUseNonExistentKeyWithDefault(self):
-        assert self.table.get('bogus', 'default') == 'default'
+        assert self.table.get("bogus", "default") == "default"
 
     def testGetValue(self):
         for key, value in zip(self.keys, self.values):
@@ -52,9 +54,9 @@ class HashTableBaseTestCase(object):
 
     def testGetValueWithDefault(self):
         for key, value in zip(self.keys, self.values):
-            assert self.table.get(key, 'foo') == value
-            assert self.table.get(key.upper(), 'foo') == value
-            assert self.table.get(key.capitalize(), 'foo') == value
+            assert self.table.get(key, "foo") == value
+            assert self.table.get(key.upper(), "foo") == value
+            assert self.table.get(key.capitalize(), "foo") == value
 
     def testClear(self):
         self.table.clear()
@@ -107,6 +109,7 @@ class HashTableBaseTestCase(object):
 # HashTable test case
 #
 
+
 class HashTableTestCase(unittest.TestCase, HashTableBaseTestCase):
     """Tests of the MapServer HashTable object"""
 
@@ -127,13 +130,13 @@ class HashTableTestCase(unittest.TestCas
 # ==============================================================================
 # following tests use the tests/test.map fixture
 
-class WebMetadataTestCase(MapTestCase, HashTableBaseTestCase):
 
+class WebMetadataTestCase(MapTestCase, HashTableBaseTestCase):
     def setUp(self):
         MapTestCase.setUp(self)
         self.table = self.map.web.metadata
-        self.keys = ['key1', 'key2', 'key3', 'key4', 'ows_enable_request']
-        self.values = ['value1', 'value2', 'value3', 'value4', '*']
+        self.keys = ["key1", "key2", "key3", "key4", "ows_enable_request"]
+        self.values = ["value1", "value2", "value3", "value4", "*"]
 
     def tearDown(self):
         MapTestCase.tearDown(self)
@@ -141,18 +144,16 @@ class WebMetadataTestCase(MapTestCase, H
 
 
 class LayerMetadataTestCase(WebMetadataTestCase):
-
     def setUp(self):
         MapTestCase.setUp(self)
         self.table = self.map.getLayer(1).metadata
 
 
 class ClassMetadataTestCase(WebMetadataTestCase):
-
     def setUp(self):
         MapTestCase.setUp(self)
         self.table = self.map.getLayer(1).getClass(0).metadata
 
 
-if __name__ == '__main__':
+if __name__ == "__main__":
     unittest.main()
diff -pruN 8.0.1-5/mapscript/python/tests/cases/image_test.py 8.0.2-1/mapscript/python/tests/cases/image_test.py
--- 8.0.1-5/mapscript/python/tests/cases/image_test.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapscript/python/tests/cases/image_test.py	2024-06-11 20:41:34.000000000 +0000
@@ -25,24 +25,25 @@
 # ===========================================================================
 
 import unittest
-from io import BytesIO
 import urllib
+from io import BytesIO
+
 import mapscript
+
 from .testing import TEST_IMAGE as test_image
 from .testing import MapTestCase
 
-
 have_image = False
 
 try:
     from PIL import Image
+
     have_image = True
 except ImportError:
     pass
 
 
 class ImageObjTestCase(unittest.TestCase):
-
     def testConstructor(self):
         """imageObj constructor works"""
         imgobj = mapscript.imageObj(10, 10)
@@ -52,7 +53,7 @@ class ImageObjTestCase(unittest.TestCase
 
     def testConstructorWithFormat(self):
         """imageObj with an optional driver works"""
-        driver = 'AGG/PNG'
+        driver = "AGG/PNG"
         format = mapscript.outputFormatObj(driver)
         imgobj = mapscript.imageObj(10, 10, format)
         assert imgobj.thisown == 1
@@ -66,7 +67,7 @@ class ImageObjTestCase(unittest.TestCase
         assert imgobj.thisown == 1
         assert imgobj.height == 200
         assert imgobj.width == 200
-        imgobj.save('testConstructorFilename.png')
+        imgobj.save("testConstructorFilename.png")
 
     def xtestConstructorFilenameDriver(self):
         """imageObj with a filename and a driver works"""
@@ -74,11 +75,11 @@ class ImageObjTestCase(unittest.TestCase
         assert imgobj.thisown == 1
         assert imgobj.height == 200
         assert imgobj.width == 200
-        imgobj.save('testConstructorFilenameDriver.png')
+        imgobj.save("testConstructorFilenameDriver.png")
 
     def xtestConstructorStream(self):
         """imageObj with a file stream works"""
-        f = open(test_image, 'rb')
+        f = open(test_image, "rb")
         imgobj = mapscript.imageObj(f)
         f.close()
         assert imgobj.thisown == 1
@@ -87,7 +88,7 @@ class ImageObjTestCase(unittest.TestCase
 
     def xtestConstructorBytesIO(self):
         """imageObj with a BytesIO works"""
-        with open(test_image, 'rb') as f:
+        with open(test_image, "rb") as f:
             data = f.read()
         s = BytesIO(data)
         imgobj = mapscript.imageObj(s)
@@ -97,29 +98,28 @@ class ImageObjTestCase(unittest.TestCase
 
     def xtestConstructorUrlStream(self):
         """imageObj with a URL stream works"""
-        url = urllib.urlopen('http://mapserver.org/_static/banner.png')
-        imgobj = mapscript.imageObj(url, 'AGG/JPEG')
+        url = urllib.urlopen("http://mapserver.org/_static/banner.png")
+        imgobj = mapscript.imageObj(url, "AGG/JPEG")
         assert imgobj.thisown == 1
         assert imgobj.height == 68
         assert imgobj.width == 439
-        imgobj.save('testConstructorUrlStream.jpg')
+        imgobj.save("testConstructorUrlStream.jpg")
 
 
 class ImageWriteTestCase(MapTestCase):
-
     def testImageWrite(self):
         """image writes data to an open filehandle"""
         image = self.map.draw()
         assert image.thisown == 1
-        filename = 'testImageWrite.png'
-        fh = open(filename, 'wb')
+        filename = "testImageWrite.png"
+        fh = open(filename, "wb")
         image.write(fh)
         fh.close()
         if have_image:
             pyimg = Image.open(filename)
-            assert pyimg.format == 'PNG'
+            assert pyimg.format == "PNG"
             assert pyimg.size == (200, 200)
-            assert pyimg.mode == 'RGB'
+            assert pyimg.mode == "RGB"
 
     def testImageWriteBytesIO(self):
         """image writes data to a BytesIO instance"""
@@ -129,14 +129,14 @@ class ImageWriteTestCase(MapTestCase):
         s = BytesIO()
         image.write(s)
 
-        filename = 'testImageWriteBytesIO.png'
-        with open(filename, 'wb') as fh:
+        filename = "testImageWriteBytesIO.png"
+        with open(filename, "wb") as fh:
             fh.write(s.getvalue())
         if have_image:
             pyimg = Image.open(filename)
-            assert pyimg.format == 'PNG'
+            assert pyimg.format == "PNG"
             assert pyimg.size == (200, 200)
-            assert pyimg.mode == 'RGB'
+            assert pyimg.mode == "RGB"
 
     def testImageGetBytes(self):
         """image returns bytes"""
@@ -145,15 +145,15 @@ class ImageWriteTestCase(MapTestCase):
 
         s = BytesIO(image.getBytes())
 
-        filename = 'testImageGetBytes.png'
-        with open(filename, 'wb') as fh:
+        filename = "testImageGetBytes.png"
+        with open(filename, "wb") as fh:
             fh.write(s.getvalue())
         if have_image:
             pyimg = Image.open(filename)
-            assert pyimg.format == 'PNG'
+            assert pyimg.format == "PNG"
             assert pyimg.size == (200, 200)
-            assert pyimg.mode == 'RGB'
+            assert pyimg.mode == "RGB"
 
 
-if __name__ == '__main__':
+if __name__ == "__main__":
     unittest.main()
diff -pruN 8.0.1-5/mapscript/python/tests/cases/label_test.py 8.0.2-1/mapscript/python/tests/cases/label_test.py
--- 8.0.1-5/mapscript/python/tests/cases/label_test.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapscript/python/tests/cases/label_test.py	2024-06-11 20:41:34.000000000 +0000
@@ -25,32 +25,34 @@
 # ===========================================================================
 
 import unittest
+
 import mapscript
+
 from .testing import MapTestCase
 
 
 class NewLabelsTestCase(MapTestCase):
-
     def testLabelBinding(self):
         """attribute binding can be set and get"""
         new_label = mapscript.labelObj()
-        assert (not new_label.getBinding(mapscript.MS_LABEL_BINDING_COLOR))
+        assert not new_label.getBinding(mapscript.MS_LABEL_BINDING_COLOR)
         new_label.setBinding(mapscript.MS_LABEL_BINDING_COLOR, "NEW_BINDING")
-        assert (new_label.getBinding(mapscript.MS_LABEL_BINDING_COLOR) == "NEW_BINDING")
+        assert new_label.getBinding(mapscript.MS_LABEL_BINDING_COLOR) == "NEW_BINDING"
 
 
 class LabelCacheMemberTestCase(MapTestCase):
-
     def testCacheMemberText(self):
         """string attribute has been renamed to 'text' (bug 852)"""
-        lo = self.map.getLayerByName('POINT')
+        lo = self.map.getLayerByName("POINT")
         lo.status = mapscript.MS_ON
         img = self.map.draw()
         assert img is not None
-        assert self.map.labelcache.num_rendered_members == 1, self.map.labelcache.num_rendered_members
+        assert (
+            self.map.labelcache.num_rendered_members == 1
+        ), self.map.labelcache.num_rendered_members
         # label = self.map.nextLabel()
         # assert label.text == 'A Point', label.text
 
 
-if __name__ == '__main__':
+if __name__ == "__main__":
     unittest.main()
diff -pruN 8.0.1-5/mapscript/python/tests/cases/layer_test.py 8.0.2-1/mapscript/python/tests/cases/layer_test.py
--- 8.0.1-5/mapscript/python/tests/cases/layer_test.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapscript/python/tests/cases/layer_test.py	2024-06-11 20:41:34.000000000 +0000
@@ -26,19 +26,19 @@
 
 import unittest
 from random import random
+
 import mapscript
+
 from .testing import MapTestCase
 
 
 class MapLayerTestCase(MapTestCase):
-
     def setUp(self):
         MapTestCase.setUp(self)
         self.layer = self.map.getLayer(1)
 
 
 class LayerConstructorTestCase(MapLayerTestCase):
-
     def testLayerConstructorNoArg(self):
         """test layer constructor with no argument"""
         layer = mapscript.layerObj()
@@ -52,17 +52,16 @@ class LayerConstructorTestCase(MapLayerT
         layer = mapscript.layerObj(self.map)
         assert layer.__class__.__name__ == "layerObj"
         assert layer.thisown == 1
-        lyr = self.map.getLayer(self.map.numlayers-1)
+        lyr = self.map.getLayer(self.map.numlayers - 1)
         assert lyr is not None
         # assert str(layer) == str(lyr) # TODO - check why these are not equal
         assert layer.map is not None, layer.map
 
 
 class LayerItemDefinitionTestCase(MapLayerTestCase):
-
     def setUp(self):
         MapTestCase.setUp(self)
-        self.layer = self.map.getLayerByName('POINT')
+        self.layer = self.map.getLayerByName("POINT")
         self.layer.open()
 
     def tearDown(self):
@@ -94,7 +93,7 @@ class LayerItemDefinitionTestCase(MapLay
     def testLayerGetNonDefinedItemType(self):
         """test getting layer item information for a layer with gml_types auto"""
 
-        layer = self.map.getLayerByName('POLYGON')
+        layer = self.map.getLayerByName("POLYGON")
         layer.open()
         item_type = layer.getItemType(0)
         assert item_type == ""
@@ -102,7 +101,6 @@ class LayerItemDefinitionTestCase(MapLay
 
 
 class LayerCloningTestCase(MapLayerTestCase):
-
     def testLayerCloning(self):
         """check attributes of a cloned layer"""
         clone = self.layer.clone()
@@ -115,10 +113,9 @@ class LayerCloningTestCase(MapLayerTestC
 
 
 class LayerExtentTestCase(MapTestCase):
-
     def setUp(self):
         MapTestCase.setUp(self)
-        self.layer = self.map.getLayerByName('POLYGON')
+        self.layer = self.map.getLayerByName("POLYGON")
 
     def testPolygonExtent(self):
         """retrieve the extent of a polygon layer"""
@@ -142,13 +139,13 @@ class LayerExtentTestCase(MapTestCase):
 
     def testResetLayerExtent(self):
         """test resetting a layer's extent"""
-        layer = self.map.getLayerByName('POLYGON')
+        layer = self.map.getLayerByName("POLYGON")
         layer.setExtent()
         self.assertRectsEqual(layer.extent, mapscript.rectObj())
 
     def testDirectExtentAccess(self):
         """direct access to a layer's extent works properly"""
-        pt_layer = self.map.getLayerByName('POINT')
+        pt_layer = self.map.getLayerByName("POINT")
         rect = pt_layer.extent
         assert str(pt_layer.extent) == str(rect), (pt_layer.extent, rect)
         e = mapscript.rectObj(-0.5, 51.0, 0.5, 52.0)
@@ -156,28 +153,27 @@ class LayerExtentTestCase(MapTestCase):
 
 
 class LayerRasterProcessingTestCase(MapLayerTestCase):
-
     def testAddProcessing(self):
         """adding a layer's processing directive works"""
-        self.layer.addProcessing('directive0=foo')
+        self.layer.addProcessing("directive0=foo")
         assert self.layer.numprocessing == 1, self.layer.numprocessing
-        self.layer.addProcessing('directive1=bar')
+        self.layer.addProcessing("directive1=bar")
         assert self.layer.numprocessing == 2, self.layer.numprocessing
-        directives = [self.layer.getProcessing(i)
-                      for i in range(self.layer.numprocessing)]
-        assert directives == ['directive0=foo', 'directive1=bar']
+        directives = [
+            self.layer.getProcessing(i) for i in range(self.layer.numprocessing)
+        ]
+        assert directives == ["directive0=foo", "directive1=bar"]
 
     def testClearProcessing(self):
         """clearing a self.layer's processing directive works"""
-        self.layer.addProcessing('directive0=foo')
+        self.layer.addProcessing("directive0=foo")
         assert self.layer.numprocessing == 1, self.layer.numprocessing
-        self.layer.addProcessing('directive1=bar')
+        self.layer.addProcessing("directive1=bar")
         assert self.layer.numprocessing == 2, self.layer.numprocessing
         assert self.layer.clearProcessing() == mapscript.MS_SUCCESS
 
 
 class RemoveClassTestCase(MapLayerTestCase):
-
     def testRemoveClass1NumClasses(self):
         """RemoveClassTestCase.testRemoveClass1NumClasses: removing the layer's first class
         by index leaves one class left"""
@@ -202,7 +198,7 @@ class RemoveClassTestCase(MapLayerTestCa
 
     def testRemoveClass2ClassName(self):
         """RemoveClassTestCase.testRemoveClass2ClassName: confirm removing the layer's second class reverts
-         the name of the first class"""
+        the name of the first class"""
         c1name = self.layer.getClass(0).name
         c = self.layer.removeClass(1)
         assert c is not None
@@ -210,12 +206,11 @@ class RemoveClassTestCase(MapLayerTestCa
 
 
 class InsertClassTestCase(MapLayerTestCase):
-
     def testLayerInsertClass(self):
         """insert class at default index"""
         n = self.layer.numclasses
         new_class = mapscript.classObj()
-        new_class.name = 'foo'
+        new_class.name = "foo"
         new_index = self.layer.insertClass(new_class)
         assert new_index == n
         assert self.layer.numclasses == n + 1
@@ -227,7 +222,7 @@ class InsertClassTestCase(MapLayerTestCa
         """insert class at index 0"""
         n = self.layer.numclasses
         new_class = mapscript.classObj()
-        new_class.name = 'foo'
+        new_class.name = "foo"
         new_index = self.layer.insertClass(new_class, 0)
         assert new_index == 0
         assert self.layer.numclasses == n + 1
@@ -237,8 +232,7 @@ class InsertClassTestCase(MapLayerTestCa
 
     def testInsertNULLClass(self):
         """inserting NULL class should raise an error"""
-        self.assertRaises(mapscript.MapServerChildError,
-                          self.layer.insertClass, None)
+        self.assertRaises(mapscript.MapServerChildError, self.layer.insertClass, None)
 
 
 class LayerTestCase(MapTestCase):
@@ -259,11 +253,11 @@ class LayerTestCase(MapTestCase):
         order = self.map.getLayerOrder()
         assert order == ord, order
 
+
 # Layer removal tests
 
 
 class RemoveLayerTestCase(MapTestCase):
-
     def testRemoveLayer1NumLayers(self):
         """removing the first layer by index from the mapfile leaves three"""
         self.map.removeLayer(0)
@@ -288,18 +282,17 @@ class RemoveLayerTestCase(MapTestCase):
 
 
 class ExpressionTestCase(MapLayerTestCase):
-
     def testClearExpression(self):
         """layer expression can be properly cleared"""
-        self.layer.setFilter('')
+        self.layer.setFilter("")
         fs = self.layer.getFilterString()
         assert fs is None, fs
 
     def testSetStringExpression(self):
         """layer expression can be set to string"""
-        self.layer.setFilter('foo')
+        self.layer.setFilter("foo")
         fs = self.layer.getFilterString()
-        self.layer.filteritem = 'fid'
+        self.layer.filteritem = "fid"
         assert fs == '"foo"', fs
         self.map.draw()
 
@@ -307,23 +300,23 @@ class ExpressionTestCase(MapLayerTestCas
         """layer expression string can be quoted"""
         self.layer.setFilter('"foo"')
         fs = self.layer.getFilterString()
-        self.layer.filteritem = 'fid'
+        self.layer.filteritem = "fid"
         assert fs == '"foo"', fs
         self.map.draw()
 
     def testSetRegularExpression(self):
         """layer expression can be regular expression"""
-        self.layer.setFilter('/foo/')
-        self.layer.filteritem = 'fid'
+        self.layer.setFilter("/foo/")
+        self.layer.filteritem = "fid"
         fs = self.layer.getFilterString()
-        assert fs == '/foo/', fs
+        assert fs == "/foo/", fs
         self.map.draw()
 
     def testSetLogicalExpression(self):
         """layer expression can be logical expression"""
-        self.layer.setFilter('([fid] >= 2)')
+        self.layer.setFilter("([fid] >= 2)")
         fs = self.layer.getFilterString()
-        assert fs == '([fid] >= 2)', fs
+        assert fs == "([fid] >= 2)", fs
         self.map.draw()
 
     def testSetCompoundLogicalExpression(self):
@@ -338,15 +331,13 @@ class ExpressionTestCase(MapLayerTestCas
 
 
 class LayerQueryTestCase(MapLayerTestCase):
-
     def setUp(self):
         MapLayerTestCase.setUp(self)
-        self.layer = self.map.getLayerByName('POINT')
-        self.layer.template = 'foo'
+        self.layer = self.map.getLayerByName("POINT")
+        self.layer.template = "foo"
 
 
 class SpatialLayerQueryTestCase(LayerQueryTestCase):
-
     def testRectQuery(self):
         qrect = mapscript.rectObj(-10.0, 45.0, 10.0, 55.0)
         self.layer.queryByRect(self.map, qrect)
@@ -381,31 +372,34 @@ class SpatialLayerQueryTestCase(LayerQue
 
 
 class AttributeLayerQueryTestCase(LayerQueryTestCase):
-
     def testAttributeQuery(self):
-        self.layer.queryByAttributes(self.map, "FNAME", '"A Point"',
-                                     mapscript.MS_MULTIPLE)
+        self.layer.queryByAttributes(
+            self.map, "FNAME", '"A Point"', mapscript.MS_MULTIPLE
+        )
         assert self.layer.getNumResults() == 1
 
     def testLogicalAttributeQuery(self):
-        self.layer.queryByAttributes(self.map, None, '("[FNAME]" == "A Point")',
-                                     mapscript.MS_MULTIPLE)
+        self.layer.queryByAttributes(
+            self.map, None, '("[FNAME]" == "A Point")', mapscript.MS_MULTIPLE
+        )
         assert self.layer.getNumResults() == 1
 
     def testAttributeQueryNoResults(self):
-        self.layer.queryByAttributes(self.map, "FNAME", '"Bogus Point"',
-                                     mapscript.MS_MULTIPLE)
+        self.layer.queryByAttributes(
+            self.map, "FNAME", '"Bogus Point"', mapscript.MS_MULTIPLE
+        )
         assert self.layer.getNumResults() == 0
 
 
 class LayerVisibilityTestCase(MapLayerTestCase):
-
     def setUp(self):
         MapLayerTestCase.setUp(self)
         self.layer.minscaledenom = 1000
         self.layer.maxscaledenom = 2000
         self.layer.status = mapscript.MS_ON
-        self.map.zoomScale(1500, mapscript.pointObj(100, 100), 200, 200, self.map.extent, None)
+        self.map.zoomScale(
+            1500, mapscript.pointObj(100, 100), 200, 200, self.map.extent, None
+        )
 
     def testInitialVisibility(self):
         """expect visibility"""
@@ -418,12 +412,13 @@ class LayerVisibilityTestCase(MapLayerTe
 
     def testZoomOutVisibility(self):
         """expect false visibility after zooming out beyond maximum"""
-        self.map.zoomScale(2500, mapscript.pointObj(100, 100), 200, 200, self.map.extent, None)
+        self.map.zoomScale(
+            2500, mapscript.pointObj(100, 100), 200, 200, self.map.extent, None
+        )
         assert self.layer.isVisible() == mapscript.MS_FALSE
 
 
 class InlineLayerTestCase(unittest.TestCase):
-
     def setUp(self):
         # Inline feature layer
         self.ilayer = mapscript.layerObj()
@@ -431,8 +426,8 @@ class InlineLayerTestCase(unittest.TestC
         self.ilayer.status = mapscript.MS_DEFAULT
         self.ilayer.connectiontype = mapscript.MS_INLINE
 
-        cs = 'f7fcfd, e5f5f9, ccece6, 99d8c9, 66c2a4, 41ae76, 238b45, 006d2c, 00441b'
-        colors = ['#' + h for h in cs.split(', ')]
+        cs = "f7fcfd, e5f5f9, ccece6, 99d8c9, 66c2a4, 41ae76, 238b45, 006d2c, 00441b"
+        colors = ["#" + h for h in cs.split(", ")]
 
         for i in range(9):
             # Make a class for feature
@@ -443,15 +438,15 @@ class InlineLayerTestCase(unittest.TestC
             so.color.setHex(colors[i])
             li = co.addLabel(mapscript.labelObj())
             lbl = co.getLabel(li)
-            lbl.color.setHex('#000000')
-            lbl.outlinecolor.setHex('#FFFFFF')
+            lbl.color.setHex("#000000")
+            lbl.outlinecolor.setHex("#FFFFFF")
             lbl.type = mapscript.MS_BITMAP
             lbl.size = mapscript.MS_SMALL
 
             # The shape to add is randomly generated
-            xc = 4.0*(random() - 0.5)
-            yc = 4.0*(random() - 0.5)
-            r = mapscript.rectObj(xc-0.25, yc-0.25, xc+0.25, yc+0.25)
+            xc = 4.0 * (random() - 0.5)
+            yc = 4.0 * (random() - 0.5)
+            r = mapscript.rectObj(xc - 0.25, yc - 0.25, xc + 0.25, yc + 0.25)
             s = r.toPolygon()
 
             # Classify
@@ -465,11 +460,11 @@ class InlineLayerTestCase(unittest.TestC
         mo = mapscript.mapObj()
         mo.setSize(400, 400)
         mo.setExtent(-2.5, -2.5, 2.5, 2.5)
-        mo.selectOutputFormat('image/png')
+        mo.selectOutputFormat("image/png")
         mo.insertLayer(self.ilayer)
         im = mo.draw()
-        im.save('testExternalClassification.png')
+        im.save("testExternalClassification.png")
 
 
-if __name__ == '__main__':
+if __name__ == "__main__":
     unittest.main()
diff -pruN 8.0.1-5/mapscript/python/tests/cases/line_test.py 8.0.2-1/mapscript/python/tests/cases/line_test.py
--- 8.0.1-5/mapscript/python/tests/cases/line_test.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapscript/python/tests/cases/line_test.py	2024-06-11 20:41:34.000000000 +0000
@@ -26,7 +26,9 @@
 
 
 import unittest
+
 import mapscript
+
 from .testing import MapPrimitivesTestCase
 
 
@@ -35,8 +37,7 @@ class LineObjTestCase(MapPrimitivesTestC
 
     def setUp(self):
         """The test fixture is a line with two points"""
-        self.points = (mapscript.pointObj(0.0, 1.0),
-                       mapscript.pointObj(2.0, 3.0))
+        self.points = (mapscript.pointObj(0.0, 1.0), mapscript.pointObj(2.0, 3.0))
         self.line = mapscript.lineObj()
         self.addPointToLine(self.line, self.points[0])
         self.addPointToLine(self.line, self.points[1])
@@ -76,8 +77,11 @@ class LineObjTestCase(MapPrimitivesTestC
 
     def testLineGeoInterface(self):
         """return line using the  __geo_interface__ protocol"""
-        assert self.line.__geo_interface__ == {"type": "LineString", "coordinates": [(0.0, 1.0, 0.0), (2.0, 3.0, 0.0)]}
+        assert self.line.__geo_interface__ == {
+            "type": "LineString",
+            "coordinates": [(0.0, 1.0, 0.0), (2.0, 3.0, 0.0)],
+        }
 
 
-if __name__ == '__main__':
+if __name__ == "__main__":
     unittest.main()
diff -pruN 8.0.1-5/mapscript/python/tests/cases/map_test.py 8.0.2-1/mapscript/python/tests/cases/map_test.py
--- 8.0.1-5/mapscript/python/tests/cases/map_test.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapscript/python/tests/cases/map_test.py	2024-06-11 20:41:34.000000000 +0000
@@ -25,12 +25,13 @@
 # ===========================================================================
 
 import unittest
+
 import mapscript
-from .testing import MapTestCase, TESTMAPFILE
 
+from .testing import TESTMAPFILE, MapTestCase
 
-class MapConstructorTestCase(unittest.TestCase):
 
+class MapConstructorTestCase(unittest.TestCase):
     def testMapConstructorNoArg(self):
         """MapConstructorTestCase.testMapConstructorNoArg: test map constructor with no argument"""
         test_map = mapscript.mapObj()
@@ -40,7 +41,7 @@ class MapConstructorTestCase(unittest.Te
     def testMapConstructorEmptyStringArg(self):
         """MapConstructorTestCase.testMapConstructorEmptyStringArg:
         test map constructor with old-style empty string argument"""
-        test_map = mapscript.mapObj('')
+        test_map = mapscript.mapObj("")
         assert test_map.__class__.__name__ == "mapObj"
         assert test_map.thisown == 1
 
@@ -63,8 +64,9 @@ class MapExtentTestCase(MapTestCase):
     def testSetExtentBadly(self):
         """MapExtentTestCase.testSetExtentBadly: test that mapscript raises an error for an invalid mapObj extent"""
         test_map = mapscript.mapObj(TESTMAPFILE)
-        self.assertRaises(mapscript.MapServerError, test_map.setExtent,
-                          1.0, -2.0, -3.0, 4.0)
+        self.assertRaises(
+            mapscript.MapServerError, test_map.setExtent, 1.0, -2.0, -3.0, 4.0
+        )
 
     def testReBindingExtent(self):
         """test the rebinding of a map's extent"""
@@ -78,20 +80,27 @@ class MapExtentTestCase(MapTestCase):
 
 
 class MapLayersTestCase(MapTestCase):
-
     def testMapInsertLayer(self):
         """MapLayersTestCase.testMapInsertLayer: test insertion of a new layer at default (last) index"""
         n = self.map.numlayers
         layer = mapscript.layerObj()
-        layer.name = 'new'
+        layer.name = "new"
         assert layer.map is None, layer.map
         index = self.map.insertLayer(layer)
         assert layer.map is not None, layer.map
         assert index == n, index
         assert self.map.numlayers == n + 1
         names = [self.map.getLayer(i).name for i in range(self.map.numlayers)]
-        assert names == ['RASTER', 'POLYGON', 'LINE', 'POINT', 'INLINE',
-                         'INLINE-PIXMAP-RGBA', 'INLINE-PIXMAP-PCT', 'new']
+        assert names == [
+            "RASTER",
+            "POLYGON",
+            "LINE",
+            "POINT",
+            "INLINE",
+            "INLINE-PIXMAP-RGBA",
+            "INLINE-PIXMAP-PCT",
+            "new",
+        ]
         order = self.map.getLayerOrder()
         assert order == (0, 1, 2, 3, 4, 5, 6, 7), order
 
@@ -99,15 +108,23 @@ class MapLayersTestCase(MapTestCase):
         """MapLayersTestCase.testMapInsertLayerAtZero: test insertion of a new layer at first index"""
         n = self.map.numlayers
         layer = mapscript.layerObj()
-        layer.name = 'new'
+        layer.name = "new"
         assert layer.map is None, layer.map
         index = self.map.insertLayer(layer, 0)
         assert layer.map is not None, layer.map
         assert index == 0, index
         assert self.map.numlayers == n + 1
         names = [self.map.getLayer(i).name for i in range(self.map.numlayers)]
-        assert names == ['new', 'RASTER', 'POLYGON', 'LINE', 'POINT', 'INLINE',
-                         'INLINE-PIXMAP-RGBA', 'INLINE-PIXMAP-PCT'], names
+        assert names == [
+            "new",
+            "RASTER",
+            "POLYGON",
+            "LINE",
+            "POINT",
+            "INLINE",
+            "INLINE-PIXMAP-RGBA",
+            "INLINE-PIXMAP-PCT",
+        ], names
         order = self.map.getLayerOrder()
         assert order == (0, 1, 2, 3, 4, 5, 6, 7), order
 
@@ -121,7 +138,7 @@ class MapLayersTestCase(MapTestCase):
         self.map.setLayerOrder(o_start)
         # insert Layer
         layer = mapscript.layerObj()
-        layer.name = 'new'
+        layer.name = "new"
         index = self.map.insertLayer(layer, 1)
         assert index == 1, index
         # We expect our new layer to be at index 1 in drawing order as well
@@ -131,20 +148,20 @@ class MapLayersTestCase(MapTestCase):
     def testMapInsertLayerBadIndex(self):
         """MapLayersTestCase.testMapInsertLayerBadIndex: expect an exception when index is too large"""
         layer = mapscript.layerObj()
-        self.assertRaises(mapscript.MapServerChildError, self.map.insertLayer,
-                          layer, 1000)
+        self.assertRaises(
+            mapscript.MapServerChildError, self.map.insertLayer, layer, 1000
+        )
 
     def testMapInsertNULLLayer(self):
         """expect an exception on attempt to insert a NULL Layer"""
-        self.assertRaises(mapscript.MapServerChildError, self.map.insertLayer,
-                          None)
+        self.assertRaises(mapscript.MapServerChildError, self.map.insertLayer, None)
 
     def testMapRemoveLayerAtTail(self):
         """removal of highest index (tail) layer"""
         n = self.map.numlayers
-        layer = self.map.removeLayer(n-1)
-        assert self.map.numlayers == n-1
-        assert layer.name == 'INLINE-PIXMAP-PCT'
+        layer = self.map.removeLayer(n - 1)
+        assert self.map.numlayers == n - 1
+        assert layer.name == "INLINE-PIXMAP-PCT"
         assert layer.thisown == 1
         del layer
         order = self.map.getLayerOrder()
@@ -154,8 +171,8 @@ class MapLayersTestCase(MapTestCase):
         """removal of lowest index (0) layer"""
         n = self.map.numlayers
         layer = self.map.removeLayer(0)
-        assert self.map.numlayers == n-1
-        assert layer.name == 'RASTER'
+        assert self.map.numlayers == n - 1
+        assert layer.name == "RASTER"
         order = self.map.getLayerOrder()
         assert order == (0, 1, 2, 3, 4, 5), order
 
@@ -166,27 +183,31 @@ class MapLayersTestCase(MapTestCase):
         o_start = (6, 5, 4, 3, 2, 1, 0)
         self.map.setLayerOrder(o_start)
         layer = self.map.removeLayer(1)
-        assert self.map.numlayers == n-1
-        assert layer.name == 'POLYGON'
+        assert self.map.numlayers == n - 1
+        assert layer.name == "POLYGON"
         order = self.map.getLayerOrder()
         assert order == (5, 4, 3, 2, 1, 0), order
         names = [self.map.getLayer(i).name for i in range(self.map.numlayers)]
-        assert names == ['RASTER', 'LINE', 'POINT', 'INLINE',
-                         'INLINE-PIXMAP-RGBA', 'INLINE-PIXMAP-PCT'], names
+        assert names == [
+            "RASTER",
+            "LINE",
+            "POINT",
+            "INLINE",
+            "INLINE-PIXMAP-RGBA",
+            "INLINE-PIXMAP-PCT",
+        ], names
 
 
 class MapExceptionTestCase(MapTestCase):
-
     def testDrawBadData(self):
         """MapExceptionTestCase.testDrawBadData: a bad data descriptor in a layer returns proper error"""
-        self.map.getLayerByName('POLYGON').data = 'foo'
+        self.map.getLayerByName("POLYGON").data = "foo"
         self.assertRaises(mapscript.MapServerError, self.map.draw)
 
 
 class EmptyMapExceptionTestCase(unittest.TestCase):
-
     def setUp(self):
-        self.map = mapscript.mapObj('')
+        self.map = mapscript.mapObj("")
 
     def tearDown(self):
         self.map = None
@@ -197,7 +218,6 @@ class EmptyMapExceptionTestCase(unittest
 
 
 class NoFontSetTestCase(unittest.TestCase):
-
     def testNoGetFontSetFile(self):
         """an empty map should have fontset filename == None"""
         self.map = mapscript.mapObj()
@@ -205,15 +225,13 @@ class NoFontSetTestCase(unittest.TestCas
 
 
 class MapFontSetTestCase(MapTestCase):
-
     def testGetFontSetFile(self):
         """expect fontset file to be 'fonts.txt'"""
         file = self.map.fontset.filename
-        assert file == 'fonts.txt', file
+        assert file == "fonts.txt", file
 
 
 class MapSizeTestCase(MapTestCase):
-
     def testDefaultSize(self):
         assert self.map.width == 200
         assert self.map.height == 200
@@ -226,9 +244,9 @@ class MapSizeTestCase(MapTestCase):
 
 
 class MapSetWKTTestCase(MapTestCase):
-
     def testOGCWKT(self):
-        self.map.setWKTProjection('''PROJCS["unnamed",GEOGCS["WGS 84",DATUM["WGS_1984",
+        self.map.setWKTProjection(
+            """PROJCS["unnamed",GEOGCS["WGS 84",DATUM["WGS_1984",
                                      SPHEROID["WGS 84",6378137,298.257223563]],
                                      PRIMEM["Greenwich",0],
                                      UNIT["Degree",0.0174532925199433]],
@@ -237,37 +255,41 @@ class MapSetWKTTestCase(MapTestCase):
                                      PARAMETER["latitude_of_center", 0], PARAMETER["longitude_of_center", -153],
                                      PARAMETER["false_easting", -4943910.68], PARAMETER["false_northing", 0],
                                      UNIT["metre",1.0]
-                                     ]''')
+                                     ]"""
+        )
         proj4 = self.map.getProjection()
 
-        assert proj4.find('+proj=aea') != -1
-        assert proj4.find('+datum=WGS84') != -1
+        assert proj4.find("+proj=aea") != -1
+        assert proj4.find("+datum=WGS84") != -1
         assert mapscript.projectionObj(proj4).getUnits() != mapscript.MS_DD
 
     def testESRIWKT(self):
-        self.map.setWKTProjection('ESRI::PROJCS["Pulkovo_1995_GK_Zone_2", GEOGCS["GCS_Pulkovo_1995", '
-                                  'DATUM["D_Pulkovo_1995", SPHEROID["Krasovsky_1940", 6378245, 298.3]], '
-                                  'PRIMEM["Greenwich", 0], '
-                                  'UNIT["Degree", 0.017453292519943295]], PROJECTION["Gauss_Kruger"], '
-                                  'PARAMETER["False_Easting", 2500000], '
-                                  'PARAMETER["False_Northing", 0], PARAMETER["Central_Meridian", 9], '
-                                  'PARAMETER["Scale_Factor", 1], '
-                                  'PARAMETER["Latitude_Of_Origin", 0], UNIT["Meter", 1]]')
+        self.map.setWKTProjection(
+            'ESRI::PROJCS["Pulkovo_1995_GK_Zone_2", GEOGCS["GCS_Pulkovo_1995", '
+            'DATUM["D_Pulkovo_1995", SPHEROID["Krasovsky_1940", 6378245, 298.3]], '
+            'PRIMEM["Greenwich", 0], '
+            'UNIT["Degree", 0.017453292519943295]], PROJECTION["Gauss_Kruger"], '
+            'PARAMETER["False_Easting", 2500000], '
+            'PARAMETER["False_Northing", 0], PARAMETER["Central_Meridian", 9], '
+            'PARAMETER["Scale_Factor", 1], '
+            'PARAMETER["Latitude_Of_Origin", 0], UNIT["Meter", 1]]'
+        )
         proj4 = self.map.getProjection()
 
-        assert proj4.find('+proj=tmerc') != -1
-        assert proj4.find('+ellps=krass') != -1
+        assert proj4.find("+proj=tmerc") != -1
+        assert proj4.find("+ellps=krass") != -1
         assert (mapscript.projectionObj(proj4)).getUnits() != mapscript.MS_DD
 
     def testWellKnownGEOGCS(self):
-        self.map.setWKTProjection('WGS84')
+        self.map.setWKTProjection("WGS84")
         proj4 = self.map.getProjection()
-        assert ('+proj=longlat' in proj4 and '+datum=WGS84' in proj4) or proj4 == '+init=epsg:4326', proj4
+        assert (
+            "+proj=longlat" in proj4 and "+datum=WGS84" in proj4
+        ) or proj4 == "+init=epsg:4326", proj4
         assert (mapscript.projectionObj(proj4)).getUnits() != mapscript.MS_METERS
 
 
 class MapRunSubTestCase(MapTestCase):
-
     def testDefaultSubstitutions(self):
         s = """
 MAP
@@ -330,5 +352,5 @@ class MapSLDTestCase(MapTestCase):
         assert result.startswith('<StyledLayerDescriptor version="1.1.0"'), result
 
 
-if __name__ == '__main__':
+if __name__ == "__main__":
     unittest.main()
diff -pruN 8.0.1-5/mapscript/python/tests/cases/outputformat_test.py 8.0.2-1/mapscript/python/tests/cases/outputformat_test.py
--- 8.0.1-5/mapscript/python/tests/cases/outputformat_test.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapscript/python/tests/cases/outputformat_test.py	2024-06-11 20:41:34.000000000 +0000
@@ -25,75 +25,78 @@
 # ===========================================================================
 
 import unittest
+
 import mapscript
+
 from .testing import MapTestCase
 
 
 class OutputFormatTestCase(unittest.TestCase):
     """http://mapserver.gis.umn.edu/bugs/show_bug.cgi?id=511"""
+
     def testOutputFormatConstructor(self):
-        new_format = mapscript.outputFormatObj('GDAL/GTiff', 'gtiff')
+        new_format = mapscript.outputFormatObj("GDAL/GTiff", "gtiff")
         # assert new_format.refcount == 1, new_format.refcount
-        assert new_format.name == 'gtiff'
-        assert new_format.mimetype == 'image/tiff'
+        assert new_format.name == "gtiff"
+        assert new_format.mimetype == "image/tiff"
 
 
 class MapOutputFormatTestCase(MapTestCase):
-
     def testAppendNewOutputFormat(self):
         """test that a new output format can be created on-the-fly"""
         num = self.map.numoutputformats
-        new_format = mapscript.outputFormatObj('GDAL/GTiff', 'gtiffx')
+        new_format = mapscript.outputFormatObj("GDAL/GTiff", "gtiffx")
         # assert new_format.refcount == 1, new_format.refcount
         self.map.appendOutputFormat(new_format)
         assert self.map.numoutputformats == num + 1
         # assert new_format.refcount == 2, new_format.refcount
-        self.map.selectOutputFormat('gtiffx')
-        self.map.save('testAppendNewOutputFormat.map')
-        self.map.getLayerByName('INLINE-PIXMAP-RGBA').status = mapscript.MS_ON
+        self.map.selectOutputFormat("gtiffx")
+        self.map.save("testAppendNewOutputFormat.map")
+        self.map.getLayerByName("INLINE-PIXMAP-RGBA").status = mapscript.MS_ON
         imgobj = self.map.draw()
-        filename = 'testAppendNewOutputFormat.tif'
+        filename = "testAppendNewOutputFormat.tif"
         imgobj.save(filename)
 
     def testRemoveOutputFormat(self):
         """testRemoveOutputFormat may fail depending on GD options"""
         num = self.map.numoutputformats
-        new_format = mapscript.outputFormatObj('GDAL/GTiff', 'gtiffx')
+        new_format = mapscript.outputFormatObj("GDAL/GTiff", "gtiffx")
         self.map.appendOutputFormat(new_format)
         assert self.map.numoutputformats == num + 1
         # assert new_format.refcount == 2, new_format.refcount
-        assert self.map.removeOutputFormat('gtiffx') == mapscript.MS_SUCCESS
+        assert self.map.removeOutputFormat("gtiffx") == mapscript.MS_SUCCESS
         # assert new_format.refcount == 1, new_format.refcount
         assert self.map.numoutputformats == num
-        self.assertRaises(mapscript.MapServerError,
-                          self.map.selectOutputFormat, 'gtiffx')
-        self.map.selectOutputFormat('GTiff')
-        assert self.map.outputformat.mimetype == 'image/tiff'
+        self.assertRaises(
+            mapscript.MapServerError, self.map.selectOutputFormat, "gtiffx"
+        )
+        self.map.selectOutputFormat("GTiff")
+        assert self.map.outputformat.mimetype == "image/tiff"
 
     def testBuiltInPNG24Format(self):
         """test built in PNG RGB format"""
-        self.map.selectOutputFormat('PNG24')
-        assert self.map.outputformat.mimetype == 'image/png'
-        self.map.getLayerByName('INLINE-PIXMAP-RGBA').status = mapscript.MS_ON
+        self.map.selectOutputFormat("PNG24")
+        assert self.map.outputformat.mimetype == "image/png"
+        self.map.getLayerByName("INLINE-PIXMAP-RGBA").status = mapscript.MS_ON
         img = self.map.draw()
-        assert img.format.mimetype == 'image/png'
-        filename = 'testBuiltInPNG24Format.png'
+        assert img.format.mimetype == "image/png"
+        filename = "testBuiltInPNG24Format.png"
         img.save(filename)
 
     def testBuiltInJPEGFormat(self):
         """test built in JPEG format"""
-        self.map.selectOutputFormat('JPEG')
-        assert self.map.outputformat.mimetype == 'image/jpeg'
-        self.map.getLayerByName('INLINE-PIXMAP-RGBA').status = mapscript.MS_ON
+        self.map.selectOutputFormat("JPEG")
+        assert self.map.outputformat.mimetype == "image/jpeg"
+        self.map.getLayerByName("INLINE-PIXMAP-RGBA").status = mapscript.MS_ON
         img = self.map.draw()
-        assert img.format.mimetype == 'image/jpeg'
-        filename = 'testBuiltInJPEGFormat.jpg'
+        assert img.format.mimetype == "image/jpeg"
+        filename = "testBuiltInJPEGFormat.jpg"
         img.save(filename)
 
     def testSelectBuiltInJPEGFormat(self):
         """test selection of built-in JPEG format"""
-        self.map.selectOutputFormat('JPEG')
-        assert self.map.outputformat.mimetype == 'image/jpeg'
+        self.map.selectOutputFormat("JPEG")
+        assert self.map.outputformat.mimetype == "image/jpeg"
 
 
 class UnsupportedFormatTestCase(unittest.TestCase):
@@ -101,9 +104,8 @@ class UnsupportedFormatTestCase(unittest
     format."""
 
     def testCreateUnsupported(self):
-        self.assertRaises(mapscript.MapServerError, mapscript.outputFormatObj,
-                          'PDF')
+        self.assertRaises(mapscript.MapServerError, mapscript.outputFormatObj, "PDF")
 
 
-if __name__ == '__main__':
+if __name__ == "__main__":
     unittest.main()
diff -pruN 8.0.1-5/mapscript/python/tests/cases/ows_test.py 8.0.2-1/mapscript/python/tests/cases/ows_test.py
--- 8.0.1-5/mapscript/python/tests/cases/ows_test.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapscript/python/tests/cases/ows_test.py	2024-06-11 20:41:34.000000000 +0000
@@ -26,12 +26,13 @@
 
 import unittest
 import xml.dom.minidom
+
 import mapscript
+
 from .testing import MapTestCase
 
 
 class OWSRequestTestCase(MapTestCase):
-
     def testInit(self):
         """OWSRequestTestCase.testInit: OWS initializer works right"""
         request = mapscript.OWSRequest()
@@ -43,23 +44,23 @@ class OWSRequestTestCase(MapTestCase):
     def testGetParameter(self):
         """OWSRequestTestCase.testGetParameter: OWS can get request parameters by index"""
         request = mapscript.OWSRequest()
-        request.setParameter('foo', 'bar')
-        assert request.getValue(0) == 'bar'
+        request.setParameter("foo", "bar")
+        assert request.getValue(0) == "bar"
 
     def testGetParameterByName(self):
         """OWSRequestTestCase.testGetParameterByName: OWS can get request parameters by name"""
         request = mapscript.OWSRequest()
-        request.setParameter('foo', 'bar')
-        assert request.getValueByName('Foo') == 'bar'
+        request.setParameter("foo", "bar")
+        assert request.getValueByName("Foo") == "bar"
 
     def testResetParam(self):
         """OWSRequestTestCase.testResetParam: OWS can reset parameters by name"""
         request = mapscript.OWSRequest()
-        request.setParameter('foo', 'bar')
+        request.setParameter("foo", "bar")
         assert request.NumParams == 1
-        request.setParameter('Foo', 'bra')
+        request.setParameter("Foo", "bra")
         assert request.NumParams == 1
-        assert request.getValue(0) == 'bra'
+        assert request.getValue(0) == "bra"
 
     def testLoadWMSRequest(self):
         """OWSRequestTestCase.testLoadWMSRequest: OWS can load a WMS request"""
@@ -117,8 +118,8 @@ class OWSRequestTestCase(MapTestCase):
         mapscript.msIO_stripStdoutBufferContentHeaders()
         result = mapscript.msIO_getStdoutBufferBytes()
         dom = xml.dom.minidom.parseString(result)
-        assert len(dom.getElementsByTagName('ms:POINT')) == 1
+        assert len(dom.getElementsByTagName("ms:POINT")) == 1
 
 
-if __name__ == '__main__':
+if __name__ == "__main__":
     unittest.main()
diff -pruN 8.0.1-5/mapscript/python/tests/cases/parentreference_test.py 8.0.2-1/mapscript/python/tests/cases/parentreference_test.py
--- 8.0.1-5/mapscript/python/tests/cases/parentreference_test.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapscript/python/tests/cases/parentreference_test.py	2024-06-11 20:41:34.000000000 +0000
@@ -26,12 +26,13 @@
 
 import gc
 import unittest
+
 import mapscript
+
 from .testing import TESTMAPFILE
 
 
 class ParentReferenceTestCase(unittest.TestCase):
-
     def initMap(self):
         self.map = mapscript.mapObj(TESTMAPFILE)
 
@@ -39,15 +40,15 @@ class ParentReferenceTestCase(unittest.T
         self.initMap()
         layer = self.map.getLayer(1)
         self.map = None
-        assert str(layer.p_map).find('mapscript.mapObj') != -1
+        assert str(layer.p_map).find("mapscript.mapObj") != -1
         gc.collect()
         assert layer.map is not None, layer.map
 
     def testGetLayerObjByName(self):
         self.initMap()
-        layer = self.map.getLayerByName('POLYGON')
+        layer = self.map.getLayerByName("POLYGON")
         self.map = None
-        assert str(layer.p_map).find('mapscript.mapObj') != -1
+        assert str(layer.p_map).find("mapscript.mapObj") != -1
         gc.collect()
         assert layer.map is not None, layer.map
 
@@ -55,7 +56,7 @@ class ParentReferenceTestCase(unittest.T
         self.initMap()
         layer = mapscript.layerObj(self.map)
         self.map = None
-        assert str(layer.p_map).find('mapscript.mapObj') != -1
+        assert str(layer.p_map).find("mapscript.mapObj") != -1
         gc.collect()
         assert layer.map is not None, layer.map
 
@@ -64,7 +65,7 @@ class ParentReferenceTestCase(unittest.T
         layer = mapscript.layerObj()
         self.map.insertLayer(layer)
         self.map = None
-        assert str(layer.p_map).find('mapscript.mapObj') != -1
+        assert str(layer.p_map).find("mapscript.mapObj") != -1
         gc.collect()
         assert layer.map is not None, layer.map
 
@@ -74,7 +75,7 @@ class ParentReferenceTestCase(unittest.T
         clazz = layer.getClass(0)
         self.map = None
         layer = None
-        assert str(clazz.p_layer).find('mapscript.layerObj') != -1
+        assert str(clazz.p_layer).find("mapscript.layerObj") != -1
         gc.collect()
         assert clazz.layer is not None, clazz.layer
 
@@ -84,7 +85,7 @@ class ParentReferenceTestCase(unittest.T
         clazz = mapscript.classObj(layer)
         self.map = None
         layer = None
-        assert str(clazz.p_layer).find('mapscript.layerObj') != -1
+        assert str(clazz.p_layer).find("mapscript.layerObj") != -1
         gc.collect()
         assert clazz.layer is not None, clazz.layer
 
@@ -95,7 +96,7 @@ class ParentReferenceTestCase(unittest.T
         layer.insertClass(clazz)
         self.map = None
         layer = None
-        assert str(clazz.p_layer).find('mapscript.layerObj') != -1
+        assert str(clazz.p_layer).find("mapscript.layerObj") != -1
         gc.collect()
         assert clazz.layer is not None, clazz.layer
 
@@ -103,7 +104,7 @@ class ParentReferenceTestCase(unittest.T
         self.initMap()
         layer = self.map.getLayer(1)
         clazz = layer.removeClass(0)
-        if hasattr(clazz, 'p_layer'):
+        if hasattr(clazz, "p_layer"):
             assert clazz.p_layer is None, clazz.p_layer
         assert clazz.layer is None, clazz.layer
         self.initMap()
@@ -113,5 +114,5 @@ class ParentReferenceTestCase(unittest.T
         assert clazz.layer is not None, clazz.layer
 
 
-if __name__ == '__main__':
+if __name__ == "__main__":
     unittest.main()
diff -pruN 8.0.1-5/mapscript/python/tests/cases/pgtest.py 8.0.2-1/mapscript/python/tests/cases/pgtest.py
--- 8.0.1-5/mapscript/python/tests/cases/pgtest.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapscript/python/tests/cases/pgtest.py	2024-06-11 20:41:34.000000000 +0000
@@ -39,6 +39,7 @@
 # ===========================================================================
 
 import unittest
+
 import mapscript
 
 PG_CONNECTION_STRING = "dbname=mapserver_test user=postgres"
@@ -48,7 +49,7 @@ class TableTest(unittest.TestCase):
     def setUp(self):
         self.mo = mapscript.mapObj()
         lo = mapscript.layerObj()
-        lo.name = 'pg_layer'
+        lo.name = "pg_layer"
         lo.type = mapscript.MS_LAYER_POLYGON
         lo.connectiontype = mapscript.MS_POSTGIS
         lo.connection = PG_CONNECTION_STRING
@@ -61,14 +62,14 @@ class TableTest(unittest.TestCase):
         f = self.lo.getFeature(1, -1)
         atts = [f.getValue(i) for i in range(self.lo.numitems)]
         self.lo.close()
-        self.assertEqual(atts, ['1', '1', 'A Polygon'], atts)
+        self.assertEqual(atts, ["1", "1", "A Polygon"], atts)
 
 
 class ViewTest(unittest.TestCase):
     def setUp(self):
         self.mo = mapscript.mapObj()
         lo = mapscript.layerObj()
-        lo.name = 'pg_sub_layer'
+        lo.name = "pg_sub_layer"
         lo.type = mapscript.MS_LAYER_POLYGON
         lo.connectiontype = mapscript.MS_POSTGIS
         lo.connection = PG_CONNECTION_STRING
@@ -81,14 +82,14 @@ class ViewTest(unittest.TestCase):
         f = self.lo.getFeature(1, -1)
         atts = [f.getValue(i) for i in range(self.lo.numitems)]
         self.lo.close()
-        self.assertEqual(atts, ['1', '1', 'A Polygon'], atts)
+        self.assertEqual(atts, ["1", "1", "A Polygon"], atts)
 
 
 class SubSelectTest(unittest.TestCase):
     def setUp(self):
         self.mo = mapscript.mapObj()
         lo = mapscript.layerObj()
-        lo.name = 'pg_sub_layer'
+        lo.name = "pg_sub_layer"
         lo.type = mapscript.MS_LAYER_POLYGON
         lo.connectiontype = mapscript.MS_POSTGIS
         lo.connection = PG_CONNECTION_STRING
@@ -101,15 +102,16 @@ class SubSelectTest(unittest.TestCase):
         f = self.lo.getFeature(1, -1)
         atts = [f.getValue(i) for i in range(self.lo.numitems)]
         self.lo.close()
-        self.assertEqual(atts, ['1', '1', 'A Polygon'], atts)
+        self.assertEqual(atts, ["1", "1", "A Polygon"], atts)
 
 
 class SubSelectNoSRIDTest(unittest.TestCase):
     """SRID should be diagnosed from the selection"""
+
     def setUp(self):
         self.mo = mapscript.mapObj()
         lo = mapscript.layerObj()
-        lo.name = 'pg_sub_layer'
+        lo.name = "pg_sub_layer"
         lo.type = mapscript.MS_LAYER_POLYGON
         lo.connectiontype = mapscript.MS_POSTGIS
         lo.connection = PG_CONNECTION_STRING
@@ -122,8 +124,8 @@ class SubSelectNoSRIDTest(unittest.TestC
         f = self.lo.getFeature(1, -1)
         atts = [f.getValue(i) for i in range(self.lo.numitems)]
         self.lo.close()
-        self.assertEqual(atts, ['1', '1', 'A Polygon'], atts)
+        self.assertEqual(atts, ["1", "1", "A Polygon"], atts)
 
 
-if __name__ == '__main__':
+if __name__ == "__main__":
     unittest.main()
diff -pruN 8.0.1-5/mapscript/python/tests/cases/point_test.py 8.0.2-1/mapscript/python/tests/cases/point_test.py
--- 8.0.1-5/mapscript/python/tests/cases/point_test.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapscript/python/tests/cases/point_test.py	2024-06-11 20:41:34.000000000 +0000
@@ -25,20 +25,20 @@
 # ===========================================================================
 
 import unittest
-import mapscript
 
+import mapscript
 
 have_image = False
 
 try:
     from PIL import Image
+
     have_image = True
 except ImportError:
     pass
 
 
 class PointObjTestCase(unittest.TestCase):
-
     def testPointObjConstructorNoArgs(self):
         """point can be created with no arguments"""
         p = mapscript.pointObj()
@@ -57,7 +57,7 @@ class PointObjTestCase(unittest.TestCase
         p.setXY(1.0, 1.0)
         self.assertAlmostEqual(p.x, 1.0)
         self.assertAlmostEqual(p.y, 1.0)
-        if hasattr(p, 'm'):
+        if hasattr(p, "m"):
             self.assertAlmostEqual(p.m, -2e38)
 
     def testSetXYM(self):
@@ -66,7 +66,7 @@ class PointObjTestCase(unittest.TestCase
         p.setXY(1.0, 1.0, 1.0)
         self.assertAlmostEqual(p.x, 1.0)
         self.assertAlmostEqual(p.y, 1.0)
-        if hasattr(p, 'm'):
+        if hasattr(p, "m"):
             self.assertAlmostEqual(p.m, 1.0)
 
     def testSetXYZ(self):
@@ -75,7 +75,7 @@ class PointObjTestCase(unittest.TestCase
         p.setXYZ(1.0, 2.0, 3.0, 4.0)
         self.assertAlmostEqual(p.x, 1.0)
         self.assertAlmostEqual(p.y, 2.0)
-        if hasattr(p, 'z') and hasattr(p, 'm'):
+        if hasattr(p, "z") and hasattr(p, "m"):
             self.assertAlmostEqual(p.z, 3.0)
             self.assertAlmostEqual(p.m, 4.0)
 
@@ -103,12 +103,12 @@ class PointObjTestCase(unittest.TestCase
         END"""
 
         test_map = mapscript.fromstring(map_string)
-        layer = test_map.getLayerByName('punkt')
+        layer = test_map.getLayerByName("punkt")
         cls = mapscript.classObj()
         style = mapscript.styleObj()
-        style.outlinecolor.setHex('#00aa00ff')
+        style.outlinecolor.setHex("#00aa00ff")
         style.size = 10
-        style.setSymbolByName(test_map, 'circle')
+        style.setSymbolByName(test_map, "circle")
 
         cls.insertStyle(style)
         class_idx = layer.insertClass(cls)
@@ -117,8 +117,8 @@ class PointObjTestCase(unittest.TestCase
         img = test_map.prepareImage()
         point.draw(test_map, layer, img, class_idx, "test")
 
-        filename = 'testDrawPoint.png'
-        with open(filename, 'wb') as fh:
+        filename = "testDrawPoint.png"
+        with open(filename, "wb") as fh:
             img.write(fh)
 
         if have_image:
@@ -128,7 +128,7 @@ class PointObjTestCase(unittest.TestCase
     def testPoint__str__(self):
         """return properly formatted string"""
         p = mapscript.pointObj(1.0, 1.0)
-        if hasattr(p, 'z'):
+        if hasattr(p, "z"):
             p_str = "{ 'x': %.16g, 'y': %.16g, 'z': %.16g }" % (p.x, p.y, p.z)
         else:
             p_str = "{ 'x': %.16g, 'y': %.16g }" % (p.x, p.y)
@@ -137,9 +137,13 @@ class PointObjTestCase(unittest.TestCase
     def testPointToString(self):
         """return properly formatted string in toString()"""
         p = mapscript.pointObj(1.0, 1.0, 0.002, 15.0)
-        if hasattr(p, 'z') and hasattr(p, 'm'):
-            p_str = "{ 'x': %.16g, 'y': %.16g, 'z': %.16g, 'm': %.16g }" \
-                  % (p.x, p.y, p.z, p.m)
+        if hasattr(p, "z") and hasattr(p, "m"):
+            p_str = "{ 'x': %.16g, 'y': %.16g, 'z': %.16g, 'm': %.16g }" % (
+                p.x,
+                p.y,
+                p.z,
+                p.m,
+            )
         else:
             p_str = "{ 'x': %.16g, 'y': %.16g }" % (p.x, p.y)
 
@@ -148,11 +152,14 @@ class PointObjTestCase(unittest.TestCase
     def testPointGeoInterface(self):
         """return point using the  __geo_interface__ protocol"""
         p = mapscript.pointObj(1.0, 1.0, 0.002, 15.0)
-        if hasattr(p, 'z'):
-            assert p.__geo_interface__ == {"type": "Point", "coordinates": (1.0, 1.0, 0.002)}
+        if hasattr(p, "z"):
+            assert p.__geo_interface__ == {
+                "type": "Point",
+                "coordinates": (1.0, 1.0, 0.002),
+            }
         else:
             assert p.__geo_interface__ == {"type": "Point", "coordinates": (1.0, 1.0)}
 
 
-if __name__ == '__main__':
+if __name__ == "__main__":
     unittest.main()
diff -pruN 8.0.1-5/mapscript/python/tests/cases/rect_test.py 8.0.2-1/mapscript/python/tests/cases/rect_test.py
--- 8.0.1-5/mapscript/python/tests/cases/rect_test.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapscript/python/tests/cases/rect_test.py	2024-06-11 20:41:34.000000000 +0000
@@ -25,12 +25,13 @@
 # ===========================================================================
 
 import unittest
+
 import mapscript
+
 from .testing import MapPrimitivesTestCase
 
 
 class RectObjTestCase(MapPrimitivesTestCase):
-
     def testRectObjConstructorNoArgs(self):
         """a rect can be initialized with no args"""
         r = mapscript.rectObj()
@@ -49,13 +50,15 @@ class RectObjTestCase(MapPrimitivesTestC
 
     def testRectObjConstructorBadXCoords(self):
         """an invalid extent raises proper error (x direction)"""
-        self.assertRaises(mapscript.MapServerError, mapscript.rectObj,
-                          1.0, -2.0, -3.0, 4.0)
+        self.assertRaises(
+            mapscript.MapServerError, mapscript.rectObj, 1.0, -2.0, -3.0, 4.0
+        )
 
     def testRectObjConstructorBadYCoords(self):
         """an invalid extent raises proper error (y direction)"""
-        self.assertRaises(mapscript.MapServerError, mapscript.rectObj,
-                          -1.0, 2.0, 3.0, -2.0)
+        self.assertRaises(
+            mapscript.MapServerError, mapscript.rectObj, -1.0, 2.0, 3.0, -2.0
+        )
 
     def testRectObjToPolygon(self):
         """a rect can be converted into a MS_POLYGON shape"""
@@ -74,25 +77,31 @@ class RectObjTestCase(MapPrimitivesTestC
             r = mapscript.rectObj(1.0, -2.0, -3.0, 4.0)
             print(r)
         except mapscript.MapServerError as msg:
-            assert str(msg) == "rectObj(): Invalid rectangle. { 'minx': 1.000000 , " \
-                               "'miny': -2.000000 , 'maxx': -3.000000 , 'maxy': 4.000000 }", msg
+            assert (
+                str(msg) == "rectObj(): Invalid rectangle. { 'minx': 1.000000 , "
+                "'miny': -2.000000 , 'maxx': -3.000000 , 'maxy': 4.000000 }"
+            ), msg
 
     def testRect__str__(self):
         """__str__ returns properly formatted string"""
         r = mapscript.rectObj(-1.0, -2.0, 3.0001, 4.0)
         r_str = str(r)
-        assert r_str == "{ 'minx': -1 , 'miny': -2 , 'maxx': 3.0001 , 'maxy': 4 }", r_str
+        assert (
+            r_str == "{ 'minx': -1 , 'miny': -2 , 'maxx': 3.0001 , 'maxy': 4 }"
+        ), r_str
         r2 = eval(r_str)
-        self.assertAlmostEqual(r2['minx'], r.minx)
-        self.assertAlmostEqual(r2['miny'], r.miny)
-        self.assertAlmostEqual(r2['maxx'], r.maxx)
-        self.assertAlmostEqual(r2['maxy'], r.maxy)
+        self.assertAlmostEqual(r2["minx"], r.minx)
+        self.assertAlmostEqual(r2["miny"], r.miny)
+        self.assertAlmostEqual(r2["maxx"], r.maxx)
+        self.assertAlmostEqual(r2["maxy"], r.maxy)
 
     def testRectToString(self):
         """return properly formatted string"""
         r = mapscript.rectObj(-1.0, -2.0, 3.0001, 4.0)
         r_str = r.toString()
-        assert r_str == "{ 'minx': -1 , 'miny': -2 , 'maxx': 3.0001 , 'maxy': 4 }", r_str
+        assert (
+            r_str == "{ 'minx': -1 , 'miny': -2 , 'maxx': 3.0001 , 'maxy': 4 }"
+        ), r_str
 
     def testRectContainsPoint(self):
         """point is contained (spatially) in rectangle"""
@@ -108,7 +117,6 @@ class RectObjTestCase(MapPrimitivesTestC
 
 
 class ImageRectObjTestCase(MapPrimitivesTestCase):
-
     def testRectObjConstructorArgs(self):
         """create a rect in image units"""
         r = mapscript.rectObj(-1.0, 2.0, 3.0, 0.0, mapscript.MS_TRUE)
@@ -119,9 +127,16 @@ class ImageRectObjTestCase(MapPrimitives
 
     def testRectObjConstructorBadYCoords(self):
         """in image units miny should be greater than maxy"""
-        self.assertRaises(mapscript.MapServerError, mapscript.rectObj,
-                          -1.0, 0.0, 3.0, 2.0, mapscript.MS_TRUE)
+        self.assertRaises(
+            mapscript.MapServerError,
+            mapscript.rectObj,
+            -1.0,
+            0.0,
+            3.0,
+            2.0,
+            mapscript.MS_TRUE,
+        )
 
 
-if __name__ == '__main__':
+if __name__ == "__main__":
     unittest.main()
diff -pruN 8.0.1-5/mapscript/python/tests/cases/refcount_test.py 8.0.2-1/mapscript/python/tests/cases/refcount_test.py
--- 8.0.1-5/mapscript/python/tests/cases/refcount_test.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapscript/python/tests/cases/refcount_test.py	2024-06-11 20:41:34.000000000 +0000
@@ -25,12 +25,13 @@
 # ===========================================================================
 
 import unittest
+
 import mapscript
+
 from .testing import TESTMAPFILE
 
 
 class ReferenceCountingTestCase(unittest.TestCase):
-
     def initMap(self):
         self.map = mapscript.mapObj(TESTMAPFILE)
 
@@ -62,7 +63,7 @@ class ReferenceCountingTestCase(unittest
         self.initMap()
         n = self.map.numlayers
         layer = mapscript.layerObj()
-        layer.name = 'new'
+        layer.name = "new"
         assert layer.refcount == 1
         assert layer.thisown == 1
         index = self.map.insertLayer(layer)
@@ -80,7 +81,7 @@ class ReferenceCountingTestCase(unittest
         self.initMap()
         n = self.map.numlayers
         layer = mapscript.layerObj()
-        layer.name = 'new'
+        layer.name = "new"
         assert layer.refcount == 1
         assert layer.thisown == 1
         index = self.map.insertLayer(layer, 0)
@@ -97,9 +98,9 @@ class ReferenceCountingTestCase(unittest
         """removal of highest index (tail) layer"""
         self.initMap()
         n = self.map.numlayers
-        layer = self.map.removeLayer(n-1)
-        assert self.map.numlayers == n-1
-        assert layer.name == 'INLINE-PIXMAP-PCT'
+        layer = self.map.removeLayer(n - 1)
+        assert self.map.numlayers == n - 1
+        assert layer.name == "INLINE-PIXMAP-PCT"
         assert layer.thisown == 1
         assert layer.refcount == 1, layer.refcount
         self.map.draw()
@@ -109,8 +110,8 @@ class ReferenceCountingTestCase(unittest
         self.initMap()
         n = self.map.numlayers
         layer = self.map.removeLayer(0)
-        assert self.map.numlayers == n-1
-        assert layer.name == 'RASTER'
+        assert self.map.numlayers == n - 1
+        assert layer.name == "RASTER"
         assert layer.thisown == 1
         assert layer.refcount == 1, layer.refcount
         self.map.draw()
@@ -119,7 +120,7 @@ class ReferenceCountingTestCase(unittest
         """behave when parent (map) is null"""
         self.initMap()
         layer = mapscript.layerObj()
-        layer.name = 'new'
+        layer.name = "new"
         index = self.map.insertLayer(layer, 0)
         assert index == 0, index
         self.map = None
@@ -135,7 +136,7 @@ class ReferenceCountingTestCase(unittest
     def testLayerClone(self):
         """Clone a layer"""
         layer = mapscript.layerObj()
-        layer.name = 'sample'
+        layer.name = "sample"
         copy = layer.clone()
 
         assert layer.refcount == 1, layer.refcount
@@ -155,7 +156,7 @@ class ReferenceCountingTestCase(unittest
         """behave when parent (map) is not null"""
         self.initMap()
         layer = mapscript.layerObj(self.map)
-        layer.name = 'new'
+        layer.name = "new"
         assert layer.refcount == 2, layer.refcount
 
     def testDummyClass(self):
@@ -191,8 +192,12 @@ class ReferenceCountingTestCase(unittest
         assert clazz.refcount == 1, clazz.refcount
         idx = self.map.getLayer(1).insertClass(clazz)
         assert clazz.refcount == 2, clazz.refcount
-        assert self.map.getLayer(1).getClass(idx).refcount == 3, self.map.getLayer(1).getClass(idx).refcount
-        assert self.map.getLayer(1).getClass(idx).minscaledenom == 666, self.map.getLayer(1).getClass(idx).minscaledenom
+        assert self.map.getLayer(1).getClass(idx).refcount == 3, (
+            self.map.getLayer(1).getClass(idx).refcount
+        )
+        assert self.map.getLayer(1).getClass(idx).minscaledenom == 666, (
+            self.map.getLayer(1).getClass(idx).minscaledenom
+        )
 
     def testClassInsertAtMiddle(self):
         """classObj insert at pos. 1"""
@@ -203,9 +208,15 @@ class ReferenceCountingTestCase(unittest
         idx = self.map.getLayer(1).insertClass(clazz, 1)
         assert idx == 1, idx
         assert clazz.refcount == 2, clazz.refcount
-        assert self.map.getLayer(1).getClass(idx).refcount == 3, self.map.getLayer(1).getClass(idx).refcount
-        assert self.map.getLayer(1).getClass(idx).thisown, self.map.getLayer(1).getClass(idx).thisown
-        assert self.map.getLayer(1).getClass(idx).minscaledenom == 666, self.map.getLayer(1).getClass(idx).minscaledenom
+        assert self.map.getLayer(1).getClass(idx).refcount == 3, (
+            self.map.getLayer(1).getClass(idx).refcount
+        )
+        assert self.map.getLayer(1).getClass(idx).thisown, (
+            self.map.getLayer(1).getClass(idx).thisown
+        )
+        assert self.map.getLayer(1).getClass(idx).minscaledenom == 666, (
+            self.map.getLayer(1).getClass(idx).minscaledenom
+        )
 
     def testRemoveFirstClass(self):
         """removal of first class"""
@@ -279,7 +290,7 @@ class ReferenceCountingTestCase(unittest
         assert clone.thisown == 1, clone.thisown
 
     def testBasicSymbolRefcounting(self):
-        """symbolObj refcounting """
+        """symbolObj refcounting"""
         self.initMap()
         symb = self.map.symbolset.getSymbol(0)
         assert symb.refcount == 2, symb.refcount
@@ -292,7 +303,7 @@ class ReferenceCountingTestCase(unittest
         assert symb2.thisown == 1, symb2.thisown
 
     def testSymbolAppendRemove(self):
-        """appendSymbolObj refcounting """
+        """appendSymbolObj refcounting"""
         self.initMap()
         symb = mapscript.symbolObj("ANEWSYMBOL")
         assert symb.refcount == 1, symb.refcount
@@ -305,5 +316,5 @@ class ReferenceCountingTestCase(unittest
         assert symb.thisown == 1, symb.thisown
 
 
-if __name__ == '__main__':
+if __name__ == "__main__":
     unittest.main()
diff -pruN 8.0.1-5/mapscript/python/tests/cases/resultcache_test.py 8.0.2-1/mapscript/python/tests/cases/resultcache_test.py
--- 8.0.1-5/mapscript/python/tests/cases/resultcache_test.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapscript/python/tests/cases/resultcache_test.py	2024-06-11 20:41:34.000000000 +0000
@@ -25,16 +25,17 @@
 # ===========================================================================
 
 import unittest
+
 import mapscript
+
 from .testing import MapTestCase
 
 
 class LayerQueryTestCase(MapTestCase):
-
     def setUp(self):
         MapTestCase.setUp(self)
         self.layer = self.map.getLayer(1)
-        self.layer.template = 'some day i will fix this!'
+        self.layer.template = "some day i will fix this!"
 
     def pointquery(self):
         p = mapscript.pointObj(0.0, 51.5)
@@ -47,10 +48,9 @@ class LayerQueryTestCase(MapTestCase):
 
 
 class ResultCacheTestCase(LayerQueryTestCase):
-
     def testNoDirectAccess(self):
         """denying direct access to layer's resultcache"""
-        self.assertRaises(AttributeError, getattr, self.layer, 'resultcache')
+        self.assertRaises(AttributeError, getattr, self.layer, "resultcache")
 
     def testNullResultCache(self):
         """before a query layer's resultcache should be NULL"""
@@ -59,7 +59,6 @@ class ResultCacheTestCase(LayerQueryTest
 
 
 class PointQueryResultsTestCase(LayerQueryTestCase):
-
     def testCacheAfterQuery(self):
         """simple point query returns one result"""
         results = self.pointquery()
@@ -94,7 +93,7 @@ class PointQueryResultsTestCase(LayerQue
         feature = self.layer.getShape(res)
         self.layer.close()
         self.assertRectsEqual(results.bounds, feature.bounds)
-        assert feature.getValue(1) == 'A Polygon'
+        assert feature.getValue(1) == "A Polygon"
 
     def testQueryResultsListComp(self):
         """get all results using list comprehension"""
@@ -114,21 +113,19 @@ class PointQueryResultsTestCase(LayerQue
 
 
 class DumpAndLoadTestCase(LayerQueryTestCase):
-
     def testSaveAndLoadQuery(self):
         """test saving query to a file"""
         results = self.pointquery()
-        self.map.saveQuery('test.qy')
+        self.map.saveQuery("test.qy")
         self.map.freeQuery()
         results = self.layer.getResults()
         assert results is None
-        self.map.loadQuery('test.qy')
+        self.map.loadQuery("test.qy")
         results = self.layer.getResults()
         assert results is not None
 
 
 class LayerOffQueryTestCase(LayerQueryTestCase):
-
     def testPointQueryOffLayer(self):
         """simple point query returns one result, even if layer is off"""
         self.layer.status = mapscript.MS_OFF
@@ -142,5 +139,5 @@ class LayerOffQueryTestCase(LayerQueryTe
         assert results.numresults == 1
 
 
-if __name__ == '__main__':
+if __name__ == "__main__":
     unittest.main()
diff -pruN 8.0.1-5/mapscript/python/tests/cases/shape_test.py 8.0.2-1/mapscript/python/tests/cases/shape_test.py
--- 8.0.1-5/mapscript/python/tests/cases/shape_test.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapscript/python/tests/cases/shape_test.py	2024-06-11 20:41:34.000000000 +0000
@@ -25,7 +25,9 @@
 # ===========================================================================
 
 import unittest
+
 import mapscript
+
 from .testing import MapTestCase, ShapeObjTestCase
 
 
@@ -34,8 +36,8 @@ class ShapePointTestCase(ShapeObjTestCas
 
     def setUp(self):
         """The test fixture is a shape of one point"""
-        self.points = (mapscript.pointObj(0.0, 1.0), )
-        self.lines = (mapscript.lineObj(), )
+        self.points = (mapscript.pointObj(0.0, 1.0),)
+        self.lines = (mapscript.lineObj(),)
         self.addPointToLine(self.lines[0], self.points[0])
         self.shape = mapscript.shapeObj(mapscript.MS_SHAPE_POINT)
         self.addLineToShape(self.shape, self.lines[0])
@@ -55,7 +57,7 @@ class InlineFeatureTestCase(MapTestCase)
 
     def testAddPointFeature(self):
         """adding a point to an inline feature works correctly"""
-        inline_layer = self.map.getLayerByName('INLINE')
+        inline_layer = self.map.getLayerByName("INLINE")
         assert inline_layer.connectiontype == mapscript.MS_INLINE
         p = mapscript.pointObj(0.2, 51.5)
         lyr = mapscript.lineObj()
@@ -65,12 +67,12 @@ class InlineFeatureTestCase(MapTestCase)
         self.addLineToShape(shape, lyr)
         inline_layer.addFeature(shape)
         msimg = self.map.draw()
-        filename = 'testAddPointFeature.png'
+        filename = "testAddPointFeature.png"
         msimg.save(filename)
 
     def testGetShape(self):
         """returning the shape from an inline feature works"""
-        inline_layer = self.map.getLayerByName('INLINE')
+        inline_layer = self.map.getLayerByName("INLINE")
         inline_layer.open()
         inline_layer.template = "FAKE"
         inline_layer.queryByIndex(self.map, -1, 0)
@@ -83,33 +85,40 @@ class InlineFeatureTestCase(MapTestCase)
 
     def testGetNumFeatures(self):
         """the number of features in the inline layer is correct"""
-        inline_layer = self.map.getLayerByName('INLINE')
+        inline_layer = self.map.getLayerByName("INLINE")
         assert inline_layer.getNumFeatures() == 1
 
     def testShapeGeoInterface(self):
         """return the shape using the  __geo_interface__ protocol with no attribute names"""
-        layer = self.map.getLayerByName('POLYGON')
+        layer = self.map.getLayerByName("POLYGON")
         layer.open()
         layer.template = "FAKE"
         layer.queryByIndex(self.map, -1, 0)
         res = layer.getResult(0)
         s = layer.getShape(res)
         assert s.__geo_interface__ == {
-            'geometry': {
-                'type': 'Polygon',
-                'coordinates': [[(-0.25, 51.227222, 0.0), (-0.25, 51.727222, 0.0), (0.25, 51.727222, 0.0),
-                                 (0.25, 51.227222, 0.0), (-0.25, 51.227222, 0.0)]]
+            "geometry": {
+                "type": "Polygon",
+                "coordinates": [
+                    [
+                        (-0.25, 51.227222, 0.0),
+                        (-0.25, 51.727222, 0.0),
+                        (0.25, 51.727222, 0.0),
+                        (0.25, 51.227222, 0.0),
+                        (-0.25, 51.227222, 0.0),
+                    ]
+                ],
             },
-            'type': 'Feature',
-            'bbox': (-0.25, 51.227222, 0.25, 51.727222),
-            'properties': {'1': 'A Polygon', '0': '1'}
-         }
+            "type": "Feature",
+            "bbox": (-0.25, 51.227222, 0.25, 51.727222),
+            "properties": {"1": "A Polygon", "0": "1"},
+        }
 
         layer.close()
 
     def testShapeGeoInterfaceWithFields(self):
         """return the shape using the  __geo_interface__ protocol with attribute names"""
-        layer = self.map.getLayerByName('POINT')
+        layer = self.map.getLayerByName("POINT")
         layer.open()
         layer.template = "FAKE"
         layer.queryByIndex(self.map, -1, 0)
@@ -117,20 +126,16 @@ class InlineFeatureTestCase(MapTestCase)
         s = layer.getShape(res)
         s.itemdefinitions = layer.getItemDefinitions()
         assert s.__geo_interface__ == {
-            'geometry': {
-                'type': 'Point',
-                'coordinates': [[(0.0, 51.477222, 0.0)]]
-            },
-            'type': 'Feature',
-            'bbox': (0.0, 51.477222, 0.0, 51.477222),
-            'properties': {'FNAME': 'A Point', 'FID': 1}
-         }
+            "geometry": {"type": "Point", "coordinates": [[(0.0, 51.477222, 0.0)]]},
+            "type": "Feature",
+            "bbox": (0.0, 51.477222, 0.0, 51.477222),
+            "properties": {"FNAME": "A Point", "FID": 1},
+        }
 
         layer.close()
 
 
 class ShapeValuesTestCase(unittest.TestCase):
-
     def testNullValue(self):
         so = mapscript.shapeObj(mapscript.MS_SHAPE_POINT)
         assert so.numvalues == 0
@@ -139,10 +144,10 @@ class ShapeValuesTestCase(unittest.TestC
     def testSetValue(self):
         so = mapscript.shapeObj(mapscript.MS_SHAPE_POINT)
         so.initValues(4)
-        so.setValue(0, 'Foo')
+        so.setValue(0, "Foo")
         assert so.numvalues == 4
-        assert so.getValue(0) == 'Foo'
-        assert so.getValue(1) == ''
+        assert so.getValue(0) == "Foo"
+        assert so.getValue(1) == ""
 
 
 # New class for testing the WKT stuff of RFC-2
@@ -150,7 +155,7 @@ class ShapeWKTTestCase(unittest.TestCase
 
     # define a pair of coords, and WKT as class data
     point_xy = (-105.5000000000000000, 40.0000000000000000)
-    point_wkt = 'POINT (-105.5000000000000000 40.0000000000000000)'
+    point_wkt = "POINT (-105.5000000000000000 40.0000000000000000)"
 
     def testSetPointWKT(self):
         # Create new instance and set/init from WKT
@@ -178,5 +183,5 @@ class ShapeWKTTestCase(unittest.TestCase
         self.assertTrue(wkt == self.point_wkt, wkt)
 
 
-if __name__ == '__main__':
+if __name__ == "__main__":
     unittest.main()
diff -pruN 8.0.1-5/mapscript/python/tests/cases/shapefile_test.py 8.0.2-1/mapscript/python/tests/cases/shapefile_test.py
--- 8.0.1-5/mapscript/python/tests/cases/shapefile_test.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapscript/python/tests/cases/shapefile_test.py	2024-06-11 20:41:34.000000000 +0000
@@ -24,18 +24,19 @@
 # DEALINGS IN THE SOFTWARE.
 # ===========================================================================
 
-import unittest
 import os
+import unittest
+
 import mapscript
+
 from .testing import TESTS_PATH
 
 
 class AddShapeTestCase(unittest.TestCase):
-
     def testAddEmpty(self):
         """expect an error rather than segfault when adding an empty shape"""
         # See bug 1201
-        sf = mapscript.shapefileObj('testAddDud.shp', 1)
+        sf = mapscript.shapefileObj("testAddDud.shp", 1)
         so = mapscript.shapeObj(mapscript.MS_SHAPE_POINT)
         self.assertRaises(mapscript.MapServerError, sf.add, so)
 
@@ -45,9 +46,9 @@ class AddShapeTestCase(unittest.TestCase
         sf = mapscript.shapefileObj(pth)
         assert sf.getDBF() is not None, sf.getDBF()
         assert sf.getDBF().nFields == 2, sf.getDBF().nFields
-        assert sf.getDBF().getFieldName(0) == 'FID', sf.getDBF().getFieldName(0)
-        assert sf.getDBF().getFieldName(1) == 'FNAME', sf.getDBF().getFieldName(1)
+        assert sf.getDBF().getFieldName(0) == "FID", sf.getDBF().getFieldName(0)
+        assert sf.getDBF().getFieldName(1) == "FNAME", sf.getDBF().getFieldName(1)
 
 
-if __name__ == '__main__':
+if __name__ == "__main__":
     unittest.main()
diff -pruN 8.0.1-5/mapscript/python/tests/cases/style_test.py 8.0.2-1/mapscript/python/tests/cases/style_test.py
--- 8.0.1-5/mapscript/python/tests/cases/style_test.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapscript/python/tests/cases/style_test.py	2024-06-11 20:41:34.000000000 +0000
@@ -25,21 +25,27 @@
 # ===========================================================================
 
 import unittest
+
 import mapscript
+
 from .testing import MapTestCase
 
 
 class DrawProgrammedStylesTestCase(MapTestCase):
     def testDrawPoints(self):
         """DrawProgrammedStylesTestCase.testDrawPoints: point drawing with styles works as advertised"""
-        points = [mapscript.pointObj(-0.2, 51.6),
-                  mapscript.pointObj(0.0, 51.2),
-                  mapscript.pointObj(0.2, 51.6)]
-        colors = [mapscript.colorObj(255, 0, 0),
-                  mapscript.colorObj(0, 255, 0),
-                  mapscript.colorObj(0, 0, 255)]
+        points = [
+            mapscript.pointObj(-0.2, 51.6),
+            mapscript.pointObj(0.0, 51.2),
+            mapscript.pointObj(0.2, 51.6),
+        ]
+        colors = [
+            mapscript.colorObj(255, 0, 0),
+            mapscript.colorObj(0, 255, 0),
+            mapscript.colorObj(0, 0, 255),
+        ]
         img = self.map.prepareImage()
-        layer = self.map.getLayerByName('POINT')
+        layer = self.map.getLayerByName("POINT")
         # layer.draw(self.map, img)
         class0 = layer.getClass(0)
         for i in range(len(points)):
@@ -48,11 +54,10 @@ class DrawProgrammedStylesTestCase(MapTe
             # style0.color.pen = -4
             assert style0.color.toHex() == colors[i].toHex()
             points[i].draw(self.map, layer, img, 0, "foo")
-        img.save('test_draw_points.png')
+        img.save("test_draw_points.png")
 
 
 class NewStylesTestCase(MapTestCase):
-
     def testStyleConstructor(self):
         """a new style is properly initialized"""
         new_style = mapscript.styleObj()
@@ -63,10 +68,10 @@ class NewStylesTestCase(MapTestCase):
     def testCloneStyle(self):
         """check attributes of a cloned style"""
         new_style = mapscript.styleObj()
-        new_style.color.setHex('#808080')
+        new_style.color.setHex("#808080")
         clone = new_style.clone()
         assert clone.thisown == 1
-        assert clone.color.toHex() == '#808080'
+        assert clone.color.toHex() == "#808080"
 
     def testStyleColorSettable(self):
         """a style can be set with a color tuple"""
@@ -79,32 +84,32 @@ class NewStylesTestCase(MapTestCase):
     def testStyleBinding(self):
         """attribute binding can be set and get"""
         new_style = mapscript.styleObj()
-        assert (not new_style.getBinding(mapscript.MS_STYLE_BINDING_COLOR))
+        assert not new_style.getBinding(mapscript.MS_STYLE_BINDING_COLOR)
         new_style.setBinding(mapscript.MS_STYLE_BINDING_COLOR, "NEW_BINDING")
-        assert (new_style.getBinding(mapscript.MS_STYLE_BINDING_COLOR) == "NEW_BINDING")
+        assert new_style.getBinding(mapscript.MS_STYLE_BINDING_COLOR) == "NEW_BINDING"
 
     def testAppendNewStyle(self):
         """a new style can be appended properly"""
-        p_layer = self.map.getLayerByName('POINT')
+        p_layer = self.map.getLayerByName("POINT")
         class0 = p_layer.getClass(0)
         assert class0.numstyles == 2, class0.numstyles
         new_style = mapscript.styleObj()
         new_style.color.setRGB(0, 0, 0)
-        new_style.setSymbolByName(self.map, 'circle')
+        new_style.setSymbolByName(self.map, "circle")
         new_style.size = 3
         index = class0.insertStyle(new_style)
         assert index == 2, index
         assert class0.numstyles == 3, class0.numstyles
         msimg = self.map.draw()
         assert msimg.thisown == 1
-        filename = 'testAppendNewStyle.png'
-        fh = open(filename, 'wb')
+        filename = "testAppendNewStyle.png"
+        fh = open(filename, "wb")
         msimg.write(fh)
         fh.close()
 
     def testAppendNewStyleOldWay(self):
         """NewStylesTestCase.testAppendNewStyleOldWay: a new style can be appended properly using old method"""
-        p_layer = self.map.getLayerByName('POINT')
+        p_layer = self.map.getLayerByName("POINT")
         class0 = p_layer.getClass(0)
         assert class0.numstyles == 2, class0.numstyles
         new_style = mapscript.styleObj(class0)
@@ -113,14 +118,14 @@ class NewStylesTestCase(MapTestCase):
         new_style.symbol = 1
         new_style.size = 3
         msimg = self.map.draw()
-        filename = 'testAppendNewStyleOldWay.png'
-        fh = open(filename, 'wb')
+        filename = "testAppendNewStyleOldWay.png"
+        fh = open(filename, "wb")
         msimg.write(fh)
         fh.close()
 
     def testInsertNewStyleAtIndex0(self):
         """NewStylesTestCase.testInsertNewStyleAtIndex0: a new style can be inserted ahead of all others"""
-        l_layer = self.map.getLayerByName('LINE')
+        l_layer = self.map.getLayerByName("LINE")
         class0 = l_layer.getClass(0)
         new_style = mapscript.styleObj()
         new_style.color.setRGB(255, 255, 0)
@@ -131,46 +136,47 @@ class NewStylesTestCase(MapTestCase):
         assert class0.numstyles == 2, class0.numstyles
         msimg = self.map.draw()
         assert msimg.thisown == 1
-        filename = 'testInsertNewStyleAtIndex0.png'
-        fh = open(filename, 'wb')
+        filename = "testInsertNewStyleAtIndex0.png"
+        fh = open(filename, "wb")
         msimg.write(fh)
         fh.close()
 
     def testRemovePointStyle(self):
         """NewStylesTestCase.testRemovePointStyle: a point style can be properly removed"""
-        p_layer = self.map.getLayerByName('POINT')
+        p_layer = self.map.getLayerByName("POINT")
         class0 = p_layer.getClass(0)
         rem_style = class0.removeStyle(1)
         assert rem_style is not None
         assert class0.numstyles == 1, class0.numstyles
         msimg = self.map.draw()
-        filename = 'testRemovePointStyle.png'
+        filename = "testRemovePointStyle.png"
         msimg.save(filename)
 
     def testModifyMultipleStyle(self):
         """NewStylesTestCase.testModifyMultipleStyle: multiple styles can be modified"""
-        p_layer = self.map.getLayerByName('POINT')
+        p_layer = self.map.getLayerByName("POINT")
         class0 = p_layer.getClass(0)
         style1 = class0.getStyle(1)
         style1.color.setRGB(255, 255, 0)
         msimg = self.map.draw()
-        filename = 'testModifyMutiplePointStyle.png'
+        filename = "testModifyMutiplePointStyle.png"
         msimg.save(filename)
 
     def testInsertStylePastEnd(self):
         """NewStylesTestCase.testInsertStylePastEnd: inserting a style past the end of
         the list raises the proper error"""
-        p_layer = self.map.getLayerByName('POINT')
+        p_layer = self.map.getLayerByName("POINT")
         class0 = p_layer.getClass(0)
         new_style = mapscript.styleObj()
-        self.assertRaises(mapscript.MapServerChildError, class0.insertStyle, new_style, 6)
+        self.assertRaises(
+            mapscript.MapServerChildError, class0.insertStyle, new_style, 6
+        )
 
     def testInsertNULLStyle(self):
         """attempt to insert a NULL style should raise error"""
-        p_layer = self.map.getLayerByName('POINT')
+        p_layer = self.map.getLayerByName("POINT")
         class0 = p_layer.getClass(0)
-        self.assertRaises(mapscript.MapServerChildError,
-                          class0.insertStyle, None)
+        self.assertRaises(mapscript.MapServerChildError, class0.insertStyle, None)
 
     def testConvertToString(self):
         """ensure styles can be created and output to strings
@@ -249,10 +255,9 @@ class NewStylesTestCase(MapTestCase):
 
 
 class BrushCachingTestCase(MapTestCase):
-
     def testDrawMapWithSecondPolygon(self):
         """draw a blue polygon and a red polygon"""
-        p = self.map.getLayerByName('POLYGON')
+        p = self.map.getLayerByName("POLYGON")
         ip = mapscript.layerObj(self.map)
         ip.type = mapscript.MS_LAYER_POLYGON
         ip.status = mapscript.MS_DEFAULT
@@ -275,13 +280,15 @@ class BrushCachingTestCase(MapTestCase):
         s0 = p.getShape(res)
         p.close()
         r0 = s0.bounds
-        r1 = mapscript.rectObj(r0.minx-0.1, r0.miny-0.1, r0.maxx-0.1, r0.maxy-0.1)
+        r1 = mapscript.rectObj(
+            r0.minx - 0.1, r0.miny - 0.1, r0.maxx - 0.1, r0.maxy - 0.1
+        )
         s1 = r1.toPolygon()
 
         ip.addFeature(s1)
         img = self.map.draw()
-        img.save('test_drawmapw2ndpolygon.png')
+        img.save("test_drawmapw2ndpolygon.png")
 
 
-if __name__ == '__main__':
+if __name__ == "__main__":
     unittest.main()
diff -pruN 8.0.1-5/mapscript/python/tests/cases/symbol_test.py 8.0.2-1/mapscript/python/tests/cases/symbol_test.py
--- 8.0.1-5/mapscript/python/tests/cases/symbol_test.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapscript/python/tests/cases/symbol_test.py	2024-06-11 20:41:34.000000000 +0000
@@ -26,53 +26,53 @@
 
 import unittest
 from io import BytesIO
+
 import mapscript
-from .testing import MapTestCase, XMARKS_IMAGE, HOME_IMAGE
 
+from .testing import HOME_IMAGE, XMARKS_IMAGE, MapTestCase
 
-class SymbolTestCase(unittest.TestCase):
 
+class SymbolTestCase(unittest.TestCase):
     def testConstructor(self):
         """create new instance of symbolObj"""
-        symbol = mapscript.symbolObj('test')
-        assert symbol.name == 'test'
+        symbol = mapscript.symbolObj("test")
+        assert symbol.name == "test"
         assert symbol.thisown == 1
 
     def testConstructorImage(self):
         """create new instance of symbolObj from an image"""
-        symbol = mapscript.symbolObj('xmarks', XMARKS_IMAGE)
-        assert symbol.name == 'xmarks'
+        symbol = mapscript.symbolObj("xmarks", XMARKS_IMAGE)
+        assert symbol.name == "xmarks"
         assert symbol.type == mapscript.MS_SYMBOL_VECTOR  # was MS_SYMBOL_PIXMAP!
-        format = mapscript.outputFormatObj('AGG/PNG')
+        format = mapscript.outputFormatObj("AGG/PNG")
         img = symbol.getImage(format)
-        img.save('sym-%s.%s' % (symbol.name, img.format.extension))
+        img.save("sym-%s.%s" % (symbol.name, img.format.extension))
 
 
-class DynamicGraphicSymbolTestCase():
-
+class DynamicGraphicSymbolTestCase:
     def setUp(self):
         MapTestCase.setUp(self)
-        with open(HOME_IMAGE, 'rb') as fh:
+        with open(HOME_IMAGE, "rb") as fh:
             s = BytesIO(fh.read())
         symb_img = mapscript.imageObj(s)
-        self.h_symbol = mapscript.symbolObj('house')
+        self.h_symbol = mapscript.symbolObj("house")
         self.h_symbol.type = mapscript.MS_SYMBOL_PIXMAP
         self.h_symbol.setImage(symb_img)
-        with open(XMARKS_IMAGE, 'rb') as fh:
+        with open(XMARKS_IMAGE, "rb") as fh:
             s = BytesIO(fh.read())
         symb_img = mapscript.imageObj(s)
-        self.x_symbol = mapscript.symbolObj('xmarks')
+        self.x_symbol = mapscript.symbolObj("xmarks")
         self.x_symbol.type = mapscript.MS_SYMBOL_PIXMAP
         self.x_symbol.setImage(symb_img)
 
     def testSetPCTImage(self):
         """set image of new symbolObj"""
-        assert self.h_symbol.name == 'house'
+        assert self.h_symbol.name == "house"
         assert self.h_symbol.type == mapscript.MS_SYMBOL_PIXMAP
-        format = mapscript.outputFormatObj('AGG/PNG')
+        format = mapscript.outputFormatObj("AGG/PNG")
         format.transparent = mapscript.MS_ON
         img = self.h_symbol.getImage(format)
-        img.save('set-%s.%s' % (self.h_symbol.name, img.format.extension))
+        img.save("set-%s.%s" % (self.h_symbol.name, img.format.extension))
 
     def testDrawSetPCTImage(self):
         """draw a map using the set image symbol"""
@@ -80,39 +80,38 @@ class DynamicGraphicSymbolTestCase():
         assert symbol_index == 4, symbol_index
         num = self.map.symbolset.numsymbols
         assert num == 5, num
-        inline_layer = self.map.getLayerByName('INLINE')
+        inline_layer = self.map.getLayerByName("INLINE")
         s = inline_layer.getClass(0).getStyle(0)
         s.symbol = symbol_index
         s.size = -1  # pixmap's own size
         img = self.map.draw()
-        img.save('testDrawSetPCTImage.%s' % (img.format.extension))
+        img.save("testDrawSetPCTImage.%s" % (img.format.extension))
 
     def testSetRGBAImage(self):
         """set image of new symbolObj"""
-        assert self.x_symbol.name == 'xmarks'
+        assert self.x_symbol.name == "xmarks"
         assert self.x_symbol.type == mapscript.MS_SYMBOL_PIXMAP
-        format = mapscript.outputFormatObj('AGG/PNG')
+        format = mapscript.outputFormatObj("AGG/PNG")
         img = self.x_symbol.getImage(format)
-        img.save('set-%s.%s' % (self.x_symbol.name, img.format.extension))
+        img.save("set-%s.%s" % (self.x_symbol.name, img.format.extension))
 
     def testDrawSetRGBAImage(self):
         """draw a map using the set image symbol"""
         symbol_index = self.map.symbolset.appendSymbol(self.x_symbol)
-        inline_layer = self.map.getLayerByName('INLINE')
+        inline_layer = self.map.getLayerByName("INLINE")
         s = inline_layer.getClass(0).getStyle(0)
         s.symbol = symbol_index
         s.size = -1  # pixmap's own size
-        self.map.selectOutputFormat('PNG24')
+        self.map.selectOutputFormat("PNG24")
         img = self.map.draw()
-        img.save('testDrawSetRGBAImage.%s' % (img.format.extension))
+        img.save("testDrawSetRGBAImage.%s" % (img.format.extension))
 
 
 class MapSymbolTestCase(MapTestCase):
-
     def testGetPoints(self):
         """get symbol points as line and test coords"""
         symbol = self.map.symbolset.getSymbol(1)
-        assert symbol.name == 'circle'
+        assert symbol.name == "circle"
         line = symbol.getPoints()
         assert line.numpoints == 1, line.numpoints
         pt = self.getPointFromLine(line, 0)
@@ -121,7 +120,7 @@ class MapSymbolTestCase(MapTestCase):
     def testSetPoints(self):
         """add lines of points to an existing symbol"""
         symbol = self.map.symbolset.getSymbol(1)
-        assert symbol.name == 'circle'
+        assert symbol.name == "circle"
         line = mapscript.lineObj()
         self.addPointToLine(line, mapscript.pointObj(2.0, 2.0))
         self.addPointToLine(line, mapscript.pointObj(3.0, 3.0))
@@ -142,20 +141,20 @@ class MapSymbolTestCase(MapTestCase):
 
     def testRGBASymbolInPNG24(self):
         """draw a RGBA PNG pixmap on PNG canvas"""
-        self.map.setImageType('PNG24')
+        self.map.setImageType("PNG24")
         # self.map.getLayerByName('INLINE-PIXMAP-RGBA').status \
         #    == mapscript.MS_DEFAULT
         img = self.map.draw()
-        img.save('pixmap-rgba-24.png')
+        img.save("pixmap-rgba-24.png")
 
     def testRGBASymbolInJPEG(self):
         """draw a RGBA PNG pixmap on JPEG canvas"""
-        self.map.setImageType('JPEG')
+        self.map.setImageType("JPEG")
         # self.map.getLayerByName('INLINE-PIXMAP-RGBA').status \
         #    == mapscript.MS_DEFAULT
         img = self.map.draw()
-        img.save('pixmap-rgba.jpg')
+        img.save("pixmap-rgba.jpg")
 
 
-if __name__ == '__main__':
+if __name__ == "__main__":
     unittest.main()
diff -pruN 8.0.1-5/mapscript/python/tests/cases/symbolset_test.py 8.0.2-1/mapscript/python/tests/cases/symbolset_test.py
--- 8.0.1-5/mapscript/python/tests/cases/symbolset_test.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapscript/python/tests/cases/symbolset_test.py	2024-06-11 20:41:34.000000000 +0000
@@ -26,14 +26,15 @@
 
 import os
 import unittest
+
 import mapscript
-from .testing import MapTestCase, XMARKS_IMAGE, TESTS_PATH
+
+from .testing import TESTS_PATH, XMARKS_IMAGE, MapTestCase
 
 SYMBOLSET = os.path.join(TESTS_PATH, "symbols.txt")
 
 
 class SymbolSetTestCase(unittest.TestCase):
-
     def testConstructorNoArgs(self):
         """new instance of symbolSetObj should have one symbol"""
         symbolset = mapscript.symbolSetObj()
@@ -49,13 +50,13 @@ class SymbolSetTestCase(unittest.TestCas
     def testAddSymbolToNewSymbolSet(self):
         """add two new symbols to a SymbolSet"""
         symbolset = mapscript.symbolSetObj(SYMBOLSET)
-        symbola = mapscript.symbolObj('testa')
-        symbolb = mapscript.symbolObj('testb')
+        symbola = mapscript.symbolObj("testa")
+        symbolb = mapscript.symbolObj("testb")
         symbolset.appendSymbol(symbola)
         symbolset.appendSymbol(symbolb)
         num = symbolset.numsymbols
         assert num == 6, num
-        names = [None, 'circle', 'xmarks-png', 'home-png', 'testa', 'testb']
+        names = [None, "circle", "xmarks-png", "home-png", "testa", "testb"]
         for i in range(symbolset.numsymbols):
             symbol = symbolset.getSymbol(i)
             assert symbol.name == names[i], symbol.name
@@ -70,23 +71,24 @@ class SymbolSetTestCase(unittest.TestCas
     def testSaveNewSymbolSet(self):
         """save a new SymbolSet to disk"""
         symbolset = mapscript.symbolSetObj(SYMBOLSET)
-        symbola = mapscript.symbolObj('testa')
-        symbolb = mapscript.symbolObj('testb')
+        symbola = mapscript.symbolObj("testa")
+        symbolb = mapscript.symbolObj("testb")
         symbolset.appendSymbol(symbola)
         symbolset.appendSymbol(symbolb)
-        assert symbolset.save('new_symbols.txt') == mapscript.MS_SUCCESS
+        assert symbolset.save("new_symbols.txt") == mapscript.MS_SUCCESS
 
     def testError(self):
         symbolset = mapscript.symbolSetObj(SYMBOLSET)
-        symbola = mapscript.symbolObj('testa')
-        symbolb = mapscript.symbolObj('testb')
+        symbola = mapscript.symbolObj("testa")
+        symbolb = mapscript.symbolObj("testb")
         symbolset.appendSymbol(symbola)
         symbolset.appendSymbol(symbolb)
-        self.assertRaises(mapscript.MapServerError, symbolset.save, '/bogus/new_symbols.txt')
+        self.assertRaises(
+            mapscript.MapServerError, symbolset.save, "/bogus/new_symbols.txt"
+        )
 
 
 class MapSymbolSetTestCase(MapTestCase):
-
     def testGetNumSymbols(self):
         """expect getNumSymbols == 2 from test fixture test.map"""
         num = self.map.getNumSymbols()
@@ -100,23 +102,23 @@ class MapSymbolSetTestCase(MapTestCase):
     def testSymbolSetSymbolNames(self):
         """test names of symbols in test fixture's symbolset"""
         set = self.map.symbolset
-        names = [None, 'circle', 'xmarks-png', 'home-png']
+        names = [None, "circle", "xmarks-png", "home-png"]
         for i in range(set.numsymbols):
             symbol = set.getSymbol(i)
             assert symbol.name == names[i], symbol.name
 
     def testSymbolIndex(self):
         """expect index of 'circle' symbol to be 1 in test fixture symbolset"""
-        i = self.map.symbolset.index('circle')
+        i = self.map.symbolset.index("circle")
         assert i == 1, i
 
     def testBug1962(self):
         """resetting imagepath doesn't cause segfault"""
-        layer = self.map.getLayerByName('POINT')
+        layer = self.map.getLayerByName("POINT")
         style0 = layer.getClass(0).getStyle(0)
         sym0 = style0.symbol
         sym1 = self.map.symbolset.getSymbol(sym0)
-        sym2 = mapscript.symbolObj('xxx')
+        sym2 = mapscript.symbolObj("xxx")
         assert sym2 is not None
         sym1.setImagepath(XMARKS_IMAGE)
         # self.assertRaises(IOError, sym1.setImagepath, '/bogus/new_symbols.txt')
@@ -124,29 +126,29 @@ class MapSymbolSetTestCase(MapTestCase):
         msimg = self.map.draw()
         assert msimg.thisown == 1
         data = msimg.getBytes()
-        filename = 'testBug1962.png'
-        fh = open(filename, 'wb')
+        filename = "testBug1962.png"
+        fh = open(filename, "wb")
         fh.write(data)
         fh.close()
 
     def testDrawNewSymbol(self):
         """draw using a new symbol added to the fixture"""
-        symbol = mapscript.symbolObj('xmarks', XMARKS_IMAGE)
+        symbol = mapscript.symbolObj("xmarks", XMARKS_IMAGE)
         symbol_index = self.map.symbolset.appendSymbol(symbol)
         assert symbol_index == 4, symbol_index
         num = self.map.symbolset.numsymbols
         assert num == 5, num
-        inline_layer = self.map.getLayerByName('INLINE')
+        inline_layer = self.map.getLayerByName("INLINE")
         s = inline_layer.getClass(0).getStyle(0)
         s.symbol = symbol_index
         # s.size = 24
         msimg = self.map.draw()
         assert msimg.thisown == 1
-        filename = 'testDrawNewSymbol.png'
-        fh = open(filename, 'wb')
+        filename = "testDrawNewSymbol.png"
+        fh = open(filename, "wb")
         msimg.write(fh)
         fh.close()
 
 
-if __name__ == '__main__':
+if __name__ == "__main__":
     unittest.main()
diff -pruN 8.0.1-5/mapscript/python/tests/cases/testing.py 8.0.2-1/mapscript/python/tests/cases/testing.py
--- 8.0.1-5/mapscript/python/tests/cases/testing.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapscript/python/tests/cases/testing.py	2024-06-11 20:41:34.000000000 +0000
@@ -32,17 +32,18 @@
 # ===========================================================================
 
 import os
-import unittest
 import tempfile
+import unittest
+
 import mapscript
 
 # define the path to mapserver test data
 TESTS_PATH = os.path.abspath(os.path.join(os.path.dirname(__file__), "data"))
-TESTMAPFILE = os.path.join(TESTS_PATH, 'test.map')
-TESTCONFIGFILE = os.path.join(TESTS_PATH, 'mapserver-sample.conf')
-XMARKS_IMAGE = os.path.join(TESTS_PATH, 'xmarks.png')
-HOME_IMAGE = os.path.join(TESTS_PATH, 'home.png')
-TEST_IMAGE = os.path.join(TESTS_PATH, 'test.png')
+TESTMAPFILE = os.path.join(TESTS_PATH, "test.map")
+TESTCONFIGFILE = os.path.join(TESTS_PATH, "mapserver-sample.conf")
+XMARKS_IMAGE = os.path.join(TESTS_PATH, "xmarks.png")
+HOME_IMAGE = os.path.join(TESTS_PATH, "home.png")
+TEST_IMAGE = os.path.join(TESTS_PATH, "test.png")
 
 INCOMING = tempfile.mkdtemp(prefix="mapscript")
 
@@ -50,6 +51,7 @@ INCOMING = tempfile.mkdtemp(prefix="maps
 # ==========================================================================
 # Base testing classes
 
+
 class MapPrimitivesTestCase(unittest.TestCase):
     """Base class for testing primitives (points, lines, shapes)
     in stand-alone mode"""
@@ -121,6 +123,7 @@ class MapPrimitivesTestCase(unittest.Tes
 
 class MapTestCase(MapPrimitivesTestCase):
     """Base class for testing with a map fixture"""
+
     def setUp(self):
         self.map = mapscript.mapObj(TESTMAPFILE)
         # self.xmarks_image = xmarks_image
@@ -132,6 +135,7 @@ class MapTestCase(MapPrimitivesTestCase)
 
 class MapZoomTestCase(MapPrimitivesTestCase):
     "Testing new zoom* methods that we are adapting from the PHP MapScript"
+
     def setUp(self):
         self.mapobj1 = mapscript.mapObj(TESTMAPFILE)
         # Change the extent for purposes of zoom testing
@@ -147,4 +151,5 @@ class MapZoomTestCase(MapPrimitivesTestC
 
 class ShapeObjTestCase(MapPrimitivesTestCase):
     """Base class for shapeObj tests"""
+
     pass
diff -pruN 8.0.1-5/mapscript/python/tests/cases/thread_test.py 8.0.2-1/mapscript/python/tests/cases/thread_test.py
--- 8.0.1-5/mapscript/python/tests/cases/thread_test.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapscript/python/tests/cases/thread_test.py	2024-06-11 20:41:34.000000000 +0000
@@ -25,10 +25,12 @@
 # ===========================================================================
 
 import os
-import unittest
 import threading
+import unittest
+
 import mapscript
-from .testing import TESTMAPFILE, INCOMING
+
+from .testing import INCOMING, TESTMAPFILE
 
 
 def draw_map(name, save=0):
@@ -37,7 +39,7 @@ def draw_map(name, save=0):
     mo = mapscript.mapObj(TESTMAPFILE)
     im = mo.draw()
     if save:
-        im.save('threadtest_%s.png' % (name))
+        im.save("threadtest_%s.png" % (name))
 
 
 def trigger_exception(name):
@@ -52,13 +54,12 @@ def trigger_exception(name):
 
 
 class MultipleThreadsTestCase(unittest.TestCase):
-
     def testDrawMultiThreads(self):
         """map drawing with multiple threads"""
 
         workers = []
         for i in range(10):
-            name = 'd%d' % (i)
+            name = "d%d" % (i)
             thread = threading.Thread(target=draw_map, name=name, args=(name, 1))
             workers.append(thread)
             thread.start()
@@ -68,7 +69,7 @@ class MultipleThreadsTestCase(unittest.T
 
         workers = []
         for i in range(10):
-            name = 'e%d' % (i)
+            name = "e%d" % (i)
             thread = threading.Thread(target=trigger_exception, name=name, args=(name,))
             workers.append(thread)
             thread.start()
@@ -80,13 +81,13 @@ class MultipleThreadsTestCase(unittest.T
 
         # Trigger an exception in the first started thread
         for i in range(0, 1):
-            name = 'c%d' % (i)
+            name = "c%d" % (i)
             thread = threading.Thread(target=trigger_exception, name=name, args=(name,))
             workers.append(thread)
 
         # Draw normally
         for i in range(1, num):
-            name = 'c%d' % (i)
+            name = "c%d" % (i)
             thread = threading.Thread(target=draw_map, name=name, args=(name,))
             workers.append(thread)
 
@@ -102,32 +103,32 @@ def draw_map_wfs(name, save=0):
 
     # WFS layer
     lo = mapscript.layerObj()
-    lo.name = 'cheapo_wfs'
-    lo.setProjection('+init=epsg:4326')
+    lo.name = "cheapo_wfs"
+    lo.setProjection("+init=epsg:4326")
     lo.connectiontype = mapscript.MS_WFS
-    lo.connection = 'http://zcologia.com:9001/mapserver/members/features.rpy?'
-    lo.metadata.set('wfs_service', 'WFS')
-    lo.metadata.set('wfs_typename', 'users')
-    lo.metadata.set('wfs_version', '1.0.0')
+    lo.connection = "http://zcologia.com:9001/mapserver/members/features.rpy?"
+    lo.metadata.set("wfs_service", "WFS")
+    lo.metadata.set("wfs_typename", "users")
+    lo.metadata.set("wfs_version", "1.0.0")
     lo.type = mapscript.MS_LAYER_POINT
     lo.status = mapscript.MS_DEFAULT
-    lo.labelitem = 'zco:mid'
+    lo.labelitem = "zco:mid"
 
     so1 = mapscript.styleObj()
-    so1.color.setHex('#FFFFFF')
+    so1.color.setHex("#FFFFFF")
     so1.size = 9
     so1.symbol = 1  # mo.symbolset.index('circle')
 
     so2 = mapscript.styleObj()
-    so2.color.setHex('#333333')
+    so2.color.setHex("#333333")
     so2.size = 7
     so2.symbol = 1  # mo.symbolset.index('circle')
 
     co = mapscript.classObj()
     co.label.type = mapscript.MS_BITMAP
     co.label.size = mapscript.MS_SMALL
-    co.label.color.setHex('#000000')
-    co.label.outlinecolor.setHex('#FFFFFF')
+    co.label.color.setHex("#000000")
+    co.label.outlinecolor.setHex("#FFFFFF")
     co.label.position = mapscript.MS_AUTO
 
     co.insertStyle(so1)
@@ -136,11 +137,11 @@ def draw_map_wfs(name, save=0):
     mo.insertLayer(lo)
 
     if not mo.web.imagepath:
-        mo.web.imagepath = os.environ.get('TEMP', None) or INCOMING
+        mo.web.imagepath = os.environ.get("TEMP", None) or INCOMING
     mo.debug = mapscript.MS_ON
     im = mo.draw()
     if save:
-        im.save('threadtest_wfs_%s.png' % (name))
+        im.save("threadtest_wfs_%s.png" % (name))
 
 
 def draw_map_wms(name, save=0):
@@ -149,27 +150,27 @@ def draw_map_wms(name, save=0):
     mo = mapscript.mapObj(TESTMAPFILE)
     # WFS layer
     lo = mapscript.layerObj()
-    lo.name = 'jpl_wms'
-    lo.setProjection('+init=epsg:4326')
+    lo.name = "jpl_wms"
+    lo.setProjection("+init=epsg:4326")
     lo.connectiontype = mapscript.MS_WMS
-    lo.connection = 'http://vmap0.tiles.osgeo.org/wms/vmap0?'
-    lo.metadata.set('wms_service', 'WMS')
-    lo.metadata.set('wms_server_version', '1.1.1')
-    lo.metadata.set('wms_name', 'basic')
-    lo.metadata.set('wms_style', 'visual')
-    lo.metadata.set('wms_format', 'image/jpeg')
+    lo.connection = "http://vmap0.tiles.osgeo.org/wms/vmap0?"
+    lo.metadata.set("wms_service", "WMS")
+    lo.metadata.set("wms_server_version", "1.1.1")
+    lo.metadata.set("wms_name", "basic")
+    lo.metadata.set("wms_style", "visual")
+    lo.metadata.set("wms_format", "image/jpeg")
     lo.type = mapscript.MS_LAYER_RASTER
     lo.status = mapscript.MS_DEFAULT
     lo.debug = mapscript.MS_ON
     mo.insertLayer(lo)
 
     if not mo.web.imagepath:
-        mo.web.imagepath = os.environ.get('TEMP', None) or INCOMING
+        mo.web.imagepath = os.environ.get("TEMP", None) or INCOMING
     mo.debug = mapscript.MS_ON
-    mo.selectOutputFormat('image/jpeg')
+    mo.selectOutputFormat("image/jpeg")
     im = mo.draw()
     if save:
-        im.save('threadtest_wms_%s.jpg' % (name))
+        im.save("threadtest_wms_%s.jpg" % (name))
 
 
 class OWSRequestTestCase(unittest.TestCase):
@@ -185,11 +186,11 @@ class OWSRequestTestCase(unittest.TestCa
     def testDrawWMS(self):
         workers = []
         for i in range(10):
-            name = 'd%d' % (i)
+            name = "d%d" % (i)
             thread = threading.Thread(target=draw_map_wms, name=name, args=(name, 1))
             workers.append(thread)
             thread.start()
 
 
-if __name__ == '__main__':
+if __name__ == "__main__":
     unittest.main()
diff -pruN 8.0.1-5/mapscript/python/tests/cases/zoom_test.py 8.0.2-1/mapscript/python/tests/cases/zoom_test.py
--- 8.0.1-5/mapscript/python/tests/cases/zoom_test.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapscript/python/tests/cases/zoom_test.py	2024-06-11 20:41:34.000000000 +0000
@@ -25,12 +25,13 @@
 # ===========================================================================
 
 import unittest
+
 import mapscript
+
 from .testing import MapZoomTestCase
 
 
 class ZoomPointTestCase(MapZoomTestCase):
-
     def testRecenter(self):
         """ZoomPointTestCase.testRecenter: recentering the map with a point returns the same extent"""
         w, h = (self.mapobj1.width, self.mapobj1.height)
@@ -78,8 +79,9 @@ class ZoomPointTestCase(MapZoomTestCase)
         extent = self.mapobj1.extent
         w = 0
         h = -1
-        self.assertRaises(mapscript.MapServerError,
-                          self.mapobj1.zoomPoint, -2, p, w, h, extent, None)
+        self.assertRaises(
+            mapscript.MapServerError, self.mapobj1.zoomPoint, -2, p, w, h, extent, None
+        )
 
     def testZoomBadExtent(self):
         """ZoomPointTestCase.testZoomBadExtent: zooming to a bad extent raises proper error"""
@@ -89,12 +91,12 @@ class ZoomPointTestCase(MapZoomTestCase)
         extent.maxx = extent.maxx - 1000000
         w = 100
         h = 100
-        self.assertRaises(mapscript.MapServerError,
-                          self.mapobj1.zoomPoint, -2, p, w, h, extent, None)
+        self.assertRaises(
+            mapscript.MapServerError, self.mapobj1.zoomPoint, -2, p, w, h, extent, None
+        )
 
 
 class ZoomRectangleTestCase(MapZoomTestCase):
-
     def testZoomRectangle(self):
         """ZoomRectangleTestCase.testZoomRectangle: zooming to an extent returns proper map extent"""
         w, h = (self.mapobj1.width, self.mapobj1.height)
@@ -119,12 +121,12 @@ class ZoomRectangleTestCase(MapZoomTestC
         w, h = (self.mapobj1.width, self.mapobj1.height)
         r = mapscript.rectObj(0, 0, 200, 200)
         extent = self.mapobj1.extent
-        self.assertRaises(mapscript.MapServerError,
-                          self.mapobj1.zoomRectangle, r, w, h, extent, None)
+        self.assertRaises(
+            mapscript.MapServerError, self.mapobj1.zoomRectangle, r, w, h, extent, None
+        )
 
 
 class ZoomScaleTestCase(MapZoomTestCase):
-
     def testRecenter(self):
         """ZoomScaleTestCase.testRecenter: recentering map returns proper extent"""
         w, h = (self.mapobj1.width, self.mapobj1.height)  # 100 by 100
@@ -148,7 +150,9 @@ class ZoomScaleTestCase(MapZoomTestCase)
         self.mapobj1.zoomScale(scale, p, w, h, extent, None)
         new_extent = self.mapobj1.extent
         # self.assertRectsEqual(new_extent, mapscript.rectObj(-25, -25, 25, 25))  # old values
-        self.assertRectsEqual(new_extent, mapscript.rectObj(-24.75, -24.75, 24.75, 24.75))
+        self.assertRectsEqual(
+            new_extent, mapscript.rectObj(-24.75, -24.75, 24.75, 24.75)
+        )
 
     def testZoomOutScale(self):
         """ZoomScaleTestCase.testZoomOutScale: zooming out to a specified scale returns proper extent"""
@@ -176,5 +180,5 @@ class ZoomScaleTestCase(MapZoomTestCase)
         self.assertRectsEqual(new_extent, max)
 
 
-if __name__ == '__main__':
+if __name__ == "__main__":
     unittest.main()
diff -pruN 8.0.1-5/mapscript/python/tests/runalldoctests.py 8.0.2-1/mapscript/python/tests/runalldoctests.py
--- 8.0.1-5/mapscript/python/tests/runalldoctests.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapscript/python/tests/runalldoctests.py	2024-06-11 20:41:34.000000000 +0000
@@ -5,18 +5,21 @@ import sys
 
 try:
     import pkg_resources
-    pkg_resources.require('mapscript')
+
+    pkg_resources.require("mapscript")
 except (ImportError, pkg_resources.DistributionNotFound):
     pass
 
+
 def run(pattern):
     if pattern is None:
-        testfiles = glob.glob('*.txt')
+        testfiles = glob.glob("*.txt")
     else:
         testfiles = glob.glob(pattern)
-    for file in testfiles: 
+    for file in testfiles:
         doctest.testfile(file)
 
+
 if __name__ == "__main__":
     try:
         opts, args = getopt.getopt(sys.argv[1:], "t:v")
@@ -25,7 +28,6 @@ if __name__ == "__main__":
         sys.exit(2)
     pattern = None
     for o, a in opts:
-        if o == '-t':
+        if o == "-t":
             pattern = a
     run(pattern)
-
diff -pruN 8.0.1-5/mapscript/python/tests/runtests.py 8.0.2-1/mapscript/python/tests/runtests.py
--- 8.0.1-5/mapscript/python/tests/runtests.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapscript/python/tests/runtests.py	2024-06-11 20:41:34.000000000 +0000
@@ -6,7 +6,7 @@
 #
 # ===========================================================================
 # Copyright (c) 2004, Sean Gillies
-# 
+#
 # Permission is hereby granted, free of charge, to any person obtaining a
 # copy of this software and associated documentation files (the "Software"),
 # to deal in the Software without restriction, including without limitation
@@ -35,59 +35,48 @@
 import unittest
 
 # Import test cases
-import cases
-
-from cases.recttest import RectObjTestCase
-
-from cases.hashtest import HashTableTestCase, WebMetadataTestCase
-from cases.hashtest import LayerMetadataTestCase, ClassMetadataTestCase
-
-from cases.owstest import OWSRequestTestCase
 from cases.clonetest import MapCloningTestCase
-
+from cases.colortest import ColorObjTestCase
+from cases.hashtest import (
+    ClassMetadataTestCase,
+    HashTableTestCase,
+    LayerMetadataTestCase,
+    WebMetadataTestCase,
+)
 from cases.imagetest import ImageObjTestCase, ImageWriteTestCase
-
-from cases.maptest import MapConstructorTestCase
-from cases.maptest import MapLayersTestCase
-from cases.maptest import MapExtentTestCase
-from cases.maptest import MapExceptionTestCase
-from cases.maptest import EmptyMapExceptionTestCase
-from cases.maptest import MapSizeTestCase
-
-from cases.layertest import LayerConstructorTestCase
-from cases.layertest import LayerExtentTestCase
-from cases.layertest import LayerRasterProcessingTestCase
-from cases.layertest import LayerTestCase
-from cases.layertest import RemoveLayerTestCase
-
-from cases.zoomtest import ZoomPointTestCase
-from cases.zoomtest import ZoomRectangleTestCase
-from cases.zoomtest import ZoomScaleTestCase
-
+from cases.labeltest import LabelCacheMemberTestCase
+from cases.layertest import (
+    LayerConstructorTestCase,
+    LayerExtentTestCase,
+    LayerRasterProcessingTestCase,
+    RemoveLayerTestCase,
+)
 from cases.linetest import LineObjTestCase
-from cases.shapetest import ShapePointTestCase
+from cases.maptest import (
+    EmptyMapExceptionTestCase,
+    MapConstructorTestCase,
+    MapExceptionTestCase,
+    MapExtentTestCase,
+    MapLayersTestCase,
+)
+from cases.outputformattest import MapOutputFormatTestCase, OutputFormatTestCase
+from cases.owstest import OWSRequestTestCase
 from cases.pointtest import PointObjTestCase
-from cases.shapetest import InlineFeatureTestCase
-
-from cases.styletest import DrawProgrammedStylesTestCase
-from cases.styletest import NewStylesTestCase
-from cases.styletest import BrushCachingTestCase
-from cases.colortest import ColorObjTestCase
-
-from cases.symboltest import SymbolTestCase
-from cases.symboltest import MapSymbolTestCase
-
-from cases.symbolsettest import SymbolSetTestCase
-from cases.symbolsettest import MapSymbolSetTestCase
-
-from cases.outputformattest import OutputFormatTestCase
-from cases.outputformattest import MapOutputFormatTestCase
-
-from cases.labeltest import LabelCacheMemberTestCase
-
-from cases.resultcachetest import ResultCacheTestCase
-from cases.resultcachetest import PointQueryResultsTestCase
-from cases.resultcachetest import DumpAndLoadTestCase
+from cases.recttest import RectObjTestCase
+from cases.resultcachetest import (
+    DumpAndLoadTestCase,
+    PointQueryResultsTestCase,
+    ResultCacheTestCase,
+)
+from cases.shapetest import InlineFeatureTestCase, ShapePointTestCase
+from cases.styletest import (
+    BrushCachingTestCase,
+    DrawProgrammedStylesTestCase,
+    NewStylesTestCase,
+)
+from cases.symbolsettest import MapSymbolSetTestCase, SymbolSetTestCase
+from cases.symboltest import MapSymbolTestCase, SymbolTestCase
+from cases.zoomtest import ZoomPointTestCase, ZoomRectangleTestCase, ZoomScaleTestCase
 
 # Create a test suite
 suite = unittest.TestSuite()
@@ -95,54 +84,73 @@ suite = unittest.TestSuite()
 # Add tests to the suite
 suite.addTests([RectObjTestCase()])
 
-suite.addTests([HashTableTestCase(), WebMetadataTestCase(),
-                LayerMetadataTestCase(), ClassMetadataTestCase()])
+suite.addTests(
+    [
+        HashTableTestCase(),
+        WebMetadataTestCase(),
+        LayerMetadataTestCase(),
+        ClassMetadataTestCase(),
+    ]
+)
 
 suite.addTests([MapCloningTestCase()])
 suite.addTests([OWSRequestTestCase()])
 
 suite.addTests([ImageObjTestCase(), ImageWriteTestCase()])
 
-suite.addTests([MapConstructorTestCase(),
-                MapLayersTestCase(),
-                MapExtentTestCase(),
-                MapExceptionTestCase(),
-                EmptyMapExceptionTestCase()])
-
-suite.addTests([LayerConstructorTestCase(),
-                LayerExtentTestCase(),
-                LayerRasterProcessingTestCase(),
-                RemoveLayerTestCase()])
-
-suite.addTests([LineObjTestCase(),
-                ShapePointTestCase(),
-                PointObjTestCase(),
-                InlineFeatureTestCase()])
-
-
-suite.addTests([DrawProgrammedStylesTestCase(),
-                NewStylesTestCase(), BrushCachingTestCase(),
-                ColorObjTestCase()])
-                
-suite.addTests([SymbolTestCase(),
-                MapSymbolTestCase()])
-
-suite.addTests([SymbolSetTestCase(),
-                MapSymbolSetTestCase()])
-
-suite.addTests([ZoomPointTestCase(),
-                ZoomRectangleTestCase(),
-                ZoomScaleTestCase()])
-                
+suite.addTests(
+    [
+        MapConstructorTestCase(),
+        MapLayersTestCase(),
+        MapExtentTestCase(),
+        MapExceptionTestCase(),
+        EmptyMapExceptionTestCase(),
+    ]
+)
+
+suite.addTests(
+    [
+        LayerConstructorTestCase(),
+        LayerExtentTestCase(),
+        LayerRasterProcessingTestCase(),
+        RemoveLayerTestCase(),
+    ]
+)
+
+suite.addTests(
+    [
+        LineObjTestCase(),
+        ShapePointTestCase(),
+        PointObjTestCase(),
+        InlineFeatureTestCase(),
+    ]
+)
+
+
+suite.addTests(
+    [
+        DrawProgrammedStylesTestCase(),
+        NewStylesTestCase(),
+        BrushCachingTestCase(),
+        ColorObjTestCase(),
+    ]
+)
+
+suite.addTests([SymbolTestCase(), MapSymbolTestCase()])
+
+suite.addTests([SymbolSetTestCase(), MapSymbolSetTestCase()])
+
+suite.addTests([ZoomPointTestCase(), ZoomRectangleTestCase(), ZoomScaleTestCase()])
+
 suite.addTests([OutputFormatTestCase(), MapOutputFormatTestCase()])
 
 suite.addTest(LabelCacheMemberTestCase())
 
-suite.addTests([ResultCacheTestCase(), PointQueryResultsTestCase(),
-                DumpAndLoadTestCase()])
+suite.addTests(
+    [ResultCacheTestCase(), PointQueryResultsTestCase(), DumpAndLoadTestCase()]
+)
 
 # ============================================================================
 # If module is run as a script, execute every test case in the suite
-if __name__ == '__main__':
+if __name__ == "__main__":
     unittest.main()
-
diff -pruN 8.0.1-5/mapscript/python/tests/timing/clonemaps.py 8.0.2-1/mapscript/python/tests/timing/clonemaps.py
--- 8.0.1-5/mapscript/python/tests/timing/clonemaps.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapscript/python/tests/timing/clonemaps.py	2024-06-11 20:41:34.000000000 +0000
@@ -3,8 +3,9 @@
 # Timing tests of mapfile parsing vs map cloning
 
 import os
-from shutil import copyfile
 import timeit
+from shutil import copyfile
+
 from .testing import TESTMAPFILE, mapscript
 
 # ===========================================================================
@@ -16,8 +17,8 @@ print("Test 1A: reloading maps from mapf
 s = """\
 m = mapscript.mapObj(TESTMAPFILE)
 """
-t = timeit.Timer(stmt=s, setup='from __main__ import mapscript, TESTMAPFILE')
-print("%.2f usec/pass" % (1000000 * t.timeit(number=100)/100))
+t = timeit.Timer(stmt=s, setup="from __main__ import mapscript, TESTMAPFILE")
+print("%.2f usec/pass" % (1000000 * t.timeit(number=100) / 100))
 
 # ===========================================================================
 # Test 1B: Cloning
@@ -29,39 +30,37 @@ m = mapscript.mapObj(TESTMAPFILE)
 s = """\
 c = m.clone()
 """
-t = timeit.Timer(stmt=s, setup='from __main__ import m')
-print("%.2f usec/pass" % (1000000 * t.timeit(number=100)/100))
+t = timeit.Timer(stmt=s, setup="from __main__ import m")
+print("%.2f usec/pass" % (1000000 * t.timeit(number=100) / 100))
 
 # ===========================================================================
 # Test 2: Add 20 dups of the POLYGON layer to see how results scale
 
 timing_map = mapscript.mapObj(TESTMAPFILE)
-polygon_layer = timing_map.getLayerByName('POLYGON')
+polygon_layer = timing_map.getLayerByName("POLYGON")
 
 # duplicate POLYGON layer 20 times
 for i in range(20):
     timing_map.insertLayer(polygon_layer)
 assert timing_map.numlayers == 24
 
-TIMINGMAPFILE = os.path.join(os.getcwd(), 'timing.map')
+TIMINGMAPFILE = os.path.join(os.getcwd(), "timing.map")
 timing_map.save(TIMINGMAPFILE)
-copyfile('../../tests/fonts.txt', os.path.join(os.getcwd(), 'fonts.txt'))
-copyfile('../../tests/symbols.txt', os.path.join(os.getcwd(), 'symbols.txt'))
+copyfile("../../tests/fonts.txt", os.path.join(os.getcwd(), "fonts.txt"))
+copyfile("../../tests/symbols.txt", os.path.join(os.getcwd(), "symbols.txt"))
 
 # Test 2A: reloading mapfile
 print("Test 2A: reloading inflated mapfile")
 s = """\
 m = mapscript.mapObj(TIMINGMAPFILE)
 """
-t = timeit.Timer(stmt=s, setup='from __main__ import mapscript, TIMINGMAPFILE')
-print("%.2f usec/pass" % (1000000 * t.timeit(number=100)/100))
+t = timeit.Timer(stmt=s, setup="from __main__ import mapscript, TIMINGMAPFILE")
+print("%.2f usec/pass" % (1000000 * t.timeit(number=100) / 100))
 
 print("Test 2B: cloning inflated mapfile")
 m = mapscript.mapObj(TIMINGMAPFILE)
 s = """\
 c = m.clone()
 """
-t = timeit.Timer(stmt=s, setup='from __main__ import m')
-print("%.2f usec/pass" % (1000000 * t.timeit(number=100)/100))
-
-
+t = timeit.Timer(stmt=s, setup="from __main__ import m")
+print("%.2f usec/pass" % (1000000 * t.timeit(number=100) / 100))
diff -pruN 8.0.1-5/mapscript/python/tests/timing/drawshapes.py 8.0.2-1/mapscript/python/tests/timing/drawshapes.py
--- 8.0.1-5/mapscript/python/tests/timing/drawshapes.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapscript/python/tests/timing/drawshapes.py	2024-06-11 20:41:34.000000000 +0000
@@ -8,26 +8,27 @@ import os
 import sys
 import timeit
 from random import random
+
 from .testing import mapscript
 
 # Get Number of shapes from the command line
 try:
-    opts, args = getopt.getopt(sys.argv[1:], 'n:')
+    opts, args = getopt.getopt(sys.argv[1:], "n:")
 except getopt.GetoptError:
     sys.exit(2)
 
-numshapes = 100 # default to 100
+numshapes = 100  # default to 100
 for o, a in opts:
-    if o == '-n':
+    if o == "-n":
         numshapes = int(a)
 
 # The shapefileObj
-shpfile = mapscript.shapefileObj('timing.shp', mapscript.MS_SHAPEFILE_POLYGON)
+shpfile = mapscript.shapefileObj("timing.shp", mapscript.MS_SHAPEFILE_POLYGON)
 
 # Inline feature layer
 ilayer = mapscript.layerObj()
 ilayer.type = mapscript.MS_LAYER_POLYGON
-ilayer.setProjection('init=epsg:4326')
+ilayer.setProjection("init=epsg:4326")
 ilayer.status = mapscript.MS_DEFAULT
 ilayer.connectiontype = mapscript.MS_INLINE
 
@@ -36,9 +37,9 @@ print(numshapes, "shapes")
 i = 0
 while i < numshapes:
     # The shape to add is randomly generated
-    xc = 4.0*(random() - 0.5)
-    yc = 4.0*(random() - 0.5)
-    r = mapscript.rectObj(xc-0.25, yc-0.25, xc+0.25, yc+0.25)
+    xc = 4.0 * (random() - 0.5)
+    yc = 4.0 * (random() - 0.5)
+    r = mapscript.rectObj(xc - 0.25, yc - 0.25, xc + 0.25, yc + 0.25)
     s = r.toPolygon()
 
     # Add to shapefile
@@ -46,33 +47,33 @@ while i < numshapes:
 
     # Add to inline feature layer
     ilayer.addFeature(s)
-    
+
     i = i + 1
 
-del shpfile # closes up the file
+del shpfile  # closes up the file
 
 # Prepare the testing fixture
-m = mapscript.mapObj('timing.map')
-l = m.getLayerByName('POLYGON')
-l.data = os.path.join(os.getcwd(), 'timing')
+m = mapscript.mapObj("timing.map")
+l = m.getLayerByName("POLYGON")
+l.data = os.path.join(os.getcwd(), "timing")
 
 # Save three map images to check afterwards
 img = m.draw()
-img.save('timing.png')
+img.save("timing.png")
 
-shpfile = mapscript.shapefileObj('timing.shp')
+shpfile = mapscript.shapefileObj("timing.shp")
 img = m.prepareImage()
 for i in range(shpfile.numshapes):
     s = shpfile.getShape(i)
     s.classindex = 0
     s.draw(m, l, img)
-img.save('timing-shapes.png')
+img.save("timing-shapes.png")
 
 class0 = mapscript.classObj(ilayer)
 class0.insertStyle(l.getClass(0).getStyle(0))
 img = m.prepareImage()
 ilayer.draw(m, img)
-img.save('timing-inline.png')
+img.save("timing-inline.png")
 
 # =========================================================================
 # Test 1A: Draw all shapes at once using map.draw()
@@ -81,8 +82,8 @@ print("Test 1A: draw map, all shapes at
 s = """\
 img = m.draw()
 """
-t = timeit.Timer(stmt=s, setup='from __main__ import m')
-print("%.2f usec/pass" % (1000000 * t.timeit(number=100)/100))
+t = timeit.Timer(stmt=s, setup="from __main__ import m")
+print("%.2f usec/pass" % (1000000 * t.timeit(number=100) / 100))
 
 
 # =========================================================================
@@ -96,8 +97,8 @@ for i in range(shpfile.numshapes):
     s.classindex = 0
     s.draw(m, l, img)
 """
-t = timeit.Timer(stmt=s, setup='from __main__ import m, l, shpfile')
-print("%.2f usec/pass" % (1000000 * t.timeit(number=100)/100))
+t = timeit.Timer(stmt=s, setup="from __main__ import m, l, shpfile")
+print("%.2f usec/pass" % (1000000 * t.timeit(number=100) / 100))
 
 
 # =========================================================================
@@ -108,6 +109,5 @@ s = """\
 img = m.prepareImage()
 ilayer.draw(m, img)
 """
-t = timeit.Timer(stmt=s, setup='from __main__ import m, ilayer')
-print("%.2f usec/pass" % (1000000 * t.timeit(number=100)/100))
-
+t = timeit.Timer(stmt=s, setup="from __main__ import m, ilayer")
+print("%.2f usec/pass" % (1000000 * t.timeit(number=100) / 100))
diff -pruN 8.0.1-5/mapscript/python/tests/timing/testing.py 8.0.2-1/mapscript/python/tests/timing/testing.py
--- 8.0.1-5/mapscript/python/tests/timing/testing.py	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapscript/python/tests/timing/testing.py	2024-06-11 20:41:34.000000000 +0000
@@ -6,7 +6,7 @@
 #
 # ===========================================================================
 # Copyright (c) 2004, Sean Gillies
-# 
+#
 # Permission is hereby granted, free of charge, to any person obtaining a
 # copy of this software and associated documentation files (the "Software"),
 # to deal in the Software without restriction, including without limitation
@@ -28,7 +28,7 @@
 #
 # Purpose of this module is to export the locally built mapscript module
 # prior to installation, do some name normalization that allows testing of
-# the so-called next generation class names, and define some classes 
+# the so-called next generation class names, and define some classes
 # useful to many test cases.
 #
 # All test case modules should import mapscript from testing
@@ -40,36 +40,50 @@
 import os
 import sys
 import sysconfig
-import unittest
 
 # define the path to mapserver test data
-TESTS_PATH = '../../tests'
+TESTS_PATH = "../../tests"
 
-TESTMAPFILE = os.path.join(TESTS_PATH, 'test.map')
-XMARKS_IMAGE = os.path.join(TESTS_PATH, 'xmarks.png')
-TEST_IMAGE = os.path.join(TESTS_PATH, 'test.png')
+TESTMAPFILE = os.path.join(TESTS_PATH, "test.map")
+XMARKS_IMAGE = os.path.join(TESTS_PATH, "xmarks.png")
+TEST_IMAGE = os.path.join(TESTS_PATH, "test.png")
 
 # Put local build directory on head of python path
-platformdir = '-'.join((sysconfig.get_platform(), 
-                        '.'.join(map(str, sys.version_info[0:2]))))
-sys.path.insert(0, os.path.join('build', 'lib.' + platformdir))
+platformdir = "-".join(
+    (sysconfig.get_platform(), ".".join(map(str, sys.version_info[0:2])))
+)
+sys.path.insert(0, os.path.join("build", "lib." + platformdir))
 
 # import mapscript from the local build directory
 import mapscript
 
 # normalize names, allows testing of module that uses the experimental
 # next generation names
-classnames = [ 'mapObj', 'layerObj', 'classObj', 'styleObj', 'shapeObj',
-            'lineObj', 'pointObj', 'rectObj', 'outputFormatObj', 'symbolObj',
-            'symbolSetObj', 'colorObj', 'imageObj', 'shapefileObj',
-            'projectionObj', 'fontSetObj', 'hashTableObj' ]
+classnames = [
+    "mapObj",
+    "layerObj",
+    "classObj",
+    "styleObj",
+    "shapeObj",
+    "lineObj",
+    "pointObj",
+    "rectObj",
+    "outputFormatObj",
+    "symbolObj",
+    "symbolSetObj",
+    "colorObj",
+    "imageObj",
+    "shapefileObj",
+    "projectionObj",
+    "fontSetObj",
+    "hashTableObj",
+]
 
 for name in classnames:
     try:
-        new_name = name.replace('Obj', '')
+        new_name = name.replace("Obj", "")
         new_name = new_name.capitalize()
         new_object = getattr(mapscript, new_name)
         setattr(mapscript, name, new_object)
     except AttributeError:
         pass
-
diff -pruN 8.0.1-5/mapscript/swiginc/layer.i 8.0.2-1/mapscript/swiginc/layer.i
--- 8.0.1-5/mapscript/swiginc/layer.i	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapscript/swiginc/layer.i	2024-06-11 20:41:34.000000000 +0000
@@ -386,7 +386,7 @@
     on which the query is performed, and *qstring* is the expression to match. 
     The query is performed on all the shapes that are part of a CLASS that contains a TEMPLATE value or that match any class in a layer that contains a LAYER TEMPLATE value.
     Note that the layer's FILTER/FILTERITEM are ignored by this function. *mode* is :data:`MS_SINGLE` or :data:`MS_MULTIPLE` depending on number of results you want. 
-    Returns :data:`MS_SUCCESS` if shapes were found or :data:`MS_FAILURE` if nothing was found or if some other error happened.
+    Returns :data:`MS_SUCCESS` if the query was successfully performed, regardless of whether any shapes were found, or :data:`MS_FAILURE` if an error occured.
     */
     int queryByAttributes(mapObj *map, char *qitem, char *qstring, int mode) 
     {
@@ -419,7 +419,7 @@
     Query layer at point location specified in georeferenced map coordinates (i.e. not pixels). 
     The query is performed on all the shapes that are part of a CLASS that contains a TEMPLATE value or that match any class in a layer that contains a LAYER TEMPLATE value.
     Note that the layer's FILTER/FILTERITEM are ignored by this function. *mode* is :data:`MS_SINGLE` or :data:`MS_MULTIPLE` depending on number of results you want. 
-    Returns :data:`MS_SUCCESS` if shapes were found or :data:`MS_FAILURE` if nothing was found or if some other error happened.
+    Returns :data:`MS_SUCCESS` if the query was successfully performed, regardless of whether any shapes were found, or :data:`MS_FAILURE` if an error occured.
     */
     int queryByPoint(mapObj *map, pointObj *point, int mode, double buffer) 
     {
@@ -446,7 +446,7 @@
     Query layer using a rectangle specified in georeferenced map coordinates (i.e. not pixels).
     The query is performed on all the shapes that are part of a CLASS that contains a TEMPLATE value or that match any class in a layer that contains a LAYER TEMPLATE value.
     Note that the layer's FILTER/FILTERITEM are ignored by this function. The :data:`MS_MULTIPLE` mode is set by default.
-    Returns :data:`MS_SUCCESS` if shapes were found or :data:`MS_FAILURE` if nothing was found or if some other error happened.
+    Returns :data:`MS_SUCCESS` if the query was successfully performed, regardless of whether any shapes were found, or :data:`MS_FAILURE` if an error occured.
     */
     int queryByRect(mapObj *map, rectObj rect) 
     {
@@ -471,7 +471,7 @@
     /**
     Perform a query set based on a previous set of results from another layer. 
     At present the results MUST be based on a polygon layer. 
-    Returns :data:`MS_SUCCESS` if shapes were found or :data:`MS_FAILURE` if nothing was found or if some other error happened.
+    Returns :data:`MS_SUCCESS` if the query was successfully performed, regardless of whether any shapes were found, or :data:`MS_FAILURE` if an error occured.
     */
     int queryByFeatures(mapObj *map, int slayer) 
     {
@@ -490,7 +490,7 @@
 
     /**
     Query layer based on a single shape, the shape has to be a polygon at this point. 
-    Returns :data:`MS_SUCCESS` if shapes were found or :data:`MS_FAILURE` if nothing was found or if some other error happened.
+    Returns :data:`MS_SUCCESS` if the query was successfully performed, regardless of whether any shapes were found, or :data:`MS_FAILURE` if an error occured.
     */
     int queryByShape(mapObj *map, shapeObj *shape) 
     {
diff -pruN 8.0.1-5/mapscript/v8/line.cpp 8.0.2-1/mapscript/v8/line.cpp
--- 8.0.1-5/mapscript/v8/line.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapscript/v8/line.cpp	2024-06-11 20:41:34.000000000 +0000
@@ -35,8 +35,7 @@ using namespace v8;
 
 Persistent<FunctionTemplate> Line::constructor;
 
-void Line::Initialize(Handle<Object> target)
-{
+void Line::Initialize(Handle<Object> target) {
   HandleScope scope;
 
   Handle<FunctionTemplate> c = FunctionTemplate::New(Line::New);
@@ -55,78 +54,66 @@ void Line::Initialize(Handle<Object> tar
   constructor.Reset(Isolate::GetCurrent(), c);
 }
 
-void Line::Dispose()
-{
+void Line::Dispose() {
   Line::constructor.Dispose();
   Line::constructor.Clear();
 }
 
-Line::~Line()
-{
+Line::~Line() {
   if (this->freeInternal) {
     msFree(this->this_->point);
     msFree(this->this_);
   }
 }
 
-Handle<Function> Line::Constructor()
-{
+Handle<Function> Line::Constructor() {
   return (*Line::constructor)->GetFunction();
 }
 
-void Line::New(const v8::FunctionCallbackInfo<Value>& args)
-{
+void Line::New(const v8::FunctionCallbackInfo<Value> &args) {
   HandleScope scope;
 
-  if (args[0]->IsExternal())
-  {
+  if (args[0]->IsExternal()) {
     Local<External> ext = Local<External>::Cast(args[0]);
     void *ptr = ext->Value();
-    Line *line = static_cast<Line*>(ptr);
+    Line *line = static_cast<Line *>(ptr);
     Handle<Object> self = args.Holder();
     line->Wrap(self);
     if (line->parent_) {
       self->SetHiddenValue(String::New("__parent__"), line->parent_->handle());
       line->disableMemoryHandler();
     }
-  }
-  else
-  {
+  } else {
     lineObj *l = (lineObj *)msSmallMalloc(sizeof(lineObj));
 
-    l->numpoints=0;
-    l->point=NULL;
+    l->numpoints = 0;
+    l->point = NULL;
 
     Line *line = new Line(l);
     line->Wrap(args.Holder());
   }
-
 }
 
-Line::Line(lineObj *l, ObjectWrap *p):
-  ObjectWrap()
-{
+Line::Line(lineObj *l, ObjectWrap *p) : ObjectWrap() {
   this->this_ = l;
   this->parent_ = p;
   this->freeInternal = true;
 }
 
 void Line::getProp(Local<String> property,
-                   const PropertyCallbackInfo<Value>& info)
-{
-    HandleScope scope;
-    Line* l = ObjectWrap::Unwrap<Line>(info.Holder());
-    std::string name = TOSTR(property);
-    Handle<Value> value = Undefined();
+                   const PropertyCallbackInfo<Value> &info) {
+  HandleScope scope;
+  Line *l = ObjectWrap::Unwrap<Line>(info.Holder());
+  std::string name = TOSTR(property);
+  Handle<Value> value = Undefined();
 
-    if (name == "numpoints")
-      value = Integer::New(l->get()->numpoints);
+  if (name == "numpoints")
+    value = Integer::New(l->get()->numpoints);
 
-    info.GetReturnValue().Set(value);
+  info.GetReturnValue().Set(value);
 }
 
-void Line::getPoint(const v8::FunctionCallbackInfo<Value>& args)
-{
+void Line::getPoint(const v8::FunctionCallbackInfo<Value> &args) {
   HandleScope scope;
 
   if (args.Length() < 1 || !args[0]->IsInt32()) {
@@ -134,13 +121,12 @@ void Line::getPoint(const v8::FunctionCa
     return;
   }
 
-  Line* l = ObjectWrap::Unwrap<Line>(args.Holder());
-  lineObj* line = l->get();
+  Line *l = ObjectWrap::Unwrap<Line>(args.Holder());
+  lineObj *line = l->get();
 
   int index = args[0]->Int32Value();
 
-  if (index < 0 || index >= line->numpoints)
-  {
+  if (index < 0 || index >= line->numpoints) {
     ThrowException(String::New("Invalid point index."));
     return;
   }
@@ -150,8 +136,7 @@ void Line::getPoint(const v8::FunctionCa
   args.GetReturnValue().Set(Point::Constructor()->NewInstance(1, &ext));
 }
 
-void Line::addXY(const v8::FunctionCallbackInfo<Value>& args)
-{
+void Line::addXY(const v8::FunctionCallbackInfo<Value> &args) {
   HandleScope scope;
 
   if (args.Length() < 2 || !args[0]->IsNumber() || !args[1]->IsNumber()) {
@@ -159,13 +144,14 @@ void Line::addXY(const v8::FunctionCallb
     return;
   }
 
-  Line* l = ObjectWrap::Unwrap<Line>(args.Holder());
-  lineObj* line = l->get();
+  Line *l = ObjectWrap::Unwrap<Line>(args.Holder());
+  lineObj *line = l->get();
 
-  if(line->numpoints == 0) /* new */
+  if (line->numpoints == 0) /* new */
     line->point = (pointObj *)msSmallMalloc(sizeof(pointObj));
   else /* extend array */
-    line->point = (pointObj *)msSmallRealloc(line->point, sizeof(pointObj)*(line->numpoints+1));
+    line->point = (pointObj *)msSmallRealloc(
+        line->point, sizeof(pointObj) * (line->numpoints + 1));
 
   line->point[line->numpoints].x = args[0]->NumberValue();
   line->point[line->numpoints].y = args[1]->NumberValue();
@@ -175,23 +161,23 @@ void Line::addXY(const v8::FunctionCallb
   line->numpoints++;
 }
 
-void Line::addXYZ(const v8::FunctionCallbackInfo<Value>& args)
-{
+void Line::addXYZ(const v8::FunctionCallbackInfo<Value> &args) {
   HandleScope scope;
 
-  if (args.Length() < 3 || !args[0]->IsNumber() ||
-      !args[1]->IsNumber() || !args[2]->IsNumber()) {
+  if (args.Length() < 3 || !args[0]->IsNumber() || !args[1]->IsNumber() ||
+      !args[2]->IsNumber()) {
     ThrowException(String::New("Invalid argument"));
     return;
   }
 
-  Line* l = ObjectWrap::Unwrap<Line>(args.Holder());
-  lineObj* line = l->get();
+  Line *l = ObjectWrap::Unwrap<Line>(args.Holder());
+  lineObj *line = l->get();
 
-  if(line->numpoints == 0) /* new */
+  if (line->numpoints == 0) /* new */
     line->point = (pointObj *)msSmallMalloc(sizeof(pointObj));
   else /* extend array */
-    line->point = (pointObj *)msSmallRealloc(line->point, sizeof(pointObj)*(line->numpoints+1));
+    line->point = (pointObj *)msSmallRealloc(
+        line->point, sizeof(pointObj) * (line->numpoints + 1));
 
   line->point[line->numpoints].x = args[0]->NumberValue();
   line->point[line->numpoints].y = args[1]->NumberValue();
@@ -201,25 +187,26 @@ void Line::addXYZ(const v8::FunctionCall
   line->numpoints++;
 }
 
-void Line::addPoint(const v8::FunctionCallbackInfo<Value>& args)
-{
+void Line::addPoint(const v8::FunctionCallbackInfo<Value> &args) {
   HandleScope scope;
 
   if (args.Length() < 1 || !args[0]->IsObject() ||
-      !args[0]->ToObject()->GetConstructorName()->Equals(String::New("pointObj"))) {
+      !args[0]->ToObject()->GetConstructorName()->Equals(
+          String::New("pointObj"))) {
     ThrowException(String::New("Invalid argument"));
     return;
   }
 
-  Line* l = ObjectWrap::Unwrap<Line>(args.Holder());
-  lineObj* line = l->get();
-  Point* p = ObjectWrap::Unwrap<Point>(args[0]->ToObject());
-  pointObj* point = p->get();
+  Line *l = ObjectWrap::Unwrap<Line>(args.Holder());
+  lineObj *line = l->get();
+  Point *p = ObjectWrap::Unwrap<Point>(args[0]->ToObject());
+  pointObj *point = p->get();
 
-  if(line->numpoints == 0) /* new */
+  if (line->numpoints == 0) /* new */
     line->point = (pointObj *)msSmallMalloc(sizeof(pointObj));
   else /* extend array */
-    line->point = (pointObj *)msSmallRealloc(line->point, sizeof(pointObj)*(line->numpoints+1));
+    line->point = (pointObj *)msSmallRealloc(
+        line->point, sizeof(pointObj) * (line->numpoints + 1));
 
   line->point[line->numpoints].x = point->x;
   line->point[line->numpoints].y = point->y;
diff -pruN 8.0.1-5/mapscript/v8/line.hpp 8.0.2-1/mapscript/v8/line.hpp
--- 8.0.1-5/mapscript/v8/line.hpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapscript/v8/line.hpp	2024-06-11 20:41:34.000000000 +0000
@@ -33,29 +33,28 @@
 
 using namespace v8;
 
-class Line: public ObjectWrap
-{
+class Line : public ObjectWrap {
 public:
   static void Initialize(Handle<Object> target);
-  static void New(const v8::FunctionCallbackInfo<v8::Value>& args);
+  static void New(const v8::FunctionCallbackInfo<v8::Value> &args);
   static void Dispose();
   static Handle<Function> Constructor();
 
   Line(lineObj *l, ObjectWrap *p = NULL);
   ~Line();
-  inline lineObj* get() { return this_; }
+  inline lineObj *get() { return this_; }
   inline void disableMemoryHandler() { this->freeInternal = false; }
 
   static void getProp(Local<String> property,
-                      const PropertyCallbackInfo<Value>& info);
-  static void setProp(Local<String> property,
-                      Local<Value> value,
-                      const PropertyCallbackInfo<void>& info);
-
-  static void getPoint(const v8::FunctionCallbackInfo<Value>& args);
-  static void addXY(const v8::FunctionCallbackInfo<Value>& args);
-  static void addXYZ(const v8::FunctionCallbackInfo<Value>& args);
-  static void addPoint(const v8::FunctionCallbackInfo<Value>& args);
+                      const PropertyCallbackInfo<Value> &info);
+  static void setProp(Local<String> property, Local<Value> value,
+                      const PropertyCallbackInfo<void> &info);
+
+  static void getPoint(const v8::FunctionCallbackInfo<Value> &args);
+  static void addXY(const v8::FunctionCallbackInfo<Value> &args);
+  static void addXYZ(const v8::FunctionCallbackInfo<Value> &args);
+  static void addPoint(const v8::FunctionCallbackInfo<Value> &args);
+
 private:
   static Persistent<FunctionTemplate> constructor;
   lineObj *this_;
diff -pruN 8.0.1-5/mapscript/v8/point.cpp 8.0.2-1/mapscript/v8/point.cpp
--- 8.0.1-5/mapscript/v8/point.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapscript/v8/point.cpp	2024-06-11 20:41:34.000000000 +0000
@@ -35,8 +35,7 @@ using namespace v8;
 
 Persistent<FunctionTemplate> Point::constructor;
 
-void Point::Initialize(Handle<Object> target)
-{
+void Point::Initialize(Handle<Object> target) {
   HandleScope scope;
 
   Handle<FunctionTemplate> c = FunctionTemplate::New(Point::New);
@@ -56,42 +55,35 @@ void Point::Initialize(Handle<Object> ta
   constructor.Reset(Isolate::GetCurrent(), c);
 }
 
-void Point::Dispose()
-{
+void Point::Dispose() {
   Point::constructor.Dispose();
   Point::constructor.Clear();
 }
 
-Point::~Point()
-{
+Point::~Point() {
   if (this->freeInternal) {
     msFree(this->get());
   }
 }
 
-Handle<Function> Point::Constructor()
-{
+Handle<Function> Point::Constructor() {
   return (*Point::constructor)->GetFunction();
 }
 
-void Point::New(const v8::FunctionCallbackInfo<Value>& args)
-{
+void Point::New(const v8::FunctionCallbackInfo<Value> &args) {
   HandleScope scope;
 
-  if (args[0]->IsExternal())
-  {
+  if (args[0]->IsExternal()) {
     Local<External> ext = Local<External>::Cast(args[0]);
     void *ptr = ext->Value();
-    Point *point = static_cast<Point*>(ptr);
+    Point *point = static_cast<Point *>(ptr);
     Handle<Object> self = args.Holder();
     point->Wrap(self);
     if (point->parent_) {
       self->SetHiddenValue(String::New("__parent__"), point->parent_->handle());
       point->disableMemoryHandler();
     }
-  }
-  else
-  {
+  } else {
     pointObj *p = (pointObj *)msSmallMalloc(sizeof(pointObj));
 
     p->x = 0;
@@ -104,58 +96,51 @@ void Point::New(const v8::FunctionCallba
   }
 }
 
- Point::Point(pointObj *p, ObjectWrap *pa):
-  ObjectWrap()
-{
-    this->this_ = p;
-    this->parent_ = pa;
-    this->freeInternal = true;
+Point::Point(pointObj *p, ObjectWrap *pa) : ObjectWrap() {
+  this->this_ = p;
+  this->parent_ = pa;
+  this->freeInternal = true;
 }
 
 void Point::getProp(Local<String> property,
-                    const PropertyCallbackInfo<Value>& info)
-{
-    HandleScope scope;
-    Point* p = ObjectWrap::Unwrap<Point>(info.Holder());
-    std::string name = TOSTR(property);
-    Handle<Value> value = Undefined();
-    
-    if (name == "x")
-      value = Number::New(p->get()->x);
-    else if (name == "y")
-      value = Number::New(p->get()->y);
-    else if (name == "z")
-      value = Number::New(p->get()->z);
-    else if (name == "m")
-      value = Number::New(p->get()->m);
-
-    info.GetReturnValue().Set(value);
-}
-
-void Point::setProp(Local<String> property,
-                    Local<Value> value,
-                    const PropertyCallbackInfo<void>& info)
-{
-    HandleScope scope;
-    Point* p = ObjectWrap::Unwrap<Point>(info.Holder());
-    std::string name = TOSTR(property);
-    if (!value->IsNumber())
-      ThrowException(Exception::TypeError(
-                           String::New("point value must be a number")));
-    if (name == "x") {
-      p->get()->x = value->NumberValue();
-    } else if (name == "y") {
-      p->get()->y = value->NumberValue();
-    }
-    else if (name == "z") {
-      p->get()->z = value->NumberValue();
-    } else if (name == "m") {
-      p->get()->m = value->NumberValue();
-    }
+                    const PropertyCallbackInfo<Value> &info) {
+  HandleScope scope;
+  Point *p = ObjectWrap::Unwrap<Point>(info.Holder());
+  std::string name = TOSTR(property);
+  Handle<Value> value = Undefined();
+
+  if (name == "x")
+    value = Number::New(p->get()->x);
+  else if (name == "y")
+    value = Number::New(p->get()->y);
+  else if (name == "z")
+    value = Number::New(p->get()->z);
+  else if (name == "m")
+    value = Number::New(p->get()->m);
+
+  info.GetReturnValue().Set(value);
 }
 
-void Point::setXY(const v8::FunctionCallbackInfo<v8::Value>& args)
-{
+void Point::setProp(Local<String> property, Local<Value> value,
+                    const PropertyCallbackInfo<void> &info) {
+  HandleScope scope;
+  Point *p = ObjectWrap::Unwrap<Point>(info.Holder());
+  std::string name = TOSTR(property);
+  if (!value->IsNumber())
+    ThrowException(
+        Exception::TypeError(String::New("point value must be a number")));
+  if (name == "x") {
+    p->get()->x = value->NumberValue();
+  } else if (name == "y") {
+    p->get()->y = value->NumberValue();
+  } else if (name == "z") {
+    p->get()->z = value->NumberValue();
+  } else if (name == "m") {
+    p->get()->m = value->NumberValue();
+  }
+}
+
+void Point::setXY(const v8::FunctionCallbackInfo<v8::Value> &args) {
   HandleScope scope;
 
   if (args.Length() < 2 || !args[0]->IsNumber() || !args[1]->IsNumber()) {
@@ -163,24 +148,22 @@ void Point::setXY(const v8::FunctionCall
     return;
   }
 
-  Point* p = ObjectWrap::Unwrap<Point>(args.Holder());
+  Point *p = ObjectWrap::Unwrap<Point>(args.Holder());
 
   p->get()->x = args[0]->NumberValue();
   p->get()->y = args[1]->NumberValue();
-
 }
 
-void Point::setXYZ(const v8::FunctionCallbackInfo<v8::Value>& args)
-{
+void Point::setXYZ(const v8::FunctionCallbackInfo<v8::Value> &args) {
   HandleScope scope;
 
-  if (args.Length() < 3 ||
-      !args[0]->IsNumber() || !args[1]->IsNumber() || !args[2]->IsNumber()) {
+  if (args.Length() < 3 || !args[0]->IsNumber() || !args[1]->IsNumber() ||
+      !args[2]->IsNumber()) {
     ThrowException(String::New("Invalid argument"));
     return;
   }
 
-  Point* p = ObjectWrap::Unwrap<Point>(args.Holder());
+  Point *p = ObjectWrap::Unwrap<Point>(args.Holder());
 
   p->get()->x = args[0]->NumberValue();
   p->get()->y = args[1]->NumberValue();
diff -pruN 8.0.1-5/mapscript/v8/point.hpp 8.0.2-1/mapscript/v8/point.hpp
--- 8.0.1-5/mapscript/v8/point.hpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapscript/v8/point.hpp	2024-06-11 20:41:34.000000000 +0000
@@ -33,27 +33,26 @@
 
 using namespace v8;
 
-class Point: public ObjectWrap
-{
+class Point : public ObjectWrap {
 public:
   static void Initialize(Handle<Object> target);
-  static void New(const v8::FunctionCallbackInfo<v8::Value>& args);
+  static void New(const v8::FunctionCallbackInfo<v8::Value> &args);
   static void Dispose();
   static Handle<Function> Constructor();
 
   Point(pointObj *p, ObjectWrap *pa = NULL);
   ~Point();
-  inline pointObj* get() { return this_; }
+  inline pointObj *get() { return this_; }
   inline void disableMemoryHandler() { this->freeInternal = false; }
 
   static void getProp(Local<String> property,
-                      const PropertyCallbackInfo<Value>& info);
-  static void setProp(Local<String> property,
-                      Local<Value> value,
-                      const PropertyCallbackInfo<void>& info);
+                      const PropertyCallbackInfo<Value> &info);
+  static void setProp(Local<String> property, Local<Value> value,
+                      const PropertyCallbackInfo<void> &info);
+
+  static void setXY(const v8::FunctionCallbackInfo<v8::Value> &args);
+  static void setXYZ(const v8::FunctionCallbackInfo<v8::Value> &args);
 
-  static void setXY(const v8::FunctionCallbackInfo<v8::Value>& args);
-  static void setXYZ(const v8::FunctionCallbackInfo<v8::Value>& args);
 private:
   static Persistent<FunctionTemplate> constructor;
   pointObj *this_;
diff -pruN 8.0.1-5/mapscript/v8/shape.cpp 8.0.2-1/mapscript/v8/shape.cpp
--- 8.0.1-5/mapscript/v8/shape.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapscript/v8/shape.cpp	2024-06-11 20:41:34.000000000 +0000
@@ -38,8 +38,7 @@ using std::string;
 
 Persistent<FunctionTemplate> Shape::constructor;
 
-void Shape::Initialize(Handle<Object> target)
-{
+void Shape::Initialize(Handle<Object> target) {
   HandleScope scope;
 
   Handle<FunctionTemplate> c = FunctionTemplate::New(Shape::New);
@@ -59,28 +58,22 @@ void Shape::Initialize(Handle<Object> ta
   NODE_SET_PROTOTYPE_METHOD(c, "add", addLine);
   NODE_SET_PROTOTYPE_METHOD(c, "setGeometry", setGeometry);
 
-  NODE_DEFINE_CONSTANT(c->GetFunction(),
-                       "Point",MS_SHAPE_POINT);
-  NODE_DEFINE_CONSTANT(c->GetFunction(),
-                       "Line",MS_SHAPE_LINE);
-  NODE_DEFINE_CONSTANT(c->GetFunction(),
-                       "Polygon",MS_SHAPE_POLYGON);
-  NODE_DEFINE_CONSTANT(c->GetFunction(),
-                       "Null",MS_SHAPE_NULL);
+  NODE_DEFINE_CONSTANT(c->GetFunction(), "Point", MS_SHAPE_POINT);
+  NODE_DEFINE_CONSTANT(c->GetFunction(), "Line", MS_SHAPE_LINE);
+  NODE_DEFINE_CONSTANT(c->GetFunction(), "Polygon", MS_SHAPE_POLYGON);
+  NODE_DEFINE_CONSTANT(c->GetFunction(), "Null", MS_SHAPE_NULL);
 
   target->Set(String::NewSymbol("shapeObj"), c->GetFunction());
 
   constructor.Reset(Isolate::GetCurrent(), c);
 }
 
-void Shape::Dispose()
-{
+void Shape::Dispose() {
   Shape::constructor.Dispose();
   Shape::constructor.Clear();
 }
 
-Shape::~Shape()
-{
+Shape::~Shape() {
   /* this is set to false if the shapeObj is owned by mapserver and not v8 */
   if (freeInternal) {
     msFreeShape(this->get());
@@ -88,33 +81,27 @@ Shape::~Shape()
   }
 }
 
-Handle<Function> Shape::Constructor()
-{
+Handle<Function> Shape::Constructor() {
   return (*Shape::constructor)->GetFunction();
 }
 
-void Shape::New(const v8::FunctionCallbackInfo<Value>& args)
-{
+void Shape::New(const v8::FunctionCallbackInfo<Value> &args) {
   HandleScope scope;
   Handle<Object> self = args.Holder();
   Shape *shape;
 
-  if (args[0]->IsExternal())
-  {
+  if (args[0]->IsExternal()) {
     Local<External> ext = Local<External>::Cast(args[0]);
     void *ptr = ext->Value();
-    shape = static_cast<Shape*>(ptr);
+    shape = static_cast<Shape *>(ptr);
     shape->Wrap(args.Holder());
-  }
-  else
-  {
+  } else {
     shapeObj *s = (shapeObj *)msSmallMalloc(sizeof(shapeObj));
 
     msInitShape(s);
-    if(args.Length() >= 1) {
+    if (args.Length() >= 1) {
       s->type = args[0]->Int32Value();
-    }
-    else {
+    } else {
       s->type = MS_SHAPE_NULL;
     }
 
@@ -130,11 +117,11 @@ void Shape::New(const v8::FunctionCallba
   Handle<Object> attributes = attributes_templ->NewInstance();
   map<string, int> *attributes_map = new map<string, int>();
   attributes->SetInternalField(0, External::New(attributes_map));
-  attributes->SetInternalField(1, External::New(shape->get()->values));  
+  attributes->SetInternalField(1, External::New(shape->get()->values));
   attributes->SetHiddenValue(String::New("__parent__"), self);
 
   if (shape->layer) {
-    for (int i=0; i<shape->layer->numitems; ++i) {
+    for (int i = 0; i < shape->layer->numitems; ++i) {
       (*attributes_map)[string(shape->layer->items[i])] = i;
     }
   }
@@ -147,59 +134,53 @@ void Shape::New(const v8::FunctionCallba
   self->Set(String::New("attributes"), attributes);
 }
 
-Shape::Shape(shapeObj *s):
-  ObjectWrap()
-{
+Shape::Shape(shapeObj *s) : ObjectWrap() {
   this->this_ = s;
   this->layer = NULL;
   this->freeInternal = true;
 }
 
 void Shape::getProp(Local<String> property,
-                    const PropertyCallbackInfo<Value>& info)
-{
-    HandleScope scope;
-    Shape* s = ObjectWrap::Unwrap<Shape>(info.Holder());
-    std::string name = TOSTR(property);
-    Handle<Value> value = Undefined();
-
-    if (name == "numvalues")
-      value = Integer::New(s->get()->numvalues);
-    else if (name == "numlines")
-      value = Integer::New(s->get()->numlines);
-    else if (name == "index")
-      value = Number::New(s->get()->index);
-    else if (name == "type")
-      value = Integer::New(s->get()->type);
-    else if (name == "tileindex")
-      value = Integer::New(s->get()->tileindex);
-    else if (name == "classindex")
-      value = Integer::New(s->get()->classindex);
-    else if (name == "text")
-      value = String::New(s->get()->text);
-
-    info.GetReturnValue().Set(value);
-}
-
-void Shape::setProp(Local<String> property,
-                    Local<Value> value,
-                    const PropertyCallbackInfo<void>& info)
-{
-    HandleScope scope;
-    Shape* s = ObjectWrap::Unwrap<Shape>(info.Holder());
-    std::string name = TOSTR(property);
-
-    if (name == "text") {
-      if (s->get()->text)
-        msFree(s->get()->text);
-      s->get()->text = getStringValue(value);
-    }
+                    const PropertyCallbackInfo<Value> &info) {
+  HandleScope scope;
+  Shape *s = ObjectWrap::Unwrap<Shape>(info.Holder());
+  std::string name = TOSTR(property);
+  Handle<Value> value = Undefined();
+
+  if (name == "numvalues")
+    value = Integer::New(s->get()->numvalues);
+  else if (name == "numlines")
+    value = Integer::New(s->get()->numlines);
+  else if (name == "index")
+    value = Number::New(s->get()->index);
+  else if (name == "type")
+    value = Integer::New(s->get()->type);
+  else if (name == "tileindex")
+    value = Integer::New(s->get()->tileindex);
+  else if (name == "classindex")
+    value = Integer::New(s->get()->classindex);
+  else if (name == "text")
+    value = String::New(s->get()->text);
+
+  info.GetReturnValue().Set(value);
 }
 
-void Shape::clone(const v8::FunctionCallbackInfo<v8::Value>& args)
-{
+void Shape::setProp(Local<String> property, Local<Value> value,
+                    const PropertyCallbackInfo<void> &info) {
   HandleScope scope;
-  Shape* s = ObjectWrap::Unwrap<Shape>(args.Holder());
+  Shape *s = ObjectWrap::Unwrap<Shape>(info.Holder());
+  std::string name = TOSTR(property);
+
+  if (name == "text") {
+    if (s->get()->text)
+      msFree(s->get()->text);
+    s->get()->text = getStringValue(value);
+  }
+}
+
+void Shape::clone(const v8::FunctionCallbackInfo<v8::Value> &args) {
+  HandleScope scope;
+  Shape *s = ObjectWrap::Unwrap<Shape>(args.Holder());
   shapeObj *shape = s->get();
 
   shapeObj *new_shape = (shapeObj *)msSmallMalloc(sizeof(shapeObj));
@@ -208,16 +189,19 @@ void Shape::clone(const v8::FunctionCall
 
   Shape *ns = new Shape(new_shape);
   Handle<Value> ext = External::New(ns);
-  Handle<Object> clone =  Shape::Constructor()->NewInstance(1, &ext);
+  Handle<Object> clone = Shape::Constructor()->NewInstance(1, &ext);
 
   /* we need this to copy shape attributes */
   Handle<Object> self = s->handle();
-  Handle<Object> self_attributes = self->Get(String::New("attributes"))->ToObject();
-  Local<External> wrap = Local<External>::Cast(self_attributes->GetInternalField(0));
+  Handle<Object> self_attributes =
+      self->Get(String::New("attributes"))->ToObject();
+  Local<External> wrap =
+      Local<External>::Cast(self_attributes->GetInternalField(0));
   void *ptr = wrap->Value();
   map<string, int> *self_attributes_map = static_cast<map<string, int> *>(ptr);
 
-  Handle<Object> clone_attributes = clone->Get(String::New("attributes"))->ToObject();
+  Handle<Object> clone_attributes =
+      clone->Get(String::New("attributes"))->ToObject();
   wrap = Local<External>::Cast(clone_attributes->GetInternalField(0));
   ptr = wrap->Value();
   map<string, int> *clone_attributes_map = static_cast<map<string, int> *>(ptr);
@@ -228,8 +212,7 @@ void Shape::clone(const v8::FunctionCall
   args.GetReturnValue().Set(clone);
 }
 
-void Shape::getLine(const v8::FunctionCallbackInfo<v8::Value>& args)
-{
+void Shape::getLine(const v8::FunctionCallbackInfo<v8::Value> &args) {
   HandleScope scope;
 
   if (args.Length() < 1 || !args[0]->IsInt32()) {
@@ -239,11 +222,10 @@ void Shape::getLine(const v8::FunctionCa
 
   int index = args[0]->Int32Value();
 
-  Shape* s = ObjectWrap::Unwrap<Shape>(args.Holder());
+  Shape *s = ObjectWrap::Unwrap<Shape>(args.Holder());
   shapeObj *shape = s->get();
 
-  if (index < 0 || index >= shape->numlines)
-  {
+  if (index < 0 || index >= shape->numlines) {
     ThrowException(String::New("Invalid line index."));
     return;
   }
@@ -253,45 +235,46 @@ void Shape::getLine(const v8::FunctionCa
   args.GetReturnValue().Set(Line::Constructor()->NewInstance(1, &ext));
 }
 
-void Shape::addLine(const v8::FunctionCallbackInfo<v8::Value>& args)
-{
+void Shape::addLine(const v8::FunctionCallbackInfo<v8::Value> &args) {
   HandleScope scope;
 
   if (args.Length() < 1 || !args[0]->IsObject() ||
-      !args[0]->ToObject()->GetConstructorName()->Equals(String::New("lineObj"))) {
+      !args[0]->ToObject()->GetConstructorName()->Equals(
+          String::New("lineObj"))) {
     ThrowException(String::New("Invalid argument"));
     return;
   }
 
-  Shape* s = ObjectWrap::Unwrap<Shape>(args.Holder());
+  Shape *s = ObjectWrap::Unwrap<Shape>(args.Holder());
   shapeObj *shape = s->get();
 
-  Line* l = ObjectWrap::Unwrap<Line>(args[0]->ToObject());
+  Line *l = ObjectWrap::Unwrap<Line>(args[0]->ToObject());
   lineObj *line = l->get();
 
   msAddLine(shape, line);
 }
 
-void Shape::setGeometry(const v8::FunctionCallbackInfo<v8::Value>& args)
-{
+void Shape::setGeometry(const v8::FunctionCallbackInfo<v8::Value> &args) {
   HandleScope scope;
 
   if (args.Length() < 1 || !args[0]->IsObject() ||
-      !args[0]->ToObject()->GetConstructorName()->Equals(String::New("shapeObj"))) {
+      !args[0]->ToObject()->GetConstructorName()->Equals(
+          String::New("shapeObj"))) {
     ThrowException(String::New("Invalid argument"));
     return;
   }
 
-  Shape* s = ObjectWrap::Unwrap<Shape>(args.Holder());
+  Shape *s = ObjectWrap::Unwrap<Shape>(args.Holder());
   shapeObj *shape = s->get();
-  Shape* ns = ObjectWrap::Unwrap<Shape>(args[0]->ToObject());
+  Shape *ns = ObjectWrap::Unwrap<Shape>(args[0]->ToObject());
   shapeObj *new_shape = ns->get();
 
   /* clean current shape */
   for (int i = 0; i < shape->numlines; i++) {
     free(shape->line[i].point);
   }
-  if (shape->line) free(shape->line);
+  if (shape->line)
+    free(shape->line);
   shape->line = NULL;
   shape->numlines = 0;
 
@@ -302,18 +285,17 @@ void Shape::setGeometry(const v8::Functi
   return;
 }
 
-void Shape::attributeWeakCallback(v8::Isolate* isolate,
-                           v8::Persistent<v8::Object>* pobj,
-                           map<string, int> *map) {
-    v8::HandleScope scope(isolate);
-    pobj->Dispose();
-    pobj->Clear();
-    delete map;
+void Shape::attributeWeakCallback(v8::Isolate *isolate,
+                                  v8::Persistent<v8::Object> *pobj,
+                                  map<string, int> *map) {
+  v8::HandleScope scope(isolate);
+  pobj->Dispose();
+  pobj->Clear();
+  delete map;
 }
 
 void Shape::attributeGetValue(Local<String> name,
-                              const PropertyCallbackInfo<Value> &info)
-{
+                              const PropertyCallbackInfo<Value> &info) {
   Local<Object> self = info.Holder();
   Local<External> wrap = Local<External>::Cast(self->GetInternalField(0));
   void *ptr = wrap->Value();
@@ -332,10 +314,8 @@ void Shape::attributeGetValue(Local<Stri
   }
 }
 
-void Shape::attributeSetValue(Local<String> name,
-                              Local<Value> value,
-                              const PropertyCallbackInfo<Value> &info)
-{
+void Shape::attributeSetValue(Local<String> name, Local<Value> value,
+                              const PropertyCallbackInfo<Value> &info) {
   Local<Object> self = info.Holder();
   Local<External> wrap = Local<External>::Cast(self->GetInternalField(0));
   void *ptr = wrap->Value();
@@ -351,9 +331,7 @@ void Shape::attributeSetValue(Local<Stri
 
   if (iter == indexes->end()) {
     ThrowException(String::New("Invalid value name."));
-  }
-  else
-  {
+  } else {
     const int &index = (*iter).second;
     msFree(values[index]);
     values[index] = msStrdup(*utf8_value);
diff -pruN 8.0.1-5/mapscript/v8/shape.hpp 8.0.2-1/mapscript/v8/shape.hpp
--- 8.0.1-5/mapscript/v8/shape.hpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapscript/v8/shape.hpp	2024-06-11 20:41:34.000000000 +0000
@@ -37,44 +37,41 @@ using namespace v8;
 using std::map;
 using std::string;
 
-class Shape: public ObjectWrap
-{
+class Shape : public ObjectWrap {
 public:
   static void Initialize(Handle<Object> target);
-  static void New(const v8::FunctionCallbackInfo<v8::Value>& args);
+  static void New(const v8::FunctionCallbackInfo<v8::Value> &args);
   static void Dispose();
   static Handle<Function> Constructor();
 
   Shape(shapeObj *p);
-  ~Shape();  
-  inline shapeObj* get() { return this_; }
+  ~Shape();
+  inline shapeObj *get() { return this_; }
   inline void disableMemoryHandler() { this->freeInternal = false; }
-  
+
   inline void setLayer(layerObj *layer) { this->layer = layer; };
-  
+
   static void getProp(Local<String> property,
-                      const PropertyCallbackInfo<Value>& info);
-  static void setProp(Local<String> property,
-                      Local<Value> value,
-                      const PropertyCallbackInfo<void>& info);
-
-  static void clone(const v8::FunctionCallbackInfo<v8::Value>& args);
-  static void getLine(const v8::FunctionCallbackInfo<v8::Value>& args);
-  static void addLine(const v8::FunctionCallbackInfo<v8::Value>& args);
-  static void setGeometry(const v8::FunctionCallbackInfo<v8::Value>& args);
+                      const PropertyCallbackInfo<Value> &info);
+  static void setProp(Local<String> property, Local<Value> value,
+                      const PropertyCallbackInfo<void> &info);
+
+  static void clone(const v8::FunctionCallbackInfo<v8::Value> &args);
+  static void getLine(const v8::FunctionCallbackInfo<v8::Value> &args);
+  static void addLine(const v8::FunctionCallbackInfo<v8::Value> &args);
+  static void setGeometry(const v8::FunctionCallbackInfo<v8::Value> &args);
 
   /* This could be generic in the future.. */
-  static void attributeWeakCallback(v8::Isolate* isolate,
-                                    v8::Persistent<v8::Object>* pobj,
+  static void attributeWeakCallback(v8::Isolate *isolate,
+                                    v8::Persistent<v8::Object> *pobj,
                                     map<string, int> *map);
   static void attributeGetValue(Local<String> name,
                                 const PropertyCallbackInfo<Value> &info);
-  static void attributeSetValue(Local<String> name,
-                                Local<Value> value,
+  static void attributeSetValue(Local<String> name, Local<Value> value,
                                 const PropertyCallbackInfo<Value> &info);
-  static void attributeMapDestroy(Isolate *isolate,
-                                  Persistent<Object> *object,
-                                  map<string, int> *map);  
+  static void attributeMapDestroy(Isolate *isolate, Persistent<Object> *object,
+                                  map<string, int> *map);
+
 private:
   static Persistent<FunctionTemplate> constructor;
   bool freeInternal;
diff -pruN 8.0.1-5/mapscript/v8/v8_mapscript.cpp 8.0.2-1/mapscript/v8/v8_mapscript.cpp
--- 8.0.1-5/mapscript/v8/v8_mapscript.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapscript/v8/v8_mapscript.cpp	2024-06-11 20:41:34.000000000 +0000
@@ -32,15 +32,14 @@
 #include "mapserver.h"
 #include "v8_mapscript.h"
 
-char* getStringValue(Local<Value> value, const char *fallback)
-{
+char *getStringValue(Local<Value> value, const char *fallback) {
   if (value->IsString()) {
     String::AsciiValue string(value);
-    char *str = (char *) malloc(string.length() + 1);
+    char *str = (char *)malloc(string.length() + 1);
     strcpy(str, *string);
     return str;
   }
-  char *str = (char *) malloc(strlen(fallback) + 1);
+  char *str = (char *)malloc(strlen(fallback) + 1);
   strcpy(str, fallback);
   return str;
 }
diff -pruN 8.0.1-5/mapscript/v8/v8_mapscript.h 8.0.2-1/mapscript/v8/v8_mapscript.h
--- 8.0.1-5/mapscript/v8/v8_mapscript.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapscript/v8/v8_mapscript.h	2024-06-11 20:41:34.000000000 +0000
@@ -48,28 +48,26 @@
 
 using namespace v8;
 
-using std::string;
-using std::stack;
 using std::map;
+using std::stack;
+using std::string;
 
-class V8Context
-{
+class V8Context {
 public:
-  V8Context(Isolate *isolate)
-    : isolate(isolate) {}
+  V8Context(Isolate *isolate) : isolate(isolate) {}
   Isolate *isolate;
   stack<string> paths; /* for relative paths and the require function */
-  map<string, Persistent<Script> > scripts;
+  map<string, Persistent<Script>> scripts;
   Persistent<Context> context;
   layerObj *layer; /* current layer, used in geomtransform */
 };
 
-#define V8CONTEXT(map) ((V8Context*) (map)->v8context)
+#define V8CONTEXT(map) ((V8Context *)(map)->v8context)
 
 inline void NODE_SET_PROTOTYPE_METHOD(v8::Handle<v8::FunctionTemplate> recv,
-                                      const char* name,
+                                      const char *name,
                                       v8::FunctionCallback callback) {
-  v8::Isolate* isolate = v8::Isolate::GetCurrent();
+  v8::Isolate *isolate = v8::Isolate::GetCurrent();
   v8::HandleScope handle_scope(isolate);
   v8::Local<v8::FunctionTemplate> t = v8::FunctionTemplate::New(callback);
   recv->InstanceTemplate()->Set(v8::String::NewFromUtf8(isolate, name),
@@ -79,29 +77,22 @@ inline void NODE_SET_PROTOTYPE_METHOD(v8
 
 #define TOSTR(obj) (*String::Utf8Value((obj)->ToString()))
 
-#define SET(target, name, value)                 \
+#define SET(target, name, value)                                               \
   (target)->PrototypeTemplate()->Set(String::NewSymbol(name), value);
 
-#define SET_ATTRIBUTE(t, name, get, set)   \
+#define SET_ATTRIBUTE(t, name, get, set)                                       \
   t->InstanceTemplate()->SetAccessor(String::NewSymbol(name), get, set)
 
-#define SET_ATTRIBUTE_RO(t, name, get)             \
-  t->InstanceTemplate()->SetAccessor(              \
-        String::NewSymbol(name),                   \
-        get, 0,                                    \
-        Handle<Value>(),                           \
-        DEFAULT,                                   \
-        static_cast<PropertyAttribute>(            \
-          ReadOnly|DontDelete))
-
-#define NODE_DEFINE_CONSTANT(target, name, constant)     \
-    (target)->Set(String::NewSymbol(name),               \
-                  Integer::New(constant),                \
-                  static_cast<PropertyAttribute>(        \
-                  ReadOnly|DontDelete));
-
-char* getStringValue(Local<Value> value, const char *fallback="");
+#define SET_ATTRIBUTE_RO(t, name, get)                                         \
+  t->InstanceTemplate()->SetAccessor(                                          \
+      String::NewSymbol(name), get, 0, Handle<Value>(), DEFAULT,               \
+      static_cast<PropertyAttribute>(ReadOnly | DontDelete))
+
+#define NODE_DEFINE_CONSTANT(target, name, constant)                           \
+  (target)->Set(String::NewSymbol(name), Integer::New(constant),               \
+                static_cast<PropertyAttribute>(ReadOnly | DontDelete));
 
+char *getStringValue(Local<Value> value, const char *fallback = "");
 
 #endif
 
diff -pruN 8.0.1-5/mapscript/v8/v8_object_wrap.hpp 8.0.2-1/mapscript/v8/v8_object_wrap.hpp
--- 8.0.1-5/mapscript/v8/v8_object_wrap.hpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapscript/v8/v8_object_wrap.hpp	2024-06-11 20:41:34.000000000 +0000
@@ -26,10 +26,8 @@
 #include <assert.h>
 
 class ObjectWrap {
- public:
-  ObjectWrap() {
-    refs_ = 0;
-  }
+public:
+  ObjectWrap() { refs_ = 0; }
 
   virtual ~ObjectWrap() {
     if (persistent().IsEmpty())
@@ -39,35 +37,27 @@ class ObjectWrap {
     persistent().Dispose();
   }
 
-
-  template <class T>
-  static inline T* Unwrap(v8::Handle<v8::Object> handle) {
+  template <class T> static inline T *Unwrap(v8::Handle<v8::Object> handle) {
     assert(!handle.IsEmpty());
     assert(handle->InternalFieldCount() > 0);
     // Cast to ObjectWrap before casting to T.  A direct cast from void
     // to T won't work right when T has more than one base class.
-    void* ptr = handle->GetAlignedPointerFromInternalField(0);
-    ObjectWrap* wrap = static_cast<ObjectWrap*>(ptr);
-    return static_cast<T*>(wrap);
+    void *ptr = handle->GetAlignedPointerFromInternalField(0);
+    ObjectWrap *wrap = static_cast<ObjectWrap *>(ptr);
+    return static_cast<T *>(wrap);
   }
 
-
   inline v8::Local<v8::Object> handle() {
     return handle(v8::Isolate::GetCurrent());
   }
 
-
-  inline v8::Local<v8::Object> handle(v8::Isolate* isolate) {
+  inline v8::Local<v8::Object> handle(v8::Isolate *isolate) {
     return v8::Local<v8::Object>::New(isolate, persistent());
   }
 
+  inline v8::Persistent<v8::Object> &persistent() { return handle_; }
 
-  inline v8::Persistent<v8::Object>& persistent() {
-    return handle_;
-  }
-
-
- protected:
+protected:
   inline void Wrap(v8::Handle<v8::Object> handle) {
     assert(persistent().IsEmpty());
     assert(handle->InternalFieldCount() > 0);
@@ -76,7 +66,6 @@ class ObjectWrap {
     MakeWeak();
   }
 
-
   inline void MakeWeak(void) {
     persistent().MakeWeak(this, WeakCallback);
     persistent().MarkIndependent();
@@ -109,12 +98,11 @@ class ObjectWrap {
       MakeWeak();
   }
 
-  int refs_;  // ro
+  int refs_; // ro
 
- private:
-  static void WeakCallback(v8::Isolate* isolate,
-                           v8::Persistent<v8::Object>* pobj,
-                           ObjectWrap* wrap) {
+private:
+  static void WeakCallback(v8::Isolate *isolate,
+                           v8::Persistent<v8::Object> *pobj, ObjectWrap *wrap) {
     v8::HandleScope scope(isolate);
     assert(wrap->refs_ == 0);
     assert(*pobj == wrap->persistent());
@@ -125,5 +113,4 @@ class ObjectWrap {
   v8::Persistent<v8::Object> handle_;
 };
 
-
-#endif  // v8_OBJECT_WRAP_H_
+#endif // v8_OBJECT_WRAP_H_
diff -pruN 8.0.1-5/mapsearch.c 8.0.2-1/mapsearch.c
--- 8.0.1-5/mapsearch.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapsearch.c	2024-06-11 20:41:34.000000000 +0000
@@ -35,21 +35,22 @@
 
 #include "mapserver.h"
 
-
-
-#define LASTVERT(v,n)  ((v) == 0 ? n-2 : v-1)
-#define NEXTVERT(v,n)  ((v) == n-2 ? 0 : v+1)
+#define LASTVERT(v, n) ((v) == 0 ? n - 2 : v - 1)
+#define NEXTVERT(v, n) ((v) == n - 2 ? 0 : v + 1)
 
 /*
 ** Returns MS_TRUE if rectangles a and b overlap
 */
-int msRectOverlap(const rectObj *a, const rectObj *b)
-{
-  if(a->minx > b->maxx) return(MS_FALSE);
-  if(a->maxx < b->minx) return(MS_FALSE);
-  if(a->miny > b->maxy) return(MS_FALSE);
-  if(a->maxy < b->miny) return(MS_FALSE);
-  return(MS_TRUE);
+int msRectOverlap(const rectObj *a, const rectObj *b) {
+  if (a->minx > b->maxx)
+    return (MS_FALSE);
+  if (a->maxx < b->minx)
+    return (MS_FALSE);
+  if (a->miny > b->maxy)
+    return (MS_FALSE);
+  if (a->maxy < b->miny)
+    return (MS_FALSE);
+  return (MS_TRUE);
 }
 
 /*
@@ -57,18 +58,17 @@ int msRectOverlap(const rectObj *a, cons
 ** to be only the intersection of the two.  Returns MS_FALSE if
 ** the intersection is empty.
 */
-int msRectIntersect( rectObj *a, const rectObj *b )
-{
-  if( a->maxx > b->maxx )
+int msRectIntersect(rectObj *a, const rectObj *b) {
+  if (a->maxx > b->maxx)
     a->maxx = b->maxx;
-  if( a->minx < b->minx )
+  if (a->minx < b->minx)
     a->minx = b->minx;
-  if( a->maxy > b->maxy )
+  if (a->maxy > b->maxy)
     a->maxy = b->maxy;
-  if( a->miny < b->miny )
+  if (a->miny < b->miny)
     a->miny = b->miny;
 
-  if( a->maxx < a->minx || b->maxx < b->minx )
+  if (a->maxx < a->minx || b->maxx < b->minx)
     return MS_FALSE;
   else
     return MS_TRUE;
@@ -77,91 +77,108 @@ int msRectIntersect( rectObj *a, const r
 /*
 ** Returns MS_TRUE if rectangle a is contained in rectangle b
 */
-int msRectContained(const rectObj *a, const rectObj *b)
-{
-  if(a->minx >= b->minx && a->maxx <= b->maxx)
-    if(a->miny >= b->miny && a->maxy <= b->maxy)
-      return(MS_TRUE);
-  return(MS_FALSE);
+int msRectContained(const rectObj *a, const rectObj *b) {
+  if (a->minx >= b->minx && a->maxx <= b->maxx)
+    if (a->miny >= b->miny && a->maxy <= b->maxy)
+      return (MS_TRUE);
+  return (MS_FALSE);
 }
 
 /*
 ** Merges rect b into rect a. Rect a changes, b does not.
 */
-void msMergeRect(rectObj *a, rectObj *b)
-{
+void msMergeRect(rectObj *a, rectObj *b) {
   a->minx = MS_MIN(a->minx, b->minx);
   a->maxx = MS_MAX(a->maxx, b->maxx);
   a->miny = MS_MIN(a->miny, b->miny);
   a->maxy = MS_MAX(a->maxy, b->maxy);
 }
 
-int msPointInRect(const pointObj *p, const rectObj *rect)
-{
-  if(p->x < rect->minx) return(MS_FALSE);
-  if(p->x > rect->maxx) return(MS_FALSE);
-  if(p->y < rect->miny) return(MS_FALSE);
-  if(p->y > rect->maxy) return(MS_FALSE);
-  return(MS_TRUE);
+int msPointInRect(const pointObj *p, const rectObj *rect) {
+  if (p->x < rect->minx)
+    return (MS_FALSE);
+  if (p->x > rect->maxx)
+    return (MS_FALSE);
+  if (p->y < rect->miny)
+    return (MS_FALSE);
+  if (p->y > rect->maxy)
+    return (MS_FALSE);
+  return (MS_TRUE);
 }
 
-int msPolygonDirection(lineObj *c)
-{
+int msPolygonDirection(lineObj *c) {
   double mx, my, area;
-  int i, v=0, lv, nv;
+  int i, v = 0, lv, nv;
 
   /* first find lowest, rightmost point of polygon */
   mx = c->point[0].x;
   my = c->point[0].y;
 
-  for(i=0; i<c->numpoints-1; i++) {
-    if((c->point[i].y < my) || ((c->point[i].y == my) && (c->point[i].x > mx))) {
+  for (i = 0; i < c->numpoints - 1; i++) {
+    if ((c->point[i].y < my) ||
+        ((c->point[i].y == my) && (c->point[i].x > mx))) {
       v = i;
       mx = c->point[i].x;
       my = c->point[i].y;
     }
   }
 
-  lv = LASTVERT(v,c->numpoints);
-  nv = NEXTVERT(v,c->numpoints);
+  lv = LASTVERT(v, c->numpoints);
+  nv = NEXTVERT(v, c->numpoints);
 
-  area = c->point[lv].x*c->point[v].y - c->point[lv].y*c->point[v].x + c->point[lv].y*c->point[nv].x - c->point[lv].x*c->point[nv].y + c->point[v].x*c->point[nv].y - c->point[nv].x*c->point[v].y;
-  if(area > 0)
-    return(1); /* counter clockwise orientation */
-  else if(area < 0) /* clockwise orientation */
-    return(-1);
+  area = c->point[lv].x * c->point[v].y - c->point[lv].y * c->point[v].x +
+         c->point[lv].y * c->point[nv].x - c->point[lv].x * c->point[nv].y +
+         c->point[v].x * c->point[nv].y - c->point[nv].x * c->point[v].y;
+  if (area > 0)
+    return (1);      /* counter clockwise orientation */
+  else if (area < 0) /* clockwise orientation */
+    return (-1);
   else
-    return(0); /* shouldn't happen unless the polygon is self intersecting */
+    return (0); /* shouldn't happen unless the polygon is self intersecting */
 }
 
 /*
 ** Copyright (c) 1970-2003, Wm. Randolph Franklin
 **
-** Permission is hereby granted, free of charge, to any person obtaining a copy of this software and
-** associated documentation files (the "Software"), to deal in the Software without restriction, including
-** without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
-** copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the
+** Permission is hereby granted, free of charge, to any person obtaining a copy
+*of this software and
+** associated documentation files (the "Software"), to deal in the Software
+*without restriction, including
+** without limitation the rights to use, copy, modify, merge, publish,
+*distribute, sublicense, and/or sell
+** copies of the Software, and to permit persons to whom the Software is
+*furnished to do so, subject to the
 ** following conditions:
 **
-** 1. Redistributions of source code must retain the above copyright notice, this list of conditions and the
+** 1. Redistributions of source code must retain the above copyright notice,
+*this list of conditions and the
 **    following disclaimers.
-** 2. Redistributions in binary form must reproduce the above copyright notice in the documentation and/or
+** 2. Redistributions in binary form must reproduce the above copyright notice
+*in the documentation and/or
 **    other materials provided with the distribution.
-** 3. The name of W. Randolph Franklin may not be used to endorse or promote products derived from this
+** 3. The name of W. Randolph Franklin may not be used to endorse or promote
+*products derived from this
 **    Software without specific prior written permission.
 **
-** THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT
-** LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
-** NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
-** WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
+** THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+*IMPLIED, INCLUDING BUT NOT
+** LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
+*PURPOSE AND NONINFRINGEMENT. IN
+** NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
+*DAMAGES OR OTHER LIABILITY,
+** WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR
+*IN CONNECTION WITH THE
 ** SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */
-int msPointInPolygon(pointObj *p, lineObj *c)
-{
+int msPointInPolygon(pointObj *p, lineObj *c) {
   int i, j, status = MS_FALSE;
 
-  for (i = 0, j = c->numpoints-1; i < c->numpoints; j = i++) {
-    if ((((c->point[i].y<=p->y) && (p->y<c->point[j].y)) || ((c->point[j].y<=p->y) && (p->y<c->point[i].y))) && (p->x < (c->point[j].x - c->point[i].x) * (p->y - c->point[i].y) / (c->point[j].y - c->point[i].y) + c->point[i].x))
+  for (i = 0, j = c->numpoints - 1; i < c->numpoints; j = i++) {
+    if ((((c->point[i].y <= p->y) && (p->y < c->point[j].y)) ||
+         ((c->point[j].y <= p->y) && (p->y < c->point[i].y))) &&
+        (p->x < (c->point[j].x - c->point[i].x) * (p->y - c->point[i].y) /
+                        (c->point[j].y - c->point[i].y) +
+                    c->point[i].x))
       status = !status;
   }
   return status;
@@ -173,44 +190,50 @@ int msPointInPolygon(pointObj *p, lineOb
 ** cases. In due time... -SDL-
 */
 
-int msIntersectSegments(const pointObj *a, const pointObj *b, const pointObj *c, const pointObj *d)   /* from comp.graphics.alogorithms FAQ */
+int msIntersectSegments(
+    const pointObj *a, const pointObj *b, const pointObj *c,
+    const pointObj *d) /* from comp.graphics.alogorithms FAQ */
 {
 
   double r, s;
   double denominator, numerator;
 
-  numerator = ((a->y-c->y)*(d->x-c->x) - (a->x-c->x)*(d->y-c->y));
-  denominator = ((b->x-a->x)*(d->y-c->y) - (b->y-a->y)*(d->x-c->x));
+  numerator = ((a->y - c->y) * (d->x - c->x) - (a->x - c->x) * (d->y - c->y));
+  denominator = ((b->x - a->x) * (d->y - c->y) - (b->y - a->y) * (d->x - c->x));
 
-  if((denominator == 0) && (numerator == 0)) { /* lines are coincident, intersection is a line segement if it exists */
-    if(a->y == c->y) { /* coincident horizontally, check x's */
-      if(((a->x >= MS_MIN(c->x,d->x)) && (a->x <= MS_MAX(c->x,d->x))) || ((b->x >= MS_MIN(c->x,d->x)) && (b->x <= MS_MAX(c->x,d->x))))
-        return(MS_TRUE);
+  if ((denominator == 0) &&
+      (numerator == 0)) { /* lines are coincident, intersection is a line
+                             segement if it exists */
+    if (a->y == c->y) {   /* coincident horizontally, check x's */
+      if (((a->x >= MS_MIN(c->x, d->x)) && (a->x <= MS_MAX(c->x, d->x))) ||
+          ((b->x >= MS_MIN(c->x, d->x)) && (b->x <= MS_MAX(c->x, d->x))))
+        return (MS_TRUE);
       else
-        return(MS_FALSE);
+        return (MS_FALSE);
     } else { /* test for y's will work fine for remaining cases */
-      if(((a->y >= MS_MIN(c->y,d->y)) && (a->y <= MS_MAX(c->y,d->y))) || ((b->y >= MS_MIN(c->y,d->y)) && (b->y <= MS_MAX(c->y,d->y))))
-        return(MS_TRUE);
+      if (((a->y >= MS_MIN(c->y, d->y)) && (a->y <= MS_MAX(c->y, d->y))) ||
+          ((b->y >= MS_MIN(c->y, d->y)) && (b->y <= MS_MAX(c->y, d->y))))
+        return (MS_TRUE);
       else
-        return(MS_FALSE);
+        return (MS_FALSE);
     }
   }
 
-  if(denominator == 0) /* lines are parallel, can't intersect */
-    return(MS_FALSE);
+  if (denominator == 0) /* lines are parallel, can't intersect */
+    return (MS_FALSE);
 
-  r = numerator/denominator;
+  r = numerator / denominator;
 
-  if((r<0) || (r>1))
-    return(MS_FALSE); /* no intersection */
+  if ((r < 0) || (r > 1))
+    return (MS_FALSE); /* no intersection */
 
-  numerator = ((a->y-c->y)*(b->x-a->x) - (a->x-c->x)*(b->y-a->y));
-  s = numerator/denominator;
+  numerator = ((a->y - c->y) * (b->x - a->x) - (a->x - c->x) * (b->y - a->y));
+  s = numerator / denominator;
 
-  if((s<0) || (s>1))
-    return(MS_FALSE); /* no intersection */
+  if ((s < 0) || (s > 1))
+    return (MS_FALSE); /* no intersection */
 
-  return(MS_TRUE);
+  return (MS_TRUE);
 }
 
 /*
@@ -218,160 +241,168 @@ int msIntersectSegments(const pointObj *
 ** point falls in. If odd the point is in the polygon, if 0 or even
 ** then the point is in a hole or completely outside.
 */
-int msIntersectPointPolygon(pointObj *point, shapeObj *poly)
-{
+int msIntersectPointPolygon(pointObj *point, shapeObj *poly) {
   int i;
-  int status=MS_FALSE;
+  int status = MS_FALSE;
 
-  for(i=0; i<poly->numlines; i++) {
-    if(msPointInPolygon(point, &poly->line[i]) == MS_TRUE) /* ok, the point is in a line */
+  for (i = 0; i < poly->numlines; i++) {
+    if (msPointInPolygon(point, &poly->line[i]) ==
+        MS_TRUE) /* ok, the point is in a line */
       status = !status;
   }
 
-  return(status);
+  return (status);
 }
 
-int msIntersectMultipointPolygon(shapeObj *multipoint, shapeObj *poly)
-{
-  int i,j;
+int msIntersectMultipointPolygon(shapeObj *multipoint, shapeObj *poly) {
+  int i, j;
 
   /* The change to loop through all the lines has been made for ticket
    * #2443 but is no more needed since ticket #2762. PostGIS now put all
    * points into a single line.  */
-  for(i=0; i<multipoint->numlines; i++ ) {
+  for (i = 0; i < multipoint->numlines; i++) {
     lineObj points = multipoint->line[i];
-    for(j=0; j<points.numpoints; j++) {
-      if(msIntersectPointPolygon(&(points.point[j]), poly) == MS_TRUE)
-        return(MS_TRUE);
+    for (j = 0; j < points.numpoints; j++) {
+      if (msIntersectPointPolygon(&(points.point[j]), poly) == MS_TRUE)
+        return (MS_TRUE);
     }
   }
 
-  return(MS_FALSE);
+  return (MS_FALSE);
 }
 
-int msIntersectPolylines(shapeObj *line1, shapeObj *line2)
-{
-  int c1,v1,c2,v2;
+int msIntersectPolylines(shapeObj *line1, shapeObj *line2) {
+  int c1, v1, c2, v2;
 
-  for(c1=0; c1<line1->numlines; c1++)
-    for(v1=1; v1<line1->line[c1].numpoints; v1++)
-      for(c2=0; c2<line2->numlines; c2++)
-        for(v2=1; v2<line2->line[c2].numpoints; v2++)
-          if(msIntersectSegments(&(line1->line[c1].point[v1-1]), &(line1->line[c1].point[v1]),
-                                 &(line2->line[c2].point[v2-1]), &(line2->line[c2].point[v2])) ==  MS_TRUE)
-            return(MS_TRUE);
+  for (c1 = 0; c1 < line1->numlines; c1++)
+    for (v1 = 1; v1 < line1->line[c1].numpoints; v1++)
+      for (c2 = 0; c2 < line2->numlines; c2++)
+        for (v2 = 1; v2 < line2->line[c2].numpoints; v2++)
+          if (msIntersectSegments(&(line1->line[c1].point[v1 - 1]),
+                                  &(line1->line[c1].point[v1]),
+                                  &(line2->line[c2].point[v2 - 1]),
+                                  &(line2->line[c2].point[v2])) == MS_TRUE)
+            return (MS_TRUE);
 
-  return(MS_FALSE);
+  return (MS_FALSE);
 }
 
-int msIntersectPolylinePolygon(shapeObj *line, shapeObj *poly)
-{
+int msIntersectPolylinePolygon(shapeObj *line, shapeObj *poly) {
   int i;
 
-  /* STEP 1: polygon might competely contain the polyline or one of it's parts (only need to check one point from each part) */
-  for(i=0; i<line->numlines; i++) {
-    if(msIntersectPointPolygon(&(line->line[i].point[0]), poly) == MS_TRUE) /* this considers holes and multiple parts */
-      return(MS_TRUE);
+  /* STEP 1: polygon might competely contain the polyline or one of it's parts
+   * (only need to check one point from each part) */
+  for (i = 0; i < line->numlines; i++) {
+    if (msIntersectPointPolygon(&(line->line[i].point[0]), poly) ==
+        MS_TRUE) /* this considers holes and multiple parts */
+      return (MS_TRUE);
   }
 
   /* STEP 2: look for intersecting line segments */
   if (msIntersectPolylines(line, poly) == MS_TRUE)
     return (MS_TRUE);
 
-  return(MS_FALSE);
+  return (MS_FALSE);
 }
 
-int msIntersectPolygons(shapeObj *p1, shapeObj *p2)
-{
+int msIntersectPolygons(shapeObj *p1, shapeObj *p2) {
   int i;
 
-  /* STEP 1: polygon 1 completely contains 2 (only need to check one point from each part) */
-  for(i=0; i<p2->numlines; i++) {
-    if(msIntersectPointPolygon(&(p2->line[i].point[0]), p1) == MS_TRUE) /* this considers holes and multiple parts */
-      return(MS_TRUE);
+  /* STEP 1: polygon 1 completely contains 2 (only need to check one point from
+   * each part) */
+  for (i = 0; i < p2->numlines; i++) {
+    if (msIntersectPointPolygon(&(p2->line[i].point[0]), p1) ==
+        MS_TRUE) /* this considers holes and multiple parts */
+      return (MS_TRUE);
   }
 
-  /* STEP 2: polygon 2 completely contains 1 (only need to check one point from each part) */
-  for(i=0; i<p1->numlines; i++) {
-    if(msIntersectPointPolygon(&(p1->line[i].point[0]), p2) == MS_TRUE) /* this considers holes and multiple parts */
-      return(MS_TRUE);
+  /* STEP 2: polygon 2 completely contains 1 (only need to check one point from
+   * each part) */
+  for (i = 0; i < p1->numlines; i++) {
+    if (msIntersectPointPolygon(&(p1->line[i].point[0]), p2) ==
+        MS_TRUE) /* this considers holes and multiple parts */
+      return (MS_TRUE);
   }
 
   /* STEP 3: look for intersecting line segments */
   if (msIntersectPolylines(p1, p2) == MS_TRUE)
-    return(MS_TRUE);
+    return (MS_TRUE);
 
   /*
-  ** At this point we know there are are no intersections between edges. There may be other tests necessary
+  ** At this point we know there are are no intersections between edges. There
+  *may be other tests necessary
   ** but I haven't run into any cases that require them.
   */
 
-  return(MS_FALSE);
+  return (MS_FALSE);
 }
 
-
 /*
 ** Distance computations
 */
 
-double msDistancePointToPoint(pointObj *a, pointObj *b)
-{
+double msDistancePointToPoint(pointObj *a, pointObj *b) {
   double d;
 
   d = sqrt(msSquareDistancePointToPoint(a, b));
 
-  return(d);
+  return (d);
 }
 
 /*
-** Quickly compute the square of the distance; avoids expensive sqrt() call on each invocation
+** Quickly compute the square of the distance; avoids expensive sqrt() call on
+*each invocation
 */
-double msSquareDistancePointToPoint(pointObj *a, pointObj *b)
-{
+double msSquareDistancePointToPoint(pointObj *a, pointObj *b) {
   double dx, dy;
 
   dx = a->x - b->x;
   dy = a->y - b->y;
 
-  return(dx*dx + dy*dy);
+  return (dx * dx + dy * dy);
 }
 
-double msDistancePointToSegment(pointObj *p, pointObj *a, pointObj *b)
-{
+double msDistancePointToSegment(pointObj *p, pointObj *a, pointObj *b) {
   return (sqrt(msSquareDistancePointToSegment(p, a, b)));
 }
 
-double msSquareDistancePointToSegment(pointObj *p, pointObj *a, pointObj *b)
-{
+double msSquareDistancePointToSegment(pointObj *p, pointObj *a, pointObj *b) {
   double l_squared; /* squared length of line ab */
-  double r,s;
+  double r, s;
 
-  l_squared = msSquareDistancePointToPoint(a,b);
+  l_squared = msSquareDistancePointToPoint(a, b);
 
-  if(l_squared == 0.0) /* a = b */
-    return(msSquareDistancePointToPoint(a,p));
+  if (l_squared == 0.0) /* a = b */
+    return (msSquareDistancePointToPoint(a, p));
 
-  r = ((a->y - p->y)*(a->y - b->y) - (a->x - p->x)*(b->x - a->x))/(l_squared);
+  r = ((a->y - p->y) * (a->y - b->y) - (a->x - p->x) * (b->x - a->x)) /
+      (l_squared);
 
-  if(r > 1) /* perpendicular projection of P is on the forward extention of AB */
-    return(MS_MIN(msSquareDistancePointToPoint(p, b),msSquareDistancePointToPoint(p, a)));
-  if(r < 0) /* perpendicular projection of P is on the backward extention of AB */
-    return(MS_MIN(msSquareDistancePointToPoint(p, b),msSquareDistancePointToPoint(p, a)));
+  if (r >
+      1) /* perpendicular projection of P is on the forward extention of AB */
+    return (MS_MIN(msSquareDistancePointToPoint(p, b),
+                   msSquareDistancePointToPoint(p, a)));
+  if (r <
+      0) /* perpendicular projection of P is on the backward extention of AB */
+    return (MS_MIN(msSquareDistancePointToPoint(p, b),
+                   msSquareDistancePointToPoint(p, a)));
 
-  s = ((a->y - p->y)*(b->x - a->x) - (a->x - p->x)*(b->y - a->y))/l_squared;
+  s = ((a->y - p->y) * (b->x - a->x) - (a->x - p->x) * (b->y - a->y)) /
+      l_squared;
 
-  return(fabs(s*s*l_squared));
+  return (fabs(s * s * l_squared));
 }
 
 #define SMALL_NUMBER 0.00000001
-#define dot(u,v) ((u).x *(v).x + (u).y *(v).y) /* vector dot product */
-#define norm(v) sqrt(dot(v,v))
+#define dot(u, v) ((u).x * (v).x + (u).y * (v).y) /* vector dot product */
+#define norm(v) sqrt(dot(v, v))
 
-#define slope(a,b) (((a)->y - (b)->y)/((a)->x - (b)->x))
+#define slope(a, b) (((a)->y - (b)->y) / ((a)->x - (b)->x))
 
 /* Segment to segment distance code is a modified version of that found at:  */
 /*  */
-/* http://www.geometryalgorithms.com/Archive/algorithm_0106/algorithm_0106.htm */
+/* http://www.geometryalgorithms.com/Archive/algorithm_0106/algorithm_0106.htm
+ */
 /*  */
 /* Copyright 2001, softSurfer (www.softsurfer.com) */
 /* This code may be freely used and modified for any purpose */
@@ -380,12 +411,13 @@ double msSquareDistancePointToSegment(po
 /* liable for any real or imagined damage resulting from its use. */
 /* Users of this code must verify correctness for their application. */
 
-double msDistanceSegmentToSegment(pointObj *pa, pointObj *pb, pointObj *pc, pointObj *pd)
-{
+double msDistanceSegmentToSegment(pointObj *pa, pointObj *pb, pointObj *pc,
+                                  pointObj *pd) {
   vectorObj u, v, w;
 
   /* check for strictly parallel segments first */
-  /* if(((pa->x == pb->x) && (pc->x == pd->x)) || (slope(pa,pb) == slope(pc,pd))) { // vertical (infinite slope) || otherwise parallel */
+  /* if(((pa->x == pb->x) && (pc->x == pd->x)) || (slope(pa,pb) ==
+   * slope(pc,pd))) { // vertical (infinite slope) || otherwise parallel */
   /* D = msDistancePointToSegment(pa, pc, pd); */
   /* D = MS_MIN(D, msDistancePointToSegment(pb, pc, pd)); */
   /* D = MS_MIN(D, msDistancePointToSegment(pc, pa, pb)); */
@@ -399,13 +431,13 @@ double msDistanceSegmentToSegment(pointO
   w.x = pa->x - pc->x; /* w = pa - pc */
   w.y = pa->y - pc->y;
 
-  const double a = dot(u,u);
-  const double b = dot(u,v);
-  const double c = dot(v,v);
-  const double d = dot(u,w);
-  const double e = dot(v,w);
+  const double a = dot(u, u);
+  const double b = dot(u, v);
+  const double c = dot(v, v);
+  const double d = dot(u, w);
+  const double e = dot(v, w);
 
-  const double D = a*c - b*b;
+  const double D = a * c - b * b;
   /* N=numerator, D=demoninator */
   double sN = 0;
   double sD = D;
@@ -413,41 +445,39 @@ double msDistanceSegmentToSegment(pointO
   double tN = D;
 
   /* compute the line parameters of the two closest points */
-  if(D < SMALL_NUMBER) { /* lines are parallel or almost parallel */
+  if (D < SMALL_NUMBER) { /* lines are parallel or almost parallel */
     sD = 1.0;
     tN = e;
     tD = c;
   } else { /* get the closest points on the infinite lines */
-    sN = b*e - c*d;
-    tN = a*e - b*d;
-    if(sN < 0) {
+    sN = b * e - c * d;
+    tN = a * e - b * d;
+    if (sN < 0) {
       sN = 0.0;
       tN = e;
       tD = c;
-    } else if(sN > sD) {
+    } else if (sN > sD) {
       sN = sD;
       tN = e + b;
       tD = c;
     }
   }
 
-  if(tN < 0) {
+  if (tN < 0) {
     tN = 0.0;
-    if(-d < 0) {
+    if (-d < 0) {
       /* sN = 0.0 */
-    }
-    else if(-d > a)
+    } else if (-d > a)
       sN = sD;
     else {
       sN = -d;
       sD = a;
     }
-  } else if(tN > tD) {
+  } else if (tN > tD) {
     tN = tD;
-    if((-d + b) < 0) {
+    if ((-d + b) < 0) {
       /* sN = 0.0 */
-    }
-    else if((-d + b) > a)
+    } else if ((-d + b) > a)
       sN = sD;
     else {
       sN = (-d + b);
@@ -456,213 +486,248 @@ double msDistanceSegmentToSegment(pointO
   }
 
   /* finally do the division to get sc and tc */
-  const double sc = sN/sD;
-  const double tc = tN/tD;
+  const double sc = sN / sD;
+  const double tc = tN / tD;
 
   vectorObj dP;
-  dP.x = w.x + (sc*u.x) - (tc*v.x);
-  dP.y = w.y + (sc*u.y) - (tc*v.y);
+  dP.x = w.x + (sc * u.x) - (tc * v.x);
+  dP.y = w.y + (sc * u.y) - (tc * v.y);
 
-  return(norm(dP));
+  return (norm(dP));
 }
 
-double msDistancePointToShape(pointObj *point, shapeObj *shape)
-{
+double msDistancePointToShape(pointObj *point, shapeObj *shape) {
   double d;
 
   d = msSquareDistancePointToShape(point, shape);
 
-  return(sqrt(d));
+  return (sqrt(d));
 }
 
 /*
 ** As msDistancePointToShape; avoid expensive sqrt calls
 */
-double msSquareDistancePointToShape(pointObj *point, shapeObj *shape)
-{
+double msSquareDistancePointToShape(pointObj *point, shapeObj *shape) {
   int i, j;
-  double dist, minDist=-1;
+  double dist, minDist = -1;
 
-  switch(shape->type) {
-    case(MS_SHAPE_POINT):
-      for(j=0; j<shape->numlines; j++) {
-        for(i=0; i<shape->line[j].numpoints; i++) {
-          dist = msSquareDistancePointToPoint(point, &(shape->line[j].point[i]));
-          if((dist < minDist) || (minDist < 0)) minDist = dist;
-        }
+  switch (shape->type) {
+  case (MS_SHAPE_POINT):
+    for (j = 0; j < shape->numlines; j++) {
+      for (i = 0; i < shape->line[j].numpoints; i++) {
+        dist = msSquareDistancePointToPoint(point, &(shape->line[j].point[i]));
+        if ((dist < minDist) || (minDist < 0))
+          minDist = dist;
       }
-      break;
-    case(MS_SHAPE_LINE):
-      for(j=0; j<shape->numlines; j++) {
-        for(i=1; i<shape->line[j].numpoints; i++) {
-          dist = msSquareDistancePointToSegment(point, &(shape->line[j].point[i-1]), &(shape->line[j].point[i]));
-          if((dist < minDist) || (minDist < 0)) minDist = dist;
-        }
+    }
+    break;
+  case (MS_SHAPE_LINE):
+    for (j = 0; j < shape->numlines; j++) {
+      for (i = 1; i < shape->line[j].numpoints; i++) {
+        dist = msSquareDistancePointToSegment(
+            point, &(shape->line[j].point[i - 1]), &(shape->line[j].point[i]));
+        if ((dist < minDist) || (minDist < 0))
+          minDist = dist;
       }
-      break;
-    case(MS_SHAPE_POLYGON):
-      if(msIntersectPointPolygon(point, shape))
-        minDist = 0; /* point is IN the shape */
-      else { /* treat shape just like a line */
-        for(j=0; j<shape->numlines; j++) {
-          for(i=1; i<shape->line[j].numpoints; i++) {
-            dist = msSquareDistancePointToSegment(point, &(shape->line[j].point[i-1]), &(shape->line[j].point[i]));
-            if((dist < minDist) || (minDist < 0)) minDist = dist;
-          }
+    }
+    break;
+  case (MS_SHAPE_POLYGON):
+    if (msIntersectPointPolygon(point, shape))
+      minDist = 0; /* point is IN the shape */
+    else {         /* treat shape just like a line */
+      for (j = 0; j < shape->numlines; j++) {
+        for (i = 1; i < shape->line[j].numpoints; i++) {
+          dist = msSquareDistancePointToSegment(point,
+                                                &(shape->line[j].point[i - 1]),
+                                                &(shape->line[j].point[i]));
+          if ((dist < minDist) || (minDist < 0))
+            minDist = dist;
         }
       }
-      break;
-    default:
-      break;
-  }
-
-  return(minDist);
-}
-
-double msDistanceShapeToShape(shapeObj *shape1, shapeObj *shape2)
-{
-  int i,j,k,l;
-  double dist, minDist=-1;
-
-  switch(shape1->type) {
-    case(MS_SHAPE_POINT): /* shape1 */
-      for(i=0; i<shape1->numlines; i++) {
-        for(j=0; j<shape1->line[i].numpoints; j++) {
-          dist = msSquareDistancePointToShape(&(shape1->line[i].point[j]), shape2);
-          if((dist < minDist) || (minDist < 0))
+    }
+    break;
+  default:
+    break;
+  }
+
+  return (minDist);
+}
+
+double msDistanceShapeToShape(shapeObj *shape1, shapeObj *shape2) {
+  int i, j, k, l;
+  double dist, minDist = -1;
+
+  switch (shape1->type) {
+  case (MS_SHAPE_POINT): /* shape1 */
+    for (i = 0; i < shape1->numlines; i++) {
+      for (j = 0; j < shape1->line[i].numpoints; j++) {
+        dist =
+            msSquareDistancePointToShape(&(shape1->line[i].point[j]), shape2);
+        if ((dist < minDist) || (minDist < 0))
+          minDist = dist;
+      }
+    }
+    minDist = sqrt(minDist);
+    break;
+  case (MS_SHAPE_LINE): /* shape1 */
+    switch (shape2->type) {
+    case (MS_SHAPE_POINT):
+      for (i = 0; i < shape2->numlines; i++) {
+        for (j = 0; j < shape2->line[i].numpoints; j++) {
+          dist =
+              msSquareDistancePointToShape(&(shape2->line[i].point[j]), shape1);
+          if ((dist < minDist) || (minDist < 0))
             minDist = dist;
         }
       }
       minDist = sqrt(minDist);
       break;
-    case(MS_SHAPE_LINE): /* shape1 */
-      switch(shape2->type) {
-        case(MS_SHAPE_POINT):
-          for(i=0; i<shape2->numlines; i++) {
-            for(j=0; j<shape2->line[i].numpoints; j++) {
-              dist = msSquareDistancePointToShape(&(shape2->line[i].point[j]), shape1);
-              if((dist < minDist) || (minDist < 0))
+    case (MS_SHAPE_LINE):
+      for (i = 0; i < shape1->numlines; i++) {
+        for (j = 1; j < shape1->line[i].numpoints; j++) {
+          for (k = 0; k < shape2->numlines; k++) {
+            for (l = 1; l < shape2->line[k].numpoints; l++) {
+              /* check intersection (i.e. dist=0) */
+              if (msIntersectSegments(&(shape1->line[i].point[j - 1]),
+                                      &(shape1->line[i].point[j]),
+                                      &(shape2->line[k].point[l - 1]),
+                                      &(shape2->line[k].point[l])) == MS_TRUE)
+                return (0);
+
+              /* no intersection, compute distance */
+              dist = msDistanceSegmentToSegment(
+                  &(shape1->line[i].point[j - 1]), &(shape1->line[i].point[j]),
+                  &(shape2->line[k].point[l - 1]), &(shape2->line[k].point[l]));
+              if ((dist < minDist) || (minDist < 0))
                 minDist = dist;
             }
           }
-          minDist = sqrt(minDist);
-          break;
-        case(MS_SHAPE_LINE):
-          for(i=0; i<shape1->numlines; i++) {
-            for(j=1; j<shape1->line[i].numpoints; j++) {
-              for(k=0; k<shape2->numlines; k++) {
-                for(l=1; l<shape2->line[k].numpoints; l++) {
-                  /* check intersection (i.e. dist=0) */
-                  if(msIntersectSegments(&(shape1->line[i].point[j-1]), &(shape1->line[i].point[j]), &(shape2->line[k].point[l-1]), &(shape2->line[k].point[l])) == MS_TRUE)
-                    return(0);
-
-                  /* no intersection, compute distance */
-                  dist = msDistanceSegmentToSegment(&(shape1->line[i].point[j-1]), &(shape1->line[i].point[j]), &(shape2->line[k].point[l-1]), &(shape2->line[k].point[l]));
-                  if((dist < minDist) || (minDist < 0))
-                    minDist = dist;
-                }
-              }
-            }
-          }
-          break;
-        case(MS_SHAPE_POLYGON):
-          /* shape2 (the polygon) could contain shape1 or one of it's parts       */
-          for(i=0; i<shape1->numlines; i++) {
-            if(msIntersectPointPolygon(&(shape1->line[0].point[0]), shape2) == MS_TRUE) /* this considers holes and multiple parts */
-              return(0);
-          }
-
-          /* check segment intersection and, if necessary, distance between segments */
-          for(i=0; i<shape1->numlines; i++) {
-            for(j=1; j<shape1->line[i].numpoints; j++) {
-              for(k=0; k<shape2->numlines; k++) {
-                for(l=1; l<shape2->line[k].numpoints; l++) {
-                  /* check intersection (i.e. dist=0) */
-                  if(msIntersectSegments(&(shape1->line[i].point[j-1]), &(shape1->line[i].point[j]), &(shape2->line[k].point[l-1]), &(shape2->line[k].point[l])) == MS_TRUE)
-                    return(0);
-
-                  /* no intersection, compute distance */
-                  dist = msDistanceSegmentToSegment(&(shape1->line[i].point[j-1]), &(shape1->line[i].point[j]), &(shape2->line[k].point[l-1]), &(shape2->line[k].point[l]));
-                  if((dist < minDist) || (minDist < 0))
-                    minDist = dist;
-                }
-              }
-            }
-          }
-          break;
+        }
       }
       break;
-    case(MS_SHAPE_POLYGON): /* shape1 */
-      switch(shape2->type) {
-        case(MS_SHAPE_POINT):
-          for(i=0; i<shape2->numlines; i++) {
-            for(j=0; j<shape2->line[i].numpoints; j++) {
-              dist = msSquareDistancePointToShape(&(shape2->line[i].point[j]), shape1);
-              if((dist < minDist) || (minDist < 0))
+    case (MS_SHAPE_POLYGON):
+      /* shape2 (the polygon) could contain shape1 or one of it's parts       */
+      for (i = 0; i < shape1->numlines; i++) {
+        if (msIntersectPointPolygon(&(shape1->line[0].point[0]), shape2) ==
+            MS_TRUE) /* this considers holes and multiple parts */
+          return (0);
+      }
+
+      /* check segment intersection and, if necessary, distance between segments
+       */
+      for (i = 0; i < shape1->numlines; i++) {
+        for (j = 1; j < shape1->line[i].numpoints; j++) {
+          for (k = 0; k < shape2->numlines; k++) {
+            for (l = 1; l < shape2->line[k].numpoints; l++) {
+              /* check intersection (i.e. dist=0) */
+              if (msIntersectSegments(&(shape1->line[i].point[j - 1]),
+                                      &(shape1->line[i].point[j]),
+                                      &(shape2->line[k].point[l - 1]),
+                                      &(shape2->line[k].point[l])) == MS_TRUE)
+                return (0);
+
+              /* no intersection, compute distance */
+              dist = msDistanceSegmentToSegment(
+                  &(shape1->line[i].point[j - 1]), &(shape1->line[i].point[j]),
+                  &(shape2->line[k].point[l - 1]), &(shape2->line[k].point[l]));
+              if ((dist < minDist) || (minDist < 0))
                 minDist = dist;
             }
           }
-          minDist = sqrt(minDist);
-          break;
-        case(MS_SHAPE_LINE):
-          /* shape1 (the polygon) could contain shape2 or one of it's parts       */
-          for(i=0; i<shape2->numlines; i++) {
-            if(msIntersectPointPolygon(&(shape2->line[i].point[0]), shape1) == MS_TRUE) /* this considers holes and multiple parts */
-              return(0);
-          }
+        }
+      }
+      break;
+    }
+    break;
+  case (MS_SHAPE_POLYGON): /* shape1 */
+    switch (shape2->type) {
+    case (MS_SHAPE_POINT):
+      for (i = 0; i < shape2->numlines; i++) {
+        for (j = 0; j < shape2->line[i].numpoints; j++) {
+          dist =
+              msSquareDistancePointToShape(&(shape2->line[i].point[j]), shape1);
+          if ((dist < minDist) || (minDist < 0))
+            minDist = dist;
+        }
+      }
+      minDist = sqrt(minDist);
+      break;
+    case (MS_SHAPE_LINE):
+      /* shape1 (the polygon) could contain shape2 or one of it's parts       */
+      for (i = 0; i < shape2->numlines; i++) {
+        if (msIntersectPointPolygon(&(shape2->line[i].point[0]), shape1) ==
+            MS_TRUE) /* this considers holes and multiple parts */
+          return (0);
+      }
 
-          /* check segment intersection and, if necessary, distance between segments */
-          for(i=0; i<shape1->numlines; i++) {
-            for(j=1; j<shape1->line[i].numpoints; j++) {
-              for(k=0; k<shape2->numlines; k++) {
-                for(l=1; l<shape2->line[k].numpoints; l++) {
-                  /* check intersection (i.e. dist=0) */
-                  if(msIntersectSegments(&(shape1->line[i].point[j-1]), &(shape1->line[i].point[j]), &(shape2->line[k].point[l-1]), &(shape2->line[k].point[l])) == MS_TRUE)
-                    return(0);
-
-                  /* no intersection, compute distance */
-                  dist = msDistanceSegmentToSegment(&(shape1->line[i].point[j-1]), &(shape1->line[i].point[j]), &(shape2->line[k].point[l-1]), &(shape2->line[k].point[l]));
-                  if((dist < minDist) || (minDist < 0))
-                    minDist = dist;
-                }
-              }
+      /* check segment intersection and, if necessary, distance between segments
+       */
+      for (i = 0; i < shape1->numlines; i++) {
+        for (j = 1; j < shape1->line[i].numpoints; j++) {
+          for (k = 0; k < shape2->numlines; k++) {
+            for (l = 1; l < shape2->line[k].numpoints; l++) {
+              /* check intersection (i.e. dist=0) */
+              if (msIntersectSegments(&(shape1->line[i].point[j - 1]),
+                                      &(shape1->line[i].point[j]),
+                                      &(shape2->line[k].point[l - 1]),
+                                      &(shape2->line[k].point[l])) == MS_TRUE)
+                return (0);
+
+              /* no intersection, compute distance */
+              dist = msDistanceSegmentToSegment(
+                  &(shape1->line[i].point[j - 1]), &(shape1->line[i].point[j]),
+                  &(shape2->line[k].point[l - 1]), &(shape2->line[k].point[l]));
+              if ((dist < minDist) || (minDist < 0))
+                minDist = dist;
             }
           }
-          break;
-        case(MS_SHAPE_POLYGON):
-          /* shape1 completely contains shape2 (only need to check one point from each part) */
-          for(i=0; i<shape2->numlines; i++) {
-            if(msIntersectPointPolygon(&(shape2->line[i].point[0]), shape1) == MS_TRUE) /* this considers holes and multiple parts */
-              return(0);
-          }
+        }
+      }
+      break;
+    case (MS_SHAPE_POLYGON):
+      /* shape1 completely contains shape2 (only need to check one point from
+       * each part) */
+      for (i = 0; i < shape2->numlines; i++) {
+        if (msIntersectPointPolygon(&(shape2->line[i].point[0]), shape1) ==
+            MS_TRUE) /* this considers holes and multiple parts */
+          return (0);
+      }
 
-          /* shape2 completely contains shape1 (only need to check one point from each part) */
-          for(i=0; i<shape1->numlines; i++) {
-            if(msIntersectPointPolygon(&(shape1->line[i].point[0]), shape2) == MS_TRUE) /* this considers holes and multiple parts */
-              return(0);
-          }
+      /* shape2 completely contains shape1 (only need to check one point from
+       * each part) */
+      for (i = 0; i < shape1->numlines; i++) {
+        if (msIntersectPointPolygon(&(shape1->line[i].point[0]), shape2) ==
+            MS_TRUE) /* this considers holes and multiple parts */
+          return (0);
+      }
 
-          /* check segment intersection and, if necessary, distance between segments */
-          for(i=0; i<shape1->numlines; i++) {
-            for(j=1; j<shape1->line[i].numpoints; j++) {
-              for(k=0; k<shape2->numlines; k++) {
-                for(l=1; l<shape2->line[k].numpoints; l++) {
-                  /* check intersection (i.e. dist=0) */
-                  if(msIntersectSegments(&(shape1->line[i].point[j-1]), &(shape1->line[i].point[j]), &(shape2->line[k].point[l-1]), &(shape2->line[k].point[l])) == MS_TRUE)
-                    return(0);
-
-                  /* no intersection, compute distance */
-                  dist = msDistanceSegmentToSegment(&(shape1->line[i].point[j-1]), &(shape1->line[i].point[j]), &(shape2->line[k].point[l-1]), &(shape2->line[k].point[l]));
-                  if((dist < minDist) || (minDist < 0))
-                    minDist = dist;
-                }
-              }
+      /* check segment intersection and, if necessary, distance between segments
+       */
+      for (i = 0; i < shape1->numlines; i++) {
+        for (j = 1; j < shape1->line[i].numpoints; j++) {
+          for (k = 0; k < shape2->numlines; k++) {
+            for (l = 1; l < shape2->line[k].numpoints; l++) {
+              /* check intersection (i.e. dist=0) */
+              if (msIntersectSegments(&(shape1->line[i].point[j - 1]),
+                                      &(shape1->line[i].point[j]),
+                                      &(shape2->line[k].point[l - 1]),
+                                      &(shape2->line[k].point[l])) == MS_TRUE)
+                return (0);
+
+              /* no intersection, compute distance */
+              dist = msDistanceSegmentToSegment(
+                  &(shape1->line[i].point[j - 1]), &(shape1->line[i].point[j]),
+                  &(shape2->line[k].point[l - 1]), &(shape2->line[k].point[l]));
+              if ((dist < minDist) || (minDist < 0))
+                minDist = dist;
             }
           }
-          break;
+        }
       }
       break;
+    }
+    break;
   }
 
-  return(minDist);
+  return (minDist);
 }
diff -pruN 8.0.1-5/mapserv-config.cpp 8.0.2-1/mapserv-config.cpp
--- 8.0.1-5/mapserv-config.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapserv-config.cpp	2024-06-11 20:41:34.000000000 +0000
@@ -6,7 +6,7 @@
  * Author:   Steve Lime and the MapServer team.
  *
  **********************************************************************
- * Copyright (c) 1996-2005 Regents of the University of Minnesota. 
+ * Copyright (c) 1996-2005 Regents of the University of Minnesota.
  *
  * Permission is hereby granted, free of charge, to any person obtaining a
  * copy of this software and associated documentation files (the "Software"),
@@ -40,82 +40,91 @@ extern "C" int msyystate;
 extern "C" int msyylineno;
 extern "C" char *msyystring_buffer;
 
-static int initConfig(configObj *config)
-{
+static int initConfig(configObj *config) {
   if (config == NULL) {
     msSetError(MS_MEMERR, "Config object is NULL.", "initConfig()");
     return MS_FAILURE;
   }
 
-  if(initHashTable(&(config->env)) != MS_SUCCESS) return MS_FAILURE;
-  if(initHashTable(&(config->maps)) != MS_SUCCESS) return MS_FAILURE;
-  if(initHashTable(&(config->plugins)) != MS_SUCCESS) return MS_FAILURE;
+  if (initHashTable(&(config->env)) != MS_SUCCESS)
+    return MS_FAILURE;
+  if (initHashTable(&(config->maps)) != MS_SUCCESS)
+    return MS_FAILURE;
+  if (initHashTable(&(config->plugins)) != MS_SUCCESS)
+    return MS_FAILURE;
 
   return MS_SUCCESS;
 }
 
-void msFreeConfig(configObj *config)
-{
-  if(config == NULL) return;
-  if(&(config->env)) msFreeHashItems(&(config->env));
-  if(&(config->maps)) msFreeHashItems(&(config->maps));
-  if(&(config->plugins)) msFreeHashItems(&(config->plugins));
+void msFreeConfig(configObj *config) {
+  if (config == NULL)
+    return;
+  if (&(config->env))
+    msFreeHashItems(&(config->env));
+  if (&(config->maps))
+    msFreeHashItems(&(config->maps));
+  if (&(config->plugins))
+    msFreeHashItems(&(config->plugins));
 
   msFree(config);
 }
 
-static int loadConfig(configObj *config)
-{
+static int loadConfig(configObj *config) {
   int token;
 
-  if(config == NULL) return MS_FAILURE;
+  if (config == NULL)
+    return MS_FAILURE;
 
   token = msyylex();
-  if(token != MS_CONFIG_SECTION) {
-    msSetError(MS_IDENTERR, "First token must be CONFIG, this doesn't look like a mapserver config file.", "msLoadConfig()");
+  if (token != MS_CONFIG_SECTION) {
+    msSetError(MS_IDENTERR,
+               "First token must be CONFIG, this doesn't look like a mapserver "
+               "config file.",
+               "msLoadConfig()");
     return MS_FAILURE;
   }
 
-  for(;;) {
-    switch(msyylex()) {
-    case(MS_CONFIG_SECTION_ENV): {
-      if(loadHashTable(&(config->env)) != MS_SUCCESS) return MS_FAILURE;
+  for (;;) {
+    switch (msyylex()) {
+    case (MS_CONFIG_SECTION_ENV): {
+      if (loadHashTable(&(config->env)) != MS_SUCCESS)
+        return MS_FAILURE;
       break;
     }
-    case(MS_CONFIG_SECTION_MAPS):
-      if(loadHashTable(&config->maps) != MS_SUCCESS) return MS_FAILURE;
+    case (MS_CONFIG_SECTION_MAPS):
+      if (loadHashTable(&config->maps) != MS_SUCCESS)
+        return MS_FAILURE;
       break;
-    case(MS_CONFIG_SECTION_PLUGINS):
-      if(loadHashTable(&config->plugins) != MS_SUCCESS) return MS_FAILURE;
+    case (MS_CONFIG_SECTION_PLUGINS):
+      if (loadHashTable(&config->plugins) != MS_SUCCESS)
+        return MS_FAILURE;
       break;
-    case(EOF):
+    case (EOF):
       msSetError(MS_EOFERR, NULL, "msLoadConfig()");
       return MS_FAILURE;
-    case(END):
-      if(msyyin) {
-	fclose(msyyin);
-	msyyin = NULL;
+    case (END):
+      if (msyyin) {
+        fclose(msyyin);
+        msyyin = NULL;
       }
       return MS_SUCCESS;
       break;
     default:
-      msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)", "msLoadConfig()", msyystring_buffer, msyylineno);
+      msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)",
+                 "msLoadConfig()", msyystring_buffer, msyylineno);
       return MS_FAILURE;
     }
   }
 }
 
-static void msConfigSetConfigOption(const char* key, const char* value)
-{
+static void msConfigSetConfigOption(const char *key, const char *value) {
   CPLSetConfigOption(key, value);
-  if( strcasecmp(key,"PROJ_DATA") == 0 ||
-      strcasecmp(key,"PROJ_LIB") == 0 ) {
-    msSetPROJ_DATA( value, nullptr );
+  if (strcasecmp(key, "PROJ_DATA") == 0 || strcasecmp(key, "PROJ_LIB") == 0) {
+    msSetPROJ_DATA(value, nullptr);
   }
 }
 
-configObj *msLoadConfig(const char* ms_config_file)
-{
+configObj *msLoadConfig(const char *ms_config_file) {
   configObj *config = NULL;
 
   if (ms_config_file == NULL) {
@@ -123,12 +132,12 @@ configObj *msLoadConfig(const char* ms_c
     ms_config_file = getenv("MAPSERVER_CONFIG_FILE");
   }
 
-  if(ms_config_file == NULL && MAPSERVER_CONFIG_FILE[0] != '\0') {
+  if (ms_config_file == NULL && MAPSERVER_CONFIG_FILE[0] != '\0') {
     // Fallback to hardcoded file name
     ms_config_file = MAPSERVER_CONFIG_FILE;
   }
 
-  if(ms_config_file == NULL) {
+  if (ms_config_file == NULL) {
     msSetError(MS_MISCERR, "No config file set.", "msLoadConfig()");
     return NULL;
   }
@@ -136,16 +145,18 @@ configObj *msLoadConfig(const char* ms_c
   config = (configObj *)calloc(sizeof(configObj), 1);
   MS_CHECK_ALLOC(config, sizeof(configObj), NULL);
 
-  if(initConfig(config) != MS_SUCCESS) {
+  if (initConfig(config) != MS_SUCCESS) {
     msFreeConfig(config);
     return NULL;
   }
 
   msAcquireLock(TLOCK_PARSER);
 
-  if((msyyin = fopen(ms_config_file, "r")) == NULL) {    
+  if ((msyyin = fopen(ms_config_file, "r")) == NULL) {
     msDebug("Cannot open configuration file %s.\n", ms_config_file);
-    msSetError(MS_IOERR, "See mapserver.org/mapfile/config.html for more information.", "msLoadConfig()");
+    msSetError(MS_IOERR,
+               "See mapserver.org/mapfile/config.html for more information.",
+               "msLoadConfig()");
     msReleaseLock(TLOCK_PARSER);
     msFreeConfig(config);
     return NULL;
@@ -157,10 +168,10 @@ configObj *msLoadConfig(const char* ms_c
   msyyrestart(msyyin); // start at line 1
   msyylineno = 1;
 
-  if(loadConfig(config) != MS_SUCCESS) {
+  if (loadConfig(config) != MS_SUCCESS) {
     msFreeConfig(config);
     msReleaseLock(TLOCK_PARSER);
-    if(msyyin) {
+    if (msyyin) {
       fclose(msyyin);
       msyyin = NULL;
     }
@@ -168,35 +179,36 @@ configObj *msLoadConfig(const char* ms_c
   }
   msReleaseLock(TLOCK_PARSER);
 
-  // load all env key/values using CPLSetConfigOption() - only do this *after* we have a good config
+  // load all env key/values using CPLSetConfigOption() - only do this *after*
+  // we have a good config
   const char *key = msFirstKeyFromHashTable(&config->env);
-  if(key != NULL) {
+  if (key != NULL) {
     msConfigSetConfigOption(key, msLookupHashTable(&config->env, key));
 
     const char *last_key = key;
-    while((key = msNextKeyFromHashTable(&config->env, last_key)) != NULL) {
+    while ((key = msNextKeyFromHashTable(&config->env, last_key)) != NULL) {
       msConfigSetConfigOption(key, msLookupHashTable(&config->env, key));
       last_key = key;
     }
   }
 
-  return config;  
+  return config;
 }
 
-const char *msConfigGetEnv(const configObj *config, const char *key) 
-{
-  if(config == NULL || key == NULL) return NULL;
+const char *msConfigGetEnv(const configObj *config, const char *key) {
+  if (config == NULL || key == NULL)
+    return NULL;
   return msLookupHashTable(&config->env, key);
 }
 
-const char *msConfigGetMap(const configObj *config, const char *key)
-{
-  if(config == NULL || key == NULL) return NULL;
+const char *msConfigGetMap(const configObj *config, const char *key) {
+  if (config == NULL || key == NULL)
+    return NULL;
   return msLookupHashTable(&config->maps, key);
 }
 
-const char *msConfigGetPlugin(const configObj *config, const char *key)
-{
-  if(config == NULL || key == NULL) return NULL;
+const char *msConfigGetPlugin(const configObj *config, const char *key) {
+  if (config == NULL || key == NULL)
+    return NULL;
   return msLookupHashTable(&config->plugins, key);
 }
diff -pruN 8.0.1-5/mapserv-config.h 8.0.2-1/mapserv-config.h
--- 8.0.1-5/mapserv-config.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapserv-config.h	2024-06-11 20:41:34.000000000 +0000
@@ -7,25 +7,33 @@
 extern "C" {
 #endif
 
-enum MS_CONFIG_SECTIONS { MS_CONFIG_SECTION=3000, MS_CONFIG_SECTION_ENV, MS_CONFIG_SECTION_MAPS, MS_CONFIG_SECTION_PLUGINS };
+enum MS_CONFIG_SECTIONS {
+  MS_CONFIG_SECTION = 3000,
+  MS_CONFIG_SECTION_ENV,
+  MS_CONFIG_SECTION_MAPS,
+  MS_CONFIG_SECTION_PLUGINS
+};
 
 /**
 The :ref:`CONFIG <config>` object
 */
 typedef struct {
-  hashTableObj env; ///< Key-value pairs of environment variables and values
-  hashTableObj maps; ///< Key-value pairs of Mapfile names and paths
+  hashTableObj env;     ///< Key-value pairs of environment variables and values
+  hashTableObj maps;    ///< Key-value pairs of Mapfile names and paths
   hashTableObj plugins; ///< Key-value pairs of plugin names and paths
 } configObj;
 
-MS_DLL_EXPORT configObj *msLoadConfig(const char* ms_config_file);
+MS_DLL_EXPORT configObj *msLoadConfig(const char *ms_config_file);
 MS_DLL_EXPORT void msFreeConfig(configObj *config);
-MS_DLL_EXPORT const char *msConfigGetEnv(const configObj *config, const char *key);
-MS_DLL_EXPORT const char *msConfigGetMap(const configObj *config, const char *key);
-MS_DLL_EXPORT const char *msConfigGetPlugin(const configObj *config, const char *key);
+MS_DLL_EXPORT const char *msConfigGetEnv(const configObj *config,
+                                         const char *key);
+MS_DLL_EXPORT const char *msConfigGetMap(const configObj *config,
+                                         const char *key);
+MS_DLL_EXPORT const char *msConfigGetPlugin(const configObj *config,
+                                            const char *key);
 
 #ifdef __cplusplus
 } /* extern C */
 #endif
 
-#endif 
+#endif
diff -pruN 8.0.1-5/mapserv.c 8.0.2-1/mapserv.c
--- 8.0.1-5/mapserv.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapserv.c	2024-06-11 20:41:34.000000000 +0000
@@ -50,7 +50,6 @@
 #include <signal.h>
 #endif
 
-
 /************************************************************************/
 /*                      FastCGI cleanup functions.                      */
 /************************************************************************/
@@ -58,18 +57,14 @@
 static int finish_process = 0;
 
 #ifndef _WIN32
-static void msCleanupOnSignal( int nInData )
-{
+static void msCleanupOnSignal(int nInData) {
   (void)nInData;
   finish_process = 1;
 }
 #endif
 
 #ifdef _WIN32
-static void msCleanupOnExit( void )
-{
-  finish_process = 1;
-}
+static void msCleanupOnExit(void) { finish_process = 1; }
 #endif
 
 #ifdef USE_FASTCGI
@@ -80,10 +75,10 @@ static void msCleanupOnExit( void )
 /*      This is the default implementation via stdio.                   */
 /************************************************************************/
 
-static int msIO_fcgiRead( void *cbData, void *data, int byteCount )
+static int msIO_fcgiRead(void *cbData, void *data, int byteCount)
 
 {
-  return (int) FCGI_fread( data, 1, byteCount, (FCGI_FILE *) cbData );
+  return (int)FCGI_fread(data, 1, byteCount, (FCGI_FILE *)cbData);
 }
 
 /************************************************************************/
@@ -92,10 +87,10 @@ static int msIO_fcgiRead( void *cbData,
 /*      This is the default implementation via stdio.                   */
 /************************************************************************/
 
-static int msIO_fcgiWrite( void *cbData, void *data, int byteCount )
+static int msIO_fcgiWrite(void *cbData, void *data, int byteCount)
 
 {
-  return (int) FCGI_fwrite( data, 1, byteCount, (FCGI_FILE *) cbData );
+  return (int)FCGI_fwrite(data, 1, byteCount, (FCGI_FILE *)cbData);
 }
 
 /************************************************************************/
@@ -109,19 +104,19 @@ static int msIO_installFastCGIRedirect()
   stdin_ctx.label = "fcgi";
   stdin_ctx.write_channel = MS_FALSE;
   stdin_ctx.readWriteFunc = msIO_fcgiRead;
-  stdin_ctx.cbData = (void *) FCGI_stdin;
+  stdin_ctx.cbData = (void *)FCGI_stdin;
 
   stdout_ctx.label = "fcgi";
   stdout_ctx.write_channel = MS_TRUE;
   stdout_ctx.readWriteFunc = msIO_fcgiWrite;
-  stdout_ctx.cbData = (void *) FCGI_stdout;
+  stdout_ctx.cbData = (void *)FCGI_stdout;
 
   stderr_ctx.label = "fcgi";
   stderr_ctx.write_channel = MS_TRUE;
   stderr_ctx.readWriteFunc = msIO_fcgiWrite;
-  stderr_ctx.cbData = (void *) FCGI_stderr;
+  stderr_ctx.cbData = (void *)FCGI_stderr;
 
-  msIO_installHandlers( &stdin_ctx, &stdout_ctx, &stderr_ctx );
+  msIO_installHandlers(&stdin_ctx, &stdout_ctx, &stderr_ctx);
 
   return MS_TRUE;
 }
@@ -130,59 +125,65 @@ static int msIO_installFastCGIRedirect()
 /************************************************************************/
 /*                                main()                                */
 /************************************************************************/
-int main(int argc, char *argv[])
-{
+int main(int argc, char *argv[]) {
   int sendheaders = MS_TRUE;
   struct mstimeval execstarttime, execendtime;
   struct mstimeval requeststarttime, requestendtime;
-  mapservObj  *mapserv = NULL;
+  mapservObj *mapserv = NULL;
   configObj *config = NULL;
 
-  /* 
-  ** Process -v and -h command line arguments  first end exit. We want to avoid any error messages 
+  /*
+  ** Process -v and -h command line arguments  first end exit. We want to avoid
+  *any error messages
   ** associated with msLoadConfig() or msSetup().
   */
-  const char* config_filename = NULL;
+  const char *config_filename = NULL;
   const bool use_command_line_options = getenv("QUERY_STRING") == NULL;
   if (use_command_line_options) {
     /* WARNING:
      * Do not parse command line arguments (especially those that could have
-     * dangerous consequences if controlled through a web request), without checking
-     * that the QUERY_STRING environment variable is *not* set, because in a
-     * CGI context, command line arguments can be generated from the content
-     * of the QUERY_STRING, and thus cause a security problem.
-     * For ex, "http://example.com/mapserv.cgi?-conf+bar
-     * would result in "mapserv.cgi -conf bar" being invoked.
-     * See https://github.com/MapServer/MapServer/pull/6429#issuecomment-952533589
+     * dangerous consequences if controlled through a web request), without
+     * checking that the QUERY_STRING environment variable is *not* set, because
+     * in a CGI context, command line arguments can be generated from the
+     * content of the QUERY_STRING, and thus cause a security problem. For ex,
+     * "http://example.com/mapserv.cgi?-conf+bar would result in "mapserv.cgi
+     * -conf bar" being invoked. See
+     * https://github.com/MapServer/MapServer/pull/6429#issuecomment-952533589
      * and https://datatracker.ietf.org/doc/html/rfc3875#section-4.4
-    */
-    for( int iArg = 1; iArg < argc; iArg++ ) {
-      if( strcmp(argv[iArg],"-v") == 0 ) {
+     */
+    for (int iArg = 1; iArg < argc; iArg++) {
+      if (strcmp(argv[iArg], "-v") == 0) {
         printf("%s\n", msGetVersion());
         fflush(stdout);
         exit(0);
-      } else if (strcmp(argv[iArg], "-h") == 0 || strcmp(argv[iArg], "--help") == 0) {
-        printf("Usage: mapserv [--help] [-v] [-nh] [QUERY_STRING=value] [PATH_INFO=value]\n");
+      } else if (strcmp(argv[iArg], "-h") == 0 ||
+                 strcmp(argv[iArg], "--help") == 0) {
+        printf("Usage: mapserv [--help] [-v] [-nh] [QUERY_STRING=value] "
+               "[PATH_INFO=value]\n");
         printf("                [-conf filename]\n");
         printf("\n");
         printf("Options :\n");
         printf("  -h, --help              Display this help message.\n");
         printf("  -v                      Display version and exit.\n");
-        printf("  -nh                     Suppress HTTP headers in CGI mode.\n");
-        printf("  -conf filename          Filename of the MapServer configuration file.\n");
-        printf("  QUERY_STRING=value      Set the QUERY_STRING in GET request mode.\n");
-        printf("  PATH_INFO=value         Set the PATH_INFO for an API request.\n");
+        printf(
+            "  -nh                     Suppress HTTP headers in CGI mode.\n");
+        printf("  -conf filename          Filename of the MapServer "
+               "configuration file.\n");
+        printf("  QUERY_STRING=value      Set the QUERY_STRING in GET request "
+               "mode.\n");
+        printf("  PATH_INFO=value         Set the PATH_INFO for an API "
+               "request.\n");
         fflush(stdout);
         exit(0);
-      } else if( iArg < argc-1 && strcmp(argv[iArg], "-conf") == 0) {
-        config_filename = argv[iArg+1];
+      } else if (iArg < argc - 1 && strcmp(argv[iArg], "-conf") == 0) {
+        config_filename = argv[iArg + 1];
         ++iArg;
       }
     }
   }
 
   config = msLoadConfig(config_filename); // first thing
-  if(config == NULL) {
+  if (config == NULL) {
 #ifdef USE_FASTCGI
     msIO_installFastCGIRedirect(); // FastCGI setup for error handling here
     FCGI_Accept();
@@ -195,7 +196,7 @@ int main(int argc, char *argv[])
   /*      Initialize mapserver.  This sets up threads, GD and GEOS as     */
   /*      well as using MS_ERRORFILE and MS_DEBUGLEVEL env vars if set.   */
   /* -------------------------------------------------------------------- */
-  if( msSetup() != MS_SUCCESS ) {
+  if (msSetup() != MS_SUCCESS) {
 #ifdef USE_FASTCGI
     msIO_installFastCGIRedirect(); // FastCGI setup for error handling here
     FCGI_Accept();
@@ -206,7 +207,7 @@ int main(int argc, char *argv[])
     exit(0);
   }
 
-  if(msGetGlobalDebugLevel() >= MS_DEBUGLEVEL_TUNING)
+  if (msGetGlobalDebugLevel() >= MS_DEBUGLEVEL_TUNING)
     msGettimeofday(&execstarttime, NULL);
 
   /* -------------------------------------------------------------------- */
@@ -214,21 +215,22 @@ int main(int argc, char *argv[])
   /*      commandline switches, but we provide a few for test/debug       */
   /*      purposes.                                                       */
   /* -------------------------------------------------------------------- */
-  if(use_command_line_options) {
-    for( int iArg = 1; iArg < argc; iArg++ ) {
-      if(strcmp(argv[iArg], "-nh") == 0) {
+  if (use_command_line_options) {
+    for (int iArg = 1; iArg < argc; iArg++) {
+      if (strcmp(argv[iArg], "-nh") == 0) {
         sendheaders = MS_FALSE;
-        msIO_setHeaderEnabled( MS_FALSE );
-      } else if( strncmp(argv[iArg], "QUERY_STRING=", 13) == 0 ) {
+        msIO_setHeaderEnabled(MS_FALSE);
+      } else if (strncmp(argv[iArg], "QUERY_STRING=", 13) == 0) {
         /* Debugging hook... pass "QUERY_STRING=..." on the command-line */
-        putenv( "REQUEST_METHOD=GET" );
+        putenv("REQUEST_METHOD=GET");
         /* coverity[tainted_string] */
-        putenv( argv[iArg] );
-      } else if( strncmp(argv[iArg], "PATH_INFO=", 10) == 0 ) {
-        /* Debugging hook for APIs... pass "PATH_INFO=..." on the command-line */
-        putenv( "REQUEST_METHOD=GET" );
+        putenv(argv[iArg]);
+      } else if (strncmp(argv[iArg], "PATH_INFO=", 10) == 0) {
+        /* Debugging hook for APIs... pass "PATH_INFO=..." on the command-line
+         */
+        putenv("REQUEST_METHOD=GET");
         /* coverity[tainted_string] */
-        putenv( argv[iArg] );
+        putenv(argv[iArg]);
       }
     }
   }
@@ -237,8 +239,8 @@ int main(int argc, char *argv[])
   /*      Setup cleanup magic, mainly for FastCGI case.                   */
   /* -------------------------------------------------------------------- */
 #ifndef _WIN32
-  signal( SIGUSR1, msCleanupOnSignal );
-  signal( SIGTERM, msCleanupOnSignal );
+  signal(SIGUSR1, msCleanupOnSignal);
+  signal(SIGTERM, msCleanupOnSignal);
 #endif
 
 #ifdef USE_FASTCGI
@@ -246,55 +248,58 @@ int main(int argc, char *argv[])
 
   /* In FastCGI case we loop accepting multiple requests.  In normal CGI */
   /* use we only accept and process one request.  */
-  while( !finish_process && FCGI_Accept() >= 0 ) {
+  while (!finish_process && FCGI_Accept() >= 0) {
 #endif /* def USE_FASTCGI */
 
     /* -------------------------------------------------------------------- */
     /*      Process a request.                                              */
     /* -------------------------------------------------------------------- */
     mapserv = msAllocMapServObj();
-    mapserv->sendheaders = sendheaders; /* override the default if necessary (via command line -nh switch) */
+    mapserv->sendheaders = sendheaders; /* override the default if necessary
+                                           (via command line -nh switch) */
 
-    mapserv->request->NumParams = loadParams(mapserv->request, NULL, NULL, 0, NULL);
-    if(msCGIIsAPIRequest(mapserv) == MS_FALSE && mapserv->request->NumParams == -1) { /* no QUERY_STRING or PATH_INFO */
+    mapserv->request->NumParams =
+        loadParams(mapserv->request, NULL, NULL, 0, NULL);
+    if (msCGIIsAPIRequest(mapserv) == MS_FALSE &&
+        mapserv->request->NumParams == -1) { /* no QUERY_STRING or PATH_INFO */
       msCGIWriteError(mapserv);
       goto end_request;
     }
 
     mapserv->map = msCGILoadMap(mapserv, config);
-    if(!mapserv->map) {
+    if (!mapserv->map) {
       msCGIWriteError(mapserv);
       goto end_request;
     }
 
-    if( mapserv->map->debug >= MS_DEBUGLEVEL_TUNING)
+    if (mapserv->map->debug >= MS_DEBUGLEVEL_TUNING)
       msGettimeofday(&requeststarttime, NULL);
 
 #ifdef USE_FASTCGI
-    if( mapserv->map->debug ) {
+    if (mapserv->map->debug) {
       static int nRequestCounter = 1;
 
-      msDebug( "CGI Request %d on process %d\n", nRequestCounter, getpid() );
+      msDebug("CGI Request %d on process %d\n", nRequestCounter, getpid());
       nRequestCounter++;
     }
 #endif
 
-    if(mapserv->request->api_path != NULL) {
-      if(msCGIDispatchAPIRequest(mapserv) != MS_SUCCESS) {
-	msCGIWriteError(mapserv);
-	goto end_request;
+    if (mapserv->request->api_path != NULL) {
+      if (msCGIDispatchAPIRequest(mapserv) != MS_SUCCESS) {
+        msCGIWriteError(mapserv);
+        goto end_request;
       }
-    } else if(msCGIDispatchRequest(mapserv) != MS_SUCCESS) {
+    } else if (msCGIDispatchRequest(mapserv) != MS_SUCCESS) {
       msCGIWriteError(mapserv);
       goto end_request;
     }
 
-end_request:
-    if(mapserv->map && mapserv->map->debug >= MS_DEBUGLEVEL_TUNING) {
+  end_request:
+    if (mapserv->map && mapserv->map->debug >= MS_DEBUGLEVEL_TUNING) {
       msGettimeofday(&requestendtime, NULL);
       msDebug("mapserv request processing time (msLoadMap not incl.): %.3fs\n",
-              (requestendtime.tv_sec+requestendtime.tv_usec/1.0e6)-
-              (requeststarttime.tv_sec+requeststarttime.tv_usec/1.0e6) );
+              (requestendtime.tv_sec + requestendtime.tv_usec / 1.0e6) -
+                  (requeststarttime.tv_sec + requeststarttime.tv_usec / 1.0e6));
     }
     msFreeMapServObj(mapserv);
 #ifdef USE_FASTCGI
@@ -305,11 +310,11 @@ end_request:
 #endif
 
   /* normal case, processing is complete */
-  if(msGetGlobalDebugLevel() >= MS_DEBUGLEVEL_TUNING) {
+  if (msGetGlobalDebugLevel() >= MS_DEBUGLEVEL_TUNING) {
     msGettimeofday(&execendtime, NULL);
     msDebug("mapserv total execution time: %.3fs\n",
-            (execendtime.tv_sec+execendtime.tv_usec/1.0e6)-
-            (execstarttime.tv_sec+execstarttime.tv_usec/1.0e6) );
+            (execendtime.tv_sec + execendtime.tv_usec / 1.0e6) -
+                (execstarttime.tv_sec + execstarttime.tv_usec / 1.0e6));
   }
   msCleanup();
   msFreeConfig(config);
@@ -319,5 +324,5 @@ end_request:
   fflush(stdout);
 #endif
 
-  exit( 0 );
+  exit(0);
 }
diff -pruN 8.0.1-5/mapserv.h 8.0.2-1/mapserv.h
--- 8.0.1-5/mapserv.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapserv.h	2024-06-11 20:41:34.000000000 +0000
@@ -51,7 +51,11 @@
 /*
 ** Macros
 */
-#define TEMPLATE_TYPE(s)  (((strncmp("http://", s, 7) == 0) || (strncmp("https://", s, 8) == 0) || (strncmp("ftp://", s, 6)) == 0)  ? MS_URL : MS_FILE)
+#define TEMPLATE_TYPE(s)                                                       \
+  (((strncmp("http://", s, 7) == 0) || (strncmp("https://", s, 8) == 0) ||     \
+    (strncmp("ftp://", s, 6)) == 0)                                            \
+       ? MS_URL                                                                \
+       : MS_FILE)
 
 MS_DLL_EXPORT void msCGIWriteError(mapservObj *mapserv);
 MS_DLL_EXPORT mapObj *msCGILoadMap(mapservObj *mapserv, configObj *context);
diff -pruN 8.0.1-5/mapserver-api.c 8.0.2-1/mapserver-api.c
--- 8.0.1-5/mapserver-api.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapserver-api.c	2024-06-11 20:41:34.000000000 +0000
@@ -1,20 +1,19 @@
 #include "mapserver.h"
 
-
-mapObj* umnms_new_map(char *filename) {
+mapObj *umnms_new_map(char *filename) {
   mapObj *map = NULL;
-  if(filename) {  
-    map = msLoadMap(filename,NULL);
+  if (filename) {
+    map = msLoadMap(filename, NULL);
   } else {
-    map = (mapObj *)msSmallCalloc(sizeof(mapObj),1);
-    if(initMap(map) == -1) {
+    map = (mapObj *)msSmallCalloc(sizeof(mapObj), 1);
+    if (initMap(map) == -1) {
       free(map);
       return NULL;
     }
   }
   return map;
 }
-layerObj* umnms_new_layer(mapObj *map);
-classObj* umnms_new_class(layerObj *layer);
-styleObj* umnms_new_style(classObj *theclass);
-labelObj* umnms_new_label(classObj *theclass);
+layerObj *umnms_new_layer(mapObj *map);
+classObj *umnms_new_class(layerObj *layer);
+styleObj *umnms_new_style(classObj *theclass);
+labelObj *umnms_new_label(classObj *theclass);
diff -pruN 8.0.1-5/mapserver-api.h 8.0.2-1/mapserver-api.h
--- 8.0.1-5/mapserver-api.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapserver-api.h	2024-06-11 20:41:34.000000000 +0000
@@ -1,4 +1,4 @@
-/* 
+/*
  * File:   mapserver-api.h
  * Author: tbonfort
  *
@@ -6,11 +6,11 @@
  */
 
 #ifndef MAPSERVER_API_H
-#define	MAPSERVER_API_H
+#define MAPSERVER_API_H
 
 #include "mapserver-version.h"
 
-#ifdef	__cplusplus
+#ifdef __cplusplus
 extern "C" {
 #endif
 
@@ -22,18 +22,14 @@ typedef struct labelObj labelObj;
 typedef struct symbolObj symbolObj;
 typedef struct imageObj imageObj;
 
-mapObj* umnms_new_map(char *filename);
-layerObj* umnms_new_layer(mapObj *map);
-classObj* umnms_new_class(layerObj *layer);
-styleObj* umnms_new_style(classObj *theclass);
-labelObj* umnms_new_label(classObj *theclass);
+mapObj *umnms_new_map(char *filename);
+layerObj *umnms_new_layer(mapObj *map);
+classObj *umnms_new_class(layerObj *layer);
+styleObj *umnms_new_style(classObj *theclass);
+labelObj *umnms_new_label(classObj *theclass);
 
-
-
-
-#ifdef	__cplusplus
+#ifdef __cplusplus
 }
 #endif
 
-#endif	/* MAPSERVER_API_H */
-
+#endif /* MAPSERVER_API_H */
diff -pruN 8.0.1-5/mapserver.h 8.0.2-1/mapserver.h
--- 8.0.1-5/mapserver.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapserver.h	2024-06-11 20:41:34.000000000 +0000
@@ -56,16 +56,16 @@
 #endif
 
 #if defined(_WIN32) && !defined(__CYGWIN__)
-#  define MS_DLL_EXPORT     __declspec(dllexport)
+#define MS_DLL_EXPORT __declspec(dllexport)
 #define USE_MSFREE
 #else
-#define  MS_DLL_EXPORT
+#define MS_DLL_EXPORT
 #endif
 
 #if defined(__GNUC__)
 #define WARN_UNUSED __attribute__((warn_unused_result))
-#define MS_LIKELY(x)   __builtin_expect((x),1)
-#define MS_UNLIKELY(x) __builtin_expect((x),0)
+#define MS_LIKELY(x) __builtin_expect((x), 1)
+#define MS_UNLIKELY(x) __builtin_expect((x), 0)
 #else
 #define WARN_UNUSED
 #define MS_LIKELY(x) (x)
@@ -89,14 +89,14 @@
 #endif
 
 #if ULONG_MAX == 0xffffffff
-typedef long            ms_int32;
-typedef unsigned long   ms_uint32;
+typedef long ms_int32;
+typedef unsigned long ms_uint32;
 #elif UINT_MAX == 0xffffffff
-typedef int             ms_int32;
-typedef unsigned int    ms_uint32;
+typedef int ms_int32;
+typedef unsigned int ms_uint32;
 #else
-typedef int32_t         ms_int32;
-typedef uint32_t        ms_uint32;
+typedef int32_t ms_int32;
+typedef uint32_t ms_uint32;
 #endif
 
 #if defined(_WIN32) && !defined(__CYGWIN__)
@@ -116,7 +116,6 @@ typedef struct glyph_element glyph_eleme
 typedef struct face_element face_element;
 #endif
 
-
 /* ms_bitarray is used by the bit mask in mapbit.c */
 typedef ms_uint32 *ms_bitarray;
 typedef const ms_uint32 *ms_const_bitarray;
@@ -141,30 +140,28 @@ typedef const ms_uint32 *ms_const_bitarr
  */
 #include "mapregex.h"
 
-
 #define CPL_SUPRESS_CPLUSPLUS
 #include "ogr_api.h"
 
-
-/* EQUAL and EQUALN are defined in cpl_port.h, so add them in here if ogr was not included */
+/* EQUAL and EQUALN are defined in cpl_port.h, so add them in here if ogr was
+ * not included */
 
 #ifndef EQUAL
 #if defined(_WIN32) || defined(WIN32CE)
-#  define EQUAL(a,b)              (stricmp(a,b)==0)
+#define EQUAL(a, b) (stricmp(a, b) == 0)
 #else
-#  define EQUAL(a,b)              (strcasecmp(a,b)==0)
+#define EQUAL(a, b) (strcasecmp(a, b) == 0)
 #endif
 #endif
 
 #ifndef EQUALN
 #if defined(_WIN32) || defined(WIN32CE)
-#  define EQUALN(a,b,n)           (strnicmp(a,b,n)==0)
+#define EQUALN(a, b, n) (strnicmp(a, b, n) == 0)
 #else
-#  define EQUALN(a,b,n)           (strncasecmp(a,b,n)==0)
+#define EQUALN(a, b, n) (strncasecmp(a, b, n) == 0)
 #endif
 #endif
 
-
 #if defined(_WIN32) && !defined(__CYGWIN__)
 #if (defined(_MSC_VER) && (_MSC_VER < 1900)) || !defined(_MSC_VER)
 #define snprintf _snprintf
@@ -179,27 +176,27 @@ extern "C" {
 
 // hide from swig or ruby will choke on the __FUNCTION__ name
 #ifndef SWIG
-  /* Memory allocation check utility */
+/* Memory allocation check utility */
 #ifndef __FUNCTION__
-#   define __FUNCTION__ "MapServer"
+#define __FUNCTION__ "MapServer"
 #endif
 #endif
 
-#define MS_CHECK_ALLOC(var, size, retval)     \
-    if (!var) {   \
-        msSetError(MS_MEMERR, "%s: %d: Out of memory allocating %u bytes.\n", __FUNCTION__, \
-                   __FILE__, __LINE__, (unsigned int)(size));  \
-        return retval;                         \
-    }
+#define MS_CHECK_ALLOC(var, size, retval)                                      \
+  if (!var) {                                                                  \
+    msSetError(MS_MEMERR, "%s: %d: Out of memory allocating %u bytes.\n",      \
+               __FUNCTION__, __FILE__, __LINE__, (unsigned int)(size));        \
+    return retval;                                                             \
+  }
 
-#define MS_CHECK_ALLOC_NO_RET(var, size)                                   \
-    if (!var) {                                                       \
-        msSetError(MS_MEMERR, "%s: %d: Out of memory allocating %u bytes.\n", __FUNCTION__, \
-                   __FILE__, __LINE__, (unsigned int)(size));                           \
-        return;                                                         \
-    }
+#define MS_CHECK_ALLOC_NO_RET(var, size)                                       \
+  if (!var) {                                                                  \
+    msSetError(MS_MEMERR, "%s: %d: Out of memory allocating %u bytes.\n",      \
+               __FUNCTION__, __FILE__, __LINE__, (unsigned int)(size));        \
+    return;                                                                    \
+  }
 
-  /* General defines, wrapable */
+/* General defines, wrapable */
 
 #define MS_TRUE 1 /* logical control variables */
 #define MS_FALSE 0
@@ -212,21 +209,20 @@ extern "C" {
 #define MS_YES 1
 #define MS_NO 0
 
-
-  /* Number of layer, class and style ptrs to alloc at once in the
-     corresponding msGrow...() functions. Replaces former MS_MAXLAYERS,
-     MS_MAXCLASSES and MS_MAXSTYLES with dynamic allocation (see RFC-17). */
+/* Number of layer, class and style ptrs to alloc at once in the
+   corresponding msGrow...() functions. Replaces former MS_MAXLAYERS,
+   MS_MAXCLASSES and MS_MAXSTYLES with dynamic allocation (see RFC-17). */
 #define MS_LAYER_ALLOCSIZE 64
 #define MS_CLASS_ALLOCSIZE 8
 #define MS_STYLE_ALLOCSIZE 4
 #define MS_LABEL_ALLOCSIZE 2 /* not too common */
 
-#define MS_MAX_LABEL_PRIORITY     10
-#define MS_MAX_LABEL_FONTS     5
+#define MS_MAX_LABEL_PRIORITY 10
+#define MS_MAX_LABEL_FONTS 5
 #define MS_DEFAULT_LABEL_PRIORITY 1
 #define MS_LABEL_FORCE_GROUP 2 /* other values are MS_ON/MS_OFF */
 
-  /* General defines, not wrapable */
+/* General defines, not wrapable */
 #ifndef SWIG
 #ifdef USE_XMLMAPFILE
 #define MS_DEFAULT_MAPFILE_PATTERN "\\.(map|xml)$"
@@ -245,7 +241,7 @@ extern "C" {
 #define MS_QUERY_EXTENSION ".qy"
 
 #define MS_DEG_TO_RAD .0174532925199432958
-#define MS_RAD_TO_DEG   57.29577951
+#define MS_RAD_TO_DEG 57.29577951
 
 #define MS_DEFAULT_RESOLUTION 72
 
@@ -270,10 +266,10 @@ extern "C" {
 #define MS_ITEMNAMELEN 32
 #define MS_NAMELEN 20
 
-#define MS_MINSYMBOLSIZE 0   /* in pixels */
+#define MS_MINSYMBOLSIZE 0 /* in pixels */
 #define MS_MAXSYMBOLSIZE 500
 
-#define MS_MINSYMBOLWIDTH 0   /* in pixels */
+#define MS_MINSYMBOLWIDTH 0 /* in pixels */
 #define MS_MAXSYMBOLWIDTH 32
 
 #define MS_URL 0 /* template types */
@@ -288,7 +284,9 @@ extern "C" {
 #define MS_RESULTCACHEINITSIZE 10
 #define MS_RESULTCACHEINCREMENT 10
 
-#define MS_FEATUREINITSIZE 10 /* how many points initially can a feature have */
+#define MS_FEATUREINITSIZE                                                     \
+  10 /* how many points initially can a feature have                           \
+      */
 #define MS_FEATUREINCREMENT 10
 
 #define MS_EXPRESSION 2000 /* todo: make this an enum */
@@ -301,26 +299,27 @@ extern "C" {
 #define MS_BINDING 2007
 #define MS_LIST 2008
 
-  /* string split flags */
-#define MS_HONOURSTRINGS      0x0001
-#define MS_ALLOWEMPTYTOKENS   0x0002
-#define MS_PRESERVEQUOTES     0x0004
-#define MS_PRESERVEESCAPES    0x0008
-#define MS_STRIPLEADSPACES    0x0010
-#define MS_STRIPENDSPACES     0x0020
+/* string split flags */
+#define MS_HONOURSTRINGS 0x0001
+#define MS_ALLOWEMPTYTOKENS 0x0002
+#define MS_PRESERVEQUOTES 0x0004
+#define MS_PRESERVEESCAPES 0x0008
+#define MS_STRIPLEADSPACES 0x0010
+#define MS_STRIPENDSPACES 0x0020
 
-  /* boolean options for the expression object. */
+/* boolean options for the expression object. */
 #define MS_EXP_INSENSITIVE 1
 
-  /* General macro definitions */
-#define MS_MIN(a,b) (((a)<(b))?(a):(b))
-#define MS_MAX(a,b) (((a)>(b))?(a):(b))
-#define MS_ABS(a) (((a)<0) ? -(a) : (a))
-#define MS_SGN(a) (((a)<0) ? -1 : 1)
+/* General macro definitions */
+#define MS_MIN(a, b) (((a) < (b)) ? (a) : (b))
+#define MS_MAX(a, b) (((a) > (b)) ? (a) : (b))
+#define MS_ABS(a) (((a) < 0) ? -(a) : (a))
+#define MS_SGN(a) (((a) < 0) ? -1 : 1)
 
-#define MS_STRING_IS_NULL_OR_EMPTY(s) ((!s || s[0] == '\0') ? MS_TRUE:MS_FALSE)
+#define MS_STRING_IS_NULL_OR_EMPTY(s)                                          \
+  ((!s || s[0] == '\0') ? MS_TRUE : MS_FALSE)
 
-#define MS_NINT_GENERIC(x) ((x) >= 0.0 ? ((long) ((x)+.5)) : ((long) ((x)-.5)))
+#define MS_NINT_GENERIC(x) ((x) >= 0.0 ? ((long)((x) + .5)) : ((long)((x)-.5)))
 
 #ifdef _MSC_VER
 #define msIsNan(x) _isnan(x)
@@ -328,74 +327,104 @@ extern "C" {
 #define msIsNan(x) isnan(x)
 #endif
 
-  /* see http://mega-nerd.com/FPcast/ for some discussion of fast
-     conversion to nearest int.  We avoid lrint() for now because it
-     would be hard to include math.h "properly". */
+/* see http://mega-nerd.com/FPcast/ for some discussion of fast
+   conversion to nearest int.  We avoid lrint() for now because it
+   would be hard to include math.h "properly". */
 
 #if defined(HAVE_LRINT) && !defined(USE_GENERIC_MS_NINT)
-#   define MS_NINT(x) lrint(x)
-  /*#   define MS_NINT(x) lround(x) */
-/* note that lrint rounds .5 to the nearest *even* integer, i.e. lrint(0.5)=0,lrint(1.5)=2 */
+#define MS_NINT(x) lrint(x)
+/*#   define MS_NINT(x) lround(x) */
+/* note that lrint rounds .5 to the nearest *even* integer, i.e.
+ * lrint(0.5)=0,lrint(1.5)=2 */
 #elif defined(_MSC_VER) && defined(_WIN32) && !defined(USE_GENERIC_MS_NINT)
-  static __inline long int MS_NINT (double flt)
-  {
-    int intgr;
+static __inline long int MS_NINT(double flt) {
+  int intgr;
 
-    _asm {
+  _asm {
       fld flt
       fistp intgr
-    } ;
-
-    return intgr ;
   }
+  ;
+
+  return intgr;
+}
 #elif defined(i386) && defined(__GNUC_PREREQ) && !defined(USE_GENERIC_MS_NINT)
-  static __inline long int MS_NINT( double __x )
-  {
-    long int __lrintres;
-    __asm__ __volatile__
-    ("fistpl %0"
-     : "=m" (__lrintres) : "t" (__x) : "st");
-    return __lrintres;
-  }
+static __inline long int MS_NINT(double __x) {
+  long int __lrintres;
+  __asm__ __volatile__("fistpl %0" : "=m"(__lrintres) : "t"(__x) : "st");
+  return __lrintres;
+}
 #else
-#  define MS_NINT(x)      MS_NINT_GENERIC(x)
+#define MS_NINT(x) MS_NINT_GENERIC(x)
 #endif
 
-  /* #define MS_VALID_EXTENT(minx, miny, maxx, maxy)  (((minx<maxx) && (miny<maxy))?MS_TRUE:MS_FALSE) */
-#define MS_VALID_EXTENT(rect)  ((((rect).minx < (rect).maxx && (rect).miny < (rect).maxy))?MS_TRUE:MS_FALSE)
-#define MS_VALID_SEARCH_EXTENT(rect)  ((((rect).minx <= (rect).maxx && (rect).miny <= (rect).maxy))?MS_TRUE:MS_FALSE)
-
-#define MS_INIT_COLOR(color,r,g,b,a) { (color).red = r; (color).green = g; (color).blue = b; (color).alpha=a; }
-#define MS_VALID_COLOR(color) (((color).red==-1 || (color).green==-1 || (color).blue==-1)?MS_FALSE:MS_TRUE)
-#define MS_COMPARE_COLOR(color1, color2) (((color2).red==(color1).red && (color2).green==(color1).green && (color2).blue==(color1).blue)?MS_TRUE:MS_FALSE)
-#define MS_TRANSPARENT_COLOR(color) (((color).alpha==0 || (color).red==-255 || (color).green==-255 || (color).blue==-255)?MS_TRUE:MS_FALSE)
-#define MS_COMPARE_COLORS(a,b) (((a).red!=(b).red || (a).green!=(b).green || (a).blue!=(b).blue)?MS_FALSE:MS_TRUE)
-#define MS_COLOR_GETRGB(color) (MS_VALID_COLOR(color)?((color).red *0x10000 + (color).green *0x100 + (color).blue):-1)
-
-#define MS_IMAGE_MIME_TYPE(format) (format->mimetype ? format->mimetype : "unknown")
-#define MS_IMAGE_EXTENSION(format)  (format->extension ? format->extension : "unknown")
-#define MS_DRIVER_SWF(format) (strncasecmp((format)->driver,"swf",3)==0)
-#define MS_DRIVER_GDAL(format)  (strncasecmp((format)->driver,"gdal/",5)==0)
-#define MS_DRIVER_IMAGEMAP(format)  (strncasecmp((format)->driver,"imagemap",8)==0)
-#define MS_DRIVER_AGG(format) (strncasecmp((format)->driver,"agg/",4)==0)
-#define MS_DRIVER_MVT(format) (strncasecmp((format)->driver,"mvt",3)==0)
-#define MS_DRIVER_CAIRO(format) (strncasecmp((format)->driver,"cairo/",6)==0)
-#define MS_DRIVER_OGL(format) (strncasecmp((format)->driver,"ogl/",4)==0)
-#define MS_DRIVER_TEMPLATE(format) (strncasecmp((format)->driver,"template",8)==0)
+/* #define MS_VALID_EXTENT(minx, miny, maxx, maxy)  (((minx<maxx) &&
+ * (miny<maxy))?MS_TRUE:MS_FALSE) */
+#define MS_VALID_EXTENT(rect)                                                  \
+  ((((rect).minx < (rect).maxx && (rect).miny < (rect).maxy)) ? MS_TRUE        \
+                                                              : MS_FALSE)
+#define MS_VALID_SEARCH_EXTENT(rect)                                           \
+  ((((rect).minx <= (rect).maxx && (rect).miny <= (rect).maxy)) ? MS_TRUE      \
+                                                                : MS_FALSE)
+
+#define MS_INIT_COLOR(color, r, g, b, a)                                       \
+  {                                                                            \
+    (color).red = r;                                                           \
+    (color).green = g;                                                         \
+    (color).blue = b;                                                          \
+    (color).alpha = a;                                                         \
+  }
+#define MS_VALID_COLOR(color)                                                  \
+  (((color).red == -1 || (color).green == -1 || (color).blue == -1) ? MS_FALSE \
+                                                                    : MS_TRUE)
+#define MS_COMPARE_COLOR(color1, color2)                                       \
+  (((color2).red == (color1).red && (color2).green == (color1).green &&        \
+    (color2).blue == (color1).blue)                                            \
+       ? MS_TRUE                                                               \
+       : MS_FALSE)
+#define MS_TRANSPARENT_COLOR(color)                                            \
+  (((color).alpha == 0 || (color).red == -255 || (color).green == -255 ||      \
+    (color).blue == -255)                                                      \
+       ? MS_TRUE                                                               \
+       : MS_FALSE)
+#define MS_COMPARE_COLORS(a, b)                                                \
+  (((a).red != (b).red || (a).green != (b).green || (a).blue != (b).blue)      \
+       ? MS_FALSE                                                              \
+       : MS_TRUE)
+#define MS_COLOR_GETRGB(color)                                                 \
+  (MS_VALID_COLOR(color)                                                       \
+       ? ((color).red * 0x10000 + (color).green * 0x100 + (color).blue)        \
+       : -1)
+
+#define MS_IMAGE_MIME_TYPE(format)                                             \
+  (format->mimetype ? format->mimetype : "unknown")
+#define MS_IMAGE_EXTENSION(format)                                             \
+  (format->extension ? format->extension : "unknown")
+#define MS_DRIVER_SWF(format) (strncasecmp((format)->driver, "swf", 3) == 0)
+#define MS_DRIVER_GDAL(format) (strncasecmp((format)->driver, "gdal/", 5) == 0)
+#define MS_DRIVER_IMAGEMAP(format)                                             \
+  (strncasecmp((format)->driver, "imagemap", 8) == 0)
+#define MS_DRIVER_AGG(format) (strncasecmp((format)->driver, "agg/", 4) == 0)
+#define MS_DRIVER_MVT(format) (strncasecmp((format)->driver, "mvt", 3) == 0)
+#define MS_DRIVER_CAIRO(format)                                                \
+  (strncasecmp((format)->driver, "cairo/", 6) == 0)
+#define MS_DRIVER_OGL(format) (strncasecmp((format)->driver, "ogl/", 4) == 0)
+#define MS_DRIVER_TEMPLATE(format)                                             \
+  (strncasecmp((format)->driver, "template", 8) == 0)
 
 #endif /*SWIG*/
 
-#define MS_RENDER_WITH_SWF      2
-#define MS_RENDER_WITH_RAWDATA  3
+#define MS_RENDER_WITH_SWF 2
+#define MS_RENDER_WITH_RAWDATA 3
 #define MS_RENDER_WITH_IMAGEMAP 5
 #define MS_RENDER_WITH_TEMPLATE 8 /* query results only */
 #define MS_RENDER_WITH_OGR 16
 
 #define MS_RENDER_WITH_PLUGIN 100
-#define MS_RENDER_WITH_CAIRO_RASTER   101
+#define MS_RENDER_WITH_CAIRO_RASTER 101
 #define MS_RENDER_WITH_CAIRO_PDF 102
 #define MS_RENDER_WITH_CAIRO_SVG 103
-#define MS_RENDER_WITH_OGL      104
+#define MS_RENDER_WITH_OGL 104
 #define MS_RENDER_WITH_AGG 105
 #define MS_RENDER_WITH_KML 106
 #define MS_RENDER_WITH_UTFGRID 107
@@ -404,41 +433,50 @@ extern "C" {
 #ifndef SWIG
 
 #define MS_RENDERER_SWF(format) ((format)->renderer == MS_RENDER_WITH_SWF)
-#define MS_RENDERER_RAWDATA(format) ((format)->renderer == MS_RENDER_WITH_RAWDATA)
-#define MS_RENDERER_IMAGEMAP(format) ((format)->renderer == MS_RENDER_WITH_IMAGEMAP)
-#define MS_RENDERER_TEMPLATE(format) ((format)->renderer == MS_RENDER_WITH_TEMPLATE)
+#define MS_RENDERER_RAWDATA(format)                                            \
+  ((format)->renderer == MS_RENDER_WITH_RAWDATA)
+#define MS_RENDERER_IMAGEMAP(format)                                           \
+  ((format)->renderer == MS_RENDER_WITH_IMAGEMAP)
+#define MS_RENDERER_TEMPLATE(format)                                           \
+  ((format)->renderer == MS_RENDER_WITH_TEMPLATE)
 #define MS_RENDERER_KML(format) ((format)->renderer == MS_RENDER_WITH_KML)
 #define MS_RENDERER_OGR(format) ((format)->renderer == MS_RENDER_WITH_OGR)
 #define MS_RENDERER_MVT(format) ((format)->renderer == MS_RENDER_WITH_MVT)
 
 #define MS_RENDERER_PLUGIN(format) ((format)->renderer > MS_RENDER_WITH_PLUGIN)
 
-#define MS_CELLSIZE(min,max,d) (((max) - (min))/((d)-1)) /* where min/max are from an MapServer pixel center-to-pixel center extent */
-#define MS_OWS_CELLSIZE(min,max,d) (((max) - (min))/(d)) /* where min/max are from an OGC pixel outside edge-to-pixel outside edge extent */
-#define MS_MAP2IMAGE_X(x,minx,cx) (MS_NINT(((x) - (minx))/(cx)))
-#define MS_MAP2IMAGE_Y(y,maxy,cy) (MS_NINT(((maxy) - (y))/(cy)))
-#define MS_IMAGE2MAP_X(x,minx,cx) ((minx) + (cx)*(x))
-#define MS_IMAGE2MAP_Y(y,maxy,cy) ((maxy) - (cy)*(y))
-
-  /* these versions of MS_MAP2IMAGE takes 1/cellsize and is much faster */
-#define MS_MAP2IMAGE_X_IC(x,minx,icx) (MS_NINT(((x) - (minx))*(icx)))
-#define MS_MAP2IMAGE_Y_IC(y,maxy,icy) (MS_NINT(((maxy) - (y))*(icy)))
-#define MS_MAP2IMAGE_XCELL_IC(x,minx,icx) ((int)(((x) - (minx))*(icx)))
-#define MS_MAP2IMAGE_YCELL_IC(y,maxy,icy) ((int)(((maxy) - (y))*(icy)))
-
-#define MS_MAP2IMAGE_X_IC_DBL(x,minx,icx) (((x) - (minx))*(icx))
-#define MS_MAP2IMAGE_Y_IC_DBL(y,maxy,icy) (((maxy) - (y))*(icy))
-
-#define MS_MAP2IMAGE_X_IC_SNAP(x,minx,icx,res) ((MS_NINT(((x) - (minx))*(icx)*(res)))/(res))
-#define MS_MAP2IMAGE_Y_IC_SNAP(y,maxy,icy,res) ((MS_NINT(((maxy) - (y))*(icy)*(res)))/(res))
-
-  /* For CARTO symbols */
-#define MS_PI    3.14159265358979323846
-#define MS_PI2   1.57079632679489661923  /* (MS_PI / 2) */
-#define MS_3PI2  4.71238898038468985769  /* (3 * MS_PI2) */
-#define MS_2PI   6.28318530717958647693  /* (2 * MS_PI) */
+#define MS_CELLSIZE(min, max, d)                                               \
+  (((max) - (min)) / ((d)-1)) /* where min/max are from an MapServer pixel     \
+                                 center-to-pixel center extent */
+#define MS_OWS_CELLSIZE(min, max, d)                                           \
+  (((max) - (min)) / (d)) /* where min/max are from an OGC pixel outside       \
+                             edge-to-pixel outside edge extent */
+#define MS_MAP2IMAGE_X(x, minx, cx) (MS_NINT(((x) - (minx)) / (cx)))
+#define MS_MAP2IMAGE_Y(y, maxy, cy) (MS_NINT(((maxy) - (y)) / (cy)))
+#define MS_IMAGE2MAP_X(x, minx, cx) ((minx) + (cx) * (x))
+#define MS_IMAGE2MAP_Y(y, maxy, cy) ((maxy) - (cy) * (y))
+
+/* these versions of MS_MAP2IMAGE takes 1/cellsize and is much faster */
+#define MS_MAP2IMAGE_X_IC(x, minx, icx) (MS_NINT(((x) - (minx)) * (icx)))
+#define MS_MAP2IMAGE_Y_IC(y, maxy, icy) (MS_NINT(((maxy) - (y)) * (icy)))
+#define MS_MAP2IMAGE_XCELL_IC(x, minx, icx) ((int)(((x) - (minx)) * (icx)))
+#define MS_MAP2IMAGE_YCELL_IC(y, maxy, icy) ((int)(((maxy) - (y)) * (icy)))
+
+#define MS_MAP2IMAGE_X_IC_DBL(x, minx, icx) (((x) - (minx)) * (icx))
+#define MS_MAP2IMAGE_Y_IC_DBL(y, maxy, icy) (((maxy) - (y)) * (icy))
+
+#define MS_MAP2IMAGE_X_IC_SNAP(x, minx, icx, res)                              \
+  ((MS_NINT(((x) - (minx)) * (icx) * (res))) / (res))
+#define MS_MAP2IMAGE_Y_IC_SNAP(y, maxy, icy, res)                              \
+  ((MS_NINT(((maxy) - (y)) * (icy) * (res))) / (res))
+
+/* For CARTO symbols */
+#define MS_PI 3.14159265358979323846
+#define MS_PI2 1.57079632679489661923  /* (MS_PI / 2) */
+#define MS_3PI2 4.71238898038468985769 /* (3 * MS_PI2) */
+#define MS_2PI 6.28318530717958647693  /* (2 * MS_PI) */
 
-#define MS_ENCRYPTION_KEY_SIZE  16   /* Key size: 128 bits = 16 bytes */
+#define MS_ENCRYPTION_KEY_SIZE 16 /* Key size: 128 bits = 16 bytes */
 
 #define GET_LAYER(map, pos) map->layers[pos]
 #define GET_CLASS(map, lid, cid) map->layers[lid]->class[cid]
@@ -447,1448 +485,1858 @@ extern "C" {
 #if defined(HAVE_SYNC_FETCH_AND_ADD)
 #define MS_REFCNT_INCR(obj) __sync_fetch_and_add(&obj->refcount, +1)
 #define MS_REFCNT_DECR(obj) __sync_sub_and_fetch(&obj->refcount, +1)
-#define MS_REFCNT_INIT(obj) obj->refcount=1, __sync_synchronize()
+#define MS_REFCNT_INIT(obj) obj->refcount = 1, __sync_synchronize()
 #elif defined(_MSC_VER) && (defined(_M_IX86) || defined(_M_X64))
 #include <intrin.h>
-#pragma intrinsic (_InterlockedExchangeAdd)
+#pragma intrinsic(_InterlockedExchangeAdd)
 #if defined(_MSC_VER) && (_MSC_VER <= 1200)
-#define MS_REFCNT_INCR(obj) ( _InterlockedExchangeAdd((long*)(&obj->refcount), (long)(+1)) +1 )
-#define MS_REFCNT_DECR(obj) ( _InterlockedExchangeAdd((long*)(&obj->refcount), (long)(-1)) -1 )
-#define MS_REFCNT_INIT(obj) obj->refcount=1
+#define MS_REFCNT_INCR(obj)                                                    \
+  (_InterlockedExchangeAdd((long *)(&obj->refcount), (long)(+1)) + 1)
+#define MS_REFCNT_DECR(obj)                                                    \
+  (_InterlockedExchangeAdd((long *)(&obj->refcount), (long)(-1)) - 1)
+#define MS_REFCNT_INIT(obj) obj->refcount = 1
 #else
-#define MS_REFCNT_INCR(obj) ( _InterlockedExchangeAdd((volatile long*)(&obj->refcount), (long)(+1)) +1 )
-#define MS_REFCNT_DECR(obj) ( _InterlockedExchangeAdd((volatile long*)(&obj->refcount), (long)(-1)) -1 )
-#define MS_REFCNT_INIT(obj) obj->refcount=1
+#define MS_REFCNT_INCR(obj)                                                    \
+  (_InterlockedExchangeAdd((volatile long *)(&obj->refcount), (long)(+1)) + 1)
+#define MS_REFCNT_DECR(obj)                                                    \
+  (_InterlockedExchangeAdd((volatile long *)(&obj->refcount), (long)(-1)) - 1)
+#define MS_REFCNT_INIT(obj) obj->refcount = 1
 #endif
 #elif defined(__MINGW32__) && defined(__i386__)
-#define MS_REFCNT_INCR(obj) ( InterlockedExchangeAdd((long*)(&obj->refcount), (long)(+1)) +1 )
-#define MS_REFCNT_DECR(obj) ( InterlockedExchangeAdd((long*)(&obj->refcount), (long)(-1)) -1 )
-#define MS_REFCNT_INIT(obj) obj->refcount=1
+#define MS_REFCNT_INCR(obj)                                                    \
+  (InterlockedExchangeAdd((long *)(&obj->refcount), (long)(+1)) + 1)
+#define MS_REFCNT_DECR(obj)                                                    \
+  (InterlockedExchangeAdd((long *)(&obj->refcount), (long)(-1)) - 1)
+#define MS_REFCNT_INIT(obj) obj->refcount = 1
 #else
-  // unsafe fallback
+// unsafe fallback
 #define MS_REFCNT_INCR(obj) obj->refcount++
 #define MS_REFCNT_DECR(obj) (--(obj->refcount))
-#define MS_REFCNT_INIT(obj) obj->refcount=1
+#define MS_REFCNT_INIT(obj) obj->refcount = 1
 #endif // close if defined(_MSC..
-#else /*USE_THREAD*/
+#else  /*USE_THREAD*/
 #define MS_REFCNT_INCR(obj) obj->refcount++
 #define MS_REFCNT_DECR(obj) (--(obj->refcount))
-#define MS_REFCNT_INIT(obj) obj->refcount=1
+#define MS_REFCNT_INIT(obj) obj->refcount = 1
 #endif /*USE_THREAD*/
 
-#define MS_REFCNT_DECR_IS_NOT_ZERO(obj) (MS_REFCNT_DECR(obj))>0
-#define MS_REFCNT_DECR_IS_ZERO(obj) (MS_REFCNT_DECR(obj))<=0
+#define MS_REFCNT_DECR_IS_NOT_ZERO(obj) (MS_REFCNT_DECR(obj)) > 0
+#define MS_REFCNT_DECR_IS_ZERO(obj) (MS_REFCNT_DECR(obj)) <= 0
 
-#define MS_IS_VALID_ARRAY_INDEX(index, size) ((index<0 || index>=size)?MS_FALSE:MS_TRUE)
+#define MS_IS_VALID_ARRAY_INDEX(index, size)                                   \
+  ((index < 0 || index >= size) ? MS_FALSE : MS_TRUE)
 
-#define MS_CONVERT_UNIT(src_unit, dst_unit, value) (value * msInchesPerUnit(src_unit,0) / msInchesPerUnit(dst_unit,0))
+#define MS_CONVERT_UNIT(src_unit, dst_unit, value)                             \
+  (value * msInchesPerUnit(src_unit, 0) / msInchesPerUnit(dst_unit, 0))
 
-#define MS_INIT_INVALID_RECT { -1e300, -1e300, 1e300, 1e300 }
+#define MS_INIT_INVALID_RECT                                                   \
+  { -1e300, -1e300, 1e300, 1e300 }
 
 #endif
 
-  enum MS_NUM_CHECK_TYPES { MS_NUM_CHECK_NONE=0, MS_NUM_CHECK_RANGE, MS_NUM_CHECK_GT, MS_NUM_CHECK_GTE };
+enum MS_NUM_CHECK_TYPES {
+  MS_NUM_CHECK_NONE = 0,
+  MS_NUM_CHECK_RANGE,
+  MS_NUM_CHECK_GT,
+  MS_NUM_CHECK_GTE
+};
 
-  /* General enumerated types - needed by scripts */
-  enum MS_FILE_TYPE {MS_FILE_MAP, MS_FILE_SYMBOL};
-  enum MS_UNITS {MS_INCHES, MS_FEET, MS_MILES, MS_METERS, MS_KILOMETERS, MS_DD, MS_PIXELS, MS_PERCENTAGES, MS_NAUTICALMILES, MS_INHERIT = -1};
-  enum MS_SHAPE_TYPE {MS_SHAPE_POINT, MS_SHAPE_LINE, MS_SHAPE_POLYGON, MS_SHAPE_NULL};
-  enum MS_LAYER_TYPE {MS_LAYER_POINT, MS_LAYER_LINE, MS_LAYER_POLYGON, MS_LAYER_RASTER, MS_LAYER_ANNOTATION /* only used for parser backwards compatibility */, MS_LAYER_QUERY, MS_LAYER_CIRCLE, MS_LAYER_TILEINDEX, MS_LAYER_CHART};
-  enum MS_FONT_TYPE {MS_TRUETYPE, MS_BITMAP};
-  enum MS_RENDER_MODE {MS_FIRST_MATCHING_CLASS, MS_ALL_MATCHING_CLASSES};
+/* General enumerated types - needed by scripts */
+enum MS_FILE_TYPE { MS_FILE_MAP, MS_FILE_SYMBOL };
+enum MS_UNITS {
+  MS_INCHES,
+  MS_FEET,
+  MS_MILES,
+  MS_METERS,
+  MS_KILOMETERS,
+  MS_DD,
+  MS_PIXELS,
+  MS_PERCENTAGES,
+  MS_NAUTICALMILES,
+  MS_INHERIT = -1
+};
+enum MS_SHAPE_TYPE {
+  MS_SHAPE_POINT,
+  MS_SHAPE_LINE,
+  MS_SHAPE_POLYGON,
+  MS_SHAPE_NULL
+};
+enum MS_LAYER_TYPE {
+  MS_LAYER_POINT,
+  MS_LAYER_LINE,
+  MS_LAYER_POLYGON,
+  MS_LAYER_RASTER,
+  MS_LAYER_ANNOTATION /* only used for parser backwards compatibility */,
+  MS_LAYER_QUERY,
+  MS_LAYER_CIRCLE,
+  MS_LAYER_TILEINDEX,
+  MS_LAYER_CHART
+};
+enum MS_FONT_TYPE { MS_TRUETYPE, MS_BITMAP };
+enum MS_RENDER_MODE { MS_FIRST_MATCHING_CLASS, MS_ALL_MATCHING_CLASSES };
 
 #define MS_POSITIONS_LENGTH 14
-  enum MS_POSITIONS_ENUM {MS_UL=101, MS_LR, MS_UR, MS_LL, MS_CR, MS_CL, MS_UC, MS_LC, MS_CC, MS_AUTO, MS_XY, MS_NONE, MS_AUTO2,MS_FOLLOW};
+enum MS_POSITIONS_ENUM {
+  MS_UL = 101,
+  MS_LR,
+  MS_UR,
+  MS_LL,
+  MS_CR,
+  MS_CL,
+  MS_UC,
+  MS_LC,
+  MS_CC,
+  MS_AUTO,
+  MS_XY,
+  MS_NONE,
+  MS_AUTO2,
+  MS_FOLLOW
+};
 #define MS_TINY 5
 #define MS_SMALL 7
 #define MS_MEDIUM 10
 #define MS_LARGE 13
 #define MS_GIANT 16
-  enum MS_QUERYMAP_STYLES {MS_NORMAL, MS_HILITE, MS_SELECTED};
-  enum MS_CONNECTION_TYPE {MS_INLINE, MS_SHAPEFILE, MS_TILED_SHAPEFILE, MS_UNUSED_2, MS_OGR, MS_UNUSED_1, MS_POSTGIS, MS_WMS, MS_ORACLESPATIAL, MS_WFS, MS_GRATICULE, MS_MYSQL, MS_RASTER, MS_PLUGIN, MS_UNION, MS_UVRASTER, MS_CONTOUR, MS_KERNELDENSITY, MS_IDW, MS_FLATGEOBUF };
-#define IS_THIRDPARTY_LAYER_CONNECTIONTYPE(type) ((type) == MS_UNION || (type) == MS_KERNELDENSITY || (type) == MS_IDW)
-  enum MS_JOIN_CONNECTION_TYPE {MS_DB_XBASE, MS_DB_CSV, MS_DB_MYSQL, MS_DB_ORACLE, MS_DB_POSTGRES};
-  enum MS_JOIN_TYPE {MS_JOIN_ONE_TO_ONE, MS_JOIN_ONE_TO_MANY};
+enum MS_QUERYMAP_STYLES { MS_NORMAL, MS_HILITE, MS_SELECTED };
+enum MS_CONNECTION_TYPE {
+  MS_INLINE,
+  MS_SHAPEFILE,
+  MS_TILED_SHAPEFILE,
+  MS_UNUSED_2,
+  MS_OGR,
+  MS_UNUSED_1,
+  MS_POSTGIS,
+  MS_WMS,
+  MS_ORACLESPATIAL,
+  MS_WFS,
+  MS_GRATICULE,
+  MS_MYSQL,
+  MS_RASTER,
+  MS_PLUGIN,
+  MS_UNION,
+  MS_UVRASTER,
+  MS_CONTOUR,
+  MS_KERNELDENSITY,
+  MS_IDW,
+  MS_FLATGEOBUF
+};
+#define IS_THIRDPARTY_LAYER_CONNECTIONTYPE(type)                               \
+  ((type) == MS_UNION || (type) == MS_KERNELDENSITY || (type) == MS_IDW)
+enum MS_JOIN_CONNECTION_TYPE {
+  MS_DB_XBASE,
+  MS_DB_CSV,
+  MS_DB_MYSQL,
+  MS_DB_ORACLE,
+  MS_DB_POSTGRES
+};
+enum MS_JOIN_TYPE { MS_JOIN_ONE_TO_ONE, MS_JOIN_ONE_TO_MANY };
 
 #define MS_SINGLE 0 /* modes for searching (spatial/database) */
 #define MS_MULTIPLE 1
 
-  enum MS_QUERY_MODE {MS_QUERY_SINGLE, MS_QUERY_MULTIPLE};
-  enum MS_QUERY_TYPE {MS_QUERY_IS_NULL, MS_QUERY_BY_POINT, MS_QUERY_BY_RECT, MS_QUERY_BY_SHAPE, MS_QUERY_BY_ATTRIBUTE, MS_QUERY_BY_INDEX, MS_QUERY_BY_FILTER};
+enum MS_QUERY_MODE { MS_QUERY_SINGLE, MS_QUERY_MULTIPLE };
+enum MS_QUERY_TYPE {
+  MS_QUERY_IS_NULL,
+  MS_QUERY_BY_POINT,
+  MS_QUERY_BY_RECT,
+  MS_QUERY_BY_SHAPE,
+  MS_QUERY_BY_ATTRIBUTE,
+  MS_QUERY_BY_INDEX,
+  MS_QUERY_BY_FILTER
+};
 
-  enum MS_ALIGN_VALUE {MS_ALIGN_DEFAULT, MS_ALIGN_LEFT, MS_ALIGN_CENTER, MS_ALIGN_RIGHT};
+enum MS_ALIGN_VALUE {
+  MS_ALIGN_DEFAULT,
+  MS_ALIGN_LEFT,
+  MS_ALIGN_CENTER,
+  MS_ALIGN_RIGHT
+};
 
-  enum MS_CAPS_JOINS_AND_CORNERS {MS_CJC_NONE, MS_CJC_BEVEL, MS_CJC_BUTT, MS_CJC_MITER, MS_CJC_ROUND, MS_CJC_SQUARE, MS_CJC_TRIANGLE};
+enum MS_CAPS_JOINS_AND_CORNERS {
+  MS_CJC_NONE,
+  MS_CJC_BEVEL,
+  MS_CJC_BUTT,
+  MS_CJC_MITER,
+  MS_CJC_ROUND,
+  MS_CJC_SQUARE,
+  MS_CJC_TRIANGLE
+};
 
 #define MS_CJC_DEFAULT_CAPS MS_CJC_ROUND
 #define MS_CJC_DEFAULT_JOINS MS_CJC_NONE
 #define MS_CJC_DEFAULT_JOIN_MAXSIZE 3
 
-  enum MS_RETURN_VALUE {MS_SUCCESS, MS_FAILURE, MS_DONE};
-  enum MS_IMAGEMODE { MS_IMAGEMODE_PC256, MS_IMAGEMODE_RGB, MS_IMAGEMODE_RGBA, MS_IMAGEMODE_INT16, MS_IMAGEMODE_FLOAT32, MS_IMAGEMODE_BYTE, MS_IMAGEMODE_FEATURE, MS_IMAGEMODE_NULL };
+enum MS_RETURN_VALUE { MS_SUCCESS, MS_FAILURE, MS_DONE };
+enum MS_IMAGEMODE {
+  MS_IMAGEMODE_PC256,
+  MS_IMAGEMODE_RGB,
+  MS_IMAGEMODE_RGBA,
+  MS_IMAGEMODE_INT16,
+  MS_IMAGEMODE_FLOAT32,
+  MS_IMAGEMODE_BYTE,
+  MS_IMAGEMODE_FEATURE,
+  MS_IMAGEMODE_NULL
+};
 
-  enum MS_GEOS_OPERATOR {MS_GEOS_EQUALS, MS_GEOS_DISJOINT, MS_GEOS_TOUCHES, MS_GEOS_OVERLAPS, MS_GEOS_CROSSES, MS_GEOS_INTERSECTS, MS_GEOS_WITHIN, MS_GEOS_CONTAINS, MS_GEOS_BEYOND, MS_GEOS_DWITHIN};
+enum MS_GEOS_OPERATOR {
+  MS_GEOS_EQUALS,
+  MS_GEOS_DISJOINT,
+  MS_GEOS_TOUCHES,
+  MS_GEOS_OVERLAPS,
+  MS_GEOS_CROSSES,
+  MS_GEOS_INTERSECTS,
+  MS_GEOS_WITHIN,
+  MS_GEOS_CONTAINS,
+  MS_GEOS_BEYOND,
+  MS_GEOS_DWITHIN
+};
 #define MS_FILE_DEFAULT MS_FILE_MAP
 
 #if defined(_MSC_VER) && (_MSC_VER <= 1310)
 #define MS_DEBUG msDebug2
 #else
 #ifdef USE_EXTENDED_DEBUG
-#define MS_DEBUG(level,elt,fmt, ...) if((elt)->debug >= (level)) msDebug(fmt,##__VA_ARGS__)
+#define MS_DEBUG(level, elt, fmt, ...)                                         \
+  if ((elt)->debug >= (level))                                                 \
+  msDebug(fmt, ##__VA_ARGS__)
 #else
-#define MS_DEBUG(level,elt,fmt, ...) /* no-op */
+#define MS_DEBUG(level, elt, fmt, ...) /* no-op */
 #endif
 #endif
 
-  /* coordinate to pixel simplification modes, used in msTransformShape */
-  enum MS_TRANSFORM_MODE {
-    MS_TRANSFORM_NONE, /* no geographic to pixel transformation */
-    MS_TRANSFORM_ROUND, /* round to integer, might create degenerate geometries (used for GD)*/
-    MS_TRANSFORM_SNAPTOGRID, /* snap to a grid, should be user configurable in the future*/
-    MS_TRANSFORM_FULLRESOLUTION, /* keep full resolution */
-    MS_TRANSFORM_SIMPLIFY /* keep full resolution */
-  };
-
-  typedef enum {
-        MS_COMPOP_CLEAR,
-        MS_COMPOP_SRC,
-        MS_COMPOP_DST,
-        MS_COMPOP_SRC_OVER,
-        MS_COMPOP_DST_OVER,
-        MS_COMPOP_SRC_IN,
-        MS_COMPOP_DST_IN,
-        MS_COMPOP_SRC_OUT,
-        MS_COMPOP_DST_OUT,
-        MS_COMPOP_SRC_ATOP,
-        MS_COMPOP_DST_ATOP,
-        MS_COMPOP_XOR,
-        MS_COMPOP_PLUS,
-        MS_COMPOP_MINUS,
-        MS_COMPOP_MULTIPLY,
-        MS_COMPOP_SCREEN,
-        MS_COMPOP_OVERLAY,
-        MS_COMPOP_DARKEN,
-        MS_COMPOP_LIGHTEN,
-        MS_COMPOP_COLOR_DODGE,
-        MS_COMPOP_COLOR_BURN,
-        MS_COMPOP_HARD_LIGHT,
-        MS_COMPOP_SOFT_LIGHT,
-        MS_COMPOP_DIFFERENCE,
-        MS_COMPOP_EXCLUSION,
-        MS_COMPOP_CONTRAST,
-        MS_COMPOP_INVERT,
-        MS_COMPOP_INVERT_RGB
-  } CompositingOperation;
-
-  typedef struct _CompositingFilter{
-    char *filter;
-    struct _CompositingFilter *next;
-  } CompositingFilter;
-
-  typedef struct _LayerCompositer{
-    CompositingOperation comp_op;
-    int opacity;
-    CompositingFilter *filter;
-    struct _LayerCompositer *next;
-  } LayerCompositer;
-
-#ifndef SWIG
-  /* Filter object */
-  typedef enum {
-    FILTER_NODE_TYPE_UNDEFINED = -1,
-    FILTER_NODE_TYPE_LOGICAL = 0,
-    FILTER_NODE_TYPE_SPATIAL = 1,
-    FILTER_NODE_TYPE_COMPARISON = 2,
-    FILTER_NODE_TYPE_PROPERTYNAME = 3,
-    FILTER_NODE_TYPE_BBOX = 4,
-    FILTER_NODE_TYPE_LITERAL = 5,
-    FILTER_NODE_TYPE_BOUNDARY = 6,
-    FILTER_NODE_TYPE_GEOMETRY_POINT = 7,
-    FILTER_NODE_TYPE_GEOMETRY_LINE = 8,
-    FILTER_NODE_TYPE_GEOMETRY_POLYGON = 9,
-    FILTER_NODE_TYPE_FEATUREID = 10,
-    FILTER_NODE_TYPE_TEMPORAL = 11,
-    FILTER_NODE_TYPE_TIME_PERIOD = 12
-  } FilterNodeType;
-
-
-  /************************************************************************/
-  /*                          FilterEncodingNode                          */
-  /************************************************************************/
-
-  typedef struct _FilterNode {
-    FilterNodeType      eType;
-    char                *pszValue;
-    void                *pOther;
-    char                *pszSRS;
-    struct _FilterNode  *psLeftNode;
-    struct _FilterNode  *psRightNode;
-  } FilterEncodingNode;
+/* coordinate to pixel simplification modes, used in msTransformShape */
+enum MS_TRANSFORM_MODE {
+  MS_TRANSFORM_NONE,  /* no geographic to pixel transformation */
+  MS_TRANSFORM_ROUND, /* round to integer, might create degenerate geometries
+                         (used for GD)*/
+  MS_TRANSFORM_SNAPTOGRID, /* snap to a grid, should be user configurable in the
+                              future*/
+  MS_TRANSFORM_FULLRESOLUTION, /* keep full resolution */
+  MS_TRANSFORM_SIMPLIFY        /* keep full resolution */
+};
+
+typedef enum {
+  MS_COMPOP_CLEAR,
+  MS_COMPOP_SRC,
+  MS_COMPOP_DST,
+  MS_COMPOP_SRC_OVER,
+  MS_COMPOP_DST_OVER,
+  MS_COMPOP_SRC_IN,
+  MS_COMPOP_DST_IN,
+  MS_COMPOP_SRC_OUT,
+  MS_COMPOP_DST_OUT,
+  MS_COMPOP_SRC_ATOP,
+  MS_COMPOP_DST_ATOP,
+  MS_COMPOP_XOR,
+  MS_COMPOP_PLUS,
+  MS_COMPOP_MINUS,
+  MS_COMPOP_MULTIPLY,
+  MS_COMPOP_SCREEN,
+  MS_COMPOP_OVERLAY,
+  MS_COMPOP_DARKEN,
+  MS_COMPOP_LIGHTEN,
+  MS_COMPOP_COLOR_DODGE,
+  MS_COMPOP_COLOR_BURN,
+  MS_COMPOP_HARD_LIGHT,
+  MS_COMPOP_SOFT_LIGHT,
+  MS_COMPOP_DIFFERENCE,
+  MS_COMPOP_EXCLUSION,
+  MS_COMPOP_CONTRAST,
+  MS_COMPOP_INVERT,
+  MS_COMPOP_INVERT_RGB
+} CompositingOperation;
+
+typedef struct _CompositingFilter {
+  char *filter;
+  struct _CompositingFilter *next;
+} CompositingFilter;
+
+typedef struct _LayerCompositer {
+  CompositingOperation comp_op;
+  int opacity;
+  CompositingFilter *filter;
+  struct _LayerCompositer *next;
+} LayerCompositer;
+
+#ifndef SWIG
+/* Filter object */
+typedef enum {
+  FILTER_NODE_TYPE_UNDEFINED = -1,
+  FILTER_NODE_TYPE_LOGICAL = 0,
+  FILTER_NODE_TYPE_SPATIAL = 1,
+  FILTER_NODE_TYPE_COMPARISON = 2,
+  FILTER_NODE_TYPE_PROPERTYNAME = 3,
+  FILTER_NODE_TYPE_BBOX = 4,
+  FILTER_NODE_TYPE_LITERAL = 5,
+  FILTER_NODE_TYPE_BOUNDARY = 6,
+  FILTER_NODE_TYPE_GEOMETRY_POINT = 7,
+  FILTER_NODE_TYPE_GEOMETRY_LINE = 8,
+  FILTER_NODE_TYPE_GEOMETRY_POLYGON = 9,
+  FILTER_NODE_TYPE_FEATUREID = 10,
+  FILTER_NODE_TYPE_TEMPORAL = 11,
+  FILTER_NODE_TYPE_TIME_PERIOD = 12
+} FilterNodeType;
+
+/************************************************************************/
+/*                          FilterEncodingNode                          */
+/************************************************************************/
+
+typedef struct _FilterNode {
+  FilterNodeType eType;
+  char *pszValue;
+  void *pOther;
+  char *pszSRS;
+  struct _FilterNode *psLeftNode;
+  struct _FilterNode *psRightNode;
+} FilterEncodingNode;
 #endif /*SWIG*/
 
-  /* Define supported bindings here (only covers existing bindings at first). Not accessible directly using MapScript. */
+/* Define supported bindings here (only covers existing bindings at first). Not
+ * accessible directly using MapScript. */
 #define MS_STYLE_BINDING_LENGTH 12
-  enum MS_STYLE_BINDING_ENUM { MS_STYLE_BINDING_SIZE, MS_STYLE_BINDING_WIDTH, MS_STYLE_BINDING_ANGLE, MS_STYLE_BINDING_COLOR, MS_STYLE_BINDING_OUTLINECOLOR, MS_STYLE_BINDING_SYMBOL, MS_STYLE_BINDING_OUTLINEWIDTH, MS_STYLE_BINDING_OPACITY, MS_STYLE_BINDING_OFFSET_X, MS_STYLE_BINDING_OFFSET_Y, MS_STYLE_BINDING_POLAROFFSET_PIXEL, MS_STYLE_BINDING_POLAROFFSET_ANGLE };
+enum MS_STYLE_BINDING_ENUM {
+  MS_STYLE_BINDING_SIZE,
+  MS_STYLE_BINDING_WIDTH,
+  MS_STYLE_BINDING_ANGLE,
+  MS_STYLE_BINDING_COLOR,
+  MS_STYLE_BINDING_OUTLINECOLOR,
+  MS_STYLE_BINDING_SYMBOL,
+  MS_STYLE_BINDING_OUTLINEWIDTH,
+  MS_STYLE_BINDING_OPACITY,
+  MS_STYLE_BINDING_OFFSET_X,
+  MS_STYLE_BINDING_OFFSET_Y,
+  MS_STYLE_BINDING_POLAROFFSET_PIXEL,
+  MS_STYLE_BINDING_POLAROFFSET_ANGLE
+};
 #define MS_LABEL_BINDING_LENGTH 12
-  enum MS_LABEL_BINDING_ENUM { MS_LABEL_BINDING_SIZE, MS_LABEL_BINDING_ANGLE, MS_LABEL_BINDING_COLOR, MS_LABEL_BINDING_OUTLINECOLOR, MS_LABEL_BINDING_FONT, MS_LABEL_BINDING_PRIORITY, MS_LABEL_BINDING_POSITION, MS_LABEL_BINDING_SHADOWSIZEX, MS_LABEL_BINDING_SHADOWSIZEY, MS_LABEL_BINDING_OFFSET_X, MS_LABEL_BINDING_OFFSET_Y,MS_LABEL_BINDING_ALIGN };
+enum MS_LABEL_BINDING_ENUM {
+  MS_LABEL_BINDING_SIZE,
+  MS_LABEL_BINDING_ANGLE,
+  MS_LABEL_BINDING_COLOR,
+  MS_LABEL_BINDING_OUTLINECOLOR,
+  MS_LABEL_BINDING_FONT,
+  MS_LABEL_BINDING_PRIORITY,
+  MS_LABEL_BINDING_POSITION,
+  MS_LABEL_BINDING_SHADOWSIZEX,
+  MS_LABEL_BINDING_SHADOWSIZEY,
+  MS_LABEL_BINDING_OFFSET_X,
+  MS_LABEL_BINDING_OFFSET_Y,
+  MS_LABEL_BINDING_ALIGN
+};
 
-  /************************************************************************/
-  /*                         attributeBindingObj                          */
-  /************************************************************************/
-#ifndef SWIG
-  typedef struct {
-    char *item;
-    int index;
-  } attributeBindingObj;
+/************************************************************************/
+/*                         attributeBindingObj                          */
+/************************************************************************/
+#ifndef SWIG
+typedef struct {
+  char *item;
+  int index;
+} attributeBindingObj;
 #endif /*SWIG*/
 
-  /************************************************************************/
-  /*                             labelPathObj                             */
-  /*                                                                      */
-  /*      Label path object - used to hold path and bounds of curved      */
-  /*      labels - Bug #1620 implementation.                              */
-  /************************************************************************/
-#ifndef SWIG
-  typedef struct {
-    multipointObj path;
-    shapeObj bounds;
-    double *angles;
-  } labelPathObj;
+/************************************************************************/
+/*                             labelPathObj                             */
+/*                                                                      */
+/*      Label path object - used to hold path and bounds of curved      */
+/*      labels - Bug #1620 implementation.                              */
+/************************************************************************/
+#ifndef SWIG
+typedef struct {
+  multipointObj path;
+  shapeObj bounds;
+  double *angles;
+} labelPathObj;
 #endif /*SWIG*/
 
-  /************************************************************************/
-  /*                              fontSetObj                              */
-  /*                                                                      */
-  /*      used to hold aliases for TRUETYPE fonts                         */
-  /************************************************************************/
+/************************************************************************/
+/*                              fontSetObj                              */
+/*                                                                      */
+/*      used to hold aliases for TRUETYPE fonts                         */
+/************************************************************************/
 
-  /**
-  The :ref:`FONTSET <fontset>` object
-  */
-  typedef struct {
+/**
+The :ref:`FONTSET <fontset>` object
+*/
+typedef struct {
 #ifdef SWIG
     %immutable;
 #endif
-    char *filename; ///< The filename of the fonset
-    int numfonts; ///< The number of fonts in the fontset
-    hashTableObj fonts; ///< Key, value pairs of font name and font file
+  char *filename;     ///< The filename of the fonset
+  int numfonts;       ///< The number of fonts in the fontset
+  hashTableObj fonts; ///< Key, value pairs of font name and font file
 #ifdef SWIG
     %mutable;
 #endif
 
 #ifndef SWIG
-    struct mapObj *map;
+  struct mapObj *map;
+#endif
+} fontSetObj;
+
+/************************************************************************/
+/*                         featureListNodeObj                           */
+/*                                                                      */
+/*      for inline features, shape caches and queries                   */
+/************************************************************************/
+#ifndef SWIG
+typedef struct listNode {
+  shapeObj shape;
+  struct listNode *next;
+  struct listNode *tailifhead; /* this is the tail node in the list, if this is
+                                  the head element, otherwise NULL */
+} featureListNodeObj;
+
+typedef featureListNodeObj *featureListNodeObjPtr;
+#endif
+
+/************************************************************************/
+/*                              paletteObj                              */
+/*                                                                      */
+/*      used to hold colors while a map file is read                    */
+/************************************************************************/
+#ifndef SWIG
+typedef struct {
+  colorObj colors[MS_MAXCOLORS - 1];
+  int colorvalue[MS_MAXCOLORS - 1];
+  int numcolors;
+} paletteObj;
 #endif
-  } fontSetObj;
 
-  /************************************************************************/
-  /*                         featureListNodeObj                           */
-  /*                                                                      */
-  /*      for inline features, shape caches and queries                   */
-  /************************************************************************/
-#ifndef SWIG
-  typedef struct listNode {
-    shapeObj shape;
-    struct listNode *next;
-    struct listNode *tailifhead; /* this is the tail node in the list, if this is the head element, otherwise NULL */
-  } featureListNodeObj;
-
-  typedef featureListNodeObj * featureListNodeObjPtr;
-#endif
-
-  /************************************************************************/
-  /*                              paletteObj                              */
-  /*                                                                      */
-  /*      used to hold colors while a map file is read                    */
-  /************************************************************************/
-#ifndef SWIG
-  typedef struct {
-    colorObj colors[MS_MAXCOLORS-1];
-    int      colorvalue[MS_MAXCOLORS-1];
-    int numcolors;
-  } paletteObj;
-#endif
-
-  /************************************************************************/
-  /*                     expressionObj & tokenObj                         */
-  /************************************************************************/
-
-  enum MS_TOKEN_LOGICAL_ENUM { MS_TOKEN_LOGICAL_AND=300, MS_TOKEN_LOGICAL_OR, MS_TOKEN_LOGICAL_NOT };
-  enum MS_TOKEN_LITERAL_ENUM { MS_TOKEN_LITERAL_NUMBER=310, MS_TOKEN_LITERAL_STRING, MS_TOKEN_LITERAL_TIME, MS_TOKEN_LITERAL_SHAPE, MS_TOKEN_LITERAL_BOOLEAN };
-  enum MS_TOKEN_COMPARISON_ENUM {
-    MS_TOKEN_COMPARISON_EQ=320, MS_TOKEN_COMPARISON_NE, MS_TOKEN_COMPARISON_GT, MS_TOKEN_COMPARISON_LT, MS_TOKEN_COMPARISON_LE, MS_TOKEN_COMPARISON_GE, MS_TOKEN_COMPARISON_IEQ,
-    MS_TOKEN_COMPARISON_RE, MS_TOKEN_COMPARISON_IRE,
-    MS_TOKEN_COMPARISON_IN, MS_TOKEN_COMPARISON_LIKE,
-    MS_TOKEN_COMPARISON_INTERSECTS, MS_TOKEN_COMPARISON_DISJOINT, MS_TOKEN_COMPARISON_TOUCHES, MS_TOKEN_COMPARISON_OVERLAPS, MS_TOKEN_COMPARISON_CROSSES, MS_TOKEN_COMPARISON_WITHIN, MS_TOKEN_COMPARISON_CONTAINS, MS_TOKEN_COMPARISON_EQUALS, MS_TOKEN_COMPARISON_BEYOND, MS_TOKEN_COMPARISON_DWITHIN
-  };
-  enum MS_TOKEN_FUNCTION_ENUM {
-    MS_TOKEN_FUNCTION_LENGTH=350, MS_TOKEN_FUNCTION_TOSTRING, MS_TOKEN_FUNCTION_COMMIFY, MS_TOKEN_FUNCTION_AREA, MS_TOKEN_FUNCTION_ROUND, MS_TOKEN_FUNCTION_FROMTEXT,
-    MS_TOKEN_FUNCTION_BUFFER, MS_TOKEN_FUNCTION_DIFFERENCE, MS_TOKEN_FUNCTION_SIMPLIFY, MS_TOKEN_FUNCTION_SIMPLIFYPT, MS_TOKEN_FUNCTION_GENERALIZE, MS_TOKEN_FUNCTION_SMOOTHSIA, 
-    MS_TOKEN_FUNCTION_CENTERLINE, MS_TOKEN_FUNCTION_DENSIFY, MS_TOKEN_FUNCTION_OUTER, MS_TOKEN_FUNCTION_INNER,
-    MS_TOKEN_FUNCTION_JAVASCRIPT, MS_TOKEN_FUNCTION_UPPER, MS_TOKEN_FUNCTION_LOWER, MS_TOKEN_FUNCTION_INITCAP, MS_TOKEN_FUNCTION_FIRSTCAP
-  };
-  enum MS_TOKEN_BINDING_ENUM { MS_TOKEN_BINDING_DOUBLE=380, MS_TOKEN_BINDING_INTEGER, MS_TOKEN_BINDING_STRING, MS_TOKEN_BINDING_TIME, MS_TOKEN_BINDING_SHAPE, MS_TOKEN_BINDING_MAP_CELLSIZE, MS_TOKEN_BINDING_DATA_CELLSIZE };
-  enum MS_PARSE_TYPE_ENUM { MS_PARSE_TYPE_BOOLEAN, MS_PARSE_TYPE_STRING, MS_PARSE_TYPE_SHAPE, MS_PARSE_TYPE_SLD };
-
-#ifndef SWIG
-  typedef union {
-    int intval;
-    char *strval;
-    shapeObj *shpval;
-  } parseResultObj;
-
-  typedef union {
-    double dblval;
-    int intval;
-    char *strval;
-    struct tm tmval;
-    shapeObj *shpval;
-    attributeBindingObj bindval;
-  } tokenValueObj;
-
-  typedef struct tokenListNode {
-    int token;
-    tokenValueObj tokenval;
-    char *tokensrc; /* on occassion we may want to access to the original source string (e.g. date/time) */
-    struct tokenListNode *next;
-    struct tokenListNode *tailifhead; /* this is the tail node in the list if this is the head element, otherwise NULL */
-  } tokenListNodeObj;
-
-  typedef tokenListNodeObj * tokenListNodeObjPtr;
-
-  typedef struct {
-    char *string;
-    int type;
-    /* container for expression options such as case-insensitiveness */
-    /* This is a boolean container. */
-    int flags;
-
-    /* logical expression options */
-    tokenListNodeObjPtr tokens;
-    tokenListNodeObjPtr curtoken;
-
-    /* regular expression options */
-    ms_regex_t regex; /* compiled regular expression to be matched */
-    int compiled;
-
-    char *native_string; /* RFC 91 */
-  } expressionObj;
-
-  typedef struct {
-    colorObj *pixel; /* for raster layers */
-    shapeObj *shape; /* for vector layers */
-    double dblval; /* for map cellsize used by simplify */
-    double dblval2; /* for data cellsize */
-    expressionObj *expr; /* expression to be evaluated (contains tokens) */
-    int type; /* type of parse: boolean, string/text or shape/geometry */
-    parseResultObj result; /* parse result */
-  } parseObj;
-#endif
-
-  /************************************************************************/
-  /*                          clusterObj                                  */
-  /************************************************************************/
+/************************************************************************/
+/*                     expressionObj & tokenObj                         */
+/************************************************************************/
+
+enum MS_TOKEN_LOGICAL_ENUM {
+  MS_TOKEN_LOGICAL_AND = 300,
+  MS_TOKEN_LOGICAL_OR,
+  MS_TOKEN_LOGICAL_NOT
+};
+enum MS_TOKEN_LITERAL_ENUM {
+  MS_TOKEN_LITERAL_NUMBER = 310,
+  MS_TOKEN_LITERAL_STRING,
+  MS_TOKEN_LITERAL_TIME,
+  MS_TOKEN_LITERAL_SHAPE,
+  MS_TOKEN_LITERAL_BOOLEAN
+};
+enum MS_TOKEN_COMPARISON_ENUM {
+  MS_TOKEN_COMPARISON_EQ = 320,
+  MS_TOKEN_COMPARISON_NE,
+  MS_TOKEN_COMPARISON_GT,
+  MS_TOKEN_COMPARISON_LT,
+  MS_TOKEN_COMPARISON_LE,
+  MS_TOKEN_COMPARISON_GE,
+  MS_TOKEN_COMPARISON_IEQ,
+  MS_TOKEN_COMPARISON_RE,
+  MS_TOKEN_COMPARISON_IRE,
+  MS_TOKEN_COMPARISON_IN,
+  MS_TOKEN_COMPARISON_LIKE,
+  MS_TOKEN_COMPARISON_INTERSECTS,
+  MS_TOKEN_COMPARISON_DISJOINT,
+  MS_TOKEN_COMPARISON_TOUCHES,
+  MS_TOKEN_COMPARISON_OVERLAPS,
+  MS_TOKEN_COMPARISON_CROSSES,
+  MS_TOKEN_COMPARISON_WITHIN,
+  MS_TOKEN_COMPARISON_CONTAINS,
+  MS_TOKEN_COMPARISON_EQUALS,
+  MS_TOKEN_COMPARISON_BEYOND,
+  MS_TOKEN_COMPARISON_DWITHIN
+};
+enum MS_TOKEN_FUNCTION_ENUM {
+  MS_TOKEN_FUNCTION_LENGTH = 350,
+  MS_TOKEN_FUNCTION_TOSTRING,
+  MS_TOKEN_FUNCTION_COMMIFY,
+  MS_TOKEN_FUNCTION_AREA,
+  MS_TOKEN_FUNCTION_ROUND,
+  MS_TOKEN_FUNCTION_FROMTEXT,
+  MS_TOKEN_FUNCTION_BUFFER,
+  MS_TOKEN_FUNCTION_DIFFERENCE,
+  MS_TOKEN_FUNCTION_SIMPLIFY,
+  MS_TOKEN_FUNCTION_SIMPLIFYPT,
+  MS_TOKEN_FUNCTION_GENERALIZE,
+  MS_TOKEN_FUNCTION_SMOOTHSIA,
+  MS_TOKEN_FUNCTION_CENTERLINE,
+  MS_TOKEN_FUNCTION_DENSIFY,
+  MS_TOKEN_FUNCTION_OUTER,
+  MS_TOKEN_FUNCTION_INNER,
+  MS_TOKEN_FUNCTION_JAVASCRIPT,
+  MS_TOKEN_FUNCTION_UPPER,
+  MS_TOKEN_FUNCTION_LOWER,
+  MS_TOKEN_FUNCTION_INITCAP,
+  MS_TOKEN_FUNCTION_FIRSTCAP
+};
+enum MS_TOKEN_BINDING_ENUM {
+  MS_TOKEN_BINDING_DOUBLE = 380,
+  MS_TOKEN_BINDING_INTEGER,
+  MS_TOKEN_BINDING_STRING,
+  MS_TOKEN_BINDING_TIME,
+  MS_TOKEN_BINDING_SHAPE,
+  MS_TOKEN_BINDING_MAP_CELLSIZE,
+  MS_TOKEN_BINDING_DATA_CELLSIZE
+};
+enum MS_PARSE_TYPE_ENUM {
+  MS_PARSE_TYPE_BOOLEAN,
+  MS_PARSE_TYPE_STRING,
+  MS_PARSE_TYPE_SHAPE,
+  MS_PARSE_TYPE_SLD
+};
+
+#ifndef SWIG
+typedef union {
+  int intval;
+  char *strval;
+  shapeObj *shpval;
+} parseResultObj;
+
+typedef union {
+  double dblval;
+  int intval;
+  char *strval;
+  struct tm tmval;
+  shapeObj *shpval;
+  attributeBindingObj bindval;
+} tokenValueObj;
+
+typedef struct tokenListNode {
+  int token;
+  tokenValueObj tokenval;
+  char *tokensrc; /* on occassion we may want to access to the original source
+                     string (e.g. date/time) */
+  struct tokenListNode *next;
+  struct tokenListNode *tailifhead; /* this is the tail node in the list if this
+                                       is the head element, otherwise NULL */
+} tokenListNodeObj;
+
+typedef tokenListNodeObj *tokenListNodeObjPtr;
+
+typedef struct {
+  char *string;
+  int type;
+  /* container for expression options such as case-insensitiveness */
+  /* This is a boolean container. */
+  int flags;
+
+  /* logical expression options */
+  tokenListNodeObjPtr tokens;
+  tokenListNodeObjPtr curtoken;
+
+  /* regular expression options */
+  ms_regex_t regex; /* compiled regular expression to be matched */
+  int compiled;
+
+  char *native_string; /* RFC 91 */
+} expressionObj;
+
+typedef struct {
+  colorObj *pixel;     /* for raster layers */
+  shapeObj *shape;     /* for vector layers */
+  double dblval;       /* for map cellsize used by simplify */
+  double dblval2;      /* for data cellsize */
+  expressionObj *expr; /* expression to be evaluated (contains tokens) */
+  int type; /* type of parse: boolean, string/text or shape/geometry */
+  parseResultObj result; /* parse result */
+} parseObj;
+#endif
+
+/************************************************************************/
+/*                          clusterObj                                  */
+/************************************************************************/
 
 /**
 The :ref:`CLUSTER <cluster>` object. See :ref:`RFC 69 <rfc69>`.
 */
-  typedef struct {
-    double maxdistance; ///< Maximum distance between clusters - see :ref:`MAXDISTANCE <mapfile-cluster-maxdistance>`
-    double buffer; ///< The buffer size around the selection area - see :ref:`BUFFER <mapfile-cluster-buffer>`
-    char* region; ///< The type of the cluster region (rectangle or ellipse) - see :ref:`REGION <mapfile-cluster-region>`
-#ifndef SWIG
-    expressionObj group; /* expression to identify the groups */
-    expressionObj filter; /* expression for filtering the shapes */
-#endif
-  } clusterObj;
-
-  /************************************************************************/
-  /*                          processingParams                            */
-  /************************************************************************/
+typedef struct {
+  double maxdistance; ///< Maximum distance between clusters - see
+                      ///< :ref:`MAXDISTANCE <mapfile-cluster-maxdistance>`
+  double buffer;      ///< The buffer size around the selection area - see
+                      ///< :ref:`BUFFER <mapfile-cluster-buffer>`
+  char *region; ///< The type of the cluster region (rectangle or ellipse) - see
+                ///< :ref:`REGION <mapfile-cluster-region>`
+#ifndef SWIG
+  expressionObj group;  /* expression to identify the groups */
+  expressionObj filter; /* expression for filtering the shapes */
+#endif
+} clusterObj;
+
+/************************************************************************/
+/*                          processingParams                            */
+/************************************************************************/
 
 #ifndef SWIG
 /* Used by idw.c and kerneldensity.c */
-  typedef struct {
-      float normalization_scale;
-      int expand_searchrect;
-      int radius;
-      float power;
-  } interpolationProcessingParams;
+typedef struct {
+  float normalization_scale;
+  int expand_searchrect;
+  int radius;
+  float power;
+} interpolationProcessingParams;
 #endif
 
-  /************************************************************************/
-  /*                               joinObj                                */
-  /*                                                                      */
-  /*      simple way to access other XBase files, one-to-one or           */
-  /*      one-to-many supported                                           */
-  /************************************************************************/
+/************************************************************************/
+/*                               joinObj                                */
+/*                                                                      */
+/*      simple way to access other XBase files, one-to-one or           */
+/*      one-to-many supported                                           */
+/************************************************************************/
 
 #ifndef SWIG
-  typedef struct {
-    char *name;
-    char **items, **values; /* items/values (process 1 record at a time) */
-    int numitems;
+typedef struct {
+  char *name;
+  char **items, **values; /* items/values (process 1 record at a time) */
+  int numitems;
 
-    char *table;
-    char *from, *to; /* item names */
+  char *table;
+  char *from, *to; /* item names */
 
-    void *joininfo; /* vendor specific (i.e. XBase, MySQL, etc.) stuff to allow for persistent access */
+  void *joininfo; /* vendor specific (i.e. XBase, MySQL, etc.) stuff to allow
+                     for persistent access */
 
-    char *header, *footer;
+  char *header, *footer;
 #ifndef __cplusplus
-    char *template;
+  char *template;
 #else
-    char *_template;
+  char *_template;
 #endif
 
-    enum MS_JOIN_TYPE type;
-    char *connection;
-    enum MS_JOIN_CONNECTION_TYPE connectiontype;
-  } joinObj;
+  enum MS_JOIN_TYPE type;
+  char *connection;
+  enum MS_JOIN_CONNECTION_TYPE connectiontype;
+} joinObj;
 #endif
 
-  /************************************************************************/
-  /*                           outputFormatObj                            */
-  /*                                                                      */
-  /*      see mapoutput.c for most related code.                          */
-  /************************************************************************/
- 
+/************************************************************************/
+/*                           outputFormatObj                            */
+/*                                                                      */
+/*      see mapoutput.c for most related code.                          */
+/************************************************************************/
+
 /**
 The :ref:`OUTPUTFORMAT <outputformat>` object
 */
-  typedef struct {
+typedef struct {
 #ifndef SWIG
-    int refcount;
-    char **formatoptions;
-    rendererVTableObj *vtable;
-    void *device; /* for supporting direct rendering onto a device context */
-#endif /* SWIG */
+  int refcount;
+  char **formatoptions;
+  rendererVTableObj *vtable;
+  void *device; /* for supporting direct rendering onto a device context */
+#endif          /* SWIG */
 #ifdef SWIG
     %immutable;
 #endif /* SWIG */
 
-    /**
-    The number of option values set on this format - can be used to
-    iterate over the options array in conjunction with :func:`outputFormatObj.getOptionAt`
-    */
-    int  numformatoptions;
+  /**
+  The number of option values set on this format - can be used to
+  iterate over the options array in conjunction with
+  :func:`outputFormatObj.getOptionAt`
+  */
+  int numformatoptions;
 
 #ifdef SWIG
     %mutable;
-#endif /* SWIG */
-    char *name; ///< See :ref:`NAME <mapfile-outputformat-name>`
-    char *mimetype; ///< See :ref:`MIMETYPE <mapfile-outputformat-mimetype>`
-    char *driver; ///< See :ref:`DRIVER <mapfile-outputformat-driver>`
-    char *extension; ///< See :ref:`EXTENSION <mapfile-outputformat-extension>`
-    int  renderer;  ///< A :ref:`render mode constant<mapfile-constants-render>` - normally set internally based on the driver and some other setting in the constructor.
-    int  imagemode; ///< An :ref:`Image mode constant<mapfile-constants-imagemode>` - see :ref:`IMAGEMODE <mapfile-outputformat-imagemode>`
-    int  transparent; ///< See :ref:`TRANSPARENT <mapfile-outputformat-transparent>`
-    int  bands; ///< The number of bands in the raster, normally set via the BAND_COUNT formatoption - this field should be considered read-only
-                ///< Only used for the "raw" modes, MS_IMAGEMODE_BYTE, MS_IMAGEMODE_INT16, and MS_IMAGEMODE_FLOAT32
-    int inmapfile; ///< Boolean value indicating if the format is in the Mapfile
-  } outputFormatObj;
-
-  /* The following is used for "don't care" values in transparent, interlace and
-     imagequality values. */
-#define MS_NOOVERRIDE  -1111
-
-  /************************************************************************/
-  /*                             queryObj                                 */
-  /*                                                                      */
-  /*      encapsulates the information necessary to perform a query       */
-  /************************************************************************/
-#ifndef SWIG
-  typedef struct {
-    int type; /* MS_QUERY_TYPE */
-    int mode; /* MS_QUERY_MODE */
-
-    int layer;
-
-    pointObj point; /* by point */
-    double buffer;
-    int maxresults;
-
-    rectObj rect; /* by rect */
-    shapeObj *shape; /* by shape & operator (OGC filter) */
-
-    long shapeindex; /* by index */
-    long tileindex;
-    int clear_resultcache;
-
-    int  maxfeatures; /* global maxfeatures */
-    int  startindex;
-    int  only_cache_result_count; /* set to 1 sometimes by WFS 2.0 GetFeature request */
-
-    expressionObj filter; /* by filter */
-    char *filteritem;
-
-    int slayer; /* selection layer, used for msQueryByFeatures() (note this is not a query mode per se) */
-
-    int cache_shapes; /* whether to cache shapes in resultCacheObj */
-    int max_cached_shape_count; /* maximum number of shapes cached in the total number of resultCacheObj */
-    int max_cached_shape_ram_amount; /* maximum number of bytes taken by shapes cached in the total number of resultCacheObj */
-  } queryObj;
-#endif
-
-  /************************************************************************/
-  /*                             queryMapObj                              */
-  /*                                                                      */
-  /*      used to visualize query results                                 */
-  /************************************************************************/
+#endif             /* SWIG */
+  char *name;      ///< See :ref:`NAME <mapfile-outputformat-name>`
+  char *mimetype;  ///< See :ref:`MIMETYPE <mapfile-outputformat-mimetype>`
+  char *driver;    ///< See :ref:`DRIVER <mapfile-outputformat-driver>`
+  char *extension; ///< See :ref:`EXTENSION <mapfile-outputformat-extension>`
+  int renderer;  ///< A :ref:`render mode constant<mapfile-constants-render>` -
+                 ///< normally set internally based on the driver and some other
+                 ///< setting in the constructor.
+  int imagemode; ///< An :ref:`Image mode constant<mapfile-constants-imagemode>`
+                 ///< - see :ref:`IMAGEMODE <mapfile-outputformat-imagemode>`
+  int transparent; ///< See :ref:`TRANSPARENT
+                   ///< <mapfile-outputformat-transparent>`
+  int bands;       ///< The number of bands in the raster, normally set via the
+             ///< BAND_COUNT formatoption - this field should be considered
+             ///< read-only Only used for the "raw" modes, MS_IMAGEMODE_BYTE,
+             ///< MS_IMAGEMODE_INT16, and MS_IMAGEMODE_FLOAT32
+  int inmapfile; ///< Boolean value indicating if the format is in the Mapfile
+} outputFormatObj;
+
+/* The following is used for "don't care" values in transparent, interlace and
+   imagequality values. */
+#define MS_NOOVERRIDE -1111
+
+/************************************************************************/
+/*                             queryObj                                 */
+/*                                                                      */
+/*      encapsulates the information necessary to perform a query       */
+/************************************************************************/
+#ifndef SWIG
+typedef struct {
+  int type; /* MS_QUERY_TYPE */
+  int mode; /* MS_QUERY_MODE */
+
+  int layer;
+
+  pointObj point; /* by point */
+  double buffer;
+  int maxresults;
+
+  rectObj rect;    /* by rect */
+  shapeObj *shape; /* by shape & operator (OGC filter) */
+
+  long shapeindex; /* by index */
+  long tileindex;
+  int clear_resultcache;
+
+  int maxfeatures; /* global maxfeatures */
+  int startindex;
+  int only_cache_result_count; /* set to 1 sometimes by WFS 2.0 GetFeature
+                                  request */
+
+  expressionObj filter; /* by filter */
+  char *filteritem;
+
+  int slayer; /* selection layer, used for msQueryByFeatures() (note this is not
+                 a query mode per se) */
+
+  int cache_shapes;           /* whether to cache shapes in resultCacheObj */
+  int max_cached_shape_count; /* maximum number of shapes cached in the total
+                                 number of resultCacheObj */
+  int max_cached_shape_ram_amount; /* maximum number of bytes taken by shapes
+                                      cached in the total number of
+                                      resultCacheObj */
+} queryObj;
+#endif
+
+/************************************************************************/
+/*                             queryMapObj                              */
+/*                                                                      */
+/*      used to visualize query results                                 */
+/************************************************************************/
 
 /**
 The :ref:`QUERYMAP <querymap>` object.
-Instances of querymapObj are always are always embedded inside the :class:`mapObj`.
+Instances of querymapObj are always are always embedded inside the
+:class:`mapObj`.
 */
-  typedef struct {
+typedef struct {
 #ifdef SWIG
     %immutable;
-#endif /* SWIG */
-    struct mapObj *map; ///< Reference to parent :class:`mapObj`                                                                                                                 
+#endif                /* SWIG */
+  struct mapObj *map; ///< Reference to parent :class:`mapObj`
 #ifdef SWIG
     %mutable;
-#endif /* SWIG */
-    int height; ///< See :ref:`SIZE <mapfile-querymap-size>`
-    int width; ///< See :ref:`SIZE <mapfile-querymap-size>`
-    int status; ///< See :ref:`STATUS <mapfile-querymap-status>`
-    int style; ///< ``HILITE``, ``SELECTED`` or ``NORMAL`` - see :ref:`STYLE <mapfile-querymap-style>`
-    colorObj color; ///< See :ref:`COLOR <mapfile-querymap-color>`
-  } queryMapObj;
-
-  /************************************************************************/
-  /*                                webObj                                */
-  /*                                                                      */
-  /*      holds parameters for a mapserver/mapscript interface            */
-  /************************************************************************/
+#endif            /* SWIG */
+  int height;     ///< See :ref:`SIZE <mapfile-querymap-size>`
+  int width;      ///< See :ref:`SIZE <mapfile-querymap-size>`
+  int status;     ///< See :ref:`STATUS <mapfile-querymap-status>`
+  int style;      ///< ``HILITE``, ``SELECTED`` or ``NORMAL`` - see :ref:`STYLE
+                  ///< <mapfile-querymap-style>`
+  colorObj color; ///< See :ref:`COLOR <mapfile-querymap-color>`
+} queryMapObj;
+
+/************************************************************************/
+/*                                webObj                                */
+/*                                                                      */
+/*      holds parameters for a mapserver/mapscript interface            */
+/************************************************************************/
 
 /**
 The :ref:`WEB <web>` object.
-Has no other existence than as an attribute of a :class:`mapObj`. 
-Serves as a container for various run-time web application definitions like temporary file paths, template paths, etc.
+Has no other existence than as an attribute of a :class:`mapObj`.
+Serves as a container for various run-time web application definitions like
+temporary file paths, template paths, etc.
 */
-  typedef struct {
+typedef struct {
 
 #ifdef SWIG
       %immutable;
-#endif /* SWIG */
-      hashTableObj metadata; ///< Metadata hash table - see :ref:`METADATA <mapfile-web-metadata>`
-      hashTableObj validation; ///< See :ref:`VALIDATION <mapfile-web-validation>`
-      struct mapObj *map; ///< Reference to parent :class:`mapObj`
+#endif                     /* SWIG */
+  hashTableObj metadata;   ///< Metadata hash table - see :ref:`METADATA
+                           ///< <mapfile-web-metadata>`
+  hashTableObj validation; ///< See :ref:`VALIDATION <mapfile-web-validation>`
+  struct mapObj *map;      ///< Reference to parent :class:`mapObj`
 
 #ifdef SWIG
       %mutable;
 #endif /* SWIG */
 
-    char *imagepath; ///< Filesystem path to temporary image location - see :ref:`IMAGEPATH <mapfile-web-imagepath>`
-    char *imageurl; ///< URL to temporary image location - see :ref:`IMAGEURL <mapfile-web-imageurl>`
-    char *temppath; ///< See :ref:`TEMPPATH <mapfile-web-temppath>`
-    char *header; ///< Path to header document - see :ref:`HEADER <mapfile-web-header>`
-    char *footer; ///< Path to footer document - see :ref:`FOOTER <mapfile-web-footer>`
-    char *empty; ///< See :ref:`EMPTY <mapfile-web-empty>`
-    char *error; ///< Error handling - see :ref:`ERROR <mapfile-web-error>`
-
-    double minscaledenom; ///< Maximum map scale - see :ref:`MINSCALEDENOM <mapfile-web-minscaledenom>`
-    double maxscaledenom; ///< Minimum map scale - see :ref:`MAXSCALEDENOM <mapfile-web-maxscaledenom>`
-    char *mintemplate; ///< See :ref:`MINTEMPLATE <mapfile-web-mintemplate>`
-    char *maxtemplate; ///< See :ref:`MAXTEMPLATE <mapfile-web-maxtemplate>`
-
-    char *queryformat; ///< See :ref:`QUERYFORMAT <mapfile-web-queryformat>` /* what format is the query to be returned, given as a MIME type */
-    char *legendformat; ///< See :ref:`LEGENDFORMAT <mapfile-web-legendformat>`
-    char *browseformat; ///< See :ref:`BROWSEFORMAT <mapfile-web-browseformat>`
+  char *imagepath; ///< Filesystem path to temporary image location - see
+                   ///< :ref:`IMAGEPATH <mapfile-web-imagepath>`
+  char *imageurl;  ///< URL to temporary image location - see :ref:`IMAGEURL
+                   ///< <mapfile-web-imageurl>`
+  char *temppath;  ///< See :ref:`TEMPPATH <mapfile-web-temppath>`
+  char *header;    ///< Path to header document - see :ref:`HEADER
+                   ///< <mapfile-web-header>`
+  char *footer;    ///< Path to footer document - see :ref:`FOOTER
+                   ///< <mapfile-web-footer>`
+  char *empty;     ///< See :ref:`EMPTY <mapfile-web-empty>`
+  char *error;     ///< Error handling - see :ref:`ERROR <mapfile-web-error>`
+
+  double minscaledenom; ///< Maximum map scale - see :ref:`MINSCALEDENOM
+                        ///< <mapfile-web-minscaledenom>`
+  double maxscaledenom; ///< Minimum map scale - see :ref:`MAXSCALEDENOM
+                        ///< <mapfile-web-maxscaledenom>`
+  char *mintemplate;    ///< See :ref:`MINTEMPLATE <mapfile-web-mintemplate>`
+  char *maxtemplate;    ///< See :ref:`MAXTEMPLATE <mapfile-web-maxtemplate>`
+
+  char *queryformat;  ///< See :ref:`QUERYFORMAT <mapfile-web-queryformat>` /*
+                      ///< what format is the query to be returned, given as a
+                      ///< MIME type */
+  char *legendformat; ///< See :ref:`LEGENDFORMAT <mapfile-web-legendformat>`
+  char *browseformat; ///< See :ref:`BROWSEFORMAT <mapfile-web-browseformat>`
 
 #ifndef __cplusplus
-    char *template; ///< Path to template document - see :ref:`TEMPLATE <mapfile-web-template>`
+  char *template; ///< Path to template document - see :ref:`TEMPLATE
+                  ///< <mapfile-web-template>`
 #else
-    char *_template;
+  char *_template;
 #endif
 
-  } webObj;
+} webObj;
 
-  /************************************************************************/
-  /*                               styleObj                               */
-  /*                                                                      */
-  /*      holds parameters for symbolization, multiple styles may be      */
-  /*      applied within a classObj                                       */
-  /************************************************************************/
+/************************************************************************/
+/*                               styleObj                               */
+/*                                                                      */
+/*      holds parameters for symbolization, multiple styles may be      */
+/*      applied within a classObj                                       */
+/************************************************************************/
 
 /**
-The :ref:`STYLE <style>` object. An instance of styleObj is associated with one instance of :class:`classObj`.
+The :ref:`STYLE <style>` object. An instance of styleObj is associated with one
+instance of :class:`classObj`.
 */
-  struct styleObj{
+struct styleObj {
 
 #ifndef SWIG
-      /* private vars for rfc 48 & 64 */
-      expressionObj _geomtransform;
-      double scalefactor; // computed, not set
-      attributeBindingObj bindings[MS_STYLE_BINDING_LENGTH];
-      int numbindings;
-      expressionObj exprBindings[MS_STYLE_BINDING_LENGTH];
-      int nexprbindings;
+  /* private vars for rfc 48 & 64 */
+  expressionObj _geomtransform;
+  double scalefactor; // computed, not set
+  attributeBindingObj bindings[MS_STYLE_BINDING_LENGTH];
+  int numbindings;
+  expressionObj exprBindings[MS_STYLE_BINDING_LENGTH];
+  int nexprbindings;
 #endif
 
-
 #ifdef SWIG
     %immutable;
 #endif /* SWIG */
 
-    int refcount; ///< number of references to this object
-    char *symbolname; ///< Name of the style's symbol - see :ref:`symbolname <mapfile-style-symbol>`
+  int refcount;     ///< number of references to this object
+  char *symbolname; ///< Name of the style's symbol - see :ref:`symbolname
+                    ///< <mapfile-style-symbol>`
 
 #ifdef SWIG
     %mutable;
 #endif /* SWIG */
 
-#if defined(SWIG) && defined(SWIGPYTHON) /* would probably make sense to mark it immutable for other binding languages than Python */
-    %immutable;
-#endif
-    int patternlength; ///< Number of elements in the pattern attribute
 #if defined(SWIG) && defined(SWIGPYTHON)
-    %mutable;
-#endif
-
-#if !(defined(SWIG) && defined(SWIGPYTHON)) /* in Python we use a special typemap for this */
-    double pattern[MS_MAXPATTERNLENGTH]; ///< List of on, off values to define a dash pattern for line work (lines, polygon outlines, hatch lines)
+  /* would probably make sense to mark it immutable for other binding languages
+   * than Python */
+  // clang-format off
+  %immutable;
+// clang-format on
 #endif
-
-    double angle; ///< Angle, given in degrees, to draw the line work, default is 0, for symbols of Type HATCH, this is the angle of the 
-                  ///< hatched lines - see :ref:`ANGLE <mapfile-style-angle>`
-    /*should an angle be automatically computed*/
-    int autoangle; ///< If the angle is set to ``AUTO`` - see :ref:`ANGLE <mapfile-style-angle>`
-
-    /* should lines be drawn with antialiasing (default)? */
-    int antialiased; ///< See :ref:`ANTIALIAS <mapfile-style-antialias>`
-
-    colorObj color; ///< Foreground or fill pen color - see :ref:`COLOR <mapfile-style-color>`
-    colorObj outlinecolor; ///< Outline pen color - see :ref:`OUTLINECOLOR <mapfile-style-outlinecolor>`
-
-    int opacity; ///< See :ref:`OPACITY <mapfile-style-opacity>`
-
-    /* Stuff to handle Color Range Styles */
-    colorObj mincolor; ///< Minimum color in the :ref:`COLORRANGE <mapfile-style-colorrange>`
-    colorObj maxcolor; ///< Maximum color in the :ref:`COLORRANGE <mapfile-style-colorrange>`
-    double minvalue; ///< related to color ranges
-    double maxvalue; ///< related to color ranges
-    char *rangeitem; ///< Attribute/field that stores the values for the Color Range Mapping  - see :ref:`RANGEITEM <mapfile-style-rangeitem>`
-    int rangeitemindex; ///< The index of the range item - see :ref:`RANGEITEM <mapfile-style-rangeitem>`
-
-    int symbol; ///< The index within the map symbolset of the style's symbol - see :ref:`SYMBOL <mapfile-style-symbol>`
-    double size; ///< Pixel width of the style's pen or symbol - see :ref:`SIZE <mapfile-style-size>`
-    double minsize; ///< Minimum pen or symbol width for scaling styles - see :ref:`MINSIZE <mapfile-style-minsize>`
-    double maxsize; ///< Maximum pen or symbol width for scaling - see :ref:`MAXSIZE <mapfile-style-maxsize>`
-
-    double gap; ///< See :ref:`GAP <mapfile-style-gap>` - moved from symbolObj in version 6.0
-    double initialgap; ///< See :ref:`INITIALGAP <mapfile-style-initialgap>`
-
-    int linecap; ///< See :ref:`LINECAP <mapfile-style-linecap>`
-    int linejoin; ///< See :ref:`LINEJOIN <mapfile-style-linejoin>` - moved from symbolObj in version 6.0
-    double linejoinmaxsize; ///< See :ref:`LINEJOINMAXSIZE <mapfile-style-linejoinmaxsize>` - moved from symbolObj in version 6.0
-
-    double width; ///< Width refers to the thickness of line work drawn, in pixels - default is 1,
-                  ///< for symbols of type ``HATCH``, the with is how thick the hatched lines are - see :ref:`WIDTH <mapfile-style-width>`
-    double outlinewidth; ///< See :ref:`OUTLINEWIDTH <mapfile-style-outlinewidth>`
-    double minwidth; ///< Minimum width of the symbol - see :ref:`MINWIDTH <mapfile-style-minwidth>`
-    double maxwidth; ///< Maximum width of the symbol - see :ref:`MAXWIDTH <mapfile-style-maxwidth>`
-
-    double offsetx; ///< Draw with pen or symbol offset from map data, for shadows, hollow symbols, etc - see :ref:`OFFSET <mapfile-style-offset>`
-    double offsety; ///< Draw with pen or symbol offset from map data, for shadows, hollow symbols, etc - see :ref:`OFFSET <mapfile-style-offset>`
-    double polaroffsetpixel; ///< Specifies the radius/distance - see :ref:`POLAROFFSET <mapfile-style-polaroffset>`
-    double polaroffsetangle; ///< Specified the angle - see :ref:`POLAROFFSET <mapfile-style-polaroffset>`
-
-
-    double minscaledenom; ///< See :ref:`MINSCALEDENOM <mapfile-style-minscaledenom>`
-    double maxscaledenom; ///< See :ref:`MAXSCALEDENOM <mapfile-style-maxscaledenom>`
-    int sizeunits; ///< Supersedes class's :ref:`SIZEUNITS <mapfile-layer-sizeunits>` to allow fine-grained sizing for improved SLD (RFC 124)
-  };
+  int patternlength; ///< Number of elements in the pattern attribute
+#if defined(SWIG) && defined(SWIGPYTHON)
+  // clang-format off
+  %mutable;
+// clang-format on
+#endif
+
+#if !(defined(SWIG) &&                                                         \
+      defined(SWIGPYTHON)) /* in Python we use a special typemap for this */
+  double pattern[MS_MAXPATTERNLENGTH]; ///< List of on, off values to define a
+                                       ///< dash pattern for line work (lines,
+                                       ///< polygon outlines, hatch lines)
+#endif
+
+  double angle; ///< Angle, given in degrees, to draw the line work, default is
+                ///< 0, for symbols of Type HATCH, this is the angle of the
+                ///< hatched lines - see :ref:`ANGLE <mapfile-style-angle>`
+  /*should an angle be automatically computed*/
+  int autoangle; ///< If the angle is set to ``AUTO`` - see :ref:`ANGLE
+                 ///< <mapfile-style-angle>`
+
+  /* should lines be drawn with antialiasing (default)? */
+  int antialiased; ///< See :ref:`ANTIALIAS <mapfile-style-antialias>`
+
+  colorObj color;        ///< Foreground or fill pen color - see :ref:`COLOR
+                         ///< <mapfile-style-color>`
+  colorObj outlinecolor; ///< Outline pen color - see :ref:`OUTLINECOLOR
+                         ///< <mapfile-style-outlinecolor>`
+
+  int opacity; ///< See :ref:`OPACITY <mapfile-style-opacity>`
+
+  /* Stuff to handle Color Range Styles */
+  colorObj mincolor; ///< Minimum color in the :ref:`COLORRANGE
+                     ///< <mapfile-style-colorrange>`
+  colorObj maxcolor; ///< Maximum color in the :ref:`COLORRANGE
+                     ///< <mapfile-style-colorrange>`
+  double minvalue;   ///< related to color ranges
+  double maxvalue;   ///< related to color ranges
+  char *
+      rangeitem; ///< Attribute/field that stores the values for the Color Range
+                 ///< Mapping  - see :ref:`RANGEITEM <mapfile-style-rangeitem>`
+  int rangeitemindex; ///< The index of the range item - see :ref:`RANGEITEM
+                      ///< <mapfile-style-rangeitem>`
+
+  int symbol;  ///< The index within the map symbolset of the style's symbol -
+               ///< see :ref:`SYMBOL <mapfile-style-symbol>`
+  double size; ///< Pixel width of the style's pen or symbol - see :ref:`SIZE
+               ///< <mapfile-style-size>`
+  double minsize; ///< Minimum pen or symbol width for scaling styles - see
+                  ///< :ref:`MINSIZE <mapfile-style-minsize>`
+  double maxsize; ///< Maximum pen or symbol width for scaling - see
+                  ///< :ref:`MAXSIZE <mapfile-style-maxsize>`
+
+  double gap; ///< See :ref:`GAP <mapfile-style-gap>` - moved from symbolObj in
+              ///< version 6.0
+  double initialgap; ///< See :ref:`INITIALGAP <mapfile-style-initialgap>`
+
+  int linecap;  ///< See :ref:`LINECAP <mapfile-style-linecap>`
+  int linejoin; ///< See :ref:`LINEJOIN <mapfile-style-linejoin>` - moved from
+                ///< symbolObj in version 6.0
+  double linejoinmaxsize; ///< See :ref:`LINEJOINMAXSIZE
+                          ///< <mapfile-style-linejoinmaxsize>` - moved from
+                          ///< symbolObj in version 6.0
+
+  double width; ///< Width refers to the thickness of line work drawn, in pixels
+                ///< - default is 1, for symbols of type ``HATCH``, the with is
+                ///< how thick the hatched lines are - see :ref:`WIDTH
+                ///< <mapfile-style-width>`
+  double outlinewidth; ///< See :ref:`OUTLINEWIDTH <mapfile-style-outlinewidth>`
+  double minwidth;     ///< Minimum width of the symbol - see :ref:`MINWIDTH
+                       ///< <mapfile-style-minwidth>`
+  double maxwidth;     ///< Maximum width of the symbol - see :ref:`MAXWIDTH
+                       ///< <mapfile-style-maxwidth>`
+
+  double offsetx; ///< Draw with pen or symbol offset from map data, for
+                  ///< shadows, hollow symbols, etc - see :ref:`OFFSET
+                  ///< <mapfile-style-offset>`
+  double offsety; ///< Draw with pen or symbol offset from map data, for
+                  ///< shadows, hollow symbols, etc - see :ref:`OFFSET
+                  ///< <mapfile-style-offset>`
+  double polaroffsetpixel; ///< Specifies the radius/distance - see
+                           ///< :ref:`POLAROFFSET <mapfile-style-polaroffset>`
+  double polaroffsetangle; ///< Specified the angle - see :ref:`POLAROFFSET
+                           ///< <mapfile-style-polaroffset>`
+
+  double
+      minscaledenom; ///< See :ref:`MINSCALEDENOM <mapfile-style-minscaledenom>`
+  double
+      maxscaledenom; ///< See :ref:`MAXSCALEDENOM <mapfile-style-maxscaledenom>`
+  int sizeunits;     ///< Supersedes class's :ref:`SIZEUNITS
+                 ///< <mapfile-layer-sizeunits>` to allow fine-grained sizing
+                 ///< for improved SLD (RFC 124)
+};
 
 #define MS_STYLE_SINGLE_SIDED_OFFSET -99
 #define MS_STYLE_DOUBLE_SIDED_OFFSET -999
-#define IS_PARALLEL_OFFSET(offsety) ((offsety) == MS_STYLE_SINGLE_SIDED_OFFSET || (offsety) == MS_STYLE_DOUBLE_SIDED_OFFSET)
-
-  /********************************************************************/
-  /*                          labelLeaderObj                          */
-  /*                                                                  */
-  /*  parameters defining how a label or a group of labels may be     */
-  /*  offsetted from its original position                            */
-  /********************************************************************/
+#define IS_PARALLEL_OFFSET(offsety)                                            \
+  ((offsety) == MS_STYLE_SINGLE_SIDED_OFFSET ||                                \
+   (offsety) == MS_STYLE_DOUBLE_SIDED_OFFSET)
+
+/********************************************************************/
+/*                          labelLeaderObj                          */
+/*                                                                  */
+/*  parameters defining how a label or a group of labels may be     */
+/*  offsetted from its original position                            */
+/********************************************************************/
 
 /**
 The :ref:`LEADER <leader>` object
 */
-  typedef struct {
+typedef struct {
 #ifndef SWIG
-    styleObj **styles;
-    int maxstyles;
+  styleObj **styles;
+  int maxstyles;
 #endif
 #ifdef SWIG
     %immutable;
 #endif
-    int numstyles; ///< Number of styles used
+  int numstyles; ///< Number of styles used
 #ifdef SWIG
     %mutable;
 #endif
-    int maxdistance; ///< See :ref:`MAXDISTANCE <mapfile-leader-maxdistance>`
-    int gridstep; ///< See :ref:`GRIDSTEP <mapfile-leader-gridstep>`
-  } labelLeaderObj;
-
-
-  /************************************************************************/
-  /*                               labelObj                               */
-  /*                                                                      */
-  /*      parameters needed to annotate a layer, legend or scalebar       */
-  /************************************************************************/
+  int maxdistance; ///< See :ref:`MAXDISTANCE <mapfile-leader-maxdistance>`
+  int gridstep;    ///< See :ref:`GRIDSTEP <mapfile-leader-gridstep>`
+} labelLeaderObj;
+
+/************************************************************************/
+/*                               labelObj                               */
+/*                                                                      */
+/*      parameters needed to annotate a layer, legend or scalebar       */
+/************************************************************************/
 
 /**
 The :ref:`LABEL <label>` object
 */
-  struct labelObj{
+struct labelObj {
 #ifdef SWIG
     %immutable;
 #endif /* SWIG */
-    int refcount;
+  int refcount;
 #ifdef SWIG
     %mutable;
 #endif /* SWIG */
 
-    char *font; ///< Name of TrueType font  see :ref:`FONT <mapfile-label-font>`
-    colorObj color; ///< Foreground color - see :ref:`COLOR <mapfile-label-color>`
-    colorObj outlinecolor; ///< Color of one point outline - see :ref:`OUTLINECOLOR <mapfile-label-outlinecolor>`
-    int outlinewidth; ///< See :ref:`OUTLINEWIDTH <mapfile-label-outlinewidth>`
-
-    colorObj shadowcolor; ///< See :ref:`SHADOWCOLOR <mapfile-label-shadowcolor>`
-    int shadowsizex; ///< See :ref:`SHADOWSIZE <mapfile-label-shadowsize>`
-    int shadowsizey; ///< See :ref:`SHADOWSIZE <mapfile-label-shadowsize>`
-
-    int size; ///< Annotation height in pixels - see :ref:`SIZE <mapfile-label-size>`
-    int minsize; ///< Minimum height in pixels - see :ref:`MINSIZE <mapfile-label-minsize>`
-    int maxsize; ///< Maximum height in pixels for scaled labels. See :ref:`MAXSIZE <mapfile-label-maxsize>`
-
-    int position; ///< See :ref:`POSTION <mapfile-label-position>`
-    int offsetx; ///< Horizontal offset of label - see :ref:`OFFSET <mapfile-label-offset>`
-    int offsety; ///< Vertical offset of label - see :ref:`OFFSET <mapfile-label-offset>`
-
-    double angle; ///< See :ref:`ANGLE <mapfile-label-angle>`
-    enum MS_POSITIONS_ENUM anglemode; ///< One of :data:`AUTO` :data:`AUTO2`, or :data:`FOLLOW` - see :ref:`ANGLE <mapfile-label-angle>`
-
-    int buffer; ///< Space to reserve around a label (padding) - see :ref:`BUFFER <mapfile-label-buffer>`
-
-    int align; ///< See :ref:`ALIGN <mapfile-label-align>`
-
-    char wrap; ///< See :ref:`WRAP <mapfile-label-wrap>`
-    int maxlength; ///< See :ref:`MAXLENGTH <mapfile-label-maxlength>`
-    double space_size_10; ///< Cached size of a single space character used for label text alignment of rfc40
+  char *font; ///< Name of TrueType font  see :ref:`FONT <mapfile-label-font>`
+  colorObj color; ///< Foreground color - see :ref:`COLOR <mapfile-label-color>`
+  colorObj outlinecolor; ///< Color of one point outline - see
+                         ///< :ref:`OUTLINECOLOR <mapfile-label-outlinecolor>`
+  int outlinewidth; ///< See :ref:`OUTLINEWIDTH <mapfile-label-outlinewidth>`
+
+  colorObj shadowcolor; ///< See :ref:`SHADOWCOLOR <mapfile-label-shadowcolor>`
+  int shadowsizex;      ///< See :ref:`SHADOWSIZE <mapfile-label-shadowsize>`
+  int shadowsizey;      ///< See :ref:`SHADOWSIZE <mapfile-label-shadowsize>`
+
+  int size;    ///< Annotation height in pixels - see :ref:`SIZE
+               ///< <mapfile-label-size>`
+  int minsize; ///< Minimum height in pixels - see :ref:`MINSIZE
+               ///< <mapfile-label-minsize>`
+  int maxsize; ///< Maximum height in pixels for scaled labels. See
+               ///< :ref:`MAXSIZE <mapfile-label-maxsize>`
+
+  int position; ///< See :ref:`POSTION <mapfile-label-position>`
+  int offsetx;  ///< Horizontal offset of label - see :ref:`OFFSET
+                ///< <mapfile-label-offset>`
+  int offsety;  ///< Vertical offset of label - see :ref:`OFFSET
+                ///< <mapfile-label-offset>`
+
+  double angle; ///< See :ref:`ANGLE <mapfile-label-angle>`
+  enum MS_POSITIONS_ENUM
+      anglemode; ///< One of :data:`AUTO` :data:`AUTO2`, or :data:`FOLLOW` - see
+                 ///< :ref:`ANGLE <mapfile-label-angle>`
+
+  int buffer; ///< Space to reserve around a label (padding) - see :ref:`BUFFER
+              ///< <mapfile-label-buffer>`
+
+  int align; ///< See :ref:`ALIGN <mapfile-label-align>`
+
+  char wrap;            ///< See :ref:`WRAP <mapfile-label-wrap>`
+  int maxlength;        ///< See :ref:`MAXLENGTH <mapfile-label-maxlength>`
+  double space_size_10; ///< Cached size of a single space character used for
+                        ///< label text alignment of rfc40
 
-    /**
-    Minimum feature size (in pixels) to label, features of this size or greater will be 
-    labeled - see :ref:`MINFEATURESIZE  <mapfile-label-minfeaturesize>`
-    */
-    int minfeaturesize;
-    int autominfeaturesize; ///< :data:`MS_TRUE` or :data:`MS_FALSE`
-
-    double minscaledenom; ///< See :ref:`MINSCALEDENOM  <mapfile-label-minscaledenom>`
-    double maxscaledenom; ///< See :ref:`MAXSCALEDENOM  <mapfile-label-maxscaledenom>`
+  /**
+  Minimum feature size (in pixels) to label, features of this size or greater
+  will be labeled - see :ref:`MINFEATURESIZE  <mapfile-label-minfeaturesize>`
+  */
+  int minfeaturesize;
+  int autominfeaturesize; ///< :data:`MS_TRUE` or :data:`MS_FALSE`
 
-    int mindistance; ///< Minimum distance in pixels between duplicate labels - see :ref:`MINDISTANCE <mapfile-label-mindistance>`
-    int repeatdistance; ///< See :ref:`REPEATDISTANCE <mapfile-label-repeatdistance>`
-    double maxoverlapangle; ///< See :ref:`MAXOVERLAPANGLE <mapfile-label-maxoverlapangle>`
+  double
+      minscaledenom; ///< See :ref:`MINSCALEDENOM <mapfile-label-minscaledenom>`
+  double
+      maxscaledenom; ///< See :ref:`MAXSCALEDENOM <mapfile-label-maxscaledenom>`
+
+  int mindistance;    ///< Minimum distance in pixels between duplicate labels -
+                      ///< see :ref:`MINDISTANCE <mapfile-label-mindistance>`
+  int repeatdistance; ///< See :ref:`REPEATDISTANCE
+                      ///< <mapfile-label-repeatdistance>`
+  double maxoverlapangle; ///< See :ref:`MAXOVERLAPANGLE
+                          ///< <mapfile-label-maxoverlapangle>`
 
-    /**
-    Indicates if labels can run off the edge of an image, either :data:`MS_TRUE` 
-    or :data:`MS_FALSE` (default) - see :ref:`PARTIALS <mapfile-label-partials>`
-    */
-    int partials;
+  /**
+  Indicates if labels can run off the edge of an image, either :data:`MS_TRUE`
+  or :data:`MS_FALSE` (default) - see :ref:`PARTIALS <mapfile-label-partials>`
+  */
+  int partials;
 
-    int force; ///< Indicates if labels **must** be drawn - see :ref:`FORCE <mapfile-label-force>`
+  int force; ///< Indicates if labels **must** be drawn - see :ref:`FORCE
+             ///< <mapfile-label-force>`
 
-    char *encoding; ///< Supported encoding format to be used for labels - see :ref:`ENCODING <mapfile-label-encoding>`
+  char *encoding; ///< Supported encoding format to be used for labels - see
+                  ///< :ref:`ENCODING <mapfile-label-encoding>`
 
-    int priority; ///< Priority level 1 to :data:`MS_MAX_LABEL_PRIORITY`, default=1 - see :ref:`PRIORITY <mapfile-label-priority>`
-    int numstyles; ///< The number of styles associated with the label
+  int priority;  ///< Priority level 1 to :data:`MS_MAX_LABEL_PRIORITY`,
+                 ///< default=1 - see :ref:`PRIORITY <mapfile-label-priority>`
+  int numstyles; ///< The number of styles associated with the label
 
-    int sizeunits; ///< Supersedes class's sizeunits, defaults to :data:`MS_INHERIT`.
+  int sizeunits; ///< Supersedes class's sizeunits, defaults to
+                 ///< :data:`MS_INHERIT`.
 
 #ifndef SWIG
-    styleObj **styles;
-    int maxstyles;
+  styleObj **styles;
+  int maxstyles;
 
-    expressionObj expression;
-    expressionObj text;
+  expressionObj expression;
+  expressionObj text;
 
-    labelLeaderObj *leader;
+  labelLeaderObj *leader;
 
-    attributeBindingObj bindings[MS_LABEL_BINDING_LENGTH];
-    int numbindings;
-    expressionObj exprBindings[MS_LABEL_BINDING_LENGTH];
-    int nexprbindings;
+  attributeBindingObj bindings[MS_LABEL_BINDING_LENGTH];
+  int numbindings;
+  expressionObj exprBindings[MS_LABEL_BINDING_LENGTH];
+  int nexprbindings;
 
-    double scalefactor; // computed, not set
-#endif /* not SWIG */
-
-  };
+  double scalefactor; // computed, not set
+#endif                /* not SWIG */
+};
 
 #ifdef SWIG
-#ifdef	__cplusplus
+#ifdef __cplusplus
 extern "C" {
 #endif
 typedef struct labelObj labelObj;
-#ifdef	__cplusplus
+#ifdef __cplusplus
 }
 #endif
 #endif
 
 #ifndef SWIG
-  /* lightweight structure containing information to render a labelObj */
-  typedef struct {
-    lineObj *poly;
-    rectObj bbox;
-  } label_bounds;
-
-  typedef struct {
-    labelObj *label;
-    char *annotext;
-    double scalefactor,resolutionfactor;
-    pointObj annopoint;
-    double rotation;
-    textPathObj *textpath;
-    //rectObj bbox;
-    label_bounds **style_bounds;
-  } textSymbolObj;
+/* lightweight structure containing information to render a labelObj */
+typedef struct {
+  lineObj *poly;
+  rectObj bbox;
+} label_bounds;
+
+typedef struct {
+  labelObj *label;
+  char *annotext;
+  double scalefactor, resolutionfactor;
+  pointObj annopoint;
+  double rotation;
+  textPathObj *textpath;
+  // rectObj bbox;
+  label_bounds **style_bounds;
+} textSymbolObj;
 #endif
 
 #define MS_LABEL_PERPENDICULAR_OFFSET -99
 #define MS_LABEL_PERPENDICULAR_TOP_OFFSET 99
-#define IS_PERPENDICULAR_OFFSET(offsety) ((offsety) == MS_LABEL_PERPENDICULAR_OFFSET || (offsety) == MS_LABEL_PERPENDICULAR_TOP_OFFSET)
-
-  /************************************************************************/
-  /*                          classObj                                    */
-  /************************************************************************/
+#define IS_PERPENDICULAR_OFFSET(offsety)                                       \
+  ((offsety) == MS_LABEL_PERPENDICULAR_OFFSET ||                               \
+   (offsety) == MS_LABEL_PERPENDICULAR_TOP_OFFSET)
+
+/************************************************************************/
+/*                          classObj                                    */
+/************************************************************************/
 
 /**
- * The :ref:`CLASS <class>` object. Used for symbolization and classification information.
+ * The :ref:`CLASS <class>` object. Used for symbolization and classification
+ * information.
  *
  */
-  struct classObj {
+struct classObj {
 
 #ifdef SWIG
     %immutable;
 #endif /* SWIG */
-    
-    hashTableObj metadata; ///< see :ref:`METADATA <mapfile-class-metadata>`
-    hashTableObj validation; ///< see :ref:`VALIDATION <mapfile-class-validation>`
-    int numstyles; ///< number of styles for class
-    int numlabels;  ///< number of labels for class
-    int refcount; ///< number of references to this object
-    struct layerObj *layer; ///< reference to the parent layer
-    labelLeaderObj *leader; ///< see :ref:`LEADER <mapfile-class-leader>`
+
+  hashTableObj metadata;   ///< see :ref:`METADATA <mapfile-class-metadata>`
+  hashTableObj validation; ///< see :ref:`VALIDATION <mapfile-class-validation>`
+  int numstyles;           ///< number of styles for class
+  int numlabels;           ///< number of labels for class
+  int refcount;            ///< number of references to this object
+  struct layerObj *layer;  ///< reference to the parent layer
+  labelLeaderObj *leader;  ///< see :ref:`LEADER <mapfile-class-leader>`
 
 #ifdef SWIG
     %mutable;
 #endif
 
-    int status; ///< :data:`MS_ON` or :data:`MS_OFF` - draw features of this class or do not - see :ref:`STATUS <mapfile-class-status>`
-    int isfallback; ///< :data:`MS_TRUE` or :data:`MS_FALSE` use :data:`MS_TRUE` if this class should be applied if and only if no other class is applicable
-    char *name; ///< See :ref:`NAME <mapfile-class-name>` should be unique within a layer
-    char *title; ///< See :ref:`TITLE <mapfile-class-title>`
-    double minscaledenom; ///< See :ref:`MINSCALEDENOM <mapfile-class-minscaledenom>`
-    double maxscaledenom; ///< See :ref:`MAXSCALEDENOM <mapfile-CLASS-maxscaledenom>`
-    int minfeaturesize; ///< See :ref:`MINFEATURESIZE <mapfile-class-minfeaturesize>` minimum feature size in pixels
-    int debug; ///< :data:`MS_TRUE` or :data:`MS_FALSE` - see :ref:`DEBUG <mapfile-class-debug>`
-    char *keyimage; ///< See :ref:`KEYIMAGE <mapfile-class-keyimage>`
-    char *group; ///< See :ref:`GROUP <mapfile-class-group>`
-    int sizeunits; ///< Supersedes layer's sizeunits and applies to all styles and labels - see :ref:`LAYER SIZEUNITS <mapfile-layer-sizeunits>`
+  int status; ///< :data:`MS_ON` or :data:`MS_OFF` - draw features of this class
+              ///< or do not - see :ref:`STATUS <mapfile-class-status>`
+  int isfallback; ///< :data:`MS_TRUE` or :data:`MS_FALSE` use :data:`MS_TRUE`
+                  ///< if this class should be applied if and only if no other
+                  ///< class is applicable
+  char *name;  ///< See :ref:`NAME <mapfile-class-name>` should be unique within
+               ///< a layer
+  char *title; ///< See :ref:`TITLE <mapfile-class-title>`
+  double
+      minscaledenom; ///< See :ref:`MINSCALEDENOM <mapfile-class-minscaledenom>`
+  double
+      maxscaledenom; ///< See :ref:`MAXSCALEDENOM <mapfile-CLASS-maxscaledenom>`
+  int minfeaturesize; ///< See :ref:`MINFEATURESIZE
+                      ///< <mapfile-class-minfeaturesize>` minimum feature size
+                      ///< in pixels
+  int debug;          ///< :data:`MS_TRUE` or :data:`MS_FALSE` - see :ref:`DEBUG
+                      ///< <mapfile-class-debug>`
+  char *keyimage;     ///< See :ref:`KEYIMAGE <mapfile-class-keyimage>`
+  char *group;        ///< See :ref:`GROUP <mapfile-class-group>`
+  int sizeunits; ///< Supersedes layer's sizeunits and applies to all styles and
+                 ///< labels - see :ref:`LAYER SIZEUNITS
+                 ///< <mapfile-layer-sizeunits>`
 
 #ifndef __cplusplus
-    char *template; ///< See :ref:`TEMPLATE <mapfile-class-template>`
-#else /* __cplusplus */
-    char *_template; // keyword in cplusplus
-#endif /* __cplusplus */
+  char *template; ///< See :ref:`TEMPLATE <mapfile-class-template>`
+#else             /* __cplusplus */
+  char *_template; // keyword in cplusplus
+#endif            /* __cplusplus */
 
 #ifndef SWIG
-    expressionObj text;
-    expressionObj expression; /* the expression to be matched */
-    labelObj **labels;
-    int maxlabels;
-    int maxstyles;
-    styleObj **styles;
-    double scalefactor; // computed, not set
-#endif /* not SWIG */
-
-  };
-
-  /************************************************************************/
-  /*                         labelCacheMemberObj                          */
-  /*                                                                      */
-  /*      structures to implement label caching and collision             */
-  /*      avoidance etc                                                   */
-  /*                                                                      */
-  /*        Note: These are scriptable, but are read only.                */
-  /************************************************************************/
+  expressionObj text;
+  expressionObj expression; /* the expression to be matched */
+  labelObj **labels;
+  int maxlabels;
+  int maxstyles;
+  styleObj **styles;
+  double scalefactor; // computed, not set
+#endif                /* not SWIG */
+};
 
+/************************************************************************/
+/*                         labelCacheMemberObj                          */
+/*                                                                      */
+/*      structures to implement label caching and collision             */
+/*      avoidance etc                                                   */
+/*                                                                      */
+/*        Note: These are scriptable, but are read only.                */
+/************************************************************************/
 
 #ifdef SWIG
   %immutable;
 #endif /* SWIG */
-  /**
-  An individual feature label. The labelCacheMemberObj class is associated with labelCacheObj.
-  */
-  typedef struct {
-    int numtextsymbols; ///< Number of text symbols found in textsymbols
-    int layerindex; ///< The index of the layer of the labelled feature
-    int classindex; ///< Index of the class of the labelled feature
-    int status; ///< Has this label been drawn or not?
-    int markerid;  ///< Corresponding marker (POINT layers only)
+/**
+An individual feature label. The labelCacheMemberObj class is associated with
+labelCacheObj.
+*/
+typedef struct {
+  int numtextsymbols; ///< Number of text symbols found in textsymbols
+  int layerindex;     ///< The index of the layer of the labelled feature
+  int classindex;     ///< Index of the class of the labelled feature
+  int status;         ///< Has this label been drawn or not?
+  int markerid;       ///< Corresponding marker (POINT layers only)
 
-    pointObj point; ///< Label point
-    rectObj bbox; ///< Bounds of the whole cachePtr. Individual text and symbol sub bounds are found in textsymbols
+  pointObj point; ///< Label point
+  rectObj bbox;   ///< Bounds of the whole cachePtr. Individual text and symbol
+                  ///< sub bounds are found in textsymbols
 
-    lineObj *leaderline; ///< Leader lineObj
-    rectObj *leaderbbox; ///< Leader rectObj
+  lineObj *leaderline; ///< Leader lineObj
+  rectObj *leaderbbox; ///< Leader rectObj
 
 #ifndef SWIG
-    textSymbolObj **textsymbols;
+  textSymbolObj **textsymbols;
 #endif
 
-  } labelCacheMemberObj;
+} labelCacheMemberObj;
 
-  /************************************************************************/
-  /*                         markerCacheMemberObj                         */
-  /************************************************************************/
-  /**
-  An individual marker. The markerCacheMemberObj class is associated with labelCacheObj.
-  */
-  typedef struct {
-    int id; ///< Corresponding label
-    rectObj bounds; ///< Bounds of the markerCacheMemberObj
-  } markerCacheMemberObj;
-
-  /************************************************************************/
-  /*                          labelCacheSlotObj                           */
-  /************************************************************************/
-  /**
-  A cache slot to hold labels grouped by priority
-  */
-  typedef struct {
-    int numlabels; ///< Number of label members
-    int cachesize; ///< TODO
-    int nummarkers; ///< Number of marker members
-    int markercachesize; ///< TODO
-    labelCacheMemberObj *labels;
-    markerCacheMemberObj *markers;
-  } labelCacheSlotObj;
-
-  /************************************************************************/
-  /*                            labelCacheObj                             */
-  /************************************************************************/
-  /**
-  Set of a map's cached labels. Has no other existence other than as a labelcache
-  attribute of a mapObj. Associated with labelCacheMemberObj and markerCacheMemberObj.
-  */
-  typedef struct {
-    int num_rendered_members; ///< Number of rendered labels
+/************************************************************************/
+/*                         markerCacheMemberObj                         */
+/************************************************************************/
+/**
+An individual marker. The markerCacheMemberObj class is associated with
+labelCacheObj.
+*/
+typedef struct {
+  int id;         ///< Corresponding label
+  rectObj bounds; ///< Bounds of the markerCacheMemberObj
+} markerCacheMemberObj;
+
+/************************************************************************/
+/*                          labelCacheSlotObj                           */
+/************************************************************************/
+/**
+A cache slot to hold labels grouped by priority
+*/
+typedef struct {
+  int numlabels;       ///< Number of label members
+  int cachesize;       ///< TODO
+  int nummarkers;      ///< Number of marker members
+  int markercachesize; ///< TODO
+  labelCacheMemberObj *labels;
+  markerCacheMemberObj *markers;
+} labelCacheSlotObj;
+
+/************************************************************************/
+/*                            labelCacheObj                             */
+/************************************************************************/
+/**
+Set of a map's cached labels. Has no other existence other than as a labelcache
+attribute of a mapObj. Associated with labelCacheMemberObj and
+markerCacheMemberObj.
+*/
+typedef struct {
+  int num_rendered_members; ///< Number of rendered labels
 #ifndef SWIG
-    /* One labelCacheSlotObj for each priority level */
-    labelCacheSlotObj slots[MS_MAX_LABEL_PRIORITY];
-    int gutter; /* space in pixels around the image where labels cannot be placed */
-    labelCacheMemberObj **rendered_text_symbols;
-    int num_allocated_rendered_members;
-#endif
-  } labelCacheObj;
-
-  /************************************************************************/
-  /*                         resultObj                                    */
-  /************************************************************************/
-  /**
-  The result object is a handle, of sorts, for a feature of the layer
-  */
-  typedef struct {
+  /* One labelCacheSlotObj for each priority level */
+  labelCacheSlotObj slots[MS_MAX_LABEL_PRIORITY];
+  int gutter; /* space in pixels around the image where labels cannot be placed
+               */
+  labelCacheMemberObj **rendered_text_symbols;
+  int num_allocated_rendered_members;
+#endif
+} labelCacheObj;
+
+/************************************************************************/
+/*                         resultObj                                    */
+/************************************************************************/
+/**
+The result object is a handle, of sorts, for a feature of the layer
+*/
+typedef struct {
 #ifndef SWIG
-      shapeObj* shape;
+  shapeObj *shape;
 #endif
-    long shapeindex; ///< The shape index of the result
-    int tileindex; ///< The tile index of the result
-    int resultindex; ///< The index of the result
-    int classindex; ///< The class index of the result
-  } resultObj;
-
-  /************************************************************************/
-  /*                            resultCacheObj                            */
-  /************************************************************************/
-  /**
-  A cached result object
-  */
-  typedef struct {
+  long shapeindex; ///< The shape index of the result
+  int tileindex;   ///< The tile index of the result
+  int resultindex; ///< The index of the result
+  int classindex;  ///< The class index of the result
+} resultObj;
+
+/************************************************************************/
+/*                            resultCacheObj                            */
+/************************************************************************/
+/**
+A cached result object
+*/
+typedef struct {
 
 #ifndef SWIG
-    resultObj *results;
-    int cachesize;
-    rectObj previousBounds; /* bounds at previous iteration */
-#endif /* not SWIG */
+  resultObj *results;
+  int cachesize;
+  rectObj previousBounds; /* bounds at previous iteration */
+#endif                    /* not SWIG */
 
 #ifdef SWIG
     %immutable;
-#endif /* SWIG */
-    int numresults; ///< Length of result set
-    rectObj bounds; ///< Bounding box of query results
+#endif            /* SWIG */
+  int numresults; ///< Length of result set
+  rectObj bounds; ///< Bounding box of query results
 
 #ifdef SWIG
     %mutable;
 #endif /* SWIG */
-  } resultCacheObj;
-
+} resultCacheObj;
 
-  /************************************************************************/
-  /*                             symbolSetObj                             */
-  /************************************************************************/
-  /**
-  A :class:`symbolSetObj` is an attribute of a :class:`mapObj` and is associated with instances of :class:`symbolObj`.
-  */
-  typedef struct {
+/************************************************************************/
+/*                             symbolSetObj                             */
+/************************************************************************/
+/**
+A :class:`symbolSetObj` is an attribute of a :class:`mapObj` and is associated
+with instances of :class:`symbolObj`.
+*/
+typedef struct {
 #ifndef SWIG
-      int refcount;
-      symbolObj** symbol;
-      struct mapObj *map;
-      fontSetObj *fontset; /* a pointer to the main mapObj version */
-      struct imageCacheObj *imagecache;
+  int refcount;
+  symbolObj **symbol;
+  struct mapObj *map;
+  fontSetObj *fontset; /* a pointer to the main mapObj version */
+  struct imageCacheObj *imagecache;
 #endif /* not SWIG */
 
 #ifdef SWIG
     %immutable;
-#endif /* SWIG */
-    int numsymbols; ///< Number of symbols in the set
-    int maxsymbols; ///< Maximum number of allowed symbols
+#endif            /* SWIG */
+  int numsymbols; ///< Number of symbols in the set
+  int maxsymbols; ///< Maximum number of allowed symbols
 #ifdef SWIG
     %mutable;
 #endif /* SWIG */
 
-    char *filename; ///< Symbolset filename
-    int imagecachesize; ///< Symbols in the cache
+  char *filename;     ///< Symbolset filename
+  int imagecachesize; ///< Symbols in the cache
 
-  } symbolSetObj;
+} symbolSetObj;
 
-  /************************************************************************/
-  /*                           referenceMapObj                            */
-  /************************************************************************/
+/************************************************************************/
+/*                           referenceMapObj                            */
+/************************************************************************/
 
 /**
 The :ref:`REFERENCE <reference>` object
 */
-  typedef struct {
+typedef struct {
 #ifdef SWIG
       %immutable;
-#endif /* SWIG */
-      struct mapObj *map; ///< Reference to parent :class:`mapObj`
+#endif                /* SWIG */
+  struct mapObj *map; ///< Reference to parent :class:`mapObj`
 #ifdef SWIG
       %mutable;
-#endif /* SWIG */
-    rectObj extent; ///< Spatial extent of reference in units of parent map - see :ref:`EXTENT <mapfile-reference-extent>`
-    int height; ///< Height of reference map in pixels - see :ref:`SIZE <mapfile-reference-size>`
-    int width; ///< Width of reference map in pixels - see :ref:`SIZE <mapfile-reference-size>`
-    colorObj color; ///< Color of reference box - see :ref:`COLOR <mapfile-reference-color>`
-    colorObj outlinecolor; ///< Outline color of reference box - see :ref:`OUTLINECOLOR <mapfile-reference-outlinecolor>`
-    char *image; ///< Filename of reference map image - see :ref:`IMAGE <mapfile-reference-image>`
-    int status; ///< :data:`MS_ON` or :data:`MS_OFF` - see :ref:`STATUS <mapfile-reference-status>`
-    int marker; ///< Index of a symbol in the map symbol set to use for marker - see :ref:`MARKER <mapfile-reference-marker>`
-    char *markername; ///< Name of a symbol - see :ref:`MARKER <mapfile-reference-marker>`
-    int markersize; ///< Size of marker - see :ref:`MARKERSIZE <mapfile-reference-markersize>`
-    int minboxsize; ///< In pixels - see :ref:`MINBOXSIZE <mapfile-reference-minboxsize>`
-    int maxboxsize; ///< In pixels - see :ref:`MAXBOXSIZE <mapfile-reference-maxboxsize>`
-  } referenceMapObj;
-
-  /************************************************************************/
-  /*                             scalebarObj                              */
-  /************************************************************************/
-
-  #define MS_SCALEBAR_INTERVALS_MIN 1
-  #define MS_SCALEBAR_INTERVALS_MAX 100
-
-  #define MS_SCALEBAR_WIDTH_MIN 5
-  #define MS_SCALEBAR_WIDTH_MAX 1000
-  #define MS_SCALEBAR_HEIGHT_MIN 2
-  #define MS_SCALEBAR_HEIGHT_MAX 100
-
-  #define MS_SCALEBAR_OFFSET_MIN -50
-  #define MS_SCALEBAR_OFFSET_MAX 50
-  
-  /**
-  The :ref:`SCALEBAR <scalebar>` object
-  */
-  typedef struct {
+#endif            /* SWIG */
+  rectObj extent; ///< Spatial extent of reference in units of parent map - see
+                  ///< :ref:`EXTENT <mapfile-reference-extent>`
+  int height;     ///< Height of reference map in pixels - see :ref:`SIZE
+                  ///< <mapfile-reference-size>`
+  int width;      ///< Width of reference map in pixels - see :ref:`SIZE
+                  ///< <mapfile-reference-size>`
+  colorObj color; ///< Color of reference box - see :ref:`COLOR
+                  ///< <mapfile-reference-color>`
+  colorObj
+      outlinecolor; ///< Outline color of reference box - see :ref:`OUTLINECOLOR
+                    ///< <mapfile-reference-outlinecolor>`
+  char *image;      ///< Filename of reference map image - see :ref:`IMAGE
+                    ///< <mapfile-reference-image>`
+  int status;       ///< :data:`MS_ON` or :data:`MS_OFF` - see :ref:`STATUS
+                    ///< <mapfile-reference-status>`
+  int marker; ///< Index of a symbol in the map symbol set to use for marker -
+              ///< see :ref:`MARKER <mapfile-reference-marker>`
+  char *markername; ///< Name of a symbol - see :ref:`MARKER
+                    ///< <mapfile-reference-marker>`
+  int markersize;   ///< Size of marker - see :ref:`MARKERSIZE
+                    ///< <mapfile-reference-markersize>`
+  int minboxsize;   ///< In pixels - see :ref:`MINBOXSIZE
+                    ///< <mapfile-reference-minboxsize>`
+  int maxboxsize;   ///< In pixels - see :ref:`MAXBOXSIZE
+                    ///< <mapfile-reference-maxboxsize>`
+} referenceMapObj;
+
+/************************************************************************/
+/*                             scalebarObj                              */
+/************************************************************************/
+
+#define MS_SCALEBAR_INTERVALS_MIN 1
+#define MS_SCALEBAR_INTERVALS_MAX 100
+
+#define MS_SCALEBAR_WIDTH_MIN 5
+#define MS_SCALEBAR_WIDTH_MAX 1000
+#define MS_SCALEBAR_HEIGHT_MIN 2
+#define MS_SCALEBAR_HEIGHT_MAX 100
 
-     int transparent; ///< Allows transparency for an embedded scalebar - see :ref:`TRANSPARENT <mapfile-scalebar-transparent>`
-     colorObj imagecolor; ///< Background color of scalebar - see :ref:`IMAGECOLOR <mapfile-scalebar-imagecolor>`
-      int height; ///< Height in pixels - see :ref:`SIZE <mapfile-scalebar-size>`
-      int width; ///< Height in pixels - see :ref:`SIZE <mapfile-scalebar-size>`
-      int style; ///< 0 or 1 - see :ref:`STYLE <mapfile-scalebar-style>`
-      int intervals; ///< Number of intervals - see :ref:`INTERVALS <mapfile-scalebar-intervals>`
-      labelObj label; ///< Scalebar label - see :ref:`LABEL <mapfile-scalebar-label>`
-      colorObj color; ///< Scalebar foreground color - see :ref:`COLOR <mapfile-scalebar-color>`
-      colorObj backgroundcolor; ///< Scalebar background color - see :ref:`BACKGROUNDCOLOR <mapfile-scalebar-backgroundcolor>`
-      colorObj outlinecolor; ///< Foreground outline color - see :ref:`OUTLINECOLOR <mapfile-scalebar-outlinecolor>`
-      int units; ///< See :ref:`UNITS <mapfile-scalebar-units>`
-      int status; ///< ON, OFF or EMBED - see :ref:`STATUS <mapfile-scalebar-status>` - :data:`MS_ON`, :data:`MS_OFF`, or :data:`MS_EMBED`.
-      int position; ///< For embeded scalebars - see :ref:`POSITION <mapfile-scalebar-position>` - 
-                    ///< :data:`MS_UL`, :data:`MS_UC`, :data:`MS_UR`, :data:`MS_LL`, :data:`MS_LC`, or :data:`MS_LR`
-
-      int postlabelcache; ///< See :ref:`POSTLABELCACHE <mapfile-scalebar-postlabelcache>` - :data:`MS_TRUE` or :data:`MS_FALSE`
-      int align; ///< See :ref:`ALIGN <mapfile-scalebar-align>`
-      int offsetx; ///< See :ref:`OFFSET <mapfile-scalebar-offset>`
-      int offsety; ///< See :ref:`OFFSET <mapfile-scalebar-offset>`
-  } scalebarObj;
-
-  /************************************************************************/
-  /*                              legendObj                               */
-  /************************************************************************/
-
-  #define MS_LEGEND_KEYSIZE_MIN 5
-  #define MS_LEGEND_KEYSIZE_MAX 200
-  #define MS_LEGEND_KEYSPACING_MIN 0
-  #define MS_LEGEND_KEYSPACING_MAX 50
+#define MS_SCALEBAR_OFFSET_MIN -50
+#define MS_SCALEBAR_OFFSET_MAX 50
 
-  /**
-  The :ref:`LEGEND <legend>` object
-  */
-  typedef struct {
+/**
+The :ref:`SCALEBAR <scalebar>` object
+*/
+typedef struct {
+
+  int transparent;     ///< Allows transparency for an embedded scalebar - see
+                       ///< :ref:`TRANSPARENT <mapfile-scalebar-transparent>`
+  colorObj imagecolor; ///< Background color of scalebar - see :ref:`IMAGECOLOR
+                       ///< <mapfile-scalebar-imagecolor>`
+  int height;    ///< Height in pixels - see :ref:`SIZE <mapfile-scalebar-size>`
+  int width;     ///< Height in pixels - see :ref:`SIZE <mapfile-scalebar-size>`
+  int style;     ///< 0 or 1 - see :ref:`STYLE <mapfile-scalebar-style>`
+  int intervals; ///< Number of intervals - see :ref:`INTERVALS
+                 ///< <mapfile-scalebar-intervals>`
+  labelObj
+      label; ///< Scalebar label - see :ref:`LABEL <mapfile-scalebar-label>`
+  colorObj color;           ///< Scalebar foreground color - see :ref:`COLOR
+                            ///< <mapfile-scalebar-color>`
+  colorObj backgroundcolor; ///< Scalebar background color - see
+                            ///< :ref:`BACKGROUNDCOLOR
+                            ///< <mapfile-scalebar-backgroundcolor>`
+  colorObj outlinecolor; ///< Foreground outline color - see :ref:`OUTLINECOLOR
+                         ///< <mapfile-scalebar-outlinecolor>`
+  int units;             ///< See :ref:`UNITS <mapfile-scalebar-units>`
+  int status;            ///< ON, OFF or EMBED - see :ref:`STATUS
+              ///< <mapfile-scalebar-status>` - :data:`MS_ON`, :data:`MS_OFF`,
+              ///< or :data:`MS_EMBED`.
+  int position; ///< For embeded scalebars - see :ref:`POSITION
+                ///< <mapfile-scalebar-position>` - :data:`MS_UL`,
+                ///< :data:`MS_UC`, :data:`MS_UR`, :data:`MS_LL`, :data:`MS_LC`,
+                ///< or :data:`MS_LR`
+
+  int postlabelcache; ///< See :ref:`POSTLABELCACHE
+                      ///< <mapfile-scalebar-postlabelcache>` - :data:`MS_TRUE`
+                      ///< or :data:`MS_FALSE`
+  int align;          ///< See :ref:`ALIGN <mapfile-scalebar-align>`
+  int offsetx;        ///< See :ref:`OFFSET <mapfile-scalebar-offset>`
+  int offsety;        ///< See :ref:`OFFSET <mapfile-scalebar-offset>`
+} scalebarObj;
+
+/************************************************************************/
+/*                              legendObj                               */
+/************************************************************************/
+
+#define MS_LEGEND_KEYSIZE_MIN 5
+#define MS_LEGEND_KEYSIZE_MAX 200
+#define MS_LEGEND_KEYSPACING_MIN 0
+#define MS_LEGEND_KEYSPACING_MAX 50
+
+/**
+The :ref:`LEGEND <legend>` object
+*/
+typedef struct {
 
 #ifdef SWIG
     %immutable;
 #endif
-    labelObj label; ///< See :ref:`LABEL <mapfile-legend-label>`
-    struct mapObj *map; ///< Instances of legendObj are always are always embedded inside the mapObj
+  labelObj label;     ///< See :ref:`LABEL <mapfile-legend-label>`
+  struct mapObj *map; ///< Instances of legendObj are always are always embedded
+                      ///< inside the mapObj
 #ifdef SWIG
     %mutable;
 #endif
-    int transparent; ///< Allows transparency for an embedded legend - see :ref:`TRANSPARENT <mapfile-legend-transparent>`
-    colorObj imagecolor; ///< Legend background color - see :ref:`IMAGECOLOR <mapfile-legend-imagecolor>`
-    int keysizex; ///< Width in pixels of legend keys - see :ref:`KEYSIZE <mapfile-legend-keysize>`
-    int keysizey; ///< Height in pixels of legend keys - see :ref:`KEYSIZE <mapfile-legend-keysize>`
-    int keyspacingx; ///< Horizontal padding around keys in pixels - see :ref:`KEYSPACING <mapfile-legend-keyspacing>`
-    int keyspacingy; ///< Vertical padding around keys in pixels - see :ref:`KEYSPACING <mapfile-legend-keyspacing>`
-    colorObj outlinecolor; ///< Key outline color, -1 for no outline - see :ref:`OUTLINECOLOR <mapfile-legend-outlinecolor>`
-    int status; ///< :data:`MS_ON`, :data:`MS_OFF` or :data:`MS_EMBED`- see :ref:`STATUS <mapfile-legend-status>`
-    int height; ///< Legend height
-    int width; ///< Legend width
-    int position; ///< Used for embedded legends, see :ref:`POSITION  <mapfile-legend-position>`
-    int postlabelcache; ///< :data:`MS_TRUE`, :data:`MS_FALSE` - see :ref:`POSTLABELCACHE  <mapfile-legend-postlabelcache>`
+  int transparent;     ///< Allows transparency for an embedded legend - see
+                       ///< :ref:`TRANSPARENT <mapfile-legend-transparent>`
+  colorObj imagecolor; ///< Legend background color - see :ref:`IMAGECOLOR
+                       ///< <mapfile-legend-imagecolor>`
+  int keysizex;        ///< Width in pixels of legend keys - see :ref:`KEYSIZE
+                       ///< <mapfile-legend-keysize>`
+  int keysizey;        ///< Height in pixels of legend keys - see :ref:`KEYSIZE
+                       ///< <mapfile-legend-keysize>`
+  int keyspacingx;     ///< Horizontal padding around keys in pixels - see
+                       ///< :ref:`KEYSPACING <mapfile-legend-keyspacing>`
+  int keyspacingy;     ///< Vertical padding around keys in pixels - see
+                       ///< :ref:`KEYSPACING <mapfile-legend-keyspacing>`
+  colorObj outlinecolor; ///< Key outline color, -1 for no outline - see
+                         ///< :ref:`OUTLINECOLOR <mapfile-legend-outlinecolor>`
+  int status;   ///< :data:`MS_ON`, :data:`MS_OFF` or :data:`MS_EMBED`- see
+                ///< :ref:`STATUS <mapfile-legend-status>`
+  int height;   ///< Legend height
+  int width;    ///< Legend width
+  int position; ///< Used for embedded legends, see :ref:`POSITION
+                ///< <mapfile-legend-position>`
+  int postlabelcache; ///< :data:`MS_TRUE`, :data:`MS_FALSE` - see
+                      ///< :ref:`POSTLABELCACHE <mapfile-legend-postlabelcache>`
 #ifndef __cplusplus
-    char *template; ///< See :ref:`TEMPLATE <mapfile-legend-template>`
-#else /* __cplusplus */
-    char *_template;
-#endif /* __cplusplus */
-  } legendObj;
-
-  /************************************************************************/
-  /*                             graticuleObj                             */
-  /************************************************************************/
-#ifndef SWIG
-  typedef struct {
-    double    dwhichlatitude;
-    double    dwhichlongitude;
-    double    dstartlatitude;
-    double    dstartlongitude;
-    double    dendlatitude;
-    double    dendlongitude;
-    double    dincrementlatitude;
-    double    dincrementlongitude;
-    double    minarcs;
-    double    maxarcs;
-    double    minincrement;
-    double    maxincrement;
-    double    minsubdivides;
-    double    maxsubdivides;
-    int     bvertical;
-    int     blabelaxes;
-    int     ilabelstate;
-    int     ilabeltype;
-    rectObj   extent;
-    lineObj   *pboundinglines;
-    pointObj  *pboundingpoints;
-    char    *labelformat;
-  } graticuleObj;
-
-  typedef struct {
-    int nTop;
-    pointObj *pasTop;
-    char  **papszTopLabels;
-    int nBottom;
-    pointObj *pasBottom;
-    char  **papszBottomLabels;
-    int nLeft;
-    pointObj *pasLeft;
-    char  **papszLeftLabels;
-    int nRight;
-    pointObj *pasRight;
-    char  **papszRightLabels;
+  char *template; ///< See :ref:`TEMPLATE <mapfile-legend-template>`
+#else             /* __cplusplus */
+  char *_template;
+#endif            /* __cplusplus */
+} legendObj;
+
+/************************************************************************/
+/*                             graticuleObj                             */
+/************************************************************************/
+#ifndef SWIG
+typedef struct {
+  double dwhichlatitude;
+  double dwhichlongitude;
+  double dstartlatitude;
+  double dstartlongitude;
+  double dendlatitude;
+  double dendlongitude;
+  double dincrementlatitude;
+  double dincrementlongitude;
+  double minarcs;
+  double maxarcs;
+  double minincrement;
+  double maxincrement;
+  double minsubdivides;
+  double maxsubdivides;
+  int bvertical;
+  int blabelaxes;
+  int ilabelstate;
+  int ilabeltype;
+  rectObj extent;
+  lineObj *pboundinglines;
+  pointObj *pboundingpoints;
+  char *labelformat;
+} graticuleObj;
 
-  } graticuleIntersectionObj;
+typedef struct {
+  int nTop;
+  pointObj *pasTop;
+  char **papszTopLabels;
+  int nBottom;
+  pointObj *pasBottom;
+  char **papszBottomLabels;
+  int nLeft;
+  pointObj *pasLeft;
+  char **papszLeftLabels;
+  int nRight;
+  pointObj *pasRight;
+  char **papszRightLabels;
 
-  struct layerVTable;
-  typedef struct layerVTable layerVTableObj;
+} graticuleIntersectionObj;
+
+struct layerVTable;
+typedef struct layerVTable layerVTableObj;
 
 #endif /*SWIG*/
 
-  /************************************************************************/
-  /*                               imageObj                               */
-  /************************************************************************/
+/************************************************************************/
+/*                               imageObj                               */
+/************************************************************************/
 
 /**
- * An image object is a wrapper for images generated by MapServer. 
+ * An image object is a wrapper for images generated by MapServer.
  *
  */
-  struct imageObj{
+struct imageObj {
 #ifdef SWIG
     %immutable;
 #endif
-    int width; ///< image width in pixels
-    int height; ///< image height in pixels
-    double resolution; ///< image resolution in pixels per inch
-    double resolutionfactor; ///< resolution factor
-
-    char *imagepath; ///< if image is drawn by :func:`mapObj.draw` this is :ref:`IMAGEPATH <mapfile-web-imagepath>`
-    char *imageurl; ///< if image is drawn by :func:`mapObj.draw` this is :ref:`IMAGEURL <mapfile-web-imageurl>`
-    outputFormatObj *format; ///< an :class:`outputFormatObj` representing the output format of the image
-
-#ifndef SWIG
-    tileCacheObj *tilecache;
-    int ntiles;
-    int size;
+  int width;               ///< image width in pixels
+  int height;              ///< image height in pixels
+  double resolution;       ///< image resolution in pixels per inch
+  double resolutionfactor; ///< resolution factor
+
+  char *imagepath;         ///< if image is drawn by :func:`mapObj.draw` this is
+                           ///< :ref:`IMAGEPATH <mapfile-web-imagepath>`
+  char *imageurl;          ///< if image is drawn by :func:`mapObj.draw` this is
+                           ///< :ref:`IMAGEURL <mapfile-web-imageurl>`
+  outputFormatObj *format; ///< an :class:`outputFormatObj` representing the
+                           ///< output format of the image
+
+#ifndef SWIG
+  tileCacheObj *tilecache;
+  int ntiles;
+  int size;
 #endif
 #ifdef SWIG
     %mutable;
 #endif
 
 #ifndef SWIG
-    union {
-      void *plugin;
+  union {
+    void *plugin;
 
-      char *imagemap;
-      short *raw_16bit;
-      float *raw_float;
-      unsigned char *raw_byte;
-    } img;
-    ms_bitarray  img_mask;
-    pointObj refpt;
-    mapObj *map;
-#endif
-  };
-
-  /************************************************************************/
-  /*                               layerObj                               */
-  /*                                                                      */
-  /*      base unit of a map.                                             */
-  /************************************************************************/
+    char *imagemap;
+    short *raw_16bit;
+    float *raw_float;
+    unsigned char *raw_byte;
+  } img;
+  ms_bitarray img_mask;
+  pointObj refpt;
+  mapObj *map;
+#endif
+};
 
-  /**
-  An individual value within the :ref:`SCALETOKEN <mapfile-layer-scaletoken>` object
-  */
-  typedef struct {
-    double minscale; ///< The minimum scale for the replacement
-    double maxscale; ///< The maximum scale for the replacement
-    char *value; ///< The token replacement value
-  } scaleTokenEntryObj;
+/************************************************************************/
+/*                               layerObj                               */
+/*                                                                      */
+/*      base unit of a map.                                             */
+/************************************************************************/
 
-  /**
-  The :ref:`SCALETOKEN <mapfile-layer-scaletoken>` object
-  */
-  typedef struct {
-     char *name; ///< The name of the token to replace in the :ref:`DATA <mapfile-layer-data>` statement
-     int n_entries; ///< The number of values within the scaletoken
-     scaleTokenEntryObj *tokens; ///< A reference to the values
-  } scaleTokenObj;
-
-#ifndef SWIG
-  typedef enum {
-      SORT_ASC,
-      SORT_DESC
-  } sortOrderEnum;
-
-  typedef struct {
-      char* item;
-      sortOrderEnum sortOrder;
-  } sortByProperties;
-
-  typedef struct {
-      int nProperties;
-      sortByProperties* properties;
-  } sortByClause;
-
-  typedef struct {
-    /* The following store original members if they have been modified at runtime by a rfc86 scaletoken */
-    char *data;
-    char *tileitem;
-    char *tileindex;
-    char *filteritem;
-    char *filter;
-    char **processing;
-    int *processing_idx;
-    int n_processing;
-  } originalScaleTokenStrings;
+/**
+An individual value within the :ref:`SCALETOKEN <mapfile-layer-scaletoken>`
+object
+*/
+typedef struct {
+  double minscale; ///< The minimum scale for the replacement
+  double maxscale; ///< The maximum scale for the replacement
+  char *value;     ///< The token replacement value
+} scaleTokenEntryObj;
+
+/**
+The :ref:`SCALETOKEN <mapfile-layer-scaletoken>` object
+*/
+typedef struct {
+  char *name;    ///< The name of the token to replace in the :ref:`DATA
+                 ///< <mapfile-layer-data>` statement
+  int n_entries; ///< The number of values within the scaletoken
+  scaleTokenEntryObj *tokens; ///< A reference to the values
+} scaleTokenObj;
+
+#ifndef SWIG
+typedef enum { SORT_ASC, SORT_DESC } sortOrderEnum;
+
+typedef struct {
+  char *item;
+  sortOrderEnum sortOrder;
+} sortByProperties;
+
+typedef struct {
+  int nProperties;
+  sortByProperties *properties;
+} sortByClause;
+
+typedef struct {
+  /* The following store original members if they have been modified at runtime
+   * by a rfc86 scaletoken */
+  char *data;
+  char *tileitem;
+  char *tileindex;
+  char *filteritem;
+  char *filter;
+  char **processing;
+  int *processing_idx;
+  int n_processing;
+} originalScaleTokenStrings;
 #endif
 
-  /**
-  The :ref:`LAYER <layer>` object
-  */
-  struct layerObj {
+/**
+The :ref:`LAYER <layer>` object
+*/
+struct layerObj {
 
 #ifndef SWIG
-    /* RFC86 Scale-dependent token replacements */
-    scaleTokenObj *scaletokens;
-    int numscaletokens;
-    originalScaleTokenStrings *orig_st;
-    int labelitemindex;
+  /* RFC86 Scale-dependent token replacements */
+  scaleTokenObj *scaletokens;
+  int numscaletokens;
+  originalScaleTokenStrings *orig_st;
+  int labelitemindex;
 
-    int tileitemindex;
-    projectionObj projection; /* projection information for the layer */
-    int project; /* boolean variable, do we need to project this layer or not */
-    reprojectionObj* reprojectorLayerToMap;
-    reprojectionObj* reprojectorMapToLayer;
+  int tileitemindex;
+  projectionObj projection; /* projection information for the layer */
+  int project; /* boolean variable, do we need to project this layer or not */
+  reprojectionObj *reprojectorLayerToMap;
+  reprojectionObj *reprojectorMapToLayer;
 
-    featureListNodeObjPtr features; /* linked list so we don't need a counter */
-    featureListNodeObjPtr currentfeature; /* pointer to the current feature */
+  featureListNodeObjPtr features; /* linked list so we don't need a counter */
+  featureListNodeObjPtr currentfeature; /* pointer to the current feature */
 
-    layerVTableObj *vtable;
+  layerVTableObj *vtable;
 
-    /* SDL has converted OracleSpatial, SDE, Graticules */
-    void *layerinfo; /* all connection types should use this generic pointer to a vendor specific structure */
-    void *wfslayerinfo; /* For WFS layers, will contain a msWFSLayerInfo struct */
+  /* SDL has converted OracleSpatial, SDE, Graticules */
+  void *layerinfo; /* all connection types should use this generic pointer to a
+                      vendor specific structure */
+  void *wfslayerinfo; /* For WFS layers, will contain a msWFSLayerInfo struct */
 
-    char **items;
-    void *iteminfo; /* connection specific information necessary to retrieve values */
-    expressionObj filter; /* connection specific attribute filter */
-    int bandsitemindex;
-    int filteritemindex;
-    int styleitemindex;
+  char **items;
+  void *iteminfo;       /* connection specific information necessary to retrieve
+                           values */
+  expressionObj filter; /* connection specific attribute filter */
+  int bandsitemindex;
+  int filteritemindex;
+  int styleitemindex;
 
-    char **processing;
-    joinObj *joins;
+  char **processing;
+  joinObj *joins;
 
-    imageObj *maskimage;
-    graticuleObj* grid;
-    expressionObj _geomtransform;
-    sortByClause sortBy;
+  imageObj *maskimage;
+  graticuleObj *grid;
+  expressionObj _geomtransform;
+  sortByClause sortBy;
 
 #endif
 
 #ifndef SWIG
-    int classitemindex;
-    resultCacheObj *resultcache; /* holds the results of a query against this layer */
-    double scalefactor; /* computed, not set */
+  int classitemindex;
+  resultCacheObj
+      *resultcache;   /* holds the results of a query against this layer */
+  double scalefactor; /* computed, not set */
 #ifndef __cplusplus
-    classObj **class; /* always at least 1 class */
-#else /* __cplusplus */
-    classObj **_class;
-#endif /* __cplusplus */
-#endif /* not SWIG */
+  classObj **class; /* always at least 1 class */
+#else               /* __cplusplus */
+  classObj **_class;
+#endif              /* __cplusplus */
+#endif              /* not SWIG */
 
 #ifdef SWIG
     %immutable;
-#endif /* SWIG */
-    int refcount; ///< reference counting, RFC24
-    int numclasses; ///< Number of layer classes
-    int maxclasses; ///< Used to track of the maximum number of classes - see RFC-17
-    int index; ///< Index of layer within parent map's layers array
-    struct mapObj *map; ///< Reference to parent map
-    int numitems; ///< Number of layer feature attributes (items)
-    hashTableObj metadata; ///< See :ref:`METADATA <mapfile-layer-metadata>`
-    hashTableObj validation; ///< See :ref:`VALIDATION <mapfile-layer-validation>`
-    hashTableObj bindvals; ///< Relates to RFC59
-    hashTableObj connectionoptions; ///< See :ref:`CONNECTIONOPTIONS <mapfile-layer-connectionoptions>`
-
-    clusterObj cluster; ///< See :ref:`CLUSTER <mapfile-layer-cluster>`
-    rectObj extent; ///< optional limiting extent for layer features - see :ref:`EXTENT <mapfile-layer-extent>`
-    int numprocessing; ///< Number of raster processing directives
-    int numjoins; ///< Number of layer joins
-
-    expressionObj utfdata; ///< See :ref:`UTFDATA <mapfile-layer-utfdata>`
-    LayerCompositer *compositer; ///< See :ref:`COMPOSITE <mapfile-layer-composite>`
+#endif                /* SWIG */
+  int refcount;       ///< reference counting, RFC24
+  int numclasses;     ///< Number of layer classes
+  int maxclasses;     ///< Used to track of the maximum number of classes - see
+                      ///< RFC-17
+  int index;          ///< Index of layer within parent map's layers array
+  struct mapObj *map; ///< Reference to parent map
+  int numitems;       ///< Number of layer feature attributes (items)
+  hashTableObj metadata;   ///< See :ref:`METADATA <mapfile-layer-metadata>`
+  hashTableObj validation; ///< See :ref:`VALIDATION <mapfile-layer-validation>`
+  hashTableObj bindvals;   ///< Relates to RFC59
+  hashTableObj connectionoptions; ///< See :ref:`CONNECTIONOPTIONS
+                                  ///< <mapfile-layer-connectionoptions>`
+
+  clusterObj cluster; ///< See :ref:`CLUSTER <mapfile-layer-cluster>`
+  rectObj extent;     ///< optional limiting extent for layer features - see
+                      ///< :ref:`EXTENT <mapfile-layer-extent>`
+  int numprocessing;  ///< Number of raster processing directives
+  int numjoins;       ///< Number of layer joins
+
+  expressionObj utfdata; ///< See :ref:`UTFDATA <mapfile-layer-utfdata>`
+  LayerCompositer
+      *compositer; ///< See :ref:`COMPOSITE <mapfile-layer-composite>`
 
 #ifdef SWIG
     %mutable;
 #endif /* SWIG */
 
-    char *classitem; ///< the attribute used to classify layer data - see :ref:`CLASSITEM <mapfile-layer-classitem>`
-    char *header; ///< filename to a template for result's header - see :ref:`HEADER <mapfile-layer-header>`
-    char *footer; ///< filename to a template for result's footer - see :ref:`FOOTER <mapfile-layer-footer>`
+  char *classitem; ///< the attribute used to classify layer data - see
+                   ///< :ref:`CLASSITEM <mapfile-layer-classitem>`
+  char *header;    ///< filename to a template for result's header - see
+                   ///< :ref:`HEADER <mapfile-layer-header>`
+  char *footer;    ///< filename to a template for result's footer - see
+                   ///< :ref:`FOOTER <mapfile-layer-footer>`
 
 #ifndef __cplusplus
-    char *template; ///< See :ref:`TEMPLATE <mapfile-layer-template>` - global template, used across all classes
-#else /* __cplusplus */
-    char *_template;
-#endif /* __cplusplus */
-
-    char *name; ///< See :ref:`NAME <mapfile-layer-name>` - should be unique
-    char *group; ///< Name of a group of layers - see :ref:`GROUP <mapfile-layer-group>`
-    int status; ///< See :ref:`STATUS <mapfile-layer-status>`:data:`MS_ON`, :data:`MS_OFF` or :data:`MS_DEFAULT`
-    enum MS_RENDER_MODE rendermode; ///< :data:`MS_FIRST_MATCHING_CLASS` - default and historic MapServer behavior, :data:`MS_ALL_MATCHING_CLASSES` - SLD behavior
-    char *data; ///< Layer data definition, values depend upon connectiontype - see :ref:`DATA <mapfile-layer-data>`
-    enum MS_LAYER_TYPE type; ///< the layer type - see :ref:`TYPE <mapfile-layer-type>`
-    enum MS_CONNECTION_TYPE connectiontype; ///< the layer connection type - see :ref:`CONNECTIONTYPE <mapfile-layer-connectiontype>`
-
-    double tolerance; ///< search buffer for point and line queries (in toleranceunits) - see :ref:`TOLERANCE <mapfile-layer-tolerance>`
-    int toleranceunits; ///< See :ref:`TOLERANCEUNITS <mapfile-layer-toleranceunits>`
-
-    double symbolscaledenom; ///< scale at which symbols are default size - see :ref:`SYMBOLSCALEDENOM <mapfile-layer-symbolscaledenom>`
-    double minscaledenom; ///< Maximum scale at which layer will be drawn - see :ref:`MINSCALEDENOM <mapfile-layer-minscaledenom>`
-    double maxscaledenom; ///< Minimum scale at which layer will be drawn - see :ref:`MAXSCALEDENOM <mapfile-layer-maxscaledenom>`
-    int minfeaturesize; ///< minimum feature size (in pixels) for shape
-    double labelminscaledenom; ///< See :ref:`LABELMINSCALEDENOM <mapfile-layer-labelminscaledenom>`
-    double labelmaxscaledenom; ///< See :ref:`LABELMAXSCALEDENOM <mapfile-layer-labelmaxscaledenom>`
-    double mingeowidth; ///< min map width (in map units) at which the layer should be drawn - see :ref:`MAXGEOWIDTH <mapfile-layer-maxgeowidth>`
-    double maxgeowidth; ///< max map width (in map units) at which the layer should be drawn - see :ref:`MAXGEOWIDTH <mapfile-layer-maxgeowidth>`
-
-    int sizeunits; ///< applies to all classes - see :ref:`SIZEUNITS <mapfile-layer-sizeunits>`
-
-    int maxfeatures; ///< Maximum number of layer features that will be drawn - see :ref:`MAXFEATURES <mapfile-layer-maxfeatures>`
-    int startindex; ///< Feature start index - used for paging
-
-    colorObj offsite; ///< transparent pixel value for raster images - see :ref:`OFFSITE <mapfile-layer-offsite>`
-
-    /**
-    :data:`MS_TRUE` (default) or :data:`MS_FALSE` whether or not layer data is to be transformed to 
-    image units - see :ref:`TRANSFORM <mapfile-layer-transform>`
-    */
-    int transform;
-
-    int labelcache; ///< :data:`MS_ON` (default) or :data:`MS_OFF` - see :ref:`LABELCACHE <mapfile-layer-labelcache>`
-    int postlabelcache; ///< :data:`MS_ON` or :data:`MS_OFF` (default) - see :ref:`POSTLABELCACHE <mapfile-layer-postlabelcache>`
-
-    char *labelitem; ///< attribute defining feature label text - see :ref:`LABELITEM <mapfile-layer-labelitem>`
-    char *tileitem; ///< attribute defining tile paths - see :ref:`TILEITEM <mapfile-layer-tileitem>`
-    char *tileindex; ///< layer index file for tiling support - see :ref:`TILEINDEX <mapfile-layer-tileindex>`
-    char *tilesrs; ///< name of the attribute that contains the SRS of an individual tile - see :ref:`TILESRS <mapfile-layer-tilesrs>`
-    int units; ///< units of the layer - see :ref:`UNITS <mapfile-layer-units>`
-
-    char *connection; ///< layer connection or data source name - see :ref:`CONNECTION <mapfile-layer-connection>`
-    char *plugin_library; ///< Used to select the library to load by MapServer
-    char *plugin_library_original; ///< this is needed for Mapfile writing
-
-    /**
-    The attribute from the index file used to select the source raster band(s) to be 
-    used - normally NULL for default bands processing
-    */
-    char *bandsitem;
-
-    char *filteritem; ///< Attribute defining filter - see :ref:`FILTERITEM <mapfile-layer-filteritem>`
-    char *styleitem; ///< item to be used for style lookup - can also be 'AUTO' - see :ref:`STYLEITEM <mapfile-layer-styleitem>`
-
-    char *requires; ///< Context expressions, simple enough to not use expressionObj - see :ref:`REQUIRES <mapfile-layer-requires>`
-    char *labelrequires;  ///< Simple logical expression - see :ref:`LABELREQUIRES <mapfile-layer-labelrequires>`
-
-    int debug; ///< Enable debugging of layer-  :data:`MS_ON` or :data:`MS_OFF` (default) - see :ref:`DEBUG <mapfile-layer-debug>`
-    char *classgroup; ///< See :ref:`CLASSGROUP <mapfile-layer-classgroup>`
-    char *mask; ///< See :ref:`MASK <mapfile-layer-mask>`
-    char *encoding; ///< For iconving shape attributes, ignored if NULL or "utf-8" - see :ref:`ENCODING <mapfile-layer-encoding>`
-
-    /* RFC93 UTFGrid support */
-    char *utfitem; ///< See :ref:`UTFITEM <mapfile-layer-utfitem>`
-    int utfitemindex; ///< See :ref:`CLASSITEM <mapfile-layer-classitem>`
-  };
+  char *template; ///< See :ref:`TEMPLATE <mapfile-layer-template>` - global
+                  ///< template, used across all classes
+#else             /* __cplusplus */
+  char *_template;
+#endif            /* __cplusplus */
+
+  char *name;  ///< See :ref:`NAME <mapfile-layer-name>` - should be unique
+  char *group; ///< Name of a group of layers - see :ref:`GROUP
+               ///< <mapfile-layer-group>`
+  int status;  ///< See :ref:`STATUS <mapfile-layer-status>`:data:`MS_ON`,
+               ///< :data:`MS_OFF` or :data:`MS_DEFAULT`
+  enum MS_RENDER_MODE
+      rendermode; ///< :data:`MS_FIRST_MATCHING_CLASS` - default and historic
+                  ///< MapServer behavior, :data:`MS_ALL_MATCHING_CLASSES` - SLD
+                  ///< behavior
+  char *data; ///< Layer data definition, values depend upon connectiontype -
+              ///< see :ref:`DATA <mapfile-layer-data>`
+  enum MS_LAYER_TYPE
+      type; ///< the layer type - see :ref:`TYPE <mapfile-layer-type>`
+  enum MS_CONNECTION_TYPE
+      connectiontype; ///< the layer connection type - see :ref:`CONNECTIONTYPE
+                      ///< <mapfile-layer-connectiontype>`
+
+  double tolerance;   ///< search buffer for point and line queries (in
+                      ///< toleranceunits) - see :ref:`TOLERANCE
+                      ///< <mapfile-layer-tolerance>`
+  int toleranceunits; ///< See :ref:`TOLERANCEUNITS
+                      ///< <mapfile-layer-toleranceunits>`
+
+  double symbolscaledenom; ///< scale at which symbols are default size - see
+                           ///< :ref:`SYMBOLSCALEDENOM
+                           ///< <mapfile-layer-symbolscaledenom>`
+  double minscaledenom;    ///< Maximum scale at which layer will be drawn - see
+                        ///< :ref:`MINSCALEDENOM <mapfile-layer-minscaledenom>`
+  double maxscaledenom; ///< Minimum scale at which layer will be drawn - see
+                        ///< :ref:`MAXSCALEDENOM <mapfile-layer-maxscaledenom>`
+  int minfeaturesize;   ///< minimum feature size (in pixels) for shape
+  double labelminscaledenom; ///< See :ref:`LABELMINSCALEDENOM
+                             ///< <mapfile-layer-labelminscaledenom>`
+  double labelmaxscaledenom; ///< See :ref:`LABELMAXSCALEDENOM
+                             ///< <mapfile-layer-labelmaxscaledenom>`
+  double mingeowidth; ///< min map width (in map units) at which the layer
+                      ///< should be drawn - see :ref:`MAXGEOWIDTH
+                      ///< <mapfile-layer-maxgeowidth>`
+  double maxgeowidth; ///< max map width (in map units) at which the layer
+                      ///< should be drawn - see :ref:`MAXGEOWIDTH
+                      ///< <mapfile-layer-maxgeowidth>`
+
+  int sizeunits; ///< applies to all classes - see :ref:`SIZEUNITS
+                 ///< <mapfile-layer-sizeunits>`
+
+  int maxfeatures; ///< Maximum number of layer features that will be drawn -
+                   ///< see :ref:`MAXFEATURES <mapfile-layer-maxfeatures>`
+  int startindex;  ///< Feature start index - used for paging
+
+  colorObj offsite; ///< transparent pixel value for raster images - see
+                    ///< :ref:`OFFSITE <mapfile-layer-offsite>`
+
+  /**
+  :data:`MS_TRUE` (default) or :data:`MS_FALSE` whether or not layer data is to
+  be transformed to image units - see :ref:`TRANSFORM <mapfile-layer-transform>`
+  */
+  int transform;
+
+  int labelcache;     ///< :data:`MS_ON` (default) or :data:`MS_OFF` - see
+                      ///< :ref:`LABELCACHE <mapfile-layer-labelcache>`
+  int postlabelcache; ///< :data:`MS_ON` or :data:`MS_OFF` (default) - see
+                      ///< :ref:`POSTLABELCACHE <mapfile-layer-postlabelcache>`
+
+  char *labelitem; ///< attribute defining feature label text - see
+                   ///< :ref:`LABELITEM <mapfile-layer-labelitem>`
+  char *tileitem;  ///< attribute defining tile paths - see :ref:`TILEITEM
+                   ///< <mapfile-layer-tileitem>`
+  char *tileindex; ///< layer index file for tiling support - see
+                   ///< :ref:`TILEINDEX <mapfile-layer-tileindex>`
+  char *
+      tilesrs; ///< name of the attribute that contains the SRS of an individual
+               ///< tile - see :ref:`TILESRS <mapfile-layer-tilesrs>`
+  int units;   ///< units of the layer - see :ref:`UNITS <mapfile-layer-units>`
+
+  char *connection;     ///< layer connection or data source name - see
+                        ///< :ref:`CONNECTION <mapfile-layer-connection>`
+  char *plugin_library; ///< Used to select the library to load by MapServer
+  char *plugin_library_original; ///< this is needed for Mapfile writing
 
+  /**
+  The attribute from the index file used to select the source raster band(s) to
+  be used - normally NULL for default bands processing
+  */
+  char *bandsitem;
+
+  char *filteritem; ///< Attribute defining filter - see :ref:`FILTERITEM
+                    ///< <mapfile-layer-filteritem>`
+  char *styleitem;  ///< item to be used for style lookup - can also be 'AUTO' -
+                    ///< see :ref:`STYLEITEM <mapfile-layer-styleitem>`
+
+  char *
+    requires; ///< Context expressions, simple enough to not use expressionObj -
+              ///< see :ref:`REQUIRES <mapfile-layer-requires>`
+  char *labelrequires; ///< Simple logical expression - see :ref:`LABELREQUIRES
+                       ///< <mapfile-layer-labelrequires>`
+
+  int debug; ///< Enable debugging of layer-  :data:`MS_ON` or :data:`MS_OFF`
+             ///< (default) - see :ref:`DEBUG <mapfile-layer-debug>`
+  char *classgroup; ///< See :ref:`CLASSGROUP <mapfile-layer-classgroup>`
+  char *mask;       ///< See :ref:`MASK <mapfile-layer-mask>`
+  char *encoding; ///< For iconving shape attributes, ignored if NULL or "utf-8"
+                  ///< - see :ref:`ENCODING <mapfile-layer-encoding>`
+
+  /* RFC93 UTFGrid support */
+  char *utfitem;    ///< See :ref:`UTFITEM <mapfile-layer-utfitem>`
+  int utfitemindex; ///< See :ref:`CLASSITEM <mapfile-layer-classitem>`
+};
 
 #ifndef SWIG
 void msFontCacheSetup();
 void msFontCacheCleanup();
 
 typedef struct {
-  double minx,miny,maxx,maxy,advance;
+  double minx, miny, maxx, maxy, advance;
 } glyph_metrics;
 
 typedef struct {
@@ -1898,12 +2346,13 @@ typedef struct {
   double rot;
 } glyphObj;
 
-struct textPathObj{
+struct textPathObj {
   int numglyphs;
   int numlines;
   int line_height;
   int glyph_size;
-  int absolute; /* are the glyph positions absolutely placed, or relative to the origin */
+  int absolute; /* are the glyph positions absolutely placed, or relative to the
+                   origin */
   glyphObj *glyphs;
   label_bounds bounds;
 };
@@ -1923,1379 +2372,1709 @@ void freeTextSymbol(textSymbolObj *ts);
 void freeTextSymbolEx(textSymbolObj *ts, int doFreeLabel);
 void copyLabelBounds(label_bounds *dst, label_bounds *src);
 void msCopyTextSymbol(textSymbolObj *dst, textSymbolObj *src);
-void msPopulateTextSymbolForLabelAndString(textSymbolObj *ts, labelObj *l, char *string, double scalefactor, double resolutionfactor, label_cache_mode cache);
+void msPopulateTextSymbolForLabelAndString(textSymbolObj *ts, labelObj *l,
+                                           char *string, double scalefactor,
+                                           double resolutionfactor,
+                                           label_cache_mode cache);
 #endif /* SWIG */
 
+/************************************************************************/
+/*                                mapObj                                */
+/*                                                                      */
+/*      encompasses everything used in an Internet mapping              */
+/*      application.                                                    */
+/************************************************************************/
 
-  /************************************************************************/
-  /*                                mapObj                                */
-  /*                                                                      */
-  /*      encompasses everything used in an Internet mapping              */
-  /*      application.                                                    */
-  /************************************************************************/
+#define MS_RESOLUTION_MAX 1000 /* applies to resolution and defresolution */
+#define MS_RESOLUTION_MIN 10
 
-  #define MS_RESOLUTION_MAX 1000 /* applies to resolution and defresolution */
-  #define MS_RESOLUTION_MIN 10
-
-  /**
-  The :ref:`MAP <map>` object
-  */
-  struct mapObj { /* structure for a map */
+/**
+The :ref:`MAP <map>` object
+*/
+struct mapObj { /* structure for a map */
 
 #ifndef SWIG
-      layerObj **layers;
-      geotransformObj gt; /* rotation / geotransform */
-      rectObj saved_extent;
-      paletteObj palette; /* holds a map palette */
-      outputFormatObj **outputformatlist;
-      projectionObj projection; /* projection information for output map */
-      projectionObj latlon; /* geographic projection definition */
-
-      /* Private encryption key information - see mapcrypto.c */
-      int encryption_key_loaded;        /* MS_TRUE once key has been loaded */
-      unsigned char encryption_key[MS_ENCRYPTION_KEY_SIZE]; /* 128bits encryption key */
-      queryObj query;
-      projectionContext* projContext;
+  layerObj **layers;
+  geotransformObj gt; /* rotation / geotransform */
+  rectObj saved_extent;
+  paletteObj palette; /* holds a map palette */
+  outputFormatObj **outputformatlist;
+  projectionObj projection; /* projection information for output map */
+  projectionObj latlon;     /* geographic projection definition */
+
+  /* Private encryption key information - see mapcrypto.c */
+  int encryption_key_loaded; /* MS_TRUE once key has been loaded */
+  unsigned char
+      encryption_key[MS_ENCRYPTION_KEY_SIZE]; /* 128bits encryption key */
+  queryObj query;
+  projectionContext *projContext;
 
 #endif /* SWIG */
 
 #ifdef SWIG
       %immutable;
-#endif /* SWIG */
-      int refcount; ///< Used for reference counting see RFC24
-      int numlayers; ///< Number of layers in mapfile
-      int maxlayers; ///< Allocated size of layers[] array
-
-      /**
-      A hash table of configuration options from CONFIG keywords 
-      in the map - see :ref:`CONFIG <mapfile-map-config>`
-      */
-      hashTableObj configoptions;
+#endif           /* SWIG */
+  int refcount;  ///< Used for reference counting see RFC24
+  int numlayers; ///< Number of layers in mapfile
+  int maxlayers; ///< Allocated size of layers[] array
 
-      symbolSetObj symbolset; ///< See :ref:`SYMBOLSET <mapfile-map-symbolset>`
-      fontSetObj fontset; ///< See :ref:`FONTSET <mapfile-map-fontset>`
+  /**
+  A hash table of configuration options from CONFIG keywords
+  in the map - see :ref:`CONFIG <mapfile-map-config>`
+  */
+  hashTableObj configoptions;
+
+  symbolSetObj symbolset; ///< See :ref:`SYMBOLSET <mapfile-map-symbolset>`
+  fontSetObj fontset;     ///< See :ref:`FONTSET <mapfile-map-fontset>`
 
-      labelCacheObj labelcache; ///< We need this here so multiple feature processors can access it
-      int numoutputformats; ///< Number of output formats available in the map
-      outputFormatObj *outputformat; ///< See :ref:`OUTPUTFORMAT <mapfile-map-outputformat>`
-      char *imagetype; ///< Name of current outputformat
-
-      referenceMapObj reference; ///< See :ref:`SCALEBAR <mapfile-map-scalebar>`
-      scalebarObj scalebar; ///< See :ref:`SCALEBAR <mapfile-map-scalebar>`
-      legendObj legend; ///< See :ref:`LEGEND <mapfile-map-legend>`
-      queryMapObj querymap; ///< See :ref:`QUERYMAP <mapfile-map-querymap>`
-      webObj web; ///< See :ref:`WEB <mapfile-map-web>`
+  labelCacheObj labelcache; ///< We need this here so multiple feature
+                            ///< processors can access it
+  int numoutputformats;     ///< Number of output formats available in the map
+  outputFormatObj
+      *outputformat; ///< See :ref:`OUTPUTFORMAT <mapfile-map-outputformat>`
+  char *imagetype;   ///< Name of current outputformat
+
+  referenceMapObj reference; ///< See :ref:`SCALEBAR <mapfile-map-scalebar>`
+  scalebarObj scalebar;      ///< See :ref:`SCALEBAR <mapfile-map-scalebar>`
+  legendObj legend;          ///< See :ref:`LEGEND <mapfile-map-legend>`
+  queryMapObj querymap;      ///< See :ref:`QUERYMAP <mapfile-map-querymap>`
+  webObj web;                ///< See :ref:`WEB <mapfile-map-web>`
 
-      const configObj *config;
+  const configObj *config;
 #ifdef SWIG
     %mutable;
 #endif /* SWIG */
 
-    char *datapattern; ///< TODO - Deprecated use VALIDATION ... END block instead
-    char *templatepattern; ///< TODO - Deprecated use VALIDATION ... END block instead
-
-    char *name; ///< Small identifier for naming etc - see :ref:`NAME <mapfile-map-name>`
-    int status;  ///< Is map creation on or off - see :ref:`STATUS <mapfile-map-status>`
-    int height; ///< See :ref:`SIZE <mapfile-map-size>`
-    int width; ///< See :ref:`SIZE <mapfile-map-size>`
-    int maxsize; ///< See :ref:`MAXSIZE  <mapfile-map-maxsize>`
-
-    rectObj extent; ///< Map extent array - see :ref:`EXTENT <mapfile-map-extent>`
-    double cellsize; ///< Pixel size in map units
-
-    enum MS_UNITS units; ///< Units of the projection - see :ref:`UNITS <mapfile-map-units>`
-    double scaledenom; ///< The nominal map scale, a value of 25000 means 1:25000 scale - see :ref:`SCALEDENOM  <mapfile-map-scaledenom>`
-    double resolution; ///< See :ref:`RESOLUTION <mapfile-map-resolution>`
-    double defresolution; ///< Default resolution - used to calculate the scalefactor, see :ref:`DEFRESOLUTION <mapfile-map-defresolution>`
-
-    char *shapepath; ///< Where are the shape files located - see :ref:`SHAPEPATH <mapfile-map-shapepath>`
-    char *mappath; ///< Path of the mapfile, all paths are relative to this path
-
-    /**
-    URL of SLD document as specified with "&SLD=..." WMS parameter d- currently this reference is 
-    used only in mapogcsld.c and has a NULL value outside that context
-    */
-    char *sldurl;
-
-    colorObj imagecolor; ///< Holds the initial image color value - see :ref:`IMAGECOLOR <mapfile-map-imagecolor>`
+  char *datapattern; ///< TODO - Deprecated use VALIDATION ... END block instead
+  char *templatepattern; ///< TODO - Deprecated use VALIDATION ... END block
+                         ///< instead
+
+  char *name;  ///< Small identifier for naming etc - see :ref:`NAME
+               ///< <mapfile-map-name>`
+  int status;  ///< Is map creation on or off - see :ref:`STATUS
+               ///< <mapfile-map-status>`
+  int height;  ///< See :ref:`SIZE <mapfile-map-size>`
+  int width;   ///< See :ref:`SIZE <mapfile-map-size>`
+  int maxsize; ///< See :ref:`MAXSIZE  <mapfile-map-maxsize>`
+
+  rectObj extent; ///< Map extent array - see :ref:`EXTENT <mapfile-map-extent>`
+  double cellsize; ///< Pixel size in map units
+
+  enum MS_UNITS
+      units; ///< Units of the projection - see :ref:`UNITS <mapfile-map-units>`
+  double scaledenom; ///< The nominal map scale, a value of 25000 means 1:25000
+                     ///< scale - see :ref:`SCALEDENOM <mapfile-map-scaledenom>`
+  double resolution; ///< See :ref:`RESOLUTION <mapfile-map-resolution>`
+  double defresolution; ///< Default resolution - used to calculate the
+                        ///< scalefactor, see :ref:`DEFRESOLUTION
+                        ///< <mapfile-map-defresolution>`
+
+  char *shapepath; ///< Where are the shape files located - see :ref:`SHAPEPATH
+                   ///< <mapfile-map-shapepath>`
+  char *mappath;   ///< Path of the mapfile, all paths are relative to this path
 
-    int *layerorder; ///< Used to modify the order in which the layers are drawn - TODO should be immutable?
-    int debug; ///< See :ref:`DEBUG <mapfile-map-debug>`
+  /**
+  URL of SLD document as specified with "&SLD=..." WMS parameter d- currently
+  this reference is used only in mapogcsld.c and has a NULL value outside that
+  context
+  */
+  char *sldurl;
+
+  colorObj imagecolor; ///< Holds the initial image color value - see
+                       ///< :ref:`IMAGECOLOR <mapfile-map-imagecolor>`
+
+  int *layerorder; ///< Used to modify the order in which the layers are drawn -
+                   ///< TODO should be immutable?
+  int debug;       ///< See :ref:`DEBUG <mapfile-map-debug>`
 
 #ifdef USE_V8_MAPSCRIPT
-    void *v8context;
+  void *v8context;
 #endif
+};
 
-  };
-
-  /************************************************************************/
-  /*                             layerVTable                              */
-  /*                                                                      */
-  /*      contains function pointers to the layer operations.  If you     */
-  /*      add new functions to here, remember to update                   */
-  /*      populateVirtualTable in maplayer.c                              */
-  /************************************************************************/
-#ifndef SWIG
-  struct layerVTable {
-    int (*LayerTranslateFilter)(layerObj *layer, expressionObj *filter, char *filteritem);
-    int (*LayerSupportsCommonFilters)(layerObj *layer);
-    int (*LayerInitItemInfo)(layerObj *layer);
-    void (*LayerFreeItemInfo)(layerObj *layer);
-    int (*LayerOpen)(layerObj *layer);
-    int (*LayerIsOpen)(layerObj *layer);
-    int (*LayerWhichShapes)(layerObj *layer, rectObj rect, int isQuery);
-    int (*LayerNextShape)(layerObj *layer, shapeObj *shape);
-    int (*LayerGetShape)(layerObj *layer, shapeObj *shape, resultObj *record);
-    int (*LayerGetShapeCount)(layerObj *layer, rectObj rect, projectionObj *rectProjection);
-    int (*LayerClose)(layerObj *layer);
-    int (*LayerGetItems)(layerObj *layer);
-    int (*LayerGetExtent)(layerObj *layer, rectObj *extent);
-    int (*LayerGetAutoStyle)(mapObj *map, layerObj *layer, classObj *c, shapeObj *shape);
-    int (*LayerCloseConnection)(layerObj *layer);
-    int (*LayerSetTimeFilter)(layerObj *layer, const char *timestring, const char *timefield);
-    int (*LayerApplyFilterToLayer)(FilterEncodingNode *psNode, mapObj *map, int iLayerIndex);
-    int (*LayerCreateItems)(layerObj *layer, int nt);
-    int (*LayerGetNumFeatures)(layerObj *layer);
-    int (*LayerGetAutoProjection)(layerObj *layer, projectionObj *projection);
-    char* (*LayerEscapeSQLParam)(layerObj *layer, const char* pszString);
-    char* (*LayerEscapePropertyName)(layerObj *layer, const char* pszString);
-    void (*LayerEnablePaging)(layerObj *layer, int value);
-    int (*LayerGetPaging)(layerObj *layer);
-  };
+/************************************************************************/
+/*                             layerVTable                              */
+/*                                                                      */
+/*      contains function pointers to the layer operations.  If you     */
+/*      add new functions to here, remember to update                   */
+/*      populateVirtualTable in maplayer.c                              */
+/************************************************************************/
+#ifndef SWIG
+struct layerVTable {
+  int (*LayerTranslateFilter)(layerObj *layer, expressionObj *filter,
+                              char *filteritem);
+  int (*LayerSupportsCommonFilters)(layerObj *layer);
+  int (*LayerInitItemInfo)(layerObj *layer);
+  void (*LayerFreeItemInfo)(layerObj *layer);
+  int (*LayerOpen)(layerObj *layer);
+  int (*LayerIsOpen)(layerObj *layer);
+  int (*LayerWhichShapes)(layerObj *layer, rectObj rect, int isQuery);
+  int (*LayerNextShape)(layerObj *layer, shapeObj *shape);
+  int (*LayerGetShape)(layerObj *layer, shapeObj *shape, resultObj *record);
+  int (*LayerGetShapeCount)(layerObj *layer, rectObj rect,
+                            projectionObj *rectProjection);
+  int (*LayerClose)(layerObj *layer);
+  int (*LayerGetItems)(layerObj *layer);
+  int (*LayerGetExtent)(layerObj *layer, rectObj *extent);
+  int (*LayerGetAutoStyle)(mapObj *map, layerObj *layer, classObj *c,
+                           shapeObj *shape);
+  int (*LayerCloseConnection)(layerObj *layer);
+  int (*LayerSetTimeFilter)(layerObj *layer, const char *timestring,
+                            const char *timefield);
+  int (*LayerApplyFilterToLayer)(FilterEncodingNode *psNode, mapObj *map,
+                                 int iLayerIndex);
+  int (*LayerCreateItems)(layerObj *layer, int nt);
+  int (*LayerGetNumFeatures)(layerObj *layer);
+  int (*LayerGetAutoProjection)(layerObj *layer, projectionObj *projection);
+  char *(*LayerEscapeSQLParam)(layerObj *layer, const char *pszString);
+  char *(*LayerEscapePropertyName)(layerObj *layer, const char *pszString);
+  void (*LayerEnablePaging)(layerObj *layer, int value);
+  int (*LayerGetPaging)(layerObj *layer);
+};
 #endif /*SWIG*/
 
-  /* Function prototypes, wrapable */
+/* Function prototypes, wrapable */
 
-  /**
-  Saves a map image to a file
-  */
-  MS_DLL_EXPORT int msSaveImage(mapObj *map, imageObj *img, const char *filename); 
+/**
+Saves a map image to a file
+*/
+MS_DLL_EXPORT int msSaveImage(mapObj *map, imageObj *img, const char *filename);
 
-  /**
-  Generic function to free a imageObj
-  */
-  MS_DLL_EXPORT void msFreeImage(imageObj *img);
+/**
+Generic function to free a imageObj
+*/
+MS_DLL_EXPORT void msFreeImage(imageObj *img);
 
-  /**
-  Sets up threads and font cache - called when MapScript is initialised
-  */
-  MS_DLL_EXPORT int msSetup(void);
+/**
+Sets up threads and font cache - called when MapScript is initialised
+*/
+MS_DLL_EXPORT int msSetup(void);
 
-  /**
-  Attempts to recover all dynamically allocated resources allocated by MapServer code and
-  dependent libraries. It is used primarily for final clean-up in scripts that need to do
-  memory leak testing to get rid of "noise" one-time allocations.
-  It should not normally be used by production code.
-  */
-  MS_DLL_EXPORT void msCleanup(void);
+/**
+Attempts to recover all dynamically allocated resources allocated by MapServer
+code and dependent libraries. It is used primarily for final clean-up in scripts
+that need to do memory leak testing to get rid of "noise" one-time allocations.
+It should not normally be used by production code.
+*/
+MS_DLL_EXPORT void msCleanup(void);
 
-  /**
-  Sets up string-based mapfile loading and calls loadMapInternal to do the work
-  */
-  MS_DLL_EXPORT mapObj *msLoadMapFromString(char *buffer, char *new_mappath, const configObj* config);
+/**
+Sets up string-based mapfile loading and calls loadMapInternal to do the work
+*/
+MS_DLL_EXPORT mapObj *msLoadMapFromString(char *buffer, char *new_mappath,
+                                          const configObj *config);
 
-  /* Function prototypes, not wrapable */
+/* Function prototypes, not wrapable */
 
 #ifndef SWIG
 
-  /*
-  ** helper functions not part of the general API but needed in
-  ** a few other places (like mapscript)... found in mapfile.c
-  */
-  int getString(char **s);
-  int getDouble(double *d, int num_check_type, double value1, double value2); // getDouble(double *d);
-  int getInteger(int *i, int num_check_type, int value1, int value2); // getInteger(int *i);
-  int getSymbol(int n, ...);
-  int getCharacter(char *c);
-
-  int msBuildPluginLibraryPath(char **dest, const char *lib_str, mapObj *map);
-
-  MS_DLL_EXPORT int  hex2int(char *hex);
-
-  MS_DLL_EXPORT void initJoin(joinObj *join);
-  MS_DLL_EXPORT void initSymbol(symbolObj *s);
-  MS_DLL_EXPORT int initMap(mapObj *map);
-  MS_DLL_EXPORT layerObj *msGrowMapLayers( mapObj *map );
-  MS_DLL_EXPORT int initLayer(layerObj *layer, mapObj *map);
-  MS_DLL_EXPORT int freeLayer( layerObj * );
-  MS_DLL_EXPORT classObj *msGrowLayerClasses( layerObj *layer );
-  MS_DLL_EXPORT scaleTokenObj *msGrowLayerScaletokens( layerObj *layer );
-  MS_DLL_EXPORT int initScaleToken(scaleTokenObj *scaleToken);
-  MS_DLL_EXPORT int initClass(classObj *_class);
-  MS_DLL_EXPORT int freeClass( classObj * );
-  MS_DLL_EXPORT styleObj *msGrowClassStyles( classObj *_class );
-  MS_DLL_EXPORT labelObj *msGrowClassLabels( classObj *_class );
-  MS_DLL_EXPORT styleObj *msGrowLabelStyles( labelObj *label );
-  MS_DLL_EXPORT styleObj *msGrowLeaderStyles( labelLeaderObj *leader );
-  MS_DLL_EXPORT int msMaybeAllocateClassStyle(classObj* c, int idx);
-  MS_DLL_EXPORT void initLabel(labelObj *label);
-  MS_DLL_EXPORT int  freeLabel(labelObj *label);
-  MS_DLL_EXPORT int  freeLabelLeader(labelLeaderObj *leader);
-  MS_DLL_EXPORT void resetClassStyle(classObj *_class);
-  MS_DLL_EXPORT int initStyle(styleObj *style);
-  MS_DLL_EXPORT int freeStyle(styleObj *style);
-  MS_DLL_EXPORT void initReferenceMap(referenceMapObj *ref);
-  MS_DLL_EXPORT void initScalebar(scalebarObj *scalebar);
-  MS_DLL_EXPORT void initGrid( graticuleObj *pGraticule );
-  MS_DLL_EXPORT void initWeb(webObj *web);
-  MS_DLL_EXPORT void freeWeb(webObj *web);
-  MS_DLL_EXPORT void initResultCache(resultCacheObj *resultcache);
-  void cleanupResultCache(resultCacheObj *resultcache);
-  MS_DLL_EXPORT int initLayerCompositer(LayerCompositer *compositer);
-  MS_DLL_EXPORT void initLeader(labelLeaderObj *leader);
-  MS_DLL_EXPORT void freeGrid( graticuleObj *pGraticule);
-  int loadHashTable(hashTableObj *ptable); // used by other file loading code
-
-  MS_DLL_EXPORT featureListNodeObjPtr insertFeatureList(featureListNodeObjPtr *list, shapeObj *shape);
-  MS_DLL_EXPORT void freeFeatureList(featureListNodeObjPtr list);
-
-  /* To be used *only* within the mapfile loading phase */
-  MS_DLL_EXPORT int loadExpressionString(expressionObj *exp, char *value);
-  /* Use this next, thread safe wrapper, function everywhere else */
-  MS_DLL_EXPORT int msLoadExpressionString(expressionObj *exp, char *value);
-  MS_DLL_EXPORT char *msGetExpressionString(expressionObj *exp);
-  MS_DLL_EXPORT void msInitExpression(expressionObj *exp);
-  MS_DLL_EXPORT void msFreeExpressionTokens(expressionObj *exp);
-  MS_DLL_EXPORT void msFreeExpression(expressionObj *exp);
-
-  MS_DLL_EXPORT void msApplySubstitutions(mapObj *map, char **names, char **values, int npairs);
-  MS_DLL_EXPORT void msApplyDefaultSubstitutions(mapObj *map);
-
-  MS_DLL_EXPORT int getClassIndex(layerObj *layer, char *str);
-
-  /* For maplabel */
-  int intersectLabelPolygons(lineObj *p1, rectObj *r1, lineObj *p2, rectObj *r2);
-  int intersectTextSymbol(textSymbolObj *ts, label_bounds *lb);
-  pointObj get_metrics(pointObj *p, int position, textPathObj *tp, int ox, int oy, double rotation, int buffer, label_bounds *metrics);
-  double dist(pointObj a, pointObj b);
-  void fastComputeBounds(lineObj *line, rectObj *bounds);
-
-  /*
-  ** Main API Functions
-  */
-
-  /* mapobject.c */
+/*
+** helper functions not part of the general API but needed in
+** a few other places (like mapscript)... found in mapfile.c
+*/
+int getString(char **s);
+int getDouble(double *d, int num_check_type, double value1,
+              double value2); // getDouble(double *d);
+int getInteger(int *i, int num_check_type, int value1,
+               int value2); // getInteger(int *i);
+int getSymbol(int n, ...);
+int getCharacter(char *c);
+
+int msBuildPluginLibraryPath(char **dest, const char *lib_str, mapObj *map);
+
+MS_DLL_EXPORT int hex2int(char *hex);
+
+MS_DLL_EXPORT void initJoin(joinObj *join);
+MS_DLL_EXPORT void initSymbol(symbolObj *s);
+MS_DLL_EXPORT int initMap(mapObj *map);
+MS_DLL_EXPORT layerObj *msGrowMapLayers(mapObj *map);
+MS_DLL_EXPORT int initLayer(layerObj *layer, mapObj *map);
+MS_DLL_EXPORT int freeLayer(layerObj *);
+MS_DLL_EXPORT classObj *msGrowLayerClasses(layerObj *layer);
+MS_DLL_EXPORT scaleTokenObj *msGrowLayerScaletokens(layerObj *layer);
+MS_DLL_EXPORT int initScaleToken(scaleTokenObj *scaleToken);
+MS_DLL_EXPORT int initClass(classObj *_class);
+MS_DLL_EXPORT int freeClass(classObj *);
+MS_DLL_EXPORT styleObj *msGrowClassStyles(classObj *_class);
+MS_DLL_EXPORT labelObj *msGrowClassLabels(classObj *_class);
+MS_DLL_EXPORT styleObj *msGrowLabelStyles(labelObj *label);
+MS_DLL_EXPORT styleObj *msGrowLeaderStyles(labelLeaderObj *leader);
+MS_DLL_EXPORT int msMaybeAllocateClassStyle(classObj *c, int idx);
+MS_DLL_EXPORT void initLabel(labelObj *label);
+MS_DLL_EXPORT int freeLabel(labelObj *label);
+MS_DLL_EXPORT int freeLabelLeader(labelLeaderObj *leader);
+MS_DLL_EXPORT void resetClassStyle(classObj *_class);
+MS_DLL_EXPORT int initStyle(styleObj *style);
+MS_DLL_EXPORT int freeStyle(styleObj *style);
+MS_DLL_EXPORT void initReferenceMap(referenceMapObj *ref);
+MS_DLL_EXPORT void initScalebar(scalebarObj *scalebar);
+MS_DLL_EXPORT void initGrid(graticuleObj *pGraticule);
+MS_DLL_EXPORT void initWeb(webObj *web);
+MS_DLL_EXPORT void freeWeb(webObj *web);
+MS_DLL_EXPORT void initResultCache(resultCacheObj *resultcache);
+void cleanupResultCache(resultCacheObj *resultcache);
+MS_DLL_EXPORT int initLayerCompositer(LayerCompositer *compositer);
+MS_DLL_EXPORT void initLeader(labelLeaderObj *leader);
+MS_DLL_EXPORT void freeGrid(graticuleObj *pGraticule);
+int loadHashTable(hashTableObj *ptable); // used by other file loading code
+
+MS_DLL_EXPORT featureListNodeObjPtr
+insertFeatureList(featureListNodeObjPtr *list, shapeObj *shape);
+MS_DLL_EXPORT void freeFeatureList(featureListNodeObjPtr list);
+
+/* To be used *only* within the mapfile loading phase */
+MS_DLL_EXPORT int loadExpressionString(expressionObj *exp, char *value);
+/* Use this next, thread safe wrapper, function everywhere else */
+MS_DLL_EXPORT int msLoadExpressionString(expressionObj *exp, char *value);
+MS_DLL_EXPORT char *msGetExpressionString(expressionObj *exp);
+MS_DLL_EXPORT void msInitExpression(expressionObj *exp);
+MS_DLL_EXPORT void msFreeExpressionTokens(expressionObj *exp);
+MS_DLL_EXPORT void msFreeExpression(expressionObj *exp);
+
+MS_DLL_EXPORT void msApplySubstitutions(mapObj *map, char **names,
+                                        char **values, int npairs);
+MS_DLL_EXPORT void msApplyDefaultSubstitutions(mapObj *map);
+
+MS_DLL_EXPORT int getClassIndex(layerObj *layer, char *str);
+
+/* For maplabel */
+int intersectLabelPolygons(lineObj *p1, rectObj *r1, lineObj *p2, rectObj *r2);
+int intersectTextSymbol(textSymbolObj *ts, label_bounds *lb);
+pointObj get_metrics(pointObj *p, int position, textPathObj *tp, int ox, int oy,
+                     double rotation, int buffer, label_bounds *metrics);
+double dist(pointObj a, pointObj b);
+void fastComputeBounds(lineObj *line, rectObj *bounds);
 
-  MS_DLL_EXPORT void msFreeMap(mapObj *map);
-  MS_DLL_EXPORT mapObj *msNewMapObj(void);
-  MS_DLL_EXPORT const char *msGetConfigOption( mapObj *map, const char *key);
-  MS_DLL_EXPORT int msSetConfigOption( mapObj *map, const char *key, const char *value);
-  MS_DLL_EXPORT int msTestConfigOption( mapObj *map, const char *key,
-                                        int default_result );
-  MS_DLL_EXPORT void msApplyMapConfigOptions( mapObj *map );
-  MS_DLL_EXPORT int msMapComputeGeotransform( mapObj *map );
-  int msMapComputeGeotransformEx( mapObj * map, double resolutionX, double resolutionY );
+/*
+** Main API Functions
+*/
 
-  MS_DLL_EXPORT void msMapPixelToGeoref( mapObj *map, double *x, double *y );
-  MS_DLL_EXPORT void msMapGeorefToPixel( mapObj *map, double *x, double *y );
+/* mapobject.c */
 
-  MS_DLL_EXPORT int msMapSetExtent(mapObj *map, double minx, double miny,
-                                   double maxx, double maxy);
-  MS_DLL_EXPORT int msMapOffsetExtent( mapObj *map, double x, double y);
-  MS_DLL_EXPORT int msMapScaleExtent( mapObj *map, double zoomfactor,
-                                      double minscaledenom, double maxscaledenom);
-  MS_DLL_EXPORT int msMapSetCenter( mapObj *map, pointObj *center);
-  MS_DLL_EXPORT int msMapSetRotation( mapObj *map, double rotation_angle );
-  MS_DLL_EXPORT int msMapSetSize( mapObj *map, int width, int height );
-  MS_DLL_EXPORT int msMapSetSize( mapObj *map, int width, int height );
-  MS_DLL_EXPORT int msMapSetFakedExtent( mapObj *map );
-  MS_DLL_EXPORT int msMapRestoreRealExtent( mapObj *map );
-  MS_DLL_EXPORT int msMapLoadOWSParameters( mapObj *map, cgiRequestObj *request,
-      const char *wmtver_string );
-  MS_DLL_EXPORT int msMapIgnoreMissingData( mapObj *map );
-
-  /* mapfile.c */
-
-  MS_DLL_EXPORT int msValidateParameter(const char *value, const char *pattern1, const char *pattern2, const char *pattern3, const char *pattern4);
-  MS_DLL_EXPORT int msGetLayerIndex(mapObj *map, const char *name);
-  MS_DLL_EXPORT int msGetSymbolIndex(symbolSetObj *set, char *name, int try_addimage_if_notfound);
-  MS_DLL_EXPORT mapObj  *msLoadMap(const char *filename, const char *new_mappath, const configObj *config);
-  MS_DLL_EXPORT int msTransformXmlMapfile(const char *stylesheet, const char *xmlMapfile, FILE *tmpfile);
-  MS_DLL_EXPORT int msSaveMap(mapObj *map, char *filename);
-  MS_DLL_EXPORT int msSaveConfig(configObj *map, const char *filename);
-  MS_DLL_EXPORT void msFreeCharArray(char **array, int num_items);
-  MS_DLL_EXPORT int msUpdateScalebarFromString(scalebarObj *scalebar, char *string);
-  MS_DLL_EXPORT int msUpdateQueryMapFromString(queryMapObj *querymap, char *string);
-  MS_DLL_EXPORT int msUpdateLabelFromString(labelObj *label, char *string);
-  MS_DLL_EXPORT int msUpdateClusterFromString(clusterObj *cluster, char *string);
-  MS_DLL_EXPORT int msUpdateReferenceMapFromString(referenceMapObj *ref, char *string);
-  MS_DLL_EXPORT int msUpdateLegendFromString(legendObj *legend, char *string);
-  MS_DLL_EXPORT int msUpdateWebFromString(webObj *web, char *string);
-  MS_DLL_EXPORT int msUpdateStyleFromString(styleObj *style, char *string);
-  MS_DLL_EXPORT int msUpdateClassFromString(classObj *_class, char *string);
-  MS_DLL_EXPORT int msUpdateLayerFromString(layerObj *layer, char *string);
-  MS_DLL_EXPORT char *msWriteLayerToString(layerObj *layer);
-  MS_DLL_EXPORT char *msWriteMapToString(mapObj *map);
-  MS_DLL_EXPORT char *msWriteClassToString(classObj *_class);
-  MS_DLL_EXPORT char *msWriteStyleToString(styleObj *style);
-  MS_DLL_EXPORT char *msWriteLabelToString(labelObj *label);
-  MS_DLL_EXPORT char *msWriteWebToString(webObj *web);
-  MS_DLL_EXPORT char *msWriteScalebarToString(scalebarObj *scalebar);
-  MS_DLL_EXPORT char *msWriteQueryMapToString(queryMapObj *querymap);
-  MS_DLL_EXPORT char *msWriteReferenceMapToString(referenceMapObj *ref);
-  MS_DLL_EXPORT char *msWriteLegendToString(legendObj *legend);
-  MS_DLL_EXPORT char *msWriteClusterToString(clusterObj *cluster);
-  MS_DLL_EXPORT int msIsValidRegex(const char* e);
-  MS_DLL_EXPORT int msEvalRegex(const char *e, const char *s);
-  MS_DLL_EXPORT int msCaseEvalRegex(const char *e, const char *s);
+MS_DLL_EXPORT void msFreeMap(mapObj *map);
+MS_DLL_EXPORT mapObj *msNewMapObj(void);
+MS_DLL_EXPORT const char *msGetConfigOption(mapObj *map, const char *key);
+MS_DLL_EXPORT int msSetConfigOption(mapObj *map, const char *key,
+                                    const char *value);
+MS_DLL_EXPORT int msTestConfigOption(mapObj *map, const char *key,
+                                     int default_result);
+MS_DLL_EXPORT void msApplyMapConfigOptions(mapObj *map);
+MS_DLL_EXPORT int msMapComputeGeotransform(mapObj *map);
+int msMapComputeGeotransformEx(mapObj *map, double resolutionX,
+                               double resolutionY);
+
+MS_DLL_EXPORT void msMapPixelToGeoref(mapObj *map, double *x, double *y);
+MS_DLL_EXPORT void msMapGeorefToPixel(mapObj *map, double *x, double *y);
+
+MS_DLL_EXPORT int msMapSetExtent(mapObj *map, double minx, double miny,
+                                 double maxx, double maxy);
+MS_DLL_EXPORT int msMapOffsetExtent(mapObj *map, double x, double y);
+MS_DLL_EXPORT int msMapScaleExtent(mapObj *map, double zoomfactor,
+                                   double minscaledenom, double maxscaledenom);
+MS_DLL_EXPORT int msMapSetCenter(mapObj *map, pointObj *center);
+MS_DLL_EXPORT int msMapSetRotation(mapObj *map, double rotation_angle);
+MS_DLL_EXPORT int msMapSetSize(mapObj *map, int width, int height);
+MS_DLL_EXPORT int msMapSetSize(mapObj *map, int width, int height);
+MS_DLL_EXPORT int msMapSetFakedExtent(mapObj *map);
+MS_DLL_EXPORT int msMapRestoreRealExtent(mapObj *map);
+MS_DLL_EXPORT int msMapLoadOWSParameters(mapObj *map, cgiRequestObj *request,
+                                         const char *wmtver_string);
+MS_DLL_EXPORT int msMapIgnoreMissingData(mapObj *map);
+
+/* mapfile.c */
+
+MS_DLL_EXPORT int msValidateParameter(const char *value, const char *pattern1,
+                                      const char *pattern2,
+                                      const char *pattern3,
+                                      const char *pattern4);
+MS_DLL_EXPORT int msGetLayerIndex(mapObj *map, const char *name);
+MS_DLL_EXPORT int msGetSymbolIndex(symbolSetObj *set, char *name,
+                                   int try_addimage_if_notfound);
+MS_DLL_EXPORT mapObj *msLoadMap(const char *filename, const char *new_mappath,
+                                const configObj *config);
+MS_DLL_EXPORT int msTransformXmlMapfile(const char *stylesheet,
+                                        const char *xmlMapfile, FILE *tmpfile);
+MS_DLL_EXPORT int msSaveMap(mapObj *map, char *filename);
+MS_DLL_EXPORT int msSaveConfig(configObj *map, const char *filename);
+MS_DLL_EXPORT void msFreeCharArray(char **array, int num_items);
+MS_DLL_EXPORT int msUpdateScalebarFromString(scalebarObj *scalebar,
+                                             char *string);
+MS_DLL_EXPORT int msUpdateQueryMapFromString(queryMapObj *querymap,
+                                             char *string);
+MS_DLL_EXPORT int msUpdateLabelFromString(labelObj *label, char *string);
+MS_DLL_EXPORT int msUpdateClusterFromString(clusterObj *cluster, char *string);
+MS_DLL_EXPORT int msUpdateReferenceMapFromString(referenceMapObj *ref,
+                                                 char *string);
+MS_DLL_EXPORT int msUpdateLegendFromString(legendObj *legend, char *string);
+MS_DLL_EXPORT int msUpdateWebFromString(webObj *web, char *string);
+MS_DLL_EXPORT int msUpdateStyleFromString(styleObj *style, char *string);
+MS_DLL_EXPORT int msUpdateClassFromString(classObj *_class, char *string);
+MS_DLL_EXPORT int msUpdateLayerFromString(layerObj *layer, char *string);
+MS_DLL_EXPORT char *msWriteLayerToString(layerObj *layer);
+MS_DLL_EXPORT char *msWriteMapToString(mapObj *map);
+MS_DLL_EXPORT char *msWriteClassToString(classObj *_class);
+MS_DLL_EXPORT char *msWriteStyleToString(styleObj *style);
+MS_DLL_EXPORT char *msWriteLabelToString(labelObj *label);
+MS_DLL_EXPORT char *msWriteWebToString(webObj *web);
+MS_DLL_EXPORT char *msWriteScalebarToString(scalebarObj *scalebar);
+MS_DLL_EXPORT char *msWriteQueryMapToString(queryMapObj *querymap);
+MS_DLL_EXPORT char *msWriteReferenceMapToString(referenceMapObj *ref);
+MS_DLL_EXPORT char *msWriteLegendToString(legendObj *legend);
+MS_DLL_EXPORT char *msWriteClusterToString(clusterObj *cluster);
+MS_DLL_EXPORT int msIsValidRegex(const char *e);
+MS_DLL_EXPORT int msEvalRegex(const char *e, const char *s);
+MS_DLL_EXPORT int msCaseEvalRegex(const char *e, const char *s);
 #ifdef USE_MSFREE
-  MS_DLL_EXPORT void msFree(void *p);
+MS_DLL_EXPORT void msFree(void *p);
 #else
 #define msFree free
 #endif
-  MS_DLL_EXPORT char **msTokenizeMap(char *filename, int *numtokens);
-  MS_DLL_EXPORT int msInitLabelCache(labelCacheObj *cache);
-  MS_DLL_EXPORT int msFreeLabelCache(labelCacheObj *cache);
-  MS_DLL_EXPORT int msCheckConnection(layerObj * layer); /* connection pooling functions (mapfile.c) */
-  MS_DLL_EXPORT void msCloseConnections(mapObj *map);
-
-  MS_DLL_EXPORT void msOGRInitialize(void);
-  MS_DLL_EXPORT void msOGRCleanup(void);
-  MS_DLL_EXPORT void msGDALCleanup(void);
-  MS_DLL_EXPORT void msGDALInitialize(void);
-
-  MS_DLL_EXPORT imageObj *msDrawScalebar(mapObj *map); /* in mapscale.c */
-  MS_DLL_EXPORT int msCalculateScale(rectObj extent, int units, int width, int height, double resolution, double *scaledenom);
-  MS_DLL_EXPORT double GetDeltaExtentsUsingScale(double scale, int units, double centerLat, int width, double resolution);
-  MS_DLL_EXPORT double Pix2Georef(int nPixPos, int nPixMin, int nPixMax, double dfGeoMin, double dfGeoMax, int bULisYOrig);
-  MS_DLL_EXPORT double Pix2LayerGeoref(mapObj *map, layerObj *layer, int value);
-  MS_DLL_EXPORT double msInchesPerUnit(int units, double center_lat);
-  MS_DLL_EXPORT int msEmbedScalebar(mapObj *map, imageObj *img);
-
-  MS_DLL_EXPORT int msPointInRect(const pointObj *p, const rectObj *rect); /* in mapsearch.c */
-  MS_DLL_EXPORT int msRectOverlap(const rectObj *a, const rectObj *b);
-  MS_DLL_EXPORT int msRectContained(const rectObj *a, const rectObj *b);
-  MS_DLL_EXPORT int msRectIntersect(rectObj *a, const rectObj *b);
-
-  MS_DLL_EXPORT void msRectToFormattedString(rectObj *rect, char *format,
-      char *buffer, int buffer_length);
-  MS_DLL_EXPORT void msPointToFormattedString(pointObj *point, const char*format,
-      char *buffer, int buffer_length);
-  MS_DLL_EXPORT int msIsDegenerateShape(shapeObj *shape);
-
-  MS_DLL_EXPORT void msMergeRect(rectObj *a, rectObj *b);
-  MS_DLL_EXPORT double msDistancePointToPoint(pointObj *a, pointObj *b);
-  MS_DLL_EXPORT double msSquareDistancePointToPoint(pointObj *a, pointObj *b);
-  MS_DLL_EXPORT double msDistancePointToSegment(pointObj *p, pointObj *a, pointObj *b);
-  MS_DLL_EXPORT double msSquareDistancePointToSegment(pointObj *p, pointObj *a, pointObj *b);
-  MS_DLL_EXPORT double msDistancePointToShape(pointObj *p, shapeObj *shape);
-  MS_DLL_EXPORT double msSquareDistancePointToShape(pointObj *p, shapeObj *shape);
-  MS_DLL_EXPORT double msDistanceSegmentToSegment(pointObj *pa, pointObj *pb, pointObj *pc, pointObj *pd);
-  MS_DLL_EXPORT double msDistanceShapeToShape(shapeObj *shape1, shapeObj *shape2);
-  MS_DLL_EXPORT int msIntersectSegments(const pointObj *a, const pointObj *b, const pointObj *c, const pointObj *d);
-  MS_DLL_EXPORT int msPointInPolygon(pointObj *p, lineObj *c);
-  MS_DLL_EXPORT int msIntersectMultipointPolygon(shapeObj *multipoint, shapeObj *polygon);
-  MS_DLL_EXPORT int msIntersectPointPolygon(pointObj *p, shapeObj *polygon);
-  MS_DLL_EXPORT int msIntersectPolylinePolygon(shapeObj *line, shapeObj *poly);
-  MS_DLL_EXPORT int msIntersectPolygons(shapeObj *p1, shapeObj *p2);
-  MS_DLL_EXPORT int msIntersectPolylines(shapeObj *line1, shapeObj *line2);
-
-  MS_DLL_EXPORT int msInitQuery(queryObj *query); /* in mapquery.c */
-  MS_DLL_EXPORT void msFreeQuery(queryObj *query);
-  MS_DLL_EXPORT int msSaveQuery(mapObj *map, char *filename, int results);
-  MS_DLL_EXPORT int msLoadQuery(mapObj *map, char *filename);
-  MS_DLL_EXPORT int msExecuteQuery(mapObj *map);
-
-  MS_DLL_EXPORT int msQueryByIndex(mapObj *map); /* various query methods, all rely on the queryObj hung off the mapObj */
-  MS_DLL_EXPORT int msQueryByAttributes(mapObj *map);
-  MS_DLL_EXPORT int msQueryByPoint(mapObj *map);
-  MS_DLL_EXPORT int msQueryByRect(mapObj *map);
-  MS_DLL_EXPORT int msQueryByFeatures(mapObj *map);
-  MS_DLL_EXPORT int msQueryByShape(mapObj *map);
-  MS_DLL_EXPORT int msQueryByFilter(mapObj *map);
-
-  MS_DLL_EXPORT int msGetQueryResultBounds(mapObj *map, rectObj *bounds);
-  MS_DLL_EXPORT int msIsLayerQueryable(layerObj *lp);
-  MS_DLL_EXPORT void msQueryFree(mapObj *map, int qlayer); /* todo: rename */
-  MS_DLL_EXPORT int msRasterQueryByShape(mapObj *map, layerObj *layer, shapeObj *selectshape);
-  MS_DLL_EXPORT int msRasterQueryByRect(mapObj *map, layerObj *layer, rectObj queryRect);
-  MS_DLL_EXPORT int msRasterQueryByPoint(mapObj *map, layerObj *layer, int mode, pointObj p, double buffer, int maxresults );
-
-  /* in mapstring.c */
-  MS_DLL_EXPORT void msStringTrim(char *str);
-  MS_DLL_EXPORT void msStringTrimBlanks(char *string);
-  MS_DLL_EXPORT char *msStringTrimLeft(char *string);
-  MS_DLL_EXPORT char *msStringChop(char *string);
-  MS_DLL_EXPORT void msStringTrimEOL(char *string);
-  MS_DLL_EXPORT char *msReplaceSubstring(char *str, const char *old, const char *sznew);
-  MS_DLL_EXPORT void msReplaceChar(char *str, char old, char sznew);
-  MS_DLL_EXPORT char *msCaseReplaceSubstring(char *str, const char *old, const char *sznew);
-  MS_DLL_EXPORT char *msStripPath(char *fn);
-  MS_DLL_EXPORT char *msGetPath(const char *fn);
-  MS_DLL_EXPORT char *msBuildPath(char *pszReturnPath, const char *abs_path, const char *path);
-  MS_DLL_EXPORT char *msBuildPath3(char *pszReturnPath, const char *abs_path, const char *path1, const char *path2);
-  MS_DLL_EXPORT char *msTryBuildPath(char *szReturnPath, const char *abs_path, const char *path);
-  MS_DLL_EXPORT char *msTryBuildPath3(char *szReturnPath, const char *abs_path, const char *path1, const char *path2);
-  MS_DLL_EXPORT char **msStringSplit(const char *string, char cd, int *num_tokens);
-  MS_DLL_EXPORT char ** msStringSplitComplex( const char * pszString, const char * pszDelimiters, int *num_tokens, int nFlags);
-  MS_DLL_EXPORT int msStringArrayContains(char **array, const char *element, int numElements);
-  MS_DLL_EXPORT char **msStringTokenize( const char *pszLine, const char *pszDelim, int *num_tokens, int preserve_quote);
-  MS_DLL_EXPORT int msCountChars(char *str, char ch);
-  MS_DLL_EXPORT char *msLongToString(long value);
-  MS_DLL_EXPORT char *msDoubleToString(double value, int force_f);
-  MS_DLL_EXPORT char *msIntToString(int value);
-  MS_DLL_EXPORT void msStringToUpper(char *string);
-  MS_DLL_EXPORT void msStringToLower(char *string);
-  MS_DLL_EXPORT void msStringInitCap(char *string);
-  MS_DLL_EXPORT void msStringFirstCap(char *string);
-  MS_DLL_EXPORT int msEncodeChar(const char);
-  MS_DLL_EXPORT char *msEncodeUrlExcept(const char*, const char);
-  MS_DLL_EXPORT char *msEncodeUrl(const char*);
-  MS_DLL_EXPORT char *msEscapeJSonString(const char* pszJSonString);
-  MS_DLL_EXPORT char *msEncodeHTMLEntities(const char *string);
-  MS_DLL_EXPORT void msDecodeHTMLEntities(const char *string);
-  MS_DLL_EXPORT int msIsXMLTagValid(const char *string);
-  MS_DLL_EXPORT char *msStringConcatenate(char *pszDest, const char *pszSrc);
-  MS_DLL_EXPORT char *msJoinStrings(char **array, int arrayLength, const char *delimeter);
-  MS_DLL_EXPORT char *msHashString(const char *pszStr);
-  MS_DLL_EXPORT char *msCommifyString(char *str);
-  MS_DLL_EXPORT int msHexToInt(char *hex);
-  MS_DLL_EXPORT char *msGetEncodedString(const char *string, const char *encoding);
-  MS_DLL_EXPORT char *msConvertWideStringToUTF8 (const wchar_t* string, const char* encoding);
-  MS_DLL_EXPORT wchar_t *msConvertWideStringFromUTF8 (const char* string, const char* encoding);
-  MS_DLL_EXPORT int msGetNextGlyph(const char **in_ptr, char *out_string);
-  MS_DLL_EXPORT int msGetNumGlyphs(const char *in_ptr);
-  MS_DLL_EXPORT int msGetUnicodeEntity(const char *inptr, unsigned int *unicode);
-  MS_DLL_EXPORT int msStringIsInteger(const char *string);
-  MS_DLL_EXPORT int msUTF8ToUniChar(const char *str, unsigned int *chPtr); /* maptclutf.c */
-  MS_DLL_EXPORT char* msStringEscape( const char * pszString );
-  MS_DLL_EXPORT int msStringInArray( const char * pszString, char **array, int numelements);
-
-  typedef struct msStringBuffer msStringBuffer;
-  MS_DLL_EXPORT msStringBuffer* msStringBufferAlloc(void);
-  MS_DLL_EXPORT void msStringBufferFree(msStringBuffer* sb);
-  MS_DLL_EXPORT const char* msStringBufferGetString(msStringBuffer* sb);
-  MS_DLL_EXPORT char* msStringBufferReleaseStringAndFree(msStringBuffer* sb);
-  MS_DLL_EXPORT int msStringBufferAppend(msStringBuffer* sb, const char* pszAppendedString);
+MS_DLL_EXPORT char **msTokenizeMap(char *filename, int *numtokens);
+MS_DLL_EXPORT int msInitLabelCache(labelCacheObj *cache);
+MS_DLL_EXPORT int msFreeLabelCache(labelCacheObj *cache);
+MS_DLL_EXPORT int msCheckConnection(
+    layerObj *layer); /* connection pooling functions (mapfile.c) */
+MS_DLL_EXPORT void msCloseConnections(mapObj *map);
+
+MS_DLL_EXPORT void msOGRInitialize(void);
+MS_DLL_EXPORT void msOGRCleanup(void);
+MS_DLL_EXPORT void msGDALCleanup(void);
+MS_DLL_EXPORT void msGDALInitialize(void);
+
+MS_DLL_EXPORT imageObj *msDrawScalebar(mapObj *map); /* in mapscale.c */
+MS_DLL_EXPORT int msCalculateScale(rectObj extent, int units, int width,
+                                   int height, double resolution,
+                                   double *scaledenom);
+MS_DLL_EXPORT double GetDeltaExtentsUsingScale(double scale, int units,
+                                               double centerLat, int width,
+                                               double resolution);
+MS_DLL_EXPORT double Pix2Georef(int nPixPos, int nPixMin, int nPixMax,
+                                double dfGeoMin, double dfGeoMax,
+                                int bULisYOrig);
+MS_DLL_EXPORT double Pix2LayerGeoref(mapObj *map, layerObj *layer, int value);
+MS_DLL_EXPORT double msInchesPerUnit(int units, double center_lat);
+MS_DLL_EXPORT int msEmbedScalebar(mapObj *map, imageObj *img);
+
+MS_DLL_EXPORT int msPointInRect(const pointObj *p,
+                                const rectObj *rect); /* in mapsearch.c */
+MS_DLL_EXPORT int msRectOverlap(const rectObj *a, const rectObj *b);
+MS_DLL_EXPORT int msRectContained(const rectObj *a, const rectObj *b);
+MS_DLL_EXPORT int msRectIntersect(rectObj *a, const rectObj *b);
+
+MS_DLL_EXPORT void msRectToFormattedString(rectObj *rect, char *format,
+                                           char *buffer, int buffer_length);
+MS_DLL_EXPORT void msPointToFormattedString(pointObj *point, const char *format,
+                                            char *buffer, int buffer_length);
+MS_DLL_EXPORT int msIsDegenerateShape(shapeObj *shape);
+
+MS_DLL_EXPORT void msMergeRect(rectObj *a, rectObj *b);
+MS_DLL_EXPORT double msDistancePointToPoint(pointObj *a, pointObj *b);
+MS_DLL_EXPORT double msSquareDistancePointToPoint(pointObj *a, pointObj *b);
+MS_DLL_EXPORT double msDistancePointToSegment(pointObj *p, pointObj *a,
+                                              pointObj *b);
+MS_DLL_EXPORT double msSquareDistancePointToSegment(pointObj *p, pointObj *a,
+                                                    pointObj *b);
+MS_DLL_EXPORT double msDistancePointToShape(pointObj *p, shapeObj *shape);
+MS_DLL_EXPORT double msSquareDistancePointToShape(pointObj *p, shapeObj *shape);
+MS_DLL_EXPORT double msDistanceSegmentToSegment(pointObj *pa, pointObj *pb,
+                                                pointObj *pc, pointObj *pd);
+MS_DLL_EXPORT double msDistanceShapeToShape(shapeObj *shape1, shapeObj *shape2);
+MS_DLL_EXPORT int msIntersectSegments(const pointObj *a, const pointObj *b,
+                                      const pointObj *c, const pointObj *d);
+MS_DLL_EXPORT int msPointInPolygon(pointObj *p, lineObj *c);
+MS_DLL_EXPORT int msIntersectMultipointPolygon(shapeObj *multipoint,
+                                               shapeObj *polygon);
+MS_DLL_EXPORT int msIntersectPointPolygon(pointObj *p, shapeObj *polygon);
+MS_DLL_EXPORT int msIntersectPolylinePolygon(shapeObj *line, shapeObj *poly);
+MS_DLL_EXPORT int msIntersectPolygons(shapeObj *p1, shapeObj *p2);
+MS_DLL_EXPORT int msIntersectPolylines(shapeObj *line1, shapeObj *line2);
+
+MS_DLL_EXPORT int msInitQuery(queryObj *query); /* in mapquery.c */
+MS_DLL_EXPORT void msFreeQuery(queryObj *query);
+MS_DLL_EXPORT int msSaveQuery(mapObj *map, char *filename, int results);
+MS_DLL_EXPORT int msLoadQuery(mapObj *map, char *filename);
+MS_DLL_EXPORT int msExecuteQuery(mapObj *map);
+
+MS_DLL_EXPORT int
+msQueryByIndex(mapObj *map); /* various query methods, all rely on the queryObj
+                                hung off the mapObj */
+MS_DLL_EXPORT int msQueryByAttributes(mapObj *map);
+MS_DLL_EXPORT int msQueryByPoint(mapObj *map);
+MS_DLL_EXPORT int msQueryByRect(mapObj *map);
+MS_DLL_EXPORT int msQueryByFeatures(mapObj *map);
+MS_DLL_EXPORT int msQueryByShape(mapObj *map);
+MS_DLL_EXPORT int msQueryByFilter(mapObj *map);
+
+MS_DLL_EXPORT int msGetQueryResultBounds(mapObj *map, rectObj *bounds);
+MS_DLL_EXPORT int msIsLayerQueryable(layerObj *lp);
+MS_DLL_EXPORT void msQueryFree(mapObj *map, int qlayer); /* todo: rename */
+MS_DLL_EXPORT int msRasterQueryByShape(mapObj *map, layerObj *layer,
+                                       shapeObj *selectshape);
+MS_DLL_EXPORT int msRasterQueryByRect(mapObj *map, layerObj *layer,
+                                      rectObj queryRect);
+MS_DLL_EXPORT int msRasterQueryByPoint(mapObj *map, layerObj *layer, int mode,
+                                       pointObj p, double buffer,
+                                       int maxresults);
+
+/* in mapstring.c */
+MS_DLL_EXPORT void msStringTrim(char *str);
+MS_DLL_EXPORT void msStringTrimBlanks(char *string);
+MS_DLL_EXPORT char *msStringTrimLeft(char *string);
+MS_DLL_EXPORT char *msStringChop(char *string);
+MS_DLL_EXPORT void msStringTrimEOL(char *string);
+MS_DLL_EXPORT char *msReplaceSubstring(char *str, const char *old,
+                                       const char *sznew);
+MS_DLL_EXPORT void msReplaceChar(char *str, char old, char sznew);
+MS_DLL_EXPORT char *msCaseReplaceSubstring(char *str, const char *old,
+                                           const char *sznew);
+MS_DLL_EXPORT char *msStripPath(char *fn);
+MS_DLL_EXPORT char *msGetPath(const char *fn);
+MS_DLL_EXPORT char *msBuildPath(char *pszReturnPath, const char *abs_path,
+                                const char *path);
+MS_DLL_EXPORT char *msBuildPath3(char *pszReturnPath, const char *abs_path,
+                                 const char *path1, const char *path2);
+MS_DLL_EXPORT char *msTryBuildPath(char *szReturnPath, const char *abs_path,
+                                   const char *path);
+MS_DLL_EXPORT char *msTryBuildPath3(char *szReturnPath, const char *abs_path,
+                                    const char *path1, const char *path2);
+MS_DLL_EXPORT char **msStringSplit(const char *string, char cd,
+                                   int *num_tokens);
+MS_DLL_EXPORT char **msStringSplitComplex(const char *pszString,
+                                          const char *pszDelimiters,
+                                          int *num_tokens, int nFlags);
+MS_DLL_EXPORT int msStringArrayContains(char **array, const char *element,
+                                        int numElements);
+MS_DLL_EXPORT char **msStringTokenize(const char *pszLine, const char *pszDelim,
+                                      int *num_tokens, int preserve_quote);
+MS_DLL_EXPORT int msCountChars(char *str, char ch);
+MS_DLL_EXPORT char *msLongToString(long value);
+MS_DLL_EXPORT char *msDoubleToString(double value, int force_f);
+MS_DLL_EXPORT char *msIntToString(int value);
+MS_DLL_EXPORT void msStringToUpper(char *string);
+MS_DLL_EXPORT void msStringToLower(char *string);
+MS_DLL_EXPORT void msStringInitCap(char *string);
+MS_DLL_EXPORT void msStringFirstCap(char *string);
+MS_DLL_EXPORT int msEncodeChar(const char);
+MS_DLL_EXPORT char *msEncodeUrlExcept(const char *, const char);
+MS_DLL_EXPORT char *msEncodeUrl(const char *);
+MS_DLL_EXPORT char *msEscapeJSonString(const char *pszJSonString);
+MS_DLL_EXPORT char *msEncodeHTMLEntities(const char *string);
+MS_DLL_EXPORT void msDecodeHTMLEntities(const char *string);
+MS_DLL_EXPORT int msIsXMLTagValid(const char *string);
+MS_DLL_EXPORT char *msStringConcatenate(char *pszDest, const char *pszSrc);
+MS_DLL_EXPORT char *msJoinStrings(char **array, int arrayLength,
+                                  const char *delimeter);
+MS_DLL_EXPORT char *msHashString(const char *pszStr);
+MS_DLL_EXPORT char *msCommifyString(char *str);
+MS_DLL_EXPORT int msHexToInt(char *hex);
+MS_DLL_EXPORT char *msGetEncodedString(const char *string,
+                                       const char *encoding);
+MS_DLL_EXPORT char *msConvertWideStringToUTF8(const wchar_t *string,
+                                              const char *encoding);
+MS_DLL_EXPORT wchar_t *msConvertWideStringFromUTF8(const char *string,
+                                                   const char *encoding);
+MS_DLL_EXPORT int msGetNextGlyph(const char **in_ptr, char *out_string);
+MS_DLL_EXPORT int msGetNumGlyphs(const char *in_ptr);
+MS_DLL_EXPORT int msGetUnicodeEntity(const char *inptr, unsigned int *unicode);
+MS_DLL_EXPORT int msStringIsInteger(const char *string);
+MS_DLL_EXPORT int msUTF8ToUniChar(const char *str,
+                                  unsigned int *chPtr); /* maptclutf.c */
+MS_DLL_EXPORT char *msStringEscape(const char *pszString);
+MS_DLL_EXPORT int msStringInArray(const char *pszString, char **array,
+                                  int numelements);
+
+typedef struct msStringBuffer msStringBuffer;
+MS_DLL_EXPORT msStringBuffer *msStringBufferAlloc(void);
+MS_DLL_EXPORT void msStringBufferFree(msStringBuffer *sb);
+MS_DLL_EXPORT const char *msStringBufferGetString(msStringBuffer *sb);
+MS_DLL_EXPORT char *msStringBufferReleaseStringAndFree(msStringBuffer *sb);
+MS_DLL_EXPORT int msStringBufferAppend(msStringBuffer *sb,
+                                       const char *pszAppendedString);
 
-  MS_DLL_EXPORT int msStringToInt(const char *str, int *value, int base);
-  MS_DLL_EXPORT int msStringToDouble(const char *str, double *value);
+MS_DLL_EXPORT int msStringToInt(const char *str, int *value, int base);
+MS_DLL_EXPORT int msStringToDouble(const char *str, double *value);
 
 #ifdef __cplusplus
 }
-  std::string msStdStringEscape( const char * pszString );
-  void msStringTrim(std::string& string);
-  void msStringTrimBlanks(std::string& string);
-  void msStringTrimLeft(std::string& string);
-  std::vector<std::string> msStringSplit(const char *string, char cd);
-  std::string msStringToLower(const std::string& s);
-  bool msStringInArray( const char * pszString, const std::vector<std::string>& array);
+std::string msStdStringEscape(const char *pszString);
+void msStringTrim(std::string &string);
+void msStringTrimBlanks(std::string &string);
+void msStringTrimLeft(std::string &string);
+std::vector<std::string> msStringSplit(const char *string, char cd);
+std::string msStringToLower(const std::string &s);
+bool msStringInArray(const char *pszString,
+                     const std::vector<std::string> &array);
 extern "C" {
 #endif
 
 #ifndef HAVE_STRRSTR
-  MS_DLL_EXPORT char *strrstr(const char *string, const char *find);
+MS_DLL_EXPORT char *strrstr(const char *string, const char *find);
 #endif /* NEED_STRRSTR */
 
 #ifndef HAVE_STRCASESTR
-  MS_DLL_EXPORT char *strcasestr(const char *s, const char *find);
+MS_DLL_EXPORT char *strcasestr(const char *s, const char *find);
 #endif /* NEED_STRCASESTR */
 
 #ifndef HAVE_STRNCASECMP
-  MS_DLL_EXPORT int strncasecmp(const char *s1, const char *s2, size_t len);
+MS_DLL_EXPORT int strncasecmp(const char *s1, const char *s2, size_t len);
 #endif /* NEED_STRNCASECMP */
 
 #ifndef HAVE_STRCASECMP
-  MS_DLL_EXPORT int strcasecmp(const char *s1, const char *s2);
+MS_DLL_EXPORT int strcasecmp(const char *s1, const char *s2);
 #endif /* NEED_STRCASECMP */
 
 #ifndef HAVE_STRLCAT
-  MS_DLL_EXPORT size_t strlcat(char *dst, const char *src, size_t siz);
+MS_DLL_EXPORT size_t strlcat(char *dst, const char *src, size_t siz);
 #endif /* NEED_STRLCAT */
 
 #ifndef HAVE_STRLCPY
-  MS_DLL_EXPORT size_t strlcpy(char *dst, const char *src, size_t siz);
+MS_DLL_EXPORT size_t strlcpy(char *dst, const char *src, size_t siz);
 #endif /* NEED_STRLCAT */
 
-  MS_DLL_EXPORT char *msStrdup( const char * pszString );
+MS_DLL_EXPORT char *msStrdup(const char *pszString);
 
 #include "hittest.h"
 
-  /* in mapsymbol.c */
-  /* Use this function *only* with mapfile loading phase */
-  MS_DLL_EXPORT int loadSymbolSet(symbolSetObj *symbolset, mapObj *map);
-  /* Use this threadsafe wrapper everywhere else */
-  MS_DLL_EXPORT int msLoadSymbolSet(symbolSetObj *symbolset, mapObj *map);
-  MS_DLL_EXPORT int msCopySymbol(symbolObj *dst, const symbolObj *src, mapObj *map);
-  MS_DLL_EXPORT int msCopySymbolSet(symbolSetObj *dst, const symbolSetObj *src, mapObj *map);
-  MS_DLL_EXPORT int msCopyHashTable(hashTableObj *dst, const hashTableObj *src);
-  MS_DLL_EXPORT void msInitSymbolSet(symbolSetObj *symbolset);
-  MS_DLL_EXPORT symbolObj *msGrowSymbolSet( symbolSetObj *symbolset );
-  MS_DLL_EXPORT int msAddImageSymbol(symbolSetObj *symbolset, char *filename);
-  MS_DLL_EXPORT int msFreeSymbolSet(symbolSetObj *symbolset);
-  MS_DLL_EXPORT int msFreeSymbol(symbolObj *symbol);
-  MS_DLL_EXPORT int msAddNewSymbol(mapObj *map, char *name);
-  MS_DLL_EXPORT int msAppendSymbol(symbolSetObj *symbolset, symbolObj *symbol);
-  MS_DLL_EXPORT symbolObj *msRemoveSymbol(symbolSetObj *symbolset, int index);
-  MS_DLL_EXPORT int msSaveSymbolSet(symbolSetObj *symbolset, const char *filename);
-  MS_DLL_EXPORT int msLoadImageSymbol(symbolObj *symbol, const char *filename);
-  MS_DLL_EXPORT int msPreloadImageSymbol(rendererVTableObj *renderer, symbolObj *symbol);
-  MS_DLL_EXPORT int msPreloadSVGSymbol(symbolObj *symbol);
-  MS_DLL_EXPORT symbolObj *msRotateSymbol(symbolObj *symbol, double angle);
-
-  MS_DLL_EXPORT int WARN_UNUSED msGetCharacterSize(mapObj *map, char* font, int size, char *character, rectObj *r);
-  MS_DLL_EXPORT int WARN_UNUSED msGetMarkerSize(mapObj *map, styleObj *style, double *width, double *height, double scalefactor);
-  /* MS_DLL_EXPORT int msGetCharacterSize(char *character, int size, char *font, rectObj *rect); */
-  MS_DLL_EXPORT double msSymbolGetDefaultSize(symbolObj *s);
-  MS_DLL_EXPORT void freeImageCache(struct imageCacheObj *ic);
-
-  MS_DLL_EXPORT imageObj WARN_UNUSED *msDrawLegend(mapObj *map, int scale_independent, map_hittest *hittest); /* in maplegend.c */
-  MS_DLL_EXPORT int WARN_UNUSED msLegendCalcSize(mapObj *map, int scale_independent, int *size_x, int *size_y,
-                                     int *alayers, int numl_ayer, map_hittest *hittest, double resolutionfactor);
-  MS_DLL_EXPORT int WARN_UNUSED msEmbedLegend(mapObj *map, imageObj *img);
-  MS_DLL_EXPORT int WARN_UNUSED msDrawLegendIcon(mapObj* map, layerObj* lp, classObj* myClass, int width, int height, imageObj *img, int dstX, int dstY, int scale_independant, class_hittest *hittest);
-  MS_DLL_EXPORT imageObj WARN_UNUSED *msCreateLegendIcon(mapObj* map, layerObj* lp, classObj* myClass, int width, int height, int scale_independant);
-
-  MS_DLL_EXPORT int msLoadFontSet(fontSetObj *fontSet, mapObj *map); /* in maplabel.c */
-  MS_DLL_EXPORT int msInitFontSet(fontSetObj *fontset);
-  MS_DLL_EXPORT int msFreeFontSet(fontSetObj *fontset);
-
-  MS_DLL_EXPORT int WARN_UNUSED msGetTextSymbolSize(mapObj *map, textSymbolObj *ts, rectObj *r);
-  MS_DLL_EXPORT int WARN_UNUSED msGetStringSize(mapObj *map, labelObj *label, int size, char *string, rectObj *r);
-
-  MS_DLL_EXPORT int WARN_UNUSED msAddLabel(mapObj *map, imageObj *image, labelObj *label, int layerindex, int classindex, shapeObj *shape, pointObj *point, double featuresize, textSymbolObj *ts);
-  MS_DLL_EXPORT int WARN_UNUSED msAddLabelGroup(mapObj *map, imageObj *image, layerObj *layer, int classindex, shapeObj *shape, pointObj *point, double featuresize);
-  MS_DLL_EXPORT void insertRenderedLabelMember(mapObj *map, labelCacheMemberObj *cachePtr);
-  MS_DLL_EXPORT int msTestLabelCacheCollisions(mapObj *map, labelCacheMemberObj *cachePtr, label_bounds *lb, int current_priority, int current_label);
-  MS_DLL_EXPORT int msTestLabelCacheLeaderCollision(mapObj *map, pointObj *lp1, pointObj *lp2);
-  MS_DLL_EXPORT labelCacheMemberObj *msGetLabelCacheMember(labelCacheObj *labelcache, int i);
-
-  MS_DLL_EXPORT void msFreeShape(shapeObj *shape); /* in mapprimitive.c */
-  int msGetShapeRAMSize(shapeObj* shape); /* in mapprimitive.c */
-  MS_DLL_EXPORT void msFreeLabelPathObj(labelPathObj *path);
-  MS_DLL_EXPORT shapeObj *msShapeFromWKT(const char *string);
-  MS_DLL_EXPORT char *msShapeToWKT(shapeObj *shape);
-  MS_DLL_EXPORT void msInitShape(shapeObj *shape);
-  MS_DLL_EXPORT void msShapeDeleteLine( shapeObj *shape, int line );
-  MS_DLL_EXPORT int msCopyShape(const shapeObj *from, shapeObj *to);
-  MS_DLL_EXPORT int msIsOuterRing(shapeObj *shape, int r);
-  MS_DLL_EXPORT int *msGetOuterList(shapeObj *shape);
-  MS_DLL_EXPORT int *msGetInnerList(shapeObj *shape, int r, int *outerlist);
-  MS_DLL_EXPORT void msComputeBounds(shapeObj *shape);
-  MS_DLL_EXPORT void msRectToPolygon(rectObj rect, shapeObj *poly);
-  MS_DLL_EXPORT void msClipPolylineRect(shapeObj *shape, rectObj rect);
-  MS_DLL_EXPORT void msClipPolygonRect(shapeObj *shape, rectObj rect);
-  MS_DLL_EXPORT void msTransformShape(shapeObj *shape, rectObj extent, double cellsize, imageObj *image);
-  MS_DLL_EXPORT void msTransformPoint(pointObj *point, rectObj *extent, double cellsize, imageObj *image);
-
-  MS_DLL_EXPORT void msOffsetPointRelativeTo(pointObj *point, layerObj *layer);
-  MS_DLL_EXPORT void msOffsetShapeRelativeTo(shapeObj *shape, layerObj *layer);
-  MS_DLL_EXPORT void msTransformShapeSimplify(shapeObj *shape, rectObj extent, double cellsize);
-  MS_DLL_EXPORT void msTransformShapeToPixelSnapToGrid(shapeObj *shape, rectObj extent, double cellsize, double grid_resolution);
-  MS_DLL_EXPORT void msTransformShapeToPixelRound(shapeObj *shape, rectObj extent, double cellsize);
-  MS_DLL_EXPORT void msTransformShapeToPixelDoublePrecision(shapeObj *shape, rectObj extent, double cellsize);
-
-  MS_DLL_EXPORT shapeObj *msDensify(shapeObj *shape, double tolerance);
-  MS_DLL_EXPORT shapeObj *msRings2Shape(shapeObj *shape, int outer);
-
-#ifndef SWIG
-
-  struct line_lengths {
-    double *segment_lengths;
-    double total_length;
-    int longest_segment_index;
-  };
-
-  struct polyline_lengths {
-    struct line_lengths *ll;
-    double total_length;
-    int longest_line_index;
-    int longest_segment_line_index, longest_segment_point_index;
-  };
-
-  struct label_auto_result {
-    pointObj *label_points;
-    double *angles;
-    int num_label_points;
-  };
-
-  struct label_follow_result {
-    textSymbolObj **follow_labels;
-    int num_follow_labels;
-    struct label_auto_result lar;
-  };
-
-#endif
-
-  MS_DLL_EXPORT void msTransformPixelToShape(shapeObj *shape, rectObj extent, double cellsize);
-  MS_DLL_EXPORT void msPolylineComputeLineSegments(shapeObj *shape, struct polyline_lengths *pll);
-  MS_DLL_EXPORT int msPolylineLabelPath(mapObj *map, imageObj *image, shapeObj *p, textSymbolObj *ts, labelObj *label, struct label_follow_result *lfr);
-  MS_DLL_EXPORT int WARN_UNUSED msPolylineLabelPoint(mapObj *map, shapeObj *p, textSymbolObj *ts, labelObj *label, struct label_auto_result *lar, double resolutionfactor);
-  MS_DLL_EXPORT int WARN_UNUSED msLineLabelPath(mapObj *map, imageObj *img, lineObj *p, textSymbolObj *ts, struct line_lengths *ll, struct label_follow_result *lfr, labelObj *lbl);
-  MS_DLL_EXPORT int WARN_UNUSED msLineLabelPoint(mapObj *map, lineObj *p, textSymbolObj *ts, struct line_lengths *ll, struct label_auto_result *lar, labelObj *lbl, double resolutionfactor);
-  MS_DLL_EXPORT int msPolygonLabelPoint(shapeObj *p, pointObj *lp, double min_dimension);
-  MS_DLL_EXPORT int msAddLine(shapeObj *p, const lineObj *new_line);
-  MS_DLL_EXPORT int msAddLineDirectly(shapeObj *p, lineObj *new_line);
-  MS_DLL_EXPORT int msAddPointToLine(lineObj *line, pointObj *point );
-  MS_DLL_EXPORT double msGetPolygonArea(shapeObj *p);
-  MS_DLL_EXPORT int msGetPolygonCentroid(shapeObj *p, pointObj *lp, double *miny, double *maxy);
+/* in mapsymbol.c */
+/* Use this function *only* with mapfile loading phase */
+MS_DLL_EXPORT int loadSymbolSet(symbolSetObj *symbolset, mapObj *map);
+/* Use this threadsafe wrapper everywhere else */
+MS_DLL_EXPORT int msLoadSymbolSet(symbolSetObj *symbolset, mapObj *map);
+MS_DLL_EXPORT int msCopySymbol(symbolObj *dst, const symbolObj *src,
+                               mapObj *map);
+MS_DLL_EXPORT int msCopySymbolSet(symbolSetObj *dst, const symbolSetObj *src,
+                                  mapObj *map);
+MS_DLL_EXPORT int msCopyHashTable(hashTableObj *dst, const hashTableObj *src);
+MS_DLL_EXPORT void msInitSymbolSet(symbolSetObj *symbolset);
+MS_DLL_EXPORT symbolObj *msGrowSymbolSet(symbolSetObj *symbolset);
+MS_DLL_EXPORT int msAddImageSymbol(symbolSetObj *symbolset, char *filename);
+MS_DLL_EXPORT int msFreeSymbolSet(symbolSetObj *symbolset);
+MS_DLL_EXPORT int msFreeSymbol(symbolObj *symbol);
+MS_DLL_EXPORT int msAddNewSymbol(mapObj *map, char *name);
+MS_DLL_EXPORT int msAppendSymbol(symbolSetObj *symbolset, symbolObj *symbol);
+MS_DLL_EXPORT symbolObj *msRemoveSymbol(symbolSetObj *symbolset, int index);
+MS_DLL_EXPORT int msSaveSymbolSet(symbolSetObj *symbolset,
+                                  const char *filename);
+MS_DLL_EXPORT int msLoadImageSymbol(symbolObj *symbol, const char *filename);
+MS_DLL_EXPORT int msPreloadImageSymbol(rendererVTableObj *renderer,
+                                       symbolObj *symbol);
+MS_DLL_EXPORT int msPreloadSVGSymbol(symbolObj *symbol);
+MS_DLL_EXPORT symbolObj *msRotateSymbol(symbolObj *symbol, double angle);
+
+MS_DLL_EXPORT int WARN_UNUSED msGetCharacterSize(mapObj *map, char *font,
+                                                 int size, char *character,
+                                                 rectObj *r);
+MS_DLL_EXPORT int WARN_UNUSED msGetMarkerSize(mapObj *map, styleObj *style,
+                                              double *width, double *height,
+                                              double scalefactor);
+/* MS_DLL_EXPORT int msGetCharacterSize(char *character, int size, char *font,
+ * rectObj *rect); */
+MS_DLL_EXPORT double msSymbolGetDefaultSize(symbolObj *s);
+MS_DLL_EXPORT void freeImageCache(struct imageCacheObj *ic);
+
+MS_DLL_EXPORT imageObj WARN_UNUSED *
+msDrawLegend(mapObj *map, int scale_independent,
+             map_hittest *hittest); /* in maplegend.c */
+MS_DLL_EXPORT int WARN_UNUSED msLegendCalcSize(
+    mapObj *map, int scale_independent, int *size_x, int *size_y, int *alayers,
+    int numl_ayer, map_hittest *hittest, double resolutionfactor);
+MS_DLL_EXPORT int WARN_UNUSED msEmbedLegend(mapObj *map, imageObj *img);
+MS_DLL_EXPORT int WARN_UNUSED msDrawLegendIcon(mapObj *map, layerObj *lp,
+                                               classObj *myClass, int width,
+                                               int height, imageObj *img,
+                                               int dstX, int dstY,
+                                               int scale_independant,
+                                               class_hittest *hittest);
+MS_DLL_EXPORT imageObj WARN_UNUSED *
+msCreateLegendIcon(mapObj *map, layerObj *lp, classObj *myClass, int width,
+                   int height, int scale_independant);
+
+MS_DLL_EXPORT int msLoadFontSet(fontSetObj *fontSet,
+                                mapObj *map); /* in maplabel.c */
+MS_DLL_EXPORT int msInitFontSet(fontSetObj *fontset);
+MS_DLL_EXPORT int msFreeFontSet(fontSetObj *fontset);
+
+MS_DLL_EXPORT int WARN_UNUSED msGetTextSymbolSize(mapObj *map,
+                                                  textSymbolObj *ts,
+                                                  rectObj *r);
+MS_DLL_EXPORT int WARN_UNUSED msGetStringSize(mapObj *map, labelObj *label,
+                                              int size, char *string,
+                                              rectObj *r);
+
+MS_DLL_EXPORT int WARN_UNUSED msAddLabel(mapObj *map, imageObj *image,
+                                         labelObj *label, int layerindex,
+                                         int classindex, shapeObj *shape,
+                                         pointObj *point, double featuresize,
+                                         textSymbolObj *ts);
+MS_DLL_EXPORT int WARN_UNUSED msAddLabelGroup(mapObj *map, imageObj *image,
+                                              layerObj *layer, int classindex,
+                                              shapeObj *shape, pointObj *point,
+                                              double featuresize);
+MS_DLL_EXPORT void insertRenderedLabelMember(mapObj *map,
+                                             labelCacheMemberObj *cachePtr);
+MS_DLL_EXPORT int msTestLabelCacheCollisions(mapObj *map,
+                                             labelCacheMemberObj *cachePtr,
+                                             label_bounds *lb,
+                                             int current_priority,
+                                             int current_label);
+MS_DLL_EXPORT int msTestLabelCacheLeaderCollision(mapObj *map, pointObj *lp1,
+                                                  pointObj *lp2);
+MS_DLL_EXPORT labelCacheMemberObj *
+msGetLabelCacheMember(labelCacheObj *labelcache, int i);
+
+MS_DLL_EXPORT void msFreeShape(shapeObj *shape); /* in mapprimitive.c */
+int msGetShapeRAMSize(shapeObj *shape);          /* in mapprimitive.c */
+MS_DLL_EXPORT void msFreeLabelPathObj(labelPathObj *path);
+MS_DLL_EXPORT shapeObj *msShapeFromWKT(const char *string);
+MS_DLL_EXPORT char *msShapeToWKT(shapeObj *shape);
+MS_DLL_EXPORT void msInitShape(shapeObj *shape);
+MS_DLL_EXPORT void msShapeDeleteLine(shapeObj *shape, int line);
+MS_DLL_EXPORT int msCopyShape(const shapeObj *from, shapeObj *to);
+MS_DLL_EXPORT int msIsOuterRing(shapeObj *shape, int r);
+MS_DLL_EXPORT int *msGetOuterList(shapeObj *shape);
+MS_DLL_EXPORT int *msGetInnerList(shapeObj *shape, int r, int *outerlist);
+MS_DLL_EXPORT void msComputeBounds(shapeObj *shape);
+MS_DLL_EXPORT void msRectToPolygon(rectObj rect, shapeObj *poly);
+MS_DLL_EXPORT void msClipPolylineRect(shapeObj *shape, rectObj rect);
+MS_DLL_EXPORT void msClipPolygonRect(shapeObj *shape, rectObj rect);
+MS_DLL_EXPORT void msTransformShape(shapeObj *shape, rectObj extent,
+                                    double cellsize, imageObj *image);
+MS_DLL_EXPORT void msTransformPoint(pointObj *point, rectObj *extent,
+                                    double cellsize, imageObj *image);
+
+MS_DLL_EXPORT void msOffsetPointRelativeTo(pointObj *point, layerObj *layer);
+MS_DLL_EXPORT void msOffsetShapeRelativeTo(shapeObj *shape, layerObj *layer);
+MS_DLL_EXPORT void msTransformShapeSimplify(shapeObj *shape, rectObj extent,
+                                            double cellsize);
+MS_DLL_EXPORT void msTransformShapeToPixelSnapToGrid(shapeObj *shape,
+                                                     rectObj extent,
+                                                     double cellsize,
+                                                     double grid_resolution);
+MS_DLL_EXPORT void msTransformShapeToPixelRound(shapeObj *shape, rectObj extent,
+                                                double cellsize);
+MS_DLL_EXPORT void msTransformShapeToPixelDoublePrecision(shapeObj *shape,
+                                                          rectObj extent,
+                                                          double cellsize);
+
+MS_DLL_EXPORT shapeObj *msDensify(shapeObj *shape, double tolerance);
+MS_DLL_EXPORT shapeObj *msRings2Shape(shapeObj *shape, int outer);
+
+#ifndef SWIG
+
+struct line_lengths {
+  double *segment_lengths;
+  double total_length;
+  int longest_segment_index;
+};
+
+struct polyline_lengths {
+  struct line_lengths *ll;
+  double total_length;
+  int longest_line_index;
+  int longest_segment_line_index, longest_segment_point_index;
+};
+
+struct label_auto_result {
+  pointObj *label_points;
+  double *angles;
+  int num_label_points;
+};
+
+struct label_follow_result {
+  textSymbolObj **follow_labels;
+  int num_follow_labels;
+  struct label_auto_result lar;
+};
 
-  MS_DLL_EXPORT int msDrawRasterLayer(mapObj *map, layerObj *layer, imageObj *image); /* in mapraster.c */
-  MS_DLL_EXPORT imageObj *msDrawReferenceMap(mapObj *map);
+#endif
 
-  /* mapbits.c - bit array handling functions and macros */
+MS_DLL_EXPORT void msTransformPixelToShape(shapeObj *shape, rectObj extent,
+                                           double cellsize);
+MS_DLL_EXPORT void msPolylineComputeLineSegments(shapeObj *shape,
+                                                 struct polyline_lengths *pll);
+MS_DLL_EXPORT int msPolylineLabelPath(mapObj *map, imageObj *image, shapeObj *p,
+                                      textSymbolObj *ts, labelObj *label,
+                                      struct label_follow_result *lfr);
+MS_DLL_EXPORT int WARN_UNUSED msPolylineLabelPoint(
+    mapObj *map, shapeObj *p, textSymbolObj *ts, labelObj *label,
+    struct label_auto_result *lar, double resolutionfactor);
+MS_DLL_EXPORT int WARN_UNUSED msLineLabelPath(mapObj *map, imageObj *img,
+                                              lineObj *p, textSymbolObj *ts,
+                                              struct line_lengths *ll,
+                                              struct label_follow_result *lfr,
+                                              labelObj *lbl);
+MS_DLL_EXPORT int WARN_UNUSED msLineLabelPoint(
+    mapObj *map, lineObj *p, textSymbolObj *ts, struct line_lengths *ll,
+    struct label_auto_result *lar, labelObj *lbl, double resolutionfactor);
+MS_DLL_EXPORT int msPolygonLabelPoint(shapeObj *p, pointObj *lp,
+                                      double min_dimension);
+MS_DLL_EXPORT int msAddLine(shapeObj *p, const lineObj *new_line);
+MS_DLL_EXPORT int msAddLineDirectly(shapeObj *p, lineObj *new_line);
+MS_DLL_EXPORT int msAddPointToLine(lineObj *line, pointObj *point);
+MS_DLL_EXPORT double msGetPolygonArea(shapeObj *p);
+MS_DLL_EXPORT int msGetPolygonCentroid(shapeObj *p, pointObj *lp, double *miny,
+                                       double *maxy);
+
+MS_DLL_EXPORT int msDrawRasterLayer(mapObj *map, layerObj *layer,
+                                    imageObj *image); /* in mapraster.c */
+MS_DLL_EXPORT imageObj *msDrawReferenceMap(mapObj *map);
+
+/* mapbits.c - bit array handling functions and macros */
 
 #define MS_ARRAY_BIT 32
 
-#define MS_GET_BIT(array,i) (array[i>>5] & (1 <<(i & 0x3f)))
-#define MS_SET_BIT(array,i) {array[i>>5] |= (1 <<(i & 0x3f));}
-#define MS_CLR_BIT(array,i) {array[i>>5] &= (~(1 <<(i & 0x3f)));}
-
-  MS_DLL_EXPORT size_t msGetBitArraySize(int numbits); /* in mapbits.c */
-  MS_DLL_EXPORT ms_bitarray msAllocBitArray(int numbits);
-  MS_DLL_EXPORT int msGetBit(ms_const_bitarray array, int index);
-  MS_DLL_EXPORT void msSetBit(ms_bitarray array, int index, int value);
-  MS_DLL_EXPORT void msSetAllBits(ms_bitarray array, int index, int value);
-  MS_DLL_EXPORT void msFlipBit(ms_bitarray array, int index);
-  MS_DLL_EXPORT int msGetNextBit(ms_const_bitarray array, int index, int size);
-
-  /* maplayer.c - layerObj  api */
-
-  MS_DLL_EXPORT int msLayerInitItemInfo(layerObj *layer);
-  MS_DLL_EXPORT void msLayerFreeItemInfo(layerObj *layer);
-
-  MS_DLL_EXPORT int msLayerOpen(layerObj *layer); /* in maplayer.c */
-  MS_DLL_EXPORT int msLayerApplyScaletokens(layerObj *layer, double scale);
-  MS_DLL_EXPORT int msLayerRestoreFromScaletokens(layerObj *layer);
-  MS_DLL_EXPORT int msClusterLayerOpen(layerObj *layer); /* in mapcluster.c */
-  MS_DLL_EXPORT int msLayerIsOpen(layerObj *layer);
-  MS_DLL_EXPORT void msLayerClose(layerObj *layer);
-  MS_DLL_EXPORT void msLayerFreeExpressions(layerObj *layer);
-  MS_DLL_EXPORT int msLayerWhichShapes(layerObj *layer, rectObj rect, int isQuery);
-  MS_DLL_EXPORT int msLayerGetItemIndex(layerObj *layer, char *item);
-  MS_DLL_EXPORT int msLayerWhichItems(layerObj *layer, int get_all, const char *metadata);
-  MS_DLL_EXPORT int msLayerNextShape(layerObj *layer, shapeObj *shape);
-  MS_DLL_EXPORT int msLayerGetItems(layerObj *layer);
-  MS_DLL_EXPORT int msLayerSetItems(layerObj *layer, char **items, int numitems);
-  MS_DLL_EXPORT int msLayerGetShape(layerObj *layer, shapeObj *shape, resultObj *record);
-  MS_DLL_EXPORT int msLayerGetShapeCount(layerObj *layer, rectObj rect, projectionObj *rectProjection);
-  MS_DLL_EXPORT int msLayerGetExtent(layerObj *layer, rectObj *extent);
-  MS_DLL_EXPORT int msLayerSetExtent( layerObj *layer, double minx, double miny, double maxx, double maxy);
-  MS_DLL_EXPORT int msLayerGetAutoStyle(mapObj *map, layerObj *layer, classObj *c, shapeObj* shape);
-  MS_DLL_EXPORT int msLayerGetFeatureStyle(mapObj *map, layerObj *layer, classObj *c, shapeObj* shape);
-  MS_DLL_EXPORT void msLayerAddProcessing( layerObj *layer, const char *directive );
-  MS_DLL_EXPORT void msLayerSetProcessingKey( layerObj *layer, const char *key, const char *value);
-  MS_DLL_EXPORT const char *msLayerGetProcessing( const layerObj *layer, int proc_index);
-  MS_DLL_EXPORT const char *msLayerGetProcessingKey( const layerObj *layer, const char *);
-  MS_DLL_EXPORT int msLayerClearProcessing( layerObj *layer );
-  MS_DLL_EXPORT void msLayerSubstituteProcessing( layerObj *layer, const char *from, const char *to );
-  MS_DLL_EXPORT char *msLayerGetFilterString( layerObj *layer );
-  MS_DLL_EXPORT int msLayerEncodeShapeAttributes( layerObj *layer, shapeObj *shape);
-
-  MS_DLL_EXPORT int msLayerTranslateFilter(layerObj *layer, expressionObj *filter, char *filteritem);
-  MS_DLL_EXPORT int msLayerSupportsCommonFilters(layerObj *layer);
-  MS_DLL_EXPORT const char *msExpressionTokenToString(int token);
-  MS_DLL_EXPORT int msTokenizeExpression(expressionObj *expression, char **list, int *listsize);
-
-  MS_DLL_EXPORT int msLayerSetTimeFilter(layerObj *lp, const char *timestring, const char *timefield);
-  MS_DLL_EXPORT int msLayerMakeBackticsTimeFilter(layerObj *lp, const char *timestring, const char *timefield);
-  MS_DLL_EXPORT int msLayerMakePlainTimeFilter(layerObj *lp, const char *timestring, const char *timefield);
-
-  MS_DLL_EXPORT int msLayerApplyCondSQLFilterToLayer(FilterEncodingNode *psNode, mapObj *map, int iLayerIndex);
-  MS_DLL_EXPORT int msLayerApplyPlainFilterToLayer(FilterEncodingNode *psNode, mapObj *map, int iLayerIndex);
-
-  /* maplayer.c */
-  MS_DLL_EXPORT int msLayerGetNumFeatures(layerObj *layer);
-
-  MS_DLL_EXPORT int msLayerSupportsPaging(layerObj *layer);
-
-  MS_DLL_EXPORT void msLayerEnablePaging(layerObj *layer, int value);
-  MS_DLL_EXPORT int msLayerGetPaging(layerObj *layer);
-
-  MS_DLL_EXPORT int msLayerGetMaxFeaturesToDraw(layerObj *layer, outputFormatObj *format);
-
-  MS_DLL_EXPORT char *msLayerEscapeSQLParam(layerObj *layer, const char* pszString);
-  MS_DLL_EXPORT char *msLayerEscapePropertyName(layerObj *layer, const char* pszString);
-
-  int msLayerSupportsSorting(layerObj *layer);
-  void msLayerSetSort(layerObj *layer, const sortByClause* sortBy);
-  MS_DLL_EXPORT char* msLayerBuildSQLOrderBy(layerObj *layer);
-
-  /* These are special because SWF is using these */
-  int msOGRLayerNextShape(layerObj *layer, shapeObj *shape);
-  int msOGRLayerGetItems(layerObj *layer);
-  void msOGRLayerFreeItemInfo(layerObj *layer);
-  int msOGRLayerGetShape(layerObj *layer, shapeObj *shape, resultObj *record);
-  int msOGRLayerGetExtent(layerObj *layer, rectObj *extent);
-
-  MS_DLL_EXPORT int msOGRGeometryToShape(OGRGeometryH hGeometry, shapeObj *shape,
-                                         OGRwkbGeometryType type);
-
-  MS_DLL_EXPORT int msInitializeVirtualTable(layerObj *layer);
-  MS_DLL_EXPORT int msConnectLayer(layerObj *layer, const int connectiontype,
-                                   const char *library_str);
-
-  MS_DLL_EXPORT int msINLINELayerInitializeVirtualTable(layerObj *layer);
-  MS_DLL_EXPORT int msSHPLayerInitializeVirtualTable(layerObj *layer);
-  MS_DLL_EXPORT int msFlatGeobufLayerInitializeVirtualTable(layerObj *layer);
-  MS_DLL_EXPORT int msTiledSHPLayerInitializeVirtualTable(layerObj *layer);
-  MS_DLL_EXPORT int msOGRLayerInitializeVirtualTable(layerObj *layer);
-  MS_DLL_EXPORT int msPostGISLayerInitializeVirtualTable(layerObj *layer);
-  MS_DLL_EXPORT int msOracleSpatialLayerInitializeVirtualTable(layerObj *layer);
-  MS_DLL_EXPORT int msWFSLayerInitializeVirtualTable(layerObj *layer);
-  MS_DLL_EXPORT int msGraticuleLayerInitializeVirtualTable(layerObj *layer);
-  MS_DLL_EXPORT int msRASTERLayerInitializeVirtualTable(layerObj *layer);
-  MS_DLL_EXPORT int msUVRASTERLayerInitializeVirtualTable(layerObj *layer);
-  MS_DLL_EXPORT int msContourLayerInitializeVirtualTable(layerObj *layer);
-  MS_DLL_EXPORT int msPluginLayerInitializeVirtualTable(layerObj *layer);
-  MS_DLL_EXPORT int msUnionLayerInitializeVirtualTable(layerObj *layer);
-  MS_DLL_EXPORT void msPluginFreeVirtualTableFactory(void);
-
-  MS_DLL_EXPORT int LayerDefaultGetShapeCount(layerObj *layer, rectObj rect, projectionObj *rectProjection);
-  void msUVRASTERLayerUseMapExtentAndProjectionForNextWhichShapes(layerObj* layer, mapObj* map);
-  rectObj msUVRASTERGetSearchRect( layerObj* layer, mapObj* map );
-
-  /* ==================================================================== */
-  /*      Prototypes for functions in mapdraw.c                           */
-  /* ==================================================================== */
-
-  MS_DLL_EXPORT imageObj *msPrepareImage(mapObj *map, int allow_nonsquare);
-  MS_DLL_EXPORT imageObj *msDrawMap(mapObj *map, int querymap);
-  MS_DLL_EXPORT int msLayerIsVisible(mapObj *map, layerObj *layer);
-  MS_DLL_EXPORT int msDrawLayer(mapObj *map, layerObj *layer, imageObj *image);
-  MS_DLL_EXPORT int msDrawVectorLayer(mapObj *map, layerObj *layer, imageObj *image);
-  MS_DLL_EXPORT int msDrawQueryLayer(mapObj *map, layerObj *layer, imageObj *image);
-  MS_DLL_EXPORT int msDrawWMSLayer(mapObj *map, layerObj *layer, imageObj *image);
-  MS_DLL_EXPORT int msDrawWFSLayer(mapObj *map, layerObj *layer, imageObj *image);
-
-#define MS_DRAWMODE_FEATURES    0x00001
-#define MS_DRAW_FEATURES(mode) (MS_DRAWMODE_FEATURES&(mode))
-#define MS_DRAWMODE_LABELS      0x00002
-#define MS_DRAW_LABELS(mode) (MS_DRAWMODE_LABELS&(mode))
+#define MS_GET_BIT(array, i) (array[i >> 5] & (1 << (i & 0x3f)))
+#define MS_SET_BIT(array, i)                                                   \
+  { array[i >> 5] |= (1 << (i & 0x3f)); }
+#define MS_CLR_BIT(array, i)                                                   \
+  { array[i >> 5] &= (~(1 << (i & 0x3f))); }
+
+MS_DLL_EXPORT size_t msGetBitArraySize(int numbits); /* in mapbits.c */
+MS_DLL_EXPORT ms_bitarray msAllocBitArray(int numbits);
+MS_DLL_EXPORT int msGetBit(ms_const_bitarray array, int index);
+MS_DLL_EXPORT void msSetBit(ms_bitarray array, int index, int value);
+MS_DLL_EXPORT void msSetAllBits(ms_bitarray array, int index, int value);
+MS_DLL_EXPORT void msFlipBit(ms_bitarray array, int index);
+MS_DLL_EXPORT int msGetNextBit(ms_const_bitarray array, int index, int size);
+
+/* maplayer.c - layerObj  api */
+
+MS_DLL_EXPORT int msLayerInitItemInfo(layerObj *layer);
+MS_DLL_EXPORT void msLayerFreeItemInfo(layerObj *layer);
+
+MS_DLL_EXPORT int msLayerOpen(layerObj *layer); /* in maplayer.c */
+MS_DLL_EXPORT int msLayerApplyScaletokens(layerObj *layer, double scale);
+MS_DLL_EXPORT int msLayerRestoreFromScaletokens(layerObj *layer);
+MS_DLL_EXPORT int msClusterLayerOpen(layerObj *layer); /* in mapcluster.c */
+MS_DLL_EXPORT int msLayerIsOpen(layerObj *layer);
+MS_DLL_EXPORT void msLayerClose(layerObj *layer);
+MS_DLL_EXPORT void msLayerFreeExpressions(layerObj *layer);
+MS_DLL_EXPORT int msLayerWhichShapes(layerObj *layer, rectObj rect,
+                                     int isQuery);
+MS_DLL_EXPORT int msLayerGetItemIndex(layerObj *layer, char *item);
+MS_DLL_EXPORT int msLayerWhichItems(layerObj *layer, int get_all,
+                                    const char *metadata);
+MS_DLL_EXPORT int msLayerNextShape(layerObj *layer, shapeObj *shape);
+MS_DLL_EXPORT int msLayerGetItems(layerObj *layer);
+MS_DLL_EXPORT int msLayerSetItems(layerObj *layer, char **items, int numitems);
+MS_DLL_EXPORT int msLayerGetShape(layerObj *layer, shapeObj *shape,
+                                  resultObj *record);
+MS_DLL_EXPORT int msLayerGetShapeCount(layerObj *layer, rectObj rect,
+                                       projectionObj *rectProjection);
+MS_DLL_EXPORT int msLayerGetExtent(layerObj *layer, rectObj *extent);
+MS_DLL_EXPORT int msLayerSetExtent(layerObj *layer, double minx, double miny,
+                                   double maxx, double maxy);
+MS_DLL_EXPORT int msLayerGetAutoStyle(mapObj *map, layerObj *layer, classObj *c,
+                                      shapeObj *shape);
+MS_DLL_EXPORT int msLayerGetFeatureStyle(mapObj *map, layerObj *layer,
+                                         classObj *c, shapeObj *shape);
+MS_DLL_EXPORT void msLayerAddProcessing(layerObj *layer, const char *directive);
+MS_DLL_EXPORT void msLayerSetProcessingKey(layerObj *layer, const char *key,
+                                           const char *value);
+MS_DLL_EXPORT const char *msLayerGetProcessing(const layerObj *layer,
+                                               int proc_index);
+MS_DLL_EXPORT const char *msLayerGetProcessingKey(const layerObj *layer,
+                                                  const char *);
+MS_DLL_EXPORT int msLayerClearProcessing(layerObj *layer);
+MS_DLL_EXPORT void
+msLayerSubstituteProcessing(layerObj *layer, const char *from, const char *to);
+MS_DLL_EXPORT char *msLayerGetFilterString(layerObj *layer);
+MS_DLL_EXPORT int msLayerEncodeShapeAttributes(layerObj *layer,
+                                               shapeObj *shape);
+
+MS_DLL_EXPORT int msLayerTranslateFilter(layerObj *layer, expressionObj *filter,
+                                         char *filteritem);
+MS_DLL_EXPORT int msLayerSupportsCommonFilters(layerObj *layer);
+MS_DLL_EXPORT const char *msExpressionTokenToString(int token);
+MS_DLL_EXPORT int msTokenizeExpression(expressionObj *expression, char **list,
+                                       int *listsize);
+
+MS_DLL_EXPORT int msLayerSetTimeFilter(layerObj *lp, const char *timestring,
+                                       const char *timefield);
+MS_DLL_EXPORT int msLayerMakeBackticsTimeFilter(layerObj *lp,
+                                                const char *timestring,
+                                                const char *timefield);
+MS_DLL_EXPORT int msLayerMakePlainTimeFilter(layerObj *lp,
+                                             const char *timestring,
+                                             const char *timefield);
+
+MS_DLL_EXPORT int msLayerApplyCondSQLFilterToLayer(FilterEncodingNode *psNode,
+                                                   mapObj *map,
+                                                   int iLayerIndex);
+MS_DLL_EXPORT int msLayerApplyPlainFilterToLayer(FilterEncodingNode *psNode,
+                                                 mapObj *map, int iLayerIndex);
+
+/* maplayer.c */
+MS_DLL_EXPORT int msLayerGetNumFeatures(layerObj *layer);
+
+MS_DLL_EXPORT int msLayerSupportsPaging(layerObj *layer);
+
+MS_DLL_EXPORT void msLayerEnablePaging(layerObj *layer, int value);
+MS_DLL_EXPORT int msLayerGetPaging(layerObj *layer);
+
+MS_DLL_EXPORT int msLayerGetMaxFeaturesToDraw(layerObj *layer,
+                                              outputFormatObj *format);
+
+MS_DLL_EXPORT char *msLayerEscapeSQLParam(layerObj *layer,
+                                          const char *pszString);
+MS_DLL_EXPORT char *msLayerEscapePropertyName(layerObj *layer,
+                                              const char *pszString);
+
+int msLayerSupportsSorting(layerObj *layer);
+void msLayerSetSort(layerObj *layer, const sortByClause *sortBy);
+MS_DLL_EXPORT char *msLayerBuildSQLOrderBy(layerObj *layer);
+
+/* These are special because SWF is using these */
+int msOGRLayerNextShape(layerObj *layer, shapeObj *shape);
+int msOGRLayerGetItems(layerObj *layer);
+void msOGRLayerFreeItemInfo(layerObj *layer);
+int msOGRLayerGetShape(layerObj *layer, shapeObj *shape, resultObj *record);
+int msOGRLayerGetExtent(layerObj *layer, rectObj *extent);
+
+reprojectionObj MS_DLL_EXPORT *msLayerGetReprojectorToMap(layerObj *layer,
+                                                          mapObj *map);
+
+MS_DLL_EXPORT int msOGRGeometryToShape(OGRGeometryH hGeometry, shapeObj *shape,
+                                       OGRwkbGeometryType type);
+
+MS_DLL_EXPORT int msInitializeVirtualTable(layerObj *layer);
+MS_DLL_EXPORT int msConnectLayer(layerObj *layer, const int connectiontype,
+                                 const char *library_str);
+
+MS_DLL_EXPORT int msINLINELayerInitializeVirtualTable(layerObj *layer);
+MS_DLL_EXPORT int msSHPLayerInitializeVirtualTable(layerObj *layer);
+MS_DLL_EXPORT int msFlatGeobufLayerInitializeVirtualTable(layerObj *layer);
+MS_DLL_EXPORT int msTiledSHPLayerInitializeVirtualTable(layerObj *layer);
+MS_DLL_EXPORT int msOGRLayerInitializeVirtualTable(layerObj *layer);
+MS_DLL_EXPORT int msPostGISLayerInitializeVirtualTable(layerObj *layer);
+MS_DLL_EXPORT int msOracleSpatialLayerInitializeVirtualTable(layerObj *layer);
+MS_DLL_EXPORT int msWFSLayerInitializeVirtualTable(layerObj *layer);
+MS_DLL_EXPORT int msGraticuleLayerInitializeVirtualTable(layerObj *layer);
+MS_DLL_EXPORT int msRASTERLayerInitializeVirtualTable(layerObj *layer);
+MS_DLL_EXPORT int msUVRASTERLayerInitializeVirtualTable(layerObj *layer);
+MS_DLL_EXPORT int msContourLayerInitializeVirtualTable(layerObj *layer);
+MS_DLL_EXPORT int msPluginLayerInitializeVirtualTable(layerObj *layer);
+MS_DLL_EXPORT int msUnionLayerInitializeVirtualTable(layerObj *layer);
+MS_DLL_EXPORT void msPluginFreeVirtualTableFactory(void);
+
+MS_DLL_EXPORT int LayerDefaultGetShapeCount(layerObj *layer, rectObj rect,
+                                            projectionObj *rectProjection);
+void msUVRASTERLayerUseMapExtentAndProjectionForNextWhichShapes(layerObj *layer,
+                                                                mapObj *map);
+rectObj msUVRASTERGetSearchRect(layerObj *layer, mapObj *map);
+
+/* ==================================================================== */
+/*      Prototypes for functions in mapdraw.c                           */
+/* ==================================================================== */
+
+MS_DLL_EXPORT imageObj *msPrepareImage(mapObj *map, int allow_nonsquare);
+MS_DLL_EXPORT imageObj *msDrawMap(mapObj *map, int querymap);
+MS_DLL_EXPORT int msLayerIsVisible(mapObj *map, layerObj *layer);
+MS_DLL_EXPORT int msDrawLayer(mapObj *map, layerObj *layer, imageObj *image);
+MS_DLL_EXPORT int msDrawVectorLayer(mapObj *map, layerObj *layer,
+                                    imageObj *image);
+MS_DLL_EXPORT int msDrawQueryLayer(mapObj *map, layerObj *layer,
+                                   imageObj *image);
+MS_DLL_EXPORT int msDrawWMSLayer(mapObj *map, layerObj *layer, imageObj *image);
+MS_DLL_EXPORT int msDrawWFSLayer(mapObj *map, layerObj *layer, imageObj *image);
+
+#define MS_DRAWMODE_FEATURES 0x00001
+#define MS_DRAW_FEATURES(mode) (MS_DRAWMODE_FEATURES & (mode))
+#define MS_DRAWMODE_LABELS 0x00002
+#define MS_DRAW_LABELS(mode) (MS_DRAWMODE_LABELS & (mode))
 #define MS_DRAWMODE_SINGLESTYLE 0x00004
-#define MS_DRAW_SINGLESTYLE(mode) (MS_DRAWMODE_SINGLESTYLE&(mode))
-#define MS_DRAWMODE_QUERY       0x00008
-#define MS_DRAW_QUERY(mode) (MS_DRAWMODE_QUERY&(mode))
-#define MS_DRAWMODE_UNCLIPPEDLABELS       0x00010
-#define MS_DRAW_UNCLIPPED_LABELS(mode) (MS_DRAWMODE_UNCLIPPEDLABELS&(mode))
-#define MS_DRAWMODE_UNCLIPPEDLINES       0x00020
-#define MS_DRAW_UNCLIPPED_LINES(mode) (MS_DRAWMODE_UNCLIPPEDLINES&(mode))
-
-  MS_DLL_EXPORT int WARN_UNUSED msDrawShape(mapObj *map, layerObj *layer, shapeObj *shape, imageObj *image, int style, int mode);
-  MS_DLL_EXPORT int WARN_UNUSED msDrawPoint(mapObj *map, layerObj *layer, pointObj *point, imageObj *image, int classindex, char *labeltext);
-
-  /*Range Support*/
-  typedef enum {
-    MS_COLORSPACE_RGB,
-    MS_COLORSPACE_HSL
-  } colorspace;
-  MS_DLL_EXPORT int msShapeToRange(styleObj *style, shapeObj *shape);
-  MS_DLL_EXPORT int msValueToRange(styleObj *style, double fieldVal, colorspace cs);
-
-  MS_DLL_EXPORT int WARN_UNUSED msDrawMarkerSymbol(mapObj *map, imageObj *image, pointObj *p, styleObj *style, double scalefactor);
-  MS_DLL_EXPORT int WARN_UNUSED msDrawLineSymbol(mapObj *map, imageObj *image, shapeObj *p, styleObj *style, double scalefactor);
-  MS_DLL_EXPORT int WARN_UNUSED msDrawShadeSymbol(mapObj *map, imageObj *image, shapeObj *p, styleObj *style, double scalefactor);
-  MS_DLL_EXPORT int WARN_UNUSED msCircleDrawLineSymbol(mapObj *map, imageObj *image, pointObj *p, double r, styleObj *style, double scalefactor);
-  MS_DLL_EXPORT int WARN_UNUSED msCircleDrawShadeSymbol(mapObj *map, imageObj *image, pointObj *p, double r, styleObj *style, double scalefactor);
-  MS_DLL_EXPORT int WARN_UNUSED msDrawPieSlice(mapObj *map, imageObj *image, pointObj *p, styleObj *style, double radius, double start, double end);
-  MS_DLL_EXPORT int WARN_UNUSED msDrawLabelBounds(mapObj *map, imageObj *image, label_bounds *bnds, styleObj *style, double scalefactor);
-
-  MS_DLL_EXPORT void msOutlineRenderingPrepareStyle(styleObj *pStyle, mapObj *map, layerObj *layer, imageObj *image);
-  MS_DLL_EXPORT void msOutlineRenderingRestoreStyle(styleObj *pStyle, mapObj *map, layerObj *layer, imageObj *image);
-
-  MS_DLL_EXPORT int WARN_UNUSED msDrawLabel(mapObj *map, imageObj *image, pointObj labelPnt, char *string, labelObj *label, double scalefactor);
-  MS_DLL_EXPORT int WARN_UNUSED msDrawTextSymbol(mapObj *map, imageObj *image, pointObj labelPnt, textSymbolObj *ts);
-  MS_DLL_EXPORT int WARN_UNUSED msDrawLabelCache(mapObj *map, imageObj *image);
-
-  MS_DLL_EXPORT void msImageStartLayer(mapObj *map, layerObj *layer, imageObj *image);
-  MS_DLL_EXPORT void msImageEndLayer(mapObj *map, layerObj *layer, imageObj *image);
-
-  MS_DLL_EXPORT void msDrawStartShape(mapObj *map, layerObj *layer, imageObj *image, shapeObj *shape);
-  MS_DLL_EXPORT void msDrawEndShape(mapObj *map, layerObj *layer, imageObj *image, shapeObj *shape);
-  /* ==================================================================== */
-  /*      End of Prototypes for functions in mapdraw.c                    */
-  /* ==================================================================== */
-
-  /* ==================================================================== */
-  /*      Prototypes for functions in mapgeomutil.cpp                       */
-  /* ==================================================================== */
-  MS_DLL_EXPORT shapeObj *msRasterizeArc(double x0, double y0, double radius, double startAngle, double endAngle, int isSlice);
-  MS_DLL_EXPORT int msHatchPolygon(imageObj *img, shapeObj *poly, double spacing, double width, double *pattern, int patternlength, double angle, colorObj *color);
-
-
-
-  /* ==================================================================== */
-  /*      Prototypes for functions in mapimagemap.c                       */
-  /* ==================================================================== */
-  MS_DLL_EXPORT imageObj *msImageCreateIM(int width, int height, outputFormatObj *format, char *imagepath, char *imageurl, double resolution, double defresolution);
-  MS_DLL_EXPORT void msImageStartLayerIM(mapObj *map, layerObj *layer, imageObj *image);
-  MS_DLL_EXPORT int msSaveImageIM(imageObj* img, const char *filename, outputFormatObj *format);
-  MS_DLL_EXPORT void msFreeImageIM(imageObj* img);
-  MS_DLL_EXPORT void msDrawMarkerSymbolIM(mapObj *map, imageObj* img, pointObj *p, styleObj *style, double scalefactor);
-  MS_DLL_EXPORT void msDrawLineSymbolIM(mapObj *map, imageObj* img, shapeObj *p, styleObj *style, double scalefactor);
-  MS_DLL_EXPORT void msDrawShadeSymbolIM(mapObj *map, imageObj* img, shapeObj *p, styleObj *style, double scalefactor);
-  MS_DLL_EXPORT int msDrawTextIM(mapObj *map, imageObj* img, pointObj labelPnt, char *string, labelObj *label, double scalefactor);
-  /* ==================================================================== */
-  /*      End of Prototypes for functions in mapimagemap.c                */
-  /* ==================================================================== */
-
-
-  /* various JOIN functions (in mapjoin.c) */
-  MS_DLL_EXPORT int msJoinConnect(layerObj *layer, joinObj *join);
-  MS_DLL_EXPORT int msJoinPrepare(joinObj *join, shapeObj *shape);
-  MS_DLL_EXPORT int msJoinNext(joinObj *join);
-  MS_DLL_EXPORT int msJoinClose(joinObj *join);
-
-  /*in mapraster.c */
-  int msDrawRasterLayerLowCheckIfMustDraw(mapObj *map, layerObj *layer);
-  void* msDrawRasterLayerLowOpenDataset(mapObj *map, layerObj *layer,
-                                      const char* filename,
+#define MS_DRAW_SINGLESTYLE(mode) (MS_DRAWMODE_SINGLESTYLE & (mode))
+#define MS_DRAWMODE_QUERY 0x00008
+#define MS_DRAW_QUERY(mode) (MS_DRAWMODE_QUERY & (mode))
+#define MS_DRAWMODE_UNCLIPPEDLABELS 0x00010
+#define MS_DRAW_UNCLIPPED_LABELS(mode) (MS_DRAWMODE_UNCLIPPEDLABELS & (mode))
+#define MS_DRAWMODE_UNCLIPPEDLINES 0x00020
+#define MS_DRAW_UNCLIPPED_LINES(mode) (MS_DRAWMODE_UNCLIPPEDLINES & (mode))
+
+MS_DLL_EXPORT int WARN_UNUSED msDrawShape(mapObj *map, layerObj *layer,
+                                          shapeObj *shape, imageObj *image,
+                                          int style, int mode);
+MS_DLL_EXPORT int WARN_UNUSED msDrawPoint(mapObj *map, layerObj *layer,
+                                          pointObj *point, imageObj *image,
+                                          int classindex, char *labeltext);
+
+/*Range Support*/
+typedef enum { MS_COLORSPACE_RGB, MS_COLORSPACE_HSL } colorspace;
+MS_DLL_EXPORT int msShapeToRange(styleObj *style, shapeObj *shape);
+MS_DLL_EXPORT int msValueToRange(styleObj *style, double fieldVal,
+                                 colorspace cs);
+
+MS_DLL_EXPORT int WARN_UNUSED msDrawMarkerSymbol(mapObj *map, imageObj *image,
+                                                 pointObj *p, styleObj *style,
+                                                 double scalefactor);
+MS_DLL_EXPORT int WARN_UNUSED msDrawLineSymbol(mapObj *map, imageObj *image,
+                                               shapeObj *p, styleObj *style,
+                                               double scalefactor);
+MS_DLL_EXPORT int WARN_UNUSED msDrawShadeSymbol(mapObj *map, imageObj *image,
+                                                shapeObj *p, styleObj *style,
+                                                double scalefactor);
+MS_DLL_EXPORT int WARN_UNUSED msCircleDrawLineSymbol(mapObj *map,
+                                                     imageObj *image,
+                                                     pointObj *p, double r,
+                                                     styleObj *style,
+                                                     double scalefactor);
+MS_DLL_EXPORT int WARN_UNUSED msCircleDrawShadeSymbol(mapObj *map,
+                                                      imageObj *image,
+                                                      pointObj *p, double r,
+                                                      styleObj *style,
+                                                      double scalefactor);
+MS_DLL_EXPORT int WARN_UNUSED msDrawPieSlice(mapObj *map, imageObj *image,
+                                             pointObj *p, styleObj *style,
+                                             double radius, double start,
+                                             double end);
+MS_DLL_EXPORT int WARN_UNUSED msDrawLabelBounds(mapObj *map, imageObj *image,
+                                                label_bounds *bnds,
+                                                styleObj *style,
+                                                double scalefactor);
+
+MS_DLL_EXPORT void msOutlineRenderingPrepareStyle(styleObj *pStyle, mapObj *map,
+                                                  layerObj *layer,
+                                                  imageObj *image);
+MS_DLL_EXPORT void msOutlineRenderingRestoreStyle(styleObj *pStyle, mapObj *map,
+                                                  layerObj *layer,
+                                                  imageObj *image);
+
+MS_DLL_EXPORT int WARN_UNUSED msDrawLabel(mapObj *map, imageObj *image,
+                                          pointObj labelPnt, char *string,
+                                          labelObj *label, double scalefactor);
+MS_DLL_EXPORT int WARN_UNUSED msDrawTextSymbol(mapObj *map, imageObj *image,
+                                               pointObj labelPnt,
+                                               textSymbolObj *ts);
+MS_DLL_EXPORT int WARN_UNUSED msDrawLabelCache(mapObj *map, imageObj *image);
+
+MS_DLL_EXPORT void msImageStartLayer(mapObj *map, layerObj *layer,
+                                     imageObj *image);
+MS_DLL_EXPORT void msImageEndLayer(mapObj *map, layerObj *layer,
+                                   imageObj *image);
+
+MS_DLL_EXPORT void msDrawStartShape(mapObj *map, layerObj *layer,
+                                    imageObj *image, shapeObj *shape);
+MS_DLL_EXPORT void msDrawEndShape(mapObj *map, layerObj *layer, imageObj *image,
+                                  shapeObj *shape);
+/* ==================================================================== */
+/*      End of Prototypes for functions in mapdraw.c                    */
+/* ==================================================================== */
+
+/* ==================================================================== */
+/*      Prototypes for functions in mapgeomutil.cpp                       */
+/* ==================================================================== */
+MS_DLL_EXPORT shapeObj *msRasterizeArc(double x0, double y0, double radius,
+                                       double startAngle, double endAngle,
+                                       int isSlice);
+MS_DLL_EXPORT int msHatchPolygon(imageObj *img, shapeObj *poly, double spacing,
+                                 double width, double *pattern,
+                                 int patternlength, double angle,
+                                 colorObj *color);
+
+/* ==================================================================== */
+/*      Prototypes for functions in mapimagemap.c                       */
+/* ==================================================================== */
+MS_DLL_EXPORT imageObj *
+msImageCreateIM(int width, int height, outputFormatObj *format, char *imagepath,
+                char *imageurl, double resolution, double defresolution);
+MS_DLL_EXPORT void msImageStartLayerIM(mapObj *map, layerObj *layer,
+                                       imageObj *image);
+MS_DLL_EXPORT int msSaveImageIM(imageObj *img, const char *filename,
+                                outputFormatObj *format);
+MS_DLL_EXPORT void msFreeImageIM(imageObj *img);
+MS_DLL_EXPORT void msDrawMarkerSymbolIM(mapObj *map, imageObj *img, pointObj *p,
+                                        styleObj *style, double scalefactor);
+MS_DLL_EXPORT void msDrawLineSymbolIM(mapObj *map, imageObj *img, shapeObj *p,
+                                      styleObj *style, double scalefactor);
+MS_DLL_EXPORT void msDrawShadeSymbolIM(mapObj *map, imageObj *img, shapeObj *p,
+                                       styleObj *style, double scalefactor);
+MS_DLL_EXPORT int msDrawTextIM(mapObj *map, imageObj *img, pointObj labelPnt,
+                               char *string, labelObj *label,
+                               double scalefactor);
+/* ==================================================================== */
+/*      End of Prototypes for functions in mapimagemap.c                */
+/* ==================================================================== */
+
+/* various JOIN functions (in mapjoin.c) */
+MS_DLL_EXPORT int msJoinConnect(layerObj *layer, joinObj *join);
+MS_DLL_EXPORT int msJoinPrepare(joinObj *join, shapeObj *shape);
+MS_DLL_EXPORT int msJoinNext(joinObj *join);
+MS_DLL_EXPORT int msJoinClose(joinObj *join);
+
+/*in mapraster.c */
+int msDrawRasterLayerLowCheckIfMustDraw(mapObj *map, layerObj *layer);
+void *msDrawRasterLayerLowOpenDataset(mapObj *map, layerObj *layer,
+                                      const char *filename,
                                       char szPath[MS_MAXPATHLEN],
-                                      char** p_decrypted_path);
-  void msDrawRasterLayerLowCloseDataset(layerObj *layer, void* hDataset);
-  int msDrawRasterLayerLowWithDataset(mapObj *map, layerObj *layer, imageObj *image, rasterBufferObj *rb, void* hDatasetIn );
-
-  MS_DLL_EXPORT int msDrawRasterLayerLow(mapObj *map, layerObj *layer, imageObj *image, rasterBufferObj *rb );
-  MS_DLL_EXPORT int msGetClass(layerObj *layer, colorObj *color, int colormap_index);
-  MS_DLL_EXPORT int msGetClass_FloatRGB(layerObj *layer, float fValue,
-                                        int red, int green, int blue );
-  int msGetClass_FloatRGB_WithFirstClassToTry(layerObj *layer, float fValue, int red, int green, int blue, int firstClassToTry );
-
-  /* in mapdrawgdal.c */
-  MS_DLL_EXPORT int msDrawRasterLayerGDAL(mapObj *map, layerObj *layer, imageObj *image, rasterBufferObj *rb, void *hDSVoid );
-  MS_DLL_EXPORT int msGetGDALGeoTransform(void *hDS, mapObj *map, layerObj *layer, double *padfGeoTransform );
-  MS_DLL_EXPORT int *msGetGDALBandList( layerObj *layer, void *hDS, int max_bands, int *band_count );
-  MS_DLL_EXPORT double msGetGDALNoDataValue( layerObj *layer, void *hBand, int *pbGotNoData );
-
-  /* in interpolation.c */
-  MS_DLL_EXPORT int msInterpolationDataset(mapObj *map, imageObj *image, layerObj *layer, void **hDSvoid, void **cleanup_ptr);
-  MS_DLL_EXPORT int msCleanupInterpolationDataset(mapObj *map, imageObj *image, layerObj *layer, void *cleanup_ptr);
-
-  /* in mapchart.c */
-  MS_DLL_EXPORT int msDrawChartLayer(mapObj *map, layerObj *layer, imageObj *image);
-
-  /* ==================================================================== */
-  /*      End of prototypes for functions in mapgd.c                      */
-  /* ==================================================================== */
-
-  /* ==================================================================== */
-  /*      Prototypes for functions in maputil.c                           */
-  /* ==================================================================== */
-
-  MS_DLL_EXPORT int msScaleInBounds(double scale, double minscale, double maxscale);
-  MS_DLL_EXPORT void *msSmallMalloc( size_t nSize );
-  MS_DLL_EXPORT void * msSmallRealloc( void * pData, size_t nNewSize );
-  MS_DLL_EXPORT void *msSmallCalloc( size_t nCount, size_t nSize );
-  MS_DLL_EXPORT int msIntegerInArray(const int value, int *array, int numelements);
-
-  MS_DLL_EXPORT int msExtentsOverlap(mapObj *map, layerObj *layer);
-  MS_DLL_EXPORT char *msBuildOnlineResource(mapObj *map, cgiRequestObj *req);
-
-  /* For mapswf */
-  MS_DLL_EXPORT int getRgbColor(mapObj *map,int i,int *r,int *g,int *b); /* maputil.c */
-
-  MS_DLL_EXPORT int msBindLayerToShape(layerObj *layer, shapeObj *shape, int querymapMode);
-  MS_DLL_EXPORT int msValidateContexts(mapObj *map);
-  MS_DLL_EXPORT int msEvalContext(mapObj *map, layerObj *layer, char *context);
-  MS_DLL_EXPORT int msEvalExpression(layerObj *layer, shapeObj *shape, expressionObj *expression, int itemindex);
-  MS_DLL_EXPORT int msShapeGetClass(layerObj *layer, mapObj *map, shapeObj *shape, int *classgroup, int numclasses);
-  MS_DLL_EXPORT int msShapeGetNextClass(int currentclass, layerObj *layer, mapObj *map, shapeObj *shape, int *classgroup, int numclasses);
-  MS_DLL_EXPORT int msShapeCheckSize(shapeObj *shape, double minfeaturesize);
-  MS_DLL_EXPORT char* msShapeGetLabelAnnotation(layerObj *layer, shapeObj *shape, labelObj *lbl);
-  MS_DLL_EXPORT int msGetLabelStatus(mapObj *map, layerObj *layer, shapeObj *shape, labelObj *lbl);
-  MS_DLL_EXPORT int msAdjustImage(rectObj rect, int *width, int *height);
-  MS_DLL_EXPORT char *msEvalTextExpression(expressionObj *expr, shapeObj *shape);
-  MS_DLL_EXPORT char *msEvalTextExpressionJSonEscape(expressionObj *expr, shapeObj *shape);
-  MS_DLL_EXPORT double msEvalDoubleExpression(expressionObj *expr, shapeObj *shape);
-  MS_DLL_EXPORT double msAdjustExtent(rectObj *rect, int width, int height);
-  MS_DLL_EXPORT int msConstrainExtent(rectObj *bounds, rectObj *rect, double overlay);
-  MS_DLL_EXPORT int *msGetLayersIndexByGroup(mapObj *map, char *groupname, int *nCount);
-  MS_DLL_EXPORT unsigned char *msSaveImageBuffer(imageObj* image, int *size_ptr, outputFormatObj *format);
-  MS_DLL_EXPORT shapeObj* msOffsetPolyline(shapeObj* shape, double offsetx, double offsety);
-  MS_DLL_EXPORT int msMapSetLayerProjections(mapObj* map);
-
-  /* Functions to chnage the drawing order of the layers. */
-  /* Defined in mapobject.c */
-  MS_DLL_EXPORT int msMoveLayerUp(mapObj *map, int nLayerIndex);
-  MS_DLL_EXPORT int msMoveLayerDown(mapObj *map, int nLayerIndex);
-  MS_DLL_EXPORT int msSetLayersdrawingOrder(mapObj *self, int *panIndexes);
-  MS_DLL_EXPORT int msInsertLayer(mapObj *map, layerObj *layer, int nIndex);
-  MS_DLL_EXPORT layerObj *msRemoveLayer(mapObj *map, int nIndex);
-
-  /* Defined in layerobject.c */
-  MS_DLL_EXPORT int msInsertClass(layerObj *layer,classObj *classobj,int nIndex);
-  MS_DLL_EXPORT classObj *msRemoveClass(layerObj *layer, int nIndex);
-  MS_DLL_EXPORT int msMoveClassUp(layerObj *layer, int nClassIndex);
-  MS_DLL_EXPORT int msMoveClassDown(layerObj *layer, int nClassIndex);
-
-  /* classobject.c */
-  MS_DLL_EXPORT int msAddLabelToClass(classObj *classo, labelObj *label);
-  MS_DLL_EXPORT labelObj *msRemoveLabelFromClass(classObj *classo, int nLabelIndex);
-  MS_DLL_EXPORT int msMoveStyleUp(classObj *classo, int nStyleIndex);
-  MS_DLL_EXPORT int msMoveStyleDown(classObj *classo, int nStyleIndex);
-  MS_DLL_EXPORT int msDeleteStyle(classObj *classo, int nStyleIndex);
-  MS_DLL_EXPORT int msInsertStyle(classObj *classo, styleObj *style, int nStyleIndex);
-  MS_DLL_EXPORT styleObj *msRemoveStyle(classObj *classo, int index);
-
-  /* maplabel.c */
-  MS_DLL_EXPORT int msInsertLabelStyle(labelObj *label, styleObj *style,
-                                       int nStyleIndex);
-  MS_DLL_EXPORT int msMoveLabelStyleUp(labelObj *label, int nStyleIndex);
-  MS_DLL_EXPORT int msMoveLabelStyleDown(labelObj *label, int nStyleIndex);
-  MS_DLL_EXPORT int msDeleteLabelStyle(labelObj *label, int nStyleIndex);
-  MS_DLL_EXPORT styleObj *msRemoveLabelStyle(labelObj *label, int nStyleIndex);
-
-  /* Measured shape utility functions. */
-  MS_DLL_EXPORT pointObj *msGetPointUsingMeasure(shapeObj *shape, double m);
-  MS_DLL_EXPORT pointObj *msGetMeasureUsingPoint(shapeObj *shape, pointObj *point);
-
-  MS_DLL_EXPORT char **msGetAllGroupNames(mapObj* map, int *numTok);
-  MS_DLL_EXPORT char *msTmpFile(mapObj *map, const char *mappath, const char *tmppath, const char *ext);
-  MS_DLL_EXPORT char *msTmpPath(mapObj *map, const char *mappath, const char *tmppath);
-  MS_DLL_EXPORT char *msTmpFilename(const char *ext);
-  MS_DLL_EXPORT void msForceTmpFileBase( const char *new_base );
-
-
-  MS_DLL_EXPORT imageObj *msImageCreate(int width, int height, outputFormatObj *format, char *imagepath, char *imageurl, double resolution, double defresolution, colorObj *bg);
-
-  MS_DLL_EXPORT void msAlphaBlend(
-    unsigned char red_src, unsigned char green_src,
-    unsigned char blue_src, unsigned char alpha_src,
-    unsigned char *red_dst, unsigned char *green_dst,
-    unsigned char *blue_dst, unsigned char *alpha_dst );
-  MS_DLL_EXPORT void msAlphaBlendPM(
-    unsigned char red_src, unsigned char green_src,
-    unsigned char blue_src, unsigned char alpha_src,
-    unsigned char *red_dst, unsigned char *green_dst,
-    unsigned char *blue_dst, unsigned char *alpha_dst );
-
-  MS_DLL_EXPORT void msRGBtoHSL(colorObj *rgb, double *h, double *s, double *l);
-
-  MS_DLL_EXPORT void msHSLtoRGB(double h, double s, double l, colorObj *rgb);
-
-  MS_DLL_EXPORT int msCheckParentPointer(void* p, const char* objname);
-
-  MS_DLL_EXPORT int *msAllocateValidClassGroups(layerObj *lp, int *nclasses);
-
-  MS_DLL_EXPORT void msFreeRasterBuffer(rasterBufferObj *b);
-  MS_DLL_EXPORT void msSetLayerOpacity(layerObj *layer, int opacity);
-
-  void msMapSetLanguageSpecificConnection(mapObj* map, const char* validated_language);
-  MS_DLL_EXPORT shapeObj* msGeneralize(shapeObj * shape, double tolerance);
-  /* ==================================================================== */
-  /*      End of prototypes for functions in maputil.c                    */
-  /* ==================================================================== */
-
-
-  /* ==================================================================== */
-  /*      prototypes for functions in mapoutput.c                         */
-  /* ==================================================================== */
-
-  MS_DLL_EXPORT void msApplyDefaultOutputFormats( mapObj * );
-  MS_DLL_EXPORT void msFreeOutputFormat( outputFormatObj * );
-  MS_DLL_EXPORT int msGetOutputFormatIndex(mapObj *map, const char *imagetype);
-  MS_DLL_EXPORT int msRemoveOutputFormat(mapObj *map, const char *imagetype);
-  MS_DLL_EXPORT int msAppendOutputFormat(mapObj *map, outputFormatObj *format);
-  MS_DLL_EXPORT outputFormatObj *msSelectOutputFormat( mapObj *map, const char *imagetype );
-  MS_DLL_EXPORT void msApplyOutputFormat( outputFormatObj **target, outputFormatObj *format, int transparent);
-  MS_DLL_EXPORT const char *msGetOutputFormatOption( outputFormatObj *format, const char *optionkey, const char *defaultresult );
-  MS_DLL_EXPORT outputFormatObj *msCreateDefaultOutputFormat( mapObj *map, const char *driver, const char *name, const char *mimetype );
-  MS_DLL_EXPORT int msPostMapParseOutputFormatSetup( mapObj *map );
-  MS_DLL_EXPORT void msSetOutputFormatOption( outputFormatObj *format, const char *key, const char *value );
-  MS_DLL_EXPORT void msGetOutputFormatMimeList( mapObj *map, char **mime_list, int max_mime );
-  MS_DLL_EXPORT void msGetOutputFormatMimeListImg( mapObj *map, const char **mime_list, int max_mime );
-  MS_DLL_EXPORT void msGetOutputFormatMimeListWMS( mapObj *map, const char **mime_list, int max_mime );
-  MS_DLL_EXPORT outputFormatObj *msCloneOutputFormat( outputFormatObj *format );
-  MS_DLL_EXPORT int msOutputFormatValidate( outputFormatObj *format,
-      int issue_error );
-  void  msOutputFormatResolveFromImage( mapObj *map, imageObj* img );
-
-  /* ==================================================================== */
-  /*      End of prototypes for functions in mapoutput.c                  */
-  /* ==================================================================== */
-
-  /* ==================================================================== */
-  /*      prototypes for functions in mapgdal.c                           */
-  /* ==================================================================== */
-  MS_DLL_EXPORT int msSaveImageGDAL( mapObj *map, imageObj *image, const char *filename );
-  MS_DLL_EXPORT int msInitDefaultGDALOutputFormat( outputFormatObj *format );
-  void msCleanVSIDir( const char *pszDir );
-  char** msGetStringListFromHashTable(hashTableObj* table);
-
-  /* ==================================================================== */
-  /*      prototypes for functions in mapogroutput.c                      */
-  /* ==================================================================== */
-  MS_DLL_EXPORT int msInitDefaultOGROutputFormat( outputFormatObj *format );
-  MS_DLL_EXPORT int msOGRWriteFromQuery( mapObj *map, outputFormatObj *format,
-                                         int sendheaders );
-
-  /* ==================================================================== */
-  /*      Public prototype for mapogr.cpp functions.                      */
-  /* ==================================================================== */
-  int MS_DLL_EXPORT msOGRLayerWhichShapes(layerObj *layer, rectObj rect, int isQuery);
-  int MS_DLL_EXPORT msOGRLayerOpen(layerObj *layer, const char *pszOverrideConnection); /* in mapogr.cpp */
-  int MS_DLL_EXPORT msOGRLayerClose(layerObj *layer);
-
-  char MS_DLL_EXPORT *msOGRShapeToWKT(shapeObj *shape);
-  shapeObj MS_DLL_EXPORT *msOGRShapeFromWKT(const char *string);
-  int msOGRUpdateStyleFromString(mapObj *map, layerObj *layer, classObj *c,
-                                 const char *stylestring);
-
-  /* ==================================================================== */
-  /*      prototypes for functions in mapcopy                             */
-  /* ==================================================================== */
-  MS_DLL_EXPORT int msCopyMap(mapObj *dst, const mapObj *src);
-  MS_DLL_EXPORT int msCopyLayer(layerObj *dst, const layerObj *src);
-  MS_DLL_EXPORT int msCopyScaleToken(const scaleTokenObj *src, scaleTokenObj *dst);
-  MS_DLL_EXPORT int msCopyPoint(pointObj *dst, const pointObj *src);
-  MS_DLL_EXPORT int msCopyFontSet(fontSetObj *dst, const fontSetObj *src, mapObj *map);
-  MS_DLL_EXPORT void copyProperty(void *dst, const void *src, int size);
-  MS_DLL_EXPORT char *copyStringProperty(char **dst, const char *src);
-  MS_DLL_EXPORT int msCopyClass(classObj *dst, const classObj *src, layerObj *layer);
-  MS_DLL_EXPORT int msCopyStyle(styleObj *dst, const styleObj *src);
-  MS_DLL_EXPORT int msCopyLabel(labelObj *dst, const labelObj *src);
-  MS_DLL_EXPORT int msCopyLabelLeader(labelLeaderObj *dst, const labelLeaderObj *src);
-  MS_DLL_EXPORT int msCopyLine(lineObj *dst, const lineObj *src);
-  MS_DLL_EXPORT int msCopyProjection(projectionObj *dst, const projectionObj *src);
-  MS_DLL_EXPORT int msCopyProjectionExtended(projectionObj *dst, const projectionObj *src, char ** args, int num_args);
-  int msCopyExpression(expressionObj *dst, const expressionObj *src);
-  int msCopyProjection(projectionObj *dst, const projectionObj *src);
-  MS_DLL_EXPORT int msCopyRasterBuffer(rasterBufferObj *dst, const rasterBufferObj *src);
-
-  /* ==================================================================== */
-  /*      end prototypes for functions in mapcopy                         */
-  /* ==================================================================== */
-
-  /* ==================================================================== */
-  /*      mappool.c: connection pooling API.                              */
-  /* ==================================================================== */
-  MS_DLL_EXPORT void *msConnPoolRequest( layerObj *layer );
-  MS_DLL_EXPORT void msConnPoolRelease( layerObj *layer, void * );
-  MS_DLL_EXPORT void msConnPoolRegister( layerObj *layer,
-                                         void *conn_handle,
-                                         void (*close)( void * ) );
-  MS_DLL_EXPORT void msConnPoolCloseUnreferenced( void );
-  MS_DLL_EXPORT void msConnPoolFinalCleanup( void );
-
-  /* ==================================================================== */
-  /*      prototypes for functions in mapcpl.c                            */
-  /* ==================================================================== */
-  MS_DLL_EXPORT const char *msGetBasename( const char *pszFullFilename );
-  MS_DLL_EXPORT void *msGetSymbol(const char *pszLibrary,
-                                  const char *pszEntryPoint);
-
-  /* ==================================================================== */
-  /*      prototypes for functions in mapgeos.c                         */
-  /* ==================================================================== */
-  MS_DLL_EXPORT void msGEOSSetup(void);
-  MS_DLL_EXPORT void msGEOSCleanup(void);
-  MS_DLL_EXPORT void msGEOSFreeGeometry(shapeObj *shape);
-
-  MS_DLL_EXPORT shapeObj *msGEOSShapeFromWKT(const char *string);
-  MS_DLL_EXPORT char *msGEOSShapeToWKT(shapeObj *shape);
-  MS_DLL_EXPORT void msGEOSFreeWKT(char* pszGEOSWKT);
-
-  MS_DLL_EXPORT shapeObj *msGEOSBuffer(shapeObj *shape, double width);
-  MS_DLL_EXPORT shapeObj *msGEOSSimplify(shapeObj *shape, double tolerance);
-  MS_DLL_EXPORT shapeObj *msGEOSTopologyPreservingSimplify(shapeObj *shape, double tolerance);
-  MS_DLL_EXPORT shapeObj *msGEOSConvexHull(shapeObj *shape);
-  MS_DLL_EXPORT shapeObj *msGEOSBoundary(shapeObj *shape);
-  MS_DLL_EXPORT pointObj *msGEOSGetCentroid(shapeObj *shape);
-  MS_DLL_EXPORT shapeObj *msGEOSUnion(shapeObj *shape1, shapeObj *shape2);
-  MS_DLL_EXPORT shapeObj *msGEOSIntersection(shapeObj *shape1, shapeObj *shape2);
-  MS_DLL_EXPORT shapeObj *msGEOSDifference(shapeObj *shape1, shapeObj *shape2);
-  MS_DLL_EXPORT shapeObj *msGEOSSymDifference(shapeObj *shape1, shapeObj *shape2);
-  MS_DLL_EXPORT shapeObj *msGEOSOffsetCurve(shapeObj *p, double offset);
-  MS_DLL_EXPORT shapeObj *msGEOSVoronoiDiagram(shapeObj *shape, double tolerance, int onlyEdges);
-  MS_DLL_EXPORT shapeObj *msGEOSCenterline(shapeObj *shape);
-
-  MS_DLL_EXPORT int msGEOSContains(shapeObj *shape1, shapeObj *shape2);
-  MS_DLL_EXPORT int msGEOSOverlaps(shapeObj *shape1, shapeObj *shape2);
-  MS_DLL_EXPORT int msGEOSWithin(shapeObj *shape1, shapeObj *shape2);
-  MS_DLL_EXPORT int msGEOSCrosses(shapeObj *shape1, shapeObj *shape2);
-  MS_DLL_EXPORT int msGEOSIntersects(shapeObj *shape1, shapeObj *shape2);
-  MS_DLL_EXPORT int msGEOSTouches(shapeObj *shape1, shapeObj *shape2);
-  MS_DLL_EXPORT int msGEOSEquals(shapeObj *shape1, shapeObj *shape2);
-  MS_DLL_EXPORT int msGEOSDisjoint(shapeObj *shape1, shapeObj *shape2);
-
-  MS_DLL_EXPORT double msGEOSArea(shapeObj *shape);
-  MS_DLL_EXPORT double msGEOSLength(shapeObj *shape);
-  MS_DLL_EXPORT double msGEOSDistance(shapeObj *shape1, shapeObj *shape2);
-
-  /* ==================================================================== */
-  /*      prototypes for functions in mapcrypto.c                         */
-  /* ==================================================================== */
-  MS_DLL_EXPORT int msGenerateEncryptionKey(unsigned char *k);
-  MS_DLL_EXPORT int msReadEncryptionKeyFromFile(const char *keyfile, unsigned char *k);
-  MS_DLL_EXPORT void msEncryptStringWithKey(const unsigned char *key, const char *in, char *out);
-  MS_DLL_EXPORT void msDecryptStringWithKey(const unsigned char *key, const char *in, char *out);
-  MS_DLL_EXPORT char *msDecryptStringTokens(mapObj *map, const char *in);
-  MS_DLL_EXPORT void msHexEncode(const unsigned char *in, char *out, int numbytes);
-  MS_DLL_EXPORT int msHexDecode(const char *in, unsigned char *out, int numchars);
-
-  /* ==================================================================== */
-  /*      prototypes for functions in mapxmp.c                            */
-  /* ==================================================================== */
-  MS_DLL_EXPORT int msXmpPresent(mapObj *map);
-  MS_DLL_EXPORT int msXmpWrite(mapObj *map, const char *filename);
-
-  /* ==================================================================== */
-  /*      prototypes for functions in mapgeomtransform.c                  */
-  /* ==================================================================== */
-  enum MS_GEOMTRANSFORM_TYPE {
-    MS_GEOMTRANSFORM_NONE,
-    MS_GEOMTRANSFORM_EXPRESSION,
-    MS_GEOMTRANSFORM_START,
-    MS_GEOMTRANSFORM_END,
-    MS_GEOMTRANSFORM_VERTICES,
-    MS_GEOMTRANSFORM_BBOX,
-    MS_GEOMTRANSFORM_CENTROID,
-    MS_GEOMTRANSFORM_BUFFER,
-    MS_GEOMTRANSFORM_CONVEXHULL,
-    MS_GEOMTRANSFORM_LABELPOINT,
-    MS_GEOMTRANSFORM_LABELPOLY,
-    MS_GEOMTRANSFORM_LABELCENTER
-  };
-
-  MS_DLL_EXPORT int msDrawTransformedShape(mapObj *map, imageObj *image, shapeObj *shape, styleObj *style, double scalefactor);
-  MS_DLL_EXPORT void msStyleSetGeomTransform(styleObj *s, char *transform);
-  MS_DLL_EXPORT char *msStyleGetGeomTransform(styleObj *style);
-
-  MS_DLL_EXPORT int msGeomTransformShape(mapObj *map, layerObj *layer, shapeObj *shape);
-
-  /* ==================================================================== */
-  /*      end of prototypes for functions in mapgeomtransform.c                 */
-  /* ==================================================================== */
-
-
-  /* ==================================================================== */
-  /*      prototypes for functions in mapgraticule.c                      */
-  /* ==================================================================== */
-  MS_DLL_EXPORT graticuleIntersectionObj *msGraticuleLayerGetIntersectionPoints(mapObj *map, layerObj *layer);
-  MS_DLL_EXPORT void msGraticuleLayerFreeIntersectionPoints( graticuleIntersectionObj *psValue);
-
-  /* ==================================================================== */
-  /*      end of prototypes for functions in mapgraticule.c               */
-  /* ==================================================================== */
-
-  /* ==================================================================== */
-  /*      prototypes for functions in mapsmoothing.c                      */
-  /* ==================================================================== */
-  MS_DLL_EXPORT shapeObj* msSmoothShapeSIA(shapeObj *shape, int ss, int si, char *preprocessing);
-
-  /* ==================================================================== */
-  /*      end of prototypes for functions in mapsmoothing.c               */
-  /* ==================================================================== */
-
-  /* ==================================================================== */
-  /*      prototypes for functions in mapv8.cpp                           */
-  /* ==================================================================== */
+                                      char **p_decrypted_path);
+void msDrawRasterLayerLowCloseDataset(layerObj *layer, void *hDataset);
+int msDrawRasterLayerLowWithDataset(mapObj *map, layerObj *layer,
+                                    imageObj *image, rasterBufferObj *rb,
+                                    void *hDatasetIn);
+
+MS_DLL_EXPORT int msDrawRasterLayerLow(mapObj *map, layerObj *layer,
+                                       imageObj *image, rasterBufferObj *rb);
+MS_DLL_EXPORT int msGetClass(layerObj *layer, colorObj *color,
+                             int colormap_index);
+MS_DLL_EXPORT int msGetClass_FloatRGB(layerObj *layer, float fValue, int red,
+                                      int green, int blue);
+int msGetClass_FloatRGB_WithFirstClassToTry(layerObj *layer, float fValue,
+                                            int red, int green, int blue,
+                                            int firstClassToTry);
+
+/* in mapdrawgdal.c */
+MS_DLL_EXPORT int msDrawRasterLayerGDAL(mapObj *map, layerObj *layer,
+                                        imageObj *image, rasterBufferObj *rb,
+                                        void *hDSVoid);
+MS_DLL_EXPORT int msGetGDALGeoTransform(void *hDS, mapObj *map, layerObj *layer,
+                                        double *padfGeoTransform);
+MS_DLL_EXPORT int *msGetGDALBandList(layerObj *layer, void *hDS, int max_bands,
+                                     int *band_count);
+MS_DLL_EXPORT double msGetGDALNoDataValue(layerObj *layer, void *hBand,
+                                          int *pbGotNoData);
+
+/* in interpolation.c */
+MS_DLL_EXPORT int msInterpolationDataset(mapObj *map, imageObj *image,
+                                         layerObj *layer, void **hDSvoid,
+                                         void **cleanup_ptr);
+MS_DLL_EXPORT int msCleanupInterpolationDataset(mapObj *map, imageObj *image,
+                                                layerObj *layer,
+                                                void *cleanup_ptr);
+
+/* in mapchart.c */
+MS_DLL_EXPORT int msDrawChartLayer(mapObj *map, layerObj *layer,
+                                   imageObj *image);
+
+/* ==================================================================== */
+/*      End of prototypes for functions in mapgd.c                      */
+/* ==================================================================== */
+
+/* ==================================================================== */
+/*      Prototypes for functions in maputil.c                           */
+/* ==================================================================== */
+
+MS_DLL_EXPORT int msScaleInBounds(double scale, double minscale,
+                                  double maxscale);
+MS_DLL_EXPORT void *msSmallMalloc(size_t nSize);
+MS_DLL_EXPORT void *msSmallRealloc(void *pData, size_t nNewSize);
+MS_DLL_EXPORT void *msSmallCalloc(size_t nCount, size_t nSize);
+MS_DLL_EXPORT int msIntegerInArray(const int value, int *array,
+                                   int numelements);
+
+MS_DLL_EXPORT int msExtentsOverlap(mapObj *map, layerObj *layer);
+MS_DLL_EXPORT char *msBuildOnlineResource(mapObj *map, cgiRequestObj *req);
+
+/* For mapswf */
+MS_DLL_EXPORT int getRgbColor(mapObj *map, int i, int *r, int *g,
+                              int *b); /* maputil.c */
+
+MS_DLL_EXPORT int msBindLayerToShape(layerObj *layer, shapeObj *shape,
+                                     int querymapMode);
+MS_DLL_EXPORT int msValidateContexts(mapObj *map);
+MS_DLL_EXPORT int msEvalContext(mapObj *map, layerObj *layer, char *context);
+MS_DLL_EXPORT int msEvalExpression(layerObj *layer, shapeObj *shape,
+                                   expressionObj *expression, int itemindex);
+MS_DLL_EXPORT int msShapeGetClass(layerObj *layer, mapObj *map, shapeObj *shape,
+                                  int *classgroup, int numclasses);
+MS_DLL_EXPORT int msShapeGetNextClass(int currentclass, layerObj *layer,
+                                      mapObj *map, shapeObj *shape,
+                                      int *classgroup, int numclasses);
+MS_DLL_EXPORT int msShapeCheckSize(shapeObj *shape, double minfeaturesize);
+MS_DLL_EXPORT char *msShapeGetLabelAnnotation(layerObj *layer, shapeObj *shape,
+                                              labelObj *lbl);
+MS_DLL_EXPORT int msGetLabelStatus(mapObj *map, layerObj *layer,
+                                   shapeObj *shape, labelObj *lbl);
+MS_DLL_EXPORT int msAdjustImage(rectObj rect, int *width, int *height);
+MS_DLL_EXPORT char *msEvalTextExpression(expressionObj *expr, shapeObj *shape);
+MS_DLL_EXPORT char *msEvalTextExpressionJSonEscape(expressionObj *expr,
+                                                   shapeObj *shape);
+MS_DLL_EXPORT double msEvalDoubleExpression(expressionObj *expr,
+                                            shapeObj *shape);
+MS_DLL_EXPORT double msAdjustExtent(rectObj *rect, int width, int height);
+MS_DLL_EXPORT int msConstrainExtent(rectObj *bounds, rectObj *rect,
+                                    double overlay);
+MS_DLL_EXPORT int *msGetLayersIndexByGroup(mapObj *map, char *groupname,
+                                           int *nCount);
+MS_DLL_EXPORT unsigned char *msSaveImageBuffer(imageObj *image, int *size_ptr,
+                                               outputFormatObj *format);
+MS_DLL_EXPORT shapeObj *msOffsetPolyline(shapeObj *shape, double offsetx,
+                                         double offsety);
+MS_DLL_EXPORT int msMapSetLayerProjections(mapObj *map);
+
+/* Functions to chnage the drawing order of the layers. */
+/* Defined in mapobject.c */
+MS_DLL_EXPORT int msMoveLayerUp(mapObj *map, int nLayerIndex);
+MS_DLL_EXPORT int msMoveLayerDown(mapObj *map, int nLayerIndex);
+MS_DLL_EXPORT int msSetLayersdrawingOrder(mapObj *self, int *panIndexes);
+MS_DLL_EXPORT int msInsertLayer(mapObj *map, layerObj *layer, int nIndex);
+MS_DLL_EXPORT layerObj *msRemoveLayer(mapObj *map, int nIndex);
+
+/* Defined in layerobject.c */
+MS_DLL_EXPORT int msInsertClass(layerObj *layer, classObj *classobj,
+                                int nIndex);
+MS_DLL_EXPORT classObj *msRemoveClass(layerObj *layer, int nIndex);
+MS_DLL_EXPORT int msMoveClassUp(layerObj *layer, int nClassIndex);
+MS_DLL_EXPORT int msMoveClassDown(layerObj *layer, int nClassIndex);
+
+/* classobject.c */
+MS_DLL_EXPORT int msAddLabelToClass(classObj *classo, labelObj *label);
+MS_DLL_EXPORT labelObj *msRemoveLabelFromClass(classObj *classo,
+                                               int nLabelIndex);
+MS_DLL_EXPORT int msMoveStyleUp(classObj *classo, int nStyleIndex);
+MS_DLL_EXPORT int msMoveStyleDown(classObj *classo, int nStyleIndex);
+MS_DLL_EXPORT int msDeleteStyle(classObj *classo, int nStyleIndex);
+MS_DLL_EXPORT int msInsertStyle(classObj *classo, styleObj *style,
+                                int nStyleIndex);
+MS_DLL_EXPORT styleObj *msRemoveStyle(classObj *classo, int index);
+
+/* maplabel.c */
+MS_DLL_EXPORT int msInsertLabelStyle(labelObj *label, styleObj *style,
+                                     int nStyleIndex);
+MS_DLL_EXPORT int msMoveLabelStyleUp(labelObj *label, int nStyleIndex);
+MS_DLL_EXPORT int msMoveLabelStyleDown(labelObj *label, int nStyleIndex);
+MS_DLL_EXPORT int msDeleteLabelStyle(labelObj *label, int nStyleIndex);
+MS_DLL_EXPORT styleObj *msRemoveLabelStyle(labelObj *label, int nStyleIndex);
+
+/* Measured shape utility functions. */
+MS_DLL_EXPORT pointObj *msGetPointUsingMeasure(shapeObj *shape, double m);
+MS_DLL_EXPORT pointObj *msGetMeasureUsingPoint(shapeObj *shape,
+                                               pointObj *point);
+
+MS_DLL_EXPORT char **msGetAllGroupNames(mapObj *map, int *numTok);
+MS_DLL_EXPORT char *msTmpFile(mapObj *map, const char *mappath,
+                              const char *tmppath, const char *ext);
+MS_DLL_EXPORT char *msTmpPath(mapObj *map, const char *mappath,
+                              const char *tmppath);
+MS_DLL_EXPORT char *msTmpFilename(const char *ext);
+MS_DLL_EXPORT void msForceTmpFileBase(const char *new_base);
+
+MS_DLL_EXPORT imageObj *msImageCreate(int width, int height,
+                                      outputFormatObj *format, char *imagepath,
+                                      char *imageurl, double resolution,
+                                      double defresolution, colorObj *bg);
+
+MS_DLL_EXPORT void msAlphaBlend(unsigned char red_src, unsigned char green_src,
+                                unsigned char blue_src, unsigned char alpha_src,
+                                unsigned char *red_dst,
+                                unsigned char *green_dst,
+                                unsigned char *blue_dst,
+                                unsigned char *alpha_dst);
+MS_DLL_EXPORT void
+msAlphaBlendPM(unsigned char red_src, unsigned char green_src,
+               unsigned char blue_src, unsigned char alpha_src,
+               unsigned char *red_dst, unsigned char *green_dst,
+               unsigned char *blue_dst, unsigned char *alpha_dst);
+
+MS_DLL_EXPORT void msRGBtoHSL(colorObj *rgb, double *h, double *s, double *l);
+
+MS_DLL_EXPORT void msHSLtoRGB(double h, double s, double l, colorObj *rgb);
+
+MS_DLL_EXPORT int msCheckParentPointer(void *p, const char *objname);
+
+MS_DLL_EXPORT int *msAllocateValidClassGroups(layerObj *lp, int *nclasses);
+
+MS_DLL_EXPORT void msFreeRasterBuffer(rasterBufferObj *b);
+MS_DLL_EXPORT void msSetLayerOpacity(layerObj *layer, int opacity);
+
+void msMapSetLanguageSpecificConnection(mapObj *map,
+                                        const char *validated_language);
+MS_DLL_EXPORT shapeObj *msGeneralize(shapeObj *shape, double tolerance);
+/* ==================================================================== */
+/*      End of prototypes for functions in maputil.c                    */
+/* ==================================================================== */
+
+/* ==================================================================== */
+/*      prototypes for functions in mapoutput.c                         */
+/* ==================================================================== */
+
+MS_DLL_EXPORT void msApplyDefaultOutputFormats(mapObj *);
+MS_DLL_EXPORT void msFreeOutputFormat(outputFormatObj *);
+MS_DLL_EXPORT int msGetOutputFormatIndex(mapObj *map, const char *imagetype);
+MS_DLL_EXPORT int msRemoveOutputFormat(mapObj *map, const char *imagetype);
+MS_DLL_EXPORT int msAppendOutputFormat(mapObj *map, outputFormatObj *format);
+MS_DLL_EXPORT outputFormatObj *msSelectOutputFormat(mapObj *map,
+                                                    const char *imagetype);
+MS_DLL_EXPORT void msApplyOutputFormat(outputFormatObj **target,
+                                       outputFormatObj *format,
+                                       int transparent);
+MS_DLL_EXPORT const char *msGetOutputFormatOption(outputFormatObj *format,
+                                                  const char *optionkey,
+                                                  const char *defaultresult);
+MS_DLL_EXPORT outputFormatObj *
+msCreateDefaultOutputFormat(mapObj *map, const char *driver, const char *name,
+                            const char *mimetype);
+MS_DLL_EXPORT int msPostMapParseOutputFormatSetup(mapObj *map);
+MS_DLL_EXPORT void msSetOutputFormatOption(outputFormatObj *format,
+                                           const char *key, const char *value);
+MS_DLL_EXPORT void msGetOutputFormatMimeList(mapObj *map, char **mime_list,
+                                             int max_mime);
+MS_DLL_EXPORT void
+msGetOutputFormatMimeListImg(mapObj *map, const char **mime_list, int max_mime);
+MS_DLL_EXPORT void
+msGetOutputFormatMimeListWMS(mapObj *map, const char **mime_list, int max_mime);
+MS_DLL_EXPORT outputFormatObj *msCloneOutputFormat(outputFormatObj *format);
+MS_DLL_EXPORT int msOutputFormatValidate(outputFormatObj *format,
+                                         int issue_error);
+void msOutputFormatResolveFromImage(mapObj *map, imageObj *img);
+
+/* ==================================================================== */
+/*      End of prototypes for functions in mapoutput.c                  */
+/* ==================================================================== */
+
+/* ==================================================================== */
+/*      prototypes for functions in mapgdal.c                           */
+/* ==================================================================== */
+MS_DLL_EXPORT int msSaveImageGDAL(mapObj *map, imageObj *image,
+                                  const char *filename);
+MS_DLL_EXPORT int msInitDefaultGDALOutputFormat(outputFormatObj *format);
+void msCleanVSIDir(const char *pszDir);
+char **msGetStringListFromHashTable(hashTableObj *table);
+
+/* ==================================================================== */
+/*      prototypes for functions in mapogroutput.c                      */
+/* ==================================================================== */
+MS_DLL_EXPORT int msInitDefaultOGROutputFormat(outputFormatObj *format);
+MS_DLL_EXPORT int msOGRWriteFromQuery(mapObj *map, outputFormatObj *format,
+                                      int sendheaders);
+
+/* ==================================================================== */
+/*      Public prototype for mapogr.cpp functions.                      */
+/* ==================================================================== */
+int MS_DLL_EXPORT msOGRLayerWhichShapes(layerObj *layer, rectObj rect,
+                                        int isQuery);
+int MS_DLL_EXPORT msOGRLayerOpen(
+    layerObj *layer, const char *pszOverrideConnection); /* in mapogr.cpp */
+int MS_DLL_EXPORT msOGRLayerClose(layerObj *layer);
+
+char MS_DLL_EXPORT *msOGRShapeToWKT(shapeObj *shape);
+shapeObj MS_DLL_EXPORT *msOGRShapeFromWKT(const char *string);
+int msOGRUpdateStyleFromString(mapObj *map, layerObj *layer, classObj *c,
+                               const char *stylestring);
+
+/* ==================================================================== */
+/*      prototypes for functions in mapcopy                             */
+/* ==================================================================== */
+MS_DLL_EXPORT int msCopyMap(mapObj *dst, const mapObj *src);
+MS_DLL_EXPORT int msCopyLayer(layerObj *dst, const layerObj *src);
+MS_DLL_EXPORT int msCopyScaleToken(const scaleTokenObj *src,
+                                   scaleTokenObj *dst);
+MS_DLL_EXPORT int msCopyPoint(pointObj *dst, const pointObj *src);
+MS_DLL_EXPORT int msCopyFontSet(fontSetObj *dst, const fontSetObj *src,
+                                mapObj *map);
+MS_DLL_EXPORT void copyProperty(void *dst, const void *src, int size);
+MS_DLL_EXPORT char *copyStringProperty(char **dst, const char *src);
+MS_DLL_EXPORT int msCopyClass(classObj *dst, const classObj *src,
+                              layerObj *layer);
+MS_DLL_EXPORT int msCopyStyle(styleObj *dst, const styleObj *src);
+MS_DLL_EXPORT int msCopyLabel(labelObj *dst, const labelObj *src);
+MS_DLL_EXPORT int msCopyLabelLeader(labelLeaderObj *dst,
+                                    const labelLeaderObj *src);
+MS_DLL_EXPORT int msCopyLine(lineObj *dst, const lineObj *src);
+MS_DLL_EXPORT int msCopyProjection(projectionObj *dst,
+                                   const projectionObj *src);
+MS_DLL_EXPORT int msCopyProjectionExtended(projectionObj *dst,
+                                           const projectionObj *src,
+                                           char **args, int num_args);
+int msCopyExpression(expressionObj *dst, const expressionObj *src);
+int msCopyProjection(projectionObj *dst, const projectionObj *src);
+MS_DLL_EXPORT int msCopyRasterBuffer(rasterBufferObj *dst,
+                                     const rasterBufferObj *src);
+
+/* ==================================================================== */
+/*      end prototypes for functions in mapcopy                         */
+/* ==================================================================== */
+
+/* ==================================================================== */
+/*      mappool.c: connection pooling API.                              */
+/* ==================================================================== */
+MS_DLL_EXPORT void *msConnPoolRequest(layerObj *layer);
+MS_DLL_EXPORT void msConnPoolRelease(layerObj *layer, void *);
+MS_DLL_EXPORT void msConnPoolRegister(layerObj *layer, void *conn_handle,
+                                      void (*close)(void *));
+MS_DLL_EXPORT void msConnPoolCloseUnreferenced(void);
+MS_DLL_EXPORT void msConnPoolFinalCleanup(void);
+
+/* ==================================================================== */
+/*      prototypes for functions in mapcpl.c                            */
+/* ==================================================================== */
+MS_DLL_EXPORT const char *msGetBasename(const char *pszFullFilename);
+MS_DLL_EXPORT void *msGetSymbol(const char *pszLibrary,
+                                const char *pszEntryPoint);
+
+/* ==================================================================== */
+/*      prototypes for functions in mapgeos.c                         */
+/* ==================================================================== */
+MS_DLL_EXPORT void msGEOSSetup(void);
+MS_DLL_EXPORT void msGEOSCleanup(void);
+MS_DLL_EXPORT void msGEOSFreeGeometry(shapeObj *shape);
+
+MS_DLL_EXPORT shapeObj *msGEOSShapeFromWKT(const char *string);
+MS_DLL_EXPORT char *msGEOSShapeToWKT(shapeObj *shape);
+MS_DLL_EXPORT void msGEOSFreeWKT(char *pszGEOSWKT);
+
+MS_DLL_EXPORT shapeObj *msGEOSBuffer(shapeObj *shape, double width);
+MS_DLL_EXPORT shapeObj *msGEOSSimplify(shapeObj *shape, double tolerance);
+MS_DLL_EXPORT shapeObj *msGEOSTopologyPreservingSimplify(shapeObj *shape,
+                                                         double tolerance);
+MS_DLL_EXPORT shapeObj *msGEOSConvexHull(shapeObj *shape);
+MS_DLL_EXPORT shapeObj *msGEOSBoundary(shapeObj *shape);
+MS_DLL_EXPORT pointObj *msGEOSGetCentroid(shapeObj *shape);
+MS_DLL_EXPORT shapeObj *msGEOSUnion(shapeObj *shape1, shapeObj *shape2);
+MS_DLL_EXPORT shapeObj *msGEOSIntersection(shapeObj *shape1, shapeObj *shape2);
+MS_DLL_EXPORT shapeObj *msGEOSDifference(shapeObj *shape1, shapeObj *shape2);
+MS_DLL_EXPORT shapeObj *msGEOSSymDifference(shapeObj *shape1, shapeObj *shape2);
+MS_DLL_EXPORT shapeObj *msGEOSOffsetCurve(shapeObj *p, double offset);
+MS_DLL_EXPORT shapeObj *msGEOSVoronoiDiagram(shapeObj *shape, double tolerance,
+                                             int onlyEdges);
+MS_DLL_EXPORT shapeObj *msGEOSCenterline(shapeObj *shape);
+
+MS_DLL_EXPORT int msGEOSContains(shapeObj *shape1, shapeObj *shape2);
+MS_DLL_EXPORT int msGEOSOverlaps(shapeObj *shape1, shapeObj *shape2);
+MS_DLL_EXPORT int msGEOSWithin(shapeObj *shape1, shapeObj *shape2);
+MS_DLL_EXPORT int msGEOSCrosses(shapeObj *shape1, shapeObj *shape2);
+MS_DLL_EXPORT int msGEOSIntersects(shapeObj *shape1, shapeObj *shape2);
+MS_DLL_EXPORT int msGEOSTouches(shapeObj *shape1, shapeObj *shape2);
+MS_DLL_EXPORT int msGEOSEquals(shapeObj *shape1, shapeObj *shape2);
+MS_DLL_EXPORT int msGEOSDisjoint(shapeObj *shape1, shapeObj *shape2);
+
+MS_DLL_EXPORT double msGEOSArea(shapeObj *shape);
+MS_DLL_EXPORT double msGEOSLength(shapeObj *shape);
+MS_DLL_EXPORT double msGEOSDistance(shapeObj *shape1, shapeObj *shape2);
+
+/* ==================================================================== */
+/*      prototypes for functions in mapcrypto.c                         */
+/* ==================================================================== */
+MS_DLL_EXPORT int msGenerateEncryptionKey(unsigned char *k);
+MS_DLL_EXPORT int msReadEncryptionKeyFromFile(const char *keyfile,
+                                              unsigned char *k);
+MS_DLL_EXPORT void msEncryptStringWithKey(const unsigned char *key,
+                                          const char *in, char *out);
+MS_DLL_EXPORT void msDecryptStringWithKey(const unsigned char *key,
+                                          const char *in, char *out);
+MS_DLL_EXPORT char *msDecryptStringTokens(mapObj *map, const char *in);
+MS_DLL_EXPORT void msHexEncode(const unsigned char *in, char *out,
+                               int numbytes);
+MS_DLL_EXPORT int msHexDecode(const char *in, unsigned char *out, int numchars);
+
+/* ==================================================================== */
+/*      prototypes for functions in mapxmp.c                            */
+/* ==================================================================== */
+MS_DLL_EXPORT int msXmpPresent(mapObj *map);
+MS_DLL_EXPORT int msXmpWrite(mapObj *map, const char *filename);
+
+/* ==================================================================== */
+/*      prototypes for functions in mapgeomtransform.c                  */
+/* ==================================================================== */
+enum MS_GEOMTRANSFORM_TYPE {
+  MS_GEOMTRANSFORM_NONE,
+  MS_GEOMTRANSFORM_EXPRESSION,
+  MS_GEOMTRANSFORM_START,
+  MS_GEOMTRANSFORM_END,
+  MS_GEOMTRANSFORM_VERTICES,
+  MS_GEOMTRANSFORM_BBOX,
+  MS_GEOMTRANSFORM_CENTROID,
+  MS_GEOMTRANSFORM_BUFFER,
+  MS_GEOMTRANSFORM_CONVEXHULL,
+  MS_GEOMTRANSFORM_LABELPOINT,
+  MS_GEOMTRANSFORM_LABELPOLY,
+  MS_GEOMTRANSFORM_LABELCENTER
+};
+
+MS_DLL_EXPORT int msDrawTransformedShape(mapObj *map, imageObj *image,
+                                         shapeObj *shape, styleObj *style,
+                                         double scalefactor);
+MS_DLL_EXPORT void msStyleSetGeomTransform(styleObj *s, char *transform);
+MS_DLL_EXPORT char *msStyleGetGeomTransform(styleObj *style);
+
+MS_DLL_EXPORT int msGeomTransformShape(mapObj *map, layerObj *layer,
+                                       shapeObj *shape);
+
+/* ==================================================================== */
+/*      end of prototypes for functions in mapgeomtransform.c                 */
+/* ==================================================================== */
+
+/* ==================================================================== */
+/*      prototypes for functions in mapgraticule.c                      */
+/* ==================================================================== */
+MS_DLL_EXPORT graticuleIntersectionObj *
+msGraticuleLayerGetIntersectionPoints(mapObj *map, layerObj *layer);
+MS_DLL_EXPORT void
+msGraticuleLayerFreeIntersectionPoints(graticuleIntersectionObj *psValue);
+
+/* ==================================================================== */
+/*      end of prototypes for functions in mapgraticule.c               */
+/* ==================================================================== */
+
+/* ==================================================================== */
+/*      prototypes for functions in mapsmoothing.c                      */
+/* ==================================================================== */
+MS_DLL_EXPORT shapeObj *msSmoothShapeSIA(shapeObj *shape, int ss, int si,
+                                         char *preprocessing);
+
+/* ==================================================================== */
+/*      end of prototypes for functions in mapsmoothing.c               */
+/* ==================================================================== */
+
+/* ==================================================================== */
+/*      prototypes for functions in mapv8.cpp                           */
+/* ==================================================================== */
 #ifdef USE_V8_MAPSCRIPT
-  MS_DLL_EXPORT void msV8CreateContext(mapObj *map);
-  MS_DLL_EXPORT void msV8ContextSetLayer(mapObj *map, layerObj *layer);
-  MS_DLL_EXPORT void msV8FreeContext(mapObj *map);
-  MS_DLL_EXPORT char* msV8GetFeatureStyle(mapObj *map, const char *filename,
-                                          layerObj *layer, shapeObj *shape);
-  MS_DLL_EXPORT shapeObj *msV8TransformShape(shapeObj *shape,
-                                             const char* filename);
+MS_DLL_EXPORT void msV8CreateContext(mapObj *map);
+MS_DLL_EXPORT void msV8ContextSetLayer(mapObj *map, layerObj *layer);
+MS_DLL_EXPORT void msV8FreeContext(mapObj *map);
+MS_DLL_EXPORT char *msV8GetFeatureStyle(mapObj *map, const char *filename,
+                                        layerObj *layer, shapeObj *shape);
+MS_DLL_EXPORT shapeObj *msV8TransformShape(shapeObj *shape,
+                                           const char *filename);
 #endif
-  /* ==================================================================== */
-  /*      end of prototypes for functions in mapv8.cpp                    */
-  /* ==================================================================== */
+/* ==================================================================== */
+/*      end of prototypes for functions in mapv8.cpp                    */
+/* ==================================================================== */
 
 #endif
 
-
 #ifndef SWIG
-  /*
-   * strokeStyleObj
-   */
-  typedef struct {
-    double width; /* line width in pixels */
-
-    /* line pattern, e.g. dots, dashes, etc.. */
-    int patternlength;
-    double pattern[MS_MAXPATTERNLENGTH];
-    double patternoffset;
-
-    /* must be a valid color if not NULL */
-    /* color.alpha must be used if supported by the renderer */
-    colorObj *color;
-
-    int linecap; /* MS_CJC_TRIANGLE, MS_CJC_SQUARE, MS_CJC_ROUND, MS_CJC_BUTT */
-    int linejoin; /* MS_CJC_BEVEL MS_CJC_ROUND MS_CJC_MITER */
-    double linejoinmaxsize;
-    int antialiased;
-  } strokeStyleObj;
+/*
+ * strokeStyleObj
+ */
+typedef struct {
+  double width; /* line width in pixels */
 
-#define INIT_STROKE_STYLE(s) { (s).width=0; (s).patternlength=0; (s).color=NULL; (s).linecap=MS_CJC_ROUND; (s).linejoin=MS_CJC_ROUND; (s).linejoinmaxsize=0; (s).antialiased=MS_TRUE; }
+  /* line pattern, e.g. dots, dashes, etc.. */
+  int patternlength;
+  double pattern[MS_MAXPATTERNLENGTH];
+  double patternoffset;
+
+  /* must be a valid color if not NULL */
+  /* color.alpha must be used if supported by the renderer */
+  colorObj *color;
+
+  int linecap;  /* MS_CJC_TRIANGLE, MS_CJC_SQUARE, MS_CJC_ROUND, MS_CJC_BUTT */
+  int linejoin; /* MS_CJC_BEVEL MS_CJC_ROUND MS_CJC_MITER */
+  double linejoinmaxsize;
+  int antialiased;
+} strokeStyleObj;
+
+#define INIT_STROKE_STYLE(s)                                                   \
+  {                                                                            \
+    (s).width = 0;                                                             \
+    (s).patternlength = 0;                                                     \
+    (s).color = NULL;                                                          \
+    (s).linecap = MS_CJC_ROUND;                                                \
+    (s).linejoin = MS_CJC_ROUND;                                               \
+    (s).linejoinmaxsize = 0;                                                   \
+    (s).antialiased = MS_TRUE;                                                 \
+  }
 
+/*
+ * symbolStyleObj
+ */
+typedef struct {
+  /* must be valid colors if not NULL */
+  /* color.alpha must be used if supported by the renderer */
+  colorObj *color;
+  colorObj *backgroundcolor;
+
+  double outlinewidth;
+  colorObj *outlinecolor;
+
+  /* scalefactor to be applied on the tile or symbol*/
+  double scale;
+
+  /* rotation to apply on the symbol (and the tile?)
+   * in radians */
+  double rotation;
 
-  /*
-   * symbolStyleObj
+  /* the gap to space symbols appart when used as a polygon tile
    */
-  typedef struct {
-    /* must be valid colors if not NULL */
-    /* color.alpha must be used if supported by the renderer */
-    colorObj *color;
-    colorObj *backgroundcolor;
-
-    double outlinewidth;
-    colorObj *outlinecolor;
-
-    /* scalefactor to be applied on the tile or symbol*/
-    double scale;
-
-    /* rotation to apply on the symbol (and the tile?)
-     * in radians */
-    double rotation;
-
-    /* the gap to space symbols appart when used as a polygon tile
-     */
-    double gap;
-
-    /* style object, necessary for vector type renderers to be able
-     * to render symbols through other renders such as cairo/agg */
-    styleObj *style;
-  } symbolStyleObj;
-
-#define INIT_SYMBOL_STYLE(s) {(s).color=NULL; (s).backgroundcolor=NULL; (s).outlinewidth=0; (s).outlinecolor=NULL; (s).scale=1.0; (s).rotation=0; (s).style=NULL;}
-
-  struct tileCacheObj {
-    symbolObj *symbol;
-    int width;
-    int height;
-    colorObj color, outlinecolor, backgroundcolor;
-    double outlinewidth, rotation,scale;
-    imageObj *image;
-    tileCacheObj *next;
-  };
+  double gap;
+
+  /* style object, necessary for vector type renderers to be able
+   * to render symbols through other renders such as cairo/agg */
+  styleObj *style;
+} symbolStyleObj;
+
+#define INIT_SYMBOL_STYLE(s)                                                   \
+  {                                                                            \
+    (s).color = NULL;                                                          \
+    (s).backgroundcolor = NULL;                                                \
+    (s).outlinewidth = 0;                                                      \
+    (s).outlinecolor = NULL;                                                   \
+    (s).scale = 1.0;                                                           \
+    (s).rotation = 0;                                                          \
+    (s).style = NULL;                                                          \
+  }
 
+struct tileCacheObj {
+  symbolObj *symbol;
+  int width;
+  int height;
+  colorObj color, outlinecolor, backgroundcolor;
+  double outlinewidth, rotation, scale;
+  imageObj *image;
+  tileCacheObj *next;
+};
 
-  /*
-   * labelStyleObj
-   */
-  typedef struct {
-    /* full paths to truetype font file */
-    char* fonts[MS_MAX_LABEL_FONTS];
-    int numfonts;
-    double size;
-    double rotation;
-    colorObj *color;
-    double outlinewidth;
-    colorObj *outlinecolor;
-  } labelStyleObj;
-
-#define INIT_LABEL_STYLE(s) {memset(&(s),'\0',sizeof(labelStyleObj));}
+/*
+ * labelStyleObj
+ */
+typedef struct {
+  /* full paths to truetype font file */
+  char *fonts[MS_MAX_LABEL_FONTS];
+  int numfonts;
+  double size;
+  double rotation;
+  colorObj *color;
+  double outlinewidth;
+  colorObj *outlinecolor;
+} labelStyleObj;
+
+#define INIT_LABEL_STYLE(s)                                                    \
+  { memset(&(s), '\0', sizeof(labelStyleObj)); }
 
 #endif
 
 #ifndef SWIG
-  MS_DLL_EXPORT int msInitializeDummyRenderer(rendererVTableObj *vtable);
-  MS_DLL_EXPORT int msInitializeRendererVTable(outputFormatObj *outputformat);
-  MS_DLL_EXPORT int msPopulateRendererVTableCairoRaster( rendererVTableObj *renderer );
-  MS_DLL_EXPORT int msPopulateRendererVTableCairoSVG( rendererVTableObj *renderer );
-  MS_DLL_EXPORT int msPopulateRendererVTableCairoPDF( rendererVTableObj *renderer );
-  MS_DLL_EXPORT int msPopulateRendererVTableOGL( rendererVTableObj *renderer );
-  MS_DLL_EXPORT int msPopulateRendererVTableAGG( rendererVTableObj *renderer );
-  MS_DLL_EXPORT int msPopulateRendererVTableUTFGrid( rendererVTableObj *renderer );
-  MS_DLL_EXPORT int msPopulateRendererVTableKML( rendererVTableObj *renderer );
-  MS_DLL_EXPORT int msPopulateRendererVTableOGR( rendererVTableObj *renderer );
-  MS_DLL_EXPORT int msPopulateRendererVTableMVT( rendererVTableObj *renderer );
+MS_DLL_EXPORT int msInitializeDummyRenderer(rendererVTableObj *vtable);
+MS_DLL_EXPORT int msInitializeRendererVTable(outputFormatObj *outputformat);
+MS_DLL_EXPORT int
+msPopulateRendererVTableCairoRaster(rendererVTableObj *renderer);
+MS_DLL_EXPORT int msPopulateRendererVTableCairoSVG(rendererVTableObj *renderer);
+MS_DLL_EXPORT int msPopulateRendererVTableCairoPDF(rendererVTableObj *renderer);
+MS_DLL_EXPORT int msPopulateRendererVTableOGL(rendererVTableObj *renderer);
+MS_DLL_EXPORT int msPopulateRendererVTableAGG(rendererVTableObj *renderer);
+MS_DLL_EXPORT int msPopulateRendererVTableUTFGrid(rendererVTableObj *renderer);
+MS_DLL_EXPORT int msPopulateRendererVTableKML(rendererVTableObj *renderer);
+MS_DLL_EXPORT int msPopulateRendererVTableOGR(rendererVTableObj *renderer);
+MS_DLL_EXPORT int msPopulateRendererVTableMVT(rendererVTableObj *renderer);
 
-  MS_DLL_EXPORT int msMVTWriteTile( mapObj *map, int sendheaders );
+MS_DLL_EXPORT int msMVTWriteTile(mapObj *map, int sendheaders);
 
 #ifdef USE_CAIRO
-  MS_DLL_EXPORT void msCairoCleanup(void);
+MS_DLL_EXPORT void msCairoCleanup(void);
 #endif
 
-  /* allocate 50k for starters */
+/* allocate 50k for starters */
 #define MS_DEFAULT_BUFFER_ALLOC 50000
 
-  typedef struct _autobuffer {
-    unsigned char *data;
-    size_t size;
-    size_t available;
-    size_t _next_allocation_size;
-  } bufferObj;
-
-
-  /* in mapimageio.c */
-  int msQuantizeRasterBuffer(rasterBufferObj *rb, unsigned int *reqcolors, rgbaPixel *palette,
-                             rgbaPixel *forced_palette, int num_forced_palette_entries,
-                             unsigned int *palette_scaling_maxval);
-  int msClassifyRasterBuffer(rasterBufferObj *rb, rasterBufferObj *qrb);
-  int msSaveRasterBuffer(mapObj *map, rasterBufferObj *data, FILE *stream, outputFormatObj *format);
-  int msSaveRasterBufferToBuffer(rasterBufferObj *data, bufferObj *buffer, outputFormatObj *format);
-  int msLoadMSRasterBufferFromFile(char *path, rasterBufferObj *rb);
-
-  /* in mapagg.cpp */
-  void msApplyBlurringCompositingFilter(rasterBufferObj *rb, unsigned int radius);
-
-  int WARN_UNUSED msApplyCompositingFilter(mapObj *map, rasterBufferObj *rb, CompositingFilter *filter);
-
-  void msBufferInit(bufferObj *buffer);
-  void msBufferResize(bufferObj *buffer, size_t target_size);
-  MS_DLL_EXPORT void msBufferFree(bufferObj *buffer);
-  MS_DLL_EXPORT void msBufferAppend(bufferObj *buffer, void *data, size_t length);
-
-  typedef struct {
-    int charWidth, charHeight;
-  } fontMetrics;
-
-  struct rendererVTableObj {
-    int supports_pixel_buffer;
-    int supports_clipping;
-    int supports_svg;
-    int use_imagecache;
-    enum MS_TRANSFORM_MODE default_transform_mode;
-    enum MS_TRANSFORM_MODE transform_mode;
-    double default_approximation_scale;
-    double approximation_scale;
-
-    void *renderer_data;
-
-    int WARN_UNUSED (*renderLine)(imageObj *img, shapeObj *p, strokeStyleObj *style);
-    int WARN_UNUSED (*renderPolygon)(imageObj *img, shapeObj *p, colorObj *color);
-    int WARN_UNUSED (*renderPolygonTiled)(imageObj *img, shapeObj *p, imageObj *tile);
-    int WARN_UNUSED (*renderLineTiled)(imageObj *img, shapeObj *p, imageObj *tile);
-
-    /* only ts->textpath is guaranteed to be populated. Other fields might be 0/NULL */
-    int WARN_UNUSED (*renderGlyphs)(imageObj *img, const textSymbolObj *ts, colorObj *clr, colorObj *olcolor, int olwidth, int isMarker);
-
-    int WARN_UNUSED (*renderVectorSymbol)(imageObj *img, double x, double y,
-                              symbolObj *symbol, symbolStyleObj *style);
-
-    int WARN_UNUSED (*renderPixmapSymbol)(imageObj *img, double x, double y,
-                              symbolObj *symbol, symbolStyleObj *style);
-
-    int WARN_UNUSED (*renderEllipseSymbol)(imageObj *image, double x, double y,
-                               symbolObj *symbol, symbolStyleObj *style);
-
-    int WARN_UNUSED (*renderSVGSymbol)(imageObj *img, double x, double y,
-                           symbolObj *symbol, symbolStyleObj *style);
-
-    int WARN_UNUSED (*renderTile)(imageObj *img, imageObj *tile, double x, double y);
-
-    int WARN_UNUSED (*loadImageFromFile)(char *path, rasterBufferObj *rb);
-
-    int WARN_UNUSED (*getRasterBufferHandle)(imageObj *img, rasterBufferObj *rb);
-    int WARN_UNUSED (*getRasterBufferCopy)(imageObj *img, rasterBufferObj *rb);
-    int WARN_UNUSED (*initializeRasterBuffer)(rasterBufferObj *rb, int width, int height, int mode);
-
-    int WARN_UNUSED (*mergeRasterBuffer)(imageObj *dest, rasterBufferObj *overlay, double opacity, int srcX, int srcY, int dstX, int dstY, int width, int height);
-    int WARN_UNUSED (*compositeRasterBuffer)(imageObj *dest, rasterBufferObj *overlay, CompositingOperation comp_op, int opacity);
-
-
-    /* image i/o */
-    imageObj* WARN_UNUSED (*createImage)(int width, int height, outputFormatObj *format, colorObj* bg);
-    int WARN_UNUSED (*saveImage)(imageObj *img, mapObj *map, FILE *fp, outputFormatObj *format);
-    unsigned char* WARN_UNUSED (*saveImageBuffer)(imageObj *img, int *size_ptr, outputFormatObj *format);
-    /*...*/
-
-    int (*startLayer)(imageObj *img, mapObj *map, layerObj *layer);
-    int (*endLayer)(imageObj *img, mapObj *map, layerObj *layer);
-
-    int (*startShape)(imageObj *img, shapeObj *shape);
-    int (*endShape)(imageObj *img, shapeObj *shape);
-    int (*setClip)(imageObj *img, rectObj clipRect);
-    int (*resetClip)(imageObj *img);
-
-    int (*freeImage)(imageObj *image);
-    int (*freeSymbol)(symbolObj *symbol);
-    int (*cleanup)(void *renderer_data);
-  } ;
-  MS_DLL_EXPORT int msRenderRasterizedSVGSymbol(imageObj* img, double x, double y, symbolObj* symbol, symbolStyleObj* style);
+typedef struct _autobuffer {
+  unsigned char *data;
+  size_t size;
+  size_t available;
+  size_t _next_allocation_size;
+} bufferObj;
+
+/* in mapimageio.c */
+int msQuantizeRasterBuffer(rasterBufferObj *rb, unsigned int *reqcolors,
+                           rgbaPixel *palette, rgbaPixel *forced_palette,
+                           int num_forced_palette_entries,
+                           unsigned int *palette_scaling_maxval);
+int msClassifyRasterBuffer(rasterBufferObj *rb, rasterBufferObj *qrb);
+int msSaveRasterBuffer(mapObj *map, rasterBufferObj *data, FILE *stream,
+                       outputFormatObj *format);
+int msSaveRasterBufferToBuffer(rasterBufferObj *data, bufferObj *buffer,
+                               outputFormatObj *format);
+int msLoadMSRasterBufferFromFile(char *path, rasterBufferObj *rb);
+
+/* in mapagg.cpp */
+void msApplyBlurringCompositingFilter(rasterBufferObj *rb, unsigned int radius);
+
+int WARN_UNUSED msApplyCompositingFilter(mapObj *map, rasterBufferObj *rb,
+                                         CompositingFilter *filter);
+
+void msBufferInit(bufferObj *buffer);
+void msBufferResize(bufferObj *buffer, size_t target_size);
+MS_DLL_EXPORT void msBufferFree(bufferObj *buffer);
+MS_DLL_EXPORT void msBufferAppend(bufferObj *buffer, void *data, size_t length);
+
+typedef struct {
+  int charWidth, charHeight;
+} fontMetrics;
+
+struct rendererVTableObj {
+  int supports_pixel_buffer;
+  int supports_clipping;
+  int supports_svg;
+  int use_imagecache;
+  enum MS_TRANSFORM_MODE default_transform_mode;
+  enum MS_TRANSFORM_MODE transform_mode;
+  double default_approximation_scale;
+  double approximation_scale;
+
+  void *renderer_data;
+
+  int WARN_UNUSED (*renderLine)(imageObj *img, shapeObj *p,
+                                strokeStyleObj *style);
+  int WARN_UNUSED (*renderPolygon)(imageObj *img, shapeObj *p, colorObj *color);
+  int WARN_UNUSED (*renderPolygonTiled)(imageObj *img, shapeObj *p,
+                                        imageObj *tile);
+  int WARN_UNUSED (*renderLineTiled)(imageObj *img, shapeObj *p,
+                                     imageObj *tile);
+
+  /* only ts->textpath is guaranteed to be populated. Other fields might be
+   * 0/NULL */
+  int WARN_UNUSED (*renderGlyphs)(imageObj *img, const textSymbolObj *ts,
+                                  colorObj *clr, colorObj *olcolor, int olwidth,
+                                  int isMarker);
+
+  int WARN_UNUSED (*renderVectorSymbol)(imageObj *img, double x, double y,
+                                        symbolObj *symbol,
+                                        symbolStyleObj *style);
+
+  int WARN_UNUSED (*renderPixmapSymbol)(imageObj *img, double x, double y,
+                                        symbolObj *symbol,
+                                        symbolStyleObj *style);
+
+  int WARN_UNUSED (*renderEllipseSymbol)(imageObj *image, double x, double y,
+                                         symbolObj *symbol,
+                                         symbolStyleObj *style);
+
+  int WARN_UNUSED (*renderSVGSymbol)(imageObj *img, double x, double y,
+                                     symbolObj *symbol, symbolStyleObj *style);
+
+  int WARN_UNUSED (*renderTile)(imageObj *img, imageObj *tile, double x,
+                                double y);
+
+  int WARN_UNUSED (*loadImageFromFile)(char *path, rasterBufferObj *rb);
+
+  int WARN_UNUSED (*getRasterBufferHandle)(imageObj *img, rasterBufferObj *rb);
+  int WARN_UNUSED (*getRasterBufferCopy)(imageObj *img, rasterBufferObj *rb);
+  int WARN_UNUSED (*initializeRasterBuffer)(rasterBufferObj *rb, int width,
+                                            int height, int mode);
+
+  int WARN_UNUSED (*mergeRasterBuffer)(imageObj *dest, rasterBufferObj *overlay,
+                                       double opacity, int srcX, int srcY,
+                                       int dstX, int dstY, int width,
+                                       int height);
+  int WARN_UNUSED (*compositeRasterBuffer)(imageObj *dest,
+                                           rasterBufferObj *overlay,
+                                           CompositingOperation comp_op,
+                                           int opacity);
+
+  /* image i/o */
+  imageObj *WARN_UNUSED (*createImage)(int width, int height,
+                                       outputFormatObj *format, colorObj *bg);
+  int WARN_UNUSED (*saveImage)(imageObj *img, mapObj *map, FILE *fp,
+                               outputFormatObj *format);
+  unsigned char *WARN_UNUSED (*saveImageBuffer)(imageObj *img, int *size_ptr,
+                                                outputFormatObj *format);
+  /*...*/
+
+  int (*startLayer)(imageObj *img, mapObj *map, layerObj *layer);
+  int (*endLayer)(imageObj *img, mapObj *map, layerObj *layer);
+
+  int (*startShape)(imageObj *img, shapeObj *shape);
+  int (*endShape)(imageObj *img, shapeObj *shape);
+  int (*setClip)(imageObj *img, rectObj clipRect);
+  int (*resetClip)(imageObj *img);
+
+  int (*freeImage)(imageObj *image);
+  int (*freeSymbol)(symbolObj *symbol);
+  int (*cleanup)(void *renderer_data);
+};
+MS_DLL_EXPORT int msRenderRasterizedSVGSymbol(imageObj *img, double x, double y,
+                                              symbolObj *symbol,
+                                              symbolStyleObj *style);
 
 #define MS_IMAGE_RENDERER(im) ((im)->format->vtable)
 #define MS_RENDERER_CACHE(renderer) ((renderer)->renderer_data)
@@ -3303,11 +4082,12 @@ extern "C" {
 #define MS_MAP_RENDERER(map) ((map)->outputformat->vtable)
 
 shapeObj *msOffsetCurve(shapeObj *p, double offset);
-#if defined USE_GEOS && (GEOS_VERSION_MAJOR > 3 || (GEOS_VERSION_MAJOR == 3 && GEOS_VERSION_MINOR >= 3))
+#if defined USE_GEOS && (GEOS_VERSION_MAJOR > 3 ||                             \
+                         (GEOS_VERSION_MAJOR == 3 && GEOS_VERSION_MINOR >= 3))
 shapeObj *msGEOSOffsetCurve(shapeObj *p, double offset);
 #endif
 
-int msOGRSupportsIsNull(layerObj* layer);
+int msOGRSupportsIsNull(layerObj *layer);
 
 #ifdef NEED_IGNORE_RET_VAL
 static inline void IGNORE_RET_VAL(int x) { (void)x; }
diff -pruN 8.0.1-5/mapservutil.c 8.0.2-1/mapservutil.c
--- 8.0.1-5/mapservutil.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapservutil.c	2024-06-11 20:41:34.000000000 +0000
@@ -40,28 +40,46 @@
 #include "cpl_conv.h"
 
 /*
-** Enumerated types, keep the query modes in sequence and at the end of the enumeration (mode enumeration is in maptemplate.h).
+** Enumerated types, keep the query modes in sequence and at the end of the
+*enumeration (mode enumeration is in maptemplate.h).
 */
 static const int numModes = 23;
-static char *const modeStrings[23] = {"BROWSE","ZOOMIN","ZOOMOUT","MAP","LEGEND","LEGENDICON","REFERENCE","SCALEBAR","COORDINATE",
-                                "QUERY","NQUERY","ITEMQUERY","ITEMNQUERY",
-                                "FEATUREQUERY","FEATURENQUERY","ITEMFEATUREQUERY","ITEMFEATURENQUERY",
-                                "INDEXQUERY","TILE","OWS", "WFS", "MAPLEGEND", "MAPLEGENDICON"
-                               };
+static char *const modeStrings[23] = {"BROWSE",
+                                      "ZOOMIN",
+                                      "ZOOMOUT",
+                                      "MAP",
+                                      "LEGEND",
+                                      "LEGENDICON",
+                                      "REFERENCE",
+                                      "SCALEBAR",
+                                      "COORDINATE",
+                                      "QUERY",
+                                      "NQUERY",
+                                      "ITEMQUERY",
+                                      "ITEMNQUERY",
+                                      "FEATUREQUERY",
+                                      "FEATURENQUERY",
+                                      "ITEMFEATUREQUERY",
+                                      "ITEMFEATURENQUERY",
+                                      "INDEXQUERY",
+                                      "TILE",
+                                      "OWS",
+                                      "WFS",
+                                      "MAPLEGEND",
+                                      "MAPLEGENDICON"};
 
 static int commonLoadForm(mapservObj *mapserv, mapObj *map);
 
-void msCGIWriteError(mapservObj *mapserv)
-{
+void msCGIWriteError(mapservObj *mapserv) {
   errorObj *ms_error = msGetErrorObj();
 
-  if(!ms_error || ms_error->code == MS_NOERR || ms_error->isreported) {
+  if (!ms_error || ms_error->code == MS_NOERR || ms_error->isreported) {
     /* either we have no error, or it was already reported by other means */
     return;
   }
 
-  if(!mapserv || !mapserv->map) {
-    msIO_setHeader("Content-Type","text/html");
+  if (!mapserv || !mapserv->map) {
+    msIO_setHeader("Content-Type", "text/html");
     msIO_sendHeaders();
     msIO_printf("<HTML>\n");
     msIO_printf("<HEAD><TITLE>MapServer Message</TITLE></HEAD>\n");
@@ -71,10 +89,10 @@ void msCGIWriteError(mapservObj *mapserv
     return;
   }
 
-  if((ms_error->code == MS_NOTFOUND) && (mapserv->map->web.empty)) {
+  if ((ms_error->code == MS_NOTFOUND) && (mapserv->map->web.empty)) {
     /* msRedirect(mapserv->map->web.empty); */
-    if(msReturnURL(mapserv, mapserv->map->web.empty, BROWSE) != MS_SUCCESS) {
-      msIO_setHeader("Content-Type","text/html");
+    if (msReturnURL(mapserv, mapserv->map->web.empty, BROWSE) != MS_SUCCESS) {
+      msIO_setHeader("Content-Type", "text/html");
       msIO_sendHeaders();
       msIO_printf("<HTML>\n");
       msIO_printf("<HEAD><TITLE>MapServer Message</TITLE></HEAD>\n");
@@ -83,10 +101,10 @@ void msCGIWriteError(mapservObj *mapserv
       msIO_printf("</BODY></HTML>");
     }
   } else {
-    if(mapserv->map->web.error) {
+    if (mapserv->map->web.error) {
       /* msRedirect(mapserv->map->web.error); */
-      if(msReturnURL(mapserv, mapserv->map->web.error, BROWSE) != MS_SUCCESS) {
-        msIO_setHeader("Content-Type","text/html");
+      if (msReturnURL(mapserv, mapserv->map->web.error, BROWSE) != MS_SUCCESS) {
+        msIO_setHeader("Content-Type", "text/html");
         msIO_sendHeaders();
         msIO_printf("<HTML>\n");
         msIO_printf("<HEAD><TITLE>MapServer Message</TITLE></HEAD>\n");
@@ -95,7 +113,7 @@ void msCGIWriteError(mapservObj *mapserv
         msIO_printf("</BODY></HTML>");
       }
     } else {
-      msIO_setHeader("Content-Type","text/html");
+      msIO_setHeader("Content-Type", "text/html");
       msIO_sendHeaders();
       msIO_printf("<HTML>\n");
       msIO_printf("<HEAD><TITLE>MapServer Message</TITLE></HEAD>\n");
@@ -107,34 +125,38 @@ void msCGIWriteError(mapservObj *mapserv
 }
 
 /*
-** Converts a string (e.g. form parameter) to a double, first checking the format against
+** Converts a string (e.g. form parameter) to a double, first checking the
+*format against
 ** a regular expression. returns an error if the format test fails.
 */
 
-#define GET_NUMERIC(string,dbl) do { \
-  dbl = strtod((string), &strtoderr);\
-  if (*strtoderr) {\
-    msSetError(MS_TYPEERR, NULL, "GET_NUMERIC()");\
-    return MS_FAILURE;\
-  }\
-} while (0)
-
-#define GET_NUMERIC_NO_ERROR(string,dbl) dbl = strtod((string), &strtoderr);
-
-#define FREE_TOKENS_ON_ERROR(ntok) if(!strtoderr) {\
-  msSetError(MS_TYPEERR, "invalid number", "msCGILoadForm()");\
-  msFreeCharArray(tokens,(ntok));\
-  return MS_FAILURE;\
-}
+#define GET_NUMERIC(string, dbl)                                               \
+  do {                                                                         \
+    dbl = strtod((string), &strtoderr);                                        \
+    if (*strtoderr) {                                                          \
+      msSetError(MS_TYPEERR, NULL, "GET_NUMERIC()");                           \
+      return MS_FAILURE;                                                       \
+    }                                                                          \
+  } while (0)
+
+#define GET_NUMERIC_NO_ERROR(string, dbl) dbl = strtod((string), &strtoderr);
+
+#define FREE_TOKENS_ON_ERROR(ntok)                                             \
+  if (!strtoderr) {                                                            \
+    msSetError(MS_TYPEERR, "invalid number", "msCGILoadForm()");               \
+    msFreeCharArray(tokens, (ntok));                                           \
+    return MS_FAILURE;                                                         \
+  }
 
-static void setClassGroup(layerObj *layer, char *classgroup)
-{
+static void setClassGroup(layerObj *layer, char *classgroup) {
   int i;
 
-  if(!layer || !classgroup) return;
+  if (!layer || !classgroup)
+    return;
 
-  for(i=0; i<layer->numclasses; i++) {
-    if(layer->class[i]->group && strcmp(layer->class[i]->group, classgroup) == 0) {
+  for (i = 0; i < layer->numclasses; i++) {
+    if (layer->class[i] -> group && strcmp(layer->class[i] -> group,
+                                           classgroup) == 0) {
       msFree(layer->classgroup);
       layer->classgroup = msStrdup(classgroup);
       return; /* bail */
@@ -146,8 +168,7 @@ static void setClassGroup(layerObj *laye
 ** Extract Map File name from params and load it.
 ** Returns map object or NULL on error.
 */
-mapObj *msCGILoadMap(mapservObj *mapserv, configObj *config)
-{
+mapObj *msCGILoadMap(mapservObj *mapserv, configObj *config) {
   int i;
   mapObj *map = NULL;
 
@@ -159,36 +180,48 @@ mapObj *msCGILoadMap(mapservObj *mapserv
   const char *ms_map_no_path = CPLGetConfigOption("MS_MAP_NO_PATH", NULL);
   const char *ms_map_pattern = CPLGetConfigOption("MS_MAP_PATTERN", NULL);
 
-  const char *ms_map_bad_pattern = CPLGetConfigOption("MS_MAP_BAD_PATTERN", NULL);
-  if(ms_map_bad_pattern == NULL) ms_map_bad_pattern = ms_map_bad_pattern_default;
+  const char *ms_map_bad_pattern =
+      CPLGetConfigOption("MS_MAP_BAD_PATTERN", NULL);
+  if (ms_map_bad_pattern == NULL)
+    ms_map_bad_pattern = ms_map_bad_pattern_default;
 
   const char *map_value = NULL;
 
-  if(mapserv->request->api_path != NULL) {
-    map_value = mapserv->request->api_path[0]; /* mapfile is *always* in the first position (/{mapfile}/{signature}) of an API call */
+  if (mapserv->request->api_path != NULL) {
+    map_value = mapserv->request
+                    ->api_path[0]; /* mapfile is *always* in the first position
+                                      (/{mapfile}/{signature}) of an API call */
   } else {
-    for(i=0; i<mapserv->request->NumParams; i++) { /* find the map parameter */
-      if(strcasecmp(mapserv->request->ParamNames[i], "map") == 0) {
+    for (i = 0; i < mapserv->request->NumParams;
+         i++) { /* find the map parameter */
+      if (strcasecmp(mapserv->request->ParamNames[i], "map") == 0) {
         map_value = mapserv->request->ParamValues[i];
         break;
       }
     }
   }
 
-  if(map_value == NULL) {
-    if(ms_mapfile == NULL) {
-      msSetError(MS_WEBERR, "CGI variable \"map\" is not set.", "msCGILoadMap()"); /* no default, outta here */
+  if (map_value == NULL) {
+    if (ms_mapfile == NULL) {
+      msSetError(MS_WEBERR, "CGI variable \"map\" is not set.",
+                 "msCGILoadMap()"); /* no default, outta here */
       return NULL;
     }
     ms_mapfile_tainted = MS_FALSE;
   } else {
-    ms_mapfile = msConfigGetMap(config, map_value); /* does NOT check the environment, only the config */
-    if(ms_mapfile) {
+    ms_mapfile = msConfigGetMap(
+        config,
+        map_value); /* does NOT check the environment, only the config */
+    if (ms_mapfile) {
       ms_mapfile_tainted = MS_FALSE;
     } else {
-      /* by now we know the map parameter isn't referencing something in the configuration */
-      if(ms_map_no_path != NULL) {
-        msSetError(MS_WEBERR, "CGI variable \"map\" not found in configuration and this server is not configured for full paths.", "msCGILoadMap()");
+      /* by now we know the map parameter isn't referencing something in the
+       * configuration */
+      if (ms_map_no_path != NULL) {
+        msSetError(MS_WEBERR,
+                   "CGI variable \"map\" not found in configuration and this "
+                   "server is not configured for full paths.",
+                   "msCGILoadMap()");
         return NULL;
       }
       ms_mapfile = map_value;
@@ -196,66 +229,88 @@ mapObj *msCGILoadMap(mapservObj *mapserv
   }
 
   /* validate ms_mapfile if tainted */
-  if(ms_mapfile_tainted == MS_TRUE) {
-    if(ms_map_pattern == NULL) { // can't go any further, bail
-      msSetError(MS_WEBERR, "Required configuration value MS_MAP_PATTERN not set.", "msCGILoadMap()");
+  if (ms_mapfile_tainted == MS_TRUE) {
+    if (ms_map_pattern == NULL) { // can't go any further, bail
+      msSetError(MS_WEBERR,
+                 "Required configuration value MS_MAP_PATTERN not set.",
+                 "msCGILoadMap()");
       return NULL;
     }
-    if(msIsValidRegex(ms_map_bad_pattern) == MS_FALSE || msEvalRegex(ms_map_bad_pattern, ms_mapfile) == MS_TRUE) {
-      msSetError(MS_WEBERR, "CGI variable \"map\" fails to validate.", "msCGILoadMap()");
+    if (msIsValidRegex(ms_map_bad_pattern) == MS_FALSE ||
+        msEvalRegex(ms_map_bad_pattern, ms_mapfile) == MS_TRUE) {
+      msSetError(MS_WEBERR, "CGI variable \"map\" fails to validate.",
+                 "msCGILoadMap()");
       return NULL;
     }
-    if(msEvalRegex(ms_map_pattern, ms_mapfile) != MS_TRUE) {
-      msSetError(MS_WEBERR, "CGI variable \"map\" fails to validate.", "msCGILoadMap()");
+    if (msEvalRegex(ms_map_pattern, ms_mapfile) != MS_TRUE) {
+      msSetError(MS_WEBERR, "CGI variable \"map\" fails to validate.",
+                 "msCGILoadMap()");
       return NULL;
     }
   }
 
   /* ok to try to load now */
   map = msLoadMap(ms_mapfile, NULL, config);
-  if(!map) return NULL;  
+  if (!map)
+    return NULL;
 
   /* handle common parameters */
-  if(commonLoadForm(mapserv, map) != MS_SUCCESS) {
+  if (commonLoadForm(mapserv, map) != MS_SUCCESS) {
     msFreeMap(map);
     return NULL;
   }
 
-  if(!msLookupHashTable(&(map->web.validation), "immutable")) {
+  if (!msLookupHashTable(&(map->web.validation), "immutable")) {
     /* check for any %variable% substitutions, we do this here so WMS/WFS  */
     /* services can take advantage of these "vendor specific" extensions */
 
-    msApplySubstitutions(map, mapserv->request->ParamNames, mapserv->request->ParamValues, mapserv->request->NumParams);
+    msApplySubstitutions(map, mapserv->request->ParamNames,
+                         mapserv->request->ParamValues,
+                         mapserv->request->NumParams);
     msApplyDefaultSubstitutions(map);
 
     /* check to see if a ogc map context is passed as argument. if there */
     /* is one load it */
 
-    for(i=0; i<mapserv->request->NumParams; i++) {
-      if(strcasecmp(mapserv->request->ParamNames[i],"context") == 0) {
-        if(mapserv->request->ParamValues[i] && strlen(mapserv->request->ParamValues[i]) > 0) {
-          if(strncasecmp(mapserv->request->ParamValues[i],"http",4) == 0) {
-            if(msGetConfigOption(map, "CGI_CONTEXT_URL"))
-              msLoadMapContextURL(map, mapserv->request->ParamValues[i], MS_FALSE);
+    for (i = 0; i < mapserv->request->NumParams; i++) {
+      if (strcasecmp(mapserv->request->ParamNames[i], "context") == 0) {
+        if (mapserv->request->ParamValues[i] &&
+            strlen(mapserv->request->ParamValues[i]) > 0) {
+          if (strncasecmp(mapserv->request->ParamValues[i], "http", 4) == 0) {
+            if (msGetConfigOption(map, "CGI_CONTEXT_URL"))
+              msLoadMapContextURL(map, mapserv->request->ParamValues[i],
+                                  MS_FALSE);
           } else {
             const char *map_context_filename = mapserv->request->ParamValues[i];
-            const char *ms_context_pattern = CPLGetConfigOption("MS_CONTEXT_PATTERN", NULL);
-            const char *ms_context_bad_pattern = CPLGetConfigOption("MS_CONTEXT_BAD_PATTERN", NULL);
-            if(ms_context_bad_pattern == NULL) ms_context_bad_pattern = ms_map_bad_pattern_default;
-
-            if(ms_context_pattern == NULL) { // can't go any further, bail
-              msSetError(MS_WEBERR, "Required configuration value MS_CONTEXT_PATTERN not set.", "msCGILoadMap()");
+            const char *ms_context_pattern =
+                CPLGetConfigOption("MS_CONTEXT_PATTERN", NULL);
+            const char *ms_context_bad_pattern =
+                CPLGetConfigOption("MS_CONTEXT_BAD_PATTERN", NULL);
+            if (ms_context_bad_pattern == NULL)
+              ms_context_bad_pattern = ms_map_bad_pattern_default;
+
+            if (ms_context_pattern == NULL) { // can't go any further, bail
+              msSetError(
+                  MS_WEBERR,
+                  "Required configuration value MS_CONTEXT_PATTERN not set.",
+                  "msCGILoadMap()");
               msFreeMap(map);
               return NULL;
             }
-            if(msIsValidRegex(ms_context_bad_pattern) == MS_FALSE ||
-               msEvalRegex(ms_context_bad_pattern, map_context_filename) == MS_TRUE) {
-              msSetError(MS_WEBERR, "CGI variable \"context\" fails to validate.", "msCGILoadMap()");
+            if (msIsValidRegex(ms_context_bad_pattern) == MS_FALSE ||
+                msEvalRegex(ms_context_bad_pattern, map_context_filename) ==
+                    MS_TRUE) {
+              msSetError(MS_WEBERR,
+                         "CGI variable \"context\" fails to validate.",
+                         "msCGILoadMap()");
               msFreeMap(map);
               return NULL;
             }
-            if(msEvalRegex(ms_context_pattern, map_context_filename) != MS_TRUE) {
-              msSetError(MS_WEBERR, "CGI variable \"context\" fails to validate.", "msCGILoadMap()");
+            if (msEvalRegex(ms_context_pattern, map_context_filename) !=
+                MS_TRUE) {
+              msSetError(MS_WEBERR,
+                         "CGI variable \"context\" fails to validate.",
+                         "msCGILoadMap()");
               msFreeMap(map);
               return NULL;
             }
@@ -274,56 +329,56 @@ mapObj *msCGILoadMap(mapservObj *mapserv
    * by an object that is part of the mapObject that would contain
    * information on the application status (such as cookie).
    */
-  if( mapserv->request->httpcookiedata != NULL ) {
-    msInsertHashTable( &(map->web.metadata), "http_cookie_data",
-                       mapserv->request->httpcookiedata );
+  if (mapserv->request->httpcookiedata != NULL) {
+    msInsertHashTable(&(map->web.metadata), "http_cookie_data",
+                      mapserv->request->httpcookiedata);
   }
 
   return map;
 }
 
-
 /*
 ** Set operation mode. First look in MS_MODE env. var. as a
 ** default value that can be overridden by the mode=... CGI param.
 ** Returns silently, leaving mapserv->Mode unchanged if mode param not set.
 */
-int msCGISetMode(mapservObj *mapserv)
-{
+int msCGISetMode(mapservObj *mapserv) {
   const char *mode = NULL;
   int i, j;
 
-
   mode = CPLGetConfigOption("MS_MODE", NULL);
-  for( i=0; i<mapserv->request->NumParams; i++ ) {
-    if(strcasecmp(mapserv->request->ParamNames[i], "mode") == 0) {
+  for (i = 0; i < mapserv->request->NumParams; i++) {
+    if (strcasecmp(mapserv->request->ParamNames[i], "mode") == 0) {
       mode = mapserv->request->ParamValues[i];
       break;
     }
   }
 
   if (mode) {
-    for(j=0; j<numModes; j++) {
-      if(strcasecmp(mode, modeStrings[j]) == 0) {
+    for (j = 0; j < numModes; j++) {
+      if (strcasecmp(mode, modeStrings[j]) == 0) {
         mapserv->Mode = j;
         break;
       }
     }
 
-    if(j == numModes) {
+    if (j == numModes) {
       msSetError(MS_WEBERR, "Invalid mode.", "msCGISetMode()");
       return MS_FAILURE;
     }
   }
 
-  if (mapserv->Mode >= 0)
-  {
+  if (mapserv->Mode >= 0) {
     int disabled = MS_FALSE;
-    const char* enable_modes = msLookupHashTable(&mapserv->map->web.metadata, "ms_enable_modes");
+    const char *enable_modes =
+        msLookupHashTable(&mapserv->map->web.metadata, "ms_enable_modes");
 
     if (!msOWSParseRequestMetadata(enable_modes, mode, &disabled) && disabled) {
       /* the current mode is disabled */
-      msSetError(MS_WEBERR, "The specified mode '%s' is not supported by the current map configuration", "msCGISetMode()", mode);
+      msSetError(MS_WEBERR,
+                 "The specified mode '%s' is not supported by the current map "
+                 "configuration",
+                 "msCGISetMode()", mode);
       return MS_FAILURE;
     }
   }
@@ -334,38 +389,44 @@ int msCGISetMode(mapservObj *mapserv)
 /*
 ** API-related funtions.
 */
-int msCGIIsAPIRequest(mapservObj *mapserv) 
-{
-  char **tmp_api_path=NULL;
-  int i, n, tmp_api_path_length=0;
+int msCGIIsAPIRequest(mapservObj *mapserv) {
+  char **tmp_api_path = NULL;
+  int i, n, tmp_api_path_length = 0;
 
   mapserv->request->path_info = getenv("PATH_INFO");
-  if(mapserv->request->path_info != NULL && strlen(mapserv->request->path_info) > 0) {
-    tmp_api_path = msStringSplit(mapserv->request->path_info, '/', &tmp_api_path_length); // ignores consecutive delimeters
-    if(tmp_api_path_length >= 3) { // /{mapfile}/{signature} so 3 components at a minimum (1st component is a zero-length string)
+  if (mapserv->request->path_info != NULL &&
+      strlen(mapserv->request->path_info) > 0) {
+    tmp_api_path =
+        msStringSplit(mapserv->request->path_info, '/',
+                      &tmp_api_path_length); // ignores consecutive delimeters
+    if (tmp_api_path_length >=
+        3) { // /{mapfile}/{signature} so 3 components at a minimum (1st
+             // component is a zero-length string)
 
       // capture only non-zero length components
       n = 0;
-      for(i=0; i<tmp_api_path_length; i++) {
-        if(strlen(tmp_api_path[i]) > 0)
+      for (i = 0; i < tmp_api_path_length; i++) {
+        if (strlen(tmp_api_path[i]) > 0)
           n++;
       }
 
-      if(n < 2) { // not enough non-zero length components for a legitimate API request
+      if (n < 2) { // not enough non-zero length components for a legitimate API
+                   // request
         msFreeCharArray(tmp_api_path, tmp_api_path_length);
         return MS_FALSE;
       }
 
-      mapserv->request->api_path = (char **) msSmallMalloc(sizeof(char *)*n);
-      if(mapserv->request->api_path == NULL) {
+      mapserv->request->api_path = (char **)msSmallMalloc(sizeof(char *) * n);
+      if (mapserv->request->api_path == NULL) {
         msFreeCharArray(tmp_api_path, tmp_api_path_length);
         return MS_FALSE;
       }
 
       mapserv->request->api_path_length = 0;
-      for(i=0; i<tmp_api_path_length; i++) {
-        if(strlen(tmp_api_path[i]) > 0) {
-          mapserv->request->api_path[mapserv->request->api_path_length] = msStrdup(tmp_api_path[i]);
+      for (i = 0; i < tmp_api_path_length; i++) {
+        if (strlen(tmp_api_path[i]) > 0) {
+          mapserv->request->api_path[mapserv->request->api_path_length] =
+              msStrdup(tmp_api_path[i]);
           mapserv->request->api_path_length++;
         }
       }
@@ -373,65 +434,73 @@ int msCGIIsAPIRequest(mapservObj *mapser
       msFreeCharArray(tmp_api_path, tmp_api_path_length);
       return MS_TRUE;
     } else {
-      msFreeCharArray(tmp_api_path, tmp_api_path_length);      
+      msFreeCharArray(tmp_api_path, tmp_api_path_length);
     }
   }
 
   return MS_FALSE;
 }
 
-int msCGIDispatchAPIRequest(mapservObj *mapserv) 
-{
-  // should be a more elegant way to do this (perhaps similar to how drivers are handled)
-  if(strcmp("ogcapi", mapserv->request->api_path[1]) == 0) {
+int msCGIDispatchAPIRequest(mapservObj *mapserv) {
+  // should be a more elegant way to do this (perhaps similar to how drivers are
+  // handled)
+  if (strcmp("ogcapi", mapserv->request->api_path[1]) == 0) {
 #ifdef USE_OGCAPI_SVR
     return msOGCAPIDispatchRequest(mapserv->map, mapserv->request);
 #else
-    msSetError(MS_OGCAPIERR, "OGC API server support is not enabled.", "msCGIDispatchAPIRequest()");
+    msSetError(MS_OGCAPIERR, "OGC API server support is not enabled.",
+               "msCGIDispatchAPIRequest()");
 #endif
   } else {
-    msSetError(MS_WEBERR, "Invalid API signature.", "msCGIDispatchAPIRequest()");
+    msSetError(MS_WEBERR, "Invalid API signature.",
+               "msCGIDispatchAPIRequest()");
   }
 
   return MS_FAILURE;
 }
 
 /*
-** Process common parameters that can apply to CGI and WxS calls - there are just a few and affect the mapObj directly.
+** Process common parameters that can apply to CGI and WxS calls - there are
+*just a few and affect the mapObj directly.
 */
-static int commonLoadForm(mapservObj *mapserv, mapObj *map)
-{
+static int commonLoadForm(mapservObj *mapserv, mapObj *map) {
   double tmpval;
   char *strtoderr;
 
-  if(!mapserv || !map) return MS_FAILURE;
+  if (!mapserv || !map)
+    return MS_FAILURE;
 
-  for(int i=0; i<mapserv->request->NumParams; i++) {
-    if(strlen(mapserv->request->ParamValues[i]) == 0) continue;
+  for (int i = 0; i < mapserv->request->NumParams; i++) {
+    if (strlen(mapserv->request->ParamValues[i]) == 0)
+      continue;
 
-    if(strncasecmp(mapserv->request->ParamNames[i], "classgroup", 10) == 0) { /* #4207 */
-      for(int j=0; j<map->numlayers; j++) {
-	setClassGroup(GET_LAYER(map, j), mapserv->request->ParamValues[i]);
+    if (strncasecmp(mapserv->request->ParamNames[i], "classgroup", 10) ==
+        0) { /* #4207 */
+      for (int j = 0; j < map->numlayers; j++) {
+        setClassGroup(GET_LAYER(map, j), mapserv->request->ParamValues[i]);
       }
       continue;
     }
 
     /*
-    ** For backwards compatibility. Might want to consider a vendor parameter for WFS specifically and then deprecate this.
+    ** For backwards compatibility. Might want to consider a vendor parameter
+    *for WFS specifically and then deprecate this.
     */
-    if(strcasecmp(mapserv->request->ParamNames[i], "map.extent") == 0 || strcasecmp(mapserv->request->ParamNames[i], "map_extent") == 0) {      
-      int n=0;
+    if (strcasecmp(mapserv->request->ParamNames[i], "map.extent") == 0 ||
+        strcasecmp(mapserv->request->ParamNames[i], "map_extent") == 0) {
+      int n = 0;
       char **tokens = msStringSplit(mapserv->request->ParamValues[i], ' ', &n);
 
-      if(!tokens) {
-	msSetError(MS_MEMERR, NULL, "commonLoadForm()");
-	return MS_FAILURE;
+      if (!tokens) {
+        msSetError(MS_MEMERR, NULL, "commonLoadForm()");
+        return MS_FAILURE;
       }
 
-      if(n != 4) {
-	msSetError(MS_WEBERR, "Not enough arguments for mapext.", "commonLoadForm()");
-	msFreeCharArray(tokens,n);
-	return MS_FAILURE;
+      if (n != 4) {
+        msSetError(MS_WEBERR, "Not enough arguments for mapext.",
+                   "commonLoadForm()");
+        msFreeCharArray(tokens, n);
+        return MS_FAILURE;
       }
 
       GET_NUMERIC_NO_ERROR(tokens[0], map->extent.minx);
@@ -446,51 +515,64 @@ static int commonLoadForm(mapservObj *ma
       msFreeCharArray(tokens, 4);
 
       if (!MS_VALID_EXTENT(map->extent)) {
-	msSetError(MS_WEBERR, "Supplied extent is invalid. Check that it is in the form: minx, miny, maxx, maxy", "commonLoadForm()");
-	return(MS_FAILURE);
+        msSetError(MS_WEBERR,
+                   "Supplied extent is invalid. Check that it is in the form: "
+                   "minx, miny, maxx, maxy",
+                   "commonLoadForm()");
+        return (MS_FAILURE);
       }
     }
 
-    /* 
-    ** For backwards compatibility - we don't use plain RESOLUTION here because of a potential conflict WCS. Might want
-    ** to consider a vendor parameter for WMS specifically and then deprecate these.
+    /*
+    ** For backwards compatibility - we don't use plain RESOLUTION here because
+    *of a potential conflict WCS. Might want
+    ** to consider a vendor parameter for WMS specifically and then deprecate
+    *these.
     */
-    if(strcasecmp(mapserv->request->ParamNames[i], "map.resolution") == 0 || strcasecmp(mapserv->request->ParamNames[i], "map_resolution") == 0) {
+    if (strcasecmp(mapserv->request->ParamNames[i], "map.resolution") == 0 ||
+        strcasecmp(mapserv->request->ParamNames[i], "map_resolution") == 0) {
       GET_NUMERIC(mapserv->request->ParamValues[i], tmpval);
-      if(tmpval < MS_RESOLUTION_MIN || tmpval > MS_RESOLUTION_MAX) {
-        msSetError(MS_WEBERR, "Resolution value out of range.", "commonLoadForm()");
+      if (tmpval < MS_RESOLUTION_MIN || tmpval > MS_RESOLUTION_MAX) {
+        msSetError(MS_WEBERR, "Resolution value out of range.",
+                   "commonLoadForm()");
         return MS_FAILURE;
       }
       map->resolution = (int)tmpval;
       continue;
     }
 
-    if(strcasecmp(mapserv->request->ParamNames[i],"keysize") == 0) { // legend keysize, used with legend-related outputs
-      int n=0;
+    if (strcasecmp(mapserv->request->ParamNames[i], "keysize") ==
+        0) { // legend keysize, used with legend-related outputs
+      int n = 0;
       char **tokens = msStringSplit(mapserv->request->ParamValues[i], ' ', &n);
 
-      if(!tokens) {
+      if (!tokens) {
         msSetError(MS_MEMERR, NULL, "commonLoadForm()");
         return MS_FAILURE;
       }
 
-      if(n != 2) {
-        msSetError(MS_WEBERR, "Not enough arguments for keysize.", "commonLoadForm()");
-        msFreeCharArray(tokens,n);
+      if (n != 2) {
+        msSetError(MS_WEBERR, "Not enough arguments for keysize.",
+                   "commonLoadForm()");
+        msFreeCharArray(tokens, n);
         return MS_FAILURE;
       }
 
-      GET_NUMERIC_NO_ERROR(tokens[0],tmpval);
+      GET_NUMERIC_NO_ERROR(tokens[0], tmpval);
       FREE_TOKENS_ON_ERROR(2);
       map->legend.keysizex = (int)tmpval;
-      GET_NUMERIC_NO_ERROR(tokens[1],tmpval);
+      GET_NUMERIC_NO_ERROR(tokens[1], tmpval);
       FREE_TOKENS_ON_ERROR(2);
       map->legend.keysizey = (int)tmpval;
 
       msFreeCharArray(tokens, 2);
 
-      if(map->legend.keysizex < MS_LEGEND_KEYSIZE_MIN || map->legend.keysizex > MS_LEGEND_KEYSIZE_MAX || map->legend.keysizey < MS_LEGEND_KEYSIZE_MIN || map->legend.keysizey > MS_LEGEND_KEYSIZE_MAX) {
-        msSetError(MS_WEBERR, "Legend keysize out of range.", "commonLoadForm()");
+      if (map->legend.keysizex < MS_LEGEND_KEYSIZE_MIN ||
+          map->legend.keysizex > MS_LEGEND_KEYSIZE_MAX ||
+          map->legend.keysizey < MS_LEGEND_KEYSIZE_MIN ||
+          map->legend.keysizey > MS_LEGEND_KEYSIZE_MAX) {
+        msSetError(MS_WEBERR, "Legend keysize out of range.",
+                   "commonLoadForm()");
         return MS_FAILURE;
       }
 
@@ -504,162 +586,183 @@ static int commonLoadForm(mapservObj *ma
 /*
 ** Process CGI parameters.
 */
-int msCGILoadForm(mapservObj *mapserv)
-{
-  int i,n;
-  char **tokens=NULL;
-  int rosa_type=0;
+int msCGILoadForm(mapservObj *mapserv) {
+  int i, n;
+  char **tokens = NULL;
+  int rosa_type = 0;
   double tmpval;
   char *strtoderr;
 
-  for(i=0; i<mapserv->request->NumParams; i++) { /* now process the rest of the form variables */
-    if(strlen(mapserv->request->ParamValues[i]) == 0)
+  for (i = 0; i < mapserv->request->NumParams;
+       i++) { /* now process the rest of the form variables */
+    if (strlen(mapserv->request->ParamValues[i]) == 0)
       continue;
 
-
-    if(strcasecmp(mapserv->request->ParamNames[i],"icon") == 0) {
+    if (strcasecmp(mapserv->request->ParamNames[i], "icon") == 0) {
       mapserv->icon = msStrdup(mapserv->request->ParamValues[i]);
       continue;
     }
 
-    if(strcasecmp(mapserv->request->ParamNames[i],"queryfile") == 0) {
+    if (strcasecmp(mapserv->request->ParamNames[i], "queryfile") == 0) {
       mapserv->QueryFile = msStrdup(mapserv->request->ParamValues[i]);
-      if(msValidateParameter(mapserv->QueryFile, msLookupHashTable(&(mapserv->map->web.validation), "queryfile"), NULL, NULL, NULL) != MS_SUCCESS) {
-        msSetError(MS_WEBERR, "Parameter 'queryfile' value fails to validate.", "mapserv()");
+      if (msValidateParameter(
+              mapserv->QueryFile,
+              msLookupHashTable(&(mapserv->map->web.validation), "queryfile"),
+              NULL, NULL, NULL) != MS_SUCCESS) {
+        msSetError(MS_WEBERR, "Parameter 'queryfile' value fails to validate.",
+                   "mapserv()");
         return MS_FAILURE;
       }
       continue;
     }
 
-    if(strcasecmp(mapserv->request->ParamNames[i],"savequery") == 0) {
+    if (strcasecmp(mapserv->request->ParamNames[i], "savequery") == 0) {
       mapserv->savequery = MS_TRUE;
       continue;
     }
 
-    /* Insecure as implemented, need to save someplace non accessible by everyone in the universe
+    /* Insecure as implemented, need to save someplace non accessible by
+       everyone in the universe
         if(strcasecmp(mapserv->request->ParamNames[i],"savemap") == 0) {
          mapserv->savemap = MS_TRUE;
          continue;
         }
     */
 
-    if(strcasecmp(mapserv->request->ParamNames[i],"zoom") == 0) {
-      GET_NUMERIC(mapserv->request->ParamValues[i],mapserv->Zoom);
-      if((mapserv->Zoom > MAXZOOM) || (mapserv->Zoom < MINZOOM)) {
+    if (strcasecmp(mapserv->request->ParamNames[i], "zoom") == 0) {
+      GET_NUMERIC(mapserv->request->ParamValues[i], mapserv->Zoom);
+      if ((mapserv->Zoom > MAXZOOM) || (mapserv->Zoom < MINZOOM)) {
         msSetError(MS_WEBERR, "Zoom value out of range.", "msCGILoadForm()");
         return MS_FAILURE;
       }
       continue;
     }
 
-    if(strcasecmp(mapserv->request->ParamNames[i],"zoomdir") == 0) {
-      GET_NUMERIC(mapserv->request->ParamValues[i],tmpval);
+    if (strcasecmp(mapserv->request->ParamNames[i], "zoomdir") == 0) {
+      GET_NUMERIC(mapserv->request->ParamValues[i], tmpval);
       mapserv->ZoomDirection = (int)tmpval;
-      if((mapserv->ZoomDirection != -1) && (mapserv->ZoomDirection != 1) && (mapserv->ZoomDirection != 0)) {
-        msSetError(MS_WEBERR, "Zoom direction must be 1, 0 or -1.", "msCGILoadForm()");
+      if ((mapserv->ZoomDirection != -1) && (mapserv->ZoomDirection != 1) &&
+          (mapserv->ZoomDirection != 0)) {
+        msSetError(MS_WEBERR, "Zoom direction must be 1, 0 or -1.",
+                   "msCGILoadForm()");
         return MS_FAILURE;
       }
       continue;
     }
 
-    if(strcasecmp(mapserv->request->ParamNames[i],"zoomsize") == 0) { /* absolute zoom magnitude */
-      GET_NUMERIC(mapserv->request->ParamValues[i],tmpval);
+    if (strcasecmp(mapserv->request->ParamNames[i], "zoomsize") ==
+        0) { /* absolute zoom magnitude */
+      GET_NUMERIC(mapserv->request->ParamValues[i], tmpval);
       mapserv->ZoomSize = (int)tmpval;
-      if((mapserv->ZoomSize > MAXZOOM) || (mapserv->ZoomSize < 1)) {
+      if ((mapserv->ZoomSize > MAXZOOM) || (mapserv->ZoomSize < 1)) {
         msSetError(MS_WEBERR, "Invalid zoom size.", "msCGILoadForm()");
         return MS_FAILURE;
       }
       continue;
     }
 
-    if(strcasecmp(mapserv->request->ParamNames[i],"imgext") == 0) { /* extent of an existing image in a web application */
+    if (strcasecmp(mapserv->request->ParamNames[i], "imgext") ==
+        0) { /* extent of an existing image in a web application */
       tokens = msStringSplit(mapserv->request->ParamValues[i], ' ', &n);
 
-      if(!tokens) {
+      if (!tokens) {
         msSetError(MS_MEMERR, NULL, "msCGILoadForm()");
         return MS_FAILURE;
       }
 
-      if(n != 4) {
-        msSetError(MS_WEBERR, "Not enough arguments for imgext.", "msCGILoadForm()");
-        msFreeCharArray(tokens,n);
+      if (n != 4) {
+        msSetError(MS_WEBERR, "Not enough arguments for imgext.",
+                   "msCGILoadForm()");
+        msFreeCharArray(tokens, n);
         return MS_FAILURE;
       }
 
-      GET_NUMERIC_NO_ERROR(tokens[0],mapserv->ImgExt.minx);
+      GET_NUMERIC_NO_ERROR(tokens[0], mapserv->ImgExt.minx);
       FREE_TOKENS_ON_ERROR(4);
-      GET_NUMERIC_NO_ERROR(tokens[1],mapserv->ImgExt.miny);
+      GET_NUMERIC_NO_ERROR(tokens[1], mapserv->ImgExt.miny);
       FREE_TOKENS_ON_ERROR(4);
-      GET_NUMERIC_NO_ERROR(tokens[2],mapserv->ImgExt.maxx);
+      GET_NUMERIC_NO_ERROR(tokens[2], mapserv->ImgExt.maxx);
       FREE_TOKENS_ON_ERROR(4);
-      GET_NUMERIC_NO_ERROR(tokens[3],mapserv->ImgExt.maxy);
+      GET_NUMERIC_NO_ERROR(tokens[3], mapserv->ImgExt.maxy);
       FREE_TOKENS_ON_ERROR(4);
 
       msFreeCharArray(tokens, 4);
       continue;
     }
 
-    if(strcasecmp(mapserv->request->ParamNames[i],"searchmap") == 0) {
+    if (strcasecmp(mapserv->request->ParamNames[i], "searchmap") == 0) {
       mapserv->SearchMap = MS_TRUE;
       continue;
     }
 
-    if(strcasecmp(mapserv->request->ParamNames[i],"id") == 0) {
-      if(msEvalRegex(IDPATTERN, mapserv->request->ParamValues[i]) == MS_FALSE) {
-        msSetError(MS_WEBERR, "Parameter 'id' value fails to validate.", "msCGILoadForm()");
+    if (strcasecmp(mapserv->request->ParamNames[i], "id") == 0) {
+      if (msEvalRegex(IDPATTERN, mapserv->request->ParamValues[i]) ==
+          MS_FALSE) {
+        msSetError(MS_WEBERR, "Parameter 'id' value fails to validate.",
+                   "msCGILoadForm()");
         return MS_FAILURE;
       }
       strlcpy(mapserv->Id, mapserv->request->ParamValues[i], IDSIZE);
       continue;
     }
 
-    if(strcasecmp(mapserv->request->ParamNames[i],"mapext") == 0) { /* extent of the new map or query */
+    if (strcasecmp(mapserv->request->ParamNames[i], "mapext") ==
+        0) { /* extent of the new map or query */
 
-      if(strncasecmp(mapserv->request->ParamValues[i],"shape",5) == 0)
+      if (strncasecmp(mapserv->request->ParamValues[i], "shape", 5) == 0)
         mapserv->UseShapes = MS_TRUE;
       else {
         tokens = msStringSplit(mapserv->request->ParamValues[i], ' ', &n);
 
-        if(!tokens) {
+        if (!tokens) {
           msSetError(MS_MEMERR, NULL, "msCGILoadForm()");
           return MS_FAILURE;
         }
 
-        if(n != 4) {
-          msSetError(MS_WEBERR, "Not enough arguments for mapext.", "msCGILoadForm()");
-          msFreeCharArray(tokens,n);
+        if (n != 4) {
+          msSetError(MS_WEBERR, "Not enough arguments for mapext.",
+                     "msCGILoadForm()");
+          msFreeCharArray(tokens, n);
           return MS_FAILURE;
         }
 
-        GET_NUMERIC_NO_ERROR(tokens[0],mapserv->map->extent.minx);
+        GET_NUMERIC_NO_ERROR(tokens[0], mapserv->map->extent.minx);
         FREE_TOKENS_ON_ERROR(4);
-        GET_NUMERIC_NO_ERROR(tokens[1],mapserv->map->extent.miny);
+        GET_NUMERIC_NO_ERROR(tokens[1], mapserv->map->extent.miny);
         FREE_TOKENS_ON_ERROR(4);
-        GET_NUMERIC_NO_ERROR(tokens[2],mapserv->map->extent.maxx);
+        GET_NUMERIC_NO_ERROR(tokens[2], mapserv->map->extent.maxx);
         FREE_TOKENS_ON_ERROR(4);
-        GET_NUMERIC_NO_ERROR(tokens[3],mapserv->map->extent.maxy);
+        GET_NUMERIC_NO_ERROR(tokens[3], mapserv->map->extent.maxy);
         FREE_TOKENS_ON_ERROR(4);
 
         msFreeCharArray(tokens, 4);
 
         /*
-         * If there is a projection in the map file, and it is not lon/lat, and the
-         * extents "look like" they *are* lon/lat, based on their size,
-         * then convert the extents to the map file projection.
+         * If there is a projection in the map file, and it is not lon/lat, and
+         * the extents "look like" they *are* lon/lat, based on their size, then
+         * convert the extents to the map file projection.
          *
          * DANGER: If the extents are legitimately in the mapfile projection
          *         and coincidentally fall in the lon/lat range, bad things
          *         will ensue.
          */
-        if(mapserv->map->projection.proj && !msProjIsGeographicCRS(&(mapserv->map->projection))
-            && (mapserv->map->extent.minx >= -180.0 && mapserv->map->extent.minx <= 180.0)
-            && (mapserv->map->extent.miny >= -90.0 && mapserv->map->extent.miny <= 90.0)
-            && (mapserv->map->extent.maxx >= -180.0 && mapserv->map->extent.maxx <= 180.0)
-            && (mapserv->map->extent.maxy >= -90.0 && mapserv->map->extent.maxy <= 90.0)) {
-          msProjectRect(&(mapserv->map->latlon), &(mapserv->map->projection), &(mapserv->map->extent)); /* extent is a in lat/lon */
-        }
-
-        if((mapserv->map->extent.minx != mapserv->map->extent.maxx) && (mapserv->map->extent.miny != mapserv->map->extent.maxy)) { /* extent seems ok */
+        if (mapserv->map->projection.proj &&
+            !msProjIsGeographicCRS(&(mapserv->map->projection)) &&
+            (mapserv->map->extent.minx >= -180.0 &&
+             mapserv->map->extent.minx <= 180.0) &&
+            (mapserv->map->extent.miny >= -90.0 &&
+             mapserv->map->extent.miny <= 90.0) &&
+            (mapserv->map->extent.maxx >= -180.0 &&
+             mapserv->map->extent.maxx <= 180.0) &&
+            (mapserv->map->extent.maxy >= -90.0 &&
+             mapserv->map->extent.maxy <= 90.0)) {
+          msProjectRect(&(mapserv->map->latlon), &(mapserv->map->projection),
+                        &(mapserv->map->extent)); /* extent is a in lat/lon */
+        }
+
+        if ((mapserv->map->extent.minx != mapserv->map->extent.maxx) &&
+            (mapserv->map->extent.miny !=
+             mapserv->map->extent.maxy)) { /* extent seems ok */
           mapserv->CoordSource = FROMUSERBOX;
           mapserv->QueryCoordSource = FROMUSERBOX;
         }
@@ -668,57 +771,63 @@ int msCGILoadForm(mapservObj *mapserv)
       continue;
     }
 
-    if(strcasecmp(mapserv->request->ParamNames[i],"minx") == 0) { /* extent of the new map, in pieces */
-      GET_NUMERIC(mapserv->request->ParamValues[i],mapserv->map->extent.minx);
+    if (strcasecmp(mapserv->request->ParamNames[i], "minx") ==
+        0) { /* extent of the new map, in pieces */
+      GET_NUMERIC(mapserv->request->ParamValues[i], mapserv->map->extent.minx);
       continue;
     }
-    if(strcasecmp(mapserv->request->ParamNames[i],"maxx") == 0) {
-      GET_NUMERIC(mapserv->request->ParamValues[i],mapserv->map->extent.maxx);
+    if (strcasecmp(mapserv->request->ParamNames[i], "maxx") == 0) {
+      GET_NUMERIC(mapserv->request->ParamValues[i], mapserv->map->extent.maxx);
       continue;
     }
-    if(strcasecmp(mapserv->request->ParamNames[i],"miny") == 0) {
-      GET_NUMERIC(mapserv->request->ParamValues[i],mapserv->map->extent.miny);
+    if (strcasecmp(mapserv->request->ParamNames[i], "miny") == 0) {
+      GET_NUMERIC(mapserv->request->ParamValues[i], mapserv->map->extent.miny);
       continue;
     }
-    if(strcasecmp(mapserv->request->ParamNames[i],"maxy") == 0) {
-      GET_NUMERIC(mapserv->request->ParamValues[i],mapserv->map->extent.maxy);
+    if (strcasecmp(mapserv->request->ParamNames[i], "maxy") == 0) {
+      GET_NUMERIC(mapserv->request->ParamValues[i], mapserv->map->extent.maxy);
       mapserv->CoordSource = FROMUSERBOX;
       mapserv->QueryCoordSource = FROMUSERBOX;
       continue;
     }
 
-    if(strcasecmp(mapserv->request->ParamNames[i],"mapxy") == 0) { /* user map coordinate */
+    if (strcasecmp(mapserv->request->ParamNames[i], "mapxy") ==
+        0) { /* user map coordinate */
 
-      if(strncasecmp(mapserv->request->ParamValues[i],"shape",5) == 0) {
+      if (strncasecmp(mapserv->request->ParamValues[i], "shape", 5) == 0) {
         mapserv->UseShapes = MS_TRUE;
       } else {
         tokens = msStringSplit(mapserv->request->ParamValues[i], ' ', &n);
 
-        if(!tokens) {
+        if (!tokens) {
           msSetError(MS_MEMERR, NULL, "msCGILoadForm()");
           return MS_FAILURE;
         }
 
-        if(n != 2) {
-          msSetError(MS_WEBERR, "Not enough arguments for mapxy.", "msCGILoadForm()");
-          msFreeCharArray(tokens,n);
+        if (n != 2) {
+          msSetError(MS_WEBERR, "Not enough arguments for mapxy.",
+                     "msCGILoadForm()");
+          msFreeCharArray(tokens, n);
           return MS_FAILURE;
         }
 
-        GET_NUMERIC_NO_ERROR(tokens[0],mapserv->mappnt.x );
+        GET_NUMERIC_NO_ERROR(tokens[0], mapserv->mappnt.x);
         FREE_TOKENS_ON_ERROR(2);
-        GET_NUMERIC_NO_ERROR(tokens[1],mapserv->mappnt.y );
+        GET_NUMERIC_NO_ERROR(tokens[1], mapserv->mappnt.y);
         FREE_TOKENS_ON_ERROR(2);
 
         msFreeCharArray(tokens, 2);
 
-        if(mapserv->map->projection.proj && !msProjIsGeographicCRS(&(mapserv->map->projection))
-            && (mapserv->mappnt.x >= -180.0 && mapserv->mappnt.x <= 180.0)
-            && (mapserv->mappnt.y >= -90.0 && mapserv->mappnt.y <= 90.0)) {
-          msProjectPoint(&(mapserv->map->latlon), &(mapserv->map->projection), &mapserv->mappnt); /* point is a in lat/lon */
+        if (mapserv->map->projection.proj &&
+            !msProjIsGeographicCRS(&(mapserv->map->projection)) &&
+            (mapserv->mappnt.x >= -180.0 && mapserv->mappnt.x <= 180.0) &&
+            (mapserv->mappnt.y >= -90.0 && mapserv->mappnt.y <= 90.0)) {
+          msProjectPoint(&(mapserv->map->latlon), &(mapserv->map->projection),
+                         &mapserv->mappnt); /* point is a in lat/lon */
         }
 
-        if(mapserv->CoordSource == NONE) { /* don't override previous settings (i.e. buffer or scale ) */
+        if (mapserv->CoordSource == NONE) { /* don't override previous settings
+                                               (i.e. buffer or scale ) */
           mapserv->CoordSource = FROMUSERPNT;
           mapserv->QueryCoordSource = FROMUSERPNT;
         }
@@ -727,51 +836,61 @@ int msCGILoadForm(mapservObj *mapserv)
     }
 
     /*
-    ** Query shape consisting of map or image coordinates. It's almost identical processing so we'll do either in this block...
+    ** Query shape consisting of map or image coordinates. It's almost identical
+    *processing so we'll do either in this block...
     */
-    if(strcasecmp(mapserv->request->ParamNames[i], "mapshape") == 0 || strcasecmp(mapserv->request->ParamNames[i], "imgshape") == 0) {
-      if(strcasecmp(mapserv->request->ParamNames[i],"mapshape") == 0)
+    if (strcasecmp(mapserv->request->ParamNames[i], "mapshape") == 0 ||
+        strcasecmp(mapserv->request->ParamNames[i], "imgshape") == 0) {
+      if (strcasecmp(mapserv->request->ParamNames[i], "mapshape") == 0)
         mapserv->QueryCoordSource = FROMUSERSHAPE;
       else
         mapserv->QueryCoordSource = FROMIMGSHAPE;
 
-      if(strchr(mapserv->request->ParamValues[i], '(') != NULL) { /* try WKT */
-        if((mapserv->map->query.shape = msShapeFromWKT(mapserv->request->ParamValues[i])) == NULL) {
-          msSetError(MS_WEBERR, "WKT parse failed for mapshape/imgshape.", "msCGILoadForm()");
+      if (strchr(mapserv->request->ParamValues[i], '(') != NULL) { /* try WKT */
+        if ((mapserv->map->query.shape =
+                 msShapeFromWKT(mapserv->request->ParamValues[i])) == NULL) {
+          msSetError(MS_WEBERR, "WKT parse failed for mapshape/imgshape.",
+                     "msCGILoadForm()");
           return MS_FAILURE;
         }
       } else {
-        lineObj line= {0,NULL};
-        char **tmp=NULL;
+        lineObj line = {0, NULL};
+        char **tmp = NULL;
         int n, j;
 
         tmp = msStringSplit(mapserv->request->ParamValues[i], ' ', &n);
 
-        if(n%2 != 0 || n<8) { /* n must be even and be at least 8 */
-          msSetError(MS_WEBERR, "Malformed polygon geometry for mapshape/imgshape.", "msCGILoadForm()");
-          msFreeCharArray(tmp,n);
+        if (n % 2 != 0 || n < 8) { /* n must be even and be at least 8 */
+          msSetError(MS_WEBERR,
+                     "Malformed polygon geometry for mapshape/imgshape.",
+                     "msCGILoadForm()");
+          msFreeCharArray(tmp, n);
           return MS_FAILURE;
         }
 
-        line.numpoints = n/2;
-        line.point = (pointObj *)msSmallMalloc(sizeof(pointObj)*line.numpoints);
+        line.numpoints = n / 2;
+        line.point =
+            (pointObj *)msSmallMalloc(sizeof(pointObj) * line.numpoints);
 
-        mapserv->map->query.shape = (shapeObj *) msSmallMalloc(sizeof(shapeObj));
+        mapserv->map->query.shape = (shapeObj *)msSmallMalloc(sizeof(shapeObj));
         msInitShape(mapserv->map->query.shape);
         mapserv->map->query.shape->type = MS_SHAPE_POLYGON;
 
-        for(j=0; j<line.numpoints; j++) {
-          line.point[j].x = atof(tmp[2*j]);
-          line.point[j].y = atof(tmp[2*j+1]);
-
-          if(mapserv->QueryCoordSource == FROMUSERSHAPE && mapserv->map->projection.proj && !msProjIsGeographicCRS(&(mapserv->map->projection))
-              && (line.point[j].x >= -180.0 && line.point[j].x <= 180.0)
-              && (line.point[j].y >= -90.0 && line.point[j].y <= 90.0)) {
-            msProjectPoint(&(mapserv->map->latlon), &(mapserv->map->projection), &line.point[j]); /* point is a in lat/lon */
+        for (j = 0; j < line.numpoints; j++) {
+          line.point[j].x = atof(tmp[2 * j]);
+          line.point[j].y = atof(tmp[2 * j + 1]);
+
+          if (mapserv->QueryCoordSource == FROMUSERSHAPE &&
+              mapserv->map->projection.proj &&
+              !msProjIsGeographicCRS(&(mapserv->map->projection)) &&
+              (line.point[j].x >= -180.0 && line.point[j].x <= 180.0) &&
+              (line.point[j].y >= -90.0 && line.point[j].y <= 90.0)) {
+            msProjectPoint(&(mapserv->map->latlon), &(mapserv->map->projection),
+                           &line.point[j]); /* point is a in lat/lon */
           }
         }
 
-        if(msAddLine(mapserv->map->query.shape, &line) == -1) {
+        if (msAddLine(mapserv->map->query.shape, &line) == -1) {
           msFree(line.point);
           msFreeCharArray(tmp, n);
           return MS_FAILURE;
@@ -784,9 +903,11 @@ int msCGILoadForm(mapservObj *mapserv)
       continue;
     }
 
-    if(strcasecmp(mapserv->request->ParamNames[i],"img.x") == 0) { /* mouse click, in pieces */
-      GET_NUMERIC(mapserv->request->ParamValues[i],mapserv->ImgPnt.x);
-      if((mapserv->ImgPnt.x > (2*mapserv->map->maxsize)) || (mapserv->ImgPnt.x < (-2*mapserv->map->maxsize))) {
+    if (strcasecmp(mapserv->request->ParamNames[i], "img.x") ==
+        0) { /* mouse click, in pieces */
+      GET_NUMERIC(mapserv->request->ParamValues[i], mapserv->ImgPnt.x);
+      if ((mapserv->ImgPnt.x > (2 * mapserv->map->maxsize)) ||
+          (mapserv->ImgPnt.x < (-2 * mapserv->map->maxsize))) {
         msSetError(MS_WEBERR, "Coordinate out of range.", "msCGILoadForm()");
         return MS_FAILURE;
       }
@@ -794,9 +915,10 @@ int msCGILoadForm(mapservObj *mapserv)
       mapserv->QueryCoordSource = FROMIMGPNT;
       continue;
     }
-    if(strcasecmp(mapserv->request->ParamNames[i],"img.y") == 0) {
-      GET_NUMERIC(mapserv->request->ParamValues[i],mapserv->ImgPnt.y);
-      if((mapserv->ImgPnt.y > (2*mapserv->map->maxsize)) || (mapserv->ImgPnt.y < (-2*mapserv->map->maxsize))) {
+    if (strcasecmp(mapserv->request->ParamNames[i], "img.y") == 0) {
+      GET_NUMERIC(mapserv->request->ParamValues[i], mapserv->ImgPnt.y);
+      if ((mapserv->ImgPnt.y > (2 * mapserv->map->maxsize)) ||
+          (mapserv->ImgPnt.y < (-2 * mapserv->map->maxsize))) {
         msSetError(MS_WEBERR, "Coordinate out of range.", "msCGILoadForm()");
         return MS_FAILURE;
       }
@@ -805,86 +927,101 @@ int msCGILoadForm(mapservObj *mapserv)
       continue;
     }
 
-    if(strcasecmp(mapserv->request->ParamNames[i],"imgxy") == 0) { /* mouse click, single variable */
-      if(mapserv->CoordSource == FROMIMGPNT)
+    if (strcasecmp(mapserv->request->ParamNames[i], "imgxy") ==
+        0) { /* mouse click, single variable */
+      if (mapserv->CoordSource == FROMIMGPNT)
         continue;
 
       tokens = msStringSplit(mapserv->request->ParamValues[i], ' ', &n);
 
-      if(!tokens) {
+      if (!tokens) {
         msSetError(MS_MEMERR, NULL, "msCGILoadForm()");
         return MS_FAILURE;
       }
 
-      if(n != 2) {
-        msSetError(MS_WEBERR, "Not enough arguments for imgxy.", "msCGILoadForm()");
-        msFreeCharArray(tokens,n);
+      if (n != 2) {
+        msSetError(MS_WEBERR, "Not enough arguments for imgxy.",
+                   "msCGILoadForm()");
+        msFreeCharArray(tokens, n);
         return MS_FAILURE;
       }
 
-      GET_NUMERIC_NO_ERROR(tokens[0],mapserv->ImgPnt.x );
+      GET_NUMERIC_NO_ERROR(tokens[0], mapserv->ImgPnt.x);
       FREE_TOKENS_ON_ERROR(2);
-      GET_NUMERIC_NO_ERROR(tokens[1],mapserv->ImgPnt.y );
+      GET_NUMERIC_NO_ERROR(tokens[1], mapserv->ImgPnt.y);
       FREE_TOKENS_ON_ERROR(2);
 
       msFreeCharArray(tokens, 2);
 
-      if((mapserv->ImgPnt.x > (2*mapserv->map->maxsize)) || (mapserv->ImgPnt.x < (-2*mapserv->map->maxsize)) || (mapserv->ImgPnt.y > (2*mapserv->map->maxsize)) || (mapserv->ImgPnt.y < (-2*mapserv->map->maxsize))) {
-        msSetError(MS_WEBERR, "Reference map coordinate out of range.", "msCGILoadForm()");
+      if ((mapserv->ImgPnt.x > (2 * mapserv->map->maxsize)) ||
+          (mapserv->ImgPnt.x < (-2 * mapserv->map->maxsize)) ||
+          (mapserv->ImgPnt.y > (2 * mapserv->map->maxsize)) ||
+          (mapserv->ImgPnt.y < (-2 * mapserv->map->maxsize))) {
+        msSetError(MS_WEBERR, "Reference map coordinate out of range.",
+                   "msCGILoadForm()");
         return MS_FAILURE;
       }
 
-      if(mapserv->CoordSource == NONE) { /* override nothing since this parameter is usually used to hold a default value */
+      if (mapserv->CoordSource ==
+          NONE) { /* override nothing since this parameter is usually used to
+                     hold a default value */
         mapserv->CoordSource = FROMIMGPNT;
         mapserv->QueryCoordSource = FROMIMGPNT;
       }
       continue;
     }
 
-    if(strcasecmp(mapserv->request->ParamNames[i],"imgbox") == 0) { /* selection box (eg. mouse drag) */
+    if (strcasecmp(mapserv->request->ParamNames[i], "imgbox") ==
+        0) { /* selection box (eg. mouse drag) */
       tokens = msStringSplit(mapserv->request->ParamValues[i], ' ', &n);
 
-      if(!tokens) {
+      if (!tokens) {
         msSetError(MS_MEMERR, NULL, "msCGILoadForm()");
         return MS_FAILURE;
       }
 
-      if(n != 4) {
-        msSetError(MS_WEBERR, "Not enough arguments for imgbox.", "msCGILoadForm()");
-        msFreeCharArray(tokens,n);
+      if (n != 4) {
+        msSetError(MS_WEBERR, "Not enough arguments for imgbox.",
+                   "msCGILoadForm()");
+        msFreeCharArray(tokens, n);
         return MS_FAILURE;
       }
 
-      GET_NUMERIC_NO_ERROR(tokens[0],mapserv->ImgBox.minx);
+      GET_NUMERIC_NO_ERROR(tokens[0], mapserv->ImgBox.minx);
       FREE_TOKENS_ON_ERROR(4);
-      GET_NUMERIC_NO_ERROR(tokens[1],mapserv->ImgBox.miny);
+      GET_NUMERIC_NO_ERROR(tokens[1], mapserv->ImgBox.miny);
       FREE_TOKENS_ON_ERROR(4);
-      GET_NUMERIC_NO_ERROR(tokens[2],mapserv->ImgBox.maxx);
+      GET_NUMERIC_NO_ERROR(tokens[2], mapserv->ImgBox.maxx);
       FREE_TOKENS_ON_ERROR(4);
-      GET_NUMERIC_NO_ERROR(tokens[3],mapserv->ImgBox.maxy);
+      GET_NUMERIC_NO_ERROR(tokens[3], mapserv->ImgBox.maxy);
       FREE_TOKENS_ON_ERROR(4);
 
       msFreeCharArray(tokens, 4);
 
-      if((mapserv->ImgBox.minx != mapserv->ImgBox.maxx) && (mapserv->ImgBox.miny != mapserv->ImgBox.maxy)) { /* must not degenerate into a point */
+      if ((mapserv->ImgBox.minx != mapserv->ImgBox.maxx) &&
+          (mapserv->ImgBox.miny !=
+           mapserv->ImgBox.maxy)) { /* must not degenerate into a point */
         mapserv->CoordSource = FROMIMGBOX;
         mapserv->QueryCoordSource = FROMIMGBOX;
       }
       continue;
     }
 
-    if(strcasecmp(mapserv->request->ParamNames[i],"ref.x") == 0) { /* mouse click in reference image, in pieces */
-      GET_NUMERIC(mapserv->request->ParamValues[i],mapserv->RefPnt.x);
-      if((mapserv->RefPnt.x > (2*mapserv->map->maxsize)) || (mapserv->RefPnt.x < (-2*mapserv->map->maxsize))) {
+    if (strcasecmp(mapserv->request->ParamNames[i], "ref.x") ==
+        0) { /* mouse click in reference image, in pieces */
+      GET_NUMERIC(mapserv->request->ParamValues[i], mapserv->RefPnt.x);
+      if ((mapserv->RefPnt.x > (2 * mapserv->map->maxsize)) ||
+          (mapserv->RefPnt.x < (-2 * mapserv->map->maxsize))) {
         msSetError(MS_WEBERR, "Coordinate out of range.", "msCGILoadForm()");
         return MS_FAILURE;
       }
       mapserv->CoordSource = FROMREFPNT;
       continue;
     }
-    if(strcasecmp(mapserv->request->ParamNames[i],"ref.y") == 0) {
-      GET_NUMERIC(mapserv->request->ParamValues[i],mapserv->RefPnt.y);
-      if((mapserv->RefPnt.y > (2*mapserv->map->maxsize)) || (mapserv->RefPnt.y < (-2*mapserv->map->maxsize))) {
+    if (strcasecmp(mapserv->request->ParamNames[i], "ref.y") == 0) {
+      GET_NUMERIC(mapserv->request->ParamValues[i], mapserv->RefPnt.y);
+      if ((mapserv->RefPnt.y > (2 * mapserv->map->maxsize)) ||
+          (mapserv->RefPnt.y < (-2 * mapserv->map->maxsize))) {
         msSetError(MS_WEBERR, "Coordinate out of range.", "msCGILoadForm()");
         return MS_FAILURE;
       }
@@ -892,29 +1029,35 @@ int msCGILoadForm(mapservObj *mapserv)
       continue;
     }
 
-    if(strcasecmp(mapserv->request->ParamNames[i],"refxy") == 0) { /* mouse click in reference image, single variable */
+    if (strcasecmp(mapserv->request->ParamNames[i], "refxy") ==
+        0) { /* mouse click in reference image, single variable */
       tokens = msStringSplit(mapserv->request->ParamValues[i], ' ', &n);
 
-      if(!tokens) {
+      if (!tokens) {
         msSetError(MS_MEMERR, NULL, "msCGILoadForm()");
         return MS_FAILURE;
       }
 
-      if(n != 2) {
-        msSetError(MS_WEBERR, "Not enough arguments for imgxy.", "msCGILoadForm()");
-        msFreeCharArray(tokens,n);
+      if (n != 2) {
+        msSetError(MS_WEBERR, "Not enough arguments for imgxy.",
+                   "msCGILoadForm()");
+        msFreeCharArray(tokens, n);
         return MS_FAILURE;
       }
 
-      GET_NUMERIC_NO_ERROR(tokens[0],mapserv->RefPnt.x);
+      GET_NUMERIC_NO_ERROR(tokens[0], mapserv->RefPnt.x);
       FREE_TOKENS_ON_ERROR(2);
-      GET_NUMERIC_NO_ERROR(tokens[1],mapserv->RefPnt.y);
+      GET_NUMERIC_NO_ERROR(tokens[1], mapserv->RefPnt.y);
       FREE_TOKENS_ON_ERROR(2);
 
       msFreeCharArray(tokens, 2);
 
-      if((mapserv->RefPnt.x > (2*mapserv->map->maxsize)) || (mapserv->RefPnt.x < (-2*mapserv->map->maxsize)) || (mapserv->RefPnt.y > (2*mapserv->map->maxsize)) || (mapserv->RefPnt.y < (-2*mapserv->map->maxsize))) {
-        msSetError(MS_WEBERR, "Reference map coordinate out of range.", "msCGILoadForm()");
+      if ((mapserv->RefPnt.x > (2 * mapserv->map->maxsize)) ||
+          (mapserv->RefPnt.x < (-2 * mapserv->map->maxsize)) ||
+          (mapserv->RefPnt.y > (2 * mapserv->map->maxsize)) ||
+          (mapserv->RefPnt.y < (-2 * mapserv->map->maxsize))) {
+        msSetError(MS_WEBERR, "Reference map coordinate out of range.",
+                   "msCGILoadForm()");
         return MS_FAILURE;
       }
 
@@ -922,16 +1065,19 @@ int msCGILoadForm(mapservObj *mapserv)
       continue;
     }
 
-    if(strcasecmp(mapserv->request->ParamNames[i],"buffer") == 0) { /* radius (map units), actually 1/2 square side */
-      GET_NUMERIC(mapserv->request->ParamValues[i],mapserv->Buffer);
+    if (strcasecmp(mapserv->request->ParamNames[i], "buffer") ==
+        0) { /* radius (map units), actually 1/2 square side */
+      GET_NUMERIC(mapserv->request->ParamValues[i], mapserv->Buffer);
       mapserv->CoordSource = FROMBUF;
       mapserv->QueryCoordSource = FROMUSERPNT;
       continue;
     }
 
-    if(strcasecmp(mapserv->request->ParamNames[i],"scale") == 0 || strcasecmp(mapserv->request->ParamNames[i],"scaledenom") == 0) { /* scale for new map */
-      GET_NUMERIC(mapserv->request->ParamValues[i],mapserv->ScaleDenom);
-      if(mapserv->ScaleDenom <= 0) {
+    if (strcasecmp(mapserv->request->ParamNames[i], "scale") == 0 ||
+        strcasecmp(mapserv->request->ParamNames[i], "scaledenom") ==
+            0) { /* scale for new map */
+      GET_NUMERIC(mapserv->request->ParamValues[i], mapserv->ScaleDenom);
+      if (mapserv->ScaleDenom <= 0) {
         msSetError(MS_WEBERR, "Scale out of range.", "msCGILoadForm()");
         return MS_FAILURE;
       }
@@ -940,30 +1086,34 @@ int msCGILoadForm(mapservObj *mapserv)
       continue;
     }
 
-    if(strcasecmp(mapserv->request->ParamNames[i],"imgsize") == 0) { /* size of existing image (pixels) */
+    if (strcasecmp(mapserv->request->ParamNames[i], "imgsize") ==
+        0) { /* size of existing image (pixels) */
       tokens = msStringSplit(mapserv->request->ParamValues[i], ' ', &n);
 
-      if(!tokens) {
+      if (!tokens) {
         msSetError(MS_MEMERR, NULL, "msCGILoadForm()");
         return MS_FAILURE;
       }
 
-      if(n != 2) {
-        msSetError(MS_WEBERR, "Not enough arguments for imgsize.", "msCGILoadForm()");
-        msFreeCharArray(tokens,n);
+      if (n != 2) {
+        msSetError(MS_WEBERR, "Not enough arguments for imgsize.",
+                   "msCGILoadForm()");
+        msFreeCharArray(tokens, n);
         return MS_FAILURE;
       }
 
-      GET_NUMERIC_NO_ERROR(tokens[0],tmpval);
+      GET_NUMERIC_NO_ERROR(tokens[0], tmpval);
       FREE_TOKENS_ON_ERROR(2);
       mapserv->ImgCols = (int)tmpval;
-      GET_NUMERIC_NO_ERROR(tokens[1],tmpval);
+      GET_NUMERIC_NO_ERROR(tokens[1], tmpval);
       FREE_TOKENS_ON_ERROR(2);
       mapserv->ImgRows = (int)tmpval;
 
       msFreeCharArray(tokens, 2);
 
-      if(mapserv->ImgCols > mapserv->map->maxsize || mapserv->ImgRows > mapserv->map->maxsize || mapserv->ImgCols <= 0 || mapserv->ImgRows <= 0) {
+      if (mapserv->ImgCols > mapserv->map->maxsize ||
+          mapserv->ImgRows > mapserv->map->maxsize || mapserv->ImgCols <= 0 ||
+          mapserv->ImgRows <= 0) {
         msSetError(MS_WEBERR, "Image size out of range.", "msCGILoadForm()");
         return MS_FAILURE;
       }
@@ -971,60 +1121,75 @@ int msCGILoadForm(mapservObj *mapserv)
       continue;
     }
 
-    if(strcasecmp(mapserv->request->ParamNames[i], "resolution") == 0) {
+    if (strcasecmp(mapserv->request->ParamNames[i], "resolution") == 0) {
       GET_NUMERIC(mapserv->request->ParamValues[i], tmpval);
-      if(tmpval < MS_RESOLUTION_MIN || tmpval > MS_RESOLUTION_MAX) {
-        msSetError(MS_WEBERR, "Resolution value out of range.", "msCGILoadForm()");
+      if (tmpval < MS_RESOLUTION_MIN || tmpval > MS_RESOLUTION_MAX) {
+        msSetError(MS_WEBERR, "Resolution value out of range.",
+                   "msCGILoadForm()");
         return MS_FAILURE;
       }
       mapserv->map->resolution = (int)tmpval;
       continue;
     }
 
-    // map.imagetype and map_imagetype are for backwards compatibility and may be removed in the future
-    if(strcasecmp(mapserv->request->ParamNames[i], "imagetype") == 0 || strcasecmp(mapserv->request->ParamNames[i], "map.imagetype") == 0 || strcasecmp(mapserv->request->ParamNames[i], "map_imagetype") == 0) {
-
-      const char *imagetype_validation_pattern = msLookupHashTable(&(mapserv->map->web.validation), "imagetype");
-      if(imagetype_validation_pattern != NULL && msEvalRegex(imagetype_validation_pattern, mapserv->request->ParamValues[i]) != MS_TRUE) { /* optional check */
-	msSetError(MS_WEBERR, "Imagetype value fails to validate.", "msCGILoadMap()");
-	return MS_FAILURE;
+    // map.imagetype and map_imagetype are for backwards compatibility and may
+    // be removed in the future
+    if (strcasecmp(mapserv->request->ParamNames[i], "imagetype") == 0 ||
+        strcasecmp(mapserv->request->ParamNames[i], "map.imagetype") == 0 ||
+        strcasecmp(mapserv->request->ParamNames[i], "map_imagetype") == 0) {
+
+      const char *imagetype_validation_pattern =
+          msLookupHashTable(&(mapserv->map->web.validation), "imagetype");
+      if (imagetype_validation_pattern != NULL &&
+          msEvalRegex(imagetype_validation_pattern,
+                      mapserv->request->ParamValues[i]) !=
+              MS_TRUE) { /* optional check */
+        msSetError(MS_WEBERR, "Imagetype value fails to validate.",
+                   "msCGILoadMap()");
+        return MS_FAILURE;
       }
 
-      outputFormatObj *format = msSelectOutputFormat(mapserv->map, mapserv->request->ParamValues[i]);
-      if(format == NULL) {
-	msSetError(MS_WEBERR, "Invalid imagetype value.\n", "msCGILoadForm()");
+      outputFormatObj *format =
+          msSelectOutputFormat(mapserv->map, mapserv->request->ParamValues[i]);
+      if (format == NULL) {
+        msSetError(MS_WEBERR, "Invalid imagetype value.\n", "msCGILoadForm()");
         return MS_FAILURE;
       } else {
-	msFree((char *) mapserv->map->imagetype);
-	mapserv->map->imagetype = msStrdup(mapserv->request->ParamValues[i]);
-	msApplyOutputFormat(&(mapserv->map->outputformat), format, MS_NOOVERRIDE);
+        msFree((char *)mapserv->map->imagetype);
+        mapserv->map->imagetype = msStrdup(mapserv->request->ParamValues[i]);
+        msApplyOutputFormat(&(mapserv->map->outputformat), format,
+                            MS_NOOVERRIDE);
       }
     }
 
-    if(strcasecmp(mapserv->request->ParamNames[i],"tilesize") == 0) { /* size of existing image (pixels) */
+    if (strcasecmp(mapserv->request->ParamNames[i], "tilesize") ==
+        0) { /* size of existing image (pixels) */
       tokens = msStringSplit(mapserv->request->ParamValues[i], ' ', &n);
 
-      if(!tokens) {
+      if (!tokens) {
         msSetError(MS_MEMERR, NULL, "msCGILoadForm()");
         return MS_FAILURE;
       }
 
-      if(n != 2) {
-        msSetError(MS_WEBERR, "Not enough arguments for tilesize.", "msCGILoadForm()");
-        msFreeCharArray(tokens,n);
+      if (n != 2) {
+        msSetError(MS_WEBERR, "Not enough arguments for tilesize.",
+                   "msCGILoadForm()");
+        msFreeCharArray(tokens, n);
         return MS_FAILURE;
       }
 
-      GET_NUMERIC_NO_ERROR(tokens[0],tmpval);
+      GET_NUMERIC_NO_ERROR(tokens[0], tmpval);
       FREE_TOKENS_ON_ERROR(2);
       mapserv->TileWidth = (int)tmpval;
-      GET_NUMERIC_NO_ERROR(tokens[1],tmpval);
+      GET_NUMERIC_NO_ERROR(tokens[1], tmpval);
       FREE_TOKENS_ON_ERROR(2);
       mapserv->TileHeight = (int)tmpval;
 
       msFreeCharArray(tokens, 2);
 
-      if(mapserv->TileWidth > mapserv->map->maxsize || mapserv->TileHeight > mapserv->map->maxsize || mapserv->TileWidth <= 0 || mapserv->TileHeight <= 0) {
+      if (mapserv->TileWidth > mapserv->map->maxsize ||
+          mapserv->TileHeight > mapserv->map->maxsize ||
+          mapserv->TileWidth <= 0 || mapserv->TileHeight <= 0) {
         msSetError(MS_WEBERR, "Tile size out of range.", "msCGILoadForm()");
         return MS_FAILURE;
       }
@@ -1032,66 +1197,77 @@ int msCGILoadForm(mapservObj *mapserv)
       continue;
     }
 
-    /* size of new map (pixels), map.size/map_size are included for backwards compatibility and may be removed in future release */
-    if(strcasecmp(mapserv->request->ParamNames[i],"mapsize") == 0 ||
-       strcasecmp(mapserv->request->ParamNames[i],"map.size") == 0 || strcasecmp(mapserv->request->ParamNames[i],"map_size") == 0) {
+    /* size of new map (pixels), map.size/map_size are included for backwards
+     * compatibility and may be removed in future release */
+    if (strcasecmp(mapserv->request->ParamNames[i], "mapsize") == 0 ||
+        strcasecmp(mapserv->request->ParamNames[i], "map.size") == 0 ||
+        strcasecmp(mapserv->request->ParamNames[i], "map_size") == 0) {
       tokens = msStringSplit(mapserv->request->ParamValues[i], ' ', &n);
 
-      if(!tokens) {
+      if (!tokens) {
         msSetError(MS_MEMERR, NULL, "msCGILoadForm()");
         return MS_FAILURE;
       }
 
-      if(n != 2) {
-        msSetError(MS_WEBERR, "Not enough arguments for mapsize.", "msCGILoadForm()");
-        msFreeCharArray(tokens,n);
+      if (n != 2) {
+        msSetError(MS_WEBERR, "Not enough arguments for mapsize.",
+                   "msCGILoadForm()");
+        msFreeCharArray(tokens, n);
         return MS_FAILURE;
       }
 
-      GET_NUMERIC_NO_ERROR(tokens[0],tmpval);
+      GET_NUMERIC_NO_ERROR(tokens[0], tmpval);
       FREE_TOKENS_ON_ERROR(2);
       mapserv->map->width = (int)tmpval;
-      GET_NUMERIC_NO_ERROR(tokens[1],tmpval);
+      GET_NUMERIC_NO_ERROR(tokens[1], tmpval);
       FREE_TOKENS_ON_ERROR(2);
       mapserv->map->height = (int)tmpval;
 
       msFreeCharArray(tokens, 2);
 
-      if(mapserv->map->width > mapserv->map->maxsize || mapserv->map->height > mapserv->map->maxsize || mapserv->map->width <= 0 || mapserv->map->height <= 0) {
+      if (mapserv->map->width > mapserv->map->maxsize ||
+          mapserv->map->height > mapserv->map->maxsize ||
+          mapserv->map->width <= 0 || mapserv->map->height <= 0) {
         msSetError(MS_WEBERR, "Image size out of range.", "msCGILoadForm()");
         return MS_FAILURE;
       }
       continue;
     }
 
-    if(strncasecmp(mapserv->request->ParamNames[i],"layers", 6) == 0) { /* turn a set of layers, delimited by spaces, on */
+    if (strncasecmp(mapserv->request->ParamNames[i], "layers", 6) ==
+        0) { /* turn a set of layers, delimited by spaces, on */
 
       /* If layers=all then turn on all layers */
       if (strcasecmp(mapserv->request->ParamValues[i], "all") == 0) {
         int l;
 
-        /* Reset NumLayers=0. If individual layers were already selected then free the previous values.  */
-        for(l=0; l<mapserv->NumLayers; l++)
+        /* Reset NumLayers=0. If individual layers were already selected then
+         * free the previous values.  */
+        for (l = 0; l < mapserv->NumLayers; l++)
           msFree(mapserv->Layers[l]);
-        mapserv->NumLayers=0;
+        mapserv->NumLayers = 0;
 
-        for(mapserv->NumLayers=0; mapserv->NumLayers < mapserv->map->numlayers; mapserv->NumLayers++) {
-          if(msGrowMapservLayers(mapserv) == MS_FAILURE)
+        for (mapserv->NumLayers = 0;
+             mapserv->NumLayers < mapserv->map->numlayers;
+             mapserv->NumLayers++) {
+          if (msGrowMapservLayers(mapserv) == MS_FAILURE)
             return MS_FAILURE;
 
-          if(GET_LAYER(mapserv->map, mapserv->NumLayers)->name) {
-            mapserv->Layers[mapserv->NumLayers] = msStrdup(GET_LAYER(mapserv->map, mapserv->NumLayers)->name);
+          if (GET_LAYER(mapserv->map, mapserv->NumLayers)->name) {
+            mapserv->Layers[mapserv->NumLayers] =
+                msStrdup(GET_LAYER(mapserv->map, mapserv->NumLayers)->name);
           } else {
             mapserv->Layers[mapserv->NumLayers] = msStrdup("");
           }
         }
       } else {
-        int num_layers=0, l;
-        char **layers=NULL;
+        int num_layers = 0, l;
+        char **layers = NULL;
 
-        layers = msStringSplit(mapserv->request->ParamValues[i], ' ', &(num_layers));
-        for(l=0; l<num_layers; l++) {
-          if(msGrowMapservLayers(mapserv) == MS_FAILURE) {
+        layers =
+            msStringSplit(mapserv->request->ParamValues[i], ' ', &(num_layers));
+        for (l = 0; l < num_layers; l++) {
+          if (msGrowMapservLayers(mapserv) == MS_FAILURE) {
             msFreeCharArray(layers, num_layers);
             return MS_FAILURE;
           }
@@ -1105,47 +1281,58 @@ int msCGILoadForm(mapservObj *mapserv)
       continue;
     }
 
-    if(strncasecmp(mapserv->request->ParamNames[i],"layer", 5) == 0) { /* turn a single layer/group on */
-      if(msGrowMapservLayers(mapserv) == MS_FAILURE)
+    if (strncasecmp(mapserv->request->ParamNames[i], "layer", 5) ==
+        0) { /* turn a single layer/group on */
+      if (msGrowMapservLayers(mapserv) == MS_FAILURE)
         return MS_FAILURE;
-      mapserv->Layers[mapserv->NumLayers] = msStrdup(mapserv->request->ParamValues[i]);
+      mapserv->Layers[mapserv->NumLayers] =
+          msStrdup(mapserv->request->ParamValues[i]);
       mapserv->NumLayers++;
       continue;
     }
 
-    if(strcasecmp(mapserv->request->ParamNames[i],"qlayer") == 0) { /* layer to query (i.e search) */
+    if (strcasecmp(mapserv->request->ParamNames[i], "qlayer") ==
+        0) { /* layer to query (i.e search) */
       mapserv->QueryLayer = msStrdup(mapserv->request->ParamValues[i]);
       continue;
     }
 
-    if(strcasecmp(mapserv->request->ParamNames[i],"qitem") == 0) { /* attribute to query on (optional) */
+    if (strcasecmp(mapserv->request->ParamNames[i], "qitem") ==
+        0) { /* attribute to query on (optional) */
       mapserv->QueryItem = msStrdup(mapserv->request->ParamValues[i]);
       continue;
     }
 
-    if(strcasecmp(mapserv->request->ParamNames[i],"qstring") == 0) { /* attribute query string */
+    if (strcasecmp(mapserv->request->ParamNames[i], "qstring") ==
+        0) { /* attribute query string */
       mapserv->QueryString = msStrdup(mapserv->request->ParamValues[i]);
       continue;
     }
 
-    if(strcasecmp(mapserv->request->ParamNames[i],"qformat") == 0) { /* format to apply to query results (shortcut instead of having to use "map.web=QUERYFORMAT+foo") */
-      if(mapserv->map->web.queryformat) free(mapserv->map->web.queryformat); /* avoid leak */
-      mapserv->map->web.queryformat = msStrdup(mapserv->request->ParamValues[i]);
+    if (strcasecmp(mapserv->request->ParamNames[i], "qformat") ==
+        0) { /* format to apply to query results (shortcut instead of having to
+                use "map.web=QUERYFORMAT+foo") */
+      if (mapserv->map->web.queryformat)
+        free(mapserv->map->web.queryformat); /* avoid leak */
+      mapserv->map->web.queryformat =
+          msStrdup(mapserv->request->ParamValues[i]);
       continue;
     }
 
-    if(strcasecmp(mapserv->request->ParamNames[i],"slayer") == 0) { /* layer to select (for feature based search) */
+    if (strcasecmp(mapserv->request->ParamNames[i], "slayer") ==
+        0) { /* layer to select (for feature based search) */
       mapserv->SelectLayer = msStrdup(mapserv->request->ParamValues[i]);
       continue;
     }
 
-    if(strcasecmp(mapserv->request->ParamNames[i],"shapeindex") == 0) { /* used for index queries */
-      GET_NUMERIC(mapserv->request->ParamValues[i],tmpval);
+    if (strcasecmp(mapserv->request->ParamNames[i], "shapeindex") ==
+        0) { /* used for index queries */
+      GET_NUMERIC(mapserv->request->ParamValues[i], tmpval);
       mapserv->ShapeIndex = (int)tmpval;
       continue;
     }
-    if(strcasecmp(mapserv->request->ParamNames[i],"tileindex") == 0) {
-      GET_NUMERIC(mapserv->request->ParamValues[i],tmpval);
+    if (strcasecmp(mapserv->request->ParamNames[i], "tileindex") == 0) {
+      GET_NUMERIC(mapserv->request->ParamValues[i], tmpval);
       mapserv->TileIndex = (int)tmpval;
       continue;
     }
@@ -1154,22 +1341,23 @@ int msCGILoadForm(mapservObj *mapserv)
      *   The following code is used to support mode=tile
      * -------------------------------------------------------------------- */
 
-    if(strcasecmp(mapserv->request->ParamNames[i], "tilemode") == 0) {
+    if (strcasecmp(mapserv->request->ParamNames[i], "tilemode") == 0) {
       /* currently, only valid tilemode is "spheremerc" */
-      if( strcasecmp(mapserv->request->ParamValues[i], "gmap") == 0) {
+      if (strcasecmp(mapserv->request->ParamValues[i], "gmap") == 0) {
         mapserv->TileMode = TILE_GMAP;
-      } else if ( strcasecmp(mapserv->request->ParamValues[i], "ve") == 0 ) {
+      } else if (strcasecmp(mapserv->request->ParamValues[i], "ve") == 0) {
         mapserv->TileMode = TILE_VE;
       } else {
-        msSetError(MS_WEBERR, "Invalid tilemode. Use one of: gmap, ve", "msCGILoadForm()");
+        msSetError(MS_WEBERR, "Invalid tilemode. Use one of: gmap, ve",
+                   "msCGILoadForm()");
         return MS_FAILURE;
       }
       continue;
     }
 
-    if(strcasecmp(mapserv->request->ParamNames[i],"tile") == 0) {
+    if (strcasecmp(mapserv->request->ParamNames[i], "tile") == 0) {
 
-      if( strlen(mapserv->request->ParamValues[i]) < 1 ) {
+      if (strlen(mapserv->request->ParamValues[i]) < 1) {
         msSetError(MS_WEBERR, "Empty tile parameter.", "msCGILoadForm()");
         return MS_FAILURE;
       }
@@ -1190,43 +1378,43 @@ int msCGILoadForm(mapservObj *mapserv)
     /*                                                                      */
     /* -------------------------------------------------------------------- */
 
-    if(strcasecmp(mapserv->request->ParamNames[i],"INPUT_TYPE") == 0) {
+    if (strcasecmp(mapserv->request->ParamNames[i], "INPUT_TYPE") == 0) {
       /* Rosa input type */
-      if(strcasecmp(mapserv->request->ParamValues[i],"auto_rect") == 0) {
-        rosa_type=1; /* rectangle */
+      if (strcasecmp(mapserv->request->ParamValues[i], "auto_rect") == 0) {
+        rosa_type = 1; /* rectangle */
         continue;
       }
 
-      if(strcasecmp(mapserv->request->ParamValues[i],"auto_point") == 0) {
-        rosa_type=2; /* point */
+      if (strcasecmp(mapserv->request->ParamValues[i], "auto_point") == 0) {
+        rosa_type = 2; /* point */
         continue;
       }
     }
-    if(strcasecmp(mapserv->request->ParamNames[i],"INPUT_COORD") == 0) {
+    if (strcasecmp(mapserv->request->ParamNames[i], "INPUT_COORD") == 0) {
       /* Rosa coordinates */
 
-      switch(rosa_type) {
-        case 1:
-          sscanf(mapserv->request->ParamValues[i],"%lf,%lf;%lf,%lf",
-                 &mapserv->ImgBox.minx,&mapserv->ImgBox.miny,&mapserv->ImgBox.maxx,
-                 &mapserv->ImgBox.maxy);
-          if((mapserv->ImgBox.minx != mapserv->ImgBox.maxx) &&
-              (mapserv->ImgBox.miny != mapserv->ImgBox.maxy)) {
-            mapserv->CoordSource = FROMIMGBOX;
-            mapserv->QueryCoordSource = FROMIMGBOX;
-          } else {
-            mapserv->CoordSource = FROMIMGPNT;
-            mapserv->QueryCoordSource = FROMIMGPNT;
-            mapserv->ImgPnt.x=mapserv->ImgBox.minx;
-            mapserv->ImgPnt.y=mapserv->ImgBox.miny;
-          }
-          break;
-        case 2:
-          sscanf(mapserv->request->ParamValues[i],"%lf,%lf",&mapserv->ImgPnt.x,
-                 &mapserv->ImgPnt.y);
+      switch (rosa_type) {
+      case 1:
+        sscanf(mapserv->request->ParamValues[i], "%lf,%lf;%lf,%lf",
+               &mapserv->ImgBox.minx, &mapserv->ImgBox.miny,
+               &mapserv->ImgBox.maxx, &mapserv->ImgBox.maxy);
+        if ((mapserv->ImgBox.minx != mapserv->ImgBox.maxx) &&
+            (mapserv->ImgBox.miny != mapserv->ImgBox.maxy)) {
+          mapserv->CoordSource = FROMIMGBOX;
+          mapserv->QueryCoordSource = FROMIMGBOX;
+        } else {
           mapserv->CoordSource = FROMIMGPNT;
           mapserv->QueryCoordSource = FROMIMGPNT;
-          break;
+          mapserv->ImgPnt.x = mapserv->ImgBox.minx;
+          mapserv->ImgPnt.y = mapserv->ImgBox.miny;
+        }
+        break;
+      case 2:
+        sscanf(mapserv->request->ParamValues[i], "%lf,%lf", &mapserv->ImgPnt.x,
+               &mapserv->ImgPnt.y);
+        mapserv->CoordSource = FROMIMGPNT;
+        mapserv->QueryCoordSource = FROMIMGPNT;
+        break;
       }
       continue;
     }
@@ -1236,83 +1424,97 @@ int msCGILoadForm(mapservObj *mapserv)
 
   } /* next parameter */
 
-  if(mapserv->Mode == ZOOMIN) {
+  if (mapserv->Mode == ZOOMIN) {
     mapserv->ZoomDirection = 1;
     mapserv->Mode = BROWSE;
   }
-  if(mapserv->Mode == ZOOMOUT) {
+  if (mapserv->Mode == ZOOMOUT) {
     mapserv->ZoomDirection = -1;
     mapserv->Mode = BROWSE;
   }
 
-  if(mapserv->ZoomSize != 0) { /* use direction and magnitude to calculate zoom */
-    if(mapserv->ZoomDirection == 0) {
+  if (mapserv->ZoomSize !=
+      0) { /* use direction and magnitude to calculate zoom */
+    if (mapserv->ZoomDirection == 0) {
       mapserv->fZoom = 1;
     } else {
-      mapserv->fZoom = mapserv->ZoomSize*mapserv->ZoomDirection;
-      if(mapserv->fZoom < 0)
-        mapserv->fZoom = 1.0/MS_ABS(mapserv->fZoom);
+      mapserv->fZoom = mapserv->ZoomSize * mapserv->ZoomDirection;
+      if (mapserv->fZoom < 0)
+        mapserv->fZoom = 1.0 / MS_ABS(mapserv->fZoom);
     }
   } else { /* use single value for zoom */
-    if((mapserv->Zoom >= -1) && (mapserv->Zoom <= 1)) {
+    if ((mapserv->Zoom >= -1) && (mapserv->Zoom <= 1)) {
       mapserv->fZoom = 1; /* pan */
     } else {
-      if(mapserv->Zoom < 0)
-        mapserv->fZoom = 1.0/MS_ABS(mapserv->Zoom);
+      if (mapserv->Zoom < 0)
+        mapserv->fZoom = 1.0 / MS_ABS(mapserv->Zoom);
       else
         mapserv->fZoom = mapserv->Zoom;
     }
   }
 
-  if(mapserv->ImgRows == -1) mapserv->ImgRows = mapserv->map->height;
-  if(mapserv->ImgCols == -1) mapserv->ImgCols = mapserv->map->width;
-  if(mapserv->map->height == -1) mapserv->map->height = mapserv->ImgRows;
-  if(mapserv->map->width == -1) mapserv->map->width = mapserv->ImgCols;
+  if (mapserv->ImgRows == -1)
+    mapserv->ImgRows = mapserv->map->height;
+  if (mapserv->ImgCols == -1)
+    mapserv->ImgCols = mapserv->map->width;
+  if (mapserv->map->height == -1)
+    mapserv->map->height = mapserv->ImgRows;
+  if (mapserv->map->width == -1)
+    mapserv->map->width = mapserv->ImgCols;
   return MS_SUCCESS;
 }
 
-int setExtentFromShapes(mapservObj *mapserv)
-{
+int setExtentFromShapes(mapservObj *mapserv) {
   double dx, dy, cellsize;
 
-  rectObj tmpext= {-1.0,-1.0,-1.0,-1.0};
-  pointObj tmppnt= {-1.0,-1.0,-1.0,-1.0};
+  rectObj tmpext = {-1.0, -1.0, -1.0, -1.0};
+  pointObj tmppnt = {-1.0, -1.0, -1.0, -1.0};
 
   msGetQueryResultBounds(mapserv->map, &(tmpext));
 
   dx = tmpext.maxx - tmpext.minx;
   dy = tmpext.maxy - tmpext.miny;
 
-  tmppnt.x = (tmpext.maxx + tmpext.minx)/2;
-  tmppnt.y = (tmpext.maxy + tmpext.miny)/2;
-  tmpext.minx -= dx*EXTENT_PADDING/2.0;
-  tmpext.maxx += dx*EXTENT_PADDING/2.0;
-  tmpext.miny -= dy*EXTENT_PADDING/2.0;
-  tmpext.maxy += dy*EXTENT_PADDING/2.0;
-
-  if(mapserv->ScaleDenom != 0) { /* apply the scale around the center point (tmppnt) */
-    cellsize = (mapserv->ScaleDenom/mapserv->map->resolution)/msInchesPerUnit(mapserv->map->units,0); /* user supplied a point and a scale */
-    tmpext.minx = tmppnt.x - cellsize*mapserv->map->width/2.0;
-    tmpext.miny = tmppnt.y - cellsize*mapserv->map->height/2.0;
-    tmpext.maxx = tmppnt.x + cellsize*mapserv->map->width/2.0;
-    tmpext.maxy = tmppnt.y + cellsize*mapserv->map->height/2.0;
-  } else if(mapserv->Buffer != 0) { /* apply the buffer around the center point (tmppnt) */
+  tmppnt.x = (tmpext.maxx + tmpext.minx) / 2;
+  tmppnt.y = (tmpext.maxy + tmpext.miny) / 2;
+  tmpext.minx -= dx * EXTENT_PADDING / 2.0;
+  tmpext.maxx += dx * EXTENT_PADDING / 2.0;
+  tmpext.miny -= dy * EXTENT_PADDING / 2.0;
+  tmpext.maxy += dy * EXTENT_PADDING / 2.0;
+
+  if (mapserv->ScaleDenom !=
+      0) { /* apply the scale around the center point (tmppnt) */
+    cellsize = (mapserv->ScaleDenom / mapserv->map->resolution) /
+               msInchesPerUnit(mapserv->map->units,
+                               0); /* user supplied a point and a scale */
+    tmpext.minx = tmppnt.x - cellsize * mapserv->map->width / 2.0;
+    tmpext.miny = tmppnt.y - cellsize * mapserv->map->height / 2.0;
+    tmpext.maxx = tmppnt.x + cellsize * mapserv->map->width / 2.0;
+    tmpext.maxy = tmppnt.y + cellsize * mapserv->map->height / 2.0;
+  } else if (mapserv->Buffer !=
+             0) { /* apply the buffer around the center point (tmppnt) */
     tmpext.minx = tmppnt.x - mapserv->Buffer;
     tmpext.miny = tmppnt.y - mapserv->Buffer;
     tmpext.maxx = tmppnt.x + mapserv->Buffer;
     tmpext.maxy = tmppnt.y + mapserv->Buffer;
   }
 
-  /* in case we don't get  usable extent at this point (i.e. single point result) */
-  if(!MS_VALID_EXTENT(tmpext)) {
-    if(mapserv->map->web.minscaledenom > 0) { /* try web object minscale first */
-      cellsize = (mapserv->map->web.minscaledenom/mapserv->map->resolution)/msInchesPerUnit(mapserv->map->units,0); /* user supplied a point and a scale */
-      tmpext.minx = tmppnt.x - cellsize*mapserv->map->width/2.0;
-      tmpext.miny = tmppnt.y - cellsize*mapserv->map->height/2.0;
-      tmpext.maxx = tmppnt.x + cellsize*mapserv->map->width/2.0;
-      tmpext.maxy = tmppnt.y + cellsize*mapserv->map->height/2.0;
+  /* in case we don't get  usable extent at this point (i.e. single point
+   * result) */
+  if (!MS_VALID_EXTENT(tmpext)) {
+    if (mapserv->map->web.minscaledenom >
+        0) { /* try web object minscale first */
+      cellsize = (mapserv->map->web.minscaledenom / mapserv->map->resolution) /
+                 msInchesPerUnit(mapserv->map->units,
+                                 0); /* user supplied a point and a scale */
+      tmpext.minx = tmppnt.x - cellsize * mapserv->map->width / 2.0;
+      tmpext.miny = tmppnt.y - cellsize * mapserv->map->height / 2.0;
+      tmpext.maxx = tmppnt.x + cellsize * mapserv->map->width / 2.0;
+      tmpext.maxy = tmppnt.y + cellsize * mapserv->map->height / 2.0;
     } else {
-      msSetError(MS_WEBERR, "No way to generate a valid map extent from selected shapes.", "mapserv()");
+      msSetError(MS_WEBERR,
+                 "No way to generate a valid map extent from selected shapes.",
+                 "mapserv()");
       return MS_FAILURE;
     }
   }
@@ -1323,473 +1525,614 @@ int setExtentFromShapes(mapservObj *maps
   return MS_SUCCESS;
 }
 
-
 /* FIX: NEED ERROR CHECKING HERE FOR IMGPNT or MAPPNT */
-void setCoordinate(mapservObj *mapserv)
-{
-  double cellx,celly;
+void setCoordinate(mapservObj *mapserv) {
+  double cellx, celly;
 
-  cellx = MS_CELLSIZE(mapserv->ImgExt.minx, mapserv->ImgExt.maxx, mapserv->ImgCols);
-  celly = MS_CELLSIZE(mapserv->ImgExt.miny, mapserv->ImgExt.maxy, mapserv->ImgRows);
-
-  mapserv->mappnt.x = MS_IMAGE2MAP_X(mapserv->ImgPnt.x, mapserv->ImgExt.minx, cellx);
-  mapserv->mappnt.y = MS_IMAGE2MAP_Y(mapserv->ImgPnt.y, mapserv->ImgExt.maxy, celly);
+  cellx =
+      MS_CELLSIZE(mapserv->ImgExt.minx, mapserv->ImgExt.maxx, mapserv->ImgCols);
+  celly =
+      MS_CELLSIZE(mapserv->ImgExt.miny, mapserv->ImgExt.maxy, mapserv->ImgRows);
+
+  mapserv->mappnt.x =
+      MS_IMAGE2MAP_X(mapserv->ImgPnt.x, mapserv->ImgExt.minx, cellx);
+  mapserv->mappnt.y =
+      MS_IMAGE2MAP_Y(mapserv->ImgPnt.y, mapserv->ImgExt.maxy, celly);
 
   return;
 }
 
-
-int msCGIDispatchBrowseRequest(mapservObj *mapserv)
-{
-  char *template =  NULL;
-  int i,status;
-  for(i=0; i<mapserv->request->NumParams; i++) /* find the template param value */
+int msCGIDispatchBrowseRequest(mapservObj *mapserv) {
+  char *template = NULL;
+  int i, status;
+  for (i = 0; i < mapserv->request->NumParams;
+       i++) /* find the template param value */
     if (strcasecmp(mapserv->request->ParamNames[i], "template") == 0)
       template = mapserv->request->ParamValues[i];
 
-  if ( (!mapserv->map->web.template) && (template==NULL || (strcasecmp(template, "openlayers")!=0)) ) {
-    msSetError(MS_WEBERR, "Traditional BROWSE mode requires a TEMPLATE in the WEB section, but none was provided.", "mapserv()");
+  if ((!mapserv->map->web.template) &&
+      (template == NULL || (strcasecmp(template, "openlayers") != 0))) {
+    msSetError(MS_WEBERR,
+               "Traditional BROWSE mode requires a TEMPLATE in the WEB "
+               "section, but none was provided.",
+               "mapserv()");
     return MS_FAILURE;
   }
 
-  if(mapserv->QueryFile) {
+  if (mapserv->QueryFile) {
     status = msLoadQuery(mapserv->map, mapserv->QueryFile);
-    if(status != MS_SUCCESS) return MS_FAILURE;
+    if (status != MS_SUCCESS)
+      return MS_FAILURE;
   }
 
   status = setExtent(mapserv);
-  if(status != MS_SUCCESS) return MS_FAILURE;
+  if (status != MS_SUCCESS)
+    return MS_FAILURE;
   status = checkWebScale(mapserv);
-  if(status != MS_SUCCESS) return MS_FAILURE;
+  if (status != MS_SUCCESS)
+    return MS_FAILURE;
 
   /* -------------------------------------------------------------------- */
   /*      generate map, legend, scalebar and refernce images.             */
   /* -------------------------------------------------------------------- */
-  if(msGenerateImages(mapserv, MS_FALSE, MS_TRUE) != MS_SUCCESS)
+  if (msGenerateImages(mapserv, MS_FALSE, MS_TRUE) != MS_SUCCESS)
     return MS_FAILURE;
 
-  if ( (template != NULL) && (strcasecmp(template, "openlayers")==0) ) {
-    msIO_setHeader("Content-Type","text/html");
+  if ((template != NULL) && (strcasecmp(template, "openlayers") == 0)) {
+    msIO_setHeader("Content-Type", "text/html");
     msIO_sendHeaders();
     if (msReturnOpenLayersPage(mapserv) != MS_SUCCESS)
       return MS_FAILURE;
-  } else if(mapserv->QueryFile) {
-    if(msReturnTemplateQuery(mapserv, mapserv->map->web.queryformat, NULL) != MS_SUCCESS)
+  } else if (mapserv->QueryFile) {
+    if (msReturnTemplateQuery(mapserv, mapserv->map->web.queryformat, NULL) !=
+        MS_SUCCESS)
       return MS_FAILURE;
   } else {
-    if(TEMPLATE_TYPE(mapserv->map->web.template) == MS_FILE) { /* if thers's an html template, then use it */
-      if(mapserv->sendheaders) {
-        msIO_setHeader("Content-Type","%s", mapserv->map->web.browseformat); /* write MIME header */
+    if (TEMPLATE_TYPE(mapserv->map->web.template) ==
+        MS_FILE) { /* if thers's an html template, then use it */
+      if (mapserv->sendheaders) {
+        msIO_setHeader("Content-Type", "%s",
+                       mapserv->map->web.browseformat); /* write MIME header */
         msIO_sendHeaders();
       }
-      if(msReturnPage(mapserv, mapserv->map->web.template, BROWSE, NULL) != MS_SUCCESS)
+      if (msReturnPage(mapserv, mapserv->map->web.template, BROWSE, NULL) !=
+          MS_SUCCESS)
         return MS_FAILURE;
     } else {
-      if(msReturnURL(mapserv, mapserv->map->web.template, BROWSE) != MS_SUCCESS)
+      if (msReturnURL(mapserv, mapserv->map->web.template, BROWSE) !=
+          MS_SUCCESS)
         return MS_FAILURE;
     }
   }
   return MS_SUCCESS;
 }
 
-
-int msCGIDispatchCoordinateRequest(mapservObj *mapserv)
-{
+int msCGIDispatchCoordinateRequest(mapservObj *mapserv) {
   setCoordinate(mapserv); /* mouse click => map coord */
   msIO_printf("Your \"<i>click</i>\" corresponds to (approximately): (%g, %g).",
               mapserv->mappnt.x, mapserv->mappnt.y);
 
-  if(mapserv->map->projection.proj != NULL && !msProjIsGeographicCRS(&(mapserv->map->projection)) ) {
-    pointObj p=mapserv->mappnt;
+  if (mapserv->map->projection.proj != NULL &&
+      !msProjIsGeographicCRS(&(mapserv->map->projection))) {
+    pointObj p = mapserv->mappnt;
     msProjectPoint(&(mapserv->map->projection), &(mapserv->map->latlon), &p);
-    msIO_printf("Computed lat/lon value is (%g, %g).\n",p.x, p.y);
+    msIO_printf("Computed lat/lon value is (%g, %g).\n", p.x, p.y);
   }
   return MS_SUCCESS;
 }
 
-int msCGIDispatchQueryRequest(mapservObj *mapserv)
-{
-  int status,i,j;
+int msCGIDispatchQueryRequest(mapservObj *mapserv) {
+  int status, i, j;
   char buffer[1024];
-  if(mapserv->QueryFile) { /* already got a completed query */
+  if (mapserv->QueryFile) { /* already got a completed query */
     status = msLoadQuery(mapserv->map, mapserv->QueryFile);
-    if(status != MS_SUCCESS) return MS_FAILURE;
+    if (status != MS_SUCCESS)
+      return MS_FAILURE;
   } else {
 
-    if((mapserv->QueryLayerIndex = msGetLayerIndex(mapserv->map, mapserv->QueryLayer)) != -1) /* force the query layer on */
+    if ((mapserv->QueryLayerIndex =
+             msGetLayerIndex(mapserv->map, mapserv->QueryLayer)) !=
+        -1) /* force the query layer on */
       GET_LAYER(mapserv->map, mapserv->QueryLayerIndex)->status = MS_ON;
 
-    switch(mapserv->Mode) {
-      case ITEMFEATUREQUERY:
-      case ITEMFEATURENQUERY:
-        if((mapserv->SelectLayerIndex = msGetLayerIndex(mapserv->map, mapserv->SelectLayer)) == -1) { /* force the selection layer on */
-          msSetError(MS_WEBERR, "Selection layer not set or references an invalid layer.", "mapserv()");
-          return MS_FAILURE;
-        }
-        GET_LAYER(mapserv->map, mapserv->SelectLayerIndex)->status = MS_ON;
+    switch (mapserv->Mode) {
+    case ITEMFEATUREQUERY:
+    case ITEMFEATURENQUERY:
+      if ((mapserv->SelectLayerIndex =
+               msGetLayerIndex(mapserv->map, mapserv->SelectLayer)) ==
+          -1) { /* force the selection layer on */
+        msSetError(MS_WEBERR,
+                   "Selection layer not set or references an invalid layer.",
+                   "mapserv()");
+        return MS_FAILURE;
+      }
+      GET_LAYER(mapserv->map, mapserv->SelectLayerIndex)->status = MS_ON;
+
+      /* validate the qstring parameter */
+      if (msValidateParameter(
+              mapserv->QueryString,
+              msLookupHashTable(
+                  &(GET_LAYER(mapserv->map, mapserv->SelectLayerIndex)
+                        ->validation),
+                  "qstring"),
+              msLookupHashTable(&(mapserv->map->web.validation), "qstring"),
+              NULL, NULL) != MS_SUCCESS) {
+        msSetError(MS_WEBERR, "Parameter 'qstring' value fails to validate.",
+                   "mapserv()");
+        return MS_FAILURE;
+      }
 
-        /* validate the qstring parameter */
-        if(msValidateParameter(mapserv->QueryString, msLookupHashTable(&(GET_LAYER(mapserv->map, mapserv->SelectLayerIndex)->validation), "qstring"),
-                               msLookupHashTable(&(mapserv->map->web.validation), "qstring"),
-                               NULL, NULL) != MS_SUCCESS) {
-          msSetError(MS_WEBERR, "Parameter 'qstring' value fails to validate.", "mapserv()");
+      if (mapserv->QueryCoordSource != NONE && !mapserv->UseShapes)
+        if (MS_SUCCESS != setExtent(mapserv)) /* set user area of interest */
           return MS_FAILURE;
-        }
-
-        if(mapserv->QueryCoordSource != NONE && !mapserv->UseShapes)
-          if(MS_SUCCESS != setExtent(mapserv)) /* set user area of interest */
-            return MS_FAILURE;
 
-        mapserv->map->query.type = MS_QUERY_BY_FILTER;
-        if(mapserv->QueryItem) mapserv->map->query.filteritem = msStrdup(mapserv->QueryItem);
-        if(mapserv->QueryString) {
-          msInitExpression(&mapserv->map->query.filter);
-          msLoadExpressionString(&mapserv->map->query.filter, mapserv->QueryString);
-        }
+      mapserv->map->query.type = MS_QUERY_BY_FILTER;
+      if (mapserv->QueryItem)
+        mapserv->map->query.filteritem = msStrdup(mapserv->QueryItem);
+      if (mapserv->QueryString) {
+        msInitExpression(&mapserv->map->query.filter);
+        msLoadExpressionString(&mapserv->map->query.filter,
+                               mapserv->QueryString);
+      }
 
-        mapserv->map->query.rect = mapserv->map->extent;
+      mapserv->map->query.rect = mapserv->map->extent;
 
-        mapserv->map->query.mode = MS_QUERY_MULTIPLE;
-        if(mapserv->Mode == ITEMFEATUREQUERY)
-          mapserv->map->query.mode = MS_QUERY_SINGLE;
+      mapserv->map->query.mode = MS_QUERY_MULTIPLE;
+      if (mapserv->Mode == ITEMFEATUREQUERY)
+        mapserv->map->query.mode = MS_QUERY_SINGLE;
 
-        mapserv->map->query.layer = mapserv->QueryLayerIndex;
-        mapserv->map->query.slayer = mapserv->SelectLayerIndex; /* this will trigger the feature query eventually */
-        break;
-      case FEATUREQUERY:
-      case FEATURENQUERY:
-        if((mapserv->SelectLayerIndex = msGetLayerIndex(mapserv->map, mapserv->SelectLayer)) == -1) { /* force the selection layer on */
-          msSetError(MS_WEBERR, "Selection layer not set or references an invalid layer.", "mapserv()");
+      mapserv->map->query.layer = mapserv->QueryLayerIndex;
+      mapserv->map->query.slayer =
+          mapserv->SelectLayerIndex; /* this will trigger the feature query
+                                        eventually */
+      break;
+    case FEATUREQUERY:
+    case FEATURENQUERY:
+      if ((mapserv->SelectLayerIndex =
+               msGetLayerIndex(mapserv->map, mapserv->SelectLayer)) ==
+          -1) { /* force the selection layer on */
+        msSetError(MS_WEBERR,
+                   "Selection layer not set or references an invalid layer.",
+                   "mapserv()");
+        return MS_FAILURE;
+      }
+      GET_LAYER(mapserv->map, mapserv->SelectLayerIndex)->status = MS_ON;
+
+      if (mapserv->Mode == FEATUREQUERY) {
+        switch (mapserv->QueryCoordSource) {
+        case FROMIMGPNT:
+          mapserv->map->extent =
+              mapserv->ImgExt; /* use the existing map extent */
+          setCoordinate(mapserv);
+          break;
+        case FROMUSERPNT:
+          break;
+        default:
+          msSetError(
+              MS_WEBERR,
+              "No way to perform the initial search, not enough information.",
+              "mapserv()");
           return MS_FAILURE;
+          break;
         }
-        GET_LAYER(mapserv->map, mapserv->SelectLayerIndex)->status = MS_ON;
-
-        if(mapserv->Mode == FEATUREQUERY) {
-          switch(mapserv->QueryCoordSource) {
-            case FROMIMGPNT:
-              mapserv->map->extent = mapserv->ImgExt; /* use the existing map extent */
-              setCoordinate(mapserv);
-              break;
-            case FROMUSERPNT:
-              break;
-            default:
-              msSetError(MS_WEBERR, "No way to perform the initial search, not enough information.", "mapserv()");
-              return MS_FAILURE;
-              break;
-          }
 
+        mapserv->map->query.type = MS_QUERY_BY_POINT;
+      } else { /* FEATURENQUERY */
+        switch (mapserv->QueryCoordSource) {
+        case FROMIMGPNT:
+          mapserv->map->extent =
+              mapserv->ImgExt; /* use the existing map extent */
+          setCoordinate(mapserv);
+          mapserv->map->query.type = MS_QUERY_BY_POINT;
+          break;
+        case FROMIMGBOX:
+          /* TODO: this option was present but with no code to leverage the
+           * image box... */
+          break;
+        case FROMUSERPNT:
           mapserv->map->query.type = MS_QUERY_BY_POINT;
-        } else { /* FEATURENQUERY */
-          switch(mapserv->QueryCoordSource) {
-            case FROMIMGPNT:
-              mapserv->map->extent = mapserv->ImgExt; /* use the existing map extent */
-              setCoordinate(mapserv);
-              mapserv->map->query.type = MS_QUERY_BY_POINT;
-              break;
-            case FROMIMGBOX:
-              /* TODO: this option was present but with no code to leverage the image box... */
-              break;
-            case FROMUSERPNT:
-              mapserv->map->query.type = MS_QUERY_BY_POINT;
-              break;
-            default:
-              if(MS_SUCCESS != setExtent(mapserv)) {
-                return MS_FAILURE;
-              }
-              mapserv->map->query.type = MS_QUERY_BY_RECT;
-              break;
+          break;
+        default:
+          if (MS_SUCCESS != setExtent(mapserv)) {
+            return MS_FAILURE;
           }
+          mapserv->map->query.type = MS_QUERY_BY_RECT;
+          break;
         }
+      }
 
-        mapserv->map->query.mode = MS_QUERY_MULTIPLE;
+      mapserv->map->query.mode = MS_QUERY_MULTIPLE;
 
-        mapserv->map->query.rect = mapserv->map->extent;
-        mapserv->map->query.point = mapserv->mappnt;
-        mapserv->map->query.buffer = mapserv->Buffer;
+      mapserv->map->query.rect = mapserv->map->extent;
+      mapserv->map->query.point = mapserv->mappnt;
+      mapserv->map->query.buffer = mapserv->Buffer;
 
-        mapserv->map->query.layer = mapserv->QueryLayerIndex;
-        mapserv->map->query.slayer = mapserv->SelectLayerIndex;
-        break;
-      case ITEMQUERY:
-      case ITEMNQUERY:
-        if(mapserv->QueryLayerIndex < 0 || mapserv->QueryLayerIndex >= mapserv->map->numlayers) {
-          msSetError(MS_WEBERR, "Query layer not set or references an invalid layer.", "mapserv()");
-          return MS_FAILURE;
-        }
+      mapserv->map->query.layer = mapserv->QueryLayerIndex;
+      mapserv->map->query.slayer = mapserv->SelectLayerIndex;
+      break;
+    case ITEMQUERY:
+    case ITEMNQUERY:
+      if (mapserv->QueryLayerIndex < 0 ||
+          mapserv->QueryLayerIndex >= mapserv->map->numlayers) {
+        msSetError(MS_WEBERR,
+                   "Query layer not set or references an invalid layer.",
+                   "mapserv()");
+        return MS_FAILURE;
+      }
+
+      /* validate the qstring parameter */
+      if (msValidateParameter(
+              mapserv->QueryString,
+              msLookupHashTable(
+                  &(GET_LAYER(mapserv->map, mapserv->QueryLayerIndex)
+                        ->validation),
+                  "qstring"),
+              msLookupHashTable(&(mapserv->map->web.validation), "qstring"),
+              NULL, NULL) != MS_SUCCESS) {
+        msSetError(MS_WEBERR, "Parameter 'qstring' value fails to validate.",
+                   "mapserv()");
+        return MS_FAILURE;
+      }
 
-        /* validate the qstring parameter */
-        if(msValidateParameter(mapserv->QueryString, msLookupHashTable(&(GET_LAYER(mapserv->map, mapserv->QueryLayerIndex)->validation), "qstring"),
-                               msLookupHashTable(&(mapserv->map->web.validation), "qstring"),
-                               NULL, NULL) != MS_SUCCESS) {
-          msSetError(MS_WEBERR, "Parameter 'qstring' value fails to validate.", "mapserv()");
+      if (mapserv->QueryCoordSource != NONE && !mapserv->UseShapes)
+        if (MS_SUCCESS != setExtent(mapserv)) /* set user area of interest */
           return MS_FAILURE;
-        }
 
-        if(mapserv->QueryCoordSource != NONE && !mapserv->UseShapes)
-          if(MS_SUCCESS != setExtent(mapserv)) /* set user area of interest */
-            return MS_FAILURE;
+      mapserv->map->query.type = MS_QUERY_BY_FILTER;
+      mapserv->map->query.layer = mapserv->QueryLayerIndex;
+      if (mapserv->QueryItem)
+        mapserv->map->query.filteritem = msStrdup(mapserv->QueryItem);
+      if (mapserv->QueryString) {
+        msInitExpression(&mapserv->map->query.filter);
+        msLoadExpressionString(&mapserv->map->query.filter,
+                               mapserv->QueryString);
+      }
 
-        mapserv->map->query.type = MS_QUERY_BY_FILTER;
-        mapserv->map->query.layer = mapserv->QueryLayerIndex;
-        if(mapserv->QueryItem) mapserv->map->query.filteritem = msStrdup(mapserv->QueryItem);
-        if(mapserv->QueryString) {
-          msInitExpression(&mapserv->map->query.filter);
-          msLoadExpressionString(&mapserv->map->query.filter, mapserv->QueryString);
-	}
+      mapserv->map->query.rect = mapserv->map->extent;
 
-        mapserv->map->query.rect = mapserv->map->extent;
+      mapserv->map->query.mode = MS_QUERY_MULTIPLE;
+      if (mapserv->Mode == ITEMQUERY)
+        mapserv->map->query.mode = MS_QUERY_SINGLE;
+      break;
+    case NQUERY:
+      mapserv->map->query.mode =
+          MS_QUERY_MULTIPLE; /* all of these cases return multiple results */
+      mapserv->map->query.layer = mapserv->QueryLayerIndex;
+
+      switch (mapserv->QueryCoordSource) {
+      case FROMIMGPNT:
+        setCoordinate(mapserv);
+
+        if (mapserv->SearchMap) { /* compute new extent, pan etc then search
+                                     that extent */
+          if (MS_SUCCESS != setExtent(mapserv)) /* set user area of interest */
+            return MS_FAILURE;
+          mapserv->map->cellsize =
+              msAdjustExtent(&(mapserv->map->extent), mapserv->map->width,
+                             mapserv->map->height);
+          if (msCalculateScale(mapserv->map->extent, mapserv->map->units,
+                               mapserv->map->width, mapserv->map->height,
+                               mapserv->map->resolution,
+                               &mapserv->map->scaledenom) != MS_SUCCESS)
+            return MS_FAILURE;
+          mapserv->map->query.rect = mapserv->map->extent;
+          mapserv->map->query.type = MS_QUERY_BY_RECT;
+        } else {
+          mapserv->map->extent =
+              mapserv->ImgExt; /* use the existing image parameters */
+          mapserv->map->width = mapserv->ImgCols;
+          mapserv->map->height = mapserv->ImgRows;
+          if (msCalculateScale(mapserv->map->extent, mapserv->map->units,
+                               mapserv->map->width, mapserv->map->height,
+                               mapserv->map->resolution,
+                               &mapserv->map->scaledenom) != MS_SUCCESS)
+            return MS_FAILURE;
+          mapserv->map->query.point = mapserv->mappnt;
+          mapserv->map->query.type = MS_QUERY_BY_POINT;
+        }
 
-        mapserv->map->query.mode = MS_QUERY_MULTIPLE;
-        if(mapserv->Mode == ITEMQUERY) mapserv->map->query.mode = MS_QUERY_SINGLE;
         break;
-      case NQUERY:
-        mapserv->map->query.mode = MS_QUERY_MULTIPLE; /* all of these cases return multiple results */
-        mapserv->map->query.layer = mapserv->QueryLayerIndex;
-
-        switch(mapserv->QueryCoordSource) {
-          case FROMIMGPNT:
-            setCoordinate(mapserv);
-
-            if(mapserv->SearchMap) { /* compute new extent, pan etc then search that extent */
-              if(MS_SUCCESS != setExtent(mapserv)) /* set user area of interest */
-                return MS_FAILURE;
-              mapserv->map->cellsize = msAdjustExtent(&(mapserv->map->extent), mapserv->map->width, mapserv->map->height);
-              if(msCalculateScale(mapserv->map->extent, mapserv->map->units, mapserv->map->width, mapserv->map->height, mapserv->map->resolution, &mapserv->map->scaledenom) != MS_SUCCESS) return MS_FAILURE;
-              mapserv->map->query.rect = mapserv->map->extent;
-              mapserv->map->query.type = MS_QUERY_BY_RECT;
-            } else {
-              mapserv->map->extent = mapserv->ImgExt; /* use the existing image parameters */
-              mapserv->map->width = mapserv->ImgCols;
-              mapserv->map->height = mapserv->ImgRows;
-              if(msCalculateScale(mapserv->map->extent, mapserv->map->units, mapserv->map->width, mapserv->map->height, mapserv->map->resolution, &mapserv->map->scaledenom) != MS_SUCCESS) return MS_FAILURE;
-              mapserv->map->query.point = mapserv->mappnt;
-              mapserv->map->query.type = MS_QUERY_BY_POINT;
-            }
-
-            break;
-          case FROMIMGBOX:
-            if(mapserv->SearchMap) { /* compute new extent, pan etc then search that extent */
-              setExtent(mapserv);
-              if(msCalculateScale(mapserv->map->extent, mapserv->map->units, mapserv->map->width, mapserv->map->height, mapserv->map->resolution, &mapserv->map->scaledenom) != MS_SUCCESS) return MS_FAILURE;
-              mapserv->map->cellsize = msAdjustExtent(&(mapserv->map->extent), mapserv->map->width, mapserv->map->height);
-              mapserv->map->query.rect = mapserv->map->extent;
-              mapserv->map->query.type = MS_QUERY_BY_RECT;
-            } else {
-              double cellx, celly;
-
-              mapserv->map->extent = mapserv->ImgExt; /* use the existing image parameters */
-              mapserv->map->width = mapserv->ImgCols;
-              mapserv->map->height = mapserv->ImgRows;
-              if(msCalculateScale(mapserv->map->extent, mapserv->map->units, mapserv->map->width, mapserv->map->height, mapserv->map->resolution, &mapserv->map->scaledenom) != MS_SUCCESS) return MS_FAILURE;
-              cellx = MS_CELLSIZE(mapserv->ImgExt.minx, mapserv->ImgExt.maxx, mapserv->ImgCols); /* calculate the new search extent */
-              celly = MS_CELLSIZE(mapserv->ImgExt.miny, mapserv->ImgExt.maxy, mapserv->ImgRows);
-              mapserv->RawExt.minx = MS_IMAGE2MAP_X(mapserv->ImgBox.minx, mapserv->ImgExt.minx, cellx);
-              mapserv->RawExt.maxx = MS_IMAGE2MAP_X(mapserv->ImgBox.maxx, mapserv->ImgExt.minx, cellx);
-              mapserv->RawExt.maxy = MS_IMAGE2MAP_Y(mapserv->ImgBox.miny, mapserv->ImgExt.maxy, celly); /* y's are flip flopped because img/map coordinate systems are */
-              mapserv->RawExt.miny = MS_IMAGE2MAP_Y(mapserv->ImgBox.maxy, mapserv->ImgExt.maxy, celly);
+      case FROMIMGBOX:
+        if (mapserv->SearchMap) { /* compute new extent, pan etc then search
+                                     that extent */
+          setExtent(mapserv);
+          if (msCalculateScale(mapserv->map->extent, mapserv->map->units,
+                               mapserv->map->width, mapserv->map->height,
+                               mapserv->map->resolution,
+                               &mapserv->map->scaledenom) != MS_SUCCESS)
+            return MS_FAILURE;
+          mapserv->map->cellsize =
+              msAdjustExtent(&(mapserv->map->extent), mapserv->map->width,
+                             mapserv->map->height);
+          mapserv->map->query.rect = mapserv->map->extent;
+          mapserv->map->query.type = MS_QUERY_BY_RECT;
+        } else {
+          double cellx, celly;
+
+          mapserv->map->extent =
+              mapserv->ImgExt; /* use the existing image parameters */
+          mapserv->map->width = mapserv->ImgCols;
+          mapserv->map->height = mapserv->ImgRows;
+          if (msCalculateScale(mapserv->map->extent, mapserv->map->units,
+                               mapserv->map->width, mapserv->map->height,
+                               mapserv->map->resolution,
+                               &mapserv->map->scaledenom) != MS_SUCCESS)
+            return MS_FAILURE;
+          cellx = MS_CELLSIZE(
+              mapserv->ImgExt.minx, mapserv->ImgExt.maxx,
+              mapserv->ImgCols); /* calculate the new search extent */
+          celly = MS_CELLSIZE(mapserv->ImgExt.miny, mapserv->ImgExt.maxy,
+                              mapserv->ImgRows);
+          mapserv->RawExt.minx =
+              MS_IMAGE2MAP_X(mapserv->ImgBox.minx, mapserv->ImgExt.minx, cellx);
+          mapserv->RawExt.maxx =
+              MS_IMAGE2MAP_X(mapserv->ImgBox.maxx, mapserv->ImgExt.minx, cellx);
+          mapserv->RawExt.maxy =
+              MS_IMAGE2MAP_Y(mapserv->ImgBox.miny, mapserv->ImgExt.maxy,
+                             celly); /* y's are flip flopped because img/map
+                                        coordinate systems are */
+          mapserv->RawExt.miny =
+              MS_IMAGE2MAP_Y(mapserv->ImgBox.maxy, mapserv->ImgExt.maxy, celly);
 
-              mapserv->map->query.rect = mapserv->RawExt;
-              mapserv->map->query.type = MS_QUERY_BY_RECT;
-            }
-            break;
-          case FROMIMGSHAPE:
-            mapserv->map->extent = mapserv->ImgExt; /* use the existing image parameters */
-            mapserv->map->width = mapserv->ImgCols;
-            mapserv->map->height = mapserv->ImgRows;
-            mapserv->map->cellsize = msAdjustExtent(&(mapserv->map->extent), mapserv->map->width, mapserv->map->height);
-            if(msCalculateScale(mapserv->map->extent, mapserv->map->units, mapserv->map->width, mapserv->map->height, mapserv->map->resolution, &mapserv->map->scaledenom) != MS_SUCCESS) return MS_FAILURE;
-
-            /* convert from image to map coordinates here (see setCoordinate) */
-            for(i=0; i<mapserv->map->query.shape->numlines; i++) {
-              for(j=0; j<mapserv->map->query.shape->line[i].numpoints; j++) {
-                mapserv->map->query.shape->line[i].point[j].x = MS_IMAGE2MAP_X(mapserv->map->query.shape->line[i].point[j].x, mapserv->map->extent.minx, mapserv->map->cellsize);
-                mapserv->map->query.shape->line[i].point[j].y = MS_IMAGE2MAP_Y(mapserv->map->query.shape->line[i].point[j].y, mapserv->map->extent.maxy, mapserv->map->cellsize);
-              }
-            }
+          mapserv->map->query.rect = mapserv->RawExt;
+          mapserv->map->query.type = MS_QUERY_BY_RECT;
+        }
+        break;
+      case FROMIMGSHAPE:
+        mapserv->map->extent =
+            mapserv->ImgExt; /* use the existing image parameters */
+        mapserv->map->width = mapserv->ImgCols;
+        mapserv->map->height = mapserv->ImgRows;
+        mapserv->map->cellsize = msAdjustExtent(
+            &(mapserv->map->extent), mapserv->map->width, mapserv->map->height);
+        if (msCalculateScale(mapserv->map->extent, mapserv->map->units,
+                             mapserv->map->width, mapserv->map->height,
+                             mapserv->map->resolution,
+                             &mapserv->map->scaledenom) != MS_SUCCESS)
+          return MS_FAILURE;
 
-            mapserv->map->query.type = MS_QUERY_BY_SHAPE;
-            break;
-          case FROMUSERPNT:
-            if(mapserv->Buffer == 0) { /* do a *pure* point query */
-              mapserv->map->query.point = mapserv->mappnt;
-              mapserv->map->query.type = MS_QUERY_BY_POINT;
-              setExtent(mapserv);
-            } else {
-              setExtent(mapserv);
-              if(mapserv->SearchMap) { /* the extent should be tied to a map, so we need to "adjust" it */
-                if(msCalculateScale(mapserv->map->extent, mapserv->map->units, mapserv->map->width, mapserv->map->height, mapserv->map->resolution, &mapserv->map->scaledenom) != MS_SUCCESS) return MS_FAILURE;
-                mapserv->map->cellsize = msAdjustExtent(&(mapserv->map->extent), mapserv->map->width, mapserv->map->height);
-              }
-              mapserv->map->query.rect = mapserv->map->extent;
-              mapserv->map->query.type = MS_QUERY_BY_RECT;
-            }
-            break;
-          case FROMUSERSHAPE:
-            setExtent(mapserv);
-            mapserv->map->query.type = MS_QUERY_BY_SHAPE;
-            break;
-          default: /* from an extent of some sort */
-            setExtent(mapserv);
-            if(mapserv->SearchMap) { /* the extent should be tied to a map, so we need to "adjust" it */
-              if(msCalculateScale(mapserv->map->extent, mapserv->map->units, mapserv->map->width, mapserv->map->height, mapserv->map->resolution, &mapserv->map->scaledenom) != MS_SUCCESS) return MS_FAILURE;
-              mapserv->map->cellsize = msAdjustExtent(&(mapserv->map->extent), mapserv->map->width, mapserv->map->height);
-            }
+        /* convert from image to map coordinates here (see setCoordinate) */
+        for (i = 0; i < mapserv->map->query.shape->numlines; i++) {
+          for (j = 0; j < mapserv->map->query.shape->line[i].numpoints; j++) {
+            mapserv->map->query.shape->line[i].point[j].x = MS_IMAGE2MAP_X(
+                mapserv->map->query.shape->line[i].point[j].x,
+                mapserv->map->extent.minx, mapserv->map->cellsize);
+            mapserv->map->query.shape->line[i].point[j].y = MS_IMAGE2MAP_Y(
+                mapserv->map->query.shape->line[i].point[j].y,
+                mapserv->map->extent.maxy, mapserv->map->cellsize);
+          }
+        }
 
-            mapserv->map->query.rect = mapserv->map->extent;
-            mapserv->map->query.type = MS_QUERY_BY_RECT;
-            break;
+        mapserv->map->query.type = MS_QUERY_BY_SHAPE;
+        break;
+      case FROMUSERPNT:
+        if (mapserv->Buffer == 0) { /* do a *pure* point query */
+          mapserv->map->query.point = mapserv->mappnt;
+          mapserv->map->query.type = MS_QUERY_BY_POINT;
+          setExtent(mapserv);
+        } else {
+          setExtent(mapserv);
+          if (mapserv->SearchMap) { /* the extent should be tied to a map, so we
+                                       need to "adjust" it */
+            if (msCalculateScale(mapserv->map->extent, mapserv->map->units,
+                                 mapserv->map->width, mapserv->map->height,
+                                 mapserv->map->resolution,
+                                 &mapserv->map->scaledenom) != MS_SUCCESS)
+              return MS_FAILURE;
+            mapserv->map->cellsize =
+                msAdjustExtent(&(mapserv->map->extent), mapserv->map->width,
+                               mapserv->map->height);
+          }
+          mapserv->map->query.rect = mapserv->map->extent;
+          mapserv->map->query.type = MS_QUERY_BY_RECT;
         }
         break;
-      case QUERY:
-        switch(mapserv->QueryCoordSource) {
-          case FROMIMGPNT:
-            setCoordinate(mapserv);
-            mapserv->map->extent = mapserv->ImgExt; /* use the existing image parameters */
-            mapserv->map->width = mapserv->ImgCols;
-            mapserv->map->height = mapserv->ImgRows;
-            if(msCalculateScale(mapserv->map->extent, mapserv->map->units, mapserv->map->width, mapserv->map->height, mapserv->map->resolution, &mapserv->map->scaledenom) != MS_SUCCESS) return MS_FAILURE;
-            break;
-          case FROMUSERPNT: /* only a buffer makes sense, DOES IT? */
-            if(setExtent(mapserv) != MS_SUCCESS) return MS_FAILURE;
-            break;
-          default:
-            msSetError(MS_WEBERR, "Query mode needs a point, imgxy and mapxy are not set.", "mapserv()");
+      case FROMUSERSHAPE:
+        setExtent(mapserv);
+        mapserv->map->query.type = MS_QUERY_BY_SHAPE;
+        break;
+      default: /* from an extent of some sort */
+        setExtent(mapserv);
+        if (mapserv->SearchMap) { /* the extent should be tied to a map, so we
+                                     need to "adjust" it */
+          if (msCalculateScale(mapserv->map->extent, mapserv->map->units,
+                               mapserv->map->width, mapserv->map->height,
+                               mapserv->map->resolution,
+                               &mapserv->map->scaledenom) != MS_SUCCESS)
             return MS_FAILURE;
-            break;
+          mapserv->map->cellsize =
+              msAdjustExtent(&(mapserv->map->extent), mapserv->map->width,
+                             mapserv->map->height);
         }
 
-        mapserv->map->query.type = MS_QUERY_BY_POINT;
-        mapserv->map->query.mode = MS_QUERY_SINGLE;
-        mapserv->map->query.layer = mapserv->QueryLayerIndex;
-        mapserv->map->query.point = mapserv->mappnt;
-        mapserv->map->query.buffer = mapserv->Buffer;
+        mapserv->map->query.rect = mapserv->map->extent;
+        mapserv->map->query.type = MS_QUERY_BY_RECT;
         break;
-      case INDEXQUERY:
-        mapserv->map->query.type = MS_QUERY_BY_INDEX;
-        mapserv->map->query.mode = MS_QUERY_SINGLE;
-        mapserv->map->query.layer = mapserv->QueryLayerIndex;
-        mapserv->map->query.shapeindex = mapserv->ShapeIndex;
-        mapserv->map->query.tileindex = mapserv->TileIndex;
+      }
+      break;
+    case QUERY:
+      switch (mapserv->QueryCoordSource) {
+      case FROMIMGPNT:
+        setCoordinate(mapserv);
+        mapserv->map->extent =
+            mapserv->ImgExt; /* use the existing image parameters */
+        mapserv->map->width = mapserv->ImgCols;
+        mapserv->map->height = mapserv->ImgRows;
+        if (msCalculateScale(mapserv->map->extent, mapserv->map->units,
+                             mapserv->map->width, mapserv->map->height,
+                             mapserv->map->resolution,
+                             &mapserv->map->scaledenom) != MS_SUCCESS)
+          return MS_FAILURE;
         break;
+      case FROMUSERPNT: /* only a buffer makes sense, DOES IT? */
+        if (setExtent(mapserv) != MS_SUCCESS)
+          return MS_FAILURE;
+        break;
+      default:
+        msSetError(MS_WEBERR,
+                   "Query mode needs a point, imgxy and mapxy are not set.",
+                   "mapserv()");
+        return MS_FAILURE;
+        break;
+      }
+
+      mapserv->map->query.type = MS_QUERY_BY_POINT;
+      mapserv->map->query.mode = MS_QUERY_SINGLE;
+      mapserv->map->query.layer = mapserv->QueryLayerIndex;
+      mapserv->map->query.point = mapserv->mappnt;
+      mapserv->map->query.buffer = mapserv->Buffer;
+      break;
+    case INDEXQUERY:
+      mapserv->map->query.type = MS_QUERY_BY_INDEX;
+      mapserv->map->query.mode = MS_QUERY_SINGLE;
+      mapserv->map->query.layer = mapserv->QueryLayerIndex;
+      mapserv->map->query.shapeindex = mapserv->ShapeIndex;
+      mapserv->map->query.tileindex = mapserv->TileIndex;
+      break;
     } /* end mode switch */
 
     /* finally execute the query */
-    if(msExecuteQuery(mapserv->map) != MS_SUCCESS) return MS_FAILURE;
+    if (msExecuteQuery(mapserv->map) != MS_SUCCESS)
+      return MS_FAILURE;
   }
 
-  if(mapserv->map->querymap.width > 0 && mapserv->map->querymap.width <= mapserv->map->maxsize) mapserv->map->width = mapserv->map->querymap.width; /* make sure we use the right size */
-  if(mapserv->map->querymap.height > 0 && mapserv->map->querymap.height <= mapserv->map->maxsize) mapserv->map->height = mapserv->map->querymap.height;
+  if (mapserv->map->querymap.width > 0 &&
+      mapserv->map->querymap.width <= mapserv->map->maxsize)
+    mapserv->map->width =
+        mapserv->map->querymap.width; /* make sure we use the right size */
+  if (mapserv->map->querymap.height > 0 &&
+      mapserv->map->querymap.height <= mapserv->map->maxsize)
+    mapserv->map->height = mapserv->map->querymap.height;
 
-  if(mapserv->UseShapes)
-    if(MS_SUCCESS != setExtentFromShapes(mapserv))
+  if (mapserv->UseShapes)
+    if (MS_SUCCESS != setExtentFromShapes(mapserv))
       return MS_FAILURE;
 
-  if(msReturnTemplateQuery(mapserv, mapserv->map->web.queryformat, NULL) != MS_SUCCESS) return MS_FAILURE;
+  if (msReturnTemplateQuery(mapserv, mapserv->map->web.queryformat, NULL) !=
+      MS_SUCCESS)
+    return MS_FAILURE;
 
-  if(mapserv->savequery) {
-    snprintf(buffer, sizeof(buffer), "%s%s%s%s", mapserv->map->web.imagepath, mapserv->map->name, mapserv->Id, MS_QUERY_EXTENSION);
-    if((status = msSaveQuery(mapserv->map, buffer, MS_FALSE)) != MS_SUCCESS) return status;
+  if (mapserv->savequery) {
+    snprintf(buffer, sizeof(buffer), "%s%s%s%s", mapserv->map->web.imagepath,
+             mapserv->map->name, mapserv->Id, MS_QUERY_EXTENSION);
+    if ((status = msSaveQuery(mapserv->map, buffer, MS_FALSE)) != MS_SUCCESS)
+      return status;
   }
   return MS_SUCCESS;
 }
 
-int msCGIDispatchImageRequest(mapservObj *mapserv)
-{
+int msCGIDispatchImageRequest(mapservObj *mapserv) {
   int status;
   imageObj *img = NULL;
-  switch(mapserv->Mode) {
-    case MAP:
-      if(mapserv->QueryFile) {
-        status = msLoadQuery(mapserv->map, mapserv->QueryFile);
-        if(status != MS_SUCCESS) return MS_FAILURE;
-        img = msDrawMap(mapserv->map, MS_TRUE);
-      } else
-        img = msDrawMap(mapserv->map, MS_FALSE);
-      break;
-    case REFERENCE:
-      mapserv->map->cellsize = msAdjustExtent(&(mapserv->map->extent), mapserv->map->width, mapserv->map->height);
-      img = msDrawReferenceMap(mapserv->map);
-      break;
-    case SCALEBAR:
-      img = msDrawScalebar(mapserv->map);
-      break;
-    case TILE:
-      msTileSetExtent(mapserv);
-
-      if(!strcmp(MS_IMAGE_MIME_TYPE(mapserv->map->outputformat), "application/vnd.mapbox-vector-tile") || !strcmp(MS_IMAGE_MIME_TYPE(mapserv->map->outputformat), "application/x-protobuf")) {
-        if(msMVTWriteTile(mapserv->map, mapserv->sendheaders) != MS_SUCCESS) return MS_FAILURE;
-        return MS_SUCCESS;
-      }
+  switch (mapserv->Mode) {
+  case MAP:
+    if (mapserv->QueryFile) {
+      status = msLoadQuery(mapserv->map, mapserv->QueryFile);
+      if (status != MS_SUCCESS)
+        return MS_FAILURE;
+      img = msDrawMap(mapserv->map, MS_TRUE);
+    } else
+      img = msDrawMap(mapserv->map, MS_FALSE);
+    break;
+  case REFERENCE:
+    mapserv->map->cellsize = msAdjustExtent(
+        &(mapserv->map->extent), mapserv->map->width, mapserv->map->height);
+    img = msDrawReferenceMap(mapserv->map);
+    break;
+  case SCALEBAR:
+    img = msDrawScalebar(mapserv->map);
+    break;
+  case TILE:
+    msTileSetExtent(mapserv);
+
+    if (!strcmp(MS_IMAGE_MIME_TYPE(mapserv->map->outputformat),
+                "application/vnd.mapbox-vector-tile") ||
+        !strcmp(MS_IMAGE_MIME_TYPE(mapserv->map->outputformat),
+                "application/x-protobuf")) {
+      if (msMVTWriteTile(mapserv->map, mapserv->sendheaders) != MS_SUCCESS)
+        return MS_FAILURE;
+      return MS_SUCCESS;
+    }
 
-      img = msTileDraw(mapserv);
-      break;
-    case LEGEND:
-    case MAPLEGEND:
-      img = msDrawLegend(mapserv->map, MS_FALSE, mapserv->hittest);
-      break;
-    default:
-      msSetError(MS_CGIERR,"Invalid CGI mode", "msCGIDispatchImageRequest()");
-      break;
+    img = msTileDraw(mapserv);
+    break;
+  case LEGEND:
+  case MAPLEGEND:
+    img = msDrawLegend(mapserv->map, MS_FALSE, mapserv->hittest);
+    break;
+  default:
+    msSetError(MS_CGIERR, "Invalid CGI mode", "msCGIDispatchImageRequest()");
+    break;
   }
 
-  if(!img) return MS_FAILURE;
+  if (!img)
+    return MS_FAILURE;
 
   /*
    ** Set the Cache control headers if the option is set.
    */
-  if( mapserv->sendheaders && msLookupHashTable(&(mapserv->map->web.metadata), "http_max_age") ) {
-    msIO_setHeader("Cache-Control","max-age=%s", msLookupHashTable(&(mapserv->map->web.metadata), "http_max_age"));
-  }
-
-  if(mapserv->sendheaders)  {
-    const char *attachment = msGetOutputFormatOption(mapserv->map->outputformat, "ATTACHMENT", NULL );
-    if(attachment)
-      msIO_setHeader("Content-disposition","attachment; filename=%s", attachment);
-
-    if(!strcmp(MS_IMAGE_MIME_TYPE(mapserv->map->outputformat), "application/json")) {
-      msIO_setHeader("Content-Type","application/json; charset=utf-8");
+  if (mapserv->sendheaders &&
+      msLookupHashTable(&(mapserv->map->web.metadata), "http_max_age")) {
+    msIO_setHeader(
+        "Cache-Control", "max-age=%s",
+        msLookupHashTable(&(mapserv->map->web.metadata), "http_max_age"));
+  }
+
+  if (mapserv->sendheaders) {
+    const char *attachment =
+        msGetOutputFormatOption(mapserv->map->outputformat, "ATTACHMENT", NULL);
+    if (attachment)
+      msIO_setHeader("Content-disposition", "attachment; filename=%s",
+                     attachment);
+
+    if (!strcmp(MS_IMAGE_MIME_TYPE(mapserv->map->outputformat),
+                "application/json")) {
+      msIO_setHeader("Content-Type", "application/json; charset=utf-8");
     } else {
-      msIO_setHeader("Content-Type","%s", MS_IMAGE_MIME_TYPE(mapserv->map->outputformat));
+      msIO_setHeader("Content-Type", "%s",
+                     MS_IMAGE_MIME_TYPE(mapserv->map->outputformat));
     }
     msIO_sendHeaders();
   }
 
-  if( mapserv->Mode == MAP || mapserv->Mode == TILE )
+  if (mapserv->Mode == MAP || mapserv->Mode == TILE)
     status = msSaveImage(mapserv->map, img, NULL);
   else
-    status = msSaveImage(NULL,img, NULL);
+    status = msSaveImage(NULL, img, NULL);
 
-  if(status != MS_SUCCESS) return MS_FAILURE;
+  if (status != MS_SUCCESS)
+    return MS_FAILURE;
 
   msFreeImage(img);
   return MS_SUCCESS;
 }
 
-
-int msCGIDispatchLegendRequest(mapservObj *mapserv)
-{
+int msCGIDispatchLegendRequest(mapservObj *mapserv) {
   int status;
-  if(mapserv->Mode == MAPLEGEND) {
-    if(setExtent(mapserv) != MS_SUCCESS) return MS_FAILURE;
-    if(checkWebScale(mapserv) != MS_SUCCESS) return MS_FAILURE;
+  if (mapserv->Mode == MAPLEGEND) {
+    if (setExtent(mapserv) != MS_SUCCESS)
+      return MS_FAILURE;
+    if (checkWebScale(mapserv) != MS_SUCCESS)
+      return MS_FAILURE;
     mapserv->hittest = msSmallMalloc(sizeof(map_hittest));
-    initMapHitTests(mapserv->map,mapserv->hittest);
-    status = msHitTestMap(mapserv->map,mapserv->hittest);
-    if(status != MS_SUCCESS) return MS_FAILURE;
+    initMapHitTests(mapserv->map, mapserv->hittest);
+    status = msHitTestMap(mapserv->map, mapserv->hittest);
+    if (status != MS_SUCCESS)
+      return MS_FAILURE;
   }
-  if(mapserv->map->legend.template) {
+  if (mapserv->map->legend.template) {
     char *legendTemplate;
     legendTemplate = generateLegendTemplate(mapserv);
-    if(legendTemplate) {
-      if(mapserv->sendheaders) {
-        msIO_setHeader("Content-Type","%s",mapserv->map->web.legendformat);
+    if (legendTemplate) {
+      if (mapserv->sendheaders) {
+        msIO_setHeader("Content-Type", "%s", mapserv->map->web.legendformat);
         msIO_sendHeaders();
       }
       msIO_fwrite(legendTemplate, strlen(legendTemplate), 1, stdout);
 
       free(legendTemplate);
       return MS_SUCCESS;
-    } else {/* error already generated by (generateLegendTemplate()) */
+    } else { /* error already generated by (generateLegendTemplate()) */
       return MS_FAILURE;
     }
   } else {
@@ -1797,74 +2140,86 @@ int msCGIDispatchLegendRequest(mapservOb
   }
 }
 
-int msCGIDispatchLegendIconRequest(mapservObj *mapserv)
-{
+int msCGIDispatchLegendIconRequest(mapservObj *mapserv) {
   char **tokens = NULL;
-  int numtokens=0;
-  int layerindex=-1, classindex=0, status;
+  int numtokens = 0;
+  int layerindex = -1, classindex = 0, status;
   outputFormatObj *format = NULL;
   imageObj *img = NULL;
 
   /* TODO: do we want to set scale here? */
 
   /* do we have enough information */
-  if(!mapserv->icon) {
-    msSetError(MS_WEBERR, "Mode=LEGENDICON requires an icon parameter.", "mapserv()");
+  if (!mapserv->icon) {
+    msSetError(MS_WEBERR, "Mode=LEGENDICON requires an icon parameter.",
+               "mapserv()");
     return MS_FAILURE;
   }
 
   /* process the icon definition */
   tokens = msStringSplit(mapserv->icon, ',', &numtokens);
 
-  if(numtokens != 1 && numtokens != 2) {
-    msSetError(MS_WEBERR, "%d Malformed icon parameter, should be 'layer,class' or just 'layer' if the layer has only 1 class defined.", "mapserv()", numtokens);
+  if (numtokens != 1 && numtokens != 2) {
+    msSetError(MS_WEBERR,
+               "%d Malformed icon parameter, should be 'layer,class' or just "
+               "'layer' if the layer has only 1 class defined.",
+               "mapserv()", numtokens);
     status = MS_FAILURE;
     goto li_cleanup;
   }
 
-  if((layerindex = msGetLayerIndex(mapserv->map, tokens[0])) == -1) {
-    msSetError(MS_WEBERR, "Icon layer=%s not found in mapfile.", "mapserv()", tokens[0]);
+  if ((layerindex = msGetLayerIndex(mapserv->map, tokens[0])) == -1) {
+    msSetError(MS_WEBERR, "Icon layer=%s not found in mapfile.", "mapserv()",
+               tokens[0]);
     status = MS_FAILURE;
     goto li_cleanup;
   }
 
-  if(numtokens == 2) { /* check the class index */
+  if (numtokens == 2) { /* check the class index */
     classindex = atoi(tokens[1]);
-    if(classindex < 0 || classindex >= GET_LAYER(mapserv->map, layerindex)->numclasses) {
-      msSetError(MS_WEBERR, "Icon class=%d not found in layer=%s.", "mapserv()", classindex, GET_LAYER(mapserv->map, layerindex)->name);
+    if (classindex < 0 ||
+        classindex >= GET_LAYER(mapserv->map, layerindex)->numclasses) {
+      msSetError(MS_WEBERR, "Icon class=%d not found in layer=%s.", "mapserv()",
+                 classindex, GET_LAYER(mapserv->map, layerindex)->name);
       status = MS_FAILURE;
       goto li_cleanup;
     }
   }
 
-  if(mapserv->Mode == MAPLEGENDICON) {
-    if(setExtent(mapserv) != MS_SUCCESS) {
-      status=MS_FAILURE;
+  if (mapserv->Mode == MAPLEGENDICON) {
+    if (setExtent(mapserv) != MS_SUCCESS) {
+      status = MS_FAILURE;
       goto li_cleanup;
     }
-    if(checkWebScale(mapserv) != MS_SUCCESS) {
-      status=MS_FAILURE;
+    if (checkWebScale(mapserv) != MS_SUCCESS) {
+      status = MS_FAILURE;
       goto li_cleanup;
     }
     mapserv->hittest = msSmallMalloc(sizeof(map_hittest));
-    initMapHitTests(mapserv->map,mapserv->hittest);
-    status = msHitTestLayer(mapserv->map, GET_LAYER(mapserv->map,layerindex),&mapserv->hittest->layerhits[layerindex]);
-    if(status != MS_SUCCESS) goto li_cleanup;
+    initMapHitTests(mapserv->map, mapserv->hittest);
+    status = msHitTestLayer(mapserv->map, GET_LAYER(mapserv->map, layerindex),
+                            &mapserv->hittest->layerhits[layerindex]);
+    if (status != MS_SUCCESS)
+      goto li_cleanup;
   }
 
   /* ensure we have an image format representing the options for the legend. */
-  msApplyOutputFormat(&format, mapserv->map->outputformat, mapserv->map->legend.transparent);
+  msApplyOutputFormat(&format, mapserv->map->outputformat,
+                      mapserv->map->legend.transparent);
 
   /* initialize the legend image */
-  if( ! MS_RENDERER_PLUGIN(format) ) {
-    msSetError(MS_RENDERERERR, "unsupported renderer for legend icon", "mapserv main()");
+  if (!MS_RENDERER_PLUGIN(format)) {
+    msSetError(MS_RENDERERERR, "unsupported renderer for legend icon",
+               "mapserv main()");
     status = MS_FAILURE;
     goto li_cleanup;
   }
-  img = msImageCreate(mapserv->map->legend.keysizex, mapserv->map->legend.keysizey, format,
-                      mapserv->map->web.imagepath, mapserv->map->web.imageurl, mapserv->map->resolution, mapserv->map->defresolution,
+  img = msImageCreate(mapserv->map->legend.keysizex,
+                      mapserv->map->legend.keysizey, format,
+                      mapserv->map->web.imagepath, mapserv->map->web.imageurl,
+                      mapserv->map->resolution, mapserv->map->defresolution,
                       &(mapserv->map->legend.imagecolor));
-  if(!img) {
+  if (!img) {
     status = MS_FAILURE;
     goto li_cleanup;
   }
@@ -1873,23 +2228,33 @@ int msCGIDispatchLegendIconRequest(mapse
   /* drop this reference to output format */
   msApplyOutputFormat(&format, NULL, MS_NOOVERRIDE);
 
-  if(msDrawLegendIcon(mapserv->map, GET_LAYER(mapserv->map, layerindex), GET_LAYER(mapserv->map, layerindex)->class[classindex], mapserv->map->legend.keysizex,  mapserv->map->legend.keysizey, img, 0, 0, MS_TRUE,
-      ((mapserv->hittest)?(&mapserv->hittest->layerhits[layerindex].classhits[classindex]):(NULL))) != MS_SUCCESS) {
+  if (msDrawLegendIcon(mapserv->map, GET_LAYER(mapserv->map, layerindex),
+                       GET_LAYER(mapserv->map, layerindex)->class[classindex],
+                       mapserv -> map -> legend.keysizex,
+                       mapserv->map->legend.keysizey, img, 0, 0, MS_TRUE,
+                       ((mapserv->hittest)
+                            ? (&mapserv->hittest->layerhits[layerindex]
+                                    .classhits[classindex])
+                            : (NULL))) != MS_SUCCESS) {
     status = MS_FAILURE;
     goto li_cleanup;
   }
 
-  if(mapserv->sendheaders) {
-    msIO_setHeader("Content-Type","%s",MS_IMAGE_MIME_TYPE(mapserv->map->outputformat));
+  if (mapserv->sendheaders) {
+    msIO_setHeader("Content-Type", "%s",
+                   MS_IMAGE_MIME_TYPE(mapserv->map->outputformat));
     msIO_sendHeaders();
   }
   /*
    ** Set the Cache control headers if the option is set.
    */
-  if( mapserv->sendheaders && msLookupHashTable(&(mapserv->map->web.metadata), "http_max_age") ) {
-    msIO_printf("Cache-Control: max-age=%s%c", msLookupHashTable(&(mapserv->map->web.metadata), "http_max_age"), 10);
+  if (mapserv->sendheaders &&
+      msLookupHashTable(&(mapserv->map->web.metadata), "http_max_age")) {
+    msIO_printf(
+        "Cache-Control: max-age=%s%c",
+        msLookupHashTable(&(mapserv->map->web.metadata), "http_max_age"), 10);
   }
-  
+
   status = msSaveImage(NULL, img, NULL);
 
 li_cleanup:
@@ -1898,8 +2263,7 @@ li_cleanup:
   return status;
 }
 
-int msCGIDispatchRequest(mapservObj *mapserv)
-{
+int msCGIDispatchRequest(mapservObj *mapserv) {
   int i;
   int status;
 
@@ -1907,7 +2271,7 @@ int msCGIDispatchRequest(mapservObj *map
    ** Determine 'mode': Check for MS_MODE env. var. and mode=... CGI param
    */
   mapserv->Mode = -1; /* Not set */
-  if( msCGISetMode(mapserv) != MS_SUCCESS) {
+  if (msCGISetMode(mapserv) != MS_SUCCESS) {
     return MS_FAILURE;
   }
 
@@ -1915,28 +2279,28 @@ int msCGIDispatchRequest(mapservObj *map
    ** Start by calling the WMS/WFS/WCS Dispatchers.  If they fail then we'll
    ** process this as a regular MapServer request.
    */
-  if((mapserv->Mode == -1 || mapserv->Mode == OWS || mapserv->Mode == WFS) &&
-      (status = msOWSDispatch(mapserv->map, mapserv->request,
-                              mapserv->Mode)) != MS_DONE  )  {
+  if ((mapserv->Mode == -1 || mapserv->Mode == OWS || mapserv->Mode == WFS) &&
+      (status = msOWSDispatch(mapserv->map, mapserv->request, mapserv->Mode)) !=
+          MS_DONE) {
     /*
      ** OWSDispatch returned either MS_SUCCESS or MS_FAILURE
      */
-    if( status == MS_FAILURE ) {
+    if (status == MS_FAILURE) {
       return MS_FAILURE;
     }
 
     if (status == MS_SUCCESS &&
-        strcasecmp(mapserv->map->imagetype, "application/openlayers")==0) {
+        strcasecmp(mapserv->map->imagetype, "application/openlayers") == 0) {
       char *service = NULL;
-      for( i=0; i<mapserv->request->NumParams; i++) {
-        if(strcasecmp(mapserv->request->ParamNames[i], "SERVICE") == 0) {
+      for (i = 0; i < mapserv->request->NumParams; i++) {
+        if (strcasecmp(mapserv->request->ParamNames[i], "SERVICE") == 0) {
           service = mapserv->request->ParamValues[i];
           break;
         }
       }
-      if (service && strcasecmp(service,"WMS")==0) {
-        if(mapserv->sendheaders) {
-          msIO_setHeader("Content-Type","text/html");
+      if (service && strcasecmp(service, "WMS") == 0) {
+        if (mapserv->sendheaders) {
+          msIO_setHeader("Content-Type", "text/html");
           msIO_sendHeaders();
         }
 
@@ -1947,65 +2311,75 @@ int msCGIDispatchRequest(mapservObj *map
     return MS_SUCCESS;
   } /* done OGC/OWS case */
 
-
   /*
   ** Do "traditional" mode processing.
   */
   if (mapserv->Mode == -1)
     mapserv->Mode = BROWSE;
 
-  if(MS_SUCCESS != msCGILoadForm(mapserv)) {
+  if (MS_SUCCESS != msCGILoadForm(mapserv)) {
     return MS_FAILURE;
   }
 
-  /* Insecure as implemented, need to save someplace non accessible by everyone in the universe
-      if(mapserv->savemap) {
-        snprintf(buffer, sizeof(buffer), "%s%s%s.map", mapserv->map->web.imagepath, mapserv->map->name, mapserv->Id);
-        if(msSaveMap(mapserv->map, buffer) == -1) return MS_FAILURE;
+  /* Insecure as implemented, need to save someplace non accessible by everyone
+     in the universe if(mapserv->savemap) { snprintf(buffer, sizeof(buffer),
+     "%s%s%s.map", mapserv->map->web.imagepath, mapserv->map->name,
+     mapserv->Id); if(msSaveMap(mapserv->map, buffer) == -1) return MS_FAILURE;
       }
   */
 
-  if((mapserv->CoordSource == FROMIMGPNT) || (mapserv->CoordSource == FROMIMGBOX)) /* make sure extent of existing image matches shape of image */
-    mapserv->map->cellsize = msAdjustExtent(&mapserv->ImgExt, mapserv->ImgCols, mapserv->ImgRows);
+  if ((mapserv->CoordSource == FROMIMGPNT) ||
+      (mapserv->CoordSource == FROMIMGBOX)) /* make sure extent of existing
+                                               image matches shape of image */
+    mapserv->map->cellsize =
+        msAdjustExtent(&mapserv->ImgExt, mapserv->ImgCols, mapserv->ImgRows);
 
   /*
   ** For each layer let's set layer status
   */
-  for(i=0; i<mapserv->map->numlayers; i++) {
-    if((GET_LAYER(mapserv->map, i)->status != MS_DEFAULT)) {
-      if(isOn(mapserv,  GET_LAYER(mapserv->map, i)->name, GET_LAYER(mapserv->map, i)->group) == MS_TRUE) /* Set layer status */
+  for (i = 0; i < mapserv->map->numlayers; i++) {
+    if ((GET_LAYER(mapserv->map, i)->status != MS_DEFAULT)) {
+      if (isOn(mapserv, GET_LAYER(mapserv->map, i)->name,
+               GET_LAYER(mapserv->map, i)->group) ==
+          MS_TRUE) /* Set layer status */
         GET_LAYER(mapserv->map, i)->status = MS_ON;
       else
         GET_LAYER(mapserv->map, i)->status = MS_OFF;
     }
   }
 
-  if(mapserv->CoordSource == FROMREFPNT) /* force browse mode if the reference coords are set */
+  if (mapserv->CoordSource ==
+      FROMREFPNT) /* force browse mode if the reference coords are set */
     mapserv->Mode = BROWSE;
 
-  if(mapserv->Mode == TILE) {
+  if (mapserv->Mode == TILE) {
     /*
      ** Tile mode:
      ** Set the projection up and test the parameters for legality.
      */
-    if( msTileSetup(mapserv) != MS_SUCCESS ) {
+    if (msTileSetup(mapserv) != MS_SUCCESS) {
       return MS_FAILURE;
     }
   }
-  if(mapserv->Mode == BROWSE) {
+  if (mapserv->Mode == BROWSE) {
     return msCGIDispatchBrowseRequest(mapserv);
-  } else if(mapserv->Mode == MAP || mapserv->Mode == SCALEBAR || mapserv->Mode == REFERENCE || mapserv->Mode == TILE) { /* "image" only modes */
-    /* tile, map, scalebar and reference all need the extent to be set up correctly */
-    if(setExtent(mapserv) != MS_SUCCESS) return MS_FAILURE;
-    if(checkWebScale(mapserv) != MS_SUCCESS) return MS_FAILURE;
+  } else if (mapserv->Mode == MAP || mapserv->Mode == SCALEBAR ||
+             mapserv->Mode == REFERENCE ||
+             mapserv->Mode == TILE) { /* "image" only modes */
+    /* tile, map, scalebar and reference all need the extent to be set up
+     * correctly */
+    if (setExtent(mapserv) != MS_SUCCESS)
+      return MS_FAILURE;
+    if (checkWebScale(mapserv) != MS_SUCCESS)
+      return MS_FAILURE;
     return msCGIDispatchImageRequest(mapserv);
-  } else if(mapserv->Mode == LEGEND || mapserv->Mode == MAPLEGEND) {
+  } else if (mapserv->Mode == LEGEND || mapserv->Mode == MAPLEGEND) {
     return msCGIDispatchLegendRequest(mapserv);
-  } else if(mapserv->Mode == LEGENDICON || mapserv->Mode == MAPLEGENDICON) {
+  } else if (mapserv->Mode == LEGENDICON || mapserv->Mode == MAPLEGENDICON) {
     return msCGIDispatchLegendIconRequest(mapserv);
-  } else if(mapserv->Mode >= QUERY) {
+  } else if (mapserv->Mode >= QUERY) {
     return msCGIDispatchQueryRequest(mapserv);
-  } else if(mapserv->Mode == COORDINATE) {
+  } else if (mapserv->Mode == COORDINATE) {
     return msCGIDispatchCoordinateRequest(mapserv);
   } else {
     msSetError(MS_WEBERR, "Bug: unsupported mode", "msDispatchRequest");
@@ -2013,16 +2387,16 @@ int msCGIDispatchRequest(mapservObj *map
   }
 }
 
-int msCGIHandler(const char *query_string, void **out_buffer, size_t *buffer_length)
-{
-  int x,m=0;
+int msCGIHandler(const char *query_string, void **out_buffer,
+                 size_t *buffer_length) {
+  int x, m = 0;
   struct mstimeval execstarttime = {0}, execendtime = {0};
   struct mstimeval requeststarttime = {0}, requestendtime = {0};
   mapservObj *mapserv = NULL;
   char *queryString = NULL;
   int maxParams = MS_DEFAULT_CGI_PARAMS;
   msIOContext *ctx;
-  msIOBuffer  *buf;
+  msIOBuffer *buf;
 
   configObj *config = NULL;
 
@@ -2032,95 +2406,97 @@ int msCGIHandler(const char *query_strin
   msProjDataInitFromEnv();
 
   /* Use MS_ERRORFILE and MS_DEBUGLEVEL env vars if set */
-  if( msDebugInitFromEnv() != MS_SUCCESS ) {
+  if (msDebugInitFromEnv() != MS_SUCCESS) {
     msCGIWriteError(mapserv);
     goto end_request;
   }
 
-  if(msGetGlobalDebugLevel() >= MS_DEBUGLEVEL_TUNING)
+  if (msGetGlobalDebugLevel() >= MS_DEBUGLEVEL_TUNING)
     msGettimeofday(&execstarttime, NULL);
 
-  if(!query_string || !*query_string) {
-    msIO_setHeader("Content-Type","text/html");
+  if (!query_string || !*query_string) {
+    msIO_setHeader("Content-Type", "text/html");
     msIO_sendHeaders();
     msIO_printf("No query information to decode. QUERY_STRING not set.\n");
     goto end_request;
   }
 
   config = msLoadConfig(NULL);
-  if(config == NULL) {
+  if (config == NULL) {
     msCGIWriteError(mapserv);
     goto end_request;
   }
-  
+
   mapserv = msAllocMapServObj();
   mapserv->request->type = MS_GET_REQUEST;
 
   /* don't modify the string */
   queryString = msStrdup(query_string);
-  for(x=0; queryString[0] != '\0'; x++) {
-    if(m >= maxParams) {
+  for (x = 0; queryString[0] != '\0'; x++) {
+    if (m >= maxParams) {
       maxParams *= 2;
-      mapserv->request->ParamNames = (char **) realloc(mapserv->request->ParamNames,sizeof(char *) * maxParams);
+      mapserv->request->ParamNames = (char **)realloc(
+          mapserv->request->ParamNames, sizeof(char *) * maxParams);
       if (mapserv->request->ParamNames == NULL) {
         msIO_printf("Out of memory trying to allocate name/value pairs.\n");
         goto end_request;
       }
-      mapserv->request->ParamValues = (char **) realloc(mapserv->request->ParamValues,sizeof(char *) * maxParams);
-      if (mapserv->request->ParamValues ==  NULL) {
+      mapserv->request->ParamValues = (char **)realloc(
+          mapserv->request->ParamValues, sizeof(char *) * maxParams);
+      if (mapserv->request->ParamValues == NULL) {
         msIO_printf("Out of memory trying to allocate name/value pairs.\n");
         goto end_request;
       }
     }
-    mapserv->request->ParamValues[m] = makeword(queryString,'&');
+    mapserv->request->ParamValues[m] = makeword(queryString, '&');
     plustospace(mapserv->request->ParamValues[m]);
     unescape_url(mapserv->request->ParamValues[m]);
-    mapserv->request->ParamNames[m] = makeword(mapserv->request->ParamValues[m],'=');
+    mapserv->request->ParamNames[m] =
+        makeword(mapserv->request->ParamValues[m], '=');
     m++;
   }
   mapserv->request->NumParams = m;
 
-  if( mapserv->request->NumParams == 0 ) {
+  if (mapserv->request->NumParams == 0) {
     msCGIWriteError(mapserv);
     goto end_request;
   }
 
   mapserv->map = msCGILoadMap(mapserv, config);
-  if(!mapserv->map) {
+  if (!mapserv->map) {
     msCGIWriteError(mapserv);
     goto end_request;
   }
 
-  if( mapserv->map->debug >= MS_DEBUGLEVEL_TUNING)
+  if (mapserv->map->debug >= MS_DEBUGLEVEL_TUNING)
     msGettimeofday(&requeststarttime, NULL);
 
-  if(msCGIDispatchRequest(mapserv) != MS_SUCCESS) {
+  if (msCGIDispatchRequest(mapserv) != MS_SUCCESS) {
     msCGIWriteError(mapserv);
     goto end_request;
   }
 
-
 end_request:
-  if(mapserv) {
-    if(mapserv->map && mapserv->map->debug >= MS_DEBUGLEVEL_TUNING) {
+  if (mapserv) {
+    if (mapserv->map && mapserv->map->debug >= MS_DEBUGLEVEL_TUNING) {
       msGettimeofday(&requestendtime, NULL);
       msDebug("mapserv request processing time (msLoadMap not incl.): %.3fs\n",
-              (requestendtime.tv_sec+requestendtime.tv_usec/1.0e6)-
-              (requeststarttime.tv_sec+requeststarttime.tv_usec/1.0e6) );
+              (requestendtime.tv_sec + requestendtime.tv_usec / 1.0e6) -
+                  (requeststarttime.tv_sec + requeststarttime.tv_usec / 1.0e6));
     }
     msFreeMapServObj(mapserv);
     msFreeConfig(config);
   }
 
   /* normal case, processing is complete */
-  if(msGetGlobalDebugLevel() >= MS_DEBUGLEVEL_TUNING) {
+  if (msGetGlobalDebugLevel() >= MS_DEBUGLEVEL_TUNING) {
     msGettimeofday(&execendtime, NULL);
     msDebug("mapserv total execution time: %.3fs\n",
-            (execendtime.tv_sec+execendtime.tv_usec/1.0e6)-
-            (execstarttime.tv_sec+execstarttime.tv_usec/1.0e6) );
+            (execendtime.tv_sec + execendtime.tv_usec / 1.0e6) -
+                (execstarttime.tv_sec + execstarttime.tv_usec / 1.0e6));
   }
-  ctx = msIO_getHandler( (FILE *) "stdout" );
-  buf = (msIOBuffer *) ctx->cbData;
+  ctx = msIO_getHandler((FILE *)"stdout");
+  buf = (msIOBuffer *)ctx->cbData;
   *out_buffer = buf->data;
   *buffer_length = buf->data_offset;
 
diff -pruN 8.0.1-5/mapshape.c 8.0.2-1/mapshape.c
--- 8.0.1-5/mapshape.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapshape.c	2024-06-11 20:41:34.000000000 +0000
@@ -48,8 +48,7 @@
 /* Only use this macro on 32-bit integers! */
 #define SWAP_FOUR_BYTES(data) CPL_SWAP32(data)
 
-
-#define ByteCopy( a, b, c )     memcpy( b, a, c )
+#define ByteCopy(a, b, c) memcpy(b, a, c)
 
 #ifdef __BYTE_ORDER__
 /* GCC/clang predefined macro */
@@ -60,28 +59,32 @@
 #define bBigEndian false
 #else
 /* generic check */
-#define bBigEndian (((union{int in;char out;}){1}).out)
+#define bBigEndian                                                             \
+  (((union {                                                                   \
+     int in;                                                                   \
+     char out;                                                                 \
+   }){1})                                                                      \
+       .out)
 #endif
 
 /* SHX reading */
-static int msSHXLoadAll( SHPHandle psSHP );
-static int msSHXReadOffset( SHPHandle psSHP, int hEntity );
-static int msSHXReadSize( SHPHandle psSHP, int hEntity );
+static int msSHXLoadAll(SHPHandle psSHP);
+static int msSHXReadOffset(SHPHandle psSHP, int hEntity);
+static int msSHXReadSize(SHPHandle psSHP, int hEntity);
 
 /************************************************************************/
 /*                              SwapWord()                              */
 /*                                                                      */
 /*      Swap a 2, 4 or 8 byte word.                                     */
 /************************************************************************/
-static void SwapWord( int length, void * wordP )
-{
+static void SwapWord(int length, void *wordP) {
   int i;
   uchar temp;
 
-  for( i=0; i < length/2; i++ ) {
-    temp = ((uchar *) wordP)[i];
-    ((uchar *)wordP)[i] = ((uchar *) wordP)[length-i-1];
-    ((uchar *) wordP)[length-i-1] = temp;
+  for (i = 0; i < length / 2; i++) {
+    temp = ((uchar *)wordP)[i];
+    ((uchar *)wordP)[i] = ((uchar *)wordP)[length - i - 1];
+    ((uchar *)wordP)[length - i - 1] = temp;
   }
 }
 
@@ -91,8 +94,7 @@ static void SwapWord( int length, void *
 /*      A realloc cover function that will access a NULL pointer as     */
 /*      a valid input.                                                  */
 /************************************************************************/
-static void * SfRealloc( void * pMem, int nNewSize )
-{
+static void *SfRealloc(void *pMem, int nNewSize) {
   return realloc(pMem, nNewSize);
 }
 
@@ -102,8 +104,7 @@ static void * SfRealloc( void * pMem, in
 /*      Write out a header for the .shp and .shx files as well as the */
 /*  contents of the index (.shx) file.        */
 /************************************************************************/
-static void writeHeader( SHPHandle psSHP )
-{
+static void writeHeader(SHPHandle psSHP) {
   uchar abyHeader[100];
   int i;
   ms_int32 i32;
@@ -113,98 +114,108 @@ static void writeHeader( SHPHandle psSHP
   /* -------------------------------------------------------------------- */
   /*      Prepare header block for .shp file.                             */
   /* -------------------------------------------------------------------- */
-  for( i = 0; i < 100; i++ )
+  for (i = 0; i < 100; i++)
     abyHeader[i] = 0;
 
-  abyHeader[2] = 0x27;        /* magic cookie */
+  abyHeader[2] = 0x27; /* magic cookie */
   abyHeader[3] = 0x0a;
 
-  i32 = psSHP->nFileSize/2;       /* file size */
-  ByteCopy( &i32, abyHeader+24, 4 );
-  if( !bBigEndian ) SwapWord( 4, abyHeader+24 );
-
-  i32 = 1000;           /* version */
-  ByteCopy( &i32, abyHeader+28, 4 );
-  if( bBigEndian ) SwapWord( 4, abyHeader+28 );
-
-  i32 = psSHP->nShapeType;        /* shape type */
-  ByteCopy( &i32, abyHeader+32, 4 );
-  if( bBigEndian ) SwapWord( 4, abyHeader+32 );
-
-  dValue = psSHP->adBoundsMin[0];     /* set bounds */
-  ByteCopy( &dValue, abyHeader+36, 8 );
-  if( bBigEndian ) SwapWord( 8, abyHeader+36 );
+  i32 = psSHP->nFileSize / 2; /* file size */
+  ByteCopy(&i32, abyHeader + 24, 4);
+  if (!bBigEndian)
+    SwapWord(4, abyHeader + 24);
+
+  i32 = 1000; /* version */
+  ByteCopy(&i32, abyHeader + 28, 4);
+  if (bBigEndian)
+    SwapWord(4, abyHeader + 28);
+
+  i32 = psSHP->nShapeType; /* shape type */
+  ByteCopy(&i32, abyHeader + 32, 4);
+  if (bBigEndian)
+    SwapWord(4, abyHeader + 32);
+
+  dValue = psSHP->adBoundsMin[0]; /* set bounds */
+  ByteCopy(&dValue, abyHeader + 36, 8);
+  if (bBigEndian)
+    SwapWord(8, abyHeader + 36);
 
   dValue = psSHP->adBoundsMin[1];
-  ByteCopy( &dValue, abyHeader+44, 8 );
-  if( bBigEndian ) SwapWord( 8, abyHeader+44 );
+  ByteCopy(&dValue, abyHeader + 44, 8);
+  if (bBigEndian)
+    SwapWord(8, abyHeader + 44);
 
   dValue = psSHP->adBoundsMax[0];
-  ByteCopy( &dValue, abyHeader+52, 8 );
-  if( bBigEndian ) SwapWord( 8, abyHeader+52 );
+  ByteCopy(&dValue, abyHeader + 52, 8);
+  if (bBigEndian)
+    SwapWord(8, abyHeader + 52);
 
   dValue = psSHP->adBoundsMax[1];
-  ByteCopy( &dValue, abyHeader+60, 8 );
-  if( bBigEndian ) SwapWord( 8, abyHeader+60 );
-
-  dValue = psSHP->adBoundsMin[2];     /* z */
-  ByteCopy( &dValue, abyHeader+68, 8 );
-  if( bBigEndian ) SwapWord( 8, abyHeader+68 );
+  ByteCopy(&dValue, abyHeader + 60, 8);
+  if (bBigEndian)
+    SwapWord(8, abyHeader + 60);
+
+  dValue = psSHP->adBoundsMin[2]; /* z */
+  ByteCopy(&dValue, abyHeader + 68, 8);
+  if (bBigEndian)
+    SwapWord(8, abyHeader + 68);
 
   dValue = psSHP->adBoundsMax[2];
-  ByteCopy( &dValue, abyHeader+76, 8 );
-  if( bBigEndian ) SwapWord( 8, abyHeader+76 );
-
-
-  dValue = psSHP->adBoundsMin[3];     /* m */
-  ByteCopy( &dValue, abyHeader+84, 8 );
-  if( bBigEndian ) SwapWord( 8, abyHeader+84 );
+  ByteCopy(&dValue, abyHeader + 76, 8);
+  if (bBigEndian)
+    SwapWord(8, abyHeader + 76);
+
+  dValue = psSHP->adBoundsMin[3]; /* m */
+  ByteCopy(&dValue, abyHeader + 84, 8);
+  if (bBigEndian)
+    SwapWord(8, abyHeader + 84);
 
   dValue = psSHP->adBoundsMax[3];
-  ByteCopy( &dValue, abyHeader+92, 8 );
-  if( bBigEndian ) SwapWord( 8, abyHeader+92 );
+  ByteCopy(&dValue, abyHeader + 92, 8);
+  if (bBigEndian)
+    SwapWord(8, abyHeader + 92);
 
   /* -------------------------------------------------------------------- */
   /*      Write .shp file header.                                         */
   /* -------------------------------------------------------------------- */
-  VSIFSeekL( psSHP->fpSHP, 0, 0 );
-  VSIFWriteL( abyHeader, 100, 1, psSHP->fpSHP );
+  VSIFSeekL(psSHP->fpSHP, 0, 0);
+  VSIFWriteL(abyHeader, 100, 1, psSHP->fpSHP);
 
   /* -------------------------------------------------------------------- */
   /*      Prepare, and write .shx file header.                            */
   /* -------------------------------------------------------------------- */
-  i32 = (psSHP->nRecords * 2 * sizeof(ms_int32) + 100)/2;   /* file size */
-  ByteCopy( &i32, abyHeader+24, 4 );
-  if( !bBigEndian ) SwapWord( 4, abyHeader+24 );
+  i32 = (psSHP->nRecords * 2 * sizeof(ms_int32) + 100) / 2; /* file size */
+  ByteCopy(&i32, abyHeader + 24, 4);
+  if (!bBigEndian)
+    SwapWord(4, abyHeader + 24);
 
-  VSIFSeekL( psSHP->fpSHX, 0, 0 );
-  VSIFWriteL( abyHeader, 100, 1, psSHP->fpSHX );
+  VSIFSeekL(psSHP->fpSHX, 0, 0);
+  VSIFWriteL(abyHeader, 100, 1, psSHP->fpSHX);
 
   /* -------------------------------------------------------------------- */
   /*      Write out the .shx contents.                                    */
   /* -------------------------------------------------------------------- */
-  panSHX = (ms_int32 *) msSmallMalloc(sizeof(ms_int32) * 2 * psSHP->nRecords);
+  panSHX = (ms_int32 *)msSmallMalloc(sizeof(ms_int32) * 2 * psSHP->nRecords);
 
-  for( i = 0; i < psSHP->nRecords; i++ ) {
-    panSHX[i*2  ] = psSHP->panRecOffset[i]/2;
-    panSHX[i*2+1] = psSHP->panRecSize[i]/2;
-    if( !bBigEndian ) {
-      *(panSHX+i*2) = SWAP_FOUR_BYTES(*(panSHX+i*2));
-      *(panSHX+i*2+1) = SWAP_FOUR_BYTES(*(panSHX+i*2+1));
+  for (i = 0; i < psSHP->nRecords; i++) {
+    panSHX[i * 2] = psSHP->panRecOffset[i] / 2;
+    panSHX[i * 2 + 1] = psSHP->panRecSize[i] / 2;
+    if (!bBigEndian) {
+      *(panSHX + i * 2) = SWAP_FOUR_BYTES(*(panSHX + i * 2));
+      *(panSHX + i * 2 + 1) = SWAP_FOUR_BYTES(*(panSHX + i * 2 + 1));
     }
   }
 
-  VSIFWriteL( panSHX, sizeof(ms_int32) * 2, psSHP->nRecords, psSHP->fpSHX );
+  VSIFWriteL(panSHX, sizeof(ms_int32) * 2, psSHP->nRecords, psSHP->fpSHX);
 
-  free( panSHX );
+  free(panSHX);
 }
 
-SHPHandle msSHPOpenVirtualFile( VSILFILE * fpSHP, VSILFILE * fpSHX )
-{
+SHPHandle msSHPOpenVirtualFile(VSILFILE *fpSHP, VSILFILE *fpSHX) {
   /* -------------------------------------------------------------------- */
   /*  Initialize the info structure.              */
   /* -------------------------------------------------------------------- */
-  SHPHandle psSHP = (SHPHandle) msSmallMalloc(sizeof(SHPInfo));
+  SHPHandle psSHP = (SHPHandle)msSmallMalloc(sizeof(SHPInfo));
 
   psSHP->bUpdated = MS_FALSE;
 
@@ -218,107 +229,119 @@ SHPHandle msSHPOpenVirtualFile( VSILFILE
   /* -------------------------------------------------------------------- */
   /*   Read the file size from the SHP file.            */
   /* -------------------------------------------------------------------- */
-  uchar *pabyBuf = (uchar *) msSmallMalloc(100);
-  if(1 != VSIFReadL( pabyBuf, 100, 1, psSHP->fpSHP )) {
-    VSIFCloseL( psSHP->fpSHP );
-    VSIFCloseL( psSHP->fpSHX );
-    free( psSHP );
+  uchar *pabyBuf = (uchar *)msSmallMalloc(100);
+  if (1 != VSIFReadL(pabyBuf, 100, 1, psSHP->fpSHP)) {
+    VSIFCloseL(psSHP->fpSHP);
+    VSIFCloseL(psSHP->fpSHX);
+    free(psSHP);
     free(pabyBuf);
-    return( NULL );
+    return (NULL);
   }
 
-  if( !bBigEndian ) SwapWord( 4, pabyBuf+24 );
-  memcpy(&psSHP->nFileSize, pabyBuf+24, 4);
-  if( psSHP->nFileSize < 0 || psSHP->nFileSize > INT_MAX / 2 ) {
-      msDebug("Invalid / unsupported nFileSize = %d value. Got it from actual file length", psSHP->nFileSize);
-      VSIFSeekL( psSHP->fpSHP, 0, SEEK_END );
-      vsi_l_offset nSize = VSIFTellL( psSHP->fpSHP );
-      if( nSize > (vsi_l_offset)INT_MAX ) {
-          msDebug("Actual .shp size is larger than 2 GB. Not suported. Invalidating nFileSize");
-          psSHP->nFileSize = 0;
-      }
-      else
-          psSHP->nFileSize = (int)nSize;
-  }
-  else {
-      psSHP->nFileSize *= 2;
+  if (!bBigEndian)
+    SwapWord(4, pabyBuf + 24);
+  memcpy(&psSHP->nFileSize, pabyBuf + 24, 4);
+  if (psSHP->nFileSize < 0 || psSHP->nFileSize > INT_MAX / 2) {
+    msDebug("Invalid / unsupported nFileSize = %d value. Got it from actual "
+            "file length",
+            psSHP->nFileSize);
+    VSIFSeekL(psSHP->fpSHP, 0, SEEK_END);
+    vsi_l_offset nSize = VSIFTellL(psSHP->fpSHP);
+    if (nSize > (vsi_l_offset)INT_MAX) {
+      msDebug("Actual .shp size is larger than 2 GB. Not supported. "
+              "Invalidating nFileSize");
+      psSHP->nFileSize = 0;
+    } else
+      psSHP->nFileSize = (int)nSize;
+  } else {
+    psSHP->nFileSize *= 2;
   }
 
   /* -------------------------------------------------------------------- */
   /*  Read SHX file Header info                                           */
   /* -------------------------------------------------------------------- */
-  if(1 != VSIFReadL( pabyBuf, 100, 1, psSHP->fpSHX )) {
+  if (1 != VSIFReadL(pabyBuf, 100, 1, psSHP->fpSHX)) {
     msSetError(MS_SHPERR, "Corrupted .shx file", "msSHPOpen()");
-    VSIFCloseL( psSHP->fpSHP );
-    VSIFCloseL( psSHP->fpSHX );
-    free( psSHP );
+    VSIFCloseL(psSHP->fpSHP);
+    VSIFCloseL(psSHP->fpSHX);
+    free(psSHP);
     free(pabyBuf);
-    return( NULL );
+    return (NULL);
   }
 
-  if( pabyBuf[0] != 0 || pabyBuf[1] != 0 || pabyBuf[2] != 0x27  || (pabyBuf[3] != 0x0a && pabyBuf[3] != 0x0d) ) {
+  if (pabyBuf[0] != 0 || pabyBuf[1] != 0 || pabyBuf[2] != 0x27 ||
+      (pabyBuf[3] != 0x0a && pabyBuf[3] != 0x0d)) {
     msSetError(MS_SHPERR, "Corrupted .shx file", "msSHPOpen()");
-    VSIFCloseL( psSHP->fpSHP );
-    VSIFCloseL( psSHP->fpSHX );
-    free( psSHP );
+    VSIFCloseL(psSHP->fpSHP);
+    VSIFCloseL(psSHP->fpSHX);
+    free(psSHP);
     free(pabyBuf);
 
-    return( NULL );
+    return (NULL);
   }
 
   int nSHXHalfFileSize;
-  if( !bBigEndian ) SwapWord( 4, pabyBuf+24 );
-  memcpy(&nSHXHalfFileSize, pabyBuf+24, 4);
+  if (!bBigEndian)
+    SwapWord(4, pabyBuf + 24);
+  memcpy(&nSHXHalfFileSize, pabyBuf + 24, 4);
   if (nSHXHalfFileSize >= 50)
-    psSHP->nRecords = (nSHXHalfFileSize - 50) / 4;   // (nSHXFileSize - 100) / 8
+    psSHP->nRecords = (nSHXHalfFileSize - 50) / 4; // (nSHXFileSize - 100) / 8
   else
     psSHP->nRecords = -1;
 
-  if( psSHP->nRecords < 0 || psSHP->nRecords > 256000000 ) {
+  if (psSHP->nRecords < 0 || psSHP->nRecords > 256000000) {
     msSetError(MS_SHPERR, "Corrupted .shx file : nRecords = %d.", "msSHPOpen()",
                psSHP->nRecords);
-    VSIFCloseL( psSHP->fpSHP );
-    VSIFCloseL( psSHP->fpSHX );
-    free( psSHP );
+    VSIFCloseL(psSHP->fpSHP);
+    VSIFCloseL(psSHP->fpSHX);
+    free(psSHP);
     free(pabyBuf);
-    return( NULL );
+    return (NULL);
   }
 
   psSHP->nShapeType = pabyBuf[32];
 
-  if( bBigEndian ) SwapWord( 8, pabyBuf+36 );
+  if (bBigEndian)
+    SwapWord(8, pabyBuf + 36);
   double dValue;
-  memcpy( &dValue, pabyBuf+36, 8 );
+  memcpy(&dValue, pabyBuf + 36, 8);
   psSHP->adBoundsMin[0] = dValue;
 
-  if( bBigEndian ) SwapWord( 8, pabyBuf+44 );
-  memcpy( &dValue, pabyBuf+44, 8 );
+  if (bBigEndian)
+    SwapWord(8, pabyBuf + 44);
+  memcpy(&dValue, pabyBuf + 44, 8);
   psSHP->adBoundsMin[1] = dValue;
 
-  if( bBigEndian ) SwapWord( 8, pabyBuf+52 );
-  memcpy( &dValue, pabyBuf+52, 8 );
+  if (bBigEndian)
+    SwapWord(8, pabyBuf + 52);
+  memcpy(&dValue, pabyBuf + 52, 8);
   psSHP->adBoundsMax[0] = dValue;
 
-  if( bBigEndian ) SwapWord( 8, pabyBuf+60 );
-  memcpy( &dValue, pabyBuf+60, 8 );
+  if (bBigEndian)
+    SwapWord(8, pabyBuf + 60);
+  memcpy(&dValue, pabyBuf + 60, 8);
   psSHP->adBoundsMax[1] = dValue;
 
-  if( bBigEndian ) SwapWord( 8, pabyBuf+68 );   /* z */
-  memcpy( &dValue, pabyBuf+68, 8 );
+  if (bBigEndian)
+    SwapWord(8, pabyBuf + 68); /* z */
+  memcpy(&dValue, pabyBuf + 68, 8);
   psSHP->adBoundsMin[2] = dValue;
 
-  if( bBigEndian ) SwapWord( 8, pabyBuf+76 );
-  memcpy( &dValue, pabyBuf+76, 8 );
+  if (bBigEndian)
+    SwapWord(8, pabyBuf + 76);
+  memcpy(&dValue, pabyBuf + 76, 8);
   psSHP->adBoundsMax[2] = dValue;
 
-  if( bBigEndian ) SwapWord( 8, pabyBuf+84 );   /* m */
-  memcpy( &dValue, pabyBuf+84, 8 );
+  if (bBigEndian)
+    SwapWord(8, pabyBuf + 84); /* m */
+  memcpy(&dValue, pabyBuf + 84, 8);
   psSHP->adBoundsMin[3] = dValue;
 
-  if( bBigEndian ) SwapWord( 8, pabyBuf+92 );
-  memcpy( &dValue, pabyBuf+92, 8 );
+  if (bBigEndian)
+    SwapWord(8, pabyBuf + 92);
+  memcpy(&dValue, pabyBuf + 92, 8);
   psSHP->adBoundsMax[3] = dValue;
-  free( pabyBuf );
+  free(pabyBuf);
 
   /* -------------------------------------------------------------------- */
   /*  Read the .shx file to get the offsets to each record in       */
@@ -327,30 +350,29 @@ SHPHandle msSHPOpenVirtualFile( VSILFILE
   psSHP->nMaxRecords = psSHP->nRecords;
 
   /* Our in-memory cache of offset information */
-  psSHP->panRecOffset = (int *) malloc(sizeof(int) * psSHP->nMaxRecords );
+  psSHP->panRecOffset = (int *)malloc(sizeof(int) * psSHP->nMaxRecords);
   /* Our in-memory cache of size information */
-  psSHP->panRecSize = (int *) malloc(sizeof(int) * psSHP->nMaxRecords );
+  psSHP->panRecSize = (int *)malloc(sizeof(int) * psSHP->nMaxRecords);
   /* The completeness information for our in-memory cache */
-  psSHP->panRecLoaded = msAllocBitArray( 1 + (psSHP->nMaxRecords / SHX_BUFFER_PAGE) ) ;
+  psSHP->panRecLoaded =
+      msAllocBitArray(1 + (psSHP->nMaxRecords / SHX_BUFFER_PAGE));
   /* Is our in-memory cache completely populated? */
   psSHP->panRecAllLoaded = 0;
 
   /* malloc failed? clean up and shut down */
-  if (psSHP->panRecOffset == NULL ||
-      psSHP->panRecSize == NULL ||
+  if (psSHP->panRecOffset == NULL || psSHP->panRecSize == NULL ||
       psSHP->panRecLoaded == NULL) {
     free(psSHP->panRecOffset);
     free(psSHP->panRecSize);
     free(psSHP->panRecLoaded);
-    VSIFCloseL( psSHP->fpSHP );
-    VSIFCloseL( psSHP->fpSHX );
-    free( psSHP );
+    VSIFCloseL(psSHP->fpSHP);
+    VSIFCloseL(psSHP->fpSHX);
+    free(psSHP);
     msSetError(MS_MEMERR, "Out of memory", "msSHPOpen()");
-    return( NULL );
+    return (NULL);
   }
 
-
-  return( psSHP );
+  return (psSHP);
 }
 
 /************************************************************************/
@@ -359,8 +381,7 @@ SHPHandle msSHPOpenVirtualFile( VSILFILE
 /*      Open the .shp and .shx files based on the basename of the       */
 /*      files or either file name.                                      */
 /************************************************************************/
-SHPHandle msSHPOpen( const char * pszLayer, const char * pszAccess )
-{
+SHPHandle msSHPOpen(const char *pszLayer, const char *pszAccess) {
   char *pszFullname, *pszBasename;
 
   int i;
@@ -370,7 +391,8 @@ SHPHandle msSHPOpen( const char * pszLay
   /*      ensure the result string indicates binary to avoid common       */
   /*      problems on Windows.                                            */
   /* -------------------------------------------------------------------- */
-  if( strcmp(pszAccess,"rb+") == 0 || strcmp(pszAccess,"r+b") == 0 || strcmp(pszAccess,"r+") == 0 )
+  if (strcmp(pszAccess, "rb+") == 0 || strcmp(pszAccess, "r+b") == 0 ||
+      strcmp(pszAccess, "r+") == 0)
     pszAccess = "r+b";
   else
     pszAccess = "rb";
@@ -379,47 +401,49 @@ SHPHandle msSHPOpen( const char * pszLay
   /*  Compute the base (layer) name.  If there is any extension     */
   /*  on the passed in filename we will strip it off.         */
   /* -------------------------------------------------------------------- */
-  pszBasename = (char *) msSmallMalloc(strlen(pszLayer)+5);
-  strcpy( pszBasename, pszLayer );
-  for( i = strlen(pszBasename)-1;
-       i > 0 && pszBasename[i] != '.' && pszBasename[i] != '/' && pszBasename[i] != '\\';
-       i-- ) {}
+  pszBasename = (char *)msSmallMalloc(strlen(pszLayer) + 5);
+  strcpy(pszBasename, pszLayer);
+  for (i = strlen(pszBasename) - 1;
+       i > 0 && pszBasename[i] != '.' && pszBasename[i] != '/' &&
+       pszBasename[i] != '\\';
+       i--) {
+  }
 
-  if( pszBasename[i] == '.' )
+  if (pszBasename[i] == '.')
     pszBasename[i] = '\0';
 
   /* -------------------------------------------------------------------- */
   /*  Open the .shp and .shx files.  Note that files pulled from      */
   /*  a PC to Unix with upper case filenames won't work!        */
   /* -------------------------------------------------------------------- */
-  pszFullname = (char *) msSmallMalloc(strlen(pszBasename) + 5);
-  sprintf( pszFullname, "%s.shp", pszBasename );
-  VSILFILE *fpSHP = VSIFOpenL(pszFullname, pszAccess );
-  if( fpSHP == NULL ) {
-    sprintf( pszFullname, "%s.SHP", pszBasename );
-    fpSHP = VSIFOpenL(pszFullname, pszAccess );
+  pszFullname = (char *)msSmallMalloc(strlen(pszBasename) + 5);
+  sprintf(pszFullname, "%s.shp", pszBasename);
+  VSILFILE *fpSHP = VSIFOpenL(pszFullname, pszAccess);
+  if (fpSHP == NULL) {
+    sprintf(pszFullname, "%s.SHP", pszBasename);
+    fpSHP = VSIFOpenL(pszFullname, pszAccess);
   }
-  if( fpSHP == NULL ) {
+  if (fpSHP == NULL) {
     msFree(pszBasename);
     msFree(pszFullname);
-    return( NULL );
+    return (NULL);
   }
 
-  sprintf( pszFullname, "%s.shx", pszBasename );
-  VSILFILE *fpSHX = VSIFOpenL(pszFullname, pszAccess );
-  if( fpSHX == NULL ) {
-    sprintf( pszFullname, "%s.SHX", pszBasename );
-    fpSHX = VSIFOpenL(pszFullname, pszAccess );
+  sprintf(pszFullname, "%s.shx", pszBasename);
+  VSILFILE *fpSHX = VSIFOpenL(pszFullname, pszAccess);
+  if (fpSHX == NULL) {
+    sprintf(pszFullname, "%s.SHX", pszBasename);
+    fpSHX = VSIFOpenL(pszFullname, pszAccess);
   }
-  if( fpSHX == NULL ) {
+  if (fpSHX == NULL) {
     VSIFCloseL(fpSHP);
     msFree(pszBasename);
     msFree(pszFullname);
-    return( NULL );
+    return (NULL);
   }
 
-  free( pszFullname );
-  free( pszBasename );
+  free(pszFullname);
+  free(pszBasename);
 
   return msSHPOpenVirtualFile(fpSHP, fpSHX);
 }
@@ -429,29 +453,27 @@ SHPHandle msSHPOpen( const char * pszLay
 /*                        */
 /*  Close the .shp and .shx files.          */
 /************************************************************************/
-void msSHPClose(SHPHandle psSHP )
-{
+void msSHPClose(SHPHandle psSHP) {
   /* -------------------------------------------------------------------- */
   /*  Update the header if we have modified anything.           */
   /* -------------------------------------------------------------------- */
-  if( psSHP->bUpdated )
-    writeHeader( psSHP );
+  if (psSHP->bUpdated)
+    writeHeader(psSHP);
 
   /* -------------------------------------------------------------------- */
   /*      Free all resources, and close files.                            */
   /* -------------------------------------------------------------------- */
-  free( psSHP->panRecOffset );
-  free( psSHP->panRecSize );
-  free( psSHP->panRecLoaded );
-
+  free(psSHP->panRecOffset);
+  free(psSHP->panRecSize);
+  free(psSHP->panRecLoaded);
 
   free(psSHP->pabyRec);
   free(psSHP->panParts);
 
-  VSIFCloseL( psSHP->fpSHX );
-  VSIFCloseL( psSHP->fpSHP );
+  VSIFCloseL(psSHP->fpSHX);
+  VSIFCloseL(psSHP->fpSHP);
 
-  free( psSHP );
+  free(psSHP);
 }
 
 /************************************************************************/
@@ -459,12 +481,11 @@ void msSHPClose(SHPHandle psSHP )
 /*                                                                      */
 /*      Fetch general information about the shape file.                 */
 /************************************************************************/
-void msSHPGetInfo(SHPHandle psSHP, int * pnEntities, int * pnShapeType )
-{
-  if( pnEntities )
+void msSHPGetInfo(SHPHandle psSHP, int *pnEntities, int *pnShapeType) {
+  if (pnEntities)
     *pnEntities = psSHP->nRecords;
 
-  if( pnShapeType )
+  if (pnShapeType)
     *pnShapeType = psSHP->nShapeType;
 }
 
@@ -474,8 +495,7 @@ void msSHPGetInfo(SHPHandle psSHP, int *
 /*      Create a new shape file and return a handle to the open         */
 /*      shape file with read/write access.                              */
 /************************************************************************/
-SHPHandle msSHPCreate( const char * pszLayer, int nShapeType )
-{
+SHPHandle msSHPCreate(const char *pszLayer, int nShapeType) {
   char *pszBasename, *pszFullname;
   int i;
   VSILFILE *fpSHP, *fpSHX;
@@ -487,87 +507,93 @@ SHPHandle msSHPCreate( const char * pszL
   /*  Compute the base (layer) name.  If there is any extension       */
   /*  on the passed in filename we will strip it off.         */
   /* -------------------------------------------------------------------- */
-  pszBasename = (char *) msSmallMalloc(strlen(pszLayer)+5);
-  strcpy( pszBasename, pszLayer );
-  for( i = strlen(pszBasename)-1;
-       i > 0 && pszBasename[i] != '.' && pszBasename[i] != '/' && pszBasename[i] != '\\';
-       i-- ) {}
+  pszBasename = (char *)msSmallMalloc(strlen(pszLayer) + 5);
+  strcpy(pszBasename, pszLayer);
+  for (i = strlen(pszBasename) - 1;
+       i > 0 && pszBasename[i] != '.' && pszBasename[i] != '/' &&
+       pszBasename[i] != '\\';
+       i--) {
+  }
 
-  if( pszBasename[i] == '.' )
+  if (pszBasename[i] == '.')
     pszBasename[i] = '\0';
 
   /* -------------------------------------------------------------------- */
   /*      Open the two files so we can write their headers.               */
   /* -------------------------------------------------------------------- */
-  pszFullname = (char *) msSmallMalloc(strlen(pszBasename) + 5);
-  sprintf( pszFullname, "%s.shp", pszBasename );
-  fpSHP = VSIFOpenL(pszFullname, "wb" );
-  if( fpSHP == NULL ) {
-    free( pszFullname );
+  pszFullname = (char *)msSmallMalloc(strlen(pszBasename) + 5);
+  sprintf(pszFullname, "%s.shp", pszBasename);
+  fpSHP = VSIFOpenL(pszFullname, "wb");
+  if (fpSHP == NULL) {
+    free(pszFullname);
     free(pszBasename);
-    return( NULL );
+    return (NULL);
   }
 
-  sprintf( pszFullname, "%s.shx", pszBasename );
-  fpSHX = VSIFOpenL(pszFullname, "wb" );
-  if( fpSHX == NULL ) {
+  sprintf(pszFullname, "%s.shx", pszBasename);
+  fpSHX = VSIFOpenL(pszFullname, "wb");
+  if (fpSHX == NULL) {
     VSIFCloseL(fpSHP);
-    free( pszFullname );
+    free(pszFullname);
     free(pszBasename);
-    return( NULL );
+    return (NULL);
   }
 
-  free( pszFullname );
+  free(pszFullname);
   free(pszBasename);
 
   /* -------------------------------------------------------------------- */
   /*      Prepare header block for .shp file.                             */
   /* -------------------------------------------------------------------- */
-  for( i = 0; i < 100; i++ )
+  for (i = 0; i < 100; i++)
     abyHeader[i] = 0;
 
-  abyHeader[2] = 0x27;        /* magic cookie */
+  abyHeader[2] = 0x27; /* magic cookie */
   abyHeader[3] = 0x0a;
 
-  i32 = 50;           /* file size */
-  ByteCopy( &i32, abyHeader+24, 4 );
-  if( !bBigEndian ) SwapWord( 4, abyHeader+24 );
-
-  i32 = 1000;           /* version */
-  ByteCopy( &i32, abyHeader+28, 4 );
-  if( bBigEndian ) SwapWord( 4, abyHeader+28 );
-
-  i32 = nShapeType;         /* shape type */
-  ByteCopy( &i32, abyHeader+32, 4 );
-  if( bBigEndian ) SwapWord( 4, abyHeader+32 );
-
-  dValue = 0.0;         /* set bounds */
-  ByteCopy( &dValue, abyHeader+36, 8 );
-  ByteCopy( &dValue, abyHeader+44, 8 );
-  ByteCopy( &dValue, abyHeader+52, 8 );
-  ByteCopy( &dValue, abyHeader+60, 8 );
+  i32 = 50; /* file size */
+  ByteCopy(&i32, abyHeader + 24, 4);
+  if (!bBigEndian)
+    SwapWord(4, abyHeader + 24);
+
+  i32 = 1000; /* version */
+  ByteCopy(&i32, abyHeader + 28, 4);
+  if (bBigEndian)
+    SwapWord(4, abyHeader + 28);
+
+  i32 = nShapeType; /* shape type */
+  ByteCopy(&i32, abyHeader + 32, 4);
+  if (bBigEndian)
+    SwapWord(4, abyHeader + 32);
+
+  dValue = 0.0; /* set bounds */
+  ByteCopy(&dValue, abyHeader + 36, 8);
+  ByteCopy(&dValue, abyHeader + 44, 8);
+  ByteCopy(&dValue, abyHeader + 52, 8);
+  ByteCopy(&dValue, abyHeader + 60, 8);
 
   /* -------------------------------------------------------------------- */
   /*      Write .shp file header.                                         */
   /* -------------------------------------------------------------------- */
-  VSIFWriteL( abyHeader, 100, 1, fpSHP );
+  VSIFWriteL(abyHeader, 100, 1, fpSHP);
 
   /* -------------------------------------------------------------------- */
   /*      Prepare, and write .shx file header.                            */
   /* -------------------------------------------------------------------- */
-  i32 = 50;           /* file size */
-  ByteCopy( &i32, abyHeader+24, 4 );
-  if( !bBigEndian ) SwapWord( 4, abyHeader+24 );
+  i32 = 50; /* file size */
+  ByteCopy(&i32, abyHeader + 24, 4);
+  if (!bBigEndian)
+    SwapWord(4, abyHeader + 24);
 
-  VSIFWriteL( abyHeader, 100, 1, fpSHX );
+  VSIFWriteL(abyHeader, 100, 1, fpSHX);
 
   /* -------------------------------------------------------------------- */
   /*      Close the files, and then open them as regular existing files.  */
   /* -------------------------------------------------------------------- */
-  VSIFCloseL( fpSHP );
-  VSIFCloseL( fpSHX );
+  VSIFCloseL(fpSHP);
+  VSIFCloseL(fpSHX);
 
-  return( msSHPOpen( pszLayer, "rb+" ) );
+  return (msSHPOpen(pszLayer, "rb+"));
 }
 
 /************************************************************************/
@@ -576,19 +602,18 @@ SHPHandle msSHPCreate( const char * pszL
 /*      Compute a bounds rectangle for a shape, and set it into the     */
 /*      indicated location in the record.                               */
 /************************************************************************/
-static void writeBounds( uchar * pabyRec, shapeObj *shape, int nVCount )
-{
+static void writeBounds(uchar *pabyRec, shapeObj *shape, int nVCount) {
   double dXMin, dXMax, dYMin, dYMax;
   int i, j;
 
-  if( nVCount == 0 ) {
+  if (nVCount == 0) {
     dXMin = dYMin = dXMax = dYMax = 0.0;
   } else {
     dXMin = dXMax = shape->line[0].point[0].x;
     dYMin = dYMax = shape->line[0].point[0].y;
 
-    for( i=0; i<shape->numlines; i++ ) {
-      for( j=0; j<shape->line[i].numpoints; j++ ) {
+    for (i = 0; i < shape->numlines; i++) {
+      for (j = 0; j < shape->line[i].numpoints; j++) {
         dXMin = MS_MIN(dXMin, shape->line[i].point[j].x);
         dXMax = MS_MAX(dXMax, shape->line[i].point[j].x);
         dYMin = MS_MIN(dYMin, shape->line[i].point[j].y);
@@ -597,42 +622,46 @@ static void writeBounds( uchar * pabyRec
     }
   }
 
-  if( bBigEndian ) {
-    SwapWord( 8, &dXMin );
-    SwapWord( 8, &dYMin );
-    SwapWord( 8, &dXMax );
-    SwapWord( 8, &dYMax );
-  }
-
-  ByteCopy( &dXMin, pabyRec +  0, 8 );
-  ByteCopy( &dYMin, pabyRec +  8, 8 );
-  ByteCopy( &dXMax, pabyRec + 16, 8 );
-  ByteCopy( &dYMax, pabyRec + 24, 8 );
-}
-
-int msSHPWritePoint(SHPHandle psSHP, pointObj *point )
-{
-  int nRecordOffset, nRecordSize=0;
+  if (bBigEndian) {
+    SwapWord(8, &dXMin);
+    SwapWord(8, &dYMin);
+    SwapWord(8, &dXMax);
+    SwapWord(8, &dYMax);
+  }
+
+  ByteCopy(&dXMin, pabyRec + 0, 8);
+  ByteCopy(&dYMin, pabyRec + 8, 8);
+  ByteCopy(&dXMax, pabyRec + 16, 8);
+  ByteCopy(&dYMax, pabyRec + 24, 8);
+}
+
+int msSHPWritePoint(SHPHandle psSHP, pointObj *point) {
+  int nRecordOffset, nRecordSize = 0;
   uchar *pabyRec;
-  ms_int32  i32, nPoints, nParts;
+  ms_int32 i32, nPoints, nParts;
 
-  if( psSHP->nShapeType != SHP_POINT) return(-1);
-  if( psSHP->nFileSize == 0 ) return -1;
+  if (psSHP->nShapeType != SHP_POINT)
+    return (-1);
+  if (psSHP->nFileSize == 0)
+    return -1;
 
   psSHP->bUpdated = MS_TRUE;
 
   /* Fill the SHX buffer if it is not already full. */
-  if( ! psSHP->panRecAllLoaded ) msSHXLoadAll( psSHP );
+  if (!psSHP->panRecAllLoaded)
+    msSHXLoadAll(psSHP);
 
   /* -------------------------------------------------------------------- */
   /*      Add the new entity to the in memory index.                      */
   /* -------------------------------------------------------------------- */
   psSHP->nRecords++;
-  if( psSHP->nRecords > psSHP->nMaxRecords ) {
-    psSHP->nMaxRecords = (int) (psSHP->nMaxRecords * 1.3 + 100);
+  if (psSHP->nRecords > psSHP->nMaxRecords) {
+    psSHP->nMaxRecords = (int)(psSHP->nMaxRecords * 1.3 + 100);
 
-    psSHP->panRecOffset = (int *) SfRealloc(psSHP->panRecOffset,sizeof(int) * psSHP->nMaxRecords );
-    psSHP->panRecSize = (int *) SfRealloc(psSHP->panRecSize,sizeof(int) * psSHP->nMaxRecords );
+    psSHP->panRecOffset =
+        (int *)SfRealloc(psSHP->panRecOffset, sizeof(int) * psSHP->nMaxRecords);
+    psSHP->panRecSize =
+        (int *)SfRealloc(psSHP->panRecSize, sizeof(int) * psSHP->nMaxRecords);
   }
 
   /* -------------------------------------------------------------------- */
@@ -644,20 +673,20 @@ int msSHPWritePoint(SHPHandle psSHP, poi
   /* -------------------------------------------------------------------- */
   /*      Initialize record.                                              */
   /* -------------------------------------------------------------------- */
-  psSHP->panRecOffset[psSHP->nRecords-1] = nRecordOffset = psSHP->nFileSize;
+  psSHP->panRecOffset[psSHP->nRecords - 1] = nRecordOffset = psSHP->nFileSize;
 
-  pabyRec = (uchar *) msSmallMalloc(nPoints * 2 * sizeof(double) + nParts * 4 + 128);
+  pabyRec =
+      (uchar *)msSmallMalloc(nPoints * 2 * sizeof(double) + nParts * 4 + 128);
 
   /* -------------------------------------------------------------------- */
   /*      Write vertices for a point.                                     */
   /* -------------------------------------------------------------------- */
-  ByteCopy( &(point->x), pabyRec + 12, 8 );
-  ByteCopy( &(point->y), pabyRec + 20, 8 );
+  ByteCopy(&(point->x), pabyRec + 12, 8);
+  ByteCopy(&(point->y), pabyRec + 20, 8);
 
-
-  if( bBigEndian ) {
-    SwapWord( 8, pabyRec + 12 );
-    SwapWord( 8, pabyRec + 20 );
+  if (bBigEndian) {
+    SwapWord(8, pabyRec + 12);
+    SwapWord(8, pabyRec + 20);
   }
 
   nRecordSize = 20;
@@ -665,31 +694,34 @@ int msSHPWritePoint(SHPHandle psSHP, poi
   /* -------------------------------------------------------------------- */
   /*      Set the shape type, record number, and record size.             */
   /* -------------------------------------------------------------------- */
-  i32 = psSHP->nRecords-1+1;          /* record # */
-  if( !bBigEndian ) i32 = SWAP_FOUR_BYTES(i32);
-  ByteCopy( &i32, pabyRec, 4 );
-
-  i32 = nRecordSize/2;        /* record size */
-  if( !bBigEndian ) i32 = SWAP_FOUR_BYTES(i32);
-  ByteCopy( &i32, pabyRec + 4, 4 );
-
-  i32 = psSHP->nShapeType;        /* shape type */
-  if( bBigEndian ) i32 = SWAP_FOUR_BYTES(i32);
-  ByteCopy( &i32, pabyRec + 8, 4 );
+  i32 = psSHP->nRecords - 1 + 1; /* record # */
+  if (!bBigEndian)
+    i32 = SWAP_FOUR_BYTES(i32);
+  ByteCopy(&i32, pabyRec, 4);
+
+  i32 = nRecordSize / 2; /* record size */
+  if (!bBigEndian)
+    i32 = SWAP_FOUR_BYTES(i32);
+  ByteCopy(&i32, pabyRec + 4, 4);
+
+  i32 = psSHP->nShapeType; /* shape type */
+  if (bBigEndian)
+    i32 = SWAP_FOUR_BYTES(i32);
+  ByteCopy(&i32, pabyRec + 8, 4);
 
   /* -------------------------------------------------------------------- */
   /*      Write out record.                                               */
   /* -------------------------------------------------------------------- */
-  if(VSIFSeekL( psSHP->fpSHP, nRecordOffset, 0 ) == 0) {
-    VSIFWriteL( pabyRec, nRecordSize+8, 1, psSHP->fpSHP );
+  if (VSIFSeekL(psSHP->fpSHP, nRecordOffset, 0) == 0) {
+    VSIFWriteL(pabyRec, nRecordSize + 8, 1, psSHP->fpSHP);
 
-    psSHP->panRecSize[psSHP->nRecords-1] = nRecordSize;
+    psSHP->panRecSize[psSHP->nRecords - 1] = nRecordSize;
     psSHP->nFileSize += nRecordSize + 8;
 
     /* -------------------------------------------------------------------- */
     /*  Expand file wide bounds based on this shape.        */
     /* -------------------------------------------------------------------- */
-    if( psSHP->nRecords == 1 ) {
+    if (psSHP->nRecords == 1) {
       psSHP->adBoundsMin[0] = psSHP->adBoundsMax[0] = point->x;
       psSHP->adBoundsMin[1] = psSHP->adBoundsMax[1] = point->y;
     } else {
@@ -699,43 +731,46 @@ int msSHPWritePoint(SHPHandle psSHP, poi
       psSHP->adBoundsMax[1] = MS_MAX(psSHP->adBoundsMax[1], point->y);
     }
   } else {
-    psSHP->nRecords -- ;
+    psSHP->nRecords--;
   }
-  free( pabyRec );
-  return( psSHP->nRecords - 1 );
+  free(pabyRec);
+  return (psSHP->nRecords - 1);
 }
 
-int msSHPWriteShape(SHPHandle psSHP, shapeObj *shape )
-{
-  int nRecordOffset, i, j, k, nRecordSize=0;
+int msSHPWriteShape(SHPHandle psSHP, shapeObj *shape) {
+  int nRecordOffset, i, j, k, nRecordSize = 0;
   uchar *pabyRec;
   int nShapeType;
 
-  ms_int32  i32, nPoints, nParts;
+  ms_int32 i32, nPoints, nParts;
 
-  if( psSHP->nFileSize == 0 ) return -1;
+  if (psSHP->nFileSize == 0)
+    return -1;
 
   psSHP->bUpdated = MS_TRUE;
 
   /* Fill the SHX buffer if it is not already full. */
-  if( ! psSHP->panRecAllLoaded ) msSHXLoadAll( psSHP );
+  if (!psSHP->panRecAllLoaded)
+    msSHXLoadAll(psSHP);
 
   /* -------------------------------------------------------------------- */
   /*      Add the new entity to the in memory index.                      */
   /* -------------------------------------------------------------------- */
   psSHP->nRecords++;
-  if( psSHP->nRecords > psSHP->nMaxRecords ) {
-    psSHP->nMaxRecords = (int) (psSHP->nMaxRecords * 1.3 + 100);
+  if (psSHP->nRecords > psSHP->nMaxRecords) {
+    psSHP->nMaxRecords = (int)(psSHP->nMaxRecords * 1.3 + 100);
 
-    psSHP->panRecOffset = (int *) SfRealloc(psSHP->panRecOffset,sizeof(int) * psSHP->nMaxRecords );
-    psSHP->panRecSize = (int *) SfRealloc(psSHP->panRecSize,sizeof(int) * psSHP->nMaxRecords );
+    psSHP->panRecOffset =
+        (int *)SfRealloc(psSHP->panRecOffset, sizeof(int) * psSHP->nMaxRecords);
+    psSHP->panRecSize =
+        (int *)SfRealloc(psSHP->panRecSize, sizeof(int) * psSHP->nMaxRecords);
   }
 
   /* -------------------------------------------------------------------- */
   /*      Compute a few things.                                           */
   /* -------------------------------------------------------------------- */
   nPoints = 0;
-  for(i=0; i<shape->numlines; i++)
+  for (i = 0; i < shape->numlines; i++)
     nPoints += shape->line[i].numpoints;
 
   nParts = shape->numlines;
@@ -743,9 +778,10 @@ int msSHPWriteShape(SHPHandle psSHP, sha
   /* -------------------------------------------------------------------- */
   /*      Initialize record.                                              */
   /* -------------------------------------------------------------------- */
-  psSHP->panRecOffset[psSHP->nRecords-1] = nRecordOffset = psSHP->nFileSize;
+  psSHP->panRecOffset[psSHP->nRecords - 1] = nRecordOffset = psSHP->nFileSize;
 
-  pabyRec = (uchar *) msSmallMalloc(nPoints * 4 * sizeof(double) + nParts * 8 + 128);
+  pabyRec =
+      (uchar *)msSmallMalloc(nPoints * 4 * sizeof(double) + nParts * 8 + 128);
   nShapeType = psSHP->nShapeType;
 
   if (shape->type == MS_SHAPE_NULL) {
@@ -755,73 +791,82 @@ int msSHPWriteShape(SHPHandle psSHP, sha
   /* -------------------------------------------------------------------- */
   /*  Write vertices for a Polygon or Arc.            */
   /* -------------------------------------------------------------------- */
-  else if(psSHP->nShapeType == SHP_POLYGON || psSHP->nShapeType == SHP_ARC ||
-          psSHP->nShapeType == SHP_POLYGONM || psSHP->nShapeType == SHP_ARCM ||
-          psSHP->nShapeType == SHP_ARCZ ||  psSHP->nShapeType == SHP_POLYGONZ) {
+  else if (psSHP->nShapeType == SHP_POLYGON || psSHP->nShapeType == SHP_ARC ||
+           psSHP->nShapeType == SHP_POLYGONM || psSHP->nShapeType == SHP_ARCM ||
+           psSHP->nShapeType == SHP_ARCZ || psSHP->nShapeType == SHP_POLYGONZ) {
     ms_int32 t_nParts, t_nPoints, partSize;
 
     t_nParts = nParts;
     t_nPoints = nPoints;
 
-    writeBounds( pabyRec + 12, shape, t_nPoints );
+    writeBounds(pabyRec + 12, shape, t_nPoints);
 
-    if( bBigEndian ) {
+    if (bBigEndian) {
       nPoints = SWAP_FOUR_BYTES(nPoints);
       nParts = SWAP_FOUR_BYTES(nParts);
     }
 
-    ByteCopy( &nPoints, pabyRec + 40 + 8, 4 );
-    ByteCopy( &nParts, pabyRec + 36 + 8, 4 );
+    ByteCopy(&nPoints, pabyRec + 40 + 8, 4);
+    ByteCopy(&nParts, pabyRec + 36 + 8, 4);
 
     partSize = 0; /* first part always starts at 0 */
-    ByteCopy( &partSize, pabyRec + 44 + 8 + 4*0, 4 );
-    if( bBigEndian ) SwapWord( 4, pabyRec + 44 + 8 + 4*0);
-
-    for( i = 1; i < t_nParts; i++ ) {
-      partSize += shape->line[i-1].numpoints;
-      ByteCopy( &partSize, pabyRec + 44 + 8 + 4*i, 4 );
-      if( bBigEndian ) SwapWord( 4, pabyRec + 44 + 8 + 4*i);
-
+    ByteCopy(&partSize, pabyRec + 44 + 8 + 4 * 0, 4);
+    if (bBigEndian)
+      SwapWord(4, pabyRec + 44 + 8 + 4 * 0);
+
+    for (i = 1; i < t_nParts; i++) {
+      partSize += shape->line[i - 1].numpoints;
+      ByteCopy(&partSize, pabyRec + 44 + 8 + 4 * i, 4);
+      if (bBigEndian)
+        SwapWord(4, pabyRec + 44 + 8 + 4 * i);
     }
 
     k = 0; /* overall point counter */
-    for( i = 0; i < shape->numlines; i++ ) {
-      for( j = 0; j < shape->line[i].numpoints; j++ ) {
-        ByteCopy( &(shape->line[i].point[j].x), pabyRec + 44 + 4*t_nParts + 8 + k * 16, 8 );
-        ByteCopy( &(shape->line[i].point[j].y), pabyRec + 44 + 4*t_nParts + 8 + k * 16 + 8, 8 );
-
-        if( bBigEndian ) {
-          SwapWord( 8, pabyRec + 44+4*t_nParts+8+k*16 );
-          SwapWord( 8, pabyRec + 44+4*t_nParts+8+k*16+8 );
+    for (i = 0; i < shape->numlines; i++) {
+      for (j = 0; j < shape->line[i].numpoints; j++) {
+        ByteCopy(&(shape->line[i].point[j].x),
+                 pabyRec + 44 + 4 * t_nParts + 8 + k * 16, 8);
+        ByteCopy(&(shape->line[i].point[j].y),
+                 pabyRec + 44 + 4 * t_nParts + 8 + k * 16 + 8, 8);
+
+        if (bBigEndian) {
+          SwapWord(8, pabyRec + 44 + 4 * t_nParts + 8 + k * 16);
+          SwapWord(8, pabyRec + 44 + 4 * t_nParts + 8 + k * 16 + 8);
         }
 
         k++;
       }
     }
 
-    nRecordSize = 44 + 4*t_nParts + 16 * t_nPoints;
+    nRecordSize = 44 + 4 * t_nParts + 16 * t_nPoints;
 
     /* -------------------------------------------------------------------- */
     /*      measured shape : polygon and arc.                               */
     /* -------------------------------------------------------------------- */
-    if(psSHP->nShapeType == SHP_POLYGONM || psSHP->nShapeType == SHP_ARCM) {
+    if (psSHP->nShapeType == SHP_POLYGONM || psSHP->nShapeType == SHP_ARCM) {
       const double dfMMin = shape->line[0].point[0].m;
-      const double dfMMax = shape->line[shape->numlines-1].point[shape->line[shape->numlines-1].numpoints-1].m;
-
-      nRecordSize = 44 + 4*t_nParts + 8 + (t_nPoints* 16);
-
-      ByteCopy( &(dfMMin), pabyRec + nRecordSize, 8 );
-      if( bBigEndian ) SwapWord( 8, pabyRec + nRecordSize );
+      const double dfMMax =
+          shape->line[shape->numlines - 1]
+              .point[shape->line[shape->numlines - 1].numpoints - 1]
+              .m;
+
+      nRecordSize = 44 + 4 * t_nParts + 8 + (t_nPoints * 16);
+
+      ByteCopy(&(dfMMin), pabyRec + nRecordSize, 8);
+      if (bBigEndian)
+        SwapWord(8, pabyRec + nRecordSize);
       nRecordSize += 8;
 
-      ByteCopy( &(dfMMax), pabyRec + nRecordSize, 8 );
-      if( bBigEndian ) SwapWord( 8, pabyRec + nRecordSize );
+      ByteCopy(&(dfMMax), pabyRec + nRecordSize, 8);
+      if (bBigEndian)
+        SwapWord(8, pabyRec + nRecordSize);
       nRecordSize += 8;
 
-      for( i = 0; i < shape->numlines; i++ ) {
-        for( j = 0; j < shape->line[i].numpoints; j++ ) {
-          ByteCopy( &(shape->line[i].point[j].m), pabyRec + nRecordSize, 8 );
-          if( bBigEndian ) SwapWord( 8, pabyRec + nRecordSize );
+      for (i = 0; i < shape->numlines; i++) {
+        for (j = 0; j < shape->line[i].numpoints; j++) {
+          ByteCopy(&(shape->line[i].point[j].m), pabyRec + nRecordSize, 8);
+          if (bBigEndian)
+            SwapWord(8, pabyRec + nRecordSize);
           nRecordSize += 8;
         }
       }
@@ -830,25 +875,31 @@ int msSHPWriteShape(SHPHandle psSHP, sha
     /* -------------------------------------------------------------------- */
     /*      Polygon. Arc with Z                                             */
     /* -------------------------------------------------------------------- */
-    if (psSHP->nShapeType == SHP_POLYGONZ || psSHP->nShapeType == SHP_ARCZ
-        || psSHP->nShapeType == SHP_POLYGONM || psSHP->nShapeType == SHP_ARCM) {
+    if (psSHP->nShapeType == SHP_POLYGONZ || psSHP->nShapeType == SHP_ARCZ ||
+        psSHP->nShapeType == SHP_POLYGONM || psSHP->nShapeType == SHP_ARCM) {
       const double dfMMin = shape->line[0].point[0].z;
-      const double dfMMax = shape->line[shape->numlines-1].point[shape->line[shape->numlines-1].numpoints-1].z;
-
-      nRecordSize = 44 + 4*t_nParts + 8 + (t_nPoints* 16);
-
-      ByteCopy( &(dfMMin), pabyRec + nRecordSize, 8 );
-      if( bBigEndian ) SwapWord( 8, pabyRec + nRecordSize );
+      const double dfMMax =
+          shape->line[shape->numlines - 1]
+              .point[shape->line[shape->numlines - 1].numpoints - 1]
+              .z;
+
+      nRecordSize = 44 + 4 * t_nParts + 8 + (t_nPoints * 16);
+
+      ByteCopy(&(dfMMin), pabyRec + nRecordSize, 8);
+      if (bBigEndian)
+        SwapWord(8, pabyRec + nRecordSize);
       nRecordSize += 8;
 
-      ByteCopy( &(dfMMax), pabyRec + nRecordSize, 8 );
-      if( bBigEndian ) SwapWord( 8, pabyRec + nRecordSize );
+      ByteCopy(&(dfMMax), pabyRec + nRecordSize, 8);
+      if (bBigEndian)
+        SwapWord(8, pabyRec + nRecordSize);
       nRecordSize += 8;
 
-      for( i = 0; i < shape->numlines; i++ ) {
-        for( j = 0; j < shape->line[i].numpoints; j++ ) {
-          ByteCopy( &(shape->line[i].point[j].z), pabyRec + nRecordSize, 8 );
-          if( bBigEndian ) SwapWord( 8, pabyRec + nRecordSize );
+      for (i = 0; i < shape->numlines; i++) {
+        for (j = 0; j < shape->line[i].numpoints; j++) {
+          ByteCopy(&(shape->line[i].point[j].z), pabyRec + nRecordSize, 8);
+          if (bBigEndian)
+            SwapWord(8, pabyRec + nRecordSize);
           nRecordSize += 8;
         }
       }
@@ -858,25 +909,26 @@ int msSHPWriteShape(SHPHandle psSHP, sha
   /* -------------------------------------------------------------------- */
   /*  Write vertices for a MultiPoint.                                    */
   /* -------------------------------------------------------------------- */
-  else if( psSHP->nShapeType == SHP_MULTIPOINT ||
+  else if (psSHP->nShapeType == SHP_MULTIPOINT ||
            psSHP->nShapeType == SHP_MULTIPOINTM ||
            psSHP->nShapeType == SHP_MULTIPOINTZ) {
     ms_int32 t_nPoints;
 
     t_nPoints = nPoints;
 
-    writeBounds( pabyRec + 12, shape, nPoints );
+    writeBounds(pabyRec + 12, shape, nPoints);
 
-    if( bBigEndian ) nPoints = SWAP_FOUR_BYTES(nPoints);
-    ByteCopy( &nPoints, pabyRec + 44, 4 );
+    if (bBigEndian)
+      nPoints = SWAP_FOUR_BYTES(nPoints);
+    ByteCopy(&nPoints, pabyRec + 44, 4);
 
-    for( i = 0; i < shape->line[0].numpoints; i++ ) {
-      ByteCopy( &(shape->line[0].point[i].x), pabyRec + 48 + i*16, 8 );
-      ByteCopy( &(shape->line[0].point[i].y), pabyRec + 48 + i*16 + 8, 8 );
-
-      if( bBigEndian ) {
-        SwapWord( 8, pabyRec + 48 + i*16 );
-        SwapWord( 8, pabyRec + 48 + i*16 + 8 );
+    for (i = 0; i < shape->line[0].numpoints; i++) {
+      ByteCopy(&(shape->line[0].point[i].x), pabyRec + 48 + i * 16, 8);
+      ByteCopy(&(shape->line[0].point[i].y), pabyRec + 48 + i * 16 + 8, 8);
+
+      if (bBigEndian) {
+        SwapWord(8, pabyRec + 48 + i * 16);
+        SwapWord(8, pabyRec + 48 + i * 16 + 8);
       }
     }
 
@@ -884,38 +936,46 @@ int msSHPWriteShape(SHPHandle psSHP, sha
 
     if (psSHP->nShapeType == SHP_MULTIPOINTM) {
       const double dfMMin = shape->line[0].point[0].m;
-      const double dfMMax = shape->line[0].point[shape->line[0].numpoints-1].m;
+      const double dfMMax =
+          shape->line[0].point[shape->line[0].numpoints - 1].m;
 
-      ByteCopy( &(dfMMin), pabyRec + nRecordSize, 8 );
-      if( bBigEndian ) SwapWord( 8, pabyRec + nRecordSize );
+      ByteCopy(&(dfMMin), pabyRec + nRecordSize, 8);
+      if (bBigEndian)
+        SwapWord(8, pabyRec + nRecordSize);
       nRecordSize += 8;
 
-      ByteCopy( &(dfMMax), pabyRec + nRecordSize, 8 );
-      if( bBigEndian ) SwapWord( 8, pabyRec + nRecordSize );
+      ByteCopy(&(dfMMax), pabyRec + nRecordSize, 8);
+      if (bBigEndian)
+        SwapWord(8, pabyRec + nRecordSize);
       nRecordSize += 8;
 
-      for( i = 0; i < shape->line[0].numpoints; i++ ) {
-        ByteCopy( &(shape->line[0].point[i].m), pabyRec + nRecordSize, 8 );
-        if( bBigEndian ) SwapWord( 8, pabyRec + nRecordSize );
+      for (i = 0; i < shape->line[0].numpoints; i++) {
+        ByteCopy(&(shape->line[0].point[i].m), pabyRec + nRecordSize, 8);
+        if (bBigEndian)
+          SwapWord(8, pabyRec + nRecordSize);
         nRecordSize += 8;
       }
     }
 
     if (psSHP->nShapeType == SHP_MULTIPOINTZ) {
       const double dfMMin = shape->line[0].point[0].z;
-      const double dfMMax = shape->line[0].point[shape->line[0].numpoints-1].z;
+      const double dfMMax =
+          shape->line[0].point[shape->line[0].numpoints - 1].z;
 
-      ByteCopy( &(dfMMin), pabyRec + nRecordSize, 8 );
-      if( bBigEndian ) SwapWord( 8, pabyRec + nRecordSize );
+      ByteCopy(&(dfMMin), pabyRec + nRecordSize, 8);
+      if (bBigEndian)
+        SwapWord(8, pabyRec + nRecordSize);
       nRecordSize += 8;
 
-      ByteCopy( &(dfMMax), pabyRec + nRecordSize, 8 );
-      if( bBigEndian ) SwapWord( 8, pabyRec + nRecordSize );
+      ByteCopy(&(dfMMax), pabyRec + nRecordSize, 8);
+      if (bBigEndian)
+        SwapWord(8, pabyRec + nRecordSize);
       nRecordSize += 8;
 
-      for( i = 0; i < shape->line[0].numpoints; i++ ) {
-        ByteCopy( &(shape->line[0].point[i].z), pabyRec + nRecordSize, 8 );
-        if( bBigEndian ) SwapWord( 8, pabyRec + nRecordSize );
+      for (i = 0; i < shape->line[0].numpoints; i++) {
+        ByteCopy(&(shape->line[0].point[i].z), pabyRec + nRecordSize, 8);
+        if (bBigEndian)
+          SwapWord(8, pabyRec + nRecordSize);
         nRecordSize += 8;
       }
     }
@@ -924,27 +984,29 @@ int msSHPWriteShape(SHPHandle psSHP, sha
   /* -------------------------------------------------------------------- */
   /*      Write vertices for a point.                                     */
   /* -------------------------------------------------------------------- */
-  else if( psSHP->nShapeType == SHP_POINT ||  psSHP->nShapeType == SHP_POINTM ||
+  else if (psSHP->nShapeType == SHP_POINT || psSHP->nShapeType == SHP_POINTM ||
            psSHP->nShapeType == SHP_POINTZ) {
-    ByteCopy( &(shape->line[0].point[0].x), pabyRec + 12, 8 );
-    ByteCopy( &(shape->line[0].point[0].y), pabyRec + 20, 8 );
+    ByteCopy(&(shape->line[0].point[0].x), pabyRec + 12, 8);
+    ByteCopy(&(shape->line[0].point[0].y), pabyRec + 20, 8);
 
-    if( bBigEndian ) {
-      SwapWord( 8, pabyRec + 12 );
-      SwapWord( 8, pabyRec + 20 );
+    if (bBigEndian) {
+      SwapWord(8, pabyRec + 12);
+      SwapWord(8, pabyRec + 20);
     }
 
     nRecordSize = 20;
 
     if (psSHP->nShapeType == SHP_POINTM) {
-      ByteCopy( &(shape->line[0].point[0].m), pabyRec + nRecordSize, 8 );
-      if( bBigEndian ) SwapWord( 8, pabyRec + nRecordSize );
+      ByteCopy(&(shape->line[0].point[0].m), pabyRec + nRecordSize, 8);
+      if (bBigEndian)
+        SwapWord(8, pabyRec + nRecordSize);
       nRecordSize += 8;
     }
 
     if (psSHP->nShapeType == SHP_POINTZ) {
-      ByteCopy( &(shape->line[0].point[0].z), pabyRec + nRecordSize, 8 );
-      if( bBigEndian ) SwapWord( 8, pabyRec + nRecordSize );
+      ByteCopy(&(shape->line[0].point[0].z), pabyRec + nRecordSize, 8);
+      if (bBigEndian)
+        SwapWord(8, pabyRec + nRecordSize);
       nRecordSize += 8;
     }
   }
@@ -952,69 +1014,82 @@ int msSHPWriteShape(SHPHandle psSHP, sha
   /* -------------------------------------------------------------------- */
   /*      Set the shape type, record number, and record size.             */
   /* -------------------------------------------------------------------- */
-  i32 = psSHP->nRecords-1+1;          /* record # */
-  if( !bBigEndian ) i32 = SWAP_FOUR_BYTES(i32);
-  ByteCopy( &i32, pabyRec, 4 );
-
-  i32 = nRecordSize/2;        /* record size */
-  if( !bBigEndian ) i32 = SWAP_FOUR_BYTES(i32);
-  ByteCopy( &i32, pabyRec + 4, 4 );
-
-  i32 = nShapeType;     /* shape type */
-  if( bBigEndian ) i32 = SWAP_FOUR_BYTES(i32);
-  ByteCopy( &i32, pabyRec + 8, 4 );
+  i32 = psSHP->nRecords - 1 + 1; /* record # */
+  if (!bBigEndian)
+    i32 = SWAP_FOUR_BYTES(i32);
+  ByteCopy(&i32, pabyRec, 4);
+
+  i32 = nRecordSize / 2; /* record size */
+  if (!bBigEndian)
+    i32 = SWAP_FOUR_BYTES(i32);
+  ByteCopy(&i32, pabyRec + 4, 4);
+
+  i32 = nShapeType; /* shape type */
+  if (bBigEndian)
+    i32 = SWAP_FOUR_BYTES(i32);
+  ByteCopy(&i32, pabyRec + 8, 4);
 
   /* -------------------------------------------------------------------- */
   /*      Write out record.                                               */
   /* -------------------------------------------------------------------- */
-  if(VSIFSeekL( psSHP->fpSHP, nRecordOffset, 0 ) == 0) {
-    VSIFWriteL( pabyRec, nRecordSize+8, 1, psSHP->fpSHP );
+  if (VSIFSeekL(psSHP->fpSHP, nRecordOffset, 0) == 0) {
+    VSIFWriteL(pabyRec, nRecordSize + 8, 1, psSHP->fpSHP);
 
-    psSHP->panRecSize[psSHP->nRecords-1] = nRecordSize;
+    psSHP->panRecSize[psSHP->nRecords - 1] = nRecordSize;
     psSHP->nFileSize += nRecordSize + 8;
 
     /* -------------------------------------------------------------------- */
     /*  Expand file wide bounds based on this shape.        */
     /* -------------------------------------------------------------------- */
-    if( psSHP->nRecords == 1 ) {
+    if (psSHP->nRecords == 1) {
       psSHP->adBoundsMin[0] = psSHP->adBoundsMax[0] = shape->line[0].point[0].x;
       psSHP->adBoundsMin[1] = psSHP->adBoundsMax[1] = shape->line[0].point[0].y;
       psSHP->adBoundsMin[2] = psSHP->adBoundsMax[2] = shape->line[0].point[0].z;
       psSHP->adBoundsMin[3] = psSHP->adBoundsMax[3] = shape->line[0].point[0].m;
     }
 
-    for( i=0; i<shape->numlines; i++ ) {
-      for( j=0; j<shape->line[i].numpoints; j++ ) {
-        psSHP->adBoundsMin[0] = MS_MIN(psSHP->adBoundsMin[0], shape->line[i].point[j].x);
-        psSHP->adBoundsMin[1] = MS_MIN(psSHP->adBoundsMin[1], shape->line[i].point[j].y);
-        psSHP->adBoundsMin[2] = MS_MIN(psSHP->adBoundsMin[2], shape->line[i].point[j].z);
-        psSHP->adBoundsMin[3] = MS_MIN(psSHP->adBoundsMin[3], shape->line[i].point[j].m);
-        psSHP->adBoundsMax[0] = MS_MAX(psSHP->adBoundsMax[0], shape->line[i].point[j].x);
-        psSHP->adBoundsMax[1] = MS_MAX(psSHP->adBoundsMax[1], shape->line[i].point[j].y);
-        psSHP->adBoundsMax[2] = MS_MAX(psSHP->adBoundsMax[2], shape->line[i].point[j].z);
-        psSHP->adBoundsMax[3] = MS_MAX(psSHP->adBoundsMax[3], shape->line[i].point[j].m);
+    for (i = 0; i < shape->numlines; i++) {
+      for (j = 0; j < shape->line[i].numpoints; j++) {
+        psSHP->adBoundsMin[0] =
+            MS_MIN(psSHP->adBoundsMin[0], shape->line[i].point[j].x);
+        psSHP->adBoundsMin[1] =
+            MS_MIN(psSHP->adBoundsMin[1], shape->line[i].point[j].y);
+        psSHP->adBoundsMin[2] =
+            MS_MIN(psSHP->adBoundsMin[2], shape->line[i].point[j].z);
+        psSHP->adBoundsMin[3] =
+            MS_MIN(psSHP->adBoundsMin[3], shape->line[i].point[j].m);
+        psSHP->adBoundsMax[0] =
+            MS_MAX(psSHP->adBoundsMax[0], shape->line[i].point[j].x);
+        psSHP->adBoundsMax[1] =
+            MS_MAX(psSHP->adBoundsMax[1], shape->line[i].point[j].y);
+        psSHP->adBoundsMax[2] =
+            MS_MAX(psSHP->adBoundsMax[2], shape->line[i].point[j].z);
+        psSHP->adBoundsMax[3] =
+            MS_MAX(psSHP->adBoundsMax[3], shape->line[i].point[j].m);
       }
     }
 
   } else {
-    psSHP->nRecords --;
+    psSHP->nRecords--;
     /* there was an error writing the record */
   }
-  free( pabyRec );
-  return( psSHP->nRecords - 1 );
+  free(pabyRec);
+  return (psSHP->nRecords - 1);
 }
 
 /*
  ** msSHPReadAllocateBuffer() - Ensure our record buffer is large enough.
  */
-static uchar *msSHPReadAllocateBuffer( SHPHandle psSHP, int hEntity, const char* pszCallingFunction)
-{
+static uchar *msSHPReadAllocateBuffer(SHPHandle psSHP, int hEntity,
+                                      const char *pszCallingFunction) {
 
   int nEntitySize = msSHXReadSize(psSHP, hEntity);
-  if( nEntitySize <= 0 || nEntitySize > INT_MAX - 8 ) {
-      msSetError(MS_MEMERR, "Out of memory. Cannot allocate %d bytes. Probably broken shapefile at feature %d",
-                 pszCallingFunction, nEntitySize, hEntity);
-      return NULL;
+  if (nEntitySize <= 0 || nEntitySize > INT_MAX - 8) {
+    msSetError(MS_MEMERR,
+               "Out of memory. Cannot allocate %d bytes. Probably broken "
+               "shapefile at feature %d",
+               pszCallingFunction, nEntitySize, hEntity);
+    return NULL;
   }
   nEntitySize += 8;
   /* -------------------------------------------------------------------- */
@@ -1029,10 +1104,12 @@ static uchar *msSHPReadAllocateBuffer( S
   psSHP->nBufSize = 0;
 #endif
 
-  if( nEntitySize > psSHP->nBufSize ) {
-    uchar* pabyRec = (uchar *) SfRealloc(psSHP->pabyRec,nEntitySize);
+  if (nEntitySize > psSHP->nBufSize) {
+    uchar *pabyRec = (uchar *)SfRealloc(psSHP->pabyRec, nEntitySize);
     if (pabyRec == NULL) {
-      msSetError(MS_MEMERR, "Out of memory. Cannot allocate %d bytes. Probably broken shapefile at feature %d",
+      msSetError(MS_MEMERR,
+                 "Out of memory. Cannot allocate %d bytes. Probably broken "
+                 "shapefile at feature %d",
                  pszCallingFunction, nEntitySize, hEntity);
       return NULL;
     }
@@ -1045,35 +1122,36 @@ static uchar *msSHPReadAllocateBuffer( S
 /*
 ** msSHPReadPoint() - Reads a single point from a POINT shape file.
 */
-int msSHPReadPoint( SHPHandle psSHP, int hEntity, pointObj *point )
-{
+int msSHPReadPoint(SHPHandle psSHP, int hEntity, pointObj *point) {
   int nEntitySize;
 
   /* -------------------------------------------------------------------- */
   /*      Only valid for point shapefiles                                 */
   /* -------------------------------------------------------------------- */
-  if( psSHP->nShapeType != SHP_POINT ) {
-    msSetError(MS_SHPERR, "msSHPReadPoint only operates on point shapefiles.", "msSHPReadPoint()");
-    return(MS_FAILURE);
+  if (psSHP->nShapeType != SHP_POINT) {
+    msSetError(MS_SHPERR, "msSHPReadPoint only operates on point shapefiles.",
+               "msSHPReadPoint()");
+    return (MS_FAILURE);
   }
 
   /* -------------------------------------------------------------------- */
   /*      Validate the record/entity number.                              */
   /* -------------------------------------------------------------------- */
-  if( hEntity < 0 || hEntity >= psSHP->nRecords ) {
+  if (hEntity < 0 || hEntity >= psSHP->nRecords) {
     msSetError(MS_SHPERR, "Record index out of bounds.", "msSHPReadPoint()");
-    return(MS_FAILURE);
+    return (MS_FAILURE);
   }
 
-  nEntitySize = msSHXReadSize( psSHP, hEntity) + 8;
+  nEntitySize = msSHXReadSize(psSHP, hEntity) + 8;
 
-  if( nEntitySize == 12 ) {
+  if (nEntitySize == 12) {
     msSetError(MS_SHPERR, "NULL feature encountered.", "msSHPReadPoint()");
-    return(MS_FAILURE);
-  } else if ( nEntitySize < 28 ) {
-    msSetError(MS_SHPERR, "Corrupted feature encountered.  hEntity=%d, nEntitySize=%d", "msSHPReadPoint()",
-               hEntity, nEntitySize);
-    return(MS_FAILURE);
+    return (MS_FAILURE);
+  } else if (nEntitySize < 28) {
+    msSetError(MS_SHPERR,
+               "Corrupted feature encountered.  hEntity=%d, nEntitySize=%d",
+               "msSHPReadPoint()", hEntity, nEntitySize);
+    return (MS_FAILURE);
   }
 
   uchar *pabyRec = msSHPReadAllocateBuffer(psSHP, hEntity, "msSHPReadPoint()");
@@ -1084,26 +1162,25 @@ int msSHPReadPoint( SHPHandle psSHP, int
   /* -------------------------------------------------------------------- */
   /*      Read the record.                                                */
   /* -------------------------------------------------------------------- */
-  const int offset = msSHXReadOffset( psSHP, hEntity);
-  if( offset <= 0 || 0 != VSIFSeekL( psSHP->fpSHP, offset, 0 )) {
+  const int offset = msSHXReadOffset(psSHP, hEntity);
+  if (offset <= 0 || 0 != VSIFSeekL(psSHP->fpSHP, offset, 0)) {
     msSetError(MS_IOERR, "failed to seek offset", "msSHPReadPoint()");
-    return(MS_FAILURE);
+    return (MS_FAILURE);
   }
-  if( 1 != VSIFReadL( pabyRec, nEntitySize, 1, psSHP->fpSHP )) {
+  if (1 != VSIFReadL(pabyRec, nEntitySize, 1, psSHP->fpSHP)) {
     msSetError(MS_IOERR, "failed to fread record", "msSHPReadPoint()");
-    return(MS_FAILURE);
+    return (MS_FAILURE);
   }
 
+  memcpy(&(point->x), pabyRec + 12, 8);
+  memcpy(&(point->y), pabyRec + 20, 8);
 
-  memcpy( &(point->x), pabyRec + 12, 8 );
-  memcpy( &(point->y), pabyRec + 20, 8 );
-
-  if( bBigEndian ) {
-    SwapWord( 8, &(point->x));
-    SwapWord( 8, &(point->y));
+  if (bBigEndian) {
+    SwapWord(8, &(point->x));
+    SwapWord(8, &(point->y));
   }
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
 /*
@@ -1114,22 +1191,23 @@ int msSHPReadPoint( SHPHandle psSHP, int
 ** successive accesses during the reading cycle (first bounds are read,
 ** then entire shapes). Each time we read a page, we mark it as read.
 */
-static bool msSHXLoadPage( SHPHandle psSHP, int shxBufferPage )
-{
+static bool msSHXLoadPage(SHPHandle psSHP, int shxBufferPage) {
   int i;
 
   /* Each SHX record is 8 bytes long (two ints), hence our buffer size. */
   char buffer[SHX_BUFFER_PAGE * 8];
 
   /*  Validate the page number. */
-  if( shxBufferPage < 0  )
-    return(MS_FAILURE);
+  if (shxBufferPage < 0)
+    return (MS_FAILURE);
 
   const int nShapesToCache =
-      shxBufferPage < psSHP->nRecords / SHX_BUFFER_PAGE ? SHX_BUFFER_PAGE :
-      psSHP->nRecords - shxBufferPage * SHX_BUFFER_PAGE;
+      shxBufferPage < psSHP->nRecords / SHX_BUFFER_PAGE
+          ? SHX_BUFFER_PAGE
+          : psSHP->nRecords - shxBufferPage * SHX_BUFFER_PAGE;
 
-  if( 0 != VSIFSeekL( psSHP->fpSHX, 100 + shxBufferPage * SHX_BUFFER_PAGE * 8, 0 )) {
+  if (0 !=
+      VSIFSeekL(psSHP->fpSHX, 100 + shxBufferPage * SHX_BUFFER_PAGE * 8, 0)) {
     memset(psSHP->panRecOffset + shxBufferPage * SHX_BUFFER_PAGE, 0,
            nShapesToCache * sizeof(psSHP->panRecOffset[0]));
     memset(psSHP->panRecSize + shxBufferPage * SHX_BUFFER_PAGE, 0,
@@ -1139,7 +1217,8 @@ static bool msSHXLoadPage( SHPHandle psS
     return false;
   }
 
-  if( (size_t)nShapesToCache != VSIFReadL( buffer, 8, nShapesToCache, psSHP->fpSHX )) {
+  if ((size_t)nShapesToCache !=
+      VSIFReadL(buffer, 8, nShapesToCache, psSHP->fpSHX)) {
     memset(psSHP->panRecOffset + shxBufferPage * SHX_BUFFER_PAGE, 0,
            nShapesToCache * sizeof(psSHP->panRecOffset[0]));
     memset(psSHP->panRecSize + shxBufferPage * SHX_BUFFER_PAGE, 0,
@@ -1150,30 +1229,30 @@ static bool msSHXLoadPage( SHPHandle psS
   }
 
   /* Copy the buffer contents out into the working arrays. */
-  for( i = 0; i < nShapesToCache; i++ ) {
+  for (i = 0; i < nShapesToCache; i++) {
     int tmpOffset, tmpSize;
 
-    memcpy( &tmpOffset, (buffer + (8*i)), 4);
-    memcpy( &tmpSize, (buffer + (8*i) + 4), 4);
+    memcpy(&tmpOffset, (buffer + (8 * i)), 4);
+    memcpy(&tmpSize, (buffer + (8 * i) + 4), 4);
 
     /* SHX uses big endian numbers for the offsets, so we have to flip them */
     /* if we are a little endian machine. */
-    if( !bBigEndian ) {
+    if (!bBigEndian) {
       tmpOffset = SWAP_FOUR_BYTES(tmpOffset);
       tmpSize = SWAP_FOUR_BYTES(tmpSize);
     }
 
     /* SHX stores the offsets in 2 byte units, so we double them to get */
     /* an offset in bytes. */
-    if( tmpOffset > 0 && tmpOffset < INT_MAX / 2 )
-        tmpOffset = tmpOffset * 2;
+    if (tmpOffset > 0 && tmpOffset < INT_MAX / 2)
+      tmpOffset = tmpOffset * 2;
     else
-        tmpOffset = 0;
+      tmpOffset = 0;
 
-    if( tmpSize > 0 && tmpSize < INT_MAX / 2 )
-        tmpSize = tmpSize * 2;
+    if (tmpSize > 0 && tmpSize < INT_MAX / 2)
+      tmpSize = tmpSize * 2;
     else
-        tmpSize = 0;
+      tmpSize = 0;
 
     /* Write the answer into the working arrays on the SHPHandle */
     psSHP->panRecOffset[shxBufferPage * SHX_BUFFER_PAGE + i] = tmpOffset;
@@ -1182,48 +1261,48 @@ static bool msSHXLoadPage( SHPHandle psS
 
   msSetBit(psSHP->panRecLoaded, shxBufferPage, 1);
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
-static int msSHXLoadAll( SHPHandle psSHP )
-{
+static int msSHXLoadAll(SHPHandle psSHP) {
 
   int i;
   uchar *pabyBuf;
 
-  pabyBuf = (uchar *) malloc(8 * psSHP->nRecords );
-  if( pabyBuf == NULL )
-  {
-    msSetError(MS_IOERR, "failed to allocate memory for SHX buffer", "msSHXLoadAll()");
+  pabyBuf = (uchar *)malloc(8 * psSHP->nRecords);
+  if (pabyBuf == NULL) {
+    msSetError(MS_IOERR, "failed to allocate memory for SHX buffer",
+               "msSHXLoadAll()");
     return MS_FAILURE;
   }
-  if((size_t)psSHP->nRecords != VSIFReadL( pabyBuf, 8, psSHP->nRecords, psSHP->fpSHX )) {
+  if ((size_t)psSHP->nRecords !=
+      VSIFReadL(pabyBuf, 8, psSHP->nRecords, psSHP->fpSHX)) {
     msSetError(MS_IOERR, "failed to read shx records", "msSHXLoadAll()");
     free(pabyBuf);
     return MS_FAILURE;
   }
-  for( i = 0; i < psSHP->nRecords; i++ ) {
+  for (i = 0; i < psSHP->nRecords; i++) {
     ms_int32 nOffset, nLength;
 
-    memcpy( &nOffset, pabyBuf + i * 8, 4 );
-    memcpy( &nLength, pabyBuf + i * 8 + 4, 4 );
+    memcpy(&nOffset, pabyBuf + i * 8, 4);
+    memcpy(&nLength, pabyBuf + i * 8 + 4, 4);
 
-    if( !bBigEndian ) {
-      nOffset = SWAP_FOUR_BYTES( nOffset );
-      nLength = SWAP_FOUR_BYTES( nLength );
+    if (!bBigEndian) {
+      nOffset = SWAP_FOUR_BYTES(nOffset);
+      nLength = SWAP_FOUR_BYTES(nLength);
     }
 
     /* SHX stores the offsets in 2 byte units, so we double them to get */
     /* an offset in bytes. */
-    if( nOffset > 0 && nOffset < INT_MAX / 2 )
-        nOffset = nOffset * 2;
+    if (nOffset > 0 && nOffset < INT_MAX / 2)
+      nOffset = nOffset * 2;
     else
-        nOffset = 0;
+      nOffset = 0;
 
-    if( nLength > 0 && nLength < INT_MAX / 2 )
-        nLength = nLength * 2;
+    if (nLength > 0 && nLength < INT_MAX / 2)
+      nLength = nLength * 2;
     else
-        nLength = 0;
+      nLength = 0;
 
     psSHP->panRecOffset[i] = nOffset;
     psSHP->panRecSize[i] = nLength;
@@ -1231,64 +1310,59 @@ static int msSHXLoadAll( SHPHandle psSHP
   free(pabyBuf);
   psSHP->panRecAllLoaded = 1;
 
-  return(MS_SUCCESS);
-
+  return (MS_SUCCESS);
 }
 
-static int msSHXReadOffset( SHPHandle psSHP, int hEntity )
-{
+static int msSHXReadOffset(SHPHandle psSHP, int hEntity) {
 
   int shxBufferPage = hEntity / SHX_BUFFER_PAGE;
 
   /*  Validate the record/entity number. */
-  if( hEntity < 0 || hEntity >= psSHP->nRecords )
+  if (hEntity < 0 || hEntity >= psSHP->nRecords)
     return 0;
 
-  if( ! (psSHP->panRecAllLoaded || msGetBit(psSHP->panRecLoaded, shxBufferPage)) ) {
-    msSHXLoadPage( psSHP, shxBufferPage );
+  if (!(psSHP->panRecAllLoaded ||
+        msGetBit(psSHP->panRecLoaded, shxBufferPage))) {
+    msSHXLoadPage(psSHP, shxBufferPage);
   }
 
   return psSHP->panRecOffset[hEntity];
-
 }
 
-static int msSHXReadSize( SHPHandle psSHP, int hEntity )
-{
+static int msSHXReadSize(SHPHandle psSHP, int hEntity) {
 
   int shxBufferPage = hEntity / SHX_BUFFER_PAGE;
 
   /*  Validate the record/entity number. */
-  if( hEntity < 0 || hEntity >= psSHP->nRecords )
+  if (hEntity < 0 || hEntity >= psSHP->nRecords)
     return 0;
 
-  if( ! (psSHP->panRecAllLoaded || msGetBit(psSHP->panRecLoaded, shxBufferPage)) ) {
-    msSHXLoadPage( psSHP, shxBufferPage );
+  if (!(psSHP->panRecAllLoaded ||
+        msGetBit(psSHP->panRecLoaded, shxBufferPage))) {
+    msSHXLoadPage(psSHP, shxBufferPage);
   }
 
   return psSHP->panRecSize[hEntity];
-
 }
 
-static void ReadRect(rectObj *r, const uchar *src)
-{
-    memcpy( &r->minx, src, 8 );
-    memcpy( &r->miny, src + 8, 8 );
-    memcpy( &r->maxx, src + 16, 8 );
-    memcpy( &r->maxy, src + 24, 8 );
-
-    if( bBigEndian ) {
-      SwapWord( 8, &r->minx);
-      SwapWord( 8, &r->miny);
-      SwapWord( 8, &r->maxx);
-      SwapWord( 8, &r->maxy);
-    }
+static void ReadRect(rectObj *r, const uchar *src) {
+  memcpy(&r->minx, src, 8);
+  memcpy(&r->miny, src + 8, 8);
+  memcpy(&r->maxx, src + 16, 8);
+  memcpy(&r->maxy, src + 24, 8);
+
+  if (bBigEndian) {
+    SwapWord(8, &r->minx);
+    SwapWord(8, &r->miny);
+    SwapWord(8, &r->maxx);
+    SwapWord(8, &r->maxy);
+  }
 }
 
 /*
 ** msSHPReadShape() - Reads the vertices for one shape from a shape file.
 */
-void msSHPReadShape( SHPHandle psSHP, int hEntity, shapeObj *shape )
-{
+void msSHPReadShape(SHPHandle psSHP, int hEntity, shapeObj *shape) {
   int i, j, k;
   int nEntitySize, nRequiredSize;
 
@@ -1297,20 +1371,20 @@ void msSHPReadShape( SHPHandle psSHP, in
   /* -------------------------------------------------------------------- */
   /*      Validate the record/entity number.                              */
   /* -------------------------------------------------------------------- */
-  if( hEntity < 0 || hEntity >= psSHP->nRecords )
+  if (hEntity < 0 || hEntity >= psSHP->nRecords)
     return;
 
   nEntitySize = msSHXReadSize(psSHP, hEntity);
-  if( nEntitySize < 4 || nEntitySize > INT_MAX - 8 )
-  {
-      shape->type = MS_SHAPE_NULL;
-      msSetError(MS_SHPERR, "Corrupted feature encountered.  hEntity = %d, nEntitySize=%d", "msSHPReadShape()",
-                 hEntity, nEntitySize);
-      return;
+  if (nEntitySize < 4 || nEntitySize > INT_MAX - 8) {
+    shape->type = MS_SHAPE_NULL;
+    msSetError(MS_SHPERR,
+               "Corrupted feature encountered.  hEntity = %d, nEntitySize=%d",
+               "msSHPReadShape()", hEntity, nEntitySize);
+    return;
   }
 
   nEntitySize += 8;
-  if( nEntitySize == 12 ) {
+  if (nEntitySize == 12) {
     shape->type = MS_SHAPE_NULL;
     return;
   }
@@ -1324,13 +1398,13 @@ void msSHPReadShape( SHPHandle psSHP, in
   /* -------------------------------------------------------------------- */
   /*      Read the record.                                                */
   /* -------------------------------------------------------------------- */
-  const int offset = msSHXReadOffset( psSHP, hEntity);
-  if( offset <= 0 || 0 != VSIFSeekL( psSHP->fpSHP, offset, 0 )) {
+  const int offset = msSHXReadOffset(psSHP, hEntity);
+  if (offset <= 0 || 0 != VSIFSeekL(psSHP->fpSHP, offset, 0)) {
     msSetError(MS_IOERR, "failed to seek offset", "msSHPReadShape()");
     shape->type = MS_SHAPE_NULL;
     return;
   }
-  if( 1 != VSIFReadL( pabyRec, nEntitySize, 1, psSHP->fpSHP )) {
+  if (1 != VSIFReadL(pabyRec, nEntitySize, 1, psSHP->fpSHP)) {
     msSetError(MS_IOERR, "failed to fread record", "msSHPReadPoint()");
     shape->type = MS_SHAPE_NULL;
     return;
@@ -1339,34 +1413,37 @@ void msSHPReadShape( SHPHandle psSHP, in
   /* -------------------------------------------------------------------- */
   /*  Extract vertices for a Polygon or Arc.            */
   /* -------------------------------------------------------------------- */
-  if( psSHP->nShapeType == SHP_POLYGON || psSHP->nShapeType == SHP_ARC ||
+  if (psSHP->nShapeType == SHP_POLYGON || psSHP->nShapeType == SHP_ARC ||
       psSHP->nShapeType == SHP_POLYGONM || psSHP->nShapeType == SHP_ARCM ||
       psSHP->nShapeType == SHP_POLYGONZ || psSHP->nShapeType == SHP_ARCZ) {
-    ms_int32  nPoints, nParts;
+    ms_int32 nPoints, nParts;
 
     if (nEntitySize < 40 + 8 + 4) {
       shape->type = MS_SHAPE_NULL;
-      msSetError(MS_SHPERR, "Corrupted feature encountered.  hEntity = %d, nEntitySize=%d", "msSHPReadShape()",
-                 hEntity, nEntitySize);
+      msSetError(MS_SHPERR,
+                 "Corrupted feature encountered.  hEntity = %d, nEntitySize=%d",
+                 "msSHPReadShape()", hEntity, nEntitySize);
       return;
     }
 
     /* copy the bounding box */
     ReadRect(&shape->bounds, pabyRec + 8 + 4);
 
-    memcpy( &nPoints, pabyRec + 40 + 8, 4 );
-    memcpy( &nParts, pabyRec + 36 + 8, 4 );
+    memcpy(&nPoints, pabyRec + 40 + 8, 4);
+    memcpy(&nParts, pabyRec + 36 + 8, 4);
 
-    if( bBigEndian ) {
+    if (bBigEndian) {
       nPoints = SWAP_FOUR_BYTES(nPoints);
       nParts = SWAP_FOUR_BYTES(nParts);
     }
 
-    if (nPoints < 0 || nParts < 0 ||
-        nPoints > 50 * 1000 * 1000 || nParts > 10 * 1000 * 1000) {
+    if (nPoints < 0 || nParts < 0 || nPoints > 50 * 1000 * 1000 ||
+        nParts > 10 * 1000 * 1000) {
       shape->type = MS_SHAPE_NULL;
-      msSetError(MS_SHPERR, "Corrupted feature encountered.  hEntity = %d, nPoints =%d, nParts = %d", "msSHPReadShape()",
-                 hEntity, nPoints, nParts);
+      msSetError(MS_SHPERR,
+                 "Corrupted feature encountered.  hEntity = %d, nPoints =%d, "
+                 "nParts = %d",
+                 "msSHPReadShape()", hEntity, nPoints, nParts);
       return;
     }
 
@@ -1382,14 +1459,16 @@ void msSHPReadShape( SHPHandle psSHP, in
     psSHP->nPartMax = 0;
 #endif
 
-    if( psSHP->nPartMax < nParts ) {
-      psSHP->panParts = (int *) SfRealloc(psSHP->panParts, nParts * sizeof(int) );
+    if (psSHP->nPartMax < nParts) {
+      psSHP->panParts = (int *)SfRealloc(psSHP->panParts, nParts * sizeof(int));
       if (psSHP->panParts == NULL) {
         /* Reallocate previous successfull size for following features */
-        psSHP->panParts = (int *) msSmallMalloc(psSHP->nPartMax * sizeof(int) );
+        psSHP->panParts = (int *)msSmallMalloc(psSHP->nPartMax * sizeof(int));
 
         shape->type = MS_SHAPE_NULL;
-        msSetError(MS_MEMERR, "Out of memory. Cannot allocate %d bytes. Probably broken shapefile at feature %d",
+        msSetError(MS_MEMERR,
+                   "Out of memory. Cannot allocate %d bytes. Probably broken "
+                   "shapefile at feature %d",
                    "msSHPReadShape()", (int)(nParts * sizeof(int)), hEntity);
         return;
       }
@@ -1406,38 +1485,37 @@ void msSHPReadShape( SHPHandle psSHP, in
     /* since 50 M * (16 + 8 + 8) = 1 600 MB */
     if (44 + 8 + 4 * nParts + 16 * nPoints > nEntitySize) {
       shape->type = MS_SHAPE_NULL;
-      msSetError(MS_SHPERR, "Corrupted .shp file : shape %d, nPoints=%d, nParts=%d.",
+      msSetError(MS_SHPERR,
+                 "Corrupted .shp file : shape %d, nPoints=%d, nParts=%d.",
                  "msSHPReadShape()", hEntity, nPoints, nParts);
       return;
     }
 
-    memcpy( psSHP->panParts, pabyRec + 44 + 8, 4 * nParts );
-    if( bBigEndian ) {
-      for( i = 0; i < nParts; i++ ) {
-        *(psSHP->panParts+i) = SWAP_FOUR_BYTES(*(psSHP->panParts+i));
+    memcpy(psSHP->panParts, pabyRec + 44 + 8, 4 * nParts);
+    if (bBigEndian) {
+      for (i = 0; i < nParts; i++) {
+        *(psSHP->panParts + i) = SWAP_FOUR_BYTES(*(psSHP->panParts + i));
       }
     }
 
     /* -------------------------------------------------------------------- */
     /*      Fill the shape structure.                                       */
     /* -------------------------------------------------------------------- */
-    shape->line = (lineObj *)malloc(sizeof(lineObj)*nParts);
-    MS_CHECK_ALLOC_NO_RET(shape->line, sizeof(lineObj)*nParts);
+    shape->line = (lineObj *)malloc(sizeof(lineObj) * nParts);
+    MS_CHECK_ALLOC_NO_RET(shape->line, sizeof(lineObj) * nParts);
 
     shape->numlines = nParts;
 
     k = 0; /* overall point counter */
-    for( i = 0; i < nParts; i++) {
-      const ms_int32 end = i == nParts - 1
-        ? nPoints
-        : psSHP->panParts[i+1];
+    for (i = 0; i < nParts; i++) {
+      const ms_int32 end = i == nParts - 1 ? nPoints : psSHP->panParts[i + 1];
       if (psSHP->panParts[i] < 0 || end < 0 || end > nPoints ||
           psSHP->panParts[i] >= end) {
-        msSetError(MS_SHPERR, "Corrupted .shp file : shape %d, shape->line[%d].start=%d, shape->line[%d].end=%d", "msSHPReadShape()",
-                   hEntity,
-                   i, psSHP->panParts[i],
-                   i, end);
-        while(--i >= 0)
+        msSetError(MS_SHPERR,
+                   "Corrupted .shp file : shape %d, shape->line[%d].start=%d, "
+                   "shape->line[%d].end=%d",
+                   "msSHPReadShape()", hEntity, i, psSHP->panParts[i], i, end);
+        while (--i >= 0)
           free(shape->line[i].point);
         free(shape->line);
         shape->line = NULL;
@@ -1447,8 +1525,9 @@ void msSHPReadShape( SHPHandle psSHP, in
       }
 
       shape->line[i].numpoints = end - psSHP->panParts[i];
-      if( (shape->line[i].point = (pointObj *)malloc(sizeof(pointObj)*shape->line[i].numpoints)) == NULL ) {
-        while(--i >= 0)
+      if ((shape->line[i].point = (pointObj *)malloc(
+               sizeof(pointObj) * shape->line[i].numpoints)) == NULL) {
+        while (--i >= 0)
           free(shape->line[i].point);
         free(shape->line);
         shape->line = NULL;
@@ -1459,45 +1538,56 @@ void msSHPReadShape( SHPHandle psSHP, in
       }
 
       /* nOffset = 44 + 8 + 4*nParts; */
-      for( j = 0; j < shape->line[i].numpoints; j++ ) {
-        memcpy(&(shape->line[i].point[j].x), pabyRec + 44 + 4*nParts + 8 + k * 16, 8 );
-        memcpy(&(shape->line[i].point[j].y), pabyRec + 44 + 4*nParts + 8 + k * 16 + 8, 8 );
-
-        if( bBigEndian ) {
-          SwapWord( 8, &(shape->line[i].point[j].x) );
-          SwapWord( 8, &(shape->line[i].point[j].y) );
+      for (j = 0; j < shape->line[i].numpoints; j++) {
+        memcpy(&(shape->line[i].point[j].x),
+               pabyRec + 44 + 4 * nParts + 8 + k * 16, 8);
+        memcpy(&(shape->line[i].point[j].y),
+               pabyRec + 44 + 4 * nParts + 8 + k * 16 + 8, 8);
+
+        if (bBigEndian) {
+          SwapWord(8, &(shape->line[i].point[j].x));
+          SwapWord(8, &(shape->line[i].point[j].y));
         }
 
-        /* -------------------------------------------------------------------- */
-        /*      Polygon, Arc with Z values.                                     */
-        /* -------------------------------------------------------------------- */
+        /* --------------------------------------------------------------------
+         */
+        /*      Polygon, Arc with Z values. */
+        /* --------------------------------------------------------------------
+         */
         shape->line[i].point[j].z = 0.0; /* initialize */
-        if (psSHP->nShapeType == SHP_POLYGONZ || psSHP->nShapeType == SHP_ARCZ) {
-          const int nOffset = 44 + 8 + (4*nParts) + (16*nPoints) ;
-          if( nEntitySize >= nOffset + 16 + 8*nPoints ) {
-            memcpy(&(shape->line[i].point[j].z), pabyRec + nOffset + 16 + k*8, 8 );
-            if( bBigEndian ) SwapWord( 8, &(shape->line[i].point[j].z) );
+        if (psSHP->nShapeType == SHP_POLYGONZ ||
+            psSHP->nShapeType == SHP_ARCZ) {
+          const int nOffset = 44 + 8 + (4 * nParts) + (16 * nPoints);
+          if (nEntitySize >= nOffset + 16 + 8 * nPoints) {
+            memcpy(&(shape->line[i].point[j].z), pabyRec + nOffset + 16 + k * 8,
+                   8);
+            if (bBigEndian)
+              SwapWord(8, &(shape->line[i].point[j].z));
           }
         }
 
-        /* -------------------------------------------------------------------- */
-        /*      Measured arc and polygon support.                               */
-        /* -------------------------------------------------------------------- */
+        /* --------------------------------------------------------------------
+         */
+        /*      Measured arc and polygon support. */
+        /* --------------------------------------------------------------------
+         */
         shape->line[i].point[j].m = 0; /* initialize */
-        if (psSHP->nShapeType == SHP_POLYGONM || psSHP->nShapeType == SHP_ARCM) {
-          const int nOffset = 44 + 8 + (4*nParts) + (16*nPoints) ;
-          if( nEntitySize >= nOffset + 16 + 8*nPoints ) {
-            memcpy(&(shape->line[i].point[j].m), pabyRec + nOffset + 16 + k*8, 8 );
-            if( bBigEndian ) SwapWord( 8, &(shape->line[i].point[j].m) );
+        if (psSHP->nShapeType == SHP_POLYGONM ||
+            psSHP->nShapeType == SHP_ARCM) {
+          const int nOffset = 44 + 8 + (4 * nParts) + (16 * nPoints);
+          if (nEntitySize >= nOffset + 16 + 8 * nPoints) {
+            memcpy(&(shape->line[i].point[j].m), pabyRec + nOffset + 16 + k * 8,
+                   8);
+            if (bBigEndian)
+              SwapWord(8, &(shape->line[i].point[j].m));
           }
         }
         k++;
       }
     }
 
-    if(psSHP->nShapeType == SHP_POLYGON
-        || psSHP->nShapeType == SHP_POLYGONZ
-        || psSHP->nShapeType == SHP_POLYGONM)
+    if (psSHP->nShapeType == SHP_POLYGON || psSHP->nShapeType == SHP_POLYGONZ ||
+        psSHP->nShapeType == SHP_POLYGONM)
       shape->type = MS_SHAPE_POLYGON;
     else
       shape->type = MS_SHAPE_LINE;
@@ -1507,27 +1597,30 @@ void msSHPReadShape( SHPHandle psSHP, in
   /* -------------------------------------------------------------------- */
   /*  Extract a MultiPoint.                                               */
   /* -------------------------------------------------------------------- */
-  else if( psSHP->nShapeType == SHP_MULTIPOINT || psSHP->nShapeType == SHP_MULTIPOINTM ||
+  else if (psSHP->nShapeType == SHP_MULTIPOINT ||
+           psSHP->nShapeType == SHP_MULTIPOINTM ||
            psSHP->nShapeType == SHP_MULTIPOINTZ) {
     ms_int32 nPoints;
 
     if (nEntitySize < 44 + 4) {
       shape->type = MS_SHAPE_NULL;
-      msSetError(MS_SHPERR, "Corrupted feature encountered.  recSize of feature %d=%d", "msSHPReadShape()",
-                 hEntity, msSHXReadSize(psSHP, hEntity));
+      msSetError(MS_SHPERR,
+                 "Corrupted feature encountered.  recSize of feature %d=%d",
+                 "msSHPReadShape()", hEntity, msSHXReadSize(psSHP, hEntity));
       return;
     }
 
     /* copy the bounding box */
     ReadRect(&shape->bounds, pabyRec + 8 + 4);
 
-    memcpy( &nPoints, pabyRec + 44, 4 );
-    if( bBigEndian ) nPoints = SWAP_FOUR_BYTES(nPoints);
+    memcpy(&nPoints, pabyRec + 44, 4);
+    if (bBigEndian)
+      nPoints = SWAP_FOUR_BYTES(nPoints);
 
     /* -------------------------------------------------------------------- */
     /*      Fill the shape structure.                                       */
     /* -------------------------------------------------------------------- */
-    if( (shape->line = (lineObj *)malloc(sizeof(lineObj))) == NULL ) {
+    if ((shape->line = (lineObj *)malloc(sizeof(lineObj))) == NULL) {
       shape->type = MS_SHAPE_NULL;
       msSetError(MS_MEMERR, "Out of memory", "msSHPReadShape()");
       return;
@@ -1544,21 +1637,24 @@ void msSHPReadShape( SHPHandle psSHP, in
     }
 
     nRequiredSize = 48 + nPoints * 16;
-    if (psSHP->nShapeType == SHP_MULTIPOINTZ || psSHP->nShapeType == SHP_MULTIPOINTM)
+    if (psSHP->nShapeType == SHP_MULTIPOINTZ ||
+        psSHP->nShapeType == SHP_MULTIPOINTM)
       nRequiredSize += 16 + nPoints * 8;
     if (nRequiredSize > nEntitySize) {
       free(shape->line);
       shape->line = NULL;
       shape->numlines = 0;
       shape->type = MS_SHAPE_NULL;
-      msSetError(MS_SHPERR, "Corrupted .shp file : shape %d : nPoints = %d, nEntitySize = %d",
-                 "msSHPReadShape()", hEntity, nPoints, nEntitySize);
+      msSetError(
+          MS_SHPERR,
+          "Corrupted .shp file : shape %d : nPoints = %d, nEntitySize = %d",
+          "msSHPReadShape()", hEntity, nPoints, nEntitySize);
       return;
     }
 
     shape->numlines = 1;
     shape->line[0].numpoints = nPoints;
-    shape->line[0].point = (pointObj *) malloc( nPoints * sizeof(pointObj) );
+    shape->line[0].point = (pointObj *)malloc(nPoints * sizeof(pointObj));
     if (shape->line[0].point == NULL) {
       free(shape->line);
       shape->line = NULL;
@@ -1568,13 +1664,13 @@ void msSHPReadShape( SHPHandle psSHP, in
       return;
     }
 
-    for( i = 0; i < nPoints; i++ ) {
-      memcpy(&(shape->line[0].point[i].x), pabyRec + 48 + 16 * i, 8 );
-      memcpy(&(shape->line[0].point[i].y), pabyRec + 48 + 16 * i + 8, 8 );
-
-      if( bBigEndian ) {
-        SwapWord( 8, &(shape->line[0].point[i].x) );
-        SwapWord( 8, &(shape->line[0].point[i].y) );
+    for (i = 0; i < nPoints; i++) {
+      memcpy(&(shape->line[0].point[i].x), pabyRec + 48 + 16 * i, 8);
+      memcpy(&(shape->line[0].point[i].y), pabyRec + 48 + 16 * i + 8, 8);
+
+      if (bBigEndian) {
+        SwapWord(8, &(shape->line[0].point[i].x));
+        SwapWord(8, &(shape->line[0].point[i].y));
       }
 
       /* -------------------------------------------------------------------- */
@@ -1582,9 +1678,10 @@ void msSHPReadShape( SHPHandle psSHP, in
       /* -------------------------------------------------------------------- */
       shape->line[0].point[i].z = 0; /* initialize */
       if (psSHP->nShapeType == SHP_MULTIPOINTZ) {
-        const int nOffset = 48 + 16*nPoints;
-        memcpy(&(shape->line[0].point[i].z), pabyRec + nOffset + 16 + i*8, 8 );
-        if( bBigEndian ) SwapWord( 8, &(shape->line[0].point[i].z));
+        const int nOffset = 48 + 16 * nPoints;
+        memcpy(&(shape->line[0].point[i].z), pabyRec + nOffset + 16 + i * 8, 8);
+        if (bBigEndian)
+          SwapWord(8, &(shape->line[0].point[i].z));
       }
 
       /* -------------------------------------------------------------------- */
@@ -1592,9 +1689,10 @@ void msSHPReadShape( SHPHandle psSHP, in
       /* -------------------------------------------------------------------- */
       shape->line[0].point[i].m = 0; /* initialize */
       if (psSHP->nShapeType == SHP_MULTIPOINTM) {
-        const int nOffset = 48 + 16*nPoints;
-        memcpy(&(shape->line[0].point[i].m), pabyRec + nOffset + 16 + i*8, 8 );
-        if( bBigEndian ) SwapWord( 8, &(shape->line[0].point[i].m));
+        const int nOffset = 48 + 16 * nPoints;
+        memcpy(&(shape->line[0].point[i].m), pabyRec + nOffset + 16 + i * 8, 8);
+        if (bBigEndian)
+          SwapWord(8, &(shape->line[0].point[i].m));
       }
     }
 
@@ -1604,13 +1702,14 @@ void msSHPReadShape( SHPHandle psSHP, in
   /* -------------------------------------------------------------------- */
   /*  Extract a Point.                            */
   /* -------------------------------------------------------------------- */
-  else if(psSHP->nShapeType == SHP_POINT ||  psSHP->nShapeType == SHP_POINTM ||
-          psSHP->nShapeType == SHP_POINTZ) {
+  else if (psSHP->nShapeType == SHP_POINT || psSHP->nShapeType == SHP_POINTM ||
+           psSHP->nShapeType == SHP_POINTZ) {
 
     if (nEntitySize < 20 + 8) {
       shape->type = MS_SHAPE_NULL;
-      msSetError(MS_SHPERR, "Corrupted feature encountered.  recSize of feature %d=%d", "msSHPReadShape()",
-                 hEntity, msSHXReadSize(psSHP, hEntity));
+      msSetError(MS_SHPERR,
+                 "Corrupted feature encountered.  recSize of feature %d=%d",
+                 "msSHPReadShape()", hEntity, msSHXReadSize(psSHP, hEntity));
       return;
     }
 
@@ -1622,14 +1721,14 @@ void msSHPReadShape( SHPHandle psSHP, in
 
     shape->numlines = 1;
     shape->line[0].numpoints = 1;
-    shape->line[0].point = (pointObj *) msSmallMalloc(sizeof(pointObj));
+    shape->line[0].point = (pointObj *)msSmallMalloc(sizeof(pointObj));
 
-    memcpy( &(shape->line[0].point[0].x), pabyRec + 12, 8 );
-    memcpy( &(shape->line[0].point[0].y), pabyRec + 20, 8 );
+    memcpy(&(shape->line[0].point[0].x), pabyRec + 12, 8);
+    memcpy(&(shape->line[0].point[0].y), pabyRec + 20, 8);
 
-    if( bBigEndian ) {
-      SwapWord( 8, &(shape->line[0].point[0].x));
-      SwapWord( 8, &(shape->line[0].point[0].y));
+    if (bBigEndian) {
+      SwapWord(8, &(shape->line[0].point[0].x));
+      SwapWord(8, &(shape->line[0].point[0].y));
     }
 
     /* -------------------------------------------------------------------- */
@@ -1638,9 +1737,10 @@ void msSHPReadShape( SHPHandle psSHP, in
     shape->line[0].point[0].z = 0; /* initialize */
     if (psSHP->nShapeType == SHP_POINTZ) {
       const int nOffset = 20 + 8;
-      if( nEntitySize >= nOffset + 8 ) {
-        memcpy(&(shape->line[0].point[0].z), pabyRec + nOffset, 8 );
-        if( bBigEndian ) SwapWord( 8, &(shape->line[0].point[0].z));
+      if (nEntitySize >= nOffset + 8) {
+        memcpy(&(shape->line[0].point[0].z), pabyRec + nOffset, 8);
+        if (bBigEndian)
+          SwapWord(8, &(shape->line[0].point[0].z));
       }
     }
 
@@ -1650,9 +1750,10 @@ void msSHPReadShape( SHPHandle psSHP, in
     shape->line[0].point[0].m = 0; /* initialize */
     if (psSHP->nShapeType == SHP_POINTM) {
       const int nOffset = 20 + 8;
-      if( nEntitySize >= nOffset + 8 ) {
-        memcpy(&(shape->line[0].point[0].m), pabyRec + nOffset, 8 );
-        if( bBigEndian ) SwapWord( 8, &(shape->line[0].point[0].m));
+      if (nEntitySize >= nOffset + 8) {
+        memcpy(&(shape->line[0].point[0].m), pabyRec + nOffset, 8);
+        if (bBigEndian)
+          SwapWord(8, &(shape->line[0].point[0].m));
       }
     }
 
@@ -1668,12 +1769,11 @@ void msSHPReadShape( SHPHandle psSHP, in
   return;
 }
 
-int msSHPReadBounds( SHPHandle psSHP, int hEntity, rectObj *padBounds)
-{
+int msSHPReadBounds(SHPHandle psSHP, int hEntity, rectObj *padBounds) {
   /* -------------------------------------------------------------------- */
   /*      Validate the record/entity number.                              */
   /* -------------------------------------------------------------------- */
-  if( psSHP->nRecords <= 0 || hEntity < -1 || hEntity >= psSHP->nRecords ) {
+  if (psSHP->nRecords <= 0 || hEntity < -1 || hEntity >= psSHP->nRecords) {
     padBounds->minx = padBounds->miny = padBounds->maxx = padBounds->maxy = 0.0;
     return MS_FAILURE;
   }
@@ -1681,39 +1781,43 @@ int msSHPReadBounds( SHPHandle psSHP, in
   /* -------------------------------------------------------------------- */
   /*  If the entity is -1 we fetch the bounds for the whole file.   */
   /* -------------------------------------------------------------------- */
-  if( hEntity == -1 ) {
+  if (hEntity == -1) {
     padBounds->minx = psSHP->adBoundsMin[0];
     padBounds->miny = psSHP->adBoundsMin[1];
     padBounds->maxx = psSHP->adBoundsMax[0];
     padBounds->maxy = psSHP->adBoundsMax[1];
   } else {
 
-    if( msSHXReadSize(psSHP, hEntity) <= 4 ) { /* NULL shape */
-      padBounds->minx = padBounds->miny = padBounds->maxx = padBounds->maxy = 0.0;
+    if (msSHXReadSize(psSHP, hEntity) <= 4) { /* NULL shape */
+      padBounds->minx = padBounds->miny = padBounds->maxx = padBounds->maxy =
+          0.0;
       return MS_FAILURE;
     }
 
-    const int offset = msSHXReadOffset( psSHP, hEntity);
-    if( offset <= 0 || offset >= INT_MAX - 12 || 0 != VSIFSeekL( psSHP->fpSHP, offset + 12, 0 )) {
+    const int offset = msSHXReadOffset(psSHP, hEntity);
+    if (offset <= 0 || offset >= INT_MAX - 12 ||
+        0 != VSIFSeekL(psSHP->fpSHP, offset + 12, 0)) {
       msSetError(MS_IOERR, "failed to seek offset", "msSHPReadBounds()");
-      return(MS_FAILURE);
+      return (MS_FAILURE);
     }
 
-    if( psSHP->nShapeType != SHP_POINT && psSHP->nShapeType != SHP_POINTZ && psSHP->nShapeType != SHP_POINTM) {
-      if( 1 != VSIFReadL( padBounds, sizeof(double)*4, 1, psSHP->fpSHP )) {
+    if (psSHP->nShapeType != SHP_POINT && psSHP->nShapeType != SHP_POINTZ &&
+        psSHP->nShapeType != SHP_POINTM) {
+      if (1 != VSIFReadL(padBounds, sizeof(double) * 4, 1, psSHP->fpSHP)) {
         msSetError(MS_IOERR, "failed to fread record", "msSHPReadBounds()");
-        return(MS_FAILURE);
+        return (MS_FAILURE);
       }
 
-      if( bBigEndian ) {
-        SwapWord( 8, &(padBounds->minx) );
-        SwapWord( 8, &(padBounds->miny) );
-        SwapWord( 8, &(padBounds->maxx) );
-        SwapWord( 8, &(padBounds->maxy) );
+      if (bBigEndian) {
+        SwapWord(8, &(padBounds->minx));
+        SwapWord(8, &(padBounds->miny));
+        SwapWord(8, &(padBounds->maxx));
+        SwapWord(8, &(padBounds->maxy));
       }
 
-      if(msIsNan(padBounds->minx)) { /* empty shape */
-        padBounds->minx = padBounds->miny = padBounds->maxx = padBounds->maxy = 0.0;
+      if (msIsNan(padBounds->minx)) { /* empty shape */
+        padBounds->minx = padBounds->miny = padBounds->maxx = padBounds->maxy =
+            0.0;
         return MS_FAILURE;
       }
     } else {
@@ -1721,14 +1825,14 @@ int msSHPReadBounds( SHPHandle psSHP, in
       /*      For points we fetch the point, and duplicate it as the          */
       /*      minimum and maximum bound.                                      */
       /* -------------------------------------------------------------------- */
-      if( 1 != VSIFReadL( padBounds, sizeof(double)*2, 1, psSHP->fpSHP )) {
+      if (1 != VSIFReadL(padBounds, sizeof(double) * 2, 1, psSHP->fpSHP)) {
         msSetError(MS_IOERR, "failed to fread record", "msSHPReadBounds()");
-        return(MS_FAILURE);
+        return (MS_FAILURE);
       }
 
-      if( bBigEndian ) {
-        SwapWord( 8, &(padBounds->minx) );
-        SwapWord( 8, &(padBounds->miny) );
+      if (bBigEndian) {
+        SwapWord(8, &(padBounds->minx));
+        SwapWord(8, &(padBounds->miny));
       }
 
       padBounds->maxx = padBounds->minx;
@@ -1739,8 +1843,8 @@ int msSHPReadBounds( SHPHandle psSHP, in
   return MS_SUCCESS;
 }
 
-int msShapefileOpenHandle(shapefileObj *shpfile, const char *filename, SHPHandle hSHP, DBFHandle hDBF)
-{
+int msShapefileOpenHandle(shapefileObj *shpfile, const char *filename,
+                          SHPHandle hSHP, DBFHandle hDBF) {
   assert(filename != NULL);
   assert(hSHP != NULL);
   assert(hDBF != NULL);
@@ -1755,9 +1859,9 @@ int msShapefileOpenHandle(shapefileObj *
   strlcpy(shpfile->source, filename, sizeof(shpfile->source));
 
   /* load some information about this shapefile */
-  msSHPGetInfo( shpfile->hSHP, &shpfile->numshapes, &shpfile->type);
+  msSHPGetInfo(shpfile->hSHP, &shpfile->numshapes, &shpfile->type);
 
-  if( shpfile->numshapes < 0 || shpfile->numshapes > 256000000 ) {
+  if (shpfile->numshapes < 0 || shpfile->numshapes > 256000000) {
     msSetError(MS_SHPERR, "Corrupted .shp file : numshapes = %d.",
                "msShapefileOpen()", shpfile->numshapes);
     msDBFClose(hDBF);
@@ -1765,16 +1869,17 @@ int msShapefileOpenHandle(shapefileObj *
     return -1;
   }
 
-  msSHPReadBounds( shpfile->hSHP, -1, &(shpfile->bounds));
+  msSHPReadBounds(shpfile->hSHP, -1, &(shpfile->bounds));
 
   shpfile->hDBF = hDBF;
 
   shpfile->isopen = MS_TRUE;
-  return(0); /* all o.k. */
+  return (0); /* all o.k. */
 }
 
-int msShapefileOpenVirtualFile(shapefileObj *shpfile, const char *filename, VSILFILE * fpSHP, VSILFILE * fpSHX, VSILFILE * fpDBF, int log_failures)
-{
+int msShapefileOpenVirtualFile(shapefileObj *shpfile, const char *filename,
+                               VSILFILE *fpSHP, VSILFILE *fpSHX,
+                               VSILFILE *fpDBF, int log_failures) {
   assert(filename != NULL);
   assert(fpSHP != NULL);
   assert(fpSHX != NULL);
@@ -1782,72 +1887,74 @@ int msShapefileOpenVirtualFile(shapefile
 
   /* open the shapefile file (appending ok) and get basic info */
   SHPHandle hSHP = msSHPOpenVirtualFile(fpSHP, fpSHX);
-  if(!hSHP) {
-    if( log_failures )
+  if (!hSHP) {
+    if (log_failures)
       msSetError(MS_IOERR, "(%s)", "msShapefileOpen()", filename);
-    VSIFCloseL( fpDBF );
-    return(-1);
+    VSIFCloseL(fpDBF);
+    return (-1);
   }
 
   DBFHandle hDBF = msDBFOpenVirtualFile(fpDBF);
 
-  if(!hDBF) {
-    if( log_failures )
+  if (!hDBF) {
+    if (log_failures)
       msSetError(MS_IOERR, "(%s)", "msShapefileOpen()", filename);
     msSHPClose(hSHP);
-    return(-1);
+    return (-1);
   }
 
   return msShapefileOpenHandle(shpfile, filename, hSHP, hDBF);
 }
 
-int msShapefileOpen(shapefileObj *shpfile, const char *mode, const char *filename, int log_failures)
-{
+int msShapefileOpen(shapefileObj *shpfile, const char *mode,
+                    const char *filename, int log_failures) {
   int i;
   char *dbfFilename;
   size_t bufferSize = 0;
 
-  if(!filename) {
-    if( log_failures )
+  if (!filename) {
+    if (log_failures)
       msSetError(MS_IOERR, "No (NULL) filename provided.", "msShapefileOpen()");
-    return(-1);
+    return (-1);
   }
 
   /* open the shapefile file (appending ok) and get basic info */
   SHPHandle hSHP;
-  if(!mode)
-    hSHP = msSHPOpen( filename, "rb");
+  if (!mode)
+    hSHP = msSHPOpen(filename, "rb");
   else
-    hSHP = msSHPOpen( filename, mode);
+    hSHP = msSHPOpen(filename, mode);
 
-  if(!hSHP) {
-    if( log_failures )
+  if (!hSHP) {
+    if (log_failures)
       msSetError(MS_IOERR, "(%s)", "msShapefileOpen()", filename);
-    return(-1);
+    return (-1);
   }
 
-  bufferSize = strlen(filename)+5;
+  bufferSize = strlen(filename) + 5;
   dbfFilename = (char *)msSmallMalloc(bufferSize);
   strcpy(dbfFilename, filename);
 
   /* clean off any extention the filename might have */
   for (i = strlen(dbfFilename) - 1;
-       i > 0 && dbfFilename[i] != '.' && dbfFilename[i] != '/' && dbfFilename[i] != '\\';
-       i-- ) {}
+       i > 0 && dbfFilename[i] != '.' && dbfFilename[i] != '/' &&
+       dbfFilename[i] != '\\';
+       i--) {
+  }
 
-  if( dbfFilename[i] == '.' )
+  if (dbfFilename[i] == '.')
     dbfFilename[i] = '\0';
 
   strlcat(dbfFilename, ".dbf", bufferSize);
 
   DBFHandle hDBF = msDBFOpen(dbfFilename, "rb");
 
-  if(!hDBF) {
-    if( log_failures )
+  if (!hDBF) {
+    if (log_failures)
       msSetError(MS_IOERR, "(%s)", "msShapefileOpen()", dbfFilename);
     free(dbfFilename);
     msSHPClose(hSHP);
-    return(-1);
+    return (-1);
   }
   free(dbfFilename);
 
@@ -1855,28 +1962,25 @@ int msShapefileOpen(shapefileObj *shpfil
 }
 
 /* Creates a new shapefile */
-int msShapefileCreate(shapefileObj *shpfile, char *filename, int type)
-{
-  if(type != SHP_POINT && type != SHP_MULTIPOINT && type != SHP_ARC &&
-      type != SHP_POLYGON &&
-      type != SHP_POINTM && type != SHP_MULTIPOINTM &&
-      type != SHP_ARCM && type != SHP_POLYGONM &&
-      type != SHP_POINTZ && type != SHP_MULTIPOINTZ &&
-      type != SHP_ARCZ && type != SHP_POLYGONZ) {
+int msShapefileCreate(shapefileObj *shpfile, char *filename, int type) {
+  if (type != SHP_POINT && type != SHP_MULTIPOINT && type != SHP_ARC &&
+      type != SHP_POLYGON && type != SHP_POINTM && type != SHP_MULTIPOINTM &&
+      type != SHP_ARCM && type != SHP_POLYGONM && type != SHP_POINTZ &&
+      type != SHP_MULTIPOINTZ && type != SHP_ARCZ && type != SHP_POLYGONZ) {
     msSetError(MS_SHPERR, "Invalid shape type.", "msNewSHPFile()");
-    return(-1);
+    return (-1);
   }
 
   /* create the spatial portion */
   shpfile->hSHP = msSHPCreate(filename, type);
-  if(!shpfile->hSHP) {
-    msSetError(MS_IOERR, "(%s)", "msNewSHPFile()",filename);
-    return(-1);
+  if (!shpfile->hSHP) {
+    msSetError(MS_IOERR, "(%s)", "msNewSHPFile()", filename);
+    return (-1);
   }
 
   /* retrieve a few things about this shapefile */
-  msSHPGetInfo( shpfile->hSHP, &shpfile->numshapes, &shpfile->type);
-  msSHPReadBounds( shpfile->hSHP, -1, &(shpfile->bounds));
+  msSHPGetInfo(shpfile->hSHP, &shpfile->numshapes, &shpfile->type);
+  msSHPReadBounds(shpfile->hSHP, -1, &(shpfile->bounds));
 
   /* initialize a few other things */
   shpfile->status = NULL;
@@ -1884,22 +1988,24 @@ int msShapefileCreate(shapefileObj *shpf
   shpfile->isopen = MS_TRUE;
 
   shpfile->hDBF = NULL; /* XBase file is NOT created here... */
-  return(0);
+  return (0);
 }
 
-void msShapefileClose(shapefileObj *shpfile)
-{
-  if (shpfile && shpfile->isopen == MS_TRUE) { /* Silently return if called with NULL shpfile by freeLayer() */
-    if(shpfile->hSHP) msSHPClose(shpfile->hSHP);
-    if(shpfile->hDBF) msDBFClose(shpfile->hDBF);
+void msShapefileClose(shapefileObj *shpfile) {
+  if (shpfile && shpfile->isopen == MS_TRUE) { /* Silently return if called with
+                                                  NULL shpfile by freeLayer() */
+    if (shpfile->hSHP)
+      msSHPClose(shpfile->hSHP);
+    if (shpfile->hDBF)
+      msDBFClose(shpfile->hDBF);
     free(shpfile->status);
     shpfile->isopen = MS_FALSE;
   }
 }
 
-/* status array lives in the shpfile, can return MS_SUCCESS/MS_FAILURE/MS_DONE */
-int msShapefileWhichShapes(shapefileObj *shpfile, rectObj rect, int debug)
-{
+/* status array lives in the shpfile, can return MS_SUCCESS/MS_FAILURE/MS_DONE
+ */
+int msShapefileWhichShapes(shapefileObj *shpfile, rectObj rect, int debug) {
   int i;
   rectObj shaperect;
   char *filename;
@@ -1908,72 +2014,78 @@ int msShapefileWhichShapes(shapefileObj
   shpfile->status = NULL;
 
   /* rect and shapefile DON'T overlap... */
-  if(msRectOverlap(&shpfile->bounds, &rect) != MS_TRUE)
-    return(MS_DONE);
+  if (msRectOverlap(&shpfile->bounds, &rect) != MS_TRUE)
+    return (MS_DONE);
 
-  if(msRectContained(&shpfile->bounds, &rect) == MS_TRUE) {
+  if (msRectContained(&shpfile->bounds, &rect) == MS_TRUE) {
     shpfile->status = msAllocBitArray(shpfile->numshapes);
-    if(!shpfile->status) {
+    if (!shpfile->status) {
       msSetError(MS_MEMERR, NULL, "msShapefileWhichShapes()");
-      return(MS_FAILURE);
+      return (MS_FAILURE);
     }
     msSetAllBits(shpfile->status, shpfile->numshapes, 1);
   } else {
 
     /* deal with case where sourcename is of the form 'file.shp' */
-    char* sourcename = msStrdup(shpfile->source); /* shape file source string from map file */
-    char* s = strstr(sourcename, ".shp");
-    if( s )
+    char *sourcename =
+        msStrdup(shpfile->source); /* shape file source string from map file */
+    char *s = strstr(sourcename, ".shp");
+    if (s)
       *s = '\0';
     else {
       s = strstr(sourcename, ".SHP");
-      if( s )
+      if (s)
         *s = '\0';
     }
 
-    filename = (char *)malloc(strlen(sourcename)+strlen(MS_INDEX_EXTENSION)+1);
-    MS_CHECK_ALLOC(filename, strlen(sourcename)+strlen(MS_INDEX_EXTENSION)+1, MS_FAILURE);
+    filename =
+        (char *)malloc(strlen(sourcename) + strlen(MS_INDEX_EXTENSION) + 1);
+    MS_CHECK_ALLOC(filename,
+                   strlen(sourcename) + strlen(MS_INDEX_EXTENSION) + 1,
+                   MS_FAILURE);
 
     sprintf(filename, "%s%s", sourcename, MS_INDEX_EXTENSION);
 
-    shpfile->status = msSearchDiskTree(filename, rect, debug, shpfile->numshapes);
+    shpfile->status =
+        msSearchDiskTree(filename, rect, debug, shpfile->numshapes);
     free(filename);
     free(sourcename);
 
-    if(shpfile->status) { /* index  */
+    if (shpfile->status) { /* index  */
       msFilterTreeSearch(shpfile, shpfile->status, rect);
     } else { /* no index  */
       shpfile->status = msAllocBitArray(shpfile->numshapes);
-      if(!shpfile->status) {
+      if (!shpfile->status) {
         msSetError(MS_MEMERR, NULL, "msShapefileWhichShapes()");
-        return(MS_FAILURE);
+        return (MS_FAILURE);
       }
 
-      for(i=0; i<shpfile->numshapes; i++) {
-        if(msSHPReadBounds(shpfile->hSHP, i, &shaperect) != MS_SUCCESS) {
+      for (i = 0; i < shpfile->numshapes; i++) {
+        if (msSHPReadBounds(shpfile->hSHP, i, &shaperect) != MS_SUCCESS) {
           if (msSHXReadSize(shpfile->hSHP, i) == 4) { /* handle NULL shape */
-              continue;
+            continue;
           }
-          return(MS_FAILURE);
+          return (MS_FAILURE);
         }
 
-        if(msRectOverlap(&shaperect, &rect) == MS_TRUE) msSetBit(shpfile->status, i, 1);
+        if (msRectOverlap(&shaperect, &rect) == MS_TRUE)
+          msSetBit(shpfile->status, i, 1);
       }
     }
   }
 
   shpfile->lastshape = -1;
 
-  return(MS_SUCCESS); /* success */
+  return (MS_SUCCESS); /* success */
 }
 
 /* Return the absolute path to the given layer's tileindex file's directory */
-void msTileIndexAbsoluteDir(char *tiFileAbsDir, layerObj *layer)
-{
+void msTileIndexAbsoluteDir(char *tiFileAbsDir, layerObj *layer) {
   char tiFileAbsPath[MS_MAXPATHLEN];
-  char *tiFileAbsDirTmp=NULL;
+  char *tiFileAbsDirTmp = NULL;
 
-  msBuildPath(tiFileAbsPath, layer->map->mappath, layer->tileindex); /* absolute path to tileindex file */
+  msBuildPath(tiFileAbsPath, layer->map->mappath,
+              layer->tileindex); /* absolute path to tileindex file */
   tiFileAbsDirTmp = msGetPath(tiFileAbsPath); /* tileindex file's directory */
   strlcpy(tiFileAbsDir, tiFileAbsDirTmp, MS_MAXPATHLEN);
   free(tiFileAbsDirTmp);
@@ -1990,132 +2102,156 @@ void msTileIndexAbsoluteDir(char *tiFile
 ** MS_FAILURE - no file, and map is configured to fail on missing
 ** MS_DONE - no file, and map is configured to continue on missing
 */
-static
-int msTiledSHPTryOpen(shapefileObj *shpfile, layerObj *layer, char *tiFileAbsDir, const char *filename)
-{
+static int msTiledSHPTryOpen(shapefileObj *shpfile, layerObj *layer,
+                             char *tiFileAbsDir, const char *filename) {
   char szPath[MS_MAXPATHLEN];
   int ignore_missing = msMapIgnoreMissingData(layer->map);
   int log_failures = MS_TRUE;
 
-  if( ignore_missing == MS_MISSING_DATA_IGNORE )
+  if (ignore_missing == MS_MISSING_DATA_IGNORE)
     log_failures = MS_FALSE;
 
-  if(msShapefileOpen(shpfile, "rb", msBuildPath3(szPath, layer->map->mappath, layer->map->shapepath, filename), log_failures) == -1) {
-    if(msShapefileOpen(shpfile, "rb", msBuildPath3(szPath, tiFileAbsDir, layer->map->shapepath, filename), log_failures) == -1) {
-      if(msShapefileOpen(shpfile, "rb", msBuildPath(szPath, layer->map->mappath, filename), log_failures) == -1) {
-        if(ignore_missing == MS_MISSING_DATA_FAIL) {
-          msSetError(MS_IOERR, "Unable to open shapefile '%s' for layer '%s' ... fatal error.", "msTiledSHPTryOpen()", filename, layer->name);
-          return(MS_FAILURE);
-        } else if( ignore_missing == MS_MISSING_DATA_LOG ) {
-          if( layer->debug || layer->map->debug ) {
-            msDebug( "Unable to open shapefile '%s' for layer '%s' ... ignoring this missing data.\n", szPath, layer->name );
+  if (msShapefileOpen(shpfile, "rb",
+                      msBuildPath3(szPath, layer->map->mappath,
+                                   layer->map->shapepath, filename),
+                      log_failures) == -1) {
+    if (msShapefileOpen(
+            shpfile, "rb",
+            msBuildPath3(szPath, tiFileAbsDir, layer->map->shapepath, filename),
+            log_failures) == -1) {
+      if (msShapefileOpen(shpfile, "rb",
+                          msBuildPath(szPath, layer->map->mappath, filename),
+                          log_failures) == -1) {
+        if (ignore_missing == MS_MISSING_DATA_FAIL) {
+          msSetError(
+              MS_IOERR,
+              "Unable to open shapefile '%s' for layer '%s' ... fatal error.",
+              "msTiledSHPTryOpen()", filename, layer->name);
+          return (MS_FAILURE);
+        } else if (ignore_missing == MS_MISSING_DATA_LOG) {
+          if (layer->debug || layer->map->debug) {
+            msDebug("Unable to open shapefile '%s' for layer '%s' ... ignoring "
+                    "this missing data.\n",
+                    szPath, layer->name);
           }
-          return(MS_DONE);
-        } else if( ignore_missing == MS_MISSING_DATA_IGNORE ) {
-          return(MS_DONE);
+          return (MS_DONE);
+        } else if (ignore_missing == MS_MISSING_DATA_IGNORE) {
+          return (MS_DONE);
         } else {
           /* never get here */
-          msSetError(MS_IOERR, "msIgnoreMissingData returned unexpected value.", "msTiledSHPTryOpen()");
-          return(MS_FAILURE);
+          msSetError(MS_IOERR, "msIgnoreMissingData returned unexpected value.",
+                     "msTiledSHPTryOpen()");
+          return (MS_FAILURE);
         }
       }
     }
   }
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
-static const char* msTiledSHPLoadEntry(layerObj *layer, int i, char* tilename, size_t tilenamesize)
-{
-    const char* filename;
-    msTiledSHPLayerInfo *tSHP= layer->layerinfo;
+static const char *msTiledSHPLoadEntry(layerObj *layer, int i, char *tilename,
+                                       size_t tilenamesize) {
+  const char *filename;
+  msTiledSHPLayerInfo *tSHP = layer->layerinfo;
 
-    msProjectDestroyReprojector(tSHP->reprojectorFromTileProjToLayerProj);
-    tSHP->reprojectorFromTileProjToLayerProj = NULL;
+  msProjectDestroyReprojector(tSHP->reprojectorFromTileProjToLayerProj);
+  tSHP->reprojectorFromTileProjToLayerProj = NULL;
 
-    msFreeProjection(&(tSHP->sTileProj));
-    if( layer->tilesrs != NULL )
-    {
-        int idx = msDBFGetItemIndex(tSHP->tileshpfile->hDBF, layer->tilesrs);
-        const char* pszWKT = msDBFReadStringAttribute(tSHP->tileshpfile->hDBF, i, idx);
-        IGNORE_RET_VAL(msOGCWKT2ProjectionObj(pszWKT, &(tSHP->sTileProj), layer->debug ));
-    }
-
-    if(!layer->data) /* assume whole filename is in attribute field */
-      filename =msDBFReadStringAttribute(tSHP->tileshpfile->hDBF, i, layer->tileitemindex);
-    else {
-      snprintf(tilename, tilenamesize, "%s/%s",
-               msDBFReadStringAttribute(tSHP->tileshpfile->hDBF, i, layer->tileitemindex) ,
-               layer->data);
-      filename = tilename;
-    }
+  msFreeProjection(&(tSHP->sTileProj));
+  if (layer->tilesrs != NULL) {
+    int idx = msDBFGetItemIndex(tSHP->tileshpfile->hDBF, layer->tilesrs);
+    const char *pszWKT =
+        msDBFReadStringAttribute(tSHP->tileshpfile->hDBF, i, idx);
+    IGNORE_RET_VAL(
+        msOGCWKT2ProjectionObj(pszWKT, &(tSHP->sTileProj), layer->debug));
+  }
+
+  if (!layer->data) /* assume whole filename is in attribute field */
+    filename = msDBFReadStringAttribute(tSHP->tileshpfile->hDBF, i,
+                                        layer->tileitemindex);
+  else {
+    snprintf(tilename, tilenamesize, "%s/%s",
+             msDBFReadStringAttribute(tSHP->tileshpfile->hDBF, i,
+                                      layer->tileitemindex),
+             layer->data);
+    filename = tilename;
+  }
 
-    return filename;
+  return filename;
 }
 
-static
-int msTiledSHPOpenFile(layerObj *layer)
-{
+static int msTiledSHPOpenFile(layerObj *layer) {
   int i;
   const char *filename;
   char tilename[MS_MAXPATHLEN], szPath[MS_MAXPATHLEN];
   char tiFileAbsDir[MS_MAXPATHLEN];
 
-  msTiledSHPLayerInfo *tSHP=NULL;
+  msTiledSHPLayerInfo *tSHP = NULL;
 
   if (layer->layerinfo != NULL) {
-    return MS_SUCCESS;  // Nothing to do... layer is already opened
+    return MS_SUCCESS; // Nothing to do... layer is already opened
   }
 
-  if ( msCheckParentPointer(layer->map,"map")==MS_FAILURE )
+  if (msCheckParentPointer(layer->map, "map") == MS_FAILURE)
     return MS_FAILURE;
 
   /* allocate space for a shapefileObj using layer->layerinfo  */
-  tSHP = (msTiledSHPLayerInfo *) calloc(1, sizeof(msTiledSHPLayerInfo));
+  tSHP = (msTiledSHPLayerInfo *)calloc(1, sizeof(msTiledSHPLayerInfo));
   MS_CHECK_ALLOC(tSHP, sizeof(msTiledSHPLayerInfo), MS_FAILURE);
   msInitProjection(&(tSHP->sTileProj));
   msProjectionInheritContextFrom(&(tSHP->sTileProj), &layer->projection);
 
-  tSHP->shpfile = (shapefileObj *) malloc(sizeof(shapefileObj));
+  tSHP->shpfile = (shapefileObj *)malloc(sizeof(shapefileObj));
   if (tSHP->shpfile == NULL) {
-    msSetError(MS_MEMERR, "%s: %d: Out of memory allocating %u bytes.\n", "msTiledSHPOpenFile()",
-               __FILE__, __LINE__, (unsigned int)sizeof(shapefileObj));
+    msSetError(MS_MEMERR, "%s: %d: Out of memory allocating %u bytes.\n",
+               "msTiledSHPOpenFile()", __FILE__, __LINE__,
+               (unsigned int)sizeof(shapefileObj));
     msFreeProjection(&(tSHP->sTileProj));
     free(tSHP);
     return MS_FAILURE;
   }
-  
-  tSHP->shpfile->isopen = MS_FALSE; /* in case of error: do not try to close the shpfile */
-  tSHP->tileshpfile = NULL; /* may need this if not using a tile layer, look for malloc later */
+
+  tSHP->shpfile->isopen =
+      MS_FALSE; /* in case of error: do not try to close the shpfile */
+  tSHP->tileshpfile =
+      NULL; /* may need this if not using a tile layer, look for malloc later */
   layer->layerinfo = tSHP;
 
   tSHP->tilelayerindex = msGetLayerIndex(layer->map, layer->tileindex);
-  if(tSHP->tilelayerindex != -1) { /* does the tileindex reference another layer */
+  if (tSHP->tilelayerindex !=
+      -1) { /* does the tileindex reference another layer */
     int status;
     layerObj *tlp;
 
     tlp = (GET_LAYER(layer->map, tSHP->tilelayerindex));
 
-    if(tlp->connectiontype != MS_SHAPEFILE) {
-      msSetError(MS_SHPERR, "Tileindex layer must be a shapefile.", "msTiledSHPOpenFile()");
-      return(MS_FAILURE);
+    if (tlp->connectiontype != MS_SHAPEFILE) {
+      msSetError(MS_SHPERR, "Tileindex layer must be a shapefile.",
+                 "msTiledSHPOpenFile()");
+      return (MS_FAILURE);
     }
 
     status = msLayerOpen(tlp);
-    if(status != MS_SUCCESS) return(MS_FAILURE);
+    if (status != MS_SUCCESS)
+      return (MS_FAILURE);
 
     /* build item list */
     status = msLayerWhichItems(tlp, MS_FALSE, NULL);
-    if(status != MS_SUCCESS) return(MS_FAILURE);
+    if (status != MS_SUCCESS)
+      return (MS_FAILURE);
 
-    tSHP->tileshpfile = (shapefileObj *) tlp->layerinfo; /* shapefiles use layerinfo to point to a shapefileObj */
+    tSHP->tileshpfile =
+        (shapefileObj *)tlp->layerinfo; /* shapefiles use layerinfo to point to
+                                           a shapefileObj */
 
   } else { /* or reference a shapefile directly */
 
     /* we need tSHP->tileshpfile if we're not working with a layer */
-    tSHP->tileshpfile = (shapefileObj *) malloc(sizeof(shapefileObj));
+    tSHP->tileshpfile = (shapefileObj *)malloc(sizeof(shapefileObj));
     if (tSHP->tileshpfile == NULL) {
-      msSetError(MS_MEMERR, "%s: %d: Out of memory allocating %u bytes.\n", "msTiledSHPOpenFile()",
-                 __FILE__, __LINE__, (unsigned int)sizeof(shapefileObj));
+      msSetError(MS_MEMERR, "%s: %d: Out of memory allocating %u bytes.\n",
+                 "msTiledSHPOpenFile()", __FILE__, __LINE__,
+                 (unsigned int)sizeof(shapefileObj));
       free(tSHP->shpfile);
       msFreeProjection(&(tSHP->sTileProj));
       free(tSHP);
@@ -2123,157 +2259,170 @@ int msTiledSHPOpenFile(layerObj *layer)
       return MS_FAILURE;
     }
 
-
-    if(msShapefileOpen(tSHP->tileshpfile, "rb", msBuildPath3(szPath, layer->map->mappath, layer->map->shapepath, layer->tileindex), MS_TRUE) == -1)
-      if(msShapefileOpen(tSHP->tileshpfile, "rb", msBuildPath(szPath, layer->map->mappath, layer->tileindex), MS_TRUE) == -1)
-        return(MS_FAILURE);
-  }
-
-  if((layer->tileitemindex = msDBFGetItemIndex(tSHP->tileshpfile->hDBF, layer->tileitem)) == -1) return(MS_FAILURE);
-
-  if( layer->tilesrs != NULL &&
-      msDBFGetItemIndex(tSHP->tileshpfile->hDBF, layer->tilesrs) < 0 )
-  {
-    msSetError(MS_SHPERR,
-                "Cannot identify TILESRS field.",
-                "msTiledSHPOpenFile()");
+    if (msShapefileOpen(tSHP->tileshpfile, "rb",
+                        msBuildPath3(szPath, layer->map->mappath,
+                                     layer->map->shapepath, layer->tileindex),
+                        MS_TRUE) == -1)
+      if (msShapefileOpen(
+              tSHP->tileshpfile, "rb",
+              msBuildPath(szPath, layer->map->mappath, layer->tileindex),
+              MS_TRUE) == -1)
+        return (MS_FAILURE);
+  }
+
+  if ((layer->tileitemindex =
+           msDBFGetItemIndex(tSHP->tileshpfile->hDBF, layer->tileitem)) == -1)
+    return (MS_FAILURE);
+
+  if (layer->tilesrs != NULL &&
+      msDBFGetItemIndex(tSHP->tileshpfile->hDBF, layer->tilesrs) < 0) {
+    msSetError(MS_SHPERR, "Cannot identify TILESRS field.",
+               "msTiledSHPOpenFile()");
     return MS_FAILURE;
   }
-  if( layer->tilesrs != NULL && layer->projection.numargs == 0 )
-  {
+  if (layer->tilesrs != NULL && layer->projection.numargs == 0) {
     msSetError(MS_SHPERR,
-                "A layer with TILESRS set in TILEINDEX `%s' must have a "
-                "projection set on itself.",
-                "msOGRLayerOpen()",
-                layer->tileindex );
+               "A layer with TILESRS set in TILEINDEX `%s' must have a "
+               "projection set on itself.",
+               "msOGRLayerOpen()", layer->tileindex);
     return MS_FAILURE;
   }
 
   msTileIndexAbsoluteDir(tiFileAbsDir, layer);
 
-  /* position the source at the FIRST tile to use as a template, this is so the functions that fill the iteminfo array have something to work from */
-  for(i=0; i<tSHP->tileshpfile->numshapes; i++) {
+  /* position the source at the FIRST tile to use as a template, this is so the
+   * functions that fill the iteminfo array have something to work from */
+  for (i = 0; i < tSHP->tileshpfile->numshapes; i++) {
     int try_open;
 
     filename = msTiledSHPLoadEntry(layer, i, tilename, sizeof(tilename));
-    if(strlen(filename) == 0) continue; /* check again */
+    if (strlen(filename) == 0)
+      continue; /* check again */
 
     try_open = msTiledSHPTryOpen(tSHP->shpfile, layer, tiFileAbsDir, filename);
-    if( try_open == MS_DONE )
+    if (try_open == MS_DONE)
       continue;
-    else if (try_open == MS_FAILURE )
-      return(MS_FAILURE);
+    else if (try_open == MS_FAILURE)
+      return (MS_FAILURE);
 
-    return(MS_SUCCESS); /* found a template, ok to proceed */
+    return (MS_SUCCESS); /* found a template, ok to proceed */
   }
 
-  msSetError(MS_SHPERR, "Unable to open a single tile to use as a template in layer %s.", "msTiledSHPOpenFile()", layer->name?layer->name:"(null)");
-  return(MS_FAILURE);
+  msSetError(MS_SHPERR,
+             "Unable to open a single tile to use as a template in layer %s.",
+             "msTiledSHPOpenFile()", layer->name ? layer->name : "(null)");
+  return (MS_FAILURE);
 }
 
-static
-int msTiledSHPWhichShapes(layerObj *layer, rectObj rect, int isQuery)
-{
+static int msTiledSHPWhichShapes(layerObj *layer, rectObj rect, int isQuery) {
   int i, status;
   const char *filename;
   char tilename[MS_MAXPATHLEN];
   char tiFileAbsDir[MS_MAXPATHLEN];
 
-  msTiledSHPLayerInfo *tSHP=NULL;
+  msTiledSHPLayerInfo *tSHP = NULL;
 
-  if ( msCheckParentPointer(layer->map,"map")==MS_FAILURE )
+  if (msCheckParentPointer(layer->map, "map") == MS_FAILURE)
     return MS_FAILURE;
 
   tSHP = layer->layerinfo;
-  if(!tSHP) {
-    msSetError(MS_SHPERR, "Tiled shapefile layer has not been opened.", "msTiledSHPWhichShapes()");
-    return(MS_FAILURE);
+  if (!tSHP) {
+    msSetError(MS_SHPERR, "Tiled shapefile layer has not been opened.",
+               "msTiledSHPWhichShapes()");
+    return (MS_FAILURE);
   }
 
   msShapefileClose(tSHP->shpfile); /* close previously opened files */
 
   tSHP->searchrect = rect; /* save the search extent */
 
-  if(tSHP->tilelayerindex != -1) {  /* does the tileindex reference another layer */
+  if (tSHP->tilelayerindex !=
+      -1) { /* does the tileindex reference another layer */
     layerObj *tlp;
     shapeObj tshape;
 
     tlp = (GET_LAYER(layer->map, tSHP->tilelayerindex));
-    status= msLayerWhichShapes(tlp, rect, isQuery);
-    if(status != MS_SUCCESS) return(status); /* could be MS_DONE or MS_FAILURE */
+    status = msLayerWhichShapes(tlp, rect, isQuery);
+    if (status != MS_SUCCESS)
+      return (status); /* could be MS_DONE or MS_FAILURE */
 
     msTileIndexAbsoluteDir(tiFileAbsDir, layer);
 
     msInitShape(&tshape);
-    while((status = msLayerNextShape(tlp, &tshape)) == MS_SUCCESS) {
+    while ((status = msLayerNextShape(tlp, &tshape)) == MS_SUCCESS) {
       int try_open;
       rectObj rectTile = rect;
 
-      filename = msTiledSHPLoadEntry(layer, tshape.index, tilename, sizeof(tilename));
-      if(strlen(filename) == 0) continue; /* check again */
-
-      try_open = msTiledSHPTryOpen(tSHP->shpfile, layer, tiFileAbsDir, filename);
-      if( try_open == MS_DONE )
+      filename =
+          msTiledSHPLoadEntry(layer, tshape.index, tilename, sizeof(tilename));
+      if (strlen(filename) == 0)
+        continue; /* check again */
+
+      try_open =
+          msTiledSHPTryOpen(tSHP->shpfile, layer, tiFileAbsDir, filename);
+      if (try_open == MS_DONE)
         continue;
-      else if (try_open == MS_FAILURE )
-        return(MS_FAILURE);
+      else if (try_open == MS_FAILURE)
+        return (MS_FAILURE);
 
-      if( tSHP->sTileProj.numargs > 0 )
-      {
+      if (tSHP->sTileProj.numargs > 0) {
         msProjectRect(&(layer->projection), &(tSHP->sTileProj), &rectTile);
       }
 
       status = msShapefileWhichShapes(tSHP->shpfile, rectTile, layer->debug);
-      if(status == MS_DONE) {
+      if (status == MS_DONE) {
         /* Close and continue to next tile */
         msShapefileClose(tSHP->shpfile);
         continue;
-      } else if(status != MS_SUCCESS) {
+      } else if (status != MS_SUCCESS) {
         msShapefileClose(tSHP->shpfile);
-        return(MS_FAILURE);
+        return (MS_FAILURE);
       }
 
       /* the layer functions keeps track of this */
       /* tSHP->tileshpfile->lastshape = tshape.index; */
       break;
     }
-    return(status); /* if we reach here we either 1) ran out of tiles or 2) had an error reading a tile */
+    return (status); /* if we reach here we either 1) ran out of tiles or 2) had
+                        an error reading a tile */
 
   } else { /* or reference a shapefile directly */
     int try_open;
 
     status = msShapefileWhichShapes(tSHP->tileshpfile, rect, layer->debug);
-    if(status != MS_SUCCESS) return(status); /* could be MS_DONE or MS_FAILURE */
+    if (status != MS_SUCCESS)
+      return (status); /* could be MS_DONE or MS_FAILURE */
 
     msTileIndexAbsoluteDir(tiFileAbsDir, layer);
 
     /* position the source at the FIRST shapefile */
-    for(i=0; i<tSHP->tileshpfile->numshapes; i++) {
+    for (i = 0; i < tSHP->tileshpfile->numshapes; i++) {
       rectObj rectTile = rect;
-      if(msGetBit(tSHP->tileshpfile->status,i)) {
+      if (msGetBit(tSHP->tileshpfile->status, i)) {
 
         filename = msTiledSHPLoadEntry(layer, i, tilename, sizeof(tilename));
-        if(strlen(filename) == 0) continue; /* check again */
+        if (strlen(filename) == 0)
+          continue; /* check again */
 
-        try_open = msTiledSHPTryOpen(tSHP->shpfile, layer, tiFileAbsDir, filename);
-        if( try_open == MS_DONE )
+        try_open =
+            msTiledSHPTryOpen(tSHP->shpfile, layer, tiFileAbsDir, filename);
+        if (try_open == MS_DONE)
           continue;
-        else if (try_open == MS_FAILURE )
-          return(MS_FAILURE);
+        else if (try_open == MS_FAILURE)
+          return (MS_FAILURE);
 
-        if( tSHP->sTileProj.numargs > 0 )
-        {
+        if (tSHP->sTileProj.numargs > 0) {
           msProjectRect(&(layer->projection), &(tSHP->sTileProj), &rectTile);
         }
 
         status = msShapefileWhichShapes(tSHP->shpfile, rectTile, layer->debug);
-        if(status == MS_DONE) {
+        if (status == MS_DONE) {
           /* Close and continue to next tile */
           msShapefileClose(tSHP->shpfile);
           continue;
-        } else if(status != MS_SUCCESS) {
+        } else if (status != MS_SUCCESS) {
           msShapefileClose(tSHP->shpfile);
-          return(MS_FAILURE);
+          return (MS_FAILURE);
         }
 
         tSHP->tileshpfile->lastshape = i;
@@ -2281,45 +2430,47 @@ int msTiledSHPWhichShapes(layerObj *laye
       }
     }
 
-    if(i == tSHP->tileshpfile->numshapes)
-      return(MS_DONE); /* no more tiles */
+    if (i == tSHP->tileshpfile->numshapes)
+      return (MS_DONE); /* no more tiles */
     else
-      return(MS_SUCCESS);
+      return (MS_SUCCESS);
   }
 
-  return(MS_FAILURE); /* should *never* get here */
+  return (MS_FAILURE); /* should *never* get here */
 }
 
-static
-int msTiledSHPNextShape(layerObj *layer, shapeObj *shape)
-{
+static int msTiledSHPNextShape(layerObj *layer, shapeObj *shape) {
   int i, status, filter_passed = MS_FALSE;
   const char *filename;
   char tilename[MS_MAXPATHLEN];
   char tiFileAbsDir[MS_MAXPATHLEN];
 
-  msTiledSHPLayerInfo *tSHP=NULL;
+  msTiledSHPLayerInfo *tSHP = NULL;
 
-  if ( msCheckParentPointer(layer->map,"map")==MS_FAILURE )
+  if (msCheckParentPointer(layer->map, "map") == MS_FAILURE)
     return MS_FAILURE;
 
   tSHP = layer->layerinfo;
-  if(!tSHP) {
-    msSetError(MS_SHPERR, "Tiled shapefile layer has not been opened.", "msTiledSHPNextShape()");
-    return(MS_FAILURE);
+  if (!tSHP) {
+    msSetError(MS_SHPERR, "Tiled shapefile layer has not been opened.",
+               "msTiledSHPNextShape()");
+    return (MS_FAILURE);
   }
 
   msTileIndexAbsoluteDir(tiFileAbsDir, layer);
 
   do {
     i = tSHP->shpfile->lastshape + 1;
-    while(i<tSHP->shpfile->numshapes && !msGetBit(tSHP->shpfile->status,i)) i++; /* next "in" shape */
+    while (i < tSHP->shpfile->numshapes && !msGetBit(tSHP->shpfile->status, i))
+      i++; /* next "in" shape */
 
-    if(i == tSHP->shpfile->numshapes) { /* done with this tile, need a new one */
+    if (i ==
+        tSHP->shpfile->numshapes) {    /* done with this tile, need a new one */
       msShapefileClose(tSHP->shpfile); /* clean up */
 
       /* position the source to the NEXT shapefile based on the tileindex */
-      if(tSHP->tilelayerindex != -1) { /* does the tileindex reference another layer */
+      if (tSHP->tilelayerindex !=
+          -1) { /* does the tileindex reference another layer */
         layerObj *tlp;
         shapeObj tshape;
         int try_open;
@@ -2327,32 +2478,35 @@ int msTiledSHPNextShape(layerObj *layer,
         tlp = (GET_LAYER(layer->map, tSHP->tilelayerindex));
 
         msInitShape(&tshape);
-        while((status = msLayerNextShape(tlp, &tshape)) == MS_SUCCESS) {
+        while ((status = msLayerNextShape(tlp, &tshape)) == MS_SUCCESS) {
           rectObj rectTile = tSHP->searchrect;
 
-          filename = msTiledSHPLoadEntry(layer, tshape.index, tilename, sizeof(tilename));
-          if(strlen(filename) == 0) continue; /* check again */
-
-          try_open = msTiledSHPTryOpen(tSHP->shpfile, layer, tiFileAbsDir, filename);
-          if( try_open == MS_DONE )
+          filename = msTiledSHPLoadEntry(layer, tshape.index, tilename,
+                                         sizeof(tilename));
+          if (strlen(filename) == 0)
+            continue; /* check again */
+
+          try_open =
+              msTiledSHPTryOpen(tSHP->shpfile, layer, tiFileAbsDir, filename);
+          if (try_open == MS_DONE)
             continue;
-          else if (try_open == MS_FAILURE )
-            return(MS_FAILURE);
+          else if (try_open == MS_FAILURE)
+            return (MS_FAILURE);
 
-          if( tSHP->sTileProj.numargs > 0 )
-          {
+          if (tSHP->sTileProj.numargs > 0) {
             msProjectRect(&(layer->projection), &(tSHP->sTileProj), &rectTile);
           }
 
-          status = msShapefileWhichShapes(tSHP->shpfile, rectTile, layer->debug);
-          if(status == MS_DONE) {
+          status =
+              msShapefileWhichShapes(tSHP->shpfile, rectTile, layer->debug);
+          if (status == MS_DONE) {
             /* Close and continue to next tile */
             msShapefileClose(tSHP->shpfile);
             continue;
-          } else if(status != MS_SUCCESS) {
+          } else if (status != MS_SUCCESS) {
             msShapefileClose(tSHP->shpfile);
             tSHP->tileshpfile->lastshape = -1;
-            return(MS_FAILURE);
+            return (MS_FAILURE);
           }
 
           /* the layer functions keeps track of this */
@@ -2360,45 +2514,49 @@ int msTiledSHPNextShape(layerObj *layer,
           break;
         }
 
-        if(status == MS_DONE) {
-            tSHP->tileshpfile->lastshape = -1;
-            return(MS_DONE); /* no more tiles */
-        }
-        else {
+        if (status == MS_DONE) {
+          tSHP->tileshpfile->lastshape = -1;
+          return (MS_DONE); /* no more tiles */
+        } else {
           msFreeShape(&tshape);
           continue; /* we've got shapes */
         }
 
       } else { /* or reference a shapefile directly   */
 
-        for(i=(tSHP->tileshpfile->lastshape + 1); i<tSHP->tileshpfile->numshapes; i++) {
-          if(msGetBit(tSHP->tileshpfile->status,i)) {
+        for (i = (tSHP->tileshpfile->lastshape + 1);
+             i < tSHP->tileshpfile->numshapes; i++) {
+          if (msGetBit(tSHP->tileshpfile->status, i)) {
             rectObj rectTile = tSHP->searchrect;
             int try_open;
 
-            filename = msTiledSHPLoadEntry(layer, i, tilename, sizeof(tilename));
-            if(strlen(filename) == 0) continue; /* check again */
-
-            try_open = msTiledSHPTryOpen(tSHP->shpfile, layer, tiFileAbsDir, filename);
-            if( try_open == MS_DONE )
+            filename =
+                msTiledSHPLoadEntry(layer, i, tilename, sizeof(tilename));
+            if (strlen(filename) == 0)
+              continue; /* check again */
+
+            try_open =
+                msTiledSHPTryOpen(tSHP->shpfile, layer, tiFileAbsDir, filename);
+            if (try_open == MS_DONE)
               continue;
-            else if (try_open == MS_FAILURE )
-              return(MS_FAILURE);
+            else if (try_open == MS_FAILURE)
+              return (MS_FAILURE);
 
-            if( tSHP->sTileProj.numargs > 0 )
-            {
-              msProjectRect(&(layer->projection), &(tSHP->sTileProj), &rectTile);
+            if (tSHP->sTileProj.numargs > 0) {
+              msProjectRect(&(layer->projection), &(tSHP->sTileProj),
+                            &rectTile);
             }
 
-            status = msShapefileWhichShapes(tSHP->shpfile, rectTile, layer->debug);
-            if(status == MS_DONE) {
+            status =
+                msShapefileWhichShapes(tSHP->shpfile, rectTile, layer->debug);
+            if (status == MS_DONE) {
               /* Close and continue to next tile */
               msShapefileClose(tSHP->shpfile);
               continue;
-            } else if(status != MS_SUCCESS) {
+            } else if (status != MS_SUCCESS) {
               msShapefileClose(tSHP->shpfile);
               tSHP->tileshpfile->lastshape = -1;
-              return(MS_FAILURE);
+              return (MS_FAILURE);
             }
 
             tSHP->tileshpfile->lastshape = i;
@@ -2406,135 +2564,150 @@ int msTiledSHPNextShape(layerObj *layer,
           }
         } /* end for loop */
 
-        if(i == tSHP->tileshpfile->numshapes) {
-            tSHP->tileshpfile->lastshape = -1;
-            return(MS_DONE); /* no more tiles */
-        }
-        else continue; /* we've got shapes */
+        if (i == tSHP->tileshpfile->numshapes) {
+          tSHP->tileshpfile->lastshape = -1;
+          return (MS_DONE); /* no more tiles */
+        } else
+          continue; /* we've got shapes */
       }
     }
 
     tSHP->shpfile->lastshape = i;
 
     msSHPReadShape(tSHP->shpfile->hSHP, i, shape);
-    if(shape->type == MS_SHAPE_NULL) {
+    if (shape->type == MS_SHAPE_NULL) {
       msFreeShape(shape);
       continue; /* skip NULL shapes */
     }
 
-    if( tSHP->sTileProj.numargs > 0 )
-    {
-      if( tSHP->reprojectorFromTileProjToLayerProj == NULL )
-      {
-          tSHP->reprojectorFromTileProjToLayerProj = msProjectCreateReprojector(&(tSHP->sTileProj), &(layer->projection));
-      }
-      if( tSHP->reprojectorFromTileProjToLayerProj )
-      {
-        msProjectShapeEx( tSHP->reprojectorFromTileProjToLayerProj, shape);
+    if (tSHP->sTileProj.numargs > 0) {
+      if (tSHP->reprojectorFromTileProjToLayerProj == NULL) {
+        tSHP->reprojectorFromTileProjToLayerProj = msProjectCreateReprojector(
+            &(tSHP->sTileProj), &(layer->projection));
+      }
+      if (tSHP->reprojectorFromTileProjToLayerProj) {
+        msProjectShapeEx(tSHP->reprojectorFromTileProjToLayerProj, shape);
       }
     }
 
     shape->tileindex = tSHP->tileshpfile->lastshape;
     shape->numvalues = layer->numitems;
-    shape->values = msDBFGetValueList(tSHP->shpfile->hDBF, i, layer->iteminfo, layer->numitems);
-    if(!shape->values) shape->numvalues = 0;
+    shape->values = msDBFGetValueList(tSHP->shpfile->hDBF, i, layer->iteminfo,
+                                      layer->numitems);
+    if (!shape->values)
+      shape->numvalues = 0;
 
-    filter_passed = MS_TRUE;  /* By default accept ANY shape */
-    if(layer->numitems > 0 && layer->iteminfo) {
-      filter_passed = msEvalExpression(layer, shape, &(layer->filter), layer->filteritemindex);
+    filter_passed = MS_TRUE; /* By default accept ANY shape */
+    if (layer->numitems > 0 && layer->iteminfo) {
+      filter_passed = msEvalExpression(layer, shape, &(layer->filter),
+                                       layer->filteritemindex);
     }
 
-    if(!filter_passed) msFreeShape(shape); /* free's values as well */
+    if (!filter_passed)
+      msFreeShape(shape); /* free's values as well */
 
-  } while(!filter_passed);  /* Loop until both spatial and attribute filters match  */
+  } while (
+      !filter_passed); /* Loop until both spatial and attribute filters match */
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
-static
-int msTiledSHPGetShape(layerObj *layer, shapeObj *shape, resultObj *record)
-{
+static int msTiledSHPGetShape(layerObj *layer, shapeObj *shape,
+                              resultObj *record) {
   const char *filename;
   char tilename[MS_MAXPATHLEN], szPath[MS_MAXPATHLEN];
 
-  msTiledSHPLayerInfo *tSHP=NULL;
+  msTiledSHPLayerInfo *tSHP = NULL;
   char tiFileAbsDir[MS_MAXPATHLEN];
 
   long shapeindex = record->shapeindex;
   int tileindex = record->tileindex;
 
-  if ( msCheckParentPointer(layer->map,"map")==MS_FAILURE )
+  if (msCheckParentPointer(layer->map, "map") == MS_FAILURE)
     return MS_FAILURE;
 
   tSHP = layer->layerinfo;
-  if(!tSHP) {
-    msSetError(MS_SHPERR, "Tiled shapefile layer has not been opened.", "msTiledSHPGetShape()");
-    return(MS_FAILURE);
+  if (!tSHP) {
+    msSetError(MS_SHPERR, "Tiled shapefile layer has not been opened.",
+               "msTiledSHPGetShape()");
+    return (MS_FAILURE);
   }
 
   msTileIndexAbsoluteDir(tiFileAbsDir, layer);
 
-  if((tileindex < 0) || (tileindex >= tSHP->tileshpfile->numshapes)) return(MS_FAILURE); /* invalid tile id */
+  if ((tileindex < 0) || (tileindex >= tSHP->tileshpfile->numshapes))
+    return (MS_FAILURE); /* invalid tile id */
 
-  if(tileindex != tSHP->tileshpfile->lastshape) { /* correct tile is not currenly open so open the correct tile */
-    msShapefileClose(tSHP->shpfile); /* close current tile */
-
-    filename = msTiledSHPLoadEntry(layer, tileindex, tilename, sizeof(tilename));
-
-    /* open the shapefile, since a specific tile was request an error should be generated if that tile does not exist */
-    if(strlen(filename) == 0) return(MS_FAILURE);
-    if(msShapefileOpen(tSHP->shpfile, "rb", msBuildPath3(szPath, tiFileAbsDir, layer->map->shapepath, filename), MS_TRUE) == -1) {
-      if(msShapefileOpen(tSHP->shpfile, "rb", msBuildPath3(szPath, layer->map->mappath, layer->map->shapepath, filename), MS_TRUE) == -1) {
-        if(msShapefileOpen(tSHP->shpfile, "rb", msBuildPath(szPath, layer->map->mappath, filename), MS_TRUE) == -1) {
-          return(MS_FAILURE);
+  if (tileindex !=
+      tSHP->tileshpfile->lastshape) { /* correct tile is not currenly open so
+                                         open the correct tile */
+    msShapefileClose(tSHP->shpfile);  /* close current tile */
+
+    filename =
+        msTiledSHPLoadEntry(layer, tileindex, tilename, sizeof(tilename));
+
+    /* open the shapefile, since a specific tile was request an error should be
+     * generated if that tile does not exist */
+    if (strlen(filename) == 0)
+      return (MS_FAILURE);
+    if (msShapefileOpen(
+            tSHP->shpfile, "rb",
+            msBuildPath3(szPath, tiFileAbsDir, layer->map->shapepath, filename),
+            MS_TRUE) == -1) {
+      if (msShapefileOpen(tSHP->shpfile, "rb",
+                          msBuildPath3(szPath, layer->map->mappath,
+                                       layer->map->shapepath, filename),
+                          MS_TRUE) == -1) {
+        if (msShapefileOpen(tSHP->shpfile, "rb",
+                            msBuildPath(szPath, layer->map->mappath, filename),
+                            MS_TRUE) == -1) {
+          return (MS_FAILURE);
         }
       }
     }
-
   }
 
-  if((shapeindex < 0) || (shapeindex >= tSHP->shpfile->numshapes)) return(MS_FAILURE);
+  if ((shapeindex < 0) || (shapeindex >= tSHP->shpfile->numshapes))
+    return (MS_FAILURE);
 
   msSHPReadShape(tSHP->shpfile->hSHP, shapeindex, shape);
   tSHP->shpfile->lastshape = shapeindex;
   tSHP->tileshpfile->lastshape = tileindex;
 
-  if( tSHP->sTileProj.numargs > 0 )
-  {
-      if( tSHP->reprojectorFromTileProjToLayerProj == NULL )
-      {
-          tSHP->reprojectorFromTileProjToLayerProj = msProjectCreateReprojector(&(tSHP->sTileProj), &(layer->projection));
-      }
-      if( tSHP->reprojectorFromTileProjToLayerProj )
-      {
-        msProjectShapeEx( tSHP->reprojectorFromTileProjToLayerProj, shape);
-      }
+  if (tSHP->sTileProj.numargs > 0) {
+    if (tSHP->reprojectorFromTileProjToLayerProj == NULL) {
+      tSHP->reprojectorFromTileProjToLayerProj =
+          msProjectCreateReprojector(&(tSHP->sTileProj), &(layer->projection));
+    }
+    if (tSHP->reprojectorFromTileProjToLayerProj) {
+      msProjectShapeEx(tSHP->reprojectorFromTileProjToLayerProj, shape);
+    }
   }
 
-  if(layer->numitems > 0 && layer->iteminfo) {
+  if (layer->numitems > 0 && layer->iteminfo) {
     shape->numvalues = layer->numitems;
-    shape->values = msDBFGetValueList(tSHP->shpfile->hDBF, shapeindex, layer->iteminfo, layer->numitems);
-    if(!shape->values) return(MS_FAILURE);
+    shape->values = msDBFGetValueList(tSHP->shpfile->hDBF, shapeindex,
+                                      layer->iteminfo, layer->numitems);
+    if (!shape->values)
+      return (MS_FAILURE);
   }
 
   shape->tileindex = tileindex;
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
-static
-void msTiledSHPClose(layerObj *layer)
-{
-  msTiledSHPLayerInfo *tSHP=NULL;
+static void msTiledSHPClose(layerObj *layer) {
+  msTiledSHPLayerInfo *tSHP = NULL;
 
   tSHP = layer->layerinfo;
-  if(tSHP) {
+  if (tSHP) {
     msShapefileClose(tSHP->shpfile);
     free(tSHP->shpfile);
 
-    if(tSHP->tilelayerindex != -1) {
+    if (tSHP->tilelayerindex != -1) {
       layerObj *tlp;
-      if ( msCheckParentPointer(layer->map,"map")==MS_FAILURE )
+      if (msCheckParentPointer(layer->map, "map") == MS_FAILURE)
         return;
       tlp = (GET_LAYER(layer->map, tSHP->tilelayerindex));
       msLayerClose(tlp);
@@ -2555,111 +2728,111 @@ void msTiledSHPClose(layerObj *layer)
 /*                              msTiledSHPClose()                       */
 /* Overloaded version of msTiledSHPClose for virtual table architecture */
 /************************************************************************/
-int msTiledSHPCloseVT(layerObj *layer)
-{
+int msTiledSHPCloseVT(layerObj *layer) {
   msTiledSHPClose(layer);
   return MS_SUCCESS;
 }
 
-void msTiledSHPLayerFreeItemInfo(layerObj *layer)
-{
-  if(layer->iteminfo) {
+void msTiledSHPLayerFreeItemInfo(layerObj *layer) {
+  if (layer->iteminfo) {
     free(layer->iteminfo);
     layer->iteminfo = NULL;
   }
 }
 
-int msTiledSHPLayerInitItemInfo(layerObj *layer)
-{
-  msTiledSHPLayerInfo *tSHP=NULL;
+int msTiledSHPLayerInitItemInfo(layerObj *layer) {
+  msTiledSHPLayerInfo *tSHP = NULL;
 
   tSHP = layer->layerinfo;
-  if(!tSHP) {
-    msSetError(MS_SHPERR, "Tiled shapefile layer has not been opened.", "msTiledSHPLayerInitItemInfo()");
+  if (!tSHP) {
+    msSetError(MS_SHPERR, "Tiled shapefile layer has not been opened.",
+               "msTiledSHPLayerInitItemInfo()");
     return MS_FAILURE;
   }
 
   msTiledSHPLayerFreeItemInfo(layer);
-  layer->iteminfo = (int *) msDBFGetItemIndexes(tSHP->shpfile->hDBF, layer->items, layer->numitems);
-  if(!layer->iteminfo) return(MS_FAILURE);
+  layer->iteminfo = (int *)msDBFGetItemIndexes(tSHP->shpfile->hDBF,
+                                               layer->items, layer->numitems);
+  if (!layer->iteminfo)
+    return (MS_FAILURE);
 
   return MS_SUCCESS;
 }
 
-static void msSHPPassThroughFieldDefinitions( layerObj *layer, DBFHandle hDBF )
-{
+static void msSHPPassThroughFieldDefinitions(layerObj *layer, DBFHandle hDBF) {
   int numitems, i;
 
-  numitems = msDBFGetFieldCount( hDBF );
+  numitems = msDBFGetFieldCount(hDBF);
 
-  for(i=0; i<numitems; i++) {
+  for (i = 0; i < numitems; i++) {
     char item[16];
-    int  nWidth=0, nPrecision=0;
+    int nWidth = 0, nPrecision = 0;
     char gml_width[32], gml_precision[32];
     DBFFieldType eType;
     const char *gml_type = NULL;
 
-    eType = msDBFGetFieldInfo( hDBF, i, item, &nWidth, &nPrecision );
+    eType = msDBFGetFieldInfo(hDBF, i, item, &nWidth, &nPrecision);
 
     gml_width[0] = '\0';
     gml_precision[0] = '\0';
 
-    switch( eType ) {
-      case FTInteger:
-        gml_type = "Integer";
-        sprintf( gml_width, "%d", nWidth );
-        break;
+    switch (eType) {
+    case FTInteger:
+      gml_type = "Integer";
+      sprintf(gml_width, "%d", nWidth);
+      break;
 
-      case FTDouble:
-        gml_type = "Real";
-        sprintf( gml_width, "%d", nWidth );
-        sprintf( gml_precision, "%d", nPrecision );
-        break;
+    case FTDouble:
+      gml_type = "Real";
+      sprintf(gml_width, "%d", nWidth);
+      sprintf(gml_precision, "%d", nPrecision);
+      break;
 
-      case FTString:
-      default:
-        gml_type = "Character";
-        sprintf( gml_width, "%d", nWidth );
-        break;
+    case FTString:
+    default:
+      gml_type = "Character";
+      sprintf(gml_width, "%d", nWidth);
+      break;
     }
 
-    msUpdateGMLFieldMetadata(layer, item, gml_type, gml_width, gml_precision, 0);
-
+    msUpdateGMLFieldMetadata(layer, item, gml_type, gml_width, gml_precision,
+                             0);
   }
 }
 
-int msTiledSHPLayerGetItems(layerObj *layer)
-{
-  msTiledSHPLayerInfo *tSHP=NULL;
+int msTiledSHPLayerGetItems(layerObj *layer) {
+  msTiledSHPLayerInfo *tSHP = NULL;
   const char *value;
 
   tSHP = layer->layerinfo;
-  if(!tSHP) {
-    msSetError(MS_SHPERR, "Tiled shapefile layer has not been opened.", "msTiledSHPLayerGetItems()");
+  if (!tSHP) {
+    msSetError(MS_SHPERR, "Tiled shapefile layer has not been opened.",
+               "msTiledSHPLayerGetItems()");
     return MS_FAILURE;
   }
 
   layer->numitems = msDBFGetFieldCount(tSHP->shpfile->hDBF);
   layer->items = msDBFGetItems(tSHP->shpfile->hDBF);
-  if(!layer->items) return MS_FAILURE;
+  if (!layer->items)
+    return MS_FAILURE;
 
   /* -------------------------------------------------------------------- */
   /*      consider populating the field definitions in metadata.          */
   /* -------------------------------------------------------------------- */
-  if((value = msOWSLookupMetadata(&(layer->metadata), "G", "types")) != NULL
-      && strcasecmp(value,"auto") == 0 )
-    msSHPPassThroughFieldDefinitions( layer, tSHP->shpfile->hDBF );
+  if ((value = msOWSLookupMetadata(&(layer->metadata), "G", "types")) != NULL &&
+      strcasecmp(value, "auto") == 0)
+    msSHPPassThroughFieldDefinitions(layer, tSHP->shpfile->hDBF);
 
   return msTiledSHPLayerInitItemInfo(layer);
 }
 
-int msTiledSHPLayerGetExtent(layerObj *layer, rectObj *extent)
-{
-  msTiledSHPLayerInfo *tSHP=NULL;
+int msTiledSHPLayerGetExtent(layerObj *layer, rectObj *extent) {
+  msTiledSHPLayerInfo *tSHP = NULL;
 
   tSHP = layer->layerinfo;
-  if(!tSHP) {
-    msSetError(MS_SHPERR, "Tiled shapefile layer has not been opened.", "msTiledSHPLayerGetExtent()");
+  if (!tSHP) {
+    msSetError(MS_SHPERR, "Tiled shapefile layer has not been opened.",
+               "msTiledSHPLayerGetExtent()");
     return MS_FAILURE;
   }
 
@@ -2667,26 +2840,24 @@ int msTiledSHPLayerGetExtent(layerObj *l
   return MS_SUCCESS;
 }
 
-int msTiledSHPLayerIsOpen(layerObj *layer)
-{
-  if(layer->layerinfo)
+int msTiledSHPLayerIsOpen(layerObj *layer) {
+  if (layer->layerinfo)
     return MS_TRUE;
   else
     return MS_FALSE;
 }
 
-int msTiledSHPLayerSupportsCommonFilters(layerObj *layer)
-{
+int msTiledSHPLayerSupportsCommonFilters(layerObj *layer) {
   (void)layer;
   return MS_TRUE;
 }
 
-int msTiledSHPLayerInitializeVirtualTable(layerObj *layer)
-{
+int msTiledSHPLayerInitializeVirtualTable(layerObj *layer) {
   assert(layer != NULL);
   assert(layer->vtable != NULL);
 
-  layer->vtable->LayerSupportsCommonFilters = msTiledSHPLayerSupportsCommonFilters;
+  layer->vtable->LayerSupportsCommonFilters =
+      msTiledSHPLayerSupportsCommonFilters;
   layer->vtable->LayerInitItemInfo = msTiledSHPLayerInitItemInfo;
   layer->vtable->LayerFreeItemInfo = msTiledSHPLayerFreeItemInfo;
   layer->vtable->LayerOpen = msTiledSHPOpenFile;
@@ -2712,141 +2883,139 @@ int msTiledSHPLayerInitializeVirtualTabl
 
 /* SHAPEFILE Layer virtual table functions */
 
-void msSHPLayerFreeItemInfo(layerObj *layer)
-{
-  if(layer->iteminfo) {
+void msSHPLayerFreeItemInfo(layerObj *layer) {
+  if (layer->iteminfo) {
     free(layer->iteminfo);
     layer->iteminfo = NULL;
   }
 }
 
-int msSHPLayerInitItemInfo(layerObj *layer)
-{
+int msSHPLayerInitItemInfo(layerObj *layer) {
   shapefileObj *shpfile = layer->layerinfo;
-  if( ! shpfile) {
-    msSetError(MS_SHPERR, "Shapefile layer has not been opened.", "msSHPLayerInitItemInfo()");
+  if (!shpfile) {
+    msSetError(MS_SHPERR, "Shapefile layer has not been opened.",
+               "msSHPLayerInitItemInfo()");
     return MS_FAILURE;
   }
 
-  /* iteminfo needs to be a bit more complex, a list of indexes plus the length of the list */
+  /* iteminfo needs to be a bit more complex, a list of indexes plus the length
+   * of the list */
   msSHPLayerFreeItemInfo(layer);
-  layer->iteminfo = (int *) msDBFGetItemIndexes(shpfile->hDBF, layer->items, layer->numitems);
-  if( ! layer->iteminfo) {
+  layer->iteminfo =
+      (int *)msDBFGetItemIndexes(shpfile->hDBF, layer->items, layer->numitems);
+  if (!layer->iteminfo) {
     return MS_FAILURE;
   }
 
   return MS_SUCCESS;
 }
 
-int msSHPLayerOpen(layerObj *layer)
-{
+int msSHPLayerOpen(layerObj *layer) {
   char szPath[MS_MAXPATHLEN];
   shapefileObj *shpfile;
 
-  if(layer->layerinfo) return MS_SUCCESS; /* layer already open */
+  if (layer->layerinfo)
+    return MS_SUCCESS; /* layer already open */
 
-  if ( msCheckParentPointer(layer->map,"map")==MS_FAILURE )
+  if (msCheckParentPointer(layer->map, "map") == MS_FAILURE)
     return MS_FAILURE;
 
   /* allocate space for a shapefileObj using layer->layerinfo  */
-  shpfile = (shapefileObj *) malloc(sizeof(shapefileObj));
+  shpfile = (shapefileObj *)malloc(sizeof(shapefileObj));
   MS_CHECK_ALLOC(shpfile, sizeof(shapefileObj), MS_FAILURE);
 
-
   layer->layerinfo = shpfile;
 
-  if(msShapefileOpen(shpfile, "rb", msBuildPath3(szPath, layer->map->mappath, layer->map->shapepath, layer->data), MS_TRUE) == -1) {
-    if(msShapefileOpen(shpfile, "rb", msBuildPath(szPath, layer->map->mappath, layer->data), MS_TRUE) == -1) {
+  if (msShapefileOpen(shpfile, "rb",
+                      msBuildPath3(szPath, layer->map->mappath,
+                                   layer->map->shapepath, layer->data),
+                      MS_TRUE) == -1) {
+    if (msShapefileOpen(shpfile, "rb",
+                        msBuildPath(szPath, layer->map->mappath, layer->data),
+                        MS_TRUE) == -1) {
       layer->layerinfo = NULL;
       free(shpfile);
       return MS_FAILURE;
     }
   }
-  
+
   if (layer->projection.numargs > 0 &&
-      EQUAL(layer->projection.args[0], "auto"))
-  {
-    const char* pszPRJFilename = CPLResetExtension(szPath, "prj");
+      EQUAL(layer->projection.args[0], "auto")) {
+    const char *pszPRJFilename = CPLResetExtension(szPath, "prj");
     int bOK = MS_FALSE;
-    VSILFILE* fp = VSIFOpenL(pszPRJFilename, "rb");
-    if( fp != NULL )
-    {
-        char szPRJ[2048];
-        OGRSpatialReferenceH hSRS;
-        int nRead;
-
-        nRead = (int)VSIFReadL(szPRJ, 1, sizeof(szPRJ) - 1, fp);
-        szPRJ[nRead] = '\0';
-        hSRS = OSRNewSpatialReference(szPRJ);
-        if( hSRS != NULL )
-        {
-            if( OSRMorphFromESRI( hSRS ) == OGRERR_NONE )
-            {
-                char* pszWKT = NULL;
-                if( OSRExportToWkt( hSRS, &pszWKT ) == OGRERR_NONE )
-                {
-                    if( msOGCWKT2ProjectionObj(pszWKT, &(layer->projection),
-                                               layer->debug ) == MS_SUCCESS )
-                    {
-                        bOK = MS_TRUE;
-                    }
-                }
-                CPLFree(pszWKT);
+    VSILFILE *fp = VSIFOpenL(pszPRJFilename, "rb");
+    if (fp != NULL) {
+      char szPRJ[2048];
+      OGRSpatialReferenceH hSRS;
+      int nRead;
+
+      nRead = (int)VSIFReadL(szPRJ, 1, sizeof(szPRJ) - 1, fp);
+      szPRJ[nRead] = '\0';
+      hSRS = OSRNewSpatialReference(szPRJ);
+      if (hSRS != NULL) {
+        if (OSRMorphFromESRI(hSRS) == OGRERR_NONE) {
+          char *pszWKT = NULL;
+          if (OSRExportToWkt(hSRS, &pszWKT) == OGRERR_NONE) {
+            if (msOGCWKT2ProjectionObj(pszWKT, &(layer->projection),
+                                       layer->debug) == MS_SUCCESS) {
+              bOK = MS_TRUE;
             }
-            OSRDestroySpatialReference(hSRS);
+          }
+          CPLFree(pszWKT);
         }
+        OSRDestroySpatialReference(hSRS);
+      }
       VSIFCloseL(fp);
     }
 
-    if( bOK != MS_TRUE )
-    {
-        if( layer->debug || layer->map->debug ) {
-            msDebug( "Unable to get SRS from shapefile '%s' for layer '%s'.\n", szPath, layer->name );
-        }
+    if (bOK != MS_TRUE) {
+      if (layer->debug || layer->map->debug) {
+        msDebug("Unable to get SRS from shapefile '%s' for layer '%s'.\n",
+                szPath, layer->name);
+      }
     }
   }
 
   return MS_SUCCESS;
 }
 
-int msSHPLayerIsOpen(layerObj *layer)
-{
-  if(layer->layerinfo)
+int msSHPLayerIsOpen(layerObj *layer) {
+  if (layer->layerinfo)
     return MS_TRUE;
   else
     return MS_FALSE;
 }
 
-int msSHPLayerWhichShapes(layerObj *layer, rectObj rect, int isQuery)
-{
+int msSHPLayerWhichShapes(layerObj *layer, rectObj rect, int isQuery) {
   (void)isQuery;
   int status;
   shapefileObj *shpfile;
 
   shpfile = layer->layerinfo;
 
-  if(!shpfile) {
-    msSetError(MS_SHPERR, "Shapefile layer has not been opened.", "msSHPLayerWhichShapes()");
+  if (!shpfile) {
+    msSetError(MS_SHPERR, "Shapefile layer has not been opened.",
+               "msSHPLayerWhichShapes()");
     return MS_FAILURE;
   }
 
   status = msShapefileWhichShapes(shpfile, rect, layer->debug);
-  if(status != MS_SUCCESS) {
+  if (status != MS_SUCCESS) {
     return status;
   }
 
   return MS_SUCCESS;
 }
 
-int msSHPLayerNextShape(layerObj *layer, shapeObj *shape)
-{
+int msSHPLayerNextShape(layerObj *layer, shapeObj *shape) {
   int i;
   shapefileObj *shpfile;
 
   shpfile = layer->layerinfo;
 
-  if(!shpfile) {
-    msSetError(MS_SHPERR, "Shapefile layer has not been opened.", "msSHPLayerNextShape()");
+  if (!shpfile) {
+    msSetError(MS_SHPERR, "Shapefile layer has not been opened.",
+               "msSHPLayerNextShape()");
     return MS_FAILURE;
   }
 
@@ -2857,22 +3026,24 @@ int msSHPLayerNextShape(layerObj *layer,
 
   i = msGetNextBit(shpfile->status, shpfile->lastshape + 1, shpfile->numshapes);
   shpfile->lastshape = i;
-  if(i == -1) return(MS_DONE); /* nothing else to read */
+  if (i == -1)
+    return (MS_DONE); /* nothing else to read */
 
   msSHPReadShape(shpfile->hSHP, i, shape);
-  if(shape->type == MS_SHAPE_NULL) {
+  if (shape->type == MS_SHAPE_NULL) {
     msFreeShape(shape);
     return msSHPLayerNextShape(layer, shape); /* skip NULL shapes */
   }
   shape->numvalues = layer->numitems;
-  shape->values = msDBFGetValueList(shpfile->hDBF, i, layer->iteminfo, layer->numitems);
-  if(!shape->values) shape->numvalues = 0;
+  shape->values =
+      msDBFGetValueList(shpfile->hDBF, i, layer->iteminfo, layer->numitems);
+  if (!shape->values)
+    shape->numvalues = 0;
 
   return MS_SUCCESS;
 }
 
-int msSHPLayerGetShape(layerObj *layer, shapeObj *shape, resultObj *record)
-{
+int msSHPLayerGetShape(layerObj *layer, shapeObj *shape, resultObj *record) {
   shapefileObj *shpfile;
   long shapeindex;
 
@@ -2880,22 +3051,26 @@ int msSHPLayerGetShape(layerObj *layer,
 
   shapeindex = record->shapeindex;
 
-  if(!shpfile) {
-    msSetError(MS_SHPERR, "Shapefile layer has not been opened.", "msSHPLayerGetShape()");
+  if (!shpfile) {
+    msSetError(MS_SHPERR, "Shapefile layer has not been opened.",
+               "msSHPLayerGetShape()");
     return MS_FAILURE;
   }
 
-  /* msSHPReadShape *should* return success or failure so we don't have to test here */
-  if(shapeindex < 0 || shapeindex >= shpfile->numshapes) {
+  /* msSHPReadShape *should* return success or failure so we don't have to test
+   * here */
+  if (shapeindex < 0 || shapeindex >= shpfile->numshapes) {
     msSetError(MS_MISCERR, "Invalid feature id.", "msSHPLayerGetShape()");
     return MS_FAILURE;
   }
 
   msSHPReadShape(shpfile->hSHP, shapeindex, shape);
-  if(layer->numitems > 0 && layer->iteminfo) {
+  if (layer->numitems > 0 && layer->iteminfo) {
     shape->numvalues = layer->numitems;
-    shape->values = msDBFGetValueList(shpfile->hDBF, shapeindex, layer->iteminfo, layer->numitems);
-    if(!shape->values) return MS_FAILURE;
+    shape->values = msDBFGetValueList(shpfile->hDBF, shapeindex,
+                                      layer->iteminfo, layer->numitems);
+    if (!shape->values)
+      return MS_FAILURE;
   }
 
   shpfile->lastshape = shapeindex;
@@ -2903,11 +3078,11 @@ int msSHPLayerGetShape(layerObj *layer,
   return MS_SUCCESS;
 }
 
-int msSHPLayerClose(layerObj *layer)
-{
+int msSHPLayerClose(layerObj *layer) {
   shapefileObj *shpfile;
   shpfile = layer->layerinfo;
-  if(!shpfile) return MS_SUCCESS; /* nothing to do */
+  if (!shpfile)
+    return MS_SUCCESS; /* nothing to do */
 
   msShapefileClose(shpfile);
   free(layer->layerinfo);
@@ -2916,47 +3091,46 @@ int msSHPLayerClose(layerObj *layer)
   return MS_SUCCESS;
 }
 
-int msSHPLayerGetItems(layerObj *layer)
-{
+int msSHPLayerGetItems(layerObj *layer) {
   shapefileObj *shpfile;
   const char *value;
 
   shpfile = layer->layerinfo;
 
-  if(!shpfile) {
-    msSetError(MS_SHPERR, "Shapefile layer has not been opened.", "msSHPLayerGetItems()");
+  if (!shpfile) {
+    msSetError(MS_SHPERR, "Shapefile layer has not been opened.",
+               "msSHPLayerGetItems()");
     return MS_FAILURE;
   }
 
   layer->numitems = msDBFGetFieldCount(shpfile->hDBF);
   layer->items = msDBFGetItems(shpfile->hDBF);
-  if(layer->numitems == 0) return MS_SUCCESS; /* No items is a valid case (#3147) */
-  if(!layer->items) return MS_FAILURE;
+  if (layer->numitems == 0)
+    return MS_SUCCESS; /* No items is a valid case (#3147) */
+  if (!layer->items)
+    return MS_FAILURE;
 
   /* -------------------------------------------------------------------- */
   /*      consider populating the field definitions in metadata.          */
   /* -------------------------------------------------------------------- */
-  if((value = msOWSLookupMetadata(&(layer->metadata), "G", "types")) != NULL
-      && strcasecmp(value,"auto") == 0 )
-    msSHPPassThroughFieldDefinitions( layer, shpfile->hDBF );
+  if ((value = msOWSLookupMetadata(&(layer->metadata), "G", "types")) != NULL &&
+      strcasecmp(value, "auto") == 0)
+    msSHPPassThroughFieldDefinitions(layer, shpfile->hDBF);
 
   return msLayerInitItemInfo(layer);
 }
 
-int msSHPLayerGetExtent(layerObj *layer, rectObj *extent)
-{
-  *extent = ((shapefileObj*)layer->layerinfo)->bounds;
+int msSHPLayerGetExtent(layerObj *layer, rectObj *extent) {
+  *extent = ((shapefileObj *)layer->layerinfo)->bounds;
   return MS_SUCCESS;
 }
 
-int msSHPLayerSupportsCommonFilters(layerObj *layer)
-{
+int msSHPLayerSupportsCommonFilters(layerObj *layer) {
   (void)layer;
   return MS_TRUE;
 }
 
-int msSHPLayerInitializeVirtualTable(layerObj *layer)
-{
+int msSHPLayerInitializeVirtualTable(layerObj *layer) {
   assert(layer != NULL);
   assert(layer->vtable != NULL);
 
diff -pruN 8.0.1-5/mapshape.h 8.0.2-1/mapshape.h
--- 8.0.1-5/mapshape.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapshape.h	2024-06-11 20:41:34.000000000 +0000
@@ -45,19 +45,19 @@ extern "C" {
 #ifndef SWIG
 #define MS_PATH_LENGTH 1024
 
-  /* Shapefile types */
+/* Shapefile types */
 #define SHP_POINT 1
 #define SHP_ARC 3
 #define SHP_POLYGON 5
 #define SHP_MULTIPOINT 8
 
 #define SHP_POINTZ 11
-#define SHP_ARCZ  13
+#define SHP_ARCZ 13
 #define SHP_POLYGONZ 15
 #define SHP_MULTIPOINTZ 18
 
 #define SHP_POINTM 21
-#define SHP_ARCM  23
+#define SHP_ARCM 23
 #define SHP_POLYGONM 25
 #define SHP_MULTIPOINTM 28
 #endif
@@ -68,178 +68,203 @@ extern "C" {
 #define MS_SHAPEFILE_MULTIPOINT 8
 
 #define MS_SHP_POINTZ 11
-#define MS_SHP_ARCZ  13
+#define MS_SHP_ARCZ 13
 #define MS_SHP_POLYGONZ 15
 #define MS_SHP_MULTIPOINTZ 18
 
 #define MS_SHP_POINTM 21
-#define MS_SHP_ARCM  23
+#define MS_SHP_ARCM 23
 #define MS_SHP_POLYGONM 25
 #define MS_SHP_MULTIPOINTM 28
 
 #ifndef SWIG
-  typedef unsigned char uchar;
+typedef unsigned char uchar;
 
-  typedef struct {
-    VSILFILE  *fpSHP;
-    VSILFILE  *fpSHX;
+typedef struct {
+  VSILFILE *fpSHP;
+  VSILFILE *fpSHX;
 
-    int   nShapeType;       /* SHPT_* */
-    int   nFileSize;        /* SHP file */
+  int nShapeType; /* SHPT_* */
+  int nFileSize;  /* SHP file */
 
-    int   nRecords;
-    int   nMaxRecords;
+  int nRecords;
+  int nMaxRecords;
 
-    int   *panRecOffset;
-    int   *panRecSize;
-    ms_bitarray panRecLoaded;
-    int   panRecAllLoaded;
+  int *panRecOffset;
+  int *panRecSize;
+  ms_bitarray panRecLoaded;
+  int panRecAllLoaded;
 
-    double  adBoundsMin[4];
-    double  adBoundsMax[4];
+  double adBoundsMin[4];
+  double adBoundsMax[4];
 
-    int   bUpdated;
+  int bUpdated;
 
-    int   nBufSize; /* these used static vars in shape readers, moved to be thread-safe */
-    uchar   *pabyRec;
-    int   nPartMax;
-    int   *panParts;
+  int nBufSize; /* these used static vars in shape readers, moved to be
+                   thread-safe */
+  uchar *pabyRec;
+  int nPartMax;
+  int *panParts;
 
-  } SHPInfo;
-  typedef SHPInfo * SHPHandle;
+} SHPInfo;
+typedef SHPInfo *SHPHandle;
 #endif
 
-  /************************************************************************/
-  /*                          DBFInfo                                     */
-  /************************************************************************/
+/************************************************************************/
+/*                          DBFInfo                                     */
+/************************************************************************/
 
 /**
  * An object containing information about a DBF file
  *
  */
-  typedef struct {
+typedef struct {
 #ifdef SWIG
     %immutable;
 #endif
 
-    int   nRecords; ///< Number of records in the DBF
-    int   nFields; ///< Number of fields in the DBF
-
+  int nRecords; ///< Number of records in the DBF
+  int nFields;  ///< Number of fields in the DBF
 
 #ifndef SWIG
-    VSILFILE  *fp;
-    unsigned int nRecordLength;
-    int   nHeaderLength;
-
-    int   *panFieldOffset;
-    int   *panFieldSize;
-    int   *panFieldDecimals;
-    char  *pachFieldType;
-
-    char  *pszHeader;
-
-    int   nCurrentRecord;
-    int   bCurrentRecordModified;
-    char  *pszCurrentRecord;
+  VSILFILE *fp;
+  unsigned int nRecordLength;
+  int nHeaderLength;
+
+  int *panFieldOffset;
+  int *panFieldSize;
+  int *panFieldDecimals;
+  char *pachFieldType;
+
+  char *pszHeader;
+
+  int nCurrentRecord;
+  int bCurrentRecordModified;
+  char *pszCurrentRecord;
 
-    int   bNoHeader;
-    int   bUpdated;
+  int bNoHeader;
+  int bUpdated;
 
-    char  *pszStringField;
-    int   nStringFieldLen;
+  char *pszStringField;
+  int nStringFieldLen;
 #endif /* not SWIG */
-  } DBFInfo;
+} DBFInfo;
 
-  typedef DBFInfo * DBFHandle;
+typedef DBFInfo *DBFHandle;
 
-  typedef enum {FTString, FTInteger, FTDouble, FTInvalid} DBFFieldType;
+typedef enum { FTString, FTInteger, FTDouble, FTInvalid } DBFFieldType;
 
-  /************************************************************************/
-  /*                          shapefileObj                                */
-  /************************************************************************/
+/************************************************************************/
+/*                          shapefileObj                                */
+/************************************************************************/
 
 /**
  * An object representing a Shapefile. There is no write access to this object
  * using MapScript.
  */
-  typedef struct {
+typedef struct {
 #ifdef SWIG
     %immutable;
 #endif
 
-    int type; ///< Shapefile type - see mapshape.h for values of type
-    int numshapes; ///< Number of shapes
-    rectObj bounds; ///< Extent of shapes
+  int type;       ///< Shapefile type - see mapshape.h for values of type
+  int numshapes;  ///< Number of shapes
+  rectObj bounds; ///< Extent of shapes
 
 #ifndef SWIG
-    char source[MS_PATH_LENGTH]; /* full path to this file data */
-    int lastshape;
-    ms_bitarray status;
-    int isopen;
-    SHPHandle hSHP; /* SHP/SHX file pointer */
-    DBFHandle hDBF; /* DBF file pointer */
+  char source[MS_PATH_LENGTH]; /* full path to this file data */
+  int lastshape;
+  ms_bitarray status;
+  int isopen;
+  SHPHandle hSHP; /* SHP/SHX file pointer */
+  DBFHandle hDBF; /* DBF file pointer */
 #endif
 
-  } shapefileObj;
+} shapefileObj;
 
 #ifndef SWIG
-  /* layerInfo structure for tiled shapefiles */
-  typedef struct {
-    shapefileObj *shpfile;
-    shapefileObj *tileshpfile;
-    int tilelayerindex;
-    projectionObj sTileProj;
-    rectObj searchrect;
-    reprojectionObj* reprojectorFromTileProjToLayerProj;
-  } msTiledSHPLayerInfo;
-
-  /* shapefileObj function prototypes  */
-  MS_DLL_EXPORT int msShapefileOpenHandle(shapefileObj *shpfile, const char *filename, SHPHandle hSHP, DBFHandle hDBF);
-  MS_DLL_EXPORT int msShapefileOpenVirtualFile(shapefileObj *shpfile, const char *filename, VSILFILE * fpSHP, VSILFILE * fpSHX, VSILFILE * fpDBF, int log_failures);
-  MS_DLL_EXPORT int msShapefileOpen(shapefileObj *shpfile, const char *mode, const char *filename, int log_failures);
-  MS_DLL_EXPORT int msShapefileCreate(shapefileObj *shpfile, char *filename, int type);
-  MS_DLL_EXPORT void msShapefileClose(shapefileObj *shpfile);
-  MS_DLL_EXPORT int msShapefileWhichShapes(shapefileObj *shpfile, rectObj rect, int debug);
-
-  /* SHP/SHX function prototypes */
-  MS_DLL_EXPORT SHPHandle msSHPOpenVirtualFile( VSILFILE * fpSHP, VSILFILE * fpSHX );
-  MS_DLL_EXPORT SHPHandle msSHPOpen( const char * pszShapeFile, const char * pszAccess );
-  MS_DLL_EXPORT SHPHandle msSHPCreate( const char * pszShapeFile, int nShapeType );
-  MS_DLL_EXPORT void msSHPClose( SHPHandle hSHP );
-  MS_DLL_EXPORT void msSHPGetInfo( SHPHandle hSHP, int * pnEntities, int * pnShapeType );
-  MS_DLL_EXPORT int msSHPReadBounds( SHPHandle psSHP, int hEntity, rectObj *padBounds );
-  MS_DLL_EXPORT void msSHPReadShape( SHPHandle psSHP, int hEntity, shapeObj *shape );
-  MS_DLL_EXPORT int msSHPReadPoint(SHPHandle psSHP, int hEntity, pointObj *point );
-  MS_DLL_EXPORT int msSHPWriteShape( SHPHandle psSHP, shapeObj *shape );
-  MS_DLL_EXPORT int msSHPWritePoint(SHPHandle psSHP, pointObj *point );
-
-  /* tiledShapefileObj function prototypes are in mapserver.h */
-
-  /* XBase function prototypes */
-  MS_DLL_EXPORT DBFHandle msDBFOpenVirtualFile( VSILFILE * fp );
-  MS_DLL_EXPORT DBFHandle msDBFOpen( const char * pszDBFFile, const char * pszAccess );
-  MS_DLL_EXPORT void msDBFClose( DBFHandle hDBF );
-  MS_DLL_EXPORT DBFHandle msDBFCreate( const char * pszDBFFile );
-
-  MS_DLL_EXPORT int msDBFGetFieldCount( DBFHandle psDBF );
-  MS_DLL_EXPORT int msDBFGetRecordCount( DBFHandle psDBF );
-  MS_DLL_EXPORT int msDBFAddField( DBFHandle hDBF, const char * pszFieldName, DBFFieldType eType, int nWidth, int nDecimals );
-
-  MS_DLL_EXPORT DBFFieldType msDBFGetFieldInfo( DBFHandle psDBF, int iField, char * pszFieldName, int * pnWidth, int * pnDecimals );
-
-  MS_DLL_EXPORT int msDBFReadIntegerAttribute( DBFHandle hDBF, int iShape, int iField );
-  MS_DLL_EXPORT double msDBFReadDoubleAttribute( DBFHandle hDBF, int iShape, int iField );
-  MS_DLL_EXPORT const char *msDBFReadStringAttribute( DBFHandle hDBF, int iShape, int iField );
-
-  MS_DLL_EXPORT int msDBFWriteIntegerAttribute( DBFHandle hDBF, int iShape, int iField, int nFieldValue );
-  MS_DLL_EXPORT int msDBFWriteDoubleAttribute( DBFHandle hDBF, int iShape, int iField, double dFieldValue );
-  MS_DLL_EXPORT int msDBFWriteStringAttribute( DBFHandle hDBF, int iShape, int iField, const char * pszFieldValue );
-
-  MS_DLL_EXPORT char **msDBFGetItems(DBFHandle dbffile);
-  MS_DLL_EXPORT char **msDBFGetValues(DBFHandle dbffile, int record);
-  MS_DLL_EXPORT char **msDBFGetValueList(DBFHandle dbffile, int record, int *itemindexes, int numitems);
-  MS_DLL_EXPORT int *msDBFGetItemIndexes(DBFHandle dbffile, char **items, int numitems);
-  MS_DLL_EXPORT int msDBFGetItemIndex(DBFHandle dbffile, char *name);
+/* layerInfo structure for tiled shapefiles */
+typedef struct {
+  shapefileObj *shpfile;
+  shapefileObj *tileshpfile;
+  int tilelayerindex;
+  projectionObj sTileProj;
+  rectObj searchrect;
+  reprojectionObj *reprojectorFromTileProjToLayerProj;
+} msTiledSHPLayerInfo;
+
+/* shapefileObj function prototypes  */
+MS_DLL_EXPORT int msShapefileOpenHandle(shapefileObj *shpfile,
+                                        const char *filename, SHPHandle hSHP,
+                                        DBFHandle hDBF);
+MS_DLL_EXPORT int msShapefileOpenVirtualFile(shapefileObj *shpfile,
+                                             const char *filename,
+                                             VSILFILE *fpSHP, VSILFILE *fpSHX,
+                                             VSILFILE *fpDBF, int log_failures);
+MS_DLL_EXPORT int msShapefileOpen(shapefileObj *shpfile, const char *mode,
+                                  const char *filename, int log_failures);
+MS_DLL_EXPORT int msShapefileCreate(shapefileObj *shpfile, char *filename,
+                                    int type);
+MS_DLL_EXPORT void msShapefileClose(shapefileObj *shpfile);
+MS_DLL_EXPORT int msShapefileWhichShapes(shapefileObj *shpfile, rectObj rect,
+                                         int debug);
+
+/* SHP/SHX function prototypes */
+MS_DLL_EXPORT SHPHandle msSHPOpenVirtualFile(VSILFILE *fpSHP, VSILFILE *fpSHX);
+MS_DLL_EXPORT SHPHandle msSHPOpen(const char *pszShapeFile,
+                                  const char *pszAccess);
+MS_DLL_EXPORT SHPHandle msSHPCreate(const char *pszShapeFile, int nShapeType);
+MS_DLL_EXPORT void msSHPClose(SHPHandle hSHP);
+MS_DLL_EXPORT void msSHPGetInfo(SHPHandle hSHP, int *pnEntities,
+                                int *pnShapeType);
+MS_DLL_EXPORT int msSHPReadBounds(SHPHandle psSHP, int hEntity,
+                                  rectObj *padBounds);
+MS_DLL_EXPORT void msSHPReadShape(SHPHandle psSHP, int hEntity,
+                                  shapeObj *shape);
+MS_DLL_EXPORT int msSHPReadPoint(SHPHandle psSHP, int hEntity, pointObj *point);
+MS_DLL_EXPORT int msSHPWriteShape(SHPHandle psSHP, shapeObj *shape);
+MS_DLL_EXPORT int msSHPWritePoint(SHPHandle psSHP, pointObj *point);
+
+/* tiledShapefileObj function prototypes are in mapserver.h */
+
+/* XBase function prototypes */
+MS_DLL_EXPORT DBFHandle msDBFOpenVirtualFile(VSILFILE *fp);
+MS_DLL_EXPORT DBFHandle msDBFOpen(const char *pszDBFFile,
+                                  const char *pszAccess);
+MS_DLL_EXPORT void msDBFClose(DBFHandle hDBF);
+MS_DLL_EXPORT DBFHandle msDBFCreate(const char *pszDBFFile);
+
+MS_DLL_EXPORT int msDBFGetFieldCount(DBFHandle psDBF);
+MS_DLL_EXPORT int msDBFGetRecordCount(DBFHandle psDBF);
+MS_DLL_EXPORT int msDBFAddField(DBFHandle hDBF, const char *pszFieldName,
+                                DBFFieldType eType, int nWidth, int nDecimals);
+
+MS_DLL_EXPORT DBFFieldType msDBFGetFieldInfo(DBFHandle psDBF, int iField,
+                                             char *pszFieldName, int *pnWidth,
+                                             int *pnDecimals);
+
+MS_DLL_EXPORT int msDBFReadIntegerAttribute(DBFHandle hDBF, int iShape,
+                                            int iField);
+MS_DLL_EXPORT double msDBFReadDoubleAttribute(DBFHandle hDBF, int iShape,
+                                              int iField);
+MS_DLL_EXPORT const char *msDBFReadStringAttribute(DBFHandle hDBF, int iShape,
+                                                   int iField);
+
+MS_DLL_EXPORT int msDBFWriteIntegerAttribute(DBFHandle hDBF, int iShape,
+                                             int iField, int nFieldValue);
+MS_DLL_EXPORT int msDBFWriteDoubleAttribute(DBFHandle hDBF, int iShape,
+                                            int iField, double dFieldValue);
+MS_DLL_EXPORT int msDBFWriteStringAttribute(DBFHandle hDBF, int iShape,
+                                            int iField,
+                                            const char *pszFieldValue);
+
+MS_DLL_EXPORT char **msDBFGetItems(DBFHandle dbffile);
+MS_DLL_EXPORT char **msDBFGetValues(DBFHandle dbffile, int record);
+MS_DLL_EXPORT char **msDBFGetValueList(DBFHandle dbffile, int record,
+                                       int *itemindexes, int numitems);
+MS_DLL_EXPORT int *msDBFGetItemIndexes(DBFHandle dbffile, char **items,
+                                       int numitems);
+MS_DLL_EXPORT int msDBFGetItemIndex(DBFHandle dbffile, char *name);
 
 #endif
 
diff -pruN 8.0.1-5/mapsmoothing.c 8.0.2-1/mapsmoothing.c
--- 8.0.1-5/mapsmoothing.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapsmoothing.c	2024-06-11 20:41:34.000000000 +0000
@@ -31,7 +31,7 @@
 #include "mapserver.h"
 
 #define FP_EPSILON 1e-12
-#define FP_EQ(a, b) (fabs((a)-(b)) < FP_EPSILON)
+#define FP_EQ(a, b) (fabs((a) - (b)) < FP_EPSILON)
 
 /* Internal Use, represent a line window (points) */
 typedef struct {
@@ -39,35 +39,29 @@ typedef struct {
   int size;
   int index; /* index of the current point in points array */
   lineObj *line;
-  int lineIsRing; /* closed ring? */  
+  int lineIsRing; /* closed ring? */
   pointObj **points;
 } lineWindow;
 
-static void initLineWindow(lineWindow *lw, lineObj *line, int size)
-{ 
+static void initLineWindow(lineWindow *lw, lineObj *line, int size) {
   lw->pos = -1;
   lw->lineIsRing = MS_FALSE;
   lw->size = size;
   lw->line = line;
-  lw->index = floor(lw->size/2); /* index of current position in points array */
-  lw->points = (pointObj**)msSmallMalloc(sizeof(pointObj*)*size);
-  
-  if ( (line->numpoints >= 2) &&
-       ((FP_EQ(line->point[0].x,
-               line->point[line->numpoints-1].x)) &&
-        (FP_EQ(line->point[0].y,
-               line->point[line->numpoints-1].y))) ) {
-    lw->lineIsRing = 1; 
+  lw->index =
+      floor(lw->size / 2); /* index of current position in points array */
+  lw->points = (pointObj **)msSmallMalloc(sizeof(pointObj *) * size);
+
+  if ((line->numpoints >= 2) &&
+      ((FP_EQ(line->point[0].x, line->point[line->numpoints - 1].x)) &&
+       (FP_EQ(line->point[0].y, line->point[line->numpoints - 1].y)))) {
+    lw->lineIsRing = 1;
   }
 }
 
-static void freeLineWindow(lineWindow *lw)
-{  
-  free(lw->points);
-}
+static void freeLineWindow(lineWindow *lw) { free(lw->points); }
 
-static int nextLineWindow(lineWindow *lw)
-{
+static int nextLineWindow(lineWindow *lw) {
   int i;
 
   if (++lw->pos >= lw->line->numpoints)
@@ -75,63 +69,62 @@ static int nextLineWindow(lineWindow *lw
 
   lw->points[lw->index] = &lw->line->point[lw->pos];
 
-  for (i=0;i<lw->index;++i) {
+  for (i = 0; i < lw->index; ++i) {
     int r, l;
-    r = lw->pos-(i+1);
-    l = lw->pos+(i+1);
+    r = lw->pos - (i + 1);
+    l = lw->pos + (i + 1);
 
     /* adjust values */
     if ((r < 0) && lw->lineIsRing)
-      r = lw->line->numpoints-(i+2);
+      r = lw->line->numpoints - (i + 2);
     if ((l >= lw->line->numpoints) && lw->lineIsRing)
-      l = 1+(l-lw->line->numpoints);
-    
+      l = 1 + (l - lw->line->numpoints);
+
     /* return if the window in not valid.. */
-    if (r<0 || l>=lw->line->numpoints)
+    if (r < 0 || l >= lw->line->numpoints)
       return MS_FALSE;
-    
-    lw->points[lw->index-(i+1)] = &lw->line->point[r];
-    lw->points[lw->index+(i+1)] = &lw->line->point[l];
+
+    lw->points[lw->index - (i + 1)] = &lw->line->point[r];
+    lw->points[lw->index + (i + 1)] = &lw->line->point[l];
   }
 
   return MS_TRUE;
 }
 
-/* Calculates the distance ratio between the total distance of a path and the distance
-   between the first and last point (to detect a loop). */
-static double computePathDistanceRatio(pointObj **points, int len)
-{
+/* Calculates the distance ratio between the total distance of a path and the
+   distance between the first and last point (to detect a loop). */
+static double computePathDistanceRatio(pointObj **points, int len) {
   double sum;
   int i;
 
-  for (sum=0,i=1;i<len;++i) {
-    sum += msDistancePointToPoint(points[i-1], points[i]);
+  for (sum = 0, i = 1; i < len; ++i) {
+    sum += msDistancePointToPoint(points[i - 1], points[i]);
   }
 
-  return sum/msDistancePointToPoint(points[0], points[len-1]);
+  return sum / msDistancePointToPoint(points[0], points[len - 1]);
 }
 
 /* Pre-Processing of a shape. It modifies the shape by adding intermediate
    points where a loop is detected to improve the smoothing result. */
-static int processShapePathDistance(shapeObj *shape, int force)
-{
+static int processShapePathDistance(shapeObj *shape, int force) {
   shapeObj initialShape, *newShape;
   int i;
-  
+
   /* initial shape to process */
-  msInitShape(&initialShape);    
+  msInitShape(&initialShape);
   msCopyShape(shape, &initialShape);
 
   newShape = shape; /* we modify the shape object directly */
   shape = &initialShape;
-  
+
   /* Clean our shape object */
-  for (i= 0; i < newShape->numlines; i++)
+  for (i = 0; i < newShape->numlines; i++)
     free(newShape->line[i].point);
   newShape->numlines = 0;
-  if (newShape->line) free(newShape->line);
-  
-  for (i=0;i<shape->numlines;++i) {
+  if (newShape->line)
+    free(newShape->line);
+
+  for (i = 0; i < shape->numlines; ++i) {
     const int windowSize = 5;
     int res;
     lineWindow lw;
@@ -144,88 +137,81 @@ static int processShapePathDistance(shap
       double ratio = 0;
       pointObj point = {0}; // initialize
 
-      if (lw.lineIsRing && lw.pos==lw.line->numpoints-1) {
+      if (lw.lineIsRing && lw.pos == lw.line->numpoints - 1) {
         point = newShape->line[i].point[0];
-        msAddPointToLine(&newShape->line[i],
-                         &point);
+        msAddPointToLine(&newShape->line[i], &point);
         continue;
       }
 
       if (res == MS_FALSE) { /* invalid window */
-        msAddPointToLine(&newShape->line[i],
-                         lw.points[lw.index]);
+        msAddPointToLine(&newShape->line[i], lw.points[lw.index]);
         continue;
       }
 
       if (!force)
         ratio = computePathDistanceRatio(lw.points, windowSize);
-                      
+
       if (force || (ratio > 1.3)) {
-        point.x = (lw.line->point[lw.pos].x + lw.points[lw.index-1]->x)/2;
-        point.y = (lw.line->point[lw.pos].y + lw.points[lw.index-1]->y)/2;
-        msAddPointToLine(&newShape->line[i],
-                         &point);
+        point.x = (lw.line->point[lw.pos].x + lw.points[lw.index - 1]->x) / 2;
+        point.y = (lw.line->point[lw.pos].y + lw.points[lw.index - 1]->y) / 2;
+        msAddPointToLine(&newShape->line[i], &point);
       }
-      
+
       point = lw.line->point[lw.pos];
-      msAddPointToLine(&newShape->line[i],
-                       &point);
-      
+      msAddPointToLine(&newShape->line[i], &point);
+
       if (force || (ratio > 1.3)) {
-        point.x = (lw.line->point[lw.pos].x + lw.points[lw.index+1]->x)/2;
-        point.y = (lw.line->point[lw.pos].y + lw.points[lw.index+1]->y)/2;
-        msAddPointToLine(&newShape->line[i],
-                         &point);
+        point.x = (lw.line->point[lw.pos].x + lw.points[lw.index + 1]->x) / 2;
+        point.y = (lw.line->point[lw.pos].y + lw.points[lw.index + 1]->y) / 2;
+        msAddPointToLine(&newShape->line[i], &point);
       }
-      
     }
-       
+
     freeLineWindow(&lw);
   }
-    
+
   msFreeShape(shape);
-  
+
   return MS_SUCCESS;
 }
 
-shapeObj* msSmoothShapeSIA(shapeObj *shape, int ss, int si, char *preprocessing)
-{
+shapeObj *msSmoothShapeSIA(shapeObj *shape, int ss, int si,
+                           char *preprocessing) {
   int i, j;
   pointObj *p;
   double *coeff;
   shapeObj *newShape;
 
-  newShape = (shapeObj *) msSmallMalloc(sizeof (shapeObj));
+  newShape = (shapeObj *)msSmallMalloc(sizeof(shapeObj));
   msInitShape(newShape);
   newShape->type = shape->type; // preserve the type
 
   if (ss < 3)
     ss = 3;
-  
+
   if (si < 1)
     si = 1;
 
   /* Apply preprocessing */
-  if (preprocessing)
-  {
+  if (preprocessing) {
     if (strcasecmp(preprocessing, "all") == 0)
       processShapePathDistance(shape, MS_TRUE);
     else if (strcasecmp(preprocessing, "angle") == 0)
       processShapePathDistance(shape, MS_FALSE);
   }
-  
-  p = (pointObj *) msSmallMalloc(ss*sizeof(pointObj));
-  coeff = (double *) msSmallMalloc(ss*sizeof (double));        
-  
-  for (i=0;i<si;++i) {
+
+  p = (pointObj *)msSmallMalloc(ss * sizeof(pointObj));
+  coeff = (double *)msSmallMalloc(ss * sizeof(double));
+
+  for (i = 0; i < si; ++i) {
     shapeObj initialShape;
-    
-    if (si > 1 && i>0) {
-      msInitShape(&initialShape);    
+
+    if (si > 1 && i > 0) {
+      msInitShape(&initialShape);
       msCopyShape(shape, &initialShape);
-      
+
       /* Clean our shape object */
-      for (j=0; j < newShape->numlines; ++j)
+      for (j = 0; j < newShape->numlines; ++j)
         free(newShape->line[j].point);
       newShape->numlines = 0;
       if (newShape->line) {
@@ -235,75 +221,71 @@ shapeObj* msSmoothShapeSIA(shapeObj *sha
 
       shape = &initialShape;
     }
-    
-    for (j=0;j<shape->numlines;++j) {
-      int k, ws, res;      
-      lineObj newLine = {0,NULL};
+
+    for (j = 0; j < shape->numlines; ++j) {
+      int k, ws, res;
+      lineObj newLine = {0, NULL};
       lineWindow lw;
 
       /* determine if we can use the ss for this line */
-      ws = ss;      
+      ws = ss;
       if (ws >= shape->line[j].numpoints) {
-        ws = shape->line[j].numpoints-1;
+        ws = shape->line[j].numpoints - 1;
       }
 
-      if (ws%2==0)
-        ws-=1;  
+      if (ws % 2 == 0)
+        ws -= 1;
 
       initLineWindow(&lw, &shape->line[j], ws);
       msAddLine(newShape, &newLine);
 
       coeff[lw.index] = 1;
-      for (k=0;k<lw.index;++k) {
-        coeff[lw.index+(k+1)] = coeff[lw.index-k]/2;
-        coeff[lw.index-(k+1)] = coeff[lw.index+k]/2;    
+      for (k = 0; k < lw.index; ++k) {
+        coeff[lw.index + (k + 1)] = coeff[lw.index - k] / 2;
+        coeff[lw.index - (k + 1)] = coeff[lw.index + k] / 2;
       }
-      
-      
+
       while ((res = nextLineWindow(&lw)) != MS_DONE) {
-        double sum_x=0, sum_y=0, sum = 0;
+        double sum_x = 0, sum_y = 0, sum = 0;
         pointObj point = {0}; // initialize
         int k = 0;
 
         if (res == MS_FALSE) { /* invalid window */
-          msAddPointToLine(&newShape->line[j],
-                           lw.points[lw.index]);
+          msAddPointToLine(&newShape->line[j], lw.points[lw.index]);
           continue;
         }
 
         /* Apply Coefficient */
         p[lw.index] = *lw.points[lw.index];
-        for (k=0; k<lw.index; ++k) {
-          p[lw.index-(k+1)] = *lw.points[lw.index-(k+1)];
-          p[lw.index-(k+1)].x *= coeff[lw.index-(k+1)];
-          p[lw.index-(k+1)].y *= coeff[lw.index-(k+1)];
-          p[lw.index+(k+1)] = *lw.points[lw.index+(k+1)];
-          p[lw.index+(k+1)].x *= coeff[lw.index+(k+1)];
-          p[lw.index+(k+1)].y *= coeff[lw.index+(k+1)];
+        for (k = 0; k < lw.index; ++k) {
+          p[lw.index - (k + 1)] = *lw.points[lw.index - (k + 1)];
+          p[lw.index - (k + 1)].x *= coeff[lw.index - (k + 1)];
+          p[lw.index - (k + 1)].y *= coeff[lw.index - (k + 1)];
+          p[lw.index + (k + 1)] = *lw.points[lw.index + (k + 1)];
+          p[lw.index + (k + 1)].x *= coeff[lw.index + (k + 1)];
+          p[lw.index + (k + 1)].y *= coeff[lw.index + (k + 1)];
         }
-        
-        for (k=0; k<lw.size; ++k) {
+
+        for (k = 0; k < lw.size; ++k) {
           sum += coeff[k];
           sum_x += p[k].x;
-          sum_y += p[k].y;          
+          sum_y += p[k].y;
         }
-      
-        point.x = sum_x/sum;
-        point.y = sum_y/sum;
-        msAddPointToLine(&newShape->line[j],
-                         &point);
+
+        point.x = sum_x / sum;
+        point.y = sum_y / sum;
+        msAddPointToLine(&newShape->line[j], &point);
       }
 
-      freeLineWindow(&lw);      
+      freeLineWindow(&lw);
     }
-    
-    if (i>0) {
+
+    if (i > 0) {
       msFreeShape(shape);
       shape = newShape;
     }
-    
   }
-  
+
   free(p);
   free(coeff);
 
diff -pruN 8.0.1-5/mapstring.cpp 8.0.2-1/mapstring.cpp
--- 8.0.1-5/mapstring.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapstring.cpp	2024-06-11 20:41:34.000000000 +0000
@@ -5,8 +5,8 @@
  * Purpose:  Various string handling functions.
  * Author:   Steve Lime and the MapServer team.
  *
- * Notes: A couple of string handling functions (strrstr, strlcat) were taken from
- * other sources. Copyright notices accompany those functions below.
+ * Notes: A couple of string handling functions (strrstr, strlcat) were taken
+ *from other sources. Copyright notices accompany those functions below.
  *
  ******************************************************************************
  * Copyright (c) 1996-2005 Regents of the University of Minnesota.
@@ -101,8 +101,7 @@
 ** TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
 ** OR THE USE OR OTHER DEALINGS WITH THE SOFTWARE.
 */
-char *strrstr(const char *string, const char *find)
-{
+char *strrstr(const char *string, const char *find) {
   size_t stringlen, findlen;
   const char *cp;
 
@@ -113,7 +112,7 @@ char *strrstr(const char *string, const
 
   for (cp = string + stringlen - findlen; cp >= string; cp--)
     if (strncmp(cp, find, findlen) == 0)
-      return (char*) cp;
+      return (char *)cp;
 
   return NULL;
 }
@@ -143,8 +142,7 @@ char *strrstr(const char *string, const
  * Returns strlen(src) + MS_MIN(siz, strlen(initial dst)).
  * If retval >= siz, truncation occurred.
  */
-size_t strlcat(char *dst, const char *src, size_t siz)
-{
+size_t strlcat(char *dst, const char *src, size_t siz) {
   char *d = dst;
   const char *s = src;
   size_t n = siz;
@@ -157,7 +155,7 @@ size_t strlcat(char *dst, const char *sr
   n = siz - dlen;
 
   if (n == 0)
-    return(dlen + strlen(s));
+    return (dlen + strlen(s));
   while (*s != '\0') {
     if (n != 1) {
       *d++ = *s;
@@ -167,7 +165,7 @@ size_t strlcat(char *dst, const char *sr
   }
   *d = '\0';
 
-  return(dlen + (s - src));/* count does not include NUL */
+  return (dlen + (s - src)); /* count does not include NUL */
 }
 #endif
 
@@ -204,9 +202,7 @@ size_t strlcat(char *dst, const char *sr
  * will be copied.  Always NUL terminates (unless siz == 0).
  * Returns strlen(src); if retval >= siz, truncation occurred.
  */
-size_t
-strlcpy(char *dst, const char *src, size_t siz)
-{
+size_t strlcpy(char *dst, const char *src, size_t siz) {
   char *d = dst;
   const char *s = src;
   size_t n = siz;
@@ -222,12 +218,12 @@ strlcpy(char *dst, const char *src, size
   /* Not enough room in dst, add NUL and traverse rest of src */
   if (n == 0) {
     if (siz != 0)
-      *d = '\0';              /* NUL-terminate dst */
+      *d = '\0'; /* NUL-terminate dst */
     while (*s++)
       ;
   }
 
-  return(s - src - 1);    /* count does not include NUL */
+  return (s - src - 1); /* count does not include NUL */
 }
 #endif
 
@@ -263,8 +259,7 @@ strlcpy(char *dst, const char *src, size
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  */
-char *strcasestr(const char *s, const char *find)
-{
+char *strcasestr(const char *s, const char *find) {
   char c, sc;
   size_t len;
 
@@ -284,131 +279,129 @@ char *strcasestr(const char *s, const ch
 #endif
 
 #ifndef HAVE_STRNCASECMP
-int strncasecmp(const char *s1, const char *s2, size_t len)
-{
+int strncasecmp(const char *s1, const char *s2, size_t len) {
   const char *cp1, *cp2;
 
   cp1 = s1;
   cp2 = s2;
 
-  if(len == 0)
-    return(0);
+  if (len == 0)
+    return (0);
 
   if (!*cp1)
     return -1;
   else if (!*cp2)
     return 1;
 
-  while(*cp1 && *cp2 && len) {
+  while (*cp1 && *cp2 && len) {
     int cmp;
-    if((cmp = (toupper(*cp1) - toupper(*cp2))) != 0)
-      return(cmp);
+    if ((cmp = (toupper(*cp1) - toupper(*cp2))) != 0)
+      return (cmp);
     cp1++;
     cp2++;
     len--;
   }
 
-  if(len == 0) {
-    return(0);
+  if (len == 0) {
+    return (0);
   }
-  if(*cp1 || *cp2) {
+  if (*cp1 || *cp2) {
     if (*cp1)
-      return(1);
+      return (1);
     else
       return (-1);
   }
-  return(0);
+  return (0);
 }
 #endif
 
 #ifndef HAVE_STRCASECMP
-int strcasecmp(const char *s1, const char *s2)
-{
+int strcasecmp(const char *s1, const char *s2) {
   const char *cp1, *cp2;
 
   cp1 = s1;
   cp2 = s2;
-  if ((!cp1) || (!cp2 )) {
+  if ((!cp1) || (!cp2)) {
     return (0);
   }
-  while(*cp1 && *cp2) {
+  while (*cp1 && *cp2) {
     int cmp;
-    if((cmp = (toupper(*cp1) - toupper(*cp2))) != 0)
-      return(cmp);
+    if ((cmp = (toupper(*cp1) - toupper(*cp2))) != 0)
+      return (cmp);
     cp1++;
     cp2++;
   }
-  if(*cp1 || *cp2) {
+  if (*cp1 || *cp2) {
     if (*cp1)
-      return(1);
+      return (1);
     else
       return (-1);
   }
 
-  return(0);
+  return (0);
 }
 #endif
 
 /*
-** msStringToInt() and msStringToDouble() are helper functions to convert strings to numbers. They
-** return MS_FAILURE if the input string is NULL or if the entire string did not convert successfully.
+** msStringToInt() and msStringToDouble() are helper functions to convert
+*strings to numbers. They
+** return MS_FAILURE if the input string is NULL or if the entire string did not
+*convert successfully.
 */
-int msStringToInt(const char *str, int *value, int base)
-{
+int msStringToInt(const char *str, int *value, int base) {
   char *parse_check = NULL;
 
-  if(!str) return MS_FAILURE;
+  if (!str)
+    return MS_FAILURE;
 
   *value = (int)strtol(str, &parse_check, base);
-  if(*parse_check != '\0') return MS_FAILURE;
+  if (*parse_check != '\0')
+    return MS_FAILURE;
 
   return MS_SUCCESS;
 }
 
-int msStringToDouble(const char *str, double *value)
-{
+int msStringToDouble(const char *str, double *value) {
   char *parse_check = NULL;
 
-  if(!str) return MS_FAILURE;
+  if (!str)
+    return MS_FAILURE;
 
   *value = strtod(str, &parse_check);
-  if(*parse_check != '\0') return MS_FAILURE;
+  if (*parse_check != '\0')
+    return MS_FAILURE;
 
   return MS_SUCCESS;
 }
 
-char *msLongToString(long value)
-{
+char *msLongToString(long value) {
   size_t bufferSize = 256;
-  char *buffer = (char*)msSmallMalloc(bufferSize);
+  char *buffer = (char *)msSmallMalloc(bufferSize);
 
   snprintf(buffer, bufferSize, "%ld", value);
-  return(buffer);
+  return (buffer);
 }
 
-char *msDoubleToString(double value, int force_f)
-{
+char *msDoubleToString(double value, int force_f) {
   size_t bufferSize = 256;
-  char *buffer = (char*)msSmallMalloc(bufferSize);
+  char *buffer = (char *)msSmallMalloc(bufferSize);
 
   if (force_f == MS_TRUE)
     snprintf(buffer, bufferSize, "%f", value);
   else
     snprintf(buffer, bufferSize, "%g", value);
-  return(buffer);
+  return (buffer);
 }
 
-char *msIntToString(int value)
-{
+char *msIntToString(int value) {
   size_t bufferSize = 256;
-  char *buffer = (char*)msSmallMalloc(bufferSize);
+  char *buffer = (char *)msSmallMalloc(bufferSize);
 
   snprintf(buffer, bufferSize, "%i", value);
-  return(buffer);
+  return (buffer);
 }
 
-void msStringToUpper(char *string)
-{
+void msStringToUpper(char *string) {
   int i;
 
   if (string != NULL) {
@@ -419,8 +412,7 @@ void msStringToUpper(char *string)
   }
 }
 
-void msStringToLower(char *string)
-{
+void msStringToLower(char *string) {
   int i;
 
   if (string != NULL) {
@@ -431,10 +423,10 @@ void msStringToLower(char *string)
   }
 }
 
-std::string msStringToLower(const std::string& s) {
+std::string msStringToLower(const std::string &s) {
   std::string ret(s);
-  std::transform(ret.begin(), ret.end(), ret.begin(), 
-                 [](unsigned char c){ return std::tolower(c); });
+  std::transform(ret.begin(), ret.end(), ret.begin(),
+                 [](unsigned char c) { return std::tolower(c); });
   return ret;
 }
 
@@ -442,10 +434,9 @@ std::string msStringToLower(const std::s
  * Force the first character to uppercase and the rest of the characters to
  * lower case for EACH word in the string.
  */
-void msStringInitCap(char *string)
-{
+void msStringInitCap(char *string) {
   int i;
-  int start = 1; 
+  int start = 1;
   if (string != NULL) {
     for (i = 0; i < (int)strlen(string); i++) {
       if (string[i] == ' ')
@@ -453,8 +444,7 @@ void msStringInitCap(char *string)
       else if (start) {
         string[i] = toupper(string[i]);
         start = 0;
-      }
-      else {
+      } else {
         string[i] = tolower(string[i]);
       }
     }
@@ -465,78 +455,72 @@ void msStringInitCap(char *string)
  * Force the first character to uppercase for the FIRST word in the string
  * and the rest of the characters to lower case.
  */
-void msStringFirstCap(char *string)
-{
+void msStringFirstCap(char *string) {
   int i;
-  int start = 1; 
+  int start = 1;
   if (string != NULL) {
     for (i = 0; i < (int)strlen(string); i++) {
       if (string[i] != ' ') {
         if (start) {
           string[i] = toupper(string[i]);
           start = 0;
-        }
-        else
+        } else
           string[i] = tolower(string[i]);
       }
     }
   }
 }
 
-char *msStringChop(char *string)
-{
+char *msStringChop(char *string) {
   int n;
 
   n = strlen(string);
-  if(n>0)
-    string[n-1] = '\0';
+  if (n > 0)
+    string[n - 1] = '\0';
 
-  return(string);
+  return (string);
 }
 
 /*
 ** Trim leading and trailing white space.
 */
-void msStringTrim(char *str)
-{
+void msStringTrim(char *str) {
   int i;
 
   /* Send nulls home without supper. */
-  if( ! str ) return;
+  if (!str)
+    return;
 
   /* Move non-white string to the front. */
   i = strspn(str, " ");
-  if(i) {
+  if (i) {
     memmove(str, str + i, strlen(str) - i + 1);
   }
   /* Nothing left? Exit. */
-  if(strlen(str) == 0) {
+  if (strlen(str) == 0) {
     return;
   }
   /* Null-terminate end of non-white string. */
-  for(i=strlen(str)-1; i>=0; i--) { /* step backwards from end */
-    if(str[i] != ' ') {
-      str[i+1] = '\0';
+  for (i = strlen(str) - 1; i >= 0; i--) { /* step backwards from end */
+    if (str[i] != ' ') {
+      str[i + 1] = '\0';
       return;
     }
   }
   return;
 }
 
-void msStringTrim(std::string& string)
-{
+void msStringTrim(std::string &string) {
   const size_t npos = string.find_first_not_of(' ');
-  if( npos != std::string::npos )
+  if (npos != std::string::npos)
     string.erase(0, npos);
   msStringTrimBlanks(string);
 }
 
-
 /*
 ** Remove leading white spaces and shift everything to the left.
 */
-char *msStringTrimLeft(char *string)
-{
+char *msStringTrimLeft(char *string) {
   char *read, *write;
   int i, length;
 
@@ -545,7 +529,7 @@ char *msStringTrimLeft(char *string)
     read = string;
     write = string;
 
-    for (i=0; i<length; i++) {
+    for (i = 0; i < length; i++) {
       if (isspace(string[i]))
         read++;
       else
@@ -564,76 +548,77 @@ char *msStringTrimLeft(char *string)
   return string;
 }
 
-void msStringTrimLeft(std::string& string)
-{
+void msStringTrimLeft(std::string &string) {
   const size_t length = string.length();
-  for( size_t i = 0; i < length; i++ ) {
-    if( !isspace(string[i]) ) {
-        if( i > 0 ) {
-          string.erase(0, i-1);
-        }
-        return;
+  for (size_t i = 0; i < length; i++) {
+    if (!isspace(string[i])) {
+      if (i > 0) {
+        string.erase(0, i - 1);
+      }
+      return;
     }
   }
   string.clear();
 }
 
-/* ------------------------------------------------------------------------------- */
-/*       Trims trailing blanks from a string                                        */
-/* ------------------------------------------------------------------------------- */
-void msStringTrimBlanks(char *string)
-{
-  int i,n;
+/* -------------------------------------------------------------------------------
+ */
+/*       Trims trailing blanks from a string */
+/* -------------------------------------------------------------------------------
+ */
+void msStringTrimBlanks(char *string) {
+  int i, n;
 
   n = strlen(string);
-  for(i=n-1; i>=0; i--) { /* step backwards through the string */
-    if(string[i] != ' ') {
-      string[i+1] = '\0';
+  for (i = n - 1; i >= 0; i--) { /* step backwards through the string */
+    if (string[i] != ' ') {
+      string[i + 1] = '\0';
       return;
     }
   }
 }
 
-void msStringTrimBlanks(std::string& string)
-{
+void msStringTrimBlanks(std::string &string) {
   const size_t npos = string.find_last_not_of(' ');
-  if( npos != std::string::npos )
-    string.resize(npos+1);
+  if (npos != std::string::npos)
+    string.resize(npos + 1);
 }
 
-/* ------------------------------------------------------------------------------- */
-/*       Trims end-of-line marker from a string                                    */
-/*       Usefull in conjunction with fgets() calls                                 */
-/* ------------------------------------------------------------------------------- */
-void msStringTrimEOL(char *string)
-{
+/* -------------------------------------------------------------------------------
+ */
+/*       Trims end-of-line marker from a string */
+/*       Usefull in conjunction with fgets() calls */
+/* -------------------------------------------------------------------------------
+ */
+void msStringTrimEOL(char *string) {
   int i;
 
-  for(i=0 ; string[i] != '\0'; i++) {
-    if(string[i] == '\n') {
+  for (i = 0; string[i] != '\0'; i++) {
+    if (string[i] == '\n') {
       string[i] = '\0'; /* Terminate the string at the newline */
       return;
     }
   }
 }
 
-/* ------------------------------------------------------------------------------- */
-/*       Replace all occurances of old with new in str.                            */
-/*       It is assumed that str was dynamically created using malloc.              */
-/* ------------------------------------------------------------------------------- */
-char *msReplaceSubstring(char *str, const char *old, const char *newstr)
-{
+/* -------------------------------------------------------------------------------
+ */
+/*       Replace all occurances of old with new in str. */
+/*       It is assumed that str was dynamically created using malloc. */
+/* -------------------------------------------------------------------------------
+ */
+char *msReplaceSubstring(char *str, const char *old, const char *newstr) {
   size_t str_len, old_len, new_len, tmp_offset;
   char *tmp_ptr;
 
-  if(newstr == NULL)
+  if (newstr == NULL)
     newstr = "";
 
   /*
   ** If old is not found then leave str alone
   */
-  if( (tmp_ptr = strstr(str, old)) == NULL)
-    return(str);
+  if ((tmp_ptr = strstr(str, old)) == NULL)
+    return (str);
 
   /*
   ** Grab some info about incoming strings
@@ -645,16 +630,17 @@ char *msReplaceSubstring(char *str, cons
   /*
   ** Now loop until old is NOT found in new
   */
-  while( tmp_ptr != NULL ) {
+  while (tmp_ptr != NULL) {
 
     /*
     ** re-allocate memory for buf assuming 1 replacement of old with new
-          ** don't bother reallocating if old is larger than new)
+    ** don't bother reallocating if old is larger than new)
     */
     if (old_len < new_len) {
       tmp_offset = tmp_ptr - str;
       str_len = str_len - old_len + new_len;
-      str = (char *)msSmallRealloc(str, (str_len + 1)); /* make new space for a copy */
+      str = (char *)msSmallRealloc(
+          str, (str_len + 1)); /* make new space for a copy */
       tmp_ptr = str + tmp_offset;
     }
 
@@ -662,7 +648,8 @@ char *msReplaceSubstring(char *str, cons
     ** Move the trailing part of str to make some room unless old_len == new_len
     */
     if (old_len != new_len) {
-      memmove(tmp_ptr+new_len, tmp_ptr+old_len, strlen(tmp_ptr)-old_len+1);
+      memmove(tmp_ptr + new_len, tmp_ptr + old_len,
+              strlen(tmp_ptr) - old_len + 1);
     }
 
     /*
@@ -676,7 +663,7 @@ char *msReplaceSubstring(char *str, cons
     tmp_ptr = strstr(tmp_ptr + new_len, old);
   }
 
-  return(str);
+  return (str);
 }
 
 /*
@@ -684,81 +671,81 @@ char *msReplaceSubstring(char *str, cons
  * when we won't have to do reallocs etc
  * used to replace the wrap characetr by a newline for labels
  */
-void msReplaceChar(char *str, char old, char newstr)
-{
-  while(*(str++))
-    if(*str==old)
-      *str=newstr;
+void msReplaceChar(char *str, char old, char newstr) {
+  while (*(str++))
+    if (*str == old)
+      *str = newstr;
 }
 
 /*
 ** how many times does ch occur in str
 */
-int msCountChars(char *str, char ch)
-{
-  int i, l, n=0;
+int msCountChars(char *str, char ch) {
+  int i, l, n = 0;
 
   l = strlen(str);
-  for(i=0; i<l; i++)
-    if(str[i] == ch) n++;
+  for (i = 0; i < l; i++)
+    if (str[i] == ch)
+      n++;
 
-  return(n);
+  return (n);
 }
 
-/* ------------------------------------------------------------------------------- */
-/*       Strip filename from a full path                                           */
-/* ------------------------------------------------------------------------------- */
-char *msStripPath(char *fn)
-{
+/* -------------------------------------------------------------------------------
+ */
+/*       Strip filename from a full path */
+/* -------------------------------------------------------------------------------
+ */
+char *msStripPath(char *fn) {
   char *pSlash;
   char *pBackslash;
 
   /* try to locate both, the last slash or backslash */
-  pSlash = strrchr(fn,'/');
-  pBackslash = strrchr(fn,'\\');
+  pSlash = strrchr(fn, '/');
+  pBackslash = strrchr(fn, '\\');
 
-  if( pSlash != NULL && pBackslash != NULL ) {
-    if( pSlash < pBackslash )
+  if (pSlash != NULL && pBackslash != NULL) {
+    if (pSlash < pBackslash)
       return ++pBackslash;
     else
       return ++pSlash;
-  } else if ( pSlash != NULL )
+  } else if (pSlash != NULL)
     return ++pSlash; /* skip past the "slash" */
-  else if ( pBackslash != NULL )
+  else if (pBackslash != NULL)
     return ++pBackslash; /* skip past the "backslash" */
   else
-    return(fn);
+    return (fn);
 }
 
 /*
-** Returns the *path* portion of the filename fn. Memory is allocated using malloc.
+** Returns the *path* portion of the filename fn. Memory is allocated using
+*malloc.
 */
-char *msGetPath(const char *fn)
-{
+char *msGetPath(const char *fn) {
   char *str;
   int i, length;
 
   length = strlen(fn);
-  if((str = msStrdup(fn)) == NULL)
-    return(NULL);
+  if ((str = msStrdup(fn)) == NULL)
+    return (NULL);
 
-  for(i=length-1; i>=0; i--) { /* step backwards through the string */
-    if((str[i] == '/') || (str[i] == '\\')) {
-      str[i+1] = '\0';
+  for (i = length - 1; i >= 0; i--) { /* step backwards through the string */
+    if ((str[i] == '/') || (str[i] == '\\')) {
+      str[i + 1] = '\0';
       break;
     }
   }
 
-  if(strcmp(str, fn) == 0) {
+  if (strcmp(str, fn) == 0) {
     msFree(str);
 #if defined(_WIN32) && !defined(__CYGWIN__)
     str = msStrdup(".\\");
 #else
-    str= msStrdup("./");
+    str = msStrdup("./");
 #endif
   }
 
-  return(str);
+  return (str);
 }
 
 /*
@@ -766,13 +753,11 @@ char *msGetPath(const char *fn)
 ** The pszReturnPath must be declared by the caller function as an array
 ** of MS_MAXPATHLEN char
 */
-char *msBuildPath(char *pszReturnPath, const char *abs_path, const char *path)
-{
-  int   abslen = 0;
-  int   pathlen = 0;
-
+char *msBuildPath(char *pszReturnPath, const char *abs_path, const char *path) {
+  int abslen = 0;
+  int pathlen = 0;
 
-  if(path == NULL) {
+  if (path == NULL) {
     msSetError(MS_IOERR, NULL, "msBuildPath");
     return NULL;
   }
@@ -781,7 +766,7 @@ char *msBuildPath(char *pszReturnPath, c
   if (abs_path)
     abslen = strlen(abs_path);
 
-  if((pathlen + abslen + 2) > MS_MAXPATHLEN) {
+  if ((pathlen + abslen + 2) > MS_MAXPATHLEN) {
     msSetError(MS_IOERR, "Path is too long.  Check server logs.",
                "msBuildPath()");
     msDebug("msBuildPath(): (%s%s): path is too long.\n", abs_path, path);
@@ -789,21 +774,20 @@ char *msBuildPath(char *pszReturnPath, c
   }
 
   /* Check if path is absolute */
-  if((abs_path == NULL) || (abslen == 0) ||
-      (path[0] == '\\') || (path[0] == '/') ||
-      (pathlen > 1 && (path[1] == ':'))) {
+  if ((abs_path == NULL) || (abslen == 0) || (path[0] == '\\') ||
+      (path[0] == '/') || (pathlen > 1 && (path[1] == ':'))) {
     strlcpy(pszReturnPath, path, MS_MAXPATHLEN);
-    return(pszReturnPath);
+    return (pszReturnPath);
   }
 
   /* else return abs_path/path */
-  if((abs_path[abslen-1] == '/') || (abs_path[abslen-1] == '\\')) {
+  if ((abs_path[abslen - 1] == '/') || (abs_path[abslen - 1] == '\\')) {
     snprintf(pszReturnPath, MS_MAXPATHLEN, "%s%s", abs_path, path);
   } else {
     snprintf(pszReturnPath, MS_MAXPATHLEN, "%s/%s", abs_path, path);
   }
 
-  return(pszReturnPath);
+  return (pszReturnPath);
 }
 
 /*
@@ -812,8 +796,8 @@ char *msBuildPath(char *pszReturnPath, c
 ** The pszReturnPath must be declared by the caller function as an array
 ** of MS_MAXPATHLEN char
 */
-char *msBuildPath3(char *pszReturnPath, const char *abs_path, const char *path1,const char *path2)
-{
+char *msBuildPath3(char *pszReturnPath, const char *abs_path, const char *path1,
+                   const char *path2) {
   char szPath[MS_MAXPATHLEN];
 
   return msBuildPath(pszReturnPath, abs_path,
@@ -830,17 +814,17 @@ char *msBuildPath3(char *pszReturnPath,
 char *msTryBuildPath(char *szReturnPath, const char *abs_path, const char *path)
 
 {
-  VSILFILE  *fp;
+  VSILFILE *fp;
 
-  if( msBuildPath( szReturnPath, abs_path, path ) == NULL )
+  if (msBuildPath(szReturnPath, abs_path, path) == NULL)
     return NULL;
 
-  fp = VSIFOpenL( szReturnPath, "r" );
-  if( fp == NULL ) {
-    strlcpy( szReturnPath, path, MS_MAXPATHLEN);
+  fp = VSIFOpenL(szReturnPath, "r");
+  if (fp == NULL) {
+    strlcpy(szReturnPath, path, MS_MAXPATHLEN);
     return NULL;
   } else
-    VSIFCloseL( fp );
+    VSIFCloseL(fp);
 
   return szReturnPath;
 }
@@ -852,59 +836,60 @@ char *msTryBuildPath(char *szReturnPath,
 ** Returns NULL if the resulting path doesn't point to a readable file.
 */
 
-char *msTryBuildPath3(char *szReturnPath, const char *abs_path, const char *path1, const char *path2)
+char *msTryBuildPath3(char *szReturnPath, const char *abs_path,
+                      const char *path1, const char *path2)
 
 {
-  VSILFILE  *fp;
+  VSILFILE *fp;
 
-  if( msBuildPath3( szReturnPath, abs_path, path1, path2 ) == NULL )
+  if (msBuildPath3(szReturnPath, abs_path, path1, path2) == NULL)
     return NULL;
 
-  fp = VSIFOpenL( szReturnPath, "r" );
-  if( fp == NULL ) {
-    strlcpy( szReturnPath, path2, MS_MAXPATHLEN);
+  fp = VSIFOpenL(szReturnPath, "r");
+  if (fp == NULL) {
+    strlcpy(szReturnPath, path2, MS_MAXPATHLEN);
     return NULL;
   } else
-    VSIFCloseL( fp );
+    VSIFCloseL(fp);
 
   return szReturnPath;
 }
 
 /*
-** Splits a string into multiple strings based on ch. Consecutive ch's are ignored.
+** Splits a string into multiple strings based on ch. Consecutive ch's are
+*ignored.
 */
-char **msStringSplit(const char *string, char ch, int *num_tokens)
-{
-  int i,j,k;
-  int length,n;
+char **msStringSplit(const char *string, char ch, int *num_tokens) {
+  int i, j, k;
+  int length, n;
   char **token;
-  char last_ch='\0';
+  char last_ch = '\0';
 
   n = 1; /* always at least 1 token, the string itself */
   length = strlen(string);
-  for(i=0; i<length; i++) {
-    if(string[i] == ch && last_ch != ch)
+  for (i = 0; i < length; i++) {
+    if (string[i] == ch && last_ch != ch)
       n++;
     last_ch = string[i];
   }
 
-  token = (char **) msSmallMalloc(sizeof(char *)*n);
+  token = (char **)msSmallMalloc(sizeof(char *) * n);
 
   k = 0;
-  token[k] = (char *)msSmallMalloc(sizeof(char)*(length+1));
+  token[k] = (char *)msSmallMalloc(sizeof(char) * (length + 1));
 
   j = 0;
-  last_ch='\0';
-  for(i=0; i<length; i++) {
-    if(string[i] == ch) {
+  last_ch = '\0';
+  for (i = 0; i < length; i++) {
+    if (string[i] == ch) {
 
-      if(last_ch == ch)
+      if (last_ch == ch)
         continue;
 
       token[k][j] = '\0'; /* terminate current token */
 
       k++;
-      token[k] = (char *)msSmallMalloc(sizeof(char)*(length+1));
+      token[k] = (char *)msSmallMalloc(sizeof(char) * (length + 1));
 
       j = 0;
     } else {
@@ -919,19 +904,18 @@ char **msStringSplit(const char *string,
 
   *num_tokens = n;
 
-  return(token);
+  return (token);
 }
 
-std::vector<std::string> msStringSplit(const char *string, char ch)
-{
-    int num_tokens = 0;
-    char** tmp = msStringSplit(string, ch, &num_tokens);
-    std::vector<std::string> res;
-    res.reserve(num_tokens);
-    for( int i = 0; i < num_tokens; i++ )
-        res.push_back(tmp[i]);
-    msFreeCharArray(tmp, num_tokens);
-    return res;
+std::vector<std::string> msStringSplit(const char *string, char ch) {
+  int num_tokens = 0;
+  char **tmp = msStringSplit(string, ch, &num_tokens);
+  std::vector<std::string> res;
+  res.reserve(num_tokens);
+  for (int i = 0; i < num_tokens; i++)
+    res.push_back(tmp[i]);
+  msFreeCharArray(tmp, num_tokens);
+  return res;
 }
 
 /*
@@ -953,35 +937,34 @@ std::vector<std::string> msStringSplit(c
  * and for literal double quotes) will be preserved in the tokens, otherwise
  * the backslashes will be removed in processing.
  */
-char ** msStringSplitComplex( const char * pszString,
-                              const char * pszDelimiters,
-                              int *num_tokens,
-                              int nFlags )
+char **msStringSplitComplex(const char *pszString, const char *pszDelimiters,
+                            int *num_tokens, int nFlags)
 
 {
-  char        **papszRetList = NULL;
-  int         nRetMax = 0, nRetLen = 0;
-  char        *pszToken;
-  int         nTokenMax, nTokenLen;
-  int         bHonourStrings = (nFlags & MS_HONOURSTRINGS);
-  int         bAllowEmptyTokens = (nFlags & MS_ALLOWEMPTYTOKENS);
-  int         bStripLeadSpaces = (nFlags & MS_STRIPLEADSPACES);
-  int         bStripEndSpaces = (nFlags & MS_STRIPENDSPACES);
+  char **papszRetList = NULL;
+  int nRetMax = 0, nRetLen = 0;
+  char *pszToken;
+  int nTokenMax, nTokenLen;
+  int bHonourStrings = (nFlags & MS_HONOURSTRINGS);
+  int bAllowEmptyTokens = (nFlags & MS_ALLOWEMPTYTOKENS);
+  int bStripLeadSpaces = (nFlags & MS_STRIPLEADSPACES);
+  int bStripEndSpaces = (nFlags & MS_STRIPENDSPACES);
 
-  pszToken = (char *) msSmallMalloc(sizeof(char)*10);;
+  pszToken = (char *)msSmallMalloc(sizeof(char) * 10);
+  ;
   nTokenMax = 10;
 
-  while( pszString != NULL && *pszString != '\0' ) {
-    int     bInString = MS_FALSE;
-    int     bStartString = MS_TRUE;
+  while (pszString != NULL && *pszString != '\0') {
+    int bInString = MS_FALSE;
+    int bStartString = MS_TRUE;
 
     nTokenLen = 0;
 
     /* Try to find the next delimeter, marking end of token */
-    for( ; *pszString != '\0'; pszString++ ) {
+    for (; *pszString != '\0'; pszString++) {
 
       /* End if this is a delimeter skip it and break. */
-      if( !bInString && strchr(pszDelimiters, *pszString) != NULL ) {
+      if (!bInString && strchr(pszDelimiters, *pszString) != NULL) {
         pszString++;
         break;
       }
@@ -989,13 +972,13 @@ char ** msStringSplitComplex( const char
       /* If this is a quote, and we are honouring constant
          strings, then process the constant strings, with out delim
          but don't copy over the quotes */
-      if( bHonourStrings && *pszString == '"' ) {
-        if( nFlags & MS_PRESERVEQUOTES ) {
+      if (bHonourStrings && *pszString == '"') {
+        if (nFlags & MS_PRESERVEQUOTES) {
           pszToken[nTokenLen] = *pszString;
           nTokenLen++;
         }
 
-        if( bInString ) {
+        if (bInString) {
           bInString = MS_FALSE;
           continue;
         } else {
@@ -1009,9 +992,9 @@ char ** msStringSplitComplex( const char
        * processing them we will unescape the quotes and \\ sequence
        * reduces to \
        */
-      if( bInString && pszString[0] == '\\' ) {
-        if ( pszString[1] == '"' || pszString[1] == '\\' ) {
-          if( nFlags & MS_PRESERVEESCAPES ) {
+      if (bInString && pszString[0] == '\\') {
+        if (pszString[1] == '"' || pszString[1] == '\\') {
+          if (nFlags & MS_PRESERVEESCAPES) {
             pszToken[nTokenLen] = *pszString;
             nTokenLen++;
           }
@@ -1023,8 +1006,8 @@ char ** msStringSplitComplex( const char
       /*
        * Strip spaces at the token start if requested.
        */
-      if ( !bInString && bStripLeadSpaces
-           && bStartString && isspace((unsigned char)*pszString) )
+      if (!bInString && bStripLeadSpaces && bStartString &&
+          isspace((unsigned char)*pszString))
         continue;
 
       bStartString = MS_FALSE;
@@ -1032,9 +1015,9 @@ char ** msStringSplitComplex( const char
       /*
        * Extend token buffer if we are running close to its end.
        */
-      if( nTokenLen >= nTokenMax-3 ) {
+      if (nTokenLen >= nTokenMax - 3) {
         nTokenMax = nTokenMax * 2 + 10;
-        pszToken = (char *) msSmallRealloc(pszToken, sizeof(char)*nTokenMax);
+        pszToken = (char *)msSmallRealloc(pszToken, sizeof(char) * nTokenMax);
       }
 
       pszToken[nTokenLen] = *pszString;
@@ -1044,8 +1027,8 @@ char ** msStringSplitComplex( const char
     /*
      * Strip spaces at the token end if requested.
      */
-    if ( !bInString && bStripEndSpaces ) {
-      while ( nTokenLen && isspace((unsigned char)pszToken[nTokenLen - 1]) )
+    if (!bInString && bStripEndSpaces) {
+      while (nTokenLen && isspace((unsigned char)pszToken[nTokenLen - 1]))
         nTokenLen--;
     }
 
@@ -1054,13 +1037,14 @@ char ** msStringSplitComplex( const char
     /*
      * Add the token.
      */
-    if( pszToken[0] != '\0' || bAllowEmptyTokens ) {
-      if( nRetLen >= nRetMax - 1 ) {
+    if (pszToken[0] != '\0' || bAllowEmptyTokens) {
+      if (nRetLen >= nRetMax - 1) {
         nRetMax = nRetMax * 2 + 10;
-        papszRetList = (char **) msSmallRealloc(papszRetList, sizeof(char*)*nRetMax);
+        papszRetList =
+            (char **)msSmallRealloc(papszRetList, sizeof(char *) * nRetMax);
       }
 
-      papszRetList[nRetLen++] = msStrdup( pszToken );
+      papszRetList[nRetLen++] = msStrdup(pszToken);
       papszRetList[nRetLen] = NULL;
     }
   }
@@ -1069,19 +1053,20 @@ char ** msStringSplitComplex( const char
    * If the last token was empty, then we need to capture
    * it now, as the loop would skip it.
    */
-  if( pszString != NULL && *pszString == '\0' && bAllowEmptyTokens && nRetLen > 0
-      && strchr(pszDelimiters,*(pszString-1)) != NULL ) {
-    if( nRetLen >= nRetMax - 1 ) {
+  if (pszString != NULL && *pszString == '\0' && bAllowEmptyTokens &&
+      nRetLen > 0 && strchr(pszDelimiters, *(pszString - 1)) != NULL) {
+    if (nRetLen >= nRetMax - 1) {
       nRetMax = nRetMax * 2 + 10;
-      papszRetList = (char **) msSmallRealloc(papszRetList, sizeof(char*)*nRetMax);
+      papszRetList =
+          (char **)msSmallRealloc(papszRetList, sizeof(char *) * nRetMax);
     }
 
     papszRetList[nRetLen++] = msStrdup("");
     papszRetList[nRetLen] = NULL;
   }
 
-  if( papszRetList == NULL )
-    papszRetList = (char **) msSmallMalloc(sizeof(char *)*1);
+  if (papszRetList == NULL)
+    papszRetList = (char **)msSmallMalloc(sizeof(char *) * 1);
 
   *num_tokens = nRetLen;
   free(pszToken);
@@ -1091,42 +1076,44 @@ char ** msStringSplitComplex( const char
 
 /* This method is similar to msStringSplit but support quoted strings.
    It also support multi-characters delimiter and allows to preserve quotes */
-char **msStringTokenize( const char *pszLine, const char *pszDelim,
-                         int *num_tokens, int preserve_quote )
-{
+char **msStringTokenize(const char *pszLine, const char *pszDelim,
+                        int *num_tokens, int preserve_quote) {
   char **papszResult = NULL;
-  int n = 1, iChar, nLength = strlen(pszLine), iTokenChar = 0, bInQuotes = MS_FALSE;
-  char *pszToken = (char *) msSmallMalloc(sizeof(char)*(nLength+1));
+  int n = 1, iChar, nLength = strlen(pszLine), iTokenChar = 0,
+      bInQuotes = MS_FALSE;
+  char *pszToken = (char *)msSmallMalloc(sizeof(char) * (nLength + 1));
   int nDelimLen = strlen(pszDelim);
 
   /* Compute the number of tokens */
-  for( iChar = 0; pszLine[iChar] != '\0'; iChar++ ) {
-    if( bInQuotes && pszLine[iChar] == '"' && pszLine[iChar+1] == '"' ) {
+  for (iChar = 0; pszLine[iChar] != '\0'; iChar++) {
+    if (bInQuotes && pszLine[iChar] == '"' && pszLine[iChar + 1] == '"') {
       iChar++;
-    } else if( pszLine[iChar] == '"' ) {
+    } else if (pszLine[iChar] == '"') {
       bInQuotes = !bInQuotes;
-    } else if ( !bInQuotes && strncmp(pszLine+iChar,pszDelim,nDelimLen) == 0 ) {
+    } else if (!bInQuotes &&
+               strncmp(pszLine + iChar, pszDelim, nDelimLen) == 0) {
       iChar += nDelimLen - 1;
       n++;
     }
   }
 
-  papszResult = (char **) msSmallMalloc(sizeof(char *)*n);
+  papszResult = (char **)msSmallMalloc(sizeof(char *) * n);
   n = iTokenChar = bInQuotes = 0;
-  for( iChar = 0; pszLine[iChar] != '\0'; iChar++ ) {
-    if( bInQuotes && pszLine[iChar] == '"' && pszLine[iChar+1] == '"' ) {
+  for (iChar = 0; pszLine[iChar] != '\0'; iChar++) {
+    if (bInQuotes && pszLine[iChar] == '"' && pszLine[iChar + 1] == '"') {
       if (preserve_quote == MS_TRUE)
         pszToken[iTokenChar++] = '"';
       pszToken[iTokenChar++] = '"';
       iChar++;
-    } else if( pszLine[iChar] == '"' ) {
+    } else if (pszLine[iChar] == '"') {
       if (preserve_quote == MS_TRUE)
         pszToken[iTokenChar++] = '"';
       bInQuotes = !bInQuotes;
-    } else if( !bInQuotes && strncmp(pszLine+iChar,pszDelim,nDelimLen) == 0 ) {
+    } else if (!bInQuotes &&
+               strncmp(pszLine + iChar, pszDelim, nDelimLen) == 0) {
       pszToken[iTokenChar++] = '\0';
       papszResult[n] = pszToken;
-      pszToken = (char *) msSmallMalloc(sizeof(char)*(nLength+1));
+      pszToken = (char *)msSmallMalloc(sizeof(char) * (nLength + 1));
       iChar += nDelimLen - 1;
       iTokenChar = 0;
       n++;
@@ -1138,7 +1125,7 @@ char **msStringTokenize( const char *psz
   pszToken[iTokenChar++] = '\0';
   papszResult[n] = pszToken;
 
-  *num_tokens = n+1;
+  *num_tokens = n + 1;
 
   return papszResult;
 }
@@ -1152,30 +1139,27 @@ char **msStringTokenize( const char *psz
  *
  **********************************************************************/
 
-int msEncodeChar(const char c)
-{
-  if (
-    (c >= 0x61 && c <= 0x7A ) ||   /* Letters a-z */
-    (c >= 0x41 && c <= 0x5A ) ||   /* Letters A-Z */
-    (c >= 0x30 && c <= 0x39 ) ||   /* Numbers 0-9 */
-    (c >= 0x27 && c <= 0x2A ) ||   /* * ' ( )     */
-    (c >= 0x2D && c <= 0x2E ) ||   /* - .         */
-    (c == 0x5F ) ||                /* _           */
-    (c == 0x21 ) ||                /* !           */
-    (c == 0x7E ) ) {               /* ~           */
-    return(0);
+int msEncodeChar(const char c) {
+  if ((c >= 0x61 && c <= 0x7A) || /* Letters a-z */
+      (c >= 0x41 && c <= 0x5A) || /* Letters A-Z */
+      (c >= 0x30 && c <= 0x39) || /* Numbers 0-9 */
+      (c >= 0x27 && c <= 0x2A) || /* * ' ( )     */
+      (c >= 0x2D && c <= 0x2E) || /* - .         */
+      (c == 0x5F) ||              /* _           */
+      (c == 0x21) ||              /* !           */
+      (c == 0x7E)) {              /* ~           */
+    return (0);
   } else {
-    return(1);
+    return (1);
   }
 }
 
-char *msEncodeUrl(const char *data)
-{
+char *msEncodeUrl(const char *data) {
   /*
    * Delegate to msEncodeUrlExcept, with a null second argument
    * to render the except handling moot.
    */
-  return(msEncodeUrlExcept(data, '\0'));
+  return (msEncodeUrlExcept(data, '\0'));
 }
 
 /**********************************************************************
@@ -1187,28 +1171,27 @@ char *msEncodeUrl(const char *data)
  *
  **********************************************************************/
 
-char *msEncodeUrlExcept(const char *data, const char except)
-{
+char *msEncodeUrlExcept(const char *data, const char except) {
   static const char *hex = "0123456789ABCDEF";
   const char *i;
-  char  *j, *code;
-  int   inc;
+  char *j, *code;
+  int inc;
   unsigned char ch;
 
-  for (inc=0, i=data; *i!='\0'; i++)
+  for (inc = 0, i = data; *i != '\0'; i++)
     if (msEncodeChar(*i))
       inc += 2;
 
-  code = (char*)msSmallMalloc(strlen(data)+inc+1);
+  code = (char *)msSmallMalloc(strlen(data) + inc + 1);
 
-  for (j=code, i=data; *i!='\0'; i++, j++) {
-    if ( except != '\0' && *i == except ) {
+  for (j = code, i = data; *i != '\0'; i++, j++) {
+    if (except != '\0' && *i == except) {
       *j = except;
     } else if (msEncodeChar(*i)) {
       ch = *i;
       *j++ = '%';
-      *j++ = hex[ch/16];
-      *j   = hex[ch%16];
+      *j++ = hex[ch / 16];
+      *j = hex[ch % 16];
     } else
       *j = *i;
   }
@@ -1223,69 +1206,50 @@ char *msEncodeUrlExcept(const char *data
 
 /* The input (and output) string are not supposed to start/end with double */
 /* quote characters. It is the responsibility of the caller to do that. */
-char* msEscapeJSonString(const char* pszJSonString)
-{
-    /* Worst case is one character to become \uABCD so 6 characters */
-    char* pszRet;
-    int i = 0, j = 0;
-    static const char* pszHex = "0123456789ABCDEF";
-    
-    pszRet = (char*) msSmallMalloc(strlen(pszJSonString) * 6 + 1);
-    /* From http://www.json.org/ */
-    for(i = 0; pszJSonString[i] != '\0'; i++)
-    {
-        unsigned char ch = pszJSonString[i];
-        if( ch == '\b' )
-        {
-            pszRet[j++] = '\\';
-            pszRet[j++] = 'b';
-        }
-        else if( ch == '\f' )
-        {
-            pszRet[j++] = '\\';
-            pszRet[j++] = 'f';
-        }
-        else if( ch == '\n' )
-        {
-            pszRet[j++] = '\\';
-            pszRet[j++] = 'n';
-        }
-        else if( ch == '\r' )
-        {
-            pszRet[j++] = '\\';
-            pszRet[j++] = 'r';
-        }
-        else if( ch == '\t' )
-        {
-            pszRet[j++] = '\\';
-            pszRet[j++] = 't';
-        }
-        else if( ch < 32 )
-        {
-            pszRet[j++] = '\\';
-            pszRet[j++] = 'u';
-            pszRet[j++] = '0';
-            pszRet[j++] = '0';
-            pszRet[j++] = pszHex[ch / 16];
-            pszRet[j++] = pszHex[ch % 16];
-        }
-        else if( ch == '"' )
-        {
-            pszRet[j++] = '\\';
-            pszRet[j++] = '"';
-        }
-        else if( ch == '\\' )
-        {
-            pszRet[j++] = '\\';
-            pszRet[j++] = '\\';
-        }
-        else
-        {
-            pszRet[j++] = ch;
-        }
+char *msEscapeJSonString(const char *pszJSonString) {
+  /* Worst case is one character to become \uABCD so 6 characters */
+  char *pszRet;
+  int i = 0, j = 0;
+  static const char *pszHex = "0123456789ABCDEF";
+
+  pszRet = (char *)msSmallMalloc(strlen(pszJSonString) * 6 + 1);
+  /* From http://www.json.org/ */
+  for (i = 0; pszJSonString[i] != '\0'; i++) {
+    unsigned char ch = pszJSonString[i];
+    if (ch == '\b') {
+      pszRet[j++] = '\\';
+      pszRet[j++] = 'b';
+    } else if (ch == '\f') {
+      pszRet[j++] = '\\';
+      pszRet[j++] = 'f';
+    } else if (ch == '\n') {
+      pszRet[j++] = '\\';
+      pszRet[j++] = 'n';
+    } else if (ch == '\r') {
+      pszRet[j++] = '\\';
+      pszRet[j++] = 'r';
+    } else if (ch == '\t') {
+      pszRet[j++] = '\\';
+      pszRet[j++] = 't';
+    } else if (ch < 32) {
+      pszRet[j++] = '\\';
+      pszRet[j++] = 'u';
+      pszRet[j++] = '0';
+      pszRet[j++] = '0';
+      pszRet[j++] = pszHex[ch / 16];
+      pszRet[j++] = pszHex[ch % 16];
+    } else if (ch == '"') {
+      pszRet[j++] = '\\';
+      pszRet[j++] = '"';
+    } else if (ch == '\\') {
+      pszRet[j++] = '\\';
+      pszRet[j++] = '\\';
+    } else {
+      pszRet[j++] = ch;
     }
-    pszRet[j] = '\0';
-    return pszRet;
+  }
+  pszRet[j] = '\0';
+  return pszRet;
 }
 
 /* msEncodeHTMLEntities()
@@ -1296,55 +1260,55 @@ char* msEscapeJSonString(const char* psz
 ** The replacements performed are:
 **  '&' -> "&amp;", '"' -> "&quot;", '<' -> "&lt;" and '>' -> "&gt;"
 **/
-char *msEncodeHTMLEntities(const char *string)
-{
+char *msEncodeHTMLEntities(const char *string) {
   int buflen, i;
   char *newstring;
   const char *c;
 
-  if(string == NULL)
+  if (string == NULL)
     return NULL;
 
   /* Start with 100 extra chars for replacements...  */
   /* should be good enough for most cases */
   buflen = strlen(string) + 100;
-  newstring = (char*)malloc(buflen+1);
-  MS_CHECK_ALLOC(newstring, buflen+1, NULL);
+  newstring = (char *)malloc(buflen + 1);
+  MS_CHECK_ALLOC(newstring, buflen + 1, NULL);
 
-  for(i=0, c=string; *c != '\0'; c++) {
+  for (i = 0, c = string; *c != '\0'; c++) {
     /* Need to realloc buffer? */
-    if (i+6 > buflen) {
+    if (i + 6 > buflen) {
       /* If we had to realloc then this string must contain several */
       /* entities... so let's go with twice the previous buffer size */
       buflen *= 2;
       /* cppcheck-suppress memleakOnRealloc */
-      newstring = (char*)realloc(newstring, buflen+1);
-      MS_CHECK_ALLOC(newstring, buflen+1, NULL);
+      newstring = (char *)realloc(newstring, buflen + 1);
+      MS_CHECK_ALLOC(newstring, buflen + 1, NULL);
     }
 
-    switch(*c) {
-      case '&':
-        strcpy(newstring+i, "&amp;");
-        i += 5;
-        break;
-      case '<':
-        strcpy(newstring+i, "&lt;");
-        i += 4;
-        break;
-      case '>':
-        strcpy(newstring+i, "&gt;");
-        i += 4;
-        break;
-      case '"':
-        strcpy(newstring+i, "&quot;");
-        i += 6;
-        break;
-      case '\'':
-        strcpy(newstring+i, "&#39;"); /* changed from &apos; and i += 6 (bug 1040) */
-        i += 5;
-        break;
-      default:
-        newstring[i++] = *c;
+    switch (*c) {
+    case '&':
+      strcpy(newstring + i, "&amp;");
+      i += 5;
+      break;
+    case '<':
+      strcpy(newstring + i, "&lt;");
+      i += 4;
+      break;
+    case '>':
+      strcpy(newstring + i, "&gt;");
+      i += 4;
+      break;
+    case '"':
+      strcpy(newstring + i, "&quot;");
+      i += 6;
+      break;
+    case '\'':
+      strcpy(newstring + i,
+             "&#39;"); /* changed from &apos; and i += 6 (bug 1040) */
+      i += 5;
+      break;
+    default:
+      newstring[i++] = *c;
     }
   }
 
@@ -1353,7 +1317,6 @@ char *msEncodeHTMLEntities(const char *s
   return newstring;
 }
 
-
 /* msDecodeHTMLEntities()
 **
 ** Modify the string to replace encoded characters by their true value
@@ -1361,26 +1324,25 @@ char *msEncodeHTMLEntities(const char *s
 ** The replacements performed are:
 **  "&amp;" -> '&', "&quot;" -> '"', "&lt;" -> '<' and "&gt;" -> '>'
 **/
-void msDecodeHTMLEntities(const char *string)
-{
-  char *pszAmp=NULL, *pszSemiColon=NULL, *pszReplace=NULL, *pszEnd=NULL;
-  char *pszBuffer=NULL;
+void msDecodeHTMLEntities(const char *string) {
+  char *pszAmp = NULL, *pszSemiColon = NULL, *pszReplace = NULL, *pszEnd = NULL;
+  char *pszBuffer = NULL;
   size_t bufferSize = 0;
 
-  if(string == NULL)
+  if (string == NULL)
     return;
   else
-    pszBuffer = (char*)string;
+    pszBuffer = (char *)string;
 
   bufferSize = strlen(pszBuffer);
-  pszReplace = (char*) msSmallMalloc(bufferSize+1);
-  pszEnd = (char*) msSmallMalloc(bufferSize+1);
+  pszReplace = (char *)msSmallMalloc(bufferSize + 1);
+  pszEnd = (char *)msSmallMalloc(bufferSize + 1);
 
-  while((pszAmp = strchr(pszBuffer, '&')) != NULL) {
+  while ((pszAmp = strchr(pszBuffer, '&')) != NULL) {
     /* Get the &...; */
     strlcpy(pszReplace, pszAmp, bufferSize);
     pszSemiColon = strchr(pszReplace, ';');
-    if(pszSemiColon == NULL)
+    if (pszSemiColon == NULL)
       break;
     else
       pszSemiColon++;
@@ -1388,26 +1350,26 @@ void msDecodeHTMLEntities(const char *st
     /* Get everything after the &...; */
     strlcpy(pszEnd, pszSemiColon, bufferSize);
 
-    pszReplace[pszSemiColon-pszReplace] = '\0';
+    pszReplace[pszSemiColon - pszReplace] = '\0';
 
     /* Replace the &...; */
-    if(strcasecmp(pszReplace, "&amp;") == 0) {
+    if (strcasecmp(pszReplace, "&amp;") == 0) {
       pszBuffer[pszAmp - pszBuffer] = '&';
       pszBuffer[pszAmp - pszBuffer + 1] = '\0';
       strcat(pszBuffer, pszEnd);
-    } else if(strcasecmp(pszReplace, "&lt;") == 0) {
+    } else if (strcasecmp(pszReplace, "&lt;") == 0) {
       pszBuffer[pszAmp - pszBuffer] = '<';
       pszBuffer[pszAmp - pszBuffer + 1] = '\0';
       strcat(pszBuffer, pszEnd);
-    } else if(strcasecmp(pszReplace, "&gt;") == 0) {
+    } else if (strcasecmp(pszReplace, "&gt;") == 0) {
       pszBuffer[pszAmp - pszBuffer] = '>';
       pszBuffer[pszAmp - pszBuffer + 1] = '\0';
       strcat(pszBuffer, pszEnd);
-    } else if(strcasecmp(pszReplace, "&quot;") == 0) {
+    } else if (strcasecmp(pszReplace, "&quot;") == 0) {
       pszBuffer[pszAmp - pszBuffer] = '"';
       pszBuffer[pszAmp - pszBuffer + 1] = '\0';
       strcat(pszBuffer, pszEnd);
-    } else if(strcasecmp(pszReplace, "&apos;") == 0) {
+    } else if (strcasecmp(pszReplace, "&apos;") == 0) {
       pszBuffer[pszAmp - pszBuffer] = '\'';
       pszBuffer[pszAmp - pszBuffer + 1] = '\0';
       strcat(pszBuffer, pszEnd);
@@ -1429,30 +1391,26 @@ void msDecodeHTMLEntities(const char *st
 ** A-Z, a-z, 0-9, '_', '-', '.', and ':'
 ** Return MS_TRUE or MS_FALSE
 */
-int msIsXMLTagValid(const char *string)
-{
+int msIsXMLTagValid(const char *string) {
   int i, nLen;
 
   nLen = strlen(string);
 
-  for(i=0; i<nLen; i++) {
-    if( !( string[i] >= 'A' && string[i] <= 'Z' ) &&
-        !( string[i] >= 'a' && string[i] <= 'z' ) &&
-        !( string[i] >= '0' && string[i] <= '9' ) &&
-        string[i] != '-' && string[i] != '.' &&
-        string[i] != ':' && string[i] != '_' )
+  for (i = 0; i < nLen; i++) {
+    if (!(string[i] >= 'A' && string[i] <= 'Z') &&
+        !(string[i] >= 'a' && string[i] <= 'z') &&
+        !(string[i] >= '0' && string[i] <= '9') && string[i] != '-' &&
+        string[i] != '.' && string[i] != ':' && string[i] != '_')
       return MS_FALSE;
   }
 
   return MS_TRUE;
 }
 
-
 /*
  * Concatenate pszSrc to pszDest and reallocate memory if necessary.
-*/
-char *msStringConcatenate(char *pszDest, const char *pszSrc)
-{
+ */
+char *msStringConcatenate(char *pszDest, const char *pszSrc) {
   int nLen;
 
   if (pszSrc == NULL)
@@ -1466,13 +1424,14 @@ char *msStringConcatenate(char *pszDest,
 
     nLen = strlen(pszDest) + strlen(pszSrc);
 
-    pszTemp = (char*)realloc(pszDest, nLen + 1);
+    pszTemp = (char *)realloc(pszDest, nLen + 1);
     if (pszTemp) {
       pszDest = pszTemp;
       strcat(pszDest, pszSrc);
       pszDest[nLen] = '\0';
     } else {
-      msSetError(MS_MEMERR, "Error while reallocating memory.", "msStringConcatenate()");
+      msSetError(MS_MEMERR, "Error while reallocating memory.",
+                 "msStringConcatenate()");
       return NULL;
     }
   }
@@ -1480,25 +1439,25 @@ char *msStringConcatenate(char *pszDest,
   return pszDest;
 }
 
-char *msJoinStrings(char **array, int arrayLength, const char *delimeter)
-{
+char *msJoinStrings(char **array, int arrayLength, const char *delimeter) {
   char *string;
-  int stringLength=0;
+  int stringLength = 0;
   int delimeterLength;
   int i;
 
-  if(!array || arrayLength <= 0 || !delimeter) return NULL;
+  if (!array || arrayLength <= 0 || !delimeter)
+    return NULL;
 
   delimeterLength = strlen(delimeter);
 
-  for(i=0; i<arrayLength; i++)
+  for (i = 0; i < arrayLength; i++)
     stringLength += strlen(array[i]) + delimeterLength;
 
-  string = (char *)calloc(stringLength+1, sizeof(char));
-  MS_CHECK_ALLOC(string, (stringLength+1)* sizeof(char), NULL);
+  string = (char *)calloc(stringLength + 1, sizeof(char));
+  MS_CHECK_ALLOC(string, (stringLength + 1) * sizeof(char), NULL);
   string[0] = '\0';
 
-  for(i=0; i<arrayLength-1; i++) {
+  for (i = 0; i < arrayLength - 1; i++) {
     strlcat(string, array[i], stringLength);
     strlcat(string, delimeter, stringLength);
   }
@@ -1507,101 +1466,107 @@ char *msJoinStrings(char **array, int ar
   return string;
 }
 
-#define HASH_SIZE  16
+#define HASH_SIZE 16
 /*
  * Return a hashed string for a given input string.
  * The caller should free the return value.
-*/
-char *msHashString(const char *pszStr)
-{
-  unsigned char sums[HASH_SIZE] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
+ */
+char *msHashString(const char *pszStr) {
+  unsigned char sums[HASH_SIZE] = {0, 0, 0, 0, 0, 0, 0, 0,
+                                   0, 0, 0, 0, 0, 0, 0, 0};
   char *pszOutBuf = NULL;
   size_t bufferSize = 0;
-  int i=0;
+  int i = 0;
 
-  bufferSize = HASH_SIZE*2+1;
-  pszOutBuf = (char*)msSmallMalloc(bufferSize);
+  bufferSize = HASH_SIZE * 2 + 1;
+  pszOutBuf = (char *)msSmallMalloc(bufferSize);
 
-  for(i=0; pszStr && pszStr[i]; i++) {
-    sums[i%HASH_SIZE] += (unsigned char)(pszStr[i]);
+  for (i = 0; pszStr && pszStr[i]; i++) {
+    sums[i % HASH_SIZE] += (unsigned char)(pszStr[i]);
   }
 
-  for(i=0; i<HASH_SIZE; i++) {
-    snprintf(pszOutBuf + i*2, bufferSize-(i*2), "%02x", sums[i]);
+  for (i = 0; i < HASH_SIZE; i++) {
+    snprintf(pszOutBuf + i * 2, bufferSize - (i * 2), "%02x", sums[i]);
   }
 
   return pszOutBuf;
 }
 
-char *msCommifyString(char *str)
-{
+char *msCommifyString(char *str) {
   int i, j, old_length, new_length;
-  int num_commas=0, num_decimal_points=0;
+  int num_commas = 0, num_decimal_points = 0;
   int add_commas;
 
-  char comma=',', decimal_point='.';
+  char comma = ',', decimal_point = '.';
 
-  if(!str) return NULL;
+  if (!str)
+    return NULL;
 
   num_decimal_points = msCountChars(str, decimal_point);
-  if(num_decimal_points > 1) return str;
+  if (num_decimal_points > 1)
+    return str;
 
   old_length = strlen(str);
-  if(num_decimal_points == 0) {
-    num_commas =  floor((old_length - 1)/3);
-    add_commas=1; /* add commas right away */
+  if (num_decimal_points == 0) {
+    num_commas = floor((old_length - 1) / 3);
+    add_commas = 1; /* add commas right away */
   } else {
-    num_commas = floor(((old_length - strlen(strchr(str, decimal_point))) - 1)/3);
-    add_commas=0; /* wait until after the decimal point */
+    num_commas =
+        floor(((old_length - strlen(strchr(str, decimal_point))) - 1) / 3);
+    add_commas = 0; /* wait until after the decimal point */
   }
 
-  if(num_commas < 1) return str; /* nothing to add */
+  if (num_commas < 1)
+    return str; /* nothing to add */
 
   new_length = old_length + num_commas;
-  str = (char *) msSmallRealloc(str, new_length+1);
+  str = (char *)msSmallRealloc(str, new_length + 1);
   str[new_length] = '\0';
 
   j = 0;
-  for(i=new_length-1; i>=0; i--) { /* step backwards through the string */
+  for (i = new_length - 1; i >= 0;
+       i--) { /* step backwards through the string */
 
-    if(num_decimal_points == 1 &&  add_commas == 0) { /* to the right of the decimal point, no commas */
-      str[i] = str[i-num_commas];
-      if(str[i] == decimal_point) add_commas = 1;
-    } else if(add_commas == 1 && j>2) { /* need a comma */
+    if (num_decimal_points == 1 &&
+        add_commas == 0) { /* to the right of the decimal point, no commas */
+      str[i] = str[i - num_commas];
+      if (str[i] == decimal_point)
+        add_commas = 1;
+    } else if (add_commas == 1 && j > 2) { /* need a comma */
       str[i] = comma;
       num_commas--; /* need one fewer now */
-      j = 0; /* reset */
+      j = 0;        /* reset */
     } else {
-      str[i] = str[i-num_commas]; /* shift to the right */
+      str[i] = str[i - num_commas]; /* shift to the right */
       j++;
     }
 
-    if(num_commas == 0) break; /* done, rest of string is ok "as is" */
+    if (num_commas == 0)
+      break; /* done, rest of string is ok "as is" */
   }
 
   return str;
 }
 
-
-/* ------------------------------------------------------------------------------- */
-/*       Replace all occurrences of old with new in str.                           */
-/*       It is assumed that str was dynamically created using malloc.              */
-/*       Same function as msReplaceSubstring but this is case insensitive          */
-/* ------------------------------------------------------------------------------- */
-char *msCaseReplaceSubstring(char *str, const char *old, const char *newstr)
-{
+/* -------------------------------------------------------------------------------
+ */
+/*       Replace all occurrences of old with new in str. */
+/*       It is assumed that str was dynamically created using malloc. */
+/*       Same function as msReplaceSubstring but this is case insensitive */
+/* -------------------------------------------------------------------------------
+ */
+char *msCaseReplaceSubstring(char *str, const char *old, const char *newstr) {
   size_t str_len, old_len, new_len, tmp_offset;
   char *tmp_ptr;
 
   /*
   ** If old is not found then leave str alone
   */
-  if( (tmp_ptr = (char *) strcasestr(str, old)) == NULL)
-    return(str);
-  
-  if(newstr == NULL)
-    newstr = "";
+  if ((tmp_ptr = (char *)strcasestr(str, old)) == NULL)
+    return (str);
 
+  if (newstr == NULL)
+    newstr = "";
 
   /*
   ** Grab some info about incoming strings
@@ -1613,16 +1578,17 @@ char *msCaseReplaceSubstring(char *str,
   /*
   ** Now loop until old is NOT found in new
   */
-  while( tmp_ptr != NULL ) {
+  while (tmp_ptr != NULL) {
 
     /*
     ** re-allocate memory for buf assuming 1 replacement of old with new
-          ** don't bother reallocating if old is larger than new)
+    ** don't bother reallocating if old is larger than new)
     */
     if (old_len < new_len) {
       tmp_offset = tmp_ptr - str;
       str_len = str_len - old_len + new_len;
-      str = (char *)msSmallRealloc(str, (str_len + 1)); /* make new space for a copy */
+      str = (char *)msSmallRealloc(
+          str, (str_len + 1)); /* make new space for a copy */
       tmp_ptr = str + tmp_offset;
     }
 
@@ -1630,7 +1596,8 @@ char *msCaseReplaceSubstring(char *str,
     ** Move the trailing part of str to make some room unless old_len == new_len
     */
     if (old_len != new_len) {
-      memmove(tmp_ptr+new_len, tmp_ptr+old_len, strlen(tmp_ptr)-old_len+1);
+      memmove(tmp_ptr + new_len, tmp_ptr + old_len,
+              strlen(tmp_ptr) - old_len + 1);
     }
 
     /*
@@ -1641,34 +1608,31 @@ char *msCaseReplaceSubstring(char *str,
     /*
     ** And look for more matches in the rest of the string
     */
-    tmp_ptr = (char *) strcasestr(tmp_ptr + new_len, old);
+    tmp_ptr = (char *)strcasestr(tmp_ptr + new_len, old);
   }
 
-  return(str);
+  return (str);
 }
 
 /*
 ** Converts a 2 character hexidecimal string to an integer.
 */
-int msHexToInt(char *hex)
-{
+int msHexToInt(char *hex) {
   int number;
 
-  number = (hex[0] >= 'A' ? ((hex[0] & 0xdf) - 'A')+10 : (hex[0] - '0'));
+  number = (hex[0] >= 'A' ? ((hex[0] & 0xdf) - 'A') + 10 : (hex[0] - '0'));
   number *= 16;
-  number += (hex[1] >= 'A' ? ((hex[1] & 0xdf) - 'A')+10 : (hex[1] - '0'));
+  number += (hex[1] >= 'A' ? ((hex[1] & 0xdf) - 'A') + 10 : (hex[1] - '0'));
 
-  return(number);
+  return (number);
 }
 
-
 /*
 ** Use FRIBIDI to encode the string.
 ** The return value must be freed by the caller.
 */
 #ifdef USE_FRIBIDI
-char *msGetFriBidiEncodedString(const char *string, const char *encoding)
-{
+char *msGetFriBidiEncodedString(const char *string, const char *encoding) {
   FriBidiChar logical[MAX_STR_LEN];
   FriBidiParType base;
   size_t len;
@@ -1683,15 +1647,15 @@ char *msGetFriBidiEncodedString(const ch
   len = strlen(string);
 
 #ifdef FRIBIDI_NO_CHARSETS
-  to_ucs4 = iconv_open ("WCHAR_T", encoding);
-  from_ucs4 = iconv_open ("UTF-8", "WCHAR_T");
+  to_ucs4 = iconv_open("WCHAR_T", encoding);
+  from_ucs4 = iconv_open("UTF-8", "WCHAR_T");
 #else
-  to_char_set_num = fribidi_parse_charset ((char*)encoding);
-  from_char_set_num = fribidi_parse_charset ("UTF-8");
+  to_char_set_num = fribidi_parse_charset((char *)encoding);
+  from_char_set_num = fribidi_parse_charset("UTF-8");
 #endif
 
 #ifdef FRIBIDI_NO_CHARSETS
-  if (to_ucs4 == (iconv_t) (-1) || from_ucs4 == (iconv_t) (-1))
+  if (to_ucs4 == (iconv_t)(-1) || from_ucs4 == (iconv_t)(-1))
 #else
   if (!to_char_set_num || !from_char_set_num)
 #endif
@@ -1703,14 +1667,15 @@ char *msGetFriBidiEncodedString(const ch
 
 #ifdef FRIBIDI_NO_CHARSETS
   {
-    char *st = string, *ust = (char *) logical;
-    int in_len = (int) len;
+    char *st = string, *ust = (char *)logical;
+    int in_len = (int)len;
     len = sizeof logical;
-    iconv (to_ucs4, &st, &in_len, &ust, (int *) &len);
-    len = (FriBidiChar *) ust - logical;
+    iconv(to_ucs4, &st, &in_len, &ust, (int *)&len);
+    len = (FriBidiChar *)ust - logical;
   }
 #else
-  len = fribidi_charset_to_unicode (to_char_set_num, (char*)string, len, logical);
+  len =
+      fribidi_charset_to_unicode(to_char_set_num, (char *)string, len, logical);
 #endif
 
   {
@@ -1721,28 +1686,29 @@ char *msGetFriBidiEncodedString(const ch
     FriBidiStrIndex new_len;
     fribidi_boolean log2vis;
 
-    visual = (FriBidiChar *) msSmallMalloc (sizeof (FriBidiChar) * (len + 1));
+    visual = (FriBidiChar *)msSmallMalloc(sizeof(FriBidiChar) * (len + 1));
     ltov = NULL;
     vtol = NULL;
     levels = NULL;
 
     // fribidi_log2vis() doesn't support multi-line paragraphs.
-    // See: https://lists.freedesktop.org/archives/fribidi/2008-January/000515.html
-    for( size_t i = 0; i < len; i++ )
-    {
-        if (logical[i] == '\n') {
-          msSetError(MS_IDENTERR,
-                     "Input string is a multi-line paragraph, which is not supported.",
-                     "msGetFriBidiEncodedString()");
-          msFree(visual);
-          return NULL;
-        }
+    // See:
+    // https://lists.freedesktop.org/archives/fribidi/2008-January/000515.html
+    for (size_t i = 0; i < len; i++) {
+      if (logical[i] == '\n') {
+        msSetError(
+            MS_IDENTERR,
+            "Input string is a multi-line paragraph, which is not supported.",
+            "msGetFriBidiEncodedString()");
+        msFree(visual);
+        return NULL;
+      }
     }
 
     /* Create a bidi string. */
-    log2vis = fribidi_log2vis (logical, len, &base,
-                               /* output */
-                               visual, ltov, vtol, levels);
+    log2vis = fribidi_log2vis(logical, len, &base,
+                              /* output */
+                              visual, ltov, vtol, levels);
 
     if (!log2vis) {
       msSetError(MS_IDENTERR, "Failed to create bidi string.",
@@ -1754,23 +1720,23 @@ char *msGetFriBidiEncodedString(const ch
     /* Convert it to utf-8 for display. */
 #ifdef FRIBIDI_NO_CHARSETS
     {
-      char *str = outstring, *ust = (char *) visual;
+      char *str = outstring, *ust = (char *)visual;
       int in_len = len * sizeof visual[0];
       new_len = sizeof outstring;
-      iconv (from_ucs4, &ust, &in_len, &str, (int *) &new_len);
+      iconv(from_ucs4, &ust, &in_len, &str, (int *)&new_len);
       *str = '\0';
       new_len = str - outstring;
     }
 #else
     new_len =
-      fribidi_unicode_to_charset (from_char_set_num,
-                                  visual, len, outstring);
+        fribidi_unicode_to_charset(from_char_set_num, visual, len, outstring);
 
     /* scan str and compress out FRIBIDI_CHAR_FILL UTF8 characters */
 
-    int j=0;
-    for (int i=0; i<new_len; i++, j++) {
-      if (outstring[i] == '\xef' && outstring[i+1] == '\xbb' && outstring[i+2] == '\xbf') {
+    int j = 0;
+    for (int i = 0; i < new_len; i++, j++) {
+      if (outstring[i] == '\xef' && outstring[i + 1] == '\xbb' &&
+          outstring[i + 2] == '\xbf') {
         i += 3;
       }
       if (i != j) {
@@ -1791,8 +1757,7 @@ char *msGetFriBidiEncodedString(const ch
 ** Simple charset converter. Converts string from specified encoding to UTF-8.
 ** The return value must be freed by the caller.
 */
-char *msGetEncodedString(const char *string, const char *encoding)
-{
+char *msGetEncodedString(const char *string, const char *encoding) {
 #ifdef USE_ICONV
   iconv_t cd = NULL;
   const char *inp;
@@ -1802,7 +1767,7 @@ char *msGetEncodedString(const char *str
 
 #ifdef USE_FRIBIDI
   msAcquireLock(TLOCK_FRIBIDI);
-  if(fribidi_parse_charset ((char*)encoding)) {
+  if (fribidi_parse_charset((char *)encoding)) {
     char *ret = msGetFriBidiEncodedString(string, encoding);
     msReleaseLock(TLOCK_FRIBIDI);
     return ret;
@@ -1811,11 +1776,11 @@ char *msGetEncodedString(const char *str
 #endif
   len = strlen(string);
 
-  if (len == 0 || strcasecmp(encoding, "UTF-8")==0)
-    return msStrdup(string);    /* Nothing to do: string already in UTF-8 */
+  if (len == 0 || strcasecmp(encoding, "UTF-8") == 0)
+    return msStrdup(string); /* Nothing to do: string already in UTF-8 */
 
   cd = iconv_open("UTF-8", encoding);
-  if(cd == (iconv_t)-1) {
+  if (cd == (iconv_t)-1) {
     msSetError(MS_IDENTERR, "Encoding not supported by libiconv (%s).",
                "msGetEncodedString()", encoding);
     return NULL;
@@ -1823,8 +1788,8 @@ char *msGetEncodedString(const char *str
 
   bufsize = len * 6 + 1; /* Each UTF-8 char can be up to 6 bytes */
   inp = string;
-  out = (char*) malloc(bufsize);
-  if(out == NULL) {
+  out = (char *)malloc(bufsize);
+  if (out == NULL) {
     msSetError(MS_MEMERR, NULL, "msGetEncodedString()");
     iconv_close(cd);
     return NULL;
@@ -1835,8 +1800,9 @@ char *msGetEncodedString(const char *str
   bufleft = bufsize;
 
   while (len > 0) {
-    const size_t iconv_status = msIconv(cd, (char**)&inp, &len, &outp, &bufleft);
-    if(iconv_status == static_cast<size_t>(-1)) {
+    const size_t iconv_status =
+        msIconv(cd, (char **)&inp, &len, &outp, &bufleft);
+    if (iconv_status == static_cast<size_t>(-1)) {
       msFree(out);
       iconv_close(cd);
       return msStrdup(string);
@@ -1848,34 +1814,33 @@ char *msGetEncodedString(const char *str
 
   return out;
 #else
-  if (*string == '\0' || (encoding && strcasecmp(encoding, "UTF-8")==0))
-    return msStrdup(string);    /* Nothing to do: string already in UTF-8 */
+  if (*string == '\0' || (encoding && strcasecmp(encoding, "UTF-8") == 0))
+    return msStrdup(string); /* Nothing to do: string already in UTF-8 */
 
-  msSetError(MS_MISCERR, "Not implemeted since Iconv is not enabled.", "msGetEncodedString()");
+  msSetError(MS_MISCERR, "Not implemeted since Iconv is not enabled.",
+             "msGetEncodedString()");
   return NULL;
 #endif
 }
 
-
-char* msConvertWideStringToUTF8 (const wchar_t* string, const char* encoding)
-{
+char *msConvertWideStringToUTF8(const wchar_t *string, const char *encoding) {
 #ifdef USE_ICONV
 
-  char* output = NULL;
-  const char* errormessage = NULL;
+  char *output = NULL;
+  const char *errormessage = NULL;
   iconv_t cd = NULL;
   size_t nStr;
   size_t nInSize;
   size_t nOutSize;
   size_t nBufferSize;
 
-  char* pszUTF8 = NULL;
-  const wchar_t* pwszWide = NULL;
+  char *pszUTF8 = NULL;
+  const wchar_t *pwszWide = NULL;
 
   if (string != NULL) {
-    nStr = wcslen (string);
+    nStr = wcslen(string);
     nBufferSize = ((nStr * 6) + 1);
-    output = (char*) msSmallMalloc (nBufferSize);
+    output = (char *)msSmallMalloc(nBufferSize);
 
     if (nStr == 0) {
       /* return an empty 8 byte string */
@@ -1887,28 +1852,31 @@ char* msConvertWideStringToUTF8 (const w
 
     nOutSize = nBufferSize;
     if ((iconv_t)-1 != cd) {
-      nInSize = sizeof (wchar_t)*nStr;
+      nInSize = sizeof(wchar_t) * nStr;
       pszUTF8 = output;
       pwszWide = string;
-      size_t iconv_status = msIconv(cd, (char **)&pwszWide, &nInSize, &pszUTF8, &nOutSize);
+      size_t iconv_status =
+          msIconv(cd, (char **)&pwszWide, &nInSize, &pszUTF8, &nOutSize);
       if ((size_t)-1 == iconv_status) {
         switch (errno) {
-          case E2BIG:
-            errormessage = "There is not sufficient room in buffer";
-            break;
-          case EILSEQ:
-            errormessage = "An invalid multibyte sequence has been encountered in the input";
-            break;
-          case EINVAL:
-            errormessage = "An incomplete multibyte sequence has been encountered in the input";
-            break;
-          default:
-            errormessage = "Unknown";
-            break;
+        case E2BIG:
+          errormessage = "There is not sufficient room in buffer";
+          break;
+        case EILSEQ:
+          errormessage =
+              "An invalid multibyte sequence has been encountered in the input";
+          break;
+        case EINVAL:
+          errormessage = "An incomplete multibyte sequence has been "
+                         "encountered in the input";
+          break;
+        default:
+          errormessage = "Unknown";
+          break;
         }
-        msSetError(MS_MISCERR, "Unable to convert string in encoding '%s' to UTF8 %s",
-                   "msConvertWideStringToUTF8()",
-                   encoding,errormessage);
+        msSetError(MS_MISCERR,
+                   "Unable to convert string in encoding '%s' to UTF8 %s",
+                   "msConvertWideStringToUTF8()", encoding, errormessage);
         iconv_close(cd);
         msFree(output);
         return NULL;
@@ -1916,8 +1884,7 @@ char* msConvertWideStringToUTF8 (const w
       iconv_close(cd);
     } else {
       msSetError(MS_MISCERR, "Encoding not supported by libiconv (%s).",
-                 "msConvertWideStringToUTF8()",
-                 encoding);
+                 "msConvertWideStringToUTF8()", encoding);
       msFree(output);
       return NULL;
     }
@@ -1931,29 +1898,29 @@ char* msConvertWideStringToUTF8 (const w
   output[nBufferSize - nOutSize] = '\0';
   return output;
 #else
-  msSetError(MS_MISCERR, "Not implemented since Iconv is not enabled.", "msConvertWideStringToUTF8()");
+  msSetError(MS_MISCERR, "Not implemented since Iconv is not enabled.",
+             "msConvertWideStringToUTF8()");
   return NULL;
 #endif
 }
 
-wchar_t* msConvertWideStringFromUTF8 (const char* string, const char* encoding)
-{
+wchar_t *msConvertWideStringFromUTF8(const char *string, const char *encoding) {
 #ifdef USE_ICONV
-  wchar_t* output = NULL;
-  const char* errormessage = NULL;
+  wchar_t *output = NULL;
+  const char *errormessage = NULL;
   iconv_t cd = NULL;
   size_t nStr;
   size_t nInSize;
   size_t nOutSize;
   size_t nBufferSize;
 
-  const char* pszUTF8 = NULL;
-  wchar_t* pwszWide = NULL;
+  const char *pszUTF8 = NULL;
+  wchar_t *pwszWide = NULL;
 
   if (string != NULL) {
-    nStr = strlen (string);
+    nStr = strlen(string);
     nBufferSize = ((nStr * 6) + 1);
-    output = (wchar_t*) msSmallMalloc (nBufferSize);
+    output = (wchar_t *)msSmallMalloc(nBufferSize);
 
     if (nStr == 0) {
       /* return an empty 8 byte string */
@@ -1965,28 +1932,31 @@ wchar_t* msConvertWideStringFromUTF8 (co
 
     nOutSize = nBufferSize;
     if ((iconv_t)-1 != cd) {
-      nInSize = sizeof (char)*nStr;
+      nInSize = sizeof(char) * nStr;
       pszUTF8 = string;
       pwszWide = output;
-      size_t iconv_status = msIconv(cd, (char **)&pszUTF8, &nInSize, (char **)&pwszWide, &nOutSize);
+      size_t iconv_status = msIconv(cd, (char **)&pszUTF8, &nInSize,
+                                    (char **)&pwszWide, &nOutSize);
       if ((size_t)-1 == iconv_status) {
         switch (errno) {
-          case E2BIG:
-            errormessage = "There is not sufficient room in buffer";
-            break;
-          case EILSEQ:
-            errormessage = "An invalid multibyte sequence has been encountered in the input";
-            break;
-          case EINVAL:
-            errormessage = "An incomplete multibyte sequence has been encountered in the input";
-            break;
-          default:
-            errormessage = "Unknown";
-            break;
+        case E2BIG:
+          errormessage = "There is not sufficient room in buffer";
+          break;
+        case EILSEQ:
+          errormessage =
+              "An invalid multibyte sequence has been encountered in the input";
+          break;
+        case EINVAL:
+          errormessage = "An incomplete multibyte sequence has been "
+                         "encountered in the input";
+          break;
+        default:
+          errormessage = "Unknown";
+          break;
         }
-        msSetError(MS_MISCERR, "Unable to convert string in UTF8 to encoding '%s' %s",
-                   "msConvertWideStringFromUTF8()",
-                   encoding, errormessage);
+        msSetError(MS_MISCERR,
+                   "Unable to convert string in UTF8 to encoding '%s' %s",
+                   "msConvertWideStringFromUTF8()", encoding, errormessage);
         iconv_close(cd);
         msFree(output);
         return NULL;
@@ -1994,8 +1964,7 @@ wchar_t* msConvertWideStringFromUTF8 (co
       iconv_close(cd);
     } else {
       msSetError(MS_MISCERR, "Encoding not supported by libiconv (%s).",
-                 "msConvertWideStringFromUTF8()",
-                 encoding);
+                 "msConvertWideStringFromUTF8()", encoding);
       msFree(output);
       return NULL;
     }
@@ -2005,12 +1974,13 @@ wchar_t* msConvertWideStringFromUTF8 (co
   }
 
   /* NULL-terminate the output string */
-  if (nOutSize >= sizeof (wchar_t))
-    *((wchar_t *) pwszWide) = L'\0';
+  if (nOutSize >= sizeof(wchar_t))
+    *((wchar_t *)pwszWide) = L'\0';
 
   return output;
 #else
-  msSetError(MS_MISCERR, "Not implemented since Iconv is not enabled.", "msConvertWideStringFromUTF8()");
+  msSetError(MS_MISCERR, "Not implemented since Iconv is not enabled.",
+             "msConvertWideStringFromUTF8()");
   return NULL;
 #endif
 }
@@ -2045,105 +2015,104 @@ wchar_t* msConvertWideStringFromUTF8 (co
 ** U-00200000 U-03FFFFFF: 111110xx 10xxxxxx 10xxxxxx 10xxxxxx 10xxxxxx
 ** U-04000000 U-7FFFFFFF: 1111110x 10xxxxxx 10xxxxxx 10xxxxxx 10xxxxxx 10xxxxxx
 */
-int msGetNextGlyph(const char **in_ptr, char *out_string)
-{
+int msGetNextGlyph(const char **in_ptr, char *out_string) {
   unsigned char in;
-  int numbytes=0;
+  int numbytes = 0;
   unsigned int unicode;
   int i;
 
   in = (unsigned char)**in_ptr;
 
   if (in == 0)
-    return -1;  /* Empty string */
-  if((numbytes=msGetUnicodeEntity(*in_ptr,&unicode))>0) {
-    if(out_string) {
-      for(i=0; i<numbytes; i++) {
-        out_string[i]=(*in_ptr)[i];
+    return -1; /* Empty string */
+  if ((numbytes = msGetUnicodeEntity(*in_ptr, &unicode)) > 0) {
+    if (out_string) {
+      for (i = 0; i < numbytes; i++) {
+        out_string[i] = (*in_ptr)[i];
       }
-      out_string[numbytes]='\0';
+      out_string[numbytes] = '\0';
     }
-    *in_ptr+=numbytes;
+    *in_ptr += numbytes;
     return numbytes;
   }
   if (in < 0xC0) {
     /*
-    * Handles properly formed UTF-8 characters between
-    * 0x01 and 0x7F.  Also treats \0 and naked trail
-    * bytes 0x80 to 0xBF as valid characters representing
-    * themselves.
-    */
+     * Handles properly formed UTF-8 characters between
+     * 0x01 and 0x7F.  Also treats \0 and naked trail
+     * bytes 0x80 to 0xBF as valid characters representing
+     * themselves.
+     */
     /*goto end of loop to return just the char*/
   } else if (in < 0xE0) {
-    if (((*in_ptr)[1]& 0xC0) == 0x80) {
-      if(out_string) {
-        out_string[0]=in;
-        out_string[1]=(*in_ptr)[1];
-        out_string[2]='\0';
+    if (((*in_ptr)[1] & 0xC0) == 0x80) {
+      if (out_string) {
+        out_string[0] = in;
+        out_string[1] = (*in_ptr)[1];
+        out_string[2] = '\0';
       }
-      *in_ptr+=2;
+      *in_ptr += 2;
       return 2; /*110xxxxx 10xxxxxx*/
     }
   } else if (in < 0xF0) {
-    if (((*in_ptr)[1]& 0xC0) == 0x80 && ((*in_ptr)[2]& 0xC0) == 0x80) {
-      if(out_string) {
-        out_string[0]=in;
-        *in_ptr+=numbytes;
-        out_string[1]=(*in_ptr)[1];
-        out_string[2]=(*in_ptr)[2];
-        out_string[3]='\0';
+    if (((*in_ptr)[1] & 0xC0) == 0x80 && ((*in_ptr)[2] & 0xC0) == 0x80) {
+      if (out_string) {
+        out_string[0] = in;
+        *in_ptr += numbytes;
+        out_string[1] = (*in_ptr)[1];
+        out_string[2] = (*in_ptr)[2];
+        out_string[3] = '\0';
       }
-      *in_ptr+=3;
-      return 3;   /* 1110xxxx 10xxxxxx 10xxxxxx */
+      *in_ptr += 3;
+      return 3; /* 1110xxxx 10xxxxxx 10xxxxxx */
     }
   } else if (in < 0xF8) {
-    if (((*in_ptr)[1]& 0xC0) == 0x80 && ((*in_ptr)[2]& 0xC0) == 0x80
-        && ((*in_ptr)[3]& 0xC0) == 0x80) {
-      if(out_string) {
-        out_string[0]=in;
-        out_string[1]=(*in_ptr)[1];
-        out_string[2]=(*in_ptr)[2];
-        out_string[3]=(*in_ptr)[3];
-        out_string[4]='\0';
+    if (((*in_ptr)[1] & 0xC0) == 0x80 && ((*in_ptr)[2] & 0xC0) == 0x80 &&
+        ((*in_ptr)[3] & 0xC0) == 0x80) {
+      if (out_string) {
+        out_string[0] = in;
+        out_string[1] = (*in_ptr)[1];
+        out_string[2] = (*in_ptr)[2];
+        out_string[3] = (*in_ptr)[3];
+        out_string[4] = '\0';
       }
-      *in_ptr+=4;
-      return 4;   /* 11110xxx 10xxxxxx 10xxxxxx 10xxxxxx */
+      *in_ptr += 4;
+      return 4; /* 11110xxx 10xxxxxx 10xxxxxx 10xxxxxx */
     }
   } else if (in < 0xFC) {
-    if (((*in_ptr)[1]& 0xC0) == 0x80 && ((*in_ptr)[2]& 0xC0) == 0x80
-        && ((*in_ptr)[3]& 0xC0) == 0x80 && ((*in_ptr)[4]& 0xC0) == 0x80) {
-      if(out_string) {
-        out_string[0]=in;
-        out_string[1]=(*in_ptr)[1];
-        out_string[2]=(*in_ptr)[2];
-        out_string[3]=(*in_ptr)[3];
-        out_string[4]=(*in_ptr)[4];
-        out_string[5]='\0';
+    if (((*in_ptr)[1] & 0xC0) == 0x80 && ((*in_ptr)[2] & 0xC0) == 0x80 &&
+        ((*in_ptr)[3] & 0xC0) == 0x80 && ((*in_ptr)[4] & 0xC0) == 0x80) {
+      if (out_string) {
+        out_string[0] = in;
+        out_string[1] = (*in_ptr)[1];
+        out_string[2] = (*in_ptr)[2];
+        out_string[3] = (*in_ptr)[3];
+        out_string[4] = (*in_ptr)[4];
+        out_string[5] = '\0';
       }
-      *in_ptr+=5;
-      return 5;   /* 111110xx 10xxxxxx 10xxxxxx 10xxxxxx 10xxxxxx */
+      *in_ptr += 5;
+      return 5; /* 111110xx 10xxxxxx 10xxxxxx 10xxxxxx 10xxxxxx */
     }
   } else if (in < 0xFE) {
-    if (((*in_ptr)[1]& 0xC0) == 0x80 && ((*in_ptr)[2]& 0xC0) == 0x80
-        && ((*in_ptr)[3]& 0xC0) == 0x80 && ((*in_ptr)[4]& 0xC0) == 0x80
-        && ((*in_ptr)[5]& 0xC0) == 0x80) {
-      if(out_string) {
-        out_string[0]=in;
-        out_string[1]=(*in_ptr)[1];
-        out_string[2]=(*in_ptr)[2];
-        out_string[3]=(*in_ptr)[3];
-        out_string[4]=(*in_ptr)[4];
-        out_string[5]=(*in_ptr)[5];
-        out_string[6]='\0';
+    if (((*in_ptr)[1] & 0xC0) == 0x80 && ((*in_ptr)[2] & 0xC0) == 0x80 &&
+        ((*in_ptr)[3] & 0xC0) == 0x80 && ((*in_ptr)[4] & 0xC0) == 0x80 &&
+        ((*in_ptr)[5] & 0xC0) == 0x80) {
+      if (out_string) {
+        out_string[0] = in;
+        out_string[1] = (*in_ptr)[1];
+        out_string[2] = (*in_ptr)[2];
+        out_string[3] = (*in_ptr)[3];
+        out_string[4] = (*in_ptr)[4];
+        out_string[5] = (*in_ptr)[5];
+        out_string[6] = '\0';
       }
-      *in_ptr+=6;
-      return 6;   /* 1111110x 10xxxxxx 10xxxxxx 10xxxxxx 10xxxxxx 10xxxxxx */
+      *in_ptr += 6;
+      return 6; /* 1111110x 10xxxxxx 10xxxxxx 10xxxxxx 10xxxxxx 10xxxxxx */
     }
   }
 
   if (out_string) {
-    out_string[0]=in;
-    out_string[1] = '\0';   /* 0xxxxxxx */
+    out_string[0] = in;
+    out_string[1] = '\0'; /* 0xxxxxxx */
   }
   (*in_ptr)++;
   return 1;
@@ -2152,20 +2121,18 @@ int msGetNextGlyph(const char **in_ptr,
 /*
 ** Returns the number of glyphs in string
 */
-int msGetNumGlyphs(const char *in_ptr)
-{
-  int numchars=0;
+int msGetNumGlyphs(const char *in_ptr) {
+  int numchars = 0;
 
-  while( msGetNextGlyph(&in_ptr, NULL) != -1 )
+  while (msGetNextGlyph(&in_ptr, NULL) != -1)
     numchars++;
 
   return numchars;
 }
 
-static int cmp_entities(const void *e1, const void *e2)
-{
-  struct mapentities_s *en1 = (struct mapentities_s *) e1;
-  struct mapentities_s *en2 = (struct mapentities_s *) e2;
+static int cmp_entities(const void *e1, const void *e2) {
+  struct mapentities_s *en1 = (struct mapentities_s *)e1;
+  struct mapentities_s *en2 = (struct mapentities_s *)e2;
   return strcmp(en1->name, en2->name);
 }
 /*
@@ -2176,67 +2143,65 @@ static int cmp_entities(const void *e1,
  * - if the string does start with such entity,it returns the number of
  * bytes occupied by said entity, and stores the unicode value in *unicode
  */
-int msGetUnicodeEntity(const char *inptr, unsigned int *unicode)
-{
-  unsigned char *in = (unsigned char*)inptr;
-  int l,val=0;
-  if(*in=='&') {
+int msGetUnicodeEntity(const char *inptr, unsigned int *unicode) {
+  unsigned char *in = (unsigned char *)inptr;
+  int l, val = 0;
+  if (*in == '&') {
     in++;
-    if(*in=='#') {
+    if (*in == '#') {
       in++;
-      if(*in=='x'||*in=='X') {
+      if (*in == 'x' || *in == 'X') {
         in++;
-        for(l=3; l<8; l++) {
+        for (l = 3; l < 8; l++) {
           char byte;
-          if(*in>='0'&&*in<='9')
+          if (*in >= '0' && *in <= '9')
             byte = *in - '0';
-          else if(*in>='a'&&*in<='f')
+          else if (*in >= 'a' && *in <= 'f')
             byte = *in - 'a' + 10;
-          else if(*in>='A'&&*in<='F')
+          else if (*in >= 'A' && *in <= 'F')
             byte = *in - 'A' + 10;
           else
             break;
           in++;
           val = (val * 16) + byte;
         }
-        if(*in==';' && l>3 ) {
-          *unicode=val;
+        if (*in == ';' && l > 3) {
+          *unicode = val;
           return ++l;
         }
       } else {
-        for(l=2; l<8; l++) {
-          if(*in>='0'&&*in<='9') {
-            val = val*10+*in-'0';
+        for (l = 2; l < 8; l++) {
+          if (*in >= '0' && *in <= '9') {
+            val = val * 10 + *in - '0';
             in++;
           } else
             break;
         }
-        if(*in==';' && l>2 ) {
-          *unicode=val;
+        if (*in == ';' && l > 2) {
+          *unicode = val;
           return ++l;
         }
       }
     } else {
-      char entity_name_buf[MAP_ENTITY_NAME_LENGTH_MAX+1];
+      char entity_name_buf[MAP_ENTITY_NAME_LENGTH_MAX + 1];
       char *p;
       struct mapentities_s key;
       key.name = p = entity_name_buf;
-      for (l = 1; l <=  MAP_ENTITY_NAME_LENGTH_MAX+1; l++) {
+      for (l = 1; l <= MAP_ENTITY_NAME_LENGTH_MAX + 1; l++) {
         if (*in == '\0') /*end of string before possible entity: return*/
           break;
         if (*in == ';') { /*possible end of entity: do a lookup*/
           *p++ = '\0';
-          const struct mapentities_s* res =
-            static_cast<const struct mapentities_s*>(bsearch(
-                &key,
-                mapentities,
-                MAP_NR_OF_ENTITIES,
-                sizeof(mapentities[0]), cmp_entities));
+          const struct mapentities_s *res =
+              static_cast<const struct mapentities_s *>(
+                  bsearch(&key, mapentities, MAP_NR_OF_ENTITIES,
+                          sizeof(mapentities[0]), cmp_entities));
           if (res) {
             *unicode = res->value;
             return ++l;
           }
-          break; /*the string was of the form of an entity but didn't correspond to an existing one: return*/
+          break; /*the string was of the form of an entity but didn't correspond
+                    to an existing one: return*/
         }
         *p++ = *in;
         in++;
@@ -2256,8 +2221,7 @@ int msGetUnicodeEntity(const char *inptr
  * @return MS_SUCCESS or MS_FAILURE
  */
 
-int msStringIsInteger(const char *string)
-{
+int msStringIsInteger(const char *string) {
   int length, i;
 
   length = strlen(string);
@@ -2265,7 +2229,7 @@ int msStringIsInteger(const char *string
   if (length == 0)
     return MS_FAILURE;
 
-  for(i=0; i<length; i++) {
+  for (i = 0; i < length; i++) {
     if (!isdigit(string[i]))
       return MS_FAILURE;
   }
@@ -2279,29 +2243,27 @@ int msStringIsInteger(const char *string
 
 /* Safe version of msStrdup(). This function is taken from gdal/cpl. */
 
-char *msStrdup(const char * pszString)
-{
-    size_t nStringLength; 
-    char *pszReturn;
+char *msStrdup(const char *pszString) {
+  size_t nStringLength;
+  char *pszReturn;
 
-    if (pszString == NULL)
-        pszString = "";
+  if (pszString == NULL)
+    pszString = "";
 
-    nStringLength = strlen(pszString) + 1; /* null terminated byte */
-    pszReturn = static_cast<char*>(malloc(nStringLength));
+  nStringLength = strlen(pszString) + 1; /* null terminated byte */
+  pszReturn = static_cast<char *>(malloc(nStringLength));
 
-    if (pszReturn == NULL) {
-        fprintf(stderr, "msSmallMalloc(): Out of memory allocating %ld bytes.\n",
+  if (pszReturn == NULL) {
+    fprintf(stderr, "msSmallMalloc(): Out of memory allocating %ld bytes.\n",
             (long)strlen(pszString));
-        exit(1);
-    }
+    exit(1);
+  }
 
-    memcpy(pszReturn, pszString, nStringLength);
+  memcpy(pszReturn, pszString, nStringLength);
 
-    return pszReturn;
+  return pszReturn;
 }
 
-
 /************************************************************************/
 /*                             msStringEscape()                         */
 /************************************************************************/
@@ -2310,24 +2272,24 @@ char *msStrdup(const char * pszString)
    NOTE: the user must free the returned char* if it is different than the
    one passed in */
 
-char* msStringEscape( const char * pszString )
-{
+char *msStringEscape(const char *pszString) {
   char *string_tmp, *string_ptr;
-  int i,ncharstoescape=0;
+  int i, ncharstoescape = 0;
 
-  if (pszString ==  NULL || strlen(pszString) == 0)
+  if (pszString == NULL || strlen(pszString) == 0)
     return msStrdup("");
 
-  for (i=0; pszString[i]; i++)
-    ncharstoescape += ((pszString[i] == '\"')||(pszString[i] == '\''));
-  
-  if(!ncharstoescape) {
-    return (char*)pszString;
+  for (i = 0; pszString[i]; i++)
+    ncharstoescape += ((pszString[i] == '\"') || (pszString[i] == '\''));
+
+  if (!ncharstoescape) {
+    return (char *)pszString;
   }
 
-  string_tmp = (char*)msSmallMalloc(strlen(pszString)+ncharstoescape+1);
-  for (string_ptr=(char*)pszString,i=0; *string_ptr!='\0'; ++string_ptr,++i) {
-    if ( (*string_ptr == '\"') || (*string_ptr == '\'') ) {
+  string_tmp = (char *)msSmallMalloc(strlen(pszString) + ncharstoescape + 1);
+  for (string_ptr = (char *)pszString, i = 0; *string_ptr != '\0';
+       ++string_ptr, ++i) {
+    if ((*string_ptr == '\"') || (*string_ptr == '\'')) {
       string_tmp[i] = '\\';
       ++i;
     }
@@ -2338,12 +2300,11 @@ char* msStringEscape( const char * pszSt
   return string_tmp;
 }
 
-std::string msStdStringEscape( const char * pszString )
-{
-  char* tmp = msStringEscape(pszString);
+std::string msStdStringEscape(const char *pszString) {
+  char *tmp = msStringEscape(pszString);
   std::string ret(tmp);
-  if( tmp != pszString )
-      msFree(tmp);
+  if (tmp != pszString)
+    msFree(tmp);
   return ret;
 }
 
@@ -2352,26 +2313,25 @@ std::string msStdStringEscape( const cha
 /************************************************************************/
 
 /* Check if a string is in a array */
-int msStringInArray( const char * pszString, char **array, int numelements)
-{
+int msStringInArray(const char *pszString, char **array, int numelements) {
   int i;
-  for (i=0; i<numelements; ++i) {
-    if (strcasecmp(pszString, array[i])==0)
+  for (i = 0; i < numelements; ++i) {
+    if (strcasecmp(pszString, array[i]) == 0)
       return MS_TRUE;
   }
   return MS_FALSE;
 }
 
-bool msStringInArray( const char * pszString, const std::vector<std::string>& array)
-{
-  for( const auto& str: array ) {
-    if (strcasecmp(pszString, str.c_str())==0)
+bool msStringInArray(const char *pszString,
+                     const std::vector<std::string> &array) {
+  for (const auto &str : array) {
+    if (strcasecmp(pszString, str.c_str()) == 0)
       return true;
   }
   return false;
 }
 
-int msLayerEncodeShapeAttributes( layerObj *layer, shapeObj *shape) {
+int msLayerEncodeShapeAttributes(layerObj *layer, shapeObj *shape) {
 
 #ifdef USE_ICONV
   iconv_t cd = NULL;
@@ -2380,24 +2340,25 @@ int msLayerEncodeShapeAttributes( layerO
   size_t len, bufsize, bufleft;
   int i;
 
-  if( !layer->encoding || !*layer->encoding || !strcasecmp(layer->encoding, "UTF-8"))
+  if (!layer->encoding || !*layer->encoding ||
+      !strcasecmp(layer->encoding, "UTF-8"))
     return MS_SUCCESS;
 
   cd = iconv_open("UTF-8", layer->encoding);
-  if(cd == (iconv_t)-1) {
+  if (cd == (iconv_t)-1) {
     msSetError(MS_IDENTERR, "Encoding not supported by libiconv (%s).",
                "msGetEncodedString()", layer->encoding);
     return MS_FAILURE;
   }
 
-  for(i=0;i <shape->numvalues; i++) {
-    if(!shape->values[i] || (len = strlen(shape->values[i]))==0) {
-      continue;    /* Nothing to do */
+  for (i = 0; i < shape->numvalues; i++) {
+    if (!shape->values[i] || (len = strlen(shape->values[i])) == 0) {
+      continue; /* Nothing to do */
     }
 
     bufsize = len * 6 + 1; /* Each UTF-8 char can be up to 6 bytes */
     inp = shape->values[i];
-    out = (char*) msSmallMalloc(bufsize);
+    out = (char *)msSmallMalloc(bufsize);
 
     strlcpy(out, shape->values[i], bufsize);
     outp = out;
@@ -2406,13 +2367,14 @@ int msLayerEncodeShapeAttributes( layerO
 
     bool failedIconv = false;
     while (len > 0) {
-      const size_t iconv_status = msIconv(cd, (char**)&inp, &len, &outp, &bufleft);
-      if(iconv_status == static_cast<size_t>(-1)) {
+      const size_t iconv_status =
+          msIconv(cd, (char **)&inp, &len, &outp, &bufleft);
+      if (iconv_status == static_cast<size_t>(-1)) {
         failedIconv = true;
         break;
       }
     }
-    if( failedIconv ) {
+    if (failedIconv) {
       msFree(out);
       continue; /* silently ignore failed conversions */
     }
@@ -2424,9 +2386,11 @@ int msLayerEncodeShapeAttributes( layerO
 
   return MS_SUCCESS;
 #else
-  if( !layer->encoding || !*layer->encoding || !strcasecmp(layer->encoding, "UTF-8"))
+  if (!layer->encoding || !*layer->encoding ||
+      !strcasecmp(layer->encoding, "UTF-8"))
     return MS_SUCCESS;
-  msSetError(MS_MISCERR, "Not implemented since Iconv is not enabled.", "msGetEncodedString()");
+  msSetError(MS_MISCERR, "Not implemented since Iconv is not enabled.",
+             "msGetEncodedString()");
   return MS_FAILURE;
 #endif
 }
@@ -2435,77 +2399,68 @@ int msLayerEncodeShapeAttributes( layerO
 /*                             msStringBuffer                           */
 /************************************************************************/
 
-struct msStringBuffer
-{
-    size_t alloc_size;
-    size_t length;
-    char  *str;
+struct msStringBuffer {
+  size_t alloc_size;
+  size_t length;
+  char *str;
 };
 
 /************************************************************************/
 /*                         msStringBufferAlloc()                        */
 /************************************************************************/
 
-msStringBuffer* msStringBufferAlloc(void)
-{
-    return (msStringBuffer*)msSmallCalloc(sizeof(msStringBuffer), 1);
+msStringBuffer *msStringBufferAlloc(void) {
+  return (msStringBuffer *)msSmallCalloc(sizeof(msStringBuffer), 1);
 }
 
 /************************************************************************/
 /*                         msStringBufferFree()                         */
 /************************************************************************/
 
-void msStringBufferFree(msStringBuffer* sb)
-{
-    if( sb )
-        msFree(sb->str);
-    msFree(sb);
+void msStringBufferFree(msStringBuffer *sb) {
+  if (sb)
+    msFree(sb->str);
+  msFree(sb);
 }
 
 /************************************************************************/
 /*                       msStringBufferGetString()                      */
 /************************************************************************/
 
-const char* msStringBufferGetString(msStringBuffer* sb)
-{
-    return sb->str;
-}
+const char *msStringBufferGetString(msStringBuffer *sb) { return sb->str; }
 
 /************************************************************************/
 /*                   msStringBufferReleaseStringAndFree()               */
 /************************************************************************/
 
-char* msStringBufferReleaseStringAndFree(msStringBuffer* sb)
-{
-    char* str = sb->str;
-    sb->str = NULL;
-    sb->alloc_size = 0;
-    sb->length = 0;
-    msStringBufferFree(sb);
-    return str;
+char *msStringBufferReleaseStringAndFree(msStringBuffer *sb) {
+  char *str = sb->str;
+  sb->str = NULL;
+  sb->alloc_size = 0;
+  sb->length = 0;
+  msStringBufferFree(sb);
+  return str;
 }
 
 /************************************************************************/
 /*                        msStringBufferAppend()                        */
 /************************************************************************/
 
-int msStringBufferAppend(msStringBuffer* sb, const char* pszAppendedString)
-{
-    size_t nAppendLen = strlen(pszAppendedString);
-    if( sb->length + nAppendLen >= sb->alloc_size )
-    {
-        size_t newAllocSize1 = sb->alloc_size + sb->alloc_size / 3;
-        size_t newAllocSize2 = sb->length + nAppendLen + 1;
-        size_t newAllocSize = MAX(newAllocSize1, newAllocSize2);
-        void* newStr = realloc(sb->str, newAllocSize);
-        if( newStr == NULL ) {
-            msSetError(MS_MEMERR, "Not enough memory", "msStringBufferAppend()");
-            return MS_FAILURE;
-        }
-        sb->alloc_size = newAllocSize;
-        sb->str = (char*) newStr;
+int msStringBufferAppend(msStringBuffer *sb, const char *pszAppendedString) {
+  size_t nAppendLen = strlen(pszAppendedString);
+  if (sb->length + nAppendLen >= sb->alloc_size) {
+    size_t newAllocSize1 = sb->alloc_size + sb->alloc_size / 3;
+    size_t newAllocSize2 = sb->length + nAppendLen + 1;
+    size_t newAllocSize = MAX(newAllocSize1, newAllocSize2);
+    void *newStr = realloc(sb->str, newAllocSize);
+    if (newStr == NULL) {
+      msSetError(MS_MEMERR, "Not enough memory", "msStringBufferAppend()");
+      return MS_FAILURE;
     }
-    memcpy(sb->str + sb->length, pszAppendedString, nAppendLen + 1);
-    sb->length += nAppendLen;
-    return MS_SUCCESS;
+    sb->alloc_size = newAllocSize;
+    sb->str = (char *)newStr;
+  }
+  memcpy(sb->str + sb->length, pszAppendedString, nAppendLen + 1);
+  sb->length += nAppendLen;
+  return MS_SUCCESS;
 }
diff -pruN 8.0.1-5/mapsymbol.c 8.0.2-1/mapsymbol.c
--- 8.0.1-5/mapsymbol.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapsymbol.c	2024-06-11 20:41:34.000000000 +0000
@@ -28,7 +28,7 @@
  *****************************************************************************/
 
 #include <stdarg.h> /* variable number of function arguments support */
-#include <time.h> /* since the parser handles time/date we need this */
+#include <time.h>   /* since the parser handles time/date we need this */
 
 #include "mapserver.h"
 #include "mapfile.h"
@@ -37,8 +37,6 @@
 #include "fontcache.h"
 #include "mapows.h"
 
-
-
 extern int msyylex(void); /* lexer globals */
 extern void msyyrestart(FILE *);
 extern double msyynumber;
@@ -48,9 +46,8 @@ extern FILE *msyyin;
 
 extern int msyystate;
 
-void freeImageCache(struct imageCacheObj *ic)
-{
-  if(ic) {
+void freeImageCache(struct imageCacheObj *ic) {
+  if (ic) {
     freeImageCache(ic->next); /* free any children */
     msFreeRasterBuffer(&(ic->img));
     free(ic);
@@ -66,39 +63,38 @@ void freeImageCache(struct imageCacheObj
 ** is adjusted to the size that becomes the height.
 ** See mapgd.c // size ~ height in pixels
 */
-double msSymbolGetDefaultSize(symbolObj *s)
-{
+double msSymbolGetDefaultSize(symbolObj *s) {
   double size = 1;
-  if(s == NULL)
+  if (s == NULL)
     return 1;
 
-  switch(s->type) {
-    case(MS_SYMBOL_TRUETYPE):
-      break;
-    case(MS_SYMBOL_PIXMAP):
-      assert(s->pixmap_buffer != NULL);
-      if(s->pixmap_buffer == NULL) return 1; /* FIXME */
-      size = (double)s->pixmap_buffer->height;
-      break;
-    case(MS_SYMBOL_SVG):
-#if defined(USE_SVG_CAIRO) || defined (USE_RSVG)
-      assert(s->renderer_cache != NULL);
-      size = s->sizey;
+  switch (s->type) {
+  case (MS_SYMBOL_TRUETYPE):
+    break;
+  case (MS_SYMBOL_PIXMAP):
+    assert(s->pixmap_buffer != NULL);
+    if (s->pixmap_buffer == NULL)
+      return 1; /* FIXME */
+    size = (double)s->pixmap_buffer->height;
+    break;
+  case (MS_SYMBOL_SVG):
+#if defined(USE_SVG_CAIRO) || defined(USE_RSVG)
+    assert(s->renderer_cache != NULL);
+    size = s->sizey;
 #endif
-      break;
-    default: /* vector and ellipses, scalable */
-      size = (s->sizey<=0)?s->sizex:s->sizey;
-      break;
+    break;
+  default: /* vector and ellipses, scalable */
+    size = (s->sizey <= 0) ? s->sizex : s->sizey;
+    break;
   }
 
-  if(size <= 0)
+  if (size <= 0)
     return 1;
 
   return size;
 }
 
-void initSymbol(symbolObj *s)
-{
+void initSymbol(symbolObj *s) {
   MS_REFCNT_INIT(s);
   s->type = MS_SYMBOL_VECTOR;
   s->transparent = MS_FALSE;
@@ -106,11 +102,11 @@ void initSymbol(symbolObj *s)
   s->sizex = 1;
   s->sizey = 1;
   s->filled = MS_FALSE;
-  s->numpoints=0;
-  s->renderer=NULL;
+  s->numpoints = 0;
+  s->renderer = NULL;
   s->renderer_free_func = NULL;
   s->renderer_cache = NULL;
-  s->pixmap_buffer=NULL;
+  s->pixmap_buffer = NULL;
   s->imagepath = NULL;
   s->name = NULL;
   s->inmapfile = MS_FALSE;
@@ -118,254 +114,289 @@ void initSymbol(symbolObj *s)
   s->full_pixmap_path = NULL;
   s->character = NULL;
   s->anchorpoint_x = s->anchorpoint_y = 0.5;
-
 }
 
-int msFreeSymbol(symbolObj *s)
-{
-  if(!s) return MS_FAILURE;
-  if( MS_REFCNT_DECR_IS_NOT_ZERO(s) ) {
+int msFreeSymbol(symbolObj *s) {
+  if (!s)
+    return MS_FAILURE;
+  if (MS_REFCNT_DECR_IS_NOT_ZERO(s)) {
     return MS_FAILURE;
   }
 
-  if(s->name) free(s->name);
-  if(s->renderer_free_func) {
+  if (s->name)
+    free(s->name);
+  if (s->renderer_free_func) {
     s->renderer_free_func(s);
   } else {
-    if(s->renderer!=NULL) {
+    if (s->renderer != NULL) {
       s->renderer->freeSymbol(s);
     }
   }
-  if(s->pixmap_buffer) {
+  if (s->pixmap_buffer) {
     msFreeRasterBuffer(s->pixmap_buffer);
     free(s->pixmap_buffer);
   }
 
-
-  if(s->font) free(s->font);
+  if (s->font)
+    free(s->font);
   msFree(s->full_pixmap_path);
-  if(s->imagepath) free(s->imagepath);
-  if(s->character) free(s->character);
+  if (s->imagepath)
+    free(s->imagepath);
+  if (s->character)
+    free(s->character);
 
   return MS_SUCCESS;
 }
 
-int loadSymbol(symbolObj *s, char *symbolpath)
-{
-  int done=MS_FALSE;
+int loadSymbol(symbolObj *s, char *symbolpath) {
+  int done = MS_FALSE;
   char szPath[MS_MAXPATHLEN];
 
   initSymbol(s);
 
-  for(;;) {
-    switch(msyylex()) {
-      case(ANCHORPOINT):
-	if(getDouble(&(s->anchorpoint_x), MS_NUM_CHECK_RANGE, 0, 1) == -1) {
-	  msSetError(MS_SYMERR, "ANCHORPOINT must be between 0 and 1", "loadSymbol()");
-          return -1;
-        }
-        if(getDouble(&(s->anchorpoint_y), MS_NUM_CHECK_RANGE, 0, 1) == -1) {        
-          msSetError(MS_SYMERR, "ANCHORPOINT must be between 0 and 1", "loadSymbol()");
-          return(-1);
-	}
-        break;
-
-      case(ANTIALIAS): /*ignore*/
-        msyylex();
-        break;
-      case(CHARACTER):
-        if(getString(&s->character) == MS_FAILURE) return(-1);
-        break;
-      case(END): /* do some error checking */
-        if((s->type == MS_SYMBOL_SVG) && (s->imagepath == NULL)) {
-          msSetError(MS_SYMERR, "Symbol of type SVG has no file path specified.", "loadSymbol()");
-          return(-1);
-        }
-        if((s->type == MS_SYMBOL_PIXMAP) && (s->full_pixmap_path == NULL)) {
-          msSetError(MS_SYMERR, "Symbol of type PIXMAP has no image data.", "loadSymbol()");
-          return(-1);
-        }
-        if(((s->type == MS_SYMBOL_ELLIPSE) || (s->type == MS_SYMBOL_VECTOR)) && (s->numpoints == 0)) {
-          msSetError(MS_SYMERR, "Symbol of type VECTOR or ELLIPSE has no point data.", "loadSymbol()");
-          return(-1);
-        }
-        if(s->type == MS_SYMBOL_VECTOR) {
-          double minx = s->points[0].x;
-          double miny = s->points[0].y;
-          /* should only negative points be shifted? (#4116)*/
-          int shiftpositive = ((s->anchorpoint_x!=0.5)||(s->anchorpoint_y!=0.5));
-          int i;
-          for(i=1; i<s->numpoints; i++) {
-            if(s->points[i].x != -99 && s->points[i].y != -99) {
-              if(s->points[i].x<minx) minx = s->points[i].x;
-              if(s->points[i].y<miny) miny = s->points[i].y;
-            }
+  for (;;) {
+    switch (msyylex()) {
+    case (ANCHORPOINT):
+      if (getDouble(&(s->anchorpoint_x), MS_NUM_CHECK_RANGE, 0, 1) == -1) {
+        msSetError(MS_SYMERR, "ANCHORPOINT must be between 0 and 1",
+                   "loadSymbol()");
+        return -1;
+      }
+      if (getDouble(&(s->anchorpoint_y), MS_NUM_CHECK_RANGE, 0, 1) == -1) {
+        msSetError(MS_SYMERR, "ANCHORPOINT must be between 0 and 1",
+                   "loadSymbol()");
+        return (-1);
+      }
+      break;
+
+    case (ANTIALIAS): /*ignore*/
+      msyylex();
+      break;
+    case (CHARACTER):
+      if (getString(&s->character) == MS_FAILURE)
+        return (-1);
+      break;
+    case (END): /* do some error checking */
+      if ((s->type == MS_SYMBOL_SVG) && (s->imagepath == NULL)) {
+        msSetError(MS_SYMERR, "Symbol of type SVG has no file path specified.",
+                   "loadSymbol()");
+        return (-1);
+      }
+      if ((s->type == MS_SYMBOL_PIXMAP) && (s->full_pixmap_path == NULL)) {
+        msSetError(MS_SYMERR, "Symbol of type PIXMAP has no image data.",
+                   "loadSymbol()");
+        return (-1);
+      }
+      if (((s->type == MS_SYMBOL_ELLIPSE) || (s->type == MS_SYMBOL_VECTOR)) &&
+          (s->numpoints == 0)) {
+        msSetError(MS_SYMERR,
+                   "Symbol of type VECTOR or ELLIPSE has no point data.",
+                   "loadSymbol()");
+        return (-1);
+      }
+      if (s->type == MS_SYMBOL_VECTOR) {
+        double minx = s->points[0].x;
+        double miny = s->points[0].y;
+        /* should only negative points be shifted? (#4116)*/
+        int shiftpositive =
+            ((s->anchorpoint_x != 0.5) || (s->anchorpoint_y != 0.5));
+        int i;
+        for (i = 1; i < s->numpoints; i++) {
+          if (s->points[i].x != -99 && s->points[i].y != -99) {
+            if (s->points[i].x < minx)
+              minx = s->points[i].x;
+            if (s->points[i].y < miny)
+              miny = s->points[i].y;
           }
-          if(minx<0 || miny<0 || (shiftpositive && (minx!=0 || miny!=0))) {
-            for(i=0; i<s->numpoints; i++) {
-              if(s->points[i].x != -99 && s->points[i].y != -99) {
-                s->points[i].x -= minx;
-                s->points[i].y -= miny;
-              }
+        }
+        if (minx < 0 || miny < 0 ||
+            (shiftpositive && (minx != 0 || miny != 0))) {
+          for (i = 0; i < s->numpoints; i++) {
+            if (s->points[i].x != -99 && s->points[i].y != -99) {
+              s->points[i].x -= minx;
+              s->points[i].y -= miny;
             }
-            s->sizex -= minx;
-            s->sizey -= miny;
           }
+          s->sizex -= minx;
+          s->sizey -= miny;
         }
+      }
 
-        return(0);
-        break;
-      case(EOF):
-        msSetError(MS_EOFERR, NULL, "loadSymbol()");
-        return(-1);
-        break;
-      case(FILLED):
-        if((s->filled = getSymbol(2,MS_TRUE,MS_FALSE)) == -1)
-          return(-1);
-        break;
-      case(FONT):
-        if(getString(&s->font) == MS_FAILURE) return(-1);
-        break;
-      case(IMAGE):
-        if(msyylex() != MS_STRING) { /* get image location from next token */
-          msSetError(MS_TYPEERR, "Parsing error near (%s):(line %d)", "loadSymbol()", msyystring_buffer, msyylineno);
-          return(-1);
-        }
-        msFree(s->full_pixmap_path);
-        s->full_pixmap_path = msStrdup(msBuildPath(szPath, symbolpath, msyystring_buffer));
-        /* Set imagepath */
-        msFree(s->imagepath);
-        s->imagepath = msStrdup(msyystring_buffer);
-        break;
-      case(NAME):
-        if(getString(&s->name) == MS_FAILURE) return(-1);
-        break;
-      case(POINTS):
-        done = MS_FALSE;
-        s->sizex = 0;
-        s->sizey = 0;
-        for(;;) {
-          switch(msyylex()) {
-            case(END):
-              done = MS_TRUE;
-              break;
-            case(MS_NUMBER):
-              if(s->numpoints == MS_MAXVECTORPOINTS) {
-                msSetError(MS_SYMERR, "POINT block contains too many points.", "loadSymbol()");
-		return(-1);
-	      }
-              s->points[s->numpoints].x = atof(msyystring_buffer); /* grab the x */
-              if(getDouble(&(s->points[s->numpoints].y), MS_NUM_CHECK_NONE, -1, -1) == -1) return(-1); /* grab the y */
-              if(s->points[s->numpoints].x!=-99) {
-                s->sizex = MS_MAX(s->sizex, s->points[s->numpoints].x);
-                s->sizey = MS_MAX(s->sizey, s->points[s->numpoints].y);
-              }
-              s->numpoints++;
-              break;
-            default:
-              msSetError(MS_TYPEERR, "Parsing error near (%s):(line %d)", "loadSymbol()", msyystring_buffer, msyylineno);
-              return(-1);
+      return (0);
+      break;
+    case (EOF):
+      msSetError(MS_EOFERR, NULL, "loadSymbol()");
+      return (-1);
+      break;
+    case (FILLED):
+      if ((s->filled = getSymbol(2, MS_TRUE, MS_FALSE)) == -1)
+        return (-1);
+      break;
+    case (FONT):
+      if (getString(&s->font) == MS_FAILURE)
+        return (-1);
+      break;
+    case (IMAGE):
+      if (msyylex() != MS_STRING) { /* get image location from next token */
+        msSetError(MS_TYPEERR, "Parsing error near (%s):(line %d)",
+                   "loadSymbol()", msyystring_buffer, msyylineno);
+        return (-1);
+      }
+      msFree(s->full_pixmap_path);
+      s->full_pixmap_path =
+          msStrdup(msBuildPath(szPath, symbolpath, msyystring_buffer));
+      /* Set imagepath */
+      msFree(s->imagepath);
+      s->imagepath = msStrdup(msyystring_buffer);
+      break;
+    case (NAME):
+      if (getString(&s->name) == MS_FAILURE)
+        return (-1);
+      break;
+    case (POINTS):
+      done = MS_FALSE;
+      s->sizex = 0;
+      s->sizey = 0;
+      for (;;) {
+        switch (msyylex()) {
+        case (END):
+          done = MS_TRUE;
+          break;
+        case (MS_NUMBER):
+          if (s->numpoints == MS_MAXVECTORPOINTS) {
+            msSetError(MS_SYMERR, "POINT block contains too many points.",
+                       "loadSymbol()");
+            return (-1);
           }
-
-          if(done == MS_TRUE)
-            break;
+          s->points[s->numpoints].x = atof(msyystring_buffer); /* grab the x */
+          if (getDouble(&(s->points[s->numpoints].y), MS_NUM_CHECK_NONE, -1,
+                        -1) == -1)
+            return (-1); /* grab the y */
+          if (s->points[s->numpoints].x != -99) {
+            s->sizex = MS_MAX(s->sizex, s->points[s->numpoints].x);
+            s->sizey = MS_MAX(s->sizey, s->points[s->numpoints].y);
+          }
+          s->numpoints++;
+          break;
+        default:
+          msSetError(MS_TYPEERR, "Parsing error near (%s):(line %d)",
+                     "loadSymbol()", msyystring_buffer, msyylineno);
+          return (-1);
         }
-        break;
-      case(TRANSPARENT):
-        s->transparent = MS_TRUE;
-        if(getInteger(&(s->transparentcolor), MS_NUM_CHECK_RANGE, 0, 255) == -1) return(-1);
-        break;
-      case(TYPE):
-        if((s->type = getSymbol(8,MS_SYMBOL_VECTOR,MS_SYMBOL_ELLIPSE,MS_SYMBOL_PIXMAP,MS_SYMBOL_SIMPLE,MS_TRUETYPE,MS_SYMBOL_HATCH,MS_SYMBOL_SVG)) == -1)
-          return(-1);
-        if(s->type == MS_TRUETYPE) /* TrueType keyword is valid several place in map files and symbol files, this simplifies the lexer */
-          s->type = MS_SYMBOL_TRUETYPE;
-        break;
-      default:
-        msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)", "loadSymbol()", msyystring_buffer, msyylineno);
-        return(-1);
+
+        if (done == MS_TRUE)
+          break;
+      }
+      break;
+    case (TRANSPARENT):
+      s->transparent = MS_TRUE;
+      if (getInteger(&(s->transparentcolor), MS_NUM_CHECK_RANGE, 0, 255) == -1)
+        return (-1);
+      break;
+    case (TYPE):
+      if ((s->type = getSymbol(8, MS_SYMBOL_VECTOR, MS_SYMBOL_ELLIPSE,
+                               MS_SYMBOL_PIXMAP, MS_SYMBOL_SIMPLE, MS_TRUETYPE,
+                               MS_SYMBOL_HATCH, MS_SYMBOL_SVG)) == -1)
+        return (-1);
+      if (s->type ==
+          MS_TRUETYPE) /* TrueType keyword is valid several place in map files
+                          and symbol files, this simplifies the lexer */
+        s->type = MS_SYMBOL_TRUETYPE;
+      break;
+    default:
+      msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)",
+                 "loadSymbol()", msyystring_buffer, msyylineno);
+      return (-1);
     } /* end switch */
-  } /* end for */
+  }   /* end for */
   return done;
 }
 
-void writeSymbol(symbolObj *s, FILE *stream)
-{
+void writeSymbol(symbolObj *s, FILE *stream) {
   int i;
 
   msIO_fprintf(stream, "  SYMBOL\n");
-  if(s->name != NULL) msIO_fprintf(stream, "    NAME \"%s\"\n", s->name);
+  if (s->name != NULL)
+    msIO_fprintf(stream, "    NAME \"%s\"\n", s->name);
 
   switch (s->type) {
-    case(MS_SYMBOL_HATCH):
-      msIO_fprintf(stream, "    TYPE HATCH\n");
-      break;
-    case(MS_SYMBOL_PIXMAP):
-      msIO_fprintf(stream, "    TYPE PIXMAP\n");
-      if(s->imagepath != NULL) msIO_fprintf(stream, "    IMAGE \"%s\"\n", s->imagepath);
-      if(s->anchorpoint_y!=0.5 || s->anchorpoint_x!=0.5) {
-        msIO_fprintf(stream, "    ANCHORPOINT %g %g\n", s->anchorpoint_x, s->anchorpoint_y);
-      }
-      msIO_fprintf(stream, "    TRANSPARENT %d\n", s->transparentcolor);
-      break;
-    case(MS_SYMBOL_TRUETYPE):
-      msIO_fprintf(stream, "    TYPE TRUETYPE\n");
-      if (s->character != NULL) msIO_fprintf(stream, "    CHARACTER \"%s\"\n", s->character);
-      if (s->font != NULL) msIO_fprintf(stream, "    FONT \"%s\"\n", s->font);
-      if(s->anchorpoint_y!=0.5 || s->anchorpoint_x!=0.5) {
-        msIO_fprintf(stream, "    ANCHORPOINT %g %g\n", s->anchorpoint_x, s->anchorpoint_y);
-      }
-      break;
-    default:
-      if(s->type == MS_SYMBOL_ELLIPSE)
-        msIO_fprintf(stream, "    TYPE ELLIPSE\n");
-      else if(s->type == MS_SYMBOL_VECTOR)
-        msIO_fprintf(stream, "    TYPE VECTOR\n");
-      else if(s->type == MS_SYMBOL_SVG)
-        msIO_fprintf(stream, "    TYPE SVG\n");
-      else
-        msIO_fprintf(stream, "    TYPE SIMPLE\n");
-
-      if(s->filled == MS_TRUE) msIO_fprintf(stream, "    FILLED TRUE\n");
-      if(s->imagepath != NULL) msIO_fprintf(stream, "    IMAGE \"%s\"\n", s->imagepath);
-      if(s->anchorpoint_y!=0.5 || s->anchorpoint_x!=0.5) {
-        msIO_fprintf(stream, "    ANCHORPOINT %g %g\n", s->anchorpoint_x, s->anchorpoint_y);
-      }
+  case (MS_SYMBOL_HATCH):
+    msIO_fprintf(stream, "    TYPE HATCH\n");
+    break;
+  case (MS_SYMBOL_PIXMAP):
+    msIO_fprintf(stream, "    TYPE PIXMAP\n");
+    if (s->imagepath != NULL)
+      msIO_fprintf(stream, "    IMAGE \"%s\"\n", s->imagepath);
+    if (s->anchorpoint_y != 0.5 || s->anchorpoint_x != 0.5) {
+      msIO_fprintf(stream, "    ANCHORPOINT %g %g\n", s->anchorpoint_x,
+                   s->anchorpoint_y);
+    }
+    msIO_fprintf(stream, "    TRANSPARENT %d\n", s->transparentcolor);
+    break;
+  case (MS_SYMBOL_TRUETYPE):
+    msIO_fprintf(stream, "    TYPE TRUETYPE\n");
+    if (s->character != NULL)
+      msIO_fprintf(stream, "    CHARACTER \"%s\"\n", s->character);
+    if (s->font != NULL)
+      msIO_fprintf(stream, "    FONT \"%s\"\n", s->font);
+    if (s->anchorpoint_y != 0.5 || s->anchorpoint_x != 0.5) {
+      msIO_fprintf(stream, "    ANCHORPOINT %g %g\n", s->anchorpoint_x,
+                   s->anchorpoint_y);
+    }
+    break;
+  default:
+    if (s->type == MS_SYMBOL_ELLIPSE)
+      msIO_fprintf(stream, "    TYPE ELLIPSE\n");
+    else if (s->type == MS_SYMBOL_VECTOR)
+      msIO_fprintf(stream, "    TYPE VECTOR\n");
+    else if (s->type == MS_SYMBOL_SVG)
+      msIO_fprintf(stream, "    TYPE SVG\n");
+    else
+      msIO_fprintf(stream, "    TYPE SIMPLE\n");
+
+    if (s->filled == MS_TRUE)
+      msIO_fprintf(stream, "    FILLED TRUE\n");
+    if (s->imagepath != NULL)
+      msIO_fprintf(stream, "    IMAGE \"%s\"\n", s->imagepath);
+    if (s->anchorpoint_y != 0.5 || s->anchorpoint_x != 0.5) {
+      msIO_fprintf(stream, "    ANCHORPOINT %g %g\n", s->anchorpoint_x,
+                   s->anchorpoint_y);
+    }
 
-      /* POINTS */
-      if(s->numpoints != 0) {
-        msIO_fprintf(stream, "    POINTS\n");
-        for(i=0; i<s->numpoints; i++) {
-          msIO_fprintf(stream, "      %g %g\n", s->points[i].x, s->points[i].y);
-        }
-        msIO_fprintf(stream, "    END\n");
+    /* POINTS */
+    if (s->numpoints != 0) {
+      msIO_fprintf(stream, "    POINTS\n");
+      for (i = 0; i < s->numpoints; i++) {
+        msIO_fprintf(stream, "      %g %g\n", s->points[i].x, s->points[i].y);
       }
-      break;
+      msIO_fprintf(stream, "    END\n");
+    }
+    break;
   }
 
   msIO_fprintf(stream, "  END\n\n");
 }
 
-
 /*
 ** Little helper function to allow us to build symbol files on-the-fly
 ** from just a file name.
 **
 ** Returns the symbol index or -1 if it could not be added.
 */
-int msAddImageSymbol(symbolSetObj *symbolset, char *filename)
-{
+int msAddImageSymbol(symbolSetObj *symbolset, char *filename) {
   char szPath[MS_MAXPATHLEN];
-  symbolObj *symbol=NULL;
-  char *extension=NULL;
+  symbolObj *symbol = NULL;
+  char *extension = NULL;
   int symbolidx;
 
-  if(!symbolset) {
-    msSetError(MS_SYMERR, "Symbol structure unallocated.", "msAddImageSymbol()");
-    return(-1);
+  if (!symbolset) {
+    msSetError(MS_SYMERR, "Symbol structure unallocated.",
+               "msAddImageSymbol()");
+    return (-1);
   }
 
-  if(!filename || strlen(filename) == 0) return(-1);
+  if (!filename || strlen(filename) == 0)
+    return (-1);
 
   /* Allocate/init memory for new symbol if needed */
   if (msGrowSymbolSet(symbolset) == NULL)
@@ -399,11 +430,13 @@ int msAddImageSymbol(symbolSetObj *symbo
       tmpfullfilename = msBuildPath(szPath, tmppath, tmpfilename);
       if (tmpfullfilename) {
         /*use the url for now as a caching mechanism*/
-        if (msHTTPGetFile(filename, tmpfullfilename, &status, -1, bCheckLocalCache, 0, 1024*1024 /* 1 MegaByte */) == MS_SUCCESS) {
+        if (msHTTPGetFile(filename, tmpfullfilename, &status, -1,
+                          bCheckLocalCache, 0,
+                          1024 * 1024 /* 1 MegaByte */) == MS_SUCCESS) {
           symbol->imagepath = msStrdup(tmpfullfilename);
           symbol->full_pixmap_path = msStrdup(tmpfullfilename);
         } else {
-          unlink(tmpfullfilename); 
+          unlink(tmpfullfilename);
           msFree(tmpfilename);
           msFree(tmppath);
           return -1;
@@ -416,8 +449,9 @@ int msAddImageSymbol(symbolSetObj *symbo
 #endif
   /*if the http did not work, allow it to be treated as a file*/
   if (!symbol->full_pixmap_path) {
-    if(symbolset->map) {
-      symbol->full_pixmap_path = msStrdup(msBuildPath(szPath, symbolset->map->mappath, filename));
+    if (symbolset->map) {
+      symbol->full_pixmap_path =
+          msStrdup(msBuildPath(szPath, symbolset->map->mappath, filename));
     } else {
       symbol->full_pixmap_path = msStrdup(msBuildPath(szPath, NULL, filename));
     }
@@ -427,16 +461,15 @@ int msAddImageSymbol(symbolSetObj *symbo
   return symbolidx;
 }
 
-int msFreeSymbolSet(symbolSetObj *symbolset)
-{
+int msFreeSymbolSet(symbolSetObj *symbolset) {
   int i;
 
   freeImageCache(symbolset->imagecache);
-  for(i=0; i<symbolset->numsymbols; i++) {
-    if (symbolset->symbol[i]!=NULL) {
-      if ( msFreeSymbol((symbolset->symbol[i])) == MS_SUCCESS ) {
+  for (i = 0; i < symbolset->numsymbols; i++) {
+    if (symbolset->symbol[i] != NULL) {
+      if (msFreeSymbol((symbolset->symbol[i])) == MS_SUCCESS) {
         msFree(symbolset->symbol[i]);
-        symbolset->symbol[i]=NULL;
+        symbolset->symbol[i] = NULL;
       }
     }
   }
@@ -446,8 +479,7 @@ int msFreeSymbolSet(symbolSetObj *symbol
   return MS_SUCCESS;
 }
 
-void msInitSymbolSet(symbolSetObj *symbolset)
-{
+void msInitSymbolSet(symbolSetObj *symbolset) {
   symbolset->filename = NULL;
 
   symbolset->imagecache = NULL;
@@ -463,7 +495,7 @@ void msInitSymbolSet(symbolSetObj *symbo
   /* Alloc symbol[] array and ensure there is at least 1 symbol:
    * symbol 0 which is the default symbol with all default params.
    */
-  symbolObj* symbol = msGrowSymbolSet(symbolset);
+  symbolObj *symbol = msGrowSymbolSet(symbolset);
   if (symbol == NULL)
     return; /* alloc failed */
   symbol->type = MS_SYMBOL_ELLIPSE;
@@ -476,10 +508,8 @@ void msInitSymbolSet(symbolSetObj *symbo
    * initSymbol() has already been called
    */
   symbolset->numsymbols = 1;
-
 }
 
-
 /*
 ** Ensure there is at least one free entry in the symbol array of this
 ** symbolSetObj. Grow the allocated symbol[] array if necessary and
@@ -491,8 +521,7 @@ void msInitSymbolSet(symbolSetObj *symbo
 **
 ** Returns a reference to the new symbolObj on success, NULL on error.
 */
-symbolObj *msGrowSymbolSet( symbolSetObj *symbolset )
-{
+symbolObj *msGrowSymbolSet(symbolSetObj *symbolset) {
   /* Do we need to increase the size of symbol[] by MS_SYMBOL_ALLOCSIZE? */
   if (symbolset->numsymbols == symbolset->maxsymbols) {
     int i;
@@ -500,27 +529,31 @@ symbolObj *msGrowSymbolSet( symbolSetObj
       /* Initial allocation of array */
       symbolset->maxsymbols += MS_SYMBOL_ALLOCSIZE;
       symbolset->numsymbols = 0;
-      symbolset->symbol = (symbolObj**)malloc(symbolset->maxsymbols*sizeof(symbolObj*));
+      symbolset->symbol =
+          (symbolObj **)malloc(symbolset->maxsymbols * sizeof(symbolObj *));
     } else {
       /* realloc existing array */
       symbolset->maxsymbols += MS_SYMBOL_ALLOCSIZE;
-      symbolset->symbol = (symbolObj**)realloc(symbolset->symbol,
-                          symbolset->maxsymbols*sizeof(symbolObj*));
+      symbolset->symbol = (symbolObj **)realloc(
+          symbolset->symbol, symbolset->maxsymbols * sizeof(symbolObj *));
     }
 
     if (symbolset->symbol == NULL) {
-      msSetError(MS_MEMERR, "Failed to allocate memory for symbol array.", "msGrowSymbolSet()");
+      msSetError(MS_MEMERR, "Failed to allocate memory for symbol array.",
+                 "msGrowSymbolSet()");
       return NULL;
     }
 
-    for(i=symbolset->numsymbols; i<symbolset->maxsymbols; i++)
+    for (i = symbolset->numsymbols; i < symbolset->maxsymbols; i++)
       symbolset->symbol[i] = NULL;
   }
 
-  if (symbolset->symbol[symbolset->numsymbols]==NULL) {
-    symbolset->symbol[symbolset->numsymbols]=(symbolObj*)malloc(sizeof(symbolObj));
-    if (symbolset->symbol[symbolset->numsymbols]==NULL) {
-      msSetError(MS_MEMERR, "Failed to allocate memory for a symbolObj", "msGrowSymbolSet()");
+  if (symbolset->symbol[symbolset->numsymbols] == NULL) {
+    symbolset->symbol[symbolset->numsymbols] =
+        (symbolObj *)malloc(sizeof(symbolObj));
+    if (symbolset->symbol[symbolset->numsymbols] == NULL) {
+      msSetError(MS_MEMERR, "Failed to allocate memory for a symbolObj",
+                 "msGrowSymbolSet()");
       return NULL;
     }
   }
@@ -532,8 +565,6 @@ symbolObj *msGrowSymbolSet( symbolSetObj
   return symbolset->symbol[symbolset->numsymbols];
 }
 
-
-
 /* ---------------------------------------------------------------------------
    msLoadSymbolSet and loadSymbolSet
 
@@ -545,136 +576,160 @@ symbolObj *msGrowSymbolSet( symbolSetObj
    See bug 339 for more details -- SG.
    ------------------------------------------------------------------------ */
 
-int msLoadSymbolSet(symbolSetObj *symbolset, mapObj *map)
-{
+int msLoadSymbolSet(symbolSetObj *symbolset, mapObj *map) {
   int retval = MS_FAILURE;
 
-  msAcquireLock( TLOCK_PARSER );
-  retval = loadSymbolSet( symbolset, map );
-  msReleaseLock( TLOCK_PARSER );
+  msAcquireLock(TLOCK_PARSER);
+  retval = loadSymbolSet(symbolset, map);
+  msReleaseLock(TLOCK_PARSER);
 
   return retval;
 }
 
-int loadSymbolSet(symbolSetObj *symbolset, mapObj *map)
-{
-  int status=1;
-  char szPath[MS_MAXPATHLEN], *pszSymbolPath=NULL;
+int loadSymbolSet(symbolSetObj *symbolset, mapObj *map) {
+  int status = 1;
+  char szPath[MS_MAXPATHLEN], *pszSymbolPath = NULL;
 
-  int foundSymbolSetToken=MS_FALSE;
-  int symbolSetLevel=0;
+  int foundSymbolSetToken = MS_FALSE;
+  int symbolSetLevel = 0;
   int token;
 
-  if(!symbolset) {
+  if (!symbolset) {
     msSetError(MS_SYMERR, "Symbol structure unallocated.", "loadSymbolSet()");
-    return(-1);
+    return (-1);
   }
 
   symbolset->map = (mapObj *)map;
 
-  if(!symbolset->filename) return(0);
+  if (!symbolset->filename)
+    return (0);
 
   /*
   ** Open the file
   */
-  if((msyyin = fopen(msBuildPath(szPath, symbolset->map->mappath, symbolset->filename), "r")) == NULL) {
+  if ((msyyin = fopen(
+           msBuildPath(szPath, symbolset->map->mappath, symbolset->filename),
+           "r")) == NULL) {
     msSetError(MS_IOERR, "(%s)", "loadSymbolSet()", symbolset->filename);
-    return(-1);
+    return (-1);
   }
 
   pszSymbolPath = msGetPath(szPath);
 
-  msyystate = MS_TOKENIZE_FILE; /* restore lexer state to INITIAL, and do return comments */
+  msyystate = MS_TOKENIZE_FILE; /* restore lexer state to INITIAL, and do return
+                                   comments */
   msyylex(); /* sets things up, but doesn't process any tokens */
 
-  msyylineno = 0; /* reset line counter */
-  msyyrestart(msyyin); /* flush the scanner - there's a better way but this works for now */
+  msyylineno = 0;      /* reset line counter */
+  msyyrestart(msyyin); /* flush the scanner - there's a better way but this
+                          works for now */
 
   /*
   ** Read the symbol file
   */
-  for(;;) {
+  for (;;) {
     token = msyylex();
 
-    if(!foundSymbolSetToken && token != SYMBOLSET) {
-      msSetError(MS_IDENTERR, "First token must be SYMBOLSET, this doesn't look like a symbol file.", "msLoadSymbolSet()");
+    if (!foundSymbolSetToken && token != SYMBOLSET) {
+      msSetError(MS_IDENTERR,
+                 "First token must be SYMBOLSET, this doesn't look like a "
+                 "symbol file.",
+                 "msLoadSymbolSet()");
       status = -1;
       break;
     }
 
-    switch(token) {
-      case(END):
-        if (--symbolSetLevel < 0) {
-          msSetError(MS_IDENTERR, "END token found outside SYMBOLSET context. When nesting multiple SYMBOLSETs, make sure the SYMBOLSET/END pairs match.", "msLoadSymbolSet()");
-          status = -1;
-        }
-        break;
-      case(EOF):
-        status = 0;
-        break;
-      case(SYMBOL):
-        /* Allocate/init memory for new symbol if needed */
-        if (symbolSetLevel == 0) {
-          msSetError(MS_IDENTERR, "SYMBOL token found outside SYMBOLSET context. When nesting multiple SYMBOLSETs, make sure the SYMBOLSET/END pairs match.", "msLoadSymbolSet()");
-          status = -1;
-        } else if (msGrowSymbolSet(symbolset) == NULL) {
-          status = -1;
-        } else if((loadSymbol((symbolset->symbol[symbolset->numsymbols]), pszSymbolPath) == -1))
-          status = -1;
-        else
-          symbolset->numsymbols++;
-        break;
-      case(SYMBOLSET):
-        foundSymbolSetToken = MS_TRUE;
-        symbolSetLevel++;
-        break;
-      default:
-        msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)", "loadSymbolSet()", msyystring_buffer, msyylineno);
+    switch (token) {
+    case (END):
+      if (--symbolSetLevel < 0) {
+        msSetError(
+            MS_IDENTERR,
+            "END token found outside SYMBOLSET context. When nesting multiple "
+            "SYMBOLSETs, make sure the SYMBOLSET/END pairs match.",
+            "msLoadSymbolSet()");
+        status = -1;
+      }
+      break;
+    case (EOF):
+      status = 0;
+      break;
+    case (SYMBOL):
+      /* Allocate/init memory for new symbol if needed */
+      if (symbolSetLevel == 0) {
+        msSetError(
+            MS_IDENTERR,
+            "SYMBOL token found outside SYMBOLSET context. When nesting "
+            "multiple SYMBOLSETs, make sure the SYMBOLSET/END pairs match.",
+            "msLoadSymbolSet()");
         status = -1;
+      } else if (msGrowSymbolSet(symbolset) == NULL) {
+        status = -1;
+      } else if ((loadSymbol((symbolset->symbol[symbolset->numsymbols]),
+                             pszSymbolPath) == -1))
+        status = -1;
+      else
+        symbolset->numsymbols++;
+      break;
+    case (SYMBOLSET):
+      foundSymbolSetToken = MS_TRUE;
+      symbolSetLevel++;
+      break;
+    default:
+      msSetError(MS_IDENTERR, "Parsing error near (%s):(line %d)",
+                 "loadSymbolSet()", msyystring_buffer, msyylineno);
+      status = -1;
     } /* end switch */
 
-    if(status != 1) break;
+    if (status != 1)
+      break;
   } /* end for */
 
   fclose(msyyin);
   msyyin = NULL;
   free(pszSymbolPath);
-  return(status);
+  return (status);
 }
 
-int msGetCharacterSize(mapObj *map, char* font, int size, char *character, rectObj *r) {
+int msGetCharacterSize(mapObj *map, char *font, int size, char *character,
+                       rectObj *r) {
   unsigned int unicode, codepoint;
   glyph_element *glyph;
   face_element *face = msGetFontFace(font, &map->fontset);
-  if(MS_UNLIKELY(!face)) return MS_FAILURE;
+  if (MS_UNLIKELY(!face))
+    return MS_FAILURE;
   msUTF8ToUniChar(character, &unicode);
-  codepoint = msGetGlyphIndex(face,unicode);
-  glyph = msGetGlyphByIndex(face,size,codepoint);
-  if(MS_UNLIKELY(!glyph)) return MS_FAILURE;
+  codepoint = msGetGlyphIndex(face, unicode);
+  glyph = msGetGlyphByIndex(face, size, codepoint);
+  if (MS_UNLIKELY(!glyph))
+    return MS_FAILURE;
   r->minx = glyph->metrics.minx;
   r->maxx = glyph->metrics.maxx;
-  r->miny = - glyph->metrics.maxy;
-  r->maxy = - glyph->metrics.miny;
+  r->miny = -glyph->metrics.maxy;
+  r->maxy = -glyph->metrics.miny;
   return MS_SUCCESS;
 }
 
 /*
-** Returns the size, in pixels, of a marker symbol defined by a specific style and scalefactor. Used for annotation
-** layer collision avoidance. A marker is made up of a number of styles so the calling code must either do the looping
-** itself or call this function for the bottom style which should be the largest.
+** Returns the size, in pixels, of a marker symbol defined by a specific style
+*and scalefactor. Used for annotation
+** layer collision avoidance. A marker is made up of a number of styles so the
+*calling code must either do the looping
+** itself or call this function for the bottom style which should be the
+*largest.
 */
-int msGetMarkerSize(mapObj *map, styleObj *style, double *width, double *height, double scalefactor)
-{
+int msGetMarkerSize(mapObj *map, styleObj *style, double *width, double *height,
+                    double scalefactor) {
   int size;
   symbolObj *symbol;
   *width = *height = 0; /* set a starting value */
 
-  if(style->symbol > map->symbolset.numsymbols || style->symbol < 0) return(MS_FAILURE); /* no such symbol, 0 is OK */
+  if (style->symbol > map->symbolset.numsymbols || style->symbol < 0)
+    return (MS_FAILURE); /* no such symbol, 0 is OK */
 
-  if(style->symbol == 0) { /* single point */
+  if (style->symbol == 0) { /* single point */
     *width = 1;
     *height = 1;
-    return(MS_SUCCESS);
+    return (MS_SUCCESS);
   }
 
   symbol = map->symbolset.symbol[style->symbol];
@@ -682,64 +737,68 @@ int msGetMarkerSize(mapObj *map, styleOb
     if (MS_SUCCESS != msPreloadImageSymbol(MS_MAP_RENDERER(map), symbol))
       return MS_FAILURE;
   }
-  if(symbol->type == MS_SYMBOL_SVG && !symbol->renderer_cache) {
-#if defined(USE_SVG_CAIRO) || defined (USE_RSVG)
-    if(MS_SUCCESS != msPreloadSVGSymbol(symbol))
+  if (symbol->type == MS_SYMBOL_SVG && !symbol->renderer_cache) {
+#if defined(USE_SVG_CAIRO) || defined(USE_RSVG)
+    if (MS_SUCCESS != msPreloadSVGSymbol(symbol))
       return MS_FAILURE;
 #else
-    msSetError(MS_SYMERR, "SVG symbol support is not enabled.", "msGetMarkerSize()");
+    msSetError(MS_SYMERR, "SVG symbol support is not enabled.",
+               "msGetMarkerSize()");
     return MS_FAILURE;
 #endif
   }
-  if(style->size == -1) {
-    size = ( msSymbolGetDefaultSize(symbol) * scalefactor );
+  if (style->size == -1) {
+    size = (msSymbolGetDefaultSize(symbol) * scalefactor);
   } else
-    size = (style->size*scalefactor);
+    size = (style->size * scalefactor);
   size = MS_MAX(size, style->minsize);
   size = MS_MIN(size, style->maxsize);
 
-  switch(symbol->type) {
+  switch (symbol->type) {
 
-    case(MS_SYMBOL_TRUETYPE): {
-      rectObj gbounds;
-      if(MS_UNLIKELY(MS_FAILURE == msGetCharacterSize(map,symbol->font,size,symbol->character, &gbounds)))
-        return MS_FAILURE;
+  case (MS_SYMBOL_TRUETYPE): {
+    rectObj gbounds;
+    if (MS_UNLIKELY(MS_FAILURE == msGetCharacterSize(map, symbol->font, size,
+                                                     symbol->character,
+                                                     &gbounds)))
+      return MS_FAILURE;
 
-      *width = MS_MAX(*width, (gbounds.maxx-gbounds.minx));
-      *height = MS_MAX(*height, (gbounds.maxy-gbounds.miny));
-    }
+    *width = MS_MAX(*width, (gbounds.maxx - gbounds.minx));
+    *height = MS_MAX(*height, (gbounds.maxy - gbounds.miny));
+  }
 
-      break;
+  break;
 
-    case(MS_SYMBOL_PIXMAP):
-      if(size == 1) {
-        *width = MS_MAX(*width, symbol->pixmap_buffer->width);
-        *height = MS_MAX(*height, symbol->pixmap_buffer->height);
-      } else {
-        *width = MS_MAX(*width, (((double)size/(double)symbol->pixmap_buffer->height) * symbol->pixmap_buffer->width));
-        *height = MS_MAX(*height, size);
-      }
-      break;
-    default: /* vector and ellipses, scalable */
-      if(style->size > 0) {
-        *width = MS_MAX(*width, ((size/symbol->sizey) * symbol->sizex));
-        *height = MS_MAX(*height, size);
-      } else { /* use symbol defaults */
-        *width = MS_MAX(*width, symbol->sizex);
-        *height = MS_MAX(*height, symbol->sizey);
-      }
-      break;
+  case (MS_SYMBOL_PIXMAP):
+    if (size == 1) {
+      *width = MS_MAX(*width, symbol->pixmap_buffer->width);
+      *height = MS_MAX(*height, symbol->pixmap_buffer->height);
+    } else {
+      *width = MS_MAX(*width,
+                      (((double)size / (double)symbol->pixmap_buffer->height) *
+                       symbol->pixmap_buffer->width));
+      *height = MS_MAX(*height, size);
+    }
+    break;
+  default: /* vector and ellipses, scalable */
+    if (style->size > 0) {
+      *width = MS_MAX(*width, ((size / symbol->sizey) * symbol->sizex));
+      *height = MS_MAX(*height, size);
+    } else { /* use symbol defaults */
+      *width = MS_MAX(*width, symbol->sizex);
+      *height = MS_MAX(*height, symbol->sizey);
+    }
+    break;
   }
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
 /*
  * Add a default new symbol. If the symbol name exists
  * return the id of the symbol.
  */
-int msAddNewSymbol(mapObj *map, char *name)
-{
+int msAddNewSymbol(mapObj *map, char *name) {
   int i = 0;
 
   if (!map || !name)
@@ -765,9 +824,7 @@ int msAddNewSymbol(mapObj *map, char *na
  * MapServer bug 579.
  * http://mapserver.gis.umn.edu/bugs/show_bug.cgi?id=579 */
 
-
-int msAppendSymbol(symbolSetObj *symbolset, symbolObj *symbol)
-{
+int msAppendSymbol(symbolSetObj *symbolset, symbolObj *symbol) {
   /* Allocate memory for new symbol if needed */
   if (msGrowSymbolSet(symbolset) == NULL)
     return -1;
@@ -777,96 +834,95 @@ int msAppendSymbol(symbolSetObj *symbols
    technique, but this function should be rarely called, and in any case only
    by mapscript. Another option could be to use msCopySymbol(), in which case
    the call to MS_REFCNT_INCR(symbol) should be removed.*/
-  if(symbolset->symbol[symbolset->numsymbols]) {
+  if (symbolset->symbol[symbolset->numsymbols]) {
     msFreeSymbol(symbolset->symbol[symbolset->numsymbols]);
     msFree(symbolset->symbol[symbolset->numsymbols]);
   }
-  symbolset->symbol[symbolset->numsymbols]=symbol;
+  symbolset->symbol[symbolset->numsymbols] = symbol;
   MS_REFCNT_INCR(symbol);
   return symbolset->numsymbols++;
 }
 
-
-symbolObj *msRemoveSymbol(symbolSetObj *symbolset, int nSymbolIndex)
-{
+symbolObj *msRemoveSymbol(symbolSetObj *symbolset, int nSymbolIndex) {
   int i;
   symbolObj *symbol;
   if (symbolset->numsymbols == 1) {
-    msSetError(MS_CHILDERR, "Cannot remove a symbolset's sole symbol", "removeSymbol()");
+    msSetError(MS_CHILDERR, "Cannot remove a symbolset's sole symbol",
+               "removeSymbol()");
     return NULL;
   } else if (nSymbolIndex < 0 || nSymbolIndex >= symbolset->numsymbols) {
-    msSetError(MS_CHILDERR, "Cannot remove symbol, invalid nSymbolIndex %d", "removeSymbol()", nSymbolIndex);
+    msSetError(MS_CHILDERR, "Cannot remove symbol, invalid nSymbolIndex %d",
+               "removeSymbol()", nSymbolIndex);
     return NULL;
   } else {
-    symbol=symbolset->symbol[nSymbolIndex];
-    for (i=nSymbolIndex+1; i<symbolset->numsymbols; i++) {
-      symbolset->symbol[i-1] = symbolset->symbol[i];
+    symbol = symbolset->symbol[nSymbolIndex];
+    for (i = nSymbolIndex + 1; i < symbolset->numsymbols; i++) {
+      symbolset->symbol[i - 1] = symbolset->symbol[i];
     }
-    symbolset->symbol[i-1]=NULL;
+    symbolset->symbol[i - 1] = NULL;
     symbolset->numsymbols--;
     MS_REFCNT_DECR(symbol);
     /* update symbol references in the map */
     if (symbolset->map) {
-        int l,c,s,lb;
-        layerObj *layer;
-        classObj *cl;
-        styleObj *style;
-        labelObj *label;
-        for (l = 0; l < symbolset->map->numlayers; l++) {
-            layer = GET_LAYER(symbolset->map, l);
-            for (c = 0; c < layer->numclasses; c++) {
-                cl = layer->class[c];
-                for (s = 0; s < cl->numstyles; s++) {
-                    style = cl->styles[s];
-                    if (style->symbol >= nSymbolIndex)
-                        --style->symbol;
-                }
-                for (lb = 0; lb < cl->numlabels; lb++) {
-                    label = cl->labels[lb];
-                    for (s = 0; s < label->numstyles; s++) {
-                        style = label->styles[s];
-                        if (style->symbol >= nSymbolIndex)
-                            --style->symbol;
-                    }
-                }
+      int l, c, s, lb;
+      layerObj *layer;
+      classObj *cl;
+      styleObj *style;
+      labelObj *label;
+      for (l = 0; l < symbolset->map->numlayers; l++) {
+        layer = GET_LAYER(symbolset->map, l);
+        for (c = 0; c < layer->numclasses; c++) {
+          cl = layer->class[c];
+          for (s = 0; s < cl->numstyles; s++) {
+            style = cl->styles[s];
+            if (style->symbol >= nSymbolIndex)
+              --style->symbol;
+          }
+          for (lb = 0; lb < cl->numlabels; lb++) {
+            label = cl->labels[lb];
+            for (s = 0; s < label->numstyles; s++) {
+              style = label->styles[s];
+              if (style->symbol >= nSymbolIndex)
+                --style->symbol;
             }
+          }
         }
-        /* Update symbol references in labelcache */
-        for(c = 0; c < MS_MAX_LABEL_PRIORITY; c++) {
-            labelCacheSlotObj *cacheslot = &(symbolset->map->labelcache.slots[c]);
-            for(l = 0; l < cacheslot->numlabels; l++) {
-                labelCacheMemberObj *cachePtr = &(cacheslot->labels[l]);
-                for(lb = 0; lb < cachePtr->numtextsymbols; lb++) {
-                    label = cachePtr->textsymbols[lb]->label;
-                    for (s = 0; s < label->numstyles; s++) {
-                        style = label->styles[s];
-                        if (style->symbol >= nSymbolIndex)
-                            --style->symbol;
-                    }
-                }
+      }
+      /* Update symbol references in labelcache */
+      for (c = 0; c < MS_MAX_LABEL_PRIORITY; c++) {
+        labelCacheSlotObj *cacheslot = &(symbolset->map->labelcache.slots[c]);
+        for (l = 0; l < cacheslot->numlabels; l++) {
+          labelCacheMemberObj *cachePtr = &(cacheslot->labels[l]);
+          for (lb = 0; lb < cachePtr->numtextsymbols; lb++) {
+            label = cachePtr->textsymbols[lb]->label;
+            for (s = 0; s < label->numstyles; s++) {
+              style = label->styles[s];
+              if (style->symbol >= nSymbolIndex)
+                --style->symbol;
             }
+          }
         }
+      }
     }
     return symbol;
   }
 }
 
-int msSaveSymbolSetStream(symbolSetObj *symbolset, FILE *stream)
-{
+int msSaveSymbolSetStream(symbolSetObj *symbolset, FILE *stream) {
   int i;
   if (!symbolset || !stream) {
     msSetError(MS_SYMERR, "Cannot save symbolset.", "msSaveSymbolSetStream()");
     return MS_FAILURE;
   }
   /* Don't ever write out the default symbol at index 0 */
-  for (i=1; i<symbolset->numsymbols; i++) {
-    if(!symbolset->symbol[i]->inmapfile) writeSymbol((symbolset->symbol[i]), stream);
+  for (i = 1; i < symbolset->numsymbols; i++) {
+    if (!symbolset->symbol[i]->inmapfile)
+      writeSymbol((symbolset->symbol[i]), stream);
   }
   return MS_SUCCESS;
 }
 
-int msSaveSymbolSet(symbolSetObj *symbolset, const char *filename)
-{
+int msSaveSymbolSet(symbolSetObj *symbolset, const char *filename) {
   FILE *stream;
   int retval;
   if (!filename || strlen(filename) == 0) {
@@ -887,23 +943,23 @@ int msSaveSymbolSet(symbolSetObj *symbol
   return retval;
 }
 
-int msLoadImageSymbol(symbolObj *symbol, const char *filename)
-{
+int msLoadImageSymbol(symbolObj *symbol, const char *filename) {
   msFree(symbol->full_pixmap_path);
   symbol->full_pixmap_path = msStrdup(filename);
   return MS_SUCCESS;
 }
 
-int msPreloadImageSymbol(rendererVTableObj *renderer, symbolObj *symbol)
-{
-  if(symbol->pixmap_buffer && symbol->renderer == renderer)
+int msPreloadImageSymbol(rendererVTableObj *renderer, symbolObj *symbol) {
+  if (symbol->pixmap_buffer && symbol->renderer == renderer)
     return MS_SUCCESS;
-  if(symbol->pixmap_buffer) { /* other renderer was used, start again */
+  if (symbol->pixmap_buffer) { /* other renderer was used, start again */
     msFreeRasterBuffer(symbol->pixmap_buffer);
   } else {
-    symbol->pixmap_buffer = (rasterBufferObj*)calloc(1,sizeof(rasterBufferObj));
+    symbol->pixmap_buffer =
+        (rasterBufferObj *)calloc(1, sizeof(rasterBufferObj));
   }
-  if(MS_SUCCESS != renderer->loadImageFromFile(symbol->full_pixmap_path, symbol->pixmap_buffer)) {
+  if (MS_SUCCESS != renderer->loadImageFromFile(symbol->full_pixmap_path,
+                                                symbol->pixmap_buffer)) {
     /* Free pixmap_buffer already allocated */
     free(symbol->pixmap_buffer);
     symbol->pixmap_buffer = NULL;
@@ -913,7 +969,6 @@ int msPreloadImageSymbol(rendererVTableO
   symbol->sizex = symbol->pixmap_buffer->width;
   symbol->sizey = symbol->pixmap_buffer->height;
   return MS_SUCCESS;
-
 }
 
 /***********************************************************************
@@ -923,8 +978,7 @@ int msPreloadImageSymbol(rendererVTableO
  * gdImageCreate(), gdImageCopy()                                      *
  **********************************************************************/
 
-int msCopySymbol(symbolObj *dst, const symbolObj *src, mapObj *map)
-{
+int msCopySymbol(symbolObj *dst, const symbolObj *src, mapObj *map) {
   int i;
 
   initSymbol(dst);
@@ -941,7 +995,7 @@ int msCopySymbol(symbolObj *dst, const s
   MS_COPYSTELEM(anchorpoint_x);
   MS_COPYSTELEM(anchorpoint_y);
 
-  for (i=0; i < src->numpoints; i++) {
+  for (i = 0; i < src->numpoints; i++) {
     MS_COPYPOINT(&(dst->points[i]), &(src->points[i]));
   }
 
@@ -953,9 +1007,9 @@ int msCopySymbol(symbolObj *dst, const s
   MS_COPYSTELEM(transparentcolor);
   MS_COPYSTRING(dst->character, src->character);
   MS_COPYSTRING(dst->font, src->font);
-  MS_COPYSTRING(dst->full_pixmap_path,src->full_pixmap_path);
+  MS_COPYSTRING(dst->full_pixmap_path, src->full_pixmap_path);
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
 /***********************************************************************
@@ -964,8 +1018,7 @@ int msCopySymbol(symbolObj *dst, const s
  * Copy a symbolSetObj using msCopyFontSet(), msCopySymbol()           *
  **********************************************************************/
 
-int msCopySymbolSet(symbolSetObj *dst, const symbolSetObj *src, mapObj *map)
-{
+int msCopySymbolSet(symbolSetObj *dst, const symbolSetObj *src, mapObj *map) {
   int i, return_value;
 
   MS_COPYSTRING(dst->filename, src->filename);
@@ -979,8 +1032,8 @@ int msCopySymbolSet(symbolSetObj *dst, c
       return MS_FAILURE;
     return_value = msCopySymbol(dst->symbol[i], src->symbol[i], map);
     if (return_value != MS_SUCCESS) {
-      msSetError(MS_MEMERR,"Failed to copy symbol.","msCopySymbolSet()");
-      return(MS_FAILURE);
+      msSetError(MS_MEMERR, "Failed to copy symbol.", "msCopySymbolSet()");
+      return (MS_FAILURE);
     }
     dst->numsymbols++;
   }
@@ -992,20 +1045,22 @@ int msCopySymbolSet(symbolSetObj *dst, c
                sizeof(struct imageCacheObj));
    */
 
-  dst->imagecachesize = 0; /* since we are not copying the cache set the cache  to NUNLL and the size to 0 (bug 1521) */
+  dst->imagecachesize = 0; /* since we are not copying the cache set the cache
+                              to NUNLL and the size to 0 (bug 1521) */
   dst->imagecache = NULL;
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
-static void get_bbox(pointObj *poiList, int numpoints, double *minx, double *miny, double *maxx, double *maxy)
-{
+static void get_bbox(pointObj *poiList, int numpoints, double *minx,
+                     double *miny, double *maxx, double *maxy) {
   int j;
 
   *minx = *maxx = poiList[0].x;
   *miny = *maxy = poiList[0].y;
-  for(j=1; j<numpoints; j++) {
-    if ((poiList[j].x==-99.0) || (poiList[j].y==-99.0)) continue;
+  for (j = 1; j < numpoints; j++) {
+    if ((poiList[j].x == -99.0) || (poiList[j].y == -99.0))
+      continue;
     *minx = MS_MIN(*minx, poiList[j].x);
     *maxx = MS_MAX(*maxx, poiList[j].x);
     *miny = MS_MIN(*miny, poiList[j].y);
@@ -1020,23 +1075,23 @@ static void get_bbox(pointObj *poiList,
  ** by MapMedia, with clean up by SDL. Currently only type VECTOR and PIXMAP
  ** symbols are handled.
  */
-symbolObj *msRotateVectorSymbol(symbolObj *symbol, double angle)
-{
-  double angle_rad=0.0;
+symbolObj *msRotateVectorSymbol(symbolObj *symbol, double angle) {
+  double angle_rad = 0.0;
   double cos_a, sin_a;
-  double minx=0.0, miny=0.0, maxx=0.0, maxy=0.0;
+  double minx = 0.0, miny = 0.0, maxx = 0.0, maxy = 0.0;
   symbolObj *newSymbol = NULL;
   double dp_x, dp_y, xcor, ycor;
-  double TOL=0.00000000001;
+  double TOL = 0.00000000001;
   int i;
 
   /* assert(symbol->type == MS_SYMBOL_VECTOR); */
 
-  newSymbol = (symbolObj *) malloc(sizeof(symbolObj));
-  msCopySymbol(newSymbol, symbol, NULL); /* TODO: do we really want to do this for all symbol types? */
-
-  angle_rad = (MS_DEG_TO_RAD*angle);
+  newSymbol = (symbolObj *)malloc(sizeof(symbolObj));
+  msCopySymbol(
+      newSymbol, symbol,
+      NULL); /* TODO: do we really want to do this for all symbol types? */
 
+  angle_rad = (MS_DEG_TO_RAD * angle);
 
   sin_a = sin(angle_rad);
   cos_a = cos(angle_rad);
@@ -1045,32 +1100,38 @@ symbolObj *msRotateVectorSymbol(symbolOb
   dp_y = symbol->sizey * .5;
 
   /* center at 0,0 and rotate; then move back */
-  for( i=0; i < symbol->numpoints; i++) {
+  for (i = 0; i < symbol->numpoints; i++) {
     /* don't rotate PENUP commands (TODO: should use a constant here) */
-    if ((symbol->points[i].x == -99.0) && (symbol->points[i].y == -99.0) ) {
+    if ((symbol->points[i].x == -99.0) && (symbol->points[i].y == -99.0)) {
       newSymbol->points[i].x = -99.0;
       newSymbol->points[i].y = -99.0;
       continue;
     }
 
-    newSymbol->points[i].x = dp_x + ((symbol->points[i].x-dp_x)*cos_a - (symbol->points[i].y-dp_y)*sin_a);
-    newSymbol->points[i].y = dp_y + ((symbol->points[i].x-dp_x)*sin_a + (symbol->points[i].y-dp_y)*cos_a);
+    newSymbol->points[i].x = dp_x + ((symbol->points[i].x - dp_x) * cos_a -
+                                     (symbol->points[i].y - dp_y) * sin_a);
+    newSymbol->points[i].y = dp_y + ((symbol->points[i].x - dp_x) * sin_a +
+                                     (symbol->points[i].y - dp_y) * cos_a);
   }
 
-  /* get the new bbox of the symbol, because we need it to get the new dimensions of the new symbol */
+  /* get the new bbox of the symbol, because we need it to get the new
+   * dimensions of the new symbol */
   get_bbox(newSymbol->points, newSymbol->numpoints, &minx, &miny, &maxx, &maxy);
-  if ( (fabs(minx)>TOL) || (fabs(miny)>TOL) ) {
-    xcor = minx*-1.0; /* symbols always start at 0,0 so get the shift vector */
-    ycor = miny*-1.0;
-    for( i=0; i < newSymbol->numpoints; i++) {
-      if ((newSymbol->points[i].x == -99.0) && (newSymbol->points[i].y == -99.0))
+  if ((fabs(minx) > TOL) || (fabs(miny) > TOL)) {
+    xcor =
+        minx * -1.0; /* symbols always start at 0,0 so get the shift vector */
+    ycor = miny * -1.0;
+    for (i = 0; i < newSymbol->numpoints; i++) {
+      if ((newSymbol->points[i].x == -99.0) &&
+          (newSymbol->points[i].y == -99.0))
         continue;
       newSymbol->points[i].x = newSymbol->points[i].x + xcor;
       newSymbol->points[i].y = newSymbol->points[i].y + ycor;
     }
 
     /* update the bbox to get the final dimension values for the symbol */
-    get_bbox(newSymbol->points, newSymbol->numpoints, &minx, &miny, &maxx, &maxy);
+    get_bbox(newSymbol->points, newSymbol->numpoints, &minx, &miny, &maxx,
+             &maxy);
   }
 
   newSymbol->sizex = maxx;
diff -pruN 8.0.1-5/mapsymbol.h 8.0.2-1/mapsymbol.h
--- 8.0.1-5/mapsymbol.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapsymbol.h	2024-06-11 20:41:34.000000000 +0000
@@ -33,10 +33,19 @@
 #include "mapserver-api.h"
 #include <assert.h>
 
-enum MS_SYMBOL_TYPE {MS_SYMBOL_SIMPLE=1000, MS_SYMBOL_VECTOR, MS_SYMBOL_ELLIPSE, MS_SYMBOL_PIXMAP, MS_SYMBOL_TRUETYPE, MS_SYMBOL_HATCH, MS_SYMBOL_SVG};
+enum MS_SYMBOL_TYPE {
+  MS_SYMBOL_SIMPLE = 1000,
+  MS_SYMBOL_VECTOR,
+  MS_SYMBOL_ELLIPSE,
+  MS_SYMBOL_PIXMAP,
+  MS_SYMBOL_TRUETYPE,
+  MS_SYMBOL_HATCH,
+  MS_SYMBOL_SVG
+};
 
-#define MS_SYMBOL_ALLOCSIZE 64      /* number of symbolObj ptrs to allocate for a symbolset at once */
-#define MS_MAXVECTORPOINTS 100      /* shade, marker and line symbol parameters */
+#define MS_SYMBOL_ALLOCSIZE                                                    \
+  64 /* number of symbolObj ptrs to allocate for a symbolset at once */
+#define MS_MAXVECTORPOINTS 100 /* shade, marker and line symbol parameters */
 #define MS_MAXPATTERNLENGTH 10
 
 #define MS_IMAGECACHESIZE 6
@@ -57,33 +66,36 @@ typedef struct {
 } colorObj;
 
 #ifndef SWIG
-enum MS_RASTER_BUFFER_TYPE { MS_BUFFER_NONE=2000, MS_BUFFER_BYTE_RGBA, MS_BUFFER_BYTE_PALETTE };
+enum MS_RASTER_BUFFER_TYPE {
+  MS_BUFFER_NONE = 2000,
+  MS_BUFFER_BYTE_RGBA,
+  MS_BUFFER_BYTE_PALETTE
+};
 
 typedef struct {
   unsigned char *pixels;
   unsigned int pixel_step, row_step;
-  unsigned char *a,*r,*g,*b;
+  unsigned char *a, *r, *g, *b;
 } rgbaArrayObj;
 
 typedef struct {
-  unsigned char b,g,r,a;
+  unsigned char b, g, r, a;
 } rgbaPixel;
 
 typedef struct {
-  unsigned char r,g,b;
+  unsigned char r, g, b;
 } rgbPixel;
 
-
 typedef struct {
-  unsigned char *pixels; /*stores the actual pixel indexes*/
-  rgbaPixel *palette; /*rgba palette entries*/
+  unsigned char *pixels;    /*stores the actual pixel indexes*/
+  rgbaPixel *palette;       /*rgba palette entries*/
   unsigned int num_entries; /*number of palette entries*/
   unsigned int scaling_maxval;
 } paletteArrayObj;
 
 typedef struct {
   int type;
-  unsigned int width,height;
+  unsigned int width, height;
   union {
     rgbaArrayObj rgba;
     paletteArrayObj palette;
@@ -93,50 +105,50 @@ typedef struct {
 /* NOTE: RB_SET_PIXEL() will premultiply by alpha, inputs should not be
          premultiplied */
 
-#define RB_SET_PIXEL(rb,x,y,red,green,blue,alpha) \
-    {  \
-        int _rb_off = (x) * (rb)->data.rgba.pixel_step + (y) * (rb)->data.rgba.row_step;   \
-        if( !(rb)->data.rgba.a ) { \
-           (rb)->data.rgba.r[_rb_off] = red; \
-           (rb)->data.rgba.g[_rb_off] = green; \
-           (rb)->data.rgba.b[_rb_off] = blue; \
-        } else { \
-           double a = alpha/255.0; \
-           (rb)->data.rgba.r[_rb_off] = red * a; \
-           (rb)->data.rgba.g[_rb_off] = green * a; \
-           (rb)->data.rgba.b[_rb_off] = blue * a; \
-           (rb)->data.rgba.a[_rb_off] = alpha; \
-        } \
-    }
+#define RB_SET_PIXEL(rb, x, y, red, green, blue, alpha)                        \
+  {                                                                            \
+    int _rb_off =                                                              \
+        (x) * (rb)->data.rgba.pixel_step + (y) * (rb)->data.rgba.row_step;     \
+    if (!(rb)->data.rgba.a) {                                                  \
+      (rb)->data.rgba.r[_rb_off] = red;                                        \
+      (rb)->data.rgba.g[_rb_off] = green;                                      \
+      (rb)->data.rgba.b[_rb_off] = blue;                                       \
+    } else {                                                                   \
+      double a = alpha / 255.0;                                                \
+      (rb)->data.rgba.r[_rb_off] = red * a;                                    \
+      (rb)->data.rgba.g[_rb_off] = green * a;                                  \
+      (rb)->data.rgba.b[_rb_off] = blue * a;                                   \
+      (rb)->data.rgba.a[_rb_off] = alpha;                                      \
+    }                                                                          \
+  }
 
 /* This versions receives an input red/green/blue that is already
    premultiplied with alpha */
-#define RB_SET_PIXEL_PM(rb,x,y,red,green,blue,alpha) \
-    {  \
-        int _rb_off = (x) * (rb)->data.rgba.pixel_step + (y) * (rb)->data.rgba.row_step;   \
-        (rb)->data.rgba.r[_rb_off] = red; \
-        (rb)->data.rgba.g[_rb_off] = green; \
-        (rb)->data.rgba.b[_rb_off] = blue; \
-        if( rb->data.rgba.a ) { \
-           (rb)->data.rgba.a[_rb_off] = alpha; \
-        } \
-    }
+#define RB_SET_PIXEL_PM(rb, x, y, red, green, blue, alpha)                     \
+  {                                                                            \
+    int _rb_off =                                                              \
+        (x) * (rb)->data.rgba.pixel_step + (y) * (rb)->data.rgba.row_step;     \
+    (rb)->data.rgba.r[_rb_off] = red;                                          \
+    (rb)->data.rgba.g[_rb_off] = green;                                        \
+    (rb)->data.rgba.b[_rb_off] = blue;                                         \
+    if (rb->data.rgba.a) {                                                     \
+      (rb)->data.rgba.a[_rb_off] = alpha;                                      \
+    }                                                                          \
+  }
 
 /* NOTE: RB_MIX_PIXEL() will premultiply by alpha, inputs should not be
          premultiplied */
 
-#define RB_MIX_PIXEL(rb,x,y,red,green,blue,alpha) \
-    {  \
-        int _rb_off = (x) * (rb)->data.rgba.pixel_step + (y) * (rb)->data.rgba.row_step;   \
-        \
-        msAlphaBlend(  red, green, blue, alpha, \
-                       (rb)->data.rgba.r + _rb_off, \
-                       (rb)->data.rgba.g + _rb_off, \
-                       (rb)->data.rgba.b + _rb_off, \
-                       ((rb)->data.rgba.a == NULL ) ? NULL : (rb)->data.rgba.a + _rb_off );  \
-    }
-
-
+#define RB_MIX_PIXEL(rb, x, y, red, green, blue, alpha)                        \
+  {                                                                            \
+    int _rb_off =                                                              \
+        (x) * (rb)->data.rgba.pixel_step + (y) * (rb)->data.rgba.row_step;     \
+                                                                               \
+    msAlphaBlend(red, green, blue, alpha, (rb)->data.rgba.r + _rb_off,         \
+                 (rb)->data.rgba.g + _rb_off, (rb)->data.rgba.b + _rb_off,     \
+                 ((rb)->data.rgba.a == NULL) ? NULL                            \
+                                             : (rb)->data.rgba.a + _rb_off);   \
+  }
 
 struct imageCacheObj {
   int symbol;
@@ -148,71 +160,81 @@ struct imageCacheObj {
   struct imageCacheObj *next;
 };
 
-
 #endif /* SWIG */
 
 /**
 The :ref:`SYMBOL <symbol>` object
 */
-struct symbolObj{
+struct symbolObj {
 
-    /*
-    ** MS_SYMBOL_PIXMAP options
-    */
+  /*
+  ** MS_SYMBOL_PIXMAP options
+  */
 #ifndef SWIG
-    rendererVTableObj *renderer;
-    void(*renderer_free_func)(symbolObj *self);
-    rasterBufferObj *pixmap_buffer;
-    void *renderer_cache;
-    char *full_pixmap_path;
-
-    /*
-    ** Pointer to his map
-    */
-    struct mapObj *map;
+  rendererVTableObj *renderer;
+  void (*renderer_free_func)(symbolObj *self);
+  rasterBufferObj *pixmap_buffer;
+  void *renderer_cache;
+  char *full_pixmap_path;
+
+  /*
+  ** Pointer to his map
+  */
+  struct mapObj *map;
 
-    pointObj points[MS_MAXVECTORPOINTS];
+  pointObj points[MS_MAXVECTORPOINTS];
 
 #endif /* SWIG */
 
 #ifdef SWIG
     %immutable;
-#endif /* SWIG */
-    int refcount; ///< Reference counter
-    int numpoints; ///< Number of points of a vector symbol
-    char *imagepath; ///< Path to pixmap file - see :ref:`IMAGE <mapfile-symbol-image>`
+#endif             /* SWIG */
+  int refcount;    ///< Reference counter
+  int numpoints;   ///< Number of points of a vector symbol
+  char *imagepath; ///< Path to pixmap file - see :ref:`IMAGE
+                   ///< <mapfile-symbol-image>`
 
 #ifdef SWIG
     %mutable;
 #endif /* SWIG */
 
-  char *name; ///< Symbol name - see :ref:`NAME <mapfile-symbol-name>`
-  int type; ///< See :ref:`TYPE <mapfile-symbol-type>`
-  int inmapfile; ///< Boolean value for writing - if set to :data:`TRUE`, the symbol will be saved inside the Mapfile. Added in MapServer 5.6.1
+  char *name;    ///< Symbol name - see :ref:`NAME <mapfile-symbol-name>`
+  int type;      ///< See :ref:`TYPE <mapfile-symbol-type>`
+  int inmapfile; ///< Boolean value for writing - if set to :data:`TRUE`, the
+                 ///< symbol will be saved inside the Mapfile. Added in
+                 ///< MapServer 5.6.1
 
   /*
   ** MS_SYMBOL_VECTOR and MS_SYMBOL_ELLIPSE options
   */
-  double sizex; ///< :data:`MS_SYMBOL_VECTOR` and :data:`MS_SYMBOL_ELLIPSE` option
-  double sizey; ///< :data:`MS_SYMBOL_VECTOR` and :data:`MS_SYMBOL_ELLIPSE` option
-
-  double minx; ///< :data:`MS_SYMBOL_VECTOR` and :data:`MS_SYMBOL_ELLIPSE` option
-  double miny; ///< :data:`MS_SYMBOL_VECTOR` and :data:`MS_SYMBOL_ELLIPSE` option
-  double maxx; ///< :data:`MS_SYMBOL_VECTOR` and :data:`MS_SYMBOL_ELLIPSE` option
-  double maxy; ///< :data:`MS_SYMBOL_VECTOR` and :data:`MS_SYMBOL_ELLIPSE` option
+  double
+      sizex; ///< :data:`MS_SYMBOL_VECTOR` and :data:`MS_SYMBOL_ELLIPSE` option
+  double
+      sizey; ///< :data:`MS_SYMBOL_VECTOR` and :data:`MS_SYMBOL_ELLIPSE` option
+
+  double
+      minx; ///< :data:`MS_SYMBOL_VECTOR` and :data:`MS_SYMBOL_ELLIPSE` option
+  double
+      miny; ///< :data:`MS_SYMBOL_VECTOR` and :data:`MS_SYMBOL_ELLIPSE` option
+  double
+      maxx; ///< :data:`MS_SYMBOL_VECTOR` and :data:`MS_SYMBOL_ELLIPSE` option
+  double
+      maxy; ///< :data:`MS_SYMBOL_VECTOR` and :data:`MS_SYMBOL_ELLIPSE` option
 
-  int filled; ///< :data:`MS_TRUE` or :data:`MS_FALSE` - see :ref:`FILLED <mapfile-symbol-filled>`
+  int filled; ///< :data:`MS_TRUE` or :data:`MS_FALSE` - see :ref:`FILLED
+              ///< <mapfile-symbol-filled>`
   double anchorpoint_x; ///< See :ref:`ANCHORPOINT <mapfile-symbol-anchorpoint>`
   double anchorpoint_y; ///< See :ref:`ANCHORPOINT <mapfile-symbol-anchorpoint>`
 
-  int transparent; ///< \**TODO** Remove
+  int transparent;      ///< \**TODO** Remove
   int transparentcolor; ///< \**TODO** Remove
 
   /*
   ** MS_SYMBOL_TRUETYPE options
   */
-  char *character; ///< For TrueType symbols - see :ref:`CHARACTER <mapfile-symbol-character>`
+  char *character; ///< For TrueType symbols - see :ref:`CHARACTER
+                   ///< <mapfile-symbol-character>`
   char *font; ///< For TrueType symbols - see :ref:`FONT <mapfile-symbol-font>`
-} ;
+};
 
 #endif /* MAPSYMBOL_H */
diff -pruN 8.0.1-5/maptclutf.c 8.0.2-1/maptclutf.c
--- 8.0.1-5/maptclutf.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/maptclutf.c	2024-06-11 20:41:34.000000000 +0000
@@ -86,12 +86,8 @@
  * terms specified in this license.
  */
 
-
 #include "mapserver.h"
 
-
-
-
 /* The source code of Tcl_UtfToUniChar() was borrowed from tclUtf.c
  * from the Tcl/Tk project:
  * Website:
@@ -159,38 +155,38 @@ terms specified in this license.
 
 ***********************************************************/
 
-
 #define TCL_UTF_MAX 6
 
-
 /*
  * The following structures are used when mapping between Unicode (UCS-2)
  * and UTF-8.
  */
 
 static const unsigned char totalBytes[256] = {
-  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
-  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
-  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
-  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
-  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
-  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
-  2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
-  3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,
+    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
+    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
+    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
+    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
+    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
+    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
+    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
+    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
+    2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
+    2, 2, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
 #if TCL_UTF_MAX > 3
-  4,4,4,4,4,4,4,4,
+    4, 4, 4, 4, 4, 4, 4, 4,
 #else
-  1,1,1,1,1,1,1,1,
+    1, 1, 1, 1, 1, 1, 1, 1,
 #endif
 #if TCL_UTF_MAX > 4
-  5,5,5,5,
+    5, 5, 5, 5,
 #else
-  1,1,1,1,
+    1, 1, 1, 1,
 #endif
 #if TCL_UTF_MAX > 5
-  6,6,6,6
+    6, 6, 6, 6
 #else
-  1,1,1,1
+    1, 1, 1, 1
 #endif
 };
 
@@ -220,16 +216,15 @@ static const unsigned char totalBytes[25
  *---------------------------------------------------------------------------
  */
 
-int ms_Tcl_UtfToUniChar(register const char *str, register unsigned int *chPtr)
-{
+int ms_Tcl_UtfToUniChar(register const char *str,
+                        register unsigned int *chPtr) {
   register int byte;
 
-
   /*
    * Unroll 1 to 3 byte UTF-8 sequences, use loop to handle longer ones.
    */
 
-  byte = *((unsigned char *) str);
+  byte = *((unsigned char *)str);
   if (byte < 0xC0) {
     /*
      * Handles properly formed UTF-8 characters between 0x01 and 0x7F.
@@ -261,8 +256,8 @@ int ms_Tcl_UtfToUniChar(register const c
        * Three-byte-character lead byte followed by two trail bytes.
        */
 
-      *chPtr = (((byte & 0x0F) << 12)
-                              | ((str[1] & 0x3F) << 6) | (str[2] & 0x3F));
+      *chPtr =
+          (((byte & 0x0F) << 12) | ((str[1] & 0x3F) << 6) | (str[2] & 0x3F));
       return 3;
     }
     /*
@@ -301,7 +296,6 @@ int ms_Tcl_UtfToUniChar(register const c
   return 1;
 }
 
-
 /* msUTF8ToUniChar()
  *
  *  Extract the Unicode Char represented by the UTF-8 string.  Bad
@@ -316,17 +310,15 @@ int ms_Tcl_UtfToUniChar(register const c
  * Results:
  *  *chPtr is filled with the Unicode Char value, and the return value
  *  is the number of bytes from the UTF-8 string that were consumed.
-**
-**/
-int msUTF8ToUniChar(const char *str, /* The UTF-8 string. */
-                    unsigned int *chPtr)      /* Filled with the Unicode Char represented
-                                      * by the UTF-8 string. */
+ **
+ **/
+int msUTF8ToUniChar(const char *str,     /* The UTF-8 string. */
+                    unsigned int *chPtr) /* Filled with the Unicode Char
+                                          * represented by the UTF-8 string. */
 {
   /*check if the string is an html entity (eg &#123; or &#x12a;)*/
   int entitylgth;
-  if(*str == '&' && (entitylgth=msGetUnicodeEntity(str, chPtr))>0)
+  if (*str == '&' && (entitylgth = msGetUnicodeEntity(str, chPtr)) > 0)
     return entitylgth;
   return ms_Tcl_UtfToUniChar(str, chPtr);
 }
-
-
diff -pruN 8.0.1-5/maptemplate.c 8.0.2-1/maptemplate.c
--- 8.0.1-5/maptemplate.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/maptemplate.c	2024-06-11 20:41:34.000000000 +0000
@@ -44,55 +44,69 @@
 #include <assert.h>
 #include <ctype.h>
 
-
-static inline void IGUR_sizet(size_t ignored) { (void)ignored; }  /* Ignore GCC Unused Result */
-static inline void IGUR_voidp(void* ignored) { (void)ignored; }  /* Ignore GCC Unused Result */
+static inline void IGUR_sizet(size_t ignored) {
+  (void)ignored;
+} /* Ignore GCC Unused Result */
+static inline void IGUR_voidp(void *ignored) {
+  (void)ignored;
+} /* Ignore GCC Unused Result */
 
 static const char *const olUrl = "//www.mapserver.org/lib/OpenLayers-ms60.js";
-static const char *const olTemplate = \
-                          "<html>\n"
-                          "<head>\n"
-                          "<meta content=\"text/html;charset=utf-8\" http-equiv=\"Content-Type\">\n"
-                          "  <title>MapServer Simple Viewer</title>\n"
-                          "    <script type=\"text/javascript\" src=\"[openlayers_js_url]\"></script>\n"
-                          "    <link rel=\"shortcut icon\" type=\"image/x-icon\" href=\"//www.mapserver.org/_static/mapserver.ico\"/>\n"
-                          "    </head>\n"
-                          "    <body>\n"
-                          "      <div style=\"width:[mapwidth]; height:[mapheight]\" id=\"map\"></div>\n"
-                          "      <script defer=\"defer\" type=\"text/javascript\">\n"
-                          "        var map = new OpenLayers.Map('map',\n"
-                          "                                     {maxExtent: new OpenLayers.Bounds([minx],[miny],[maxx],[maxy]),\n"
-                          "                                      maxResolution: [cellsize]});\n"
-                          "        [openlayers_layer];\n"
-                          "        map.addLayer(mslayer);\n"
-                          "        map.zoomToMaxExtent();\n"
-                          "      </script>\n"
-                          "</body>\n"
-                          "</html>";
-
-static const char *const olLayerMapServerTag = \
-                                   "var mslayer = new OpenLayers.Layer.MapServer( \"MapServer Layer\",\n"
-                                   "                                              \"[mapserv_onlineresource]\",\n"
-                                   "                                              {layers: '[layers]'},\n"
-                                   "                                              {singleTile: \"true\", ratio:1} )";
-
-static const char *const olLayerWMSTag = \
-                             "var mslayer = new OpenLayers.Layer.WMS('MapServer Simple Viewer\',\n"
-                             "                                   '[mapserv_onlineresource]',\n"
-                             "                                   {layers: '[LAYERS]',\n"
-                             "                                   bbox: '[minx],[miny],[maxx],[maxy]',\n"
-                             "                                   width: [mapwidth], height: [mapheight], version: '[VERSION]', format:'[openlayers_format]'},"
-                             "                                   {singleTile: \"true\", ratio:1, projection: '[openlayers_projection]'});\n";
+static const char *const olTemplate =
+    "<html>\n"
+    "<head>\n"
+    "<meta content=\"text/html;charset=utf-8\" http-equiv=\"Content-Type\">\n"
+    "  <title>MapServer Simple Viewer</title>\n"
+    "    <script type=\"text/javascript\" "
+    "src=\"[openlayers_js_url]\"></script>\n"
+    "    <link rel=\"shortcut icon\" type=\"image/x-icon\" "
+    "href=\"//www.mapserver.org/_static/mapserver.ico\"/>\n"
+    "    </head>\n"
+    "    <body>\n"
+    "      <div style=\"width:[mapwidth]; height:[mapheight]\" "
+    "id=\"map\"></div>\n"
+    "      <script defer=\"defer\" type=\"text/javascript\">\n"
+    "        var map = new OpenLayers.Map('map',\n"
+    "                                     {maxExtent: new "
+    "OpenLayers.Bounds([minx],[miny],[maxx],[maxy]),\n"
+    "                                      maxResolution: [cellsize]});\n"
+    "        [openlayers_layer];\n"
+    "        map.addLayer(mslayer);\n"
+    "        map.zoomToMaxExtent();\n"
+    "      </script>\n"
+    "</body>\n"
+    "</html>";
+
+static const char *const olLayerMapServerTag =
+    "var mslayer = new OpenLayers.Layer.MapServer( \"MapServer Layer\",\n"
+    "                                              "
+    "\"[mapserv_onlineresource]\",\n"
+    "                                              {layers: '[layers]'},\n"
+    "                                              {singleTile: \"true\", "
+    "ratio:1} )";
+
+static const char *const olLayerWMSTag =
+    "var mslayer = new OpenLayers.Layer.WMS('MapServer Simple Viewer\',\n"
+    "                                   '[mapserv_onlineresource]',\n"
+    "                                   {layers: '[LAYERS]',\n"
+    "                                   bbox: '[minx],[miny],[maxx],[maxy]',\n"
+    "                                   width: [mapwidth], height: "
+    "[mapheight], version: '[VERSION]', format:'[openlayers_format]'},"
+    "                                   {singleTile: \"true\", ratio:1, "
+    "projection: '[openlayers_projection]'});\n";
 
-static char *processLine(mapservObj *mapserv, const char *instr, FILE *stream, int mode);
+static char *processLine(mapservObj *mapserv, const char *instr, FILE *stream,
+                         int mode);
 
-static int isValidTemplate(FILE *stream, const char *filename)
-{
+static int isValidTemplate(FILE *stream, const char *filename) {
   char buffer[MS_BUFFER_LENGTH];
 
-  if(fgets(buffer, MS_BUFFER_LENGTH, stream) != NULL) {
-    if(!strcasestr(buffer, MS_TEMPLATE_MAGIC_STRING)) {
-      msSetError(MS_WEBERR, "Missing magic string, %s doesn't look like a MapServer template.", "isValidTemplate()", filename);
+  if (fgets(buffer, MS_BUFFER_LENGTH, stream) != NULL) {
+    if (!strcasestr(buffer, MS_TEMPLATE_MAGIC_STRING)) {
+      msSetError(
+          MS_WEBERR,
+          "Missing magic string, %s doesn't look like a MapServer template.",
+          "isValidTemplate()", filename);
       return MS_FALSE;
     }
   }
@@ -103,13 +117,12 @@ static int isValidTemplate(FILE *stream,
 /*
  * Redirect to (only use in CGI)
  *
-*/
-int msRedirect(char *url)
-{
-  msIO_setHeader("Status","302 Found");
-  msIO_setHeader("Uri","%s",url);
-  msIO_setHeader("Location","%s",url);
-  msIO_setHeader("Content-Type","text/html");
+ */
+int msRedirect(char *url) {
+  msIO_setHeader("Status", "302 Found");
+  msIO_setHeader("Uri", "%s", url);
+  msIO_setHeader("Location", "%s", url);
+  msIO_setHeader("Content-Type", "text/html");
   msIO_sendHeaders();
   return MS_SUCCESS;
 }
@@ -117,66 +130,109 @@ int msRedirect(char *url)
 /*
 ** Sets the map extent under a variety of scenarios.
 */
-int setExtent(mapservObj *mapserv)
-{
-  double cellx,celly,cellsize;
+int setExtent(mapservObj *mapserv) {
+  double cellx, celly, cellsize;
 
-  if(mapserv->Mode == TILE) {
-    if(MS_SUCCESS != msTileSetExtent(mapserv)) {
+  if (mapserv->Mode == TILE) {
+    if (MS_SUCCESS != msTileSetExtent(mapserv)) {
       return MS_FAILURE;
     }
   }
-  switch(mapserv->CoordSource) {
-    case FROMUSERBOX: /* user passed in a map extent */
-      break;
-    case FROMIMGBOX: /* fully interactive web, most likely with java front end */
-      cellx = MS_CELLSIZE(mapserv->ImgExt.minx, mapserv->ImgExt.maxx, mapserv->ImgCols);
-      celly = MS_CELLSIZE(mapserv->ImgExt.miny, mapserv->ImgExt.maxy, mapserv->ImgRows);
-      mapserv->map->extent.minx = MS_IMAGE2MAP_X(mapserv->ImgBox.minx, mapserv->ImgExt.minx, cellx);
-      mapserv->map->extent.maxx = MS_IMAGE2MAP_X(mapserv->ImgBox.maxx, mapserv->ImgExt.minx, cellx);
-      mapserv->map->extent.maxy = MS_IMAGE2MAP_Y(mapserv->ImgBox.miny, mapserv->ImgExt.maxy, celly); /* y's are flip flopped because img/map coordinate systems are */
-      mapserv->map->extent.miny = MS_IMAGE2MAP_Y(mapserv->ImgBox.maxy, mapserv->ImgExt.maxy, celly);
-      break;
-    case FROMIMGPNT:
-      cellx = MS_CELLSIZE(mapserv->ImgExt.minx, mapserv->ImgExt.maxx, mapserv->ImgCols);
-      celly = MS_CELLSIZE(mapserv->ImgExt.miny, mapserv->ImgExt.maxy, mapserv->ImgRows);
-      mapserv->mappnt.x = MS_IMAGE2MAP_X(mapserv->ImgPnt.x, mapserv->ImgExt.minx, cellx);
-      mapserv->mappnt.y = MS_IMAGE2MAP_Y(mapserv->ImgPnt.y, mapserv->ImgExt.maxy, celly);
-
-      mapserv->map->extent.minx = mapserv->mappnt.x - .5*((mapserv->ImgExt.maxx - mapserv->ImgExt.minx)/mapserv->fZoom); /* create an extent around that point */
-      mapserv->map->extent.miny = mapserv->mappnt.y - .5*((mapserv->ImgExt.maxy - mapserv->ImgExt.miny)/mapserv->fZoom);
-      mapserv->map->extent.maxx = mapserv->mappnt.x + .5*((mapserv->ImgExt.maxx - mapserv->ImgExt.minx)/mapserv->fZoom);
-      mapserv->map->extent.maxy = mapserv->mappnt.y + .5*((mapserv->ImgExt.maxy - mapserv->ImgExt.miny)/mapserv->fZoom);
-      break;
-    case FROMREFPNT:
-      cellx = MS_CELLSIZE(mapserv->map->reference.extent.minx, mapserv->map->reference.extent.maxx, mapserv->map->reference.width);
-      celly = MS_CELLSIZE(mapserv->map->reference.extent.miny, mapserv->map->reference.extent.maxy, mapserv->map->reference.height);
-      mapserv->mappnt.x = MS_IMAGE2MAP_X(mapserv->RefPnt.x, mapserv->map->reference.extent.minx, cellx);
-      mapserv->mappnt.y = MS_IMAGE2MAP_Y(mapserv->RefPnt.y, mapserv->map->reference.extent.maxy, celly);
-
-      mapserv->map->extent.minx = mapserv->mappnt.x - .5*(mapserv->ImgExt.maxx - mapserv->ImgExt.minx); /* create an extent around that point */
-      mapserv->map->extent.miny = mapserv->mappnt.y - .5*(mapserv->ImgExt.maxy - mapserv->ImgExt.miny);
-      mapserv->map->extent.maxx = mapserv->mappnt.x + .5*(mapserv->ImgExt.maxx - mapserv->ImgExt.minx);
-      mapserv->map->extent.maxy = mapserv->mappnt.y + .5*(mapserv->ImgExt.maxy - mapserv->ImgExt.miny);
-      break;
-    case FROMBUF:
-      mapserv->map->extent.minx = mapserv->mappnt.x - mapserv->Buffer; /* create an extent around that point, using the buffer */
-      mapserv->map->extent.miny = mapserv->mappnt.y - mapserv->Buffer;
-      mapserv->map->extent.maxx = mapserv->mappnt.x + mapserv->Buffer;
-      mapserv->map->extent.maxy = mapserv->mappnt.y + mapserv->Buffer;
-      break;
-    case FROMSCALE:
-      cellsize = (mapserv->ScaleDenom/mapserv->map->resolution)/msInchesPerUnit(mapserv->map->units,0); /* user supplied a point and a scale denominator */
-      mapserv->map->extent.minx = mapserv->mappnt.x - cellsize*(mapserv->map->width-1)/2.0;
-      mapserv->map->extent.miny = mapserv->mappnt.y - cellsize*(mapserv->map->height-1)/2.0;
-      mapserv->map->extent.maxx = mapserv->mappnt.x + cellsize*(mapserv->map->width-1)/2.0;
-      mapserv->map->extent.maxy = mapserv->mappnt.y + cellsize*(mapserv->map->height-1)/2.0;
-      break;
-    default: /* use the default in the mapfile if it exists */
-      if((mapserv->map->extent.minx == mapserv->map->extent.maxx) && (mapserv->map->extent.miny == mapserv->map->extent.maxy)) {
-        msSetError(MS_WEBERR, "No way to generate map extent.", "mapserv()");
-        return MS_FAILURE;
-      }
+  switch (mapserv->CoordSource) {
+  case FROMUSERBOX: /* user passed in a map extent */
+    break;
+  case FROMIMGBOX: /* fully interactive web, most likely with java front end */
+    cellx = MS_CELLSIZE(mapserv->ImgExt.minx, mapserv->ImgExt.maxx,
+                        mapserv->ImgCols);
+    celly = MS_CELLSIZE(mapserv->ImgExt.miny, mapserv->ImgExt.maxy,
+                        mapserv->ImgRows);
+    mapserv->map->extent.minx =
+        MS_IMAGE2MAP_X(mapserv->ImgBox.minx, mapserv->ImgExt.minx, cellx);
+    mapserv->map->extent.maxx =
+        MS_IMAGE2MAP_X(mapserv->ImgBox.maxx, mapserv->ImgExt.minx, cellx);
+    mapserv->map->extent.maxy =
+        MS_IMAGE2MAP_Y(mapserv->ImgBox.miny, mapserv->ImgExt.maxy,
+                       celly); /* y's are flip flopped because img/map
+                                  coordinate systems are */
+    mapserv->map->extent.miny =
+        MS_IMAGE2MAP_Y(mapserv->ImgBox.maxy, mapserv->ImgExt.maxy, celly);
+    break;
+  case FROMIMGPNT:
+    cellx = MS_CELLSIZE(mapserv->ImgExt.minx, mapserv->ImgExt.maxx,
+                        mapserv->ImgCols);
+    celly = MS_CELLSIZE(mapserv->ImgExt.miny, mapserv->ImgExt.maxy,
+                        mapserv->ImgRows);
+    mapserv->mappnt.x =
+        MS_IMAGE2MAP_X(mapserv->ImgPnt.x, mapserv->ImgExt.minx, cellx);
+    mapserv->mappnt.y =
+        MS_IMAGE2MAP_Y(mapserv->ImgPnt.y, mapserv->ImgExt.maxy, celly);
+
+    mapserv->map->extent.minx =
+        mapserv->mappnt.x -
+        .5 * ((mapserv->ImgExt.maxx - mapserv->ImgExt.minx) /
+              mapserv->fZoom); /* create an extent around that point */
+    mapserv->map->extent.miny =
+        mapserv->mappnt.y -
+        .5 * ((mapserv->ImgExt.maxy - mapserv->ImgExt.miny) / mapserv->fZoom);
+    mapserv->map->extent.maxx =
+        mapserv->mappnt.x +
+        .5 * ((mapserv->ImgExt.maxx - mapserv->ImgExt.minx) / mapserv->fZoom);
+    mapserv->map->extent.maxy =
+        mapserv->mappnt.y +
+        .5 * ((mapserv->ImgExt.maxy - mapserv->ImgExt.miny) / mapserv->fZoom);
+    break;
+  case FROMREFPNT:
+    cellx = MS_CELLSIZE(mapserv->map->reference.extent.minx,
+                        mapserv->map->reference.extent.maxx,
+                        mapserv->map->reference.width);
+    celly = MS_CELLSIZE(mapserv->map->reference.extent.miny,
+                        mapserv->map->reference.extent.maxy,
+                        mapserv->map->reference.height);
+    mapserv->mappnt.x = MS_IMAGE2MAP_X(
+        mapserv->RefPnt.x, mapserv->map->reference.extent.minx, cellx);
+    mapserv->mappnt.y = MS_IMAGE2MAP_Y(
+        mapserv->RefPnt.y, mapserv->map->reference.extent.maxy, celly);
+
+    mapserv->map->extent.minx =
+        mapserv->mappnt.x -
+        .5 * (mapserv->ImgExt.maxx -
+              mapserv->ImgExt.minx); /* create an extent around that point */
+    mapserv->map->extent.miny =
+        mapserv->mappnt.y - .5 * (mapserv->ImgExt.maxy - mapserv->ImgExt.miny);
+    mapserv->map->extent.maxx =
+        mapserv->mappnt.x + .5 * (mapserv->ImgExt.maxx - mapserv->ImgExt.minx);
+    mapserv->map->extent.maxy =
+        mapserv->mappnt.y + .5 * (mapserv->ImgExt.maxy - mapserv->ImgExt.miny);
+    break;
+  case FROMBUF:
+    mapserv->map->extent.minx =
+        mapserv->mappnt.x -
+        mapserv
+            ->Buffer; /* create an extent around that point, using the buffer */
+    mapserv->map->extent.miny = mapserv->mappnt.y - mapserv->Buffer;
+    mapserv->map->extent.maxx = mapserv->mappnt.x + mapserv->Buffer;
+    mapserv->map->extent.maxy = mapserv->mappnt.y + mapserv->Buffer;
+    break;
+  case FROMSCALE:
+    cellsize =
+        (mapserv->ScaleDenom / mapserv->map->resolution) /
+        msInchesPerUnit(mapserv->map->units,
+                        0); /* user supplied a point and a scale denominator */
+    mapserv->map->extent.minx =
+        mapserv->mappnt.x - cellsize * (mapserv->map->width - 1) / 2.0;
+    mapserv->map->extent.miny =
+        mapserv->mappnt.y - cellsize * (mapserv->map->height - 1) / 2.0;
+    mapserv->map->extent.maxx =
+        mapserv->mappnt.x + cellsize * (mapserv->map->width - 1) / 2.0;
+    mapserv->map->extent.maxy =
+        mapserv->mappnt.y + cellsize * (mapserv->map->height - 1) / 2.0;
+    break;
+  default: /* use the default in the mapfile if it exists */
+    if ((mapserv->map->extent.minx == mapserv->map->extent.maxx) &&
+        (mapserv->map->extent.miny == mapserv->map->extent.maxy)) {
+      msSetError(MS_WEBERR, "No way to generate map extent.", "mapserv()");
+      return MS_FAILURE;
+    }
   }
 
   mapserv->RawExt = mapserv->map->extent; /* save unaltered extent */
@@ -184,50 +240,81 @@ int setExtent(mapservObj *mapserv)
   return MS_SUCCESS;
 }
 
-int checkWebScale(mapservObj *mapserv)
-{
+int checkWebScale(mapservObj *mapserv) {
   int status;
   rectObj work_extent = mapserv->map->extent;
 
-  mapserv->map->cellsize = msAdjustExtent(&(work_extent), mapserv->map->width, mapserv->map->height); /* we do this cause we need a scale */
-  if((status = msCalculateScale(work_extent, mapserv->map->units, mapserv->map->width, mapserv->map->height, mapserv->map->resolution, &mapserv->map->scaledenom)) != MS_SUCCESS) return status;
-
-  if((mapserv->map->scaledenom < mapserv->map->web.minscaledenom) && (mapserv->map->web.minscaledenom > 0)) {
-    if(mapserv->map->web.mintemplate) { /* use the template provided */
-      if(TEMPLATE_TYPE(mapserv->map->web.mintemplate) == MS_FILE) {
-        if((status = msReturnPage(mapserv, mapserv->map->web.mintemplate, BROWSE, NULL)) != MS_SUCCESS) return status;
+  mapserv->map->cellsize = msAdjustExtent(
+      &(work_extent), mapserv->map->width,
+      mapserv->map->height); /* we do this cause we need a scale */
+  if ((status = msCalculateScale(work_extent, mapserv->map->units,
+                                 mapserv->map->width, mapserv->map->height,
+                                 mapserv->map->resolution,
+                                 &mapserv->map->scaledenom)) != MS_SUCCESS)
+    return status;
+
+  if ((mapserv->map->scaledenom < mapserv->map->web.minscaledenom) &&
+      (mapserv->map->web.minscaledenom > 0)) {
+    if (mapserv->map->web.mintemplate) { /* use the template provided */
+      if (TEMPLATE_TYPE(mapserv->map->web.mintemplate) == MS_FILE) {
+        if ((status = msReturnPage(mapserv, mapserv->map->web.mintemplate,
+                                   BROWSE, NULL)) != MS_SUCCESS)
+          return status;
       } else {
-        if((status = msReturnURL(mapserv, mapserv->map->web.mintemplate, BROWSE)) != MS_SUCCESS) return status;
+        if ((status = msReturnURL(mapserv, mapserv->map->web.mintemplate,
+                                  BROWSE)) != MS_SUCCESS)
+          return status;
       }
     } else { /* force zoom = 1 (i.e. pan) */
       mapserv->fZoom = mapserv->Zoom = 1;
       mapserv->ZoomDirection = 0;
       mapserv->CoordSource = FROMSCALE;
       mapserv->ScaleDenom = mapserv->map->web.minscaledenom;
-      mapserv->mappnt.x = (mapserv->map->extent.maxx + mapserv->map->extent.minx)/2; /* use center of bad extent */
-      mapserv->mappnt.y = (mapserv->map->extent.maxy + mapserv->map->extent.miny)/2;
+      mapserv->mappnt.x =
+          (mapserv->map->extent.maxx + mapserv->map->extent.minx) /
+          2; /* use center of bad extent */
+      mapserv->mappnt.y =
+          (mapserv->map->extent.maxy + mapserv->map->extent.miny) / 2;
       setExtent(mapserv);
-      mapserv->map->cellsize = msAdjustExtent(&(mapserv->map->extent), mapserv->map->width, mapserv->map->height);
-      if((status = msCalculateScale(mapserv->map->extent, mapserv->map->units, mapserv->map->width, mapserv->map->height, mapserv->map->resolution, &mapserv->map->scaledenom)) != MS_SUCCESS) return status;
+      mapserv->map->cellsize = msAdjustExtent(
+          &(mapserv->map->extent), mapserv->map->width, mapserv->map->height);
+      if ((status = msCalculateScale(mapserv->map->extent, mapserv->map->units,
+                                     mapserv->map->width, mapserv->map->height,
+                                     mapserv->map->resolution,
+                                     &mapserv->map->scaledenom)) != MS_SUCCESS)
+        return status;
     }
   } else {
-    if((mapserv->map->scaledenom > mapserv->map->web.maxscaledenom) && (mapserv->map->web.maxscaledenom > 0)) {
-      if(mapserv->map->web.maxtemplate) { /* use the template provided */
-        if(TEMPLATE_TYPE(mapserv->map->web.maxtemplate) == MS_FILE) {
-          if((status = msReturnPage(mapserv, mapserv->map->web.maxtemplate, BROWSE, NULL)) != MS_SUCCESS) return status;
+    if ((mapserv->map->scaledenom > mapserv->map->web.maxscaledenom) &&
+        (mapserv->map->web.maxscaledenom > 0)) {
+      if (mapserv->map->web.maxtemplate) { /* use the template provided */
+        if (TEMPLATE_TYPE(mapserv->map->web.maxtemplate) == MS_FILE) {
+          if ((status = msReturnPage(mapserv, mapserv->map->web.maxtemplate,
+                                     BROWSE, NULL)) != MS_SUCCESS)
+            return status;
         } else {
-          if((status = msReturnURL(mapserv, mapserv->map->web.maxtemplate, BROWSE)) != MS_SUCCESS) return status;
+          if ((status = msReturnURL(mapserv, mapserv->map->web.maxtemplate,
+                                    BROWSE)) != MS_SUCCESS)
+            return status;
         }
       } else { /* force zoom = 1 (i.e. pan) */
         mapserv->fZoom = mapserv->Zoom = 1;
         mapserv->ZoomDirection = 0;
         mapserv->CoordSource = FROMSCALE;
         mapserv->ScaleDenom = mapserv->map->web.maxscaledenom;
-        mapserv->mappnt.x = (mapserv->map->extent.maxx + mapserv->map->extent.minx)/2; /* use center of bad extent */
-        mapserv->mappnt.y = (mapserv->map->extent.maxy + mapserv->map->extent.miny)/2;
+        mapserv->mappnt.x =
+            (mapserv->map->extent.maxx + mapserv->map->extent.minx) /
+            2; /* use center of bad extent */
+        mapserv->mappnt.y =
+            (mapserv->map->extent.maxy + mapserv->map->extent.miny) / 2;
         setExtent(mapserv);
-        mapserv->map->cellsize = msAdjustExtent(&(mapserv->map->extent), mapserv->map->width, mapserv->map->height);
-        if((status = msCalculateScale(mapserv->map->extent, mapserv->map->units, mapserv->map->width, mapserv->map->height, mapserv->map->resolution, &mapserv->map->scaledenom)) != MS_SUCCESS) return status;
+        mapserv->map->cellsize = msAdjustExtent(
+            &(mapserv->map->extent), mapserv->map->width, mapserv->map->height);
+        if ((status = msCalculateScale(
+                 mapserv->map->extent, mapserv->map->units, mapserv->map->width,
+                 mapserv->map->height, mapserv->map->resolution,
+                 &mapserv->map->scaledenom)) != MS_SUCCESS)
+          return status;
       }
     }
   }
@@ -235,29 +322,32 @@ int checkWebScale(mapservObj *mapserv)
   return MS_SUCCESS;
 }
 
-int msReturnTemplateQuery(mapservObj *mapserv, char *queryFormat, char **papszBuffer)
-{
+int msReturnTemplateQuery(mapservObj *mapserv, char *queryFormat,
+                          char **papszBuffer) {
   imageObj *img = NULL;
   int i, status;
 
-  outputFormatObj *outputFormat=NULL;
+  outputFormatObj *outputFormat = NULL;
   mapObj *map = mapserv->map;
 
-  if(!queryFormat) {
-    msSetError(MS_WEBERR, "Return format/mime-type not specified.", "msReturnTemplateQuery()");
+  if (!queryFormat) {
+    msSetError(MS_WEBERR, "Return format/mime-type not specified.",
+               "msReturnTemplateQuery()");
     return MS_FAILURE;
   }
 
   msApplyDefaultOutputFormats(map);
 
-  i = msGetOutputFormatIndex(map, queryFormat); /* queryFormat can be a mime-type or name */
-  if(i >= 0) outputFormat = map->outputformatlist[i];
+  i = msGetOutputFormatIndex(
+      map, queryFormat); /* queryFormat can be a mime-type or name */
+  if (i >= 0)
+    outputFormat = map->outputformatlist[i];
 
-  if(outputFormat) {
-    if( MS_RENDERER_PLUGIN(outputFormat) ) {
+  if (outputFormat) {
+    if (MS_RENDERER_PLUGIN(outputFormat)) {
       msInitializeRendererVTable(outputFormat);
     }
-    if( MS_RENDERER_OGR(outputFormat) ) {
+    if (MS_RENDERER_OGR(outputFormat)) {
       checkWebScale(mapserv);
 
       status = msOGRWriteFromQuery(map, outputFormat, mapserv->sendheaders);
@@ -265,17 +355,20 @@ int msReturnTemplateQuery(mapservObj *ma
       return status;
     }
 
-    if( !MS_RENDERER_TEMPLATE(outputFormat) ) { /* got an image format, return the query results that way */
+    if (!MS_RENDERER_TEMPLATE(outputFormat)) { /* got an image format, return
+                                                  the query results that way */
       outputFormatObj *tempOutputFormat = map->outputformat; /* save format */
 
       checkWebScale(mapserv);
 
-      map->outputformat = outputFormat; /* override what was given for IMAGETYPE */
+      map->outputformat =
+          outputFormat; /* override what was given for IMAGETYPE */
       img = msDrawMap(map, MS_TRUE);
-      if(!img) return MS_FAILURE;
+      if (!img)
+        return MS_FAILURE;
       map->outputformat = tempOutputFormat; /* restore format */
 
-      if(mapserv->sendheaders) {
+      if (mapserv->sendheaders) {
         msIO_setHeader("Content-Type", "%s", MS_IMAGE_MIME_TYPE(outputFormat));
         msIO_sendHeaders();
       }
@@ -287,34 +380,42 @@ int msReturnTemplateQuery(mapservObj *ma
   }
 
   /*
-  ** At this point we know we have a template of some sort, either the new style that references a or the old
-  ** style made up of external files slammed together. Either way we may have to compute a query map and other
+  ** At this point we know we have a template of some sort, either the new style
+  *that references a or the old
+  ** style made up of external files slammed together. Either way we may have to
+  *compute a query map and other
   ** images. We only create support images IF the querymap has status=MS_ON.
   */
-  if(map->querymap.status) {
+  if (map->querymap.status) {
     checkWebScale(mapserv);
-    if(msGenerateImages(mapserv, MS_TRUE, MS_TRUE) != MS_SUCCESS)
+    if (msGenerateImages(mapserv, MS_TRUE, MS_TRUE) != MS_SUCCESS)
       return MS_FAILURE;
   }
 
-  if(outputFormat) {
-    const char *file = msGetOutputFormatOption( outputFormat, "FILE", NULL );
-    if(!file) {
-      msSetError(MS_WEBERR, "Template driver requires \"FILE\" format option be set.", "msReturnTemplateQuery()");
+  if (outputFormat) {
+    const char *file = msGetOutputFormatOption(outputFormat, "FILE", NULL);
+    if (!file) {
+      msSetError(MS_WEBERR,
+                 "Template driver requires \"FILE\" format option be set.",
+                 "msReturnTemplateQuery()");
       return MS_FAILURE;
     }
 
-    if(mapserv->sendheaders) {
-      const char *attachment = msGetOutputFormatOption( outputFormat, "ATTACHMENT", NULL );
-      if(attachment)
-        msIO_setHeader("Content-disposition","attachment; filename=%s", attachment);
+    if (mapserv->sendheaders) {
+      const char *attachment =
+          msGetOutputFormatOption(outputFormat, "ATTACHMENT", NULL);
+      if (attachment)
+        msIO_setHeader("Content-disposition", "attachment; filename=%s",
+                       attachment);
       msIO_setHeader("Content-Type", "%s", outputFormat->mimetype);
       msIO_sendHeaders();
     }
-    if((status = msReturnPage(mapserv, (char *) file, BROWSE, papszBuffer)) != MS_SUCCESS)
+    if ((status = msReturnPage(mapserv, (char *)file, BROWSE, papszBuffer)) !=
+        MS_SUCCESS)
       return status;
   } else {
-    if((status = msReturnNestedTemplateQuery(mapserv, queryFormat, papszBuffer)) != MS_SUCCESS)
+    if ((status = msReturnNestedTemplateQuery(mapserv, queryFormat,
+                                              papszBuffer)) != MS_SUCCESS)
       return status;
   }
 
@@ -322,18 +423,20 @@ int msReturnTemplateQuery(mapservObj *ma
 }
 
 /*
-** Is a particular layer or group on, that is was it requested explicitly by the user.
+** Is a particular layer or group on, that is was it requested explicitly by the
+*user.
 */
-int isOn(mapservObj *mapserv, char *name, char *group)
-{
+int isOn(mapservObj *mapserv, char *name, char *group) {
   int i;
 
-  for(i=0; i<mapserv->NumLayers; i++) {
-    if(name && strcmp(mapserv->Layers[i], name) == 0)  return(MS_TRUE);
-    if(group && strcmp(mapserv->Layers[i], group) == 0) return(MS_TRUE);
+  for (i = 0; i < mapserv->NumLayers; i++) {
+    if (name && strcmp(mapserv->Layers[i], name) == 0)
+      return (MS_TRUE);
+    if (group && strcmp(mapserv->Layers[i], group) == 0)
+      return (MS_TRUE);
   }
 
-  return(MS_FALSE);
+  return (MS_FALSE);
 }
 
 /************************************************************************/
@@ -341,11 +444,10 @@ int isOn(mapservObj *mapserv, char *name
 /*                                                                      */
 /*      sorth the displaying in ascending or descending order.          */
 /************************************************************************/
-int sortLayerByOrder(mapObj *map, const char* pszOrder)
-{
+int sortLayerByOrder(mapObj *map, const char *pszOrder) {
   int *panCurrentOrder = NULL;
 
-  if(!map) {
+  if (!map) {
     msSetError(MS_WEBERR, "Invalid pointer.", "sortLayerByOrder()");
     return MS_FAILURE;
   }
@@ -358,14 +460,14 @@ int sortLayerByOrder(mapObj *map, const
   /*      the map->layerorder should be set at this point in the          */
   /*      sortLayerByMetadata.                                            */
   /* -------------------------------------------------------------------- */
-  if(map->layerorder) {
-    panCurrentOrder = (int*)msSmallMalloc(map->numlayers * sizeof(int));
-    for (int i=0; i<map->numlayers ; i++)
+  if (map->layerorder) {
+    panCurrentOrder = (int *)msSmallMalloc(map->numlayers * sizeof(int));
+    for (int i = 0; i < map->numlayers; i++)
       panCurrentOrder[i] = map->layerorder[i];
 
-    if(strcasecmp(pszOrder, "DESCENDING") == 0) {
-      for (int i=0; i<map->numlayers; i++)
-        map->layerorder[i] = panCurrentOrder[map->numlayers-1-i];
+    if (strcasecmp(pszOrder, "DESCENDING") == 0) {
+      for (int i = 0; i < map->numlayers; i++)
+        map->layerorder[i] = panCurrentOrder[map->numlayers - 1 - i];
     }
 
     free(panCurrentOrder);
@@ -374,19 +476,17 @@ int sortLayerByOrder(mapObj *map, const
   return MS_SUCCESS;
 }
 
-
 /*!
  * This function set the map->layerorder
  * index order by the metadata collumn name
-*/
-static int sortLayerByMetadata(mapObj *map, const char* pszMetadata)
-{
+ */
+static int sortLayerByMetadata(mapObj *map, const char *pszMetadata) {
   int nLegendOrder1;
   int nLegendOrder2;
   int i, j;
   int tmp;
 
-  if(!map) {
+  if (!map) {
     msSetError(MS_WEBERR, "Invalid pointer.", "sortLayerByMetadata()");
     return MS_FAILURE;
   }
@@ -394,53 +494,55 @@ static int sortLayerByMetadata(mapObj *m
   /*
    * Initiate to default order (Reverse mapfile order)
    */
-  if(map->layerorder) {
+  if (map->layerorder) {
     int *pnLayerOrder;
 
     /* Backup the original layer order to be able to reverse it */
-    pnLayerOrder = (int*)msSmallMalloc(map->numlayers * sizeof(int));
-    for (i=0; i<map->numlayers ; i++)
+    pnLayerOrder = (int *)msSmallMalloc(map->numlayers * sizeof(int));
+    for (i = 0; i < map->numlayers; i++)
       pnLayerOrder[i] = map->layerorder[i];
 
     /* Get a new layerorder array */
     free(map->layerorder);
-    map->layerorder = (int*)msSmallMalloc(map->numlayers * sizeof(int));
+    map->layerorder = (int *)msSmallMalloc(map->numlayers * sizeof(int));
 
     /* Reverse the layerorder array */
-    for (i=0; i<map->numlayers ; i++)
+    for (i = 0; i < map->numlayers; i++)
       map->layerorder[i] = pnLayerOrder[map->numlayers - i - 1];
 
     free(pnLayerOrder);
   } else {
-    map->layerorder = (int*)msSmallMalloc(map->numlayers * sizeof(int));
+    map->layerorder = (int *)msSmallMalloc(map->numlayers * sizeof(int));
 
-    for (i=0; i<map->numlayers ; i++)
+    for (i = 0; i < map->numlayers; i++)
       map->layerorder[i] = map->numlayers - i - 1;
   }
 
-  if(!pszMetadata)
+  if (!pszMetadata)
     return MS_SUCCESS;
 
   /*
    * Bubble sort algo (not very efficient)
    * should implement a kind of quick sort
    * alog instead
-  */
-  for (i=0; i<map->numlayers-1; i++) {
-    for (j=0; j<map->numlayers-1-i; j++) {
-      const char* pszLegendOrder1 = msLookupHashTable(&(GET_LAYER(map, map->layerorder[j+1])->metadata), pszMetadata);
-      const char* pszLegendOrder2 = msLookupHashTable(&(GET_LAYER(map, map->layerorder[j])->metadata), pszMetadata);
+   */
+  for (i = 0; i < map->numlayers - 1; i++) {
+    for (j = 0; j < map->numlayers - 1 - i; j++) {
+      const char *pszLegendOrder1 = msLookupHashTable(
+          &(GET_LAYER(map, map->layerorder[j + 1])->metadata), pszMetadata);
+      const char *pszLegendOrder2 = msLookupHashTable(
+          &(GET_LAYER(map, map->layerorder[j])->metadata), pszMetadata);
 
-      if(!pszLegendOrder1 || !pszLegendOrder2)
+      if (!pszLegendOrder1 || !pszLegendOrder2)
         continue;
 
       nLegendOrder1 = atoi(pszLegendOrder1);
       nLegendOrder2 = atoi(pszLegendOrder2);
 
-      if(nLegendOrder1 < nLegendOrder2) {  /* compare the two neighbors */
-        tmp = map->layerorder[j];         /* swap a[j] and a[j+1]      */
-        map->layerorder[j] = map->layerorder[j+1];
-        map->layerorder[j+1] = tmp;
+      if (nLegendOrder1 < nLegendOrder2) { /* compare the two neighbors */
+        tmp = map->layerorder[j];          /* swap a[j] and a[j+1]      */
+        map->layerorder[j] = map->layerorder[j + 1];
+        map->layerorder[j + 1] = tmp;
       }
     }
   }
@@ -455,31 +557,30 @@ static int sortLayerByMetadata(mapObj *m
 **
 ** Tag can be [TAG] or [TAG something]
 */
-char *findTag(char *pszInstr, char *pszTag)
-{
-  char *pszTag1, *pszStart=NULL;
+char *findTag(char *pszInstr, char *pszTag) {
+  char *pszTag1, *pszStart = NULL;
   char *pszTemp;
-  int done=MS_FALSE;
+  int done = MS_FALSE;
   int length;
 
-  if(!pszInstr || !pszTag) {
+  if (!pszInstr || !pszTag) {
     msSetError(MS_WEBERR, "Invalid pointer.", "findTag()");
     return NULL;
   }
 
   length = strlen(pszTag) + 1; /* adding [ character to the beginning */
-  pszTag1 = (char*) msSmallMalloc(length+1);
+  pszTag1 = (char *)msSmallMalloc(length + 1);
 
   strcpy(pszTag1, "[");
   strcat(pszTag1, pszTag);
 
   pszTemp = pszInstr;
-  while(!done) {
+  while (!done) {
     pszStart = strstr(pszTemp, pszTag1);
 
-    if(pszStart == NULL)
+    if (pszStart == NULL)
       done = MS_TRUE; /* tag not found */
-    else if((*(pszStart+length) == ']' || *(pszStart+length) == ' '))
+    else if ((*(pszStart + length) == ']' || *(pszStart + length) == ' '))
       done = MS_TRUE; /* valid tag */
     else
       pszTemp += length; /* skip ahead and start over */
@@ -499,14 +600,12 @@ char *findTag(char *pszInstr, char *pszT
 ** Return NULL if not found.
 */
 
-char *findTagEnd(const char *pszTag)
-{
-  char *pszEnd = NULL,
-        *pszTmp = (char*)pszTag;
+char *findTagEnd(const char *pszTag) {
+  char *pszEnd = NULL, *pszTmp = (char *)pszTag;
 
   while (pszTmp != NULL) {
     if (*pszTmp == '"')
-      pszTmp = strchr(pszTmp+1,'"');
+      pszTmp = strchr(pszTmp + 1, '"');
     if ((pszTmp == NULL) || (*pszTmp == ']')) {
       pszEnd = pszTmp;
       pszTmp = NULL;
@@ -521,15 +620,14 @@ char *findTagEnd(const char *pszTag)
 ** Return a hashtableobj from instr of all
 ** arguments. hashtable must be freed by caller.
 */
-int getTagArgs(char* pszTag, char* pszInstr, hashTableObj **ppoHashTable)
-{
+int getTagArgs(char *pszTag, char *pszInstr, hashTableObj **ppoHashTable) {
   char *pszStart, *pszEnd, *pszArgs;
   int nLength;
   char **papszArgs, **papszVarVal;
   int nArgs, nDummy;
   int i;
 
-  if(!pszTag || !pszInstr) {
+  if (!pszTag || !pszInstr) {
     msSetError(MS_WEBERR, "Invalid pointer.", "getTagArgs()");
     return MS_FAILURE;
   }
@@ -537,38 +635,38 @@ int getTagArgs(char* pszTag, char* pszIn
   /* set position to the begining of tag */
   pszStart = findTag(pszInstr, pszTag);
 
-  if(pszStart) {
+  if (pszStart) {
     /* find ending position */
     pszEnd = findTagEnd(pszStart);
 
-    if(pszEnd) {
+    if (pszEnd) {
       /* skip the tag name */
       pszStart = pszStart + strlen(pszTag) + 1;
 
       /* get length of all args */
       nLength = pszEnd - pszStart;
 
-      if(nLength > 0) { /* is there arguments ? */
-        pszArgs = (char*)msSmallMalloc(nLength + 1);
-        strlcpy(pszArgs, pszStart, nLength+1);
+      if (nLength > 0) { /* is there arguments ? */
+        pszArgs = (char *)msSmallMalloc(nLength + 1);
+        strlcpy(pszArgs, pszStart, nLength + 1);
 
-        if(!(*ppoHashTable))
+        if (!(*ppoHashTable))
           *ppoHashTable = msCreateHashTable();
 
         /* put all arguments seperate by space in a hash table */
         papszArgs = msStringTokenize(pszArgs, " ", &nArgs, MS_TRUE);
 
         /* msReturnTemplateQuerycheck all argument if they have values */
-        for (i=0; i<nArgs; i++) {
-          if(strlen(papszArgs[i]) == 0) {
+        for (i = 0; i < nArgs; i++) {
+          if (strlen(papszArgs[i]) == 0) {
             free(papszArgs[i]);
             continue;
           }
 
-          if(strchr(papszArgs[i], '=')) {
-            papszVarVal = msStringTokenize(papszArgs[i], "=", &nDummy, MS_FALSE);
-            msInsertHashTable(*ppoHashTable, papszVarVal[0],
-                              papszVarVal[1]);
+          if (strchr(papszArgs[i], '=')) {
+            papszVarVal =
+                msStringTokenize(papszArgs[i], "=", &nDummy, MS_FALSE);
+            msInsertHashTable(*ppoHashTable, papszVarVal[0], papszVarVal[1]);
             free(papszVarVal[0]);
             free(papszVarVal[1]);
             free(papszVarVal);
@@ -592,66 +690,66 @@ int getTagArgs(char* pszTag, char* pszIn
 ** pszNextInstr will be a pointer at the end of the
 ** first occurence found.
 */
-int getInlineTag(char *pszTag, char *pszInstr, char **pszResult)
-{
-  char *pszStart, *pszEnd=NULL,  *pszEndTag, *pszPatIn, *pszPatOut=NULL, *pszTmp;
-  int nInst=0;
+int getInlineTag(char *pszTag, char *pszInstr, char **pszResult) {
+  char *pszStart, *pszEnd = NULL, *pszEndTag, *pszPatIn, *pszPatOut = NULL,
+                  *pszTmp;
+  int nInst = 0;
   int nLength;
 
   *pszResult = NULL;
 
-  if(!pszInstr || !pszTag) {
+  if (!pszInstr || !pszTag) {
     msSetError(MS_WEBERR, "Invalid pointer.", "getInlineTag()");
     return MS_FAILURE;
   }
 
-  pszEndTag = (char*)msSmallMalloc(strlen(pszTag) + 3);
+  pszEndTag = (char *)msSmallMalloc(strlen(pszTag) + 3);
   strcpy(pszEndTag, "[/");
   strcat(pszEndTag, pszTag);
 
   /* find start tag */
-  pszPatIn  = findTag(pszInstr, pszTag);
+  pszPatIn = findTag(pszInstr, pszTag);
   pszPatOut = strstr(pszInstr, pszEndTag);
 
   pszStart = pszPatIn;
 
   pszTmp = pszInstr;
 
-  if(pszPatIn) {
+  if (pszPatIn) {
     do {
-      if(pszPatIn && pszPatIn < pszPatOut) {
+      if (pszPatIn && pszPatIn < pszPatOut) {
         nInst++;
 
         pszTmp = pszPatIn;
       }
 
-      if(pszPatOut && ((pszPatIn == NULL) || pszPatOut < pszPatIn)) {
+      if (pszPatOut && ((pszPatIn == NULL) || pszPatOut < pszPatIn)) {
         pszEnd = pszPatOut;
         nInst--;
 
         pszTmp = pszPatOut;
       }
 
-      pszPatIn  = findTag(pszTmp+1, pszTag);
-      pszPatOut = strstr(pszTmp+1, pszEndTag);
+      pszPatIn = findTag(pszTmp + 1, pszTag);
+      pszPatOut = strstr(pszTmp + 1, pszEndTag);
 
     } while (pszTmp != NULL && nInst > 0);
   }
 
-  if(pszStart && pszEnd) {
+  if (pszStart && pszEnd) {
     /* find end of start tag */
     pszStart = strchr(pszStart, ']');
 
-    if(pszStart) {
+    if (pszStart) {
       pszStart++;
 
       nLength = pszEnd - pszStart;
 
-      if(nLength > 0) {
-        *pszResult = (char*)msSmallMalloc(nLength + 1);
+      if (nLength > 0) {
+        *pszResult = (char *)msSmallMalloc(nLength + 1);
 
         /* copy string beetween start and end tag */
-        strlcpy(*pszResult, pszStart, nLength+1);
+        strlcpy(*pszResult, pszStart, nLength + 1);
 
         (*pszResult)[nLength] = '\0';
       }
@@ -674,59 +772,58 @@ int getInlineTag(char *pszTag, char *psz
  *
  * If bLastPass is true then all tests for 'null' values will be
  * considered true if the corresponding value is not set.
-*/
-int processIfTag(char **pszInstr, hashTableObj *ht, int bLastPass)
-{
+ */
+int processIfTag(char **pszInstr, hashTableObj *ht, int bLastPass) {
   /*   char *pszNextInstr = pszInstr; */
-  char *pszStart, *pszEnd=NULL;
+  char *pszStart, *pszEnd = NULL;
   const char *pszName, *pszValue, *pszOperator, *pszHTValue;
-  char *pszThen=NULL;
+  char *pszThen = NULL;
   char *pszIfTag;
-  char *pszPatIn=NULL, *pszPatOut=NULL, *pszTmp;
+  char *pszPatIn = NULL, *pszPatOut = NULL, *pszTmp;
   int nInst = 0;
   int nLength;
 
-  hashTableObj *ifArgs=NULL;
+  hashTableObj *ifArgs = NULL;
 
-  if(!*pszInstr) {
+  if (!*pszInstr) {
     msSetError(MS_WEBERR, "Invalid pointer.", "processIfTag()");
     return MS_FAILURE;
   }
 
   /* find the if start tag */
 
-  pszStart  = findTag(*pszInstr, "if");
+  pszStart = findTag(*pszInstr, "if");
 
   while (pszStart) {
-    pszPatIn  = findTag(pszStart, "if");
+    pszPatIn = findTag(pszStart, "if");
     pszPatOut = strstr(pszStart, "[/if]");
     pszTmp = pszPatIn;
 
     do {
-      if(pszPatIn && pszPatIn < pszPatOut) {
+      if (pszPatIn && pszPatIn < pszPatOut) {
         nInst++;
         pszTmp = pszPatIn;
       }
 
-      if(pszPatOut && ((pszPatIn == NULL) || pszPatOut < pszPatIn)) {
+      if (pszPatOut && ((pszPatIn == NULL) || pszPatOut < pszPatIn)) {
         pszEnd = pszPatOut;
         nInst--;
         pszTmp = pszPatOut;
       }
 
-      pszPatIn  = findTag(pszTmp+1, "if");
-      pszPatOut = strstr(pszTmp+1, "[/if]");
+      pszPatIn = findTag(pszTmp + 1, "if");
+      pszPatOut = strstr(pszTmp + 1, "[/if]");
 
     } while (nInst > 0);
 
     /* get the then string (if expression is true) */
-    if(getInlineTag("if", pszStart, &pszThen) != MS_SUCCESS) {
+    if (getInlineTag("if", pszStart, &pszThen) != MS_SUCCESS) {
       msSetError(MS_WEBERR, "Malformed then if tag.", "processIfTag()");
       return MS_FAILURE;
     }
 
     /* retrieve if tag args */
-    if(getTagArgs("if", pszStart, &ifArgs) != MS_SUCCESS) {
+    if (getTagArgs("if", pszStart, &ifArgs) != MS_SUCCESS) {
       msSetError(MS_WEBERR, "Malformed args if tag.", "processIfTag()");
       return MS_FAILURE;
     }
@@ -734,57 +831,58 @@ int processIfTag(char **pszInstr, hashTa
     pszName = msLookupHashTable(ifArgs, "name");
     pszValue = msLookupHashTable(ifArgs, "value");
     pszOperator = msLookupHashTable(ifArgs, "oper");
-    if(pszOperator == NULL) /* Default operator if not set is "eq" */
+    if (pszOperator == NULL) /* Default operator if not set is "eq" */
       pszOperator = "eq";
 
     int bEmpty = 0;
 
-    if(pszName) {
+    if (pszName) {
       /* build the complete if tag ([if all_args]then string[/if]) */
       /* to replace if by then string if expression is true */
       /* or by a white space if not. */
       nLength = pszEnd - pszStart;
-      pszIfTag = (char*)msSmallMalloc(nLength + 6);
-      strlcpy(pszIfTag, pszStart, nLength+1);
+      pszIfTag = (char *)msSmallMalloc(nLength + 6);
+      strlcpy(pszIfTag, pszStart, nLength + 1);
       pszIfTag[nLength] = '\0';
       strcat(pszIfTag, "[/if]");
 
       pszHTValue = msLookupHashTable(ht, pszName);
 
-      if(strcmp(pszOperator, "neq") == 0) {
-        if(pszValue && pszHTValue && strcasecmp(pszValue, pszHTValue) != 0) {
+      if (strcmp(pszOperator, "neq") == 0) {
+        if (pszValue && pszHTValue && strcasecmp(pszValue, pszHTValue) != 0) {
           *pszInstr = msReplaceSubstring(*pszInstr, pszIfTag, pszThen);
-        } else if(pszHTValue) {
+        } else if (pszHTValue) {
           *pszInstr = msReplaceSubstring(*pszInstr, pszIfTag, "");
           bEmpty = 1;
         }
-      } else if(strcmp(pszOperator, "eq") == 0) {
-        if(pszValue && pszHTValue && strcasecmp(pszValue, pszHTValue) == 0) {
+      } else if (strcmp(pszOperator, "eq") == 0) {
+        if (pszValue && pszHTValue && strcasecmp(pszValue, pszHTValue) == 0) {
           *pszInstr = msReplaceSubstring(*pszInstr, pszIfTag, pszThen);
-        } else if(pszHTValue) {
+        } else if (pszHTValue) {
           *pszInstr = msReplaceSubstring(*pszInstr, pszIfTag, "");
           bEmpty = 1;
         }
-      } else if(strcmp(pszOperator, "isnull") == 0) {
-        if(pszHTValue != NULL) {
+      } else if (strcmp(pszOperator, "isnull") == 0) {
+        if (pszHTValue != NULL) {
           /* We met a non-null value... condition is false */
           *pszInstr = msReplaceSubstring(*pszInstr, pszIfTag, "");
           bEmpty = 1;
-        } else if(bLastPass) {
+        } else if (bLastPass) {
           /* On last pass, if value is still null then condition is true */
           *pszInstr = msReplaceSubstring(*pszInstr, pszIfTag, pszThen);
         }
-      } else if(strcmp(pszOperator, "isset") == 0) {
-        if(pszHTValue != NULL) {
+      } else if (strcmp(pszOperator, "isset") == 0) {
+        if (pszHTValue != NULL) {
           /* Found a non-null value... condition is true */
           *pszInstr = msReplaceSubstring(*pszInstr, pszIfTag, pszThen);
-        } else if(bLastPass) {
+        } else if (bLastPass) {
           /* On last pass, if value still not set then condition is false */
           *pszInstr = msReplaceSubstring(*pszInstr, pszIfTag, "");
           bEmpty = 1;
         }
       } else {
-        msSetError(MS_WEBERR, "Unsupported operator (%s) in if tag.",  "processIfTag()", pszOperator);
+        msSetError(MS_WEBERR, "Unsupported operator (%s) in if tag.",
+                   "processIfTag()", pszOperator);
         return MS_FAILURE;
       }
 
@@ -792,16 +890,16 @@ int processIfTag(char **pszInstr, hashTa
       pszIfTag = NULL;
     }
 
-    if(pszThen)
-      free (pszThen);
+    if (pszThen)
+      free(pszThen);
 
-    pszThen=NULL;
+    pszThen = NULL;
 
     msFreeHashTable(ifArgs);
-    ifArgs=NULL;
+    ifArgs = NULL;
 
     /* find the if start tag */
-    if(bEmpty)
+    if (bEmpty)
       pszStart = findTag(pszStart, "if");
     else
       pszStart = findTag(pszStart + 1, "if");
@@ -811,26 +909,26 @@ int processIfTag(char **pszInstr, hashTa
 }
 
 /* Helper function to return the text before the supplied string2 in string1. */
-static char *getPreTagText(const char *string1, const char *string2)
-{
+static char *getPreTagText(const char *string1, const char *string2) {
   int n;
   char *result, *tmpstr;
 
-  if((tmpstr = strstr(string1, string2)) == NULL) return msStrdup(""); /* return an empty string */
+  if ((tmpstr = strstr(string1, string2)) == NULL)
+    return msStrdup(""); /* return an empty string */
 
   n = strlen(string1) - strlen(tmpstr);
-  result = (char *) msSmallMalloc(n + 1);
-  strlcpy(result, string1, n+1);
+  result = (char *)msSmallMalloc(n + 1);
+  strlcpy(result, string1, n + 1);
 
   return result;
 }
 
 /* Helper function to retunr the text after the supplied string2 in string1. */
-static char *getPostTagText(const char *string1, const char *string2)
-{
+static char *getPostTagText(const char *string1, const char *string2) {
   char *tmpstr;
 
-  if((tmpstr = strstr(string1, string2)) == NULL) return msStrdup(""); /* return an empty string */
+  if ((tmpstr = strstr(string1, string2)) == NULL)
+    return msStrdup(""); /* return an empty string */
 
   tmpstr += strlen(string2); /* skip string2 */
   return msStrdup(tmpstr);
@@ -840,44 +938,50 @@ static char *getPostTagText(const char *
 ** Function to process a [feature ...] tag. This tag can *only* be found within
 ** a [resultset ...][/resultset] block.
 */
-static int processFeatureTag(mapservObj *mapserv, char **line, layerObj *layer)
-{
+static int processFeatureTag(mapservObj *mapserv, char **line,
+                             layerObj *layer) {
   char *preTag, *postTag; /* text before and after the tag */
 
   const char *argValue;
   char *tag, *tagInstance, *tagStart;
-  hashTableObj *tagArgs=NULL;
+  hashTableObj *tagArgs = NULL;
 
-  int limit=-1;
-  const char *trimLast=NULL;
+  int limit = -1;
+  const char *trimLast = NULL;
 
   int i, j, status;
 
-  if(!*line) {
+  if (!*line) {
     msSetError(MS_WEBERR, "Invalid line pointer.", "processFeatureTag()");
-    return(MS_FAILURE);
+    return (MS_FAILURE);
   }
 
   tagStart = findTag(*line, "feature");
-  if(!tagStart) return(MS_SUCCESS); /* OK, just return; */
+  if (!tagStart)
+    return (MS_SUCCESS); /* OK, just return; */
 
   /* check for any tag arguments */
-  if(getTagArgs("feature", tagStart, &tagArgs) != MS_SUCCESS) return(MS_FAILURE);
-  if(tagArgs) {
+  if (getTagArgs("feature", tagStart, &tagArgs) != MS_SUCCESS)
+    return (MS_FAILURE);
+  if (tagArgs) {
     argValue = msLookupHashTable(tagArgs, "limit");
-    if(argValue) limit = atoi(argValue);
+    if (argValue)
+      limit = atoi(argValue);
 
     argValue = msLookupHashTable(tagArgs, "trimlast");
-    if(argValue) trimLast = argValue;
+    if (argValue)
+      trimLast = argValue;
   }
 
-  if(strstr(*line, "[/feature]") == NULL) { /* we know the closing tag must be here, if not throw an error */
-    msSetError(MS_WEBERR, "[feature] tag found without closing [/feature].", "processFeatureTag()");
+  if (strstr(*line, "[/feature]") ==
+      NULL) { /* we know the closing tag must be here, if not throw an error */
+    msSetError(MS_WEBERR, "[feature] tag found without closing [/feature].",
+               "processFeatureTag()");
     msFreeHashTable(tagArgs);
-    return(MS_FAILURE);
+    return (MS_FAILURE);
   }
 
-  if(getInlineTag("feature", *line, &tag) != MS_SUCCESS) {
+  if (getInlineTag("feature", *line, &tag) != MS_SUCCESS) {
     msSetError(MS_WEBERR, "Malformed feature tag.", "processFeatureTag()");
     msFreeHashTable(tagArgs);
     return MS_FAILURE;
@@ -899,10 +1003,10 @@ static int processFeatureTag(mapservObj
   if(status != MS_SUCCESS) return status;
 #endif
 
-  if(layer->numjoins > 0) { /* initialize necessary JOINs here */
-    for(j=0; j<layer->numjoins; j++) {
+  if (layer->numjoins > 0) { /* initialize necessary JOINs here */
+    for (j = 0; j < layer->numjoins; j++) {
       status = msJoinConnect(layer, &(layer->joins[j]));
-      if(status != MS_SUCCESS) {
+      if (status != MS_SUCCESS) {
         msFreeHashTable(tagArgs);
         msFree(postTag);
         msFree(tag);
@@ -915,26 +1019,28 @@ static int processFeatureTag(mapservObj
   mapserv->resultlayer = layer;
   msInitShape(&(mapserv->resultshape));
 
-  if(limit == -1) /* return all */
+  if (limit == -1) /* return all */
     limit = layer->resultcache->numresults;
   else
     limit = MS_MIN(limit, layer->resultcache->numresults);
 
-  for(i=0; i<limit; i++) {
-    status = msLayerGetShape(layer, &(mapserv->resultshape), &(layer->resultcache->results[i]));
-    if(status != MS_SUCCESS) {
+  for (i = 0; i < limit; i++) {
+    status = msLayerGetShape(layer, &(mapserv->resultshape),
+                             &(layer->resultcache->results[i]));
+    if (status != MS_SUCCESS) {
       msFreeHashTable(tagArgs);
       msFree(postTag);
       msFree(tag);
       return status;
     }
 
-    mapserv->resultshape.classindex = msShapeGetClass(layer, layer->map, &mapserv->resultshape,  NULL, -1);
+    mapserv->resultshape.classindex =
+        msShapeGetClass(layer, layer->map, &mapserv->resultshape, NULL, -1);
 
     /* prepare any necessary JOINs here (one-to-one only) */
-    if(layer->numjoins > 0) {
-      for(j=0; j<layer->numjoins; j++) {
-        if(layer->joins[j].type == MS_JOIN_ONE_TO_ONE) {
+    if (layer->numjoins > 0) {
+      for (j = 0; j < layer->numjoins; j++) {
+        if (layer->joins[j].type == MS_JOIN_ONE_TO_ONE) {
           msJoinPrepare(&(layer->joins[j]), &(mapserv->resultshape));
           msJoinNext(&(layer->joins[j])); /* fetch the first row */
         }
@@ -944,15 +1050,15 @@ static int processFeatureTag(mapservObj
     /*
     ** if necessary trim a few characters off the end of the tag
     */
-    if(trimLast && (i == limit-1)) {
+    if (trimLast && (i == limit - 1)) {
       char *ptr;
-      if((ptr = strrstr(tag, trimLast)) != NULL)
+      if ((ptr = strrstr(tag, trimLast)) != NULL)
         *ptr = '\0';
     }
 
     /* process the tag */
     tagInstance = processLine(mapserv, tag, NULL, QUERY); /* do substitutions */
-    *line = msStringConcatenate(*line, tagInstance); /* grow the line */
+    *line = msStringConcatenate(*line, tagInstance);      /* grow the line */
 
     free(tagInstance);
     msFreeShape(&(mapserv->resultshape)); /* init too */
@@ -973,105 +1079,113 @@ static int processFeatureTag(mapservObj
   free(tag);
   msFreeHashTable(tagArgs);
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
 /*
 ** Function to process a [resultset ...] tag.
 */
-static int processResultSetTag(mapservObj *mapserv, char **line, FILE *stream)
-{
+static int processResultSetTag(mapservObj *mapserv, char **line, FILE *stream) {
   char lineBuffer[MS_BUFFER_LENGTH];
   int foundTagEnd;
 
   char *preTag, *postTag; /* text before and after the tag */
 
   char *tag, *tagStart;
-  hashTableObj *tagArgs=NULL;
+  hashTableObj *tagArgs = NULL;
 
-  const char *layerName=NULL;
-  const char *nodata=NULL;
+  const char *layerName = NULL;
+  const char *nodata = NULL;
 
   layerObj *lp;
 
-  if(!*line) {
+  if (!*line) {
     msSetError(MS_WEBERR, "Invalid line pointer.", "processResultSetTag()");
-    return(MS_FAILURE);
+    return (MS_FAILURE);
   }
 
   tagStart = findTag(*line, "resultset");
-  if(!tagStart) return(MS_SUCCESS); /* OK, just return; */
+  if (!tagStart)
+    return (MS_SUCCESS); /* OK, just return; */
 
   while (tagStart) {
     /* initialize the tag arguments */
     layerName = NULL;
 
-
     /* check for any tag arguments */
-    if(getTagArgs("resultset", tagStart, &tagArgs) != MS_SUCCESS) return(MS_FAILURE);
-    if(tagArgs) {
+    if (getTagArgs("resultset", tagStart, &tagArgs) != MS_SUCCESS)
+      return (MS_FAILURE);
+    if (tagArgs) {
       layerName = msLookupHashTable(tagArgs, "layer");
       nodata = msLookupHashTable(tagArgs, "nodata");
     }
 
-    if(!layerName) {
-      msSetError(MS_WEBERR, "[resultset] tag missing required 'layer' argument.", "processResultSetTag()");
+    if (!layerName) {
+      msSetError(MS_WEBERR,
+                 "[resultset] tag missing required 'layer' argument.",
+                 "processResultSetTag()");
       msFreeHashTable(tagArgs);
-      return(MS_FAILURE);
+      return (MS_FAILURE);
     }
 
     const int layerIndex = msGetLayerIndex(mapserv->map, layerName);
-    if(layerIndex>=mapserv->map->numlayers || layerIndex<0) {
-      msSetError(MS_MISCERR, "Layer named '%s' does not exist.", "processResultSetTag()", layerName);
+    if (layerIndex >= mapserv->map->numlayers || layerIndex < 0) {
+      msSetError(MS_MISCERR, "Layer named '%s' does not exist.",
+                 "processResultSetTag()", layerName);
       msFreeHashTable(tagArgs);
       return MS_FAILURE;
     }
     lp = GET_LAYER(mapserv->map, layerIndex);
 
-    if(strstr(*line, "[/resultset]") == NULL) { /* read ahead */
-      if(!stream) {
+    if (strstr(*line, "[/resultset]") == NULL) { /* read ahead */
+      if (!stream) {
         msSetError(MS_WEBERR, "Invalid file pointer.", "processResultSetTag()");
         msFreeHashTable(tagArgs);
-        return(MS_FAILURE);
+        return (MS_FAILURE);
       }
 
       foundTagEnd = MS_FALSE;
-      while(!foundTagEnd) {
-        if(fgets(lineBuffer, MS_BUFFER_LENGTH, stream) != NULL) {
+      while (!foundTagEnd) {
+        if (fgets(lineBuffer, MS_BUFFER_LENGTH, stream) != NULL) {
           *line = msStringConcatenate(*line, lineBuffer);
-          if(strstr(*line, "[/resultset]") != NULL)
+          if (strstr(*line, "[/resultset]") != NULL)
             foundTagEnd = MS_TRUE;
         } else
           break; /* ran out of file */
       }
-      if(foundTagEnd == MS_FALSE) {
-        msSetError(MS_WEBERR, "[resultset] tag found without closing [/resultset].", "processResultSetTag()");
+      if (foundTagEnd == MS_FALSE) {
+        msSetError(MS_WEBERR,
+                   "[resultset] tag found without closing [/resultset].",
+                   "processResultSetTag()");
         msFreeHashTable(tagArgs);
-        return(MS_FAILURE);
+        return (MS_FAILURE);
       }
     }
 
-    if(getInlineTag("resultset", *line, &tag) != MS_SUCCESS) {
-      msSetError(MS_WEBERR, "Malformed resultset tag.", "processResultSetTag()");
+    if (getInlineTag("resultset", *line, &tag) != MS_SUCCESS) {
+      msSetError(MS_WEBERR, "Malformed resultset tag.",
+                 "processResultSetTag()");
       msFreeHashTable(tagArgs);
       return MS_FAILURE;
     }
 
-    preTag = getPreTagText(*line, "[resultset"); /* TODO: need to handle tags in these */
+    preTag = getPreTagText(
+        *line, "[resultset"); /* TODO: need to handle tags in these */
     postTag = getPostTagText(*line, "[/resultset]");
 
     /* start rebuilding **line */
     free(*line);
     *line = preTag;
 
-    if(lp->resultcache && lp->resultcache->numresults > 0) {
-      /* probably will need a while-loop here to handle multiple instances of [feature ...] tags */
-      if(processFeatureTag(mapserv, &tag, lp) != MS_SUCCESS) {
+    if (lp->resultcache && lp->resultcache->numresults > 0) {
+      /* probably will need a while-loop here to handle multiple instances of
+       * [feature ...] tags */
+      if (processFeatureTag(mapserv, &tag, lp) != MS_SUCCESS) {
         msFreeHashTable(tagArgs);
-        return(MS_FAILURE); /* TODO: how to handle */
+        return (MS_FAILURE); /* TODO: how to handle */
       }
       *line = msStringConcatenate(*line, tag);
-    } else if(nodata) {
+    } else if (nodata) {
       *line = msStringConcatenate(*line, nodata);
     }
 
@@ -1085,7 +1199,7 @@ static int processResultSetTag(mapservOb
   }
   msFreeHashTable(tagArgs);
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
 /*
@@ -1094,50 +1208,55 @@ static int processResultSetTag(mapservOb
 ** TODO's:
 **   - allow URLs
 */
-static int processIncludeTag(mapservObj *mapserv, char **line, FILE *stream, int mode)
-{
+static int processIncludeTag(mapservObj *mapserv, char **line, FILE *stream,
+                             int mode) {
   char *tag, *tagStart, *tagEnd;
-  hashTableObj *tagArgs=NULL;
+  hashTableObj *tagArgs = NULL;
   int tagOffset, tagLength;
 
-  char *content=NULL, *processedContent=NULL;
-  const char *src=NULL;
+  char *content = NULL, *processedContent = NULL;
+  const char *src = NULL;
 
   FILE *includeStream;
   char buffer[MS_BUFFER_LENGTH], path[MS_MAXPATHLEN];
 
-  if(!*line) {
+  if (!*line) {
     msSetError(MS_WEBERR, "Invalid line pointer.", "processIncludeTag()");
-    return(MS_FAILURE);
+    return (MS_FAILURE);
   }
 
   tagStart = findTag(*line, "include");
 
   /* It is OK to have no include tags, just return. */
-  if( !tagStart ) return MS_SUCCESS;
+  if (!tagStart)
+    return MS_SUCCESS;
 
-  while( tagStart ) {
+  while (tagStart) {
     tagOffset = tagStart - *line;
 
     /* check for any tag arguments */
-    if(getTagArgs("include", tagStart, &tagArgs) != MS_SUCCESS) return(MS_FAILURE);
-    if(tagArgs) {
+    if (getTagArgs("include", tagStart, &tagArgs) != MS_SUCCESS)
+      return (MS_FAILURE);
+    if (tagArgs) {
       src = msLookupHashTable(tagArgs, "src");
     }
 
-    if(!src) return(MS_SUCCESS); /* don't process the tag, could be something else so return MS_SUCCESS */
+    if (!src)
+      return (MS_SUCCESS); /* don't process the tag, could be something else so
+                              return MS_SUCCESS */
 
-    if((includeStream = fopen(msBuildPath(path, mapserv->map->mappath, src), "r")) == NULL) {
+    if ((includeStream = fopen(msBuildPath(path, mapserv->map->mappath, src),
+                               "r")) == NULL) {
       msSetError(MS_IOERR, "%s", "processIncludeTag()", src);
       return MS_FAILURE;
     }
 
-    if(isValidTemplate(includeStream, src) != MS_TRUE) {
+    if (isValidTemplate(includeStream, src) != MS_TRUE) {
       fclose(includeStream);
       return MS_FAILURE;
     }
 
-    while(fgets(buffer, MS_BUFFER_LENGTH, includeStream) != NULL)
+    while (fgets(buffer, MS_BUFFER_LENGTH, includeStream) != NULL)
       content = msStringConcatenate(content, buffer);
 
     /* done with included file handle */
@@ -1149,8 +1268,8 @@ static int processIncludeTag(mapservObj
 
     /* build the complete tag so we can do substitution */
     tagLength = tagEnd - tagStart;
-    tag = (char *) msSmallMalloc(tagLength + 1);
-    strlcpy(tag, tagStart, tagLength+1);
+    tag = (char *)msSmallMalloc(tagLength + 1);
+    strlcpy(tag, tagStart, tagLength + 1);
 
     /* process any other tags in the content */
     processedContent = processLine(mapserv, content, stream, mode);
@@ -1162,50 +1281,51 @@ static int processIncludeTag(mapservObj
     free(tag);
     tag = NULL;
     msFreeHashTable(tagArgs);
-    tagArgs=NULL;
+    tagArgs = NULL;
     free(content);
     free(processedContent);
 
-    if((*line)[tagOffset] != '\0')
-      tagStart = findTag(*line+tagOffset+1, "include");
+    if ((*line)[tagOffset] != '\0')
+      tagStart = findTag(*line + tagOffset + 1, "include");
     else
       tagStart = NULL;
   }
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
 /*
-** Function to process an [item ...] tag: line contains the tag, shape holds the attributes.
+** Function to process an [item ...] tag: line contains the tag, shape holds the
+*attributes.
 */
-enum ITEM_ESCAPING {ESCAPE_HTML, ESCAPE_URL, ESCAPE_JSON, ESCAPE_NONE};
+enum ITEM_ESCAPING { ESCAPE_HTML, ESCAPE_URL, ESCAPE_JSON, ESCAPE_NONE };
 
-static int processItemTag(layerObj *layer, char **line, shapeObj *shape)
-{
+static int processItemTag(layerObj *layer, char **line, shapeObj *shape) {
   int i;
 
   char *tag, *tagStart, *tagEnd;
-  hashTableObj *tagArgs=NULL;
+  hashTableObj *tagArgs = NULL;
   int tagLength;
-  char *encodedTagValue=NULL, *tagValue=NULL;
+  char *encodedTagValue = NULL, *tagValue = NULL;
 
-  const char *argValue=NULL;
+  const char *argValue = NULL;
 
-  const char *name=NULL, *pattern=NULL;
-  const char *format=NULL, *nullFormat=NULL;
+  const char *name = NULL, *pattern = NULL;
+  const char *format = NULL, *nullFormat = NULL;
   int precision;
   int padding;
   int uc, lc, commify;
   int escape;
 
-  if(!*line) {
+  if (!*line) {
     msSetError(MS_WEBERR, "Invalid line pointer.", "processItemTag()");
-    return(MS_FAILURE);
+    return (MS_FAILURE);
   }
 
   tagStart = findTag(*line, "item");
 
-  if(!tagStart) return(MS_SUCCESS); /* OK, just return; */
+  if (!tagStart)
+    return (MS_SUCCESS); /* OK, just return; */
 
   while (tagStart) {
     format = "$value"; /* initialize the tag arguments */
@@ -1214,104 +1334,124 @@ static int processItemTag(layerObj *laye
     padding = -1;
     name = pattern = NULL;
     uc = lc = commify = MS_FALSE;
-    escape=ESCAPE_HTML;
+    escape = ESCAPE_HTML;
 
     /* check for any tag arguments */
-    if(getTagArgs("item", tagStart, &tagArgs) != MS_SUCCESS) return(MS_FAILURE);
-    if(tagArgs) {
+    if (getTagArgs("item", tagStart, &tagArgs) != MS_SUCCESS)
+      return (MS_FAILURE);
+    if (tagArgs) {
       argValue = msLookupHashTable(tagArgs, "name");
-      if(argValue) name = argValue;
+      if (argValue)
+        name = argValue;
 
       argValue = msLookupHashTable(tagArgs, "pattern");
-      if(argValue) pattern = argValue;
+      if (argValue)
+        pattern = argValue;
 
       argValue = msLookupHashTable(tagArgs, "precision");
-      if(argValue) precision = atoi(argValue);
+      if (argValue)
+        precision = atoi(argValue);
 
       argValue = msLookupHashTable(tagArgs, "padding");
-      if (argValue) padding = atoi(argValue);
+      if (argValue)
+        padding = atoi(argValue);
 
       argValue = msLookupHashTable(tagArgs, "format");
-      if(argValue) format = argValue;
+      if (argValue)
+        format = argValue;
 
       argValue = msLookupHashTable(tagArgs, "nullformat");
-      if(argValue) nullFormat = argValue;
+      if (argValue)
+        nullFormat = argValue;
 
       argValue = msLookupHashTable(tagArgs, "uc");
-      if(argValue && strcasecmp(argValue, "true") == 0) uc = MS_TRUE;
+      if (argValue && strcasecmp(argValue, "true") == 0)
+        uc = MS_TRUE;
 
       argValue = msLookupHashTable(tagArgs, "lc");
-      if(argValue && strcasecmp(argValue, "true") == 0) lc = MS_TRUE;
+      if (argValue && strcasecmp(argValue, "true") == 0)
+        lc = MS_TRUE;
 
       argValue = msLookupHashTable(tagArgs, "commify");
-      if(argValue && strcasecmp(argValue, "true") == 0) commify = MS_TRUE;
+      if (argValue && strcasecmp(argValue, "true") == 0)
+        commify = MS_TRUE;
 
       argValue = msLookupHashTable(tagArgs, "escape");
-      if(argValue && strcasecmp(argValue, "url") == 0) escape = ESCAPE_URL;
-      else if(argValue && strcasecmp(argValue, "none") == 0) escape = ESCAPE_NONE;
-      else if(argValue && strcasecmp(argValue, "json") == 0) escape = ESCAPE_JSON;
+      if (argValue && strcasecmp(argValue, "url") == 0)
+        escape = ESCAPE_URL;
+      else if (argValue && strcasecmp(argValue, "none") == 0)
+        escape = ESCAPE_NONE;
+      else if (argValue && strcasecmp(argValue, "json") == 0)
+        escape = ESCAPE_JSON;
 
       /* TODO: deal with sub strings */
     }
 
-    if(!name) {
-      msSetError(MS_WEBERR, "Item tag contains no name attribute.", "processItemTag()");
-      return(MS_FAILURE);
+    if (!name) {
+      msSetError(MS_WEBERR, "Item tag contains no name attribute.",
+                 "processItemTag()");
+      return (MS_FAILURE);
     }
 
-    for(i=0; i<layer->numitems; i++)
-      if(strcasecmp(name, layer->items[i]) == 0) break;
+    for (i = 0; i < layer->numitems; i++)
+      if (strcasecmp(name, layer->items[i]) == 0)
+        break;
 
-    if(i == layer->numitems) {
-      msSetError(MS_WEBERR, "Item name (%s) not found in layer item list.", "processItemTag()", name);
-      return(MS_FAILURE);
+    if (i == layer->numitems) {
+      msSetError(MS_WEBERR, "Item name (%s) not found in layer item list.",
+                 "processItemTag()", name);
+      return (MS_FAILURE);
     }
 
     /*
     ** now we know which item so build the tagValue
     */
-    if(shape->values[i] && strlen(shape->values[i]) > 0) {
-      char *itemValue=NULL;
+    if (shape->values[i] && strlen(shape->values[i]) > 0) {
+      char *itemValue = NULL;
 
-      /* set tag text depending on pattern (if necessary), nullFormat can contain $value (#3637) */
-      if(pattern && msEvalRegex(pattern, shape->values[i]) != MS_TRUE)
+      /* set tag text depending on pattern (if necessary), nullFormat can
+       * contain $value (#3637) */
+      if (pattern && msEvalRegex(pattern, shape->values[i]) != MS_TRUE)
         tagValue = msStrdup(nullFormat);
       else
         tagValue = msStrdup(format);
 
-      if(precision != -1) {
+      if (precision != -1) {
         char numberFormat[16];
 
-        itemValue = (char *) msSmallMalloc(64); /* plenty big */
+        itemValue = (char *)msSmallMalloc(64); /* plenty big */
         snprintf(numberFormat, sizeof(numberFormat), "%%.%dlf", precision);
         snprintf(itemValue, 64, numberFormat, atof(shape->values[i]));
       } else
         itemValue = msStrdup(shape->values[i]);
 
-      if(commify == MS_TRUE)
+      if (commify == MS_TRUE)
         itemValue = msCommifyString(itemValue);
 
       /* apply other effects */
-      if(uc == MS_TRUE)
-        for(unsigned j=0; j<strlen(itemValue); j++) itemValue[j] = toupper(itemValue[j]);
-      if(lc == MS_TRUE)
-        for(unsigned j=0; j<strlen(itemValue); j++) itemValue[j] = tolower(itemValue[j]);
+      if (uc == MS_TRUE)
+        for (unsigned j = 0; j < strlen(itemValue); j++)
+          itemValue[j] = toupper(itemValue[j]);
+      if (lc == MS_TRUE)
+        for (unsigned j = 0; j < strlen(itemValue); j++)
+          itemValue[j] = tolower(itemValue[j]);
 
       tagValue = msReplaceSubstring(tagValue, "$value", itemValue);
       msFree(itemValue);
 
       if (padding > 0 && padding < 1000) {
-          int paddedSize = strlen(tagValue) + padding + 1;
-          char *paddedValue = NULL;
-          paddedValue = (char *) msSmallMalloc(paddedSize);
-          snprintf(paddedValue, paddedSize, "%-*s", padding, tagValue);
-          msFree(tagValue);
-          tagValue = paddedValue;
+        int paddedSize = strlen(tagValue) + padding + 1;
+        char *paddedValue = NULL;
+        paddedValue = (char *)msSmallMalloc(paddedSize);
+        snprintf(paddedValue, paddedSize, "%-*s", padding, tagValue);
+        msFree(tagValue);
+        tagValue = paddedValue;
       }
 
-      if(!tagValue) {
-        msSetError(MS_WEBERR, "Error applying item format.", "processItemTag()");
-        return(MS_FAILURE); /* todo leaking... */
+      if (!tagValue) {
+        msSetError(MS_WEBERR, "Error applying item format.",
+                   "processItemTag()");
+        return (MS_FAILURE); /* todo leaking... */
       }
     } else {
       tagValue = msStrdup(nullFormat); /* attribute value is NULL or empty */
@@ -1323,81 +1463,83 @@ static int processItemTag(layerObj *laye
 
     /* build the complete tag so we can do substitution */
     tagLength = tagEnd - tagStart;
-    tag = (char *) msSmallMalloc(tagLength + 1);
-    strlcpy(tag, tagStart, tagLength+1);
+    tag = (char *)msSmallMalloc(tagLength + 1);
+    strlcpy(tag, tagStart, tagLength + 1);
 
     /* do the replacement */
-    switch(escape) {
-      case ESCAPE_HTML:
-        encodedTagValue = msEncodeHTMLEntities(tagValue);
-        *line = msReplaceSubstring(*line, tag, encodedTagValue);
-        break;
-      case ESCAPE_JSON:
-        encodedTagValue = msEscapeJSonString(tagValue);
-        *line = msReplaceSubstring(*line, tag, encodedTagValue);
-        break;
-      case ESCAPE_URL:
-        encodedTagValue = msEncodeUrl(tagValue);
-        *line = msReplaceSubstring(*line, tag, encodedTagValue);
-        break;
-      case ESCAPE_NONE:
-        *line = msReplaceSubstring(*line, tag, tagValue);
-        break;
-      default:
-        break;
+    switch (escape) {
+    case ESCAPE_HTML:
+      encodedTagValue = msEncodeHTMLEntities(tagValue);
+      *line = msReplaceSubstring(*line, tag, encodedTagValue);
+      break;
+    case ESCAPE_JSON:
+      encodedTagValue = msEscapeJSonString(tagValue);
+      *line = msReplaceSubstring(*line, tag, encodedTagValue);
+      break;
+    case ESCAPE_URL:
+      encodedTagValue = msEncodeUrl(tagValue);
+      *line = msReplaceSubstring(*line, tag, encodedTagValue);
+      break;
+    case ESCAPE_NONE:
+      *line = msReplaceSubstring(*line, tag, tagValue);
+      break;
+    default:
+      break;
     }
 
     /* clean up */
     free(tag);
     tag = NULL;
     msFreeHashTable(tagArgs);
-    tagArgs=NULL;
+    tagArgs = NULL;
     msFree(tagValue);
-    tagValue=NULL;
+    tagValue = NULL;
     msFree(encodedTagValue);
-    encodedTagValue=NULL;
+    encodedTagValue = NULL;
 
     tagStart = findTag(*line, "item");
   }
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
 /*
-** Function process any number of MapServer extent tags (e.g. shpext, mapext, etc...).
+** Function process any number of MapServer extent tags (e.g. shpext, mapext,
+*etc...).
 */
-static int processExtentTag(mapservObj *mapserv, char **line, char *name, rectObj *extent, projectionObj *rectProj)
-{
+static int processExtentTag(mapservObj *mapserv, char **line, char *name,
+                            rectObj *extent, projectionObj *rectProj) {
   char *tag, *tagStart, *tagEnd;
-  hashTableObj *tagArgs=NULL;
+  hashTableObj *tagArgs = NULL;
   int tagOffset, tagLength;
 
-  char *encodedTagValue=NULL, *tagValue=NULL;
+  char *encodedTagValue = NULL, *tagValue = NULL;
 
   rectObj tempExtent;
 
   char number[64]; /* holds a single number in the extent */
   char numberFormat[16];
 
-  if(!*line) {
+  if (!*line) {
     msSetError(MS_WEBERR, "Invalid line pointer.", "processExtentTag()");
-    return(MS_FAILURE);
+    return (MS_FAILURE);
   }
 
   tagStart = findTag(*line, name); /* this supports any extent */
 
   /* It is OK to have no include tags, just return. */
-  if(!tagStart) return MS_SUCCESS;
+  if (!tagStart)
+    return MS_SUCCESS;
 
-  while(tagStart) {
+  while (tagStart) {
     double xExpand = 0, yExpand = 0; /* set tag argument defaults */
     int precision = -1;
-    const char* format = "$minx $miny $maxx $maxy";
-    const char* projectionString = NULL;
+    const char *format = "$minx $miny $maxx $maxy";
+    const char *projectionString = NULL;
 
     /* hack to handle tags like 'mapext_esc' easily */
     int escape;
-    if(strstr(name, "_esc"))
+    if (strstr(name, "_esc"))
       escape = ESCAPE_URL;
     else
       escape = ESCAPE_HTML;
@@ -1405,15 +1547,16 @@ static int processExtentTag(mapservObj *
     tagOffset = tagStart - *line;
 
     /* check for any tag arguments */
-    if(getTagArgs(name, tagStart, &tagArgs) != MS_SUCCESS) return(MS_FAILURE);
-    if(tagArgs) {
-      const char* argValue = msLookupHashTable(tagArgs, "expand");
-      if(argValue) {
-        if(strchr(argValue, '%') != NULL) {
+    if (getTagArgs(name, tagStart, &tagArgs) != MS_SUCCESS)
+      return (MS_FAILURE);
+    if (tagArgs) {
+      const char *argValue = msLookupHashTable(tagArgs, "expand");
+      if (argValue) {
+        if (strchr(argValue, '%') != NULL) {
           float f;
           sscanf(argValue, "%f%%", &f);
-          xExpand = ((f/100.0)*(extent->maxx-extent->minx))/2;
-          yExpand = ((f/100.0)*(extent->maxy-extent->miny))/2;
+          xExpand = ((f / 100.0) * (extent->maxx - extent->minx)) / 2;
+          yExpand = ((f / 100.0) * (extent->maxy - extent->miny)) / 2;
         } else {
           xExpand = atof(argValue);
           yExpand = xExpand;
@@ -1421,17 +1564,22 @@ static int processExtentTag(mapservObj *
       }
 
       argValue = msLookupHashTable(tagArgs, "escape");
-      if(argValue && strcasecmp(argValue, "url") == 0) escape = ESCAPE_URL;
-      else if(argValue && strcasecmp(argValue, "none") == 0) escape = ESCAPE_NONE;
+      if (argValue && strcasecmp(argValue, "url") == 0)
+        escape = ESCAPE_URL;
+      else if (argValue && strcasecmp(argValue, "none") == 0)
+        escape = ESCAPE_NONE;
 
       argValue = msLookupHashTable(tagArgs, "format");
-      if(argValue) format = argValue;
+      if (argValue)
+        format = argValue;
 
       argValue = msLookupHashTable(tagArgs, "precision");
-      if(argValue) precision = atoi(argValue);
+      if (argValue)
+        precision = atoi(argValue);
 
       argValue = msLookupHashTable(tagArgs, "proj");
-      if(argValue) projectionString = argValue;
+      if (argValue)
+        projectionString = argValue;
     }
 
     tempExtent.minx = extent->minx - xExpand;
@@ -1439,33 +1587,41 @@ static int processExtentTag(mapservObj *
     tempExtent.maxx = extent->maxx + xExpand;
     tempExtent.maxy = extent->maxy + yExpand;
 
-    /* no big deal to convert from file to image coordinates, but what are the image parameters */
-    if(rectProj && projectionString && strcasecmp(projectionString,"image") == 0) {
+    /* no big deal to convert from file to image coordinates, but what are the
+     * image parameters */
+    if (rectProj && projectionString &&
+        strcasecmp(projectionString, "image") == 0) {
       precision = 0;
 
       /* if necessary, project the shape to match the map */
-      if(msProjectionsDiffer(rectProj, &(mapserv->map->projection)))
+      if (msProjectionsDiffer(rectProj, &(mapserv->map->projection)))
         msProjectRect(rectProj, &mapserv->map->projection, &tempExtent);
 
-      /* convert tempExtent to image coordinates based on the map extent and cellsize */
-      tempExtent.minx = MS_MAP2IMAGE_X(tempExtent.minx, mapserv->map->extent.minx, mapserv->map->cellsize);
-      tempExtent.miny = MS_MAP2IMAGE_Y(tempExtent.miny, mapserv->map->extent.maxy, mapserv->map->cellsize);
-      tempExtent.maxx = MS_MAP2IMAGE_X(tempExtent.minx, mapserv->map->extent.minx, mapserv->map->cellsize);
-      tempExtent.maxy = MS_MAP2IMAGE_Y(tempExtent.miny, mapserv->map->extent.maxy, mapserv->map->cellsize);
-    } else if(rectProj && projectionString) {
+      /* convert tempExtent to image coordinates based on the map extent and
+       * cellsize */
+      tempExtent.minx = MS_MAP2IMAGE_X(
+          tempExtent.minx, mapserv->map->extent.minx, mapserv->map->cellsize);
+      tempExtent.miny = MS_MAP2IMAGE_Y(
+          tempExtent.miny, mapserv->map->extent.maxy, mapserv->map->cellsize);
+      tempExtent.maxx = MS_MAP2IMAGE_X(
+          tempExtent.minx, mapserv->map->extent.minx, mapserv->map->cellsize);
+      tempExtent.maxy = MS_MAP2IMAGE_Y(
+          tempExtent.miny, mapserv->map->extent.maxy, mapserv->map->cellsize);
+    } else if (rectProj && projectionString) {
       projectionObj projection;
       msInitProjection(&projection);
       msProjectionInheritContextFrom(&projection, &mapserv->map->projection);
 
-      if(MS_SUCCESS != msLoadProjectionString(&projection, projectionString)) return MS_FAILURE;
+      if (MS_SUCCESS != msLoadProjectionString(&projection, projectionString))
+        return MS_FAILURE;
 
-      if(msProjectionsDiffer(rectProj, &projection))
+      if (msProjectionsDiffer(rectProj, &projection))
         msProjectRect(rectProj, &projection, &tempExtent);
     }
 
     tagValue = msStrdup(format);
 
-    if(precision != -1)
+    if (precision != -1)
       snprintf(numberFormat, sizeof(numberFormat), "%%.%dlf", precision);
     else
       snprintf(numberFormat, sizeof(numberFormat), "%%f");
@@ -1485,59 +1641,59 @@ static int processExtentTag(mapservObj *
 
     /* build the complete tag so we can do substitution */
     tagLength = tagEnd - tagStart;
-    tag = (char *) msSmallMalloc(tagLength + 1);
-    strlcpy(tag, tagStart, tagLength+1);
+    tag = (char *)msSmallMalloc(tagLength + 1);
+    strlcpy(tag, tagStart, tagLength + 1);
 
     /* do the replacement */
-    switch(escape) {
-      case ESCAPE_HTML:
-        encodedTagValue = msEncodeHTMLEntities(tagValue);
-        *line = msReplaceSubstring(*line, tag, encodedTagValue);
-        break;
-      case ESCAPE_URL:
-        encodedTagValue = msEncodeUrl(tagValue);
-        *line = msReplaceSubstring(*line, tag, encodedTagValue);
-        break;
-      case ESCAPE_NONE:
-        *line = msReplaceSubstring(*line, tag, tagValue);
-        break;
-      default:
-        break;
+    switch (escape) {
+    case ESCAPE_HTML:
+      encodedTagValue = msEncodeHTMLEntities(tagValue);
+      *line = msReplaceSubstring(*line, tag, encodedTagValue);
+      break;
+    case ESCAPE_URL:
+      encodedTagValue = msEncodeUrl(tagValue);
+      *line = msReplaceSubstring(*line, tag, encodedTagValue);
+      break;
+    case ESCAPE_NONE:
+      *line = msReplaceSubstring(*line, tag, tagValue);
+      break;
+    default:
+      break;
     }
 
     /* clean up */
     free(tag);
     tag = NULL;
     msFreeHashTable(tagArgs);
-    tagArgs=NULL;
+    tagArgs = NULL;
     msFree(tagValue);
-    tagValue=NULL;
+    tagValue = NULL;
     msFree(encodedTagValue);
-    encodedTagValue=NULL;
+    encodedTagValue = NULL;
 
-    if((*line)[tagOffset] != '\0')
-      tagStart = findTag(*line+tagOffset+1, name);
+    if ((*line)[tagOffset] != '\0')
+      tagStart = findTag(*line + tagOffset + 1, name);
     else
       tagStart = NULL;
   }
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
 // RFC 77 TODO: Need to validate these changes with Assefa...
-static int processShplabelTag(layerObj *layer, char **line, shapeObj *origshape)
-{
+static int processShplabelTag(layerObj *layer, char **line,
+                              shapeObj *origshape) {
   char *tag, *tagStart, *tagEnd;
-  char *tagValue=NULL;
-  hashTableObj *tagArgs=NULL;
+  char *tagValue = NULL;
+  hashTableObj *tagArgs = NULL;
   int tagOffset, tagLength;
   const char *format;
-  const char *argValue=NULL;
-  const char *projectionString=NULL;
+  const char *argValue = NULL;
+  const char *projectionString = NULL;
   shapeObj tShape;
-  int precision=0;
-  int clip_to_map=MS_TRUE;
-  int use_label_settings=MS_FALSE;
+  int precision = 0;
+  int clip_to_map = MS_TRUE;
+  int use_label_settings = MS_FALSE;
   int labelposvalid = MS_FALSE;
   pointObj labelPos;
   int status;
@@ -1545,27 +1701,30 @@ static int processShplabelTag(layerObj *
   char numberFormat[16];
   shapeObj *shape = NULL;
 
-  if(!*line) {
+  if (!*line) {
     msSetError(MS_WEBERR, "Invalid line pointer.", "processShplabelTag()");
-    return(MS_FAILURE);
+    return (MS_FAILURE);
   }
-  if(msCheckParentPointer(layer->map,"map") == MS_FAILURE)
+  if (msCheckParentPointer(layer->map, "map") == MS_FAILURE)
     return MS_FAILURE;
 
   tagStart = findTag(*line, "shplabel");
 
   /* It is OK to have no shplabel tags, just return. */
-  if(!tagStart)
+  if (!tagStart)
     return MS_SUCCESS;
 
-  if(!origshape || origshape->numlines <= 0) { /* I suppose we need to make sure the part has vertices (need shape checker?) */
+  if (!origshape ||
+      origshape->numlines <= 0) { /* I suppose we need to make sure the part has
+                                     vertices (need shape checker?) */
     msSetError(MS_WEBERR, "Null or empty shape.", "processShplabelTag()");
-    return(MS_FAILURE);
+    return (MS_FAILURE);
   }
 
-  while(tagStart) {
-    if(shape) msFreeShape(shape);
-    shape = (shapeObj *) msSmallMalloc(sizeof(shapeObj));
+  while (tagStart) {
+    if (shape)
+      msFreeShape(shape);
+    shape = (shapeObj *)msSmallMalloc(sizeof(shapeObj));
     msInitShape(shape);
     msCopyShape(origshape, shape);
 
@@ -1573,25 +1732,31 @@ static int processShplabelTag(layerObj *
     format = "$x,$y";
     tagOffset = tagStart - *line;
 
-    if(getTagArgs("shplabel", tagStart, &tagArgs) != MS_SUCCESS) return(MS_FAILURE);
-    if(tagArgs) {
+    if (getTagArgs("shplabel", tagStart, &tagArgs) != MS_SUCCESS)
+      return (MS_FAILURE);
+    if (tagArgs) {
       argValue = msLookupHashTable(tagArgs, "format");
-      if(argValue) format = argValue;
+      if (argValue)
+        format = argValue;
 
       argValue = msLookupHashTable(tagArgs, "precision");
-      if(argValue) precision = atoi(argValue);
+      if (argValue)
+        precision = atoi(argValue);
 
       argValue = msLookupHashTable(tagArgs, "proj");
-      if(argValue) projectionString = argValue;
+      if (argValue)
+        projectionString = argValue;
 
       argValue = msLookupHashTable(tagArgs, "clip_to_map");
-      if(argValue) {
-        if(strcasecmp(argValue,"false") == 0) clip_to_map = MS_FALSE;
+      if (argValue) {
+        if (strcasecmp(argValue, "false") == 0)
+          clip_to_map = MS_FALSE;
       }
 
       argValue = msLookupHashTable(tagArgs, "use_label_settings");
-      if(argValue) {
-        if(strcasecmp(argValue,"true") == 0) use_label_settings = MS_TRUE;
+      if (argValue) {
+        if (strcasecmp(argValue, "true") == 0)
+          use_label_settings = MS_TRUE;
       }
     }
 
@@ -1600,73 +1765,74 @@ static int processShplabelTag(layerObj *
     msInitShape(&tShape);
 
     tShape.type = MS_SHAPE_LINE;
-    tShape.line = (lineObj *) msSmallMalloc(sizeof(lineObj));
+    tShape.line = (lineObj *)msSmallMalloc(sizeof(lineObj));
     tShape.numlines = 1;
     tShape.line[0].point = NULL; /* initialize the line */
     tShape.line[0].numpoints = 0;
 
     double cellsize;
-    if(layer->map->cellsize <= 0)
-      cellsize = MS_MAX(MS_CELLSIZE(layer->map->extent.minx, layer->map->extent.maxx, layer->map->width), MS_CELLSIZE(layer->map->extent.miny, layer->map->extent.maxy, layer->map->height));
+    if (layer->map->cellsize <= 0)
+      cellsize =
+          MS_MAX(MS_CELLSIZE(layer->map->extent.minx, layer->map->extent.maxx,
+                             layer->map->width),
+                 MS_CELLSIZE(layer->map->extent.miny, layer->map->extent.maxy,
+                             layer->map->height));
     else
-      cellsize = layer->map->cellsize ;
+      cellsize = layer->map->cellsize;
 
-    if(shape->type == MS_SHAPE_POINT) {
+    if (shape->type == MS_SHAPE_POINT) {
       labelposvalid = MS_FALSE;
-      if(shape->numlines > 0 && shape->line[0].numpoints > 0) {
+      if (shape->numlines > 0 && shape->line[0].numpoints > 0) {
         labelposvalid = MS_TRUE;
         labelPos = shape->line[0].point[0];
-        if(layer->transform == MS_TRUE) {
-          if(layer->project && msProjectionsDiffer(&(layer->projection), &(layer->map->projection)))
-          {
-            if( layer->reprojectorLayerToMap == NULL )
-            {
-                layer->reprojectorLayerToMap = msProjectCreateReprojector(
-                    &layer->projection, &layer->map->projection);
-            }
-            if( layer->reprojectorLayerToMap )
-            {
-                msProjectShapeEx(layer->reprojectorLayerToMap, shape);
+        if (layer->transform == MS_TRUE) {
+          if (layer->project &&
+              msProjectionsDiffer(&(layer->projection),
+                                  &(layer->map->projection))) {
+            reprojectionObj *reprojector =
+                msLayerGetReprojectorToMap(layer, layer->map);
+            if (reprojector) {
+              msProjectShapeEx(reprojector, shape);
             }
           }
 
           labelPos = shape->line[0].point[0];
-          labelPos.x = MS_MAP2IMAGE_X(labelPos.x, layer->map->extent.minx, cellsize);
-          labelPos.y = MS_MAP2IMAGE_Y(labelPos.y, layer->map->extent.maxy, cellsize);
+          labelPos.x =
+              MS_MAP2IMAGE_X(labelPos.x, layer->map->extent.minx, cellsize);
+          labelPos.y =
+              MS_MAP2IMAGE_Y(labelPos.y, layer->map->extent.maxy, cellsize);
         }
       }
-    } else if(shape->type == MS_SHAPE_LINE) {
+    } else if (shape->type == MS_SHAPE_LINE) {
       labelposvalid = MS_FALSE;
-      if(layer->transform == MS_TRUE) {
-        if(layer->project && msProjectionsDiffer(&(layer->projection), &(layer->map->projection)))
-        {
-            if( layer->reprojectorLayerToMap == NULL )
-            {
-                layer->reprojectorLayerToMap = msProjectCreateReprojector(
-                    &layer->projection, &layer->map->projection);
-            }
-            if( layer->reprojectorLayerToMap )
-            {
-                msProjectShapeEx(layer->reprojectorLayerToMap, shape);
-            }
+      if (layer->transform == MS_TRUE) {
+        if (layer->project && msProjectionsDiffer(&(layer->projection),
+                                                  &(layer->map->projection))) {
+          reprojectionObj *reprojector =
+              msLayerGetReprojectorToMap(layer, layer->map);
+          if (reprojector) {
+            msProjectShapeEx(reprojector, shape);
+          }
         }
 
-        if(clip_to_map)
+        if (clip_to_map)
           msClipPolylineRect(shape, layer->map->extent);
 
         msTransformShapeToPixelRound(shape, layer->map->extent, cellsize);
       } else
         msOffsetShapeRelativeTo(shape, layer);
 
-      if(shape->numlines > 0) {
+      if (shape->numlines > 0) {
         struct label_auto_result lar;
-        memset(&lar,0,sizeof(struct label_auto_result));
-        if(MS_UNLIKELY(MS_FAILURE == msPolylineLabelPoint(layer->map, shape, NULL, NULL, &lar, 0))) {
+        memset(&lar, 0, sizeof(struct label_auto_result));
+        if (MS_UNLIKELY(MS_FAILURE == msPolylineLabelPoint(layer->map, shape,
+                                                           NULL, NULL, &lar,
+                                                           0))) {
           free(lar.angles);
           free(lar.label_points);
           return MS_FAILURE;
         }
-        if(lar.num_label_points > 0) {
+        if (lar.num_label_points > 0) {
           /* convert to geo */
           labelPos.x = lar.label_points[0].x;
           labelPos.y = lar.label_points[0].y;
@@ -1677,30 +1843,26 @@ static int processShplabelTag(layerObj *
       }
     } else if (shape->type == MS_SHAPE_POLYGON) {
       labelposvalid = MS_FALSE;
-      if(layer->transform == MS_TRUE) {
-        if(layer->project && msProjectionsDiffer(&(layer->projection), &(layer->map->projection)))
-        {
-            if( layer->reprojectorLayerToMap == NULL )
-            {
-                layer->reprojectorLayerToMap = msProjectCreateReprojector(
-                    &layer->projection, &layer->map->projection);
-            }
-            if( layer->reprojectorLayerToMap )
-            {
-                msProjectShapeEx(layer->reprojectorLayerToMap, shape);
-            }
+      if (layer->transform == MS_TRUE) {
+        if (layer->project && msProjectionsDiffer(&(layer->projection),
+                                                  &(layer->map->projection))) {
+          reprojectionObj *reprojector =
+              msLayerGetReprojectorToMap(layer, layer->map);
+          if (reprojector) {
+            msProjectShapeEx(reprojector, shape);
+          }
         }
 
-        if(clip_to_map)
+        if (clip_to_map)
           msClipPolygonRect(shape, layer->map->extent);
 
         msTransformShapeToPixelRound(shape, layer->map->extent, cellsize);
       } else
         msOffsetShapeRelativeTo(shape, layer);
 
-      if(shape->numlines > 0) {
-        if(msPolygonLabelPoint(shape, &labelPos, -1) == MS_SUCCESS) {
-          if(labelPos.x == -1 && labelPos.y == -1)
+      if (shape->numlines > 0) {
+        if (msPolygonLabelPoint(shape, &labelPos, -1) == MS_SUCCESS) {
+          if (labelPos.x == -1 && labelPos.y == -1)
             labelposvalid = MS_FALSE;
           else
             labelposvalid = MS_TRUE;
@@ -1708,43 +1870,49 @@ static int processShplabelTag(layerObj *
       }
     }
 
-    if(labelposvalid == MS_TRUE) {
+    if (labelposvalid == MS_TRUE) {
       pointObj p1 = {0}; // initialize
       pointObj p2 = {0};
       int label_offset_x, label_offset_y;
-      labelObj *label=NULL;
+      labelObj *label = NULL;
       label_bounds lbounds;
       lineObj lbounds_line;
       pointObj lbounds_point[5];
       double tmp;
 
-      p1.x =labelPos.x;
-      p1.y =labelPos.y;
-
-      p2.x =labelPos.x;
-      p2.y =labelPos.y;
-      if(use_label_settings == MS_TRUE) {
+      p1.x = labelPos.x;
+      p1.y = labelPos.y;
 
-        /* RFC 77: classes (and shapes) can have more than 1 piece of annotation, here we only use the first (index=0) */
-        if(shape->classindex >= 0  && layer->class[shape->classindex]->numlabels > 0) {
+      p2.x = labelPos.x;
+      p2.y = labelPos.y;
+      if (use_label_settings == MS_TRUE) {
+
+        /* RFC 77: classes (and shapes) can have more than 1 piece of
+         * annotation, here we only use the first (index=0) */
+        if (shape->classindex >= 0 &&
+                layer->class[shape->classindex] -> numlabels > 0) {
           label = layer->class[shape->classindex]->labels[0];
-          if(msGetLabelStatus(layer->map,layer,shape,label) == MS_ON) {
-            char *annotext = msShapeGetLabelAnnotation(layer,shape,label);
-            if(annotext) {
+          if (msGetLabelStatus(layer->map, layer, shape, label) == MS_ON) {
+            char *annotext = msShapeGetLabelAnnotation(layer, shape, label);
+            if (annotext) {
               textSymbolObj ts;
               initTextSymbol(&ts);
-              msPopulateTextSymbolForLabelAndString(&ts, label, annotext, layer->scalefactor, 1.0, 0);
+              msPopulateTextSymbolForLabelAndString(&ts, label, annotext,
+                                                    layer->scalefactor, 1.0, 0);
 
-              label_offset_x = (int)(label->offsetx*layer->scalefactor);
-              label_offset_y = (int)(label->offsety*layer->scalefactor);
+              label_offset_x = (int)(label->offsetx * layer->scalefactor);
+              label_offset_y = (int)(label->offsety * layer->scalefactor);
               lbounds.poly = &lbounds_line;
               lbounds_line.numpoints = 5;
               lbounds_line.point = lbounds_point;
 
-              p1 = get_metrics(&labelPos, label->position, ts.textpath, label_offset_x, label_offset_y, label->angle* MS_DEG_TO_RAD, 0, &lbounds);
-
-              /* should we use the point returned from  get_metrics?. From few test done, It seems
-                to return the UL corner of the text. For now use the bounds.minx/miny */
+              p1 = get_metrics(&labelPos, label->position, ts.textpath,
+                               label_offset_x, label_offset_y,
+                               label->angle * MS_DEG_TO_RAD, 0, &lbounds);
+
+              /* should we use the point returned from  get_metrics?. From few
+                test done, It seems to return the UL corner of the text. For now
+                use the bounds.minx/miny */
               p1.x = lbounds.bbox.minx;
               p1.y = lbounds.bbox.miny;
               p2.x = lbounds.bbox.maxx;
@@ -1761,8 +1929,9 @@ static int processShplabelTag(layerObj *
       p1.y = MS_IMAGE2MAP_Y(p2.y, layer->map->extent.maxy, cellsize);
       p2.x = MS_IMAGE2MAP_X(p2.x, layer->map->extent.minx, cellsize);
       p2.y = MS_IMAGE2MAP_Y(tmp, layer->map->extent.maxy, cellsize);
-      if(layer->transform == MS_TRUE) {
-        if(layer->project && msProjectionsDiffer(&(layer->projection), &(layer->map->projection))) {
+      if (layer->transform == MS_TRUE) {
+        if (layer->project && msProjectionsDiffer(&(layer->projection),
+                                                  &(layer->map->projection))) {
           msProjectPoint(&layer->map->projection, &layer->projection, &p1);
           msProjectPoint(&layer->map->projection, &layer->projection, &p2);
         }
@@ -1772,69 +1941,73 @@ static int processShplabelTag(layerObj *
     } else
       tShape.numlines = 0;
 
-    if(projectionString && strcasecmp(projectionString,"image") == 0) {
+    if (projectionString && strcasecmp(projectionString, "image") == 0) {
       precision = 0;
 
       /* if necessary, project the shape to match the map */
-      if(msProjectionsDiffer(&(layer->projection), &(layer->map->projection)))
-      {
-        if( layer->reprojectorLayerToMap == NULL )
-        {
-            layer->reprojectorLayerToMap = msProjectCreateReprojector(
-                &layer->projection, &layer->map->projection);
-        }
-        if( layer->reprojectorLayerToMap )
-        {
-            msProjectShapeEx(layer->reprojectorLayerToMap, &tShape);
+      if (msProjectionsDiffer(&(layer->projection),
+                              &(layer->map->projection))) {
+        reprojectionObj *reprojector =
+            msLayerGetReprojectorToMap(layer, layer->map);
+        if (reprojector) {
+          msProjectShapeEx(reprojector, &tShape);
         }
       }
 
       msClipPolylineRect(&tShape, layer->map->extent);
 
-      msTransformShapeToPixelRound(&tShape, layer->map->extent, layer->map->cellsize);
-    } else if(projectionString) {
+      msTransformShapeToPixelRound(&tShape, layer->map->extent,
+                                   layer->map->cellsize);
+    } else if (projectionString) {
       projectionObj projection;
       msInitProjection(&projection);
       msProjectionInheritContextFrom(&projection, &layer->map->projection);
 
       status = msLoadProjectionString(&projection, projectionString);
-      if(status != MS_SUCCESS) return MS_FAILURE;
+      if (status != MS_SUCCESS)
+        return MS_FAILURE;
 
-      if(msProjectionsDiffer(&(layer->projection), &projection))
+      if (msProjectionsDiffer(&(layer->projection), &projection))
         msProjectShape(&layer->projection, &projection, &tShape);
     }
 
     /* do the replacement */
     tagValue = msStrdup(format);
-    if(precision > 0)
+    if (precision > 0)
       snprintf(numberFormat, sizeof(numberFormat), "%%.%dlf", precision);
     else
       snprintf(numberFormat, sizeof(numberFormat), "%%f");
 
-    if(tShape.numlines > 0) {
-      if(strcasestr(tagValue, "$x") != 0) {
-        snprintf(number, sizeof(number), numberFormat, tShape.line[0].point[0].x);
+    if (tShape.numlines > 0) {
+      if (strcasestr(tagValue, "$x") != 0) {
+        snprintf(number, sizeof(number), numberFormat,
+                 tShape.line[0].point[0].x);
         tagValue = msReplaceSubstring(tagValue, "$x", number);
       }
-      if(strcasestr(tagValue, "$y") != 0) {
-        snprintf(number, sizeof(number), numberFormat, tShape.line[0].point[0].y);
+      if (strcasestr(tagValue, "$y") != 0) {
+        snprintf(number, sizeof(number), numberFormat,
+                 tShape.line[0].point[0].y);
         tagValue = msReplaceSubstring(tagValue, "$y", number);
       }
 
-      if(strcasestr(tagValue, "$minx") != 0) {
-        snprintf(number, sizeof(number), numberFormat, tShape.line[0].point[0].x);
+      if (strcasestr(tagValue, "$minx") != 0) {
+        snprintf(number, sizeof(number), numberFormat,
+                 tShape.line[0].point[0].x);
         tagValue = msReplaceSubstring(tagValue, "$minx", number);
       }
-      if(strcasestr(tagValue, "$miny") != 0) {
-        snprintf(number, sizeof(number), numberFormat, tShape.line[0].point[0].y);
+      if (strcasestr(tagValue, "$miny") != 0) {
+        snprintf(number, sizeof(number), numberFormat,
+                 tShape.line[0].point[0].y);
         tagValue = msReplaceSubstring(tagValue, "$miny", number);
       }
-      if(strcasestr(tagValue, "$maxx") != 0) {
-        snprintf(number, sizeof(number), numberFormat, tShape.line[0].point[1].x);
+      if (strcasestr(tagValue, "$maxx") != 0) {
+        snprintf(number, sizeof(number), numberFormat,
+                 tShape.line[0].point[1].x);
         tagValue = msReplaceSubstring(tagValue, "$maxx", number);
       }
-      if(strcasestr(tagValue, "$maxy") != 0) {
-        snprintf(number, sizeof(number), numberFormat, tShape.line[0].point[1].y);
+      if (strcasestr(tagValue, "$maxy") != 0) {
+        snprintf(number, sizeof(number), numberFormat,
+                 tShape.line[0].point[1].y);
         tagValue = msReplaceSubstring(tagValue, "$maxy", number);
       }
     }
@@ -1845,8 +2018,8 @@ static int processShplabelTag(layerObj *
 
     /* build the complete tag so we can do substitution */
     tagLength = tagEnd - tagStart;
-    tag = (char *) msSmallMalloc(tagLength + 1);
-    strlcpy(tag, tagStart, tagLength+1);
+    tag = (char *)msSmallMalloc(tagLength + 1);
+    strlcpy(tag, tagStart, tagLength + 1);
 
     *line = msReplaceSubstring(*line, tag, tagValue);
 
@@ -1855,46 +2028,45 @@ static int processShplabelTag(layerObj *
     free(tag);
     tag = NULL;
     msFreeHashTable(tagArgs);
-    tagArgs=NULL;
+    tagArgs = NULL;
     msFree(tagValue);
-    tagValue=NULL;
+    tagValue = NULL;
 
-    if((*line)[tagOffset] != '\0')
-      tagStart = findTag(*line+tagOffset+1, "shplabel");
+    if ((*line)[tagOffset] != '\0')
+      tagStart = findTag(*line + tagOffset + 1, "shplabel");
     else
       tagStart = NULL;
   }
-  if(shape)
+  if (shape)
     msFreeShape(shape);
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
 /*
 ** Function to process a [date ...] tag
 */
-static int processDateTag(char **line)
-{
+static int processDateTag(char **line) {
   struct tm *datetime;
   time_t t;
   int result;
-  char *tag=NULL, *tagStart, *tagEnd;
-  hashTableObj *tagArgs=NULL;
+  char *tag = NULL, *tagStart, *tagEnd;
+  hashTableObj *tagArgs = NULL;
   int tagOffset, tagLength;
 #define DATE_BUFLEN 1024
   char datestr[DATE_BUFLEN];
-  const char *argValue=NULL;
+  const char *argValue = NULL;
   const char *format, *tz; /* tag parameters */
 
-  if(!*line) {
+  if (!*line) {
     msSetError(MS_WEBERR, "Invalid line pointer.", "processDateTag()");
-    return(MS_FAILURE);
+    return (MS_FAILURE);
   }
 
   tagStart = findTag(*line, "date");
 
   /* It is OK to have no date tags, just return. */
-  if( !tagStart )
+  if (!tagStart)
     return MS_SUCCESS;
 
   while (tagStart) {
@@ -1905,17 +2077,20 @@ static int processDateTag(char **line)
     tagOffset = tagStart - *line;
 
     /* check for any tag arguments */
-    if(getTagArgs("date", tagStart, &tagArgs) != MS_SUCCESS) return(MS_FAILURE);
+    if (getTagArgs("date", tagStart, &tagArgs) != MS_SUCCESS)
+      return (MS_FAILURE);
 
-    if(tagArgs) {
+    if (tagArgs) {
       argValue = msLookupHashTable(tagArgs, "format");
-      if(argValue) format = argValue;
+      if (argValue)
+        format = argValue;
       argValue = msLookupHashTable(tagArgs, "tz");
-      if(argValue) tz = argValue;
+      if (argValue)
+        tz = argValue;
     }
 
     t = time(NULL);
-    if( strncasecmp( tz, "gmt", 4 ) == 0 ) {
+    if (strncasecmp(tz, "gmt", 4) == 0) {
       datetime = gmtime(&t);
     } else {
       datetime = localtime(&t);
@@ -1923,15 +2098,15 @@ static int processDateTag(char **line)
     result = strftime(datestr, DATE_BUFLEN, format, datetime);
 
     /* Only do the replacement if the date was successfully written */
-    if( result > 0 ) {
+    if (result > 0) {
       /* find the end of the tag */
       tagEnd = findTagEnd(tagStart);
       tagEnd++;
 
       /* build the complete tag so we can do substitution */
       tagLength = tagEnd - tagStart;
-      tag = (char *) msSmallMalloc(tagLength + 1);
-      strlcpy(tag, tagStart, tagLength+1);
+      tag = (char *)msSmallMalloc(tagLength + 1);
+      strlcpy(tag, tagStart, tagLength + 1);
 
       /* do the replacement */
       *line = msReplaceSubstring(*line, tag, datestr);
@@ -1941,42 +2116,42 @@ static int processDateTag(char **line)
     msFree(tag);
     tag = NULL;
     msFreeHashTable(tagArgs);
-    tagArgs=NULL;
+    tagArgs = NULL;
 
-    if((*line)[tagOffset] != '\0')
-      tagStart = findTag(*line+tagOffset+1, "date");
+    if ((*line)[tagOffset] != '\0')
+      tagStart = findTag(*line + tagOffset + 1, "date");
     else
       tagStart = NULL;
   }
 
-  return(MS_SUCCESS);
-
+  return (MS_SUCCESS);
 }
 
 /*
-** Function to process a [shpxy ...] tag: line contains the tag, shape holds the coordinates.
+** Function to process a [shpxy ...] tag: line contains the tag, shape holds the
+*coordinates.
 **
 ** TODO's:
 **   - May need to change attribute names.
 **   - Need generalization routines (not here, but in mapprimative.c).
 **   - Try to avoid all the realloc calls.
 */
-static int processShpxyTag(layerObj *layer, char **line, shapeObj *shape)
-{
-  int i,j,p;
+static int processShpxyTag(layerObj *layer, char **line, shapeObj *shape) {
+  int i, j, p;
   int status;
 
   char *tag, *tagStart, *tagEnd;
-  hashTableObj *tagArgs=NULL;
+  hashTableObj *tagArgs = NULL;
   int tagOffset, tagLength;
 
-  const char *argValue=NULL;
-  char *pointFormat1=NULL, *pointFormat2=NULL;
+  const char *argValue = NULL;
+  char *pointFormat1 = NULL, *pointFormat2 = NULL;
   int pointFormatLength;
 
   /*
   ** Pointers to static strings, naming convention is:
-  **   char 1/2 - x=x, y=y, c=coordinate, p=part, s=shape, ir=inner ring, or=outer ring
+  **   char 1/2 - x=x, y=y, c=coordinate, p=part, s=shape, ir=inner ring,
+  *or=outer ring
   **   last char - h=header, f=footer, s=seperator
   */
   const char *xh, *xf, *yh, *yf;
@@ -1991,27 +2166,29 @@ static int processShpxyTag(layerObj *lay
 
   double scale_x, scale_y;
 
-  const char *projectionString=NULL;
+  const char *projectionString = NULL;
 
   shapeObj tShape;
-  char *coords=NULL, point[128];
+  char *coords = NULL, point[128];
 
-  if(!*line) {
+  if (!*line) {
     msSetError(MS_WEBERR, "Invalid line pointer.", "processShpxyTag()");
-    return(MS_FAILURE);
+    return (MS_FAILURE);
   }
-  if( msCheckParentPointer(layer->map,"map")==MS_FAILURE )
+  if (msCheckParentPointer(layer->map, "map") == MS_FAILURE)
     return MS_FAILURE;
 
   tagStart = findTag(*line, "shpxy");
 
   /* It is OK to have no shpxy tags, just return. */
-  if( !tagStart )
+  if (!tagStart)
     return MS_SUCCESS;
 
-  if(!shape || shape->numlines <= 0) { /* I suppose we need to make sure the part has vertices (need shape checker?) */
+  if (!shape ||
+      shape->numlines <= 0) { /* I suppose we need to make sure the part has
+                                 vertices (need shape checker?) */
     msSetError(MS_WEBERR, "Null or empty shape.", "processShpxyTag()");
-    return(MS_FAILURE);
+    return (MS_FAILURE);
   }
 
   while (tagStart) {
@@ -2020,7 +2197,7 @@ static int processShpxyTag(layerObj *lay
     int bufferUnits = -1;
 #endif
     xh = yh = yf = ph = pf = sh = sf = ""; /* initialize the tag arguments */
-    xf= ",";
+    xf = ",";
     irh = irf = orh = orf = "";
     ps = cs = " ";
 
@@ -2033,91 +2210,116 @@ static int processShpxyTag(layerObj *lay
     tagOffset = tagStart - *line;
 
     /* check for any tag arguments */
-    if(getTagArgs("shpxy", tagStart, &tagArgs) != MS_SUCCESS) return(MS_FAILURE);
-    if(tagArgs) {
+    if (getTagArgs("shpxy", tagStart, &tagArgs) != MS_SUCCESS)
+      return (MS_FAILURE);
+    if (tagArgs) {
       argValue = msLookupHashTable(tagArgs, "xh");
-      if(argValue) xh = argValue;
+      if (argValue)
+        xh = argValue;
       argValue = msLookupHashTable(tagArgs, "xf");
-      if(argValue) xf = argValue;
+      if (argValue)
+        xf = argValue;
 
       argValue = msLookupHashTable(tagArgs, "yh");
-      if(argValue) yh = argValue;
+      if (argValue)
+        yh = argValue;
       argValue = msLookupHashTable(tagArgs, "yf");
-      if(argValue) yf = argValue;
+      if (argValue)
+        yf = argValue;
 
       argValue = msLookupHashTable(tagArgs, "cs");
-      if(argValue) cs = argValue;
+      if (argValue)
+        cs = argValue;
 
       argValue = msLookupHashTable(tagArgs, "irh");
-      if(argValue) irh = argValue;
+      if (argValue)
+        irh = argValue;
       argValue = msLookupHashTable(tagArgs, "irf");
-      if(argValue) irf = argValue;
+      if (argValue)
+        irf = argValue;
 
       argValue = msLookupHashTable(tagArgs, "orh");
-      if(argValue) orh = argValue;
+      if (argValue)
+        orh = argValue;
       argValue = msLookupHashTable(tagArgs, "orf");
-      if(argValue) orf = argValue;
+      if (argValue)
+        orf = argValue;
 
       argValue = msLookupHashTable(tagArgs, "ph");
-      if(argValue) ph = argValue;
+      if (argValue)
+        ph = argValue;
       argValue = msLookupHashTable(tagArgs, "pf");
-      if(argValue) pf = argValue;
+      if (argValue)
+        pf = argValue;
       argValue = msLookupHashTable(tagArgs, "ps");
-      if(argValue) ps = argValue;
+      if (argValue)
+        ps = argValue;
 
       argValue = msLookupHashTable(tagArgs, "sh");
-      if(argValue) sh = argValue;
+      if (argValue)
+        sh = argValue;
       argValue = msLookupHashTable(tagArgs, "sf");
-      if(argValue) sf = argValue;
+      if (argValue)
+        sf = argValue;
 
 #ifdef USE_GEOS
       argValue = msLookupHashTable(tagArgs, "buffer");
-      if(argValue) {
+      if (argValue) {
         buffer = atof(argValue);
-        if(strstr(argValue, "px")) bufferUnits = MS_PIXELS; /* may support others at some point */
+        if (strstr(argValue, "px"))
+          bufferUnits = MS_PIXELS; /* may support others at some point */
       }
 #endif
 
       argValue = msLookupHashTable(tagArgs, "precision");
-      if(argValue) precision = atoi(argValue);
+      if (argValue)
+        precision = atoi(argValue);
 
       argValue = msLookupHashTable(tagArgs, "scale");
-      if(argValue) {
+      if (argValue) {
         scale_x = atof(argValue);
         scale_y = scale_x;
       }
 
       argValue = msLookupHashTable(tagArgs, "scale_x");
-      if(argValue) scale_x = atof(argValue);
+      if (argValue)
+        scale_x = atof(argValue);
 
       argValue = msLookupHashTable(tagArgs, "scale_y");
-      if(argValue) scale_y = atof(argValue);
+      if (argValue)
+        scale_y = atof(argValue);
 
       argValue = msLookupHashTable(tagArgs, "centroid");
-      if(argValue)
-        if(strcasecmp(argValue,"true") == 0) centroid = MS_TRUE;
+      if (argValue)
+        if (strcasecmp(argValue, "true") == 0)
+          centroid = MS_TRUE;
 
       argValue = msLookupHashTable(tagArgs, "proj");
-      if(argValue) projectionString = argValue;
+      if (argValue)
+        projectionString = argValue;
     }
 
-    /* build the per point format strings (version 1 contains the coordinate seperator, version 2 doesn't) */
-    pointFormatLength = strlen(xh) + strlen(xf) + strlen(yh) + strlen(yf) + strlen(cs) + 12 + 1;
-    pointFormat1 = (char *) msSmallMalloc(pointFormatLength);
-    snprintf(pointFormat1, pointFormatLength, "%s%%.%dlf%s%s%%.%dlf%s%s", xh, precision, xf, yh, precision, yf, cs);
-    pointFormat2 = (char *) msSmallMalloc(pointFormatLength);
-    snprintf(pointFormat2, pointFormatLength, "%s%%.%dlf%s%s%%.%dlf%s", xh, precision, xf, yh, precision, yf);
+    /* build the per point format strings (version 1 contains the coordinate
+     * seperator, version 2 doesn't) */
+    pointFormatLength =
+        strlen(xh) + strlen(xf) + strlen(yh) + strlen(yf) + strlen(cs) + 12 + 1;
+    pointFormat1 = (char *)msSmallMalloc(pointFormatLength);
+    snprintf(pointFormat1, pointFormatLength, "%s%%.%dlf%s%s%%.%dlf%s%s", xh,
+             precision, xf, yh, precision, yf, cs);
+    pointFormat2 = (char *)msSmallMalloc(pointFormatLength);
+    snprintf(pointFormat2, pointFormatLength, "%s%%.%dlf%s%s%%.%dlf%s", xh,
+             precision, xf, yh, precision, yf);
 
     /* make a copy of the original shape or compute a centroid if necessary */
     msInitShape(&tShape);
-    if(centroid == MS_TRUE) {
+    if (centroid == MS_TRUE) {
       pointObj p;
 
-      p.x = (shape->bounds.minx + shape->bounds.maxx)/2;
-      p.y = (shape->bounds.miny + shape->bounds.maxy)/2;
+      p.x = (shape->bounds.minx + shape->bounds.maxx) / 2;
+      p.y = (shape->bounds.miny + shape->bounds.maxy) / 2;
 
       tShape.type = MS_SHAPE_POINT;
-      tShape.line = (lineObj *) msSmallMalloc(sizeof(lineObj));
+      tShape.line = (lineObj *)msSmallMalloc(sizeof(lineObj));
       tShape.numlines = 1;
       tShape.line[0].point = NULL; /* initialize the line */
       tShape.line[0].numpoints = 0;
@@ -2126,14 +2328,14 @@ static int processShpxyTag(layerObj *lay
     }
 
 #ifdef USE_GEOS
-    else if(buffer != 0 && bufferUnits != MS_PIXELS) {
-      shapeObj *bufferShape=NULL;
+    else if (buffer != 0 && bufferUnits != MS_PIXELS) {
+      shapeObj *bufferShape = NULL;
 
       bufferShape = msGEOSBuffer(shape, buffer);
-      if(!bufferShape) {
+      if (!bufferShape) {
         free(pointFormat1);
         free(pointFormat2);
-        return(MS_FAILURE); /* buffer failed */
+        return (MS_FAILURE); /* buffer failed */
       }
       msCopyShape(bufferShape, &tShape);
       msFreeShape(bufferShape);
@@ -2141,56 +2343,55 @@ static int processShpxyTag(layerObj *lay
 #endif
     else {
       status = msCopyShape(shape, &tShape);
-      if(status != 0) {
+      if (status != 0) {
         free(pointFormat1);
         free(pointFormat2);
-        return(MS_FAILURE); /* copy failed */
+        return (MS_FAILURE); /* copy failed */
       }
     }
 
-    /* no big deal to convert from file to image coordinates, but what are the image parameters */
-    if(projectionString && strcasecmp(projectionString,"image") == 0) {
+    /* no big deal to convert from file to image coordinates, but what are the
+     * image parameters */
+    if (projectionString && strcasecmp(projectionString, "image") == 0) {
       precision = 0;
 
       /* if necessary, project the shape to match the map */
-      if(msProjectionsDiffer(&(layer->projection), &(layer->map->projection)))
-      {
-        if( layer->reprojectorLayerToMap == NULL )
-        {
-            layer->reprojectorLayerToMap = msProjectCreateReprojector(
-                &layer->projection, &layer->map->projection);
-        }
-        if( layer->reprojectorLayerToMap )
-        {
-            msProjectShapeEx(layer->reprojectorLayerToMap, &tShape);
+      if (msProjectionsDiffer(&(layer->projection),
+                              &(layer->map->projection))) {
+        reprojectionObj *reprojector =
+            msLayerGetReprojectorToMap(layer, layer->map);
+        if (reprojector) {
+          msProjectShapeEx(reprojector, &tShape);
         }
       }
 
-      switch(tShape.type) {
-        case(MS_SHAPE_POINT):
-          /* no clipping necessary */
-          break;
-        case(MS_SHAPE_LINE):
-          msClipPolylineRect(&tShape, layer->map->extent);
-          break;
-        case(MS_SHAPE_POLYGON):
-          msClipPolygonRect(&tShape, layer->map->extent);
-          break;
-        default:
-          /* TO DO: need an error message here */
-          return(MS_FAILURE);
-          break;
+      switch (tShape.type) {
+      case (MS_SHAPE_POINT):
+        /* no clipping necessary */
+        break;
+      case (MS_SHAPE_LINE):
+        msClipPolylineRect(&tShape, layer->map->extent);
+        break;
+      case (MS_SHAPE_POLYGON):
+        msClipPolygonRect(&tShape, layer->map->extent);
+        break;
+      default:
+        /* TO DO: need an error message here */
+        return (MS_FAILURE);
+        break;
       }
-      msTransformShapeToPixelRound(&tShape, layer->map->extent, layer->map->cellsize);
+      msTransformShapeToPixelRound(&tShape, layer->map->extent,
+                                   layer->map->cellsize);
 
 #ifdef USE_GEOS
-      if(buffer != 0 && bufferUnits == MS_PIXELS) {
-        shapeObj *bufferShape=NULL;
+      if (buffer != 0 && bufferUnits == MS_PIXELS) {
+        shapeObj *bufferShape = NULL;
 
         bufferShape = msGEOSBuffer(&tShape, buffer);
-        if(!bufferShape) {
-          if(!msIsDegenerateShape(&tShape)) /* If shape is degenerate this is expected. */
-            return(MS_FAILURE); /* buffer failed */
+        if (!bufferShape) {
+          if (!msIsDegenerateShape(
+                  &tShape))      /* If shape is degenerate this is expected. */
+            return (MS_FAILURE); /* buffer failed */
         } else {
           msFreeShape(&tShape); /* avoid memory leak */
           msCopyShape(bufferShape, &tShape);
@@ -2199,15 +2400,16 @@ static int processShpxyTag(layerObj *lay
       }
 #endif
 
-    } else if(projectionString) {
+    } else if (projectionString) {
       projectionObj projection;
       msInitProjection(&projection);
       msProjectionInheritContextFrom(&projection, &(layer->projection));
 
       status = msLoadProjectionString(&projection, projectionString);
-      if(status != MS_SUCCESS) return MS_FAILURE;
+      if (status != MS_SUCCESS)
+        return MS_FAILURE;
 
-      if(msProjectionsDiffer(&(layer->projection), &projection))
+      if (msProjectionsDiffer(&(layer->projection), &projection))
         msProjectShape(&layer->projection, &projection, &tShape);
     }
 
@@ -2217,74 +2419,95 @@ static int processShpxyTag(layerObj *lay
     ** build the coordinate string
     */
 
-    if(strlen(sh) > 0) coords = msStringConcatenate(coords, sh);
+    if (strlen(sh) > 0)
+      coords = msStringConcatenate(coords, sh);
 
     /* do we need to handle inner/outer rings */
-    if(tShape.type == MS_SHAPE_POLYGON && strlen(orh) > 0 && strlen(irh) > 0) {
+    if (tShape.type == MS_SHAPE_POLYGON && strlen(orh) > 0 && strlen(irh) > 0) {
       int *outers;
-      int firstPart; /* to keep track of inserting part separators before each part after the first */
-      outers = msGetOuterList( &tShape );
+      int firstPart; /* to keep track of inserting part separators before each
+                        part after the first */
+      outers = msGetOuterList(&tShape);
       firstPart = 1;
       /* loop over rings looking for outers*/
-      for(i=0; i<tShape.numlines; i++) {
+      for (i = 0; i < tShape.numlines; i++) {
         int *inners;
-        if( outers[i] ) {
+        if (outers[i]) {
           /* this is an outer ring */
-          if((!firstPart) && (strlen(ps) > 0)) coords = msStringConcatenate(coords, ps);
+          if ((!firstPart) && (strlen(ps) > 0))
+            coords = msStringConcatenate(coords, ps);
           firstPart = 0;
-          if(strlen(ph) > 0) coords = msStringConcatenate(coords, ph);
+          if (strlen(ph) > 0)
+            coords = msStringConcatenate(coords, ph);
           coords = msStringConcatenate(coords, orh);
-          for(p=0; p<tShape.line[i].numpoints-1; p++) {
-            snprintf(point, sizeof(point), pointFormat1, scale_x*tShape.line[i].point[p].x, scale_y*tShape.line[i].point[p].y);
+          for (p = 0; p < tShape.line[i].numpoints - 1; p++) {
+            snprintf(point, sizeof(point), pointFormat1,
+                     scale_x * tShape.line[i].point[p].x,
+                     scale_y * tShape.line[i].point[p].y);
             coords = msStringConcatenate(coords, point);
           }
-          snprintf(point, sizeof(point), pointFormat2, scale_x*tShape.line[i].point[p].x, scale_y*tShape.line[i].point[p].y);
+          snprintf(point, sizeof(point), pointFormat2,
+                   scale_x * tShape.line[i].point[p].x,
+                   scale_y * tShape.line[i].point[p].y);
           coords = msStringConcatenate(coords, point);
           coords = msStringConcatenate(coords, orf);
 
           inners = msGetInnerList(&tShape, i, outers);
           /* loop over rings looking for inners to this outer */
-          for(j=0; j<tShape.numlines; j++) {
-            if( inners[j] ) {
+          for (j = 0; j < tShape.numlines; j++) {
+            if (inners[j]) {
               /* j is an inner ring of i */
               coords = msStringConcatenate(coords, irh);
-              for(p=0; p<tShape.line[j].numpoints-1; p++) {
-                snprintf(point, sizeof(point), pointFormat1, scale_x*tShape.line[j].point[p].x, scale_y*tShape.line[j].point[p].y);
+              for (p = 0; p < tShape.line[j].numpoints - 1; p++) {
+                snprintf(point, sizeof(point), pointFormat1,
+                         scale_x * tShape.line[j].point[p].x,
+                         scale_y * tShape.line[j].point[p].y);
                 coords = msStringConcatenate(coords, point);
               }
-              snprintf(point, sizeof(point), pointFormat2, scale_x*tShape.line[j].point[p].x, scale_y*tShape.line[j].point[p].y);
+              snprintf(point, sizeof(point), pointFormat2,
+                       scale_x * tShape.line[j].point[p].x,
+                       scale_y * tShape.line[j].point[p].y);
               coords = msStringConcatenate(coords, irf);
             }
           }
-          free( inners );
-          if(strlen(pf) > 0) coords = msStringConcatenate(coords, pf);
+          free(inners);
+          if (strlen(pf) > 0)
+            coords = msStringConcatenate(coords, pf);
         }
       } /* end of loop over outer rings */
-      free( outers );
+      free(outers);
     } else { /* output without ring formatting */
 
-      for(i=0; i<tShape.numlines; i++) { /* e.g. part */
+      for (i = 0; i < tShape.numlines; i++) { /* e.g. part */
 
         /* skip degenerate parts, really should only happen with pixel output */
-        if((tShape.type == MS_SHAPE_LINE && tShape.line[i].numpoints < 2) ||
+        if ((tShape.type == MS_SHAPE_LINE && tShape.line[i].numpoints < 2) ||
             (tShape.type == MS_SHAPE_POLYGON && tShape.line[i].numpoints < 3))
           continue;
 
-        if(strlen(ph) > 0) coords = msStringConcatenate(coords, ph);
+        if (strlen(ph) > 0)
+          coords = msStringConcatenate(coords, ph);
 
-        for(p=0; p<tShape.line[i].numpoints-1; p++) {
-          snprintf(point, sizeof(point), pointFormat1, scale_x*tShape.line[i].point[p].x, scale_y*tShape.line[i].point[p].y);
+        for (p = 0; p < tShape.line[i].numpoints - 1; p++) {
+          snprintf(point, sizeof(point), pointFormat1,
+                   scale_x * tShape.line[i].point[p].x,
+                   scale_y * tShape.line[i].point[p].y);
           coords = msStringConcatenate(coords, point);
         }
-        snprintf(point, sizeof(point), pointFormat2, scale_x*tShape.line[i].point[p].x, scale_y*tShape.line[i].point[p].y);
+        snprintf(point, sizeof(point), pointFormat2,
+                 scale_x * tShape.line[i].point[p].x,
+                 scale_y * tShape.line[i].point[p].y);
         coords = msStringConcatenate(coords, point);
 
-        if(strlen(pf) > 0) coords = msStringConcatenate(coords, pf);
+        if (strlen(pf) > 0)
+          coords = msStringConcatenate(coords, pf);
 
-        if((i < tShape.numlines-1) && (strlen(ps) > 0)) coords = msStringConcatenate(coords, ps);
+        if ((i < tShape.numlines - 1) && (strlen(ps) > 0))
+          coords = msStringConcatenate(coords, ps);
       }
     }
-    if(strlen(sf) > 0) coords = msStringConcatenate(coords, sf);
+    if (strlen(sf) > 0)
+      coords = msStringConcatenate(coords, sf);
 
     msFreeShape(&tShape);
 
@@ -2294,8 +2517,8 @@ static int processShpxyTag(layerObj *lay
 
     /* build the complete tag so we can do substitution */
     tagLength = tagEnd - tagStart;
-    tag = (char *) msSmallMalloc(tagLength + 1);
-    strlcpy(tag, tagStart, tagLength+1);
+    tag = (char *)msSmallMalloc(tagLength + 1);
+    strlcpy(tag, tagStart, tagLength + 1);
 
     /* do the replacement */
     *line = msReplaceSubstring(*line, tag, coords);
@@ -2304,7 +2527,7 @@ static int processShpxyTag(layerObj *lay
     free(tag);
     tag = NULL;
     msFreeHashTable(tagArgs);
-    tagArgs=NULL;
+    tagArgs = NULL;
     free(pointFormat1);
     pointFormat1 = NULL;
     free(pointFormat2);
@@ -2312,13 +2535,13 @@ static int processShpxyTag(layerObj *lay
     free(coords);
     coords = NULL;
 
-    if((*line)[tagOffset] != '\0')
-      tagStart = findTag(*line+tagOffset+1, "shpxy");
+    if ((*line)[tagOffset] != '\0')
+      tagStart = findTag(*line + tagOffset + 1, "shpxy");
     else
       tagStart = NULL;
   }
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
 /*!
@@ -2327,9 +2550,8 @@ static int processShpxyTag(layerObj *lay
  * metadata value.
  *
  * this function return a modified pszInstr
-*/
-int processMetadata(char** pszInstr, hashTableObj *ht)
-{
+ */
+int processMetadata(char **pszInstr, hashTableObj *ht) {
   /* char *pszNextInstr = pszInstr; */
   char *pszEnd, *pszStart;
   char *pszMetadataTag;
@@ -2339,7 +2561,7 @@ int processMetadata(char** pszInstr, has
 
   hashTableObj *metadataArgs = NULL;
 
-  if(!*pszInstr) {
+  if (!*pszInstr) {
     msSetError(MS_WEBERR, "Invalid pointer.", "processMetadata()");
     return MS_FAILURE;
   }
@@ -2349,7 +2571,7 @@ int processMetadata(char** pszInstr, has
 
   while (pszStart) {
     /* get metadata args */
-    if(getTagArgs("metadata", pszStart, &metadataArgs) != MS_SUCCESS)
+    if (getTagArgs("metadata", pszStart, &metadataArgs) != MS_SUCCESS)
       return MS_FAILURE;
 
     pszHashName = msLookupHashTable(metadataArgs, "name");
@@ -2357,7 +2579,7 @@ int processMetadata(char** pszInstr, has
 
     nOffset = pszStart - *pszInstr;
 
-    if(pszHashName && pszHashValue) {
+    if (pszHashName && pszHashValue) {
       /* set position to the end of metadata start tag */
       pszEnd = strchr(pszStart, ']');
       pszEnd++;
@@ -2365,22 +2587,21 @@ int processMetadata(char** pszInstr, has
       /* build the complete metadata tag ([metadata all_args]) */
       /* to replace it by the corresponding value from ht */
       nLength = pszEnd - pszStart;
-      pszMetadataTag = (char*)msSmallMalloc(nLength + 1);
-      strlcpy(pszMetadataTag, pszStart, nLength+1);
+      pszMetadataTag = (char *)msSmallMalloc(nLength + 1);
+      strlcpy(pszMetadataTag, pszStart, nLength + 1);
 
       *pszInstr = msReplaceSubstring(*pszInstr, pszMetadataTag, pszHashValue);
 
       free(pszMetadataTag);
-      pszMetadataTag=NULL;
+      pszMetadataTag = NULL;
     }
 
     msFreeHashTable(metadataArgs);
-    metadataArgs=NULL;
-
+    metadataArgs = NULL;
 
     /* set position to the begining of the next metadata tag */
-    if((*pszInstr)[nOffset] != '\0')
-      pszStart = findTag(*pszInstr+nOffset+1, "metadata");
+    if ((*pszInstr)[nOffset] != '\0')
+      pszStart = findTag(*pszInstr + nOffset + 1, "metadata");
     else
       pszStart = NULL;
   }
@@ -2393,18 +2614,16 @@ int processMetadata(char** pszInstr, has
  * from pszInstr.
  *
  * This func return a modified pszInstr.
-*/
-int processIcon(mapObj *map, int nIdxLayer, int nIdxClass, char** pszInstr, char* pszPrefix)
-{
+ */
+int processIcon(mapObj *map, int nIdxLayer, int nIdxClass, char **pszInstr,
+                char *pszPrefix) {
   int nWidth, nHeight, nLen;
-  char szImgFname[1024], *pszFullImgFname=NULL, *pszImgTag;
+  char szImgFname[1024], *pszFullImgFname = NULL, *pszImgTag;
   char szPath[MS_MAXPATHLEN];
-  hashTableObj *myHashTable=NULL;
+  hashTableObj *myHashTable = NULL;
   FILE *fIcon;
 
-  if(!map ||
-      nIdxLayer > map->numlayers ||
-      nIdxLayer < 0 ) {
+  if (!map || nIdxLayer > map->numlayers || nIdxLayer < 0) {
     msSetError(MS_WEBERR, "Invalid pointer.", "processIcon()");
     return MS_FAILURE;
   }
@@ -2415,67 +2634,68 @@ int processIcon(mapObj *map, int nIdxLay
   while (pszImgTag) {
     int i;
     char szStyleCode[512] = "";
-    classObj *thisClass=NULL;
+    classObj *thisClass = NULL;
 
-    /* It's okay to have no classes... we'll generate an empty icon in this case */
-    if(nIdxClass >= 0 && nIdxClass < GET_LAYER(map, nIdxLayer)->numclasses)
+    /* It's okay to have no classes... we'll generate an empty icon in this case
+     */
+    if (nIdxClass >= 0 && nIdxClass < GET_LAYER(map, nIdxLayer)->numclasses)
       thisClass = GET_LAYER(map, nIdxLayer)->class[nIdxClass];
 
-    if(getTagArgs("leg_icon", pszImgTag, &myHashTable) != MS_SUCCESS)
+    if (getTagArgs("leg_icon", pszImgTag, &myHashTable) != MS_SUCCESS)
       return MS_FAILURE;
 
     /* if no specified width or height, set them to map default */
-    if(!msLookupHashTable(myHashTable, "width") || !msLookupHashTable(myHashTable, "height")) {
+    if (!msLookupHashTable(myHashTable, "width") ||
+        !msLookupHashTable(myHashTable, "height")) {
       nWidth = map->legend.keysizex;
-      nHeight= map->legend.keysizey;
+      nHeight = map->legend.keysizey;
     } else {
-      nWidth  = atoi(msLookupHashTable(myHashTable, "width"));
+      nWidth = atoi(msLookupHashTable(myHashTable, "width"));
       nHeight = atoi(msLookupHashTable(myHashTable, "height"));
     }
 
     /* Create a unique and predictable filename to cache the legend icons.
      * Include some key parameters from the first 2 styles
      */
-    for(i=0; i<2 && thisClass && i<thisClass->numstyles; i++) {
+    for (i = 0; i < 2 && thisClass && i < thisClass->numstyles; i++) {
       styleObj *style;
       char *pszSymbolNameHash = NULL;
       style = thisClass->styles[i];
-      if(style->symbolname)
+      if (style->symbolname)
         pszSymbolNameHash = msHashString(style->symbolname);
 
-      snprintf(szStyleCode+strlen(szStyleCode), 255,
-               "s%d_%x_%x_%d_%s_%g",
-               i, MS_COLOR_GETRGB(style->color),MS_COLOR_GETRGB(style->outlinecolor),
-               style->symbol, pszSymbolNameHash?pszSymbolNameHash:"",
-               style->angle);
+      snprintf(szStyleCode + strlen(szStyleCode), 255, "s%d_%x_%x_%d_%s_%g", i,
+               MS_COLOR_GETRGB(style->color),
+               MS_COLOR_GETRGB(style->outlinecolor), style->symbol,
+               pszSymbolNameHash ? pszSymbolNameHash : "", style->angle);
       msFree(pszSymbolNameHash);
     }
 
     snprintf(szImgFname, sizeof(szImgFname), "%s_%d_%d_%d_%d_%s.%s%c",
-             pszPrefix, nIdxLayer, nIdxClass, nWidth, nHeight,
-             szStyleCode, MS_IMAGE_EXTENSION(map->outputformat),'\0');
+             pszPrefix, nIdxLayer, nIdxClass, nWidth, nHeight, szStyleCode,
+             MS_IMAGE_EXTENSION(map->outputformat), '\0');
 
-    pszFullImgFname = msStrdup(msBuildPath3(szPath, map->mappath,
-                                            map->web.imagepath, szImgFname));
+    pszFullImgFname = msStrdup(
+        msBuildPath3(szPath, map->mappath, map->web.imagepath, szImgFname));
 
     /* check if icon already exist in cache */
-    if((fIcon = fopen(pszFullImgFname, "r")) != NULL) {
+    if ((fIcon = fopen(pszFullImgFname, "r")) != NULL) {
       /* File already exists. No need to generate it again */
       fclose(fIcon);
     } else {
       /* Create an image corresponding to the current class */
-      imageObj *img=NULL;
+      imageObj *img = NULL;
 
-      if(thisClass == NULL) {
+      if (thisClass == NULL) {
         /* Nonexistent class.  Create an empty image */
         img = msCreateLegendIcon(map, NULL, NULL, nWidth, nHeight, MS_TRUE);
       } else {
-        img = msCreateLegendIcon(map, GET_LAYER(map, nIdxLayer),
-                                 thisClass, nWidth, nHeight, MS_TRUE);
+        img = msCreateLegendIcon(map, GET_LAYER(map, nIdxLayer), thisClass,
+                                 nWidth, nHeight, MS_TRUE);
       }
 
-      if(!img) {
-        if(myHashTable)
+      if (!img) {
+        if (myHashTable)
           msFreeHashTable(myHashTable);
 
         msSetError(MS_IMGERR, "Error while creating image.", "processIcon()");
@@ -2483,13 +2703,14 @@ int processIcon(mapObj *map, int nIdxLay
       }
 
       /* save it with a unique file name */
-      if(msSaveImage(map, img, pszFullImgFname) != MS_SUCCESS) {
-        if(myHashTable)
+      if (msSaveImage(map, img, pszFullImgFname) != MS_SUCCESS) {
+        if (myHashTable)
           msFreeHashTable(myHashTable);
 
         msFreeImage(img);
 
-        msSetError(MS_IOERR, "Error saving GD image to disk (%s).", "processIcon()", pszFullImgFname);
+        msSetError(MS_IOERR, "Error saving GD image to disk (%s).",
+                   "processIcon()", pszFullImgFname);
         msFree(pszFullImgFname);
         return MS_FAILURE;
       }
@@ -2502,15 +2723,16 @@ int processIcon(mapObj *map, int nIdxLay
 
     nLen = (strchr(pszImgTag, ']') + 1) - pszImgTag;
 
-    if(nLen > 0) {
+    if (nLen > 0) {
       char *pszTag;
 
       /* rebuid image tag ([leg_class_img all_args]) */
       /* to replace it by the image url */
-      pszTag = (char*)msSmallMalloc(nLen + 1);
-      strlcpy(pszTag, pszImgTag, nLen+1);
+      pszTag = (char *)msSmallMalloc(nLen + 1);
+      strlcpy(pszTag, pszImgTag, nLen + 1);
 
-      pszFullImgFname = (char*)msSmallMalloc(strlen(map->web.imageurl) + strlen(szImgFname) + 1);
+      pszFullImgFname = (char *)msSmallMalloc(strlen(map->web.imageurl) +
+                                              strlen(szImgFname) + 1);
       strcpy(pszFullImgFname, map->web.imageurl);
       strcat(pszFullImgFname, szImgFname);
 
@@ -2526,7 +2748,7 @@ int processIcon(mapObj *map, int nIdxLay
       pszImgTag = NULL;
     }
 
-    if(myHashTable) {
+    if (myHashTable) {
       msFreeHashTable(myHashTable);
       myHashTable = NULL;
     }
@@ -2543,9 +2765,10 @@ int processIcon(mapObj *map, int nIdxLay
  * the template with correct values.
  *
  * buffer must be freed by caller.
-*/
-int generateGroupTemplate(char* pszGroupTemplate, mapObj *map, char* pszGroupName, hashTableObj *oGroupArgs, char **pszTemp, char* pszPrefix)
-{
+ */
+int generateGroupTemplate(char *pszGroupTemplate, mapObj *map,
+                          char *pszGroupName, hashTableObj *oGroupArgs,
+                          char **pszTemp, char *pszPrefix) {
   hashTableObj *myHashTable;
   char pszStatus[3];
   char *pszClassImg;
@@ -2556,7 +2779,7 @@ int generateGroupTemplate(char* pszGroup
 
   *pszTemp = NULL;
 
-  if(!pszGroupName || !pszGroupTemplate) {
+  if (!pszGroupName || !pszGroupTemplate) {
     msSetError(MS_WEBERR, "Invalid pointer.", "generateGroupTemplate()");
     return MS_FAILURE;
   }
@@ -2564,10 +2787,10 @@ int generateGroupTemplate(char* pszGroup
   /*
    * Get the opt_flag is any.
    */
-  if(oGroupArgs)
+  if (oGroupArgs)
     pszOptFlag = msLookupHashTable(oGroupArgs, "opt_flag");
 
-  if(pszOptFlag)
+  if (pszOptFlag)
     nOptFlag = atoi(pszOptFlag);
 
   /*
@@ -2576,47 +2799,49 @@ int generateGroupTemplate(char* pszGroup
    * (Check for opt_flag)
    */
   bShowGroup = 0;
-  for (j=0; j<map->numlayers; j++) {
-    if(GET_LAYER(map, map->layerorder[j])->group &&
+  for (j = 0; j < map->numlayers; j++) {
+    if (GET_LAYER(map, map->layerorder[j])->group &&
         strcmp(GET_LAYER(map, map->layerorder[j])->group, pszGroupName) == 0) {
       /* dont display layer is off. */
-      if( (nOptFlag & 2) == 0 &&
-          GET_LAYER(map, map->layerorder[j])->status == MS_OFF )
+      if ((nOptFlag & 2) == 0 &&
+          GET_LAYER(map, map->layerorder[j])->status == MS_OFF)
         bShowGroup = 0;
       else
         bShowGroup = 1;
 
       /* dont display layer is query. */
-      if( (nOptFlag & 4) == 0  &&
-          GET_LAYER(map, map->layerorder[j])->type == MS_LAYER_QUERY )
+      if ((nOptFlag & 4) == 0 &&
+          GET_LAYER(map, map->layerorder[j])->type == MS_LAYER_QUERY)
         bShowGroup = 0;
 
       /* dont display layer if out of scale. */
-      if((nOptFlag & 1) == 0) {
-        if(map->scaledenom > 0) {
-          if((GET_LAYER(map, map->layerorder[j])->maxscaledenom > 0) &&
-              (map->scaledenom > GET_LAYER(map, map->layerorder[j])->maxscaledenom))
+      if ((nOptFlag & 1) == 0) {
+        if (map->scaledenom > 0) {
+          if ((GET_LAYER(map, map->layerorder[j])->maxscaledenom > 0) &&
+              (map->scaledenom >
+               GET_LAYER(map, map->layerorder[j])->maxscaledenom))
             bShowGroup = 0;
-          if((GET_LAYER(map, map->layerorder[j])->minscaledenom > 0) &&
-              (map->scaledenom <= GET_LAYER(map, map->layerorder[j])->minscaledenom))
+          if ((GET_LAYER(map, map->layerorder[j])->minscaledenom > 0) &&
+              (map->scaledenom <=
+               GET_LAYER(map, map->layerorder[j])->minscaledenom))
             bShowGroup = 0;
         }
       }
 
       /* The group contains one visible layer */
       /* Draw the group */
-      if( bShowGroup )
+      if (bShowGroup)
         break;
     }
   }
 
-  if( ! bShowGroup )
+  if (!bShowGroup)
     return MS_SUCCESS;
 
   /*
    * Work from a copy
    */
-  *pszTemp = (char*)msSmallMalloc(strlen(pszGroupTemplate) + 1);
+  *pszTemp = (char *)msSmallMalloc(strlen(pszGroupTemplate) + 1);
   strcpy(*pszTemp, pszGroupTemplate);
 
   /*
@@ -2624,7 +2849,6 @@ int generateGroupTemplate(char* pszGroup
    */
   *pszTemp = msReplaceSubstring(*pszTemp, "[leg_group_name]", pszGroupName);
 
-
   /*
    * Create a hash table that contain info
    * on current layer
@@ -2636,21 +2860,31 @@ int generateGroupTemplate(char* pszGroup
    * that belong to this group.
    * Get his status and check for if.
    */
-  for (j=0; j<map->numlayers; j++) {
-    if(GET_LAYER(map, map->layerorder[j])->group && strcmp(GET_LAYER(map, map->layerorder[j])->group, pszGroupName) == 0) {
-      snprintf(pszStatus, sizeof(pszStatus), "%d", GET_LAYER(map, map->layerorder[j])->status);
+  for (j = 0; j < map->numlayers; j++) {
+    if (GET_LAYER(map, map->layerorder[j])->group &&
+        strcmp(GET_LAYER(map, map->layerorder[j])->group, pszGroupName) == 0) {
+      snprintf(pszStatus, sizeof(pszStatus), "%d",
+               GET_LAYER(map, map->layerorder[j])->status);
       msInsertHashTable(myHashTable, "layer_status", pszStatus);
-      msInsertHashTable(myHashTable, "layer_visible", msLayerIsVisible(map, GET_LAYER(map, map->layerorder[j]))?"1":"0" );
-      msInsertHashTable(myHashTable, "layer_queryable", msIsLayerQueryable(GET_LAYER(map, map->layerorder[j]))?"1":"0" );
+      msInsertHashTable(
+          myHashTable, "layer_visible",
+          msLayerIsVisible(map, GET_LAYER(map, map->layerorder[j])) ? "1"
+                                                                    : "0");
+      msInsertHashTable(
+          myHashTable, "layer_queryable",
+          msIsLayerQueryable(GET_LAYER(map, map->layerorder[j])) ? "1" : "0");
       msInsertHashTable(myHashTable, "group_name", pszGroupName);
 
-      if(processIfTag(pszTemp, myHashTable, MS_FALSE) != MS_SUCCESS)
+      if (processIfTag(pszTemp, myHashTable, MS_FALSE) != MS_SUCCESS)
         return MS_FAILURE;
 
-      if(processIfTag(pszTemp, &(GET_LAYER(map, map->layerorder[j])->metadata), MS_FALSE) != MS_SUCCESS)
+      if (processIfTag(pszTemp, &(GET_LAYER(map, map->layerorder[j])->metadata),
+                       MS_FALSE) != MS_SUCCESS)
         return MS_FAILURE;
 
-      if(processMetadata(pszTemp, &GET_LAYER(map, map->layerorder[j])->metadata) != MS_SUCCESS)
+      if (processMetadata(pszTemp,
+                          &GET_LAYER(map, map->layerorder[j])->metadata) !=
+          MS_SUCCESS)
         return MS_FAILURE;
 
       break;
@@ -2662,14 +2896,14 @@ int generateGroupTemplate(char* pszGroup
   /*
    * Process all metadata tags
    * only web object is accessible
-  */
-  if(processMetadata(pszTemp, &(map->web.metadata)) != MS_SUCCESS)
+   */
+  if (processMetadata(pszTemp, &(map->web.metadata)) != MS_SUCCESS)
     return MS_FAILURE;
 
   /*
    * check for if tag
-  */
-  if(processIfTag(pszTemp, &(map->web.metadata), MS_TRUE) != MS_SUCCESS)
+   */
+  if (processIfTag(pszTemp, &(map->web.metadata), MS_TRUE) != MS_SUCCESS)
     return MS_FAILURE;
 
   /*
@@ -2677,10 +2911,11 @@ int generateGroupTemplate(char* pszGroup
    * if so display the first layer first class icon
    */
   pszClassImg = strstr(*pszTemp, "[leg_icon");
-  if(pszClassImg) {
+  if (pszClassImg) {
     /* find first layer of this group */
-    for (i=0; i<map->numlayers; i++)
-      if(GET_LAYER(map, map->layerorder[i])->group && strcmp(GET_LAYER(map, map->layerorder[i])->group, pszGroupName) == 0)
+    for (i = 0; i < map->numlayers; i++)
+      if (GET_LAYER(map, map->layerorder[i])->group &&
+          strcmp(GET_LAYER(map, map->layerorder[i])->group, pszGroupName) == 0)
         processIcon(map, map->layerorder[i], 0, pszTemp, pszPrefix);
   }
 
@@ -2695,56 +2930,58 @@ int generateGroupTemplate(char* pszGroup
  * the template with correct values.
  *
  * buffer must be freed by caller.
-*/
-int generateLayerTemplate(char *pszLayerTemplate, mapObj *map, int nIdxLayer, hashTableObj *oLayerArgs, char **pszTemp, char* pszPrefix)
-{
+ */
+int generateLayerTemplate(char *pszLayerTemplate, mapObj *map, int nIdxLayer,
+                          hashTableObj *oLayerArgs, char **pszTemp,
+                          char *pszPrefix) {
   hashTableObj *myHashTable;
   char szStatus[10];
   char szType[10];
 
-  int nOptFlag=0;
+  int nOptFlag = 0;
   const char *pszOptFlag = NULL;
   char *pszClassImg;
 
-  char szTmpstr[128]; /* easily big enough for the couple of instances we need */
+  char
+      szTmpstr[128]; /* easily big enough for the couple of instances we need */
 
   *pszTemp = NULL;
 
-  if(!pszLayerTemplate ||
-      !map ||
-      nIdxLayer > map->numlayers ||
-      nIdxLayer < 0 ) {
+  if (!pszLayerTemplate || !map || nIdxLayer > map->numlayers ||
+      nIdxLayer < 0) {
     msSetError(MS_WEBERR, "Invalid pointer.", "generateLayerTemplate()");
     return MS_FAILURE;
   }
 
-  if(oLayerArgs)
+  if (oLayerArgs)
     pszOptFlag = msLookupHashTable(oLayerArgs, "opt_flag");
 
-  if(pszOptFlag)
+  if (pszOptFlag)
     nOptFlag = atoi(pszOptFlag);
 
   /* don't display deleted layers */
-  if(GET_LAYER(map, nIdxLayer)->status == MS_DELETE)
+  if (GET_LAYER(map, nIdxLayer)->status == MS_DELETE)
     return MS_SUCCESS;
 
   /* dont display layer is off. */
   /* check this if Opt flag is not set */
-  if((nOptFlag & 2) == 0 && GET_LAYER(map, nIdxLayer)->status == MS_OFF)
+  if ((nOptFlag & 2) == 0 && GET_LAYER(map, nIdxLayer)->status == MS_OFF)
     return MS_SUCCESS;
 
   /* dont display layer is query. */
   /* check this if Opt flag is not set */
-  if((nOptFlag & 4) == 0  && GET_LAYER(map, nIdxLayer)->type == MS_LAYER_QUERY)
+  if ((nOptFlag & 4) == 0 && GET_LAYER(map, nIdxLayer)->type == MS_LAYER_QUERY)
     return MS_SUCCESS;
 
   /* dont display layer if out of scale. */
   /* check this if Opt flag is not set             */
-  if((nOptFlag & 1) == 0) {
-    if(map->scaledenom > 0) {
-      if((GET_LAYER(map, nIdxLayer)->maxscaledenom > 0) && (map->scaledenom > GET_LAYER(map, nIdxLayer)->maxscaledenom))
+  if ((nOptFlag & 1) == 0) {
+    if (map->scaledenom > 0) {
+      if ((GET_LAYER(map, nIdxLayer)->maxscaledenom > 0) &&
+          (map->scaledenom > GET_LAYER(map, nIdxLayer)->maxscaledenom))
         return MS_SUCCESS;
-      if((GET_LAYER(map, nIdxLayer)->minscaledenom > 0) && (map->scaledenom <= GET_LAYER(map, nIdxLayer)->minscaledenom))
+      if ((GET_LAYER(map, nIdxLayer)->minscaledenom > 0) &&
+          (map->scaledenom <= GET_LAYER(map, nIdxLayer)->minscaledenom))
         return MS_SUCCESS;
     }
   }
@@ -2757,18 +2994,24 @@ int generateLayerTemplate(char *pszLayer
   /*
    * Change layer tags
    */
-  *pszTemp = msReplaceSubstring(*pszTemp, "[leg_layer_name]", GET_LAYER(map, nIdxLayer)->name);
-  *pszTemp = msReplaceSubstring(*pszTemp, "[leg_layer_group]", GET_LAYER(map, nIdxLayer)->group);
+  *pszTemp = msReplaceSubstring(*pszTemp, "[leg_layer_name]",
+                                GET_LAYER(map, nIdxLayer)->name);
+  *pszTemp = msReplaceSubstring(*pszTemp, "[leg_layer_group]",
+                                GET_LAYER(map, nIdxLayer)->group);
 
   snprintf(szTmpstr, sizeof(szTmpstr), "%d", nIdxLayer);
   *pszTemp = msReplaceSubstring(*pszTemp, "[leg_layer_index]", szTmpstr);
 
-  snprintf(szTmpstr, sizeof(szTmpstr), "%g", GET_LAYER(map, nIdxLayer)->minscaledenom);
+  snprintf(szTmpstr, sizeof(szTmpstr), "%g",
+           GET_LAYER(map, nIdxLayer)->minscaledenom);
   *pszTemp = msReplaceSubstring(*pszTemp, "[leg_layer_minscale]", szTmpstr);
-  *pszTemp = msReplaceSubstring(*pszTemp, "[leg_layer_minscaledenom]", szTmpstr);
-  snprintf(szTmpstr, sizeof(szTmpstr), "%g", GET_LAYER(map, nIdxLayer)->maxscaledenom);
+  *pszTemp =
+      msReplaceSubstring(*pszTemp, "[leg_layer_minscaledenom]", szTmpstr);
+  snprintf(szTmpstr, sizeof(szTmpstr), "%g",
+           GET_LAYER(map, nIdxLayer)->maxscaledenom);
   *pszTemp = msReplaceSubstring(*pszTemp, "[leg_layer_maxscale]", szTmpstr);
-  *pszTemp = msReplaceSubstring(*pszTemp, "[leg_layer_maxscaledenom]", szTmpstr);
+  *pszTemp =
+      msReplaceSubstring(*pszTemp, "[leg_layer_maxscaledenom]", szTmpstr);
 
   /*
    * Create a hash table that contain info
@@ -2785,18 +3028,27 @@ int generateLayerTemplate(char *pszLayer
   snprintf(szType, sizeof(szType), "%d", GET_LAYER(map, nIdxLayer)->type);
   msInsertHashTable(myHashTable, "layer_type", szType);
 
-  msInsertHashTable(myHashTable, "layer_name", (GET_LAYER(map, nIdxLayer)->name)? GET_LAYER(map, nIdxLayer)->name : "");
-  msInsertHashTable(myHashTable, "layer_group", (GET_LAYER(map, nIdxLayer)->group)? GET_LAYER(map, nIdxLayer)->group : "");
-  msInsertHashTable(myHashTable, "layer_visible", msLayerIsVisible(map, GET_LAYER(map, nIdxLayer))?"1":"0" );
-  msInsertHashTable(myHashTable, "layer_queryable", msIsLayerQueryable(GET_LAYER(map, nIdxLayer))?"1":"0" );
+  msInsertHashTable(
+      myHashTable, "layer_name",
+      (GET_LAYER(map, nIdxLayer)->name) ? GET_LAYER(map, nIdxLayer)->name : "");
+  msInsertHashTable(myHashTable, "layer_group",
+                    (GET_LAYER(map, nIdxLayer)->group)
+                        ? GET_LAYER(map, nIdxLayer)->group
+                        : "");
+  msInsertHashTable(myHashTable, "layer_visible",
+                    msLayerIsVisible(map, GET_LAYER(map, nIdxLayer)) ? "1"
+                                                                     : "0");
+  msInsertHashTable(myHashTable, "layer_queryable",
+                    msIsLayerQueryable(GET_LAYER(map, nIdxLayer)) ? "1" : "0");
 
-  if(processIfTag(pszTemp, myHashTable, MS_FALSE) != MS_SUCCESS)
+  if (processIfTag(pszTemp, myHashTable, MS_FALSE) != MS_SUCCESS)
     return MS_FAILURE;
 
-  if(processIfTag(pszTemp, &(GET_LAYER(map, nIdxLayer)->metadata), MS_FALSE) != MS_SUCCESS)
+  if (processIfTag(pszTemp, &(GET_LAYER(map, nIdxLayer)->metadata), MS_FALSE) !=
+      MS_SUCCESS)
     return MS_FAILURE;
 
-  if(processIfTag(pszTemp, &(map->web.metadata), MS_TRUE) != MS_SUCCESS)
+  if (processIfTag(pszTemp, &(map->web.metadata), MS_TRUE) != MS_SUCCESS)
     return MS_FAILURE;
 
   msFreeHashTable(myHashTable);
@@ -2806,18 +3058,19 @@ int generateLayerTemplate(char *pszLayer
    * if so display the first class icon
    */
   pszClassImg = strstr(*pszTemp, "[leg_icon");
-  if(pszClassImg) {
+  if (pszClassImg) {
     processIcon(map, nIdxLayer, 0, pszTemp, pszPrefix);
   }
 
   /* process all metadata tags
    * only current layer and web object
    * metaddata are accessible
-  */
-  if(processMetadata(pszTemp, &GET_LAYER(map, nIdxLayer)->metadata) != MS_SUCCESS)
+   */
+  if (processMetadata(pszTemp, &GET_LAYER(map, nIdxLayer)->metadata) !=
+      MS_SUCCESS)
     return MS_FAILURE;
 
-  if(processMetadata(pszTemp, &(map->web.metadata)) != MS_SUCCESS)
+  if (processMetadata(pszTemp, &(map->web.metadata)) != MS_SUCCESS)
     return MS_FAILURE;
 
   return MS_SUCCESS;
@@ -2831,59 +3084,60 @@ int generateLayerTemplate(char *pszLayer
  * the template with correct values.
  *
  * buffer must be freed by caller.
-*/
-int generateClassTemplate(char* pszClassTemplate, mapObj *map, int nIdxLayer, int nIdxClass, hashTableObj *oClassArgs, char **pszTemp, char* pszPrefix)
-{
+ */
+int generateClassTemplate(char *pszClassTemplate, mapObj *map, int nIdxLayer,
+                          int nIdxClass, hashTableObj *oClassArgs,
+                          char **pszTemp, char *pszPrefix) {
   hashTableObj *myHashTable;
   char szStatus[10];
   char szType[10];
 
   char *pszClassImg;
-  int nOptFlag=0;
+  int nOptFlag = 0;
   const char *pszOptFlag = NULL;
 
-  char szTmpstr[128]; /* easily big enough for the couple of instances we need */
+  char
+      szTmpstr[128]; /* easily big enough for the couple of instances we need */
 
   *pszTemp = NULL;
 
-  if(!pszClassTemplate ||
-      !map ||
-      nIdxLayer > map->numlayers ||
-      nIdxLayer < 0 ||
-      nIdxClass > GET_LAYER(map, nIdxLayer)->numclasses ||
+  if (!pszClassTemplate || !map || nIdxLayer > map->numlayers ||
+      nIdxLayer < 0 || nIdxClass > GET_LAYER(map, nIdxLayer)->numclasses ||
       nIdxClass < 0) {
 
     msSetError(MS_WEBERR, "Invalid pointer.", "generateClassTemplate()");
     return MS_FAILURE;
   }
 
-  if(oClassArgs)
+  if (oClassArgs)
     pszOptFlag = msLookupHashTable(oClassArgs, "Opt_flag");
 
-  if(pszOptFlag)
+  if (pszOptFlag)
     nOptFlag = atoi(pszOptFlag);
 
   /* don't display deleted layers */
-  if(GET_LAYER(map, nIdxLayer)->status == MS_DELETE)
+  if (GET_LAYER(map, nIdxLayer)->status == MS_DELETE)
     return MS_SUCCESS;
 
   /* dont display class if layer is off. */
   /* check this if Opt flag is not set */
-  if((nOptFlag & 2) == 0 && GET_LAYER(map, nIdxLayer)->status == MS_OFF)
+  if ((nOptFlag & 2) == 0 && GET_LAYER(map, nIdxLayer)->status == MS_OFF)
     return MS_SUCCESS;
 
   /* dont display class if layer is query. */
   /* check this if Opt flag is not set       */
-  if((nOptFlag & 4) == 0 && GET_LAYER(map, nIdxLayer)->type == MS_LAYER_QUERY)
+  if ((nOptFlag & 4) == 0 && GET_LAYER(map, nIdxLayer)->type == MS_LAYER_QUERY)
     return MS_SUCCESS;
 
   /* dont display layer if out of scale. */
   /* check this if Opt flag is not set */
-  if((nOptFlag & 1) == 0) {
-    if(map->scaledenom > 0) {
-      if((GET_LAYER(map, nIdxLayer)->maxscaledenom > 0) && (map->scaledenom > GET_LAYER(map, nIdxLayer)->maxscaledenom))
+  if ((nOptFlag & 1) == 0) {
+    if (map->scaledenom > 0) {
+      if ((GET_LAYER(map, nIdxLayer)->maxscaledenom > 0) &&
+          (map->scaledenom > GET_LAYER(map, nIdxLayer)->maxscaledenom))
         return MS_SUCCESS;
-      if((GET_LAYER(map, nIdxLayer)->minscaledenom > 0) && (map->scaledenom <= GET_LAYER(map, nIdxLayer)->minscaledenom))
+      if ((GET_LAYER(map, nIdxLayer)->minscaledenom > 0) &&
+          (map->scaledenom <= GET_LAYER(map, nIdxLayer)->minscaledenom))
         return MS_SUCCESS;
     }
   }
@@ -2891,25 +3145,34 @@ int generateClassTemplate(char* pszClass
   /*
    * Work from a copy
    */
-  *pszTemp = (char*)msSmallMalloc(strlen(pszClassTemplate) + 1);
+  *pszTemp = (char *)msSmallMalloc(strlen(pszClassTemplate) + 1);
   strcpy(*pszTemp, pszClassTemplate);
 
   /*
    * Change class tags
    */
-  *pszTemp = msReplaceSubstring(*pszTemp, "[leg_class_name]", GET_LAYER(map, nIdxLayer)->class[nIdxClass]->name);
-  *pszTemp = msReplaceSubstring(*pszTemp, "[leg_class_title]", GET_LAYER(map, nIdxLayer)->class[nIdxClass]->title);
-  *pszTemp = msReplaceSubstring(*pszTemp, "[leg_layer_name]", GET_LAYER(map, nIdxLayer)->name);
+  *pszTemp =
+      msReplaceSubstring(*pszTemp, "[leg_class_name]",
+                         GET_LAYER(map, nIdxLayer)->class[nIdxClass] -> name);
+  *pszTemp =
+      msReplaceSubstring(*pszTemp, "[leg_class_title]",
+                         GET_LAYER(map, nIdxLayer)->class[nIdxClass] -> title);
+  *pszTemp = msReplaceSubstring(*pszTemp, "[leg_layer_name]",
+                                GET_LAYER(map, nIdxLayer)->name);
 
   snprintf(szTmpstr, sizeof(szTmpstr), "%d", nIdxClass);
   *pszTemp = msReplaceSubstring(*pszTemp, "[leg_class_index]", szTmpstr);
 
-  snprintf(szTmpstr, sizeof(szTmpstr), "%g", GET_LAYER(map, nIdxLayer)->class[nIdxClass]->minscaledenom);
+  snprintf(szTmpstr, sizeof(szTmpstr), "%g",
+           GET_LAYER(map, nIdxLayer)->class[nIdxClass] -> minscaledenom);
   *pszTemp = msReplaceSubstring(*pszTemp, "[leg_class_minscale]", szTmpstr);
-  *pszTemp = msReplaceSubstring(*pszTemp, "[leg_class_minscaledenom]", szTmpstr);
-  snprintf(szTmpstr, sizeof(szTmpstr), "%g", GET_LAYER(map, nIdxLayer)->class[nIdxClass]->maxscaledenom);
+  *pszTemp =
+      msReplaceSubstring(*pszTemp, "[leg_class_minscaledenom]", szTmpstr);
+  snprintf(szTmpstr, sizeof(szTmpstr), "%g",
+           GET_LAYER(map, nIdxLayer)->class[nIdxClass] -> maxscaledenom);
   *pszTemp = msReplaceSubstring(*pszTemp, "[leg_class_maxscale]", szTmpstr);
-  *pszTemp = msReplaceSubstring(*pszTemp, "[leg_class_maxscaledenom]", szTmpstr);
+  *pszTemp =
+      msReplaceSubstring(*pszTemp, "[leg_class_maxscaledenom]", szTmpstr);
 
   /*
    * Create a hash table that contain info
@@ -2926,22 +3189,31 @@ int generateClassTemplate(char* pszClass
   snprintf(szType, sizeof(szType), "%d", GET_LAYER(map, nIdxLayer)->type);
   msInsertHashTable(myHashTable, "layer_type", szType);
 
-  msInsertHashTable(myHashTable, "layer_name",
-                    (GET_LAYER(map, nIdxLayer)->name)? GET_LAYER(map, nIdxLayer)->name : "");
+  msInsertHashTable(
+      myHashTable, "layer_name",
+      (GET_LAYER(map, nIdxLayer)->name) ? GET_LAYER(map, nIdxLayer)->name : "");
   msInsertHashTable(myHashTable, "layer_group",
-                    (GET_LAYER(map, nIdxLayer)->group)? GET_LAYER(map, nIdxLayer)->group : "");
-  msInsertHashTable(myHashTable, "layer_visible", msLayerIsVisible(map, GET_LAYER(map, nIdxLayer))?"1":"0" );
-  msInsertHashTable(myHashTable, "layer_queryable", msIsLayerQueryable(GET_LAYER(map, nIdxLayer))?"1":"0" );
+                    (GET_LAYER(map, nIdxLayer)->group)
+                        ? GET_LAYER(map, nIdxLayer)->group
+                        : "");
+  msInsertHashTable(myHashTable, "layer_visible",
+                    msLayerIsVisible(map, GET_LAYER(map, nIdxLayer)) ? "1"
+                                                                     : "0");
+  msInsertHashTable(myHashTable, "layer_queryable",
+                    msIsLayerQueryable(GET_LAYER(map, nIdxLayer)) ? "1" : "0");
   msInsertHashTable(myHashTable, "class_name",
-                    (GET_LAYER(map, nIdxLayer)->class[nIdxClass]->name)? GET_LAYER(map, nIdxLayer)->class[nIdxClass]->name : "");
+                    (GET_LAYER(map, nIdxLayer)->class[nIdxClass] -> name)
+                    ? GET_LAYER(map, nIdxLayer)->class[nIdxClass] -> name
+                    : "");
 
-  if(processIfTag(pszTemp, myHashTable, MS_FALSE) != MS_SUCCESS)
+  if (processIfTag(pszTemp, myHashTable, MS_FALSE) != MS_SUCCESS)
     return MS_FAILURE;
 
-  if(processIfTag(pszTemp, &(GET_LAYER(map, nIdxLayer)->metadata), MS_FALSE) != MS_SUCCESS)
+  if (processIfTag(pszTemp, &(GET_LAYER(map, nIdxLayer)->metadata), MS_FALSE) !=
+      MS_SUCCESS)
     return MS_FAILURE;
 
-  if(processIfTag(pszTemp, &(map->web.metadata), MS_TRUE) != MS_SUCCESS)
+  if (processIfTag(pszTemp, &(map->web.metadata), MS_TRUE) != MS_SUCCESS)
     return MS_FAILURE;
 
   msFreeHashTable(myHashTable);
@@ -2950,25 +3222,25 @@ int generateClassTemplate(char* pszClass
    * Check if leg_icon tag exist
    */
   pszClassImg = strstr(*pszTemp, "[leg_icon");
-  if(pszClassImg) {
+  if (pszClassImg) {
     processIcon(map, nIdxLayer, nIdxClass, pszTemp, pszPrefix);
   }
 
   /* process all metadata tags
    * only current layer and web object
    * metaddata are accessible
-  */
-  if(processMetadata(pszTemp, &GET_LAYER(map, nIdxLayer)->metadata) != MS_SUCCESS)
+   */
+  if (processMetadata(pszTemp, &GET_LAYER(map, nIdxLayer)->metadata) !=
+      MS_SUCCESS)
     return MS_FAILURE;
 
-  if(processMetadata(pszTemp, &(map->web.metadata)) != MS_SUCCESS)
+  if (processMetadata(pszTemp, &(map->web.metadata)) != MS_SUCCESS)
     return MS_FAILURE;
 
   return MS_SUCCESS;
 }
 
-char *generateLegendTemplate(mapservObj *mapserv)
-{
+char *generateLegendTemplate(mapservObj *mapserv) {
   FILE *stream;
   char *file = NULL;
   int length;
@@ -2991,7 +3263,7 @@ char *generateLegendTemplate(mapservObj
   const char *pszOrderMetadata = NULL;
   const char *pszOrder = NULL;
 
-  int i,j,k;
+  int i, j, k;
   char **papszGroups = NULL;
   int nGroupNames = 0;
 
@@ -3004,16 +3276,19 @@ char *generateLegendTemplate(mapservObj
 
   ms_regex_t re; /* compiled regular expression to be matched */
 
-  int  *panCurrentDrawingOrder = NULL;
+  int *panCurrentDrawingOrder = NULL;
   char szPath[MS_MAXPATHLEN];
 
-  if(ms_regcomp(&re, MS_TEMPLATE_EXPR, MS_REG_EXTENDED|MS_REG_NOSUB|MS_REG_ICASE) != 0) {
+  if (ms_regcomp(&re, MS_TEMPLATE_EXPR,
+                 MS_REG_EXTENDED | MS_REG_NOSUB | MS_REG_ICASE) != 0) {
     msSetError(MS_IOERR, "Error regcomp.", "generateLegendTemplate()");
     return NULL;
   }
 
-  if(ms_regexec(&re, mapserv->map->legend.template, 0, NULL, 0) != 0) { /* no match */
-    msSetError(MS_IOERR, "Invalid template file name.", "generateLegendTemplate()");
+  if (ms_regexec(&re, mapserv->map->legend.template, 0, NULL, 0) !=
+      0) { /* no match */
+    msSetError(MS_IOERR, "Invalid template file name.",
+               "generateLegendTemplate()");
     ms_regfree(&re);
     return NULL;
   }
@@ -3023,12 +3298,12 @@ char *generateLegendTemplate(mapservObj
   /*      Save the current drawing order. The drawing order is reset      */
   /*      at the end of the function.                                     */
   /* -------------------------------------------------------------------- */
-  if(mapserv->map->numlayers > 0) {
+  if (mapserv->map->numlayers > 0) {
     panCurrentDrawingOrder =
-      (int *)msSmallMalloc(sizeof(int)*mapserv->map->numlayers);
+        (int *)msSmallMalloc(sizeof(int) * mapserv->map->numlayers);
 
-    for (i=0; i<mapserv->map->numlayers; i++) {
-      if(mapserv->map->layerorder)
+    for (i = 0; i < mapserv->map->numlayers; i++) {
+      if (mapserv->map->layerorder)
         panCurrentDrawingOrder[i] = mapserv->map->layerorder[i];
       else
         panCurrentDrawingOrder[i] = i;
@@ -3038,31 +3313,34 @@ char *generateLegendTemplate(mapservObj
   /*
    * build prefix filename
    * for legend icon creation
-  */
-  for(i=0; i<mapserv->request->NumParams; i++) /* find the mapfile parameter first */
-    if(strcasecmp(mapserv->request->ParamNames[i], "map") == 0) break;
+   */
+  for (i = 0; i < mapserv->request->NumParams;
+       i++) /* find the mapfile parameter first */
+    if (strcasecmp(mapserv->request->ParamNames[i], "map") == 0)
+      break;
 
-  if(i == mapserv->request->NumParams) {
+  if (i == mapserv->request->NumParams) {
     const char *ms_mapfile = CPLGetConfigOption("MS_MAPFILE", NULL);
-    if(ms_mapfile)
+    if (ms_mapfile)
       pszMapFname = msStringConcatenate(pszMapFname, ms_mapfile);
   } else {
-    if(getenv(mapserv->request->ParamValues[i])) /* an environment references the actual file to use */
-      pszMapFname = msStringConcatenate(pszMapFname, getenv(mapserv->request->ParamValues[i]));
+    if (getenv(mapserv->request->ParamValues[i])) /* an environment references
+                                                     the actual file to use */
+      pszMapFname = msStringConcatenate(
+          pszMapFname, getenv(mapserv->request->ParamValues[i]));
     else
-      pszMapFname = msStringConcatenate(pszMapFname, mapserv->request->ParamValues[i]);
+      pszMapFname =
+          msStringConcatenate(pszMapFname, mapserv->request->ParamValues[i]);
   }
 
-  if(pszMapFname) {
-    if(stat(pszMapFname, &tmpStat) != -1) {
+  if (pszMapFname) {
+    if (stat(pszMapFname, &tmpStat) != -1) {
       int nLen;
 
-      nLen = (mapserv->map->name?strlen(mapserv->map->name):0)  + 50;
-      pszPrefix = (char*)msSmallMalloc((nLen+1) * sizeof(char));
-      snprintf(pszPrefix, nLen, "%s_%ld_%ld",
-               mapserv->map->name,
-               (long) tmpStat.st_size,
-               (long) tmpStat.st_mtime);
+      nLen = (mapserv->map->name ? strlen(mapserv->map->name) : 0) + 50;
+      pszPrefix = (char *)msSmallMalloc((nLen + 1) * sizeof(char));
+      snprintf(pszPrefix, nLen, "%s_%ld_%ld", mapserv->map->name,
+               (long)tmpStat.st_size, (long)tmpStat.st_mtime);
       pszPrefix[nLen] = '\0';
     }
 
@@ -3080,31 +3358,34 @@ char *generateLegendTemplate(mapservObj
   }
 
   /* open template */
-  if((stream = fopen(msBuildPath(szPath, mapserv->map->mappath, mapserv->map->legend.template), "r")) == NULL) {
-    msSetError(MS_IOERR, "Error while opening template file.", "generateLegendTemplate()");
+  if ((stream = fopen(msBuildPath(szPath, mapserv->map->mappath,
+                                  mapserv->map->legend.template),
+                      "r")) == NULL) {
+    msSetError(MS_IOERR, "Error while opening template file.",
+               "generateLegendTemplate()");
     free(pszResult);
-    pszResult=NULL;
+    pszResult = NULL;
     goto error;
   }
 
   fseek(stream, 0, SEEK_END);
   long lengthLong = ftell(stream);
   rewind(stream);
-  if( lengthLong < 0 || lengthLong > INT_MAX - 1 )
-  {
-    msSetError(MS_IOERR, "Too large template file.", "generateLegendTemplate()");
+  if (lengthLong < 0 || lengthLong > INT_MAX - 1) {
+    msSetError(MS_IOERR, "Too large template file.",
+               "generateLegendTemplate()");
     free(pszResult);
-    pszResult=NULL;
+    pszResult = NULL;
     goto error;
   }
   length = (int)lengthLong;
 
-  file = (char*)malloc(length + 1);
-  if( file == NULL )
-  {
-    msSetError(MS_IOERR, "Cannot allocate memory for template file.", "generateLegendTemplate()");
+  file = (char *)malloc(length + 1);
+  if (file == NULL) {
+    msSetError(MS_IOERR, "Cannot allocate memory for template file.",
+               "generateLegendTemplate()");
     free(pszResult);
-    pszResult=NULL;
+    pszResult = NULL;
     goto error;
   }
 
@@ -3119,18 +3400,18 @@ char *generateLegendTemplate(mapservObj
    * to deal with Windows \r\n end of lines ? */
   /* Disabled for now due to Windows issue, see ticket #3814
      if( 1 != fread(file, length, 1, stream)) {
-       msSetError(MS_IOERR, "Error while reading template file.", "generateLegendTemplate()");
-       free(file);
-       fclose(stream);
-       return NULL;
+       msSetError(MS_IOERR, "Error while reading template file.",
+     "generateLegendTemplate()"); free(file); fclose(stream); return NULL;
      }
   */
   file[length] = '\0';
 
-  if(msValidateContexts(mapserv->map) != MS_SUCCESS) { /* make sure there are no recursive REQUIRES or LABELREQUIRES expressions */
-    if(pszResult)
+  if (msValidateContexts(mapserv->map) !=
+      MS_SUCCESS) { /* make sure there are no recursive REQUIRES or
+                       LABELREQUIRES expressions */
+    if (pszResult)
       free(pszResult);
-    pszResult=NULL;
+    pszResult = NULL;
     goto error;
   }
 
@@ -3146,45 +3427,45 @@ char *generateLegendTemplate(mapservObj
   /*
    * Retrieve arguments of all three parts
    */
-  if(legGroupHtml)
-    if(getTagArgs("leg_group_html", file, &groupArgs) != MS_SUCCESS) {
-      if(pszResult)
+  if (legGroupHtml)
+    if (getTagArgs("leg_group_html", file, &groupArgs) != MS_SUCCESS) {
+      if (pszResult)
         free(pszResult);
-      pszResult=NULL;
+      pszResult = NULL;
       goto error;
     }
 
-  if(legLayerHtml)
-    if(getTagArgs("leg_layer_html", file, &layerArgs) != MS_SUCCESS) {
-      if(pszResult)
+  if (legLayerHtml)
+    if (getTagArgs("leg_layer_html", file, &layerArgs) != MS_SUCCESS) {
+      if (pszResult)
         free(pszResult);
-      pszResult=NULL;
+      pszResult = NULL;
       goto error;
     }
 
-  if(legClassHtml)
-    if(getTagArgs("leg_class_html", file, &classArgs) != MS_SUCCESS) {
-      if(pszResult)
+  if (legClassHtml)
+    if (getTagArgs("leg_class_html", file, &classArgs) != MS_SUCCESS) {
+      if (pszResult)
         free(pszResult);
-      pszResult=NULL;
+      pszResult = NULL;
       goto error;
     }
 
-
-  mapserv->map->cellsize = msAdjustExtent(&(mapserv->map->extent),
-                                          mapserv->map->width,
-                                          mapserv->map->height);
-  if(msCalculateScale(mapserv->map->extent, mapserv->map->units,
-                      mapserv->map->width, mapserv->map->height,
-                      mapserv->map->resolution, &mapserv->map->scaledenom) != MS_SUCCESS) {
-    if(pszResult)
+  mapserv->map->cellsize = msAdjustExtent(
+      &(mapserv->map->extent), mapserv->map->width, mapserv->map->height);
+  if (msCalculateScale(mapserv->map->extent, mapserv->map->units,
+                       mapserv->map->width, mapserv->map->height,
+                       mapserv->map->resolution,
+                       &mapserv->map->scaledenom) != MS_SUCCESS) {
+    if (pszResult)
       free(pszResult);
-    pszResult=NULL;
+    pszResult = NULL;
     goto error;
   }
 
   /* start with the header if present */
-  if(legHeaderHtml) pszResult = msStringConcatenate(pszResult, legHeaderHtml);
+  if (legHeaderHtml)
+    pszResult = msStringConcatenate(pszResult, legHeaderHtml);
 
   /********************************************************************/
 
@@ -3194,10 +3475,10 @@ char *generateLegendTemplate(mapservObj
    */
   pszOrderMetadata = msLookupHashTable(layerArgs, "order_metadata");
 
-  if(sortLayerByMetadata(mapserv->map, pszOrderMetadata) != MS_SUCCESS) {
-    if(pszResult)
+  if (sortLayerByMetadata(mapserv->map, pszOrderMetadata) != MS_SUCCESS) {
+    if (pszResult)
       free(pszResult);
-    pszResult=NULL;
+    pszResult = NULL;
     goto error;
   }
 
@@ -3206,26 +3487,28 @@ char *generateLegendTemplate(mapservObj
   /*      current order will be changed to correspond to that.            */
   /* -------------------------------------------------------------------- */
   pszOrder = msLookupHashTable(layerArgs, "order");
-  if(pszOrder && ((strcasecmp(pszOrder, "ASCENDING") == 0) ||
-                  (strcasecmp(pszOrder, "DESCENDING") == 0))) {
-    if(sortLayerByOrder(mapserv->map, pszOrder) != MS_SUCCESS) {
-      if(pszResult)
+  if (pszOrder && ((strcasecmp(pszOrder, "ASCENDING") == 0) ||
+                   (strcasecmp(pszOrder, "DESCENDING") == 0))) {
+    if (sortLayerByOrder(mapserv->map, pszOrder) != MS_SUCCESS) {
+      if (pszResult)
         free(pszResult);
-      pszResult=NULL;
+      pszResult = NULL;
       goto error;
     }
   }
 
-  if(legGroupHtml) {
+  if (legGroupHtml) {
     /* retrieve group names */
     papszGroups = msGetAllGroupNames(mapserv->map, &nGroupNames);
 
-    for (i=0; i<nGroupNames; i++) {
+    for (i = 0; i < nGroupNames; i++) {
       /* process group tags */
-      if(generateGroupTemplate(legGroupHtml, mapserv->map, papszGroups[i], groupArgs, &legGroupHtmlCopy, pszPrefix) != MS_SUCCESS) {
-        if(pszResult)
+      if (generateGroupTemplate(legGroupHtml, mapserv->map, papszGroups[i],
+                                groupArgs, &legGroupHtmlCopy,
+                                pszPrefix) != MS_SUCCESS) {
+        if (pszResult)
           free(pszResult);
-        pszResult=NULL;
+        pszResult = NULL;
         goto error;
       }
 
@@ -3242,72 +3525,89 @@ char *generateLegendTemplate(mapservObj
                }
       */
 
-      if(legGroupHtmlCopy) {
+      if (legGroupHtmlCopy) {
         free(legGroupHtmlCopy);
         legGroupHtmlCopy = NULL;
       }
 
       /* for all layers in group */
-      if(legLayerHtml) {
-        for (j=0; j<mapserv->map->numlayers; j++) {
+      if (legLayerHtml) {
+        for (j = 0; j < mapserv->map->numlayers; j++) {
           /*
            * if order_metadata is set and the order
            * value is less than 0, dont display it
            */
           pszOrderMetadata = msLookupHashTable(layerArgs, "order_metadata");
-          if(pszOrderMetadata) {
-            pszOrderValue = msLookupHashTable(&(GET_LAYER(mapserv->map, mapserv->map->layerorder[j])->metadata), pszOrderMetadata);
-            if(pszOrderValue) {
+          if (pszOrderMetadata) {
+            pszOrderValue = msLookupHashTable(
+                &(GET_LAYER(mapserv->map, mapserv->map->layerorder[j])
+                      ->metadata),
+                pszOrderMetadata);
+            if (pszOrderValue) {
               nLegendOrder = atoi(pszOrderValue);
-              if(nLegendOrder < 0)
+              if (nLegendOrder < 0)
                 continue;
             }
           }
-          if(mapserv->hittest && mapserv->hittest->layerhits[mapserv->map->layerorder[j]].status == 0) {
+          if (mapserv->hittest &&
+              mapserv->hittest->layerhits[mapserv->map->layerorder[j]].status ==
+                  0) {
             continue;
           }
 
-          if(GET_LAYER(mapserv->map, mapserv->map->layerorder[j])->group && strcmp(GET_LAYER(mapserv->map, mapserv->map->layerorder[j])->group, papszGroups[i]) == 0) {
+          if (GET_LAYER(mapserv->map, mapserv->map->layerorder[j])->group &&
+              strcmp(
+                  GET_LAYER(mapserv->map, mapserv->map->layerorder[j])->group,
+                  papszGroups[i]) == 0) {
             /* process all layer tags */
-            if(generateLayerTemplate(legLayerHtml, mapserv->map, mapserv->map->layerorder[j], layerArgs, &legLayerHtmlCopy, pszPrefix) != MS_SUCCESS) {
-              if(pszResult)
+            if (generateLayerTemplate(
+                    legLayerHtml, mapserv->map, mapserv->map->layerorder[j],
+                    layerArgs, &legLayerHtmlCopy, pszPrefix) != MS_SUCCESS) {
+              if (pszResult)
                 free(pszResult);
-              pszResult=NULL;
+              pszResult = NULL;
               goto error;
             }
 
-
             /* concatenate to final result */
             pszResult = msStringConcatenate(pszResult, legLayerHtmlCopy);
 
-            if(legLayerHtmlCopy) {
+            if (legLayerHtmlCopy) {
               free(legLayerHtmlCopy);
               legLayerHtmlCopy = NULL;
             }
 
-
             /* for all classes in layer */
-            if(legClassHtml) {
-              for (k=0; k<GET_LAYER(mapserv->map, mapserv->map->layerorder[j])->numclasses; k++) {
+            if (legClassHtml) {
+              for (k = 0;
+                   k < GET_LAYER(mapserv->map, mapserv->map->layerorder[j])
+                           ->numclasses;
+                   k++) {
                 /* process all class tags */
-                if(!GET_LAYER(mapserv->map, mapserv->map->layerorder[j])->class[k]->name)
+                if (!GET_LAYER(mapserv->map, mapserv->map->layerorder[j])
+                         ->class[k] -> name)
                   continue;
-                if(mapserv->hittest && mapserv->hittest->layerhits[mapserv->map->layerorder[j]].classhits[k].status == 0) {
+                if (mapserv->hittest &&
+                    mapserv->hittest->layerhits[mapserv->map->layerorder[j]]
+                            .classhits[k]
+                            .status == 0) {
                   continue;
                 }
 
-                if(generateClassTemplate(legClassHtml, mapserv->map, mapserv->map->layerorder[j], k, classArgs, &legClassHtmlCopy, pszPrefix) != MS_SUCCESS) {
-                  if(pszResult)
+                if (generateClassTemplate(legClassHtml, mapserv->map,
+                                          mapserv->map->layerorder[j], k,
+                                          classArgs, &legClassHtmlCopy,
+                                          pszPrefix) != MS_SUCCESS) {
+                  if (pszResult)
                     free(pszResult);
-                  pszResult=NULL;
+                  pszResult = NULL;
                   goto error;
                 }
 
-
                 /* concatenate to final result */
                 pszResult = msStringConcatenate(pszResult, legClassHtmlCopy);
 
-                if(legClassHtmlCopy) {
+                if (legClassHtmlCopy) {
                   free(legClassHtmlCopy);
                   legClassHtmlCopy = NULL;
                 }
@@ -3315,117 +3615,147 @@ char *generateLegendTemplate(mapservObj
             }
           }
         }
-      } else if(legClassHtml) { /* no layer template specified but class and group template */
-        for (j=0; j<mapserv->map->numlayers; j++) {
+      } else if (legClassHtml) { /* no layer template specified but class and
+                                    group template */
+        for (j = 0; j < mapserv->map->numlayers; j++) {
           /*
            * if order_metadata is set and the order
            * value is less than 0, dont display it
            */
           pszOrderMetadata = msLookupHashTable(layerArgs, "order_metadata");
-          if(pszOrderMetadata) {
-            pszOrderValue = msLookupHashTable(&(GET_LAYER(mapserv->map, mapserv->map->layerorder[j])->metadata), pszOrderMetadata);
-            if(pszOrderValue) {
+          if (pszOrderMetadata) {
+            pszOrderValue = msLookupHashTable(
+                &(GET_LAYER(mapserv->map, mapserv->map->layerorder[j])
+                      ->metadata),
+                pszOrderMetadata);
+            if (pszOrderValue) {
               nLegendOrder = atoi(pszOrderValue);
-              if(nLegendOrder < 0)
+              if (nLegendOrder < 0)
                 continue;
             }
           }
-          if(mapserv->hittest && mapserv->hittest->layerhits[mapserv->map->layerorder[j]].status == 0) {
+          if (mapserv->hittest &&
+              mapserv->hittest->layerhits[mapserv->map->layerorder[j]].status ==
+                  0) {
             continue;
           }
 
-          if(GET_LAYER(mapserv->map, mapserv->map->layerorder[j])->group && strcmp(GET_LAYER(mapserv->map, mapserv->map->layerorder[j])->group, papszGroups[i]) == 0) {
+          if (GET_LAYER(mapserv->map, mapserv->map->layerorder[j])->group &&
+              strcmp(
+                  GET_LAYER(mapserv->map, mapserv->map->layerorder[j])->group,
+                  papszGroups[i]) == 0) {
             /* for all classes in layer */
 
-              for (k=0; k<GET_LAYER(mapserv->map, mapserv->map->layerorder[j])->numclasses; k++) {
-                /* process all class tags */
-                if(!GET_LAYER(mapserv->map, mapserv->map->layerorder[j])->class[k]->name)
-                  continue;
-                if(mapserv->hittest && mapserv->hittest->layerhits[mapserv->map->layerorder[j]].classhits[k].status == 0) {
-                  continue;
-                }
-
-                if(generateClassTemplate(legClassHtml, mapserv->map, mapserv->map->layerorder[j], k, classArgs, &legClassHtmlCopy, pszPrefix) != MS_SUCCESS) {
-                  if(pszResult)
-                    free(pszResult);
-                  pszResult=NULL;
-                  goto error;
-                }
+            for (k = 0; k < GET_LAYER(mapserv->map, mapserv->map->layerorder[j])
+                                ->numclasses;
+                 k++) {
+              /* process all class tags */
+              if (!GET_LAYER(mapserv->map, mapserv->map->layerorder[j])
+                       ->class[k] -> name)
+                continue;
+              if (mapserv->hittest &&
+                  mapserv->hittest->layerhits[mapserv->map->layerorder[j]]
+                          .classhits[k]
+                          .status == 0) {
+                continue;
+              }
 
+              if (generateClassTemplate(legClassHtml, mapserv->map,
+                                        mapserv->map->layerorder[j], k,
+                                        classArgs, &legClassHtmlCopy,
+                                        pszPrefix) != MS_SUCCESS) {
+                if (pszResult)
+                  free(pszResult);
+                pszResult = NULL;
+                goto error;
+              }
 
-                /* concatenate to final result */
-                pszResult = msStringConcatenate(pszResult, legClassHtmlCopy);
+              /* concatenate to final result */
+              pszResult = msStringConcatenate(pszResult, legClassHtmlCopy);
 
-                if(legClassHtmlCopy) {
-                  free(legClassHtmlCopy);
-                  legClassHtmlCopy = NULL;
-                }
+              if (legClassHtmlCopy) {
+                free(legClassHtmlCopy);
+                legClassHtmlCopy = NULL;
               }
-
+            }
           }
         }
       }
     }
   } else {
     /* if no group template specified */
-    if(legLayerHtml) {
-      for (j=0; j<mapserv->map->numlayers; j++) {
+    if (legLayerHtml) {
+      for (j = 0; j < mapserv->map->numlayers; j++) {
         /*
          * if order_metadata is set and the order
          * value is less than 0, dont display it
          */
         pszOrderMetadata = msLookupHashTable(layerArgs, "order_metadata");
-        if(pszOrderMetadata) {
-          pszOrderValue = msLookupHashTable(&(GET_LAYER(mapserv->map, mapserv->map->layerorder[j])->metadata), pszOrderMetadata);
-          if(pszOrderValue) {
+        if (pszOrderMetadata) {
+          pszOrderValue = msLookupHashTable(
+              &(GET_LAYER(mapserv->map, mapserv->map->layerorder[j])->metadata),
+              pszOrderMetadata);
+          if (pszOrderValue) {
             nLegendOrder = atoi(pszOrderValue);
-            if(nLegendOrder < 0)
+            if (nLegendOrder < 0)
               continue;
           } else
-            nLegendOrder=0;
+            nLegendOrder = 0;
         }
-        if(mapserv->hittest && mapserv->hittest->layerhits[mapserv->map->layerorder[j]].status == 0) {
+        if (mapserv->hittest &&
+            mapserv->hittest->layerhits[mapserv->map->layerorder[j]].status ==
+                0) {
           continue;
         }
 
         /* process a layer tags */
-        if(generateLayerTemplate(legLayerHtml, mapserv->map, mapserv->map->layerorder[j], layerArgs, &legLayerHtmlCopy, pszPrefix) != MS_SUCCESS) {
-          if(pszResult)
+        if (generateLayerTemplate(legLayerHtml, mapserv->map,
+                                  mapserv->map->layerorder[j], layerArgs,
+                                  &legLayerHtmlCopy, pszPrefix) != MS_SUCCESS) {
+          if (pszResult)
             free(pszResult);
-          pszResult=NULL;
+          pszResult = NULL;
           goto error;
         }
 
         /* concatenate to final result */
         pszResult = msStringConcatenate(pszResult, legLayerHtmlCopy);
 
-        if(legLayerHtmlCopy) {
+        if (legLayerHtmlCopy) {
           free(legLayerHtmlCopy);
           legLayerHtmlCopy = NULL;
         }
 
         /* for all classes in layer */
-        if(legClassHtml) {
-          for (k=0; k<GET_LAYER(mapserv->map, mapserv->map->layerorder[j])->numclasses; k++) {
+        if (legClassHtml) {
+          for (k = 0;
+               k <
+               GET_LAYER(mapserv->map, mapserv->map->layerorder[j])->numclasses;
+               k++) {
             /* process all class tags */
-            if(!GET_LAYER(mapserv->map, mapserv->map->layerorder[j])->class[k]->name)
+            if (!GET_LAYER(mapserv->map, mapserv->map->layerorder[j])->class[k]
+                -> name)
               continue;
-            if(mapserv->hittest && mapserv->hittest->layerhits[mapserv->map->layerorder[j]].classhits[k].status == 0) {
+            if (mapserv->hittest &&
+                mapserv->hittest->layerhits[mapserv->map->layerorder[j]]
+                        .classhits[k]
+                        .status == 0) {
               continue;
             }
 
-            if(generateClassTemplate(legClassHtml, mapserv->map, mapserv->map->layerorder[j], k, classArgs, &legClassHtmlCopy, pszPrefix) != MS_SUCCESS) {
-              if(pszResult)
+            if (generateClassTemplate(
+                    legClassHtml, mapserv->map, mapserv->map->layerorder[j], k,
+                    classArgs, &legClassHtmlCopy, pszPrefix) != MS_SUCCESS) {
+              if (pszResult)
                 free(pszResult);
-              pszResult=NULL;
+              pszResult = NULL;
               goto error;
             }
 
-
             /* concatenate to final result */
             pszResult = msStringConcatenate(pszResult, legClassHtmlCopy);
 
-            if(legClassHtmlCopy) {
+            if (legClassHtmlCopy) {
               free(legClassHtmlCopy);
               legClassHtmlCopy = NULL;
             }
@@ -3433,43 +3763,56 @@ char *generateLegendTemplate(mapservObj
         }
       }
     } else { /* if no group and layer template specified */
-      if(legClassHtml) {
-        for (j=0; j<mapserv->map->numlayers; j++) {
+      if (legClassHtml) {
+        for (j = 0; j < mapserv->map->numlayers; j++) {
           /*
            * if order_metadata is set and the order
            * value is less than 0, dont display it
            */
           pszOrderMetadata = msLookupHashTable(layerArgs, "order_metadata");
-          if(pszOrderMetadata) {
-            pszOrderValue = msLookupHashTable(&(GET_LAYER(mapserv->map, mapserv->map->layerorder[j])->metadata), pszOrderMetadata);
-            if(pszOrderValue) {
+          if (pszOrderMetadata) {
+            pszOrderValue = msLookupHashTable(
+                &(GET_LAYER(mapserv->map, mapserv->map->layerorder[j])
+                      ->metadata),
+                pszOrderMetadata);
+            if (pszOrderValue) {
               nLegendOrder = atoi(pszOrderValue);
-              if(nLegendOrder < 0)
+              if (nLegendOrder < 0)
                 continue;
             }
           }
-          if(mapserv->hittest && mapserv->hittest->layerhits[mapserv->map->layerorder[j]].status == 0) {
+          if (mapserv->hittest &&
+              mapserv->hittest->layerhits[mapserv->map->layerorder[j]].status ==
+                  0) {
             continue;
           }
 
-          for (k=0; k<GET_LAYER(mapserv->map, mapserv->map->layerorder[j])->numclasses; k++) {
-            if(!GET_LAYER(mapserv->map, mapserv->map->layerorder[j])->class[k]->name)
+          for (k = 0;
+               k <
+               GET_LAYER(mapserv->map, mapserv->map->layerorder[j])->numclasses;
+               k++) {
+            if (!GET_LAYER(mapserv->map, mapserv->map->layerorder[j])->class[k]
+                -> name)
               continue;
-            if(mapserv->hittest && mapserv->hittest->layerhits[mapserv->map->layerorder[j]].classhits[k].status == 0) {
+            if (mapserv->hittest &&
+                mapserv->hittest->layerhits[mapserv->map->layerorder[j]]
+                        .classhits[k]
+                        .status == 0) {
               continue;
             }
 
-            if(generateClassTemplate(legClassHtml, mapserv->map, mapserv->map->layerorder[j], k, classArgs, &legClassHtmlCopy, pszPrefix) != MS_SUCCESS) {
-              if(pszResult)
+            if (generateClassTemplate(
+                    legClassHtml, mapserv->map, mapserv->map->layerorder[j], k,
+                    classArgs, &legClassHtmlCopy, pszPrefix) != MS_SUCCESS) {
+              if (pszResult)
                 free(pszResult);
-              pszResult=NULL;
+              pszResult = NULL;
               goto error;
             }
 
-
             pszResult = msStringConcatenate(pszResult, legClassHtmlCopy);
 
-            if(legClassHtmlCopy) {
+            if (legClassHtmlCopy) {
               free(legClassHtmlCopy);
               legClassHtmlCopy = NULL;
             }
@@ -3480,23 +3823,23 @@ char *generateLegendTemplate(mapservObj
   }
 
   /* finish with the footer if present */
-  if(legFooterHtml) pszResult = msStringConcatenate(pszResult, legFooterHtml);
+  if (legFooterHtml)
+    pszResult = msStringConcatenate(pszResult, legFooterHtml);
 
   /*
    * if we reach this point, that mean no error was generated.
    * So check if template is null and initialize it to <space>.
    */
-  if(pszResult == NULL) {
+  if (pszResult == NULL) {
     pszResult = msStringConcatenate(pszResult, " ");
   }
 
-
   /********************************************************************/
 
 error:
 
-  if(papszGroups) {
-    for (i=0; i<nGroupNames; i++)
+  if (papszGroups) {
+    for (i = 0; i < nGroupNames; i++)
       msFree(papszGroups[i]);
 
     msFree(papszGroups);
@@ -3520,15 +3863,15 @@ error:
   msFree(legClassHtml);
   msFree(pszPrefix);
 
-  if(stream)
+  if (stream)
     fclose(stream);
 
   /* -------------------------------------------------------------------- */
   /*      Reset the layerdrawing order.                                   */
   /* -------------------------------------------------------------------- */
-  if(panCurrentDrawingOrder && mapserv->map->layerorder) {
-    for (i=0; i<mapserv->map->numlayers; i++)
-      mapserv->map->layerorder[i] =  panCurrentDrawingOrder[i];
+  if (panCurrentDrawingOrder && mapserv->map->layerorder) {
+    for (i = 0; i < mapserv->map->numlayers; i++)
+      mapserv->map->layerorder[i] = panCurrentDrawingOrder[i];
 
     free(panCurrentDrawingOrder);
   }
@@ -3536,50 +3879,59 @@ error:
   return pszResult;
 }
 
-char *processOneToManyJoin(mapservObj* mapserv, joinObj *join)
-{
-  int records=MS_FALSE;
-  FILE *stream=NULL;
+char *processOneToManyJoin(mapservObj *mapserv, joinObj *join) {
+  int records = MS_FALSE;
+  FILE *stream = NULL;
   char *outbuf;
   char line[MS_BUFFER_LENGTH], *tmpline;
   char szPath[MS_MAXPATHLEN];
 
-  if((outbuf = msStrdup("")) == NULL) return(NULL); /* empty at first */
+  if ((outbuf = msStrdup("")) == NULL)
+    return (NULL); /* empty at first */
 
   msJoinPrepare(join, &(mapserv->resultshape)); /* execute the join */
-  while(msJoinNext(join) == MS_SUCCESS) {
-    /* First time through, deal with the header (if necessary) and open the main template. We only */
+  while (msJoinNext(join) == MS_SUCCESS) {
+    /* First time through, deal with the header (if necessary) and open the main
+     * template. We only */
     /* want to do this if there are joined records. */
-    if(records == MS_FALSE) {
-      if(join->header != NULL) {
+    if (records == MS_FALSE) {
+      if (join->header != NULL) {
         /* coverity[dead_error_line] */
-        if(stream) fclose(stream);
-        if((stream = fopen(msBuildPath(szPath, mapserv->map->mappath, join->header), "r")) == NULL) {
-          msSetError(MS_IOERR, "Error while opening join header file %s.", "processOneToManyJoin()", join->header);
+        if (stream)
+          fclose(stream);
+        if ((stream =
+                 fopen(msBuildPath(szPath, mapserv->map->mappath, join->header),
+                       "r")) == NULL) {
+          msSetError(MS_IOERR, "Error while opening join header file %s.",
+                     "processOneToManyJoin()", join->header);
           msFree(outbuf);
-          return(NULL);
+          return (NULL);
         }
 
-        if(isValidTemplate(stream, join->header) != MS_TRUE) {
+        if (isValidTemplate(stream, join->header) != MS_TRUE) {
           fclose(stream);
           msFree(outbuf);
           return NULL;
         }
 
         /* echo file to the output buffer, no substitutions */
-        while(fgets(line, MS_BUFFER_LENGTH, stream) != NULL) outbuf = msStringConcatenate(outbuf, line);
+        while (fgets(line, MS_BUFFER_LENGTH, stream) != NULL)
+          outbuf = msStringConcatenate(outbuf, line);
 
         fclose(stream);
         stream = NULL;
       }
 
-      if((stream = fopen(msBuildPath(szPath, mapserv->map->mappath, join->template), "r")) == NULL) {
-        msSetError(MS_IOERR, "Error while opening join template file %s.", "processOneToManyJoin()", join->template);
+      if ((stream =
+               fopen(msBuildPath(szPath, mapserv->map->mappath, join->template),
+                     "r")) == NULL) {
+        msSetError(MS_IOERR, "Error while opening join template file %s.",
+                   "processOneToManyJoin()", join->template);
         msFree(outbuf);
-        return(NULL);
+        return (NULL);
       }
 
-      if(isValidTemplate(stream, join->template) != MS_TRUE) {
+      if (isValidTemplate(stream, join->template) != MS_TRUE) {
         fclose(stream);
         msFree(outbuf);
         return NULL;
@@ -3588,13 +3940,16 @@ char *processOneToManyJoin(mapservObj* m
       records = MS_TRUE;
     }
 
-    while(fgets(line, MS_BUFFER_LENGTH, stream) != NULL) { /* now on to the end of the template */
-      if(strchr(line, '[') != NULL) {
-        tmpline = processLine(mapserv, line, NULL, QUERY); /* no multiline tags are allowed in a join */
-        if(!tmpline) {
-           msFree(outbuf);
-           fclose(stream);
-           return NULL;
+    while (fgets(line, MS_BUFFER_LENGTH, stream) !=
+           NULL) { /* now on to the end of the template */
+      if (strchr(line, '[') != NULL) {
+        tmpline =
+            processLine(mapserv, line, NULL,
+                        QUERY); /* no multiline tags are allowed in a join */
+        if (!tmpline) {
+          msFree(outbuf);
+          fclose(stream);
+          return NULL;
         }
         outbuf = msStringConcatenate(outbuf, tmpline);
         free(tmpline);
@@ -3603,25 +3958,32 @@ char *processOneToManyJoin(mapservObj* m
     }
 
     rewind(stream);
-    IGUR_voidp(fgets(line, MS_BUFFER_LENGTH, stream)); /* skip the first line since it's the magic string */
-  } /* next record */
+    IGUR_voidp(
+        fgets(line, MS_BUFFER_LENGTH,
+              stream)); /* skip the first line since it's the magic string */
+  }                     /* next record */
 
-  if(records==MS_TRUE && join->footer) {
-    if(stream) fclose(stream);
-    if((stream = fopen(msBuildPath(szPath, mapserv->map->mappath, join->footer), "r")) == NULL) {
-      msSetError(MS_IOERR, "Error while opening join footer file %s.", "processOneToManyJoin()", join->footer);
+  if (records == MS_TRUE && join->footer) {
+    if (stream)
+      fclose(stream);
+    if ((stream =
+             fopen(msBuildPath(szPath, mapserv->map->mappath, join->footer),
+                   "r")) == NULL) {
+      msSetError(MS_IOERR, "Error while opening join footer file %s.",
+                 "processOneToManyJoin()", join->footer);
       msFree(outbuf);
-      return(NULL);
+      return (NULL);
     }
 
-    if(isValidTemplate(stream, join->footer) != MS_TRUE) {
+    if (isValidTemplate(stream, join->footer) != MS_TRUE) {
       msFree(outbuf);
       fclose(stream);
       return NULL;
     }
 
     /* echo file to the output buffer, no substitutions */
-    while(fgets(line, MS_BUFFER_LENGTH, stream) != NULL) outbuf = msStringConcatenate(outbuf, line);
+    while (fgets(line, MS_BUFFER_LENGTH, stream) != NULL)
+      outbuf = msStringConcatenate(outbuf, line);
 
     fclose(stream);
     stream = NULL;
@@ -3631,21 +3993,24 @@ char *processOneToManyJoin(mapservObj* m
   msFreeCharArray(join->values, join->numitems);
   join->values = NULL;
 
-  if(stream) fclose(stream);
+  if (stream)
+    fclose(stream);
 
-  return(outbuf);
+  return (outbuf);
 }
 
 /*
-** Process a single line in the template. A few tags (e.g. [resultset]...[/resultset]) can be multi-line so
+** Process a single line in the template. A few tags (e.g.
+*[resultset]...[/resultset]) can be multi-line so
 ** we pass the filehandle to look ahead if necessary.
 */
-static char *processLine(mapservObj *mapserv, const char *instr, FILE *stream, int mode)
-{
+static char *processLine(mapservObj *mapserv, const char *instr, FILE *stream,
+                         int mode) {
   int i, j;
 #define PROCESSLINE_BUFLEN 5120
-  char repstr[PROCESSLINE_BUFLEN], substr[PROCESSLINE_BUFLEN], *outstr; /* repstr = replace string, substr = sub string */
-  struct hashObj *tp=NULL;
+  char repstr[PROCESSLINE_BUFLEN], substr[PROCESSLINE_BUFLEN],
+      *outstr; /* repstr = replace string, substr = sub string */
+  struct hashObj *tp = NULL;
   char *encodedstr;
 
   rectObj llextent;
@@ -3653,16 +4018,24 @@ static char *processLine(mapservObj *map
 
   outstr = msStrdup(instr); /* work from a copy */
 
-  if(strstr(outstr, "[version]")) outstr = msReplaceSubstring(outstr, "[version]",  msGetVersion());
+  if (strstr(outstr, "[version]"))
+    outstr = msReplaceSubstring(outstr, "[version]", msGetVersion());
 
-  snprintf(repstr, PROCESSLINE_BUFLEN, "%s%s%s.%s", mapserv->map->web.imageurl, mapserv->map->name, mapserv->Id, MS_IMAGE_EXTENSION(mapserv->map->outputformat));
+  snprintf(repstr, PROCESSLINE_BUFLEN, "%s%s%s.%s", mapserv->map->web.imageurl,
+           mapserv->map->name, mapserv->Id,
+           MS_IMAGE_EXTENSION(mapserv->map->outputformat));
   outstr = msReplaceSubstring(outstr, "[img]", repstr);
-  snprintf(repstr, PROCESSLINE_BUFLEN, "%s%sref%s.%s", mapserv->map->web.imageurl, mapserv->map->name, mapserv->Id, MS_IMAGE_EXTENSION(mapserv->map->outputformat));
+  snprintf(repstr, PROCESSLINE_BUFLEN, "%s%sref%s.%s",
+           mapserv->map->web.imageurl, mapserv->map->name, mapserv->Id,
+           MS_IMAGE_EXTENSION(mapserv->map->outputformat));
   outstr = msReplaceSubstring(outstr, "[ref]", repstr);
 
-  if(strstr(outstr, "[errmsg")) {
+  if (strstr(outstr, "[errmsg")) {
     char *errmsg = msGetErrorString(";");
-    if(!errmsg) errmsg = msStrdup("Error message buffer is empty."); /* should never happen, but just in case... */
+    if (!errmsg)
+      errmsg =
+          msStrdup("Error message buffer is empty."); /* should never happen,
+                                                         but just in case... */
     outstr = msReplaceSubstring(outstr, "[errmsg]", errmsg);
     encodedstr = msEncodeUrl(errmsg);
     outstr = msReplaceSubstring(outstr, "[errmsg_esc]", encodedstr);
@@ -3670,53 +4043,62 @@ static char *processLine(mapservObj *map
     free(encodedstr);
   }
 
-  if(strstr(outstr, "[legend]")) {
+  if (strstr(outstr, "[legend]")) {
     /* if there's a template legend specified, use it */
-    if(mapserv->map->legend.template) {
+    if (mapserv->map->legend.template) {
       char *legendTemplate;
 
       legendTemplate = generateLegendTemplate(mapserv);
-      if(legendTemplate) {
+      if (legendTemplate) {
         outstr = msReplaceSubstring(outstr, "[legend]", legendTemplate);
 
         free(legendTemplate);
       } else /* error already generated by (generateLegendTemplate()) */
         return NULL;
     } else { /* if not display gif image with all legend icon */
-      snprintf(repstr, PROCESSLINE_BUFLEN, "%s%sleg%s.%s", mapserv->map->web.imageurl, mapserv->map->name, mapserv->Id, MS_IMAGE_EXTENSION(mapserv->map->outputformat));
+      snprintf(repstr, PROCESSLINE_BUFLEN, "%s%sleg%s.%s",
+               mapserv->map->web.imageurl, mapserv->map->name, mapserv->Id,
+               MS_IMAGE_EXTENSION(mapserv->map->outputformat));
       outstr = msReplaceSubstring(outstr, "[legend]", repstr);
     }
   }
 
-  snprintf(repstr, PROCESSLINE_BUFLEN, "%s%ssb%s.%s", mapserv->map->web.imageurl, mapserv->map->name, mapserv->Id, MS_IMAGE_EXTENSION(mapserv->map->outputformat));
+  snprintf(repstr, PROCESSLINE_BUFLEN, "%s%ssb%s.%s",
+           mapserv->map->web.imageurl, mapserv->map->name, mapserv->Id,
+           MS_IMAGE_EXTENSION(mapserv->map->outputformat));
   outstr = msReplaceSubstring(outstr, "[scalebar]", repstr);
 
-  if(mapserv->savequery) {
-    snprintf(repstr, PROCESSLINE_BUFLEN, "%s%s%s%s", mapserv->map->web.imagepath, mapserv->map->name, mapserv->Id, MS_QUERY_EXTENSION);
+  if (mapserv->savequery) {
+    snprintf(repstr, PROCESSLINE_BUFLEN, "%s%s%s%s",
+             mapserv->map->web.imagepath, mapserv->map->name, mapserv->Id,
+             MS_QUERY_EXTENSION);
     outstr = msReplaceSubstring(outstr, "[queryfile]", repstr);
   }
 
-  if(mapserv->savemap) {
-    snprintf(repstr, PROCESSLINE_BUFLEN, "%s%s%s.map", mapserv->map->web.imagepath, mapserv->map->name, mapserv->Id);
+  if (mapserv->savemap) {
+    snprintf(repstr, PROCESSLINE_BUFLEN, "%s%s%s.map",
+             mapserv->map->web.imagepath, mapserv->map->name, mapserv->Id);
     outstr = msReplaceSubstring(outstr, "[map]", repstr);
   }
 
-  if(strstr(outstr,"[mapserv_onlineresource]")) {
+  if (strstr(outstr, "[mapserv_onlineresource]")) {
     char *ol;
-#if defined(USE_WMS_SVR) || defined (USE_WFS_SVR) || defined (USE_WCS_SVR) || defined(USE_SOS_SVR) || defined(USE_WMS_LYR) || defined(USE_WFS_LYR)
-    ol = msOWSGetOnlineResource(mapserv->map, "O", "onlineresource", mapserv->request);
+#if defined(USE_WMS_SVR) || defined(USE_WFS_SVR) || defined(USE_WCS_SVR) ||    \
+    defined(USE_SOS_SVR) || defined(USE_WMS_LYR) || defined(USE_WFS_LYR)
+    ol = msOWSGetOnlineResource(mapserv->map, "O", "onlineresource",
+                                mapserv->request);
 #else
     ol = msBuildOnlineResource(mapserv->map, mapserv->request);
 #endif
-    outstr = msReplaceSubstring(outstr, "[mapserv_onlineresource]",ol);
+    outstr = msReplaceSubstring(outstr, "[mapserv_onlineresource]", ol);
     msFree(ol);
   }
 
-  if(getenv("HTTP_HOST")) {
+  if (getenv("HTTP_HOST")) {
     snprintf(repstr, PROCESSLINE_BUFLEN, "%s", getenv("HTTP_HOST"));
     outstr = msReplaceSubstring(outstr, "[host]", repstr);
   }
-  if(getenv("SERVER_PORT")) {
+  if (getenv("SERVER_PORT")) {
     snprintf(repstr, PROCESSLINE_BUFLEN, "%s", getenv("SERVER_PORT"));
     outstr = msReplaceSubstring(outstr, "[port]", repstr);
   }
@@ -3725,7 +4107,7 @@ static char *processLine(mapservObj *map
   outstr = msReplaceSubstring(outstr, "[id]", repstr);
 
   repstr[0] = '\0'; /* Layer list for a "POST" request */
-  for(i=0; i<mapserv->NumLayers; i++) {
+  for (i = 0; i < mapserv->NumLayers; i++) {
     strlcat(repstr, mapserv->Layers[i], sizeof(repstr));
     strlcat(repstr, " ", sizeof(repstr));
   }
@@ -3740,8 +4122,9 @@ static char *processLine(mapservObj *map
 
   strcpy(repstr, ""); /* list of ALL layers that can be toggled */
   repstr[0] = '\0';
-  for(i=0; i<mapserv->map->numlayers; i++) {
-    if(GET_LAYER(mapserv->map, i)->status != MS_DEFAULT && GET_LAYER(mapserv->map, i)->name != NULL) {
+  for (i = 0; i < mapserv->map->numlayers; i++) {
+    if (GET_LAYER(mapserv->map, i)->status != MS_DEFAULT &&
+        GET_LAYER(mapserv->map, i)->name != NULL) {
       strlcat(repstr, GET_LAYER(mapserv->map, i)->name, sizeof(repstr));
       strlcat(repstr, " ", sizeof(repstr));
     }
@@ -3753,38 +4136,49 @@ static char *processLine(mapservObj *map
   outstr = msReplaceSubstring(outstr, "[toggle_layers_esc]", encodedstr);
   free(encodedstr);
 
-  for(i=0; i<mapserv->map->numlayers; i++) { /* Set form widgets (i.e. checkboxes, radio and select lists), note that default layers don't show up here */
-    if(isOn(mapserv, GET_LAYER(mapserv->map, i)->name, GET_LAYER(mapserv->map, i)->group) == MS_TRUE) {
-      if(GET_LAYER(mapserv->map, i)->group) {
-        snprintf(substr, PROCESSLINE_BUFLEN, "[%s_select]", GET_LAYER(mapserv->map, i)->group);
+  for (i = 0; i < mapserv->map->numlayers;
+       i++) { /* Set form widgets (i.e. checkboxes, radio and select lists),
+                 note that default layers don't show up here */
+    if (isOn(mapserv, GET_LAYER(mapserv->map, i)->name,
+             GET_LAYER(mapserv->map, i)->group) == MS_TRUE) {
+      if (GET_LAYER(mapserv->map, i)->group) {
+        snprintf(substr, PROCESSLINE_BUFLEN, "[%s_select]",
+                 GET_LAYER(mapserv->map, i)->group);
         outstr = msReplaceSubstring(outstr, substr, "selected=\"selected\"");
-        snprintf(substr, PROCESSLINE_BUFLEN, "[%s_check]", GET_LAYER(mapserv->map, i)->group);
+        snprintf(substr, PROCESSLINE_BUFLEN, "[%s_check]",
+                 GET_LAYER(mapserv->map, i)->group);
         outstr = msReplaceSubstring(outstr, substr, "checked=\"checked\"");
       }
-      if(GET_LAYER(mapserv->map, i)->name) {
-        snprintf(substr, PROCESSLINE_BUFLEN, "[%s_select]", GET_LAYER(mapserv->map, i)->name);
+      if (GET_LAYER(mapserv->map, i)->name) {
+        snprintf(substr, PROCESSLINE_BUFLEN, "[%s_select]",
+                 GET_LAYER(mapserv->map, i)->name);
         outstr = msReplaceSubstring(outstr, substr, "selected=\"selected\"");
-        snprintf(substr, PROCESSLINE_BUFLEN, "[%s_check]", GET_LAYER(mapserv->map, i)->name);
+        snprintf(substr, PROCESSLINE_BUFLEN, "[%s_check]",
+                 GET_LAYER(mapserv->map, i)->name);
         outstr = msReplaceSubstring(outstr, substr, "checked=\"checked\"");
       }
     } else {
-      if(GET_LAYER(mapserv->map, i)->group) {
-        snprintf(substr, PROCESSLINE_BUFLEN, "[%s_select]", GET_LAYER(mapserv->map, i)->group);
+      if (GET_LAYER(mapserv->map, i)->group) {
+        snprintf(substr, PROCESSLINE_BUFLEN, "[%s_select]",
+                 GET_LAYER(mapserv->map, i)->group);
         outstr = msReplaceSubstring(outstr, substr, "");
-        snprintf(substr, PROCESSLINE_BUFLEN, "[%s_check]", GET_LAYER(mapserv->map, i)->group);
+        snprintf(substr, PROCESSLINE_BUFLEN, "[%s_check]",
+                 GET_LAYER(mapserv->map, i)->group);
         outstr = msReplaceSubstring(outstr, substr, "");
       }
-      if(GET_LAYER(mapserv->map, i)->name) {
-        snprintf(substr, PROCESSLINE_BUFLEN, "[%s_select]", GET_LAYER(mapserv->map, i)->name);
+      if (GET_LAYER(mapserv->map, i)->name) {
+        snprintf(substr, PROCESSLINE_BUFLEN, "[%s_select]",
+                 GET_LAYER(mapserv->map, i)->name);
         outstr = msReplaceSubstring(outstr, substr, "");
-        snprintf(substr, PROCESSLINE_BUFLEN, "[%s_check]", GET_LAYER(mapserv->map, i)->name);
+        snprintf(substr, PROCESSLINE_BUFLEN, "[%s_check]",
+                 GET_LAYER(mapserv->map, i)->name);
         outstr = msReplaceSubstring(outstr, substr, "");
       }
     }
   }
 
-  for(i=-1; i<=1; i++) { /* make zoom direction persistant */
-    if(mapserv->ZoomDirection == i) {
+  for (i = -1; i <= 1; i++) { /* make zoom direction persistant */
+    if (mapserv->ZoomDirection == i) {
       snprintf(substr, sizeof(substr), "[zoomdir_%d_select]", i);
       outstr = msReplaceSubstring(outstr, substr, "selected=\"selected\"");
       snprintf(substr, sizeof(substr), "[zoomdir_%d_check]", i);
@@ -3797,8 +4191,8 @@ static char *processLine(mapservObj *map
     }
   }
 
-  for(i=MINZOOM; i<=MAXZOOM; i++) { /* make zoom persistant */
-    if(mapserv->Zoom == i) {
+  for (i = MINZOOM; i <= MAXZOOM; i++) { /* make zoom persistant */
+    if (mapserv->Zoom == i) {
       snprintf(substr, sizeof(substr), "[zoom_%d_select]", i);
       outstr = msReplaceSubstring(outstr, substr, "selected=\"selected\"");
       snprintf(substr, sizeof(substr), "[zoom_%d_check]", i);
@@ -3817,10 +4211,11 @@ static char *processLine(mapservObj *map
    * reworked by SG to use HashTable methods
    */
 
-  if(&(mapserv->map->web.metadata) && strstr(outstr, "web_")) {
-    for (j=0; j<MS_HASHSIZE; j++) {
-      if(mapserv->map->web.metadata.items[j] != NULL) {
-        for(tp=mapserv->map->web.metadata.items[j]; tp!=NULL; tp=tp->next) {
+  if (&(mapserv->map->web.metadata) && strstr(outstr, "web_")) {
+    for (j = 0; j < MS_HASHSIZE; j++) {
+      if (mapserv->map->web.metadata.items[j] != NULL) {
+        for (tp = mapserv->map->web.metadata.items[j]; tp != NULL;
+             tp = tp->next) {
           snprintf(substr, PROCESSLINE_BUFLEN, "[web_%s]", tp->key);
           outstr = msReplaceSubstring(outstr, substr, tp->data);
           snprintf(substr, PROCESSLINE_BUFLEN, "[web_%s_esc]", tp->key);
@@ -3834,18 +4229,23 @@ static char *processLine(mapservObj *map
   }
 
   /* allow layer metadata access in template */
-  for(i=0; i<mapserv->map->numlayers; i++) {
-    if(&(GET_LAYER(mapserv->map, i)->metadata) && GET_LAYER(mapserv->map, i)->name && strstr(outstr, GET_LAYER(mapserv->map, i)->name)) {
-      for(j=0; j<MS_HASHSIZE; j++) {
-        if(GET_LAYER(mapserv->map, i)->metadata.items[j] != NULL) {
-          for(tp=GET_LAYER(mapserv->map, i)->metadata.items[j]; tp!=NULL; tp=tp->next) {
-            snprintf(substr, PROCESSLINE_BUFLEN, "[%s_%s]", GET_LAYER(mapserv->map, i)->name, tp->key);
-            if(GET_LAYER(mapserv->map, i)->status == MS_ON)
+  for (i = 0; i < mapserv->map->numlayers; i++) {
+    if (&(GET_LAYER(mapserv->map, i)->metadata) &&
+        GET_LAYER(mapserv->map, i)->name &&
+        strstr(outstr, GET_LAYER(mapserv->map, i)->name)) {
+      for (j = 0; j < MS_HASHSIZE; j++) {
+        if (GET_LAYER(mapserv->map, i)->metadata.items[j] != NULL) {
+          for (tp = GET_LAYER(mapserv->map, i)->metadata.items[j]; tp != NULL;
+               tp = tp->next) {
+            snprintf(substr, PROCESSLINE_BUFLEN, "[%s_%s]",
+                     GET_LAYER(mapserv->map, i)->name, tp->key);
+            if (GET_LAYER(mapserv->map, i)->status == MS_ON)
               outstr = msReplaceSubstring(outstr, substr, tp->data);
             else
               outstr = msReplaceSubstring(outstr, substr, "");
-            snprintf(substr, PROCESSLINE_BUFLEN, "[%s_%s_esc]", GET_LAYER(mapserv->map, i)->name, tp->key);
-            if(GET_LAYER(mapserv->map, i)->status == MS_ON) {
+            snprintf(substr, PROCESSLINE_BUFLEN, "[%s_%s_esc]",
+                     GET_LAYER(mapserv->map, i)->name, tp->key);
+            if (GET_LAYER(mapserv->map, i)->status == MS_ON) {
               encodedstr = msEncodeUrl(tp->data);
               outstr = msReplaceSubstring(outstr, substr, encodedstr);
               free(encodedstr);
@@ -3862,7 +4262,9 @@ static char *processLine(mapservObj *map
   snprintf(repstr, sizeof(repstr), "%f", mapserv->mappnt.y);
   outstr = msReplaceSubstring(outstr, "[mapy]", repstr);
 
-  snprintf(repstr, sizeof(repstr), "%f", mapserv->map->extent.minx); /* Individual mapextent elements for spatial query building, deprecated. */
+  snprintf(repstr, sizeof(repstr), "%f",
+           mapserv->map->extent.minx); /* Individual mapextent elements for
+                                          spatial query building, deprecated. */
   outstr = msReplaceSubstring(outstr, "[minx]", repstr);
   snprintf(repstr, sizeof(repstr), "%f", mapserv->map->extent.maxx);
   outstr = msReplaceSubstring(outstr, "[maxx]", repstr);
@@ -3871,20 +4273,30 @@ static char *processLine(mapservObj *map
   snprintf(repstr, sizeof(repstr), "%f", mapserv->map->extent.maxy);
   outstr = msReplaceSubstring(outstr, "[maxy]", repstr);
 
-  if(processDateTag( &outstr ) != MS_SUCCESS)
-    return(NULL);
+  if (processDateTag(&outstr) != MS_SUCCESS)
+    return (NULL);
 
-  if(processExtentTag(mapserv, &outstr, "mapext", &(mapserv->map->extent), &(mapserv->map->projection)) != MS_SUCCESS)
-    return(NULL);
-  if(processExtentTag(mapserv, &outstr, "mapext_esc", &(mapserv->map->extent), &(mapserv->map->projection)) != MS_SUCCESS) /* depricated */
-    return(NULL);
-
-  snprintf(repstr, sizeof(repstr), "%f", (mapserv->map->extent.maxx-mapserv->map->extent.minx)); /* useful for creating cachable extents (i.e. 0 0 dx dy) with legends and scalebars */
+  if (processExtentTag(mapserv, &outstr, "mapext", &(mapserv->map->extent),
+                       &(mapserv->map->projection)) != MS_SUCCESS)
+    return (NULL);
+  if (processExtentTag(mapserv, &outstr, "mapext_esc", &(mapserv->map->extent),
+                       &(mapserv->map->projection)) !=
+      MS_SUCCESS) /* depricated */
+    return (NULL);
+
+  snprintf(repstr, sizeof(repstr), "%f",
+           (mapserv->map->extent.maxx -
+            mapserv->map->extent
+                .minx)); /* useful for creating cachable extents (i.e. 0 0 dx
+                            dy) with legends and scalebars */
   outstr = msReplaceSubstring(outstr, "[dx]", repstr);
-  snprintf(repstr, sizeof(repstr), "%f", (mapserv->map->extent.maxy-mapserv->map->extent.miny));
+  snprintf(repstr, sizeof(repstr), "%f",
+           (mapserv->map->extent.maxy - mapserv->map->extent.miny));
   outstr = msReplaceSubstring(outstr, "[dy]", repstr);
 
-  snprintf(repstr, sizeof(repstr), "%f", mapserv->RawExt.minx); /* Individual raw extent elements for spatial query building, deprecated. */
+  snprintf(repstr, sizeof(repstr), "%f",
+           mapserv->RawExt.minx); /* Individual raw extent elements for spatial
+                                     query building, deprecated. */
   outstr = msReplaceSubstring(outstr, "[rawminx]", repstr);
   snprintf(repstr, sizeof(repstr), "%f", mapserv->RawExt.maxx);
   outstr = msReplaceSubstring(outstr, "[rawmaxx]", repstr);
@@ -3893,25 +4305,32 @@ static char *processLine(mapservObj *map
   snprintf(repstr, sizeof(repstr), "%f", mapserv->RawExt.maxy);
   outstr = msReplaceSubstring(outstr, "[rawmaxy]", repstr);
 
-  if(processExtentTag(mapserv, &outstr, "rawext", &(mapserv->RawExt), &(mapserv->map->projection)) != MS_SUCCESS)
-    return(NULL);
-  if(processExtentTag(mapserv, &outstr, "rawext_esc", &(mapserv->RawExt), &(mapserv->map->projection)) != MS_SUCCESS) /* depricated */
-    return(NULL);
-
-  if((strstr(outstr, "lat]") || strstr(outstr, "lon]") || strstr(outstr, "lon_esc]"))
-      && mapserv->map->projection.proj != NULL
-      && !msProjIsGeographicCRS(&(mapserv->map->projection)) ) {
-    llextent=mapserv->map->extent;
-    llpoint=mapserv->mappnt;
-    msProjectRect(&(mapserv->map->projection), &(mapserv->map->latlon), &llextent);
-    msProjectPoint(&(mapserv->map->projection), &(mapserv->map->latlon), &llpoint);
+  if (processExtentTag(mapserv, &outstr, "rawext", &(mapserv->RawExt),
+                       &(mapserv->map->projection)) != MS_SUCCESS)
+    return (NULL);
+  if (processExtentTag(mapserv, &outstr, "rawext_esc", &(mapserv->RawExt),
+                       &(mapserv->map->projection)) !=
+      MS_SUCCESS) /* depricated */
+    return (NULL);
+
+  if ((strstr(outstr, "lat]") || strstr(outstr, "lon]") ||
+       strstr(outstr, "lon_esc]")) &&
+      mapserv->map->projection.proj != NULL &&
+      !msProjIsGeographicCRS(&(mapserv->map->projection))) {
+    llextent = mapserv->map->extent;
+    llpoint = mapserv->mappnt;
+    msProjectRect(&(mapserv->map->projection), &(mapserv->map->latlon),
+                  &llextent);
+    msProjectPoint(&(mapserv->map->projection), &(mapserv->map->latlon),
+                   &llpoint);
 
     snprintf(repstr, sizeof(repstr), "%f", llpoint.x);
     outstr = msReplaceSubstring(outstr, "[maplon]", repstr);
     snprintf(repstr, sizeof(repstr), "%f", llpoint.y);
     outstr = msReplaceSubstring(outstr, "[maplat]", repstr);
 
-    snprintf(repstr, sizeof(repstr), "%f", llextent.minx); /* map extent as lat/lon */
+    snprintf(repstr, sizeof(repstr), "%f",
+             llextent.minx); /* map extent as lat/lon */
     outstr = msReplaceSubstring(outstr, "[minlon]", repstr);
     snprintf(repstr, sizeof(repstr), "%f", llextent.maxx);
     outstr = msReplaceSubstring(outstr, "[maxlon]", repstr);
@@ -3920,15 +4339,20 @@ static char *processLine(mapservObj *map
     snprintf(repstr, sizeof(repstr), "%f", llextent.maxy);
     outstr = msReplaceSubstring(outstr, "[maxlat]", repstr);
 
-    if(processExtentTag(mapserv, &outstr, "mapext_latlon", &(llextent), NULL) != MS_SUCCESS)
-      return(NULL);
-    if(processExtentTag(mapserv, &outstr, "mapext_latlon_esc", &(llextent), NULL) != MS_SUCCESS) /* depricated */
-      return(NULL);
+    if (processExtentTag(mapserv, &outstr, "mapext_latlon", &(llextent),
+                         NULL) != MS_SUCCESS)
+      return (NULL);
+    if (processExtentTag(mapserv, &outstr, "mapext_latlon_esc", &(llextent),
+                         NULL) != MS_SUCCESS) /* depricated */
+      return (NULL);
   }
 
   /* submitted by J.F (bug 1102) */
-  if(mapserv->map->reference.status == MS_ON) {
-    snprintf(repstr, sizeof(repstr), "%f", mapserv->map->reference.extent.minx); /* Individual reference map extent elements for spatial query building, depricated. */
+  if (mapserv->map->reference.status == MS_ON) {
+    snprintf(repstr, sizeof(repstr), "%f",
+             mapserv->map->reference.extent
+                 .minx); /* Individual reference map extent elements for spatial
+                            query building, depricated. */
     outstr = msReplaceSubstring(outstr, "[refminx]", repstr);
     snprintf(repstr, sizeof(repstr), "%f", mapserv->map->reference.extent.maxx);
     outstr = msReplaceSubstring(outstr, "[refmaxx]", repstr);
@@ -3937,13 +4361,18 @@ static char *processLine(mapservObj *map
     snprintf(repstr, sizeof(repstr), "%f", mapserv->map->reference.extent.maxy);
     outstr = msReplaceSubstring(outstr, "[refmaxy]", repstr);
 
-    if(processExtentTag(mapserv, &outstr, "refext", &(mapserv->map->reference.extent), &(mapserv->map->projection)) != MS_SUCCESS)
-      return(NULL);
-    if(processExtentTag(mapserv, &outstr, "refext_esc", &(mapserv->map->reference.extent), &(mapserv->map->projection)) != MS_SUCCESS) /* depricated */
-      return(NULL);
+    if (processExtentTag(mapserv, &outstr, "refext",
+                         &(mapserv->map->reference.extent),
+                         &(mapserv->map->projection)) != MS_SUCCESS)
+      return (NULL);
+    if (processExtentTag(
+            mapserv, &outstr, "refext_esc", &(mapserv->map->reference.extent),
+            &(mapserv->map->projection)) != MS_SUCCESS) /* depricated */
+      return (NULL);
   }
 
-  snprintf(repstr, sizeof(repstr), "%d %d", mapserv->map->width, mapserv->map->height);
+  snprintf(repstr, sizeof(repstr), "%d %d", mapserv->map->width,
+           mapserv->map->height);
   outstr = msReplaceSubstring(outstr, "[mapsize]", repstr);
 
   encodedstr = msEncodeUrl(repstr);
@@ -3961,42 +4390,59 @@ static char *processLine(mapservObj *map
   snprintf(repstr, sizeof(repstr), "%f", mapserv->map->cellsize);
   outstr = msReplaceSubstring(outstr, "[cellsize]", repstr);
 
-  snprintf(repstr, sizeof(repstr), "%.1f %.1f", (mapserv->map->width)/2.0, (mapserv->map->height)/2.0); /* not subtracting 1 from image dimensions (see bug 633) */
+  snprintf(repstr, sizeof(repstr), "%.1f %.1f", (mapserv->map->width) / 2.0,
+           (mapserv->map->height) /
+               2.0); /* not subtracting 1 from image dimensions (see bug 633) */
   outstr = msReplaceSubstring(outstr, "[center]", repstr);
-  snprintf(repstr, sizeof(repstr), "%.1f", (mapserv->map->width)/2.0);
+  snprintf(repstr, sizeof(repstr), "%.1f", (mapserv->map->width) / 2.0);
   outstr = msReplaceSubstring(outstr, "[center_x]", repstr);
-  snprintf(repstr, sizeof(repstr), "%.1f", (mapserv->map->height)/2.0);
+  snprintf(repstr, sizeof(repstr), "%.1f", (mapserv->map->height) / 2.0);
   outstr = msReplaceSubstring(outstr, "[center_y]", repstr);
 
-  /* These are really for situations with multiple result sets only, but often used in header/footer   */
-  snprintf(repstr, sizeof(repstr), "%d", mapserv->NR); /* total number of results */
+  /* These are really for situations with multiple result sets only, but often
+   * used in header/footer   */
+  snprintf(repstr, sizeof(repstr), "%d",
+           mapserv->NR); /* total number of results */
   outstr = msReplaceSubstring(outstr, "[nr]", repstr);
-  snprintf(repstr, sizeof(repstr), "%d", mapserv->NL); /* total number of layers with results */
+  snprintf(repstr, sizeof(repstr), "%d",
+           mapserv->NL); /* total number of layers with results */
   outstr = msReplaceSubstring(outstr, "[nl]", repstr);
 
-  if(mapserv->resultlayer) {
-    if(strstr(outstr, "[items]") != NULL) {
-      char *itemstr=NULL;
+  if (mapserv->resultlayer) {
+    if (strstr(outstr, "[items]") != NULL) {
+      char *itemstr = NULL;
 
-      itemstr = msJoinStrings(mapserv->resultlayer->items, mapserv->resultlayer->numitems, ",");
+      itemstr = msJoinStrings(mapserv->resultlayer->items,
+                              mapserv->resultlayer->numitems, ",");
       outstr = msReplaceSubstring(outstr, "[items]", itemstr);
       free(itemstr);
     }
 
-    snprintf(repstr, sizeof(repstr), "%d", mapserv->NLR); /* total number of results within this layer */
+    snprintf(repstr, sizeof(repstr), "%d",
+             mapserv->NLR); /* total number of results within this layer */
     outstr = msReplaceSubstring(outstr, "[nlr]", repstr);
-    snprintf(repstr, sizeof(repstr), "%d", mapserv->RN); /* sequential (eg. 1..n) result number within all layers */
+    snprintf(
+        repstr, sizeof(repstr), "%d",
+        mapserv
+            ->RN); /* sequential (eg. 1..n) result number within all layers */
     outstr = msReplaceSubstring(outstr, "[rn]", repstr);
-    snprintf(repstr, sizeof(repstr), "%d", mapserv->LRN); /* sequential (eg. 1..n) result number within this layer */
+    snprintf(
+        repstr, sizeof(repstr), "%d",
+        mapserv
+            ->LRN); /* sequential (eg. 1..n) result number within this layer */
     outstr = msReplaceSubstring(outstr, "[lrn]", repstr);
-    outstr = msReplaceSubstring(outstr, "[cl]", mapserv->resultlayer->name); /* current layer name */
-    /* if(resultlayer->description) outstr = msReplaceSubstring(outstr, "[cd]", resultlayer->description); */ /* current layer description */
-
-    /* allow layer metadata access when there is a current result layer (implicitly a query template) */
-    if(&(mapserv->resultlayer->metadata) && strstr(outstr, "[metadata_")) {
-      for(i=0; i<MS_HASHSIZE; i++) {
-        if(mapserv->resultlayer->metadata.items[i] != NULL) {
-          for(tp=mapserv->resultlayer->metadata.items[i]; tp!=NULL; tp=tp->next) {
+    outstr = msReplaceSubstring(
+        outstr, "[cl]", mapserv->resultlayer->name); /* current layer name */
+    /* if(resultlayer->description) outstr = msReplaceSubstring(outstr, "[cd]",
+     * resultlayer->description); */ /* current layer description */
+
+    /* allow layer metadata access when there is a current result layer
+     * (implicitly a query template) */
+    if (&(mapserv->resultlayer->metadata) && strstr(outstr, "[metadata_")) {
+      for (i = 0; i < MS_HASHSIZE; i++) {
+        if (mapserv->resultlayer->metadata.items[i] != NULL) {
+          for (tp = mapserv->resultlayer->metadata.items[i]; tp != NULL;
+               tp = tp->next) {
             snprintf(substr, PROCESSLINE_BUFLEN, "[metadata_%s]", tp->key);
             outstr = msReplaceSubstring(outstr, substr, tp->data);
 
@@ -4010,35 +4456,52 @@ static char *processLine(mapservObj *map
     }
   }
 
-  if(mode != QUERY) {
-    if(processResultSetTag(mapserv, &outstr, stream) != MS_SUCCESS) {
+  if (mode != QUERY) {
+    if (processResultSetTag(mapserv, &outstr, stream) != MS_SUCCESS) {
       msFree(outstr);
-      return(NULL);
+      return (NULL);
     }
   } else { /* return shape and/or values */
 
     assert(mapserv->resultlayer);
 
-    snprintf(repstr, sizeof(repstr), "%f %f", (mapserv->resultshape.bounds.maxx + mapserv->resultshape.bounds.minx)/2, (mapserv->resultshape.bounds.maxy + mapserv->resultshape.bounds.miny)/2);
+    snprintf(
+        repstr, sizeof(repstr), "%f %f",
+        (mapserv->resultshape.bounds.maxx + mapserv->resultshape.bounds.minx) /
+            2,
+        (mapserv->resultshape.bounds.maxy + mapserv->resultshape.bounds.miny) /
+            2);
     outstr = msReplaceSubstring(outstr, "[shpmid]", repstr);
-    snprintf(repstr, sizeof(repstr), "%f", (mapserv->resultshape.bounds.maxx + mapserv->resultshape.bounds.minx)/2);
+    snprintf(
+        repstr, sizeof(repstr), "%f",
+        (mapserv->resultshape.bounds.maxx + mapserv->resultshape.bounds.minx) /
+            2);
     outstr = msReplaceSubstring(outstr, "[shpmidx]", repstr);
-    snprintf(repstr, sizeof(repstr), "%f", (mapserv->resultshape.bounds.maxy + mapserv->resultshape.bounds.miny)/2);
+    snprintf(
+        repstr, sizeof(repstr), "%f",
+        (mapserv->resultshape.bounds.maxy + mapserv->resultshape.bounds.miny) /
+            2);
     outstr = msReplaceSubstring(outstr, "[shpmidy]", repstr);
 
-    if(processExtentTag(mapserv, &outstr, "shpext", &(mapserv->resultshape.bounds), &(mapserv->resultlayer->projection)) != MS_SUCCESS)
-      return(NULL);
-    if(processExtentTag(mapserv, &outstr, "shpext_esc", &(mapserv->resultshape.bounds), &(mapserv->resultlayer->projection)) != MS_SUCCESS) /* depricated */
-      return(NULL);
+    if (processExtentTag(mapserv, &outstr, "shpext",
+                         &(mapserv->resultshape.bounds),
+                         &(mapserv->resultlayer->projection)) != MS_SUCCESS)
+      return (NULL);
+    if (processExtentTag(
+            mapserv, &outstr, "shpext_esc", &(mapserv->resultshape.bounds),
+            &(mapserv->resultlayer->projection)) != MS_SUCCESS) /* depricated */
+      return (NULL);
 
     snprintf(repstr, sizeof(repstr), "%d", mapserv->resultshape.classindex);
     outstr = msReplaceSubstring(outstr, "[shpclass]", repstr);
 
-    if(processShpxyTag(mapserv->resultlayer, &outstr, &mapserv->resultshape) != MS_SUCCESS)
-      return(NULL);
-
-    if(processShplabelTag(mapserv->resultlayer, &outstr, &mapserv->resultshape) != MS_SUCCESS)
-      return(NULL);
+    if (processShpxyTag(mapserv->resultlayer, &outstr, &mapserv->resultshape) !=
+        MS_SUCCESS)
+      return (NULL);
+
+    if (processShplabelTag(mapserv->resultlayer, &outstr,
+                           &mapserv->resultshape) != MS_SUCCESS)
+      return (NULL);
 
     snprintf(repstr, sizeof(repstr), "%f", mapserv->resultshape.bounds.minx);
     outstr = msReplaceSubstring(outstr, "[shpminx]", repstr);
@@ -4055,72 +4518,89 @@ static char *processLine(mapservObj *map
     outstr = msReplaceSubstring(outstr, "[tileidx]", repstr);
 
     /* return ALL attributes in one delimeted list */
-    if(strstr(outstr, "[values]") != NULL) {
-      char *valuestr=NULL;
+    if (strstr(outstr, "[values]") != NULL) {
+      char *valuestr = NULL;
 
-      valuestr = msJoinStrings(mapserv->resultshape.values, mapserv->resultlayer->numitems, ",");
+      valuestr = msJoinStrings(mapserv->resultshape.values,
+                               mapserv->resultlayer->numitems, ",");
       outstr = msReplaceSubstring(outstr, "[values]", valuestr);
       free(valuestr);
     }
 
-    for(i=0; i<mapserv->resultlayer->numitems; i++) {
+    for (i = 0; i < mapserv->resultlayer->numitems; i++) {
       /* by default let's encode attributes for HTML presentation */
-      snprintf(substr, PROCESSLINE_BUFLEN, "[%s]", mapserv->resultlayer->items[i]);
-      if(strstr(outstr, substr) != NULL) {
+      snprintf(substr, PROCESSLINE_BUFLEN, "[%s]",
+               mapserv->resultlayer->items[i]);
+      if (strstr(outstr, substr) != NULL) {
         encodedstr = msEncodeHTMLEntities(mapserv->resultshape.values[i]);
         outstr = msReplaceSubstring(outstr, substr, encodedstr);
         free(encodedstr);
       }
 
       /* of course you might want to embed that data in URLs */
-      snprintf(substr, PROCESSLINE_BUFLEN, "[%s_esc]", mapserv->resultlayer->items[i]);
-      if(strstr(outstr, substr) != NULL) {
+      snprintf(substr, PROCESSLINE_BUFLEN, "[%s_esc]",
+               mapserv->resultlayer->items[i]);
+      if (strstr(outstr, substr) != NULL) {
         encodedstr = msEncodeUrl(mapserv->resultshape.values[i]);
         outstr = msReplaceSubstring(outstr, substr, encodedstr);
         free(encodedstr);
       }
 
       /* or you might want to access the attributes unaltered */
-      snprintf(substr, PROCESSLINE_BUFLEN, "[%s_raw]", mapserv->resultlayer->items[i]);
-      if(strstr(outstr, substr) != NULL)
-        outstr = msReplaceSubstring(outstr, substr, mapserv->resultshape.values[i]);
+      snprintf(substr, PROCESSLINE_BUFLEN, "[%s_raw]",
+               mapserv->resultlayer->items[i]);
+      if (strstr(outstr, substr) != NULL)
+        outstr =
+            msReplaceSubstring(outstr, substr, mapserv->resultshape.values[i]);
     }
 
-    if(processItemTag(mapserv->resultlayer, &outstr, &mapserv->resultshape) != MS_SUCCESS)
-      return(NULL);
+    if (processItemTag(mapserv->resultlayer, &outstr, &mapserv->resultshape) !=
+        MS_SUCCESS)
+      return (NULL);
 
     /* handle joins in this next section */
-    for(i=0; i<mapserv->resultlayer->numjoins; i++) {
-      if(mapserv->resultlayer->joins[i].values) { /* join has data */
-        for(j=0; j<mapserv->resultlayer->joins[i].numitems; j++) {
+    for (i = 0; i < mapserv->resultlayer->numjoins; i++) {
+      if (mapserv->resultlayer->joins[i].values) { /* join has data */
+        for (j = 0; j < mapserv->resultlayer->joins[i].numitems; j++) {
           /* by default let's encode attributes for HTML presentation */
-          snprintf(substr, PROCESSLINE_BUFLEN, "[%s_%s]", mapserv->resultlayer->joins[i].name, mapserv->resultlayer->joins[i].items[j]);
-          if(strstr(outstr, substr) != NULL) {
-            encodedstr = msEncodeHTMLEntities(mapserv->resultlayer->joins[i].values[j]);
+          snprintf(substr, PROCESSLINE_BUFLEN, "[%s_%s]",
+                   mapserv->resultlayer->joins[i].name,
+                   mapserv->resultlayer->joins[i].items[j]);
+          if (strstr(outstr, substr) != NULL) {
+            encodedstr =
+                msEncodeHTMLEntities(mapserv->resultlayer->joins[i].values[j]);
             outstr = msReplaceSubstring(outstr, substr, encodedstr);
             free(encodedstr);
           }
 
           /* of course you might want to embed that data in URLs */
-          snprintf(substr, PROCESSLINE_BUFLEN, "[%s_%s_esc]", mapserv->resultlayer->joins[i].name, mapserv->resultlayer->joins[i].items[j]);
-          if(strstr(outstr, substr) != NULL) {
+          snprintf(substr, PROCESSLINE_BUFLEN, "[%s_%s_esc]",
+                   mapserv->resultlayer->joins[i].name,
+                   mapserv->resultlayer->joins[i].items[j]);
+          if (strstr(outstr, substr) != NULL) {
             encodedstr = msEncodeUrl(mapserv->resultlayer->joins[i].values[j]);
             outstr = msReplaceSubstring(outstr, substr, encodedstr);
             free(encodedstr);
           }
 
           /* or you might want to access the attributes unaltered */
-          snprintf(substr, PROCESSLINE_BUFLEN, "[%s_%s_raw]", mapserv->resultlayer->joins[i].name, mapserv->resultlayer->joins[i].items[j]);
-          if(strstr(outstr, substr) != NULL)
-            outstr = msReplaceSubstring(outstr, substr, mapserv->resultlayer->joins[i].values[j]);
-        }
-      } else if(mapserv->resultlayer->joins[i].type ==  MS_JOIN_ONE_TO_MANY) { /* one-to-many join */
-        char *joinTemplate=NULL;
-
-        snprintf(substr, PROCESSLINE_BUFLEN, "[join_%s]", mapserv->resultlayer->joins[i].name);
-        if(strstr(outstr, substr) != NULL) {
-          joinTemplate = processOneToManyJoin(mapserv, &(mapserv->resultlayer->joins[i]));
-          if(joinTemplate) {
+          snprintf(substr, PROCESSLINE_BUFLEN, "[%s_%s_raw]",
+                   mapserv->resultlayer->joins[i].name,
+                   mapserv->resultlayer->joins[i].items[j]);
+          if (strstr(outstr, substr) != NULL)
+            outstr = msReplaceSubstring(
+                outstr, substr, mapserv->resultlayer->joins[i].values[j]);
+        }
+      } else if (mapserv->resultlayer->joins[i].type ==
+                 MS_JOIN_ONE_TO_MANY) { /* one-to-many join */
+        char *joinTemplate = NULL;
+
+        snprintf(substr, PROCESSLINE_BUFLEN, "[join_%s]",
+                 mapserv->resultlayer->joins[i].name);
+        if (strstr(outstr, substr) != NULL) {
+          joinTemplate =
+              processOneToManyJoin(mapserv, &(mapserv->resultlayer->joins[i]));
+          if (joinTemplate) {
             outstr = msReplaceSubstring(outstr, substr, joinTemplate);
             free(joinTemplate);
           } else
@@ -4131,70 +4611,75 @@ static char *processLine(mapservObj *map
 
   } /* end query mode specific substitutions */
 
-  if(processIncludeTag(mapserv, &outstr, stream, mode) != MS_SUCCESS)
-    return(NULL);
+  if (processIncludeTag(mapserv, &outstr, stream, mode) != MS_SUCCESS)
+    return (NULL);
 
-  for(i=0; i<mapserv->request->NumParams; i++) {
+  for (i = 0; i < mapserv->request->NumParams; i++) {
     /* Replace [variable] tags using values from URL. We cannot offer a
      * [variable_raw] option here due to the risk of XSS.
      *
      * Replacement is case-insensitive. (#4511)
      */
-    snprintf(substr, PROCESSLINE_BUFLEN, "[%s]", mapserv->request->ParamNames[i]);
+    snprintf(substr, PROCESSLINE_BUFLEN, "[%s]",
+             mapserv->request->ParamNames[i]);
     encodedstr = msEncodeHTMLEntities(mapserv->request->ParamValues[i]);
     outstr = msCaseReplaceSubstring(outstr, substr, encodedstr);
     free(encodedstr);
 
-    snprintf(substr, PROCESSLINE_BUFLEN, "[%s_esc]", mapserv->request->ParamNames[i]);
+    snprintf(substr, PROCESSLINE_BUFLEN, "[%s_esc]",
+             mapserv->request->ParamNames[i]);
     encodedstr = msEncodeUrl(mapserv->request->ParamValues[i]);
     outstr = msCaseReplaceSubstring(outstr, substr, encodedstr);
     free(encodedstr);
   }
 
-  return(outstr);
+  return (outstr);
 }
 
 #define MS_TEMPLATE_BUFFER 1024 /* 1k */
 
-int msReturnPage(mapservObj *mapserv, char *html, int mode, char **papszBuffer)
-{
+int msReturnPage(mapservObj *mapserv, char *html, int mode,
+                 char **papszBuffer) {
   FILE *stream;
   char line[MS_BUFFER_LENGTH], *tmpline;
-  int   nBufferSize = 0;
-  int   nCurrentSize = 0;
+  int nBufferSize = 0;
+  int nCurrentSize = 0;
 
   ms_regex_t re; /* compiled regular expression to be matched */
   char szPath[MS_MAXPATHLEN];
 
-  if(!html) {
+  if (!html) {
     msSetError(MS_WEBERR, "No template specified", "msReturnPage()");
     return MS_FAILURE;
   }
 
-  if(ms_regcomp(&re, MS_TEMPLATE_EXPR, MS_REG_EXTENDED|MS_REG_NOSUB|MS_REG_ICASE) != 0) {
+  if (ms_regcomp(&re, MS_TEMPLATE_EXPR,
+                 MS_REG_EXTENDED | MS_REG_NOSUB | MS_REG_ICASE) != 0) {
     msSetError(MS_REGEXERR, NULL, "msReturnPage()");
     return MS_FAILURE;
   }
 
-  if(ms_regexec(&re, html, 0, NULL, 0) != 0) { /* no match */
+  if (ms_regexec(&re, html, 0, NULL, 0) != 0) { /* no match */
     ms_regfree(&re);
-    msSetError(MS_WEBERR, "Malformed template name (%s).", "msReturnPage()", html);
+    msSetError(MS_WEBERR, "Malformed template name (%s).", "msReturnPage()",
+               html);
     return MS_FAILURE;
   }
   ms_regfree(&re);
 
-  if((stream = fopen(msBuildPath(szPath, mapserv->map->mappath, html), "r")) == NULL) {
+  if ((stream = fopen(msBuildPath(szPath, mapserv->map->mappath, html), "r")) ==
+      NULL) {
     msSetError(MS_IOERR, "%s", "msReturnPage()", html);
     return MS_FAILURE;
   }
 
-  if(isValidTemplate(stream, html) != MS_TRUE) {
+  if (isValidTemplate(stream, html) != MS_TRUE) {
     fclose(stream);
     return MS_FAILURE;
   }
 
-  if(papszBuffer) {
-    if((*papszBuffer) == NULL) {
+  if (papszBuffer) {
+    if ((*papszBuffer) == NULL) {
       (*papszBuffer) = (char *)msSmallMalloc(MS_TEMPLATE_BUFFER);
       (*papszBuffer)[0] = '\0';
       nBufferSize = MS_TEMPLATE_BUFFER;
@@ -4205,20 +4690,23 @@ int msReturnPage(mapservObj *mapserv, ch
     }
   }
 
-  while(fgets(line, MS_BUFFER_LENGTH, stream) != NULL) { /* now on to the end of the file */
+  while (fgets(line, MS_BUFFER_LENGTH, stream) !=
+         NULL) { /* now on to the end of the file */
 
-    if(strchr(line, '[') != NULL) {
+    if (strchr(line, '[') != NULL) {
       tmpline = processLine(mapserv, line, stream, mode);
-      if(!tmpline) {
+      if (!tmpline) {
         fclose(stream);
         return MS_FAILURE;
       }
 
-      if(papszBuffer) {
-        if(nBufferSize <= (int)(nCurrentSize + strlen(tmpline) + 1)) {
-          const int nExpandBuffer = (strlen(tmpline) /  MS_TEMPLATE_BUFFER) + 1;
-          nBufferSize = MS_TEMPLATE_BUFFER*nExpandBuffer + strlen((*papszBuffer));
-          (*papszBuffer) = (char *) msSmallRealloc((*papszBuffer),sizeof(char)*nBufferSize);
+      if (papszBuffer) {
+        if (nBufferSize <= (int)(nCurrentSize + strlen(tmpline) + 1)) {
+          const int nExpandBuffer = (strlen(tmpline) / MS_TEMPLATE_BUFFER) + 1;
+          nBufferSize =
+              MS_TEMPLATE_BUFFER * nExpandBuffer + strlen((*papszBuffer));
+          (*papszBuffer) = (char *)msSmallRealloc((*papszBuffer),
+                                                  sizeof(char) * nBufferSize);
         }
         strcat((*papszBuffer), tmpline);
         nCurrentSize += strlen(tmpline);
@@ -4227,18 +4715,20 @@ int msReturnPage(mapservObj *mapserv, ch
 
       free(tmpline);
     } else {
-      if(papszBuffer) {
-        if(nBufferSize <= (int)(nCurrentSize + strlen(line))) {
-          const int nExpandBuffer = (strlen(line) /  MS_TEMPLATE_BUFFER) + 1;
-          nBufferSize = MS_TEMPLATE_BUFFER*nExpandBuffer + strlen((*papszBuffer));
-          (*papszBuffer) = (char *)msSmallRealloc((*papszBuffer),sizeof(char)*nBufferSize);
+      if (papszBuffer) {
+        if (nBufferSize <= (int)(nCurrentSize + strlen(line))) {
+          const int nExpandBuffer = (strlen(line) / MS_TEMPLATE_BUFFER) + 1;
+          nBufferSize =
+              MS_TEMPLATE_BUFFER * nExpandBuffer + strlen((*papszBuffer));
+          (*papszBuffer) = (char *)msSmallRealloc((*papszBuffer),
+                                                  sizeof(char) * nBufferSize);
         }
         strcat((*papszBuffer), line);
         nCurrentSize += strlen(line);
       } else
         msIO_fwrite(line, strlen(line), 1, stdout);
     }
-    if(!papszBuffer)
+    if (!papszBuffer)
       fflush(stdout);
   } /* next line */
 
@@ -4247,18 +4737,19 @@ int msReturnPage(mapservObj *mapserv, ch
   return MS_SUCCESS;
 }
 
-int msReturnURL(mapservObj* ms, char* url, int mode)
-{
+int msReturnURL(mapservObj *ms, char *url, int mode) {
   char *tmpurl;
 
-  if(url == NULL) {
+  if (url == NULL) {
     msSetError(MS_WEBERR, "Empty URL.", "msReturnURL()");
     return MS_FAILURE;
   }
 
-  tmpurl = processLine(ms, url, NULL, mode); /* URL templates can't handle multi-line tags, hence the NULL file pointer */
+  tmpurl =
+      processLine(ms, url, NULL, mode); /* URL templates can't handle multi-line
+                                           tags, hence the NULL file pointer */
 
-  if(!tmpurl)
+  if (!tmpurl)
     return MS_FAILURE;
 
   msRedirect(tmpurl);
@@ -4270,20 +4761,20 @@ int msReturnURL(mapservObj* ms, char* ur
 /*
 ** Legacy query template parsing where you use headers, footers and such...
 */
-int msReturnNestedTemplateQuery(mapservObj* mapserv, char* pszMimeType, char **papszBuffer)
-{
+int msReturnNestedTemplateQuery(mapservObj *mapserv, char *pszMimeType,
+                                char **papszBuffer) {
   int status;
-  int i,j,k;
+  int i, j, k;
   char buffer[1024];
-  int nBufferSize =0;
+  int nBufferSize = 0;
   int nCurrentSize = 0;
   int nExpandBuffer = 0;
 
   char *template;
 
-  layerObj *lp=NULL;
+  layerObj *lp = NULL;
 
-  if(papszBuffer) {
+  if (papszBuffer) {
     (*papszBuffer) = (char *)msSmallMalloc(MS_TEMPLATE_BUFFER);
     (*papszBuffer)[0] = '\0';
     nBufferSize = MS_TEMPLATE_BUFFER;
@@ -4293,28 +4784,37 @@ int msReturnNestedTemplateQuery(mapservO
 
   msInitShape(&(mapserv->resultshape));
 
-  if((mapserv->Mode == ITEMQUERY) || (mapserv->Mode == QUERY)) { /* may need to handle a URL result set since these modes return exactly 1 result */
+  if ((mapserv->Mode == ITEMQUERY) ||
+      (mapserv->Mode == QUERY)) { /* may need to handle a URL result set since
+                                     these modes return exactly 1 result */
 
-    for(i=(mapserv->map->numlayers-1); i>=0; i--) {
+    for (i = (mapserv->map->numlayers - 1); i >= 0; i--) {
       lp = (GET_LAYER(mapserv->map, i));
 
-      if(!lp->resultcache) continue;
-      if(lp->resultcache->numresults > 0) break;
+      if (!lp->resultcache)
+        continue;
+      if (lp->resultcache->numresults > 0)
+        break;
     }
 
-    if(i >= 0) { /* at least if no result found, mapserver will display an empty template. */
+    if (i >= 0) { /* at least if no result found, mapserver will display an
+                     empty template. */
 
-      if(lp->resultcache->results[0].classindex >= 0 && lp->class[(int)(lp->resultcache->results[0].classindex)]->template)
-        template = lp->class[(int)(lp->resultcache->results[0].classindex)]->template;
+      if (lp->resultcache->results[0].classindex >= 0 &&
+              lp->class[(int)(lp->resultcache->results[0].classindex)]
+          -> template)
+        template =
+            lp->class[(int)(lp->resultcache->results[0].classindex)]->template;
       else
         template = lp->template;
 
-      if( template == NULL ) {
-        msSetError(MS_WEBERR, "No template for layer %s or it's classes.", "msReturnNestedTemplateQuery()", lp->name );
+      if (template == NULL) {
+        msSetError(MS_WEBERR, "No template for layer %s or it's classes.",
+                   "msReturnNestedTemplateQuery()", lp->name);
         return MS_FAILURE;
       }
 
-      if(TEMPLATE_TYPE(template) == MS_URL) {
+      if (TEMPLATE_TYPE(template) == MS_URL) {
         mapserv->resultlayer = lp;
 
 #if 0
@@ -4325,21 +4825,25 @@ int msReturnNestedTemplateQuery(mapservO
         if(status != MS_SUCCESS) return status;
 #endif
 
-        status = msLayerGetShape(lp, &(mapserv->resultshape), &(lp->resultcache->results[0]));
-        if(status != MS_SUCCESS) return status;
+        status = msLayerGetShape(lp, &(mapserv->resultshape),
+                                 &(lp->resultcache->results[0]));
+        if (status != MS_SUCCESS)
+          return status;
 
-        if(lp->numjoins > 0) {
-          for(k=0; k<lp->numjoins; k++) {
+        if (lp->numjoins > 0) {
+          for (k = 0; k < lp->numjoins; k++) {
             status = msJoinConnect(lp, &(lp->joins[k]));
-            if(status != MS_SUCCESS) return status;
+            if (status != MS_SUCCESS)
+              return status;
 
             msJoinPrepare(&(lp->joins[k]), &(mapserv->resultshape));
             msJoinNext(&(lp->joins[k])); /* fetch the first row */
           }
         }
 
-        if(papszBuffer == NULL) {
-          if(msReturnURL(mapserv, template, QUERY) != MS_SUCCESS) return MS_FAILURE;
+        if (papszBuffer == NULL) {
+          if (msReturnURL(mapserv, template, QUERY) != MS_SUCCESS)
+            return MS_FAILURE;
         }
 
         msFreeShape(&(mapserv->resultshape));
@@ -4355,45 +4859,55 @@ int msReturnNestedTemplateQuery(mapservO
   ** Now we know we're making a template sandwich
   */
   mapserv->NR = mapserv->NL = 0;
-  for(i=0; i<mapserv->map->numlayers; i++) { /* compute some totals */
+  for (i = 0; i < mapserv->map->numlayers; i++) { /* compute some totals */
     lp = (GET_LAYER(mapserv->map, i));
 
-    if(!lp->resultcache) continue;
+    if (!lp->resultcache)
+      continue;
 
-    if(lp->resultcache->numresults > 0) {
+    if (lp->resultcache->numresults > 0) {
       mapserv->NL++;
       mapserv->NR += lp->resultcache->numresults;
     }
   }
 
   /*
-  ** Is this step really necessary for buffered output? Legend and browse templates don't deal with mime-types
-  ** so why should this. Note that new-style templates don't buffer the mime-type either.
+  ** Is this step really necessary for buffered output? Legend and browse
+  *templates don't deal with mime-types
+  ** so why should this. Note that new-style templates don't buffer the
+  *mime-type either.
   */
-  if(papszBuffer && mapserv->sendheaders) {
-    snprintf(buffer, sizeof(buffer), "Content-Type: %s%c%c", pszMimeType, 10, 10);
-    if(nBufferSize <= (int)(nCurrentSize + strlen(buffer) + 1)) {
+  if (papszBuffer && mapserv->sendheaders) {
+    snprintf(buffer, sizeof(buffer), "Content-Type: %s%c%c", pszMimeType, 10,
+             10);
+    if (nBufferSize <= (int)(nCurrentSize + strlen(buffer) + 1)) {
       nExpandBuffer++;
-      (*papszBuffer) = (char *)msSmallRealloc((*papszBuffer), MS_TEMPLATE_BUFFER*nExpandBuffer);
-      nBufferSize = MS_TEMPLATE_BUFFER*nExpandBuffer;
+      (*papszBuffer) = (char *)msSmallRealloc(
+          (*papszBuffer), MS_TEMPLATE_BUFFER * nExpandBuffer);
+      nBufferSize = MS_TEMPLATE_BUFFER * nExpandBuffer;
     }
     strcat((*papszBuffer), buffer);
     nCurrentSize += strlen(buffer);
-  } else if(mapserv->sendheaders) {
-    msIO_setHeader("Content-Type","%s",pszMimeType);
+  } else if (mapserv->sendheaders) {
+    msIO_setHeader("Content-Type", "%s", pszMimeType);
     msIO_sendHeaders();
   }
 
-  if(mapserv->map->web.header) {
-    if(msReturnPage(mapserv, mapserv->map->web.header, BROWSE, papszBuffer) != MS_SUCCESS) return MS_FAILURE;
+  if (mapserv->map->web.header) {
+    if (msReturnPage(mapserv, mapserv->map->web.header, BROWSE, papszBuffer) !=
+        MS_SUCCESS)
+      return MS_FAILURE;
   }
 
   mapserv->RN = 1; /* overall result number */
-  for(i=0; i<mapserv->map->numlayers; i++) {
-    mapserv->resultlayer = lp = (GET_LAYER(mapserv->map, mapserv->map->layerorder[i]));
-
-    if(!lp->resultcache) continue;
-    if(lp->resultcache->numresults <= 0) continue;
+  for (i = 0; i < mapserv->map->numlayers; i++) {
+    mapserv->resultlayer = lp =
+        (GET_LAYER(mapserv->map, mapserv->map->layerorder[i]));
+
+    if (!lp->resultcache)
+      continue;
+    if (lp->resultcache->numresults <= 0)
+      continue;
 
     mapserv->NLR = lp->resultcache->numresults;
 
@@ -4405,38 +4919,45 @@ int msReturnNestedTemplateQuery(mapservO
     if(status != MS_SUCCESS) return status;
 #endif
 
-    if(lp->numjoins > 0) { /* open any necessary JOINs here */
-      for(k=0; k<lp->numjoins; k++) {
+    if (lp->numjoins > 0) { /* open any necessary JOINs here */
+      for (k = 0; k < lp->numjoins; k++) {
         status = msJoinConnect(lp, &(lp->joins[k]));
-        if(status != MS_SUCCESS) return status;
+        if (status != MS_SUCCESS)
+          return status;
       }
     }
 
-    if(lp->header) {
-      if(msReturnPage(mapserv, lp->header, BROWSE, papszBuffer) != MS_SUCCESS) return MS_FAILURE;
+    if (lp->header) {
+      if (msReturnPage(mapserv, lp->header, BROWSE, papszBuffer) != MS_SUCCESS)
+        return MS_FAILURE;
     }
 
     mapserv->LRN = 1; /* layer result number */
-    for(j=0; j<lp->resultcache->numresults; j++) {
-      status = msLayerGetShape(lp, &(mapserv->resultshape), &(lp->resultcache->results[j]));
-      if(status != MS_SUCCESS) return status;
+    for (j = 0; j < lp->resultcache->numresults; j++) {
+      status = msLayerGetShape(lp, &(mapserv->resultshape),
+                               &(lp->resultcache->results[j]));
+      if (status != MS_SUCCESS)
+        return status;
 
       /* prepare any necessary JOINs here (one-to-one only) */
-      if(lp->numjoins > 0) {
-        for(k=0; k<lp->numjoins; k++) {
-          if(lp->joins[k].type == MS_JOIN_ONE_TO_ONE) {
+      if (lp->numjoins > 0) {
+        for (k = 0; k < lp->numjoins; k++) {
+          if (lp->joins[k].type == MS_JOIN_ONE_TO_ONE) {
             msJoinPrepare(&(lp->joins[k]), &(mapserv->resultshape));
             msJoinNext(&(lp->joins[k])); /* fetch the first row */
           }
         }
       }
 
-      if(lp->resultcache->results[j].classindex >= 0 && lp->class[(int)(lp->resultcache->results[j].classindex)]->template)
-        template = lp->class[(int)(lp->resultcache->results[j].classindex)]->template;
+      if (lp->resultcache->results[j].classindex >= 0 &&
+              lp->class[(int)(lp->resultcache->results[j].classindex)]
+          -> template)
+        template =
+            lp->class[(int)(lp->resultcache->results[j].classindex)]->template;
       else
         template = lp->template;
 
-      if(msReturnPage(mapserv, template, QUERY, papszBuffer) != MS_SUCCESS) {
+      if (msReturnPage(mapserv, template, QUERY, papszBuffer) != MS_SUCCESS) {
         msFreeShape(&(mapserv->resultshape));
         return MS_FAILURE;
       }
@@ -4447,22 +4968,22 @@ int msReturnNestedTemplateQuery(mapservO
       mapserv->LRN++;
     }
 
-    if(lp->footer) {
-      if(msReturnPage(mapserv, lp->footer, BROWSE, papszBuffer) != MS_SUCCESS) return MS_FAILURE;
+    if (lp->footer) {
+      if (msReturnPage(mapserv, lp->footer, BROWSE, papszBuffer) != MS_SUCCESS)
+        return MS_FAILURE;
     }
 
     /* msLayerClose(lp); */
     mapserv->resultlayer = NULL;
   }
 
-  if(mapserv->map->web.footer)
+  if (mapserv->map->web.footer)
     return msReturnPage(mapserv, mapserv->map->web.footer, BROWSE, papszBuffer);
 
   return MS_SUCCESS;
 }
 
-int msReturnOpenLayersPage(mapservObj *mapserv)
-{
+int msReturnOpenLayersPage(mapservObj *mapserv) {
   int i;
   char *buffer = NULL, *layer = NULL;
   const char *tmpUrl = NULL;
@@ -4474,27 +4995,29 @@ int msReturnOpenLayersPage(mapservObj *m
    * to be sure the case match during the template processing. We also
    * need to search the SRS/CRS parameter to get the projection info. OGC
    * services version >= 1.3.0 uses CRS rather than SRS */
-  for( i=0; i<mapserv->request->NumParams; i++) {
-    if( (strcasecmp(mapserv->request->ParamNames[i], "SRS") == 0) ||
-        (strcasecmp(mapserv->request->ParamNames[i], "CRS") == 0) ) {
+  for (i = 0; i < mapserv->request->NumParams; i++) {
+    if ((strcasecmp(mapserv->request->ParamNames[i], "SRS") == 0) ||
+        (strcasecmp(mapserv->request->ParamNames[i], "CRS") == 0)) {
       projection = mapserv->request->ParamValues[i];
-    } else if(strcasecmp(mapserv->request->ParamNames[i], "LAYERS") == 0) {
+    } else if (strcasecmp(mapserv->request->ParamNames[i], "LAYERS") == 0) {
       free(mapserv->request->ParamNames[i]);
       mapserv->request->ParamNames[i] = msStrdup("LAYERS");
-    } else if(strcasecmp(mapserv->request->ParamNames[i], "VERSION") == 0) {
+    } else if (strcasecmp(mapserv->request->ParamNames[i], "VERSION") == 0) {
       free(mapserv->request->ParamNames[i]);
       mapserv->request->ParamNames[i] = msStrdup("VERSION");
     }
   }
-  if(mapserv->map->outputformat->mimetype && *mapserv->map->outputformat->mimetype) {
+  if (mapserv->map->outputformat->mimetype &&
+      *mapserv->map->outputformat->mimetype) {
     format = mapserv->map->outputformat->mimetype;
   }
 
   /* check if the environment variable or config MS_OPENLAYERS_JS_URL is set */
   tmpUrl = msGetConfigOption(mapserv->map, "MS_OPENLAYERS_JS_URL");
-  if(tmpUrl == NULL) tmpUrl = CPLGetConfigOption("MS_OPENLAYERS_JS_URL", NULL);
-  
-  if(tmpUrl)
+  if (tmpUrl == NULL)
+    tmpUrl = CPLGetConfigOption("MS_OPENLAYERS_JS_URL", NULL);
+
+  if (tmpUrl)
     openlayersUrl = (char *)tmpUrl;
 
   if (mapserv->Mode == BROWSE) {
@@ -4520,121 +5043,122 @@ int msReturnOpenLayersPage(mapservObj *m
   return MS_SUCCESS;
 }
 
-mapservObj *msAllocMapServObj()
-{
+mapservObj *msAllocMapServObj() {
   mapservObj *mapserv = msSmallMalloc(sizeof(mapservObj));
 
-  mapserv->savemap=MS_FALSE;
-  mapserv->savequery=MS_FALSE; /* should the query and/or map be saved  */
+  mapserv->savemap = MS_FALSE;
+  mapserv->savequery = MS_FALSE; /* should the query and/or map be saved  */
 
   mapserv->sendheaders = MS_TRUE;
 
   mapserv->request = msAllocCgiObj();
 
-  mapserv->map=NULL;
+  mapserv->map = NULL;
 
-  mapserv->NumLayers=0; /* number of layers specfied by a user */
-  mapserv->MaxLayers=0; /* allocated size of Layers[] array */
+  mapserv->NumLayers = 0; /* number of layers specfied by a user */
+  mapserv->MaxLayers = 0; /* allocated size of Layers[] array */
   mapserv->Layers = NULL;
 
   mapserv->icon = NULL;
 
-  mapserv->RawExt.minx=-1;
-  mapserv->RawExt.miny=-1;
-  mapserv->RawExt.maxx=-1;
-  mapserv->RawExt.maxy=-1;
+  mapserv->RawExt.minx = -1;
+  mapserv->RawExt.miny = -1;
+  mapserv->RawExt.maxx = -1;
+  mapserv->RawExt.maxy = -1;
 
-  mapserv->fZoom=1;
-  mapserv->Zoom=1; /* default for browsing */
+  mapserv->fZoom = 1;
+  mapserv->Zoom = 1; /* default for browsing */
 
-  mapserv->resultlayer=NULL;
+  mapserv->resultlayer = NULL;
 
-  mapserv->UseShapes=MS_FALSE;
+  mapserv->UseShapes = MS_FALSE;
 
-  mapserv->mappnt.x=-1;
-  mapserv->mappnt.y=-1;
+  mapserv->mappnt.x = -1;
+  mapserv->mappnt.y = -1;
 
-  mapserv->ZoomDirection=0; /* whether zooming in or out, default is pan or 0 */
+  mapserv->ZoomDirection =
+      0; /* whether zooming in or out, default is pan or 0 */
 
-  mapserv->Mode=BROWSE; /* can be BROWSE, QUERY, etc. */
+  mapserv->Mode = BROWSE; /* can be BROWSE, QUERY, etc. */
 
   sprintf(mapserv->Id, "%ld%d", (long)time(NULL), (int)getpid());
 
-  mapserv->CoordSource=NONE;
-  mapserv->ScaleDenom=0;
+  mapserv->CoordSource = NONE;
+  mapserv->ScaleDenom = 0;
 
-  mapserv->ImgRows=-1;
-  mapserv->ImgCols=-1;
+  mapserv->ImgRows = -1;
+  mapserv->ImgCols = -1;
 
-  mapserv->ImgExt.minx=-1;
-  mapserv->ImgExt.miny=-1;
-  mapserv->ImgExt.maxx=-1;
-  mapserv->ImgExt.maxy=-1;
-
-  mapserv->ImgBox.minx=-1;
-  mapserv->ImgBox.miny=-1;
-  mapserv->ImgBox.maxx=-1;
-  mapserv->ImgBox.maxy=-1;
-
-  mapserv->RefPnt.x=-1;
-  mapserv->RefPnt.y=-1;
-  mapserv->ImgPnt.x=-1;
-  mapserv->ImgPnt.y=-1;
+  mapserv->ImgExt.minx = -1;
+  mapserv->ImgExt.miny = -1;
+  mapserv->ImgExt.maxx = -1;
+  mapserv->ImgExt.maxy = -1;
+
+  mapserv->ImgBox.minx = -1;
+  mapserv->ImgBox.miny = -1;
+  mapserv->ImgBox.maxx = -1;
+  mapserv->ImgBox.maxy = -1;
+
+  mapserv->RefPnt.x = -1;
+  mapserv->RefPnt.y = -1;
+  mapserv->ImgPnt.x = -1;
+  mapserv->ImgPnt.y = -1;
 
-  mapserv->Buffer=0;
+  mapserv->Buffer = 0;
 
   /*
   ** variables for multiple query results processing
   */
-  mapserv->RN=0; /* overall result number */
-  mapserv->LRN=0; /* result number within a layer */
-  mapserv->NL=0; /* total number of layers with results */
-  mapserv->NR=0; /* total number or results */
-  mapserv->NLR=0; /* number of results in a layer */
-
-  mapserv->SearchMap=MS_FALSE; /* apply pan/zoom BEFORE doing the query (e.g. query the output image rather than the input image) */
-
-  mapserv->QueryFile=NULL;
-  mapserv->QueryLayer=NULL;
-  mapserv->SelectLayer=NULL;
-  mapserv->QueryLayerIndex=-1;
-  mapserv->SelectLayerIndex=-1;
-  mapserv->QueryItem=NULL;
-  mapserv->QueryString=NULL;
-  mapserv->ShapeIndex=-1;
-  mapserv->TileIndex=-1;
-  mapserv->TileMode=TILE_GMAP;
-  mapserv->TileCoords=NULL;
-  mapserv->TileWidth=-1;
-  mapserv->TileHeight=-1;
-  mapserv->QueryCoordSource=NONE;
-  mapserv->ZoomSize=0; /* zoom absolute magnitude (i.e. > 0) */
+  mapserv->RN = 0;  /* overall result number */
+  mapserv->LRN = 0; /* result number within a layer */
+  mapserv->NL = 0;  /* total number of layers with results */
+  mapserv->NR = 0;  /* total number or results */
+  mapserv->NLR = 0; /* number of results in a layer */
+
+  mapserv->SearchMap =
+      MS_FALSE; /* apply pan/zoom BEFORE doing the query (e.g. query the output
+                   image rather than the input image) */
+
+  mapserv->QueryFile = NULL;
+  mapserv->QueryLayer = NULL;
+  mapserv->SelectLayer = NULL;
+  mapserv->QueryLayerIndex = -1;
+  mapserv->SelectLayerIndex = -1;
+  mapserv->QueryItem = NULL;
+  mapserv->QueryString = NULL;
+  mapserv->ShapeIndex = -1;
+  mapserv->TileIndex = -1;
+  mapserv->TileMode = TILE_GMAP;
+  mapserv->TileCoords = NULL;
+  mapserv->TileWidth = -1;
+  mapserv->TileHeight = -1;
+  mapserv->QueryCoordSource = NONE;
+  mapserv->ZoomSize = 0; /* zoom absolute magnitude (i.e. > 0) */
 
   mapserv->hittest = NULL;
 
   return mapserv;
 }
 
-void msFreeMapServObj(mapservObj* mapserv)
-{
+void msFreeMapServObj(mapservObj *mapserv) {
   int i;
 
-  if(mapserv) {
-    if( mapserv->map ) {
-      if(mapserv->hittest) {
-        freeMapHitTests(mapserv->map,mapserv->hittest);
+  if (mapserv) {
+    if (mapserv->map) {
+      if (mapserv->hittest) {
+        freeMapHitTests(mapserv->map, mapserv->hittest);
         free(mapserv->hittest);
       }
       msFreeMap(mapserv->map);
       mapserv->map = NULL;
     }
 
-    if( mapserv->request ) {
+    if (mapserv->request) {
       msFreeCgiObj(mapserv->request);
       mapserv->request = NULL;
     }
 
-    for(i=0; i<mapserv->NumLayers; i++)
+    for (i = 0; i < mapserv->NumLayers; i++)
       msFree(mapserv->Layers[i]);
     msFree(mapserv->Layers);
 
@@ -4660,29 +5184,31 @@ void msFreeMapServObj(mapservObj* mapser
 **
 ** Returns MS_SUCCESS/MS_FAILURE
 */
-int msGrowMapservLayers( mapservObj* mapserv )
-{
+int msGrowMapservLayers(mapservObj *mapserv) {
   /* Do we need to increase the size of Layers[] by MS_LAYER_ALLOCSIZE? */
-  if(mapserv->NumLayers == mapserv->MaxLayers) {
+  if (mapserv->NumLayers == mapserv->MaxLayers) {
     int i;
 
-    if(mapserv->MaxLayers == 0) {
+    if (mapserv->MaxLayers == 0) {
       /* initial allocation of array */
       mapserv->MaxLayers += MS_LAYER_ALLOCSIZE;
       mapserv->NumLayers = 0;
-      mapserv->Layers = (char**)msSmallMalloc(mapserv->MaxLayers*sizeof(char*));
+      mapserv->Layers =
+          (char **)msSmallMalloc(mapserv->MaxLayers * sizeof(char *));
     } else {
       /* realloc existing array */
       mapserv->MaxLayers += MS_LAYER_ALLOCSIZE;
-      mapserv->Layers = (char**)msSmallRealloc(mapserv->Layers, mapserv->MaxLayers*sizeof(char*));
+      mapserv->Layers = (char **)msSmallRealloc(
+          mapserv->Layers, mapserv->MaxLayers * sizeof(char *));
     }
 
-    if(mapserv->Layers == NULL) {
-      msSetError(MS_MEMERR, "Failed to allocate memory for Layers array.", "msGrowMappservLayers()");
+    if (mapserv->Layers == NULL) {
+      msSetError(MS_MEMERR, "Failed to allocate memory for Layers array.",
+                 "msGrowMappservLayers()");
       return MS_FAILURE;
     }
 
-    for(i=mapserv->NumLayers; i<mapserv->MaxLayers; i++) {
+    for (i = mapserv->NumLayers; i < mapserv->MaxLayers; i++) {
       mapserv->Layers[i] = NULL;
     }
   }
@@ -4695,78 +5221,91 @@ int msGrowMapservLayers( mapservObj* map
 **
 ** Parameters:
 **   - mapserv: mapserv object (used to extract the map object).
-**   - bQueryMap: if set to TRUE a query map will be created instead of a regular map.
-**   - bReturnOnError: if set to TRUE, the function will return on the first error, else it will try to generate all the images.
+**   - bQueryMap: if set to TRUE a query map will be created instead of a
+*regular map.
+**   - bReturnOnError: if set to TRUE, the function will return on the first
+*error, else it will try to generate all the images.
 */
-int msGenerateImages(mapservObj *mapserv, int bQueryMap, int bReturnOnError)
-{
+int msGenerateImages(mapservObj *mapserv, int bQueryMap, int bReturnOnError) {
   char buffer[1024];
 
-  if(mapserv) {
+  if (mapserv) {
 
     /* render the map OR query map */
-    if((!bQueryMap && mapserv->map->status == MS_ON) || (bQueryMap && mapserv->map->querymap.status == MS_ON)) {
+    if ((!bQueryMap && mapserv->map->status == MS_ON) ||
+        (bQueryMap && mapserv->map->querymap.status == MS_ON)) {
       imageObj *image = NULL;
 
       image = msDrawMap(mapserv->map, bQueryMap);
-      if(image) {
-        snprintf(buffer, sizeof(buffer), "%s%s%s.%s", mapserv->map->web.imagepath, mapserv->map->name, mapserv->Id, MS_IMAGE_EXTENSION(mapserv->map->outputformat));
+      if (image) {
+        snprintf(buffer, sizeof(buffer), "%s%s%s.%s",
+                 mapserv->map->web.imagepath, mapserv->map->name, mapserv->Id,
+                 MS_IMAGE_EXTENSION(mapserv->map->outputformat));
 
-        if(msSaveImage(mapserv->map, image, buffer) != MS_SUCCESS && bReturnOnError) {
+        if (msSaveImage(mapserv->map, image, buffer) != MS_SUCCESS &&
+            bReturnOnError) {
           msFreeImage(image);
           return MS_FAILURE;
         }
         msFreeImage(image);
-      } else if(bReturnOnError)
+      } else if (bReturnOnError)
         return MS_FAILURE;
     }
 
     /* render the legend */
-    if(mapserv->map->legend.status == MS_ON) {
+    if (mapserv->map->legend.status == MS_ON) {
       imageObj *image = NULL;
       image = msDrawLegend(mapserv->map, MS_FALSE, NULL);
-      if(image) {
-        snprintf(buffer, sizeof(buffer), "%s%sleg%s.%s", mapserv->map->web.imagepath, mapserv->map->name, mapserv->Id, MS_IMAGE_EXTENSION(mapserv->map->outputformat));
+      if (image) {
+        snprintf(buffer, sizeof(buffer), "%s%sleg%s.%s",
+                 mapserv->map->web.imagepath, mapserv->map->name, mapserv->Id,
+                 MS_IMAGE_EXTENSION(mapserv->map->outputformat));
 
-        if(msSaveImage(mapserv->map, image, buffer) != MS_SUCCESS && bReturnOnError) {
+        if (msSaveImage(mapserv->map, image, buffer) != MS_SUCCESS &&
+            bReturnOnError) {
           msFreeImage(image);
           return MS_FAILURE;
         }
         msFreeImage(image);
-      } else if(bReturnOnError)
+      } else if (bReturnOnError)
         return MS_FAILURE;
     }
 
     /* render the scalebar */
-    if(mapserv->map->scalebar.status == MS_ON) {
+    if (mapserv->map->scalebar.status == MS_ON) {
       imageObj *image = NULL;
       image = msDrawScalebar(mapserv->map);
-      if(image) {
-        snprintf(buffer, sizeof(buffer), "%s%ssb%s.%s", mapserv->map->web.imagepath, mapserv->map->name, mapserv->Id, MS_IMAGE_EXTENSION(mapserv->map->outputformat));
-        if(msSaveImage(mapserv->map, image, buffer) != MS_SUCCESS && bReturnOnError) {
+      if (image) {
+        snprintf(buffer, sizeof(buffer), "%s%ssb%s.%s",
+                 mapserv->map->web.imagepath, mapserv->map->name, mapserv->Id,
+                 MS_IMAGE_EXTENSION(mapserv->map->outputformat));
+        if (msSaveImage(mapserv->map, image, buffer) != MS_SUCCESS &&
+            bReturnOnError) {
           msFreeImage(image);
           return MS_FAILURE;
         }
         msFreeImage(image);
-      } else if(bReturnOnError)
+      } else if (bReturnOnError)
         return MS_FAILURE;
     }
 
     /* render the reference map */
-    if(mapserv->map->reference.status == MS_ON) {
+    if (mapserv->map->reference.status == MS_ON) {
       imageObj *image;
       image = msDrawReferenceMap(mapserv->map);
-      if(image) {
-        snprintf(buffer, sizeof(buffer), "%s%sref%s.%s", mapserv->map->web.imagepath, mapserv->map->name, mapserv->Id, MS_IMAGE_EXTENSION(mapserv->map->outputformat));
-        if(msSaveImage(mapserv->map, image, buffer) != MS_SUCCESS && bReturnOnError) {
+      if (image) {
+        snprintf(buffer, sizeof(buffer), "%s%sref%s.%s",
+                 mapserv->map->web.imagepath, mapserv->map->name, mapserv->Id,
+                 MS_IMAGE_EXTENSION(mapserv->map->outputformat));
+        if (msSaveImage(mapserv->map, image, buffer) != MS_SUCCESS &&
+            bReturnOnError) {
           msFreeImage(image);
           return MS_FAILURE;
         }
         msFreeImage(image);
-      } else if(bReturnOnError)
+      } else if (bReturnOnError)
         return MS_FAILURE;
     }
-
   }
 
   return MS_SUCCESS;
@@ -4778,22 +5317,24 @@ int msGenerateImages(mapservObj *mapserv
 ** template file from the web object. Returns NULL if there is
 ** an error.
 */
-char *msProcessTemplate(mapObj *map, int bGenerateImages, char **names, char **values, int numentries)
-{
+char *msProcessTemplate(mapObj *map, int bGenerateImages, char **names,
+                        char **values, int numentries) {
   char *pszBuffer = NULL;
 
-  if(map) {
+  if (map) {
 
     /* Initialize object and set appropriate defaults. */
-    mapservObj  *mapserv  = NULL;
+    mapservObj *mapserv = NULL;
     mapserv = msAllocMapServObj();
 
     mapserv->map = map;
     mapserv->Mode = BROWSE;
 
-    if(names && values && numentries > 0) {
-      msFreeCharArray(mapserv->request->ParamNames, mapserv->request->NumParams);
-      msFreeCharArray(mapserv->request->ParamValues, mapserv->request->NumParams);
+    if (names && values && numentries > 0) {
+      msFreeCharArray(mapserv->request->ParamNames,
+                      mapserv->request->NumParams);
+      msFreeCharArray(mapserv->request->ParamValues,
+                      mapserv->request->NumParams);
       mapserv->request->ParamNames = names;
       mapserv->request->ParamValues = values;
       mapserv->request->NumParams = numentries;
@@ -4805,7 +5346,7 @@ char *msProcessTemplate(mapObj *map, int
     ** loadform.
     */
 
-    if(bGenerateImages)
+    if (bGenerateImages)
       msGenerateImages(mapserv, MS_FALSE, MS_FALSE);
 
     /*
@@ -4813,12 +5354,14 @@ char *msProcessTemplate(mapObj *map, int
     **
     ** TODO : use web minscaledenom/maxscaledenom depending on the scale.
     */
-    if(msReturnPage(mapserv, mapserv->map->web.template, BROWSE, &pszBuffer) != MS_SUCCESS) {
+    if (msReturnPage(mapserv, mapserv->map->web.template, BROWSE, &pszBuffer) !=
+        MS_SUCCESS) {
       msFree(pszBuffer);
       pszBuffer = NULL;
     }
 
-    /* Don't free the map and names and values arrays since they were passed by reference. */
+    /* Don't free the map and names and values arrays since they were passed by
+     * reference. */
     mapserv->map = NULL;
     mapserv->request->ParamNames = mapserv->request->ParamValues = NULL;
     mapserv->request->NumParams = 0;
@@ -4831,22 +5374,24 @@ char *msProcessTemplate(mapObj *map, int
 /*
 ** Utility method to process the legend template.
 */
-char *msProcessLegendTemplate(mapObj *map, char **names, char **values, int numentries)
-{
+char *msProcessLegendTemplate(mapObj *map, char **names, char **values,
+                              int numentries) {
   char *pszOutBuf = NULL;
 
-  if(map && map->legend.template) {
+  if (map && map->legend.template) {
 
     /* Initialize object and set appropriate defaults. */
-    mapservObj  *mapserv  = NULL;
+    mapservObj *mapserv = NULL;
     mapserv = msAllocMapServObj();
 
     mapserv->map = map;
     mapserv->Mode = BROWSE;
 
-    if(names && values && numentries > 0) {
-      msFreeCharArray(mapserv->request->ParamNames, mapserv->request->NumParams);
-      msFreeCharArray(mapserv->request->ParamValues, mapserv->request->NumParams);
+    if (names && values && numentries > 0) {
+      msFreeCharArray(mapserv->request->ParamNames,
+                      mapserv->request->NumParams);
+      msFreeCharArray(mapserv->request->ParamValues,
+                      mapserv->request->NumParams);
       mapserv->request->ParamNames = names;
       mapserv->request->ParamValues = values;
       mapserv->request->NumParams = numentries;
@@ -4854,7 +5399,8 @@ char *msProcessLegendTemplate(mapObj *ma
 
     pszOutBuf = generateLegendTemplate(mapserv);
 
-    /* Don't free the map and names and values arrays since they were passed by reference. */
+    /* Don't free the map and names and values arrays since they were passed by
+     * reference. */
     mapserv->map = NULL;
     mapserv->request->ParamNames = mapserv->request->ParamValues = NULL;
     mapserv->request->NumParams = 0;
@@ -4868,11 +5414,11 @@ char *msProcessLegendTemplate(mapObj *ma
 ** Utility function that process a template file(s) used in the
 ** query and return the processed template(s) in a buffer.
 */
-char *msProcessQueryTemplate(mapObj *map, int bGenerateImages, char **names, char **values, int numentries)
-{
+char *msProcessQueryTemplate(mapObj *map, int bGenerateImages, char **names,
+                             char **values, int numentries) {
   char *pszBuffer = NULL;
 
-  if(map) {
+  if (map) {
 
     /* Initialize object and set appropriate defaults. */
     mapservObj *mapserv = NULL;
@@ -4881,19 +5427,22 @@ char *msProcessQueryTemplate(mapObj *map
     mapserv->map = map;
     mapserv->Mode = QUERY;
 
-    if(names && values && numentries > 0) {
-      msFreeCharArray(mapserv->request->ParamNames, mapserv->request->NumParams);
-      msFreeCharArray(mapserv->request->ParamValues, mapserv->request->NumParams);
+    if (names && values && numentries > 0) {
+      msFreeCharArray(mapserv->request->ParamNames,
+                      mapserv->request->NumParams);
+      msFreeCharArray(mapserv->request->ParamValues,
+                      mapserv->request->NumParams);
       mapserv->request->ParamNames = names;
       mapserv->request->ParamValues = values;
       mapserv->request->NumParams = numentries;
     }
 
-    if(bGenerateImages)
+    if (bGenerateImages)
       msGenerateImages(mapserv, MS_TRUE, MS_FALSE);
 
     mapserv->sendheaders = MS_FALSE;
-    IGNORE_RET_VAL(msReturnTemplateQuery(mapserv, mapserv->map->web.queryformat, &pszBuffer));
+    IGNORE_RET_VAL(msReturnTemplateQuery(mapserv, mapserv->map->web.queryformat,
+                                         &pszBuffer));
 
     mapserv->map = NULL;
     mapserv->request->ParamNames = mapserv->request->ParamValues = NULL;
diff -pruN 8.0.1-5/maptemplate.h 8.0.2-1/maptemplate.h
--- 8.0.1-5/maptemplate.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/maptemplate.h	2024-06-11 20:41:34.000000000 +0000
@@ -39,19 +39,54 @@ extern "C" {
 
 #define IDPATTERN "^[0-9A-Za-z]{1,63}$"
 #define IDSIZE 64
-#define TEMPLATE_TYPE(s)  (((strncmp("http://", s, 7) == 0) || (strncmp("https://", s, 8) == 0) || (strncmp("ftp://", s, 6)) == 0)  ? MS_URL : MS_FILE)
+#define TEMPLATE_TYPE(s)                                                       \
+  (((strncmp("http://", s, 7) == 0) || (strncmp("https://", s, 8) == 0) ||     \
+    (strncmp("ftp://", s, 6)) == 0)                                            \
+       ? MS_URL                                                                \
+       : MS_FILE)
 #define MAXZOOM 25
 #define MINZOOM -25
 #define DEFAULT_DATE_FORMAT "%d/%b/%Y:%H:%M:%S %z"
 
-enum coordSources {NONE, FROMIMGPNT, FROMIMGBOX, FROMIMGSHAPE, FROMREFPNT, FROMUSERPNT, FROMUSERBOX, FROMUSERSHAPE, FROMBUF, FROMSCALE, FROMTILE};
-
-enum modes {BROWSE, ZOOMIN, ZOOMOUT, MAP, LEGEND, LEGENDICON, REFERENCE, SCALEBAR, COORDINATE,
-            QUERY, NQUERY, ITEMQUERY, ITEMNQUERY,
-            FEATUREQUERY, FEATURENQUERY, ITEMFEATUREQUERY, ITEMFEATURENQUERY,
-            INDEXQUERY, TILE, OWS, WFS, MAPLEGEND, MAPLEGENDICON
-           };
-
+enum coordSources {
+  NONE,
+  FROMIMGPNT,
+  FROMIMGBOX,
+  FROMIMGSHAPE,
+  FROMREFPNT,
+  FROMUSERPNT,
+  FROMUSERBOX,
+  FROMUSERSHAPE,
+  FROMBUF,
+  FROMSCALE,
+  FROMTILE
+};
+
+enum modes {
+  BROWSE,
+  ZOOMIN,
+  ZOOMOUT,
+  MAP,
+  LEGEND,
+  LEGENDICON,
+  REFERENCE,
+  SCALEBAR,
+  COORDINATE,
+  QUERY,
+  NQUERY,
+  ITEMQUERY,
+  ITEMNQUERY,
+  FEATUREQUERY,
+  FEATURENQUERY,
+  ITEMFEATUREQUERY,
+  ITEMFEATURENQUERY,
+  INDEXQUERY,
+  TILE,
+  OWS,
+  WFS,
+  MAPLEGEND,
+  MAPLEGENDICON
+};
 
 /* struct mapservObj
  * Global structure used by templates and mapserver CGI interface.
@@ -61,14 +96,15 @@ enum modes {BROWSE, ZOOMIN, ZOOMOUT, MAP
  * related functions in a new file (maptemplate.c) and change
  * their signatures to pass all global variables, we created this
  * structure with all global variables needed by template.
-*/
+ */
 typedef struct {
   /* should the query and/or map be saved */
   int savemap, savequery;
 
   cgiRequestObj *request;
 
-  int sendheaders; /* should mime-type header be output, default will be MS_TRUE */
+  int sendheaders; /* should mime-type header be output, default will be MS_TRUE
+                    */
 
   mapObj *map;
 
@@ -80,7 +116,8 @@ typedef struct {
 
   layerObj *resultlayer;
 
-  int UseShapes; /* are results of a query to be used in calculating an extent of some sort */
+  int UseShapes; /* are results of a query to be used in calculating an extent
+                    of some sort */
 
   shapeObj resultshape;
 
@@ -93,7 +130,7 @@ typedef struct {
 
   int Mode; /* can be BROWSE, QUERY, etc. */
 
-  int TileMode; /* can be GMAP, VE */
+  int TileMode;     /* can be GMAP, VE */
   char *TileCoords; /* for GMAP: 0 0 1; for VE: 013021023 */
   int TileWidth;
   int TileHeight;
@@ -112,7 +149,8 @@ typedef struct {
 
   double Buffer;
 
-  int SearchMap; /* apply pan/zoom BEFORE doing the query (e.g. query the output image rather than the input image) */
+  int SearchMap; /* apply pan/zoom BEFORE doing the query (e.g. query the output
+                    image rather than the input image) */
 
   char *QueryFile;
   char *QueryLayer;
@@ -133,67 +171,63 @@ typedef struct {
   /*
   ** variables for multiple query results processing
   */
-  int RN; /* overall result number */
+  int RN;  /* overall result number */
   int LRN; /* result number within a layer */
-  int NL; /* total number of layers with results */
-  int NR; /* total number or results */
+  int NL;  /* total number of layers with results */
+  int NR;  /* total number or results */
   int NLR; /* number of results in a layer */
 
   map_hittest *hittest;
 
 } mapservObj;
 
-
-
 /*! \fn msAllocMapServObj
  * Allocate memory for all variables in strusture
  * and initiate default values
-*/
-MS_DLL_EXPORT mapservObj* msAllocMapServObj(void);
+ */
+MS_DLL_EXPORT mapservObj *msAllocMapServObj(void);
 
 /*! \fn msFreeMapServObj
  * free all variables in structure
-*/
-MS_DLL_EXPORT void msFreeMapServObj(mapservObj* msObj);
+ */
+MS_DLL_EXPORT void msFreeMapServObj(mapservObj *msObj);
 
 /* For Mapserv.c */
-MS_DLL_EXPORT int isOn(mapservObj* msObj, char *name, char *group);
+MS_DLL_EXPORT int isOn(mapservObj *msObj, char *name, char *group);
 MS_DLL_EXPORT int checkWebScale(mapservObj *msObj);
 MS_DLL_EXPORT int setExtent(mapservObj *msObj);
 
-MS_DLL_EXPORT int msReturnPage(mapservObj* msObj, char* , int, char **);
-MS_DLL_EXPORT int msReturnURL(mapservObj* msObj, char*, int);
-MS_DLL_EXPORT int msReturnNestedTemplateQuery(mapservObj* msObj, char* pszMimeType, char **papszBuffer);
-MS_DLL_EXPORT int msReturnTemplateQuery(mapservObj *msObj, char* pszMimeType,  char **papszBuffer);
+MS_DLL_EXPORT int msReturnPage(mapservObj *msObj, char *, int, char **);
+MS_DLL_EXPORT int msReturnURL(mapservObj *msObj, char *, int);
+MS_DLL_EXPORT int msReturnNestedTemplateQuery(mapservObj *msObj,
+                                              char *pszMimeType,
+                                              char **papszBuffer);
+MS_DLL_EXPORT int msReturnTemplateQuery(mapservObj *msObj, char *pszMimeType,
+                                        char **papszBuffer);
 MS_DLL_EXPORT int msReturnOpenLayersPage(mapservObj *mapserv);
 
-MS_DLL_EXPORT int msRedirect(char* url);
+MS_DLL_EXPORT int msRedirect(char *url);
 
 MS_DLL_EXPORT char *generateLegendTemplate(mapservObj *msObj);
 
-MS_DLL_EXPORT int msGenerateImages(mapservObj *msObj, int bQueryMap, int bReturnOnError);
-
+MS_DLL_EXPORT int msGenerateImages(mapservObj *msObj, int bQueryMap,
+                                   int bReturnOnError);
 
 MS_DLL_EXPORT char *msProcessTemplate(mapObj *map, int bGenerateImages,
                                       char **names, char **values,
                                       int numentries);
 
-MS_DLL_EXPORT char *msProcessLegendTemplate(mapObj *map,
-    char **names, char **values,
-    int numentries);
-
-MS_DLL_EXPORT char *msProcessQueryTemplate(mapObj *map,
-    int bGenerateImages,
-    char **names, char **values,
-    int numentries);
+MS_DLL_EXPORT char *msProcessLegendTemplate(mapObj *map, char **names,
+                                            char **values, int numentries);
 
-MS_DLL_EXPORT int msGrowMapservLayers( mapservObj* msObj );
+MS_DLL_EXPORT char *msProcessQueryTemplate(mapObj *map, int bGenerateImages,
+                                           char **names, char **values,
+                                           int numentries);
+
+MS_DLL_EXPORT int msGrowMapservLayers(mapservObj *msObj);
 
 #ifdef __cplusplus
 } /* extern C */
 #endif
 
 #endif
-
-
-
diff -pruN 8.0.1-5/mapthread.c 8.0.2-1/mapthread.c
--- 8.0.1-5/mapthread.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapthread.c	2024-06-11 20:41:34.000000000 +0000
@@ -132,20 +132,18 @@ files instead.
 
 ******************************************************************************/
 
-
 #include <assert.h>
 #include "mapserver.h"
 #include "mapthread.h"
 
-
-
 #if defined(USE_THREAD)
 static int thread_debug = 0;
 
 static char *const lock_names[] = {
-  NULL, "PARSER", "GDAL", "ERROROBJ", "PROJ", "TTF", "POOL", "SDE",
-  "ORACLE", "OWS", "LAYER_VTABLE", "IOCONTEXT", "TMPFILE", "DEBUGOBJ", "OGR", "TIME", "FRIBIDI", "WXS", "GEOS", NULL
-};
+    NULL,           "PARSER",    "GDAL",    "ERROROBJ", "PROJ",
+    "TTF",          "POOL",      "SDE",     "ORACLE",   "OWS",
+    "LAYER_VTABLE", "IOCONTEXT", "TMPFILE", "DEBUGOBJ", "OGR",
+    "TIME",         "FRIBIDI",   "WXS",     "GEOS",     NULL};
 #endif
 
 /************************************************************************/
@@ -170,61 +168,61 @@ void msThreadInit()
 {
   static pthread_mutex_t core_lock = PTHREAD_MUTEX_INITIALIZER;
 
-  if( thread_debug )
-    fprintf( stderr, "msThreadInit() (posix)\n" );
+  if (thread_debug)
+    fprintf(stderr, "msThreadInit() (posix)\n");
 
-  pthread_mutex_lock( &core_lock );
+  pthread_mutex_lock(&core_lock);
 
-  for( ; mutexes_initialized < TLOCK_STATIC_MAX; mutexes_initialized++ )
-    pthread_mutex_init( mutex_locks + mutexes_initialized, NULL );
+  for (; mutexes_initialized < TLOCK_STATIC_MAX; mutexes_initialized++)
+    pthread_mutex_init(mutex_locks + mutexes_initialized, NULL);
 
-  pthread_mutex_unlock( &core_lock );
+  pthread_mutex_unlock(&core_lock);
 }
 
 /************************************************************************/
 /*                           msGetThreadId()                            */
 /************************************************************************/
 
-void* msGetThreadId()
+void *msGetThreadId()
 
 {
-  return (void*) pthread_self();
+  return (void *)pthread_self();
 }
 
 /************************************************************************/
 /*                           msAcquireLock()                            */
 /************************************************************************/
 
-void msAcquireLock( int nLockId )
+void msAcquireLock(int nLockId)
 
 {
-  if( mutexes_initialized == 0 )
+  if (mutexes_initialized == 0)
     msThreadInit();
 
-  assert( nLockId >= 0 && nLockId < mutexes_initialized );
+  assert(nLockId >= 0 && nLockId < mutexes_initialized);
 
-  if( thread_debug )
-    fprintf( stderr, "msAcquireLock(%d/%s) (posix)\n",
-             nLockId, lock_names[nLockId] );
+  if (thread_debug)
+    fprintf(stderr, "msAcquireLock(%d/%s) (posix)\n", nLockId,
+            lock_names[nLockId]);
 
-  pthread_mutex_lock( mutex_locks + nLockId );
+  pthread_mutex_lock(mutex_locks + nLockId);
 }
 
 /************************************************************************/
 /*                           msReleaseLock()                            */
 /************************************************************************/
 
-void msReleaseLock( int nLockId )
+void msReleaseLock(int nLockId)
 
 {
-  assert( mutexes_initialized > 0 );
-  assert( nLockId >= 0 && nLockId < mutexes_initialized );
+  assert(mutexes_initialized > 0);
+  assert(nLockId >= 0 && nLockId < mutexes_initialized);
 
-  if( thread_debug )
-    fprintf( stderr, "msReleaseLock(%d/%s) (posix)\n",
-             nLockId, lock_names[nLockId] );
+  if (thread_debug)
+    fprintf(stderr, "msReleaseLock(%d/%s) (posix)\n", nLockId,
+            lock_names[nLockId]);
 
-  pthread_mutex_unlock( mutex_locks + nLockId );
+  pthread_mutex_unlock(mutex_locks + nLockId);
 }
 
 #endif /* defined(USE_THREAD) && !defined(_WIN32) */
@@ -252,67 +250,67 @@ void msThreadInit()
   /* static pthread_mutex_t core_lock = PTHREAD_MUTEX_INITIALIZER; */
   static HANDLE core_lock = NULL;
 
-  if( mutexes_initialized >= TLOCK_STATIC_MAX )
+  if (mutexes_initialized >= TLOCK_STATIC_MAX)
     return;
 
-  if( thread_debug )
-    fprintf( stderr, "msThreadInit() (win32)\n" );
+  if (thread_debug)
+    fprintf(stderr, "msThreadInit() (win32)\n");
 
-  if( core_lock == NULL )
-    core_lock = CreateMutex( NULL, TRUE, NULL );
+  if (core_lock == NULL)
+    core_lock = CreateMutex(NULL, TRUE, NULL);
   else
-    WaitForSingleObject( core_lock, INFINITE );
+    WaitForSingleObject(core_lock, INFINITE);
 
-  for( ; mutexes_initialized < TLOCK_STATIC_MAX; mutexes_initialized++ )
-    mutex_locks[mutexes_initialized] = CreateMutex( NULL, FALSE, NULL );
+  for (; mutexes_initialized < TLOCK_STATIC_MAX; mutexes_initialized++)
+    mutex_locks[mutexes_initialized] = CreateMutex(NULL, FALSE, NULL);
 
-  ReleaseMutex( core_lock );
+  ReleaseMutex(core_lock);
 }
 
 /************************************************************************/
 /*                           msGetThreadId()                            */
 /************************************************************************/
 
-void* msGetThreadId()
+void *msGetThreadId()
 
 {
-  return (void*) (size_t) GetCurrentThreadId();
+  return (void *)(size_t)GetCurrentThreadId();
 }
 
 /************************************************************************/
 /*                           msAcquireLock()                            */
 /************************************************************************/
 
-void msAcquireLock( int nLockId )
+void msAcquireLock(int nLockId)
 
 {
-  if( mutexes_initialized == 0 )
+  if (mutexes_initialized == 0)
     msThreadInit();
 
-  assert( nLockId >= 0 && nLockId < mutexes_initialized );
+  assert(nLockId >= 0 && nLockId < mutexes_initialized);
 
-  if( thread_debug )
-    fprintf( stderr, "msAcquireLock(%d/%s) (win32)\n",
-             nLockId, lock_names[nLockId] );
+  if (thread_debug)
+    fprintf(stderr, "msAcquireLock(%d/%s) (win32)\n", nLockId,
+            lock_names[nLockId]);
 
-  WaitForSingleObject( mutex_locks[nLockId], INFINITE );
+  WaitForSingleObject(mutex_locks[nLockId], INFINITE);
 }
 
 /************************************************************************/
 /*                           msReleaseLock()                            */
 /************************************************************************/
 
-void msReleaseLock( int nLockId )
+void msReleaseLock(int nLockId)
 
 {
-  assert( mutexes_initialized > 0 );
-  assert( nLockId >= 0 && nLockId < mutexes_initialized );
+  assert(mutexes_initialized > 0);
+  assert(nLockId >= 0 && nLockId < mutexes_initialized);
 
-  if( thread_debug )
-    fprintf( stderr, "msReleaseLock(%d/%s) (win32)\n",
-             nLockId, lock_names[nLockId] );
+  if (thread_debug)
+    fprintf(stderr, "msReleaseLock(%d/%s) (win32)\n", nLockId,
+            lock_names[nLockId]);
 
-  ReleaseMutex( mutex_locks[nLockId] );
+  ReleaseMutex(mutex_locks[nLockId]);
 }
 
 #endif /* defined(USE_THREAD) && defined(_WIN32) */
diff -pruN 8.0.1-5/mapthread.h 8.0.2-1/mapthread.h
--- 8.0.1-5/mapthread.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapthread.h	2024-06-11 20:41:34.000000000 +0000
@@ -35,10 +35,10 @@ extern "C" {
 #endif
 
 #ifdef USE_THREAD
-  void msThreadInit(void);
-  void* msGetThreadId(void);
-  void msAcquireLock(int);
-  void msReleaseLock(int);
+void msThreadInit(void);
+void *msGetThreadId(void);
+void msAcquireLock(int);
+void msReleaseLock(int);
 #else
 #define msThreadInit()
 #define msGetThreadId() (0)
@@ -46,43 +46,35 @@ extern "C" {
 #define msReleaseLock(x)
 #endif
 
-  /*
-  ** lock ids - note there is a corresponding lock_names[] array in
-  ** mapthread.c that needs to be extended when new ids are added.
-  */
-
-#define TLOCK_PARSER  1
-#define TLOCK_GDAL  2
-#define TLOCK_ERROROBJ  3
-#define TLOCK_PROJ      4
-#define TLOCK_TTF       5
-#define TLOCK_POOL      6
-#define TLOCK_SDE       7
-#define TLOCK_ORACLE    8
-#define TLOCK_OWS       9
+/*
+** lock ids - note there is a corresponding lock_names[] array in
+** mapthread.c that needs to be extended when new ids are added.
+*/
+
+#define TLOCK_PARSER 1
+#define TLOCK_GDAL 2
+#define TLOCK_ERROROBJ 3
+#define TLOCK_PROJ 4
+#define TLOCK_TTF 5
+#define TLOCK_POOL 6
+#define TLOCK_SDE 7
+#define TLOCK_ORACLE 8
+#define TLOCK_OWS 9
 #define TLOCK_LAYER_VTABLE 10
 #define TLOCK_IOCONTEXT 11
-#define TLOCK_TMPFILE   12
-#define TLOCK_DEBUGOBJ  13
-#define TLOCK_OGR       14
-#define TLOCK_TIME      15
-#define TLOCK_FRIBIDI   16
-#define TLOCK_WxS       17
-#define TLOCK_GEOS       18
+#define TLOCK_TMPFILE 12
+#define TLOCK_DEBUGOBJ 13
+#define TLOCK_OGR 14
+#define TLOCK_TIME 15
+#define TLOCK_FRIBIDI 16
+#define TLOCK_WxS 17
+#define TLOCK_GEOS 18
 
 #define TLOCK_STATIC_MAX 20
-#define TLOCK_MAX       100
+#define TLOCK_MAX 100
 
 #ifdef __cplusplus
 }
 #endif
 
 #endif /* MAPTHREAD_H */
-
-
-
-
-
-
-
-
diff -pruN 8.0.1-5/maptile.c 8.0.2-1/maptile.c
--- 8.0.1-5/maptile.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/maptile.c	2024-06-11 20:41:34.000000000 +0000
@@ -31,13 +31,12 @@
 #include "mapproject.h"
 
 #ifdef USE_TILE_API
-static void msTileResetMetatileLevel(mapObj *map)
-{
+static void msTileResetMetatileLevel(mapObj *map) {
   hashTableObj *meta = &(map->web.metadata);
   const char *zero = "0";
 
   /*  Is the tile_metatile_levetl set... */
-  if(msLookupHashTable(meta, "tile_metatile_level") != NULL) {
+  if (msLookupHashTable(meta, "tile_metatile_level") != NULL) {
     msRemoveHashTable(meta, "tile_metatile_level");
   }
   msInsertHashTable(meta, "tile_metatile_level", zero);
@@ -47,17 +46,19 @@ static void msTileResetMetatileLevel(map
 /************************************************************************
  *                            msTileGetGMapCoords                       *
  ************************************************************************/
-static int msTileGetGMapCoords(const char *coordstring, int *x, int *y, int *zoom)
-{
+static int msTileGetGMapCoords(const char *coordstring, int *x, int *y,
+                               int *zoom) {
 
   int num_coords = 0;
   char **coords = NULL;
 
-  if( coordstring ) {
+  if (coordstring) {
     coords = msStringSplit(coordstring, ' ', &(num_coords));
-    if( num_coords != 3 ) {
+    if (num_coords != 3) {
       msFreeCharArray(coords, num_coords);
-      msSetError(MS_WEBERR, "Invalid number of tile coordinates (should be three).", "msTileSetup()");
+      msSetError(MS_WEBERR,
+                 "Invalid number of tile coordinates (should be three).",
+                 "msTileSetup()");
       return MS_FAILURE;
     }
   } else {
@@ -65,87 +66,87 @@ static int msTileGetGMapCoords(const cha
     return MS_FAILURE;
   }
 
-  if( x )
+  if (x)
     *x = strtol(coords[0], NULL, 10);
-  if( y )
+  if (y)
     *y = strtol(coords[1], NULL, 10);
-  if( zoom )
+  if (zoom)
     *zoom = strtol(coords[2], NULL, 10);
-  
+
   msFreeCharArray(coords, 3);
   return MS_SUCCESS;
 }
 
-
 /************************************************************************
  *                            msTileSetParams                           *
  ************************************************************************/
-static void msTileGetParams(const mapservObj *msObj, tileParams *params)
-{
+static void msTileGetParams(const mapservObj *msObj, tileParams *params) {
 
   const char *value = NULL;
-  const mapObj* map = msObj->map;
+  const mapObj *map = msObj->map;
   const hashTableObj *meta = &(map->web.metadata);
 
-  if( msObj->TileWidth < 0 )
-      params->tile_width = SPHEREMERC_IMAGE_SIZE;
+  if (msObj->TileWidth < 0)
+    params->tile_width = SPHEREMERC_IMAGE_SIZE;
   else
-      params->tile_width = msObj->TileWidth;
-  if( msObj->TileHeight < 0 )
-      params->tile_height = SPHEREMERC_IMAGE_SIZE;
+    params->tile_width = msObj->TileWidth;
+  if (msObj->TileHeight < 0)
+    params->tile_height = SPHEREMERC_IMAGE_SIZE;
   else
-      params->tile_height = msObj->TileHeight;
+    params->tile_height = msObj->TileHeight;
 
   /* Check for tile buffer, set to buffer==0 as default */
-  if((value = msLookupHashTable(meta, "tile_map_edge_buffer")) != NULL) {
+  if ((value = msLookupHashTable(meta, "tile_map_edge_buffer")) != NULL) {
     params->map_edge_buffer = atoi(value);
-    if(map->debug)
-      msDebug("msTileSetParams(): tile_map_edge_buffer = %d\n", params->map_edge_buffer);
+    if (map->debug)
+      msDebug("msTileSetParams(): tile_map_edge_buffer = %d\n",
+              params->map_edge_buffer);
   } else
     params->map_edge_buffer = 0;
 
   /* Check for metatile size, set to tile==metatile as default */
-  if((value = msLookupHashTable(meta, "tile_metatile_level")) != NULL) {
+  if ((value = msLookupHashTable(meta, "tile_metatile_level")) != NULL) {
     params->metatile_level = atoi(value);
     /* Quietly force metatile_level to be sane */
-    if( params->metatile_level < 0 )
+    if (params->metatile_level < 0)
       params->metatile_level = 0;
-    if( params->metatile_level > 2 )
+    if (params->metatile_level > 2)
       params->metatile_level = 2;
-    if(map->debug)
-      msDebug("msTileSetParams(): tile_metatile_level = %d\n", params->metatile_level);
+    if (map->debug)
+      msDebug("msTileSetParams(): tile_metatile_level = %d\n",
+              params->metatile_level);
   } else
     params->metatile_level = 0;
-
 }
 
 /************************************************************************
  *                            msTileExtractSubTile                      *
  *                                                                      *
  ************************************************************************/
-static imageObj* msTileExtractSubTile(const mapservObj *msObj, const imageObj *img)
-{
+static imageObj *msTileExtractSubTile(const mapservObj *msObj,
+                                      const imageObj *img) {
 
   int width, mini, minj;
   int zoom = 2;
-  imageObj* imgOut = NULL;
+  imageObj *imgOut = NULL;
   tileParams params;
   rendererVTableObj *renderer;
   rasterBufferObj imgBuffer;
 
-  if( !MS_RENDERER_PLUGIN(msObj->map->outputformat)
-      || msObj->map->outputformat->renderer != img->format->renderer ||
-      ! MS_MAP_RENDERER(msObj->map)->supports_pixel_buffer ) {
-    msSetError(MS_MISCERR,"unsupported or mixed renderers","msTileExtractSubTile()");
+  if (!MS_RENDERER_PLUGIN(msObj->map->outputformat) ||
+      msObj->map->outputformat->renderer != img->format->renderer ||
+      !MS_MAP_RENDERER(msObj->map)->supports_pixel_buffer) {
+    msSetError(MS_MISCERR, "unsupported or mixed renderers",
+               "msTileExtractSubTile()");
     return NULL;
   }
   renderer = MS_MAP_RENDERER(msObj->map);
 
-  if (renderer->getRasterBufferHandle((imageObj*)img,&imgBuffer) != MS_SUCCESS) {
+  if (renderer->getRasterBufferHandle((imageObj *)img, &imgBuffer) !=
+      MS_SUCCESS) {
     return NULL;
   }
 
-
   /*
   ** Load the metatiling information from the map file.
   */
@@ -154,23 +155,23 @@ static imageObj* msTileExtractSubTile(co
   /*
   ** Initialize values for the metatile clip area.
   */
-  width = img->width - 2*params.map_edge_buffer;
+  width = img->width - 2 * params.map_edge_buffer;
   mini = params.map_edge_buffer;
   minj = params.map_edge_buffer;
-  
-  if( msObj->TileMode == TILE_GMAP ) {
+
+  if (msObj->TileMode == TILE_GMAP) {
     int x, y, zoom;
 
-    if( msObj->TileCoords ) {
-      if( msTileGetGMapCoords(msObj->TileCoords, &x, &y, &zoom) == MS_FAILURE )
+    if (msObj->TileCoords) {
+      if (msTileGetGMapCoords(msObj->TileCoords, &x, &y, &zoom) == MS_FAILURE)
         return NULL;
     } else {
       msSetError(MS_WEBERR, "Tile parameter not set.", "msTileSetup()");
       return NULL;
     }
 
-    if(msObj->map->debug)
-      msDebug("msTileExtractSubTile(): gmaps coords (x: %d, y: %d)\n",x,y);
+    if (msObj->map->debug)
+      msDebug("msTileExtractSubTile(): gmaps coords (x: %d, y: %d)\n", x, y);
 
     /*
     ** The bottom N bits of the coordinates give us the subtile
@@ -179,49 +180,55 @@ static imageObj* msTileExtractSubTile(co
     x = (0xffff ^ (0xffff << params.metatile_level)) & x;
     y = (0xffff ^ (0xffff << params.metatile_level)) & y;
 
-    if(msObj->map->debug)
-      msDebug("msTileExtractSubTile(): gmaps image coords (x: %d, y: %d)\n",x,y);
+    if (msObj->map->debug)
+      msDebug("msTileExtractSubTile(): gmaps image coords (x: %d, y: %d)\n", x,
+              y);
 
     mini = mini + x * params.tile_width;
     minj = minj + y * params.tile_height;
 
-  } else if( msObj->TileMode == TILE_VE ) {
+  } else if (msObj->TileMode == TILE_VE) {
     int tsize;
 
-    const int lenTileCoords = (int)strlen( msObj->TileCoords );
-    if( lenTileCoords - params.metatile_level < 0 ) {
-      return(NULL);
+    const int lenTileCoords = (int)strlen(msObj->TileCoords);
+    if (lenTileCoords - params.metatile_level < 0) {
+      return (NULL);
     }
 
     /*
     ** Process the last elements of the VE coordinate string to place the
     ** requested tile in the context of the metatile
     */
-    for( int i = lenTileCoords - params.metatile_level;
-         i < lenTileCoords;
-         i++ ) {
+    for (int i = lenTileCoords - params.metatile_level; i < lenTileCoords;
+         i++) {
       char j = msObj->TileCoords[i];
       tsize = width / zoom;
-      if( j == '1' || j == '3' ) mini += tsize;
-      if( j == '2' || j == '3' ) minj += tsize;
+      if (j == '1' || j == '3')
+        mini += tsize;
+      if (j == '2' || j == '3')
+        minj += tsize;
       zoom *= 2;
     }
   } else {
-    return(NULL); /* Huh? Should have a mode. */
+    return (NULL); /* Huh? Should have a mode. */
   }
 
-  imgOut = msImageCreate(params.tile_width, params.tile_height, msObj->map->outputformat, NULL, NULL, msObj->map->resolution, msObj->map->defresolution, NULL);
+  imgOut = msImageCreate(
+      params.tile_width, params.tile_height, msObj->map->outputformat, NULL,
+      NULL, msObj->map->resolution, msObj->map->defresolution, NULL);
 
-  if( imgOut == NULL ) {
+  if (imgOut == NULL) {
     return NULL;
   }
 
-  if(msObj->map->debug)
-    msDebug("msTileExtractSubTile(): extracting (%d x %d) tile, top corner (%d, %d)\n",params.tile_width, params.tile_height,mini,minj);
-
-
-
-  if(MS_UNLIKELY(MS_FAILURE == renderer->mergeRasterBuffer(imgOut,&imgBuffer,1.0,mini, minj,0, 0,params.tile_width, params.tile_height))) {
+  if (msObj->map->debug)
+    msDebug("msTileExtractSubTile(): extracting (%d x %d) tile, top corner "
+            "(%d, %d)\n",
+            params.tile_width, params.tile_height, mini, minj);
+
+  if (MS_UNLIKELY(MS_FAILURE == renderer->mergeRasterBuffer(
+                                    imgOut, &imgBuffer, 1.0, mini, minj, 0, 0,
+                                    params.tile_width, params.tile_height))) {
     msFreeImage(imgOut);
     return NULL;
   }
@@ -229,15 +236,13 @@ static imageObj* msTileExtractSubTile(co
   return imgOut;
 }
 
-
 /************************************************************************
  *                            msTileSetup                               *
  *                                                                      *
  *  Called from mapserv.c, this is where the fun begins                 *
  *  Set up projections and test the parameters for legality.            *
  ************************************************************************/
-int msTileSetup(mapservObj* msObj)
-{
+int msTileSetup(mapservObj *msObj) {
 #ifdef USE_TILE_API
 
   char *outProjStr = NULL;
@@ -251,19 +256,19 @@ int msTileSetup(mapservObj* msObj)
   /*
   ** Ensure all the LAYERs have a projection.
   */
-  if( msMapSetLayerProjections(msObj->map) != 0 ) {
-    return(MS_FAILURE);
+  if (msMapSetLayerProjections(msObj->map) != 0) {
+    return (MS_FAILURE);
   }
 
   /*
   ** Set the projection string for this mode.
   */
-  if( msObj->TileMode == TILE_GMAP || msObj->TileMode == TILE_VE ) {
+  if (msObj->TileMode == TILE_GMAP || msObj->TileMode == TILE_VE) {
     outProjStr = SPHEREMERC_PROJ4;
   } else {
     return MS_FAILURE; /* Huh? No mode? */
   }
-  if( msLoadProjectionString(&(msObj->map->projection), outProjStr) != 0 ) {
+  if (msLoadProjectionString(&(msObj->map->projection), outProjStr) != 0) {
     msSetError(MS_CGIERR, "Unable to load projection string.", "msTileSetup()");
     return MS_FAILURE;
   }
@@ -271,20 +276,20 @@ int msTileSetup(mapservObj* msObj)
   /*
   ** Set up the output extents for this tilemode and tile coordinates
   */
-  if( msObj->TileMode == TILE_GMAP ) {
+  if (msObj->TileMode == TILE_GMAP) {
 
     int x, y, zoom;
     double zoomfactor;
 
-    if( msObj->TileCoords ) {
-      if( msTileGetGMapCoords(msObj->TileCoords, &x, &y, &zoom) == MS_FAILURE )
+    if (msObj->TileCoords) {
+      if (msTileGetGMapCoords(msObj->TileCoords, &x, &y, &zoom) == MS_FAILURE)
         return MS_FAILURE;
     } else {
       msSetError(MS_WEBERR, "Tile parameter not set.", "msTileSetup()");
       return MS_FAILURE;
     }
 
-    if( params.metatile_level >= zoom ) {
+    if (params.metatile_level >= zoom) {
       msTileResetMetatileLevel(msObj->map);
     }
 
@@ -293,83 +298,88 @@ int msTileSetup(mapservObj* msObj)
     /*
     ** Check the input request for sanity.
     */
-    if( x >= zoomfactor || y >= zoomfactor ) {
-      msSetError(MS_CGIERR, "GMap tile coordinates are too large for supplied zoom.", "msTileSetup()");
-      return(MS_FAILURE);
+    if (x >= zoomfactor || y >= zoomfactor) {
+      msSetError(MS_CGIERR,
+                 "GMap tile coordinates are too large for supplied zoom.",
+                 "msTileSetup()");
+      return (MS_FAILURE);
     }
-    if( x < 0 || y < 0 ) {
-      msSetError(MS_CGIERR, "GMap tile coordinates should not be less than zero.", "msTileSetup()");
-      return(MS_FAILURE);
+    if (x < 0 || y < 0) {
+      msSetError(MS_CGIERR,
+                 "GMap tile coordinates should not be less than zero.",
+                 "msTileSetup()");
+      return (MS_FAILURE);
     }
 
-  } else if ( msObj->TileMode == TILE_VE ) {
+  } else if (msObj->TileMode == TILE_VE) {
 
-    if( strspn( msObj->TileCoords, "0123" ) < strlen( msObj->TileCoords ) ) {
-      msSetError(MS_CGIERR, "VE tile name should only include characters 0, 1, 2 and 3.", "msTileSetup()");
-      return(MS_FAILURE);
+    if (strspn(msObj->TileCoords, "0123") < strlen(msObj->TileCoords)) {
+      msSetError(MS_CGIERR,
+                 "VE tile name should only include characters 0, 1, 2 and 3.",
+                 "msTileSetup()");
+      return (MS_FAILURE);
     }
 
-    if( params.metatile_level >= (int)strlen(msObj->TileCoords) ) {
+    if (params.metatile_level >= (int)strlen(msObj->TileCoords)) {
       msTileResetMetatileLevel(msObj->map);
     }
 
   } else {
-    return(MS_FAILURE); /* Huh? Should have a mode. */
+    return (MS_FAILURE); /* Huh? Should have a mode. */
   }
 
   return MS_SUCCESS;
 #else
   msSetError(MS_CGIERR, "Tile API is not available.", "msTileSetup()");
-  return(MS_FAILURE);
+  return (MS_FAILURE);
 #endif
 }
 
-
-
 /************************************************************************
  *                            msTileSetExtent                           *
  *                                                                      *
  *  Based on the input parameters, set the output extent for this       *
  *  tile.                                                               *
  ************************************************************************/
-int msTileSetExtent(mapservObj* msObj)
-{
+int msTileSetExtent(mapservObj *msObj) {
 #ifdef USE_TILE_API
 
   mapObj *map = msObj->map;
-  double  dx, dy, buffer;
+  double dx, dy, buffer;
   tileParams params;
 
   /* Read the tile-mode map file parameters */
   msTileGetParams(msObj, &params);
 
-  if( msObj->TileMode == TILE_GMAP ) {
+  if (msObj->TileMode == TILE_GMAP) {
     int x, y, zoom;
     double zoomfactor, tilesize, xmin, xmax, ymin, ymax;
 
-    if( msObj->TileCoords ) {
-      if( msTileGetGMapCoords(msObj->TileCoords, &x, &y, &zoom) == MS_FAILURE )
+    if (msObj->TileCoords) {
+      if (msTileGetGMapCoords(msObj->TileCoords, &x, &y, &zoom) == MS_FAILURE)
         return MS_FAILURE;
     } else {
       msSetError(MS_WEBERR, "Tile parameter not set.", "msTileSetup()");
       return MS_FAILURE;
     }
 
-    if(map->debug)
-      msDebug("msTileSetExtent(): gmaps coords (x: %d, y: %d, z: %d)\n",x,y,zoom);
+    if (map->debug)
+      msDebug("msTileSetExtent(): gmaps coords (x: %d, y: %d, z: %d)\n", x, y,
+              zoom);
 
     /*
     ** If we are metatiling, adjust the zoom level appropriately,
     ** then scale back the x/y coordinates to match the new level.
     */
-    if( params.metatile_level > 0 ) {
+    if (params.metatile_level > 0) {
       zoom = zoom - params.metatile_level;
       x = x >> params.metatile_level;
       y = y >> params.metatile_level;
     }
 
-    if(map->debug)
-      msDebug("msTileSetExtent(): gmaps metacoords (x: %d, y: %d, z: %d)\n",x,y,zoom);
+    if (map->debug)
+      msDebug("msTileSetExtent(): gmaps metacoords (x: %d, y: %d, z: %d)\n", x,
+              y, zoom);
 
     zoomfactor = pow(2.0, (double)zoom);
 
@@ -388,7 +398,7 @@ int msTileSetExtent(mapservObj* msObj)
     map->extent.miny = ymin;
     map->extent.maxy = ymax;
 
-  } else if( msObj->TileMode == TILE_VE ) {
+  } else if (msObj->TileMode == TILE_VE) {
 
     double minx = SPHEREMERC_GROUND_SIZE / -2.0;
     double miny = SPHEREMERC_GROUND_SIZE / -2.0;
@@ -401,13 +411,18 @@ int msTileSetExtent(mapservObj* msObj)
     ** Walk down the VE URL string, adjusting the extent each time.
     ** For meta-tiling cases, we stop early, to draw a larger image.
     */
-    for( int i = 0; i < (int)strlen( msObj->TileCoords ) - params.metatile_level; i++ ) {
+    for (int i = 0; i < (int)strlen(msObj->TileCoords) - params.metatile_level;
+         i++) {
       char j = msObj->TileCoords[i];
       tsize = SPHEREMERC_GROUND_SIZE / zoom;
-      if( j == '1' || j == '3' ) minx += tsize;
-      if( j == '0' || j == '2' ) maxx -= tsize;
-      if( j == '2' || j == '3' ) maxy -= tsize;
-      if( j == '0' || j == '1' ) miny += tsize;
+      if (j == '1' || j == '3')
+        minx += tsize;
+      if (j == '0' || j == '2')
+        maxx -= tsize;
+      if (j == '2' || j == '3')
+        maxy -= tsize;
+      if (j == '0' || j == '1')
+        miny += tsize;
       zoom *= 2.0;
     }
 
@@ -417,7 +432,7 @@ int msTileSetExtent(mapservObj* msObj)
     map->extent.maxy = maxy;
 
   } else {
-    return(MS_FAILURE); /* Huh? Should have a mode. */
+    return (MS_FAILURE); /* Huh? Should have a mode. */
   }
 
   /*
@@ -426,14 +441,16 @@ int msTileSetExtent(mapservObj* msObj)
   map->width = params.tile_width << params.metatile_level;
   map->height = params.tile_height << params.metatile_level;
 
-  if(map->debug)
-    msDebug("msTileSetExtent(): base image size (%d x %d)\n",map->width,map->height);
+  if (map->debug)
+    msDebug("msTileSetExtent(): base image size (%d x %d)\n", map->width,
+            map->height);
 
   /*
   ** Add the gutters
   ** First calculate ground units in the buffer at current extent
   */
-  buffer = params.map_edge_buffer * (map->extent.maxx - map->extent.minx) / (double)map->width;
+  buffer = params.map_edge_buffer * (map->extent.maxx - map->extent.minx) /
+           (double)map->width;
   /*
   ** Then adjust the map extents out by that amount
   */
@@ -447,8 +464,9 @@ int msTileSetExtent(mapservObj* msObj)
   map->width += 2 * params.map_edge_buffer;
   map->height += 2 * params.map_edge_buffer;
 
-  if(map->debug)
-    msDebug("msTileSetExtent(): buffered image size (%d x %d)\n",map->width,map->height);
+  if (map->debug)
+    msDebug("msTileSetExtent(): buffered image size (%d x %d)\n", map->width,
+            map->height);
 
   /*
   ** Adjust the extents inwards by 1/2 pixel so they are from
@@ -456,27 +474,29 @@ int msTileSetExtent(mapservObj* msObj)
   ** This is the way mapserver does it.
   */
   dx = (map->extent.maxx - map->extent.minx) / map->width;
-  map->extent.minx += dx*0.5;
-  map->extent.maxx -= dx*0.5;
+  map->extent.minx += dx * 0.5;
+  map->extent.maxx -= dx * 0.5;
   dy = (map->extent.maxy - map->extent.miny) / map->height;
-  map->extent.miny += dy*0.5;
-  map->extent.maxy -= dy*0.5;
+  map->extent.miny += dy * 0.5;
+  map->extent.maxy -= dy * 0.5;
 
   /*
   ** Ensure the labelcache buffer is greater than the tile buffer.
   */
-  if( params.map_edge_buffer > 0 ) {
+  if (params.map_edge_buffer > 0) {
     const char *value;
     hashTableObj *meta = &(map->web.metadata);
     char tilebufferstr[64];
 
     /* Write the tile buffer to a string */
-    snprintf(tilebufferstr, sizeof(tilebufferstr), "-%d", params.map_edge_buffer);
+    snprintf(tilebufferstr, sizeof(tilebufferstr), "-%d",
+             params.map_edge_buffer);
 
     /* Hm, the labelcache buffer is set... */
-    if((value = msLookupHashTable(meta, "labelcache_map_edge_buffer")) != NULL) {
+    if ((value = msLookupHashTable(meta, "labelcache_map_edge_buffer")) !=
+        NULL) {
       /* If it's too small, replace with a bigger one */
-      if( params.map_edge_buffer > abs(atoi(value)) ) {
+      if (params.map_edge_buffer > abs(atoi(value))) {
         msRemoveHashTable(meta, "labelcache_map_edge_buffer");
         msInsertHashTable(meta, "labelcache_map_edge_buffer", tilebufferstr);
       }
@@ -487,19 +507,20 @@ int msTileSetExtent(mapservObj* msObj)
     }
   }
 
-  if(map->debug) {
-    msDebug( "msTileSetExtent (%f, %f) (%f, %f)\n", map->extent.minx, map->extent.miny, map->extent.maxx, map->extent.maxy);
+  if (map->debug) {
+    msDebug("msTileSetExtent (%f, %f) (%f, %f)\n", map->extent.minx,
+            map->extent.miny, map->extent.maxx, map->extent.maxy);
   }
 
+  map->units = MS_METERS; // now the units are meters
+
   return MS_SUCCESS;
 #else
   msSetError(MS_CGIERR, "Tile API is not available.", "msTileSetExtent()");
-  return(MS_FAILURE);
+  return (MS_FAILURE);
 #endif
 }
 
-
-
 /************************************************************************
  *                            msDrawTile                                *
  *                                                                      *
@@ -509,21 +530,19 @@ int msTileSetExtent(mapservObj* msObj)
  *   fucnction call.                                                    *
  ************************************************************************/
 
-imageObj* msTileDraw(mapservObj *msObj)
-{
+imageObj *msTileDraw(mapservObj *msObj) {
   imageObj *img;
   tileParams params;
   msTileGetParams(msObj, &params);
   img = msDrawMap(msObj->map, MS_FALSE);
-  if( img == NULL )
+  if (img == NULL)
     return NULL;
-  if( params.metatile_level > 0 || params.map_edge_buffer > 0 ) {
+  if (params.metatile_level > 0 || params.map_edge_buffer > 0) {
     imageObj *tmp = msTileExtractSubTile(msObj, img);
     msFreeImage(img);
-    if( tmp == NULL )
+    if (tmp == NULL)
       return NULL;
     img = tmp;
   }
   return img;
 }
-
diff -pruN 8.0.1-5/maptile.h 8.0.2-1/maptile.h
--- 8.0.1-5/maptile.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/maptile.h	2024-06-11 20:41:34.000000000 +0000
@@ -32,8 +32,10 @@
 
 #define USE_TILE_API 1
 
-#define SPHEREMERC_PROJ4 "+proj=merc +a=6378137 +b=6378137 +lat_ts=0.0 +lon_0=0.0 +x_0=0.0 +y_0=0 +units=m +k=1.0 +nadgrids=@null"
-#define SPHEREMERC_GROUND_SIZE (20037508.34*2)
+#define SPHEREMERC_PROJ4                                                       \
+  "+proj=merc +a=6378137 +b=6378137 +lat_ts=0.0 +lon_0=0.0 +x_0=0.0 +y_0=0 "   \
+  "+units=m +k=1.0 +nadgrids=@null"
+#define SPHEREMERC_GROUND_SIZE (20037508.34 * 2)
 #define SPHEREMERC_IMAGE_SIZE 0x0100
 
 enum tileModes { TILE_GMAP, TILE_VE };
@@ -41,13 +43,12 @@ enum tileModes { TILE_GMAP, TILE_VE };
 MS_DLL_EXPORT int msTileSetup(mapservObj *msObj);
 MS_DLL_EXPORT int msTileSetExtent(mapservObj *msObj);
 MS_DLL_EXPORT int msTileSetProjections(mapObj *map);
-MS_DLL_EXPORT imageObj* msTileDraw(mapservObj *msObj);
+MS_DLL_EXPORT imageObj *msTileDraw(mapservObj *msObj);
 
 typedef struct {
-  int metatile_level; /* In zoom levels above tile request: best bet is 0, 1 or 2 */
-  int tile_width; /* In pixels */
-  int tile_height; /* In pixels */
+  int metatile_level;  /* In zoom levels above tile request: best bet is 0, 1 or
+                          2 */
+  int tile_width;      /* In pixels */
+  int tile_height;     /* In pixels */
   int map_edge_buffer; /* In pixels */
 } tileParams;
-
-
diff -pruN 8.0.1-5/maptime.c 8.0.2-1/maptime.c
--- 8.0.1-5/maptime.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/maptime.c	2024-06-11 20:41:34.000000000 +0000
@@ -27,7 +27,7 @@
  * DEALINGS IN THE SOFTWARE.
  ****************************************************************************/
 
-#define _GNU_SOURCE  /* glibc2 needs this for strptime() */
+#define _GNU_SOURCE /* glibc2 needs this for strptime() */
 #include <stdlib.h>
 #include <stdio.h>
 #include <time.h>
@@ -40,50 +40,64 @@
 typedef struct {
   char pattern[64];
   ms_regex_t *regex;
-  char  format[32];
+  char format[32];
   char userformat[32];
   MS_TIME_RESOLUTION resolution;
 } timeFormatObj;
 
 static timeFormatObj ms_timeFormats[] = {
-  {"^[0-9]{8}", NULL, "%Y%m%d","YYYYMMDD",TIME_RESOLUTION_DAY},
-  {"^[0-9]{4}-[0-9]{2}-[0-9]{2}T[0-9]{2}:[0-9]{2}:[0-9]{2}Z", NULL, "%Y-%m-%dT%H:%M:%SZ","YYYY-MM-DDTHH:MM:SSZ",TIME_RESOLUTION_SECOND},
-  {"^[0-9]{4}-[0-9]{2}-[0-9]{2}T[0-9]{2}:[0-9]{2}:[0-9]{2}", NULL, "%Y-%m-%dT%H:%M:%S", "YYYY-MM-DDTHH:MM:SS",TIME_RESOLUTION_SECOND},
-  {"^[0-9]{4}-[0-9]{2}-[0-9]{2} [0-9]{2}:[0-9]{2}:[0-9]{2}", NULL, "%Y-%m-%d %H:%M:%S", "YYYY-MM-DD HH:MM:SS", TIME_RESOLUTION_SECOND},
-  {"^[0-9]{4}-[0-9]{2}-[0-9]{2}T[0-9]{2}:[0-9]{2}", NULL, "%Y-%m-%dT%H:%M", "YYYY-MM-DDTHH:MM",TIME_RESOLUTION_MINUTE},
-  {"^[0-9]{4}-[0-9]{2}-[0-9]{2} [0-9]{2}:[0-9]{2}", NULL, "%Y-%m-%d %H:%M", "YYYY-MM-DD HH:MM",TIME_RESOLUTION_MINUTE},
-  {"^[0-9]{4}-[0-9]{2}-[0-9]{2}T[0-9]{2}", NULL, "%Y-%m-%dT%H", "YYYY-MM-DDTHH",TIME_RESOLUTION_HOUR},
-  {"^[0-9]{4}-[0-9]{2}-[0-9]{2} [0-9]{2}", NULL, "%Y-%m-%d %H", "YYYY-MM-DD HH",TIME_RESOLUTION_HOUR},
-  {"^[0-9]{4}-[0-9]{2}-[0-9]{2}", NULL, "%Y-%m-%d", "YYYY-MM-DD", TIME_RESOLUTION_DAY},
-  {"^[0-9]{4}-[0-9]{2}", NULL, "%Y-%m", "YYYY-MM",TIME_RESOLUTION_MONTH},
-  {"^[0-9]{4}", NULL, "%Y", "YYYY",TIME_RESOLUTION_YEAR},
-  {"^T[0-9]{2}:[0-9]{2}:[0-9]{2}Z", NULL, "T%H:%M:%SZ", "THH:MM:SSZ",TIME_RESOLUTION_SECOND},
-  {"^T[0-9]{2}:[0-9]{2}:[0-9]{2}", NULL, "T%H:%M:%S", "THH:MM:SS", TIME_RESOLUTION_SECOND},
-  {"^[0-9]{2}:[0-9]{2}:[0-9]{2}Z", NULL, "%H:%M:%SZ", "HH:MM:SSZ", TIME_RESOLUTION_SECOND},
-  {"^[0-9]{2}:[0-9]{2}:[0-9]{2}", NULL, "%H:%M:%S", "HH:MM:SS", TIME_RESOLUTION_SECOND}
-};
+    {"^[0-9]{8}", NULL, "%Y%m%d", "YYYYMMDD", TIME_RESOLUTION_DAY},
+    {"^[0-9]{4}-[0-9]{2}-[0-9]{2}T[0-9]{2}:[0-9]{2}:[0-9]{2}Z", NULL,
+     "%Y-%m-%dT%H:%M:%SZ", "YYYY-MM-DDTHH:MM:SSZ", TIME_RESOLUTION_SECOND},
+    {"^[0-9]{4}-[0-9]{2}-[0-9]{2}T[0-9]{2}:[0-9]{2}:[0-9]{2}", NULL,
+     "%Y-%m-%dT%H:%M:%S", "YYYY-MM-DDTHH:MM:SS", TIME_RESOLUTION_SECOND},
+    {"^[0-9]{4}-[0-9]{2}-[0-9]{2} [0-9]{2}:[0-9]{2}:[0-9]{2}", NULL,
+     "%Y-%m-%d %H:%M:%S", "YYYY-MM-DD HH:MM:SS", TIME_RESOLUTION_SECOND},
+    {"^[0-9]{4}-[0-9]{2}-[0-9]{2}T[0-9]{2}:[0-9]{2}", NULL, "%Y-%m-%dT%H:%M",
+     "YYYY-MM-DDTHH:MM", TIME_RESOLUTION_MINUTE},
+    {"^[0-9]{4}-[0-9]{2}-[0-9]{2} [0-9]{2}:[0-9]{2}", NULL, "%Y-%m-%d %H:%M",
+     "YYYY-MM-DD HH:MM", TIME_RESOLUTION_MINUTE},
+    {"^[0-9]{4}-[0-9]{2}-[0-9]{2}T[0-9]{2}", NULL, "%Y-%m-%dT%H",
+     "YYYY-MM-DDTHH", TIME_RESOLUTION_HOUR},
+    {"^[0-9]{4}-[0-9]{2}-[0-9]{2} [0-9]{2}", NULL, "%Y-%m-%d %H",
+     "YYYY-MM-DD HH", TIME_RESOLUTION_HOUR},
+    {"^[0-9]{4}-[0-9]{2}-[0-9]{2}", NULL, "%Y-%m-%d", "YYYY-MM-DD",
+     TIME_RESOLUTION_DAY},
+    {"^[0-9]{4}-[0-9]{2}", NULL, "%Y-%m", "YYYY-MM", TIME_RESOLUTION_MONTH},
+    {"^[0-9]{4}", NULL, "%Y", "YYYY", TIME_RESOLUTION_YEAR},
+    {"^T[0-9]{2}:[0-9]{2}:[0-9]{2}Z", NULL, "T%H:%M:%SZ", "THH:MM:SSZ",
+     TIME_RESOLUTION_SECOND},
+    {"^T[0-9]{2}:[0-9]{2}:[0-9]{2}", NULL, "T%H:%M:%S", "THH:MM:SS",
+     TIME_RESOLUTION_SECOND},
+    {"^[0-9]{2}:[0-9]{2}:[0-9]{2}Z", NULL, "%H:%M:%SZ", "HH:MM:SSZ",
+     TIME_RESOLUTION_SECOND},
+    {"^[0-9]{2}:[0-9]{2}:[0-9]{2}", NULL, "%H:%M:%S", "HH:MM:SS",
+     TIME_RESOLUTION_SECOND}};
 
-#define MS_NUMTIMEFORMATS (int)(sizeof(ms_timeFormats)/sizeof(ms_timeFormats[0]))
+#define MS_NUMTIMEFORMATS                                                      \
+  (int)(sizeof(ms_timeFormats) / sizeof(ms_timeFormats[0]))
 
 int *ms_limited_pattern = NULL;
 int ms_num_limited_pattern;
 
 int ms_time_inited = 0;
-int msTimeSetup() 
-{
-  if(!ms_time_inited) {
+int msTimeSetup() {
+  if (!ms_time_inited) {
     msAcquireLock(TLOCK_TIME);
-    if(!ms_time_inited) {
+    if (!ms_time_inited) {
       int i;
-      for(i=0;i<MS_NUMTIMEFORMATS;i++) {
+      for (i = 0; i < MS_NUMTIMEFORMATS; i++) {
         ms_timeFormats[i].regex = msSmallMalloc(sizeof(ms_regex_t));
-        if(0!=ms_regcomp(ms_timeFormats[i].regex, ms_timeFormats[i].pattern, MS_REG_EXTENDED|MS_REG_NOSUB)) {
-          msSetError(MS_REGEXERR, "Failed to compile expression (%s).", "msTimeSetup()", ms_timeFormats[i].pattern);
+        if (0 != ms_regcomp(ms_timeFormats[i].regex, ms_timeFormats[i].pattern,
+                            MS_REG_EXTENDED | MS_REG_NOSUB)) {
+          msSetError(MS_REGEXERR, "Failed to compile expression (%s).",
+                     "msTimeSetup()", ms_timeFormats[i].pattern);
           return MS_FAILURE;
           /* TODO: free already init'd regexes */
         }
       }
-      ms_limited_pattern = (int *)msSmallMalloc(sizeof(int)*MS_NUMTIMEFORMATS);
+      ms_limited_pattern =
+          (int *)msSmallMalloc(sizeof(int) * MS_NUMTIMEFORMATS);
       ms_num_limited_pattern = 0;
       ms_time_inited = 1;
     }
@@ -92,12 +106,11 @@ int msTimeSetup()
   return MS_SUCCESS;
 }
 
-void msTimeCleanup() 
-{
-  if(ms_time_inited) {
+void msTimeCleanup() {
+  if (ms_time_inited) {
     int i;
-    for(i=0;i<MS_NUMTIMEFORMATS;i++) {
-      if(ms_timeFormats[i].regex) {
+    for (i = 0; i < MS_NUMTIMEFORMATS; i++) {
+      if (ms_timeFormats[i].regex) {
         ms_regfree(ms_timeFormats[i].regex);
         msFree(ms_timeFormats[i].regex);
         ms_timeFormats[i].regex = NULL;
@@ -108,8 +121,7 @@ void msTimeCleanup()
   }
 }
 
-void msTimeInit(struct tm *time) 
-{
+void msTimeInit(struct tm *time) {
   time->tm_sec = 0; /* set all members to zero */
   time->tm_min = 0;
   time->tm_hour = 0;
@@ -123,55 +135,57 @@ void msTimeInit(struct tm *time)
   return;
 }
 
-static int compareIntVals(int a, int b)
-{
-  if(a<b) return -1;
-  else if(a>b) return 1;
-  else return 0;
+static int compareIntVals(int a, int b) {
+  if (a < b)
+    return -1;
+  else if (a > b)
+    return 1;
+  else
+    return 0;
 }
 
-int msDateCompare(struct tm *time1, struct tm *time2)
-{
+int msDateCompare(struct tm *time1, struct tm *time2) {
   int result;
 
-  if((result = compareIntVals(time1->tm_year, time2->tm_year)) != 0)
+  if ((result = compareIntVals(time1->tm_year, time2->tm_year)) != 0)
     return result; /* not equal based on year */
-  else if((result = compareIntVals(time1->tm_mon, time2->tm_mon)) != 0)
+  else if ((result = compareIntVals(time1->tm_mon, time2->tm_mon)) != 0)
     return result; /* not equal based on month */
-  else if((result = compareIntVals(time1->tm_mday, time2->tm_mday)) != 0)
+  else if ((result = compareIntVals(time1->tm_mday, time2->tm_mday)) != 0)
     return result; /* not equal based on day of month */
 
-  return(0); /* must be equal */
+  return (0); /* must be equal */
 }
 
-int msTimeCompare(struct tm *time1, struct tm *time2)
-{
+int msTimeCompare(struct tm *time1, struct tm *time2) {
   int result;
 
   // fprintf(stderr, "in msTimeCompare()...\n");
-  // fprintf(stderr, "time1: %d %d %d %d %d %d\n", time1->tm_year, time1->tm_mon, time1->tm_mday, time1->tm_hour, time1->tm_min, time1->tm_sec);
-  // fprintf(stderr, "time2: %d %d %d %d %d %d\n", time2->tm_year, time2->tm_mon, time2->tm_mday, time2->tm_hour, time2->tm_min, time2->tm_sec);
+  // fprintf(stderr, "time1: %d %d %d %d %d %d\n", time1->tm_year,
+  // time1->tm_mon, time1->tm_mday, time1->tm_hour, time1->tm_min,
+  // time1->tm_sec); fprintf(stderr, "time2: %d %d %d %d %d %d\n",
+  // time2->tm_year, time2->tm_mon, time2->tm_mday, time2->tm_hour,
+  // time2->tm_min, time2->tm_sec);
 
-  if((result = compareIntVals(time1->tm_year, time2->tm_year)) != 0)
+  if ((result = compareIntVals(time1->tm_year, time2->tm_year)) != 0)
     return result; /* not equal based on year */
-  else if((result = compareIntVals(time1->tm_mon, time2->tm_mon)) != 0)
+  else if ((result = compareIntVals(time1->tm_mon, time2->tm_mon)) != 0)
     return result; /* not equal based on month */
-  else if((result = compareIntVals(time1->tm_mday, time2->tm_mday)) != 0)
+  else if ((result = compareIntVals(time1->tm_mday, time2->tm_mday)) != 0)
     return result; /* not equal based on day of month */
-  else if((result = compareIntVals(time1->tm_hour, time2->tm_hour)) != 0)
+  else if ((result = compareIntVals(time1->tm_hour, time2->tm_hour)) != 0)
     return result; /* not equal based on hour */
-  else if((result = compareIntVals(time1->tm_min, time2->tm_min)) != 0)
+  else if ((result = compareIntVals(time1->tm_min, time2->tm_min)) != 0)
     return result; /* not equal based on minute */
-  else if((result = compareIntVals(time1->tm_sec, time2->tm_sec)) != 0)
+  else if ((result = compareIntVals(time1->tm_sec, time2->tm_sec)) != 0)
     return result; /* not equal based on second */
 
-  return(0); /* must be equal */
+  return (0); /* must be equal */
 }
 
 #if defined(_WIN32) && !defined(__CYGWIN__)
 #include <sys/timeb.h>
-void msGettimeofday(struct mstimeval* tp, void* tzp)
-{
+void msGettimeofday(struct mstimeval *tp, void *tzp) {
   struct _timeb theTime;
 
   _ftime(&theTime);
@@ -182,11 +196,10 @@ void msGettimeofday(struct mstimeval* tp
 
 #if defined(_WIN32) && !defined(__CYGWIN__)
 /* we need to provide our own prototype on windows. */
-char *strptime( const char *buf, const char *format, struct tm *timeptr );
+char *strptime(const char *buf, const char *format, struct tm *timeptr);
 #endif
 
-char *msStrptime(const char *s, const char *format, struct tm *tm)
-{
+char *msStrptime(const char *s, const char *format, struct tm *tm) {
   memset(tm, 0, sizeof(struct tm));
   return strptime(s, format, tm);
 }
@@ -195,43 +208,39 @@ char *msStrptime(const char *s, const ch
    return MS_TRUE if the time string matchs the timeformat.
    else return MS_FALSE.
  */
-int msTimeMatchPattern(const char *timestring, const char *timeformat)
-{
-  int i =-1;
-  if(msTimeSetup() != MS_SUCCESS) {
+int msTimeMatchPattern(const char *timestring, const char *timeformat) {
+  int i = -1;
+  if (msTimeSetup() != MS_SUCCESS) {
     return MS_FALSE;
   }
 
   /* match the pattern format first and then check if the time string  */
   /* matchs the pattern. If it is the case retrurn the MS_TRUE */
-  for (i=0; i<MS_NUMTIMEFORMATS; i++) {
+  for (i = 0; i < MS_NUMTIMEFORMATS; i++) {
     if (strcasecmp(ms_timeFormats[i].userformat, timeformat) == 0)
       break;
   }
 
   if (i >= 0 && i < MS_NUMTIMEFORMATS) {
     int match = ms_regexec(ms_timeFormats[i].regex, timestring, 0, NULL, 0);
-    if(match == 0)
+    if (match == 0)
       return MS_TRUE;
   }
   return MS_FALSE;
 }
 
-
-void msUnsetLimitedPatternToUse()
-{
+void msUnsetLimitedPatternToUse() {
   msTimeSetup();
   ms_num_limited_pattern = 0;
 }
 
-void msSetLimitedPatternsToUse(const char *patternstring)
-{
+void msSetLimitedPatternsToUse(const char *patternstring) {
   int *limitedpatternindice = NULL;
-  int numpatterns=0, ntmp=0;
+  int numpatterns = 0, ntmp = 0;
   char **patterns = NULL;
   msTimeSetup();
 
-  limitedpatternindice = (int *)msSmallMalloc(sizeof(int)*MS_NUMTIMEFORMATS);
+  limitedpatternindice = (int *)msSmallMalloc(sizeof(int) * MS_NUMTIMEFORMATS);
 
   /* free previous setting */
   msUnsetLimitedPatternToUse();
@@ -240,9 +249,9 @@ void msSetLimitedPatternsToUse(const cha
     patterns = msStringSplit(patternstring, ',', &ntmp);
     if (patterns && ntmp >= 1) {
 
-      for (int i=0; i<ntmp; i++) {
-        for (int j=0; j<MS_NUMTIMEFORMATS; j++) {
-          if (strcasecmp( ms_timeFormats[j].userformat, patterns[i]) ==0) {
+      for (int i = 0; i < ntmp; i++) {
+        for (int j = 0; j < MS_NUMTIMEFORMATS; j++) {
+          if (strcasecmp(ms_timeFormats[j].userformat, patterns[i]) == 0) {
             limitedpatternindice[numpatterns] = j;
             numpatterns++;
             break;
@@ -254,21 +263,21 @@ void msSetLimitedPatternsToUse(const cha
   }
 
   if (numpatterns > 0) {
-    for (int i=0; i<numpatterns; i++)
+    for (int i = 0; i < numpatterns; i++)
       ms_limited_pattern[i] = limitedpatternindice[i];
 
     ms_num_limited_pattern = numpatterns;
   }
-  free (limitedpatternindice);
+  free(limitedpatternindice);
 }
 
-int msParseTime(const char *string, struct tm *tm)
-{
+int msParseTime(const char *string, struct tm *tm) {
   int num_patterns = 0;
-  
-  if(MS_STRING_IS_NULL_OR_EMPTY(string)) return MS_FALSE; /* nothing to parse so bail */
 
-  if(msTimeSetup() != MS_SUCCESS) {
+  if (MS_STRING_IS_NULL_OR_EMPTY(string))
+    return MS_FALSE; /* nothing to parse so bail */
+
+  if (msTimeSetup() != MS_SUCCESS) {
     return MS_FALSE;
   }
 
@@ -278,7 +287,7 @@ int msParseTime(const char *string, stru
   else
     num_patterns = MS_NUMTIMEFORMATS;
 
-  for(int i=0; i<num_patterns; i++) {
+  for (int i = 0; i < num_patterns; i++) {
     int match;
     int indice;
     if (ms_num_limited_pattern > 0)
@@ -286,39 +295,40 @@ int msParseTime(const char *string, stru
     else
       indice = i;
 
-    match = ms_regexec(ms_timeFormats[indice].regex, string, 0,NULL, 0);
+    match = ms_regexec(ms_timeFormats[indice].regex, string, 0, NULL, 0);
     /* test the expression against the string */
-    if(match == 0) {
-      /* match    */      
+    if (match == 0) {
+      /* match    */
       msStrptime(string, ms_timeFormats[indice].format, tm);
-      return(MS_TRUE);
+      return (MS_TRUE);
     }
   }
 
-  msSetError(MS_REGEXERR, "Unrecognized date or time format (%s).", "msParseTime()", string);
-  return(MS_FALSE);
+  msSetError(MS_REGEXERR, "Unrecognized date or time format (%s).",
+             "msParseTime()", string);
+  return (MS_FALSE);
 }
 
 /**
  * Parse the time string and return the reslution
  */
-int msTimeGetResolution(const char *timestring)
-{
-  int i=0;
+int msTimeGetResolution(const char *timestring) {
+  int i = 0;
 
   if (!timestring)
     return -1;
 
-  for(i=0; i<MS_NUMTIMEFORMATS; i++) {
-    ms_regex_t *regex = (ms_regex_t *) msSmallMalloc(sizeof(ms_regex_t));
-    if(ms_regcomp(regex, ms_timeFormats[i].pattern,
-                  MS_REG_EXTENDED|MS_REG_NOSUB) != 0) {
-      msSetError(MS_REGEXERR, "Failed to compile expression (%s).", "msParseTime()", ms_timeFormats[i].pattern);
+  for (i = 0; i < MS_NUMTIMEFORMATS; i++) {
+    ms_regex_t *regex = (ms_regex_t *)msSmallMalloc(sizeof(ms_regex_t));
+    if (ms_regcomp(regex, ms_timeFormats[i].pattern,
+                   MS_REG_EXTENDED | MS_REG_NOSUB) != 0) {
+      msSetError(MS_REGEXERR, "Failed to compile expression (%s).",
+                 "msParseTime()", ms_timeFormats[i].pattern);
       msFree(regex);
       return -1;
     }
     /* test the expression against the string */
-    if(ms_regexec(regex, timestring, 0, NULL, 0) == 0) {
+    if (ms_regexec(regex, timestring, 0, NULL, 0) == 0) {
       /* match    */
       ms_regfree(regex);
       msFree(regex);
@@ -331,12 +341,10 @@ int msTimeGetResolution(const char *time
   return -1;
 }
 
-
-int _msValidateTime(const char *timestring,  const char *timeextent)
-{
+int _msValidateTime(const char *timestring, const char *timeextent) {
   int numelements, numextents, i, numranges;
-  struct tm  tmtimestart, tmtimeend, tmstart, tmend;
-  char **atimerange = NULL, **atimeelements= NULL, **atimeextents=NULL;
+  struct tm tmtimestart, tmtimeend, tmstart, tmend;
+  char **atimerange = NULL, **atimeelements = NULL, **atimeextents = NULL;
 
   if (!timestring || !timeextent)
     return MS_FALSE;
@@ -349,7 +357,7 @@ int _msValidateTime(const char *timestri
      or a range */
 
   numelements = 0;
-  atimeelements = msStringSplit (timestring, '/', &numelements);
+  atimeelements = msStringSplit(timestring, '/', &numelements);
   msTimeInit(&tmtimestart);
   msTimeInit(&tmtimeend);
 
@@ -357,26 +365,25 @@ int _msValidateTime(const char *timestri
     /*start end end times are the same*/
     if (msParseTime(timestring, &tmtimestart) != MS_TRUE) {
       msFreeCharArray(atimeelements, numelements);
-      return  MS_FALSE;
+      return MS_FALSE;
     }
     if (msParseTime(timestring, &tmtimeend) != MS_TRUE) {
       msFreeCharArray(atimeelements, numelements);
-      return  MS_FALSE;
+      return MS_FALSE;
     }
-  } else if (numelements >=2) { /*range */
+  } else if (numelements >= 2) { /*range */
     if (msParseTime(atimeelements[0], &tmtimestart) != MS_TRUE) {
       msFreeCharArray(atimeelements, numelements);
-      return  MS_FALSE;
+      return MS_FALSE;
     }
     if (msParseTime(atimeelements[1], &tmtimeend) != MS_TRUE) {
       msFreeCharArray(atimeelements, numelements);
-      return  MS_FALSE;
+      return MS_FALSE;
     }
   }
 
   msFreeCharArray(atimeelements, numelements);
 
-
   /* Now parse the time extent. Extents can be
     -  one range (2004-09-21/2004-09-25/resolution)
     -  multiple rages 2004-09-21/2004-09-25/res1,2004-09-21/2004-09-25/res2
@@ -385,7 +392,7 @@ int _msValidateTime(const char *timestri
   */
 
   numextents = 0;
-  atimeextents = msStringSplit (timeextent, ',', &numextents);
+  atimeextents = msStringSplit(timeextent, ',', &numextents);
   if (numextents <= 0) {
     msFreeCharArray(atimeextents, numextents);
     return MS_FALSE;
@@ -394,13 +401,13 @@ int _msValidateTime(const char *timestri
   /*the time timestring should at be valid in one of the extents
     defined */
 
-  for (i=0; i<numextents; i++) {
+  for (i = 0; i < numextents; i++) {
     /* build time structure for the extents */
     msTimeInit(&tmstart);
     msTimeInit(&tmend);
 
     numranges = 0;
-    atimerange = msStringSplit (atimeextents[i], '/', &numranges);
+    atimerange = msStringSplit(atimeextents[i], '/', &numranges);
     /* - one value 2004-09-21 */
     if (numranges == 1) {
       /*time tested can either be descrete or a range */
@@ -426,18 +433,14 @@ int _msValidateTime(const char *timestri
       }
     }
     msFreeCharArray(atimerange, numranges);
-
-
   }
   msFreeCharArray(atimeextents, numextents);
   return MS_FALSE;
-
 }
 
-int msValidateTimeValue(const char *timestring, const char *timeextent)
-{
-  char **atimes =  NULL;
-  int i, numtimes=0;
+int msValidateTimeValue(const char *timestring, const char *timeextent) {
+  char **atimes = NULL;
+  int i, numtimes = 0;
 
   /* we need to validate the time passsed in the request */
   /* against the time extent defined */
@@ -452,12 +455,13 @@ int msValidateTimeValue(const char *time
   /* parse the time string. We support descrete times (eg 2004-09-21), */
   /* multiple times (2004-09-21, 2004-09-22, ...) */
   /* and range(s) (2004-09-21/2004-09-25, 2004-09-27/2004-09-29) */
-  if (strstr(timestring, ",") == NULL && strstr(timestring, "/") == NULL) { /* discrete time */
-    return _msValidateTime(timestring,  timeextent);
+  if (strstr(timestring, ",") == NULL &&
+      strstr(timestring, "/") == NULL) { /* discrete time */
+    return _msValidateTime(timestring, timeextent);
   } else {
     atimes = msStringSplit(timestring, ',', &numtimes);
-    if (numtimes >=1) { /* multiple times */
-      for (i=0; i<numtimes; i++) {
+    if (numtimes >= 1) { /* multiple times */
+      for (i = 0; i < numtimes; i++) {
         if (_msValidateTime(atimes[i], timeextent) == MS_FALSE) {
           msFreeCharArray(atimes, numtimes);
           return MS_FALSE;
@@ -466,9 +470,8 @@ int msValidateTimeValue(const char *time
       msFreeCharArray(atimes, numtimes);
       return MS_TRUE;
     } else {
-      msFreeCharArray(atimes,numtimes);
+      msFreeCharArray(atimes, numtimes);
     }
   }
   return MS_FALSE;
 }
-
diff -pruN 8.0.1-5/maptime.h 8.0.2-1/maptime.h
--- 8.0.1-5/maptime.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/maptime.h	2024-06-11 20:41:34.000000000 +0000
@@ -40,26 +40,26 @@ extern "C" {
  */
 #if defined(_WIN32) && !defined(__CYGWIN__)
 struct mstimeval {
-  long    tv_sec;         /* seconds */
-  long    tv_usec;        /* and microseconds */
+  long tv_sec;  /* seconds */
+  long tv_usec; /* and microseconds */
 };
 MS_DLL_EXPORT void msGettimeofday(struct mstimeval *t, void *__not_used_here__);
 #else
-#  include <sys/time.h>     /* for gettimeofday() */
-#  define  mstimeval timeval
-#  define  msGettimeofday(t,u) gettimeofday(t,u)
+#include <sys/time.h> /* for gettimeofday() */
+#define mstimeval timeval
+#define msGettimeofday(t, u) gettimeofday(t, u)
 #endif
 
 typedef enum {
   TIME_RESOLUTION_UNDEFINED = -1,
-  TIME_RESOLUTION_MICROSECOND =0,
-  TIME_RESOLUTION_MILLISECOND =1,
-  TIME_RESOLUTION_SECOND =2,
-  TIME_RESOLUTION_MINUTE =3,
-  TIME_RESOLUTION_HOUR =4,
-  TIME_RESOLUTION_DAY =5,
-  TIME_RESOLUTION_MONTH =6,
-  TIME_RESOLUTION_YEAR =7
+  TIME_RESOLUTION_MICROSECOND = 0,
+  TIME_RESOLUTION_MILLISECOND = 1,
+  TIME_RESOLUTION_SECOND = 2,
+  TIME_RESOLUTION_MINUTE = 3,
+  TIME_RESOLUTION_HOUR = 4,
+  TIME_RESOLUTION_DAY = 5,
+  TIME_RESOLUTION_MONTH = 6,
+  TIME_RESOLUTION_YEAR = 7
 } MS_TIME_RESOLUTION;
 
 /* function prototypes */
diff -pruN 8.0.1-5/maptree.c 8.0.2-1/maptree.c
--- 8.0.1-5/maptree.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/maptree.c	2024-06-11 20:41:34.000000000 +0000
@@ -42,7 +42,12 @@
 #define bBigEndian false
 #else
 /* generic check */
-#define bBigEndian (((union{int in;char out;}){1}).out)
+#define bBigEndian                                                             \
+  (((union {                                                                   \
+     int in;                                                                   \
+     char out;                                                                 \
+   }){1})                                                                      \
+       .out)
 #endif
 
 /* -------------------------------------------------------------------- */
@@ -52,36 +57,34 @@
 /*      prevent small objects on a boundary from shifting too high      */
 /*      up the tree.                                                    */
 /* -------------------------------------------------------------------- */
-#define SPLITRATIO  0.55
+#define SPLITRATIO 0.55
 
 static int treeAddShapeId(treeObj *tree, int id, rectObj rect);
 
-static void SwapWord( int length, void * wordP )
-{
+static void SwapWord(int length, void *wordP) {
   int i;
   uchar temp;
 
-  for( i=0; i < length/2; i++ ) {
-    temp = ((uchar *) wordP)[i];
-    ((uchar *)wordP)[i] = ((uchar *) wordP)[length-i-1];
-    ((uchar *) wordP)[length-i-1] = temp;
+  for (i = 0; i < length / 2; i++) {
+    temp = ((uchar *)wordP)[i];
+    ((uchar *)wordP)[i] = ((uchar *)wordP)[length - i - 1];
+    ((uchar *)wordP)[length - i - 1] = temp;
   }
 }
 
-static void * SfRealloc( void * pMem, int nNewSize )
+static void *SfRealloc(void *pMem, int nNewSize)
 
 {
-  if( pMem == NULL )
-    return( (void *) malloc(nNewSize) );
+  if (pMem == NULL)
+    return ((void *)malloc(nNewSize));
   else
-    return( (void *) realloc(pMem,nNewSize) );
+    return ((void *)realloc(pMem, nNewSize));
 }
 
-static treeNodeObj *treeNodeCreate(rectObj rect)
-{
+static treeNodeObj *treeNodeCreate(rectObj rect) {
   treeNodeObj *node;
 
-  node = (treeNodeObj *) msSmallMalloc(sizeof(treeNodeObj));
+  node = (treeNodeObj *)msSmallMalloc(sizeof(treeNodeObj));
 
   node->numshapes = 0;
   node->ids = NULL;
@@ -93,61 +96,60 @@ static treeNodeObj *treeNodeCreate(rectO
   return node;
 }
 
-
-SHPTreeHandle msSHPDiskTreeOpen(const char * pszTree, int debug)
-{
-  char    *pszFullname, *pszBasename;
+SHPTreeHandle msSHPDiskTreeOpen(const char *pszTree, int debug) {
+  char *pszFullname, *pszBasename;
   SHPTreeHandle psTree;
 
-  char    pabyBuf[16];
-  int     i;
+  char pabyBuf[16];
+  int i;
 
   /* -------------------------------------------------------------------- */
   /*  Initialize the info structure.              */
   /* -------------------------------------------------------------------- */
-  psTree = (SHPTreeHandle) msSmallMalloc(sizeof(SHPTreeInfo));
+  psTree = (SHPTreeHandle)msSmallMalloc(sizeof(SHPTreeInfo));
 
   /* -------------------------------------------------------------------- */
   /*  Compute the base (layer) name.  If there is any extension     */
   /*  on the passed in filename we will strip it off.         */
   /* -------------------------------------------------------------------- */
-  pszBasename = (char *) msSmallMalloc(strlen(pszTree)+5);
-  strcpy( pszBasename, pszTree );
-  for( i = strlen(pszBasename)-1;
-       i > 0 && pszBasename[i] != '.' && pszBasename[i] != '/'
-       && pszBasename[i] != '\\';
-       i-- ) {}
+  pszBasename = (char *)msSmallMalloc(strlen(pszTree) + 5);
+  strcpy(pszBasename, pszTree);
+  for (i = strlen(pszBasename) - 1;
+       i > 0 && pszBasename[i] != '.' && pszBasename[i] != '/' &&
+       pszBasename[i] != '\\';
+       i--) {
+  }
 
-  if( pszBasename[i] == '.' )
+  if (pszBasename[i] == '.')
     pszBasename[i] = '\0';
 
   /* -------------------------------------------------------------------- */
   /*  Open the .shp and .shx files.  Note that files pulled from      */
   /*  a PC to Unix with upper case filenames won't work!        */
   /* -------------------------------------------------------------------- */
-  pszFullname = (char *) msSmallMalloc(strlen(pszBasename) + 5);
-  sprintf( pszFullname, "%s%s", pszBasename, MS_INDEX_EXTENSION);
-  psTree->fp = fopen(pszFullname, "rb" );
-  if( psTree->fp == NULL ) {
-      sprintf( pszFullname, "%s.QIX", pszBasename);
-      psTree->fp = fopen(pszFullname, "rb" );
+  pszFullname = (char *)msSmallMalloc(strlen(pszBasename) + 5);
+  sprintf(pszFullname, "%s%s", pszBasename, MS_INDEX_EXTENSION);
+  psTree->fp = fopen(pszFullname, "rb");
+  if (psTree->fp == NULL) {
+    sprintf(pszFullname, "%s.QIX", pszBasename);
+    psTree->fp = fopen(pszFullname, "rb");
   }
 
   msFree(pszBasename); /* don't need these any more */
   msFree(pszFullname);
 
-  if( psTree->fp == NULL ) {
+  if (psTree->fp == NULL) {
     msFree(psTree);
-    return( NULL );
+    return (NULL);
   }
 
-  if( fread( pabyBuf, 8, 1, psTree->fp ) != 1 ) {
+  if (fread(pabyBuf, 8, 1, psTree->fp) != 1) {
     msFree(psTree);
-    return( NULL );
+    return (NULL);
   }
 
-  memcpy( &psTree->signature, pabyBuf, 3 );
-  if( strncmp(psTree->signature,"SQT",3) ) {
+  memcpy(&psTree->signature, pabyBuf, 3);
+  if (strncmp(psTree->signature, "SQT", 3)) {
     /* ---------------------------------------------------------------------- */
     /*     must check if the 2 first bytes equal 0 of max depth that cannot   */
     /*     be more than 65535. If yes, we must swap all value. The problem    */
@@ -158,10 +160,11 @@ SHPTreeHandle msSHPDiskTreeOpen(const ch
     if (debug) {
       msDebug("WARNING in msSHPDiskTreeOpen(): %s is in old index format "
               "which has been deprecated.  It is strongly recommended to "
-              "regenerate it in new format.\n", pszTree);
+              "regenerate it in new format.\n",
+              pszTree);
     }
-    if((pabyBuf[4] == 0 && pabyBuf[5] == 0 &&
-        pabyBuf[6] == 0 && pabyBuf[7] == 0)) {
+    if ((pabyBuf[4] == 0 && pabyBuf[5] == 0 && pabyBuf[6] == 0 &&
+         pabyBuf[7] == 0)) {
       psTree->LSB_order = !(pabyBuf[0] == 0 && pabyBuf[1] == 0);
     } else {
       psTree->LSB_order = !(pabyBuf[4] == 0 && pabyBuf[5] == 0);
@@ -174,48 +177,46 @@ SHPTreeHandle msSHPDiskTreeOpen(const ch
     /* ---------------------------------------------------------------------- */
     psTree->version = 0;
   } else {
-    psTree->needswap = (( pabyBuf[3] == MS_NEW_MSB_ORDER ) ^ ( bBigEndian ));
+    psTree->needswap = ((pabyBuf[3] == MS_NEW_MSB_ORDER) ^ (bBigEndian));
 
-    psTree->LSB_order = ( pabyBuf[3] == MS_NEW_LSB_ORDER );
-    memcpy( &psTree->version, pabyBuf+4, 1 );
-    memcpy( &psTree->flags, pabyBuf+5, 3 );
+    psTree->LSB_order = (pabyBuf[3] == MS_NEW_LSB_ORDER);
+    memcpy(&psTree->version, pabyBuf + 4, 1);
+    memcpy(&psTree->flags, pabyBuf + 5, 3);
 
-    if( fread( pabyBuf, 8, 1, psTree->fp ) != 1 )
-    {
+    if (fread(pabyBuf, 8, 1, psTree->fp) != 1) {
       msFree(psTree);
-      return( NULL );
+      return (NULL);
     }
   }
 
-  if( psTree->needswap ) SwapWord( 4, pabyBuf );
-  memcpy( &psTree->nShapes, pabyBuf, 4 );
+  if (psTree->needswap)
+    SwapWord(4, pabyBuf);
+  memcpy(&psTree->nShapes, pabyBuf, 4);
 
-  if( psTree->needswap ) SwapWord( 4, pabyBuf+4 );
-  memcpy( &psTree->nDepth, pabyBuf+4, 4 );
+  if (psTree->needswap)
+    SwapWord(4, pabyBuf + 4);
+  memcpy(&psTree->nDepth, pabyBuf + 4, 4);
 
-  return( psTree );
+  return (psTree);
 }
 
-
-void msSHPDiskTreeClose(SHPTreeHandle disktree)
-{
-  fclose( disktree->fp );
-  free( disktree );
+void msSHPDiskTreeClose(SHPTreeHandle disktree) {
+  fclose(disktree->fp);
+  free(disktree);
 }
 
-
-treeObj *msCreateTree(shapefileObj *shapefile, int maxdepth)
-{
+treeObj *msCreateTree(shapefileObj *shapefile, int maxdepth) {
   int i;
   treeObj *tree;
   rectObj bounds;
 
-  if(!shapefile) return NULL;
+  if (!shapefile)
+    return NULL;
 
   /* -------------------------------------------------------------------- */
   /*      Allocate the tree object                                        */
   /* -------------------------------------------------------------------- */
-  tree = (treeObj *) msSmallMalloc(sizeof(treeObj));
+  tree = (treeObj *)msSmallMalloc(sizeof(treeObj));
 
   tree->numshapes = shapefile->numshapes;
   tree->maxdepth = maxdepth;
@@ -224,10 +225,10 @@ treeObj *msCreateTree(shapefileObj *shap
   /*      If no max depth was defined, try to select a reasonable one     */
   /*      that implies approximately 8 shapes per node.                   */
   /* -------------------------------------------------------------------- */
-  if( tree->maxdepth == 0 ) {
+  if (tree->maxdepth == 0) {
     int numnodes = 1;
 
-    while(numnodes*4 < shapefile->numshapes) {
+    while (numnodes * 4 < shapefile->numshapes) {
       tree->maxdepth += 1;
       numnodes = numnodes * 2;
     }
@@ -238,37 +239,34 @@ treeObj *msCreateTree(shapefileObj *shap
   /* -------------------------------------------------------------------- */
   tree->root = treeNodeCreate(shapefile->bounds);
 
-  for(i=0; i<shapefile->numshapes; i++) {
-    if(msSHPReadBounds(shapefile->hSHP, i, &bounds) == MS_SUCCESS)
+  for (i = 0; i < shapefile->numshapes; i++) {
+    if (msSHPReadBounds(shapefile->hSHP, i, &bounds) == MS_SUCCESS)
       treeAddShapeId(tree, i, bounds);
   }
 
   return tree;
 }
 
-static void destroyTreeNode(treeNodeObj *node)
-{
+static void destroyTreeNode(treeNodeObj *node) {
   int i;
 
-  for(i=0; i<node->numsubnodes; i++ ) {
-    if(node->subnode[i])
+  for (i = 0; i < node->numsubnodes; i++) {
+    if (node->subnode[i])
       destroyTreeNode(node->subnode[i]);
   }
 
-  if(node->ids)
+  if (node->ids)
     free(node->ids);
 
   free(node);
 }
 
-void msDestroyTree(treeObj *tree)
-{
+void msDestroyTree(treeObj *tree) {
   destroyTreeNode(tree->root);
   free(tree);
 }
 
-static void treeSplitBounds( rectObj *in, rectObj *out1, rectObj *out2)
-{
+static void treeSplitBounds(rectObj *in, rectObj *out1, rectObj *out2) {
   double range;
 
   /* -------------------------------------------------------------------- */
@@ -281,7 +279,7 @@ static void treeSplitBounds( rectObj *in
   /* -------------------------------------------------------------------- */
   /*      Split in X direction.                                           */
   /* -------------------------------------------------------------------- */
-  if((in->maxx - in->minx) > (in->maxy - in->miny)) {
+  if ((in->maxx - in->minx) > (in->maxy - in->miny)) {
     range = in->maxx - in->minx;
 
     out1->maxx = in->minx + range * SPLITRATIO;
@@ -299,18 +297,18 @@ static void treeSplitBounds( rectObj *in
   }
 }
 
-static int treeNodeAddShapeId( treeNodeObj *node, int id, rectObj rect, int maxdepth)
-{
+static int treeNodeAddShapeId(treeNodeObj *node, int id, rectObj rect,
+                              int maxdepth) {
   int i;
 
   /* -------------------------------------------------------------------- */
   /*      If there are subnodes, then consider whether this object        */
   /*      will fit in them.                                               */
   /* -------------------------------------------------------------------- */
-  if( maxdepth > 1 && node->numsubnodes > 0 ) {
-    for(i=0; i<node->numsubnodes; i++ ) {
-      if( msRectContained(&rect, &node->subnode[i]->rect)) {
-        return treeNodeAddShapeId( node->subnode[i], id, rect, maxdepth-1);
+  if (maxdepth > 1 && node->numsubnodes > 0) {
+    for (i = 0; i < node->numsubnodes; i++) {
+      if (msRectContained(&rect, &node->subnode[i]->rect)) {
+        return treeNodeAddShapeId(node->subnode[i], id, rect, maxdepth - 1);
       }
     }
   }
@@ -320,14 +318,15 @@ static int treeNodeAddShapeId( treeNodeO
   /*      them, and adding to the appropriate subnode.                    */
   /* -------------------------------------------------------------------- */
 #if MAX_SUBNODES == 4
-  else if( maxdepth > 1 && node->numsubnodes == 0 ) {
+  else if (maxdepth > 1 && node->numsubnodes == 0) {
     rectObj half1, half2, quad1, quad2, quad3, quad4;
 
     treeSplitBounds(&node->rect, &half1, &half2);
     treeSplitBounds(&half1, &quad1, &quad2);
     treeSplitBounds(&half2, &quad3, &quad4);
 
-    if(msRectContained(&rect, &quad1) || msRectContained(&rect, &quad2) ||  msRectContained(&rect, &quad3) || msRectContained(&rect, &quad4)) {
+    if (msRectContained(&rect, &quad1) || msRectContained(&rect, &quad2) ||
+        msRectContained(&rect, &quad3) || msRectContained(&rect, &quad4)) {
       node->numsubnodes = 4;
       node->subnode[0] = treeNodeCreate(quad1);
       node->subnode[1] = treeNodeCreate(quad2);
@@ -335,7 +334,7 @@ static int treeNodeAddShapeId( treeNodeO
       node->subnode[3] = treeNodeCreate(quad4);
 
       /* recurse back on this node now that it has subnodes */
-      return(treeNodeAddShapeId(node, id, rect, maxdepth));
+      return (treeNodeAddShapeId(node, id, rect, maxdepth));
     }
   }
 #endif
@@ -345,23 +344,23 @@ static int treeNodeAddShapeId( treeNodeO
   /*      them, and adding to the appropriate subnode.                    */
   /* -------------------------------------------------------------------- */
 #if MAX_SUBNODE == 2
-  else if( maxdepth > 1 && node->numsubnodes == 0 ) {
+  else if (maxdepth > 1 && node->numsubnodes == 0) {
     rectObj half1, half2;
 
     treeSplitBounds(&node->rect, &half1, &half2);
 
-    if( msRectContained(&rect, &half1)) {
+    if (msRectContained(&rect, &half1)) {
       node->numsubnodes = 2;
       node->subnode[0] = treeNodeCreate(half1);
       node->subnode[1] = treeNodeCreate(half2);
 
-      return(treeNodeAddShapeId(node->subnode[0], id, rect, maxdepth-1));
-    } else if(msRectContained(&rect, &half2)) {
+      return (treeNodeAddShapeId(node->subnode[0], id, rect, maxdepth - 1));
+    } else if (msRectContained(&rect, &half2)) {
       node->numsubnodes = 2;
       node->subnode[0] = treeNodeCreate(&half1);
       node->subnode[1] = treeNodeCreate(&half2);
 
-      return(treeNodeAddShapeId(node->subnode[1], id, rect, maxdepth-1));
+      return (treeNodeAddShapeId(node->subnode[1], id, rect, maxdepth - 1));
     }
   }
 #endif /* MAX_SUBNODE == 2 */
@@ -371,69 +370,66 @@ static int treeNodeAddShapeId( treeNodeO
   /* -------------------------------------------------------------------- */
   node->numshapes++;
 
-  node->ids = SfRealloc( node->ids, sizeof(ms_int32) * node->numshapes );
-  node->ids[node->numshapes-1] = id;
+  node->ids = SfRealloc(node->ids, sizeof(ms_int32) * node->numshapes);
+  node->ids[node->numshapes - 1] = id;
 
   return MS_TRUE;
 }
 
-static int treeAddShapeId(treeObj *tree, int id, rectObj rect)
-{
-  return(treeNodeAddShapeId(tree->root, id, rect, tree->maxdepth));
+static int treeAddShapeId(treeObj *tree, int id, rectObj rect) {
+  return (treeNodeAddShapeId(tree->root, id, rect, tree->maxdepth));
 }
 
-static void treeCollectShapeIds(treeNodeObj *node, rectObj aoi, ms_bitarray status)
-{
+static void treeCollectShapeIds(treeNodeObj *node, rectObj aoi,
+                                ms_bitarray status) {
   int i;
 
   /* -------------------------------------------------------------------- */
   /*      Does this node overlap the area of interest at all?  If not,    */
   /*      return without adding to the list at all.                       */
   /* -------------------------------------------------------------------- */
-  if(!msRectOverlap(&node->rect, &aoi))
+  if (!msRectOverlap(&node->rect, &aoi))
     return;
 
   /* -------------------------------------------------------------------- */
   /*      Add the local nodes shapeids to the list.                       */
   /* -------------------------------------------------------------------- */
-  for(i=0; i<node->numshapes; i++)
+  for (i = 0; i < node->numshapes; i++)
     msSetBit(status, node->ids[i], 1);
 
   /* -------------------------------------------------------------------- */
   /*      Recurse to subnodes if they exist.                              */
   /* -------------------------------------------------------------------- */
-  for(i=0; i<node->numsubnodes; i++) {
-    if(node->subnode[i])
+  for (i = 0; i < node->numsubnodes; i++) {
+    if (node->subnode[i])
       treeCollectShapeIds(node->subnode[i], aoi, status);
   }
 }
 
-ms_bitarray msSearchTree(const treeObj *tree, rectObj aoi)
-{
-  ms_bitarray status=NULL;
+ms_bitarray msSearchTree(const treeObj *tree, rectObj aoi) {
+  ms_bitarray status = NULL;
 
   status = msAllocBitArray(tree->numshapes);
-  if(!status) {
+  if (!status) {
     msSetError(MS_MEMERR, NULL, "msSearchTree()");
-    return(NULL);
+    return (NULL);
   }
 
   treeCollectShapeIds(tree->root, aoi, status);
 
-  return(status);
+  return (status);
 }
 
-static int treeNodeTrim( treeNodeObj *node )
-{
+static int treeNodeTrim(treeNodeObj *node) {
   int i;
 
   /* -------------------------------------------------------------------- */
   /*      Trim subtrees, and free subnodes that come back empty.          */
   /* -------------------------------------------------------------------- */
-  for(i=0; i<node->numsubnodes; i++ ) {
-    if(treeNodeTrim(node->subnode[i])) {
+  for (i = 0; i < node->numsubnodes; i++) {
+    if (treeNodeTrim(node->subnode[i])) {
       destroyTreeNode(node->subnode[i]);
-      node->subnode[i] = node->subnode[node->numsubnodes-1];
+      node->subnode[i] = node->subnode[node->numsubnodes - 1];
       node->numsubnodes--;
       i--; /* process the new occupant of this subnode entry */
     }
@@ -443,16 +439,15 @@ static int treeNodeTrim( treeNodeObj *no
   /*      If the current node has 1 subnode and no shapes, promote that   */
   /*      subnode to the current node position.                           */
   /* -------------------------------------------------------------------- */
-  if( node->numsubnodes == 1 && node->numshapes == 0) {
-    treeNodeObj* psSubNode = node->subnode[0];
+  if (node->numsubnodes == 1 && node->numshapes == 0) {
+    treeNodeObj *psSubNode = node->subnode[0];
 
-    memcpy(&node->rect, &psSubNode->rect,
-           sizeof(psSubNode->rect));
+    memcpy(&node->rect, &psSubNode->rect, sizeof(psSubNode->rect));
     node->numshapes = psSubNode->numshapes;
     assert(node->ids == NULL);
     node->ids = psSubNode->ids;
     node->numsubnodes = psSubNode->numsubnodes;
-    for( i = 0; i < psSubNode->numsubnodes; i++ )
+    for (i = 0; i < psSubNode->numsubnodes; i++)
       node->subnode[i] = psSubNode->subnode[i];
     free(psSubNode);
   }
@@ -461,212 +456,221 @@ static int treeNodeTrim( treeNodeObj *no
   /*      We should be trimmed if we have no subnodes, and no shapes.     */
   /* -------------------------------------------------------------------- */
 
-  return(node->numsubnodes == 0 && node->numshapes == 0);
+  return (node->numsubnodes == 0 && node->numshapes == 0);
 }
 
-void msTreeTrim(treeObj *tree)
-{
-  treeNodeTrim(tree->root);
-}
+void msTreeTrim(treeObj *tree) { treeNodeTrim(tree->root); }
 
-static void searchDiskTreeNode(SHPTreeHandle disktree, rectObj aoi, ms_bitarray status)
-{
+static void searchDiskTreeNode(SHPTreeHandle disktree, rectObj aoi,
+                               ms_bitarray status) {
   int i;
   ms_int32 offset;
   ms_int32 numshapes, numsubnodes;
   rectObj rect;
 
-  int *ids=NULL;
+  int *ids = NULL;
 
-  if( fread( &offset, 4, 1, disktree->fp ) != 1 )
+  if (fread(&offset, 4, 1, disktree->fp) != 1)
     goto error;
-  if ( disktree->needswap ) SwapWord ( 4, &offset );
+  if (disktree->needswap)
+    SwapWord(4, &offset);
 
-  if( fread( &rect, sizeof(rectObj), 1, disktree->fp ) != 1 )
+  if (fread(&rect, sizeof(rectObj), 1, disktree->fp) != 1)
     goto error;
-  if ( disktree->needswap ) SwapWord ( 8, &rect.minx );
-  if ( disktree->needswap ) SwapWord ( 8, &rect.miny );
-  if ( disktree->needswap ) SwapWord ( 8, &rect.maxx );
-  if ( disktree->needswap ) SwapWord ( 8, &rect.maxy );
+  if (disktree->needswap)
+    SwapWord(8, &rect.minx);
+  if (disktree->needswap)
+    SwapWord(8, &rect.miny);
+  if (disktree->needswap)
+    SwapWord(8, &rect.maxx);
+  if (disktree->needswap)
+    SwapWord(8, &rect.maxy);
 
-  if( fread( &numshapes, 4, 1, disktree->fp ) != 1 )
+  if (fread(&numshapes, 4, 1, disktree->fp) != 1)
     goto error;
-  if ( disktree->needswap ) SwapWord ( 4, &numshapes );
-  if( numshapes < 0 || numshapes > INT_MAX / 4 )
+  if (disktree->needswap)
+    SwapWord(4, &numshapes);
+  if (numshapes < 0 || numshapes > INT_MAX / 4)
     goto error;
 
-  if(!msRectOverlap(&rect, &aoi)) { /* skip rest of this node and sub-nodes */
-    offset += numshapes*sizeof(ms_int32) + sizeof(ms_int32);
-    if( fseek(disktree->fp, offset, SEEK_CUR) < 0 )
-        goto error;
+  if (!msRectOverlap(&rect, &aoi)) { /* skip rest of this node and sub-nodes */
+    offset += numshapes * sizeof(ms_int32) + sizeof(ms_int32);
+    if (fseek(disktree->fp, offset, SEEK_CUR) < 0)
+      goto error;
     return;
   }
-  if(numshapes > 0) {
-    ids = (int *)msSmallMalloc(numshapes*sizeof(ms_int32));
+  if (numshapes > 0) {
+    ids = (int *)msSmallMalloc(numshapes * sizeof(ms_int32));
 
-    if( fread( ids, numshapes*sizeof(ms_int32), 1, disktree->fp ) != 1 )
+    if (fread(ids, numshapes * sizeof(ms_int32), 1, disktree->fp) != 1)
       goto error;
-    if (disktree->needswap ) {
-      for( i=0; i<numshapes; i++ ) {
-        SwapWord( 4, &ids[i] );
+    if (disktree->needswap) {
+      for (i = 0; i < numshapes; i++) {
+        SwapWord(4, &ids[i]);
         msSetBit(status, ids[i], 1);
       }
     } else {
-      for(i=0; i<numshapes; i++)
+      for (i = 0; i < numshapes; i++)
         msSetBit(status, ids[i], 1);
     }
     free(ids);
     ids = NULL;
   }
 
-  if( fread( &numsubnodes, 4, 1, disktree->fp ) != 1 )
+  if (fread(&numsubnodes, 4, 1, disktree->fp) != 1)
     goto error;
-  if ( disktree->needswap ) SwapWord ( 4, &numsubnodes );
-  if( numsubnodes < 0 || numsubnodes > INT_MAX / 4 )
+  if (disktree->needswap)
+    SwapWord(4, &numsubnodes);
+  if (numsubnodes < 0 || numsubnodes > INT_MAX / 4)
     goto error;
 
-  for(i=0; i<numsubnodes; i++)
+  for (i = 0; i < numsubnodes; i++)
     searchDiskTreeNode(disktree, aoi, status);
 
   return;
-  
+
 error:
   msSetError(MS_IOERR, NULL, "searchDiskTreeNode()");
   free(ids);
   return;
 }
 
-ms_bitarray msSearchDiskTree(const char *filename, rectObj aoi, int debug, int numshapes)
-{
+ms_bitarray msSearchDiskTree(const char *filename, rectObj aoi, int debug,
+                             int numshapes) {
   SHPTreeHandle disktree;
-  ms_bitarray status=NULL;
+  ms_bitarray status = NULL;
 
-  disktree = msSHPDiskTreeOpen (filename, debug);
-  if(!disktree) {
+  disktree = msSHPDiskTreeOpen(filename, debug);
+  if (!disktree) {
 
     /* only set this error IF debugging is turned on, gets annoying otherwise */
-    if(debug) msSetError(MS_NOTFOUND, "Unable to open spatial index for %s. In most cases you can safely ignore this message, otherwise check file names and permissions.", "msSearchDiskTree()", filename);
+    if (debug)
+      msSetError(
+          MS_NOTFOUND,
+          "Unable to open spatial index for %s. In most cases you can safely "
+          "ignore this message, otherwise check file names and permissions.",
+          "msSearchDiskTree()", filename);
 
-    return(NULL);
+    return (NULL);
   }
 
   if (disktree->nShapes != numshapes) {
-      msSetError(MS_SHPERR, "The spatial index file %s is corrupt.", "msSearchDiskTree()", filename);
-      msSHPDiskTreeClose(disktree);
-      return(NULL);
+    msSetError(MS_SHPERR, "The spatial index file %s is corrupt.",
+               "msSearchDiskTree()", filename);
+    msSHPDiskTreeClose(disktree);
+    return (NULL);
   }
 
   status = msAllocBitArray(disktree->nShapes);
-  if(!status) {
+  if (!status) {
     msSetError(MS_MEMERR, NULL, "msSearchDiskTree()");
-    msSHPDiskTreeClose( disktree );
-    return(NULL);
+    msSHPDiskTreeClose(disktree);
+    return (NULL);
   }
 
   searchDiskTreeNode(disktree, aoi, status);
 
-  msSHPDiskTreeClose( disktree );
-  return(status);
+  msSHPDiskTreeClose(disktree);
+  return (status);
 }
 
-treeNodeObj *readTreeNode( SHPTreeHandle disktree )
-{
-  int i,res;
+treeNodeObj *readTreeNode(SHPTreeHandle disktree) {
+  int i, res;
   ms_int32 offset;
   treeNodeObj *node;
 
-  node = (treeNodeObj *) msSmallMalloc(sizeof(treeNodeObj));
+  node = (treeNodeObj *)msSmallMalloc(sizeof(treeNodeObj));
   node->ids = NULL;
 
-  res = fread( &offset, 4, 1, disktree->fp );
-  if ( !res )
-  {
+  res = fread(&offset, 4, 1, disktree->fp);
+  if (!res) {
     free(node);
     return NULL;
   }
 
-  if ( disktree->needswap ) SwapWord ( 4, &offset );
+  if (disktree->needswap)
+    SwapWord(4, &offset);
 
-  res = fread( &node->rect, sizeof(rectObj), 1, disktree->fp );
-  if ( !res )
-  {
+  res = fread(&node->rect, sizeof(rectObj), 1, disktree->fp);
+  if (!res) {
     free(node);
     return NULL;
   }
-  if ( disktree->needswap ) SwapWord ( 8, &node->rect.minx );
-  if ( disktree->needswap ) SwapWord ( 8, &node->rect.miny );
-  if ( disktree->needswap ) SwapWord ( 8, &node->rect.maxx );
-  if ( disktree->needswap ) SwapWord ( 8, &node->rect.maxy );
-
-  res = fread( &node->numshapes, 4, 1, disktree->fp );
-  if ( !res )
-  {
+  if (disktree->needswap)
+    SwapWord(8, &node->rect.minx);
+  if (disktree->needswap)
+    SwapWord(8, &node->rect.miny);
+  if (disktree->needswap)
+    SwapWord(8, &node->rect.maxx);
+  if (disktree->needswap)
+    SwapWord(8, &node->rect.maxy);
+
+  res = fread(&node->numshapes, 4, 1, disktree->fp);
+  if (!res) {
     free(node);
     return NULL;
   }
-  if ( disktree->needswap ) SwapWord ( 4, &node->numshapes );
-  if ( node->numshapes < 0 || node->numshapes > INT_MAX / 4 )
-  {
+  if (disktree->needswap)
+    SwapWord(4, &node->numshapes);
+  if (node->numshapes < 0 || node->numshapes > INT_MAX / 4) {
     free(node);
     return NULL;
   }
-  if( node->numshapes > 0 )
-  {
-    node->ids = (ms_int32 *)msSmallMalloc(sizeof(ms_int32)*node->numshapes);
-    res = fread( node->ids, node->numshapes*4, 1, disktree->fp );
-    if ( !res )
-    {
+  if (node->numshapes > 0) {
+    node->ids = (ms_int32 *)msSmallMalloc(sizeof(ms_int32) * node->numshapes);
+    res = fread(node->ids, node->numshapes * 4, 1, disktree->fp);
+    if (!res) {
       free(node->ids);
       free(node);
       return NULL;
     }
   }
-  for( i=0; i < node->numshapes; i++ ) {
-    if ( disktree->needswap ) SwapWord ( 4, &node->ids[i] );
+  for (i = 0; i < node->numshapes; i++) {
+    if (disktree->needswap)
+      SwapWord(4, &node->ids[i]);
   }
 
-  res = fread( &node->numsubnodes, 4, 1, disktree->fp );
-  if ( !res )
-  {
+  res = fread(&node->numsubnodes, 4, 1, disktree->fp);
+  if (!res) {
     free(node->ids);
     free(node);
     return NULL;
   }
-  if ( disktree->needswap ) SwapWord ( 4, &node->numsubnodes );
+  if (disktree->needswap)
+    SwapWord(4, &node->numsubnodes);
 
   return node;
 }
 
-treeObj *msReadTree(char *filename, int debug)
-{
-  treeObj *tree=NULL;
+treeObj *msReadTree(char *filename, int debug) {
+  treeObj *tree = NULL;
   SHPTreeHandle disktree;
 
-  disktree = msSHPDiskTreeOpen( filename, debug );
-  if(!disktree) {
+  disktree = msSHPDiskTreeOpen(filename, debug);
+  if (!disktree) {
     msSetError(MS_IOERR, NULL, "msReadTree()");
-    return(NULL);
+    return (NULL);
   }
 
-  tree = (treeObj *) malloc(sizeof(treeObj));
+  tree = (treeObj *)malloc(sizeof(treeObj));
   MS_CHECK_ALLOC(tree, sizeof(treeObj), NULL);
 
   tree->numshapes = disktree->nShapes;
   tree->maxdepth = disktree->nDepth;
 
-  tree->root = readTreeNode( disktree );
+  tree->root = readTreeNode(disktree);
 
-  return(tree);
+  return (tree);
 }
 
-static ms_int32 getSubNodeOffset(treeNodeObj *node)
-{
+static ms_int32 getSubNodeOffset(treeNodeObj *node) {
   int i;
-  ms_int32 offset=0;
+  ms_int32 offset = 0;
 
-  for(i=0; i<node->numsubnodes; i++ ) {
-    if(node->subnode[i]) {
-      offset += sizeof(rectObj) + (node->subnode[i]->numshapes+3)*sizeof(int);
+  for (i = 0; i < node->numsubnodes; i++) {
+    if (node->subnode[i]) {
+      offset +=
+          sizeof(rectObj) + (node->subnode[i]->numshapes + 3) * sizeof(int);
       offset += getSubNodeOffset(node->subnode[i]);
     }
   }
@@ -680,98 +684,98 @@ static ms_int32 getSubNodeOffset(treeNod
   /*    int   numSubNodes   4 bytes           */
   /*                                               */
 
-  return(offset);
+  return (offset);
 }
 
-
-static void writeTreeNode(SHPTreeHandle disktree, treeNodeObj *node)
-{
-  int i,j;
+static void writeTreeNode(SHPTreeHandle disktree, treeNodeObj *node) {
+  int i, j;
   ms_int32 offset;
   char *pabyRec = NULL;
 
   offset = getSubNodeOffset(node);
 
-  pabyRec = msSmallMalloc(sizeof(rectObj) + (3 * sizeof(ms_int32)) + (node->numshapes * sizeof(ms_int32)) );
-
-  memcpy( pabyRec, &offset, 4);
-  if( disktree->needswap ) SwapWord( 4, pabyRec );
-
-  memcpy( pabyRec+4, &node->rect, sizeof(rectObj));
-  for (i=0; i < 4; i++)
-    if( disktree->needswap ) SwapWord( 8, pabyRec+4+(8*i) );
-
-  memcpy( pabyRec+36, &node->numshapes, 4);
-  if( disktree->needswap ) SwapWord( 4, pabyRec+36 );
+  pabyRec = msSmallMalloc(sizeof(rectObj) + (3 * sizeof(ms_int32)) +
+                          (node->numshapes * sizeof(ms_int32)));
 
-  j = node->numshapes*sizeof(ms_int32);
-  memcpy( pabyRec+40, node->ids, j);
-  for (i=0; i<node->numshapes; i++)
-    if( disktree->needswap ) SwapWord( 4, pabyRec+40+(4*i));
+  memcpy(pabyRec, &offset, 4);
+  if (disktree->needswap)
+    SwapWord(4, pabyRec);
+
+  memcpy(pabyRec + 4, &node->rect, sizeof(rectObj));
+  for (i = 0; i < 4; i++)
+    if (disktree->needswap)
+      SwapWord(8, pabyRec + 4 + (8 * i));
+
+  memcpy(pabyRec + 36, &node->numshapes, 4);
+  if (disktree->needswap)
+    SwapWord(4, pabyRec + 36);
+
+  j = node->numshapes * sizeof(ms_int32);
+  memcpy(pabyRec + 40, node->ids, j);
+  for (i = 0; i < node->numshapes; i++)
+    if (disktree->needswap)
+      SwapWord(4, pabyRec + 40 + (4 * i));
+
+  memcpy(pabyRec + j + 40, &node->numsubnodes, 4);
+  if (disktree->needswap)
+    SwapWord(4, pabyRec + 40 + j);
 
-  memcpy( pabyRec+j+40, &node->numsubnodes, 4);
-  if( disktree->needswap ) SwapWord( 4, pabyRec+40+j );
+  fwrite(pabyRec, 44 + j, 1, disktree->fp);
+  free(pabyRec);
 
-  fwrite( pabyRec, 44+j, 1, disktree->fp);
-  free (pabyRec);
-
-  for(i=0; i<node->numsubnodes; i++ ) {
-    if(node->subnode[i])
+  for (i = 0; i < node->numsubnodes; i++) {
+    if (node->subnode[i])
       writeTreeNode(disktree, node->subnode[i]);
   }
 
-
   return;
-
 }
 
-int msWriteTree(treeObj *tree, char *filename, int B_order)
-{
-  char    signature[3] = "SQT";
-  char    version = 1;
-  char    reserved[3] = {0,0,0};
+int msWriteTree(treeObj *tree, char *filename, int B_order) {
+  char signature[3] = "SQT";
+  char version = 1;
+  char reserved[3] = {0, 0, 0};
   SHPTreeHandle disktree;
-  int   i;
-  char    mtBigEndian;
-  char    pabyBuf[32];
-  char    *pszBasename, *pszFullname;
-
+  int i;
+  char mtBigEndian;
+  char pabyBuf[32];
+  char *pszBasename, *pszFullname;
 
-  disktree = (SHPTreeHandle) malloc(sizeof(SHPTreeInfo));
+  disktree = (SHPTreeHandle)malloc(sizeof(SHPTreeInfo));
   MS_CHECK_ALLOC(disktree, sizeof(SHPTreeInfo), MS_FALSE);
 
   /* -------------------------------------------------------------------- */
   /*  Compute the base (layer) name.  If there is any extension     */
   /*  on the passed in filename we will strip it off.         */
   /* -------------------------------------------------------------------- */
-  pszBasename = (char *) msSmallMalloc(strlen(filename)+5);
-  strcpy( pszBasename, filename );
-  for( i = strlen(pszBasename)-1;
-       i > 0 && pszBasename[i] != '.' && pszBasename[i] != '/'
-       && pszBasename[i] != '\\';
-       i-- ) {}
+  pszBasename = (char *)msSmallMalloc(strlen(filename) + 5);
+  strcpy(pszBasename, filename);
+  for (i = strlen(pszBasename) - 1;
+       i > 0 && pszBasename[i] != '.' && pszBasename[i] != '/' &&
+       pszBasename[i] != '\\';
+       i--) {
+  }
 
-  if( pszBasename[i] == '.' )
+  if (pszBasename[i] == '.')
     pszBasename[i] = '\0';
 
   /* -------------------------------------------------------------------- */
   /*  Open the .shp and .shx files.  Note that files pulled from      */
   /*  a PC to Unix with upper case filenames won't work!        */
   /* -------------------------------------------------------------------- */
-  pszFullname = (char *) msSmallMalloc(strlen(pszBasename) + 5);
-  sprintf( pszFullname, "%s%s", pszBasename, MS_INDEX_EXTENSION);
+  pszFullname = (char *)msSmallMalloc(strlen(pszBasename) + 5);
+  sprintf(pszFullname, "%s%s", pszBasename, MS_INDEX_EXTENSION);
   disktree->fp = fopen(pszFullname, "wb");
 
   msFree(pszBasename); /* not needed */
   msFree(pszFullname);
 
-  if(!disktree->fp) {
+  if (!disktree->fp) {
     msFree(disktree);
     msSetError(MS_IOERR, NULL, "msWriteTree()");
-    return(MS_FALSE);
+    return (MS_FALSE);
   }
 
-
   /* for efficiency, trim the tree */
   msTreeTrim(tree);
 
@@ -780,68 +784,69 @@ int msWriteTree(treeObj *tree, char *fil
   /* -------------------------------------------------------------------- */
   i = 1;
   /* cppcheck-suppress knownConditionTrueFalse */
-  if( *((uchar *) &i) == 1 )
+  if (*((uchar *)&i) == 1)
     mtBigEndian = MS_FALSE;
   else
     mtBigEndian = MS_TRUE;
 
-  if( !(mtBigEndian ^ ( B_order == MS_LSB_ORDER || B_order == MS_NEW_LSB_ORDER )) )
+  if (!(mtBigEndian ^ (B_order == MS_LSB_ORDER || B_order == MS_NEW_LSB_ORDER)))
     disktree->needswap = 1;
   else
     disktree->needswap = 0;
 
-  if( B_order == MS_NATIVE_ORDER )
+  if (B_order == MS_NATIVE_ORDER)
     disktree->needswap = 0;
 
   /* write the header */
-  if ( B_order > 0 ) {
-    memcpy( pabyBuf, &signature, 3 );
-    memcpy (&disktree->signature, &signature, 3);
+  if (B_order > 0) {
+    memcpy(pabyBuf, &signature, 3);
+    memcpy(&disktree->signature, &signature, 3);
     pabyBuf[3] = B_order;
 
-    memcpy( pabyBuf+4, &version, 1);
-    memcpy( pabyBuf+5, &reserved, 3);
+    memcpy(pabyBuf + 4, &version, 1);
+    memcpy(pabyBuf + 5, &reserved, 3);
 
-    memcpy( &disktree->version, &version, 1);
-    memcpy( &disktree->flags, &reserved, 3);
+    memcpy(&disktree->version, &version, 1);
+    memcpy(&disktree->flags, &reserved, 3);
 
-    fwrite( pabyBuf, 8, 1, disktree->fp );
+    fwrite(pabyBuf, 8, 1, disktree->fp);
   }
 
-  memcpy( pabyBuf, &tree->numshapes, 4 );
-  if( disktree->needswap ) SwapWord( 4, pabyBuf );
+  memcpy(pabyBuf, &tree->numshapes, 4);
+  if (disktree->needswap)
+    SwapWord(4, pabyBuf);
 
-  memcpy( pabyBuf+4, &tree->maxdepth, 4 );
-  if( disktree->needswap ) SwapWord( 4, pabyBuf+4 );
+  memcpy(pabyBuf + 4, &tree->maxdepth, 4);
+  if (disktree->needswap)
+    SwapWord(4, pabyBuf + 4);
 
-  i = fwrite( pabyBuf, 8, 1, disktree->fp );
-  if( !i ) {
-    fprintf (stderr, "unable to write to index file ... exiting \n");
-    msSHPDiskTreeClose( disktree );
+  i = fwrite(pabyBuf, 8, 1, disktree->fp);
+  if (!i) {
+    fprintf(stderr, "unable to write to index file ... exiting \n");
+    msSHPDiskTreeClose(disktree);
     return (MS_FALSE);
   }
 
   writeTreeNode(disktree, tree->root);
 
-  msSHPDiskTreeClose( disktree );
+  msSHPDiskTreeClose(disktree);
 
-  return(MS_TRUE);
+  return (MS_TRUE);
 }
 
 /* Function to filter search results further against feature bboxes */
-void msFilterTreeSearch(shapefileObj *shp, ms_bitarray status, rectObj search_rect)
-{
+void msFilterTreeSearch(shapefileObj *shp, ms_bitarray status,
+                        rectObj search_rect) {
   int i;
   rectObj shape_rect;
 
   i = msGetNextBit(status, 0, shp->numshapes);
-  while(i >= 0) {
-    if(msSHPReadBounds(shp->hSHP, i, &shape_rect) == MS_SUCCESS) {
-      if(msRectOverlap(&shape_rect, &search_rect) != MS_TRUE) {
+  while (i >= 0) {
+    if (msSHPReadBounds(shp->hSHP, i, &shape_rect) == MS_SUCCESS) {
+      if (msRectOverlap(&shape_rect, &search_rect) != MS_TRUE) {
         msSetBit(status, i, 0);
       }
     }
-    i = msGetNextBit(status, i+1, shp->numshapes);
+    i = msGetNextBit(status, i + 1, shp->numshapes);
   }
-
 }
diff -pruN 8.0.1-5/maptree.h 8.0.2-1/maptree.h
--- 8.0.1-5/maptree.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/maptree.h	2024-06-11 20:41:34.000000000 +0000
@@ -34,40 +34,39 @@
 extern "C" {
 #endif
 
-  /* this can be 2 or 4 for binary or quad tree */
+/* this can be 2 or 4 for binary or quad tree */
 #define MAX_SUBNODES 4
 
-  typedef struct shape_tree_node {
-    /* area covered by this node */
-    rectObj rect;
-
-    /* list of shapes stored at this node. */
-    ms_int32 numshapes;
-    ms_int32 *ids;
-
-    int numsubnodes;
-    struct shape_tree_node *subnode[MAX_SUBNODES];
-  } treeNodeObj;
-
-  typedef struct {
-    ms_int32 numshapes;
-    ms_int32 maxdepth;
-    treeNodeObj *root;
-  } treeObj;
-
-
-  typedef struct {
-    FILE        *fp;
-    char        signature[3];
-    char  LSB_order;
-    char        needswap;
-    char  version;
-    char  flags[3];
-
-    ms_int32        nShapes;
-    ms_int32        nDepth;
-  } SHPTreeInfo;
-  typedef SHPTreeInfo * SHPTreeHandle;
+typedef struct shape_tree_node {
+  /* area covered by this node */
+  rectObj rect;
+
+  /* list of shapes stored at this node. */
+  ms_int32 numshapes;
+  ms_int32 *ids;
+
+  int numsubnodes;
+  struct shape_tree_node *subnode[MAX_SUBNODES];
+} treeNodeObj;
+
+typedef struct {
+  ms_int32 numshapes;
+  ms_int32 maxdepth;
+  treeNodeObj *root;
+} treeObj;
+
+typedef struct {
+  FILE *fp;
+  char signature[3];
+  char LSB_order;
+  char needswap;
+  char version;
+  char flags[3];
+
+  ms_int32 nShapes;
+  ms_int32 nDepth;
+} SHPTreeInfo;
+typedef SHPTreeInfo *SHPTreeHandle;
 
 #define MS_LSB_ORDER -1
 #define MS_MSB_ORDER -2
@@ -75,22 +74,23 @@ extern "C" {
 #define MS_NEW_LSB_ORDER 1
 #define MS_NEW_MSB_ORDER 2
 
+MS_DLL_EXPORT SHPTreeHandle msSHPDiskTreeOpen(const char *pszTree, int debug);
+MS_DLL_EXPORT void msSHPDiskTreeClose(SHPTreeHandle disktree);
+MS_DLL_EXPORT treeNodeObj *readTreeNode(SHPTreeHandle disktree);
+
+MS_DLL_EXPORT treeObj *msCreateTree(shapefileObj *shapefile, int maxdepth);
+MS_DLL_EXPORT void msTreeTrim(treeObj *tree);
+MS_DLL_EXPORT void msDestroyTree(treeObj *tree);
+
+MS_DLL_EXPORT ms_bitarray msSearchTree(const treeObj *tree, rectObj aoi);
+MS_DLL_EXPORT ms_bitarray msSearchDiskTree(const char *filename, rectObj aoi,
+                                           int debug, int numshapes);
 
-  MS_DLL_EXPORT SHPTreeHandle msSHPDiskTreeOpen(const char * pszTree, int debug);
-  MS_DLL_EXPORT void msSHPDiskTreeClose(SHPTreeHandle disktree);
-  MS_DLL_EXPORT treeNodeObj *readTreeNode( SHPTreeHandle disktree );
+MS_DLL_EXPORT treeObj *msReadTree(char *filename, int debug);
+MS_DLL_EXPORT int msWriteTree(treeObj *tree, char *filename, int LSB_order);
 
-  MS_DLL_EXPORT treeObj *msCreateTree(shapefileObj *shapefile, int maxdepth);
-  MS_DLL_EXPORT void msTreeTrim(treeObj *tree);
-  MS_DLL_EXPORT void msDestroyTree(treeObj *tree);
-
-  MS_DLL_EXPORT ms_bitarray msSearchTree(const treeObj *tree, rectObj aoi);
-  MS_DLL_EXPORT ms_bitarray msSearchDiskTree(const char *filename, rectObj aoi, int debug, int numshapes);
-
-  MS_DLL_EXPORT treeObj *msReadTree(char *filename, int debug);
-  MS_DLL_EXPORT int msWriteTree(treeObj *tree, char *filename, int LSB_order);
-
-  MS_DLL_EXPORT void msFilterTreeSearch(shapefileObj *shp, ms_bitarray status, rectObj search_rect);
+MS_DLL_EXPORT void msFilterTreeSearch(shapefileObj *shp, ms_bitarray status,
+                                      rectObj search_rect);
 
 #ifdef __cplusplus
 }
diff -pruN 8.0.1-5/mapunion.cpp 8.0.2-1/mapunion.cpp
--- 8.0.1-5/mapunion.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapunion.cpp	2024-06-11 20:41:34.000000000 +0000
@@ -33,34 +33,31 @@
 #include <assert.h>
 #include "mapserver.h"
 
-
-
-#define MSUNION_NUMITEMS        3
-#define MSUNION_SOURCELAYERNAME        "Union_SourceLayerName"
-#define MSUNION_SOURCELAYERNAMEINDEX   -100
-#define MSUNION_SOURCELAYERGROUP        "Union_SourceLayerGroup"
-#define MSUNION_SOURCELAYERGROUPINDEX   -101
-#define MSUNION_SOURCELAYERVISIBLE        "Union_SourceLayerVisible"
-#define MSUNION_SOURCELAYERVISIBLEINDEX   -102
+#define MSUNION_NUMITEMS 3
+#define MSUNION_SOURCELAYERNAME "Union_SourceLayerName"
+#define MSUNION_SOURCELAYERNAMEINDEX -100
+#define MSUNION_SOURCELAYERGROUP "Union_SourceLayerGroup"
+#define MSUNION_SOURCELAYERGROUPINDEX -101
+#define MSUNION_SOURCELAYERVISIBLE "Union_SourceLayerVisible"
+#define MSUNION_SOURCELAYERVISIBLEINDEX -102
 
 typedef struct {
-  int layerIndex;  /* current source layer index */
-  int classIndex;  /* current class index */
-  char* classText;   /* current class text (autostyle) */
-  int layerCount;  /* number of the source layers */
-  layerObj* layers; /* structure to the source layers */
-  int *status;     /* the layer status */
-  int *classgroup; /* current array of the valid classes */
-  int nclasses;  /* number of the valid classes */
-  reprojectionObj* reprojectorSrcLayerToLayer;
+  int layerIndex;   /* current source layer index */
+  int classIndex;   /* current class index */
+  char *classText;  /* current class text (autostyle) */
+  int layerCount;   /* number of the source layers */
+  layerObj *layers; /* structure to the source layers */
+  int *status;      /* the layer status */
+  int *classgroup;  /* current array of the valid classes */
+  int nclasses;     /* number of the valid classes */
+  reprojectionObj *reprojectorSrcLayerToLayer;
   int reprojectorCurSrcLayer;
 } msUnionLayerInfo;
 
 /* Close the the combined layer */
-int msUnionLayerClose(layerObj * const layer)
-{
+int msUnionLayerClose(layerObj *const layer) {
   int i;
-  msUnionLayerInfo* layerinfo = (msUnionLayerInfo*)layer->layerinfo;
+  msUnionLayerInfo *layerinfo = (msUnionLayerInfo *)layer->layerinfo;
 
   if (!layerinfo)
     return MS_SUCCESS;
@@ -70,7 +67,7 @@ int msUnionLayerClose(layerObj * const l
 
   msProjectDestroyReprojector(layerinfo->reprojectorSrcLayerToLayer);
   for (i = 0; i < layerinfo->layerCount; i++) {
-    layerObj* const srclayer = &layerinfo->layers[i];
+    layerObj *const srclayer = &layerinfo->layers[i];
     msLayerClose(srclayer);
     freeLayer(srclayer);
   }
@@ -84,62 +81,67 @@ int msUnionLayerClose(layerObj * const l
   return MS_SUCCESS;
 }
 
-int isScaleInRange(mapObj* map, layerObj * const layer)
-{
-  if(map->scaledenom > 0) {
+int isScaleInRange(mapObj *map, layerObj *const layer) {
+  if (map->scaledenom > 0) {
     int i;
     /* layer scale boundaries should be checked first */
-    if((layer->maxscaledenom > 0) && (map->scaledenom > layer->maxscaledenom))
+    if ((layer->maxscaledenom > 0) && (map->scaledenom > layer->maxscaledenom))
       return MS_FALSE;
 
-    if((layer->minscaledenom > 0) && (map->scaledenom <= layer->minscaledenom))
+    if ((layer->minscaledenom > 0) && (map->scaledenom <= layer->minscaledenom))
       return MS_FALSE;
 
     /* now check class scale boundaries (all layers *must* pass these tests) */
-    if(layer->numclasses > 0) {
-      for(i=0; i<layer->numclasses; i++) {
-        if((layer->_class[i]->maxscaledenom > 0) && (map->scaledenom > layer->_class[i]->maxscaledenom))
+    if (layer->numclasses > 0) {
+      for (i = 0; i < layer->numclasses; i++) {
+        if ((layer->_class[i]->maxscaledenom > 0) &&
+            (map->scaledenom > layer->_class[i]->maxscaledenom))
           continue; /* can skip this one, next class */
-        if((layer->_class[i]->minscaledenom > 0) && (map->scaledenom <= layer->_class[i]->minscaledenom))
+        if ((layer->_class[i]->minscaledenom > 0) &&
+            (map->scaledenom <= layer->_class[i]->minscaledenom))
           continue; /* can skip this one, next class */
 
         break; /* can't skip this class (or layer for that matter) */
       }
-      if(i == layer->numclasses)
+      if (i == layer->numclasses)
         return MS_FALSE;
-
     }
 
     if (layer->maxscaledenom <= 0 && layer->minscaledenom <= 0) {
-      if((layer->maxgeowidth > 0) && ((map->extent.maxx - map->extent.minx) > layer->maxgeowidth))
+      if ((layer->maxgeowidth > 0) &&
+          ((map->extent.maxx - map->extent.minx) > layer->maxgeowidth))
         return MS_FALSE;
 
-      if((layer->mingeowidth > 0) && ((map->extent.maxx - map->extent.minx) < layer->mingeowidth))
+      if ((layer->mingeowidth > 0) &&
+          ((map->extent.maxx - map->extent.minx) < layer->mingeowidth))
         return MS_FALSE;
     }
   }
   return MS_TRUE;
 }
 
-int msUnionLayerOpen(layerObj * const layer)
-{
+int msUnionLayerOpen(layerObj *const layer) {
   if (layer->layerinfo != NULL) {
-    return MS_SUCCESS;  /* Nothing to do... layer is already opened */
+    return MS_SUCCESS; /* Nothing to do... layer is already opened */
   }
 
   if (!layer->connection) {
-    msSetError(MS_MISCERR, "The CONNECTION option is not specified for layer: %s", "msUnionLayerOpen()", layer->name);
+    msSetError(MS_MISCERR,
+               "The CONNECTION option is not specified for layer: %s",
+               "msUnionLayerOpen()", layer->name);
     return MS_FAILURE;
   }
 
   if (!layer->map) {
-    msSetError(MS_MISCERR, "No map assigned to this layer: %s", "msUnionLayerOpen()", layer->name);
+    msSetError(MS_MISCERR, "No map assigned to this layer: %s",
+               "msUnionLayerOpen()", layer->name);
     return MS_FAILURE;
   }
 
-  mapObj* map = layer->map;
+  mapObj *map = layer->map;
 
-  msUnionLayerInfo* layerinfo =(msUnionLayerInfo*)calloc(1, sizeof(msUnionLayerInfo));
+  msUnionLayerInfo *layerinfo =
+      (msUnionLayerInfo *)calloc(1, sizeof(msUnionLayerInfo));
   MS_CHECK_ALLOC(layerinfo, sizeof(msUnionLayerInfo), MS_FAILURE);
 
   layer->layerinfo = layerinfo;
@@ -153,7 +155,7 @@ int msUnionLayerOpen(layerObj * const la
   layerinfo->classText = NULL;
   layerinfo->reprojectorCurSrcLayer = -1;
 
-  const char* pkey = msLayerGetProcessingKey(layer, "UNION_STATUS_CHECK");
+  const char *pkey = msLayerGetProcessingKey(layer, "UNION_STATUS_CHECK");
   const bool status_check = (pkey && strcasecmp(pkey, "true") == 0);
 
   pkey = msLayerGetProcessingKey(layer, "UNION_SCALE_CHECK");
@@ -164,34 +166,40 @@ int msUnionLayerOpen(layerObj * const la
   const auto layerNames = msStringSplit(layer->connection, ',');
 
   if (layerNames.empty()) {
-    msSetError(MS_MISCERR, "No source layers specified in layer: %s", "msUnionLayerOpen()", layer->name);
+    msSetError(MS_MISCERR, "No source layers specified in layer: %s",
+               "msUnionLayerOpen()", layer->name);
     msUnionLayerClose(layer);
     return MS_FAILURE;
   }
 
   const int layerCount = static_cast<int>(layerNames.size());
-  layerinfo->layers =(layerObj*)malloc(layerCount * sizeof(layerObj));
+  layerinfo->layers = (layerObj *)malloc(layerCount * sizeof(layerObj));
   MS_CHECK_ALLOC(layerinfo->layers, layerCount * sizeof(layerObj), MS_FAILURE);
 
-  layerinfo->status =(int*)malloc(layerCount * sizeof(int));
+  layerinfo->status = (int *)malloc(layerCount * sizeof(int));
   MS_CHECK_ALLOC(layerinfo->status, layerCount * sizeof(int), MS_FAILURE);
 
-  for(int i=0; i < layerCount; i++) {
-    const char* layerName = layerNames[i].c_str();
+  for (int i = 0; i < layerCount; i++) {
+    const char *layerName = layerNames[i].c_str();
     const int layerindex = msGetLayerIndex(map, layerName);
     if (layerindex >= 0 && layerindex < map->numlayers) {
-      const layerObj* const srclayer = map->layers[layerindex];
+      const layerObj *const srclayer = map->layers[layerindex];
 
       if (srclayer->type != layer->type) {
-        msSetError(MS_MISCERR, "The type of the source layer doesn't match with the union layer: %s", "msUnionLayerOpen()", srclayer->name);
+        msSetError(MS_MISCERR,
+                   "The type of the source layer doesn't match with the union "
+                   "layer: %s",
+                   "msUnionLayerOpen()", srclayer->name);
         msUnionLayerClose(layer);
         return MS_FAILURE;
       }
 
-      /* we need to create a new layer in order make the single pass query to work */
-      layerObj* dstlayer = &layerinfo->layers[i];
-      if(initLayer(dstlayer, map) == -1) {
-        msSetError(MS_MISCERR, "Cannot initialize source layer: %s", "msUnionLayerOpen()", srclayer->name);
+      /* we need to create a new layer in order make the single pass query to
+       * work */
+      layerObj *dstlayer = &layerinfo->layers[i];
+      if (initLayer(dstlayer, map) == -1) {
+        msSetError(MS_MISCERR, "Cannot initialize source layer: %s",
+                   "msUnionLayerOpen()", srclayer->name);
         msUnionLayerClose(layer);
         return MS_FAILURE;
       }
@@ -199,7 +207,8 @@ int msUnionLayerOpen(layerObj * const la
       ++layerinfo->layerCount;
 
       if (msCopyLayer(dstlayer, srclayer) != MS_SUCCESS) {
-        msSetError(MS_MISCERR, "Cannot copy source layer: %s", "msUnionLayerOpen()", srclayer->name);
+        msSetError(MS_MISCERR, "Cannot copy source layer: %s",
+                   "msUnionLayerOpen()", srclayer->name);
         msUnionLayerClose(layer);
         return MS_FAILURE;
       }
@@ -227,7 +236,8 @@ int msUnionLayerOpen(layerObj * const la
         return MS_FAILURE;
       }
     } else {
-      msSetError(MS_MISCERR, "Invalid layer: %s", "msUnionLayerOpen()", layerName);
+      msSetError(MS_MISCERR, "Invalid layer: %s", "msUnionLayerOpen()",
+                 layerName);
       msUnionLayerClose(layer);
       return MS_FAILURE;
     }
@@ -237,19 +247,17 @@ int msUnionLayerOpen(layerObj * const la
 }
 
 /* Return MS_TRUE if layer is open, MS_FALSE otherwise. */
-int msUnionLayerIsOpen(layerObj * const layer)
-{
+int msUnionLayerIsOpen(layerObj *const layer) {
   if (layer->layerinfo)
-    return(MS_TRUE);
+    return (MS_TRUE);
   else
-    return(MS_FALSE);
+    return (MS_FALSE);
 }
 
 /* Free the itemindexes array in a layer. */
-void msUnionLayerFreeItemInfo(layerObj * const layer)
-{
+void msUnionLayerFreeItemInfo(layerObj *const layer) {
   int i;
-  msUnionLayerInfo* layerinfo = (msUnionLayerInfo*)layer->layerinfo;
+  msUnionLayerInfo *layerinfo = (msUnionLayerInfo *)layer->layerinfo;
 
   if (!layerinfo || !layer->map)
     return;
@@ -260,9 +268,10 @@ void msUnionLayerFreeItemInfo(layerObj *
 
   for (i = 0; i < layerinfo->layerCount; i++) {
     msLayerFreeItemInfo(&(layerinfo->layers[i]));
-    if(layerinfo->layers[i].items) {
+    if (layerinfo->layers[i].items) {
       /* need to remove the source layer items */
-      msFreeCharArray(layerinfo->layers[i].items, layerinfo->layers[i].numitems);
+      msFreeCharArray(layerinfo->layers[i].items,
+                      layerinfo->layers[i].numitems);
       layerinfo->layers[i].items = NULL;
       layerinfo->layers[i].numitems = 0;
     }
@@ -270,30 +279,28 @@ void msUnionLayerFreeItemInfo(layerObj *
 }
 
 /* clean up expression tokens */
-void msUnionLayerFreeExpressionTokens(layerObj * const layer)
-{
-  int i,j;
+void msUnionLayerFreeExpressionTokens(layerObj *const layer) {
+  int i, j;
   msFreeExpressionTokens(&(layer->filter));
   msFreeExpressionTokens(&(layer->cluster.group));
   msFreeExpressionTokens(&(layer->cluster.filter));
-  for(i=0; i<layer->numclasses; i++) {
+  for (i = 0; i < layer->numclasses; i++) {
     msFreeExpressionTokens(&(layer->_class[i]->expression));
     msFreeExpressionTokens(&(layer->_class[i]->text));
-    for(j=0; j<layer->_class[i]->numstyles; j++)
+    for (j = 0; j < layer->_class[i]->numstyles; j++)
       msFreeExpressionTokens(&(layer->_class[i]->styles[j]->_geomtransform));
   }
 }
 
 /* allocate the iteminfo index array - same order as the item list */
-int msUnionLayerInitItemInfo(layerObj * const layer)
-{
+int msUnionLayerInitItemInfo(layerObj *const layer) {
   int i, numitems;
   int *itemindexes;
-  char* itemlist = NULL;
+  char *itemlist = NULL;
 
-  msUnionLayerInfo* layerinfo = (msUnionLayerInfo*)layer->layerinfo;
+  msUnionLayerInfo *layerinfo = (msUnionLayerInfo *)layer->layerinfo;
 
-  if(layer->numitems == 0) {
+  if (layer->numitems == 0) {
     return MS_SUCCESS;
   }
 
@@ -303,10 +310,10 @@ int msUnionLayerInitItemInfo(layerObj *
   /* Cleanup any previous item selection */
   msUnionLayerFreeItemInfo(layer);
 
-  layer->iteminfo = (int *) malloc(sizeof(int) * layer->numitems);
+  layer->iteminfo = (int *)malloc(sizeof(int) * layer->numitems);
   MS_CHECK_ALLOC(layer->iteminfo, sizeof(int) * layer->numitems, MS_FAILURE);
 
-  itemindexes = (int*)layer->iteminfo;
+  itemindexes = (int *)layer->iteminfo;
 
   /* check whether we require attributes from the source layers also */
   numitems = 0;
@@ -329,7 +336,7 @@ int msUnionLayerInitItemInfo(layerObj *
   }
 
   for (i = 0; i < layerinfo->layerCount; i++) {
-    layerObj* const srclayer = &(layerinfo->layers[i]);
+    layerObj *const srclayer = &(layerinfo->layers[i]);
 
     if (layerinfo->status[i] != MS_SUCCESS)
       continue; /* skip empty layers */
@@ -355,15 +362,14 @@ int msUnionLayerInitItemInfo(layerObj *
 }
 
 // cppcheck-suppress passedByValue
-int msUnionLayerWhichShapes(layerObj * const layer, rectObj rect, int isQuery)
-{
-  msUnionLayerInfo* layerinfo = (msUnionLayerInfo*)layer->layerinfo;
+int msUnionLayerWhichShapes(layerObj *const layer, rectObj rect, int isQuery) {
+  msUnionLayerInfo *layerinfo = (msUnionLayerInfo *)layer->layerinfo;
 
   if (!layerinfo || !layer->map)
     return MS_FAILURE;
 
   for (int i = 0; i < layerinfo->layerCount; i++) {
-    layerObj* const srclayer = &layerinfo->layers[i];
+    layerObj *const srclayer = &layerinfo->layers[i];
 
     if (layerinfo->status[i] != MS_SUCCESS)
       continue; /* skip empty layers */
@@ -379,8 +385,11 @@ int msUnionLayerWhichShapes(layerObj * c
 
     rectObj srcRect = rect;
 
-    if(srclayer->transform == MS_TRUE && srclayer->project && layer->transform == MS_TRUE && layer->project &&msProjectionsDiffer(&(srclayer->projection), &(layer->projection)))
-      msProjectRect(&layer->projection, &srclayer->projection, &srcRect); /* project the searchrect to source coords */
+    if (srclayer->transform == MS_TRUE && srclayer->project &&
+        layer->transform == MS_TRUE && layer->project &&
+        msProjectionsDiffer(&(srclayer->projection), &(layer->projection)))
+      msProjectRect(&layer->projection, &srclayer->projection,
+                    &srcRect); /* project the searchrect to source coords */
 
     layerinfo->status[i] = msLayerWhichShapes(srclayer, srcRect, isQuery);
     if (layerinfo->status[i] == MS_FAILURE)
@@ -388,7 +397,7 @@ int msUnionLayerWhichShapes(layerObj * c
   }
 
   layerinfo->layerIndex = 0;
-  layerObj* const srclayer = &layerinfo->layers[0];
+  layerObj *const srclayer = &layerinfo->layers[0];
 
   msFree(layerinfo->classgroup);
 
@@ -396,17 +405,20 @@ int msUnionLayerWhichShapes(layerObj * c
   layerinfo->nclasses = 0;
 
   if (srclayer->classgroup && srclayer->numclasses > 0)
-    layerinfo->classgroup = msAllocateValidClassGroups(srclayer, &layerinfo->nclasses);
+    layerinfo->classgroup =
+        msAllocateValidClassGroups(srclayer, &layerinfo->nclasses);
 
   return MS_SUCCESS;
 }
 
-static int BuildFeatureAttributes(layerObj * const layer, const layerObj* srclayer, shapeObj *shape)
-{
-  const int* const itemindexes = static_cast<const int*>(layer->iteminfo);
-
-  char** values = static_cast<char**>(msSmallMalloc(sizeof(char*) * (layer->numitems)));
-  MS_CHECK_ALLOC(values, layer->numitems * sizeof(char*), MS_FAILURE);;
+static int BuildFeatureAttributes(layerObj *const layer,
+                                  const layerObj *srclayer, shapeObj *shape) {
+  const int *const itemindexes = static_cast<const int *>(layer->iteminfo);
+
+  char **values =
+      static_cast<char **>(msSmallMalloc(sizeof(char *) * (layer->numitems)));
+  MS_CHECK_ALLOC(values, layer->numitems * sizeof(char *), MS_FAILURE);
+  ;
 
   for (int i = 0; i < layer->numitems; i++) {
     if (itemindexes[i] == MSUNION_SOURCELAYERNAMEINDEX)
@@ -436,61 +448,75 @@ static int BuildFeatureAttributes(layerO
 /* find the next shape with the appropriate shape type */
 /* also, load in the attribute data */
 /* MS_DONE => no more data */
-int msUnionLayerNextShape(layerObj * const layer, shapeObj *shape)
-{
-  msUnionLayerInfo* layerinfo = (msUnionLayerInfo*)layer->layerinfo;
+int msUnionLayerNextShape(layerObj *const layer, shapeObj *shape) {
+  msUnionLayerInfo *layerinfo = (msUnionLayerInfo *)layer->layerinfo;
 
   if (!layerinfo || !layer->map)
     return MS_FAILURE;
 
-  if (layerinfo->layerIndex < 0 || layerinfo->layerIndex >= layerinfo->layerCount)
+  if (layerinfo->layerIndex < 0 ||
+      layerinfo->layerIndex >= layerinfo->layerCount)
     return MS_FAILURE;
 
   int rv = MS_DONE;
 
   while (layerinfo->layerIndex < layerinfo->layerCount) {
-    layerObj* srclayer = &layerinfo->layers[layerinfo->layerIndex];
+    layerObj *srclayer = &layerinfo->layers[layerinfo->layerIndex];
     if (layerinfo->status[layerinfo->layerIndex] == MS_SUCCESS) {
-      while ((rv = srclayer->vtable->LayerNextShape(srclayer, shape)) == MS_SUCCESS) {
-        if(layer->styleitem) {
-          /* need to retrieve the source layer classindex if styleitem AUTO is set */
-          layerinfo->classIndex = msShapeGetClass(srclayer, layer->map, shape, layerinfo->classgroup, layerinfo->nclasses);
-          if(layerinfo->classIndex < 0 || layerinfo->classIndex >= srclayer->numclasses) {
+      while ((rv = srclayer->vtable->LayerNextShape(srclayer, shape)) ==
+             MS_SUCCESS) {
+        if (layer->styleitem) {
+          /* need to retrieve the source layer classindex if styleitem AUTO is
+           * set */
+          layerinfo->classIndex =
+              msShapeGetClass(srclayer, layer->map, shape,
+                              layerinfo->classgroup, layerinfo->nclasses);
+          if (layerinfo->classIndex < 0 ||
+              layerinfo->classIndex >= srclayer->numclasses) {
             /*  this shape is not visible, skip it */
             msFreeShape(shape);
             continue;
           }
-          if(srclayer->styleitem && strcasecmp(srclayer->styleitem, "AUTO") != 0) {
+          if (srclayer->styleitem &&
+              strcasecmp(srclayer->styleitem, "AUTO") != 0) {
             /* Generic feature style handling as per RFC-61 */
-            msLayerGetFeatureStyle(layer->map, srclayer, srclayer->_class[layerinfo->classIndex], shape);
+            msLayerGetFeatureStyle(layer->map, srclayer,
+                                   srclayer->_class[layerinfo->classIndex],
+                                   shape);
           }
           /* set up annotation */
           msFree(layerinfo->classText);
           layerinfo->classText = NULL;
-          if(srclayer->_class[layerinfo->classIndex]->numlabels > 0) {
+          if (srclayer->_class[layerinfo->classIndex]->numlabels > 0) {
             /* pull text from the first label only */
-            if(msGetLabelStatus(layer->map,layer,shape,srclayer->_class[layerinfo->classIndex]->labels[0]) == MS_ON) {
-              layerinfo->classText = msShapeGetLabelAnnotation(layer,shape,srclayer->_class[layerinfo->classIndex]->labels[0]);
+            if (msGetLabelStatus(
+                    layer->map, layer, shape,
+                    srclayer->_class[layerinfo->classIndex]->labels[0]) ==
+                MS_ON) {
+              layerinfo->classText = msShapeGetLabelAnnotation(
+                  layer, shape,
+                  srclayer->_class[layerinfo->classIndex]->labels[0]);
             }
           }
         }
 
         /* reproject to the target layer */
-        if( layerinfo->reprojectorCurSrcLayer != layerinfo->layerIndex )
-        {
-            msProjectDestroyReprojector(layerinfo->reprojectorSrcLayerToLayer);
-            layerinfo->reprojectorSrcLayerToLayer = NULL;
-            layerinfo->reprojectorCurSrcLayer = layerinfo->layerIndex;
-            if(srclayer->project && msProjectionsDiffer(&(srclayer->projection), &(layer->projection)))
-                layerinfo->reprojectorSrcLayerToLayer = msProjectCreateReprojector(&(srclayer->projection), &(layer->projection));
-            else
-                srclayer->project = MS_FALSE;
+        if (layerinfo->reprojectorCurSrcLayer != layerinfo->layerIndex) {
+          msProjectDestroyReprojector(layerinfo->reprojectorSrcLayerToLayer);
+          layerinfo->reprojectorSrcLayerToLayer = NULL;
+          layerinfo->reprojectorCurSrcLayer = layerinfo->layerIndex;
+          if (srclayer->project && msProjectionsDiffer(&(srclayer->projection),
+                                                       &(layer->projection)))
+            layerinfo->reprojectorSrcLayerToLayer = msProjectCreateReprojector(
+                &(srclayer->projection), &(layer->projection));
+          else
+            srclayer->project = MS_FALSE;
         }
-        if(layerinfo->reprojectorSrcLayerToLayer)
-            msProjectShapeEx(layerinfo->reprojectorSrcLayerToLayer, shape);
+        if (layerinfo->reprojectorSrcLayerToLayer)
+          msProjectShapeEx(layerinfo->reprojectorSrcLayerToLayer, shape);
 
         /* update the layer styles with the bound values */
-        if(msBindLayerToShape(srclayer, shape, MS_FALSE) != MS_SUCCESS)
+        if (msBindLayerToShape(srclayer, shape, MS_FALSE) != MS_SUCCESS)
           return MS_FAILURE;
 
         shape->tileindex = layerinfo->layerIndex;
@@ -500,11 +526,15 @@ int msUnionLayerNextShape(layerObj * con
           rv = BuildFeatureAttributes(layer, srclayer, shape);
 
         /* check the layer filter condition */
-        if(layer->filter.string != NULL && layer->numitems > 0 && layer->iteminfo) {
-          if (layer->filter.type == MS_EXPRESSION && layer->filter.tokens == NULL)
-            msTokenizeExpression(&(layer->filter), layer->items, &(layer->numitems));
+        if (layer->filter.string != NULL && layer->numitems > 0 &&
+            layer->iteminfo) {
+          if (layer->filter.type == MS_EXPRESSION &&
+              layer->filter.tokens == NULL)
+            msTokenizeExpression(&(layer->filter), layer->items,
+                                 &(layer->numitems));
 
-          if (!msEvalExpression(layer, shape, &(layer->filter), layer->filteritemindex)) {
+          if (!msEvalExpression(layer, shape, &(layer->filter),
+                                layer->filteritemindex)) {
             /* this shape is filtered */
             msFreeShape(shape);
             continue;
@@ -528,44 +558,47 @@ int msUnionLayerNextShape(layerObj * con
     layerinfo->nclasses = 0;
 
     if (srclayer->classgroup && srclayer->numclasses > 0)
-      layerinfo->classgroup = msAllocateValidClassGroups(srclayer, &layerinfo->nclasses);
+      layerinfo->classgroup =
+          msAllocateValidClassGroups(srclayer, &layerinfo->nclasses);
   }
 
   return rv;
 }
 
 /* Random access of the feature. */
-int msUnionLayerGetShape(layerObj * const layer, shapeObj *shape, resultObj *record)
-{
+int msUnionLayerGetShape(layerObj *const layer, shapeObj *shape,
+                         resultObj *record) {
   const long tile = record->tileindex;
-  msUnionLayerInfo* layerinfo = (msUnionLayerInfo*)layer->layerinfo;
+  msUnionLayerInfo *layerinfo = (msUnionLayerInfo *)layer->layerinfo;
 
   if (!layerinfo || !layer->map)
     return MS_FAILURE;
 
   if (tile < 0 || tile >= layerinfo->layerCount) {
-    msSetError(MS_MISCERR, "Invalid tile index: %s", "msUnionLayerGetShape()", layer->name);
+    msSetError(MS_MISCERR, "Invalid tile index: %s", "msUnionLayerGetShape()",
+               layer->name);
     return MS_FAILURE;
   }
 
-  layerObj* const srclayer = &layerinfo->layers[tile];
+  layerObj *const srclayer = &layerinfo->layers[tile];
   record->tileindex = 0;
   int rv = srclayer->vtable->LayerGetShape(srclayer, shape, record);
   record->tileindex = tile;
 
   if (rv == MS_SUCCESS) {
     /* reproject to the target layer */
-    if( layerinfo->reprojectorCurSrcLayer != tile )
-    {
-        msProjectDestroyReprojector(layerinfo->reprojectorSrcLayerToLayer);
-        layerinfo->reprojectorSrcLayerToLayer = NULL;
-        layerinfo->reprojectorCurSrcLayer = tile;
-        if(srclayer->project && msProjectionsDiffer(&(srclayer->projection), &(layer->projection)))
-            layerinfo->reprojectorSrcLayerToLayer = msProjectCreateReprojector(&(srclayer->projection), &(layer->projection));
-        else
-            srclayer->project = MS_FALSE;
+    if (layerinfo->reprojectorCurSrcLayer != tile) {
+      msProjectDestroyReprojector(layerinfo->reprojectorSrcLayerToLayer);
+      layerinfo->reprojectorSrcLayerToLayer = NULL;
+      layerinfo->reprojectorCurSrcLayer = tile;
+      if (srclayer->project &&
+          msProjectionsDiffer(&(srclayer->projection), &(layer->projection)))
+        layerinfo->reprojectorSrcLayerToLayer = msProjectCreateReprojector(
+            &(srclayer->projection), &(layer->projection));
+      else
+        srclayer->project = MS_FALSE;
     }
-    if(layerinfo->reprojectorSrcLayerToLayer)
+    if (layerinfo->reprojectorSrcLayerToLayer)
       msProjectShapeEx(layerinfo->reprojectorSrcLayerToLayer, shape);
 
     shape->tileindex = tile;
@@ -579,21 +612,20 @@ int msUnionLayerGetShape(layerObj * cons
 }
 
 /* Query for the items collection */
-int msUnionLayerGetItems(layerObj * const layer)
-{
+int msUnionLayerGetItems(layerObj *const layer) {
   /* we support certain built in attributes */
   layer->numitems = 2;
-  layer->items = static_cast<char**>(msSmallMalloc(sizeof(char*) * (layer->numitems)));
-  MS_CHECK_ALLOC(layer->items, layer->numitems * sizeof(char*), MS_FAILURE);
+  layer->items =
+      static_cast<char **>(msSmallMalloc(sizeof(char *) * (layer->numitems)));
+  MS_CHECK_ALLOC(layer->items, layer->numitems * sizeof(char *), MS_FAILURE);
   layer->items[0] = msStrdup(MSUNION_SOURCELAYERNAME);
   layer->items[1] = msStrdup(MSUNION_SOURCELAYERGROUP);
 
   return msUnionLayerInitItemInfo(layer);
 }
 
-int msUnionLayerGetNumFeatures(layerObj * const layer)
-{
-  msUnionLayerInfo* layerinfo = (msUnionLayerInfo*)layer->layerinfo;
+int msUnionLayerGetNumFeatures(layerObj *const layer) {
+  msUnionLayerInfo *layerinfo = (msUnionLayerInfo *)layer->layerinfo;
 
   if (!layerinfo || !layer->map)
     return 0;
@@ -612,28 +644,29 @@ int msUnionLayerGetNumFeatures(layerObj
   return numFeatures;
 }
 
-static int msUnionLayerGetAutoStyle(mapObj *map, layerObj * const layer, classObj *c, shapeObj* shape)
-{
-  msUnionLayerInfo* layerinfo = (msUnionLayerInfo*)layer->layerinfo;
+static int msUnionLayerGetAutoStyle(mapObj *map, layerObj *const layer,
+                                    classObj *c, shapeObj *shape) {
+  msUnionLayerInfo *layerinfo = (msUnionLayerInfo *)layer->layerinfo;
 
   if (!layerinfo || !layer->map)
     return MS_FAILURE;
 
   if (shape->tileindex < 0 || shape->tileindex >= layerinfo->layerCount) {
-    msSetError(MS_MISCERR, "Invalid tile index: %s", "msUnionLayerGetAutoStyle()", layer->name);
+    msSetError(MS_MISCERR, "Invalid tile index: %s",
+               "msUnionLayerGetAutoStyle()", layer->name);
     return MS_FAILURE;
   }
 
-  layerObj* const srclayer = &layerinfo->layers[shape->tileindex];
+  layerObj *const srclayer = &layerinfo->layers[shape->tileindex];
 
-  if(srclayer->styleitem && strcasecmp(srclayer->styleitem, "AUTO") == 0) {
+  if (srclayer->styleitem && strcasecmp(srclayer->styleitem, "AUTO") == 0) {
     const int tileindex = shape->tileindex;
     shape->tileindex = 0;
     int rv = msLayerGetAutoStyle(map, srclayer, c, shape);
     shape->tileindex = tileindex;
     return rv;
   } else {
-    const classObj* src = srclayer->_class[layerinfo->classIndex];
+    const classObj *src = srclayer->_class[layerinfo->classIndex];
     /* copy the style from the current class index */
     /* free any previous styles on the dst layer */
 
@@ -644,11 +677,12 @@ static int msUnionLayerGetAutoStyle(mapO
         return MS_FAILURE;
 
       if (msCopyStyle(c->styles[i], src->styles[i]) != MS_SUCCESS) {
-        msSetError(MS_MEMERR, "Failed to copy style.", "msUnionLayerGetAutoStyle()");
+        msSetError(MS_MEMERR, "Failed to copy style.",
+                   "msUnionLayerGetAutoStyle()");
         return MS_FAILURE;
       }
       /* remove the bindings on the style */
-      for(int j=0; j<MS_STYLE_BINDING_LENGTH; j++) {
+      for (int j = 0; j < MS_STYLE_BINDING_LENGTH; j++) {
         msFree(c->styles[i]->bindings[j].item);
         c->styles[i]->bindings[j].item = NULL;
       }
@@ -656,18 +690,20 @@ static int msUnionLayerGetAutoStyle(mapO
     }
 
     for (int i = 0; i < src->numlabels; i++) {
-      // RFC77 TODO: allocation need to be done, but is the right way (from mapcopy.c)?
+      // RFC77 TODO: allocation need to be done, but is the right way (from
+      // mapcopy.c)?
       if (msGrowClassLabels(c) == NULL)
         return MS_FAILURE;
       initLabel(c->labels[i]);
 
       if (msCopyLabel(c->labels[i], src->labels[i]) != MS_SUCCESS) {
-        msSetError(MS_MEMERR, "Failed to copy label.", "msUnionLayerGetAutoStyle()");
+        msSetError(MS_MEMERR, "Failed to copy label.",
+                   "msUnionLayerGetAutoStyle()");
         return MS_FAILURE;
       }
 
       /* remove the bindings on the label */
-      for(int j=0; j<MS_LABEL_BINDING_LENGTH; j++) {
+      for (int j = 0; j < MS_LABEL_BINDING_LENGTH; j++) {
         msFree(c->labels[i]->bindings[j].item);
         c->labels[i]->bindings[j].item = NULL;
       }
@@ -682,8 +718,7 @@ static int msUnionLayerGetAutoStyle(mapO
   return MS_SUCCESS;
 }
 
-int msUnionLayerCopyVirtualTable(layerVTableObj* vtable)
-{
+int msUnionLayerCopyVirtualTable(layerVTableObj *vtable) {
   vtable->LayerInitItemInfo = msUnionLayerInitItemInfo;
   vtable->LayerFreeItemInfo = msUnionLayerFreeItemInfo;
   vtable->LayerOpen = msUnionLayerOpen;
@@ -703,8 +738,7 @@ int msUnionLayerCopyVirtualTable(layerVT
   return MS_SUCCESS;
 }
 
-int msUnionLayerInitializeVirtualTable(layerObj * const layer)
-{
+int msUnionLayerInitializeVirtualTable(layerObj *const layer) {
   assert(layer != NULL);
   assert(layer->vtable != NULL);
 
diff -pruN 8.0.1-5/maputfgrid.cpp 8.0.2-1/maputfgrid.cpp
--- 8.0.1-5/maputfgrid.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/maputfgrid.cpp	2024-06-11 20:41:34.000000000 +0000
@@ -27,7 +27,6 @@
  * DEALINGS IN THE SOFTWARE.
  *****************************************************************************/
 
-
 #include "mapserver.h"
 #include "maputfgrid.h"
 #include "mapagg.h"
@@ -55,8 +54,7 @@ static const utfpix32 UTF_WATER = utfpix
 
 namespace {
 
-struct shapeData
-{
+struct shapeData {
   std::string datavalues{};
   std::string itemvalue{};
   band_type utfvalue = 0;
@@ -66,35 +64,30 @@ struct shapeData
 /*
  * UTFGrid specific polygon adaptor.
  */
-class polygon_adaptor_utf final: public polygon_adaptor
-{
+class polygon_adaptor_utf final : public polygon_adaptor {
 public:
-  polygon_adaptor_utf(shapeObj *shape,int utfres_in):
-      polygon_adaptor(shape),
-      utfresolution(utfres_in)
-  {
-  }
+  polygon_adaptor_utf(shapeObj *shape, int utfres_in)
+      : polygon_adaptor(shape), utfresolution(utfres_in) {}
 
-  unsigned vertex(double* x, double* y) override
-  {
-    if(m_point < m_pend) {
+  unsigned vertex(double *x, double *y) override {
+    if (m_point < m_pend) {
       bool first = m_point == m_line->point;
-      *x = m_point->x/utfresolution;
-      *y = m_point->y/utfresolution;
+      *x = m_point->x / utfresolution;
+      *y = m_point->y / utfresolution;
       m_point++;
       return first ? mapserver::path_cmd_move_to : mapserver::path_cmd_line_to;
     }
     *x = *y = 0.0;
-    if(!m_stop) {
+    if (!m_stop) {
 
       m_line++;
-      if(m_line>=m_lend) {
-        m_stop=true;
+      if (m_line >= m_lend) {
+        m_stop = true;
         return mapserver::path_cmd_end_poly;
       }
 
-      m_point=m_line->point;
-      m_pend=&(m_line->point[m_line->numpoints]);
+      m_point = m_line->point;
+      m_pend = &(m_line->point[m_line->numpoints]);
       return mapserver::path_cmd_end_poly;
     }
     return mapserver::path_cmd_stop;
@@ -107,33 +100,28 @@ private:
 /*
  * UTFGrid specific line adaptor.
  */
-class line_adaptor_utf final: public line_adaptor
-{
+class line_adaptor_utf final : public line_adaptor {
 public:
-  line_adaptor_utf(shapeObj *shape,int utfres_in):
-      line_adaptor(shape),
-      utfresolution(utfres_in)
-  {
-  }
+  line_adaptor_utf(shapeObj *shape, int utfres_in)
+      : line_adaptor(shape), utfresolution(utfres_in) {}
 
-  unsigned vertex(double* x, double* y) override
-  {
-    if(m_point < m_pend) {
+  unsigned vertex(double *x, double *y) override {
+    if (m_point < m_pend) {
       bool first = m_point == m_line->point;
-      *x = m_point->x/utfresolution;
-      *y = m_point->y/utfresolution;
+      *x = m_point->x / utfresolution;
+      *y = m_point->y / utfresolution;
       m_point++;
       return first ? mapserver::path_cmd_move_to : mapserver::path_cmd_line_to;
     }
     m_line++;
     *x = *y = 0.0;
-    if(m_line>=m_lend)
+    if (m_line >= m_lend)
       return mapserver::path_cmd_stop;
 
-    m_point=m_line->point;
-    m_pend=&(m_line->point[m_line->numpoints]);
+    m_point = m_line->point;
+    m_pend = &(m_line->point[m_line->numpoints]);
 
-    return vertex(x,y);
+    return vertex(x, y);
   }
 
 private:
@@ -165,23 +153,22 @@ public:
 
 } // namespace
 
-#define UTFGRID_RENDERER(image) (static_cast<UTFGridRenderer*>((image)->img.plugin))
+#define UTFGRID_RENDERER(image)                                                \
+  (static_cast<UTFGridRenderer *>((image)->img.plugin))
 
 /*
  * Encode to avoid unavailable char in the JSON
  */
-static
-unsigned int encodeForRendering(unsigned int toencode)
-{
+static unsigned int encodeForRendering(unsigned int toencode) {
   unsigned int encoded;
   encoded = toencode + 32;
   /* 34 => " */
-  if(encoded >= 34) {
-    encoded = encoded +1;
+  if (encoded >= 34) {
+    encoded = encoded + 1;
   }
   /* 92 => \ */
   if (encoded >= 92) {
-    encoded = encoded +1;
+    encoded = encoded + 1;
   }
   return encoded;
 }
@@ -189,18 +176,16 @@ unsigned int encodeForRendering(unsigned
 /*
  * Decode value to have the initial one
  */
-static
-unsigned int decodeRendered(unsigned int todecode)
-{
+static unsigned int decodeRendered(unsigned int todecode) {
   unsigned int decoded;
-  
-  if(todecode >= 92)
-    todecode --;
 
-  if(todecode >= 34)
-    todecode --;
+  if (todecode >= 92)
+    todecode--;
+
+  if (todecode >= 34)
+    todecode--;
 
-  decoded = todecode-32;
+  decoded = todecode - 32;
 
   return decoded;
 }
@@ -208,14 +193,12 @@ unsigned int decodeRendered(unsigned int
 /*
  * Add the shapeObj UTFDATA and UTFITEM to the lookup table.
  */
-static
-band_type addToTable(UTFGridRenderer *r, shapeObj *p)
-{
+static band_type addToTable(UTFGridRenderer *r, shapeObj *p) {
   /* Looks for duplicates. */
-  if(r->duplicates == false && r->useutfitem) {
+  if (r->duplicates == false && r->useutfitem) {
     const auto itemvalue = p->values[r->utflayer->utfitemindex];
-    for( const auto& tableItem: r->table ) {
-      if(tableItem.itemvalue == itemvalue) {
+    for (const auto &tableItem : r->table) {
+      if (tableItem.itemvalue == itemvalue) {
         /* Found a copy of the values in the table. */
         return tableItem.utfvalue;
       }
@@ -224,15 +207,15 @@ band_type addToTable(UTFGridRenderer *r,
 
   /* Data added to the table */
   shapeData table;
-  char* escaped = msEvalTextExpressionJSonEscape(&r->utflayer->utfdata, p);
+  char *escaped = msEvalTextExpressionJSonEscape(&r->utflayer->utfdata, p);
   table.datavalues = escaped ? escaped : "";
   msFree(escaped);
 
   /* If UTFITEM is set in the mapfile we add its value to the table */
-  if(r->useutfitem)
+  if (r->useutfitem)
     table.itemvalue = p->values[r->utflayer->utfitemindex];
 
-  table.serialid = static_cast<int>(r->table.size()+1);
+  table.serialid = static_cast<int>(r->table.size() + 1);
 
   /* Simple operation so we don't have unavailable char in the JSON */
   const auto utfvalue = encodeForRendering(table.serialid);
@@ -246,35 +229,38 @@ band_type addToTable(UTFGridRenderer *r,
 /*
  * Use AGG to render any path.
  */
-template<class vertex_source>
-static int utfgridRenderPath(imageObj *img, vertex_source &path)
-{
+template <class vertex_source>
+static int utfgridRenderPath(imageObj *img, vertex_source &path) {
   UTFGridRenderer *r = UTFGRID_RENDERER(img);
   r->m_rasterizer.reset();
   r->m_rasterizer.filling_rule(mapserver::fill_even_odd);
   r->m_rasterizer.add_path(path);
   r->m_renderer_scanline.color(utfitem(r->utfvalue));
-  mapserver::render_scanlines(r->m_rasterizer, r->sl_utf, r->m_renderer_scanline);
+  mapserver::render_scanlines(r->m_rasterizer, r->sl_utf,
+                              r->m_renderer_scanline);
   return MS_SUCCESS;
 }
 
 /*
  * Initialize the renderer, create buffer, allocate memory.
  */
-static
-imageObj *utfgridCreateImage(int width, int height, outputFormatObj *format, colorObj * /*bg*/)
-{
+static imageObj *utfgridCreateImage(int width, int height,
+                                    outputFormatObj *format,
+                                    colorObj * /*bg*/) {
   auto r = std::unique_ptr<UTFGridRenderer>(new UTFGridRenderer);
 
-  r->utfresolution = atof(msGetOutputFormatOption(format, "UTFRESOLUTION", "4"));
-  if(r->utfresolution < 1) {
-    msSetError(MS_MISCERR, "UTFRESOLUTION smaller that 1 in the mapfile.", "utfgridCreateImage()");
+  r->utfresolution =
+      atof(msGetOutputFormatOption(format, "UTFRESOLUTION", "4"));
+  if (r->utfresolution < 1) {
+    msSetError(MS_MISCERR, "UTFRESOLUTION smaller that 1 in the mapfile.",
+               "utfgridCreateImage()");
     return nullptr;
   }
-  r->duplicates = EQUAL("true", msGetOutputFormatOption(format, "DUPLICATES", "true"));
+  r->duplicates =
+      EQUAL("true", msGetOutputFormatOption(format, "DUPLICATES", "true"));
 
-  r->width = width/r->utfresolution;
-  r->height = height/r->utfresolution;
+  r->width = width / r->utfresolution;
+  r->height = height / r->utfresolution;
 
   r->buffer.resize(r->width * r->height);
 
@@ -286,7 +272,7 @@ imageObj *utfgridCreateImage(int width,
   r->m_renderer_base.clear(UTF_WATER);
   r->m_rasterizer.gamma(mapserver::gamma_none());
 
-  imageObj *image = (imageObj *) msSmallCalloc(1,sizeof(imageObj));
+  imageObj *image = (imageObj *)msSmallCalloc(1, sizeof(imageObj));
   image->img.plugin = r.release();
 
   return image;
@@ -295,9 +281,7 @@ imageObj *utfgridCreateImage(int width,
 /*
  * Free all the memory used by the renderer.
  */
-static
-int utfgridFreeImage(imageObj *img)
-{
+static int utfgridFreeImage(imageObj *img) {
   UTFGridRenderer *r = UTFGRID_RENDERER(img);
   delete r;
 
@@ -308,14 +292,13 @@ int utfgridFreeImage(imageObj *img)
 
 /*
  * Update a character in the utfgrid.
-*/
-static
-int utfgridUpdateChar(imageObj *img, band_type oldChar, band_type newChar)
-{
+ */
+static int utfgridUpdateChar(imageObj *img, band_type oldChar,
+                             band_type newChar) {
   UTFGridRenderer *r = UTFGRID_RENDERER(img);
 
-  for( auto& ch: r->buffer ) {
-    if(ch == oldChar) {
+  for (auto &ch : r->buffer) {
+    if (ch == oldChar) {
       ch = newChar;
     }
   }
@@ -326,40 +309,36 @@ int utfgridUpdateChar(imageObj *img, ban
 /*
  * Remove unnecessary data that didn't made it to the final grid.
  */
-static
-int utfgridCleanData(imageObj *img)
-{
+static int utfgridCleanData(imageObj *img) {
   UTFGridRenderer *r = UTFGRID_RENDERER(img);
 
   std::vector<bool> usedChar;
   usedChar.resize(r->table.size());
 
-  int itemFound=0;
+  int itemFound = 0;
 
-  for(const auto ch: r->buffer)
-  {
+  for (const auto ch : r->buffer) {
     const auto rendered = decodeRendered(ch);
-    if(rendered != 0 && !usedChar[rendered-1])
-    {
+    if (rendered != 0 && !usedChar[rendered - 1]) {
       itemFound++;
-      usedChar[rendered-1] = true;
+      usedChar[rendered - 1] = true;
     }
   }
 
   std::vector<shapeData> updatedData;
   updatedData.reserve(itemFound);
 
-  for(const auto& tableItem: r->table) {
-    if(usedChar[decodeRendered(tableItem.utfvalue)-1]){
-        updatedData.emplace_back(tableItem);
-        auto& newData = updatedData.back();
+  for (const auto &tableItem : r->table) {
+    if (usedChar[decodeRendered(tableItem.utfvalue) - 1]) {
+      updatedData.emplace_back(tableItem);
+      auto &newData = updatedData.back();
 
-        newData.serialid=static_cast<int>(updatedData.size());
+      newData.serialid = static_cast<int>(updatedData.size());
 
-        const band_type utfvalue=encodeForRendering(newData.serialid);
+      const band_type utfvalue = encodeForRendering(newData.serialid);
 
-        utfgridUpdateChar(img,newData.utfvalue,utfvalue);
-        newData.utfvalue = utfvalue;
+      utfgridUpdateChar(img, newData.utfvalue, utfvalue);
+      newData.utfvalue = utfvalue;
     }
   }
 
@@ -371,90 +350,87 @@ int utfgridCleanData(imageObj *img)
 /*
  * Print the renderer data as JSON.
  */
-static
-int utfgridSaveImage(imageObj *img, mapObj * /*map*/, FILE *fp, outputFormatObj * /*format*/)
-{
+static int utfgridSaveImage(imageObj *img, mapObj * /*map*/, FILE *fp,
+                            outputFormatObj * /*format*/) {
   utfgridCleanData(img);
 
   const UTFGridRenderer *renderer = UTFGRID_RENDERER(img);
 
-  if(renderer->layerwatch>1)
+  if (renderer->layerwatch > 1)
     return MS_FAILURE;
 
   const int imgheight = renderer->height;
   const int imgwidth = renderer->width;
 
-  msIO_fprintf(fp,"{\"grid\":[");
+  msIO_fprintf(fp, "{\"grid\":[");
 
   /* Print the buffer */
   std::vector<wchar_t> string;
-  string.resize(imgwidth+1);
-  for(int row=0; row<imgheight; row++) {
+  string.resize(imgwidth + 1);
+  for (int row = 0; row < imgheight; row++) {
 
     /* Need a comma between each line but JSON must not start with a comma. */
-    if(row!=0)
-      msIO_fprintf(fp,",");
-    msIO_fprintf(fp,"\"");
-    for(int col=0; col<imgwidth; col++) {
+    if (row != 0)
+      msIO_fprintf(fp, ",");
+    msIO_fprintf(fp, "\"");
+    for (int col = 0; col < imgwidth; col++) {
       /* Get the data from buffer. */
-      band_type pixelid = renderer->buffer[(row*imgwidth)+col];
+      band_type pixelid = renderer->buffer[(row * imgwidth) + col];
       string[col] = pixelid;
     }
 
     /* Conversion to UTF-8 encoding */
 #if defined(_WIN32) && !defined(__CYGWIN__)
-	const char* encoding = "UCS-2LE";
+    const char *encoding = "UCS-2LE";
 #else
-	const char* encoding = "UCS-4LE";
+    const char *encoding = "UCS-4LE";
 #endif
 
-    char* utf8 = msConvertWideStringToUTF8(string.data(), encoding);
-    msIO_fprintf(fp,"%s", utf8);
+    char *utf8 = msConvertWideStringToUTF8(string.data(), encoding);
+    msIO_fprintf(fp, "%s", utf8);
     msFree(utf8);
-    msIO_fprintf(fp,"\"");
+    msIO_fprintf(fp, "\"");
   }
 
-  msIO_fprintf(fp,"],\"keys\":[\"\"");
+  msIO_fprintf(fp, "],\"keys\":[\"\"");
 
   /* Print the specified key */
-  for(const auto& table: renderer->table) {
-      msIO_fprintf(fp,",");
+  for (const auto &table : renderer->table) {
+    msIO_fprintf(fp, ",");
 
-    if(renderer->useutfitem)
-    {
-      char* pszEscaped = msEscapeJSonString(table.itemvalue.c_str());
-      msIO_fprintf(fp,"\"%s\"", pszEscaped);
+    if (renderer->useutfitem) {
+      char *pszEscaped = msEscapeJSonString(table.itemvalue.c_str());
+      msIO_fprintf(fp, "\"%s\"", pszEscaped);
       msFree(pszEscaped);
     }
     /* If no UTFITEM specified use the serial ID as the key */
     else
-      msIO_fprintf(fp,"\"%i\"", table.serialid);
+      msIO_fprintf(fp, "\"%i\"", table.serialid);
   }
 
-  msIO_fprintf(fp,"],\"data\":{");
+  msIO_fprintf(fp, "],\"data\":{");
 
   /* Print the data */
-  if(renderer->useutfdata) {
+  if (renderer->useutfdata) {
     bool first = true;
-    for(const auto& table: renderer->table) {
-      if(!first)
-        msIO_fprintf(fp,",");
+    for (const auto &table : renderer->table) {
+      if (!first)
+        msIO_fprintf(fp, ",");
       first = false;
 
-      if(renderer->useutfitem)
-      {
-        char* pszEscaped = msEscapeJSonString(table.itemvalue.c_str());
-        msIO_fprintf(fp,"\"%s\":", pszEscaped);
+      if (renderer->useutfitem) {
+        char *pszEscaped = msEscapeJSonString(table.itemvalue.c_str());
+        msIO_fprintf(fp, "\"%s\":", pszEscaped);
         msFree(pszEscaped);
       }
       /* If no UTFITEM specified use the serial ID as the key */
       else
-        msIO_fprintf(fp,"\"%i\":", table.serialid);
+        msIO_fprintf(fp, "\"%i\":", table.serialid);
 
-      msIO_fprintf(fp,"%s", table.datavalues.c_str());
+      msIO_fprintf(fp, "%s", table.datavalues.c_str());
     }
   }
-  msIO_fprintf(fp,"}}");
+  msIO_fprintf(fp, "}}");
 
   return MS_SUCCESS;
 }
@@ -462,34 +438,36 @@ int utfgridSaveImage(imageObj *img, mapO
 /*
  * Starts a layer for UTFGrid renderer.
  */
-static
-int utfgridStartLayer(imageObj *img, mapObj * /*map*/, layerObj *layer)
-{
+static int utfgridStartLayer(imageObj *img, mapObj * /*map*/, layerObj *layer) {
   UTFGridRenderer *r = UTFGRID_RENDERER(img);
 
   /* Look if the layer uses the UTFGrid output format */
-  if(layer->utfdata.string!=0) {
+  if (layer->utfdata.string != 0) {
     r->useutfdata = true;
   }
 
-    /* layerwatch is set to 1 on first layer treated. Doesn't allow multiple layers. */
-    if(!r->layerwatch) {
-      r->layerwatch++;
-
-      r->renderlayer = true;
-      r->utflayer = layer;
-      layer->refcount++;
-
-      /* Verify if renderer needs to use UTFITEM */
-      if(r->utflayer->utfitem)
-        r->useutfitem = true;
-    }
-    /* If multiple layers, send error */
-    else {
-      r->layerwatch++;
-      msSetError(MS_MISCERR, "MapServer does not support multiple UTFGrid layers rendering simultaneously.", "utfgridStartLayer()");
-      return MS_FAILURE;
-    }
+  /* layerwatch is set to 1 on first layer treated. Doesn't allow multiple
+   * layers. */
+  if (!r->layerwatch) {
+    r->layerwatch++;
+
+    r->renderlayer = true;
+    r->utflayer = layer;
+    layer->refcount++;
+
+    /* Verify if renderer needs to use UTFITEM */
+    if (r->utflayer->utfitem)
+      r->useutfitem = true;
+  }
+  /* If multiple layers, send error */
+  else {
+    r->layerwatch++;
+    msSetError(MS_MISCERR,
+               "MapServer does not support multiple UTFGrid layers rendering "
+               "simultaneously.",
+               "utfgridStartLayer()");
+    return MS_FAILURE;
+  }
 
   return MS_SUCCESS;
 }
@@ -497,13 +475,11 @@ int utfgridStartLayer(imageObj *img, map
 /*
  * Tell renderer the layer is done.
  */
-static
-int utfgridEndLayer(imageObj *img, mapObj * /*map*/, layerObj *layer)
-{
+static int utfgridEndLayer(imageObj *img, mapObj * /*map*/, layerObj *layer) {
   UTFGridRenderer *r = UTFGRID_RENDERER(img);
 
   /* Look if the layer was rendered, if it was then turn off rendering. */
-  if(r->renderlayer) {
+  if (r->renderlayer) {
     r->utflayer = NULL;
     layer->refcount--;
     r->renderlayer = false;
@@ -513,14 +489,13 @@ int utfgridEndLayer(imageObj *img, mapOb
 }
 
 /*
- * Do the table operations on the shapes. Allow multiple types of data to be rendered.
+ * Do the table operations on the shapes. Allow multiple types of data to be
+ * rendered.
  */
-static
-int utfgridStartShape(imageObj *img, shapeObj *shape)
-{
+static int utfgridStartShape(imageObj *img, shapeObj *shape) {
   UTFGridRenderer *r = UTFGRID_RENDERER(img);
 
-  if(!r->renderlayer)
+  if (!r->renderlayer)
     return MS_FAILURE;
 
   /* Table operations */
@@ -532,9 +507,7 @@ int utfgridStartShape(imageObj *img, sha
 /*
  * Tells the renderer that the shape's rendering is done.
  */
-static
-int utfgridEndShape(imageObj *img, shapeObj *)
-{
+static int utfgridEndShape(imageObj *img, shapeObj *) {
   UTFGridRenderer *r = UTFGRID_RENDERER(img);
 
   r->utfvalue = 0;
@@ -544,13 +517,12 @@ int utfgridEndShape(imageObj *img, shape
 /*
  * Function that renders polygons into UTFGrid.
  */
-static
-int utfgridRenderPolygon(imageObj *img, shapeObj *polygonshape, colorObj *)
-{
+static int utfgridRenderPolygon(imageObj *img, shapeObj *polygonshape,
+                                colorObj *) {
   const UTFGridRenderer *r = UTFGRID_RENDERER(img);
 
   /* utfvalue is set to 0 if the shape isn't in the table. */
-  if(r->utfvalue == 0) {
+  if (r->utfvalue == 0) {
     return MS_FAILURE;
   }
 
@@ -562,16 +534,15 @@ int utfgridRenderPolygon(imageObj *img,
 }
 
 /*
- * Function that renders lines into UTFGrid. Starts by looking if the line is a polygon
- * outline, draw it if it's not.
+ * Function that renders lines into UTFGrid. Starts by looking if the line is a
+ * polygon outline, draw it if it's not.
  */
-static
-int utfgridRenderLine(imageObj *img, shapeObj *lineshape, strokeStyleObj *linestyle)
-{
+static int utfgridRenderLine(imageObj *img, shapeObj *lineshape,
+                             strokeStyleObj *linestyle) {
   UTFGridRenderer *r = UTFGRID_RENDERER(img);
 
   /* utfvalue is set to 0 if the shape isn't in the table. */
-  if(r->utfvalue == 0) {
+  if (r->utfvalue == 0) {
     return MS_SUCCESS;
     /* If we dont get a caracter to draw we just skip execution
      * instead of failing
@@ -581,12 +552,12 @@ int utfgridRenderLine(imageObj *img, sha
   /* Render the line */
   line_adaptor_utf lines(lineshape, r->utfresolution);
 
-  if(!r->stroke) {
+  if (!r->stroke) {
     r->stroke.reset(new mapserver::conv_stroke<line_adaptor_utf>(lines));
   } else {
     r->stroke->attach(lines);
   }
-  r->stroke->width(linestyle->width/r->utfresolution);
+  r->stroke->width(linestyle->width / r->utfresolution);
   utfgridRenderPath(img, *r->stroke);
 
   return MS_SUCCESS;
@@ -595,15 +566,14 @@ int utfgridRenderLine(imageObj *img, sha
 /*
  * Function that render vector type symbols into UTFGrid.
  */
-static
-int utfgridRenderVectorSymbol(imageObj *img, double x, double y, symbolObj *symbol, symbolStyleObj * style)
-{
+static int utfgridRenderVectorSymbol(imageObj *img, double x, double y,
+                                     symbolObj *symbol, symbolStyleObj *style) {
   const UTFGridRenderer *r = UTFGRID_RENDERER(img);
   double ox = symbol->sizex * 0.5;
   double oy = symbol->sizey * 0.5;
 
   /* utfvalue is set to 0 if the shape isn't in the table. */
-  if(r->utfvalue == 0) {
+  if (r->utfvalue == 0) {
     return MS_FAILURE;
   }
 
@@ -612,10 +582,11 @@ int utfgridRenderVectorSymbol(imageObj *
 
   /* Transformation to the right size/scale. */
   mapserver::trans_affine mtx;
-  mtx *= mapserver::trans_affine_translation(-ox,-oy);
-  mtx *= mapserver::trans_affine_scaling(style->scale/r->utfresolution);
+  mtx *= mapserver::trans_affine_translation(-ox, -oy);
+  mtx *= mapserver::trans_affine_scaling(style->scale / r->utfresolution);
   mtx *= mapserver::trans_affine_rotation(-style->rotation);
-  mtx *= mapserver::trans_affine_translation(x/r->utfresolution, y/r->utfresolution);
+  mtx *= mapserver::trans_affine_translation(x / r->utfresolution,
+                                             y / r->utfresolution);
   path.transform(mtx);
 
   /* Rendering the symbol. */
@@ -627,26 +598,25 @@ int utfgridRenderVectorSymbol(imageObj *
 /*
  * Function that renders Pixmap type symbols into UTFGrid.
  */
-static
-int utfgridRenderPixmapSymbol(imageObj *img, double x, double y, symbolObj *symbol, symbolStyleObj * style)
-{
+static int utfgridRenderPixmapSymbol(imageObj *img, double x, double y,
+                                     symbolObj *symbol, symbolStyleObj *style) {
   const UTFGridRenderer *r = UTFGRID_RENDERER(img);
   rasterBufferObj *pixmap = symbol->pixmap_buffer;
 
   /* utfvalue is set to 0 if the shape isn't in the table. */
-  if(r->utfvalue == 0) {
+  if (r->utfvalue == 0) {
     return MS_FAILURE;
   }
 
   /* Pathing the symbol BBox */
   mapserver::path_storage pixmap_bbox;
   double w, h;
-  w = pixmap->width*style->scale/(2.0);
-  h= pixmap->height*style->scale/(2.0);
-  pixmap_bbox.move_to((x-w)/r->utfresolution,(y-h)/r->utfresolution);
-  pixmap_bbox.line_to((x+w)/r->utfresolution,(y-h)/r->utfresolution);
-  pixmap_bbox.line_to((x+w)/r->utfresolution,(y+h)/r->utfresolution);
-  pixmap_bbox.line_to((x-w)/r->utfresolution,(y+h)/r->utfresolution);
+  w = pixmap->width * style->scale / (2.0);
+  h = pixmap->height * style->scale / (2.0);
+  pixmap_bbox.move_to((x - w) / r->utfresolution, (y - h) / r->utfresolution);
+  pixmap_bbox.line_to((x + w) / r->utfresolution, (y - h) / r->utfresolution);
+  pixmap_bbox.line_to((x + w) / r->utfresolution, (y + h) / r->utfresolution);
+  pixmap_bbox.line_to((x - w) / r->utfresolution, (y + h) / r->utfresolution);
 
   /* Rendering the symbol */
   utfgridRenderPath(img, pixmap_bbox);
@@ -657,27 +627,32 @@ int utfgridRenderPixmapSymbol(imageObj *
 /*
  * Function that render ellipse type symbols into UTFGrid.
  */
-static
-int utfgridRenderEllipseSymbol(imageObj *img, double x, double y, symbolObj *symbol, symbolStyleObj * style)
-{
+static int utfgridRenderEllipseSymbol(imageObj *img, double x, double y,
+                                      symbolObj *symbol,
+                                      symbolStyleObj *style) {
   const UTFGridRenderer *r = UTFGRID_RENDERER(img);
 
   /* utfvalue is set to 0 if the shape isn't in the table. */
-  if(r->utfvalue == 0) {
+  if (r->utfvalue == 0) {
     return MS_FAILURE;
   }
 
   /* Pathing the symbol. */
   mapserver::path_storage path;
-  mapserver::ellipse ellipse(x/r->utfresolution,y/r->utfresolution,symbol->sizex*style->scale/2/r->utfresolution,symbol->sizey*style->scale/2/r->utfresolution);
+  mapserver::ellipse ellipse(
+      x / r->utfresolution, y / r->utfresolution,
+      symbol->sizex * style->scale / 2 / r->utfresolution,
+      symbol->sizey * style->scale / 2 / r->utfresolution);
   path.concat_path(ellipse);
 
   /* Rotation if necessary. */
-  if( style->rotation != 0) {
+  if (style->rotation != 0) {
     mapserver::trans_affine mtx;
-    mtx *= mapserver::trans_affine_translation(-x/r->utfresolution,-y/r->utfresolution);
+    mtx *= mapserver::trans_affine_translation(-x / r->utfresolution,
+                                               -y / r->utfresolution);
     mtx *= mapserver::trans_affine_rotation(-style->rotation);
-    mtx *= mapserver::trans_affine_translation(x/r->utfresolution,y/r->utfresolution);
+    mtx *= mapserver::trans_affine_translation(x / r->utfresolution,
+                                               y / r->utfresolution);
     path.transform(mtx);
   }
 
@@ -687,8 +662,9 @@ int utfgridRenderEllipseSymbol(imageObj
   return MS_SUCCESS;
 }
 
-static
-int utfgridRenderGlyphs(imageObj *img, const textSymbolObj *ts, colorObj * /*c*/, colorObj * /*oc*/, int /*ow*/, int isMarker) {
+static int utfgridRenderGlyphs(imageObj *img, const textSymbolObj *ts,
+                               colorObj * /*c*/, colorObj * /*oc*/, int /*ow*/,
+                               int isMarker) {
 
   const textPathObj *tp = ts->textpath;
   const UTFGridRenderer *r = UTFGRID_RENDERER(img);
@@ -696,37 +672,39 @@ int utfgridRenderGlyphs(imageObj *img, c
   /* If it's not a marker then it's a label or other thing and we dont
    *  want to draw it on the map
    */
-  if(!isMarker) {
-    return MS_SUCCESS; //Stop the rendering with no errors
+  if (!isMarker) {
+    return MS_SUCCESS; // Stop the rendering with no errors
   }
 
   /* utfvalue is set to 0 if the shape isn't in the table. */
-  if(r->utfvalue == 0) {
-    return MS_SUCCESS; //Stop the rendering with no errors
+  if (r->utfvalue == 0) {
+    return MS_SUCCESS; // Stop the rendering with no errors
   }
 
   /* Pathing the symbol BBox */
   mapserver::path_storage box;
   double size, x, y;
-  
-  size = tp->glyph_size;;
+
+  size = tp->glyph_size;
+  ;
   x = tp->glyphs->pnt.x;
   y = tp->glyphs->pnt.y;
-  
-  box.move_to((x)/r->utfresolution,(y)/r->utfresolution);
-  box.line_to((x+size)/r->utfresolution,(y)/r->utfresolution);
-  box.line_to((x+size)/r->utfresolution,(y-size)/r->utfresolution);
-  box.line_to((x)/r->utfresolution,(y-size)/r->utfresolution);
 
-     /* Rotation if necessary. */
-  if( tp->glyphs->rot != 0) {
+  box.move_to((x) / r->utfresolution, (y) / r->utfresolution);
+  box.line_to((x + size) / r->utfresolution, (y) / r->utfresolution);
+  box.line_to((x + size) / r->utfresolution, (y - size) / r->utfresolution);
+  box.line_to((x) / r->utfresolution, (y - size) / r->utfresolution);
+
+  /* Rotation if necessary. */
+  if (tp->glyphs->rot != 0) {
     mapserver::trans_affine mtx;
-    mtx *= mapserver::trans_affine_translation(-x/r->utfresolution,-y/r->utfresolution);
+    mtx *= mapserver::trans_affine_translation(-x / r->utfresolution,
+                                               -y / r->utfresolution);
     mtx *= mapserver::trans_affine_rotation(-tp->glyphs->rot);
-    mtx *= mapserver::trans_affine_translation(x/r->utfresolution,y/r->utfresolution);
+    mtx *= mapserver::trans_affine_translation(x / r->utfresolution,
+                                               y / r->utfresolution);
     box.transform(mtx);
-  } 
-
+  }
 
   /* Rendering the symbol */
   utfgridRenderPath(img, box);
@@ -734,17 +712,12 @@ int utfgridRenderGlyphs(imageObj *img, c
   return MS_SUCCESS;
 }
 
-static
-int utfgridFreeSymbol(symbolObj *)
-{
-  return MS_SUCCESS;
-}
+static int utfgridFreeSymbol(symbolObj *) { return MS_SUCCESS; }
 
 /*
  * Add the necessary functions for UTFGrid to the renderer VTable.
  */
-int msPopulateRendererVTableUTFGrid( rendererVTableObj *renderer )
-{
+int msPopulateRendererVTableUTFGrid(rendererVTableObj *renderer) {
   renderer->default_transform_mode = MS_TRANSFORM_SIMPLIFY;
 
   renderer->createImage = &utfgridCreateImage;
diff -pruN 8.0.1-5/maputfgrid.h 8.0.2-1/maputfgrid.h
--- 8.0.1-5/maputfgrid.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/maputfgrid.h	2024-06-11 20:41:34.000000000 +0000
@@ -35,216 +35,164 @@
  */
 
 //==================================================================utfpix32
-struct utfpix32
-{
+struct utfpix32 {
   typedef mapserver::int32u value_type;
   typedef mapserver::int64u calc_type;
-  typedef mapserver::int64  long_type;
+  typedef mapserver::int64 long_type;
 
   typedef utfpix32 self_type;
 
   value_type v;
 
   //--------------------------------------------------------------------
-  utfpix32(): v(0) {}
+  utfpix32() : v(0) {}
 
   //--------------------------------------------------------------------
-  explicit utfpix32(unsigned v_) :
-    v(mapserver::int32u(v_)) {}
+  explicit utfpix32(unsigned v_) : v(mapserver::int32u(v_)) {}
 
   //--------------------------------------------------------------------
-  utfpix32(const self_type& c) :
-    v(c.v) {}
+  utfpix32(const self_type &c) : v(c.v) {}
 
   //--------------------------------------------------------------------
-  utfpix32& operator= (const self_type&) = default;
+  utfpix32 &operator=(const self_type &) = default;
 
   //--------------------------------------------------------------------
-  void clear()
-  {
-    v = 0;
-  }
+  void clear() { v = 0; }
 
   //--------------------------------------------------------------------
-  AGG_INLINE void add(const self_type& c, unsigned /*cover*/)
-  {
-    *this = c;
-  }
+  AGG_INLINE void add(const self_type &c, unsigned /*cover*/) { *this = c; }
 };
 
 //=================================================pixfmt_utf
-template<class ColorT, class RenBuf, unsigned Step=1, unsigned Offset=0>
-class pixfmt_utf
-{
+template <class ColorT, class RenBuf, unsigned Step = 1, unsigned Offset = 0>
+class pixfmt_utf {
 public:
-  typedef RenBuf   rbuf_type;
+  typedef RenBuf rbuf_type;
   typedef typename rbuf_type::row_data row_data;
-  typedef ColorT                            color_type;
-  typedef typename color_type::value_type   value_type;
-  typedef typename color_type::calc_type    calc_type;
-  enum base_scale_e
-  {
-    pix_width  = sizeof(value_type),
-    pix_step   = Step,
+  typedef ColorT color_type;
+  typedef typename color_type::value_type value_type;
+  typedef typename color_type::calc_type calc_type;
+  enum base_scale_e {
+    pix_width = sizeof(value_type),
+    pix_step = Step,
     pix_offset = Offset
   };
 
 private:
   //--------------------------------------------------------------------
-  static AGG_INLINE void copy_or_blend_pix(value_type* p, 
-                                           const color_type& c, 
-                                           unsigned cover)
-  {
-      *p = c.v;
+  static AGG_INLINE void copy_or_blend_pix(value_type *p, const color_type &c,
+                                           unsigned cover) {
+    *p = c.v;
   }
 
-  static AGG_INLINE void copy_or_blend_pix(value_type* p, 
-                                           const color_type& c)
-  {
-      *p = c.v;
+  static AGG_INLINE void copy_or_blend_pix(value_type *p, const color_type &c) {
+    *p = c.v;
   }
 
 public:
   pixfmt_utf() : m_rbuf(0) {}
   //--------------------------------------------------------------------
-  explicit pixfmt_utf(rbuf_type& rb) :
-    m_rbuf(&rb)
-  {}
-  void attach(rbuf_type& rb) { m_rbuf = &rb; }
+  explicit pixfmt_utf(rbuf_type &rb) : m_rbuf(&rb) {}
+  void attach(rbuf_type &rb) { m_rbuf = &rb; }
   //--------------------------------------------------------------------
 
-  template<class PixFmt>
-  bool attach(PixFmt& pixf, int x1, int y1, int x2, int y2)
-  {
+  template <class PixFmt>
+  bool attach(PixFmt &pixf, int x1, int y1, int x2, int y2) {
     mapserver::rect_i r(x1, y1, x2, y2);
-    if(r.clip(mapserver::rect_i(0, 0, pixf.width()-1, pixf.height()-1)))
-    {
+    if (r.clip(mapserver::rect_i(0, 0, pixf.width() - 1, pixf.height() - 1))) {
       int stride = pixf.stride();
-      m_rbuf->attach(pixf.pix_ptr(r.x1, stride < 0 ? r.y2 : r.y1), 
-                     (r.x2 - r.x1) + 1,
-                     (r.y2 - r.y1) + 1, 
-                     stride);
+      m_rbuf->attach(pixf.pix_ptr(r.x1, stride < 0 ? r.y2 : r.y1),
+                     (r.x2 - r.x1) + 1, (r.y2 - r.y1) + 1, stride);
       return true;
     }
     return false;
   }
 
   //--------------------------------------------------------------------
-  AGG_INLINE unsigned width()  const { return m_rbuf->width();  }
+  AGG_INLINE unsigned width() const { return m_rbuf->width(); }
   AGG_INLINE unsigned height() const { return m_rbuf->height(); }
-  AGG_INLINE int      stride() const { return m_rbuf->stride(); }
+  AGG_INLINE int stride() const { return m_rbuf->stride(); }
 
   //--------------------------------------------------------------------
-        mapserver::int8u* row_ptr(int y)       { return m_rbuf->row_ptr(y); }
-  const mapserver::int8u* row_ptr(int y) const { return m_rbuf->row_ptr(y); }
-  row_data                row(int y)     const { return m_rbuf->row(y); }
+  mapserver::int8u *row_ptr(int y) { return m_rbuf->row_ptr(y); }
+  const mapserver::int8u *row_ptr(int y) const { return m_rbuf->row_ptr(y); }
+  row_data row(int y) const { return m_rbuf->row(y); }
 
-  const mapserver::int8u* pix_ptr(int x, int y) const
-  {
-    return m_rbuf->row_ptr(y) + x * Step + Offset+1213;
+  const mapserver::int8u *pix_ptr(int x, int y) const {
+    return m_rbuf->row_ptr(y) + x * Step + Offset + 1213;
   }
 
-  mapserver::int8u* pix_ptr(int x, int y)
-  {
-    return m_rbuf->row_ptr(y) + x * Step + Offset +1213;
+  mapserver::int8u *pix_ptr(int x, int y) {
+    return m_rbuf->row_ptr(y) + x * Step + Offset + 1213;
   }
 
   //--------------------------------------------------------------------
-  AGG_INLINE static void make_pix(mapserver::int8u* p, const color_type& c)
-  {
-    *(value_type*)p = c.v;
+  AGG_INLINE static void make_pix(mapserver::int8u *p, const color_type &c) {
+    *(value_type *)p = c.v;
   }
 
   //--------------------------------------------------------------------
-  AGG_INLINE color_type pixel(int x, int y) const
-  {
-    value_type* p = (value_type*)m_rbuf->row_ptr(y) + x * Step + Offset;
+  AGG_INLINE color_type pixel(int x, int y) const {
+    value_type *p = (value_type *)m_rbuf->row_ptr(y) + x * Step + Offset;
     return color_type(*p);
   }
 
   //--------------------------------------------------------------------
-  AGG_INLINE void copy_pixel(int x, int y, const color_type& c)
-  {
-    *((value_type*)m_rbuf->row_ptr(x, y, 1) + x * Step + Offset) = c.v;
+  AGG_INLINE void copy_pixel(int x, int y, const color_type &c) {
+    *((value_type *)m_rbuf->row_ptr(x, y, 1) + x * Step + Offset) = c.v;
   }
 
   //--------------------------------------------------------------------
-  AGG_INLINE void blend_pixel(int x, int y, const color_type& c, mapserver::int8u cover)
-  {
-    copy_or_blend_pix((value_type*)
-                       m_rbuf->row_ptr(x, y, 1) + x * Step + Offset, 
-                       c);
+  AGG_INLINE void blend_pixel(int x, int y, const color_type &c,
+                              mapserver::int8u cover) {
+    copy_or_blend_pix(
+        (value_type *)m_rbuf->row_ptr(x, y, 1) + x * Step + Offset, c);
   }
 
-
   //--------------------------------------------------------------------
-  AGG_INLINE void copy_hline(int x, int y, 
-                             unsigned len, 
-                             const color_type& c)
-  {
-    value_type* p = (value_type*)
-        m_rbuf->row_ptr(x, y, len) + x * Step + Offset;
+  AGG_INLINE void copy_hline(int x, int y, unsigned len, const color_type &c) {
+    value_type *p =
+        (value_type *)m_rbuf->row_ptr(x, y, len) + x * Step + Offset;
 
-    do
-    {
+    do {
       *p = c.v;
       p += Step;
-    }
-    while(--len);
+    } while (--len);
   }
 
-
   //--------------------------------------------------------------------
-  AGG_INLINE void copy_vline(int x, int y, 
-                             unsigned len, 
-                             const color_type& c)
-  {
-    do
-    {
-      value_type* p = (value_type*) 
-          m_rbuf->row_ptr(x, y++, 1) + x * Step + Offset;
+  AGG_INLINE void copy_vline(int x, int y, unsigned len, const color_type &c) {
+    do {
+      value_type *p =
+          (value_type *)m_rbuf->row_ptr(x, y++, 1) + x * Step + Offset;
 
       *p = c.v;
-    }
-    while(--len);
+    } while (--len);
   }
 
-
   //--------------------------------------------------------------------
-  void blend_hline(int x, int y, 
-                   unsigned len, 
-                   const color_type& c, 
-                   mapserver::int8u /*cover*/)
-  {
-    value_type* p = (value_type*) 
-        m_rbuf->row_ptr(x, y, len) + x * Step + Offset;
+  void blend_hline(int x, int y, unsigned len, const color_type &c,
+                   mapserver::int8u /*cover*/) {
+    value_type *p =
+        (value_type *)m_rbuf->row_ptr(x, y, len) + x * Step + Offset;
 
-    do
-    {
+    do {
       *p = c.v;
       p += Step;
-    }
-    while(--len);
+    } while (--len);
   }
 
-
   //--------------------------------------------------------------------
-  void blend_vline(int x, int y, 
-                   unsigned len, 
-                   const color_type& c, 
-                   mapserver::int8u cover)
-  {
-    do
-    {
-      value_type* p = (value_type*) 
-          m_rbuf->row_ptr(x, y++, 1) + x * Step + Offset;
+  void blend_vline(int x, int y, unsigned len, const color_type &c,
+                   mapserver::int8u cover) {
+    do {
+      value_type *p =
+          (value_type *)m_rbuf->row_ptr(x, y++, 1) + x * Step + Offset;
 
       *p = c.v;
-    }
-    while(--len);
+    } while (--len);
   }
 
-
 private:
-  rbuf_type* m_rbuf;
+  rbuf_type *m_rbuf;
 };
diff -pruN 8.0.1-5/maputil.c 8.0.2-1/maputil.c
--- 8.0.1-5/maputil.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/maputil.c	2024-06-11 20:41:34.000000000 +0000
@@ -43,10 +43,10 @@
 #include "cpl_conv.h"
 
 #if defined(_WIN32) && !defined(__CYGWIN__)
-# include <windows.h>
-# include <tchar.h>
-# include <fcntl.h>
-# include <io.h>
+#include <windows.h>
+#include <tchar.h>
+#include <fcntl.h>
+#include <io.h>
 #include <process.h>
 #endif
 
@@ -57,16 +57,16 @@
 #include <geos_c.h>
 #endif
 
-
 extern char *msyystring_buffer;
 extern int msyylex_destroy(void);
 extern int yyparse(parseObj *);
 
-int msScaleInBounds(double scale, double minscale, double maxscale)
-{
-  if(scale > 0) {
-    if(maxscale != -1 && scale >= maxscale) return MS_FALSE;
-    if(minscale != -1 && scale < minscale) return MS_FALSE;
+int msScaleInBounds(double scale, double minscale, double maxscale) {
+  if (scale > 0) {
+    if (maxscale != -1 && scale >= maxscale)
+      return MS_FALSE;
+    if (minscale != -1 && scale < minscale)
+      return MS_FALSE;
   }
   return MS_TRUE;
 }
@@ -74,27 +74,28 @@ int msScaleInBounds(double scale, double
 /*
 ** Helper functions to convert from strings to other types or objects.
 */
-static int bindIntegerAttribute(int *attribute, const char *value)
-{
-  if(!value || strlen(value) == 0) return MS_FAILURE;
-  *attribute = MS_NINT(atof(value)); /*use atof instead of atoi as a fix for bug 2394*/
+static int bindIntegerAttribute(int *attribute, const char *value) {
+  if (!value || strlen(value) == 0)
+    return MS_FAILURE;
+  *attribute =
+      MS_NINT(atof(value)); /*use atof instead of atoi as a fix for bug 2394*/
   return MS_SUCCESS;
 }
 
-static int bindDoubleAttribute(double *attribute, const char *value)
-{
-  if(!value || strlen(value) == 0) return MS_FAILURE;
+static int bindDoubleAttribute(double *attribute, const char *value) {
+  if (!value || strlen(value) == 0)
+    return MS_FAILURE;
   *attribute = atof(value);
   return MS_SUCCESS;
 }
 
-static int bindColorAttribute(colorObj *attribute, const char *value)
-{
+static int bindColorAttribute(colorObj *attribute, const char *value) {
   int len;
 
-  if(!value || ((len = strlen(value)) == 0)) return MS_FAILURE;
+  if (!value || ((len = strlen(value)) == 0))
+    return MS_FAILURE;
 
-  if(value[0] == '#' && (len == 7 || len == 9)) { /* got a hex color */
+  if (value[0] == '#' && (len == 7 || len == 9)) { /* got a hex color */
     char hex[2];
 
     hex[0] = value[1];
@@ -106,18 +107,18 @@ static int bindColorAttribute(colorObj *
     hex[0] = value[5];
     hex[1] = value[6];
     attribute->blue = msHexToInt(hex);
-    if(len == 9) {
+    if (len == 9) {
       hex[0] = value[7];
       hex[1] = value[8];
       attribute->alpha = msHexToInt(hex);
     }
     return MS_SUCCESS;
   } else { /* try a space delimited string */
-    char **tokens=NULL;
-    int numtokens=0;
+    char **tokens = NULL;
+    int numtokens = 0;
 
     tokens = msStringSplit(value, ' ', &numtokens);
-    if(tokens==NULL || numtokens != 3) {
+    if (tokens == NULL || numtokens != 3) {
       msFreeCharArray(tokens, numtokens);
       return MS_FAILURE; /* punt */
     }
@@ -133,119 +134,138 @@ static int bindColorAttribute(colorObj *
   return MS_FAILURE; /* shouldn't get here */
 }
 
-static void bindStyle(layerObj *layer, shapeObj *shape, styleObj *style, int drawmode)
-{
+static void bindStyle(layerObj *layer, shapeObj *shape, styleObj *style,
+                      int drawmode) {
   int applyOpacity = MS_FALSE;
   assert(MS_DRAW_FEATURES(drawmode));
-  if(style->numbindings > 0) {
+  if (style->numbindings > 0) {
     applyOpacity = MS_TRUE;
-    if(style->bindings[MS_STYLE_BINDING_SYMBOL].index != -1) {
-      style->symbol = msGetSymbolIndex(&(layer->map->symbolset), shape->values[style->bindings[MS_STYLE_BINDING_SYMBOL].index], MS_TRUE);
-      if(style->symbol == -1) style->symbol = 0; /* a reasonable default (perhaps should throw an error?) */
+    if (style->bindings[MS_STYLE_BINDING_SYMBOL].index != -1) {
+      style->symbol = msGetSymbolIndex(
+          &(layer->map->symbolset),
+          shape->values[style->bindings[MS_STYLE_BINDING_SYMBOL].index],
+          MS_TRUE);
+      if (style->symbol == -1)
+        style->symbol =
+            0; /* a reasonable default (perhaps should throw an error?) */
     }
-    if(style->bindings[MS_STYLE_BINDING_ANGLE].index != -1) {
+    if (style->bindings[MS_STYLE_BINDING_ANGLE].index != -1) {
       style->angle = 360.0;
-      bindDoubleAttribute(&style->angle, shape->values[style->bindings[MS_STYLE_BINDING_ANGLE].index]);
+      bindDoubleAttribute(
+          &style->angle,
+          shape->values[style->bindings[MS_STYLE_BINDING_ANGLE].index]);
     }
-    if(style->bindings[MS_STYLE_BINDING_SIZE].index != -1) {
+    if (style->bindings[MS_STYLE_BINDING_SIZE].index != -1) {
       style->size = 1;
-      bindDoubleAttribute(&style->size, shape->values[style->bindings[MS_STYLE_BINDING_SIZE].index]);
+      bindDoubleAttribute(
+          &style->size,
+          shape->values[style->bindings[MS_STYLE_BINDING_SIZE].index]);
     }
-    if(style->bindings[MS_STYLE_BINDING_WIDTH].index != -1) {
+    if (style->bindings[MS_STYLE_BINDING_WIDTH].index != -1) {
       style->width = 1;
-      bindDoubleAttribute(&style->width, shape->values[style->bindings[MS_STYLE_BINDING_WIDTH].index]);
+      bindDoubleAttribute(
+          &style->width,
+          shape->values[style->bindings[MS_STYLE_BINDING_WIDTH].index]);
+    }
+    if (style->bindings[MS_STYLE_BINDING_COLOR].index != -1 &&
+        !MS_DRAW_QUERY(drawmode)) {
+      MS_INIT_COLOR(style->color, -1, -1, -1, 255);
+      bindColorAttribute(
+          &style->color,
+          shape->values[style->bindings[MS_STYLE_BINDING_COLOR].index]);
+    }
+    if (style->bindings[MS_STYLE_BINDING_OUTLINECOLOR].index != -1 &&
+        !MS_DRAW_QUERY(drawmode)) {
+      MS_INIT_COLOR(style->outlinecolor, -1, -1, -1, 255);
+      bindColorAttribute(
+          &style->outlinecolor,
+          shape->values[style->bindings[MS_STYLE_BINDING_OUTLINECOLOR].index]);
     }
-    if(style->bindings[MS_STYLE_BINDING_COLOR].index != -1 && !MS_DRAW_QUERY(drawmode)) {
-      MS_INIT_COLOR(style->color, -1,-1,-1,255);
-      bindColorAttribute(&style->color, shape->values[style->bindings[MS_STYLE_BINDING_COLOR].index]);
-    }
-    if(style->bindings[MS_STYLE_BINDING_OUTLINECOLOR].index != -1 && !MS_DRAW_QUERY(drawmode)) {
-      MS_INIT_COLOR(style->outlinecolor, -1,-1,-1,255);
-      bindColorAttribute(&style->outlinecolor, shape->values[style->bindings[MS_STYLE_BINDING_OUTLINECOLOR].index]);
-    }
-    if(style->bindings[MS_STYLE_BINDING_OUTLINEWIDTH].index != -1) {
+    if (style->bindings[MS_STYLE_BINDING_OUTLINEWIDTH].index != -1) {
       style->outlinewidth = 1;
-      bindDoubleAttribute(&style->outlinewidth, shape->values[style->bindings[MS_STYLE_BINDING_OUTLINEWIDTH].index]);
+      bindDoubleAttribute(
+          &style->outlinewidth,
+          shape->values[style->bindings[MS_STYLE_BINDING_OUTLINEWIDTH].index]);
     }
-    if(style->bindings[MS_STYLE_BINDING_OPACITY].index != -1) {
+    if (style->bindings[MS_STYLE_BINDING_OPACITY].index != -1) {
       style->opacity = 100;
-      bindIntegerAttribute(&style->opacity, shape->values[style->bindings[MS_STYLE_BINDING_OPACITY].index]);
+      bindIntegerAttribute(
+          &style->opacity,
+          shape->values[style->bindings[MS_STYLE_BINDING_OPACITY].index]);
     }
-    if(style->bindings[MS_STYLE_BINDING_OFFSET_X].index != -1) {
+    if (style->bindings[MS_STYLE_BINDING_OFFSET_X].index != -1) {
       style->offsetx = 0;
-      bindDoubleAttribute(&style->offsetx, shape->values[style->bindings[MS_STYLE_BINDING_OFFSET_X].index]);
+      bindDoubleAttribute(
+          &style->offsetx,
+          shape->values[style->bindings[MS_STYLE_BINDING_OFFSET_X].index]);
     }
-    if(style->bindings[MS_STYLE_BINDING_OFFSET_Y].index != -1) {
+    if (style->bindings[MS_STYLE_BINDING_OFFSET_Y].index != -1) {
       style->offsety = 0;
-      bindDoubleAttribute(&style->offsety, shape->values[style->bindings[MS_STYLE_BINDING_OFFSET_Y].index]);
+      bindDoubleAttribute(
+          &style->offsety,
+          shape->values[style->bindings[MS_STYLE_BINDING_OFFSET_Y].index]);
     }
-    if(style->bindings[MS_STYLE_BINDING_POLAROFFSET_PIXEL].index != -1) {
+    if (style->bindings[MS_STYLE_BINDING_POLAROFFSET_PIXEL].index != -1) {
       style->polaroffsetpixel = 0;
-      bindDoubleAttribute(&style->polaroffsetpixel, shape->values[style->bindings[MS_STYLE_BINDING_POLAROFFSET_PIXEL].index]);
+      bindDoubleAttribute(
+          &style->polaroffsetpixel,
+          shape->values[style->bindings[MS_STYLE_BINDING_POLAROFFSET_PIXEL]
+                            .index]);
     }
-    if(style->bindings[MS_STYLE_BINDING_POLAROFFSET_ANGLE].index != -1) {
+    if (style->bindings[MS_STYLE_BINDING_POLAROFFSET_ANGLE].index != -1) {
       style->polaroffsetangle = 0;
-      bindDoubleAttribute(&style->polaroffsetangle, shape->values[style->bindings[MS_STYLE_BINDING_POLAROFFSET_ANGLE].index]);
+      bindDoubleAttribute(
+          &style->polaroffsetangle,
+          shape->values[style->bindings[MS_STYLE_BINDING_POLAROFFSET_ANGLE]
+                            .index]);
     }
   }
-  if (style->nexprbindings > 0)
-  {
+  if (style->nexprbindings > 0) {
     applyOpacity = MS_TRUE;
-    if (style->exprBindings[MS_STYLE_BINDING_OFFSET_X].type == MS_EXPRESSION)
-    {
+    if (style->exprBindings[MS_STYLE_BINDING_OFFSET_X].type == MS_EXPRESSION) {
       style->offsetx = msEvalDoubleExpression(
-          &(style->exprBindings[MS_STYLE_BINDING_OFFSET_X]),
-          shape);
+          &(style->exprBindings[MS_STYLE_BINDING_OFFSET_X]), shape);
     }
-    if (style->exprBindings[MS_STYLE_BINDING_OFFSET_Y].type == MS_EXPRESSION)
-    {
+    if (style->exprBindings[MS_STYLE_BINDING_OFFSET_Y].type == MS_EXPRESSION) {
       style->offsety = msEvalDoubleExpression(
-          &(style->exprBindings[MS_STYLE_BINDING_OFFSET_Y]),
-          shape);
+          &(style->exprBindings[MS_STYLE_BINDING_OFFSET_Y]), shape);
     }
-    if (style->exprBindings[MS_STYLE_BINDING_ANGLE].type == MS_EXPRESSION)
-    {
+    if (style->exprBindings[MS_STYLE_BINDING_ANGLE].type == MS_EXPRESSION) {
       style->angle = msEvalDoubleExpression(
-          &(style->exprBindings[MS_STYLE_BINDING_ANGLE]),
-          shape);
+          &(style->exprBindings[MS_STYLE_BINDING_ANGLE]), shape);
     }
-    if (style->exprBindings[MS_STYLE_BINDING_SIZE].type == MS_EXPRESSION)
-    {
+    if (style->exprBindings[MS_STYLE_BINDING_SIZE].type == MS_EXPRESSION) {
       style->size = msEvalDoubleExpression(
-          &(style->exprBindings[MS_STYLE_BINDING_SIZE]),
-          shape);
+          &(style->exprBindings[MS_STYLE_BINDING_SIZE]), shape);
     }
-    if (style->exprBindings[MS_STYLE_BINDING_WIDTH].type == MS_EXPRESSION)
-    {
+    if (style->exprBindings[MS_STYLE_BINDING_WIDTH].type == MS_EXPRESSION) {
       style->width = msEvalDoubleExpression(
-          &(style->exprBindings[MS_STYLE_BINDING_WIDTH]),
-          shape);
+          &(style->exprBindings[MS_STYLE_BINDING_WIDTH]), shape);
     }
-    if (style->exprBindings[MS_STYLE_BINDING_OPACITY].type == MS_EXPRESSION)
-    {
-      style->opacity = 100 * msEvalDoubleExpression(
-          &(style->exprBindings[MS_STYLE_BINDING_OPACITY]),
-          shape);
-    }
-    if (style->exprBindings[MS_STYLE_BINDING_OUTLINECOLOR].type == MS_EXPRESSION)
-    {
-      char* txt = msEvalTextExpression(
-            &(style->exprBindings[MS_STYLE_BINDING_OUTLINECOLOR]), shape);
+    if (style->exprBindings[MS_STYLE_BINDING_OPACITY].type == MS_EXPRESSION) {
+      style->opacity =
+          100 * msEvalDoubleExpression(
+                    &(style->exprBindings[MS_STYLE_BINDING_OPACITY]), shape);
+    }
+    if (style->exprBindings[MS_STYLE_BINDING_OUTLINECOLOR].type ==
+        MS_EXPRESSION) {
+      char *txt = msEvalTextExpression(
+          &(style->exprBindings[MS_STYLE_BINDING_OUTLINECOLOR]), shape);
       bindColorAttribute(&style->outlinecolor, txt);
       msFree(txt);
     }
-    if (style->exprBindings[MS_STYLE_BINDING_COLOR].type == MS_EXPRESSION)
-    {
-      char* txt = msEvalTextExpression(
-            &(style->exprBindings[MS_STYLE_BINDING_COLOR]), shape);
+    if (style->exprBindings[MS_STYLE_BINDING_COLOR].type == MS_EXPRESSION) {
+      char *txt = msEvalTextExpression(
+          &(style->exprBindings[MS_STYLE_BINDING_COLOR]), shape);
       bindColorAttribute(&style->color, txt);
       msFree(txt);
     }
   }
 
-  if(applyOpacity == MS_TRUE && (style->opacity < 100 || style->color.alpha != 255) ) {
+  if (applyOpacity == MS_TRUE &&
+      (style->opacity < 100 || style->color.alpha != 255)) {
     int alpha;
-    alpha = MS_NINT(style->opacity*2.55);
+    alpha = MS_NINT(style->opacity * 2.55);
     style->color.alpha = alpha;
     style->outlinecolor.alpha = alpha;
     style->mincolor.alpha = alpha;
@@ -253,140 +273,164 @@ static void bindStyle(layerObj *layer, s
   }
 }
 
-static void bindLabel(layerObj *layer, shapeObj *shape, labelObj *label, int drawmode)
-{
+static void bindLabel(layerObj *layer, shapeObj *shape, labelObj *label,
+                      int drawmode) {
   int i;
   assert(MS_DRAW_LABELS(drawmode));
 
   /* check the label styleObj's (TODO: do we need to use querymapMode here? */
-  for(i=0; i<label->numstyles; i++) {
+  for (i = 0; i < label->numstyles; i++) {
     /* force MS_DRAWMODE_FEATURES for label styles */
-    bindStyle(layer, shape, label->styles[i], drawmode|MS_DRAWMODE_FEATURES);
+    bindStyle(layer, shape, label->styles[i], drawmode | MS_DRAWMODE_FEATURES);
   }
 
-  if(label->numbindings > 0) {
-    if(label->bindings[MS_LABEL_BINDING_ANGLE].index != -1) {
+  if (label->numbindings > 0) {
+    if (label->bindings[MS_LABEL_BINDING_ANGLE].index != -1) {
       label->angle = 0.0;
-      bindDoubleAttribute(&label->angle, shape->values[label->bindings[MS_LABEL_BINDING_ANGLE].index]);
+      bindDoubleAttribute(
+          &label->angle,
+          shape->values[label->bindings[MS_LABEL_BINDING_ANGLE].index]);
     }
 
-    if(label->bindings[MS_LABEL_BINDING_SIZE].index != -1) {
+    if (label->bindings[MS_LABEL_BINDING_SIZE].index != -1) {
       label->size = 1;
-      bindIntegerAttribute(&label->size, shape->values[label->bindings[MS_LABEL_BINDING_SIZE].index]);
+      bindIntegerAttribute(
+          &label->size,
+          shape->values[label->bindings[MS_LABEL_BINDING_SIZE].index]);
     }
 
-    if(label->bindings[MS_LABEL_BINDING_COLOR].index != -1) {
-      MS_INIT_COLOR(label->color, -1,-1,-1,255);
-      bindColorAttribute(&label->color, shape->values[label->bindings[MS_LABEL_BINDING_COLOR].index]);
+    if (label->bindings[MS_LABEL_BINDING_COLOR].index != -1) {
+      MS_INIT_COLOR(label->color, -1, -1, -1, 255);
+      bindColorAttribute(
+          &label->color,
+          shape->values[label->bindings[MS_LABEL_BINDING_COLOR].index]);
     }
 
-    if(label->bindings[MS_LABEL_BINDING_OUTLINECOLOR].index != -1) {
-      MS_INIT_COLOR(label->outlinecolor, -1,-1,-1,255);
-      bindColorAttribute(&label->outlinecolor, shape->values[label->bindings[MS_LABEL_BINDING_OUTLINECOLOR].index]);
+    if (label->bindings[MS_LABEL_BINDING_OUTLINECOLOR].index != -1) {
+      MS_INIT_COLOR(label->outlinecolor, -1, -1, -1, 255);
+      bindColorAttribute(
+          &label->outlinecolor,
+          shape->values[label->bindings[MS_LABEL_BINDING_OUTLINECOLOR].index]);
     }
 
-    if(label->bindings[MS_LABEL_BINDING_FONT].index != -1) {
+    if (label->bindings[MS_LABEL_BINDING_FONT].index != -1) {
       msFree(label->font);
-      label->font = msStrdup(shape->values[label->bindings[MS_LABEL_BINDING_FONT].index]);
+      label->font =
+          msStrdup(shape->values[label->bindings[MS_LABEL_BINDING_FONT].index]);
     }
 
-    if(label->bindings[MS_LABEL_BINDING_PRIORITY].index != -1) {
+    if (label->bindings[MS_LABEL_BINDING_PRIORITY].index != -1) {
       label->priority = MS_DEFAULT_LABEL_PRIORITY;
-      bindIntegerAttribute(&label->priority, shape->values[label->bindings[MS_LABEL_BINDING_PRIORITY].index]);
+      bindIntegerAttribute(
+          &label->priority,
+          shape->values[label->bindings[MS_LABEL_BINDING_PRIORITY].index]);
     }
 
-    if(label->bindings[MS_LABEL_BINDING_SHADOWSIZEX].index != -1) {
+    if (label->bindings[MS_LABEL_BINDING_SHADOWSIZEX].index != -1) {
       label->shadowsizex = 1;
-      bindIntegerAttribute(&label->shadowsizex, shape->values[label->bindings[MS_LABEL_BINDING_SHADOWSIZEX].index]);
+      bindIntegerAttribute(
+          &label->shadowsizex,
+          shape->values[label->bindings[MS_LABEL_BINDING_SHADOWSIZEX].index]);
     }
-    if(label->bindings[MS_LABEL_BINDING_SHADOWSIZEY].index != -1) {
+    if (label->bindings[MS_LABEL_BINDING_SHADOWSIZEY].index != -1) {
       label->shadowsizey = 1;
-      bindIntegerAttribute(&label->shadowsizey, shape->values[label->bindings[MS_LABEL_BINDING_SHADOWSIZEY].index]);
+      bindIntegerAttribute(
+          &label->shadowsizey,
+          shape->values[label->bindings[MS_LABEL_BINDING_SHADOWSIZEY].index]);
     }
 
-    if(label->bindings[MS_LABEL_BINDING_OFFSET_X].index != -1) {
+    if (label->bindings[MS_LABEL_BINDING_OFFSET_X].index != -1) {
       label->offsetx = 0;
-      bindIntegerAttribute(&label->offsetx, shape->values[label->bindings[MS_LABEL_BINDING_OFFSET_X].index]);
+      bindIntegerAttribute(
+          &label->offsetx,
+          shape->values[label->bindings[MS_LABEL_BINDING_OFFSET_X].index]);
     }
 
-    if(label->bindings[MS_LABEL_BINDING_OFFSET_Y].index != -1) {
+    if (label->bindings[MS_LABEL_BINDING_OFFSET_Y].index != -1) {
       label->offsety = 0;
-      bindIntegerAttribute(&label->offsety, shape->values[label->bindings[MS_LABEL_BINDING_OFFSET_Y].index]);
+      bindIntegerAttribute(
+          &label->offsety,
+          shape->values[label->bindings[MS_LABEL_BINDING_OFFSET_Y].index]);
     }
 
-    if(label->bindings[MS_LABEL_BINDING_ALIGN].index != -1) {
+    if (label->bindings[MS_LABEL_BINDING_ALIGN].index != -1) {
       int tmpAlign = 0;
-      bindIntegerAttribute(&tmpAlign, shape->values[label->bindings[MS_LABEL_BINDING_ALIGN].index]);
-      if(tmpAlign != 0) { /* is this test sufficient? */
+      bindIntegerAttribute(
+          &tmpAlign,
+          shape->values[label->bindings[MS_LABEL_BINDING_ALIGN].index]);
+      if (tmpAlign != 0) { /* is this test sufficient? */
         label->align = tmpAlign;
-      } else { /* Integer binding failed, look for strings like cc, ul, lr, etc... */
-        if(strlen(shape->values[label->bindings[MS_LABEL_BINDING_ALIGN].index]) >= 4) {
-          char *va = shape->values[label->bindings[MS_LABEL_BINDING_ALIGN].index];
-          if(!strncasecmp(va,"center",5))
+      } else { /* Integer binding failed, look for strings like cc, ul, lr,
+                  etc... */
+        if (strlen(
+                shape->values[label->bindings[MS_LABEL_BINDING_ALIGN].index]) >=
+            4) {
+          char *va =
+              shape->values[label->bindings[MS_LABEL_BINDING_ALIGN].index];
+          if (!strncasecmp(va, "center", 5))
             label->align = MS_ALIGN_CENTER;
-          else if(!strncasecmp(va,"left",4))
+          else if (!strncasecmp(va, "left", 4))
             label->align = MS_ALIGN_LEFT;
-          else if(!strncasecmp(va,"right",5))
+          else if (!strncasecmp(va, "right", 5))
             label->align = MS_ALIGN_RIGHT;
         }
       }
     }
 
-    if(label->bindings[MS_LABEL_BINDING_POSITION].index != -1) {
+    if (label->bindings[MS_LABEL_BINDING_POSITION].index != -1) {
       int tmpPosition = 0;
-      bindIntegerAttribute(&tmpPosition, shape->values[label->bindings[MS_LABEL_BINDING_POSITION].index]);
-      if(tmpPosition != 0) { /* is this test sufficient? */
+      bindIntegerAttribute(
+          &tmpPosition,
+          shape->values[label->bindings[MS_LABEL_BINDING_POSITION].index]);
+      if (tmpPosition != 0) { /* is this test sufficient? */
         label->position = tmpPosition;
-      } else { /* Integer binding failed, look for strings like cc, ul, lr, etc... */
-        if(strlen(shape->values[label->bindings[MS_LABEL_BINDING_POSITION].index]) == 2) {
-          char *vp = shape->values[label->bindings[MS_LABEL_BINDING_POSITION].index];
-          if(!strncasecmp(vp,"ul",2))
+      } else { /* Integer binding failed, look for strings like cc, ul, lr,
+                  etc... */
+        if (strlen(shape->values[label->bindings[MS_LABEL_BINDING_POSITION]
+                                     .index]) == 2) {
+          char *vp =
+              shape->values[label->bindings[MS_LABEL_BINDING_POSITION].index];
+          if (!strncasecmp(vp, "ul", 2))
             label->position = MS_UL;
-          else if(!strncasecmp(vp,"lr",2))
+          else if (!strncasecmp(vp, "lr", 2))
             label->position = MS_LR;
-          else if(!strncasecmp(vp,"ur",2))
+          else if (!strncasecmp(vp, "ur", 2))
             label->position = MS_UR;
-          else if(!strncasecmp(vp,"ll",2))
+          else if (!strncasecmp(vp, "ll", 2))
             label->position = MS_LL;
-          else if(!strncasecmp(vp,"cr",2))
+          else if (!strncasecmp(vp, "cr", 2))
             label->position = MS_CR;
-          else if(!strncasecmp(vp,"cl",2))
+          else if (!strncasecmp(vp, "cl", 2))
             label->position = MS_CL;
-          else if(!strncasecmp(vp,"uc",2))
+          else if (!strncasecmp(vp, "uc", 2))
             label->position = MS_UC;
-          else if(!strncasecmp(vp,"lc",2))
+          else if (!strncasecmp(vp, "lc", 2))
             label->position = MS_LC;
-          else if(!strncasecmp(vp,"cc",2))
+          else if (!strncasecmp(vp, "cc", 2))
             label->position = MS_CC;
         }
       }
     }
   }
-  if (label->nexprbindings > 0)
-  {
-    if (label->exprBindings[MS_LABEL_BINDING_ANGLE].type == MS_EXPRESSION)
-    {
+  if (label->nexprbindings > 0) {
+    if (label->exprBindings[MS_LABEL_BINDING_ANGLE].type == MS_EXPRESSION) {
       label->angle = msEvalDoubleExpression(
-          &(label->exprBindings[MS_LABEL_BINDING_ANGLE]),
-          shape);
+          &(label->exprBindings[MS_LABEL_BINDING_ANGLE]), shape);
     }
-    if (label->exprBindings[MS_LABEL_BINDING_SIZE].type == MS_EXPRESSION)
-    {
+    if (label->exprBindings[MS_LABEL_BINDING_SIZE].type == MS_EXPRESSION) {
       label->size = msEvalDoubleExpression(
-          &(label->exprBindings[MS_LABEL_BINDING_SIZE]),
-          shape);
+          &(label->exprBindings[MS_LABEL_BINDING_SIZE]), shape);
     }
-    if (label->exprBindings[MS_LABEL_BINDING_COLOR].type == MS_EXPRESSION)
-    {
-      char* txt = msEvalTextExpression(
-            &(label->exprBindings[MS_LABEL_BINDING_COLOR]), shape);
+    if (label->exprBindings[MS_LABEL_BINDING_COLOR].type == MS_EXPRESSION) {
+      char *txt = msEvalTextExpression(
+          &(label->exprBindings[MS_LABEL_BINDING_COLOR]), shape);
       bindColorAttribute(&label->color, txt);
       msFree(txt);
     }
-    if (label->exprBindings[MS_LABEL_BINDING_OUTLINECOLOR].type == MS_EXPRESSION)
-    {
-      char* txt = msEvalTextExpression(
-            &(label->exprBindings[MS_LABEL_BINDING_OUTLINECOLOR]), shape);
+    if (label->exprBindings[MS_LABEL_BINDING_OUTLINECOLOR].type ==
+        MS_EXPRESSION) {
+      char *txt = msEvalTextExpression(
+          &(label->exprBindings[MS_LABEL_BINDING_OUTLINECOLOR]), shape);
       bindColorAttribute(&label->outlinecolor, txt);
       msFree(txt);
     }
@@ -396,24 +440,24 @@ static void bindLabel(layerObj *layer, s
 /*
 ** Function to bind various layer properties to shape attributes.
 */
-int msBindLayerToShape(layerObj *layer, shapeObj *shape, int drawmode)
-{
+int msBindLayerToShape(layerObj *layer, shapeObj *shape, int drawmode) {
   int i, j;
 
-  if(!layer || !shape) return MS_FAILURE;
+  if (!layer || !shape)
+    return MS_FAILURE;
 
-  for(i=0; i<layer->numclasses; i++) {
+  for (i = 0; i < layer->numclasses; i++) {
     /* check the styleObj's */
-    if(MS_DRAW_FEATURES(drawmode)) {
-      for(j=0; j<layer->class[i]->numstyles; j++) {
-        bindStyle(layer, shape, layer->class[i]->styles[j], drawmode);
+    if (MS_DRAW_FEATURES(drawmode)) {
+      for (j = 0; j < layer->class[i] -> numstyles; j++) {
+        bindStyle(layer, shape, layer->class[i] -> styles[j], drawmode);
       }
     }
 
     /* check the labelObj's */
-    if(MS_DRAW_LABELS(drawmode)) {
-      for(j=0; j<layer->class[i]->numlabels; j++) {
-        bindLabel(layer, shape, layer->class[i]->labels[j], drawmode);
+    if (MS_DRAW_LABELS(drawmode)) {
+      for (j = 0; j < layer->class[i] -> numlabels; j++) {
+        bindLabel(layer, shape, layer->class[i] -> labels[j], drawmode);
       }
     }
   } /* next classObj */
@@ -424,37 +468,44 @@ int msBindLayerToShape(layerObj *layer,
 /*
  * Used to get red, green, blue integers separately based upon the color index
  */
-int getRgbColor(mapObj *map,int i,int *r,int *g,int *b)
-{
+int getRgbColor(mapObj *map, int i, int *r, int *g, int *b) {
   /* check index range */
-  int status=1;
-  *r=*g=*b=-1;
-  if ((i > 0 ) && (i <= map->palette.numcolors) ) {
-    *r=map->palette.colors[i-1].red;
-    *g=map->palette.colors[i-1].green;
-    *b=map->palette.colors[i-1].blue;
-    status=0;
+  int status = 1;
+  *r = *g = *b = -1;
+  if ((i > 0) && (i <= map->palette.numcolors)) {
+    *r = map->palette.colors[i - 1].red;
+    *g = map->palette.colors[i - 1].green;
+    *b = map->palette.colors[i - 1].blue;
+    status = 0;
   }
   return status;
 }
 
-static int searchContextForTag(mapObj *map, char **ltags, char *tag, char *context, int requires)
-{
+static int searchContextForTag(mapObj *map, char **ltags, char *tag,
+                               char *context, int requires) {
   int i;
 
-  if(!context) return MS_FAILURE;
+  if (!context)
+    return MS_FAILURE;
 
-  /*  printf("\tin searchContextForTag, searching %s for %s\n", context, tag); */
+  /*  printf("\tin searchContextForTag, searching %s for %s\n", context, tag);
+   */
 
-  if(strstr(context, tag) != NULL) return MS_SUCCESS; /* found the tag */
+  if (strstr(context, tag) != NULL)
+    return MS_SUCCESS; /* found the tag */
 
   /* check referenced layers for the tag too */
-  for(i=0; i<map->numlayers; i++) {
-    if(strstr(context, ltags[i]) != NULL) { /* need to check this layer */
-      if(requires == MS_TRUE) {
-        if(searchContextForTag(map, ltags, tag, GET_LAYER(map, i)->requires, MS_TRUE) == MS_SUCCESS) return MS_SUCCESS;
+  for (i = 0; i < map->numlayers; i++) {
+    if (strstr(context, ltags[i]) != NULL) { /* need to check this layer */
+      if (requires == MS_TRUE) {
+        if (searchContextForTag(map, ltags, tag, GET_LAYER(map, i)->requires,
+                                MS_TRUE) == MS_SUCCESS)
+          return MS_SUCCESS;
       } else {
-        if(searchContextForTag(map, ltags, tag, GET_LAYER(map, i)->labelrequires, MS_FALSE) == MS_SUCCESS) return MS_SUCCESS;
+        if (searchContextForTag(map, ltags, tag,
+                                GET_LAYER(map, i)->labelrequires,
+                                MS_FALSE) == MS_SUCCESS)
+          return MS_SUCCESS;
       }
     }
   }
@@ -463,36 +514,47 @@ static int searchContextForTag(mapObj *m
 }
 
 /*
-** Function to take a look at all layers with REQUIRES/LABELREQUIRES set to make sure there are no
-** recursive context requirements set (e.g. layer1 requires layer2 and layer2 requires layer1). This
+** Function to take a look at all layers with REQUIRES/LABELREQUIRES set to make
+*sure there are no
+** recursive context requirements set (e.g. layer1 requires layer2 and layer2
+*requires layer1). This
 ** is bug 1059.
 */
-int msValidateContexts(mapObj *map)
-{
+int msValidateContexts(mapObj *map) {
   int i;
   char **ltags;
   int status = MS_SUCCESS;
 
-  ltags = (char **) msSmallMalloc(map->numlayers*sizeof(char *));
-  for(i=0; i<map->numlayers; i++) {
-    if(GET_LAYER(map, i)->name == NULL) {
+  ltags = (char **)msSmallMalloc(map->numlayers * sizeof(char *));
+  for (i = 0; i < map->numlayers; i++) {
+    if (GET_LAYER(map, i)->name == NULL) {
       ltags[i] = msStrdup("[NULL]");
     } else {
-      ltags[i] = (char *) msSmallMalloc(sizeof(char)*strlen(GET_LAYER(map, i)->name) + 3);
+      ltags[i] = (char *)msSmallMalloc(
+          sizeof(char) * strlen(GET_LAYER(map, i)->name) + 3);
       sprintf(ltags[i], "[%s]", GET_LAYER(map, i)->name);
     }
   }
 
   /* check each layer's REQUIRES and LABELREQUIRES parameters */
-  for(i=0; i<map->numlayers; i++) {
-    /* printf("working on layer %s, looking for references to %s\n", GET_LAYER(map, i)->name, ltags[i]); */
-    if(searchContextForTag(map, ltags, ltags[i], GET_LAYER(map, i)->requires, MS_TRUE) == MS_SUCCESS) {
-      msSetError(MS_PARSEERR, "Recursion error found for REQUIRES parameter for layer %s.", "msValidateContexts", GET_LAYER(map, i)->name);
+  for (i = 0; i < map->numlayers; i++) {
+    /* printf("working on layer %s, looking for references to %s\n",
+     * GET_LAYER(map, i)->name, ltags[i]); */
+    if (searchContextForTag(map, ltags, ltags[i], GET_LAYER(map, i)->requires,
+                            MS_TRUE) == MS_SUCCESS) {
+      msSetError(MS_PARSEERR,
+                 "Recursion error found for REQUIRES parameter for layer %s.",
+                 "msValidateContexts", GET_LAYER(map, i)->name);
       status = MS_FAILURE;
       break;
     }
-    if(searchContextForTag(map, ltags, ltags[i], GET_LAYER(map, i)->labelrequires, MS_FALSE) == MS_SUCCESS) {
-      msSetError(MS_PARSEERR, "Recursion error found for LABELREQUIRES parameter for layer %s.", "msValidateContexts", GET_LAYER(map, i)->name);
+    if (searchContextForTag(map, ltags, ltags[i],
+                            GET_LAYER(map, i)->labelrequires,
+                            MS_FALSE) == MS_SUCCESS) {
+      msSetError(
+          MS_PARSEERR,
+          "Recursion error found for LABELREQUIRES parameter for layer %s.",
+          "msValidateContexts", GET_LAYER(map, i)->name);
       status = MS_FAILURE;
       break;
     }
@@ -505,15 +567,15 @@ int msValidateContexts(mapObj *map)
   return status;
 }
 
-int msEvalContext(mapObj *map, layerObj *layer, char *context)
-{
+int msEvalContext(mapObj *map, layerObj *layer, char *context) {
   int i, status;
-  char *tag=NULL;
+  char *tag = NULL;
 
   expressionObj e;
   parseObj p;
 
-  if(!context) return(MS_TRUE);
+  if (!context)
+    return (MS_TRUE);
 
   /* initialize a temporary expression (e) */
   msInitExpression(&e);
@@ -521,15 +583,18 @@ int msEvalContext(mapObj *map, layerObj
   e.string = msStrdup(context);
   e.type = MS_EXPRESSION; /* todo */
 
-  for(i=0; i<map->numlayers; i++) { /* step through all the layers */
-    if(layer->index == i) continue; /* skip the layer in question */
-    if (GET_LAYER(map, i)->name == NULL) continue; /* Layer without name cannot be used in contexts */
+  for (i = 0; i < map->numlayers; i++) { /* step through all the layers */
+    if (layer->index == i)
+      continue; /* skip the layer in question */
+    if (GET_LAYER(map, i)->name == NULL)
+      continue; /* Layer without name cannot be used in contexts */
 
-    tag = (char *)msSmallMalloc(sizeof(char)*strlen(GET_LAYER(map, i)->name) + 3);
+    tag = (char *)msSmallMalloc(sizeof(char) * strlen(GET_LAYER(map, i)->name) +
+                                3);
     sprintf(tag, "[%s]", GET_LAYER(map, i)->name);
 
-    if(strstr(e.string, tag)) {
-      if(msLayerIsVisible(map, (GET_LAYER(map, i))))
+    if (strstr(e.string, tag)) {
+      if (msLayerIsVisible(map, (GET_LAYER(map, i))))
         e.string = msReplaceSubstring(e.string, tag, "1");
       else
         e.string = msReplaceSubstring(e.string, tag, "0");
@@ -565,118 +630,141 @@ int msEvalContext(mapObj *map, layerObj
  * (check the error stack if you care)
  *
  */
-int msEvalExpression(layerObj *layer, shapeObj *shape, expressionObj *expression, int itemindex)
-{
-  if(MS_STRING_IS_NULL_OR_EMPTY(expression->string)) return MS_TRUE; /* NULL or empty expressions are ALWAYS true */
-  if(expression->native_string != NULL) return MS_TRUE; /* expressions that are evaluated natively are ALWAYS true */
-
-  switch(expression->type) {
-    case(MS_STRING):
-      if(itemindex == -1) {
-        msSetError(MS_MISCERR, "Cannot evaluate expression, no item index defined.", "msEvalExpression()");
-        return MS_FALSE;
-      }
-      if(itemindex >= layer->numitems || itemindex >= shape->numvalues) {
-        msSetError(MS_MISCERR, "Invalid item index.", "msEvalExpression()");
-        return MS_FALSE;
+int msEvalExpression(layerObj *layer, shapeObj *shape,
+                     expressionObj *expression, int itemindex) {
+  if (MS_STRING_IS_NULL_OR_EMPTY(expression->string))
+    return MS_TRUE; /* NULL or empty expressions are ALWAYS true */
+  if (expression->native_string != NULL)
+    return MS_TRUE; /* expressions that are evaluated natively are ALWAYS true
+                     */
+
+  switch (expression->type) {
+  case (MS_STRING):
+    if (itemindex == -1) {
+      msSetError(MS_MISCERR,
+                 "Cannot evaluate expression, no item index defined.",
+                 "msEvalExpression()");
+      return MS_FALSE;
+    }
+    if (itemindex >= layer->numitems || itemindex >= shape->numvalues) {
+      msSetError(MS_MISCERR, "Invalid item index.", "msEvalExpression()");
+      return MS_FALSE;
+    }
+    if (expression->flags & MS_EXP_INSENSITIVE) {
+      if (strcasecmp(expression->string, shape->values[itemindex]) == 0)
+        return MS_TRUE; /* got a match */
+    } else {
+      if (strcmp(expression->string, shape->values[itemindex]) == 0)
+        return MS_TRUE; /* got a match */
+    }
+    break;
+  case (MS_LIST):
+    if (itemindex == -1) {
+      msSetError(MS_MISCERR,
+                 "Cannot evaluate expression, no item index defined.",
+                 "msEvalExpression()");
+      return MS_FALSE;
+    }
+    if (itemindex >= layer->numitems || itemindex >= shape->numvalues) {
+      msSetError(MS_MISCERR, "Invalid item index.", "msEvalExpression()");
+      return MS_FALSE;
+    }
+    {
+      char *start, *end;
+      int value_len = strlen(shape->values[itemindex]);
+      start = expression->string;
+      while ((end = strchr(start, ',')) != NULL) {
+        if (value_len == end - start &&
+            !strncmp(start, shape->values[itemindex], end - start))
+          return MS_TRUE;
+        start = end + 1;
       }
-      if(expression->flags & MS_EXP_INSENSITIVE) {
-        if(strcasecmp(expression->string, shape->values[itemindex]) == 0) return MS_TRUE; /* got a match */
+      if (!strcmp(start, shape->values[itemindex]))
+        return MS_TRUE;
+    }
+    break;
+  case (MS_EXPRESSION): {
+    int status;
+    parseObj p;
+
+    p.shape = shape;
+    p.expr = expression;
+    p.expr->curtoken = p.expr->tokens; /* reset */
+    p.type = MS_PARSE_TYPE_BOOLEAN;
+
+    status = yyparse(&p);
+
+    if (status != 0) {
+      msSetError(MS_PARSEERR, "Failed to parse expression: %s",
+                 "msEvalExpression", expression->string);
+      return MS_FALSE;
+    }
+
+    return p.result.intval;
+  }
+  case (MS_REGEX):
+    if (itemindex == -1) {
+      msSetError(MS_MISCERR,
+                 "Cannot evaluate expression, no item index defined.",
+                 "msEvalExpression()");
+      return MS_FALSE;
+    }
+    if (itemindex >= layer->numitems || itemindex >= shape->numvalues) {
+      msSetError(MS_MISCERR, "Invalid item index.", "msEvalExpression()");
+      return MS_FALSE;
+    }
+
+    if (MS_STRING_IS_NULL_OR_EMPTY(shape->values[itemindex]) == MS_TRUE)
+      return MS_FALSE;
+
+    if (!expression->compiled) {
+      if (expression->flags & MS_EXP_INSENSITIVE) {
+        if (ms_regcomp(&(expression->regex), expression->string,
+                       MS_REG_EXTENDED | MS_REG_NOSUB | MS_REG_ICASE) !=
+            0) { /* compile the expression */
+          msSetError(MS_REGEXERR, "Invalid regular expression.",
+                     "msEvalExpression()");
+          return MS_FALSE;
+        }
       } else {
-        if(strcmp(expression->string, shape->values[itemindex]) == 0) return MS_TRUE; /* got a match */
-      }
-      break;
-    case(MS_LIST):
-      if(itemindex == -1) {
-        msSetError(MS_MISCERR, "Cannot evaluate expression, no item index defined.", "msEvalExpression()");
-        return MS_FALSE;
-      }
-      if(itemindex >= layer->numitems || itemindex >= shape->numvalues) {
-        msSetError(MS_MISCERR, "Invalid item index.", "msEvalExpression()");
-        return MS_FALSE;
-      }
-      {
-        char *start,*end;
-        int value_len = strlen(shape->values[itemindex]);
-        start = expression->string;
-        while((end = strchr(start,',')) != NULL) {
-          if(value_len == end-start && !strncmp(start,shape->values[itemindex],end-start)) return MS_TRUE;
-          start = end+1;
+        if (ms_regcomp(&(expression->regex), expression->string,
+                       MS_REG_EXTENDED | MS_REG_NOSUB) !=
+            0) { /* compile the expression */
+          msSetError(MS_REGEXERR, "Invalid regular expression.",
+                     "msEvalExpression()");
+          return MS_FALSE;
         }
-        if(!strcmp(start,shape->values[itemindex])) return MS_TRUE;
-      }
-      break;
-    case(MS_EXPRESSION): {
-      int status;
-      parseObj p;
-
-      p.shape = shape;
-      p.expr = expression;
-      p.expr->curtoken = p.expr->tokens; /* reset */
-      p.type = MS_PARSE_TYPE_BOOLEAN;
-
-      status = yyparse(&p);
-
-      if (status != 0) {
-        msSetError(MS_PARSEERR, "Failed to parse expression: %s", "msEvalExpression", expression->string);
-        return MS_FALSE;
       }
-
-      return p.result.intval;
-
+      expression->compiled = MS_TRUE;
     }
-    case(MS_REGEX):
-      if(itemindex == -1) {
-        msSetError(MS_MISCERR, "Cannot evaluate expression, no item index defined.", "msEvalExpression()");
-        return MS_FALSE;
-      }
-      if(itemindex >= layer->numitems || itemindex >= shape->numvalues) {
-        msSetError(MS_MISCERR, "Invalid item index.", "msEvalExpression()");
-        return MS_FALSE;
-      }
 
-      if(MS_STRING_IS_NULL_OR_EMPTY(shape->values[itemindex]) == MS_TRUE) return MS_FALSE;
-
-      if(!expression->compiled) {
-        if(expression->flags & MS_EXP_INSENSITIVE) {
-          if(ms_regcomp(&(expression->regex), expression->string, MS_REG_EXTENDED|MS_REG_NOSUB|MS_REG_ICASE) != 0) { /* compile the expression */
-            msSetError(MS_REGEXERR, "Invalid regular expression.", "msEvalExpression()");
-            return MS_FALSE;
-          }
-        } else {
-          if(ms_regcomp(&(expression->regex), expression->string, MS_REG_EXTENDED|MS_REG_NOSUB) != 0) { /* compile the expression */
-            msSetError(MS_REGEXERR, "Invalid regular expression.", "msEvalExpression()");
-            return MS_FALSE;
-          }
-        }
-        expression->compiled = MS_TRUE;
-      }
-
-      if(ms_regexec(&(expression->regex), shape->values[itemindex], 0, NULL, 0) == 0) return MS_TRUE; /* got a match */
-      break;
+    if (ms_regexec(&(expression->regex), shape->values[itemindex], 0, NULL,
+                   0) == 0)
+      return MS_TRUE; /* got a match */
+    break;
   }
 
   return MS_FALSE;
 }
 
-int *msAllocateValidClassGroups(layerObj *lp, int *nclasses)
-{
+int *msAllocateValidClassGroups(layerObj *lp, int *nclasses) {
   int *classgroup = NULL;
-  int nvalidclass = 0, i=0;
+  int nvalidclass = 0, i = 0;
 
-  if (!lp || !lp->classgroup || lp->numclasses <=0 || !nclasses)
+  if (!lp || !lp->classgroup || lp->numclasses <= 0 || !nclasses)
     return NULL;
 
-  classgroup = (int *)msSmallMalloc(sizeof(int)*lp->numclasses);
+  classgroup = (int *)msSmallMalloc(sizeof(int) * lp->numclasses);
   nvalidclass = 0;
-  for (i=0; i<lp->numclasses; i++) {
-    if (lp->class[i]->group && strcasecmp(lp->class[i]->group, lp->classgroup) == 0) {
+  for (i = 0; i < lp->numclasses; i++) {
+    if (lp->class[i] -> group && strcasecmp(lp->class[i] -> group,
+                                            lp -> classgroup) == 0) {
       classgroup[nvalidclass] = i;
       nvalidclass++;
     }
   }
   if (nvalidclass > 0) {
-    classgroup = (int *)msSmallRealloc(classgroup, sizeof(int)*nvalidclass);
+    classgroup = (int *)msSmallRealloc(classgroup, sizeof(int) * nvalidclass);
     *nclasses = nvalidclass;
     return classgroup;
   }
@@ -685,27 +773,25 @@ int *msAllocateValidClassGroups(layerObj
     msFree(classgroup);
 
   return NULL;
-
 }
 
-int msShapeGetClass(layerObj *layer, mapObj *map, shapeObj *shape, int *classgroup, int numclasses)
-{
+int msShapeGetClass(layerObj *layer, mapObj *map, shapeObj *shape,
+                    int *classgroup, int numclasses) {
   return msShapeGetNextClass(-1, layer, map, shape, classgroup, numclasses);
 }
 
 int msShapeGetNextClass(int currentclass, layerObj *layer, mapObj *map,
-    shapeObj *shape, int *classgroup, int numclasses)
-{
+                        shapeObj *shape, int *classgroup, int numclasses) {
   int i, iclass;
 
   if (currentclass < 0)
     currentclass = -1;
 
   if (layer->numclasses > 0) {
-    if (classgroup == NULL || numclasses <=0)
+    if (classgroup == NULL || numclasses <= 0)
       numclasses = layer->numclasses;
 
-    for(i=currentclass+1; i<numclasses; i++) {
+    for (i = currentclass + 1; i < numclasses; i++) {
       if (classgroup)
         iclass = classgroup[i];
       else
@@ -714,121 +800,126 @@ int msShapeGetNextClass(int currentclass
       if (iclass < 0 || iclass >= layer->numclasses)
         continue; /* this should never happen but just in case */
 
-      if(map->scaledenom > 0) { /* verify scaledenom here  */
-        if((layer->class[iclass]->maxscaledenom > 0) && (map->scaledenom > layer->class[iclass]->maxscaledenom))
+      if (map->scaledenom > 0) { /* verify scaledenom here  */
+        if ((layer->class[iclass] -> maxscaledenom > 0) &&
+            (map->scaledenom > layer->class[iclass] -> maxscaledenom))
           continue; /* can skip this one, next class */
-        if((layer->class[iclass]->minscaledenom > 0) && (map->scaledenom <= layer->class[iclass]->minscaledenom))
+        if ((layer->class[iclass] -> minscaledenom > 0) &&
+            (map->scaledenom <= layer->class[iclass] -> minscaledenom))
           continue; /* can skip this one, next class */
       }
 
       /* verify the minfeaturesize */
-      if ((shape->type == MS_SHAPE_LINE || shape->type == MS_SHAPE_POLYGON) && (layer->class[iclass]->minfeaturesize > 0)) {
-        double minfeaturesize = Pix2LayerGeoref(map, layer,
-                                                layer->class[iclass]->minfeaturesize);
+      if ((shape->type == MS_SHAPE_LINE || shape->type == MS_SHAPE_POLYGON) &&
+          (layer->class[iclass] -> minfeaturesize > 0)) {
+        double minfeaturesize =
+            Pix2LayerGeoref(map, layer, layer->class[iclass] -> minfeaturesize);
         if (msShapeCheckSize(shape, minfeaturesize) == MS_FALSE)
           continue; /* skip this one, next class */
       }
 
-      if(layer->class[iclass]->status != MS_DELETE && msEvalExpression(layer, shape, &(layer->class[iclass]->expression), layer->classitemindex) == MS_TRUE)
-      {
-        if (layer->class[iclass]->isfallback && currentclass != -1)
-        {
-          // Class is not applicable if it is flagged as fallback (<ElseFilter/> tag in SLD)
-          // but other classes have been applied before.
+      if (layer->class[iclass] -> status != MS_DELETE &&
+                                      msEvalExpression(
+                                          layer, shape,
+                                          &(layer->class[iclass] -> expression),
+                                          layer->classitemindex) == MS_TRUE) {
+        if (layer->class[iclass] -> isfallback && currentclass != -1) {
+          // Class is not applicable if it is flagged as fallback (<ElseFilter/>
+          // tag in SLD) but other classes have been applied before.
           return -1;
-        }
-        else
-        {
-          return(iclass);
+        } else {
+          return (iclass);
         }
       }
     }
   }
 
-  return(-1); /* no match */
+  return (-1); /* no match */
 }
 
-static
-char *msEvalTextExpressionInternal(expressionObj *expr, shapeObj *shape, int bJSonEscape)
-{
-  char *result=NULL;
-
-  if(!expr->string) return result; /* nothing to do */
-
-  switch(expr->type) {
-    case(MS_STRING): {
-      char *target=NULL;
-      char *pszEscaped;
-      tokenListNodeObjPtr node=NULL;
-      tokenListNodeObjPtr nextNode=NULL;
-
-      result = msStrdup(expr->string);
-
-      node = expr->tokens;
-      if(node) {
-        while(node != NULL) {
-          nextNode = node->next;
-          if(node->token == MS_TOKEN_BINDING_DOUBLE || node->token == MS_TOKEN_BINDING_INTEGER || node->token == MS_TOKEN_BINDING_STRING || node->token == MS_TOKEN_BINDING_TIME) {
-            target = (char *) msSmallMalloc(strlen(node->tokenval.bindval.item) + 3);
-            sprintf(target, "[%s]", node->tokenval.bindval.item);
-            if( bJSonEscape )
-                pszEscaped = msEscapeJSonString(shape->values[node->tokenval.bindval.index]);
-            else
-                pszEscaped = msStrdup(shape->values[node->tokenval.bindval.index]);
-            result = msReplaceSubstring(result, target, pszEscaped);
-            msFree(pszEscaped);
-            msFree(target);
-          }
-          node = nextNode;
+static char *msEvalTextExpressionInternal(expressionObj *expr, shapeObj *shape,
+                                          int bJSonEscape) {
+  char *result = NULL;
+
+  if (!expr->string)
+    return result; /* nothing to do */
+
+  switch (expr->type) {
+  case (MS_STRING): {
+    char *target = NULL;
+    char *pszEscaped;
+    tokenListNodeObjPtr node = NULL;
+    tokenListNodeObjPtr nextNode = NULL;
+
+    result = msStrdup(expr->string);
+
+    node = expr->tokens;
+    if (node) {
+      while (node != NULL) {
+        nextNode = node->next;
+        if (node->token == MS_TOKEN_BINDING_DOUBLE ||
+            node->token == MS_TOKEN_BINDING_INTEGER ||
+            node->token == MS_TOKEN_BINDING_STRING ||
+            node->token == MS_TOKEN_BINDING_TIME) {
+          target =
+              (char *)msSmallMalloc(strlen(node->tokenval.bindval.item) + 3);
+          sprintf(target, "[%s]", node->tokenval.bindval.item);
+          if (bJSonEscape)
+            pszEscaped =
+                msEscapeJSonString(shape->values[node->tokenval.bindval.index]);
+          else
+            pszEscaped = msStrdup(shape->values[node->tokenval.bindval.index]);
+          result = msReplaceSubstring(result, target, pszEscaped);
+          msFree(pszEscaped);
+          msFree(target);
         }
-      }
-      if(!strlen(result)) {
-        msFree(result);
-        result = NULL;
+        node = nextNode;
       }
     }
-    break;
-    case(MS_EXPRESSION): {
-      int status;
-      parseObj p;
-
-      p.shape = shape;
-      p.expr = expr;
-      p.expr->curtoken = p.expr->tokens; /* reset */
-      p.type = MS_PARSE_TYPE_STRING;
+    if (!strlen(result)) {
+      msFree(result);
+      result = NULL;
+    }
+  } break;
+  case (MS_EXPRESSION): {
+    int status;
+    parseObj p;
 
-      status = yyparse(&p);
+    p.shape = shape;
+    p.expr = expr;
+    p.expr->curtoken = p.expr->tokens; /* reset */
+    p.type = MS_PARSE_TYPE_STRING;
 
-      if (status != 0) {
-        msSetError(MS_PARSEERR, "Failed to process text expression: %s", "msEvalTextExpression", expr->string);
-        return NULL;
-      }
+    status = yyparse(&p);
 
-      result = p.result.strval;
-      break;
+    if (status != 0) {
+      msSetError(MS_PARSEERR, "Failed to process text expression: %s",
+                 "msEvalTextExpression", expr->string);
+      return NULL;
     }
-    default:
-      break;
+
+    result = p.result.strval;
+    break;
   }
-  if(result && !strlen(result)) {
+  default:
+    break;
+  }
+  if (result && !strlen(result)) {
     msFree(result);
     result = NULL;
   }
   return result;
 }
 
-char *msEvalTextExpressionJSonEscape(expressionObj *expr, shapeObj *shape)
-{
-    return msEvalTextExpressionInternal(expr, shape, MS_TRUE);
+char *msEvalTextExpressionJSonEscape(expressionObj *expr, shapeObj *shape) {
+  return msEvalTextExpressionInternal(expr, shape, MS_TRUE);
 }
 
-char *msEvalTextExpression(expressionObj *expr, shapeObj *shape)
-{
-    return msEvalTextExpressionInternal(expr, shape, MS_FALSE);
+char *msEvalTextExpression(expressionObj *expr, shapeObj *shape) {
+  return msEvalTextExpressionInternal(expr, shape, MS_FALSE);
 }
 
-double msEvalDoubleExpression(expressionObj *expression, shapeObj *shape)
-{
+double msEvalDoubleExpression(expressionObj *expression, shapeObj *shape) {
   double value;
   int status;
   parseObj p;
@@ -838,8 +929,8 @@ double msEvalDoubleExpression(expression
   p.type = MS_PARSE_TYPE_STRING;
   status = yyparse(&p);
   if (status != 0) {
-    msSetError(MS_PARSEERR, "Failed to parse expression: %s",
-        "bindStyle", expression->string);
+    msSetError(MS_PARSEERR, "Failed to parse expression: %s", "bindStyle",
+               expression->string);
     value = 0.0;
   } else {
     value = atof(p.result.strval);
@@ -848,26 +939,33 @@ double msEvalDoubleExpression(expression
   return value;
 }
 
-char* msShapeGetLabelAnnotation(layerObj *layer, shapeObj *shape, labelObj *lbl) {
+char *msShapeGetLabelAnnotation(layerObj *layer, shapeObj *shape,
+                                labelObj *lbl) {
   assert(shape && lbl);
-  if(lbl->text.string) {
+  if (lbl->text.string) {
     return msEvalTextExpression(&(lbl->text), shape);
-  } else if(layer->class[shape->classindex]->text.string) {
-    return msEvalTextExpression(&(layer->class[shape->classindex]->text), shape);
+  } else if (layer->class[shape->classindex] -> text.string) {
+    return msEvalTextExpression(&(layer->class[shape->classindex] -> text),
+                                shape);
   } else {
-    if (shape->values && layer->labelitemindex >= 0 && shape->values[layer->labelitemindex] && strlen(shape->values[layer->labelitemindex]) )
+    if (shape->values && layer->labelitemindex >= 0 &&
+        shape->values[layer->labelitemindex] &&
+        strlen(shape->values[layer->labelitemindex]))
       return msStrdup(shape->values[layer->labelitemindex]);
-    else if(shape->text)
-      return msStrdup(shape->text); /* last resort but common with iniline features */
+    else if (shape->text)
+      return msStrdup(
+          shape->text); /* last resort but common with iniline features */
   }
   return NULL;
 }
 
-int msGetLabelStatus(mapObj *map, layerObj *layer, shapeObj *shape, labelObj *lbl) {
+int msGetLabelStatus(mapObj *map, layerObj *layer, shapeObj *shape,
+                     labelObj *lbl) {
   assert(layer && lbl);
-  if(!msScaleInBounds(map->scaledenom,lbl->minscaledenom,lbl->maxscaledenom))
+  if (!msScaleInBounds(map->scaledenom, lbl->minscaledenom, lbl->maxscaledenom))
     return MS_OFF;
-  if(msEvalExpression(layer, shape, &(lbl->expression), layer->labelitemindex) != MS_TRUE)
+  if (msEvalExpression(layer, shape, &(lbl->expression),
+                       layer->labelitemindex) != MS_TRUE)
     return MS_OFF;
   /* TODO: check for minfeaturesize here ? */
   return MS_ON;
@@ -878,12 +976,11 @@ int msGetLabelStatus(mapObj *map, layerO
    the value in geo ref (not in pixel) and should have been multiplied by
    the resolution factor.
  */
-int msShapeCheckSize(shapeObj *shape, double minfeaturesize)
-{
-  double dx = (shape->bounds.maxx-shape->bounds.minx);
-  double dy = (shape->bounds.maxy-shape->bounds.miny);
+int msShapeCheckSize(shapeObj *shape, double minfeaturesize) {
+  double dx = (shape->bounds.maxx - shape->bounds.minx);
+  double dy = (shape->bounds.maxy - shape->bounds.miny);
 
-  if (pow(minfeaturesize,2.0) > (pow(dx,2.0)+pow(dy,2.0)))
+  if (pow(minfeaturesize, 2.0) > (pow(dx, 2.0) + pow(dy, 2.0)))
     return MS_FALSE;
 
   return MS_TRUE;
@@ -892,45 +989,49 @@ int msShapeCheckSize(shapeObj *shape, do
 /*
 ** Adjusts an image size in one direction to fit an extent.
 */
-int msAdjustImage(rectObj rect, int *width, int *height)
-{
-  if(*width == -1 && *height == -1) {
-    msSetError(MS_MISCERR, "Cannot calculate both image height and width.", "msAdjustImage()");
-    return(-1);
+int msAdjustImage(rectObj rect, int *width, int *height) {
+  if (*width == -1 && *height == -1) {
+    msSetError(MS_MISCERR, "Cannot calculate both image height and width.",
+               "msAdjustImage()");
+    return (-1);
   }
 
-  if(*width > 0)
-    *height = MS_NINT((rect.maxy - rect.miny)/((rect.maxx - rect.minx)/(*width)));
+  if (*width > 0)
+    *height =
+        MS_NINT((rect.maxy - rect.miny) / ((rect.maxx - rect.minx) / (*width)));
   else
-    *width = MS_NINT((rect.maxx - rect.minx)/((rect.maxy - rect.miny)/(*height)));
+    *width = MS_NINT((rect.maxx - rect.minx) /
+                     ((rect.maxy - rect.miny) / (*height)));
 
-  return(0);
+  return (0);
 }
 
 /*
-** Make sure extent fits image window to be created. Returns cellsize of output image.
+** Make sure extent fits image window to be created. Returns cellsize of output
+*image.
 */
-double msAdjustExtent(rectObj *rect, int width, int height)
-{
+double msAdjustExtent(rectObj *rect, int width, int height) {
   double cellsize, ox, oy;
 
-  if(width == 1 || height == 1)
+  if (width == 1 || height == 1)
     return 0;
 
-  cellsize = MS_MAX(MS_CELLSIZE(rect->minx, rect->maxx, width), MS_CELLSIZE(rect->miny, rect->maxy, height));
+  cellsize = MS_MAX(MS_CELLSIZE(rect->minx, rect->maxx, width),
+                    MS_CELLSIZE(rect->miny, rect->maxy, height));
 
-  if(cellsize <= 0) /* avoid division by zero errors */
-    return(0);
+  if (cellsize <= 0) /* avoid division by zero errors */
+    return (0);
 
-  ox = MS_MAX(((width-1) - (rect->maxx - rect->minx)/cellsize)/2,0); /* these were width-1 and height-1 */
-  oy = MS_MAX(((height-1) - (rect->maxy - rect->miny)/cellsize)/2,0);
+  ox = MS_MAX(((width - 1) - (rect->maxx - rect->minx) / cellsize) / 2,
+              0); /* these were width-1 and height-1 */
+  oy = MS_MAX(((height - 1) - (rect->maxy - rect->miny) / cellsize) / 2, 0);
+
+  rect->minx = rect->minx - ox * cellsize;
+  rect->miny = rect->miny - oy * cellsize;
+  rect->maxx = rect->maxx + ox * cellsize;
+  rect->maxy = rect->maxy + oy * cellsize;
 
-  rect->minx = rect->minx - ox*cellsize;
-  rect->miny = rect->miny - oy*cellsize;
-  rect->maxx = rect->maxx + ox*cellsize;
-  rect->maxy = rect->maxy + oy*cellsize;
-
-  return(cellsize);
+  return (cellsize);
 }
 
 /*
@@ -938,31 +1039,30 @@ double msAdjustExtent(rectObj *rect, int
 ** shifted to overlap by overlay percent. The dimensions of rect do
 ** not change but placement relative to bounds can.
 */
-int msConstrainExtent(rectObj *bounds, rectObj *rect, double overlay)
-{
+int msConstrainExtent(rectObj *bounds, rectObj *rect, double overlay) {
   /* check left edge, and if necessary the right edge of bounds */
-  if(rect->maxx <= bounds->minx) {
-    const double offset = overlay*(rect->maxx - rect->minx);
+  if (rect->maxx <= bounds->minx) {
+    const double offset = overlay * (rect->maxx - rect->minx);
     rect->minx += offset; /* shift right */
     rect->maxx += offset;
-  } else if(rect->minx >= bounds->maxx) {
-    const double offset = overlay*(rect->maxx - rect->minx);
+  } else if (rect->minx >= bounds->maxx) {
+    const double offset = overlay * (rect->maxx - rect->minx);
     rect->minx -= offset; /* shift left */
     rect->maxx -= offset;
   }
 
   /* check top edge, and if necessary the bottom edge of bounds */
-  if(rect->maxy <= bounds->miny) {
-    const double offset = overlay*(rect->maxy - rect->miny);
+  if (rect->maxy <= bounds->miny) {
+    const double offset = overlay * (rect->maxy - rect->miny);
     rect->miny -= offset; /* shift down */
     rect->maxy -= offset;
-  } else if(rect->miny >= bounds->maxy) {
-    const double offset = overlay*(rect->maxy - rect->miny);
+  } else if (rect->miny >= bounds->maxy) {
+    const double offset = overlay * (rect->maxy - rect->miny);
     rect->miny += offset; /* shift up */
     rect->maxy += offset;
   }
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
 /*
@@ -977,76 +1077,72 @@ int msConstrainExtent(rectObj *bounds, r
 ** The filename is NULL when the image is supposed to be written to stdout.
 */
 
-int msSaveImage(mapObj *map, imageObj *img, const char *filename)
-{
+int msSaveImage(mapObj *map, imageObj *img, const char *filename) {
   int nReturnVal = MS_FAILURE;
   char szPath[MS_MAXPATHLEN];
-  struct mstimeval starttime={0}, endtime={0};
+  struct mstimeval starttime = {0}, endtime = {0};
 
-  if(map && map->debug >= MS_DEBUGLEVEL_TUNING) {
+  if (map && map->debug >= MS_DEBUGLEVEL_TUNING) {
     msGettimeofday(&starttime, NULL);
   }
 
   if (img) {
-    if( MS_DRIVER_GDAL(img->format) ) {
-      if (map != NULL && filename != NULL )
-        nReturnVal = msSaveImageGDAL(map, img,
-                                     msBuildPath(szPath, map->mappath,
-                                         filename));
+    if (MS_DRIVER_GDAL(img->format)) {
+      if (map != NULL && filename != NULL)
+        nReturnVal = msSaveImageGDAL(
+            map, img, msBuildPath(szPath, map->mappath, filename));
       else
         nReturnVal = msSaveImageGDAL(map, img, filename);
     } else
 
-      if (MS_RENDERER_PLUGIN(img->format)) {
-        rendererVTableObj *renderer = img->format->vtable;
-        FILE *stream = NULL;
-        if(filename) {
-          if(map)
-            stream = fopen(msBuildPath(szPath, map->mappath, filename),"wb");
-          else
-            stream = fopen(filename,"wb");
-
-          if(!stream) {
-            msSetError(MS_IOERR,
-                       "Failed to create output file (%s).",
-                       "msSaveImage()", (map?szPath:filename) );
-            return MS_FAILURE;
-          }
+        if (MS_RENDERER_PLUGIN(img->format)) {
+      rendererVTableObj *renderer = img->format->vtable;
+      FILE *stream = NULL;
+      if (filename) {
+        if (map)
+          stream = fopen(msBuildPath(szPath, map->mappath, filename), "wb");
+        else
+          stream = fopen(filename, "wb");
 
-        } else {
-          if ( msIO_needBinaryStdout() == MS_FAILURE )
-            return MS_FAILURE;
-          stream = stdout;
+        if (!stream) {
+          msSetError(MS_IOERR, "Failed to create output file (%s).",
+                     "msSaveImage()", (map ? szPath : filename));
+          return MS_FAILURE;
         }
 
-        if(renderer->supports_pixel_buffer) {
-          rasterBufferObj data;
-          if(renderer->getRasterBufferHandle(img,&data) != MS_SUCCESS) {
-            if( stream != stdout )
-              fclose(stream);
-            return MS_FAILURE;
-          }
+      } else {
+        if (msIO_needBinaryStdout() == MS_FAILURE)
+          return MS_FAILURE;
+        stream = stdout;
+      }
 
-          nReturnVal = msSaveRasterBuffer(map,&data,stream,img->format );
-        } else {
-          nReturnVal = renderer->saveImage(img, map, stream, img->format);
+      if (renderer->supports_pixel_buffer) {
+        rasterBufferObj data;
+        if (renderer->getRasterBufferHandle(img, &data) != MS_SUCCESS) {
+          if (stream != stdout)
+            fclose(stream);
+          return MS_FAILURE;
         }
-        if( stream != stdout )
-          fclose(stream);
 
-      } else if( MS_DRIVER_IMAGEMAP(img->format) )
-        nReturnVal = msSaveImageIM(img, filename, img->format);
-      else
-        msSetError(MS_MISCERR, "Unknown image type",
-                   "msSaveImage()");
+        nReturnVal = msSaveRasterBuffer(map, &data, stream, img->format);
+      } else {
+        nReturnVal = renderer->saveImage(img, map, stream, img->format);
+      }
+      if (stream != stdout)
+        fclose(stream);
+
+    } else if (MS_DRIVER_IMAGEMAP(img->format))
+      nReturnVal = msSaveImageIM(img, filename, img->format);
+    else
+      msSetError(MS_MISCERR, "Unknown image type", "msSaveImage()");
   }
 
-  if(map && map->debug >= MS_DEBUGLEVEL_TUNING) {
+  if (map && map->debug >= MS_DEBUGLEVEL_TUNING) {
     msGettimeofday(&endtime, NULL);
     msDebug("msSaveImage(%s) total time: %.3fs\n",
             (filename ? filename : "stdout"),
-            (endtime.tv_sec+endtime.tv_usec/1.0e6)-
-            (starttime.tv_sec+starttime.tv_usec/1.0e6) );
+            (endtime.tv_sec + endtime.tv_usec / 1.0e6) -
+                (starttime.tv_sec + starttime.tv_usec / 1.0e6));
   }
 
   return nReturnVal;
@@ -1062,20 +1158,20 @@ int msSaveImage(mapObj *map, imageObj *i
 ** The function returns NULL if the output format is not supported.
 */
 
-unsigned char *msSaveImageBuffer(imageObj* image, int *size_ptr, outputFormatObj *format)
-{
+unsigned char *msSaveImageBuffer(imageObj *image, int *size_ptr,
+                                 outputFormatObj *format) {
   *size_ptr = 0;
-  if( MS_RENDERER_PLUGIN(image->format)) {
+  if (MS_RENDERER_PLUGIN(image->format)) {
     rasterBufferObj data;
     rendererVTableObj *renderer = image->format->vtable;
-    if(renderer->supports_pixel_buffer) {
+    if (renderer->supports_pixel_buffer) {
       bufferObj buffer;
       msBufferInit(&buffer);
-      const int status = renderer->getRasterBufferHandle(image,&data);
-      if(MS_UNLIKELY(status == MS_FAILURE)) {
+      const int status = renderer->getRasterBufferHandle(image, &data);
+      if (MS_UNLIKELY(status == MS_FAILURE)) {
         return NULL;
       }
-      msSaveRasterBufferToBuffer(&data,&buffer,format);
+      msSaveRasterBufferToBuffer(&data, &buffer, format);
       *size_ptr = buffer.size;
       return buffer.data;
       /* don't free the bufferObj as we don't own the bytes anymore */
@@ -1095,13 +1191,12 @@ unsigned char *msSaveImageBuffer(imageOb
 /**
  * Generic function to free the imageObj
  */
-void msFreeImage(imageObj *image)
-{
+void msFreeImage(imageObj *image) {
   if (image) {
-    if(MS_RENDERER_PLUGIN(image->format)) {
+    if (MS_RENDERER_PLUGIN(image->format)) {
       rendererVTableObj *renderer = image->format->vtable;
-      tileCacheObj *next,*cur = image->tilecache;
-      while(cur) {
+      tileCacheObj *next, *cur = image->tilecache;
+      while (cur) {
         msFreeImage(cur->image);
         next = cur->next;
         free(cur);
@@ -1109,29 +1204,28 @@ void msFreeImage(imageObj *image)
       }
       image->ntiles = 0;
       renderer->freeImage(image);
-    } else if( MS_RENDERER_IMAGEMAP(image->format) )
+    } else if (MS_RENDERER_IMAGEMAP(image->format))
       msFreeImageIM(image);
-    else if( MS_RENDERER_RAWDATA(image->format) )
+    else if (MS_RENDERER_RAWDATA(image->format))
       msFree(image->img.raw_16bit);
     else
-      msSetError(MS_MISCERR, "Unknown image type",
-                 "msFreeImage()");
+      msSetError(MS_MISCERR, "Unknown image type", "msFreeImage()");
 
     if (image->imagepath)
       free(image->imagepath);
     if (image->imageurl)
       free(image->imageurl);
 
-    if( --image->format->refcount < 1 )
-      msFreeOutputFormat( image->format );
+    if (--image->format->refcount < 1)
+      msFreeOutputFormat(image->format);
 
     image->imagepath = NULL;
     image->imageurl = NULL;
 
-    msFree( image->img_mask );
-    image->img_mask= NULL;
+    msFree(image->img_mask);
+    image->img_mask = NULL;
 
-    msFree( image );
+    msFree(image);
   }
 }
 
@@ -1141,22 +1235,21 @@ void msFreeImage(imageObj *image)
 ** to the number of elements in the returned array.
 ** Note : the caller of the function should free the array.
 */
-int *msGetLayersIndexByGroup(mapObj *map, char *groupname, int *pnCount)
-{
-  int         i;
-  int         iLayer = 0;
-  int         *aiIndex;
+int *msGetLayersIndexByGroup(mapObj *map, char *groupname, int *pnCount) {
+  int i;
+  int iLayer = 0;
+  int *aiIndex;
 
-  if(!groupname || !map || !pnCount) {
+  if (!groupname || !map || !pnCount) {
     return NULL;
   }
 
   aiIndex = (int *)msSmallMalloc(sizeof(int) * map->numlayers);
 
-  for(i=0; i<map->numlayers; i++) {
-    if(!GET_LAYER(map, i)->group) /* skip it */
+  for (i = 0; i < map->numlayers; i++) {
+    if (!GET_LAYER(map, i)->group) /* skip it */
       continue;
-    if(strcmp(groupname, GET_LAYER(map, i)->group) == 0) {
+    if (strcmp(groupname, GET_LAYER(map, i)->group) == 0) {
       aiIndex[iLayer] = i;
       iLayer++;
     }
@@ -1167,7 +1260,7 @@ int *msGetLayersIndexByGroup(mapObj *map
     aiIndex = NULL;
     *pnCount = 0;
   } else {
-    aiIndex = (int *)msSmallRealloc(aiIndex, sizeof(int)* iLayer);
+    aiIndex = (int *)msSmallRealloc(aiIndex, sizeof(int) * iLayer);
     *pnCount = iLayer;
   }
 
@@ -1178,7 +1271,6 @@ int *msGetLayersIndexByGroup(mapObj *map
 /*      Measured shape utility functions.                               */
 /* ==================================================================== */
 
-
 /************************************************************************/
 /*        pointObj *msGetPointUsingMeasure(shapeObj *shape, double m)   */
 /*                                                                      */
@@ -1186,32 +1278,31 @@ int *msGetLayersIndexByGroup(mapObj *map
 /*      to.                                                             */
 /*                                                                      */
 /************************************************************************/
-pointObj *msGetPointUsingMeasure(shapeObj *shape, double m)
-{
-  pointObj    *point = NULL;
-  int         bFound = 0;
-  double      dfFirstPointX = 0;
-  double      dfFirstPointY = 0;
-  double      dfFirstPointM = 0;
-  double      dfSecondPointX = 0;
-  double      dfSecondPointY = 0;
-  double      dfSecondPointM = 0;
+pointObj *msGetPointUsingMeasure(shapeObj *shape, double m) {
+  pointObj *point = NULL;
+  int bFound = 0;
+  double dfFirstPointX = 0;
+  double dfFirstPointY = 0;
+  double dfFirstPointM = 0;
+  double dfSecondPointX = 0;
+  double dfSecondPointY = 0;
+  double dfSecondPointM = 0;
 
-  if (shape &&  shape->numlines > 0) {
+  if (shape && shape->numlines > 0) {
     /* -------------------------------------------------------------------- */
     /*      check fir the first value (min) and the last value(max) to      */
     /*      see if the m is contained between these min and max.            */
     /* -------------------------------------------------------------------- */
-    const lineObj* lineFirst = &(shape->line[0]);
+    const lineObj *lineFirst = &(shape->line[0]);
     const double dfMin = lineFirst->point[0].m;
-    const lineObj* lineLast = &(shape->line[shape->numlines-1]);
-    const double dfMax = lineLast->point[lineLast->numpoints-1].m;
+    const lineObj *lineLast = &(shape->line[shape->numlines - 1]);
+    const double dfMax = lineLast->point[lineLast->numpoints - 1].m;
 
     if (m >= dfMin && m <= dfMax) {
-      for (int i=0; i<shape->numlines; i++) {
-        const lineObj* line = &(shape->line[i]);
+      for (int i = 0; i < shape->numlines; i++) {
+        const lineObj *line = &(shape->line[i]);
 
-        for (int j=0; j<line->numpoints; j++) {
+        for (int j = 0; j < line->numpoints; j++) {
           const double dfCurrentM = line->point[j].m;
           if (dfCurrentM > m) {
             bFound = 1;
@@ -1220,17 +1311,19 @@ pointObj *msGetPointUsingMeasure(shapeOb
             dfSecondPointY = line->point[j].y;
             dfSecondPointM = line->point[j].m;
 
-            /* -------------------------------------------------------------------- */
-            /*      get the previous node xy values.                                */
-            /* -------------------------------------------------------------------- */
+            /* --------------------------------------------------------------------
+             */
+            /*      get the previous node xy values. */
+            /* --------------------------------------------------------------------
+             */
             if (j > 0) { /* not the first point of the line */
-              dfFirstPointX = line->point[j-1].x;
-              dfFirstPointY = line->point[j-1].y;
-              dfFirstPointM = line->point[j-1].m;
+              dfFirstPointX = line->point[j - 1].x;
+              dfFirstPointY = line->point[j - 1].y;
+              dfFirstPointM = line->point[j - 1].m;
             } else { /* get last point of previous line */
-              dfFirstPointX = shape->line[i-1].point[0].x;
-              dfFirstPointY = shape->line[i-1].point[0].y;
-              dfFirstPointM = shape->line[i-1].point[0].m;
+              dfFirstPointX = shape->line[i - 1].point[0].x;
+              dfFirstPointY = shape->line[i - 1].point[0].y;
+              dfFirstPointM = shape->line[i - 1].point[0].m;
             }
             break;
           }
@@ -1247,15 +1340,13 @@ pointObj *msGetPointUsingMeasure(shapeOb
 
     double dfFactor = 0;
     if (dfFirstPointM != dfSecondPointM)
-      dfFactor = (m-dfFirstPointM)/(dfSecondPointM - dfFirstPointM);
+      dfFactor = (m - dfFirstPointM) / (dfSecondPointM - dfFirstPointM);
 
     point = (pointObj *)msSmallMalloc(sizeof(pointObj));
 
     point->x = dfFirstPointX + (dfFactor * (dfSecondPointX - dfFirstPointX));
-    point->y = dfFirstPointY +
-               (dfFactor * (dfSecondPointY - dfFirstPointY));
-    point->m = dfFirstPointM +
-               (dfFactor * (dfSecondPointM - dfFirstPointM));
+    point->y = dfFirstPointY + (dfFactor * (dfSecondPointY - dfFirstPointY));
+    point->m = dfFirstPointM + (dfFactor * (dfSecondPointM - dfFirstPointM));
 
     return point;
   }
@@ -1263,7 +1354,6 @@ pointObj *msGetPointUsingMeasure(shapeOb
   return NULL;
 }
 
-
 /************************************************************************/
 /*       IntersectionPointLinepointObj *p, pointObj *a, pointObj *b)    */
 /*                                                                      */
@@ -1276,8 +1366,10 @@ pointObj *msGetPointUsingMeasure(shapeOb
 /*      Subject 1.02:How do I find the distance from a point to a line? */
 /*                                                                      */
 /*          Let the point be C (Cx,Cy) and the line be AB (Ax,Ay) to (Bx,By).*/
-/*          Let P be the point of perpendicular projection of C on AB.  The parameter*/
-/*          r, which indicates P's position along AB, is computed by the dot product */
+/*          Let P be the point of perpendicular projection of C on AB.  The
+ * parameter*/
+/*          r, which indicates P's position along AB, is computed by the dot
+ * product */
 /*          of AC and AB divided by the square of the length of AB:     */
 /*                                                                      */
 /*          (1)     AC dot AB                                           */
@@ -1300,7 +1392,8 @@ pointObj *msGetPointUsingMeasure(shapeOb
 /*                                                                      */
 /*              L = sqrt( (Bx-Ax)^2 + (By-Ay)^2 )                       */
 /*                                                                      */
-/*          and the dot product of two vectors in d dimensions, U dot V is computed:*/
+/*          and the dot product of two vectors in d dimensions, U dot V is
+ * computed:*/
 /*                                                                      */
 /*              D = (Ux * Vx) + (Uy * Vy) + ... + (Ud * Vd)             */
 /*                                                                      */
@@ -1321,7 +1414,8 @@ pointObj *msGetPointUsingMeasure(shapeOb
 /*                                                                      */
 /*          And the distance from A to P = r*L.                         */
 /*                                                                      */
-/*          Use another parameter s to indicate the location along PC, with the */
+/*          Use another parameter s to indicate the location along PC, with the
+ */
 /*          following meaning:                                          */
 /*                 s<0      C is left of AB                             */
 /*                 s>0      C is right of AB                            */
@@ -1337,17 +1431,17 @@ pointObj *msGetPointUsingMeasure(shapeOb
 /*          Then the distance from C to P = |s|*L.                      */
 /*                                                                      */
 /************************************************************************/
-pointObj *msIntersectionPointLine(pointObj *p, pointObj *a, pointObj *b)
-{
+pointObj *msIntersectionPointLine(pointObj *p, pointObj *a, pointObj *b) {
   pointObj *result = NULL;
 
   if (p && a && b) {
-    const double L = sqrt(((b->x - a->x)*(b->x - a->x)) +
-             ((b->y - a->y)*(b->y - a->y)));
+    const double L =
+        sqrt(((b->x - a->x) * (b->x - a->x)) + ((b->y - a->y) * (b->y - a->y)));
 
     double r = 0;
     if (L != 0)
-      r = ((p->x - a->x)*(b->x - a->x) + (p->y - a->y)*(b->y - a->y))/(L*L);
+      r = ((p->x - a->x) * (b->x - a->x) + (p->y - a->y) * (b->y - a->y)) /
+          (L * L);
 
     result = (pointObj *)msSmallMalloc(sizeof(pointObj));
     /* -------------------------------------------------------------------- */
@@ -1366,8 +1460,8 @@ pointObj *msIntersectionPointLine(pointO
       result->x = b->x;
       result->y = b->y;
     } else {
-      result->x = a->x + r*(b->x - a->x);
-      result->y = a->y + r*(b->y - a->y);
+      result->x = a->x + r * (b->x - a->x);
+      result->y = a->y + r * (b->y - a->y);
     }
     result->m = 0;
   }
@@ -1375,7 +1469,6 @@ pointObj *msIntersectionPointLine(pointO
   return result;
 }
 
-
 /************************************************************************/
 /*         pointObj *msGetMeasureUsingPoint(shapeObj *shape, pointObj   */
 /*      *point)                                                         */
@@ -1383,30 +1476,30 @@ pointObj *msIntersectionPointLine(pointO
 /*      Calculate the intersection point betwwen the point and the      */
 /*      shape and return the Measured value at the intersection.        */
 /************************************************************************/
-pointObj *msGetMeasureUsingPoint(shapeObj *shape, pointObj *point)
-{
-  pointObj    oFirst;
-  pointObj    oSecond;
+pointObj *msGetMeasureUsingPoint(shapeObj *shape, pointObj *point) {
+  pointObj oFirst;
+  pointObj oSecond;
 
   if (shape && point) {
-    double      dfMinDist = 1e35;
-    for (int i=0; i<shape->numlines; i++) {
+    double dfMinDist = 1e35;
+    for (int i = 0; i < shape->numlines; i++) {
       lineObj line = shape->line[i];
       /* -------------------------------------------------------------------- */
       /*      for each line (2 consecutive lines) get the distance between    */
       /*      the line and the point and determine which line segment is      */
       /*      the closeset to the point.                                      */
       /* -------------------------------------------------------------------- */
-      for (int j=0; j<line.numpoints-1; j++) {
-        const double dfDist = msDistancePointToSegment(point, &line.point[j], &line.point[j+1]);
+      for (int j = 0; j < line.numpoints - 1; j++) {
+        const double dfDist =
+            msDistancePointToSegment(point, &line.point[j], &line.point[j + 1]);
         if (dfDist < dfMinDist) {
           oFirst.x = line.point[j].x;
           oFirst.y = line.point[j].y;
           oFirst.m = line.point[j].m;
 
-          oSecond.x =  line.point[j+1].x;
-          oSecond.y =  line.point[j+1].y;
-          oSecond.m =  line.point[j+1].m;
+          oSecond.x = line.point[j + 1].x;
+          oSecond.y = line.point[j + 1].y;
+          oSecond.m = line.point[j + 1].m;
 
           dfMinDist = dfDist;
         }
@@ -1417,22 +1510,24 @@ pointObj *msGetMeasureUsingPoint(shapeOb
     /*      which is the nearest intersection between the line and the      */
     /*      point.                                                          */
     /* -------------------------------------------------------------------- */
-    pointObj* poIntersectionPt = msIntersectionPointLine(point, &oFirst, &oSecond);
+    pointObj *poIntersectionPt =
+        msIntersectionPointLine(point, &oFirst, &oSecond);
     if (poIntersectionPt) {
-      const double dfDistTotal = sqrt(((oSecond.x - oFirst.x)*(oSecond.x - oFirst.x)) +
-                         ((oSecond.y - oFirst.y)*(oSecond.y - oFirst.y)));
-
-      const double dfDistToIntersection = sqrt(((poIntersectionPt->x - oFirst.x)*
-                                   (poIntersectionPt->x - oFirst.x)) +
-                                  ((poIntersectionPt->y - oFirst.y)*
-                                   (poIntersectionPt->y - oFirst.y)));
+      const double dfDistTotal =
+          sqrt(((oSecond.x - oFirst.x) * (oSecond.x - oFirst.x)) +
+               ((oSecond.y - oFirst.y) * (oSecond.y - oFirst.y)));
+
+      const double dfDistToIntersection =
+          sqrt(((poIntersectionPt->x - oFirst.x) *
+                (poIntersectionPt->x - oFirst.x)) +
+               ((poIntersectionPt->y - oFirst.y) *
+                (poIntersectionPt->y - oFirst.y)));
 
       const double dfFactor = dfDistToIntersection / dfDistTotal;
 
-      poIntersectionPt->m = oFirst.m + (oSecond.m - oFirst.m)*dfFactor;
+      poIntersectionPt->m = oFirst.m + (oSecond.m - oFirst.m) * dfFactor;
       return poIntersectionPt;
     }
-
   }
   return NULL;
 }
@@ -1441,40 +1536,37 @@ pointObj *msGetMeasureUsingPoint(shapeOb
 /*   End   Measured shape utility functions.                            */
 /* ==================================================================== */
 
-
-char **msGetAllGroupNames(mapObj *map, int *numTok)
-{
-  char        **papszGroups = NULL;
+char **msGetAllGroupNames(mapObj *map, int *numTok) {
+  char **papszGroups = NULL;
 
   assert(map);
   *numTok = 0;
 
   if (!map->layerorder) {
-    map->layerorder = (int*)msSmallMalloc(map->numlayers * sizeof(int));
+    map->layerorder = (int *)msSmallMalloc(map->numlayers * sizeof(int));
 
     /*
      * Initiate to default order
      */
-    for (int i=0; i<map->numlayers; i++)
+    for (int i = 0; i < map->numlayers; i++)
       map->layerorder[i] = i;
   }
 
   if (map->numlayers > 0) {
     const int nCount = map->numlayers;
-    papszGroups = (char **)msSmallMalloc(sizeof(char *)*nCount);
+    papszGroups = (char **)msSmallMalloc(sizeof(char *) * nCount);
 
-    for (int i=0; i<nCount; i++)
+    for (int i = 0; i < nCount; i++)
       papszGroups[i] = NULL;
 
-    for (int i=0; i<nCount; i++) {
+    for (int i = 0; i < nCount; i++) {
       layerObj *lp;
       lp = (GET_LAYER(map, map->layerorder[i]));
 
       int bFound = 0;
       if (lp->group && lp->status != MS_DELETE) {
-        for (int j=0; j<*numTok; j++) {
-          if (papszGroups[j] &&
-              strcmp(lp->group, papszGroups[j]) == 0) {
+        for (int j = 0; j < *numTok; j++) {
+          if (papszGroups[j] && strcmp(lp->group, papszGroups[j]) == 0) {
             bFound = 1;
             break;
           }
@@ -1486,7 +1578,6 @@ char **msGetAllGroupNames(mapObj *map, i
         }
       }
     }
-
   }
 
   return papszGroups;
@@ -1499,25 +1590,24 @@ char **msGetAllGroupNames(mapObj *map, i
 static int tmpCount = 0;
 static char *ForcedTmpBase = NULL;
 
-void msForceTmpFileBase( const char *new_base )
-{
+void msForceTmpFileBase(const char *new_base) {
   /* -------------------------------------------------------------------- */
   /*      Clear previous setting, if any.                                 */
   /* -------------------------------------------------------------------- */
-  if( ForcedTmpBase != NULL ) {
-    free( ForcedTmpBase );
+  if (ForcedTmpBase != NULL) {
+    free(ForcedTmpBase);
     ForcedTmpBase = NULL;
   }
 
   tmpCount = -1;
 
-  if( new_base == NULL )
+  if (new_base == NULL)
     return;
 
   /* -------------------------------------------------------------------- */
   /*      Record new base.                                                */
   /* -------------------------------------------------------------------- */
-  ForcedTmpBase = msStrdup( new_base );
+  ForcedTmpBase = msStrdup(new_base);
   tmpCount = 0;
 }
 
@@ -1528,8 +1618,8 @@ void msForceTmpFileBase( const char *new
  *
  * Returns char* which must be freed by caller.
  **********************************************************************/
-char *msTmpFile(mapObj *map, const char *mappath, const char *tmppath, const char *ext)
-{
+char *msTmpFile(mapObj *map, const char *mappath, const char *tmppath,
+                const char *ext) {
   char szPath[MS_MAXPATHLEN];
   const char *fullFname;
   char *tmpFileName; /* big enough for time + pid + ext */
@@ -1556,8 +1646,7 @@ char *msTmpFile(mapObj *map, const char
  *
  * Returns char* which must be freed by caller.
  **********************************************************************/
-char *msTmpPath(mapObj *map, const char *mappath, const char *tmppath)
-{
+char *msTmpPath(mapObj *map, const char *mappath, const char *tmppath) {
   char szPath[MS_MAXPATHLEN];
   const char *fullPath;
   const char *tmpBase;
@@ -1567,7 +1656,7 @@ char *msTmpPath(mapObj *map, const char
   TCHAR lpTempPathBuffer[MAX_PATH];
 #endif
 
-  if( ForcedTmpBase != NULL )
+  if (ForcedTmpBase != NULL)
     tmpBase = ForcedTmpBase;
   else if (tmppath != NULL)
     tmpBase = tmppath;
@@ -1579,12 +1668,12 @@ char *msTmpPath(mapObj *map, const char
 #ifndef _WIN32
     tmpBase = "/tmp/";
 #else
-    dwRetVal =  GetTempPath(MAX_PATH,          /* length of the buffer */
-                            lpTempPathBuffer); /* buffer for path */
+    dwRetVal = GetTempPath(MAX_PATH,          /* length of the buffer */
+                           lpTempPathBuffer); /* buffer for path */
     if (dwRetVal > MAX_PATH || (dwRetVal == 0)) {
       tmpBase = "C:\\";
     } else {
-      tmpBase = (char*)lpTempPathBuffer;
+      tmpBase = (char *)lpTempPathBuffer;
     }
 #endif
   }
@@ -1600,22 +1689,22 @@ char *msTmpPath(mapObj *map, const char
  *
  * Returns char* which must be freed by caller.
  **********************************************************************/
-char *msTmpFilename(const char *ext)
-{
+char *msTmpFilename(const char *ext) {
   char *tmpFname;
   int tmpFnameBufsize;
   char *fullFname;
   char tmpId[128]; /* big enough for time + pid + ext */
 
-  snprintf(tmpId, sizeof(tmpId), "%lx_%x",(long)time(NULL),(int)getpid());
+  snprintf(tmpId, sizeof(tmpId), "%lx_%x", (long)time(NULL), (int)getpid());
 
-  if (ext == NULL)  ext = "";
+  if (ext == NULL)
+    ext = "";
   tmpFnameBufsize = strlen(tmpId) + 10 + strlen(ext) + 1;
-  tmpFname = (char*)msSmallMalloc(tmpFnameBufsize);
+  tmpFname = (char *)msSmallMalloc(tmpFnameBufsize);
 
-  msAcquireLock( TLOCK_TMPFILE );
+  msAcquireLock(TLOCK_TMPFILE);
   snprintf(tmpFname, tmpFnameBufsize, "%s_%x.%s", tmpId, tmpCount++, ext);
-  msReleaseLock( TLOCK_TMPFILE );
+  msReleaseLock(TLOCK_TMPFILE);
 
   fullFname = msStrdup(tmpFname);
   free(tmpFname);
@@ -1628,14 +1717,14 @@ char *msTmpFilename(const char *ext)
  */
 imageObj *msImageCreate(int width, int height, outputFormatObj *format,
                         char *imagepath, char *imageurl, double resolution,
-                        double defresolution, colorObj *bg)
-{
+                        double defresolution, colorObj *bg) {
   imageObj *image = NULL;
-  if(MS_RENDERER_PLUGIN(format)) {
+  if (MS_RENDERER_PLUGIN(format)) {
 
-    image = format->vtable->createImage(width,height,format,bg);
+    image = format->vtable->createImage(width, height, format, bg);
     if (image == NULL) {
-      msSetError(MS_MEMERR, "Unable to create new image object.", "msImageCreate()");
+      msSetError(MS_MEMERR, "Unable to create new image object.",
+                 "msImageCreate()");
       return NULL;
     }
 
@@ -1649,47 +1738,48 @@ imageObj *msImageCreate(int width, int h
     image->tilecache = NULL;
     image->ntiles = 0;
     image->resolution = resolution;
-    image->resolutionfactor = resolution/defresolution;
+    image->resolutionfactor = resolution / defresolution;
 
     if (imagepath)
       image->imagepath = msStrdup(imagepath);
     if (imageurl)
       image->imageurl = msStrdup(imageurl);
-  } else if( MS_RENDERER_RAWDATA(format) ) {
-    if( format->imagemode != MS_IMAGEMODE_INT16
-        && format->imagemode != MS_IMAGEMODE_FLOAT32
-        && format->imagemode != MS_IMAGEMODE_BYTE ) {
+  } else if (MS_RENDERER_RAWDATA(format)) {
+    if (format->imagemode != MS_IMAGEMODE_INT16 &&
+        format->imagemode != MS_IMAGEMODE_FLOAT32 &&
+        format->imagemode != MS_IMAGEMODE_BYTE) {
       msSetError(MS_IMGERR,
                  "Attempt to use illegal imagemode with rawdata renderer.",
-                 "msImageCreate()" );
+                 "msImageCreate()");
       return NULL;
     }
 
-    image = (imageObj *)calloc(1,sizeof(imageObj));
+    image = (imageObj *)calloc(1, sizeof(imageObj));
     if (image == NULL) {
-      msSetError(MS_MEMERR, "Unable to create new image object.", "msImageCreate()");
+      msSetError(MS_MEMERR, "Unable to create new image object.",
+                 "msImageCreate()");
       return NULL;
     }
 
-    if( format->imagemode == MS_IMAGEMODE_INT16 )
-      image->img.raw_16bit = (short *)
-                             msSmallCalloc(sizeof(short),width*height*format->bands);
-    else if( format->imagemode == MS_IMAGEMODE_FLOAT32 )
-      image->img.raw_float = (float *)
-                             msSmallCalloc(sizeof(float),width*height*format->bands);
-    else if( format->imagemode == MS_IMAGEMODE_BYTE )
-      image->img.raw_byte = (unsigned char *)
-                            msSmallCalloc(sizeof(unsigned char),width*height*format->bands);
+    if (format->imagemode == MS_IMAGEMODE_INT16)
+      image->img.raw_16bit =
+          (short *)msSmallCalloc(sizeof(short), width * height * format->bands);
+    else if (format->imagemode == MS_IMAGEMODE_FLOAT32)
+      image->img.raw_float =
+          (float *)msSmallCalloc(sizeof(float), width * height * format->bands);
+    else if (format->imagemode == MS_IMAGEMODE_BYTE)
+      image->img.raw_byte = (unsigned char *)msSmallCalloc(
+          sizeof(unsigned char), width * height * format->bands);
 
-    if( image->img.raw_16bit == NULL ) {
-      msFree( image );
+    if (image->img.raw_16bit == NULL) {
+      msFree(image);
       msSetError(MS_IMGERR,
                  "Attempt to allocate raw image failed, out of memory.",
-                 "msImageCreate()" );
+                 "msImageCreate()");
       return NULL;
     }
 
-    image->img_mask = msAllocBitArray( width*height );
+    image->img_mask = msAllocBitArray(width * height);
 
     image->format = format;
     format->refcount++;
@@ -1699,7 +1789,7 @@ imageObj *msImageCreate(int width, int h
     image->imagepath = NULL;
     image->imageurl = NULL;
     image->resolution = resolution;
-    image->resolutionfactor = resolution/defresolution;
+    image->resolutionfactor = resolution / defresolution;
 
     if (imagepath)
       image->imagepath = msStrdup(imagepath);
@@ -1707,29 +1797,29 @@ imageObj *msImageCreate(int width, int h
       image->imageurl = msStrdup(imageurl);
 
     /* initialize to requested nullvalue if there is one */
-    const char *nullvalue = msGetOutputFormatOption(image->format,
-                              "NULLVALUE",NULL);
-    if( nullvalue != NULL ) {
+    const char *nullvalue =
+        msGetOutputFormatOption(image->format, "NULLVALUE", NULL);
+    if (nullvalue != NULL) {
       int i = image->width * image->height * format->bands;
-      if( atof(nullvalue) == 0.0 )
+      if (atof(nullvalue) == 0.0)
         /* nothing to do */;
-      else if( format->imagemode == MS_IMAGEMODE_INT16 ) {
+      else if (format->imagemode == MS_IMAGEMODE_INT16) {
         short nv = atoi(nullvalue);
-        for( ; i > 0; )
+        for (; i > 0;)
           image->img.raw_16bit[--i] = nv;
-      } else if( format->imagemode == MS_IMAGEMODE_FLOAT32 ) {
+      } else if (format->imagemode == MS_IMAGEMODE_FLOAT32) {
         float nv = atof(nullvalue);
-        for( ; i > 0; )
+        for (; i > 0;)
           image->img.raw_float[--i] = nv;
-      } else if( format->imagemode == MS_IMAGEMODE_BYTE ) {
-        unsigned char nv = (unsigned char) atoi(nullvalue);
+      } else if (format->imagemode == MS_IMAGEMODE_BYTE) {
+        unsigned char nv = (unsigned char)atoi(nullvalue);
 
-        memset( image->img.raw_byte, nv, i );
+        memset(image->img.raw_byte, nv, i);
       }
     }
-  } else if( MS_RENDERER_IMAGEMAP(format) ) {
-    image = msImageCreateIM(width, height, format,
-                            imagepath, imageurl, resolution, defresolution);
+  } else if (MS_RENDERER_IMAGEMAP(format)) {
+    image = msImageCreateIM(width, height, format, imagepath, imageurl,
+                            resolution, defresolution);
   } else {
     msSetError(MS_MISCERR,
                "Unsupported renderer requested, unable to initialize image.",
@@ -1737,7 +1827,7 @@ imageObj *msImageCreate(int width, int h
     return NULL;
   }
 
-  if(!image) {
+  if (!image) {
     msSetError(MS_IMGERR, "Unable to initialize image.", "msImageCreate()");
     return NULL;
   }
@@ -1745,119 +1835,111 @@ imageObj *msImageCreate(int width, int h
   return image;
 }
 
-
 /**
  * Generic function to transorm a point.
  *
  */
-void  msTransformPoint(pointObj *point, rectObj *extent, double cellsize,
-                       imageObj *image)
-{
+void msTransformPoint(pointObj *point, rectObj *extent, double cellsize,
+                      imageObj *image) {
   double invcellsize;
   /*We should probabaly have a function defined at all the renders*/
   if (image != NULL && MS_RENDERER_PLUGIN(image->format)) {
-    if(image->format->renderer == MS_RENDER_WITH_KML) {
+    if (image->format->renderer == MS_RENDER_WITH_KML) {
       return;
     }
   }
-  invcellsize = 1.0/cellsize;
+  invcellsize = 1.0 / cellsize;
   point->x = MS_MAP2IMAGE_X_IC_DBL(point->x, extent->minx, invcellsize);
   point->y = MS_MAP2IMAGE_Y_IC_DBL(point->y, extent->maxy, invcellsize);
 }
 
-
 /*
-** Helper functions supplied as part of bug #2868 solution. Consider moving these to
+** Helper functions supplied as part of bug #2868 solution. Consider moving
+*these to
 ** mapprimitive.c for more general use.
 */
 
 /* vector difference */
-static pointObj point_diff(const pointObj a, const pointObj b)
-{
+static pointObj point_diff(const pointObj a, const pointObj b) {
   pointObj retv;
-  retv.x = a.x-b.x;
-  retv.y = a.y-b.y;
-  retv.z = a.z-b.z;
-  retv.m = a.m-b.m;
+  retv.x = a.x - b.x;
+  retv.y = a.y - b.y;
+  retv.z = a.z - b.z;
+  retv.m = a.m - b.m;
   return retv;
 }
 
 /* vector sum */
-static pointObj point_sum(const pointObj a, const pointObj b)
-{
+static pointObj point_sum(const pointObj a, const pointObj b) {
   pointObj retv;
-  retv.x = a.x+b.x;
-  retv.y = a.y+b.y;
-  retv.z = a.z+b.z;
-  retv.m = a.m+b.m;
+  retv.x = a.x + b.x;
+  retv.y = a.y + b.y;
+  retv.z = a.z + b.z;
+  retv.m = a.m + b.m;
   return retv;
 }
 
 /* vector multiply */
-static pointObj point_mul(const pointObj a, double b)
-{
+static pointObj point_mul(const pointObj a, double b) {
   pointObj retv;
-  retv.x = a.x*b;
-  retv.y = a.y*b;
-  retv.z = a.z*b;
-  retv.m = a.m*b;
+  retv.x = a.x * b;
+  retv.y = a.y * b;
+  retv.z = a.z * b;
+  retv.m = a.m * b;
   return retv;
 }
 
 /* vector ??? */
-static double point_abs2(const pointObj a)
-{
-  return a.x*a.x+a.y*a.y+a.z*a.z+a.m*a.m;
+static double point_abs2(const pointObj a) {
+  return a.x * a.x + a.y * a.y + a.z * a.z + a.m * a.m;
 }
 
 /* vector normal */
-static pointObj point_norm(const pointObj a)
-{
+static pointObj point_norm(const pointObj a) {
   double lenmul;
   pointObj retv;
   int norm_vector;
 
-  norm_vector = a.x==0 && a.y==0;
-  norm_vector = norm_vector && a.z==0 && a.m==0;
+  norm_vector = a.x == 0 && a.y == 0;
+  norm_vector = norm_vector && a.z == 0 && a.m == 0;
 
   if (norm_vector)
     return a;
 
-  lenmul=1.0/sqrt(point_abs2(a));  /* this seems to be the costly operation */
+  lenmul =
+      1.0 / sqrt(point_abs2(a)); /* this seems to be the costly operation */
 
-  retv.x = a.x*lenmul;
-  retv.y = a.y*lenmul;
-  retv.z = a.z*lenmul;
-  retv.m = a.m*lenmul;
+  retv.x = a.x * lenmul;
+  retv.y = a.y * lenmul;
+  retv.z = a.z * lenmul;
+  retv.m = a.m * lenmul;
 
   return retv;
 }
 
 /* rotate a vector 90 degrees */
-static pointObj point_rotz90(const pointObj a)
-{
-  double nx=-1.0*a.y, ny=a.x;
-  pointObj retv=a;
-  retv.x=nx;
-  retv.y=ny;
+static pointObj point_rotz90(const pointObj a) {
+  double nx = -1.0 * a.y, ny = a.x;
+  pointObj retv = a;
+  retv.x = nx;
+  retv.y = ny;
   return retv;
 }
 
 /* vector cross product (warning: z and m dimensions are ignored!) */
-static double point_cross(const pointObj a, const pointObj b)
-{
-  return a.x*b.y-a.y*b.x;
+static double point_cross(const pointObj a, const pointObj b) {
+  return a.x * b.y - a.y * b.x;
 }
 
-shapeObj *msOffsetCurve(shapeObj *p, double offset)
-{
+shapeObj *msOffsetCurve(shapeObj *p, double offset) {
   shapeObj *ret;
-  int i, j, first,idx,ok=0;
-#if defined USE_GEOS && (GEOS_VERSION_MAJOR > 3 || (GEOS_VERSION_MAJOR == 3 && GEOS_VERSION_MINOR >= 3))
-  ret = msGEOSOffsetCurve(p,offset);
-  /* GEOS curve offsetting can fail sometimes, we continue with our own implementation
-   if that is the case.*/
-  if(ret)
+  int i, j, first, idx, ok = 0;
+#if defined USE_GEOS && (GEOS_VERSION_MAJOR > 3 ||                             \
+                         (GEOS_VERSION_MAJOR == 3 && GEOS_VERSION_MINOR >= 3))
+  ret = msGEOSOffsetCurve(p, offset);
+  /* GEOS curve offsetting can fail sometimes, we continue with our own
+   implementation if that is the case.*/
+  if (ret)
     return ret;
   /* clear error raised by geos in this case */
   msResetErrorList();
@@ -1868,113 +1950,126 @@ shapeObj *msOffsetCurve(shapeObj *p, dou
   ** limit for sin().
   */
 #define CURVE_SIN_LIMIT 0.3
-  ret = (shapeObj*)msSmallMalloc(sizeof(shapeObj));
+  ret = (shapeObj *)msSmallMalloc(sizeof(shapeObj));
   msInitShape(ret);
   ret->numlines = p->numlines;
-  ret->line=(lineObj*)msSmallMalloc(sizeof(lineObj)*ret->numlines);
-  for(i=0; i<ret->numlines; i++) {
-    ret->line[i].numpoints=p->line[i].numpoints;
-    ret->line[i].point=(pointObj*)msSmallMalloc(sizeof(pointObj)*ret->line[i].numpoints);
+  ret->line = (lineObj *)msSmallMalloc(sizeof(lineObj) * ret->numlines);
+  for (i = 0; i < ret->numlines; i++) {
+    ret->line[i].numpoints = p->line[i].numpoints;
+    ret->line[i].point =
+        (pointObj *)msSmallMalloc(sizeof(pointObj) * ret->line[i].numpoints);
   }
   for (i = 0; i < p->numlines; i++) {
     pointObj old_diffdir, old_offdir;
-    if(p->line[i].numpoints<2) {
+    if (p->line[i].numpoints < 2) {
       ret->line[i].numpoints = 0;
       continue; /* skip degenerate points */
     }
     ok = 1;
-    /* initialize old_offdir and old_diffdir, as gcc isn't smart enough to see that it
-     * is not an error to do so, and prints a warning */
-    old_offdir.x=old_offdir.y=old_diffdir.x=old_diffdir.y = 0;
+    /* initialize old_offdir and old_diffdir, as gcc isn't smart enough to see
+     * that it is not an error to do so, and prints a warning */
+    old_offdir.x = old_offdir.y = old_diffdir.x = old_diffdir.y = 0;
 
-    idx=0;
+    idx = 0;
     first = 1;
 
     /* saved metrics of the last processed point */
-    pointObj old_pt=p->line[i].point[0];
-    for(j=1; j<p->line[i].numpoints; j++) {
+    pointObj old_pt = p->line[i].point[0];
+    for (j = 1; j < p->line[i].numpoints; j++) {
       const pointObj pt = p->line[i].point[j]; /* place of the point */
-      const pointObj diffdir = point_norm(point_diff(pt,old_pt)); /* direction of the line */
-      const pointObj offdir = point_rotz90(diffdir); /* direction where the distance between the line and the offset is measured */
+      const pointObj diffdir =
+          point_norm(point_diff(pt, old_pt)); /* direction of the line */
+      const pointObj offdir =
+          point_rotz90(diffdir); /* direction where the distance between the
+                                    line and the offset is measured */
       pointObj offpt; /* this will be the corner point of the offset line */
 
       /* offset line points computation */
-      if(first == 1) { /* first point */
+      if (first == 1) { /* first point */
         first = 0;
-        offpt = point_sum(old_pt,point_mul(offdir,offset));
+        offpt = point_sum(old_pt, point_mul(offdir, offset));
       } else { /* middle points */
-        /* curve is the angle of the last and the current line's direction (supplementary angle of the shape's inner angle) */
-        double sin_curve = point_cross(diffdir,old_diffdir);
-        double cos_curve = point_cross(old_offdir,diffdir);
-        if ((-1.0)*CURVE_SIN_LIMIT < sin_curve && sin_curve < CURVE_SIN_LIMIT) {
-          /* do not calculate 1/sin, instead use a corner point approximation: average of the last and current offset direction and length */
+        /* curve is the angle of the last and the current line's direction
+         * (supplementary angle of the shape's inner angle) */
+        double sin_curve = point_cross(diffdir, old_diffdir);
+        double cos_curve = point_cross(old_offdir, diffdir);
+        if ((-1.0) * CURVE_SIN_LIMIT < sin_curve &&
+            sin_curve < CURVE_SIN_LIMIT) {
+          /* do not calculate 1/sin, instead use a corner point approximation:
+           * average of the last and current offset direction and length */
 
           /*
           ** TODO: fair for obtuse inner angles, however, positive and negative
           ** acute inner angles would need special handling - similar to LINECAP
           ** to avoid drawing of long spikes
           */
-          offpt = point_sum(old_pt, point_mul(point_sum(offdir, old_offdir),0.5*offset));
+          offpt = point_sum(
+              old_pt, point_mul(point_sum(offdir, old_offdir), 0.5 * offset));
         } else {
-          double base_shift = -1.0*(1.0+cos_curve)/sin_curve;
-          offpt = point_sum(old_pt, point_mul(point_sum(point_mul(diffdir,base_shift),offdir), offset));
+          double base_shift = -1.0 * (1.0 + cos_curve) / sin_curve;
+          offpt = point_sum(
+              old_pt,
+              point_mul(point_sum(point_mul(diffdir, base_shift), offdir),
+                        offset));
         }
       }
-      ret->line[i].point[idx]=offpt;
+      ret->line[i].point[idx] = offpt;
       idx++;
-      old_pt=pt;
-      old_diffdir=diffdir;
-      old_offdir=offdir;
+      old_pt = pt;
+      old_diffdir = diffdir;
+      old_offdir = offdir;
     }
 
     /* last point */
-    if(first == 0) {
-      pointObj offpt=point_sum(old_pt,point_mul(old_offdir,offset));
-      ret->line[i].point[idx]=offpt;
+    if (first == 0) {
+      pointObj offpt = point_sum(old_pt, point_mul(old_offdir, offset));
+      ret->line[i].point[idx] = offpt;
       idx++;
     }
 
-    if(idx != p->line[i].numpoints) {
+    if (idx != p->line[i].numpoints) {
       /* printf("shouldn't happen :(\n"); */
-      ret->line[i].numpoints=idx;
-      ret->line=msSmallRealloc(ret->line,ret->line[i].numpoints*sizeof(pointObj));
+      ret->line[i].numpoints = idx;
+      ret->line =
+          msSmallRealloc(ret->line, ret->line[i].numpoints * sizeof(pointObj));
     }
   }
-  if(!ok) ret->numlines = 0; /* all lines where degenerate */
+  if (!ok)
+    ret->numlines = 0; /* all lines where degenerate */
   return ret;
 }
 
-shapeObj *msOffsetPolyline(shapeObj *p, double offsetx, double offsety)
-{
+shapeObj *msOffsetPolyline(shapeObj *p, double offsetx, double offsety) {
   int i, j;
   shapeObj *ret;
-  if(offsety == MS_STYLE_SINGLE_SIDED_OFFSET) { /* complex calculations */
-    return msOffsetCurve(p,offsetx);
-  } else if(offsety == MS_STYLE_DOUBLE_SIDED_OFFSET) {
+  if (offsety == MS_STYLE_SINGLE_SIDED_OFFSET) { /* complex calculations */
+    return msOffsetCurve(p, offsetx);
+  } else if (offsety == MS_STYLE_DOUBLE_SIDED_OFFSET) {
     shapeObj *tmp1;
-    ret = msOffsetCurve(p,offsetx/2.0);
-    tmp1 = msOffsetCurve(p, -offsetx/2.0);
-    for(i=0;i<tmp1->numlines; i++) {
-      msAddLineDirectly(ret,tmp1->line + i);
+    ret = msOffsetCurve(p, offsetx / 2.0);
+    tmp1 = msOffsetCurve(p, -offsetx / 2.0);
+    for (i = 0; i < tmp1->numlines; i++) {
+      msAddLineDirectly(ret, tmp1->line + i);
     }
     msFreeShape(tmp1);
     free(tmp1);
     return ret;
   }
 
-  ret = (shapeObj*)msSmallMalloc(sizeof(shapeObj));
+  ret = (shapeObj *)msSmallMalloc(sizeof(shapeObj));
   msInitShape(ret);
   ret->numlines = p->numlines;
-  ret->line=(lineObj*)msSmallMalloc(sizeof(lineObj)*ret->numlines);
-  for(i=0; i<ret->numlines; i++) {
-    ret->line[i].numpoints=p->line[i].numpoints;
-    ret->line[i].point=(pointObj*)msSmallMalloc(sizeof(pointObj)*ret->line[i].numpoints);
+  ret->line = (lineObj *)msSmallMalloc(sizeof(lineObj) * ret->numlines);
+  for (i = 0; i < ret->numlines; i++) {
+    ret->line[i].numpoints = p->line[i].numpoints;
+    ret->line[i].point =
+        (pointObj *)msSmallMalloc(sizeof(pointObj) * ret->line[i].numpoints);
   }
 
   for (i = 0; i < p->numlines; i++) {
-    for(j=0; j<p->line[i].numpoints; j++) {
-      ret->line[i].point[j].x=p->line[i].point[j].x+offsetx;
-      ret->line[i].point[j].y=p->line[i].point[j].y+offsety;
+    for (j = 0; j < p->line[i].numpoints; j++) {
+      ret->line[i].point[j].x = p->line[i].point[j].x + offsetx;
+      ret->line[i].point[j].y = p->line[i].point[j].y + offsety;
     }
   }
 
@@ -1991,8 +2086,7 @@ shapeObj *msOffsetPolyline(shapeObj *p,
 -------------------------------------------------------------------------------
 */
 
-int msSetup()
-{
+int msSetup() {
 #ifdef _WIN32
   const char *maxfiles = CPLGetConfigOption("MS_MAX_OPEN_FILES", NULL);
   if (maxfiles) {
@@ -2027,7 +2121,6 @@ int msSetup()
 
   msFontCacheSetup();
 
-
   return MS_SUCCESS;
 }
 
@@ -2038,9 +2131,8 @@ int msSetup()
 #include "maplibxml2.h"
 #endif
 #endif
-void msCleanup()
-{
-  msForceTmpFileBase( NULL );
+void msCleanup() {
+  msForceTmpFileBase(NULL);
   msConnPoolFinalCleanup();
   /* Lexer string parsing variable */
   if (msyystring_buffer != NULL) {
@@ -2053,23 +2145,23 @@ void msCleanup()
   msGDALCleanup();
 
   /* Release both GDAL and OGR resources */
-  msAcquireLock( TLOCK_GDAL );
-#if GDAL_VERSION_MAJOR >= 3 || (GDAL_VERSION_MAJOR == 2 && GDAL_VERSION_MINOR == 4)
+  msAcquireLock(TLOCK_GDAL);
+#if GDAL_VERSION_MAJOR >= 3 ||                                                 \
+    (GDAL_VERSION_MAJOR == 2 && GDAL_VERSION_MINOR == 4)
   /* Cleanup some GDAL global resources in particular */
   GDALDestroy();
 #else
   GDALDestroyDriverManager();
 #endif
-  msReleaseLock( TLOCK_GDAL );
-
+  msReleaseLock(TLOCK_GDAL);
 
 #if PROJ_VERSION_MAJOR < 6
-#  if PJ_VERSION >= 480
+#if PJ_VERSION >= 480
   pj_clear_initcache();
-#  endif
+#endif
   pj_deallocate_grids();
 #endif
-  msSetPROJ_DATA( NULL, NULL );
+  msSetPROJ_DATA(NULL, NULL);
   msProjectionContextPoolCleanup();
 
 #if defined(USE_CURL)
@@ -2118,22 +2210,21 @@ void msCleanup()
 /*      NOTE: alpha_dst may be NULL.                                    */
 /************************************************************************/
 
-void msAlphaBlend( unsigned char red_src, unsigned char green_src,
-                   unsigned char blue_src, unsigned char alpha_src,
-                   unsigned char *red_dst, unsigned char *green_dst,
-                   unsigned char *blue_dst, unsigned char *alpha_dst )
-{
+void msAlphaBlend(unsigned char red_src, unsigned char green_src,
+                  unsigned char blue_src, unsigned char alpha_src,
+                  unsigned char *red_dst, unsigned char *green_dst,
+                  unsigned char *blue_dst, unsigned char *alpha_dst) {
   /* -------------------------------------------------------------------- */
   /*      Simple cases we want to handle fast.                            */
   /* -------------------------------------------------------------------- */
-  if( alpha_src == 0 )
+  if (alpha_src == 0)
     return;
 
-  if( alpha_src == 255 ) {
+  if (alpha_src == 255) {
     *red_dst = red_src;
     *green_dst = green_src;
     *blue_dst = blue_src;
-    if( alpha_dst )
+    if (alpha_dst)
       *alpha_dst = 255;
     return;
   }
@@ -2141,15 +2232,15 @@ void msAlphaBlend( unsigned char red_src
   /* -------------------------------------------------------------------- */
   /*      Premultiple alpha for source values now.                        */
   /* -------------------------------------------------------------------- */
-  red_src   = red_src * alpha_src / 255;
+  red_src = red_src * alpha_src / 255;
   green_src = green_src * alpha_src / 255;
-  blue_src  = blue_src * alpha_src / 255;
+  blue_src = blue_src * alpha_src / 255;
 
   /* -------------------------------------------------------------------- */
   /*      Another pretty fast case if there is nothing in the             */
   /*      destination to mix with.                                        */
   /* -------------------------------------------------------------------- */
-  if( alpha_dst && *alpha_dst == 0) {
+  if (alpha_dst && *alpha_dst == 0) {
     *red_dst = red_src;
     *green_dst = green_src;
     *blue_dst = blue_src;
@@ -2160,18 +2251,18 @@ void msAlphaBlend( unsigned char red_src
   /* -------------------------------------------------------------------- */
   /*      Cases with actual blending.                                     */
   /* -------------------------------------------------------------------- */
-  if(!alpha_dst || *alpha_dst == 255) {
+  if (!alpha_dst || *alpha_dst == 255) {
     int weight_dst = 256 - alpha_src;
 
-    *red_dst   = (256 * red_src   + *red_dst   * weight_dst) >> 8;
+    *red_dst = (256 * red_src + *red_dst * weight_dst) >> 8;
     *green_dst = (256 * green_src + *green_dst * weight_dst) >> 8;
-    *blue_dst  = (256 * blue_src  + *blue_dst  * weight_dst) >> 8;
+    *blue_dst = (256 * blue_src + *blue_dst * weight_dst) >> 8;
   } else {
-    int   weight_dst = (256 - alpha_src);
+    int weight_dst = (256 - alpha_src);
 
-    *red_dst   = (256 * red_src   + *red_dst   * weight_dst) >> 8;
+    *red_dst = (256 * red_src + *red_dst * weight_dst) >> 8;
     *green_dst = (256 * green_src + *green_dst * weight_dst) >> 8;
-    *blue_dst  = (256 * blue_src  + *blue_dst  * weight_dst) >> 8;
+    *blue_dst = (256 * blue_src + *blue_dst * weight_dst) >> 8;
 
     *alpha_dst = (256 * alpha_src + *alpha_dst * weight_dst) >> 8;
   }
@@ -2184,22 +2275,21 @@ void msAlphaBlend( unsigned char red_src
 /*      assumed to already be premultiplied.                            */
 /************************************************************************/
 
-void msAlphaBlendPM( unsigned char red_src, unsigned char green_src,
-                     unsigned char blue_src, unsigned char alpha_src,
-                     unsigned char *red_dst, unsigned char *green_dst,
-                     unsigned char *blue_dst, unsigned char *alpha_dst )
-{
+void msAlphaBlendPM(unsigned char red_src, unsigned char green_src,
+                    unsigned char blue_src, unsigned char alpha_src,
+                    unsigned char *red_dst, unsigned char *green_dst,
+                    unsigned char *blue_dst, unsigned char *alpha_dst) {
   /* -------------------------------------------------------------------- */
   /*      Simple cases we want to handle fast.                            */
   /* -------------------------------------------------------------------- */
-  if( alpha_src == 0 )
+  if (alpha_src == 0)
     return;
 
-  if( alpha_src == 255 ) {
+  if (alpha_src == 255) {
     *red_dst = red_src;
     *green_dst = green_src;
     *blue_dst = blue_src;
-    if( alpha_dst )
+    if (alpha_dst)
       *alpha_dst = 255;
     return;
   }
@@ -2208,7 +2298,7 @@ void msAlphaBlendPM( unsigned char red_s
   /*      Another pretty fast case if there is nothing in the             */
   /*      destination to mix with.                                        */
   /* -------------------------------------------------------------------- */
-  if( alpha_dst && *alpha_dst == 0) {
+  if (alpha_dst && *alpha_dst == 0) {
     *red_dst = red_src;
     *green_dst = green_src;
     *blue_dst = blue_src;
@@ -2219,54 +2309,62 @@ void msAlphaBlendPM( unsigned char red_s
   /* -------------------------------------------------------------------- */
   /*      Cases with actual blending.                                     */
   /* -------------------------------------------------------------------- */
-  if(!alpha_dst || *alpha_dst == 255) {
+  if (!alpha_dst || *alpha_dst == 255) {
     int weight_dst = 255 - alpha_src;
 
-    *red_dst   = (alpha_src * red_src   + *red_dst   * weight_dst) >> 8;
+    *red_dst = (alpha_src * red_src + *red_dst * weight_dst) >> 8;
     *green_dst = (alpha_src * green_src + *green_dst * weight_dst) >> 8;
-    *blue_dst  = (alpha_src * blue_src  + *blue_dst  * weight_dst) >> 8;
+    *blue_dst = (alpha_src * blue_src + *blue_dst * weight_dst) >> 8;
   } else {
-    int   weight_dst = (255 - alpha_src);
+    int weight_dst = (255 - alpha_src);
 
-    *red_dst   = (alpha_src * red_src   + *red_dst   * weight_dst) >> 8;
+    *red_dst = (alpha_src * red_src + *red_dst * weight_dst) >> 8;
     *green_dst = (alpha_src * green_src + *green_dst * weight_dst) >> 8;
-    *blue_dst  = (alpha_src * blue_src  + *blue_dst  * weight_dst) >> 8;
+    *blue_dst = (alpha_src * blue_src + *blue_dst * weight_dst) >> 8;
 
     *alpha_dst = (255 * alpha_src + *alpha_dst * weight_dst) >> 8;
   }
 }
 
 void msRGBtoHSL(colorObj *rgb, double *h, double *s, double *l) {
-  double r = rgb->red/255.0, g = rgb->green/255.0, b = rgb->blue/255.0;
+  double r = rgb->red / 255.0, g = rgb->green / 255.0, b = rgb->blue / 255.0;
   double maxv = MS_MAX(MS_MAX(r, g), b), minv = MS_MIN(MS_MIN(r, g), b);
   double d = maxv - minv;
 
   *h = 0, *s = 0;
   *l = (maxv + minv) / 2;
 
-  if (maxv != minv)
-  {
+  if (maxv != minv) {
     *s = *l > 0.5 ? d / (2 - maxv - minv) : d / (maxv + minv);
-    if (maxv == r) { *h = (g - b) / d + (g < b ? 6 : 0); }
-    else if (maxv == g) { *h = (b - r) / d + 2; }
-    else if (maxv == b) { *h = (r - g) / d + 4; }
+    if (maxv == r) {
+      *h = (g - b) / d + (g < b ? 6 : 0);
+    } else if (maxv == g) {
+      *h = (b - r) / d + 2;
+    } else if (maxv == b) {
+      *h = (r - g) / d + 4;
+    }
     *h /= 6;
   }
 }
 
 static double hue_to_rgb(double p, double q, double t) {
-  if(t < 0) t += 1;
-  if(t > 1) t -= 1;
-  if(t < 0.1666666666666666) return p + (q - p) * 6 * t;
-  if(t < 0.5) return q;
-  if(t < 0.6666666666666666) return p + (q - p) * (0.666666666666 - t) * 6;
+  if (t < 0)
+    t += 1;
+  if (t > 1)
+    t -= 1;
+  if (t < 0.1666666666666666)
+    return p + (q - p) * 6 * t;
+  if (t < 0.5)
+    return q;
+  if (t < 0.6666666666666666)
+    return p + (q - p) * (0.666666666666 - t) * 6;
   return p;
 }
 
 void msHSLtoRGB(double h, double s, double l, colorObj *rgb) {
   double r, g, b;
 
-  if(s == 0){
+  if (s == 0) {
     r = g = b = l;
   } else {
 
@@ -2284,67 +2382,62 @@ void msHSLtoRGB(double h, double s, doub
 /*
  RFC 24: check if the parent pointer is NULL and raise an error otherwise
 */
-int msCheckParentPointer(void* p, const char *objname)
-{
+int msCheckParentPointer(void *p, const char *objname) {
   if (p == NULL) {
-    if(objname != NULL) {
-      msSetError(MS_NULLPARENTERR, "The %s parent object is null", "msCheckParentPointer()", objname);
+    if (objname != NULL) {
+      msSetError(MS_NULLPARENTERR, "The %s parent object is null",
+                 "msCheckParentPointer()", objname);
     } else {
-      msSetError(MS_NULLPARENTERR, "The parent object is null", "msCheckParentPointer()");
+      msSetError(MS_NULLPARENTERR, "The parent object is null",
+                 "msCheckParentPointer()");
     }
     return MS_FAILURE;
   }
   return MS_SUCCESS;
 }
 
-void msBufferInit(bufferObj *buffer)
-{
-  buffer->data=NULL;
-  buffer->size=0;
-  buffer->available=0;
+void msBufferInit(bufferObj *buffer) {
+  buffer->data = NULL;
+  buffer->size = 0;
+  buffer->available = 0;
   buffer->_next_allocation_size = MS_DEFAULT_BUFFER_ALLOC;
 }
 
-void msBufferResize(bufferObj *buffer, size_t target_size)
-{
-  while(buffer->available <= target_size) {
-    buffer->data = msSmallRealloc(buffer->data,buffer->available+buffer->_next_allocation_size);
+void msBufferResize(bufferObj *buffer, size_t target_size) {
+  while (buffer->available <= target_size) {
+    buffer->data = msSmallRealloc(
+        buffer->data, buffer->available + buffer->_next_allocation_size);
     buffer->available += buffer->_next_allocation_size;
     buffer->_next_allocation_size *= 2;
   }
 }
 
-void msBufferAppend(bufferObj *buffer, void *data, size_t length)
-{
-  if(buffer->available < buffer->size+length) {
-    msBufferResize(buffer,buffer->size+length);
+void msBufferAppend(bufferObj *buffer, void *data, size_t length) {
+  if (buffer->available < buffer->size + length) {
+    msBufferResize(buffer, buffer->size + length);
   }
-  memcpy(&(buffer->data[buffer->size]),data,length);
+  memcpy(&(buffer->data[buffer->size]), data, length);
   buffer->size += length;
 }
 
-void msBufferFree(bufferObj *buffer)
-{
-  if(buffer->available>0)
+void msBufferFree(bufferObj *buffer) {
+  if (buffer->available > 0)
     free(buffer->data);
 }
 
-
-void msFreeRasterBuffer(rasterBufferObj *b)
-{
-  switch(b->type) {
-    case MS_BUFFER_BYTE_RGBA:
-      msFree(b->data.rgba.pixels);
-      b->data.rgba.pixels = NULL;
-      break;
-    case MS_BUFFER_BYTE_PALETTE:
-      msFree(b->data.palette.pixels);
-      msFree(b->data.palette.palette);
-      b->data.palette.pixels = NULL;
-      b->data.palette.palette = NULL;
-      break;
+void msFreeRasterBuffer(rasterBufferObj *b) {
+  switch (b->type) {
+  case MS_BUFFER_BYTE_RGBA:
+    msFree(b->data.rgba.pixels);
+    b->data.rgba.pixels = NULL;
+    break;
+  case MS_BUFFER_BYTE_PALETTE:
+    msFree(b->data.palette.pixels);
+    msFree(b->data.palette.palette);
+    b->data.palette.pixels = NULL;
+    b->data.palette.palette = NULL;
+    break;
   }
-
 }
 
 /*
@@ -2357,48 +2450,52 @@ void msFreeRasterBuffer(rasterBufferObj
 ** not enough info to calculate a deterministic answer.
 **
 */
-int msExtentsOverlap(mapObj *map, layerObj *layer)
-{
+int msExtentsOverlap(mapObj *map, layerObj *layer) {
   rectObj map_extent;
   rectObj layer_extent;
 
   /* No extent info? Nothing we can do, return MS_UNKNOWN. */
-  if( (map->extent.minx == -1) && (map->extent.miny == -1) && (map->extent.maxx == -1 ) && (map->extent.maxy == -1) ) return MS_UNKNOWN;
-  if( (layer->extent.minx == -1) && (layer->extent.miny == -1) && (layer->extent.maxx == -1 ) && (layer->extent.maxy == -1) ) return MS_UNKNOWN;
+  if ((map->extent.minx == -1) && (map->extent.miny == -1) &&
+      (map->extent.maxx == -1) && (map->extent.maxy == -1))
+    return MS_UNKNOWN;
+  if ((layer->extent.minx == -1) && (layer->extent.miny == -1) &&
+      (layer->extent.maxx == -1) && (layer->extent.maxy == -1))
+    return MS_UNKNOWN;
 
   /* No map projection? Let someone else sort this out. */
-  if( ! (map->projection.numargs > 0) )
+  if (!(map->projection.numargs > 0))
     return MS_UNKNOWN;
 
   /* No layer projection? Perform naive comparison, because they are
   ** in the same projection. */
-  if( ! (layer->projection.numargs > 0) )
-    return msRectOverlap( &(map->extent), &(layer->extent) );
+  if (!(layer->projection.numargs > 0))
+    return msRectOverlap(&(map->extent), &(layer->extent));
 
   /* In the case where map and layer projections are identical, and the */
   /* bounding boxes don't cross the dateline, do simple rectangle comparison */
-  if( map->extent.minx < map->extent.maxx &&
+  if (map->extent.minx < map->extent.maxx &&
       layer->extent.minx < layer->extent.maxx &&
-      !msProjectionsDiffer(&(map->projection), &(layer->projection)) ) {
-    return msRectOverlap( &(map->extent), &(layer->extent) );
+      !msProjectionsDiffer(&(map->projection), &(layer->projection))) {
+    return msRectOverlap(&(map->extent), &(layer->extent));
   }
 
   /* We need to transform our rectangles for comparison,
   ** so we will work with copies and leave the originals intact. */
-  MS_COPYRECT(&map_extent, &(map->extent) );
-  MS_COPYRECT(&layer_extent, &(layer->extent) );
+  MS_COPYRECT(&map_extent, &(map->extent));
+  MS_COPYRECT(&layer_extent, &(layer->extent));
 
   /* Transform map extents into geographics for comparison. */
-  if( msProjectRect(&(map->projection), &(map->latlon), &map_extent) )
+  if (msProjectRect(&(map->projection), &(map->latlon), &map_extent))
     return MS_UNKNOWN;
 
   /* Transform layer extents into geographics for comparison. */
-  if( msProjectRect(&(layer->projection), &(map->latlon), &layer_extent) )
+  if (msProjectRect(&(layer->projection), &(map->latlon), &layer_extent))
     return MS_UNKNOWN;
 
   /* Simple case? Return simple answer. */
-  if ( map_extent.minx < map_extent.maxx && layer_extent.minx < layer_extent.maxx )
-    return msRectOverlap( &(map_extent), &(layer_extent) );
+  if (map_extent.minx < map_extent.maxx &&
+      layer_extent.minx < layer_extent.maxx)
+    return msRectOverlap(&(map_extent), &(layer_extent));
 
   /* Uh oh, one of the rects crosses the dateline!
   ** Let someone else handle it. */
@@ -2411,17 +2508,17 @@ int msExtentsOverlap(mapObj *map, layerO
 
 /* Safe version of malloc(). This function is taken from gdal/cpl. */
 
-void *msSmallMalloc( size_t nSize )
-{
-  void        *pReturn;
+void *msSmallMalloc(size_t nSize) {
+  void *pReturn;
 
-  if( MS_UNLIKELY(nSize == 0) )
+  if (MS_UNLIKELY(nSize == 0))
     return NULL;
 
-  pReturn = malloc( nSize );
-  if( MS_UNLIKELY(pReturn == NULL) ) {
-    msIO_fprintf(stderr, "msSmallMalloc(): Out of memory allocating %ld bytes.\n",
-                 (long) nSize );
+  pReturn = malloc(nSize);
+  if (MS_UNLIKELY(pReturn == NULL)) {
+    msIO_fprintf(stderr,
+                 "msSmallMalloc(): Out of memory allocating %ld bytes.\n",
+                 (long)nSize);
     exit(1);
   }
 
@@ -2434,18 +2531,18 @@ void *msSmallMalloc( size_t nSize )
 
 /* Safe version of realloc(). This function is taken from gdal/cpl. */
 
-void * msSmallRealloc( void * pData, size_t nNewSize )
-{
-  void        *pReturn;
+void *msSmallRealloc(void *pData, size_t nNewSize) {
+  void *pReturn;
 
-  if ( MS_UNLIKELY(nNewSize == 0) )
+  if (MS_UNLIKELY(nNewSize == 0))
     return NULL;
 
-  pReturn = realloc( pData, nNewSize );
+  pReturn = realloc(pData, nNewSize);
 
-  if( MS_UNLIKELY(pReturn == NULL) ) {
-    msIO_fprintf(stderr, "msSmallRealloc(): Out of memory allocating %ld bytes.\n",
-                 (long)nNewSize );
+  if (MS_UNLIKELY(pReturn == NULL)) {
+    msIO_fprintf(stderr,
+                 "msSmallRealloc(): Out of memory allocating %ld bytes.\n",
+                 (long)nNewSize);
     exit(1);
   }
 
@@ -2458,17 +2555,17 @@ void * msSmallRealloc( void * pData, siz
 
 /* Safe version of calloc(). This function is taken from gdal/cpl. */
 
-void *msSmallCalloc( size_t nCount, size_t nSize )
-{
-  void  *pReturn;
+void *msSmallCalloc(size_t nCount, size_t nSize) {
+  void *pReturn;
 
-  if( MS_UNLIKELY(nSize * nCount == 0) )
+  if (MS_UNLIKELY(nSize * nCount == 0))
     return NULL;
 
-  pReturn = calloc( nCount, nSize );
-  if( MS_UNLIKELY(pReturn == NULL) ) {
-    msIO_fprintf(stderr, "msSmallCalloc(): Out of memory allocating %ld bytes.\n",
-                 (long)(nCount*nSize));
+  pReturn = calloc(nCount, nSize);
+  if (MS_UNLIKELY(pReturn == NULL)) {
+    msIO_fprintf(stderr,
+                 "msSmallCalloc(): Out of memory allocating %ld bytes.\n",
+                 (long)(nCount * nSize));
     exit(1);
   }
 
@@ -2485,37 +2582,37 @@ void *msSmallCalloc( size_t nCount, size
 ** Returns a newly allocated string that should be freed by the caller or
 ** NULL in case of error.
 */
-char *msBuildOnlineResource(mapObj *map, cgiRequestObj *req)
-{
+char *msBuildOnlineResource(mapObj *map, cgiRequestObj *req) {
   (void)map;
   char *online_resource = NULL;
-  const char *value, *hostname, *port, *script, *protocol="http", *mapparam=NULL;
+  const char *value, *hostname, *port, *script, *protocol = "http",
+                                                *mapparam = NULL;
   char **hostname_array = NULL;
   int mapparam_len = 0, hostname_array_len = 0;
 
   hostname = getenv("HTTP_X_FORWARDED_HOST");
-  if(!hostname)
+  if (!hostname)
     hostname = getenv("SERVER_NAME");
   else {
-    if(strchr(hostname,',')) {
-      hostname_array = msStringSplit(hostname,',', &hostname_array_len);
+    if (strchr(hostname, ',')) {
+      hostname_array = msStringSplit(hostname, ',', &hostname_array_len);
       hostname = hostname_array[0];
     }
   }
 
   port = getenv("HTTP_X_FORWARDED_PORT");
-  if(!port)
+  if (!port)
     port = getenv("SERVER_PORT");
 
   script = getenv("SCRIPT_NAME");
 
   /* HTTPS is set by Apache to "on" in an HTTPS server ... if not set */
   /* then check SERVER_PORT: 443 is the default https port. */
-  if ( ((value=getenv("HTTPS")) && strcasecmp(value, "on") == 0) ||
-       ((value=getenv("SERVER_PORT")) && atoi(value) == 443) ) {
+  if (((value = getenv("HTTPS")) && strcasecmp(value, "on") == 0) ||
+      ((value = getenv("SERVER_PORT")) && atoi(value) == 443)) {
     protocol = "https";
   }
-  if ( (value=getenv("HTTP_X_FORWARDED_PROTO")) ) {
+  if ((value = getenv("HTTP_X_FORWARDED_PROTO"))) {
     protocol = value;
   }
 
@@ -2523,10 +2620,10 @@ char *msBuildOnlineResource(mapObj *map,
    */
   if (req->type == MS_GET_REQUEST) {
     int i;
-    for(i=0; i<req->NumParams; i++) {
+    for (i = 0; i < req->NumParams; i++) {
       if (strcasecmp(req->ParamNames[i], "map") == 0) {
         mapparam = req->ParamValues[i];
-        mapparam_len = strlen(mapparam)+5; /* +5 for "map="+"&" */
+        mapparam_len = strlen(mapparam) + 5; /* +5 for "map="+"&" */
         break;
       }
     }
@@ -2534,47 +2631,51 @@ char *msBuildOnlineResource(mapObj *map,
 
   if (hostname && port && script) {
     size_t buffer_size;
-    buffer_size = strlen(hostname)+strlen(port)+strlen(script)+mapparam_len+11; /* 11 comes from https://[host]:[port][scriptname]?[map]\0, i.e. "https://:?\0" */
-    online_resource = (char*)msSmallMalloc(buffer_size);
+    buffer_size =
+        strlen(hostname) + strlen(port) + strlen(script) + mapparam_len +
+        11; /* 11 comes from https://[host]:[port][scriptname]?[map]\0, i.e.
+               "https://:?\0" */
+    online_resource = (char *)msSmallMalloc(buffer_size);
     if ((atoi(port) == 80 && strcmp(protocol, "http") == 0) ||
-        (atoi(port) == 443 && strcmp(protocol, "https") == 0) )
-      snprintf(online_resource, buffer_size, "%s://%s%s?", protocol, hostname, script);
+        (atoi(port) == 443 && strcmp(protocol, "https") == 0))
+      snprintf(online_resource, buffer_size, "%s://%s%s?", protocol, hostname,
+               script);
     else
-      snprintf(online_resource, buffer_size, "%s://%s:%s%s?", protocol, hostname, port, script);
+      snprintf(online_resource, buffer_size, "%s://%s:%s%s?", protocol,
+               hostname, port, script);
 
     if (mapparam) {
       int baselen;
       baselen = strlen(online_resource);
-      snprintf(online_resource+baselen, buffer_size-baselen, "map=%s&", mapparam);
+      snprintf(online_resource + baselen, buffer_size - baselen, "map=%s&",
+               mapparam);
     }
   } else {
-    msSetError(MS_CGIERR, "Impossible to establish server URL.", "msBuildOnlineResource()");
+    msSetError(MS_CGIERR, "Impossible to establish server URL.",
+               "msBuildOnlineResource()");
     return NULL;
   }
-  if(hostname_array) {
+  if (hostname_array) {
     msFreeCharArray(hostname_array, hostname_array_len);
   }
 
   return online_resource;
 }
 
-
 /************************************************************************/
 /*                             msIntegerInArray()                        */
 /************************************************************************/
 
 /* Check if a integer is in a array */
-int msIntegerInArray(const int value, int *array, int numelements)
-{
+int msIntegerInArray(const int value, int *array, int numelements) {
   int i;
-  for (i=0; i<numelements; ++i) {
+  for (i = 0; i < numelements; ++i) {
     if (value == array[i])
       return MS_TRUE;
   }
   return MS_FALSE;
 }
 
-
 /************************************************************************
  *                            msMapSetProjections                       *
  *                                                                      *
@@ -2583,25 +2684,24 @@ int msIntegerInArray(const int value, in
  *   projection.                                                        *
  ************************************************************************/
 
-int msMapSetLayerProjections(mapObj* map)
-{
+int msMapSetLayerProjections(mapObj *map) {
 
   char *mapProjStr = NULL;
   int i;
 
   if (map->projection.numargs <= 0) {
-    msSetError(MS_WMSERR, "Cannot set new SRS on a map that doesn't "
+    msSetError(MS_WMSERR,
+               "Cannot set new SRS on a map that doesn't "
                "have any projection set. Please make sure your mapfile "
                "has a PROJECTION defined at the top level.",
                "msTileSetProjectionst()");
-    return(MS_FAILURE);
+    return (MS_FAILURE);
   }
 
-  for(i=0; i<map->numlayers; i++) {
-    layerObj *lp = GET_LAYER(map,i);
+  for (i = 0; i < map->numlayers; i++) {
+    layerObj *lp = GET_LAYER(map, i);
     /* This layer is turned on and needs a projection? */
-    if (lp->projection.numargs <= 0 &&
-        lp->status != MS_OFF &&
+    if (lp->projection.numargs <= 0 && lp->status != MS_OFF &&
         lp->transform == MS_TRUE) {
 
       /* Fetch main map projection string only now that we need it */
@@ -2610,28 +2710,32 @@ int msMapSetLayerProjections(mapObj* map
 
       /* Set the projection to the map file projection */
       if (msLoadProjectionString(&(lp->projection), mapProjStr) != 0) {
-        msSetError(MS_CGIERR, "Unable to set projection on layer.", "msMapSetLayerProjections()");
-        return(MS_FAILURE);
+        msSetError(MS_CGIERR, "Unable to set projection on layer.",
+                   "msMapSetLayerProjections()");
+        return (MS_FAILURE);
       }
       lp->project = MS_TRUE;
-      if(lp->connection && IS_THIRDPARTY_LAYER_CONNECTIONTYPE(lp->connectiontype)) {
+      if (lp->connection &&
+          IS_THIRDPARTY_LAYER_CONNECTIONTYPE(lp->connectiontype)) {
         char **reflayers;
-        int numreflayers,j;
-        reflayers = msStringSplit(lp->connection,',',&numreflayers);
-        for(j=0; j<numreflayers; j++) {
+        int numreflayers, j;
+        reflayers = msStringSplit(lp->connection, ',', &numreflayers);
+        for (j = 0; j < numreflayers; j++) {
           int *lidx, nlidx;
           /* first check layers referenced by group name */
           lidx = msGetLayersIndexByGroup(map, reflayers[i], &nlidx);
-          if(lidx) {
+          if (lidx) {
             int k;
-            for(k=0; k<nlidx; k++) {
-              layerObj *glp = GET_LAYER(map,lidx[k]);
+            for (k = 0; k < nlidx; k++) {
+              layerObj *glp = GET_LAYER(map, lidx[k]);
               if (glp->projection.numargs <= 0 && glp->transform == MS_TRUE) {
 
                 /* Set the projection to the map file projection */
-                if (msLoadProjectionString(&(glp->projection), mapProjStr) != 0) {
-                  msSetError(MS_CGIERR, "Unable to set projection on layer.", "msMapSetLayerProjections()");
-                  return(MS_FAILURE);
+                if (msLoadProjectionString(&(glp->projection), mapProjStr) !=
+                    0) {
+                  msSetError(MS_CGIERR, "Unable to set projection on layer.",
+                             "msMapSetLayerProjections()");
+                  return (MS_FAILURE);
                 }
                 glp->project = MS_TRUE;
               }
@@ -2639,14 +2743,15 @@ int msMapSetLayerProjections(mapObj* map
             free(lidx);
           } else {
             /* group name did not match, check by layer name */
-            int layer_idx = msGetLayerIndex(map,lp->connection);
-            layerObj *glp = GET_LAYER(map,layer_idx);
+            int layer_idx = msGetLayerIndex(map, lp->connection);
+            layerObj *glp = GET_LAYER(map, layer_idx);
             if (glp->projection.numargs <= 0 && glp->transform == MS_TRUE) {
 
               /* Set the projection to the map file projection */
               if (msLoadProjectionString(&(glp->projection), mapProjStr) != 0) {
-                msSetError(MS_CGIERR, "Unable to set projection on layer.", "msMapSetLayerProjections()");
-                return(MS_FAILURE);
+                msSetError(MS_CGIERR, "Unable to set projection on layer.",
+                           "msMapSetLayerProjections()");
+                return (MS_FAILURE);
               }
               glp->project = MS_TRUE;
             }
@@ -2657,10 +2762,9 @@ int msMapSetLayerProjections(mapObj* map
     }
   }
   msFree(mapProjStr);
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
-
 /************************************************************************
  *                    msMapSetLanguageSpecificConnection                *
  *                                                                      *
@@ -2668,74 +2772,74 @@ int msMapSetLayerProjections(mapObj* map
  *  variant for the specified language.                                 *
  ************************************************************************/
 
-void msMapSetLanguageSpecificConnection(mapObj* map, const char* validated_language)
-{
-    int i;
-    for(i=0; i<map->numlayers; i++) {
-      layerObj *layer = GET_LAYER(map, i);
-      if(layer->data) layer->data = msCaseReplaceSubstring(layer->data, "%language%", validated_language);
-      if(layer->connection) layer->connection = msCaseReplaceSubstring(layer->connection, "%language%", validated_language);
-    }
+void msMapSetLanguageSpecificConnection(mapObj *map,
+                                        const char *validated_language) {
+  int i;
+  for (i = 0; i < map->numlayers; i++) {
+    layerObj *layer = GET_LAYER(map, i);
+    if (layer->data)
+      layer->data =
+          msCaseReplaceSubstring(layer->data, "%language%", validated_language);
+    if (layer->connection)
+      layer->connection = msCaseReplaceSubstring(
+          layer->connection, "%language%", validated_language);
+  }
 }
 
 /* Generalize a shape based of the tolerance.
    Ref: http://trac.osgeo.org/gdal/ticket/966 */
-shapeObj* msGeneralize(shapeObj *shape, double tolerance)
-{
-  lineObj newLine = {0,NULL};
-  const double sqTolerance = tolerance*tolerance;
+shapeObj *msGeneralize(shapeObj *shape, double tolerance) {
+  lineObj newLine = {0, NULL};
+  const double sqTolerance = tolerance * tolerance;
 
-  shapeObj* newShape = (shapeObj*)msSmallMalloc(sizeof(shapeObj));
+  shapeObj *newShape = (shapeObj *)msSmallMalloc(sizeof(shapeObj));
   msInitShape(newShape);
   msCopyShape(shape, newShape);
 
-  if (shape->numlines<1)
+  if (shape->numlines < 1)
     return newShape;
 
   /* Clean shape */
-  for (int i=0; i < newShape->numlines; i++)
+  for (int i = 0; i < newShape->numlines; i++)
     free(newShape->line[i].point);
   newShape->numlines = 0;
-  if (newShape->line) free(newShape->line);
+  if (newShape->line)
+    free(newShape->line);
 
   msAddLine(newShape, &newLine);
 
-  if (shape->line[0].numpoints==0) {
+  if (shape->line[0].numpoints == 0) {
     return newShape;
   }
 
-  msAddPointToLine(&newShape->line[0],
-                   &shape->line[0].point[0]);
+  msAddPointToLine(&newShape->line[0], &shape->line[0].point[0]);
   double dX0 = shape->line[0].point[0].x;
   double dY0 = shape->line[0].point[0].y;
 
-  for(int i=1; i<shape->line[0].numpoints; i++)
-  {
-      double dX1 = shape->line[0].point[i].x;
-      double dY1 = shape->line[0].point[i].y;
-
-      const double dX = dX1-dX0;
-      const double dY = dY1-dY0;
-      const double dSqDist = dX*dX + dY*dY;
-      if (i == shape->line[0].numpoints-1 || dSqDist >= sqTolerance)
-      {
-          pointObj p;
-          p.x = dX1;
-          p.y = dY1;
-
-          /* Keep this point (always keep the last point) */
-          msAddPointToLine(&newShape->line[0],
-                           &p);
-          dX0 = dX1;
-          dY0 = dY1;
-        }
+  for (int i = 1; i < shape->line[0].numpoints; i++) {
+    double dX1 = shape->line[0].point[i].x;
+    double dY1 = shape->line[0].point[i].y;
+
+    const double dX = dX1 - dX0;
+    const double dY = dY1 - dY0;
+    const double dSqDist = dX * dX + dY * dY;
+    if (i == shape->line[0].numpoints - 1 || dSqDist >= sqTolerance) {
+      pointObj p;
+      p.x = dX1;
+      p.y = dY1;
+
+      /* Keep this point (always keep the last point) */
+      msAddPointToLine(&newShape->line[0], &p);
+      dX0 = dX1;
+      dY0 = dY1;
     }
+  }
 
   return newShape;
 }
 
 void msSetLayerOpacity(layerObj *layer, int opacity) {
-  if(!layer->compositer) {
+  if (!layer->compositer) {
     layer->compositer = msSmallMalloc(sizeof(LayerCompositer));
     initLayerCompositer(layer->compositer);
   }
diff -pruN 8.0.1-5/mapuvraster.c 8.0.2-1/mapuvraster.c
--- 8.0.1-5/mapuvraster.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapuvraster.c	2024-06-11 20:41:34.000000000 +0000
@@ -35,24 +35,24 @@
 #include "mapresample.h"
 #include "mapthread.h"
 
-#define MSUVRASTER_NUMITEMS        6
-#define MSUVRASTER_ANGLE    "uv_angle"
-#define MSUVRASTER_ANGLEINDEX   -100
-#define MSUVRASTER_MINUS_ANGLE    "uv_minus_angle"
-#define MSUVRASTER_MINUSANGLEINDEX   -101
-#define MSUVRASTER_LENGTH    "uv_length"
-#define MSUVRASTER_LENGTHINDEX   -102
-#define MSUVRASTER_LENGTH_2    "uv_length_2"
-#define MSUVRASTER_LENGTH2INDEX   -103
-#define MSUVRASTER_U    "u"
-#define MSUVRASTER_UINDEX   -104
-#define MSUVRASTER_V    "v"
-#define MSUVRASTER_VINDEX   -105
-
-#define RQM_UNKNOWN               0
-#define RQM_ENTRY_PER_PIXEL       1
-#define RQM_HIST_ON_CLASS         2
-#define RQM_HIST_ON_VALUE         3
+#define MSUVRASTER_NUMITEMS 6
+#define MSUVRASTER_ANGLE "uv_angle"
+#define MSUVRASTER_ANGLEINDEX -100
+#define MSUVRASTER_MINUS_ANGLE "uv_minus_angle"
+#define MSUVRASTER_MINUSANGLEINDEX -101
+#define MSUVRASTER_LENGTH "uv_length"
+#define MSUVRASTER_LENGTHINDEX -102
+#define MSUVRASTER_LENGTH_2 "uv_length_2"
+#define MSUVRASTER_LENGTH2INDEX -103
+#define MSUVRASTER_U "u"
+#define MSUVRASTER_UINDEX -104
+#define MSUVRASTER_V "v"
+#define MSUVRASTER_VINDEX -105
+
+#define RQM_UNKNOWN 0
+#define RQM_ENTRY_PER_PIXEL 1
+#define RQM_HIST_ON_CLASS 2
+#define RQM_HIST_ON_VALUE 3
 
 typedef struct {
 
@@ -81,46 +81,47 @@ typedef struct {
   int width;
   int height;
   rectObj extent;
-  int     next_shape;
+  int next_shape;
   int x, y; /* used internally in msUVRasterLayerNextShape() */
 
-  mapObj* mapToUseForWhichShapes; /* set if the map->extent and map->projection are valid in msUVRASTERLayerWhichShapes() */
+  mapObj
+      *mapToUseForWhichShapes; /* set if the map->extent and map->projection are
+                                  valid in msUVRASTERLayerWhichShapes() */
 
 } uvRasterLayerInfo;
 
-void msUVRASTERLayerUseMapExtentAndProjectionForNextWhichShapes(layerObj* layer,
-                                                                mapObj* map)
-{
-  uvRasterLayerInfo *uvlinfo = (uvRasterLayerInfo *) layer->layerinfo;
+void msUVRASTERLayerUseMapExtentAndProjectionForNextWhichShapes(layerObj *layer,
+                                                                mapObj *map) {
+  uvRasterLayerInfo *uvlinfo = (uvRasterLayerInfo *)layer->layerinfo;
   uvlinfo->mapToUseForWhichShapes = map;
 }
 
-static int msUVRASTERLayerInitItemInfo(layerObj *layer)
-{
-  uvRasterLayerInfo *uvlinfo = (uvRasterLayerInfo *) layer->layerinfo;
-  int   i;
+static int msUVRASTERLayerInitItemInfo(layerObj *layer) {
+  uvRasterLayerInfo *uvlinfo = (uvRasterLayerInfo *)layer->layerinfo;
+  int i;
   int *itemindexes;
-  int failed=0;
+  int failed = 0;
 
   if (layer->numitems == 0)
     return MS_SUCCESS;
 
-  if( uvlinfo == NULL ) {
+  if (uvlinfo == NULL) {
     msSetError(MS_MISCERR, "Assertion failed: GDAL layer not opened!!!",
                "msUVRASTERLayerInitItemInfo()");
-    return(MS_FAILURE);
+    return (MS_FAILURE);
   }
 
   if (layer->iteminfo)
     free(layer->iteminfo);
 
-  if((layer->iteminfo = (int *)malloc(sizeof(int)*layer->numitems))== NULL) {
+  if ((layer->iteminfo = (int *)malloc(sizeof(int) * layer->numitems)) ==
+      NULL) {
     msSetError(MS_MEMERR, NULL, "msUVRASTERLayerInitItemInfo()");
-    return(MS_FAILURE);
+    return (MS_FAILURE);
   }
 
-  itemindexes = (int*)layer->iteminfo;
-  for(i=0; i<layer->numitems; i++) {
+  itemindexes = (int *)layer->iteminfo;
+  for (i = 0; i < layer->numitems; i++) {
     /* Special case for handling text string and angle coming from */
     /* OGR style strings.  We use special attribute snames. */
     if (EQUAL(layer->items[i], MSUVRASTER_ANGLE))
@@ -137,33 +138,28 @@ static int msUVRASTERLayerInitItemInfo(l
       itemindexes[i] = MSUVRASTER_VINDEX;
     else {
       itemindexes[i] = -1;
-      msSetError(MS_OGRERR,
-                 "Invalid Field name: %s",
-                 "msUVRASTERLayerInitItemInfo()",
-                 layer->items[i]);
-      failed=1;
+      msSetError(MS_OGRERR, "Invalid Field name: %s",
+                 "msUVRASTERLayerInitItemInfo()", layer->items[i]);
+      failed = 1;
     }
   }
 
   return failed ? (MS_FAILURE) : (MS_SUCCESS);
 }
 
-
-void msUVRASTERLayerFreeItemInfo(layerObj *layer)
-{
+void msUVRASTERLayerFreeItemInfo(layerObj *layer) {
   if (layer->iteminfo)
     free(layer->iteminfo);
   layer->iteminfo = NULL;
 }
 
-static void msUVRasterLayerInfoInitialize(layerObj *layer)
-{
-  uvRasterLayerInfo *uvlinfo = (uvRasterLayerInfo *) layer->layerinfo;
+static void msUVRasterLayerInfoInitialize(layerObj *layer) {
+  uvRasterLayerInfo *uvlinfo = (uvRasterLayerInfo *)layer->layerinfo;
 
-  if( uvlinfo != NULL )
+  if (uvlinfo != NULL)
     return;
 
-  uvlinfo = (uvRasterLayerInfo *) msSmallCalloc(1,sizeof(uvRasterLayerInfo));
+  uvlinfo = (uvRasterLayerInfo *)msSmallCalloc(1, sizeof(uvRasterLayerInfo));
   layer->layerinfo = uvlinfo;
 
   uvlinfo->band_count = -1;
@@ -179,23 +175,19 @@ static void msUVRasterLayerInfoInitializ
   /* Set attribute type to Real, unless the user has explicitly set */
   /* something else. */
   {
-      const char* const items[] = {
-          MSUVRASTER_ANGLE,
-          MSUVRASTER_MINUS_ANGLE,
-          MSUVRASTER_LENGTH,
-          MSUVRASTER_LENGTH_2,
-          MSUVRASTER_U,
-          MSUVRASTER_V,
-      };
-      size_t i;
-      for( i = 0; i < sizeof(items)/sizeof(items[0]); ++i ) {
-          char szTmp[100];
-          snprintf(szTmp, sizeof(szTmp), "%s_type", items[i]);
-          if (msOWSLookupMetadata(&(layer->metadata), "OFG", szTmp) == NULL) {
-              snprintf(szTmp, sizeof(szTmp), "gml_%s_type", items[i]);
-              msInsertHashTable(&(layer->metadata), szTmp, "Real");
-          }
+    const char *const items[] = {
+        MSUVRASTER_ANGLE,    MSUVRASTER_MINUS_ANGLE, MSUVRASTER_LENGTH,
+        MSUVRASTER_LENGTH_2, MSUVRASTER_U,           MSUVRASTER_V,
+    };
+    size_t i;
+    for (i = 0; i < sizeof(items) / sizeof(items[0]); ++i) {
+      char szTmp[100];
+      snprintf(szTmp, sizeof(szTmp), "%s_type", items[i]);
+      if (msOWSLookupMetadata(&(layer->metadata), "OFG", szTmp) == NULL) {
+        snprintf(szTmp, sizeof(szTmp), "gml_%s_type", items[i]);
+        msInsertHashTable(&(layer->metadata), szTmp, "Real");
       }
+    }
   }
 
   /* uvlinfo->query_result_hard_max = 1000000; */
@@ -204,83 +196,80 @@ static void msUVRasterLayerInfoInitializ
   /*     != NULL ) */
   /* { */
   /*     uvlinfo->query_result_hard_max =  */
-  /*         atoi(CSLFetchNameValue( layer->processing, "RASTER_QUERY_MAX_RESULT" )); */
+  /*         atoi(CSLFetchNameValue( layer->processing,
+   * "RASTER_QUERY_MAX_RESULT" )); */
   /* } */
 }
 
-static void msUVRasterLayerInfoFree( layerObj *layer )
+static void msUVRasterLayerInfoFree(layerObj *layer)
 
 {
-  uvRasterLayerInfo *uvlinfo = (uvRasterLayerInfo *) layer->layerinfo;
+  uvRasterLayerInfo *uvlinfo = (uvRasterLayerInfo *)layer->layerinfo;
   int i;
 
-  if( uvlinfo == NULL )
+  if (uvlinfo == NULL)
     return;
 
   if (uvlinfo->u) {
-    for (i=0; i<uvlinfo->width; ++i) {
+    for (i = 0; i < uvlinfo->width; ++i) {
       free(uvlinfo->u[i]);
     }
     free(uvlinfo->u);
   }
 
   if (uvlinfo->v) {
-    for (i=0; i<uvlinfo->width; ++i) {
+    for (i = 0; i < uvlinfo->width; ++i) {
       free(uvlinfo->v[i]);
     }
     free(uvlinfo->v);
   }
 
-  free( uvlinfo );
+  free(uvlinfo);
 
   layer->layerinfo = NULL;
 }
 
-int msUVRASTERLayerOpen(layerObj *layer)
-{
+int msUVRASTERLayerOpen(layerObj *layer) {
   /* If we don't have info, initialize an empty one now */
-  if( layer->layerinfo == NULL )
-    msUVRasterLayerInfoInitialize( layer );
-  if( layer->layerinfo == NULL )
+  if (layer->layerinfo == NULL)
+    msUVRasterLayerInfoInitialize(layer);
+  if (layer->layerinfo == NULL)
     return MS_FAILURE;
 
-  uvRasterLayerInfo* uvlinfo = (uvRasterLayerInfo *) layer->layerinfo;
+  uvRasterLayerInfo *uvlinfo = (uvRasterLayerInfo *)layer->layerinfo;
 
   uvlinfo->refcount = uvlinfo->refcount + 1;
 
   return MS_SUCCESS;
 }
 
-int msUVRASTERLayerIsOpen(layerObj *layer)
-{
+int msUVRASTERLayerIsOpen(layerObj *layer) {
   if (layer->layerinfo)
     return MS_TRUE;
   return MS_FALSE;
 }
 
+int msUVRASTERLayerClose(layerObj *layer) {
+  uvRasterLayerInfo *uvlinfo = (uvRasterLayerInfo *)layer->layerinfo;
 
-int msUVRASTERLayerClose(layerObj *layer)
-{
-  uvRasterLayerInfo *uvlinfo = (uvRasterLayerInfo *) layer->layerinfo;
-
-  if( uvlinfo != NULL ) {
+  if (uvlinfo != NULL) {
     uvlinfo->refcount--;
 
-    if( uvlinfo->refcount < 1 )
-      msUVRasterLayerInfoFree( layer );
+    if (uvlinfo->refcount < 1)
+      msUVRasterLayerInfoFree(layer);
   }
   return MS_SUCCESS;
 }
 
-int msUVRASTERLayerGetItems(layerObj *layer)
-{
-  uvRasterLayerInfo *uvlinfo = (uvRasterLayerInfo *) layer->layerinfo;
+int msUVRASTERLayerGetItems(layerObj *layer) {
+  uvRasterLayerInfo *uvlinfo = (uvRasterLayerInfo *)layer->layerinfo;
 
-  if( uvlinfo == NULL )
+  if (uvlinfo == NULL)
     return MS_FAILURE;
 
   layer->numitems = 0;
-  layer->items = (char **) msSmallCalloc(sizeof(char *),10);;
+  layer->items = (char **)msSmallCalloc(sizeof(char *), 10);
+  ;
 
   layer->items[layer->numitems++] = msStrdup(MSUVRASTER_ANGLE);
   layer->items[layer->numitems++] = msStrdup(MSUVRASTER_MINUS_ANGLE);
@@ -299,229 +288,226 @@ int msUVRASTERLayerGetItems(layerObj *la
  * Special attribute names are used to return some UV params: uv_angle,
  * uv_length, u and v.
  **********************************************************************/
-static char **msUVRASTERGetValues(layerObj *layer, float *u, float *v)
-{
+static char **msUVRASTERGetValues(layerObj *layer, float *u, float *v) {
   char **values;
   int i = 0;
   char tmp[100];
   float size_scale;
-  int *itemindexes = (int*)layer->iteminfo;
+  int *itemindexes = (int *)layer->iteminfo;
 
-  if(layer->numitems == 0)
-    return(NULL);
+  if (layer->numitems == 0)
+    return (NULL);
 
-  if(!layer->iteminfo) { /* Should not happen... but just in case! */
+  if (!layer->iteminfo) { /* Should not happen... but just in case! */
     if (msUVRASTERLayerInitItemInfo(layer) != MS_SUCCESS)
       return NULL;
-    itemindexes = (int*)layer->iteminfo; /* reassign after malloc */
+    itemindexes = (int *)layer->iteminfo; /* reassign after malloc */
   }
 
-  if((values = (char **)malloc(sizeof(char *)*layer->numitems)) == NULL) {
+  if ((values = (char **)malloc(sizeof(char *) * layer->numitems)) == NULL) {
     msSetError(MS_MEMERR, NULL, "msUVRASTERGetValues()");
-    return(NULL);
+    return (NULL);
   }
 
   /* -------------------------------------------------------------------- */
   /*    Determine desired size_scale.  Default to 1 if not otherwise set  */
   /* -------------------------------------------------------------------- */
   size_scale = 1;
-  if( CSLFetchNameValue( layer->processing, "UV_SIZE_SCALE" ) != NULL ) {
-    size_scale =
-      atof(CSLFetchNameValue( layer->processing, "UV_SIZE_SCALE" ));
+  if (CSLFetchNameValue(layer->processing, "UV_SIZE_SCALE") != NULL) {
+    size_scale = atof(CSLFetchNameValue(layer->processing, "UV_SIZE_SCALE"));
   }
 
-  for(i=0; i<layer->numitems; i++) {
+  for (i = 0; i < layer->numitems; i++) {
     if (itemindexes[i] == MSUVRASTER_ANGLEINDEX) {
       snprintf(tmp, 100, "%f", (atan2((double)*v, (double)*u) * 180 / MS_PI));
       values[i] = msStrdup(tmp);
     } else if (itemindexes[i] == MSUVRASTER_MINUSANGLEINDEX) {
       double minus_angle;
-      minus_angle = (atan2((double)*v, (double)*u) * 180 / MS_PI)+180;
+      minus_angle = (atan2((double)*v, (double)*u) * 180 / MS_PI) + 180;
       if (minus_angle >= 360)
         minus_angle -= 360;
       snprintf(tmp, 100, "%f", minus_angle);
       values[i] = msStrdup(tmp);
-    } else if ( (itemindexes[i] == MSUVRASTER_LENGTHINDEX) ||
-                (itemindexes[i] == MSUVRASTER_LENGTH2INDEX) ) {
-      float length = sqrt((*u**u)+(*v**v))*size_scale;
+    } else if ((itemindexes[i] == MSUVRASTER_LENGTHINDEX) ||
+               (itemindexes[i] == MSUVRASTER_LENGTH2INDEX)) {
+      float length = sqrt((*u * *u) + (*v * *v)) * size_scale;
 
       if (itemindexes[i] == MSUVRASTER_LENGTHINDEX)
         snprintf(tmp, 100, "%f", length);
       else
-        snprintf(tmp, 100, "%f", length/2);
+        snprintf(tmp, 100, "%f", length / 2);
 
       values[i] = msStrdup(tmp);
     } else if (itemindexes[i] == MSUVRASTER_UINDEX) {
-      snprintf(tmp, 100, "%f",*u);
+      snprintf(tmp, 100, "%f", *u);
       values[i] = msStrdup(tmp);
     } else if (itemindexes[i] == MSUVRASTER_VINDEX) {
-      snprintf(tmp, 100, "%f",*v);
+      snprintf(tmp, 100, "%f", *v);
       values[i] = msStrdup(tmp);
     } else {
       values[i] = NULL;
-      }
+    }
   }
 
   return values;
 }
 
-rectObj msUVRASTERGetSearchRect( layerObj* layer, mapObj* map )
-{
-    rectObj searchrect = map->extent;
-    int bDone = MS_FALSE;
-
-    /* For UVRaster, it is important that the searchrect is not too large */
-    /* to avoid insufficient intermediate raster resolution, which could */
-    /* happen if we use the default code path, given potential reprojection */
-    /* issues when using a map extent that is not in the validity area of */
-    /* the layer projection. */
-    if( !layer->projection.gt.need_geotransform &&
-        !(msProjIsGeographicCRS(&(map->projection)) &&
-        msProjIsGeographicCRS(&(layer->projection))) ) {
-      rectObj layer_ori_extent;
-
-      if( msLayerGetExtent(layer, &layer_ori_extent) == MS_SUCCESS ) {
-        projectionObj map_proj;
-
-        double map_extent_minx = map->extent.minx;
-        double map_extent_miny = map->extent.miny;
-        double map_extent_maxx = map->extent.maxx;
-        double map_extent_maxy = map->extent.maxy;
-        rectObj layer_extent = layer_ori_extent;
-
-        /* Create a variant of map->projection without geotransform for */
-        /* conveniency */
-        msInitProjection(&map_proj);
-        msCopyProjection(&map_proj, &map->projection);
-        map_proj.gt.need_geotransform = MS_FALSE;
-        if( map->projection.gt.need_geotransform ) {
-            map_extent_minx = map->projection.gt.geotransform[0]
-                + map->projection.gt.geotransform[1] * map->extent.minx
-                + map->projection.gt.geotransform[2] * map->extent.miny;
-            map_extent_miny = map->projection.gt.geotransform[3]
-                + map->projection.gt.geotransform[4] * map->extent.minx
-                + map->projection.gt.geotransform[5] * map->extent.miny;
-            map_extent_maxx = map->projection.gt.geotransform[0]
-                + map->projection.gt.geotransform[1] * map->extent.maxx
-                + map->projection.gt.geotransform[2] * map->extent.maxy;
-            map_extent_maxy = map->projection.gt.geotransform[3]
-                + map->projection.gt.geotransform[4] * map->extent.maxx
-                + map->projection.gt.geotransform[5] * map->extent.maxy;
-        }
+rectObj msUVRASTERGetSearchRect(layerObj *layer, mapObj *map) {
+  rectObj searchrect = map->extent;
+  int bDone = MS_FALSE;
+
+  /* For UVRaster, it is important that the searchrect is not too large */
+  /* to avoid insufficient intermediate raster resolution, which could */
+  /* happen if we use the default code path, given potential reprojection */
+  /* issues when using a map extent that is not in the validity area of */
+  /* the layer projection. */
+  if (!layer->projection.gt.need_geotransform &&
+      !(msProjIsGeographicCRS(&(map->projection)) &&
+        msProjIsGeographicCRS(&(layer->projection)))) {
+    rectObj layer_ori_extent;
+
+    if (msLayerGetExtent(layer, &layer_ori_extent) == MS_SUCCESS) {
+      projectionObj map_proj;
+
+      double map_extent_minx = map->extent.minx;
+      double map_extent_miny = map->extent.miny;
+      double map_extent_maxx = map->extent.maxx;
+      double map_extent_maxy = map->extent.maxy;
+      rectObj layer_extent = layer_ori_extent;
+
+      /* Create a variant of map->projection without geotransform for */
+      /* conveniency */
+      msInitProjection(&map_proj);
+      msCopyProjection(&map_proj, &map->projection);
+      map_proj.gt.need_geotransform = MS_FALSE;
+      if (map->projection.gt.need_geotransform) {
+        map_extent_minx =
+            map->projection.gt.geotransform[0] +
+            map->projection.gt.geotransform[1] * map->extent.minx +
+            map->projection.gt.geotransform[2] * map->extent.miny;
+        map_extent_miny =
+            map->projection.gt.geotransform[3] +
+            map->projection.gt.geotransform[4] * map->extent.minx +
+            map->projection.gt.geotransform[5] * map->extent.miny;
+        map_extent_maxx =
+            map->projection.gt.geotransform[0] +
+            map->projection.gt.geotransform[1] * map->extent.maxx +
+            map->projection.gt.geotransform[2] * map->extent.maxy;
+        map_extent_maxy =
+            map->projection.gt.geotransform[3] +
+            map->projection.gt.geotransform[4] * map->extent.maxx +
+            map->projection.gt.geotransform[5] * map->extent.maxy;
+      }
 
-        /* Reproject layer extent to map projection */
-        msProjectRect(&layer->projection, &map_proj, &layer_extent);
+      /* Reproject layer extent to map projection */
+      msProjectRect(&layer->projection, &map_proj, &layer_extent);
 
-        if( layer_extent.minx <= map_extent_minx &&
-            layer_extent.miny <= map_extent_miny &&
-            layer_extent.maxx >= map_extent_maxx &&
-            layer_extent.maxy >= map_extent_maxy ) {
-            /* do nothing special if area to map is inside layer extent */
-        }
-        else {
-            if( layer_extent.minx >= map_extent_minx &&
-                layer_extent.maxx <= map_extent_maxx &&
-                layer_extent.miny >= map_extent_miny &&
-                layer_extent.maxy <= map_extent_maxy ) {
-                /* if the area to map is larger than the layer extent, then */
-                /* use full layer extent and add some margin to reflect the */
-                /* proportion of the useful area over the requested bbox */
-                double extra_x =
-                (map_extent_maxx - map_extent_minx) /
-                    (layer_extent.maxx - layer_extent.minx) *
-                    (layer_ori_extent.maxx -  layer_ori_extent.minx);
-                double extra_y =
-                    (map_extent_maxy - map_extent_miny) /
-                    (layer_extent.maxy - layer_extent.miny) *
-                    (layer_ori_extent.maxy -  layer_ori_extent.miny);
-                searchrect.minx = layer_ori_extent.minx - extra_x / 2;
-                searchrect.maxx = layer_ori_extent.maxx + extra_x / 2;
-                searchrect.miny = layer_ori_extent.miny - extra_y / 2;
-                searchrect.maxy = layer_ori_extent.maxy + extra_y / 2;
-            }
-            else
-            {
-                /* otherwise clip the map extent with the reprojected layer */
-                /* extent */
-                searchrect.minx = MS_MAX( map_extent_minx, layer_extent.minx );
-                searchrect.maxx = MS_MIN( map_extent_maxx, layer_extent.maxx );
-                searchrect.miny = MS_MAX( map_extent_miny, layer_extent.miny );
-                searchrect.maxy = MS_MIN( map_extent_maxy, layer_extent.maxy );
-                /* and reproject into the layer projection */
-                msProjectRect(&map_proj, &layer->projection, &searchrect);
-            }
-            bDone = MS_TRUE;
+      if (layer_extent.minx <= map_extent_minx &&
+          layer_extent.miny <= map_extent_miny &&
+          layer_extent.maxx >= map_extent_maxx &&
+          layer_extent.maxy >= map_extent_maxy) {
+        /* do nothing special if area to map is inside layer extent */
+      } else {
+        if (layer_extent.minx >= map_extent_minx &&
+            layer_extent.maxx <= map_extent_maxx &&
+            layer_extent.miny >= map_extent_miny &&
+            layer_extent.maxy <= map_extent_maxy) {
+          /* if the area to map is larger than the layer extent, then */
+          /* use full layer extent and add some margin to reflect the */
+          /* proportion of the useful area over the requested bbox */
+          double extra_x = (map_extent_maxx - map_extent_minx) /
+                           (layer_extent.maxx - layer_extent.minx) *
+                           (layer_ori_extent.maxx - layer_ori_extent.minx);
+          double extra_y = (map_extent_maxy - map_extent_miny) /
+                           (layer_extent.maxy - layer_extent.miny) *
+                           (layer_ori_extent.maxy - layer_ori_extent.miny);
+          searchrect.minx = layer_ori_extent.minx - extra_x / 2;
+          searchrect.maxx = layer_ori_extent.maxx + extra_x / 2;
+          searchrect.miny = layer_ori_extent.miny - extra_y / 2;
+          searchrect.maxy = layer_ori_extent.maxy + extra_y / 2;
+        } else {
+          /* otherwise clip the map extent with the reprojected layer */
+          /* extent */
+          searchrect.minx = MS_MAX(map_extent_minx, layer_extent.minx);
+          searchrect.maxx = MS_MIN(map_extent_maxx, layer_extent.maxx);
+          searchrect.miny = MS_MAX(map_extent_miny, layer_extent.miny);
+          searchrect.maxy = MS_MIN(map_extent_maxy, layer_extent.maxy);
+          /* and reproject into the layer projection */
+          msProjectRect(&map_proj, &layer->projection, &searchrect);
         }
-
-        msFreeProjection(&map_proj);
+        bDone = MS_TRUE;
       }
+
+      msFreeProjection(&map_proj);
     }
+  }
 
-    if( !bDone )
-      msProjectRect(&map->projection, &layer->projection, &searchrect); /* project the searchrect to source coords */
+  if (!bDone)
+    msProjectRect(&map->projection, &layer->projection,
+                  &searchrect); /* project the searchrect to source coords */
 
-    return searchrect;
+  return searchrect;
 }
 
-int msUVRASTERLayerWhichShapes(layerObj *layer, rectObj rect, int isQuery)
-{
-  uvRasterLayerInfo *uvlinfo = (uvRasterLayerInfo *) layer->layerinfo;
+int msUVRASTERLayerWhichShapes(layerObj *layer, rectObj rect, int isQuery) {
+  uvRasterLayerInfo *uvlinfo = (uvRasterLayerInfo *)layer->layerinfo;
   imageObj *image_tmp;
   outputFormatObj *outputformat = NULL;
   mapObj *map_tmp;
   double map_cellsize;
   unsigned int spacing;
   int width, height, u_src_off, v_src_off, i, x, y;
-  char   **alteredProcessing = NULL, *saved_layer_mask;
+  char **alteredProcessing = NULL, *saved_layer_mask;
   char **savedProcessing = NULL;
   int bHasLonWrap = MS_FALSE;
   double dfLonWrap = 0.0;
   rectObj oldLayerExtent = {0};
-  char* oldLayerData = NULL;
-  projectionObj oldLayerProjection={0};
+  char *oldLayerData = NULL;
+  projectionObj oldLayerProjection = {0};
   int ret;
 
   if (layer->debug)
     msDebug("Entering msUVRASTERLayerWhichShapes().\n");
 
-  if( uvlinfo == NULL )
+  if (uvlinfo == NULL)
     return MS_FAILURE;
 
-  if( CSLFetchNameValue( layer->processing, "BANDS" ) == NULL ) {
-    msSetError( MS_MISCERR, "BANDS processing option is required for UV layer. You have to specified 2 bands.",
-                "msUVRASTERLayerWhichShapes()" );
+  if (CSLFetchNameValue(layer->processing, "BANDS") == NULL) {
+    msSetError(MS_MISCERR,
+               "BANDS processing option is required for UV layer. You have to "
+               "specified 2 bands.",
+               "msUVRASTERLayerWhichShapes()");
     return MS_FAILURE;
   }
-  
+
   /*
   ** Allocate mapObj structure
   */
-  map_tmp = (mapObj *)msSmallCalloc(sizeof(mapObj),1);
-  if(initMap(map_tmp) == -1) { /* initialize this map */
+  map_tmp = (mapObj *)msSmallCalloc(sizeof(mapObj), 1);
+  if (initMap(map_tmp) == -1) { /* initialize this map */
     msFree(map_tmp);
-    return(MS_FAILURE);
+    return (MS_FAILURE);
   }
 
   /* -------------------------------------------------------------------- */
   /*      Determine desired spacing.  Default to 32 if not otherwise set  */
   /* -------------------------------------------------------------------- */
   spacing = 32;
-  if( CSLFetchNameValue( layer->processing, "UV_SPACING" ) != NULL ) {
-    spacing =
-      atoi(CSLFetchNameValue( layer->processing, "UV_SPACING" ));
-    if( spacing == 0 )
-        spacing = 32;
+  if (CSLFetchNameValue(layer->processing, "UV_SPACING") != NULL) {
+    spacing = atoi(CSLFetchNameValue(layer->processing, "UV_SPACING"));
+    if (spacing == 0)
+      spacing = 32;
   }
 
-  width = (int)(layer->map->width/spacing);
-  height = (int)(layer->map->height/spacing);
+  width = (int)(layer->map->width / spacing);
+  height = (int)(layer->map->height / spacing);
 
   /* Initialize our dummy map */
-  MS_INIT_COLOR(map_tmp->imagecolor, 255,255,255,255);
+  MS_INIT_COLOR(map_tmp->imagecolor, 255, 255, 255, 255);
   map_tmp->resolution = layer->map->resolution;
   map_tmp->defresolution = layer->map->defresolution;
 
-  outputformat = (outputFormatObj *) msSmallCalloc(1,sizeof(outputFormatObj));
+  outputformat = (outputFormatObj *)msSmallCalloc(1, sizeof(outputFormatObj));
   outputformat->bands = uvlinfo->band_count = 2;
   outputformat->name = NULL;
   outputformat->driver = NULL;
@@ -531,7 +517,7 @@ int msUVRASTERLayerWhichShapes(layerObj
   outputformat->renderer = MS_RENDER_WITH_RAWDATA;
   outputformat->imagemode = MS_IMAGEMODE_FLOAT32;
   msAppendOutputFormat(map_tmp, outputformat);
-  
+
   msCopyHashTable(&map_tmp->configoptions, &layer->map->configoptions);
   map_tmp->mappath = msStrdup(layer->map->mappath);
   map_tmp->shapepath = msStrdup(layer->map->shapepath);
@@ -546,13 +532,12 @@ int msUVRASTERLayerWhichShapes(layerObj
     map_tmp->projection.automatic = layer->projection.automatic;
 
     for (i = 0; i < layer->projection.numargs; i++) {
-      if( strncmp(layer->projection.args[i], "lon_wrap=",
-                  strlen("lon_wrap=")) == 0 ) {
+      if (strncmp(layer->projection.args[i],
+                  "lon_wrap=", strlen("lon_wrap=")) == 0) {
         bHasLonWrap = MS_TRUE;
-        dfLonWrap = atof( layer->projection.args[i] + strlen("lon_wrap=") );
-      }
-      else {
-        map_tmp->projection.args[map_tmp->projection.numargs ++] =
+        dfLonWrap = atof(layer->projection.args[i] + strlen("lon_wrap="));
+      } else {
+        map_tmp->projection.args[map_tmp->projection.numargs++] =
             msStrdup(layer->projection.args[i]);
       }
     }
@@ -560,171 +545,182 @@ int msUVRASTERLayerWhichShapes(layerObj
       msProcessProjection(&(map_tmp->projection));
     }
 
-    map_tmp->projection.wellknownprojection = layer->projection.wellknownprojection;
+    map_tmp->projection.wellknownprojection =
+        layer->projection.wellknownprojection;
   }
 
-  /* Very special case to improve quality for rasters referenced from lon=0 to 360 */
+  /* Very special case to improve quality for rasters referenced from lon=0 to
+   * 360 */
   /* We create a temporary VRT that swiches the 2 hemispheres, and then we */
   /* modify the georeferncing to be in the more standard [-180, 180] range */
   /* and we adjust the layer->data, extent and projection accordingly */
-  if( layer->tileindex == NULL &&
-      uvlinfo->mapToUseForWhichShapes && bHasLonWrap && dfLonWrap == 180.0 )
-  {
-      rectObj layerExtent;
-      msLayerGetExtent(layer, &layerExtent);
-      if( layerExtent.minx == 0 && layerExtent.maxx == 360 )
-      {
-          GDALDatasetH hDS = NULL;
-          char* decrypted_path;
-
-          if( strncmp(layer->data, "<VRTDataset", strlen("<VRTDataset")) == 0 )
-          {
-            decrypted_path = msStrdup(layer->data);
-          }
-          else
-          {
-            char szPath[MS_MAXPATHLEN];
-            msTryBuildPath3(szPath, layer->map->mappath,
-                            layer->map->shapepath, layer->data);
-            decrypted_path = msDecryptStringTokens( layer->map, szPath );
-          }
+  if (layer->tileindex == NULL && uvlinfo->mapToUseForWhichShapes &&
+      bHasLonWrap && dfLonWrap == 180.0) {
+    rectObj layerExtent;
+    msLayerGetExtent(layer, &layerExtent);
+    if (layerExtent.minx == 0 && layerExtent.maxx == 360) {
+      GDALDatasetH hDS = NULL;
+      char *decrypted_path;
+
+      if (strncmp(layer->data, "<VRTDataset", strlen("<VRTDataset")) == 0) {
+        decrypted_path = msStrdup(layer->data);
+      } else {
+        char szPath[MS_MAXPATHLEN];
+        msTryBuildPath3(szPath, layer->map->mappath, layer->map->shapepath,
+                        layer->data);
+        decrypted_path = msDecryptStringTokens(layer->map, szPath);
+      }
 
-          if( decrypted_path )
-          {
-              char** connectionoptions;
-              GDALAllRegister();
-              connectionoptions = msGetStringListFromHashTable(&(layer->connectionoptions));
-              hDS = GDALOpenEx(decrypted_path,
-                                        GDAL_OF_RASTER,
-                                        NULL,
-                                        (const char* const*)connectionoptions,
-                                        NULL);
-              CSLDestroy(connectionoptions);
+      if (decrypted_path) {
+        char **connectionoptions;
+        GDALAllRegister();
+        connectionoptions =
+            msGetStringListFromHashTable(&(layer->connectionoptions));
+        hDS = GDALOpenEx(decrypted_path, GDAL_OF_RASTER, NULL,
+                         (const char *const *)connectionoptions, NULL);
+        CSLDestroy(connectionoptions);
+      }
+      if (hDS != NULL) {
+        int iBand;
+        int nXSize = GDALGetRasterXSize(hDS);
+        int nYSize = GDALGetRasterYSize(hDS);
+        int nBands = GDALGetRasterCount(hDS);
+        int nMaxLen = 100 + nBands * (800 + 2 * strlen(decrypted_path));
+        int nOffset = 0;
+        char *pszInlineVRT = msSmallMalloc(nMaxLen);
+
+        snprintf(pszInlineVRT, nMaxLen,
+                 "<VRTDataset rasterXSize=\"%d\" rasterYSize=\"%d\">", nXSize,
+                 nYSize);
+        nOffset = strlen(pszInlineVRT);
+        for (iBand = 1; iBand <= nBands; iBand++) {
+          const char *pszDataType = "Byte";
+          switch (GDALGetRasterDataType(GDALGetRasterBand(hDS, iBand))) {
+          case GDT_Byte:
+            pszDataType = "Byte";
+            break;
+          case GDT_Int16:
+            pszDataType = "Int16";
+            break;
+          case GDT_UInt16:
+            pszDataType = "UInt16";
+            break;
+          case GDT_Int32:
+            pszDataType = "Int32";
+            break;
+          case GDT_UInt32:
+            pszDataType = "UInt32";
+            break;
+          case GDT_Float32:
+            pszDataType = "Float32";
+            break;
+          case GDT_Float64:
+            pszDataType = "Float64";
+            break;
+          default:
+            break;
           }
-          if( hDS != NULL )
-          {
-              int iBand;
-              int nXSize = GDALGetRasterXSize( hDS );
-              int nYSize = GDALGetRasterYSize( hDS );
-              int nBands = GDALGetRasterCount( hDS );
-              int nMaxLen = 100 + nBands * (800 + 2 * strlen(decrypted_path));
-              int nOffset = 0;
-              char* pszInlineVRT = msSmallMalloc( nMaxLen );
-
-              snprintf(pszInlineVRT, nMaxLen,
-                "<VRTDataset rasterXSize=\"%d\" rasterYSize=\"%d\">",
-                nXSize, nYSize);
-              nOffset = strlen(pszInlineVRT);
-              for( iBand = 1; iBand <= nBands; iBand++ )
-              {
-                  const char* pszDataType = "Byte";
-                  switch( GDALGetRasterDataType(GDALGetRasterBand(hDS, iBand)) )
-                  {
-                      case GDT_Byte: pszDataType = "Byte"; break;
-                      case GDT_Int16: pszDataType = "Int16"; break;
-                      case GDT_UInt16: pszDataType = "UInt16"; break;
-                      case GDT_Int32: pszDataType = "Int32"; break;
-                      case GDT_UInt32: pszDataType = "UInt32"; break;
-                      case GDT_Float32: pszDataType = "Float32"; break;
-                      case GDT_Float64: pszDataType = "Float64"; break;
-                      default: break;
-                  }
-
-                  snprintf( pszInlineVRT + nOffset, nMaxLen - nOffset,
-                    "    <VRTRasterBand dataType=\"%s\" band=\"%d\">"
-                    "        <SimpleSource>"
-                    "            <SourceFilename relativeToVrt=\"1\"><![CDATA[%s]]></SourceFilename>"
-                    "            <SourceBand>%d</SourceBand>"
-                    "            <SrcRect xOff=\"%d\" yOff=\"%d\" xSize=\"%d\" ySize=\"%d\"/>"
-                    "            <DstRect xOff=\"%d\" yOff=\"%d\" xSize=\"%d\" ySize=\"%d\"/>"
-                    "        </SimpleSource>"
-                    "        <SimpleSource>"
-                    "            <SourceFilename relativeToVrt=\"1\"><![CDATA[%s]]></SourceFilename>"
-                    "            <SourceBand>%d</SourceBand>"
-                    "            <SrcRect xOff=\"%d\" yOff=\"%d\" xSize=\"%d\" ySize=\"%d\"/>"
-                    "            <DstRect xOff=\"%d\" yOff=\"%d\" xSize=\"%d\" ySize=\"%d\"/>"
-                    "        </SimpleSource>"
-                    "    </VRTRasterBand>",
-                    pszDataType, iBand,
-                    decrypted_path, iBand,
-                    nXSize / 2, 0, nXSize - nXSize / 2, nYSize,
-                    0,          0, nXSize - nXSize / 2, nYSize,
-                    decrypted_path, iBand,
-                    0,                   0, nXSize / 2, nYSize,
-                    nXSize - nXSize / 2, 0, nXSize / 2, nYSize );
-
-                  nOffset += strlen(pszInlineVRT + nOffset);
-              }
-              snprintf(pszInlineVRT + nOffset, nMaxLen - nOffset,
-                "</VRTDataset>");
-
-              oldLayerExtent = layer->extent;
-              oldLayerData = layer->data;
-              oldLayerProjection = layer->projection;
-              layer->extent.minx = -180;
-              layer->extent.maxx = 180;
-              layer->data = pszInlineVRT;
-              layer->projection = map_tmp->projection;
-
-
-              /* map_tmp->projection is actually layer->projection without lon_wrap */
-              rect = uvlinfo->mapToUseForWhichShapes->extent;
-              msProjectRect(&uvlinfo->mapToUseForWhichShapes->projection,
-                            &map_tmp->projection, &rect);
-              bHasLonWrap = MS_FALSE;
 
-              GDALClose(hDS);
-          }
-          msFree( decrypted_path );
+          snprintf(pszInlineVRT + nOffset, nMaxLen - nOffset,
+                   "    <VRTRasterBand dataType=\"%s\" band=\"%d\">"
+                   "        <SimpleSource>"
+                   "            <SourceFilename "
+                   "relativeToVrt=\"1\"><![CDATA[%s]]></SourceFilename>"
+                   "            <SourceBand>%d</SourceBand>"
+                   "            <SrcRect xOff=\"%d\" yOff=\"%d\" xSize=\"%d\" "
+                   "ySize=\"%d\"/>"
+                   "            <DstRect xOff=\"%d\" yOff=\"%d\" xSize=\"%d\" "
+                   "ySize=\"%d\"/>"
+                   "        </SimpleSource>"
+                   "        <SimpleSource>"
+                   "            <SourceFilename "
+                   "relativeToVrt=\"1\"><![CDATA[%s]]></SourceFilename>"
+                   "            <SourceBand>%d</SourceBand>"
+                   "            <SrcRect xOff=\"%d\" yOff=\"%d\" xSize=\"%d\" "
+                   "ySize=\"%d\"/>"
+                   "            <DstRect xOff=\"%d\" yOff=\"%d\" xSize=\"%d\" "
+                   "ySize=\"%d\"/>"
+                   "        </SimpleSource>"
+                   "    </VRTRasterBand>",
+                   pszDataType, iBand, decrypted_path, iBand, nXSize / 2, 0,
+                   nXSize - nXSize / 2, nYSize, 0, 0, nXSize - nXSize / 2,
+                   nYSize, decrypted_path, iBand, 0, 0, nXSize / 2, nYSize,
+                   nXSize - nXSize / 2, 0, nXSize / 2, nYSize);
+
+          nOffset += strlen(pszInlineVRT + nOffset);
+        }
+        snprintf(pszInlineVRT + nOffset, nMaxLen - nOffset, "</VRTDataset>");
+
+        oldLayerExtent = layer->extent;
+        oldLayerData = layer->data;
+        oldLayerProjection = layer->projection;
+        layer->extent.minx = -180;
+        layer->extent.maxx = 180;
+        layer->data = pszInlineVRT;
+        layer->projection = map_tmp->projection;
+
+        /* map_tmp->projection is actually layer->projection without lon_wrap */
+        rect = uvlinfo->mapToUseForWhichShapes->extent;
+        msProjectRect(&uvlinfo->mapToUseForWhichShapes->projection,
+                      &map_tmp->projection, &rect);
+        bHasLonWrap = MS_FALSE;
+
+        GDALClose(hDS);
       }
+      msFree(decrypted_path);
+    }
   }
 
-  if( isQuery )
-  {
-      /* For query mode, use layer->map->extent reprojected rather than */
-      /* the provided rect. Generic query code will filter returned features. */
-      rect = msUVRASTERGetSearchRect(layer, layer->map);
-  }
-
-  map_cellsize = MS_MAX(MS_CELLSIZE(rect.minx, rect.maxx,layer->map->width),
-                        MS_CELLSIZE(rect.miny,rect.maxy,layer->map->height));
-  map_tmp->cellsize = map_cellsize*spacing;
-  map_tmp->extent.minx = rect.minx-(0.5*map_cellsize)+(0.5*map_tmp->cellsize);
-  map_tmp->extent.miny = rect.miny-(0.5*map_cellsize)+(0.5*map_tmp->cellsize);
-  map_tmp->extent.maxx = map_tmp->extent.minx+((width-1)*map_tmp->cellsize);
-  map_tmp->extent.maxy = map_tmp->extent.miny+((height-1)*map_tmp->cellsize);
-
-  if( bHasLonWrap && dfLonWrap == 180.0) {
-    if( map_tmp->extent.minx >= 180 ) {
-      /* Request on the right half of the shifted raster (= western hemisphere) */
+  if (isQuery) {
+    /* For query mode, use layer->map->extent reprojected rather than */
+    /* the provided rect. Generic query code will filter returned features. */
+    rect = msUVRASTERGetSearchRect(layer, layer->map);
+  }
+
+  map_cellsize = MS_MAX(MS_CELLSIZE(rect.minx, rect.maxx, layer->map->width),
+                        MS_CELLSIZE(rect.miny, rect.maxy, layer->map->height));
+  map_tmp->cellsize = map_cellsize * spacing;
+  map_tmp->extent.minx =
+      rect.minx - (0.5 * map_cellsize) + (0.5 * map_tmp->cellsize);
+  map_tmp->extent.miny =
+      rect.miny - (0.5 * map_cellsize) + (0.5 * map_tmp->cellsize);
+  map_tmp->extent.maxx =
+      map_tmp->extent.minx + ((width - 1) * map_tmp->cellsize);
+  map_tmp->extent.maxy =
+      map_tmp->extent.miny + ((height - 1) * map_tmp->cellsize);
+
+  if (bHasLonWrap && dfLonWrap == 180.0) {
+    if (map_tmp->extent.minx >= 180) {
+      /* Request on the right half of the shifted raster (= western hemisphere)
+       */
       map_tmp->extent.minx -= 360;
       map_tmp->extent.maxx -= 360;
-    }
-    else if( map_tmp->extent.maxx >= 180.0 ) {
+    } else if (map_tmp->extent.maxx >= 180.0) {
       /* Request spanning on the 2 hemispheres => drawing whole planet */
       /* Take only into account vertical resolution, as horizontal one */
       /* will be unreliable (assuming square pixels...) */
-      map_cellsize = MS_CELLSIZE(rect.miny,rect.maxy,layer->map->height);
-      map_tmp->cellsize = map_cellsize*spacing;
+      map_cellsize = MS_CELLSIZE(rect.miny, rect.maxy, layer->map->height);
+      map_tmp->cellsize = map_cellsize * spacing;
 
       width = 360.0 / map_tmp->cellsize;
-      map_tmp->extent.minx = -180.0+(0.5*map_tmp->cellsize);
-      map_tmp->extent.maxx = 180.0-(0.5*map_tmp->cellsize);
+      map_tmp->extent.minx = -180.0 + (0.5 * map_tmp->cellsize);
+      map_tmp->extent.maxx = 180.0 - (0.5 * map_tmp->cellsize);
     }
   }
 
   if (layer->debug)
-    msDebug("msUVRASTERLayerWhichShapes(): width: %d, height: %d, cellsize: %g\n",
-            width, height, map_tmp->cellsize);
+    msDebug(
+        "msUVRASTERLayerWhichShapes(): width: %d, height: %d, cellsize: %g\n",
+        width, height, map_tmp->cellsize);
 
   if (layer->debug == MS_DEBUGLEVEL_VVV)
     msDebug("msUVRASTERLayerWhichShapes(): extent: %g %g %g %g\n",
-            map_tmp->extent.minx, map_tmp->extent.miny,
-            map_tmp->extent.maxx, map_tmp->extent.maxy);
+            map_tmp->extent.minx, map_tmp->extent.miny, map_tmp->extent.maxx,
+            map_tmp->extent.maxy);
 
   /* important to use that function, to compute map
      geotransform, used by the resampling*/
-   msMapSetSize(map_tmp, width, height);
+  msMapSetSize(map_tmp, width, height);
 
   if (layer->debug == MS_DEBUGLEVEL_VVV)
     msDebug("msUVRASTERLayerWhichShapes(): geotransform: %g %g %g %g %g %g\n",
@@ -734,35 +730,33 @@ int msUVRASTERLayerWhichShapes(layerObj
 
   uvlinfo->extent = map_tmp->extent;
 
-  image_tmp = msImageCreate(width, height, map_tmp->outputformatlist[0],
-                            NULL, NULL, map_tmp->resolution, map_tmp->defresolution,
+  image_tmp = msImageCreate(width, height, map_tmp->outputformatlist[0], NULL,
+                            NULL, map_tmp->resolution, map_tmp->defresolution,
                             &(map_tmp->imagecolor));
 
   /* Default set to AVERAGE resampling */
-  if( CSLFetchNameValue( layer->processing, "RESAMPLE" ) == NULL ) {
-    alteredProcessing = CSLDuplicate( layer->processing );
+  if (CSLFetchNameValue(layer->processing, "RESAMPLE") == NULL) {
+    alteredProcessing = CSLDuplicate(layer->processing);
     alteredProcessing =
-      CSLSetNameValue( alteredProcessing, "RESAMPLE",
-                       "AVERAGE");
+        CSLSetNameValue(alteredProcessing, "RESAMPLE", "AVERAGE");
     savedProcessing = layer->processing;
     layer->processing = alteredProcessing;
   }
 
-  /* disable masking at this level: we don't want to apply the mask at the raster level,
-   * it will be applied with the correct cellsize and image size in the vector rendering
-   * phase.
+  /* disable masking at this level: we don't want to apply the mask at the
+   * raster level, it will be applied with the correct cellsize and image size
+   * in the vector rendering phase.
    */
   saved_layer_mask = layer->mask;
   layer->mask = NULL;
-  ret = msDrawRasterLayerLow(map_tmp, layer, image_tmp, NULL );
+  ret = msDrawRasterLayerLow(map_tmp, layer, image_tmp, NULL);
 
   /* restore layer attributes if we went through the above on-the-fly VRT */
-  if( oldLayerData )
-  {
-      msFree(layer->data);
-      layer->data = oldLayerData;
-      layer->extent = oldLayerExtent;
-      layer->projection = oldLayerProjection;
+  if (oldLayerData) {
+    msFree(layer->data);
+    layer->data = oldLayerData;
+    layer->extent = oldLayerExtent;
+    layer->projection = oldLayerProjection;
   }
 
   /* restore layer mask */
@@ -774,8 +768,9 @@ int msUVRASTERLayerWhichShapes(layerObj
     CSLDestroy(alteredProcessing);
   }
 
-  if( ret == MS_FAILURE) {
-    msSetError(MS_MISCERR, "Unable to draw raster data.", "msUVRASTERLayerWhichShapes()");
+  if (ret == MS_FAILURE) {
+    msSetError(MS_MISCERR, "Unable to draw raster data.",
+               "msUVRASTERLayerWhichShapes()");
 
     msFreeMap(map_tmp);
     msFreeImage(image_tmp);
@@ -785,14 +780,14 @@ int msUVRASTERLayerWhichShapes(layerObj
 
   /* free old query arrays */
   if (uvlinfo->u) {
-    for (i=0; i<uvlinfo->width; ++i) {
+    for (i = 0; i < uvlinfo->width; ++i) {
       free(uvlinfo->u[i]);
     }
     free(uvlinfo->u);
   }
 
   if (uvlinfo->v) {
-    for (i=0; i<uvlinfo->width; ++i) {
+    for (i = 0; i < uvlinfo->width; ++i) {
       free(uvlinfo->v[i]);
     }
     free(uvlinfo->v);
@@ -801,10 +796,10 @@ int msUVRASTERLayerWhichShapes(layerObj
   /* Update our uv layer structure */
   uvlinfo->width = width;
   uvlinfo->height = height;
-  uvlinfo->query_results = width*height;
+  uvlinfo->query_results = width * height;
 
-  uvlinfo->u = (float **)msSmallMalloc(sizeof(float *)*width);
-  uvlinfo->v = (float **)msSmallMalloc(sizeof(float *)*width);
+  uvlinfo->u = (float **)msSmallMalloc(sizeof(float *) * width);
+  uvlinfo->v = (float **)msSmallMalloc(sizeof(float *) * width);
 
   for (x = 0; x < width; ++x) {
     uvlinfo->u[x] = (float *)msSmallMalloc(height * sizeof(float));
@@ -812,7 +807,7 @@ int msUVRASTERLayerWhichShapes(layerObj
 
     for (y = 0; y < height; ++y) {
       u_src_off = v_src_off = x + y * width;
-      v_src_off += width*height;
+      v_src_off += width * height;
 
       uvlinfo->u[x][y] = image_tmp->img.raw_float[u_src_off];
       uvlinfo->v[x][y] = image_tmp->img.raw_float[v_src_off];
@@ -831,39 +826,38 @@ int msUVRASTERLayerWhichShapes(layerObj
   return MS_SUCCESS;
 }
 
-int msUVRASTERLayerGetShape(layerObj *layer, shapeObj *shape, resultObj *record)
-{
-  uvRasterLayerInfo *uvlinfo = (uvRasterLayerInfo *) layer->layerinfo;
-  lineObj line ;
+int msUVRASTERLayerGetShape(layerObj *layer, shapeObj *shape,
+                            resultObj *record) {
+  uvRasterLayerInfo *uvlinfo = (uvRasterLayerInfo *)layer->layerinfo;
+  lineObj line;
   pointObj point;
-  int i, j, k, x=0, y=0;
+  int i, j, k, x = 0, y = 0;
   long shapeindex = record->shapeindex;
 
   msFreeShape(shape);
   shape->type = MS_SHAPE_NULL;
 
-  if( shapeindex < 0 || shapeindex >= uvlinfo->query_results ) {
+  if (shapeindex < 0 || shapeindex >= uvlinfo->query_results) {
     msSetError(MS_MISCERR,
                "Out of range shape index requested.  Requested %ld\n"
                "but only %d shapes available.",
-               "msUVRASTERLayerGetShape()",
-               shapeindex, uvlinfo->query_results );
+               "msUVRASTERLayerGetShape()", shapeindex, uvlinfo->query_results);
     return MS_FAILURE;
   }
 
   /* loop to the next non null vector */
   k = 0;
-  for (i=0, x=-1; i<uvlinfo->width && k<=shapeindex; ++i, ++x) {
-    for (j=0, y=-1; j<uvlinfo->height && k<=shapeindex; ++j, ++k, ++y) {
+  for (i = 0, x = -1; i < uvlinfo->width && k <= shapeindex; ++i, ++x) {
+    for (j = 0, y = -1; j < uvlinfo->height && k <= shapeindex; ++j, ++k, ++y) {
       if (uvlinfo->u[i][j] == 0 && uvlinfo->v[i][j] == 0)
         --k;
     }
   }
 
-  point.x = Pix2Georef(x, 0, uvlinfo->width-1,
-                       uvlinfo->extent.minx, uvlinfo->extent.maxx, MS_FALSE);
-  point.y = Pix2Georef(y, 0, uvlinfo->height-1,
-                       uvlinfo->extent.miny, uvlinfo->extent.maxy, MS_TRUE);
+  point.x = Pix2Georef(x, 0, uvlinfo->width - 1, uvlinfo->extent.minx,
+                       uvlinfo->extent.maxx, MS_FALSE);
+  point.y = Pix2Georef(y, 0, uvlinfo->height - 1, uvlinfo->extent.miny,
+                       uvlinfo->extent.maxy, MS_TRUE);
   if (layer->debug == MS_DEBUGLEVEL_VVV)
     msDebug("msUVRASTERLayerWhichShapes(): shapeindex: %ld, x: %g, y: %g\n",
             shapeindex, point.x, point.y);
@@ -873,24 +867,23 @@ int msUVRASTERLayerGetShape(layerObj *la
   shape->type = MS_SHAPE_POINT;
   line.numpoints = 1;
   line.point = &point;
-  msAddLine( shape, &line );
-  msComputeBounds( shape );
+  msAddLine(shape, &line);
+  msComputeBounds(shape);
 
   shape->numvalues = layer->numitems;
-  shape->values = msUVRASTERGetValues(layer, &uvlinfo->u[x][y], &uvlinfo->v[x][y]);
+  shape->values =
+      msUVRASTERGetValues(layer, &uvlinfo->u[x][y], &uvlinfo->v[x][y]);
   shape->index = shapeindex;
   shape->resultindex = shapeindex;
 
   return MS_SUCCESS;
-
 }
 
-int msUVRASTERLayerNextShape(layerObj *layer, shapeObj *shape)
-{
-  uvRasterLayerInfo *uvlinfo = (uvRasterLayerInfo *) layer->layerinfo;
+int msUVRASTERLayerNextShape(layerObj *layer, shapeObj *shape) {
+  uvRasterLayerInfo *uvlinfo = (uvRasterLayerInfo *)layer->layerinfo;
 
-  if( uvlinfo->next_shape < 0
-      || uvlinfo->next_shape >= uvlinfo->query_results ) {
+  if (uvlinfo->next_shape < 0 ||
+      uvlinfo->next_shape >= uvlinfo->query_results) {
     msFreeShape(shape);
     shape->type = MS_SHAPE_NULL;
     return MS_DONE;
@@ -901,7 +894,7 @@ int msUVRASTERLayerNextShape(layerObj *l
     record.tileindex = 0;
     record.classindex = record.resultindex = -1;
 
-    return msUVRASTERLayerGetShape( layer, shape, &record);
+    return msUVRASTERLayerGetShape(layer, shape, &record);
   }
 }
 
@@ -917,27 +910,32 @@ int msUVRASTERLayerGetExtent(layerObj *l
   mapObj *map = layer->map;
   shapefileObj *tileshpfile;
 
-  if( (!layer->data || strlen(layer->data) == 0)
-      && layer->tileindex == NULL) {
+  if ((!layer->data || strlen(layer->data) == 0) && layer->tileindex == NULL) {
     /* should we be issuing a specific error about not supporting
        extents for tileindexed raster layers? */
     return MS_FAILURE;
   }
 
-  if( map == NULL )
+  if (map == NULL)
     return MS_FAILURE;
 
-  /* If the layer use a tileindex, return the extent of the tileindex shapefile/referenced layer */
+  /* If the layer use a tileindex, return the extent of the tileindex
+   * shapefile/referenced layer */
   if (layer->tileindex) {
     const int tilelayerindex = msGetLayerIndex(map, layer->tileindex);
-    if(tilelayerindex != -1) /* does the tileindex reference another layer */
+    if (tilelayerindex != -1) /* does the tileindex reference another layer */
       return msLayerGetExtent(GET_LAYER(map, tilelayerindex), extent);
     else {
-      tileshpfile = (shapefileObj *) malloc(sizeof(shapefileObj));
+      tileshpfile = (shapefileObj *)malloc(sizeof(shapefileObj));
       MS_CHECK_ALLOC(tileshpfile, sizeof(shapefileObj), MS_FAILURE);
 
-      if(msShapefileOpen(tileshpfile, "rb", msBuildPath3(szPath, map->mappath, map->shapepath, layer->tileindex), MS_TRUE) == -1)
-        if(msShapefileOpen(tileshpfile, "rb", msBuildPath(szPath, map->mappath, layer->tileindex), MS_TRUE) == -1)
+      if (msShapefileOpen(tileshpfile, "rb",
+                          msBuildPath3(szPath, map->mappath, map->shapepath,
+                                       layer->tileindex),
+                          MS_TRUE) == -1)
+        if (msShapefileOpen(tileshpfile, "rb",
+                            msBuildPath(szPath, map->mappath, layer->tileindex),
+                            MS_TRUE) == -1)
           return MS_FAILURE;
 
       *extent = tileshpfile->bounds;
@@ -948,36 +946,34 @@ int msUVRASTERLayerGetExtent(layerObj *l
   }
 
   msTryBuildPath3(szPath, map->mappath, map->shapepath, layer->data);
-  char* decrypted_path = msDecryptStringTokens( map, szPath );
-  if( !decrypted_path )
-      return MS_FAILURE;
+  char *decrypted_path = msDecryptStringTokens(map, szPath);
+  if (!decrypted_path)
+    return MS_FAILURE;
 
   GDALAllRegister();
 
-  char** connectionoptions = msGetStringListFromHashTable(&(layer->connectionoptions));
-  GDALDatasetH hDS = GDALOpenEx(decrypted_path,
-                                GDAL_OF_RASTER,
-                                NULL,
-                                (const char* const*)connectionoptions,
-                                NULL);
+  char **connectionoptions =
+      msGetStringListFromHashTable(&(layer->connectionoptions));
+  GDALDatasetH hDS = GDALOpenEx(decrypted_path, GDAL_OF_RASTER, NULL,
+                                (const char *const *)connectionoptions, NULL);
   CSLDestroy(connectionoptions);
-  msFree( decrypted_path );
-  if( hDS == NULL ) {
+  msFree(decrypted_path);
+  if (hDS == NULL) {
     return MS_FAILURE;
   }
 
-  const int nXSize = GDALGetRasterXSize( hDS );
-  const int nYSize = GDALGetRasterYSize( hDS );
+  const int nXSize = GDALGetRasterXSize(hDS);
+  const int nYSize = GDALGetRasterYSize(hDS);
   double adfGeoTransform[6] = {0};
-  const CPLErr eErr = GDALGetGeoTransform( hDS, adfGeoTransform );
-  if( eErr != CE_None ) {
-    GDALClose( hDS );
+  const CPLErr eErr = GDALGetGeoTransform(hDS, adfGeoTransform);
+  if (eErr != CE_None) {
+    GDALClose(hDS);
     return MS_FAILURE;
   }
 
   /* If this appears to be an ungeoreferenced raster than flip it for
      mapservers purposes. */
-  if( adfGeoTransform[5] == 1.0 && adfGeoTransform[3] == 0.0 ) {
+  if (adfGeoTransform[5] == 1.0 && adfGeoTransform[3] == 0.0) {
     adfGeoTransform[5] = -1.0;
     adfGeoTransform[3] = nYSize;
   }
@@ -991,7 +987,6 @@ int msUVRASTERLayerGetExtent(layerObj *l
   return MS_SUCCESS;
 }
 
-
 /************************************************************************/
 /*                     msUVRASTERLayerSetTimeFilter()                   */
 /*                                                                      */
@@ -1008,14 +1003,13 @@ int msUVRASTERLayerGetExtent(layerObj *l
 /************************************************************************/
 
 int msUVRASTERLayerSetTimeFilter(layerObj *layer, const char *timestring,
-                                 const char *timefield)
-{
+                                 const char *timefield) {
   int tilelayerindex;
 
   /* -------------------------------------------------------------------- */
   /*      If we don't have a tileindex the time filter has no effect.     */
   /* -------------------------------------------------------------------- */
-  if( layer->tileindex == NULL )
+  if (layer->tileindex == NULL)
     return MS_SUCCESS;
 
   /* -------------------------------------------------------------------- */
@@ -1030,27 +1024,24 @@ int msUVRASTERLayerSetTimeFilter(layerOb
   /*      This is propogated to the "working layer" created for the       */
   /*      tileindex by code in mapraster.c.                               */
   /* -------------------------------------------------------------------- */
-  if( tilelayerindex == -1 )
-    return msLayerMakeBackticsTimeFilter( layer, timestring, timefield );
+  if (tilelayerindex == -1)
+    return msLayerMakeBackticsTimeFilter(layer, timestring, timefield);
 
   /* -------------------------------------------------------------------- */
   /*      Otherwise we invoke the tileindex layers SetTimeFilter          */
   /*      method.                                                         */
   /* -------------------------------------------------------------------- */
-  if ( msCheckParentPointer(layer->map,"map")==MS_FAILURE )
+  if (msCheckParentPointer(layer->map, "map") == MS_FAILURE)
     return MS_FAILURE;
-  return msLayerSetTimeFilter( layer->GET_LAYER(map,tilelayerindex),
-                               timestring, timefield );
+  return msLayerSetTimeFilter(layer->GET_LAYER(map, tilelayerindex), timestring,
+                              timefield);
 }
 
-
 /************************************************************************/
 /*                msRASTERLayerInitializeVirtualTable()                 */
 /************************************************************************/
 
-int
-msUVRASTERLayerInitializeVirtualTable(layerObj *layer)
-{
+int msUVRASTERLayerInitializeVirtualTable(layerObj *layer) {
   assert(layer != NULL);
   assert(layer->vtable != NULL);
 
diff -pruN 8.0.1-5/mapv8.cpp 8.0.2-1/mapv8.cpp
--- 8.0.1-5/mapv8.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapv8.cpp	2024-06-11 20:41:34.000000000 +0000
@@ -35,11 +35,10 @@
 /* This file could be refactored in the future to encapsulate the global
    functions and internal use functions in a class. */
 
-/* Handler for Javascript Exceptions. Not exposed to JavaScript, used internally.
-   Most of the code from v8 shell example.
+/* Handler for Javascript Exceptions. Not exposed to JavaScript, used
+   internally. Most of the code from v8 shell example.
 */
-void msV8ReportException(TryCatch* try_catch, const char *msg = "")
-{
+void msV8ReportException(TryCatch *try_catch, const char *msg = "") {
   HandleScope handle_scope;
 
   if (!try_catch || !try_catch->HasCaught()) {
@@ -48,24 +47,25 @@ void msV8ReportException(TryCatch* try_c
   }
 
   String::Utf8Value exception(try_catch->Exception());
-  const char* exception_string = *exception;
+  const char *exception_string = *exception;
   Handle<Message> message = try_catch->Message();
   if (message.IsEmpty()) {
     msSetError(MS_V8ERR, "Javascript Exception: %s.", "msV8ReportException()",
                exception_string);
   } else {
     String::Utf8Value filename(message->GetScriptResourceName());
-    const char* filename_string = *filename;
+    const char *filename_string = *filename;
     int linenum = message->GetLineNumber();
-    msSetError(MS_V8ERR, "Javascript Exception: %s:%i: %s", "msV8ReportException()",
-               filename_string, linenum, exception_string);
+    msSetError(MS_V8ERR, "Javascript Exception: %s:%i: %s",
+               "msV8ReportException()", filename_string, linenum,
+               exception_string);
     String::Utf8Value sourceline(message->GetSourceLine());
-    const char* sourceline_string = *sourceline;
+    const char *sourceline_string = *sourceline;
     msSetError(MS_V8ERR, "Exception source line: %s", "msV8ReportException()",
                sourceline_string);
     String::Utf8Value stack_trace(try_catch->StackTrace());
     if (stack_trace.length() > 0) {
-      const char* stack_trace_string = *stack_trace;
+      const char *stack_trace_string = *stack_trace;
       msSetError(MS_V8ERR, "Exception StackTrace: %s", "msV8ReportException()",
                  stack_trace_string);
     }
@@ -73,11 +73,10 @@ void msV8ReportException(TryCatch* try_c
 }
 
 /* This function load a javascript file in memory. */
-static Handle<Value> msV8ReadFile(V8Context *v8context, const char *path)
-{
-  FILE* file = fopen(path, "rb");
+static Handle<Value> msV8ReadFile(V8Context *v8context, const char *path) {
+  FILE *file = fopen(path, "rb");
   if (file == NULL) {
-    char err[MS_MAXPATHLEN+21];
+    char err[MS_MAXPATHLEN + 21];
     sprintf(err, "Error opening file: %s", path);
     msV8ReportException(NULL, err);
     return Handle<String>(String::New(""));
@@ -87,12 +86,12 @@ static Handle<Value> msV8ReadFile(V8Cont
   int size = ftell(file);
   rewind(file);
 
-  char* chars = new char[size + 1];
+  char *chars = new char[size + 1];
   chars[size] = '\0';
   for (int i = 0; i < size;) {
     int read = static_cast<int>(fread(&chars[i], 1, size - i, file));
     if (read == 0) {
-      delete [] chars;
+      delete[] chars;
       fclose(file);
       msDebug("msV8ReadFile: error while reading file '%s'\n", path);
       return Undefined();
@@ -107,8 +106,8 @@ static Handle<Value> msV8ReadFile(V8Cont
 }
 
 /* Returns a compiled javascript script. */
-static Handle<Script> msV8CompileScript(Handle<String> source, Handle<String> script_name)
-{
+static Handle<Script> msV8CompileScript(Handle<String> source,
+                                        Handle<String> script_name) {
   TryCatch try_catch;
 
   if (source.IsEmpty() || source->Length() == 0) {
@@ -125,8 +124,7 @@ static Handle<Script> msV8CompileScript(
 }
 
 /* Runs a compiled script */
-static Handle<Value> msV8RunScript(Handle<Script> script)
-{
+static Handle<Value> msV8RunScript(Handle<Script> script) {
   if (script.IsEmpty()) {
     ThrowException(String::New("No script to run"));
     return Handle<Value>();
@@ -143,16 +141,16 @@ static Handle<Value> msV8RunScript(Handl
 }
 
 /* Execute a javascript file */
-static Handle<Value> msV8ExecuteScript(const char *path, int throw_exception = MS_FALSE)
-{
+static Handle<Value> msV8ExecuteScript(const char *path,
+                                       int throw_exception = MS_FALSE) {
   char fullpath[MS_MAXPATHLEN];
-  map<string, Persistent<Script> >::iterator it;
+  map<string, Persistent<Script>>::iterator it;
   Isolate *isolate = Isolate::GetCurrent();
-  V8Context *v8context = (V8Context*)isolate->GetData();
+  V8Context *v8context = (V8Context *)isolate->GetData();
 
   /* construct the path */
   msBuildPath(fullpath, v8context->paths.top().c_str(), path);
-  char *filepath = msGetPath((char*)fullpath);
+  char *filepath = msGetPath((char *)fullpath);
   v8context->paths.push(filepath);
   free(filepath);
 
@@ -160,7 +158,7 @@ static Handle<Value> msV8ExecuteScript(c
   it = v8context->scripts.find(fullpath);
   if (it == v8context->scripts.end()) {
     Handle<Value> source = msV8ReadFile(v8context, fullpath);
-    Handle<String> script_name = String::New(msStripPath((char*)path));
+    Handle<String> script_name = String::New(msStripPath((char *)path));
     script = msV8CompileScript(source->ToString(), script_name);
     if (script.IsEmpty()) {
       v8context->paths.pop();
@@ -191,8 +189,7 @@ static Handle<Value> msV8ExecuteScript(c
 
 /* JavaScript Function to load javascript dependencies.
    Exposed to JavaScript as 'require()'. */
-static Handle<Value> msV8Require(const Arguments& args)
-{
+static Handle<Value> msV8Require(const Arguments &args) {
   TryCatch try_catch;
 
   for (int i = 0; i < args.Length(); i++) {
@@ -208,8 +205,7 @@ static Handle<Value> msV8Require(const A
 
 /* Javascript Function print: print to debug file.
    Exposed to JavaScript as 'print()'. */
-static Handle<Value> msV8Print(const Arguments& args)
-{
+static Handle<Value> msV8Print(const Arguments &args) {
   for (int i = 0; i < args.Length(); i++) {
     String::Utf8Value str(args[i]);
     msDebug("msV8Print: %s\n", *str);
@@ -221,8 +217,7 @@ static Handle<Value> msV8Print(const Arg
 /* END OF JAVASCRIPT EXPOSED FUNCTIONS */
 
 /* Create and return a v8 context. Thread safe. */
-void msV8CreateContext(mapObj *map)
-{
+void msV8CreateContext(mapObj *map) {
 
   Isolate *isolate = Isolate::GetCurrent();
   Isolate::Scope isolate_scope(isolate);
@@ -235,7 +230,8 @@ void msV8CreateContext(mapObj *map)
   global_templ->Set(String::New("print"), FunctionTemplate::New(msV8Print));
   global_templ->Set(String::New("alert"), FunctionTemplate::New(msV8Print));
 
-  Handle<Context> context_ = Context::New(v8context->isolate, NULL, global_templ);
+  Handle<Context> context_ =
+      Context::New(v8context->isolate, NULL, global_templ);
   v8context->context.Reset(v8context->isolate, context_);
 
   /* we have to enter the context before getting global instance */
@@ -249,33 +245,30 @@ void msV8CreateContext(mapObj *map)
   v8context->isolate->SetData(v8context);
   v8context->layer = NULL;
 
-  map->v8context = (void*)v8context;
+  map->v8context = (void *)v8context;
 }
 
-void msV8ContextSetLayer(mapObj *map, layerObj *layer)
-{
-  V8Context* v8context = V8CONTEXT(map);
+void msV8ContextSetLayer(mapObj *map, layerObj *layer) {
+  V8Context *v8context = V8CONTEXT(map);
 
   if (!v8context) {
-    msSetError(MS_V8ERR, "V8 Persistent Context is not created.", "msV8ContextSetLayer()");
+    msSetError(MS_V8ERR, "V8 Persistent Context is not created.",
+               "msV8ContextSetLayer()");
     return;
   }
 
   v8context->layer = layer;
 }
 
-static void msV8FreeContextScripts(V8Context *v8context)
-{
-  map<string, Persistent<Script> >::iterator it;
-  for(it=v8context->scripts.begin(); it!=v8context->scripts.end(); ++it)
-  {
+static void msV8FreeContextScripts(V8Context *v8context) {
+  map<string, Persistent<Script>>::iterator it;
+  for (it = v8context->scripts.begin(); it != v8context->scripts.end(); ++it) {
     ((*it).second).Dispose();
   }
 }
 
-void msV8FreeContext(mapObj *map)
-{
-  V8Context* v8context = V8CONTEXT(map);
+void msV8FreeContext(mapObj *map) {
+  V8Context *v8context = V8CONTEXT(map);
   Shape::Dispose();
   Point::Dispose();
   Line::Dispose();
@@ -286,14 +279,15 @@ void msV8FreeContext(mapObj *map)
 
 /* Create a V8 execution context, execute a script and return the feature
  * style. */
-char* msV8GetFeatureStyle(mapObj *map, const char *filename, layerObj *layer, shapeObj *shape)
-{
+char *msV8GetFeatureStyle(mapObj *map, const char *filename, layerObj *layer,
+                          shapeObj *shape) {
   TryCatch try_catch;
-  V8Context* v8context = V8CONTEXT(map);
+  V8Context *v8context = V8CONTEXT(map);
   char *ret = NULL;
-    
+
   if (!v8context) {
-    msSetError(MS_V8ERR, "V8 Persistent Context is not created.", "msV8ReportException()");
+    msSetError(MS_V8ERR, "V8 Persistent Context is not created.",
+               "msV8ReportException()");
     return NULL;
   }
 
@@ -301,17 +295,19 @@ char* msV8GetFeatureStyle(mapObj *map, c
   HandleScope handle_scope(v8context->isolate);
 
   /* execution context */
-  Local<Context> context = Local<Context>::New(v8context->isolate, v8context->context);
+  Local<Context> context =
+      Local<Context>::New(v8context->isolate, v8context->context);
   Context::Scope context_scope(context);
   Handle<Object> global = context->Global();
 
   Shape *shape_ = new Shape(shape);
-  shape_->setLayer(layer); // hack to set the attribute names, should change in future.
-  shape_->disableMemoryHandler(); /* the internal object should not be freed by the v8 GC */
+  shape_->setLayer(
+      layer); // hack to set the attribute names, should change in future.
+  shape_->disableMemoryHandler(); /* the internal object should not be freed by
+                                     the v8 GC */
   Handle<Value> ext = External::New(shape_);
-  global->Set(String::New("shape"),
-              Shape::Constructor()->NewInstance(1, &ext));
-  
+  global->Set(String::New("shape"), Shape::Constructor()->NewInstance(1, &ext));
+
   msV8ExecuteScript(filename);
   Handle<Value> value = global->Get(String::New("styleitem"));
   if (value->IsUndefined()) {
@@ -325,33 +321,32 @@ char* msV8GetFeatureStyle(mapObj *map, c
   }
 
   if (!result.IsEmpty() && !result->IsUndefined()) {
-     String::AsciiValue ascii(result);
-     ret = msStrdup(*ascii);
+    String::AsciiValue ascii(result);
+    ret = msStrdup(*ascii);
   }
 
   return ret;
 }
 
 /* for geomtransform, we don't have the mapObj */
-shapeObj *msV8TransformShape(shapeObj *shape, const char* filename)
-{
+shapeObj *msV8TransformShape(shapeObj *shape, const char *filename) {
   TryCatch try_catch;
   Isolate *isolate = Isolate::GetCurrent();
-  V8Context *v8context = (V8Context*)isolate->GetData();
+  V8Context *v8context = (V8Context *)isolate->GetData();
 
   HandleScope handle_scope(v8context->isolate);
 
   /* execution context */
-  Local<Context> context = Local<Context>::New(v8context->isolate, v8context->context);
+  Local<Context> context =
+      Local<Context>::New(v8context->isolate, v8context->context);
   Context::Scope context_scope(context);
   Handle<Object> global = context->Global();
 
-  Shape* shape_ = new Shape(shape);
+  Shape *shape_ = new Shape(shape);
   shape_->setLayer(v8context->layer);
   shape_->disableMemoryHandler();
   Handle<Value> ext = External::New(shape_);
-  global->Set(String::New("shape"),
-              Shape::Constructor()->NewInstance(1, &ext));
+  global->Set(String::New("shape"), Shape::Constructor()->NewInstance(1, &ext));
 
   msV8ExecuteScript(filename);
   Handle<Value> value = global->Get(String::New("geomtransform"));
@@ -368,14 +363,13 @@ shapeObj *msV8TransformShape(shapeObj *s
   if (!result.IsEmpty() && result->IsObject()) {
     Handle<Object> obj = result->ToObject();
     if (obj->GetConstructorName()->Equals(String::New("shapeObj"))) {
-      Shape* new_shape = ObjectWrap::Unwrap<Shape>(result->ToObject());
+      Shape *new_shape = ObjectWrap::Unwrap<Shape>(result->ToObject());
       if (shape == new_shape->get()) {
         shapeObj *new_shape_ = (shapeObj *)msSmallMalloc(sizeof(shapeObj));
         msInitShape(new_shape_);
         msCopyShape(shape, new_shape_);
         return new_shape_;
-      }
-      else {
+      } else {
         new_shape->disableMemoryHandler();
         return new_shape->get();
       }
diff -pruN 8.0.1-5/mapwcs.cpp 8.0.2-1/mapwcs.cpp
--- 8.0.1-5/mapwcs.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapwcs.cpp	2024-06-11 20:41:34.000000000 +0000
@@ -49,47 +49,46 @@
 /************************************************************************/
 /*                    msWCSValidateRangeSetParam()                      */
 /************************************************************************/
-static int msWCSValidateRangeSetParam(layerObj *lp, char *name, const char *value)
-{
+static int msWCSValidateRangeSetParam(layerObj *lp, char *name,
+                                      const char *value) {
   char **allowed_ri_values;
   char **client_ri_values;
-  int  allowed_count, client_count;
-  int  i_client, i, all_match = 1;
+  int allowed_count, client_count;
+  int i_client, i, all_match = 1;
   char *tmpname = NULL;
   const char *ri_values_list;
 
-  if( name == NULL )
+  if (name == NULL)
     return MS_FAILURE;
 
   /* Fetch the available values list for the rangeset item and tokenize */
-  tmpname = (char *)msSmallMalloc(sizeof(char)*strlen(name) + 10);
-  sprintf(tmpname,"%s_values", name);
+  tmpname = (char *)msSmallMalloc(sizeof(char) * strlen(name) + 10);
+  sprintf(tmpname, "%s_values", name);
   ri_values_list = msOWSLookupMetadata(&(lp->metadata), "CO", tmpname);
-  msFree( tmpname );
+  msFree(tmpname);
 
   if (ri_values_list == NULL)
     return MS_FAILURE;
 
-  allowed_ri_values = msStringSplit( ri_values_list, ',', &allowed_count);
+  allowed_ri_values = msStringSplit(ri_values_list, ',', &allowed_count);
 
   /* Parse the client value list into tokens. */
-  client_ri_values = msStringSplit( value, ',', &client_count );
+  client_ri_values = msStringSplit(value, ',', &client_count);
 
   /* test each client value against the allowed list. */
 
-  for( i_client = 0; all_match && i_client < client_count; i_client++ ) {
-    for( i = 0;
-         i < allowed_count
-         && strcasecmp(client_ri_values[i_client],
-                       allowed_ri_values[i]) != 0;
-         i++ ) {}
+  for (i_client = 0; all_match && i_client < client_count; i_client++) {
+    for (i = 0; i < allowed_count && strcasecmp(client_ri_values[i_client],
+                                                allowed_ri_values[i]) != 0;
+         i++) {
+    }
 
-    if( i == allowed_count )
+    if (i == allowed_count)
       all_match = 0;
   }
 
-  msFreeCharArray(allowed_ri_values, allowed_count );
-  msFreeCharArray(client_ri_values, client_count );
+  msFreeCharArray(allowed_ri_values, allowed_count);
+  msFreeCharArray(client_ri_values, client_count);
 
   if (all_match == 0)
     return MS_FAILURE;
@@ -100,17 +99,16 @@ static int msWCSValidateRangeSetParam(la
 /************************************************************************/
 /*                    msWCSConvertRangeSetToString()                    */
 /************************************************************************/
-static char *msWCSConvertRangeSetToString(const char *value)
-{
+static char *msWCSConvertRangeSetToString(const char *value) {
   char **tokens;
   int numtokens;
   double min, max, res;
   double val;
-  char buf1[128], *buf2=NULL;
+  char buf1[128], *buf2 = NULL;
 
-  if(strchr(value, '/')) { /* value is min/max/res */
+  if (strchr(value, '/')) { /* value is min/max/res */
     tokens = msStringSplit(value, '/', &numtokens);
-    if(tokens==NULL || numtokens != 3) {
+    if (tokens == NULL || numtokens != 3) {
       msFreeCharArray(tokens, numtokens);
       return NULL; /* not a set of equally spaced intervals */
     }
@@ -120,8 +118,8 @@ static char *msWCSConvertRangeSetToStrin
     res = atof(tokens[2]);
     msFreeCharArray(tokens, numtokens);
 
-    for(val=min; val<=max; val+=res) {
-      if(val == min)
+    for (val = min; val <= max; val += res) {
+      if (val == min)
         snprintf(buf1, sizeof(buf1), "%g", val);
       else
         snprintf(buf1, sizeof(buf1), ",%g", val);
@@ -137,23 +135,28 @@ static char *msWCSConvertRangeSetToStrin
 /*                           msWCSException()                           */
 /************************************************************************/
 int msWCSException(mapObj *map, const char *code, const char *locator,
-                   const char *version )
-{
+                   const char *version) {
   char *pszEncodedVal = NULL;
   char version_string[OWS_VERSION_MAXLEN];
 
-  if( version == NULL )
+  if (version == NULL)
     version = "1.0.0";
 
 #if defined(USE_LIBXML2)
-  if( msOWSParseVersionString(version) >= OWS_2_0_0 )
-    return msWCSException20( map, code, locator, msOWSGetVersionString(msOWSParseVersionString(version), version_string) );
+  if (msOWSParseVersionString(version) >= OWS_2_0_0)
+    return msWCSException20(
+        map, code, locator,
+        msOWSGetVersionString(msOWSParseVersionString(version),
+                              version_string));
 #endif
 
-  if( msOWSParseVersionString(version) >= OWS_1_1_0 )
-    return msWCSException11( map, code, locator, msOWSGetVersionString(msOWSParseVersionString(version), version_string) );
+  if (msOWSParseVersionString(version) >= OWS_1_1_0)
+    return msWCSException11(
+        map, code, locator,
+        msOWSGetVersionString(msOWSParseVersionString(version),
+                              version_string));
 
-  msIO_setHeader("Content-Type","application/vnd.ogc.se_xml; charset=UTF-8");
+  msIO_setHeader("Content-Type", "application/vnd.ogc.se_xml; charset=UTF-8");
   msIO_sendHeaders();
 
   /* msIO_printf("Content-Type: text/xml%c%c",10,10); */
@@ -164,7 +167,8 @@ int msWCSException(mapObj *map, const ch
   msIO_printf("xmlns=\"http://www.opengis.net/ogc\" ");
   msIO_printf("xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" ");
   pszEncodedVal = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
-  msIO_printf("xsi:schemaLocation=\"http://www.opengis.net/ogc %s/wcs/1.0.0/OGC-exception.xsd\">\n",
+  msIO_printf("xsi:schemaLocation=\"http://www.opengis.net/ogc "
+              "%s/wcs/1.0.0/OGC-exception.xsd\">\n",
               pszEncodedVal);
   msFree(pszEncodedVal);
   msIO_printf("  <ServiceException");
@@ -188,18 +192,22 @@ int msWCSException(mapObj *map, const ch
 /*                    msWCSPrintRequestCapability()                     */
 /************************************************************************/
 
-static void msWCSPrintRequestCapability(const char *request_tag, const char *script_url)
-{
+static void msWCSPrintRequestCapability(const char *request_tag,
+                                        const char *script_url) {
   msIO_printf("    <%s>\n", request_tag);
 
   msIO_printf("      <DCPType>\n");
   msIO_printf("        <HTTP>\n");
-  msIO_printf("          <Get><OnlineResource xlink:type=\"simple\" xlink:href=\"%s\" /></Get>\n", script_url);
+  msIO_printf("          <Get><OnlineResource xlink:type=\"simple\" "
+              "xlink:href=\"%s\" /></Get>\n",
+              script_url);
   msIO_printf("        </HTTP>\n");
   msIO_printf("      </DCPType>\n");
   msIO_printf("      <DCPType>\n");
   msIO_printf("        <HTTP>\n");
-  msIO_printf("          <Post><OnlineResource xlink:type=\"simple\" xlink:href=\"%s\" /></Post>\n", script_url);
+  msIO_printf("          <Post><OnlineResource xlink:type=\"simple\" "
+              "xlink:href=\"%s\" /></Post>\n",
+              script_url);
   msIO_printf("        </HTTP>\n");
   msIO_printf("      </DCPType>\n");
 
@@ -209,11 +217,10 @@ static void msWCSPrintRequestCapability(
 /************************************************************************/
 /*                         msWCSCreateParams()                          */
 /************************************************************************/
-static wcsParamsObj *msWCSCreateParams()
-{
+static wcsParamsObj *msWCSCreateParams() {
   wcsParamsObj *params;
 
-  params = (wcsParamsObj *) calloc(1, sizeof(wcsParamsObj));
+  params = (wcsParamsObj *)calloc(1, sizeof(wcsParamsObj));
   MS_CHECK_ALLOC(params, sizeof(wcsParamsObj), NULL);
 
   return params;
@@ -222,22 +229,32 @@ static wcsParamsObj *msWCSCreateParams()
 /************************************************************************/
 /*                          msWCSFreeParams()                           */
 /************************************************************************/
-void msWCSFreeParams(wcsParamsObj *params)
-{
-  if(params) {
+void msWCSFreeParams(wcsParamsObj *params) {
+  if (params) {
     /* TODO */
-    if(params->version) free(params->version);
-    if(params->updatesequence) free(params->updatesequence);
-    if(params->request) free(params->request);
-    if(params->service) free(params->service);
-    if(params->section) free(params->section);
-    if(params->crs) free(params->crs);
-    if(params->response_crs) free(params->response_crs);
-    if(params->format) free(params->format);
-    if(params->exceptions) free(params->exceptions);
-    if(params->time) free(params->time);
-    if(params->interpolation) free(params->interpolation);
-    CSLDestroy( params->coverages );
+    if (params->version)
+      free(params->version);
+    if (params->updatesequence)
+      free(params->updatesequence);
+    if (params->request)
+      free(params->request);
+    if (params->service)
+      free(params->service);
+    if (params->section)
+      free(params->section);
+    if (params->crs)
+      free(params->crs);
+    if (params->response_crs)
+      free(params->response_crs);
+    if (params->format)
+      free(params->format);
+    if (params->exceptions)
+      free(params->exceptions);
+    if (params->time)
+      free(params->time);
+    if (params->interpolation)
+      free(params->interpolation);
+    CSLDestroy(params->coverages);
   }
 }
 
@@ -245,10 +262,12 @@ void msWCSFreeParams(wcsParamsObj *param
 /*                       msWCSIsLayerSupported()                        */
 /************************************************************************/
 
-int msWCSIsLayerSupported(layerObj *layer)
-{
-  /* only raster layers, are elligible to be served via WCS, WMS rasters are not ok */
-  if((layer->type == MS_LAYER_RASTER) && layer->connectiontype != MS_WMS && layer->name != NULL) return MS_TRUE;
+int msWCSIsLayerSupported(layerObj *layer) {
+  /* only raster layers, are elligible to be served via WCS, WMS rasters are not
+   * ok */
+  if ((layer->type == MS_LAYER_RASTER) && layer->connectiontype != MS_WMS &&
+      layer->name != NULL)
+    return MS_TRUE;
 
   return MS_FALSE;
 }
@@ -258,16 +277,15 @@ int msWCSIsLayerSupported(layerObj *laye
 /*                                                                      */
 /************************************************************************/
 
-const char *msWCSGetRequestParameter(cgiRequestObj *request, const char *name)
-{
+const char *msWCSGetRequestParameter(cgiRequestObj *request, const char *name) {
   int i;
 
-  if(!request || !name) /* nothing to do */
+  if (!request || !name) /* nothing to do */
     return NULL;
 
-  if(request->NumParams > 0) {
-    for(i=0; i<request->NumParams; i++) {
-      if(strcasecmp(request->ParamNames[i], name) == 0)
+  if (request->NumParams > 0) {
+    for (i = 0; i < request->NumParams; i++) {
+      if (strcasecmp(request->ParamNames[i], name) == 0)
         return request->ParamValues[i];
     }
   }
@@ -279,118 +297,122 @@ const char *msWCSGetRequestParameter(cgi
 /*                  msWCSSetDefaultBandsRangeSetInfo()                  */
 /************************************************************************/
 
-void msWCSSetDefaultBandsRangeSetInfo( wcsParamsObj *params,
-                                       coverageMetadataObj *cm,
-                                       layerObj *lp )
-{
+void msWCSSetDefaultBandsRangeSetInfo(wcsParamsObj *params,
+                                      coverageMetadataObj *cm, layerObj *lp) {
   (void)params;
 
-  /* This function will provide default rangeset information for the "special" */
-  /* "bands" rangeset if it appears in the axes list but has no specifics provided */
+  /* This function will provide default rangeset information for the "special"
+   */
+  /* "bands" rangeset if it appears in the axes list but has no specifics
+   * provided */
   /* in the metadata.   */
 
   const char *value;
   char *bandlist;
   size_t bufferSize = 0;
-  int  i;
+  int i;
 
   /* Does this item exist in the axes list?  */
 
   value = msOWSLookupMetadata(&(lp->metadata), "CO", "rangeset_axes");
-  if( value == NULL )
+  if (value == NULL)
     return;
 
-  value = strstr(value,"bands");
-  if( value == NULL || (value[5] != '\0' && value[5] != ' ') )
+  value = strstr(value, "bands");
+  if (value == NULL || (value[5] != '\0' && value[5] != ' '))
     return;
 
   /* Are there any w*s_bands_ metadata already? If so, skip out. */
-  if( msOWSLookupMetadata(&(lp->metadata), "CO", "bands_description") != NULL
-      || msOWSLookupMetadata(&(lp->metadata), "CO", "bands_name") != NULL
-      || msOWSLookupMetadata(&(lp->metadata), "CO", "bands_label") != NULL
-      || msOWSLookupMetadata(&(lp->metadata), "CO", "bands_values") != NULL
-      || msOWSLookupMetadata(&(lp->metadata), "CO", "bands_values_semantic") != NULL
-      || msOWSLookupMetadata(&(lp->metadata), "CO", "bands_values_type") != NULL
-      || msOWSLookupMetadata(&(lp->metadata), "CO", "bands_rangeitem") != NULL
-      || msOWSLookupMetadata(&(lp->metadata), "CO", "bands_semantic") != NULL
-      || msOWSLookupMetadata(&(lp->metadata), "CO", "bands_refsys") != NULL
-      || msOWSLookupMetadata(&(lp->metadata), "CO", "bands_refsyslabel") != NULL
-      || msOWSLookupMetadata(&(lp->metadata), "CO", "bands_interval") != NULL )
+  if (msOWSLookupMetadata(&(lp->metadata), "CO", "bands_description") != NULL ||
+      msOWSLookupMetadata(&(lp->metadata), "CO", "bands_name") != NULL ||
+      msOWSLookupMetadata(&(lp->metadata), "CO", "bands_label") != NULL ||
+      msOWSLookupMetadata(&(lp->metadata), "CO", "bands_values") != NULL ||
+      msOWSLookupMetadata(&(lp->metadata), "CO", "bands_values_semantic") !=
+          NULL ||
+      msOWSLookupMetadata(&(lp->metadata), "CO", "bands_values_type") != NULL ||
+      msOWSLookupMetadata(&(lp->metadata), "CO", "bands_rangeitem") != NULL ||
+      msOWSLookupMetadata(&(lp->metadata), "CO", "bands_semantic") != NULL ||
+      msOWSLookupMetadata(&(lp->metadata), "CO", "bands_refsys") != NULL ||
+      msOWSLookupMetadata(&(lp->metadata), "CO", "bands_refsyslabel") != NULL ||
+      msOWSLookupMetadata(&(lp->metadata), "CO", "bands_interval") != NULL)
     return;
 
   /* OK, we have decided to fill in the information. */
 
-  msInsertHashTable( &(lp->metadata), "wcs_bands_name", "bands" );
-  msInsertHashTable( &(lp->metadata), "wcs_bands_label", "Bands/Channels/Samples" );
-  msInsertHashTable( &(lp->metadata), "wcs_bands_rangeitem", "_bands" ); /* ? */
-
-  bufferSize = cm->bandcount*30+30;
-  bandlist = (char *) msSmallMalloc(bufferSize);
-  strcpy( bandlist, "1" );
-  for( i = 1; i < cm->bandcount; i++ )
-    snprintf( bandlist+strlen(bandlist), bufferSize-strlen(bandlist), ",%d", i+1 );
+  msInsertHashTable(&(lp->metadata), "wcs_bands_name", "bands");
+  msInsertHashTable(&(lp->metadata), "wcs_bands_label",
+                    "Bands/Channels/Samples");
+  msInsertHashTable(&(lp->metadata), "wcs_bands_rangeitem", "_bands"); /* ? */
+
+  bufferSize = cm->bandcount * 30 + 30;
+  bandlist = (char *)msSmallMalloc(bufferSize);
+  strcpy(bandlist, "1");
+  for (i = 1; i < cm->bandcount; i++)
+    snprintf(bandlist + strlen(bandlist), bufferSize - strlen(bandlist), ",%d",
+             i + 1);
 
-  msInsertHashTable( &(lp->metadata), "wcs_bands_values", bandlist );
-  free( bandlist );
+  msInsertHashTable(&(lp->metadata), "wcs_bands_values", bandlist);
+  free(bandlist);
 }
 
 /************************************************************************/
 /*                         msWCSParseRequest()                          */
 /************************************************************************/
 
-static int msWCSParseRequest(cgiRequestObj *request, wcsParamsObj *params, mapObj *map)
-{
+static int msWCSParseRequest(cgiRequestObj *request, wcsParamsObj *params,
+                             mapObj *map) {
   int i, n;
   char **tokens;
 
-  if(!request || !params) /* nothing to do */
+  if (!request || !params) /* nothing to do */
     return MS_SUCCESS;
 
   /* -------------------------------------------------------------------- */
   /*      Check if this appears to be an XML POST WCS request.            */
   /* -------------------------------------------------------------------- */
 
-  msDebug("msWCSParseRequest(): request is %s.\n", (request->type == MS_POST_REQUEST)?"POST":"KVP");
+  msDebug("msWCSParseRequest(): request is %s.\n",
+          (request->type == MS_POST_REQUEST) ? "POST" : "KVP");
 
-  if( request->type == MS_POST_REQUEST
-      && request->postrequest ) {
+  if (request->type == MS_POST_REQUEST && request->postrequest) {
 #if defined(USE_LIBXML2)
     xmlDocPtr doc = NULL;
     xmlNodePtr root = NULL, child = NULL;
     char *tmp = NULL;
 
     /* parse to DOM-Structure and get root element */
-    if((doc = xmlParseMemory(request->postrequest, strlen(request->postrequest)))
-        == NULL) {
-      xmlErrorPtr error = xmlGetLastError();
-      msSetError(MS_WCSERR, "XML parsing error: %s",
-                 "msWCSParseRequest()", error->message);
+    if ((doc = xmlParseMemory(request->postrequest,
+                              strlen(request->postrequest))) == NULL) {
+      const xmlError *error = xmlGetLastError();
+      msSetError(MS_WCSERR, "XML parsing error: %s", "msWCSParseRequest()",
+                 error->message);
       return MS_FAILURE;
     }
     root = xmlDocGetRootElement(doc);
 
     /* Get service, version and request from root */
-    params->request = msStrdup((char *) root->name);
-    if ((tmp = (char *) xmlGetProp(root, BAD_CAST "service")) != NULL)
+    params->request = msStrdup((char *)root->name);
+    if ((tmp = (char *)xmlGetProp(root, BAD_CAST "service")) != NULL)
       params->service = tmp;
-    if ((tmp = (char *) xmlGetProp(root, BAD_CAST "version")) != NULL)
+    if ((tmp = (char *)xmlGetProp(root, BAD_CAST "version")) != NULL)
       params->version = tmp;
 
     /* search first level children, either CoverageID,  */
     for (child = root->children; child != NULL; child = child->next) {
       if (EQUAL((char *)child->name, "AcceptVersions")) {
         /* will be overridden to 1.1.1 anyway */
-      } else if (EQUAL((char *) child->name, "UpdateSequence")) {
+      } else if (EQUAL((char *)child->name, "UpdateSequence")) {
         params->updatesequence = (char *)xmlNodeGetContent(child);
-      } else if (EQUAL((char *) child->name, "Sections")) {
+      } else if (EQUAL((char *)child->name, "Sections")) {
         xmlNodePtr sectionNode = NULL;
         /* concatenate all sections by ',' */
-        for(sectionNode = child->children; sectionNode != NULL; sectionNode = sectionNode->next) {
+        for (sectionNode = child->children; sectionNode != NULL;
+             sectionNode = sectionNode->next) {
           char *content;
-          if(!EQUAL((char *)sectionNode->name, "Section"))
+          if (!EQUAL((char *)sectionNode->name, "Section"))
             continue;
           content = (char *)xmlNodeGetContent(sectionNode);
-          if(!params->section) {
+          if (!params->section) {
             params->section = content;
           } else {
             params->section = msStringConcatenate(params->section, ",");
@@ -398,44 +420,49 @@ static int msWCSParseRequest(cgiRequestO
             xmlFree(content);
           }
         }
-      } else if(EQUAL((char *) child->name, "AcceptFormats")) {
+      } else if (EQUAL((char *)child->name, "AcceptFormats")) {
         /* TODO: implement */
-      } else if(EQUAL((char *) child->name, "Identifier")) {
+      } else if (EQUAL((char *)child->name, "Identifier")) {
         char *content = (char *)xmlNodeGetContent(child);
         params->coverages = CSLAddString(params->coverages, content);
         xmlFree(content);
-      } else if(EQUAL((char *) child->name, "DomainSubset")) {
+      } else if (EQUAL((char *)child->name, "DomainSubset")) {
         xmlNodePtr tmpNode = NULL;
-        for(tmpNode = child->children; tmpNode != NULL; tmpNode = tmpNode->next) {
-          if(EQUAL((char *) tmpNode->name, "BoundingBox")) {
+        for (tmpNode = child->children; tmpNode != NULL;
+             tmpNode = tmpNode->next) {
+          if (EQUAL((char *)tmpNode->name, "BoundingBox")) {
             xmlNodePtr cornerNode = NULL;
             params->crs = (char *)xmlGetProp(tmpNode, BAD_CAST "crs");
-            if( strncasecmp(params->crs,"urn:ogc:def:crs:",16) == 0
-                && strncasecmp(params->crs+strlen(params->crs)-8,"imageCRS",8)==0)
-              strcpy( params->crs, "imageCRS" );
-            for(cornerNode = tmpNode->children; cornerNode != NULL; cornerNode = cornerNode->next) {
-              if(EQUAL((char *) cornerNode->name, "LowerCorner")) {
+            if (strncasecmp(params->crs, "urn:ogc:def:crs:", 16) == 0 &&
+                strncasecmp(params->crs + strlen(params->crs) - 8, "imageCRS",
+                            8) == 0)
+              strcpy(params->crs, "imageCRS");
+            for (cornerNode = tmpNode->children; cornerNode != NULL;
+                 cornerNode = cornerNode->next) {
+              if (EQUAL((char *)cornerNode->name, "LowerCorner")) {
                 char *value = (char *)xmlNodeGetContent(cornerNode);
                 tokens = msStringSplit(value, ' ', &n);
-                if(tokens==NULL || n < 2) {
-                  msSetError(MS_WCSERR, "Wrong number of arguments for LowerCorner",
+                if (tokens == NULL || n < 2) {
+                  msSetError(MS_WCSERR,
+                             "Wrong number of arguments for LowerCorner",
                              "msWCSParseRequest()");
-                  return msWCSException(map, "InvalidParameterValue", "LowerCorner",
-                                        params->version );
+                  return msWCSException(map, "InvalidParameterValue",
+                                        "LowerCorner", params->version);
                 }
                 params->bbox.minx = atof(tokens[0]);
                 params->bbox.miny = atof(tokens[1]);
                 msFreeCharArray(tokens, n);
                 xmlFree(value);
               }
-              if(EQUAL((char *) cornerNode->name, "UpperCorner")) {
+              if (EQUAL((char *)cornerNode->name, "UpperCorner")) {
                 char *value = (char *)xmlNodeGetContent(cornerNode);
                 tokens = msStringSplit(value, ' ', &n);
-                if(tokens==NULL || n < 2) {
-                  msSetError(MS_WCSERR, "Wrong number of arguments for UpperCorner",
+                if (tokens == NULL || n < 2) {
+                  msSetError(MS_WCSERR,
+                             "Wrong number of arguments for UpperCorner",
                              "msWCSParseRequest()");
-                  return msWCSException(map, "InvalidParameterValue", "UpperCorner",
-                                        params->version );
+                  return msWCSException(map, "InvalidParameterValue",
+                                        "UpperCorner", params->version);
                 }
                 params->bbox.maxx = atof(tokens[0]);
                 params->bbox.maxy = atof(tokens[1]);
@@ -445,38 +472,42 @@ static int msWCSParseRequest(cgiRequestO
             }
           }
         }
-      } else if(EQUAL((char *) child->name, "RangeSubset")) {
+      } else if (EQUAL((char *)child->name, "RangeSubset")) {
         /* TODO: not implemented in mapserver WCS 1.1? */
-      } else if(EQUAL((char *) child->name, "Output")) {
+      } else if (EQUAL((char *)child->name, "Output")) {
         xmlNodePtr tmpNode = NULL;
         params->format = (char *)xmlGetProp(child, BAD_CAST "format");
-        for(tmpNode = child->children; tmpNode != NULL; tmpNode = tmpNode->next) {
-          if(EQUAL((char *) tmpNode->name, "GridCRS")) {
+        for (tmpNode = child->children; tmpNode != NULL;
+             tmpNode = tmpNode->next) {
+          if (EQUAL((char *)tmpNode->name, "GridCRS")) {
             xmlNodePtr crsNode = NULL;
-            for(crsNode = tmpNode->children; crsNode != NULL; crsNode = crsNode->next) {
-              if(EQUAL((char *) crsNode->name, "GridBaseCRS")) {
-                params->response_crs = (char *) xmlNodeGetContent(crsNode);
-              } else if (EQUAL((char *) crsNode->name, "GridOrigin")) {
+            for (crsNode = tmpNode->children; crsNode != NULL;
+                 crsNode = crsNode->next) {
+              if (EQUAL((char *)crsNode->name, "GridBaseCRS")) {
+                params->response_crs = (char *)xmlNodeGetContent(crsNode);
+              } else if (EQUAL((char *)crsNode->name, "GridOrigin")) {
                 char *value = (char *)xmlNodeGetContent(crsNode);
                 tokens = msStringSplit(value, ' ', &n);
-                if(tokens==NULL || n < 2) {
-                  msSetError(MS_WCSERR, "Wrong number of arguments for GridOrigin",
+                if (tokens == NULL || n < 2) {
+                  msSetError(MS_WCSERR,
+                             "Wrong number of arguments for GridOrigin",
                              "msWCSParseRequest()");
-                  return msWCSException(map, "InvalidParameterValue", "GridOffsets",
-                                        params->version );
+                  return msWCSException(map, "InvalidParameterValue",
+                                        "GridOffsets", params->version);
                 }
                 params->originx = atof(tokens[0]);
                 params->originy = atof(tokens[1]);
                 msFreeCharArray(tokens, n);
                 xmlFree(value);
-              } else if (EQUAL((char *) crsNode->name, "GridOffsets")) {
+              } else if (EQUAL((char *)crsNode->name, "GridOffsets")) {
                 char *value = (char *)xmlNodeGetContent(crsNode);
                 tokens = msStringSplit(value, ' ', &n);
-                if(tokens==NULL || n < 2) {
-                  msSetError(MS_WCSERR, "Wrong number of arguments for GridOffsets",
+                if (tokens == NULL || n < 2) {
+                  msSetError(MS_WCSERR,
+                             "Wrong number of arguments for GridOffsets",
                              "msWCSParseRequest()");
-                  return msWCSException(map, "InvalidParameterValue", "GridOffsets",
-                                        params->version );
+                  return msWCSException(map, "InvalidParameterValue",
+                                        "GridOffsets", params->version);
                 }
                 /* take absolute values to convert to positive RESX/RESY style
                 WCS 1.0 behavior.  *but* this does break some possibilities! */
@@ -493,9 +524,11 @@ static int msWCSParseRequest(cgiRequestO
     xmlFreeDoc(doc);
     xmlCleanupParser();
     return MS_SUCCESS;
-#else /* defined(USE_LIBXML2) */
-    msSetError(MS_WCSERR, "To enable POST requests, MapServer has to "
-               "be compiled with libxml2.", "msWCSParseRequest()");
+#else  /* defined(USE_LIBXML2) */
+    msSetError(MS_WCSERR,
+               "To enable POST requests, MapServer has to "
+               "be compiled with libxml2.",
+               "msWCSParseRequest()");
     return MS_FAILURE;
 #endif /* defined(USE_LIBXML2) */
   }
@@ -503,31 +536,34 @@ static int msWCSParseRequest(cgiRequestO
   /* -------------------------------------------------------------------- */
   /*      Extract WCS KVP Parameters.                                     */
   /* -------------------------------------------------------------------- */
-  if(request->NumParams > 0) {
-    for(i=0; i<request->NumParams; i++) {
+  if (request->NumParams > 0) {
+    for (i = 0; i < request->NumParams; i++) {
 
-      if(strcasecmp(request->ParamNames[i], "VERSION") == 0)
+      if (strcasecmp(request->ParamNames[i], "VERSION") == 0)
         params->version = msStrdup(request->ParamValues[i]);
-      if(strcasecmp(request->ParamNames[i], "UPDATESEQUENCE") == 0)
+      if (strcasecmp(request->ParamNames[i], "UPDATESEQUENCE") == 0)
         params->updatesequence = msStrdup(request->ParamValues[i]);
-      else if(strcasecmp(request->ParamNames[i], "REQUEST") == 0)
+      else if (strcasecmp(request->ParamNames[i], "REQUEST") == 0)
         params->request = msStrdup(request->ParamValues[i]);
-      else if(strcasecmp(request->ParamNames[i], "INTERPOLATION") == 0)
+      else if (strcasecmp(request->ParamNames[i], "INTERPOLATION") == 0)
         params->interpolation = msStrdup(request->ParamValues[i]);
-      else if(strcasecmp(request->ParamNames[i], "SERVICE") == 0)
+      else if (strcasecmp(request->ParamNames[i], "SERVICE") == 0)
         params->service = msStrdup(request->ParamValues[i]);
-      else if(strcasecmp(request->ParamNames[i], "SECTION") == 0) /* 1.0 */
-        params->section = msStrdup(request->ParamValues[i]); /* TODO: validate value here */
-      else if(strcasecmp(request->ParamNames[i], "SECTIONS") == 0) /* 1.1 */
-        params->section = msStrdup(request->ParamValues[i]); /* TODO: validate value here */
+      else if (strcasecmp(request->ParamNames[i], "SECTION") == 0) /* 1.0 */
+        params->section =
+            msStrdup(request->ParamValues[i]); /* TODO: validate value here */
+      else if (strcasecmp(request->ParamNames[i], "SECTIONS") == 0) /* 1.1 */
+        params->section =
+            msStrdup(request->ParamValues[i]); /* TODO: validate value here */
 
       /* GetCoverage parameters. */
-      else if(strcasecmp(request->ParamNames[i], "BBOX") == 0) {
+      else if (strcasecmp(request->ParamNames[i], "BBOX") == 0) {
         tokens = msStringSplit(request->ParamValues[i], ',', &n);
-        if(tokens==NULL || n != 4) {
-          msSetError(MS_WCSERR, "Wrong number of arguments for BBOX.", "msWCSParseRequest()");
+        if (tokens == NULL || n != 4) {
+          msSetError(MS_WCSERR, "Wrong number of arguments for BBOX.",
+                     "msWCSParseRequest()");
           return msWCSException(map, "InvalidParameterValue", "bbox",
-                                params->version );
+                                params->version);
         }
         params->bbox.minx = atof(tokens[0]);
         params->bbox.miny = atof(tokens[1]);
@@ -535,38 +571,42 @@ static int msWCSParseRequest(cgiRequestO
         params->bbox.maxy = atof(tokens[3]);
 
         msFreeCharArray(tokens, n);
-      } else if(strcasecmp(request->ParamNames[i], "RESX") == 0)
+      } else if (strcasecmp(request->ParamNames[i], "RESX") == 0)
         params->resx = atof(request->ParamValues[i]);
-      else if(strcasecmp(request->ParamNames[i], "RESY") == 0)
+      else if (strcasecmp(request->ParamNames[i], "RESY") == 0)
         params->resy = atof(request->ParamValues[i]);
-      else if(strcasecmp(request->ParamNames[i], "WIDTH") == 0)
+      else if (strcasecmp(request->ParamNames[i], "WIDTH") == 0)
         params->width = atoi(request->ParamValues[i]);
-      else if(strcasecmp(request->ParamNames[i], "HEIGHT") == 0)
+      else if (strcasecmp(request->ParamNames[i], "HEIGHT") == 0)
         params->height = atoi(request->ParamValues[i]);
-      else if(strcasecmp(request->ParamNames[i], "COVERAGE") == 0)
-        params->coverages = CSLAddString(params->coverages, request->ParamValues[i]);
-      else if(strcasecmp(request->ParamNames[i], "TIME") == 0)
+      else if (strcasecmp(request->ParamNames[i], "COVERAGE") == 0)
+        params->coverages =
+            CSLAddString(params->coverages, request->ParamValues[i]);
+      else if (strcasecmp(request->ParamNames[i], "TIME") == 0)
         params->time = msStrdup(request->ParamValues[i]);
-      else if(strcasecmp(request->ParamNames[i], "FORMAT") == 0)
+      else if (strcasecmp(request->ParamNames[i], "FORMAT") == 0)
         params->format = msStrdup(request->ParamValues[i]);
-      else if(strcasecmp(request->ParamNames[i], "CRS") == 0)
+      else if (strcasecmp(request->ParamNames[i], "CRS") == 0)
         params->crs = msStrdup(request->ParamValues[i]);
-      else if(strcasecmp(request->ParamNames[i], "RESPONSE_CRS") == 0)
+      else if (strcasecmp(request->ParamNames[i], "RESPONSE_CRS") == 0)
         params->response_crs = msStrdup(request->ParamValues[i]);
 
       /* WCS 1.1 DescribeCoverage and GetCoverage ... */
-      else if(strcasecmp(request->ParamNames[i], "IDENTIFIER") == 0
-              || strcasecmp(request->ParamNames[i], "IDENTIFIERS") == 0 ) {
-        msDebug("msWCSParseRequest(): Whole String: %s\n", request->ParamValues[i]);
-        params->coverages = CSLAddString(params->coverages, request->ParamValues[i]);
+      else if (strcasecmp(request->ParamNames[i], "IDENTIFIER") == 0 ||
+               strcasecmp(request->ParamNames[i], "IDENTIFIERS") == 0) {
+        msDebug("msWCSParseRequest(): Whole String: %s\n",
+                request->ParamValues[i]);
+        params->coverages =
+            CSLAddString(params->coverages, request->ParamValues[i]);
       }
       /* WCS 1.1 style BOUNDINGBOX */
-      else if(strcasecmp(request->ParamNames[i], "BOUNDINGBOX") == 0) {
+      else if (strcasecmp(request->ParamNames[i], "BOUNDINGBOX") == 0) {
         tokens = msStringSplit(request->ParamValues[i], ',', &n);
-        if(tokens==NULL || n < 5) {
-          msSetError(MS_WCSERR, "Wrong number of arguments for BOUNDINGBOX.", "msWCSParseRequest()");
+        if (tokens == NULL || n < 5) {
+          msSetError(MS_WCSERR, "Wrong number of arguments for BOUNDINGBOX.",
+                     "msWCSParseRequest()");
           return msWCSException(map, "InvalidParameterValue", "boundingbox",
-                                params->version );
+                                params->version);
         }
 
         /* NOTE: WCS 1.1 boundingbox is center of pixel oriented, not edge
@@ -580,29 +620,30 @@ static int msWCSParseRequest(cgiRequestO
         params->crs = msStrdup(tokens[4]);
         msFreeCharArray(tokens, n);
         /* normalize imageCRS urns to simply "imageCRS" */
-        if( strncasecmp(params->crs,"urn:ogc:def:crs:",16) == 0
-            && strncasecmp(params->crs+strlen(params->crs)-8,"imageCRS",8)==0)
-          strcpy( params->crs, "imageCRS" );
-      } else if(strcasecmp(request->ParamNames[i], "GridOffsets") == 0) {
+        if (strncasecmp(params->crs, "urn:ogc:def:crs:", 16) == 0 &&
+            strncasecmp(params->crs + strlen(params->crs) - 8, "imageCRS", 8) ==
+                0)
+          strcpy(params->crs, "imageCRS");
+      } else if (strcasecmp(request->ParamNames[i], "GridOffsets") == 0) {
         tokens = msStringSplit(request->ParamValues[i], ',', &n);
-        if(tokens==NULL || n < 2) {
+        if (tokens == NULL || n < 2) {
           msSetError(MS_WCSERR, "Wrong number of arguments for GridOffsets",
                      "msWCSParseRequest()");
           return msWCSException(map, "InvalidParameterValue", "GridOffsets",
-                                params->version );
+                                params->version);
         }
         /* take absolute values to convert to positive RESX/RESY style
            WCS 1.0 behavior.  *but* this does break some possibilities! */
         params->resx = fabs(atof(tokens[0]));
         params->resy = fabs(atof(tokens[1]));
         msFreeCharArray(tokens, n);
-      } else if(strcasecmp(request->ParamNames[i], "GridOrigin") == 0) {
+      } else if (strcasecmp(request->ParamNames[i], "GridOrigin") == 0) {
         tokens = msStringSplit(request->ParamValues[i], ',', &n);
-        if(tokens==NULL || n < 2) {
+        if (tokens == NULL || n < 2) {
           msSetError(MS_WCSERR, "Wrong number of arguments for GridOrigin",
                      "msWCSParseRequest()");
           return msWCSException(map, "InvalidParameterValue", "GridOffsets",
-                                params->version );
+                                params->version);
         }
         params->originx = atof(tokens[0]);
         params->originy = atof(tokens[1]);
@@ -620,94 +661,174 @@ static int msWCSParseRequest(cgiRequestO
 /*           msWCSGetCapabilities_Service_ResponsibleParty()            */
 /************************************************************************/
 
-static void msWCSGetCapabilities_Service_ResponsibleParty(mapObj *map)
-{
-  int bEnableTelephone=MS_FALSE, bEnableAddress=MS_FALSE, bEnableOnlineResource=MS_FALSE;
+static void msWCSGetCapabilities_Service_ResponsibleParty(mapObj *map) {
+  int bEnableTelephone = MS_FALSE, bEnableAddress = MS_FALSE,
+      bEnableOnlineResource = MS_FALSE;
 
   /* the WCS-specific way */
-  if(msOWSLookupMetadata(&(map->web.metadata), "CO", "responsibleparty_individualname") ||
-      msOWSLookupMetadata(&(map->web.metadata), "CO", "responsibleparty_organizationname")) {
+  if (msOWSLookupMetadata(&(map->web.metadata), "CO",
+                          "responsibleparty_individualname") ||
+      msOWSLookupMetadata(&(map->web.metadata), "CO",
+                          "responsibleparty_organizationname")) {
 
     msIO_printf("<responsibleParty>\n");
-    msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "responsibleparty_individualname", OWS_NOERR, "    <individualName>%s</individualName>\n", NULL);
-    msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "responsibleparty_organizationname", OWS_NOERR, "    <organisationName>%s</organisationName>\n", NULL);
-    msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "responsibleparty_positionname", OWS_NOERR, "    <positionName>%s</positionName>\n", NULL);
-
-    if(msOWSLookupMetadata(&(map->web.metadata), "CO", "responsibleparty_phone_voice") ||
-        msOWSLookupMetadata(&(map->web.metadata), "CO", "responsibleparty_phone_facsimile")) bEnableTelephone = MS_TRUE;
-
-    if(msOWSLookupMetadata(&(map->web.metadata), "CO", "responsibleparty_address_deliverypoint") ||
-        msOWSLookupMetadata(&(map->web.metadata), "CO", "responsibleparty_address_city") ||
-        msOWSLookupMetadata(&(map->web.metadata), "CO", "responsibleparty_address_administrativearea") ||
-        msOWSLookupMetadata(&(map->web.metadata), "CO", "responsibleparty_address_postalcode") ||
-        msOWSLookupMetadata(&(map->web.metadata), "CO", "responsibleparty_address_country") ||
-        msOWSLookupMetadata(&(map->web.metadata), "CO", "responsibleparty_address_electronicmailaddress")) bEnableAddress = MS_TRUE;
+    msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO",
+                             "responsibleparty_individualname", OWS_NOERR,
+                             "    <individualName>%s</individualName>\n", NULL);
+    msOWSPrintEncodeMetadata(
+        stdout, &(map->web.metadata), "CO", "responsibleparty_organizationname",
+        OWS_NOERR, "    <organisationName>%s</organisationName>\n", NULL);
+    msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO",
+                             "responsibleparty_positionname", OWS_NOERR,
+                             "    <positionName>%s</positionName>\n", NULL);
+
+    if (msOWSLookupMetadata(&(map->web.metadata), "CO",
+                            "responsibleparty_phone_voice") ||
+        msOWSLookupMetadata(&(map->web.metadata), "CO",
+                            "responsibleparty_phone_facsimile"))
+      bEnableTelephone = MS_TRUE;
+
+    if (msOWSLookupMetadata(&(map->web.metadata), "CO",
+                            "responsibleparty_address_deliverypoint") ||
+        msOWSLookupMetadata(&(map->web.metadata), "CO",
+                            "responsibleparty_address_city") ||
+        msOWSLookupMetadata(&(map->web.metadata), "CO",
+                            "responsibleparty_address_administrativearea") ||
+        msOWSLookupMetadata(&(map->web.metadata), "CO",
+                            "responsibleparty_address_postalcode") ||
+        msOWSLookupMetadata(&(map->web.metadata), "CO",
+                            "responsibleparty_address_country") ||
+        msOWSLookupMetadata(&(map->web.metadata), "CO",
+                            "responsibleparty_address_electronicmailaddress"))
+      bEnableAddress = MS_TRUE;
+
+    if (msOWSLookupMetadata(&(map->web.metadata), "CO",
+                            "responsibleparty_onlineresource"))
+      bEnableOnlineResource = MS_TRUE;
 
-    if(msOWSLookupMetadata(&(map->web.metadata), "CO", "responsibleparty_onlineresource")) bEnableOnlineResource = MS_TRUE;
-
-    if(bEnableTelephone || bEnableAddress || bEnableOnlineResource) {
+    if (bEnableTelephone || bEnableAddress || bEnableOnlineResource) {
       msIO_printf("  <contactInfo>\n");
-      if(bEnableTelephone) {
+      if (bEnableTelephone) {
         msIO_printf("    <phone>\n");
-        msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "responsibleparty_phone_voice", OWS_NOERR, "    <voice>%s</voice>\n", NULL);
-        msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "responsibleparty_phone_facsimile", OWS_NOERR, "    <facsimile>%s</facsimile>\n", NULL);
+        msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO",
+                                 "responsibleparty_phone_voice", OWS_NOERR,
+                                 "    <voice>%s</voice>\n", NULL);
+        msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO",
+                                 "responsibleparty_phone_facsimile", OWS_NOERR,
+                                 "    <facsimile>%s</facsimile>\n", NULL);
         msIO_printf("    </phone>\n");
       }
-      if(bEnableAddress) {
+      if (bEnableAddress) {
         msIO_printf("    <address>\n");
-        msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "responsibleparty_address_deliverypoint", OWS_NOERR, "    <deliveryPoint>%s</deliveryPoint>\n", NULL);
-        msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "responsibleparty_address_city", OWS_NOERR, "    <city>%s</city>\n", NULL);
-        msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "responsibleparty_address_administrativearea", OWS_NOERR, "    <administrativeArea>%s</administrativeArea>\n", NULL);
-        msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "responsibleparty_address_postalcode", OWS_NOERR, "    <postalCode>%s</postalCode>\n", NULL);
-        msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "responsibleparty_address_country", OWS_NOERR, "    <country>%s</country>\n", NULL);
-        msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "responsibleparty_address_electronicmailaddress", OWS_NOERR, "    <electronicMailAddress>%s</electronicMailAddress>\n", NULL);
+        msOWSPrintEncodeMetadata(
+            stdout, &(map->web.metadata), "CO",
+            "responsibleparty_address_deliverypoint", OWS_NOERR,
+            "    <deliveryPoint>%s</deliveryPoint>\n", NULL);
+        msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO",
+                                 "responsibleparty_address_city", OWS_NOERR,
+                                 "    <city>%s</city>\n", NULL);
+        msOWSPrintEncodeMetadata(
+            stdout, &(map->web.metadata), "CO",
+            "responsibleparty_address_administrativearea", OWS_NOERR,
+            "    <administrativeArea>%s</administrativeArea>\n", NULL);
+        msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO",
+                                 "responsibleparty_address_postalcode",
+                                 OWS_NOERR, "    <postalCode>%s</postalCode>\n",
+                                 NULL);
+        msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO",
+                                 "responsibleparty_address_country", OWS_NOERR,
+                                 "    <country>%s</country>\n", NULL);
+        msOWSPrintEncodeMetadata(
+            stdout, &(map->web.metadata), "CO",
+            "responsibleparty_address_electronicmailaddress", OWS_NOERR,
+            "    <electronicMailAddress>%s</electronicMailAddress>\n", NULL);
         msIO_printf("    </address>\n");
       }
-      msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "responsibleparty_onlineresource", OWS_NOERR, "    <onlineResource xlink:type=\"simple\" xlink:href=\"%s\"/>\n", NULL);
+      msOWSPrintEncodeMetadata(
+          stdout, &(map->web.metadata), "CO", "responsibleparty_onlineresource",
+          OWS_NOERR,
+          "    <onlineResource xlink:type=\"simple\" xlink:href=\"%s\"/>\n",
+          NULL);
       msIO_printf("  </contactInfo>\n");
     }
 
     msIO_printf("</responsibleParty>\n");
 
-  } else if(msOWSLookupMetadata(&(map->web.metadata), "CO", "contactperson") ||
-            msOWSLookupMetadata(&(map->web.metadata), "CO", "contactorganization")) { /* leverage WMS contact information */
+  } else if (msOWSLookupMetadata(&(map->web.metadata), "CO", "contactperson") ||
+             msOWSLookupMetadata(
+                 &(map->web.metadata), "CO",
+                 "contactorganization")) { /* leverage WMS contact information
+                                            */
 
     msIO_printf("<responsibleParty>\n");
-    msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "contactperson", OWS_NOERR, "    <individualName>%s</individualName>\n", NULL);
-    msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "contactorganization", OWS_NOERR, "    <organisationName>%s</organisationName>\n", NULL);
-    msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "contactposition", OWS_NOERR, "    <positionName>%s</positionName>\n", NULL);
-
-    if(msOWSLookupMetadata(&(map->web.metadata), "CO", "contactvoicetelephone") ||
-        msOWSLookupMetadata(&(map->web.metadata), "CO", "contactfacsimiletelephone")) bEnableTelephone = MS_TRUE;
+    msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO",
+                             "contactperson", OWS_NOERR,
+                             "    <individualName>%s</individualName>\n", NULL);
+    msOWSPrintEncodeMetadata(
+        stdout, &(map->web.metadata), "CO", "contactorganization", OWS_NOERR,
+        "    <organisationName>%s</organisationName>\n", NULL);
+    msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO",
+                             "contactposition", OWS_NOERR,
+                             "    <positionName>%s</positionName>\n", NULL);
+
+    if (msOWSLookupMetadata(&(map->web.metadata), "CO",
+                            "contactvoicetelephone") ||
+        msOWSLookupMetadata(&(map->web.metadata), "CO",
+                            "contactfacsimiletelephone"))
+      bEnableTelephone = MS_TRUE;
 
-    if(msOWSLookupMetadata(&(map->web.metadata), "CO", "address") ||
+    if (msOWSLookupMetadata(&(map->web.metadata), "CO", "address") ||
         msOWSLookupMetadata(&(map->web.metadata), "CO", "city") ||
         msOWSLookupMetadata(&(map->web.metadata), "CO", "stateorprovince") ||
         msOWSLookupMetadata(&(map->web.metadata), "CO", "postcode") ||
         msOWSLookupMetadata(&(map->web.metadata), "CO", "country") ||
-        msOWSLookupMetadata(&(map->web.metadata), "CO", "contactelectronicmailaddress")) bEnableAddress = MS_TRUE;
+        msOWSLookupMetadata(&(map->web.metadata), "CO",
+                            "contactelectronicmailaddress"))
+      bEnableAddress = MS_TRUE;
+
+    if (msOWSLookupMetadata(&(map->web.metadata), "CO",
+                            "service_onlineresource"))
+      bEnableOnlineResource = MS_TRUE;
 
-    if(msOWSLookupMetadata(&(map->web.metadata), "CO", "service_onlineresource")) bEnableOnlineResource = MS_TRUE;
-
-    if(bEnableTelephone || bEnableAddress || bEnableOnlineResource) {
+    if (bEnableTelephone || bEnableAddress || bEnableOnlineResource) {
       msIO_printf("  <contactInfo>\n");
-      if(bEnableTelephone) {
+      if (bEnableTelephone) {
         msIO_printf("    <phone>\n");
-        msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "contactvoicetelephone", OWS_NOERR, "    <voice>%s</voice>\n", NULL);
-        msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "contactfacsimiletelephone", OWS_NOERR, "    <facsimile>%s</facsimile>\n", NULL);
+        msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO",
+                                 "contactvoicetelephone", OWS_NOERR,
+                                 "    <voice>%s</voice>\n", NULL);
+        msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO",
+                                 "contactfacsimiletelephone", OWS_NOERR,
+                                 "    <facsimile>%s</facsimile>\n", NULL);
         msIO_printf("    </phone>\n");
       }
-      if(bEnableAddress) {
+      if (bEnableAddress) {
         msIO_printf("    <address>\n");
-        msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "address", OWS_NOERR, "    <deliveryPoint>%s</deliveryPoint>\n", NULL);
-        msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "city", OWS_NOERR, "    <city>%s</city>\n", NULL);
-        msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "stateorprovince", OWS_NOERR, "    <administrativeArea>%s</administrativeArea>\n", NULL);
-        msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "postcode", OWS_NOERR, "    <postalCode>%s</postalCode>\n", NULL);
-        msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "country", OWS_NOERR, "    <country>%s</country>\n", NULL);
-        msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "contactelectronicmailaddress", OWS_NOERR, "    <electronicMailAddress>%s</electronicMailAddress>\n", NULL);
+        msOWSPrintEncodeMetadata(
+            stdout, &(map->web.metadata), "CO", "address", OWS_NOERR,
+            "    <deliveryPoint>%s</deliveryPoint>\n", NULL);
+        msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "city",
+                                 OWS_NOERR, "    <city>%s</city>\n", NULL);
+        msOWSPrintEncodeMetadata(
+            stdout, &(map->web.metadata), "CO", "stateorprovince", OWS_NOERR,
+            "    <administrativeArea>%s</administrativeArea>\n", NULL);
+        msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "postcode",
+                                 OWS_NOERR, "    <postalCode>%s</postalCode>\n",
+                                 NULL);
+        msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "country",
+                                 OWS_NOERR, "    <country>%s</country>\n",
+                                 NULL);
+        msOWSPrintEncodeMetadata(
+            stdout, &(map->web.metadata), "CO", "contactelectronicmailaddress",
+            OWS_NOERR,
+            "    <electronicMailAddress>%s</electronicMailAddress>\n", NULL);
         msIO_printf("    </address>\n");
       }
-      msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "service_onlineresource", OWS_NOERR, "    <onlineResource xlink:type=\"simple\" xlink:href=\"%s\"/>\n", NULL);
+      msOWSPrintEncodeMetadata(
+          stdout, &(map->web.metadata), "CO", "service_onlineresource",
+          OWS_NOERR,
+          "    <onlineResource xlink:type=\"simple\" xlink:href=\"%s\"/>\n",
+          NULL);
       msIO_printf("  </contactInfo>\n");
     }
     msIO_printf("</responsibleParty>\n");
@@ -720,10 +841,11 @@ static void msWCSGetCapabilities_Service
 /*                    msWCSGetCapabilities_Service()                    */
 /************************************************************************/
 
-static int msWCSGetCapabilities_Service(mapObj *map, wcsParamsObj *params)
-{
-  /* start the Service section, only need the full start tag if this is the only section requested */
-  if(!params->section || (params->section && strcasecmp(params->section, "/") == 0))
+static int msWCSGetCapabilities_Service(mapObj *map, wcsParamsObj *params) {
+  /* start the Service section, only need the full start tag if this is the only
+   * section requested */
+  if (!params->section ||
+      (params->section && strcasecmp(params->section, "/") == 0))
     msIO_printf("<Service>\n");
   else
     msIO_printf("<Service\n"
@@ -733,27 +855,39 @@ static int msWCSGetCapabilities_Service(
                 "   xmlns:xlink=\"http://www.w3.org/1999/xlink\" \n"
                 "   xmlns:gml=\"http://www.opengis.net/gml\" \n"
                 "   xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n"
-                "   xsi:schemaLocation=\"http://www.opengis.net/wcs %s/wcs/%s/wcsCapabilities.xsd\">\n", params->version, params->updatesequence, msOWSGetSchemasLocation(map), params->version);
+                "   xsi:schemaLocation=\"http://www.opengis.net/wcs "
+                "%s/wcs/%s/wcsCapabilities.xsd\">\n",
+                params->version, params->updatesequence,
+                msOWSGetSchemasLocation(map), params->version);
 
   /* optional metadataLink */
   msOWSPrintURLType(stdout, &(map->web.metadata), "CO", "metadatalink",
                     OWS_NOERR,
-                    "  <metadataLink%s%s%s%s xlink:type=\"simple\"%s/>",
-                    NULL, " metadataType=\"%s\"", NULL, NULL, NULL,
+                    "  <metadataLink%s%s%s%s xlink:type=\"simple\"%s/>", NULL,
+                    " metadataType=\"%s\"", NULL, NULL, NULL,
                     " xlink:href=\"%s\"", MS_FALSE, MS_FALSE, MS_FALSE,
                     MS_FALSE, MS_TRUE, "other", NULL, NULL, NULL, NULL, NULL);
 
-  msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "description", OWS_NOERR, "  <description>%s</description>\n", NULL);
-  msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "name", OWS_NOERR, "  <name>%s</name>\n", "MapServer WCS");
-  msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "label", OWS_WARN, "  <label>%s</label>\n", NULL);
+  msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "description",
+                           OWS_NOERR, "  <description>%s</description>\n",
+                           NULL);
+  msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "name",
+                           OWS_NOERR, "  <name>%s</name>\n", "MapServer WCS");
+  msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "label",
+                           OWS_WARN, "  <label>%s</label>\n", NULL);
 
   /* we are not supporting the optional keyword type, at least not yet */
-  msOWSPrintEncodeMetadataList(stdout, &(map->web.metadata), "CO", "keywordlist", "  <keywords>\n", "  </keywords>\n", "    <keyword>%s</keyword>\n", NULL);
+  msOWSPrintEncodeMetadataList(
+      stdout, &(map->web.metadata), "CO", "keywordlist", "  <keywords>\n",
+      "  </keywords>\n", "    <keyword>%s</keyword>\n", NULL);
 
   msWCSGetCapabilities_Service_ResponsibleParty(map);
 
-  msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "fees", OWS_NOERR, "  <fees>%s</fees>\n", "NONE");
-  msOWSPrintEncodeMetadataList(stdout, &(map->web.metadata), "CO", "accessconstraints", "  <accessConstraints>\n", "  </accessConstraints>\n", "    %s\n", "NONE");
+  msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "CO", "fees",
+                           OWS_NOERR, "  <fees>%s</fees>\n", "NONE");
+  msOWSPrintEncodeMetadataList(stdout, &(map->web.metadata), "CO",
+                               "accessconstraints", "  <accessConstraints>\n",
+                               "  </accessConstraints>\n", "    %s\n", "NONE");
 
   /* done */
   msIO_printf("</Service>\n");
@@ -765,19 +899,23 @@ static int msWCSGetCapabilities_Service(
 /*                  msWCSGetCapabilities_Capability()                   */
 /************************************************************************/
 
-static int msWCSGetCapabilities_Capability(mapObj *map, wcsParamsObj *params, cgiRequestObj *req)
-{
-  char *script_url=NULL, *script_url_encoded=NULL;
+static int msWCSGetCapabilities_Capability(mapObj *map, wcsParamsObj *params,
+                                           cgiRequestObj *req) {
+  char *script_url = NULL, *script_url_encoded = NULL;
 
   /* we need this server's onlineresource for the request section */
-  if((script_url=msOWSGetOnlineResource(map, "CO", "onlineresource", req)) == NULL || (script_url_encoded = msEncodeHTMLEntities(script_url)) == NULL) {
+  if ((script_url = msOWSGetOnlineResource(map, "CO", "onlineresource", req)) ==
+          NULL ||
+      (script_url_encoded = msEncodeHTMLEntities(script_url)) == NULL) {
     free(script_url);
     free(script_url_encoded);
-    return msWCSException(map, NULL, NULL, params->version );
+    return msWCSException(map, NULL, NULL, params->version);
   }
 
-  /* start the Capabilty section, only need the full start tag if this is the only section requested */
-  if(!params->section || (params->section && strcasecmp(params->section, "/") == 0))
+  /* start the Capabilty section, only need the full start tag if this is the
+   * only section requested */
+  if (!params->section ||
+      (params->section && strcasecmp(params->section, "/") == 0))
     msIO_printf("<Capability>\n");
   else
     msIO_printf("<Capability\n"
@@ -787,7 +925,10 @@ static int msWCSGetCapabilities_Capabili
                 "   xmlns:xlink=\"http://www.w3.org/1999/xlink\" \n"
                 "   xmlns:gml=\"http://www.opengis.net/gml\" \n"
                 "   xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n"
-                "   xsi:schemaLocation=\"http://www.opengis.net/wcs %s/wcs/%s/wcsCapabilities.xsd\">\n", params->version, params->updatesequence, msOWSGetSchemasLocation(map), params->version);
+                "   xsi:schemaLocation=\"http://www.opengis.net/wcs "
+                "%s/wcs/%s/wcsCapabilities.xsd\">\n",
+                params->version, params->updatesequence,
+                msOWSGetSchemasLocation(map), params->version);
 
   /* describe the types of requests the server can handle */
   msIO_printf("  <Request>\n");
@@ -821,79 +962,93 @@ static int msWCSGetCapabilities_Capabili
 /*                    msWCSPrintMetadataLink()                          */
 /************************************************************************/
 
-static void  msWCSPrintMetadataLink(layerObj *layer, const char *script_url_encoded)
-{
-  const char* list = msOWSLookupMetadata(&(layer->metadata), "CO", "metadatalink_list");
-  if( list ) {
+static void msWCSPrintMetadataLink(layerObj *layer,
+                                   const char *script_url_encoded) {
+  const char *list =
+      msOWSLookupMetadata(&(layer->metadata), "CO", "metadatalink_list");
+  if (list) {
     int ntokens = 0;
-    char** tokens = msStringSplit(list, ' ', &ntokens);
-    for( int i = 0; i < ntokens; i++ )
-    {
+    char **tokens = msStringSplit(list, ' ', &ntokens);
+    for (int i = 0; i < ntokens; i++) {
       std::string key("metadatalink_");
       key += tokens[i];
-      msOWSPrintURLType(stdout, &(layer->metadata), "CO", key.c_str(),
-                        OWS_NOERR,
-                        "  <metadataLink%s%s%s%s xlink:type=\"simple\"%s/>",
-                        NULL, " metadataType=\"%s\"", NULL, NULL, NULL,
-                        " xlink:href=\"%s\"", MS_FALSE, MS_FALSE, MS_FALSE,
-                        MS_FALSE, MS_TRUE, "other", NULL, NULL, NULL, NULL, NULL);
+      msOWSPrintURLType(
+          stdout, &(layer->metadata), "CO", key.c_str(), OWS_NOERR,
+          "  <metadataLink%s%s%s%s xlink:type=\"simple\"%s/>", NULL,
+          " metadataType=\"%s\"", NULL, NULL, NULL, " xlink:href=\"%s\"",
+          MS_FALSE, MS_FALSE, MS_FALSE, MS_FALSE, MS_TRUE, "other", NULL, NULL,
+          NULL, NULL, NULL);
     }
     msFreeCharArray(tokens, ntokens);
     return;
   }
 
   /* optional metadataLink */
-  if (! msOWSLookupMetadata(&(layer->metadata), "CO", "metadatalink_href"))
+  if (!msOWSLookupMetadata(&(layer->metadata), "CO", "metadatalink_href"))
     msMetadataSetGetMetadataURL(layer, script_url_encoded);
 
-  msOWSPrintURLType(stdout, &(layer->metadata), "CO", "metadatalink",
-                    OWS_NOERR,
-                    "  <metadataLink%s%s%s%s xlink:type=\"simple\"%s/>",
-                    NULL, " metadataType=\"%s\"", NULL, NULL, NULL,
+  msOWSPrintURLType(stdout, &(layer->metadata), "CO", "metadatalink", OWS_NOERR,
+                    "  <metadataLink%s%s%s%s xlink:type=\"simple\"%s/>", NULL,
+                    " metadataType=\"%s\"", NULL, NULL, NULL,
                     " xlink:href=\"%s\"", MS_FALSE, MS_FALSE, MS_FALSE,
                     MS_FALSE, MS_TRUE, "other", NULL, NULL, NULL, NULL, NULL);
-
 }
 
 /************************************************************************/
 /*             msWCSGetCapabilities_CoverageOfferingBrief()             */
 /************************************************************************/
 
-static int msWCSGetCapabilities_CoverageOfferingBrief(layerObj *layer, const char *script_url_encoded)
-{
+static int
+msWCSGetCapabilities_CoverageOfferingBrief(layerObj *layer,
+                                           const char *script_url_encoded) {
   coverageMetadataObj cm;
   int status;
 
-  if((layer->status == MS_DELETE) || !msWCSIsLayerSupported(layer)) return MS_SUCCESS; /* not an error, this layer cannot be served via WCS */
+  if ((layer->status == MS_DELETE) || !msWCSIsLayerSupported(layer))
+    return MS_SUCCESS; /* not an error, this layer cannot be served via WCS */
 
   status = msWCSGetCoverageMetadata(layer, &cm);
-  if(status != MS_SUCCESS) return MS_FAILURE;
+  if (status != MS_SUCCESS)
+    return MS_FAILURE;
 
   /* start the CoverageOfferingBrief section */
-  msIO_printf("  <CoverageOfferingBrief>\n"); /* is this tag right? (I hate schemas without ANY examples) */
+  msIO_printf(
+      "  <CoverageOfferingBrief>\n"); /* is this tag right? (I hate schemas
+                                         without ANY examples) */
 
   msWCSPrintMetadataLink(layer, script_url_encoded);
 
-  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", "description", OWS_NOERR, "    <description>%s</description>\n", NULL);
-  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", "name", OWS_NOERR, "    <name>%s</name>\n", layer->name);
+  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", "description",
+                           OWS_NOERR, "    <description>%s</description>\n",
+                           NULL);
+  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", "name", OWS_NOERR,
+                           "    <name>%s</name>\n", layer->name);
 
-  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", "label", OWS_WARN, "    <label>%s</label>\n", NULL);
+  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", "label", OWS_WARN,
+                           "    <label>%s</label>\n", NULL);
 
   /* TODO: add elevation ranges to lonLatEnvelope (optional) */
-  msIO_printf("    <lonLatEnvelope srsName=\"urn:ogc:def:crs:OGC:1.3:CRS84\">\n");
-  msIO_printf("      <gml:pos>%.15g %.15g</gml:pos>\n", cm.llextent.minx, cm.llextent.miny); /* TODO: don't know if this is right */
-  msIO_printf("      <gml:pos>%.15g %.15g</gml:pos>\n", cm.llextent.maxx, cm.llextent.maxy);
-
-  msOWSPrintEncodeMetadataList(stdout, &(layer->metadata), "CO", "timeposition", NULL, NULL, "      <gml:timePosition>%s</gml:timePosition>\n", NULL);
+  msIO_printf(
+      "    <lonLatEnvelope srsName=\"urn:ogc:def:crs:OGC:1.3:CRS84\">\n");
+  msIO_printf("      <gml:pos>%.15g %.15g</gml:pos>\n", cm.llextent.minx,
+              cm.llextent.miny); /* TODO: don't know if this is right */
+  msIO_printf("      <gml:pos>%.15g %.15g</gml:pos>\n", cm.llextent.maxx,
+              cm.llextent.maxy);
+
+  msOWSPrintEncodeMetadataList(
+      stdout, &(layer->metadata), "CO", "timeposition", NULL, NULL,
+      "      <gml:timePosition>%s</gml:timePosition>\n", NULL);
 
   msIO_printf("    </lonLatEnvelope>\n");
 
   /* we are not supporting the optional keyword type, at least not yet */
-  msOWSPrintEncodeMetadataList(stdout, &(layer->metadata), "CO", "keywordlist", "  <keywords>\n", "  </keywords>\n", "    <keyword>%s</keyword>\n", NULL);
+  msOWSPrintEncodeMetadataList(stdout, &(layer->metadata), "CO", "keywordlist",
+                               "  <keywords>\n", "  </keywords>\n",
+                               "    <keyword>%s</keyword>\n", NULL);
 
   /* done */
   msIO_printf("  </CoverageOfferingBrief>\n");
-  
+
   msWCSFreeCoverageMetadata(&cm);
 
   return MS_SUCCESS;
@@ -903,20 +1058,24 @@ static int msWCSGetCapabilities_Coverage
 /*                msWCSGetCapabilities_ContentMetadata()                */
 /************************************************************************/
 
-static int msWCSGetCapabilities_ContentMetadata(mapObj *map, wcsParamsObj *params, owsRequestObj *ows_request, cgiRequestObj *req)
-{
+static int msWCSGetCapabilities_ContentMetadata(mapObj *map,
+                                                wcsParamsObj *params,
+                                                owsRequestObj *ows_request,
+                                                cgiRequestObj *req) {
   int i;
-  char *script_url_encoded=NULL;
+  char *script_url_encoded = NULL;
 
   {
-      char* pszTmp = msOWSGetOnlineResource(map, "CO", "onlineresource", req);
-      script_url_encoded = msEncodeHTMLEntities(pszTmp);
-      msFree(pszTmp);
+    char *pszTmp = msOWSGetOnlineResource(map, "CO", "onlineresource", req);
+    script_url_encoded = msEncodeHTMLEntities(pszTmp);
+    msFree(pszTmp);
   }
 
-  /* start the ContentMetadata section, only need the full start tag if this is the only section requested */
+  /* start the ContentMetadata section, only need the full start tag if this is
+   * the only section requested */
   /* TODO: add Xlink attributes for other sources of this information  */
-  if(!params->section || (params->section && strcasecmp(params->section, "/") == 0))
+  if (!params->section ||
+      (params->section && strcasecmp(params->section, "/") == 0))
     msIO_printf("<ContentMetadata>\n");
   else
     msIO_printf("<ContentMetadata\n"
@@ -926,17 +1085,25 @@ static int msWCSGetCapabilities_ContentM
                 "   xmlns:xlink=\"http://www.w3.org/1999/xlink\" \n"
                 "   xmlns:gml=\"http://www.opengis.net/gml\" \n"
                 "   xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n"
-                "   xsi:schemaLocation=\"http://www.opengis.net/wcs %s/wcs/%s/wcsCapabilities.xsd\">\n", params->version, params->updatesequence, msOWSGetSchemasLocation(map), params->version);
+                "   xsi:schemaLocation=\"http://www.opengis.net/wcs "
+                "%s/wcs/%s/wcsCapabilities.xsd\">\n",
+                params->version, params->updatesequence,
+                msOWSGetSchemasLocation(map), params->version);
 
-  if(ows_request->numlayers == 0) {
-    msIO_printf("  <!-- WARNING: No WCS layers are enabled. Check wcs/ows_enable_request settings. -->\n");
+  if (ows_request->numlayers == 0) {
+    msIO_printf("  <!-- WARNING: No WCS layers are enabled. Check "
+                "wcs/ows_enable_request settings. -->\n");
   } else {
-    for(i=0; i<map->numlayers; i++) {
-      if (!msIntegerInArray(GET_LAYER(map, i)->index, ows_request->enabled_layers, ows_request->numlayers))
+    for (i = 0; i < map->numlayers; i++) {
+      if (!msIntegerInArray(GET_LAYER(map, i)->index,
+                            ows_request->enabled_layers,
+                            ows_request->numlayers))
         continue;
 
-      if(msWCSGetCapabilities_CoverageOfferingBrief((GET_LAYER(map, i)), script_url_encoded) != MS_SUCCESS ) {
-        msIO_printf("  <!-- WARNING: There was a problem with one of layers. See server log for details. -->\n");
+      if (msWCSGetCapabilities_CoverageOfferingBrief(
+              (GET_LAYER(map, i)), script_url_encoded) != MS_SUCCESS) {
+        msIO_printf("  <!-- WARNING: There was a problem with one of layers. "
+                    "See server log for details. -->\n");
       }
     }
   }
@@ -953,23 +1120,24 @@ static int msWCSGetCapabilities_ContentM
 /*                        msWCSGetCapabilities()                        */
 /************************************************************************/
 
-static int msWCSGetCapabilities(mapObj *map, wcsParamsObj *params, cgiRequestObj *req, owsRequestObj *ows_request)
-{
+static int msWCSGetCapabilities(mapObj *map, wcsParamsObj *params,
+                                cgiRequestObj *req,
+                                owsRequestObj *ows_request) {
   char tmpString[OWS_VERSION_MAXLEN];
   int i, tmpInt = 0;
   int wcsSupportedVersions[] = {OWS_1_1_2, OWS_1_1_1, OWS_1_1_0, OWS_1_0_0};
   int wcsNumSupportedVersions = 4;
-  const char *updatesequence=NULL;
+  const char *updatesequence = NULL;
 
   /* check version is valid */
   tmpInt = msOWSParseVersionString(params->version);
   if (tmpInt == OWS_VERSION_BADFORMAT) {
-    return msWCSException(map, "InvalidParameterValue",
-                          "version", "1.0.0 ");
+    return msWCSException(map, "InvalidParameterValue", "version", "1.0.0 ");
   }
 
   /* negotiate version */
-  tmpInt = msOWSNegotiateVersion(tmpInt, wcsSupportedVersions, wcsNumSupportedVersions);
+  tmpInt = msOWSNegotiateVersion(tmpInt, wcsSupportedVersions,
+                                 wcsNumSupportedVersions);
 
   /* set result as string and carry on */
   free(params->version);
@@ -979,27 +1147,32 @@ static int msWCSGetCapabilities(mapObj *
   /*      1.1.x is sufficiently different we have a whole case for        */
   /*      it.  The remainder of this function is for 1.0.0.               */
   /* -------------------------------------------------------------------- */
-  if( strncmp(params->version,"1.1",3) == 0 )
-    return msWCSGetCapabilities11( map, params, req, ows_request);
+  if (strncmp(params->version, "1.1", 3) == 0)
+    return msWCSGetCapabilities11(map, params, req, ows_request);
 
-  updatesequence = msOWSLookupMetadata(&(map->web.metadata), "CO", "updatesequence");
+  updatesequence =
+      msOWSLookupMetadata(&(map->web.metadata), "CO", "updatesequence");
 
   if (params->updatesequence != NULL) {
     i = msOWSNegotiateUpdateSequence(params->updatesequence, updatesequence);
     if (i == 0) { /* current */
-      msSetError(MS_WCSERR, "UPDATESEQUENCE parameter (%s) is equal to server (%s)", "msWCSGetCapabilities()", params->updatesequence, updatesequence);
-      return msWCSException(map, "CurrentUpdateSequence",
-                            "updatesequence", params->version );
+      msSetError(
+          MS_WCSERR, "UPDATESEQUENCE parameter (%s) is equal to server (%s)",
+          "msWCSGetCapabilities()", params->updatesequence, updatesequence);
+      return msWCSException(map, "CurrentUpdateSequence", "updatesequence",
+                            params->version);
     }
     if (i > 0) { /* invalid */
-      msSetError(MS_WCSERR, "UPDATESEQUENCE parameter (%s) is higher than server (%s)", "msWCSGetCapabilities()", params->updatesequence, updatesequence);
-      return msWCSException(map, "InvalidUpdateSequence",
-                            "updatesequence", params->version );
+      msSetError(
+          MS_WCSERR, "UPDATESEQUENCE parameter (%s) is higher than server (%s)",
+          "msWCSGetCapabilities()", params->updatesequence, updatesequence);
+      return msWCSException(map, "InvalidUpdateSequence", "updatesequence",
+                            params->version);
     }
   }
 
   else { /* set default updatesequence */
-    if(!updatesequence)
+    if (!updatesequence)
       updatesequence = "0";
     params->updatesequence = msStrdup(updatesequence);
   }
@@ -1010,17 +1183,16 @@ static int msWCSGetCapabilities(mapObj *
       strcasecmp(params->section, "/WCS_Capabilities/Capability") != 0 &&
       strcasecmp(params->section, "/WCS_Capabilities/ContentMetadata") != 0 &&
       strcasecmp(params->section, "/") != 0) {
-    msIO_setHeader("Content-Type","application/vnd.ogc.se_xml; charset=UTF-8");
+    msIO_setHeader("Content-Type", "application/vnd.ogc.se_xml; charset=UTF-8");
     msIO_sendHeaders();
-    msSetError( MS_WCSERR,
-                "Invalid SECTION parameter \"%s\"",
-                "msWCSGetCapabilities()", params->section);
+    msSetError(MS_WCSERR, "Invalid SECTION parameter \"%s\"",
+               "msWCSGetCapabilities()", params->section);
     return msWCSException(map, "InvalidParameterValue", "section",
-                          params->version );
+                          params->version);
   }
 
   else {
-    msIO_setHeader("Content-Type","text/xml; charset=UTF-8");
+    msIO_setHeader("Content-Type", "text/xml; charset=UTF-8");
     msIO_sendHeaders();
 
     /* print common capability elements  */
@@ -1029,35 +1201,46 @@ static int msWCSGetCapabilities(mapObj *
     if (!updatesequence)
       updatesequence = "0";
 
-    msIO_printf("<?xml version='1.0' encoding=\"UTF-8\" standalone=\"no\" ?>\n");
+    msIO_printf(
+        "<?xml version='1.0' encoding=\"UTF-8\" standalone=\"no\" ?>\n");
 
-    if(!params->section || (params->section && strcasecmp(params->section, "/")  == 0)) msIO_printf("<WCS_Capabilities\n"
-          "   version=\"%s\" \n"
-          "   updateSequence=\"%s\" \n"
-          "   xmlns=\"http://www.opengis.net/wcs\" \n"
-          "   xmlns:xlink=\"http://www.w3.org/1999/xlink\" \n"
-          "   xmlns:gml=\"http://www.opengis.net/gml\" \n"
-          "   xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n"
-          "   xsi:schemaLocation=\"http://www.opengis.net/wcs %s/wcs/%s/wcsCapabilities.xsd\">\n", params->version, updatesequence, msOWSGetSchemasLocation(map), params->version);
+    if (!params->section ||
+        (params->section && strcasecmp(params->section, "/") == 0))
+      msIO_printf("<WCS_Capabilities\n"
+                  "   version=\"%s\" \n"
+                  "   updateSequence=\"%s\" \n"
+                  "   xmlns=\"http://www.opengis.net/wcs\" \n"
+                  "   xmlns:xlink=\"http://www.w3.org/1999/xlink\" \n"
+                  "   xmlns:gml=\"http://www.opengis.net/gml\" \n"
+                  "   xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n"
+                  "   xsi:schemaLocation=\"http://www.opengis.net/wcs "
+                  "%s/wcs/%s/wcsCapabilities.xsd\">\n",
+                  params->version, updatesequence, msOWSGetSchemasLocation(map),
+                  params->version);
 
     /* print the various capability sections */
-    if(!params->section || strcasecmp(params->section, "/WCS_Capabilities/Service") == 0)
+    if (!params->section ||
+        strcasecmp(params->section, "/WCS_Capabilities/Service") == 0)
       msWCSGetCapabilities_Service(map, params);
 
-    if(!params->section || strcasecmp(params->section, "/WCS_Capabilities/Capability")  == 0)
+    if (!params->section ||
+        strcasecmp(params->section, "/WCS_Capabilities/Capability") == 0)
       msWCSGetCapabilities_Capability(map, params, req);
 
-    if(!params->section || strcasecmp(params->section, "/WCS_Capabilities/ContentMetadata")  == 0)
+    if (!params->section ||
+        strcasecmp(params->section, "/WCS_Capabilities/ContentMetadata") == 0)
       msWCSGetCapabilities_ContentMetadata(map, params, ows_request, req);
 
-    if(params->section && strcasecmp(params->section, "/")  == 0) {
+    if (params->section && strcasecmp(params->section, "/") == 0) {
       msWCSGetCapabilities_Service(map, params);
       msWCSGetCapabilities_Capability(map, params, req);
       msWCSGetCapabilities_ContentMetadata(map, params, ows_request, req);
     }
 
     /* done */
-    if(!params->section || (params->section && strcasecmp(params->section, "/")  == 0)) msIO_printf("</WCS_Capabilities>\n");
+    if (!params->section ||
+        (params->section && strcasecmp(params->section, "/") == 0))
+      msIO_printf("</WCS_Capabilities>\n");
   }
 
   return MS_SUCCESS;
@@ -1067,55 +1250,71 @@ static int msWCSGetCapabilities(mapObj *
 /*               msWCSDescribeCoverage_AxisDescription()                */
 /************************************************************************/
 
-static int msWCSDescribeCoverage_AxisDescription(layerObj *layer, char *name)
-{
+static int msWCSDescribeCoverage_AxisDescription(layerObj *layer, char *name) {
   const char *value;
   char tag[100]; /* should be plenty of space */
 
   msIO_printf("        <axisDescription>\n");
   msIO_printf("          <AxisDescription");
-  snprintf(tag, sizeof(tag), "%s_semantic",  name); /* optional attributes follow (should escape?) */
-  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", tag, OWS_NOERR, " semantic=\"%s\"", NULL);
+  snprintf(tag, sizeof(tag), "%s_semantic",
+           name); /* optional attributes follow (should escape?) */
+  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", tag, OWS_NOERR,
+                           " semantic=\"%s\"", NULL);
   snprintf(tag, sizeof(tag), "%s_refsys", name);
-  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", tag, OWS_NOERR, " refSys=\"%s\"", NULL);
+  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", tag, OWS_NOERR,
+                           " refSys=\"%s\"", NULL);
   snprintf(tag, sizeof(tag), "%s_refsyslabel", name);
-  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", tag, OWS_NOERR, " refSysLabel=\"%s\"", NULL);
+  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", tag, OWS_NOERR,
+                           " refSysLabel=\"%s\"", NULL);
   msIO_printf(">\n");
 
   /* TODO: add metadataLink (optional) */
 
   snprintf(tag, sizeof(tag), "%s_description", name);
-  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", tag, OWS_NOERR, "            <description>%s</description>\n", NULL);
+  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", tag, OWS_NOERR,
+                           "            <description>%s</description>\n", NULL);
   /* snprintf(tag, sizeof(tag), "%s_name", name); */
-  /* msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", tag, OWS_WARN, "            <name>%s</name>\n", NULL); */
+  /* msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", tag, OWS_WARN, "
+   * <name>%s</name>\n", NULL); */
   msIO_printf("            <name>%s</name>\n", name);
 
   snprintf(tag, sizeof(tag), "%s_label", name);
-  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", tag, OWS_WARN, "            <label>%s</label>\n", NULL);
+  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", tag, OWS_WARN,
+                           "            <label>%s</label>\n", NULL);
 
   /* Values */
   msIO_printf("            <values");
-  snprintf(tag, sizeof(tag), "%s_values_semantic", name); /* optional attributes follow (should escape?) */
-  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", tag, OWS_NOERR, " semantic=\"%s\"", NULL);
+  snprintf(tag, sizeof(tag), "%s_values_semantic",
+           name); /* optional attributes follow (should escape?) */
+  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", tag, OWS_NOERR,
+                           " semantic=\"%s\"", NULL);
   snprintf(tag, sizeof(tag), "%s_values_type", name);
-  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", tag, OWS_NOERR, " type=\"%s\"", NULL);
+  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", tag, OWS_NOERR,
+                           " type=\"%s\"", NULL);
   msIO_printf(">\n");
 
   /* single values, we do not support optional type and semantic attributes */
   snprintf(tag, sizeof(tag), "%s_values", name);
-  if(msOWSLookupMetadata(&(layer->metadata), "CO", tag))
-    msOWSPrintEncodeMetadataList(stdout, &(layer->metadata), "CO", tag, NULL, NULL, "              <singleValue>%s</singleValue>\n", NULL);
+  if (msOWSLookupMetadata(&(layer->metadata), "CO", tag))
+    msOWSPrintEncodeMetadataList(
+        stdout, &(layer->metadata), "CO", tag, NULL, NULL,
+        "              <singleValue>%s</singleValue>\n", NULL);
 
-  /* intervals, only one per axis for now, we do not support optional type, atomic and semantic attributes */
+  /* intervals, only one per axis for now, we do not support optional type,
+   * atomic and semantic attributes */
   snprintf(tag, sizeof(tag), "%s_interval", name);
-  if((value = msOWSLookupMetadata(&(layer->metadata), "CO", tag)) != NULL) {
+  if ((value = msOWSLookupMetadata(&(layer->metadata), "CO", tag)) != NULL) {
     int numtokens = 0;
-    char** tokens = msStringSplit(value, '/', &numtokens);
-    if(tokens && numtokens > 0) {
+    char **tokens = msStringSplit(value, '/', &numtokens);
+    if (tokens && numtokens > 0) {
       msIO_printf("            <interval>\n");
-      if(numtokens >= 1) msIO_printf("            <min>%s</min>\n", tokens[0]); /* TODO: handle closure */
-      if(numtokens >= 2) msIO_printf("            <max>%s</max>\n", tokens[1]);
-      if(numtokens >= 3) msIO_printf("            <res>%s</res>\n", tokens[2]);
+      if (numtokens >= 1)
+        msIO_printf("            <min>%s</min>\n",
+                    tokens[0]); /* TODO: handle closure */
+      if (numtokens >= 2)
+        msIO_printf("            <max>%s</max>\n", tokens[1]);
+      if (numtokens >= 3)
+        msIO_printf("            <res>%s</res>\n", tokens[2]);
       msIO_printf("            </interval>\n");
     }
     msFreeCharArray(tokens, numtokens);
@@ -1135,48 +1334,62 @@ static int msWCSDescribeCoverage_AxisDes
 /*               msWCSDescribeCoverage_CoverageOffering()               */
 /************************************************************************/
 
-static int msWCSDescribeCoverage_CoverageOffering(layerObj *layer, wcsParamsObj *params, char *script_url_encoded)
-{
+static int msWCSDescribeCoverage_CoverageOffering(layerObj *layer,
+                                                  wcsParamsObj *params,
+                                                  char *script_url_encoded) {
   const char *value;
   char *epsg_buf, *encoded_format;
   coverageMetadataObj cm;
   int i, status;
 
-  if ( msCheckParentPointer(layer->map,"map")==MS_FAILURE )
+  if (msCheckParentPointer(layer->map, "map") == MS_FAILURE)
     return MS_FAILURE;
 
-  if(!msWCSIsLayerSupported(layer)) return MS_SUCCESS; /* not an error, this layer cannot be served via WCS */
-
+  if (!msWCSIsLayerSupported(layer))
+    return MS_SUCCESS; /* not an error, this layer cannot be served via WCS */
 
   status = msWCSGetCoverageMetadata(layer, &cm);
-  if(status != MS_SUCCESS) return MS_FAILURE;
+  if (status != MS_SUCCESS)
+    return MS_FAILURE;
 
   /* fill in bands rangeset info, if required.  */
-  msWCSSetDefaultBandsRangeSetInfo( params, &cm, layer );
+  msWCSSetDefaultBandsRangeSetInfo(params, &cm, layer);
 
   /* start the Coverage section */
   msIO_printf("  <CoverageOffering>\n");
 
   msWCSPrintMetadataLink(layer, script_url_encoded);
 
-  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", "description", OWS_NOERR, "  <description>%s</description>\n", NULL);
-  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", "name", OWS_NOERR, "  <name>%s</name>\n", layer->name);
+  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", "description",
+                           OWS_NOERR, "  <description>%s</description>\n",
+                           NULL);
+  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", "name", OWS_NOERR,
+                           "  <name>%s</name>\n", layer->name);
 
-  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", "label", OWS_WARN, "  <label>%s</label>\n", NULL);
+  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", "label", OWS_WARN,
+                           "  <label>%s</label>\n", NULL);
 
   /* TODO: add elevation ranges to lonLatEnvelope (optional) */
-  msIO_printf("    <lonLatEnvelope srsName=\"urn:ogc:def:crs:OGC:1.3:CRS84\">\n");
-  msIO_printf("      <gml:pos>%.15g %.15g</gml:pos>\n", cm.llextent.minx, cm.llextent.miny);
-  msIO_printf("      <gml:pos>%.15g %.15g</gml:pos>\n", cm.llextent.maxx, cm.llextent.maxy);
-
-  msOWSPrintEncodeMetadataList(stdout, &(layer->metadata), "CO", "timeposition", NULL, NULL, "      <gml:timePosition>%s</gml:timePosition>\n", NULL);
+  msIO_printf(
+      "    <lonLatEnvelope srsName=\"urn:ogc:def:crs:OGC:1.3:CRS84\">\n");
+  msIO_printf("      <gml:pos>%.15g %.15g</gml:pos>\n", cm.llextent.minx,
+              cm.llextent.miny);
+  msIO_printf("      <gml:pos>%.15g %.15g</gml:pos>\n", cm.llextent.maxx,
+              cm.llextent.maxy);
+
+  msOWSPrintEncodeMetadataList(
+      stdout, &(layer->metadata), "CO", "timeposition", NULL, NULL,
+      "      <gml:timePosition>%s</gml:timePosition>\n", NULL);
 
   msIO_printf("    </lonLatEnvelope>\n");
 
   /* we are not supporting the optional keyword type, at least not yet */
-  msOWSPrintEncodeMetadataList(stdout, &(layer->metadata), "CO", "keywordlist", "  <keywords>\n", "  </keywords>\n", "    <keyword>%s</keyword>\n", NULL);
+  msOWSPrintEncodeMetadataList(stdout, &(layer->metadata), "CO", "keywordlist",
+                               "  <keywords>\n", "  </keywords>\n",
+                               "    <keyword>%s</keyword>\n", NULL);
 
-  /* DomainSet: starting simple, just a spatial domain (gml:envelope) and optionally a temporal domain */
+  /* DomainSet: starting simple, just a spatial domain (gml:envelope) and
+   * optionally a temporal domain */
   msIO_printf("    <domainSet>\n");
 
   /* SpatialDomain */
@@ -1184,23 +1397,30 @@ static int msWCSDescribeCoverage_Coverag
 
   /* envelope in lat/lon */
   msIO_printf("        <gml:Envelope srsName=\"EPSG:4326\">\n");
-  msIO_printf("          <gml:pos>%.15g %.15g</gml:pos>\n", cm.llextent.minx, cm.llextent.miny);
-  msIO_printf("          <gml:pos>%.15g %.15g</gml:pos>\n", cm.llextent.maxx, cm.llextent.maxy);
+  msIO_printf("          <gml:pos>%.15g %.15g</gml:pos>\n", cm.llextent.minx,
+              cm.llextent.miny);
+  msIO_printf("          <gml:pos>%.15g %.15g</gml:pos>\n", cm.llextent.maxx,
+              cm.llextent.maxy);
   msIO_printf("        </gml:Envelope>\n");
 
   /* envelope in the native srs */
-  msOWSGetEPSGProj(&(layer->projection), &(layer->metadata), "CO", MS_TRUE, &epsg_buf);
-  if(!epsg_buf) {
-    msOWSGetEPSGProj(&(layer->map->projection), &(layer->map->web.metadata), "CO", MS_TRUE, &epsg_buf);
+  msOWSGetEPSGProj(&(layer->projection), &(layer->metadata), "CO", MS_TRUE,
+                   &epsg_buf);
+  if (!epsg_buf) {
+    msOWSGetEPSGProj(&(layer->map->projection), &(layer->map->web.metadata),
+                     "CO", MS_TRUE, &epsg_buf);
   }
-  if(epsg_buf) {
+  if (epsg_buf) {
     msIO_printf("        <gml:Envelope srsName=\"%s\">\n", epsg_buf);
     msFree(epsg_buf);
   } else {
-    msIO_printf("        <!-- NativeCRSs ERROR: missing required information, no SRSs defined -->\n");
+    msIO_printf("        <!-- NativeCRSs ERROR: missing required information, "
+                "no SRSs defined -->\n");
   }
-  msIO_printf("          <gml:pos>%.15g %.15g</gml:pos>\n", cm.extent.minx, cm.extent.miny);
-  msIO_printf("          <gml:pos>%.15g %.15g</gml:pos>\n", cm.extent.maxx, cm.extent.maxy);
+  msIO_printf("          <gml:pos>%.15g %.15g</gml:pos>\n", cm.extent.minx,
+              cm.extent.miny);
+  msIO_printf("          <gml:pos>%.15g %.15g</gml:pos>\n", cm.extent.maxx,
+              cm.extent.maxy);
   msIO_printf("        </gml:Envelope>\n");
 
   /* gml:rectifiedGrid */
@@ -1208,30 +1428,41 @@ static int msWCSDescribeCoverage_Coverag
   msIO_printf("          <gml:limits>\n");
   msIO_printf("            <gml:GridEnvelope>\n");
   msIO_printf("              <gml:low>0 0</gml:low>\n");
-  msIO_printf("              <gml:high>%d %d</gml:high>\n", cm.xsize-1, cm.ysize-1);
+  msIO_printf("              <gml:high>%d %d</gml:high>\n", cm.xsize - 1,
+              cm.ysize - 1);
   msIO_printf("            </gml:GridEnvelope>\n");
   msIO_printf("          </gml:limits>\n");
   msIO_printf("          <gml:axisName>x</gml:axisName>\n");
   msIO_printf("          <gml:axisName>y</gml:axisName>\n");
   msIO_printf("          <gml:origin>\n");
-  msIO_printf("            <gml:pos>%.15g %.15g</gml:pos>\n", cm.geotransform[0], cm.geotransform[3]);
+  msIO_printf("            <gml:pos>%.15g %.15g</gml:pos>\n",
+              cm.geotransform[0], cm.geotransform[3]);
   msIO_printf("          </gml:origin>\n");
-  msIO_printf("          <gml:offsetVector>%.15g %.15g</gml:offsetVector>\n", cm.geotransform[1], cm.geotransform[2]); /* offset vector in X direction */
-  msIO_printf("          <gml:offsetVector>%.15g %.15g</gml:offsetVector>\n", cm.geotransform[4], cm.geotransform[5]); /* offset vector in Y direction */
+  msIO_printf("          <gml:offsetVector>%.15g %.15g</gml:offsetVector>\n",
+              cm.geotransform[1],
+              cm.geotransform[2]); /* offset vector in X direction */
+  msIO_printf("          <gml:offsetVector>%.15g %.15g</gml:offsetVector>\n",
+              cm.geotransform[4],
+              cm.geotransform[5]); /* offset vector in Y direction */
   msIO_printf("        </gml:RectifiedGrid>\n");
 
   msIO_printf("      </spatialDomain>\n");
-  
+
   msWCSFreeCoverageMetadata(&cm);
 
   /* TemporalDomain */
 
-  /* TODO: figure out when a temporal domain is valid, for example only tiled rasters support time as a domain, plus we need a timeitem */
-  if(msOWSLookupMetadata(&(layer->metadata), "CO", "timeposition") || msOWSLookupMetadata(&(layer->metadata), "CO", "timeperiod")) {
+  /* TODO: figure out when a temporal domain is valid, for example only tiled
+   * rasters support time as a domain, plus we need a timeitem */
+  if (msOWSLookupMetadata(&(layer->metadata), "CO", "timeposition") ||
+      msOWSLookupMetadata(&(layer->metadata), "CO", "timeperiod")) {
     msIO_printf("      <temporalDomain>\n");
 
-    /* TimePosition (should support a value AUTO, then we could mine positions from the timeitem) */
-    msOWSPrintEncodeMetadataList(stdout, &(layer->metadata), "CO", "timeposition", NULL, NULL, "        <gml:timePosition>%s</gml:timePosition>\n", NULL);
+    /* TimePosition (should support a value AUTO, then we could mine positions
+     * from the timeitem) */
+    msOWSPrintEncodeMetadataList(
+        stdout, &(layer->metadata), "CO", "timeposition", NULL, NULL,
+        "        <gml:timePosition>%s</gml:timePosition>\n", NULL);
 
     /* TODO:  add TimePeriod (only one per layer)  */
 
@@ -1242,27 +1473,34 @@ static int msWCSDescribeCoverage_Coverag
 
   /* rangeSet */
   msIO_printf("    <rangeSet>\n");
-  msIO_printf("      <RangeSet>\n"); /* TODO: there are some optional attributes */
+  msIO_printf(
+      "      <RangeSet>\n"); /* TODO: there are some optional attributes */
 
   /* TODO: add metadataLink (optional) */
 
-  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", "rangeset_description", OWS_NOERR, "        <description>%s</description>\n", NULL);
-  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", "rangeset_name", OWS_WARN, "        <name>%s</name>\n", NULL);
+  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO",
+                           "rangeset_description", OWS_NOERR,
+                           "        <description>%s</description>\n", NULL);
+  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", "rangeset_name",
+                           OWS_WARN, "        <name>%s</name>\n", NULL);
 
-  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", "rangeset_label", OWS_WARN, "        <label>%s</label>\n", NULL);
+  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", "rangeset_label",
+                           OWS_WARN, "        <label>%s</label>\n", NULL);
 
   /* compound range sets */
-  if((value = msOWSLookupMetadata(&(layer->metadata), "CO", "rangeset_axes")) != NULL) {
+  if ((value = msOWSLookupMetadata(&(layer->metadata), "CO",
+                                   "rangeset_axes")) != NULL) {
     int numtokens = 0;
-    char** tokens = msStringSplit(value, ',', &numtokens);
-    if(tokens && numtokens > 0) {
-      for(i=0; i<numtokens; i++)
+    char **tokens = msStringSplit(value, ',', &numtokens);
+    if (tokens && numtokens > 0) {
+      for (i = 0; i < numtokens; i++)
         msWCSDescribeCoverage_AxisDescription(layer, tokens[i]);
     }
     msFreeCharArray(tokens, numtokens);
   }
 
-  if((value = msOWSLookupMetadata(&(layer->metadata), "CO", "rangeset_nullvalue")) != NULL) {
+  if ((value = msOWSLookupMetadata(&(layer->metadata), "CO",
+                                   "rangeset_nullvalue")) != NULL) {
     msIO_printf("        <nullValues>\n");
     msIO_printf("          <singleValue>%s</singleValue>\n", value);
     msIO_printf("        </nullValues>\n");
@@ -1274,50 +1512,58 @@ static int msWCSDescribeCoverage_Coverag
   /* supportedCRSs */
   msIO_printf("    <supportedCRSs>\n");
 
-  /* requestResposeCRSs: check the layer metadata/projection, and then the map metadata/projection if necessary (should never get to the error message) */
-  msOWSGetEPSGProj(&(layer->projection), &(layer->metadata), "CO", MS_FALSE, &epsg_buf);
-  if(!epsg_buf) {
-    msOWSGetEPSGProj(&(layer->map->projection), &(layer->map->web.metadata), "CO", MS_FALSE, &epsg_buf);
+  /* requestResposeCRSs: check the layer metadata/projection, and then the map
+   * metadata/projection if necessary (should never get to the error message) */
+  msOWSGetEPSGProj(&(layer->projection), &(layer->metadata), "CO", MS_FALSE,
+                   &epsg_buf);
+  if (!epsg_buf) {
+    msOWSGetEPSGProj(&(layer->map->projection), &(layer->map->web.metadata),
+                     "CO", MS_FALSE, &epsg_buf);
   }
-  if(epsg_buf) {
+  if (epsg_buf) {
     int numtokens = 0;
-    char** tokens = msStringSplit(epsg_buf, ' ', &numtokens);
-    if(tokens && numtokens > 0) {
-      for(i=0; i<numtokens; i++)
-        msIO_printf("      <requestResponseCRSs>%s</requestResponseCRSs>\n", tokens[i]);
+    char **tokens = msStringSplit(epsg_buf, ' ', &numtokens);
+    if (tokens && numtokens > 0) {
+      for (i = 0; i < numtokens; i++)
+        msIO_printf("      <requestResponseCRSs>%s</requestResponseCRSs>\n",
+                    tokens[i]);
     }
     msFreeCharArray(tokens, numtokens);
     msFree(epsg_buf);
   } else {
-    msIO_printf("      <!-- requestResponseCRSs ERROR: missing required information, no SRSs defined -->\n");
+    msIO_printf("      <!-- requestResponseCRSs ERROR: missing required "
+                "information, no SRSs defined -->\n");
   }
 
   /* nativeCRSs (only one in our case) */
-  msOWSGetEPSGProj(&(layer->projection), &(layer->metadata), "CO", MS_TRUE, &epsg_buf);
-  if(!epsg_buf) {
-    msOWSGetEPSGProj(&(layer->map->projection), &(layer->map->web.metadata), "CO", MS_TRUE, &epsg_buf);
+  msOWSGetEPSGProj(&(layer->projection), &(layer->metadata), "CO", MS_TRUE,
+                   &epsg_buf);
+  if (!epsg_buf) {
+    msOWSGetEPSGProj(&(layer->map->projection), &(layer->map->web.metadata),
+                     "CO", MS_TRUE, &epsg_buf);
   }
-  if(epsg_buf) {
+  if (epsg_buf) {
     msIO_printf("      <nativeCRSs>%s</nativeCRSs>\n", epsg_buf);
     msFree(epsg_buf);
   } else {
-    msIO_printf("      <!-- nativeCRSs ERROR: missing required information, no SRSs defined -->\n");
+    msIO_printf("      <!-- nativeCRSs ERROR: missing required information, no "
+                "SRSs defined -->\n");
   }
 
   msIO_printf("    </supportedCRSs>\n");
 
-
   /* supportedFormats */
   msIO_printf("    <supportedFormats");
-  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", "nativeformat", OWS_NOERR, " nativeFormat=\"%s\"", NULL);
+  msOWSPrintEncodeMetadata(stdout, &(layer->metadata), "CO", "nativeformat",
+                           OWS_NOERR, " nativeFormat=\"%s\"", NULL);
   msIO_printf(">\n");
 
-  if( (encoded_format = msOWSGetEncodeMetadata( &(layer->metadata), "CO", "formats",
-                                       "GTiff" )) != NULL ) {
+  if ((encoded_format = msOWSGetEncodeMetadata(&(layer->metadata), "CO",
+                                               "formats", "GTiff")) != NULL) {
     int numtokens = 0;
-    char** tokens = msStringSplit(encoded_format, ' ', &numtokens);
-    if(tokens && numtokens > 0) {
-      for(i=0; i<numtokens; i++)
+    char **tokens = msStringSplit(encoded_format, ' ', &numtokens);
+    if (tokens && numtokens > 0) {
+      for (i = 0; i < numtokens; i++)
         msIO_printf("      <formats>%s</formats>\n", tokens[i]);
     }
     msFreeCharArray(tokens, numtokens);
@@ -1326,12 +1572,13 @@ static int msWCSDescribeCoverage_Coverag
   msIO_printf("    </supportedFormats>\n");
 
   msIO_printf("    <supportedInterpolations default=\"nearest neighbor\">\n");
-  msIO_printf("      <interpolationMethod>nearest neighbor</interpolationMethod>\n" );
-  msIO_printf("      <interpolationMethod>bilinear</interpolationMethod>\n" );
-  /*  msIO_printf("      <interpolationMethod>bicubic</interpolationMethod>\n" ); */
+  msIO_printf(
+      "      <interpolationMethod>nearest neighbor</interpolationMethod>\n");
+  msIO_printf("      <interpolationMethod>bilinear</interpolationMethod>\n");
+  /*  msIO_printf("      <interpolationMethod>bicubic</interpolationMethod>\n"
+   * ); */
   msIO_printf("    </supportedInterpolations>\n");
 
-
   /* done */
   msIO_printf("  </CoverageOffering>\n");
 
@@ -1342,36 +1589,41 @@ static int msWCSDescribeCoverage_Coverag
 /*                       msWCSDescribeCoverage()                        */
 /************************************************************************/
 
-static int msWCSDescribeCoverage(mapObj *map, wcsParamsObj *params, owsRequestObj *ows_request, cgiRequestObj *req)
-{
-  int i = 0,j = 0, k = 0;
-  const char *updatesequence=NULL;
-  char **coverages=NULL;
-  int numcoverages=0;
+static int msWCSDescribeCoverage(mapObj *map, wcsParamsObj *params,
+                                 owsRequestObj *ows_request,
+                                 cgiRequestObj *req) {
+  int i = 0, j = 0, k = 0;
+  const char *updatesequence = NULL;
+  char **coverages = NULL;
+  int numcoverages = 0;
 
-  char *coverageName=NULL;
-  char *script_url_encoded=NULL;
+  char *coverageName = NULL;
+  char *script_url_encoded = NULL;
 
   /* -------------------------------------------------------------------- */
   /*      1.1.x is sufficiently different we have a whole case for        */
   /*      it.  The remainder of this function is for 1.0.0.               */
   /* -------------------------------------------------------------------- */
-  if( strncmp(params->version,"1.1",3) == 0 )
-    return msWCSDescribeCoverage11( map, params, ows_request);
+  if (strncmp(params->version, "1.1", 3) == 0)
+    return msWCSDescribeCoverage11(map, params, ows_request);
 
   /* -------------------------------------------------------------------- */
   /*      Process 1.0.0...                                                */
   /* -------------------------------------------------------------------- */
 
-  if(params->coverages) { /* use the list, but validate it first */
-    for(j=0; params->coverages[j]; j++) {
+  if (params->coverages) { /* use the list, but validate it first */
+    for (j = 0; params->coverages[j]; j++) {
       coverages = msStringSplit(params->coverages[j], ',', &numcoverages);
-      for(k=0; k<numcoverages; k++) {
+      for (k = 0; k < numcoverages; k++) {
 
-        for(i=0; i<map->numlayers; i++) {
-          coverageName = msOWSGetEncodeMetadata(&(GET_LAYER(map, i)->metadata), "CO", "name", GET_LAYER(map, i)->name);
-          if( coverageName != NULL && EQUAL(coverageName, coverages[k]) &&
-              (msIntegerInArray(GET_LAYER(map, i)->index, ows_request->enabled_layers, ows_request->numlayers)) ) {
+        for (i = 0; i < map->numlayers; i++) {
+          coverageName =
+              msOWSGetEncodeMetadata(&(GET_LAYER(map, i)->metadata), "CO",
+                                     "name", GET_LAYER(map, i)->name);
+          if (coverageName != NULL && EQUAL(coverageName, coverages[k]) &&
+              (msIntegerInArray(GET_LAYER(map, i)->index,
+                                ows_request->enabled_layers,
+                                ows_request->numlayers))) {
             msFree(coverageName);
             break;
           }
@@ -1379,22 +1631,27 @@ static int msWCSDescribeCoverage(mapObj
         }
 
         /* i = msGetLayerIndex(map, coverages[k]); */
-        if(i == map->numlayers) { /* coverage not found */
-          msSetError( MS_WCSERR, "COVERAGE %s cannot be opened / does not exist. A layer might be disabled for \
-this request. Check wcs/ows_enable_request settings.", "msWCSDescribeCoverage()", coverages[k]);
-          return msWCSException(map, "CoverageNotDefined", "coverage", params->version );
+        if (i == map->numlayers) { /* coverage not found */
+          msSetError(
+              MS_WCSERR,
+              "COVERAGE %s cannot be opened / does not exist. A layer might be disabled for \
+this request. Check wcs/ows_enable_request settings.",
+              "msWCSDescribeCoverage()", coverages[k]);
+          return msWCSException(map, "CoverageNotDefined", "coverage",
+                                params->version);
         }
       } /* next coverage */
-      msFreeCharArray(coverages,numcoverages);
+      msFreeCharArray(coverages, numcoverages);
     }
   }
 
-  updatesequence = msOWSLookupMetadata(&(map->web.metadata), "CO", "updatesequence");
+  updatesequence =
+      msOWSLookupMetadata(&(map->web.metadata), "CO", "updatesequence");
   if (!updatesequence)
     updatesequence = "0";
 
   /* printf("Content-Type: application/vnd.ogc.se_xml%c%c",10,10); */
-  msIO_setHeader("Content-Type","text/xml; charset=UTF-8");
+  msIO_setHeader("Content-Type", "text/xml; charset=UTF-8");
   msIO_sendHeaders();
 
   /* print common capability elements  */
@@ -1408,36 +1665,45 @@ this request. Check wcs/ows_enable_reque
               "   xmlns:xlink=\"http://www.w3.org/1999/xlink\" \n"
               "   xmlns:gml=\"http://www.opengis.net/gml\" \n"
               "   xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n"
-              "   xsi:schemaLocation=\"http://www.opengis.net/wcs %s/wcs/%s/describeCoverage.xsd\">\n", params->version, updatesequence, msOWSGetSchemasLocation(map), params->version);
+              "   xsi:schemaLocation=\"http://www.opengis.net/wcs "
+              "%s/wcs/%s/describeCoverage.xsd\">\n",
+              params->version, updatesequence, msOWSGetSchemasLocation(map),
+              params->version);
 
   {
-    char* pszTmp = msOWSGetOnlineResource(map, "CO", "onlineresource", req);
+    char *pszTmp = msOWSGetOnlineResource(map, "CO", "onlineresource", req);
     script_url_encoded = msEncodeHTMLEntities(pszTmp);
     msFree(pszTmp);
   }
 
-  if(params->coverages) { /* use the list */
-    for( j = 0; params->coverages[j]; j++ ) {
+  if (params->coverages) { /* use the list */
+    for (j = 0; params->coverages[j]; j++) {
       coverages = msStringSplit(params->coverages[j], ',', &numcoverages);
-      for(k=0; k<numcoverages; k++) {
-        for(i=0; i<map->numlayers; i++) {
-          coverageName = msOWSGetEncodeMetadata(&(GET_LAYER(map, i)->metadata), "CO", "name", GET_LAYER(map, i)->name);
-          if( coverageName != NULL && EQUAL(coverageName, coverages[k]) ) {
+      for (k = 0; k < numcoverages; k++) {
+        for (i = 0; i < map->numlayers; i++) {
+          coverageName =
+              msOWSGetEncodeMetadata(&(GET_LAYER(map, i)->metadata), "CO",
+                                     "name", GET_LAYER(map, i)->name);
+          if (coverageName != NULL && EQUAL(coverageName, coverages[k])) {
             msFree(coverageName);
             break;
           }
           msFree(coverageName);
         }
-        msWCSDescribeCoverage_CoverageOffering((GET_LAYER(map, i)), params, script_url_encoded);
+        msWCSDescribeCoverage_CoverageOffering((GET_LAYER(map, i)), params,
+                                               script_url_encoded);
       }
-      msFreeCharArray(coverages,numcoverages);
+      msFreeCharArray(coverages, numcoverages);
     }
   } else { /* return all layers */
-    for(i=0; i<map->numlayers; i++) {
-      if (!msIntegerInArray(GET_LAYER(map, i)->index, ows_request->enabled_layers, ows_request->numlayers))
+    for (i = 0; i < map->numlayers; i++) {
+      if (!msIntegerInArray(GET_LAYER(map, i)->index,
+                            ows_request->enabled_layers,
+                            ows_request->numlayers))
         continue;
 
-      msWCSDescribeCoverage_CoverageOffering((GET_LAYER(map, i)), params, script_url_encoded);
+      msWCSDescribeCoverage_CoverageOffering((GET_LAYER(map, i)), params,
+                                             script_url_encoded);
     }
   }
 
@@ -1453,17 +1719,20 @@ this request. Check wcs/ows_enable_reque
 /*                       msWCSGetCoverageBands10()                      */
 /************************************************************************/
 
-static int msWCSGetCoverageBands10( mapObj *map, cgiRequestObj *request,
-                                    wcsParamsObj *params, layerObj *lp,
-                                    char **p_bandlist )
+static int msWCSGetCoverageBands10(mapObj *map, cgiRequestObj *request,
+                                   wcsParamsObj *params, layerObj *lp,
+                                   char **p_bandlist)
 
 {
   const char *value = NULL;
   int i;
 
-  /* Are there any non-spatio/temporal ranges to do subsetting on (e.g. bands) */
-  value = msOWSLookupMetadata(&(lp->metadata), "CO", "rangeset_axes"); /* this will get all the compound range sets */
-  if(value) {
+  /* Are there any non-spatio/temporal ranges to do subsetting on (e.g. bands)
+   */
+  value = msOWSLookupMetadata(
+      &(lp->metadata), "CO",
+      "rangeset_axes"); /* this will get all the compound range sets */
+  if (value) {
     char **tokens;
     int numtokens;
     char tag[100];
@@ -1471,42 +1740,59 @@ static int msWCSGetCoverageBands10( mapO
 
     tokens = msStringSplit(value, ',', &numtokens);
 
-    for(i=0; i<numtokens; i++) {
-      if((value = msWCSGetRequestParameter(request, tokens[i])) == NULL) continue; /* next rangeset parameter */
-
-      /* ok, a parameter has been passed which matches a token in wcs_rangeset_axes */
-      if(msWCSValidateRangeSetParam(lp, tokens[i], value) != MS_SUCCESS) {
+    for (i = 0; i < numtokens; i++) {
+      if ((value = msWCSGetRequestParameter(request, tokens[i])) == NULL)
+        continue; /* next rangeset parameter */
+
+      /* ok, a parameter has been passed which matches a token in
+       * wcs_rangeset_axes */
+      if (msWCSValidateRangeSetParam(lp, tokens[i], value) != MS_SUCCESS) {
         int ret;
-        msSetError( MS_WCSERR, "Error specifying \"%s\" parameter value(s).", "msWCSGetCoverage()", tokens[i]);
-        ret = msWCSException(map, "InvalidParameterValue", tokens[i], params->version );
+        msSetError(MS_WCSERR, "Error specifying \"%s\" parameter value(s).",
+                   "msWCSGetCoverage()", tokens[i]);
+        ret = msWCSException(map, "InvalidParameterValue", tokens[i],
+                             params->version);
         msFreeCharArray(tokens, numtokens);
         return ret;
       }
 
       /* xxxxx_rangeitem tells us how to subset */
       snprintf(tag, sizeof(tag), "%s_rangeitem", tokens[i]);
-      if((rangeitem = msOWSLookupMetadata(&(lp->metadata), "CO", tag)) == NULL) {
-        msSetError( MS_WCSERR, "Missing required metadata element \"%s\", unable to process %s=%s.", "msWCSGetCoverage()", tag, tokens[i], value);
+      if ((rangeitem = msOWSLookupMetadata(&(lp->metadata), "CO", tag)) ==
+          NULL) {
+        msSetError(MS_WCSERR,
+                   "Missing required metadata element \"%s\", unable to "
+                   "process %s=%s.",
+                   "msWCSGetCoverage()", tag, tokens[i], value);
         msFreeCharArray(tokens, numtokens);
         return msWCSException(map, NULL, NULL, params->version);
       }
 
-      if(strcasecmp(rangeitem, "_bands") == 0) { /* special case, subset bands */
+      if (strcasecmp(rangeitem, "_bands") ==
+          0) { /* special case, subset bands */
         *p_bandlist = msWCSConvertRangeSetToString(value);
 
-        if(!*p_bandlist) {
-          msSetError( MS_WCSERR, "Error specifying \"%s\" parameter value(s).", "msWCSGetCoverage()", tokens[i]);
+        if (!*p_bandlist) {
+          msSetError(MS_WCSERR, "Error specifying \"%s\" parameter value(s).",
+                     "msWCSGetCoverage()", tokens[i]);
           msFreeCharArray(tokens, numtokens);
-          return msWCSException(map, NULL, NULL, params->version );
+          return msWCSException(map, NULL, NULL, params->version);
         }
-      } else if(strcasecmp(rangeitem, "_pixels") == 0) { /* special case, subset pixels */
+      } else if (strcasecmp(rangeitem, "_pixels") ==
+                 0) { /* special case, subset pixels */
         msFreeCharArray(tokens, numtokens);
-        msSetError( MS_WCSERR, "Arbitrary range sets based on pixel values are not yet supported.", "msWCSGetCoverage()" );
+        msSetError(
+            MS_WCSERR,
+            "Arbitrary range sets based on pixel values are not yet supported.",
+            "msWCSGetCoverage()");
         return msWCSException(map, NULL, NULL, params->version);
       } else {
         msFreeCharArray(tokens, numtokens);
-        msSetError( MS_WCSERR, "Arbitrary range sets based on tile (i.e. image) attributes are not yet supported.", "msWCSGetCoverage()" );
-        return msWCSException(map, NULL, NULL, params->version );
+        msSetError(MS_WCSERR,
+                   "Arbitrary range sets based on tile (i.e. image) attributes "
+                   "are not yet supported.",
+                   "msWCSGetCoverage()");
+        return msWCSException(map, NULL, NULL, params->version);
       }
     }
     /* clean-up */
@@ -1525,61 +1811,57 @@ static int msWCSGetCoverageBands10( mapO
 /*      the imageCRS request.                                           */
 /************************************************************************/
 
-static int msWCSGetCoverage_ImageCRSSetup(
-  mapObj *map, wcsParamsObj *params,
-  coverageMetadataObj *cm, layerObj *layer )
+static int msWCSGetCoverage_ImageCRSSetup(mapObj *map, wcsParamsObj *params,
+                                          coverageMetadataObj *cm,
+                                          layerObj *layer)
 
 {
   /* -------------------------------------------------------------------- */
   /*      Load map with the layer (coverage) coordinate system.  We       */
   /*      really need a set projectionObj from projectionObj function!    */
   /* -------------------------------------------------------------------- */
-  char *layer_proj = msGetProjectionString( &(layer->projection) );
+  char *layer_proj = msGetProjectionString(&(layer->projection));
 
   if (msLoadProjectionString(&(map->projection), layer_proj) != 0) {
     msFree(layer_proj);
-    return msWCSException( map, NULL, NULL, params->version );
+    return msWCSException(map, NULL, NULL, params->version);
   }
 
-  free( layer_proj );
+  free(layer_proj);
   layer_proj = NULL;
 
   /* -------------------------------------------------------------------- */
   /*      Reset bounding box.                                             */
   /* -------------------------------------------------------------------- */
-  if( params->bbox.maxx != params->bbox.minx ) {
+  if (params->bbox.maxx != params->bbox.minx) {
     rectObj orig_bbox = params->bbox;
 
-    params->bbox.minx =
-      cm->geotransform[0]
-      + orig_bbox.minx * cm->geotransform[1]
-      + orig_bbox.miny * cm->geotransform[2];
-    params->bbox.maxy =
-      cm->geotransform[3]
-      + orig_bbox.minx * cm->geotransform[4]
-      + orig_bbox.miny * cm->geotransform[5];
-    params->bbox.maxx =
-      cm->geotransform[0]
-      + (orig_bbox.maxx+1) * cm->geotransform[1]
-      + (orig_bbox.maxy+1) * cm->geotransform[2];
-    params->bbox.miny =
-      cm->geotransform[3]
-      + (orig_bbox.maxx+1) * cm->geotransform[4]
-      + (orig_bbox.maxy+1) * cm->geotransform[5];
+    params->bbox.minx = cm->geotransform[0] +
+                        orig_bbox.minx * cm->geotransform[1] +
+                        orig_bbox.miny * cm->geotransform[2];
+    params->bbox.maxy = cm->geotransform[3] +
+                        orig_bbox.minx * cm->geotransform[4] +
+                        orig_bbox.miny * cm->geotransform[5];
+    params->bbox.maxx = cm->geotransform[0] +
+                        (orig_bbox.maxx + 1) * cm->geotransform[1] +
+                        (orig_bbox.maxy + 1) * cm->geotransform[2];
+    params->bbox.miny = cm->geotransform[3] +
+                        (orig_bbox.maxx + 1) * cm->geotransform[4] +
+                        (orig_bbox.maxy + 1) * cm->geotransform[5];
 
     /* WCS 1.1 boundbox is center of pixel oriented. */
-    if( strncasecmp(params->version,"1.1",3) == 0 ) {
-      params->bbox.minx += cm->geotransform[1]/2 + cm->geotransform[2]/2;
-      params->bbox.maxx -= cm->geotransform[1]/2 + cm->geotransform[2]/2;
-      params->bbox.maxy += cm->geotransform[4]/2 + cm->geotransform[5]/2;
-      params->bbox.miny -= cm->geotransform[4]/2 + cm->geotransform[5]/2;
+    if (strncasecmp(params->version, "1.1", 3) == 0) {
+      params->bbox.minx += cm->geotransform[1] / 2 + cm->geotransform[2] / 2;
+      params->bbox.maxx -= cm->geotransform[1] / 2 + cm->geotransform[2] / 2;
+      params->bbox.maxy += cm->geotransform[4] / 2 + cm->geotransform[5] / 2;
+      params->bbox.miny -= cm->geotransform[4] / 2 + cm->geotransform[5] / 2;
     }
   }
 
   /* -------------------------------------------------------------------- */
   /*      Reset resolution.                                               */
   /* -------------------------------------------------------------------- */
-  if( params->resx != 0.0 ) {
+  if (params->resx != 0.0) {
     params->resx = cm->geotransform[1] * params->resx;
     params->resy = fabs(cm->geotransform[5] * params->resy);
   }
@@ -1591,558 +1873,487 @@ static int msWCSGetCoverage_ImageCRSSetu
 /*                    msWCSApplyLayerCreationOptions()                  */
 /************************************************************************/
 
-void msWCSApplyLayerCreationOptions(layerObj* lp,
-                                    outputFormatObj* format,
-                                    const char* bandlist)
+void msWCSApplyLayerCreationOptions(layerObj *lp, outputFormatObj *format,
+                                    const char *bandlist)
 
 {
-    const char* pszKey;
-    char szKeyBeginning[256];
-    size_t nKeyBeginningLength;
-    int nBands = 0;
-    char** papszBandNumbers = msStringSplit(bandlist, ',', &nBands);
-
-    snprintf(szKeyBeginning, sizeof(szKeyBeginning),
-             "wcs_outputformat_%s_creationoption_", format->name);
-    nKeyBeginningLength = strlen(szKeyBeginning);
-
-    pszKey = msFirstKeyFromHashTable( &(lp->metadata) );
-    for( ; pszKey != NULL;
-           pszKey = msNextKeyFromHashTable( &(lp->metadata), pszKey) )
-    {
-        if( strncmp(pszKey, szKeyBeginning, nKeyBeginningLength) == 0 )
-        {
-            const char* pszValue = msLookupHashTable( &(lp->metadata), pszKey);
-            const char* pszGDALKey = pszKey + nKeyBeginningLength;
-            if( EQUALN(pszGDALKey, "BAND_", strlen("BAND_")) )
-            {
-                /* Remap BAND specific creation option to the real output
-                 * band number, given the band subset of the request */
-                int nKeyOriBandNumber = atoi(pszGDALKey + strlen("BAND_"));
-                int nTargetBandNumber = -1;
-                int i;
-                for(i = 0; i < nBands; i++ )
-                {
-                    if( nKeyOriBandNumber == atoi(papszBandNumbers[i]) )
-                    {
-                        nTargetBandNumber = i + 1;
-                        break;
-                    }
-                }
-                if( nTargetBandNumber > 0 )
-                {
-                    char szModKey[256];
-                    const char* pszAfterBand =
-                        strchr(pszGDALKey + strlen("BAND_"), '_');
-                    if( pszAfterBand != NULL )
-                    {
-                        snprintf(szModKey, sizeof(szModKey),
-                                 "BAND_%d%s",
-                                 nTargetBandNumber,
-                                 pszAfterBand);
-                        if( lp->debug >= MS_DEBUGLEVEL_VVV ) {
-                            msDebug("Setting GDAL %s=%s creation option\n",
-                                    szModKey, pszValue);
-                        }
-                        msSetOutputFormatOption(format, szModKey, pszValue);
-                    }
-                }
-            }
-            else
-            {
-                if( lp->debug >= MS_DEBUGLEVEL_VVV ) {
-                    msDebug("Setting GDAL %s=%s creation option\n",
-                            pszGDALKey, pszValue);
-                }
-                msSetOutputFormatOption(format, pszGDALKey, pszValue);
+  const char *pszKey;
+  char szKeyBeginning[256];
+  size_t nKeyBeginningLength;
+  int nBands = 0;
+  char **papszBandNumbers = msStringSplit(bandlist, ',', &nBands);
+
+  snprintf(szKeyBeginning, sizeof(szKeyBeginning),
+           "wcs_outputformat_%s_creationoption_", format->name);
+  nKeyBeginningLength = strlen(szKeyBeginning);
+
+  pszKey = msFirstKeyFromHashTable(&(lp->metadata));
+  for (; pszKey != NULL;
+       pszKey = msNextKeyFromHashTable(&(lp->metadata), pszKey)) {
+    if (strncmp(pszKey, szKeyBeginning, nKeyBeginningLength) == 0) {
+      const char *pszValue = msLookupHashTable(&(lp->metadata), pszKey);
+      const char *pszGDALKey = pszKey + nKeyBeginningLength;
+      if (EQUALN(pszGDALKey, "BAND_", strlen("BAND_"))) {
+        /* Remap BAND specific creation option to the real output
+         * band number, given the band subset of the request */
+        int nKeyOriBandNumber = atoi(pszGDALKey + strlen("BAND_"));
+        int nTargetBandNumber = -1;
+        int i;
+        for (i = 0; i < nBands; i++) {
+          if (nKeyOriBandNumber == atoi(papszBandNumbers[i])) {
+            nTargetBandNumber = i + 1;
+            break;
+          }
+        }
+        if (nTargetBandNumber > 0) {
+          char szModKey[256];
+          const char *pszAfterBand = strchr(pszGDALKey + strlen("BAND_"), '_');
+          if (pszAfterBand != NULL) {
+            snprintf(szModKey, sizeof(szModKey), "BAND_%d%s", nTargetBandNumber,
+                     pszAfterBand);
+            if (lp->debug >= MS_DEBUGLEVEL_VVV) {
+              msDebug("Setting GDAL %s=%s creation option\n", szModKey,
+                      pszValue);
             }
+            msSetOutputFormatOption(format, szModKey, pszValue);
+          }
+        }
+      } else {
+        if (lp->debug >= MS_DEBUGLEVEL_VVV) {
+          msDebug("Setting GDAL %s=%s creation option\n", pszGDALKey, pszValue);
         }
+        msSetOutputFormatOption(format, pszGDALKey, pszValue);
+      }
     }
+  }
 
-    msFreeCharArray( papszBandNumbers, nBands );
+  msFreeCharArray(papszBandNumbers, nBands);
 }
 
 /************************************************************************/
 /*               msWCSApplyDatasetMetadataAsCreationOptions()           */
 /************************************************************************/
 
-void msWCSApplyDatasetMetadataAsCreationOptions(layerObj* lp,
-                                                outputFormatObj* format,
-                                                const char* bandlist,
-                                                void* hDSIn)
-{
-    /* Requires GDAL 2.3 in practice. */
-    /* Automatic forwarding of input dataset metadata if it is GRIB and the */
-    /* output is GRIB as well, and wcs_outputformat_GRIB_creationoption* are */
-    /* not defined. */
-    GDALDatasetH hDS = (GDALDatasetH)hDSIn;
-    if( hDS && GDALGetDatasetDriver(hDS) &&
-        EQUAL(GDALGetDriverShortName(GDALGetDatasetDriver(hDS)), "GRIB") &&
-        EQUAL(format->driver, "GDAL/GRIB") )
-    {
-        const char* pszKey;
-        char szKeyBeginning[256];
-        size_t nKeyBeginningLength;
-        int bWCSMetadataFound = MS_FALSE;
-
-        snprintf(szKeyBeginning, sizeof(szKeyBeginning),
-                "wcs_outputformat_%s_creationoption_", format->name);
-        nKeyBeginningLength = strlen(szKeyBeginning);
-
-        for( pszKey = msFirstKeyFromHashTable( &(lp->metadata) );
-             pszKey != NULL;
-             pszKey = msNextKeyFromHashTable( &(lp->metadata), pszKey) )
-        {
-            if( strncmp(pszKey, szKeyBeginning, nKeyBeginningLength) == 0 )
-            {
-                bWCSMetadataFound = MS_TRUE;
-                break;
-            }
-        }
-        if( !bWCSMetadataFound )
-        {
-            int nBands = 0;
-            char** papszBandNumbers = msStringSplit(bandlist, ',', &nBands);
-            int i;
-            for(i = 0; i < nBands; i++ )
-            {
-                int nSrcBand = atoi(papszBandNumbers[i]);
-                int nDstBand = i + 1;
-                GDALRasterBandH hBand = GDALGetRasterBand(hDS, nSrcBand);
-                if( hBand )
-                {
-                    char** papszMD = GDALGetMetadata(hBand, NULL);
-                    const char* pszMDI = CSLFetchNameValue(papszMD, "GRIB_IDS");
-                    // Make sure it is a GRIB2 band
-                    if( pszMDI )
-                    {
-                        char szKey[256];
-                        sprintf(szKey, "BAND_%d_IDS", nDstBand);
-                        msSetOutputFormatOption(format, szKey, pszMDI);
-
-                        sprintf(szKey, "BAND_%d_DISCIPLINE", nDstBand);
-                        msSetOutputFormatOption(format, szKey, 
-                                CSLFetchNameValue(papszMD, "DISCIPLINE"));
-
-                        sprintf(szKey, "BAND_%d_PDS_PDTN", nDstBand);
-                        msSetOutputFormatOption(format, szKey, 
-                                CSLFetchNameValue(papszMD, "GRIB_PDS_PDTN"));
-
-                        sprintf(szKey, "BAND_%d_PDS_TEMPLATE_NUMBERS",
-                                nDstBand);
-                        msSetOutputFormatOption(format, szKey, 
-                                CSLFetchNameValue(papszMD,
-                                                  "GRIB_PDS_TEMPLATE_NUMBERS"));
-                    }
-                }
-            }
-            msFreeCharArray( papszBandNumbers, nBands );
+void msWCSApplyDatasetMetadataAsCreationOptions(layerObj *lp,
+                                                outputFormatObj *format,
+                                                const char *bandlist,
+                                                void *hDSIn) {
+  /* Requires GDAL 2.3 in practice. */
+  /* Automatic forwarding of input dataset metadata if it is GRIB and the */
+  /* output is GRIB as well, and wcs_outputformat_GRIB_creationoption* are */
+  /* not defined. */
+  GDALDatasetH hDS = (GDALDatasetH)hDSIn;
+  if (hDS && GDALGetDatasetDriver(hDS) &&
+      EQUAL(GDALGetDriverShortName(GDALGetDatasetDriver(hDS)), "GRIB") &&
+      EQUAL(format->driver, "GDAL/GRIB")) {
+    const char *pszKey;
+    char szKeyBeginning[256];
+    size_t nKeyBeginningLength;
+    int bWCSMetadataFound = MS_FALSE;
+
+    snprintf(szKeyBeginning, sizeof(szKeyBeginning),
+             "wcs_outputformat_%s_creationoption_", format->name);
+    nKeyBeginningLength = strlen(szKeyBeginning);
+
+    for (pszKey = msFirstKeyFromHashTable(&(lp->metadata)); pszKey != NULL;
+         pszKey = msNextKeyFromHashTable(&(lp->metadata), pszKey)) {
+      if (strncmp(pszKey, szKeyBeginning, nKeyBeginningLength) == 0) {
+        bWCSMetadataFound = MS_TRUE;
+        break;
+      }
+    }
+    if (!bWCSMetadataFound) {
+      int nBands = 0;
+      char **papszBandNumbers = msStringSplit(bandlist, ',', &nBands);
+      int i;
+      for (i = 0; i < nBands; i++) {
+        int nSrcBand = atoi(papszBandNumbers[i]);
+        int nDstBand = i + 1;
+        GDALRasterBandH hBand = GDALGetRasterBand(hDS, nSrcBand);
+        if (hBand) {
+          char **papszMD = GDALGetMetadata(hBand, NULL);
+          const char *pszMDI = CSLFetchNameValue(papszMD, "GRIB_IDS");
+          // Make sure it is a GRIB2 band
+          if (pszMDI) {
+            char szKey[256];
+            sprintf(szKey, "BAND_%d_IDS", nDstBand);
+            msSetOutputFormatOption(format, szKey, pszMDI);
+
+            sprintf(szKey, "BAND_%d_DISCIPLINE", nDstBand);
+            msSetOutputFormatOption(format, szKey,
+                                    CSLFetchNameValue(papszMD, "DISCIPLINE"));
+
+            sprintf(szKey, "BAND_%d_PDS_PDTN", nDstBand);
+            msSetOutputFormatOption(
+                format, szKey, CSLFetchNameValue(papszMD, "GRIB_PDS_PDTN"));
+
+            sprintf(szKey, "BAND_%d_PDS_TEMPLATE_NUMBERS", nDstBand);
+            msSetOutputFormatOption(
+                format, szKey,
+                CSLFetchNameValue(papszMD, "GRIB_PDS_TEMPLATE_NUMBERS"));
+          }
         }
+      }
+      msFreeCharArray(papszBandNumbers, nBands);
     }
+  }
 }
 
 /************************************************************************/
 /*                  msWCSApplyLayerMetadataItemOptions()                */
 /************************************************************************/
 
-void msWCSApplyLayerMetadataItemOptions(layerObj* lp,
-                                        outputFormatObj* format,
-                                        const char* bandlist)
+void msWCSApplyLayerMetadataItemOptions(layerObj *lp, outputFormatObj *format,
+                                        const char *bandlist)
 
 {
-    if( !STARTS_WITH(format->driver, "GDAL/") )
-        return;
-
-    const bool bIsNetCDFOutput = EQUAL(format->driver, "GDAL/netCDF");
-    const char* pszKey;
-    char szKeyBeginning[256];
-    size_t nKeyBeginningLength;
-    int nBands = 0;
-    char** papszBandNumbers = msStringSplit(bandlist, ',', &nBands);
-
-    snprintf(szKeyBeginning, sizeof(szKeyBeginning),
-             "wcs_outputformat_%s_mdi_", format->name);
-    nKeyBeginningLength = strlen(szKeyBeginning);
+  if (!STARTS_WITH(format->driver, "GDAL/"))
+    return;
 
-    // Transform wcs_outputformat_{formatname}_mdi_{key} to mdi_{key}
-    // and Transform wcs_outputformat_{formatname}_mdi_BAND_X_{key} to mdi_BAND_Y_{key}
-    // MDI stands for MetaDataItem
-
-    // For netCDF 3D output
-    std::map<int, std::string> oMapExtraDimValues;
-    std::string osExtraDimName;
-    bool bExtraDimValid = false;
-
-    pszKey = msFirstKeyFromHashTable( &(lp->metadata) );
-    for( ; pszKey != NULL;
-           pszKey = msNextKeyFromHashTable( &(lp->metadata), pszKey) )
-    {
-        if( strncmp(pszKey, szKeyBeginning, nKeyBeginningLength) == 0 )
-        {
-            const char* pszValue = msLookupHashTable( &(lp->metadata), pszKey);
-            const char* pszGDALKey = pszKey + nKeyBeginningLength;
-
-            if( EQUALN(pszGDALKey, "BAND_", strlen("BAND_")) )
-            {
-                /* Remap BAND specific creation option to the real output
-                 * band number, given the band subset of the request */
-                int nKeyOriBandNumber = atoi(pszGDALKey + strlen("BAND_"));
-                int nTargetBandNumber = -1;
-                int i;
-                for(i = 0; i < nBands; i++ )
-                {
-                    if( nKeyOriBandNumber == atoi(papszBandNumbers[i]) )
-                    {
-                        nTargetBandNumber = i + 1;
-                        break;
-                    }
-                }
-                if( nTargetBandNumber > 0 )
-                {
-                    char szModKey[256];
-                    const char* pszAfterBand =
-                        strchr(pszGDALKey + strlen("BAND_"), '_');
-                    if( pszAfterBand != NULL )
-                    {
-                        // Special case to generate 3D netCDF files
-                        if( bIsNetCDFOutput &&
-                            strncmp(pszAfterBand, "_default_NETCDF_DIM_",
-                                    strlen("_default_NETCDF_DIM_")) == 0 )
-                        {
-                            const char* pszDimName = pszAfterBand +
-                                                strlen("_default_NETCDF_DIM_");
-                            if( osExtraDimName.empty() )
-                            {
-                                bExtraDimValid = true;
-                                osExtraDimName = pszDimName;
-                                oMapExtraDimValues[nTargetBandNumber] = pszValue;
-                            }
-                            else if( bExtraDimValid )
-                            {
-                                if( osExtraDimName != pszDimName )
-                                {
-                                    msDebug("One band has several %sdefault_NETCDF_DIM_ metadata items, "
-                                            "or different bands have a different value. "
-                                            "Only a single extra dimension is supported.",
-                                            szKeyBeginning);
-                                    bExtraDimValid = false;
-                                }
-                                else
-                                {
-                                    oMapExtraDimValues[nTargetBandNumber] = pszValue;
-                                }
-                            }
-                        }
-                        else
-                        {
-                            snprintf(szModKey, sizeof(szModKey),
-                                     "mdi_BAND_%d%s",
-                                     nTargetBandNumber,
-                                     pszAfterBand);
-                            if( lp->debug >= MS_DEBUGLEVEL_VVV ) {
-                                msDebug("Setting GDAL %s=%s metadata item option\n",
-                                        szModKey, pszValue);
-                            }
-                            msSetOutputFormatOption(format, szModKey, pszValue);
-                        }
-                    }
-                }
-            }
-            else
-            {
-                char szModKey[256];
-                snprintf(szModKey, sizeof(szModKey),
-                         "mdi_%s", pszGDALKey);
-                if( lp->debug >= MS_DEBUGLEVEL_VVV ) {
-                    msDebug("Setting GDAL %s=%s metadata item option\n",
-                            szModKey, pszValue);
+  const bool bIsNetCDFOutput = EQUAL(format->driver, "GDAL/netCDF");
+  const char *pszKey;
+  char szKeyBeginning[256];
+  size_t nKeyBeginningLength;
+  int nBands = 0;
+  char **papszBandNumbers = msStringSplit(bandlist, ',', &nBands);
+
+  snprintf(szKeyBeginning, sizeof(szKeyBeginning), "wcs_outputformat_%s_mdi_",
+           format->name);
+  nKeyBeginningLength = strlen(szKeyBeginning);
+
+  // Transform wcs_outputformat_{formatname}_mdi_{key} to mdi_{key}
+  // and Transform wcs_outputformat_{formatname}_mdi_BAND_X_{key} to
+  // mdi_BAND_Y_{key} MDI stands for MetaDataItem
+
+  // For netCDF 3D output
+  std::map<int, std::string> oMapExtraDimValues;
+  std::string osExtraDimName;
+  bool bExtraDimValid = false;
+
+  pszKey = msFirstKeyFromHashTable(&(lp->metadata));
+  for (; pszKey != NULL;
+       pszKey = msNextKeyFromHashTable(&(lp->metadata), pszKey)) {
+    if (strncmp(pszKey, szKeyBeginning, nKeyBeginningLength) == 0) {
+      const char *pszValue = msLookupHashTable(&(lp->metadata), pszKey);
+      const char *pszGDALKey = pszKey + nKeyBeginningLength;
+
+      if (EQUALN(pszGDALKey, "BAND_", strlen("BAND_"))) {
+        /* Remap BAND specific creation option to the real output
+         * band number, given the band subset of the request */
+        int nKeyOriBandNumber = atoi(pszGDALKey + strlen("BAND_"));
+        int nTargetBandNumber = -1;
+        int i;
+        for (i = 0; i < nBands; i++) {
+          if (nKeyOriBandNumber == atoi(papszBandNumbers[i])) {
+            nTargetBandNumber = i + 1;
+            break;
+          }
+        }
+        if (nTargetBandNumber > 0) {
+          char szModKey[256];
+          const char *pszAfterBand = strchr(pszGDALKey + strlen("BAND_"), '_');
+          if (pszAfterBand != NULL) {
+            // Special case to generate 3D netCDF files
+            if (bIsNetCDFOutput &&
+                strncmp(pszAfterBand, "_default_NETCDF_DIM_",
+                        strlen("_default_NETCDF_DIM_")) == 0) {
+              const char *pszDimName =
+                  pszAfterBand + strlen("_default_NETCDF_DIM_");
+              if (osExtraDimName.empty()) {
+                bExtraDimValid = true;
+                osExtraDimName = pszDimName;
+                oMapExtraDimValues[nTargetBandNumber] = pszValue;
+              } else if (bExtraDimValid) {
+                if (osExtraDimName != pszDimName) {
+                  msDebug("One band has several %sdefault_NETCDF_DIM_ metadata "
+                          "items, "
+                          "or different bands have a different value. "
+                          "Only a single extra dimension is supported.",
+                          szKeyBeginning);
+                  bExtraDimValid = false;
+                } else {
+                  oMapExtraDimValues[nTargetBandNumber] = pszValue;
                 }
-                msSetOutputFormatOption(format, szModKey, pszValue);
+              }
+            } else {
+              snprintf(szModKey, sizeof(szModKey), "mdi_BAND_%d%s",
+                       nTargetBandNumber, pszAfterBand);
+              if (lp->debug >= MS_DEBUGLEVEL_VVV) {
+                msDebug("Setting GDAL %s=%s metadata item option\n", szModKey,
+                        pszValue);
+              }
+              msSetOutputFormatOption(format, szModKey, pszValue);
             }
+          }
         }
+      } else {
+        char szModKey[256];
+        snprintf(szModKey, sizeof(szModKey), "mdi_%s", pszGDALKey);
+        if (lp->debug >= MS_DEBUGLEVEL_VVV) {
+          msDebug("Setting GDAL %s=%s metadata item option\n", szModKey,
+                  pszValue);
+        }
+        msSetOutputFormatOption(format, szModKey, pszValue);
+      }
     }
+  }
 
-    // netCDF 3D output
-    // Tested in msautotest/wxs/wcs_netcdf_3d_output.map
-    std::string osExtraDimDataType;
-    if( bExtraDimValid && static_cast<int>(oMapExtraDimValues.size()) != nBands )
-    {
-        msDebug("One of the band lack a NETCDF_DIM_%s metadata item.",
-                osExtraDimName.c_str());
-        bExtraDimValid = false;
+  // netCDF 3D output
+  // Tested in msautotest/wxs/wcs_netcdf_3d_output.map
+  std::string osExtraDimDataType;
+  if (bExtraDimValid && static_cast<int>(oMapExtraDimValues.size()) != nBands) {
+    msDebug("One of the band lack a NETCDF_DIM_%s metadata item.",
+            osExtraDimName.c_str());
+    bExtraDimValid = false;
+  }
+  if (bExtraDimValid) {
+    for (const auto &keyValue : oMapExtraDimValues) {
+      const auto &osVal = keyValue.second;
+      const CPLValueType eType = CPLGetValueType(osVal.c_str());
+      if (eType == CPL_VALUE_STRING) {
+        osExtraDimDataType = "string";
+        break;
+      } else if (eType == CPL_VALUE_INTEGER) {
+        if (osExtraDimDataType.empty() || osExtraDimDataType == "integer") {
+          osExtraDimDataType = "integer";
+          const GIntBig nVal = CPLAtoGIntBig(osVal.c_str());
+          if (nVal > INT_MAX || nVal < INT_MIN) {
+            osExtraDimDataType = "integer64";
+          }
+        }
+      } else {
+        osExtraDimDataType = "double";
+      }
+    }
+    if (osExtraDimDataType == "string") {
+      msDebug("One of the value for the NETCDF_DIM_%s metadata is a string. "
+              "This is not supported",
+              osExtraDimName.c_str());
+      bExtraDimValid = false;
     }
-    if( bExtraDimValid )
+  }
+  if (bExtraDimValid) {
+    // Cf
+    // https://gdal.org/drivers/raster/netcdf.html#creation-of-multidimensional-files-with-createcopy-2d-raster-api
+
+    // Define the name of the extra dimensions
     {
-        for( const auto& keyValue: oMapExtraDimValues )
-        {
-            const auto& osVal = keyValue.second;
-            const CPLValueType eType = CPLGetValueType(osVal.c_str());
-            if( eType == CPL_VALUE_STRING )
-            {
-                osExtraDimDataType = "string";
-                break;
-            }
-            else if( eType == CPL_VALUE_INTEGER )
-            {
-                if( osExtraDimDataType.empty() || osExtraDimDataType == "integer" )
-                {
-                    osExtraDimDataType = "integer";
-                    const GIntBig nVal = CPLAtoGIntBig(osVal.c_str());
-                    if( nVal > INT_MAX || nVal < INT_MIN )
-                    {
-                        osExtraDimDataType = "integer64";
-                    }
-                }
-            }
-            else
-            {
-                osExtraDimDataType = "double";
-            }
-        }
-        if( osExtraDimDataType == "string" )
-        {
-            msDebug("One of the value for the NETCDF_DIM_%s metadata is a string. "
-                    "This is not supported", osExtraDimName.c_str());
-            bExtraDimValid = false;
-        }
+      std::string osValue;
+      osValue = '{';
+      osValue += osExtraDimName;
+      osValue += '}';
+
+      msSetOutputFormatOption(format, "mdi_default_NETCDF_DIM_EXTRA",
+                              osValue.c_str());
     }
-    if( bExtraDimValid )
+
+    // Define the size (in number of samples) and type of the extra dimension
     {
-        // Cf https://gdal.org/drivers/raster/netcdf.html#creation-of-multidimensional-files-with-createcopy-2d-raster-api
+      std::string osKey;
+      osKey = "mdi_default_NETCDF_DIM_";
+      osKey += osExtraDimName;
+      osKey += "_DEF";
+
+      std::string osValue;
+      osValue = '{';
+      osValue += CPLSPrintf("%d", nBands);
+      osValue += ',';
+      if (osExtraDimDataType == "integer")
+        osValue += '4';
+      else if (osExtraDimDataType == "integer64")
+        osValue += "10";
+      else /* if ( osExtraDimDataType == "double" ) */
+        osValue += '6';
+      osValue += '}';
 
-        // Define the name of the extra dimensions
-        {
-            std::string osValue;
-            osValue = '{';
-            osValue += osExtraDimName;
-            osValue += '}';
-
-            msSetOutputFormatOption(format, "mdi_default_NETCDF_DIM_EXTRA", osValue.c_str());
-        }
-
-        // Define the size (in number of samples) and type of the extra dimension
-        {
-            std::string osKey;
-            osKey = "mdi_default_NETCDF_DIM_";
-            osKey += osExtraDimName;
-            osKey += "_DEF";
-
-            std::string osValue;
-            osValue = '{';
-            osValue += CPLSPrintf("%d", nBands);
-            osValue += ',';
-            if( osExtraDimDataType == "integer" )
-                osValue += '4';
-            else if ( osExtraDimDataType == "integer64" )
-                osValue += "10";
-            else /* if ( osExtraDimDataType == "double" ) */
-                osValue += '6';
-            osValue += '}';
-
-            msSetOutputFormatOption(format, osKey.c_str(), osValue.c_str());
-        }
-
-        // Define the values along the extra dimension
-        {
-            std::string osKey;
-            osKey = "mdi_default_NETCDF_DIM_";
-            osKey += osExtraDimName;
-            osKey += "_VALUES";
-            std::string osValue;
-            osValue = '{';
-            bool bFirstVal = true;
-            for( const auto& keyValue: oMapExtraDimValues )
-            {
-                const auto& osVal = keyValue.second;
-                if( !bFirstVal )
-                    osValue += ',';
-                else
-                    bFirstVal = false;
-                osValue += osVal;
-            }
-            osValue += '}';
+      msSetOutputFormatOption(format, osKey.c_str(), osValue.c_str());
+    }
 
-            msSetOutputFormatOption(format, osKey.c_str(), osValue.c_str());
-        }
+    // Define the values along the extra dimension
+    {
+      std::string osKey;
+      osKey = "mdi_default_NETCDF_DIM_";
+      osKey += osExtraDimName;
+      osKey += "_VALUES";
+      std::string osValue;
+      osValue = '{';
+      bool bFirstVal = true;
+      for (const auto &keyValue : oMapExtraDimValues) {
+        const auto &osVal = keyValue.second;
+        if (!bFirstVal)
+          osValue += ',';
+        else
+          bFirstVal = false;
+        osValue += osVal;
+      }
+      osValue += '}';
+
+      msSetOutputFormatOption(format, osKey.c_str(), osValue.c_str());
     }
+  }
 
-    msFreeCharArray( papszBandNumbers, nBands );
+  msFreeCharArray(papszBandNumbers, nBands);
 }
 
 /************************************************************************/
 /*               msWCSApplySourceDatasetMetadata()                      */
 /************************************************************************/
 
-void msWCSApplySourceDatasetMetadata(layerObj* lp,
-                                     outputFormatObj* format,
-                                     const char* bandlist,
-                                     void* hDSIn)
-{
-    /* Automatic forwarding of input dataset metadata if it is netCDF and the */
-    /* output is netCDF as well, and wcs_outputformat_netCDF_mdi* are */
-    /* not defined. */
-    GDALDatasetH hDS = (GDALDatasetH)hDSIn;
-    if( hDS && GDALGetDatasetDriver(hDS) &&
-        EQUAL(GDALGetDriverShortName(GDALGetDatasetDriver(hDS)), "netCDF") &&
-        EQUAL(format->driver, "GDAL/netCDF") )
-    {
-        const char* pszKey;
-        char szKeyBeginning[256];
-        size_t nKeyBeginningLength;
-        int bWCSMetadataFound = MS_FALSE;
-
-        snprintf(szKeyBeginning, sizeof(szKeyBeginning),
-                "wcs_outputformat_%s_mdi_", format->name);
-        nKeyBeginningLength = strlen(szKeyBeginning);
-
-        for( pszKey = msFirstKeyFromHashTable( &(lp->metadata) );
-             pszKey != NULL;
-             pszKey = msNextKeyFromHashTable( &(lp->metadata), pszKey) )
-        {
-            if( strncmp(pszKey, szKeyBeginning, nKeyBeginningLength) == 0 )
-            {
-                bWCSMetadataFound = MS_TRUE;
-                break;
+void msWCSApplySourceDatasetMetadata(layerObj *lp, outputFormatObj *format,
+                                     const char *bandlist, void *hDSIn) {
+  /* Automatic forwarding of input dataset metadata if it is netCDF and the */
+  /* output is netCDF as well, and wcs_outputformat_netCDF_mdi* are */
+  /* not defined. */
+  GDALDatasetH hDS = (GDALDatasetH)hDSIn;
+  if (hDS && GDALGetDatasetDriver(hDS) &&
+      EQUAL(GDALGetDriverShortName(GDALGetDatasetDriver(hDS)), "netCDF") &&
+      EQUAL(format->driver, "GDAL/netCDF")) {
+    const char *pszKey;
+    char szKeyBeginning[256];
+    size_t nKeyBeginningLength;
+    int bWCSMetadataFound = MS_FALSE;
+
+    snprintf(szKeyBeginning, sizeof(szKeyBeginning), "wcs_outputformat_%s_mdi_",
+             format->name);
+    nKeyBeginningLength = strlen(szKeyBeginning);
+
+    for (pszKey = msFirstKeyFromHashTable(&(lp->metadata)); pszKey != NULL;
+         pszKey = msNextKeyFromHashTable(&(lp->metadata), pszKey)) {
+      if (strncmp(pszKey, szKeyBeginning, nKeyBeginningLength) == 0) {
+        bWCSMetadataFound = MS_TRUE;
+        break;
+      }
+    }
+    if (!bWCSMetadataFound) {
+      int nBands = 0;
+      char **papszBandNumbers = msStringSplit(bandlist, ',', &nBands);
+
+      std::string osExtraDimName;
+      // Special processing if the input dataset is a 3D one
+      {
+        // Check if extra dimensions are declared on the source dataset,
+        // and if so, if there's just a single one.
+        const char *pszDimExtraWithCurl =
+            GDALGetMetadataItem(hDS, "NETCDF_DIM_EXTRA", nullptr);
+        if (pszDimExtraWithCurl &&
+            strchr(pszDimExtraWithCurl, ',') == nullptr &&
+            pszDimExtraWithCurl[0] == '{' &&
+            pszDimExtraWithCurl[strlen(pszDimExtraWithCurl) - 1] == '}') {
+          osExtraDimName.append(pszDimExtraWithCurl + 1,
+                                strlen(pszDimExtraWithCurl) - 2);
+
+          // Declare the extra dimension name
+          msSetOutputFormatOption(format, "mdi_default_NETCDF_DIM_EXTRA",
+                                  pszDimExtraWithCurl);
+
+          // Declare the extra dimension definition: size + data type
+          const char *pszDimExtraDef = GDALGetMetadataItem(
+              hDS, ("NETCDF_DIM_" + osExtraDimName + "_DEF").c_str(), nullptr);
+          if (pszDimExtraDef && pszDimExtraDef[0] == '{' &&
+              pszDimExtraDef[strlen(pszDimExtraDef) - 1] == '}') {
+            const auto tokens = msStringSplit(
+                std::string(pszDimExtraDef + 1, strlen(pszDimExtraDef) - 2)
+                    .c_str(),
+                ',');
+            if (tokens.size() == 2) {
+              const auto varType = tokens[1];
+              msSetOutputFormatOption(
+                  format,
+                  ("mdi_default_NETCDF_DIM_" + osExtraDimName + "_DEF").c_str(),
+                  (std::string("{") + CPLSPrintf("%d", nBands) + ',' + varType +
+                   '}')
+                      .c_str());
             }
-        }
-        if( !bWCSMetadataFound )
-        {
-            int nBands = 0;
-            char** papszBandNumbers = msStringSplit(bandlist, ',', &nBands);
-
-            std::string osExtraDimName;
-            // Special processing if the input dataset is a 3D one
-            {
-                // Check if extra dimensions are declared on the source dataset,
-                // and if so, if there's just a single one.
-                const char* pszDimExtraWithCurl = GDALGetMetadataItem(hDS, "NETCDF_DIM_EXTRA", nullptr);
-                if( pszDimExtraWithCurl &&
-                    strchr(pszDimExtraWithCurl, ',') == nullptr &&
-                    pszDimExtraWithCurl[0] == '{' &&
-                    pszDimExtraWithCurl[strlen(pszDimExtraWithCurl)-1] == '}')
-                {
-                    osExtraDimName.append(
-                        pszDimExtraWithCurl + 1, strlen(pszDimExtraWithCurl) - 2);
-
-                    // Declare the extra dimension name
-                    msSetOutputFormatOption(format,
-                                            "mdi_default_NETCDF_DIM_EXTRA",
-                                            pszDimExtraWithCurl);
-
-                    // Declare the extra dimension definition: size + data type
-                    const char* pszDimExtraDef = GDALGetMetadataItem(hDS,
-                         ("NETCDF_DIM_" + osExtraDimName + "_DEF").c_str(), nullptr);
-                    if( pszDimExtraDef && pszDimExtraDef[0] == '{' &&
-                        pszDimExtraDef[strlen(pszDimExtraDef)-1] == '}' )
-                    {
-                        const auto tokens = msStringSplit(
-                            std::string(pszDimExtraDef + 1, strlen(pszDimExtraDef) -2).c_str(), ',');
-                        if( tokens.size() == 2 )
-                        {
-                            const auto varType = tokens[1];
-                            msSetOutputFormatOption(format,
-                                ("mdi_default_NETCDF_DIM_" + osExtraDimName + "_DEF").c_str(),
-                                (std::string("{") + CPLSPrintf("%d", nBands) + ',' + varType + '}').c_str());
-                        }
-                    }
-
-                    // Declare the extra dimension values
-                    const char* pszDimExtraValues = GDALGetMetadataItem(hDS,
-                         ("NETCDF_DIM_" + osExtraDimName + "_VALUES").c_str(), nullptr);
-                    if( pszDimExtraValues && pszDimExtraValues[0] == '{' &&
-                        pszDimExtraValues[strlen(pszDimExtraValues)-1] == '}' )
-                    {
-                        const auto tokens = msStringSplit(
-                            std::string(pszDimExtraValues + 1, strlen(pszDimExtraValues) -2).c_str(), ',');
-                        if( static_cast<int>(tokens.size()) == GDALGetRasterCount(hDS) )
-                        {
-                            std::string osValue = "{";
-                            for(int i = 0; i < nBands; i++ )
-                            {
-                                int nSrcBand = atoi(papszBandNumbers[i]);
-                                assert( nSrcBand >= 1 && nSrcBand <= static_cast<int>(tokens.size()) );
-                                if( i > 0 )
-                                    osValue += ',';
-                                osValue += tokens[nSrcBand - 1];
-                            }
-                            osValue += '}';
-
-                            msSetOutputFormatOption(format,
-                                ("mdi_default_NETCDF_DIM_" + osExtraDimName + "_VALUES").c_str(),
-                                osValue.c_str());
-                        }
-                    }
-                    else if ( pszDimExtraValues )
-                    {
-                        // If there's a single value
-                        msSetOutputFormatOption(format,
-                                ("mdi_default_NETCDF_DIM_" + osExtraDimName + "_VALUES").c_str(),
-                                pszDimExtraValues);
-                    }
+          }
 
-                }
+          // Declare the extra dimension values
+          const char *pszDimExtraValues = GDALGetMetadataItem(
+              hDS, ("NETCDF_DIM_" + osExtraDimName + "_VALUES").c_str(),
+              nullptr);
+          if (pszDimExtraValues && pszDimExtraValues[0] == '{' &&
+              pszDimExtraValues[strlen(pszDimExtraValues) - 1] == '}') {
+            const auto tokens =
+                msStringSplit(std::string(pszDimExtraValues + 1,
+                                          strlen(pszDimExtraValues) - 2)
+                                  .c_str(),
+                              ',');
+            if (static_cast<int>(tokens.size()) == GDALGetRasterCount(hDS)) {
+              std::string osValue = "{";
+              for (int i = 0; i < nBands; i++) {
+                int nSrcBand = atoi(papszBandNumbers[i]);
+                assert(nSrcBand >= 1 &&
+                       nSrcBand <= static_cast<int>(tokens.size()));
+                if (i > 0)
+                  osValue += ',';
+                osValue += tokens[nSrcBand - 1];
+              }
+              osValue += '}';
+
+              msSetOutputFormatOption(
+                  format,
+                  ("mdi_default_NETCDF_DIM_" + osExtraDimName + "_VALUES")
+                      .c_str(),
+                  osValue.c_str());
             }
+          } else if (pszDimExtraValues) {
+            // If there's a single value
+            msSetOutputFormatOption(
+                format,
+                ("mdi_default_NETCDF_DIM_" + osExtraDimName + "_VALUES")
+                    .c_str(),
+                pszDimExtraValues);
+          }
+        }
+      }
 
-            {
-                char** papszMD = GDALGetMetadata(hDS, NULL);
-                if( papszMD )
-                {
-                    for( char** papszIter = papszMD; *papszIter; ++papszIter )
-                    {
-                        // Copy netCDF global attributes, as well as the ones
-                        // of the extra dimension for 3D netCDF files
-                        if( STARTS_WITH(*papszIter, "NC_GLOBAL#") ||
-                            (!osExtraDimName.empty() &&
-                             STARTS_WITH(*papszIter, osExtraDimName.c_str()) &&
-                             (*papszIter)[osExtraDimName.size()] == '#') )
-                        {
-                            char* pszKey = nullptr;
-                            const char* pszValue = CPLParseNameValue(*papszIter, &pszKey);
-                            if( pszKey && pszValue )
-                            {
-                                char szKey[256];
-                                snprintf(szKey, sizeof(szKey),
-                                    "mdi_default_%s", pszKey);
-                                msSetOutputFormatOption(format, szKey, pszValue);
-                            }
-                            CPLFree(pszKey);
-                        }
-                    }
-                }
+      {
+        char **papszMD = GDALGetMetadata(hDS, NULL);
+        if (papszMD) {
+          for (char **papszIter = papszMD; *papszIter; ++papszIter) {
+            // Copy netCDF global attributes, as well as the ones
+            // of the extra dimension for 3D netCDF files
+            if (STARTS_WITH(*papszIter, "NC_GLOBAL#") ||
+                (!osExtraDimName.empty() &&
+                 STARTS_WITH(*papszIter, osExtraDimName.c_str()) &&
+                 (*papszIter)[osExtraDimName.size()] == '#')) {
+              char *pszKey = nullptr;
+              const char *pszValue = CPLParseNameValue(*papszIter, &pszKey);
+              if (pszKey && pszValue) {
+                char szKey[256];
+                snprintf(szKey, sizeof(szKey), "mdi_default_%s", pszKey);
+                msSetOutputFormatOption(format, szKey, pszValue);
+              }
+              CPLFree(pszKey);
             }
+          }
+        }
+      }
 
-            for(int i = 0; i < nBands; i++ )
-            {
-                int nSrcBand = atoi(papszBandNumbers[i]);
-                int nDstBand = i + 1;
-                GDALRasterBandH hBand = GDALGetRasterBand(hDS, nSrcBand);
-                if( hBand )
-                {
-                    char** papszMD = GDALGetMetadata(hBand, NULL);
-                    if( papszMD )
-                    {
-                        for( char** papszIter = papszMD; *papszIter; ++papszIter )
-                        {
-                            char* pszKey = nullptr;
-                            const char* pszValue = CPLParseNameValue(*papszIter, &pszKey);
-                            if( pszKey && pszValue &&
-                                !EQUAL(pszKey, "grid_name") &&
-                                !EQUAL(pszKey, "grid_mapping") )
-                            {
-                                char szKey[256];
-                                snprintf(szKey, sizeof(szKey),
-                                    "mdi_BAND_%d_default_%s",
-                                    nDstBand, pszKey);
-                                msSetOutputFormatOption(format, szKey, pszValue);
-                            }
-                            CPLFree(pszKey);
-                        }
-                    }
-                }
+      for (int i = 0; i < nBands; i++) {
+        int nSrcBand = atoi(papszBandNumbers[i]);
+        int nDstBand = i + 1;
+        GDALRasterBandH hBand = GDALGetRasterBand(hDS, nSrcBand);
+        if (hBand) {
+          char **papszMD = GDALGetMetadata(hBand, NULL);
+          if (papszMD) {
+            for (char **papszIter = papszMD; *papszIter; ++papszIter) {
+              char *pszKey = nullptr;
+              const char *pszValue = CPLParseNameValue(*papszIter, &pszKey);
+              if (pszKey && pszValue && !EQUAL(pszKey, "grid_name") &&
+                  !EQUAL(pszKey, "grid_mapping")) {
+                char szKey[256];
+                snprintf(szKey, sizeof(szKey), "mdi_BAND_%d_default_%s",
+                         nDstBand, pszKey);
+                msSetOutputFormatOption(format, szKey, pszValue);
+              }
+              CPLFree(pszKey);
             }
-            msFreeCharArray( papszBandNumbers, nBands );
+          }
         }
+      }
+      msFreeCharArray(papszBandNumbers, nBands);
     }
+  }
 }
 
 /************************************************************************/
@@ -2150,16 +2361,16 @@ void msWCSApplySourceDatasetMetadata(lay
 /************************************************************************/
 
 static int msWCSGetCoverage(mapObj *map, cgiRequestObj *request,
-                            wcsParamsObj *params, owsRequestObj *ows_request)
-{
-  imageObj   *image;
-  layerObj   *lp;
-  int         status, i;
+                            wcsParamsObj *params, owsRequestObj *ows_request) {
+  imageObj *image;
+  layerObj *lp;
+  int status, i;
   const char *value;
   outputFormatObj *format;
-  char *bandlist=NULL;
+  char *bandlist = NULL;
   size_t bufferSize = 0;
-  char numbands[12]; /* should be large enough to hold the number of bands in the bandlist */
+  char numbands[12]; /* should be large enough to hold the number of bands in
+                        the bandlist */
   coverageMetadataObj cm;
   rectObj reqextent;
   rectObj covextent;
@@ -2170,111 +2381,123 @@ static int msWCSGetCoverage(mapObj *map,
   char *coverageName;
 
   /* make sure all required parameters are available (at least the easy ones) */
-  if(!params->crs) {
-    msSetError( MS_WCSERR, "Required parameter CRS was not supplied.", "msWCSGetCoverage()");
+  if (!params->crs) {
+    msSetError(MS_WCSERR, "Required parameter CRS was not supplied.",
+               "msWCSGetCoverage()");
     return msWCSException(map, "MissingParameterValue", "crs", params->version);
   }
 
-  if(!params->time && !params->bbox.minx && !params->bbox.miny
-      && !params->bbox.maxx && !params->bbox.maxy) {
-    msSetError(MS_WCSERR, "One of BBOX or TIME is required", "msWCSGetCoverage()");
-    return msWCSException(map, "MissingParameterValue", "bbox/time", params->version);
+  if (!params->time && !params->bbox.minx && !params->bbox.miny &&
+      !params->bbox.maxx && !params->bbox.maxy) {
+    msSetError(MS_WCSERR, "One of BBOX or TIME is required",
+               "msWCSGetCoverage()");
+    return msWCSException(map, "MissingParameterValue", "bbox/time",
+                          params->version);
   }
 
-  if( params->coverages == NULL || params->coverages[0] == NULL ) {
-    msSetError( MS_WCSERR,
-                "Required parameter COVERAGE was not supplied.",
-                "msWCSGetCoverage()");
-    return msWCSException(map, "MissingParameterValue", "coverage", params->version);
+  if (params->coverages == NULL || params->coverages[0] == NULL) {
+    msSetError(MS_WCSERR, "Required parameter COVERAGE was not supplied.",
+               "msWCSGetCoverage()");
+    return msWCSException(map, "MissingParameterValue", "coverage",
+                          params->version);
   }
 
   /* For WCS 1.1, we need to normalize the axis order of the BBOX and
      resolution values some coordinate systems (eg. EPSG geographic) */
-  if( strncasecmp(params->version,"1.0",3) != 0
-      && params->crs != NULL
-      && strncasecmp(params->crs,"urn:",4) == 0 ) {
+  if (strncasecmp(params->version, "1.0", 3) != 0 && params->crs != NULL &&
+      strncasecmp(params->crs, "urn:", 4) == 0) {
     projectionObj proj;
 
-    msInitProjection( &proj );
+    msInitProjection(&proj);
     msProjectionInheritContextFrom(&proj, &(map->projection));
-    if( msLoadProjectionString( &proj, (char *) params->crs ) == 0 ) {
-      msAxisNormalizePoints( &proj, 1,
-                             &(params->bbox.minx),
-                             &(params->bbox.miny) );
-      msAxisNormalizePoints( &proj, 1,
-                             &(params->bbox.maxx),
-                             &(params->bbox.maxy) );
-      msAxisNormalizePoints( &proj, 1,
-                             &(params->resx),
-                             &(params->resy) );
-      msAxisNormalizePoints( &proj, 1,
-                             &(params->originx),
-                             &(params->originy) );
+    if (msLoadProjectionString(&proj, (char *)params->crs) == 0) {
+      msAxisNormalizePoints(&proj, 1, &(params->bbox.minx),
+                            &(params->bbox.miny));
+      msAxisNormalizePoints(&proj, 1, &(params->bbox.maxx),
+                            &(params->bbox.maxy));
+      msAxisNormalizePoints(&proj, 1, &(params->resx), &(params->resy));
+      msAxisNormalizePoints(&proj, 1, &(params->originx), &(params->originy));
     } else
       msResetErrorList();
-    msFreeProjection( &proj );
+    msFreeProjection(&proj);
   }
 
   /* find the layer we are working with */
   lp = NULL;
-  for(i=0; i<map->numlayers; i++) {
-    coverageName = msOWSGetEncodeMetadata(&(GET_LAYER(map, i)->metadata), "CO", "name", GET_LAYER(map, i)->name);
-    if( coverageName != NULL && EQUAL(coverageName, params->coverages[0]) &&
-        (msIntegerInArray(GET_LAYER(map, i)->index, ows_request->enabled_layers, ows_request->numlayers)) ) {
+  for (i = 0; i < map->numlayers; i++) {
+    coverageName = msOWSGetEncodeMetadata(&(GET_LAYER(map, i)->metadata), "CO",
+                                          "name", GET_LAYER(map, i)->name);
+    if (coverageName != NULL && EQUAL(coverageName, params->coverages[0]) &&
+        (msIntegerInArray(GET_LAYER(map, i)->index, ows_request->enabled_layers,
+                          ows_request->numlayers))) {
       lp = GET_LAYER(map, i);
-      free( coverageName );
+      free(coverageName);
       break;
     }
-    free( coverageName );
+    free(coverageName);
   }
 
-  if(lp == NULL) {
-    msSetError( MS_WCSERR, "COVERAGE=%s not found, not in supported layer list. A layer might be disabled for \
-this request. Check wcs/ows_enable_request settings.", "msWCSGetCoverage()", params->coverages[0] );
-    return msWCSException(map, "InvalidParameterValue", "coverage", params->version);
+  if (lp == NULL) {
+    msSetError(
+        MS_WCSERR,
+        "COVERAGE=%s not found, not in supported layer list. A layer might be disabled for \
+this request. Check wcs/ows_enable_request settings.",
+        "msWCSGetCoverage()", params->coverages[0]);
+    return msWCSException(map, "InvalidParameterValue", "coverage",
+                          params->version);
   }
 
   /* make sure the layer is on */
   lp->status = MS_ON;
-  
-  /* If the layer has no projection set, set it to the map's projection (#4079) */
-  if(lp->projection.numargs <=0) {
+
+  /* If the layer has no projection set, set it to the map's projection (#4079)
+   */
+  if (lp->projection.numargs <= 0) {
     char *map_original_srs = msGetProjectionString(&(map->projection));
     if (msLoadProjectionString(&(lp->projection), map_original_srs) != 0) {
-      msSetError( MS_WCSERR, "Error when setting map projection to a layer with no projection", "msWCSGetCoverage()" );
+      msSetError(
+          MS_WCSERR,
+          "Error when setting map projection to a layer with no projection",
+          "msWCSGetCoverage()");
       free(map_original_srs);
       return msWCSException(map, NULL, NULL, params->version);
     }
     free(map_original_srs);
   }
 
-  /* we need the coverage metadata, since things like numbands may not be available otherwise */
+  /* we need the coverage metadata, since things like numbands may not be
+   * available otherwise */
   status = msWCSGetCoverageMetadata(lp, &cm);
-  if(status != MS_SUCCESS) return MS_FAILURE;
+  if (status != MS_SUCCESS)
+    return MS_FAILURE;
 
   /* fill in bands rangeset info, if required.  */
   msWCSSetDefaultBandsRangeSetInfo(params, &cm, lp);
 
   /* handle the response CRS, that is, set the map object projection */
-  if(params->response_crs || params->crs ) {
+  if (params->response_crs || params->crs) {
     int iUnits;
     const char *crs_to_use = params->response_crs;
 
-    if( crs_to_use == NULL )
+    if (crs_to_use == NULL)
       crs_to_use = params->crs;
 
-    if (strncasecmp(crs_to_use, "EPSG:", 5) == 0 || strncasecmp(crs_to_use,"urn:ogc:def:crs:",16) == 0 ) {
-      if (msLoadProjectionString(&(map->projection), (char *) crs_to_use) != 0)
-        return msWCSException( map, NULL, NULL,params->version);
-    } else if( strcasecmp(crs_to_use,"imageCRS") == 0 ) {
+    if (strncasecmp(crs_to_use, "EPSG:", 5) == 0 ||
+        strncasecmp(crs_to_use, "urn:ogc:def:crs:", 16) == 0) {
+      if (msLoadProjectionString(&(map->projection), (char *)crs_to_use) != 0)
+        return msWCSException(map, NULL, NULL, params->version);
+    } else if (strcasecmp(crs_to_use, "imageCRS") == 0) {
       /* use layer native CRS, and rework bounding box accordingly */
-      if( msWCSGetCoverage_ImageCRSSetup( map, params, &cm, lp ) != MS_SUCCESS ) {
+      if (msWCSGetCoverage_ImageCRSSetup(map, params, &cm, lp) != MS_SUCCESS) {
         msWCSFreeCoverageMetadata(&cm);
         return MS_FAILURE;
       }
-    } else {  /* should we support WMS style AUTO: projections? (not for now) */
-      msSetError(MS_WCSERR, "Unsupported SRS namespace (only EPSG currently supported).", "msWCSGetCoverage()");
-      return msWCSException(map, "InvalidParameterValue", "srs", params->version);
+    } else { /* should we support WMS style AUTO: projections? (not for now) */
+      msSetError(MS_WCSERR,
+                 "Unsupported SRS namespace (only EPSG currently supported).",
+                 "msWCSGetCoverage()");
+      return msWCSException(map, "InvalidParameterValue", "srs",
+                            params->version);
     }
 
     iUnits = GetMapserverUnitUsingProj(&(map->projection));
@@ -2283,49 +2506,65 @@ this request. Check wcs/ows_enable_reque
   }
 
   /* did we get a TIME value (support only a single value for now) */
-  if(params->time) {
+  if (params->time) {
     int tli;
-    layerObj *tlp=NULL;
+    layerObj *tlp = NULL;
 
     /* need to handle NOW case */
 
     /* check format of TIME parameter */
-    if(strchr(params->time, ',')) {
+    if (strchr(params->time, ',')) {
       msWCSFreeCoverageMetadata(&cm);
-      msSetError( MS_WCSERR, "Temporal lists are not supported, only individual values.", "msWCSGetCoverage()" );
-      return msWCSException(map, "InvalidParameterValue", "time", params->version);
+      msSetError(MS_WCSERR,
+                 "Temporal lists are not supported, only individual values.",
+                 "msWCSGetCoverage()");
+      return msWCSException(map, "InvalidParameterValue", "time",
+                            params->version);
     }
-    if(strchr(params->time, '/')) {
+    if (strchr(params->time, '/')) {
       msWCSFreeCoverageMetadata(&cm);
-      msSetError( MS_WCSERR, "Temporal ranges are not supported, only individual values.", "msWCSGetCoverage()" );
-      return msWCSException(map, "InvalidParameterValue", "time", params->version);
+      msSetError(MS_WCSERR,
+                 "Temporal ranges are not supported, only individual values.",
+                 "msWCSGetCoverage()");
+      return msWCSException(map, "InvalidParameterValue", "time",
+                            params->version);
     }
 
     /* TODO: will need to expand this check if a time period is supported */
     value = msOWSLookupMetadata(&(lp->metadata), "CO", "timeposition");
-    if(!value) {
+    if (!value) {
       msWCSFreeCoverageMetadata(&cm);
-      msSetError( MS_WCSERR, "The coverage does not support temporal subsetting.", "msWCSGetCoverage()" );
-      return msWCSException(map, "InvalidParameterValue", "time", params->version );
+      msSetError(MS_WCSERR,
+                 "The coverage does not support temporal subsetting.",
+                 "msWCSGetCoverage()");
+      return msWCSException(map, "InvalidParameterValue", "time",
+                            params->version);
     }
 
     /* check if timestamp is covered by the wcs_timeposition definition */
     if (msValidateTimeValue(params->time, value) == MS_FALSE) {
       msWCSFreeCoverageMetadata(&cm);
-      msSetError( MS_WCSERR, "The coverage does not have a time position of %s.", "msWCSGetCoverage()", params->time );
-      return msWCSException(map, "InvalidParameterValue", "time", params->version);
+      msSetError(MS_WCSERR, "The coverage does not have a time position of %s.",
+                 "msWCSGetCoverage()", params->time);
+      return msWCSException(map, "InvalidParameterValue", "time",
+                            params->version);
     }
 
     /* make sure layer is tiled appropriately */
-    if(!lp->tileindex) {
+    if (!lp->tileindex) {
       msWCSFreeCoverageMetadata(&cm);
-      msSetError( MS_WCSERR, "Underlying layer is not tiled, unable to do temporal subsetting.", "msWCSGetCoverage()" );
+      msSetError(
+          MS_WCSERR,
+          "Underlying layer is not tiled, unable to do temporal subsetting.",
+          "msWCSGetCoverage()");
       return msWCSException(map, NULL, NULL, params->version);
     }
     tli = msGetLayerIndex(map, lp->tileindex);
-    if(tli == -1) {
+    if (tli == -1) {
       msWCSFreeCoverageMetadata(&cm);
-      msSetError( MS_WCSERR, "Underlying layer does not use appropriate tiling mechanism.", "msWCSGetCoverage()" );
+      msSetError(MS_WCSERR,
+                 "Underlying layer does not use appropriate tiling mechanism.",
+                 "msWCSGetCoverage()");
       return msWCSException(map, NULL, NULL, params->version);
     }
 
@@ -2333,15 +2572,17 @@ this request. Check wcs/ows_enable_reque
 
     /* make sure there is enough information to filter */
     value = msOWSLookupMetadata(&(lp->metadata), "CO", "timeitem");
-    if(!tlp->filteritem && !value) {
+    if (!tlp->filteritem && !value) {
       msWCSFreeCoverageMetadata(&cm);
-      msSetError( MS_WCSERR, "Not enough information available to filter.", "msWCSGetCoverage()" );
+      msSetError(MS_WCSERR, "Not enough information available to filter.",
+                 "msWCSGetCoverage()");
       return msWCSException(map, NULL, NULL, params->version);
     }
 
     /* override filteritem if specified in metadata */
-    if(value) {
-      if(tlp->filteritem) free(tlp->filteritem);
+    if (value) {
+      if (tlp->filteritem)
+        free(tlp->filteritem);
       tlp->filteritem = msStrdup(value);
     }
 
@@ -2349,108 +2590,133 @@ this request. Check wcs/ows_enable_reque
     msLayerSetTimeFilter(tlp, params->time, value);
   }
 
-  if( strncasecmp(params->version,"1.0",3) == 0 )
-    status = msWCSGetCoverageBands10( map, request, params, lp, &bandlist );
+  if (strncasecmp(params->version, "1.0", 3) == 0)
+    status = msWCSGetCoverageBands10(map, request, params, lp, &bandlist);
   else
-    status = msWCSGetCoverageBands11( map, request, params, lp, &bandlist );
-  if( status != MS_SUCCESS ) {
+    status = msWCSGetCoverageBands11(map, request, params, lp, &bandlist);
+  if (status != MS_SUCCESS) {
     msWCSFreeCoverageMetadata(&cm);
     return status;
   }
 
-  /* did we get BBOX values? if not use the exent stored in the coverageMetadataObj */
-  if( fabs((params->bbox.maxx - params->bbox.minx)) < 0.000000000001  || fabs(params->bbox.maxy - params->bbox.miny) < 0.000000000001 ) {
+  /* did we get BBOX values? if not use the exent stored in the
+   * coverageMetadataObj */
+  if (fabs((params->bbox.maxx - params->bbox.minx)) < 0.000000000001 ||
+      fabs(params->bbox.maxy - params->bbox.miny) < 0.000000000001) {
     params->bbox = cm.extent;
 
     /* WCS 1.1 boundbox is center of pixel oriented. */
-    if( strncasecmp(params->version,"1.1",3) == 0 ) {
-      params->bbox.minx += cm.geotransform[1]/2 + cm.geotransform[2]/2;
-      params->bbox.maxx -= cm.geotransform[1]/2 + cm.geotransform[2]/2;
-      params->bbox.maxy += cm.geotransform[4]/2 + cm.geotransform[5]/2;
-      params->bbox.miny -= cm.geotransform[4]/2 + cm.geotransform[5]/2;
+    if (strncasecmp(params->version, "1.1", 3) == 0) {
+      params->bbox.minx += cm.geotransform[1] / 2 + cm.geotransform[2] / 2;
+      params->bbox.maxx -= cm.geotransform[1] / 2 + cm.geotransform[2] / 2;
+      params->bbox.maxy += cm.geotransform[4] / 2 + cm.geotransform[5] / 2;
+      params->bbox.miny -= cm.geotransform[4] / 2 + cm.geotransform[5] / 2;
     }
   }
 
   /* WCS 1.1+ GridOrigin is effectively resetting the minx/maxy
      BOUNDINGBOX values, so apply that here */
-  if( params->originx != 0.0 || params->originy != 0.0 ) {
-    assert( strncasecmp(params->version,"1.0",3) != 0 ); /* should always be 1.0 in this logic. */
+  if (params->originx != 0.0 || params->originy != 0.0) {
+    assert(strncasecmp(params->version, "1.0", 3) !=
+           0); /* should always be 1.0 in this logic. */
     params->bbox.minx = params->originx;
     params->bbox.maxy = params->originy;
   }
 
   /* if necessary, project the BBOX to the map->projection */
-  if(params->response_crs && params->crs) {
+  if (params->response_crs && params->crs) {
     projectionObj tmp_proj;
 
     msInitProjection(&tmp_proj);
     msProjectionInheritContextFrom(&tmp_proj, &(map->projection));
-    if (msLoadProjectionString(&tmp_proj, (char *) params->crs) != 0) {
+    if (msLoadProjectionString(&tmp_proj, (char *)params->crs) != 0) {
       msWCSFreeCoverageMetadata(&cm);
-      return msWCSException( map, NULL, NULL, params->version);
+      return msWCSException(map, NULL, NULL, params->version);
     }
     msProjectRect(&tmp_proj, &map->projection, &(params->bbox));
     msFreeProjection(&tmp_proj);
   }
 
   /* in WCS 1.1 the default is full resolution */
-  if( strncasecmp(params->version,"1.1",3) == 0 && params->resx == 0.0 && params->resy == 0.0 ) {
+  if (strncasecmp(params->version, "1.1", 3) == 0 && params->resx == 0.0 &&
+      params->resy == 0.0) {
     params->resx = cm.geotransform[1];
     params->resy = fabs(cm.geotransform[5]);
   }
 
   /* compute width/height from BBOX and cellsize.  */
-  if( (params->resx == 0.0 || params->resy == 0.0) && params->width != 0 && params->height != 0 ) {
-    assert( strncasecmp(params->version,"1.0",3) == 0 ); /* should always be 1.0 in this logic. */
-    params->resx = (params->bbox.maxx -params->bbox.minx) / params->width;
-    params->resy = (params->bbox.maxy -params->bbox.miny) / params->height;
+  if ((params->resx == 0.0 || params->resy == 0.0) && params->width != 0 &&
+      params->height != 0) {
+    assert(strncasecmp(params->version, "1.0", 3) ==
+           0); /* should always be 1.0 in this logic. */
+    params->resx = (params->bbox.maxx - params->bbox.minx) / params->width;
+    params->resy = (params->bbox.maxy - params->bbox.miny) / params->height;
   }
 
   /* compute cellsize/res from bbox and raster size. */
-  if( (params->width == 0 || params->height == 0) && params->resx != 0 && params->resy != 0 ) {
+  if ((params->width == 0 || params->height == 0) && params->resx != 0 &&
+      params->resy != 0) {
 
     /* WCS 1.0 boundbox is edge of pixel oriented. */
-    if( strncasecmp(params->version,"1.0",3) == 0 ) {
-      params->width = (int) ((params->bbox.maxx - params->bbox.minx) / params->resx + 0.5);
-      params->height = (int) ((params->bbox.maxy - params->bbox.miny) / params->resy + 0.5);
+    if (strncasecmp(params->version, "1.0", 3) == 0) {
+      params->width =
+          (int)((params->bbox.maxx - params->bbox.minx) / params->resx + 0.5);
+      params->height =
+          (int)((params->bbox.maxy - params->bbox.miny) / params->resy + 0.5);
     } else {
-      params->width = (int) ((params->bbox.maxx - params->bbox.minx) / params->resx + 1.000001);
-      params->height = (int) ((params->bbox.maxy - params->bbox.miny) / params->resy + 1.000001);
+      params->width =
+          (int)((params->bbox.maxx - params->bbox.minx) / params->resx +
+                1.000001);
+      params->height =
+          (int)((params->bbox.maxy - params->bbox.miny) / params->resy +
+                1.000001);
 
       /* recompute bounding box so we get exactly the origin and
          resolution requested. */
-      params->bbox.maxx = params->bbox.minx + (params->width-1) * params->resx;
-      params->bbox.miny = params->bbox.maxy - (params->height-1) * params->resy;
+      params->bbox.maxx =
+          params->bbox.minx + (params->width - 1) * params->resx;
+      params->bbox.miny =
+          params->bbox.maxy - (params->height - 1) * params->resy;
     }
   }
 
   /* are we still underspecified?  */
-  if( (params->width == 0 || params->height == 0) && (params->resx == 0.0 || params->resy == 0.0 )) {
+  if ((params->width == 0 || params->height == 0) &&
+      (params->resx == 0.0 || params->resy == 0.0)) {
     msWCSFreeCoverageMetadata(&cm);
-    msSetError( MS_WCSERR, "A non-zero RESX/RESY or WIDTH/HEIGHT is required but neither was provided.", "msWCSGetCoverage()" );
-    return msWCSException(map, "MissingParameterValue", "width/height/resx/resy", params->version);
+    msSetError(MS_WCSERR,
+               "A non-zero RESX/RESY or WIDTH/HEIGHT is required but neither "
+               "was provided.",
+               "msWCSGetCoverage()");
+    return msWCSException(map, "MissingParameterValue",
+                          "width/height/resx/resy", params->version);
   }
 
   map->cellsize = params->resx;
 
   /* Do we need to force special handling?  */
-  if( fabs(params->resx/params->resy - 1.0) > 0.001 ) {
+  if (fabs(params->resx / params->resy - 1.0) > 0.001) {
     map->gt.need_geotransform = MS_TRUE;
-    if( map->debug ) msDebug( "RESX and RESY don't match.  Using geotransform/resample.\n");
+    if (map->debug)
+      msDebug("RESX and RESY don't match.  Using geotransform/resample.\n");
   }
 
   /* Do we have a specified interpolation method */
-  if( params->interpolation != NULL ) {
-    if( strncasecmp(params->interpolation,"NEAREST",7) == 0 )
+  if (params->interpolation != NULL) {
+    if (strncasecmp(params->interpolation, "NEAREST", 7) == 0)
       msLayerSetProcessingKey(lp, "RESAMPLE", "NEAREST");
-    else if( strcasecmp(params->interpolation,"BILINEAR") == 0 )
+    else if (strcasecmp(params->interpolation, "BILINEAR") == 0)
       msLayerSetProcessingKey(lp, "RESAMPLE", "BILINEAR");
-    else if( strcasecmp(params->interpolation,"AVERAGE") == 0 )
+    else if (strcasecmp(params->interpolation, "AVERAGE") == 0)
       msLayerSetProcessingKey(lp, "RESAMPLE", "AVERAGE");
     else {
       msWCSFreeCoverageMetadata(&cm);
-      msSetError( MS_WCSERR, "INTERPOLATION=%s specifies an unsupported interpolation method.", "msWCSGetCoverage()", params->interpolation );
-      return msWCSException(map, "InvalidParameterValue", "interpolation", params->version);
+      msSetError(
+          MS_WCSERR,
+          "INTERPOLATION=%s specifies an unsupported interpolation method.",
+          "msWCSGetCoverage()", params->interpolation);
+      return msWCSException(map, "InvalidParameterValue", "interpolation",
+                            params->version);
     }
   }
 
@@ -2459,34 +2725,38 @@ this request. Check wcs/ows_enable_reque
   map->height = params->height;
 
   /* Are we exceeding the MAXSIZE limit on result size? */
-  if(map->width > map->maxsize || map->height > map->maxsize ) {
+  if (map->width > map->maxsize || map->height > map->maxsize) {
     msWCSFreeCoverageMetadata(&cm);
-    msSetError(MS_WCSERR, "Raster size out of range, width and height of resulting coverage must be no more than MAXSIZE=%d.", "msWCSGetCoverage()", map->maxsize);
+    msSetError(MS_WCSERR,
+               "Raster size out of range, width and height of resulting "
+               "coverage must be no more than MAXSIZE=%d.",
+               "msWCSGetCoverage()", map->maxsize);
 
-    return msWCSException(map, "InvalidParameterValue",
-                          "width/height", params->version);
+    return msWCSException(map, "InvalidParameterValue", "width/height",
+                          params->version);
   }
 
   /* adjust OWS BBOX to MapServer's pixel model */
-  if( strncasecmp(params->version,"1.0",3) == 0 ) {
-    params->bbox.minx += params->resx*0.5;
-    params->bbox.miny += params->resy*0.5;
-    params->bbox.maxx -= params->resx*0.5;
-    params->bbox.maxy -= params->resy*0.5;
+  if (strncasecmp(params->version, "1.0", 3) == 0) {
+    params->bbox.minx += params->resx * 0.5;
+    params->bbox.miny += params->resy * 0.5;
+    params->bbox.maxx -= params->resx * 0.5;
+    params->bbox.maxy -= params->resy * 0.5;
   }
 
   map->extent = params->bbox;
 
-  map->cellsize = params->resx; /* pick one, MapServer only supports square cells (what about msAdjustExtent here!) */
+  map->cellsize = params->resx; /* pick one, MapServer only supports square
+                                   cells (what about msAdjustExtent here!) */
 
-  if( params->width == 1 || params->height == 1 )
-      msMapComputeGeotransformEx(map, params->resx, params->resy);
+  if (params->width == 1 || params->height == 1)
+    msMapComputeGeotransformEx(map, params->resx, params->resy);
   else
-      msMapComputeGeotransform(map);
+    msMapComputeGeotransform(map);
 
   /* Do we need to fake out stuff for rotated support? */
-  if( map->gt.need_geotransform )
-    msMapSetFakedExtent( map );
+  if (map->gt.need_geotransform)
+    msMapSetFakedExtent(map);
 
   map->projection.gt = map->gt;
 
@@ -2507,111 +2777,117 @@ this request. Check wcs/ows_enable_reque
   covextent.maxx = cm.extent.maxx;
   covextent.maxy = cm.extent.maxy;
 
-  if(msRectOverlap(&reqextent, &covextent) == MS_FALSE) {
+  if (msRectOverlap(&reqextent, &covextent) == MS_FALSE) {
     msWCSFreeCoverageMetadata(&cm);
-    msSetError(MS_WCSERR, "Requested BBOX (%.15g,%.15g,%.15g,%.15g) is outside requested coverage BBOX (%.15g,%.15g,%.15g,%.15g)",
-               "msWCSGetCoverage()",
-               reqextent.minx, reqextent.miny, reqextent.maxx, reqextent.maxy,
-               covextent.minx, covextent.miny, covextent.maxx, covextent.maxy);
+    msSetError(MS_WCSERR,
+               "Requested BBOX (%.15g,%.15g,%.15g,%.15g) is outside requested "
+               "coverage BBOX (%.15g,%.15g,%.15g,%.15g)",
+               "msWCSGetCoverage()", reqextent.minx, reqextent.miny,
+               reqextent.maxx, reqextent.maxy, covextent.minx, covextent.miny,
+               covextent.maxx, covextent.maxy);
     return msWCSException(map, "NoApplicableCode", "bbox", params->version);
   }
 
-  /* check and make sure there is a format, and that it's valid (TODO: make sure in the layer metadata) */
-  if(!params->format) {
+  /* check and make sure there is a format, and that it's valid (TODO: make sure
+   * in the layer metadata) */
+  if (!params->format) {
     msWCSFreeCoverageMetadata(&cm);
-    msSetError( MS_WCSERR,  "Missing required FORMAT parameter.", "msWCSGetCoverage()" );
-    return msWCSException(map, "MissingParameterValue", "format", params->version);
+    msSetError(MS_WCSERR, "Missing required FORMAT parameter.",
+               "msWCSGetCoverage()");
+    return msWCSException(map, "MissingParameterValue", "format",
+                          params->version);
   }
   msApplyDefaultOutputFormats(map);
-  if(msGetOutputFormatIndex(map,params->format) == -1) {
+  if (msGetOutputFormatIndex(map, params->format) == -1) {
     msWCSFreeCoverageMetadata(&cm);
-    msSetError( MS_WCSERR,  "Unrecognized value for the FORMAT parameter.", "msWCSGetCoverage()" );
+    msSetError(MS_WCSERR, "Unrecognized value for the FORMAT parameter.",
+               "msWCSGetCoverage()");
     return msWCSException(map, "InvalidParameterValue", "format",
-                          params->version );
+                          params->version);
   }
 
   /* create a temporary outputformat (we likely will need to tweak parts) */
-  format = msCloneOutputFormat(msSelectOutputFormat(map,params->format));
+  format = msCloneOutputFormat(msSelectOutputFormat(map, params->format));
   msApplyOutputFormat(&(map->outputformat), format, MS_NOOVERRIDE);
 
-  if(!bandlist) { /* build a bandlist (default is ALL bands) */
-    bufferSize = cm.bandcount*30+30;
-    bandlist = (char *) msSmallMalloc(bufferSize);
+  if (!bandlist) { /* build a bandlist (default is ALL bands) */
+    bufferSize = cm.bandcount * 30 + 30;
+    bandlist = (char *)msSmallMalloc(bufferSize);
     strcpy(bandlist, "1");
-    for(i = 1; i < cm.bandcount; i++)
-      snprintf(bandlist+strlen(bandlist), bufferSize-strlen(bandlist), ",%d", i+1);
+    for (i = 1; i < cm.bandcount; i++)
+      snprintf(bandlist + strlen(bandlist), bufferSize - strlen(bandlist),
+               ",%d", i + 1);
   }
 
   /* apply nullvalue to the output format object if we have it */
-  if((value = msOWSLookupMetadata(&(lp->metadata), "CO", "rangeset_nullvalue")) != NULL) {
-    msSetOutputFormatOption( map->outputformat, "NULLVALUE", value );
+  if ((value = msOWSLookupMetadata(&(lp->metadata), "CO",
+                                   "rangeset_nullvalue")) != NULL) {
+    msSetOutputFormatOption(map->outputformat, "NULLVALUE", value);
   }
 
   msLayerSetProcessingKey(lp, "BANDS", bandlist);
-  snprintf(numbands, sizeof(numbands), "%d", msCountChars(bandlist, ',')+1);
+  snprintf(numbands, sizeof(numbands), "%d", msCountChars(bandlist, ',') + 1);
   msSetOutputFormatOption(map->outputformat, "BAND_COUNT", numbands);
 
   msWCSApplyLayerCreationOptions(lp, map->outputformat, bandlist);
   msWCSApplyLayerMetadataItemOptions(lp, map->outputformat, bandlist);
 
-  if( lp->tileindex == NULL && lp->data != NULL &&
-      strlen(lp->data) > 0 &&
-      lp->connectiontype != MS_KERNELDENSITY )
-  {
-      if( msDrawRasterLayerLowCheckIfMustDraw(map, lp) )
-      {
-          char* decrypted_path = NULL;
-          char szPath[MS_MAXPATHLEN];
-          hDS = (GDALDatasetH)msDrawRasterLayerLowOpenDataset(
-                                    map, lp, lp->data, szPath, &decrypted_path);
-          msFree(decrypted_path);
-          if( hDS )
-          {
-            msWCSApplyDatasetMetadataAsCreationOptions(lp, map->outputformat, bandlist, hDS);
-            msWCSApplySourceDatasetMetadata(lp, map->outputformat, bandlist, hDS);
-          }
-      }
-      else
-      {
-          doDrawRasterLayerDraw = MS_FALSE;
+  if (lp->tileindex == NULL && lp->data != NULL && strlen(lp->data) > 0 &&
+      lp->connectiontype != MS_KERNELDENSITY) {
+    if (msDrawRasterLayerLowCheckIfMustDraw(map, lp)) {
+      char *decrypted_path = NULL;
+      char szPath[MS_MAXPATHLEN];
+      hDS = (GDALDatasetH)msDrawRasterLayerLowOpenDataset(
+          map, lp, lp->data, szPath, &decrypted_path);
+      msFree(decrypted_path);
+      if (hDS) {
+        msWCSApplyDatasetMetadataAsCreationOptions(lp, map->outputformat,
+                                                   bandlist, hDS);
+        msWCSApplySourceDatasetMetadata(lp, map->outputformat, bandlist, hDS);
       }
+    } else {
+      doDrawRasterLayerDraw = MS_FALSE;
+    }
   }
 
-  free( bandlist );
+  free(bandlist);
 
-  if(lp->mask) {
-    int maskLayerIdx = msGetLayerIndex(map,lp->mask);
+  if (lp->mask) {
+    int maskLayerIdx = msGetLayerIndex(map, lp->mask);
     layerObj *maskLayer;
     outputFormatObj *altFormat;
-    if(maskLayerIdx == -1) {
+    if (maskLayerIdx == -1) {
       msWCSFreeCoverageMetadata(&cm);
-      msSetError(MS_MISCERR, "Layer (%s) references unknown mask layer (%s)", "msDrawLayer()",
-                 lp->name,lp->mask);
+      msSetError(MS_MISCERR, "Layer (%s) references unknown mask layer (%s)",
+                 "msDrawLayer()", lp->name, lp->mask);
       msDrawRasterLayerLowCloseDataset(lp, hDS);
-      return msWCSException(map, NULL, NULL, params->version );
+      return msWCSException(map, NULL, NULL, params->version);
     }
     maskLayer = GET_LAYER(map, maskLayerIdx);
-    if(!maskLayer->maskimage) {
-      int i,retcode;
+    if (!maskLayer->maskimage) {
+      int i, retcode;
       int origstatus, origlabelcache;
       char *origImageType = msStrdup(map->imagetype);
-      altFormat =  msSelectOutputFormat(map, "png24");
+      altFormat = msSelectOutputFormat(map, "png24");
       msInitializeRendererVTable(altFormat);
-      /* TODO: check the png24 format hasn't been tampered with, i.e. it's agg */
-      maskLayer->maskimage= msImageCreate(map->width, map->height, altFormat,
-                                          map->web.imagepath, map->web.imageurl, map->resolution, map->defresolution, NULL);
+      /* TODO: check the png24 format hasn't been tampered with, i.e. it's agg
+       */
+      maskLayer->maskimage = msImageCreate(
+          map->width, map->height, altFormat, map->web.imagepath,
+          map->web.imageurl, map->resolution, map->defresolution, NULL);
       if (!maskLayer->maskimage) {
         msWCSFreeCoverageMetadata(&cm);
-        msSetError(MS_MISCERR, "Unable to initialize mask image.", "msDrawLayer()");
+        msSetError(MS_MISCERR, "Unable to initialize mask image.",
+                   "msDrawLayer()");
         msFree(origImageType);
         msDrawRasterLayerLowCloseDataset(lp, hDS);
-        return msWCSException(map, NULL, NULL, params->version );
+        return msWCSException(map, NULL, NULL, params->version);
       }
 
       /*
-       * force the masked layer to status on, and turn off the labelcache so that
-       * eventual labels are added to the temporary image instead of being added
-       * to the labelcache
+       * force the masked layer to status on, and turn off the labelcache so
+       * that eventual labels are added to the temporary image instead of being
+       * added to the labelcache
        */
       origstatus = maskLayer->status;
       origlabelcache = maskLayer->labelcache;
@@ -2622,109 +2898,115 @@ this request. Check wcs/ows_enable_reque
       retcode = msDrawLayer(map, maskLayer, maskLayer->maskimage);
       maskLayer->status = origstatus;
       maskLayer->labelcache = origlabelcache;
-      if(retcode != MS_SUCCESS) {
+      if (retcode != MS_SUCCESS) {
         msWCSFreeCoverageMetadata(&cm);
-        /* set the imagetype from the original outputformat back (it was removed by msSelectOutputFormat() */
+        /* set the imagetype from the original outputformat back (it was removed
+         * by msSelectOutputFormat() */
         msFree(map->imagetype);
         map->imagetype = origImageType;
         msDrawRasterLayerLowCloseDataset(lp, hDS);
-        return msWCSException(map, NULL, NULL, params->version );
+        return msWCSException(map, NULL, NULL, params->version);
       }
       /*
-       * hack to work around bug #3834: if we have use an alternate renderer, the symbolset may contain
-       * symbols that reference it. We want to remove those references before the altFormat is destroyed
-       * to avoid a segfault and/or a leak, and so the the main renderer doesn't pick the cache up thinking
-       * it's for him.
+       * hack to work around bug #3834: if we have use an alternate renderer,
+       * the symbolset may contain symbols that reference it. We want to remove
+       * those references before the altFormat is destroyed to avoid a segfault
+       * and/or a leak, and so the the main renderer doesn't pick the cache up
+       * thinking it's for him.
        */
-      for(i=0; i<map->symbolset.numsymbols; i++) {
-        if (map->symbolset.symbol[i]!=NULL) {
+      for (i = 0; i < map->symbolset.numsymbols; i++) {
+        if (map->symbolset.symbol[i] != NULL) {
           symbolObj *s = map->symbolset.symbol[i];
-          if(s->renderer == MS_IMAGE_RENDERER(maskLayer->maskimage)) {
+          if (s->renderer == MS_IMAGE_RENDERER(maskLayer->maskimage)) {
             MS_IMAGE_RENDERER(maskLayer->maskimage)->freeSymbol(s);
             s->renderer = NULL;
           }
         }
       }
-      /* set the imagetype from the original outputformat back (it was removed by msSelectOutputFormat() */
+      /* set the imagetype from the original outputformat back (it was removed
+       * by msSelectOutputFormat() */
       msFree(map->imagetype);
       map->imagetype = origImageType;
-      
     }
   }
-  
+
   /* create the image object  */
-  if(!map->outputformat) {
+  if (!map->outputformat) {
     msWCSFreeCoverageMetadata(&cm);
-    msSetError(MS_WCSERR, "The map outputformat is missing!", "msWCSGetCoverage()");
+    msSetError(MS_WCSERR, "The map outputformat is missing!",
+               "msWCSGetCoverage()");
     msDrawRasterLayerLowCloseDataset(lp, hDS);
-    return msWCSException(map, NULL, NULL, params->version );
-  } else if( MS_RENDERER_RAWDATA(map->outputformat) || MS_RENDERER_PLUGIN(map->outputformat) ) {
-    image = msImageCreate(map->width, map->height, map->outputformat, map->web.imagepath, map->web.imageurl, map->resolution, map->defresolution, NULL);
+    return msWCSException(map, NULL, NULL, params->version);
+  } else if (MS_RENDERER_RAWDATA(map->outputformat) ||
+             MS_RENDERER_PLUGIN(map->outputformat)) {
+    image = msImageCreate(map->width, map->height, map->outputformat,
+                          map->web.imagepath, map->web.imageurl,
+                          map->resolution, map->defresolution, NULL);
   } else {
     msWCSFreeCoverageMetadata(&cm);
-    msSetError(MS_WCSERR, "Map outputformat not supported for WCS!", "msWCSGetCoverage()");
+    msSetError(MS_WCSERR, "Map outputformat not supported for WCS!",
+               "msWCSGetCoverage()");
     msDrawRasterLayerLowCloseDataset(lp, hDS);
-    return msWCSException(map, NULL, NULL, params->version );
+    return msWCSException(map, NULL, NULL, params->version);
   }
 
-  if( image == NULL ) {
+  if (image == NULL) {
     msWCSFreeCoverageMetadata(&cm);
     msDrawRasterLayerLowCloseDataset(lp, hDS);
-    return msWCSException(map, NULL, NULL, params->version );
+    return msWCSException(map, NULL, NULL, params->version);
   }
-  if( MS_RENDERER_RAWDATA(map->outputformat) ) {
-    if( doDrawRasterLayerDraw ) {
-      status = msDrawRasterLayerLowWithDataset( map, lp, image, NULL, hDS );
+  if (MS_RENDERER_RAWDATA(map->outputformat)) {
+    if (doDrawRasterLayerDraw) {
+      status = msDrawRasterLayerLowWithDataset(map, lp, image, NULL, hDS);
     } else {
       status = MS_SUCCESS;
     }
   } else {
-    status = MS_IMAGE_RENDERER(image)->getRasterBufferHandle(image,&rb);
-    if(MS_UNLIKELY(status == MS_FAILURE)) {
+    status = MS_IMAGE_RENDERER(image)->getRasterBufferHandle(image, &rb);
+    if (MS_UNLIKELY(status == MS_FAILURE)) {
       msWCSFreeCoverageMetadata(&cm);
       msDrawRasterLayerLowCloseDataset(lp, hDS);
       return MS_FAILURE;
     }
 
     /* Actually produce the "grid". */
-    if( doDrawRasterLayerDraw ) {
-      status = msDrawRasterLayerLowWithDataset( map, lp, image, &rb, hDS );
+    if (doDrawRasterLayerDraw) {
+      status = msDrawRasterLayerLowWithDataset(map, lp, image, &rb, hDS);
     } else {
       status = MS_SUCCESS;
     }
   }
   msDrawRasterLayerLowCloseDataset(lp, hDS);
 
-  if( status != MS_SUCCESS ) {
+  if (status != MS_SUCCESS) {
     msWCSFreeCoverageMetadata(&cm);
     msFreeImage(image);
-    return msWCSException(map, NULL, NULL, params->version );
+    return msWCSException(map, NULL, NULL, params->version);
   }
 
-
-  if( strncmp(params->version, "1.1",3) == 0 ) {
-    msWCSReturnCoverage11( params, map, image );
+  if (strncmp(params->version, "1.1", 3) == 0) {
+    msWCSReturnCoverage11(params, map, image);
   } else { /* WCS 1.0.0 - just return the binary data with a content type */
     const char *fo_filename;
 
     /* Do we have a predefined filename? */
-    fo_filename = msGetOutputFormatOption( format, "FILENAME", NULL );
-    if( fo_filename )
-      msIO_setHeader("Content-Disposition","attachment; filename=%s",
-                     fo_filename );
+    fo_filename = msGetOutputFormatOption(format, "FILENAME", NULL);
+    if (fo_filename)
+      msIO_setHeader("Content-Disposition", "attachment; filename=%s",
+                     fo_filename);
 
     /* Emit back to client. */
-    msOutputFormatResolveFromImage( map, image );
-    msIO_setHeader("Content-Type","%s",MS_IMAGE_MIME_TYPE(map->outputformat));
+    msOutputFormatResolveFromImage(map, image);
+    msIO_setHeader("Content-Type", "%s", MS_IMAGE_MIME_TYPE(map->outputformat));
     msIO_sendHeaders();
     status = msSaveImage(map, image, NULL);
 
-    if( status != MS_SUCCESS ) {
+    if (status != MS_SUCCESS) {
       /* unfortunately, the image content type will have already been sent
          but that is hard for us to avoid.  The main error that could happen
          here is a misconfigured tmp directory or running out of space. */
       msWCSFreeCoverageMetadata(&cm);
-      return msWCSException(map, NULL, NULL, params->version );
+      return msWCSException(map, NULL, NULL, params->version);
     }
   }
 
@@ -2744,25 +3026,23 @@ this request. Check wcs/ows_enable_reque
 /*      Entry point for WCS requests                                    */
 /************************************************************************/
 
-int msWCSDispatch(mapObj *map, cgiRequestObj *request, owsRequestObj *ows_request)
-{
+int msWCSDispatch(mapObj *map, cgiRequestObj *request,
+                  owsRequestObj *ows_request) {
 #if defined(USE_WCS_SVR)
   wcs20ParamsObj *params20 = NULL;
   int status, retVal, operation;
 
   /* If SERVICE is not set or not WCS exit gracefully. */
-  if (ows_request->service == NULL
-      || !EQUAL(ows_request->service, "WCS")) {
+  if (ows_request->service == NULL || !EQUAL(ows_request->service, "WCS")) {
     return MS_DONE;
   }
 
   /* If no REQUEST is set, exit with an error */
   if (ows_request->request == NULL) {
     /* The request has to be set. */
-    msSetError(MS_WCSERR, "Missing REQUEST parameter",
-               "msWCSDispatch()");
+    msSetError(MS_WCSERR, "Missing REQUEST parameter", "msWCSDispatch()");
     return msWCSException(map, "MissingParameterValue", "request",
-                          ows_request->version );
+                          ows_request->version);
   }
 
   if (EQUAL(ows_request->request, "GetCapabilities")) {
@@ -2772,8 +3052,8 @@ int msWCSDispatch(mapObj *map, cgiReques
   } else if (EQUAL(ows_request->request, "GetCoverage")) {
     operation = MS_WCS_GET_COVERAGE;
   } else {
-    msSetError(MS_WCSERR, "Invalid REQUEST parameter \"%s\"",
-               "msWCSDispatch()", ows_request->request);
+    msSetError(MS_WCSERR, "Invalid REQUEST parameter \"%s\"", "msWCSDispatch()",
+               ows_request->request);
     return msWCSException(map, "InvalidParameterValue", "request",
                           ows_request->version);
   }
@@ -2783,17 +3063,20 @@ int msWCSDispatch(mapObj *map, cgiReques
   if (ows_request->numlayers == 0) {
     int caps_globally_enabled = MS_FALSE, disabled = MS_FALSE;
     const char *enable_request;
-    if(operation == MS_WCS_GET_CAPABILITIES) {
-      enable_request = msOWSLookupMetadata(&map->web.metadata, "OC", "enable_request");
-      caps_globally_enabled = msOWSParseRequestMetadata(enable_request, "GetCapabilities", &disabled);
+    if (operation == MS_WCS_GET_CAPABILITIES) {
+      enable_request =
+          msOWSLookupMetadata(&map->web.metadata, "OC", "enable_request");
+      caps_globally_enabled = msOWSParseRequestMetadata(
+          enable_request, "GetCapabilities", &disabled);
     }
 
-    if(caps_globally_enabled == MS_FALSE) {
-      msSetError(MS_WCSERR, "WCS request not enabled. Check "
+    if (caps_globally_enabled == MS_FALSE) {
+      msSetError(MS_WCSERR,
+                 "WCS request not enabled. Check "
                  "wcs/ows_enable_request settings.",
                  "msWCSDispatch()");
       return msWCSException(map, "InvalidParameterValue", "request",
-                            ows_request->version );
+                            ows_request->version);
     }
   }
 
@@ -2812,8 +3095,7 @@ int msWCSDispatch(mapObj *map, cgiReques
       status = msWCSParseRequest20(map, request, ows_request, params_tmp);
       if (status == MS_FAILURE) {
         msWCSFreeParamsObj20(params_tmp);
-        return msWCSException(map, "InvalidParameterValue",
-                              "request", "2.0.1");
+        return msWCSException(map, "InvalidParameterValue", "request", "2.0.1");
       }
 
       /* VERSION negotiation */
@@ -2821,14 +3103,14 @@ int msWCSDispatch(mapObj *map, cgiReques
         /* choose highest acceptable */
         int i, highest_version = 0;
         char version_string[OWS_VERSION_MAXLEN];
-        for(i = 0; params_tmp->accept_versions[i] != NULL; ++i) {
+        for (i = 0; params_tmp->accept_versions[i] != NULL; ++i) {
           int version = msOWSParseVersionString(params_tmp->accept_versions[i]);
           if (version == OWS_VERSION_BADFORMAT) {
             msWCSFreeParamsObj20(params_tmp);
-            return msWCSException(map, "InvalidParameterValue",
-                                  "version", NULL );
+            return msWCSException(map, "InvalidParameterValue", "version",
+                                  NULL);
           }
-          if(version > highest_version) {
+          if (version > highest_version) {
             highest_version = version;
           }
         }
@@ -2849,10 +3131,8 @@ int msWCSDispatch(mapObj *map, cgiReques
       }
     } else { /* operation != GetCapabilities */
       /* VERSION is mandatory in other requests */
-      msSetError(MS_WCSERR, "VERSION parameter not set.",
-                 "msWCSDispatch()");
-      return msWCSException(map, "InvalidParameterValue", "version",
-                            NULL );
+      msSetError(MS_WCSERR, "VERSION parameter not set.", "msWCSDispatch()");
+      return msWCSException(map, "InvalidParameterValue", "version", NULL);
     }
   } else {
     /* Parse the VERSION parameter */
@@ -2860,18 +3140,16 @@ int msWCSDispatch(mapObj *map, cgiReques
     if (requested_version == OWS_VERSION_BADFORMAT) {
       /* Return an error if the VERSION is */
       /* in an unsupported format.         */
-      return msWCSException(map, "InvalidParameterValue",
-                            "version", NULL );
+      return msWCSException(map, "InvalidParameterValue", "version", NULL);
     }
 
     if (operation == MS_WCS_GET_CAPABILITIES) {
       /* In case of GetCapabilities, make  */
       char version_string[OWS_VERSION_MAXLEN];
-      int version, supported_versions[] =
-      {OWS_2_0_1, OWS_2_0_0, OWS_1_1_2, OWS_1_1_1, OWS_1_1_0, OWS_1_0_0};
-      version = msOWSNegotiateVersion(requested_version,
-                                      supported_versions,
-                                      sizeof(supported_versions)/sizeof(int));
+      int version, supported_versions[] = {OWS_2_0_1, OWS_2_0_0, OWS_1_1_2,
+                                           OWS_1_1_1, OWS_1_1_0, OWS_1_0_0};
+      version = msOWSNegotiateVersion(requested_version, supported_versions,
+                                      sizeof(supported_versions) / sizeof(int));
       msOWSGetVersionString(version, version_string);
       msFree(ows_request->version);
       ows_request->version = msStrdup(version_string);
@@ -2879,17 +3157,16 @@ int msWCSDispatch(mapObj *map, cgiReques
   }
 
   /* VERSION specific request handler */
-  if (strcmp(ows_request->version, "1.0.0") == 0
-      || strcmp(ows_request->version, "1.1.0") == 0
-      || strcmp(ows_request->version, "1.1.1") == 0
-      || strcmp(ows_request->version, "1.1.2") == 0) {
+  if (strcmp(ows_request->version, "1.0.0") == 0 ||
+      strcmp(ows_request->version, "1.1.0") == 0 ||
+      strcmp(ows_request->version, "1.1.1") == 0 ||
+      strcmp(ows_request->version, "1.1.2") == 0) {
     auto paramsTmp = msWCSCreateParams();
     status = msWCSParseRequest(request, paramsTmp, map);
     if (status == MS_FAILURE) {
       msWCSFreeParams(paramsTmp);
       free(paramsTmp);
-      return msWCSException(map, "InvalidParameterValue",
-                            "request", "2.0");
+      return msWCSException(map, "InvalidParameterValue", "request", "2.0");
     }
 
     retVal = MS_FAILURE;
@@ -2903,8 +3180,8 @@ int msWCSDispatch(mapObj *map, cgiReques
     msWCSFreeParams(paramsTmp);
     free(paramsTmp);
     return retVal;
-  } else if (strcmp(ows_request->version, "2.0.0") == 0
-             || strcmp(ows_request->version, "2.0.1") == 0) {
+  } else if (strcmp(ows_request->version, "2.0.0") == 0 ||
+             strcmp(ows_request->version, "2.0.1") == 0) {
 #if defined(USE_LIBXML2)
     int i;
 
@@ -2913,12 +3190,10 @@ int msWCSDispatch(mapObj *map, cgiReques
       status = msWCSParseRequest20(map, request, ows_request, params20);
       if (status == MS_FAILURE) {
         msWCSFreeParamsObj20(params20);
-        return msWCSException(map, "InvalidParameterValue",
-                              "request", "2.0.1");
-      }
-      else if (status == MS_DONE) {
-        /* MS_DONE means, that the exception has already been written to the IO 
-          buffer. 
+        return msWCSException(map, "InvalidParameterValue", "request", "2.0.1");
+      } else if (status == MS_DONE) {
+        /* MS_DONE means, that the exception has already been written to the IO
+          buffer.
         */
         msWCSFreeParamsObj20(params20);
         return MS_FAILURE;
@@ -2926,12 +3201,13 @@ int msWCSDispatch(mapObj *map, cgiReques
     }
 
     /* check if all layer names are valid NCNames */
-    for(i = 0; i < map->numlayers; ++i) {
-      if(!msWCSIsLayerSupported(map->layers[i]))
+    for (i = 0; i < map->numlayers; ++i) {
+      if (!msWCSIsLayerSupported(map->layers[i]))
         continue;
 
       /* Check if each layers name is a valid NCName. */
-      if (msEvalRegex("^[a-zA-z_][a-zA-Z0-9_.-]*$" , map->layers[i]->name) == MS_FALSE) {
+      if (msEvalRegex("^[a-zA-z_][a-zA-Z0-9_.-]*$", map->layers[i]->name) ==
+          MS_FALSE) {
         msSetError(MS_WCSERR, "Layer name '%s' is not a valid NCName.",
                    "msWCSDispatch()", map->layers[i]->name);
         msWCSFreeParamsObj20(params20);
@@ -2947,28 +3223,30 @@ int msWCSDispatch(mapObj *map, cgiReques
     } else if (operation == MS_WCS_GET_COVERAGE) {
       retVal = msWCSGetCoverage20(map, request, params20, ows_request);
     } else {
-      msSetError(MS_WCSERR, "Invalid request '%s'.",
-                 "msWCSDispatch20()", ows_request->request);
-      retVal = msWCSException20(map, "InvalidParameterValue",
-                                "request", "2.0.1");
+      msSetError(MS_WCSERR, "Invalid request '%s'.", "msWCSDispatch20()",
+                 ows_request->request);
+      retVal =
+          msWCSException20(map, "InvalidParameterValue", "request", "2.0.1");
     }
     /* clean up */
     msWCSFreeParamsObj20(params20);
     return retVal;
-#else /* def USE_LIBXML2 */
-    msSetError(MS_WCSERR, "WCS 2.0 needs mapserver to be compiled with libxml2.",
+#else      /* def USE_LIBXML2 */
+    msSetError(MS_WCSERR,
+               "WCS 2.0 needs mapserver to be compiled with libxml2.",
                "msWCSDispatch()");
     return msWCSException(map, "mapserv", "NoApplicableCode", "2.0.1");
-#endif /* def USE_LIBXML2 */
+#endif     /* def USE_LIBXML2 */
   } else { /* unsupported version */
     msSetError(MS_WCSERR, "WCS Server does not support VERSION %s.",
                "msWCSDispatch()", ows_request->version);
-    return msWCSException(map, "InvalidParameterValue",
-                          "version", ows_request->version);
+    return msWCSException(map, "InvalidParameterValue", "version",
+                          ows_request->version);
   }
 
 #else
-  msSetError(MS_WCSERR, "WCS server support is not available.", "msWCSDispatch()");
+  msSetError(MS_WCSERR, "WCS server support is not available.",
+             "msWCSDispatch()");
   return MS_FAILURE;
 #endif
 }
@@ -2983,21 +3261,25 @@ void msWCSFreeCoverageMetadata(coverageM
   msFree(cm->srs_epsg);
 }
 
-int msWCSGetCoverageMetadata( layerObj *layer, coverageMetadataObj *cm )
-{
-  char  *srs_urn = NULL;
+int msWCSGetCoverageMetadata(layerObj *layer, coverageMetadataObj *cm) {
+  char *srs_urn = NULL;
   int i = 0;
-  if ( msCheckParentPointer(layer->map,"map")==MS_FAILURE )
+  if (msCheckParentPointer(layer->map, "map") == MS_FAILURE)
     return MS_FAILURE;
 
   /* -------------------------------------------------------------------- */
   /*      Get the SRS in WCS 1.0 format (eg. EPSG:n)                      */
   /* -------------------------------------------------------------------- */
-  msOWSGetEPSGProj(&(layer->projection), &(layer->metadata), "CO", MS_TRUE, &(cm->srs_epsg));
-  if(!cm->srs_epsg) {
-    msOWSGetEPSGProj(&(layer->map->projection), &(layer->map->web.metadata), "CO", MS_TRUE, &(cm->srs_epsg));
-    if(!cm->srs_epsg) {
-      msSetError(MS_WCSERR, "Unable to determine the SRS for this layer, no projection defined and no metadata available.", "msWCSGetCoverageMetadata()");
+  msOWSGetEPSGProj(&(layer->projection), &(layer->metadata), "CO", MS_TRUE,
+                   &(cm->srs_epsg));
+  if (!cm->srs_epsg) {
+    msOWSGetEPSGProj(&(layer->map->projection), &(layer->map->web.metadata),
+                     "CO", MS_TRUE, &(cm->srs_epsg));
+    if (!cm->srs_epsg) {
+      msSetError(MS_WCSERR,
+                 "Unable to determine the SRS for this layer, no projection "
+                 "defined and no metadata available.",
+                 "msWCSGetCoverageMetadata()");
       return MS_FAILURE;
     }
   }
@@ -3005,22 +3287,20 @@ int msWCSGetCoverageMetadata( layerObj *
   /* -------------------------------------------------------------------- */
   /*      Get the SRS in urn format.                                      */
   /* -------------------------------------------------------------------- */
-  if((srs_urn = msOWSGetProjURN(&(layer->projection), &(layer->metadata),
-                                "CO", MS_TRUE)) == NULL) {
+  if ((srs_urn = msOWSGetProjURN(&(layer->projection), &(layer->metadata), "CO",
+                                 MS_TRUE)) == NULL) {
     srs_urn = msOWSGetProjURN(&(layer->map->projection),
-                              &(layer->map->web.metadata),
-                              "CO", MS_TRUE);
+                              &(layer->map->web.metadata), "CO", MS_TRUE);
   }
 
-  if( srs_urn != NULL ) {
-    if( strlen(srs_urn) > sizeof(cm->srs_urn) - 1 ) {
-      msSetError(MS_WCSERR, "SRS URN too long!",
-                 "msWCSGetCoverageMetadata()");
+  if (srs_urn != NULL) {
+    if (strlen(srs_urn) > sizeof(cm->srs_urn) - 1) {
+      msSetError(MS_WCSERR, "SRS URN too long!", "msWCSGetCoverageMetadata()");
       return MS_FAILURE;
     }
 
-    strcpy( cm->srs_urn, srs_urn );
-    msFree( srs_urn );
+    strcpy(cm->srs_urn, srs_urn);
+    msFree(srs_urn);
   } else
     cm->srs_urn[0] = '\0';
 
@@ -3029,9 +3309,9 @@ int msWCSGetCoverageMetadata( layerObj *
   /*      that in preference to inspecting the file(s).                   */
   /*      We require extent and either size or resolution.                */
   /* -------------------------------------------------------------------- */
-  if( msOWSLookupMetadata(&(layer->metadata), "CO", "extent") != NULL
-      && (msOWSLookupMetadata(&(layer->metadata), "CO", "resolution") != NULL
-          || msOWSLookupMetadata(&(layer->metadata), "CO", "size") != NULL) ) {
+  if (msOWSLookupMetadata(&(layer->metadata), "CO", "extent") != NULL &&
+      (msOWSLookupMetadata(&(layer->metadata), "CO", "resolution") != NULL ||
+       msOWSLookupMetadata(&(layer->metadata), "CO", "size") != NULL)) {
     const char *value;
 
     /* get extent */
@@ -3039,60 +3319,76 @@ int msWCSGetCoverageMetadata( layerObj *
     cm->extent.maxx = 0.0;
     cm->extent.miny = 0.0;
     cm->extent.maxy = 0.0;
-    if( msOWSGetLayerExtent( layer->map, layer, "CO", &cm->extent ) == MS_FAILURE )
+    if (msOWSGetLayerExtent(layer->map, layer, "CO", &cm->extent) == MS_FAILURE)
       return MS_FAILURE;
 
     /* get resolution */
     cm->xresolution = 0.0;
     cm->yresolution = 0.0;
-    if( (value = msOWSLookupMetadata(&(layer->metadata), "CO", "resolution")) != NULL ) {
+    if ((value = msOWSLookupMetadata(&(layer->metadata), "CO", "resolution")) !=
+        NULL) {
       char **tokens;
       int n;
 
       tokens = msStringSplit(value, ' ', &n);
-      if( tokens == NULL || n != 2 ) {
-        msSetError( MS_WCSERR, "Wrong number of arguments for wcs|ows_resolution metadata.", "msWCSGetCoverageMetadata()");
-        msFreeCharArray( tokens, n );
+      if (tokens == NULL || n != 2) {
+        msSetError(MS_WCSERR,
+                   "Wrong number of arguments for wcs|ows_resolution metadata.",
+                   "msWCSGetCoverageMetadata()");
+        msFreeCharArray(tokens, n);
         return MS_FAILURE;
       }
       cm->xresolution = atof(tokens[0]);
       cm->yresolution = atof(tokens[1]);
-      msFreeCharArray( tokens, n );
+      msFreeCharArray(tokens, n);
     }
 
     /* get Size (in pixels and lines) */
     cm->xsize = 0;
     cm->ysize = 0;
-    if( (value=msOWSLookupMetadata(&(layer->metadata), "CO", "size")) != NULL ) {
+    if ((value = msOWSLookupMetadata(&(layer->metadata), "CO", "size")) !=
+        NULL) {
       char **tokens;
       int n;
 
       tokens = msStringSplit(value, ' ', &n);
-      if( tokens == NULL || n != 2 ) {
-        msSetError( MS_WCSERR, "Wrong number of arguments for wcs|ows_size metadata.", "msWCSGetCoverageDomain()");
-        msFreeCharArray( tokens, n );
+      if (tokens == NULL || n != 2) {
+        msSetError(MS_WCSERR,
+                   "Wrong number of arguments for wcs|ows_size metadata.",
+                   "msWCSGetCoverageDomain()");
+        msFreeCharArray(tokens, n);
         return MS_FAILURE;
       }
       cm->xsize = atoi(tokens[0]);
       cm->ysize = atoi(tokens[1]);
-      msFreeCharArray( tokens, n );
+      msFreeCharArray(tokens, n);
     }
 
     /* try to compute raster size */
-    if( cm->xsize == 0 && cm->ysize == 0 && cm->xresolution != 0.0 && cm->yresolution != 0.0 && cm->extent.minx != cm->extent.maxx && cm->extent.miny != cm->extent.maxy ) {
-      cm->xsize = (int) ((cm->extent.maxx - cm->extent.minx) / cm->xresolution + 0.5);
-      cm->ysize = (int) fabs((cm->extent.maxy - cm->extent.miny) / cm->yresolution + 0.5);
+    if (cm->xsize == 0 && cm->ysize == 0 && cm->xresolution != 0.0 &&
+        cm->yresolution != 0.0 && cm->extent.minx != cm->extent.maxx &&
+        cm->extent.miny != cm->extent.maxy) {
+      cm->xsize =
+          (int)((cm->extent.maxx - cm->extent.minx) / cm->xresolution + 0.5);
+      cm->ysize = (int)fabs(
+          (cm->extent.maxy - cm->extent.miny) / cm->yresolution + 0.5);
     }
 
     /* try to compute raster resolution */
-    if( (cm->xresolution == 0.0 || cm->yresolution == 0.0) && cm->xsize != 0 && cm->ysize != 0 ) {
+    if ((cm->xresolution == 0.0 || cm->yresolution == 0.0) && cm->xsize != 0 &&
+        cm->ysize != 0) {
       cm->xresolution = (cm->extent.maxx - cm->extent.minx) / cm->xsize;
       cm->yresolution = (cm->extent.maxy - cm->extent.miny) / cm->ysize;
     }
 
     /* do we have information to do anything */
-    if( cm->xresolution == 0.0 || cm->yresolution == 0.0 || cm->xsize == 0 || cm->ysize == 0 ) {
-      msSetError( MS_WCSERR, "Failed to collect extent and resolution for WCS coverage from metadata for layer '%s'.  Need value wcs|ows_resolution or wcs|ows_size values.", "msWCSGetCoverageMetadata()", layer->name );
+    if (cm->xresolution == 0.0 || cm->yresolution == 0.0 || cm->xsize == 0 ||
+        cm->ysize == 0) {
+      msSetError(MS_WCSERR,
+                 "Failed to collect extent and resolution for WCS coverage "
+                 "from metadata for layer '%s'.  Need value wcs|ows_resolution "
+                 "or wcs|ows_size values.",
+                 "msWCSGetCoverageMetadata()", layer->name);
       return MS_FAILURE;
     }
 
@@ -3106,31 +3402,43 @@ int msWCSGetCoverageMetadata( layerObj *
 
     /* get bands count, or assume 1 if not found */
     cm->bandcount = 1;
-    if( (value=msOWSLookupMetadata(&(layer->metadata), "CO", "bandcount")) != NULL) {
+    if ((value = msOWSLookupMetadata(&(layer->metadata), "CO", "bandcount")) !=
+        NULL) {
       cm->bandcount = atoi(value);
     }
 
     /* get bands type, or assume float if not found */
     cm->imagemode = MS_IMAGEMODE_FLOAT32;
-    if( (value=msOWSLookupMetadata(&(layer->metadata), "CO", "imagemode")) != NULL ) {
-      if( EQUAL(value,"INT16") )
+    if ((value = msOWSLookupMetadata(&(layer->metadata), "CO", "imagemode")) !=
+        NULL) {
+      if (EQUAL(value, "INT16"))
         cm->imagemode = MS_IMAGEMODE_INT16;
-      else if( EQUAL(value,"FLOAT32") )
+      else if (EQUAL(value, "FLOAT32"))
         cm->imagemode = MS_IMAGEMODE_FLOAT32;
-      else if( EQUAL(value,"BYTE") )
+      else if (EQUAL(value, "BYTE"))
         cm->imagemode = MS_IMAGEMODE_BYTE;
       else {
-        msSetError( MS_WCSERR, "Content of wcs|ows_imagemode (%s) not recognised.  Should be one of BYTE, INT16 or FLOAT32.", "msWCSGetCoverageMetadata()", value );
+        msSetError(MS_WCSERR,
+                   "Content of wcs|ows_imagemode (%s) not recognised.  Should "
+                   "be one of BYTE, INT16 or FLOAT32.",
+                   "msWCSGetCoverageMetadata()", value);
         return MS_FAILURE;
       }
     }
     /* set color interpretation to undefined */
     /* TODO: find better solution */
-    for(i = 0; i < 10; ++i) {
+    for (i = 0; i < 10; ++i) {
       cm->bandinterpretation[i] = GDALGetColorInterpretationName(GCI_Undefined);
     }
-  } else if( layer->data == NULL ) { /* no virtual metadata, not ok unless we're talking 1 image, hopefully we can fix that */
-    msSetError( MS_WCSERR, "RASTER Layer with no DATA statement and no WCS virtual dataset metadata.  Tileindexed raster layers not supported for WCS without virtual dataset metadata (cm->extent, wcs_res, wcs_size).", "msWCSGetCoverageDomain()" );
+  } else if (layer->data ==
+             NULL) { /* no virtual metadata, not ok unless we're talking 1
+                        image, hopefully we can fix that */
+    msSetError(
+        MS_WCSERR,
+        "RASTER Layer with no DATA statement and no WCS virtual dataset "
+        "metadata.  Tileindexed raster layers not supported for WCS without "
+        "virtual dataset metadata (cm->extent, wcs_res, wcs_size).",
+        "msWCSGetCoverageDomain()");
     return MS_FAILURE;
   } else { /* work from the file (e.g. DATA) */
     GDALDatasetH hDS;
@@ -3140,48 +3448,51 @@ int msWCSGetCoverageMetadata( layerObj *
 
     msGDALInitialize();
 
-    msTryBuildPath3(szPath,  layer->map->mappath, layer->map->shapepath, layer->data);
-    decrypted_path = msDecryptStringTokens( layer->map, szPath );
-    if( !decrypted_path )
+    msTryBuildPath3(szPath, layer->map->mappath, layer->map->shapepath,
+                    layer->data);
+    decrypted_path = msDecryptStringTokens(layer->map, szPath);
+    if (!decrypted_path)
       return MS_FAILURE;
 
-    msAcquireLock( TLOCK_GDAL );
+    msAcquireLock(TLOCK_GDAL);
     {
-        char** connectionoptions = msGetStringListFromHashTable(&(layer->connectionoptions));
-        hDS = GDALOpenEx( decrypted_path, GDAL_OF_RASTER, NULL,
-                          (const char* const*)connectionoptions, NULL);
-        CSLDestroy(connectionoptions);
+      char **connectionoptions =
+          msGetStringListFromHashTable(&(layer->connectionoptions));
+      hDS = GDALOpenEx(decrypted_path, GDAL_OF_RASTER, NULL,
+                       (const char *const *)connectionoptions, NULL);
+      CSLDestroy(connectionoptions);
     }
-    if( hDS == NULL ) {
+    if (hDS == NULL) {
       const char *cpl_error_msg = CPLGetLastErrorMsg();
 
       /* we wish to avoid reporting decrypted paths */
-      if( cpl_error_msg != NULL
-          && strstr(cpl_error_msg,decrypted_path) != NULL
-          && strcmp(decrypted_path,szPath) != 0 )
+      if (cpl_error_msg != NULL &&
+          strstr(cpl_error_msg, decrypted_path) != NULL &&
+          strcmp(decrypted_path, szPath) != 0)
         cpl_error_msg = NULL;
 
-      if( cpl_error_msg == NULL )
+      if (cpl_error_msg == NULL)
         cpl_error_msg = "";
 
-      msReleaseLock( TLOCK_GDAL );
+      msReleaseLock(TLOCK_GDAL);
 
-      msSetError( MS_IOERR, "%s", "msWCSGetCoverageMetadata()",
-                  cpl_error_msg );
+      msSetError(MS_IOERR, "%s", "msWCSGetCoverageMetadata()", cpl_error_msg);
 
-      msFree( decrypted_path );
+      msFree(decrypted_path);
       return MS_FAILURE;
     }
-    msFree( decrypted_path );
+    msFree(decrypted_path);
 
-    msGetGDALGeoTransform( hDS, layer->map, layer, cm->geotransform );
+    msGetGDALGeoTransform(hDS, layer->map, layer, cm->geotransform);
 
-    cm->xsize = GDALGetRasterXSize( hDS );
-    cm->ysize = GDALGetRasterYSize( hDS );
+    cm->xsize = GDALGetRasterXSize(hDS);
+    cm->ysize = GDALGetRasterYSize(hDS);
 
     cm->extent.minx = cm->geotransform[0];
-    cm->extent.maxx = cm->geotransform[0] + cm->geotransform[1] * cm->xsize + cm->geotransform[2] * cm->ysize;
-    cm->extent.miny = cm->geotransform[3] + cm->geotransform[4] * cm->xsize + cm->geotransform[5] * cm->ysize;
+    cm->extent.maxx = cm->geotransform[0] + cm->geotransform[1] * cm->xsize +
+                      cm->geotransform[2] * cm->ysize;
+    cm->extent.miny = cm->geotransform[3] + cm->geotransform[4] * cm->xsize +
+                      cm->geotransform[5] * cm->ysize;
     cm->extent.maxy = cm->geotransform[3];
 
     cm->xresolution = cm->geotransform[1];
@@ -3189,66 +3500,77 @@ int msWCSGetCoverageMetadata( layerObj *
 
     /* TODO: need to set resolution */
 
-    cm->bandcount = GDALGetRasterCount( hDS );
+    cm->bandcount = GDALGetRasterCount(hDS);
 
-    if( cm->bandcount == 0 ) {
-      msReleaseLock( TLOCK_GDAL );
-      msSetError( MS_WCSERR, "Raster file %s has no raster bands.  This cannot be used in a layer.", "msWCSGetCoverageMetadata()", layer->data );
+    if (cm->bandcount == 0) {
+      msReleaseLock(TLOCK_GDAL);
+      msSetError(MS_WCSERR,
+                 "Raster file %s has no raster bands.  This cannot be used in "
+                 "a layer.",
+                 "msWCSGetCoverageMetadata()", layer->data);
       return MS_FAILURE;
     }
 
-    hBand = GDALGetRasterBand( hDS, 1 );
-    switch( GDALGetRasterDataType( hBand ) ) {
-      case GDT_Byte:
-        cm->imagemode = MS_IMAGEMODE_BYTE;
-        break;
-      case GDT_Int16:
-        cm->imagemode = MS_IMAGEMODE_INT16;
-        break;
-      default:
-        cm->imagemode = MS_IMAGEMODE_FLOAT32;
-        break;
+    hBand = GDALGetRasterBand(hDS, 1);
+    switch (GDALGetRasterDataType(hBand)) {
+    case GDT_Byte:
+      cm->imagemode = MS_IMAGEMODE_BYTE;
+      break;
+    case GDT_Int16:
+      cm->imagemode = MS_IMAGEMODE_INT16;
+      break;
+    default:
+      cm->imagemode = MS_IMAGEMODE_FLOAT32;
+      break;
     }
 
     /* color interpretation */
-    for(i = 1; i <= 10 && i <= cm->bandcount; ++i) {
+    for (i = 1; i <= 10 && i <= cm->bandcount; ++i) {
       GDALColorInterp colorInterp;
-      hBand = GDALGetRasterBand( hDS, i );
+      hBand = GDALGetRasterBand(hDS, i);
       colorInterp = GDALGetRasterColorInterpretation(hBand);
-      cm->bandinterpretation[i-1] = GDALGetColorInterpretationName(colorInterp);
+      cm->bandinterpretation[i - 1] =
+          GDALGetColorInterpretationName(colorInterp);
     }
 
-    GDALClose( hDS );
-    msReleaseLock( TLOCK_GDAL );
+    GDALClose(hDS);
+    msReleaseLock(TLOCK_GDAL);
   }
 
   /* we must have the bounding box in lat/lon [WGS84(DD)/EPSG:4326] */
   cm->llextent = cm->extent;
 
   /* Already in latlong .. use directly. */
-  if( layer->projection.proj != NULL && msProjIsGeographicCRS(&(layer->projection))) {
+  if (layer->projection.proj != NULL &&
+      msProjIsGeographicCRS(&(layer->projection))) {
     /* no change */
   }
 
-  else if (layer->projection.numargs > 0 && !msProjIsGeographicCRS(&(layer->projection))) /* check the layer projection */
+  else if (layer->projection.numargs > 0 &&
+           !msProjIsGeographicCRS(
+               &(layer->projection))) /* check the layer projection */
     msProjectRect(&(layer->projection), NULL, &(cm->llextent));
 
-  else if (layer->map->projection.numargs > 0 && !msProjIsGeographicCRS(&(layer->map->projection))) /* check the map projection */
+  else if (layer->map->projection.numargs > 0 &&
+           !msProjIsGeographicCRS(
+               &(layer->map->projection))) /* check the map projection */
     msProjectRect(&(layer->map->projection), NULL, &(cm->llextent));
 
-  else { /* projection was specified in the metadata only (EPSG:... only at the moment)  */
+  else { /* projection was specified in the metadata only (EPSG:... only at the
+            moment)  */
     projectionObj proj;
     char projstring[32];
 
     msInitProjection(&proj); /* or bad things happen */
     msProjectionInheritContextFrom(&proj, &(layer->map->projection));
 
-    snprintf(projstring, sizeof(projstring), "init=epsg:%.20s", cm->srs_epsg+5);
-    if (msLoadProjectionString(&proj, projstring) != 0) return MS_FAILURE;
+    snprintf(projstring, sizeof(projstring), "init=epsg:%.20s",
+             cm->srs_epsg + 5);
+    if (msLoadProjectionString(&proj, projstring) != 0)
+      return MS_FAILURE;
     msProjectRect(&proj, NULL, &(cm->llextent));
   }
 
   return MS_SUCCESS;
 }
 #endif /* def USE_WCS_SVR */
-
diff -pruN 8.0.1-5/mapwcs.h 8.0.2-1/mapwcs.h
--- 8.0.1-5/mapwcs.h	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapwcs.h	2024-06-11 20:41:34.000000000 +0000
@@ -50,11 +50,7 @@ extern "C" {
 
 #define MS_WCS_GML_COVERAGETYPE_RECTIFIED_GRID_COVERAGE "RectifiedGridCoverage"
 
-enum {
-  MS_WCS_GET_CAPABILITIES,
-  MS_WCS_DESCRIBE_COVERAGE,
-  MS_WCS_GET_COVERAGE
-};
+enum { MS_WCS_GET_CAPABILITIES, MS_WCS_DESCRIBE_COVERAGE, MS_WCS_GET_COVERAGE };
 
 /*
 ** Structure to hold metadata taken from the image or image tile index
@@ -72,22 +68,27 @@ typedef struct {
 } coverageMetadataObj;
 
 typedef struct {
-  char *version;    /* 1.0.0 for now */
-  char *updatesequence;   /* string, int or timestampe */
-  char *request;    /* GetCapabilities|DescribeCoverage|GetCoverage */
-  char *service;    /* MUST be WCS */
-  char *section;    /* of capabilities document: /WCS_Capabilities/Service|/WCS_Capabilities/Capability|/WCS_Capabilities/ContentMetadata */
-  char **coverages;   /* NULL terminated list of coverages (in the case of a GetCoverage there will only be 1) */
+  char *version;        /* 1.0.0 for now */
+  char *updatesequence; /* string, int or timestampe */
+  char *request;        /* GetCapabilities|DescribeCoverage|GetCoverage */
+  char *service;        /* MUST be WCS */
+  char *
+      section;        /* of capabilities document:
+                         /WCS_Capabilities/Service|/WCS_Capabilities/Capability|/WCS_Capabilities/ContentMetadata
+                       */
+  char **coverages;   /* NULL terminated list of coverages (in the case of a
+                         GetCoverage there will only be 1) */
   char *crs;          /* request coordinate reference system */
   char *response_crs; /* response coordinate reference system */
   rectObj bbox;       /* subset bounding box (3D), although we'll only use 2D */
   char *time;
-  long width, height, depth;  /* image dimensions */
-  double originx, originy;      /* WCS 1.1 GridOrigin */
-  double resx, resy, resz;      /* resolution */
-  char *interpolation;          /* interpolationMethod */
+  long width, height, depth; /* image dimensions */
+  double originx, originy;   /* WCS 1.1 GridOrigin */
+  double resx, resy, resz;   /* resolution */
+  char *interpolation;       /* interpolationMethod */
   char *format;
-  char *exceptions;   /* exception MIME type, (default application=vnd.ogc.se_xml) */
+  char *exceptions; /* exception MIME type, (default application=vnd.ogc.se_xml)
+                     */
 } wcsParamsObj;
 
 /* -------------------------------------------------------------------- */
@@ -100,48 +101,40 @@ void msWCSFreeParams(wcsParamsObj *param
 int msWCSException(mapObj *map, const char *code, const char *locator,
                    const char *version);
 int msWCSIsLayerSupported(layerObj *layer);
-int msWCSGetCoverageMetadata( layerObj *layer, coverageMetadataObj *cm );
+int msWCSGetCoverageMetadata(layerObj *layer, coverageMetadataObj *cm);
 void msWCSFreeCoverageMetadata(coverageMetadataObj *cm);
-void msWCSSetDefaultBandsRangeSetInfo( wcsParamsObj *params,
-                                       coverageMetadataObj *cm,
-                                       layerObj *lp );
+void msWCSSetDefaultBandsRangeSetInfo(wcsParamsObj *params,
+                                      coverageMetadataObj *cm, layerObj *lp);
 const char *msWCSGetRequestParameter(cgiRequestObj *request, const char *name);
-void msWCSApplyLayerCreationOptions(layerObj* lp,
-                                    outputFormatObj* format,
-                                    const char* bandlist);
-void msWCSApplyDatasetMetadataAsCreationOptions(layerObj* lp,
-                                                outputFormatObj* format,
-                                                const char* bandlist,
-                                                void* hDSIn);
-void msWCSApplyLayerMetadataItemOptions(layerObj* lp,
-                                        outputFormatObj* format,
-                                        const char* bandlist);
-void msWCSApplySourceDatasetMetadata(layerObj* lp,
-                                     outputFormatObj* format,
-                                     const char* bandlist,
-                                     void* hDSIn);
+void msWCSApplyLayerCreationOptions(layerObj *lp, outputFormatObj *format,
+                                    const char *bandlist);
+void msWCSApplyDatasetMetadataAsCreationOptions(layerObj *lp,
+                                                outputFormatObj *format,
+                                                const char *bandlist,
+                                                void *hDSIn);
+void msWCSApplyLayerMetadataItemOptions(layerObj *lp, outputFormatObj *format,
+                                        const char *bandlist);
+void msWCSApplySourceDatasetMetadata(layerObj *lp, outputFormatObj *format,
+                                     const char *bandlist, void *hDSIn);
 /* -------------------------------------------------------------------- */
 /*      Some WCS 1.1 specific functions from mapwcs11.c                 */
 /* -------------------------------------------------------------------- */
 int msWCSGetCapabilities11(mapObj *map, wcsParamsObj *params,
                            cgiRequestObj *req, owsRequestObj *ows_request);
-int msWCSDescribeCoverage11(mapObj *map, wcsParamsObj *params, owsRequestObj *ows_request);
-int msWCSReturnCoverage11( wcsParamsObj *params, mapObj *map, imageObj *image);
-int msWCSGetCoverageBands11( mapObj *map, cgiRequestObj *request,
-                             wcsParamsObj *params, layerObj *lp,
-                             char **p_bandlist );
+int msWCSDescribeCoverage11(mapObj *map, wcsParamsObj *params,
+                            owsRequestObj *ows_request);
+int msWCSReturnCoverage11(wcsParamsObj *params, mapObj *map, imageObj *image);
+int msWCSGetCoverageBands11(mapObj *map, cgiRequestObj *request,
+                            wcsParamsObj *params, layerObj *lp,
+                            char **p_bandlist);
 int msWCSException11(mapObj *map, const char *locator,
                      const char *exceptionCode, const char *version);
 
-
 /* -------------------------------------------------------------------- */
 /*      Some WCS 2.0 specific functions and structs from mapwcs20.c     */
 /* -------------------------------------------------------------------- */
 
-enum {
-  MS_WCS20_TRIM = 0,
-  MS_WCS20_SLICE = 1
-};
+enum { MS_WCS20_TRIM = 0, MS_WCS20_SLICE = 1 };
 
 enum {
   MS_WCS20_ERROR_VALUE = -1,
@@ -162,53 +155,54 @@ typedef struct {
 } timeScalarUnion;
 
 typedef struct {
-  char *axis;         /* the name of the subsetted axis */
-  int operation;      /* Either TRIM or SLICE */
-  char *crs;          /* optional CRS to use */
-  int timeOrScalar;   /* 0 if scalar value, 1 if time value */
+  char *axis;          /* the name of the subsetted axis */
+  int operation;       /* Either TRIM or SLICE */
+  char *crs;           /* optional CRS to use */
+  int timeOrScalar;    /* 0 if scalar value, 1 if time value */
   timeScalarUnion min; /* Minimum and Maximum of the subsetted axis;*/
   timeScalarUnion max;
 } wcs20SubsetObj;
-typedef wcs20SubsetObj * wcs20SubsetObjPtr;
+typedef wcs20SubsetObj *wcs20SubsetObjPtr;
 
 typedef struct {
-  char *name;         /* name of the axis */
-  int size;           /* pixelsize of the axis */
-  double resolution;  /* resolution of the axis */
-  double scale;       /* scale of the axis */
+  char *name;          /* name of the axis */
+  int size;            /* pixelsize of the axis */
+  double resolution;   /* resolution of the axis */
+  double scale;        /* scale of the axis */
   char *resolutionUOM; /* resolution units of measure */
   wcs20SubsetObjPtr subset;
 } wcs20AxisObj;
-typedef wcs20AxisObj * wcs20AxisObjPtr;
+typedef wcs20AxisObj *wcs20AxisObjPtr;
 
 typedef struct {
-  char *version;      /* 2.0.0 v 2.0.1 */
-  char *request;      /* GetCapabilities|DescribeCoverage|GetCoverage */
-  char *service;      /* MUST be WCS */
-  char **accept_versions; /* NULL terminated list of Accepted versions */
+  char *version;           /* 2.0.0 v 2.0.1 */
+  char *request;           /* GetCapabilities|DescribeCoverage|GetCoverage */
+  char *service;           /* MUST be WCS */
+  char **accept_versions;  /* NULL terminated list of Accepted versions */
   char **accept_languages; /* NULL terminated list of Accepted versions */
-  char **sections;    /* NULL terminated list of GetCapabilities sections */
+  char **sections;      /* NULL terminated list of GetCapabilities sections */
   char *updatesequence; /* GetCapabilities updatesequence */
-  char **ids;         /* NULL terminated list of coverages (in the case of a GetCoverage there will only be 1) */
-  long width, height; /* image dimensions */
-  double resolutionX; /* image resolution in X axis */
-  double resolutionY; /* image resolution in Y axis */
-  double scale;       /* Overall scale */
-  double scaleX;      /* X-Axis specific scale */
-  double scaleY;      /* Y-Axis specific scale */
+  char **ids; /* NULL terminated list of coverages (in the case of a GetCoverage
+                 there will only be 1) */
+  long width, height;    /* image dimensions */
+  double resolutionX;    /* image resolution in X axis */
+  double resolutionY;    /* image resolution in Y axis */
+  double scale;          /* Overall scale */
+  double scaleX;         /* X-Axis specific scale */
+  double scaleY;         /* Y-Axis specific scale */
   char *resolutionUnits; /* Units of Measure for resolution */
-  char *format;       /* requested output format */
-  int multipart;      /* flag for multipart GML+image */
-  char *interpolation; /* requested interpolation method */
-  char *outputcrs;    /* requested CRS for output */
-  char *subsetcrs;    /* determined CRS of the subsets */
-  rectObj bbox;       /* determined Bounding Box */
-  int numaxes;        /* number of axes */
+  char *format;          /* requested output format */
+  int multipart;         /* flag for multipart GML+image */
+  char *interpolation;   /* requested interpolation method */
+  char *outputcrs;       /* requested CRS for output */
+  char *subsetcrs;       /* determined CRS of the subsets */
+  rectObj bbox;          /* determined Bounding Box */
+  int numaxes;           /* number of axes */
   wcs20AxisObjPtr *axes; /* list of axes, NULL if none*/
-  char **range_subset; /* list of bands selected */
+  char **range_subset;   /* list of bands selected */
   char **format_options; /* list of format specific options, NULL terminated */
 } wcs20ParamsObj;
-typedef wcs20ParamsObj * wcs20ParamsObjPtr;
+typedef wcs20ParamsObj *wcs20ParamsObjPtr;
 
 typedef struct {
   union {
@@ -225,10 +219,10 @@ typedef struct {
   double interval_max;
   int significant_figures;
 } wcs20rasterbandMetadataObj;
-typedef wcs20rasterbandMetadataObj * wcs20rasterbandMetadataObjPtr;
+typedef wcs20rasterbandMetadataObj *wcs20rasterbandMetadataObjPtr;
 
 typedef struct {
-  char *native_format;    /* mime type of the native format */
+  char *native_format; /* mime type of the native format */
   char *srs_epsg;
   char srs_uri[200];
   rectObj extent;
@@ -244,19 +238,33 @@ typedef struct {
   size_t numbands;
   wcs20rasterbandMetadataObjPtr bands;
 } wcs20coverageMetadataObj;
-typedef wcs20coverageMetadataObj * wcs20coverageMetadataObjPtr;
+typedef wcs20coverageMetadataObj *wcs20coverageMetadataObjPtr;
 
-#define MS_WCS_20_PROFILE_CORE      "http://www.opengis.net/spec/WCS/2.0/conf/core"
-#define MS_WCS_20_PROFILE_KVP       "http://www.opengis.net/spec/WCS_protocol-binding_get-kvp/1.0/conf/get-kvp"
-#define MS_WCS_20_PROFILE_POST      "http://www.opengis.net/spec/WCS_protocol-binding_post-xml/1.0/conf/post-xml"
-#define MS_WCS_20_PROFILE_GML       "http://www.opengis.net/spec/GMLCOV/1.0/conf/gml-coverage"
-#define MS_WCS_20_PROFILE_GML_MULTIPART "http://www.opengis.net/spec/GMLCOV/1.0/conf/multipart"
-#define MS_WCS_20_PROFILE_GML_SPECIAL "http://www.opengis.net/spec/GMLCOV/1.0/conf/special-format"
-#define MS_WCS_20_PROFILE_GML_GEOTIFF "http://www.opengis.net/spec/GMLCOV_geotiff-coverages/1.0/conf/geotiff-coverage"
-#define MS_WCS_20_PROFILE_CRS       "http://www.opengis.net/spec/WCS_service-extension_crs/1.0/conf/crs"
-#define MS_WCS_20_PROFILE_SCALING   "http://www.opengis.net/spec/WCS_service-extension_scaling/1.0/conf/scaling"
-#define MS_WCS_20_PROFILE_RANGESUBSET "http://www.opengis.net/spec/WCS_service-extension_range-subsetting/1.0/conf/record-subsetting"
-#define MS_WCS_20_PROFILE_INTERPOLATION "http://www.opengis.net/spec/WCS_service-extension_interpolation/1.0/conf/interpolation"
+#define MS_WCS_20_PROFILE_CORE "http://www.opengis.net/spec/WCS/2.0/conf/core"
+#define MS_WCS_20_PROFILE_KVP                                                  \
+  "http://www.opengis.net/spec/WCS_protocol-binding_get-kvp/1.0/conf/get-kvp"
+#define MS_WCS_20_PROFILE_POST                                                 \
+  "http://www.opengis.net/spec/WCS_protocol-binding_post-xml/1.0/conf/"        \
+  "post-xml"
+#define MS_WCS_20_PROFILE_GML                                                  \
+  "http://www.opengis.net/spec/GMLCOV/1.0/conf/gml-coverage"
+#define MS_WCS_20_PROFILE_GML_MULTIPART                                        \
+  "http://www.opengis.net/spec/GMLCOV/1.0/conf/multipart"
+#define MS_WCS_20_PROFILE_GML_SPECIAL                                          \
+  "http://www.opengis.net/spec/GMLCOV/1.0/conf/special-format"
+#define MS_WCS_20_PROFILE_GML_GEOTIFF                                          \
+  "http://www.opengis.net/spec/GMLCOV_geotiff-coverages/1.0/conf/"             \
+  "geotiff-coverage"
+#define MS_WCS_20_PROFILE_CRS                                                  \
+  "http://www.opengis.net/spec/WCS_service-extension_crs/1.0/conf/crs"
+#define MS_WCS_20_PROFILE_SCALING                                              \
+  "http://www.opengis.net/spec/WCS_service-extension_scaling/1.0/conf/scaling"
+#define MS_WCS_20_PROFILE_RANGESUBSET                                          \
+  "http://www.opengis.net/spec/WCS_service-extension_range-subsetting/1.0/"    \
+  "conf/record-subsetting"
+#define MS_WCS_20_PROFILE_INTERPOLATION                                        \
+  "http://www.opengis.net/spec/WCS_service-extension_interpolation/1.0/conf/"  \
+  "interpolation"
 
 /* -------------------------------------------------------------------- */
 /*      WCS 2.0 function prototypes.                                    */
@@ -264,51 +272,55 @@ typedef wcs20coverageMetadataObj * wcs20
 
 wcs20ParamsObjPtr msWCSCreateParamsObj20();
 void msWCSFreeParamsObj20(wcs20ParamsObjPtr params);
-int msWCSParseRequest20(mapObj *map, cgiRequestObj *request, owsRequestObj *ows_request, wcs20ParamsObjPtr params);
+int msWCSParseRequest20(mapObj *map, cgiRequestObj *request,
+                        owsRequestObj *ows_request, wcs20ParamsObjPtr params);
 
-int msWCSException20(mapObj *map, const char *locator, const char *exceptionCode, const char *version);
+int msWCSException20(mapObj *map, const char *locator,
+                     const char *exceptionCode, const char *version);
 
-int msWCSGetCapabilities20(mapObj *map, cgiRequestObj *req, wcs20ParamsObjPtr params, owsRequestObj *ows_request);
-int msWCSDescribeCoverage20(mapObj *map, wcs20ParamsObjPtr params, owsRequestObj *ows_request);
-int msWCSGetCoverage20(mapObj *map, cgiRequestObj *request, wcs20ParamsObjPtr params, owsRequestObj *ows_request);
+int msWCSGetCapabilities20(mapObj *map, cgiRequestObj *req,
+                           wcs20ParamsObjPtr params,
+                           owsRequestObj *ows_request);
+int msWCSDescribeCoverage20(mapObj *map, wcs20ParamsObjPtr params,
+                            owsRequestObj *ows_request);
+int msWCSGetCoverage20(mapObj *map, cgiRequestObj *request,
+                       wcs20ParamsObjPtr params, owsRequestObj *ows_request);
 
 /* -------------------------------------------------------------------- */
 /*      XML parsing helper macros.                                      */
 /* -------------------------------------------------------------------- */
 
-#define XML_FOREACH_CHILD(parent_node, child_node)              \
-    for(child_node = parent_node->children; child_node != NULL; child_node = child_node->next)
+#define XML_FOREACH_CHILD(parent_node, child_node)                             \
+  for (child_node = parent_node->children; child_node != NULL;                 \
+       child_node = child_node->next)
 
 /* Makro to continue the iteration over an xml structure    */
 /* when the current node has the type 'text' or 'comment'   */
-#define XML_LOOP_IGNORE_COMMENT_OR_TEXT(node)                   \
-    if(xmlNodeIsText(node) || node->type == XML_COMMENT_NODE)   \
-    {                                                           \
-        continue;                                               \
-    }
+#define XML_LOOP_IGNORE_COMMENT_OR_TEXT(node)                                  \
+  if (xmlNodeIsText(node) || node->type == XML_COMMENT_NODE) {                 \
+    continue;                                                                  \
+  }
 
 /* Makro to set an XML error that an unknown node type      */
 /* occurred.                                                */
-#define XML_UNKNOWN_NODE_ERROR(node)                            \
-    msSetError(MS_WCSERR, "Unknown XML element '%s'.",          \
-            __FUNCTION__, (char *)node->name);                  \
-    return MS_FAILURE;
-
-#define XML_ASSERT_NODE_NAME(node,nodename)                     \
-    if(EQUAL((char *)node->name, nodename) == MS_FALSE)         \
-    {                                                           \
-        XML_UNKNOWN_NODE_ERROR(node);                           \
-    }
-
-#define MS_WCS_20_CAPABILITIES_INCLUDE_SECTION(params,section)  \
-    (params->sections == NULL                                   \
-    || CSLFindString(params->sections, "All") != -1             \
-    || CSLFindString(params->sections, section) != -1)
-
+#define XML_UNKNOWN_NODE_ERROR(node)                                           \
+  msSetError(MS_WCSERR, "Unknown XML element '%s'.", __FUNCTION__,             \
+             (char *)node->name);                                              \
+  return MS_FAILURE;
+
+#define XML_ASSERT_NODE_NAME(node, nodename)                                   \
+  if (EQUAL((char *)node->name, nodename) == MS_FALSE) {                       \
+    XML_UNKNOWN_NODE_ERROR(node);                                              \
+  }
+
+#define MS_WCS_20_CAPABILITIES_INCLUDE_SECTION(params, section)                \
+  (params->sections == NULL || CSLFindString(params->sections, "All") != -1 || \
+   CSLFindString(params->sections, section) != -1)
 
 #if defined(USE_LIBXML2)
 #include "maplibxml2.h"
-void msWCS_11_20_PrintMetadataLinks(layerObj *layer, xmlDocPtr doc, xmlNodePtr psCSummary);
+void msWCS_11_20_PrintMetadataLinks(layerObj *layer, xmlDocPtr doc,
+                                    xmlNodePtr psCSummary);
 #endif
 
 #ifdef __cplusplus
diff -pruN 8.0.1-5/mapwcs11.cpp 8.0.2-1/mapwcs11.cpp
--- 8.0.1-5/mapwcs11.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapwcs11.cpp	2024-06-11 20:41:34.000000000 +0000
@@ -37,7 +37,6 @@
 #include "mapwcs.h"
 #include "mapgdal.h"
 
-
 #if defined(USE_WCS_SVR)
 #include "mapwcs.h"
 #include "gdal.h"
@@ -61,31 +60,34 @@
 */
 
 int msWCSException11(mapObj *map, const char *exceptionCode,
-                     const char *locator, const char *version)
-{
+                     const char *locator, const char *version) {
   int size = 0;
-  char *errorString     = NULL;
+  char *errorString = NULL;
   char *schemasLocation = NULL;
 
-  xmlDocPtr  psDoc      = NULL;
+  xmlDocPtr psDoc = NULL;
   xmlNodePtr psRootNode = NULL;
-  xmlNsPtr   psNsOws    = NULL;
-  xmlChar *buffer       = NULL;
+  xmlNsPtr psNsOws = NULL;
+  xmlChar *buffer = NULL;
 
-  psNsOws = xmlNewNs(NULL, BAD_CAST "http://www.opengis.net/ows/1.1", BAD_CAST "ows");
+  psNsOws =
+      xmlNewNs(NULL, BAD_CAST "http://www.opengis.net/ows/1.1", BAD_CAST "ows");
 
   errorString = msGetErrorString("\n");
   schemasLocation = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
 
   psDoc = xmlNewDoc(BAD_CAST "1.0");
 
-  psRootNode = msOWSCommonExceptionReport(psNsOws, OWS_1_1_0, schemasLocation, version, msOWSGetLanguage(map, "exception"), exceptionCode, locator, errorString);
+  psRootNode = msOWSCommonExceptionReport(
+      psNsOws, OWS_1_1_0, schemasLocation, version,
+      msOWSGetLanguage(map, "exception"), exceptionCode, locator, errorString);
 
   xmlDocSetRootElement(psDoc, psRootNode);
 
-  xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/ows/1.1", BAD_CAST "ows");
+  xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/ows/1.1",
+           BAD_CAST "ows");
 
-  msIO_setHeader("Content-Type","text/xml; charset=UTF-8");
+  msIO_setHeader("Content-Type", "text/xml; charset=UTF-8");
   msIO_sendHeaders();
 
   xmlDocDumpFormatMemoryEnc(psDoc, &buffer, &size, "UTF-8", 1);
@@ -113,12 +115,12 @@ int msWCSException11(mapObj *map, const
 /*      the server.  Formats should be identified by mime type.         */
 /************************************************************************/
 
-static char *msWCSGetFormatsList11( mapObj *map, layerObj *layer )
+static char *msWCSGetFormatsList11(mapObj *map, layerObj *layer)
 
 {
   char *format_list = msStrdup("");
   char **tokens = NULL, **formats = NULL;
-  int  i, numtokens = 0, numformats;
+  int i, numtokens = 0, numformats;
   char *value;
 
   msApplyDefaultOutputFormats(map);
@@ -126,9 +128,9 @@ static char *msWCSGetFormatsList11( mapO
   /* -------------------------------------------------------------------- */
   /*      Parse from layer metadata.                                      */
   /* -------------------------------------------------------------------- */
-  if( layer != NULL
-      && (value = msOWSGetEncodeMetadata( &(layer->metadata),"CO","formats",
-                                          "GTiff" )) != NULL ) {
+  if (layer != NULL &&
+      (value = msOWSGetEncodeMetadata(&(layer->metadata), "CO", "formats",
+                                      "GTiff")) != NULL) {
     tokens = msStringSplit(value, ' ', &numtokens);
     msFree(value);
   }
@@ -136,8 +138,8 @@ static char *msWCSGetFormatsList11( mapO
   /* -------------------------------------------------------------------- */
   /*      Parse from map.web metadata.                                    */
   /* -------------------------------------------------------------------- */
-  else if((value = msOWSGetEncodeMetadata( &(map->web.metadata), "CO", "formats",
-                                           NULL)) != NULL ) {
+  else if ((value = msOWSGetEncodeMetadata(&(map->web.metadata), "CO",
+                                           "formats", NULL)) != NULL) {
     tokens = msStringSplit(value, ' ', &numtokens);
     msFree(value);
   }
@@ -147,19 +149,18 @@ static char *msWCSGetFormatsList11( mapO
   /*      look plausible.                                                 */
   /* -------------------------------------------------------------------- */
   else {
-    tokens = (char **) calloc(map->numoutputformats,sizeof(char*));
-    for( i = 0; i < map->numoutputformats; i++ ) {
-      switch( map->outputformatlist[i]->renderer ) {
-          /* seeminly normal raster format */
-        case MS_RENDER_WITH_AGG:
-        case MS_RENDER_WITH_RAWDATA:
-          tokens[numtokens++] = msStrdup(map->outputformatlist[i]->name);
-          break;
-
-          /* rest of formats aren't really WCS compatible */
-        default:
-          break;
+    tokens = (char **)calloc(map->numoutputformats, sizeof(char *));
+    for (i = 0; i < map->numoutputformats; i++) {
+      switch (map->outputformatlist[i]->renderer) {
+        /* seeminly normal raster format */
+      case MS_RENDER_WITH_AGG:
+      case MS_RENDER_WITH_RAWDATA:
+        tokens[numtokens++] = msStrdup(map->outputformatlist[i]->name);
+        break;
 
+        /* rest of formats aren't really WCS compatible */
+      default:
+        break;
       }
     }
   }
@@ -169,59 +170,57 @@ static char *msWCSGetFormatsList11( mapO
   /*      duplicates.                                                     */
   /* -------------------------------------------------------------------- */
   numformats = 0;
-  formats = (char **) calloc(sizeof(char*),numtokens);
+  formats = (char **)calloc(sizeof(char *), numtokens);
 
-  for( i = 0; i < numtokens; i++ ) {
+  for (i = 0; i < numtokens; i++) {
     int format_i, j;
     const char *mimetype;
 
-    for( format_i = 0; format_i < map->numoutputformats; format_i++ ) {
-      if( strcasecmp(map->outputformatlist[format_i]->name,
-                     tokens[i]) == 0 )
+    for (format_i = 0; format_i < map->numoutputformats; format_i++) {
+      if (strcasecmp(map->outputformatlist[format_i]->name, tokens[i]) == 0)
         break;
     }
 
-
-    if( format_i == map->numoutputformats ) {
+    if (format_i == map->numoutputformats) {
       msDebug("Failed to find outputformat info on format '%s', ignore.\n",
-              tokens[i] );
+              tokens[i]);
       continue;
     }
 
     mimetype = map->outputformatlist[format_i]->mimetype;
-    if( mimetype == NULL || strlen(mimetype) == 0 ) {
-      msDebug("No mimetime for format '%s', ignoring.\n",
-              tokens[i] );
+    if (mimetype == NULL || strlen(mimetype) == 0) {
+      msDebug("No mimetime for format '%s', ignoring.\n", tokens[i]);
       continue;
     }
 
-    for( j = 0; j < numformats; j++ ) {
-      if( strcasecmp(mimetype,formats[j]) == 0 )
+    for (j = 0; j < numformats; j++) {
+      if (strcasecmp(mimetype, formats[j]) == 0)
         break;
     }
 
-    if( j < numformats ) {
-      msDebug( "Format '%s' ignored since mimetype '%s' duplicates another outputFormatObj.\n",
-               tokens[i], mimetype );
+    if (j < numformats) {
+      msDebug("Format '%s' ignored since mimetype '%s' duplicates another "
+              "outputFormatObj.\n",
+              tokens[i], mimetype);
       continue;
     }
 
     formats[numformats++] = msStrdup(mimetype);
   }
 
-  msFreeCharArray(tokens,numtokens);
+  msFreeCharArray(tokens, numtokens);
 
   /* -------------------------------------------------------------------- */
   /*      Turn mimetype list into comma delimited form for easy use       */
   /*      with xml functions.                                             */
   /* -------------------------------------------------------------------- */
-  for(i=0; i<numformats; i++) {
-    if(i > 0) {
-      format_list = msStringConcatenate(format_list, (char *) ",");
+  for (i = 0; i < numformats; i++) {
+    if (i > 0) {
+      format_list = msStringConcatenate(format_list, (char *)",");
     }
     format_list = msStringConcatenate(format_list, formats[i]);
   }
-  msFreeCharArray(formats,numformats);
+  msFreeCharArray(formats, numformats);
 
   return format_list;
 }
@@ -231,17 +230,22 @@ static char *msWCSGetFormatsList11( mapO
 /************************************************************************/
 
 static void msWCS_11_20_PrintMetadataLink(layerObj *layer,
-                                          const std::string& radix,
+                                          const std::string &radix,
                                           xmlDocPtr doc,
-                                          xmlNodePtr psCSummary)
-{
-  const char* value = msOWSLookupMetadata(&(layer->metadata), "CO", (radix + "_href").c_str());
+                                          xmlNodePtr psCSummary) {
+  const char *value =
+      msOWSLookupMetadata(&(layer->metadata), "CO", (radix + "_href").c_str());
   if (value) {
-    xmlNsPtr psOwsNs = xmlSearchNs( doc, xmlDocGetRootElement(doc), BAD_CAST "ows" );
-    xmlNodePtr psMetadata = xmlNewChild(psCSummary, psOwsNs, BAD_CAST "Metadata", NULL);
-    xmlNsPtr psXlinkNs = xmlSearchNs( doc, xmlDocGetRootElement(doc), BAD_CAST "xlink" );
-    const char *metadatalink_type = msOWSLookupMetadata(&(layer->metadata), "CO", (radix + "_type").c_str());
-    const char *metadatalink_format = msOWSLookupMetadata(&(layer->metadata), "CO", (radix + "_format").c_str());
+    xmlNsPtr psOwsNs =
+        xmlSearchNs(doc, xmlDocGetRootElement(doc), BAD_CAST "ows");
+    xmlNodePtr psMetadata =
+        xmlNewChild(psCSummary, psOwsNs, BAD_CAST "Metadata", NULL);
+    xmlNsPtr psXlinkNs =
+        xmlSearchNs(doc, xmlDocGetRootElement(doc), BAD_CAST "xlink");
+    const char *metadatalink_type = msOWSLookupMetadata(
+        &(layer->metadata), "CO", (radix + "_type").c_str());
+    const char *metadatalink_format = msOWSLookupMetadata(
+        &(layer->metadata), "CO", (radix + "_format").c_str());
 
     xmlNewNsProp(psMetadata, psXlinkNs, BAD_CAST "type", BAD_CAST "simple");
     xmlNewNsProp(psMetadata, psXlinkNs, BAD_CAST "href", BAD_CAST value);
@@ -249,7 +253,8 @@ static void msWCS_11_20_PrintMetadataLin
       xmlNewProp(psMetadata, BAD_CAST "about", BAD_CAST metadatalink_type);
     }
     if (metadatalink_format != NULL) {
-      xmlNewNsProp(psMetadata, psXlinkNs, BAD_CAST "role", BAD_CAST metadatalink_format);
+      xmlNewNsProp(psMetadata, psXlinkNs, BAD_CAST "role",
+                   BAD_CAST metadatalink_format);
     }
   }
 }
@@ -259,14 +264,13 @@ static void msWCS_11_20_PrintMetadataLin
 /************************************************************************/
 
 void msWCS_11_20_PrintMetadataLinks(layerObj *layer, xmlDocPtr doc,
-                                    xmlNodePtr psCSummary)
-{
-  const char* list = msOWSLookupMetadata(&(layer->metadata), "CO", "metadatalink_list");
-  if( list ) {
+                                    xmlNodePtr psCSummary) {
+  const char *list =
+      msOWSLookupMetadata(&(layer->metadata), "CO", "metadatalink_list");
+  if (list) {
     int ntokens = 0;
-    char** tokens = msStringSplit(list, ' ', &ntokens);
-    for( int i = 0; i < ntokens; i++ )
-    {
+    char **tokens = msStringSplit(list, ' ', &ntokens);
+    for (int i = 0; i < ntokens; i++) {
       std::string key("metadatalink_");
       key += tokens[i];
       msWCS_11_20_PrintMetadataLink(layer, key, doc, psCSummary);
@@ -284,9 +288,9 @@ void msWCS_11_20_PrintMetadataLinks(laye
 /*      Generate a WCS 1.1 CoverageSummary.                             */
 /************************************************************************/
 
-static int msWCSGetCapabilities11_CoverageSummary(
-  mapObj *map,
-  xmlDocPtr doc, xmlNodePtr psContents, layerObj *layer )
+static int msWCSGetCapabilities11_CoverageSummary(mapObj *map, xmlDocPtr doc,
+                                                  xmlNodePtr psContents,
+                                                  layerObj *layer)
 
 {
   coverageMetadataObj cm;
@@ -295,29 +299,30 @@ static int msWCSGetCapabilities11_Covera
   char *owned_value;
   char *format_list;
   xmlNodePtr psCSummary;
-  xmlNsPtr psOwsNs = xmlSearchNs( doc, psContents, BAD_CAST "ows" );
+  xmlNsPtr psOwsNs = xmlSearchNs(doc, psContents, BAD_CAST "ows");
   int i = 0;
 
   status = msWCSGetCoverageMetadata(layer, &cm);
-  if(status != MS_SUCCESS) return MS_FAILURE;
+  if (status != MS_SUCCESS)
+    return MS_FAILURE;
 
-  psCSummary = xmlNewChild( psContents, NULL, BAD_CAST "CoverageSummary", NULL );
+  psCSummary = xmlNewChild(psContents, NULL, BAD_CAST "CoverageSummary", NULL);
 
   /* -------------------------------------------------------------------- */
   /*      Title (from description)                                        */
   /* -------------------------------------------------------------------- */
-  value = msOWSLookupMetadata( &(layer->metadata), "CO", "description");
-  if( value == NULL )
-    value = msOWSLookupMetadata( &(layer->metadata), "CO", "title");
-  if( value == NULL )
+  value = msOWSLookupMetadata(&(layer->metadata), "CO", "description");
+  if (value == NULL)
+    value = msOWSLookupMetadata(&(layer->metadata), "CO", "title");
+  if (value == NULL)
     value = layer->name;
-  xmlNewChild( psCSummary, psOwsNs, BAD_CAST "Title", BAD_CAST value );
+  xmlNewChild(psCSummary, psOwsNs, BAD_CAST "Title", BAD_CAST value);
 
   /* -------------------------------------------------------------------- */
   /*      Abstract                                                        */
   /* -------------------------------------------------------------------- */
-  value = msOWSLookupMetadata( &(layer->metadata), "CO", "abstract");
-  xmlNewChild( psCSummary, psOwsNs, BAD_CAST "Abstract", BAD_CAST value );
+  value = msOWSLookupMetadata(&(layer->metadata), "CO", "abstract");
+  xmlNewChild(psCSummary, psOwsNs, BAD_CAST "Abstract", BAD_CAST value);
 
   /* -------------------------------------------------------------------- */
   /*      Keywords                                                        */
@@ -330,10 +335,10 @@ static int msWCSGetCapabilities11_Covera
     psNode = xmlNewChild(psCSummary, psOwsNs, BAD_CAST "Keywords", NULL);
 
     int n = 0;
-    char** tokens = msStringSplit(value, ',', &n);
+    char **tokens = msStringSplit(value, ',', &n);
     if (tokens && n > 0) {
-      for (i=0; i<n; i++) {
-        xmlNewChild(psNode, NULL, BAD_CAST "Keyword", BAD_CAST tokens[i] );
+      for (i = 0; i < n; i++) {
+        xmlNewChild(psNode, NULL, BAD_CAST "Keyword", BAD_CAST tokens[i]);
       }
     }
     msFreeCharArray(tokens, n);
@@ -347,49 +352,44 @@ static int msWCSGetCapabilities11_Covera
   /* -------------------------------------------------------------------- */
   /*      WGS84 bounding box.                                             */
   /* -------------------------------------------------------------------- */
-  xmlAddChild(
-    psCSummary,
-    msOWSCommonWGS84BoundingBox( psOwsNs, 2,
-                                 cm.llextent.minx, cm.llextent.miny,
-                                 cm.llextent.maxx, cm.llextent.maxy ));
+  xmlAddChild(psCSummary, msOWSCommonWGS84BoundingBox(
+                              psOwsNs, 2, cm.llextent.minx, cm.llextent.miny,
+                              cm.llextent.maxx, cm.llextent.maxy));
 
   /* -------------------------------------------------------------------- */
   /*      Supported CRSes.                                                */
   /* -------------------------------------------------------------------- */
-  if( (owned_value =
-         msOWSGetProjURN( &(layer->projection), &(layer->metadata),
-                          "CO", MS_FALSE)) != NULL ) {
+  if ((owned_value = msOWSGetProjURN(&(layer->projection), &(layer->metadata),
+                                     "CO", MS_FALSE)) != NULL) {
     /* ok */
-  } else if((owned_value =
-               msOWSGetProjURN( &(layer->map->projection),
-                                &(layer->map->web.metadata),
-                                "CO", MS_FALSE)) != NULL ) {
+  } else if ((owned_value = msOWSGetProjURN(&(layer->map->projection),
+                                            &(layer->map->web.metadata), "CO",
+                                            MS_FALSE)) != NULL) {
     /* ok */
   } else
-    msDebug( "mapwcs.c: missing required information, no SRSs defined.\n");
+    msDebug("mapwcs.c: missing required information, no SRSs defined.\n");
 
-  if( owned_value != NULL && strlen(owned_value) > 0 )
-    msLibXml2GenerateList( psCSummary, NULL, "SupportedCRS",
-                           owned_value, ' ' );
+  if (owned_value != NULL && strlen(owned_value) > 0)
+    msLibXml2GenerateList(psCSummary, NULL, "SupportedCRS", owned_value, ' ');
 
-  msFree( owned_value );
+  msFree(owned_value);
 
   /* -------------------------------------------------------------------- */
   /*      SupportedFormats                                                */
   /* -------------------------------------------------------------------- */
-  format_list = msWCSGetFormatsList11( map, layer );
+  format_list = msWCSGetFormatsList11(map, layer);
 
-  if (strlen(format_list) > 0 )
-    msLibXml2GenerateList( psCSummary, NULL, "SupportedFormat",
-                           format_list, ',' );
+  if (strlen(format_list) > 0)
+    msLibXml2GenerateList(psCSummary, NULL, "SupportedFormat", format_list,
+                          ',');
 
-  msFree( format_list );
+  msFree(format_list);
   msWCSFreeCoverageMetadata(&cm);
 
   /* -------------------------------------------------------------------- */
   /*      Identifier (layer name)                                         */
   /* -------------------------------------------------------------------- */
-  xmlNewChild( psCSummary, NULL, BAD_CAST "Identifier", BAD_CAST layer->name );
+  xmlNewChild(psCSummary, NULL, BAD_CAST "Identifier", BAD_CAST layer->name);
 
   return MS_SUCCESS;
 }
@@ -398,16 +398,15 @@ static int msWCSGetCapabilities11_Covera
 /*                       msWCSGetCapabilities11()                       */
 /************************************************************************/
 int msWCSGetCapabilities11(mapObj *map, wcsParamsObj *params,
-                           cgiRequestObj *req, owsRequestObj *ows_request)
-{
-  xmlDocPtr psDoc = NULL;       /* document pointer */
+                           cgiRequestObj *req, owsRequestObj *ows_request) {
+  xmlDocPtr psDoc = NULL; /* document pointer */
   xmlNodePtr psRootNode, psMainNode, psNode;
   char *identifier_list = NULL, *format_list = NULL;
-  const char *updatesequence=NULL;
+  const char *updatesequence = NULL;
   xmlNsPtr psOwsNs, psXLinkNs;
   char *schemaLocation = NULL;
   char *xsi_schemaLocation = NULL;
-  char *script_url=NULL, *script_url_encoded=NULL;
+  char *script_url = NULL, *script_url_encoded = NULL;
 
   xmlChar *buffer = NULL;
   int size = 0, i;
@@ -419,17 +418,24 @@ int msWCSGetCapabilities11(mapObj *map,
   /*      Handle updatesequence                                           */
   /* -------------------------------------------------------------------- */
 
-  updatesequence = msOWSLookupMetadata(&(map->web.metadata), "CO", "updatesequence");
+  updatesequence =
+      msOWSLookupMetadata(&(map->web.metadata), "CO", "updatesequence");
 
   if (params->updatesequence != NULL) {
     i = msOWSNegotiateUpdateSequence(params->updatesequence, updatesequence);
     if (i == 0) { /* current */
-      msSetError(MS_WCSERR, "UPDATESEQUENCE parameter (%s) is equal to server (%s)", "msWCSGetCapabilities11()", params->updatesequence, updatesequence);
-      return msWCSException11(map, "CurrentUpdateSequence", "updatesequence", params->version);
+      msSetError(
+          MS_WCSERR, "UPDATESEQUENCE parameter (%s) is equal to server (%s)",
+          "msWCSGetCapabilities11()", params->updatesequence, updatesequence);
+      return msWCSException11(map, "CurrentUpdateSequence", "updatesequence",
+                              params->version);
     }
     if (i > 0) { /* invalid */
-      msSetError(MS_WCSERR, "UPDATESEQUENCE parameter (%s) is higher than server (%s)", "msWCSGetCapabilities11()", params->updatesequence, updatesequence);
-      return msWCSException11(map, "InvalidUpdateSequence", "updatesequence", params->version);
+      msSetError(
+          MS_WCSERR, "UPDATESEQUENCE parameter (%s) is higher than server (%s)",
+          "msWCSGetCapabilities11()", params->updatesequence, updatesequence);
+      return msWCSException11(map, "InvalidUpdateSequence", "updatesequence",
+                              params->version);
     }
   }
 
@@ -437,19 +443,19 @@ int msWCSGetCapabilities11(mapObj *map,
   /*      Build list of layer identifiers available.                      */
   /* -------------------------------------------------------------------- */
   identifier_list = msStrdup("");
-  for(i=0; i<map->numlayers; i++) {
+  for (i = 0; i < map->numlayers; i++) {
     layerObj *layer = map->layers[i];
-    int       new_length;
+    int new_length;
 
-    if(!msWCSIsLayerSupported(layer))
+    if (!msWCSIsLayerSupported(layer))
       continue;
 
     new_length = strlen(identifier_list) + strlen(layer->name) + 2;
-    identifier_list = (char *) realloc(identifier_list,new_length);
+    identifier_list = (char *)realloc(identifier_list, new_length);
 
-    if( strlen(identifier_list) > 0 )
-      strcat( identifier_list, "," );
-    strcat( identifier_list, layer->name );
+    if (strlen(identifier_list) > 0)
+      strcat(identifier_list, ",");
+    strcat(identifier_list, layer->name);
   }
 
   /* -------------------------------------------------------------------- */
@@ -464,95 +470,113 @@ int msWCSGetCapabilities11(mapObj *map,
   /* -------------------------------------------------------------------- */
   /*      Name spaces                                                     */
   /* -------------------------------------------------------------------- */
-  xmlSetNs(psRootNode, xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/wcs/1.1", NULL));
-  psOwsNs = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OWS_110_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_PREFIX);
-  psXLinkNs = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_PREFIX);
-  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX);
-  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OGC_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_OGC_NAMESPACE_PREFIX );
+  xmlSetNs(
+      psRootNode,
+      xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/wcs/1.1", NULL));
+  psOwsNs = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OWS_110_NAMESPACE_URI,
+                     BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_PREFIX);
+  psXLinkNs =
+      xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_URI,
+               BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_PREFIX);
+  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI,
+           BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX);
+  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OGC_NAMESPACE_URI,
+           BAD_CAST MS_OWSCOMMON_OGC_NAMESPACE_PREFIX);
 
   /*xmlNewProp(psRootNode, BAD_CAST " */
-  xmlNewProp(psRootNode, BAD_CAST "version", BAD_CAST params->version );
+  xmlNewProp(psRootNode, BAD_CAST "version", BAD_CAST params->version);
 
-  updatesequence = msOWSLookupMetadata(&(map->web.metadata), "CO", "updatesequence");
+  updatesequence =
+      msOWSLookupMetadata(&(map->web.metadata), "CO", "updatesequence");
 
   if (updatesequence)
     xmlNewProp(psRootNode, BAD_CAST "updateSequence", BAD_CAST updatesequence);
 
-  schemaLocation = msEncodeHTMLEntities( msOWSGetSchemasLocation(map) );
+  schemaLocation = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
   xsi_schemaLocation = msStrdup("http://www.opengis.net/wcs/1.1");
   xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
   xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, schemaLocation);
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, "/wcs/1.1/wcsGetCapabilities.xsd ");
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, MS_OWSCOMMON_OWS_110_NAMESPACE_URI);
+  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation,
+                                           "/wcs/1.1/wcsGetCapabilities.xsd ");
+  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation,
+                                           MS_OWSCOMMON_OWS_110_NAMESPACE_URI);
   xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
   xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, schemaLocation);
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, "/ows/1.1.0/owsAll.xsd");
-  xmlNewNsProp(psRootNode, NULL, BAD_CAST "xsi:schemaLocation", BAD_CAST xsi_schemaLocation);
+  xsi_schemaLocation =
+      msStringConcatenate(xsi_schemaLocation, "/ows/1.1.0/owsAll.xsd");
+  xmlNewNsProp(psRootNode, NULL, BAD_CAST "xsi:schemaLocation",
+               BAD_CAST xsi_schemaLocation);
   msFree(schemaLocation);
   msFree(xsi_schemaLocation);
 
   /* -------------------------------------------------------------------- */
   /*      Service metadata.                                               */
   /* -------------------------------------------------------------------- */
-  if( params->section == NULL
-      || strstr(params->section,"All") != NULL
-      || strstr(params->section,"ServiceIdentification") != NULL ) {
-    xmlAddChild(psRootNode, msOWSCommonServiceIdentification(
-                              psOwsNs, map, "OGC WCS", "2.0.1,1.1.1,1.0.0", "CO", NULL));
+  if (params->section == NULL || strstr(params->section, "All") != NULL ||
+      strstr(params->section, "ServiceIdentification") != NULL) {
+    xmlAddChild(psRootNode,
+                msOWSCommonServiceIdentification(
+                    psOwsNs, map, "OGC WCS", "2.0.1,1.1.1,1.0.0", "CO", NULL));
   }
 
   /*service provider*/
-  if( params->section == NULL
-      || strstr(params->section,"All") != NULL
-      || strstr(params->section,"ServiceProvider") != NULL ) {
-    xmlAddChild(psRootNode, msOWSCommonServiceProvider(
-                              psOwsNs, psXLinkNs, map, "CO", NULL));
+  if (params->section == NULL || strstr(params->section, "All") != NULL ||
+      strstr(params->section, "ServiceProvider") != NULL) {
+    xmlAddChild(psRootNode, msOWSCommonServiceProvider(psOwsNs, psXLinkNs, map,
+                                                       "CO", NULL));
   }
 
   /* -------------------------------------------------------------------- */
   /*      Operations metadata.                                            */
   /* -------------------------------------------------------------------- */
   /*operation metadata */
-  if ((script_url=msOWSGetOnlineResource(map, "CO", "onlineresource", req)) == NULL
-      || (script_url_encoded = msEncodeHTMLEntities(script_url)) == NULL) {
+  if ((script_url = msOWSGetOnlineResource(map, "CO", "onlineresource", req)) ==
+          NULL ||
+      (script_url_encoded = msEncodeHTMLEntities(script_url)) == NULL) {
     msSetError(MS_WCSERR, "Server URL not found", "msWCSGetCapabilities11()");
-    return msWCSException11(map, "NoApplicableCode", "mapserv", params->version);
+    return msWCSException11(map, "NoApplicableCode", "mapserv",
+                            params->version);
   }
-  free( script_url );
+  free(script_url);
 
-  if( params->section == NULL
-      || strstr(params->section,"All") != NULL
-      || strstr(params->section,"OperationsMetadata") != NULL ) {
-    psMainNode= xmlAddChild(psRootNode,msOWSCommonOperationsMetadata(psOwsNs));
+  if (params->section == NULL || strstr(params->section, "All") != NULL ||
+      strstr(params->section, "OperationsMetadata") != NULL) {
+    psMainNode =
+        xmlAddChild(psRootNode, msOWSCommonOperationsMetadata(psOwsNs));
 
     /* -------------------------------------------------------------------- */
     /*      GetCapabilities - add Sections and AcceptVersions?              */
     /* -------------------------------------------------------------------- */
     psNode = msOWSCommonOperationsMetadataOperation(
-               psOwsNs, psXLinkNs,
-               "GetCapabilities", OWS_METHOD_GETPOST, script_url_encoded);
+        psOwsNs, psXLinkNs, "GetCapabilities", OWS_METHOD_GETPOST,
+        script_url_encoded);
 
     xmlAddChild(psMainNode, psNode);
+    xmlAddChild(psNode,
+                msOWSCommonOperationsMetadataDomainType(
+                    ows_version, psOwsNs, "Parameter", "service", "WCS"));
     xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
-                  ows_version, psOwsNs, "Parameter", "service", "WCS"));
-    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
-                  ows_version, psOwsNs, "Parameter", "version", (char *)params->version));
+                            ows_version, psOwsNs, "Parameter", "version",
+                            (char *)params->version));
 
     /* -------------------------------------------------------------------- */
     /*      DescribeCoverage                                                */
     /* -------------------------------------------------------------------- */
     if (msOWSRequestIsEnabled(map, NULL, "C", "DescribeCoverage", MS_FALSE)) {
       psNode = msOWSCommonOperationsMetadataOperation(
-                 psOwsNs, psXLinkNs,
-                 "DescribeCoverage", OWS_METHOD_GETPOST, script_url_encoded);
+          psOwsNs, psXLinkNs, "DescribeCoverage", OWS_METHOD_GETPOST,
+          script_url_encoded);
 
       xmlAddChild(psMainNode, psNode);
+      xmlAddChild(psNode,
+                  msOWSCommonOperationsMetadataDomainType(
+                      ows_version, psOwsNs, "Parameter", "service", "WCS"));
       xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
-                    ows_version, psOwsNs, "Parameter", "service", "WCS"));
-      xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
-                    ows_version, psOwsNs, "Parameter", "version", (char *)params->version));
+                              ows_version, psOwsNs, "Parameter", "version",
+                              (char *)params->version));
       xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
-                    ows_version, psOwsNs, "Parameter", "identifiers", identifier_list ));
+                              ows_version, psOwsNs, "Parameter", "identifiers",
+                              identifier_list));
     }
 
     /* -------------------------------------------------------------------- */
@@ -561,59 +585,66 @@ int msWCSGetCapabilities11(mapObj *map,
     if (msOWSRequestIsEnabled(map, NULL, "C", "GetCoverage", MS_FALSE)) {
 
       psNode = msOWSCommonOperationsMetadataOperation(
-                 psOwsNs, psXLinkNs,
-                 "GetCoverage", OWS_METHOD_GETPOST, script_url_encoded);
+          psOwsNs, psXLinkNs, "GetCoverage", OWS_METHOD_GETPOST,
+          script_url_encoded);
 
-      format_list = msWCSGetFormatsList11( map, NULL );
+      format_list = msWCSGetFormatsList11(map, NULL);
 
       xmlAddChild(psMainNode, psNode);
+      xmlAddChild(psNode,
+                  msOWSCommonOperationsMetadataDomainType(
+                      ows_version, psOwsNs, "Parameter", "service", "WCS"));
       xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
-                    ows_version, psOwsNs, "Parameter", "service", "WCS"));
-      xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
-                    ows_version, psOwsNs, "Parameter", "version", (char *)params->version));
-      xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
-                    ows_version, psOwsNs, "Parameter", "Identifier", identifier_list ));
+                              ows_version, psOwsNs, "Parameter", "version",
+                              (char *)params->version));
       xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
-                    ows_version, psOwsNs, "Parameter", "InterpolationType",
-                    "NEAREST_NEIGHBOUR,BILINEAR" ));
+                              ows_version, psOwsNs, "Parameter", "Identifier",
+                              identifier_list));
+      xmlAddChild(psNode,
+                  msOWSCommonOperationsMetadataDomainType(
+                      ows_version, psOwsNs, "Parameter", "InterpolationType",
+                      "NEAREST_NEIGHBOUR,BILINEAR"));
       xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
-                    ows_version, psOwsNs, "Parameter", "format", format_list ));
+                              ows_version, psOwsNs, "Parameter", "format",
+                              format_list));
+      xmlAddChild(psNode,
+                  msOWSCommonOperationsMetadataDomainType(
+                      ows_version, psOwsNs, "Parameter", "store", "false"));
       xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
-                    ows_version, psOwsNs, "Parameter", "store", "false" ));
-      xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
-                    ows_version, psOwsNs, "Parameter", "GridBaseCRS",
-                    "urn:ogc:def:crs:epsg::4326" ));
+                              ows_version, psOwsNs, "Parameter", "GridBaseCRS",
+                              "urn:ogc:def:crs:epsg::4326"));
 
-      msFree( format_list );
+      msFree(format_list);
     }
   }
 
   /* -------------------------------------------------------------------- */
   /*      Contents section.                                               */
   /* -------------------------------------------------------------------- */
-  if( params->section == NULL
-      || strstr(params->section,"All") != NULL
-      || strstr(params->section,"Contents") != NULL ) {
-    psMainNode = xmlNewChild( psRootNode, NULL, BAD_CAST "Contents", NULL );
+  if (params->section == NULL || strstr(params->section, "All") != NULL ||
+      strstr(params->section, "Contents") != NULL) {
+    psMainNode = xmlNewChild(psRootNode, NULL, BAD_CAST "Contents", NULL);
 
-    if(ows_request->numlayers == 0) {
+    if (ows_request->numlayers == 0) {
       xmlAddChild(psMainNode,
-                  xmlNewComment(BAD_CAST "WARNING: No WCS layers are enabled. "
+                  xmlNewComment(BAD_CAST
+                                "WARNING: No WCS layers are enabled. "
                                 "Check wcs/ows_enable_request settings."));
     } else {
-      for(i=0; i<map->numlayers; i++) {
+      for (i = 0; i < map->numlayers; i++) {
         layerObj *layer = map->layers[i];
-        int       status;
+        int status;
 
-        if(!msWCSIsLayerSupported(layer))
+        if (!msWCSIsLayerSupported(layer))
           continue;
 
-        if (!msIntegerInArray(layer->index, ows_request->enabled_layers, ows_request->numlayers))
+        if (!msIntegerInArray(layer->index, ows_request->enabled_layers,
+                              ows_request->numlayers))
           continue;
 
-        status = msWCSGetCapabilities11_CoverageSummary(
-                   map, psDoc, psMainNode, layer );
-        if(status != MS_SUCCESS) {
+        status = msWCSGetCapabilities11_CoverageSummary(map, psDoc, psMainNode,
+                                                        layer);
+        if (status != MS_SUCCESS) {
           msFree(identifier_list);
           return MS_FAILURE;
         }
@@ -625,10 +656,10 @@ int msWCSGetCapabilities11(mapObj *map,
   /*      Write out the document.                                         */
   /* -------------------------------------------------------------------- */
 
-  if( msIO_needBinaryStdout() == MS_FAILURE )
+  if (msIO_needBinaryStdout() == MS_FAILURE)
     return MS_FAILURE;
 
-  msIO_setHeader("Content-Type","text/xml; charset=UTF-8");
+  msIO_setHeader("Content-Type", "text/xml; charset=UTF-8");
   msIO_sendHeaders();
 
   context = msIO_getHandler(stdout);
@@ -644,20 +675,20 @@ int msWCSGetCapabilities11(mapObj *map,
   xmlCleanupParser();
 
   /* clean up */
-  free( script_url_encoded );
-  free( identifier_list );
+  free(script_url_encoded);
+  free(identifier_list);
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
 /************************************************************************/
 /*            msWCSDescribeCoverage_CoverageDescription11()             */
 /************************************************************************/
 
-static int
-msWCSDescribeCoverage_CoverageDescription11(
-  layerObj *layer, wcsParamsObj *params, xmlNodePtr psRootNode,
-  xmlNsPtr psOwsNs )
+static int msWCSDescribeCoverage_CoverageDescription11(layerObj *layer,
+                                                       wcsParamsObj *params,
+                                                       xmlNodePtr psRootNode,
+                                                       xmlNsPtr psOwsNs)
 
 {
   int status;
@@ -668,39 +699,40 @@ msWCSDescribeCoverage_CoverageDescriptio
   /* -------------------------------------------------------------------- */
   /*      Verify layer is processable.                                    */
   /* -------------------------------------------------------------------- */
-  if( msCheckParentPointer(layer->map,"map") == MS_FAILURE )
+  if (msCheckParentPointer(layer->map, "map") == MS_FAILURE)
     return MS_FAILURE;
 
-  if(!msWCSIsLayerSupported(layer))
+  if (!msWCSIsLayerSupported(layer))
     return MS_SUCCESS;
 
   /* -------------------------------------------------------------------- */
   /*      Setup coverage metadata.                                        */
   /* -------------------------------------------------------------------- */
   status = msWCSGetCoverageMetadata(layer, &cm);
-  if(status != MS_SUCCESS) return status;
+  if (status != MS_SUCCESS)
+    return status;
 
   /* fill in bands rangeset info, if required.  */
-  msWCSSetDefaultBandsRangeSetInfo( params, &cm, layer );
+  msWCSSetDefaultBandsRangeSetInfo(params, &cm, layer);
 
   /* -------------------------------------------------------------------- */
   /*      Create CoverageDescription node.                                */
   /* -------------------------------------------------------------------- */
-  psCD = xmlNewChild( psRootNode, NULL, BAD_CAST "CoverageDescription", NULL );
+  psCD = xmlNewChild(psRootNode, NULL, BAD_CAST "CoverageDescription", NULL);
 
   /* -------------------------------------------------------------------- */
   /*      Title (from description)                                        */
   /* -------------------------------------------------------------------- */
-  value = msOWSLookupMetadata( &(layer->metadata), "CO", "description");
-  if( value == NULL )
+  value = msOWSLookupMetadata(&(layer->metadata), "CO", "description");
+  if (value == NULL)
     value = layer->name;
-  xmlNewChild( psCD, psOwsNs, BAD_CAST "Title", BAD_CAST value );
+  xmlNewChild(psCD, psOwsNs, BAD_CAST "Title", BAD_CAST value);
 
   /* -------------------------------------------------------------------- */
   /*      Abstract                                                        */
   /* -------------------------------------------------------------------- */
-  value = msOWSLookupMetadata( &(layer->metadata), "CO", "abstract");
-  xmlNewChild( psCD, psOwsNs, BAD_CAST "Abstract", BAD_CAST value );
+  value = msOWSLookupMetadata(&(layer->metadata), "CO", "abstract");
+  xmlNewChild(psCD, psOwsNs, BAD_CAST "Abstract", BAD_CAST value);
 
   /* -------------------------------------------------------------------- */
   /*      Keywords                                                        */
@@ -708,50 +740,44 @@ msWCSDescribeCoverage_CoverageDescriptio
   value = msOWSLookupMetadata(&(layer->metadata), "CO", "keywordlist");
 
   if (value)
-    msLibXml2GenerateList(
-      xmlNewChild(psCD, psOwsNs, BAD_CAST "Keywords", NULL),
-      NULL, "Keyword", value, ',' );
+    msLibXml2GenerateList(xmlNewChild(psCD, psOwsNs, BAD_CAST "Keywords", NULL),
+                          NULL, "Keyword", value, ',');
 
   /* -------------------------------------------------------------------- */
   /*      Identifier (layer name)                                         */
   /* -------------------------------------------------------------------- */
-  xmlNewChild( psCD, NULL, BAD_CAST "Identifier", BAD_CAST layer->name);
+  xmlNewChild(psCD, NULL, BAD_CAST "Identifier", BAD_CAST layer->name);
 
   /* -------------------------------------------------------------------- */
   /*      Domain                                                          */
   /* -------------------------------------------------------------------- */
-  psDomain = xmlNewChild( psCD, NULL, BAD_CAST "Domain", NULL );
+  psDomain = xmlNewChild(psCD, NULL, BAD_CAST "Domain", NULL);
 
   /* -------------------------------------------------------------------- */
   /*      SpatialDomain                                                   */
   /* -------------------------------------------------------------------- */
-  psSD = xmlNewChild( psDomain, NULL, BAD_CAST "SpatialDomain", NULL );
+  psSD = xmlNewChild(psDomain, NULL, BAD_CAST "SpatialDomain", NULL);
 
   /* -------------------------------------------------------------------- */
   /*      imageCRS bounding box.                                          */
   /* -------------------------------------------------------------------- */
-  xmlAddChild(
-    psSD,
-    msOWSCommonBoundingBox( psOwsNs, "urn:ogc:def:crs:OGC::imageCRS",
-                            2, 0, 0, cm.xsize-1, cm.ysize-1 ));
+  xmlAddChild(psSD,
+              msOWSCommonBoundingBox(psOwsNs, "urn:ogc:def:crs:OGC::imageCRS",
+                                     2, 0, 0, cm.xsize - 1, cm.ysize - 1));
 
   /* -------------------------------------------------------------------- */
   /*      native CRS bounding box.                                        */
   /* -------------------------------------------------------------------- */
-  xmlAddChild(
-    psSD,
-    msOWSCommonBoundingBox( psOwsNs, cm.srs_urn, 2,
-                            cm.extent.minx, cm.extent.miny,
-                            cm.extent.maxx, cm.extent.maxy ));
+  xmlAddChild(psSD, msOWSCommonBoundingBox(psOwsNs, cm.srs_urn, 2,
+                                           cm.extent.minx, cm.extent.miny,
+                                           cm.extent.maxx, cm.extent.maxy));
 
   /* -------------------------------------------------------------------- */
   /*      WGS84 bounding box.                                             */
   /* -------------------------------------------------------------------- */
-  xmlAddChild(
-    psSD,
-    msOWSCommonWGS84BoundingBox( psOwsNs, 2,
-                                 cm.llextent.minx, cm.llextent.miny,
-                                 cm.llextent.maxx, cm.llextent.maxy ));
+  xmlAddChild(psSD, msOWSCommonWGS84BoundingBox(
+                        psOwsNs, 2, cm.llextent.minx, cm.llextent.miny,
+                        cm.llextent.maxx, cm.llextent.maxy));
 
   /* -------------------------------------------------------------------- */
   /*      GridCRS                                                         */
@@ -759,46 +785,51 @@ msWCSDescribeCoverage_CoverageDescriptio
   {
     char format_buf[500];
     projectionObj proj;
-    double x0 = cm.geotransform[0]+cm.geotransform[1]/2+cm.geotransform[2]/2;
-    double y0 = cm.geotransform[3]+cm.geotransform[4]/2+cm.geotransform[5]/2;
+    double x0 =
+        cm.geotransform[0] + cm.geotransform[1] / 2 + cm.geotransform[2] / 2;
+    double y0 =
+        cm.geotransform[3] + cm.geotransform[4] / 2 + cm.geotransform[5] / 2;
     double resx = cm.geotransform[1];
     double resy = cm.geotransform[5];
 
-    msInitProjection( &proj );
+    msInitProjection(&proj);
     msProjectionInheritContextFrom(&proj, &(layer->projection));
-    if( msLoadProjectionString( &proj, cm.srs_urn ) == 0 ) {
-      msAxisNormalizePoints( &proj, 1, &x0, &y0 );
-      msAxisNormalizePoints( &proj, 1, &resx, &resy );
+    if (msLoadProjectionString(&proj, cm.srs_urn) == 0) {
+      msAxisNormalizePoints(&proj, 1, &x0, &y0);
+      msAxisNormalizePoints(&proj, 1, &resx, &resy);
     }
-    msFreeProjection( &proj );
+    msFreeProjection(&proj);
 
-    psGridCRS = xmlNewChild( psSD, NULL, BAD_CAST "GridCRS", NULL );
+    psGridCRS = xmlNewChild(psSD, NULL, BAD_CAST "GridCRS", NULL);
 
-    xmlNewChild( psGridCRS, NULL, BAD_CAST "GridBaseCRS", BAD_CAST cm.srs_urn );
-    xmlNewChild( psGridCRS, NULL, BAD_CAST "GridType",
-                 BAD_CAST "urn:ogc:def:method:WCS:1.1:2dSimpleGrid" );
+    xmlNewChild(psGridCRS, NULL, BAD_CAST "GridBaseCRS", BAD_CAST cm.srs_urn);
+    xmlNewChild(psGridCRS, NULL, BAD_CAST "GridType",
+                BAD_CAST "urn:ogc:def:method:WCS:1.1:2dSimpleGrid");
 
-    sprintf( format_buf, "%.15g %.15g", x0, y0 );
-    xmlNewChild( psGridCRS, NULL, BAD_CAST "GridOrigin", BAD_CAST format_buf );
+    sprintf(format_buf, "%.15g %.15g", x0, y0);
+    xmlNewChild(psGridCRS, NULL, BAD_CAST "GridOrigin", BAD_CAST format_buf);
 
-    sprintf( format_buf, "%.15g %.15g", resx, resy );
-    xmlNewChild( psGridCRS, NULL, BAD_CAST "GridOffsets", BAD_CAST format_buf );
+    sprintf(format_buf, "%.15g %.15g", resx, resy);
+    xmlNewChild(psGridCRS, NULL, BAD_CAST "GridOffsets", BAD_CAST format_buf);
 
-    xmlNewChild( psGridCRS, NULL, BAD_CAST "GridCS",
-                 BAD_CAST "urn:ogc:def:cs:OGC:0.0:Grid2dSquareCS" );
+    xmlNewChild(psGridCRS, NULL, BAD_CAST "GridCS",
+                BAD_CAST "urn:ogc:def:cs:OGC:0.0:Grid2dSquareCS");
   }
 
-
-
 #ifdef notdef
   /* TemporalDomain */
 
-  /* TODO: figure out when a temporal domain is valid, for example only tiled rasters support time as a domain, plus we need a timeitem */
-  if(msOWSLookupMetadata(&(layer->metadata), "CO", "timeposition") || msOWSLookupMetadata(&(layer->metadata), "CO", "timeperiod")) {
+  /* TODO: figure out when a temporal domain is valid, for example only tiled
+   * rasters support time as a domain, plus we need a timeitem */
+  if (msOWSLookupMetadata(&(layer->metadata), "CO", "timeposition") ||
+      msOWSLookupMetadata(&(layer->metadata), "CO", "timeperiod")) {
     msIO_printf("      <temporalDomain>\n");
 
-    /* TimePosition (should support a value AUTO, then we could mine positions from the timeitem) */
-    msOWSPrintEncodeMetadataList(stdout, &(layer->metadata), "CO", "timeposition", NULL, NULL, "        <gml:timePosition>%s</gml:timePosition>\n", NULL);
+    /* TimePosition (should support a value AUTO, then we could mine positions
+     * from the timeitem) */
+    msOWSPrintEncodeMetadataList(
+        stdout, &(layer->metadata), "CO", "timeposition", NULL, NULL,
+        "        <gml:timePosition>%s</gml:timePosition>\n", NULL);
 
     /* TODO:  add TimePeriod (only one per layer)  */
 
@@ -815,43 +846,40 @@ msWCSDescribeCoverage_CoverageDescriptio
     xmlNodePtr psField, psInterpMethods, psAxis;
     char *value;
 
-    psField =
-      xmlNewChild(
-        xmlNewChild( psCD, NULL, BAD_CAST "Range", NULL ),
-        NULL, BAD_CAST "Field", NULL );
-
-    value = msOWSGetEncodeMetadata( &(layer->metadata), "CO",
-                                    "rangeset_label", NULL );
-    if( value )
-      xmlNewChild( psField, psOwsNs, BAD_CAST "Title", BAD_CAST value );
+    psField = xmlNewChild(xmlNewChild(psCD, NULL, BAD_CAST "Range", NULL), NULL,
+                          BAD_CAST "Field", NULL);
+
+    value = msOWSGetEncodeMetadata(&(layer->metadata), "CO", "rangeset_label",
+                                   NULL);
+    if (value)
+      xmlNewChild(psField, psOwsNs, BAD_CAST "Title", BAD_CAST value);
     msFree(value);
 
     /* ows:Abstract? TODO */
 
-    value = msOWSGetEncodeMetadata( &(layer->metadata), "CO",
-                                    "rangeset_name", "raster" );
-    xmlNewChild( psField, NULL, BAD_CAST "Identifier", BAD_CAST value );
+    value = msOWSGetEncodeMetadata(&(layer->metadata), "CO", "rangeset_name",
+                                   "raster");
+    xmlNewChild(psField, NULL, BAD_CAST "Identifier", BAD_CAST value);
     msFree(value);
 
-    xmlNewChild(
-        xmlNewChild( psField, NULL, BAD_CAST "Definition", NULL ),
-        psOwsNs, BAD_CAST "AnyValue", NULL );
+    xmlNewChild(xmlNewChild(psField, NULL, BAD_CAST "Definition", NULL),
+                psOwsNs, BAD_CAST "AnyValue", NULL);
 
     /* NullValue */
-    value = msOWSGetEncodeMetadata( &(layer->metadata), "CO",
-                                    "rangeset_nullvalue", NULL);
-    if( value )
-      xmlNewChild( psField, NULL, BAD_CAST "NullValue",
-                   BAD_CAST value );
+    value = msOWSGetEncodeMetadata(&(layer->metadata), "CO",
+                                   "rangeset_nullvalue", NULL);
+    if (value)
+      xmlNewChild(psField, NULL, BAD_CAST "NullValue", BAD_CAST value);
     msFree(value);
 
     /* InterpolationMethods */
     psInterpMethods =
-      xmlNewChild( psField, NULL, BAD_CAST "InterpolationMethods", NULL );
+        xmlNewChild(psField, NULL, BAD_CAST "InterpolationMethods", NULL);
 
-    xmlNewChild( psInterpMethods, NULL, BAD_CAST "InterpolationMethod", BAD_CAST "bilinear" );
-    xmlNewChild( psInterpMethods, NULL,
-                 BAD_CAST "Default", BAD_CAST "nearest neighbor" );
+    xmlNewChild(psInterpMethods, NULL, BAD_CAST "InterpolationMethod",
+                BAD_CAST "bilinear");
+    xmlNewChild(psInterpMethods, NULL, BAD_CAST "Default",
+                BAD_CAST "nearest neighbor");
 
     /* -------------------------------------------------------------------- */
     /*      Bands axis.                                                     */
@@ -860,21 +888,19 @@ msWCSDescribeCoverage_CoverageDescriptio
       xmlNodePtr psKeys;
       int iBand;
 
-      value = msOWSGetEncodeMetadata( &(layer->metadata), "CO",
-                                      "bands_name", "bands" );
-      psAxis = xmlNewChild( psField, NULL, BAD_CAST "Axis", NULL );
-      xmlNewProp( psAxis, BAD_CAST "identifier", BAD_CAST value );
+      value = msOWSGetEncodeMetadata(&(layer->metadata), "CO", "bands_name",
+                                     "bands");
+      psAxis = xmlNewChild(psField, NULL, BAD_CAST "Axis", NULL);
+      xmlNewProp(psAxis, BAD_CAST "identifier", BAD_CAST value);
       msFree(value);
 
-      psKeys = xmlNewChild( psAxis, NULL, BAD_CAST
-                            "AvailableKeys",  NULL );
+      psKeys = xmlNewChild(psAxis, NULL, BAD_CAST "AvailableKeys", NULL);
 
-      for( iBand = 0; iBand < cm.bandcount; iBand++ ) {
+      for (iBand = 0; iBand < cm.bandcount; iBand++) {
         char szBandName[32];
 
-        snprintf( szBandName, sizeof(szBandName), "%d", iBand+1 );
-        xmlNewChild( psKeys, NULL, BAD_CAST "Key",
-                     BAD_CAST szBandName );
+        snprintf(szBandName, sizeof(szBandName), "%d", iBand + 1);
+        xmlNewChild(psKeys, NULL, BAD_CAST "Key", BAD_CAST szBandName);
       }
     }
   }
@@ -885,23 +911,20 @@ msWCSDescribeCoverage_CoverageDescriptio
   {
     char *owned_value;
 
-    if( (owned_value =
-           msOWSGetProjURN( &(layer->projection), &(layer->metadata),
-                            "CO", MS_FALSE)) != NULL ) {
+    if ((owned_value = msOWSGetProjURN(&(layer->projection), &(layer->metadata),
+                                       "CO", MS_FALSE)) != NULL) {
       /* ok */
-    } else if((owned_value =
-                 msOWSGetProjURN( &(layer->map->projection),
-                                  &(layer->map->web.metadata),
-                                  "CO", MS_FALSE)) != NULL ) {
+    } else if ((owned_value = msOWSGetProjURN(&(layer->map->projection),
+                                              &(layer->map->web.metadata), "CO",
+                                              MS_FALSE)) != NULL) {
       /* ok */
     } else
-      msDebug( "mapwcs.c: missing required information, no SRSs defined.\n");
+      msDebug("mapwcs.c: missing required information, no SRSs defined.\n");
 
-    if( owned_value != NULL && strlen(owned_value) > 0 )
-      msLibXml2GenerateList( psCD, NULL, "SupportedCRS",
-                             owned_value, ' ' );
+    if (owned_value != NULL && strlen(owned_value) > 0)
+      msLibXml2GenerateList(psCD, NULL, "SupportedCRS", owned_value, ' ');
 
-    msFree( owned_value );
+    msFree(owned_value);
   }
 
   /* -------------------------------------------------------------------- */
@@ -910,13 +933,12 @@ msWCSDescribeCoverage_CoverageDescriptio
   {
     char *format_list;
 
-    format_list = msWCSGetFormatsList11( layer->map, layer );
+    format_list = msWCSGetFormatsList11(layer->map, layer);
 
-    if (strlen(format_list) > 0 )
-      msLibXml2GenerateList( psCD, NULL, "SupportedFormat",
-                             format_list, ',' );
+    if (strlen(format_list) > 0)
+      msLibXml2GenerateList(psCD, NULL, "SupportedFormat", format_list, ',');
 
-    msFree( format_list );
+    msFree(format_list);
   }
   msWCSFreeCoverageMetadata(&cm);
 
@@ -927,15 +949,15 @@ msWCSDescribeCoverage_CoverageDescriptio
 /*                      msWCSDescribeCoverage11()                       */
 /************************************************************************/
 
-int msWCSDescribeCoverage11(mapObj *map, wcsParamsObj *params, owsRequestObj *ows_request)
-{
-  xmlDocPtr psDoc = NULL;       /* document pointer */
+int msWCSDescribeCoverage11(mapObj *map, wcsParamsObj *params,
+                            owsRequestObj *ows_request) {
+  xmlDocPtr psDoc = NULL; /* document pointer */
   xmlNodePtr psRootNode;
   xmlNsPtr psOwsNs;
   char *schemaLocation = NULL;
   char *xsi_schemaLocation = NULL;
 
-  int i,j;
+  int i, j;
 
   /* -------------------------------------------------------------------- */
   /*      We will actually get the coverages list as a single item in     */
@@ -943,25 +965,26 @@ int msWCSDescribeCoverage11(mapObj *map,
   /*      coverage names.  Split it up now, and assign back in place      */
   /*      of the old coverages list.                                      */
   /* -------------------------------------------------------------------- */
-  if( CSLCount(params->coverages) == 1 ) {
+  if (CSLCount(params->coverages) == 1) {
     char **old_coverages = params->coverages;
-    params->coverages = CSLTokenizeStringComplex( old_coverages[0], ",",
-                        FALSE, FALSE );
-    CSLDestroy( old_coverages );
+    params->coverages =
+        CSLTokenizeStringComplex(old_coverages[0], ",", FALSE, FALSE);
+    CSLDestroy(old_coverages);
   }
 
   /* -------------------------------------------------------------------- */
   /*      Validate that the requested coverages exist as named layers.    */
   /* -------------------------------------------------------------------- */
-  if(params->coverages) { /* use the list */
-    for( j = 0; params->coverages[j]; j++ ) {
+  if (params->coverages) { /* use the list */
+    for (j = 0; params->coverages[j]; j++) {
       i = msGetLayerIndex(map, params->coverages[j]);
-      if ( (i == -1) ||
-           (!msIntegerInArray(GET_LAYER(map, i)->index, ows_request->enabled_layers, ows_request->numlayers)) ) {
-        msSetError( MS_WCSERR,
-                    "COVERAGE %s cannot be opened / does not exist",
-                    "msWCSDescribeCoverage()", params->coverages[j]);
-        return msWCSException11(map, "CoverageNotDefined", "coverage", params->version);
+      if ((i == -1) || (!msIntegerInArray(GET_LAYER(map, i)->index,
+                                          ows_request->enabled_layers,
+                                          ows_request->numlayers))) {
+        msSetError(MS_WCSERR, "COVERAGE %s cannot be opened / does not exist",
+                   "msWCSDescribeCoverage()", params->coverages[j]);
+        return msWCSException11(map, "CoverageNotDefined", "coverage",
+                                params->version);
       }
     }
   }
@@ -978,22 +1001,32 @@ int msWCSDescribeCoverage11(mapObj *map,
   /* -------------------------------------------------------------------- */
   /*      Name spaces                                                     */
   /* -------------------------------------------------------------------- */
-  xmlSetNs(psRootNode, xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/wcs/1.1", NULL));
-  psOwsNs = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OWS_110_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_PREFIX);
-  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_PREFIX);
-  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX);
-  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OGC_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_OGC_NAMESPACE_PREFIX );
+  xmlSetNs(
+      psRootNode,
+      xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/wcs/1.1", NULL));
+  psOwsNs = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OWS_110_NAMESPACE_URI,
+                     BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_PREFIX);
+  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_URI,
+           BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_PREFIX);
+  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI,
+           BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX);
+  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OGC_NAMESPACE_URI,
+           BAD_CAST MS_OWSCOMMON_OGC_NAMESPACE_PREFIX);
 
-  schemaLocation = msEncodeHTMLEntities( msOWSGetSchemasLocation(map) );
+  schemaLocation = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
   xsi_schemaLocation = msStrdup("http://www.opengis.net/wcs/1.1");
   xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
   xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, schemaLocation);
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, "/wcs/1.1/wcsDescribeCoverage.xsd ");
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, MS_OWSCOMMON_OWS_110_NAMESPACE_URI);
+  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation,
+                                           "/wcs/1.1/wcsDescribeCoverage.xsd ");
+  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation,
+                                           MS_OWSCOMMON_OWS_110_NAMESPACE_URI);
   xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
   xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, schemaLocation);
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, "/ows/1.1.0/owsAll.xsd");
-  xmlNewNsProp(psRootNode, NULL, BAD_CAST "xsi:schemaLocation", BAD_CAST xsi_schemaLocation);
+  xsi_schemaLocation =
+      msStringConcatenate(xsi_schemaLocation, "/ows/1.1.0/owsAll.xsd");
+  xmlNewNsProp(psRootNode, NULL, BAD_CAST "xsi:schemaLocation",
+               BAD_CAST xsi_schemaLocation);
   msFree(schemaLocation);
   msFree(xsi_schemaLocation);
 
@@ -1001,22 +1034,22 @@ int msWCSDescribeCoverage11(mapObj *map,
   /*      Generate a CoverageDescription for each requested coverage.     */
   /* -------------------------------------------------------------------- */
 
-  if(params->coverages) { /* use the list */
-    for( j = 0; params->coverages[j]; j++ ) {
+  if (params->coverages) { /* use the list */
+    for (j = 0; params->coverages[j]; j++) {
       i = msGetLayerIndex(map, params->coverages[j]);
-      msWCSDescribeCoverage_CoverageDescription11((GET_LAYER(map, i)),
-          params, psRootNode,
-          psOwsNs );
+      msWCSDescribeCoverage_CoverageDescription11((GET_LAYER(map, i)), params,
+                                                  psRootNode, psOwsNs);
     }
   } else { /* return all layers */
-    for(i=0; i<map->numlayers; i++) {
+    for (i = 0; i < map->numlayers; i++) {
 
-      if (!msIntegerInArray(GET_LAYER(map, i)->index, ows_request->enabled_layers, ows_request->numlayers))
+      if (!msIntegerInArray(GET_LAYER(map, i)->index,
+                            ows_request->enabled_layers,
+                            ows_request->numlayers))
         continue;
 
-      msWCSDescribeCoverage_CoverageDescription11((GET_LAYER(map, i)),
-          params, psRootNode,
-          psOwsNs );
+      msWCSDescribeCoverage_CoverageDescription11((GET_LAYER(map, i)), params,
+                                                  psRootNode, psOwsNs);
     }
   }
 
@@ -1028,10 +1061,10 @@ int msWCSDescribeCoverage11(mapObj *map,
     int size = 0;
     msIOContext *context = NULL;
 
-    if( msIO_needBinaryStdout() == MS_FAILURE )
+    if (msIO_needBinaryStdout() == MS_FAILURE)
       return MS_FAILURE;
 
-    msIO_setHeader("Content-Type","text/xml; charset=UTF-8");
+    msIO_setHeader("Content-Type", "text/xml; charset=UTF-8");
     msIO_sendHeaders();
 
     context = msIO_getHandler(stdout);
@@ -1068,9 +1101,9 @@ int msWCSDescribeCoverage11(mapObj *map,
 /************************************************************************/
 
 #if defined(USE_WCS_SVR)
-int msWCSGetCoverageBands11( mapObj *map, cgiRequestObj *request,
-                             wcsParamsObj *params, layerObj *lp,
-                             char **p_bandlist )
+int msWCSGetCoverageBands11(mapObj *map, cgiRequestObj *request,
+                            wcsParamsObj *params, layerObj *lp,
+                            char **p_bandlist)
 
 {
   char *rangesubset, *field_id;
@@ -1081,8 +1114,8 @@ int msWCSGetCoverageBands11( mapObj *map
   /*      Fetch the RangeSubset from the parameters, skip building a      */
   /*      bands list if not found.                                        */
   /* -------------------------------------------------------------------- */
-  const char* value = msWCSGetRequestParameter(request, "RangeSubset");
-  if( value == NULL )
+  const char *value = msWCSGetRequestParameter(request, "RangeSubset");
+  if (value == NULL)
     return MS_SUCCESS;
 
   rangesubset = msStrdup(value);
@@ -1090,16 +1123,16 @@ int msWCSGetCoverageBands11( mapObj *map
   /* -------------------------------------------------------------------- */
   /*      What is the <Field identifier=...> (rangeset_name)?             */
   /* -------------------------------------------------------------------- */
-  value = msOWSLookupMetadata( &(lp->metadata), "CO", "rangeset_name" );
-  if( value == NULL )
+  value = msOWSLookupMetadata(&(lp->metadata), "CO", "rangeset_name");
+  if (value == NULL)
     value = "raster";
   field_id = msStrdup(value);
 
   /* -------------------------------------------------------------------- */
   /*      What is the <Axis identifier=...> (bands_name)?                 */
   /* -------------------------------------------------------------------- */
-  axis_id = msOWSLookupMetadata( &(lp->metadata), "CO", "bands_name" );
-  if( axis_id == NULL )
+  axis_id = msOWSLookupMetadata(&(lp->metadata), "CO", "bands_name");
+  if (axis_id == NULL)
     axis_id = "bands";
 
   /* -------------------------------------------------------------------- */
@@ -1107,35 +1140,36 @@ int msWCSGetCoverageBands11( mapObj *map
   /* -------------------------------------------------------------------- */
   value = rangesubset + strlen(field_id);
 
-  if( strcasecmp(rangesubset,field_id) == 0 ) {
+  if (strcasecmp(rangesubset, field_id) == 0) {
     free(rangesubset);
     free(field_id);
     return MS_SUCCESS; /* we only got field ... default options */
   }
 
-  if( strlen(rangesubset) <= strlen(field_id)+1
-      || strncasecmp(rangesubset,field_id,strlen(field_id)) != 0
-      || (*value != '[' && *value != ':') ) {
-    msSetError( MS_WCSERR,
-                "RangeSubset field name malformed, expected '%s', got RangeSubset=%s",
-                "msWCSGetCoverageBands11()",
-                field_id, rangesubset );
+  if (strlen(rangesubset) <= strlen(field_id) + 1 ||
+      strncasecmp(rangesubset, field_id, strlen(field_id)) != 0 ||
+      (*value != '[' && *value != ':')) {
+    msSetError(
+        MS_WCSERR,
+        "RangeSubset field name malformed, expected '%s', got RangeSubset=%s",
+        "msWCSGetCoverageBands11()", field_id, rangesubset);
     free(rangesubset);
     free(field_id);
-    return msWCSException11(map, "NoApplicableCode", "mapserv", params->version);
+    return msWCSException11(map, "NoApplicableCode", "mapserv",
+                            params->version);
   }
 
-  free( field_id );
+  free(field_id);
   field_id = NULL;
 
   /* -------------------------------------------------------------------- */
   /*      Parse out the interpolation, if found.                          */
   /* -------------------------------------------------------------------- */
-  if( *value == ':' ) {
-    assert( params->interpolation == NULL );
-    params->interpolation = msStrdup(value+1);
-    for( i = 0; params->interpolation[i] != '\0'; i++ ) {
-      if( params->interpolation[i] == '[' ) {
+  if (*value == ':') {
+    assert(params->interpolation == NULL);
+    params->interpolation = msStrdup(value + 1);
+    for (i = 0; params->interpolation[i] != '\0'; i++) {
+      if (params->interpolation[i] == '[') {
         params->interpolation[i] = '\0';
         break;
       }
@@ -1147,22 +1181,23 @@ int msWCSGetCoverageBands11( mapObj *map
   /* -------------------------------------------------------------------- */
   /*      Parse out the axis name, and verify.                            */
   /* -------------------------------------------------------------------- */
-  if( *value != '[' ) {
+  if (*value != '[') {
     free(rangesubset);
     return MS_SUCCESS;
   }
 
   value++;
 
-  if( strlen(value) <= strlen(axis_id)+1
-      || strncasecmp(value,axis_id,strlen(axis_id)) != 0
-      || value[strlen(axis_id)] != '[' ) {
-    msSetError( MS_WCSERR,
-                "RangeSubset axis name malformed, expected '%s', got RangeSubset=%s",
-                "msWCSGetCoverageBands11()",
-                axis_id, rangesubset );
+  if (strlen(value) <= strlen(axis_id) + 1 ||
+      strncasecmp(value, axis_id, strlen(axis_id)) != 0 ||
+      value[strlen(axis_id)] != '[') {
+    msSetError(
+        MS_WCSERR,
+        "RangeSubset axis name malformed, expected '%s', got RangeSubset=%s",
+        "msWCSGetCoverageBands11()", axis_id, rangesubset);
     free(rangesubset);
-    return msWCSException11(map, "NoApplicableCode", "mapserv", params->version);
+    return msWCSException11(map, "NoApplicableCode", "mapserv",
+                            params->version);
   }
 
   /* -------------------------------------------------------------------- */
@@ -1173,8 +1208,8 @@ int msWCSGetCoverageBands11( mapObj *map
 
   *p_bandlist = msStrdup(value);
 
-  for( i = 0; (*p_bandlist)[i] != '\0'; i++ ) {
-    if( (*p_bandlist)[i] == '[' ) {
+  for (i = 0; (*p_bandlist)[i] != '\0'; i++) {
+    if ((*p_bandlist)[i] == '[') {
       (*p_bandlist)[i] = '\0';
       break;
     }
@@ -1192,53 +1227,47 @@ int msWCSGetCoverageBands11( mapObj *map
 /************************************************************************/
 
 #if defined(USE_WCS_SVR)
-int  msWCSReturnCoverage11( wcsParamsObj *params, mapObj *map,
-                            imageObj *image )
-{
+int msWCSReturnCoverage11(wcsParamsObj *params, mapObj *map, imageObj *image) {
   int status, i;
   char *filename = NULL;
   char *base_dir = NULL;
   const char *fo_filename;
 
-  fo_filename = msGetOutputFormatOption( image->format, "FILENAME", NULL );
+  fo_filename = msGetOutputFormatOption(image->format, "FILENAME", NULL);
 
   /* -------------------------------------------------------------------- */
   /*      Fetch the driver we will be using and check if it supports      */
   /*      VSIL IO.                                                        */
   /* -------------------------------------------------------------------- */
-  if( EQUALN(image->format->driver,"GDAL/",5) ) {
+  if (EQUALN(image->format->driver, "GDAL/", 5)) {
     GDALDriverH hDriver;
     const char *pszExtension = image->format->extension;
 
-    msAcquireLock( TLOCK_GDAL );
-    hDriver = GDALGetDriverByName( image->format->driver+5 );
-    if( hDriver == NULL ) {
-      msReleaseLock( TLOCK_GDAL );
-      msSetError( MS_MISCERR,
-                  "Failed to find %s driver.",
-                  "msWCSReturnCoverage11()",
-                  image->format->driver+5 );
+    msAcquireLock(TLOCK_GDAL);
+    hDriver = GDALGetDriverByName(image->format->driver + 5);
+    if (hDriver == NULL) {
+      msReleaseLock(TLOCK_GDAL);
+      msSetError(MS_MISCERR, "Failed to find %s driver.",
+                 "msWCSReturnCoverage11()", image->format->driver + 5);
       return msWCSException11(map, "NoApplicableCode", "mapserv",
                               params->version);
     }
 
-    if( pszExtension == NULL )
+    if (pszExtension == NULL)
       pszExtension = "img.tmp";
 
-    if( msGDALDriverSupportsVirtualIOOutput(hDriver) ) {
+    if (msGDALDriverSupportsVirtualIOOutput(hDriver)) {
       base_dir = msTmpFile(map, map->mappath, "/vsimem/wcsout", NULL);
-      if( fo_filename )
-        filename = msStrdup(CPLFormFilename(base_dir,
-                                            fo_filename,NULL));
+      if (fo_filename)
+        filename = msStrdup(CPLFormFilename(base_dir, fo_filename, NULL));
       else
-        filename = msStrdup(CPLFormFilename(base_dir,
-                                            "out", pszExtension ));
+        filename = msStrdup(CPLFormFilename(base_dir, "out", pszExtension));
 
       /*            CleanVSIDir( "/vsimem/wcsout" ); */
 
-      msReleaseLock( TLOCK_GDAL );
+      msReleaseLock(TLOCK_GDAL);
       status = msSaveImage(map, image, filename);
-      if( status != MS_SUCCESS ) {
+      if (status != MS_SUCCESS) {
         msFree(filename);
         msSetError(MS_MISCERR, "msSaveImage() failed",
                    "msWCSReturnCoverage11()");
@@ -1246,55 +1275,55 @@ int  msWCSReturnCoverage11( wcsParamsObj
                                 params->version);
       }
     }
-    msReleaseLock( TLOCK_GDAL );
+    msReleaseLock(TLOCK_GDAL);
   }
 
   /* -------------------------------------------------------------------- */
   /*      Output stock header.                                            */
   /* -------------------------------------------------------------------- */
-  msIO_setHeader("Content-Type","multipart/mixed; boundary=wcs");
+  msIO_setHeader("Content-Type", "multipart/mixed; boundary=wcs");
   msIO_sendHeaders();
-  msIO_printf(
-    "\r\n--wcs\r\n"
-    "Content-Type: text/xml; charset=UTF-8\r\n"
-    "Content-ID: wcs.xml\r\n\r\n"
-    "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"
-    "<Coverages\n"
-    "     xmlns=\"http://www.opengis.net/wcs/1.1\"\n"
-    "     xmlns:ows=\"http://www.opengis.net/ows/1.1\"\n"
-    "     xmlns:xlink=\"http://www.w3.org/1999/xlink\"\n"
-    "     xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n"
-    "     xsi:schemaLocation=\"http://www.opengis.net/ows/1.1 ../owsCoverages.xsd\">\n"
-    "  <Coverage>\n");
+  msIO_printf("\r\n--wcs\r\n"
+              "Content-Type: text/xml; charset=UTF-8\r\n"
+              "Content-ID: wcs.xml\r\n\r\n"
+              "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"
+              "<Coverages\n"
+              "     xmlns=\"http://www.opengis.net/wcs/1.1\"\n"
+              "     xmlns:ows=\"http://www.opengis.net/ows/1.1\"\n"
+              "     xmlns:xlink=\"http://www.w3.org/1999/xlink\"\n"
+              "     xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n"
+              "     xsi:schemaLocation=\"http://www.opengis.net/ows/1.1 "
+              "../owsCoverages.xsd\">\n"
+              "  <Coverage>\n");
 
   /* -------------------------------------------------------------------- */
   /*      If we weren't able to write data under /vsimem, then we just    */
   /*      output a single "stock" filename.                               */
   /* -------------------------------------------------------------------- */
-  if( filename == NULL ) {
-    msOutputFormatResolveFromImage( map, image );
-    msIO_fprintf(
-      stdout,
-      "    <ows:Reference xlink:href=\"cid:coverage/wcs.%s\"/>\n"
-      "  </Coverage>\n"
-      "</Coverages>\n"
-      "\r\n--wcs\r\n"
-      "Content-Type: %s\r\n"
-      "Content-Description: coverage data\r\n"
-      "Content-Transfer-Encoding: binary\r\n"
-      "Content-ID: coverage/wcs.%s\r\n"
-      "Content-Disposition: INLINE\r\n\r\n",
-      MS_IMAGE_EXTENSION(map->outputformat),
-      MS_IMAGE_MIME_TYPE(map->outputformat),
-      MS_IMAGE_EXTENSION(map->outputformat));
+  if (filename == NULL) {
+    msOutputFormatResolveFromImage(map, image);
+    msIO_fprintf(stdout,
+                 "    <ows:Reference xlink:href=\"cid:coverage/wcs.%s\"/>\n"
+                 "  </Coverage>\n"
+                 "</Coverages>\n"
+                 "\r\n--wcs\r\n"
+                 "Content-Type: %s\r\n"
+                 "Content-Description: coverage data\r\n"
+                 "Content-Transfer-Encoding: binary\r\n"
+                 "Content-ID: coverage/wcs.%s\r\n"
+                 "Content-Disposition: INLINE\r\n\r\n",
+                 MS_IMAGE_EXTENSION(map->outputformat),
+                 MS_IMAGE_MIME_TYPE(map->outputformat),
+                 MS_IMAGE_EXTENSION(map->outputformat));
 
     status = msSaveImage(map, image, NULL);
-    if( status != MS_SUCCESS ) {
-      msSetError( MS_MISCERR, "msSaveImage() failed", "msWCSReturnCoverage11()");
-      return msWCSException11(map, "NoApplicableCode", "mapserv", params->version);
+    if (status != MS_SUCCESS) {
+      msSetError(MS_MISCERR, "msSaveImage() failed", "msWCSReturnCoverage11()");
+      return msWCSException11(map, "NoApplicableCode", "mapserv",
+                              params->version);
     }
 
-    msIO_fprintf( stdout, "\r\n--wcs--\r\n" );
+    msIO_fprintf(stdout, "\r\n--wcs--\r\n");
     return MS_SUCCESS;
   }
 
@@ -1304,88 +1333,82 @@ int  msWCSReturnCoverage11( wcsParamsObj
   /*      it is the only file listed in the coverages document.           */
   /* -------------------------------------------------------------------- */
   {
-    char **all_files = CPLReadDir( base_dir );
+    char **all_files = CPLReadDir(base_dir);
     int count = CSLCount(all_files);
 
-    if( msIO_needBinaryStdout() == MS_FAILURE )
+    if (msIO_needBinaryStdout() == MS_FAILURE)
       return MS_FAILURE;
 
-    msAcquireLock( TLOCK_GDAL );
-    for( i = count-1; i >= 0; i-- ) {
+    msAcquireLock(TLOCK_GDAL);
+    for (i = count - 1; i >= 0; i--) {
       const char *this_file = all_files[i];
 
-      if( EQUAL(this_file,".") || EQUAL(this_file,"..") ) {
-        all_files = CSLRemoveStrings( all_files, i, 1, NULL );
+      if (EQUAL(this_file, ".") || EQUAL(this_file, "..")) {
+        all_files = CSLRemoveStrings(all_files, i, 1, NULL);
         continue;
       }
 
-      if( i > 0 && EQUAL(this_file,CPLGetFilename(filename)) ) {
-        all_files = CSLRemoveStrings( all_files, i, 1, NULL );
-        all_files = CSLInsertString(all_files,0,CPLGetFilename(filename));
+      if (i > 0 && EQUAL(this_file, CPLGetFilename(filename))) {
+        all_files = CSLRemoveStrings(all_files, i, 1, NULL);
+        all_files = CSLInsertString(all_files, 0, CPLGetFilename(filename));
         i++;
       }
     }
 
-    msIO_fprintf(
-      stdout,
-      "    <ows:Reference xlink:href=\"cid:coverage/%s\"/>\n"
-      "  </Coverage>\n"
-      "</Coverages>\n",
-      CPLGetFilename(filename) );
+    msIO_fprintf(stdout,
+                 "    <ows:Reference xlink:href=\"cid:coverage/%s\"/>\n"
+                 "  </Coverage>\n"
+                 "</Coverages>\n",
+                 CPLGetFilename(filename));
 
     /* -------------------------------------------------------------------- */
     /*      Dump all the files in the memory directory as mime sections.    */
     /* -------------------------------------------------------------------- */
     count = CSLCount(all_files);
 
-    for( i = 0; i < count; i++ ) {
+    for (i = 0; i < count; i++) {
       const char *mimetype = NULL;
       VSILFILE *fp;
       unsigned char block[4000];
       int bytes_read;
 
-      if( i == 0 )
+      if (i == 0)
         mimetype = MS_IMAGE_MIME_TYPE(map->outputformat);
 
-      if( mimetype == NULL )
+      if (mimetype == NULL)
         mimetype = "application/octet-stream";
 
-      msIO_fprintf(
-        stdout,
-        "\r\n--wcs\r\n"
-        "Content-Type: %s\r\n"
-        "Content-Description: coverage data\r\n"
-        "Content-Transfer-Encoding: binary\r\n"
-        "Content-ID: coverage/%s\r\n"
-        "Content-Disposition: INLINE\r\n\r\n",
-        mimetype,
-        all_files[i]);
-
-      fp = VSIFOpenL(
-             CPLFormFilename(base_dir, all_files[i], NULL),
-             "rb" );
-      if( fp == NULL ) {
-        msReleaseLock( TLOCK_GDAL );
-        msSetError( MS_MISCERR,
-                    "Failed to open %s for streaming to stdout.",
-                    "msWCSReturnCoverage11()", all_files[i] );
+      msIO_fprintf(stdout,
+                   "\r\n--wcs\r\n"
+                   "Content-Type: %s\r\n"
+                   "Content-Description: coverage data\r\n"
+                   "Content-Transfer-Encoding: binary\r\n"
+                   "Content-ID: coverage/%s\r\n"
+                   "Content-Disposition: INLINE\r\n\r\n",
+                   mimetype, all_files[i]);
+
+      fp = VSIFOpenL(CPLFormFilename(base_dir, all_files[i], NULL), "rb");
+      if (fp == NULL) {
+        msReleaseLock(TLOCK_GDAL);
+        msSetError(MS_MISCERR, "Failed to open %s for streaming to stdout.",
+                   "msWCSReturnCoverage11()", all_files[i]);
         return MS_FAILURE;
       }
 
-      while( (bytes_read = VSIFReadL(block, 1, sizeof(block), fp)) > 0 )
-        msIO_fwrite( block, 1, bytes_read, stdout );
+      while ((bytes_read = VSIFReadL(block, 1, sizeof(block), fp)) > 0)
+        msIO_fwrite(block, 1, bytes_read, stdout);
 
-      VSIFCloseL( fp );
+      VSIFCloseL(fp);
 
-      VSIUnlink( CPLFormFilename(base_dir, all_files[i], NULL) );
+      VSIUnlink(CPLFormFilename(base_dir, all_files[i], NULL));
     }
 
     msFree(base_dir);
     msFree(filename);
-    CSLDestroy( all_files );
-    msReleaseLock( TLOCK_GDAL );
+    CSLDestroy(all_files);
+    msReleaseLock(TLOCK_GDAL);
 
-    msIO_fprintf( stdout, "\r\n--wcs--\r\n" );
+    msIO_fprintf(stdout, "\r\n--wcs--\r\n");
     return MS_SUCCESS;
   }
 }
@@ -1405,30 +1428,30 @@ int  msWCSReturnCoverage11( wcsParamsObj
 /* ==================================================================== */
 
 int msWCSDescribeCoverage11(mapObj *map, wcsParamsObj *params,
-                            owsRequestObj *ows_request)
-{
-  msSetError( MS_WCSERR,
-              "WCS 1.1 request made, but mapserver requires libxml2 for WCS 1.1 services and this is not configured.",
-              "msWCSDescribeCoverage11()" );
+                            owsRequestObj *ows_request) {
+  msSetError(MS_WCSERR,
+             "WCS 1.1 request made, but mapserver requires libxml2 for WCS 1.1 "
+             "services and this is not configured.",
+             "msWCSDescribeCoverage11()");
   return msWCSException11(map, "NoApplicableCode", "mapserv", params->version);
 }
 
 /* ==================================================================== */
 
 int msWCSGetCapabilities11(mapObj *map, wcsParamsObj *params,
-                           cgiRequestObj *req, owsRequestObj *ows_request)
-{
-  msSetError( MS_WCSERR,
-              "WCS 1.1 request made, but mapserver requires libxml2 for WCS 1.1 services and this is not configured.",
-              "msWCSGetCapabilities11()" );
+                           cgiRequestObj *req, owsRequestObj *ows_request) {
+  msSetError(MS_WCSERR,
+             "WCS 1.1 request made, but mapserver requires libxml2 for WCS 1.1 "
+             "services and this is not configured.",
+             "msWCSGetCapabilities11()");
 
   return msWCSException11(map, "NoApplicableCode", "mapserv", params->version);
 }
 
-int msWCSException11(mapObj *map, const char *exceptionCode, const char *locator, const char *version)
-{
+int msWCSException11(mapObj *map, const char *exceptionCode,
+                     const char *locator, const char *version) {
   /* fallback to reporting using 1.0 style exceptions. */
-  return msWCSException( map, exceptionCode, locator, "1.0.0" );
+  return msWCSException(map, exceptionCode, locator, "1.0.0");
 }
 
 #endif /* defined(USE_WCS_SVR) && !defined(USE_LIBXML2) */
diff -pruN 8.0.1-5/mapwcs20.cpp 8.0.2-1/mapwcs20.cpp
--- 8.0.1-5/mapwcs20.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapwcs20.cpp	2024-06-11 20:41:34.000000000 +0000
@@ -61,31 +61,23 @@
 /*                          msXMLStripIndentation                       */
 /************************************************************************/
 
-static void msXMLStripIndentation(char* ptr)
-{
-    /* Remove spaces between > and < to get properly indented result */
-    char* afterLastClosingBracket = NULL;
-    if( *ptr == ' ' )
-        afterLastClosingBracket = ptr;
-    while( *ptr != '\0' )
-    {
-        if( *ptr == '<' && afterLastClosingBracket != NULL )
-        {
-            memmove(afterLastClosingBracket, ptr, strlen(ptr) + 1);
-            ptr = afterLastClosingBracket;
-        }
-        else if( *ptr == '>' )
-        {
-            afterLastClosingBracket = ptr + 1;
-        }
-        else if( *ptr != ' ' &&  *ptr != '\n' )
-            afterLastClosingBracket = NULL;
-        ptr ++;
-    }
+static void msXMLStripIndentation(char *ptr) {
+  /* Remove spaces between > and < to get properly indented result */
+  char *afterLastClosingBracket = NULL;
+  if (*ptr == ' ')
+    afterLastClosingBracket = ptr;
+  while (*ptr != '\0') {
+    if (*ptr == '<' && afterLastClosingBracket != NULL) {
+      memmove(afterLastClosingBracket, ptr, strlen(ptr) + 1);
+      ptr = afterLastClosingBracket;
+    } else if (*ptr == '>') {
+      afterLastClosingBracket = ptr + 1;
+    } else if (*ptr != ' ' && *ptr != '\n')
+      afterLastClosingBracket = NULL;
+    ptr++;
+  }
 }
 
-
-
 /************************************************************************/
 /*                   msStringParseInteger()                             */
 /*                                                                      */
@@ -96,13 +88,12 @@ static void msXMLStripIndentation(char*
 /*      only if all characters could be parsed, MS_SUCCESS is returned. */
 /************************************************************************/
 
-static int msStringParseInteger(const char *string, int *dest)
-{
+static int msStringParseInteger(const char *string, int *dest) {
   char *parse_check;
   *dest = (int)strtol(string, &parse_check, 0);
-  if(parse_check == string) {
+  if (parse_check == string) {
     return MS_FAILURE;
-  } else if(parse_check - strlen(string) != string) {
+  } else if (parse_check - strlen(string) != string) {
     return MS_DONE;
   }
   return MS_SUCCESS;
@@ -118,13 +109,12 @@ static int msStringParseInteger(const ch
 /*      only if all characters could be parsed, MS_SUCCESS is returned. */
 /************************************************************************/
 
-static int msStringParseDouble(const char *string, double *dest)
-{
+static int msStringParseDouble(const char *string, double *dest) {
   char *parse_check = NULL;
   *dest = strtod(string, &parse_check);
-  if(parse_check == string) {
+  if (parse_check == string) {
     return MS_FAILURE;
-  } else if(parse_check - strlen(string) != string) {
+  } else if (parse_check - strlen(string) != string) {
     return MS_DONE;
   }
   return MS_SUCCESS;
@@ -137,12 +127,11 @@ static int msStringParseDouble(const cha
 /*      writes the output into the timeScalarUnion.                     */
 /************************************************************************/
 
-static int msWCSParseTimeOrScalar20(timeScalarUnion *u, const char *string)
-{
+static int msWCSParseTimeOrScalar20(timeScalarUnion *u, const char *string) {
   struct tm time;
   if (string) {
-    while(*string == ' ')
-      string ++;
+    while (*string == ' ')
+      string++;
   }
 
   if (!string || strlen(string) == 0 || !u) {
@@ -171,7 +160,7 @@ static int msWCSParseTimeOrScalar20(time
   else {
     msSetError(MS_WCSERR,
                "String %s could not be parsed to a time or scalar value",
-               "msWCSParseTimeOrScalar20()",string);
+               "msWCSParseTimeOrScalar20()", string);
     return MS_WCS20_ERROR_VALUE;
   }
 }
@@ -183,9 +172,8 @@ static int msWCSParseTimeOrScalar20(time
 /*      values.                                                         */
 /************************************************************************/
 
-static wcs20SubsetObjPtr msWCSCreateSubsetObj20()
-{
-  wcs20SubsetObjPtr subset = (wcs20SubsetObjPtr) malloc(sizeof(wcs20SubsetObj));
+static wcs20SubsetObjPtr msWCSCreateSubsetObj20() {
+  wcs20SubsetObjPtr subset = (wcs20SubsetObjPtr)malloc(sizeof(wcs20SubsetObj));
   MS_CHECK_ALLOC(subset, sizeof(wcs20SubsetObj), NULL);
 
   subset->axis = NULL;
@@ -203,8 +191,7 @@ static wcs20SubsetObjPtr msWCSCreateSubs
 /*      Frees a wcs20SubsetObj and releases all linked resources.       */
 /************************************************************************/
 
-static void msWCSFreeSubsetObj20(wcs20SubsetObjPtr subset)
-{
+static void msWCSFreeSubsetObj20(wcs20SubsetObjPtr subset) {
   if (NULL == subset) {
     return;
   }
@@ -220,8 +207,7 @@ static void msWCSFreeSubsetObj20(wcs20Su
 /*      values.                                                         */
 /************************************************************************/
 
-static wcs20AxisObjPtr msWCSCreateAxisObj20()
-{
+static wcs20AxisObjPtr msWCSCreateAxisObj20() {
   wcs20AxisObj *axis = (wcs20AxisObjPtr)malloc(sizeof(wcs20AxisObj));
   MS_CHECK_ALLOC(axis, sizeof(wcs20AxisObj), NULL);
 
@@ -241,9 +227,8 @@ static wcs20AxisObjPtr msWCSCreateAxisOb
 /*      Frees a wcs20AxisObj and releases all linked resources.         */
 /************************************************************************/
 
-static void msWCSFreeAxisObj20(wcs20AxisObjPtr axis)
-{
-  if(NULL == axis) {
+static void msWCSFreeAxisObj20(wcs20AxisObjPtr axis) {
+  if (NULL == axis) {
     return;
   }
 
@@ -261,11 +246,10 @@ static void msWCSFreeAxisObj20(wcs20Axis
 /************************************************************************/
 
 static wcs20AxisObjPtr msWCSFindAxis20(wcs20ParamsObjPtr params,
-                                       const char *name)
-{
+                                       const char *name) {
   int i = 0;
-  for(i = 0; i < params->numaxes; ++i) {
-    if(EQUAL(params->axes[i]->name, name)) {
+  for (i = 0; i < params->numaxes; ++i) {
+    if (EQUAL(params->axes[i]->name, name)) {
       return params->axes[i];
     }
   }
@@ -279,11 +263,11 @@ static wcs20AxisObjPtr msWCSFindAxis20(w
 /*      a params object.                                                */
 /************************************************************************/
 
-static void msWCSInsertAxisObj20(wcs20ParamsObjPtr params, wcs20AxisObjPtr axis)
-{
+static void msWCSInsertAxisObj20(wcs20ParamsObjPtr params,
+                                 wcs20AxisObjPtr axis) {
   params->numaxes++;
-  params->axes = (wcs20AxisObjPtr*) msSmallRealloc(params->axes,
-                 sizeof(wcs20AxisObjPtr) * (params->numaxes));
+  params->axes = (wcs20AxisObjPtr *)msSmallRealloc(
+      params->axes, sizeof(wcs20AxisObjPtr) * (params->numaxes));
   params->axes[params->numaxes - 1] = axis;
 }
 
@@ -294,39 +278,37 @@ static void msWCSInsertAxisObj20(wcs20Pa
 /*      values.                                                         */
 /************************************************************************/
 
-wcs20ParamsObjPtr msWCSCreateParamsObj20()
-{
-  wcs20ParamsObjPtr params
-    = (wcs20ParamsObjPtr) malloc(sizeof(wcs20ParamsObj));
+wcs20ParamsObjPtr msWCSCreateParamsObj20() {
+  wcs20ParamsObjPtr params = (wcs20ParamsObjPtr)malloc(sizeof(wcs20ParamsObj));
   MS_CHECK_ALLOC(params, sizeof(wcs20ParamsObj), NULL);
 
-  params->version         = NULL;
-  params->request         = NULL;
-  params->service         = NULL;
+  params->version = NULL;
+  params->request = NULL;
+  params->service = NULL;
   params->accept_versions = NULL;
   params->accept_languages = NULL;
-  params->sections        = NULL;
-  params->updatesequence  = NULL;
-  params->ids             = NULL;
-  params->width           = 0;
-  params->height          = 0;
-  params->resolutionX     = MS_WCS20_UNBOUNDED;
-  params->resolutionY     = MS_WCS20_UNBOUNDED;
-  params->scale           = MS_WCS20_UNBOUNDED;
-  params->scaleX          = MS_WCS20_UNBOUNDED;
-  params->scaleY          = MS_WCS20_UNBOUNDED;
+  params->sections = NULL;
+  params->updatesequence = NULL;
+  params->ids = NULL;
+  params->width = 0;
+  params->height = 0;
+  params->resolutionX = MS_WCS20_UNBOUNDED;
+  params->resolutionY = MS_WCS20_UNBOUNDED;
+  params->scale = MS_WCS20_UNBOUNDED;
+  params->scaleX = MS_WCS20_UNBOUNDED;
+  params->scaleY = MS_WCS20_UNBOUNDED;
   params->resolutionUnits = NULL;
-  params->numaxes         = 0;
-  params->axes            = NULL;
-  params->format          = NULL;
-  params->multipart       = 0;
-  params->interpolation   = NULL;
-  params->outputcrs       = NULL;
-  params->subsetcrs       = NULL;
+  params->numaxes = 0;
+  params->axes = NULL;
+  params->format = NULL;
+  params->multipart = 0;
+  params->interpolation = NULL;
+  params->outputcrs = NULL;
+  params->subsetcrs = NULL;
   params->bbox.minx = params->bbox.miny = -DBL_MAX;
-  params->bbox.maxx = params->bbox.maxy =  DBL_MAX;
-  params->range_subset    = NULL;
-  params->format_options  = NULL;
+  params->bbox.maxx = params->bbox.maxy = DBL_MAX;
+  params->range_subset = NULL;
+  params->format_options = NULL;
 
   return params;
 }
@@ -337,8 +319,7 @@ wcs20ParamsObjPtr msWCSCreateParamsObj20
 /*      Frees a wcs20ParamsObj and releases all linked resources.       */
 /************************************************************************/
 
-void msWCSFreeParamsObj20(wcs20ParamsObjPtr params)
-{
+void msWCSFreeParamsObj20(wcs20ParamsObjPtr params) {
   if (NULL == params) {
     return;
   }
@@ -356,7 +337,7 @@ void msWCSFreeParamsObj20(wcs20ParamsObj
   msFree(params->interpolation);
   msFree(params->outputcrs);
   msFree(params->subsetcrs);
-  while(params->numaxes > 0) {
+  while (params->numaxes > 0) {
     params->numaxes -= 1;
     msWCSFreeAxisObj20(params->axes[params->numaxes]);
   }
@@ -374,8 +355,8 @@ void msWCSFreeParamsObj20(wcs20ParamsObj
 /************************************************************************/
 
 static int msWCSParseSubset20(wcs20SubsetObjPtr subset, const char *axis,
-                              const char *crs, const char *min, const char *max)
-{
+                              const char *crs, const char *min,
+                              const char *max) {
   int ts1, ts2;
   ts1 = ts2 = MS_WCS20_UNDEFINED_VALUE;
 
@@ -384,8 +365,7 @@ static int msWCSParseSubset20(wcs20Subse
   }
 
   if (axis == NULL || strlen(axis) == 0) {
-    msSetError(MS_WCSERR, "Subset axis is not given.",
-               "msWCSParseSubset20()");
+    msSetError(MS_WCSERR, "Subset axis is not given.", "msWCSParseSubset20()");
     return MS_FAILURE;
   }
 
@@ -413,15 +393,14 @@ static int msWCSParseSubset20(wcs20Subse
     }
 
     /* if at least one boundary is defined, use that value */
-    if ((ts1 == MS_WCS20_UNDEFINED_VALUE) ^ (ts2
-        == MS_WCS20_UNDEFINED_VALUE)) {
+    if ((ts1 == MS_WCS20_UNDEFINED_VALUE) ^ (ts2 == MS_WCS20_UNDEFINED_VALUE)) {
       if (ts1 == MS_WCS20_UNDEFINED_VALUE) {
         ts1 = ts2;
       }
     }
     /* if time and scalar values do not fit, throw an error */
-    else if (ts1 != MS_WCS20_UNDEFINED_VALUE && ts2
-             != MS_WCS20_UNDEFINED_VALUE && ts1 != ts2) {
+    else if (ts1 != MS_WCS20_UNDEFINED_VALUE &&
+             ts2 != MS_WCS20_UNDEFINED_VALUE && ts1 != ts2) {
       msSetError(MS_WCSERR,
                  "Interval error: minimum is a %s value, maximum is a %s value",
                  "msWCSParseSubset20()", ts1 ? "time" : "scalar",
@@ -450,21 +429,25 @@ static int msWCSParseSubset20(wcs20Subse
 
   /* check whether the min is smaller than the max */
   if (subset->operation == MS_WCS20_TRIM) {
-    if(subset->timeOrScalar == MS_WCS20_SCALAR_VALUE && subset->min.scalar == MS_WCS20_UNBOUNDED) {
+    if (subset->timeOrScalar == MS_WCS20_SCALAR_VALUE &&
+        subset->min.scalar == MS_WCS20_UNBOUNDED) {
       subset->min.scalar = -MS_WCS20_UNBOUNDED;
     }
 
-    if (subset->timeOrScalar == MS_WCS20_TIME_VALUE && subset->min.time
-        > subset->max.time) {
+    if (subset->timeOrScalar == MS_WCS20_TIME_VALUE &&
+        subset->min.time > subset->max.time) {
       msSetError(MS_WCSERR,
                  "Minimum value of subset axis %s is larger than maximum value",
                  "msWCSParseSubset20()", subset->axis);
       return MS_FAILURE;
     }
-    if (subset->timeOrScalar == MS_WCS20_SCALAR_VALUE && subset->min.scalar > subset->max.scalar) {
+    if (subset->timeOrScalar == MS_WCS20_SCALAR_VALUE &&
+        subset->min.scalar > subset->max.scalar) {
       msSetError(MS_WCSERR,
-                 "Minimum value (%f) of subset axis '%s' is larger than maximum value (%f).",
-                 "msWCSParseSubset20()", subset->min.scalar, subset->axis, subset->max.scalar);
+                 "Minimum value (%f) of subset axis '%s' is larger than "
+                 "maximum value (%f).",
+                 "msWCSParseSubset20()", subset->min.scalar, subset->axis,
+                 subset->max.scalar);
       return MS_FAILURE;
     }
   }
@@ -479,8 +462,7 @@ static int msWCSParseSubset20(wcs20Subse
 /*      Subset string: axis [ , crs ] ( intervalOrPoint )               */
 /************************************************************************/
 
-static int msWCSParseSubsetKVPString20(wcs20SubsetObjPtr subset, char *string)
-{
+static int msWCSParseSubsetKVPString20(wcs20SubsetObjPtr subset, char *string) {
   char *axis, *crs, *min, *max;
 
   axis = string;
@@ -529,15 +511,15 @@ static int msWCSParseSubsetKVPString20(w
 /*      Size string: axis ( size )                                      */
 /************************************************************************/
 
-static int msWCSParseSizeString20(char *string, char *outAxis, size_t axisStringLen, int *outSize)
-{
+static int msWCSParseSizeString20(char *string, char *outAxis,
+                                  size_t axisStringLen, int *outSize) {
   char *number = NULL;
   char *check = NULL;
 
   /* find first '(', the character before the number */
   number = strchr(string, '(');
 
-  if(NULL == number) {
+  if (NULL == number) {
     msSetError(MS_WCSERR, "Invalid size parameter value.",
                "msWCSParseSize20()");
     return MS_FAILURE;
@@ -545,7 +527,7 @@ static int msWCSParseSizeString20(char *
 
   /* cut trailing ')' */
   check = strchr(string, ')');
-  if(NULL == check) {
+  if (NULL == check) {
     msSetError(MS_WCSERR, "Invalid size parameter value.",
                "msWCSParseSize20()");
     return MS_FAILURE;
@@ -557,7 +539,7 @@ static int msWCSParseSizeString20(char *
   strlcpy(outAxis, string, axisStringLen);
 
   /* parse size value */
-  if(msStringParseInteger(number, outSize) != MS_SUCCESS) {
+  if (msStringParseInteger(number, outSize) != MS_SUCCESS) {
     msSetError(MS_WCSERR, "Parameter value '%s' is not a valid integer.",
                "msWCSParseSize20()", number);
     return MS_FAILURE;
@@ -574,16 +556,16 @@ static int msWCSParseSizeString20(char *
 /*      Subset string: axis ( value )                                   */
 /************************************************************************/
 
-static int msWCSParseResolutionString20(char *string,
-                                        char *outAxis, size_t axisStringLen, double *outResolution)
-{
+static int msWCSParseResolutionString20(char *string, char *outAxis,
+                                        size_t axisStringLen,
+                                        double *outResolution) {
   char *number = NULL;
   char *check = NULL;
 
   /* find brackets */
   number = strchr(string, '(');
 
-  if(NULL == number) {
+  if (NULL == number) {
     msSetError(MS_WCSERR, "Invalid resolution parameter value : %s.",
                "msWCSParseSize20()", string);
     return MS_FAILURE;
@@ -591,7 +573,7 @@ static int msWCSParseResolutionString20(
 
   /* cut trailing ')' */
   check = strchr(string, ')');
-  if(NULL == check) {
+  if (NULL == check) {
     msSetError(MS_WCSERR, "Invalid size parameter value.",
                "msWCSParseSize20()");
     return MS_FAILURE;
@@ -603,7 +585,7 @@ static int msWCSParseResolutionString20(
 
   strlcpy(outAxis, string, axisStringLen);
 
-  if(msStringParseDouble(number, outResolution) != MS_SUCCESS) {
+  if (msStringParseDouble(number, outResolution) != MS_SUCCESS) {
     *outResolution = MS_WCS20_UNBOUNDED;
     msSetError(MS_WCSERR, "Invalid resolution parameter value : %s.",
                "msWCSParseSize20()", number);
@@ -620,16 +602,15 @@ static int msWCSParseResolutionString20(
 /*      Subset string: axis ( value )                                   */
 /************************************************************************/
 
-static int msWCSParseScaleString20(char *string,
-                                  char *outAxis, size_t axisStringLen, double *outScale)
-{
+static int msWCSParseScaleString20(char *string, char *outAxis,
+                                   size_t axisStringLen, double *outScale) {
   char *number = NULL;
   char *check = NULL;
 
   /* find brackets */
   number = strchr(string, '(');
 
-  if(NULL == number) {
+  if (NULL == number) {
     msSetError(MS_WCSERR, "Invalid resolution parameter value : %s.",
                "msWCSParseScaleString20()", string);
     return MS_FAILURE;
@@ -637,7 +618,7 @@ static int msWCSParseScaleString20(char
 
   /* cut trailing ')' */
   check = strchr(string, ')');
-  if(NULL == check || check < number) {
+  if (NULL == check || check < number) {
     msSetError(MS_WCSERR, "Invalid scale parameter value.",
                "msWCSParseScaleString20()");
     return MS_FAILURE;
@@ -649,7 +630,7 @@ static int msWCSParseScaleString20(char
 
   strlcpy(outAxis, string, axisStringLen);
 
-  if(msStringParseDouble(number, outScale) != MS_SUCCESS || *outScale <= 0.0) {
+  if (msStringParseDouble(number, outScale) != MS_SUCCESS || *outScale <= 0.0) {
     *outScale = MS_WCS20_UNBOUNDED;
     msSetError(MS_WCSERR, "Invalid scale parameter value : %s.",
                "msWCSParseScaleString20()", number);
@@ -668,9 +649,8 @@ static int msWCSParseScaleString20(char
 /************************************************************************/
 
 static int msWCSParseScaleExtentString20(char *string, char *outAxis,
-                                         size_t axisStringLen,
-                                         int *outMin, int *outMax)
-{
+                                         size_t axisStringLen, int *outMin,
+                                         int *outMax) {
   char *number = NULL;
   char *check = NULL;
   char *colon = NULL;
@@ -678,7 +658,7 @@ static int msWCSParseScaleExtentString20
   /* find brackets */
   number = strchr(string, '(');
 
-  if(NULL == number) {
+  if (NULL == number) {
     msSetError(MS_WCSERR, "Invalid extent parameter value : %s.",
                "msWCSParseScaleExtentString20()", string);
     return MS_FAILURE;
@@ -687,7 +667,7 @@ static int msWCSParseScaleExtentString20
   /* find colon */
   colon = strchr(string, ':');
 
-  if(NULL == colon || colon < number) {
+  if (NULL == colon || colon < number) {
     msSetError(MS_WCSERR, "Invalid extent parameter value : %s.",
                "msWCSParseScaleExtentString20()", string);
     return MS_FAILURE;
@@ -696,7 +676,7 @@ static int msWCSParseScaleExtentString20
   /* cut trailing ')' */
   check = strchr(string, ')');
 
-  if(NULL == check || check < colon) {
+  if (NULL == check || check < colon) {
     msSetError(MS_WCSERR, "Invalid extent parameter value.",
                "msWCSParseScaleExtentString20()");
     return MS_FAILURE;
@@ -710,13 +690,12 @@ static int msWCSParseScaleExtentString20
 
   strlcpy(outAxis, string, axisStringLen);
 
-  if(msStringParseInteger(number, outMin) != MS_SUCCESS) {
+  if (msStringParseInteger(number, outMin) != MS_SUCCESS) {
     *outMin = 0;
     msSetError(MS_WCSERR, "Invalid min parameter value : %s.",
                "msWCSParseScaleExtentString20()", number);
     return MS_FAILURE;
-  }
-  else if(msStringParseInteger(colon, outMax) != MS_SUCCESS) {
+  } else if (msStringParseInteger(colon, outMax) != MS_SUCCESS) {
     *outMax = 0;
     msSetError(MS_WCSERR, "Invalid resolution parameter value : %s.",
                "msWCSParseScaleExtentString20()", colon);
@@ -724,7 +703,8 @@ static int msWCSParseScaleExtentString20
   }
 
   if (*outMin > *outMax) {
-    msSetError(MS_WCSERR, "Invalid extent: lower part is higher than upper part.",
+    msSetError(MS_WCSERR,
+               "Invalid extent: lower part is higher than upper part.",
                "msWCSParseScaleExtentString20()");
     return MS_FAILURE;
   }
@@ -752,13 +732,13 @@ xmlNodePtr msLibXml2GetFirstChild(xmlNod
   return NULL;
 }
 
-
 /*
   Utility function to get the first child of a node with a given node name and
   namespace.
   */
 
-xmlNodePtr msLibXml2GetFirstChildNs(xmlNodePtr parent, const char *name, xmlNsPtr ns) {
+xmlNodePtr msLibXml2GetFirstChildNs(xmlNodePtr parent, const char *name,
+                                    xmlNsPtr ns) {
   xmlNodePtr node;
   if (!parent || !name || !ns) {
     return NULL;
@@ -799,9 +779,8 @@ xmlNodePtr msLibXml2GetFirstChildElement
 /*      to a params object.                                             */
 /************************************************************************/
 #if defined(USE_LIBXML2)
-static int msWCSParseRequest20_XMLGetCapabilities(
-  xmlNodePtr root, wcs20ParamsObjPtr params)
-{
+static int msWCSParseRequest20_XMLGetCapabilities(xmlNodePtr root,
+                                                  wcs20ParamsObjPtr params) {
   xmlNodePtr child;
   char *content = NULL;
   XML_FOREACH_CHILD(root, child) {
@@ -813,10 +792,12 @@ static int msWCSParseRequest20_XMLGetCap
         XML_ASSERT_NODE_NAME(versionNode, "Version");
 
         content = (char *)xmlNodeGetContent(versionNode);
-        params->accept_versions = CSLAddString(params->accept_versions, content);
+        params->accept_versions =
+            CSLAddString(params->accept_versions, content);
         xmlFree(content);
       }
-    } else if(EQUAL((char *)child->name, "Sections")) {
+    }
+    else if (EQUAL((char *)child->name, "Sections")) {
       xmlNodePtr sectionNode = NULL;
       XML_FOREACH_CHILD(child, sectionNode) {
         XML_LOOP_IGNORE_COMMENT_OR_TEXT(sectionNode)
@@ -826,23 +807,27 @@ static int msWCSParseRequest20_XMLGetCap
         params->sections = CSLAddString(params->sections, content);
         xmlFree(content);
       }
-    } else if(EQUAL((char *)child->name, "UpdateSequence")) {
-      params->updatesequence =
-        (char *)xmlNodeGetContent(child);
-    } else if(EQUAL((char *)child->name, "AcceptFormats")) {
+    }
+    else if (EQUAL((char *)child->name, "UpdateSequence")) {
+      params->updatesequence = (char *)xmlNodeGetContent(child);
+    }
+    else if (EQUAL((char *)child->name, "AcceptFormats")) {
       /* Maybe not necessary, since only format is xml.   */
       /* At least ignore it, to not generate an error.    */
-    } else if(EQUAL((char *)child->name, "AcceptLanguages")) {
+    }
+    else if (EQUAL((char *)child->name, "AcceptLanguages")) {
       xmlNodePtr languageNode;
       XML_FOREACH_CHILD(child, languageNode) {
         XML_LOOP_IGNORE_COMMENT_OR_TEXT(languageNode)
         XML_ASSERT_NODE_NAME(languageNode, "Language");
 
         content = (char *)xmlNodeGetContent(languageNode);
-        params->accept_languages = CSLAddString(params->accept_languages, content);
+        params->accept_languages =
+            CSLAddString(params->accept_languages, content);
         xmlFree(content);
       }
-    } else {
+    }
+    else {
       XML_UNKNOWN_NODE_ERROR(child);
     }
   }
@@ -857,9 +842,8 @@ static int msWCSParseRequest20_XMLGetCap
 /*      to a params object.                                             */
 /************************************************************************/
 #if defined(USE_LIBXML2)
-static int msWCSParseRequest20_XMLDescribeCoverage(
-  xmlNodePtr root, wcs20ParamsObjPtr params)
-{
+static int msWCSParseRequest20_XMLDescribeCoverage(xmlNodePtr root,
+                                                   wcs20ParamsObjPtr params) {
   xmlNodePtr child;
   int numIds = 0;
   char *id;
@@ -891,9 +875,8 @@ static int msWCSParseRequest20_XMLDescri
 /*      params object.                                                  */
 /************************************************************************/
 #if defined(USE_LIBXML2)
-static int msWCSParseRequest20_XMLGetCoverage(
-  mapObj* map, xmlNodePtr root, wcs20ParamsObjPtr params)
-{
+static int msWCSParseRequest20_XMLGetCoverage(mapObj *map, xmlNodePtr root,
+                                              wcs20ParamsObjPtr params) {
   xmlNodePtr child;
   int numIds = 0;
   char *id;
@@ -913,23 +896,25 @@ static int msWCSParseRequest20_XMLGetCov
       ++numIds;
       params->ids = CSLAddString(params->ids, (char *)id);
       xmlFree(id);
-    } else if (EQUAL((char *) child->name, "Format")) {
+    }
+    else if (EQUAL((char *)child->name, "Format")) {
       msFree(params->format);
       params->format = (char *)xmlNodeGetContent(child);
-    } else if (EQUAL((char *) child->name, "Mediatype")) {
+    }
+    else if (EQUAL((char *)child->name, "Mediatype")) {
       char *content = (char *)xmlNodeGetContent(child);
-      if(content != NULL && (EQUAL(content, "multipart/mixed")
-                          || EQUAL(content, "multipart/related"))) {
+      if (content != NULL && (EQUAL(content, "multipart/mixed") ||
+                              EQUAL(content, "multipart/related"))) {
         params->multipart = MS_TRUE;
-      }
-      else {
+      } else {
         msSetError(MS_WCSERR, "Invalid value '%s' for parameter 'Mediatype'.",
-                  "msWCSParseRequest20()", content);
+                   "msWCSParseRequest20()", content);
         xmlFree(content);
         return MS_FAILURE;
       }
       xmlFree(content);
-    } else if (EQUAL((char *) child->name, "DimensionTrim")) {
+    }
+    else if (EQUAL((char *)child->name, "DimensionTrim")) {
       wcs20AxisObjPtr axis = NULL;
       wcs20SubsetObjPtr subset = NULL;
       xmlNodePtr node = NULL;
@@ -940,18 +925,20 @@ static int msWCSParseRequest20_XMLGetCov
         XML_LOOP_IGNORE_COMMENT_OR_TEXT(node)
         else if (EQUAL((char *)node->name, "Dimension")) {
           if (axisName != NULL) {
-            msSetError(MS_WCSERR,
-                       "Parameter 'Dimension' is already set.",
+            msSetError(MS_WCSERR, "Parameter 'Dimension' is already set.",
                        "msWCSParseRequest20_XMLGetCoverage()");
             return MS_FAILURE;
           }
-          axisName = (char *) xmlNodeGetContent(node);
-          crs = (char *) xmlGetProp(node, BAD_CAST "crs");
-        } else if (EQUAL((char *)node->name, "trimLow")) {
-          min = (char *) xmlNodeGetContent(node);
-        } else if (EQUAL((char *)node->name, "trimHigh")) {
-          max = (char *) xmlNodeGetContent(node);
-        } else {
+          axisName = (char *)xmlNodeGetContent(node);
+          crs = (char *)xmlGetProp(node, BAD_CAST "crs");
+        }
+        else if (EQUAL((char *)node->name, "trimLow")) {
+          min = (char *)xmlNodeGetContent(node);
+        }
+        else if (EQUAL((char *)node->name, "trimHigh")) {
+          max = (char *)xmlNodeGetContent(node);
+        }
+        else {
           msFree(axisName);
           msFree(min);
           msFree(max);
@@ -959,7 +946,7 @@ static int msWCSParseRequest20_XMLGetCov
           XML_UNKNOWN_NODE_ERROR(node);
         }
       }
-      if(NULL == (subset = msWCSCreateSubsetObj20())) {
+      if (NULL == (subset = msWCSCreateSubsetObj20())) {
         msFree(axisName);
         msFree(min);
         msFree(max);
@@ -968,21 +955,20 @@ static int msWCSParseRequest20_XMLGetCov
       }
 
       /* min and max have to have a value */
-      if(min == NULL ) {
+      if (min == NULL) {
         min = msStrdup("*");
       }
-      if(max == NULL) {
+      if (max == NULL) {
         max = msStrdup("*");
       }
-      if (msWCSParseSubset20(subset, axisName, crs, min, max)
-          == MS_FAILURE) {
+      if (msWCSParseSubset20(subset, axisName, crs, min, max) == MS_FAILURE) {
         msWCSFreeSubsetObj20(subset);
         msWCSException(map, "InvalidSubsetting", "subset", "2.0.1");
         return MS_DONE;
       }
 
-      if(NULL == (axis = msWCSFindAxis20(params, subset->axis))) {
-        if(NULL == (axis = msWCSCreateAxisObj20())) {
+      if (NULL == (axis = msWCSFindAxis20(params, subset->axis))) {
+        if (NULL == (axis = msWCSCreateAxisObj20())) {
           msFree(axisName);
           msFree(min);
           msFree(max);
@@ -1000,23 +986,27 @@ static int msWCSParseRequest20_XMLGetCov
       msFree(min);
       msFree(max);
       msFree(crs);
-    } else if(EQUAL((char *) child->name, "DimensionSlice")) {
+    }
+    else if (EQUAL((char *)child->name, "DimensionSlice")) {
       msSetError(MS_WCSERR, "Operation '%s' is not supported by MapServer.",
                  "msWCSParseRequest20_XMLGetCoverage()", (char *)child->name);
       return MS_FAILURE;
-    } else if(EQUAL((char *) child->name, "Size")) {
+    }
+    else if (EQUAL((char *)child->name, "Size")) {
       wcs20AxisObjPtr axis;
       char *axisName;
       char *content;
 
-      if(NULL == (axisName = (char *) xmlGetProp(child, BAD_CAST "dimension")) ) {
-        msSetError(MS_WCSERR, "Attribute 'dimension' is missing in element 'Size'.",
+      if (NULL ==
+          (axisName = (char *)xmlGetProp(child, BAD_CAST "dimension"))) {
+        msSetError(MS_WCSERR,
+                   "Attribute 'dimension' is missing in element 'Size'.",
                    "msWCSParseRequest20_XMLGetCoverage()");
         return MS_FAILURE;
       }
 
-      if(NULL == (axis = msWCSFindAxis20(params, axisName))) {
-        if(NULL == (axis = msWCSCreateAxisObj20())) {
+      if (NULL == (axis = msWCSFindAxis20(params, axisName))) {
+        if (NULL == (axis = msWCSCreateAxisObj20())) {
           xmlFree(axisName);
           return MS_FAILURE;
         }
@@ -1026,28 +1016,32 @@ static int msWCSParseRequest20_XMLGetCov
       xmlFree(axisName);
 
       content = (char *)xmlNodeGetContent(child);
-      if(msStringParseInteger(content, &(axis->size)) != MS_SUCCESS) {
+      if (msStringParseInteger(content, &(axis->size)) != MS_SUCCESS) {
         xmlFree(content);
-        msSetError(MS_WCSERR, "Value of element 'Size' could not "
+        msSetError(MS_WCSERR,
+                   "Value of element 'Size' could not "
                    "be parsed to a valid integer.",
                    "msWCSParseRequest20_XMLGetCoverage()");
         return MS_FAILURE;
       }
       xmlFree(content);
-    } else if(EQUAL((char *) child->name, "Resolution")) {
+    }
+    else if (EQUAL((char *)child->name, "Resolution")) {
       wcs20AxisObjPtr axis;
       char *axisName;
       char *content;
 
-      if(NULL == (axisName = (char *) xmlGetProp(child, BAD_CAST "dimension"))) {
-        msSetError(MS_WCSERR, "Attribute 'dimension' is missing "
+      if (NULL ==
+          (axisName = (char *)xmlGetProp(child, BAD_CAST "dimension"))) {
+        msSetError(MS_WCSERR,
+                   "Attribute 'dimension' is missing "
                    "in element 'Resolution'.",
                    "msWCSParseRequest20_XMLGetCoverage()");
         return MS_FAILURE;
       }
 
-      if(NULL == (axis = msWCSFindAxis20(params, axisName))) {
-        if(NULL == (axis = msWCSCreateAxisObj20())) {
+      if (NULL == (axis = msWCSFindAxis20(params, axisName))) {
+        if (NULL == (axis = msWCSCreateAxisObj20())) {
           xmlFree(axisName);
           return MS_FAILURE;
         }
@@ -1056,24 +1050,29 @@ static int msWCSParseRequest20_XMLGetCov
       }
       xmlFree(axisName);
 
-      axis->resolutionUOM = (char *) xmlGetProp(child, BAD_CAST "uom");
+      axis->resolutionUOM = (char *)xmlGetProp(child, BAD_CAST "uom");
 
       content = (char *)xmlNodeGetContent(child);
-      if(msStringParseDouble(content, &(axis->resolution)) != MS_SUCCESS) {
-        msSetError(MS_WCSERR, "Value of element 'Resolution' could not "
+      if (msStringParseDouble(content, &(axis->resolution)) != MS_SUCCESS) {
+        msSetError(MS_WCSERR,
+                   "Value of element 'Resolution' could not "
                    "be parsed to a valid value.",
                    "msWCSParseRequest20_XMLGetCoverage()");
         xmlFree(content);
         return MS_FAILURE;
       }
       xmlFree(content);
-    } else if(EQUAL((char *) child->name, "Interpolation")) {
-      /* Deprecated, use wcs:Extension/int:Interpolation/int:globalInterpolation */
+    }
+    else if (EQUAL((char *)child->name, "Interpolation")) {
+      /* Deprecated, use wcs:Extension/int:Interpolation/int:globalInterpolation
+       */
       msFree(params->interpolation);
-      params->interpolation = (char *) xmlNodeGetContent(child);
-    } else if(EQUAL((char *) child->name, "OutputCRS")) {
-      params->outputcrs = (char *) xmlNodeGetContent(child);
-    } else if(EQUAL((char *) child->name, "rangeSubset")) {
+      params->interpolation = (char *)xmlNodeGetContent(child);
+    }
+    else if (EQUAL((char *)child->name, "OutputCRS")) {
+      params->outputcrs = (char *)xmlNodeGetContent(child);
+    }
+    else if (EQUAL((char *)child->name, "rangeSubset")) {
       /* Deprecated, use wcs:Extension/rsub:RangeSubset */
       xmlNodePtr bandNode = NULL;
       XML_FOREACH_CHILD(child, bandNode) {
@@ -1082,29 +1081,32 @@ static int msWCSParseRequest20_XMLGetCov
         XML_ASSERT_NODE_NAME(bandNode, "band");
 
         content = (char *)xmlNodeGetContent(bandNode);
-        params->range_subset =
-          CSLAddString(params->range_subset, content);
+        params->range_subset = CSLAddString(params->range_subset, content);
         xmlFree(content);
       }
-    } else if (EQUAL((char *)child->name, "Extension")) {
+    }
+    else if (EQUAL((char *)child->name, "Extension")) {
       xmlNodePtr extensionNode = NULL;
       XML_FOREACH_CHILD(child, extensionNode) {
         XML_LOOP_IGNORE_COMMENT_OR_TEXT(extensionNode);
 
-        if (EQUAL((char *) extensionNode->name, "Scaling")) {
-          xmlNodePtr scaleMethodNode = msLibXml2GetFirstChildElement(extensionNode);
-
-          if (EQUAL((char *) scaleMethodNode->name, "ScaleByFactor")) {
-            xmlNodePtr scaleFactorNode = msLibXml2GetFirstChildElement(scaleMethodNode);
+        if (EQUAL((char *)extensionNode->name, "Scaling")) {
+          xmlNodePtr scaleMethodNode =
+              msLibXml2GetFirstChildElement(extensionNode);
+
+          if (EQUAL((char *)scaleMethodNode->name, "ScaleByFactor")) {
+            xmlNodePtr scaleFactorNode =
+                msLibXml2GetFirstChildElement(scaleMethodNode);
             char *content;
-            if (!scaleFactorNode || !EQUAL((char *)scaleFactorNode->name, "scaleFactor")) {
+            if (!scaleFactorNode ||
+                !EQUAL((char *)scaleFactorNode->name, "scaleFactor")) {
               msSetError(MS_WCSERR, "Missing 'scaleFactor' node.",
                          "msWCSParseRequest20_XMLGetCoverage()");
               return MS_FAILURE;
             }
             content = (char *)xmlNodeGetContent(scaleFactorNode);
-            if (msStringParseDouble(content, &(params->scale)) != MS_SUCCESS
-                || params->scale < 0.0) {
+            if (msStringParseDouble(content, &(params->scale)) != MS_SUCCESS ||
+                params->scale < 0.0) {
               msSetError(MS_WCSERR, "Invalid scaleFactor '%s'.",
                          "msWCSParseRequest20_XMLGetCoverage()", content);
               xmlFree(content);
@@ -1113,7 +1115,7 @@ static int msWCSParseRequest20_XMLGetCov
             xmlFree(content);
           }
 
-          else if (EQUAL((char *) scaleMethodNode->name, "ScaleAxesByFactor")) {
+          else if (EQUAL((char *)scaleMethodNode->name, "ScaleAxesByFactor")) {
             xmlNodePtr scaleAxisNode, axisNode, scaleFactorNode;
             char *axisName, *content;
             wcs20AxisObjPtr axis;
@@ -1128,14 +1130,15 @@ static int msWCSParseRequest20_XMLGetCov
               }
 
               /* axis */
-              if (NULL == (axisNode = msLibXml2GetFirstChild(scaleAxisNode, "axis"))) {
+              if (NULL ==
+                  (axisNode = msLibXml2GetFirstChild(scaleAxisNode, "axis"))) {
                 msSetError(MS_WCSERR, "Missing axis node",
                            "msWCSParseRequest20_XMLGetCoverage()");
                 return MS_FAILURE;
               }
               axisName = (char *)xmlNodeGetContent(axisNode);
-              if(NULL == (axis = msWCSFindAxis20(params, axisName))) {
-                if(NULL == (axis = msWCSCreateAxisObj20())) {
+              if (NULL == (axis = msWCSFindAxis20(params, axisName))) {
+                if (NULL == (axis = msWCSCreateAxisObj20())) {
                   xmlFree(axisName);
                   return MS_FAILURE;
                 }
@@ -1145,21 +1148,23 @@ static int msWCSParseRequest20_XMLGetCov
               xmlFree(axisName);
 
               if (axis->scale != MS_WCS20_UNBOUNDED) {
-                msSetError(MS_WCSERR, "scaleFactor was already set for axis '%s'.",
+                msSetError(MS_WCSERR,
+                           "scaleFactor was already set for axis '%s'.",
                            "msWCSParseRequest20_XMLGetCoverage()", axis->name);
                 return MS_FAILURE;
               }
 
               /* scaleFactor */
-              if (NULL == (scaleFactorNode = msLibXml2GetFirstChild(scaleAxisNode, "scaleFactor"))) {
+              if (NULL == (scaleFactorNode = msLibXml2GetFirstChild(
+                               scaleAxisNode, "scaleFactor"))) {
                 msSetError(MS_WCSERR, "Missing scaleFactor node",
                            "msWCSParseRequest20_XMLGetCoverage()");
                 return MS_FAILURE;
               }
 
               content = (char *)xmlNodeGetContent(scaleFactorNode);
-              if (msStringParseDouble(content, &(axis->scale)) != MS_SUCCESS
-                  || axis->scale < 0.0) {
+              if (msStringParseDouble(content, &(axis->scale)) != MS_SUCCESS ||
+                  axis->scale < 0.0) {
                 msSetError(MS_WCSERR, "Invalid scaleFactor '%s'.",
                            "msWCSParseRequest20_XMLGetCoverage()", content);
                 xmlFree(content);
@@ -1169,7 +1174,7 @@ static int msWCSParseRequest20_XMLGetCov
             }
           }
 
-          else if (EQUAL((char *) scaleMethodNode->name, "ScaleToSize")) {
+          else if (EQUAL((char *)scaleMethodNode->name, "ScaleToSize")) {
             xmlNodePtr scaleAxisNode, axisNode, targetSizeNode;
             char *axisName, *content;
             wcs20AxisObjPtr axis;
@@ -1184,14 +1189,15 @@ static int msWCSParseRequest20_XMLGetCov
               }
 
               /* axis */
-              if (NULL == (axisNode = msLibXml2GetFirstChild(scaleAxisNode, "axis"))) {
+              if (NULL ==
+                  (axisNode = msLibXml2GetFirstChild(scaleAxisNode, "axis"))) {
                 msSetError(MS_WCSERR, "Missing axis node",
                            "msWCSParseRequest20_XMLGetCoverage()");
                 return MS_FAILURE;
               }
               axisName = (char *)xmlNodeGetContent(axisNode);
-              if(NULL == (axis = msWCSFindAxis20(params, axisName))) {
-                if(NULL == (axis = msWCSCreateAxisObj20())) {
+              if (NULL == (axis = msWCSFindAxis20(params, axisName))) {
+                if (NULL == (axis = msWCSCreateAxisObj20())) {
                   xmlFree(axisName);
                   return MS_FAILURE;
                 }
@@ -1201,21 +1207,23 @@ static int msWCSParseRequest20_XMLGetCov
               xmlFree(axisName);
 
               if (axis->size != 0) {
-                msSetError(MS_WCSERR, "targetSize was already set for axis '%s'.",
+                msSetError(MS_WCSERR,
+                           "targetSize was already set for axis '%s'.",
                            "msWCSParseRequest20_XMLGetCoverage()", axis->name);
                 return MS_FAILURE;
               }
 
               /* targetSize */
-              if (NULL == (targetSizeNode = msLibXml2GetFirstChild(scaleAxisNode, "targetSize"))) {
+              if (NULL == (targetSizeNode = msLibXml2GetFirstChild(
+                               scaleAxisNode, "targetSize"))) {
                 msSetError(MS_WCSERR, "Missing targetSize node",
                            "msWCSParseRequest20_XMLGetCoverage()");
                 return MS_FAILURE;
               }
 
               content = (char *)xmlNodeGetContent(targetSizeNode);
-              if (msStringParseInteger(content, &(axis->size)) != MS_SUCCESS
-                  || axis->size <= 0) {
+              if (msStringParseInteger(content, &(axis->size)) != MS_SUCCESS ||
+                  axis->size <= 0) {
                 msSetError(MS_WCSERR, "Invalid targetSize '%s'.",
                            "msWCSParseRequest20_XMLGetCoverage()", content);
                 xmlFree(content);
@@ -1225,7 +1233,7 @@ static int msWCSParseRequest20_XMLGetCov
             }
           }
 
-          else if (EQUAL((char *) scaleMethodNode->name, "ScaleToExtent")) {
+          else if (EQUAL((char *)scaleMethodNode->name, "ScaleToExtent")) {
             xmlNodePtr scaleAxisNode, axisNode, lowNode, highNode;
             char *axisName, *content;
             wcs20AxisObjPtr axis;
@@ -1241,14 +1249,15 @@ static int msWCSParseRequest20_XMLGetCov
               }
 
               /* axis */
-              if (NULL == (axisNode = msLibXml2GetFirstChild(scaleAxisNode, "axis"))) {
+              if (NULL ==
+                  (axisNode = msLibXml2GetFirstChild(scaleAxisNode, "axis"))) {
                 msSetError(MS_WCSERR, "Missing axis node",
                            "msWCSParseRequest20_XMLGetCoverage()");
                 return MS_FAILURE;
               }
               axisName = (char *)xmlNodeGetContent(axisNode);
-              if(NULL == (axis = msWCSFindAxis20(params, axisName))) {
-                if(NULL == (axis = msWCSCreateAxisObj20())) {
+              if (NULL == (axis = msWCSFindAxis20(params, axisName))) {
+                if (NULL == (axis = msWCSCreateAxisObj20())) {
                   xmlFree(axisName);
                   return MS_FAILURE;
                 }
@@ -1258,19 +1267,22 @@ static int msWCSParseRequest20_XMLGetCov
               xmlFree(axisName);
 
               if (axis->size != 0) {
-                msSetError(MS_WCSERR, "targetSize was already set for axis '%s'.",
+                msSetError(MS_WCSERR,
+                           "targetSize was already set for axis '%s'.",
                            "msWCSParseRequest20_XMLGetCoverage()", axis->name);
                 return MS_FAILURE;
               }
 
               /* targetSize */
-              if (NULL == (lowNode = msLibXml2GetFirstChild(scaleAxisNode, "low"))) {
+              if (NULL ==
+                  (lowNode = msLibXml2GetFirstChild(scaleAxisNode, "low"))) {
                 msSetError(MS_WCSERR, "Missing low node",
                            "msWCSParseRequest20_XMLGetCoverage()");
                 return MS_FAILURE;
               }
 
-              if (NULL == (highNode = msLibXml2GetFirstChild(scaleAxisNode, "high"))) {
+              if (NULL ==
+                  (highNode = msLibXml2GetFirstChild(scaleAxisNode, "high"))) {
                 msSetError(MS_WCSERR, "Missing high node",
                            "msWCSParseRequest20_XMLGetCoverage()");
                 return MS_FAILURE;
@@ -1285,7 +1297,6 @@ static int msWCSParseRequest20_XMLGetCov
               }
               xmlFree(content);
 
-
               content = (char *)xmlNodeGetContent(highNode);
               if (msStringParseInteger(content, &high) != MS_SUCCESS) {
                 msSetError(MS_WCSERR, "Invalid high value '%s'.",
@@ -1307,36 +1318,39 @@ static int msWCSParseRequest20_XMLGetCov
         }
 
         /* Range Subset */
-        else if(EQUAL((char *) extensionNode->name, "RangeSubset")) {
+        else if (EQUAL((char *)extensionNode->name, "RangeSubset")) {
           xmlNodePtr rangeItemNode = NULL;
 
           XML_FOREACH_CHILD(extensionNode, rangeItemNode) {
-            xmlNodePtr rangeItemNodeChild = msLibXml2GetFirstChildElement(rangeItemNode);
+            xmlNodePtr rangeItemNodeChild =
+                msLibXml2GetFirstChildElement(rangeItemNode);
             XML_LOOP_IGNORE_COMMENT_OR_TEXT(rangeItemNode);
 
             XML_ASSERT_NODE_NAME(rangeItemNode, "RangeItem");
 
             if (!rangeItemNodeChild) {
               msSetError(MS_WCSERR, "Missing RangeComponent or RangeInterval.",
-                                    "msWCSParseRequest20_XMLGetCoverage()");
+                         "msWCSParseRequest20_XMLGetCoverage()");
               return MS_FAILURE;
-            }
-            else if (EQUAL((char *) rangeItemNodeChild->name, "RangeComponent")) {
+            } else if (EQUAL((char *)rangeItemNodeChild->name,
+                             "RangeComponent")) {
               char *content = (char *)xmlNodeGetContent(rangeItemNodeChild);
               params->range_subset =
-                CSLAddString(params->range_subset, content);
+                  CSLAddString(params->range_subset, content);
               xmlFree(content);
-            }
-            else if (EQUAL((char *) rangeItemNodeChild->name, "RangeInterval")) {
+            } else if (EQUAL((char *)rangeItemNodeChild->name,
+                             "RangeInterval")) {
               xmlNodePtr intervalNode = rangeItemNodeChild;
-              xmlNodePtr startComponentNode = msLibXml2GetFirstChild(intervalNode, "startComponent");
-              xmlNodePtr endComponentNode = msLibXml2GetFirstChild(intervalNode, "endComponent");
+              xmlNodePtr startComponentNode =
+                  msLibXml2GetFirstChild(intervalNode, "startComponent");
+              xmlNodePtr endComponentNode =
+                  msLibXml2GetFirstChild(intervalNode, "endComponent");
               char *start;
               char *stop;
 
               if (!startComponentNode || !endComponentNode) {
                 msSetError(MS_WCSERR, "Wrong RangeInterval.",
-                                      "msWCSParseRequest20_XMLGetCoverage()");
+                           "msWCSParseRequest20_XMLGetCoverage()");
                 return MS_FAILURE;
               }
 
@@ -1351,27 +1365,28 @@ static int msWCSParseRequest20_XMLGetCov
               xmlFree(stop);
 
               params->range_subset =
-                CSLAddString(params->range_subset, value.c_str());
+                  CSLAddString(params->range_subset, value.c_str());
             }
           }
         }
 
-        else if (EQUAL((char *) extensionNode->name, "subsettingCrs")) {
+        else if (EQUAL((char *)extensionNode->name, "subsettingCrs")) {
           msFree(params->subsetcrs);
           params->subsetcrs = (char *)xmlNodeGetContent(extensionNode);
         }
 
-        else if (EQUAL((char *) extensionNode->name, "outputCrs")) {
+        else if (EQUAL((char *)extensionNode->name, "outputCrs")) {
           msFree(params->outputcrs);
           params->outputcrs = (char *)xmlNodeGetContent(extensionNode);
         }
 
-        else if (EQUAL((char *) extensionNode->name, "Interpolation")) {
-          xmlNodePtr globalInterpolation = msLibXml2GetFirstChild(extensionNode, "globalInterpolation");
+        else if (EQUAL((char *)extensionNode->name, "Interpolation")) {
+          xmlNodePtr globalInterpolation =
+              msLibXml2GetFirstChild(extensionNode, "globalInterpolation");
           char *content;
           if (globalInterpolation == NULL) {
             msSetError(MS_WCSERR, "Missing 'globalInterpolation' node.",
-                                  "msWCSParseRequest20_XMLGetCoverage()");
+                       "msWCSParseRequest20_XMLGetCoverage()");
             return MS_FAILURE;
           }
           content = (char *)xmlNodeGetContent(globalInterpolation);
@@ -1382,9 +1397,10 @@ static int msWCSParseRequest20_XMLGetCov
         }
 
         /* GeoTIFF parameters */
-        else if (EQUAL((char *) extensionNode->name, "parameters")
-                && extensionNode->ns
-                && EQUAL((char *)extensionNode->ns->href, "http://www.opengis.net/gmlcov/geotiff/1.0")) {
+        else if (EQUAL((char *)extensionNode->name, "parameters") &&
+                 extensionNode->ns &&
+                 EQUAL((char *)extensionNode->ns->href,
+                       "http://www.opengis.net/gmlcov/geotiff/1.0")) {
 
           xmlNodePtr parameter;
 
@@ -1394,13 +1410,14 @@ static int msWCSParseRequest20_XMLGetCov
 
             content = (char *)xmlNodeGetContent(parameter);
 
-            params->format_options =
-              CSLAddNameValue(params->format_options, (char *)parameter->name, content);
+            params->format_options = CSLAddNameValue(
+                params->format_options, (char *)parameter->name, content);
             xmlFree(content);
           }
         }
       }
-    } else {
+    }
+    else {
       XML_UNKNOWN_NODE_ERROR(child);
     }
   }
@@ -1417,11 +1434,8 @@ static int msWCSParseRequest20_XMLGetCov
 /*      before the parameters can be extracted.                         */
 /************************************************************************/
 
-int msWCSParseRequest20(mapObj *map,
-                        cgiRequestObj *request,
-                        owsRequestObj *ows_request,
-                        wcs20ParamsObjPtr params)
-{
+int msWCSParseRequest20(mapObj *map, cgiRequestObj *request,
+                        owsRequestObj *ows_request, wcs20ParamsObjPtr params) {
   int i;
   if (params == NULL || request == NULL || ows_request == NULL) {
     msSetError(MS_WCSERR, "Internal error.", "msWCSParseRequest20()");
@@ -1430,12 +1444,11 @@ int msWCSParseRequest20(mapObj *map,
 
   /* Copy arbitrary service, version and request. */
   params->service = msStrdup(ows_request->service);
-  if(ows_request->version != NULL) {
+  if (ows_request->version != NULL) {
     params->version = msStrdup(ows_request->version);
   }
   params->request = msStrdup(ows_request->request);
 
-
   /* Parse the POST request */
   if (request->type == MS_POST_REQUEST) {
 #if defined(USE_LIBXML2)
@@ -1445,10 +1458,10 @@ int msWCSParseRequest20(mapObj *map,
     int ret = MS_SUCCESS;
 
     /* parse to DOM-Structure and get root element */
-    if(doc == NULL) {
-      xmlErrorPtr error = xmlGetLastError();
-      msSetError(MS_WCSERR, "XML parsing error: %s",
-                 "msWCSParseRequest20()", error->message);
+    if (doc == NULL) {
+      const xmlError *error = xmlGetLastError();
+      msSetError(MS_WCSERR, "XML parsing error: %s", "msWCSParseRequest20()",
+                 error->message);
       return MS_FAILURE;
     }
 
@@ -1456,15 +1469,14 @@ int msWCSParseRequest20(mapObj *map,
 
     validate = msOWSLookupMetadata(&(map->web.metadata), "CO", "validate_xml");
     if (validate != NULL && EQUAL(validate, "TRUE")) {
-      char *schema_dir = msStrdup(msOWSLookupMetadata(&(map->web.metadata),
-                                  "CO", "schemas_dir"));
-      if (schema_dir != NULL
-          && (params->version == NULL ||
-              EQUALN(params->version, "2.0", 3))) {
-        schema_dir = msStringConcatenate(schema_dir,
-                                         "wcs/2.0.0/wcsAll.xsd");
+      char *schema_dir = msStrdup(
+          msOWSLookupMetadata(&(map->web.metadata), "CO", "schemas_dir"));
+      if (schema_dir != NULL &&
+          (params->version == NULL || EQUALN(params->version, "2.0", 3))) {
+        schema_dir = msStringConcatenate(schema_dir, "wcs/2.0.0/wcsAll.xsd");
         if (msOWSSchemaValidation(schema_dir, request->postrequest) != 0) {
-          msSetError(MS_WCSERR, "Invalid POST request. "
+          msSetError(MS_WCSERR,
+                     "Invalid POST request. "
                      "XML is not valid",
                      "msWCSParseRequest20()");
           return MS_FAILURE;
@@ -1473,18 +1485,18 @@ int msWCSParseRequest20(mapObj *map,
       msFree(schema_dir);
     }
 
-    if(EQUAL(params->request, "GetCapabilities")) {
+    if (EQUAL(params->request, "GetCapabilities")) {
       ret = msWCSParseRequest20_XMLGetCapabilities(root, params);
-    } else if(params->version != NULL && EQUALN(params->version, "2.0", 3)) {
-      if(EQUAL(params->request, "DescribeCoverage")) {
+    } else if (params->version != NULL && EQUALN(params->version, "2.0", 3)) {
+      if (EQUAL(params->request, "DescribeCoverage")) {
         ret = msWCSParseRequest20_XMLDescribeCoverage(root, params);
-      } else if(EQUAL(params->request, "GetCoverage")) {
+      } else if (EQUAL(params->request, "GetCoverage")) {
         ret = msWCSParseRequest20_XMLGetCoverage(map, root, params);
       }
     }
     return ret;
 
-#else /* defined(USE_LIBXML2) */
+#else  /* defined(USE_LIBXML2) */
     /* TODO: maybe with CPLXML? */
     return MS_FAILURE;
 #endif /* defined(USE_LIBXML2) */
@@ -1506,16 +1518,15 @@ int msWCSParseRequest20(mapObj *map,
       continue;
     } else if (EQUAL(key, "ACCEPTVERSIONS")) {
       tokens = msStringSplit(value, ',', &num);
-      for(j = 0; j < num; ++j) {
+      for (j = 0; j < num; ++j) {
         params->accept_versions =
-          CSLAddString(params->accept_versions, tokens[j]);
+            CSLAddString(params->accept_versions, tokens[j]);
       }
       msFreeCharArray(tokens, num);
     } else if (EQUAL(key, "SECTIONS")) {
       tokens = msStringSplit(value, ',', &num);
-      for(j = 0; j < num; ++j) {
-        params->sections =
-          CSLAddString(params->sections, tokens[j]);
+      for (j = 0; j < num; ++j) {
+        params->sections = CSLAddString(params->sections, tokens[j]);
       }
       msFreeCharArray(tokens, num);
     } else if (EQUAL(key, "UPDATESEQUENCE")) {
@@ -1530,23 +1541,24 @@ int msWCSParseRequest20(mapObj *map,
       params->accept_languages = CSLTokenizeString2(value, ",", 0);
     } else if (EQUAL(key, "COVERAGEID")) {
       if (params->ids != NULL) {
-        msSetError(MS_WCSERR, "Parameter 'CoverageID' is already set. "
+        msSetError(MS_WCSERR,
+                   "Parameter 'CoverageID' is already set. "
                    "For multiple IDs use a comma separated list.",
                    "msWCSParseRequest20()");
         return MS_FAILURE;
       }
-      params->ids = CSLTokenizeString2(value, ",",0);
+      params->ids = CSLTokenizeString2(value, ",", 0);
     } else if (EQUAL(key, "FORMAT")) {
       msFree(params->format);
       params->format = msStrdup(value);
     } else if (EQUAL(key, "MEDIATYPE")) {
-      if(EQUAL(value, "multipart/mixed") || EQUAL(value, "multipart/related")) {
+      if (EQUAL(value, "multipart/mixed") ||
+          EQUAL(value, "multipart/related")) {
         params->multipart = MS_TRUE;
-      }
-      else {
-         msSetError(MS_WCSERR, "Invalid value '%s' for parameter 'Mediatype'.",
-                    "msWCSParseRequest20()", value);
-         return MS_FAILURE;
+      } else {
+        msSetError(MS_WCSERR, "Invalid value '%s' for parameter 'Mediatype'.",
+                   "msWCSParseRequest20()", value);
+        return MS_FAILURE;
       }
     } else if (EQUAL(key, "INTERPOLATION")) {
       msFree(params->interpolation);
@@ -1561,7 +1573,7 @@ int msWCSParseRequest20(mapObj *map,
       double scale = MS_WCS20_UNBOUNDED;
       if (params->scale != MS_WCS20_UNBOUNDED) {
         msSetError(MS_WCSERR, "Parameter 'SCALEFACTOR' already set.",
-                    "msWCSParseRequest20()");
+                   "msWCSParseRequest20()");
         return MS_FAILURE;
       } else if (msStringParseDouble(value, &scale) != MS_SUCCESS) {
         msSetError(MS_WCSERR, "Could not parse parameter 'SCALEFACTOR'.",
@@ -1576,17 +1588,18 @@ int msWCSParseRequest20(mapObj *map,
     } else if (EQUAL(key, "SCALEAXES")) {
       wcs20AxisObjPtr axis = NULL;
       tokens = msStringSplit(value, ',', &num);
-      for(j = 0; j < num; ++j) {
+      for (j = 0; j < num; ++j) {
         char axisName[500];
         double scale;
 
-        if (msWCSParseScaleString20(tokens[j], axisName, sizeof(axisName), &scale) != MS_SUCCESS) {
+        if (msWCSParseScaleString20(tokens[j], axisName, sizeof(axisName),
+                                    &scale) != MS_SUCCESS) {
           msFreeCharArray(tokens, num);
           return MS_FAILURE;
         }
 
-        if(NULL == (axis = msWCSFindAxis20(params, axisName))) {
-          if(NULL == (axis = msWCSCreateAxisObj20())) {
+        if (NULL == (axis = msWCSFindAxis20(params, axisName))) {
+          if (NULL == (axis = msWCSCreateAxisObj20())) {
             msFreeCharArray(tokens, num);
             return MS_FAILURE;
           }
@@ -1595,7 +1608,7 @@ int msWCSParseRequest20(mapObj *map,
         }
 
         /* check if the size of the axis is already set */
-        if(axis->scale != MS_WCS20_UNBOUNDED) {
+        if (axis->scale != MS_WCS20_UNBOUNDED) {
           msFreeCharArray(tokens, num);
           msSetError(MS_WCSERR, "The scale of the axis is already set.",
                      "msWCSParseRequest20()");
@@ -1607,17 +1620,18 @@ int msWCSParseRequest20(mapObj *map,
     } else if (EQUAL(key, "SCALESIZE")) {
       wcs20AxisObjPtr axis = NULL;
       tokens = msStringSplit(value, ',', &num);
-      for(j = 0; j < num; ++j) {
+      for (j = 0; j < num; ++j) {
         char axisName[500];
         int size;
 
-        if (msWCSParseSizeString20(tokens[j], axisName, sizeof(axisName), &size) != MS_SUCCESS) {
+        if (msWCSParseSizeString20(tokens[j], axisName, sizeof(axisName),
+                                   &size) != MS_SUCCESS) {
           msFreeCharArray(tokens, num);
           return MS_FAILURE;
         }
 
-        if(NULL == (axis = msWCSFindAxis20(params, axisName))) {
-          if(NULL == (axis = msWCSCreateAxisObj20())) {
+        if (NULL == (axis = msWCSFindAxis20(params, axisName))) {
+          if (NULL == (axis = msWCSCreateAxisObj20())) {
             msFreeCharArray(tokens, num);
             return MS_FAILURE;
           }
@@ -1626,7 +1640,7 @@ int msWCSParseRequest20(mapObj *map,
         }
 
         /* check if the size of the axis is already set */
-        if(axis->size != 0) {
+        if (axis->size != 0) {
           msFreeCharArray(tokens, num);
           msSetError(MS_WCSERR, "The size of the axis is already set.",
                      "msWCSParseRequest20()");
@@ -1639,7 +1653,7 @@ int msWCSParseRequest20(mapObj *map,
       wcs20AxisObjPtr axis = NULL;
       /* No real support for scaleextent, we just interprete it as SCALESIZE */
       tokens = msStringSplit(value, ',', &num);
-      for(j = 0; j < num; ++j) {
+      for (j = 0; j < num; ++j) {
         char axisName[500];
         int min, max;
 
@@ -1649,8 +1663,8 @@ int msWCSParseRequest20(mapObj *map,
           return MS_FAILURE;
         }
 
-        if(NULL == (axis = msWCSFindAxis20(params, axisName))) {
-          if(NULL == (axis = msWCSCreateAxisObj20())) {
+        if (NULL == (axis = msWCSFindAxis20(params, axisName))) {
+          if (NULL == (axis = msWCSCreateAxisObj20())) {
             msFreeCharArray(tokens, num);
             return MS_FAILURE;
           }
@@ -1659,7 +1673,7 @@ int msWCSParseRequest20(mapObj *map,
         }
 
         /* check if the size of the axis is already set */
-        if(axis->size != 0) {
+        if (axis->size != 0) {
           msFreeCharArray(tokens, num);
           msSetError(MS_WCSERR, "The size of the axis is already set.",
                      "msWCSParseRequest20()");
@@ -1668,19 +1682,21 @@ int msWCSParseRequest20(mapObj *map,
         axis->size = max - min;
       }
       msFreeCharArray(tokens, num);
-      /* We explicitly don't test for strict equality as the parameter name is supposed to be unique */
+      /* We explicitly don't test for strict equality as the parameter name is
+       * supposed to be unique */
     } else if (EQUALN(key, "SIZE", 4)) {
       /* Deprecated scaling */
       wcs20AxisObjPtr axis = NULL;
       char axisName[500];
       int size = 0;
 
-      if(msWCSParseSizeString20(value, axisName, sizeof(axisName), &size) == MS_FAILURE) {
+      if (msWCSParseSizeString20(value, axisName, sizeof(axisName), &size) ==
+          MS_FAILURE) {
         return MS_FAILURE;
       }
 
-      if(NULL == (axis = msWCSFindAxis20(params, axisName))) {
-        if(NULL == (axis = msWCSCreateAxisObj20())) {
+      if (NULL == (axis = msWCSFindAxis20(params, axisName))) {
+        if (NULL == (axis = msWCSCreateAxisObj20())) {
           return MS_FAILURE;
         }
         axis->name = msStrdup(axisName);
@@ -1688,25 +1704,27 @@ int msWCSParseRequest20(mapObj *map,
       }
 
       /* check if the size of the axis is already set */
-      if(axis->size != 0) {
+      if (axis->size != 0) {
         msSetError(MS_WCSERR, "The size of the axis is already set.",
                    "msWCSParseRequest20()");
         return MS_FAILURE;
       }
       axis->size = size;
-    /* We explicitly don't test for strict equality as the parameter name is supposed to be unique */
+      /* We explicitly don't test for strict equality as the parameter name is
+       * supposed to be unique */
     } else if (EQUALN(key, "RESOLUTION", 10)) {
       wcs20AxisObjPtr axis = NULL;
       char axisName[500];
       double resolution = 0;
 
-      if(msWCSParseResolutionString20(value, axisName, sizeof(axisName), &resolution) == MS_FAILURE) {
+      if (msWCSParseResolutionString20(value, axisName, sizeof(axisName),
+                                       &resolution) == MS_FAILURE) {
         return MS_FAILURE;
       }
 
       /* check if axis object already exists, otherwise create a new one */
-      if(NULL == (axis = msWCSFindAxis20(params, axisName))) {
-        if(NULL == (axis = msWCSCreateAxisObj20())) {
+      if (NULL == (axis = msWCSFindAxis20(params, axisName))) {
+        if (NULL == (axis = msWCSCreateAxisObj20())) {
           return MS_FAILURE;
         }
         axis->name = msStrdup(axisName);
@@ -1714,34 +1732,36 @@ int msWCSParseRequest20(mapObj *map,
       }
 
       /* check if the resolution of the axis is already set */
-      if(axis->resolution != MS_WCS20_UNBOUNDED) {
+      if (axis->resolution != MS_WCS20_UNBOUNDED) {
         msSetError(MS_WCSERR, "The resolution of the axis is already set.",
                    "msWCSParseRequest20()");
         return MS_FAILURE;
       }
       axis->resolution = resolution;
-    /* We explicitly don't test for strict equality as the parameter name is supposed to be unique */
+      /* We explicitly don't test for strict equality as the parameter name is
+       * supposed to be unique */
     } else if (EQUALN(key, "SUBSET", 6)) {
       wcs20AxisObjPtr axis = NULL;
       wcs20SubsetObjPtr subset = msWCSCreateSubsetObj20();
-      if(NULL == subset) {
+      if (NULL == subset) {
         return MS_FAILURE;
       }
       if (msWCSParseSubsetKVPString20(subset, value) == MS_FAILURE) {
         msWCSFreeSubsetObj20(subset);
-        msWCSException(map, "InvalidSubsetting", "subset", ows_request->version);
+        msWCSException(map, "InvalidSubsetting", "subset",
+                       ows_request->version);
         return MS_DONE;
       }
 
-      if(NULL == (axis = msWCSFindAxis20(params, subset->axis))) {
-        if(NULL == (axis = msWCSCreateAxisObj20())) {
+      if (NULL == (axis = msWCSFindAxis20(params, subset->axis))) {
+        if (NULL == (axis = msWCSCreateAxisObj20())) {
           return MS_FAILURE;
         }
         axis->name = msStrdup(subset->axis);
         msWCSInsertAxisObj20(params, axis);
       }
 
-      if(NULL != axis->subset) {
+      if (NULL != axis->subset) {
         msSetError(MS_WCSERR, "The axis '%s' is already subsetted.",
                    "msWCSParseRequest20()", axis->name);
         msWCSFreeSubsetObj20(subset);
@@ -1749,16 +1769,15 @@ int msWCSParseRequest20(mapObj *map,
         return MS_DONE;
       }
       axis->subset = subset;
-    } else if(EQUAL(key, "RANGESUBSET")) {
+    } else if (EQUAL(key, "RANGESUBSET")) {
       tokens = msStringSplit(value, ',', &num);
-      for(j = 0; j < num; ++j) {
-        params->range_subset =
-          CSLAddString(params->range_subset, tokens[j]);
+      for (j = 0; j < num; ++j) {
+        params->range_subset = CSLAddString(params->range_subset, tokens[j]);
       }
       msFreeCharArray(tokens, num);
     } else if (EQUALN(key, "GEOTIFF:", 8)) {
       params->format_options =
-        CSLAddNameValue(params->format_options, key, value);
+          CSLAddNameValue(params->format_options, key, value);
     }
     /* Ignore all other parameters here */
   }
@@ -1776,36 +1795,41 @@ int msWCSParseRequest20(mapObj *map,
 /*      a sample found for this axis, an Error is returned. Also if no  */
 /*      axis is found for a given axis, an error is returned.           */
 /************************************************************************/
-static int msWCSValidateAndFindAxes20(
-  wcs20ParamsObjPtr params,
-  wcs20AxisObjPtr outAxes[])
-{
+static int msWCSValidateAndFindAxes20(wcs20ParamsObjPtr params,
+                                      wcs20AxisObjPtr outAxes[]) {
   static const int numAxis = 2;
-  const char * const validXAxisNames[] = {"x", "xaxis", "x-axis", "x_axis", "long", "long_axis", "long-axis", "lon", "lon_axis", "lon-axis", NULL};
-  const char * const validYAxisNames[] = {"y", "yaxis", "y-axis", "y_axis", "lat", "lat_axis", "lat-axis", NULL};
-  const char * const * const validAxisNames[2] = { validXAxisNames, validYAxisNames };
+  const char *const validXAxisNames[] = {
+      "x",         "xaxis", "x-axis",   "x_axis",   "long", "long_axis",
+      "long-axis", "lon",   "lon_axis", "lon-axis", NULL};
+  const char *const validYAxisNames[] = {
+      "y", "yaxis", "y-axis", "y_axis", "lat", "lat_axis", "lat-axis", NULL};
+  const char *const *const validAxisNames[2] = {validXAxisNames,
+                                                validYAxisNames};
   int iParamAxis, iAcceptedAxis, iName, i;
 
-  for(i = 0; i < numAxis; ++i) {
+  for (i = 0; i < numAxis; ++i) {
     outAxes[i] = NULL;
   }
 
   /* iterate over all subsets */
-  for(iParamAxis = 0; iParamAxis < params->numaxes; ++iParamAxis) {
+  for (iParamAxis = 0; iParamAxis < params->numaxes; ++iParamAxis) {
     int found = 0;
 
     /* iterate over all given axes */
-    for(iAcceptedAxis = 0; iAcceptedAxis < numAxis; ++iAcceptedAxis ) {
+    for (iAcceptedAxis = 0; iAcceptedAxis < numAxis; ++iAcceptedAxis) {
       /* iterate over all possible names for the current axis */
-      for(iName = 0; validAxisNames[iAcceptedAxis][iName] != NULL ; ++iName) {
+      for (iName = 0; validAxisNames[iAcceptedAxis][iName] != NULL; ++iName) {
         /* compare axis name with current possible name */
-        if(EQUAL(params->axes[iParamAxis]->name, validAxisNames[iAcceptedAxis][iName])) {
+        if (EQUAL(params->axes[iParamAxis]->name,
+                  validAxisNames[iAcceptedAxis][iName])) {
           /* if there is already a sample for the axis, throw error */
-          if(outAxes[iAcceptedAxis] != NULL) {
-            msSetError(MS_WCSERR, "The axis with the name '%s' corresponds "
+          if (outAxes[iAcceptedAxis] != NULL) {
+            msSetError(MS_WCSERR,
+                       "The axis with the name '%s' corresponds "
                        "to the same axis as the subset with the name '%s'.",
                        "msWCSValidateAndFindAxes20()",
-                       outAxes[iAcceptedAxis]->name, params->axes[iParamAxis]->name);
+                       outAxes[iAcceptedAxis]->name,
+                       params->axes[iParamAxis]->name);
             return MS_FAILURE;
           }
 
@@ -1822,9 +1846,10 @@ static int msWCSValidateAndFindAxes20(
 
     /* no valid representation for current subset found */
     /* exit and throw error                             */
-    if(found == 0) {
+    if (found == 0) {
       msSetError(MS_WCSERR, "Invalid subset axis '%s'.",
-                 "msWCSValidateAndFindAxes20()", params->axes[iParamAxis]->name);
+                 "msWCSValidateAndFindAxes20()",
+                 params->axes[iParamAxis]->name);
       return MS_FAILURE;
     }
   }
@@ -1838,44 +1863,62 @@ static int msWCSValidateAndFindAxes20(
 /*      structure.                                                      */
 /************************************************************************/
 
-static void msWCSPrepareNamespaces20(xmlDocPtr pDoc, xmlNodePtr psRootNode, mapObj* map, int addInspire)
-{
+static void msWCSPrepareNamespaces20(xmlDocPtr pDoc, xmlNodePtr psRootNode,
+                                     mapObj *map, int addInspire) {
   xmlNsPtr psXsiNs;
   char *schemaLocation = NULL;
   char *xsi_schemaLocation = NULL;
 
-  xmlSetNs(psRootNode, xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_WCS_20_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_WCS_NAMESPACE_PREFIX));
-
-  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OWS_20_NAMESPACE_URI,        BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_PREFIX);
-  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OGC_NAMESPACE_URI,           BAD_CAST MS_OWSCOMMON_OGC_NAMESPACE_PREFIX );
-  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI,       BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX);
-  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_URI,     BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_PREFIX);
-  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_WCS_20_NAMESPACE_URI,        BAD_CAST MS_OWSCOMMON_WCS_NAMESPACE_PREFIX);
-  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_GML_32_NAMESPACE_URI,        BAD_CAST MS_OWSCOMMON_GML_NAMESPACE_PREFIX);
-  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_GMLCOV_10_NAMESPACE_URI,     BAD_CAST MS_OWSCOMMON_GMLCOV_NAMESPACE_PREFIX);
-  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_SWE_20_NAMESPACE_URI,        BAD_CAST MS_OWSCOMMON_SWE_NAMESPACE_PREFIX);
+  xmlSetNs(psRootNode,
+           xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_WCS_20_NAMESPACE_URI,
+                    BAD_CAST MS_OWSCOMMON_WCS_NAMESPACE_PREFIX));
+
+  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OWS_20_NAMESPACE_URI,
+           BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_PREFIX);
+  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OGC_NAMESPACE_URI,
+           BAD_CAST MS_OWSCOMMON_OGC_NAMESPACE_PREFIX);
+  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI,
+           BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX);
+  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_URI,
+           BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_PREFIX);
+  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_WCS_20_NAMESPACE_URI,
+           BAD_CAST MS_OWSCOMMON_WCS_NAMESPACE_PREFIX);
+  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_GML_32_NAMESPACE_URI,
+           BAD_CAST MS_OWSCOMMON_GML_NAMESPACE_PREFIX);
+  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_GMLCOV_10_NAMESPACE_URI,
+           BAD_CAST MS_OWSCOMMON_GMLCOV_NAMESPACE_PREFIX);
+  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_SWE_20_NAMESPACE_URI,
+           BAD_CAST MS_OWSCOMMON_SWE_NAMESPACE_PREFIX);
 
   if (addInspire) {
-    xmlNewNs(psRootNode, BAD_CAST MS_INSPIRE_COMMON_NAMESPACE_URI, BAD_CAST MS_INSPIRE_COMMON_NAMESPACE_PREFIX);
-    xmlNewNs(psRootNode, BAD_CAST MS_INSPIRE_DLS_NAMESPACE_URI, BAD_CAST MS_INSPIRE_DLS_NAMESPACE_PREFIX);
+    xmlNewNs(psRootNode, BAD_CAST MS_INSPIRE_COMMON_NAMESPACE_URI,
+             BAD_CAST MS_INSPIRE_COMMON_NAMESPACE_PREFIX);
+    xmlNewNs(psRootNode, BAD_CAST MS_INSPIRE_DLS_NAMESPACE_URI,
+             BAD_CAST MS_INSPIRE_DLS_NAMESPACE_PREFIX);
   }
 
-  psXsiNs = xmlSearchNs(pDoc, psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX);
+  psXsiNs = xmlSearchNs(pDoc, psRootNode,
+                        BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX);
 
-  schemaLocation = msEncodeHTMLEntities( msOWSGetSchemasLocation(map) );
+  schemaLocation = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
   xsi_schemaLocation = msStrdup(MS_OWSCOMMON_WCS_20_NAMESPACE_URI);
   xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
   xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, schemaLocation);
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, MS_OWSCOMMON_WCS_20_SCHEMAS_LOCATION);
+  xsi_schemaLocation = msStringConcatenate(
+      xsi_schemaLocation, MS_OWSCOMMON_WCS_20_SCHEMAS_LOCATION);
   xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
 
   if (addInspire) {
-    xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, MS_INSPIRE_DLS_NAMESPACE_URI " ");
-    xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, msOWSGetInspireSchemasLocation(map));
-    xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, MS_INSPIRE_DLS_SCHEMA_LOCATION);
+    xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation,
+                                             MS_INSPIRE_DLS_NAMESPACE_URI " ");
+    xsi_schemaLocation = msStringConcatenate(
+        xsi_schemaLocation, msOWSGetInspireSchemasLocation(map));
+    xsi_schemaLocation =
+        msStringConcatenate(xsi_schemaLocation, MS_INSPIRE_DLS_SCHEMA_LOCATION);
   }
 
-  xmlNewNsProp(psRootNode, psXsiNs, BAD_CAST "schemaLocation", BAD_CAST xsi_schemaLocation);
+  xmlNewNsProp(psRootNode, psXsiNs, BAD_CAST "schemaLocation",
+               BAD_CAST xsi_schemaLocation);
 
   msFree(schemaLocation);
   msFree(xsi_schemaLocation);
@@ -1887,19 +1930,18 @@ static void msWCSPrepareNamespaces20(xml
 /*      Copied from mapwcs.c.                                           */
 /************************************************************************/
 
-static char *msWCSGetFormatsList20( mapObj *map, layerObj *layer )
-{
+static char *msWCSGetFormatsList20(mapObj *map, layerObj *layer) {
   char *format_list = msStrdup("");
   char **tokens = NULL, **formats = NULL;
-  int  i, numtokens = 0, numformats;
+  int i, numtokens = 0, numformats;
   char *value;
 
   /* -------------------------------------------------------------------- */
   /*      Parse from layer metadata.                                      */
   /* -------------------------------------------------------------------- */
-  if( layer != NULL
-      && (value = msOWSGetEncodeMetadata( &(layer->metadata),"CO","formats",
-                                          NULL )) != NULL ) {
+  if (layer != NULL &&
+      (value = msOWSGetEncodeMetadata(&(layer->metadata), "CO", "formats",
+                                      NULL)) != NULL) {
     tokens = msStringSplit(value, ' ', &numtokens);
     msFree(value);
   }
@@ -1907,8 +1949,8 @@ static char *msWCSGetFormatsList20( mapO
   /* -------------------------------------------------------------------- */
   /*      Parse from map.web metadata.                                    */
   /* -------------------------------------------------------------------- */
-  else if((value = msOWSGetEncodeMetadata( &(map->web.metadata), "CO", "formats",
-                                           NULL)) != NULL ) {
+  else if ((value = msOWSGetEncodeMetadata(&(map->web.metadata), "CO",
+                                           "formats", NULL)) != NULL) {
     tokens = msStringSplit(value, ' ', &numtokens);
     msFree(value);
   }
@@ -1918,17 +1960,17 @@ static char *msWCSGetFormatsList20( mapO
   /*      look plausible.                                                 */
   /* -------------------------------------------------------------------- */
   else {
-    tokens = (char **) msSmallCalloc(map->numoutputformats,sizeof(char*));
-    for( i = 0; i < map->numoutputformats; i++ ) {
-      switch( map->outputformatlist[i]->renderer ) {
-          /* seemingly normal raster format */
-        case MS_RENDER_WITH_AGG:
-        case MS_RENDER_WITH_RAWDATA:
-          tokens[numtokens++] = msStrdup(map->outputformatlist[i]->name);
-          break;
-          /* rest of formats aren't really WCS compatible */
-        default:
-          break;
+    tokens = (char **)msSmallCalloc(map->numoutputformats, sizeof(char *));
+    for (i = 0; i < map->numoutputformats; i++) {
+      switch (map->outputformatlist[i]->renderer) {
+        /* seemingly normal raster format */
+      case MS_RENDER_WITH_AGG:
+      case MS_RENDER_WITH_RAWDATA:
+        tokens[numtokens++] = msStrdup(map->outputformatlist[i]->name);
+        break;
+        /* rest of formats aren't really WCS compatible */
+      default:
+        break;
       }
     }
   }
@@ -1938,57 +1980,57 @@ static char *msWCSGetFormatsList20( mapO
   /*      duplicates.                                                     */
   /* -------------------------------------------------------------------- */
   numformats = 0;
-  formats = (char **) msSmallCalloc(sizeof(char*),numtokens);
+  formats = (char **)msSmallCalloc(sizeof(char *), numtokens);
 
-  for( i = 0; i < numtokens; i++ ) {
+  for (i = 0; i < numtokens; i++) {
     int format_i, j;
     const char *mimetype;
 
-    for( format_i = 0; format_i < map->numoutputformats; format_i++ ) {
-      if( EQUAL(map->outputformatlist[format_i]->name, tokens[i]) )
+    for (format_i = 0; format_i < map->numoutputformats; format_i++) {
+      if (EQUAL(map->outputformatlist[format_i]->name, tokens[i]))
         break;
     }
 
-    if( format_i == map->numoutputformats ) {
+    if (format_i == map->numoutputformats) {
       msDebug("Failed to find outputformat info on format '%s', ignore.\n",
-              tokens[i] );
+              tokens[i]);
       continue;
     }
 
     mimetype = map->outputformatlist[format_i]->mimetype;
-    if( mimetype == NULL || strlen(mimetype) == 0 ) {
-      msDebug("No mimetime for format '%s', ignoring.\n",
-              tokens[i] );
+    if (mimetype == NULL || strlen(mimetype) == 0) {
+      msDebug("No mimetime for format '%s', ignoring.\n", tokens[i]);
       continue;
     }
 
-    for( j = 0; j < numformats; j++ ) {
-      if( EQUAL(mimetype,formats[j]) )
+    for (j = 0; j < numformats; j++) {
+      if (EQUAL(mimetype, formats[j]))
         break;
     }
 
-    if( j < numformats ) {
-      msDebug( "Format '%s' ignored since mimetype '%s' duplicates another outputFormatObj.\n",
-               tokens[i], mimetype );
+    if (j < numformats) {
+      msDebug("Format '%s' ignored since mimetype '%s' duplicates another "
+              "outputFormatObj.\n",
+              tokens[i], mimetype);
       continue;
     }
 
     formats[numformats++] = msStrdup(mimetype);
   }
 
-  msFreeCharArray(tokens,numtokens);
+  msFreeCharArray(tokens, numtokens);
 
   /* -------------------------------------------------------------------- */
   /*      Turn mimetype list into comma delimited form for easy use       */
   /*      with xml functions.                                             */
   /* -------------------------------------------------------------------- */
-  for(i = 0; i < numformats; i++) {
-    if(i > 0) {
-      format_list = msStringConcatenate(format_list, (char *) ",");
+  for (i = 0; i < numformats; i++) {
+    if (i > 0) {
+      format_list = msStringConcatenate(format_list, (char *)",");
     }
     format_list = msStringConcatenate(format_list, formats[i]);
   }
-  msFreeCharArray(formats,numformats);
+  msFreeCharArray(formats, numformats);
 
   return format_list;
 }
@@ -1999,15 +2041,15 @@ static char *msWCSGetFormatsList20( mapO
 /*      Helper function to determine if a SRS mandates swapped axes.    */
 /************************************************************************/
 
-static int msWCSSwapAxes20(char *srs_uri)
-{
+static int msWCSSwapAxes20(char *srs_uri) {
   int srid = 0;
 
   /* get SRID from the srs uri */
-  if(srs_uri != NULL && strlen(srs_uri) > 0) {
-    if(sscanf(srs_uri, "http://www.opengis.net/def/crs/EPSG/0/%d", &srid) != EOF)
+  if (srs_uri != NULL && strlen(srs_uri) > 0) {
+    if (sscanf(srs_uri, "http://www.opengis.net/def/crs/EPSG/0/%d", &srid) !=
+        EOF)
       ;
-    else if(sscanf(srs_uri, "http://www.opengis.net/def/crs/%d", &srid) != EOF)
+    else if (sscanf(srs_uri, "http://www.opengis.net/def/crs/%d", &srid) != EOF)
       ;
     else
       srid = 0;
@@ -2025,18 +2067,19 @@ static int msWCSSwapAxes20(char *srs_uri
 /************************************************************************/
 
 static void msWCSCommon20_CreateBoundedBy(wcs20coverageMetadataObjPtr cm,
-    xmlNsPtr psGmlNs, xmlNodePtr psRoot, projectionObj *projection, int swapAxes)
-{
+                                          xmlNsPtr psGmlNs, xmlNodePtr psRoot,
+                                          projectionObj *projection,
+                                          int swapAxes) {
   xmlNodePtr psBoundedBy, psEnvelope;
   char lowerCorner[100], upperCorner[100], axisLabels[100], uomLabels[100];
 
-  psBoundedBy = xmlNewChild( psRoot, psGmlNs, BAD_CAST "boundedBy", NULL);
+  psBoundedBy = xmlNewChild(psRoot, psGmlNs, BAD_CAST "boundedBy", NULL);
   {
     psEnvelope = xmlNewChild(psBoundedBy, psGmlNs, BAD_CAST "Envelope", NULL);
     {
       xmlNewProp(psEnvelope, BAD_CAST "srsName", BAD_CAST cm->srs_uri);
 
-      if(projection->proj != NULL && msProjIsGeographicCRS(projection)) {
+      if (projection->proj != NULL && msProjIsGeographicCRS(projection)) {
         if (swapAxes == MS_FALSE) {
           strlcpy(axisLabels, "long lat", sizeof(axisLabels));
         } else {
@@ -2056,15 +2099,21 @@ static void msWCSCommon20_CreateBoundedB
       xmlNewProp(psEnvelope, BAD_CAST "srsDimension", BAD_CAST "2");
 
       if (swapAxes == MS_FALSE) {
-        snprintf(lowerCorner, sizeof(lowerCorner), "%.15g %.15g", cm->extent.minx, cm->extent.miny);
-        snprintf(upperCorner, sizeof(upperCorner), "%.15g %.15g", cm->extent.maxx, cm->extent.maxy);
+        snprintf(lowerCorner, sizeof(lowerCorner), "%.15g %.15g",
+                 cm->extent.minx, cm->extent.miny);
+        snprintf(upperCorner, sizeof(upperCorner), "%.15g %.15g",
+                 cm->extent.maxx, cm->extent.maxy);
       } else {
-        snprintf(lowerCorner, sizeof(lowerCorner), "%.15g %.15g", cm->extent.miny, cm->extent.minx);
-        snprintf(upperCorner, sizeof(upperCorner), "%.15g %.15g", cm->extent.maxy, cm->extent.maxx);
+        snprintf(lowerCorner, sizeof(lowerCorner), "%.15g %.15g",
+                 cm->extent.miny, cm->extent.minx);
+        snprintf(upperCorner, sizeof(upperCorner), "%.15g %.15g",
+                 cm->extent.maxy, cm->extent.maxx);
       }
 
-      xmlNewChild(psEnvelope, psGmlNs, BAD_CAST "lowerCorner", BAD_CAST lowerCorner);
-      xmlNewChild(psEnvelope, psGmlNs, BAD_CAST "upperCorner", BAD_CAST upperCorner);
+      xmlNewChild(psEnvelope, psGmlNs, BAD_CAST "lowerCorner",
+                  BAD_CAST lowerCorner);
+      xmlNewChild(psEnvelope, psGmlNs, BAD_CAST "upperCorner",
+                  BAD_CAST upperCorner);
     }
   }
 }
@@ -2075,20 +2124,24 @@ static void msWCSCommon20_CreateBoundedB
 /*      Inserts the DomainSet section into an existing DOM structure.   */
 /************************************************************************/
 
-static void msWCSCommon20_CreateDomainSet(layerObj* layer, wcs20coverageMetadataObjPtr cm,
-    xmlNsPtr psGmlNs, xmlNodePtr psRoot, projectionObj *projection, int swapAxes)
-{
-  xmlNodePtr psDomainSet, psGrid, psLimits, psGridEnvelope, psOrigin,
-             psOffsetX, psOffsetY;
+static void msWCSCommon20_CreateDomainSet(layerObj *layer,
+                                          wcs20coverageMetadataObjPtr cm,
+                                          xmlNsPtr psGmlNs, xmlNodePtr psRoot,
+                                          projectionObj *projection,
+                                          int swapAxes) {
+  xmlNodePtr psDomainSet, psGrid, psLimits, psGridEnvelope, psOrigin, psOffsetX,
+      psOffsetY;
   char low[100], high[100], id[100], point[100];
   char offsetVector1[100], offsetVector2[100], axisLabels[100];
 
-  psDomainSet = xmlNewChild( psRoot, psGmlNs, BAD_CAST "domainSet", NULL);
+  psDomainSet = xmlNewChild(psRoot, psGmlNs, BAD_CAST "domainSet", NULL);
   {
     psGrid = xmlNewChild(psDomainSet, psGmlNs, BAD_CAST "RectifiedGrid", NULL);
     {
-      double x0 = cm->geotransform[0]+cm->geotransform[1]/2+cm->geotransform[2]/2;
-      double y0 = cm->geotransform[3]+cm->geotransform[4]/2+cm->geotransform[5]/2;
+      double x0 = cm->geotransform[0] + cm->geotransform[1] / 2 +
+                  cm->geotransform[2] / 2;
+      double y0 = cm->geotransform[3] + cm->geotransform[4] / 2 +
+                  cm->geotransform[5] / 2;
       double resx = cm->geotransform[1];
       double resy = cm->geotransform[5];
 
@@ -2098,7 +2151,8 @@ static void msWCSCommon20_CreateDomainSe
 
       psLimits = xmlNewChild(psGrid, psGmlNs, BAD_CAST "limits", NULL);
       {
-        psGridEnvelope = xmlNewChild(psLimits, psGmlNs, BAD_CAST "GridEnvelope", NULL);
+        psGridEnvelope =
+            xmlNewChild(psLimits, psGmlNs, BAD_CAST "GridEnvelope", NULL);
         {
           strlcpy(low, "0 0", sizeof(low));
           snprintf(high, sizeof(high), "%d %d", cm->xsize - 1, cm->ysize - 1);
@@ -2108,7 +2162,7 @@ static void msWCSCommon20_CreateDomainSe
         }
       }
 
-      if(projection->proj != NULL && msProjIsGeographicCRS(projection)) {
+      if (projection->proj != NULL && msProjIsGeographicCRS(projection)) {
         strlcpy(axisLabels, "long lat", sizeof(axisLabels));
       } else {
         strlcpy(axisLabels, "x y", sizeof(axisLabels));
@@ -2138,8 +2192,10 @@ static void msWCSCommon20_CreateDomainSe
         snprintf(offsetVector1, sizeof(offsetVector1), "0 %f", resx);
         snprintf(offsetVector2, sizeof(offsetVector2), "%f 0", resy);
       }
-      psOffsetX = xmlNewChild(psGrid, psGmlNs, BAD_CAST "offsetVector", BAD_CAST offsetVector1);
-      psOffsetY = xmlNewChild(psGrid, psGmlNs, BAD_CAST "offsetVector", BAD_CAST offsetVector2);
+      psOffsetX = xmlNewChild(psGrid, psGmlNs, BAD_CAST "offsetVector",
+                              BAD_CAST offsetVector1);
+      psOffsetY = xmlNewChild(psGrid, psGmlNs, BAD_CAST "offsetVector",
+                              BAD_CAST offsetVector2);
 
       xmlNewProp(psOffsetX, BAD_CAST "srsName", BAD_CAST cm->srs_uri);
       xmlNewProp(psOffsetY, BAD_CAST "srsName", BAD_CAST cm->srs_uri);
@@ -2153,35 +2209,35 @@ static void msWCSCommon20_CreateDomainSe
 /*      Inserts the RangeType section into an existing DOM structure.   */
 /************************************************************************/
 
-static void msWCSCommon20_CreateRangeType(wcs20coverageMetadataObjPtr cm, char *bands,
-    xmlNsPtr psGmlcovNs, xmlNsPtr psSweNs, xmlNodePtr psRoot)
-{
-  xmlNodePtr psRangeType, psDataRecord, psField, psQuantity,
-             psUom, psConstraint, psAllowedValues = NULL, psNilValues = NULL;
+static void msWCSCommon20_CreateRangeType(wcs20coverageMetadataObjPtr cm,
+                                          char *bands, xmlNsPtr psGmlcovNs,
+                                          xmlNsPtr psSweNs, xmlNodePtr psRoot) {
+  xmlNodePtr psRangeType, psDataRecord, psField, psQuantity, psUom,
+      psConstraint, psAllowedValues = NULL, psNilValues = NULL;
   char **arr = NULL;
   int num = 0;
 
-  if(NULL != bands) {
+  if (NULL != bands) {
     arr = msStringSplit(bands, ',', &num);
   }
 
-  psRangeType = xmlNewChild( psRoot, psGmlcovNs, BAD_CAST "rangeType", NULL);
-  psDataRecord  = xmlNewChild(psRangeType, psSweNs, BAD_CAST "DataRecord", NULL);
+  psRangeType = xmlNewChild(psRoot, psGmlcovNs, BAD_CAST "rangeType", NULL);
+  psDataRecord = xmlNewChild(psRangeType, psSweNs, BAD_CAST "DataRecord", NULL);
 
   /* iterate over every band */
-  for(unsigned i = 0; i < cm->numbands; ++i) {
+  for (unsigned i = 0; i < cm->numbands; ++i) {
     /* only add bands that are in the range subset */
     if (NULL != arr && num > 0) {
       int found = MS_FALSE, j;
-      for(j = 0; j < num; ++j) {
+      for (j = 0; j < num; ++j) {
         int repr = 0;
-        if(msStringParseInteger(arr[j], &repr) == MS_SUCCESS &&
-           static_cast<unsigned>(repr) == i + 1) {
+        if (msStringParseInteger(arr[j], &repr) == MS_SUCCESS &&
+            static_cast<unsigned>(repr) == i + 1) {
           found = MS_TRUE;
           break;
         }
       }
-      if(found == MS_FALSE) {
+      if (found == MS_FALSE) {
         /* ignore this band since it is not in the range subset */
         continue;
       }
@@ -2190,60 +2246,70 @@ static void msWCSCommon20_CreateRangeTyp
     /* add field tag */
     psField = xmlNewChild(psDataRecord, psSweNs, BAD_CAST "field", NULL);
 
-    if(cm->bands[i].name != NULL) {
+    if (cm->bands[i].name != NULL) {
       xmlNewProp(psField, BAD_CAST "name", BAD_CAST cm->bands[i].name);
     } else {
       xmlNewProp(psField, BAD_CAST "name", BAD_CAST "band");
     }
     /* add Quantity tag */
     psQuantity = xmlNewChild(psField, psSweNs, BAD_CAST "Quantity", NULL);
-    if(cm->bands[i].definition != NULL) {
-      xmlNewProp(psQuantity, BAD_CAST "definition", BAD_CAST cm->bands[i].definition);
-    }
-    if(cm->bands[i].description != NULL) {
-      xmlNewChild(psQuantity, psSweNs, BAD_CAST "description", BAD_CAST cm->bands[i].description);
+    if (cm->bands[i].definition != NULL) {
+      xmlNewProp(psQuantity, BAD_CAST "definition",
+                 BAD_CAST cm->bands[i].definition);
+    }
+    if (cm->bands[i].description != NULL) {
+      xmlNewChild(psQuantity, psSweNs, BAD_CAST "description",
+                  BAD_CAST cm->bands[i].description);
     }
 
     /* if there are given nilvalues -> add them to the first field */
     /* all other fields get a reference to these */
-    if(cm->numnilvalues > 0) {
+    if (cm->numnilvalues > 0) {
       psNilValues = xmlNewChild(
-                      xmlNewChild(psQuantity, psSweNs, BAD_CAST "nilValues", NULL),
-                      psSweNs, BAD_CAST "NilValues", NULL);
-      for(unsigned j = 0; j < cm->numnilvalues; ++j) {
+          xmlNewChild(psQuantity, psSweNs, BAD_CAST "nilValues", NULL), psSweNs,
+          BAD_CAST "NilValues", NULL);
+      for (unsigned j = 0; j < cm->numnilvalues; ++j) {
         xmlNodePtr psTemp =
-          xmlNewChild(psNilValues, psSweNs, BAD_CAST "nilValue", BAD_CAST cm->nilvalues[j]);
-        if(j < cm->numnilvalues)
-          xmlNewProp(psTemp, BAD_CAST "reason", BAD_CAST cm->nilvalues_reasons[j]);
+            xmlNewChild(psNilValues, psSweNs, BAD_CAST "nilValue",
+                        BAD_CAST cm->nilvalues[j]);
+        if (j < cm->numnilvalues)
+          xmlNewProp(psTemp, BAD_CAST "reason",
+                     BAD_CAST cm->nilvalues_reasons[j]);
       }
     } else { /* create an empty nilValues tag */
       xmlNewChild(psQuantity, psSweNs, BAD_CAST "nilValues", NULL);
     }
 
     psUom = xmlNewChild(psQuantity, psSweNs, BAD_CAST "uom", NULL);
-    if(cm->bands[i].uom != NULL) {
+    if (cm->bands[i].uom != NULL) {
       xmlNewProp(psUom, BAD_CAST "code", BAD_CAST cm->bands[i].uom);
     } else {
       xmlNewProp(psUom, BAD_CAST "code", BAD_CAST "W.m-2.Sr-1");
     }
 
     /* add constraint */
-    psConstraint = xmlNewChild(psQuantity, psSweNs, BAD_CAST "constraint", NULL);
+    psConstraint =
+        xmlNewChild(psQuantity, psSweNs, BAD_CAST "constraint", NULL);
 
     {
       char interval[100], significant_figures[100];
-      psAllowedValues = xmlNewChild(psConstraint, psSweNs, BAD_CAST "AllowedValues", NULL);
+      psAllowedValues =
+          xmlNewChild(psConstraint, psSweNs, BAD_CAST "AllowedValues", NULL);
 
       /* Interval */
-      snprintf(interval, sizeof(interval), "%.5g %.5g", cm->bands[i].interval_min, cm->bands[i].interval_max);
-      xmlNewChild(psAllowedValues, psSweNs, BAD_CAST "interval", BAD_CAST interval);
+      snprintf(interval, sizeof(interval), "%.5g %.5g",
+               cm->bands[i].interval_min, cm->bands[i].interval_max);
+      xmlNewChild(psAllowedValues, psSweNs, BAD_CAST "interval",
+                  BAD_CAST interval);
 
       /* Significant figures */
-      snprintf(significant_figures, sizeof(significant_figures), "%d", cm->bands[i].significant_figures);
-      xmlNewChild(psAllowedValues, psSweNs, BAD_CAST "significantFigures", BAD_CAST significant_figures);
+      snprintf(significant_figures, sizeof(significant_figures), "%d",
+               cm->bands[i].significant_figures);
+      xmlNewChild(psAllowedValues, psSweNs, BAD_CAST "significantFigures",
+                  BAD_CAST significant_figures);
     }
   }
-  msFreeCharArray(arr,num);
+  msFreeCharArray(arr, num);
 }
 
 /************************************************************************/
@@ -2252,23 +2318,22 @@ static void msWCSCommon20_CreateRangeTyp
 /*      Writes out an xml structure to the stream.                      */
 /************************************************************************/
 
-static int msWCSWriteDocument20(xmlDocPtr psDoc)
-{
+static int msWCSWriteDocument20(xmlDocPtr psDoc) {
   xmlChar *buffer = NULL;
   int size = 0;
   msIOContext *context = NULL;
   char *contenttype = NULL;
 
-  if( msIO_needBinaryStdout() == MS_FAILURE ) {
+  if (msIO_needBinaryStdout() == MS_FAILURE) {
     return MS_FAILURE;
   }
 
-  if( EQUAL((char *)xmlDocGetRootElement(psDoc)->name, "RectifiedGridCoverage") )
+  if (EQUAL((char *)xmlDocGetRootElement(psDoc)->name, "RectifiedGridCoverage"))
     contenttype = msStrdup("application/gml+xml");
   else
     contenttype = msStrdup("text/xml");
 
-  msIO_setHeader("Content-Type","%s; charset=UTF-8", contenttype);
+  msIO_setHeader("Content-Type", "%s; charset=UTF-8", contenttype);
   msIO_sendHeaders();
   msFree(contenttype);
 
@@ -2288,110 +2353,107 @@ static int msWCSWriteDocument20(xmlDocPt
 /*      then content sections are inserted.                             */
 /************************************************************************/
 
-static int msWCSWriteFile20(mapObj* map, imageObj* image, wcs20ParamsObjPtr params, int multipart)
-{
+static int msWCSWriteFile20(mapObj *map, imageObj *image,
+                            wcs20ParamsObjPtr params, int multipart) {
   int status;
-  char* filename = NULL;
+  char *filename = NULL;
   char *base_dir = NULL;
   const char *fo_filename;
   int i;
 
-  fo_filename = msGetOutputFormatOption( image->format, "FILENAME", NULL );
+  fo_filename = msGetOutputFormatOption(image->format, "FILENAME", NULL);
 
   /* -------------------------------------------------------------------- */
   /*      Fetch the driver we will be using and check if it supports      */
   /*      VSIL IO.                                                        */
   /* -------------------------------------------------------------------- */
-  if( EQUALN(image->format->driver,"GDAL/",5) ) {
+  if (EQUALN(image->format->driver, "GDAL/", 5)) {
     GDALDriverH hDriver;
     const char *pszExtension = image->format->extension;
 
-    msAcquireLock( TLOCK_GDAL );
-    hDriver = GDALGetDriverByName( image->format->driver+5 );
-    if( hDriver == NULL ) {
-      msReleaseLock( TLOCK_GDAL );
-      msSetError( MS_MISCERR,
-                  "Failed to find %s driver.",
-                  "msWCSWriteFile20()",
-                  image->format->driver+5 );
+    msAcquireLock(TLOCK_GDAL);
+    hDriver = GDALGetDriverByName(image->format->driver + 5);
+    if (hDriver == NULL) {
+      msReleaseLock(TLOCK_GDAL);
+      msSetError(MS_MISCERR, "Failed to find %s driver.", "msWCSWriteFile20()",
+                 image->format->driver + 5);
       return msWCSException(map, "NoApplicableCode", "mapserv",
                             params->version);
     }
 
-    if( pszExtension == NULL )
+    if (pszExtension == NULL)
       pszExtension = "img.tmp";
 
-    if( msGDALDriverSupportsVirtualIOOutput(hDriver) ) {
+    if (msGDALDriverSupportsVirtualIOOutput(hDriver)) {
       base_dir = msTmpFile(map, map->mappath, "/vsimem/wcsout", NULL);
-      if( fo_filename )
-        filename = msStrdup(CPLFormFilename(base_dir,
-                                            fo_filename,NULL));
+      if (fo_filename)
+        filename = msStrdup(CPLFormFilename(base_dir, fo_filename, NULL));
       else
-        filename = msStrdup(CPLFormFilename(base_dir,
-                                            "out", pszExtension ));
+        filename = msStrdup(CPLFormFilename(base_dir, "out", pszExtension));
 
       /*            CleanVSIDir( "/vsimem/wcsout" ); */
 
-      msReleaseLock( TLOCK_GDAL );
+      msReleaseLock(TLOCK_GDAL);
       status = msSaveImage(map, image, filename);
-      if( status != MS_SUCCESS ) {
-        msSetError(MS_MISCERR, "msSaveImage() failed",
-                   "msWCSWriteFile20()");
+      if (status != MS_SUCCESS) {
+        msSetError(MS_MISCERR, "msSaveImage() failed", "msWCSWriteFile20()");
         return msWCSException20(map, "NoApplicableCode", "mapserv",
                                 params->version);
       }
     }
-    msReleaseLock( TLOCK_GDAL );
+    msReleaseLock(TLOCK_GDAL);
   }
 
   /* -------------------------------------------------------------------- */
   /*      If we weren't able to write data under /vsimem, then we just    */
   /*      output a single "stock" filename.                               */
   /* -------------------------------------------------------------------- */
-  if( filename == NULL ) {
-    msOutputFormatResolveFromImage( map, image );
-    if(multipart) {
-      msIO_fprintf( stdout, "\r\n--wcs\r\n" );
-      msIO_fprintf(
-        stdout,
-        "Content-Type: %s\r\n"
-        "Content-Description: coverage data\r\n"
-        "Content-Transfer-Encoding: binary\r\n",
-        MS_IMAGE_MIME_TYPE(map->outputformat));
-
-      if( fo_filename != NULL )
-        msIO_fprintf( stdout,
-                      "Content-ID: coverage/%s\r\n"
-                      "Content-Disposition: INLINE; filename=%s\r\n\r\n",
-                      fo_filename,
-                      fo_filename);
+  if (filename == NULL) {
+    msOutputFormatResolveFromImage(map, image);
+    if (multipart) {
+      msIO_fprintf(stdout, "\r\n--wcs\r\n");
+      msIO_fprintf(stdout,
+                   "Content-Type: %s\r\n"
+                   "Content-Description: coverage data\r\n"
+                   "Content-Transfer-Encoding: binary\r\n",
+                   MS_IMAGE_MIME_TYPE(map->outputformat));
+
+      if (fo_filename != NULL)
+        msIO_fprintf(stdout,
+                     "Content-ID: coverage/%s\r\n"
+                     "Content-Disposition: INLINE; filename=%s\r\n\r\n",
+                     fo_filename, fo_filename);
       else
-        msIO_fprintf( stdout,
-                      "Content-ID: coverage/wcs.%s\r\n"
-                      "Content-Disposition: INLINE\r\n\r\n",
-                      MS_IMAGE_EXTENSION(map->outputformat));
+        msIO_fprintf(stdout,
+                     "Content-ID: coverage/wcs.%s\r\n"
+                     "Content-Disposition: INLINE\r\n\r\n",
+                     MS_IMAGE_EXTENSION(map->outputformat));
     } else {
-      msIO_setHeader("Content-Type","%s",MS_IMAGE_MIME_TYPE(map->outputformat));
-      msIO_setHeader("Content-Description","coverage data");
-      msIO_setHeader("Content-Transfer-Encoding","binary");
-
-      if( fo_filename != NULL ) {
-        msIO_setHeader("Content-ID","coverage/%s",fo_filename);
-        msIO_setHeader("Content-Disposition","INLINE; filename=%s",fo_filename);
+      msIO_setHeader("Content-Type", "%s",
+                     MS_IMAGE_MIME_TYPE(map->outputformat));
+      msIO_setHeader("Content-Description", "coverage data");
+      msIO_setHeader("Content-Transfer-Encoding", "binary");
+
+      if (fo_filename != NULL) {
+        msIO_setHeader("Content-ID", "coverage/%s", fo_filename);
+        msIO_setHeader("Content-Disposition", "INLINE; filename=%s",
+                       fo_filename);
       } else {
-        msIO_setHeader("Content-ID","coverage/wcs.%s",MS_IMAGE_EXTENSION(map->outputformat));
-        msIO_setHeader("Content-Disposition","INLINE");
+        msIO_setHeader("Content-ID", "coverage/wcs.%s",
+                       MS_IMAGE_EXTENSION(map->outputformat));
+        msIO_setHeader("Content-Disposition", "INLINE");
       }
       msIO_sendHeaders();
     }
 
     status = msSaveImage(map, image, NULL);
-    if( status != MS_SUCCESS ) {
-      msSetError( MS_MISCERR, "msSaveImage() failed", "msWCSWriteFile20()");
-      return msWCSException(map, "NoApplicableCode", "mapserv", params->version);
+    if (status != MS_SUCCESS) {
+      msSetError(MS_MISCERR, "msSaveImage() failed", "msWCSWriteFile20()");
+      return msWCSException(map, "NoApplicableCode", "mapserv",
+                            params->version);
     }
-    if(multipart)
-      msIO_fprintf( stdout, "\r\n--wcs--\r\n" );
+    if (multipart)
+      msIO_fprintf(stdout, "\r\n--wcs--\r\n");
     return MS_SUCCESS;
   }
 
@@ -2401,24 +2463,24 @@ static int msWCSWriteFile20(mapObj* map,
   /*      it is the only file listed in the coverages document.           */
   /* -------------------------------------------------------------------- */
   {
-    char **all_files = CPLReadDir( base_dir );
+    char **all_files = CPLReadDir(base_dir);
     int count = CSLCount(all_files);
 
-    if( msIO_needBinaryStdout() == MS_FAILURE )
+    if (msIO_needBinaryStdout() == MS_FAILURE)
       return MS_FAILURE;
 
-    msAcquireLock( TLOCK_GDAL );
-    for( i = count-1; i >= 0; i-- ) {
+    msAcquireLock(TLOCK_GDAL);
+    for (i = count - 1; i >= 0; i--) {
       const char *this_file = all_files[i];
 
-      if( EQUAL(this_file,".") || EQUAL(this_file,"..") ) {
-        all_files = CSLRemoveStrings( all_files, i, 1, NULL );
+      if (EQUAL(this_file, ".") || EQUAL(this_file, "..")) {
+        all_files = CSLRemoveStrings(all_files, i, 1, NULL);
         continue;
       }
 
-      if( i > 0 && EQUAL(this_file,CPLGetFilename(filename)) ) {
-        all_files = CSLRemoveStrings( all_files, i, 1, NULL );
-        all_files = CSLInsertString(all_files,0,CPLGetFilename(filename));
+      if (i > 0 && EQUAL(this_file, CPLGetFilename(filename))) {
+        all_files = CSLRemoveStrings(all_files, i, 1, NULL);
+        all_files = CSLInsertString(all_files, 0, CPLGetFilename(filename));
         i++;
       }
     }
@@ -2428,73 +2490,67 @@ static int msWCSWriteFile20(mapObj* map,
     /* -------------------------------------------------------------------- */
     count = CSLCount(all_files);
 
-    if(count > 1 && multipart == MS_FALSE) {
-      msDebug( "msWCSWriteFile20(): force multipart output without gml summary because we have multiple files in the result.\n" );
+    if (count > 1 && multipart == MS_FALSE) {
+      msDebug("msWCSWriteFile20(): force multipart output without gml summary "
+              "because we have multiple files in the result.\n");
 
       multipart = MS_TRUE;
-      msIO_setHeader("Content-Type","multipart/related; boundary=wcs");
+      msIO_setHeader("Content-Type", "multipart/related; boundary=wcs");
       msIO_sendHeaders();
     }
 
-    for( i = 0; i < count; i++ ) {
+    for (i = 0; i < count; i++) {
       const char *mimetype = NULL;
       VSILFILE *fp;
       unsigned char block[4000];
       int bytes_read;
 
-      if( i == 0
-          && !EQUAL(MS_IMAGE_MIME_TYPE(map->outputformat), "unknown") )
+      if (i == 0 && !EQUAL(MS_IMAGE_MIME_TYPE(map->outputformat), "unknown"))
         mimetype = MS_IMAGE_MIME_TYPE(map->outputformat);
 
-      if( mimetype == NULL )
+      if (mimetype == NULL)
         mimetype = "application/octet-stream";
-      if(multipart) {
-        msIO_fprintf( stdout, "\r\n--wcs\r\n" );
-        msIO_fprintf(
-          stdout,
-          "Content-Type: %s\r\n"
-          "Content-Description: coverage data\r\n"
-          "Content-Transfer-Encoding: binary\r\n"
-          "Content-ID: coverage/%s\r\n"
-          "Content-Disposition: INLINE; filename=%s\r\n\r\n",
-          mimetype,
-          all_files[i],
-          all_files[i]);
+      if (multipart) {
+        msIO_fprintf(stdout, "\r\n--wcs\r\n");
+        msIO_fprintf(stdout,
+                     "Content-Type: %s\r\n"
+                     "Content-Description: coverage data\r\n"
+                     "Content-Transfer-Encoding: binary\r\n"
+                     "Content-ID: coverage/%s\r\n"
+                     "Content-Disposition: INLINE; filename=%s\r\n\r\n",
+                     mimetype, all_files[i], all_files[i]);
       } else {
-        msIO_setHeader("Content-Type","%s",mimetype);
-        msIO_setHeader("Content-Description","coverage data");
-        msIO_setHeader("Content-Transfer-Encoding","binary");
-        msIO_setHeader("Content-ID","coverage/%s",all_files[i]);
-        msIO_setHeader("Content-Disposition","INLINE; filename=%s",all_files[i]);
+        msIO_setHeader("Content-Type", "%s", mimetype);
+        msIO_setHeader("Content-Description", "coverage data");
+        msIO_setHeader("Content-Transfer-Encoding", "binary");
+        msIO_setHeader("Content-ID", "coverage/%s", all_files[i]);
+        msIO_setHeader("Content-Disposition", "INLINE; filename=%s",
+                       all_files[i]);
         msIO_sendHeaders();
       }
 
-
-      fp = VSIFOpenL(
-             CPLFormFilename(base_dir, all_files[i], NULL),
-             "rb" );
-      if( fp == NULL ) {
-        msReleaseLock( TLOCK_GDAL );
-        msSetError( MS_MISCERR,
-                    "Failed to open %s for streaming to stdout.",
-                    "msWCSWriteFile20()", all_files[i] );
+      fp = VSIFOpenL(CPLFormFilename(base_dir, all_files[i], NULL), "rb");
+      if (fp == NULL) {
+        msReleaseLock(TLOCK_GDAL);
+        msSetError(MS_MISCERR, "Failed to open %s for streaming to stdout.",
+                   "msWCSWriteFile20()", all_files[i]);
         return MS_FAILURE;
       }
 
-      while( (bytes_read = VSIFReadL(block, 1, sizeof(block), fp)) > 0 )
-        msIO_fwrite( block, 1, bytes_read, stdout );
+      while ((bytes_read = VSIFReadL(block, 1, sizeof(block), fp)) > 0)
+        msIO_fwrite(block, 1, bytes_read, stdout);
 
-      VSIFCloseL( fp );
+      VSIFCloseL(fp);
 
-      VSIUnlink( CPLFormFilename(base_dir, all_files[i], NULL) );
+      VSIUnlink(CPLFormFilename(base_dir, all_files[i], NULL));
     }
 
     msFree(base_dir);
     msFree(filename);
-    CSLDestroy( all_files );
-    msReleaseLock( TLOCK_GDAL );
-    if(multipart)
-      msIO_fprintf( stdout, "\r\n--wcs--\r\n" );
+    CSLDestroy(all_files);
+    msReleaseLock(TLOCK_GDAL);
+    if (multipart)
+      msIO_fprintf(stdout, "\r\n--wcs--\r\n");
     return MS_SUCCESS;
   }
 
@@ -2508,19 +2564,19 @@ static int msWCSWriteFile20(mapObj* map,
 /************************************************************************/
 
 static const char *msWCSLookupRangesetAxisMetadata20(hashTableObj *table,
-    const char *axis, const char *item)
-{
+                                                     const char *axis,
+                                                     const char *item) {
   char buf[500];
-  const char* value;
+  const char *value;
 
-  if(table == NULL || axis == NULL || item == NULL) {
+  if (table == NULL || axis == NULL || item == NULL) {
     return NULL;
   }
 
   strlcpy(buf, axis, sizeof(buf));
   strlcat(buf, "_", sizeof(buf));
   strlcat(buf, item, sizeof(buf));
-  if((value = msLookupHashTable(table, buf)) != NULL) {
+  if ((value = msLookupHashTable(table, buf)) != NULL) {
     return value;
   }
   return msOWSLookupMetadata(table, "CO", buf);
@@ -2533,19 +2589,21 @@ static const char *msWCSLookupRangesetAx
 /*      but exchanges the SRS URN by an URI for compliancy with 2.0.    */
 /************************************************************************/
 
-static int msWCSGetCoverageMetadata20(layerObj *layer, wcs20coverageMetadataObj *cm)
-{
-  char  *srs_uri = NULL;
-  memset(cm,0,sizeof(wcs20coverageMetadataObj));
-  if ( msCheckParentPointer(layer->map,"map") == MS_FAILURE )
+static int msWCSGetCoverageMetadata20(layerObj *layer,
+                                      wcs20coverageMetadataObj *cm) {
+  char *srs_uri = NULL;
+  memset(cm, 0, sizeof(wcs20coverageMetadataObj));
+  if (msCheckParentPointer(layer->map, "map") == MS_FAILURE)
     return MS_FAILURE;
 
-  msOWSGetEPSGProj(&(layer->projection), &(layer->metadata), "CO", MS_TRUE, &(cm->srs_epsg));
-  if(!cm->srs_epsg) {
-    msOWSGetEPSGProj(&(layer->map->projection),
-                                   &(layer->map->web.metadata), "CO", MS_TRUE, &cm->srs_epsg);
-    if(!cm->srs_epsg) {
-      msSetError(MS_WCSERR, "Unable to determine the SRS for this layer, "
+  msOWSGetEPSGProj(&(layer->projection), &(layer->metadata), "CO", MS_TRUE,
+                   &(cm->srs_epsg));
+  if (!cm->srs_epsg) {
+    msOWSGetEPSGProj(&(layer->map->projection), &(layer->map->web.metadata),
+                     "CO", MS_TRUE, &cm->srs_epsg);
+    if (!cm->srs_epsg) {
+      msSetError(MS_WCSERR,
+                 "Unable to determine the SRS for this layer, "
                  "no projection defined and no metadata available.",
                  "msWCSGetCoverageMetadata20()");
       return MS_FAILURE;
@@ -2555,21 +2613,20 @@ static int msWCSGetCoverageMetadata20(la
   /* -------------------------------------------------------------------- */
   /*      Get the SRS in uri format.                                      */
   /* -------------------------------------------------------------------- */
-  if((srs_uri = msOWSGetProjURI(&(layer->projection), &(layer->metadata),
-                                "CO", MS_TRUE)) == NULL) {
+  if ((srs_uri = msOWSGetProjURI(&(layer->projection), &(layer->metadata), "CO",
+                                 MS_TRUE)) == NULL) {
     srs_uri = msOWSGetProjURI(&(layer->map->projection),
                               &(layer->map->web.metadata), "CO", MS_TRUE);
   }
 
-  if( srs_uri != NULL ) {
-    if( strlen(srs_uri) > sizeof(cm->srs_uri) - 1 ) {
-      msSetError(MS_WCSERR, "SRS URI too long!",
-                 "msWCSGetCoverageMetadata()");
+  if (srs_uri != NULL) {
+    if (strlen(srs_uri) > sizeof(cm->srs_uri) - 1) {
+      msSetError(MS_WCSERR, "SRS URI too long!", "msWCSGetCoverageMetadata()");
       return MS_FAILURE;
     }
 
-    strlcpy( cm->srs_uri, srs_uri, sizeof(cm->srs_uri) );
-    msFree( srs_uri );
+    strlcpy(cm->srs_uri, srs_uri, sizeof(cm->srs_uri));
+    msFree(srs_uri);
   } else {
     cm->srs_uri[0] = '\0';
   }
@@ -2585,9 +2642,9 @@ static int msWCSGetCoverageMetadata20(la
   /*      that in preference to inspecting the file(s).                   */
   /*      We require extent and either size or resolution.                */
   /* -------------------------------------------------------------------- */
-  if( msOWSLookupMetadata(&(layer->metadata), "CO", "extent") != NULL
-      && (msOWSLookupMetadata(&(layer->metadata), "CO", "resolution") != NULL
-          || msOWSLookupMetadata(&(layer->metadata), "CO", "size") != NULL) ) {
+  if (msOWSLookupMetadata(&(layer->metadata), "CO", "extent") != NULL &&
+      (msOWSLookupMetadata(&(layer->metadata), "CO", "resolution") != NULL ||
+       msOWSLookupMetadata(&(layer->metadata), "CO", "size") != NULL)) {
     const char *value;
 
     /* get extent */
@@ -2595,60 +2652,76 @@ static int msWCSGetCoverageMetadata20(la
     cm->extent.maxx = 0.0;
     cm->extent.miny = 0.0;
     cm->extent.maxy = 0.0;
-    if( msOWSGetLayerExtent( layer->map, layer, "CO", &cm->extent ) == MS_FAILURE )
+    if (msOWSGetLayerExtent(layer->map, layer, "CO", &cm->extent) == MS_FAILURE)
       return MS_FAILURE;
 
     /* get resolution */
     cm->xresolution = 0.0;
     cm->yresolution = 0.0;
-    if( (value = msOWSLookupMetadata(&(layer->metadata), "CO", "resolution")) != NULL ) {
+    if ((value = msOWSLookupMetadata(&(layer->metadata), "CO", "resolution")) !=
+        NULL) {
       char **tokens;
       int n;
 
       tokens = msStringSplit(value, ' ', &n);
-      if( tokens == NULL || n != 2 ) {
-        msSetError( MS_WCSERR, "Wrong number of arguments for wcs|ows_resolution metadata.", "msWCSGetCoverageMetadata20()");
-        msFreeCharArray( tokens, n );
+      if (tokens == NULL || n != 2) {
+        msSetError(MS_WCSERR,
+                   "Wrong number of arguments for wcs|ows_resolution metadata.",
+                   "msWCSGetCoverageMetadata20()");
+        msFreeCharArray(tokens, n);
         return MS_FAILURE;
       }
       cm->xresolution = atof(tokens[0]);
       cm->yresolution = atof(tokens[1]);
-      msFreeCharArray( tokens, n );
+      msFreeCharArray(tokens, n);
     }
 
     /* get Size (in pixels and lines) */
     cm->xsize = 0;
     cm->ysize = 0;
-    if( (value=msOWSLookupMetadata(&(layer->metadata), "CO", "size")) != NULL ) {
+    if ((value = msOWSLookupMetadata(&(layer->metadata), "CO", "size")) !=
+        NULL) {
       char **tokens;
       int n;
 
       tokens = msStringSplit(value, ' ', &n);
-      if( tokens == NULL || n != 2 ) {
-        msSetError( MS_WCSERR, "Wrong number of arguments for wcs|ows_size metadata.", "msWCSGetCoverageMetadata20()");
-        msFreeCharArray( tokens, n );
+      if (tokens == NULL || n != 2) {
+        msSetError(MS_WCSERR,
+                   "Wrong number of arguments for wcs|ows_size metadata.",
+                   "msWCSGetCoverageMetadata20()");
+        msFreeCharArray(tokens, n);
         return MS_FAILURE;
       }
       cm->xsize = atoi(tokens[0]);
       cm->ysize = atoi(tokens[1]);
-      msFreeCharArray( tokens, n );
+      msFreeCharArray(tokens, n);
     }
 
     /* try to compute raster size */
-    if( cm->xsize == 0 && cm->ysize == 0 && cm->xresolution != 0.0 && cm->yresolution != 0.0 && cm->extent.minx != cm->extent.maxx && cm->extent.miny != cm->extent.maxy ) {
-      cm->xsize = (int) ((cm->extent.maxx - cm->extent.minx) / cm->xresolution + 0.5);
-      cm->ysize = (int) fabs((cm->extent.maxy - cm->extent.miny) / cm->yresolution + 0.5);
+    if (cm->xsize == 0 && cm->ysize == 0 && cm->xresolution != 0.0 &&
+        cm->yresolution != 0.0 && cm->extent.minx != cm->extent.maxx &&
+        cm->extent.miny != cm->extent.maxy) {
+      cm->xsize =
+          (int)((cm->extent.maxx - cm->extent.minx) / cm->xresolution + 0.5);
+      cm->ysize = (int)fabs(
+          (cm->extent.maxy - cm->extent.miny) / cm->yresolution + 0.5);
     }
 
     /* try to compute raster resolution */
-    if( (cm->xresolution == 0.0 || cm->yresolution == 0.0) && cm->xsize != 0 && cm->ysize != 0 ) {
+    if ((cm->xresolution == 0.0 || cm->yresolution == 0.0) && cm->xsize != 0 &&
+        cm->ysize != 0) {
       cm->xresolution = (cm->extent.maxx - cm->extent.minx) / cm->xsize;
       cm->yresolution = (cm->extent.maxy - cm->extent.miny) / cm->ysize;
     }
 
     /* do we have information to do anything */
-    if( cm->xresolution == 0.0 || cm->yresolution == 0.0 || cm->xsize == 0 || cm->ysize == 0 ) {
-      msSetError( MS_WCSERR, "Failed to collect extent and resolution for WCS coverage from metadata for layer '%s'.  Need value wcs|ows_resolution or wcs|ows_size values.", "msWCSGetCoverageMetadata20()", layer->name );
+    if (cm->xresolution == 0.0 || cm->yresolution == 0.0 || cm->xsize == 0 ||
+        cm->ysize == 0) {
+      msSetError(MS_WCSERR,
+                 "Failed to collect extent and resolution for WCS coverage "
+                 "from metadata for layer '%s'.  Need value wcs|ows_resolution "
+                 "or wcs|ows_size values.",
+                 "msWCSGetCoverageMetadata20()", layer->name);
       return MS_FAILURE;
     }
 
@@ -2662,30 +2735,37 @@ static int msWCSGetCoverageMetadata20(la
 
     /* get bands count, or assume 1 if not found */
     cm->numbands = 1;
-    if( (value = msOWSLookupMetadata(&(layer->metadata), "CO", "bandcount")) != NULL) {
+    if ((value = msOWSLookupMetadata(&(layer->metadata), "CO", "bandcount")) !=
+        NULL) {
       int numbands = 0;
       msStringParseInteger(value, &numbands);
       cm->numbands = (size_t)numbands;
     }
 
-    cm->bands = static_cast<wcs20rasterbandMetadataObj*>(msSmallCalloc(sizeof(wcs20rasterbandMetadataObj), cm->numbands));
+    cm->bands = static_cast<wcs20rasterbandMetadataObj *>(
+        msSmallCalloc(sizeof(wcs20rasterbandMetadataObj), cm->numbands));
 
     /* get bands type, or assume float if not found */
     cm->imagemode = MS_IMAGEMODE_FLOAT32;
-    if( (value = msOWSLookupMetadata(&(layer->metadata), "CO", "imagemode")) != NULL ) {
-      if( EQUAL(value,"INT16") )
+    if ((value = msOWSLookupMetadata(&(layer->metadata), "CO", "imagemode")) !=
+        NULL) {
+      if (EQUAL(value, "INT16"))
         cm->imagemode = MS_IMAGEMODE_INT16;
-      else if( EQUAL(value,"FLOAT32") )
+      else if (EQUAL(value, "FLOAT32"))
         cm->imagemode = MS_IMAGEMODE_FLOAT32;
-      else if( EQUAL(value,"BYTE") )
+      else if (EQUAL(value, "BYTE"))
         cm->imagemode = MS_IMAGEMODE_BYTE;
       else {
-        msSetError( MS_WCSERR, "Content of wcs|ows_imagemode (%s) not recognised.  Should be one of BYTE, INT16 or FLOAT32.", "msWCSGetCoverageMetadata20()", value );
+        msSetError(MS_WCSERR,
+                   "Content of wcs|ows_imagemode (%s) not recognised.  Should "
+                   "be one of BYTE, INT16 or FLOAT32.",
+                   "msWCSGetCoverageMetadata20()", value);
         return MS_FAILURE;
       }
     }
 
-    if( (value = msOWSLookupMetadata(&(layer->metadata), "CO", "native_format")) != NULL ) {
+    if ((value = msOWSLookupMetadata(&(layer->metadata), "CO",
+                                     "native_format")) != NULL) {
       cm->native_format = msStrdup(value);
     }
 
@@ -2693,24 +2773,29 @@ static int msWCSGetCoverageMetadata20(la
     {
       int n_nilvalues = 0, n_nilvalues_reasons = 0;
       char **t_nilvalues = NULL, **t_nilvalues_reasons = NULL;
-      if( (value = msOWSLookupMetadata(&(layer->metadata), "CO", "nilvalues")) != NULL ) {
+      if ((value = msOWSLookupMetadata(&(layer->metadata), "CO",
+                                       "nilvalues")) != NULL) {
         t_nilvalues = msStringSplit(value, ' ', &n_nilvalues);
-      } else if((value = msOWSLookupMetadata(&(layer->metadata), "CO", "rangeset_nullvalue")) != NULL) {
+      } else if ((value = msOWSLookupMetadata(&(layer->metadata), "CO",
+                                              "rangeset_nullvalue")) != NULL) {
         t_nilvalues = msStringSplit(value, ' ', &n_nilvalues);
       }
 
-      if( (value = msOWSLookupMetadata(&(layer->metadata), "CO", "nilvalues_reasons")) != NULL ) {
+      if ((value = msOWSLookupMetadata(&(layer->metadata), "CO",
+                                       "nilvalues_reasons")) != NULL) {
         t_nilvalues_reasons = msStringSplit(value, ' ', &n_nilvalues_reasons);
       }
 
-      if(n_nilvalues > 0) {
+      if (n_nilvalues > 0) {
         int i;
         cm->numnilvalues = n_nilvalues;
-        cm->nilvalues = static_cast<char**>(msSmallCalloc(sizeof(char*), n_nilvalues));
-        cm->nilvalues_reasons = static_cast<char**>(msSmallCalloc(sizeof(char*), n_nilvalues));
-        for(i = 0; i < n_nilvalues; ++i) {
+        cm->nilvalues =
+            static_cast<char **>(msSmallCalloc(sizeof(char *), n_nilvalues));
+        cm->nilvalues_reasons =
+            static_cast<char **>(msSmallCalloc(sizeof(char *), n_nilvalues));
+        for (i = 0; i < n_nilvalues; ++i) {
           cm->nilvalues[i] = msStrdup(t_nilvalues[i]);
-          if(i < n_nilvalues_reasons) {
+          if (i < n_nilvalues_reasons) {
             cm->nilvalues_reasons[i] = msStrdup(t_nilvalues_reasons[i]);
           } else {
             cm->nilvalues_reasons[i] = msStrdup("");
@@ -2734,10 +2819,11 @@ static int msWCSGetCoverageMetadata20(la
 
       const char *significant_figures_key = "significant_figures";
 
-      const char *wcs11_keys[] =
-      { "label", "semantic", "values_type", "values_semantic", "description" };
-      const char *wcs20_keys[] =
-      { "band_name", "band_interpretation", "band_uom", "band_definition", "band_description" };
+      const char *wcs11_keys[] = {"label", "semantic", "values_type",
+                                  "values_semantic", "description"};
+      const char *wcs20_keys[] = {"band_name", "band_interpretation",
+                                  "band_uom", "band_definition",
+                                  "band_description"};
       const char **keys = NULL;
 
       char **interval_array;
@@ -2746,85 +2832,90 @@ static int msWCSGetCoverageMetadata20(la
       wcs20rasterbandMetadataObj default_values;
 
       /* Decide whether WCS1.1 or WCS2.0 keys should be used */
-      if( (value = msOWSLookupMetadata(&(layer->metadata), "CO", wcs20_band_names_key) ) != NULL ) {
+      if ((value = msOWSLookupMetadata(&(layer->metadata), "CO",
+                                       wcs20_band_names_key)) != NULL) {
         keys = wcs20_keys;
         interval_key = wcs20_interval_key;
         band_names = msStringSplit(value, ' ', &num_band_names);
-      } else if( (value = msOWSLookupMetadata(&(layer->metadata), "CO", wcs11_band_names_key)) != NULL ) {
+      } else if ((value = msOWSLookupMetadata(&(layer->metadata), "CO",
+                                              wcs11_band_names_key)) != NULL) {
         keys = wcs11_keys;
         interval_key = wcs11_interval_key;
         /* "bands" has a special processing in WCS 1.0. See */
         /* msWCSSetDefaultBandsRangeSetInfo */
-        if( EQUAL(value, "bands") )
-        {
-            num_band_names = cm->numbands;
-            band_names = (char**) msSmallMalloc( sizeof(char*) * num_band_names );
-            for( int i = 0; i < num_band_names; i++ )
-            {
-                char szName[30];
-                snprintf(szName, sizeof(szName), "Band%d", i+1);
-                band_names[i] = msStrdup(szName);
-            }
-        }
-        else
-        {
-            /* WARNING: in WCS 1.x,, "rangeset_axes" has never been intended */
-            /* to contain the list of band names... This code should probably */
-            /* be removed */
-            band_names = msStringSplit(value, ' ', &num_band_names);
+        if (EQUAL(value, "bands")) {
+          num_band_names = cm->numbands;
+          band_names = (char **)msSmallMalloc(sizeof(char *) * num_band_names);
+          for (int i = 0; i < num_band_names; i++) {
+            char szName[30];
+            snprintf(szName, sizeof(szName), "Band%d", i + 1);
+            band_names[i] = msStrdup(szName);
+          }
+        } else {
+          /* WARNING: in WCS 1.x,, "rangeset_axes" has never been intended */
+          /* to contain the list of band names... This code should probably */
+          /* be removed */
+          band_names = msStringSplit(value, ' ', &num_band_names);
         }
       }
 
       /* return with error when number of bands does not match    */
       /* the number of names                                      */
-      if (static_cast<size_t>(num_band_names) != cm->numbands && num_band_names != 0) {
+      if (static_cast<size_t>(num_band_names) != cm->numbands &&
+          num_band_names != 0) {
         msFreeCharArray(band_names, num_band_names);
-        msSetError( MS_WCSERR,
-                    "Wrong number of band names given in layer '%s'. "
-                    "Expected %d, got %d.", "msWCSGetCoverageMetadata20()",
-                    layer->name, (int)cm->numbands, num_band_names );
+        msSetError(MS_WCSERR,
+                   "Wrong number of band names given in layer '%s'. "
+                   "Expected %d, got %d.",
+                   "msWCSGetCoverageMetadata20()", layer->name,
+                   (int)cm->numbands, num_band_names);
         return MS_FAILURE;
       }
 
       /* look up default metadata values */
-      for(j = 1; j < 5; ++j) {
-        if(keys != NULL) {
-          default_values.values[j] = (char *)msOWSLookupMetadata(&(layer->metadata), "CO", keys[j]);
+      for (j = 1; j < 5; ++j) {
+        if (keys != NULL) {
+          default_values.values[j] =
+              (char *)msOWSLookupMetadata(&(layer->metadata), "CO", keys[j]);
         }
       }
 
       /* set default values for interval and significant figures */
-      switch(cm->imagemode) {
-        case MS_IMAGEMODE_BYTE:
-          default_values.interval_min = 0.;
-          default_values.interval_max = 255.;
-          default_values.significant_figures = 3;
-          break;
-        case MS_IMAGEMODE_INT16:
-          default_values.interval_min = 0.;
-          default_values.interval_max = (double)USHRT_MAX;
-          default_values.significant_figures = 5;
-          break;
-        case MS_IMAGEMODE_FLOAT32:
-          default_values.interval_min = -FLT_MAX;
-          default_values.interval_max = FLT_MAX;
-          default_values.significant_figures = 12;
-          break;
-        default:
-          // other imagemodes are invalid (see above), just keep the compiler happy
-          msFreeCharArray(band_names, num_band_names);
-          return MS_FAILURE;
-          break;
+      switch (cm->imagemode) {
+      case MS_IMAGEMODE_BYTE:
+        default_values.interval_min = 0.;
+        default_values.interval_max = 255.;
+        default_values.significant_figures = 3;
+        break;
+      case MS_IMAGEMODE_INT16:
+        default_values.interval_min = 0.;
+        default_values.interval_max = (double)USHRT_MAX;
+        default_values.significant_figures = 5;
+        break;
+      case MS_IMAGEMODE_FLOAT32:
+        default_values.interval_min = -FLT_MAX;
+        default_values.interval_max = FLT_MAX;
+        default_values.significant_figures = 12;
+        break;
+      default:
+        // other imagemodes are invalid (see above), just keep the compiler
+        // happy
+        msFreeCharArray(band_names, num_band_names);
+        return MS_FAILURE;
+        break;
       }
 
       /* lookup default interval values */
-      if (interval_key != NULL
-          && (value = msOWSLookupMetadata(&(layer->metadata), "CO", interval_key)) != NULL) {
+      if (interval_key != NULL &&
+          (value = msOWSLookupMetadata(&(layer->metadata), "CO",
+                                       interval_key)) != NULL) {
         interval_array = msStringSplit(value, ' ', &num_interval);
 
-        if (num_interval != 2
-            || msStringParseDouble(interval_array[0], &(default_values.interval_min)) != MS_SUCCESS
-            || msStringParseDouble(interval_array[1], &(default_values.interval_max)) != MS_SUCCESS) {
+        if (num_interval != 2 ||
+            msStringParseDouble(interval_array[0],
+                                &(default_values.interval_min)) != MS_SUCCESS ||
+            msStringParseDouble(interval_array[1],
+                                &(default_values.interval_max)) != MS_SUCCESS) {
           msFreeCharArray(band_names, num_band_names);
           msFreeCharArray(interval_array, num_interval);
           msSetError(MS_WCSERR, "Wrong interval format for default axis.",
@@ -2835,10 +2926,13 @@ static int msWCSGetCoverageMetadata20(la
       }
 
       /* lookup default value for significant figures */
-      if((value = msOWSLookupMetadata(&(layer->metadata), "CO", significant_figures_key)) != NULL) {
-        if(msStringParseInteger(value, &(default_values.significant_figures)) != MS_SUCCESS) {
+      if ((value = msOWSLookupMetadata(&(layer->metadata), "CO",
+                                       significant_figures_key)) != NULL) {
+        if (msStringParseInteger(
+                value, &(default_values.significant_figures)) != MS_SUCCESS) {
           msFreeCharArray(band_names, num_band_names);
-          msSetError(MS_WCSERR, "Wrong significant figures format "
+          msSetError(MS_WCSERR,
+                     "Wrong significant figures format "
                      "for default axis.",
                      "msWCSGetCoverageMetadata20()");
           return MS_FAILURE;
@@ -2846,33 +2940,35 @@ static int msWCSGetCoverageMetadata20(la
       }
 
       /* iterate over every band */
-      for(unsigned i = 0; i < cm->numbands; ++i) {
+      for (unsigned i = 0; i < cm->numbands; ++i) {
         cm->bands[i].name = NULL;
 
         /* look up band metadata or copy defaults */
-        if(num_band_names != 0) {
+        if (num_band_names != 0) {
           cm->bands[i].name = msStrdup(band_names[i]);
-          for(j = 1; j < 5; ++j) {
-            value = (char *)msWCSLookupRangesetAxisMetadata20(&(layer->metadata),
-                    cm->bands[i].name, keys[j]);
-            if(value != NULL) {
+          for (j = 1; j < 5; ++j) {
+            value = (char *)msWCSLookupRangesetAxisMetadata20(
+                &(layer->metadata), cm->bands[i].name, keys[j]);
+            if (value != NULL) {
               cm->bands[i].values[j] = msStrdup(value);
-            } else if(default_values.values[j] != NULL) {
+            } else if (default_values.values[j] != NULL) {
               cm->bands[i].values[j] = msStrdup(default_values.values[j]);
             }
           }
         }
 
         /* set up interval */
-        value = (char *)msWCSLookupRangesetAxisMetadata20(&(layer->metadata),
-                cm->bands[i].name, interval_key);
-        if(value != NULL) {
+        value = (char *)msWCSLookupRangesetAxisMetadata20(
+            &(layer->metadata), cm->bands[i].name, interval_key);
+        if (value != NULL) {
           num_interval = 0;
           interval_array = msStringSplit(value, ' ', &num_interval);
 
-          if (num_interval != 2
-              || msStringParseDouble(interval_array[0], &(cm->bands[i].interval_min)) != MS_SUCCESS
-              || msStringParseDouble(interval_array[1], &(cm->bands[i].interval_max)) != MS_SUCCESS) {
+          if (num_interval != 2 ||
+              msStringParseDouble(interval_array[0],
+                                  &(cm->bands[i].interval_min)) != MS_SUCCESS ||
+              msStringParseDouble(interval_array[1],
+                                  &(cm->bands[i].interval_max)) != MS_SUCCESS) {
             msFreeCharArray(band_names, num_band_names);
             msFreeCharArray(interval_array, num_interval);
             msSetError(MS_WCSERR, "Wrong interval format for axis %s.",
@@ -2887,12 +2983,14 @@ static int msWCSGetCoverageMetadata20(la
         }
 
         /* set up significant figures */
-        value = (char *)msWCSLookupRangesetAxisMetadata20(&(layer->metadata),
-                cm->bands[i].name, significant_figures_key);
-        if(value != NULL) {
-          if(msStringParseInteger(value, &(cm->bands[i].significant_figures)) != MS_SUCCESS) {
+        value = (char *)msWCSLookupRangesetAxisMetadata20(
+            &(layer->metadata), cm->bands[i].name, significant_figures_key);
+        if (value != NULL) {
+          if (msStringParseInteger(
+                  value, &(cm->bands[i].significant_figures)) != MS_SUCCESS) {
             msFreeCharArray(band_names, num_band_names);
-            msSetError(MS_WCSERR, "Wrong significant figures format "
+            msSetError(MS_WCSERR,
+                       "Wrong significant figures format "
                        "for axis %s.",
                        "msWCSGetCoverageMetadata20()", cm->bands[i].name);
             return MS_FAILURE;
@@ -2904,9 +3002,15 @@ static int msWCSGetCoverageMetadata20(la
 
       msFreeCharArray(band_names, num_band_names);
     }
-  } else if( layer->data == NULL ) {
-    /* no virtual metadata, not ok unless we're talking 1 image, hopefully we can fix that */
-    msSetError( MS_WCSERR, "RASTER Layer with no DATA statement and no WCS virtual dataset metadata.  Tileindexed raster layers not supported for WCS without virtual dataset metadata (cm->extent, wcs_res, wcs_size).", "msWCSGetCoverageMetadata20()" );
+  } else if (layer->data == NULL) {
+    /* no virtual metadata, not ok unless we're talking 1 image, hopefully we
+     * can fix that */
+    msSetError(
+        MS_WCSERR,
+        "RASTER Layer with no DATA statement and no WCS virtual dataset "
+        "metadata.  Tileindexed raster layers not supported for WCS without "
+        "virtual dataset metadata (cm->extent, wcs_res, wcs_size).",
+        "msWCSGetCoverageMetadata20()");
     return MS_FAILURE;
   } else {
     /* work from the file (e.g. DATA) */
@@ -2918,91 +3022,101 @@ static int msWCSGetCoverageMetadata20(la
 
     msGDALInitialize();
 
-    msTryBuildPath3(szPath,  layer->map->mappath, layer->map->shapepath, layer->data);
-    msAcquireLock( TLOCK_GDAL );
+    msTryBuildPath3(szPath, layer->map->mappath, layer->map->shapepath,
+                    layer->data);
+    msAcquireLock(TLOCK_GDAL);
     {
-        char** connectionoptions = msGetStringListFromHashTable(&(layer->connectionoptions));
-        hDS = GDALOpenEx( szPath, GDAL_OF_RASTER, NULL,
-                          (const char* const*)connectionoptions, NULL);
-        CSLDestroy(connectionoptions);
-    }
-    if( hDS == NULL ) {
-      msReleaseLock( TLOCK_GDAL );
-      msSetError( MS_IOERR, "%s", "msWCSGetCoverageMetadata20()", CPLGetLastErrorMsg() );
+      char **connectionoptions =
+          msGetStringListFromHashTable(&(layer->connectionoptions));
+      hDS = GDALOpenEx(szPath, GDAL_OF_RASTER, NULL,
+                       (const char *const *)connectionoptions, NULL);
+      CSLDestroy(connectionoptions);
+    }
+    if (hDS == NULL) {
+      msReleaseLock(TLOCK_GDAL);
+      msSetError(MS_IOERR, "%s", "msWCSGetCoverageMetadata20()",
+                 CPLGetLastErrorMsg());
       return MS_FAILURE;
     }
 
-    msGetGDALGeoTransform( hDS, layer->map, layer, cm->geotransform );
+    msGetGDALGeoTransform(hDS, layer->map, layer, cm->geotransform);
 
-    cm->xsize = GDALGetRasterXSize( hDS );
-    cm->ysize = GDALGetRasterYSize( hDS );
+    cm->xsize = GDALGetRasterXSize(hDS);
+    cm->ysize = GDALGetRasterYSize(hDS);
 
     cm->extent.minx = cm->geotransform[0];
-    cm->extent.maxx = cm->geotransform[0] + cm->geotransform[1] * cm->xsize + cm->geotransform[2] * cm->ysize;
-    cm->extent.miny = cm->geotransform[3] + cm->geotransform[4] * cm->xsize + cm->geotransform[5] * cm->ysize;
+    cm->extent.maxx = cm->geotransform[0] + cm->geotransform[1] * cm->xsize +
+                      cm->geotransform[2] * cm->ysize;
+    cm->extent.miny = cm->geotransform[3] + cm->geotransform[4] * cm->xsize +
+                      cm->geotransform[5] * cm->ysize;
     cm->extent.maxy = cm->geotransform[3];
 
     cm->xresolution = cm->geotransform[1];
     cm->yresolution = cm->geotransform[5];
 
-    cm->numbands = GDALGetRasterCount( hDS );
+    cm->numbands = GDALGetRasterCount(hDS);
 
     /* TODO nilvalues? */
 
-    if( cm->numbands == 0 ) {
-      msReleaseLock( TLOCK_GDAL );
-      msSetError( MS_WCSERR, "Raster file %s has no raster bands.  This cannot be used in a layer.", "msWCSGetCoverageMetadata20()", layer->data );
+    if (cm->numbands == 0) {
+      msReleaseLock(TLOCK_GDAL);
+      msSetError(MS_WCSERR,
+                 "Raster file %s has no raster bands.  This cannot be used in "
+                 "a layer.",
+                 "msWCSGetCoverageMetadata20()", layer->data);
       return MS_FAILURE;
     }
 
-    hBand = GDALGetRasterBand( hDS, 1 );
-    switch( GDALGetRasterDataType( hBand ) ) {
-      case GDT_Byte:
-        cm->imagemode = MS_IMAGEMODE_BYTE;
-        break;
-      case GDT_Int16:
-        cm->imagemode = MS_IMAGEMODE_INT16;
-        break;
-      default:
-        cm->imagemode = MS_IMAGEMODE_FLOAT32;
-        break;
+    hBand = GDALGetRasterBand(hDS, 1);
+    switch (GDALGetRasterDataType(hBand)) {
+    case GDT_Byte:
+      cm->imagemode = MS_IMAGEMODE_BYTE;
+      break;
+    case GDT_Int16:
+      cm->imagemode = MS_IMAGEMODE_INT16;
+      break;
+    default:
+      cm->imagemode = MS_IMAGEMODE_FLOAT32;
+      break;
     }
 
-    cm->bands = static_cast<wcs20rasterbandMetadataObj*>(msSmallCalloc(sizeof(wcs20rasterbandMetadataObj), cm->numbands));
+    cm->bands = static_cast<wcs20rasterbandMetadataObj *>(
+        msSmallCalloc(sizeof(wcs20rasterbandMetadataObj), cm->numbands));
 
     /* get as much band metadata as possible */
-    for(unsigned i = 0; i < cm->numbands; ++i) {
+    for (unsigned i = 0; i < cm->numbands; ++i) {
       char bandname[32];
       GDALColorInterp colorInterp;
       hBand = GDALGetRasterBand(hDS, i + 1);
-      snprintf(bandname, sizeof(bandname), "band%d", i+1);
+      snprintf(bandname, sizeof(bandname), "band%d", i + 1);
       cm->bands[i].name = msStrdup(bandname);
       colorInterp = GDALGetRasterColorInterpretation(hBand);
-      cm->bands[i].interpretation = msStrdup(GDALGetColorInterpretationName(colorInterp));
+      cm->bands[i].interpretation =
+          msStrdup(GDALGetColorInterpretationName(colorInterp));
       cm->bands[i].uom = msStrdup(GDALGetRasterUnitType(hBand));
-      if(strlen(cm->bands[i].uom) == 0) {
+      if (strlen(cm->bands[i].uom) == 0) {
         msFree(cm->bands[i].uom);
         cm->bands[i].uom = NULL;
       }
 
       /* set up interval and significant figures */
-      switch(cm->imagemode) {
-        case MS_IMAGEMODE_BYTE:
-        case MS_IMAGEMODE_PC256:
-          cm->bands[i].interval_min = 0.;
-          cm->bands[i].interval_max = 255.;
-          cm->bands[i].significant_figures = 3;
-          break;
-        case MS_IMAGEMODE_INT16:
-          cm->bands[i].interval_min = 0.;
-          cm->bands[i].interval_max = (double)USHRT_MAX;
-          cm->bands[i].significant_figures = 5;
-          break;
-        case MS_IMAGEMODE_FLOAT32:
-          cm->bands[i].interval_min = -FLT_MAX;
-          cm->bands[i].interval_max = FLT_MAX;
-          cm->bands[i].significant_figures = 12;
-          break;
+      switch (cm->imagemode) {
+      case MS_IMAGEMODE_BYTE:
+      case MS_IMAGEMODE_PC256:
+        cm->bands[i].interval_min = 0.;
+        cm->bands[i].interval_max = 255.;
+        cm->bands[i].significant_figures = 3;
+        break;
+      case MS_IMAGEMODE_INT16:
+        cm->bands[i].interval_min = 0.;
+        cm->bands[i].interval_max = (double)USHRT_MAX;
+        cm->bands[i].significant_figures = 5;
+        break;
+      case MS_IMAGEMODE_FLOAT32:
+        cm->bands[i].interval_min = -FLT_MAX;
+        cm->bands[i].interval_max = FLT_MAX;
+        cm->bands[i].significant_figures = 12;
+        break;
       }
     }
 
@@ -3010,16 +3124,18 @@ static int msWCSGetCoverageMetadata20(la
     driver_short_name = GDALGetDriverShortName(hDriver);
     driver_long_name = GDALGetDriverLongName(hDriver);
     /* TODO: improve this, exchange strstr() */
-    for(int i = 0; i < layer->map->numoutputformats; ++i) {
-      if(strstr( layer->map->outputformatlist[i]->driver, driver_short_name) != NULL
-          || strstr(layer->map->outputformatlist[i]->driver, driver_long_name) != NULL) {
+    for (int i = 0; i < layer->map->numoutputformats; ++i) {
+      if (strstr(layer->map->outputformatlist[i]->driver, driver_short_name) !=
+              NULL ||
+          strstr(layer->map->outputformatlist[i]->driver, driver_long_name) !=
+              NULL) {
         cm->native_format = msStrdup(layer->map->outputformatlist[i]->mimetype);
         break;
       }
     }
 
-    GDALClose( hDS );
-    msReleaseLock( TLOCK_GDAL );
+    GDALClose(hDS);
+    msReleaseLock(TLOCK_GDAL);
   }
 
   return MS_SUCCESS;
@@ -3032,18 +3148,17 @@ static int msWCSGetCoverageMetadata20(la
 /*      data object.                                                    */
 /************************************************************************/
 
-static int msWCSClearCoverageMetadata20(wcs20coverageMetadataObj *cm)
-{
+static int msWCSClearCoverageMetadata20(wcs20coverageMetadataObj *cm) {
   msFree(cm->native_format);
-  for(unsigned i = 0; i < cm->numnilvalues; ++i) {
+  for (unsigned i = 0; i < cm->numnilvalues; ++i) {
     msFree(cm->nilvalues[i]);
     msFree(cm->nilvalues_reasons[i]);
   }
   msFree(cm->nilvalues);
   msFree(cm->nilvalues_reasons);
 
-  for(unsigned i = 0; i < cm->numbands; ++i) {
-    for(int j = 0; j < 5; ++j) {
+  for (unsigned i = 0; i < cm->numbands; ++i) {
+    for (int j = 0; j < 5; ++j) {
       msFree(cm->bands[i].values[j]);
     }
   }
@@ -3059,8 +3174,7 @@ static int msWCSClearCoverageMetadata20(
 /************************************************************************/
 
 int msWCSException20(mapObj *map, const char *exceptionCode,
-                     const char *locator, const char *version)
-{
+                     const char *locator, const char *version) {
   int size = 0;
   const char *status = "400 Bad Request";
   char *errorString = NULL;
@@ -3085,25 +3199,30 @@ int msWCSException20(mapObj *map, const
                      BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_PREFIX);
   xmlSetNs(psRootNode, psNsOws);
 
-  psNsXsi = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX);
+  psNsXsi = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI,
+                     BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX);
 
   /* add attributes to root element */
   xmlNewProp(psRootNode, BAD_CAST "version", BAD_CAST version);
-  xmlNewProp(psRootNode, BAD_CAST "xml:lang", BAD_CAST msOWSGetLanguage(map, "exception"));
+  xmlNewProp(psRootNode, BAD_CAST "xml:lang",
+             BAD_CAST msOWSGetLanguage(map, "exception"));
 
   /* get 2 digits version string: '2.0' */
   msOWSGetVersionString(OWS_2_0_0, version_string);
-  version_string[3]= '\0';
+  version_string[3] = '\0';
 
   xsi_schemaLocation = msStrdup((char *)psNsOws->href);
   xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, (char *)schemasLocation);
+  xsi_schemaLocation =
+      msStringConcatenate(xsi_schemaLocation, (char *)schemasLocation);
   xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, "/ows/");
   xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, version_string);
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, "/owsExceptionReport.xsd");
+  xsi_schemaLocation =
+      msStringConcatenate(xsi_schemaLocation, "/owsExceptionReport.xsd");
 
   /* add namespace'd attributes to root element */
-  xmlNewNsProp(psRootNode, psNsXsi, BAD_CAST "schemaLocation", BAD_CAST xsi_schemaLocation);
+  xmlNewNsProp(psRootNode, psNsXsi, BAD_CAST "schemaLocation",
+               BAD_CAST xsi_schemaLocation);
 
   /* add child element */
   psMainNode = xmlNewChild(psRootNode, NULL, BAD_CAST "Exception", NULL);
@@ -3116,8 +3235,9 @@ int msWCSException20(mapObj *map, const
   }
 
   if (errorString != NULL) {
-    char* errorMessage = msEncodeHTMLEntities(errorString);
-    xmlNewChild(psMainNode, NULL, BAD_CAST "ExceptionText", BAD_CAST errorMessage);
+    char *errorMessage = msEncodeHTMLEntities(errorString);
+    xmlNewChild(psMainNode, NULL, BAD_CAST "ExceptionText",
+                BAD_CAST errorMessage);
     msFree(errorMessage);
   }
 
@@ -3129,20 +3249,18 @@ int msWCSException20(mapObj *map, const
 
   if (exceptionCode == NULL) {
     /* Do nothing */
-  }
-  else if(EQUAL(exceptionCode, "OperationNotSupported")
-     || EQUAL(exceptionCode, "OptionNotSupported")) {
+  } else if (EQUAL(exceptionCode, "OperationNotSupported") ||
+             EQUAL(exceptionCode, "OptionNotSupported")) {
     status = "501 Not Implemented";
-  }
-  else if (EQUAL(exceptionCode, "NoSuchCoverage")
-           || EQUAL(exceptionCode, "emptyCoverageIdList")
-           || EQUAL(exceptionCode, "InvalidAxisLabel")
-           || EQUAL(exceptionCode, "InvalidSubsetting")) {
+  } else if (EQUAL(exceptionCode, "NoSuchCoverage") ||
+             EQUAL(exceptionCode, "emptyCoverageIdList") ||
+             EQUAL(exceptionCode, "InvalidAxisLabel") ||
+             EQUAL(exceptionCode, "InvalidSubsetting")) {
     status = "404 Not Found";
   }
 
   msIO_setHeader("Status", "%s", status);
-  msIO_setHeader("Content-Type","text/xml; charset=UTF-8");
+  msIO_setHeader("Content-Type", "text/xml; charset=UTF-8");
   msIO_sendHeaders();
 
   xmlDocDumpFormatMemoryEnc(psDoc, &buffer, &size, "UTF-8", 1);
@@ -3164,44 +3282,57 @@ int msWCSException20(mapObj *map, const
 #define MAX_MIMES 20
 
 static int msWCSGetCapabilities20_CreateProfiles(
-  mapObj *map, xmlNodePtr psServiceIdentification, xmlNsPtr psOwsNs)
-{
+    mapObj *map, xmlNodePtr psServiceIdentification, xmlNsPtr psOwsNs) {
   xmlNodePtr psProfile, psTmpNode;
   char *available_mime_types[MAX_MIMES];
   int i = 0;
 
   /* even indices are urls, uneven are mime-types, or null*/
-  const char * const urls_and_mime_types[] = {
-    MS_WCS_20_PROFILE_CORE,     NULL,
-    MS_WCS_20_PROFILE_KVP,      NULL,
-    MS_WCS_20_PROFILE_POST,     NULL,
-    MS_WCS_20_PROFILE_GML,      NULL,
-    MS_WCS_20_PROFILE_GML_MULTIPART, NULL,
-    MS_WCS_20_PROFILE_GML_SPECIAL, NULL,
-    MS_WCS_20_PROFILE_GML_GEOTIFF, "image/tiff",
-    MS_WCS_20_PROFILE_CRS,     NULL,
-    MS_WCS_20_PROFILE_SCALING, NULL,
-    MS_WCS_20_PROFILE_RANGESUBSET, NULL,
-    MS_WCS_20_PROFILE_INTERPOLATION, NULL,
-    NULL, NULL /* guardian */
+  const char *const urls_and_mime_types[] = {
+      MS_WCS_20_PROFILE_CORE,
+      NULL,
+      MS_WCS_20_PROFILE_KVP,
+      NULL,
+      MS_WCS_20_PROFILE_POST,
+      NULL,
+      MS_WCS_20_PROFILE_GML,
+      NULL,
+      MS_WCS_20_PROFILE_GML_MULTIPART,
+      NULL,
+      MS_WCS_20_PROFILE_GML_SPECIAL,
+      NULL,
+      MS_WCS_20_PROFILE_GML_GEOTIFF,
+      "image/tiff",
+      MS_WCS_20_PROFILE_CRS,
+      NULL,
+      MS_WCS_20_PROFILE_SCALING,
+      NULL,
+      MS_WCS_20_PROFILE_RANGESUBSET,
+      NULL,
+      MS_WCS_20_PROFILE_INTERPOLATION,
+      NULL,
+      NULL,
+      NULL /* guardian */
   };
 
   /* navigate to node where profiles shall be inserted */
-  for(psTmpNode = psServiceIdentification->children; psTmpNode->next != NULL; psTmpNode = psTmpNode->next) {
-    if(EQUAL((char *)psTmpNode->name, "ServiceTypeVersion") && !EQUAL((char *)psTmpNode->next->name, "ServiceTypeVersion"))
+  for (psTmpNode = psServiceIdentification->children; psTmpNode->next != NULL;
+       psTmpNode = psTmpNode->next) {
+    if (EQUAL((char *)psTmpNode->name, "ServiceTypeVersion") &&
+        !EQUAL((char *)psTmpNode->next->name, "ServiceTypeVersion"))
       break;
   }
 
   /* get list of all available mime types */
   msGetOutputFormatMimeList(map, available_mime_types, MAX_MIMES);
 
-  while(urls_and_mime_types[i] != NULL) {
-    const char* mime_type = urls_and_mime_types[i+1];
+  while (urls_and_mime_types[i] != NULL) {
+    const char *mime_type = urls_and_mime_types[i + 1];
 
     /* check if there is a mime type */
-    if(mime_type != NULL) {
+    if (mime_type != NULL) {
       /* check if the mime_type is in the list of outputformats */
-      if(CSLPartialFindString(available_mime_types, mime_type) == -1)
+      if (CSLPartialFindString(available_mime_types, mime_type) == -1)
         continue;
     }
 
@@ -3223,21 +3354,25 @@ static int msWCSGetCapabilities20_Create
 /*      coverage.                                                       */
 /************************************************************************/
 
-static int msWCSGetCapabilities20_CoverageSummary(
-  xmlDocPtr doc, xmlNodePtr psContents, layerObj *layer )
-{
+static int msWCSGetCapabilities20_CoverageSummary(xmlDocPtr doc,
+                                                  xmlNodePtr psContents,
+                                                  layerObj *layer) {
   wcs20coverageMetadataObj cm;
   int status;
   xmlNodePtr psCSummary;
 
-  xmlNsPtr psWcsNs = xmlSearchNs( doc, xmlDocGetRootElement(doc), BAD_CAST "wcs" );
+  xmlNsPtr psWcsNs =
+      xmlSearchNs(doc, xmlDocGetRootElement(doc), BAD_CAST "wcs");
 
   status = msWCSGetCoverageMetadata20(layer, &cm);
-  if(status != MS_SUCCESS) return MS_FAILURE;
+  if (status != MS_SUCCESS)
+    return MS_FAILURE;
 
-  psCSummary = xmlNewChild( psContents, psWcsNs, BAD_CAST "CoverageSummary", NULL );
+  psCSummary =
+      xmlNewChild(psContents, psWcsNs, BAD_CAST "CoverageSummary", NULL);
   xmlNewChild(psCSummary, psWcsNs, BAD_CAST "CoverageId", BAD_CAST layer->name);
-  xmlNewChild(psCSummary, psWcsNs, BAD_CAST "CoverageSubtype", BAD_CAST "RectifiedGridCoverage");
+  xmlNewChild(psCSummary, psWcsNs, BAD_CAST "CoverageSubtype",
+              BAD_CAST "RectifiedGridCoverage");
 
   msWCS_11_20_PrintMetadataLinks(layer, doc, psCSummary);
 
@@ -3246,54 +3381,59 @@ static int msWCSGetCapabilities20_Covera
   return MS_SUCCESS;
 }
 
-
 /************************************************************************/
 /*                          msWCSAddInspireDSID20                       */
 /************************************************************************/
 
-static void msWCSAddInspireDSID20(mapObj *map,
-                                  xmlNsPtr psNsInspireDls,
+static void msWCSAddInspireDSID20(mapObj *map, xmlNsPtr psNsInspireDls,
                                   xmlNsPtr psNsInspireCommon,
-                                  xmlNodePtr pDlsExtendedCapabilities)
-{
-    const char* dsid_code = msOWSLookupMetadata(&(map->web.metadata), "CO", "inspire_dsid_code");
-    const char* dsid_ns = msOWSLookupMetadata(&(map->web.metadata), "CO", "inspire_dsid_ns");
-    if( dsid_code == NULL )
-    {
-        xmlAddChild(pDlsExtendedCapabilities, xmlNewComment(BAD_CAST "WARNING: Required metadata \"inspire_dsid_code\" missing"));
-    }
-    else
-    {
-        int ntokensCode = 0, ntokensNS = 0;
-        char** tokensCode;
-        char** tokensNS = NULL;
-        int i;
-
-        tokensCode = msStringSplit(dsid_code, ',', &ntokensCode);
-        if( dsid_ns != NULL )
-            tokensNS = msStringSplitComplex( dsid_ns, ",", &ntokensNS, MS_ALLOWEMPTYTOKENS);
-        if( ntokensNS > 0 && ntokensNS != ntokensCode )
-        {
-            xmlAddChild(pDlsExtendedCapabilities,
-                        xmlNewComment(BAD_CAST "WARNING: \"inspire_dsid_code\" and \"inspire_dsid_ns\" have not the same number of elements. Ignoring inspire_dsid_ns"));
-            msFreeCharArray(tokensNS, ntokensNS);
-            tokensNS = NULL;
-            ntokensNS = 0;
-        }
-        for(i = 0; i<ntokensCode; i++ )
-        {
-            xmlNodePtr pSDSI = xmlNewNode(psNsInspireDls, BAD_CAST "SpatialDataSetIdentifier");
-            xmlAddChild(pDlsExtendedCapabilities, pSDSI);
-            xmlNewTextChild(pSDSI, psNsInspireCommon, BAD_CAST "Code", BAD_CAST tokensCode[i]);
-            if( ntokensNS > 0 && tokensNS[i][0] != '\0' )
-                xmlNewTextChild(pSDSI, psNsInspireCommon, BAD_CAST "Namespace", BAD_CAST tokensNS[i]);
-        }
-        msFreeCharArray(tokensCode, ntokensCode);
-        msFreeCharArray(tokensNS, ntokensNS);
+                                  xmlNodePtr pDlsExtendedCapabilities) {
+  const char *dsid_code =
+      msOWSLookupMetadata(&(map->web.metadata), "CO", "inspire_dsid_code");
+  const char *dsid_ns =
+      msOWSLookupMetadata(&(map->web.metadata), "CO", "inspire_dsid_ns");
+  if (dsid_code == NULL) {
+    xmlAddChild(
+        pDlsExtendedCapabilities,
+        xmlNewComment(
+            BAD_CAST
+            "WARNING: Required metadata \"inspire_dsid_code\" missing"));
+  } else {
+    int ntokensCode = 0, ntokensNS = 0;
+    char **tokensCode;
+    char **tokensNS = NULL;
+    int i;
+
+    tokensCode = msStringSplit(dsid_code, ',', &ntokensCode);
+    if (dsid_ns != NULL)
+      tokensNS =
+          msStringSplitComplex(dsid_ns, ",", &ntokensNS, MS_ALLOWEMPTYTOKENS);
+    if (ntokensNS > 0 && ntokensNS != ntokensCode) {
+      xmlAddChild(
+          pDlsExtendedCapabilities,
+          xmlNewComment(
+              BAD_CAST
+              "WARNING: \"inspire_dsid_code\" and \"inspire_dsid_ns\" have not "
+              "the same number of elements. Ignoring inspire_dsid_ns"));
+      msFreeCharArray(tokensNS, ntokensNS);
+      tokensNS = NULL;
+      ntokensNS = 0;
+    }
+    for (i = 0; i < ntokensCode; i++) {
+      xmlNodePtr pSDSI =
+          xmlNewNode(psNsInspireDls, BAD_CAST "SpatialDataSetIdentifier");
+      xmlAddChild(pDlsExtendedCapabilities, pSDSI);
+      xmlNewTextChild(pSDSI, psNsInspireCommon, BAD_CAST "Code",
+                      BAD_CAST tokensCode[i]);
+      if (ntokensNS > 0 && tokensNS[i][0] != '\0')
+        xmlNewTextChild(pSDSI, psNsInspireCommon, BAD_CAST "Namespace",
+                        BAD_CAST tokensNS[i]);
     }
+    msFreeCharArray(tokensCode, ntokensCode);
+    msFreeCharArray(tokensNS, ntokensNS);
+  }
 }
 
-
 /************************************************************************/
 /*                   msWCSGetCapabilities20()                           */
 /*                                                                      */
@@ -3303,25 +3443,22 @@ static void msWCSAddInspireDSID20(mapObj
 /************************************************************************/
 
 int msWCSGetCapabilities20(mapObj *map, cgiRequestObj *req,
-                           wcs20ParamsObjPtr params, owsRequestObj *ows_request)
-{
-  xmlDocPtr psDoc = NULL;       /* document pointer */
-  xmlNodePtr psRootNode,
-             psOperationsNode,
-             psNode;
+                           wcs20ParamsObjPtr params,
+                           owsRequestObj *ows_request) {
+  xmlDocPtr psDoc = NULL; /* document pointer */
+  xmlNodePtr psRootNode, psOperationsNode, psNode;
   const char *updatesequence = NULL;
-  xmlNsPtr psOwsNs = NULL,
-           psXLinkNs = NULL,
-           psWcsNs = NULL,
-           psCrsNs = NULL,
+  xmlNsPtr psOwsNs = NULL, psXLinkNs = NULL, psWcsNs = NULL, psCrsNs = NULL,
            psIntNs = NULL;
-  char *script_url=NULL, *script_url_encoded=NULL, *format_list=NULL;
+  char *script_url = NULL, *script_url_encoded = NULL, *format_list = NULL;
   int i;
   xmlDocPtr pInspireTmpDoc = NULL;
 
-  const char *inspire_capabilities = msOWSLookupMetadata(&(map->web.metadata), "CO", "inspire_capabilities");
+  const char *inspire_capabilities =
+      msOWSLookupMetadata(&(map->web.metadata), "CO", "inspire_capabilities");
 
-  char *validated_language = msOWSLanguageNegotiation(map, "CO", params->accept_languages, CSLCount(params->accept_languages));
+  char *validated_language = msOWSLanguageNegotiation(
+      map, "CO", params->accept_languages, CSLCount(params->accept_languages));
 
   /* -------------------------------------------------------------------- */
   /*      Create document.                                                */
@@ -3336,81 +3473,96 @@ int msWCSGetCapabilities20(mapObj *map,
   /*      Name spaces                                                     */
   /* -------------------------------------------------------------------- */
 
-  msWCSPrepareNamespaces20(psDoc, psRootNode, map, inspire_capabilities != NULL);
+  msWCSPrepareNamespaces20(psDoc, psRootNode, map,
+                           inspire_capabilities != NULL);
 
   /* lookup namespaces */
-  psOwsNs = xmlSearchNs( psDoc, psRootNode, BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_PREFIX );
-  psWcsNs = xmlSearchNs( psDoc, psRootNode, BAD_CAST MS_OWSCOMMON_WCS_NAMESPACE_PREFIX );
-  xmlSearchNs( psDoc, psRootNode, BAD_CAST MS_OWSCOMMON_GML_NAMESPACE_PREFIX );
-  psXLinkNs = xmlSearchNs( psDoc, psRootNode, BAD_CAST "xlink" );
-  psCrsNs = xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/wcs/crs/1.0", BAD_CAST "crs");
-  psIntNs = xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/wcs/interpolation/1.0", BAD_CAST "int");
+  psOwsNs = xmlSearchNs(psDoc, psRootNode,
+                        BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_PREFIX);
+  psWcsNs = xmlSearchNs(psDoc, psRootNode,
+                        BAD_CAST MS_OWSCOMMON_WCS_NAMESPACE_PREFIX);
+  xmlSearchNs(psDoc, psRootNode, BAD_CAST MS_OWSCOMMON_GML_NAMESPACE_PREFIX);
+  psXLinkNs = xmlSearchNs(psDoc, psRootNode, BAD_CAST "xlink");
+  psCrsNs = xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/wcs/crs/1.0",
+                     BAD_CAST "crs");
+  psIntNs = xmlNewNs(psRootNode,
+                     BAD_CAST "http://www.opengis.net/wcs/interpolation/1.0",
+                     BAD_CAST "int");
 
   xmlSetNs(psRootNode, psWcsNs);
 
-  xmlNewProp(psRootNode, BAD_CAST "version", BAD_CAST params->version );
+  xmlNewProp(psRootNode, BAD_CAST "version", BAD_CAST params->version);
 
-  updatesequence = msOWSLookupMetadata(&(map->web.metadata), "CO", "updatesequence");
+  updatesequence =
+      msOWSLookupMetadata(&(map->web.metadata), "CO", "updatesequence");
   if (params->updatesequence != NULL) {
     i = msOWSNegotiateUpdateSequence(params->updatesequence, updatesequence);
     if (i == 0) { /* current */
-      msSetError(MS_WCSERR, "UPDATESEQUENCE parameter (%s) is equal to server (%s)",
-                 "msWCSGetCapabilities20()", params->updatesequence, updatesequence);
+      msSetError(
+          MS_WCSERR, "UPDATESEQUENCE parameter (%s) is equal to server (%s)",
+          "msWCSGetCapabilities20()", params->updatesequence, updatesequence);
       xmlFreeDoc(psDoc);
       return msWCSException(map, "CurrentUpdateSequence", "updatesequence",
                             params->version);
     }
     if (i > 0) { /* invalid */
-      msSetError(MS_WCSERR, "UPDATESEQUENCE parameter (%s) is higher than server (%s)",
-                 "msWCSGetCapabilities20()", params->updatesequence, updatesequence);
+      msSetError(
+          MS_WCSERR, "UPDATESEQUENCE parameter (%s) is higher than server (%s)",
+          "msWCSGetCapabilities20()", params->updatesequence, updatesequence);
       xmlFreeDoc(psDoc);
       return msWCSException(map, "InvalidUpdateSequence", "updatesequence",
                             params->version);
     }
   }
-  if(updatesequence != NULL) {
+  if (updatesequence != NULL) {
     xmlNewProp(psRootNode, BAD_CAST "updateSequence", BAD_CAST updatesequence);
   }
 
   /* -------------------------------------------------------------------- */
   /*      Service identification.                                         */
   /* -------------------------------------------------------------------- */
-  if ( MS_WCS_20_CAPABILITIES_INCLUDE_SECTION(params, "ServiceIdentification") ) {
-    psNode = xmlAddChild(psRootNode, msOWSCommonServiceIdentification(
-                           psOwsNs, map, "OGC WCS", "2.0.1,1.1.1,1.0.0", "CO", validated_language));
+  if (MS_WCS_20_CAPABILITIES_INCLUDE_SECTION(params, "ServiceIdentification")) {
+    psNode = xmlAddChild(
+        psRootNode, msOWSCommonServiceIdentification(psOwsNs, map, "OGC WCS",
+                                                     "2.0.1,1.1.1,1.0.0", "CO",
+                                                     validated_language));
     msWCSGetCapabilities20_CreateProfiles(map, psNode, psOwsNs);
   }
 
   /* Service Provider */
-  if ( MS_WCS_20_CAPABILITIES_INCLUDE_SECTION(params, "ServiceProvider") ) {
+  if (MS_WCS_20_CAPABILITIES_INCLUDE_SECTION(params, "ServiceProvider")) {
     xmlAddChild(psRootNode,
-                msOWSCommonServiceProvider(psOwsNs, psXLinkNs, map, "CO", validated_language));
+                msOWSCommonServiceProvider(psOwsNs, psXLinkNs, map, "CO",
+                                           validated_language));
   }
 
   /* -------------------------------------------------------------------- */
   /*      Operations metadata.                                            */
   /* -------------------------------------------------------------------- */
-  if ( MS_WCS_20_CAPABILITIES_INCLUDE_SECTION(params, "OperationsMetadata") ) {
-    if ((script_url = msOWSGetOnlineResource(map, "CO", "onlineresource", req)) == NULL
-        || (script_url_encoded = msEncodeHTMLEntities(script_url)) == NULL) {
+  if (MS_WCS_20_CAPABILITIES_INCLUDE_SECTION(params, "OperationsMetadata")) {
+    if ((script_url = msOWSGetOnlineResource(map, "CO", "onlineresource",
+                                             req)) == NULL ||
+        (script_url_encoded = msEncodeHTMLEntities(script_url)) == NULL) {
       xmlFreeDoc(psDoc);
       msSetError(MS_WCSERR, "Server URL not found", "msWCSGetCapabilities20()");
-      return msWCSException(map, "NoApplicableCode", "mapserv", params->version);
+      return msWCSException(map, "NoApplicableCode", "mapserv",
+                            params->version);
     }
     free(script_url);
 
-    psOperationsNode = xmlAddChild(psRootNode,msOWSCommonOperationsMetadata(psOwsNs));
+    psOperationsNode =
+        xmlAddChild(psRootNode, msOWSCommonOperationsMetadata(psOwsNs));
 
     /* -------------------------------------------------------------------- */
     /*      GetCapabilities - add Sections and AcceptVersions?              */
     /* -------------------------------------------------------------------- */
     psNode = msOWSCommonOperationsMetadataOperation(
-               psOwsNs, psXLinkNs,
-               "GetCapabilities", OWS_METHOD_GETPOST, script_url_encoded);
+        psOwsNs, psXLinkNs, "GetCapabilities", OWS_METHOD_GETPOST,
+        script_url_encoded);
 
     xmlAddChild(psNode->last->last->last,
-                msOWSCommonOperationsMetadataDomainType(OWS_2_0_0, psOwsNs, "Constraint",
-                    "PostEncoding", "XML"));
+                msOWSCommonOperationsMetadataDomainType(
+                    OWS_2_0_0, psOwsNs, "Constraint", "PostEncoding", "XML"));
     xmlAddChild(psOperationsNode, psNode);
 
     /* -------------------------------------------------------------------- */
@@ -3418,11 +3570,11 @@ int msWCSGetCapabilities20(mapObj *map,
     /* -------------------------------------------------------------------- */
     if (msOWSRequestIsEnabled(map, NULL, "C", "DescribeCoverage", MS_FALSE)) {
       psNode = msOWSCommonOperationsMetadataOperation(
-                 psOwsNs, psXLinkNs,
-                 "DescribeCoverage", OWS_METHOD_GETPOST, script_url_encoded);
+          psOwsNs, psXLinkNs, "DescribeCoverage", OWS_METHOD_GETPOST,
+          script_url_encoded);
       xmlAddChild(psNode->last->last->last,
-                  msOWSCommonOperationsMetadataDomainType(OWS_2_0_0, psOwsNs, "Constraint",
-                      "PostEncoding", "XML"));
+                  msOWSCommonOperationsMetadataDomainType(
+                      OWS_2_0_0, psOwsNs, "Constraint", "PostEncoding", "XML"));
       xmlAddChild(psOperationsNode, psNode);
     }
 
@@ -3431,68 +3583,73 @@ int msWCSGetCapabilities20(mapObj *map,
     /* -------------------------------------------------------------------- */
     if (msOWSRequestIsEnabled(map, NULL, "C", "GetCoverage", MS_FALSE)) {
       psNode = msOWSCommonOperationsMetadataOperation(
-                 psOwsNs, psXLinkNs,
-                 "GetCoverage", OWS_METHOD_GETPOST, script_url_encoded);
+          psOwsNs, psXLinkNs, "GetCoverage", OWS_METHOD_GETPOST,
+          script_url_encoded);
 
       xmlAddChild(psNode->last->last->last,
-                  msOWSCommonOperationsMetadataDomainType(OWS_2_0_0, psOwsNs, "Constraint",
-                      "PostEncoding", "XML"));
+                  msOWSCommonOperationsMetadataDomainType(
+                      OWS_2_0_0, psOwsNs, "Constraint", "PostEncoding", "XML"));
       xmlAddChild(psOperationsNode, psNode);
     }
     msFree(script_url_encoded);
 
-
     /* -------------------------------------------------------------------- */
     /*      Extended Capabilities for inspire                               */
     /* -------------------------------------------------------------------- */
 
     if (inspire_capabilities) {
-      msIOContext* old_context;
-      msIOContext* new_context;
-      msIOBuffer* buffer;
+      msIOContext *old_context;
+      msIOContext *new_context;
+      msIOBuffer *buffer;
 
       xmlNodePtr pRoot;
       xmlNodePtr pOWSExtendedCapabilities;
       xmlNodePtr pDlsExtendedCapabilities;
       xmlNodePtr pChild;
 
-      xmlNsPtr psInspireCommonNs = xmlSearchNs( psDoc, psRootNode, BAD_CAST MS_INSPIRE_COMMON_NAMESPACE_PREFIX );
-      xmlNsPtr psInspireDlsNs = xmlSearchNs( psDoc, psRootNode, BAD_CAST MS_INSPIRE_DLS_NAMESPACE_PREFIX );
-
+      xmlNsPtr psInspireCommonNs = xmlSearchNs(
+          psDoc, psRootNode, BAD_CAST MS_INSPIRE_COMMON_NAMESPACE_PREFIX);
+      xmlNsPtr psInspireDlsNs = xmlSearchNs(
+          psDoc, psRootNode, BAD_CAST MS_INSPIRE_DLS_NAMESPACE_PREFIX);
 
       old_context = msIO_pushStdoutToBufferAndGetOldContext();
-      msOWSPrintInspireCommonExtendedCapabilities(stdout, map, "CO", OWS_WARN,
-                                                  "foo",
-                                                  "xmlns:" MS_INSPIRE_COMMON_NAMESPACE_PREFIX "=\"" MS_INSPIRE_COMMON_NAMESPACE_URI "\" "
-                                                  "xmlns:" MS_INSPIRE_DLS_NAMESPACE_PREFIX "=\"" MS_INSPIRE_DLS_NAMESPACE_URI "\" "
-                                                  "xmlns:xsi=\"" MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI "\"", validated_language, OWS_WCS);
+      msOWSPrintInspireCommonExtendedCapabilities(
+          stdout, map, "CO", OWS_WARN, "foo",
+          "xmlns:" MS_INSPIRE_COMMON_NAMESPACE_PREFIX
+          "=\"" MS_INSPIRE_COMMON_NAMESPACE_URI "\" "
+          "xmlns:" MS_INSPIRE_DLS_NAMESPACE_PREFIX
+          "=\"" MS_INSPIRE_DLS_NAMESPACE_URI "\" "
+          "xmlns:xsi=\"" MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI "\"",
+          validated_language, OWS_WCS);
 
       new_context = msIO_getHandler(stdout);
-      buffer = (msIOBuffer *) new_context->cbData;
+      buffer = (msIOBuffer *)new_context->cbData;
 
       /* Remove spaces between > and < to get properly indented result */
-      msXMLStripIndentation( (char*) buffer->data );
+      msXMLStripIndentation((char *)buffer->data);
 
       pInspireTmpDoc = xmlParseDoc((const xmlChar *)buffer->data);
       pRoot = xmlDocGetRootElement(pInspireTmpDoc);
       xmlReconciliateNs(psDoc, pRoot);
 
-      pOWSExtendedCapabilities = xmlNewNode(psOwsNs, BAD_CAST "ExtendedCapabilities");
+      pOWSExtendedCapabilities =
+          xmlNewNode(psOwsNs, BAD_CAST "ExtendedCapabilities");
       xmlAddChild(psOperationsNode, pOWSExtendedCapabilities);
 
-      pDlsExtendedCapabilities = xmlNewNode(psInspireDlsNs, BAD_CAST "ExtendedCapabilities");
+      pDlsExtendedCapabilities =
+          xmlNewNode(psInspireDlsNs, BAD_CAST "ExtendedCapabilities");
       xmlAddChild(pOWSExtendedCapabilities, pDlsExtendedCapabilities);
 
       pChild = pRoot->children;
-      while(pChild != NULL)
-      {
-          xmlNodePtr pNext = pChild->next;
-          xmlUnlinkNode(pChild);
-          xmlAddChild(pDlsExtendedCapabilities, pChild);
-          pChild = pNext;
+      while (pChild != NULL) {
+        xmlNodePtr pNext = pChild->next;
+        xmlUnlinkNode(pChild);
+        xmlAddChild(pDlsExtendedCapabilities, pChild);
+        pChild = pNext;
       }
 
-      msWCSAddInspireDSID20(map, psInspireDlsNs, psInspireCommonNs, pDlsExtendedCapabilities);
+      msWCSAddInspireDSID20(map, psInspireDlsNs, psInspireCommonNs,
+                            pDlsExtendedCapabilities);
 
       msIO_restoreOldStdoutContext(old_context);
     }
@@ -3502,7 +3659,7 @@ int msWCSGetCapabilities20(mapObj *map,
   /*      Service metadata.                                               */
   /* -------------------------------------------------------------------- */
 
-  if ( MS_WCS_20_CAPABILITIES_INCLUDE_SECTION(params, "ServiceMetadata") ) {
+  if (MS_WCS_20_CAPABILITIES_INCLUDE_SECTION(params, "ServiceMetadata")) {
     xmlNodePtr psExtensionNode = NULL;
     psNode = xmlNewChild(psRootNode, psWcsNs, BAD_CAST "ServiceMetadata", NULL);
 
@@ -3518,12 +3675,13 @@ int msWCSGetCapabilities20(mapObj *map,
     /* interpolations supported */
     {
       /* TODO: use URIs/URLs once they are specified */
-      const char * const interpolation_methods[] = {"NEAREST", "AVERAGE", "BILINEAR"};
+      const char *const interpolation_methods[] = {"NEAREST", "AVERAGE",
+                                                   "BILINEAR"};
       int i;
       xmlNodePtr imNode = xmlNewChild(psExtensionNode, psIntNs,
                                       BAD_CAST "InterpolationMetadata", NULL);
 
-      for (i=0; i < 3; ++i) {
+      for (i = 0; i < 3; ++i) {
         xmlNewChild(imNode, psIntNs, BAD_CAST "InterpolationSupported",
                     BAD_CAST interpolation_methods[i]);
       }
@@ -3532,12 +3690,11 @@ int msWCSGetCapabilities20(mapObj *map,
     /* Report the supported CRSs */
     {
       char *crs_list = NULL;
-      xmlNodePtr crsMetadataNode = xmlNewChild(psExtensionNode, psCrsNs,
-                                               BAD_CAST "CrsMetadata", NULL);
+      xmlNodePtr crsMetadataNode =
+          xmlNewChild(psExtensionNode, psCrsNs, BAD_CAST "CrsMetadata", NULL);
 
-      if((crs_list = msOWSGetProjURI(&(map->projection),
-                                        &(map->web.metadata),
-                                        "CO", MS_FALSE)) != NULL ) {
+      if ((crs_list = msOWSGetProjURI(&(map->projection), &(map->web.metadata),
+                                      "CO", MS_FALSE)) != NULL) {
         msLibXml2GenerateList(crsMetadataNode, psCrsNs, "crsSupported",
                               crs_list, ' ');
         msFree(crs_list);
@@ -3550,27 +3707,27 @@ int msWCSGetCapabilities20(mapObj *map,
   /* -------------------------------------------------------------------- */
   /*      Contents section.                                               */
   /* -------------------------------------------------------------------- */
-  if ( MS_WCS_20_CAPABILITIES_INCLUDE_SECTION(params, "Contents") ) {
-    psNode = xmlNewChild( psRootNode, psWcsNs, BAD_CAST "Contents", NULL );
+  if (MS_WCS_20_CAPABILITIES_INCLUDE_SECTION(params, "Contents")) {
+    psNode = xmlNewChild(psRootNode, psWcsNs, BAD_CAST "Contents", NULL);
 
-    if(ows_request->numlayers == 0) {
-      xmlAddChild(psNode,
-                  xmlNewComment(BAD_CAST("WARNING: No WCS layers are enabled. "
-                                         "Check wcs/ows_enable_request settings.")));
+    if (ows_request->numlayers == 0) {
+      xmlAddChild(psNode, xmlNewComment(BAD_CAST(
+                              "WARNING: No WCS layers are enabled. "
+                              "Check wcs/ows_enable_request settings.")));
     } else {
-      for(i = 0; i < map->numlayers; ++i) {
+      for (i = 0; i < map->numlayers; ++i) {
         layerObj *layer = map->layers[i];
-        int       status;
+        int status;
 
-        if(!msWCSIsLayerSupported(layer))
+        if (!msWCSIsLayerSupported(layer))
           continue;
 
-        if (!msIntegerInArray(layer->index, ows_request->enabled_layers, ows_request->numlayers))
+        if (!msIntegerInArray(layer->index, ows_request->enabled_layers,
+                              ows_request->numlayers))
           continue;
 
-        status = msWCSGetCapabilities20_CoverageSummary(
-                   psDoc, psNode, layer );
-        if(status != MS_SUCCESS) {
+        status = msWCSGetCapabilities20_CoverageSummary(psDoc, psNode, layer);
+        if (status != MS_SUCCESS) {
           msFree(validated_language);
           xmlFreeDoc(psDoc);
           xmlCleanupParser();
@@ -3585,7 +3742,7 @@ int msWCSGetCapabilities20(mapObj *map,
   msWCSWriteDocument20(psDoc);
   msFree(validated_language);
   xmlFreeDoc(psDoc);
-  if( pInspireTmpDoc )
+  if (pInspireTmpDoc)
     xmlFreeDoc(pInspireTmpDoc);
   xmlCleanupParser();
   return MS_SUCCESS;
@@ -3598,35 +3755,40 @@ int msWCSGetCapabilities20(mapObj *map,
 /*      major sections: BoundedBy, DomainSet and RangeType.             */
 /************************************************************************/
 
-static int msWCSDescribeCoverage20_CoverageDescription(
-    layerObj *layer, xmlDocPtr psDoc, xmlNodePtr psRootNode )
-{
+static int msWCSDescribeCoverage20_CoverageDescription(layerObj *layer,
+                                                       xmlDocPtr psDoc,
+                                                       xmlNodePtr psRootNode) {
   int status, swapAxes;
   wcs20coverageMetadataObj cm;
   xmlNodePtr psCD;
   xmlNsPtr psWcsNs, psGmlNs, psGmlcovNs, psSweNs, psXLinkNs;
   psWcsNs = psGmlNs = psGmlcovNs = psSweNs = psXLinkNs = NULL;
 
-  psWcsNs    = xmlSearchNs(psDoc, xmlDocGetRootElement(psDoc), BAD_CAST MS_OWSCOMMON_WCS_NAMESPACE_PREFIX);
-  psGmlNs    = xmlSearchNs(psDoc, xmlDocGetRootElement(psDoc), BAD_CAST MS_OWSCOMMON_GML_NAMESPACE_PREFIX);
-  psGmlcovNs = xmlSearchNs(psDoc, xmlDocGetRootElement(psDoc), BAD_CAST MS_OWSCOMMON_GMLCOV_NAMESPACE_PREFIX);
-  psSweNs    = xmlSearchNs(psDoc, xmlDocGetRootElement(psDoc), BAD_CAST MS_OWSCOMMON_SWE_NAMESPACE_PREFIX);
-  psXLinkNs  = xmlSearchNs(psDoc, xmlDocGetRootElement(psDoc), BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_PREFIX);
+  psWcsNs = xmlSearchNs(psDoc, xmlDocGetRootElement(psDoc),
+                        BAD_CAST MS_OWSCOMMON_WCS_NAMESPACE_PREFIX);
+  psGmlNs = xmlSearchNs(psDoc, xmlDocGetRootElement(psDoc),
+                        BAD_CAST MS_OWSCOMMON_GML_NAMESPACE_PREFIX);
+  psGmlcovNs = xmlSearchNs(psDoc, xmlDocGetRootElement(psDoc),
+                           BAD_CAST MS_OWSCOMMON_GMLCOV_NAMESPACE_PREFIX);
+  psSweNs = xmlSearchNs(psDoc, xmlDocGetRootElement(psDoc),
+                        BAD_CAST MS_OWSCOMMON_SWE_NAMESPACE_PREFIX);
+  psXLinkNs = xmlSearchNs(psDoc, xmlDocGetRootElement(psDoc),
+                          BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_PREFIX);
 
   /* -------------------------------------------------------------------- */
   /*      Verify layer is processable.                                    */
   /* -------------------------------------------------------------------- */
-  if( msCheckParentPointer(layer->map,"map") == MS_FAILURE )
+  if (msCheckParentPointer(layer->map, "map") == MS_FAILURE)
     return MS_FAILURE;
 
-  if(!msWCSIsLayerSupported(layer))
+  if (!msWCSIsLayerSupported(layer))
     return MS_SUCCESS;
 
   /* -------------------------------------------------------------------- */
   /*      Setup coverage metadata.                                        */
   /* -------------------------------------------------------------------- */
   status = msWCSGetCoverageMetadata20(layer, &cm);
-  if(status != MS_SUCCESS)
+  if (status != MS_SUCCESS)
     return status;
 
   swapAxes = msWCSSwapAxes20(cm.srs_uri);
@@ -3637,20 +3799,22 @@ static int msWCSDescribeCoverage20_Cover
   /* -------------------------------------------------------------------- */
   /*      Create CoverageDescription node.                                */
   /* -------------------------------------------------------------------- */
-  psCD = xmlNewChild( psRootNode, psWcsNs, BAD_CAST "CoverageDescription", NULL );
+  psCD = xmlNewChild(psRootNode, psWcsNs, BAD_CAST "CoverageDescription", NULL);
   xmlNewNsProp(psCD, psGmlNs, BAD_CAST "id", BAD_CAST layer->name);
 
   /* -------------------------------------------------------------------- */
   /*      gml:boundedBy                                                   */
   /* -------------------------------------------------------------------- */
-  msWCSCommon20_CreateBoundedBy(&cm, psGmlNs, psCD, &(layer->projection), swapAxes);
+  msWCSCommon20_CreateBoundedBy(&cm, psGmlNs, psCD, &(layer->projection),
+                                swapAxes);
 
   xmlNewChild(psCD, psWcsNs, BAD_CAST "CoverageId", BAD_CAST layer->name);
 
   /* -------------------------------------------------------------------- */
   /*      gml:domainSet                                                   */
   /* -------------------------------------------------------------------- */
-  msWCSCommon20_CreateDomainSet(layer, &cm, psGmlNs, psCD, &(layer->projection), swapAxes);
+  msWCSCommon20_CreateDomainSet(layer, &cm, psGmlNs, psCD, &(layer->projection),
+                                swapAxes);
 
   /* -------------------------------------------------------------------- */
   /*      gmlcov:rangeType                                                */
@@ -3663,8 +3827,9 @@ static int msWCSDescribeCoverage20_Cover
   {
     xmlNodePtr psSP;
 
-    psSP = xmlNewChild( psCD, psWcsNs, BAD_CAST "ServiceParameters", NULL);
-    xmlNewChild(psSP, psWcsNs, BAD_CAST "CoverageSubtype", BAD_CAST "RectifiedGridCoverage");
+    psSP = xmlNewChild(psCD, psWcsNs, BAD_CAST "ServiceParameters", NULL);
+    xmlNewChild(psSP, psWcsNs, BAD_CAST "CoverageSubtype",
+                BAD_CAST "RectifiedGridCoverage");
 
     /* -------------------------------------------------------------------- */
     /*      SupportedCRS                                                    */
@@ -3678,13 +3843,11 @@ static int msWCSDescribeCoverage20_Cover
                                     BAD_CAST "SupportedCRSs", NULL);
 
       if ((owned_value = msOWSGetProjURI(&(layer->projection),
-                                         &(layer->metadata), "CO", MS_FALSE)) != NULL)
-      { }
-      else if ((owned_value = msOWSGetProjURI(&(layer->map->projection),
-                                              &(layer->map->web.metadata), "CO", MS_FALSE)) != NULL)
-      { }
-      else {
-        msDebug("missing required information, no SRSs defined.\n");
+                                         &(layer->metadata), "CO", MS_FALSE)) !=
+    NULL) { } else if ((owned_value = msOWSGetProjURI(&(layer->map->projection),
+                                              &(layer->map->web.metadata), "CO",
+    MS_FALSE)) != NULL) { } else { msDebug("missing required information, no
+    SRSs defined.\n");
       }
 
       if (owned_value != NULL && strlen(owned_value) > 0) {
@@ -3718,13 +3881,11 @@ static int msWCSDescribeCoverage20_Cover
       msFree(format_list);
     }*/
 
-
     /* -------------------------------------------------------------------- */
     /*      nativeFormat                                                    */
     /* -------------------------------------------------------------------- */
-    xmlNewChild(psSP, psWcsNs,
-                BAD_CAST "nativeFormat", BAD_CAST (cm.native_format ?
-                    cm.native_format : ""));
+    xmlNewChild(psSP, psWcsNs, BAD_CAST "nativeFormat",
+                BAD_CAST(cm.native_format ? cm.native_format : ""));
 
     if (!cm.native_format) {
       msDebug("msWCSDescribeCoverage20_CoverageDescription(): "
@@ -3746,8 +3907,8 @@ static int msWCSDescribeCoverage20_Cover
 /*      is written on the stream.                                       */
 /************************************************************************/
 
-int msWCSDescribeCoverage20(mapObj *map, wcs20ParamsObjPtr params, owsRequestObj *ows_request)
-{
+int msWCSDescribeCoverage20(mapObj *map, wcs20ParamsObjPtr params,
+                            owsRequestObj *ows_request) {
   xmlDocPtr psDoc = NULL; /* document pointer */
   xmlNodePtr psRootNode;
   xmlNsPtr psWcsNs = NULL;
@@ -3770,23 +3931,27 @@ int msWCSDescribeCoverage20(mapObj *map,
     /* for each given ID in the ID-list */
     for (j = 0; params->ids[j]; j++) {
       i = msGetLayerIndex(map, params->ids[j]);
-      if (i == -1 || (!msIntegerInArray(GET_LAYER(map, i)->index, ows_request->enabled_layers, ows_request->numlayers)) ) {
+      if (i == -1 || (!msIntegerInArray(GET_LAYER(map, i)->index,
+                                        ows_request->enabled_layers,
+                                        ows_request->numlayers))) {
         msSetError(MS_WCSERR, "Unknown coverage: (%s)",
                    "msWCSDescribeCoverage20()", params->ids[j]);
         return msWCSException(map, "NoSuchCoverage", "coverage",
                               params->version);
       }
       /* create coverage description for the specified layer */
-      if(msWCSDescribeCoverage20_CoverageDescription((GET_LAYER(map, i)),
-          psDoc, psRootNode) == MS_FAILURE) {
-        msSetError(MS_WCSERR, "Error retrieving coverage description.", "msWCSDescribeCoverage20()");
+      if (msWCSDescribeCoverage20_CoverageDescription(
+              (GET_LAYER(map, i)), psDoc, psRootNode) == MS_FAILURE) {
+        msSetError(MS_WCSERR, "Error retrieving coverage description.",
+                   "msWCSDescribeCoverage20()");
         return msWCSException(map, "MissingParameterValue", "coverage",
                               params->version);
       }
     }
   } else {
     /* Throw error, since IDs are mandatory */
-    msSetError(MS_WCSERR, "Missing COVERAGEID parameter.", "msWCSDescribeCoverage20()");
+    msSetError(MS_WCSERR, "Missing COVERAGEID parameter.",
+               "msWCSDescribeCoverage20()");
     return msWCSException(map, "MissingParameterValue", "coverage",
                           params->version);
   }
@@ -3810,14 +3975,14 @@ int msWCSDescribeCoverage20(mapObj *map,
 /*      is found out.                                                   */
 /************************************************************************/
 
-static int msWCSGetCoverage20_FinalizeParamsObj(wcs20ParamsObjPtr params, wcs20AxisObjPtr *axes)
-{
+static int msWCSGetCoverage20_FinalizeParamsObj(wcs20ParamsObjPtr params,
+                                                wcs20AxisObjPtr *axes) {
   char *crs = NULL;
   int have_scale, have_size, have_resolution;
   int have_global_scale = (params->scale != MS_WCS20_UNBOUNDED) ? 1 : 0;
 
   if (axes[0] != NULL) {
-    if(axes[0]->subset != NULL) {
+    if (axes[0]->subset != NULL) {
       msDebug("Subset for X-axis found: %s\n", axes[0]->subset->axis);
       if (!axes[0]->subset->min.unbounded)
         params->bbox.minx = axes[0]->subset->min.scalar;
@@ -3829,7 +3994,7 @@ static int msWCSGetCoverage20_FinalizePa
     params->resolutionX = axes[0]->resolution;
     params->scaleX = axes[0]->scale;
 
-    if(axes[0]->resolutionUOM != NULL) {
+    if (axes[0]->resolutionUOM != NULL) {
       params->resolutionUnits = msStrdup(axes[0]->resolutionUOM);
     }
 
@@ -3838,23 +4003,26 @@ static int msWCSGetCoverage20_FinalizePa
     have_resolution = (params->resolutionX != MS_WCS20_UNBOUNDED) ? 1 : 0;
 
     if ((have_global_scale + have_scale + have_size + have_resolution) > 1) {
-      msSetError(MS_WCSERR, "Axis '%s' defines scale, size and/or resolution multiple times.",
-                 "msWCSGetCoverage20_FinalizeParamsObj()", axes[0]->name);
+      msSetError(
+          MS_WCSERR,
+          "Axis '%s' defines scale, size and/or resolution multiple times.",
+          "msWCSGetCoverage20_FinalizeParamsObj()", axes[0]->name);
       return MS_FAILURE;
     }
   }
 
   if (axes[1] != NULL) {
-    if(axes[1]->subset != NULL) {
+    if (axes[1]->subset != NULL) {
       msDebug("Subset for Y-axis found: %s\n", axes[1]->subset->axis);
       if (!axes[1]->subset->min.unbounded)
         params->bbox.miny = axes[1]->subset->min.scalar;
       if (!axes[1]->subset->max.unbounded)
         params->bbox.maxy = axes[1]->subset->max.scalar;
-      if(crs != NULL && axes[0] != NULL && axes[0]->subset!= NULL) {
-        if(!EQUAL(crs, axes[1]->subset->crs)) {
+      if (crs != NULL && axes[0] != NULL && axes[0]->subset != NULL) {
+        if (!EQUAL(crs, axes[1]->subset->crs)) {
           msSetError(MS_WCSERR, "CRS for axis %s and axis %s are not the same.",
-                     "msWCSGetCoverage20_FinalizeParamsObj()", axes[0]->name, axes[1]->name);
+                     "msWCSGetCoverage20_FinalizeParamsObj()", axes[0]->name,
+                     axes[1]->name);
           return MS_FAILURE;
         }
       } else {
@@ -3865,13 +4033,16 @@ static int msWCSGetCoverage20_FinalizePa
     params->resolutionY = axes[1]->resolution;
     params->scaleY = axes[1]->scale;
 
-    if(params->resolutionUnits == NULL && axes[1]->resolutionUOM != NULL) {
+    if (params->resolutionUnits == NULL && axes[1]->resolutionUOM != NULL) {
       params->resolutionUnits = msStrdup(axes[1]->resolutionUOM);
-    } else if(params->resolutionUnits != NULL && axes[1]->resolutionUOM != NULL
-              && !EQUAL(params->resolutionUnits, axes[1]->resolutionUOM)) {
-      msSetError(MS_WCSERR, "The units of measure of the resolution for"
+    } else if (params->resolutionUnits != NULL &&
+               axes[1]->resolutionUOM != NULL &&
+               !EQUAL(params->resolutionUnits, axes[1]->resolutionUOM)) {
+      msSetError(MS_WCSERR,
+                 "The units of measure of the resolution for"
                  "axis %s and axis %s are not the same.",
-                 "msWCSGetCoverage20_FinalizeParamsObj()", axes[0]->name, axes[1]->name);
+                 "msWCSGetCoverage20_FinalizeParamsObj()", axes[0]->name,
+                 axes[1]->name);
       return MS_FAILURE;
     }
 
@@ -3880,8 +4051,10 @@ static int msWCSGetCoverage20_FinalizePa
     have_resolution = (params->resolutionY != MS_WCS20_UNBOUNDED) ? 1 : 0;
 
     if ((have_global_scale + have_scale + have_size + have_resolution) > 1) {
-      msSetError(MS_WCSERR, "Axis '%s' defines scale, size and/or resolution multiple times.",
-                 "msWCSGetCoverage20_FinalizeParamsObj()", axes[1]->name);
+      msSetError(
+          MS_WCSERR,
+          "Axis '%s' defines scale, size and/or resolution multiple times.",
+          "msWCSGetCoverage20_FinalizeParamsObj()", axes[1]->name);
       return MS_FAILURE;
     }
   }
@@ -3892,18 +4065,17 @@ static int msWCSGetCoverage20_FinalizePa
   }
 
   /* check if projections are equal */
-  if(crs != NULL) {
+  if (crs != NULL) {
     if (params->subsetcrs && !EQUAL(crs, params->subsetcrs)) {
       /* already set and not equal -> raise exception */
-      msSetError(MS_WCSERR, "SubsetCRS does not match the CRS of the axes: "
+      msSetError(MS_WCSERR,
+                 "SubsetCRS does not match the CRS of the axes: "
                  "'%s' != '%s'",
                  "msWCSCreateBoundingBox20()", params->subsetcrs, crs);
       return MS_FAILURE;
-    }
-    else if (params->subsetcrs) {
+    } else if (params->subsetcrs) {
       /* equal, and already set -> do nothing */
-    }
-    else {
+    } else {
       /* not yet globally set -> set it */
       params->subsetcrs = msStrdup(crs);
     }
@@ -3923,16 +4095,17 @@ static int msWCSGetCoverage20_FinalizePa
 /************************************************************************/
 
 static int msWCSGetCoverage20_GetBands(layerObj *layer,
-                                       wcs20ParamsObjPtr params, wcs20coverageMetadataObjPtr cm, char **bandlist)
-{
+                                       wcs20ParamsObjPtr params,
+                                       wcs20coverageMetadataObjPtr cm,
+                                       char **bandlist) {
   int maxlen, index;
   char *interval_stop;
   char **band_ids = NULL;
 
   /* if rangesubset parameter is not given, default to all bands */
-  if(NULL == params->range_subset) {
+  if (NULL == params->range_subset) {
     *bandlist = msStrdup("1");
-    for(unsigned i = 1; i < cm->numbands; ++i) {
+    for (unsigned i = 1; i < cm->numbands; ++i) {
       char strnumber[12];
       snprintf(strnumber, sizeof(strnumber), ",%d", i + 1);
       *bandlist = msStringConcatenate(*bandlist, strnumber);
@@ -3941,41 +4114,40 @@ static int msWCSGetCoverage20_GetBands(l
   }
 
   maxlen = cm->numbands * 4 * sizeof(char);
-  *bandlist = static_cast<char*>( msSmallCalloc(sizeof(char), maxlen));
+  *bandlist = static_cast<char *>(msSmallCalloc(sizeof(char), maxlen));
 
   /* Use WCS 2.0 metadata items in priority */
   {
-    char* tmp = msOWSGetEncodeMetadata(&layer->metadata,
-                               "CO", "band_names", NULL);
+    char *tmp =
+        msOWSGetEncodeMetadata(&layer->metadata, "CO", "band_names", NULL);
 
-    if( NULL == tmp ) {
+    if (NULL == tmp) {
       /* Otherwise default to WCS 1.x*/
-      tmp = msOWSGetEncodeMetadata(&layer->metadata,
-                     "CO", "rangeset_axes", NULL);
+      tmp =
+          msOWSGetEncodeMetadata(&layer->metadata, "CO", "rangeset_axes", NULL);
       /* "bands" has a special processing in WCS 1.0. See */
       /* msWCSSetDefaultBandsRangeSetInfo */
-      if( tmp != NULL && EQUAL(tmp, "bands") )
-      {
+      if (tmp != NULL && EQUAL(tmp, "bands")) {
         int num_band_names = cm->numbands;
-        band_ids = (char**) msSmallCalloc( sizeof(char*), (num_band_names + 1) );
-        for( int i = 0; i < num_band_names; i++ )
-        {
-            char szName[30];
-            snprintf(szName, sizeof(szName), "Band%d", i+1);
-            band_ids[i] = msStrdup(szName);
+        band_ids = (char **)msSmallCalloc(sizeof(char *), (num_band_names + 1));
+        for (int i = 0; i < num_band_names; i++) {
+          char szName[30];
+          snprintf(szName, sizeof(szName), "Band%d", i + 1);
+          band_ids[i] = msStrdup(szName);
         }
       }
     }
 
-    if(NULL != tmp && band_ids == NULL) {
+    if (NULL != tmp && band_ids == NULL) {
       band_ids = CSLTokenizeString2(tmp, " ", 0);
     }
     msFree(tmp);
   }
 
-  /* If we still don't have band names, use the band names from the coverage metadata */
+  /* If we still don't have band names, use the band names from the coverage
+   * metadata */
   if (band_ids == NULL) {
-    band_ids = (char**) CPLCalloc(sizeof(char*), (cm->numbands + 1));
+    band_ids = (char **)CPLCalloc(sizeof(char *), (cm->numbands + 1));
     for (unsigned i = 0; i < cm->numbands; ++i) {
       band_ids[i] = CPLStrdup(cm->bands[i].name);
     }
@@ -3983,7 +4155,7 @@ static int msWCSGetCoverage20_GetBands(l
 
   /* Iterate over all supplied range */
   const int count = CSLCount(params->range_subset);
-  for(int i = 0; i < count; ++i) {
+  for (int i = 0; i < count; ++i) {
     /* RangeInterval case: defined as "<start>:<stop>" */
     if ((interval_stop = strchr(params->range_subset[i], ':')) != NULL) {
       int start, stop;
@@ -3994,12 +4166,12 @@ static int msWCSGetCoverage20_GetBands(l
       if (msStringParseInteger(params->range_subset[i], &start) == MS_SUCCESS) {
       }
       /* get index of start clause, or raise an error if none was found */
-      else if ((start = CSLFindString(band_ids, params->range_subset[i])) != -1) {
+      else if ((start = CSLFindString(band_ids, params->range_subset[i])) !=
+               -1) {
         start += 1; /* adjust index, since GDAL bands start with index 1 */
-      }
-      else {
+      } else {
         msSetError(MS_WCSERR, "'%s' is not a valid band identifier.",
-               "msWCSGetCoverage20_GetBands()", params->range_subset[i]);
+                   "msWCSGetCoverage20_GetBands()", params->range_subset[i]);
         return MS_FAILURE;
       }
 
@@ -4009,28 +4181,28 @@ static int msWCSGetCoverage20_GetBands(l
       /* get index of stop clause, or raise an error if none was found */
       else if ((stop = CSLFindString(band_ids, interval_stop)) != -1) {
         stop += 1; /* adjust index, since GDAL bands start with index 1 */
-      }
-      else {
+      } else {
         msSetError(MS_WCSERR, "'%s' is not a valid band identifier.",
-               "msWCSGetCoverage20_GetBands()", interval_stop);
+                   "msWCSGetCoverage20_GetBands()", interval_stop);
         return MS_FAILURE;
       }
 
-      /* Check whether or not start and stop are different and stop is higher than start */
+      /* Check whether or not start and stop are different and stop is higher
+       * than start */
       if (stop <= start) {
         msSetError(MS_WCSERR, "Invalid range interval given.",
-               "msWCSGetCoverage20_GetBands()");
+                   "msWCSGetCoverage20_GetBands()");
         return MS_FAILURE;
       } else if (start < 1 || static_cast<unsigned>(stop) > cm->numbands) {
         msSetError(MS_WCSERR, "Band interval is out of the valid range: 1-%d",
-               "msWCSGetCoverage20_GetBands()", (int)cm->numbands);
+                   "msWCSGetCoverage20_GetBands()", (int)cm->numbands);
         return MS_FAILURE;
       }
 
       /* expand the interval to a list of indices and push them on the list */
       for (int j = start; j <= stop; ++j) {
-        char* tmp;
-        if(i != 0 || j != start) {
+        char *tmp;
+        if (i != 0 || j != start) {
           strlcat(*bandlist, ",", maxlen);
         }
         tmp = msIntToString(j);
@@ -4040,16 +4212,16 @@ static int msWCSGetCoverage20_GetBands(l
     }
     /* RangeComponent case */
     else {
-        if(i != 0) {
+      if (i != 0) {
         strlcat(*bandlist, ",", maxlen);
       }
 
       /* check if the string represents an integer */
-      if(msStringParseInteger(params->range_subset[i], &index) == MS_SUCCESS) {
-        char* tmp;
+      if (msStringParseInteger(params->range_subset[i], &index) == MS_SUCCESS) {
+        char *tmp;
         if (index < 1 || static_cast<unsigned>(index) > cm->numbands) {
           msSetError(MS_WCSERR, "Band index is out of the valid range: 1-%d",
-                 "msWCSGetCoverage20_GetBands()", (int)cm->numbands);
+                     "msWCSGetCoverage20_GetBands()", (int)cm->numbands);
           return MS_FAILURE;
         }
 
@@ -4061,12 +4233,11 @@ static int msWCSGetCoverage20_GetBands(l
 
       /* check if the string is equal to a band identifier    */
       /* if so, what is the index of the band                 */
-      if((index = CSLFindString(band_ids, params->range_subset[i])) != -1) {
-        char* tmp = msIntToString((int)index + 1);
+      if ((index = CSLFindString(band_ids, params->range_subset[i])) != -1) {
+        char *tmp = msIntToString((int)index + 1);
         strlcat(*bandlist, tmp, maxlen);
         msFree(tmp);
-      }
-      else {
+      } else {
         msSetError(MS_WCSERR, "'%s' is not a valid band identifier.",
                    "msWCSGetCoverage20_GetBands()", params->range_subset[i]);
         return MS_FAILURE;
@@ -4080,7 +4251,7 @@ static int msWCSGetCoverage20_GetBands(l
 
 /* Fixes CPLParseNameValue to allow ':' characters for namespaced keys */
 
-static const char * fixedCPLParseNameValue(const char* string, char **key) {
+static const char *fixedCPLParseNameValue(const char *string, char **key) {
   const char *value;
   size_t size;
   value = strchr(string, '=');
@@ -4091,7 +4262,7 @@ static const char * fixedCPLParseNameVal
   }
 
   size = value - string;
-  *key = static_cast<char*>(msSmallMalloc(size + 1));
+  *key = static_cast<char *>(msSmallMalloc(size + 1));
   strncpy(*key, string, size + 1);
   (*key)[size] = '\0';
   return value + 1;
@@ -4104,7 +4275,8 @@ static const char * fixedCPLParseNameVal
 /*      output format values.                                           */
 /************************************************************************/
 
-static int msWCSSetFormatParams20(outputFormatObj* format, char** format_options) {
+static int msWCSSetFormatParams20(outputFormatObj *format,
+                                  char **format_options) {
   /* currently geotiff only */
   char *format_option;
   int i = 0;
@@ -4125,8 +4297,7 @@ static int msWCSSetFormatParams20(output
       msSetError(MS_WCSERR, "Could not deduct the option key.",
                  "msWCSSetFormatParams20()");
       return MS_FAILURE;
-    }
-    else if (!value) {
+    } else if (!value) {
       msSetError(MS_WCSERR, "Missing value for parameter '%s'.",
                  "msWCSSetFormatParams20()", key);
       return MS_FAILURE;
@@ -4136,20 +4307,15 @@ static int msWCSSetFormatParams20(output
       /*COMPRESS=[JPEG/LZW/PACKBITS/DEFLATE/CCITTRLE/CCITTFAX3/CCITTFAX4/NONE]*/
       if (EQUAL(value, "None")) {
         msSetOutputFormatOption(format, "COMPRESS", "NONE");
-      }
-      else if (EQUAL(value, "PackBits")) {
+      } else if (EQUAL(value, "PackBits")) {
         msSetOutputFormatOption(format, "COMPRESS", "PACKBITS");
-      }
-      else if (EQUAL(value, "Deflate")) {
+      } else if (EQUAL(value, "Deflate")) {
         msSetOutputFormatOption(format, "COMPRESS", "DEFLATE");
-      }
-      else if (EQUAL(value, "Huffman")) {
+      } else if (EQUAL(value, "Huffman")) {
         msSetOutputFormatOption(format, "COMPRESS", "CCITTRLE");
-      }
-      else if (EQUAL(value, "LZW")) {
+      } else if (EQUAL(value, "LZW")) {
         msSetOutputFormatOption(format, "COMPRESS", "LZW");
-      }
-      else if (EQUAL(value, "JPEG")) {
+      } else if (EQUAL(value, "JPEG")) {
         msSetOutputFormatOption(format, "COMPRESS", "JPEG");
       }
       /* unsupported compression methods: CCITTFAX3/CCITTFAX4 */
@@ -4165,98 +4331,84 @@ static int msWCSSetFormatParams20(output
       /* JPEG_QUALITY=[1-100] */
       if (msStringParseInteger(value, &quality) != MS_SUCCESS) {
         msSetError(MS_WCSERR, "Could not parse jpeg_quality value.",
-                 "msWCSSetFormatParams20()");
+                   "msWCSSetFormatParams20()");
         return MS_FAILURE;
-      }
-      else if (quality < 1 || quality > 100) {
+      } else if (quality < 1 || quality > 100) {
         msSetError(MS_WCSERR, "Invalid jpeg_quality value '%d'.",
                    "msWCSSetFormatParams20()", quality);
         return MS_FAILURE;
       }
       msSetOutputFormatOption(format, "JPEG_QUALITY", value);
-    }
-    else if (EQUAL(key, "geotiff:predictor") && is_geotiff) {
+    } else if (EQUAL(key, "geotiff:predictor") && is_geotiff) {
       /* PREDICTOR=[None/Horizontal/FloatingPoint] */
       const char *predictor;
       if (EQUAL(value, "None") || EQUAL(value, "1")) {
         predictor = "1";
-      }
-      else if (EQUAL(value, "Horizontal") || EQUAL(value, "2")) {
+      } else if (EQUAL(value, "Horizontal") || EQUAL(value, "2")) {
         predictor = "2";
-      }
-      else if (EQUAL(value, "FloatingPoint") || EQUAL(value, "3")) {
+      } else if (EQUAL(value, "FloatingPoint") || EQUAL(value, "3")) {
         predictor = "3";
-      }
-      else {
+      } else {
         msSetError(MS_WCSERR, "Invalid predictor value '%s'.",
                    "msWCSSetFormatParams20()", value);
         return MS_FAILURE;
       }
       msSetOutputFormatOption(format, "PREDICTOR", predictor);
-    }
-    else if (EQUAL(key, "geotiff:interleave") && is_geotiff) {
+    } else if (EQUAL(key, "geotiff:interleave") && is_geotiff) {
       /* INTERLEAVE=[BAND,PIXEL] */
       if (EQUAL(value, "Band")) {
         msSetOutputFormatOption(format, "INTERLEAVE", "BAND");
-      }
-      else if (EQUAL(value, "Pixel")) {
+      } else if (EQUAL(value, "Pixel")) {
         msSetOutputFormatOption(format, "INTERLEAVE", "PIXEL");
-      }
-      else {
+      } else {
         msSetError(MS_WCSERR, "Interleave method '%s' not supported.",
                    "msWCSSetFormatParams20()", value);
         return MS_FAILURE;
       }
-    }
-    else if (EQUAL(key, "geotiff:tiling") && is_geotiff) {
+    } else if (EQUAL(key, "geotiff:tiling") && is_geotiff) {
       /* TILED=YES */
       if (EQUAL(value, "true")) {
         msSetOutputFormatOption(format, "TILED", "YES");
-      }
-      else if (EQUAL(value, "false")) {
+      } else if (EQUAL(value, "false")) {
         msSetOutputFormatOption(format, "TILED", "NO");
-      }
-      else {
+      } else {
         msSetError(MS_WCSERR, "Invalid boolean value '%s'.",
                    "msWCSSetFormatParams20()", value);
         return MS_FAILURE;
       }
-    }
-    else if (EQUAL(key, "geotiff:tileheight") && is_geotiff) {
+    } else if (EQUAL(key, "geotiff:tileheight") && is_geotiff) {
       /* BLOCKXSIZE=n */
       int tileheight;
 
       if (msStringParseInteger(value, &tileheight) != MS_SUCCESS) {
         msSetError(MS_WCSERR, "Could not parse tileheight value.",
-                 "msWCSSetFormatParams20()");
+                   "msWCSSetFormatParams20()");
         return MS_FAILURE;
-      }
-      else if (tileheight < 1 || tileheight % 16) {
-        msSetError(MS_WCSERR, "Invalid tileheight value '%d'. "
+      } else if (tileheight < 1 || tileheight % 16) {
+        msSetError(MS_WCSERR,
+                   "Invalid tileheight value '%d'. "
                    "Must be greater than 0 and dividable by 16.",
                    "msWCSSetFormatParams20()", tileheight);
         return MS_FAILURE;
       }
       msSetOutputFormatOption(format, "BLOCKXSIZE", value);
-    }
-    else if (EQUAL(key, "geotiff:tilewidth") && is_geotiff) {
+    } else if (EQUAL(key, "geotiff:tilewidth") && is_geotiff) {
       /* BLOCKYSIZE=n */
       int tilewidth;
 
       if (msStringParseInteger(value, &tilewidth) != MS_SUCCESS) {
         msSetError(MS_WCSERR, "Could not parse tilewidth value.",
-                 "msWCSSetFormatParams20()");
+                   "msWCSSetFormatParams20()");
         return MS_FAILURE;
-      }
-      else if (tilewidth < 1 || tilewidth % 16) {
-        msSetError(MS_WCSERR, "Invalid tilewidth value '%d'. "
+      } else if (tilewidth < 1 || tilewidth % 16) {
+        msSetError(MS_WCSERR,
+                   "Invalid tilewidth value '%d'. "
                    "Must be greater than 0 and dividable by 16.",
                    "msWCSSetFormatParams20()", tilewidth);
         return MS_FAILURE;
       }
       msSetOutputFormatOption(format, "BLOCKYSIZE", value);
-    }
-    else if (EQUALN(key, "geotiff:", 8)) {
+    } else if (EQUALN(key, "geotiff:", 8)) {
       msSetError(MS_WCSERR, "Unrecognized GeoTIFF parameter '%s'.",
                  "msWCSSetFormatParams20()", key);
       return MS_FAILURE;
@@ -4280,8 +4432,7 @@ static int msWCSSetFormatParams20(output
 /************************************************************************/
 
 int msWCSGetCoverage20(mapObj *map, cgiRequestObj *request,
-                       wcs20ParamsObjPtr params, owsRequestObj *ows_request)
-{
+                       wcs20ParamsObjPtr params, owsRequestObj *ows_request) {
   (void)request;
   layerObj *layer = NULL;
   wcs20coverageMetadataObj cm;
@@ -4293,7 +4444,7 @@ int msWCSGetCoverage20(mapObj *map, cgiR
 
   int status, i;
   double x_1, x_2, y_1, y_2;
-  char *coverageName, *bandlist=NULL, numbands[12];
+  char *coverageName, *bandlist = NULL, numbands[12];
 
   int doDrawRasterLayerDraw = MS_TRUE;
   GDALDatasetH hDS = NULL;
@@ -4317,25 +4468,27 @@ int msWCSGetCoverage20(mapObj *map, cgiR
 
   /* find the right layer */
   layer = NULL;
-  for(i = 0; i < map->numlayers; i++) {
-    coverageName = msOWSGetEncodeMetadata(&(GET_LAYER(map, i)->metadata),
-                                          "CO", "name",
-                                          GET_LAYER(map, i)->name);
+  for (i = 0; i < map->numlayers; i++) {
+    coverageName = msOWSGetEncodeMetadata(&(GET_LAYER(map, i)->metadata), "CO",
+                                          "name", GET_LAYER(map, i)->name);
     if (EQUAL(coverageName, params->ids[0]) &&
-        (msIntegerInArray(GET_LAYER(map, i)->index, ows_request->enabled_layers, ows_request->numlayers))) {
+        (msIntegerInArray(GET_LAYER(map, i)->index, ows_request->enabled_layers,
+                          ows_request->numlayers))) {
       layer = GET_LAYER(map, i);
-      i = map->numlayers; /* to exit loop don't use break, we want to free resources first */
+      i = map->numlayers; /* to exit loop don't use break, we want to free
+                             resources first */
     }
     msFree(coverageName);
   }
 
   /* throw exception if no Layer was found */
   if (layer == NULL) {
-    msSetError(MS_WCSERR,
-               "COVERAGEID=%s not found, not in supported layer list. A layer might be disabled for \
-this request. Check wcs/ows_enable_request settings.", "msWCSGetCoverage20()", params->ids[0]);
-    return msWCSException(map, "NoSuchCoverage", "coverageid",
-                          params->version);
+    msSetError(
+        MS_WCSERR,
+        "COVERAGEID=%s not found, not in supported layer list. A layer might be disabled for \
+this request. Check wcs/ows_enable_request settings.",
+        "msWCSGetCoverage20()", params->ids[0]);
+    return msWCSException(map, "NoSuchCoverage", "coverageid", params->version);
   }
   /* retrieve coverage metadata  */
   status = msWCSGetCoverageMetadata20(layer, &cm);
@@ -4363,86 +4516,84 @@ this request. Check wcs/ows_enable_reque
   if (msLoadProjectionString(&imageProj, cm.srs_epsg) == -1) {
     msFreeProjection(&imageProj);
     msWCSClearCoverageMetadata20(&cm);
-    msSetError(MS_WCSERR,
-               "Error loading CRS %s.",
-               "msWCSGetCoverage20()", cm.srs_epsg);
-    return msWCSException(map, "InvalidParameterValue",
-                          "projection", params->version);
+    msSetError(MS_WCSERR, "Error loading CRS %s.", "msWCSGetCoverage20()",
+               cm.srs_epsg);
+    return msWCSException(map, "InvalidParameterValue", "projection",
+                          params->version);
   }
 
   /* iterate over all subsets and check if they are valid*/
-  for(i = 0; i < params->numaxes; ++i) {
-    if(params->axes[i]->subset != NULL) {
-      if(params->axes[i]->subset->timeOrScalar == MS_WCS20_TIME_VALUE) {
+  for (i = 0; i < params->numaxes; ++i) {
+    if (params->axes[i]->subset != NULL) {
+      if (params->axes[i]->subset->timeOrScalar == MS_WCS20_TIME_VALUE) {
         msFreeProjection(&imageProj);
         msWCSClearCoverageMetadata20(&cm);
         msSetError(MS_WCSERR, "Time values for subsets are not supported. ",
                    "msWCSGetCoverage20()");
-        return msWCSException(map, "InvalidSubsetting", "subset", params->version);
+        return msWCSException(map, "InvalidSubsetting", "subset",
+                              params->version);
       }
-      if(params->axes[i]->subset->operation == MS_WCS20_SLICE) {
+      if (params->axes[i]->subset->operation == MS_WCS20_SLICE) {
         msFreeProjection(&imageProj);
         msWCSClearCoverageMetadata20(&cm);
         msSetError(MS_WCSERR, "Subset operation 'slice' is not supported.",
                    "msWCSGetCoverage20()");
-        return msWCSException(map, "InvalidSubsetting", "subset", params->version);
+        return msWCSException(map, "InvalidSubsetting", "subset",
+                              params->version);
       }
     }
   }
 
   {
     wcs20AxisObjPtr axes[2];
-    if(msWCSValidateAndFindAxes20(params, axes) == MS_FAILURE) {
+    if (msWCSValidateAndFindAxes20(params, axes) == MS_FAILURE) {
       msFreeProjection(&imageProj);
       msWCSClearCoverageMetadata20(&cm);
       return msWCSException(map, "InvalidAxisLabel", "subset", params->version);
     }
-    if(msWCSGetCoverage20_FinalizeParamsObj(params, axes) == MS_FAILURE) {
+    if (msWCSGetCoverage20_FinalizeParamsObj(params, axes) == MS_FAILURE) {
       msFreeProjection(&imageProj);
       msWCSClearCoverageMetadata20(&cm);
-      return msWCSException(map, "InvalidParameterValue", "extent", params->version);
+      return msWCSException(map, "InvalidParameterValue", "extent",
+                            params->version);
     }
   }
 
   subsets = params->bbox;
 
-  /* if no subsetCRS was specified use the coverages CRS 
+  /* if no subsetCRS was specified use the coverages CRS
      (Requirement 27 of the WCS 2.0 specification) */
   if (!params->subsetcrs) {
     params->subsetcrs = msStrdup(cm.srs_epsg);
   }
 
-  if(EQUAL(params->subsetcrs, "imageCRS")) {
+  if (EQUAL(params->subsetcrs, "imageCRS")) {
     /* subsets are in imageCRS; reproject them to real coordinates */
     rectObj orig_bbox = subsets;
 
     msFreeProjection(&(map->projection));
     map->projection = imageProj;
 
-    if(subsets.minx != -DBL_MAX || subsets.maxx != DBL_MAX) {
-      x_1 = cm.geotransform[0]
-            + orig_bbox.minx * cm.geotransform[1]
-            + orig_bbox.miny * cm.geotransform[2];
+    if (subsets.minx != -DBL_MAX || subsets.maxx != DBL_MAX) {
+      x_1 = cm.geotransform[0] + orig_bbox.minx * cm.geotransform[1] +
+            orig_bbox.miny * cm.geotransform[2];
       // below +1 look suspicious to me (E. Rouault) and probably mean that
       // there are still issues with pixel-center vs pixel-corner convention
       // The resolution computed on wcs_20_post_getcov_trim_x_y_both_1px
       // with that is 11, whereas it should be 10
-      x_2 = cm.geotransform[0]
-            + (orig_bbox.maxx+1) * cm.geotransform[1]
-            + (orig_bbox.maxy+1) * cm.geotransform[2];
+      x_2 = cm.geotransform[0] + (orig_bbox.maxx + 1) * cm.geotransform[1] +
+            (orig_bbox.maxy + 1) * cm.geotransform[2];
 
       subsets.minx = MS_MIN(x_1, x_2);
       subsets.maxx = MS_MAX(x_1, x_2);
     }
-    if(subsets.miny != -DBL_MAX || subsets.maxy != DBL_MAX) {
+    if (subsets.miny != -DBL_MAX || subsets.maxy != DBL_MAX) {
       // below +1 are suspicious. See bove comment in the minx/maxx cases
-      y_1 = cm.geotransform[3]
-            + (orig_bbox.maxx+1) * cm.geotransform[4]
-            + (orig_bbox.maxy+1) * cm.geotransform[5];
+      y_1 = cm.geotransform[3] + (orig_bbox.maxx + 1) * cm.geotransform[4] +
+            (orig_bbox.maxy + 1) * cm.geotransform[5];
       /*subsets.miny -= cm.geotransform[4]/2 + cm.geotransform[5]/2;*/
-      y_2 = cm.geotransform[3]
-            + orig_bbox.minx * cm.geotransform[4]
-            + orig_bbox.miny * cm.geotransform[5];
+      y_2 = cm.geotransform[3] + orig_bbox.minx * cm.geotransform[4] +
+            orig_bbox.miny * cm.geotransform[5];
 
       subsets.miny = MS_MIN(y_1, y_2);
       subsets.maxy = MS_MAX(y_1, y_2);
@@ -4453,18 +4604,17 @@ this request. Check wcs/ows_enable_reque
     /* if the subsets have a crs given, project the image extent to it */
     msInitProjection(&subsetProj);
     msProjectionInheritContextFrom(&subsetProj, &(layer->projection));
-    if(msLoadProjectionString(&subsetProj, params->subsetcrs) != MS_SUCCESS) {
+    if (msLoadProjectionString(&subsetProj, params->subsetcrs) != MS_SUCCESS) {
       msFreeProjection(&subsetProj);
       msFreeProjection(&imageProj);
       msWCSClearCoverageMetadata20(&cm);
-      msSetError(MS_WCSERR,
-                 "Error loading CRS %s.",
-                 "msWCSGetCoverage20()", params->subsetcrs);
-      return msWCSException(map, "InvalidParameterValue",
-                            "projection", params->version);
+      msSetError(MS_WCSERR, "Error loading CRS %s.", "msWCSGetCoverage20()",
+                 params->subsetcrs);
+      return msWCSException(map, "InvalidParameterValue", "projection",
+                            params->version);
     }
 
-    if(msProjectionsDiffer(&imageProj, &subsetProj)) {
+    if (msProjectionsDiffer(&imageProj, &subsetProj)) {
 
       /* Reprojection of source raster extent of (-180,-90,180,90) to any */
       /* projected CRS is going to exhibit strong anomalies. So instead */
@@ -4472,33 +4622,39 @@ this request. Check wcs/ows_enable_reque
       /* see how much the subset extent takes with respect to the source */
       /* raster extent. This is only used if output width and resolutionX (or */
       /* (height and resolutionY) are unknown. */
-      if( ((params->width == 0 && params->resolutionX == MS_WCS20_UNBOUNDED) ||
-           (params->height == 0 && params->resolutionY == MS_WCS20_UNBOUNDED)) &&
+      if (((params->width == 0 && params->resolutionX == MS_WCS20_UNBOUNDED) ||
+           (params->height == 0 &&
+            params->resolutionY == MS_WCS20_UNBOUNDED)) &&
           (msProjIsGeographicCRS(&imageProj) &&
            !msProjIsGeographicCRS(&subsetProj) &&
            fabs(layer->extent.minx - -180.0) < 1e-5 &&
            fabs(layer->extent.miny - -90.0) < 1e-5 &&
            fabs(layer->extent.maxx - 180.0) < 1e-5 &&
-           fabs(layer->extent.maxy - 90.0) < 1e-5) )
-      {
-          rectObj subsetInImageProj = subsets;
-          if( msProjectRect(&subsetProj, &imageProj, &(subsetInImageProj)) == MS_SUCCESS )
+           fabs(layer->extent.maxy - 90.0) < 1e-5)) {
+        rectObj subsetInImageProj = subsets;
+        if (msProjectRect(&subsetProj, &imageProj, &(subsetInImageProj)) ==
+            MS_SUCCESS) {
+          subsetInImageProj.minx =
+              MS_MAX(subsetInImageProj.minx, layer->extent.minx);
+          subsetInImageProj.miny =
+              MS_MAX(subsetInImageProj.miny, layer->extent.miny);
+          subsetInImageProj.maxx =
+              MS_MIN(subsetInImageProj.maxx, layer->extent.maxx);
+          subsetInImageProj.maxy =
+              MS_MIN(subsetInImageProj.maxy, layer->extent.maxy);
           {
-            subsetInImageProj.minx = MS_MAX(subsetInImageProj.minx, layer->extent.minx);
-            subsetInImageProj.miny = MS_MAX(subsetInImageProj.miny, layer->extent.miny);
-            subsetInImageProj.maxx = MS_MIN(subsetInImageProj.maxx, layer->extent.maxx);
-            subsetInImageProj.maxy = MS_MIN(subsetInImageProj.maxy, layer->extent.maxy);
-            {
-                double total = ABS(layer->extent.maxx - layer->extent.minx);
-                double part = ABS(subsetInImageProj.maxx - subsetInImageProj.minx);
-                widthFromComputationInImageCRS = MS_NINT((part * map->width) / total);
-            }
-            {
-                double total = ABS(layer->extent.maxy - layer->extent.miny);
-                double part = ABS(subsetInImageProj.maxy - subsetInImageProj.miny);
-                heightFromComputationInImageCRS = MS_NINT((part * map->height) / total);
-            }
+            double total = ABS(layer->extent.maxx - layer->extent.minx);
+            double part = ABS(subsetInImageProj.maxx - subsetInImageProj.minx);
+            widthFromComputationInImageCRS =
+                MS_NINT((part * map->width) / total);
+          }
+          {
+            double total = ABS(layer->extent.maxy - layer->extent.miny);
+            double part = ABS(subsetInImageProj.maxy - subsetInImageProj.miny);
+            heightFromComputationInImageCRS =
+                MS_NINT((part * map->height) / total);
           }
+        }
       }
 
       msProjectRect(&imageProj, &subsetProj, &(layer->extent));
@@ -4514,10 +4670,11 @@ this request. Check wcs/ows_enable_reque
   }
 
   /* create boundings of params subsets and image extent */
-  if(msRectOverlap(&subsets, &(layer->extent)) == MS_FALSE) {
+  if (msRectOverlap(&subsets, &(layer->extent)) == MS_FALSE) {
     /* extent and bbox do not overlap -> exit */
     msWCSClearCoverageMetadata20(&cm);
-    msSetError(MS_WCSERR, "Image extent does not intersect with desired region.",
+    msSetError(MS_WCSERR,
+               "Image extent does not intersect with desired region.",
                "msWCSGetCoverage20()");
     return msWCSException(map, "ExtentError", "extent", params->version);
   }
@@ -4529,10 +4686,12 @@ this request. Check wcs/ows_enable_reque
   bbox.maxy = MS_MIN(subsets.maxy, map->extent.maxy);
 
   /* check if we are overspecified  */
-  if ((params->width != 0 &&  params->resolutionX != MS_WCS20_UNBOUNDED)
-      || (params->height != 0 && params->resolutionY != MS_WCS20_UNBOUNDED)) {
+  if ((params->width != 0 && params->resolutionX != MS_WCS20_UNBOUNDED) ||
+      (params->height != 0 && params->resolutionY != MS_WCS20_UNBOUNDED)) {
     msWCSClearCoverageMetadata20(&cm);
-    msSetError(MS_WCSERR, "GetCoverage operation supports only one of SIZE or RESOLUTION per axis.",
+    msSetError(MS_WCSERR,
+               "GetCoverage operation supports only one of SIZE or RESOLUTION "
+               "per axis.",
                "msWCSGetCoverage20()");
     return msWCSException(map, "TooManyParameterValues", "coverage",
                           params->version);
@@ -4545,15 +4704,16 @@ this request. Check wcs/ows_enable_reque
   /************************************************************************/
 
   /* check x axis */
-  if(params->width != 0) {
+  if (params->width != 0) {
     /* TODO Unit Of Measure? */
     params->resolutionX = (bbox.maxx - bbox.minx) / params->width;
-  } else if(params->resolutionX != MS_WCS20_UNBOUNDED) {
+  } else if (params->resolutionX != MS_WCS20_UNBOUNDED) {
     params->width = MS_NINT((bbox.maxx - bbox.minx) / params->resolutionX);
   } else {
-    if( widthFromComputationInImageCRS != 0 ) {
+    if (widthFromComputationInImageCRS != 0) {
       params->width = widthFromComputationInImageCRS;
-    } else if(ABS(bbox.maxx - bbox.minx) != ABS(map->extent.maxx - map->extent.minx)) {
+    } else if (ABS(bbox.maxx - bbox.minx) !=
+               ABS(map->extent.maxx - map->extent.minx)) {
       double total = ABS(map->extent.maxx - map->extent.minx),
              part = ABS(bbox.maxx - bbox.minx);
       params->width = MS_NINT((part * map->width) / total);
@@ -4565,19 +4725,20 @@ this request. Check wcs/ows_enable_reque
 
     if (params->scaleX != MS_WCS20_UNBOUNDED) {
       params->resolutionX /= params->scaleX;
-      params->width = (long)(((double) params->width) * params->scaleX);
+      params->width = (long)(((double)params->width) * params->scaleX);
     }
   }
 
   /* check y axis */
-  if(params->height != 0) {
+  if (params->height != 0) {
     params->resolutionY = (bbox.maxy - bbox.miny) / params->height;
-  } else if(params->resolutionY != MS_WCS20_UNBOUNDED) {
+  } else if (params->resolutionY != MS_WCS20_UNBOUNDED) {
     params->height = MS_NINT((bbox.maxy - bbox.miny) / params->resolutionY);
   } else {
-    if( heightFromComputationInImageCRS != 0 ) {
+    if (heightFromComputationInImageCRS != 0) {
       params->height = heightFromComputationInImageCRS;
-    } else if(ABS(bbox.maxy - bbox.miny) != ABS(map->extent.maxy - map->extent.miny)) {
+    } else if (ABS(bbox.maxy - bbox.miny) !=
+               ABS(map->extent.maxy - map->extent.miny)) {
       double total = ABS(map->extent.maxy - map->extent.miny),
              part = ABS(bbox.maxy - bbox.miny);
       params->height = MS_NINT((part * map->height) / total);
@@ -4589,7 +4750,7 @@ this request. Check wcs/ows_enable_reque
 
     if (params->scaleY != MS_WCS20_UNBOUNDED) {
       params->resolutionY /= params->scaleY;
-      params->height = (long)(((double) params->height) * params->scaleY);
+      params->height = (long)(((double)params->height) * params->scaleY);
     }
   }
 
@@ -4601,42 +4762,42 @@ this request. Check wcs/ows_enable_reque
   bbox.maxy -= params->resolutionY * 0.5;
 
   /* if parameter 'outputcrs' is given, project the image to this crs */
-  if(params->outputcrs != NULL) {
+  if (params->outputcrs != NULL) {
     projectionObj outputProj;
 
     msInitProjection(&outputProj);
     msProjectionInheritContextFrom(&outputProj, &(layer->projection));
-    if(msLoadProjectionString(&outputProj, params->outputcrs) == -1) {
+    if (msLoadProjectionString(&outputProj, params->outputcrs) == -1) {
       msFreeProjection(&outputProj);
       msWCSClearCoverageMetadata20(&cm);
       return msWCSException(map, "InvalidParameterValue", "coverage",
                             params->version);
     }
-    if(msProjectionsDiffer(&(map->projection), &outputProj)) {
+    if (msProjectionsDiffer(&(map->projection), &outputProj)) {
 
-      msDebug("msWCSGetCoverage20(): projecting to outputcrs %s\n", params->outputcrs);
+      msDebug("msWCSGetCoverage20(): projecting to outputcrs %s\n",
+              params->outputcrs);
 
       msProjectRect(&(map->projection), &outputProj, &bbox);
 
       /* recalculate resolutions, needed if UOM changes (e.g: deg -> m) */
-      if( params->width == 1 || params->height == 1 )
-      {
-          // if one of the dimension is 1, we cannot use the center-of-pixel bbox,
-          // but must use the origin-is-corner one.
-          msProjectRect(&(map->projection), &outputProj, &bboxOriginIsCorner);
-          params->resolutionX = (bboxOriginIsCorner.maxx - bboxOriginIsCorner.minx) / params->width;
-          params->resolutionY = (bboxOriginIsCorner.maxy - bboxOriginIsCorner.miny) / params->height;
-      }
-      else
-      {
-          params->resolutionX = (bbox.maxx - bbox.minx) / (params->width - 1);
-          params->resolutionY = (bbox.maxy - bbox.miny) / (params->height - 1);
+      if (params->width == 1 || params->height == 1) {
+        // if one of the dimension is 1, we cannot use the center-of-pixel bbox,
+        // but must use the origin-is-corner one.
+        msProjectRect(&(map->projection), &outputProj, &bboxOriginIsCorner);
+        params->resolutionX =
+            (bboxOriginIsCorner.maxx - bboxOriginIsCorner.minx) / params->width;
+        params->resolutionY =
+            (bboxOriginIsCorner.maxy - bboxOriginIsCorner.miny) /
+            params->height;
+      } else {
+        params->resolutionX = (bbox.maxx - bbox.minx) / (params->width - 1);
+        params->resolutionY = (bbox.maxy - bbox.miny) / (params->height - 1);
       }
 
       msFreeProjection(&(map->projection));
       map->projection = outputProj;
-    }
-    else {
+    } else {
       msFreeProjection(&outputProj);
     }
   }
@@ -4647,14 +4808,15 @@ this request. Check wcs/ows_enable_reque
   map->height = params->height;
 
   /* Are we exceeding the MAXSIZE limit on result size? */
-  if(map->width > map->maxsize || map->height > map->maxsize ) {
+  if (map->width > map->maxsize || map->height > map->maxsize) {
     msWCSClearCoverageMetadata20(&cm);
-    msSetError(MS_WCSERR, "Raster size out of range, width and height of "
+    msSetError(MS_WCSERR,
+               "Raster size out of range, width and height of "
                "resulting coverage must be no more than MAXSIZE=%d.",
                "msWCSGetCoverage20()", map->maxsize);
 
-    return msWCSException(map, "InvalidParameterValue",
-                          "size", params->version);
+    return msWCSException(map, "InvalidParameterValue", "size",
+                          params->version);
   }
 
   /* Mapserver only supports square cells */
@@ -4683,7 +4845,8 @@ this request. Check wcs/ows_enable_reque
   }
 
   if (!params->format) {
-    msSetError(MS_WCSERR, "Output format could not be automatically determined. "
+    msSetError(MS_WCSERR,
+               "Output format could not be automatically determined. "
                "Use the FORMAT parameter to specify a format.",
                "msWCSGetCoverage20()");
     msWCSClearCoverageMetadata20(&cm);
@@ -4694,10 +4857,10 @@ this request. Check wcs/ows_enable_reque
   /*    make sure layer is on   */
   layer->status = MS_ON;
 
-  if( params->width == 1 || params->height == 1 )
-      msMapComputeGeotransformEx(map, params->resolutionX, params->resolutionY);
+  if (params->width == 1 || params->height == 1)
+    msMapComputeGeotransformEx(map, params->resolutionX, params->resolutionY);
   else
-      msMapComputeGeotransform(map);
+    msMapComputeGeotransform(map);
 
   /*    fill in bands rangeset info, if required.  */
   /* msWCSSetDefaultBandsRangeSetInfo(params, &cm, layer); */
@@ -4725,14 +4888,15 @@ this request. Check wcs/ows_enable_reque
                           params->version);
   }
 
-  if(msWCSGetCoverage20_GetBands(layer, params, &cm, &bandlist) != MS_SUCCESS) {
+  if (msWCSGetCoverage20_GetBands(layer, params, &cm, &bandlist) !=
+      MS_SUCCESS) {
     msFree(bandlist);
     msWCSClearCoverageMetadata20(&cm);
     return msWCSException(map, "InvalidParameterValue", "rangesubset",
                           params->version);
   }
   msLayerSetProcessingKey(layer, "BANDS", bandlist);
-  snprintf(numbands, sizeof(numbands), "%d", msCountChars(bandlist, ',')+1);
+  snprintf(numbands, sizeof(numbands), "%d", msCountChars(bandlist, ',') + 1);
   msSetOutputFormatOption(map->outputformat, "BAND_COUNT", numbands);
 
   msWCSApplyLayerCreationOptions(layer, map->outputformat, bandlist);
@@ -4740,19 +4904,21 @@ this request. Check wcs/ows_enable_reque
 
   /* check for the interpolation */
   /* Defaults to NEAREST */
-  if(params->interpolation != NULL) {
-    if(EQUALN(params->interpolation,"NEAREST",7)) {
+  if (params->interpolation != NULL) {
+    if (EQUALN(params->interpolation, "NEAREST", 7)) {
       msLayerSetProcessingKey(layer, "RESAMPLE", "NEAREST");
-    } else if(EQUAL(params->interpolation,"BILINEAR")) {
+    } else if (EQUAL(params->interpolation, "BILINEAR")) {
       msLayerSetProcessingKey(layer, "RESAMPLE", "BILINEAR");
-    } else if(EQUAL(params->interpolation,"AVERAGE")) {
+    } else if (EQUAL(params->interpolation, "AVERAGE")) {
       msLayerSetProcessingKey(layer, "RESAMPLE", "AVERAGE");
     } else {
       msFree(bandlist);
-      msSetError( MS_WCSERR, "'%s' specifies an unsupported interpolation method.",
-                  "msWCSGetCoverage20()", params->interpolation );
+      msSetError(MS_WCSERR,
+                 "'%s' specifies an unsupported interpolation method.",
+                 "msWCSGetCoverage20()", params->interpolation);
       msWCSClearCoverageMetadata20(&cm);
-      return msWCSException(map, "InvalidParameterValue", "interpolation", params->version);
+      return msWCSException(map, "InvalidParameterValue", "interpolation",
+                            params->version);
     }
   } else {
     msLayerSetProcessingKey(layer, "RESAMPLE", "NEAREST");
@@ -4762,42 +4928,40 @@ this request. Check wcs/ows_enable_reque
   /* closed after drawing the layer. This normally defaults to    */
   /* DEFER and will produce a memory leak, because the dataset    */
   /* will not be closed.                                          */
-  if( msLayerGetProcessingKey(layer, "CLOSE_CONNECTION") == NULL ) {
+  if (msLayerGetProcessingKey(layer, "CLOSE_CONNECTION") == NULL) {
     msLayerSetProcessingKey(layer, "CLOSE_CONNECTION", "NORMAL");
   }
 
-  if( layer->tileindex == NULL && layer->data != NULL &&
-      strlen(layer->data) > 0 &&
-      layer->connectiontype != MS_KERNELDENSITY )
-  {
-      if( msDrawRasterLayerLowCheckIfMustDraw(map, layer) )
-      {
-          char* decrypted_path = NULL;
-          char szPath[MS_MAXPATHLEN];
-          hDS = (GDALDatasetH)msDrawRasterLayerLowOpenDataset(
-                                    map, layer, layer->data, szPath, &decrypted_path);
-          msFree(decrypted_path);
-          if( hDS )
-          {
-            msWCSApplyDatasetMetadataAsCreationOptions(layer, map->outputformat, bandlist, hDS);
-            msWCSApplySourceDatasetMetadata(layer, map->outputformat, bandlist, hDS);
-          }
-      }
-      else
-      {
-          doDrawRasterLayerDraw = MS_FALSE;
+  if (layer->tileindex == NULL && layer->data != NULL &&
+      strlen(layer->data) > 0 && layer->connectiontype != MS_KERNELDENSITY) {
+    if (msDrawRasterLayerLowCheckIfMustDraw(map, layer)) {
+      char *decrypted_path = NULL;
+      char szPath[MS_MAXPATHLEN];
+      hDS = (GDALDatasetH)msDrawRasterLayerLowOpenDataset(
+          map, layer, layer->data, szPath, &decrypted_path);
+      msFree(decrypted_path);
+      if (hDS) {
+        msWCSApplyDatasetMetadataAsCreationOptions(layer, map->outputformat,
+                                                   bandlist, hDS);
+        msWCSApplySourceDatasetMetadata(layer, map->outputformat, bandlist,
+                                        hDS);
       }
+    } else {
+      doDrawRasterLayerDraw = MS_FALSE;
+    }
   }
 
   /* create the image object  */
   if (MS_RENDERER_PLUGIN(map->outputformat)) {
-    image = msImageCreate(map->width, map->height, map->outputformat,
-                          map->web.imagepath, map->web.imageurl, map->resolution,
-                          map->defresolution, &map->imagecolor);
+    image =
+        msImageCreate(map->width, map->height, map->outputformat,
+                      map->web.imagepath, map->web.imageurl, map->resolution,
+                      map->defresolution, &map->imagecolor);
   } else if (MS_RENDERER_RAWDATA(map->outputformat)) {
-    image = msImageCreate(map->width, map->height, map->outputformat,
-                          map->web.imagepath, map->web.imageurl, map->resolution,
-                          map->defresolution, &map->imagecolor);
+    image =
+        msImageCreate(map->width, map->height, map->outputformat,
+                      map->web.imagepath, map->web.imageurl, map->resolution,
+                      map->defresolution, &map->imagecolor);
   } else {
     msFree(bandlist);
     msWCSClearCoverageMetadata20(&cm);
@@ -4814,13 +4978,13 @@ this request. Check wcs/ows_enable_reque
     return msWCSException(map, NULL, NULL, params->version);
   }
 
-  if(layer->mask) {
-    int maskLayerIdx = msGetLayerIndex(map,layer->mask);
+  if (layer->mask) {
+    int maskLayerIdx = msGetLayerIndex(map, layer->mask);
     layerObj *maskLayer;
     outputFormatObj *altFormat;
-    if(maskLayerIdx == -1) {
-      msSetError(MS_MISCERR, "Layer (%s) references unknown mask layer (%s)", "msDrawLayer()",
-                 layer->name,layer->mask);
+    if (maskLayerIdx == -1) {
+      msSetError(MS_MISCERR, "Layer (%s) references unknown mask layer (%s)",
+                 "msDrawLayer()", layer->name, layer->mask);
       msFreeImage(image);
       msFree(bandlist);
       msWCSClearCoverageMetadata20(&cm);
@@ -4828,17 +4992,20 @@ this request. Check wcs/ows_enable_reque
       return msWCSException(map, NULL, NULL, params->version);
     }
     maskLayer = GET_LAYER(map, maskLayerIdx);
-    if(!maskLayer->maskimage) {
-      int i,retcode;
+    if (!maskLayer->maskimage) {
+      int i, retcode;
       int origstatus, origlabelcache;
       char *origImageType = msStrdup(map->imagetype);
-      altFormat =  msSelectOutputFormat(map, "png24");
+      altFormat = msSelectOutputFormat(map, "png24");
       msInitializeRendererVTable(altFormat);
-      /* TODO: check the png24 format hasn't been tampered with, i.e. it's agg */
-      maskLayer->maskimage= msImageCreate(image->width, image->height,altFormat,
-                                          image->imagepath, image->imageurl, map->resolution, map->defresolution, NULL);
+      /* TODO: check the png24 format hasn't been tampered with, i.e. it's agg
+       */
+      maskLayer->maskimage = msImageCreate(
+          image->width, image->height, altFormat, image->imagepath,
+          image->imageurl, map->resolution, map->defresolution, NULL);
       if (!maskLayer->maskimage) {
-        msSetError(MS_MISCERR, "Unable to initialize mask image.", "msDrawLayer()");
+        msSetError(MS_MISCERR, "Unable to initialize mask image.",
+                   "msDrawLayer()");
         msFreeImage(image);
         msFree(bandlist);
         msWCSClearCoverageMetadata20(&cm);
@@ -4847,9 +5014,9 @@ this request. Check wcs/ows_enable_reque
       }
 
       /*
-       * force the masked layer to status on, and turn off the labelcache so that
-       * eventual labels are added to the temporary image instead of being added
-       * to the labelcache
+       * force the masked layer to status on, and turn off the labelcache so
+       * that eventual labels are added to the temporary image instead of being
+       * added to the labelcache
        */
       origstatus = maskLayer->status;
       origlabelcache = maskLayer->labelcache;
@@ -4860,7 +5027,7 @@ this request. Check wcs/ows_enable_reque
       retcode = msDrawLayer(map, maskLayer, maskLayer->maskimage);
       maskLayer->status = origstatus;
       maskLayer->labelcache = origlabelcache;
-      if(retcode != MS_SUCCESS) {
+      if (retcode != MS_SUCCESS) {
         free(origImageType);
         msFreeImage(image);
         msFree(bandlist);
@@ -4869,40 +5036,41 @@ this request. Check wcs/ows_enable_reque
         return msWCSException(map, NULL, NULL, params->version);
       }
       /*
-       * hack to work around bug #3834: if we have use an alternate renderer, the symbolset may contain
-       * symbols that reference it. We want to remove those references before the altFormat is destroyed
-       * to avoid a segfault and/or a leak, and so the the main renderer doesn't pick the cache up thinking
-       * it's for him.
+       * hack to work around bug #3834: if we have use an alternate renderer,
+       * the symbolset may contain symbols that reference it. We want to remove
+       * those references before the altFormat is destroyed to avoid a segfault
+       * and/or a leak, and so the the main renderer doesn't pick the cache up
+       * thinking it's for him.
        */
-      for(i=0; i<map->symbolset.numsymbols; i++) {
-        if (map->symbolset.symbol[i]!=NULL) {
+      for (i = 0; i < map->symbolset.numsymbols; i++) {
+        if (map->symbolset.symbol[i] != NULL) {
           symbolObj *s = map->symbolset.symbol[i];
-          if(s->renderer == MS_IMAGE_RENDERER(maskLayer->maskimage)) {
+          if (s->renderer == MS_IMAGE_RENDERER(maskLayer->maskimage)) {
             MS_IMAGE_RENDERER(maskLayer->maskimage)->freeSymbol(s);
             s->renderer = NULL;
           }
         }
       }
-      /* set the imagetype from the original outputformat back (it was removed by msSelectOutputFormat() */
+      /* set the imagetype from the original outputformat back (it was removed
+       * by msSelectOutputFormat() */
       msFree(map->imagetype);
       map->imagetype = origImageType;
-
     }
   }
 
   /* Actually produce the "grid". */
-  if( MS_RENDERER_RAWDATA(map->outputformat) ) {
-    if( doDrawRasterLayerDraw ) {
-      status = msDrawRasterLayerLowWithDataset( map, layer, image, NULL, hDS );
+  if (MS_RENDERER_RAWDATA(map->outputformat)) {
+    if (doDrawRasterLayerDraw) {
+      status = msDrawRasterLayerLowWithDataset(map, layer, image, NULL, hDS);
     } else {
       status = MS_SUCCESS;
     }
   } else {
     rasterBufferObj rb;
-    status = MS_IMAGE_RENDERER(image)->getRasterBufferHandle(image,&rb);
-    if(MS_LIKELY(status == MS_SUCCESS)) {
-      if( doDrawRasterLayerDraw ) {
-        status = msDrawRasterLayerLowWithDataset( map, layer, image, &rb, hDS );
+    status = MS_IMAGE_RENDERER(image)->getRasterBufferHandle(image, &rb);
+    if (MS_LIKELY(status == MS_SUCCESS)) {
+      if (doDrawRasterLayerDraw) {
+        status = msDrawRasterLayerLowWithDataset(map, layer, image, &rb, hDS);
       } else {
         status = MS_SUCCESS;
       }
@@ -4911,21 +5079,19 @@ this request. Check wcs/ows_enable_reque
 
   msDrawRasterLayerLowCloseDataset(layer, hDS);
 
-  if( status != MS_SUCCESS ) {
+  if (status != MS_SUCCESS) {
     msFree(bandlist);
     msFreeImage(image);
     msWCSClearCoverageMetadata20(&cm);
-    return msWCSException(map, NULL, NULL, params->version );
+    return msWCSException(map, NULL, NULL, params->version);
   }
 
   /* GML+Image */
   /* Embed the image into multipart message */
-  if(params->multipart == MS_TRUE) {
-    xmlDocPtr psDoc = NULL;       /* document pointer */
+  if (params->multipart == MS_TRUE) {
+    xmlDocPtr psDoc = NULL; /* document pointer */
     xmlNodePtr psRootNode, psRangeSet, psFile, psRangeParameters;
-    xmlNsPtr psGmlNs = NULL,
-             psGmlcovNs = NULL,
-             psSweNs = NULL,
+    xmlNsPtr psGmlNs = NULL, psGmlcovNs = NULL, psSweNs = NULL,
              psXLinkNs = NULL;
     wcs20coverageMetadataObj tmpCm;
     char *srs_uri, *default_filename;
@@ -4934,16 +5100,21 @@ this request. Check wcs/ows_enable_reque
 
     /* Create Document  */
     psDoc = xmlNewDoc(BAD_CAST "1.0");
-    psRootNode = xmlNewNode(NULL, BAD_CAST MS_WCS_GML_COVERAGETYPE_RECTIFIED_GRID_COVERAGE);
+    psRootNode = xmlNewNode(
+        NULL, BAD_CAST MS_WCS_GML_COVERAGETYPE_RECTIFIED_GRID_COVERAGE);
     xmlDocSetRootElement(psDoc, psRootNode);
 
     msWCSPrepareNamespaces20(psDoc, psRootNode, map, MS_FALSE);
 
-    psGmlNs    = xmlSearchNs(psDoc, psRootNode, BAD_CAST MS_OWSCOMMON_GML_NAMESPACE_PREFIX);
-    psGmlcovNs = xmlSearchNs(psDoc, psRootNode, BAD_CAST MS_OWSCOMMON_GMLCOV_NAMESPACE_PREFIX);
-    psSweNs    = xmlSearchNs(psDoc, psRootNode, BAD_CAST MS_OWSCOMMON_SWE_NAMESPACE_PREFIX);
+    psGmlNs = xmlSearchNs(psDoc, psRootNode,
+                          BAD_CAST MS_OWSCOMMON_GML_NAMESPACE_PREFIX);
+    psGmlcovNs = xmlSearchNs(psDoc, psRootNode,
+                             BAD_CAST MS_OWSCOMMON_GMLCOV_NAMESPACE_PREFIX);
+    psSweNs = xmlSearchNs(psDoc, psRootNode,
+                          BAD_CAST MS_OWSCOMMON_SWE_NAMESPACE_PREFIX);
     xmlSearchNs(psDoc, psRootNode, BAD_CAST MS_OWSCOMMON_WCS_NAMESPACE_PREFIX);
-    psXLinkNs  = xmlSearchNs(psDoc, psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_PREFIX);
+    psXLinkNs = xmlSearchNs(psDoc, psRootNode,
+                            BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_PREFIX);
 
     xmlNewNsProp(psRootNode, psGmlNs, BAD_CAST "id", BAD_CAST layer->name);
 
@@ -4960,51 +5131,70 @@ this request. Check wcs/ows_enable_reque
     tmpCm.xresolution = map->gt.geotransform[1];
     tmpCm.yresolution = map->gt.geotransform[5];
 
-    tmpCm.extent.minx = MS_MIN(map->gt.geotransform[0], map->gt.geotransform[0] + map->width * tmpCm.xresolution);
-    tmpCm.extent.miny = MS_MIN(map->gt.geotransform[3], map->gt.geotransform[3] + map->height * tmpCm.yresolution);
-    tmpCm.extent.maxx = MS_MAX(map->gt.geotransform[0], map->gt.geotransform[0] + map->width * tmpCm.xresolution);
-    tmpCm.extent.maxy = MS_MAX(map->gt.geotransform[3], map->gt.geotransform[3] + map->height * tmpCm.yresolution);
+    tmpCm.extent.minx =
+        MS_MIN(map->gt.geotransform[0],
+               map->gt.geotransform[0] + map->width * tmpCm.xresolution);
+    tmpCm.extent.miny =
+        MS_MIN(map->gt.geotransform[3],
+               map->gt.geotransform[3] + map->height * tmpCm.yresolution);
+    tmpCm.extent.maxx =
+        MS_MAX(map->gt.geotransform[0],
+               map->gt.geotransform[0] + map->width * tmpCm.xresolution);
+    tmpCm.extent.maxy =
+        MS_MAX(map->gt.geotransform[3],
+               map->gt.geotransform[3] + map->height * tmpCm.yresolution);
 
     swapAxes = msWCSSwapAxes20(srs_uri);
     msFree(srs_uri);
 
     /* Setup layer information  */
-    msWCSCommon20_CreateBoundedBy(&tmpCm, psGmlNs, psRootNode, &(map->projection), swapAxes);
-    msWCSCommon20_CreateDomainSet(layer, &tmpCm, psGmlNs, psRootNode, &(map->projection), swapAxes);
+    msWCSCommon20_CreateBoundedBy(&tmpCm, psGmlNs, psRootNode,
+                                  &(map->projection), swapAxes);
+    msWCSCommon20_CreateDomainSet(layer, &tmpCm, psGmlNs, psRootNode,
+                                  &(map->projection), swapAxes);
 
     psRangeSet = xmlNewChild(psRootNode, psGmlNs, BAD_CAST "rangeSet", NULL);
-    psFile     = xmlNewChild(psRangeSet, psGmlNs, BAD_CAST "File", NULL);
+    psFile = xmlNewChild(psRangeSet, psGmlNs, BAD_CAST "File", NULL);
 
     /* TODO: wait for updated specifications */
-    psRangeParameters = xmlNewChild(psFile, psGmlNs, BAD_CAST "rangeParameters", NULL);
+    psRangeParameters =
+        xmlNewChild(psFile, psGmlNs, BAD_CAST "rangeParameters", NULL);
 
     default_filename = msStrdup("out.");
-    default_filename = msStringConcatenate(default_filename, MS_IMAGE_EXTENSION(image->format));
+    default_filename = msStringConcatenate(default_filename,
+                                           MS_IMAGE_EXTENSION(image->format));
 
-    filename = msGetOutputFormatOption(image->format, "FILENAME", default_filename);
+    filename =
+        msGetOutputFormatOption(image->format, "FILENAME", default_filename);
     std::string file_ref("cid:coverage/");
     file_ref += filename;
 
     msFree(default_filename);
 
     std::string role;
-    if(EQUAL(MS_IMAGE_MIME_TYPE(map->outputformat), "image/tiff")) {
+    if (EQUAL(MS_IMAGE_MIME_TYPE(map->outputformat), "image/tiff")) {
       role = MS_WCS_20_PROFILE_GML_GEOTIFF;
     } else {
       role = MS_IMAGE_MIME_TYPE(map->outputformat);
     }
 
-    xmlNewNsProp(psRangeParameters, psXLinkNs, BAD_CAST "href", BAD_CAST file_ref.c_str());
-    xmlNewNsProp(psRangeParameters, psXLinkNs, BAD_CAST "role", BAD_CAST role.c_str());
-    xmlNewNsProp(psRangeParameters, psXLinkNs, BAD_CAST "arcrole", BAD_CAST "fileReference");
+    xmlNewNsProp(psRangeParameters, psXLinkNs, BAD_CAST "href",
+                 BAD_CAST file_ref.c_str());
+    xmlNewNsProp(psRangeParameters, psXLinkNs, BAD_CAST "role",
+                 BAD_CAST role.c_str());
+    xmlNewNsProp(psRangeParameters, psXLinkNs, BAD_CAST "arcrole",
+                 BAD_CAST "fileReference");
 
-    xmlNewChild(psFile, psGmlNs, BAD_CAST "fileReference", BAD_CAST file_ref.c_str());
+    xmlNewChild(psFile, psGmlNs, BAD_CAST "fileReference",
+                BAD_CAST file_ref.c_str());
     xmlNewChild(psFile, psGmlNs, BAD_CAST "fileStructure", NULL);
-    xmlNewChild(psFile, psGmlNs, BAD_CAST "mimeType", BAD_CAST MS_IMAGE_MIME_TYPE(map->outputformat));
+    xmlNewChild(psFile, psGmlNs, BAD_CAST "mimeType",
+                BAD_CAST MS_IMAGE_MIME_TYPE(map->outputformat));
 
-    msWCSCommon20_CreateRangeType(&cm, bandlist, psGmlcovNs, psSweNs, psRootNode);
+    msWCSCommon20_CreateRangeType(&cm, bandlist, psGmlcovNs, psSweNs,
+                                  psRootNode);
 
-    msIO_setHeader("Content-Type","multipart/related; boundary=wcs");
+    msIO_setHeader("Content-Type", "multipart/related; boundary=wcs");
     msIO_sendHeaders();
     msIO_printf("\r\n--wcs\r\n");
 
@@ -5013,7 +5203,7 @@ this request. Check wcs/ows_enable_reque
 
     xmlFreeDoc(psDoc);
     xmlCleanupParser();
-  /* just print out the file without gml */
+    /* just print out the file without gml */
   } else {
     msWCSWriteFile20(map, image, params, 0);
   }
diff -pruN 8.0.1-5/mapwfs.cpp 8.0.2-1/mapwfs.cpp
--- 8.0.1-5/mapwfs.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapwfs.cpp	2024-06-11 20:41:34.000000000 +0000
@@ -32,7 +32,6 @@
 
 #include <string>
 
-
 #if defined(USE_WFS_SVR)
 
 /* There is a dependency to GDAL/OGR for the GML driver and MiniXML parser */
@@ -50,43 +49,42 @@
 
 #include <string>
 
-static int msWFSAnalyzeStoredQuery(mapObj* map,
-                                   wfsParamsObj *wfsparams,
-                                   const char* id,
-                                   const char* pszResolvedQuery);
+static int msWFSAnalyzeStoredQuery(mapObj *map, wfsParamsObj *wfsparams,
+                                   const char *id,
+                                   const char *pszResolvedQuery);
 static void msWFSSimplifyPropertyNameAndFilter(wfsParamsObj *wfsparams);
-static void msWFSAnalyzeStartIndexAndFeatureCount(mapObj *map, const wfsParamsObj *paramsObj,
+static void msWFSAnalyzeStartIndexAndFeatureCount(mapObj *map,
+                                                  const wfsParamsObj *paramsObj,
                                                   int bIsHits,
-                                                  int *pmaxfeatures, int* pstartindex);
-static int msWFSRunBasicGetFeature(mapObj* map,
-                                   layerObj* lp,
+                                                  int *pmaxfeatures,
+                                                  int *pstartindex);
+static int msWFSRunBasicGetFeature(mapObj *map, layerObj *lp,
                                    const wfsParamsObj *paramsObj,
                                    int nWFSVersion);
 
 static int msWFSParseRequest(mapObj *map, cgiRequestObj *request,
-                      wfsParamsObj *wfsparams, int force_wfs_mode);
+                             wfsParamsObj *wfsparams, int force_wfs_mode);
 
 /* Must be sorted from more recent to older one */
 static const int wfsSupportedVersions[] = {OWS_2_0_0, OWS_1_1_0, OWS_1_0_0};
-static const char* const wfsSupportedVersionsStr[] = { "2.0.0", "1.1.0", "1.0.0" };
+static const char *const wfsSupportedVersionsStr[] = {"2.0.0", "1.1.0",
+                                                      "1.0.0"};
 static const int wfsNumSupportedVersions =
-    (int)(sizeof(wfsSupportedVersions)/sizeof(wfsSupportedVersions[0]));
-static const char* const wfsUnsupportedOperations[] = { "GetFeatureWithLock",
-                                                  "LockFeature",
-                                                  "Transaction",
-                                                  "CreateStoredQuery",
-                                                  "DropStoredQuery" };
+    (int)(sizeof(wfsSupportedVersions) / sizeof(wfsSupportedVersions[0]));
+static const char *const wfsUnsupportedOperations[] = {
+    "GetFeatureWithLock", "LockFeature", "Transaction", "CreateStoredQuery",
+    "DropStoredQuery"};
 static const int wfsNumUnsupportedOperations =
-    (int)(sizeof(wfsUnsupportedOperations)/sizeof(wfsUnsupportedOperations[0]));
+    (int)(sizeof(wfsUnsupportedOperations) /
+          sizeof(wfsUnsupportedOperations[0]));
 
-#define WFS_LATEST_VERSION  wfsSupportedVersionsStr[0]
+#define WFS_LATEST_VERSION wfsSupportedVersionsStr[0]
 
 /* Supported DescribeFeature formats */
-typedef enum
-{
-    OWS_DEFAULT_SCHEMA, /* basically a GML 2.1 schema */
-    OWS_SFE_SCHEMA, /* GML for simple feature exchange (formerly GML3L0) */
-    OWS_GML32_SFE_SCHEMA /* GML 3.2 Simple Features Level 0 */
+typedef enum {
+  OWS_DEFAULT_SCHEMA,  /* basically a GML 2.1 schema */
+  OWS_SFE_SCHEMA,      /* GML for simple feature exchange (formerly GML3L0) */
+  OWS_GML32_SFE_SCHEMA /* GML 3.2 Simple Features Level 0 */
 } WFSSchemaVersion;
 
 /*
@@ -95,20 +93,16 @@ typedef enum
 ** Return index of pszOp in wfsUnsupportedOperations, or -1 otherwise
 */
 
-static int msWFSGetIndexUnsupportedOperation(const char* pszOp)
-{
-    int i;
-    for(i = 0; i < wfsNumUnsupportedOperations; i++ )
-    {
-        if( strcasecmp(wfsUnsupportedOperations[i], pszOp) == 0 )
-            return i;
-    }
-    return -1;
+static int msWFSGetIndexUnsupportedOperation(const char *pszOp) {
+  int i;
+  for (i = 0; i < wfsNumUnsupportedOperations; i++) {
+    if (strcasecmp(wfsUnsupportedOperations[i], pszOp) == 0)
+      return i;
+  }
+  return -1;
 }
 
-
-static
-const char *msWFSGetDefaultVersion(mapObj *map);
+static const char *msWFSGetDefaultVersion(mapObj *map);
 
 /*
 ** msWFSException()
@@ -116,23 +110,23 @@ const char *msWFSGetDefaultVersion(mapOb
 ** Report current MapServer error in XML exception format.
 */
 
-static
-int msWFSExceptionInternal(mapObj *map, const char *locator, const char *code,
-                           const char *version, int locatorShouldBeNull )
-{
+static int msWFSExceptionInternal(mapObj *map, const char *locator,
+                                  const char *code, const char *version,
+                                  int locatorShouldBeNull) {
   char *schemalocation = NULL;
   /* In WFS, exceptions are always XML.
-  */
+   */
 
-  if( version == NULL )
+  if (version == NULL)
     version = msWFSGetDefaultVersion(map);
 
-  if( msOWSParseVersionString(version) >= OWS_2_0_0 )
-    return msWFSException20( map, (locatorShouldBeNull) ? NULL : locator, code );
-  if( msOWSParseVersionString(version) >= OWS_1_1_0 )
-    return msWFSException11( map, (locatorShouldBeNull) ? NULL : locator, code, version );
+  if (msOWSParseVersionString(version) >= OWS_2_0_0)
+    return msWFSException20(map, (locatorShouldBeNull) ? NULL : locator, code);
+  if (msOWSParseVersionString(version) >= OWS_1_1_0)
+    return msWFSException11(map, (locatorShouldBeNull) ? NULL : locator, code,
+                            version);
 
-  msIO_setHeader("Content-Type","text/xml; charset=UTF-8");
+  msIO_setHeader("Content-Type", "text/xml; charset=UTF-8");
   msIO_sendHeaders();
 
   msIO_printf("<?xml version='1.0' encoding=\"UTF-8\" ?>\n");
@@ -142,9 +136,12 @@ int msWFSExceptionInternal(mapObj *map,
   msIO_printf("xmlns=\"http://www.opengis.net/ogc\" ");
   msIO_printf("xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" ");
   schemalocation = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
-  msIO_printf("xsi:schemaLocation=\"http://www.opengis.net/ogc %s/wfs/1.0.0/OGC-exception.xsd\">\n", schemalocation);
+  msIO_printf("xsi:schemaLocation=\"http://www.opengis.net/ogc "
+              "%s/wfs/1.0.0/OGC-exception.xsd\">\n",
+              schemalocation);
   free(schemalocation);
-  msIO_printf("  <ServiceException code=\"%s\" locator=\"%s\">\n", code, locator);
+  msIO_printf("  <ServiceException code=\"%s\" locator=\"%s\">\n", code,
+              locator);
   /* Optional <Locator> element currently unused. */
   /* msIO_printf("    <Message>\n"); */
   msWriteErrorXML(stdout);
@@ -156,12 +153,10 @@ int msWFSExceptionInternal(mapObj *map,
 }
 
 int msWFSException(mapObj *map, const char *locator, const char *code,
-                   const char *version )
-{
-    return msWFSExceptionInternal(map, locator, code, version, FALSE);
+                   const char *version) {
+  return msWFSExceptionInternal(map, locator, code, version, FALSE);
 }
 
-
 /*
 ** msWFSExceptionNoLocator()
 **
@@ -170,11 +165,9 @@ int msWFSException(mapObj *map, const ch
 ** for legacy WFS 1.0 exceptions.
 */
 
-static
-int msWFSExceptionNoLocator(mapObj *map, const char *locator, const char *code,
-                   const char *version )
-{
-    return msWFSExceptionInternal(map, locator, code, version, TRUE);
+static int msWFSExceptionNoLocator(mapObj *map, const char *locator,
+                                   const char *code, const char *version) {
+  return msWFSExceptionInternal(map, locator, code, version, TRUE);
 }
 
 /*
@@ -185,77 +178,75 @@ int msWFSExceptionNoLocator(mapObj *map,
 ** returned should be freed by the caller.
 */
 
-char *msWFSGetOutputFormatList(mapObj *map, layerObj *layer, int nWFSVersion )
-{
+char *msWFSGetOutputFormatList(mapObj *map, layerObj *layer, int nWFSVersion) {
   int i, got_map_list = 0;
   static const int out_list_size = 20000;
-  char *out_list = (char*) msSmallCalloc(1,out_list_size);
+  char *out_list = (char *)msSmallCalloc(1, out_list_size);
 
-  if( nWFSVersion == OWS_1_0_0 )
-      strcpy(out_list,"GML2");
-  else if( nWFSVersion == OWS_1_1_0 )
-      strcpy(out_list,"text/xml; subtype=gml/3.1.1");
+  if (nWFSVersion == OWS_1_0_0)
+    strcpy(out_list, "GML2");
+  else if (nWFSVersion == OWS_1_1_0)
+    strcpy(out_list, "text/xml; subtype=gml/3.1.1");
   else
-      strcpy(out_list,"application/gml+xml; version=3.2,"
-                      "text/xml; subtype=gml/3.2.1,"
-                      "text/xml; subtype=gml/3.1.1,"
-                      "text/xml; subtype=gml/2.1.2");
+    strcpy(out_list, "application/gml+xml; version=3.2,"
+                     "text/xml; subtype=gml/3.2.1,"
+                     "text/xml; subtype=gml/3.1.1,"
+                     "text/xml; subtype=gml/2.1.2");
 
-  for( i = 0; i < map->numlayers; i++ ) {
+  for (i = 0; i < map->numlayers; i++) {
     const char *format_list;
     layerObj *lp;
     int j, n;
     char **tokens;
 
     lp = GET_LAYER(map, i);
-    if( layer != NULL && layer != lp )
+    if (layer != NULL && layer != lp)
       continue;
 
-    format_list = msOWSLookupMetadata(&(lp->metadata),
-                                      "F","getfeature_formatlist");
+    format_list =
+        msOWSLookupMetadata(&(lp->metadata), "F", "getfeature_formatlist");
 
-    if( format_list == NULL && !got_map_list ) {
-      format_list = msOWSLookupMetadata(&(map->web.metadata),
-                                        "F","getfeature_formatlist");
+    if (format_list == NULL && !got_map_list) {
+      format_list = msOWSLookupMetadata(&(map->web.metadata), "F",
+                                        "getfeature_formatlist");
       got_map_list = 1;
     }
 
-    if( format_list == NULL )
+    if (format_list == NULL)
       continue;
 
     n = 0;
     tokens = msStringSplit(format_list, ',', &n);
 
-    for( j = 0; j < n; j++ ) {
+    for (j = 0; j < n; j++) {
       int iformat;
       const char *fname, *hit;
       outputFormatObj *format_obj;
 
-      msStringTrim( tokens[j] );
-      iformat = msGetOutputFormatIndex(map,tokens[j]);
-      if( iformat < 0 )
+      msStringTrim(tokens[j]);
+      iformat = msGetOutputFormatIndex(map, tokens[j]);
+      if (iformat < 0)
         continue;
 
       format_obj = map->outputformatlist[iformat];
 
       fname = format_obj->name;
-      if( nWFSVersion >= OWS_1_1_0
-          && format_obj->mimetype != NULL )
+      if (nWFSVersion >= OWS_1_1_0 && format_obj->mimetype != NULL)
         fname = format_obj->mimetype;
 
-      hit = strstr(out_list,fname);
-      if( hit != NULL
-          && (hit[strlen(fname)] == '\0' || hit[strlen(fname)] == ','))
+      hit = strstr(out_list, fname);
+      if (hit != NULL &&
+          (hit[strlen(fname)] == '\0' || hit[strlen(fname)] == ','))
         continue;
 
-      if( strlen(out_list) + strlen(fname)+3 < out_list_size ) {
-        strcat( out_list, "," );
-        strcat( out_list, fname );
+      if (strlen(out_list) + strlen(fname) + 3 < out_list_size) {
+        strcat(out_list, ",");
+        strcat(out_list, fname);
       } else
         break;
     }
 
-    msFreeCharArray( tokens, n );
+    msFreeCharArray(tokens, n);
   }
 
   return out_list;
@@ -264,11 +255,9 @@ char *msWFSGetOutputFormatList(mapObj *m
 /*
 **
 */
-static void msWFSPrintRequestCap(const char *request,
-                                 const char *script_url,
+static void msWFSPrintRequestCap(const char *request, const char *script_url,
                                  const char *format_tag,
-                                 const char *formats_list)
-{
+                                 const char *formats_list) {
   msIO_printf("    <%s>\n", request);
 
   /* We expect to receive a NULL-terminated args list of formats */
@@ -281,11 +270,11 @@ static void msWFSPrintRequestCap(const c
 
     msIO_printf("      <%s>\n", format_tag);
 
-    for( i = 0; i < n; i++ ) {
-      msIO_printf("        <%s/>\n", tokens[i] );
+    for (i = 0; i < n; i++) {
+      msIO_printf("        <%s/>\n", tokens[i]);
     }
 
-    msFreeCharArray( tokens, n );
+    msFreeCharArray(tokens, n);
 
     msIO_printf("      </%s>\n", format_tag);
   }
@@ -301,21 +290,21 @@ static void msWFSPrintRequestCap(const c
   msIO_printf("        </HTTP>\n");
   msIO_printf("      </DCPType>\n");
 
-
   msIO_printf("    </%s>\n", request);
 }
 
-
 /* msWFSLocateSRSInList()
 **
-** Utility function to check if a space separated list contains  the one passed in argument.
-**  The list comes normaly from ows_srs metadata, and is expected to use the simple EPSG notation
-** (EPSG:4326 ESPG:42304 ...). The srs comes from the query string and can either
+** Utility function to check if a space separated list contains  the one passed
+*in argument.
+**  The list comes normaly from ows_srs metadata, and is expected to use the
+*simple EPSG notation
+** (EPSG:4326 ESPG:42304 ...). The srs comes from the query string and can
+*either
 ** be of simple EPSG format or using gc:def:crs:EPSG:xxx format
 */
-int msWFSLocateSRSInList(const char *pszList, const char *srs)
-{
-  int nTokens,i;
+int msWFSLocateSRSInList(const char *pszList, const char *srs) {
+  int nTokens, i;
   char **tokens = NULL;
   int bFound = MS_FALSE;
   char epsg_string[100];
@@ -324,29 +313,29 @@ int msWFSLocateSRSInList(const char *psz
   if (!pszList || !srs)
     return MS_FALSE;
 
-  if (strncasecmp(srs, "EPSG:",5) == 0)
-    code = srs+5;
-  else if (strncasecmp(srs, "urn:ogc:def:crs:EPSG:",21) == 0) {
+  if (strncasecmp(srs, "EPSG:", 5) == 0)
+    code = srs + 5;
+  else if (strncasecmp(srs, "urn:ogc:def:crs:EPSG:", 21) == 0) {
     if (srs[21] == ':')
-      code = srs+21;
+      code = srs + 21;
     else
-      code = srs+20;
+      code = srs + 20;
 
-    while( *code != ':' && *code != '\0')
+    while (*code != ':' && *code != '\0')
       code++;
-    if( *code == ':' )
+    if (*code == ':')
       code++;
-  } else if (strncasecmp(srs, "urn:EPSG:geographicCRS:",23) == 0)
+  } else if (strncasecmp(srs, "urn:EPSG:geographicCRS:", 23) == 0)
     code = srs + 23;
   else
     return MS_FALSE;
 
-  snprintf( epsg_string, sizeof(epsg_string), "EPSG:%s", code );
+  snprintf(epsg_string, sizeof(epsg_string), "EPSG:%s", code);
 
-  tokens = msStringSplit(pszList, ' ', &nTokens );
+  tokens = msStringSplit(pszList, ' ', &nTokens);
   if (tokens && nTokens > 0) {
-    for (i=0; i<nTokens; i++) {
-      if (strcasecmp(tokens[i],  epsg_string) == 0) {
+    for (i = 0; i < nTokens; i++) {
+      if (strcasecmp(tokens[i], epsg_string) == 0) {
         bFound = MS_TRUE;
         break;
       }
@@ -359,32 +348,35 @@ int msWFSLocateSRSInList(const char *psz
 
 /* msWFSGetFeatureApplySRS()
 **
-** Utility function called from msWFSGetFeature. It is assumed that at this point
+** Utility function called from msWFSGetFeature. It is assumed that at this
+*point
 ** all queried layers are turned ON
 */
-static int msWFSGetFeatureApplySRS(mapObj *map, const char *srs, int nWFSVersion)
-{
-  char *pszMapSRS=NULL;
-  char *pszOutputSRS=NULL;
+static int msWFSGetFeatureApplySRS(mapObj *map, const char *srs,
+                                   int nWFSVersion) {
+  char *pszMapSRS = NULL;
+  char *pszOutputSRS = NULL;
   layerObj *lp;
   int i;
 
   /*validation of SRS
-    - wfs 1.0 does not have an srsname parameter so all queried layers should be advertized using the
-      same srs. For wfs 1.1.0 an srsName can be passed, we should validate that It is valid for all
-      queries layers
+    - wfs 1.0 does not have an srsname parameter so all queried layers should be
+    advertized using the same srs. For wfs 1.1.0 an srsName can be passed, we
+    should validate that It is valid for all queries layers
   */
 
-  /* Start by applying the default service SRS to the mapObj, 
-   * make sure we reproject the map extent if a projection was 
-   * already set 
+  /* Start by applying the default service SRS to the mapObj,
+   * make sure we reproject the map extent if a projection was
+   * already set
    */
-  msOWSGetEPSGProj(&(map->projection), &(map->web.metadata), "FO", MS_TRUE, &pszMapSRS);
-  if(pszMapSRS && nWFSVersion >  OWS_1_0_0){
+  msOWSGetEPSGProj(&(map->projection), &(map->web.metadata), "FO", MS_TRUE,
+                   &pszMapSRS);
+  if (pszMapSRS && nWFSVersion > OWS_1_0_0) {
     projectionObj proj;
     msInitProjection(&proj);
     msProjectionInheritContextFrom(&proj, &(map->projection));
-    if (map->projection.numargs > 0 && msLoadProjectionStringEPSG(&proj, pszMapSRS) == 0) {
+    if (map->projection.numargs > 0 &&
+        msLoadProjectionStringEPSG(&proj, pszMapSRS) == 0) {
       msProjectRect(&(map->projection), &proj, &map->extent);
     }
     msLoadProjectionStringEPSG(&(map->projection), pszMapSRS);
@@ -392,7 +384,7 @@ static int msWFSGetFeatureApplySRS(mapOb
   }
 
   if (srs == NULL || nWFSVersion == OWS_1_0_0) {
-    for (i=0; i<map->numlayers; i++) {
+    for (i = 0; i < map->numlayers; i++) {
       char *pszLayerSRS;
       lp = GET_LAYER(map, i);
       if (lp->status != MS_ON)
@@ -401,11 +393,13 @@ static int msWFSGetFeatureApplySRS(mapOb
       if (pszMapSRS)
         pszLayerSRS = pszMapSRS;
       else
-        msOWSGetEPSGProj(&(lp->projection), &(lp->metadata), "FO", MS_TRUE, &pszLayerSRS);
+        msOWSGetEPSGProj(&(lp->projection), &(lp->metadata), "FO", MS_TRUE,
+                         &pszLayerSRS);
 
       if (pszLayerSRS == NULL) {
         msSetError(MS_WFSERR,
-                   "Server config error: SRS must be set at least at the map or at the layer level.",
+                   "Server config error: SRS must be set at least at the map "
+                   "or at the layer level.",
                    "msWFSGetFeature()");
         if (pszOutputSRS)
           msFree(pszOutputSRS);
@@ -414,52 +408,60 @@ static int msWFSGetFeatureApplySRS(mapOb
       }
       if (pszOutputSRS == NULL)
         pszOutputSRS = msStrdup(pszLayerSRS);
-      else if (strcasecmp(pszLayerSRS,pszOutputSRS) != 0) {
-        msSetError(MS_WFSERR,
-                   "Invalid GetFeature Request: All TYPENAMES in a single GetFeature request must have been advertized in the same SRS.  Please check the capabilities and reformulate your request.",
-                   "msWFSGetFeature()");
+      else if (strcasecmp(pszLayerSRS, pszOutputSRS) != 0) {
+        msSetError(
+            MS_WFSERR,
+            "Invalid GetFeature Request: All TYPENAMES in a single GetFeature "
+            "request must have been advertized in the same SRS.  Please check "
+            "the capabilities and reformulate your request.",
+            "msWFSGetFeature()");
         if (pszOutputSRS)
           msFree(pszOutputSRS);
-        if(pszLayerSRS != pszMapSRS)
+        if (pszLayerSRS != pszMapSRS)
           msFree(pszLayerSRS);
         msFree(pszMapSRS);
         return MS_FAILURE;
       }
-      if(pszLayerSRS != pszMapSRS)
+      if (pszLayerSRS != pszMapSRS)
         msFree(pszLayerSRS);
     }
   } else { /*srs is given so it should be valid for all layers*/
-    /*get all the srs defined at the map level and check them aginst the srsName passed
-      as argument*/
+    /*get all the srs defined at the map level and check them aginst the srsName
+      passed as argument*/
     msFree(pszMapSRS);
-    msOWSGetEPSGProj(&(map->projection), &(map->web.metadata), "FO", MS_FALSE, &pszMapSRS);
+    msOWSGetEPSGProj(&(map->projection), &(map->web.metadata), "FO", MS_FALSE,
+                     &pszMapSRS);
     if (pszMapSRS) {
       if (!msWFSLocateSRSInList(pszMapSRS, srs)) {
         msSetError(MS_WFSERR,
-                   "Invalid GetFeature Request:Invalid SRS.  Please check the capabilities and reformulate your request.",
+                   "Invalid GetFeature Request:Invalid SRS.  Please check the "
+                   "capabilities and reformulate your request.",
                    "msWFSGetFeature()");
         msFree(pszMapSRS);
         return MS_FAILURE;
       }
       pszOutputSRS = msStrdup(srs);
     } else {
-      for (i=0; i<map->numlayers; i++) {
-        char *pszLayerSRS=NULL;
+      for (i = 0; i < map->numlayers; i++) {
+        char *pszLayerSRS = NULL;
         lp = GET_LAYER(map, i);
         if (lp->status != MS_ON)
           continue;
 
-        msOWSGetEPSGProj(&(lp->projection), &(lp->metadata), "FO", MS_FALSE, &pszLayerSRS);
+        msOWSGetEPSGProj(&(lp->projection), &(lp->metadata), "FO", MS_FALSE,
+                         &pszLayerSRS);
         if (!pszLayerSRS) {
           msSetError(MS_WFSERR,
-                     "Server config error: SRS must be set at least at the map or at the layer level.",
+                     "Server config error: SRS must be set at least at the map "
+                     "or at the layer level.",
                      "msWFSGetFeature()");
           msFree(pszMapSRS);
           return MS_FAILURE;
         }
         if (!msWFSLocateSRSInList(pszLayerSRS, srs)) {
           msSetError(MS_WFSERR,
-                     "Invalid GetFeature Request:Invalid SRS.  Please check the capabilities and reformulate your request.",
+                     "Invalid GetFeature Request:Invalid SRS.  Please check "
+                     "the capabilities and reformulate your request.",
                      "msWFSGetFeature()");
           msFree(pszMapSRS);
           msFree(pszLayerSRS);
@@ -473,11 +475,11 @@ static int msWFSGetFeatureApplySRS(mapOb
 
   if (pszOutputSRS) {
     projectionObj sProjTmp;
-    int nTmp=0;
+    int nTmp = 0;
 
     msInitProjection(&sProjTmp);
     msProjectionInheritContextFrom(&sProjTmp, &(map->projection));
-    if( nWFSVersion >= OWS_1_1_0 ) {
+    if (nWFSVersion >= OWS_1_1_0) {
       nTmp = msLoadProjectionStringEPSG(&(sProjTmp), pszOutputSRS);
     } else {
       nTmp = msLoadProjectionString(&(sProjTmp), pszOutputSRS);
@@ -488,20 +490,21 @@ static int msWFSGetFeatureApplySRS(mapOb
     msFreeProjection(&(sProjTmp));
 
     if (nTmp != 0) {
-      msSetError(MS_WFSERR, "msLoadProjectionString() failed", "msWFSGetFeature()");
+      msSetError(MS_WFSERR, "msLoadProjectionString() failed",
+                 "msWFSGetFeature()");
       return MS_FAILURE;
     }
 
     /*we load the projection sting in the map and possibly
     set the axis order*/
-    if( nWFSVersion >= OWS_1_1_0 ) {
+    if (nWFSVersion >= OWS_1_1_0) {
       msLoadProjectionStringEPSG(&(map->projection), pszOutputSRS);
     } else {
       msLoadProjectionString(&(map->projection), pszOutputSRS);
     }
 
     nTmp = GetMapserverUnitUsingProj(&(map->projection));
-    if( nTmp != -1 ) {
+    if (nTmp != -1) {
       map->units = static_cast<MS_UNITS>(nTmp);
     }
   }
@@ -511,54 +514,50 @@ static int msWFSGetFeatureApplySRS(mapOb
   return MS_SUCCESS;
 }
 
-
 /* msWFSIsLayerSupported()
 **
 ** Returns true (1) is this layer meets the requirements to be served as
 ** a WFS feature type.
 */
-int msWFSIsLayerSupported(layerObj *lp)
-{
+int msWFSIsLayerSupported(layerObj *lp) {
   /* In order to be supported, lp->type must be specified, even for
   ** layers that are OGR, SDE, SDO, etc connections.
   */
-  if ((lp->type == MS_LAYER_POINT ||
-       lp->type == MS_LAYER_LINE ||
-       lp->type == MS_LAYER_POLYGON ) &&
-      lp->connectiontype != MS_WMS &&
-      lp->connectiontype != MS_GRATICULE) {
+  if ((lp->type == MS_LAYER_POINT || lp->type == MS_LAYER_LINE ||
+       lp->type == MS_LAYER_POLYGON) &&
+      lp->connectiontype != MS_WMS && lp->connectiontype != MS_GRATICULE) {
     return 1; /* true */
   }
 
   return 0; /* false */
 }
 
-static int msWFSIsLayerAllowed(layerObj *lp, owsRequestObj *ows_request)
-{
-    return msWFSIsLayerSupported(lp) &&
-           (msIntegerInArray(lp->index, ows_request->enabled_layers, ows_request->numlayers));
+static int msWFSIsLayerAllowed(layerObj *lp, owsRequestObj *ows_request) {
+  return msWFSIsLayerSupported(lp) &&
+         (msIntegerInArray(lp->index, ows_request->enabled_layers,
+                           ows_request->numlayers));
 }
 
-static layerObj* msWFSGetLayerByName(mapObj* map, owsRequestObj *ows_request, const char* name)
-{
-    int j;
-    for (j=0; j<map->numlayers; j++) {
-        layerObj *lp;
+static layerObj *msWFSGetLayerByName(mapObj *map, owsRequestObj *ows_request,
+                                     const char *name) {
+  int j;
+  for (j = 0; j < map->numlayers; j++) {
+    layerObj *lp;
 
-        lp = GET_LAYER(map, j);
+    lp = GET_LAYER(map, j);
 
-        if (msWFSIsLayerAllowed(lp, ows_request) && lp->name && (strcasecmp(lp->name, name) == 0)) {
-            return lp;
-        }
+    if (msWFSIsLayerAllowed(lp, ows_request) && lp->name &&
+        (strcasecmp(lp->name, name) == 0)) {
+      return lp;
     }
-    return NULL;
+  }
+  return NULL;
 }
 
 /*
 ** msWFSDumpLayer()
 */
-int msWFSDumpLayer(mapObj *map, layerObj *lp, const char *script_url_encoded)
-{
+int msWFSDumpLayer(mapObj *map, layerObj *lp, const char *script_url_encoded) {
   rectObj ext;
   char *pszWfsSrs = NULL;
   projectionObj poWfs;
@@ -567,22 +566,23 @@ int msWFSDumpLayer(mapObj *map, layerObj
 
   if (lp->name && strlen(lp->name) > 0 &&
       (msIsXMLTagValid(lp->name) == MS_FALSE || isdigit(lp->name[0])))
-    msIO_fprintf(stdout, "<!-- WARNING: The layer name '%s' might contain spaces or "
-                 "invalid characters or may start with a number. This could lead to potential problems. -->\n",lp->name);
+    msIO_fprintf(stdout,
+                 "<!-- WARNING: The layer name '%s' might contain spaces or "
+                 "invalid characters or may start with a number. This could "
+                 "lead to potential problems. -->\n",
+                 lp->name);
 
   msOWSPrintEncodeParam(stdout, "LAYER.NAME", lp->name, OWS_WARN,
                         "        <Name>%s</Name>\n", NULL);
 
-  msOWSPrintEncodeMetadata(stdout, &(lp->metadata), "FO", "title",
-                           OWS_WARN, "        <Title>%s</Title>\n", lp->name);
+  msOWSPrintEncodeMetadata(stdout, &(lp->metadata), "FO", "title", OWS_WARN,
+                           "        <Title>%s</Title>\n", lp->name);
 
-  msOWSPrintEncodeMetadata(stdout, &(lp->metadata), "FO", "abstract",
-                           OWS_NOERR, "        <Abstract>%s</Abstract>\n", NULL);
+  msOWSPrintEncodeMetadata(stdout, &(lp->metadata), "FO", "abstract", OWS_NOERR,
+                           "        <Abstract>%s</Abstract>\n", NULL);
 
-  msOWSPrintEncodeMetadataList(stdout, &(lp->metadata), "FO",
-                               "keywordlist",
-                               "        <Keywords>\n",
-                               "        </Keywords>\n",
+  msOWSPrintEncodeMetadataList(stdout, &(lp->metadata), "FO", "keywordlist",
+                               "        <Keywords>\n", "        </Keywords>\n",
                                "          %s\n", NULL);
 
   /* In WFS, every layer must have exactly one SRS and there is none at */
@@ -596,16 +596,20 @@ int msWFSDumpLayer(mapObj *map, layerObj
   /* each layer is advertized in its own projection as defined in the */
   /* layer's projection object or wfs_srs metadata. */
   /*  */
-  
+
   /* if Map has a SRS,  Use it for all layers. */
-  msOWSGetEPSGProj(&(map->projection),&(map->web.metadata),"FO",MS_TRUE, &pszWfsSrs);
-  if(!pszWfsSrs) {
+  msOWSGetEPSGProj(&(map->projection), &(map->web.metadata), "FO", MS_TRUE,
+                   &pszWfsSrs);
+  if (!pszWfsSrs) {
     /* Map has no SRS.  Use layer SRS or produce a warning. */
-    msOWSGetEPSGProj(&(lp->projection),&(lp->metadata), "FO", MS_TRUE, &pszWfsSrs);
+    msOWSGetEPSGProj(&(lp->projection), &(lp->metadata), "FO", MS_TRUE,
+                     &pszWfsSrs);
   }
 
-  msOWSPrintEncodeParam(stdout, "(at least one of) MAP.PROJECTION, LAYER.PROJECTION or wfs_srs metadata",
-                        pszWfsSrs, OWS_WARN, "        <SRS>%s</SRS>\n", NULL);
+  msOWSPrintEncodeParam(
+      stdout,
+      "(at least one of) MAP.PROJECTION, LAYER.PROJECTION or wfs_srs metadata",
+      pszWfsSrs, OWS_WARN, "        <SRS>%s</SRS>\n", NULL);
 
   /* If layer has no proj set then use map->proj for bounding box. */
   if (msOWSGetLayerExtent(map, lp, "FO", &ext) == MS_SUCCESS) {
@@ -614,47 +618,53 @@ int msWFSDumpLayer(mapObj *map, layerObj
     if (pszWfsSrs != NULL)
       msLoadProjectionString(&(poWfs), pszWfsSrs);
 
-    if(lp->projection.numargs > 0) {
-      msOWSPrintLatLonBoundingBox(stdout, "        ", &(ext),
-                                  &(lp->projection), &(poWfs), OWS_WFS);
+    if (lp->projection.numargs > 0) {
+      msOWSPrintLatLonBoundingBox(stdout, "        ", &(ext), &(lp->projection),
+                                  &(poWfs), OWS_WFS);
     } else {
       msOWSPrintLatLonBoundingBox(stdout, "        ", &(ext),
                                   &(map->projection), &(poWfs), OWS_WFS);
     }
     msFreeProjection(&poWfs);
   } else {
-    msIO_printf("<!-- WARNING: Optional LatLongBoundingBox could not be established for this layer.  Consider setting the EXTENT in the LAYER object, or wfs_extent metadata. Also check that your data exists in the DATA statement -->\n");
+    msIO_printf("<!-- WARNING: Optional LatLongBoundingBox could not be "
+                "established for this layer.  Consider setting the EXTENT in "
+                "the LAYER object, or wfs_extent metadata. Also check that "
+                "your data exists in the DATA statement -->\n");
   }
 
-  const char* metadataurl_list = msOWSLookupMetadata(&(lp->metadata), "FO", "metadataurl_list");
-  if( metadataurl_list ) {
+  const char *metadataurl_list =
+      msOWSLookupMetadata(&(lp->metadata), "FO", "metadataurl_list");
+  if (metadataurl_list) {
     int ntokens = 0;
-    char** tokens = msStringSplit(metadataurl_list, ' ', &ntokens);
-    for( int i = 0; i < ntokens; i++ )
-    {
+    char **tokens = msStringSplit(metadataurl_list, ' ', &ntokens);
+    for (int i = 0; i < ntokens; i++) {
       std::string key("metadataurl_");
       key += tokens[i];
-      msOWSPrintURLType(stdout, &(lp->metadata), "FO", key.c_str(),
-                    OWS_WARN, NULL, "MetadataURL", " type=\"%s\"",
-                    NULL, NULL, " format=\"%s\"", "%s",
-                    MS_TRUE, MS_FALSE, MS_FALSE, MS_TRUE, MS_TRUE,
-                    NULL, NULL, NULL, NULL, NULL, "        ");
+      msOWSPrintURLType(stdout, &(lp->metadata), "FO", key.c_str(), OWS_WARN,
+                        NULL, "MetadataURL", " type=\"%s\"", NULL, NULL,
+                        " format=\"%s\"", "%s", MS_TRUE, MS_FALSE, MS_FALSE,
+                        MS_TRUE, MS_TRUE, NULL, NULL, NULL, NULL, NULL,
+                        "        ");
     }
     msFreeCharArray(tokens, ntokens);
-  }
-  else {
-    if (! msOWSLookupMetadata(&(lp->metadata), "FO", "metadataurl_href"))
+  } else {
+    if (!msOWSLookupMetadata(&(lp->metadata), "FO", "metadataurl_href"))
       msMetadataSetGetMetadataURL(lp, script_url_encoded);
 
-    msOWSPrintURLType(stdout, &(lp->metadata), "FO", "metadataurl",
-                      OWS_WARN, NULL, "MetadataURL", " type=\"%s\"",
-                      NULL, NULL, " format=\"%s\"", "%s",
-                      MS_TRUE, MS_FALSE, MS_FALSE, MS_TRUE, MS_TRUE,
-                      NULL, NULL, NULL, NULL, NULL, "        ");
+    msOWSPrintURLType(stdout, &(lp->metadata), "FO", "metadataurl", OWS_WARN,
+                      NULL, "MetadataURL", " type=\"%s\"", NULL, NULL,
+                      " format=\"%s\"", "%s", MS_TRUE, MS_FALSE, MS_FALSE,
+                      MS_TRUE, MS_TRUE, NULL, NULL, NULL, NULL, NULL,
+                      "        ");
   }
 
   if (msOWSLookupMetadata(&(lp->metadata), "OFG", "featureid") == NULL) {
-    msIO_fprintf(stdout, "<!-- WARNING: Required Feature Id attribute (fid) not specified for this feature type. Make sure you set one of wfs_featureid, ows_featureid or gml_featureid metadata. -->\n");
+    msIO_fprintf(
+        stdout,
+        "<!-- WARNING: Required Feature Id attribute (fid) not specified for "
+        "this feature type. Make sure you set one of wfs_featureid, "
+        "ows_featureid or gml_featureid metadata. -->\n");
   }
 
   msIO_printf("    </FeatureType>\n");
@@ -666,90 +676,104 @@ int msWFSDumpLayer(mapObj *map, layerObj
 /*
 ** msWFSHandleUpdateSequence()
 */
-int msWFSHandleUpdateSequence(mapObj *map, wfsParamsObj *params, const char* pszFunction)
-{
+int msWFSHandleUpdateSequence(mapObj *map, wfsParamsObj *params,
+                              const char *pszFunction) {
   /* -------------------------------------------------------------------- */
   /*      Handle updatesequence                                           */
   /* -------------------------------------------------------------------- */
 
-  const char* updatesequence = msOWSLookupMetadata(&(map->web.metadata), "FO", "updatesequence");
+  const char *updatesequence =
+      msOWSLookupMetadata(&(map->web.metadata), "FO", "updatesequence");
 
   if (params->pszUpdateSequence != NULL) {
-    int i = msOWSNegotiateUpdateSequence(params->pszUpdateSequence, updatesequence);
+    int i =
+        msOWSNegotiateUpdateSequence(params->pszUpdateSequence, updatesequence);
     if (i == 0) { /* current */
-      msSetError(MS_WFSERR, "UPDATESEQUENCE parameter (%s) is equal to server (%s)", pszFunction, params->pszUpdateSequence, updatesequence);
+      msSetError(MS_WFSERR,
+                 "UPDATESEQUENCE parameter (%s) is equal to server (%s)",
+                 pszFunction, params->pszUpdateSequence, updatesequence);
       /* FIXME? : according to table 7 of OWS 1.1, we should return a service */
-      /* metadata document with only “version” and “updateSequence” parameters */
-      return msWFSException(map, "updatesequence", "CurrentUpdateSequence", params->pszVersion);
+      /* metadata document with only “version” and “updateSequence” parameters
+       */
+      return msWFSException(map, "updatesequence", "CurrentUpdateSequence",
+                            params->pszVersion);
     }
     if (i > 0) { /* invalid */
-      msSetError(MS_WFSERR, "UPDATESEQUENCE parameter (%s) is higher than server (%s)", pszFunction, params->pszUpdateSequence, updatesequence);
+      msSetError(MS_WFSERR,
+                 "UPDATESEQUENCE parameter (%s) is higher than server (%s)",
+                 pszFunction, params->pszUpdateSequence, updatesequence);
       /* locator must be NULL. See Table 25 of OWS 1.1 */
-      return msWFSExceptionNoLocator(map, "updatesequence", MS_OWS_ERROR_INVALID_UPDATE_SEQUENCE, params->pszVersion);
+      return msWFSExceptionNoLocator(map, "updatesequence",
+                                     MS_OWS_ERROR_INVALID_UPDATE_SEQUENCE,
+                                     params->pszVersion);
     }
   }
-  
+
   return MS_SUCCESS;
 }
 
-
 /*
 ** msWFSGetCapabilitiesNegotiateVersion()
 */
-static int msWFSGetCapabilitiesNegotiateVersion(mapObj *map, wfsParamsObj *wfsparams)
-{
+static int msWFSGetCapabilitiesNegotiateVersion(mapObj *map,
+                                                wfsParamsObj *wfsparams) {
   int iVersion = -1;
   char tmpString[OWS_VERSION_MAXLEN];
 
   /* acceptversions: do OWS Common style of version negotiation */
-  if (wfsparams->pszAcceptVersions && strlen(wfsparams->pszAcceptVersions) > 0) {
+  if (wfsparams->pszAcceptVersions &&
+      strlen(wfsparams->pszAcceptVersions) > 0) {
     char **tokens;
     int i, j;
 
     tokens = msStringSplit(wfsparams->pszAcceptVersions, ',', &j);
-    for (i=0; i<j; i++) {
+    for (i = 0; i < j; i++) {
       iVersion = msOWSParseVersionString(tokens[i]);
 
       if (iVersion < 0) {
-        msSetError(MS_WFSERR, "Invalid version format : %s.", "msWFSGetCapabilities()", tokens[i]);
+        msSetError(MS_WFSERR, "Invalid version format : %s.",
+                   "msWFSGetCapabilities()", tokens[i]);
         msFreeCharArray(tokens, j);
-        return msWFSException(map, "acceptversions", MS_OWS_ERROR_INVALID_PARAMETER_VALUE,NULL);
+        return msWFSException(map, "acceptversions",
+                              MS_OWS_ERROR_INVALID_PARAMETER_VALUE, NULL);
       }
 
       /* negotiate version */
-      iVersion = msOWSCommonNegotiateVersion(iVersion, wfsSupportedVersions, wfsNumSupportedVersions);
+      iVersion = msOWSCommonNegotiateVersion(iVersion, wfsSupportedVersions,
+                                             wfsNumSupportedVersions);
       if (iVersion != -1)
         break;
     }
     msFreeCharArray(tokens, j);
-    if(iVersion == -1) {
-      msSetError(MS_WFSERR, "ACCEPTVERSIONS list (%s) does not match supported versions", "msWFSGetCapabilities()", wfsparams->pszAcceptVersions);
+    if (iVersion == -1) {
+      msSetError(MS_WFSERR,
+                 "ACCEPTVERSIONS list (%s) does not match supported versions",
+                 "msWFSGetCapabilities()", wfsparams->pszAcceptVersions);
       /* locator must be NULL. See Table 25 of OWS 1.1 */
-      return msWFSExceptionNoLocator(map, "acceptversions", MS_OWS_ERROR_VERSION_NEGOTIATION_FAILED,NULL);
+      return msWFSExceptionNoLocator(
+          map, "acceptversions", MS_OWS_ERROR_VERSION_NEGOTIATION_FAILED, NULL);
     }
   } else {
     /* negotiate version */
     int tmpInt;
     iVersion = msOWSParseVersionString(wfsparams->pszVersion);
-    if( iVersion < 0 )
-    {
-        return msWFSException(map, "version", MS_OWS_ERROR_INVALID_PARAMETER_VALUE, NULL);
+    if (iVersion < 0) {
+      return msWFSException(map, "version",
+                            MS_OWS_ERROR_INVALID_PARAMETER_VALUE, NULL);
     }
-    tmpInt = msOWSCommonNegotiateVersion(iVersion, wfsSupportedVersions, wfsNumSupportedVersions);
+    tmpInt = msOWSCommonNegotiateVersion(iVersion, wfsSupportedVersions,
+                                         wfsNumSupportedVersions);
     /* Old style negociation : paragraph D.11 of OWS 1.1.0 spec */
-    if( tmpInt < 0 )
-    {
-        int i;
-        for( i = 0 ; i < wfsNumSupportedVersions; i++ )
-        {
-            if( iVersion >= wfsSupportedVersions[i] )
-            {
-                iVersion = wfsSupportedVersions[i];
-                break;
-            }
+    if (tmpInt < 0) {
+      int i;
+      for (i = 0; i < wfsNumSupportedVersions; i++) {
+        if (iVersion >= wfsSupportedVersions[i]) {
+          iVersion = wfsSupportedVersions[i];
+          break;
         }
-        if( i == wfsNumSupportedVersions )
-            iVersion = wfsSupportedVersions[wfsNumSupportedVersions - 1];
+      }
+      if (i == wfsNumSupportedVersions)
+        iVersion = wfsSupportedVersions[wfsNumSupportedVersions - 1];
     }
   }
 
@@ -761,62 +785,64 @@ static int msWFSGetCapabilitiesNegotiate
   return MS_SUCCESS;
 }
 
-
 /*
 ** msWFSGetCapabilities()
 */
-int msWFSGetCapabilities(mapObj *map, wfsParamsObj *wfsparams, cgiRequestObj *req, owsRequestObj *ows_request)
-{
-  char *script_url=NULL, *script_url_encoded;
-  const char *updatesequence=NULL;
-  const char *wmtver=NULL;
+int msWFSGetCapabilities(mapObj *map, wfsParamsObj *wfsparams,
+                         cgiRequestObj *req, owsRequestObj *ows_request) {
+  char *script_url = NULL, *script_url_encoded;
+  const char *updatesequence = NULL;
+  const char *wmtver = NULL;
   char *formats_list;
   int ret;
   int iVersion;
-  int i=0;
-  
+  int i = 0;
+
   ret = msWFSGetCapabilitiesNegotiateVersion(map, wfsparams);
-  if( ret != MS_SUCCESS )
-      return ret;
+  if (ret != MS_SUCCESS)
+    return ret;
 
   iVersion = msOWSParseVersionString(wfsparams->pszVersion);
-  if( iVersion == OWS_2_0_0 )
-    return msWFSGetCapabilities20( map, wfsparams, req, ows_request);
-  if( iVersion == OWS_1_1_0 )
-    return msWFSGetCapabilities11( map, wfsparams, req, ows_request);
+  if (iVersion == OWS_2_0_0)
+    return msWFSGetCapabilities20(map, wfsparams, req, ows_request);
+  if (iVersion == OWS_1_1_0)
+    return msWFSGetCapabilities11(map, wfsparams, req, ows_request);
 
   /* Decide which version we're going to return... only 1.0.0 for now */
   wmtver = "1.0.0";
 
   /* We need this server's onlineresource. */
-  if ((script_url=msOWSGetOnlineResource(map, "FO", "onlineresource", req)) == NULL ||
+  if ((script_url = msOWSGetOnlineResource(map, "FO", "onlineresource", req)) ==
+          NULL ||
       (script_url_encoded = msEncodeHTMLEntities(script_url)) == NULL) {
     msSetError(MS_WFSERR, "Server URL not found", "msWFSGetCapabilities()");
-    return msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE, wmtver);
+    return msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE,
+                          wmtver);
   }
   free(script_url);
   script_url = NULL;
 
   ret = msWFSHandleUpdateSequence(map, wfsparams, "msWFSGetCapabilities()");
-  if( ret != MS_SUCCESS )
-  {
-      free(script_url_encoded);
-      return ret;
+  if (ret != MS_SUCCESS) {
+    free(script_url_encoded);
+    return ret;
   }
 
-  msIO_setHeader("Content-Type","text/xml; charset=UTF-8");
+  msIO_setHeader("Content-Type", "text/xml; charset=UTF-8");
   msIO_sendHeaders();
 
   msIO_printf("<?xml version='1.0' encoding=\"UTF-8\" ?>\n");
 
-  updatesequence = msOWSLookupMetadata(&(map->web.metadata), "FO", "updatesequence");
+  updatesequence =
+      msOWSLookupMetadata(&(map->web.metadata), "FO", "updatesequence");
   msIO_printf("<WFS_Capabilities \n"
               "   version=\"%s\" \n"
               "   updateSequence=\"%s\" \n"
               "   xmlns=\"http://www.opengis.net/wfs\" \n"
               "   xmlns:ogc=\"http://www.opengis.net/ogc\" \n"
               "   xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n"
-              "   xsi:schemaLocation=\"http://www.opengis.net/wfs %s/wfs/%s/WFS-capabilities.xsd\">\n",
+              "   xsi:schemaLocation=\"http://www.opengis.net/wfs "
+              "%s/wfs/%s/WFS-capabilities.xsd\">\n",
               wmtver, updatesequence ? updatesequence : "0",
               msOWSGetSchemasLocation(map), wmtver);
 
@@ -826,32 +852,30 @@ int msWFSGetCapabilities(mapObj *map, wf
   msIO_printf("<Service>\n");
   msIO_printf("  <Name>MapServer WFS</Name>\n");
 
-  /* the majority of this section is dependent on appropriately named metadata in the WEB object */
+  /* the majority of this section is dependent on appropriately named metadata
+   * in the WEB object */
   msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "FO", "title",
                            OWS_WARN, "  <Title>%s</Title>\n", map->name);
   msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "FO", "abstract",
                            OWS_NOERR, "  <Abstract>%s</Abstract>\n", NULL);
 
   msOWSPrintEncodeMetadataList(stdout, &(map->web.metadata), "FO",
-                               "keywordlist",
-                               "  <Keywords>\n", "  </Keywords>\n",
-                               "    %s\n", NULL);
+                               "keywordlist", "  <Keywords>\n",
+                               "  </Keywords>\n", "    %s\n", NULL);
 
   /* Service/onlineresource */
-  /* Defaults to same as request onlineresource if wfs_service_onlineresource  */
+  /* Defaults to same as request onlineresource if wfs_service_onlineresource */
   /* is not set. */
-  msOWSPrintEncodeMetadata(stdout, &(map->web.metadata),
-                           "FO", "service_onlineresource", OWS_NOERR,
-                           "  <OnlineResource>%s</OnlineResource>\n",
-                           script_url_encoded);
+  msOWSPrintEncodeMetadata(
+      stdout, &(map->web.metadata), "FO", "service_onlineresource", OWS_NOERR,
+      "  <OnlineResource>%s</OnlineResource>\n", script_url_encoded);
 
   msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "FO", "fees",
                            OWS_NOERR, "  <Fees>%s</Fees>\n", NULL);
 
-  msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "FO",
-                           "accessconstraints", OWS_NOERR,
-                           "  <AccessConstraints>%s</AccessConstraints>\n",
-                           NULL);
+  msOWSPrintEncodeMetadata(
+      stdout, &(map->web.metadata), "FO", "accessconstraints", OWS_NOERR,
+      "  <AccessConstraints>%s</AccessConstraints>\n", NULL);
 
   msIO_printf("</Service>\n\n");
 
@@ -862,19 +886,22 @@ int msWFSGetCapabilities(mapObj *map, wf
   msIO_printf("<Capability>\n");
 
   msIO_printf("  <Request>\n");
-  msWFSPrintRequestCap("GetCapabilities", script_url_encoded,
-                       NULL, NULL);
-  /* msWFSPrintRequestCap("DescribeFeatureType", script_url_encoded, "SchemaDescriptionLanguage", "XMLSCHEMA", "SFE_XMLSCHEMA", NULL); */
-  /* msWFSPrintRequestCap("GetFeature", script_url_encoded, "ResultFormat", "GML2", "GML3", NULL); */
+  msWFSPrintRequestCap("GetCapabilities", script_url_encoded, NULL, NULL);
+  /* msWFSPrintRequestCap("DescribeFeatureType", script_url_encoded,
+   * "SchemaDescriptionLanguage", "XMLSCHEMA", "SFE_XMLSCHEMA", NULL); */
+  /* msWFSPrintRequestCap("GetFeature", script_url_encoded, "ResultFormat",
+   * "GML2", "GML3", NULL); */
 
   /* don't advertise the GML3 or GML for SFE support */
   if (msOWSRequestIsEnabled(map, NULL, "F", "DescribeFeatureType", MS_TRUE))
-    msWFSPrintRequestCap("DescribeFeatureType", script_url_encoded, "SchemaDescriptionLanguage", "XMLSCHEMA" );
+    msWFSPrintRequestCap("DescribeFeatureType", script_url_encoded,
+                         "SchemaDescriptionLanguage", "XMLSCHEMA");
 
   if (msOWSRequestIsEnabled(map, NULL, "F", "GetFeature", MS_TRUE)) {
-    formats_list = msWFSGetOutputFormatList( map, NULL, OWS_1_0_0 );
-    msWFSPrintRequestCap("GetFeature", script_url_encoded, "ResultFormat", formats_list );
-    msFree( formats_list );
+    formats_list = msWFSGetOutputFormatList(map, NULL, OWS_1_0_0);
+    msWFSPrintRequestCap("GetFeature", script_url_encoded, "ResultFormat",
+                         formats_list);
+    msFree(formats_list);
   }
 
   msIO_printf("  </Request>\n");
@@ -892,7 +919,7 @@ int msWFSGetCapabilities(mapObj *map, wf
   msIO_printf("    <Query/>\n");
   msIO_printf("  </Operations>\n");
 
-  for(i=0; i<map->numlayers; i++) {
+  for (i = 0; i < map->numlayers; i++) {
     layerObj *lp;
     lp = GET_LAYER(map, i);
 
@@ -906,7 +933,6 @@ int msWFSGetCapabilities(mapObj *map, wf
 
   msIO_printf("</FeatureTypeList>\n\n");
 
-
   /*
   ** OGC Filter Capabilities ... for now we support only BBOX
   */
@@ -954,83 +980,96 @@ int msWFSGetCapabilities(mapObj *map, wf
 ** Helper functions for producing XML schema.
 */
 
-static const char *msWFSGetGeometryType(const char *type, OWSGMLVersion outputformat)
-{
-  if(!type) return "GeometryPropertyType";
-
-  if(strcasecmp(type, "point") == 0) {
-    switch(outputformat) {
-      case OWS_GML2:
-      case OWS_GML3:
-      case OWS_GML32:
-        return "PointPropertyType";
-    }
-  } else if(strcasecmp(type, "multipoint") == 0) {
-    switch(outputformat) {
-      case OWS_GML2:
-      case OWS_GML3:
-      case OWS_GML32:
-        return "MultiPointPropertyType";
-    }
-  } else if(strcasecmp(type, "line") == 0) {
-    switch(outputformat) {
-      case OWS_GML2:
-        return "LineStringPropertyType";
-      case OWS_GML3:
-      case OWS_GML32:
-        return "CurvePropertyType";
-    }
-  } else if(strcasecmp(type, "multiline") == 0) {
-    switch(outputformat) {
-      case OWS_GML2:
-        return "MultiLineStringPropertyType";
-      case OWS_GML3:
-      case OWS_GML32:
-        return "MultiCurvePropertyType";
-    }
-  } else if(strcasecmp(type, "polygon") == 0) {
-    switch(outputformat) {
-      case OWS_GML2:
-        return "PolygonPropertyType";
-      case OWS_GML3:
-      case OWS_GML32:
-        return "SurfacePropertyType";
-    }
-  } else if(strcasecmp(type, "multipolygon") == 0) {
-    switch(outputformat) {
-      case OWS_GML2:
-        return "MultiPolygonPropertyType";
-      case OWS_GML3:
-      case OWS_GML32:
-        return "MultiSurfacePropertyType";
+static const char *msWFSGetGeometryType(const char *type,
+                                        OWSGMLVersion outputformat) {
+  if (!type)
+    return "GeometryPropertyType";
+
+  if (strcasecmp(type, "point") == 0) {
+    switch (outputformat) {
+    case OWS_GML2:
+    case OWS_GML3:
+    case OWS_GML32:
+      return "PointPropertyType";
+    }
+  } else if (strcasecmp(type, "multipoint") == 0) {
+    switch (outputformat) {
+    case OWS_GML2:
+    case OWS_GML3:
+    case OWS_GML32:
+      return "MultiPointPropertyType";
+    }
+  } else if (strcasecmp(type, "line") == 0) {
+    switch (outputformat) {
+    case OWS_GML2:
+      return "LineStringPropertyType";
+    case OWS_GML3:
+    case OWS_GML32:
+      return "CurvePropertyType";
+    }
+  } else if (strcasecmp(type, "multiline") == 0) {
+    switch (outputformat) {
+    case OWS_GML2:
+      return "MultiLineStringPropertyType";
+    case OWS_GML3:
+    case OWS_GML32:
+      return "MultiCurvePropertyType";
+    }
+  } else if (strcasecmp(type, "polygon") == 0) {
+    switch (outputformat) {
+    case OWS_GML2:
+      return "PolygonPropertyType";
+    case OWS_GML3:
+    case OWS_GML32:
+      return "SurfacePropertyType";
+    }
+  } else if (strcasecmp(type, "multipolygon") == 0) {
+    switch (outputformat) {
+    case OWS_GML2:
+      return "MultiPolygonPropertyType";
+    case OWS_GML3:
+    case OWS_GML32:
+      return "MultiSurfacePropertyType";
     }
   }
 
   return "???unknown???";
 }
 
-static void msWFSWriteGeometryElement(FILE *stream, gmlGeometryListObj *geometryList, OWSGMLVersion outputformat, const char *tab)
-{
+static void msWFSWriteGeometryElement(FILE *stream,
+                                      gmlGeometryListObj *geometryList,
+                                      OWSGMLVersion outputformat,
+                                      const char *tab) {
   int i;
-  gmlGeometryObj *geometry=NULL;
+  gmlGeometryObj *geometry = NULL;
 
-  if(!stream || !tab) return;
-  if(geometryList->numgeometries == 1 && strcasecmp(geometryList->geometries[0].name, "none") == 0) return;
+  if (!stream || !tab)
+    return;
+  if (geometryList->numgeometries == 1 &&
+      strcasecmp(geometryList->geometries[0].name, "none") == 0)
+    return;
 
-  if(geometryList->numgeometries == 1) {
+  if (geometryList->numgeometries == 1) {
     geometry = &(geometryList->geometries[0]);
-    msIO_fprintf(stream, "%s<element name=\"%s\" type=\"gml:%s\" minOccurs=\"%d\"", tab, geometry->name, msWFSGetGeometryType(geometry->type, outputformat), geometry->occurmin);
-    if(geometry->occurmax == OWS_GML_OCCUR_UNBOUNDED)
+    msIO_fprintf(
+        stream, "%s<element name=\"%s\" type=\"gml:%s\" minOccurs=\"%d\"", tab,
+        geometry->name, msWFSGetGeometryType(geometry->type, outputformat),
+        geometry->occurmin);
+    if (geometry->occurmax == OWS_GML_OCCUR_UNBOUNDED)
       msIO_fprintf(stream, " maxOccurs=\"unbounded\"/>\n");
     else
       msIO_fprintf(stream, " maxOccurs=\"%d\"/>\n", geometry->occurmax);
   } else {
     msIO_fprintf(stream, "%s<choice>\n", tab);
-    for(i=0; i<geometryList->numgeometries; i++) {
+    for (i = 0; i < geometryList->numgeometries; i++) {
       geometry = &(geometryList->geometries[i]);
 
-      msIO_fprintf(stream, "  %s<element name=\"%s\" type=\"gml:%s\" minOccurs=\"%d\"", tab, geometry->name, msWFSGetGeometryType(geometry->type, outputformat), geometry->occurmin);
-      if(geometry->occurmax == OWS_GML_OCCUR_UNBOUNDED)
+      msIO_fprintf(stream,
+                   "  %s<element name=\"%s\" type=\"gml:%s\" minOccurs=\"%d\"",
+                   tab, geometry->name,
+                   msWFSGetGeometryType(geometry->type, outputformat),
+                   geometry->occurmin);
+      if (geometry->occurmax == OWS_GML_OCCUR_UNBOUNDED)
         msIO_fprintf(stream, " maxOccurs=\"unbounded\"/>\n");
       else
         msIO_fprintf(stream, " maxOccurs=\"%d\"/>\n", geometry->occurmax);
@@ -1041,110 +1080,121 @@ static void msWFSWriteGeometryElement(FI
   return;
 }
 
-static OWSGMLVersion msWFSGetGMLVersionFromSchemaVersion(WFSSchemaVersion outputformat)
-{
-    switch( outputformat )
-    {
-        case OWS_DEFAULT_SCHEMA:
-            return OWS_GML2;
-        case OWS_SFE_SCHEMA:
-            return OWS_GML3;
-        case OWS_GML32_SFE_SCHEMA:
-            return OWS_GML32;
-    }
+static OWSGMLVersion
+msWFSGetGMLVersionFromSchemaVersion(WFSSchemaVersion outputformat) {
+  switch (outputformat) {
+  case OWS_DEFAULT_SCHEMA:
     return OWS_GML2;
+  case OWS_SFE_SCHEMA:
+    return OWS_GML3;
+  case OWS_GML32_SFE_SCHEMA:
+    return OWS_GML32;
+  }
+  return OWS_GML2;
 }
 
-static void msWFSSchemaWriteGeometryElement(FILE *stream, gmlGeometryListObj *geometryList, WFSSchemaVersion outputformat, const char *tab)
-{
+static void msWFSSchemaWriteGeometryElement(FILE *stream,
+                                            gmlGeometryListObj *geometryList,
+                                            WFSSchemaVersion outputformat,
+                                            const char *tab) {
   OWSGMLVersion gmlversion = msWFSGetGMLVersionFromSchemaVersion(outputformat);
-  msWFSWriteGeometryElement(stream,geometryList,gmlversion,tab);
-}
-
-static const char* msWFSMapServTypeToXMLType(const char* type)
-{
-    const char *element_type = "string";
-    /* Map from MapServer types to XSD types */
-    if( strcasecmp(type,"Integer") == 0 )
-      element_type = "integer";
-    /* Note : xs:int and xs:integer differ */
-    else if ( EQUAL(type,"int") )
-      element_type = "int";
-    if( strcasecmp(type,"Long") == 0 ) /* 64bit integer */
-      element_type = "long";
-    else if( EQUAL(type,"Real") ||
-             EQUAL(type,"double") /* just in case someone provided the xsd type directly */ )
-      element_type = "double";
-    else if( EQUAL(type,"Character") )
-      element_type = "string";
-    else if( EQUAL(type,"Date") )
-      element_type = "date";
-    else if( EQUAL(type,"Time") )
-      element_type = "time";
-    else if( EQUAL(type,"DateTime") )
-      element_type = "dateTime";
-    else if( EQUAL(type,"Boolean") )
-      element_type = "boolean";
-    return element_type;
+  msWFSWriteGeometryElement(stream, geometryList, gmlversion, tab);
 }
 
-static void msWFSWriteItemElement(FILE *stream, gmlItemObj *item, const char *tab,
-                                  WFSSchemaVersion outputformat, int is_nillable)
-{
+static const char *msWFSMapServTypeToXMLType(const char *type) {
+  const char *element_type = "string";
+  /* Map from MapServer types to XSD types */
+  if (strcasecmp(type, "Integer") == 0)
+    element_type = "integer";
+  /* Note : xs:int and xs:integer differ */
+  else if (EQUAL(type, "int"))
+    element_type = "int";
+  if (strcasecmp(type, "Long") == 0) /* 64bit integer */
+    element_type = "long";
+  else if (
+      EQUAL(type, "Real") ||
+      EQUAL(type,
+            "double") /* just in case someone provided the xsd type directly */)
+    element_type = "double";
+  else if (EQUAL(type, "Character"))
+    element_type = "string";
+  else if (EQUAL(type, "Date"))
+    element_type = "date";
+  else if (EQUAL(type, "Time"))
+    element_type = "time";
+  else if (EQUAL(type, "DateTime"))
+    element_type = "dateTime";
+  else if (EQUAL(type, "Boolean"))
+    element_type = "boolean";
+  return element_type;
+}
+
+static void msWFSWriteItemElement(FILE *stream, gmlItemObj *item,
+                                  const char *tab,
+                                  WFSSchemaVersion outputformat,
+                                  int is_nillable) {
   const char *element_name;
   const char *element_type = "string";
   const char *pszMinOccurs = "";
-  const char* pszNillable = "";
+  const char *pszNillable = "";
 
-  if(!stream || !item || !tab) return;
-  if(!item->visible) return; /* not exposing this attribute */
-  if(item->_template) return; /* can't adequately deal with templated items yet */
+  if (!stream || !item || !tab)
+    return;
+  if (!item->visible)
+    return; /* not exposing this attribute */
+  if (item->_template)
+    return; /* can't adequately deal with templated items yet */
 
-  if(item->alias) /* TODO: what about name spaces embedded in the alias? */
+  if (item->alias) /* TODO: what about name spaces embedded in the alias? */
     element_name = item->alias;
   else
     element_name = item->name;
 
-  if(item->type)
-  {
-    if( outputformat == OWS_GML32_SFE_SCHEMA &&
-        (EQUAL(item->type,"Date") || EQUAL(item->type,"Time") || EQUAL(item->type,"DateTime")) )
+  if (item->type) {
+    if (outputformat == OWS_GML32_SFE_SCHEMA &&
+        (EQUAL(item->type, "Date") || EQUAL(item->type, "Time") ||
+         EQUAL(item->type, "DateTime")))
       element_type = "gml:TimeInstantType";
     else
       element_type = msWFSMapServTypeToXMLType(item->type);
   }
 
-  if( item->minOccurs == 0 )
-      pszMinOccurs = " minOccurs=\"0\"";
+  if (item->minOccurs == 0)
+    pszMinOccurs = " minOccurs=\"0\"";
 
-  if( is_nillable )
-      pszNillable = " nillable=\"true\"";
+  if (is_nillable)
+    pszNillable = " nillable=\"true\"";
 
-  msIO_fprintf(stream, "%s<element name=\"%s\"%s%s type=\"%s\"/>\n", tab, element_name, pszMinOccurs, pszNillable, element_type);
+  msIO_fprintf(stream, "%s<element name=\"%s\"%s%s type=\"%s\"/>\n", tab,
+               element_name, pszMinOccurs, pszNillable, element_type);
 
   return;
 }
 
-static void msWFSWriteConstantElement(FILE *stream, gmlConstantObj *constant, const char *tab)
-{
+static void msWFSWriteConstantElement(FILE *stream, gmlConstantObj *constant,
+                                      const char *tab) {
   const char *element_type = "string";
 
-  if(!stream || !constant || !tab) return;
+  if (!stream || !constant || !tab)
+    return;
 
-  if(constant->type)
+  if (constant->type)
     element_type = msWFSMapServTypeToXMLType(constant->type);
 
-  msIO_fprintf(stream, "%s<element name=\"%s\" type=\"%s\"/>\n", tab, constant->name, element_type);
+  msIO_fprintf(stream, "%s<element name=\"%s\" type=\"%s\"/>\n", tab,
+               constant->name, element_type);
 
   return;
 }
 
-static void msWFSWriteGroupElement(FILE *stream, gmlGroupObj *group, const char *tab, const char *_namespace)
-{
-  if(group->type)
-    msIO_fprintf(stream, "%s<element name=\"%s\" type=\"%s:%s\"/>\n", tab, group->name, _namespace, group->type);
+static void msWFSWriteGroupElement(FILE *stream, gmlGroupObj *group,
+                                   const char *tab, const char *_namespace) {
+  if (group->type)
+    msIO_fprintf(stream, "%s<element name=\"%s\" type=\"%s:%s\"/>\n", tab,
+                 group->name, _namespace, group->type);
   else
-    msIO_fprintf(stream, "%s<element name=\"%s\" type=\"%s:%sType\"/>\n", tab, group->name, _namespace, group->name);
+    msIO_fprintf(stream, "%s<element name=\"%s\" type=\"%s:%sType\"/>\n", tab,
+                 group->name, _namespace, group->name);
 
   return;
 }
@@ -1153,19 +1203,18 @@ static void msWFSWriteGroupElementType(F
                                        gmlItemListObj *itemList,
                                        gmlConstantListObj *constantList,
                                        const char *tab,
-                                       WFSSchemaVersion outputformat)
-{
+                                       WFSSchemaVersion outputformat) {
   int i, j;
   char *element_tab;
 
-  gmlItemObj *item=NULL;
-  gmlConstantObj *constant=NULL;
+  gmlItemObj *item = NULL;
+  gmlConstantObj *constant = NULL;
 
   /* setup the element tab */
-  element_tab = (char *) msSmallMalloc(sizeof(char)*strlen(tab)+5);
+  element_tab = (char *)msSmallMalloc(sizeof(char) * strlen(tab) + 5);
   sprintf(element_tab, "%s    ", tab);
 
-  if(group->type)
+  if (group->type)
     msIO_fprintf(stream, "%s<complexType name=\"%s\">\n", tab, group->type);
   else
     msIO_fprintf(stream, "%s<complexType name=\"%sType\">\n", tab, group->name);
@@ -1173,19 +1222,22 @@ static void msWFSWriteGroupElementType(F
   msIO_fprintf(stream, "%s  <sequence>\n", tab);
 
   /* now the items/constants (e.g. elements) in the group */
-  for(i=0; i<group->numitems; i++) {
-    for(j=0; j<constantList->numconstants; j++) { /* find the right gmlConstantObj */
+  for (i = 0; i < group->numitems; i++) {
+    for (j = 0; j < constantList->numconstants;
+         j++) { /* find the right gmlConstantObj */
       constant = &(constantList->constants[j]);
-      if(strcasecmp(constant->name, group->items[i]) == 0) {
+      if (strcasecmp(constant->name, group->items[i]) == 0) {
         msWFSWriteConstantElement(stream, constant, element_tab);
         break;
       }
     }
-    if(j != constantList->numconstants) continue; /* found this item */
-    for(j=0; j<itemList->numitems; j++) { /* find the right gmlItemObj */
+    if (j != constantList->numconstants)
+      continue;                                /* found this item */
+    for (j = 0; j < itemList->numitems; j++) { /* find the right gmlItemObj */
       item = &(itemList->items[j]);
-      if(strcasecmp(item->name, group->items[i]) == 0) {
-        msWFSWriteItemElement(stream, item, element_tab, outputformat, MS_FALSE);
+      if (strcasecmp(item->name, group->items[i]) == 0) {
+        msWFSWriteItemElement(stream, item, element_tab, outputformat,
+                              MS_FALSE);
         break;
       }
     }
@@ -1198,88 +1250,80 @@ static void msWFSWriteGroupElementType(F
   return;
 }
 
-static const char* msWFSGetGMLSchemaLocation(OWSGMLVersion outputformat)
-{
-    switch( outputformat )
-    {
-        case OWS_GML2:
-            return MS_OWSCOMMON_GML_212_SCHEMA_LOCATION;
-        case OWS_GML3:
-            return MS_OWSCOMMON_GML_311_SCHEMA_LOCATION;
-        case OWS_GML32:
-            return MS_OWSCOMMON_GML_321_SCHEMA_LOCATION;
-    }
-    return "/unknown.xsd";
-}
-
-static const char* msWFSGetGMLNamespaceURI(WFSSchemaVersion outputformat)
-{
-    switch( outputformat )
-    {
-        case OWS_DEFAULT_SCHEMA:
-            return MS_OWSCOMMON_GML_NAMESPACE_URI;
-        case OWS_SFE_SCHEMA:
-            return MS_OWSCOMMON_GML_NAMESPACE_URI;
-        case OWS_GML32_SFE_SCHEMA:
-            return MS_OWSCOMMON_GML_32_NAMESPACE_URI;
-    }
-    return "http://unknown";
-}
-
-static const char* msWFSGetGMLNamespaceURIFromGMLVersion(OWSGMLVersion outputformat)
-{
-    switch( outputformat )
-    {
-        case OWS_GML2:
-            return MS_OWSCOMMON_GML_NAMESPACE_URI;
-        case OWS_GML3:
-            return MS_OWSCOMMON_GML_NAMESPACE_URI;
-        case OWS_GML32:
-            return MS_OWSCOMMON_GML_32_NAMESPACE_URI;
-    }
-    return "http://unknown";
-}
-
-static void msWFS_NS_printf(const char* prefix, const char* uri)
-{
-    if( prefix == NULL )
-        msIO_printf("   xmlns=\"%s\"\n", uri);
-    else
-        msIO_printf("   xmlns:%s=\"%s\"\n", prefix, uri);
+static const char *msWFSGetGMLSchemaLocation(OWSGMLVersion outputformat) {
+  switch (outputformat) {
+  case OWS_GML2:
+    return MS_OWSCOMMON_GML_212_SCHEMA_LOCATION;
+  case OWS_GML3:
+    return MS_OWSCOMMON_GML_311_SCHEMA_LOCATION;
+  case OWS_GML32:
+    return MS_OWSCOMMON_GML_321_SCHEMA_LOCATION;
+  }
+  return "/unknown.xsd";
+}
+
+static const char *msWFSGetGMLNamespaceURI(WFSSchemaVersion outputformat) {
+  switch (outputformat) {
+  case OWS_DEFAULT_SCHEMA:
+    return MS_OWSCOMMON_GML_NAMESPACE_URI;
+  case OWS_SFE_SCHEMA:
+    return MS_OWSCOMMON_GML_NAMESPACE_URI;
+  case OWS_GML32_SFE_SCHEMA:
+    return MS_OWSCOMMON_GML_32_NAMESPACE_URI;
+  }
+  return "http://unknown";
+}
+
+static const char *
+msWFSGetGMLNamespaceURIFromGMLVersion(OWSGMLVersion outputformat) {
+  switch (outputformat) {
+  case OWS_GML2:
+    return MS_OWSCOMMON_GML_NAMESPACE_URI;
+  case OWS_GML3:
+    return MS_OWSCOMMON_GML_NAMESPACE_URI;
+  case OWS_GML32:
+    return MS_OWSCOMMON_GML_32_NAMESPACE_URI;
+  }
+  return "http://unknown";
+}
+
+static void msWFS_NS_printf(const char *prefix, const char *uri) {
+  if (prefix == NULL)
+    msIO_printf("   xmlns=\"%s\"\n", uri);
+  else
+    msIO_printf("   xmlns:%s=\"%s\"\n", prefix, uri);
 }
 
-static void msWFSPrintAdditionalNamespaces(const gmlNamespaceListObj *namespaceList)
-{
-    int i;
-    /* any additional namespaces */
-    for(i=0; i<namespaceList->numnamespaces; i++) {
-      if(namespaceList->namespaces[i].uri) {
-        char *uri_encoded=NULL;
+static void
+msWFSPrintAdditionalNamespaces(const gmlNamespaceListObj *namespaceList) {
+  int i;
+  /* any additional namespaces */
+  for (i = 0; i < namespaceList->numnamespaces; i++) {
+    if (namespaceList->namespaces[i].uri) {
+      char *uri_encoded = NULL;
 
-        uri_encoded = msEncodeHTMLEntities(namespaceList->namespaces[i].uri);
-        msWFS_NS_printf(namespaceList->namespaces[i].prefix, uri_encoded);
-        msFree(uri_encoded);
-      }
+      uri_encoded = msEncodeHTMLEntities(namespaceList->namespaces[i].uri);
+      msWFS_NS_printf(namespaceList->namespaces[i].prefix, uri_encoded);
+      msFree(uri_encoded);
     }
+  }
 }
 
-static const char* msWFSStripNS(const char* name)
-{
-    const char* pszColon = strchr(name, ':');
-    const char* pszSlash = strchr(name, '/');
-    if( pszColon && (pszSlash == NULL || pszColon < pszSlash) )
-      return pszColon + 1;
-    return name;
+static const char *msWFSStripNS(const char *name) {
+  const char *pszColon = strchr(name, ':');
+  const char *pszSlash = strchr(name, '/');
+  if (pszColon && (pszSlash == NULL || pszColon < pszSlash))
+    return pszColon + 1;
+  return name;
 }
 
 /*
 ** msWFSDescribeFeatureType()
 */
-static
-int msWFSDescribeFeatureType(mapObj *map, wfsParamsObj *paramsObj, owsRequestObj *ows_request,
-                             int nWFSVersion)
-{
-  int i, numlayers=0;
+static int msWFSDescribeFeatureType(mapObj *map, wfsParamsObj *paramsObj,
+                                    owsRequestObj *ows_request,
+                                    int nWFSVersion) {
+  int i, numlayers = 0;
   char **layers = NULL;
 
   const char *value;
@@ -1289,77 +1333,89 @@ int msWFSDescribeFeatureType(mapObj *map
   const char *collection_name = OWS_WFS_FEATURE_COLLECTION_NAME;
   char *encoded;
 
-  WFSSchemaVersion outputformat = OWS_DEFAULT_SCHEMA; /* default output is GML 2.1 compliant schema*/
+  WFSSchemaVersion outputformat =
+      OWS_DEFAULT_SCHEMA; /* default output is GML 2.1 compliant schema*/
 
-  gmlNamespaceListObj *namespaceList=NULL; /* for external application schema support */
+  gmlNamespaceListObj *namespaceList =
+      NULL; /* for external application schema support */
   char *mimetype = NULL;
 
-  if(paramsObj->pszTypeName && numlayers == 0) {
+  if (paramsObj->pszTypeName && numlayers == 0) {
     /* Parse comma-delimited list of type names (layers) */
     layers = msStringSplit(paramsObj->pszTypeName, ',', &numlayers);
     if (numlayers > 0) {
       /* strip namespace if there is one :ex TYPENAME=cdf:Other */
-      for (i=0; i<numlayers; i++) {
-        char* pszTmp = msStrdup(msWFSStripNS(layers[i]));
+      for (i = 0; i < numlayers; i++) {
+        char *pszTmp = msStrdup(msWFSStripNS(layers[i]));
         free(layers[i]);
         layers[i] = pszTmp;
       }
     }
   }
 
-
   if (paramsObj->pszOutputFormat) {
-    if(strcasecmp(paramsObj->pszOutputFormat, "XMLSCHEMA") == 0 ||
-        strstr(paramsObj->pszOutputFormat, "gml/2")!= NULL) {
+    if (strcasecmp(paramsObj->pszOutputFormat, "XMLSCHEMA") == 0 ||
+        strstr(paramsObj->pszOutputFormat, "gml/2") != NULL) {
       mimetype = msEncodeHTMLEntities("text/xml; subtype=gml/2.1.2");
       outputformat = OWS_DEFAULT_SCHEMA;
-    } else if(strcasecmp(paramsObj->pszOutputFormat, "SFE_XMLSCHEMA") == 0 ||
-              strstr(paramsObj->pszOutputFormat, "gml/3.1")!= NULL) {
+    } else if (strcasecmp(paramsObj->pszOutputFormat, "SFE_XMLSCHEMA") == 0 ||
+               strstr(paramsObj->pszOutputFormat, "gml/3.1") != NULL) {
       mimetype = msEncodeHTMLEntities("text/xml; subtype=gml/3.1.1");
       outputformat = OWS_SFE_SCHEMA;
-    } else if(strstr(paramsObj->pszOutputFormat, "gml/3.2")!= NULL ||
-              strstr(paramsObj->pszOutputFormat, "application/gml+xml; version=3.2")!= NULL) {
+    } else if (strstr(paramsObj->pszOutputFormat, "gml/3.2") != NULL ||
+               strstr(paramsObj->pszOutputFormat,
+                      "application/gml+xml; version=3.2") != NULL) {
       mimetype = msEncodeHTMLEntities("application/gml+xml; version=3.2");
       outputformat = OWS_GML32_SFE_SCHEMA;
     } else {
-      msSetError(MS_WFSERR, "Unsupported DescribeFeatureType outputFormat (%s).", "msWFSDescribeFeatureType()", paramsObj->pszOutputFormat);
-      if( layers )
+      msSetError(MS_WFSERR,
+                 "Unsupported DescribeFeatureType outputFormat (%s).",
+                 "msWFSDescribeFeatureType()", paramsObj->pszOutputFormat);
+      if (layers)
         msFreeCharArray(layers, numlayers);
       msFree(mimetype);
-      return msWFSException(map, "outputformat", MS_OWS_ERROR_INVALID_PARAMETER_VALUE, paramsObj->pszVersion);
+      return msWFSException(map, "outputformat",
+                            MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                            paramsObj->pszVersion);
     }
   }
-  /* If no outputFormat explicitely asked, use a sensible default for the WFS version */
+  /* If no outputFormat explicitely asked, use a sensible default for the WFS
+     version */
   else {
-    switch( nWFSVersion )
-    {
-        case OWS_1_0_0:
-        default:
-            mimetype = msEncodeHTMLEntities("text/xml"); /* ERO: why not "text/xml; subtype=gml/2.1.2" ? */
-            break;
+    switch (nWFSVersion) {
+    case OWS_1_0_0:
+    default:
+      mimetype = msEncodeHTMLEntities(
+          "text/xml"); /* ERO: why not "text/xml; subtype=gml/2.1.2" ? */
+      break;
 
-        case OWS_1_1_0:
-            mimetype = msEncodeHTMLEntities("text/xml; subtype=gml/3.1.1");
-            outputformat = OWS_SFE_SCHEMA;
-            break;
+    case OWS_1_1_0:
+      mimetype = msEncodeHTMLEntities("text/xml; subtype=gml/3.1.1");
+      outputformat = OWS_SFE_SCHEMA;
+      break;
 
-        case OWS_2_0_0:
-            mimetype = msEncodeHTMLEntities("application/gml+xml; version=3.2");
-            outputformat = OWS_GML32_SFE_SCHEMA;
-            break;
-     }
+    case OWS_2_0_0:
+      mimetype = msEncodeHTMLEntities("application/gml+xml; version=3.2");
+      outputformat = OWS_GML32_SFE_SCHEMA;
+      break;
+    }
   }
 
   /* Validate layers */
   if (numlayers > 0) {
-    for (i=0; i<numlayers; i++) {
-      layerObj* lp = msWFSGetLayerByName(map, ows_request, layers[i]);
-      if ( lp == NULL ) {
-        msSetError(MS_WFSERR, "Invalid typename (%s). A layer might be disabled for \
-this request. Check wfs/ows_enable_request settings.", "msWFSDescribeFeatureType()", layers[i]);/* paramsObj->pszTypeName); */
+    for (i = 0; i < numlayers; i++) {
+      layerObj *lp = msWFSGetLayerByName(map, ows_request, layers[i]);
+      if (lp == NULL) {
+        msSetError(MS_WFSERR,
+                   "Invalid typename (%s). A layer might be disabled for \
+this request. Check wfs/ows_enable_request settings.",
+                   "msWFSDescribeFeatureType()",
+                   layers[i]); /* paramsObj->pszTypeName); */
         msFreeCharArray(layers, numlayers);
         msFree(mimetype);
-        return msWFSException(map, "typename", MS_OWS_ERROR_INVALID_PARAMETER_VALUE, paramsObj->pszVersion);
+        return msWFSException(map, "typename",
+                              MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                              paramsObj->pszVersion);
       }
     }
   }
@@ -1369,7 +1425,8 @@ this request. Check wfs/ows_enable_reque
   */
   namespaceList = msGMLGetNamespaces(&(map->web), "G");
   if (namespaceList == NULL) {
-    msSetError(MS_MISCERR, "Unable to populate namespace list", "msWFSDescribeFeatureType()");
+    msSetError(MS_MISCERR, "Unable to populate namespace list",
+               "msWFSDescribeFeatureType()");
     return MS_FAILURE;
   }
 
@@ -1377,7 +1434,7 @@ this request. Check wfs/ows_enable_reque
   ** DescribeFeatureType response
   */
 
-  msIO_setHeader("Content-Type","%s; charset=UTF-8",mimetype);
+  msIO_setHeader("Content-Type", "%s; charset=UTF-8", mimetype);
   msIO_sendHeaders();
 
   if (mimetype)
@@ -1386,64 +1443,81 @@ this request. Check wfs/ows_enable_reque
   msIO_printf("<?xml version='1.0' encoding=\"UTF-8\" ?>\n");
 
   value = msOWSLookupMetadata(&(map->web.metadata), "FO", "namespace_uri");
-  if(value) user_namespace_uri = value;
+  if (value)
+    user_namespace_uri = value;
   user_namespace_uri_encoded = msEncodeHTMLEntities(user_namespace_uri);
 
   value = msOWSLookupMetadata(&(map->web.metadata), "FO", "namespace_prefix");
-  if(value) user_namespace_prefix = value;
-  if(user_namespace_prefix != NULL && msIsXMLTagValid(user_namespace_prefix) == MS_FALSE)
-    msIO_printf("<!-- WARNING: The value '%s' is not valid XML namespace. -->\n", user_namespace_prefix);
+  if (value)
+    user_namespace_prefix = value;
+  if (user_namespace_prefix != NULL &&
+      msIsXMLTagValid(user_namespace_prefix) == MS_FALSE)
+    msIO_printf(
+        "<!-- WARNING: The value '%s' is not valid XML namespace. -->\n",
+        user_namespace_prefix);
 
   msIO_printf("<schema\n"
               "   targetNamespace=\"%s\" \n"
               "   xmlns:%s=\"%s\" \n",
-              user_namespace_uri_encoded, user_namespace_prefix,  user_namespace_uri_encoded);
-  if( nWFSVersion < OWS_2_0_0 )
-    msWFS_NS_printf(MS_OWSCOMMON_OGC_NAMESPACE_PREFIX, MS_OWSCOMMON_OGC_NAMESPACE_URI);
+              user_namespace_uri_encoded, user_namespace_prefix,
+              user_namespace_uri_encoded);
+  if (nWFSVersion < OWS_2_0_0)
+    msWFS_NS_printf(MS_OWSCOMMON_OGC_NAMESPACE_PREFIX,
+                    MS_OWSCOMMON_OGC_NAMESPACE_URI);
   msWFS_NS_printf("xsd", MS_OWSCOMMON_W3C_XS_NAMESPACE_URI);
   msWFS_NS_printf(NULL, MS_OWSCOMMON_W3C_XS_NAMESPACE_URI);
   msWFS_NS_printf(MS_OWSCOMMON_GML_NAMESPACE_PREFIX,
-                  msWFSGetGMLNamespaceURI(outputformat) );
+                  msWFSGetGMLNamespaceURI(outputformat));
 
   msWFSPrintAdditionalNamespaces(namespaceList);
 
   msIO_printf("   elementFormDefault=\"qualified\" version=\"0.1\" >\n");
 
-  encoded = msEncodeHTMLEntities( msOWSGetSchemasLocation(map) );
+  encoded = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
 
   msIO_printf("\n  <import namespace=\"%s\"\n"
               "          schemaLocation=\"%s%s\" />\n",
-              msWFSGetGMLNamespaceURI(outputformat),
-              encoded,
-              msWFSGetGMLSchemaLocation(msWFSGetGMLVersionFromSchemaVersion(outputformat)));
+              msWFSGetGMLNamespaceURI(outputformat), encoded,
+              msWFSGetGMLSchemaLocation(
+                  msWFSGetGMLVersionFromSchemaVersion(outputformat)));
 
   msFree(encoded);
 
   /* any additional namespace includes */
-  for(i=0; i<namespaceList->numnamespaces; i++) {
-    if(namespaceList->namespaces[i].uri && namespaceList->namespaces[i].schemalocation) {
-      char *schema_location_encoded=NULL, *uri_encoded=NULL;
+  for (i = 0; i < namespaceList->numnamespaces; i++) {
+    if (namespaceList->namespaces[i].uri &&
+        namespaceList->namespaces[i].schemalocation) {
+      char *schema_location_encoded = NULL, *uri_encoded = NULL;
 
       uri_encoded = msEncodeHTMLEntities(namespaceList->namespaces[i].uri);
-      schema_location_encoded = msEncodeHTMLEntities(namespaceList->namespaces[i].schemalocation);
-      msIO_printf("\n  <import namespace=\"%s\"\n schemaLocation=\"%s\" />\n", uri_encoded, schema_location_encoded);
+      schema_location_encoded =
+          msEncodeHTMLEntities(namespaceList->namespaces[i].schemalocation);
+      msIO_printf("\n  <import namespace=\"%s\"\n schemaLocation=\"%s\" />\n",
+                  uri_encoded, schema_location_encoded);
       msFree(uri_encoded);
       msFree(schema_location_encoded);
     }
   }
 
-  /* output definition for the default feature container, can't use wfs:FeatureCollection with GML3:
-     kept here so that the behaviour with wfs1.0 and gml3 output is preserved.
-     We can use the wfs:FeatureCollection for wfs1.1*/
-  if(outputformat == OWS_SFE_SCHEMA && nWFSVersion == OWS_1_0_0 ) {
-    value = msOWSLookupMetadata(&(map->web.metadata), "FO", "feature_collection");
-    if(value) collection_name = value;
-
-    msIO_printf("  <element name=\"%s\" type=\"%s:%sType\" substitutionGroup=\"gml:_FeatureCollection\"/>\n", collection_name, user_namespace_prefix, collection_name);
+  /* output definition for the default feature container, can't use
+     wfs:FeatureCollection with GML3: kept here so that the behaviour with
+     wfs1.0 and gml3 output is preserved. We can use the wfs:FeatureCollection
+     for wfs1.1*/
+  if (outputformat == OWS_SFE_SCHEMA && nWFSVersion == OWS_1_0_0) {
+    value =
+        msOWSLookupMetadata(&(map->web.metadata), "FO", "feature_collection");
+    if (value)
+      collection_name = value;
+
+    msIO_printf("  <element name=\"%s\" type=\"%s:%sType\" "
+                "substitutionGroup=\"gml:_FeatureCollection\"/>\n",
+                collection_name, user_namespace_prefix, collection_name);
     msIO_printf("  <complexType name=\"%sType\">\n", collection_name);
     msIO_printf("    <complexContent>\n");
-    msIO_printf("      <extension base=\"gml:AbstractFeatureCollectionType\">\n");
-    msIO_printf("        <attribute name=\"version\" type=\"string\" use=\"required\" fixed=\"1.0.0\"/>\n");
+    msIO_printf(
+        "      <extension base=\"gml:AbstractFeatureCollectionType\">\n");
+    msIO_printf("        <attribute name=\"version\" type=\"string\" "
+                "use=\"required\" fixed=\"1.0.0\"/>\n");
     msIO_printf("      </extension>\n");
     msIO_printf("    </complexContent>\n");
     msIO_printf("  </complexType>\n");
@@ -1452,18 +1526,18 @@ this request. Check wfs/ows_enable_reque
   /*
   ** loop through layers
   */
-  for(i=0; i<map->numlayers; i++)  {
+  for (i = 0; i < map->numlayers; i++) {
     layerObj *lp;
     int j, bFound = 0;
 
     lp = GET_LAYER(map, i);
 
-    for (j=0; j<numlayers && !bFound; j++) {
-      if ( lp->name && strcasecmp(lp->name, layers[j]) == 0)
+    for (j = 0; j < numlayers && !bFound; j++) {
+      if (lp->name && strcasecmp(lp->name, layers[j]) == 0)
         bFound = 1;
     }
 
-    if ((numlayers == 0 || bFound) && msWFSIsLayerAllowed(lp, ows_request) ) {
+    if ((numlayers == 0 || bFound) && msWFSIsLayerAllowed(lp, ows_request)) {
 
       /*
       ** OK, describe this layer IF you can open it and retrieve items
@@ -1471,55 +1545,58 @@ this request. Check wfs/ows_enable_reque
       if (msLayerOpen(lp) == MS_SUCCESS) {
         if (msLayerGetItems(lp) == MS_SUCCESS) {
           int k;
-          gmlGroupListObj *groupList=NULL;
-          gmlItemListObj *itemList=NULL;
-          gmlConstantListObj *constantList=NULL;
-          gmlGeometryListObj *geometryList=NULL;
-          gmlItemObj *item=NULL;
-          gmlConstantObj *constant=NULL;
+          gmlGroupListObj *groupList = NULL;
+          gmlItemListObj *itemList = NULL;
+          gmlConstantListObj *constantList = NULL;
+          gmlGeometryListObj *geometryList = NULL;
+          gmlItemObj *item = NULL;
+          gmlConstantObj *constant = NULL;
           char *encoded_name = NULL;
 
           const char *layer_namespace_prefix;
           const char *substitution_group;
-          char *encoded_type=NULL;
+          char *encoded_type = NULL;
 
           itemList = msGMLGetItems(lp, "G"); /* GML-related metadata */
           constantList = msGMLGetConstants(lp, "G");
           groupList = msGMLGetGroups(lp, "G");
           geometryList = msGMLGetGeometries(lp, "GFO", MS_TRUE);
-          if (itemList == NULL || constantList == NULL || groupList == NULL || geometryList == NULL) {
-            msSetError(MS_MISCERR, "Unable to populate item and group metadata structures", "msWFSDescribeFeatureType()");
+          if (itemList == NULL || constantList == NULL || groupList == NULL ||
+              geometryList == NULL) {
+            msSetError(MS_MISCERR,
+                       "Unable to populate item and group metadata structures",
+                       "msWFSDescribeFeatureType()");
             return MS_FAILURE;
           }
 
-          value = msOWSLookupMetadata(&(lp->metadata), "OFG", "namespace_prefix");
-          if(value)
+          value =
+              msOWSLookupMetadata(&(lp->metadata), "OFG", "namespace_prefix");
+          if (value)
             layer_namespace_prefix = value;
           else
             layer_namespace_prefix = user_namespace_prefix;
 
-          encoded_name = msEncodeHTMLEntities( lp->name );
+          encoded_name = msEncodeHTMLEntities(lp->name);
           value = msOWSLookupMetadata(&(lp->metadata), "F", "layer_type");
-          if(value) {
+          if (value) {
             encoded_type = msEncodeHTMLEntities(value);
           } else {
             size_t sz = strlen(encoded_name) + strlen("Type") + 1;
-            encoded_type = (char*) msSmallMalloc(sz);
+            encoded_type = (char *)msSmallMalloc(sz);
             strlcpy(encoded_type, encoded_name, sz);
             strlcat(encoded_type, "Type", sz);
           }
 
-          switch(outputformat)
-          {
-            case OWS_DEFAULT_SCHEMA: /* default GML 2.1.x schema */
-            case OWS_SFE_SCHEMA: /* reference GML 3.1.1 schema */
-            default:
-                substitution_group = "gml:_Feature";
-                break;
-
-            case OWS_GML32_SFE_SCHEMA:  /* reference GML 3.2.1 schema */
-                substitution_group = "gml:AbstractFeature";
-                break;
+          switch (outputformat) {
+          case OWS_DEFAULT_SCHEMA: /* default GML 2.1.x schema */
+          case OWS_SFE_SCHEMA:     /* reference GML 3.1.1 schema */
+          default:
+            substitution_group = "gml:_Feature";
+            break;
+
+          case OWS_GML32_SFE_SCHEMA: /* reference GML 3.2.1 schema */
+            substitution_group = "gml:AbstractFeature";
+            break;
           }
 
           msIO_printf("\n"
@@ -1530,7 +1607,7 @@ this request. Check wfs/ows_enable_reque
                       substitution_group);
           msFree(encoded_type);
 
-          if(strcmp(layer_namespace_prefix, user_namespace_prefix) != 0) {
+          if (strcmp(layer_namespace_prefix, user_namespace_prefix) != 0) {
             msFree(encoded_name);
             msGMLFreeItems(itemList);
             msGMLFreeConstants(constantList);
@@ -1545,32 +1622,35 @@ this request. Check wfs/ows_enable_reque
           msIO_printf("        <sequence>\n");
 
           /* write the geometry schema element(s) */
-          msWFSSchemaWriteGeometryElement(stdout, geometryList, outputformat, "          ");
+          msWFSSchemaWriteGeometryElement(stdout, geometryList, outputformat,
+                                          "          ");
 
           /* write the constant-based schema elements */
-          for(k=0; k<constantList->numconstants; k++) {
+          for (k = 0; k < constantList->numconstants; k++) {
             constant = &(constantList->constants[k]);
-            if(msItemInGroups(constant->name, groupList) == MS_FALSE)
+            if (msItemInGroups(constant->name, groupList) == MS_FALSE)
               msWFSWriteConstantElement(stdout, constant, "          ");
           }
 
           /* write the item-based schema elements */
-          for(k=0; k<itemList->numitems; k++) {
+          for (k = 0; k < itemList->numitems; k++) {
             item = &(itemList->items[k]);
-            if(msItemInGroups(item->name, groupList) == MS_FALSE) {
+            if (msItemInGroups(item->name, groupList) == MS_FALSE) {
               int nillable = MS_FALSE;
               char mdname[256];
-              const char* pszNillable;
+              const char *pszNillable;
               snprintf(mdname, sizeof(mdname), "%s_nillable", item->name);
               pszNillable = msOWSLookupMetadata(&(lp->metadata), "G", mdname);
-              if( pszNillable && strcasecmp(pszNillable, "true") == 0 )
-                  nillable = MS_TRUE;
-              msWFSWriteItemElement(stdout, item, "          ", outputformat, nillable);
+              if (pszNillable && strcasecmp(pszNillable, "true") == 0)
+                nillable = MS_TRUE;
+              msWFSWriteItemElement(stdout, item, "          ", outputformat,
+                                    nillable);
             }
           }
 
-          for(k=0; k<groupList->numgroups; k++)
-            msWFSWriteGroupElement(stdout, &(groupList->groups[k]), "          ", user_namespace_prefix);
+          for (k = 0; k < groupList->numgroups; k++)
+            msWFSWriteGroupElement(stdout, &(groupList->groups[k]),
+                                   "          ", user_namespace_prefix);
 
           msIO_printf("        </sequence>\n");
           msIO_printf("      </extension>\n");
@@ -1578,8 +1658,10 @@ this request. Check wfs/ows_enable_reque
           msIO_printf("  </complexType>\n");
 
           /* any group types */
-          for(k=0; k<groupList->numgroups; k++)
-            msWFSWriteGroupElementType(stdout, &(groupList->groups[k]), itemList, constantList, "  ", outputformat);
+          for (k = 0; k < groupList->numgroups; k++)
+            msWFSWriteGroupElementType(stdout, &(groupList->groups[k]),
+                                       itemList, constantList, "  ",
+                                       outputformat);
 
           msGMLFreeItems(itemList);
           msGMLFreeConstants(constantList);
@@ -1591,7 +1673,8 @@ this request. Check wfs/ows_enable_reque
 
         msLayerClose(lp);
       } else {
-        msIO_printf("\n\n<!-- ERROR: Failed opening layer %s -->\n\n", lp->name);
+        msIO_printf("\n\n<!-- ERROR: Failed opening layer %s -->\n\n",
+                    lp->name);
       }
     }
   }
@@ -1603,7 +1686,7 @@ this request. Check wfs/ows_enable_reque
 
   msFree(user_namespace_uri_encoded);
 
-  if(layers)
+  if (layers)
     msFreeCharArray(layers, numlayers);
 
   msGMLFreeNamespaces(namespaceList);
@@ -1621,130 +1704,111 @@ this request. Check wfs/ows_enable_reque
 typedef struct {
   const char *user_namespace_prefix;
   const char *user_namespace_uri;
-  char       *user_namespace_uri_encoded;
+  char *user_namespace_uri_encoded;
   const char *collection_name;
   const char *_typename;
-  char       *script_url, *script_url_encoded;
+  char *script_url, *script_url_encoded;
   const char *output_mime_type;
   const char *output_schema_format;
 } WFSGMLInfo;
 
-
-static void msWFSPrintURLAndXMLEncoded(const char* str)
-{
-    char* url_encoded = msEncodeUrl(str);
-    char* xml_encoded = msEncodeHTMLEntities(url_encoded);
-    msIO_printf("%s", xml_encoded);
-    msFree(xml_encoded);
-    msFree(url_encoded);
+static void msWFSPrintURLAndXMLEncoded(const char *str) {
+  char *url_encoded = msEncodeUrl(str);
+  char *xml_encoded = msEncodeHTMLEntities(url_encoded);
+  msIO_printf("%s", xml_encoded);
+  msFree(xml_encoded);
+  msFree(url_encoded);
 }
 
-static void msWFSGetFeature_PrintBasePrevNextURI(cgiRequestObj *req,
-                                                 WFSGMLInfo *gmlinfo,
-                                                 wfsParamsObj *paramsObj,
-                                                 const char* encoded_version,
-                                                 const char* encoded_typename,
-                                                 const char* encoded_mime_type)
-{
-    int i;
-    int bFirstArg = MS_TRUE;
-    msIO_printf("%s", gmlinfo->script_url_encoded);
+static void msWFSGetFeature_PrintBasePrevNextURI(
+    cgiRequestObj *req, WFSGMLInfo *gmlinfo, wfsParamsObj *paramsObj,
+    const char *encoded_version, const char *encoded_typename,
+    const char *encoded_mime_type) {
+  int i;
+  int bFirstArg = MS_TRUE;
+  msIO_printf("%s", gmlinfo->script_url_encoded);
 
-    if( req->postrequest != NULL )
-    {
-        msIO_printf("SERVICE=WFS&amp;VERSION=");
-        msIO_printf("%s", encoded_version);
-        msIO_printf("&amp;REQUEST=");
-        msIO_printf("%s", paramsObj->pszRequest);
-        msIO_printf("&amp;TYPENAMES=");
-        msIO_printf("%s", encoded_typename);
-        msIO_printf("&amp;OUTPUTFORMAT=");
-        msIO_printf("%s", encoded_mime_type);
-        if( paramsObj->pszBbox != NULL )
-        {
-            msIO_printf("&amp;BBOX=");
-            msWFSPrintURLAndXMLEncoded(paramsObj->pszBbox);
-        }
-        if( paramsObj->pszSrs != NULL )
-        {
-            msIO_printf("&amp;SRSNAME=");
-            msWFSPrintURLAndXMLEncoded(paramsObj->pszSrs);
-        }
-        if( paramsObj->pszFilter != NULL )
-        {
-            msIO_printf("&amp;FILTER=");
-            msWFSPrintURLAndXMLEncoded(paramsObj->pszFilter);
-        }
-        if( paramsObj->pszPropertyName != NULL)
-        {
-            msIO_printf("&amp;PROPERTYNAME=");
-            msWFSPrintURLAndXMLEncoded(paramsObj->pszPropertyName);
-        }
-        if( paramsObj->pszValueReference != NULL)
-        {
-            msIO_printf("&amp;VALUEREFERENCE=");
-            msWFSPrintURLAndXMLEncoded(paramsObj->pszValueReference);
-        }
-        if( paramsObj->pszSortBy != NULL )
-        {
-            msIO_printf("&amp;SORTBY=");
-            msWFSPrintURLAndXMLEncoded(paramsObj->pszSortBy);
-        }
-        if( paramsObj->nMaxFeatures >= 0 )
-            msIO_printf("&amp;COUNT=%d", paramsObj->nMaxFeatures);
+  if (req->postrequest != NULL) {
+    msIO_printf("SERVICE=WFS&amp;VERSION=");
+    msIO_printf("%s", encoded_version);
+    msIO_printf("&amp;REQUEST=");
+    msIO_printf("%s", paramsObj->pszRequest);
+    msIO_printf("&amp;TYPENAMES=");
+    msIO_printf("%s", encoded_typename);
+    msIO_printf("&amp;OUTPUTFORMAT=");
+    msIO_printf("%s", encoded_mime_type);
+    if (paramsObj->pszBbox != NULL) {
+      msIO_printf("&amp;BBOX=");
+      msWFSPrintURLAndXMLEncoded(paramsObj->pszBbox);
+    }
+    if (paramsObj->pszSrs != NULL) {
+      msIO_printf("&amp;SRSNAME=");
+      msWFSPrintURLAndXMLEncoded(paramsObj->pszSrs);
+    }
+    if (paramsObj->pszFilter != NULL) {
+      msIO_printf("&amp;FILTER=");
+      msWFSPrintURLAndXMLEncoded(paramsObj->pszFilter);
+    }
+    if (paramsObj->pszPropertyName != NULL) {
+      msIO_printf("&amp;PROPERTYNAME=");
+      msWFSPrintURLAndXMLEncoded(paramsObj->pszPropertyName);
+    }
+    if (paramsObj->pszValueReference != NULL) {
+      msIO_printf("&amp;VALUEREFERENCE=");
+      msWFSPrintURLAndXMLEncoded(paramsObj->pszValueReference);
+    }
+    if (paramsObj->pszSortBy != NULL) {
+      msIO_printf("&amp;SORTBY=");
+      msWFSPrintURLAndXMLEncoded(paramsObj->pszSortBy);
     }
-    else
-    {
-        for(i=0; i<req->NumParams; i++) {
-            if (req->ParamNames[i] && req->ParamValues[i] &&
-                strcasecmp(req->ParamNames[i], "MAP") != 0 &&
-                strcasecmp(req->ParamNames[i], "STARTINDEX") != 0 &&
-                strcasecmp(req->ParamNames[i], "RESULTTYPE") != 0) {
-                if( !bFirstArg )
-                    msIO_printf("&amp;");
-                bFirstArg = MS_FALSE;
-                msIO_printf("%s=", req->ParamNames[i]);
-                msWFSPrintURLAndXMLEncoded(req->ParamValues[i]);
-            }
-        }
+    if (paramsObj->nMaxFeatures >= 0)
+      msIO_printf("&amp;COUNT=%d", paramsObj->nMaxFeatures);
+  } else {
+    for (i = 0; i < req->NumParams; i++) {
+      if (req->ParamNames[i] && req->ParamValues[i] &&
+          strcasecmp(req->ParamNames[i], "MAP") != 0 &&
+          strcasecmp(req->ParamNames[i], "STARTINDEX") != 0 &&
+          strcasecmp(req->ParamNames[i], "RESULTTYPE") != 0) {
+        if (!bFirstArg)
+          msIO_printf("&amp;");
+        bFirstArg = MS_FALSE;
+        msIO_printf("%s=", req->ParamNames[i]);
+        msWFSPrintURLAndXMLEncoded(req->ParamValues[i]);
+      }
     }
+  }
 }
 
-
-static void msWFSGetFeature_GetTimeStamp(char* timestring, size_t timestringlen)
-{
-    struct tm *now;
-    time_t tim=time(NULL);
-
-    now=localtime(&tim);
-
-    snprintf(timestring, timestringlen, "%d-%02d-%02dT%02d:%02d:%02d",
-                now->tm_year+1900, now->tm_mon+1, now->tm_mday,
-                now->tm_hour, now->tm_min, now->tm_sec);
-}
-
-static int msWFSGetFeature_GMLPreamble( mapObj *map,
-                                        cgiRequestObj *req,
-                                        WFSGMLInfo *gmlinfo,
-                                        wfsParamsObj *paramsObj,
-                                        OWSGMLVersion outputformat,
-                                        int iResultTypeHits,
-                                        int iNumberOfFeatures,
-                                        int nMatchingFeatures,
-                                        int maxfeatures,
-                                        int bHasNextFeatures,
-                                        int nWFSVersion )
+static void msWFSGetFeature_GetTimeStamp(char *timestring,
+                                         size_t timestringlen) {
+  struct tm *now;
+  time_t tim = time(NULL);
+
+  now = localtime(&tim);
+
+  snprintf(timestring, timestringlen, "%d-%02d-%02dT%02d:%02d:%02d",
+           now->tm_year + 1900, now->tm_mon + 1, now->tm_mday, now->tm_hour,
+           now->tm_min, now->tm_sec);
+}
+
+static int msWFSGetFeature_GMLPreamble(
+    mapObj *map, cgiRequestObj *req, WFSGMLInfo *gmlinfo,
+    wfsParamsObj *paramsObj, OWSGMLVersion outputformat, int iResultTypeHits,
+    int iNumberOfFeatures, int nMatchingFeatures, int maxfeatures,
+    int bHasNextFeatures, int nWFSVersion)
 
 {
   const char *value;
-  char       *encoded_version, *encoded_typename, *encoded_schema;
-  gmlNamespaceListObj *namespaceList=NULL; /* for external application schema support */
+  char *encoded_version, *encoded_typename, *encoded_schema;
+  gmlNamespaceListObj *namespaceList =
+      NULL; /* for external application schema support */
   char timestring[100];
   timestring[0] = '\0';
 
   namespaceList = msGMLGetNamespaces(&(map->web), "G");
   if (namespaceList == NULL) {
-    msSetError(MS_MISCERR, "Unable to populate namespace list", "msWFSGetFeature_GMLPreamble()");
+    msSetError(MS_MISCERR, "Unable to populate namespace list",
+               "msWFSGetFeature_GMLPreamble()");
     return MS_FAILURE;
   }
 
@@ -1752,11 +1816,14 @@ static int msWFSGetFeature_GMLPreamble(
   ** Establish script_url.
   */
 
-  if ((gmlinfo->script_url=msOWSGetOnlineResource(map,"FO","onlineresource",req)) ==NULL ||
-      (gmlinfo->script_url_encoded = msEncodeHTMLEntities(gmlinfo->script_url)) == NULL) {
+  if ((gmlinfo->script_url =
+           msOWSGetOnlineResource(map, "FO", "onlineresource", req)) == NULL ||
+      (gmlinfo->script_url_encoded =
+           msEncodeHTMLEntities(gmlinfo->script_url)) == NULL) {
     msSetError(MS_WFSERR, "Server URL not found", "msWFSGetFeature()");
     msGMLFreeNamespaces(namespaceList);
-    return msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE, paramsObj->pszVersion);
+    return msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE,
+                          paramsObj->pszVersion);
   }
 
   /*
@@ -1765,36 +1832,42 @@ static int msWFSGetFeature_GMLPreamble(
   msIO_printf("<?xml version='1.0' encoding=\"UTF-8\" ?>\n");
 
   value = msOWSLookupMetadata(&(map->web.metadata), "FO", "namespace_uri");
-  if(value) gmlinfo->user_namespace_uri = value;
+  if (value)
+    gmlinfo->user_namespace_uri = value;
   gmlinfo->user_namespace_uri_encoded =
-    msEncodeHTMLEntities(gmlinfo->user_namespace_uri);
+      msEncodeHTMLEntities(gmlinfo->user_namespace_uri);
 
   value = msOWSLookupMetadata(&(map->web.metadata), "FO", "namespace_prefix");
-  if(value) gmlinfo->user_namespace_prefix = value;
+  if (value)
+    gmlinfo->user_namespace_prefix = value;
 
-  if(gmlinfo->user_namespace_prefix != NULL && msIsXMLTagValid(gmlinfo->user_namespace_prefix) == MS_FALSE)
-    msIO_printf("<!-- WARNING: The value '%s' is not valid XML namespace. -->\n", gmlinfo->user_namespace_prefix);
+  if (gmlinfo->user_namespace_prefix != NULL &&
+      msIsXMLTagValid(gmlinfo->user_namespace_prefix) == MS_FALSE)
+    msIO_printf(
+        "<!-- WARNING: The value '%s' is not valid XML namespace. -->\n",
+        gmlinfo->user_namespace_prefix);
 
   value = msOWSLookupMetadata(&(map->web.metadata), "FO", "feature_collection");
-  if(value) gmlinfo->collection_name = value;
+  if (value)
+    gmlinfo->collection_name = value;
 
-  encoded_version = msEncodeHTMLEntities( paramsObj->pszVersion );
-  encoded_typename = msEncodeHTMLEntities( gmlinfo->_typename );
-  encoded_schema = msEncodeHTMLEntities( msOWSGetSchemasLocation(map) );
+  encoded_version = msEncodeHTMLEntities(paramsObj->pszVersion);
+  encoded_typename = msEncodeHTMLEntities(gmlinfo->_typename);
+  encoded_schema = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
 
-  if( nWFSVersion >= OWS_2_0_0) {
+  if (nWFSVersion >= OWS_2_0_0) {
     int nNextStartIndex;
-    char* tmp;
-    char* encoded_mime_type;
+    char *tmp;
+    char *encoded_mime_type;
     int bAbleToPrintPreviousOrNext = MS_TRUE;
 
-    tmp = msEncodeUrl( gmlinfo->output_mime_type );
-    encoded_mime_type = msEncodeHTMLEntities( tmp );
+    tmp = msEncodeUrl(gmlinfo->output_mime_type);
+    encoded_mime_type = msEncodeHTMLEntities(tmp);
     msFree(tmp);
 
     msWFSGetFeature_GetTimeStamp(timestring, sizeof(timestring));
 
-    if( strcasecmp(paramsObj->pszRequest, "GetFeature") == 0 )
+    if (strcasecmp(paramsObj->pszRequest, "GetFeature") == 0)
       msIO_printf("<wfs:FeatureCollection\n");
     else
       msIO_printf("<wfs:ValueCollection\n");
@@ -1809,92 +1882,90 @@ static int msWFSGetFeature_GMLPreamble(
                     MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI);
     msWFSPrintAdditionalNamespaces(namespaceList);
 
-    msIO_printf("   xsi:schemaLocation=\"%s %sSERVICE=WFS&amp;VERSION=%s&amp;REQUEST=DescribeFeatureType&amp;TYPENAME=%s&amp;OUTPUTFORMAT=%s "
-                                        "%s %s%s "
-                                        "%s %s%s\"\n",
+    msIO_printf("   xsi:schemaLocation=\"%s "
+                "%sSERVICE=WFS&amp;VERSION=%s&amp;REQUEST=DescribeFeatureType&"
+                "amp;TYPENAME=%s&amp;OUTPUTFORMAT=%s "
+                "%s %s%s "
+                "%s %s%s\"\n",
                 gmlinfo->user_namespace_uri_encoded,
-                gmlinfo->script_url_encoded, encoded_version,
-                encoded_typename,
+                gmlinfo->script_url_encoded, encoded_version, encoded_typename,
                 gmlinfo->output_schema_format,
 
-                MS_OWSCOMMON_WFS_20_NAMESPACE_URI,
-                encoded_schema,
+                MS_OWSCOMMON_WFS_20_NAMESPACE_URI, encoded_schema,
                 MS_OWSCOMMON_WFS_20_SCHEMA_LOCATION,
 
                 msWFSGetGMLNamespaceURIFromGMLVersion(outputformat),
-                encoded_schema,
-                msWFSGetGMLSchemaLocation(outputformat));
+                encoded_schema, msWFSGetGMLSchemaLocation(outputformat));
 
     msIO_printf("   timeStamp=\"%s\" numberMatched=\"", timestring);
-    if( nMatchingFeatures < 0 )
-    {
-        /* If we don't know the exact number, at least return something */
-        /* equivalent to what we would return with WFS 1.1, otherwise */
-        /* resultType=hits would not return anything usefull to the client. */
-        if( iResultTypeHits == MS_TRUE )
-            msIO_printf("%d", iNumberOfFeatures);
-        else
-            msIO_printf("unknown");
-    }
-    else
-        msIO_printf("%d", nMatchingFeatures);
+    if (nMatchingFeatures < 0) {
+      /* If we don't know the exact number, at least return something */
+      /* equivalent to what we would return with WFS 1.1, otherwise */
+      /* resultType=hits would not return anything usefull to the client. */
+      if (iResultTypeHits == MS_TRUE)
+        msIO_printf("%d", iNumberOfFeatures);
+      else
+        msIO_printf("unknown");
+    } else
+      msIO_printf("%d", nMatchingFeatures);
     msIO_printf("\" numberReturned=\"%d\"",
                 (iResultTypeHits == 1) ? 0 : iNumberOfFeatures);
 
-    /* TODO: in case of a multi-layer GetFeature POST, it is difficult to build a */
-    /* valid GET KVP GetFeature/GetPropertyValue when some options are specified. So for now just */
+    /* TODO: in case of a multi-layer GetFeature POST, it is difficult to build
+     * a */
+    /* valid GET KVP GetFeature/GetPropertyValue when some options are
+     * specified. So for now just */
     /* avoid those problematic cases */
-    if( req->postrequest != NULL && (paramsObj->bHasPostStoredQuery ||
-        (strchr(encoded_typename, ',') != NULL &&
-        (paramsObj->pszFilter != NULL || paramsObj->pszPropertyName != NULL ||
-         paramsObj->pszSortBy != NULL))) )
-    {
-        bAbleToPrintPreviousOrNext = MS_FALSE;
-    }
+    if (req->postrequest != NULL &&
+        (paramsObj->bHasPostStoredQuery ||
+         (strchr(encoded_typename, ',') != NULL &&
+          (paramsObj->pszFilter != NULL || paramsObj->pszPropertyName != NULL ||
+           paramsObj->pszSortBy != NULL)))) {
+      bAbleToPrintPreviousOrNext = MS_FALSE;
+    }
+
+    if (bAbleToPrintPreviousOrNext) {
+      if (maxfeatures > 0 && iResultTypeHits != 1 &&
+          paramsObj->nStartIndex > 0 &&
+          ((nMatchingFeatures < 0 && iNumberOfFeatures > 0) ||
+           (nMatchingFeatures >= 0 &&
+            paramsObj->nStartIndex < nMatchingFeatures))) {
+        int nPrevStartIndex;
+
+        msIO_printf("\n");
+        msIO_printf("   previous=\"");
+        msWFSGetFeature_PrintBasePrevNextURI(req, gmlinfo, paramsObj,
+                                             encoded_version, encoded_typename,
+                                             encoded_mime_type);
+
+        nPrevStartIndex = paramsObj->nStartIndex - maxfeatures;
+        if (nPrevStartIndex > 0)
+          msIO_printf("&amp;STARTINDEX=%d", nPrevStartIndex);
+        msIO_printf("\"");
+      }
 
-    if( bAbleToPrintPreviousOrNext )
-    {
-        if( maxfeatures > 0 && 
-            iResultTypeHits != 1 && paramsObj->nStartIndex > 0 &&
-            ((nMatchingFeatures < 0  && iNumberOfFeatures > 0) ||
-             (nMatchingFeatures >= 0 && paramsObj->nStartIndex < nMatchingFeatures)) )
-        {
-            int nPrevStartIndex;
-
-            msIO_printf("\n");
-            msIO_printf("   previous=\"");
-            msWFSGetFeature_PrintBasePrevNextURI(req,gmlinfo, paramsObj,
-                                                encoded_version,
-                                                encoded_typename,
-                                                encoded_mime_type);
-
-            nPrevStartIndex = paramsObj->nStartIndex - maxfeatures;
-            if( nPrevStartIndex > 0 )
-                msIO_printf("&amp;STARTINDEX=%d", nPrevStartIndex);
-            msIO_printf("\"");
-        }
-
-        if( iResultTypeHits != 1 && paramsObj->nStartIndex >= 0 )
-            nNextStartIndex = paramsObj->nStartIndex;
-        else
-            nNextStartIndex = 0;
-        if( maxfeatures > 0 && (bHasNextFeatures || (nMatchingFeatures > 0 &&
-            (iResultTypeHits == 1 || iNumberOfFeatures + nNextStartIndex < nMatchingFeatures))) )
-        {
-            msIO_printf("\n");
-            msIO_printf("   next=\"");
-            msWFSGetFeature_PrintBasePrevNextURI(req,gmlinfo, paramsObj,
-                                                encoded_version,
-                                                encoded_typename,
-                                                encoded_mime_type);
-
-            if( iResultTypeHits != 1 )
-                nNextStartIndex += iNumberOfFeatures;
-
-            if( nNextStartIndex > 0 )
-                msIO_printf("&amp;STARTINDEX=%d", nNextStartIndex);
-            msIO_printf("\"");
-        }
+      if (iResultTypeHits != 1 && paramsObj->nStartIndex >= 0)
+        nNextStartIndex = paramsObj->nStartIndex;
+      else
+        nNextStartIndex = 0;
+      if (maxfeatures > 0 &&
+          (bHasNextFeatures ||
+           (nMatchingFeatures > 0 &&
+            (iResultTypeHits == 1 ||
+             iNumberOfFeatures + nNextStartIndex < nMatchingFeatures)))) {
+        msIO_printf("\n");
+        msIO_printf("   next=\"");
+        msWFSGetFeature_PrintBasePrevNextURI(req, gmlinfo, paramsObj,
+                                             encoded_version, encoded_typename,
+                                             encoded_mime_type);
+
+        if (iResultTypeHits != 1)
+          nNextStartIndex += iNumberOfFeatures;
+
+        if (nNextStartIndex > 0)
+          msIO_printf("&amp;STARTINDEX=%d", nNextStartIndex);
+        msIO_printf("\"");
+      }
     }
 
     msIO_printf(">\n");
@@ -1904,7 +1975,7 @@ static int msWFSGetFeature_GMLPreamble(
   /*
   ** GML 2.x
   */
-  else if(outputformat == OWS_GML2) { /* use a wfs:FeatureCollection */
+  else if (outputformat == OWS_GML2) { /* use a wfs:FeatureCollection */
     msIO_printf("<wfs:FeatureCollection\n");
     msWFS_NS_printf(gmlinfo->user_namespace_prefix,
                     gmlinfo->user_namespace_uri_encoded);
@@ -1919,19 +1990,22 @@ static int msWFSGetFeature_GMLPreamble(
     msWFSPrintAdditionalNamespaces(namespaceList);
 
     /* FIXME ? : the schemaLocation will be only valid for WFS 1.0.0 */
-    msIO_printf("   xsi:schemaLocation=\"http://www.opengis.net/wfs %s/wfs/%s/WFS-basic.xsd \n"
-                "                       %s %sSERVICE=WFS&amp;VERSION=%s&amp;REQUEST=DescribeFeatureType&amp;TYPENAME=%s&amp;OUTPUTFORMAT=%s\">\n",
+    msIO_printf("   xsi:schemaLocation=\"http://www.opengis.net/wfs "
+                "%s/wfs/%s/WFS-basic.xsd \n"
+                "                       %s "
+                "%sSERVICE=WFS&amp;VERSION=%s&amp;REQUEST=DescribeFeatureType&"
+                "amp;TYPENAME=%s&amp;OUTPUTFORMAT=%s\">\n",
                 encoded_schema, encoded_version,
                 gmlinfo->user_namespace_uri_encoded,
-                gmlinfo->script_url_encoded, encoded_version,
-                encoded_typename, gmlinfo->output_schema_format);
+                gmlinfo->script_url_encoded, encoded_version, encoded_typename,
+                gmlinfo->output_schema_format);
   }
 
   /*
   ** GML 3
   */
-  else if( outputformat == OWS_GML3 ) {
-    if( nWFSVersion == OWS_1_1_0 ) {
+  else if (outputformat == OWS_GML3) {
+    if (nWFSVersion == OWS_1_1_0) {
       msIO_printf("<wfs:FeatureCollection\n");
       msWFS_NS_printf(gmlinfo->user_namespace_prefix,
                       gmlinfo->user_namespace_uri_encoded);
@@ -1946,8 +2020,7 @@ static int msWFSGetFeature_GMLPreamble(
     } else {
       msIO_printf("<%s:%s\n"
                   "   version=\"1.0.0\"\n",
-                  gmlinfo->user_namespace_prefix,
-                  gmlinfo->collection_name);
+                  gmlinfo->user_namespace_prefix, gmlinfo->collection_name);
       msWFS_NS_printf(gmlinfo->user_namespace_prefix,
                       gmlinfo->user_namespace_uri_encoded);
       msWFS_NS_printf(MS_OWSCOMMON_GML_NAMESPACE_PREFIX,
@@ -1960,23 +2033,23 @@ static int msWFSGetFeature_GMLPreamble(
 
     msWFSPrintAdditionalNamespaces(namespaceList);
 
-    msIO_printf("   xsi:schemaLocation=\"%s %sSERVICE=WFS&amp;VERSION=%s&amp;REQUEST=DescribeFeatureType&amp;TYPENAME=%s&amp;OUTPUTFORMAT=%s",
+    msIO_printf("   xsi:schemaLocation=\"%s "
+                "%sSERVICE=WFS&amp;VERSION=%s&amp;REQUEST=DescribeFeatureType&"
+                "amp;TYPENAME=%s&amp;OUTPUTFORMAT=%s",
                 gmlinfo->user_namespace_uri_encoded,
-                gmlinfo->script_url_encoded, encoded_version,
-                encoded_typename, gmlinfo->output_schema_format);
+                gmlinfo->script_url_encoded, encoded_version, encoded_typename,
+                gmlinfo->output_schema_format);
 
-    if( nWFSVersion == OWS_1_1_0 ) {
+    if (nWFSVersion == OWS_1_1_0) {
 
-      msIO_printf("  %s %s%s",
-                  MS_OWSCOMMON_WFS_NAMESPACE_URI,
-                  encoded_schema,
+      msIO_printf("  %s %s%s", MS_OWSCOMMON_WFS_NAMESPACE_URI, encoded_schema,
                   MS_OWSCOMMON_WFS_11_SCHEMA_LOCATION);
 
       if (iResultTypeHits == 1) {
         msWFSGetFeature_GetTimeStamp(timestring, sizeof(timestring));
 
-        msIO_printf("\" timeStamp=\"%s\" numberOfFeatures=\"%d",
-                    timestring, iNumberOfFeatures);
+        msIO_printf("\" timeStamp=\"%s\" numberOfFeatures=\"%d", timestring,
+                    iNumberOfFeatures);
       }
     }
     msIO_printf("\">\n");
@@ -1997,20 +2070,18 @@ static int msWFSGetFeature_GMLPreamble(
 ** Generate the GML file tail closing the collection and cleanup a bit.
 */
 
-static int msWFSGetFeature_GMLPostfix( WFSGMLInfo *gmlinfo,
-                                       OWSGMLVersion outputformat,
-                                       int maxfeatures,
-                                       int iResultTypeHits,
-                                       int iNumberOfFeatures,
-                                       int nWFSVersion )
+static int msWFSGetFeature_GMLPostfix(WFSGMLInfo *gmlinfo,
+                                      OWSGMLVersion outputformat,
+                                      int maxfeatures, int iResultTypeHits,
+                                      int iNumberOfFeatures, int nWFSVersion)
 
 {
-  if (((iNumberOfFeatures==0) || (maxfeatures == 0)) && iResultTypeHits == 0) {
+  if (((iNumberOfFeatures == 0) || (maxfeatures == 0)) &&
+      iResultTypeHits == 0) {
 
-    if( nWFSVersion < OWS_2_0_0 )
-    {
+    if (nWFSVersion < OWS_2_0_0) {
       msIO_printf("   <gml:boundedBy>\n");
-      if(outputformat == OWS_GML3 || outputformat == OWS_GML32 )
+      if (outputformat == OWS_GML3 || outputformat == OWS_GML32)
         msIO_printf("      <gml:Null>missing</gml:Null>\n");
       else
         msIO_printf("      <gml:null>missing</gml:null>\n");
@@ -2018,13 +2089,14 @@ static int msWFSGetFeature_GMLPostfix( W
     }
   }
 
-  if(outputformat == OWS_GML2)
+  if (outputformat == OWS_GML2)
     msIO_printf("</wfs:FeatureCollection>\n\n");
   else {
-    if( nWFSVersion >= OWS_1_1_0 )
+    if (nWFSVersion >= OWS_1_1_0)
       msIO_printf("</wfs:FeatureCollection>\n\n");
     else
-      msIO_printf("</%s:%s>\n\n", gmlinfo->user_namespace_prefix, gmlinfo->collection_name);
+      msIO_printf("</%s:%s>\n\n", gmlinfo->user_namespace_prefix,
+                  gmlinfo->collection_name);
   }
 
   return MS_SUCCESS;
@@ -2033,253 +2105,235 @@ static int msWFSGetFeature_GMLPostfix( W
 /*
 ** msWFSBuildParamList()
 */
-static void msWFSBuildParamList(char** ppszStrList, const char* pszValue,
-                                const char* pszSep)
-{
-    if (*ppszStrList == NULL)
-        *ppszStrList = msStrdup(pszValue);
-    else
-    {
-        char* pszTmp = msStrdup(*ppszStrList);
-        *ppszStrList =
-            (char *)msSmallRealloc(*ppszStrList,
-                                    sizeof(char)*
-                                    (strlen(pszTmp)+
-                                     strlen(pszSep)+
-                                     strlen(pszValue)+1));
+static void msWFSBuildParamList(char **ppszStrList, const char *pszValue,
+                                const char *pszSep) {
+  if (*ppszStrList == NULL)
+    *ppszStrList = msStrdup(pszValue);
+  else {
+    char *pszTmp = msStrdup(*ppszStrList);
+    *ppszStrList = (char *)msSmallRealloc(
+        *ppszStrList, sizeof(char) * (strlen(pszTmp) + strlen(pszSep) +
+                                      strlen(pszValue) + 1));
 
-        sprintf(*ppszStrList,"%s%s%s",pszTmp,pszSep,pszValue);
-        free(pszTmp);
-    }
+    sprintf(*ppszStrList, "%s%s%s", pszTmp, pszSep, pszValue);
+    free(pszTmp);
+  }
 }
 
 /*
 ** msWFSTurnOffAllLayer()
 */
-static void msWFSTurnOffAllLayer(mapObj* map)
-{
-    int j;
-    for(j=0; j<map->numlayers; j++) {
-      layerObj *lp;
-      lp = GET_LAYER(map, j);
-      lp->status = MS_OFF;
-    }
+static void msWFSTurnOffAllLayer(mapObj *map) {
+  int j;
+  for (j = 0; j < map->numlayers; j++) {
+    layerObj *lp;
+    lp = GET_LAYER(map, j);
+    lp->status = MS_OFF;
+  }
 }
 
 /*
 ** msWFSRunFilter()
 */
-static int msWFSRunFilter(mapObj* map,
-                          layerObj* lp,
-                          const wfsParamsObj *paramsObj,
-                          const char* pszFilter,
-                          int nWFSVersion)
-{
-    int layerWasOpened;
-    FilterEncodingNode *psNode = NULL;
+static int msWFSRunFilter(mapObj *map, layerObj *lp,
+                          const wfsParamsObj *paramsObj, const char *pszFilter,
+                          int nWFSVersion) {
+  int layerWasOpened;
+  FilterEncodingNode *psNode = NULL;
 
-    psNode = FLTParseFilterEncoding(pszFilter);
+  psNode = FLTParseFilterEncoding(pszFilter);
 
-    if (!psNode) {
-        msSetError(MS_WFSERR,
-                   "Invalid or Unsupported FILTER in GetFeature : %s",
-                   "msWFSGetFeature()", pszFilter);
-        return msWFSException(map, "filter", MS_OWS_ERROR_INVALID_PARAMETER_VALUE, paramsObj->pszVersion);
-    }
+  if (!psNode) {
+    msSetError(MS_WFSERR, "Invalid or Unsupported FILTER in GetFeature : %s",
+               "msWFSGetFeature()", pszFilter);
+    return msWFSException(map, "filter", MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                          paramsObj->pszVersion);
+  }
 
-    /* Starting with WFS 1.1, we need to swap coordinates of BBOX or geometry */
-    /* parameters in some circumstances */
-    if( nWFSVersion >= OWS_1_1_0 )
-    {
-          int bDefaultSRSNeedsAxisSwapping = MS_FALSE;
-          char* srs;
-          msOWSGetEPSGProj(&(map->projection),&(map->web.metadata),"FO",MS_TRUE,&srs);
-          if (!srs)
-          {
-              msOWSGetEPSGProj(&(lp->projection), &(lp->metadata), "FO", MS_TRUE, &srs);
-          }
-          if ( srs && strncasecmp(srs, "EPSG:", 5) == 0 )
-          {
-              bDefaultSRSNeedsAxisSwapping = msIsAxisInverted(atoi(srs+5));
-          }
-          msFree(srs);
-          FLTDoAxisSwappingIfNecessary(map, psNode, bDefaultSRSNeedsAxisSwapping);
+  /* Starting with WFS 1.1, we need to swap coordinates of BBOX or geometry */
+  /* parameters in some circumstances */
+  if (nWFSVersion >= OWS_1_1_0) {
+    int bDefaultSRSNeedsAxisSwapping = MS_FALSE;
+    char *srs;
+    msOWSGetEPSGProj(&(map->projection), &(map->web.metadata), "FO", MS_TRUE,
+                     &srs);
+    if (!srs) {
+      msOWSGetEPSGProj(&(lp->projection), &(lp->metadata), "FO", MS_TRUE, &srs);
     }
-
-    layerWasOpened = msLayerIsOpen(lp);
-    if( !layerWasOpened && msLayerOpen(lp) != MS_SUCCESS )
-    {
-        FLTFreeFilterEncodingNode( psNode );
-        return msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE, paramsObj->pszVersion);
+    if (srs && strncasecmp(srs, "EPSG:", 5) == 0) {
+      bDefaultSRSNeedsAxisSwapping = msIsAxisInverted(atoi(srs + 5));
     }
+    msFree(srs);
+    FLTDoAxisSwappingIfNecessary(map, psNode, bDefaultSRSNeedsAxisSwapping);
+  }
 
-    FLTProcessPropertyIsNull(psNode, map, lp->index);
+  layerWasOpened = msLayerIsOpen(lp);
+  if (!layerWasOpened && msLayerOpen(lp) != MS_SUCCESS) {
+    FLTFreeFilterEncodingNode(psNode);
+    return msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE,
+                          paramsObj->pszVersion);
+  }
 
-    /*preparse the filter for gml aliases*/
-    FLTPreParseFilterForAliasAndGroup(psNode, map, lp->index, "G");
+  FLTProcessPropertyIsNull(psNode, map, lp->index);
 
-    /* Check that FeatureId filters are consistent with the active layer */
-    if( FLTCheckFeatureIdFilters(psNode, map, lp->index) == MS_FAILURE)
-    {
-        FLTFreeFilterEncodingNode( psNode );
-        return msWFSException(map, "resourceid", MS_OWS_ERROR_INVALID_PARAMETER_VALUE, paramsObj->pszVersion);
-    }
+  /*preparse the filter for gml aliases*/
+  FLTPreParseFilterForAliasAndGroup(psNode, map, lp->index, "G");
 
-    /* FIXME?: could probably apply to WFS 1.1 too */
-    if( nWFSVersion >= OWS_2_0_0 )
-    {
-        int nEvaluation;
+  /* Check that FeatureId filters are consistent with the active layer */
+  if (FLTCheckFeatureIdFilters(psNode, map, lp->index) == MS_FAILURE) {
+    FLTFreeFilterEncodingNode(psNode);
+    return msWFSException(map, "resourceid",
+                          MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                          paramsObj->pszVersion);
+  }
 
-        if( FLTCheckInvalidOperand(psNode) == MS_FAILURE)
-        {
-            FLTFreeFilterEncodingNode( psNode );
-            return msWFSException(map, "filter", MS_WFS_ERROR_OPERATION_PROCESSING_FAILED, paramsObj->pszVersion);
-        }
-
-        if( FLTCheckInvalidProperty(psNode, map, lp->index) == MS_FAILURE)
-        {
-            FLTFreeFilterEncodingNode( psNode );
-            return msWFSException(map, "filter", MS_OWS_ERROR_INVALID_PARAMETER_VALUE, paramsObj->pszVersion);
-        }
-
-        psNode = FLTSimplify(psNode, &nEvaluation);
-        if( psNode == NULL )
-        {
-            FLTFreeFilterEncodingNode( psNode );
-            if( nEvaluation == 1 ) {
-                /* return full layer */
-                return msWFSRunBasicGetFeature(map, lp, paramsObj, nWFSVersion);
-            }
-            else {
-                /* return empty result set */
-                return MS_SUCCESS;
-            }
-        }
+  /* FIXME?: could probably apply to WFS 1.1 too */
+  if (nWFSVersion >= OWS_2_0_0) {
+    int nEvaluation;
+
+    if (FLTCheckInvalidOperand(psNode) == MS_FAILURE) {
+      FLTFreeFilterEncodingNode(psNode);
+      return msWFSException(map, "filter",
+                            MS_WFS_ERROR_OPERATION_PROCESSING_FAILED,
+                            paramsObj->pszVersion);
+    }
 
+    if (FLTCheckInvalidProperty(psNode, map, lp->index) == MS_FAILURE) {
+      FLTFreeFilterEncodingNode(psNode);
+      return msWFSException(map, "filter", MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                            paramsObj->pszVersion);
     }
 
-    /* run filter.  If no results are found, do not throw exception */
-    /* this is a null result */
-    if( FLTApplyFilterToLayer(psNode, map, lp->index) != MS_SUCCESS ) {
-        errorObj* ms_error = msGetErrorObj();
+    psNode = FLTSimplify(psNode, &nEvaluation);
+    if (psNode == NULL) {
+      FLTFreeFilterEncodingNode(psNode);
+      if (nEvaluation == 1) {
+        /* return full layer */
+        return msWFSRunBasicGetFeature(map, lp, paramsObj, nWFSVersion);
+      } else {
+        /* return empty result set */
+        return MS_SUCCESS;
+      }
+    }
+  }
 
-        if(ms_error->code != MS_NOTFOUND) {
-            msSetError(MS_WFSERR, "FLTApplyFilterToLayer() failed", "msWFSGetFeature()");
-            FLTFreeFilterEncodingNode( psNode );
-            return msWFSException(map, "mapserv", ( nWFSVersion >= OWS_2_0_0 ) ? MS_WFS_ERROR_OPERATION_PROCESSING_FAILED : MS_OWS_ERROR_NO_APPLICABLE_CODE, paramsObj->pszVersion);
-        }
+  /* run filter.  If no results are found, do not throw exception */
+  /* this is a null result */
+  if (FLTApplyFilterToLayer(psNode, map, lp->index) != MS_SUCCESS) {
+    errorObj *ms_error = msGetErrorObj();
+
+    if (ms_error->code != MS_NOTFOUND) {
+      msSetError(MS_WFSERR, "FLTApplyFilterToLayer() failed",
+                 "msWFSGetFeature()");
+      FLTFreeFilterEncodingNode(psNode);
+      return msWFSException(map, "mapserv",
+                            (nWFSVersion >= OWS_2_0_0)
+                                ? MS_WFS_ERROR_OPERATION_PROCESSING_FAILED
+                                : MS_OWS_ERROR_NO_APPLICABLE_CODE,
+                            paramsObj->pszVersion);
     }
+  }
 
-    FLTFreeFilterEncodingNode( psNode );
+  FLTFreeFilterEncodingNode(psNode);
 
-    return MS_SUCCESS;
+  return MS_SUCCESS;
 }
 
 /*
 ** msWFSRunBasicGetFeature()
 */
-static int msWFSRunBasicGetFeature(mapObj* map,
-                                   layerObj* lp,
+static int msWFSRunBasicGetFeature(mapObj *map, layerObj *lp,
                                    const wfsParamsObj *paramsObj,
-                                   int nWFSVersion)
-{
-    rectObj ext;
-    int status;
-    
-    map->query.type = MS_QUERY_BY_RECT; /* setup the query */
-    map->query.mode = MS_QUERY_MULTIPLE;
-    map->query.rect = map->extent;
-    map->query.layer = lp->index;
+                                   int nWFSVersion) {
+  rectObj ext;
+  int status;
 
-    if( FLTLayerSetInvalidRectIfSupported(lp, &(map->query.rect)) )
-    {
-        /* do nothing */
-    }
-    else if (msOWSGetLayerExtent(map, lp, "FO", &ext) == MS_SUCCESS) {
-        char *pszMapSRS=NULL;
-        
-        /*if srsName was given for wfs 1.1.0, It is at this point loaded into the
-        map object and should be used*/
-        if(!paramsObj->pszSrs)
-          msOWSGetEPSGProj(&(map->projection), &(map->web.metadata), "FO", MS_TRUE, &pszMapSRS);
-
-        /* For a single point layer, to avoid numerical precision issues */
-        /* when reprojection is involved */
-        ext.minx -= 1e-5;
-        ext.miny -= 1e-5;
-        ext.maxx += 1e-5;
-        ext.maxy += 1e-5;
-
-        if (pszMapSRS != NULL && strncmp(pszMapSRS, "EPSG:", 5) == 0) {
-
-            if( nWFSVersion >= OWS_1_1_0 )
-                status = msLoadProjectionStringEPSG(&(map->projection), pszMapSRS);
-            else
-                status = msLoadProjectionString(&(map->projection), pszMapSRS);
-
-            if (status != 0) {
-                msSetError(MS_WFSERR, "msLoadProjectionString() failed: %s", "msWFSGetFeature()", pszMapSRS);
-                msFree(pszMapSRS);
-                return msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE, paramsObj->pszVersion);
-            }
-        }
+  map->query.type = MS_QUERY_BY_RECT; /* setup the query */
+  map->query.mode = MS_QUERY_MULTIPLE;
+  map->query.rect = map->extent;
+  map->query.layer = lp->index;
+
+  if (FLTLayerSetInvalidRectIfSupported(lp, &(map->query.rect))) {
+    /* do nothing */
+  } else if (msOWSGetLayerExtent(map, lp, "FO", &ext) == MS_SUCCESS) {
+    char *pszMapSRS = NULL;
+
+    /*if srsName was given for wfs 1.1.0, It is at this point loaded into the
+    map object and should be used*/
+    if (!paramsObj->pszSrs)
+      msOWSGetEPSGProj(&(map->projection), &(map->web.metadata), "FO", MS_TRUE,
+                       &pszMapSRS);
+
+    /* For a single point layer, to avoid numerical precision issues */
+    /* when reprojection is involved */
+    ext.minx -= 1e-5;
+    ext.miny -= 1e-5;
+    ext.maxx += 1e-5;
+    ext.maxy += 1e-5;
+
+    if (pszMapSRS != NULL && strncmp(pszMapSRS, "EPSG:", 5) == 0) {
+
+      if (nWFSVersion >= OWS_1_1_0)
+        status = msLoadProjectionStringEPSG(&(map->projection), pszMapSRS);
+      else
+        status = msLoadProjectionString(&(map->projection), pszMapSRS);
+
+      if (status != 0) {
+        msSetError(MS_WFSERR, "msLoadProjectionString() failed: %s",
+                   "msWFSGetFeature()", pszMapSRS);
         msFree(pszMapSRS);
+        return msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE,
+                              paramsObj->pszVersion);
+      }
+    }
+    msFree(pszMapSRS);
 
-        /*make sure that the layer projection is loaded.
-            It could come from a ows/wfs_srs metadata*/
-        if (lp->projection.numargs == 0) {
-            char *pszLayerSRS;
-            msOWSGetEPSGProj(&(lp->projection), &(lp->metadata), "FO", MS_TRUE, &pszLayerSRS);
-            if (pszLayerSRS) {
-                if (strncmp(pszLayerSRS, "EPSG:", 5) == 0) {
-                    if( nWFSVersion >= OWS_1_1_0 )
-                        msLoadProjectionStringEPSG(&(lp->projection), pszLayerSRS);
-                    else
-                        msLoadProjectionString(&(lp->projection), pszLayerSRS);
-                }
-            }
-            msFree(pszLayerSRS);
+    /*make sure that the layer projection is loaded.
+        It could come from a ows/wfs_srs metadata*/
+    if (lp->projection.numargs == 0) {
+      char *pszLayerSRS;
+      msOWSGetEPSGProj(&(lp->projection), &(lp->metadata), "FO", MS_TRUE,
+                       &pszLayerSRS);
+      if (pszLayerSRS) {
+        if (strncmp(pszLayerSRS, "EPSG:", 5) == 0) {
+          if (nWFSVersion >= OWS_1_1_0)
+            msLoadProjectionStringEPSG(&(lp->projection), pszLayerSRS);
+          else
+            msLoadProjectionString(&(lp->projection), pszLayerSRS);
         }
+      }
+      msFree(pszLayerSRS);
+    }
 
-        if (msProjectionsDiffer(&map->projection, &lp->projection) == MS_TRUE) {
-            msProjectRect(&lp->projection, &map->projection, &(ext));
-        }
-        map->query.rect = ext;
+    if (msProjectionsDiffer(&map->projection, &lp->projection) == MS_TRUE) {
+      msProjectRect(&lp->projection, &map->projection, &(ext));
     }
+    map->query.rect = ext;
+  }
 
-    if(msQueryByRect(map) != MS_SUCCESS) {
-        errorObj   *ms_error;
-        ms_error = msGetErrorObj();
+  if (msQueryByRect(map) != MS_SUCCESS) {
+    errorObj *ms_error;
+    ms_error = msGetErrorObj();
 
-        if(ms_error->code != MS_NOTFOUND) {
-            msSetError(MS_WFSERR, "ms_error->code not found", "msWFSGetFeature()");
-            return msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE, paramsObj->pszVersion);
-        }
+    if (ms_error->code != MS_NOTFOUND) {
+      msSetError(MS_WFSERR, "ms_error->code not found", "msWFSGetFeature()");
+      return msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE,
+                            paramsObj->pszVersion);
     }
+  }
 
-    return MS_SUCCESS;
+  return MS_SUCCESS;
 }
 
-
 /*
 ** msWFSRetrieveFeatures()
 */
-static int msWFSRetrieveFeatures(mapObj* map,
-                                 owsRequestObj* ows_request,
-                              const wfsParamsObj *paramsObj,
-                              const WFSGMLInfo* gmlinfo,
-                              const char* pszFilter,
-                              int bBBOXSet,
-                              const char* pszBBOXSRS,
-                              rectObj bbox,
-                              const char* pszFeatureId,
-                              char **layers,
-                              int numlayers,
-                              int maxfeatures,
-                              int nWFSVersion,
-                              int* pnOutTotalFeatures,
-                              int* pnHasNext)
-{
+static int msWFSRetrieveFeatures(
+    mapObj *map, owsRequestObj *ows_request, const wfsParamsObj *paramsObj,
+    const WFSGMLInfo *gmlinfo, const char *pszFilter, int bBBOXSet,
+    const char *pszBBOXSRS, rectObj bbox, const char *pszFeatureId,
+    char **layers, int numlayers, int maxfeatures, int nWFSVersion,
+    int *pnOutTotalFeatures, int *pnHasNext) {
   int i, j;
   int iNumberOfFeatures = 0;
 
@@ -2296,48 +2350,62 @@ static int msWFSRetrieveFeatures(mapObj*
     /* -------------------------------------------------------------------- */
 
     /* WFS 2.0 */
-    if (nWFSVersion >= OWS_2_0_0 &&
-        paramsObj->pszFilterLanguage != NULL &&
-        strcasecmp(paramsObj->pszFilterLanguage, "urn:ogc:def:query Language:OGC-FES:Filter") != 0) {
+    if (nWFSVersion >= OWS_2_0_0 && paramsObj->pszFilterLanguage != NULL &&
+        strcasecmp(paramsObj->pszFilterLanguage,
+                   "urn:ogc:def:query Language:OGC-FES:Filter") != 0) {
       msSetError(MS_WFSERR,
-                 "Unhandled value for FILTER_LANGUAGE parameter. Only \"urn:ogc:def:query Language:OGC-FES:Filter\" accepted.",
+                 "Unhandled value for FILTER_LANGUAGE parameter. Only "
+                 "\"urn:ogc:def:query Language:OGC-FES:Filter\" accepted.",
                  "msWFSGetFeature()");
-      return msWFSException(map, "filter_language", MS_OWS_ERROR_INVALID_PARAMETER_VALUE, paramsObj->pszVersion);
+      return msWFSException(map, "filter_language",
+                            MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                            paramsObj->pszVersion);
     }
 
-    if (gmlinfo->_typename == NULL || strlen(gmlinfo->_typename) <= 0 || layers == NULL || numlayers <= 0) {
+    if (gmlinfo->_typename == NULL || strlen(gmlinfo->_typename) <= 0 ||
+        layers == NULL || numlayers <= 0) {
       msSetError(MS_WFSERR,
-                 "Required %s parameter missing for GetFeature with a FILTER parameter.",
+                 "Required %s parameter missing for GetFeature with a FILTER "
+                 "parameter.",
                  "msWFSGetFeature()",
-                 (nWFSVersion >= OWS_2_0_0 ) ? "TYPENAMES": "TYPENAME" );
-      return msWFSException(map, (nWFSVersion >= OWS_2_0_0 ) ? "typenames": "typename",
-                            MS_OWS_ERROR_MISSING_PARAMETER_VALUE, paramsObj->pszVersion);
+                 (nWFSVersion >= OWS_2_0_0) ? "TYPENAMES" : "TYPENAME");
+      return msWFSException(
+          map, (nWFSVersion >= OWS_2_0_0) ? "typenames" : "typename",
+          MS_OWS_ERROR_MISSING_PARAMETER_VALUE, paramsObj->pszVersion);
     }
 
     if (bBBOXSet) {
       msSetError(MS_WFSERR,
-                 "BBOX parameter and FILTER parameter are mutually exclusive in GetFeature.",
+                 "BBOX parameter and FILTER parameter are mutually exclusive "
+                 "in GetFeature.",
                  "msWFSGetFeature()");
-      return msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE, paramsObj->pszVersion);
+      return msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE,
+                            paramsObj->pszVersion);
     }
 
     if (pszFeatureId != NULL) {
       msSetError(MS_WFSERR,
-                 "%s parameter and FILTER parameter are mutually exclusive in GetFeature.",
+                 "%s parameter and FILTER parameter are mutually exclusive in "
+                 "GetFeature.",
                  "msWFSGetFeature()",
-                 (nWFSVersion < OWS_2_0_0 ) ? "FEATUREID" : "RESOURCEID" );
-      return msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE, paramsObj->pszVersion);
+                 (nWFSVersion < OWS_2_0_0) ? "FEATUREID" : "RESOURCEID");
+      return msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE,
+                            paramsObj->pszVersion);
     }
 
-    if (msWFSGetFeatureApplySRS(map, paramsObj->pszSrs, nWFSVersion) == MS_FAILURE)
-        return msWFSException(map, "srsname", MS_OWS_ERROR_INVALID_PARAMETER_VALUE, paramsObj->pszVersion);
+    if (msWFSGetFeatureApplySRS(map, paramsObj->pszSrs, nWFSVersion) ==
+        MS_FAILURE)
+      return msWFSException(map, "srsname",
+                            MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                            paramsObj->pszVersion);
 
     /* -------------------------------------------------------------------- */
     /*      Parse the Filter parameter. If there are several Filter         */
     /*      parameters, each Filter is inside a parantheses. Eg :           */
     /*      FILTER=(<Filter><Within><PropertyName>                          */
     /*      INWATERA_1M/WKB_GEOM|INWATERA_1M/WKB_GEOM                       */
-    /*      <PropertyName><gml:Box><gml:coordinates>10,10 20,20</gml:coordinates>*/
+    /*      <PropertyName><gml:Box><gml:coordinates>10,10
+     * 20,20</gml:coordinates>*/
     /*      </gml:Box></Within></Filter>)(<Filter><Within><PropertyName>    */
     /*      INWATERA_1M/WKB_GEOM<PropertyName><gml:Box><gml:coordinates>10,10*/
     /*      20,20</gml:coordinates></gml:Box></Within></Filter>)            */
@@ -2346,60 +2414,59 @@ static int msWFSRetrieveFeatures(mapObj*
     if (strlen(pszFilter) > 0 && pszFilter[0] == '(') {
       paszFilter = FLTSplitFilters(pszFilter, &nFilters);
     } else if (numlayers == 1) {
-      nFilters=1;
-      paszFilter = (char **)msSmallMalloc(sizeof(char *)*nFilters);
+      nFilters = 1;
+      paszFilter = (char **)msSmallMalloc(sizeof(char *) * nFilters);
       paszFilter[0] = msStrdup(pszFilter);
     }
 
     if (numlayers != nFilters) {
-      msSetError(MS_WFSERR, "Wrong number of filter elements, one filter must be specified for each feature type listed in the %s parameter.",
+      msSetError(MS_WFSERR,
+                 "Wrong number of filter elements, one filter must be "
+                 "specified for each feature type listed in the %s parameter.",
                  "msWFSGetFeature()",
-                 (nWFSVersion >= OWS_2_0_0 ) ? "TYPENAMES": "TYPENAME" );
+                 (nWFSVersion >= OWS_2_0_0) ? "TYPENAMES" : "TYPENAME");
       msFreeCharArray(paszFilter, nFilters);
-      return msWFSException(map, "filter", MS_OWS_ERROR_INVALID_PARAMETER_VALUE, paramsObj->pszVersion);
+      return msWFSException(map, "filter", MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                            paramsObj->pszVersion);
     }
 
     /* -------------------------------------------------------------------- */
     /*      run through the filters and build the class expressions.        */
     /* -------------------------------------------------------------------- */
-    for (i=0; i<nFilters; i++) {
+    for (i = 0; i < nFilters; i++) {
       int status;
-      layerObj* lp;
+      layerObj *lp;
 
       lp = msWFSGetLayerByName(map, ows_request, layers[i]);
 
       /* Special value set when parsing XML Post when there is a mix of */
       /* Query with and without Filter */
-      if( strcmp(paszFilter[i], "!") == 0 )
+      if (strcmp(paszFilter[i], "!") == 0)
         status = msWFSRunBasicGetFeature(map, lp, paramsObj, nWFSVersion);
       else
         status = msWFSRunFilter(map, lp, paramsObj, paszFilter[i], nWFSVersion);
 
-      if( status != MS_SUCCESS )
-      {
-          msFreeCharArray(paszFilter, nFilters);
-          return status;
+      if (status != MS_SUCCESS) {
+        msFreeCharArray(paszFilter, nFilters);
+        return status;
       }
 
       /* Decrement the total maxfeatures */
-      if( map->query.maxfeatures >= 0 )
-      {
-          if( lp->resultcache && lp->resultcache->numresults > 0 )
-          {
-            map->query.maxfeatures -= lp->resultcache->numresults;
-            if( map->query.maxfeatures <= 0 )
-                break;
-          }
+      if (map->query.maxfeatures >= 0) {
+        if (lp->resultcache && lp->resultcache->numresults > 0) {
+          map->query.maxfeatures -= lp->resultcache->numresults;
+          if (map->query.maxfeatures <= 0)
+            break;
+        }
       }
     }
 
     msFreeCharArray(paszFilter, nFilters);
-  }/* end if filter set */
-
+  } /* end if filter set */
 
   if (pszFeatureId != NULL) {
     char **tokens = NULL;
-    int nTokens = 0, j=0, k=0;
+    int nTokens = 0, j = 0, k = 0;
     FilterEncodingNode *psNode = NULL;
     char **aFIDLayers = NULL;
     char **aFIDValues = NULL;
@@ -2414,20 +2481,20 @@ static int msWFSRetrieveFeatures(mapObj*
     */
     tokens = msStringSplit(pszFeatureId, ',', &nTokens);
     iFIDLayers = 0;
-    if (tokens && nTokens >=1) {
-      aFIDLayers = (char **)msSmallMalloc(sizeof(char *)*nTokens);
-      aFIDValues = (char **)msSmallMalloc(sizeof(char *)*nTokens);
-      for (j=0; j<nTokens; j++) {
+    if (tokens && nTokens >= 1) {
+      aFIDLayers = (char **)msSmallMalloc(sizeof(char *) * nTokens);
+      aFIDValues = (char **)msSmallMalloc(sizeof(char *) * nTokens);
+      for (j = 0; j < nTokens; j++) {
         aFIDLayers[j] = NULL;
         aFIDValues[j] = NULL;
       }
-      for (j=0; j<nTokens; j++) {
-        const char* pszLastDot = strrchr(tokens[j], '.');
+      for (j = 0; j < nTokens; j++) {
+        const char *pszLastDot = strrchr(tokens[j], '.');
         if (pszLastDot != NULL) {
-          char* pszLayerInFID = msStrdup(tokens[j]);
+          char *pszLayerInFID = msStrdup(tokens[j]);
           pszLayerInFID[pszLastDot - tokens[j]] = '\0';
           /* Find if the layer is already requested */
-          for (k=0; k<iFIDLayers; k++) {
+          for (k = 0; k < iFIDLayers; k++) {
             if (strcasecmp(aFIDLayers[k], pszLayerInFID) == 0)
               break;
           }
@@ -2439,20 +2506,23 @@ static int msWFSRetrieveFeatures(mapObj*
           /* Add the id to the list of search identifiers of the layer */
           if (aFIDValues[k] != NULL)
             aFIDValues[k] = msStringConcatenate(aFIDValues[k], ",");
-          aFIDValues[k] = msStringConcatenate( aFIDValues[k], pszLastDot + 1);
+          aFIDValues[k] = msStringConcatenate(aFIDValues[k], pszLastDot + 1);
           msFree(pszLayerInFID);
         } else {
           /* In WFS 20, an unknown/invalid feature id shouldn't trigger an */
           /* exception. Tested by CITE */
-          if( nWFSVersion < OWS_2_0_0 ) {
+          if (nWFSVersion < OWS_2_0_0) {
             msSetError(MS_WFSERR,
-                       "Invalid FeatureId in GetFeature. Expecting layername.value : %s",
+                       "Invalid FeatureId in GetFeature. Expecting "
+                       "layername.value : %s",
                        "msWFSGetFeature()", tokens[j]);
             if (tokens)
               msFreeCharArray(tokens, nTokens);
             msFreeCharArray(aFIDLayers, iFIDLayers);
             msFreeCharArray(aFIDValues, iFIDLayers);
-            return msWFSException(map, "featureid", MS_OWS_ERROR_INVALID_PARAMETER_VALUE, paramsObj->pszVersion);
+            return msWFSException(map, "featureid",
+                                  MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                                  paramsObj->pszVersion);
           }
         }
       }
@@ -2461,30 +2531,36 @@ static int msWFSRetrieveFeatures(mapObj*
       msFreeCharArray(tokens, nTokens);
 
     /*turn on the layers and make sure projections are set properly*/
-    for (j=0; j< iFIDLayers; j++) {
+    for (j = 0; j < iFIDLayers; j++) {
       layerObj *lp;
       lp = msWFSGetLayerByName(map, ows_request, aFIDLayers[j]);
-      if( lp == NULL ) {
-        msSetError(MS_WFSERR,
-                   "Invalid typename given with FeatureId in GetFeature : %s. A layer might be disabled for \
-this request. Check wfs/ows_enable_request settings.", "msWFSGetFeature()",
-                   aFIDLayers[j]);
+      if (lp == NULL) {
+        msSetError(
+            MS_WFSERR,
+            "Invalid typename given with FeatureId in GetFeature : %s. A layer might be disabled for \
+this request. Check wfs/ows_enable_request settings.",
+            "msWFSGetFeature()", aFIDLayers[j]);
 
         msFreeCharArray(aFIDLayers, iFIDLayers);
         msFreeCharArray(aFIDValues, iFIDLayers);
-        return msWFSException(map, "featureid", MS_OWS_ERROR_INVALID_PARAMETER_VALUE, paramsObj->pszVersion);
+        return msWFSException(map, "featureid",
+                              MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                              paramsObj->pszVersion);
       }
 
       lp->status = MS_ON;
     }
 
-    if( map->query.only_cache_result_count == MS_FALSE )
-        msWFSAnalyzeStartIndexAndFeatureCount(map, paramsObj, FALSE, NULL, NULL);
+    if (map->query.only_cache_result_count == MS_FALSE)
+      msWFSAnalyzeStartIndexAndFeatureCount(map, paramsObj, FALSE, NULL, NULL);
 
-    if (msWFSGetFeatureApplySRS(map, paramsObj->pszSrs, nWFSVersion) == MS_FAILURE)
-        return msWFSException(map, "srsname", MS_OWS_ERROR_INVALID_PARAMETER_VALUE, paramsObj->pszVersion);
+    if (msWFSGetFeatureApplySRS(map, paramsObj->pszSrs, nWFSVersion) ==
+        MS_FAILURE)
+      return msWFSException(map, "srsname",
+                            MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                            paramsObj->pszVersion);
 
-    for (j=0; j< iFIDLayers; j++) {
+    for (j = 0; j < iFIDLayers; j++) {
       layerObj *lp;
       lp = msWFSGetLayerByName(map, ows_request, aFIDLayers[j]);
       if (lp->_template == NULL) {
@@ -2493,26 +2569,26 @@ this request. Check wfs/ows_enable_reque
       }
       psNode = FLTCreateFeatureIdFilterEncoding(aFIDValues[j]);
 
-      if( FLTApplyFilterToLayer(psNode, map, lp->index) != MS_SUCCESS ) {
-        msSetError(MS_WFSERR, "FLTApplyFilterToLayer() failed", "msWFSGetFeature");
-        FLTFreeFilterEncodingNode( psNode );
+      if (FLTApplyFilterToLayer(psNode, map, lp->index) != MS_SUCCESS) {
+        msSetError(MS_WFSERR, "FLTApplyFilterToLayer() failed",
+                   "msWFSGetFeature");
+        FLTFreeFilterEncodingNode(psNode);
         msFreeCharArray(aFIDLayers, iFIDLayers);
         msFreeCharArray(aFIDValues, iFIDLayers);
-        return msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE, paramsObj->pszVersion);
+        return msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE,
+                              paramsObj->pszVersion);
       }
 
-      FLTFreeFilterEncodingNode( psNode );
+      FLTFreeFilterEncodingNode(psNode);
       psNode = NULL;
 
       /* Decrement the total maxfeatures */
-      if( map->query.maxfeatures >= 0 )
-      {
-          if( lp->resultcache && lp->resultcache->numresults > 0 )
-          {
-            map->query.maxfeatures -= lp->resultcache->numresults;
-            if( map->query.maxfeatures <= 0 )
-                break;
-          }
+      if (map->query.maxfeatures >= 0) {
+        if (lp->resultcache && lp->resultcache->numresults > 0) {
+          map->query.maxfeatures -= lp->resultcache->numresults;
+          if (map->query.maxfeatures <= 0)
+            break;
+        }
       }
     }
 
@@ -2528,37 +2604,40 @@ this request. Check wfs/ows_enable_reque
   if (pszFilter == NULL && pszFeatureId == NULL) {
 
     /* Apply the requested SRS */
-    if (msWFSGetFeatureApplySRS(map, paramsObj->pszSrs, nWFSVersion) == MS_FAILURE)
-        return msWFSException(map, "srsname", MS_OWS_ERROR_INVALID_PARAMETER_VALUE, paramsObj->pszVersion);
+    if (msWFSGetFeatureApplySRS(map, paramsObj->pszSrs, nWFSVersion) ==
+        MS_FAILURE)
+      return msWFSException(map, "srsname",
+                            MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                            paramsObj->pszVersion);
 
     if (!bBBOXSet) {
-      for(j=0; j<map->numlayers; j++) {
+      for (j = 0; j < map->numlayers; j++) {
         layerObj *lp;
         lp = GET_LAYER(map, j);
         if (lp->status == MS_ON) {
           int status = msWFSRunBasicGetFeature(map, lp, paramsObj, nWFSVersion);
-          if( status != MS_SUCCESS )
-              return status;
+          if (status != MS_SUCCESS)
+            return status;
         }
       }
     } else {
 
-      char* sBBoxSrs = NULL;
+      char *sBBoxSrs = NULL;
 
-      if( pszBBOXSRS != NULL )
-          sBBoxSrs = msStrdup(pszBBOXSRS);
+      if (pszBBOXSRS != NULL)
+        sBBoxSrs = msStrdup(pszBBOXSRS);
 
       /* On WFS 2.0.0, if the BBOX has no explicit SRS, use the map SRS */
       /* Should likely be used for WFS 1.1.0 too, but don't want to cause */
       /* issue at that point, since it can influence axis ordering */
-      if( nWFSVersion >= OWS_2_0_0 && sBBoxSrs == NULL )
-      {
-          projectionObj sProjTmp;
-
-          msInitProjection(&sProjTmp);
-          msProjectionInheritContextFrom(&sProjTmp, &(map->projection));
-          msOWSGetEPSGProj(&sProjTmp,&(map->web.metadata),"FO",MS_TRUE, &sBBoxSrs);
-          msFreeProjection(&sProjTmp);
+      if (nWFSVersion >= OWS_2_0_0 && sBBoxSrs == NULL) {
+        projectionObj sProjTmp;
+
+        msInitProjection(&sProjTmp);
+        msProjectionInheritContextFrom(&sProjTmp, &(map->projection));
+        msOWSGetEPSGProj(&sProjTmp, &(map->web.metadata), "FO", MS_TRUE,
+                         &sBBoxSrs);
+        msFreeProjection(&sProjTmp);
       }
 
       if (sBBoxSrs) {
@@ -2570,15 +2649,15 @@ this request. Check wfs/ows_enable_reque
         /*do the axis order for now. It is unclear if the bbox are expected
           ro respect the axis oder defined in the projectsion #3296*/
 
-        if(nWFSVersion >= OWS_1_1_0) {
-          if ((status=msLoadProjectionStringEPSG(&sProjTmp, sBBoxSrs)) == 0) {
-            msAxisNormalizePoints( &sProjTmp, 1, &bbox.minx, &bbox.miny );
-            msAxisNormalizePoints( &sProjTmp, 1, &bbox.maxx, &bbox.maxy );
+        if (nWFSVersion >= OWS_1_1_0) {
+          if ((status = msLoadProjectionStringEPSG(&sProjTmp, sBBoxSrs)) == 0) {
+            msAxisNormalizePoints(&sProjTmp, 1, &bbox.minx, &bbox.miny);
+            msAxisNormalizePoints(&sProjTmp, 1, &bbox.maxx, &bbox.maxy);
           }
         } else
           status = msLoadProjectionString(&sProjTmp, sBBoxSrs);
 
-        if (status == 0 &&  map->projection.numargs > 0)
+        if (status == 0 && map->projection.numargs > 0)
           msProjectRect(&sProjTmp, &map->projection, &bbox);
         msFreeProjection(&sProjTmp);
 
@@ -2590,63 +2669,66 @@ this request. Check wfs/ows_enable_reque
       map->query.rect = bbox;
 
       /*
-        Retaining this block of code in case we want to setup a rendering path through
-        the query code at some point.
+        Retaining this block of code in case we want to setup a rendering path
+        through the query code at some point.
       */
       /* if(map->outputformat && MS_DRIVER_MVT(map->outputformat)) {
-        const char *mvt_buffer = msGetOutputFormatOption(map->outputformat, "EDGE_BUFFER", "10");
-        int buffer = MS_ABS(atoi(mvt_buffer));
-        double res = (bbox.maxx - bbox.minx)/(double)map->width;
-        bbox.minx -= buffer * res;
+        const char *mvt_buffer = msGetOutputFormatOption(map->outputformat,
+      "EDGE_BUFFER", "10"); int buffer = MS_ABS(atoi(mvt_buffer)); double res =
+      (bbox.maxx - bbox.minx)/(double)map->width; bbox.minx -= buffer * res;
         bbox.maxx += buffer * res;
         res = (bbox.maxy - bbox.miny)/(double)map->height;
         bbox.miny -= buffer * res;
         bbox.maxy += buffer * res;
         map->width += buffer*2;
         map->height += buffer*2;
-        msCalculateScale(bbox,map->units,map->width,map->height, map->resolution, &map->scaledenom);
-        map->query.rect = bbox;
+        msCalculateScale(bbox,map->units,map->width,map->height,
+      map->resolution, &map->scaledenom); map->query.rect = bbox;
       } */
 
-      if(msQueryByRect(map) != MS_SUCCESS) {
-        errorObj   *ms_error;
+      if (msQueryByRect(map) != MS_SUCCESS) {
+        errorObj *ms_error;
         ms_error = msGetErrorObj();
 
-        if(ms_error->code != MS_NOTFOUND) {
-          msSetError(MS_WFSERR, "ms_error->code not found", "msWFSGetFeature()");
-          return msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE, paramsObj->pszVersion);
+        if (ms_error->code != MS_NOTFOUND) {
+          msSetError(MS_WFSERR, "ms_error->code not found",
+                     "msWFSGetFeature()");
+          return msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE,
+                                paramsObj->pszVersion);
         }
       }
     }
   }
 
   /* Count total number of features retrieved */
-  for(j=0; j<map->numlayers; j++) {
-    if (GET_LAYER(map, j)->resultcache && GET_LAYER(map, j)->resultcache->numresults > 0) {
+  for (j = 0; j < map->numlayers; j++) {
+    if (GET_LAYER(map, j)->resultcache &&
+        GET_LAYER(map, j)->resultcache->numresults > 0) {
       iNumberOfFeatures += GET_LAYER(map, j)->resultcache->numresults;
     }
   }
 
-  /* If maxfeatures is set, we have actually asked for 1 more feature than asked */
+  /* If maxfeatures is set, we have actually asked for 1 more feature than asked
+   */
   /* to be able to know if there are next features. So it is now time to */
   /* remove this extra unasked feature from the result cache */
-  if( maxfeatures >= 0 && iNumberOfFeatures == maxfeatures + 1 )
-  {
-      int lastJ = -1;
-      for(j=0; j<map->numlayers; j++) {
-          if (GET_LAYER(map, j)->resultcache && GET_LAYER(map, j)->resultcache->numresults > 0) {
-              lastJ = j;
-          }
+  if (maxfeatures >= 0 && iNumberOfFeatures == maxfeatures + 1) {
+    int lastJ = -1;
+    for (j = 0; j < map->numlayers; j++) {
+      if (GET_LAYER(map, j)->resultcache &&
+          GET_LAYER(map, j)->resultcache->numresults > 0) {
+        lastJ = j;
       }
-      GET_LAYER(map, lastJ)->resultcache->numresults --;
-      GET_LAYER(map, lastJ)->resultcache->bounds = GET_LAYER(map, lastJ)->resultcache->previousBounds;
-      iNumberOfFeatures --;
-      if( pnHasNext )
-          *pnHasNext = MS_TRUE;
-  }
-  else if( pnHasNext )
-      *pnHasNext = MS_FALSE;
-  
+    }
+    GET_LAYER(map, lastJ)->resultcache->numresults--;
+    GET_LAYER(map, lastJ)->resultcache->bounds =
+        GET_LAYER(map, lastJ)->resultcache->previousBounds;
+    iNumberOfFeatures--;
+    if (pnHasNext)
+      *pnHasNext = MS_TRUE;
+  } else if (pnHasNext)
+    *pnHasNext = MS_FALSE;
+
   *pnOutTotalFeatures = iNumberOfFeatures;
 
   return MS_SUCCESS;
@@ -2655,69 +2737,64 @@ this request. Check wfs/ows_enable_reque
 /*
 ** msWFSParsePropertyNameOrSortBy()
 */
-static char** msWFSParsePropertyNameOrSortBy(const char* pszPropertyName,
-                                             int numlayers)
-{
-    char** tokens = NULL;
-    int nPropertyNames = 0;
-    char** papszPropertyName = NULL;
-    int i;
-
-    if( pszPropertyName == NULL )
-    {
-        papszPropertyName = (char **)msSmallMalloc(sizeof(char *)*numlayers);
-        for (i=0; i<numlayers; i++) {
-            papszPropertyName[i] = msStrdup("!");
-        }
-        return papszPropertyName;
-    }
+static char **msWFSParsePropertyNameOrSortBy(const char *pszPropertyName,
+                                             int numlayers) {
+  char **tokens = NULL;
+  int nPropertyNames = 0;
+  char **papszPropertyName = NULL;
+  int i;
 
-    if (!(pszPropertyName[0] == '(' || numlayers == 1))
-    {
-        return NULL;
+  if (pszPropertyName == NULL) {
+    papszPropertyName = (char **)msSmallMalloc(sizeof(char *) * numlayers);
+    for (i = 0; i < numlayers; i++) {
+      papszPropertyName[i] = msStrdup("!");
     }
+    return papszPropertyName;
+  }
 
-    if (numlayers == 1 && pszPropertyName[0] != '(') {
-        /* Accept PROPERTYNAME without () when there is a single TYPENAME */
-        std::string osTmpPropertyName;
-        osTmpPropertyName = '(';
-        osTmpPropertyName += pszPropertyName;
-        osTmpPropertyName += ')';
-        tokens = msStringSplit(osTmpPropertyName.c_str()+1, '(', &nPropertyNames);
-    } else
-        tokens = msStringSplit(pszPropertyName+1, '(', &nPropertyNames);
+  if (!(pszPropertyName[0] == '(' || numlayers == 1)) {
+    return NULL;
+  }
 
-    /*expecting to always have a list of property names equal to
-        the number of layers(typename)*/
-    if (nPropertyNames != numlayers) {
-        msFreeCharArray(tokens, nPropertyNames);
-        return NULL;
-    }
+  if (numlayers == 1 && pszPropertyName[0] != '(') {
+    /* Accept PROPERTYNAME without () when there is a single TYPENAME */
+    std::string osTmpPropertyName;
+    osTmpPropertyName = '(';
+    osTmpPropertyName += pszPropertyName;
+    osTmpPropertyName += ')';
+    tokens = msStringSplit(osTmpPropertyName.c_str() + 1, '(', &nPropertyNames);
+  } else
+    tokens = msStringSplit(pszPropertyName + 1, '(', &nPropertyNames);
+
+  /*expecting to always have a list of property names equal to
+      the number of layers(typename)*/
+  if (nPropertyNames != numlayers) {
+    msFreeCharArray(tokens, nPropertyNames);
+    return NULL;
+  }
 
-    papszPropertyName = (char **)msSmallMalloc(sizeof(char *)*nPropertyNames);
-    for (i=0; i<nPropertyNames; i++) {
-        if (strlen(tokens[i]) > 0) {
-            papszPropertyName[i] = msStrdup(tokens[i]);
-            /* remove trailing ) */
-            papszPropertyName[i][strlen(papszPropertyName[i])-1] = '\0';
-        }
-        else {
-            for ( i--; i>=0; i-- )
-                msFree(papszPropertyName[i]);
-            msFree(papszPropertyName);
-            msFreeCharArray(tokens, nPropertyNames);
-            return NULL;
-        }
+  papszPropertyName = (char **)msSmallMalloc(sizeof(char *) * nPropertyNames);
+  for (i = 0; i < nPropertyNames; i++) {
+    if (strlen(tokens[i]) > 0) {
+      papszPropertyName[i] = msStrdup(tokens[i]);
+      /* remove trailing ) */
+      papszPropertyName[i][strlen(papszPropertyName[i]) - 1] = '\0';
+    } else {
+      for (i--; i >= 0; i--)
+        msFree(papszPropertyName[i]);
+      msFree(papszPropertyName);
+      msFreeCharArray(tokens, nPropertyNames);
+      return NULL;
     }
+  }
 
-    msFreeCharArray(tokens, nPropertyNames);
+  msFreeCharArray(tokens, nPropertyNames);
 
-    return papszPropertyName;
+  return papszPropertyName;
 }
 
-static void msWFSInitGMLInfo(WFSGMLInfo* pgmlinfo)
-{
-  memset( pgmlinfo, 0, sizeof(WFSGMLInfo) );
+static void msWFSInitGMLInfo(WFSGMLInfo *pgmlinfo) {
+  memset(pgmlinfo, 0, sizeof(WFSGMLInfo));
   pgmlinfo->user_namespace_prefix = MS_DEFAULT_NAMESPACE_PREFIX;
   pgmlinfo->user_namespace_uri = MS_DEFAULT_NAMESPACE_URI;
   pgmlinfo->collection_name = OWS_WFS_FEATURE_COLLECTION_NAME;
@@ -2726,40 +2803,45 @@ static void msWFSInitGMLInfo(WFSGMLInfo*
   pgmlinfo->output_schema_format = "XMLSCHEMA";
 }
 
-static void msWFSCleanupGMLInfo(WFSGMLInfo* pgmlinfo)
-{
+static void msWFSCleanupGMLInfo(WFSGMLInfo *pgmlinfo) {
   free(pgmlinfo->script_url);
   free(pgmlinfo->script_url_encoded);
   msFree(pgmlinfo->user_namespace_uri_encoded);
 }
 
-static int msWFSGetGMLOutputFormat( wfsParamsObj *paramsObj,
-                                    WFSGMLInfo* pgmlinfo,
-                                    int nWFSVersion)
-{
+static int msWFSGetGMLOutputFormat(wfsParamsObj *paramsObj,
+                                   WFSGMLInfo *pgmlinfo, int nWFSVersion) {
   OWSGMLVersion outputformat = OWS_GML2;
 
   /* Validate outputformat */
   if (paramsObj->pszOutputFormat) {
     /* We support GML2, GML3, GML3.2 for now. */
-    if(strcasecmp(paramsObj->pszOutputFormat, "GML2") == 0 ||
-       strcasecmp(paramsObj->pszOutputFormat, "text/xml; subtype=gml/2.1.2") == 0) {
+    if (strcasecmp(paramsObj->pszOutputFormat, "GML2") == 0 ||
+        strcasecmp(paramsObj->pszOutputFormat, "text/xml; subtype=gml/2.1.2") ==
+            0) {
       outputformat = OWS_GML2;
       pgmlinfo->output_schema_format = "XMLSCHEMA";
-    /* FIXME? : subtype=gml/XXXX is invalid without quoting. Seen with CITE WFS 2.0 */
+      /* FIXME? : subtype=gml/XXXX is invalid without quoting. Seen with CITE
+       * WFS 2.0 */
       pgmlinfo->output_mime_type = "text/xml; subtype=gml/2.1.2";
-    } else if(strcasecmp(paramsObj->pszOutputFormat, "GML3") == 0 ||
-              strcasecmp(paramsObj->pszOutputFormat, "text/xml; subtype=gml/3.1.1") == 0) {
+    } else if (strcasecmp(paramsObj->pszOutputFormat, "GML3") == 0 ||
+               strcasecmp(paramsObj->pszOutputFormat,
+                          "text/xml; subtype=gml/3.1.1") == 0) {
       outputformat = OWS_GML3;
       pgmlinfo->output_schema_format = "SFE_XMLSCHEMA";
-      /* FIXME? : subtype=gml/XXXX is invalid without quoting. Seen with CITE WFS 2.0 */
+      /* FIXME? : subtype=gml/XXXX is invalid without quoting. Seen with CITE
+       * WFS 2.0 */
       pgmlinfo->output_mime_type = "text/xml; subtype=gml/3.1.1";
-    } else if(strcasecmp(paramsObj->pszOutputFormat, "GML32") == 0 ||
-              strcasecmp(paramsObj->pszOutputFormat, "text/xml; subtype=gml/3.2.1") == 0 ||
-              strcasecmp(paramsObj->pszOutputFormat, "text/xml; subtype=\"gml/3.2.1\"") == 0 ||
-              strcasecmp(paramsObj->pszOutputFormat, "application/gml+xml; version=3.2") == 0) {
+    } else if (strcasecmp(paramsObj->pszOutputFormat, "GML32") == 0 ||
+               strcasecmp(paramsObj->pszOutputFormat,
+                          "text/xml; subtype=gml/3.2.1") == 0 ||
+               strcasecmp(paramsObj->pszOutputFormat,
+                          "text/xml; subtype=\"gml/3.2.1\"") == 0 ||
+               strcasecmp(paramsObj->pszOutputFormat,
+                          "application/gml+xml; version=3.2") == 0) {
       outputformat = OWS_GML32;
-      pgmlinfo->output_schema_format = "application%2Fgml%2Bxml%3B%20version%3D3.2";
+      pgmlinfo->output_schema_format =
+          "application%2Fgml%2Bxml%3B%20version%3D3.2";
       pgmlinfo->output_mime_type = "text/xml; subtype=\"gml/3.2.1\"";
     } else {
       return -1;
@@ -2768,125 +2850,126 @@ static int msWFSGetGMLOutputFormat( wfsP
     /* If OUTPUTFORMAT not set, default to gml */
   } else {
     /*set the output format using the version if available*/
-    if( nWFSVersion == OWS_1_1_0 ) {
+    if (nWFSVersion == OWS_1_1_0) {
       outputformat = OWS_GML3;
       pgmlinfo->output_schema_format = "text/xml;%20subtype=gml/3.1.1";
-      /* FIXME? : subtype=gml/XXXX is invalid without quoting. Seen with CITE WFS 2.0 */
+      /* FIXME? : subtype=gml/XXXX is invalid without quoting. Seen with CITE
+       * WFS 2.0 */
       pgmlinfo->output_mime_type = "text/xml; subtype=gml/3.1.1";
-    }
-    else if( nWFSVersion >= OWS_2_0_0 ) {
+    } else if (nWFSVersion >= OWS_2_0_0) {
       outputformat = OWS_GML32;
-      pgmlinfo->output_schema_format = "application%2Fgml%2Bxml%3B%20version%3D3.2";
+      pgmlinfo->output_schema_format =
+          "application%2Fgml%2Bxml%3B%20version%3D3.2";
       pgmlinfo->output_mime_type = "text/xml; subtype=\"gml/3.2.1\"";
     }
   }
 
-  if( nWFSVersion == OWS_1_0_0 ) {
+  if (nWFSVersion == OWS_1_0_0) {
     pgmlinfo->output_mime_type = "text/xml";
   }
 
   return outputformat;
 }
 
-static outputFormatObj* msWFSGetOtherOutputFormat(mapObj *map, wfsParamsObj *paramsObj)
-{
+static outputFormatObj *msWFSGetOtherOutputFormat(mapObj *map,
+                                                  wfsParamsObj *paramsObj) {
   const char *format_list;
   hashTableObj *md;
-  outputFormatObj* psFormat = NULL;
+  outputFormatObj *psFormat = NULL;
   int j;
 
   /* validate selected format against all selected layers. */
-  for(j=0; j < map->numlayers; j++) {
+  for (j = 0; j < map->numlayers; j++) {
     layerObj *lp;
 
     lp = GET_LAYER(map, j);
 
-    if( lp->status != MS_ON )
-        continue;
+    if (lp->status != MS_ON)
+      continue;
 
     md = &(lp->metadata);
-    format_list = msOWSLookupMetadata(md, "F","getfeature_formatlist");
-    if( format_list == NULL ) {
-        md = &(map->web.metadata);
-        format_list = msOWSLookupMetadata(md, "F","getfeature_formatlist");
+    format_list = msOWSLookupMetadata(md, "F", "getfeature_formatlist");
+    if (format_list == NULL) {
+      md = &(map->web.metadata);
+      format_list = msOWSLookupMetadata(md, "F", "getfeature_formatlist");
     }
     if (format_list) {
-        psFormat = msOwsIsOutputFormatValid(
-                    map, paramsObj->pszOutputFormat, md,
-                    "F", "getfeature_formatlist");
+      psFormat = msOwsIsOutputFormatValid(map, paramsObj->pszOutputFormat, md,
+                                          "F", "getfeature_formatlist");
     }
     if (psFormat == NULL) {
-        msSetError(MS_WFSERR,
-                    "'%s' is not a permitted output format for layer '%s', review wfs_getfeature_formatlist setting.",
-                    "msWFSGetFeature()",
-                    paramsObj->pszOutputFormat,
-                    lp->name );
-        return NULL;
+      msSetError(MS_WFSERR,
+                 "'%s' is not a permitted output format for layer '%s', review "
+                 "wfs_getfeature_formatlist setting.",
+                 "msWFSGetFeature()", paramsObj->pszOutputFormat, lp->name);
+      return NULL;
     }
 
-    if( psFormat->imagemode != MS_IMAGEMODE_FEATURE ) {
-        msSetError(MS_WFSERR,
-                    "OUTPUTFORMAT '%s' does not have IMAGEMODE FEATURE, and is not permitted for WFS output.",
-                    "msWFSGetFeature()",
-                    paramsObj->pszOutputFormat );
-        return NULL;
+    if (psFormat->imagemode != MS_IMAGEMODE_FEATURE) {
+      msSetError(MS_WFSERR,
+                 "OUTPUTFORMAT '%s' does not have IMAGEMODE FEATURE, and is "
+                 "not permitted for WFS output.",
+                 "msWFSGetFeature()", paramsObj->pszOutputFormat);
+      return NULL;
     }
   }
-  
+
   return psFormat;
 }
 
-static void msWFSAnalyzeStartIndexAndFeatureCount(mapObj *map, const wfsParamsObj *paramsObj,
+static void msWFSAnalyzeStartIndexAndFeatureCount(mapObj *map,
+                                                  const wfsParamsObj *paramsObj,
                                                   int bIsHits,
-                                                  int *pmaxfeatures, int* pstartindex)
-{
+                                                  int *pmaxfeatures,
+                                                  int *pstartindex) {
   const char *tmpmaxfeatures = NULL;
-  int   maxfeatures=-1,startindex=-1;
+  int maxfeatures = -1, startindex = -1;
   int j;
 
-  int nQueriedLayers=0;
-  layerObj *lpQueried=NULL;
+  int nQueriedLayers = 0;
+  layerObj *lpQueried = NULL;
 
-  tmpmaxfeatures = msOWSLookupMetadata(&(map->web.metadata), "FO", "maxfeatures");
+  tmpmaxfeatures =
+      msOWSLookupMetadata(&(map->web.metadata), "FO", "maxfeatures");
   if (tmpmaxfeatures)
     maxfeatures = atoi(tmpmaxfeatures);
 
-  if( bIsHits )
-  {
-    const char* ignoreMaxFeaturesForHits =
-        msOWSLookupMetadata(&(map->web.metadata), "FO", "maxfeatures_ignore_for_resulttype_hits");
-
-    /* For PostGIS where we have an efficient implementation of hits, default to true */
-    if( ignoreMaxFeaturesForHits == NULL )
-    {
-        int bHasEfficientHits = MS_TRUE;
-        for(j=0; j<map->numlayers; j++) {
-            layerObj *lp;
-            lp = GET_LAYER(map, j);
-            if (lp->status == MS_ON) {
-                if( lp->connectiontype != MS_POSTGIS )
-                {
-                    bHasEfficientHits = MS_FALSE;
-                    break;
-                }
-            }
+  if (bIsHits) {
+    const char *ignoreMaxFeaturesForHits = msOWSLookupMetadata(
+        &(map->web.metadata), "FO", "maxfeatures_ignore_for_resulttype_hits");
+
+    /* For PostGIS where we have an efficient implementation of hits, default to
+     * true */
+    if (ignoreMaxFeaturesForHits == NULL) {
+      int bHasEfficientHits = MS_TRUE;
+      for (j = 0; j < map->numlayers; j++) {
+        layerObj *lp;
+        lp = GET_LAYER(map, j);
+        if (lp->status == MS_ON) {
+          if (lp->connectiontype != MS_POSTGIS) {
+            bHasEfficientHits = MS_FALSE;
+            break;
+          }
         }
+      }
 
-        if (bHasEfficientHits )
-            ignoreMaxFeaturesForHits = "true";
+      if (bHasEfficientHits)
+        ignoreMaxFeaturesForHits = "true";
     }
 
-    if( ignoreMaxFeaturesForHits != NULL && strcasecmp(ignoreMaxFeaturesForHits, "true") == 0 )
-        maxfeatures = -1;
+    if (ignoreMaxFeaturesForHits != NULL &&
+        strcasecmp(ignoreMaxFeaturesForHits, "true") == 0)
+      maxfeatures = -1;
   }
 
   if (paramsObj->nMaxFeatures >= 0) {
-    if (maxfeatures < 0 || (maxfeatures > 0 && paramsObj->nMaxFeatures < maxfeatures))
+    if (maxfeatures < 0 ||
+        (maxfeatures > 0 && paramsObj->nMaxFeatures < maxfeatures))
       maxfeatures = paramsObj->nMaxFeatures;
   }
 
-  nQueriedLayers=0;
-  for(j=0; j<map->numlayers; j++) {
+  nQueriedLayers = 0;
+  for (j = 0; j < map->numlayers; j++) {
     layerObj *lp;
     lp = GET_LAYER(map, j);
     if (lp->status == MS_ON) {
@@ -2904,38 +2987,36 @@ static void msWFSAnalyzeStartIndexAndFea
   /* possible confusion */
   if (paramsObj->nStartIndex >= 0) {
     startindex = 1 + paramsObj->nStartIndex;
-    map->query.startindex = startindex;    
-  } 
-
+    map->query.startindex = startindex;
+  }
 
   /* maxfeatures set */
   if (maxfeatures >= 0) {
     int extrafeature = 1;
-    for(j=0; j<map->numlayers; j++) {
+    for (j = 0; j < map->numlayers; j++) {
       layerObj *lp;
       lp = GET_LAYER(map, j);
       if (lp->status == MS_ON) {
         /*over-ride the value only if it is unset or wfs maxfeatures is
           lower that what is currently set*/
-        if (lp->maxfeatures <=0 || (lp->maxfeatures > 0 && maxfeatures < lp->maxfeatures))
-        {
+        if (lp->maxfeatures <= 0 ||
+            (lp->maxfeatures > 0 && maxfeatures < lp->maxfeatures)) {
           /* TODO: We don't handle DESC sorting, as it would mean to be */
           /* able to evict the first property, which mapquery cannot handle */
           /* This would have impact on the resultcache.bounds */
-          if( lp->sortBy.nProperties > 0 )
-          {
+          if (lp->sortBy.nProperties > 0) {
             int k;
             int countDesc = 1;
-            for(k=0;k<lp->sortBy.nProperties;k++)
-            {
-                if( lp->sortBy.properties[k].sortOrder == SORT_DESC )
-                    countDesc ++;
+            for (k = 0; k < lp->sortBy.nProperties; k++) {
+              if (lp->sortBy.properties[k].sortOrder == SORT_DESC)
+                countDesc++;
             }
-            if( countDesc > 0 )
-                extrafeature = 0;
+            if (countDesc > 0)
+              extrafeature = 0;
           }
 
-          /* + 1 to be able to detect if there are more features for a next request */
+          /* + 1 to be able to detect if there are more features for a next
+           * request */
           lp->maxfeatures = maxfeatures + extrafeature;
         }
       }
@@ -2946,7 +3027,7 @@ static void msWFSAnalyzeStartIndexAndFea
 
   /* startindex set */
   if (startindex > 0 && nQueriedLayers > 1) {
-    for(j=0; j<map->numlayers; j++) {
+    for (j = 0; j < map->numlayers; j++) {
       layerObj *lp;
       lp = GET_LAYER(map, j);
       if (lp->status == MS_ON) {
@@ -2954,18 +3035,17 @@ static void msWFSAnalyzeStartIndexAndFea
       }
     }
   } else if (startindex > 0 && lpQueried) {
-    lpQueried->startindex = startindex;    
+    lpQueried->startindex = startindex;
   }
 
-  if( pmaxfeatures )
+  if (pmaxfeatures)
     *pmaxfeatures = maxfeatures;
-  if( pstartindex )
+  if (pstartindex)
     *pstartindex = startindex;
 }
 
 static int msWFSAnalyzeBBOX(mapObj *map, wfsParamsObj *paramsObj,
-                            rectObj* pbbox, char** pszBBoxSRS)
-{
+                            rectObj *pbbox, char **pszBBoxSRS) {
   /* Default filter is map extents */
   *pbbox = map->extent;
 
@@ -2974,10 +3054,12 @@ static int msWFSAnalyzeBBOX(mapObj *map,
     int n;
 
     tokens = msStringSplit(paramsObj->pszBbox, ',', &n);
-    if (tokens==NULL || (n != 4 && n !=5)) {
-      msSetError(MS_WFSERR, "Wrong number of arguments for BBOX.", "msWFSGetFeature()");
+    if (tokens == NULL || (n != 4 && n != 5)) {
+      msSetError(MS_WFSERR, "Wrong number of arguments for BBOX.",
+                 "msWFSGetFeature()");
       msFreeCharArray(tokens, n);
-      return msWFSException(map, "bbox", MS_OWS_ERROR_INVALID_PARAMETER_VALUE, paramsObj->pszVersion);
+      return msWFSException(map, "bbox", MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                            paramsObj->pszVersion);
     }
     pbbox->minx = atof(tokens[0]);
     pbbox->miny = atof(tokens[1]);
@@ -2992,145 +3074,138 @@ static int msWFSAnalyzeBBOX(mapObj *map,
   return 0;
 }
 
-static int msWFSComputeMatchingFeatures(mapObj *map,
-                                        owsRequestObj *ows_request,
+static int msWFSComputeMatchingFeatures(mapObj *map, owsRequestObj *ows_request,
                                         wfsParamsObj *paramsObj,
-                                        int iNumberOfFeatures,
-                                        int maxfeatures,
-                                        WFSGMLInfo* pgmlinfo,
-                                        rectObj bbox,
-                                        const char* sBBoxSrs,
-                                        char** layers,
-                                        int numlayers,
-                                        int nWFSVersion)
-{
+                                        int iNumberOfFeatures, int maxfeatures,
+                                        WFSGMLInfo *pgmlinfo, rectObj bbox,
+                                        const char *sBBoxSrs, char **layers,
+                                        int numlayers, int nWFSVersion) {
   int nMatchingFeatures = -1;
 
-  if( nWFSVersion >= OWS_2_0_0 )
-  {
-    /* If no features have been retrived and there was no feature count limit, then */
-    /* it is obvious. We must test maxfeatures because if startindex is defined, */
+  if (nWFSVersion >= OWS_2_0_0) {
+    /* If no features have been retrived and there was no feature count limit,
+     * then */
+    /* it is obvious. We must test maxfeatures because if startindex is defined,
+     */
     /* and above the number of matched features, iNumberOfFeatures can be 0. */
-    if( iNumberOfFeatures == 0 && maxfeatures < 0 )
-    {
-        nMatchingFeatures = 0;
+    if (iNumberOfFeatures == 0 && maxfeatures < 0) {
+      nMatchingFeatures = 0;
     }
 
-    /* In the case we had limited the query by a maximum number of features, and */
-    /* that the query has returned less features than the limit, or if there was */
-    /* no limit in fature count, we are able to determine the number of matching */
+    /* In the case we had limited the query by a maximum number of features, and
+     */
+    /* that the query has returned less features than the limit, or if there was
+     */
+    /* no limit in fature count, we are able to determine the number of matching
+     */
     /* features */
-    else if( iNumberOfFeatures > 0 && (maxfeatures < 0 || iNumberOfFeatures < maxfeatures) )
-    {
-        if( paramsObj->nStartIndex >= 0 )
-            nMatchingFeatures = iNumberOfFeatures + paramsObj->nStartIndex;
-        else
-            nMatchingFeatures = iNumberOfFeatures;
+    else if (iNumberOfFeatures > 0 &&
+             (maxfeatures < 0 || iNumberOfFeatures < maxfeatures)) {
+      if (paramsObj->nStartIndex >= 0)
+        nMatchingFeatures = iNumberOfFeatures + paramsObj->nStartIndex;
+      else
+        nMatchingFeatures = iNumberOfFeatures;
     }
 
     /* Otherwise big hammer ! */
-    else
-    {
-        /* The WFS 2.0 spec is not really clear on numberMatched behaviour */
-        /* and there are interesting logic in server implementations. */
-        /* */
-        /* Deegree (http://deegree3-demo.deegree.org:80/inspire-workspace/services/wfs?) */
-        /* will return numberMatched="19005" on the cp:CadastralParcel layer for a */
-        /* resultType=hits request, whereas the server limitation is set to 15000 */
-        /* But on a regular GetFeature (without count specified), it will return */
-        /* numberMatched="15000" (and numberReturned="15000")) */
-        /* */
-        /* GeoServer 2.4.1 will also ignore its server limitation for a resultType=hits */
-        /* but when using a regular GetFeature (without count specified), il will return */
-        /* numberMatched=numberReturned=total_number_of_features_without_taking_into_account_server_limit */
-        /* but the number of actually returned features will be truncated to the server */
-        /* limit, likely a bug */
-        /* */
-        /* If wfs_compute_number_matched is set to TRUE, we will issue a full */
-        /* count of potentially matching features, ignoring any client or server */
-        /* side limits. */
-
-        const char* pszComputeNumberMatched =
-                msOWSLookupMetadata(&(map->web.metadata), "F",
-                                                "compute_number_matched");
-        if( pszComputeNumberMatched != NULL &&
-            strcasecmp(pszComputeNumberMatched, "true") == 0 )
-        {
-            int j;
-            mapObj* mapTmp = (mapObj*)msSmallCalloc(1, sizeof(mapObj));
-            initMap(mapTmp);
-            msCopyMap(mapTmp, map);
-
-            /* Re-run the query but with no limit */
-            mapTmp->query.maxfeatures = -1;
-            mapTmp->query.startindex = -1;
-            mapTmp->query.only_cache_result_count = MS_TRUE;
-            for(j=0; j<mapTmp->numlayers; j++) {
-                layerObj* lp = GET_LAYER(mapTmp, j);
-                /* Reset layer paging */
-                lp->maxfeatures = -1;
-                lp->startindex = -1;
-            }
+    else {
+      /* The WFS 2.0 spec is not really clear on numberMatched behaviour */
+      /* and there are interesting logic in server implementations. */
+      /* */
+      /* Deegree
+       * (http://deegree3-demo.deegree.org:80/inspire-workspace/services/wfs?)
+       */
+      /* will return numberMatched="19005" on the cp:CadastralParcel layer for a
+       */
+      /* resultType=hits request, whereas the server limitation is set to 15000
+       */
+      /* But on a regular GetFeature (without count specified), it will return
+       */
+      /* numberMatched="15000" (and numberReturned="15000")) */
+      /* */
+      /* GeoServer 2.4.1 will also ignore its server limitation for a
+       * resultType=hits */
+      /* but when using a regular GetFeature (without count specified), il will
+       * return */
+      /* numberMatched=numberReturned=total_number_of_features_without_taking_into_account_server_limit
+       */
+      /* but the number of actually returned features will be truncated to the
+       * server */
+      /* limit, likely a bug */
+      /* */
+      /* If wfs_compute_number_matched is set to TRUE, we will issue a full */
+      /* count of potentially matching features, ignoring any client or server
+       */
+      /* side limits. */
+
+      const char *pszComputeNumberMatched = msOWSLookupMetadata(
+          &(map->web.metadata), "F", "compute_number_matched");
+      if (pszComputeNumberMatched != NULL &&
+          strcasecmp(pszComputeNumberMatched, "true") == 0) {
+        int j;
+        mapObj *mapTmp = (mapObj *)msSmallCalloc(1, sizeof(mapObj));
+        initMap(mapTmp);
+        msCopyMap(mapTmp, map);
+
+        /* Re-run the query but with no limit */
+        mapTmp->query.maxfeatures = -1;
+        mapTmp->query.startindex = -1;
+        mapTmp->query.only_cache_result_count = MS_TRUE;
+        for (j = 0; j < mapTmp->numlayers; j++) {
+          layerObj *lp = GET_LAYER(mapTmp, j);
+          /* Reset layer paging */
+          lp->maxfeatures = -1;
+          lp->startindex = -1;
+        }
 
-            nMatchingFeatures = 0;
-            msWFSRetrieveFeatures(mapTmp,
-                                  ows_request,
-                                paramsObj,
-                                pgmlinfo,
-                                paramsObj->pszFilter,
-                                paramsObj->pszBbox != NULL,
-                                sBBoxSrs,
-                                bbox,
-                                paramsObj->pszFeatureId,
-                                layers,
-                                numlayers,
-                                -1,
-                                nWFSVersion,
-                                &nMatchingFeatures,
-                                NULL);
+        nMatchingFeatures = 0;
+        msWFSRetrieveFeatures(
+            mapTmp, ows_request, paramsObj, pgmlinfo, paramsObj->pszFilter,
+            paramsObj->pszBbox != NULL, sBBoxSrs, bbox, paramsObj->pszFeatureId,
+            layers, numlayers, -1, nWFSVersion, &nMatchingFeatures, NULL);
 
-            msFreeMap(mapTmp);
-        }
+        msFreeMap(mapTmp);
+      }
     }
   }
 
   return nMatchingFeatures;
 }
 
-static int msWFSResolveStoredQuery(mapObj *map, wfsParamsObj *paramsObj, cgiRequestObj *req)
-{
-  if (paramsObj->pszStoredQueryId != NULL )
-  {
-      int i;
-      int status;
-      hashTableObj* hashTable = msCreateHashTable();
-      char* pszResolvedQuery;
+static int msWFSResolveStoredQuery(mapObj *map, wfsParamsObj *paramsObj,
+                                   cgiRequestObj *req) {
+  if (paramsObj->pszStoredQueryId != NULL) {
+    int i;
+    int status;
+    hashTableObj *hashTable = msCreateHashTable();
+    char *pszResolvedQuery;
 
-      if (req->NumParams > 0 && req->postrequest == NULL ) {
-        for(i=0; i<req->NumParams; i++) {
-            if (req->ParamNames[i] && req->ParamValues[i]) {
-                msInsertHashTable(hashTable, req->ParamNames[i], req->ParamValues[i]);
-            }
+    if (req->NumParams > 0 && req->postrequest == NULL) {
+      for (i = 0; i < req->NumParams; i++) {
+        if (req->ParamNames[i] && req->ParamValues[i]) {
+          char *pszXMLValue = CPLEscapeString(
+              req->ParamValues[i], strlen(req->ParamValues[i]), CPLES_XML);
+          msInsertHashTable(hashTable, req->ParamNames[i], pszXMLValue);
+          CPLFree(pszXMLValue);
         }
       }
+    }
 
-      pszResolvedQuery = msWFSGetResolvedStoredQuery20(map, paramsObj,
-                                                       paramsObj->pszStoredQueryId,
-                                                       hashTable);
-      msFreeHashTable(hashTable);
+    pszResolvedQuery = msWFSGetResolvedStoredQuery20(
+        map, paramsObj, paramsObj->pszStoredQueryId, hashTable);
+    msFreeHashTable(hashTable);
 
-      if( pszResolvedQuery == NULL )
-          return MS_FAILURE;
+    if (pszResolvedQuery == NULL)
+      return MS_FAILURE;
 
-      status = msWFSAnalyzeStoredQuery(map, paramsObj,
-                                       paramsObj->pszStoredQueryId,
-                                       pszResolvedQuery);
-      msFree(pszResolvedQuery);
+    status = msWFSAnalyzeStoredQuery(
+        map, paramsObj, paramsObj->pszStoredQueryId, pszResolvedQuery);
+    msFree(pszResolvedQuery);
 
-      if( status != MS_SUCCESS )
-          return status;
-      
-      msWFSSimplifyPropertyNameAndFilter(paramsObj);
+    if (status != MS_SUCCESS)
+      return status;
+
+    msWFSSimplifyPropertyNameAndFilter(paramsObj);
   }
   return MS_SUCCESS;
 }
@@ -3138,194 +3213,183 @@ static int msWFSResolveStoredQuery(mapOb
 /*
 ** msWFSUnaliasItem()
 */
-static
-const char* msWFSUnaliasItem(layerObj* lp, const char* name)
-{
-    const char* pszFullName;
-    char szTmp[256];
-    int z;
-    for(z=0; z<lp->numitems; z++) {
-        if (!lp->items[z] || strlen(lp->items[z]) <= 0)
-            continue;
-        snprintf(szTmp, sizeof(szTmp), "%s_alias", lp->items[z]);
-        pszFullName = msOWSLookupMetadata(&(lp->metadata), "G", szTmp);
-        if (pszFullName && strcmp(name, pszFullName) == 0)
-            return lp->items[z];
-    }
-    return name;
+static const char *msWFSUnaliasItem(layerObj *lp, const char *name) {
+  const char *pszFullName;
+  char szTmp[256];
+  int z;
+  for (z = 0; z < lp->numitems; z++) {
+    if (!lp->items[z] || strlen(lp->items[z]) <= 0)
+      continue;
+    snprintf(szTmp, sizeof(szTmp), "%s_alias", lp->items[z]);
+    pszFullName = msOWSLookupMetadata(&(lp->metadata), "G", szTmp);
+    if (pszFullName && strcmp(name, pszFullName) == 0)
+      return lp->items[z];
+  }
+  return name;
 }
 
 /*
 ** msWFSIsAllowedItem()
 */
-static int msWFSIsAllowedItem(gmlItemListObj *itemList , const char* name)
-{
-    int z;
-    for(z=0; z<itemList->numitems; z++) {
-      if (itemList->items[z].visible &&
-          strcasecmp(name, itemList->items[z].name) == 0) {
-        return MS_TRUE;
-      }
+static int msWFSIsAllowedItem(gmlItemListObj *itemList, const char *name) {
+  int z;
+  for (z = 0; z < itemList->numitems; z++) {
+    if (itemList->items[z].visible &&
+        strcasecmp(name, itemList->items[z].name) == 0) {
+      return MS_TRUE;
     }
-    return MS_FALSE;
+  }
+  return MS_FALSE;
 }
 
 /*
 ** msWFSUngroupItem()
 */
-static
-const char* msWFSUngroupItem(layerObj* lp, gmlGroupListObj* groupList,
-                             const char* name, int* pnGroupIndex)
-{
-    int z;
-
-    *pnGroupIndex = -1;
-    for(z=0; z<groupList->numgroups; z++) {
-        const char* pszGroupName = groupList->groups[z].name;
-        size_t nGroupNameLen = strlen(pszGroupName);
-
-        /* Is it a group name ? */
-        if(strcasecmp(name, pszGroupName) == 0)
-        {
-            *pnGroupIndex = z;
-            return NULL;
-        }
-
-        /* Is it an item of a group ? */
-        if(strncasecmp(name, pszGroupName, nGroupNameLen) == 0 &&
-                       name[nGroupNameLen] == '/') {
-
-            int w;
-            const char* pszSubName = msWFSStripNS(name+nGroupNameLen+1);
-            pszSubName = msWFSUnaliasItem(lp, pszSubName);
-            for(w=0;w<groupList->groups[z].numitems;w++)
-            {
-                if( strcasecmp(pszSubName, groupList->groups[z].items[w]) == 0 )
-                {
-                    return pszSubName;
-                }
-            }
+static const char *msWFSUngroupItem(layerObj *lp, gmlGroupListObj *groupList,
+                                    const char *name, int *pnGroupIndex) {
+  int z;
+
+  *pnGroupIndex = -1;
+  for (z = 0; z < groupList->numgroups; z++) {
+    const char *pszGroupName = groupList->groups[z].name;
+    size_t nGroupNameLen = strlen(pszGroupName);
+
+    /* Is it a group name ? */
+    if (strcasecmp(name, pszGroupName) == 0) {
+      *pnGroupIndex = z;
+      return NULL;
+    }
+
+    /* Is it an item of a group ? */
+    if (strncasecmp(name, pszGroupName, nGroupNameLen) == 0 &&
+        name[nGroupNameLen] == '/') {
+
+      int w;
+      const char *pszSubName = msWFSStripNS(name + nGroupNameLen + 1);
+      pszSubName = msWFSUnaliasItem(lp, pszSubName);
+      for (w = 0; w < groupList->groups[z].numitems; w++) {
+        if (strcasecmp(pszSubName, groupList->groups[z].items[w]) == 0) {
+          return pszSubName;
         }
+      }
     }
+  }
 
-    return name;
+  return name;
 }
 
 /*
 ** msWFSApplySortBy()
 */
-static int msWFSApplySortBy(mapObj* map, wfsParamsObj *paramsObj, layerObj* lp,
-                            const char* pszSortBy,
-                            gmlItemListObj *itemList,
-                            gmlGroupListObj* groupList)
-{
-    int y, n;
-    char** tokens;
-    int invalidSortBy = MS_FALSE;
-    sortByClause sortBy;
-
-    if( !msLayerSupportsSorting(lp) )
-    {
-        msSetError(MS_WFSERR, "Layer %s does not support sorting", "msWFSGetFeature()", lp->name);
-        return msWFSException(map, "mapserv", MS_WFS_ERROR_OPERATION_PROCESSING_FAILED, paramsObj->pszVersion);
+static int msWFSApplySortBy(mapObj *map, wfsParamsObj *paramsObj, layerObj *lp,
+                            const char *pszSortBy, gmlItemListObj *itemList,
+                            gmlGroupListObj *groupList) {
+  int y, n;
+  char **tokens;
+  int invalidSortBy = MS_FALSE;
+  sortByClause sortBy;
+
+  if (!msLayerSupportsSorting(lp)) {
+    msSetError(MS_WFSERR, "Layer %s does not support sorting",
+               "msWFSGetFeature()", lp->name);
+    return msWFSException(map, "mapserv",
+                          MS_WFS_ERROR_OPERATION_PROCESSING_FAILED,
+                          paramsObj->pszVersion);
+  }
+
+  tokens = msStringSplit(pszSortBy, ',', &n);
+  sortBy.nProperties = n;
+  sortBy.properties =
+      (sortByProperties *)msSmallMalloc(n * sizeof(sortByProperties));
+  for (y = 0; y < n; y++) {
+    char *pszSpace;
+    int nGroupIndex = -1;
+    const char *pszSortProperty;
+    char *pszTmp;
+
+    sortBy.properties[y].item = msStrdup(tokens[y]);
+    sortBy.properties[y].sortOrder = SORT_ASC;
+    pszSpace = strchr(sortBy.properties[y].item, ' ');
+    if (pszSpace) {
+      *pszSpace = '\0';
+      if (strcasecmp(pszSpace + 1, "A") == 0 ||
+          strcasecmp(pszSpace + 1, "ASC") == 0)
+        ;
+      else if (strcasecmp(pszSpace + 1, "D") == 0 ||
+               strcasecmp(pszSpace + 1, "DESC") == 0)
+        sortBy.properties[y].sortOrder = SORT_DESC;
+      else
+        invalidSortBy = MS_TRUE;
     }
 
-    tokens = msStringSplit(pszSortBy, ',', &n);
-    sortBy.nProperties = n;
-    sortBy.properties = (sortByProperties* )msSmallMalloc(n * sizeof(sortByProperties));
-    for(y=0; y<n; y++) {
-        char* pszSpace;
-        int nGroupIndex = -1;
-        const char* pszSortProperty;
-        char* pszTmp;
-
-        sortBy.properties[y].item = msStrdup(tokens[y]);
-        sortBy.properties[y].sortOrder = SORT_ASC;
-        pszSpace = strchr(sortBy.properties[y].item, ' ');
-        if( pszSpace )
-        {
-            *pszSpace = '\0';
-            if( strcasecmp(pszSpace+1, "A") == 0 ||
-                strcasecmp(pszSpace+1, "ASC") == 0 )
-                ;
-            else if( strcasecmp(pszSpace+1, "D") == 0 ||
-                    strcasecmp(pszSpace+1, "DESC") == 0 )
-                sortBy.properties[y].sortOrder = SORT_DESC;
-            else
-                invalidSortBy = MS_TRUE;
-        }
-
-        pszSortProperty = msWFSStripNS(sortBy.properties[y].item);
-        pszSortProperty = msWFSUnaliasItem(lp, pszSortProperty);
-        pszSortProperty = msWFSUngroupItem(lp, groupList, pszSortProperty, &nGroupIndex);
-        if( nGroupIndex >= 0 )
-            invalidSortBy = MS_TRUE;
-
-        if( !msWFSIsAllowedItem(itemList, pszSortProperty) )
-            invalidSortBy = MS_TRUE;
-
-        pszTmp = msStrdup(pszSortProperty);
-        msFree(sortBy.properties[y].item);
-        sortBy.properties[y].item = pszTmp;
-    }
-    msFreeCharArray(tokens, n);
+    pszSortProperty = msWFSStripNS(sortBy.properties[y].item);
+    pszSortProperty = msWFSUnaliasItem(lp, pszSortProperty);
+    pszSortProperty =
+        msWFSUngroupItem(lp, groupList, pszSortProperty, &nGroupIndex);
+    if (nGroupIndex >= 0)
+      invalidSortBy = MS_TRUE;
 
-    if( !invalidSortBy )
-        msLayerSetSort(lp, &sortBy);
+    if (!msWFSIsAllowedItem(itemList, pszSortProperty))
+      invalidSortBy = MS_TRUE;
 
-    for(y=0; y<n; y++) {
-        msFree(sortBy.properties[y].item);
-    }
-    msFree(sortBy.properties);
+    pszTmp = msStrdup(pszSortProperty);
+    msFree(sortBy.properties[y].item);
+    sortBy.properties[y].item = pszTmp;
+  }
+  msFreeCharArray(tokens, n);
 
-    if( invalidSortBy )
-    {
-        msSetError(MS_WFSERR, "Invalid SORTBY clause", "msWFSGetFeature()");
-        return msWFSException(map, "sortby", MS_OWS_ERROR_INVALID_PARAMETER_VALUE, paramsObj->pszVersion);
-    }
+  if (!invalidSortBy)
+    msLayerSetSort(lp, &sortBy);
 
-    return MS_SUCCESS;
+  for (y = 0; y < n; y++) {
+    msFree(sortBy.properties[y].item);
+  }
+  msFree(sortBy.properties);
+
+  if (invalidSortBy) {
+    msSetError(MS_WFSERR, "Invalid SORTBY clause", "msWFSGetFeature()");
+    return msWFSException(map, "sortby", MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                          paramsObj->pszVersion);
+  }
+
+  return MS_SUCCESS;
 }
 
-static void msWFSSetShapeCache(mapObj* map)
-{
-    const char* pszFeaturesCacheCount =
-                msOWSLookupMetadata(&(map->web.metadata), "F",
-                                                "features_cache_count");
-    const char* pszFeaturesCacheSize =
-                msOWSLookupMetadata(&(map->web.metadata), "F",
-                                                "features_cache_size");
-    if( pszFeaturesCacheCount )
-    {
-        map->query.cache_shapes = MS_TRUE;
-        map->query.max_cached_shape_count = atoi(pszFeaturesCacheCount);
-        if (map->debug >= MS_DEBUGLEVEL_V){
-           msDebug("Caching up to %d shapes\n", map->query.max_cached_shape_count);
-        }
+static void msWFSSetShapeCache(mapObj *map) {
+  const char *pszFeaturesCacheCount =
+      msOWSLookupMetadata(&(map->web.metadata), "F", "features_cache_count");
+  const char *pszFeaturesCacheSize =
+      msOWSLookupMetadata(&(map->web.metadata), "F", "features_cache_size");
+  if (pszFeaturesCacheCount) {
+    map->query.cache_shapes = MS_TRUE;
+    map->query.max_cached_shape_count = atoi(pszFeaturesCacheCount);
+    if (map->debug >= MS_DEBUGLEVEL_V) {
+      msDebug("Caching up to %d shapes\n", map->query.max_cached_shape_count);
     }
+  }
 
-    if( pszFeaturesCacheSize )
-    {
-        map->query.cache_shapes = MS_TRUE;
-        map->query.max_cached_shape_ram_amount = atoi(pszFeaturesCacheSize);
-        if( strstr(pszFeaturesCacheSize, "mb") || strstr(pszFeaturesCacheSize, "MB") )
-             map->query.max_cached_shape_ram_amount *= 1024 * 1024;
-        if (map->debug >= MS_DEBUGLEVEL_V) {
-            msDebug("Caching up to %d bytes of shapes\n", map->query.max_cached_shape_ram_amount);
-        }
+  if (pszFeaturesCacheSize) {
+    map->query.cache_shapes = MS_TRUE;
+    map->query.max_cached_shape_ram_amount = atoi(pszFeaturesCacheSize);
+    if (strstr(pszFeaturesCacheSize, "mb") ||
+        strstr(pszFeaturesCacheSize, "MB"))
+      map->query.max_cached_shape_ram_amount *= 1024 * 1024;
+    if (map->debug >= MS_DEBUGLEVEL_V) {
+      msDebug("Caching up to %d bytes of shapes\n",
+              map->query.max_cached_shape_ram_amount);
     }
+  }
 }
 
 /*
 ** msWFSGetFeature()
 */
-static
-int msWFSGetFeature(mapObj *map, wfsParamsObj *paramsObj, cgiRequestObj *req,
-                    owsRequestObj *ows_request, int nWFSVersion)
-{
-  int   status;
-  int   maxfeatures=-1,startindex=-1;
-  rectObj     bbox;
+static int msWFSGetFeature(mapObj *map, wfsParamsObj *paramsObj,
+                           cgiRequestObj *req, owsRequestObj *ows_request,
+                           int nWFSVersion) {
+  int status;
+  int maxfeatures = -1, startindex = -1;
+  rectObj bbox;
 
   char **layers = NULL;
   int numlayers = 0;
@@ -3342,11 +3406,11 @@ int msWFSGetFeature(mapObj *map, wfsPara
   int nMatchingFeatures = -1;
   int bHasNextFeatures = MS_FALSE;
 
-  char** papszGMLGroups = NULL;
-  char** papszGMLIncludeItems = NULL;
-  char** papszGMLGeometries = NULL;
-  
-  msIOContext* old_context = NULL;
+  char **papszGMLGroups = NULL;
+  char **papszGMLIncludeItems = NULL;
+  char **papszGMLGeometries = NULL;
+
+  msIOContext *old_context = NULL;
 
   /* Initialize gml options */
   msWFSInitGMLInfo(&gmlinfo);
@@ -3357,58 +3421,57 @@ int msWFSGetFeature(mapObj *map, wfsPara
   }
 
   status = msWFSResolveStoredQuery(map, paramsObj, req);
-  if( status != MS_SUCCESS )
-      return status;
+  if (status != MS_SUCCESS)
+    return status;
 
   /* typename is mandatory unless featureid is specfied. We do not
      support featureid */
-  if (paramsObj->pszTypeName==NULL && paramsObj->pszFeatureId == NULL) {
-    msSetError(MS_WFSERR,
-               "Incomplete WFS request: %s parameter missing",
+  if (paramsObj->pszTypeName == NULL && paramsObj->pszFeatureId == NULL) {
+    msSetError(MS_WFSERR, "Incomplete WFS request: %s parameter missing",
                "msWFSGetFeature()",
-               (nWFSVersion >= OWS_2_0_0 ) ? "TYPENAMES": "TYPENAME" );
-    return msWFSException(map, (nWFSVersion >= OWS_2_0_0 ) ? "typenames": "typename",
-                          MS_OWS_ERROR_MISSING_PARAMETER_VALUE, paramsObj->pszVersion);
+               (nWFSVersion >= OWS_2_0_0) ? "TYPENAMES" : "TYPENAME");
+    return msWFSException(
+        map, (nWFSVersion >= OWS_2_0_0) ? "typenames" : "typename",
+        MS_OWS_ERROR_MISSING_PARAMETER_VALUE, paramsObj->pszVersion);
   }
 
   /* Is it a WFS 2.0 GetFeatureById stored query with an unknown id ? */
-  /* If so, CITE interprets the spec as requesting to issue a OperationProcessingFailed */
-  /* exception. But it only checks that the HTTP error code is 403 or 404. So emit 404. */
+  /* If so, CITE interprets the spec as requesting to issue a
+   * OperationProcessingFailed */
+  /* exception. But it only checks that the HTTP error code is 403 or 404. So
+   * emit 404. */
   /* A bit strange when a similar request but with RESOURCEID= should */
   /* produce an empty FeatureCollection */
-  if( nWFSVersion >= OWS_2_0_0 &&
-      paramsObj->pszTypeName != NULL && strcmp(paramsObj->pszTypeName, "?") == 0 &&
-      paramsObj->pszFilter != NULL && paramsObj->pszFeatureId == NULL )
-  {
-    CPLXMLNode* psDoc;
+  if (nWFSVersion >= OWS_2_0_0 && paramsObj->pszTypeName != NULL &&
+      strcmp(paramsObj->pszTypeName, "?") == 0 &&
+      paramsObj->pszFilter != NULL && paramsObj->pszFeatureId == NULL) {
+    CPLXMLNode *psDoc;
 
     psDoc = CPLParseXMLString(paramsObj->pszFilter);
-    if( psDoc != NULL )
-    {
-        const char* rid;
+    if (psDoc != NULL) {
+      const char *rid;
 
-        CPLStripXMLNamespace(psDoc, NULL, 1);
-        rid = CPLGetXMLValue(psDoc, "=Filter.ResourceId.rid", NULL);
-        if( rid != NULL )
-        {
-            msSetError(MS_WFSERR, "Invalid rid '%s'", "msWFSGetFeature()", rid);
-            CPLDestroyXMLNode(psDoc);
-            return msWFSException(map, NULL, MS_OWS_ERROR_NOT_FOUND,
-                                  paramsObj->pszVersion );
-        }
+      CPLStripXMLNamespace(psDoc, NULL, 1);
+      rid = CPLGetXMLValue(psDoc, "=Filter.ResourceId.rid", NULL);
+      if (rid != NULL) {
+        msSetError(MS_WFSERR, "Invalid rid '%s'", "msWFSGetFeature()", rid);
         CPLDestroyXMLNode(psDoc);
+        return msWFSException(map, NULL, MS_OWS_ERROR_NOT_FOUND,
+                              paramsObj->pszVersion);
+      }
+      CPLDestroyXMLNode(psDoc);
     }
   }
 
-  papszGMLGroups = (char**) calloc(sizeof(char*), map->numlayers);
-  papszGMLIncludeItems = (char**) calloc(sizeof(char*), map->numlayers);
-  papszGMLGeometries = (char**) calloc(sizeof(char*), map->numlayers);
+  papszGMLGroups = (char **)calloc(sizeof(char *), map->numlayers);
+  papszGMLIncludeItems = (char **)calloc(sizeof(char *), map->numlayers);
+  papszGMLGeometries = (char **)calloc(sizeof(char *), map->numlayers);
 
-  if(paramsObj->pszTypeName) {
-    int k, y,z;
+  if (paramsObj->pszTypeName) {
+    int k, y, z;
 
     char **tokens;
-    int n=0, i=0;
+    int n = 0, i = 0;
     char **papszPropertyName = NULL;
     char **papszSortBy = NULL;
 
@@ -3426,16 +3489,18 @@ int msWFSGetFeature(mapObj *map, wfsPara
     /*      If that is the case extract only the layer name.                */
     /* ==================================================================== */
 
-    if (layers==NULL || numlayers < 1) {
-      msSetError(MS_WFSERR, "At least one type name required in %s parameter.", "msWFSGetFeature()",
-                 (nWFSVersion >= OWS_2_0_0 ) ? "TYPENAMES": "TYPENAME" );
-      return msWFSException(map, (nWFSVersion >= OWS_2_0_0 ) ? "typenames": "typename" ,
-                            MS_OWS_ERROR_INVALID_PARAMETER_VALUE, paramsObj->pszVersion);
+    if (layers == NULL || numlayers < 1) {
+      msSetError(MS_WFSERR, "At least one type name required in %s parameter.",
+                 "msWFSGetFeature()",
+                 (nWFSVersion >= OWS_2_0_0) ? "TYPENAMES" : "TYPENAME");
+      return msWFSException(
+          map, (nWFSVersion >= OWS_2_0_0) ? "typenames" : "typename",
+          MS_OWS_ERROR_INVALID_PARAMETER_VALUE, paramsObj->pszVersion);
     }
 
     /* strip namespace if there is one :ex TYPENAME=cdf:Other */
-    for (i=0; i<numlayers; i++) {
-      char* pszTmp = msStrdup(msWFSStripNS(layers[i]));
+    for (i = 0; i < numlayers; i++) {
+      char *pszTmp = msStrdup(msWFSStripNS(layers[i]));
       free(layers[i]);
       layers[i] = pszTmp;
     }
@@ -3443,318 +3508,333 @@ int msWFSGetFeature(mapObj *map, wfsPara
     /* Keep only selected layers, set to OFF by default. */
     msWFSTurnOffAllLayer(map);
 
-    papszPropertyName = msWFSParsePropertyNameOrSortBy(paramsObj->pszPropertyName, numlayers);
-    if( papszPropertyName == NULL ) {
-        msFreeCharArray(layers, numlayers);
-        msFreeCharArray(papszGMLGroups, map->numlayers);
-        msFreeCharArray(papszGMLIncludeItems, map->numlayers);
-        msFreeCharArray(papszGMLGeometries, map->numlayers);
-        msSetError(MS_WFSERR,
-                    "Optional PROPERTYNAME parameter. A list of properties may be specified for each type name. Example TYPENAME=name1,name2&PROPERTYNAME=(prop1,prop2)(prop1)",
-                    "msWFSGetFeature()");
-        return msWFSException(map, "PROPERTYNAME", MS_OWS_ERROR_INVALID_PARAMETER_VALUE, paramsObj->pszVersion);
-    }
-    
-    papszSortBy = msWFSParsePropertyNameOrSortBy(paramsObj->pszSortBy, numlayers);
-    if( papszSortBy == NULL ) {
-        msFreeCharArray(layers, numlayers);
-        msFreeCharArray(papszPropertyName, numlayers);
-        msFreeCharArray(papszGMLGroups, map->numlayers);
-        msFreeCharArray(papszGMLIncludeItems, map->numlayers);
-        msFreeCharArray(papszGMLGeometries, map->numlayers);
-        msSetError(MS_WFSERR,
-                    "Optional SORTBY parameter. A list may be specified for each type name. Example TYPENAME=name1,name2&SORTBY=(prop1,prop2)(prop1)",
-                    "msWFSGetFeature()");
-        return msWFSException(map, "SORTBY", MS_OWS_ERROR_INVALID_PARAMETER_VALUE, paramsObj->pszVersion);
+    papszPropertyName =
+        msWFSParsePropertyNameOrSortBy(paramsObj->pszPropertyName, numlayers);
+    if (papszPropertyName == NULL) {
+      msFreeCharArray(layers, numlayers);
+      msFreeCharArray(papszGMLGroups, map->numlayers);
+      msFreeCharArray(papszGMLIncludeItems, map->numlayers);
+      msFreeCharArray(papszGMLGeometries, map->numlayers);
+      msSetError(MS_WFSERR,
+                 "Optional PROPERTYNAME parameter. A list of properties may be "
+                 "specified for each type name. Example "
+                 "TYPENAME=name1,name2&PROPERTYNAME=(prop1,prop2)(prop1)",
+                 "msWFSGetFeature()");
+      return msWFSException(map, "PROPERTYNAME",
+                            MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                            paramsObj->pszVersion);
+    }
+
+    papszSortBy =
+        msWFSParsePropertyNameOrSortBy(paramsObj->pszSortBy, numlayers);
+    if (papszSortBy == NULL) {
+      msFreeCharArray(layers, numlayers);
+      msFreeCharArray(papszPropertyName, numlayers);
+      msFreeCharArray(papszGMLGroups, map->numlayers);
+      msFreeCharArray(papszGMLIncludeItems, map->numlayers);
+      msFreeCharArray(papszGMLGeometries, map->numlayers);
+      msSetError(
+          MS_WFSERR,
+          "Optional SORTBY parameter. A list may be specified for each type "
+          "name. Example TYPENAME=name1,name2&SORTBY=(prop1,prop2)(prop1)",
+          "msWFSGetFeature()");
+      return msWFSException(map, "SORTBY", MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                            paramsObj->pszVersion);
     }
 
-    for (k=0; k<numlayers; k++) {
+    for (k = 0; k < numlayers; k++) {
       layerObj *lp;
       lp = msWFSGetLayerByName(map, ows_request, layers[k]);
-      if( lp != NULL )
-      {
-            gmlItemListObj *itemList=NULL;
-            gmlGeometryListObj *geometryList=NULL;
-            gmlGroupListObj* groupList=NULL;
-
-            lp->status = MS_ON;
-            if (lp->_template == NULL) {
-              /* Force setting a template to enable query. */
-              lp->_template = msStrdup("ttt.html");
-            }
+      if (lp != NULL) {
+        gmlItemListObj *itemList = NULL;
+        gmlGeometryListObj *geometryList = NULL;
+        gmlGroupListObj *groupList = NULL;
 
-            /*do an alias replace for the current layer*/
-            if (msLayerOpen(lp) == MS_SUCCESS && msLayerGetItems(lp) == MS_SUCCESS) {
+        lp->status = MS_ON;
+        if (lp->_template == NULL) {
+          /* Force setting a template to enable query. */
+          lp->_template = msStrdup("ttt.html");
+        }
 
-              itemList = msGMLGetItems(lp, "G");
-              groupList = msGMLGetGroups(lp, "G");
+        /*do an alias replace for the current layer*/
+        if (msLayerOpen(lp) == MS_SUCCESS &&
+            msLayerGetItems(lp) == MS_SUCCESS) {
 
-              if( strcmp(papszSortBy[k], "!") != 0 )
-              {
-                  status = msWFSApplySortBy(map, paramsObj, lp,
-                                            papszSortBy[k], itemList, groupList);
-                  if( status != MS_SUCCESS )
-                  {
-                    msFreeCharArray(papszPropertyName, numlayers);
-                    msFreeCharArray(papszSortBy, numlayers);
-                    msFreeCharArray(layers, numlayers);
-                    msFreeCharArray(papszGMLGroups, map->numlayers);
-                    msFreeCharArray(papszGMLIncludeItems, map->numlayers);
-                    msFreeCharArray(papszGMLGeometries, map->numlayers);
-                    msGMLFreeItems(itemList);
-                    msGMLFreeGroups(groupList);
-                    return status;
-                  }
-              }
+          itemList = msGMLGetItems(lp, "G");
+          groupList = msGMLGetGroups(lp, "G");
 
-              geometryList=msGMLGetGeometries(lp, "GFO", MS_TRUE);
+          if (strcmp(papszSortBy[k], "!") != 0) {
+            status = msWFSApplySortBy(map, paramsObj, lp, papszSortBy[k],
+                                      itemList, groupList);
+            if (status != MS_SUCCESS) {
+              msFreeCharArray(papszPropertyName, numlayers);
+              msFreeCharArray(papszSortBy, numlayers);
+              msFreeCharArray(layers, numlayers);
+              msFreeCharArray(papszGMLGroups, map->numlayers);
+              msFreeCharArray(papszGMLIncludeItems, map->numlayers);
+              msFreeCharArray(papszGMLGeometries, map->numlayers);
+              msGMLFreeItems(itemList);
+              msGMLFreeGroups(groupList);
+              return status;
+            }
+          }
 
-              /* unalias, ungroup and validate that the property names passed are part of the items list*/
-              tokens = msStringSplit(papszPropertyName[k], ',', &n);
-              for (y=0; y<n; y++) {
-                const char* pszPropertyNameItem = tokens[y];
-                int nGroupIndex = -1;
-
-                if (strcasecmp(pszPropertyNameItem, "*") == 0 ||
-                    strcasecmp(pszPropertyNameItem, "!") == 0)
-                  continue;
-
-                pszPropertyNameItem = msWFSStripNS(pszPropertyNameItem);
-                pszPropertyNameItem = msWFSUnaliasItem(lp, pszPropertyNameItem);
-                pszPropertyNameItem = msWFSUngroupItem(lp, groupList, pszPropertyNameItem, &nGroupIndex);
-                if( nGroupIndex >= 0 )
-                  continue;
-
-                /* Check that the property name is allowed (#3563) */
-                /*we need to check of the property name is the geometry name; In that case it
-                  is a valid property name*/
-                if (!msWFSIsAllowedItem(itemList,pszPropertyNameItem)) {
-                  for(z=0; z<geometryList->numgeometries; z++) {
-                    if (strcasecmp(pszPropertyNameItem, geometryList->geometries[z].name) == 0)
-                      break;
-                  }
+          geometryList = msGMLGetGeometries(lp, "GFO", MS_TRUE);
 
-                  if (z == geometryList->numgeometries) {
-                    msSetError(MS_WFSERR,
-                               "Invalid PROPERTYNAME %s",  "msWFSGetFeature()", tokens[y]);
-                    msFreeCharArray(tokens, n);
-                    msGMLFreeItems(itemList);
-                    msGMLFreeGroups(groupList);
-                    msGMLFreeGeometries(geometryList);
-                    msFreeCharArray(papszPropertyName, numlayers);
-                    msFreeCharArray(papszSortBy, numlayers);
-                    msFreeCharArray(layers, numlayers);
-                    msFreeCharArray(papszGMLGroups, map->numlayers);
-                    msFreeCharArray(papszGMLIncludeItems, map->numlayers);
-                    msFreeCharArray(papszGMLGeometries, map->numlayers);
-                    return msWFSException(map, "PROPERTYNAME", MS_OWS_ERROR_INVALID_PARAMETER_VALUE, paramsObj->pszVersion);
-                  }
-                }
-                else
-                {
-                  char* pszTmp = msStrdup(pszPropertyNameItem);
-                  msFree(tokens[y]);
-                  tokens[y] = pszTmp;
-                }
+          /* unalias, ungroup and validate that the property names passed are
+           * part of the items list*/
+          tokens = msStringSplit(papszPropertyName[k], ',', &n);
+          for (y = 0; y < n; y++) {
+            const char *pszPropertyNameItem = tokens[y];
+            int nGroupIndex = -1;
+
+            if (strcasecmp(pszPropertyNameItem, "*") == 0 ||
+                strcasecmp(pszPropertyNameItem, "!") == 0)
+              continue;
+
+            pszPropertyNameItem = msWFSStripNS(pszPropertyNameItem);
+            pszPropertyNameItem = msWFSUnaliasItem(lp, pszPropertyNameItem);
+            pszPropertyNameItem = msWFSUngroupItem(
+                lp, groupList, pszPropertyNameItem, &nGroupIndex);
+            if (nGroupIndex >= 0)
+              continue;
+
+            /* Check that the property name is allowed (#3563) */
+            /*we need to check of the property name is the geometry name; In
+              that case it is a valid property name*/
+            if (!msWFSIsAllowedItem(itemList, pszPropertyNameItem)) {
+              for (z = 0; z < geometryList->numgeometries; z++) {
+                if (strcasecmp(pszPropertyNameItem,
+                               geometryList->geometries[z].name) == 0)
+                  break;
               }
 
-              /* Add mandatory items that are not explicitely listed. */
-              /* When the user specifies PROPERTYNAME, we might have to augment */
-              /* the list of returned parameters so as to validate against the schema. */
-              /* This is made clear in the WFS 1.0.0, 1.1.0 and 2.0.0 specs (#3319) */
-              for(z=0; z<itemList->numitems; z++) {
-                if( itemList->items[z].visible &&
-                    itemList->items[z].minOccurs == 1 )
-                {
-                    int bFound = MS_FALSE;
-                    for (y=0; y<n; y++) {
-                    if( strcasecmp(tokens[y], "*") == 0 ||
-                        strcasecmp(tokens[y], "!") == 0 ||
-                        strcasecmp(tokens[y], itemList->items[z].name) == 0 )
-                    {
-                        bFound = MS_TRUE;
-                        break;
-                    }
-                    }
-                    if( !bFound )
-                    {
-                        tokens = (char**) realloc(tokens, sizeof(char*) * (n+1));
-                        tokens[n] = msStrdup(itemList->items[z].name);
-                        n ++;
-                    }
+              if (z == geometryList->numgeometries) {
+                msSetError(MS_WFSERR, "Invalid PROPERTYNAME %s",
+                           "msWFSGetFeature()", tokens[y]);
+                msFreeCharArray(tokens, n);
+                msGMLFreeItems(itemList);
+                msGMLFreeGroups(groupList);
+                msGMLFreeGeometries(geometryList);
+                msFreeCharArray(papszPropertyName, numlayers);
+                msFreeCharArray(papszSortBy, numlayers);
+                msFreeCharArray(layers, numlayers);
+                msFreeCharArray(papszGMLGroups, map->numlayers);
+                msFreeCharArray(papszGMLIncludeItems, map->numlayers);
+                msFreeCharArray(papszGMLGeometries, map->numlayers);
+                return msWFSException(map, "PROPERTYNAME",
+                                      MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                                      paramsObj->pszVersion);
+              }
+            } else {
+              char *pszTmp = msStrdup(pszPropertyNameItem);
+              msFree(tokens[y]);
+              tokens[y] = pszTmp;
+            }
+          }
+
+          /* Add mandatory items that are not explicitely listed. */
+          /* When the user specifies PROPERTYNAME, we might have to augment */
+          /* the list of returned parameters so as to validate against the
+           * schema. */
+          /* This is made clear in the WFS 1.0.0, 1.1.0 and 2.0.0 specs (#3319)
+           */
+          for (z = 0; z < itemList->numitems; z++) {
+            if (itemList->items[z].visible &&
+                itemList->items[z].minOccurs == 1) {
+              int bFound = MS_FALSE;
+              for (y = 0; y < n; y++) {
+                if (strcasecmp(tokens[y], "*") == 0 ||
+                    strcasecmp(tokens[y], "!") == 0 ||
+                    strcasecmp(tokens[y], itemList->items[z].name) == 0) {
+                  bFound = MS_TRUE;
+                  break;
                 }
               }
+              if (!bFound) {
+                tokens = (char **)realloc(tokens, sizeof(char *) * (n + 1));
+                tokens[n] = msStrdup(itemList->items[z].name);
+                n++;
+              }
+            }
+          }
+
+          /* Rebuild papszPropertyName[k] */
+          msFree(papszPropertyName[k]);
+          papszPropertyName[k] = NULL;
+          for (y = 0; y < n; y++) {
+            if (y == 0)
+              papszPropertyName[k] = msStrdup(tokens[y]);
+            else {
+              papszPropertyName[k] =
+                  msStringConcatenate(papszPropertyName[k], ",");
+              papszPropertyName[k] =
+                  msStringConcatenate(papszPropertyName[k], tokens[y]);
+            }
+          }
+
+          msFreeCharArray(tokens, n);
+          msLayerClose(lp);
+
+          if (strlen(papszPropertyName[k]) > 0) {
 
-              /* Rebuild papszPropertyName[k] */
+            if (strcasecmp(papszPropertyName[k], "*") == 0) {
+              /* Add all non-excluded items, including optional ones */
               msFree(papszPropertyName[k]);
               papszPropertyName[k] = NULL;
-              for (y=0; y<n; y++) {
-                if( y == 0 )
-                  papszPropertyName[k] = msStrdup(tokens[y]);
-                else {
+              for (z = 0; z < itemList->numitems; z++) {
+                if (itemList->items[z].visible) {
+                  if (papszPropertyName[k] != NULL)
+                    papszPropertyName[k] =
+                        msStringConcatenate(papszPropertyName[k], ",");
                   papszPropertyName[k] = msStringConcatenate(
-                            papszPropertyName[k], ",");
+                      papszPropertyName[k], itemList->items[z].name);
+                }
+              }
+              if (papszPropertyName[k])
+                papszGMLIncludeItems[lp->index] =
+                    msStrdup(papszPropertyName[k]);
+              else
+                papszGMLIncludeItems[lp->index] = msStrdup("");
+
+              /* The user didn't specify explicity PROPERTYNAME for this layer
+               */
+            } else if (strcasecmp(papszPropertyName[k], "!") == 0) {
+              /* Add all non-excluded items, but only default and mandatory ones
+               * (and geometry) */
+              msFree(papszPropertyName[k]);
+              papszPropertyName[k] = NULL;
+              for (z = 0; z < itemList->numitems; z++) {
+                if (itemList->items[z].visible &&
+                    (itemList->items[z].outputByDefault == 1 ||
+                     itemList->items[z].minOccurs == 1)) {
+                  if (papszPropertyName[k] != NULL)
+                    papszPropertyName[k] =
+                        msStringConcatenate(papszPropertyName[k], ",");
                   papszPropertyName[k] = msStringConcatenate(
-                            papszPropertyName[k], tokens[y]);
+                      papszPropertyName[k], itemList->items[z].name);
                 }
               }
-
-
-              msFreeCharArray(tokens, n);
-              msLayerClose(lp);
-
-              if (strlen(papszPropertyName[k]) > 0) {
-
-                if (strcasecmp(papszPropertyName[k], "*") == 0) {
-                  /* Add all non-excluded items, including optional ones */
-                  msFree(papszPropertyName[k]);
-                  papszPropertyName[k] = NULL;
-                  for(z=0; z<itemList->numitems; z++) {
-                    if( itemList->items[z].visible ) {
-                        if( papszPropertyName[k] != NULL )
-                            papszPropertyName[k] = msStringConcatenate(
-                                papszPropertyName[k], ",");
-                        papszPropertyName[k] = msStringConcatenate(
-                            papszPropertyName[k], itemList->items[z].name);
+              if (papszPropertyName[k])
+                papszGMLIncludeItems[lp->index] =
+                    msStrdup(papszPropertyName[k]);
+              else
+                papszGMLIncludeItems[lp->index] = msStrdup("");
+
+            } else {
+              char *pszGeometryList = NULL;
+
+              for (z = 0; z < groupList->numgroups; z++) {
+                const char *pszNeedle =
+                    strstr(papszPropertyName[k], groupList->groups[z].name);
+                char chAfterNeedle = 0;
+                if (pszNeedle != NULL)
+                  chAfterNeedle =
+                      papszPropertyName[k][strlen(groupList->groups[z].name)];
+                if (pszNeedle != NULL &&
+                    (chAfterNeedle == '\0' || chAfterNeedle == ',')) {
+                  int w;
+                  for (w = 0; w < groupList->groups[z].numitems; w++) {
+                    if (strstr(papszPropertyName[k],
+                               groupList->groups[z].items[w]) == NULL) {
+                      papszPropertyName[k] =
+                          msStringConcatenate(papszPropertyName[k], ",");
+                      papszPropertyName[k] = msStringConcatenate(
+                          papszPropertyName[k], groupList->groups[z].items[w]);
                     }
                   }
-                  if( papszPropertyName[k] )
-                    papszGMLIncludeItems[lp->index] = msStrdup(papszPropertyName[k]);
-                  else
-                    papszGMLIncludeItems[lp->index] = msStrdup("");
-
-                /* The user didn't specify explicity PROPERTYNAME for this layer */
-                } else if (strcasecmp(papszPropertyName[k], "!") == 0) {
-                  /* Add all non-excluded items, but only default and mandatory ones (and geometry) */
-                  msFree(papszPropertyName[k]);
-                  papszPropertyName[k] = NULL;
-                  for(z=0; z<itemList->numitems; z++) {
-                    if( itemList->items[z].visible &&
-                        (itemList->items[z].outputByDefault == 1 ||
-                         itemList->items[z].minOccurs == 1) ) {
-                        if( papszPropertyName[k] != NULL )
-                            papszPropertyName[k] = msStringConcatenate(
-                                papszPropertyName[k], ",");
-                        papszPropertyName[k] = msStringConcatenate(
-                            papszPropertyName[k], itemList->items[z].name);
+                }
+              }
+
+              // Set the "gml_select_items" metadata items that is used by
+              // msQueryByRect() to restrict the number of properties to
+              // select for faster results.
+              if (msOWSLookupMetadata(&(lp->metadata), "OFG", "groups") ==
+                  NULL) {
+                auto properties = msStringSplit(papszPropertyName[k], ',');
+                std::string selectItems;
+                const char *featureid =
+                    msOWSLookupMetadata(&(lp->metadata), "OFG", "featureid");
+                bool foundFeatureId = false;
+                for (const auto &prop : properties) {
+                  bool isGeom = false;
+                  const char *propNoNS = prop.c_str();
+                  const char *pszColon = strchr(propNoNS, ':');
+                  if (pszColon)
+                    propNoNS = pszColon + 1;
+                  for (z = 0; z < geometryList->numgeometries; z++) {
+                    if (strcasecmp(propNoNS,
+                                   geometryList->geometries[z].name) == 0) {
+                      isGeom = true;
+                      break;
                     }
                   }
-                  if( papszPropertyName[k] )
-                    papszGMLIncludeItems[lp->index] = msStrdup(papszPropertyName[k]);
-                  else
-                    papszGMLIncludeItems[lp->index] = msStrdup("");
-
-                } else {
-                  char* pszGeometryList = NULL;
-
-                  for(z=0; z<groupList->numgroups; z++) {
-                    const char* pszNeedle = strstr(papszPropertyName[k], groupList->groups[z].name);
-                    char chAfterNeedle = 0;
-                    if( pszNeedle != NULL )
-                        chAfterNeedle = papszPropertyName[k][strlen(groupList->groups[z].name)];
-                    if(pszNeedle != NULL && (chAfterNeedle == '\0' || chAfterNeedle == ',') ) {
-                      int w;
-                      for(w=0;w<groupList->groups[z].numitems;w++)
-                      {
-                        if(strstr(papszPropertyName[k], groupList->groups[z].items[w]) == NULL) {
-                            papszPropertyName[k] = msStringConcatenate(
-                                papszPropertyName[k], ",");
-                            papszPropertyName[k] = msStringConcatenate(
-                                papszPropertyName[k], groupList->groups[z].items[w]);
-                        }
-                      }
-                    }
+                  if (!isGeom) {
+                    if (!selectItems.empty())
+                      selectItems += ',';
+                    selectItems += prop;
                   }
-
-                  // Set the "gml_select_items" metadata items that is used by
-                  // msQueryByRect() to restrict the number of properties to
-                  // select for faster results.
-                  if( msOWSLookupMetadata(&(lp->metadata), "OFG", "groups") == NULL )
-                  {
-                      auto properties = msStringSplit(papszPropertyName[k], ',');
-                      std::string selectItems;
-                      const char* featureid = msOWSLookupMetadata(&(lp->metadata), "OFG", "featureid");
-                      bool foundFeatureId = false;
-                      for( const auto& prop: properties )
-                      {
-                          bool isGeom = false;
-                          const char* propNoNS = prop.c_str();
-                          const char* pszColon = strchr(propNoNS, ':');
-                          if( pszColon )
-                            propNoNS = pszColon+1;
-                          for(z=0; z<geometryList->numgeometries; z++) {
-                            if (strcasecmp(propNoNS, geometryList->geometries[z].name) == 0) {
-                                isGeom = true;
-                                break;
-                            }
-                          }
-                          if( !isGeom ) {
-                              if( !selectItems.empty() )
-                                  selectItems += ',';
-                              selectItems += prop;
-                          }
-                          if( featureid && featureid == prop ) {
-                              foundFeatureId =  true;
-                          }
-                      }
-                      if( featureid && !foundFeatureId ) {
-                        if( !selectItems.empty() )
-                            selectItems += ',';
-                        selectItems += featureid;
-                      }
-                      if( !selectItems.empty() ) {
-                        msInsertHashTable(&(lp->metadata), "gml_select_items", selectItems.c_str());
-                      }
+                  if (featureid && featureid == prop) {
+                    foundFeatureId = true;
                   }
+                }
+                if (featureid && !foundFeatureId) {
+                  if (!selectItems.empty())
+                    selectItems += ',';
+                  selectItems += featureid;
+                }
+                if (!selectItems.empty()) {
+                  msInsertHashTable(&(lp->metadata), "gml_select_items",
+                                    selectItems.c_str());
+                }
+              }
 
-                  papszGMLIncludeItems[lp->index] = msStrdup(papszPropertyName[k]);
+              papszGMLIncludeItems[lp->index] = msStrdup(papszPropertyName[k]);
 
-                  for(z=0; z<geometryList->numgeometries; z++) {
-                    if (strstr(papszPropertyName[k], geometryList->geometries[z].name) != NULL) {
-                        if( pszGeometryList != NULL )
-                            pszGeometryList = msStringConcatenate(
-                                pszGeometryList, ",");
-                        pszGeometryList = msStringConcatenate(
-                            pszGeometryList, geometryList->geometries[z].name);
-                    }
-                  }
-
-                  if( pszGeometryList != NULL ) {
-                      papszGMLGeometries[lp->index] = msStrdup(pszGeometryList);
-                      msFree(pszGeometryList);
-                  } else {
-                    papszGMLGeometries[lp->index] = msStrdup("none");
-                  }
+              for (z = 0; z < geometryList->numgeometries; z++) {
+                if (strstr(papszPropertyName[k],
+                           geometryList->geometries[z].name) != NULL) {
+                  if (pszGeometryList != NULL)
+                    pszGeometryList = msStringConcatenate(pszGeometryList, ",");
+                  pszGeometryList = msStringConcatenate(
+                      pszGeometryList, geometryList->geometries[z].name);
                 }
-              } else {/*empty string*/
+              }
+
+              if (pszGeometryList != NULL) {
+                papszGMLGeometries[lp->index] = msStrdup(pszGeometryList);
+                msFree(pszGeometryList);
+              } else {
                 papszGMLGeometries[lp->index] = msStrdup("none");
               }
             }
-            else
-            {
-                msFreeCharArray(papszPropertyName, numlayers);
-                msFreeCharArray(papszSortBy, numlayers);
-                msFreeCharArray(layers, numlayers);
-                msFreeCharArray(papszGMLGroups, map->numlayers);
-                msFreeCharArray(papszGMLIncludeItems, map->numlayers);
-                msFreeCharArray(papszGMLGeometries, map->numlayers);
-                msGMLFreeItems(itemList);
-                msGMLFreeGroups(groupList);
-                msGMLFreeGeometries(geometryList);
-                return msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE, paramsObj->pszVersion);
-            }
+          } else { /*empty string*/
+            papszGMLGeometries[lp->index] = msStrdup("none");
+          }
+        } else {
+          msFreeCharArray(papszPropertyName, numlayers);
+          msFreeCharArray(papszSortBy, numlayers);
+          msFreeCharArray(layers, numlayers);
+          msFreeCharArray(papszGMLGroups, map->numlayers);
+          msFreeCharArray(papszGMLIncludeItems, map->numlayers);
+          msFreeCharArray(papszGMLGeometries, map->numlayers);
+          msGMLFreeItems(itemList);
+          msGMLFreeGroups(groupList);
+          msGMLFreeGeometries(geometryList);
+          return msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE,
+                                paramsObj->pszVersion);
+        }
 
-            msGMLFreeItems(itemList);
-            msGMLFreeGroups(groupList);
-            msGMLFreeGeometries(geometryList);
-      }
-      else
-      {
+        msGMLFreeItems(itemList);
+        msGMLFreeGroups(groupList);
+        msGMLFreeGeometries(geometryList);
+      } else {
         /* Requested layer name was not in capabilities:
          * either it just doesn't exist
          */
         msSetError(MS_WFSERR,
-                   "TYPENAME '%s' doesn't exist in this server.  Please check the capabilities and reformulate your request.",
+                   "TYPENAME '%s' doesn't exist in this server.  Please check "
+                   "the capabilities and reformulate your request.",
                    "msWFSGetFeature()", layers[k]);
         msFreeCharArray(papszPropertyName, numlayers);
         msFreeCharArray(papszSortBy, numlayers);
@@ -3762,7 +3842,9 @@ int msWFSGetFeature(mapObj *map, wfsPara
         msFreeCharArray(papszGMLGroups, map->numlayers);
         msFreeCharArray(papszGMLIncludeItems, map->numlayers);
         msFreeCharArray(papszGMLGeometries, map->numlayers);
-        return msWFSException(map, "typename", MS_OWS_ERROR_INVALID_PARAMETER_VALUE, paramsObj->pszVersion);
+        return msWFSException(map, "typename",
+                              MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                              paramsObj->pszVersion);
       }
     }
 
@@ -3772,82 +3854,65 @@ int msWFSGetFeature(mapObj *map, wfsPara
 
   /* Validate outputformat */
   status = msWFSGetGMLOutputFormat(paramsObj, &gmlinfo, nWFSVersion);
-  if( status < 0 ) {
+  if (status < 0) {
     psFormat = msWFSGetOtherOutputFormat(map, paramsObj);
-    if( psFormat == NULL ) {
+    if (psFormat == NULL) {
       msFreeCharArray(layers, numlayers);
       msFreeCharArray(papszGMLGroups, map->numlayers);
       msFreeCharArray(papszGMLIncludeItems, map->numlayers);
       msFreeCharArray(papszGMLGeometries, map->numlayers);
       return msWFSException(map, "outputformat",
                             MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
-                            paramsObj->pszVersion );
+                            paramsObj->pszVersion);
     }
+    // only GML is supported for resultType=hits, so ignore any other
+    // outputformat
+    if (iResultTypeHits == 1) {
+      psFormat = NULL;
+    }
+  } else {
+    outputformat = (OWSGMLVersion)status;
   }
-  else {
-    outputformat = (OWSGMLVersion) status;
-  }
-  
+
   msWFSAnalyzeStartIndexAndFeatureCount(map, paramsObj, iResultTypeHits,
                                         &maxfeatures, &startindex);
 
   status = msWFSAnalyzeBBOX(map, paramsObj, &bbox, &sBBoxSrs);
-  if( status != 0 )
-  {
-      msFreeCharArray(layers, numlayers);
-      msFreeCharArray(papszGMLGroups, map->numlayers);
-      msFreeCharArray(papszGMLIncludeItems, map->numlayers);
-      msFreeCharArray(papszGMLGeometries, map->numlayers);
-      return status;
+  if (status != 0) {
+    msFreeCharArray(layers, numlayers);
+    msFreeCharArray(papszGMLGroups, map->numlayers);
+    msFreeCharArray(papszGMLIncludeItems, map->numlayers);
+    msFreeCharArray(papszGMLGeometries, map->numlayers);
+    return status;
   }
 
-  if( iResultTypeHits == 1 )
-  {
-      map->query.only_cache_result_count = MS_TRUE;
-  }
-  else
-  {
-      msWFSSetShapeCache(map);
+  if (iResultTypeHits == 1) {
+    map->query.only_cache_result_count = MS_TRUE;
+  } else {
+    msWFSSetShapeCache(map);
   }
 
-  status = msWFSRetrieveFeatures(map,
-                                 ows_request,
-                           paramsObj,
-                           &gmlinfo,
-                           paramsObj->pszFilter,
-                           paramsObj->pszBbox != NULL,
-                           sBBoxSrs,
-                           bbox,
-                           paramsObj->pszFeatureId,
-                           layers,
-                           numlayers,
-                           maxfeatures,
-                           nWFSVersion,
-                           &iNumberOfFeatures,
-                           &bHasNextFeatures);
-  if( status != MS_SUCCESS )
-  {
-      msFreeCharArray(layers, numlayers);
-      msFree(sBBoxSrs);
-      msFreeCharArray(papszGMLGroups, map->numlayers);
-      msFreeCharArray(papszGMLIncludeItems, map->numlayers);
-      msFreeCharArray(papszGMLGeometries, map->numlayers);
-      return status;
+  status = msWFSRetrieveFeatures(
+      map, ows_request, paramsObj, &gmlinfo, paramsObj->pszFilter,
+      paramsObj->pszBbox != NULL, sBBoxSrs, bbox, paramsObj->pszFeatureId,
+      layers, numlayers, maxfeatures, nWFSVersion, &iNumberOfFeatures,
+      &bHasNextFeatures);
+  if (status != MS_SUCCESS) {
+    msFreeCharArray(layers, numlayers);
+    msFree(sBBoxSrs);
+    msFreeCharArray(papszGMLGroups, map->numlayers);
+    msFreeCharArray(papszGMLIncludeItems, map->numlayers);
+    msFreeCharArray(papszGMLGeometries, map->numlayers);
+    return status;
   }
 
   /* ----------------------------------------- */
   /* Now compute nMatchingFeatures for WFS 2.0 */
   /* ----------------------------------------- */
-  
-  nMatchingFeatures = msWFSComputeMatchingFeatures(map,ows_request,paramsObj,
-                                                   iNumberOfFeatures,
-                                                   maxfeatures,
-                                                   &gmlinfo,
-                                                   bbox,
-                                                   sBBoxSrs,
-                                                   layers,
-                                                   numlayers,
-                                                   nWFSVersion);
+
+  nMatchingFeatures = msWFSComputeMatchingFeatures(
+      map, ows_request, paramsObj, iNumberOfFeatures, maxfeatures, &gmlinfo,
+      bbox, sBBoxSrs, layers, numlayers, nWFSVersion);
 
   msFreeCharArray(layers, numlayers);
 
@@ -3860,32 +3925,29 @@ int msWFSGetFeature(mapObj *map, wfsPara
 
   status = MS_SUCCESS;
 
-  if( psFormat == NULL ) {
-    if( paramsObj->countGetFeatureById == 1 && maxfeatures != 0 && iResultTypeHits == 0 )
-    {
-        /* When there's a single  urn:ogc:def:query:OGC-WFS::GetFeatureById GetFeature request */
-        /* we must not output a FeatureCollection but the object itself */
-        /* We do that as a post-processing step, so let print into a buffer and modify the */
-        /* XML afterwards */
-        old_context = msIO_pushStdoutToBufferAndGetOldContext();
-    }
-    else
-    {
-        msIO_setHeader("Content-Type","%s; charset=UTF-8", gmlinfo.output_mime_type);
-        msIO_sendHeaders();
+  if (psFormat == NULL) {
+    if (paramsObj->countGetFeatureById == 1 && maxfeatures != 0 &&
+        iResultTypeHits == 0) {
+      /* When there's a single  urn:ogc:def:query:OGC-WFS::GetFeatureById
+       * GetFeature request */
+      /* we must not output a FeatureCollection but the object itself */
+      /* We do that as a post-processing step, so let print into a buffer and
+       * modify the */
+      /* XML afterwards */
+      old_context = msIO_pushStdoutToBufferAndGetOldContext();
+    } else {
+      msIO_setHeader("Content-Type", "%s; charset=UTF-8",
+                     gmlinfo.output_mime_type);
+      msIO_sendHeaders();
     }
 
-    status = msWFSGetFeature_GMLPreamble( map, req, &gmlinfo, paramsObj,
-                                 outputformat,
-                                 iResultTypeHits,
-                                 iNumberOfFeatures,
-                                 nMatchingFeatures,
-                                 maxfeatures,
-                                 bHasNextFeatures,
-                                 nWFSVersion );
-    if(status != MS_SUCCESS) {
-      if( old_context != NULL )
-          msIO_restoreOldStdoutContext(old_context);
+    status = msWFSGetFeature_GMLPreamble(
+        map, req, &gmlinfo, paramsObj, outputformat, iResultTypeHits,
+        iNumberOfFeatures, nMatchingFeatures, maxfeatures, bHasNextFeatures,
+        nWFSVersion);
+    if (status != MS_SUCCESS) {
+      if (old_context != NULL)
+        msIO_restoreOldStdoutContext(old_context);
       msWFSCleanupGMLInfo(&gmlinfo);
       msFreeCharArray(papszGMLGroups, map->numlayers);
       msFreeCharArray(papszGMLIncludeItems, map->numlayers);
@@ -3896,114 +3958,110 @@ int msWFSGetFeature(mapObj *map, wfsPara
 
   {
     int i;
-    for(i=0;i<map->numlayers;i++)
-    {
-      layerObj* lp = GET_LAYER(map, i);
-      if( papszGMLGroups[i] )
-          msInsertHashTable(&(lp->metadata), "GML_GROUPS", papszGMLGroups[i]);
-      if( papszGMLIncludeItems[i] )
-          msInsertHashTable(&(lp->metadata), "GML_INCLUDE_ITEMS", papszGMLIncludeItems[i]);
-      if( papszGMLGeometries[i] )
-          msInsertHashTable(&(lp->metadata), "GML_GEOMETRIES", papszGMLGeometries[i]);
+    for (i = 0; i < map->numlayers; i++) {
+      layerObj *lp = GET_LAYER(map, i);
+      if (papszGMLGroups[i])
+        msInsertHashTable(&(lp->metadata), "GML_GROUPS", papszGMLGroups[i]);
+      if (papszGMLIncludeItems[i])
+        msInsertHashTable(&(lp->metadata), "GML_INCLUDE_ITEMS",
+                          papszGMLIncludeItems[i]);
+      if (papszGMLGeometries[i])
+        msInsertHashTable(&(lp->metadata), "GML_GEOMETRIES",
+                          papszGMLGeometries[i]);
     }
   }
 
   /* handle case of maxfeatures = 0 */
   /*internally use a start index that start with 0 as the first index*/
-  if( psFormat == NULL ) {
-    if(maxfeatures != 0 && iResultTypeHits == 0)
-    {
+  if (psFormat == NULL) {
+    if (maxfeatures != 0 && iResultTypeHits == 0) {
       int bWFS2MultipleFeatureCollection = MS_FALSE;
 
       /* Would make sense for WFS 1.1.0 too ! See #3576 */
       int bUseURN = (nWFSVersion == OWS_2_0_0);
-      const char* useurn = msOWSLookupMetadata(&(map->web.metadata), "F", "return_srs_as_urn");
+      const char *useurn =
+          msOWSLookupMetadata(&(map->web.metadata), "F", "return_srs_as_urn");
       if (useurn && strcasecmp(useurn, "true") == 0)
         bUseURN = 1;
       else if (useurn && strcasecmp(useurn, "false") == 0)
         bUseURN = 0;
 
-      /* For WFS 2.0, when we request several types, we must present each type */
+      /* For WFS 2.0, when we request several types, we must present each type
+       */
       /* in its own FeatureCollection (§ 11.3.3.5 ) */
-      if( nWFSVersion >= OWS_2_0_0 && iResultTypeHits != 1 )
-      {
-          int i;
-          int nLayersWithFeatures = 0;
-          for(i=0; i<map->numlayers; i++) {
-              layerObj* lp = GET_LAYER(map, i);
-              if(lp->resultcache && lp->resultcache->numresults > 0)
-                  nLayersWithFeatures ++;
-          }
-          if( nLayersWithFeatures > 1 )
-          {
-            char timestring[100];
-            resultCacheObj** saveResultCache = (resultCacheObj** )
-                    msSmallMalloc( map->numlayers * sizeof(resultCacheObj*));
-            int iLastNonEmptyLayer = -1;
-
-            msWFSGetFeature_GetTimeStamp(timestring, sizeof(timestring));
-
-            /* Emit global bounds */
-            msGMLWriteWFSBounds(map, stdout, "  ", outputformat, nWFSVersion, bUseURN);
-
-            /* Save the result cache that contains the features that we want to */
-            /* emit in the response */
-            for(i=0; i<map->numlayers; i++) {
-              layerObj* lp = GET_LAYER(map, i);
-              saveResultCache[i] = lp->resultcache;
-              if( lp->resultcache  && lp->resultcache->numresults > 0) {
-                  iLastNonEmptyLayer = i;
-              }
-              lp->resultcache = NULL;
+      if (nWFSVersion >= OWS_2_0_0 && iResultTypeHits != 1) {
+        int i;
+        int nLayersWithFeatures = 0;
+        for (i = 0; i < map->numlayers; i++) {
+          layerObj *lp = GET_LAYER(map, i);
+          if (lp->resultcache && lp->resultcache->numresults > 0)
+            nLayersWithFeatures++;
+        }
+        if (nLayersWithFeatures > 1) {
+          char timestring[100];
+          resultCacheObj **saveResultCache = (resultCacheObj **)msSmallMalloc(
+              map->numlayers * sizeof(resultCacheObj *));
+          int iLastNonEmptyLayer = -1;
+
+          msWFSGetFeature_GetTimeStamp(timestring, sizeof(timestring));
+
+          /* Emit global bounds */
+          msGMLWriteWFSBounds(map, stdout, "  ", outputformat, nWFSVersion,
+                              bUseURN);
+
+          /* Save the result cache that contains the features that we want to */
+          /* emit in the response */
+          for (i = 0; i < map->numlayers; i++) {
+            layerObj *lp = GET_LAYER(map, i);
+            saveResultCache[i] = lp->resultcache;
+            if (lp->resultcache && lp->resultcache->numresults > 0) {
+              iLastNonEmptyLayer = i;
             }
+            lp->resultcache = NULL;
+          }
 
-            /* Just dump one layer at a time */
-            for(i=0;i<map->numlayers;i++) {
-              layerObj* lp = GET_LAYER(map, i);
-              lp->resultcache = saveResultCache[i];
-              if( lp->resultcache  && lp->resultcache->numresults > 0) {
-                msIO_fprintf(stdout, "  <wfs:member>\n");
-                msIO_fprintf(stdout, "   <wfs:FeatureCollection timeStamp=\"%s\" numberMatched=\"", timestring);
-                if( i < iLastNonEmptyLayer || nMatchingFeatures >= 0 )
-                    msIO_fprintf(stdout, "%d", lp->resultcache->numresults );
-                else
-                    msIO_fprintf(stdout, "unknown" );
-                msIO_fprintf(stdout, "\" numberReturned=\"%d\">\n", lp->resultcache->numresults );
-
-                msGMLWriteWFSQuery(map, stdout,
-                                    gmlinfo.user_namespace_prefix,
-                                    outputformat,
-                                    nWFSVersion,
-                                    bUseURN,
-                                    MS_FALSE);
-                msIO_fprintf(stdout, "   </wfs:FeatureCollection>\n");
-                msIO_fprintf(stdout, "  </wfs:member>\n");
-              }
-              lp->resultcache = NULL;
+          /* Just dump one layer at a time */
+          for (i = 0; i < map->numlayers; i++) {
+            layerObj *lp = GET_LAYER(map, i);
+            lp->resultcache = saveResultCache[i];
+            if (lp->resultcache && lp->resultcache->numresults > 0) {
+              msIO_fprintf(stdout, "  <wfs:member>\n");
+              msIO_fprintf(
+                  stdout,
+                  "   <wfs:FeatureCollection timeStamp=\"%s\" numberMatched=\"",
+                  timestring);
+              if (i < iLastNonEmptyLayer || nMatchingFeatures >= 0)
+                msIO_fprintf(stdout, "%d", lp->resultcache->numresults);
+              else
+                msIO_fprintf(stdout, "unknown");
+              msIO_fprintf(stdout, "\" numberReturned=\"%d\">\n",
+                           lp->resultcache->numresults);
+
+              msGMLWriteWFSQuery(map, stdout, gmlinfo.user_namespace_prefix,
+                                 outputformat, nWFSVersion, bUseURN, MS_FALSE);
+              msIO_fprintf(stdout, "   </wfs:FeatureCollection>\n");
+              msIO_fprintf(stdout, "  </wfs:member>\n");
             }
+            lp->resultcache = NULL;
+          }
 
-            /* Restore for later cleanup */
-            for(i=0; i<map->numlayers; i++) {
-              layerObj* lp = GET_LAYER(map, i);
-              lp->resultcache = saveResultCache[i];
-            }
-            msFree(saveResultCache);
+          /* Restore for later cleanup */
+          for (i = 0; i < map->numlayers; i++) {
+            layerObj *lp = GET_LAYER(map, i);
+            lp->resultcache = saveResultCache[i];
+          }
+          msFree(saveResultCache);
 
-            bWFS2MultipleFeatureCollection = MS_TRUE;
-         }
+          bWFS2MultipleFeatureCollection = MS_TRUE;
+        }
       }
 
-      if( !bWFS2MultipleFeatureCollection )
-      {
-        msGMLWriteWFSQuery(map, stdout,
-                                    gmlinfo.user_namespace_prefix,
-                                    outputformat,
-                                    nWFSVersion,
-                                    bUseURN,
-                                    MS_FALSE);
+      if (!bWFS2MultipleFeatureCollection) {
+        msGMLWriteWFSQuery(map, stdout, gmlinfo.user_namespace_prefix,
+                           outputformat, nWFSVersion, bUseURN, MS_FALSE);
       }
 
-      status =  MS_SUCCESS;
+      status = MS_SUCCESS;
     }
   } else {
     mapservObj *mapserv = msAllocMapServObj();
@@ -4015,30 +4073,27 @@ int msWFSGetFeature(mapObj *map, wfsPara
     mapserv->request = req;
     map->querymap.status = MS_FALSE;
 
-    if( nMatchingFeatures >= 0 )
-    {
-        char szMatchingFeatures[12];
-        sprintf(szMatchingFeatures, "%d", nMatchingFeatures);
-        msSetOutputFormatOption( psFormat, "_matching_features_",
-                                 szMatchingFeatures);
-    }
-    else
-    {
-        msSetOutputFormatOption( psFormat, "_matching_features_", "");
+    if (nMatchingFeatures >= 0) {
+      char szMatchingFeatures[12];
+      sprintf(szMatchingFeatures, "%d", nMatchingFeatures);
+      msSetOutputFormatOption(psFormat, "_matching_features_",
+                              szMatchingFeatures);
+    } else {
+      msSetOutputFormatOption(psFormat, "_matching_features_", "");
     }
-    status = msReturnTemplateQuery( mapserv, psFormat->name, NULL );
+    status = msReturnTemplateQuery(mapserv, psFormat->name, NULL);
 
     mapserv->request = NULL;
     mapserv->map = NULL;
 
-    msFreeMapServObj( mapserv );
+    msFreeMapServObj(mapserv);
 
-    if( status != MS_SUCCESS ) {
+    if (status != MS_SUCCESS) {
       msFreeCharArray(papszGMLGroups, map->numlayers);
       msFreeCharArray(papszGMLIncludeItems, map->numlayers);
       msFreeCharArray(papszGMLGeometries, map->numlayers);
       return msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE,
-                            paramsObj->pszVersion );
+                            paramsObj->pszVersion);
     }
   }
 
@@ -4046,67 +4101,60 @@ int msWFSGetFeature(mapObj *map, wfsPara
   msFreeCharArray(papszGMLIncludeItems, map->numlayers);
   msFreeCharArray(papszGMLGeometries, map->numlayers);
 
-  if( psFormat == NULL && status == MS_SUCCESS ) {
-    msWFSGetFeature_GMLPostfix( &gmlinfo,
-                                outputformat,
-                                maxfeatures, iResultTypeHits, iNumberOfFeatures,
-                                nWFSVersion );
+  if (psFormat == NULL && status == MS_SUCCESS) {
+    msWFSGetFeature_GMLPostfix(&gmlinfo, outputformat, maxfeatures,
+                               iResultTypeHits, iNumberOfFeatures, nWFSVersion);
   }
 
-  /*Special case for a single urn:ogc:def:query:OGC-WFS::GetFeatureById GetFeature request */
-  if( old_context != NULL )
-  {
-    msIOContext* new_context;
-    msIOBuffer* buffer;
-    CPLXMLNode* psRoot;
+  /*Special case for a single urn:ogc:def:query:OGC-WFS::GetFeatureById
+   * GetFeature request */
+  if (old_context != NULL) {
+    msIOContext *new_context;
+    msIOBuffer *buffer;
+    CPLXMLNode *psRoot;
 
     new_context = msIO_getHandler(stdout);
-    buffer = (msIOBuffer *) new_context->cbData;
-    psRoot = CPLParseXMLString((const char*) buffer->data);
+    buffer = (msIOBuffer *)new_context->cbData;
+    psRoot = CPLParseXMLString((const char *)buffer->data);
     msIO_restoreOldStdoutContext(old_context);
-    if( psRoot != NULL )
-    {
-        CPLXMLNode* psFeatureCollection = CPLGetXMLNode(psRoot, "=wfs:FeatureCollection");
-        if( psFeatureCollection != NULL )
-        {
-            CPLXMLNode* psMember = CPLGetXMLNode(psFeatureCollection, "wfs:member");
-            if( psMember != NULL && psMember->psChild != NULL )
-            {
-                CPLXMLNode* psIter;
-                CPLXMLNode* psFeatureNode;
-                char* pszTmpXML;
-
-                /* Transfer all namespaces of FeatureCollection to the Feature */
-                psFeatureNode = psMember->psChild;
-                psIter = psFeatureCollection->psChild;
-                while(psIter != NULL)
-                {
-                    if( psIter->eType == CXT_Attribute &&
-                        (strncmp(psIter->pszValue, "xmlns:", strlen("xmlns:")) == 0 ||
-                         strncmp(psIter->pszValue, "xsi:", strlen("xsi:")) == 0) )
-                    {
-                        CPLXMLNode* psIterNext = psIter->psNext;
-                        psIter->psNext = NULL;
-                        CPLAddXMLChild(psFeatureNode, CPLCloneXMLTree(psIter));
-                        psIter->psNext = psIterNext;
-                    }
-                    psIter = psIter->psNext;
-                }
-
-                pszTmpXML = CPLSerializeXMLTree(psFeatureNode);
-                msIO_setHeader("Content-Type","%s; charset=UTF-8", gmlinfo.output_mime_type);
-                msIO_sendHeaders();
-                msIO_printf("<?xml version='1.0' encoding=\"UTF-8\" ?>\n");
-                msIO_printf("%s", pszTmpXML);
-                CPLFree(pszTmpXML);
-            }
-            else
-            {
-                status = msWFSException(map, NULL, MS_OWS_ERROR_NOT_FOUND,
-                                        paramsObj->pszVersion );
+    if (psRoot != NULL) {
+      CPLXMLNode *psFeatureCollection =
+          CPLGetXMLNode(psRoot, "=wfs:FeatureCollection");
+      if (psFeatureCollection != NULL) {
+        CPLXMLNode *psMember = CPLGetXMLNode(psFeatureCollection, "wfs:member");
+        if (psMember != NULL && psMember->psChild != NULL) {
+          CPLXMLNode *psIter;
+          CPLXMLNode *psFeatureNode;
+          char *pszTmpXML;
+
+          /* Transfer all namespaces of FeatureCollection to the Feature */
+          psFeatureNode = psMember->psChild;
+          psIter = psFeatureCollection->psChild;
+          while (psIter != NULL) {
+            if (psIter->eType == CXT_Attribute &&
+                (strncmp(psIter->pszValue, "xmlns:", strlen("xmlns:")) == 0 ||
+                 strncmp(psIter->pszValue, "xsi:", strlen("xsi:")) == 0)) {
+              CPLXMLNode *psIterNext = psIter->psNext;
+              psIter->psNext = NULL;
+              CPLAddXMLChild(psFeatureNode, CPLCloneXMLTree(psIter));
+              psIter->psNext = psIterNext;
             }
+            psIter = psIter->psNext;
+          }
+
+          pszTmpXML = CPLSerializeXMLTree(psFeatureNode);
+          msIO_setHeader("Content-Type", "%s; charset=UTF-8",
+                         gmlinfo.output_mime_type);
+          msIO_sendHeaders();
+          msIO_printf("<?xml version='1.0' encoding=\"UTF-8\" ?>\n");
+          msIO_printf("%s", pszTmpXML);
+          CPLFree(pszTmpXML);
+        } else {
+          status = msWFSException(map, NULL, MS_OWS_ERROR_NOT_FOUND,
+                                  paramsObj->pszVersion);
         }
-        CPLDestroyXMLNode(psRoot);
+      }
+      CPLDestroyXMLNode(psRoot);
     }
   }
 
@@ -4118,13 +4166,12 @@ int msWFSGetFeature(mapObj *map, wfsPara
 /*
 ** msWFSGetPropertyValue()
 */
-static
-int msWFSGetPropertyValue(mapObj *map, wfsParamsObj *paramsObj, cgiRequestObj *req,
-                         owsRequestObj *ows_request, int nWFSVersion)
-{
-  int   status;
-  int   maxfeatures=-1,startindex=-1;
-  rectObj     bbox;
+static int msWFSGetPropertyValue(mapObj *map, wfsParamsObj *paramsObj,
+                                 cgiRequestObj *req, owsRequestObj *ows_request,
+                                 int nWFSVersion) {
+  int status;
+  int maxfeatures = -1, startindex = -1;
+  rectObj bbox;
 
   char *sBBoxSrs = NULL;
 
@@ -4137,31 +4184,32 @@ int msWFSGetPropertyValue(mapObj *map, w
   int nMatchingFeatures = -1;
   int bHasNextFeatures = MS_FALSE;
 
-  const char* pszTypeName;
+  const char *pszTypeName;
   layerObj *lp;
 
-  char* pszGMLGroups = NULL;
-  char* pszGMLIncludeItems = NULL;
-  char* pszGMLGeometries = NULL;
+  char *pszGMLGroups = NULL;
+  char *pszGMLIncludeItems = NULL;
+  char *pszGMLGeometries = NULL;
 
   status = msWFSResolveStoredQuery(map, paramsObj, req);
-  if( status != MS_SUCCESS )
-      return status;
+  if (status != MS_SUCCESS)
+    return status;
 
-  if (paramsObj->pszTypeName==NULL) {
-    msSetError(MS_WFSERR,
-               "Incomplete WFS request: TYPENAMES parameter missing",
+  if (paramsObj->pszTypeName == NULL) {
+    msSetError(MS_WFSERR, "Incomplete WFS request: TYPENAMES parameter missing",
                "msWFSGetPropertyValue()");
     return msWFSException(map, "typenames",
-                          MS_OWS_ERROR_MISSING_PARAMETER_VALUE, paramsObj->pszVersion);
+                          MS_OWS_ERROR_MISSING_PARAMETER_VALUE,
+                          paramsObj->pszVersion);
   }
 
-  if (paramsObj->pszValueReference==NULL) {
+  if (paramsObj->pszValueReference == NULL) {
     msSetError(MS_WFSERR,
                "Incomplete WFS request: VALUEREFERENCE parameter missing",
                "msWFSGetPropertyValue()");
     return msWFSException(map, "valuereference",
-                          MS_OWS_ERROR_MISSING_PARAMETER_VALUE, paramsObj->pszVersion);
+                          MS_OWS_ERROR_MISSING_PARAMETER_VALUE,
+                          paramsObj->pszVersion);
   }
 
   /* Keep only selected layers, set to OFF by default. */
@@ -4171,113 +4219,113 @@ int msWFSGetPropertyValue(mapObj *map, w
   pszTypeName = msWFSStripNS(paramsObj->pszTypeName);
 
   lp = msWFSGetLayerByName(map, ows_request, pszTypeName);
-  if( lp != NULL ) {
-        gmlItemListObj *itemList=NULL;
-        gmlGeometryListObj *geometryList=NULL;
-        gmlGroupListObj* groupList=NULL;
-
-        lp->status = MS_ON;
-        if (lp->_template == NULL) {
-            /* Force setting a template to enable query. */
-            lp->_template = msStrdup("ttt.html");
+  if (lp != NULL) {
+    gmlItemListObj *itemList = NULL;
+    gmlGeometryListObj *geometryList = NULL;
+    gmlGroupListObj *groupList = NULL;
+
+    lp->status = MS_ON;
+    if (lp->_template == NULL) {
+      /* Force setting a template to enable query. */
+      lp->_template = msStrdup("ttt.html");
+    }
+
+    /*do an alias replace for the current layer*/
+    if (msLayerOpen(lp) == MS_SUCCESS && msLayerGetItems(lp) == MS_SUCCESS) {
+      const char *pszValueReference;
+      int z;
+      int nGroupIndex = -1;
+
+      itemList = msGMLGetItems(lp, "G");
+      groupList = msGMLGetGroups(lp, "G");
+
+      if (paramsObj->pszSortBy != NULL &&
+          strcmp(paramsObj->pszSortBy, "!") != 0) {
+        status = msWFSApplySortBy(map, paramsObj, lp, paramsObj->pszSortBy,
+                                  itemList, groupList);
+        if (status != MS_SUCCESS) {
+          msGMLFreeItems(itemList);
+          msGMLFreeGroups(groupList);
+          return status;
         }
+      }
 
-        /*do an alias replace for the current layer*/
-        if (msLayerOpen(lp) == MS_SUCCESS && msLayerGetItems(lp) == MS_SUCCESS) {
-            const char* pszValueReference;
-            int z;
-            int nGroupIndex = -1;
-
-            itemList = msGMLGetItems(lp, "G");
-            groupList = msGMLGetGroups(lp, "G");
-
-            if( paramsObj->pszSortBy != NULL &&
-                strcmp(paramsObj->pszSortBy, "!") != 0 )
-            {
-              status = msWFSApplySortBy(map, paramsObj, lp,
-                                       paramsObj->pszSortBy, itemList, groupList);
-              if( status != MS_SUCCESS )
-              {
-                msGMLFreeItems(itemList);
-                msGMLFreeGroups(groupList);
-                return status;
-              }
-            }
-
-            geometryList=msGMLGetGeometries(lp, "GFO", MS_TRUE);
-
-            pszValueReference = msWFSStripNS(paramsObj->pszValueReference);
-            pszValueReference = msWFSUnaliasItem(lp, pszValueReference);
-            pszValueReference = msWFSUngroupItem(lp, groupList, pszValueReference, &nGroupIndex);
-
-            if( strcmp(paramsObj->pszValueReference, "@gml:id") == 0 ) {
-              pszGMLGroups = msStrdup("");
-              pszGMLIncludeItems = msStrdup(paramsObj->pszValueReference);
-              pszGMLGeometries = msStrdup("none");
-            }
-            else if( nGroupIndex >= 0 ) {
-              int w;
-              char* pszItems = NULL;
-              for(w=0;w<groupList->groups[nGroupIndex].numitems;w++) {
-                if( w > 0 )
-                  pszItems = msStringConcatenate(pszItems, ",");
-                pszItems = msStringConcatenate(pszItems, groupList->groups[nGroupIndex].items[w]);
-              }
-              pszGMLGroups = msStrdup(groupList->groups[nGroupIndex].name);
-              pszGMLIncludeItems = msStrdup(pszItems);
-              pszGMLGeometries = msStrdup("none");
-              msFree(pszItems);
-            }
-            else {
-              pszGMLGroups = msStrdup("");
-
-              /* Check that the property name is allowed (#3563) */
-              /*we need to check of the property name is the geometry name; In that case it
-                    is a valid property name*/
-              if (!msWFSIsAllowedItem(itemList, pszValueReference)) {
-                for(z=0; z<geometryList->numgeometries; z++) {
-                  if (strcasecmp(pszValueReference, geometryList->geometries[z].name) == 0)
-                    break;
-                }
+      geometryList = msGMLGetGeometries(lp, "GFO", MS_TRUE);
 
-                if (z == geometryList->numgeometries) {
-                  msSetError(MS_WFSERR,
-                            "Invalid VALUEREFERENCE %s",  "msWFSGetPropertyValue()", paramsObj->pszValueReference);
-                  msFree(pszGMLGroups);
-                  msGMLFreeItems(itemList);
-                  msGMLFreeGroups(groupList);
-                  msGMLFreeGeometries(geometryList);
-                  return msWFSException(map, "valuereference", MS_OWS_ERROR_INVALID_PARAMETER_VALUE, paramsObj->pszVersion);
-                }
-                else {
-                  pszGMLIncludeItems = msStrdup("");
-                  pszGMLGeometries = msStrdup(pszValueReference);
-                }
-              }
-              else {
-                pszGMLIncludeItems = msStrdup(pszValueReference);
-                pszGMLGeometries = msStrdup("none");
-              }
-            }
+      pszValueReference = msWFSStripNS(paramsObj->pszValueReference);
+      pszValueReference = msWFSUnaliasItem(lp, pszValueReference);
+      pszValueReference =
+          msWFSUngroupItem(lp, groupList, pszValueReference, &nGroupIndex);
+
+      if (strcmp(paramsObj->pszValueReference, "@gml:id") == 0) {
+        pszGMLGroups = msStrdup("");
+        pszGMLIncludeItems = msStrdup(paramsObj->pszValueReference);
+        pszGMLGeometries = msStrdup("none");
+      } else if (nGroupIndex >= 0) {
+        int w;
+        char *pszItems = NULL;
+        for (w = 0; w < groupList->groups[nGroupIndex].numitems; w++) {
+          if (w > 0)
+            pszItems = msStringConcatenate(pszItems, ",");
+          pszItems = msStringConcatenate(
+              pszItems, groupList->groups[nGroupIndex].items[w]);
+        }
+        pszGMLGroups = msStrdup(groupList->groups[nGroupIndex].name);
+        pszGMLIncludeItems = msStrdup(pszItems);
+        pszGMLGeometries = msStrdup("none");
+        msFree(pszItems);
+      } else {
+        pszGMLGroups = msStrdup("");
 
-            msLayerClose(lp);
+        /* Check that the property name is allowed (#3563) */
+        /*we need to check of the property name is the geometry name; In that
+           case it is a valid property name*/
+        if (!msWFSIsAllowedItem(itemList, pszValueReference)) {
+          for (z = 0; z < geometryList->numgeometries; z++) {
+            if (strcasecmp(pszValueReference,
+                           geometryList->geometries[z].name) == 0)
+              break;
+          }
 
+          if (z == geometryList->numgeometries) {
+            msSetError(MS_WFSERR, "Invalid VALUEREFERENCE %s",
+                       "msWFSGetPropertyValue()", paramsObj->pszValueReference);
+            msFree(pszGMLGroups);
             msGMLFreeItems(itemList);
             msGMLFreeGroups(groupList);
             msGMLFreeGeometries(geometryList);
+            return msWFSException(map, "valuereference",
+                                  MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                                  paramsObj->pszVersion);
+          } else {
+            pszGMLIncludeItems = msStrdup("");
+            pszGMLGeometries = msStrdup(pszValueReference);
+          }
+        } else {
+          pszGMLIncludeItems = msStrdup(pszValueReference);
+          pszGMLGeometries = msStrdup("none");
         }
-  }
-  else {
-        /* Requested layer name was not in capabilities:
-         * either it just doesn't exist
-         */
-        msSetError(MS_WFSERR,
-                    "TYPENAME '%s' doesn't exist in this server.  Please check the capabilities and reformulate your request.",
-                    "msWFSGetFeature()", paramsObj->pszTypeName);
-        msFree(pszGMLGroups);
-        msFree(pszGMLIncludeItems);
-        msFree(pszGMLGeometries);
-        return msWFSException(map, "typename", MS_OWS_ERROR_INVALID_PARAMETER_VALUE, paramsObj->pszVersion);
+      }
+
+      msLayerClose(lp);
+
+      msGMLFreeItems(itemList);
+      msGMLFreeGroups(groupList);
+      msGMLFreeGeometries(geometryList);
+    }
+  } else {
+    /* Requested layer name was not in capabilities:
+     * either it just doesn't exist
+     */
+    msSetError(MS_WFSERR,
+               "TYPENAME '%s' doesn't exist in this server.  Please check the "
+               "capabilities and reformulate your request.",
+               "msWFSGetFeature()", paramsObj->pszTypeName);
+    msFree(pszGMLGroups);
+    msFree(pszGMLIncludeItems);
+    msFree(pszGMLGeometries);
+    return msWFSException(map, "typename", MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                          paramsObj->pszVersion);
   }
 
   /* Initialize gml options */
@@ -4292,79 +4340,58 @@ int msWFSGetPropertyValue(mapObj *map, w
 
   /* Validate outputformat */
   status = msWFSGetGMLOutputFormat(paramsObj, &gmlinfo, nWFSVersion);
-  if( status < 0 ) {
-    msSetError(MS_WFSERR,
-                "'%s' is not a permitted output format for GetPropertyValue request.",
-                "msWFSGetPropertyValue()",
-                paramsObj->pszOutputFormat);
+  if (status < 0) {
+    msSetError(
+        MS_WFSERR,
+        "'%s' is not a permitted output format for GetPropertyValue request.",
+        "msWFSGetPropertyValue()", paramsObj->pszOutputFormat);
     msFree(pszGMLGroups);
     msFree(pszGMLIncludeItems);
     msFree(pszGMLGeometries);
     return msWFSException(map, "outputformat",
-                        MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
-                        paramsObj->pszVersion );
-  }
-  else {
-    outputformat = (OWSGMLVersion) status;
+                          MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                          paramsObj->pszVersion);
+  } else {
+    outputformat = (OWSGMLVersion)status;
   }
 
   msWFSAnalyzeStartIndexAndFeatureCount(map, paramsObj, iResultTypeHits,
                                         &maxfeatures, &startindex);
 
   status = msWFSAnalyzeBBOX(map, paramsObj, &bbox, &sBBoxSrs);
-  if( status != 0 ) {
-      msFree(pszGMLGroups);
-      msFree(pszGMLIncludeItems);
-      msFree(pszGMLGeometries);
-      return status;
-      }
-
-  if( iResultTypeHits == 1 )
-  {
-      map->query.only_cache_result_count = MS_TRUE;
+  if (status != 0) {
+    msFree(pszGMLGroups);
+    msFree(pszGMLIncludeItems);
+    msFree(pszGMLGeometries);
+    return status;
   }
-  else
-  {
-      msWFSSetShapeCache(map);
+
+  if (iResultTypeHits == 1) {
+    map->query.only_cache_result_count = MS_TRUE;
+  } else {
+    msWFSSetShapeCache(map);
   }
 
-  status = msWFSRetrieveFeatures(map,
-                                 ows_request,
-                           paramsObj,
-                           &gmlinfo,
-                           paramsObj->pszFilter,
-                           paramsObj->pszBbox != NULL,
-                           sBBoxSrs,
-                           bbox,
-                           paramsObj->pszFeatureId,
-                           (char**) &pszTypeName,
-                           1,
-                           maxfeatures,
-                           nWFSVersion,
-                           &iNumberOfFeatures,
-                           &bHasNextFeatures);
-  if( status != MS_SUCCESS )
-  {
-      msFree(sBBoxSrs);
-      msFree(pszGMLGroups);
-      msFree(pszGMLIncludeItems);
-      msFree(pszGMLGeometries);
-      return status;
+  status = msWFSRetrieveFeatures(
+      map, ows_request, paramsObj, &gmlinfo, paramsObj->pszFilter,
+      paramsObj->pszBbox != NULL, sBBoxSrs, bbox, paramsObj->pszFeatureId,
+      (char **)&pszTypeName, 1, maxfeatures, nWFSVersion, &iNumberOfFeatures,
+      &bHasNextFeatures);
+  if (status != MS_SUCCESS) {
+    msFree(sBBoxSrs);
+    msFree(pszGMLGroups);
+    msFree(pszGMLIncludeItems);
+    msFree(pszGMLGeometries);
+    return status;
   }
 
   /* ----------------------------------------- */
   /* Now compute nMatchingFeatures for WFS 2.0 */
   /* ----------------------------------------- */
-  
-  nMatchingFeatures = msWFSComputeMatchingFeatures(map,ows_request,paramsObj,
-                                                   iNumberOfFeatures,
-                                                   maxfeatures,
-                                                   &gmlinfo,
-                                                   bbox,
-                                                   sBBoxSrs,
-                                                   (char**) &pszTypeName,
-                                                   1,
-                                                   nWFSVersion);
+
+  nMatchingFeatures = msWFSComputeMatchingFeatures(
+      map, ows_request, paramsObj, iNumberOfFeatures, maxfeatures, &gmlinfo,
+      bbox, sBBoxSrs, (char **)&pszTypeName, 1, nWFSVersion);
 
   msFree(sBBoxSrs);
   sBBoxSrs = NULL;
@@ -4372,37 +4399,29 @@ int msWFSGetPropertyValue(mapObj *map, w
   /*
   ** GML Header generation.
   */
-  msIO_setHeader("Content-Type","%s; charset=UTF-8", gmlinfo.output_mime_type);
+  msIO_setHeader("Content-Type", "%s; charset=UTF-8", gmlinfo.output_mime_type);
   msIO_sendHeaders();
 
-  status = msWFSGetFeature_GMLPreamble( map, req, &gmlinfo, paramsObj,
-                                 outputformat,
-                                 iResultTypeHits,
-                                 iNumberOfFeatures,
-                                 nMatchingFeatures,
-                                 maxfeatures,
-                                 bHasNextFeatures,
-                                 nWFSVersion );
+  status = msWFSGetFeature_GMLPreamble(
+      map, req, &gmlinfo, paramsObj, outputformat, iResultTypeHits,
+      iNumberOfFeatures, nMatchingFeatures, maxfeatures, bHasNextFeatures,
+      nWFSVersion);
+
+  if (status == MS_SUCCESS && maxfeatures != 0 && iResultTypeHits == 0) {
+    if (pszGMLGroups)
+      msInsertHashTable(&(lp->metadata), "GML_GROUPS", pszGMLGroups);
+    if (pszGMLIncludeItems)
+      msInsertHashTable(&(lp->metadata), "GML_INCLUDE_ITEMS",
+                        pszGMLIncludeItems);
+    if (pszGMLGeometries)
+      msInsertHashTable(&(lp->metadata), "GML_GEOMETRIES", pszGMLGeometries);
 
-  if(status == MS_SUCCESS && maxfeatures != 0 && iResultTypeHits == 0)
-  {
-      if( pszGMLGroups )
-        msInsertHashTable(&(lp->metadata), "GML_GROUPS", pszGMLGroups);
-      if( pszGMLIncludeItems )
-        msInsertHashTable(&(lp->metadata), "GML_INCLUDE_ITEMS", pszGMLIncludeItems);
-      if( pszGMLGeometries )
-        msInsertHashTable(&(lp->metadata), "GML_GEOMETRIES", pszGMLGeometries);
-
-      status = msGMLWriteWFSQuery(map, stdout,
-                                  gmlinfo.user_namespace_prefix,
-                                  outputformat,
-                                  nWFSVersion,
-                                  MS_TRUE,
-                                  MS_TRUE);
+    status = msGMLWriteWFSQuery(map, stdout, gmlinfo.user_namespace_prefix,
+                                outputformat, nWFSVersion, MS_TRUE, MS_TRUE);
   }
 
   msIO_printf("</wfs:ValueCollection>\n");
-  
+
   msFree(pszGMLGroups);
   msFree(pszGMLIncludeItems);
   msFree(pszGMLGeometries);
@@ -4414,10 +4433,8 @@ int msWFSGetPropertyValue(mapObj *map, w
   return status;
 }
 
-
 #endif /* USE_WFS_SVR */
 
-
 /*
 ** msWFSDispatch() is the entry point for WFS requests.
 ** - If this is a valid request then it is processed and MS_SUCCESS is returned
@@ -4426,13 +4443,13 @@ int msWFSGetPropertyValue(mapObj *map, w
 **   is returned and MapServer is expected to process this as a regular
 **   MapServer request.
 */
-int msWFSDispatch(mapObj *map, cgiRequestObj *requestobj, owsRequestObj *ows_request, int force_wfs_mode)
-{
+int msWFSDispatch(mapObj *map, cgiRequestObj *requestobj,
+                  owsRequestObj *ows_request, int force_wfs_mode) {
 #ifdef USE_WFS_SVR
   int status;
   int returnvalue = MS_DONE;
   int nWFSVersion;
-  char* validated_language;
+  char *validated_language;
 
   /* static char *wmtver = NULL, *request=NULL, *service=NULL; */
   wfsParamsObj *paramsObj;
@@ -4443,13 +4460,13 @@ int msWFSDispatch(mapObj *map, cgiReques
   /* TODO : store also parameters that are inside the map object */
   /* into the paramsObj.  */
   status = msWFSParseRequest(map, requestobj, paramsObj, force_wfs_mode);
-  if (status != MS_SUCCESS)
-  {
+  if (status != MS_SUCCESS) {
     msWFSFreeParamsObj(paramsObj);
     return status;
   }
 
-  validated_language = msOWSGetLanguageFromList(map, "FO", paramsObj->pszLanguage);
+  validated_language =
+      msOWSGetLanguageFromList(map, "FO", paramsObj->pszLanguage);
   if (validated_language != NULL) {
     msMapSetLanguageSpecificConnection(map, validated_language);
   }
@@ -4457,30 +4474,34 @@ int msWFSDispatch(mapObj *map, cgiReques
 
   if (force_wfs_mode) {
     /*request is always required*/
-    if (paramsObj->pszRequest==NULL || strlen(paramsObj->pszRequest)<=0) {
-      msSetError(MS_WFSERR,
-                 "Incomplete WFS request: REQUEST parameter missing",
+    if (paramsObj->pszRequest == NULL || strlen(paramsObj->pszRequest) <= 0) {
+      msSetError(MS_WFSERR, "Incomplete WFS request: REQUEST parameter missing",
                  "msWFSDispatch()");
-      returnvalue = msWFSException(map, "request", MS_OWS_ERROR_MISSING_PARAMETER_VALUE, paramsObj->pszVersion);
+      returnvalue =
+          msWFSException(map, "request", MS_OWS_ERROR_MISSING_PARAMETER_VALUE,
+                         paramsObj->pszVersion);
       msWFSFreeParamsObj(paramsObj);
       return returnvalue;
     }
 
     /*version:
       wfs 1.0 and 1.1.0 POST request: optional
-      wfs 1.0 and 1.1.0 GET request: optional for getcapabilities and required for describefeature and getfeature
+      wfs 1.0 and 1.1.0 GET request: optional for getcapabilities and required
+      for describefeature and getfeature
      */
-    if (paramsObj->pszVersion == NULL && requestobj && requestobj->postrequest == NULL &&
+    if (paramsObj->pszVersion == NULL && requestobj &&
+        requestobj->postrequest == NULL &&
         strcasecmp(paramsObj->pszRequest, "GetCapabilities") != 0) {
-      msSetError(MS_WFSERR,
-                 "Invalid WFS request: VERSION parameter missing",
+      msSetError(MS_WFSERR, "Invalid WFS request: VERSION parameter missing",
                  "msWFSDispatch()");
-      returnvalue = msWFSException(map, "version", MS_OWS_ERROR_MISSING_PARAMETER_VALUE, paramsObj->pszVersion);
+      returnvalue =
+          msWFSException(map, "version", MS_OWS_ERROR_MISSING_PARAMETER_VALUE,
+                         paramsObj->pszVersion);
       msWFSFreeParamsObj(paramsObj);
       return returnvalue;
     }
 
-    if (paramsObj->pszVersion == NULL || strlen(paramsObj->pszVersion) <=0)
+    if (paramsObj->pszVersion == NULL || strlen(paramsObj->pszVersion) <= 0)
       paramsObj->pszVersion = msStrdup(msWFSGetDefaultVersion(map));
 
     /*service
@@ -4489,11 +4510,13 @@ int msWFSDispatch(mapObj *map, cgiReques
       wfs 1.1.1 POST: optional
     */
     if ((paramsObj->pszService == NULL || strlen(paramsObj->pszService) == 0) &&
-        ((requestobj && requestobj->postrequest == NULL) || strcasecmp(paramsObj->pszVersion,"1.0") ==0)) {
-      msSetError(MS_WFSERR,
-                 "Invalid WFS request: Missing SERVICE parameter",
+        ((requestobj && requestobj->postrequest == NULL) ||
+         strcasecmp(paramsObj->pszVersion, "1.0") == 0)) {
+      msSetError(MS_WFSERR, "Invalid WFS request: Missing SERVICE parameter",
                  "msWFSDispatch()");
-      returnvalue = msWFSException(map, "service", MS_OWS_ERROR_MISSING_PARAMETER_VALUE, paramsObj->pszVersion);
+      returnvalue =
+          msWFSException(map, "service", MS_OWS_ERROR_MISSING_PARAMETER_VALUE,
+                         paramsObj->pszVersion);
       msWFSFreeParamsObj(paramsObj);
       return returnvalue;
     }
@@ -4501,76 +4524,88 @@ int msWFSDispatch(mapObj *map, cgiReques
     if (paramsObj->pszService == NULL || strlen(paramsObj->pszService) == 0)
       paramsObj->pszService = msStrdup("WFS");
 
-    if (paramsObj->pszService!=NULL && strcasecmp(paramsObj->pszService, "WFS") != 0) {
+    if (paramsObj->pszService != NULL &&
+        strcasecmp(paramsObj->pszService, "WFS") != 0) {
       msSetError(MS_WFSERR,
                  "Invalid WFS request: SERVICE parameter must be set to WFS",
                  "msWFSDispatch()");
-      returnvalue = msWFSException(map, "service", MS_OWS_ERROR_INVALID_PARAMETER_VALUE, paramsObj->pszVersion);
+      returnvalue =
+          msWFSException(map, "service", MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                         paramsObj->pszVersion);
       msWFSFreeParamsObj(paramsObj);
       return returnvalue;
     }
-
   }
   /* If SERVICE is specified then it MUST be "WFS" */
   if (paramsObj->pszService != NULL &&
       strcasecmp(paramsObj->pszService, "WFS") != 0) {
     msWFSFreeParamsObj(paramsObj);
-    return MS_DONE;  /* Not a WFS request */
+    return MS_DONE; /* Not a WFS request */
   }
 
   /* If SERVICE, VERSION and REQUEST not included than this isn't a WFS req*/
-  if (paramsObj->pszService == NULL && paramsObj->pszVersion==NULL &&
-      paramsObj->pszRequest==NULL) {
+  if (paramsObj->pszService == NULL && paramsObj->pszVersion == NULL &&
+      paramsObj->pszRequest == NULL) {
     msWFSFreeParamsObj(paramsObj);
-    return MS_DONE;  /* Not a WFS request */
+    return MS_DONE; /* Not a WFS request */
   }
 
   /* VERSION *and* REQUEST *and* SERVICE required by all WFS requests including
    * GetCapabilities.
    */
-  if (paramsObj->pszVersion==NULL || strlen(paramsObj->pszVersion)<=0) {
-    msSetError(MS_WFSERR,
-               "Incomplete WFS request: VERSION parameter missing",
+  if (paramsObj->pszVersion == NULL || strlen(paramsObj->pszVersion) <= 0) {
+    msSetError(MS_WFSERR, "Incomplete WFS request: VERSION parameter missing",
                "msWFSDispatch()");
 
-    returnvalue = msWFSException11(map, "version", MS_OWS_ERROR_MISSING_PARAMETER_VALUE, msWFSGetDefaultVersion(map));
+    returnvalue =
+        msWFSException11(map, "version", MS_OWS_ERROR_MISSING_PARAMETER_VALUE,
+                         msWFSGetDefaultVersion(map));
     msWFSFreeParamsObj(paramsObj);
     return returnvalue;
   }
 
-  if (paramsObj->pszRequest==NULL || strlen(paramsObj->pszRequest)<=0) {
-    msSetError(MS_WFSERR,
-               "Incomplete WFS request: REQUEST parameter missing",
+  if (paramsObj->pszRequest == NULL || strlen(paramsObj->pszRequest) <= 0) {
+    msSetError(MS_WFSERR, "Incomplete WFS request: REQUEST parameter missing",
                "msWFSDispatch()");
-    returnvalue = msWFSException(map, "request", MS_OWS_ERROR_MISSING_PARAMETER_VALUE, paramsObj->pszVersion);
+    returnvalue =
+        msWFSException(map, "request", MS_OWS_ERROR_MISSING_PARAMETER_VALUE,
+                       paramsObj->pszVersion);
     msWFSFreeParamsObj(paramsObj);
     return returnvalue;
   }
 
-  if (paramsObj->pszService==NULL || strlen(paramsObj->pszService)<=0) {
-    msSetError(MS_WFSERR,
-               "Incomplete WFS request: SERVICE parameter missing",
+  if (paramsObj->pszService == NULL || strlen(paramsObj->pszService) <= 0) {
+    msSetError(MS_WFSERR, "Incomplete WFS request: SERVICE parameter missing",
                "msWFSDispatch()");
 
-    returnvalue = msWFSException(map, "service", MS_OWS_ERROR_MISSING_PARAMETER_VALUE, paramsObj->pszVersion);
+    returnvalue =
+        msWFSException(map, "service", MS_OWS_ERROR_MISSING_PARAMETER_VALUE,
+                       paramsObj->pszVersion);
     msWFSFreeParamsObj(paramsObj);
     return returnvalue;
   }
 
   if ((status = msOWSMakeAllLayersUnique(map)) != MS_SUCCESS) {
-    msSetError(MS_WFSERR, "msOWSMakeAllLayersUnique() failed", "msWFSDispatch()");
-    returnvalue = msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE, paramsObj->pszVersion);
+    msSetError(MS_WFSERR, "msOWSMakeAllLayersUnique() failed",
+               "msWFSDispatch()");
+    returnvalue = msWFSException(
+        map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE, paramsObj->pszVersion);
     msWFSFreeParamsObj(paramsObj);
     return returnvalue;
   }
   /*
   ** Start dispatching requests
   */
-  if (strcasecmp(paramsObj->pszRequest, "GetCapabilities") == 0 ) {
+  if (strcasecmp(paramsObj->pszRequest, "GetCapabilities") == 0) {
     msOWSRequestLayersEnabled(map, "F", paramsObj->pszRequest, ows_request);
     if (ows_request->numlayers == 0) {
-      msSetError(MS_WFSERR, "WFS request not enabled. Check wfs/ows_enable_request settings.", "msWFSDispatch()");
-      returnvalue = msWFSException(map, "request", MS_OWS_ERROR_INVALID_PARAMETER_VALUE, paramsObj->pszVersion);
+      msSetError(
+          MS_WFSERR,
+          "WFS request not enabled. Check wfs/ows_enable_request settings.",
+          "msWFSDispatch()");
+      returnvalue =
+          msWFSException(map, "request", MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                         paramsObj->pszVersion);
       msWFSFreeParamsObj(paramsObj);
       return returnvalue;
     }
@@ -4587,24 +4622,29 @@ int msWFSDispatch(mapObj *map, cgiReques
   if (strcmp(paramsObj->pszVersion, "1.0.0") != 0 &&
       strcmp(paramsObj->pszVersion, "1.1.0") != 0 &&
       strcmp(paramsObj->pszVersion, "2.0.0") != 0) {
-    msSetError(MS_WFSERR,
-               "WFS Server does not support VERSION %s.",
+    msSetError(MS_WFSERR, "WFS Server does not support VERSION %s.",
                "msWFSDispatch()", paramsObj->pszVersion);
-    returnvalue = msWFSException(map, "version", MS_OWS_ERROR_INVALID_PARAMETER_VALUE,msWFSGetDefaultVersion(map));
+    returnvalue =
+        msWFSException(map, "version", MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                       msWFSGetDefaultVersion(map));
     msWFSFreeParamsObj(paramsObj);
     return returnvalue;
-
   }
-  
+
   nWFSVersion = msOWSParseVersionString(paramsObj->pszVersion);
 
-  /* Since the function can still return MS_DONE, we add an extra service check to not call
-     msOWSRequestLayersEnabled twice */
+  /* Since the function can still return MS_DONE, we add an extra service check
+     to not call msOWSRequestLayersEnabled twice */
   if (strcasecmp(paramsObj->pszService, "WFS") == 0) {
     msOWSRequestLayersEnabled(map, "F", paramsObj->pszRequest, ows_request);
     if (ows_request->numlayers == 0) {
-      msSetError(MS_WFSERR, "WFS request not enabled. Check wfs/ows_enable_request settings.", "msWFSDispatch()");
-      returnvalue = msWFSException(map, "request", MS_OWS_ERROR_INVALID_PARAMETER_VALUE, paramsObj->pszVersion);
+      msSetError(
+          MS_WFSERR,
+          "WFS request not enabled. Check wfs/ows_enable_request settings.",
+          "msWFSDispatch()");
+      returnvalue =
+          msWFSException(map, "request", MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                         paramsObj->pszVersion);
       msWFSFreeParamsObj(paramsObj);
       return returnvalue;
     }
@@ -4614,14 +4654,17 @@ int msWFSDispatch(mapObj *map, cgiReques
   /* Continue dispatching...
    */
   if (strcasecmp(paramsObj->pszRequest, "DescribeFeatureType") == 0)
-    returnvalue = msWFSDescribeFeatureType(map, paramsObj, ows_request, nWFSVersion);
+    returnvalue =
+        msWFSDescribeFeatureType(map, paramsObj, ows_request, nWFSVersion);
 
   else if (strcasecmp(paramsObj->pszRequest, "GetFeature") == 0)
-    returnvalue = msWFSGetFeature(map, paramsObj, requestobj, ows_request, nWFSVersion);
+    returnvalue =
+        msWFSGetFeature(map, paramsObj, requestobj, ows_request, nWFSVersion);
 
   else if (nWFSVersion >= OWS_2_0_0 &&
            strcasecmp(paramsObj->pszRequest, "GetPropertyValue") == 0)
-    returnvalue = msWFSGetPropertyValue(map, paramsObj, requestobj, ows_request, nWFSVersion);
+    returnvalue = msWFSGetPropertyValue(map, paramsObj, requestobj, ows_request,
+                                        nWFSVersion);
 
   else if (nWFSVersion >= OWS_2_0_0 &&
            strcasecmp(paramsObj->pszRequest, "ListStoredQueries") == 0)
@@ -4631,16 +4674,20 @@ int msWFSDispatch(mapObj *map, cgiReques
            strcasecmp(paramsObj->pszRequest, "DescribeStoredQueries") == 0)
     returnvalue = msWFSDescribeStoredQueries20(map, paramsObj, ows_request);
 
-  else if (msWFSGetIndexUnsupportedOperation(paramsObj->pszRequest) >= 0 ) {
+  else if (msWFSGetIndexUnsupportedOperation(paramsObj->pszRequest) >= 0) {
     /* Unsupported WFS request */
     msSetError(MS_WFSERR, "Unsupported WFS request: %s", "msWFSDispatch()",
                paramsObj->pszRequest);
-    returnvalue = msWFSException(map, paramsObj->pszRequest, MS_OWS_ERROR_OPERATION_NOT_SUPPORTED, paramsObj->pszVersion);
+    returnvalue = msWFSException(map, paramsObj->pszRequest,
+                                 MS_OWS_ERROR_OPERATION_NOT_SUPPORTED,
+                                 paramsObj->pszVersion);
   } else if (strcasecmp(paramsObj->pszService, "WFS") == 0) {
     /* Invalid WFS request */
     msSetError(MS_WFSERR, "Invalid WFS request: %s", "msWFSDispatch()",
                paramsObj->pszRequest);
-    returnvalue = msWFSException(map, "request", MS_OWS_ERROR_INVALID_PARAMETER_VALUE, paramsObj->pszVersion);
+    returnvalue =
+        msWFSException(map, "request", MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                       paramsObj->pszVersion);
   }
 
   /* This was not detected as a WFS request... let MapServer handle it */
@@ -4650,7 +4697,7 @@ int msWFSDispatch(mapObj *map, cgiReques
 #else
   msSetError(MS_WFSERR, "WFS server support is not available.",
              "msWFSDispatch()");
-  return(MS_FAILURE);
+  return (MS_FAILURE);
 #endif
 }
 
@@ -4660,8 +4707,7 @@ int msWFSDispatch(mapObj *map, cgiReques
 /*      Create a parameter object, initialize it.                       */
 /*      The caller should free the object using msWFSFreeParamsObj.     */
 /************************************************************************/
-wfsParamsObj *msWFSCreateParamsObj()
-{
+wfsParamsObj *msWFSCreateParamsObj() {
   wfsParamsObj *paramsObj = (wfsParamsObj *)calloc(1, sizeof(wfsParamsObj));
   MS_CHECK_ALLOC(paramsObj, sizeof(wfsParamsObj), NULL);
 
@@ -4671,15 +4717,12 @@ wfsParamsObj *msWFSCreateParamsObj()
   return paramsObj;
 }
 
-
-
 /************************************************************************/
 /*                            msWFSFreeParmsObj                         */
 /*                                                                      */
 /*      Free params object.                                             */
 /************************************************************************/
-void msWFSFreeParamsObj(wfsParamsObj *wfsparams)
-{
+void msWFSFreeParamsObj(wfsParamsObj *wfsparams) {
   if (wfsparams) {
     free(wfsparams->pszVersion);
     free(wfsparams->pszUpdateSequence);
@@ -4710,24 +4753,21 @@ void msWFSFreeParamsObj(wfsParamsObj *wf
 /************************************************************************/
 /*                       msWFSGetDefaultVersion                         */
 /************************************************************************/
-static
-const char *msWFSGetDefaultVersion(mapObj *map)
-{
-  const char* pszVersion =
-    msOWSLookupMetadata(&(map->web.metadata), "F", "getcapabilities_version");
-  if( pszVersion != NULL )
-  {
-      /* Check that the metadata value is one of the recognized versions */
-      int iVersion = msOWSParseVersionString(pszVersion);
-      int i;
-      for( i = 0; i < wfsNumSupportedVersions; i ++ )
-      {
-          if( iVersion == wfsSupportedVersions[i] )
-              return wfsSupportedVersionsStr[i];
-      }
-      /* If not, use the default (= latest) version */
-      msDebug("msWFSGetDefaultVersion(): invalid value for "
-              "wfs_getcapabilities_version: %s\n", pszVersion);
+static const char *msWFSGetDefaultVersion(mapObj *map) {
+  const char *pszVersion =
+      msOWSLookupMetadata(&(map->web.metadata), "F", "getcapabilities_version");
+  if (pszVersion != NULL) {
+    /* Check that the metadata value is one of the recognized versions */
+    int iVersion = msOWSParseVersionString(pszVersion);
+    int i;
+    for (i = 0; i < wfsNumSupportedVersions; i++) {
+      if (iVersion == wfsSupportedVersions[i])
+        return wfsSupportedVersionsStr[i];
+    }
+    /* If not, use the default (= latest) version */
+    msDebug("msWFSGetDefaultVersion(): invalid value for "
+            "wfs_getcapabilities_version: %s\n",
+            pszVersion);
   }
   return WFS_LATEST_VERSION;
 }
@@ -4735,374 +4775,356 @@ const char *msWFSGetDefaultVersion(mapOb
 /************************************************************************/
 /*                             msWFSSetParam                            */
 /************************************************************************/
-static int msWFSSetParam(char** ppszOut, cgiRequestObj *request, int i,
-                         const char* pszExpectedParamName)
-{
-    if( strcasecmp(request->ParamNames[i], pszExpectedParamName) == 0 )
-    {
-        if( *ppszOut == NULL )
-            *ppszOut = msStrdup(request->ParamValues[i]);
-        return 1;
-    }
-    return 0;
+static int msWFSSetParam(char **ppszOut, cgiRequestObj *request, int i,
+                         const char *pszExpectedParamName) {
+  if (strcasecmp(request->ParamNames[i], pszExpectedParamName) == 0) {
+    if (*ppszOut == NULL)
+      *ppszOut = msStrdup(request->ParamValues[i]);
+    return 1;
+  }
+  return 0;
 }
 
 /************************************************************************/
 /*                         msWFSParseXMLQueryNode                       */
 /************************************************************************/
 
-static void msWFSParseXMLQueryNode(CPLXMLNode* psQuery, wfsParamsObj *wfsparams)
-{
-    const char* pszTypename;
-    const char* pszValue;
-    char *pszSerializedFilter, *pszTmp, *pszTmp2;
-    CPLXMLNode* psPropertyName;
-    CPLXMLNode* psFilter;
-    CPLXMLNode* psSortBy;
-    char* pszSortBy = NULL;
-
-    pszValue = CPLGetXMLValue(psQuery,  "srsName",
-                                NULL);
-    if (pszValue)
-    {
-        msFree(wfsparams->pszSrs);
-        wfsparams->pszSrs = msStrdup(pszValue);
+static void msWFSParseXMLQueryNode(CPLXMLNode *psQuery,
+                                   wfsParamsObj *wfsparams) {
+  const char *pszTypename;
+  const char *pszValue;
+  char *pszSerializedFilter, *pszTmp, *pszTmp2;
+  CPLXMLNode *psPropertyName;
+  CPLXMLNode *psFilter;
+  CPLXMLNode *psSortBy;
+  char *pszSortBy = NULL;
+
+  pszValue = CPLGetXMLValue(psQuery, "srsName", NULL);
+  if (pszValue) {
+    msFree(wfsparams->pszSrs);
+    wfsparams->pszSrs = msStrdup(pszValue);
+  }
+
+  /* parse typenames */
+  pszTypename = CPLGetXMLValue(psQuery, "typename", NULL);
+  if (pszTypename == NULL) /* WFS 2.0 */
+    pszTypename = CPLGetXMLValue(psQuery, "typeNames", NULL);
+
+  /*parse property name*/
+  psPropertyName = CPLGetXMLNode(psQuery, "PropertyName");
+  pszTmp2 = NULL;
+
+  /*when there is no PropertyName, we output (!) so that it is parsed properly
+   * in GetFeature*/
+  if (psPropertyName == NULL)
+    pszTmp2 = msStrdup("!");
+
+  while (psPropertyName) {
+    if (!psPropertyName->pszValue ||
+        strcasecmp(psPropertyName->pszValue, "PropertyName") != 0) {
+      psPropertyName = psPropertyName->psNext;
+      continue;
     }
-
-    /* parse typenames */
-    pszTypename = CPLGetXMLValue(psQuery,
-                                "typename", NULL);
-    if( pszTypename == NULL ) /* WFS 2.0 */
-        pszTypename = CPLGetXMLValue(psQuery,
-                                "typeNames", NULL);
-
-    /*parse property name*/
-    psPropertyName = CPLGetXMLNode(psQuery, "PropertyName");
-    pszTmp2= NULL;
-
-    /*when there is no PropertyName, we output (!) so that it is parsed properly in GetFeature*/
-    if (psPropertyName == NULL)
-        pszTmp2 = msStrdup("!");
-
-    while (psPropertyName) {
-        if (!psPropertyName->pszValue ||
-            strcasecmp(psPropertyName->pszValue, "PropertyName") != 0) {
-            psPropertyName = psPropertyName->psNext;
-        continue;
-        }
-        pszValue = CPLGetXMLValue(psPropertyName, NULL, NULL);
-        if (pszTmp2 == NULL) {
-            pszTmp2 = msStrdup(pszValue);
-        } else {
-            pszTmp = msStrdup(pszTmp2);
-            pszTmp2 = (char *)msSmallRealloc(pszTmp2, sizeof(char)* (strlen(pszTmp)+ strlen(pszValue)+2));
-            sprintf(pszTmp2,"%s,%s",pszTmp, pszValue);
-            msFree(pszTmp);
-        }
-        psPropertyName = psPropertyName->psNext;
-    }
-    if (pszTmp2) {
-        pszTmp = msStrdup(pszTmp2);
-        pszTmp2 = (char *)msSmallRealloc(pszTmp2, sizeof(char)* (strlen(pszTmp)+ 3));
-        sprintf(pszTmp2,"(%s)", pszTmp);
-        msFree(pszTmp);
-
-        msWFSBuildParamList(&(wfsparams->pszPropertyName), pszTmp2, "");
-        msFree(pszTmp2);
-        pszTmp2 = NULL;
-    }
-
-    /* parse filter */
-    psFilter = CPLGetXMLNode(psQuery, "Filter");
-
-    if (psFilter == NULL) {
-        /*when there is no Filter, we output (!) so that it is parsed properly in GetFeature*/
-        pszSerializedFilter = msStrdup("(!)");
+    pszValue = CPLGetXMLValue(psPropertyName, NULL, NULL);
+    if (pszTmp2 == NULL) {
+      pszTmp2 = msStrdup(pszValue);
     } else {
-        char* pszCPLTmp = CPLSerializeXMLTree(psFilter);
-        pszSerializedFilter = (char *)msSmallMalloc(sizeof(char)*
-                                        (strlen(pszCPLTmp)+3));
-        sprintf(pszSerializedFilter, "(%s)", pszCPLTmp);
-        CPLFree(pszCPLTmp);
-    }
-
-    msWFSBuildParamList(&(wfsparams->pszFilter), pszSerializedFilter, "");
-    free(pszSerializedFilter);
-
-    /* parse SortBy */
-    psSortBy = CPLGetXMLNode(psQuery, "SortBy");
-    if( psSortBy != NULL )
-    {
-        int bFirstProperty = MS_TRUE;
-        CPLXMLNode* psIter = psSortBy->psChild;
-
-        pszSortBy = msStringConcatenate(pszSortBy, "(");
-
-        while( psIter != NULL )
-        {
-            if( psIter->eType == CXT_Element &&
-                strcmp(psIter->pszValue, "SortProperty") == 0 )
-            {
-                const char* pszPropertyName = CPLGetXMLValue(psIter, "PropertyName", NULL);
-                if( pszPropertyName == NULL )
-                    pszPropertyName = CPLGetXMLValue(psIter, "ValueReference", NULL);
-                if( pszPropertyName != NULL )
-                {
-                    const char* pszSortOrder = CPLGetXMLValue(psIter, "SortOrder", NULL);
-                    if( !bFirstProperty )
-                        pszSortBy = msStringConcatenate(pszSortBy, ",");
-                    bFirstProperty = MS_FALSE;
-
-                    pszSortBy = msStringConcatenate(pszSortBy, pszPropertyName);
-                    if( pszSortOrder != NULL )
-                    {
-                        pszSortBy = msStringConcatenate(pszSortBy, " ");
-                        pszSortBy = msStringConcatenate(pszSortBy, pszSortOrder);
-                    }
-                }
-            }
-            psIter = psIter->psNext;
+      pszTmp = msStrdup(pszTmp2);
+      pszTmp2 = (char *)msSmallRealloc(
+          pszTmp2, sizeof(char) * (strlen(pszTmp) + strlen(pszValue) + 2));
+      sprintf(pszTmp2, "%s,%s", pszTmp, pszValue);
+      msFree(pszTmp);
+    }
+    psPropertyName = psPropertyName->psNext;
+  }
+  if (pszTmp2) {
+    pszTmp = msStrdup(pszTmp2);
+    pszTmp2 =
+        (char *)msSmallRealloc(pszTmp2, sizeof(char) * (strlen(pszTmp) + 3));
+    sprintf(pszTmp2, "(%s)", pszTmp);
+    msFree(pszTmp);
+
+    msWFSBuildParamList(&(wfsparams->pszPropertyName), pszTmp2, "");
+    msFree(pszTmp2);
+    pszTmp2 = NULL;
+  }
+
+  /* parse filter */
+  psFilter = CPLGetXMLNode(psQuery, "Filter");
+
+  if (psFilter == NULL) {
+    /*when there is no Filter, we output (!) so that it is parsed properly in
+     * GetFeature*/
+    pszSerializedFilter = msStrdup("(!)");
+  } else {
+    char *pszCPLTmp = CPLSerializeXMLTree(psFilter);
+    pszSerializedFilter =
+        (char *)msSmallMalloc(sizeof(char) * (strlen(pszCPLTmp) + 3));
+    sprintf(pszSerializedFilter, "(%s)", pszCPLTmp);
+    CPLFree(pszCPLTmp);
+  }
+
+  msWFSBuildParamList(&(wfsparams->pszFilter), pszSerializedFilter, "");
+  free(pszSerializedFilter);
+
+  /* parse SortBy */
+  psSortBy = CPLGetXMLNode(psQuery, "SortBy");
+  if (psSortBy != NULL) {
+    int bFirstProperty = MS_TRUE;
+    CPLXMLNode *psIter = psSortBy->psChild;
+
+    pszSortBy = msStringConcatenate(pszSortBy, "(");
+
+    while (psIter != NULL) {
+      if (psIter->eType == CXT_Element &&
+          strcmp(psIter->pszValue, "SortProperty") == 0) {
+        const char *pszPropertyName =
+            CPLGetXMLValue(psIter, "PropertyName", NULL);
+        if (pszPropertyName == NULL)
+          pszPropertyName = CPLGetXMLValue(psIter, "ValueReference", NULL);
+        if (pszPropertyName != NULL) {
+          const char *pszSortOrder = CPLGetXMLValue(psIter, "SortOrder", NULL);
+          if (!bFirstProperty)
+            pszSortBy = msStringConcatenate(pszSortBy, ",");
+          bFirstProperty = MS_FALSE;
+
+          pszSortBy = msStringConcatenate(pszSortBy, pszPropertyName);
+          if (pszSortOrder != NULL) {
+            pszSortBy = msStringConcatenate(pszSortBy, " ");
+            pszSortBy = msStringConcatenate(pszSortBy, pszSortOrder);
+          }
         }
-
-        pszSortBy = msStringConcatenate(pszSortBy, ")");
-    }
-    else
-    {
-        pszSortBy = msStrdup("(!)");
+      }
+      psIter = psIter->psNext;
     }
 
-    msWFSBuildParamList(&(wfsparams->pszSortBy), pszSortBy, "");
-    free(pszSortBy);
+    pszSortBy = msStringConcatenate(pszSortBy, ")");
+  } else {
+    pszSortBy = msStrdup("(!)");
+  }
 
-    /* Special case for "urn:ogc:def:query:OGC-WFS::GetFeatureById" */
-    /* Resolve the property typename */
-    if( pszTypename != NULL && strcmp(pszTypename, "?") == 0 && psFilter != NULL )
-    {
-        const char* rid;
-        rid = CPLGetXMLValue(psFilter, "ResourceId.rid", NULL);
-        if( rid != NULL )
-        {
-            char* pszTmpTypename = msStrdup(rid);
-            char* pszDot = strchr(pszTmpTypename, '.');
-            if( pszDot )
-            {
-                *pszDot = '\0';
-                msWFSBuildParamList(&(wfsparams->pszTypeName), pszTmpTypename, ",");
-                pszTypename = NULL;
+  msWFSBuildParamList(&(wfsparams->pszSortBy), pszSortBy, "");
+  free(pszSortBy);
 
-                if( wfsparams->countGetFeatureById >= 0 )
-                    wfsparams->countGetFeatureById ++;
-            }
-            else
-                wfsparams->countGetFeatureById = -1;
-            msFree(pszTmpTypename);
-        }
-        else
-            wfsparams->countGetFeatureById = -1;
-    }
-    else
-        wfsparams->countGetFeatureById = -1;
+  /* Special case for "urn:ogc:def:query:OGC-WFS::GetFeatureById" */
+  /* Resolve the property typename */
+  if (pszTypename != NULL && strcmp(pszTypename, "?") == 0 &&
+      psFilter != NULL) {
+    const char *rid;
+    rid = CPLGetXMLValue(psFilter, "ResourceId.rid", NULL);
+    if (rid != NULL) {
+      char *pszTmpTypename = msStrdup(rid);
+      char *pszDot = strchr(pszTmpTypename, '.');
+      if (pszDot) {
+        *pszDot = '\0';
+        msWFSBuildParamList(&(wfsparams->pszTypeName), pszTmpTypename, ",");
+        pszTypename = NULL;
 
-    if (pszTypename) {
-        msWFSBuildParamList(&(wfsparams->pszTypeName), pszTypename, ",");
-    }
+        if (wfsparams->countGetFeatureById >= 0)
+          wfsparams->countGetFeatureById++;
+      } else
+        wfsparams->countGetFeatureById = -1;
+      msFree(pszTmpTypename);
+    } else
+      wfsparams->countGetFeatureById = -1;
+  } else
+    wfsparams->countGetFeatureById = -1;
 
+  if (pszTypename) {
+    msWFSBuildParamList(&(wfsparams->pszTypeName), pszTypename, ",");
+  }
 }
 
 /************************************************************************/
 /*                     msWFSAnalyzeStoredQuery                          */
 /************************************************************************/
 
-static int msWFSAnalyzeStoredQuery(mapObj* map,
-                                   wfsParamsObj *wfsparams,
-                                   const char* id,
-                                   const char* pszResolvedQuery)
-{
-    CPLXMLNode* psRoot;
-    CPLXMLNode* psQuery;
-    CPLXMLNode* psIter;
+static int msWFSAnalyzeStoredQuery(mapObj *map, wfsParamsObj *wfsparams,
+                                   const char *id,
+                                   const char *pszResolvedQuery) {
+  CPLXMLNode *psRoot;
+  CPLXMLNode *psQuery;
+  CPLXMLNode *psIter;
 
-    psRoot = CPLParseXMLString(pszResolvedQuery);
+  psRoot = CPLParseXMLString(pszResolvedQuery);
 
-    if( psRoot == NULL )
-    {
-        msSetError(MS_WFSERR, "Resolved definition for stored query '%s' is invalid", "msWFSParseRequest()", id);
-        msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE, wfsparams->pszVersion);
-        return MS_FAILURE;
-    }
+  if (psRoot == NULL) {
+    msSetError(MS_WFSERR,
+               "Resolved definition for stored query '%s' is invalid",
+               "msWFSParseRequest()", id);
+    msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE,
+                   wfsparams->pszVersion);
+    return MS_FAILURE;
+  }
 
-    CPLStripXMLNamespace(psRoot, NULL, 1);
-    psQuery = CPLGetXMLNode(psRoot, "=StoredQueryDescription.QueryExpressionText.Query");
-    if( psQuery == NULL )
-    {
-        msSetError(MS_WFSERR, "Resolved definition for stored query '%s' is invalid", "msWFSParseRequest()", id);
-        msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE, wfsparams->pszVersion);
-        CPLDestroyXMLNode(psRoot);
-        return MS_FAILURE;
-    }
+  CPLStripXMLNamespace(psRoot, NULL, 1);
+  psQuery = CPLGetXMLNode(psRoot,
+                          "=StoredQueryDescription.QueryExpressionText.Query");
+  if (psQuery == NULL) {
+    msSetError(MS_WFSERR,
+               "Resolved definition for stored query '%s' is invalid",
+               "msWFSParseRequest()", id);
+    msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE,
+                   wfsparams->pszVersion);
+    CPLDestroyXMLNode(psRoot);
+    return MS_FAILURE;
+  }
 
-    psIter = psQuery;
-    while( psIter != NULL )
-    {
-        if( psIter->eType == CXT_Element && strcmp(psIter->pszValue, "Query") == 0 ) {
-            msWFSParseXMLQueryNode(psIter, wfsparams);
-        }
-        psIter = psIter->psNext;
+  psIter = psQuery;
+  while (psIter != NULL) {
+    if (psIter->eType == CXT_Element &&
+        strcmp(psIter->pszValue, "Query") == 0) {
+      msWFSParseXMLQueryNode(psIter, wfsparams);
     }
+    psIter = psIter->psNext;
+  }
 
-    CPLDestroyXMLNode(psRoot);
+  CPLDestroyXMLNode(psRoot);
 
-    return MS_SUCCESS;
+  return MS_SUCCESS;
 }
 
 /************************************************************************/
 /*                     msWFSParseXMLStoredQueryNode                     */
 /************************************************************************/
 
-static int msWFSParseXMLStoredQueryNode(mapObj* map,
-                                        wfsParamsObj *wfsparams,
-                                        CPLXMLNode* psQuery)
-{
-    const char* id;
-    CPLXMLNode* psIter;
-    hashTableObj * hashTable;
-    char* pszResolvedQuery;
-    int status;
+static int msWFSParseXMLStoredQueryNode(mapObj *map, wfsParamsObj *wfsparams,
+                                        CPLXMLNode *psQuery) {
+  const char *id;
+  CPLXMLNode *psIter;
+  hashTableObj *hashTable;
+  char *pszResolvedQuery;
+  int status;
 
-    id = CPLGetXMLValue(psQuery, "id", NULL);
-    if( id == NULL )
-    {
-        msSetError(MS_WFSERR, "Missing 'id' attribute in StoredQuery", "msWFSParseRequest()");
-        return msWFSException(map, "id", MS_OWS_ERROR_MISSING_PARAMETER_VALUE, wfsparams->pszVersion);
-    }
+  id = CPLGetXMLValue(psQuery, "id", NULL);
+  if (id == NULL) {
+    msSetError(MS_WFSERR, "Missing 'id' attribute in StoredQuery",
+               "msWFSParseRequest()");
+    return msWFSException(map, "id", MS_OWS_ERROR_MISSING_PARAMETER_VALUE,
+                          wfsparams->pszVersion);
+  }
+
+  hashTable = msCreateHashTable();
+  psIter = psQuery->psChild;
+  while (psIter != NULL) {
+    if (psIter->eType == CXT_Element &&
+        strcmp(psIter->pszValue, "Parameter") == 0) {
+      const char *name;
+      CPLXMLNode *psIter2;
+      char *pszValue;
 
-    hashTable = msCreateHashTable();
-    psIter = psQuery->psChild;
-    while(psIter != NULL)
-    {
-        if( psIter->eType == CXT_Element &&
-            strcmp(psIter->pszValue, "Parameter") == 0 )
-        {
-            const char* name;
-            CPLXMLNode* psIter2;
-            char* pszValue;
-
-            name = CPLGetXMLValue(psIter, "name", NULL);
-            if( name == NULL )
-            {
-                msSetError(MS_WFSERR, "Missing 'name' attribute in Parameter of StoredQuery", "msWFSParseRequest()");
-                msFreeHashTable(hashTable);
-                return msWFSException(map,  NULL, MS_OWS_ERROR_INVALID_PARAMETER_VALUE, wfsparams->pszVersion);
-            }
+      name = CPLGetXMLValue(psIter, "name", NULL);
+      if (name == NULL) {
+        msSetError(MS_WFSERR,
+                   "Missing 'name' attribute in Parameter of StoredQuery",
+                   "msWFSParseRequest()");
+        msFreeHashTable(hashTable);
+        return msWFSException(map, NULL, MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                              wfsparams->pszVersion);
+      }
 
-            psIter2 = psIter->psChild;
-            while( psIter2 != NULL )
-            {
-                if( psIter2->eType != CXT_Attribute )
-                    break;
-                psIter2 = psIter2->psNext;
-            }
+      psIter2 = psIter->psChild;
+      while (psIter2 != NULL) {
+        if (psIter2->eType != CXT_Attribute)
+          break;
+        psIter2 = psIter2->psNext;
+      }
 
-            pszValue = CPLSerializeXMLTree(psIter2);
-            msInsertHashTable(hashTable, name, pszValue);
-            CPLFree(pszValue);
-        }
-        psIter = psIter->psNext;
+      pszValue = CPLSerializeXMLTree(psIter2);
+      msInsertHashTable(hashTable, name, pszValue);
+      CPLFree(pszValue);
     }
+    psIter = psIter->psNext;
+  }
 
-    pszResolvedQuery = msWFSGetResolvedStoredQuery20(map, wfsparams, id, hashTable);
-    msFreeHashTable(hashTable);
-    if( pszResolvedQuery == NULL)
-        return MS_FAILURE;
+  pszResolvedQuery =
+      msWFSGetResolvedStoredQuery20(map, wfsparams, id, hashTable);
+  msFreeHashTable(hashTable);
+  if (pszResolvedQuery == NULL)
+    return MS_FAILURE;
 
-    status = msWFSAnalyzeStoredQuery(map, wfsparams, id, pszResolvedQuery);
+  status = msWFSAnalyzeStoredQuery(map, wfsparams, id, pszResolvedQuery);
 
-    msFree(pszResolvedQuery);
+  msFree(pszResolvedQuery);
 
-    return status;
+  return status;
 }
 
 /************************************************************************/
 /*                    msWFSSimplifyPropertyNameAndFilter                */
 /************************************************************************/
 
-static void msWFSSimplifyPropertyNameAndFilter(wfsParamsObj *wfsparams)
-{
-    int i;
+static void msWFSSimplifyPropertyNameAndFilter(wfsParamsObj *wfsparams) {
+  int i;
 
-    /* If no PropertyName at all was specified, then clear the field */
-    /* that will be easier to generate valid 'next' and 'previous' uri */
-    /* for WFS 2.0 GetFeature */
-    if( wfsparams->pszPropertyName != NULL )
-    {
-        i = 0;
-        while( strncmp(wfsparams->pszPropertyName + i, "(!)", 3) == 0 )
-            i += 3;
-        if( wfsparams->pszPropertyName[i] == '\0' )
-        {
-            msFree(wfsparams->pszPropertyName);
-            wfsparams->pszPropertyName = NULL;
-        }
+  /* If no PropertyName at all was specified, then clear the field */
+  /* that will be easier to generate valid 'next' and 'previous' uri */
+  /* for WFS 2.0 GetFeature */
+  if (wfsparams->pszPropertyName != NULL) {
+    i = 0;
+    while (strncmp(wfsparams->pszPropertyName + i, "(!)", 3) == 0)
+      i += 3;
+    if (wfsparams->pszPropertyName[i] == '\0') {
+      msFree(wfsparams->pszPropertyName);
+      wfsparams->pszPropertyName = NULL;
     }
+  }
 
-    /* Same with filter */
-    if( wfsparams->pszFilter != NULL )
-    {
-        i = 0;
-        while( strncmp(wfsparams->pszFilter + i, "(!)", 3) == 0 )
-            i += 3;
-        if( wfsparams->pszFilter[i] == '\0' )
-        {
-            msFree(wfsparams->pszFilter);
-            wfsparams->pszFilter = NULL;
-        }
+  /* Same with filter */
+  if (wfsparams->pszFilter != NULL) {
+    i = 0;
+    while (strncmp(wfsparams->pszFilter + i, "(!)", 3) == 0)
+      i += 3;
+    if (wfsparams->pszFilter[i] == '\0') {
+      msFree(wfsparams->pszFilter);
+      wfsparams->pszFilter = NULL;
     }
+  }
 
-    /* Same with SortBy */
-    if( wfsparams->pszSortBy != NULL )
-    {
-        i = 0;
-        while( strncmp(wfsparams->pszSortBy + i, "(!)", 3) == 0 )
-            i += 3;
-        if( wfsparams->pszSortBy[i] == '\0' )
-        {
-            msFree(wfsparams->pszSortBy);
-            wfsparams->pszSortBy = NULL;
-        }
+  /* Same with SortBy */
+  if (wfsparams->pszSortBy != NULL) {
+    i = 0;
+    while (strncmp(wfsparams->pszSortBy + i, "(!)", 3) == 0)
+      i += 3;
+    if (wfsparams->pszSortBy[i] == '\0') {
+      msFree(wfsparams->pszSortBy);
+      wfsparams->pszSortBy = NULL;
     }
+  }
 }
 
 #endif /* USE_WFS_SVR */
 
-
 /************************************************************************/
 /*                            msWFSParseRequest                         */
 /*                                                                      */
 /*      Parse request into the params object.                           */
 /************************************************************************/
 int msWFSParseRequest(mapObj *map, cgiRequestObj *request,
-                      wfsParamsObj *wfsparams, int force_wfs_mode)
-{
+                      wfsParamsObj *wfsparams, int force_wfs_mode) {
 #ifdef USE_WFS_SVR
   int i = 0;
 
   if (!request || !wfsparams)
     return msWFSException(map, "request", "InvalidRequest", NULL);
 
-  if (request->NumParams > 0 && request->postrequest == NULL ) {
-    for(i=0; i<request->NumParams; i++) {
+  if (request->NumParams > 0 && request->postrequest == NULL) {
+    for (i = 0; i < request->NumParams; i++) {
       if (request->ParamNames[i] && request->ParamValues[i]) {
-        if( msWFSSetParam(&(wfsparams->pszVersion), request, i, "VERSION") )
-        {}
+        if (msWFSSetParam(&(wfsparams->pszVersion), request, i, "VERSION")) {
+        }
 
-        else if( msWFSSetParam(&(wfsparams->pszUpdateSequence), request, i, "UPDATESEQUENCE") )
-        {}
+        else if (msWFSSetParam(&(wfsparams->pszUpdateSequence), request, i,
+                               "UPDATESEQUENCE")) {
+        }
 
-        else if( msWFSSetParam(&(wfsparams->pszRequest), request, i, "REQUEST") )
-        {}
+        else if (msWFSSetParam(&(wfsparams->pszRequest), request, i,
+                               "REQUEST")) {
+        }
 
-        else if( msWFSSetParam(&(wfsparams->pszService), request, i, "SERVICE") )
-        {}
+        else if (msWFSSetParam(&(wfsparams->pszService), request, i,
+                               "SERVICE")) {
+        }
 
         else if (strcasecmp(request->ParamNames[i], "MAXFEATURES") == 0)
           wfsparams->nMaxFeatures = atoi(request->ParamValues[i]);
@@ -5114,66 +5136,78 @@ int msWFSParseRequest(mapObj *map, cgiRe
         else if (strcasecmp(request->ParamNames[i], "STARTINDEX") == 0)
           wfsparams->nStartIndex = atoi(request->ParamValues[i]);
 
-        else if( msWFSSetParam(&(wfsparams->pszBbox), request, i, "BBOX") )
-        {}
+        else if (msWFSSetParam(&(wfsparams->pszBbox), request, i, "BBOX")) {
+        }
 
-        else if( msWFSSetParam(&(wfsparams->pszSrs), request, i, "SRSNAME") )
-        {}
+        else if (msWFSSetParam(&(wfsparams->pszSrs), request, i, "SRSNAME")) {
+        }
 
-        else if( msWFSSetParam(&(wfsparams->pszResultType), request, i, "RESULTTYPE") )
-        {}
+        else if (msWFSSetParam(&(wfsparams->pszResultType), request, i,
+                               "RESULTTYPE")) {
+        }
 
-        else if( msWFSSetParam(&(wfsparams->pszTypeName), request, i, "TYPENAME") )
-        {}
+        else if (msWFSSetParam(&(wfsparams->pszTypeName), request, i,
+                               "TYPENAME")) {
+        }
 
         /* WFS 2.0 */
-        else if( msWFSSetParam(&(wfsparams->pszTypeName), request, i, "TYPENAMES") )
-        {}
+        else if (msWFSSetParam(&(wfsparams->pszTypeName), request, i,
+                               "TYPENAMES")) {
+        }
 
-        else if( msWFSSetParam(&(wfsparams->pszFilter), request, i, "FILTER") )
-        {}
+        else if (msWFSSetParam(&(wfsparams->pszFilter), request, i, "FILTER")) {
+        }
 
         /* WFS 2.0 */
-        else if( msWFSSetParam(&(wfsparams->pszFilterLanguage), request, i, "FILTER_LANGUAGE") )
-        {}
+        else if (msWFSSetParam(&(wfsparams->pszFilterLanguage), request, i,
+                               "FILTER_LANGUAGE")) {
+        }
 
-        else if( msWFSSetParam(&(wfsparams->pszOutputFormat), request, i, "OUTPUTFORMAT") )
-        {}
+        else if (msWFSSetParam(&(wfsparams->pszOutputFormat), request, i,
+                               "OUTPUTFORMAT")) {
+        }
 
-        else if( msWFSSetParam(&(wfsparams->pszFeatureId), request, i, "FEATUREID") )
-        {}
+        else if (msWFSSetParam(&(wfsparams->pszFeatureId), request, i,
+                               "FEATUREID")) {
+        }
 
         /* WFS 2.0 */
-        else if( msWFSSetParam(&(wfsparams->pszFeatureId), request, i, "RESOURCEID") )
-        {}
+        else if (msWFSSetParam(&(wfsparams->pszFeatureId), request, i,
+                               "RESOURCEID")) {
+        }
 
-        else if( msWFSSetParam(&(wfsparams->pszPropertyName), request, i, "PROPERTYNAME") )
-        {}
+        else if (msWFSSetParam(&(wfsparams->pszPropertyName), request, i,
+                               "PROPERTYNAME")) {
+        }
 
-        else if( msWFSSetParam(&(wfsparams->pszAcceptVersions), request, i, "ACCEPTVERSIONS") )
-        {}
+        else if (msWFSSetParam(&(wfsparams->pszAcceptVersions), request, i,
+                               "ACCEPTVERSIONS")) {
+        }
 
-        else if( msWFSSetParam(&(wfsparams->pszSections), request, i, "SECTIONS") )
-        {}
+        else if (msWFSSetParam(&(wfsparams->pszSections), request, i,
+                               "SECTIONS")) {
+        }
 
-        else if( msWFSSetParam(&(wfsparams->pszSortBy), request, i, "SORTBY") )
-        {}
+        else if (msWFSSetParam(&(wfsparams->pszSortBy), request, i, "SORTBY")) {
+        }
 
-        else if( msWFSSetParam(&(wfsparams->pszLanguage), request, i, "LANGUAGE") )
-        {}
+        else if (msWFSSetParam(&(wfsparams->pszLanguage), request, i,
+                               "LANGUAGE")) {
+        }
 
-        else if( msWFSSetParam(&(wfsparams->pszValueReference), request, i, "VALUEREFERENCE") )
-        {}
+        else if (msWFSSetParam(&(wfsparams->pszValueReference), request, i,
+                               "VALUEREFERENCE")) {
+        }
 
-        else if( msWFSSetParam(&(wfsparams->pszStoredQueryId), request, i, "STOREDQUERY_ID") )
-        {}
+        else if (msWFSSetParam(&(wfsparams->pszStoredQueryId), request, i,
+                               "STOREDQUERY_ID")) {
+        }
       }
     }
     /* version is optional is the GetCapabilities. If not */
     /* provided, set it. Default it to latest implemented version */
     /* or to the specified one in wfs_getcapabilities_version */
-    if (wfsparams->pszVersion == NULL &&
-        wfsparams->pszRequest &&
+    if (wfsparams->pszVersion == NULL && wfsparams->pszRequest &&
         strcasecmp(wfsparams->pszRequest, "GetCapabilities") == 0) {
       wfsparams->pszVersion = msStrdup(msWFSGetDefaultVersion(map));
     }
@@ -5196,44 +5230,47 @@ int msWFSParseRequest(mapObj *map, cgiRe
     char *pszSchemaLocation = NULL;
 
     psRoot = CPLParseXMLString(request->postrequest);
-    if(map->debug == MS_DEBUGLEVEL_VVV) {
-      msDebug("msWFSParseRequest(): WFS post request: %s\n", request->postrequest);
+    if (map->debug == MS_DEBUGLEVEL_VVV) {
+      msDebug("msWFSParseRequest(): WFS post request: %s\n",
+              request->postrequest);
     }
     if (psRoot) {
       /* need to strip namespaces */
       CPLStripXMLNamespace(psRoot, NULL, 1);
 
-      for( psOperation = psRoot;
-           psOperation != NULL;
-           psOperation = psOperation->psNext ) {
-        if(psOperation->eType == CXT_Element) {
+      for (psOperation = psRoot; psOperation != NULL;
+           psOperation = psOperation->psNext) {
+        if (psOperation->eType == CXT_Element) {
 
-          /* keep schemaLocation so as to be able to validate against appropriate */
+          /* keep schemaLocation so as to be able to validate against
+           * appropriate */
           /* wfs.xsd schema afterwards */
-          if( pszSchemaLocation == NULL &&
-              CPLGetXMLValue(psOperation, "schemaLocation", NULL) != NULL )
-             pszSchemaLocation = msStrdup( CPLGetXMLValue(psOperation, "schemaLocation", NULL) );
+          if (pszSchemaLocation == NULL &&
+              CPLGetXMLValue(psOperation, "schemaLocation", NULL) != NULL)
+            pszSchemaLocation =
+                msStrdup(CPLGetXMLValue(psOperation, "schemaLocation", NULL));
 
-          if(strcasecmp(psOperation->pszValue,"GetFeature")==0) {
+          if (strcasecmp(psOperation->pszValue, "GetFeature") == 0) {
             psGetFeature = psOperation;
             break;
-          } else if(strcasecmp(psOperation->pszValue,"GetCapabilities")==0) {
+          } else if (strcasecmp(psOperation->pszValue, "GetCapabilities") ==
+                     0) {
             psGetCapabilities = psOperation;
             break;
-          } else if(strcasecmp(psOperation->pszValue,
-                               "DescribeFeatureType")==0) {
+          } else if (strcasecmp(psOperation->pszValue, "DescribeFeatureType") ==
+                     0) {
             psDescribeFeature = psOperation;
             break;
-          } else if(strcasecmp(psOperation->pszValue,
-                               "GetPropertyValue")==0) {
+          } else if (strcasecmp(psOperation->pszValue, "GetPropertyValue") ==
+                     0) {
             psGetPropertyValue = psOperation;
             break;
-          } else if(strcasecmp(psOperation->pszValue,
-                               "ListStoredQueries")==0) {
+          } else if (strcasecmp(psOperation->pszValue, "ListStoredQueries") ==
+                     0) {
             psListStoredQueries = psOperation;
             break;
-          } else if(strcasecmp(psOperation->pszValue,
-                               "DescribeStoredQueries")==0) {
+          } else if (strcasecmp(psOperation->pszValue,
+                                "DescribeStoredQueries") == 0) {
             psDescribeStoredQueries = psOperation;
             break;
           }
@@ -5241,7 +5278,7 @@ int msWFSParseRequest(mapObj *map, cgiRe
           /* request value and return; */
           else {
             int idx = msWFSGetIndexUnsupportedOperation(psOperation->pszValue);
-            if( idx >= 0 ) {
+            if (idx >= 0) {
               wfsparams->pszRequest = msStrdup(wfsUnsupportedOperations[idx]);
               break;
             }
@@ -5249,15 +5286,12 @@ int msWFSParseRequest(mapObj *map, cgiRe
         }
       }
 
-      if( psOperation != NULL )
-      {
-        pszValue = CPLGetXMLValue(psOperation, "version",
-                                  NULL);
+      if (psOperation != NULL) {
+        pszValue = CPLGetXMLValue(psOperation, "version", NULL);
         if (pszValue)
           wfsparams->pszVersion = msStrdup(pszValue);
 
-        pszValue = CPLGetXMLValue(psOperation, "service",
-                                  NULL);
+        pszValue = CPLGetXMLValue(psOperation, "service", NULL);
         if (pszValue)
           wfsparams->pszService = msStrdup(pszValue);
       }
@@ -5266,147 +5300,128 @@ int msWFSParseRequest(mapObj *map, cgiRe
       /*      Parse the GetFeature                                            */
       /* -------------------------------------------------------------------- */
       if (psGetFeature) {
-        CPLXMLNode* psIter;
+        CPLXMLNode *psIter;
 
         wfsparams->pszRequest = msStrdup("GetFeature");
 
-        pszValue = CPLGetXMLValue(psGetFeature,  "resultType",
-                                  NULL);
+        pszValue = CPLGetXMLValue(psGetFeature, "resultType", NULL);
         if (pszValue)
           wfsparams->pszResultType = msStrdup(pszValue);
 
-        pszValue = CPLGetXMLValue(psGetFeature,  "maxFeatures",
-                                  NULL);
+        pszValue = CPLGetXMLValue(psGetFeature, "maxFeatures", NULL);
         if (pszValue)
           wfsparams->nMaxFeatures = atoi(pszValue);
-        else
-        {
-            /* WFS 2.0 */
-            pszValue = CPLGetXMLValue(psGetFeature,  "count",
-                                  NULL);
-            if (pszValue)
-                wfsparams->nMaxFeatures = atoi(pszValue);
+        else {
+          /* WFS 2.0 */
+          pszValue = CPLGetXMLValue(psGetFeature, "count", NULL);
+          if (pszValue)
+            wfsparams->nMaxFeatures = atoi(pszValue);
         }
 
-        pszValue = CPLGetXMLValue(psGetFeature,  "startIndex",
-                                  NULL);
+        pszValue = CPLGetXMLValue(psGetFeature, "startIndex", NULL);
         if (pszValue)
           wfsparams->nStartIndex = atoi(pszValue);
 
-        pszValue = CPLGetXMLValue(psGetFeature, "outputFormat",
-                                  NULL);
+        pszValue = CPLGetXMLValue(psGetFeature, "outputFormat", NULL);
         if (pszValue)
           wfsparams->pszOutputFormat = msStrdup(pszValue);
 
-          /* -------------------------------------------------------------------- */
-          /*      Parse typenames and filters. If there are multiple queries,     */
-          /*      typenames will be build with comma between thme                 */
-          /*      (typename1,typename2,...) and filters will be build with        */
-          /*      bracets enclosinf the filters :(filter1)(filter2)...            */
-          /*      propertynames are stored like (property1,property2)(property1)  */
-          /* -------------------------------------------------------------------- */
+        /* --------------------------------------------------------------------
+         */
+        /*      Parse typenames and filters. If there are multiple queries, */
+        /*      typenames will be build with comma between thme */
+        /*      (typename1,typename2,...) and filters will be build with */
+        /*      bracets enclosinf the filters :(filter1)(filter2)... */
+        /*      propertynames are stored like (property1,property2)(property1)
+         */
+        /* --------------------------------------------------------------------
+         */
         psIter = psGetFeature->psChild;
-        while( psIter != NULL )
-        {
-            if( psIter->eType == CXT_Element &&
-                strcmp(psIter->pszValue, "Query") == 0 )
-            {
-                msWFSParseXMLQueryNode(psIter, wfsparams);
-            }
-            else if( psIter->eType == CXT_Element &&
-                strcmp(psIter->pszValue, "StoredQuery") == 0 )
-            {
-                int status = msWFSParseXMLStoredQueryNode(map, wfsparams, psIter);
-                if( status != MS_SUCCESS )
-                {
-                    CPLDestroyXMLNode(psRoot);
-                    msFree(pszSchemaLocation);
-                    return status;
-                }
-                wfsparams->bHasPostStoredQuery = MS_TRUE;
+        while (psIter != NULL) {
+          if (psIter->eType == CXT_Element &&
+              strcmp(psIter->pszValue, "Query") == 0) {
+            msWFSParseXMLQueryNode(psIter, wfsparams);
+          } else if (psIter->eType == CXT_Element &&
+                     strcmp(psIter->pszValue, "StoredQuery") == 0) {
+            int status = msWFSParseXMLStoredQueryNode(map, wfsparams, psIter);
+            if (status != MS_SUCCESS) {
+              CPLDestroyXMLNode(psRoot);
+              msFree(pszSchemaLocation);
+              return status;
             }
-            psIter = psIter->psNext;
+            wfsparams->bHasPostStoredQuery = MS_TRUE;
+          }
+          psIter = psIter->psNext;
         }
 
         msWFSSimplifyPropertyNameAndFilter(wfsparams);
-      }/* end of GetFeature */
-
+      } /* end of GetFeature */
 
       /* -------------------------------------------------------------------- */
       /*      Parse the GetPropertyValue                                      */
       /* -------------------------------------------------------------------- */
       if (psGetPropertyValue) {
-        CPLXMLNode* psIter;
+        CPLXMLNode *psIter;
 
         wfsparams->pszRequest = msStrdup("GetPropertyValue");
 
-        pszValue = CPLGetXMLValue(psGetPropertyValue,  "valueReference",
-                                  NULL);
+        pszValue = CPLGetXMLValue(psGetPropertyValue, "valueReference", NULL);
         if (pszValue)
           wfsparams->pszValueReference = msStrdup(pszValue);
 
-        pszValue = CPLGetXMLValue(psGetPropertyValue,  "resultType",
-                                  NULL);
+        pszValue = CPLGetXMLValue(psGetPropertyValue, "resultType", NULL);
         if (pszValue)
           wfsparams->pszResultType = msStrdup(pszValue);
 
-        pszValue = CPLGetXMLValue(psGetPropertyValue,  "count",
-                                 NULL);
+        pszValue = CPLGetXMLValue(psGetPropertyValue, "count", NULL);
         if (pszValue)
           wfsparams->nMaxFeatures = atoi(pszValue);
 
-        pszValue = CPLGetXMLValue(psGetPropertyValue,  "startIndex",
-                                  NULL);
+        pszValue = CPLGetXMLValue(psGetPropertyValue, "startIndex", NULL);
         if (pszValue)
           wfsparams->nStartIndex = atoi(pszValue);
 
-        pszValue = CPLGetXMLValue(psGetPropertyValue, "outputFormat",
-                                  NULL);
+        pszValue = CPLGetXMLValue(psGetPropertyValue, "outputFormat", NULL);
         if (pszValue)
           wfsparams->pszOutputFormat = msStrdup(pszValue);
 
         psIter = psGetPropertyValue->psChild;
-        while( psIter != NULL )
-        {
-            if( psIter->eType == CXT_Element &&
-                strcmp(psIter->pszValue, "Query") == 0 )
-            {
-                msWFSParseXMLQueryNode(psIter, wfsparams);
-                /* Just one is allowed for GetPropertyValue */
-                break;
-            }
-            else if( psIter->eType == CXT_Element &&
-                strcmp(psIter->pszValue, "StoredQuery") == 0 )
-            {
-                int status = msWFSParseXMLStoredQueryNode(map, wfsparams, psIter);
-                if( status != MS_SUCCESS )
-                {
-                    CPLDestroyXMLNode(psRoot);
-                    msFree(pszSchemaLocation);
-                    return status;
-                }
-                wfsparams->bHasPostStoredQuery = MS_TRUE;
-                /* Just one is allowed for GetPropertyValue */
-                break;
+        while (psIter != NULL) {
+          if (psIter->eType == CXT_Element &&
+              strcmp(psIter->pszValue, "Query") == 0) {
+            msWFSParseXMLQueryNode(psIter, wfsparams);
+            /* Just one is allowed for GetPropertyValue */
+            break;
+          } else if (psIter->eType == CXT_Element &&
+                     strcmp(psIter->pszValue, "StoredQuery") == 0) {
+            int status = msWFSParseXMLStoredQueryNode(map, wfsparams, psIter);
+            if (status != MS_SUCCESS) {
+              CPLDestroyXMLNode(psRoot);
+              msFree(pszSchemaLocation);
+              return status;
             }
-            psIter = psIter->psNext;
+            wfsparams->bHasPostStoredQuery = MS_TRUE;
+            /* Just one is allowed for GetPropertyValue */
+            break;
+          }
+          psIter = psIter->psNext;
         }
 
         msWFSSimplifyPropertyNameAndFilter(wfsparams);
-      }/* end of GetPropertyValue */
+      } /* end of GetPropertyValue */
 
       /* -------------------------------------------------------------------- */
       /*      Parse GetCapabilities.                                          */
       /* -------------------------------------------------------------------- */
       if (psGetCapabilities) {
-        CPLXMLNode* psAcceptVersions;
-        CPLXMLNode* psSections;
-          
+        CPLXMLNode *psAcceptVersions;
+        CPLXMLNode *psSections;
+
         wfsparams->pszRequest = msStrdup("GetCapabilities");
-        
-        pszValue = CPLGetXMLValue(psGetCapabilities,  "updateSequence", NULL);
+
+        pszValue = CPLGetXMLValue(psGetCapabilities, "updateSequence", NULL);
         if (pszValue)
-            wfsparams->pszUpdateSequence = msStrdup(pszValue);
+          wfsparams->pszUpdateSequence = msStrdup(pszValue);
 
         /* version is optional for the GetCapabilities. If not */
         /* provided, set it. */
@@ -5414,51 +5429,44 @@ int msWFSParseRequest(mapObj *map, cgiRe
           wfsparams->pszVersion = msStrdup(msWFSGetDefaultVersion(map));
 
         psAcceptVersions = CPLGetXMLNode(psGetCapabilities, "AcceptVersions");
-        if( psAcceptVersions != NULL )
-        {
-            CPLXMLNode* psIter = psAcceptVersions->psChild;
-            while( psIter != NULL )
-            {
-                if( psIter->eType == CXT_Element &&
-                    strcmp(psIter->pszValue, "Version") == 0 )
-                {
-                    pszValue = CPLGetXMLValue(psIter, NULL, NULL);
-                    if (pszValue) {
-                      msWFSBuildParamList(&(wfsparams->pszAcceptVersions), pszValue, ",");
-                    }
-                }
-                psIter = psIter->psNext;
+        if (psAcceptVersions != NULL) {
+          CPLXMLNode *psIter = psAcceptVersions->psChild;
+          while (psIter != NULL) {
+            if (psIter->eType == CXT_Element &&
+                strcmp(psIter->pszValue, "Version") == 0) {
+              pszValue = CPLGetXMLValue(psIter, NULL, NULL);
+              if (pszValue) {
+                msWFSBuildParamList(&(wfsparams->pszAcceptVersions), pszValue,
+                                    ",");
+              }
             }
+            psIter = psIter->psNext;
+          }
         }
 
         psSections = CPLGetXMLNode(psGetCapabilities, "Sections");
-        if( psSections != NULL )
-        {
-            CPLXMLNode* psIter = psSections->psChild;
-            while( psIter != NULL )
-            {
-                if( psIter->eType == CXT_Element &&
-                    strcmp(psIter->pszValue, "Section") == 0 )
-                {
-                    pszValue = CPLGetXMLValue(psIter, NULL, NULL);
-                    if (pszValue) {
-                      msWFSBuildParamList(&(wfsparams->pszSections), pszValue, ",");
-                    }
-                }
-                psIter = psIter->psNext;
+        if (psSections != NULL) {
+          CPLXMLNode *psIter = psSections->psChild;
+          while (psIter != NULL) {
+            if (psIter->eType == CXT_Element &&
+                strcmp(psIter->pszValue, "Section") == 0) {
+              pszValue = CPLGetXMLValue(psIter, NULL, NULL);
+              if (pszValue) {
+                msWFSBuildParamList(&(wfsparams->pszSections), pszValue, ",");
+              }
             }
+            psIter = psIter->psNext;
+          }
         }
-      }/* end of GetCapabilites */
+      } /* end of GetCapabilites */
       /* -------------------------------------------------------------------- */
       /*      Parse DescribeFeatureType                                       */
       /* -------------------------------------------------------------------- */
       if (psDescribeFeature) {
-        CPLXMLNode* psIter;
+        CPLXMLNode *psIter;
         wfsparams->pszRequest = msStrdup("DescribeFeatureType");
 
-        pszValue = CPLGetXMLValue(psDescribeFeature,
-                                  "outputFormat",
-                                  NULL);
+        pszValue = CPLGetXMLValue(psDescribeFeature, "outputFormat", NULL);
         if (pszValue)
           wfsparams->pszOutputFormat = msStrdup(pszValue);
 
@@ -5470,9 +5478,8 @@ int msWFSParseRequest(mapObj *map, cgiRe
             free(wfsparams->pszTypeName);
           wfsparams->pszTypeName = NULL;
 
-          while (psIter )
-          {
-            if( psIter->eType == CXT_Element &&
+          while (psIter) {
+            if (psIter->eType == CXT_Element &&
                 strcasecmp(psIter->pszValue, "TypeName") == 0) {
               pszValue = CPLGetXMLValue(psIter, NULL, NULL);
               if (pszValue) {
@@ -5483,87 +5490,87 @@ int msWFSParseRequest(mapObj *map, cgiRe
           }
         }
 
-      }/* end of DescibeFeatureType */
+      } /* end of DescibeFeatureType */
 
       /* -------------------------------------------------------------------- */
       /*      Parse the ListStoredQueries                                     */
       /* -------------------------------------------------------------------- */
       if (psListStoredQueries) {
         wfsparams->pszRequest = msStrdup("ListStoredQueries");
-      }/* end of ListStoredQueries */
+      } /* end of ListStoredQueries */
 
       /* -------------------------------------------------------------------- */
       /*      Parse the DescribeStoredQueries                                 */
       /* -------------------------------------------------------------------- */
       if (psDescribeStoredQueries) {
-        CPLXMLNode* psIter;
+        CPLXMLNode *psIter;
 
         wfsparams->pszRequest = msStrdup("DescribeStoredQueries");
 
         psIter = CPLGetXMLNode(psDescribeStoredQueries, "StoredQueryId");
-        while (psIter )
-        {
-          if( psIter->eType == CXT_Element &&
+        while (psIter) {
+          if (psIter->eType == CXT_Element &&
               strcasecmp(psIter->pszValue, "StoredQueryId") == 0) {
             pszValue = CPLGetXMLValue(psIter, NULL, NULL);
             if (pszValue) {
-              msWFSBuildParamList(&(wfsparams->pszStoredQueryId), pszValue, ",");
+              msWFSBuildParamList(&(wfsparams->pszStoredQueryId), pszValue,
+                                  ",");
             }
           }
           psIter = psIter->psNext;
         }
-      }/* end of DescribeStoredQueries */
+      } /* end of DescribeStoredQueries */
 
       CPLDestroyXMLNode(psRoot);
     }
 
 #if defined(USE_LIBXML2)
     {
-        const char *schema_location=NULL, *validate=NULL;
+      const char *schema_location = NULL, *validate = NULL;
 
-        /*do we validate the xml ?*/
-        validate = msOWSLookupMetadata(&(map->web.metadata), "FO", "validate_xml");
-        if (validate && strcasecmp(validate, "true") == 0 &&
-            (schema_location = msOWSLookupMetadata(&(map->web.metadata), "FO", "schemas_dir")))
-        {
-            if ((wfsparams->pszService  && strcmp(wfsparams->pszService, "WFS") == 0) ||
-                force_wfs_mode)
-            {
-                char *schema_file =NULL;
-                if (pszSchemaLocation != NULL && strstr(pszSchemaLocation, "wfs/1.0") != NULL )
-                {
-                    schema_file = msStringConcatenate(schema_file, schema_location);
-                    schema_file = msStringConcatenate(schema_file, MS_OWSCOMMON_WFS_10_SCHEMA_LOCATION);
-                }
-                else if (pszSchemaLocation != NULL && strstr(pszSchemaLocation, "wfs/1.1") != NULL )
-                {
-                    schema_file = msStringConcatenate(schema_file, schema_location);
-                    schema_file = msStringConcatenate(schema_file, MS_OWSCOMMON_WFS_11_SCHEMA_LOCATION);
-                }
-                else if (pszSchemaLocation != NULL && strstr(pszSchemaLocation, "wfs/2.0") != NULL )
-                {
-                    schema_file = msStringConcatenate(schema_file, schema_location);
-                    schema_file = msStringConcatenate(schema_file, MS_OWSCOMMON_WFS_20_SCHEMA_LOCATION);
-                }
-                if( schema_file != NULL )
-                {
-                    if (msOWSSchemaValidation(schema_file, request->postrequest) != 0) {
-                        msSetError(MS_WFSERR, "Invalid POST request.  XML is not valid", "msWFSParseRequest()");
-                        msFree(schema_file);
-                        return msWFSException(map, "request", "InvalidRequest", NULL);
-                    }
-                    msFree(schema_file);
-                }
+      /*do we validate the xml ?*/
+      validate =
+          msOWSLookupMetadata(&(map->web.metadata), "FO", "validate_xml");
+      if (validate && strcasecmp(validate, "true") == 0 &&
+          (schema_location = msOWSLookupMetadata(&(map->web.metadata), "FO",
+                                                 "schemas_dir"))) {
+        if ((wfsparams->pszService &&
+             strcmp(wfsparams->pszService, "WFS") == 0) ||
+            force_wfs_mode) {
+          char *schema_file = NULL;
+          if (pszSchemaLocation != NULL &&
+              strstr(pszSchemaLocation, "wfs/1.0") != NULL) {
+            schema_file = msStringConcatenate(schema_file, schema_location);
+            schema_file = msStringConcatenate(
+                schema_file, MS_OWSCOMMON_WFS_10_SCHEMA_LOCATION);
+          } else if (pszSchemaLocation != NULL &&
+                     strstr(pszSchemaLocation, "wfs/1.1") != NULL) {
+            schema_file = msStringConcatenate(schema_file, schema_location);
+            schema_file = msStringConcatenate(
+                schema_file, MS_OWSCOMMON_WFS_11_SCHEMA_LOCATION);
+          } else if (pszSchemaLocation != NULL &&
+                     strstr(pszSchemaLocation, "wfs/2.0") != NULL) {
+            schema_file = msStringConcatenate(schema_file, schema_location);
+            schema_file = msStringConcatenate(
+                schema_file, MS_OWSCOMMON_WFS_20_SCHEMA_LOCATION);
+          }
+          if (schema_file != NULL) {
+            if (msOWSSchemaValidation(schema_file, request->postrequest) != 0) {
+              msSetError(MS_WFSERR, "Invalid POST request.  XML is not valid",
+                         "msWFSParseRequest()");
+              msFree(schema_file);
+              return msWFSException(map, "request", "InvalidRequest", NULL);
             }
+            msFree(schema_file);
+          }
         }
+      }
     }
 #endif
 
     msFree(pszSchemaLocation);
-
   }
 
 #endif
   return MS_SUCCESS;
 }
-
diff -pruN 8.0.1-5/mapwfs11.cpp 8.0.2-1/mapwfs11.cpp
--- 8.0.1-5/mapwfs11.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapwfs11.cpp	2024-06-11 20:41:34.000000000 +0000
@@ -3,8 +3,8 @@
  *
  * Project:  MapServer
  * Purpose:  OGC WFS 1.1.0 implementation. This file holds some WFS 1.1.0
- *           specific functions but other parts are still implemented in mapwfs.c.
- * Author:   Y. Assefa, DM Solutions Group (assefa@dmsolutions.ca)
+ *           specific functions but other parts are still implemented in
+ *mapwfs.c. Author:   Y. Assefa, DM Solutions Group (assefa@dmsolutions.ca)
  *
  **********************************************************************
  * Copyright (c) 2008, Y. Assefa, DM Solutions Group Inc
@@ -37,41 +37,43 @@
 
 #include <string>
 
-template<class T> inline void IGNORE_RET_VAL(T) {}
+template <class T> inline void IGNORE_RET_VAL(T) {}
 
 /************************************************************************/
 /*                          msWFSException11()                          */
 /************************************************************************/
 
 int msWFSException11(mapObj *map, const char *locator,
-                     const char *exceptionCode, const char *version)
-{
+                     const char *exceptionCode, const char *version) {
   int size = 0;
-  char *errorString     = NULL;
+  char *errorString = NULL;
   char *schemasLocation = NULL;
 
-  xmlDocPtr  psDoc      = NULL;
+  xmlDocPtr psDoc = NULL;
   xmlNodePtr psRootNode = NULL;
-  xmlNsPtr   psNsOws    = NULL;
-  xmlChar *buffer       = NULL;
+  xmlNsPtr psNsOws = NULL;
+  xmlChar *buffer = NULL;
 
   if (version == NULL)
     version = "1.1.0";
 
-  psNsOws = xmlNewNs(NULL, BAD_CAST "http://www.opengis.net/ows", BAD_CAST "ows");
+  psNsOws =
+      xmlNewNs(NULL, BAD_CAST "http://www.opengis.net/ows", BAD_CAST "ows");
 
   errorString = msGetErrorString("\n");
   schemasLocation = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
 
   psDoc = xmlNewDoc(BAD_CAST "1.0");
 
-  psRootNode = msOWSCommonExceptionReport(psNsOws, OWS_1_0_0, schemasLocation, version, msOWSGetLanguage(map, "exception"), exceptionCode, locator, errorString);
+  psRootNode = msOWSCommonExceptionReport(
+      psNsOws, OWS_1_0_0, schemasLocation, version,
+      msOWSGetLanguage(map, "exception"), exceptionCode, locator, errorString);
 
   xmlDocSetRootElement(psDoc, psRootNode);
 
   xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/ows", BAD_CAST "ows");
 
-  msIO_setHeader("Content-Type","text/xml; charset=UTF-8");
+  msIO_setHeader("Content-Type", "text/xml; charset=UTF-8");
   msIO_sendHeaders();
 
   xmlDocDumpFormatMemoryEnc(psDoc, &buffer, &size, ("UTF-8"), 1);
@@ -95,40 +97,41 @@ int msWFSException11(mapObj *map, const
 /*                       msWFSAddMetadataURL                            */
 /************************************************************************/
 
-static void msWFSAddMetadataURL(layerObj* lp,
-                                int nWFSVersion, 
-                                const std::string& radix,
-                                xmlNodePtr psRootNode)
-{
-  const char* value = msOWSLookupMetadata(&(lp->metadata), "FO", (radix + "_href").c_str());
+static void msWFSAddMetadataURL(layerObj *lp, int nWFSVersion,
+                                const std::string &radix,
+                                xmlNodePtr psRootNode) {
+  const char *value =
+      msOWSLookupMetadata(&(lp->metadata), "FO", (radix + "_href").c_str());
 
   if (value) {
-    if( nWFSVersion >= OWS_2_0_0 )
-    {
-        xmlNodePtr psNode = xmlNewChild(psRootNode, NULL, BAD_CAST "MetadataURL", NULL);
-        xmlNewProp(psNode, BAD_CAST "xlink:href", BAD_CAST value);
-
-        value = msOWSLookupMetadata(&(lp->metadata), "FO", (radix + "_about").c_str());
-        if( value != NULL )
-            xmlNewProp(psNode, BAD_CAST "about", BAD_CAST value);
-    }
-    else
-    {
-        xmlNodePtr psNode = xmlNewTextChild(psRootNode, NULL, BAD_CAST "MetadataURL", BAD_CAST value);
+    if (nWFSVersion >= OWS_2_0_0) {
+      xmlNodePtr psNode =
+          xmlNewChild(psRootNode, NULL, BAD_CAST "MetadataURL", NULL);
+      xmlNewProp(psNode, BAD_CAST "xlink:href", BAD_CAST value);
+
+      value = msOWSLookupMetadata(&(lp->metadata), "FO",
+                                  (radix + "_about").c_str());
+      if (value != NULL)
+        xmlNewProp(psNode, BAD_CAST "about", BAD_CAST value);
+    } else {
+      xmlNodePtr psNode = xmlNewTextChild(
+          psRootNode, NULL, BAD_CAST "MetadataURL", BAD_CAST value);
+
+      value = msOWSLookupMetadata(&(lp->metadata), "FO",
+                                  (radix + "_format").c_str());
+
+      if (!value)
+        value = "text/html"; /* default */
+
+      xmlNewProp(psNode, BAD_CAST "format", BAD_CAST value);
 
-        value = msOWSLookupMetadata(&(lp->metadata), "FO", (radix + "_format").c_str());
+      value =
+          msOWSLookupMetadata(&(lp->metadata), "FO", (radix + "_type").c_str());
 
-        if (!value)
-            value = "text/html"; /* default */
+      if (!value)
+        value = "FGDC"; /* default */
 
-        xmlNewProp(psNode, BAD_CAST "format", BAD_CAST value);
-
-        value = msOWSLookupMetadata(&(lp->metadata), "FO", (radix + "_type").c_str());
-
-        if (!value)
-            value = "FGDC"; /* default */
-
-        xmlNewProp(psNode, BAD_CAST "type", BAD_CAST value);
+      xmlNewProp(psNode, BAD_CAST "type", BAD_CAST value);
     }
   }
 }
@@ -137,15 +140,14 @@ static void msWFSAddMetadataURL(layerObj
 /*                            msWFSDumpLayer11                          */
 /************************************************************************/
 xmlNodePtr msWFSDumpLayer11(mapObj *map, layerObj *lp, xmlNsPtr psNsOws,
-                            int nWFSVersion, const char* validate_language,
-                            char *script_url)
-{
+                            int nWFSVersion, const char *validate_language,
+                            char *script_url) {
   rectObj ext;
 
   xmlNodePtr psRootNode, psNode;
-  const char *value    = NULL;
+  const char *value = NULL;
   char *valueToFree;
-  int i=0;
+  int i = 0;
 
   psRootNode = xmlNewNode(NULL, BAD_CAST "FeatureType");
 
@@ -154,76 +156,88 @@ xmlNodePtr msWFSDumpLayer11(mapObj *map,
 
   /* FIXME? Should probably be applied to WFS 1.1 as well, but the addition */
   /* of the prefix can be disruptive for clients */
-  if( value == NULL && nWFSVersion >= OWS_2_0_0 )
-      value = MS_DEFAULT_NAMESPACE_PREFIX;
+  if (value == NULL && nWFSVersion >= OWS_2_0_0)
+    value = MS_DEFAULT_NAMESPACE_PREFIX;
 
-  if(value) {
-    int n = strlen(value)+strlen(lp->name)+1+1;
-    valueToFree = (char *) msSmallMalloc(n);
+  if (value) {
+    int n = strlen(value) + strlen(lp->name) + 1 + 1;
+    valueToFree = (char *)msSmallMalloc(n);
     snprintf(valueToFree, n, "%s:%s", value, lp->name);
 
-    psNode = xmlNewTextChild(psRootNode, NULL, BAD_CAST "Name", BAD_CAST valueToFree);
+    psNode = xmlNewTextChild(psRootNode, NULL, BAD_CAST "Name",
+                             BAD_CAST valueToFree);
     msFree(valueToFree);
   } else {
-    psNode = xmlNewTextChild(psRootNode, NULL, BAD_CAST "Name", BAD_CAST lp->name);
+    psNode =
+        xmlNewTextChild(psRootNode, NULL, BAD_CAST "Name", BAD_CAST lp->name);
   }
 
   if (lp->name && strlen(lp->name) > 0 &&
-      (msIsXMLTagValid(lp->name) == MS_FALSE || isdigit(lp->name[0])))
-  {
+      (msIsXMLTagValid(lp->name) == MS_FALSE || isdigit(lp->name[0]))) {
     char szTmp[512];
     snprintf(szTmp, sizeof(szTmp),
              "WARNING: The layer name '%s' might contain spaces or "
-             "invalid characters or may start with a number. This could lead to potential problems",
+             "invalid characters or may start with a number. This could lead "
+             "to potential problems",
              lp->name);
     xmlAddSibling(psNode, xmlNewComment(BAD_CAST szTmp));
   }
 
-  value = msOWSLookupMetadataWithLanguage(&(lp->metadata), "FO", "title", validate_language);
+  value = msOWSLookupMetadataWithLanguage(&(lp->metadata), "FO", "title",
+                                          validate_language);
   if (!value)
-    value =(const char*)lp->name;
+    value = (const char *)lp->name;
 
   psNode = xmlNewTextChild(psRootNode, NULL, BAD_CAST "Title", BAD_CAST value);
 
-
-  value = msOWSLookupMetadataWithLanguage(&(lp->metadata), "FO", "abstract", validate_language);
+  value = msOWSLookupMetadataWithLanguage(&(lp->metadata), "FO", "abstract",
+                                          validate_language);
   if (value)
-    psNode = xmlNewTextChild(psRootNode, NULL, BAD_CAST "Abstract", BAD_CAST value);
-
-
+    psNode =
+        xmlNewTextChild(psRootNode, NULL, BAD_CAST "Abstract", BAD_CAST value);
 
-  value = msOWSLookupMetadataWithLanguage(&(lp->metadata), "FO", "keywordlist", validate_language);
+  value = msOWSLookupMetadataWithLanguage(&(lp->metadata), "FO", "keywordlist",
+                                          validate_language);
 
-  if(value)
+  if (value)
     msLibXml2GenerateList(
-        xmlNewChild(psRootNode, psNsOws, BAD_CAST "Keywords", NULL),
-        NULL, "Keyword", value, ',' );
+        xmlNewChild(psRootNode, psNsOws, BAD_CAST "Keywords", NULL), NULL,
+        "Keyword", value, ',');
 
   /*support DefaultSRS and OtherSRS*/
-  valueToFree = msOWSGetProjURN(&(map->projection),&(map->web.metadata),"FO",MS_FALSE);
+  valueToFree =
+      msOWSGetProjURN(&(map->projection), &(map->web.metadata), "FO", MS_FALSE);
   if (!valueToFree)
-    valueToFree = msOWSGetProjURN(&(lp->projection), &(lp->metadata), "FO", MS_FALSE);
+    valueToFree =
+        msOWSGetProjURN(&(lp->projection), &(lp->metadata), "FO", MS_FALSE);
 
   if (valueToFree) {
     int n = 0;
-    char** tokens = msStringSplit(valueToFree, ' ', &n);
+    char **tokens = msStringSplit(valueToFree, ' ', &n);
     if (tokens && n > 0) {
-      if( nWFSVersion == OWS_1_1_0 )
-        IGNORE_RET_VAL(xmlNewTextChild(psRootNode, NULL, BAD_CAST "DefaultSRS", BAD_CAST tokens[0]));
+      if (nWFSVersion == OWS_1_1_0)
+        IGNORE_RET_VAL(xmlNewTextChild(psRootNode, NULL, BAD_CAST "DefaultSRS",
+                                       BAD_CAST tokens[0]));
       else
-        IGNORE_RET_VAL(xmlNewTextChild(psRootNode, NULL, BAD_CAST "DefaultCRS", BAD_CAST tokens[0]));
-      for (i=1; i<n; i++)
-      {
-        if( nWFSVersion == OWS_1_1_0 )
-          IGNORE_RET_VAL(xmlNewTextChild(psRootNode, NULL, BAD_CAST "OtherSRS", BAD_CAST tokens[i]));
+        IGNORE_RET_VAL(xmlNewTextChild(psRootNode, NULL, BAD_CAST "DefaultCRS",
+                                       BAD_CAST tokens[0]));
+      for (i = 1; i < n; i++) {
+        if (nWFSVersion == OWS_1_1_0)
+          IGNORE_RET_VAL(xmlNewTextChild(psRootNode, NULL, BAD_CAST "OtherSRS",
+                                         BAD_CAST tokens[i]));
         else
-          IGNORE_RET_VAL(xmlNewTextChild(psRootNode, NULL, BAD_CAST "OtherCRS", BAD_CAST tokens[i]));
+          IGNORE_RET_VAL(xmlNewTextChild(psRootNode, NULL, BAD_CAST "OtherCRS",
+                                         BAD_CAST tokens[i]));
       }
     }
     msFreeCharArray(tokens, n);
   } else
-    xmlAddSibling(psNode,
-                  xmlNewComment(BAD_CAST "WARNING: Mandatory mapfile parameter: (at least one of) MAP.PROJECTION, LAYER.PROJECTION or wfs/ows_srs metadata was missing in this context."));
+    xmlAddSibling(
+        psNode,
+        xmlNewComment(BAD_CAST
+                      "WARNING: Mandatory mapfile parameter: (at least one of) "
+                      "MAP.PROJECTION, LAYER.PROJECTION or wfs/ows_srs "
+                      "metadata was missing in this context."));
 
   free(valueToFree);
   valueToFree = NULL;
@@ -233,16 +247,16 @@ xmlNodePtr msWFSDumpLayer11(mapObj *map,
   xmlAddChild(psRootNode, psNode);
 
   {
-    char *formats_list = msWFSGetOutputFormatList( map, lp, nWFSVersion );
+    char *formats_list = msWFSGetOutputFormatList(map, lp, nWFSVersion);
     int iformat;
     int n = 0;
-    char** tokens = msStringSplit(formats_list, ',', &n);
+    char **tokens = msStringSplit(formats_list, ',', &n);
 
-    for( iformat = 0; iformat < n; iformat++ )
+    for (iformat = 0; iformat < n; iformat++)
       xmlNewTextChild(psNode, NULL, BAD_CAST "Format",
-                  BAD_CAST tokens[iformat] );
-    msFree( formats_list );
-    msFreeCharArray( tokens, n );
+                      BAD_CAST tokens[iformat]);
+    msFree(formats_list);
+    msFreeCharArray(tokens, n);
   }
 
   /*bbox*/
@@ -254,28 +268,31 @@ xmlNodePtr msWFSDumpLayer11(mapObj *map,
       msOWSProjectToWGS84(&map->projection, &ext);
 
     xmlAddChild(psRootNode,
-                msOWSCommonWGS84BoundingBox( psNsOws, 2,
-                    ext.minx, ext.miny,
-                    ext.maxx, ext.maxy));
+                msOWSCommonWGS84BoundingBox(psNsOws, 2, ext.minx, ext.miny,
+                                            ext.maxx, ext.maxy));
   } else {
-    xmlAddSibling(psNode,
-                  xmlNewComment(BAD_CAST "WARNING: Optional WGS84BoundingBox could not be established for this layer.  Consider setting the EXTENT in the LAYER object, or wfs_extent metadata. Also check that your data exists in the DATA statement"));
+    xmlAddSibling(
+        psNode,
+        xmlNewComment(
+            BAD_CAST "WARNING: Optional WGS84BoundingBox could not be "
+                     "established for this layer.  Consider setting the EXTENT "
+                     "in the LAYER object, or wfs_extent metadata. Also check "
+                     "that your data exists in the DATA statement"));
   }
 
-  const char* metadataurl_list = msOWSLookupMetadata(&(lp->metadata), "FO", "metadataurl_list");
-  if( metadataurl_list ) {
+  const char *metadataurl_list =
+      msOWSLookupMetadata(&(lp->metadata), "FO", "metadataurl_list");
+  if (metadataurl_list) {
     int ntokens = 0;
-    char** tokens = msStringSplit(metadataurl_list, ' ', &ntokens);
-    for( int i = 0; i < ntokens; i++ )
-    {
+    char **tokens = msStringSplit(metadataurl_list, ' ', &ntokens);
+    for (int i = 0; i < ntokens; i++) {
       std::string key("metadataurl_");
       key += tokens[i];
       msWFSAddMetadataURL(lp, nWFSVersion, key, psRootNode);
     }
     msFreeCharArray(tokens, ntokens);
-  }
-  else {
-    if (! msOWSLookupMetadata(&(lp->metadata), "FO", "metadataurl_href"))
+  } else {
+    if (!msOWSLookupMetadata(&(lp->metadata), "FO", "metadataurl_href"))
       msMetadataSetGetMetadataURL(lp, script_url);
 
     msWFSAddMetadataURL(lp, nWFSVersion, "metadataurl", psRootNode);
@@ -290,19 +307,19 @@ xmlNodePtr msWFSDumpLayer11(mapObj *map,
 /*      Return the capabilities document for wfs 1.1.0                  */
 /************************************************************************/
 int msWFSGetCapabilities11(mapObj *map, wfsParamsObj *params,
-                           cgiRequestObj *req, owsRequestObj *ows_request)
-{
-  xmlDocPtr psDoc = NULL;       /* document pointer */
+                           cgiRequestObj *req, owsRequestObj *ows_request) {
+  xmlDocPtr psDoc = NULL; /* document pointer */
   xmlNodePtr psRootNode, psMainNode, psNode, psFtNode;
-  const char *updatesequence=NULL;
+  const char *updatesequence = NULL;
   xmlNsPtr psNsOws, psNsXLink, psNsOgc;
   char *schemalocation = NULL;
   char *xsi_schemaLocation = NULL;
   const char *user_namespace_prefix = NULL;
   const char *user_namespace_uri = NULL;
-  gmlNamespaceListObj *namespaceList=NULL; /* for external application schema support */
+  gmlNamespaceListObj *namespaceList =
+      NULL; /* for external application schema support */
 
-  char *script_url=NULL, *formats_list;
+  char *script_url = NULL, *formats_list;
   const char *value = NULL;
 
   xmlChar *buffer = NULL;
@@ -316,8 +333,8 @@ int msWFSGetCapabilities11(mapObj *map,
   /*      Handle updatesequence                                           */
   /* -------------------------------------------------------------------- */
   ret = msWFSHandleUpdateSequence(map, params, "msWFSGetCapabilities11()");
-  if( ret != MS_SUCCESS )
-      return ret;
+  if (ret != MS_SUCCESS)
+    return ret;
 
   /* -------------------------------------------------------------------- */
   /*      Create document.                                                */
@@ -332,106 +349,129 @@ int msWFSGetCapabilities11(mapObj *map,
   /*      Name spaces                                                     */
   /* -------------------------------------------------------------------- */
   /*default name space*/
-  xmlNewProp(psRootNode, BAD_CAST "xmlns", BAD_CAST "http://www.opengis.net/wfs");
-
-  xmlSetNs(psRootNode, xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/gml", BAD_CAST "gml"));
-  xmlSetNs(psRootNode, xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/wfs", BAD_CAST "wfs"));
+  xmlNewProp(psRootNode, BAD_CAST "xmlns",
+             BAD_CAST "http://www.opengis.net/wfs");
 
-  psNsOws = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_PREFIX);
-  psNsXLink = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_PREFIX);
-  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX);
-  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OGC_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_OGC_NAMESPACE_PREFIX );
+  xmlSetNs(psRootNode,
+           xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/gml",
+                    BAD_CAST "gml"));
+  xmlSetNs(psRootNode,
+           xmlNewNs(psRootNode, BAD_CAST "http://www.opengis.net/wfs",
+                    BAD_CAST "wfs"));
+
+  psNsOws = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_URI,
+                     BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_PREFIX);
+  psNsXLink =
+      xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_URI,
+               BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_PREFIX);
+  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI,
+           BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX);
+  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OGC_NAMESPACE_URI,
+           BAD_CAST MS_OWSCOMMON_OGC_NAMESPACE_PREFIX);
 
   value = msOWSLookupMetadata(&(map->web.metadata), "FO", "namespace_uri");
-  if(value) user_namespace_uri = value;
+  if (value)
+    user_namespace_uri = value;
 
   value = msOWSLookupMetadata(&(map->web.metadata), "FO", "namespace_prefix");
-  if(value) user_namespace_prefix = value;
-  if(user_namespace_prefix != NULL && msIsXMLTagValid(user_namespace_prefix) == MS_FALSE)
-    msIO_printf("<!-- WARNING: The value '%s' is not valid XML namespace. -->\n", user_namespace_prefix);
+  if (value)
+    user_namespace_prefix = value;
+  if (user_namespace_prefix != NULL &&
+      msIsXMLTagValid(user_namespace_prefix) == MS_FALSE)
+    msIO_printf(
+        "<!-- WARNING: The value '%s' is not valid XML namespace. -->\n",
+        user_namespace_prefix);
   else
-    xmlNewNs(psRootNode, BAD_CAST user_namespace_uri, BAD_CAST user_namespace_prefix);
+    xmlNewNs(psRootNode, BAD_CAST user_namespace_uri,
+             BAD_CAST user_namespace_prefix);
 
   /* any additional namespaces */
   namespaceList = msGMLGetNamespaces(&(map->web), "G");
-  for(i=0; i<namespaceList->numnamespaces; i++) {
-    if(namespaceList->namespaces[i].uri) {
-      xmlNewNs(psRootNode, BAD_CAST namespaceList->namespaces[i].uri, BAD_CAST namespaceList->namespaces[i].prefix);
+  for (i = 0; i < namespaceList->numnamespaces; i++) {
+    if (namespaceList->namespaces[i].uri) {
+      xmlNewNs(psRootNode, BAD_CAST namespaceList->namespaces[i].uri,
+               BAD_CAST namespaceList->namespaces[i].prefix);
     }
   }
   msGMLFreeNamespaces(namespaceList);
-  
 
-  xmlNewProp(psRootNode, BAD_CAST "version", BAD_CAST params->pszVersion );
+  xmlNewProp(psRootNode, BAD_CAST "version", BAD_CAST params->pszVersion);
 
-  updatesequence = msOWSLookupMetadata(&(map->web.metadata), "FO", "updatesequence");
+  updatesequence =
+      msOWSLookupMetadata(&(map->web.metadata), "FO", "updatesequence");
 
   if (updatesequence)
     xmlNewProp(psRootNode, BAD_CAST "updateSequence", BAD_CAST updatesequence);
 
   /*schema*/
-  schemalocation = msEncodeHTMLEntities( msOWSGetSchemasLocation(map) );
+  schemalocation = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
   xsi_schemaLocation = msStrdup("http://www.opengis.net/wfs");
   xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
   xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, schemalocation);
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, "/wfs/1.1.0/wfs.xsd");
-  xmlNewNsProp(psRootNode, NULL, BAD_CAST "xsi:schemaLocation", BAD_CAST xsi_schemaLocation);
+  xsi_schemaLocation =
+      msStringConcatenate(xsi_schemaLocation, "/wfs/1.1.0/wfs.xsd");
+  xmlNewNsProp(psRootNode, NULL, BAD_CAST "xsi:schemaLocation",
+               BAD_CAST xsi_schemaLocation);
 
   /* -------------------------------------------------------------------- */
   /*      Service metadata.                                               */
   /* -------------------------------------------------------------------- */
 
   xmlAddChild(psRootNode,
-                          msOWSCommonServiceIdentification(psNsOws, map, "OGC WFS", params->pszVersion, "FO", NULL));
+              msOWSCommonServiceIdentification(psNsOws, map, "OGC WFS",
+                                               params->pszVersion, "FO", NULL));
 
   /*service provider*/
-  xmlAddChild(psRootNode, msOWSCommonServiceProvider(
-                            psNsOws, psNsXLink, map, "FO", NULL));
+  xmlAddChild(psRootNode,
+              msOWSCommonServiceProvider(psNsOws, psNsXLink, map, "FO", NULL));
 
   /*operation metadata */
-  if ((script_url=msOWSGetOnlineResource(map, "FO", "onlineresource", req)) == NULL) {
+  if ((script_url = msOWSGetOnlineResource(map, "FO", "onlineresource", req)) ==
+      NULL) {
     msSetError(MS_WFSERR, "Server URL not found", "msWFSGetCapabilities11()");
-    return msWFSException11(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE, params->pszVersion);
+    return msWFSException11(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE,
+                            params->pszVersion);
   }
 
   /* -------------------------------------------------------------------- */
   /*      Operations metadata.                                            */
   /* -------------------------------------------------------------------- */
-  psMainNode= xmlAddChild(psRootNode,msOWSCommonOperationsMetadata(psNsOws));
+  psMainNode = xmlAddChild(psRootNode, msOWSCommonOperationsMetadata(psNsOws));
 
   /* -------------------------------------------------------------------- */
   /*      GetCapabilities                                                 */
   /* -------------------------------------------------------------------- */
-  psNode = xmlAddChild(psMainNode,
-                       msOWSCommonOperationsMetadataOperation(psNsOws,psNsXLink,"GetCapabilities",
-                           OWS_METHOD_GETPOST, script_url));
+  psNode = xmlAddChild(psMainNode, msOWSCommonOperationsMetadataOperation(
+                                       psNsOws, psNsXLink, "GetCapabilities",
+                                       OWS_METHOD_GETPOST, script_url));
 
   xmlAddChild(psMainNode, psNode);
   xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
-                ows_version, psNsOws, "Parameter", "service", "WFS"));
+                          ows_version, psNsOws, "Parameter", "service", "WFS"));
   /*accept version*/
-  xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,
-              "Parameter", "AcceptVersions",
-              "1.0.0,1.1.0"));
+  xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
+                          ows_version, psNsOws, "Parameter", "AcceptVersions",
+                          "1.0.0,1.1.0"));
   /*format*/
-  xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,
-              "Parameter", "AcceptFormats",
-              "text/xml"));
-
+  xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
+                          ows_version, psNsOws, "Parameter", "AcceptFormats",
+                          "text/xml"));
 
   /* -------------------------------------------------------------------- */
   /*      DescribeFeatureType                                             */
   /* -------------------------------------------------------------------- */
   if (msOWSRequestIsEnabled(map, NULL, "F", "DescribeFeatureType", MS_TRUE)) {
-    psNode = xmlAddChild(psMainNode,
-                         msOWSCommonOperationsMetadataOperation(psNsOws,psNsXLink,"DescribeFeatureType",
-                             OWS_METHOD_GETPOST, script_url));
+    psNode =
+        xmlAddChild(psMainNode, msOWSCommonOperationsMetadataOperation(
+                                    psNsOws, psNsXLink, "DescribeFeatureType",
+                                    OWS_METHOD_GETPOST, script_url));
     xmlAddChild(psMainNode, psNode);
 
     /*output format*/
-    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,
-                "Parameter", "outputFormat",
-                "XMLSCHEMA,text/xml; subtype=gml/2.1.2,text/xml; subtype=gml/3.1.1"));
+    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
+                            ows_version, psNsOws, "Parameter", "outputFormat",
+                            "XMLSCHEMA,text/xml; subtype=gml/2.1.2,text/xml; "
+                            "subtype=gml/3.1.1"));
   }
 
   /* -------------------------------------------------------------------- */
@@ -439,27 +479,27 @@ int msWFSGetCapabilities11(mapObj *map,
   /* -------------------------------------------------------------------- */
   if (msOWSRequestIsEnabled(map, NULL, "F", "GetFeature", MS_TRUE)) {
 
-    psNode = xmlAddChild(psMainNode,
-                         msOWSCommonOperationsMetadataOperation(psNsOws,psNsXLink,"GetFeature",
-                             OWS_METHOD_GETPOST, script_url));
+    psNode = xmlAddChild(psMainNode, msOWSCommonOperationsMetadataOperation(
+                                         psNsOws, psNsXLink, "GetFeature",
+                                         OWS_METHOD_GETPOST, script_url));
     xmlAddChild(psMainNode, psNode);
 
-    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,
-                "Parameter", "resultType",
-                "results,hits"));
-
-    formats_list = msWFSGetOutputFormatList( map, NULL, OWS_1_1_0 );
-    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,
-                "Parameter", "outputFormat",
-                formats_list));
-    msFree( formats_list );
+    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
+                            ows_version, psNsOws, "Parameter", "resultType",
+                            "results,hits"));
+
+    formats_list = msWFSGetOutputFormatList(map, NULL, OWS_1_1_0);
+    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
+                            ows_version, psNsOws, "Parameter", "outputFormat",
+                            formats_list));
+    msFree(formats_list);
 
     value = msOWSLookupMetadata(&(map->web.metadata), "FO", "maxfeatures");
 
     if (value) {
-      xmlAddChild(psMainNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,
-                  "Constraint", "DefaultMaxFeatures",
-                  (char *)value));
+      xmlAddChild(psMainNode, msOWSCommonOperationsMetadataDomainType(
+                                  ows_version, psNsOws, "Constraint",
+                                  "DefaultMaxFeatures", (char *)value));
     }
   }
 
@@ -472,35 +512,34 @@ int msWFSGetCapabilities11(mapObj *map,
   psNode = xmlNewChild(psFtNode, NULL, BAD_CAST "Operations", NULL);
   xmlNewChild(psNode, NULL, BAD_CAST "Operation", BAD_CAST "Query");
 
-  for(i=0; i<map->numlayers; i++) {
+  for (i = 0; i < map->numlayers; i++) {
     layerObj *lp;
     lp = GET_LAYER(map, i);
 
-    if (!msIntegerInArray(lp->index, ows_request->enabled_layers, ows_request->numlayers))
+    if (!msIntegerInArray(lp->index, ows_request->enabled_layers,
+                          ows_request->numlayers))
       continue;
 
     if (msWFSIsLayerSupported(lp))
-      xmlAddChild(psFtNode, msWFSDumpLayer11(map, lp, psNsOws, OWS_1_1_0, NULL, script_url));
+      xmlAddChild(psFtNode, msWFSDumpLayer11(map, lp, psNsOws, OWS_1_1_0, NULL,
+                                             script_url));
   }
 
-
-
-
-
   /* -------------------------------------------------------------------- */
   /*      Filter capabilities.                                            */
   /* -------------------------------------------------------------------- */
 
-  psNsOgc = xmlNewNs(NULL, BAD_CAST MS_OWSCOMMON_OGC_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_OGC_NAMESPACE_PREFIX);
+  psNsOgc = xmlNewNs(NULL, BAD_CAST MS_OWSCOMMON_OGC_NAMESPACE_URI,
+                     BAD_CAST MS_OWSCOMMON_OGC_NAMESPACE_PREFIX);
   xmlAddChild(psRootNode, FLTGetCapabilities(psNsOgc, psNsOgc, MS_FALSE));
   /* -------------------------------------------------------------------- */
   /*      Write out the document.                                         */
   /* -------------------------------------------------------------------- */
 
-  if( msIO_needBinaryStdout() == MS_FAILURE )
+  if (msIO_needBinaryStdout() == MS_FAILURE)
     return MS_FAILURE;
 
-  msIO_setHeader("Content-Type","text/xml; charset=UTF-8");
+  msIO_setHeader("Content-Type", "text/xml; charset=UTF-8");
   msIO_sendHeaders();
 
   context = msIO_getHandler(stdout);
@@ -520,31 +559,30 @@ int msWFSGetCapabilities11(mapObj *map,
 
   xmlCleanupParser();
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
-
 #endif /*defined(USE_WFS_SVR) && defined(USE_LIBXML2)*/
 
 #if defined(USE_WFS_SVR) && !defined(USE_LIBXML2)
 
-
-
 int msWFSGetCapabilities11(mapObj *map, wfsParamsObj *params,
                            cgiRequestObj *req, owsRequestObj *ows_request)
 
 {
-  msSetError( MS_WFSERR,
-              "WFS 1.1 request made, but mapserver requires libxml2 for WFS 1.1 services and this is not configured.",
-              "msWFSGetCapabilities11()" );
+  msSetError(MS_WFSERR,
+             "WFS 1.1 request made, but mapserver requires libxml2 for WFS 1.1 "
+             "services and this is not configured.",
+             "msWFSGetCapabilities11()");
 
-  return msWFSException11(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE, params->pszVersion);
+  return msWFSException11(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE,
+                          params->pszVersion);
 }
 
-int msWFSException11(mapObj *map, const char *locator, const char *exceptionCode, const char *version)
-{
+int msWFSException11(mapObj *map, const char *locator,
+                     const char *exceptionCode, const char *version) {
   /* fallback to reporting using 1.0 style exceptions. */
-  return msWFSException( map, locator, exceptionCode, "1.0.0" );
+  return msWFSException(map, locator, exceptionCode, "1.0.0");
 }
 
 #endif /* defined(USE_WFS_SVR) && !defined(USE_LIBXML2) */
diff -pruN 8.0.1-5/mapwfs20.c 8.0.2-1/mapwfs20.c
--- 8.0.1-5/mapwfs20.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapwfs20.c	2024-06-11 20:41:34.000000000 +0000
@@ -3,8 +3,8 @@
  *
  * Project:  MapServer
  * Purpose:  OGC WFS 2.0.0 implementation. This file holds some WFS 2.0.0
- *           specific functions but other parts are still implemented in mapwfs.c.
- * Author:   Even Rouault
+ *           specific functions but other parts are still implemented in
+ *mapwfs.c. Author:   Even Rouault
  *
  **********************************************************************
  * Copyright (c) 2013, Even Rouault
@@ -35,77 +35,79 @@
 #include "mapowscommon.h"
 #include "mapogcfilter.h"
 
-#define MS_OWS_11_NAMESPACE_PREFIX       MS_OWSCOMMON_OWS_NAMESPACE_PREFIX
-#define MS_OWS_11_NAMESPACE_URI          MS_OWSCOMMON_OWS_110_NAMESPACE_URI
+#define MS_OWS_11_NAMESPACE_PREFIX MS_OWSCOMMON_OWS_NAMESPACE_PREFIX
+#define MS_OWS_11_NAMESPACE_URI MS_OWSCOMMON_OWS_110_NAMESPACE_URI
 
 #define URN_GET_FEATURE_BY_ID "urn:ogc:def:query:OGC-WFS::GetFeatureById"
 
-#define GET_FEATURE_BY_ID \
-"<StoredQueryDescription id=\"" URN_GET_FEATURE_BY_ID "\">" \
-"<Title>Get feature by identifier</Title>" \
-"<Abstract>Returns the single feature whose value is equal to the specified value of the ID argument</Abstract>" \
-"<Parameter name=\"ID\" xmlns:xs=\"http://www.w3.org/2001/XMLSchema\" type=\"xs:string\"/>" \
-"<QueryExpressionText isPrivate=\"true\" language=\"urn:ogc:def:queryLanguage:OGC-WFS::WFS_QueryExpression\" returnFeatureTypes=\"\">" \
-"<Query xmlns:fes=\"http://www.opengis.net/fes/2.0\" typeNames=\"?\">" \
-"<fes:Filter><fes:ResourceId rid=\"${ID}\"/></fes:Filter>" \
-"</Query>" \
-"</QueryExpressionText>" \
-"</StoredQueryDescription>"
+#define GET_FEATURE_BY_ID                                                      \
+  "<StoredQueryDescription id=\"" URN_GET_FEATURE_BY_ID "\">"                  \
+  "<Title>Get feature by identifier</Title>"                                   \
+  "<Abstract>Returns the single feature whose value is equal to the "          \
+  "specified value of the ID argument</Abstract>"                              \
+  "<Parameter name=\"ID\" xmlns:xs=\"http://www.w3.org/2001/XMLSchema\" "      \
+  "type=\"xs:string\"/>"                                                       \
+  "<QueryExpressionText isPrivate=\"true\" "                                   \
+  "language=\"urn:ogc:def:queryLanguage:OGC-WFS::WFS_QueryExpression\" "       \
+  "returnFeatureTypes=\"\">"                                                   \
+  "<Query xmlns:fes=\"http://www.opengis.net/fes/2.0\" typeNames=\"?\">"       \
+  "<fes:Filter><fes:ResourceId rid=\"${ID}\"/></fes:Filter>"                   \
+  "</Query>"                                                                   \
+  "</QueryExpressionText>"                                                     \
+  "</StoredQueryDescription>"
 
 /************************************************************************/
 /*                          msWFSException20()                          */
 /************************************************************************/
 
 int msWFSException20(mapObj *map, const char *locator,
-                     const char *exceptionCode)
-{
+                     const char *exceptionCode) {
   int size = 0;
-  char *errorString     = NULL;
+  char *errorString = NULL;
 
-  xmlDocPtr  psDoc      = NULL;
+  xmlDocPtr psDoc = NULL;
   xmlNodePtr psRootNode = NULL;
-  xmlNsPtr   psNsOws    = NULL;
-  xmlChar *buffer       = NULL;
-  const char* status    = NULL;
+  xmlNsPtr psNsOws = NULL;
+  xmlChar *buffer = NULL;
+  const char *status = NULL;
 
-  psNsOws = xmlNewNs(NULL, BAD_CAST MS_OWS_11_NAMESPACE_URI, BAD_CAST MS_OWS_11_NAMESPACE_PREFIX);
+  psNsOws = xmlNewNs(NULL, BAD_CAST MS_OWS_11_NAMESPACE_URI,
+                     BAD_CAST MS_OWS_11_NAMESPACE_PREFIX);
 
   errorString = msGetErrorString("\n");
 
   psDoc = xmlNewDoc(BAD_CAST "1.0");
 
-  psRootNode = msOWSCommonExceptionReport(psNsOws, OWS_1_1_0, msOWSGetSchemasLocation(map), "2.0.0", msOWSGetLanguage(map, "exception"), exceptionCode, locator, errorString);
+  psRootNode = msOWSCommonExceptionReport(
+      psNsOws, OWS_1_1_0, msOWSGetSchemasLocation(map), "2.0.0",
+      msOWSGetLanguage(map, "exception"), exceptionCode, locator, errorString);
 
   xmlDocSetRootElement(psDoc, psRootNode);
 
-  xmlNewNs(psRootNode, BAD_CAST MS_OWS_11_NAMESPACE_URI, BAD_CAST MS_OWS_11_NAMESPACE_PREFIX);
+  xmlNewNs(psRootNode, BAD_CAST MS_OWS_11_NAMESPACE_URI,
+           BAD_CAST MS_OWS_11_NAMESPACE_PREFIX);
 
   /* Table D.2 OGC 09-025r1 - For CITE compliance */
-  if( EQUAL(exceptionCode, MS_OWS_ERROR_OPERATION_NOT_SUPPORTED) ||
-      EQUAL(exceptionCode, MS_OWS_ERROR_OPTION_NOT_SUPPORTED) ) {
+  if (EQUAL(exceptionCode, MS_OWS_ERROR_OPERATION_NOT_SUPPORTED) ||
+      EQUAL(exceptionCode, MS_OWS_ERROR_OPTION_NOT_SUPPORTED)) {
     status = "400 Not Implemented";
-  }
-  else if( EQUAL(exceptionCode, MS_OWS_ERROR_MISSING_PARAMETER_VALUE) ||
-           EQUAL(exceptionCode, MS_OWS_ERROR_INVALID_PARAMETER_VALUE) ||
-           EQUAL(exceptionCode, MS_OWS_ERROR_VERSION_NEGOTIATION_FAILED) ||
-           EQUAL(exceptionCode, MS_OWS_ERROR_INVALID_UPDATE_SEQUENCE) ) {
+  } else if (EQUAL(exceptionCode, MS_OWS_ERROR_MISSING_PARAMETER_VALUE) ||
+             EQUAL(exceptionCode, MS_OWS_ERROR_INVALID_PARAMETER_VALUE) ||
+             EQUAL(exceptionCode, MS_OWS_ERROR_VERSION_NEGOTIATION_FAILED) ||
+             EQUAL(exceptionCode, MS_OWS_ERROR_INVALID_UPDATE_SEQUENCE)) {
     status = "400 Bad request";
-  }
-  else if( EQUAL(exceptionCode, MS_WFS_ERROR_OPERATION_PROCESSING_FAILED) ) {
+  } else if (EQUAL(exceptionCode, MS_WFS_ERROR_OPERATION_PROCESSING_FAILED)) {
     status = "403 Server processing failed";
-  }
-  else if( EQUAL(exceptionCode, MS_OWS_ERROR_NOT_FOUND) ) {
+  } else if (EQUAL(exceptionCode, MS_OWS_ERROR_NOT_FOUND)) {
     status = "404 Not Found";
-  }
-  else if( EQUAL(exceptionCode, MS_OWS_ERROR_NO_APPLICABLE_CODE) ) {
+  } else if (EQUAL(exceptionCode, MS_OWS_ERROR_NO_APPLICABLE_CODE)) {
     status = "400 Internal Server Error";
   }
 
-  if( status != NULL )
-  {
+  if (status != NULL) {
     msIO_setHeader("Status", "%s", status);
   }
-  msIO_setHeader("Content-Type","text/xml; charset=UTF-8");
+  msIO_setHeader("Content-Type", "text/xml; charset=UTF-8");
   msIO_sendHeaders();
 
   xmlDocDumpFormatMemoryEnc(psDoc, &buffer, &size, "UTF-8", 1);
@@ -127,35 +129,34 @@ int msWFSException20(mapObj *map, const
 /************************************************************************/
 /*                          msWFSIncludeSection                         */
 /************************************************************************/
-static int msWFSIncludeSection(wfsParamsObj *params, const char* pszSection)
-{
-    int i;
-    if( params->pszSections == NULL )
-        return TRUE;
-    for(i = 0; params->pszSections[i] != '\0'; i++ )
-    {
-        if( strncasecmp( params->pszSections + i, "All", strlen("All")) == 0 )
-            return TRUE;
-        if( strncasecmp( params->pszSections + i, pszSection, strlen(pszSection)) == 0 )
-            return TRUE;
-    }
-    return FALSE;
+static int msWFSIncludeSection(wfsParamsObj *params, const char *pszSection) {
+  int i;
+  if (params->pszSections == NULL)
+    return TRUE;
+  for (i = 0; params->pszSections[i] != '\0'; i++) {
+    if (strncasecmp(params->pszSections + i, "All", strlen("All")) == 0)
+      return TRUE;
+    if (strncasecmp(params->pszSections + i, pszSection, strlen(pszSection)) ==
+        0)
+      return TRUE;
+  }
+  return FALSE;
 }
 
 /************************************************************************/
 /*                       msWFSConstraintDefaultValue                    */
 /************************************************************************/
 
-static
-xmlNodePtr msWFSConstraintDefaultValue(xmlNsPtr psNs, xmlNsPtr psNsOws, const char *name, const char* value)
-{
+static xmlNodePtr msWFSConstraintDefaultValue(xmlNsPtr psNs, xmlNsPtr psNsOws,
+                                              const char *name,
+                                              const char *value) {
   xmlNodePtr psRootNode = NULL;
 
   psRootNode = xmlNewNode(psNs, BAD_CAST "Constraint");
 
   xmlNewProp(psRootNode, BAD_CAST "name", BAD_CAST name);
 
-  xmlNewChild(psRootNode, psNsOws, BAD_CAST "NoValues", NULL );
+  xmlNewChild(psRootNode, psNsOws, BAD_CAST "NoValues", NULL);
   xmlNewTextChild(psRootNode, psNsOws, BAD_CAST "DefaultValue", BAD_CAST value);
 
   return psRootNode;
@@ -165,77 +166,120 @@ xmlNodePtr msWFSConstraintDefaultValue(x
 /*                              msWFSOperator                           */
 /************************************************************************/
 
-static
-xmlNodePtr msWFSOperator(xmlNsPtr psNsFES, const char* pszOperatorType, const char* pszOperator)
-{
-    xmlNodePtr psNode = xmlNewNode(psNsFES, BAD_CAST pszOperatorType);
-    xmlNewProp(psNode, BAD_CAST "name", BAD_CAST pszOperator);
-    return psNode;
+static xmlNodePtr msWFSOperator(xmlNsPtr psNsFES, const char *pszOperatorType,
+                                const char *pszOperator) {
+  xmlNodePtr psNode = xmlNewNode(psNsFES, BAD_CAST pszOperatorType);
+  xmlNewProp(psNode, BAD_CAST "name", BAD_CAST pszOperator);
+  return psNode;
 }
 
 /************************************************************************/
 /*                       msWFS20FilterCapabilities                      */
 /************************************************************************/
 
-static
-xmlNodePtr msWFS20FilterCapabilities(xmlNsPtr psNsFES, xmlNsPtr psNsOws,
-                                     int bImplementsSorting)
-{
+static xmlNodePtr msWFS20FilterCapabilities(xmlNsPtr psNsFES, xmlNsPtr psNsOws,
+                                            int bImplementsSorting) {
   xmlNodePtr psRootNode = NULL, psNode = NULL, psSubNode = NULL;
 
   psRootNode = xmlNewNode(psNsFES, BAD_CAST "Filter_Capabilities");
-  
+
   psNode = xmlNewChild(psRootNode, psNsFES, BAD_CAST "Conformance", NULL);
-  
-    xmlAddChild(psNode, msWFSConstraintDefaultValue(psNsFES, psNsOws, "ImplementsQuery", "TRUE"));
-    xmlAddChild(psNode, msWFSConstraintDefaultValue(psNsFES, psNsOws, "ImplementsAdHocQuery", "TRUE"));
-    xmlAddChild(psNode, msWFSConstraintDefaultValue(psNsFES, psNsOws, "ImplementsFunctions", "FALSE"));
-    xmlAddChild(psNode, msWFSConstraintDefaultValue(psNsFES, psNsOws, "ImplementsResourceId", "TRUE"));
-    xmlAddChild(psNode, msWFSConstraintDefaultValue(psNsFES, psNsOws, "ImplementsMinStandardFilter", "TRUE"));
-    xmlAddChild(psNode, msWFSConstraintDefaultValue(psNsFES, psNsOws, "ImplementsStandardFilter", "TRUE"));
-    xmlAddChild(psNode, msWFSConstraintDefaultValue(psNsFES, psNsOws, "ImplementsMinSpatialFilter", "TRUE"));
-    xmlAddChild(psNode, msWFSConstraintDefaultValue(psNsFES, psNsOws, "ImplementsSpatialFilter", "FALSE"));
-    xmlAddChild(psNode, msWFSConstraintDefaultValue(psNsFES, psNsOws, "ImplementsMinTemporalFilter", "TRUE"));
-    xmlAddChild(psNode, msWFSConstraintDefaultValue(psNsFES, psNsOws, "ImplementsTemporalFilter", "FALSE"));
-    xmlAddChild(psNode, msWFSConstraintDefaultValue(psNsFES, psNsOws, "ImplementsVersionNav", "FALSE"));
-    xmlAddChild(psNode, msWFSConstraintDefaultValue(psNsFES, psNsOws, "ImplementsSorting", ( bImplementsSorting ) ? "TRUE" : "FALSE"));
-    xmlAddChild(psNode, msWFSConstraintDefaultValue(psNsFES, psNsOws, "ImplementsExtendedOperators", "FALSE"));
-    xmlAddChild(psNode, msWFSConstraintDefaultValue(psNsFES, psNsOws, "ImplementsMinimumXPath", "TRUE"));
-    xmlAddChild(psNode, msWFSConstraintDefaultValue(psNsFES, psNsOws, "ImplementsSchemaElementFunc", "FALSE"));
+
+  xmlAddChild(psNode, msWFSConstraintDefaultValue(psNsFES, psNsOws,
+                                                  "ImplementsQuery", "TRUE"));
+  xmlAddChild(psNode, msWFSConstraintDefaultValue(
+                          psNsFES, psNsOws, "ImplementsAdHocQuery", "TRUE"));
+  xmlAddChild(psNode, msWFSConstraintDefaultValue(
+                          psNsFES, psNsOws, "ImplementsFunctions", "FALSE"));
+  xmlAddChild(psNode, msWFSConstraintDefaultValue(
+                          psNsFES, psNsOws, "ImplementsResourceId", "TRUE"));
+  xmlAddChild(psNode, msWFSConstraintDefaultValue(psNsFES, psNsOws,
+                                                  "ImplementsMinStandardFilter",
+                                                  "TRUE"));
+  xmlAddChild(psNode,
+              msWFSConstraintDefaultValue(psNsFES, psNsOws,
+                                          "ImplementsStandardFilter", "TRUE"));
+  xmlAddChild(psNode, msWFSConstraintDefaultValue(psNsFES, psNsOws,
+                                                  "ImplementsMinSpatialFilter",
+                                                  "TRUE"));
+  xmlAddChild(psNode,
+              msWFSConstraintDefaultValue(psNsFES, psNsOws,
+                                          "ImplementsSpatialFilter", "FALSE"));
+  xmlAddChild(psNode, msWFSConstraintDefaultValue(psNsFES, psNsOws,
+                                                  "ImplementsMinTemporalFilter",
+                                                  "TRUE"));
+  xmlAddChild(psNode,
+              msWFSConstraintDefaultValue(psNsFES, psNsOws,
+                                          "ImplementsTemporalFilter", "FALSE"));
+  xmlAddChild(psNode, msWFSConstraintDefaultValue(
+                          psNsFES, psNsOws, "ImplementsVersionNav", "FALSE"));
+  xmlAddChild(psNode, msWFSConstraintDefaultValue(
+                          psNsFES, psNsOws, "ImplementsSorting",
+                          (bImplementsSorting) ? "TRUE" : "FALSE"));
+  xmlAddChild(psNode, msWFSConstraintDefaultValue(psNsFES, psNsOws,
+                                                  "ImplementsExtendedOperators",
+                                                  "FALSE"));
+  xmlAddChild(psNode, msWFSConstraintDefaultValue(
+                          psNsFES, psNsOws, "ImplementsMinimumXPath", "TRUE"));
+  xmlAddChild(psNode, msWFSConstraintDefaultValue(psNsFES, psNsOws,
+                                                  "ImplementsSchemaElementFunc",
+                                                  "FALSE"));
 
   psNode = xmlNewChild(psRootNode, psNsFES, BAD_CAST "Id_Capabilities", NULL);
-    psSubNode = xmlNewChild(psNode, psNsFES, BAD_CAST "ResourceIdentifier", NULL );
-    xmlNewProp(psSubNode, BAD_CAST "name", BAD_CAST "fes:ResourceId");
+  psSubNode = xmlNewChild(psNode, psNsFES, BAD_CAST "ResourceIdentifier", NULL);
+  xmlNewProp(psSubNode, BAD_CAST "name", BAD_CAST "fes:ResourceId");
 
-  psNode = xmlNewChild(psRootNode, psNsFES, BAD_CAST "Scalar_Capabilities", NULL);
+  psNode =
+      xmlNewChild(psRootNode, psNsFES, BAD_CAST "Scalar_Capabilities", NULL);
   xmlNewChild(psNode, psNsFES, BAD_CAST "LogicalOperators", NULL);
   psNode = xmlNewChild(psNode, psNsFES, BAD_CAST "ComparisonOperators", NULL);
-  xmlAddChild(psNode, msWFSOperator(psNsFES, "ComparisonOperator", "PropertyIsEqualTo"));
-  xmlAddChild(psNode, msWFSOperator(psNsFES, "ComparisonOperator", "PropertyIsNotEqualTo"));
-  xmlAddChild(psNode, msWFSOperator(psNsFES, "ComparisonOperator", "PropertyIsLessThan"));
-  xmlAddChild(psNode, msWFSOperator(psNsFES, "ComparisonOperator", "PropertyIsGreaterThan"));
-  xmlAddChild(psNode, msWFSOperator(psNsFES, "ComparisonOperator", "PropertyIsLessThanOrEqualTo"));
-  xmlAddChild(psNode, msWFSOperator(psNsFES, "ComparisonOperator", "PropertyIsGreaterThanOrEqualTo"));
-  xmlAddChild(psNode, msWFSOperator(psNsFES, "ComparisonOperator", "PropertyIsLike"));
-  xmlAddChild(psNode, msWFSOperator(psNsFES, "ComparisonOperator", "PropertyIsBetween"));
+  xmlAddChild(psNode, msWFSOperator(psNsFES, "ComparisonOperator",
+                                    "PropertyIsEqualTo"));
+  xmlAddChild(psNode, msWFSOperator(psNsFES, "ComparisonOperator",
+                                    "PropertyIsNotEqualTo"));
+  xmlAddChild(psNode, msWFSOperator(psNsFES, "ComparisonOperator",
+                                    "PropertyIsLessThan"));
+  xmlAddChild(psNode, msWFSOperator(psNsFES, "ComparisonOperator",
+                                    "PropertyIsGreaterThan"));
+  xmlAddChild(psNode, msWFSOperator(psNsFES, "ComparisonOperator",
+                                    "PropertyIsLessThanOrEqualTo"));
+  xmlAddChild(psNode, msWFSOperator(psNsFES, "ComparisonOperator",
+                                    "PropertyIsGreaterThanOrEqualTo"));
+  xmlAddChild(psNode,
+              msWFSOperator(psNsFES, "ComparisonOperator", "PropertyIsLike"));
+  xmlAddChild(psNode, msWFSOperator(psNsFES, "ComparisonOperator",
+                                    "PropertyIsBetween"));
   /* Missing: PropertyIsNull, PropertyIsNil */
 
-  psNode = xmlNewChild(psRootNode, psNsFES, BAD_CAST "Spatial_Capabilities", NULL);
+  psNode =
+      xmlNewChild(psRootNode, psNsFES, BAD_CAST "Spatial_Capabilities", NULL);
 
   psSubNode = xmlNewChild(psNode, psNsFES, BAD_CAST "GeometryOperands", NULL);
-  xmlAddChild(psSubNode, msWFSOperator(psNsFES, "GeometryOperand", "gml:Point"));
-  xmlAddChild(psSubNode, msWFSOperator(psNsFES, "GeometryOperand", "gml:MultiPoint"));
-  xmlAddChild(psSubNode, msWFSOperator(psNsFES, "GeometryOperand", "gml:LineString"));
-  xmlAddChild(psSubNode, msWFSOperator(psNsFES, "GeometryOperand", "gml:MultiLineString"));
-  xmlAddChild(psSubNode, msWFSOperator(psNsFES, "GeometryOperand", "gml:Curve"));
-  xmlAddChild(psSubNode, msWFSOperator(psNsFES, "GeometryOperand", "gml:MultiCurve"));
-  xmlAddChild(psSubNode, msWFSOperator(psNsFES, "GeometryOperand", "gml:Polygon"));
-  xmlAddChild(psSubNode, msWFSOperator(psNsFES, "GeometryOperand", "gml:MultiPolygon"));
-  xmlAddChild(psSubNode, msWFSOperator(psNsFES, "GeometryOperand", "gml:Surface"));
-  xmlAddChild(psSubNode, msWFSOperator(psNsFES, "GeometryOperand", "gml:MultiSurface"));
-  /* xmlAddChild(psSubNode, msWFSOperator(psNsFES, "GeometryOperand", "gml:MultiGeometry")); */
+  xmlAddChild(psSubNode,
+              msWFSOperator(psNsFES, "GeometryOperand", "gml:Point"));
+  xmlAddChild(psSubNode,
+              msWFSOperator(psNsFES, "GeometryOperand", "gml:MultiPoint"));
+  xmlAddChild(psSubNode,
+              msWFSOperator(psNsFES, "GeometryOperand", "gml:LineString"));
+  xmlAddChild(psSubNode,
+              msWFSOperator(psNsFES, "GeometryOperand", "gml:MultiLineString"));
+  xmlAddChild(psSubNode,
+              msWFSOperator(psNsFES, "GeometryOperand", "gml:Curve"));
+  xmlAddChild(psSubNode,
+              msWFSOperator(psNsFES, "GeometryOperand", "gml:MultiCurve"));
+  xmlAddChild(psSubNode,
+              msWFSOperator(psNsFES, "GeometryOperand", "gml:Polygon"));
+  xmlAddChild(psSubNode,
+              msWFSOperator(psNsFES, "GeometryOperand", "gml:MultiPolygon"));
+  xmlAddChild(psSubNode,
+              msWFSOperator(psNsFES, "GeometryOperand", "gml:Surface"));
+  xmlAddChild(psSubNode,
+              msWFSOperator(psNsFES, "GeometryOperand", "gml:MultiSurface"));
+  /* xmlAddChild(psSubNode, msWFSOperator(psNsFES, "GeometryOperand",
+   * "gml:MultiGeometry")); */
   xmlAddChild(psSubNode, msWFSOperator(psNsFES, "GeometryOperand", "gml:Box"));
-  xmlAddChild(psSubNode, msWFSOperator(psNsFES, "GeometryOperand", "gml:Envelope"));
+  xmlAddChild(psSubNode,
+              msWFSOperator(psNsFES, "GeometryOperand", "gml:Envelope"));
 
   psSubNode = xmlNewChild(psNode, psNsFES, BAD_CAST "SpatialOperators", NULL);
 #ifdef USE_GEOS
@@ -245,20 +289,24 @@ xmlNodePtr msWFS20FilterCapabilities(xml
   xmlAddChild(psSubNode, msWFSOperator(psNsFES, "SpatialOperator", "Within"));
   xmlAddChild(psSubNode, msWFSOperator(psNsFES, "SpatialOperator", "Overlaps"));
   xmlAddChild(psSubNode, msWFSOperator(psNsFES, "SpatialOperator", "Crosses"));
-  xmlAddChild(psSubNode, msWFSOperator(psNsFES, "SpatialOperator", "Intersects"));
+  xmlAddChild(psSubNode,
+              msWFSOperator(psNsFES, "SpatialOperator", "Intersects"));
   xmlAddChild(psSubNode, msWFSOperator(psNsFES, "SpatialOperator", "Contains"));
   xmlAddChild(psSubNode, msWFSOperator(psNsFES, "SpatialOperator", "DWithin"));
   xmlAddChild(psSubNode, msWFSOperator(psNsFES, "SpatialOperator", "Beyond"));
 #endif
   xmlAddChild(psSubNode, msWFSOperator(psNsFES, "SpatialOperator", "BBOX"));
 
-  psNode = xmlNewChild(psRootNode, psNsFES, BAD_CAST "Temporal_Capabilities", NULL);
-    psSubNode = xmlNewChild(psNode, psNsFES, BAD_CAST "TemporalOperands", NULL);
-    xmlAddChild(psSubNode, msWFSOperator(psNsFES, "TemporalOperand", "gml:TimePeriod"));
-    xmlAddChild(psSubNode, msWFSOperator(psNsFES, "TemporalOperand", "gml:TimeInstant"));
+  psNode =
+      xmlNewChild(psRootNode, psNsFES, BAD_CAST "Temporal_Capabilities", NULL);
+  psSubNode = xmlNewChild(psNode, psNsFES, BAD_CAST "TemporalOperands", NULL);
+  xmlAddChild(psSubNode,
+              msWFSOperator(psNsFES, "TemporalOperand", "gml:TimePeriod"));
+  xmlAddChild(psSubNode,
+              msWFSOperator(psNsFES, "TemporalOperand", "gml:TimeInstant"));
 
-    psSubNode = xmlNewChild(psNode, psNsFES, BAD_CAST "TemporalOperators", NULL);
-    xmlAddChild(psSubNode, msWFSOperator(psNsFES, "TemporalOperator", "During"));
+  psSubNode = xmlNewChild(psNode, psNsFES, BAD_CAST "TemporalOperators", NULL);
+  xmlAddChild(psSubNode, msWFSOperator(psNsFES, "TemporalOperator", "During"));
 
   return psRootNode;
 }
@@ -267,77 +315,76 @@ xmlNodePtr msWFS20FilterCapabilities(xml
 /*                          msXMLStripIndentation                       */
 /************************************************************************/
 
-static void msXMLStripIndentation(char* ptr)
-{
-    /* Remove spaces between > and < to get properly indented result */
-    char* afterLastClosingBracket = NULL;
-    if( *ptr == ' ' )
-        afterLastClosingBracket = ptr;
-    while( *ptr != '\0' )
-    {
-        if( *ptr == '<' && afterLastClosingBracket != NULL )
-        {
-            memmove(afterLastClosingBracket, ptr, strlen(ptr) + 1);
-            ptr = afterLastClosingBracket;
-        }
-        else if( *ptr == '>' )
-        {
-            afterLastClosingBracket = ptr + 1;
-        }
-        else if( *ptr != ' ' &&  *ptr != '\n' )
-            afterLastClosingBracket = NULL;
-        ptr ++;
-    }
+static void msXMLStripIndentation(char *ptr) {
+  /* Remove spaces between > and < to get properly indented result */
+  char *afterLastClosingBracket = NULL;
+  if (*ptr == ' ')
+    afterLastClosingBracket = ptr;
+  while (*ptr != '\0') {
+    if (*ptr == '<' && afterLastClosingBracket != NULL) {
+      memmove(afterLastClosingBracket, ptr, strlen(ptr) + 1);
+      ptr = afterLastClosingBracket;
+    } else if (*ptr == '>') {
+      afterLastClosingBracket = ptr + 1;
+    } else if (*ptr != ' ' && *ptr != '\n')
+      afterLastClosingBracket = NULL;
+    ptr++;
+  }
 }
 
 /************************************************************************/
 /*                          msWFSAddInspireDSID                         */
 /************************************************************************/
 
-static void msWFSAddInspireDSID(mapObj *map,
-                                xmlNsPtr psNsInspireDls,
+static void msWFSAddInspireDSID(mapObj *map, xmlNsPtr psNsInspireDls,
                                 xmlNsPtr psNsInspireCommon,
-                                xmlNodePtr pDlsExtendedCapabilities)
-{
-    const char* dsid_code = msOWSLookupMetadata(&(map->web.metadata), "FO", "inspire_dsid_code");
-    const char* dsid_ns = msOWSLookupMetadata(&(map->web.metadata), "FO", "inspire_dsid_ns");
-    if( dsid_code == NULL )
-    {
-        xmlAddChild(pDlsExtendedCapabilities, xmlNewComment(BAD_CAST "WARNING: Required metadata \"inspire_dsid_code\" missing"));
-    }
-    else
-    {
-        int ntokensCode = 0, ntokensNS = 0;
-        char** tokensCode;
-        char** tokensNS = NULL;
-        int i;
-
-        tokensCode = msStringSplit(dsid_code, ',', &ntokensCode);
-        if( dsid_ns != NULL )
-            tokensNS = msStringSplitComplex( dsid_ns, ",", &ntokensNS, MS_ALLOWEMPTYTOKENS);
-        if( ntokensNS > 0 && ntokensNS != ntokensCode )
-        {
-            xmlAddChild(pDlsExtendedCapabilities,
-                        xmlNewComment(BAD_CAST "WARNING: \"inspire_dsid_code\" and \"inspire_dsid_ns\" have not the same number of elements. Ignoring inspire_dsid_ns"));
-            msFreeCharArray(tokensNS, ntokensNS);
-            tokensNS = NULL;
-            ntokensNS = 0;
-        }
-        for(i = 0; i<ntokensCode; i++ )
-        {
-            xmlNodePtr pSDSI = xmlNewNode(psNsInspireDls, BAD_CAST "SpatialDataSetIdentifier");
-            xmlAddChild(pDlsExtendedCapabilities, pSDSI);
-            xmlNewTextChild(pSDSI, psNsInspireCommon, BAD_CAST "Code", BAD_CAST tokensCode[i]);
-            if( ntokensNS > 0 && tokensNS[i][0] != '\0' )
-                xmlNewTextChild(pSDSI, psNsInspireCommon, BAD_CAST "Namespace", BAD_CAST tokensNS[i]);
-        }
-        msFreeCharArray(tokensCode, ntokensCode);
-        if( ntokensNS > 0 )
-            msFreeCharArray(tokensNS, ntokensNS);
-    }
-}
-
+                                xmlNodePtr pDlsExtendedCapabilities) {
+  const char *dsid_code =
+      msOWSLookupMetadata(&(map->web.metadata), "FO", "inspire_dsid_code");
+  const char *dsid_ns =
+      msOWSLookupMetadata(&(map->web.metadata), "FO", "inspire_dsid_ns");
+  if (dsid_code == NULL) {
+    xmlAddChild(
+        pDlsExtendedCapabilities,
+        xmlNewComment(
+            BAD_CAST
+            "WARNING: Required metadata \"inspire_dsid_code\" missing"));
+  } else {
+    int ntokensCode = 0, ntokensNS = 0;
+    char **tokensCode;
+    char **tokensNS = NULL;
+    int i;
 
+    tokensCode = msStringSplit(dsid_code, ',', &ntokensCode);
+    if (dsid_ns != NULL)
+      tokensNS =
+          msStringSplitComplex(dsid_ns, ",", &ntokensNS, MS_ALLOWEMPTYTOKENS);
+    if (ntokensNS > 0 && ntokensNS != ntokensCode) {
+      xmlAddChild(
+          pDlsExtendedCapabilities,
+          xmlNewComment(
+              BAD_CAST
+              "WARNING: \"inspire_dsid_code\" and \"inspire_dsid_ns\" have not "
+              "the same number of elements. Ignoring inspire_dsid_ns"));
+      msFreeCharArray(tokensNS, ntokensNS);
+      tokensNS = NULL;
+      ntokensNS = 0;
+    }
+    for (i = 0; i < ntokensCode; i++) {
+      xmlNodePtr pSDSI =
+          xmlNewNode(psNsInspireDls, BAD_CAST "SpatialDataSetIdentifier");
+      xmlAddChild(pDlsExtendedCapabilities, pSDSI);
+      xmlNewTextChild(pSDSI, psNsInspireCommon, BAD_CAST "Code",
+                      BAD_CAST tokensCode[i]);
+      if (ntokensNS > 0 && tokensNS[i][0] != '\0')
+        xmlNewTextChild(pSDSI, psNsInspireCommon, BAD_CAST "Namespace",
+                        BAD_CAST tokensNS[i]);
+    }
+    msFreeCharArray(tokensCode, ntokensCode);
+    if (ntokensNS > 0)
+      msFreeCharArray(tokensNS, ntokensNS);
+  }
+}
 
 /************************************************************************/
 /*                          msWFSGetCapabilities20                      */
@@ -345,11 +392,10 @@ static void msWFSAddInspireDSID(mapObj *
 /*      Return the capabilities document for WFS 2.0.0                  */
 /************************************************************************/
 int msWFSGetCapabilities20(mapObj *map, wfsParamsObj *params,
-                           cgiRequestObj *req, owsRequestObj *ows_request)
-{
-  xmlDocPtr psDoc = NULL;       /* document pointer */
+                           cgiRequestObj *req, owsRequestObj *ows_request) {
+  xmlDocPtr psDoc = NULL; /* document pointer */
   xmlNodePtr psRootNode, psMainNode, psNode, psFtNode = NULL;
-  const char *updatesequence=NULL;
+  const char *updatesequence = NULL;
   xmlNsPtr psNsOws, psNsXLink;
   xmlNsPtr psNsFES = NULL;
   xmlNsPtr psNsInspireCommon = NULL;
@@ -358,9 +404,10 @@ int msWFSGetCapabilities20(mapObj *map,
   char *xsi_schemaLocation = NULL;
   const char *user_namespace_prefix = NULL;
   const char *user_namespace_uri = NULL;
-  gmlNamespaceListObj *namespaceList=NULL; /* for external application schema support */
+  gmlNamespaceListObj *namespaceList =
+      NULL; /* for external application schema support */
 
-  char *script_url=NULL, *formats_list;
+  char *script_url = NULL, *formats_list;
   const char *value = NULL;
 
   xmlChar *buffer = NULL;
@@ -370,15 +417,15 @@ int msWFSGetCapabilities20(mapObj *map,
   int ows_version = OWS_1_1_0;
   int ret;
 
-  char* validated_language;
+  char *validated_language;
   int bImplementsSorting = MS_FALSE;
 
   /* -------------------------------------------------------------------- */
   /*      Handle updatesequence                                           */
   /* -------------------------------------------------------------------- */
   ret = msWFSHandleUpdateSequence(map, params, "msWFSGetCapabilities20()");
-  if( ret != MS_SUCCESS )
-      return ret;
+  if (ret != MS_SUCCESS)
+    return ret;
 
   validated_language = msOWSGetLanguageFromList(map, "FO", params->pszLanguage);
 
@@ -394,52 +441,71 @@ int msWFSGetCapabilities20(mapObj *map,
   /* -------------------------------------------------------------------- */
   /*      Name spaces                                                     */
   /* -------------------------------------------------------------------- */
-  
-  /*default name space*/
-  xmlNewProp(psRootNode, BAD_CAST "xmlns", BAD_CAST MS_OWSCOMMON_WFS_20_NAMESPACE_URI);
 
-  xmlSetNs(psRootNode, xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_GML_32_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_GML_NAMESPACE_PREFIX));
-  xmlSetNs(psRootNode, xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_WFS_20_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_WFS_NAMESPACE_PREFIX));
+  /*default name space*/
+  xmlNewProp(psRootNode, BAD_CAST "xmlns",
+             BAD_CAST MS_OWSCOMMON_WFS_20_NAMESPACE_URI);
 
-  psNsOws = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OWS_110_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_PREFIX);
-  psNsXLink = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_PREFIX);
-  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX);
-  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_FES_20_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_FES_20_NAMESPACE_PREFIX );
+  xmlSetNs(psRootNode,
+           xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_GML_32_NAMESPACE_URI,
+                    BAD_CAST MS_OWSCOMMON_GML_NAMESPACE_PREFIX));
+  xmlSetNs(psRootNode,
+           xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_WFS_20_NAMESPACE_URI,
+                    BAD_CAST MS_OWSCOMMON_WFS_NAMESPACE_PREFIX));
+
+  psNsOws = xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_OWS_110_NAMESPACE_URI,
+                     BAD_CAST MS_OWSCOMMON_OWS_NAMESPACE_PREFIX);
+  psNsXLink =
+      xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_URI,
+               BAD_CAST MS_OWSCOMMON_W3C_XLINK_NAMESPACE_PREFIX);
+  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI,
+           BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX);
+  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_FES_20_NAMESPACE_URI,
+           BAD_CAST MS_OWSCOMMON_FES_20_NAMESPACE_PREFIX);
 
   value = msOWSLookupMetadata(&(map->web.metadata), "FO", "namespace_uri");
-  if(value)
-      user_namespace_uri = value;
+  if (value)
+    user_namespace_uri = value;
   else
-      user_namespace_uri = MS_DEFAULT_NAMESPACE_URI;
+    user_namespace_uri = MS_DEFAULT_NAMESPACE_URI;
 
   value = msOWSLookupMetadata(&(map->web.metadata), "FO", "namespace_prefix");
-  if(value)
-      user_namespace_prefix = value;
+  if (value)
+    user_namespace_prefix = value;
   else
-      user_namespace_prefix = MS_DEFAULT_NAMESPACE_PREFIX;
+    user_namespace_prefix = MS_DEFAULT_NAMESPACE_PREFIX;
 
-  if(user_namespace_prefix != NULL && msIsXMLTagValid(user_namespace_prefix) == MS_FALSE)
-    msIO_printf("<!-- WARNING: The value '%s' is not valid XML namespace. -->\n", user_namespace_prefix);
+  if (user_namespace_prefix != NULL &&
+      msIsXMLTagValid(user_namespace_prefix) == MS_FALSE)
+    msIO_printf(
+        "<!-- WARNING: The value '%s' is not valid XML namespace. -->\n",
+        user_namespace_prefix);
   else
-    xmlNewNs(psRootNode, BAD_CAST user_namespace_uri, BAD_CAST user_namespace_prefix);
+    xmlNewNs(psRootNode, BAD_CAST user_namespace_uri,
+             BAD_CAST user_namespace_prefix);
 
   /* any additional namespaces */
   namespaceList = msGMLGetNamespaces(&(map->web), "G");
-  for(i=0; i<namespaceList->numnamespaces; i++) {
-    if(namespaceList->namespaces[i].uri) {
-      xmlNewNs(psRootNode, BAD_CAST namespaceList->namespaces[i].uri, BAD_CAST namespaceList->namespaces[i].prefix);
+  for (i = 0; i < namespaceList->numnamespaces; i++) {
+    if (namespaceList->namespaces[i].uri) {
+      xmlNewNs(psRootNode, BAD_CAST namespaceList->namespaces[i].uri,
+               BAD_CAST namespaceList->namespaces[i].prefix);
     }
   }
   msGMLFreeNamespaces(namespaceList);
 
-  if ( msOWSLookupMetadata(&(map->web.metadata), "FO", "inspire_capabilities") ) {
-      psNsInspireCommon = xmlNewNs(psRootNode, BAD_CAST MS_INSPIRE_COMMON_NAMESPACE_URI, BAD_CAST MS_INSPIRE_COMMON_NAMESPACE_PREFIX);
-      psNsInspireDls = xmlNewNs(psRootNode, BAD_CAST MS_INSPIRE_DLS_NAMESPACE_URI, BAD_CAST MS_INSPIRE_DLS_NAMESPACE_PREFIX);
+  if (msOWSLookupMetadata(&(map->web.metadata), "FO", "inspire_capabilities")) {
+    psNsInspireCommon =
+        xmlNewNs(psRootNode, BAD_CAST MS_INSPIRE_COMMON_NAMESPACE_URI,
+                 BAD_CAST MS_INSPIRE_COMMON_NAMESPACE_PREFIX);
+    psNsInspireDls = xmlNewNs(psRootNode, BAD_CAST MS_INSPIRE_DLS_NAMESPACE_URI,
+                              BAD_CAST MS_INSPIRE_DLS_NAMESPACE_PREFIX);
   }
 
-  xmlNewProp(psRootNode, BAD_CAST "version", BAD_CAST params->pszVersion );
+  xmlNewProp(psRootNode, BAD_CAST "version", BAD_CAST params->pszVersion);
 
-  updatesequence = msOWSLookupMetadata(&(map->web.metadata), "FO", "updatesequence");
+  updatesequence =
+      msOWSLookupMetadata(&(map->web.metadata), "FO", "updatesequence");
 
   if (updatesequence)
     xmlNewProp(psRootNode, BAD_CAST "updateSequence", BAD_CAST updatesequence);
@@ -447,100 +513,113 @@ int msWFSGetCapabilities20(mapObj *map,
   /*schema*/
   xsi_schemaLocation = msStrdup(MS_OWSCOMMON_WFS_20_NAMESPACE_URI);
   xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, msOWSGetSchemasLocation(map));
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, MS_OWSCOMMON_WFS_20_SCHEMA_LOCATION);
-
-  if( psNsInspireDls != NULL )
-  {
-      xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
-      xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, MS_INSPIRE_DLS_NAMESPACE_URI);
-      xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
-      xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, msOWSGetInspireSchemasLocation(map));
-      xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, MS_INSPIRE_DLS_SCHEMA_LOCATION);
-      xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
-      xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, MS_INSPIRE_COMMON_NAMESPACE_URI);
-      xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
-      xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, msOWSGetInspireSchemasLocation(map));
-      xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, MS_INSPIRE_COMMON_SCHEMA_LOCATION);
+  xsi_schemaLocation =
+      msStringConcatenate(xsi_schemaLocation, msOWSGetSchemasLocation(map));
+  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation,
+                                           MS_OWSCOMMON_WFS_20_SCHEMA_LOCATION);
+
+  if (psNsInspireDls != NULL) {
+    xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
+    xsi_schemaLocation =
+        msStringConcatenate(xsi_schemaLocation, MS_INSPIRE_DLS_NAMESPACE_URI);
+    xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
+    xsi_schemaLocation = msStringConcatenate(
+        xsi_schemaLocation, msOWSGetInspireSchemasLocation(map));
+    xsi_schemaLocation =
+        msStringConcatenate(xsi_schemaLocation, MS_INSPIRE_DLS_SCHEMA_LOCATION);
+    xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
+    xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation,
+                                             MS_INSPIRE_COMMON_NAMESPACE_URI);
+    xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
+    xsi_schemaLocation = msStringConcatenate(
+        xsi_schemaLocation, msOWSGetInspireSchemasLocation(map));
+    xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation,
+                                             MS_INSPIRE_COMMON_SCHEMA_LOCATION);
   }
 
-  xmlNewNsProp(psRootNode, NULL, BAD_CAST "xsi:schemaLocation", BAD_CAST xsi_schemaLocation);
+  xmlNewNsProp(psRootNode, NULL, BAD_CAST "xsi:schemaLocation",
+               BAD_CAST xsi_schemaLocation);
   free(xsi_schemaLocation);
 
   /* -------------------------------------------------------------------- */
   /*      Service metadata.                                               */
   /* -------------------------------------------------------------------- */
 
-  /* TODO? : also add 1.1.0 and 1.0.0 as extra <ows:ServiceTypeVersion>. The OWS */
+  /* TODO? : also add 1.1.0 and 1.0.0 as extra <ows:ServiceTypeVersion>. The OWS
+   */
   /* schema would suggest to do so, and also the example */
-  /* http://schemas.opengis.net/wfs/2.0/examples/GetCapabilities/GetCapabilities_Res_01.xml */
+  /* http://schemas.opengis.net/wfs/2.0/examples/GetCapabilities/GetCapabilities_Res_01.xml
+   */
   /* and Deegree too, but GeoServer also only lists the current version. */
-  if( msWFSIncludeSection(params, "ServiceIdentification") )
-  {
-    xmlAddChild(psRootNode,
-                msOWSCommonServiceIdentification(psNsOws, map, "WFS",
-                                                 params->pszVersion, "FO", validated_language));
+  if (msWFSIncludeSection(params, "ServiceIdentification")) {
+    xmlAddChild(psRootNode, msOWSCommonServiceIdentification(
+                                psNsOws, map, "WFS", params->pszVersion, "FO",
+                                validated_language));
   }
 
   /*service provider*/
-  if( msWFSIncludeSection(params, "ServiceProvider") )
-  {
-    xmlAddChild(psRootNode, msOWSCommonServiceProvider(
-                            psNsOws, psNsXLink, map, "FO", validated_language));
+  if (msWFSIncludeSection(params, "ServiceProvider")) {
+    xmlAddChild(psRootNode,
+                msOWSCommonServiceProvider(psNsOws, psNsXLink, map, "FO",
+                                           validated_language));
   }
 
   /*operation metadata */
-  if( msWFSIncludeSection(params, "OperationsMetadata") )
-  {
-    if ((script_url=msOWSGetOnlineResource2(map, "FO", "onlineresource", req, validated_language)) == NULL) {
-        msSetError(MS_WFSERR, "Server URL not found", "msWFSGetCapabilities20()");
-        return msWFSException11(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE, params->pszVersion);
+  if (msWFSIncludeSection(params, "OperationsMetadata")) {
+    if ((script_url = msOWSGetOnlineResource2(map, "FO", "onlineresource", req,
+                                              validated_language)) == NULL) {
+      msSetError(MS_WFSERR, "Server URL not found", "msWFSGetCapabilities20()");
+      return msWFSException11(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE,
+                              params->pszVersion);
     }
-    
 
     /* -------------------------------------------------------------------- */
     /*      Operations metadata.                                            */
     /* -------------------------------------------------------------------- */
-    psMainNode= xmlAddChild(psRootNode,msOWSCommonOperationsMetadata(psNsOws));
-    
+    psMainNode =
+        xmlAddChild(psRootNode, msOWSCommonOperationsMetadata(psNsOws));
+
     /* -------------------------------------------------------------------- */
     /*      GetCapabilities                                                 */
     /* -------------------------------------------------------------------- */
-    psNode = xmlAddChild(psMainNode,
-                        msOWSCommonOperationsMetadataOperation(psNsOws,psNsXLink,"GetCapabilities",
-                            OWS_METHOD_GETPOST, script_url));
+    psNode = xmlAddChild(psMainNode, msOWSCommonOperationsMetadataOperation(
+                                         psNsOws, psNsXLink, "GetCapabilities",
+                                         OWS_METHOD_GETPOST, script_url));
 
     xmlAddChild(psMainNode, psNode);
 
     /*accept version*/
-    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,
-                "Parameter", "AcceptVersions",
-                "2.0.0,1.1.0,1.0.0"));
+    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
+                            ows_version, psNsOws, "Parameter", "AcceptVersions",
+                            "2.0.0,1.1.0,1.0.0"));
     /*format*/
-    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,
-                "Parameter", "AcceptFormats",
-                "text/xml"));
+    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
+                            ows_version, psNsOws, "Parameter", "AcceptFormats",
+                            "text/xml"));
     /*sections*/
-    xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,
-                "Parameter", "Sections",
-                "ServiceIdentification,ServiceProvider,OperationsMetadata,FeatureTypeList,Filter_Capabilities"));
+    xmlAddChild(psNode,
+                msOWSCommonOperationsMetadataDomainType(
+                    ows_version, psNsOws, "Parameter", "Sections",
+                    "ServiceIdentification,ServiceProvider,OperationsMetadata,"
+                    "FeatureTypeList,Filter_Capabilities"));
 
     /* -------------------------------------------------------------------- */
     /*      DescribeFeatureType                                             */
     /* -------------------------------------------------------------------- */
     if (msOWSRequestIsEnabled(map, NULL, "F", "DescribeFeatureType", MS_TRUE)) {
-        psNode = xmlAddChild(psMainNode,
-                            msOWSCommonOperationsMetadataOperation(psNsOws,psNsXLink,"DescribeFeatureType",
-                                OWS_METHOD_GETPOST, script_url));
-        xmlAddChild(psMainNode, psNode);
-
-        /*output format*/
-        xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,
-                    "Parameter", "outputFormat",
-                    "application/gml+xml; version=3.2,"
-                    "text/xml; subtype=gml/3.2.1,"
-                    "text/xml; subtype=gml/3.1.1,"
-                    "text/xml; subtype=gml/2.1.2"));
+      psNode =
+          xmlAddChild(psMainNode, msOWSCommonOperationsMetadataOperation(
+                                      psNsOws, psNsXLink, "DescribeFeatureType",
+                                      OWS_METHOD_GETPOST, script_url));
+      xmlAddChild(psMainNode, psNode);
+
+      /*output format*/
+      xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
+                              ows_version, psNsOws, "Parameter", "outputFormat",
+                              "application/gml+xml; version=3.2,"
+                              "text/xml; subtype=gml/3.2.1,"
+                              "text/xml; subtype=gml/3.1.1,"
+                              "text/xml; subtype=gml/2.1.2"));
     }
 
     /* -------------------------------------------------------------------- */
@@ -548,16 +627,16 @@ int msWFSGetCapabilities20(mapObj *map,
     /* -------------------------------------------------------------------- */
     if (msOWSRequestIsEnabled(map, NULL, "F", "GetFeature", MS_TRUE)) {
 
-        psNode = xmlAddChild(psMainNode,
-                            msOWSCommonOperationsMetadataOperation(psNsOws,psNsXLink,"GetFeature",
-                                OWS_METHOD_GETPOST, script_url));
-        xmlAddChild(psMainNode, psNode);
-
-        formats_list = msWFSGetOutputFormatList( map, NULL, OWS_2_0_0 );
-        xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,
-                    "Parameter", "outputFormat",
-                    formats_list));
-        msFree( formats_list );
+      psNode = xmlAddChild(psMainNode, msOWSCommonOperationsMetadataOperation(
+                                           psNsOws, psNsXLink, "GetFeature",
+                                           OWS_METHOD_GETPOST, script_url));
+      xmlAddChild(psMainNode, psNode);
+
+      formats_list = msWFSGetOutputFormatList(map, NULL, OWS_2_0_0);
+      xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
+                              ows_version, psNsOws, "Parameter", "outputFormat",
+                              formats_list));
+      msFree(formats_list);
     }
 
     /* -------------------------------------------------------------------- */
@@ -565,19 +644,20 @@ int msWFSGetCapabilities20(mapObj *map,
     /* -------------------------------------------------------------------- */
     if (msOWSRequestIsEnabled(map, NULL, "F", "GetPropertyValue", MS_TRUE)) {
 
-        psNode = xmlAddChild(psMainNode,
-                            msOWSCommonOperationsMetadataOperation(psNsOws,psNsXLink,"GetPropertyValue",
-                                OWS_METHOD_GETPOST, script_url));
-        xmlAddChild(psMainNode, psNode);
-
-        /* Only advertize built-in GML formats for GetPropertyValue. Not sure */
-        /* it makes sense to advertize OGR formats. */
-        xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,
-                    "Parameter", "outputFormat",
-                    "application/gml+xml; version=3.2,"
-                    "text/xml; subtype=gml/3.2.1,"
-                    "text/xml; subtype=gml/3.1.1,"
-                    "text/xml; subtype=gml/2.1.2"));
+      psNode =
+          xmlAddChild(psMainNode, msOWSCommonOperationsMetadataOperation(
+                                      psNsOws, psNsXLink, "GetPropertyValue",
+                                      OWS_METHOD_GETPOST, script_url));
+      xmlAddChild(psMainNode, psNode);
+
+      /* Only advertize built-in GML formats for GetPropertyValue. Not sure */
+      /* it makes sense to advertize OGR formats. */
+      xmlAddChild(psNode, msOWSCommonOperationsMetadataDomainType(
+                              ows_version, psNsOws, "Parameter", "outputFormat",
+                              "application/gml+xml; version=3.2,"
+                              "text/xml; subtype=gml/3.2.1,"
+                              "text/xml; subtype=gml/3.1.1,"
+                              "text/xml; subtype=gml/2.1.2"));
     }
 
     /* -------------------------------------------------------------------- */
@@ -585,148 +665,186 @@ int msWFSGetCapabilities20(mapObj *map,
     /* -------------------------------------------------------------------- */
     if (msOWSRequestIsEnabled(map, NULL, "F", "ListStoredQueries", MS_TRUE)) {
 
-        psNode = xmlAddChild(psMainNode,
-                            msOWSCommonOperationsMetadataOperation(psNsOws,psNsXLink,"ListStoredQueries",
-                                OWS_METHOD_GETPOST, script_url));
-        xmlAddChild(psMainNode, psNode);
+      psNode =
+          xmlAddChild(psMainNode, msOWSCommonOperationsMetadataOperation(
+                                      psNsOws, psNsXLink, "ListStoredQueries",
+                                      OWS_METHOD_GETPOST, script_url));
+      xmlAddChild(psMainNode, psNode);
     }
 
     /* -------------------------------------------------------------------- */
     /*      DescribeStoredQueries                                           */
     /* -------------------------------------------------------------------- */
-    if (msOWSRequestIsEnabled(map, NULL, "F", "DescribeStoredQueries", MS_TRUE)) {
+    if (msOWSRequestIsEnabled(map, NULL, "F", "DescribeStoredQueries",
+                              MS_TRUE)) {
 
-        psNode = xmlAddChild(psMainNode,
-                            msOWSCommonOperationsMetadataOperation(psNsOws,psNsXLink,"DescribeStoredQueries",
-                                OWS_METHOD_GETPOST, script_url));
-        xmlAddChild(psMainNode, psNode);
+      psNode = xmlAddChild(psMainNode,
+                           msOWSCommonOperationsMetadataOperation(
+                               psNsOws, psNsXLink, "DescribeStoredQueries",
+                               OWS_METHOD_GETPOST, script_url));
+      xmlAddChild(psMainNode, psNode);
     }
 
-    xmlAddChild(psMainNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,
-                "Parameter", "version",
-                "2.0.0,1.1.0,1.0.0"));
+    xmlAddChild(psMainNode, msOWSCommonOperationsMetadataDomainType(
+                                ows_version, psNsOws, "Parameter", "version",
+                                "2.0.0,1.1.0,1.0.0"));
 
     /* Conformance declaration */
-    xmlAddChild(psMainNode, msWFSConstraintDefaultValue(psNsOws, psNsOws, "ImplementsBasicWFS", "TRUE"));
-    xmlAddChild(psMainNode, msWFSConstraintDefaultValue(psNsOws, psNsOws, "ImplementsTransactionalWFS", "FALSE"));
-    xmlAddChild(psMainNode, msWFSConstraintDefaultValue(psNsOws, psNsOws, "ImplementsLockingWFS", "FALSE"));
-    xmlAddChild(psMainNode, msWFSConstraintDefaultValue(psNsOws, psNsOws, "KVPEncoding", "TRUE"));
-    xmlAddChild(psMainNode, msWFSConstraintDefaultValue(psNsOws, psNsOws, "XMLEncoding", "TRUE"));
-    xmlAddChild(psMainNode, msWFSConstraintDefaultValue(psNsOws, psNsOws, "SOAPEncoding", "FALSE"));
-    xmlAddChild(psMainNode, msWFSConstraintDefaultValue(psNsOws, psNsOws, "ImplementsInheritance", "FALSE"));
-    xmlAddChild(psMainNode, msWFSConstraintDefaultValue(psNsOws, psNsOws, "ImplementsRemoteResolve", "FALSE"));
-    xmlAddChild(psMainNode, msWFSConstraintDefaultValue(psNsOws, psNsOws, "ImplementsResultPaging", "TRUE"));
-    xmlAddChild(psMainNode, msWFSConstraintDefaultValue(psNsOws, psNsOws, "ImplementsStandardJoins", "FALSE"));
-    xmlAddChild(psMainNode, msWFSConstraintDefaultValue(psNsOws, psNsOws, "ImplementsSpatialJoins", "FALSE"));
-    xmlAddChild(psMainNode, msWFSConstraintDefaultValue(psNsOws, psNsOws, "ImplementsTemporalJoins", "FALSE"));
-    xmlAddChild(psMainNode, msWFSConstraintDefaultValue(psNsOws, psNsOws, "ImplementsFeatureVersioning", "FALSE"));
-    xmlAddChild(psMainNode, msWFSConstraintDefaultValue(psNsOws, psNsOws, "ManageStoredQueries", "FALSE"));
+    xmlAddChild(psMainNode,
+                msWFSConstraintDefaultValue(psNsOws, psNsOws,
+                                            "ImplementsBasicWFS", "TRUE"));
+    xmlAddChild(psMainNode,
+                msWFSConstraintDefaultValue(
+                    psNsOws, psNsOws, "ImplementsTransactionalWFS", "FALSE"));
+    xmlAddChild(psMainNode,
+                msWFSConstraintDefaultValue(psNsOws, psNsOws,
+                                            "ImplementsLockingWFS", "FALSE"));
+    xmlAddChild(psMainNode, msWFSConstraintDefaultValue(psNsOws, psNsOws,
+                                                        "KVPEncoding", "TRUE"));
+    xmlAddChild(psMainNode, msWFSConstraintDefaultValue(psNsOws, psNsOws,
+                                                        "XMLEncoding", "TRUE"));
+    xmlAddChild(psMainNode, msWFSConstraintDefaultValue(
+                                psNsOws, psNsOws, "SOAPEncoding", "FALSE"));
+    xmlAddChild(psMainNode,
+                msWFSConstraintDefaultValue(psNsOws, psNsOws,
+                                            "ImplementsInheritance", "FALSE"));
+    xmlAddChild(psMainNode,
+                msWFSConstraintDefaultValue(
+                    psNsOws, psNsOws, "ImplementsRemoteResolve", "FALSE"));
+    xmlAddChild(psMainNode,
+                msWFSConstraintDefaultValue(psNsOws, psNsOws,
+                                            "ImplementsResultPaging", "TRUE"));
+    xmlAddChild(psMainNode,
+                msWFSConstraintDefaultValue(
+                    psNsOws, psNsOws, "ImplementsStandardJoins", "FALSE"));
+    xmlAddChild(psMainNode,
+                msWFSConstraintDefaultValue(psNsOws, psNsOws,
+                                            "ImplementsSpatialJoins", "FALSE"));
+    xmlAddChild(psMainNode,
+                msWFSConstraintDefaultValue(
+                    psNsOws, psNsOws, "ImplementsTemporalJoins", "FALSE"));
+    xmlAddChild(psMainNode,
+                msWFSConstraintDefaultValue(
+                    psNsOws, psNsOws, "ImplementsFeatureVersioning", "FALSE"));
+    xmlAddChild(psMainNode,
+                msWFSConstraintDefaultValue(psNsOws, psNsOws,
+                                            "ManageStoredQueries", "FALSE"));
 
     /* Capacity declaration */
-    xmlAddChild(psMainNode, msWFSConstraintDefaultValue(psNsOws, psNsOws, "PagingIsTransactionSafe", "FALSE"));
+    xmlAddChild(psMainNode,
+                msWFSConstraintDefaultValue(
+                    psNsOws, psNsOws, "PagingIsTransactionSafe", "FALSE"));
 
     value = msOWSLookupMetadata(&(map->web.metadata), "FO", "maxfeatures");
     if (value) {
-    xmlAddChild(psMainNode, msWFSConstraintDefaultValue(psNsOws, psNsOws, "CountDefault", value));
+      xmlAddChild(psMainNode, msWFSConstraintDefaultValue(
+                                  psNsOws, psNsOws, "CountDefault", value));
     }
 
-    xmlAddChild(psMainNode, msOWSCommonOperationsMetadataDomainType(ows_version, psNsOws,
-                "Constraint", "QueryExpressions","wfs:Query,wfs:StoredQuery"));
+    xmlAddChild(psMainNode,
+                msOWSCommonOperationsMetadataDomainType(
+                    ows_version, psNsOws, "Constraint", "QueryExpressions",
+                    "wfs:Query,wfs:StoredQuery"));
 
     /* Add Inspire Download Services extended capabilities */
-    if( psNsInspireDls != NULL )
-    {
-        msIOContext* old_context;
-        msIOContext* new_context;
-        msIOBuffer* buffer;
-        xmlNodePtr pRoot;
-        xmlNodePtr pOWSExtendedCapabilities;
-        xmlNodePtr pDlsExtendedCapabilities;
-        xmlNodePtr pChild;
-
-        old_context = msIO_pushStdoutToBufferAndGetOldContext();
-        msOWSPrintInspireCommonExtendedCapabilities(stdout, map, "FO", OWS_WARN,
-                                                    "foo",
-                                                    "xmlns:" MS_INSPIRE_COMMON_NAMESPACE_PREFIX "=\"" MS_INSPIRE_COMMON_NAMESPACE_URI "\" "
-                                                    "xmlns:" MS_INSPIRE_DLS_NAMESPACE_PREFIX "=\"" MS_INSPIRE_DLS_NAMESPACE_URI "\" "
-                                                    "xmlns:xsi=\"" MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI "\"", validated_language, OWS_WFS);
-
-        new_context = msIO_getHandler(stdout);
-        buffer = (msIOBuffer *) new_context->cbData;
-
-        /* Remove spaces between > and < to get properly indented result */
-        msXMLStripIndentation( (char*) buffer->data );
-
-        pInspireTmpDoc = xmlParseDoc((const xmlChar *)buffer->data);
-        pRoot = xmlDocGetRootElement(pInspireTmpDoc);
-        xmlReconciliateNs(psDoc, pRoot);
-
-        pOWSExtendedCapabilities = xmlNewNode(psNsOws, BAD_CAST "ExtendedCapabilities");
-        xmlAddChild(psMainNode, pOWSExtendedCapabilities);
-
-        pDlsExtendedCapabilities = xmlNewNode(psNsInspireDls, BAD_CAST "ExtendedCapabilities");
-        xmlAddChild(pOWSExtendedCapabilities, pDlsExtendedCapabilities);
-
-        pChild = pRoot->children;
-        while(pChild != NULL)
-        {
-            xmlNodePtr pNext = pChild->next;
-            xmlUnlinkNode(pChild);
-            xmlAddChild(pDlsExtendedCapabilities, pChild);
-            pChild = pNext;
-        }
+    if (psNsInspireDls != NULL) {
+      msIOContext *old_context;
+      msIOContext *new_context;
+      msIOBuffer *buffer;
+      xmlNodePtr pRoot;
+      xmlNodePtr pOWSExtendedCapabilities;
+      xmlNodePtr pDlsExtendedCapabilities;
+      xmlNodePtr pChild;
+
+      old_context = msIO_pushStdoutToBufferAndGetOldContext();
+      msOWSPrintInspireCommonExtendedCapabilities(
+          stdout, map, "FO", OWS_WARN, "foo",
+          "xmlns:" MS_INSPIRE_COMMON_NAMESPACE_PREFIX
+          "=\"" MS_INSPIRE_COMMON_NAMESPACE_URI "\" "
+          "xmlns:" MS_INSPIRE_DLS_NAMESPACE_PREFIX
+          "=\"" MS_INSPIRE_DLS_NAMESPACE_URI "\" "
+          "xmlns:xsi=\"" MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI "\"",
+          validated_language, OWS_WFS);
+
+      new_context = msIO_getHandler(stdout);
+      buffer = (msIOBuffer *)new_context->cbData;
+
+      /* Remove spaces between > and < to get properly indented result */
+      msXMLStripIndentation((char *)buffer->data);
+
+      pInspireTmpDoc = xmlParseDoc((const xmlChar *)buffer->data);
+      pRoot = xmlDocGetRootElement(pInspireTmpDoc);
+      xmlReconciliateNs(psDoc, pRoot);
+
+      pOWSExtendedCapabilities =
+          xmlNewNode(psNsOws, BAD_CAST "ExtendedCapabilities");
+      xmlAddChild(psMainNode, pOWSExtendedCapabilities);
+
+      pDlsExtendedCapabilities =
+          xmlNewNode(psNsInspireDls, BAD_CAST "ExtendedCapabilities");
+      xmlAddChild(pOWSExtendedCapabilities, pDlsExtendedCapabilities);
+
+      pChild = pRoot->children;
+      while (pChild != NULL) {
+        xmlNodePtr pNext = pChild->next;
+        xmlUnlinkNode(pChild);
+        xmlAddChild(pDlsExtendedCapabilities, pChild);
+        pChild = pNext;
+      }
 
-        msWFSAddInspireDSID(map, psNsInspireDls, psNsInspireCommon, pDlsExtendedCapabilities);
+      msWFSAddInspireDSID(map, psNsInspireDls, psNsInspireCommon,
+                          pDlsExtendedCapabilities);
 
-        msIO_restoreOldStdoutContext(old_context);
+      msIO_restoreOldStdoutContext(old_context);
     }
   }
 
   /* -------------------------------------------------------------------- */
   /*      FeatureTypeList                                                 */
   /* -------------------------------------------------------------------- */
-  if( msWFSIncludeSection(params, "FeatureTypeList") )
-  {
+  if (msWFSIncludeSection(params, "FeatureTypeList")) {
     psFtNode = xmlNewNode(NULL, BAD_CAST "FeatureTypeList");
     xmlAddChild(psRootNode, psFtNode);
   }
 
-  for(i=0; i<map->numlayers; i++) {
-        layerObj *lp;
-        lp = GET_LAYER(map, i);
-
-        if (!msIntegerInArray(lp->index, ows_request->enabled_layers, ows_request->numlayers))
-            continue;
-
-        if (msWFSIsLayerSupported(lp))
-        {
-          if( psFtNode != NULL ) {
-            xmlAddChild(psFtNode, msWFSDumpLayer11(map, lp, psNsOws, OWS_2_0_0, validated_language, script_url));
-          }
+  for (i = 0; i < map->numlayers; i++) {
+    layerObj *lp;
+    lp = GET_LAYER(map, i);
+
+    if (!msIntegerInArray(lp->index, ows_request->enabled_layers,
+                          ows_request->numlayers))
+      continue;
+
+    if (msWFSIsLayerSupported(lp)) {
+      if (psFtNode != NULL) {
+        xmlAddChild(psFtNode, msWFSDumpLayer11(map, lp, psNsOws, OWS_2_0_0,
+                                               validated_language, script_url));
+      }
 
-          /* As soon as at least one layer supports sorting, advertize sorting */
-          if( msLayerSupportsSorting(lp) )
-              bImplementsSorting = MS_TRUE;
-        }
+      /* As soon as at least one layer supports sorting, advertize sorting */
+      if (msLayerSupportsSorting(lp))
+        bImplementsSorting = MS_TRUE;
+    }
   }
 
   /* -------------------------------------------------------------------- */
   /*      Filter capabilities.                                            */
   /* -------------------------------------------------------------------- */
-  if( msWFSIncludeSection(params, "Filter_Capabilities") )
-  {
-    psNsFES = xmlNewNs(NULL, BAD_CAST MS_OWSCOMMON_FES_20_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_FES_20_NAMESPACE_PREFIX);
-    xmlAddChild(psRootNode, msWFS20FilterCapabilities(psNsFES, psNsOws, bImplementsSorting));
+  if (msWFSIncludeSection(params, "Filter_Capabilities")) {
+    psNsFES = xmlNewNs(NULL, BAD_CAST MS_OWSCOMMON_FES_20_NAMESPACE_URI,
+                       BAD_CAST MS_OWSCOMMON_FES_20_NAMESPACE_PREFIX);
+    xmlAddChild(psRootNode, msWFS20FilterCapabilities(psNsFES, psNsOws,
+                                                      bImplementsSorting));
   }
 
   /* -------------------------------------------------------------------- */
   /*      Write out the document.                                         */
   /* -------------------------------------------------------------------- */
 
-  if( msIO_needBinaryStdout() == MS_FAILURE )
+  if (msIO_needBinaryStdout() == MS_FAILURE)
     return MS_FAILURE;
 
-  msIO_setHeader("Content-Type","text/xml; charset=UTF-8");
+  msIO_setHeader("Content-Type", "text/xml; charset=UTF-8");
   msIO_sendHeaders();
 
   context = msIO_getHandler(stdout);
@@ -738,17 +856,17 @@ int msWFSGetCapabilities20(mapObj *map,
   /*free buffer and the document */
   /*xmlFree(buffer);*/
   xmlFreeDoc(psDoc);
-  if( psNsFES != NULL )
-      xmlFreeNs(psNsFES);
-  if( pInspireTmpDoc != NULL )
-      xmlFreeDoc(pInspireTmpDoc);
+  if (psNsFES != NULL)
+    xmlFreeNs(psNsFES);
+  if (pInspireTmpDoc != NULL)
+    xmlFreeDoc(pInspireTmpDoc);
 
   free(script_url);
   msFree(validated_language);
 
   xmlCleanupParser();
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
 /************************************************************************/
@@ -757,35 +875,29 @@ int msWFSGetCapabilities20(mapObj *map,
 /* Result must be freed with msFreeCharArray()                          */
 /************************************************************************/
 
-static char** msWFSGetStoredQueries(mapObj *map, int* pn)
-{
-  const char* value;
-  char** tokens;
-  int i,n;
-  
+static char **msWFSGetStoredQueries(mapObj *map, int *pn) {
+  const char *value;
+  char **tokens;
+  int i, n;
+
   value = msOWSLookupMetadata(&(map->web.metadata), "F", "storedqueries");
-  if( value != NULL )
-  {
+  if (value != NULL) {
     tokens = msStringSplit(value, ',', &n);
-    for(i=0;i<n;i++)
-    {
-        if( strcasecmp(tokens[i], URN_GET_FEATURE_BY_ID) == 0 )
-            break;
+    for (i = 0; i < n; i++) {
+      if (strcasecmp(tokens[i], URN_GET_FEATURE_BY_ID) == 0)
+        break;
     }
     /* Add mandatory GetFeatureById stored query if not found */
-    if(i == n)
-    {
-        tokens = (char**) realloc(tokens, (n+1) * sizeof(char*));
-        memmove(tokens + 1, tokens, n * sizeof(char*));
-        tokens[0] = msStrdup(URN_GET_FEATURE_BY_ID);
-        n ++;
-    }
-  }
-  else
-  {
-      tokens = (char**) malloc(sizeof(char*));
+    if (i == n) {
+      tokens = (char **)realloc(tokens, (n + 1) * sizeof(char *));
+      memmove(tokens + 1, tokens, n * sizeof(char *));
       tokens[0] = msStrdup(URN_GET_FEATURE_BY_ID);
-      n = 1;
+      n++;
+    }
+  } else {
+    tokens = (char **)malloc(sizeof(char *));
+    tokens[0] = msStrdup(URN_GET_FEATURE_BY_ID);
+    n = 1;
   }
   *pn = n;
   return tokens;
@@ -797,71 +909,57 @@ static char** msWFSGetStoredQueries(mapO
 /* Result must be freed with msFree()                                   */
 /************************************************************************/
 
-static char* msWFSGetStoredQuery(mapObj *map, const char* pszURN)
-{
-    const char* value;
-    char szKey[256];
-    
-    snprintf(szKey, sizeof(szKey), "%s_inlinedef", pszURN);
-    value = msOWSLookupMetadata(&(map->web.metadata), "F", szKey);
-    if( value != NULL )
-        return msStrdup(value);
-    
-    snprintf(szKey, sizeof(szKey), "%s_filedef", pszURN);
-    value = msOWSLookupMetadata(&(map->web.metadata), "F", szKey);
-    if( value != NULL )
-    {
-        FILE* f = fopen(value, "rb");
-        if( f != NULL )
-        {
-            char* pszBuffer;
-            int nread;
-            long length;
-
-            fseek(f, 0, SEEK_END);
-            length = ftell(f);
-            if( length > 1000000 )
-            {
-                msSetError(MS_WFSERR, "%s: too big (%ld bytes > 1000000)",
-                           "msWFSGetStoredQuery()", value, length);
-                fclose(f);
-            }
-            else
-            {
-                fseek(f, 0, SEEK_SET);
-                pszBuffer = (char*) malloc((int)length + 1);
-                if( pszBuffer == NULL )
-                {
-                    msSetError(MS_WFSERR, "Cannot allocate %d bytes to read %s",
-                               "msWFSGetStoredQuery()",
-                               (int)length + 1, value);
-                    fclose(f);
-                }
-                else
-                {
-                    nread = (int)fread(pszBuffer, 1, length, f);
-                    fclose(f);
-                    if( nread == length )
-                    {
-                        pszBuffer[nread] = '\0';
-                        return pszBuffer;
-                    }
-                    msSetError(MS_WFSERR, "Could only read %d bytes / %d of %s",
-                               "msWFSGetStoredQuery()",
-                               nread, (int)length, value);
-                    msFree(pszBuffer);
-                }
-            }
-        }
-        else
-        {
-            msSetError(MS_WFSERR, "Cannot open %s", "msWFSGetStoredQuery()", value);
+static char *msWFSGetStoredQuery(mapObj *map, const char *pszURN) {
+  const char *value;
+  char szKey[256];
+
+  snprintf(szKey, sizeof(szKey), "%s_inlinedef", pszURN);
+  value = msOWSLookupMetadata(&(map->web.metadata), "F", szKey);
+  if (value != NULL)
+    return msStrdup(value);
+
+  snprintf(szKey, sizeof(szKey), "%s_filedef", pszURN);
+  value = msOWSLookupMetadata(&(map->web.metadata), "F", szKey);
+  if (value != NULL) {
+    FILE *f = fopen(value, "rb");
+    if (f != NULL) {
+      char *pszBuffer;
+      int nread;
+      long length;
+
+      fseek(f, 0, SEEK_END);
+      length = ftell(f);
+      if (length > 1000000) {
+        msSetError(MS_WFSERR, "%s: too big (%ld bytes > 1000000)",
+                   "msWFSGetStoredQuery()", value, length);
+        fclose(f);
+      } else {
+        fseek(f, 0, SEEK_SET);
+        pszBuffer = (char *)malloc((int)length + 1);
+        if (pszBuffer == NULL) {
+          msSetError(MS_WFSERR, "Cannot allocate %d bytes to read %s",
+                     "msWFSGetStoredQuery()", (int)length + 1, value);
+          fclose(f);
+        } else {
+          nread = (int)fread(pszBuffer, 1, length, f);
+          fclose(f);
+          if (nread == length) {
+            pszBuffer[nread] = '\0';
+            return pszBuffer;
+          }
+          msSetError(MS_WFSERR, "Could only read %d bytes / %d of %s",
+                     "msWFSGetStoredQuery()", nread, (int)length, value);
+          msFree(pszBuffer);
         }
+      }
+    } else {
+      msSetError(MS_WFSERR, "Cannot open %s", "msWFSGetStoredQuery()", value);
     }
+  }
 
-    if( strcasecmp(pszURN, URN_GET_FEATURE_BY_ID) == 0 )
-        return msStrdup(GET_FEATURE_BY_ID);
-    return NULL;
+  if (strcasecmp(pszURN, URN_GET_FEATURE_BY_ID) == 0)
+    return msStrdup(GET_FEATURE_BY_ID);
+  return NULL;
 }
 
 /************************************************************************/
@@ -870,77 +968,74 @@ static char* msWFSGetStoredQuery(mapObj
 /* Result must be freed with msFree()                                   */
 /************************************************************************/
 
-char* msWFSGetResolvedStoredQuery20(mapObj *map,
-                                    wfsParamsObj *wfsparams,
-                                    const char* id,
-                                    hashTableObj* hashTable)
-{
-    char* storedQuery;
-    xmlDocPtr psStoredQueryDoc;
-    xmlNodePtr psStoredQueryRoot, pChild;
-
-    storedQuery = msWFSGetStoredQuery(map, id);
-    if( storedQuery == NULL )
-    {
-        msSetError(MS_WFSERR, "Unknown stored query id: %s", "msWFSGetResolvedStoredQuery20()",
-                   id);
-        msWFSException(map, "storedqueryid", MS_OWS_ERROR_INVALID_PARAMETER_VALUE, wfsparams->pszVersion);
-        return NULL;
-    }
+char *msWFSGetResolvedStoredQuery20(mapObj *map, wfsParamsObj *wfsparams,
+                                    const char *id, hashTableObj *hashTable) {
+  char *storedQuery;
+  xmlDocPtr psStoredQueryDoc;
+  xmlNodePtr psStoredQueryRoot, pChild;
 
-    psStoredQueryDoc = xmlParseDoc((const xmlChar*) storedQuery);
-    if( psStoredQueryDoc == NULL )
-    {
-        msSetError(MS_WFSERR, "Definition for stored query '%s' is invalid", "msWFSGetResolvedStoredQuery20()", id);
-        msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE, wfsparams->pszVersion);
-        msFree(storedQuery);
-        return NULL;
-    }
+  storedQuery = msWFSGetStoredQuery(map, id);
+  if (storedQuery == NULL) {
+    msSetError(MS_WFSERR, "Unknown stored query id: %s",
+               "msWFSGetResolvedStoredQuery20()", id);
+    msWFSException(map, "storedqueryid", MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                   wfsparams->pszVersion);
+    return NULL;
+  }
 
-    psStoredQueryRoot = xmlDocGetRootElement(psStoredQueryDoc);
+  psStoredQueryDoc = xmlParseDoc((const xmlChar *)storedQuery);
+  if (psStoredQueryDoc == NULL) {
+    msSetError(MS_WFSERR, "Definition for stored query '%s' is invalid",
+               "msWFSGetResolvedStoredQuery20()", id);
+    msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE,
+                   wfsparams->pszVersion);
+    msFree(storedQuery);
+    return NULL;
+  }
 
-    /* Check that all parameters are provided */
-    pChild = psStoredQueryRoot->children;
-    while(pChild != NULL)
-    {
-        if( pChild->type == XML_ELEMENT_NODE &&
-            strcmp((const char*) pChild->name, "Parameter") == 0 )
-        {
-            xmlChar* parameterName = xmlGetProp(pChild, BAD_CAST "name");
-            if( parameterName != NULL )
-            {
-                char szTmp[256];
-                const char* value = msLookupHashTable(hashTable, (const char*)parameterName);
-                if( value == NULL )
-                {
-                    msSetError(MS_WFSERR, "Stored query '%s' requires parameter '%s'", "msWFSParseRequest()",
-                               id, (const char*)parameterName);
-                    msWFSException(map, (const char*)parameterName, MS_OWS_ERROR_MISSING_PARAMETER_VALUE, wfsparams->pszVersion);
-                    msFree(storedQuery);
-                    xmlFree(parameterName);
-                    xmlFreeDoc(psStoredQueryDoc);
-                    return NULL;
-                }
+  psStoredQueryRoot = xmlDocGetRootElement(psStoredQueryDoc);
 
-                snprintf(szTmp, sizeof(szTmp), "${%s}", (const char*)parameterName);
-                storedQuery = msReplaceSubstring(storedQuery, szTmp, value);
-            }
-            xmlFree(parameterName);
+  /* Check that all parameters are provided */
+  pChild = psStoredQueryRoot->children;
+  while (pChild != NULL) {
+    if (pChild->type == XML_ELEMENT_NODE &&
+        strcmp((const char *)pChild->name, "Parameter") == 0) {
+      xmlChar *parameterName = xmlGetProp(pChild, BAD_CAST "name");
+      if (parameterName != NULL) {
+        char szTmp[256];
+        const char *value =
+            msLookupHashTable(hashTable, (const char *)parameterName);
+        if (value == NULL) {
+          msSetError(MS_WFSERR, "Stored query '%s' requires parameter '%s'",
+                     "msWFSParseRequest()", id, (const char *)parameterName);
+          msWFSException(map, (const char *)parameterName,
+                         MS_OWS_ERROR_MISSING_PARAMETER_VALUE,
+                         wfsparams->pszVersion);
+          msFree(storedQuery);
+          xmlFree(parameterName);
+          xmlFreeDoc(psStoredQueryDoc);
+          return NULL;
         }
-        pChild = pChild->next;
+
+        snprintf(szTmp, sizeof(szTmp), "${%s}", (const char *)parameterName);
+        // value should already be a valid XML fragment
+        storedQuery = msReplaceSubstring(storedQuery, szTmp, value);
+      }
+      xmlFree(parameterName);
     }
+    pChild = pChild->next;
+  }
 
-    xmlFreeDoc(psStoredQueryDoc);
+  xmlFreeDoc(psStoredQueryDoc);
 
-    return storedQuery;
+  return storedQuery;
 }
 
 /************************************************************************/
 /*                       msWFSListStoredQueries20                       */
 /************************************************************************/
 
-int msWFSListStoredQueries20(mapObj *map, owsRequestObj *ows_request)
-{
+int msWFSListStoredQueries20(mapObj *map, owsRequestObj *ows_request) {
   xmlDocPtr psDoc;
   xmlChar *buffer = NULL;
   int size = 0;
@@ -949,11 +1044,11 @@ int msWFSListStoredQueries20(mapObj *map
   char *xsi_schemaLocation = NULL;
   int i, j;
   int nStoredQueries = 0;
-  char** storedQueries = NULL;
+  char **storedQueries = NULL;
 
   xmlDocPtr psStoredQueryDoc;
   xmlNodePtr psStoredQueryRoot;
-  
+
   /* -------------------------------------------------------------------- */
   /*      Create document.                                                */
   /* -------------------------------------------------------------------- */
@@ -966,120 +1061,130 @@ int msWFSListStoredQueries20(mapObj *map
   /* -------------------------------------------------------------------- */
   /*      Name spaces                                                     */
   /* -------------------------------------------------------------------- */
-  
+
   /*default name space*/
-  xmlNewProp(psRootNode, BAD_CAST "xmlns", BAD_CAST MS_OWSCOMMON_WFS_20_NAMESPACE_URI);
+  xmlNewProp(psRootNode, BAD_CAST "xmlns",
+             BAD_CAST MS_OWSCOMMON_WFS_20_NAMESPACE_URI);
 
-  xmlSetNs(psRootNode, xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_WFS_20_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_WFS_NAMESPACE_PREFIX));
+  xmlSetNs(psRootNode,
+           xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_WFS_20_NAMESPACE_URI,
+                    BAD_CAST MS_OWSCOMMON_WFS_NAMESPACE_PREFIX));
 
-  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX);
+  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI,
+           BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX);
 
   /*schema*/
   xsi_schemaLocation = msStrdup(MS_OWSCOMMON_WFS_20_NAMESPACE_URI);
   xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, msOWSGetSchemasLocation(map));
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, MS_OWSCOMMON_WFS_20_SCHEMA_LOCATION);
+  xsi_schemaLocation =
+      msStringConcatenate(xsi_schemaLocation, msOWSGetSchemasLocation(map));
+  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation,
+                                           MS_OWSCOMMON_WFS_20_SCHEMA_LOCATION);
 
-  xmlNewNsProp(psRootNode, NULL, BAD_CAST "xsi:schemaLocation", BAD_CAST xsi_schemaLocation);
+  xmlNewNsProp(psRootNode, NULL, BAD_CAST "xsi:schemaLocation",
+               BAD_CAST xsi_schemaLocation);
   free(xsi_schemaLocation);
 
   /* -------------------------------------------------------------------- */
   /*      Add queries                                                     */
   /* -------------------------------------------------------------------- */
-  
+
   storedQueries = msWFSGetStoredQueries(map, &nStoredQueries);
-  for(i = 0; i < nStoredQueries; i++)
-  {
-    char* query = msWFSGetStoredQuery(map, storedQueries[i]);
-    if( query != NULL )
-    {
+  for (i = 0; i < nStoredQueries; i++) {
+    char *query = msWFSGetStoredQuery(map, storedQueries[i]);
+    if (query != NULL) {
       xmlNodePtr pChild;
       xmlNodePtr psStoredQuery;
 
-      psStoredQueryDoc = xmlParseDoc((const xmlChar*) query);
-      if( psStoredQueryDoc == NULL )
-      {
+      psStoredQueryDoc = xmlParseDoc((const xmlChar *)query);
+      if (psStoredQueryDoc == NULL) {
         char szMsg[256];
         msFree(query);
-        snprintf(szMsg, sizeof(szMsg), "WARNING: Definition for stored query %s is invalid", storedQueries[i]);
+        snprintf(szMsg, sizeof(szMsg),
+                 "WARNING: Definition for stored query %s is invalid",
+                 storedQueries[i]);
         xmlAddChild(psRootNode, xmlNewComment(BAD_CAST szMsg));
         continue;
       }
 
       psStoredQueryRoot = xmlDocGetRootElement(psStoredQueryDoc);
 
-      psStoredQuery = xmlNewNode(NULL, BAD_CAST "StoredQuery" );
+      psStoredQuery = xmlNewNode(NULL, BAD_CAST "StoredQuery");
       xmlNewProp(psStoredQuery, BAD_CAST "id", BAD_CAST storedQueries[i]);
       xmlAddChild(psRootNode, psStoredQuery);
 
       pChild = psStoredQueryRoot->children;
-      while(pChild != NULL)
-      {
+      while (pChild != NULL) {
         xmlNodePtr pNext = pChild->next;
-        if( pChild->type == XML_ELEMENT_NODE &&
-            strcmp((const char*) pChild->name, "Title") == 0 )
-        {
-            xmlUnlinkNode(pChild);
-            xmlAddChild(psStoredQuery, pChild);
-        }
-        else if( pChild->type == XML_ELEMENT_NODE &&
-            strcmp((const char*) pChild->name, "QueryExpressionText") == 0 )
-        {
-            xmlNodePtr psReturnFeatureType;
-
-            if( strcasecmp( storedQueries[i], URN_GET_FEATURE_BY_ID ) == 0 )
-            {
-                for(j=0; j<map->numlayers; j++) {
-                    layerObj *lp;
-                    const char *user_namespace_prefix = MS_DEFAULT_NAMESPACE_PREFIX;
-                    const char *user_namespace_uri = MS_DEFAULT_NAMESPACE_URI;
-                    const char *value;
-                    char szValue[256];
-
-                    lp = GET_LAYER(map, j);
-
-                    if (!msIntegerInArray(lp->index, ows_request->enabled_layers, ows_request->numlayers) ||
-                        !msWFSIsLayerSupported(lp))
-                    continue;
-
-
-                    value = msOWSLookupMetadata(&(map->web.metadata), "FO", "namespace_uri");
-                    if(value) user_namespace_uri = value;
-
-                    value = msOWSLookupMetadata(&(map->web.metadata), "FO", "namespace_prefix");
-                    if(value) user_namespace_prefix = value;
-
-                    psReturnFeatureType = xmlNewNode(NULL, BAD_CAST "ReturnFeatureType" );
-                    xmlNewNs(psReturnFeatureType, BAD_CAST user_namespace_uri, BAD_CAST user_namespace_prefix);
-
-                    xmlAddChild(psStoredQuery, psReturnFeatureType);
-                    snprintf(szValue, sizeof(szValue), "%s:%s", user_namespace_prefix, lp->name);
-                    xmlAddChild(psReturnFeatureType, xmlNewText( BAD_CAST szValue ));
-                }
+        if (pChild->type == XML_ELEMENT_NODE &&
+            strcmp((const char *)pChild->name, "Title") == 0) {
+          xmlUnlinkNode(pChild);
+          xmlAddChild(psStoredQuery, pChild);
+        } else if (pChild->type == XML_ELEMENT_NODE &&
+                   strcmp((const char *)pChild->name, "QueryExpressionText") ==
+                       0) {
+          xmlNodePtr psReturnFeatureType;
+
+          if (strcasecmp(storedQueries[i], URN_GET_FEATURE_BY_ID) == 0) {
+            for (j = 0; j < map->numlayers; j++) {
+              layerObj *lp;
+              const char *user_namespace_prefix = MS_DEFAULT_NAMESPACE_PREFIX;
+              const char *user_namespace_uri = MS_DEFAULT_NAMESPACE_URI;
+              const char *value;
+              char szValue[256];
+
+              lp = GET_LAYER(map, j);
+
+              if (!msIntegerInArray(lp->index, ows_request->enabled_layers,
+                                    ows_request->numlayers) ||
+                  !msWFSIsLayerSupported(lp))
+                continue;
+
+              value = msOWSLookupMetadata(&(map->web.metadata), "FO",
+                                          "namespace_uri");
+              if (value)
+                user_namespace_uri = value;
+
+              value = msOWSLookupMetadata(&(map->web.metadata), "FO",
+                                          "namespace_prefix");
+              if (value)
+                user_namespace_prefix = value;
+
+              psReturnFeatureType =
+                  xmlNewNode(NULL, BAD_CAST "ReturnFeatureType");
+              xmlNewNs(psReturnFeatureType, BAD_CAST user_namespace_uri,
+                       BAD_CAST user_namespace_prefix);
+
+              xmlAddChild(psStoredQuery, psReturnFeatureType);
+              snprintf(szValue, sizeof(szValue), "%s:%s", user_namespace_prefix,
+                       lp->name);
+              xmlAddChild(psReturnFeatureType, xmlNewText(BAD_CAST szValue));
             }
-            else
-            {
-                xmlChar* returnFeatureTypes = xmlGetProp(pChild, BAD_CAST "returnFeatureTypes");
-                if( returnFeatureTypes != NULL && strlen((const char*)returnFeatureTypes) > 0 )
-                {
-                    int ntypes;
-                    char** types = msStringSplit((const char*)returnFeatureTypes, ' ', &ntypes);
-                    for(j=0; j<ntypes; j++)
-                    {
-                        psReturnFeatureType = xmlNewNode(NULL, BAD_CAST "ReturnFeatureType" );
-                        xmlAddChild(psStoredQuery, psReturnFeatureType);
-                        xmlAddChild(psReturnFeatureType, xmlNewText( BAD_CAST types[j] ));
-                    }
-                    msFreeCharArray(types, ntypes);
-                }
-                else
-                {
-                    psReturnFeatureType = xmlNewNode(NULL, BAD_CAST "ReturnFeatureType" );
-                    xmlAddChild(psStoredQuery, psReturnFeatureType);
-                    xmlAddChild(psReturnFeatureType, xmlNewComment( BAD_CAST "WARNING: Missing return type" ));
-                }
-                xmlFree(returnFeatureTypes);
+          } else {
+            xmlChar *returnFeatureTypes =
+                xmlGetProp(pChild, BAD_CAST "returnFeatureTypes");
+            if (returnFeatureTypes != NULL &&
+                strlen((const char *)returnFeatureTypes) > 0) {
+              int ntypes;
+              char **types =
+                  msStringSplit((const char *)returnFeatureTypes, ' ', &ntypes);
+              for (j = 0; j < ntypes; j++) {
+                psReturnFeatureType =
+                    xmlNewNode(NULL, BAD_CAST "ReturnFeatureType");
+                xmlAddChild(psStoredQuery, psReturnFeatureType);
+                xmlAddChild(psReturnFeatureType, xmlNewText(BAD_CAST types[j]));
+              }
+              msFreeCharArray(types, ntypes);
+            } else {
+              psReturnFeatureType =
+                  xmlNewNode(NULL, BAD_CAST "ReturnFeatureType");
+              xmlAddChild(psStoredQuery, psReturnFeatureType);
+              xmlAddChild(
+                  psReturnFeatureType,
+                  xmlNewComment(BAD_CAST "WARNING: Missing return type"));
             }
+            xmlFree(returnFeatureTypes);
+          }
         }
         pChild = pNext;
       }
@@ -1087,11 +1192,11 @@ int msWFSListStoredQueries20(mapObj *map
       xmlReconciliateNs(psDoc, psStoredQuery);
       xmlFreeDoc(psStoredQueryDoc);
       msFree(query);
-    }
-    else
-    {
+    } else {
       char szMsg[256];
-      snprintf(szMsg, sizeof(szMsg), "WARNING: Definition for stored query %s missing", storedQueries[i]);
+      snprintf(szMsg, sizeof(szMsg),
+               "WARNING: Definition for stored query %s missing",
+               storedQueries[i]);
       xmlAddChild(psRootNode, xmlNewComment(BAD_CAST szMsg));
     }
   }
@@ -1101,10 +1206,10 @@ int msWFSListStoredQueries20(mapObj *map
   /*      Write out the document.                                         */
   /* -------------------------------------------------------------------- */
 
-  if( msIO_needBinaryStdout() == MS_FAILURE )
+  if (msIO_needBinaryStdout() == MS_FAILURE)
     return MS_FAILURE;
 
-  msIO_setHeader("Content-Type","text/xml; charset=UTF-8");
+  msIO_setHeader("Content-Type", "text/xml; charset=UTF-8");
   msIO_sendHeaders();
 
   context = msIO_getHandler(stdout);
@@ -1119,17 +1224,15 @@ int msWFSListStoredQueries20(mapObj *map
 
   xmlCleanupParser();
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
-
 /************************************************************************/
 /*                     msWFSDescribeStoredQueries20                     */
 /************************************************************************/
 
 int msWFSDescribeStoredQueries20(mapObj *map, wfsParamsObj *params,
-                                 owsRequestObj *ows_request)
-{
+                                 owsRequestObj *ows_request) {
   xmlDocPtr psDoc;
   xmlChar *buffer = NULL;
   int size = 0;
@@ -1138,24 +1241,25 @@ int msWFSDescribeStoredQueries20(mapObj
   char *xsi_schemaLocation = NULL;
   int i, j;
   int nStoredQueries = 0;
-  char** storedQueries = NULL;
+  char **storedQueries = NULL;
 
   xmlDocPtr psStoredQueryDoc;
   xmlNodePtr psStoredQueryRoot;
-  
-  if( params->pszStoredQueryId != NULL ) {
-    storedQueries = msStringSplit(params->pszStoredQueryId,',',&nStoredQueries);
-    for(i = 0; i < nStoredQueries; i++)
-    {
-        char* query = msWFSGetStoredQuery(map, storedQueries[i]);
-        if( query == NULL )
-        {
-            msSetError(MS_WFSERR, "Unknown stored query id: %s", "msWFSDescribeStoredQueries20()",
-                       storedQueries[i]);
-            msFreeCharArray(storedQueries, nStoredQueries);
-            return msWFSException(map, "storedqueryid", MS_OWS_ERROR_INVALID_PARAMETER_VALUE, params->pszVersion);
-        }
-        msFree(query);
+
+  if (params->pszStoredQueryId != NULL) {
+    storedQueries =
+        msStringSplit(params->pszStoredQueryId, ',', &nStoredQueries);
+    for (i = 0; i < nStoredQueries; i++) {
+      char *query = msWFSGetStoredQuery(map, storedQueries[i]);
+      if (query == NULL) {
+        msSetError(MS_WFSERR, "Unknown stored query id: %s",
+                   "msWFSDescribeStoredQueries20()", storedQueries[i]);
+        msFreeCharArray(storedQueries, nStoredQueries);
+        return msWFSException(map, "storedqueryid",
+                              MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                              params->pszVersion);
+      }
+      msFree(query);
     }
   } else {
     storedQueries = msWFSGetStoredQueries(map, &nStoredQueries);
@@ -1173,140 +1277,157 @@ int msWFSDescribeStoredQueries20(mapObj
   /* -------------------------------------------------------------------- */
   /*      Name spaces                                                     */
   /* -------------------------------------------------------------------- */
-  
+
   /*default name space*/
-  xmlNewProp(psRootNode, BAD_CAST "xmlns", BAD_CAST MS_OWSCOMMON_WFS_20_NAMESPACE_URI);
+  xmlNewProp(psRootNode, BAD_CAST "xmlns",
+             BAD_CAST MS_OWSCOMMON_WFS_20_NAMESPACE_URI);
 
-  xmlSetNs(psRootNode, xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_WFS_20_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_WFS_NAMESPACE_PREFIX));
+  xmlSetNs(psRootNode,
+           xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_WFS_20_NAMESPACE_URI,
+                    BAD_CAST MS_OWSCOMMON_WFS_NAMESPACE_PREFIX));
 
-  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX);
+  xmlNewNs(psRootNode, BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_URI,
+           BAD_CAST MS_OWSCOMMON_W3C_XSI_NAMESPACE_PREFIX);
 
   /*schema*/
   xsi_schemaLocation = msStrdup(MS_OWSCOMMON_WFS_20_NAMESPACE_URI);
   xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, " ");
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, msOWSGetSchemasLocation(map));
-  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation, MS_OWSCOMMON_WFS_20_SCHEMA_LOCATION);
+  xsi_schemaLocation =
+      msStringConcatenate(xsi_schemaLocation, msOWSGetSchemasLocation(map));
+  xsi_schemaLocation = msStringConcatenate(xsi_schemaLocation,
+                                           MS_OWSCOMMON_WFS_20_SCHEMA_LOCATION);
 
-  xmlNewNsProp(psRootNode, NULL, BAD_CAST "xsi:schemaLocation", BAD_CAST xsi_schemaLocation);
+  xmlNewNsProp(psRootNode, NULL, BAD_CAST "xsi:schemaLocation",
+               BAD_CAST xsi_schemaLocation);
   free(xsi_schemaLocation);
 
   /* -------------------------------------------------------------------- */
   /*      Add queries                                                     */
   /* -------------------------------------------------------------------- */
 
-  for(i = 0; i < nStoredQueries; i++)
-  {
-    char* query = msWFSGetStoredQuery(map, storedQueries[i]);
-    if( query != NULL )
-    {
+  for (i = 0; i < nStoredQueries; i++) {
+    char *query = msWFSGetStoredQuery(map, storedQueries[i]);
+    if (query != NULL) {
       xmlNodePtr pChild;
-      xmlNs*  ns;
+      xmlNs *ns;
       xmlNodePtr psStoredQuery;
 
-      psStoredQueryDoc = xmlParseDoc((const xmlChar*) query);
-      if( psStoredQueryDoc == NULL )
-      {
+      psStoredQueryDoc = xmlParseDoc((const xmlChar *)query);
+      if (psStoredQueryDoc == NULL) {
         char szMsg[256];
         msFree(query);
-        snprintf(szMsg, sizeof(szMsg), "WARNING: Definition for stored query %s is invalid", storedQueries[i]);
+        snprintf(szMsg, sizeof(szMsg),
+                 "WARNING: Definition for stored query %s is invalid",
+                 storedQueries[i]);
         xmlAddChild(psRootNode, xmlNewComment(BAD_CAST szMsg));
         continue;
       }
 
       psStoredQueryRoot = xmlDocGetRootElement(psStoredQueryDoc);
 
-      psStoredQuery = xmlNewNode(NULL, BAD_CAST "StoredQueryDescription" );
+      psStoredQuery = xmlNewNode(NULL, BAD_CAST "StoredQueryDescription");
       xmlNewProp(psStoredQuery, BAD_CAST "id", BAD_CAST storedQueries[i]);
       xmlAddChild(psRootNode, psStoredQuery);
 
       ns = psStoredQueryRoot->nsDef;
-      while( ns != NULL ) {
+      while (ns != NULL) {
         xmlNewNs(psStoredQuery, BAD_CAST ns->href, BAD_CAST ns->prefix);
         ns = ns->next;
       }
 
       pChild = psStoredQueryRoot->children;
-      while(pChild != NULL)
-      {
+      while (pChild != NULL) {
         xmlNodePtr pNext = pChild->next;
 
-        if( pChild->type == XML_ELEMENT_NODE &&
-            strcmp((const char*) pChild->name, "QueryExpressionText") == 0 )
-        {
-            if( strcasecmp( storedQueries[i], URN_GET_FEATURE_BY_ID ) == 0 )
-            {
-                char** arrayNsPrefix = (char**) malloc( sizeof(char*) * map->numlayers );
-                char** arrayNsUri = (char**) malloc( sizeof(char*) * map->numlayers );
-                int arraysize = 0;
-                int k;
-                char* returnFeatureTypes = NULL;
-                xmlNodePtr psQueryExpressionText;
-
-                psQueryExpressionText = xmlNewNode(NULL, BAD_CAST "QueryExpressionText" );
-                xmlAddChild(psStoredQuery, psQueryExpressionText);
-                xmlNewProp(psQueryExpressionText, BAD_CAST "isPrivate", BAD_CAST "true");
-                xmlNewProp(psQueryExpressionText, BAD_CAST "language", BAD_CAST "urn:ogc:def:queryLanguage:OGC-WFS::WFS_QueryExpression");
-
-                for(j=0; j<map->numlayers; j++) {
-                    layerObj *lp;
-                    const char *user_namespace_prefix = MS_DEFAULT_NAMESPACE_PREFIX;
-                    const char *user_namespace_uri = MS_DEFAULT_NAMESPACE_URI;
-                    const char *value;
-                    char szValue[256];
-
-                    lp = GET_LAYER(map, j);
-
-                    if (!msIntegerInArray(lp->index, ows_request->enabled_layers, ows_request->numlayers) ||
-                        !msWFSIsLayerSupported(lp))
-                    continue;
-
-                    value = msOWSLookupMetadata(&(map->web.metadata), "FO", "namespace_uri");
-                    if(value) user_namespace_uri = value;
-
-                    value = msOWSLookupMetadata(&(map->web.metadata), "FO", "namespace_prefix");
-                    if(value) user_namespace_prefix = value;
-
-                    for(k=0;k<arraysize;k++)
-                    {
-                        if( strcmp(arrayNsPrefix[k], user_namespace_prefix) == 0 )
-                            break;
-                    }
-                    if(k == arraysize) {
-                      arrayNsPrefix[arraysize] = msStrdup(user_namespace_prefix);
-                      arrayNsUri[arraysize] = msStrdup(user_namespace_uri);
-                      arraysize ++;
-
-                      xmlNewNs(psQueryExpressionText, BAD_CAST user_namespace_uri, BAD_CAST user_namespace_prefix);
-                    }
-
-                    if( returnFeatureTypes != NULL )
-                      returnFeatureTypes = msStringConcatenate(returnFeatureTypes, " ");
-                    snprintf(szValue, sizeof(szValue), "%s:%s", user_namespace_prefix, lp->name);
-                    returnFeatureTypes = msStringConcatenate(returnFeatureTypes, szValue);
-                }
-
-                xmlNewProp(psQueryExpressionText, BAD_CAST "returnFeatureTypes", BAD_CAST returnFeatureTypes);
-
-                msFree(returnFeatureTypes);
-                msFreeCharArray(arrayNsPrefix, arraysize);
-                msFreeCharArray(arrayNsUri, arraysize);
+        if (pChild->type == XML_ELEMENT_NODE &&
+            strcmp((const char *)pChild->name, "QueryExpressionText") == 0) {
+          if (strcasecmp(storedQueries[i], URN_GET_FEATURE_BY_ID) == 0) {
+            char **arrayNsPrefix =
+                (char **)malloc(sizeof(char *) * map->numlayers);
+            char **arrayNsUri =
+                (char **)malloc(sizeof(char *) * map->numlayers);
+            int arraysize = 0;
+            int k;
+            char *returnFeatureTypes = NULL;
+            xmlNodePtr psQueryExpressionText;
+
+            psQueryExpressionText =
+                xmlNewNode(NULL, BAD_CAST "QueryExpressionText");
+            xmlAddChild(psStoredQuery, psQueryExpressionText);
+            xmlNewProp(psQueryExpressionText, BAD_CAST "isPrivate",
+                       BAD_CAST "true");
+            xmlNewProp(
+                psQueryExpressionText, BAD_CAST "language",
+                BAD_CAST
+                "urn:ogc:def:queryLanguage:OGC-WFS::WFS_QueryExpression");
+
+            for (j = 0; j < map->numlayers; j++) {
+              layerObj *lp;
+              const char *user_namespace_prefix = MS_DEFAULT_NAMESPACE_PREFIX;
+              const char *user_namespace_uri = MS_DEFAULT_NAMESPACE_URI;
+              const char *value;
+              char szValue[256];
+
+              lp = GET_LAYER(map, j);
+
+              if (!msIntegerInArray(lp->index, ows_request->enabled_layers,
+                                    ows_request->numlayers) ||
+                  !msWFSIsLayerSupported(lp))
+                continue;
+
+              value = msOWSLookupMetadata(&(map->web.metadata), "FO",
+                                          "namespace_uri");
+              if (value)
+                user_namespace_uri = value;
+
+              value = msOWSLookupMetadata(&(map->web.metadata), "FO",
+                                          "namespace_prefix");
+              if (value)
+                user_namespace_prefix = value;
+
+              for (k = 0; k < arraysize; k++) {
+                if (strcmp(arrayNsPrefix[k], user_namespace_prefix) == 0)
+                  break;
+              }
+              if (k == arraysize) {
+                arrayNsPrefix[arraysize] = msStrdup(user_namespace_prefix);
+                arrayNsUri[arraysize] = msStrdup(user_namespace_uri);
+                arraysize++;
+
+                xmlNewNs(psQueryExpressionText, BAD_CAST user_namespace_uri,
+                         BAD_CAST user_namespace_prefix);
+              }
+
+              if (returnFeatureTypes != NULL)
+                returnFeatureTypes =
+                    msStringConcatenate(returnFeatureTypes, " ");
+              snprintf(szValue, sizeof(szValue), "%s:%s", user_namespace_prefix,
+                       lp->name);
+              returnFeatureTypes =
+                  msStringConcatenate(returnFeatureTypes, szValue);
             }
-            else
-            {
-                xmlChar* isPrivate = xmlGetProp(pChild, BAD_CAST "isPrivate");
-                if( isPrivate != NULL && strcmp((const char*)isPrivate, "true") == 0) {
-                    xmlNodePtr pSubChild = xmlFirstElementChild(pChild);
-                    xmlUnlinkNode(pSubChild);
-                    xmlFreeNode(pSubChild);
-                }
-                xmlUnlinkNode(pChild);
-                xmlAddChild(psStoredQuery, pChild);
-                msFree(isPrivate);
+
+            xmlNewProp(psQueryExpressionText, BAD_CAST "returnFeatureTypes",
+                       BAD_CAST returnFeatureTypes);
+
+            msFree(returnFeatureTypes);
+            msFreeCharArray(arrayNsPrefix, arraysize);
+            msFreeCharArray(arrayNsUri, arraysize);
+          } else {
+            xmlChar *isPrivate = xmlGetProp(pChild, BAD_CAST "isPrivate");
+            if (isPrivate != NULL &&
+                strcmp((const char *)isPrivate, "true") == 0) {
+              xmlNodePtr pSubChild = xmlFirstElementChild(pChild);
+              xmlUnlinkNode(pSubChild);
+              xmlFreeNode(pSubChild);
             }
-        }
-        else {
             xmlUnlinkNode(pChild);
             xmlAddChild(psStoredQuery, pChild);
+            msFree(isPrivate);
+          }
+        } else {
+          xmlUnlinkNode(pChild);
+          xmlAddChild(psStoredQuery, pChild);
         }
         pChild = pNext;
       }
@@ -1314,11 +1435,11 @@ int msWFSDescribeStoredQueries20(mapObj
       xmlReconciliateNs(psDoc, psStoredQuery);
       xmlFreeDoc(psStoredQueryDoc);
       msFree(query);
-    }
-    else
-    {
+    } else {
       char szMsg[256];
-      snprintf(szMsg, sizeof(szMsg), "WARNING: Definition for stored query %s missing", storedQueries[i]);
+      snprintf(szMsg, sizeof(szMsg),
+               "WARNING: Definition for stored query %s missing",
+               storedQueries[i]);
       xmlAddChild(psRootNode, xmlNewComment(BAD_CAST szMsg));
     }
   }
@@ -1328,10 +1449,10 @@ int msWFSDescribeStoredQueries20(mapObj
   /*      Write out the document.                                         */
   /* -------------------------------------------------------------------- */
 
-  if( msIO_needBinaryStdout() == MS_FAILURE )
+  if (msIO_needBinaryStdout() == MS_FAILURE)
     return MS_FAILURE;
 
-  msIO_setHeader("Content-Type","text/xml; charset=UTF-8");
+  msIO_setHeader("Content-Type", "text/xml; charset=UTF-8");
   msIO_sendHeaders();
 
   context = msIO_getHandler(stdout);
@@ -1346,7 +1467,7 @@ int msWFSDescribeStoredQueries20(mapObj
 
   xmlCleanupParser();
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
 #endif /* defined(USE_WFS_SVR) && defined(USE_LIBXML2) */
@@ -1354,53 +1475,56 @@ int msWFSDescribeStoredQueries20(mapObj
 #if defined(USE_WFS_SVR) && !defined(USE_LIBXML2)
 
 int msWFSException20(mapObj *map, const char *locator,
-                     const char *exceptionCode)
-{
+                     const char *exceptionCode) {
   /* fallback to reporting using 1.0 style exceptions. */
-  return msWFSException( map, locator, exceptionCode, "1.0.0" );
+  return msWFSException(map, locator, exceptionCode, "1.0.0");
 }
 
 int msWFSGetCapabilities20(mapObj *map, wfsParamsObj *params,
                            cgiRequestObj *req, owsRequestObj *ows_request)
 
 {
-  msSetError( MS_WFSERR,
-              "WFS 2.0 request made, but mapserver requires libxml2 for WFS 2.0 services and this is not configured.",
-              "msWFSGetCapabilities20()" );
+  msSetError(MS_WFSERR,
+             "WFS 2.0 request made, but mapserver requires libxml2 for WFS 2.0 "
+             "services and this is not configured.",
+             "msWFSGetCapabilities20()");
 
-  return msWFSException11(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE, params->pszVersion);
+  return msWFSException11(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE,
+                          params->pszVersion);
 }
 
 int msWFSListStoredQueries20(mapObj *map, wfsParamsObj *params,
-                             cgiRequestObj *req, owsRequestObj *ows_request)
-{
-  msSetError( MS_WFSERR,
-              "WFS 2.0 request made, but mapserver requires libxml2 for WFS 2.0 services and this is not configured.",
-              "msWFSListStoredQueries20()");
+                             cgiRequestObj *req, owsRequestObj *ows_request) {
+  msSetError(MS_WFSERR,
+             "WFS 2.0 request made, but mapserver requires libxml2 for WFS 2.0 "
+             "services and this is not configured.",
+             "msWFSListStoredQueries20()");
 
-  return msWFSException11(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE, params->pszVersion);
+  return msWFSException11(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE,
+                          params->pszVersion);
 }
 
 int msWFSDescribeStoredQueries20(mapObj *map, wfsParamsObj *params,
-                             cgiRequestObj *req, owsRequestObj *ows_request)
-{
-  msSetError( MS_WFSERR,
-              "WFS 2.0 request made, but mapserver requires libxml2 for WFS 2.0 services and this is not configured.",
-              "msWFSDescribeStoredQueries20()" );
+                                 cgiRequestObj *req,
+                                 owsRequestObj *ows_request) {
+  msSetError(MS_WFSERR,
+             "WFS 2.0 request made, but mapserver requires libxml2 for WFS 2.0 "
+             "services and this is not configured.",
+             "msWFSDescribeStoredQueries20()");
 
-  return msWFSException11(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE, params->pszVersion);
+  return msWFSException11(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE,
+                          params->pszVersion);
 }
 
-char* msWFSGetResolvedStoredQuery20(mapObj *map,
-                                    wfsParamsObj *params,
-                                    const char* id,
-                                    hashTableObj* hashTable)
-{
-  msSetError( MS_WFSERR,
-              "WFS 2.0 request made, but mapserver requires libxml2 for WFS 2.0 services and this is not configured.",
-              "msWFSGetResolvedStoredQuery20()" );
+char *msWFSGetResolvedStoredQuery20(mapObj *map, wfsParamsObj *params,
+                                    const char *id, hashTableObj *hashTable) {
+  msSetError(MS_WFSERR,
+             "WFS 2.0 request made, but mapserver requires libxml2 for WFS 2.0 "
+             "services and this is not configured.",
+             "msWFSGetResolvedStoredQuery20()");
 
-  msWFSException11(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE, params->pszVersion);
+  msWFSException11(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE,
+                   params->pszVersion);
   return NULL;
 }
 
diff -pruN 8.0.1-5/mapwfslayer.c 8.0.2-1/mapwfslayer.c
--- 8.0.1-5/mapwfslayer.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapwfslayer.c	2024-06-11 20:41:34.000000000 +0000
@@ -38,11 +38,8 @@
 #include <process.h>
 #endif
 
-
-
-#define WFS_V_0_0_14  14
-#define WFS_V_1_0_0  100
-
+#define WFS_V_0_0_14 14
+#define WFS_V_1_0_0 100
 
 /*====================================================================
  *  Private (static) functions
@@ -63,8 +60,7 @@
 /*                                                                      */
 /************************************************************************/
 static wfsParamsObj *msBuildRequestParams(mapObj *map, layerObj *lp,
-    rectObj *bbox_ret)
-{
+                                          rectObj *bbox_ret) {
   wfsParamsObj *psParams = NULL;
   rectObj bbox;
   const char *pszTmp;
@@ -85,7 +81,7 @@ static wfsParamsObj *msBuildRequestParam
     if (!pszTmp)
       pszTmp = strstr(lp->connection, "version=");
     if (pszTmp) {
-      pszVersion = strchr(pszTmp, '=')+1;
+      pszVersion = strchr(pszTmp, '=') + 1;
       if (strncmp(pszVersion, "0.0.14", 6) == 0)
         psParams->pszVersion = msStrdup("0.0.14");
       else if (strncmp(pszVersion, "1.0.0", 5) == 0)
@@ -126,17 +122,17 @@ static wfsParamsObj *msBuildRequestParam
     if (!pszTmp)
       pszTmp = strstr(lp->connection, "typename=");
     if (pszTmp) {
-      pszTypeName = strchr(pszTmp, '=')+1;
+      pszTypeName = strchr(pszTmp, '=') + 1;
       if (pszTypeName) {
         const int nLength = strlen(pszTypeName);
         if (nLength > 0) {
-          int i=0;
-          for (; i<nLength; i++) {
+          int i = 0;
+          for (; i < nLength; i++) {
             if (pszTypeName[i] == '&')
               break;
           }
 
-          if (i<nLength) {
+          if (i < nLength) {
             char *pszTypeNameTmp = NULL;
             pszTypeNameTmp = msStrdup(pszTypeName);
             pszTypeNameTmp[i] = '\0';
@@ -151,12 +147,17 @@ static wfsParamsObj *msBuildRequestParam
 
   pszTmp = msOWSLookupMetadata(&(lp->metadata), "FO", "filter");
   if (pszTmp && strlen(pszTmp) > 0) {
-    if (strstr(pszTmp, "<Filter>") !=NULL || strstr(pszTmp, "<ogc:Filter") != NULL)
+    if (strstr(pszTmp, "<Filter>") != NULL ||
+        strstr(pszTmp, "<ogc:Filter") != NULL)
       psParams->pszFilter = msStrdup(pszTmp);
     else {
-      psParams->pszFilter = msStringConcatenate(psParams->pszFilter, "<ogc:Filter xmlns:ogc=\"http://www.opengis.net/ogc\">");
-      psParams->pszFilter = msStringConcatenate(psParams->pszFilter, (char*)pszTmp);
-      psParams->pszFilter = msStringConcatenate(psParams->pszFilter, "</ogc:Filter>");
+      psParams->pszFilter = msStringConcatenate(
+          psParams->pszFilter,
+          "<ogc:Filter xmlns:ogc=\"http://www.opengis.net/ogc\">");
+      psParams->pszFilter =
+          msStringConcatenate(psParams->pszFilter, (char *)pszTmp);
+      psParams->pszFilter =
+          msStringConcatenate(psParams->pszFilter, "</ogc:Filter>");
     }
   }
 
@@ -167,7 +168,6 @@ static wfsParamsObj *msBuildRequestParam
   /* Request is always GetFeature; */
   psParams->pszRequest = msStrdup("GetFeature");
 
-
   /* ------------------------------------------------------------------
    * Figure the SRS we'll use for the request.
    * - Fetch the map SRS (if it's EPSG)
@@ -178,7 +178,8 @@ static wfsParamsObj *msBuildRequestParam
 
   /* __TODO__ WFS servers support only one SRS... need to decide how we'll */
   /* handle this and document it well. */
-  /* It's likely that we'll simply reproject the BBOX to teh layer's projection. */
+  /* It's likely that we'll simply reproject the BBOX to teh layer's projection.
+   */
 
   /* ------------------------------------------------------------------
    * Set layer SRS and reproject map extents to the layer's SRS
@@ -188,7 +189,7 @@ static wfsParamsObj *msBuildRequestParam
   if ((pszTmp = msGetEPSGProj(&(lp->projection), NULL, MS_TRUE)) == NULL ||
       strcasecmp(pszEPSG, pszTmp) != 0) {
     char szProj[20];
-    snprintf(szProj, sizeof(szProj), "init=epsg:%s", pszEPSG+5);
+    snprintf(szProj, sizeof(szProj), "init=epsg:%s", pszEPSG + 5);
     if (msLoadProjectionString(&(lp->projection), szProj) != 0)
       return NULL;
   }
@@ -202,7 +203,6 @@ static wfsParamsObj *msBuildRequestParam
   *bbox_ret = bbox;
 
   return psParams;
-
 }
 
 /**********************************************************************
@@ -213,8 +213,7 @@ static wfsParamsObj *msBuildRequestParam
  * Returns a reference to a newly allocated string that should be freed
  * by the caller.
  **********************************************************************/
-static char *msBuildWFSLayerPostRequest(rectObj *bbox, wfsParamsObj *psParams)
-{
+static char *msBuildWFSLayerPostRequest(rectObj *bbox, wfsParamsObj *psParams) {
   char *pszPostReq = NULL;
   char *pszFilter = NULL;
   char *pszGeometryName = "Geometry";
@@ -223,18 +222,19 @@ static char *msBuildWFSLayerPostRequest(
   if (psParams->pszVersion == NULL ||
       (strncmp(psParams->pszVersion, "0.0.14", 6) != 0 &&
        strncmp(psParams->pszVersion, "1.0.0", 5)) != 0) {
-    msSetError(MS_WFSCONNERR, "MapServer supports only WFS 1.0.0 or 0.0.14 (please verify the version metadata wfs_version).", "msBuildWFSLayerPostRequest()");
+    msSetError(MS_WFSCONNERR,
+               "MapServer supports only WFS 1.0.0 or 0.0.14 (please verify the "
+               "version metadata wfs_version).",
+               "msBuildWFSLayerPostRequest()");
     return NULL;
   }
 
-
-
   if (psParams->pszTypeName == NULL) {
-    msSetError(MS_WFSCONNERR, "Metadata wfs_typename must be set in the layer", "msBuildWFSLayerPostRequest()");
+    msSetError(MS_WFSCONNERR, "Metadata wfs_typename must be set in the layer",
+               "msBuildWFSLayerPostRequest()");
     return NULL;
   }
 
-
   if (psParams->pszGeometryName) {
     pszGeometryName = psParams->pszGeometryName;
   }
@@ -244,45 +244,60 @@ static char *msBuildWFSLayerPostRequest(
   else {
     bufferSize = 500;
     pszFilter = (char *)msSmallMalloc(bufferSize);
-    snprintf(pszFilter, bufferSize, "<ogc:Filter>\n"
+    snprintf(pszFilter, bufferSize,
+             "<ogc:Filter>\n"
              "<ogc:BBOX>\n"
              "<ogc:PropertyName>%s</ogc:PropertyName>\n"
              "<gml:Box>\n"
              "<gml:coordinates>%f,%f %f,%f</gml:coordinates>\n"
              "</gml:Box>\n"
              "</ogc:BBOX>\n"
-             "</ogc:Filter>", pszGeometryName, bbox->minx, bbox->miny, bbox->maxx, bbox->maxy);
+             "</ogc:Filter>",
+             pszGeometryName, bbox->minx, bbox->miny, bbox->maxx, bbox->maxy);
   }
 
-  bufferSize = strlen(pszFilter)+strlen(psParams->pszTypeName)+500;
+  bufferSize = strlen(pszFilter) + strlen(psParams->pszTypeName) + 500;
   pszPostReq = (char *)msSmallMalloc(bufferSize);
   if (psParams->nMaxFeatures > 0)
-    snprintf(pszPostReq, bufferSize, "<?xml version=\"1.0\" ?>\n"
+    snprintf(pszPostReq, bufferSize,
+             "<?xml version=\"1.0\" ?>\n"
              "<wfs:GetFeature\n"
              "service=\"WFS\"\n"
              "version=\"1.0.0\"\n"
              "maxFeatures=\"%d\"\n"
              "outputFormat=\"GML2\"\n"
-			 "xmlns:wfs=\"http://www.opengis.net/wfs\" xmlns:ogc=\"http://www.opengis.net/ogc\" xsi:schemaLocation=\"http://www.opengis.net/wfs http://schemas.opengis.net/wfs/1.0.0/wfs.xsd\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:gml=\"http://www.opengis.net/gml\">\n"
+             "xmlns:wfs=\"http://www.opengis.net/wfs\" "
+             "xmlns:ogc=\"http://www.opengis.net/ogc\" "
+             "xsi:schemaLocation=\"http://www.opengis.net/wfs "
+             "http://schemas.opengis.net/wfs/1.0.0/wfs.xsd\" "
+             "xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" "
+             "xmlns:gml=\"http://www.opengis.net/gml\">\n"
              "<wfs:Query typeName=\"%s\">\n"
              "%s"
              "</wfs:Query>\n"
-             "</wfs:GetFeature>\n", psParams->nMaxFeatures, psParams->pszTypeName, pszFilter);
+             "</wfs:GetFeature>\n",
+             psParams->nMaxFeatures, psParams->pszTypeName, pszFilter);
   else
-    snprintf(pszPostReq, bufferSize, "<?xml version=\"1.0\" ?>\n"
+    snprintf(pszPostReq, bufferSize,
+             "<?xml version=\"1.0\" ?>\n"
              "<wfs:GetFeature\n"
              "service=\"WFS\"\n"
              "version=\"1.0.0\"\n"
              "outputFormat=\"GML2\"\n"
-             "xmlns:wfs=\"http://www.opengis.net/wfs\" xmlns:ogc=\"http://www.opengis.net/ogc\" xsi:schemaLocation=\"http://www.opengis.net/wfs http://schemas.opengis.net/wfs/1.0.0/wfs.xsd\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:gml=\"http://www.opengis.net/gml\">\n"
+             "xmlns:wfs=\"http://www.opengis.net/wfs\" "
+             "xmlns:ogc=\"http://www.opengis.net/ogc\" "
+             "xsi:schemaLocation=\"http://www.opengis.net/wfs "
+             "http://schemas.opengis.net/wfs/1.0.0/wfs.xsd\" "
+             "xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" "
+             "xmlns:gml=\"http://www.opengis.net/gml\">\n"
              "<wfs:Query typeName=\"%s\">\n"
              "%s"
              "</wfs:Query>\n"
-             "</wfs:GetFeature>\n", psParams->pszTypeName, pszFilter);
+             "</wfs:GetFeature>\n",
+             psParams->pszTypeName, pszFilter);
   if (psParams->pszFilter == NULL)
     free(pszFilter);
 
-
   return pszPostReq;
 }
 
@@ -295,9 +310,8 @@ static char *msBuildWFSLayerPostRequest(
  * by the caller.
  **********************************************************************/
 static char *msBuildWFSLayerGetURL(layerObj *lp, rectObj *bbox,
-                                   wfsParamsObj *psParams)
-{
-  char *pszURL = NULL, *pszOnlineResource=NULL;
+                                   wfsParamsObj *psParams) {
+  char *pszURL = NULL, *pszOnlineResource = NULL;
   const char *pszTmp;
   char *pszVersion, *pszService, *pszTypename = NULL;
   int bVersionInConnection = 0;
@@ -319,21 +333,22 @@ static char *msBuildWFSLayerGetURL(layer
   pszVersion = psParams->pszVersion;
   if (!pszVersion) {
     if ((pszTmp = strstr(lp->connection, "VERSION=")) == NULL &&
-        (pszTmp = strstr(lp->connection, "version=")) == NULL ) {
-      msSetError(MS_WFSCONNERR, "Metadata wfs_version must be set in the layer", "msBuildWFSLayerGetURL()");
+        (pszTmp = strstr(lp->connection, "version=")) == NULL) {
+      msSetError(MS_WFSCONNERR, "Metadata wfs_version must be set in the layer",
+                 "msBuildWFSLayerGetURL()");
       return NULL;
     }
-    pszVersion = strchr(pszTmp, '=')+1;
+    pszVersion = strchr(pszTmp, '=') + 1;
     bVersionInConnection = 1;
   }
 
-
   if (strncmp(pszVersion, "0.0.14", 6) != 0 &&
       strncmp(pszVersion, "1.0.0", 5) != 0 &&
       strncmp(pszVersion, "1.1", 3) != 0) {
     msSetError(MS_WFSCONNERR,
-	       "MapServer supports only WFS 1.1.0, 1.0.0 or 0.0.14 (please verify the version metadata wfs_version).",
-	       "msBuildWFSLayerGetURL()");
+               "MapServer supports only WFS 1.1.0, 1.0.0 or 0.0.14 (please "
+               "verify the version metadata wfs_version).",
+               "msBuildWFSLayerGetURL()");
     return NULL;
   }
 
@@ -343,7 +358,6 @@ static char *msBuildWFSLayerGetURL(layer
   /* -------------------------------------------------------------------- */
   pszService = psParams->pszService;
 
-
   /* -------------------------------------------------------------------- */
   /*      Find out the typename. Look first for the wfs_tyename           */
   /*      metadata. If not available try to find out if the CONNECTION    */
@@ -353,14 +367,15 @@ static char *msBuildWFSLayerGetURL(layer
   pszTypename = psParams->pszTypeName;
   if (!pszTypename) {
     if ((pszTmp = strstr(lp->connection, "TYPENAME=")) == NULL &&
-        (pszTmp = strstr(lp->connection, "typename=")) == NULL ) {
-      msSetError(MS_WFSCONNERR, "Metadata wfs_typename must be set in the layer", "msBuildWFSLayerGetURL()");
+        (pszTmp = strstr(lp->connection, "typename=")) == NULL) {
+      msSetError(MS_WFSCONNERR,
+                 "Metadata wfs_typename must be set in the layer",
+                 "msBuildWFSLayerGetURL()");
       return NULL;
     }
     bTypenameInConnection = 1;
   }
 
-
   /* --------------------------------------------------------------------
    * Build the request URL.
    * At this point we set only the following parameters for GetFeature:
@@ -379,7 +394,7 @@ static char *msBuildWFSLayerGetURL(layer
    *   TYPENAME
    * -------------------------------------------------------------------- */
   /* Make sure we have a big enough buffer for the URL */
-  bufferSize = strlen(lp->connection)+1024;
+  bufferSize = strlen(lp->connection) + 1024;
   pszURL = (char *)malloc(bufferSize);
   MS_CHECK_ALLOC(pszURL, bufferSize, NULL);
 
@@ -396,18 +411,22 @@ static char *msBuildWFSLayerGetURL(layer
   msFree(pszOnlineResource);
 
   /* REQUEST */
-  snprintf(pszURL + strlen(pszURL), bufferSize-strlen(pszURL),  "&REQUEST=GetFeature");
+  snprintf(pszURL + strlen(pszURL), bufferSize - strlen(pszURL),
+           "&REQUEST=GetFeature");
 
   /* VERSION */
   if (!bVersionInConnection)
-    snprintf(pszURL + strlen(pszURL), bufferSize-strlen(pszURL),  "&VERSION=%s", pszVersion);
+    snprintf(pszURL + strlen(pszURL), bufferSize - strlen(pszURL),
+             "&VERSION=%s", pszVersion);
 
   /* SERVICE */
-  snprintf(pszURL + strlen(pszURL), bufferSize-strlen(pszURL),  "&SERVICE=%s", pszService);
+  snprintf(pszURL + strlen(pszURL), bufferSize - strlen(pszURL), "&SERVICE=%s",
+           pszService);
 
   /* TYPENAME */
   if (!bTypenameInConnection)
-    snprintf(pszURL + strlen(pszURL), bufferSize-strlen(pszURL),  "&TYPENAME=%s", pszTypename);
+    snprintf(pszURL + strlen(pszURL), bufferSize - strlen(pszURL),
+             "&TYPENAME=%s", pszTypename);
 
   /* -------------------------------------------------------------------- */
   /*      If the filter parameter is given in the wfs_filter metadata,    */
@@ -416,53 +435,51 @@ static char *msBuildWFSLayerGetURL(layer
   /* -------------------------------------------------------------------- */
   if (psParams->pszFilter) {
     char *encoded_filter = msEncodeUrl(psParams->pszFilter);
-    snprintf(pszURL + strlen(pszURL), bufferSize-strlen(pszURL), "&FILTER=%s",encoded_filter);
+    snprintf(pszURL + strlen(pszURL), bufferSize - strlen(pszURL), "&FILTER=%s",
+             encoded_filter);
     free(encoded_filter);
   } else {
-	  /*
-	   * take care about the axis order for WFS 1.1
-	   */
-	  char *projUrn;
-	  char *projEpsg;
-	  projUrn = msOWSGetProjURN(&(lp->projection), &(lp->metadata), "FO", 1);
-	  msOWSGetEPSGProj(&(lp->projection), &(lp->metadata), "FO", 1, &projEpsg);
-
-	  /*
-	   * WFS 1.1 supports including the SRS in the BBOX parameter, should
-	   * respect axis order in the BBOX and has a separate SRSNAME parameter for
-	   * the desired result SRS.
-	   * WFS 1.0 is always easting, northing, doesn't include the SRS as part of
-	   * the BBOX parameter and has no SRSNAME parameter: if we don't have a
-	   * URN then fallback to WFS 1.0 style */
-	  if ((strncmp(pszVersion, "1.1", 3) == 0) && projUrn) {
-		 if (projEpsg && (strncmp(projEpsg, "EPSG:", 5) == 0) &&
-				 msIsAxisInverted(atoi(projEpsg + 5))) {
-			 snprintf(pszURL + strlen(pszURL), bufferSize - strlen(pszURL),
-					 "&BBOX=%.15g,%.15g,%.15g,%.15g,%s&SRSNAME=%s",
-					 bbox->miny, bbox->minx, bbox->maxy, bbox->maxx,
-					 projUrn, projUrn);
-		 } else {
-			 snprintf(pszURL + strlen(pszURL), bufferSize - strlen(pszURL),
-					 "&BBOX=%.15g,%.15g,%.15g,%.15g,%s&SRSNAME=%s",
-					 bbox->minx, bbox->miny, bbox->maxx, bbox->maxy,
-					 projUrn, projUrn);
-		 }
-	  } else {
-		  snprintf(pszURL + strlen(pszURL), bufferSize - strlen(pszURL),
-				  "&BBOX=%.15g,%.15g,%.15g,%.15g",
-				  bbox->minx, bbox->miny, bbox->maxx, bbox->maxy);
-	  }
+    /*
+     * take care about the axis order for WFS 1.1
+     */
+    char *projUrn;
+    char *projEpsg;
+    projUrn = msOWSGetProjURN(&(lp->projection), &(lp->metadata), "FO", 1);
+    msOWSGetEPSGProj(&(lp->projection), &(lp->metadata), "FO", 1, &projEpsg);
+
+    /*
+     * WFS 1.1 supports including the SRS in the BBOX parameter, should
+     * respect axis order in the BBOX and has a separate SRSNAME parameter for
+     * the desired result SRS.
+     * WFS 1.0 is always easting, northing, doesn't include the SRS as part of
+     * the BBOX parameter and has no SRSNAME parameter: if we don't have a
+     * URN then fallback to WFS 1.0 style */
+    if ((strncmp(pszVersion, "1.1", 3) == 0) && projUrn) {
+      if (projEpsg && (strncmp(projEpsg, "EPSG:", 5) == 0) &&
+          msIsAxisInverted(atoi(projEpsg + 5))) {
+        snprintf(pszURL + strlen(pszURL), bufferSize - strlen(pszURL),
+                 "&BBOX=%.15g,%.15g,%.15g,%.15g,%s&SRSNAME=%s", bbox->miny,
+                 bbox->minx, bbox->maxy, bbox->maxx, projUrn, projUrn);
+      } else {
+        snprintf(pszURL + strlen(pszURL), bufferSize - strlen(pszURL),
+                 "&BBOX=%.15g,%.15g,%.15g,%.15g,%s&SRSNAME=%s", bbox->minx,
+                 bbox->miny, bbox->maxx, bbox->maxy, projUrn, projUrn);
+      }
+    } else {
+      snprintf(pszURL + strlen(pszURL), bufferSize - strlen(pszURL),
+               "&BBOX=%.15g,%.15g,%.15g,%.15g", bbox->minx, bbox->miny,
+               bbox->maxx, bbox->maxy);
+    }
 
-	  msFree(projUrn);
-	  msFree(projEpsg);
+    msFree(projUrn);
+    msFree(projEpsg);
   }
 
   if (psParams->nMaxFeatures > 0)
-    snprintf(pszURL + strlen(pszURL), bufferSize-strlen(pszURL),
+    snprintf(pszURL + strlen(pszURL), bufferSize - strlen(pszURL),
              "&MAXFEATURES=%d", psParams->nMaxFeatures);
 
   return pszURL;
-
 }
 
 /**********************************************************************
@@ -470,23 +487,22 @@ static char *msBuildWFSLayerGetURL(layer
  *
  **********************************************************************/
 typedef struct ms_wfs_layer_info_t {
-  char        *pszGMLFilename;
-  rectObj     rect;                     /* set by WhichShapes */
-  char        *pszGetUrl;
-  int         nStatus;           /* HTTP status */
-  int         bLayerHasValidGML;  /* False until msWFSLayerWhichShapes() is called and determines the result GML is valid with features*/
+  char *pszGMLFilename;
+  rectObj rect; /* set by WhichShapes */
+  char *pszGetUrl;
+  int nStatus;           /* HTTP status */
+  int bLayerHasValidGML; /* False until msWFSLayerWhichShapes() is called and
+                            determines the result GML is valid with features*/
 } msWFSLayerInfo;
 
-
 /**********************************************************************
  *                          msAllocWFSLayerInfo()
  *
  **********************************************************************/
-static msWFSLayerInfo *msAllocWFSLayerInfo(void)
-{
+static msWFSLayerInfo *msAllocWFSLayerInfo(void) {
   msWFSLayerInfo *psInfo;
 
-  psInfo = (msWFSLayerInfo*)calloc(1,sizeof(msWFSLayerInfo));
+  psInfo = (msWFSLayerInfo *)calloc(1, sizeof(msWFSLayerInfo));
   MS_CHECK_ALLOC(psInfo, sizeof(msWFSLayerInfo), NULL);
 
   psInfo->pszGMLFilename = NULL;
@@ -502,8 +518,7 @@ static msWFSLayerInfo *msAllocWFSLayerIn
  *                          msFreeWFSLayerInfo()
  *
  **********************************************************************/
-static void msFreeWFSLayerInfo(msWFSLayerInfo *psInfo)
-{
+static void msFreeWFSLayerInfo(msWFSLayerInfo *psInfo) {
   if (psInfo) {
     if (psInfo->pszGMLFilename)
       free(psInfo->pszGMLFilename);
@@ -526,8 +541,7 @@ static void msFreeWFSLayerInfo(msWFSLaye
  **********************************************************************/
 
 int msPrepareWFSLayerRequest(int nLayerId, mapObj *map, layerObj *lp,
-                             httpRequestObj *pasReqInfo, int *numRequests)
-{
+                             httpRequestObj *pasReqInfo, int *numRequests) {
 #ifdef USE_WFS_LYR
   char *pszURL = NULL;
   const char *pszTmp;
@@ -539,7 +553,6 @@ int msPrepareWFSLayerRequest(int nLayerI
   wfsParamsObj *psParams = NULL;
   char *pszHTTPCookieData = NULL;
 
-
   if (lp->connectiontype != MS_WFS || lp->connection == NULL)
     return MS_FAILURE;
 
@@ -559,9 +572,9 @@ int msPrepareWFSLayerRequest(int nLayerI
   /*      If it is a Post request, the URL will only contain the          */
   /*      connection string comming from the layer.                       */
   /* -------------------------------------------------------------------- */
-  if ((pszTmp = msOWSLookupMetadata(&(lp->metadata),
-                                    "FO", "request_method")) != NULL) {
-    if (strncmp(pszTmp, "GET", 3) ==0) {
+  if ((pszTmp = msOWSLookupMetadata(&(lp->metadata), "FO", "request_method")) !=
+      NULL) {
+    if (strncmp(pszTmp, "GET", 3) == 0) {
       pszURL = msBuildWFSLayerGetURL(lp, &bbox, psParams);
       if (!pszURL) {
         /* an error was already reported. */
@@ -580,9 +593,9 @@ int msPrepareWFSLayerRequest(int nLayerI
    * the case we will use it, else we use the default which is 30 seconds.
    * First check the metadata in the layer object and then in the map object.
    * ------------------------------------------------------------------ */
-  nTimeout = 30;  /* Default is 30 seconds  */
+  nTimeout = 30; /* Default is 30 seconds  */
   if ((pszTmp = msOWSLookupMetadata2(&(lp->metadata), &(map->web.metadata),
-                                    "FO", "connectiontimeout")) != NULL) {
+                                     "FO", "connectiontimeout")) != NULL) {
     nTimeout = atoi(pszTmp);
   }
 
@@ -591,21 +604,21 @@ int msPrepareWFSLayerRequest(int nLayerI
    * If Cookie differ between the two connection, it's NOT OK to merge
    * the connection
    * ------------------------------------------------------------------ */
-  if ((pszTmp = msOWSLookupMetadata(&(lp->metadata),
-                                    "FO", "http_cookie")) != NULL) {
-    if(strcasecmp(pszTmp, "forward") == 0) {
-      pszTmp= msLookupHashTable(&(map->web.metadata),"http_cookie_data");
-      if(pszTmp != NULL) {
+  if ((pszTmp = msOWSLookupMetadata(&(lp->metadata), "FO", "http_cookie")) !=
+      NULL) {
+    if (strcasecmp(pszTmp, "forward") == 0) {
+      pszTmp = msLookupHashTable(&(map->web.metadata), "http_cookie_data");
+      if (pszTmp != NULL) {
         pszHTTPCookieData = msStrdup(pszTmp);
       }
     } else {
       pszHTTPCookieData = msStrdup(pszTmp);
     }
-  } else if ((pszTmp = msOWSLookupMetadata(&(map->web.metadata),
-                       "FO", "http_cookie")) != NULL) {
-    if(strcasecmp(pszTmp, "forward") == 0) {
-      pszTmp= msLookupHashTable(&(map->web.metadata),"http_cookie_data");
-      if(pszTmp != NULL) {
+  } else if ((pszTmp = msOWSLookupMetadata(&(map->web.metadata), "FO",
+                                           "http_cookie")) != NULL) {
+    if (strcasecmp(pszTmp, "forward") == 0) {
+      pszTmp = msLookupHashTable(&(map->web.metadata), "http_cookie_data");
+      if (pszTmp != NULL) {
         pszHTTPCookieData = msStrdup(pszTmp);
       }
     } else {
@@ -618,7 +631,7 @@ int msPrepareWFSLayerRequest(int nLayerI
    * ------------------------------------------------------------------ */
   if (nLayerId == -1) {
     int iLayer;
-    for(iLayer=0; iLayer < map->numlayers; iLayer++) {
+    for (iLayer = 0; iLayer < map->numlayers; iLayer++) {
       if (GET_LAYER(map, iLayer) == lp) {
         nLayerId = iLayer;
         break;
@@ -634,14 +647,13 @@ int msPrepareWFSLayerRequest(int nLayerI
 
   if (bPostRequest) {
     pasReqInfo[(*numRequests)].pszPostRequest =
-      msBuildWFSLayerPostRequest(&bbox, psParams);
-    pasReqInfo[(*numRequests)].pszPostContentType =
-      msStrdup("text/xml");
+        msBuildWFSLayerPostRequest(&bbox, psParams);
+    pasReqInfo[(*numRequests)].pszPostContentType = msStrdup("text/xml");
   }
 
-
   /* We'll store the remote server's response to a tmp file. */
-  pasReqInfo[(*numRequests)].pszOutputFile = msTmpFile(map, map->mappath, NULL, "tmp.gml");
+  pasReqInfo[(*numRequests)].pszOutputFile =
+      msTmpFile(map, map->mappath, NULL, "tmp.gml");
 
   /* TODO: Implement Caching of GML responses. There was an older caching
    * method, but it suffered from a race condition. See #3137.
@@ -654,26 +666,26 @@ int msPrepareWFSLayerRequest(int nLayerI
   pasReqInfo[(*numRequests)].bbox = bbox;
   pasReqInfo[(*numRequests)].debug = lp->debug;
 
-  if (msHTTPAuthProxySetup(&(map->web.metadata), &(lp->metadata),
-                           pasReqInfo, *numRequests, map, "FO") != MS_SUCCESS) {
+  if (msHTTPAuthProxySetup(&(map->web.metadata), &(lp->metadata), pasReqInfo,
+                           *numRequests, map, "FO") != MS_SUCCESS) {
     msWFSFreeParamsObj(psParams);
     return MS_FAILURE;
   }
-  
+
   /* ------------------------------------------------------------------
    * Pre-Open the layer now, (i.e. alloc and fill msWFSLayerInfo inside
    * layer obj).  Layer will be ready for use when the main mapserver
    * code calls msLayerOpen().
    * ------------------------------------------------------------------ */
   if (lp->wfslayerinfo != NULL) {
-    psInfo =(msWFSLayerInfo*)(lp->wfslayerinfo);
+    psInfo = (msWFSLayerInfo *)(lp->wfslayerinfo);
   } else {
     lp->wfslayerinfo = psInfo = msAllocWFSLayerInfo();
   }
 
   if (psInfo->pszGMLFilename)
     free(psInfo->pszGMLFilename);
-  psInfo->pszGMLFilename=msStrdup(pasReqInfo[(*numRequests)].pszOutputFile);
+  psInfo->pszGMLFilename = msStrdup(pasReqInfo[(*numRequests)].pszOutputFile);
 
   psInfo->rect = pasReqInfo[(*numRequests)].bbox;
 
@@ -695,10 +707,9 @@ int msPrepareWFSLayerRequest(int nLayerI
    * ------------------------------------------------------------------ */
   msSetError(MS_WFSCONNERR, "WFS CLIENT CONNECTION support is not available.",
              "msPrepareWFSLayerRequest");
-  return(MS_FAILURE);
+  return (MS_FAILURE);
 
 #endif /* USE_WFS_LYR */
-
 }
 
 /**********************************************************************
@@ -709,13 +720,12 @@ int msPrepareWFSLayerRequest(int nLayerI
  * msWFSLayerInfo struct.  Things to copy here are the HTTP status, exceptions
  * information, mime type, etc.
  **********************************************************************/
-void msWFSUpdateRequestInfo(layerObj *lp, httpRequestObj *pasReqInfo)
-{
+void msWFSUpdateRequestInfo(layerObj *lp, httpRequestObj *pasReqInfo) {
 #ifdef USE_WFS_LYR
   if (lp->wfslayerinfo) {
     msWFSLayerInfo *psInfo = NULL;
 
-    psInfo =(msWFSLayerInfo*)(lp->wfslayerinfo);
+    psInfo = (msWFSLayerInfo *)(lp->wfslayerinfo);
 
     /* Copy request results infos to msWFSLayerInfo struct */
     /* For now there is only nStatus, but we should eventually add */
@@ -740,18 +750,17 @@ void msWFSUpdateRequestInfo(layerObj *lp
  *
  **********************************************************************/
 
-int msWFSLayerOpen(layerObj *lp,
-                   const char *pszGMLFilename, rectObj *defaultBBOX)
-{
+int msWFSLayerOpen(layerObj *lp, const char *pszGMLFilename,
+                   rectObj *defaultBBOX) {
 #ifdef USE_WFS_LYR
   int status = MS_SUCCESS;
   msWFSLayerInfo *psInfo = NULL;
 
-  if ( msCheckParentPointer(lp->map,"map")==MS_FAILURE )
+  if (msCheckParentPointer(lp->map, "map") == MS_FAILURE)
     return MS_FAILURE;
 
   if (lp->wfslayerinfo != NULL) {
-    psInfo =(msWFSLayerInfo*)lp->wfslayerinfo;
+    psInfo = (msWFSLayerInfo *)lp->wfslayerinfo;
 
     /* Layer already opened.  If explicit filename requested then check */
     /* that file was already opened with the same filename. */
@@ -759,18 +768,20 @@ int msWFSLayerOpen(layerObj *lp,
     /* previously opened layer... this will happen in a msDrawMap() call. */
     if (pszGMLFilename == NULL ||
         (psInfo->pszGMLFilename &&
-         strcmp(psInfo->pszGMLFilename, pszGMLFilename) == 0) ) {
+         strcmp(psInfo->pszGMLFilename, pszGMLFilename) == 0)) {
       if (lp->layerinfo == NULL) {
-        if (msWFSLayerWhichShapes(lp, psInfo->rect, MS_FALSE) == MS_FAILURE) /* no access to context (draw vs. query) here, although I doubt it matters... */
+        if (msWFSLayerWhichShapes(lp, psInfo->rect, MS_FALSE) ==
+            MS_FAILURE) /* no access to context (draw vs. query) here, although
+                           I doubt it matters... */
           return MS_FAILURE;
       }
-      return MS_SUCCESS;  /* Nothing to do... layer is already opened */
+      return MS_SUCCESS; /* Nothing to do... layer is already opened */
     } else {
       /* Hmmm... should we produce a fatal error? */
       /* For now we'll just close the layer and reopen it. */
       if (lp->debug)
         msDebug("msWFSLayerOpen(): Layer already opened (%s)\n",
-                lp->name?lp->name:"(null)" );
+                lp->name ? lp->name : "(null)");
       msWFSLayerClose(lp);
     }
   }
@@ -783,10 +794,8 @@ int msWFSLayerOpen(layerObj *lp,
   if (pszGMLFilename)
     psInfo->pszGMLFilename = msStrdup(pszGMLFilename);
   else {
-    psInfo->pszGMLFilename = msTmpFile(lp->map,
-                                       lp->map->mappath,
-                                       NULL,
-                                       "tmp.gml");
+    psInfo->pszGMLFilename =
+        msTmpFile(lp->map, lp->map->mappath, NULL, "tmp.gml");
   }
 
   if (defaultBBOX) {
@@ -805,13 +814,15 @@ int msWFSLayerOpen(layerObj *lp,
   /* between now and the time whichshapes() would have been called by */
   /* the MapServer core. */
 
-  if((lp->map->projection.numargs > 0) && (lp->projection.numargs > 0))
-    msProjectRect(&lp->map->projection, &lp->projection, &psInfo->rect); /* project the searchrect to source coords */
-
-  if (msWFSLayerWhichShapes(lp, psInfo->rect, MS_FALSE) == MS_FAILURE)  /* no access to context (draw vs. query) here, although I doubt it matters... */
+  if ((lp->map->projection.numargs > 0) && (lp->projection.numargs > 0))
+    msProjectRect(&lp->map->projection, &lp->projection,
+                  &psInfo->rect); /* project the searchrect to source coords */
+
+  if (msWFSLayerWhichShapes(lp, psInfo->rect, MS_FALSE) ==
+      MS_FAILURE) /* no access to context (draw vs. query) here, although I
+                     doubt it matters... */
     status = MS_FAILURE;
 
-
   return status;
 #else
   /* ------------------------------------------------------------------
@@ -819,7 +830,7 @@ int msWFSLayerOpen(layerObj *lp,
    * ------------------------------------------------------------------ */
   msSetError(MS_WFSCONNERR, "WFS CLIENT CONNECTION support is not available.",
              "msWFSLayerOpen()");
-  return(MS_FAILURE);
+  return (MS_FAILURE);
 
 #endif /* USE_WFS_LYR */
 }
@@ -829,11 +840,7 @@ int msWFSLayerOpen(layerObj *lp,
  *
  * Overloaded version of msWFSLayerOpen for virtual table architecture
  **********************************************************************/
-int
-msWFSLayerOpenVT(layerObj *lp)
-{
-  return msWFSLayerOpen(lp, NULL, NULL);
-}
+int msWFSLayerOpenVT(layerObj *lp) { return msWFSLayerOpen(lp, NULL, NULL); }
 
 /**********************************************************************
  *                          msWFSLayerIsOpen()
@@ -842,8 +849,7 @@ msWFSLayerOpenVT(layerObj *lp)
  *
  **********************************************************************/
 
-int msWFSLayerIsOpen(layerObj *lp)
-{
+int msWFSLayerIsOpen(layerObj *lp) {
 #ifdef USE_WFS_LYR
   if (lp->wfslayerinfo != NULL)
     return MS_TRUE;
@@ -855,7 +861,7 @@ int msWFSLayerIsOpen(layerObj *lp)
    * ------------------------------------------------------------------ */
   msSetError(MS_WFSCONNERR, "WFS CLIENT CONNECTION support is not available.",
              "msWFSLayerIsOpen()");
-  return(MS_FALSE);
+  return (MS_FALSE);
 
 #endif /* USE_WFS_LYR */
 }
@@ -865,8 +871,7 @@ int msWFSLayerIsOpen(layerObj *lp)
  *
  **********************************************************************/
 
-int msWFSLayerInitItemInfo(layerObj *layer)
-{
+int msWFSLayerInitItemInfo(layerObj *layer) {
   (void)layer;
   /* Nothing to do here.  OGR will do its own initialization when it */
   /* opens the actual file. */
@@ -879,19 +884,18 @@ int msWFSLayerInitItemInfo(layerObj *lay
  *                          msWFSLayerGetShape()
  *
  **********************************************************************/
-int msWFSLayerGetShape(layerObj *layer, shapeObj *shape, resultObj *record)
-{
+int msWFSLayerGetShape(layerObj *layer, shapeObj *shape, resultObj *record) {
 #ifdef USE_WFS_LYR
-  msWFSLayerInfo* psInfo = NULL;
+  msWFSLayerInfo *psInfo = NULL;
 
-  if(layer != NULL && layer->wfslayerinfo != NULL)
-    psInfo = (msWFSLayerInfo*)layer->wfslayerinfo;
+  if (layer != NULL && layer->wfslayerinfo != NULL)
+    psInfo = (msWFSLayerInfo *)layer->wfslayerinfo;
   else {
     msSetError(MS_WFSERR, "Layer is not opened.", "msWFSLayerGetShape()");
     return MS_FAILURE;
   }
 
-  if(psInfo->bLayerHasValidGML)
+  if (psInfo->bLayerHasValidGML)
     return msOGRLayerGetShape(layer, shape, record);
   else {
     /* Layer is successful, but there is no data to process */
@@ -905,28 +909,26 @@ int msWFSLayerGetShape(layerObj *layer,
    * ------------------------------------------------------------------ */
   msSetError(MS_WFSCONNERR, "WFS CLIENT CONNECTION support is not available.",
              "msWFSLayerGetShape()");
-  return(MS_FAILURE);
+  return (MS_FAILURE);
 #endif /* USE_WFS_LYR */
-
 }
 
 /**********************************************************************
  *                          msWFSLayerGetNextShape()
  *
  **********************************************************************/
-int msWFSLayerNextShape(layerObj *layer, shapeObj *shape)
-{
+int msWFSLayerNextShape(layerObj *layer, shapeObj *shape) {
 #ifdef USE_WFS_LYR
-  msWFSLayerInfo* psInfo = NULL;
+  msWFSLayerInfo *psInfo = NULL;
 
-  if(layer != NULL && layer->wfslayerinfo != NULL)
-    psInfo = (msWFSLayerInfo*)layer->wfslayerinfo;
+  if (layer != NULL && layer->wfslayerinfo != NULL)
+    psInfo = (msWFSLayerInfo *)layer->wfslayerinfo;
   else {
     msSetError(MS_WFSERR, "Layer is not opened.", "msWFSLayerNextShape()");
     return MS_FAILURE;
   }
 
-  if(psInfo->bLayerHasValidGML)
+  if (psInfo->bLayerHasValidGML)
     return msOGRLayerNextShape(layer, shape);
   else {
     /* Layer is successful, but there is no data to process */
@@ -940,32 +942,31 @@ int msWFSLayerNextShape(layerObj *layer,
    * ------------------------------------------------------------------ */
   msSetError(MS_WFSCONNERR, "WFS CLIENT CONNECTION support is not available.",
              "msWFSLayerNextShape()");
-  return(MS_FAILURE);
+  return (MS_FAILURE);
 #endif /* USE_WFS_LYR */
-
 }
 
 /**********************************************************************
  *                          msWFSLayerGetExtent()
  *
  **********************************************************************/
-int msWFSLayerGetExtent(layerObj *layer, rectObj *extent)
-{
+int msWFSLayerGetExtent(layerObj *layer, rectObj *extent) {
 #ifdef USE_WFS_LYR
-  msWFSLayerInfo* psInfo = NULL;
+  msWFSLayerInfo *psInfo = NULL;
 
-  if(layer != NULL && layer->wfslayerinfo != NULL)
-    psInfo = (msWFSLayerInfo*)layer->wfslayerinfo;
+  if (layer != NULL && layer->wfslayerinfo != NULL)
+    psInfo = (msWFSLayerInfo *)layer->wfslayerinfo;
   else {
     msSetError(MS_WFSERR, "Layer is not opened.", "msWFSLayerGetExtent()");
     return MS_FAILURE;
   }
 
-  if(psInfo->bLayerHasValidGML)
+  if (psInfo->bLayerHasValidGML)
     return msOGRLayerGetExtent(layer, extent);
   else {
     /* Layer is successful, but there is no data to process */
-    msSetError(MS_WFSERR, "Unable to get extents for this layer.", "msWFSLayerGetExtent()");
+    msSetError(MS_WFSERR, "Unable to get extents for this layer.",
+               "msWFSLayerGetExtent()");
     return MS_FAILURE;
   }
 #else
@@ -974,9 +975,8 @@ int msWFSLayerGetExtent(layerObj *layer,
    * ------------------------------------------------------------------ */
   msSetError(MS_WFSCONNERR, "WFS CLIENT CONNECTION support is not available.",
              "msWFSLayerGetExtent()");
-  return(MS_FAILURE);
+  return (MS_FAILURE);
 #endif /* USE_WFS_LYR */
-
 }
 
 /**********************************************************************
@@ -984,24 +984,23 @@ int msWFSLayerGetExtent(layerObj *layer,
  *
  **********************************************************************/
 
-int msWFSLayerGetItems(layerObj *layer)
-{
+int msWFSLayerGetItems(layerObj *layer) {
 #ifdef USE_WFS_LYR
   /* For now this method simply lets OGR parse the GML and figure the  */
   /* schema itself. */
   /* It could also be implemented to call DescribeFeatureType for */
   /* this layer, but we don't need to do it so why waste resources? */
 
-  msWFSLayerInfo* psInfo = NULL;
+  msWFSLayerInfo *psInfo = NULL;
 
-  if(layer != NULL && layer->wfslayerinfo != NULL)
-    psInfo = (msWFSLayerInfo*)layer->wfslayerinfo;
+  if (layer != NULL && layer->wfslayerinfo != NULL)
+    psInfo = (msWFSLayerInfo *)layer->wfslayerinfo;
   else {
     msSetError(MS_WFSERR, "Layer is not opened.", "msWFSLayerGetItems()");
     return MS_FAILURE;
   }
 
-  if(psInfo->bLayerHasValidGML)
+  if (psInfo->bLayerHasValidGML)
     return msOGRLayerGetItems(layer);
   else {
     /* Layer is successful, but there is no data to process */
@@ -1015,9 +1014,8 @@ int msWFSLayerGetItems(layerObj *layer)
    * ------------------------------------------------------------------ */
   msSetError(MS_WFSCONNERR, "WFS CLIENT CONNECTION support is not available.",
              "msWFSLayerGetItems()");
-  return(MS_FAILURE);
+  return (MS_FAILURE);
 #endif /* USE_WFS_LYR */
-
 }
 
 /**********************************************************************
@@ -1025,38 +1023,37 @@ int msWFSLayerGetItems(layerObj *layer)
  *
  **********************************************************************/
 
-int msWFSLayerWhichShapes(layerObj *lp, rectObj rect, int isQuery)
-{
+int msWFSLayerWhichShapes(layerObj *lp, rectObj rect, int isQuery) {
 #ifdef USE_WFS_LYR
   msWFSLayerInfo *psInfo;
   int status = MS_SUCCESS;
   const char *pszTmp;
   FILE *fp;
 
-  if ( msCheckParentPointer(lp->map,"map")==MS_FAILURE )
+  if (msCheckParentPointer(lp->map, "map") == MS_FAILURE)
     return MS_FAILURE;
 
-
-  psInfo =(msWFSLayerInfo*)lp->wfslayerinfo;
+  psInfo = (msWFSLayerInfo *)lp->wfslayerinfo;
 
   if (psInfo == NULL) {
     msSetError(MS_WFSCONNERR, "Assertion failed: WFS layer not opened!!!",
                "msWFSLayerWhichShapes()");
-    return(MS_FAILURE);
+    return (MS_FAILURE);
   }
 
   /* ------------------------------------------------------------------
    * Check if layer overlaps current view window (using wfs_latlonboundingbox)
    * ------------------------------------------------------------------ */
-  if ((pszTmp = msOWSLookupMetadata(&(lp->metadata),
-                                    "FO", "latlonboundingbox")) != NULL) {
+  if ((pszTmp = msOWSLookupMetadata(&(lp->metadata), "FO",
+                                    "latlonboundingbox")) != NULL) {
     char **tokens;
     int n;
     rectObj ext;
 
     tokens = msStringSplit(pszTmp, ' ', &n);
-    if (tokens==NULL || n != 4) {
-      msSetError(MS_WFSCONNERR, "Wrong number of values in 'wfs_latlonboundingbox' metadata.",
+    if (tokens == NULL || n != 4) {
+      msSetError(MS_WFSCONNERR,
+                 "Wrong number of values in 'wfs_latlonboundingbox' metadata.",
                  "msWFSLayerWhichShapes()");
       return MS_FAILURE;
     }
@@ -1075,18 +1072,16 @@ int msWFSLayerWhichShapes(layerObj *lp,
     if (!msRectOverlap(&rect, &ext)) {
       /* No overlap... nothing to do. If layer was never opened, go open it.*/
       if (lp->layerinfo)
-        return MS_DONE;  /* No overlap. */
+        return MS_DONE; /* No overlap. */
     }
   }
 
-
   /* ------------------------------------------------------------------
    * __TODO__ If new bbox differs from current one then we should
    * invalidate current GML file in cache
    * ------------------------------------------------------------------ */
   psInfo->rect = rect;
 
-
   /* ------------------------------------------------------------------
    * If file not downloaded yet then do it now.
    * ------------------------------------------------------------------ */
@@ -1096,10 +1091,10 @@ int msWFSLayerWhichShapes(layerObj *lp,
 
     msHTTPInitRequestObj(asReqInfo, 2);
 
-    if ( msPrepareWFSLayerRequest(-1, lp->map, lp,
-                                  asReqInfo, &numReq) == MS_FAILURE  ||
-         msOWSExecuteRequests(asReqInfo, numReq,
-                              lp->map, MS_TRUE) == MS_FAILURE ) {
+    if (msPrepareWFSLayerRequest(-1, lp->map, lp, asReqInfo, &numReq) ==
+            MS_FAILURE ||
+        msOWSExecuteRequests(asReqInfo, numReq, lp->map, MS_TRUE) ==
+            MS_FAILURE) {
       /* Delete tmp file... we don't want it to stick around. */
       unlink(asReqInfo[0].pszOutputFile);
       return MS_FAILURE;
@@ -1107,18 +1102,16 @@ int msWFSLayerWhichShapes(layerObj *lp,
 
     /* Cleanup */
     msHTTPFreeRequestObj(asReqInfo, numReq);
-
   }
 
-  if ( !MS_HTTP_SUCCESS( psInfo->nStatus ) ) {
+  if (!MS_HTTP_SUCCESS(psInfo->nStatus)) {
     /* Delete tmp file... we don't want it to stick around. */
     unlink(psInfo->pszGMLFilename);
 
-    msSetError(MS_WFSCONNERR,
-               "Got HTTP status %d downloading WFS layer %s",
-               "msWFSLayerWhichShapes()",
-               psInfo->nStatus, lp->name?lp->name:"(null)");
-    return(MS_FAILURE);
+    msSetError(MS_WFSCONNERR, "Got HTTP status %d downloading WFS layer %s",
+               "msWFSLayerWhichShapes()", psInfo->nStatus,
+               lp->name ? lp->name : "(null)");
+    return (MS_FAILURE);
   }
 
   /* ------------------------------------------------------------------
@@ -1126,46 +1119,41 @@ int msWFSLayerWhichShapes(layerObj *lp,
    * ------------------------------------------------------------------ */
   if ((fp = fopen(psInfo->pszGMLFilename, "r")) != NULL) {
     char szHeader[2000];
-    int  nBytes = 0;
+    int nBytes = 0;
 
-    nBytes = fread( szHeader, 1, sizeof(szHeader)-1, fp );
+    nBytes = fread(szHeader, 1, sizeof(szHeader) - 1, fp);
     fclose(fp);
 
     if (nBytes < 0)
       nBytes = 0;
     szHeader[nBytes] = '\0';
 
-    if ( nBytes == 0 ) {
-      msSetError(MS_WFSCONNERR,
-                 "WFS request produced no oputput for layer %s.",
-                 "msWFSLayerWhichShapes()",
-                 lp->name?lp->name:"(null)");
-      return(MS_FAILURE);
-
+    if (nBytes == 0) {
+      msSetError(MS_WFSCONNERR, "WFS request produced no oputput for layer %s.",
+                 "msWFSLayerWhichShapes()", lp->name ? lp->name : "(null)");
+      return (MS_FAILURE);
     }
-    if ( strstr(szHeader, "<WFS_Exception>") ||
-         strstr(szHeader, "<ServiceExceptionReport>") ) {
-      msOWSProcessException(lp, psInfo->pszGMLFilename,
-                            MS_WFSCONNERR, "msWFSLayerWhichShapes()" );
+    if (strstr(szHeader, "<WFS_Exception>") ||
+        strstr(szHeader, "<ServiceExceptionReport>")) {
+      msOWSProcessException(lp, psInfo->pszGMLFilename, MS_WFSCONNERR,
+                            "msWFSLayerWhichShapes()");
       return MS_FAILURE;
-    } else if ( strstr(szHeader,"opengis.net/gml") &&
-                strstr(szHeader,"featureMember>") == NULL ) {
+    } else if (strstr(szHeader, "opengis.net/gml") &&
+               strstr(szHeader, "featureMember>") == NULL) {
       /* This looks like valid GML, but contains 0 features. */
       return MS_DONE;
-    } else if ( strstr(szHeader,"opengis.net/gml") == NULL ||
-                strstr(szHeader,"featureMember>") == NULL ) {
+    } else if (strstr(szHeader, "opengis.net/gml") == NULL ||
+               strstr(szHeader, "featureMember>") == NULL) {
       /* This is probably just junk. */
       msSetError(MS_WFSCONNERR,
                  "WFS request produced unexpected output (junk?) for layer %s.",
-                 "msWFSLayerWhichShapes()",
-                 lp->name?lp->name:"(null)");
-      return(MS_FAILURE);
+                 "msWFSLayerWhichShapes()", lp->name ? lp->name : "(null)");
+      return (MS_FAILURE);
     }
 
     /* If we got this far, it must be a valid GML dataset... keep going */
   }
 
-
   /* ------------------------------------------------------------------
    * Open GML file using OGR.
    * ------------------------------------------------------------------ */
@@ -1184,20 +1172,17 @@ int msWFSLayerWhichShapes(layerObj *lp,
    * ------------------------------------------------------------------ */
   msSetError(MS_WFSCONNERR, "WFS CLIENT CONNECTION support is not available.",
              "msWFSLayerWhichShapes()");
-  return(MS_FAILURE);
+  return (MS_FAILURE);
 
 #endif /* USE_WFS_LYR */
 }
 
-
-
 /**********************************************************************
  *                          msWFSLayerClose()
  *
  **********************************************************************/
 
-int msWFSLayerClose(layerObj *lp)
-{
+int msWFSLayerClose(layerObj *lp) {
 #ifdef USE_WFS_LYR
 
   /* ------------------------------------------------------------------
@@ -1224,18 +1209,16 @@ int msWFSLayerClose(layerObj *lp)
    * ------------------------------------------------------------------ */
   msSetError(MS_WFSCONNERR, "WFS CLIENT CONNECTION support is not available.",
              "msWFSLayerClose()");
-  return(MS_FAILURE);
+  return (MS_FAILURE);
 
 #endif /* USE_WFS_LYR */
-
 }
 
 /**********************************************************************
  *                          msWFSExecuteGetFeature()
  * Returns the temporary gml file name. User shpuld free the return string.
  **********************************************************************/
-char *msWFSExecuteGetFeature(layerObj *lp)
-{
+char *msWFSExecuteGetFeature(layerObj *lp) {
 #ifdef USE_WFS_LYR
   char *gmltmpfile = NULL;
   msWFSLayerInfo *psInfo = NULL;
@@ -1244,8 +1227,8 @@ char *msWFSExecuteGetFeature(layerObj *l
     return NULL;
 
   msWFSLayerOpen(lp, NULL, NULL);
-  psInfo =(msWFSLayerInfo*)lp->wfslayerinfo;
-  if (psInfo &&  psInfo->pszGMLFilename)
+  psInfo = (msWFSLayerInfo *)lp->wfslayerinfo;
+  if (psInfo && psInfo->pszGMLFilename)
     gmltmpfile = msStrdup(psInfo->pszGMLFilename);
   msWFSLayerClose(lp);
 
@@ -1260,12 +1243,9 @@ char *msWFSExecuteGetFeature(layerObj *l
   return NULL;
 
 #endif /* USE_WFS_LYR */
-
 }
 
-int
-msWFSLayerInitializeVirtualTable(layerObj *layer)
-{
+int msWFSLayerInitializeVirtualTable(layerObj *layer) {
   assert(layer != NULL);
   assert(layer->vtable != NULL);
 
diff -pruN 8.0.1-5/mapwms.cpp 8.0.2-1/mapwms.cpp
--- 8.0.1-5/mapwms.cpp	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapwms.cpp	2024-06-11 20:41:34.000000000 +0000
@@ -68,10 +68,8 @@
 ** Report current MapServer error in requested format.
 */
 
-static
-int msWMSException(mapObj *map, int nVersion, const char *exception_code,
-                   const char *wms_exception_format)
-{
+static int msWMSException(mapObj *map, int nVersion, const char *exception_code,
+                          const char *wms_exception_format) {
   char *schemalocation = NULL;
 
   /* Default to WMS 1.3.0 exceptions if version not set yet */
@@ -79,23 +77,24 @@ int msWMSException(mapObj *map, int nVer
     nVersion = OWS_1_3_0;
 
   /* get scheam location */
-  schemalocation = msEncodeHTMLEntities( msOWSGetSchemasLocation(map) );
+  schemalocation = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
 
   /* Establish default exception format depending on VERSION */
   if (wms_exception_format == NULL) {
     if (nVersion <= OWS_1_0_0)
-      wms_exception_format = "INIMAGE";  /* WMS 1.0.0 */
+      wms_exception_format = "INIMAGE"; /* WMS 1.0.0 */
     else if (nVersion <= OWS_1_0_7)
-      wms_exception_format = "SE_XML";   /* WMS 1.0.1 to 1.0.7 */
+      wms_exception_format = "SE_XML"; /* WMS 1.0.1 to 1.0.7 */
     else if (nVersion <= OWS_1_1_1)
-      wms_exception_format = "application/vnd.ogc.se_xml"; /* WMS 1.1.0 and later */
+      wms_exception_format =
+          "application/vnd.ogc.se_xml"; /* WMS 1.1.0 and later */
     else
       wms_exception_format = "text/xml";
   }
 
   if (strcasecmp(wms_exception_format, "INIMAGE") == 0 ||
       strcasecmp(wms_exception_format, "BLANK") == 0 ||
-      strcasecmp(wms_exception_format, "application/vnd.ogc.se_inimage")== 0 ||
+      strcasecmp(wms_exception_format, "application/vnd.ogc.se_inimage") == 0 ||
       strcasecmp(wms_exception_format, "application/vnd.ogc.se_blank") == 0) {
     int blank = 0;
 
@@ -106,57 +105,74 @@ int msWMSException(mapObj *map, int nVer
 
     msWriteErrorImage(map, NULL, blank);
 
-  } else if (strcasecmp(wms_exception_format, "WMS_XML") == 0) { /* Only in V1.0.0 */
-    msIO_setHeader("Content-Type","text/xml; charset=UTF-8");
+  } else if (strcasecmp(wms_exception_format, "WMS_XML") ==
+             0) { /* Only in V1.0.0 */
+    msIO_setHeader("Content-Type", "text/xml; charset=UTF-8");
     msIO_sendHeaders();
 
     msIO_printf("<WMTException version=\"1.0.0\">\n");
     msWriteErrorXML(stdout);
     msIO_printf("</WMTException>\n");
   } else /* XML error, the default: SE_XML (1.0.1 to 1.0.7) */
-    /* or application/vnd.ogc.se_xml (1.1.0 and later) */
+  /* or application/vnd.ogc.se_xml (1.1.0 and later) */
   {
     if (nVersion <= OWS_1_0_7) {
       /* In V1.0.1 to 1.0.7, the MIME type was text/xml */
-      msIO_setHeader("Content-Type","text/xml; charset=UTF-8");
+      msIO_setHeader("Content-Type", "text/xml; charset=UTF-8");
       msIO_sendHeaders();
 
-      msIO_printf("<?xml version='1.0' encoding=\"UTF-8\" standalone=\"no\" ?>\n");
-      msIO_printf("<!DOCTYPE ServiceExceptionReport SYSTEM \"http://www.digitalearth.gov/wmt/xml/exception_1_0_1.dtd\">\n");
+      msIO_printf(
+          "<?xml version='1.0' encoding=\"UTF-8\" standalone=\"no\" ?>\n");
+      msIO_printf(
+          "<!DOCTYPE ServiceExceptionReport SYSTEM "
+          "\"http://www.digitalearth.gov/wmt/xml/exception_1_0_1.dtd\">\n");
 
       msIO_printf("<ServiceExceptionReport version=\"1.0.1\">\n");
     } else if (nVersion <= OWS_1_1_0) {
       /* In V1.1.0 and later, we have OGC-specific MIME types */
       /* we cannot return anything else than application/vnd.ogc.se_xml here. */
-      msIO_setHeader("Content-Type","application/vnd.ogc.se_xml; charset=UTF-8");
+      msIO_setHeader("Content-Type",
+                     "application/vnd.ogc.se_xml; charset=UTF-8");
       msIO_sendHeaders();
 
-      msIO_printf("<?xml version='1.0' encoding=\"UTF-8\" standalone=\"no\" ?>\n");
+      msIO_printf(
+          "<?xml version='1.0' encoding=\"UTF-8\" standalone=\"no\" ?>\n");
 
-      msIO_printf("<!DOCTYPE ServiceExceptionReport SYSTEM \"%s/wms/1.1.0/exception_1_1_0.dtd\">\n",schemalocation);
+      msIO_printf("<!DOCTYPE ServiceExceptionReport SYSTEM "
+                  "\"%s/wms/1.1.0/exception_1_1_0.dtd\">\n",
+                  schemalocation);
 
       msIO_printf("<ServiceExceptionReport version=\"1.1.0\">\n");
     } else if (nVersion <= OWS_1_1_1) { /* 1.1.1 */
-      msIO_setHeader("Content-Type","application/vnd.ogc.se_xml; charset=UTF-8");
+      msIO_setHeader("Content-Type",
+                     "application/vnd.ogc.se_xml; charset=UTF-8");
       msIO_sendHeaders();
 
-      msIO_printf("<?xml version='1.0' encoding=\"UTF-8\" standalone=\"no\" ?>\n");
-      msIO_printf("<!DOCTYPE ServiceExceptionReport SYSTEM \"%s/wms/1.1.1/exception_1_1_1.dtd\">\n", schemalocation);
+      msIO_printf(
+          "<?xml version='1.0' encoding=\"UTF-8\" standalone=\"no\" ?>\n");
+      msIO_printf("<!DOCTYPE ServiceExceptionReport SYSTEM "
+                  "\"%s/wms/1.1.1/exception_1_1_1.dtd\">\n",
+                  schemalocation);
       msIO_printf("<ServiceExceptionReport version=\"1.1.1\">\n");
     } else { /*1.3.0*/
       if (strcasecmp(wms_exception_format, "application/vnd.ogc.se_xml") == 0) {
-        msIO_setHeader("Content-Type","application/vnd.ogc.se_xml; charset=UTF-8");
+        msIO_setHeader("Content-Type",
+                       "application/vnd.ogc.se_xml; charset=UTF-8");
       } else {
-        msIO_setHeader("Content-Type","text/xml; charset=UTF-8");
+        msIO_setHeader("Content-Type", "text/xml; charset=UTF-8");
       }
       msIO_sendHeaders();
 
-      msIO_printf("<?xml version='1.0' encoding=\"UTF-8\" standalone=\"no\" ?>\n");
-      msIO_printf("<ServiceExceptionReport version=\"1.3.0\" xmlns=\"http://www.opengis.net/ogc\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://www.opengis.net/ogc %s/wms/1.3.0/exceptions_1_3_0.xsd\">\n",
+      msIO_printf(
+          "<?xml version='1.0' encoding=\"UTF-8\" standalone=\"no\" ?>\n");
+      msIO_printf("<ServiceExceptionReport version=\"1.3.0\" "
+                  "xmlns=\"http://www.opengis.net/ogc\" "
+                  "xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" "
+                  "xsi:schemaLocation=\"http://www.opengis.net/ogc "
+                  "%s/wms/1.3.0/exceptions_1_3_0.xsd\">\n",
                   schemalocation);
     }
 
-
     if (exception_code)
       msIO_printf("<ServiceException code=\"%s\">\n", exception_code);
     else
@@ -164,15 +180,15 @@ int msWMSException(mapObj *map, int nVer
     msWriteErrorXML(stdout);
     msIO_printf("</ServiceException>\n");
     msIO_printf("</ServiceExceptionReport>\n");
-
   }
   free(schemalocation);
 
-  return MS_FAILURE; /* so that we can call 'return msWMSException();' anywhere */
+  return MS_FAILURE; /* so that we can call 'return msWMSException();' anywhere
+                      */
 }
 
-static bool msWMSSetTimePattern(const char *timepatternstring, const char *timestring, bool checkonly)
-{
+static bool msWMSSetTimePattern(const char *timepatternstring,
+                                const char *timestring, bool checkonly) {
   if (timepatternstring && timestring) {
     /* parse the time parameter to extract a distinct time. */
     /* time value can be dicrete times (eg 2004-09-21), */
@@ -183,26 +199,31 @@ static bool msWMSSetTimePattern(const ch
     /* get the pattern to use */
     if (!atimes.empty()) {
       auto patterns = msStringSplit(timepatternstring, ',');
-      for (auto& pattern: patterns) {
+      for (auto &pattern : patterns) {
         msStringTrimBlanks(pattern);
         msStringTrimLeft(pattern);
       }
 
-      for (const auto& atime: atimes) {
+      for (const auto &atime : atimes) {
         const auto ranges = msStringSplit(atime.c_str(), '/');
-        for( const auto& range: ranges) {
+        for (const auto &range : ranges) {
           bool match = false;
-          for (const auto& pattern: patterns) {
+          for (const auto &pattern : patterns) {
             if (!pattern.empty()) {
-              if (msTimeMatchPattern(range.c_str(), pattern.c_str()) == MS_TRUE) {
-                if (!checkonly) msSetLimitedPatternsToUse(pattern.c_str());
+              if (msTimeMatchPattern(range.c_str(), pattern.c_str()) ==
+                  MS_TRUE) {
+                if (!checkonly)
+                  msSetLimitedPatternsToUse(pattern.c_str());
                 match = true;
                 break;
               }
             }
           }
           if (!match) {
-            msSetError(MS_WMSERR, "Time value %s given does not match the time format pattern.", "msWMSSetTimePattern", range.c_str());
+            msSetError(
+                MS_WMSERR,
+                "Time value %s given does not match the time format pattern.",
+                "msWMSSetTimePattern", range.c_str());
             return false;
           }
         }
@@ -216,65 +237,89 @@ static bool msWMSSetTimePattern(const ch
 /*
 ** Apply the TIME parameter to layers that are time aware
 */
-static
-int msWMSApplyTime(mapObj *map, int version, const char *time, const char *wms_exception_format)
-{
+static int msWMSApplyTime(mapObj *map, int version, const char *time,
+                          const char *wms_exception_format) {
   if (map) {
 
-    const char* timepattern = msOWSLookupMetadata(&(map->web.metadata), "MO", "timeformat");
+    const char *timepattern =
+        msOWSLookupMetadata(&(map->web.metadata), "MO", "timeformat");
 
-    for (int i=0; i<map->numlayers; i++) {
-      layerObj* lp = (GET_LAYER(map, i));
+    for (int i = 0; i < map->numlayers; i++) {
+      layerObj *lp = (GET_LAYER(map, i));
       if (lp->status != MS_ON && lp->status != MS_DEFAULT)
         continue;
 
       /* check if the layer is time aware */
-      const char* timeextent = msOWSLookupMetadata(&(lp->metadata), "MO", "timeextent");
-      const char* timefield =  msOWSLookupMetadata(&(lp->metadata), "MO", "timeitem");
-      const char* timedefault =  msOWSLookupMetadata(&(lp->metadata), "MO", "timedefault");
+      const char *timeextent =
+          msOWSLookupMetadata(&(lp->metadata), "MO", "timeextent");
+      const char *timefield =
+          msOWSLookupMetadata(&(lp->metadata), "MO", "timeitem");
+      const char *timedefault =
+          msOWSLookupMetadata(&(lp->metadata), "MO", "timedefault");
 
       if (timeextent && timefield) {
         /* check to see if the time value is given. If not */
         /* use default time. If default time is not available */
         /* send an exception */
-        if (time == NULL || strlen(time) <=0) {
+        if (time == NULL || strlen(time) <= 0) {
           if (timedefault == NULL) {
-            msSetError(MS_WMSERR, "No Time value was given, and no default time value defined.", "msWMSApplyTime");
-            return msWMSException(map, version, "MissingDimensionValue", wms_exception_format);
+            msSetError(
+                MS_WMSERR,
+                "No Time value was given, and no default time value defined.",
+                "msWMSApplyTime");
+            return msWMSException(map, version, "MissingDimensionValue",
+                                  wms_exception_format);
           } else {
-            if (msValidateTimeValue((char *)timedefault, timeextent) == MS_FALSE) {
-              msSetError(MS_WMSERR, "No Time value was given, and the default time value %s is invalid or outside the time extent defined %s", "msWMSApplyTime", timedefault, timeextent);
+            if (msValidateTimeValue((char *)timedefault, timeextent) ==
+                MS_FALSE) {
+              msSetError(MS_WMSERR,
+                         "No Time value was given, and the default time value "
+                         "%s is invalid or outside the time extent defined %s",
+                         "msWMSApplyTime", timedefault, timeextent);
               /* return MS_FALSE; */
-              return msWMSException(map, version, "InvalidDimensionValue", wms_exception_format);
+              return msWMSException(map, version, "InvalidDimensionValue",
+                                    wms_exception_format);
             }
             msLayerSetTimeFilter(lp, timedefault, timefield);
           }
         } else {
-          /* 
-	        ** Check to see if there is a list of possible patterns defined. If it is the case, use 
+          /*
+          ** Check to see if there is a list of possible patterns defined. If it
+          *is the case, use
           ** it to set the time pattern to use for the request.
           **
-          ** Last argument is set to TRUE (checkonly) to not trigger the patterns info setting, rather 
-          ** to only apply the wms_timeformats on the user request values, not the mapfile values. 
+          ** Last argument is set to TRUE (checkonly) to not trigger the
+          *patterns info setting, rather
+          ** to only apply the wms_timeformats on the user request values, not
+          *the mapfile values.
           */
           if (timepattern && time && strlen(time) > 0) {
-            if (!msWMSSetTimePattern(timepattern, time, true)) 
-              return msWMSException(map, version,"InvalidDimensionValue", wms_exception_format);
+            if (!msWMSSetTimePattern(timepattern, time, true))
+              return msWMSException(map, version, "InvalidDimensionValue",
+                                    wms_exception_format);
           }
-          
+
           /* check if given time is in the range */
           if (msValidateTimeValue(time, timeextent) == MS_FALSE) {
             if (timedefault == NULL) {
-              msSetError(MS_WMSERR, "Time value(s) %s given is invalid or outside the time extent defined (%s).", "msWMSApplyTime", time, timeextent);
+              msSetError(MS_WMSERR,
+                         "Time value(s) %s given is invalid or outside the "
+                         "time extent defined (%s).",
+                         "msWMSApplyTime", time, timeextent);
               /* return MS_FALSE; */
-              return msWMSException(map, version,
-                                    "InvalidDimensionValue", wms_exception_format);
+              return msWMSException(map, version, "InvalidDimensionValue",
+                                    wms_exception_format);
             } else {
-              if (msValidateTimeValue((char *)timedefault, timeextent) == MS_FALSE) {
-                msSetError(MS_WMSERR, "Time value(s) %s given is invalid or outside the time extent defined (%s), and default time set is invalid (%s)", "msWMSApplyTime", time, timeextent, timedefault);
+              if (msValidateTimeValue((char *)timedefault, timeextent) ==
+                  MS_FALSE) {
+                msSetError(
+                    MS_WMSERR,
+                    "Time value(s) %s given is invalid or outside the time "
+                    "extent defined (%s), and default time set is invalid (%s)",
+                    "msWMSApplyTime", time, timeextent, timedefault);
                 /* return MS_FALSE; */
-                return msWMSException(map, version,
-                                      "InvalidDimensionValue",  wms_exception_format);
+                return msWMSException(map, version, "InvalidDimensionValue",
+                                      wms_exception_format);
               } else
                 msLayerSetTimeFilter(lp, timedefault, timefield);
             }
@@ -282,7 +327,7 @@ int msWMSApplyTime(mapObj *map, int vers
           } else {
             /* build the time string */
             msLayerSetTimeFilter(lp, time, timefield);
-            timeextent= NULL;
+            timeextent = NULL;
           }
         }
       }
@@ -292,8 +337,9 @@ int msWMSApplyTime(mapObj *map, int vers
        info. some drivers use it */
     if (timepattern && time && strlen(time) > 0) {
       if (!msWMSSetTimePattern(timepattern, time, false))
-        return msWMSException(map, version, "InvalidDimensionValue", wms_exception_format);
-    }    
+        return msWMSException(map, version, "InvalidDimensionValue",
+                              wms_exception_format);
+    }
   }
 
   return MS_SUCCESS;
@@ -302,16 +348,16 @@ int msWMSApplyTime(mapObj *map, int vers
 /*
 ** Apply the FILTER parameter to layers (RFC118)
 */
-static
-int msWMSApplyFilter(mapObj *map, int version, const char *filter,
-		     int def_srs_needs_axis_swap, const char *wms_exception_format, owsRequestObj *ows_request)
-{
+static int msWMSApplyFilter(mapObj *map, int version, const char *filter,
+                            int def_srs_needs_axis_swap,
+                            const char *wms_exception_format,
+                            owsRequestObj *ows_request) {
   // Empty filter should be ignored
   if (!filter || strlen(filter) == 0)
     return MS_SUCCESS;
 
   if (!map)
-    return MS_FAILURE;  
+    return MS_FAILURE;
 
   /* Count number of requested layers / groups / etc.
    * Only layers with STATUS ON were in the LAYERS request param.
@@ -319,16 +365,16 @@ int msWMSApplyFilter(mapObj *map, int ve
    * not expected to have a corresponding filter in the request
    */
   int numlayers = 0;
-  for(int i=0; i<map->numlayers; i++) {
-    layerObj *lp=NULL;
+  for (int i = 0; i < map->numlayers; i++) {
+    layerObj *lp = NULL;
 
-    if(map->layerorder[i] != -1) {
-      lp = (GET_LAYER(map,  map->layerorder[i]));
+    if (map->layerorder[i] != -1) {
+      lp = (GET_LAYER(map, map->layerorder[i]));
       if (lp->status == MS_ON)
         numlayers++;
     }
   }
-   
+
   /* -------------------------------------------------------------------- */
   /*      Parse the Filter parameter. If there are several Filter         */
   /*      parameters, each Filter is inside parentheses.                  */
@@ -339,24 +385,27 @@ int msWMSApplyFilter(mapObj *map, int ve
     paszFilters = FLTSplitFilters(filter, &numfilters);
 
   } else if (numlayers == 1) {
-    numfilters=1;
-    paszFilters = (char **)msSmallMalloc(sizeof(char *)*numfilters);
+    numfilters = 1;
+    paszFilters = (char **)msSmallMalloc(sizeof(char *) * numfilters);
     paszFilters[0] = msStrdup(filter);
   }
 
   if (numfilters != ows_request->numwmslayerargs) {
-    msSetError(MS_WMSERR, "Wrong number of filter elements, one filter must be specified for each requested layer or groups.",
-	       "msWMSApplyFilter" );
+    msSetError(MS_WMSERR,
+               "Wrong number of filter elements, one filter must be specified "
+               "for each requested layer or groups.",
+               "msWMSApplyFilter");
     msFreeCharArray(paszFilters, numfilters);
-    return msWMSException(map, version, "InvalidParameterValue", wms_exception_format);
+    return msWMSException(map, version, "InvalidParameterValue",
+                          wms_exception_format);
   }
 
   /* We're good to go. Apply each filter to the corresponding layer */
-  for(int i=0; i<map->numlayers; i++) {
-    layerObj *lp=NULL;
+  for (int i = 0; i < map->numlayers; i++) {
+    layerObj *lp = NULL;
 
-    if(map->layerorder[i] != -1)
-      lp = (GET_LAYER(map,  map->layerorder[i]));
+    if (map->layerorder[i] != -1)
+      lp = (GET_LAYER(map, map->layerorder[i]));
 
     /* Only layers with STATUS ON were in the LAYERS request param.*/
     if (lp == NULL || lp->status != MS_ON)
@@ -370,19 +419,19 @@ int msWMSApplyFilter(mapObj *map, int ve
     if (paszFilters[curfilter][0] == '\0') {
       continue;
     }
-    
+
     /* Force setting a template to enable query. */
     if (lp->_template == NULL)
       lp->_template = msStrdup("ttt.html");
 
     /* Parse filter */
-    FilterEncodingNode* psNode = FLTParseFilterEncoding(paszFilters[curfilter]);
+    FilterEncodingNode *psNode = FLTParseFilterEncoding(paszFilters[curfilter]);
     if (!psNode) {
-      msSetError(MS_WMSERR,
-		 "Invalid or Unsupported FILTER : %s",
-		 "msWMSApplyFilter()", paszFilters[curfilter]);
+      msSetError(MS_WMSERR, "Invalid or Unsupported FILTER : %s",
+                 "msWMSApplyFilter()", paszFilters[curfilter]);
       msFreeCharArray(paszFilters, numfilters);
-      return msWMSException(map, version, "InvalidParameterValue", wms_exception_format);
+      return msWMSException(map, version, "InvalidParameterValue",
+                            wms_exception_format);
     }
 
     /* For WMS 1.3 and up, we may need to swap the axis of bbox and geometry
@@ -398,63 +447,62 @@ int msWMSApplyFilter(mapObj *map, int ve
     FLTPreParseFilterForAliasAndGroup(psNode, map, lp->index, "G");
 
     /* Check that FeatureId filters are consistent with the active layer */
-    if( FLTCheckFeatureIdFilters(psNode, map, lp->index) == MS_FAILURE)
-      {
-        FLTFreeFilterEncodingNode( psNode );
-        return msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE, paramsObj->pszVersion);
-      }
+    if (FLTCheckFeatureIdFilters(psNode, map, lp->index) == MS_FAILURE) {
+      FLTFreeFilterEncodingNode(psNode);
+      return msWFSException(map, "mapserv", MS_OWS_ERROR_NO_APPLICABLE_CODE,
+                            paramsObj->pszVersion);
+    }
 
     /* FIXME?: could probably apply to WFS 1.1 too */
-    if( nWFSVersion >= OWS_2_0_0 )
-      {
-	int nEvaluation;
+    if (nWFSVersion >= OWS_2_0_0) {
+      int nEvaluation;
 
-        if( FLTCheckInvalidOperand(psNode) == MS_FAILURE)
-        {
-            FLTFreeFilterEncodingNode( psNode );
-            msFreeCharArray(paszFilters, numfilters);
-            return msWFSException(map, "filter", MS_WFS_ERROR_OPERATION_PROCESSING_FAILED, paramsObj->pszVersion);
-        }
-
-        if( FLTCheckInvalidProperty(psNode, map, lp->index) == MS_FAILURE)
-        {
-            FLTFreeFilterEncodingNode( psNode );
-            msFreeCharArray(paszFilters, numfilters);
-            return msWFSException(map, "filter", MS_OWS_ERROR_INVALID_PARAMETER_VALUE, paramsObj->pszVersion);
-        }
-
-        psNode = FLTSimplify(psNode, &nEvaluation);
-        if( psNode == NULL )
-        {
-            FLTFreeFilterEncodingNode( psNode );
-            msFreeCharArray(paszFilters, numfilters);
-            if( nEvaluation == 1 ) {
-                /* return full layer */
-                return msWFSRunBasicGetFeature(map, lp, paramsObj, nWFSVersion);
-            }
-            else {
-                /* return empty result set */
-                return MS_SUCCESS;
-            }
-        }
+      if (FLTCheckInvalidOperand(psNode) == MS_FAILURE) {
+        FLTFreeFilterEncodingNode(psNode);
+        msFreeCharArray(paszFilters, numfilters);
+        return msWFSException(map, "filter",
+                              MS_WFS_ERROR_OPERATION_PROCESSING_FAILED,
+                              paramsObj->pszVersion);
+      }
 
+      if (FLTCheckInvalidProperty(psNode, map, lp->index) == MS_FAILURE) {
+        FLTFreeFilterEncodingNode(psNode);
+        msFreeCharArray(paszFilters, numfilters);
+        return msWFSException(map, "filter",
+                              MS_OWS_ERROR_INVALID_PARAMETER_VALUE,
+                              paramsObj->pszVersion);
       }
-    
+
+      psNode = FLTSimplify(psNode, &nEvaluation);
+      if (psNode == NULL) {
+        FLTFreeFilterEncodingNode(psNode);
+        msFreeCharArray(paszFilters, numfilters);
+        if (nEvaluation == 1) {
+          /* return full layer */
+          return msWFSRunBasicGetFeature(map, lp, paramsObj, nWFSVersion);
+        } else {
+          /* return empty result set */
+          return MS_SUCCESS;
+        }
+      }
+    }
+
 #endif
 
     /* Apply filter to this layer */
 
-    /* But first, start by removing any wfs_use_default_extent_for_getfeature metadata item */
+    /* But first, start by removing any wfs_use_default_extent_for_getfeature
+     * metadata item */
     /* that could result in the BBOX to be removed */
     std::string old_value_wfs_use_default_extent_for_getfeature;
     {
-        const char* old_value_tmp = msLookupHashTable(
-            &(lp->metadata), "wfs_use_default_extent_for_getfeature");
-        if( old_value_tmp )
-        {
-            old_value_wfs_use_default_extent_for_getfeature = old_value_tmp;
-            msRemoveHashTable(&(lp->metadata), "wfs_use_default_extent_for_getfeature");
-        }
+      const char *old_value_tmp = msLookupHashTable(
+          &(lp->metadata), "wfs_use_default_extent_for_getfeature");
+      if (old_value_tmp) {
+        old_value_wfs_use_default_extent_for_getfeature = old_value_tmp;
+        msRemoveHashTable(&(lp->metadata),
+                          "wfs_use_default_extent_for_getfeature");
+      }
     }
 
     msInsertHashTable(&(lp->metadata), "gml_wmsfilter_flag", "true");
@@ -463,30 +511,32 @@ int msWMSApplyFilter(mapObj *map, int ve
 
     msRemoveHashTable(&(lp->metadata), "gml_wmsfilter_flag");
 
-    if( !old_value_wfs_use_default_extent_for_getfeature.empty() )
-    {
-        msInsertHashTable(&(lp->metadata), "wfs_use_default_extent_for_getfeature",
-                          old_value_wfs_use_default_extent_for_getfeature.c_str());
+    if (!old_value_wfs_use_default_extent_for_getfeature.empty()) {
+      msInsertHashTable(
+          &(lp->metadata), "wfs_use_default_extent_for_getfeature",
+          old_value_wfs_use_default_extent_for_getfeature.c_str());
     }
 
-    if( ret != MS_SUCCESS ) {
-      errorObj* ms_error = msGetErrorObj();
-
-      if(ms_error->code != MS_NOTFOUND) {
-	msSetError(MS_WMSERR, "FLTApplyFilterToLayer() failed", "msWMSApplyFilter()");
-	FLTFreeFilterEncodingNode( psNode );
+    if (ret != MS_SUCCESS) {
+      errorObj *ms_error = msGetErrorObj();
+
+      if (ms_error->code != MS_NOTFOUND) {
+        msSetError(MS_WMSERR, "FLTApplyFilterToLayer() failed",
+                   "msWMSApplyFilter()");
+        FLTFreeFilterEncodingNode(psNode);
         msFreeCharArray(paszFilters, numfilters);
-	return msWMSException(map, version, "InvalidParameterValue", wms_exception_format);
+        return msWMSException(map, version, "InvalidParameterValue",
+                              wms_exception_format);
       }
     }
 
-    FLTFreeFilterEncodingNode( psNode );
+    FLTFreeFilterEncodingNode(psNode);
 
-  }/* for */
+  } /* for */
 
-    msFreeCharArray(paszFilters, numfilters);
+  msFreeCharArray(paszFilters, numfilters);
 
-    return MS_SUCCESS;
+  return MS_SUCCESS;
 }
 
 /*
@@ -502,58 +552,67 @@ int msWMSApplyFilter(mapObj *map, int ve
 ** - isUsedInNestedGroup: This array indicates if the layer is used as group
 **                        as set through the WMS_LAYER_GROUP metadata
 */
-static
-void msWMSPrepareNestedGroups(mapObj* map, int /* nVersion */, char*** nestedGroups, int* numNestedGroups, int* isUsedInNestedGroup)
-{
-  //Create set to hold unique groups
+static void msWMSPrepareNestedGroups(mapObj *map, int /* nVersion */,
+                                     char ***nestedGroups, int *numNestedGroups,
+                                     int *isUsedInNestedGroup) {
+  // Create set to hold unique groups
   std::set<std::string> uniqgroups;
 
   for (int i = 0; i < map->numlayers; i++) {
-    nestedGroups[i] = NULL; /* default */
-    numNestedGroups[i] = 0; /* default */
+    nestedGroups[i] = NULL;     /* default */
+    numNestedGroups[i] = 0;     /* default */
     isUsedInNestedGroup[i] = 0; /* default */
 
-    const char* groups = msOWSLookupMetadata(&(GET_LAYER(map, i)->metadata), "MO", "layer_group");
+    const char *groups = msOWSLookupMetadata(&(GET_LAYER(map, i)->metadata),
+                                             "MO", "layer_group");
     if ((groups != NULL) && (strlen(groups) != 0)) {
-      if (GET_LAYER(map, i)->group != NULL && strlen(GET_LAYER(map, i)->group) != 0) {
-        const char* errorMsg = "It is not allowed to set both the GROUP and WMS_LAYER_GROUP for a layer";
+      if (GET_LAYER(map, i)->group != NULL &&
+          strlen(GET_LAYER(map, i)->group) != 0) {
+        const char *errorMsg = "It is not allowed to set both the GROUP and "
+                               "WMS_LAYER_GROUP for a layer";
         msSetError(MS_WMSERR, errorMsg, "msWMSPrepareNestedGroups()", NULL);
         msIO_fprintf(stdout, "<!-- ERROR: %s -->\n", errorMsg);
-        /* cannot return exception at this point because we are already writing to stdout */
+        /* cannot return exception at this point because we are already writing
+         * to stdout */
       } else {
         if (groups[0] != '/') {
-          const char* errorMsg = "The WMS_LAYER_GROUP metadata does not start with a '/'";
+          const char *errorMsg =
+              "The WMS_LAYER_GROUP metadata does not start with a '/'";
           msSetError(MS_WMSERR, errorMsg, "msWMSPrepareNestedGroups()", NULL);
           msIO_fprintf(stdout, "<!-- ERROR: %s -->\n", errorMsg);
-          /* cannot return exception at this point because we are already writing to stdout */
+          /* cannot return exception at this point because we are already
+           * writing to stdout */
         } else {
-          /* split into subgroups. Start at address + 1 because the first '/' would cause an extra empty group */
+          /* split into subgroups. Start at address + 1 because the first '/'
+           * would cause an extra empty group */
           nestedGroups[i] = msStringSplit(groups + 1, '/', &numNestedGroups[i]);
-          /* Iterate through the groups and add them to the unique groups array */
-          for (int k=0; k<numNestedGroups[i]; k++) {
+          /* Iterate through the groups and add them to the unique groups array
+           */
+          for (int k = 0; k < numNestedGroups[i]; k++) {
             uniqgroups.insert(msStringToLower(std::string(nestedGroups[i][k])));
-         }
-       } 
-     }
-   }
- } 
- /* Iterate through layers to find out whether they are in any of the nested groups */
- for (int i = 0; i < map->numlayers; i++) {
-    if (GET_LAYER(map, i)->name) {
-        if( uniqgroups.find(msStringToLower(std::string(GET_LAYER(map, i)->name))) != uniqgroups.end() ) {
-            isUsedInNestedGroup[i] = 1;
+          }
         }
+      }
+    }
+  }
+  /* Iterate through layers to find out whether they are in any of the nested
+   * groups */
+  for (int i = 0; i < map->numlayers; i++) {
+    if (GET_LAYER(map, i)->name) {
+      if (uniqgroups.find(msStringToLower(
+              std::string(GET_LAYER(map, i)->name))) != uniqgroups.end()) {
+        isUsedInNestedGroup[i] = 1;
+      }
     }
   }
 }
 
-
 /*
 ** Validate that a given dimension is inside the extents defined
 */
-static
-bool msWMSValidateDimensionValue(const char *value, const char *dimensionextent, bool forcecharacter)
-{
+static bool msWMSValidateDimensionValue(const char *value,
+                                        const char *dimensionextent,
+                                        bool forcecharacter) {
   std::vector<pointObj> aextentranges;
 
   bool isextentavalue = false;
@@ -574,8 +633,9 @@ bool msWMSValidateDimensionValue(const c
   /* -------------------------------------------------------------------- */
   /*      parse the extent first.                                         */
   /* -------------------------------------------------------------------- */
-  auto extents = msStringSplit (dimensionextent, ',');
-  for( auto& extent: extents ) // Make sure to get by reference so that it is updated in place
+  auto extents = msStringSplit(dimensionextent, ',');
+  for (auto &extent :
+       extents) // Make sure to get by reference so that it is updated in place
     msStringTrim(extent);
 
   std::vector<std::string> aextentvalues;
@@ -585,11 +645,11 @@ bool msWMSValidateDimensionValue(const c
       isextentavalue = true;
       aextentvalues.push_back(dimensionextent);
       if (!forcecharacter)
-        ischaracter= FLTIsNumeric(dimensionextent) == MS_FALSE;
+        ischaracter = FLTIsNumeric(dimensionextent) == MS_FALSE;
 
     } else {
-      const auto ranges = msStringSplit (dimensionextent, '/');
-      if(ranges.size() == 2 || ranges.size() == 3) {
+      const auto ranges = msStringSplit(dimensionextent, '/');
+      if (ranges.size() == 2 || ranges.size() == 3) {
         /*single range*/
         isextentarange = true;
         aextentranges.resize(1);
@@ -599,22 +659,23 @@ bool msWMSValidateDimensionValue(const c
         ischaracter = false;
       }
     }
-  } else if (extents.size() > 1) { /*check if it is muliple values or mutliple ranges*/
+  } else if (extents.size() >
+             1) { /*check if it is muliple values or mutliple ranges*/
     if (strstr(dimensionextent, "/") == NULL) {
       /*multiple values*/
       isextentavalue = true;
       aextentvalues = extents;
       if (!forcecharacter)
-        ischaracter= FLTIsNumeric(aextentvalues[0].c_str()) == MS_FALSE;
+        ischaracter = FLTIsNumeric(aextentvalues[0].c_str()) == MS_FALSE;
     } else { /*multiple range extent*/
       int isvalidextent = MS_TRUE;
       /*ranges should be numeric*/
       ischaracter = false;
       isextentarange = true;
       aextentranges.resize(extents.size());
-      size_t nextentranges=0;
+      size_t nextentranges = 0;
 
-      for(const auto& extent: extents) {
+      for (const auto &extent : extents) {
         const auto onerange = msStringSplit(extent.c_str(), '/');
         if (onerange.size() != 2 && onerange.size() != 3) {
           isvalidextent = MS_FALSE;
@@ -643,8 +704,7 @@ bool msWMSValidateDimensionValue(const c
   single value,  or list of mulitiple values comma separated,
   a single range or multipe ranges */
 
-
-  const auto uservalues = msStringSplit (value, ',');
+  const auto uservalues = msStringSplit(value, ',');
   bool uservaluevalid = false;
   if (uservalues.size() == 1) {
     /*user iput=single*/
@@ -653,25 +713,25 @@ bool msWMSValidateDimensionValue(const c
     if (ranges.size() == 1) { /*discrete*/
       if (isextentavalue) {
         /*single user value, single/multiple values extent*/
-        for (const auto& extentvalue: aextentvalues) {
+        for (const auto &extentvalue : aextentvalues) {
           if (ischaracter)
             uservaluevalid = (uservalues[0] == extentvalue);
           else {
             if (atof(uservalues[0].c_str()) == atof(extentvalue.c_str()))
               uservaluevalid = true;
           }
-          if(uservaluevalid)
+          if (uservaluevalid)
             break;
         }
       } else if (isextentarange) {
         /*single user value, single/multiple range extent*/
         const float currentval = atof(uservalues[0].c_str());
 
-        for (const auto& extentrange: aextentranges) {
+        for (const auto &extentrange : aextentranges) {
           const float minval = extentrange.x;
           const float maxval = extentrange.y;
           if (currentval >= minval && currentval <= maxval) {
-            uservaluevalid= true;
+            uservaluevalid = true;
             break;
           }
         }
@@ -682,13 +742,13 @@ bool msWMSValidateDimensionValue(const c
       const float mincurrentval = atof(ranges[0].c_str());
       const float maxcurrentval = atof(ranges[1].c_str());
       if (isextentarange) {
-        for (const auto& extentrange: aextentranges) {
+        for (const auto &extentrange : aextentranges) {
           const float minval = extentrange.x;
           const float maxval = extentrange.y;
 
-          if(minval <= mincurrentval && maxval >= maxcurrentval &&
+          if (minval <= mincurrentval && maxval >= maxcurrentval &&
               minval <= maxval) {
-            uservaluevalid= true;
+            uservaluevalid = true;
             break;
           }
         }
@@ -698,11 +758,12 @@ bool msWMSValidateDimensionValue(const c
     if (strstr(value, "/") == NULL) {
       /*user input=multiple value*/
       bool valueisvalid = false;
-      for (const auto& uservalue: uservalues) {
+      for (const auto &uservalue : uservalues) {
         valueisvalid = false;
         if (isextentavalue) {
-          /*user input is multiple values, extent is defned as one or multiple values*/
-          for (const auto& extentvalue: aextentvalues) {
+          /*user input is multiple values, extent is defned as one or multiple
+           * values*/
+          for (const auto &extentvalue : aextentvalues) {
             if (ischaracter) {
               if (uservalue == extentvalue) {
                 valueisvalid = true;
@@ -719,12 +780,13 @@ bool msWMSValidateDimensionValue(const c
           if (!valueisvalid)
             break;
         } else if (isextentarange) {
-          /*user input is multiple values, extent is defned as one or multiple ranges*/
-          for (const auto& extentrange: aextentranges) {
+          /*user input is multiple values, extent is defned as one or multiple
+           * ranges*/
+          for (const auto &extentrange : aextentranges) {
             const float minval = extentrange.x;
             const float maxval = extentrange.y;
             const float currentval = atof(uservalue.c_str());
-            if(minval <= currentval && maxval >= currentval &&
+            if (minval <= currentval && maxval >= currentval &&
                 minval <= maxval) {
               valueisvalid = true;
               break;
@@ -738,7 +800,7 @@ bool msWMSValidateDimensionValue(const c
     } else { /*user input multiple ranges*/
       bool valueisvalid = true;
 
-      for (const auto& uservalue: uservalues) {
+      for (const auto &uservalue : uservalues) {
         /*each ranges should be valid*/
         const auto onerange = msStringSplit(uservalue.c_str(), '/');
         if (onerange.size() == 2 || onerange.size() == 3) {
@@ -748,16 +810,16 @@ bool msWMSValidateDimensionValue(const c
           /*extent must be defined also as a rangle*/
           if (isextentarange) {
             bool found = false;
-            for (const auto& extentrange: aextentranges) {
+            for (const auto &extentrange : aextentranges) {
               const float mincurrentrange = extentrange.x;
               const float maxcurrentrange = extentrange.y;
 
-              if(mincurrentval >=mincurrentrange && maxcurrentval <= maxcurrentrange &&
+              if (mincurrentval >= mincurrentrange &&
+                  maxcurrentval <= maxcurrentrange &&
                   mincurrentval <= maxcurrentval) {
                 found = true;
                 break;
               }
-
             }
             if (!found) {
               valueisvalid = false;
@@ -770,30 +832,31 @@ bool msWMSValidateDimensionValue(const c
       }
       uservaluevalid = valueisvalid;
     }
-
   }
 
   return uservaluevalid;
 }
 
-static
-bool msWMSApplyDimensionLayer(layerObj *lp, const char *item, const char *value, bool forcecharacter)
-{
+static bool msWMSApplyDimensionLayer(layerObj *lp, const char *item,
+                                     const char *value, bool forcecharacter) {
   bool result = false;
 
   if (lp && item && value) {
     /*for the value, we support descrete values (2005) */
     /* multiple values (abc, def, ...) */
     /* and range(s) (1000/2000, 3000/5000) */
-    char* pszExpression = FLTGetExpressionForValuesRanges(lp, item, value, forcecharacter ? MS_TRUE : MS_FALSE);
+    char *pszExpression = FLTGetExpressionForValuesRanges(
+        lp, item, value, forcecharacter ? MS_TRUE : MS_FALSE);
 
     if (pszExpression) {
       // If tileindex is set, the filter is applied to tileindex too.
       int tlpindex = -1;
-      if (lp->tileindex && (tlpindex = msGetLayerIndex(lp->map, lp->tileindex)) != -1) {
-          result = FLTApplyExpressionToLayer((GET_LAYER(lp->map, tlpindex)), pszExpression) != MS_FALSE;
+      if (lp->tileindex &&
+          (tlpindex = msGetLayerIndex(lp->map, lp->tileindex)) != -1) {
+        result = FLTApplyExpressionToLayer((GET_LAYER(lp->map, tlpindex)),
+                                           pszExpression) != MS_FALSE;
       } else {
-          result = true;
+        result = true;
       }
       result &= FLTApplyExpressionToLayer(lp, pszExpression) != MS_FALSE;
       msFree(pszExpression);
@@ -802,18 +865,18 @@ bool msWMSApplyDimensionLayer(layerObj *
   return result;
 }
 
-static
-bool msWMSApplyDimension(layerObj *lp, int /* version */, const char *dimensionname, const char *value,
-                        const char * /* wms_exception_format */)
-{
+static bool msWMSApplyDimension(layerObj *lp, int /* version */,
+                                const char *dimensionname, const char *value,
+                                const char * /* wms_exception_format */) {
   bool forcecharacter = false;
   bool result = false;
 
   if (lp && dimensionname && value) {
-    /*check if the dimension name passes starts with dim_. All dimensions should start with dim_, except elevation*/
+    /*check if the dimension name passes starts with dim_. All dimensions should
+     * start with dim_, except elevation*/
     std::string dimension;
     if (strncasecmp(dimensionname, "dim_", 4) == 0)
-      dimension = dimensionname+4;
+      dimension = dimensionname + 4;
     else
       dimension = dimensionname;
 
@@ -822,42 +885,56 @@ bool msWMSApplyDimension(layerObj *lp, i
     if (strlen(value) > 0)
       currentvalue = value;
     else {
-      const char* dimensiondefault = msOWSLookupMetadata(&(lp->metadata), "M", (dimension + "_default").c_str());
+      const char *dimensiondefault = msOWSLookupMetadata(
+          &(lp->metadata), "M", (dimension + "_default").c_str());
       if (dimensiondefault)
         currentvalue = dimensiondefault;
     }
 
     /*check if the manadatory metada related to the dimension are set*/
-    const char* dimensionitem = msOWSLookupMetadata(&(lp->metadata), "M", (dimension + "_item").c_str());
-    const char* dimensionextent = msOWSLookupMetadata(&(lp->metadata), "M", (dimension + "_extent").c_str());
-    const char* dimensionunit = msOWSLookupMetadata(&(lp->metadata), "M", (dimension + "_units").c_str());
+    const char *dimensionitem = msOWSLookupMetadata(
+        &(lp->metadata), "M", (dimension + "_item").c_str());
+    const char *dimensionextent = msOWSLookupMetadata(
+        &(lp->metadata), "M", (dimension + "_extent").c_str());
+    const char *dimensionunit = msOWSLookupMetadata(
+        &(lp->metadata), "M", (dimension + "_units").c_str());
 
     /*if the server want to force the type to character*/
-    const char* dimensiontype = msOWSLookupMetadata(&(lp->metadata), "M", (dimension + "_type").c_str());
+    const char *dimensiontype = msOWSLookupMetadata(
+        &(lp->metadata), "M", (dimension + "_type").c_str());
     if (dimensiontype && strcasecmp(dimensiontype, "Character") == 0)
       forcecharacter = true;
 
-    if (dimensionitem && dimensionextent && dimensionunit && !currentvalue.empty()) {
-      if(msWMSValidateDimensionValue(currentvalue.c_str(), dimensionextent, forcecharacter)) {
-        result = msWMSApplyDimensionLayer(lp, dimensionitem, currentvalue.c_str(), forcecharacter);
+    if (dimensionitem && dimensionextent && dimensionunit &&
+        !currentvalue.empty()) {
+      if (msWMSValidateDimensionValue(currentvalue.c_str(), dimensionextent,
+                                      forcecharacter)) {
+        result = msWMSApplyDimensionLayer(lp, dimensionitem,
+                                          currentvalue.c_str(), forcecharacter);
       } else {
-        msSetError(MS_WMSERR, "Dimension %s with a value of %s is invalid or outside the extents defined", "msWMSApplyDimension",
-                   dimension.c_str(), currentvalue.c_str());
+        msSetError(MS_WMSERR,
+                   "Dimension %s with a value of %s is invalid or outside the "
+                   "extents defined",
+                   "msWMSApplyDimension", dimension.c_str(),
+                   currentvalue.c_str());
         result = false;
       }
     } else
-      msSetError(MS_WMSERR, "Dimension %s : invalid settings. Make sure that item, units and extent are set.", "msWMSApplyDimension",
-                 dimension.c_str());
+      msSetError(MS_WMSERR,
+                 "Dimension %s : invalid settings. Make sure that item, units "
+                 "and extent are set.",
+                 "msWMSApplyDimension", dimension.c_str());
   }
   return result;
 }
 /*
 **
 */
-int msWMSLoadGetMapParams(mapObj *map, int nVersion,
-                          char **names, char **values, int numentries, const char *wms_exception_format,
-                          const char * /*wms_request*/, owsRequestObj *ows_request)
-{
+int msWMSLoadGetMapParams(mapObj *map, int nVersion, char **names,
+                          char **values, int numentries,
+                          const char *wms_exception_format,
+                          const char * /*wms_request*/,
+                          owsRequestObj *ows_request) {
   bool adjust_extent = false;
   bool nonsquare_enabled = false;
   int transparent = MS_NOOVERRIDE;
@@ -881,9 +958,9 @@ int msWMSLoadGetMapParams(mapObj *map, i
   const char *layerlimit = NULL;
   bool tiled = false;
 
-  const char *sldenabled=NULL;
-  const char *sld_url=NULL;
-  const char *sld_body=NULL;
+  const char *sldenabled = NULL;
+  const char *sld_url = NULL;
+  const char *sld_body = NULL;
 
   const char *filter = NULL;
 
@@ -894,12 +971,15 @@ int msWMSLoadGetMapParams(mapObj *map, i
   msAdjustExtent(&(map->extent), map->width, map->height);
 
   /*
-    Check for SLDs first. If SLD is available LAYERS and STYLES parameters are non mandatory
+    Check for SLDs first. If SLD is available LAYERS and STYLES parameters are
+    non mandatory
    */
-  for(int i=0; i<numentries; i++) {
+  for (int i = 0; i < numentries; i++) {
     /* check if SLD is passed.  If yes, check for OGR support */
-    if (strcasecmp(names[i], "SLD") == 0 || strcasecmp(names[i], "SLD_BODY") == 0) {
-      sldenabled = msOWSLookupMetadata(&(map->web.metadata), "MO", "sld_enabled");
+    if (strcasecmp(names[i], "SLD") == 0 ||
+        strcasecmp(names[i], "SLD_BODY") == 0) {
+      sldenabled =
+          msOWSLookupMetadata(&(map->web.metadata), "MO", "sld_enabled");
 
       if (sldenabled == NULL) {
         sldenabled = "true";
@@ -907,17 +987,17 @@ int msWMSLoadGetMapParams(mapObj *map, i
 
       if (strcasecmp(sldenabled, "true") == 0) {
         if (strcasecmp(names[i], "SLD") == 0) {
-          sld_url =  values[i];
+          sld_url = values[i];
         }
         if (strcasecmp(names[i], "SLD_BODY") == 0) {
-          sld_body =  values[i];
+          sld_body = values[i];
         }
       }
     }
   }
 
   std::vector<std::string> wmslayers;
-  for(int i=0; i<numentries; i++) {
+  for (int i = 0; i < numentries; i++) {
     /* getMap parameters */
 
     if (strcasecmp(names[i], "REQUEST") == 0) {
@@ -929,7 +1009,7 @@ int msWMSLoadGetMapParams(mapObj *map, i
 
       wmslayers = msStringSplit(values[i], ',');
       if (wmslayers.empty()) {
-        if (sld_url == NULL &&   sld_body == NULL) {
+        if (sld_url == NULL && sld_body == NULL) {
           msSetError(MS_WMSERR, "At least one layer name required in LAYERS.",
                      "msWMSLoadGetMapParams()");
           return msWMSException(map, nVersion, NULL, wms_exception_format);
@@ -937,22 +1017,24 @@ int msWMSLoadGetMapParams(mapObj *map, i
       }
 
       if (nVersion >= OWS_1_3_0) {
-        layerlimit = msOWSLookupMetadata(&(map->web.metadata), "MO", "layerlimit");
-        if(layerlimit) {
+        layerlimit =
+            msOWSLookupMetadata(&(map->web.metadata), "MO", "layerlimit");
+        if (layerlimit) {
           if (static_cast<int>(wmslayers.size()) > atoi(layerlimit)) {
-            msSetError(MS_WMSERR, "Number of layers requested exceeds LayerLimit.",
+            msSetError(MS_WMSERR,
+                       "Number of layers requested exceeds LayerLimit.",
                        "msWMSLoadGetMapParams()");
             return msWMSException(map, nVersion, NULL, wms_exception_format);
           }
         }
       }
 
-      for (int iLayer=0; iLayer < map->numlayers; iLayer++) {
+      for (int iLayer = 0; iLayer < map->numlayers; iLayer++) {
         map->layerorder[iLayer] = iLayer;
       }
 
       int nLayerOrder = 0;
-      for(int j=0; j<map->numlayers; j++) {
+      for (int j = 0; j < map->numlayers; j++) {
         /* Keep only layers with status=DEFAULT by default */
         /* Layer with status DEFAULT is drawn first. */
         if (GET_LAYER(map, j)->status != MS_DEFAULT)
@@ -963,30 +1045,39 @@ int msWMSLoadGetMapParams(mapObj *map, i
         }
       }
 
-      char*** nestedGroups = (char***)msSmallCalloc(map->numlayers, sizeof(char**));
-      int* numNestedGroups = (int*)msSmallCalloc(map->numlayers, sizeof(int));
-      int* isUsedInNestedGroup = (int*)msSmallCalloc(map->numlayers, sizeof(int));
-      msWMSPrepareNestedGroups(map, nVersion, nestedGroups, numNestedGroups, isUsedInNestedGroup);
+      char ***nestedGroups =
+          (char ***)msSmallCalloc(map->numlayers, sizeof(char **));
+      int *numNestedGroups = (int *)msSmallCalloc(map->numlayers, sizeof(int));
+      int *isUsedInNestedGroup =
+          (int *)msSmallCalloc(map->numlayers, sizeof(int));
+      msWMSPrepareNestedGroups(map, nVersion, nestedGroups, numNestedGroups,
+                               isUsedInNestedGroup);
 
       if (ows_request->layerwmsfilterindex != NULL)
         msFree(ows_request->layerwmsfilterindex);
-      ows_request->layerwmsfilterindex = (int*)msSmallMalloc(map->numlayers * sizeof(int));
-      for(int j=0; j<map->numlayers; j++) {
+      ows_request->layerwmsfilterindex =
+          (int *)msSmallMalloc(map->numlayers * sizeof(int));
+      for (int j = 0; j < map->numlayers; j++) {
         ows_request->layerwmsfilterindex[j] = -1;
       }
       ows_request->numwmslayerargs = static_cast<int>(wmslayers.size());
 
       for (int k = 0; k < static_cast<int>(wmslayers.size()); k++) {
-        const auto& wmslayer = wmslayers[k];
+        const auto &wmslayer = wmslayers[k];
         bool layerfound = false;
-        for (int j=0; j<map->numlayers; j++) {
+        for (int j = 0; j < map->numlayers; j++) {
           /* Turn on selected layers only. */
-          if ( ((GET_LAYER(map, j)->name &&
-                 strcasecmp(GET_LAYER(map, j)->name, wmslayer.c_str()) == 0) ||
-                (map->name && strcasecmp(map->name, wmslayer.c_str()) == 0) ||
-                (GET_LAYER(map, j)->group && strcasecmp(GET_LAYER(map, j)->group, wmslayer.c_str()) == 0) ||
-                ((numNestedGroups[j] >0) && msStringInArray(wmslayer.c_str(), nestedGroups[j], numNestedGroups[j]))) &&
-               ((msIntegerInArray(GET_LAYER(map, j)->index, ows_request->enabled_layers, ows_request->numlayers))) ) {
+          if (((GET_LAYER(map, j)->name &&
+                strcasecmp(GET_LAYER(map, j)->name, wmslayer.c_str()) == 0) ||
+               (map->name && strcasecmp(map->name, wmslayer.c_str()) == 0) ||
+               (GET_LAYER(map, j)->group &&
+                strcasecmp(GET_LAYER(map, j)->group, wmslayer.c_str()) == 0) ||
+               ((numNestedGroups[j] > 0) &&
+                msStringInArray(wmslayer.c_str(), nestedGroups[j],
+                                numNestedGroups[j]))) &&
+              ((msIntegerInArray(GET_LAYER(map, j)->index,
+                                 ows_request->enabled_layers,
+                                 ows_request->numlayers)))) {
             if (GET_LAYER(map, j)->status != MS_DEFAULT) {
               if (layerOrder[j] == 0) {
                 map->layerorder[nLayerOrder++] = j;
@@ -995,9 +1086,10 @@ int msWMSLoadGetMapParams(mapObj *map, i
               }
             }
             /* if a layer name is repeated assign the first matching filter */
-            /* duplicate names will be assigned filters later when layer copies are created */
+            /* duplicate names will be assigned filters later when layer copies
+             * are created */
             if (ows_request->layerwmsfilterindex[j] == -1) {
-                ows_request->layerwmsfilterindex[j] = k;
+              ows_request->layerwmsfilterindex[j] = k;
             }
             validlayers++;
             layerfound = true;
@@ -1005,7 +1097,6 @@ int msWMSLoadGetMapParams(mapObj *map, i
         }
         if (layerfound == false && !wmslayers.empty())
           invalidlayers++;
-
       }
 
       /* free the stuff used for nested layers */
@@ -1019,7 +1110,7 @@ int msWMSLoadGetMapParams(mapObj *map, i
       free(isUsedInNestedGroup);
 
       /* set all layers with status off at end of array */
-      for (int j=0; j<map->numlayers; j++) {
+      for (int j = 0; j < map->numlayers; j++) {
         if (GET_LAYER(map, j)->status == MS_OFF)
           if (layerOrder[j] == 0)
             map->layerorder[nLayerOrder++] = j;
@@ -1030,7 +1121,7 @@ int msWMSLoadGetMapParams(mapObj *map, i
     } else if ((strcasecmp(names[i], "SRS") == 0 && nVersion < OWS_1_3_0) ||
                (strcasecmp(names[i], "CRS") == 0 && nVersion >= OWS_1_3_0)) {
       srsfound = true;
-      char* colon = strchr(values[i], ':');
+      char *colon = strchr(values[i], ':');
       bool srsOk = false;
       /* SRS is in format "EPSG:epsg_id" or "AUTO:proj_id,unit_id,lon0,lat0" */
       if (strncasecmp(values[i], "EPSG:", 5) == 0) {
@@ -1041,14 +1132,13 @@ int msWMSLoadGetMapParams(mapObj *map, i
            used with msLoadProjection and that does already the job */
 
         srsbuffer = "EPSG:";
-        srsbuffer += (values[i]+5);
+        srsbuffer += (values[i] + 5);
         epsgbuf = srsbuffer;
 
         /* This test was to correct a request by the OCG cite 1.3.0 test
          sending CRS=ESPG:4326,  Bug:*/
         if (nVersion >= OWS_1_3_0) {
-          if (srsbuffer.back() == ',')
-          {
+          if (srsbuffer.back() == ',') {
             srsbuffer.resize(srsbuffer.size() - 1);
             epsgbuf = srsbuffer;
           }
@@ -1065,41 +1155,46 @@ int msWMSLoadGetMapParams(mapObj *map, i
         if (iUnits != -1)
           map->units = iUnits;
         */
-      } else if (strncasecmp(values[i], "AUTO:", 5) == 0 && nVersion < OWS_1_3_0) {
-        if( nVersion < OWS_1_3_0 ) {
-            srsOk = true;
-            srsbuffer = values[i];
-            /* SRS=AUTO:proj_id,unit_id,lon0,lat0 */
-            /*
-            if (msLoadProjectionString(&(map->projection), values[i]) != 0)
-              return msWMSException(map, nVersion, NULL);
-
-            iUnits = GetMapserverUnitUsingProj(&(map->projection));
-            if (iUnits != -1)
-              map->units = iUnits;
-            */
+      } else if (strncasecmp(values[i], "AUTO:", 5) == 0 &&
+                 nVersion < OWS_1_3_0) {
+        if (nVersion < OWS_1_3_0) {
+          srsOk = true;
+          srsbuffer = values[i];
+          /* SRS=AUTO:proj_id,unit_id,lon0,lat0 */
+          /*
+          if (msLoadProjectionString(&(map->projection), values[i]) != 0)
+            return msWMSException(map, nVersion, NULL);
+
+          iUnits = GetMapserverUnitUsingProj(&(map->projection));
+          if (iUnits != -1)
+            map->units = iUnits;
+          */
         }
       } else if (strncasecmp(values[i], "AUTO2:", 6) == 0 ||
                  strncasecmp(values[i], "CRS:", 4) == 0) {
-        if( nVersion >= OWS_1_3_0 ) {
-            srsOk = true;
-            srsbuffer = values[i];
+        if (nVersion >= OWS_1_3_0) {
+          srsOk = true;
+          srsbuffer = values[i];
         }
-      } else if( colon != NULL && strchr(colon + 1, ':') == NULL ) {
+      } else if (colon != NULL && strchr(colon + 1, ':') == NULL) {
         srsOk = true;
         srsbuffer = values[i];
       }
       if (!srsOk) {
         if (nVersion >= OWS_1_3_0) {
           msSetError(MS_WMSERR,
-                     "Unsupported CRS namespace (only EPSG, AUTO2, CRS currently supported).",
+                     "Unsupported CRS namespace (only EPSG, AUTO2, CRS "
+                     "currently supported).",
                      "msWMSLoadGetMapParams()");
-          return msWMSException(map, nVersion, "InvalidCRS", wms_exception_format);
+          return msWMSException(map, nVersion, "InvalidCRS",
+                                wms_exception_format);
         } else {
           msSetError(MS_WMSERR,
-                     "Unsupported SRS namespace (only EPSG and AUTO currently supported).",
+                     "Unsupported SRS namespace (only EPSG and AUTO currently "
+                     "supported).",
                      "msWMSLoadGetMapParams()");
-          return msWMSException(map, nVersion, "InvalidSRS", wms_exception_format);
+          return msWMSException(map, nVersion, "InvalidSRS",
+                                wms_exception_format);
         }
       }
     } else if (strcasecmp(names[i], "BBOX") == 0) {
@@ -1120,10 +1215,9 @@ int msWMSLoadGetMapParams(mapObj *map, i
       if (nVersion < OWS_1_3_0) {
 
         /* validate bbox values */
-        if ( map->extent.minx >= map->extent.maxx ||
-             map->extent.miny >=  map->extent.maxy) {
-          msSetError(MS_WMSERR,
-                     "Invalid values for BBOX.",
+        if (map->extent.minx >= map->extent.maxx ||
+            map->extent.miny >= map->extent.maxy) {
+          msSetError(MS_WMSERR, "Invalid values for BBOX.",
                      "msWMSLoadGetMapParams()");
           return msWMSException(map, nVersion, NULL, wms_exception_format);
         }
@@ -1138,22 +1232,22 @@ int msWMSLoadGetMapParams(mapObj *map, i
     } else if (strcasecmp(names[i], "FORMAT") == 0) {
       formatfound = true;
 
-      if (strcasecmp(values[i], "application/openlayers")!=0) {
+      if (strcasecmp(values[i], "application/openlayers") != 0) {
         /*check to see if a predefined list is given*/
-        const char* format_list = msOWSLookupMetadata(&(map->web.metadata), "M","getmap_formatlist");
+        const char *format_list =
+            msOWSLookupMetadata(&(map->web.metadata), "M", "getmap_formatlist");
         if (format_list) {
-          format = msOwsIsOutputFormatValid(map, values[i], &(map->web.metadata),
-                                            "M", "getmap_formatlist");
+          format = msOwsIsOutputFormatValid(
+              map, values[i], &(map->web.metadata), "M", "getmap_formatlist");
           if (format == NULL) {
-            msSetError(MS_IMGERR,
-                       "Unsupported output format (%s).",
-                       "msWMSLoadGetMapParams()",
-                       values[i] );
-            return msWMSException(map, nVersion, "InvalidFormat", wms_exception_format);
+            msSetError(MS_IMGERR, "Unsupported output format (%s).",
+                       "msWMSLoadGetMapParams()", values[i]);
+            return msWMSException(map, nVersion, "InvalidFormat",
+                                  wms_exception_format);
           }
         } else {
-          format = msSelectOutputFormat( map, values[i] );
-          if( format == NULL ||
+          format = msSelectOutputFormat(map, values[i]);
+          if (format == NULL ||
               (strncasecmp(format->driver, "MVT", 3) != 0 &&
                strncasecmp(format->driver, "GDAL/", 5) != 0 &&
                strncasecmp(format->driver, "AGG/", 4) != 0 &&
@@ -1162,24 +1256,23 @@ int msWMSLoadGetMapParams(mapObj *map, i
                strncasecmp(format->driver, "OGL/", 4) != 0 &&
                strncasecmp(format->driver, "KML", 3) != 0 &&
                strncasecmp(format->driver, "KMZ", 3) != 0)) {
-            msSetError(MS_IMGERR,
-                       "Unsupported output format (%s).",
-                       "msWMSLoadGetMapParams()",
-                       values[i] );
-            return msWMSException(map, nVersion, "InvalidFormat", wms_exception_format);
+            msSetError(MS_IMGERR, "Unsupported output format (%s).",
+                       "msWMSLoadGetMapParams()", values[i]);
+            return msWMSException(map, nVersion, "InvalidFormat",
+                                  wms_exception_format);
           }
         }
       }
-      msFree( map->imagetype );
+      msFree(map->imagetype);
       map->imagetype = msStrdup(values[i]);
     } else if (strcasecmp(names[i], "TRANSPARENT") == 0) {
       transparent = (strcasecmp(values[i], "TRUE") == 0);
     } else if (strcasecmp(names[i], "BGCOLOR") == 0) {
       long c;
       c = strtol(values[i], NULL, 16);
-      map->imagecolor.red = (c/0x10000)&0xff;
-      map->imagecolor.green = (c/0x100)&0xff;
-      map->imagecolor.blue = c&0xff;
+      map->imagecolor.red = (c / 0x10000) & 0xff;
+      map->imagecolor.green = (c / 0x100) & 0xff;
+      map->imagecolor.blue = c & 0xff;
     }
 
     /* value of time can be empty. We should look for a default value */
@@ -1214,10 +1307,10 @@ int msWMSLoadGetMapParams(mapObj *map, i
     if (strcasecmp(wms_exception_format, "INIMAGE") != 0 &&
         strcasecmp(wms_exception_format, "BLANK") != 0 &&
         strcasecmp(wms_exception_format, "XML") != 0) {
-      msSetError(MS_WMSERR,
-                 "Invalid format %s for the EXCEPTIONS parameter.",
-                 "msWMSLoadGetMapParams()",  wms_exception_format);
-      return msWMSException(map, nVersion, "InvalidFormat", wms_exception_format);
+      msSetError(MS_WMSERR, "Invalid format %s for the EXCEPTIONS parameter.",
+                 "msWMSLoadGetMapParams()", wms_exception_format);
+      return msWMSException(map, nVersion, "InvalidFormat",
+                            wms_exception_format);
     }
   }
 
@@ -1235,23 +1328,24 @@ int msWMSLoadGetMapParams(mapObj *map, i
       msInitProjection(&proj);
       msProjectionInheritContextFrom(&proj, &(map->projection));
       if (msLoadProjectionStringEPSG(&proj, srsbuffer.c_str()) == 0 &&
-	  (need_axis_swap = msIsAxisInvertedProj(&proj) ) ) {
-        msAxisNormalizePoints( &proj, 1, &rect.minx, &rect.miny );
-        msAxisNormalizePoints( &proj, 1, &rect.maxx, &rect.maxy );
+          (need_axis_swap = msIsAxisInvertedProj(&proj))) {
+        msAxisNormalizePoints(&proj, 1, &rect.minx, &rect.miny);
+        msAxisNormalizePoints(&proj, 1, &rect.maxx, &rect.maxy);
       }
-      msFreeProjection( &proj );
+      msFreeProjection(&proj);
     }
     /*if the CRS is AUTO2:auto_crs_id,factor,lon0,lat0,
      we need to grab the factor parameter and use it with the bbox*/
-    if (srsbuffer.size() > 1 && strncasecmp(srsbuffer.c_str(), "AUTO2:", 6) == 0) {
+    if (srsbuffer.size() > 1 &&
+        strncasecmp(srsbuffer.c_str(), "AUTO2:", 6) == 0) {
       const auto args = msStringSplit(srsbuffer.c_str(), ',');
       if (args.size() == 4) {
         const double factor = atof(args[1].c_str());
         if (factor > 0 && factor != 1.0) {
-          rect.minx = rect.minx*factor;
-          rect.miny = rect.miny*factor;
-          rect.maxx = rect.maxx*factor;
-          rect.maxx = rect.maxy*factor;
+          rect.minx = rect.minx * factor;
+          rect.miny = rect.miny * factor;
+          rect.maxx = rect.maxx * factor;
+          rect.maxx = rect.maxy * factor;
         }
       }
     }
@@ -1259,10 +1353,9 @@ int msWMSLoadGetMapParams(mapObj *map, i
     map->extent = rect;
 
     /* validate bbox values */
-    if ( map->extent.minx >= map->extent.maxx ||
-         map->extent.miny >=  map->extent.maxy) {
-      msSetError(MS_WMSERR,
-                 "Invalid values for BBOX.",
+    if (map->extent.minx >= map->extent.maxx ||
+        map->extent.miny >= map->extent.maxy) {
+      msSetError(MS_WMSERR, "Invalid values for BBOX.",
                  "msWMSLoadGetMapParams()");
       return msWMSException(map, nVersion, NULL, wms_exception_format);
     }
@@ -1275,14 +1368,19 @@ int msWMSLoadGetMapParams(mapObj *map, i
     int map_edge_buffer = 0;
 
     if ((value = msLookupHashTable(meta, "tile_map_edge_buffer")) != NULL) {
-        map_edge_buffer = atoi(value);
+      map_edge_buffer = atoi(value);
     }
-    if (map_edge_buffer > 0 && map->width > 0 && map->height >  0) {
+    if (map_edge_buffer > 0 && map->width > 0 && map->height > 0) {
       /* adjust bbox and width and height to the buffer */
-      const double buffer_x = map_edge_buffer * (map->extent.maxx - map->extent.minx) / (double)map->width;
-      const double buffer_y = map_edge_buffer * (map->extent.maxy - map->extent.miny) / (double)map->height;
+      const double buffer_x = map_edge_buffer *
+                              (map->extent.maxx - map->extent.minx) /
+                              (double)map->width;
+      const double buffer_y = map_edge_buffer *
+                              (map->extent.maxy - map->extent.miny) /
+                              (double)map->height;
 
-      // TODO: we should probably clamp the extent to avoid going outside of -180,-90,180,90 for geographic CRS for example
+      // TODO: we should probably clamp the extent to avoid going outside of
+      // -180,-90,180,90 for geographic CRS for example
       map->extent.minx -= buffer_x;
       map->extent.maxx += buffer_x;
       map->extent.miny -= buffer_y;
@@ -1291,18 +1389,20 @@ int msWMSLoadGetMapParams(mapObj *map, i
       map->width += 2 * map_edge_buffer;
       map->height += 2 * map_edge_buffer;
 
-      if( map_edge_buffer > 0 ) {
+      if (map_edge_buffer > 0) {
         char tilebufferstr[64];
 
         /* Write the tile buffer to a string */
         snprintf(tilebufferstr, sizeof(tilebufferstr), "-%d", map_edge_buffer);
 
         /* Hm, the labelcache buffer is set... */
-        if((value = msLookupHashTable(meta, "labelcache_map_edge_buffer")) != NULL) {
+        if ((value = msLookupHashTable(meta, "labelcache_map_edge_buffer")) !=
+            NULL) {
           /* If it's too small, replace with a bigger one */
-          if( map_edge_buffer > abs(atoi(value)) ) {
+          if (map_edge_buffer > abs(atoi(value))) {
             msRemoveHashTable(meta, "labelcache_map_edge_buffer");
-            msInsertHashTable(meta, "labelcache_map_edge_buffer", tilebufferstr);
+            msInsertHashTable(meta, "labelcache_map_edge_buffer",
+                              tilebufferstr);
           }
         }
         /* No labelcache buffer value? Then we use the tile buffer. */
@@ -1317,15 +1417,15 @@ int msWMSLoadGetMapParams(mapObj *map, i
   ** If any select layers have a default time, we will apply the default
   ** time value even if no TIME request was in the url.
   */
-  if( !timerequest && map ) {
-    for (int i=0; i<map->numlayers && !timerequest; i++) {
+  if (!timerequest && map) {
+    for (int i = 0; i < map->numlayers && !timerequest; i++) {
       layerObj *lp = NULL;
 
       lp = (GET_LAYER(map, i));
       if (lp->status != MS_ON && lp->status != MS_DEFAULT)
         continue;
 
-      if( msOWSLookupMetadata(&(lp->metadata), "MO", "timedefault") )
+      if (msOWSLookupMetadata(&(lp->metadata), "MO", "timedefault"))
         timerequest = true;
     }
   }
@@ -1334,44 +1434,50 @@ int msWMSLoadGetMapParams(mapObj *map, i
   ** Apply time filters if available in the request.
   */
   if (timerequest) {
-    if (msWMSApplyTime(map, nVersion, stime, wms_exception_format) == MS_FAILURE) {
-      return MS_FAILURE;/* msWMSException(map, nVersion, "InvalidTimeRequest"); */
+    if (msWMSApplyTime(map, nVersion, stime, wms_exception_format) ==
+        MS_FAILURE) {
+      return MS_FAILURE; /* msWMSException(map, nVersion, "InvalidTimeRequest");
+                          */
     }
   }
 
   /*
   ** Check/apply wms dimensions
-  ** all dimension requests should start with dim_xxxx, except time and elevation.
+  ** all dimension requests should start with dim_xxxx, except time and
+  *elevation.
   */
-  for (int i=0; i<map->numlayers; i++) {
+  for (int i = 0; i < map->numlayers; i++) {
     layerObj *lp = (GET_LAYER(map, i));
     if (lp->status != MS_ON && lp->status != MS_DEFAULT)
       continue;
 
-    const char* dimensionlist = msOWSLookupMetadata(&(lp->metadata), "M", "dimensionlist");
+    const char *dimensionlist =
+        msOWSLookupMetadata(&(lp->metadata), "M", "dimensionlist");
     if (dimensionlist) {
       auto tokens = msStringSplit(dimensionlist, ',');
-      for (auto& token: tokens) {
-          msStringTrim(token);
-          for(int k=0; k<numentries; k++) {
-            const std::string dimensionname(names[k]);
-
-            /*the dim_ is supposed to be part of the dimension name in the request*/
-            std::string stmp;
-            if (strcasecmp(token.c_str(), "elevation") == 0)
-              stmp = token;
-            else {
-              stmp = "dim_";
-              stmp += token;
-            }
-            if (strcasecmp(dimensionname.c_str(), stmp.c_str()) == 0) {
-              if (!msWMSApplyDimension(lp, nVersion, dimensionname.c_str(), values[k],
-                                       wms_exception_format)) {
-                return msWMSException(lp->map, nVersion, "InvalidDimensionValue",  wms_exception_format);
-              }
-              break;
+      for (auto &token : tokens) {
+        msStringTrim(token);
+        for (int k = 0; k < numentries; k++) {
+          const std::string dimensionname(names[k]);
+
+          /*the dim_ is supposed to be part of the dimension name in the
+           * request*/
+          std::string stmp;
+          if (strcasecmp(token.c_str(), "elevation") == 0)
+            stmp = token;
+          else {
+            stmp = "dim_";
+            stmp += token;
+          }
+          if (strcasecmp(dimensionname.c_str(), stmp.c_str()) == 0) {
+            if (!msWMSApplyDimension(lp, nVersion, dimensionname.c_str(),
+                                     values[k], wms_exception_format)) {
+              return msWMSException(lp->map, nVersion, "InvalidDimensionValue",
+                                    wms_exception_format);
             }
+            break;
           }
+        }
       }
     }
   }
@@ -1381,22 +1487,27 @@ int msWMSLoadGetMapParams(mapObj *map, i
   ** the transparency if needed.
   */
 
-  if( format != NULL )
-    msApplyOutputFormat( &(map->outputformat), format, transparent);
+  if (format != NULL)
+    msApplyOutputFormat(&(map->outputformat), format, transparent);
 
   /* Validate all layers given.
   ** If an invalid layer is sent, return an exception.
   */
   if (validlayers == 0 || invalidlayers > 0) {
     if (invalidlayers > 0) {
-      msSetError(MS_WMSERR, "Invalid layer(s) given in the LAYERS parameter. A layer might be disabled for \
+      msSetError(
+          MS_WMSERR,
+          "Invalid layer(s) given in the LAYERS parameter. A layer might be disabled for \
 this request. Check wms/ows_enable_request settings.",
-                 "msWMSLoadGetMapParams()");
-      return msWMSException(map, nVersion, "LayerNotDefined", wms_exception_format);
+          "msWMSLoadGetMapParams()");
+      return msWMSException(map, nVersion, "LayerNotDefined",
+                            wms_exception_format);
     }
-    if (validlayers == 0 && sld_url == NULL &&   sld_body == NULL) {
-      msSetError(MS_WMSERR, "Missing required parameter LAYERS", "msWMSLoadGetMapParams()");
-      return msWMSException(map, nVersion, "MissingParameterValue", wms_exception_format);
+    if (validlayers == 0 && sld_url == NULL && sld_body == NULL) {
+      msSetError(MS_WMSERR, "Missing required parameter LAYERS",
+                 "msWMSLoadGetMapParams()");
+      return msWMSException(map, nVersion, "MissingParameterValue",
+                            wms_exception_format);
     }
   }
 
@@ -1409,11 +1520,11 @@ this request. Check wms/ows_enable_reque
   if (epsgbuf.size() >= 2) { /*at least 2 chars*/
     char *projstring;
     epsgvalid = false;
-    msOWSGetEPSGProj(&(map->projection), &(map->web.metadata),
-                                  "MO", MS_FALSE, &projstring);
+    msOWSGetEPSGProj(&(map->projection), &(map->web.metadata), "MO", MS_FALSE,
+                     &projstring);
     if (projstring) {
       const auto tokens = msStringSplit(projstring, ' ');
-      for( const auto& token: tokens) {
+      for (const auto &token : tokens) {
         if (strcasecmp(token.c_str(), epsgbuf.c_str()) == 0) {
           epsgvalid = true;
           break;
@@ -1422,15 +1533,15 @@ this request. Check wms/ows_enable_reque
       msFree(projstring);
     }
     if (!epsgvalid) {
-      for (int i=0; i<map->numlayers; i++) {
+      for (int i = 0; i < map->numlayers; i++) {
         epsgvalid = false;
         if (GET_LAYER(map, i)->status == MS_ON) {
           msOWSGetEPSGProj(&(GET_LAYER(map, i)->projection),
-                                        &(GET_LAYER(map, i)->metadata),
-                                        "MO", MS_FALSE, &projstring);
+                           &(GET_LAYER(map, i)->metadata), "MO", MS_FALSE,
+                           &projstring);
           if (projstring) {
             const auto tokens = msStringSplit(projstring, ' ');
-            for( const auto& token: tokens) {
+            for (const auto &token : tokens) {
               if (strcasecmp(token.c_str(), epsgbuf.c_str()) == 0) {
                 epsgvalid = true;
                 break;
@@ -1440,13 +1551,19 @@ this request. Check wms/ows_enable_reque
           }
           if (!epsgvalid) {
             if (nVersion >= OWS_1_3_0) {
-              msSetError(MS_WMSERR, "Invalid CRS given : CRS must be valid for all requested layers.",
+              msSetError(MS_WMSERR,
+                         "Invalid CRS given : CRS must be valid for all "
+                         "requested layers.",
                          "msWMSLoadGetMapParams()");
-              return msWMSException(map, nVersion, "InvalidSRS", wms_exception_format);
+              return msWMSException(map, nVersion, "InvalidSRS",
+                                    wms_exception_format);
             } else {
-              msSetError(MS_WMSERR, "Invalid SRS given : SRS must be valid for all requested layers.",
+              msSetError(MS_WMSERR,
+                         "Invalid SRS given : SRS must be valid for all "
+                         "requested layers.",
                          "msWMSLoadGetMapParams()");
-              return msWMSException(map, nVersion, "InvalidSRS", wms_exception_format);
+              return msWMSException(map, nVersion, "InvalidSRS",
+                                    wms_exception_format);
             }
           }
         }
@@ -1456,20 +1573,24 @@ this request. Check wms/ows_enable_reque
 
   if (request == NULL || strcasecmp(request, "DescribeLayer") != 0) {
     /* Validate requested image size.
-    */
-    if(map->width > map->maxsize || map->height > map->maxsize ||
+     */
+    if (map->width > map->maxsize || map->height > map->maxsize ||
         map->width < 1 || map->height < 1) {
-      msSetError(MS_WMSERR, "Image size out of range, WIDTH and HEIGHT must be between 1 and %d pixels.", "msWMSLoadGetMapParams()", map->maxsize);
+      msSetError(MS_WMSERR,
+                 "Image size out of range, WIDTH and HEIGHT must be between 1 "
+                 "and %d pixels.",
+                 "msWMSLoadGetMapParams()", map->maxsize);
 
       /* Restore valid default values in case errors INIMAGE are used */
       map->width = 400;
-      map->height= 300;
+      map->height = 300;
       return msWMSException(map, nVersion, NULL, wms_exception_format);
     }
 
     /* Check whether requested BBOX and width/height result in non-square pixels
-    */
-    nonsquare_enabled = msTestConfigOption( map, "MS_NONSQUARE", MS_FALSE ) != MS_FALSE;
+     */
+    nonsquare_enabled =
+        msTestConfigOption(map, "MS_NONSQUARE", MS_FALSE) != MS_FALSE;
     if (!nonsquare_enabled) {
       const double dx = MS_ABS(map->extent.maxx - map->extent.minx);
       const double dy = MS_ABS(map->extent.maxy - map->extent.miny);
@@ -1478,9 +1599,9 @@ this request. Check wms/ows_enable_reque
 
       /* Allow up to 1 pixel of error on the width/height ratios. */
       /* If more than 1 pixel then enable non-square pixels */
-      if ( MS_ABS((reqy - (double)map->height)) > 1.0 ) {
+      if (MS_ABS((reqy - (double)map->height)) > 1.0) {
         if (map->debug)
-            msDebug("msWMSLoadGetMapParams(): enabling non-square pixels.\n");
+          msDebug("msWMSLoadGetMapParams(): enabling non-square pixels.\n");
         msSetConfigOption(map, "MS_NONSQUARE", "YES");
         nonsquare_enabled = true;
       }
@@ -1498,17 +1619,21 @@ this request. Check wms/ows_enable_reque
 
     if (map->projection.numargs <= 0) {
       if (nVersion >= OWS_1_3_0) {
-        msSetError(MS_WMSERR, "Cannot set new CRS on a map that doesn't "
+        msSetError(MS_WMSERR,
+                   "Cannot set new CRS on a map that doesn't "
                    "have any projection set. Please make sure your mapfile "
                    "has a projection defined at the top level.",
                    "msWMSLoadGetMapParams()");
-        return msWMSException(map, nVersion, "InvalidCRS", wms_exception_format);
+        return msWMSException(map, nVersion, "InvalidCRS",
+                              wms_exception_format);
       } else {
-        msSetError(MS_WMSERR, "Cannot set new SRS on a map that doesn't "
+        msSetError(MS_WMSERR,
+                   "Cannot set new SRS on a map that doesn't "
                    "have any projection set. Please make sure your mapfile "
                    "has a projection defined at the top level.",
                    "msWMSLoadGetMapParams()");
-        return msWMSException(map, nVersion, "InvalidSRS", wms_exception_format);
+        return msWMSException(map, nVersion, "InvalidSRS",
+                              wms_exception_format);
       }
     }
 
@@ -1548,7 +1673,7 @@ this request. Check wms/ows_enable_reque
       return msWMSException(map, nVersion, NULL, wms_exception_format);
 
     nTmp = GetMapserverUnitUsingProj(&(map->projection));
-    if( nTmp != -1 ) {
+    if (nTmp != -1) {
       map->units = static_cast<MS_UNITS>(nTmp);
     }
   }
@@ -1561,18 +1686,21 @@ this request. Check wms/ows_enable_reque
     /*      if LAYERS parameter was not given, set all layers to off        */
     /* -------------------------------------------------------------------- */
     if (validlayers == 0) { /*no LAYERS parameter is give*/
-      for(int j=0; j<map->numlayers; j++) {
+      for (int j = 0; j < map->numlayers; j++) {
         if (GET_LAYER(map, j)->status != MS_DEFAULT)
           GET_LAYER(map, j)->status = MS_OFF;
       }
     }
 
-    /*apply sld if defined. This is done here so that bbox and srs are already applied*/
+    /*apply sld if defined. This is done here so that bbox and srs are already
+     * applied*/
     if (sld_url) {
-      if ((status = msSLDApplySLDURL(map, sld_url, -1, NULL, &pszLayerNames)) != MS_SUCCESS)
+      if ((status = msSLDApplySLDURL(map, sld_url, -1, NULL, &pszLayerNames)) !=
+          MS_SUCCESS)
         return msWMSException(map, nVersion, NULL, wms_exception_format);
     } else if (sld_body) {
-      if ((status =msSLDApplySLD(map, sld_body, -1, NULL, &pszLayerNames)) != MS_SUCCESS)
+      if ((status = msSLDApplySLD(map, sld_body, -1, NULL, &pszLayerNames)) !=
+          MS_SUCCESS)
         return msWMSException(map, nVersion, NULL, wms_exception_format);
     }
     /* -------------------------------------------------------------------- */
@@ -1595,22 +1723,24 @@ this request. Check wms/ows_enable_reque
     if (validlayers == 0) {
       if (pszLayerNames) {
         const auto tokens = msStringSplit(pszLayerNames, ',');
-        for (const auto& token: tokens) {
-            for (int j=0; j<map->numlayers; j++) {
-              if ( ((GET_LAYER(map, j)->name &&
-                     strcasecmp(GET_LAYER(map, j)->name, token.c_str()) == 0) ||
-                    (map->name && strcasecmp(map->name, token.c_str()) == 0) ||
-                    (GET_LAYER(map, j)->group && strcasecmp(GET_LAYER(map, j)->group, token.c_str()) == 0)) &&
-                   ((msIntegerInArray(GET_LAYER(map, j)->index, ows_request->enabled_layers, ows_request->numlayers))) ) {
-                if (GET_LAYER(map, j)->status != MS_DEFAULT)
-                  GET_LAYER(map, j)->status = MS_ON;
-              }
+        for (const auto &token : tokens) {
+          for (int j = 0; j < map->numlayers; j++) {
+            if (((GET_LAYER(map, j)->name &&
+                  strcasecmp(GET_LAYER(map, j)->name, token.c_str()) == 0) ||
+                 (map->name && strcasecmp(map->name, token.c_str()) == 0) ||
+                 (GET_LAYER(map, j)->group &&
+                  strcasecmp(GET_LAYER(map, j)->group, token.c_str()) == 0)) &&
+                ((msIntegerInArray(GET_LAYER(map, j)->index,
+                                   ows_request->enabled_layers,
+                                   ows_request->numlayers)))) {
+              if (GET_LAYER(map, j)->status != MS_DEFAULT)
+                GET_LAYER(map, j)->status = MS_ON;
             }
+          }
         }
       }
     }
     msFree(pszLayerNames);
-
   }
 
   /* Validate Styles :
@@ -1620,55 +1750,61 @@ this request. Check wms/ows_enable_reque
   ** we could have ...&STYLES=,,,. If that is not the
   ** case, we generate an exception.
   */
-  if(styles && strlen(styles) > 0) {
+  if (styles && strlen(styles) > 0) {
     bool hasCheckedLayerUnicity = false;
-    int n=0;
+    int n = 0;
     int layerCopyIndex;
 
-    char** tokens = msStringSplitComplex(styles, ",",&n,MS_ALLOWEMPTYTOKENS);
-    for (int i=0; i<n; i++) {
+    char **tokens = msStringSplitComplex(styles, ",", &n, MS_ALLOWEMPTYTOKENS);
+    for (int i = 0; i < n; i++) {
       if (tokens[i] && strlen(tokens[i]) > 0 &&
-          strcasecmp(tokens[i],"default") != 0) {
+          strcasecmp(tokens[i], "default") != 0) {
         if (!hasCheckedLayerUnicity) {
           hasCheckedLayerUnicity = true;
           bool bLayerInserted = false;
 
-          /* -------------------------------------------------------------------- */
-          /*      If the same layer is given more that once, we need to           */
-          /*      duplicate it.                                                   */
-          /* -------------------------------------------------------------------- */
-          for (size_t m=0; m<wmslayers.size(); m++) {
-              for (size_t l=m+1; l<wmslayers.size(); l++) {
-                const int nIndex = msGetLayerIndex(map, wmslayers[m].c_str());
-                if (nIndex != -1 &&
-                    strcasecmp(wmslayers[m].c_str(), wmslayers[l].c_str())== 0) {
-                  layerObj* psTmpLayer = (layerObj *) malloc(sizeof(layerObj));
-                  initLayer(psTmpLayer, map);
-                  msCopyLayer(psTmpLayer, GET_LAYER(map,nIndex));
-                  /* open the source layer */
-                  if ( !psTmpLayer->vtable)
-                    msInitializeVirtualTable(psTmpLayer);
-
-                  /*make the name unique*/
-                  char tmpId[128];
-                  snprintf(tmpId, sizeof(tmpId), "%lx_%x_%d",(long)time(NULL),(int)getpid(),
-                           map->numlayers);
-                  if (psTmpLayer->name)
-                    msFree(psTmpLayer->name);
-                  psTmpLayer->name = msStrdup(tmpId);
-                  wmslayers[l] = tmpId;
-
-                  layerCopyIndex = msInsertLayer(map, psTmpLayer, -1);
-
-                  // expand the array mapping map layer index to filter indexes
-                  ows_request->layerwmsfilterindex = (int*)msSmallRealloc(ows_request->layerwmsfilterindex, map->numlayers * sizeof(int));
-                  ows_request->layerwmsfilterindex[layerCopyIndex] = l; // the filter index matches the index of the layer name in the WMS param
-
-                  bLayerInserted = true;
-                  /* layer was copied, we need to decrement its refcount */
-                  MS_REFCNT_DECR(psTmpLayer);
-                }
+          /* --------------------------------------------------------------------
+           */
+          /*      If the same layer is given more that once, we need to */
+          /*      duplicate it. */
+          /* --------------------------------------------------------------------
+           */
+          for (size_t m = 0; m < wmslayers.size(); m++) {
+            for (size_t l = m + 1; l < wmslayers.size(); l++) {
+              const int nIndex = msGetLayerIndex(map, wmslayers[m].c_str());
+              if (nIndex != -1 &&
+                  strcasecmp(wmslayers[m].c_str(), wmslayers[l].c_str()) == 0) {
+                layerObj *psTmpLayer = (layerObj *)malloc(sizeof(layerObj));
+                initLayer(psTmpLayer, map);
+                msCopyLayer(psTmpLayer, GET_LAYER(map, nIndex));
+                /* open the source layer */
+                if (!psTmpLayer->vtable)
+                  msInitializeVirtualTable(psTmpLayer);
+
+                /*make the name unique*/
+                char tmpId[128];
+                snprintf(tmpId, sizeof(tmpId), "%lx_%x_%d", (long)time(NULL),
+                         (int)getpid(), map->numlayers);
+                if (psTmpLayer->name)
+                  msFree(psTmpLayer->name);
+                psTmpLayer->name = msStrdup(tmpId);
+                wmslayers[l] = tmpId;
+
+                layerCopyIndex = msInsertLayer(map, psTmpLayer, -1);
+
+                // expand the array mapping map layer index to filter indexes
+                ows_request->layerwmsfilterindex =
+                    (int *)msSmallRealloc(ows_request->layerwmsfilterindex,
+                                          map->numlayers * sizeof(int));
+                ows_request->layerwmsfilterindex[layerCopyIndex] =
+                    l; // the filter index matches the index of the layer name
+                       // in the WMS param
+
+                bLayerInserted = true;
+                /* layer was copied, we need to decrement its refcount */
+                MS_REFCNT_DECR(psTmpLayer);
               }
+            }
           }
 
           if (bLayerInserted) {
@@ -1677,16 +1813,17 @@ this request. Check wms/ows_enable_reque
         }
 
         if (static_cast<int>(wmslayers.size()) == n) {
-          for (int j=0; j<map->numlayers; j++) {
-            layerObj* lp = GET_LAYER(map, j);
-            if ((lp->name &&
-                 strcasecmp(lp->name, wmslayers[i].c_str()) == 0) ||
-                (lp->group && strcasecmp(lp->group, wmslayers[i].c_str()) == 0)) {
+          for (int j = 0; j < map->numlayers; j++) {
+            layerObj *lp = GET_LAYER(map, j);
+            if ((lp->name && strcasecmp(lp->name, wmslayers[i].c_str()) == 0) ||
+                (lp->group &&
+                 strcasecmp(lp->group, wmslayers[i].c_str()) == 0)) {
               bool found = false;
-              for (int k=0; k<lp->numclasses; k++) {
-                if (lp->_class[k]->group && strcasecmp(lp->_class[k]->group, tokens[i]) == 0) {
+              for (int k = 0; k < lp->numclasses; k++) {
+                if (lp->_class[k]->group &&
+                    strcasecmp(lp->_class[k]->group, tokens[i]) == 0) {
                   msFree(lp->classgroup);
-                  lp->classgroup = msStrdup( tokens[i]);
+                  lp->classgroup = msStrdup(tokens[i]);
                   found = true;
                   break;
                 }
@@ -1696,31 +1833,38 @@ this request. Check wms/ows_enable_reque
                            "msWMSLoadGetMapParams()", tokens[i]);
                 msFreeCharArray(tokens, n);
 
-                return msWMSException(map, nVersion, "StyleNotDefined", wms_exception_format);
+                return msWMSException(map, nVersion, "StyleNotDefined",
+                                      wms_exception_format);
               }
-            /* Check the style of the root layer */
-            } else if (map->name && strcasecmp(map->name, wmslayers[i].c_str()) == 0) {
-                const char* styleName = msOWSLookupMetadata(&(map->web.metadata), "MO", "style_name");
-                if (styleName == NULL)
-                  styleName = "default";
-                char* pszEncodedStyleName = msEncodeHTMLEntities(styleName);
-                if (strcasecmp(pszEncodedStyleName, tokens[i]) != 0) {
-                    msSetError(MS_WMSERR, "Style (%s) not defined on root layer.",
-                               "msWMSLoadGetMapParams()", tokens[i]);
-                    msFreeCharArray(tokens, n);
-                    msFree(pszEncodedStyleName);
-
-                    return msWMSException(map, nVersion, "StyleNotDefined", wms_exception_format);
-                }
+              /* Check the style of the root layer */
+            } else if (map->name &&
+                       strcasecmp(map->name, wmslayers[i].c_str()) == 0) {
+              const char *styleName =
+                  msOWSLookupMetadata(&(map->web.metadata), "MO", "style_name");
+              if (styleName == NULL)
+                styleName = "default";
+              char *pszEncodedStyleName = msEncodeHTMLEntities(styleName);
+              if (strcasecmp(pszEncodedStyleName, tokens[i]) != 0) {
+                msSetError(MS_WMSERR, "Style (%s) not defined on root layer.",
+                           "msWMSLoadGetMapParams()", tokens[i]);
+                msFreeCharArray(tokens, n);
                 msFree(pszEncodedStyleName);
-            }
 
+                return msWMSException(map, nVersion, "StyleNotDefined",
+                                      wms_exception_format);
+              }
+              msFree(pszEncodedStyleName);
+            }
           }
         } else {
-          msSetError(MS_WMSERR, "Invalid style (%s). Mapserver is expecting an empty string for the STYLES : STYLES= or STYLES=,,, or using keyword default  STYLES=default,default, ...",
+          msSetError(MS_WMSERR,
+                     "Invalid style (%s). Mapserver is expecting an empty "
+                     "string for the STYLES : STYLES= or STYLES=,,, or using "
+                     "keyword default  STYLES=default,default, ...",
                      "msWMSLoadGetMapParams()", styles);
           msFreeCharArray(tokens, n);
-          return msWMSException(map, nVersion, "StyleNotDefined", wms_exception_format);
+          return msWMSException(map, nVersion, "StyleNotDefined",
+                                wms_exception_format);
         }
       }
     }
@@ -1733,46 +1877,59 @@ this request. Check wms/ows_enable_reque
   ** in by half a pixel.  We wait till here because we want to ensure we
   ** are doing this in terms of the correct WIDTH and HEIGHT.
   */
-  if( adjust_extent && map->width>1 && map->height>1 && !bbox_pixel_is_point) {
-    double  dx, dy;
+  if (adjust_extent && map->width > 1 && map->height > 1 &&
+      !bbox_pixel_is_point) {
+    double dx, dy;
 
     dx = (map->extent.maxx - map->extent.minx) / map->width;
-    map->extent.minx += dx*0.5;
-    map->extent.maxx -= dx*0.5;
+    map->extent.minx += dx * 0.5;
+    map->extent.maxx -= dx * 0.5;
 
     dy = (map->extent.maxy - map->extent.miny) / map->height;
-    map->extent.miny += dy*0.5;
-    map->extent.maxy -= dy*0.5;
+    map->extent.miny += dy * 0.5;
+    map->extent.maxy -= dy * 0.5;
   }
 
   if (request && strcasecmp(request, "DescribeLayer") != 0) {
     if (!srsfound) {
-      if ( nVersion >= OWS_1_3_0)
-        msSetError(MS_WMSERR, "Missing required parameter CRS", "msWMSLoadGetMapParams()");
+      if (nVersion >= OWS_1_3_0)
+        msSetError(MS_WMSERR, "Missing required parameter CRS",
+                   "msWMSLoadGetMapParams()");
       else
-        msSetError(MS_WMSERR, "Missing required parameter SRS", "msWMSLoadGetMapParams()");
+        msSetError(MS_WMSERR, "Missing required parameter SRS",
+                   "msWMSLoadGetMapParams()");
 
-      return msWMSException(map, nVersion, "MissingParameterValue", wms_exception_format);
+      return msWMSException(map, nVersion, "MissingParameterValue",
+                            wms_exception_format);
     }
 
     if (!bboxfound) {
-      msSetError(MS_WMSERR, "Missing required parameter BBOX", "msWMSLoadGetMapParams()");
-      return msWMSException(map, nVersion, "MissingParameterValue", wms_exception_format);
+      msSetError(MS_WMSERR, "Missing required parameter BBOX",
+                 "msWMSLoadGetMapParams()");
+      return msWMSException(map, nVersion, "MissingParameterValue",
+                            wms_exception_format);
     }
 
-    if (!formatfound && (strcasecmp(request, "GetMap") == 0 || strcasecmp(request, "map") == 0)) {
-      msSetError(MS_WMSERR, "Missing required parameter FORMAT", "msWMSLoadGetMapParams()");
-      return msWMSException(map, nVersion, "MissingParameterValue", wms_exception_format);
+    if (!formatfound && (strcasecmp(request, "GetMap") == 0 ||
+                         strcasecmp(request, "map") == 0)) {
+      msSetError(MS_WMSERR, "Missing required parameter FORMAT",
+                 "msWMSLoadGetMapParams()");
+      return msWMSException(map, nVersion, "MissingParameterValue",
+                            wms_exception_format);
     }
 
     if (!widthfound) {
-      msSetError(MS_WMSERR, "Missing required parameter WIDTH", "msWMSLoadGetMapParams()");
-      return msWMSException(map, nVersion, "MissingParameterValue", wms_exception_format);
+      msSetError(MS_WMSERR, "Missing required parameter WIDTH",
+                 "msWMSLoadGetMapParams()");
+      return msWMSException(map, nVersion, "MissingParameterValue",
+                            wms_exception_format);
     }
 
     if (!heightfound) {
-      msSetError(MS_WMSERR, "Missing required parameter HEIGHT", "msWMSLoadGetMapParams()");
-      return msWMSException(map, nVersion, "MissingParameterValue", wms_exception_format);
+      msSetError(MS_WMSERR, "Missing required parameter HEIGHT",
+                 "msWMSLoadGetMapParams()");
+      return msWMSException(map, nVersion, "MissingParameterValue",
+                            wms_exception_format);
     }
 
     if (styles == nullptr && sld_url == nullptr && sld_body == nullptr &&
@@ -1780,12 +1937,16 @@ this request. Check wms/ows_enable_reque
          strcasecmp(request, "GetFeatureInfo") == 0) &&
         msOWSLookupMetadata(&(map->web.metadata), "M",
                             "allow_getmap_without_styles") == nullptr) {
-      msSetError(MS_WMSERR,
-                 "Missing required parameter STYLES. Note to service administrators: "
-                 "defining the \"wms_allow_getmap_without_styles\" \"true\" MAP.WEB.METADATA "
-                 "item will disable this check (backward compatibility with behaviour "
-                 "of MapServer < 8.0)", "msWMSLoadGetMapParams()");
-      return msWMSException(map, nVersion, "MissingParameterValue", wms_exception_format);
+      msSetError(
+          MS_WMSERR,
+          "Missing required parameter STYLES. Note to service administrators: "
+          "defining the \"wms_allow_getmap_without_styles\" \"true\" "
+          "MAP.WEB.METADATA "
+          "item will disable this check (backward compatibility with behaviour "
+          "of MapServer < 8.0)",
+          "msWMSLoadGetMapParams()");
+      return msWMSException(map, nVersion, "MissingParameterValue",
+                            wms_exception_format);
     }
   }
 
@@ -1795,13 +1956,16 @@ this request. Check wms/ows_enable_reque
   if (filter) {
     if (sld_url || sld_body) {
       msSetError(MS_WMSERR,
-                 "Vendor-specific FILTER parameter cannot be used with SLD or SLD_BODY.",
+                 "Vendor-specific FILTER parameter cannot be used with SLD or "
+                 "SLD_BODY.",
                  "msWMSLoadGetMapParams()");
       return msWMSException(map, nVersion, NULL, wms_exception_format);
     }
 
-    if (msWMSApplyFilter(map, nVersion, filter, need_axis_swap, wms_exception_format, ows_request) == MS_FAILURE) {
-      return MS_FAILURE;/* msWMSException(map, nVersion, "InvalidFilterRequest"); */
+    if (msWMSApplyFilter(map, nVersion, filter, need_axis_swap,
+                         wms_exception_format, ows_request) == MS_FAILURE) {
+      return MS_FAILURE; /* msWMSException(map, nVersion,
+                            "InvalidFilterRequest"); */
     }
   }
 
@@ -1812,20 +1976,20 @@ this request. Check wms/ows_enable_reque
 **
 */
 static void msWMSPrintRequestCap(int nVersion, const char *request,
-                                 const char *script_url, const char *formats, ...)
-{
+                                 const char *script_url, const char *formats,
+                                 ...) {
   va_list argp;
 
   msIO_printf("    <%s>\n", request);
 
   /* We expect to receive a NULL-terminated args list of formats */
   va_start(argp, formats);
-  const char* fmt = formats;
-  while(fmt != NULL) {
+  const char *fmt = formats;
+  while (fmt != NULL) {
     /* Special case for early WMS with subelements in Format (bug 908) */
     char *encoded;
-    if( nVersion <= OWS_1_0_7 ) {
-      encoded = msStrdup( fmt );
+    if (nVersion <= OWS_1_0_7) {
+      encoded = msStrdup(fmt);
     }
 
     /* otherwise we HTML code special characters */
@@ -1847,8 +2011,14 @@ static void msWMSPrintRequestCap(int nVe
     msIO_printf("          <Get onlineResource=\"%s\" />\n", script_url);
     msIO_printf("          <Post onlineResource=\"%s\" />\n", script_url);
   } else {
-    msIO_printf("          <Get><OnlineResource xmlns:xlink=\"http://www.w3.org/1999/xlink\" xlink:href=\"%s\"/></Get>\n", script_url);
-    msIO_printf("          <Post><OnlineResource xmlns:xlink=\"http://www.w3.org/1999/xlink\" xlink:href=\"%s\"/></Post>\n", script_url);
+    msIO_printf("          <Get><OnlineResource "
+                "xmlns:xlink=\"http://www.w3.org/1999/xlink\" "
+                "xlink:href=\"%s\"/></Get>\n",
+                script_url);
+    msIO_printf("          <Post><OnlineResource "
+                "xmlns:xlink=\"http://www.w3.org/1999/xlink\" "
+                "xlink:href=\"%s\"/></Post>\n",
+                script_url);
   }
 
   msIO_printf("        </HTTP>\n");
@@ -1856,57 +2026,53 @@ static void msWMSPrintRequestCap(int nVe
   msIO_printf("    </%s>\n", request);
 }
 
-
-
 void msWMSPrintAttribution(FILE *stream, const char *tabspace,
                            hashTableObj *metadata,
-                           const char * /*namespaces*/)
-{
+                           const char * /*namespaces*/) {
   if (stream && metadata) {
-    const char* title = msOWSLookupMetadata(metadata, "MO",
-                                "attribution_title");
-    const char* onlineres = msOWSLookupMetadata(metadata, "MO",
-                                    "attribution_onlineresource");
-    const char* logourl = msOWSLookupMetadata(metadata, "MO",
-                                  "attribution_logourl_width");
+    const char *title =
+        msOWSLookupMetadata(metadata, "MO", "attribution_title");
+    const char *onlineres =
+        msOWSLookupMetadata(metadata, "MO", "attribution_onlineresource");
+    const char *logourl =
+        msOWSLookupMetadata(metadata, "MO", "attribution_logourl_width");
 
     if (title || onlineres || logourl) {
-      msIO_printf("%s<Attribution>\n",tabspace);
+      msIO_printf("%s<Attribution>\n", tabspace);
       if (title) {
-        char* pszEncodedValue = msEncodeHTMLEntities(title);
-        msIO_fprintf(stream, "%s%s<Title>%s</Title>\n", tabspace,
-                     tabspace, pszEncodedValue);
+        char *pszEncodedValue = msEncodeHTMLEntities(title);
+        msIO_fprintf(stream, "%s%s<Title>%s</Title>\n", tabspace, tabspace,
+                     pszEncodedValue);
         free(pszEncodedValue);
       }
 
       if (onlineres) {
-        char* pszEncodedValue = msEncodeHTMLEntities(onlineres);
-        msIO_fprintf(stream, "%s%s<OnlineResource xmlns:xlink=\"http://www.w3.org/1999/xlink\" xlink:href=\"%s\"/>\n", tabspace, tabspace,
-                     pszEncodedValue);
+        char *pszEncodedValue = msEncodeHTMLEntities(onlineres);
+        msIO_fprintf(
+            stream,
+            "%s%s<OnlineResource xmlns:xlink=\"http://www.w3.org/1999/xlink\" "
+            "xlink:href=\"%s\"/>\n",
+            tabspace, tabspace, pszEncodedValue);
         free(pszEncodedValue);
       }
 
       if (logourl) {
-        msOWSPrintURLType(stream, metadata, "MO","attribution_logourl",
-                          OWS_NOERR, NULL, "LogoURL", NULL,
-                          " width=\"%s\"", " height=\"%s\"",
+        msOWSPrintURLType(stream, metadata, "MO", "attribution_logourl",
+                          OWS_NOERR, NULL, "LogoURL", NULL, " width=\"%s\"",
+                          " height=\"%s\"",
                           ">\n             <Format>%s</Format",
                           "\n             <OnlineResource "
                           "xmlns:xlink=\"http://www.w3.org/1999/xlink\""
                           " xlink:type=\"simple\" xlink:href=\"%s\"/>\n"
                           "          ",
-                          MS_FALSE, MS_TRUE, MS_TRUE, MS_TRUE, MS_TRUE,
-                          NULL, NULL, NULL, NULL, NULL, "        ");
-
-
+                          MS_FALSE, MS_TRUE, MS_TRUE, MS_TRUE, MS_TRUE, NULL,
+                          NULL, NULL, NULL, NULL, "        ");
       }
       msIO_printf("%s</Attribution>\n", tabspace);
-
     }
   }
 }
 
-
 /*
 ** msWMSPrintScaleHint()
 **
@@ -1914,19 +2080,16 @@ void msWMSPrintAttribution(FILE *stream,
 ** used for WMS >=1.3.0
 */
 void msWMSPrintScaleDenominator(const char *tabspace, double minscaledenom,
-                                double maxscaledenom)
-{
+                                double maxscaledenom) {
   if (minscaledenom > 0)
-    msIO_printf("%s<MinScaleDenominator>%g</MinScaleDenominator>\n",
-                tabspace, minscaledenom);
+    msIO_printf("%s<MinScaleDenominator>%g</MinScaleDenominator>\n", tabspace,
+                minscaledenom);
 
   if (maxscaledenom > 0)
-    msIO_printf("%s<MaxScaleDenominator>%g</MaxScaleDenominator>\n",
-                tabspace, maxscaledenom);
+    msIO_printf("%s<MaxScaleDenominator>%g</MaxScaleDenominator>\n", tabspace,
+                maxscaledenom);
 }
 
-
-
 /*
 ** msWMSPrintScaleHint()
 **
@@ -1938,22 +2101,24 @@ void msWMSPrintScaleDenominator(const ch
 ** recommended values of that diagonal.
 */
 void msWMSPrintScaleHint(const char *tabspace, double minscaledenom,
-                         double maxscaledenom, double resolution)
-{
-  double scalehintmin=0.0, scalehintmax=0.0;
+                         double maxscaledenom, double resolution) {
+  double scalehintmin = 0.0, scalehintmax = 0.0;
 
   const double diag = sqrt(2.0);
 
   if (minscaledenom > 0)
-    scalehintmin = diag*(minscaledenom/resolution)/msInchesPerUnit(MS_METERS,0);
+    scalehintmin =
+        diag * (minscaledenom / resolution) / msInchesPerUnit(MS_METERS, 0);
   if (maxscaledenom > 0)
-    scalehintmax = diag*(maxscaledenom/resolution)/msInchesPerUnit(MS_METERS,0);
+    scalehintmax =
+        diag * (maxscaledenom / resolution) / msInchesPerUnit(MS_METERS, 0);
 
   if (scalehintmin > 0.0 || scalehintmax > 0.0) {
-    msIO_printf("%s<ScaleHint min=\"%.15g\" max=\"%.15g\" />\n",
-                tabspace, scalehintmin, scalehintmax);
+    msIO_printf("%s<ScaleHint min=\"%.15g\" max=\"%.15g\" />\n", tabspace,
+                scalehintmin, scalehintmax);
     if (scalehintmax == 0.0)
-      msIO_printf("%s<!-- WARNING: Only MINSCALEDENOM and no MAXSCALEDENOM specified in "
+      msIO_printf("%s<!-- WARNING: Only MINSCALEDENOM and no MAXSCALEDENOM "
+                  "specified in "
                   "the mapfile. A default value of 0 has been returned for the "
                   "Max ScaleHint but this is probably not what you want. -->\n",
                   tabspace);
@@ -1966,25 +2131,32 @@ void msWMSPrintScaleHint(const char *tab
 ** Print an AuthorityURL tag if applicable.
 */
 void msWMSPrintAuthorityURL(FILE *stream, const char *tabspace,
-                            hashTableObj *metadata, const char *namespaces)
-{
+                            hashTableObj *metadata, const char *namespaces) {
   if (stream && metadata) {
-    const char* pszWmsAuthorityName = msOWSLookupMetadata(metadata, namespaces, "authorityurl_name");
-    const char* pszWMSAuthorityHref = msOWSLookupMetadata(metadata, namespaces, "authorityurl_href");
+    const char *pszWmsAuthorityName =
+        msOWSLookupMetadata(metadata, namespaces, "authorityurl_name");
+    const char *pszWMSAuthorityHref =
+        msOWSLookupMetadata(metadata, namespaces, "authorityurl_href");
 
     /* AuthorityURL only makes sense if you have *both* the name and url */
-    if( pszWmsAuthorityName && pszWMSAuthorityHref ) {
-      msOWSPrintEncodeMetadata(stream, metadata, namespaces, "authorityurl_name",
-                               OWS_NOERR,
-                               (std::string(tabspace) + "<AuthorityURL name=\"%s\">\n").c_str(),
-                               NULL);
-      msOWSPrintEncodeMetadata(stream, metadata, namespaces, "authorityurl_href",
-                               OWS_NOERR,
-                               (std::string(tabspace) + "  <OnlineResource xmlns:xlink=\"http://www.w3.org/1999/xlink\" xlink:href=\"%s\"/>\n").c_str(),
-                               NULL);
+    if (pszWmsAuthorityName && pszWMSAuthorityHref) {
+      msOWSPrintEncodeMetadata(
+          stream, metadata, namespaces, "authorityurl_name", OWS_NOERR,
+          (std::string(tabspace) + "<AuthorityURL name=\"%s\">\n").c_str(),
+          NULL);
+      msOWSPrintEncodeMetadata(
+          stream, metadata, namespaces, "authorityurl_href", OWS_NOERR,
+          (std::string(tabspace) +
+           "  <OnlineResource xmlns:xlink=\"http://www.w3.org/1999/xlink\" "
+           "xlink:href=\"%s\"/>\n")
+              .c_str(),
+          NULL);
       msIO_printf("%s</AuthorityURL>\n", tabspace);
-    } else if ( pszWmsAuthorityName || pszWMSAuthorityHref ) {
-      msIO_printf("%s<!-- WARNING: Both wms_authorityurl_name and wms_authorityurl_href must be set to output an AuthorityURL -->\n", tabspace);
+    } else if (pszWmsAuthorityName || pszWMSAuthorityHref) {
+      msIO_printf(
+          "%s<!-- WARNING: Both wms_authorityurl_name and "
+          "wms_authorityurl_href must be set to output an AuthorityURL -->\n",
+          tabspace);
     }
   }
 }
@@ -1995,23 +2167,26 @@ void msWMSPrintAuthorityURL(FILE *stream
 ** Print an Identifier tag if applicable.
 */
 void msWMSPrintIdentifier(FILE *stream, const char *tabspace,
-                          hashTableObj *metadata, const char *namespaces)
-{
+                          hashTableObj *metadata, const char *namespaces) {
   if (stream && metadata) {
-    const char* pszWMSIdentifierAuthority = msOWSLookupMetadata(metadata, namespaces, "identifier_authority");
-    const char* pszWMSIdentifierValue = msOWSLookupMetadata(metadata, namespaces, "identifier_value");
+    const char *pszWMSIdentifierAuthority =
+        msOWSLookupMetadata(metadata, namespaces, "identifier_authority");
+    const char *pszWMSIdentifierValue =
+        msOWSLookupMetadata(metadata, namespaces, "identifier_value");
 
     /* Identifier only makes sense if you have *both* the authority and value */
-    if( pszWMSIdentifierAuthority && pszWMSIdentifierValue ) {
-      msOWSPrintEncodeMetadata(stream, metadata, namespaces, "identifier_authority",
-                               OWS_NOERR,
-                               (std::string(tabspace) + "<Identifier authority=\"%s\">").c_str(),
-                               NULL);
+    if (pszWMSIdentifierAuthority && pszWMSIdentifierValue) {
+      msOWSPrintEncodeMetadata(
+          stream, metadata, namespaces, "identifier_authority", OWS_NOERR,
+          (std::string(tabspace) + "<Identifier authority=\"%s\">").c_str(),
+          NULL);
       msOWSPrintEncodeMetadata(stream, metadata, namespaces, "identifier_value",
-                               OWS_NOERR, "%s</Identifier>\n",
-                               NULL);
-    } else if ( pszWMSIdentifierAuthority || pszWMSIdentifierValue ) {
-      msIO_printf("%s<!-- WARNING: Both wms_identifier_authority and wms_identifier_value must be set to output an Identifier -->\n", tabspace);
+                               OWS_NOERR, "%s</Identifier>\n", NULL);
+    } else if (pszWMSIdentifierAuthority || pszWMSIdentifierValue) {
+      msIO_printf(
+          "%s<!-- WARNING: Both wms_identifier_authority and "
+          "wms_identifier_value must be set to output an Identifier -->\n",
+          tabspace);
     }
   }
 }
@@ -2021,10 +2196,9 @@ void msWMSPrintIdentifier(FILE *stream,
 **
 ** Print a Keywordlist tag if applicable.
 */
-void msWMSPrintKeywordlist(FILE *stream, const char *tabspace,
-                           const char *name, hashTableObj *metadata,
-                           const char *namespaces, int nVersion)
-{
+void msWMSPrintKeywordlist(FILE *stream, const char *tabspace, const char *name,
+                           hashTableObj *metadata, const char *namespaces,
+                           int nVersion) {
   std::string newname(name); /* max. rootlayer_keywordlist_items          */
   newname += "_items";
 
@@ -2033,38 +2207,38 @@ void msWMSPrintKeywordlist(FILE *stream,
 
   if (nVersion == OWS_1_0_0) {
     /* <Keywords> in V 1.0.0 */
-    /* The 1.0.0 spec doesn't specify which delimiter to use so let's use spaces */
-    msOWSPrintEncodeMetadataList(stream, metadata, namespaces,
-                                 name,
-                                 (std::string(tabspace) + "<Keywords>").c_str(),
-                                 (std::string(tabspace) + "</Keywords>\n").c_str(),
-                                 "%s ", NULL);
-  } else if ( msOWSLookupMetadata(metadata, namespaces, name) ||
-              msOWSLookupMetadata(metadata, namespaces, newname.c_str()) ||
-              msOWSLookupMetadata(metadata, namespaces, vocname.c_str()) ) {
+    /* The 1.0.0 spec doesn't specify which delimiter to use so let's use spaces
+     */
+    msOWSPrintEncodeMetadataList(
+        stream, metadata, namespaces, name,
+        (std::string(tabspace) + "<Keywords>").c_str(),
+        (std::string(tabspace) + "</Keywords>\n").c_str(), "%s ", NULL);
+  } else if (msOWSLookupMetadata(metadata, namespaces, name) ||
+             msOWSLookupMetadata(metadata, namespaces, newname.c_str()) ||
+             msOWSLookupMetadata(metadata, namespaces, vocname.c_str())) {
     /* <KeywordList><Keyword> ... in V1.0.6+ */
     msIO_printf("%s<KeywordList>\n", tabspace);
     std::string template1(tabspace);
     template1 += "    <Keyword>%s</Keyword>\n";
     /* print old styled ..._keywordlist */
-    msOWSPrintEncodeMetadataList(stream, metadata, namespaces,
-                                 name, NULL, NULL,
+    msOWSPrintEncodeMetadataList(stream, metadata, namespaces, name, NULL, NULL,
                                  template1.c_str(), NULL);
     /* print new styled ..._keywordlist_items */
-    msOWSPrintEncodeMetadataList(stream, metadata, namespaces,
-                                 newname.c_str(), NULL, NULL,
-                                 template1.c_str(), NULL);
+    msOWSPrintEncodeMetadataList(stream, metadata, namespaces, newname.c_str(),
+                                 NULL, NULL, template1.c_str(), NULL);
 
     /* find out if there's a vocabulary list set */
-    const char* vocabularylist = msOWSLookupMetadata(metadata, namespaces, vocname.c_str());
-    if ( vocabularylist && nVersion >= OWS_1_3_0 ) {
+    const char *vocabularylist =
+        msOWSLookupMetadata(metadata, namespaces, vocname.c_str());
+    if (vocabularylist && nVersion >= OWS_1_3_0) {
       const auto tokens = msStringSplit(vocabularylist, ',');
-      for (const auto& token: tokens) {
-          msOWSPrintEncodeMetadataList(
+      for (const auto &token : tokens) {
+        msOWSPrintEncodeMetadataList(
             stream, metadata, namespaces,
-            (std::string(name) + '_' + token + "_items").c_str(),
-            NULL, NULL,
-            (std::string(tabspace) + "    <Keyword vocabulary=\"" + token + "\">%s</Keyword>\n").c_str(),
+            (std::string(name) + '_' + token + "_items").c_str(), NULL, NULL,
+            (std::string(tabspace) + "    <Keyword vocabulary=\"" + token +
+             "\">%s</Keyword>\n")
+                .c_str(),
             NULL);
       }
     }
@@ -2075,106 +2249,118 @@ void msWMSPrintKeywordlist(FILE *stream,
 /*
 ** msDumpLayer()
 */
-static
-int msDumpLayer(mapObj *map, layerObj *lp, int nVersion,
-                const char *script_url_encoded, const char *indent,
-                const char *validated_language, int grouplayer,
-                int hasQueryableSubLayers)
-{
+static int msDumpLayer(mapObj *map, layerObj *lp, int nVersion,
+                       const char *script_url_encoded, const char *indent,
+                       const char *validated_language, int grouplayer,
+                       int hasQueryableSubLayers) {
   rectObj ext;
   char **classgroups = NULL;
-  int iclassgroups=0;
-  char *pszMapEPSG,*pszLayerEPSG;
+  int iclassgroups = 0;
+  char *pszMapEPSG, *pszLayerEPSG;
 
   /* if the layer status is set to MS_DEFAULT, output a warning */
   if (lp->status == MS_DEFAULT)
-    msIO_fprintf(stdout, "<!-- WARNING: This layer has its status set to DEFAULT and will always be displayed when doing a GetMap request even if it is not requested by the client. This is not in line with the expected behavior of a WMS server. Using status ON or OFF is recommended. -->\n");
+    msIO_fprintf(stdout,
+                 "<!-- WARNING: This layer has its status set to DEFAULT and "
+                 "will always be displayed when doing a GetMap request even if "
+                 "it is not requested by the client. This is not in line with "
+                 "the expected behavior of a WMS server. Using status ON or "
+                 "OFF is recommended. -->\n");
 
   if (nVersion <= OWS_1_0_7) {
-    msIO_printf("%s    <Layer queryable=\"%d\">\n",
-                indent, hasQueryableSubLayers || msIsLayerQueryable(lp));
+    msIO_printf("%s    <Layer queryable=\"%d\">\n", indent,
+                hasQueryableSubLayers || msIsLayerQueryable(lp));
   } else {
     /* 1.1.0 and later: opaque and cascaded are new. */
-    int cascaded=0, opaque=0;
-    const char* value = msOWSLookupMetadata(&(lp->metadata), "MO", "opaque");
+    int cascaded = 0, opaque = 0;
+    const char *value = msOWSLookupMetadata(&(lp->metadata), "MO", "opaque");
     if (value != NULL)
       opaque = atoi(value);
     if (lp->connectiontype == MS_WMS)
       cascaded = 1;
 
-    msIO_printf("%s    <Layer queryable=\"%d\" opaque=\"%d\" cascaded=\"%d\">\n",
-                indent, hasQueryableSubLayers || msIsLayerQueryable(lp), opaque, cascaded);
+    msIO_printf(
+        "%s    <Layer queryable=\"%d\" opaque=\"%d\" cascaded=\"%d\">\n",
+        indent, hasQueryableSubLayers || msIsLayerQueryable(lp), opaque,
+        cascaded);
   }
 
   if (lp->name && strlen(lp->name) > 0 &&
       (msIsXMLTagValid(lp->name) == MS_FALSE || isdigit(lp->name[0])))
-    msIO_fprintf(stdout, "<!-- WARNING: The layer name '%s' might contain spaces or "
-                 "invalid characters or may start with a number. This could lead to potential problems. -->\n",
+    msIO_fprintf(stdout,
+                 "<!-- WARNING: The layer name '%s' might contain spaces or "
+                 "invalid characters or may start with a number. This could "
+                 "lead to potential problems. -->\n",
                  lp->name);
   msOWSPrintEncodeParam(stdout, "LAYER.NAME", lp->name, OWS_NOERR,
                         "        <Name>%s</Name>\n", NULL);
 
-  /* the majority of this section is dependent on appropriately named metadata in the LAYER object */
-  msOWSPrintEncodeMetadata2(stdout, &(lp->metadata), "MO", "title",
-                            OWS_WARN, "        <Title>%s</Title>\n", lp->name, validated_language);
+  /* the majority of this section is dependent on appropriately named metadata
+   * in the LAYER object */
+  msOWSPrintEncodeMetadata2(stdout, &(lp->metadata), "MO", "title", OWS_WARN,
+                            "        <Title>%s</Title>\n", lp->name,
+                            validated_language);
 
   msOWSPrintEncodeMetadata2(stdout, &(lp->metadata), "MO", "abstract",
-                            OWS_NOERR, "        <Abstract>%s</Abstract>\n", NULL, validated_language);
+                            OWS_NOERR, "        <Abstract>%s</Abstract>\n",
+                            NULL, validated_language);
 
-  msWMSPrintKeywordlist(stdout, "        ", "keywordlist", &(lp->metadata), "MO", nVersion);
+  msWMSPrintKeywordlist(stdout, "        ", "keywordlist", &(lp->metadata),
+                        "MO", nVersion);
 
-  msOWSGetEPSGProj(&(map->projection),&(map->web.metadata), "MO", MS_FALSE, &pszMapEPSG);
-  msOWSGetEPSGProj(&(lp->projection),&(lp->metadata), "MO", MS_FALSE, &pszLayerEPSG);
-  if(pszMapEPSG == NULL) {
+  msOWSGetEPSGProj(&(map->projection), &(map->web.metadata), "MO", MS_FALSE,
+                   &pszMapEPSG);
+  msOWSGetEPSGProj(&(lp->projection), &(lp->metadata), "MO", MS_FALSE,
+                   &pszLayerEPSG);
+  if (pszMapEPSG == NULL) {
     /* If map has no proj then every layer MUST have one or produce a warning */
     if (nVersion > OWS_1_1_0) {
       /* starting 1.1.1 SRS are given in individual tags */
       if (nVersion >= OWS_1_3_0) {
-        msOWSPrintEncodeParamList(stdout, "(at least one of) "
+        msOWSPrintEncodeParamList(stdout,
+                                  "(at least one of) "
                                   "MAP.PROJECTION, LAYER.PROJECTION "
                                   "or wms_srs metadata",
-                                  pszLayerEPSG,
-                                  OWS_WARN, ' ', NULL, NULL,
+                                  pszLayerEPSG, OWS_WARN, ' ', NULL, NULL,
                                   "        <CRS>%s</CRS>\n", NULL);
-      }
-      else {
-        msOWSPrintEncodeParamList(stdout, "(at least one of) "
+      } else {
+        msOWSPrintEncodeParamList(stdout,
+                                  "(at least one of) "
                                   "MAP.PROJECTION, LAYER.PROJECTION "
                                   "or wms_srs metadata",
-                                  pszLayerEPSG,
-                                  OWS_WARN, ' ', NULL, NULL,
+                                  pszLayerEPSG, OWS_WARN, ' ', NULL, NULL,
                                   "        <SRS>%s</SRS>\n", NULL);
       }
     } else {
-      msOWSPrintEncodeParam(stdout, "(at least one of) MAP.PROJECTION, "
+      msOWSPrintEncodeParam(stdout,
+                            "(at least one of) MAP.PROJECTION, "
                             "LAYER.PROJECTION or wms_srs metadata",
-                            pszLayerEPSG,
-                            OWS_WARN, "        <SRS>%s</SRS>\n", NULL);
+                            pszLayerEPSG, OWS_WARN, "        <SRS>%s</SRS>\n",
+                            NULL);
     }
   } else {
     /* No warning required in this case since there's at least a map proj. */
     if (nVersion > OWS_1_1_0) {
       /* starting 1.1.1 SRS are given in individual tags */
-      if (nVersion >=  OWS_1_3_0) {
-        msOWSPrintEncodeParamList(stdout, "(at least one of) "
+      if (nVersion >= OWS_1_3_0) {
+        msOWSPrintEncodeParamList(stdout,
+                                  "(at least one of) "
                                   "MAP.PROJECTION, LAYER.PROJECTION "
                                   "or wms_srs metadata",
-                                  pszLayerEPSG,
-                                  OWS_NOERR, ' ', NULL, NULL,
+                                  pszLayerEPSG, OWS_NOERR, ' ', NULL, NULL,
                                   "        <CRS>%s</CRS>\n", NULL);
       } else {
-        msOWSPrintEncodeParamList(stdout, "(at least one of) "
+        msOWSPrintEncodeParamList(stdout,
+                                  "(at least one of) "
                                   "MAP.PROJECTION, LAYER.PROJECTION "
                                   "or wms_srs metadata",
-                                  pszLayerEPSG,
-                                  OWS_NOERR, ' ', NULL, NULL,
+                                  pszLayerEPSG, OWS_NOERR, ' ', NULL, NULL,
                                   "        <SRS>%s</SRS>\n", NULL);
       }
     } else {
-      msOWSPrintEncodeParam(stdout,
-                            " LAYER.PROJECTION (or wms_srs metadata)",
-                            pszLayerEPSG,
-                            OWS_NOERR, "        <SRS>%s</SRS>\n", NULL);
+      msOWSPrintEncodeParam(stdout, " LAYER.PROJECTION (or wms_srs metadata)",
+                            pszLayerEPSG, OWS_NOERR, "        <SRS>%s</SRS>\n",
+                            NULL);
     }
   }
   msFree(pszLayerEPSG);
@@ -2182,7 +2368,7 @@ int msDumpLayer(mapObj *map, layerObj *l
 
   /* If layer has no proj set then use map->proj for bounding box. */
   if (msOWSGetLayerExtent(map, lp, "MO", &ext) == MS_SUCCESS) {
-    if(lp->projection.numargs > 0) {
+    if (lp->projection.numargs > 0) {
       if (nVersion >= OWS_1_3_0)
         msOWSPrintEX_GeographicBoundingBox(stdout, "        ", &(ext),
                                            &(lp->projection));
@@ -2190,8 +2376,9 @@ int msDumpLayer(mapObj *map, layerObj *l
         msOWSPrintLatLonBoundingBox(stdout, "        ", &(ext),
                                     &(lp->projection), NULL, OWS_WMS);
 
-      msOWSPrintBoundingBox( stdout,"        ", &(ext), &(lp->projection),
-                             &(lp->metadata), &(map->web.metadata), "MO", nVersion );
+      msOWSPrintBoundingBox(stdout, "        ", &(ext), &(lp->projection),
+                            &(lp->metadata), &(map->web.metadata), "MO",
+                            nVersion);
     } else {
       if (nVersion >= OWS_1_3_0)
         msOWSPrintEX_GeographicBoundingBox(stdout, "        ", &(ext),
@@ -2199,151 +2386,186 @@ int msDumpLayer(mapObj *map, layerObj *l
       else
         msOWSPrintLatLonBoundingBox(stdout, "        ", &(ext),
                                     &(map->projection), NULL, OWS_WMS);
-      msOWSPrintBoundingBox(stdout,"        ", &(ext), &(map->projection),
-                            &(lp->metadata), &(map->web.metadata), "MO", nVersion );
+      msOWSPrintBoundingBox(stdout, "        ", &(ext), &(map->projection),
+                            &(lp->metadata), &(map->web.metadata), "MO",
+                            nVersion);
     }
   } else {
     if (nVersion >= OWS_1_3_0)
-      msIO_printf("        <!-- WARNING: Optional Ex_GeographicBoundingBox could not be established for this layer.  Consider setting the EXTENT in the LAYER object, or wms_extent metadata. Also check that your data exists in the DATA statement -->\n");
+      msIO_printf(
+          "        <!-- WARNING: Optional Ex_GeographicBoundingBox could not "
+          "be established for this layer.  Consider setting the EXTENT in the "
+          "LAYER object, or wms_extent metadata. Also check that your data "
+          "exists in the DATA statement -->\n");
     else
-      msIO_printf("        <!-- WARNING: Optional LatLonBoundingBox could not be established for this layer.  Consider setting the EXTENT in the LAYER object, or wms_extent metadata. Also check that your data exists in the DATA statement -->\n");
+      msIO_printf("        <!-- WARNING: Optional LatLonBoundingBox could not "
+                  "be established for this layer.  Consider setting the EXTENT "
+                  "in the LAYER object, or wms_extent metadata. Also check "
+                  "that your data exists in the DATA statement -->\n");
   }
 
   /* time support */
-  const char* pszWmsTimeExtent = msOWSLookupMetadata(&(lp->metadata), "MO", "timeextent");
+  const char *pszWmsTimeExtent =
+      msOWSLookupMetadata(&(lp->metadata), "MO", "timeextent");
   if (pszWmsTimeExtent) {
-    const char* pszWmsTimeDefault = msOWSLookupMetadata(&(lp->metadata),  "MO",
-                                            "timedefault");
+    const char *pszWmsTimeDefault =
+        msOWSLookupMetadata(&(lp->metadata), "MO", "timedefault");
 
     if (nVersion >= OWS_1_3_0) {
       if (pszWmsTimeDefault)
-        msIO_fprintf(stdout, "        <Dimension name=\"time\" units=\"ISO8601\" default=\"%s\" nearestValue=\"0\">%s</Dimension>\n",pszWmsTimeDefault, pszWmsTimeExtent);
+        msIO_fprintf(stdout,
+                     "        <Dimension name=\"time\" units=\"ISO8601\" "
+                     "default=\"%s\" nearestValue=\"0\">%s</Dimension>\n",
+                     pszWmsTimeDefault, pszWmsTimeExtent);
       else
-        msIO_fprintf(stdout, "        <Dimension name=\"time\" units=\"ISO8601\" nearestValue=\"0\">%s</Dimension>\n",pszWmsTimeExtent);
+        msIO_fprintf(stdout,
+                     "        <Dimension name=\"time\" units=\"ISO8601\" "
+                     "nearestValue=\"0\">%s</Dimension>\n",
+                     pszWmsTimeExtent);
     }
 
     else {
-      msIO_fprintf(stdout, "        <Dimension name=\"time\" units=\"ISO8601\"/>\n");
+      msIO_fprintf(stdout,
+                   "        <Dimension name=\"time\" units=\"ISO8601\"/>\n");
       if (pszWmsTimeDefault)
-        msIO_fprintf(stdout, "        <Extent name=\"time\" default=\"%s\" nearestValue=\"0\">%s</Extent>\n",pszWmsTimeDefault, pszWmsTimeExtent);
+        msIO_fprintf(stdout,
+                     "        <Extent name=\"time\" default=\"%s\" "
+                     "nearestValue=\"0\">%s</Extent>\n",
+                     pszWmsTimeDefault, pszWmsTimeExtent);
       else
-        msIO_fprintf(stdout, "        <Extent name=\"time\" nearestValue=\"0\">%s</Extent>\n",pszWmsTimeExtent);
+        msIO_fprintf(
+            stdout,
+            "        <Extent name=\"time\" nearestValue=\"0\">%s</Extent>\n",
+            pszWmsTimeExtent);
     }
   }
 
   /*dimensions support: elevation + other user defined dimensions*/
-  const char* pszDimensionlist = msOWSLookupMetadata(&(lp->metadata), "M", "dimensionlist");
+  const char *pszDimensionlist =
+      msOWSLookupMetadata(&(lp->metadata), "M", "dimensionlist");
   if (pszDimensionlist) {
     auto tokens = msStringSplit(pszDimensionlist, ',');
-    for( auto& dimension: tokens ) {
-        /*check if manadatory unit and extent are set. Item should also be set. default value is optional*/
-        msStringTrim(dimension);
-
-        const char* pszDimensionItem = msOWSLookupMetadata(
-            &(lp->metadata), "M", (dimension + "_item").c_str());
-        const char* pszDimensionExtent = msOWSLookupMetadata(
-            &(lp->metadata), "M", (dimension + "_extent").c_str());
-        const char* pszDimensionUnit = msOWSLookupMetadata(
-            &(lp->metadata), "M", (dimension + "_units").c_str());
-        const char* pszDimensionDefault = msOWSLookupMetadata(
-            &(lp->metadata), "M", (dimension + "_default").c_str());
-
-        if (pszDimensionItem && pszDimensionExtent && pszDimensionUnit) {
-          if (nVersion >= OWS_1_3_0) {
-            if(pszDimensionDefault && strlen(pszDimensionDefault) > 0)
-              msIO_fprintf(stdout, "        <Dimension name=\"%s\" units=\"%s\" default=\"%s\" multipleValues=\"1\" nearestValue=\"0\">%s</Dimension>\n",
-                           dimension.c_str(), pszDimensionUnit, pszDimensionDefault, pszDimensionExtent);
-            else
-              msIO_fprintf(stdout, "        <Dimension name=\"%s\" units=\"%s\"  multipleValues=\"1\"  nearestValue=\"0\">%s</Dimension>\n",
-                           dimension.c_str(), pszDimensionUnit, pszDimensionExtent);
-          } else {
-            msIO_fprintf(stdout, "        <Dimension name=\"%s\" units=\"%s\"/>\n", dimension.c_str(), pszDimensionUnit);
-            if(pszDimensionDefault && strlen(pszDimensionDefault) > 0)
-              msIO_fprintf(stdout, "        <Extent name=\"%s\" default=\"%s\" nearestValue=\"0\">%s</Extent>\n",
-                           dimension.c_str(), pszDimensionDefault, pszDimensionExtent);
-            else
-              msIO_fprintf(stdout, "        <Extent name=\"%s\" nearestValue=\"0\">%s</Extent>\n",
-                           dimension.c_str(), pszDimensionExtent);
-          }
+    for (auto &dimension : tokens) {
+      /*check if manadatory unit and extent are set. Item should also be set.
+       * default value is optional*/
+      msStringTrim(dimension);
+
+      const char *pszDimensionItem = msOWSLookupMetadata(
+          &(lp->metadata), "M", (dimension + "_item").c_str());
+      const char *pszDimensionExtent = msOWSLookupMetadata(
+          &(lp->metadata), "M", (dimension + "_extent").c_str());
+      const char *pszDimensionUnit = msOWSLookupMetadata(
+          &(lp->metadata), "M", (dimension + "_units").c_str());
+      const char *pszDimensionDefault = msOWSLookupMetadata(
+          &(lp->metadata), "M", (dimension + "_default").c_str());
+
+      if (pszDimensionItem && pszDimensionExtent && pszDimensionUnit) {
+        if (nVersion >= OWS_1_3_0) {
+          if (pszDimensionDefault && strlen(pszDimensionDefault) > 0)
+            msIO_fprintf(
+                stdout,
+                "        <Dimension name=\"%s\" units=\"%s\" default=\"%s\" "
+                "multipleValues=\"1\" nearestValue=\"0\">%s</Dimension>\n",
+                dimension.c_str(), pszDimensionUnit, pszDimensionDefault,
+                pszDimensionExtent);
+          else
+            msIO_fprintf(
+                stdout,
+                "        <Dimension name=\"%s\" units=\"%s\"  "
+                "multipleValues=\"1\"  nearestValue=\"0\">%s</Dimension>\n",
+                dimension.c_str(), pszDimensionUnit, pszDimensionExtent);
+        } else {
+          msIO_fprintf(stdout,
+                       "        <Dimension name=\"%s\" units=\"%s\"/>\n",
+                       dimension.c_str(), pszDimensionUnit);
+          if (pszDimensionDefault && strlen(pszDimensionDefault) > 0)
+            msIO_fprintf(stdout,
+                         "        <Extent name=\"%s\" default=\"%s\" "
+                         "nearestValue=\"0\">%s</Extent>\n",
+                         dimension.c_str(), pszDimensionDefault,
+                         pszDimensionExtent);
+          else
+            msIO_fprintf(
+                stdout,
+                "        <Extent name=\"%s\" nearestValue=\"0\">%s</Extent>\n",
+                dimension.c_str(), pszDimensionExtent);
         }
+      }
     }
   }
 
-
   if (nVersion >= OWS_1_0_7) {
     msWMSPrintAttribution(stdout, "    ", &(lp->metadata), "MO");
   }
 
   /* AuthorityURL support and Identifier support, only available >= WMS 1.1.0 */
-  if(nVersion >= OWS_1_1_0) {
+  if (nVersion >= OWS_1_1_0) {
     msWMSPrintAuthorityURL(stdout, "        ", &(lp->metadata), "MO");
     msWMSPrintIdentifier(stdout, "        ", &(lp->metadata), "MO");
   }
 
-  if(nVersion >= OWS_1_1_0) {
-    const char* metadataurl_list = msOWSLookupMetadata(&(lp->metadata), "MO", "metadataurl_list");
-    if( metadataurl_list ) {
+  if (nVersion >= OWS_1_1_0) {
+    const char *metadataurl_list =
+        msOWSLookupMetadata(&(lp->metadata), "MO", "metadataurl_list");
+    if (metadataurl_list) {
       const auto tokens = msStringSplit(metadataurl_list, ' ');
-      for( const auto& token: tokens )
-      {
+      for (const auto &token : tokens) {
         std::string key("metadataurl_");
         key += token;
-        msOWSPrintURLType(stdout, &(lp->metadata), "MO", key.c_str(),
-                        OWS_NOERR, NULL, "MetadataURL", " type=\"%s\"",
-                        NULL, NULL, ">\n          <Format>%s</Format",
-                        "\n          <OnlineResource xmlns:xlink=\""
-                        "http://www.w3.org/1999/xlink\" "
-                       "xlink:type=\"simple\" xlink:href=\"%s\"/>\n        ",
-                        MS_TRUE, MS_FALSE, MS_FALSE, MS_TRUE, MS_TRUE,
-                        NULL, NULL, NULL, NULL, NULL, "        ");
+        msOWSPrintURLType(stdout, &(lp->metadata), "MO", key.c_str(), OWS_NOERR,
+                          NULL, "MetadataURL", " type=\"%s\"", NULL, NULL,
+                          ">\n          <Format>%s</Format",
+                          "\n          <OnlineResource xmlns:xlink=\""
+                          "http://www.w3.org/1999/xlink\" "
+                          "xlink:type=\"simple\" xlink:href=\"%s\"/>\n        ",
+                          MS_TRUE, MS_FALSE, MS_FALSE, MS_TRUE, MS_TRUE, NULL,
+                          NULL, NULL, NULL, NULL, "        ");
       }
-    }
-    else {
-      if (! msOWSLookupMetadata(&(lp->metadata), "MO", "metadataurl_href"))
+    } else {
+      if (!msOWSLookupMetadata(&(lp->metadata), "MO", "metadataurl_href"))
         msMetadataSetGetMetadataURL(lp, script_url_encoded);
 
-      msOWSPrintURLType(stdout, &(lp->metadata), "MO", "metadataurl",
-                        OWS_NOERR, NULL, "MetadataURL", " type=\"%s\"",
-                        NULL, NULL, ">\n          <Format>%s</Format",
+      msOWSPrintURLType(stdout, &(lp->metadata), "MO", "metadataurl", OWS_NOERR,
+                        NULL, "MetadataURL", " type=\"%s\"", NULL, NULL,
+                        ">\n          <Format>%s</Format",
                         "\n          <OnlineResource xmlns:xlink=\""
                         "http://www.w3.org/1999/xlink\" "
-                       "xlink:type=\"simple\" xlink:href=\"%s\"/>\n        ",
-                        MS_TRUE, MS_FALSE, MS_FALSE, MS_TRUE, MS_TRUE,
-                        NULL, NULL, NULL, NULL, NULL, "        ");
+                        "xlink:type=\"simple\" xlink:href=\"%s\"/>\n        ",
+                        MS_TRUE, MS_FALSE, MS_FALSE, MS_TRUE, MS_TRUE, NULL,
+                        NULL, NULL, NULL, NULL, "        ");
     }
   }
 
-  if(nVersion < OWS_1_1_0)
+  if (nVersion < OWS_1_1_0)
     msOWSPrintEncodeMetadata(stdout, &(lp->metadata), "MO", "dataurl_href",
                              OWS_NOERR, "        <DataURL>%s</DataURL>\n",
                              NULL);
   else {
-    const char* dataurl_list = msOWSLookupMetadata(&(lp->metadata), "MO", "dataurl_list");
-    if( dataurl_list ) {
+    const char *dataurl_list =
+        msOWSLookupMetadata(&(lp->metadata), "MO", "dataurl_list");
+    if (dataurl_list) {
       const auto tokens = msStringSplit(dataurl_list, ' ');
-      for( const auto& token: tokens )
-      {
+      for (const auto &token : tokens) {
         std::string key("dataurl_");
         key += token;
-        msOWSPrintURLType(stdout, &(lp->metadata), "MO", key.c_str(),
-                        OWS_NOERR, NULL, "DataURL", NULL, NULL, NULL,
-                        ">\n          <Format>%s</Format",
-                        "\n          <OnlineResource xmlns:xlink=\""
-                        "http://www.w3.org/1999/xlink\" "
-                        "xlink:type=\"simple\" xlink:href=\"%s\"/>\n        ",
-                        MS_FALSE, MS_FALSE, MS_FALSE, MS_TRUE, MS_TRUE,
-                        NULL, NULL, NULL, NULL, NULL, "        ");
+        msOWSPrintURLType(stdout, &(lp->metadata), "MO", key.c_str(), OWS_NOERR,
+                          NULL, "DataURL", NULL, NULL, NULL,
+                          ">\n          <Format>%s</Format",
+                          "\n          <OnlineResource xmlns:xlink=\""
+                          "http://www.w3.org/1999/xlink\" "
+                          "xlink:type=\"simple\" xlink:href=\"%s\"/>\n        ",
+                          MS_FALSE, MS_FALSE, MS_FALSE, MS_TRUE, MS_TRUE, NULL,
+                          NULL, NULL, NULL, NULL, "        ");
       }
-    }
-    else {
-      msOWSPrintURLType(stdout, &(lp->metadata), "MO", "dataurl",
-                        OWS_NOERR, NULL, "DataURL", NULL, NULL, NULL,
+    } else {
+      msOWSPrintURLType(stdout, &(lp->metadata), "MO", "dataurl", OWS_NOERR,
+                        NULL, "DataURL", NULL, NULL, NULL,
                         ">\n          <Format>%s</Format",
                         "\n          <OnlineResource xmlns:xlink=\""
                         "http://www.w3.org/1999/xlink\" "
                         "xlink:type=\"simple\" xlink:href=\"%s\"/>\n        ",
-                        MS_FALSE, MS_FALSE, MS_FALSE, MS_TRUE, MS_TRUE,
-                        NULL, NULL, NULL, NULL, NULL, "        ");
+                        MS_FALSE, MS_FALSE, MS_FALSE, MS_TRUE, MS_TRUE, NULL,
+                        NULL, NULL, NULL, NULL, "        ");
     }
   }
 
@@ -2354,93 +2576,90 @@ int msDumpLayer(mapObj *map, layerObj *l
   /* the current style before reading it. Also in the Style block, we need */
   /* a Title and a name. Title is derived from wms_style_<style>_title, */
   /* which allows mutiple style definitions, e.g. by using classgroups. */
-  const char* pszStyle = msOWSLookupMetadata(&(lp->metadata), "MO", "style");
-  const char *pszLegendURL=NULL;
+  const char *pszStyle = msOWSLookupMetadata(&(lp->metadata), "MO", "style");
+  const char *pszLegendURL = NULL;
   if (pszStyle) {
-    pszLegendURL = msOWSLookupMetadata(&(lp->metadata), "MO",
+    pszLegendURL = msOWSLookupMetadata(
+        &(lp->metadata), "MO",
         (std::string("style_") + pszStyle + "_legendurl_href").c_str());
   } else
     pszStyle = "default";
 
-
-  if(nVersion <= OWS_1_0_0 && pszLegendURL) {
+  if (nVersion <= OWS_1_0_0 && pszLegendURL) {
     /* First, print the style block */
     msIO_fprintf(stdout, "        <Style>\n");
     msIO_fprintf(stdout, "          <Name>%s</Name>\n", pszStyle);
     /* Print the real Title or Style name otherwise */
-    msOWSPrintEncodeMetadata2(stdout, &(lp->metadata), "MO",
-                              (std::string("style_") + pszStyle + "_title").c_str(),
-                              OWS_NOERR,
-                              "          <Title>%s</Title>\n",
-                              pszStyle, validated_language);
+    msOWSPrintEncodeMetadata2(
+        stdout, &(lp->metadata), "MO",
+        (std::string("style_") + pszStyle + "_title").c_str(), OWS_NOERR,
+        "          <Title>%s</Title>\n", pszStyle, validated_language);
 
     /* Inside, print the legend url block */
-    msOWSPrintEncodeMetadata(stdout, &(lp->metadata), "MO",
-                             (std::string("style_") + pszStyle + "_legendurl_href").c_str(),
-                             OWS_NOERR,
-                             "          <StyleURL>%s</StyleURL>\n",
-                             NULL);
+    msOWSPrintEncodeMetadata(
+        stdout, &(lp->metadata), "MO",
+        (std::string("style_") + pszStyle + "_legendurl_href").c_str(),
+        OWS_NOERR, "          <StyleURL>%s</StyleURL>\n", NULL);
 
     /* close the style block */
     msIO_fprintf(stdout, "        </Style>\n");
 
-  } else if(nVersion >= OWS_1_1_0) {
+  } else if (nVersion >= OWS_1_1_0) {
     if (pszLegendURL) {
       /* First, print the style block */
       msIO_fprintf(stdout, "        <Style>\n");
       msIO_fprintf(stdout, "          <Name>%s</Name>\n", pszStyle);
       /* Print the real Title or Style name otherwise */
-      msOWSPrintEncodeMetadata2(stdout, &(lp->metadata), "MO",
-                                (std::string("style_") + pszStyle + "_title").c_str(),
-                                OWS_NOERR,
-                                "          <Title>%s</Title>\n",
-                                pszStyle, validated_language);
-
+      msOWSPrintEncodeMetadata2(
+          stdout, &(lp->metadata), "MO",
+          (std::string("style_") + pszStyle + "_title").c_str(), OWS_NOERR,
+          "          <Title>%s</Title>\n", pszStyle, validated_language);
 
       /* Inside, print the legend url block */
-      msOWSPrintURLType(stdout, &(lp->metadata), "MO",
-                        (std::string("style_") + pszStyle + "_legendurl").c_str(),
-                        OWS_NOERR, NULL, "LegendURL", NULL,
-                        " width=\"%s\"", " height=\"%s\"",
-                        ">\n             <Format>%s</Format",
-                        "\n             <OnlineResource "
-                        "xmlns:xlink=\"http://www.w3.org/1999/xlink\""
-                        " xlink:type=\"simple\" xlink:href=\"%s\"/>\n"
-                        "          ",
-                        MS_FALSE, MS_TRUE, MS_TRUE, MS_TRUE, MS_TRUE,
-                        NULL, NULL, NULL, NULL, NULL, "          ");
+      msOWSPrintURLType(
+          stdout, &(lp->metadata), "MO",
+          (std::string("style_") + pszStyle + "_legendurl").c_str(), OWS_NOERR,
+          NULL, "LegendURL", NULL, " width=\"%s\"", " height=\"%s\"",
+          ">\n             <Format>%s</Format",
+          "\n             <OnlineResource "
+          "xmlns:xlink=\"http://www.w3.org/1999/xlink\""
+          " xlink:type=\"simple\" xlink:href=\"%s\"/>\n"
+          "          ",
+          MS_FALSE, MS_TRUE, MS_TRUE, MS_TRUE, MS_TRUE, NULL, NULL, NULL, NULL,
+          NULL, "          ");
       msIO_fprintf(stdout, "        </Style>\n");
 
     } else {
       if (script_url_encoded) {
-        if (lp->connectiontype != MS_WMS &&
-            lp->connectiontype != MS_WFS &&
-            lp->connectiontype != MS_UNUSED_1 &&
-            lp->numclasses > 0) {
+        if (lp->connectiontype != MS_WMS && lp->connectiontype != MS_WFS &&
+            lp->connectiontype != MS_UNUSED_1 && lp->numclasses > 0) {
           bool classnameset = false;
-          for (int i=0; i<lp->numclasses; i++) {
-            if (lp->_class[i]->name &&
-                strlen(lp->_class[i]->name) > 0) {
+          for (int i = 0; i < lp->numclasses; i++) {
+            if (lp->_class[i]->name && strlen(lp->_class[i]->name) > 0) {
               classnameset = true;
               break;
             }
           }
           if (classnameset) {
-            int size_x=0, size_y=0;
+            int size_x = 0, size_y = 0;
             std::vector<int> group_layers;
             group_layers.reserve(map->numlayers);
 
-            char ***nestedGroups = (char***)msSmallCalloc(map->numlayers, sizeof(char**));
-            int *numNestedGroups = (int*)msSmallCalloc(map->numlayers, sizeof(int));
-            int* isUsedInNestedGroup = (int*)msSmallCalloc(map->numlayers, sizeof(int));
-            msWMSPrepareNestedGroups(map, nVersion, nestedGroups, numNestedGroups, isUsedInNestedGroup);
+            char ***nestedGroups =
+                (char ***)msSmallCalloc(map->numlayers, sizeof(char **));
+            int *numNestedGroups =
+                (int *)msSmallCalloc(map->numlayers, sizeof(int));
+            int *isUsedInNestedGroup =
+                (int *)msSmallCalloc(map->numlayers, sizeof(int));
+            msWMSPrepareNestedGroups(map, nVersion, nestedGroups,
+                                     numNestedGroups, isUsedInNestedGroup);
 
             group_layers.push_back(lp->index);
             if (isUsedInNestedGroup[lp->index]) {
-              for (int j=0; j < map->numlayers; j++) {
+              for (int j = 0; j < map->numlayers; j++) {
                 if (j == lp->index)
-                    continue;
-                for(int k = 0; k < numNestedGroups[j]; k++) {
+                  continue;
+                for (int k = 0; k < numNestedGroups[j]; k++) {
                   if (strcasecmp(lp->name, nestedGroups[j][k]) == 0) {
                     group_layers.push_back(j);
                     break;
@@ -2449,11 +2668,13 @@ int msDumpLayer(mapObj *map, layerObj *l
               }
             }
 
-            if (msLegendCalcSize(map, 1, &size_x, &size_y, group_layers.data(), static_cast<int>(group_layers.size()), NULL, 1) == MS_SUCCESS) {
+            if (msLegendCalcSize(map, 1, &size_x, &size_y, group_layers.data(),
+                                 static_cast<int>(group_layers.size()), NULL,
+                                 1) == MS_SUCCESS) {
               const std::string width(std::to_string(size_x));
               const std::string height(std::to_string(size_y));
 
-              char* mimetype = NULL;
+              char *mimetype = NULL;
 #if defined USE_PNG
               mimetype = msEncodeHTMLEntities("image/png");
 #endif
@@ -2463,36 +2684,48 @@ int msDumpLayer(mapObj *map, layerObj *l
                 mimetype = msEncodeHTMLEntities("image/jpeg");
 #endif
               if (!mimetype)
-                mimetype = msEncodeHTMLEntities(MS_IMAGE_MIME_TYPE(map->outputformat));
+                mimetype =
+                    msEncodeHTMLEntities(MS_IMAGE_MIME_TYPE(map->outputformat));
 
-              /* -------------------------------------------------------------------- */
-              /*      check if the group parameters for the classes are set. We       */
-              /*      should then publish the different class groups as different styles.*/
-              /* -------------------------------------------------------------------- */
+              /* --------------------------------------------------------------------
+               */
+              /*      check if the group parameters for the classes are set. We
+               */
+              /*      should then publish the different class groups as
+               * different styles.*/
+              /* --------------------------------------------------------------------
+               */
               iclassgroups = 0;
               classgroups = NULL;
 
-              const char* styleName = msOWSLookupMetadata(&(map->web.metadata), "MO", "style_name");
+              const char *styleName =
+                  msOWSLookupMetadata(&(map->web.metadata), "MO", "style_name");
               if (styleName == NULL)
                 styleName = "default";
-              char* pszEncodedStyleName = msEncodeHTMLEntities(styleName);
+              char *pszEncodedStyleName = msEncodeHTMLEntities(styleName);
 
-              for (int i=0; i<lp->numclasses; i++) {
+              for (int i = 0; i < lp->numclasses; i++) {
                 if (lp->_class[i]->name && lp->_class[i]->group) {
-                  /* Check that style is not inherited from root layer (#4442). */
-                  if (strcasecmp(pszEncodedStyleName, lp->_class[i]->group) == 0)
+                  /* Check that style is not inherited from root layer (#4442).
+                   */
+                  if (strcasecmp(pszEncodedStyleName, lp->_class[i]->group) ==
+                      0)
                     continue;
-                  /* Check that style is not inherited from group layer(s) (#4442). */
+                  /* Check that style is not inherited from group layer(s)
+                   * (#4442). */
                   if (numNestedGroups[lp->index] > 0) {
-                    int j=0;
+                    int j = 0;
                     layerObj *lp2 = NULL;
-                    for (; j<numNestedGroups[lp->index]; j++) {
+                    for (; j < numNestedGroups[lp->index]; j++) {
                       int l = 0;
-                      for (int k=0; k < map->numlayers; k++) {
-                        if (GET_LAYER(map, k)->name && strcasecmp(GET_LAYER(map, k)->name, nestedGroups[lp->index][j]) == 0) {
+                      for (int k = 0; k < map->numlayers; k++) {
+                        if (GET_LAYER(map, k)->name &&
+                            strcasecmp(GET_LAYER(map, k)->name,
+                                       nestedGroups[lp->index][j]) == 0) {
                           lp2 = (GET_LAYER(map, k));
-                          for (l=0; l < lp2->numclasses; l++) {
-                            if (strcasecmp(lp2->_class[l]->group, lp->_class[i]->group) == 0)
+                          for (l = 0; l < lp2->numclasses; l++) {
+                            if (strcasecmp(lp2->_class[l]->group,
+                                           lp->_class[i]->group) == 0)
                               break;
                           }
                           break;
@@ -2506,20 +2739,24 @@ int msDumpLayer(mapObj *map, layerObj *l
                   }
                   if (!classgroups) {
                     classgroups = (char **)msSmallMalloc(sizeof(char *));
-                    classgroups[iclassgroups++]= msStrdup(lp->_class[i]->group);
+                    classgroups[iclassgroups++] =
+                        msStrdup(lp->_class[i]->group);
                   } else {
                     /* Output style only once. */
                     bool found = false;
-                    for (int j=0; j<iclassgroups; j++) {
-                      if (strcasecmp(classgroups[j], lp->_class[i]->group) == 0) {
+                    for (int j = 0; j < iclassgroups; j++) {
+                      if (strcasecmp(classgroups[j], lp->_class[i]->group) ==
+                          0) {
                         found = true;
                         break;
                       }
                     }
                     if (!found) {
                       iclassgroups++;
-                      classgroups = (char **)msSmallRealloc(classgroups, sizeof(char *)*iclassgroups);
-                      classgroups[iclassgroups-1]= msStrdup(lp->_class[i]->group);
+                      classgroups = (char **)msSmallRealloc(
+                          classgroups, sizeof(char *) * iclassgroups);
+                      classgroups[iclassgroups - 1] =
+                          msStrdup(lp->_class[i]->group);
                     }
                   }
                 }
@@ -2527,22 +2764,22 @@ int msDumpLayer(mapObj *map, layerObj *l
               msFree(pszEncodedStyleName);
               if (classgroups == NULL) {
                 classgroups = (char **)msSmallMalloc(sizeof(char *));
-                classgroups[0]= msStrdup("default");
+                classgroups[0] = msStrdup("default");
                 iclassgroups = 1;
               }
 
-              for (int i=0; i<iclassgroups; i++) {
+              for (int i = 0; i < iclassgroups; i++) {
                 char *name_encoded = msEncodeHTMLEntities(lp->name);
                 char *classgroup_encoded = msEncodeHTMLEntities(classgroups[i]);
                 std::string legendurl(script_url_encoded);
                 legendurl += "version=";
                 char szVersionBuf[OWS_VERSION_MAXLEN];
                 legendurl += msOWSGetVersionString(nVersion, szVersionBuf);
-                legendurl += "&amp;service=WMS&amp;request=GetLegendGraphic&amp;";
+                legendurl +=
+                    "&amp;service=WMS&amp;request=GetLegendGraphic&amp;";
                 if (nVersion >= OWS_1_3_0) {
                   legendurl += "sld_version=1.1.0&amp;layer=";
-                }
-                else {
+                } else {
                   legendurl += "layer=";
                 }
                 legendurl += name_encoded;
@@ -2555,43 +2792,45 @@ int msDumpLayer(mapObj *map, layerObj *l
                 msFree(classgroup_encoded);
 
                 msIO_fprintf(stdout, "        <Style>\n");
-                msIO_fprintf(stdout, "          <Name>%s</Name>\n",  classgroups[i]);
-                msOWSPrintEncodeMetadata2(stdout, &(lp->metadata), "MO",
-                                          (std::string("style_") + classgroups[i] + "_title").c_str(),
-                                          OWS_NOERR,
-                                          "          <Title>%s</Title>\n",
-                                          classgroups[i], validated_language);
-
-                /* A legendurl from wms_style_<style>_legendurl_href will override a self generated legend graphic */
-                pszLegendURL = msOWSLookupMetadata(&(lp->metadata), "MO",
-                    (std::string("style_") + classgroups[i] + "_legendurl_href").c_str());
+                msIO_fprintf(stdout, "          <Name>%s</Name>\n",
+                             classgroups[i]);
+                msOWSPrintEncodeMetadata2(
+                    stdout, &(lp->metadata), "MO",
+                    (std::string("style_") + classgroups[i] + "_title").c_str(),
+                    OWS_NOERR, "          <Title>%s</Title>\n", classgroups[i],
+                    validated_language);
+
+                /* A legendurl from wms_style_<style>_legendurl_href will
+                 * override a self generated legend graphic */
+                pszLegendURL = msOWSLookupMetadata(
+                    &(lp->metadata), "MO",
+                    (std::string("style_") + classgroups[i] + "_legendurl_href")
+                        .c_str());
                 if (pszLegendURL) {
-                  msOWSPrintURLType(stdout, &(lp->metadata),
-                                    "MO",
-                                    (std::string("style_") + classgroups[i] + "_legendurl").c_str(),
-                                    OWS_NOERR, NULL,
-                                    "LegendURL", NULL,
-                                    " width=\"%s\"", " height=\"%s\"",
-                                    ">\n             <Format>%s</Format",
-                                    "\n             <OnlineResource "
-                                    "xmlns:xlink=\"http://www.w3.org/1999/xlink\""
-                                    " xlink:type=\"simple\" xlink:href=\"%s\"/>\n"
-                                    "          ",
-                                    MS_FALSE, MS_TRUE, MS_TRUE, MS_TRUE, MS_TRUE,
-                                    NULL, NULL, NULL, NULL, NULL, "          ");
+                  msOWSPrintURLType(
+                      stdout, &(lp->metadata), "MO",
+                      (std::string("style_") + classgroups[i] + "_legendurl")
+                          .c_str(),
+                      OWS_NOERR, NULL, "LegendURL", NULL, " width=\"%s\"",
+                      " height=\"%s\"", ">\n             <Format>%s</Format",
+                      "\n             <OnlineResource "
+                      "xmlns:xlink=\"http://www.w3.org/1999/xlink\""
+                      " xlink:type=\"simple\" xlink:href=\"%s\"/>\n"
+                      "          ",
+                      MS_FALSE, MS_TRUE, MS_TRUE, MS_TRUE, MS_TRUE, NULL, NULL,
+                      NULL, NULL, NULL, "          ");
                 } else {
-                  msOWSPrintURLType(stdout, NULL,
-                                    "O", "ttt",
-                                    OWS_NOERR, NULL,
-                                    "LegendURL", NULL,
-                                    " width=\"%s\"", " height=\"%s\"",
-                                    ">\n             <Format>%s</Format",
-                                    "\n             <OnlineResource "
-                                    "xmlns:xlink=\"http://www.w3.org/1999/xlink\""
-                                    " xlink:type=\"simple\" xlink:href=\"%s\"/>\n"
-                                    "          ",
-                                    MS_FALSE, MS_FALSE, MS_FALSE, MS_FALSE, MS_FALSE,
-                                    NULL, width.c_str(), height.c_str(), mimetype, legendurl.c_str(), "          ");
+                  msOWSPrintURLType(
+                      stdout, NULL, "O", "ttt", OWS_NOERR, NULL, "LegendURL",
+                      NULL, " width=\"%s\"", " height=\"%s\"",
+                      ">\n             <Format>%s</Format",
+                      "\n             <OnlineResource "
+                      "xmlns:xlink=\"http://www.w3.org/1999/xlink\""
+                      " xlink:type=\"simple\" xlink:href=\"%s\"/>\n"
+                      "          ",
+                      MS_FALSE, MS_FALSE, MS_FALSE, MS_FALSE, MS_FALSE, NULL,
+                      width.c_str(), height.c_str(), mimetype,
+                      legendurl.c_str(), "          ");
                 }
                 msIO_fprintf(stdout, "        </Style>\n");
               }
@@ -2614,12 +2853,14 @@ int msDumpLayer(mapObj *map, layerObj *l
   }
 
   /* print Min/Max ScaleDenominator */
-  if (nVersion <  OWS_1_3_0)
-    msWMSPrintScaleHint("        ", lp->minscaledenom, lp->maxscaledenom, map->resolution);
+  if (nVersion < OWS_1_3_0)
+    msWMSPrintScaleHint("        ", lp->minscaledenom, lp->maxscaledenom,
+                        map->resolution);
   else
-    msWMSPrintScaleDenominator("        ", lp->minscaledenom, lp->maxscaledenom);
+    msWMSPrintScaleDenominator("        ", lp->minscaledenom,
+                               lp->maxscaledenom);
 
-  if ( grouplayer == MS_FALSE )
+  if (grouplayer == MS_FALSE)
     msIO_printf("%s    </Layer>\n", indent);
 
   return MS_SUCCESS;
@@ -2628,8 +2869,8 @@ int msDumpLayer(mapObj *map, layerObj *l
 /*
  * msWMSIsSubGroup
  */
-static bool msWMSIsSubGroup(char** currentGroups, int currentLevel, char** otherGroups, int numOtherGroups)
-{
+static bool msWMSIsSubGroup(char **currentGroups, int currentLevel,
+                            char **otherGroups, int numOtherGroups) {
   /* no match if otherGroups[] has less levels than currentLevel */
   if (numOtherGroups <= currentLevel) {
     return false;
@@ -2646,37 +2887,39 @@ static bool msWMSIsSubGroup(char** curre
 /*
  * msWMSHasQueryableSubLayers
  */
-static int msWMSHasQueryableSubLayers(mapObj* map, int index, int level,
-                                      char*** nestedGroups, int* numNestedGroups)
-{
-    for (int j = index; j < map->numlayers; j++) {
-      if (msWMSIsSubGroup(nestedGroups[index], level, nestedGroups[j], numNestedGroups[j])) {
-          if( msIsLayerQueryable( GET_LAYER(map,j) ) )
-              return MS_TRUE;
-      }
+static int msWMSHasQueryableSubLayers(mapObj *map, int index, int level,
+                                      char ***nestedGroups,
+                                      int *numNestedGroups) {
+  for (int j = index; j < map->numlayers; j++) {
+    if (msWMSIsSubGroup(nestedGroups[index], level, nestedGroups[j],
+                        numNestedGroups[j])) {
+      if (msIsLayerQueryable(GET_LAYER(map, j)))
+        return MS_TRUE;
     }
-    return MS_FALSE;
+  }
+  return MS_FALSE;
 }
 
 /***********************************************************************************
- * msWMSPrintNestedGroups()                                                        *
+ * msWMSPrintNestedGroups() *
  *                                                                                 *
- * purpose: Writes the layers to the capabilities that have the                    *
- * "WMS_LAYER_GROUP" metadata set.                                                 *
+ * purpose: Writes the layers to the capabilities that have the *
+ * "WMS_LAYER_GROUP" metadata set. *
  *                                                                                 *
- * params:                                                                         *
- * -map: The main map object                                                       *
- * -nVersion: OGC WMS version                                                      *
- * -pabLayerProcessed: boolean array indicating which layers have been dealt with. *
- * -index: the index of the current layer.                                         *
- * -level: the level of depth in the group tree (root = 0)                         *
- * -nestedGroups: This array holds the arrays of groups that have                  *
- *   been set through the WMS_LAYER_GROUP metadata                                 *
- * -numNestedGroups: This array holds the number of nested groups for each layer   *
+ * params: * -map: The main map object * -nVersion: OGC WMS version *
+ * -pabLayerProcessed: boolean array indicating which layers have been dealt
+ *with. * -index: the index of the current layer. * -level: the level of depth
+ *in the group tree (root = 0)                         * -nestedGroups: This
+ *array holds the arrays of groups that have                  * been set through
+ *the WMS_LAYER_GROUP metadata                                 *
+ * -numNestedGroups: This array holds the number of nested groups for each layer
+ **
  ***********************************************************************************/
-void msWMSPrintNestedGroups(mapObj* map, int nVersion, char* pabLayerProcessed,
-                            int index, int level, char*** nestedGroups, int* numNestedGroups, int* isUsedInNestedGroup, const char *script_url_encoded, const char *validated_language)
-{
+void msWMSPrintNestedGroups(mapObj *map, int nVersion, char *pabLayerProcessed,
+                            int index, int level, char ***nestedGroups,
+                            int *numNestedGroups, int *isUsedInNestedGroup,
+                            const char *script_url_encoded,
+                            const char *validated_language) {
   bool groupAdded = false;
   std::string indent;
   for (int i = 0; i < level; i++) {
@@ -2685,57 +2928,67 @@ void msWMSPrintNestedGroups(mapObj* map,
 
   if (numNestedGroups[index] <= level) { /* no more subgroups */
     if ((!pabLayerProcessed[index]) && (!isUsedInNestedGroup[index])) {
-      /* we are at the deepest level of the group branchings, so add layer now. */
-      msDumpLayer(map, GET_LAYER(map, index), nVersion, script_url_encoded, indent.c_str(), validated_language, MS_FALSE, MS_FALSE);
+      /* we are at the deepest level of the group branchings, so add layer now.
+       */
+      msDumpLayer(map, GET_LAYER(map, index), nVersion, script_url_encoded,
+                  indent.c_str(), validated_language, MS_FALSE, MS_FALSE);
       pabLayerProcessed[index] = 1; /* done */
     }
-  } else { /* not yet there, we have to deal with this group and possible subgroups and layers. */
+  } else { /* not yet there, we have to deal with this group and possible
+              subgroups and layers. */
     int j;
     for (j = 0; j < map->numlayers; j++) {
-      if ( GET_LAYER(map, j)->name && strcasecmp(GET_LAYER(map, j)->name, nestedGroups[index][level]) == 0 ) {
+      if (GET_LAYER(map, j)->name &&
+          strcasecmp(GET_LAYER(map, j)->name, nestedGroups[index][level]) ==
+              0) {
         break;
       }
     }
 
     /* Beginning of a new group... enclose the group in a layer block */
-    if ( j < map->numlayers ) {
+    if (j < map->numlayers) {
       if (!pabLayerProcessed[j]) {
         msDumpLayer(map, GET_LAYER(map, j), nVersion, script_url_encoded,
                     indent.c_str(), validated_language, MS_TRUE,
-                    msWMSHasQueryableSubLayers(map, index, level,
-                            nestedGroups, numNestedGroups));
+                    msWMSHasQueryableSubLayers(map, index, level, nestedGroups,
+                                               numNestedGroups));
         pabLayerProcessed[j] = 1; /* done */
         groupAdded = true;
       }
     } else {
       msIO_printf("%s    <Layer%s>\n", indent.c_str(),
-        msWMSHasQueryableSubLayers(map, index, level,
-                    nestedGroups, numNestedGroups) ? " queryable=\"1\"" : "");
-      msIO_printf("%s      <Name>%s</Name>\n", indent.c_str(), nestedGroups[index][level]);
-      msIO_printf("%s      <Title>%s</Title>\n", indent.c_str(), nestedGroups[index][level]);
+                  msWMSHasQueryableSubLayers(map, index, level, nestedGroups,
+                                             numNestedGroups)
+                      ? " queryable=\"1\""
+                      : "");
+      msIO_printf("%s      <Name>%s</Name>\n", indent.c_str(),
+                  nestedGroups[index][level]);
+      msIO_printf("%s      <Title>%s</Title>\n", indent.c_str(),
+                  nestedGroups[index][level]);
       groupAdded = true;
     }
 
     /* Look for one group deeper in the current layer */
     if (!pabLayerProcessed[index]) {
-      msWMSPrintNestedGroups(map, nVersion, pabLayerProcessed,
-                             index, level + 1, nestedGroups,
-                             numNestedGroups, isUsedInNestedGroup,
+      msWMSPrintNestedGroups(map, nVersion, pabLayerProcessed, index, level + 1,
+                             nestedGroups, numNestedGroups, isUsedInNestedGroup,
                              script_url_encoded, validated_language);
     }
 
     /* look for subgroups in other layers. */
     for (j = index + 1; j < map->numlayers; j++) {
-      if (msWMSIsSubGroup(nestedGroups[index], level, nestedGroups[j], numNestedGroups[j])) {
+      if (msWMSIsSubGroup(nestedGroups[index], level, nestedGroups[j],
+                          numNestedGroups[j])) {
         if (!pabLayerProcessed[j]) {
-          msWMSPrintNestedGroups(map, nVersion, pabLayerProcessed,
-                                 j, level + 1, nestedGroups,
-                                 numNestedGroups, isUsedInNestedGroup,
-                                 script_url_encoded, validated_language);
+          msWMSPrintNestedGroups(map, nVersion, pabLayerProcessed, j, level + 1,
+                                 nestedGroups, numNestedGroups,
+                                 isUsedInNestedGroup, script_url_encoded,
+                                 validated_language);
         }
       } else {
         /* TODO: if we would sort all layers on "WMS_LAYER_GROUP" beforehand */
-        /* we could break out of this loop at this point, which would increase */
+        /* we could break out of this loop at this point, which would increase
+         */
         /* performance.  */
       }
     }
@@ -2748,38 +3001,49 @@ void msWMSPrintNestedGroups(mapObj* map,
 /*
 ** msWMSGetCapabilities()
 */
-static
-int msWMSGetCapabilities(mapObj *map, int nVersion, cgiRequestObj *req, owsRequestObj *ows_request,
-                         const char *requested_updatesequence, const char *wms_exception_format, const char *requested_language)
-{
-  const char* updatesequence = msOWSLookupMetadata(&(map->web.metadata), "MO", "updatesequence");
+static int msWMSGetCapabilities(mapObj *map, int nVersion, cgiRequestObj *req,
+                                owsRequestObj *ows_request,
+                                const char *requested_updatesequence,
+                                const char *wms_exception_format,
+                                const char *requested_language) {
+  const char *updatesequence =
+      msOWSLookupMetadata(&(map->web.metadata), "MO", "updatesequence");
 
-  const char* sldenabled = msOWSLookupMetadata(&(map->web.metadata), "MO", "sld_enabled");
+  const char *sldenabled =
+      msOWSLookupMetadata(&(map->web.metadata), "MO", "sld_enabled");
 
   if (sldenabled == NULL)
     sldenabled = "true";
 
   if (requested_updatesequence != NULL) {
-    int i = msOWSNegotiateUpdateSequence(requested_updatesequence, updatesequence);
+    int i =
+        msOWSNegotiateUpdateSequence(requested_updatesequence, updatesequence);
     if (i == 0) { /* current */
-      msSetError(MS_WMSERR, "UPDATESEQUENCE parameter (%s) is equal to server (%s)", "msWMSGetCapabilities()", requested_updatesequence, updatesequence);
-      return msWMSException(map, nVersion, "CurrentUpdateSequence", wms_exception_format);
+      msSetError(
+          MS_WMSERR, "UPDATESEQUENCE parameter (%s) is equal to server (%s)",
+          "msWMSGetCapabilities()", requested_updatesequence, updatesequence);
+      return msWMSException(map, nVersion, "CurrentUpdateSequence",
+                            wms_exception_format);
     }
     if (i > 0) { /* invalid */
-      msSetError(MS_WMSERR, "UPDATESEQUENCE parameter (%s) is higher than server (%s)", "msWMSGetCapabilities()", requested_updatesequence, updatesequence);
-      return msWMSException(map, nVersion, "InvalidUpdateSequence", wms_exception_format);
+      msSetError(
+          MS_WMSERR, "UPDATESEQUENCE parameter (%s) is higher than server (%s)",
+          "msWMSGetCapabilities()", requested_updatesequence, updatesequence);
+      return msWMSException(map, nVersion, "InvalidUpdateSequence",
+                            wms_exception_format);
     }
   }
 
   std::string schemalocation;
   {
-      char* pszSchemalocation = msEncodeHTMLEntities( msOWSGetSchemasLocation(map) );
-      schemalocation = pszSchemalocation;
-      msFree(pszSchemalocation);
+    char *pszSchemalocation =
+        msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
+    schemalocation = pszSchemalocation;
+    msFree(pszSchemalocation);
   }
 
   if (nVersion < 0)
-    nVersion = OWS_1_3_0;     /* Default to 1.3.0 */
+    nVersion = OWS_1_3_0; /* Default to 1.3.0 */
 
   /* Decide which version we're going to return. */
   std::string dtd_url;
@@ -2811,11 +3075,11 @@ int msWMSGetCapabilities(mapObj *map, in
   /* This function owns validated_language, so remember to free it later*/
   std::string validated_language;
   {
-    char* pszValidated_language = msOWSGetLanguageFromList(map, "MO", requested_language);
-    if( pszValidated_language )
-    {
-        validated_language = pszValidated_language;
-        msMapSetLanguageSpecificConnection(map, pszValidated_language);
+    char *pszValidated_language =
+        msOWSGetLanguageFromList(map, "MO", requested_language);
+    if (pszValidated_language) {
+      validated_language = pszValidated_language;
+      msMapSetLanguageSpecificConnection(map, pszValidated_language);
     }
     msFree(pszValidated_language);
   }
@@ -2824,9 +3088,10 @@ int msWMSGetCapabilities(mapObj *map, in
   /* Default to use the value of the "onlineresource" metadata, and if not */
   /* set then build it: "http://$(SERVER_NAME):$(SERVER_PORT)$(SCRIPT_NAME)?" */
   /* the returned string should be freed once we're done with it. */
-  char *script_url_encoded=NULL;
+  char *script_url_encoded = NULL;
   {
-    char *script_url = msOWSGetOnlineResource2(map, "MO", "onlineresource", req, validated_language.c_str());
+    char *script_url = msOWSGetOnlineResource2(map, "MO", "onlineresource", req,
+                                               validated_language.c_str());
     if (script_url == NULL ||
         (script_url_encoded = msEncodeHTMLEntities(script_url)) == NULL) {
       free(script_url);
@@ -2835,25 +3100,174 @@ int msWMSGetCapabilities(mapObj *map, in
     free(script_url);
   }
 
-  if (nVersion <= OWS_1_0_7 || nVersion >= OWS_1_3_0)   /* 1.0.0 to 1.0.7 and >=1.3.0*/
-    msIO_setHeader("Content-Type","text/xml; charset=UTF-8");
+  if (nVersion <= OWS_1_0_7 ||
+      nVersion >= OWS_1_3_0) /* 1.0.0 to 1.0.7 and >=1.3.0*/
+    msIO_setHeader("Content-Type", "text/xml; charset=UTF-8");
   else /* 1.1.0 and later */
-    msIO_setHeader("Content-Type","application/vnd.ogc.wms_xml; charset=UTF-8");
+    msIO_setHeader("Content-Type",
+                   "application/vnd.ogc.wms_xml; charset=UTF-8");
   msIO_sendHeaders();
 
   msIO_printf("<?xml version='1.0' encoding=\"UTF-8\" standalone=\"no\" ?>\n");
 
   /*TODO review wms1.3.0*/
-  if ( nVersion < OWS_1_3_0) {
-    msIO_printf("<!DOCTYPE WMT_MS_Capabilities SYSTEM \"%s\"\n", dtd_url.c_str());
+  if (nVersion < OWS_1_3_0) {
+    msIO_printf("<!DOCTYPE WMT_MS_Capabilities SYSTEM \"%s\"\n",
+                dtd_url.c_str());
     msIO_printf(" [\n");
 
-    if (nVersion == OWS_1_1_1 && msOWSLookupMetadata(&(map->web.metadata), "MO", "inspire_capabilities") ) {
-      msIO_printf("<!ELEMENT VendorSpecificCapabilities (inspire_vs:ExtendedCapabilities)><!ELEMENT inspire_vs:ExtendedCapabilities ((inspire_common:MetadataUrl, inspire_common:SupportedLanguages, inspire_common:ResponseLanguage) | (inspire_common:ResourceLocator+, inspire_common:ResourceType, inspire_common:TemporalReference+, inspire_common:Conformity+, inspire_common:MetadataPointOfContact+, inspire_common:MetadataDate, inspire_common:SpatialDataServiceType, inspire_common:MandatoryKeyword+, inspire_common:Keyword*, inspire_common:SupportedLanguages, inspire_common:ResponseLanguage, inspire_common:MetadataUrl?))><!ATTLIST inspire_vs:ExtendedCapabilities xmlns:inspire_vs CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/inspire_vs/1.0\" ><!ELEMENT inspire_common:MetadataUrl (inspire_common:URL, inspire_common:MediaType*)><!ATTLIST inspire_common:MetadataUrl xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\" xmlns:xsi CDATA #FIXED \"http://www.w3.org/2001/XMLSchema-instance\" xsi:type CDATA #FIXED \"inspire_common:resourceLocatorType\" ><!ELEMENT inspire_common:URL (#PCDATA)><!ATTLIST inspire_common:URL xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\"><!ELEMENT inspire_common:MediaType (#PCDATA)><!ATTLIST inspire_common:MediaType xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\"><!ELEMENT inspire_common:SupportedLanguages (inspire_common:DefaultLanguage, inspire_common:SupportedLanguage*)><!ATTLIST inspire_common:SupportedLanguages xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT inspire_common:DefaultLanguage (inspire_common:Language)><!ATTLIST inspire_common:DefaultLanguage xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT inspire_common:SupportedLanguage (inspire_common:Language)><!ATTLIST inspire_common:SupportedLanguage xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\" >"
-                  "<!ELEMENT inspire_common:ResponseLanguage (inspire_common:Language)><!ATTLIST inspire_common:ResponseLanguage xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT inspire_common:Language (#PCDATA)><!ATTLIST inspire_common:Language xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT inspire_common:ResourceLocator (inspire_common:URL, inspire_common:MediaType*)><!ATTLIST inspire_common:ResourceLocator xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\"><!ELEMENT inspire_common:ResourceType (#PCDATA)> <!ATTLIST inspire_common:ResourceType xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT inspire_common:TemporalReference (inspire_common:DateOfCreation?, inspire_common:DateOfLastRevision?, inspire_common:DateOfPublication*, inspire_common:TemporalExtent*)><!ATTLIST inspire_common:TemporalReference xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT inspire_common:DateOfCreation (#PCDATA)> <!ATTLIST inspire_common:DateOfCreation xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\"><!ELEMENT inspire_common:DateOfLastRevision (#PCDATA)><!ATTLIST inspire_common:DateOfLastRevision xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\"><!ELEMENT inspire_common:DateOfPublication (#PCDATA)><!ATTLIST inspire_common:DateOfPublication xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\"><!ELEMENT inspire_common:TemporalExtent (inspire_common:IndividualDate | inspire_common:IntervalOfDates)><!ATTLIST inspire_common:TemporalExtent xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT inspire_common:IndividualDate (#PCDATA)> <!ATTLIST inspire_common:IndividualDate xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\">"
-                  "<!ELEMENT inspire_common:IntervalOfDates (inspire_common:StartingDate, inspire_common:EndDate)><!ATTLIST inspire_common:IntervalOfDates xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT inspire_common:StartingDate (#PCDATA)><!ATTLIST inspire_common:StartingDate xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT inspire_common:EndDate (#PCDATA)><!ATTLIST inspire_common:EndDate xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT inspire_common:Conformity (inspire_common:Specification, inspire_common:Degree)><!ATTLIST inspire_common:Conformity xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT inspire_common:Specification (inspire_common:Title, (inspire_common:DateOfPublication | inspire_common:DateOfCreation | inspire_common:DateOfLastRevision), inspire_common:URI*, inspire_common:ResourceLocator*)><!ATTLIST inspire_common:Specification xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT inspire_common:Title (#PCDATA)><!ATTLIST inspire_common:Title xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT inspire_common:URI (#PCDATA)><!ATTLIST inspire_common:URI xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT inspire_common:Degree (#PCDATA)><!ATTLIST inspire_common:Degree xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT inspire_common:MetadataPointOfContact (inspire_common:OrganisationName, inspire_common:EmailAddress)><!ATTLIST inspire_common:MetadataPointOfContact xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\" >"
-                  "<!ELEMENT inspire_common:OrganisationName (#PCDATA)><!ATTLIST inspire_common:OrganisationName  xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT inspire_common:EmailAddress (#PCDATA)><!ATTLIST inspire_common:EmailAddress xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT inspire_common:MetadataDate (#PCDATA)><!ATTLIST inspire_common:MetadataDate xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT inspire_common:SpatialDataServiceType (#PCDATA)><!ATTLIST inspire_common:SpatialDataServiceType xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT inspire_common:MandatoryKeyword (inspire_common:KeywordValue)><!ATTLIST inspire_common:MandatoryKeyword xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT inspire_common:KeywordValue (#PCDATA)><!ATTLIST inspire_common:KeywordValue xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\" >"
-                  "<!ELEMENT inspire_common:Keyword (inspire_common:OriginatingControlledVocabulary?, inspire_common:KeywordValue)><!ATTLIST inspire_common:Keyword xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\" xmlns:xsi CDATA #FIXED \"http://www.w3.org/2001/XMLSchemainstance\" xsi:type (inspire_common:inspireTheme_bul | inspire_common:inspireTheme_cze | inspire_common:inspireTheme_dan | inspire_common:inspireTheme_dut | inspire_common:inspireTheme_eng | inspire_common:inspireTheme_est | inspire_common:inspireTheme_fin | inspire_common:inspireTheme_fre | inspire_common:inspireTheme_ger | inspire_common:inspireTheme_gre | inspire_common:inspireTheme_hun | inspire_common:inspireTheme_gle | inspire_common:inspireTheme_ita | inspire_common:inspireTheme_lav | inspire_common:inspireTheme_lit | inspire_common:inspireTheme_mlt | inspire_common:inspireTheme_pol | inspire_common:inspireTheme_por | inspire_common:inspireTheme_rum | inspire_common:inspireTheme_slo | inspire_common:inspireTheme_slv | inspire_common:inspireTheme_spa | inspire_common:inspireTheme_swe) #IMPLIED ><!ELEMENT inspire_common:OriginatingControlledVocabulary (inspire_common:Title, (inspire_common:DateOfPublication | inspire_common:DateOfCreation | inspire_common:DateOfLastRevision), inspire_common:URI*, inspire_common:ResourceLocator*)><!ATTLIST inspire_common:OriginatingControlledVocabulary xmlns:inspire_common CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\">\n");
+    if (nVersion == OWS_1_1_1 && msOWSLookupMetadata(&(map->web.metadata), "MO",
+                                                     "inspire_capabilities")) {
+      msIO_printf(
+          "<!ELEMENT VendorSpecificCapabilities "
+          "(inspire_vs:ExtendedCapabilities)><!ELEMENT "
+          "inspire_vs:ExtendedCapabilities ((inspire_common:MetadataUrl, "
+          "inspire_common:SupportedLanguages, inspire_common:ResponseLanguage) "
+          "| (inspire_common:ResourceLocator+, inspire_common:ResourceType, "
+          "inspire_common:TemporalReference+, inspire_common:Conformity+, "
+          "inspire_common:MetadataPointOfContact+, "
+          "inspire_common:MetadataDate, inspire_common:SpatialDataServiceType, "
+          "inspire_common:MandatoryKeyword+, inspire_common:Keyword*, "
+          "inspire_common:SupportedLanguages, inspire_common:ResponseLanguage, "
+          "inspire_common:MetadataUrl?))><!ATTLIST "
+          "inspire_vs:ExtendedCapabilities xmlns:inspire_vs CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/inspire_vs/1.0\" ><!ELEMENT "
+          "inspire_common:MetadataUrl (inspire_common:URL, "
+          "inspire_common:MediaType*)><!ATTLIST inspire_common:MetadataUrl "
+          "xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\" xmlns:xsi CDATA "
+          "#FIXED \"http://www.w3.org/2001/XMLSchema-instance\" xsi:type CDATA "
+          "#FIXED \"inspire_common:resourceLocatorType\" ><!ELEMENT "
+          "inspire_common:URL (#PCDATA)><!ATTLIST inspire_common:URL "
+          "xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\"><!ELEMENT "
+          "inspire_common:MediaType (#PCDATA)><!ATTLIST "
+          "inspire_common:MediaType xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\"><!ELEMENT "
+          "inspire_common:SupportedLanguages (inspire_common:DefaultLanguage, "
+          "inspire_common:SupportedLanguage*)><!ATTLIST "
+          "inspire_common:SupportedLanguages xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT "
+          "inspire_common:DefaultLanguage (inspire_common:Language)><!ATTLIST "
+          "inspire_common:DefaultLanguage xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT "
+          "inspire_common:SupportedLanguage "
+          "(inspire_common:Language)><!ATTLIST "
+          "inspire_common:SupportedLanguage xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\" >"
+          "<!ELEMENT inspire_common:ResponseLanguage "
+          "(inspire_common:Language)><!ATTLIST inspire_common:ResponseLanguage "
+          "xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT "
+          "inspire_common:Language (#PCDATA)><!ATTLIST inspire_common:Language "
+          "xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT "
+          "inspire_common:ResourceLocator (inspire_common:URL, "
+          "inspire_common:MediaType*)><!ATTLIST inspire_common:ResourceLocator "
+          "xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\"><!ELEMENT "
+          "inspire_common:ResourceType (#PCDATA)> <!ATTLIST "
+          "inspire_common:ResourceType xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT "
+          "inspire_common:TemporalReference (inspire_common:DateOfCreation?, "
+          "inspire_common:DateOfLastRevision?, "
+          "inspire_common:DateOfPublication*, "
+          "inspire_common:TemporalExtent*)><!ATTLIST "
+          "inspire_common:TemporalReference xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT "
+          "inspire_common:DateOfCreation (#PCDATA)> <!ATTLIST "
+          "inspire_common:DateOfCreation xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\"><!ELEMENT "
+          "inspire_common:DateOfLastRevision (#PCDATA)><!ATTLIST "
+          "inspire_common:DateOfLastRevision xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\"><!ELEMENT "
+          "inspire_common:DateOfPublication (#PCDATA)><!ATTLIST "
+          "inspire_common:DateOfPublication xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\"><!ELEMENT "
+          "inspire_common:TemporalExtent (inspire_common:IndividualDate | "
+          "inspire_common:IntervalOfDates)><!ATTLIST "
+          "inspire_common:TemporalExtent xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT "
+          "inspire_common:IndividualDate (#PCDATA)> <!ATTLIST "
+          "inspire_common:IndividualDate xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\">"
+          "<!ELEMENT inspire_common:IntervalOfDates "
+          "(inspire_common:StartingDate, inspire_common:EndDate)><!ATTLIST "
+          "inspire_common:IntervalOfDates xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT "
+          "inspire_common:StartingDate (#PCDATA)><!ATTLIST "
+          "inspire_common:StartingDate xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT "
+          "inspire_common:EndDate (#PCDATA)><!ATTLIST inspire_common:EndDate "
+          "xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT "
+          "inspire_common:Conformity (inspire_common:Specification, "
+          "inspire_common:Degree)><!ATTLIST inspire_common:Conformity "
+          "xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT "
+          "inspire_common:Specification (inspire_common:Title, "
+          "(inspire_common:DateOfPublication | inspire_common:DateOfCreation | "
+          "inspire_common:DateOfLastRevision), inspire_common:URI*, "
+          "inspire_common:ResourceLocator*)><!ATTLIST "
+          "inspire_common:Specification xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT "
+          "inspire_common:Title (#PCDATA)><!ATTLIST inspire_common:Title "
+          "xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT "
+          "inspire_common:URI (#PCDATA)><!ATTLIST inspire_common:URI "
+          "xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT "
+          "inspire_common:Degree (#PCDATA)><!ATTLIST inspire_common:Degree "
+          "xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT "
+          "inspire_common:MetadataPointOfContact "
+          "(inspire_common:OrganisationName, "
+          "inspire_common:EmailAddress)><!ATTLIST "
+          "inspire_common:MetadataPointOfContact xmlns:inspire_common CDATA "
+          "#FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\" >"
+          "<!ELEMENT inspire_common:OrganisationName (#PCDATA)><!ATTLIST "
+          "inspire_common:OrganisationName  xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT "
+          "inspire_common:EmailAddress (#PCDATA)><!ATTLIST "
+          "inspire_common:EmailAddress xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT "
+          "inspire_common:MetadataDate (#PCDATA)><!ATTLIST "
+          "inspire_common:MetadataDate xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT "
+          "inspire_common:SpatialDataServiceType (#PCDATA)><!ATTLIST "
+          "inspire_common:SpatialDataServiceType xmlns:inspire_common CDATA "
+          "#FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\" "
+          "><!ELEMENT inspire_common:MandatoryKeyword "
+          "(inspire_common:KeywordValue)><!ATTLIST "
+          "inspire_common:MandatoryKeyword xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\" ><!ELEMENT "
+          "inspire_common:KeywordValue (#PCDATA)><!ATTLIST "
+          "inspire_common:KeywordValue xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\" >"
+          "<!ELEMENT inspire_common:Keyword "
+          "(inspire_common:OriginatingControlledVocabulary?, "
+          "inspire_common:KeywordValue)><!ATTLIST inspire_common:Keyword "
+          "xmlns:inspire_common CDATA #FIXED "
+          "\"http://inspire.ec.europa.eu/schemas/common/1.0\" xmlns:xsi CDATA "
+          "#FIXED \"http://www.w3.org/2001/XMLSchemainstance\" xsi:type "
+          "(inspire_common:inspireTheme_bul | inspire_common:inspireTheme_cze "
+          "| inspire_common:inspireTheme_dan | inspire_common:inspireTheme_dut "
+          "| inspire_common:inspireTheme_eng | inspire_common:inspireTheme_est "
+          "| inspire_common:inspireTheme_fin | inspire_common:inspireTheme_fre "
+          "| inspire_common:inspireTheme_ger | inspire_common:inspireTheme_gre "
+          "| inspire_common:inspireTheme_hun | inspire_common:inspireTheme_gle "
+          "| inspire_common:inspireTheme_ita | inspire_common:inspireTheme_lav "
+          "| inspire_common:inspireTheme_lit | inspire_common:inspireTheme_mlt "
+          "| inspire_common:inspireTheme_pol | inspire_common:inspireTheme_por "
+          "| inspire_common:inspireTheme_rum | inspire_common:inspireTheme_slo "
+          "| inspire_common:inspireTheme_slv | inspire_common:inspireTheme_spa "
+          "| inspire_common:inspireTheme_swe) #IMPLIED ><!ELEMENT "
+          "inspire_common:OriginatingControlledVocabulary "
+          "(inspire_common:Title, (inspire_common:DateOfPublication | "
+          "inspire_common:DateOfCreation | inspire_common:DateOfLastRevision), "
+          "inspire_common:URI*, inspire_common:ResourceLocator*)><!ATTLIST "
+          "inspire_common:OriginatingControlledVocabulary xmlns:inspire_common "
+          "CDATA #FIXED \"http://inspire.ec.europa.eu/schemas/common/1.0\">\n");
     } else {
       /* some mapserver specific declarations will go here */
       msIO_printf(" <!ELEMENT VendorSpecificCapabilities EMPTY>\n");
@@ -2863,39 +3277,48 @@ int msWMSGetCapabilities(mapObj *map, in
   }
 
   char szVersionBuf[OWS_VERSION_MAXLEN];
-  const char* pszVersion = msOWSGetVersionString(nVersion, szVersionBuf);
-  if ( nVersion >= OWS_1_3_0)
+  const char *pszVersion = msOWSGetVersionString(nVersion, szVersionBuf);
+  if (nVersion >= OWS_1_3_0)
     msIO_printf("<WMS_Capabilities version=\"%s\"", pszVersion);
   else
     msIO_printf("<WMT_MS_Capabilities version=\"%s\"", pszVersion);
   if (updatesequence)
-    msIO_printf(" updateSequence=\"%s\"",updatesequence);
-
+    msIO_printf(" updateSequence=\"%s\"", updatesequence);
 
-  if ( nVersion == OWS_1_3_0) {
+  if (nVersion == OWS_1_3_0) {
     msIO_printf("  xmlns=\"http://www.opengis.net/wms\""
                 "   xmlns:sld=\"http://www.opengis.net/sld\""
                 "   xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\""
                 "   xmlns:ms=\"http://mapserver.gis.umn.edu/mapserver\"");
 
-    if ( msOWSLookupMetadata(&(map->web.metadata), "MO", "inspire_capabilities") ) {
-      msIO_printf("   xmlns:" MS_INSPIRE_COMMON_NAMESPACE_PREFIX "=\"" MS_INSPIRE_COMMON_NAMESPACE_URI "\""
-                  "   xmlns:" MS_INSPIRE_VS_NAMESPACE_PREFIX "=\"" MS_INSPIRE_VS_NAMESPACE_URI "\"" );
-    }
-
-    msIO_printf("   xsi:schemaLocation=\"http://www.opengis.net/wms %s/wms/%s/capabilities_1_3_0.xsd "
-                " http://www.opengis.net/sld %s/sld/1.1.0/sld_capabilities.xsd ",
-                msOWSGetSchemasLocation(map), pszVersion, msOWSGetSchemasLocation(map));
-
-    if ( msOWSLookupMetadata(&(map->web.metadata), "MO", "inspire_capabilities") ) {
-      char* inspireschemalocation = msEncodeHTMLEntities( msOWSGetInspireSchemasLocation(map) );
+    if (msOWSLookupMetadata(&(map->web.metadata), "MO",
+                            "inspire_capabilities")) {
+      msIO_printf("   xmlns:" MS_INSPIRE_COMMON_NAMESPACE_PREFIX
+                  "=\"" MS_INSPIRE_COMMON_NAMESPACE_URI "\""
+                  "   xmlns:" MS_INSPIRE_VS_NAMESPACE_PREFIX
+                  "=\"" MS_INSPIRE_VS_NAMESPACE_URI "\"");
+    }
+
+    msIO_printf(
+        "   xsi:schemaLocation=\"http://www.opengis.net/wms "
+        "%s/wms/%s/capabilities_1_3_0.xsd "
+        " http://www.opengis.net/sld %s/sld/1.1.0/sld_capabilities.xsd ",
+        msOWSGetSchemasLocation(map), pszVersion, msOWSGetSchemasLocation(map));
+
+    if (msOWSLookupMetadata(&(map->web.metadata), "MO",
+                            "inspire_capabilities")) {
+      char *inspireschemalocation =
+          msEncodeHTMLEntities(msOWSGetInspireSchemasLocation(map));
       msIO_printf(" " MS_INSPIRE_VS_NAMESPACE_URI " "
-                  " %s%s", inspireschemalocation, MS_INSPIRE_VS_SCHEMA_LOCATION);
+                  " %s%s",
+                  inspireschemalocation, MS_INSPIRE_VS_SCHEMA_LOCATION);
       free(inspireschemalocation);
     }
 
-    msIO_printf(" http://mapserver.gis.umn.edu/mapserver %sservice=WMS&amp;version=1.3.0&amp;request=GetSchemaExtension\"",
-                script_url_encoded);
+    msIO_printf(
+        " http://mapserver.gis.umn.edu/mapserver "
+        "%sservice=WMS&amp;version=1.3.0&amp;request=GetSchemaExtension\"",
+        script_url_encoded);
   }
 
   msIO_printf(">\n");
@@ -2905,34 +3328,37 @@ int msWMSGetCapabilities(mapObj *map, in
 
   /* Service name is defined by the spec and changed at v1.0.0 */
   if (nVersion <= OWS_1_0_7)
-    msIO_printf("  <Name>GetMap</Name>\n");  /* v 1.0.0 to 1.0.7 */
+    msIO_printf("  <Name>GetMap</Name>\n"); /* v 1.0.0 to 1.0.7 */
   else if (nVersion > OWS_1_0_7 && nVersion < OWS_1_3_0)
     msIO_printf("  <Name>OGC:WMS</Name>\n"); /* v 1.1.0 to 1.1.1*/
   else
     msIO_printf("  <Name>WMS</Name>\n"); /* v 1.3.0+ */
 
-
-  /* the majority of this section is dependent on appropriately named metadata in the WEB object */
+  /* the majority of this section is dependent on appropriately named metadata
+   * in the WEB object */
   msOWSPrintEncodeMetadata2(stdout, &(map->web.metadata), "MO", "title",
-                            OWS_WARN, "  <Title>%s</Title>\n", map->name, validated_language.c_str());
+                            OWS_WARN, "  <Title>%s</Title>\n", map->name,
+                            validated_language.c_str());
   msOWSPrintEncodeMetadata2(stdout, &(map->web.metadata), "MO", "abstract",
-                            OWS_NOERR, "  <Abstract>%s</Abstract>\n", NULL, validated_language.c_str());
+                            OWS_NOERR, "  <Abstract>%s</Abstract>\n", NULL,
+                            validated_language.c_str());
 
-  msWMSPrintKeywordlist(stdout, "  ", "keywordlist", &(map->web.metadata), "MO", nVersion);
+  msWMSPrintKeywordlist(stdout, "  ", "keywordlist", &(map->web.metadata), "MO",
+                        nVersion);
 
   /* Service/onlineresource */
-  /* Defaults to same as request onlineresource if wms_service_onlineresource  */
+  /* Defaults to same as request onlineresource if wms_service_onlineresource */
   /* is not set. */
-  if (nVersion== OWS_1_0_0)
-    msOWSPrintEncodeMetadata(stdout, &(map->web.metadata),
-                             "MO", "service_onlineresource", OWS_NOERR,
-                             "  <OnlineResource>%s</OnlineResource>\n",
-                             script_url_encoded);
+  if (nVersion == OWS_1_0_0)
+    msOWSPrintEncodeMetadata(
+        stdout, &(map->web.metadata), "MO", "service_onlineresource", OWS_NOERR,
+        "  <OnlineResource>%s</OnlineResource>\n", script_url_encoded);
   else
-    msOWSPrintEncodeMetadata(stdout, &(map->web.metadata),
-                             "MO", "service_onlineresource", OWS_NOERR,
-                             "  <OnlineResource xmlns:xlink=\"http://www.w3.org/1999/xlink\" xlink:href=\"%s\"/>\n",
-                             script_url_encoded);
+    msOWSPrintEncodeMetadata(
+        stdout, &(map->web.metadata), "MO", "service_onlineresource", OWS_NOERR,
+        "  <OnlineResource xmlns:xlink=\"http://www.w3.org/1999/xlink\" "
+        "xlink:href=\"%s\"/>\n",
+        script_url_encoded);
 
   /* contact information is a required element in 1.0.7 but the */
   /* sub-elements such as ContactPersonPrimary, etc. are not! */
@@ -2942,12 +3368,13 @@ int msWMSGetCapabilities(mapObj *map, in
   msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "MO", "fees",
                            OWS_NOERR, "  <Fees>%s</Fees>\n", NULL);
 
-  msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "MO",
-                           "accessconstraints", OWS_NOERR,
-                           "  <AccessConstraints>%s</AccessConstraints>\n", NULL);
+  msOWSPrintEncodeMetadata(
+      stdout, &(map->web.metadata), "MO", "accessconstraints", OWS_NOERR,
+      "  <AccessConstraints>%s</AccessConstraints>\n", NULL);
 
   if (nVersion >= OWS_1_3_0) {
-    const char* layerlimit = msOWSLookupMetadata(&(map->web.metadata), "MO", "layerlimit");
+    const char *layerlimit =
+        msOWSLookupMetadata(&(map->web.metadata), "MO", "layerlimit");
     if (layerlimit) {
       msIO_printf("  <LayerLimit>%s</LayerLimit>\n", layerlimit);
     }
@@ -2962,9 +3389,11 @@ int msWMSGetCapabilities(mapObj *map, in
   msIO_printf("  <Request>\n");
 
   if (nVersion <= OWS_1_0_7) {
-    /* WMS 1.0.0 to 1.0.7 - We don't try to use outputformats list here for now */
+    /* WMS 1.0.0 to 1.0.7 - We don't try to use outputformats list here for now
+     */
     if (msOWSRequestIsEnabled(map, NULL, "M", "GetMap", MS_FALSE))
-      msWMSPrintRequestCap(nVersion, "Map", script_url_encoded, ""
+      msWMSPrintRequestCap(nVersion, "Map", script_url_encoded,
+                           ""
 
 #if defined USE_PNG
                            "<PNG />"
@@ -2972,12 +3401,14 @@ int msWMSGetCapabilities(mapObj *map, in
 #if defined USE_JPEG
                            "<JPEG />"
 #endif
-                           "<SVG />"
-                           , NULL);
+                           "<SVG />",
+                           NULL);
     if (msOWSRequestIsEnabled(map, NULL, "M", "GetCapabilities", MS_TRUE))
-      msWMSPrintRequestCap(nVersion, "Capabilities", script_url_encoded, "<WMS_XML />", NULL);
+      msWMSPrintRequestCap(nVersion, "Capabilities", script_url_encoded,
+                           "<WMS_XML />", NULL);
     if (msOWSRequestIsEnabled(map, NULL, "M", "GetFeatureInfo", MS_FALSE))
-      msWMSPrintRequestCap(nVersion, "FeatureInfo", script_url_encoded, "<MIME /><GML.1 />", NULL);
+      msWMSPrintRequestCap(nVersion, "FeatureInfo", script_url_encoded,
+                           "<MIME /><GML.1 />", NULL);
   } else {
     const char *mime_list[20];
     int mime_count = 0;
@@ -2988,26 +3419,25 @@ int msWMSGetCapabilities(mapObj *map, in
     if (msOWSRequestIsEnabled(map, NULL, "M", "GetCapabilities", MS_TRUE)) {
       if (nVersion >= OWS_1_3_0)
         msWMSPrintRequestCap(nVersion, "GetCapabilities", script_url_encoded,
-                             "text/xml",
-                             NULL);
+                             "text/xml", NULL);
       else
         msWMSPrintRequestCap(nVersion, "GetCapabilities", script_url_encoded,
-                             "application/vnd.ogc.wms_xml",
-                             NULL);
+                             "application/vnd.ogc.wms_xml", NULL);
     }
 
-    msGetOutputFormatMimeListWMS(map,mime_list,sizeof(mime_list)/sizeof(char*));
+    msGetOutputFormatMimeListWMS(map, mime_list,
+                                 sizeof(mime_list) / sizeof(char *));
     if (msOWSRequestIsEnabled(map, NULL, "M", "GetMap", MS_FALSE))
-      msWMSPrintRequestCap(nVersion, "GetMap", script_url_encoded,
-                           mime_list[0], mime_list[1], mime_list[2], mime_list[3],
-                           mime_list[4], mime_list[5], mime_list[6], mime_list[7],
-                           mime_list[8], mime_list[9], mime_list[10], mime_list[11],
-                           mime_list[12], mime_list[13], mime_list[14], mime_list[15],
-                           mime_list[16], mime_list[17], mime_list[18], mime_list[19],
-                           NULL );
+      msWMSPrintRequestCap(
+          nVersion, "GetMap", script_url_encoded, mime_list[0], mime_list[1],
+          mime_list[2], mime_list[3], mime_list[4], mime_list[5], mime_list[6],
+          mime_list[7], mime_list[8], mime_list[9], mime_list[10],
+          mime_list[11], mime_list[12], mime_list[13], mime_list[14],
+          mime_list[15], mime_list[16], mime_list[17], mime_list[18],
+          mime_list[19], NULL);
 
-    const char* format_list = msOWSLookupMetadata(&(map->web.metadata), "M",
-                                      "getfeatureinfo_formatlist");
+    const char *format_list = msOWSLookupMetadata(&(map->web.metadata), "M",
+                                                  "getfeatureinfo_formatlist");
     /*feature_info_mime_type depricated for MapServer 6.0*/
     if (!format_list)
       format_list = msOWSLookupMetadata(&(map->web.metadata), "MO",
@@ -3015,92 +3445,93 @@ int msWMSGetCapabilities(mapObj *map, in
 
     if (format_list && strlen(format_list) > 0) {
       auto tokens = msStringSplit(format_list, ',');
-      for(auto& token: tokens) {
-          msStringTrim(token);
-          /*text plain and gml do not need to be a format and accepted by default*/
-          /*can not really validate since the old way of using template
-            with wei->header, layer->template ... should be kept*/
-          if (!token.empty() && mime_count<max_mime)
-            mime_list[mime_count++] = token.c_str();
+      for (auto &token : tokens) {
+        msStringTrim(token);
+        /*text plain and gml do not need to be a format and accepted by
+         * default*/
+        /*can not really validate since the old way of using template
+          with wei->header, layer->template ... should be kept*/
+        if (!token.empty() && mime_count < max_mime)
+          mime_list[mime_count++] = token.c_str();
       }
       /*add text/plain and gml */
       if (strcasestr(format_list, "GML") == 0 &&
           strcasestr(format_list, "application/vnd.ogc.gml") == 0) {
-        if (mime_count<max_mime)
+        if (mime_count < max_mime)
           mime_list[mime_count++] = "application/vnd.ogc.gml";
       }
       if (strcasestr(format_list, "text/plain") == 0 &&
           strcasestr(format_list, "MIME") == 0) {
-        if (mime_count<max_mime)
+        if (mime_count < max_mime)
           mime_list[mime_count++] = "text/plain";
         else /*force always this format*/
-          mime_list[max_mime-1] = "text/plain";
+          mime_list[max_mime - 1] = "text/plain";
       }
 
-
       if (msOWSRequestIsEnabled(map, NULL, "M", "GetFeatureInfo", MS_FALSE)) {
-        if (mime_count>0) {
-          if (mime_count<max_mime)
+        if (mime_count > 0) {
+          if (mime_count < max_mime)
             mime_list[mime_count] = NULL;
-          msWMSPrintRequestCap(nVersion, "GetFeatureInfo", script_url_encoded,
-                               mime_list[0], mime_list[1], mime_list[2], mime_list[3],
-                               mime_list[4], mime_list[5], mime_list[6], mime_list[7],
-                               mime_list[8], mime_list[9], mime_list[10], mime_list[11],
-                               mime_list[12], mime_list[13], mime_list[14], mime_list[15],
-                               mime_list[16], mime_list[17], mime_list[18], mime_list[19],
-                               NULL);
+          msWMSPrintRequestCap(
+              nVersion, "GetFeatureInfo", script_url_encoded, mime_list[0],
+              mime_list[1], mime_list[2], mime_list[3], mime_list[4],
+              mime_list[5], mime_list[6], mime_list[7], mime_list[8],
+              mime_list[9], mime_list[10], mime_list[11], mime_list[12],
+              mime_list[13], mime_list[14], mime_list[15], mime_list[16],
+              mime_list[17], mime_list[18], mime_list[19], NULL);
         }
         /*if all formats given are invalid go to default*/
         else
           msWMSPrintRequestCap(nVersion, "GetFeatureInfo", script_url_encoded,
-                               "text/plain",
-                               "application/vnd.ogc.gml",
-                               NULL);
+                               "text/plain", "application/vnd.ogc.gml", NULL);
       }
     } else {
       if (msOWSRequestIsEnabled(map, NULL, "M", "GetFeatureInfo", MS_FALSE))
         msWMSPrintRequestCap(nVersion, "GetFeatureInfo", script_url_encoded,
-                             "text/plain",
-                             "application/vnd.ogc.gml",
-                             NULL);
+                             "text/plain", "application/vnd.ogc.gml", NULL);
     }
 
-
     if (strcasecmp(sldenabled, "true") == 0) {
       if (msOWSRequestIsEnabled(map, NULL, "M", "DescribeLayer", MS_FALSE)) {
         if (nVersion == OWS_1_3_0)
-          msWMSPrintRequestCap(nVersion, "sld:DescribeLayer", script_url_encoded, "text/xml", NULL);
+          msWMSPrintRequestCap(nVersion, "sld:DescribeLayer",
+                               script_url_encoded, "text/xml", NULL);
         else
-          msWMSPrintRequestCap(nVersion, "DescribeLayer", script_url_encoded, "text/xml", NULL);
+          msWMSPrintRequestCap(nVersion, "DescribeLayer", script_url_encoded,
+                               "text/xml", NULL);
       }
 
-      msGetOutputFormatMimeListImg(map,mime_list,sizeof(mime_list)/sizeof(char*));
+      msGetOutputFormatMimeListImg(map, mime_list,
+                                   sizeof(mime_list) / sizeof(char *));
 
       if (nVersion >= OWS_1_1_1) {
         const auto isGetLegendGraphicEnabled =
             msOWSRequestIsEnabled(map, NULL, "M", "GetLegendGraphic", MS_FALSE);
         if (nVersion == OWS_1_3_0) {
           if (isGetLegendGraphicEnabled)
-            msWMSPrintRequestCap(nVersion, "sld:GetLegendGraphic", script_url_encoded,
-                                 mime_list[0], mime_list[1], mime_list[2], mime_list[3],
-                                 mime_list[4], mime_list[5], mime_list[6], mime_list[7],
-                                 mime_list[8], mime_list[9], mime_list[10], mime_list[11],
-                                 mime_list[12], mime_list[13], mime_list[14], mime_list[15],
-                                 mime_list[16], mime_list[17], mime_list[18], mime_list[19],
-                                 NULL );
+            msWMSPrintRequestCap(
+                nVersion, "sld:GetLegendGraphic", script_url_encoded,
+                mime_list[0], mime_list[1], mime_list[2], mime_list[3],
+                mime_list[4], mime_list[5], mime_list[6], mime_list[7],
+                mime_list[8], mime_list[9], mime_list[10], mime_list[11],
+                mime_list[12], mime_list[13], mime_list[14], mime_list[15],
+                mime_list[16], mime_list[17], mime_list[18], mime_list[19],
+                NULL);
           if (msOWSRequestIsEnabled(map, NULL, "M", "GetStyles", MS_FALSE))
-            msWMSPrintRequestCap(nVersion, "ms:GetStyles", script_url_encoded, "text/xml", NULL);
+            msWMSPrintRequestCap(nVersion, "ms:GetStyles", script_url_encoded,
+                                 "text/xml", NULL);
         } else {
           if (isGetLegendGraphicEnabled)
-            msWMSPrintRequestCap(nVersion, "GetLegendGraphic", script_url_encoded,
-                                 mime_list[0], mime_list[1], mime_list[2], mime_list[3],
-                                 mime_list[4], mime_list[5], mime_list[6], mime_list[7],
-                                 mime_list[8], mime_list[9], mime_list[10], mime_list[11],
-                                 mime_list[12], mime_list[13], mime_list[14], mime_list[15],
-                                 mime_list[16], mime_list[17], mime_list[18], mime_list[19],
-                                 NULL );
+            msWMSPrintRequestCap(
+                nVersion, "GetLegendGraphic", script_url_encoded, mime_list[0],
+                mime_list[1], mime_list[2], mime_list[3], mime_list[4],
+                mime_list[5], mime_list[6], mime_list[7], mime_list[8],
+                mime_list[9], mime_list[10], mime_list[11], mime_list[12],
+                mime_list[13], mime_list[14], mime_list[15], mime_list[16],
+                mime_list[17], mime_list[18], mime_list[19], NULL);
           if (msOWSRequestIsEnabled(map, NULL, "M", "GetStyles", MS_FALSE))
-            msWMSPrintRequestCap(nVersion, "GetStyles", script_url_encoded, "text/xml", NULL);
+            msWMSPrintRequestCap(nVersion, "GetStyles", script_url_encoded,
+                                 "text/xml", NULL);
         }
       }
     }
@@ -3119,15 +3550,17 @@ int msWMSGetCapabilities(mapObj *map, in
     msIO_printf("    <Format>XML</Format>\n");
     msIO_printf("    <Format>INIMAGE</Format>\n");
     msIO_printf("    <Format>BLANK</Format>\n");
-
   }
   msIO_printf("  </Exception>\n");
 
   if (nVersion != OWS_1_3_0) {
     /* INSPIRE extended capabilities for WMS 1.1.1 */
-    if (nVersion == OWS_1_1_1 && msOWSLookupMetadata(&(map->web.metadata), "MO", "inspire_capabilities") ) {
+    if (nVersion == OWS_1_1_1 && msOWSLookupMetadata(&(map->web.metadata), "MO",
+                                                     "inspire_capabilities")) {
       msIO_printf("  <VendorSpecificCapabilities>\n");
-      msOWSPrintInspireCommonExtendedCapabilities(stdout, map, "MO", OWS_WARN, "inspire_vs:ExtendedCapabilities", NULL, validated_language.c_str(), OWS_WMS);
+      msOWSPrintInspireCommonExtendedCapabilities(
+          stdout, map, "MO", OWS_WARN, "inspire_vs:ExtendedCapabilities", NULL,
+          validated_language.c_str(), OWS_WMS);
       msIO_printf("  </VendorSpecificCapabilities>\n");
     } else {
       msIO_printf("  <VendorSpecificCapabilities />\n"); /* nothing yet */
@@ -3138,106 +3571,135 @@ int msWMSGetCapabilities(mapObj *map, in
   if (strcasecmp(sldenabled, "true") == 0) {
     if (nVersion >= OWS_1_0_7) {
       if (nVersion >= OWS_1_3_0)
-        msIO_printf("  <sld:UserDefinedSymbolization SupportSLD=\"1\" UserLayer=\"0\" UserStyle=\"1\" RemoteWFS=\"0\" InlineFeature=\"0\" RemoteWCS=\"0\"/>\n");
+        msIO_printf("  <sld:UserDefinedSymbolization SupportSLD=\"1\" "
+                    "UserLayer=\"0\" UserStyle=\"1\" RemoteWFS=\"0\" "
+                    "InlineFeature=\"0\" RemoteWCS=\"0\"/>\n");
       else
-        msIO_printf("  <UserDefinedSymbolization SupportSLD=\"1\" UserLayer=\"0\" UserStyle=\"1\" RemoteWFS=\"0\"/>\n");
+        msIO_printf("  <UserDefinedSymbolization SupportSLD=\"1\" "
+                    "UserLayer=\"0\" UserStyle=\"1\" RemoteWFS=\"0\"/>\n");
     }
   }
 
   /* INSPIRE extended capabilities for WMS 1.3.0 */
-  if (nVersion >= OWS_1_3_0 && msOWSLookupMetadata(&(map->web.metadata), "MO", "inspire_capabilities") ) {
-    msOWSPrintInspireCommonExtendedCapabilities(stdout, map, "MO", OWS_WARN, "inspire_vs:ExtendedCapabilities", NULL, validated_language.c_str(), OWS_WMS);
+  if (nVersion >= OWS_1_3_0 &&
+      msOWSLookupMetadata(&(map->web.metadata), "MO", "inspire_capabilities")) {
+    msOWSPrintInspireCommonExtendedCapabilities(
+        stdout, map, "MO", OWS_WARN, "inspire_vs:ExtendedCapabilities", NULL,
+        validated_language.c_str(), OWS_WMS);
   }
 
   /* Top-level layer with map extents and SRS, encloses all map layers */
   /* Output only if at least one layers is enabled. */
   if (ows_request->numlayers == 0) {
-    msIO_fprintf(stdout, "  <!-- WARNING: No WMS layers are enabled. Check wms/ows_enable_request settings. -->\n");
+    msIO_fprintf(stdout, "  <!-- WARNING: No WMS layers are enabled. Check "
+                         "wms/ows_enable_request settings. -->\n");
   } else {
     int root_is_queryable = MS_FALSE;
 
-    const char* rootlayer_name = msOWSLookupMetadata(&(map->web.metadata), "MO", "rootlayer_name");
+    const char *rootlayer_name =
+        msOWSLookupMetadata(&(map->web.metadata), "MO", "rootlayer_name");
 
     /* Root layer is queryable if it has a valid name and at list one layer */
     /* is queryable */
-    if( !rootlayer_name || strlen(rootlayer_name) > 0 ) {
+    if (!rootlayer_name || strlen(rootlayer_name) > 0) {
       int j;
-      for(j=0; j<map->numlayers; j++) {
-        layerObj* layer = GET_LAYER(map, j);
-        if( msIsLayerQueryable(layer) &&
-            msIntegerInArray(layer->index, ows_request->enabled_layers, ows_request->numlayers) ) {
+      for (j = 0; j < map->numlayers; j++) {
+        layerObj *layer = GET_LAYER(map, j);
+        if (msIsLayerQueryable(layer) &&
+            msIntegerInArray(layer->index, ows_request->enabled_layers,
+                             ows_request->numlayers)) {
           root_is_queryable = MS_TRUE;
           break;
         }
       }
     }
-    msIO_printf("  <Layer%s>\n",root_is_queryable ? " queryable=\"1\"" : "");
+    msIO_printf("  <Layer%s>\n", root_is_queryable ? " queryable=\"1\"" : "");
 
     /* Layer Name is optional but title is mandatory. */
     if (map->name && strlen(map->name) > 0 &&
         (msIsXMLTagValid(map->name) == MS_FALSE || isdigit(map->name[0])))
-      msIO_fprintf(stdout, "<!-- WARNING: The layer name '%s' might contain spaces or "
-                   "invalid characters or may start with a number. This could lead to potential problems. -->\n",
+      msIO_fprintf(stdout,
+                   "<!-- WARNING: The layer name '%s' might contain spaces or "
+                   "invalid characters or may start with a number. This could "
+                   "lead to potential problems. -->\n",
                    map->name);
 
     if (rootlayer_name) {
-        if (strlen(rootlayer_name) > 0) {
-            msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "MO", "rootlayer_name",
-                                     OWS_NOERR, "    <Name>%s</Name>\n",
-                                     NULL);
-        }
-    }
-    else {
-        msOWSPrintEncodeParam(stdout, "MAP.NAME", map->name, OWS_NOERR,
-                              "    <Name>%s</Name>\n", NULL);
+      if (strlen(rootlayer_name) > 0) {
+        msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "MO",
+                                 "rootlayer_name", OWS_NOERR,
+                                 "    <Name>%s</Name>\n", NULL);
+      }
+    } else {
+      msOWSPrintEncodeParam(stdout, "MAP.NAME", map->name, OWS_NOERR,
+                            "    <Name>%s</Name>\n", NULL);
     }
 
-    if (msOWSLookupMetadataWithLanguage(&(map->web.metadata), "MO", "rootlayer_title", validated_language.c_str()))
-      msOWSPrintEncodeMetadata2(stdout, &(map->web.metadata), "MO", "rootlayer_title", OWS_WARN, "    <Title>%s</Title>\n", map->name, validated_language.c_str());
+    if (msOWSLookupMetadataWithLanguage(&(map->web.metadata), "MO",
+                                        "rootlayer_title",
+                                        validated_language.c_str()))
+      msOWSPrintEncodeMetadata2(
+          stdout, &(map->web.metadata), "MO", "rootlayer_title", OWS_WARN,
+          "    <Title>%s</Title>\n", map->name, validated_language.c_str());
 
     else
-      msOWSPrintEncodeMetadata2(stdout, &(map->web.metadata), "MO", "title", OWS_WARN, "    <Title>%s</Title>\n", map->name, validated_language.c_str());
-
-    if (msOWSLookupMetadataWithLanguage(&(map->web.metadata), "MO", "rootlayer_abstract", validated_language.c_str()))
-      msOWSPrintEncodeMetadata2(stdout, &(map->web.metadata), "MO", "rootlayer_abstract", OWS_NOERR, "    <Abstract>%s</Abstract>\n", map->name, validated_language.c_str());
+      msOWSPrintEncodeMetadata2(stdout, &(map->web.metadata), "MO", "title",
+                                OWS_WARN, "    <Title>%s</Title>\n", map->name,
+                                validated_language.c_str());
+
+    if (msOWSLookupMetadataWithLanguage(&(map->web.metadata), "MO",
+                                        "rootlayer_abstract",
+                                        validated_language.c_str()))
+      msOWSPrintEncodeMetadata2(stdout, &(map->web.metadata), "MO",
+                                "rootlayer_abstract", OWS_NOERR,
+                                "    <Abstract>%s</Abstract>\n", map->name,
+                                validated_language.c_str());
     else
-      msOWSPrintEncodeMetadata2(stdout, &(map->web.metadata), "MO", "abstract", OWS_NOERR, "    <Abstract>%s</Abstract>\n", map->name, validated_language.c_str());
-
-    const char* pszTmp;
-    if (msOWSLookupMetadata(&(map->web.metadata), "MO", "rootlayer_keywordlist") ||
-        msOWSLookupMetadata(&(map->web.metadata), "MO", "rootlayer_keywordlist_vocabulary"))
+      msOWSPrintEncodeMetadata2(stdout, &(map->web.metadata), "MO", "abstract",
+                                OWS_NOERR, "    <Abstract>%s</Abstract>\n",
+                                map->name, validated_language.c_str());
+
+    const char *pszTmp;
+    if (msOWSLookupMetadata(&(map->web.metadata), "MO",
+                            "rootlayer_keywordlist") ||
+        msOWSLookupMetadata(&(map->web.metadata), "MO",
+                            "rootlayer_keywordlist_vocabulary"))
       pszTmp = "rootlayer_keywordlist";
     else
       pszTmp = "keywordlist";
-    msWMSPrintKeywordlist(stdout, "    ", pszTmp, &(map->web.metadata), "MO", nVersion);
+    msWMSPrintKeywordlist(stdout, "    ", pszTmp, &(map->web.metadata), "MO",
+                          nVersion);
 
-    /* According to normative comments in the 1.0.7 DTD, the root layer's SRS tag */
-    /* is REQUIRED.  It also suggests that we use an empty SRS element if there */
+    /* According to normative comments in the 1.0.7 DTD, the root layer's SRS
+     * tag */
+    /* is REQUIRED.  It also suggests that we use an empty SRS element if there
+     */
     /* is no common SRS. */
     char *pszMapEPSG;
-    msOWSGetEPSGProj(&(map->projection), &(map->web.metadata), "MO", MS_FALSE, &pszMapEPSG);
+    msOWSGetEPSGProj(&(map->projection), &(map->web.metadata), "MO", MS_FALSE,
+                     &pszMapEPSG);
     if (nVersion > OWS_1_1_0) {
       /* starting 1.1.1 SRS are given in individual tags */
       if (nVersion >= OWS_1_3_0) {
-        msOWSPrintEncodeParamList(stdout, "(at least one of) "
+        msOWSPrintEncodeParamList(stdout,
+                                  "(at least one of) "
                                   "MAP.PROJECTION, LAYER.PROJECTION "
                                   "or wms_srs metadata",
-                                  pszMapEPSG,
-                                  OWS_WARN, ' ', NULL, NULL,
+                                  pszMapEPSG, OWS_WARN, ' ', NULL, NULL,
                                   "    <CRS>%s</CRS>\n", "");
       } else {
-        msOWSPrintEncodeParamList(stdout, "(at least one of) "
+        msOWSPrintEncodeParamList(stdout,
+                                  "(at least one of) "
                                   "MAP.PROJECTION, LAYER.PROJECTION "
                                   "or wms_srs metadata",
-                                  pszMapEPSG,
-                                  OWS_WARN, ' ', NULL, NULL,
+                                  pszMapEPSG, OWS_WARN, ' ', NULL, NULL,
                                   "    <SRS>%s</SRS>\n", "");
       }
     } else {
-      /* If map has no proj then every layer MUST have one or produce a warning */
+      /* If map has no proj then every layer MUST have one or produce a warning
+       */
       msOWSPrintEncodeParam(stdout, "MAP.PROJECTION (or wms_srs metadata)",
-                            pszMapEPSG,
-                            OWS_WARN, "    <SRS>%s</SRS>\n", "");
+                            pszMapEPSG, OWS_WARN, "    <SRS>%s</SRS>\n", "");
     }
     msFree(pszMapEPSG);
 
@@ -3248,35 +3710,36 @@ int msWMSGetCapabilities(mapObj *map, in
       msOWSPrintLatLonBoundingBox(stdout, "    ", &(map->extent),
                                   &(map->projection), NULL, OWS_WMS);
 
-    msOWSPrintBoundingBox( stdout, "    ", &(map->extent), &(map->projection),
-                           NULL, &(map->web.metadata), "MO", nVersion);
+    msOWSPrintBoundingBox(stdout, "    ", &(map->extent), &(map->projection),
+                          NULL, &(map->web.metadata), "MO", nVersion);
 
     if (nVersion >= OWS_1_0_7) {
       msWMSPrintAttribution(stdout, "    ", &(map->web.metadata), "MO");
     }
 
-    /* AuthorityURL support and Identifier support, only available >= WMS 1.1.0 */
-    if(nVersion >= OWS_1_1_0) {
+    /* AuthorityURL support and Identifier support, only available >= WMS 1.1.0
+     */
+    if (nVersion >= OWS_1_1_0) {
       msWMSPrintAuthorityURL(stdout, "    ", &(map->web.metadata), "MO");
       msWMSPrintIdentifier(stdout, "    ", &(map->web.metadata), "MO");
     }
 
     /* MetadataURL */
-    if(nVersion >= OWS_1_1_0)
+    if (nVersion >= OWS_1_1_0)
       msOWSPrintURLType(stdout, &(map->web.metadata), "MO", "metadataurl",
-                        OWS_NOERR, NULL, "MetadataURL", " type=\"%s\"",
-                        NULL, NULL, ">\n      <Format>%s</Format",
+                        OWS_NOERR, NULL, "MetadataURL", " type=\"%s\"", NULL,
+                        NULL, ">\n      <Format>%s</Format",
                         "\n      <OnlineResource xmlns:xlink=\""
                         "http://www.w3.org/1999/xlink\" "
                         "xlink:type=\"simple\" xlink:href=\"%s\"/>\n    ",
-                        MS_TRUE, MS_FALSE, MS_FALSE, MS_TRUE, MS_TRUE,
-                        NULL, NULL, NULL, NULL, NULL, "    ");
+                        MS_TRUE, MS_FALSE, MS_FALSE, MS_TRUE, MS_TRUE, NULL,
+                        NULL, NULL, NULL, NULL, "    ");
 
     /* DataURL */
-    if(nVersion < OWS_1_1_0)
-      msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "MO", "dataurl_href",
-                               OWS_NOERR, "    <DataURL>%s</DataURL>\n",
-                               NULL);
+    if (nVersion < OWS_1_1_0)
+      msOWSPrintEncodeMetadata(stdout, &(map->web.metadata), "MO",
+                               "dataurl_href", OWS_NOERR,
+                               "    <DataURL>%s</DataURL>\n", NULL);
     else
       msOWSPrintURLType(stdout, &(map->web.metadata), "MO", "dataurl",
                         OWS_NOERR, NULL, "DataURL", NULL, NULL, NULL,
@@ -3284,10 +3747,12 @@ int msWMSGetCapabilities(mapObj *map, in
                         "\n      <OnlineResource xmlns:xlink=\""
                         "http://www.w3.org/1999/xlink\" "
                         "xlink:type=\"simple\" xlink:href=\"%s\"/>\n    ",
-                        MS_FALSE, MS_FALSE, MS_FALSE, MS_TRUE, MS_TRUE,
-                        NULL, NULL, NULL, NULL, NULL, "    ");
+                        MS_FALSE, MS_FALSE, MS_FALSE, MS_TRUE, MS_TRUE, NULL,
+                        NULL, NULL, NULL, NULL, "    ");
 
-    if (map->name && strlen(map->name) > 0 && msOWSLookupMetadata(&(map->web.metadata), "MO", "inspire_capabilities") ) {
+    if (map->name && strlen(map->name) > 0 &&
+        msOWSLookupMetadata(&(map->web.metadata), "MO",
+                            "inspire_capabilities")) {
       char *pszEncodedName = NULL;
       const char *styleName = NULL;
       char *pszEncodedStyleName = NULL;
@@ -3303,41 +3768,42 @@ int msWMSGetCapabilities(mapObj *map, in
 
       msIO_fprintf(stdout, "    <Style>\n");
       msIO_fprintf(stdout, "       <Name>%s</Name>\n", pszEncodedStyleName);
-      msOWSPrintEncodeMetadata2(stdout, &(map->web.metadata), "MO",
-                                "style_title",
-                                OWS_NOERR,
-                                "       <Title>%s</Title>\n",
-                                styleName, validated_language.c_str());
+      msOWSPrintEncodeMetadata2(
+          stdout, &(map->web.metadata), "MO", "style_title", OWS_NOERR,
+          "       <Title>%s</Title>\n", styleName, validated_language.c_str());
 
-      legendURL = msOWSLookupMetadata(&(map->web.metadata), "MO", "style_legendurl_href");
+      legendURL = msOWSLookupMetadata(&(map->web.metadata), "MO",
+                                      "style_legendurl_href");
       if (legendURL) {
-        msOWSPrintURLType(stdout, &(map->web.metadata),
-                          "MO", "style_legendurl",
-                          OWS_NOERR, NULL,
-                          "LegendURL", NULL,
-                          " width=\"%s\"", " height=\"%s\"",
-                          ">\n          <Format>%s</Format",
+        msOWSPrintURLType(stdout, &(map->web.metadata), "MO", "style_legendurl",
+                          OWS_NOERR, NULL, "LegendURL", NULL, " width=\"%s\"",
+                          " height=\"%s\"", ">\n          <Format>%s</Format",
                           "\n          <OnlineResource "
                           "xmlns:xlink=\"http://www.w3.org/1999/xlink\""
                           " xlink:type=\"simple\" xlink:href=\"%s\"/>\n"
                           "       ",
-                          MS_FALSE, MS_TRUE, MS_TRUE, MS_TRUE, MS_TRUE,
-                          NULL, NULL, NULL, NULL, NULL, "       ");
+                          MS_FALSE, MS_TRUE, MS_TRUE, MS_TRUE, MS_TRUE, NULL,
+                          NULL, NULL, NULL, NULL, "       ");
       } else {
         std::vector<int> group_layers;
         group_layers.reserve(map->numlayers);
 
-        for(int i=0; i<map->numlayers; i++)
-          if (msIntegerInArray(GET_LAYER(map, i)->index, ows_request->enabled_layers, ows_request->numlayers))
+        for (int i = 0; i < map->numlayers; i++)
+          if (msIntegerInArray(GET_LAYER(map, i)->index,
+                               ows_request->enabled_layers,
+                               ows_request->numlayers))
             group_layers.push_back(i);
 
         if (!group_layers.empty()) {
-          int size_x=0, size_y=0;
-          if (msLegendCalcSize(map, 1, &size_x, &size_y, group_layers.data(), static_cast<int>(group_layers.size()), NULL, 1) == MS_SUCCESS) {
+          int size_x = 0, size_y = 0;
+          if (msLegendCalcSize(map, 1, &size_x, &size_y, group_layers.data(),
+                               static_cast<int>(group_layers.size()), NULL,
+                               1) == MS_SUCCESS) {
             const std::string width(std::to_string(size_x));
             const std::string height(std::to_string(size_y));
 
-            const char* format_list = msOWSLookupMetadata(&(map->web.metadata), "M", "getlegendgraphic_formatlist");
+            const char *format_list = msOWSLookupMetadata(
+                &(map->web.metadata), "M", "getlegendgraphic_formatlist");
             char *pszMimetype = NULL;
             if (format_list && strlen(format_list) > 0) {
               const auto tokens = msStringSplit(format_list, ',');
@@ -3354,10 +3820,9 @@ int msWMSGetCapabilities(mapObj *map, in
             legendurl += msOWSGetVersionString(nVersion, szVersionBuf);
             legendurl += "&amp;service=WMS&amp;request=GetLegendGraphic&amp;";
             if (nVersion >= OWS_1_3_0) {
-                legendurl += "sld_version=1.1.0&amp;layer=";
-            }
-            else {
-                legendurl += "layer=";
+              legendurl += "sld_version=1.1.0&amp;layer=";
+            } else {
+              legendurl += "layer=";
             }
             legendurl += pszEncodedName;
             legendurl += "&amp;format=";
@@ -3365,18 +3830,17 @@ int msWMSGetCapabilities(mapObj *map, in
             legendurl += "&amp;STYLE=";
             legendurl += pszEncodedStyleName;
 
-            msOWSPrintURLType(stdout, NULL,
-                              "O", "ttt",
-                              OWS_NOERR, NULL,
-                              "LegendURL", NULL,
-                              " width=\"%s\"", " height=\"%s\"",
+            msOWSPrintURLType(stdout, NULL, "O", "ttt", OWS_NOERR, NULL,
+                              "LegendURL", NULL, " width=\"%s\"",
+                              " height=\"%s\"",
                               ">\n          <Format>%s</Format",
                               "\n          <OnlineResource "
                               "xmlns:xlink=\"http://www.w3.org/1999/xlink\""
                               " xlink:type=\"simple\" xlink:href=\"%s\"/>\n"
                               "       ",
                               MS_FALSE, MS_FALSE, MS_FALSE, MS_FALSE, MS_FALSE,
-                              NULL, width.c_str(), height.c_str(), pszMimetype, legendurl.c_str(), "       ");
+                              NULL, width.c_str(), height.c_str(), pszMimetype,
+                              legendurl.c_str(), "       ");
             msFree(pszMimetype);
           }
         }
@@ -3384,17 +3848,18 @@ int msWMSGetCapabilities(mapObj *map, in
       msIO_fprintf(stdout, "    </Style>\n");
       msFree(pszEncodedName);
       msFree(pszEncodedStyleName);
-
     }
 
-    if (nVersion <  OWS_1_3_0)
-      msWMSPrintScaleHint("    ", map->web.minscaledenom, map->web.maxscaledenom,
-                          map->resolution);
+    if (nVersion < OWS_1_3_0)
+      msWMSPrintScaleHint("    ", map->web.minscaledenom,
+                          map->web.maxscaledenom, map->resolution);
     else
-      msWMSPrintScaleDenominator("    ", map->web.minscaledenom, map->web.maxscaledenom);
+      msWMSPrintScaleDenominator("    ", map->web.minscaledenom,
+                                 map->web.maxscaledenom);
 
     /*  */
-    /* Dump list of layers organized by groups.  Layers with no group are listed */
+    /* Dump list of layers organized by groups.  Layers with no group are listed
+     */
     /* individually, at the same level as the groups in the layer hierarchy */
     /*  */
     if (map->numlayers) {
@@ -3402,49 +3867,58 @@ int msWMSGetCapabilities(mapObj *map, in
       int *numNestedGroups = NULL;
       int *isUsedInNestedGroup = NULL;
 
-      /* We'll use this array of booleans to track which layer/group have been */
+      /* We'll use this array of booleans to track which layer/group have been
+       */
       /* processed already */
       std::vector<char> pabLayerProcessed(map->numlayers);
 
-      /* Mark disabled layers as processed to prevent from being displayed in nested groups (#4533)*/
-      for(int i=0; i<map->numlayers; i++) {
-        if (!msIntegerInArray(GET_LAYER(map, i)->index, ows_request->enabled_layers, ows_request->numlayers))
+      /* Mark disabled layers as processed to prevent from being displayed in
+       * nested groups (#4533)*/
+      for (int i = 0; i < map->numlayers; i++) {
+        if (!msIntegerInArray(GET_LAYER(map, i)->index,
+                              ows_request->enabled_layers,
+                              ows_request->numlayers))
           pabLayerProcessed[i] = 1;
       }
 
-      nestedGroups = (char***)msSmallCalloc(map->numlayers, sizeof(char**));
-      numNestedGroups = (int*)msSmallCalloc(map->numlayers, sizeof(int));
-      isUsedInNestedGroup = (int*)msSmallCalloc(map->numlayers, sizeof(int));
-      msWMSPrepareNestedGroups(map, nVersion, nestedGroups, numNestedGroups, isUsedInNestedGroup);
+      nestedGroups = (char ***)msSmallCalloc(map->numlayers, sizeof(char **));
+      numNestedGroups = (int *)msSmallCalloc(map->numlayers, sizeof(int));
+      isUsedInNestedGroup = (int *)msSmallCalloc(map->numlayers, sizeof(int));
+      msWMSPrepareNestedGroups(map, nVersion, nestedGroups, numNestedGroups,
+                               isUsedInNestedGroup);
 
-      for(int i=0; i<map->numlayers; i++) {
+      for (int i = 0; i < map->numlayers; i++) {
         layerObj *lp = (GET_LAYER(map, i));
 
         if (pabLayerProcessed[i] || (lp->status == MS_DELETE))
-          continue;  /* Layer is hidden or has already been handled */
+          continue; /* Layer is hidden or has already been handled */
 
         if (numNestedGroups[i] > 0) {
           /* Has nested groups.  */
           msWMSPrintNestedGroups(map, nVersion, pabLayerProcessed.data(), i, 0,
-                                 nestedGroups, numNestedGroups, isUsedInNestedGroup,
-                                 script_url_encoded, validated_language.c_str());
+                                 nestedGroups, numNestedGroups,
+                                 isUsedInNestedGroup, script_url_encoded,
+                                 validated_language.c_str());
         } else if (lp->group == NULL || strlen(lp->group) == 0) {
           /* Don't dump layer if it is used in wms_group_layer. */
           if (!isUsedInNestedGroup[i]) {
             /* This layer is not part of a group... dump it directly */
-            msDumpLayer(map, lp, nVersion, script_url_encoded, "", validated_language.c_str(), MS_FALSE, MS_FALSE);
+            msDumpLayer(map, lp, nVersion, script_url_encoded, "",
+                        validated_language.c_str(), MS_FALSE, MS_FALSE);
             pabLayerProcessed[i] = 1;
           }
         } else {
           bool group_is_queryable = false;
           /* Group is queryable as soon as its member layers is. */
-          for(int j=i; j<map->numlayers; j++) {
+          for (int j = i; j < map->numlayers; j++) {
             if (GET_LAYER(map, j)->group &&
                 strcmp(lp->group, GET_LAYER(map, j)->group) == 0 &&
-                msIntegerInArray(GET_LAYER(map, j)->index, ows_request->enabled_layers, ows_request->numlayers) &&
-                msIsLayerQueryable(GET_LAYER(map, j)) ) {
-                group_is_queryable = true;
-                break;
+                msIntegerInArray(GET_LAYER(map, j)->index,
+                                 ows_request->enabled_layers,
+                                 ows_request->numlayers) &&
+                msIsLayerQueryable(GET_LAYER(map, j))) {
+              group_is_queryable = true;
+              break;
             }
           }
           /* Beginning of a new group... enclose the group in a layer block */
@@ -3452,22 +3926,26 @@ int msWMSGetCapabilities(mapObj *map, in
                       group_is_queryable ? " queryable=\"1\"" : "");
 
           /* Layer Name is optional but title is mandatory. */
-          if (lp->group &&  strlen(lp->group) > 0 &&
+          if (lp->group && strlen(lp->group) > 0 &&
               (msIsXMLTagValid(lp->group) == MS_FALSE || isdigit(lp->group[0])))
-            msIO_fprintf(stdout, "<!-- WARNING: The layer name '%s' might contain spaces or "
-                         "invalid characters or may start with a number. This could lead to potential problems. -->\n",
-                         lp->group);
-          msOWSPrintEncodeParam(stdout, "GROUP.NAME", lp->group,
-                                OWS_NOERR, "      <Name>%s</Name>\n", NULL);
-          msOWSPrintGroupMetadata2(stdout, map, lp->group,
-                                   "MO", "GROUP_TITLE", OWS_WARN,
-                                   "      <Title>%s</Title>\n", lp->group, validated_language.c_str());
-          msOWSPrintGroupMetadata2(stdout, map, lp->group,
-                                   "MO", "GROUP_ABSTRACT", OWS_NOERR,
-                                   "      <Abstract>%s</Abstract>\n", lp->group, validated_language.c_str());
+            msIO_fprintf(
+                stdout,
+                "<!-- WARNING: The layer name '%s' might contain spaces or "
+                "invalid characters or may start with a number. This could "
+                "lead to potential problems. -->\n",
+                lp->group);
+          msOWSPrintEncodeParam(stdout, "GROUP.NAME", lp->group, OWS_NOERR,
+                                "      <Name>%s</Name>\n", NULL);
+          msOWSPrintGroupMetadata2(stdout, map, lp->group, "MO", "GROUP_TITLE",
+                                   OWS_WARN, "      <Title>%s</Title>\n",
+                                   lp->group, validated_language.c_str());
+          msOWSPrintGroupMetadata2(stdout, map, lp->group, "MO",
+                                   "GROUP_ABSTRACT", OWS_NOERR,
+                                   "      <Abstract>%s</Abstract>\n", lp->group,
+                                   validated_language.c_str());
 
           /*build a getlegendgraphicurl*/
-          if( script_url_encoded) {
+          if (script_url_encoded) {
             if (lp->group && strlen(lp->group) > 0) {
               char *pszEncodedName = NULL;
               const char *styleName = NULL;
@@ -3476,56 +3954,61 @@ int msWMSGetCapabilities(mapObj *map, in
 
               pszEncodedName = msEncodeHTMLEntities(lp->group);
 
-              styleName = msOWSLookupMetadata(&(lp->metadata), "MO", "group_style_name");
+              styleName = msOWSLookupMetadata(&(lp->metadata), "MO",
+                                              "group_style_name");
               if (styleName == NULL)
                 styleName = "default";
 
               pszEncodedStyleName = msEncodeHTMLEntities(styleName);
 
               msIO_fprintf(stdout, "    <Style>\n");
-              msIO_fprintf(stdout, "       <Name>%s</Name>\n", pszEncodedStyleName);
+              msIO_fprintf(stdout, "       <Name>%s</Name>\n",
+                           pszEncodedStyleName);
               msOWSPrintEncodeMetadata(stdout, &(lp->metadata), "MO",
-                                       "group_style_title",
-                                       OWS_NOERR,
-                                       "       <Title>%s</Title>\n",
-                                       styleName);
+                                       "group_style_title", OWS_NOERR,
+                                       "       <Title>%s</Title>\n", styleName);
 
-              legendURL = msOWSLookupMetadata(&(lp->metadata), "MO", "group_style_legendurl_href");
+              legendURL = msOWSLookupMetadata(&(lp->metadata), "MO",
+                                              "group_style_legendurl_href");
               if (legendURL) {
-                msOWSPrintURLType(stdout, &(lp->metadata),
-                                  "MO", "group_style_legendurl",
-                                  OWS_NOERR, NULL,
-                                  "LegendURL", NULL,
-                                  " width=\"%s\"", " height=\"%s\"",
-                                  ">\n          <Format>%s</Format",
-                                  "\n          <OnlineResource "
-                                  "xmlns:xlink=\"http://www.w3.org/1999/xlink\""
-                                  " xlink:type=\"simple\" xlink:href=\"%s\"/>\n"
-                                  "       ",
-                                  MS_FALSE, MS_TRUE, MS_TRUE, MS_TRUE, MS_TRUE,
-                                  NULL, NULL, NULL, NULL, NULL, "       ");
+                msOWSPrintURLType(
+                    stdout, &(lp->metadata), "MO", "group_style_legendurl",
+                    OWS_NOERR, NULL, "LegendURL", NULL, " width=\"%s\"",
+                    " height=\"%s\"", ">\n          <Format>%s</Format",
+                    "\n          <OnlineResource "
+                    "xmlns:xlink=\"http://www.w3.org/1999/xlink\""
+                    " xlink:type=\"simple\" xlink:href=\"%s\"/>\n"
+                    "       ",
+                    MS_FALSE, MS_TRUE, MS_TRUE, MS_TRUE, MS_TRUE, NULL, NULL,
+                    NULL, NULL, NULL, "       ");
               } else {
                 std::vector<int> group_layers;
                 group_layers.reserve(map->numlayers);
 
-                for(int j=i; j<map->numlayers; j++)
-                  if (!pabLayerProcessed[j] &&
-                      GET_LAYER(map, j)->group &&
+                for (int j = i; j < map->numlayers; j++)
+                  if (!pabLayerProcessed[j] && GET_LAYER(map, j)->group &&
                       strcmp(lp->group, GET_LAYER(map, j)->group) == 0 &&
-                      msIntegerInArray(GET_LAYER(map, j)->index, ows_request->enabled_layers, ows_request->numlayers))
+                      msIntegerInArray(GET_LAYER(map, j)->index,
+                                       ows_request->enabled_layers,
+                                       ows_request->numlayers))
                     group_layers.push_back(j);
 
                 if (!group_layers.empty()) {
-                  int size_x=0, size_y=0;
+                  int size_x = 0, size_y = 0;
                   char *pszMimetype = NULL;
 
-                  if (msLegendCalcSize(map, 1, &size_x, &size_y, group_layers.data(), static_cast<int>(group_layers.size()), NULL, 1) == MS_SUCCESS) {
+                  if (msLegendCalcSize(map, 1, &size_x, &size_y,
+                                       group_layers.data(),
+                                       static_cast<int>(group_layers.size()),
+                                       NULL, 1) == MS_SUCCESS) {
                     const std::string width(std::to_string(size_x));
                     const std::string height(std::to_string(size_y));
 
-                    const char* format_list = msOWSLookupMetadata(&(map->web.metadata), "M", "getlegendgraphic_formatlist");
+                    const char *format_list =
+                        msOWSLookupMetadata(&(map->web.metadata), "M",
+                                            "getlegendgraphic_formatlist");
                     if (format_list && strlen(format_list) > 0) {
-                      const auto tokens = msStringSplit(format_list,  ',');
+                      const auto tokens = msStringSplit(format_list, ',');
                       if (!tokens.empty()) {
                         /*just grab the first mime type*/
                         pszMimetype = msEncodeHTMLEntities(tokens[0].c_str());
@@ -3537,12 +4020,12 @@ int msWMSGetCapabilities(mapObj *map, in
                     legendurl += "version=";
                     char szVersionBuf[OWS_VERSION_MAXLEN];
                     legendurl += msOWSGetVersionString(nVersion, szVersionBuf);
-                    legendurl += "&amp;service=WMS&amp;request=GetLegendGraphic&amp;";
+                    legendurl +=
+                        "&amp;service=WMS&amp;request=GetLegendGraphic&amp;";
                     if (nVersion >= OWS_1_3_0) {
-                        legendurl += "sld_version=1.1.0&amp;layer=";
-                    }
-                    else {
-                        legendurl += "layer=";
+                      legendurl += "sld_version=1.1.0&amp;layer=";
+                    } else {
+                      legendurl += "layer=";
                     }
                     legendurl += pszEncodedName;
                     legendurl += "&amp;format=";
@@ -3550,18 +4033,17 @@ int msWMSGetCapabilities(mapObj *map, in
                     legendurl += "&amp;STYLE=";
                     legendurl += pszEncodedStyleName;
 
-                    msOWSPrintURLType(stdout, NULL,
-                                      "O", "ttt",
-                                      OWS_NOERR, NULL,
-                                      "LegendURL", NULL,
-                                      " width=\"%s\"", " height=\"%s\"",
-                                      ">\n          <Format>%s</Format",
-                                      "\n          <OnlineResource "
-                                      "xmlns:xlink=\"http://www.w3.org/1999/xlink\""
-                                      " xlink:type=\"simple\" xlink:href=\"%s\"/>\n"
-                                      "       ",
-                                      MS_FALSE, MS_FALSE, MS_FALSE, MS_FALSE, MS_FALSE,
-                                      NULL, width.c_str(), height.c_str(), pszMimetype, legendurl.c_str(), "       ");
+                    msOWSPrintURLType(
+                        stdout, NULL, "O", "ttt", OWS_NOERR, NULL, "LegendURL",
+                        NULL, " width=\"%s\"", " height=\"%s\"",
+                        ">\n          <Format>%s</Format",
+                        "\n          <OnlineResource "
+                        "xmlns:xlink=\"http://www.w3.org/1999/xlink\""
+                        " xlink:type=\"simple\" xlink:href=\"%s\"/>\n"
+                        "       ",
+                        MS_FALSE, MS_FALSE, MS_FALSE, MS_FALSE, MS_FALSE, NULL,
+                        width.c_str(), height.c_str(), pszMimetype,
+                        legendurl.c_str(), "       ");
 
                     msFree(pszMimetype);
                   }
@@ -3574,12 +4056,15 @@ int msWMSGetCapabilities(mapObj *map, in
           }
 
           /* Dump all layers for this group */
-          for(int j=i; j<map->numlayers; j++) {
-            if (!pabLayerProcessed[j] &&
-                GET_LAYER(map, j)->group &&
+          for (int j = i; j < map->numlayers; j++) {
+            if (!pabLayerProcessed[j] && GET_LAYER(map, j)->group &&
                 strcmp(lp->group, GET_LAYER(map, j)->group) == 0 &&
-                msIntegerInArray(GET_LAYER(map, j)->index, ows_request->enabled_layers, ows_request->numlayers)) {
-              msDumpLayer(map, (GET_LAYER(map, j)), nVersion, script_url_encoded, "  ", validated_language.c_str(), MS_FALSE, MS_FALSE);
+                msIntegerInArray(GET_LAYER(map, j)->index,
+                                 ows_request->enabled_layers,
+                                 ows_request->numlayers)) {
+              msDumpLayer(map, (GET_LAYER(map, j)), nVersion,
+                          script_url_encoded, "  ", validated_language.c_str(),
+                          MS_FALSE, MS_FALSE);
               pabLayerProcessed[j] = 1;
             }
           }
@@ -3603,41 +4088,47 @@ int msWMSGetCapabilities(mapObj *map, in
   }
 
   msIO_printf("</Capability>\n");
-  if ( nVersion >= OWS_1_3_0)
+  if (nVersion >= OWS_1_3_0)
     msIO_printf("</WMS_Capabilities>\n");
   else
     msIO_printf("</WMT_MS_Capabilities>\n");
 
   free(script_url_encoded);
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
 /*
  * This function look for params that can be used
  * by mapserv when generating template.
-*/
-int msTranslateWMS2Mapserv(const char **names, const char **values, int numentries, char ***translated_names, char ***translated_values, int *translated_numentries)
-{
+ */
+int msTranslateWMS2Mapserv(const char **names, const char **values,
+                           int numentries, char ***translated_names,
+                           char ***translated_values,
+                           int *translated_numentries) {
   int num_allocated = numentries;
-  *translated_names = (char**)msSmallMalloc(num_allocated * sizeof(char*));
-  *translated_values = (char**)msSmallMalloc(num_allocated * sizeof(char*));
+  *translated_names = (char **)msSmallMalloc(num_allocated * sizeof(char *));
+  *translated_values = (char **)msSmallMalloc(num_allocated * sizeof(char *));
   *translated_numentries = 0;
-  for (int i=0; i<numentries; i++) {
+  for (int i = 0; i < numentries; i++) {
     (*translated_values)[*translated_numentries] = msStrdup(values[i]);
     (*translated_names)[*translated_numentries] = msStrdup(names[i]);
     (*translated_numentries)++;
     if (strcasecmp("X", names[i]) == 0) {
       num_allocated++;
-      *translated_names = (char**)msSmallRealloc(*translated_names, num_allocated * sizeof(char*));
-      *translated_values = (char**)msSmallRealloc(*translated_values, num_allocated * sizeof(char*));
+      *translated_names = (char **)msSmallRealloc(
+          *translated_names, num_allocated * sizeof(char *));
+      *translated_values = (char **)msSmallRealloc(
+          *translated_values, num_allocated * sizeof(char *));
       (*translated_values)[*translated_numentries] = msStrdup(values[i]);
       (*translated_names)[*translated_numentries] = msStrdup("img.x");
       (*translated_numentries)++;
     } else if (strcasecmp("Y", names[i]) == 0) {
       num_allocated++;
-      *translated_names = (char**)msSmallRealloc(*translated_names, num_allocated * sizeof(char*));
-      *translated_values = (char**)msSmallRealloc(*translated_values, num_allocated * sizeof(char*));
+      *translated_names = (char **)msSmallRealloc(
+          *translated_names, num_allocated * sizeof(char *));
+      *translated_values = (char **)msSmallRealloc(
+          *translated_values, num_allocated * sizeof(char *));
       (*translated_values)[*translated_numentries] = msStrdup(values[i]);
       (*translated_names)[*translated_numentries] = msStrdup("img.y");
       (*translated_numentries)++;
@@ -3647,9 +4138,11 @@ int msTranslateWMS2Mapserv(const char **
       int j;
       layers = msStringSplit(values[i], ',', &tok);
       num_allocated += tok;
-      *translated_names = (char**)msSmallRealloc(*translated_names, num_allocated * sizeof(char*));
-      *translated_values = (char**)msSmallRealloc(*translated_values, num_allocated * sizeof(char*));
-      for (j=0; j<tok; j++) {
+      *translated_names = (char **)msSmallRealloc(
+          *translated_names, num_allocated * sizeof(char *));
+      *translated_values = (char **)msSmallRealloc(
+          *translated_values, num_allocated * sizeof(char *));
+      for (j = 0; j < tok; j++) {
         (*translated_values)[*translated_numentries] = layers[j];
         (*translated_names)[*translated_numentries] = msStrdup("layer");
         (*translated_numentries)++;
@@ -3662,9 +4155,11 @@ int msTranslateWMS2Mapserv(const char **
       int j;
       layers = msStringSplit(values[i], ',', &tok);
       num_allocated += tok;
-      *translated_names = (char**)msSmallRealloc(*translated_names, num_allocated * sizeof(char*));
-      *translated_values = (char**)msSmallRealloc(*translated_values, num_allocated * sizeof(char*));
-      for (j=0; j<tok; j++) {
+      *translated_names = (char **)msSmallRealloc(
+          *translated_names, num_allocated * sizeof(char *));
+      *translated_values = (char **)msSmallRealloc(
+          *translated_values, num_allocated * sizeof(char *));
+      for (j = 0; j < tok; j++) {
         (*translated_values)[*translated_numentries] = layers[j];
         (*translated_names)[*translated_numentries] = msStrdup("qlayer");
         (*translated_numentries)++;
@@ -3674,10 +4169,13 @@ int msTranslateWMS2Mapserv(const char **
     } else if (strcasecmp("BBOX", names[i]) == 0) {
       char *imgext;
       num_allocated++;
-      *translated_names = (char**)msSmallRealloc(*translated_names, num_allocated * sizeof(char*));
-      *translated_values = (char**)msSmallRealloc(*translated_values, num_allocated * sizeof(char*));
+      *translated_names = (char **)msSmallRealloc(
+          *translated_names, num_allocated * sizeof(char *));
+      *translated_values = (char **)msSmallRealloc(
+          *translated_values, num_allocated * sizeof(char *));
 
-      /* Note msReplaceSubstring() works on the string itself, so we need to make a copy */
+      /* Note msReplaceSubstring() works on the string itself, so we need to
+       * make a copy */
       imgext = msStrdup(values[i]);
       imgext = msReplaceSubstring(imgext, ",", " ");
       (*translated_values)[*translated_numentries] = imgext;
@@ -3686,19 +4184,17 @@ int msTranslateWMS2Mapserv(const char **
     }
   }
 
-
   return MS_SUCCESS;
 }
 
 /*
 ** msWMSGetMap()
 */
-static
-int msWMSGetMap(mapObj *map, int nVersion, char **names, char **values, int numentries,
-                const char *wms_exception_format, owsRequestObj *ows_request)
-{
+static int msWMSGetMap(mapObj *map, int nVersion, char **names, char **values,
+                       int numentries, const char *wms_exception_format,
+                       owsRequestObj *ows_request) {
   imageObj *img;
-  int sldrequested = MS_FALSE,  sldspatialfilter = MS_FALSE;
+  int sldrequested = MS_FALSE, sldspatialfilter = MS_FALSE;
   int drawquerymap = MS_FALSE;
 
   /* __TODO__ msDrawMap() will try to adjust the extent of the map */
@@ -3712,24 +4208,28 @@ int msWMSGetMap(mapObj *map, int nVersio
   /* layer, we added a temporary metadata on the layer */
   /* (tmp_wms_sld_query) for layers with a spatial filter. */
 
-  for (int i=0; i<numentries; i++) {
-    if ((strcasecmp(names[i], "SLD") == 0 && values[i] && strlen(values[i]) > 0) ||
-        (strcasecmp(names[i], "SLD_BODY") == 0 && values[i] && strlen(values[i]) > 0)) {
+  for (int i = 0; i < numentries; i++) {
+    if ((strcasecmp(names[i], "SLD") == 0 && values[i] &&
+         strlen(values[i]) > 0) ||
+        (strcasecmp(names[i], "SLD_BODY") == 0 && values[i] &&
+         strlen(values[i]) > 0)) {
       sldrequested = MS_TRUE;
       break;
     }
   }
   if (sldrequested) {
-    for (int i=0; i<map->numlayers; i++) {
-      if (msLookupHashTable(&(GET_LAYER(map, i)->metadata), "tmp_wms_sld_query")) {
+    for (int i = 0; i < map->numlayers; i++) {
+      if (msLookupHashTable(&(GET_LAYER(map, i)->metadata),
+                            "tmp_wms_sld_query")) {
         sldspatialfilter = MS_TRUE;
         break;
       }
     }
   }
   /* If FILTER is passed then we'll render layers as querymap */
-  for (int i=0; i<numentries; i++) {
-    if ((strcasecmp(names[i], "FILTER") == 0 && values[i] && strlen(values[i]) > 0)) {
+  for (int i = 0; i < numentries; i++) {
+    if ((strcasecmp(names[i], "FILTER") == 0 && values[i] &&
+         strlen(values[i]) > 0)) {
       drawquerymap = MS_TRUE;
       map->querymap.status = MS_ON;
       map->querymap.style = MS_SELECTED;
@@ -3738,8 +4238,9 @@ int msWMSGetMap(mapObj *map, int nVersio
   }
 
   /* turn off layer if WMS GetMap is not enabled */
-  for (int i=0; i<map->numlayers; i++)
-    if (!msIntegerInArray(GET_LAYER(map, i)->index, ows_request->enabled_layers, ows_request->numlayers))
+  for (int i = 0; i < map->numlayers; i++)
+    if (!msIntegerInArray(GET_LAYER(map, i)->index, ows_request->enabled_layers,
+                          ows_request->numlayers))
       GET_LAYER(map, i)->status = MS_OFF;
 
   if (sldrequested && sldspatialfilter) {
@@ -3750,16 +4251,21 @@ int msWMSGetMap(mapObj *map, int nVersio
     img = msPrepareImage(map, MS_TRUE);
 
     /* compute layer scale factors now */
-    for(int i=0; i<map->numlayers; i++) {
-      if(GET_LAYER(map, i)->sizeunits != MS_PIXELS)
-        GET_LAYER(map, i)->scalefactor = (msInchesPerUnit(GET_LAYER(map, i)->sizeunits,0)/msInchesPerUnit(map->units,0)) / map->cellsize;
-      else if(GET_LAYER(map, i)->symbolscaledenom > 0 && map->scaledenom > 0)
-        GET_LAYER(map, i)->scalefactor = GET_LAYER(map, i)->symbolscaledenom/map->scaledenom;
+    for (int i = 0; i < map->numlayers; i++) {
+      if (GET_LAYER(map, i)->sizeunits != MS_PIXELS)
+        GET_LAYER(map, i)->scalefactor =
+            (msInchesPerUnit(GET_LAYER(map, i)->sizeunits, 0) /
+             msInchesPerUnit(map->units, 0)) /
+            map->cellsize;
+      else if (GET_LAYER(map, i)->symbolscaledenom > 0 && map->scaledenom > 0)
+        GET_LAYER(map, i)->scalefactor =
+            GET_LAYER(map, i)->symbolscaledenom / map->scaledenom;
       else
         GET_LAYER(map, i)->scalefactor = 1;
     }
-    for (int i=0; i<map->numlayers; i++) {
-      if (msLookupHashTable(&(GET_LAYER(map, i)->metadata), "tmp_wms_sld_query") &&
+    for (int i = 0; i < map->numlayers; i++) {
+      if (msLookupHashTable(&(GET_LAYER(map, i)->metadata),
+                            "tmp_wms_sld_query") &&
           (GET_LAYER(map, i)->type == MS_LAYER_POINT ||
            GET_LAYER(map, i)->type == MS_LAYER_LINE ||
            GET_LAYER(map, i)->type == MS_LAYER_POLYGON ||
@@ -3779,42 +4285,52 @@ int msWMSGetMap(mapObj *map, int nVersio
   } else {
 
     /* intercept requests for Mapbox vector tiles */
-    if(!strcmp(MS_IMAGE_MIME_TYPE(map->outputformat), "application/vnd.mapbox-vector-tile") || !strcmp(MS_IMAGE_MIME_TYPE(map->outputformat), "application/x-protobuf")) {
-      int status=0;
-      if((status = msMVTWriteTile(map, MS_TRUE)) != MS_SUCCESS) return MS_FAILURE;
+    if (!strcmp(MS_IMAGE_MIME_TYPE(map->outputformat),
+                "application/vnd.mapbox-vector-tile") ||
+        !strcmp(MS_IMAGE_MIME_TYPE(map->outputformat),
+                "application/x-protobuf")) {
+      int status = 0;
+      if ((status = msMVTWriteTile(map, MS_TRUE)) != MS_SUCCESS)
+        return MS_FAILURE;
       return MS_SUCCESS;
     }
 
     img = msDrawMap(map, drawquerymap);
   }
 
-/* see if we have tiled = true and a buffer */
+  /* see if we have tiled = true and a buffer */
   /* if so, clip the image */
-  for (int i=0; i<numentries; i++) {
-    if (strcasecmp(names[i], "TILED") == 0 && strcasecmp(values[i], "TRUE") == 0) {
+  for (int i = 0; i < numentries; i++) {
+    if (strcasecmp(names[i], "TILED") == 0 &&
+        strcasecmp(values[i], "TRUE") == 0) {
       hashTableObj *meta = &(map->web.metadata);
       const char *value;
 
       if ((value = msLookupHashTable(meta, "tile_map_edge_buffer")) != NULL) {
         const int map_edge_buffer = atoi(value);
-        if ( map_edge_buffer > 0 ) {
+        if (map_edge_buffer > 0) {
           /* we have to clip the image */
 
           // TODO: we could probably avoid the use of an intermediate image
-          // by playing with the rasterBufferObj's data->rgb.pixels and data->rgb.row_stride values.
-          rendererVTableObj* renderer = MS_MAP_RENDERER(map);
+          // by playing with the rasterBufferObj's data->rgb.pixels and
+          // data->rgb.row_stride values.
+          rendererVTableObj *renderer = MS_MAP_RENDERER(map);
           rasterBufferObj imgBuffer;
-          if( renderer->getRasterBufferHandle((imageObj*)img,&imgBuffer) != MS_SUCCESS )
-          {
-              msFreeImage(img);
-              return MS_FAILURE;
+          if (renderer->getRasterBufferHandle((imageObj *)img, &imgBuffer) !=
+              MS_SUCCESS) {
+            msFreeImage(img);
+            return MS_FAILURE;
           }
 
           int width = map->width - map_edge_buffer - map_edge_buffer;
           int height = map->height - map_edge_buffer - map_edge_buffer;
-          imageObj* tmp = msImageCreate( width, height, map->outputformat, NULL, NULL, map->resolution, map->defresolution, NULL);
-
-          if((MS_FAILURE == renderer->mergeRasterBuffer(tmp,&imgBuffer,1.0,map_edge_buffer, map_edge_buffer,0, 0, width, height ))) {
+          imageObj *tmp =
+              msImageCreate(width, height, map->outputformat, NULL, NULL,
+                            map->resolution, map->defresolution, NULL);
+
+          if ((MS_FAILURE == renderer->mergeRasterBuffer(
+                                 tmp, &imgBuffer, 1.0, map_edge_buffer,
+                                 map_edge_buffer, 0, 0, width, height))) {
             msFreeImage(tmp);
             msFreeImage(img);
             img = NULL;
@@ -3834,17 +4350,19 @@ int msWMSGetMap(mapObj *map, int nVersio
   /* Set the HTTP Cache-control headers if they are defined
      in the map object */
 
-  const char* http_max_age = msOWSLookupMetadata(&(map->web.metadata), "MO", "http_max_age");
-  if( http_max_age ) {
-    msIO_setHeader("Cache-Control","max-age=%s", http_max_age);
+  const char *http_max_age =
+      msOWSLookupMetadata(&(map->web.metadata), "MO", "http_max_age");
+  if (http_max_age) {
+    msIO_setHeader("Cache-Control", "max-age=%s", http_max_age);
   }
 
-  if (strcasecmp(map->imagetype, "application/openlayers")!=0) {
-    if(!strcmp(MS_IMAGE_MIME_TYPE(map->outputformat), "application/json")) {
-      msIO_setHeader("Content-Type","application/json; charset=utf-8");
+  if (strcasecmp(map->imagetype, "application/openlayers") != 0) {
+    if (!strcmp(MS_IMAGE_MIME_TYPE(map->outputformat), "application/json")) {
+      msIO_setHeader("Content-Type", "application/json; charset=utf-8");
     } else {
-      msOutputFormatResolveFromImage( map, img );
-      msIO_setHeader("Content-Type", "%s", MS_IMAGE_MIME_TYPE(map->outputformat));
+      msOutputFormatResolveFromImage(map, img);
+      msIO_setHeader("Content-Type", "%s",
+                     MS_IMAGE_MIME_TYPE(map->outputformat));
     }
     msIO_sendHeaders();
     if (msSaveImage(map, img, NULL) != MS_SUCCESS) {
@@ -3854,18 +4372,18 @@ int msWMSGetMap(mapObj *map, int nVersio
   }
   msFreeImage(img);
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
-static
-int msDumpResult(mapObj *map, int nVersion, const char *wms_exception_format)
-{
-  int numresults=0;
+static int msDumpResult(mapObj *map, int nVersion,
+                        const char *wms_exception_format) {
+  int numresults = 0;
 
-  for(int i=0; i<map->numlayers; i++) {
+  for (int i = 0; i < map->numlayers; i++) {
     layerObj *lp = (GET_LAYER(map, i));
 
-    if(lp->status != MS_ON || lp->resultcache==NULL || lp->resultcache->numresults == 0)
+    if (lp->status != MS_ON || lp->resultcache == NULL ||
+        lp->resultcache->numresults == 0)
       continue;
 
     /* if(msLayerOpen(lp) != MS_SUCCESS || msLayerGetItems(lp) != MS_SUCCESS)
@@ -3874,34 +4392,37 @@ int msDumpResult(mapObj *map, int nVersi
     /* Use metadata to control which fields to output. We use the same
      * metadata names as for GML:
      * wms/ows_include_items: comma delimited list or keyword 'all'
-     * wms/ows_exclude_items: comma delimited list (all items are excluded by default)
+     * wms/ows_exclude_items: comma delimited list (all items are excluded by
+     * default)
      */
     /* get a list of items that should be excluded in output */
     std::vector<std::string> incitems;
     const char *value;
-    if((value = msOWSLookupMetadata(&(lp->metadata), "MO", "include_items")) != NULL)
+    if ((value = msOWSLookupMetadata(&(lp->metadata), "MO", "include_items")) !=
+        NULL)
       incitems = msStringSplit(value, ',');
 
     /* get a list of items that should be excluded in output */
     std::vector<std::string> excitems;
-    if((value = msOWSLookupMetadata(&(lp->metadata), "MO", "exclude_items")) != NULL)
+    if ((value = msOWSLookupMetadata(&(lp->metadata), "MO", "exclude_items")) !=
+        NULL)
       excitems = msStringSplit(value, ',');
 
     std::vector<bool> itemvisible(lp->numitems);
-    for(int k=0; k<lp->numitems; k++) {
+    for (int k = 0; k < lp->numitems; k++) {
       /* check visibility, included items first... */
-      if(incitems.size() == 1 && strcasecmp("all", incitems[0].c_str()) == 0) {
+      if (incitems.size() == 1 && strcasecmp("all", incitems[0].c_str()) == 0) {
         itemvisible[k] = true;
       } else {
-        for( const auto& incitem: incitems ) {
-          if(strcasecmp(lp->items[k], incitem.c_str()) == 0)
+        for (const auto &incitem : incitems) {
+          if (strcasecmp(lp->items[k], incitem.c_str()) == 0)
             itemvisible[k] = true;
         }
       }
 
       /* ...and now excluded items */
-      for( const auto& excitem: excitems ) {
-        if(strcasecmp(lp->items[k], excitem.c_str()) == 0)
+      for (const auto &excitem : excitems) {
+        if (strcasecmp(lp->items[k], excitem.c_str()) == 0)
           itemvisible[k] = false;
       }
     }
@@ -3909,24 +4430,28 @@ int msDumpResult(mapObj *map, int nVersi
     /* Output selected shapes for this layer */
     msIO_printf("\nLayer '%s'\n", lp->name);
 
-    for(int j=0; j<lp->resultcache->numresults; j++) {
+    for (int j = 0; j < lp->resultcache->numresults; j++) {
       shapeObj shape;
 
       msInitShape(&shape);
-      if (msLayerGetShape(lp, &shape, &(lp->resultcache->results[j])) != MS_SUCCESS) {
+      if (msLayerGetShape(lp, &shape, &(lp->resultcache->results[j])) !=
+          MS_SUCCESS) {
         return msWMSException(map, nVersion, NULL, wms_exception_format);
       }
 
       msIO_printf("  Feature %ld: \n", lp->resultcache->results[j].shapeindex);
 
-      for(int k=0; k<lp->numitems; k++) {
+      for (int k = 0; k < lp->numitems; k++) {
         if (itemvisible[k]) {
-          value = msOWSLookupMetadata(&(lp->metadata), "MO", (std::string(lp->items[k]) + "_alias").c_str());
-          const char *lineTemplate="    %s = '%s'\n";
-          msIO_printf(lineTemplate, value != NULL ? value : lp->items[k], shape.values[k]);
+          value = msOWSLookupMetadata(
+              &(lp->metadata), "MO",
+              (std::string(lp->items[k]) + "_alias").c_str());
+          const char *lineTemplate = "    %s = '%s'\n";
+          msIO_printf(lineTemplate, value != NULL ? value : lp->items[k],
+                      shape.values[k]);
         }
       }
- 
+
       msFreeShape(&shape);
       numresults++;
     }
@@ -3937,57 +4462,63 @@ int msDumpResult(mapObj *map, int nVersi
   return numresults;
 }
 
-
 /*
 ** msWMSFeatureInfo()
 */
-static
-int msWMSFeatureInfo(mapObj *map, int nVersion, char **names, char **values, int numentries,
-                     const char *wms_exception_format, owsRequestObj *ows_request)
-{
-  int feature_count=1, numlayers_found=0;
+static int msWMSFeatureInfo(mapObj *map, int nVersion, char **names,
+                            char **values, int numentries,
+                            const char *wms_exception_format,
+                            owsRequestObj *ows_request) {
+  int feature_count = 1, numlayers_found = 0;
   pointObj point = {-1.0, -1.0, -1.0, -1.0};
-  const char *info_format="MIME";
+  const char *info_format = "MIME";
   errorObj *ms_error = msGetErrorObj();
-  int query_status=MS_NOERR;
+  int query_status = MS_NOERR;
   int query_layer = 0;
-  const char *format_list=NULL;
-  int valid_format=MS_FALSE;
+  const char *format_list = NULL;
+  int valid_format = MS_FALSE;
   int format_found = MS_FALSE;
   int use_bbox = MS_FALSE;
-  int wms_layer =  MS_FALSE;
+  int wms_layer = MS_FALSE;
   const char *wms_connection = NULL;
   int numOWSLayers = 0;
 
-  char*** nestedGroups = (char***)msSmallCalloc(map->numlayers, sizeof(char**));
-  int* numNestedGroups = (int*)msSmallCalloc(map->numlayers, sizeof(int));
-  int* isUsedInNestedGroup = (int*)msSmallCalloc(map->numlayers, sizeof(int));
-  msWMSPrepareNestedGroups(map, nVersion, nestedGroups, numNestedGroups, isUsedInNestedGroup);
+  char ***nestedGroups =
+      (char ***)msSmallCalloc(map->numlayers, sizeof(char **));
+  int *numNestedGroups = (int *)msSmallCalloc(map->numlayers, sizeof(int));
+  int *isUsedInNestedGroup = (int *)msSmallCalloc(map->numlayers, sizeof(int));
+  msWMSPrepareNestedGroups(map, nVersion, nestedGroups, numNestedGroups,
+                           isUsedInNestedGroup);
 
-  for(int i=0; i<numentries; i++) {
-    if(strcasecmp(names[i], "QUERY_LAYERS") == 0) {
+  for (int i = 0; i < numentries; i++) {
+    if (strcasecmp(names[i], "QUERY_LAYERS") == 0) {
       query_layer = 1; /* flag set if QUERY_LAYERS is the request */
 
       const auto wmslayers = msStringSplit(values[i], ',');
-      if(wmslayers.empty()) {
-        msSetError(MS_WMSERR, "At least one layer name required in QUERY_LAYERS.", "msWMSFeatureInfo()");
-        return msWMSException(map, nVersion, "LayerNotDefined", wms_exception_format);
+      if (wmslayers.empty()) {
+        msSetError(MS_WMSERR,
+                   "At least one layer name required in QUERY_LAYERS.",
+                   "msWMSFeatureInfo()");
+        return msWMSException(map, nVersion, "LayerNotDefined",
+                              wms_exception_format);
       }
 
-      for(int j=0; j<map->numlayers; j++) {
+      for (int j = 0; j < map->numlayers; j++) {
         /* Force all layers OFF by default */
         GET_LAYER(map, j)->status = MS_OFF;
       }
 
       /* Special case for root layer */
-      const char* rootlayer_name = msOWSLookupMetadata(&(map->web.metadata), "MO", "rootlayer_name");
-      if( !rootlayer_name )
-          rootlayer_name = map->name;
-      if( rootlayer_name && msStringInArray(rootlayer_name, wmslayers) ) {
-        for(int j=0; j<map->numlayers; j++) {
-          layerObj* layer = GET_LAYER(map, j);
-          if( msIsLayerQueryable(layer) &&
-              msIntegerInArray(layer->index, ows_request->enabled_layers, ows_request->numlayers) ) {
+      const char *rootlayer_name =
+          msOWSLookupMetadata(&(map->web.metadata), "MO", "rootlayer_name");
+      if (!rootlayer_name)
+        rootlayer_name = map->name;
+      if (rootlayer_name && msStringInArray(rootlayer_name, wmslayers)) {
+        for (int j = 0; j < map->numlayers; j++) {
+          layerObj *layer = GET_LAYER(map, j);
+          if (msIsLayerQueryable(layer) &&
+              msIntegerInArray(layer->index, ows_request->enabled_layers,
+                               ows_request->numlayers)) {
             if (layer->connectiontype == MS_WMS) {
               wms_layer = MS_TRUE;
               wms_connection = layer->connection;
@@ -3999,15 +4530,20 @@ int msWMSFeatureInfo(mapObj *map, int nV
         }
       }
 
-      for(int j=0; j<map->numlayers; j++) {
-        layerObj* layer = GET_LAYER(map, j);
-        if( !msIsLayerQueryable(layer) )
-            continue;
-        for(const auto& wmslayer: wmslayers) {
-          if (((layer->name && strcasecmp(layer->name, wmslayer.c_str()) == 0) ||
-               (layer->group && strcasecmp(layer->group, wmslayer.c_str()) == 0) ||
-               ((numNestedGroups[j] >0) && msStringInArray(wmslayer.c_str(), nestedGroups[j], numNestedGroups[j]))) &&
-              (msIntegerInArray(layer->index, ows_request->enabled_layers, ows_request->numlayers)) ) {
+      for (int j = 0; j < map->numlayers; j++) {
+        layerObj *layer = GET_LAYER(map, j);
+        if (!msIsLayerQueryable(layer))
+          continue;
+        for (const auto &wmslayer : wmslayers) {
+          if (((layer->name &&
+                strcasecmp(layer->name, wmslayer.c_str()) == 0) ||
+               (layer->group &&
+                strcasecmp(layer->group, wmslayer.c_str()) == 0) ||
+               ((numNestedGroups[j] > 0) &&
+                msStringInArray(wmslayer.c_str(), nestedGroups[j],
+                                numNestedGroups[j]))) &&
+              (msIntegerInArray(layer->index, ows_request->enabled_layers,
+                                ows_request->numlayers))) {
 
             if (layer->connectiontype == MS_WMS) {
               wms_layer = MS_TRUE;
@@ -4026,7 +4562,7 @@ int msWMSFeatureInfo(mapObj *map, int nV
       }
     } else if (strcasecmp(names[i], "FEATURE_COUNT") == 0)
       feature_count = atoi(values[i]);
-    else if(strcasecmp(names[i], "X") == 0 || strcasecmp(names[i], "I") == 0)
+    else if (strcasecmp(names[i], "X") == 0 || strcasecmp(names[i], "I") == 0)
       point.x = atof(values[i]);
     else if (strcasecmp(names[i], "Y") == 0 || strcasecmp(names[i], "J") == 0)
       point.y = atof(values[i]);
@@ -4038,17 +4574,16 @@ int msWMSFeatureInfo(mapObj *map, int nV
 
       /* Special RADIUS value that changes the query into a bbox query */
       /* based on the bbox in the request parameters. */
-      if( strcasecmp(values[i], "BBOX") == 0) {
+      if (strcasecmp(values[i], "BBOX") == 0) {
         use_bbox = MS_TRUE;
       } else {
         int j;
-        for(j=0; j<map->numlayers; j++) {
+        for (j = 0; j < map->numlayers; j++) {
           GET_LAYER(map, j)->tolerance = atoi(values[i]);
           GET_LAYER(map, j)->toleranceunits = MS_PIXELS;
         }
       }
     }
-
   }
 
   /* free the stuff used for nested layers */
@@ -4061,32 +4596,46 @@ int msWMSFeatureInfo(mapObj *map, int nV
   free(numNestedGroups);
   free(isUsedInNestedGroup);
 
-  if(numlayers_found == 0) {
+  if (numlayers_found == 0) {
     if (query_layer) {
-      msSetError(MS_WMSERR, "Layer(s) specified in QUERY_LAYERS parameter is not offered by the service instance.", "msWMSFeatureInfo()");
-      return msWMSException(map, nVersion, "LayerNotDefined", wms_exception_format);
+      msSetError(MS_WMSERR,
+                 "Layer(s) specified in QUERY_LAYERS parameter is not offered "
+                 "by the service instance.",
+                 "msWMSFeatureInfo()");
+      return msWMSException(map, nVersion, "LayerNotDefined",
+                            wms_exception_format);
     } else {
-      msSetError(MS_WMSERR, "Required QUERY_LAYERS parameter missing for getFeatureInfo.", "msWMSFeatureInfo()");
-      return msWMSException(map, nVersion, "LayerNotDefined", wms_exception_format);
+      msSetError(MS_WMSERR,
+                 "Required QUERY_LAYERS parameter missing for getFeatureInfo.",
+                 "msWMSFeatureInfo()");
+      return msWMSException(map, nVersion, "LayerNotDefined",
+                            wms_exception_format);
     }
   }
 
-  /*make sure to initialize the map scale so that layers that are scale dependent are resepected for
-    the query*/
-  msCalculateScale(map->extent,map->units,map->width,map->height, map->resolution, &map->scaledenom);
+  /*make sure to initialize the map scale so that layers that are scale
+    dependent are resepected for the query*/
+  msCalculateScale(map->extent, map->units, map->width, map->height,
+                   map->resolution, &map->scaledenom);
 
   /* -------------------------------------------------------------------- */
   /*      check if all layers selected are queryable. If not send an      */
   /*      exception.                                                      */
   /* -------------------------------------------------------------------- */
 
-  /* If a layer of type WMS was found... all layers have to be of that type and with the same connection */
-  for (int i=0; i<map->numlayers; i++) {
+  /* If a layer of type WMS was found... all layers have to be of that type and
+   * with the same connection */
+  for (int i = 0; i < map->numlayers; i++) {
     if (GET_LAYER(map, i)->status == MS_ON) {
       if (wms_layer == MS_TRUE) {
-        if ( (GET_LAYER(map, i)->connectiontype != MS_WMS) || (strcasecmp(wms_connection, GET_LAYER(map, i)->connection) != 0) ) {
-          msSetError(MS_WMSERR, "Requested WMS layer(s) are not queryable: type or connection differ", "msWMSFeatureInfo()");
-          return msWMSException(map, nVersion, "LayerNotQueryable", wms_exception_format);
+        if ((GET_LAYER(map, i)->connectiontype != MS_WMS) ||
+            (strcasecmp(wms_connection, GET_LAYER(map, i)->connection) != 0)) {
+          msSetError(MS_WMSERR,
+                     "Requested WMS layer(s) are not queryable: type or "
+                     "connection differ",
+                     "msWMSFeatureInfo()");
+          return msWMSException(map, nVersion, "LayerNotQueryable",
+                                wms_exception_format);
         }
         ++numOWSLayers;
       }
@@ -4096,15 +4645,20 @@ int msWMSFeatureInfo(mapObj *map, int nV
   /* It's a valid Cascading WMS GetFeatureInfo request */
   if (wms_layer)
     return msWMSLayerExecuteRequest(map, numOWSLayers, point.x, point.y,
-                                    feature_count, info_format, WMS_GETFEATUREINFO);
+                                    feature_count, info_format,
+                                    WMS_GETFEATUREINFO);
 
-  if( use_bbox == MS_FALSE ) {
+  if (use_bbox == MS_FALSE) {
 
-    if(point.x == -1.0 || point.y == -1.0) {
+    if (point.x == -1.0 || point.y == -1.0) {
       if (nVersion >= OWS_1_3_0)
-        msSetError(MS_WMSERR, "Required I/J parameters missing for getFeatureInfo.", "msWMSFeatureInfo()");
+        msSetError(MS_WMSERR,
+                   "Required I/J parameters missing for getFeatureInfo.",
+                   "msWMSFeatureInfo()");
       else
-        msSetError(MS_WMSERR, "Required X/Y parameters missing for getFeatureInfo.", "msWMSFeatureInfo()");
+        msSetError(MS_WMSERR,
+                   "Required X/Y parameters missing for getFeatureInfo.",
+                   "msWMSFeatureInfo()");
       return msWMSException(map, nVersion, NULL, wms_exception_format);
     }
 
@@ -4112,12 +4666,17 @@ int msWMSFeatureInfo(mapObj *map, int nV
     if (nVersion >= OWS_1_3_0) {
       if (point.x > map->width || point.y > map->height) {
         msSetError(MS_WMSERR, "Invalid I/J values", "msWMSFeatureInfo()");
-        return msWMSException(map, nVersion, "InvalidPoint", wms_exception_format);
+        return msWMSException(map, nVersion, "InvalidPoint",
+                              wms_exception_format);
       }
     }
     /* Perform the actual query */
-    const double cellx = MS_CELLSIZE(map->extent.minx, map->extent.maxx, map->width); /* note: don't adjust extent, WMS assumes incoming extent is correct */
-    const double celly = MS_CELLSIZE(map->extent.miny, map->extent.maxy, map->height);
+    const double cellx =
+        MS_CELLSIZE(map->extent.minx, map->extent.maxx,
+                    map->width); /* note: don't adjust extent, WMS assumes
+                                    incoming extent is correct */
+    const double celly =
+        MS_CELLSIZE(map->extent.miny, map->extent.maxy, map->height);
     point.x = MS_IMAGE2MAP_X(point.x, map->extent.minx, cellx);
     point.y = MS_IMAGE2MAP_Y(point.y, map->extent.maxy, celly);
 
@@ -4128,14 +4687,16 @@ int msWMSFeatureInfo(mapObj *map, int nV
       feature_count = 1;
 
     map->query.type = MS_QUERY_BY_POINT;
-    map->query.mode = (feature_count==1?MS_QUERY_SINGLE:MS_QUERY_MULTIPLE);
+    map->query.mode =
+        (feature_count == 1 ? MS_QUERY_SINGLE : MS_QUERY_MULTIPLE);
     map->query.layer = -1;
     map->query.point = point;
     map->query.buffer = 0;
     map->query.maxresults = feature_count;
 
-    if(msQueryByPoint(map) != MS_SUCCESS)
-      if((query_status=ms_error->code) != MS_NOTFOUND) return msWMSException(map, nVersion, NULL, wms_exception_format);
+    if (msQueryByPoint(map) != MS_SUCCESS)
+      if ((query_status = ms_error->code) != MS_NOTFOUND)
+        return msWMSException(map, nVersion, NULL, wms_exception_format);
 
   } else { /* use_bbox == MS_TRUE */
     map->query.type = MS_QUERY_BY_RECT;
@@ -4144,8 +4705,9 @@ int msWMSFeatureInfo(mapObj *map, int nV
     map->query.rect = map->extent;
     map->query.buffer = 0;
     map->query.maxresults = feature_count;
-    if(msQueryByRect(map) != MS_SUCCESS)
-      if((query_status=ms_error->code) != MS_NOTFOUND) return msWMSException(map, nVersion, NULL, wms_exception_format);
+    if (msQueryByRect(map) != MS_SUCCESS)
+      if ((query_status = ms_error->code) != MS_NOTFOUND)
+        return msWMSException(map, nVersion, NULL, wms_exception_format);
   }
 
   /*validate the INFO_FORMAT*/
@@ -4172,16 +4734,17 @@ int msWMSFeatureInfo(mapObj *map, int nV
       strcasecmp(info_format, "application/vnd.ogc.gml") == 0)
     valid_format = MS_TRUE;
 
-
-  /*last case: if the info_format is not part of the request, it defaults to MIME*/
+  /*last case: if the info_format is not part of the request, it defaults to
+   * MIME*/
   if (!valid_format && format_found == MS_FALSE)
-    valid_format =MS_TRUE;
+    valid_format = MS_TRUE;
 
   if (!valid_format) {
     msSetError(MS_WMSERR, "Unsupported INFO_FORMAT value (%s).",
                "msWMSFeatureInfo()", info_format);
     if (nVersion >= OWS_1_3_0)
-      return msWMSException(map, nVersion, "InvalidFormat", wms_exception_format);
+      return msWMSException(map, nVersion, "InvalidFormat",
+                            wms_exception_format);
     else
       return msWMSException(map, nVersion, NULL, wms_exception_format);
   }
@@ -4193,21 +4756,23 @@ int msWMSFeatureInfo(mapObj *map, int nV
     /* MIME response... we're free to use any valid MIME type */
     int numresults = 0;
 
-    msIO_setHeader("Content-Type","text/plain; charset=UTF-8");
+    msIO_setHeader("Content-Type", "text/plain; charset=UTF-8");
     msIO_sendHeaders();
     msIO_printf("GetFeatureInfo results:\n");
 
     numresults = msDumpResult(map, nVersion, wms_exception_format);
 
-    if (numresults == 0) msIO_printf("\n  Search returned no results.\n");
+    if (numresults == 0)
+      msIO_printf("\n  Search returned no results.\n");
 
-  } else if (strncasecmp(info_format, "GML", 3) == 0 ||  /* accept GML.1 or GML */
+  } else if (strncasecmp(info_format, "GML", 3) ==
+                 0 || /* accept GML.1 or GML */
              strcasecmp(info_format, "application/vnd.ogc.gml") == 0) {
 
-    if (nVersion <= OWS_1_0_7)   /* 1.0.0 to 1.0.7 */
-      msIO_setHeader("Content-Type","text/xml; charset=UTF-8");
+    if (nVersion <= OWS_1_0_7) /* 1.0.0 to 1.0.7 */
+      msIO_setHeader("Content-Type", "text/xml; charset=UTF-8");
     else /* 1.1.0 and later */
-      msIO_setHeader("Content-Type","application/vnd.ogc.gml; charset=UTF-8");
+      msIO_setHeader("Content-Type", "application/vnd.ogc.gml; charset=UTF-8");
     msIO_sendHeaders();
     msGMLWriteQuery(map, NULL, "MGO"); /* default is stdout */
 
@@ -4219,7 +4784,9 @@ int msWMSFeatureInfo(mapObj *map, int nV
     msObj = msAllocMapServObj();
 
     /* Translate some vars from WMS to mapserv */
-    msTranslateWMS2Mapserv((const char**)names, (const char**)values, numentries, &translated_names, &translated_values, &translated_numentries);
+    msTranslateWMS2Mapserv((const char **)names, (const char **)values,
+                           numentries, &translated_names, &translated_values,
+                           &translated_numentries);
 
     msObj->map = map;
     msFreeCharArray(msObj->request->ParamNames, msObj->request->NumParams);
@@ -4232,9 +4799,10 @@ int msWMSFeatureInfo(mapObj *map, int nV
     msObj->mappnt.y = point.y;
 
     if (query_status == MS_NOTFOUND && msObj->map->web.empty) {
-      if(msReturnURL(msObj, msObj->map->web.empty, BROWSE) != MS_SUCCESS)
+      if (msReturnURL(msObj, msObj->map->web.empty, BROWSE) != MS_SUCCESS)
         return msWMSException(map, nVersion, NULL, wms_exception_format);
-    } else if (msReturnTemplateQuery(msObj, (char *)info_format, NULL) != MS_SUCCESS)
+    } else if (msReturnTemplateQuery(msObj, (char *)info_format, NULL) !=
+               MS_SUCCESS)
       return msWMSException(map, nVersion, NULL, wms_exception_format);
 
     /* We don't want to free the map since it */
@@ -4244,114 +4812,134 @@ int msWMSFeatureInfo(mapObj *map, int nV
     msFreeMapServObj(msObj);
   }
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
 /*
 ** msWMSDescribeLayer()
 */
-static
-int msWMSDescribeLayer(mapObj *map, int nVersion, char **names,
-                       char **values, int numentries, const char *wms_exception_format)
-{
+static int msWMSDescribeLayer(mapObj *map, int nVersion, char **names,
+                              char **values, int numentries,
+                              const char *wms_exception_format) {
   std::vector<std::string> wmslayers;
   const char *version = NULL;
   const char *sld_version = NULL;
 
-  for(int i=0; i<numentries; i++) {
-    if(strcasecmp(names[i], "LAYERS") == 0) {
+  for (int i = 0; i < numentries; i++) {
+    if (strcasecmp(names[i], "LAYERS") == 0) {
       wmslayers = msStringSplit(values[i], ',');
     }
-    if(strcasecmp(names[i], "VERSION") == 0) {
+    if (strcasecmp(names[i], "VERSION") == 0) {
       version = values[i];
     }
-    if(strcasecmp(names[i], "SLD_VERSION") == 0) {
+    if (strcasecmp(names[i], "SLD_VERSION") == 0) {
       sld_version = values[i];
     }
   }
 
   if (nVersion >= OWS_1_3_0 && sld_version == NULL) {
-    msSetError(MS_WMSERR, "Missing required parameter SLD_VERSION", "DescribeLayer()");
-    return msWMSException(map, nVersion, "MissingParameterValue", wms_exception_format);
+    msSetError(MS_WMSERR, "Missing required parameter SLD_VERSION",
+               "DescribeLayer()");
+    return msWMSException(map, nVersion, "MissingParameterValue",
+                          wms_exception_format);
   }
   if (nVersion >= OWS_1_3_0 && strcasecmp(sld_version, "1.1.0") != 0) {
     msSetError(MS_WMSERR, "SLD_VERSION must be 1.1.0", "DescribeLayer()");
-    return msWMSException(map, nVersion, "InvalidParameterValue", wms_exception_format);
+    return msWMSException(map, nVersion, "InvalidParameterValue",
+                          wms_exception_format);
   }
 
-  msIO_setHeader("Content-Type","text/xml; charset=UTF-8");
+  msIO_setHeader("Content-Type", "text/xml; charset=UTF-8");
   msIO_sendHeaders();
 
   msIO_printf("<?xml version='1.0' encoding=\"UTF-8\"?>\n");
 
   {
-   char* schemalocation = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
-   if (nVersion < OWS_1_3_0) {
-
-    msIO_printf("<!DOCTYPE WMS_DescribeLayerResponse SYSTEM \"%s/wms/1.1.1/WMS_DescribeLayerResponse.dtd\">\n", schemalocation);
+    char *schemalocation = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
+    if (nVersion < OWS_1_3_0) {
 
+      msIO_printf("<!DOCTYPE WMS_DescribeLayerResponse SYSTEM "
+                  "\"%s/wms/1.1.1/WMS_DescribeLayerResponse.dtd\">\n",
+                  schemalocation);
 
-    msIO_printf("<WMS_DescribeLayerResponse version=\"%s\" >\n", version);
-   } else {
-    msIO_printf("<DescribeLayerResponse xmlns=\"http://www.opengis.net/sld\" xmlns:ows=\"http://www.opengis.net/ows\" xmlns:se=\"http://www.opengis.net/se\" xmlns:wfs=\"http://www.opengis.net/wfs\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:xlink=\"http://www.w3.org/1999/xlink\" xsi:schemaLocation=\"http://www.opengis.net/sld %s/sld/1.1.0/DescribeLayer.xsd\">\n", schemalocation);
-    msIO_printf("<Version>%s</Version>\n",sld_version);
-   }
-   free(schemalocation);
+      msIO_printf("<WMS_DescribeLayerResponse version=\"%s\" >\n", version);
+    } else {
+      msIO_printf("<DescribeLayerResponse xmlns=\"http://www.opengis.net/sld\" "
+                  "xmlns:ows=\"http://www.opengis.net/ows\" "
+                  "xmlns:se=\"http://www.opengis.net/se\" "
+                  "xmlns:wfs=\"http://www.opengis.net/wfs\" "
+                  "xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" "
+                  "xmlns:xlink=\"http://www.w3.org/1999/xlink\" "
+                  "xsi:schemaLocation=\"http://www.opengis.net/sld "
+                  "%s/sld/1.1.0/DescribeLayer.xsd\">\n",
+                  schemalocation);
+      msIO_printf("<Version>%s</Version>\n", sld_version);
+    }
+    free(schemalocation);
   }
 
   /* check if map-level metadata wfs(wcs)_onlineresource is available */
-  const char* pszOnlineResMapWFS = msOWSLookupMetadata(&(map->web.metadata), "FO", "onlineresource");
+  const char *pszOnlineResMapWFS =
+      msOWSLookupMetadata(&(map->web.metadata), "FO", "onlineresource");
   if (pszOnlineResMapWFS && strlen(pszOnlineResMapWFS) == 0)
     pszOnlineResMapWFS = NULL;
 
-  const char* pszOnlineResMapWCS = msOWSLookupMetadata(&(map->web.metadata), "CO", "onlineresource");
+  const char *pszOnlineResMapWCS =
+      msOWSLookupMetadata(&(map->web.metadata), "CO", "onlineresource");
   if (pszOnlineResMapWCS && strlen(pszOnlineResMapWCS) == 0)
     pszOnlineResMapWCS = NULL;
 
-  char*** nestedGroups = (char***)msSmallCalloc(map->numlayers, sizeof(char**));
-  int* numNestedGroups = (int*)msSmallCalloc(map->numlayers, sizeof(int));
-  int * isUsedInNestedGroup = (int*)msSmallCalloc(map->numlayers, sizeof(int));
-  msWMSPrepareNestedGroups(map, nVersion, nestedGroups, numNestedGroups, isUsedInNestedGroup);
-
-  for(const auto& wmslayer: wmslayers) {
-    for(int k=0; k<map->numlayers; k++) {
-      layerObj* lp = GET_LAYER(map, k);
+  char ***nestedGroups =
+      (char ***)msSmallCalloc(map->numlayers, sizeof(char **));
+  int *numNestedGroups = (int *)msSmallCalloc(map->numlayers, sizeof(int));
+  int *isUsedInNestedGroup = (int *)msSmallCalloc(map->numlayers, sizeof(int));
+  msWMSPrepareNestedGroups(map, nVersion, nestedGroups, numNestedGroups,
+                           isUsedInNestedGroup);
+
+  for (const auto &wmslayer : wmslayers) {
+    for (int k = 0; k < map->numlayers; k++) {
+      layerObj *lp = GET_LAYER(map, k);
 
       if ((map->name && strcasecmp(map->name, wmslayer.c_str()) == 0) ||
           (lp->name && strcasecmp(lp->name, wmslayer.c_str()) == 0) ||
           (lp->group && strcasecmp(lp->group, wmslayer.c_str()) == 0) ||
-          ((numNestedGroups[k] >0) && msStringInArray(wmslayer.c_str(), nestedGroups[k], numNestedGroups[k]))) {
+          ((numNestedGroups[k] > 0) &&
+           msStringInArray(wmslayer.c_str(), nestedGroups[k],
+                           numNestedGroups[k]))) {
         /* Look for a WFS onlineresouce at the layer level and then at
          * the map level.
          */
-        const char* pszOnlineResLyrWFS = msOWSLookupMetadata(&(lp->metadata), "FO",
-                             "onlineresource");
-        const char* pszOnlineResLyrWCS = msOWSLookupMetadata(&(lp->metadata), "CO",
-                             "onlineresource");
+        const char *pszOnlineResLyrWFS =
+            msOWSLookupMetadata(&(lp->metadata), "FO", "onlineresource");
+        const char *pszOnlineResLyrWCS =
+            msOWSLookupMetadata(&(lp->metadata), "CO", "onlineresource");
         if (pszOnlineResLyrWFS == NULL || strlen(pszOnlineResLyrWFS) == 0)
           pszOnlineResLyrWFS = pszOnlineResMapWFS;
 
         if (pszOnlineResLyrWCS == NULL || strlen(pszOnlineResLyrWCS) == 0)
           pszOnlineResLyrWCS = pszOnlineResMapWCS;
 
-        if (pszOnlineResLyrWFS && (lp->type == MS_LAYER_POINT ||
-                                   lp->type == MS_LAYER_LINE ||
-                                   lp->type == MS_LAYER_POLYGON) ) {
-          char* pszOnlineResEncoded = msEncodeHTMLEntities(pszOnlineResLyrWFS);
-          char* pszLayerName = msEncodeHTMLEntities(lp->name);
+        if (pszOnlineResLyrWFS &&
+            (lp->type == MS_LAYER_POINT || lp->type == MS_LAYER_LINE ||
+             lp->type == MS_LAYER_POLYGON)) {
+          char *pszOnlineResEncoded = msEncodeHTMLEntities(pszOnlineResLyrWFS);
+          char *pszLayerName = msEncodeHTMLEntities(lp->name);
 
           if (nVersion < OWS_1_3_0) {
-            msIO_printf("<LayerDescription name=\"%s\" wfs=\"%s\" owsType=\"WFS\" owsURL=\"%s\">\n",
+            msIO_printf("<LayerDescription name=\"%s\" wfs=\"%s\" "
+                        "owsType=\"WFS\" owsURL=\"%s\">\n",
                         pszLayerName, pszOnlineResEncoded, pszOnlineResEncoded);
             msIO_printf("<Query typeName=\"%s\" />\n", pszLayerName);
             msIO_printf("</LayerDescription>\n");
           } else { /*wms 1.3.0*/
             msIO_printf("  <LayerDescription>\n");
             msIO_printf("    <owsType>wfs</owsType>\n");
-            msIO_printf("    <se:OnlineResource xlink:type=\"simple\" xlink:href=\"%s\"/>\n",
+            msIO_printf("    <se:OnlineResource xlink:type=\"simple\" "
+                        "xlink:href=\"%s\"/>\n",
                         pszOnlineResEncoded);
             msIO_printf("    <TypeName>\n");
-            msIO_printf("      <se:FeatureTypeName>%s</se:FeatureTypeName>\n",pszLayerName);
+            msIO_printf("      <se:FeatureTypeName>%s</se:FeatureTypeName>\n",
+                        pszLayerName);
             msIO_printf("    </TypeName>\n");
             msIO_printf("  </LayerDescription>\n");
           }
@@ -4360,21 +4948,24 @@ int msWMSDescribeLayer(mapObj *map, int
           msFree(pszLayerName);
         } else if (pszOnlineResLyrWCS && lp->type == MS_LAYER_RASTER &&
                    lp->connectiontype != MS_WMS) {
-          char* pszOnlineResEncoded = msEncodeHTMLEntities(pszOnlineResLyrWCS);
-          char* pszLayerName = msEncodeHTMLEntities(lp->name);
+          char *pszOnlineResEncoded = msEncodeHTMLEntities(pszOnlineResLyrWCS);
+          char *pszLayerName = msEncodeHTMLEntities(lp->name);
 
           if (nVersion < OWS_1_3_0) {
-            msIO_printf("<LayerDescription name=\"%s\"  owsType=\"WCS\" owsURL=\"%s\">\n",
+            msIO_printf("<LayerDescription name=\"%s\"  owsType=\"WCS\" "
+                        "owsURL=\"%s\">\n",
                         pszLayerName, pszOnlineResEncoded);
             msIO_printf("<Query typeName=\"%s\" />\n", pszLayerName);
             msIO_printf("</LayerDescription>\n");
           } else {
             msIO_printf("  <LayerDescription>\n");
             msIO_printf("    <owsType>wcs</owsType>\n");
-            msIO_printf("    <se:OnlineResource xlink:type=\"simple\" xlink:href=\"%s\"/>\n",
+            msIO_printf("    <se:OnlineResource xlink:type=\"simple\" "
+                        "xlink:href=\"%s\"/>\n",
                         pszOnlineResEncoded);
             msIO_printf("    <TypeName>\n");
-            msIO_printf("      <se:CoverageTypeName>%s</se:CoverageTypeName>\n",pszLayerName);
+            msIO_printf("      <se:CoverageTypeName>%s</se:CoverageTypeName>\n",
+                        pszLayerName);
             msIO_printf("    </TypeName>\n");
             msIO_printf("  </LayerDescription>\n");
           }
@@ -4397,9 +4988,12 @@ int msWMSDescribeLayer(mapObj *map, int
             msIO_printf("    <se:OnlineResource xlink:type=\"simple\"/>\n");
             msIO_printf("    <TypeName>\n");
             if (lp->type == MS_LAYER_RASTER && lp->connectiontype != MS_WMS)
-              msIO_printf("      <se:CoverageTypeName>%s</se:CoverageTypeName>\n",pszLayerName);
+              msIO_printf(
+                  "      <se:CoverageTypeName>%s</se:CoverageTypeName>\n",
+                  pszLayerName);
             else
-              msIO_printf("      <se:FeatureTypeName>%s</se:FeatureTypeName>\n",pszLayerName);
+              msIO_printf("      <se:FeatureTypeName>%s</se:FeatureTypeName>\n",
+                          pszLayerName);
             msIO_printf("    </TypeName>\n");
             msIO_printf("  </LayerDescription>\n");
           }
@@ -4426,43 +5020,42 @@ int msWMSDescribeLayer(mapObj *map, int
   free(numNestedGroups);
   free(isUsedInNestedGroup);
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
-
 /*
 ** msWMSGetLegendGraphic()
 */
-static
-int msWMSLegendGraphic(mapObj *map, int nVersion, char **names,
-                       char **values, int numentries, const char *wms_exception_format, owsRequestObj *ows_request,
-                       map_hittest *hittest)
-{
+static int msWMSLegendGraphic(mapObj *map, int nVersion, char **names,
+                              char **values, int numentries,
+                              const char *wms_exception_format,
+                              owsRequestObj *ows_request,
+                              map_hittest *hittest) {
   const char *pszLayer = NULL;
   const char *pszFormat = NULL;
   const char *psRule = NULL;
   const char *psScale = NULL;
   int iLayerIndex = -1;
   outputFormatObj *psFormat = NULL;
-  imageObj *img=NULL;
-  int nWidth = -1, nHeight =-1;
+  imageObj *img = NULL;
+  int nWidth = -1, nHeight = -1;
   const char *pszStyle = NULL;
   const char *sld_version = NULL;
-  int wms_layer =  MS_FALSE;
+  int wms_layer = MS_FALSE;
   const char *sldenabled = NULL;
   const char *format_list = NULL;
-  int nLayers =0;
-
-  if(!hittest) {
-    /* we can skip alot of testing if we already have a hittest, as it has already been done in the hittesting phase */
+  int nLayers = 0;
 
+  if (!hittest) {
+    /* we can skip alot of testing if we already have a hittest, as it has
+     * already been done in the hittesting phase */
 
     sldenabled = msOWSLookupMetadata(&(map->web.metadata), "MO", "sld_enabled");
 
     if (sldenabled == NULL)
       sldenabled = "true";
 
-    for(int i=0; i<numentries; i++) {
+    for (int i = 0; i < numentries; i++) {
       if (strcasecmp(names[i], "LAYER") == 0) {
         pszLayer = values[i];
       } else if (strcasecmp(names[i], "WIDTH") == 0)
@@ -4481,11 +5074,11 @@ int msWMSLegendGraphic(mapObj *map, int
       /*        - check the SLD_BODY parameter that should contain the SLD    */
       /*      xml string.                                                     */
       /* -------------------------------------------------------------------- */
-      else if (strcasecmp(names[i], "SLD") == 0 &&
-          values[i] && strlen(values[i]) > 0 && strcasecmp(sldenabled, "true") == 0)
+      else if (strcasecmp(names[i], "SLD") == 0 && values[i] &&
+               strlen(values[i]) > 0 && strcasecmp(sldenabled, "true") == 0)
         msSLDApplySLDURL(map, values[i], -1, NULL, NULL);
-      else if (strcasecmp(names[i], "SLD_BODY") == 0 &&
-          values[i] && strlen(values[i]) > 0 && strcasecmp(sldenabled, "true") == 0)
+      else if (strcasecmp(names[i], "SLD_BODY") == 0 && values[i] &&
+               strlen(values[i]) > 0 && strcasecmp(sldenabled, "true") == 0)
         msSLDApplySLD(map, values[i], -1, NULL, NULL);
       else if (strcasecmp(names[i], "RULE") == 0)
         psRule = values[i];
@@ -4497,42 +5090,59 @@ int msWMSLegendGraphic(mapObj *map, int
       /*        - because the request parameter "sld_version" is required in  */
       /*          in WMS 1.3.0, it will be set regardless of OGR support.     */
       /* -------------------------------------------------------------------- */
-      else if(strcasecmp(names[i], "SLD_VERSION") == 0)
+      else if (strcasecmp(names[i], "SLD_VERSION") == 0)
         sld_version = values[i];
     }
 
     if (!pszLayer) {
-      msSetError(MS_WMSERR, "Mandatory LAYER parameter missing in GetLegendGraphic request.", "msWMSGetLegendGraphic()");
-      return msWMSException(map, nVersion, "LayerNotDefined", wms_exception_format);
+      msSetError(
+          MS_WMSERR,
+          "Mandatory LAYER parameter missing in GetLegendGraphic request.",
+          "msWMSGetLegendGraphic()");
+      return msWMSException(map, nVersion, "LayerNotDefined",
+                            wms_exception_format);
     }
     if (!pszFormat) {
-      msSetError(MS_WMSERR, "Mandatory FORMAT parameter missing in GetLegendGraphic request.", "msWMSGetLegendGraphic()");
-      return msWMSException(map, nVersion, "InvalidFormat", wms_exception_format);
+      msSetError(
+          MS_WMSERR,
+          "Mandatory FORMAT parameter missing in GetLegendGraphic request.",
+          "msWMSGetLegendGraphic()");
+      return msWMSException(map, nVersion, "InvalidFormat",
+                            wms_exception_format);
     }
 
     if (nVersion >= OWS_1_3_0 && sld_version == NULL) {
-      msSetError(MS_WMSERR, "Missing required parameter SLD_VERSION", "GetLegendGraphic()");
-      return msWMSException(map, nVersion, "MissingParameterValue", wms_exception_format);
+      msSetError(MS_WMSERR, "Missing required parameter SLD_VERSION",
+                 "GetLegendGraphic()");
+      return msWMSException(map, nVersion, "MissingParameterValue",
+                            wms_exception_format);
     }
     if (nVersion >= OWS_1_3_0 && strcasecmp(sld_version, "1.1.0") != 0) {
       msSetError(MS_WMSERR, "SLD_VERSION must be 1.1.0", "GetLegendGraphic()");
-      return msWMSException(map, nVersion, "InvalidParameterValue", wms_exception_format);
+      return msWMSException(map, nVersion, "InvalidParameterValue",
+                            wms_exception_format);
     }
 
-    char*** nestedGroups = (char***)msSmallCalloc(map->numlayers, sizeof(char**));
-    int* numNestedGroups = (int*)msSmallCalloc(map->numlayers, sizeof(int));
-    int* isUsedInNestedGroup = (int*)msSmallCalloc(map->numlayers, sizeof(int));
-    msWMSPrepareNestedGroups(map, nVersion, nestedGroups, numNestedGroups, isUsedInNestedGroup);
+    char ***nestedGroups =
+        (char ***)msSmallCalloc(map->numlayers, sizeof(char **));
+    int *numNestedGroups = (int *)msSmallCalloc(map->numlayers, sizeof(int));
+    int *isUsedInNestedGroup =
+        (int *)msSmallCalloc(map->numlayers, sizeof(int));
+    msWMSPrepareNestedGroups(map, nVersion, nestedGroups, numNestedGroups,
+                             isUsedInNestedGroup);
 
     /* check if layer name is valid. we check for layer's and group's name */
     /* as well as wms_layer_group names */
-    for (int i=0; i<map->numlayers; i++) {
-      layerObj* lp = GET_LAYER(map, i);
-      if (  ((map->name && strcasecmp(map->name, pszLayer) == 0) ||
-          (lp->name && strcasecmp(lp->name, pszLayer) == 0) ||
-          (lp->group && strcasecmp(lp->group, pszLayer) == 0) ||
-          ((numNestedGroups[i] >0) && (msStringInArray(pszLayer, nestedGroups[i], numNestedGroups[i]))) ) &&
-          (msIntegerInArray(lp->index, ows_request->enabled_layers, ows_request->numlayers)) ) {
+    for (int i = 0; i < map->numlayers; i++) {
+      layerObj *lp = GET_LAYER(map, i);
+      if (((map->name && strcasecmp(map->name, pszLayer) == 0) ||
+           (lp->name && strcasecmp(lp->name, pszLayer) == 0) ||
+           (lp->group && strcasecmp(lp->group, pszLayer) == 0) ||
+           ((numNestedGroups[i] > 0) &&
+            (msStringInArray(pszLayer, nestedGroups[i],
+                             numNestedGroups[i])))) &&
+          (msIntegerInArray(lp->index, ows_request->enabled_layers,
+                            ows_request->numlayers))) {
         nLayers++;
         lp->status = MS_ON;
         iLayerIndex = i;
@@ -4540,8 +5150,9 @@ int msWMSLegendGraphic(mapObj *map, int
           /* we do not cascade a wms layer if it contains at least
            * one class with the property name set */
           wms_layer = MS_TRUE;
-          for (int j=0; j<lp->numclasses; j++) {
-            if (lp->_class[j]->name != NULL && strlen(lp->_class[j]->name)>0) {
+          for (int j = 0; j < lp->numclasses; j++) {
+            if (lp->_class[j]->name != NULL &&
+                strlen(lp->_class[j]->name) > 0) {
               wms_layer = MS_FALSE;
               break;
             }
@@ -4562,60 +5173,67 @@ int msWMSLegendGraphic(mapObj *map, int
     free(isUsedInNestedGroup);
 
     if (nLayers == 0) {
-      msSetError(MS_WMSERR, "Invalid layer given in the LAYER parameter. A layer might be disabled for \
+      msSetError(
+          MS_WMSERR,
+          "Invalid layer given in the LAYER parameter. A layer might be disabled for \
 this request. Check wms/ows_enable_request settings.",
-"msWMSGetLegendGraphic()");
-      return msWMSException(map, nVersion, "LayerNotDefined", wms_exception_format);
+          "msWMSGetLegendGraphic()");
+      return msWMSException(map, nVersion, "LayerNotDefined",
+                            wms_exception_format);
     }
 
-
-    /* if SCALE was provided in request, calculate an extent and use a default width and height */
-    if ( psScale != NULL ) {
+    /* if SCALE was provided in request, calculate an extent and use a default
+     * width and height */
+    if (psScale != NULL) {
       double scale, cellsize;
 
       scale = atof(psScale);
       map->width = 600;
       map->height = 600;
 
-      cellsize = (scale/map->resolution)/msInchesPerUnit(map->units, 0.0);
+      cellsize = (scale / map->resolution) / msInchesPerUnit(map->units, 0.0);
 
-      map->extent.maxx = cellsize*map->width/2.0;
-      map->extent.maxy = cellsize*map->height/2.0;
+      map->extent.maxx = cellsize * map->width / 2.0;
+      map->extent.maxy = cellsize * map->height / 2.0;
       map->extent.minx = -map->extent.maxx;
       map->extent.miny = -map->extent.maxy;
     }
 
     /* It's a valid Cascading WMS GetLegendGraphic request */
     if (wms_layer)
-      return msWMSLayerExecuteRequest(map, 1, 0, 0,
-          0, NULL, WMS_GETLEGENDGRAPHIC);
+      return msWMSLayerExecuteRequest(map, 1, 0, 0, 0, NULL,
+                                      WMS_GETLEGENDGRAPHIC);
 
     /*if STYLE is set, check if it is a valid style (valid = at least one
     of the classes have a the group value equals to the style */
     /*style is only validated when there is only one layer #3411*/
-    if (nLayers == 1 &&  pszStyle && strlen(pszStyle) > 0 && strcasecmp(pszStyle, "default") != 0) {
+    if (nLayers == 1 && pszStyle && strlen(pszStyle) > 0 &&
+        strcasecmp(pszStyle, "default") != 0) {
       bool found = false;
-      for (int i=0; i<GET_LAYER(map, iLayerIndex)->numclasses; i++) {
+      for (int i = 0; i < GET_LAYER(map, iLayerIndex)->numclasses; i++) {
         if (GET_LAYER(map, iLayerIndex)->_class[i]->group &&
-            strcasecmp(GET_LAYER(map, iLayerIndex)->_class[i]->group, pszStyle) == 0) {
+            strcasecmp(GET_LAYER(map, iLayerIndex)->_class[i]->group,
+                       pszStyle) == 0) {
           found = true;
           break;
         }
       }
 
       if (!found) {
-        msSetError(MS_WMSERR, "style used in the STYLE parameter is not defined on the layer.",
+        msSetError(
+            MS_WMSERR,
+            "style used in the STYLE parameter is not defined on the layer.",
             "msWMSGetLegendGraphic()");
-        return msWMSException(map, nVersion, "StyleNotDefined", wms_exception_format);
+        return msWMSException(map, nVersion, "StyleNotDefined",
+                              wms_exception_format);
       } else {
         msFree(GET_LAYER(map, iLayerIndex)->classgroup);
         GET_LAYER(map, iLayerIndex)->classgroup = msStrdup(pszStyle);
-
       }
     }
   } else {
     /* extract the parameters we need */
-    for(int i=0; i<numentries; i++) {
+    for (int i = 0; i < numentries; i++) {
       if (strcasecmp(names[i], "FORMAT") == 0)
         pszFormat = values[i];
       else if (strcasecmp(names[i], "RULE") == 0)
@@ -4625,36 +5243,36 @@ this request. Check wms/ows_enable_reque
   /* validate format */
 
   /*check to see if a predefined list is given*/
-  format_list = msOWSLookupMetadata(&(map->web.metadata), "M","getlegendgraphic_formatlist");
+  format_list = msOWSLookupMetadata(&(map->web.metadata), "M",
+                                    "getlegendgraphic_formatlist");
   if (format_list) {
     psFormat = msOwsIsOutputFormatValid(map, pszFormat, &(map->web.metadata),
-        "M", "getlegendgraphic_formatlist");
+                                        "M", "getlegendgraphic_formatlist");
     if (psFormat == NULL) {
-      msSetError(MS_IMGERR,
-          "Unsupported output format (%s).",
-          "msWMSGetLegendGraphic()",
-          pszFormat);
-      return msWMSException(map, nVersion, "InvalidFormat", wms_exception_format);
+      msSetError(MS_IMGERR, "Unsupported output format (%s).",
+                 "msWMSGetLegendGraphic()", pszFormat);
+      return msWMSException(map, nVersion, "InvalidFormat",
+                            wms_exception_format);
     }
   } else {
-    psFormat = msSelectOutputFormat( map, pszFormat);
-    if( psFormat == NULL || ! MS_RENDERER_PLUGIN(psFormat) )
-      /* msDrawLegend and msCreateLegendIcon both switch the alpha channel to gd
-       ** after creation, so they can be called here without going through
-       ** the msAlphaGD2AGG functions */
+    psFormat = msSelectOutputFormat(map, pszFormat);
+    if (psFormat == NULL || !MS_RENDERER_PLUGIN(psFormat))
+    /* msDrawLegend and msCreateLegendIcon both switch the alpha channel to gd
+     ** after creation, so they can be called here without going through
+     ** the msAlphaGD2AGG functions */
     {
-      msSetError(MS_IMGERR,
-          "Unsupported output format (%s).",
-          "msWMSGetLegendGraphic()",
-          pszFormat);
-      return msWMSException(map, nVersion, "InvalidFormat", wms_exception_format);
+      msSetError(MS_IMGERR, "Unsupported output format (%s).",
+                 "msWMSGetLegendGraphic()", pszFormat);
+      return msWMSException(map, nVersion, "InvalidFormat",
+                            wms_exception_format);
     }
   }
   msApplyOutputFormat(&(map->outputformat), psFormat, MS_NOOVERRIDE);
-  
-  if ( psRule == NULL || nLayers > 1) {
-    if ( psScale != NULL ) {
-      /* Scale-dependent legend. map->scaledenom will be calculated in msDrawLegend */
+
+  if (psRule == NULL || nLayers > 1) {
+    if (psScale != NULL) {
+      /* Scale-dependent legend. map->scaledenom will be calculated in
+       * msDrawLegend */
       img = msDrawLegend(map, MS_FALSE, NULL);
     } else {
       /* Scale-independent legend */
@@ -4663,22 +5281,20 @@ this request. Check wms/ows_enable_reque
   } else {
     /* RULE was specified. Get the class corresponding to the RULE */
     /* (RULE = class->name) */
-    /* TBT FIXME? also check the map->scaledenom if multiple scale-dependant classes with same name */
+    /* TBT FIXME? also check the map->scaledenom if multiple scale-dependant
+     * classes with same name */
 
-    layerObj* lp = GET_LAYER(map, iLayerIndex);
+    layerObj *lp = GET_LAYER(map, iLayerIndex);
     int i;
-    for (i=0; i<lp->numclasses; i++) {
+    for (i = 0; i < lp->numclasses; i++) {
       if (lp->classgroup &&
           (lp->_class[i]->group == NULL ||
-           strcasecmp(lp->_class[i]->group,
-                      lp->classgroup) != 0))
+           strcasecmp(lp->_class[i]->group, lp->classgroup) != 0))
         continue;
 
-      if (lp->_class[i]->name &&
-          strlen(lp->_class[i]->name) > 0 &&
-          strcasecmp(lp->_class[i]->name,psRule) == 0)
+      if (lp->_class[i]->name && strlen(lp->_class[i]->name) > 0 &&
+          strcasecmp(lp->_class[i]->name, psRule) == 0)
         break;
-
     }
     if (i < lp->numclasses) {
       /* set the map legend parameters */
@@ -4695,24 +5311,21 @@ this request. Check wms/ows_enable_reque
           nHeight = 20;
       }
 
-      if ( psScale != NULL ) {
+      if (psScale != NULL) {
         /* Scale-dependent legend. calculate map->scaledenom */
         map->cellsize = msAdjustExtent(&(map->extent), map->width, map->height);
-        msCalculateScale(map->extent, map->units, map->width, map->height, map->resolution, &map->scaledenom);
-        img = msCreateLegendIcon(map, lp,
-                                 lp->_class[i],
-                                 nWidth, nHeight, MS_FALSE);
+        msCalculateScale(map->extent, map->units, map->width, map->height,
+                         map->resolution, &map->scaledenom);
+        img = msCreateLegendIcon(map, lp, lp->_class[i], nWidth, nHeight,
+                                 MS_FALSE);
       } else {
         /* Scale-independent legend */
-        img = msCreateLegendIcon(map, lp,
-                                 lp->_class[i],
-                                 nWidth, nHeight, MS_TRUE);
+        img = msCreateLegendIcon(map, lp, lp->_class[i], nWidth, nHeight,
+                                 MS_TRUE);
       }
     }
     if (img == NULL) {
-      msSetError(MS_IMGERR,
-                 "Unavailable RULE (%s).",
-                 "msWMSGetLegendGraphic()",
+      msSetError(MS_IMGERR, "Unavailable RULE (%s).", "msWMSGetLegendGraphic()",
                  psRule);
       return msWMSException(map, nVersion, "InvalidRule", wms_exception_format);
     }
@@ -4728,29 +5341,33 @@ this request. Check wms/ows_enable_reque
 
   msFreeImage(img);
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
 /*
 ** msWMSGetContentDependantLegend()
 */
-static
-int msWMSGetContentDependantLegend(mapObj *map, int nVersion, char **names, char **values, int numentries,
-                const char *wms_exception_format, owsRequestObj *ows_request) {
+static int msWMSGetContentDependantLegend(mapObj *map, int nVersion,
+                                          char **names, char **values,
+                                          int numentries,
+                                          const char *wms_exception_format,
+                                          owsRequestObj *ows_request) {
 
   /* turn off layer if WMS GetMap is not enabled */
-  for (int i=0; i<map->numlayers; i++)
-    if (!msIntegerInArray(GET_LAYER(map, i)->index, ows_request->enabled_layers, ows_request->numlayers))
+  for (int i = 0; i < map->numlayers; i++)
+    if (!msIntegerInArray(GET_LAYER(map, i)->index, ows_request->enabled_layers,
+                          ows_request->numlayers))
       GET_LAYER(map, i)->status = MS_OFF;
 
   map_hittest hittest;
-  initMapHitTests(map,&hittest);
-  int status = msHitTestMap(map,&hittest);
-  if(status == MS_SUCCESS) {
-    status = msWMSLegendGraphic(map,nVersion,names,values,numentries,wms_exception_format,ows_request,&hittest);
+  initMapHitTests(map, &hittest);
+  int status = msHitTestMap(map, &hittest);
+  if (status == MS_SUCCESS) {
+    status = msWMSLegendGraphic(map, nVersion, names, values, numentries,
+                                wms_exception_format, ows_request, &hittest);
   }
-  freeMapHitTests(map,&hittest);
-  if(status != MS_SUCCESS) {
+  freeMapHitTests(map, &hittest);
+  if (status != MS_SUCCESS) {
     return msWMSException(map, nVersion, NULL, wms_exception_format);
   } else {
     return MS_SUCCESS;
@@ -4761,22 +5378,26 @@ int msWMSGetContentDependantLegend(mapOb
 ** msWMSGetStyles() : return an SLD document for all layers that
 ** have a status set to on or default.
 */
-static
-int msWMSGetStyles(mapObj *map, int nVersion, char **names,
-                   char **values, int numentries, const char *wms_exception_format)
+static int msWMSGetStyles(mapObj *map, int nVersion, char **names,
+                          char **values, int numentries,
+                          const char *wms_exception_format)
 
 {
   bool validlayer = false;
 
-  char*** nestedGroups = (char***)msSmallCalloc(map->numlayers, sizeof(char**));
-  int* numNestedGroups = (int*)msSmallCalloc(map->numlayers, sizeof(int));
-  int* isUsedInNestedGroup = (int*)msSmallCalloc(map->numlayers, sizeof(int));
-  msWMSPrepareNestedGroups(map, nVersion, nestedGroups, numNestedGroups, isUsedInNestedGroup);
+  char ***nestedGroups =
+      (char ***)msSmallCalloc(map->numlayers, sizeof(char **));
+  int *numNestedGroups = (int *)msSmallCalloc(map->numlayers, sizeof(int));
+  int *isUsedInNestedGroup = (int *)msSmallCalloc(map->numlayers, sizeof(int));
+  msWMSPrepareNestedGroups(map, nVersion, nestedGroups, numNestedGroups,
+                           isUsedInNestedGroup);
 
-  const char* sldenabled = msOWSLookupMetadata(&(map->web.metadata), "MO", "sld_enabled");
-  if (sldenabled == NULL) sldenabled = "true";
+  const char *sldenabled =
+      msOWSLookupMetadata(&(map->web.metadata), "MO", "sld_enabled");
+  if (sldenabled == NULL)
+    sldenabled = "true";
 
-  for(int i=0; i<numentries; i++) {
+  for (int i = 0; i < numentries; i++) {
     /* getMap parameters */
     if (strcasecmp(names[i], "LAYERS") == 0) {
       const auto wmslayers = msStringSplit(values[i], ',');
@@ -4785,19 +5406,20 @@ int msWMSGetStyles(mapObj *map, int nVer
                    "msWMSGetStyles()");
         return msWMSException(map, nVersion, NULL, wms_exception_format);
       }
-      for(int j=0; j<map->numlayers; j++)
+      for (int j = 0; j < map->numlayers; j++)
         GET_LAYER(map, j)->status = MS_OFF;
 
-      for (int k=0; k < static_cast<int>(wmslayers.size()); k++) {
-        const auto& wmslayer = wmslayers[k];
-        for (int j=0; j<map->numlayers; j++) {
-          if ((map->name &&
-               strcasecmp(map->name, wmslayer.c_str()) == 0) ||
+      for (int k = 0; k < static_cast<int>(wmslayers.size()); k++) {
+        const auto &wmslayer = wmslayers[k];
+        for (int j = 0; j < map->numlayers; j++) {
+          if ((map->name && strcasecmp(map->name, wmslayer.c_str()) == 0) ||
               (GET_LAYER(map, j)->name &&
                strcasecmp(GET_LAYER(map, j)->name, wmslayer.c_str()) == 0) ||
               (GET_LAYER(map, j)->group &&
                strcasecmp(GET_LAYER(map, j)->group, wmslayer.c_str()) == 0) ||
-              ((numNestedGroups[j] >0) && msStringInArray(wmslayer.c_str(), nestedGroups[j], numNestedGroups[j])) ) {
+              ((numNestedGroups[j] > 0) &&
+               msStringInArray(wmslayer.c_str(), nestedGroups[j],
+                               numNestedGroups[j]))) {
             GET_LAYER(map, j)->status = MS_ON;
             validlayer = true;
           }
@@ -4805,17 +5427,13 @@ int msWMSGetStyles(mapObj *map, int nVer
       }
     }
 
-    else if (strcasecmp(names[i], "SLD") == 0 &&
-        values[i] && strlen(values[i]) > 0 &&
-        strcasecmp(sldenabled, "true") == 0)
-    {
-        msSLDApplySLDURL(map, values[i], -1, NULL, NULL);
+    else if (strcasecmp(names[i], "SLD") == 0 && values[i] &&
+             strlen(values[i]) > 0 && strcasecmp(sldenabled, "true") == 0) {
+      msSLDApplySLDURL(map, values[i], -1, NULL, NULL);
     }
 
-    else if (strcasecmp(names[i], "SLD_BODY") == 0 &&
-        values[i] && strlen(values[i]) > 0 &&
-        strcasecmp(sldenabled, "true") == 0)
-    {
+    else if (strcasecmp(names[i], "SLD_BODY") == 0 && values[i] &&
+             strlen(values[i]) > 0 && strcasecmp(sldenabled, "true") == 0) {
       msSLDApplySLD(map, values[i], -1, NULL, NULL);
     }
   }
@@ -4830,22 +5448,27 @@ int msWMSGetStyles(mapObj *map, int nVer
   free(numNestedGroups);
   free(isUsedInNestedGroup);
 
-  /* validate all layers given. If an invalid layer is sent, return an exception. */
+  /* validate all layers given. If an invalid layer is sent, return an
+   * exception. */
   if (!validlayer) {
-    msSetError(MS_WMSERR, "Invalid layer(s) given in the LAYERS parameter. A layer might be disabled for \
+    msSetError(
+        MS_WMSERR,
+        "Invalid layer(s) given in the LAYERS parameter. A layer might be disabled for \
 this request. Check wms/ows_enable_request settings.",
-               "msWMSGetStyles()");
-    return msWMSException(map, nVersion, "LayerNotDefined", wms_exception_format);
+        "msWMSGetStyles()");
+    return msWMSException(map, nVersion, "LayerNotDefined",
+                          wms_exception_format);
   }
 
-  char  *sld = NULL;
+  char *sld = NULL;
   if (nVersion <= OWS_1_1_1) {
-    msIO_setHeader("Content-Type","application/vnd.ogc.sld+xml; charset=UTF-8");
+    msIO_setHeader("Content-Type",
+                   "application/vnd.ogc.sld+xml; charset=UTF-8");
     msIO_sendHeaders();
     sld = msSLDGenerateSLD(map, -1, "1.0.0");
   } else {
     /*for wms 1.3.0 generate a 1.1 sld*/
-    msIO_setHeader("Content-Type","text/xml; charset=UTF-8");
+    msIO_setHeader("Content-Type", "text/xml; charset=UTF-8");
     msIO_sendHeaders();
     sld = msSLDGenerateSLD(map, -1, "1.1.0");
   }
@@ -4854,30 +5477,35 @@ this request. Check wms/ows_enable_reque
     free(sld);
   }
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
-int msWMSGetSchemaExtension(mapObj *map)
-{
-  char* schemalocation = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
+int msWMSGetSchemaExtension(mapObj *map) {
+  char *schemalocation = msEncodeHTMLEntities(msOWSGetSchemasLocation(map));
 
-  msIO_setHeader("Content-Type","text/xml; charset=UTF-8");
+  msIO_setHeader("Content-Type", "text/xml; charset=UTF-8");
   msIO_sendHeaders();
 
   msIO_printf("<?xml version='1.0' encoding=\"UTF-8\"?>\n");
-  msIO_printf("<schema xmlns=\"http://www.w3.org/2001/XMLSchema\" xmlns:wms=\"http://www.opengis.net/wms\" xmlns:ms=\"http://mapserver.gis.umn.edu/mapserver\" targetNamespace=\"http://mapserver.gis.umn.edu/mapserver\" elementFormDefault=\"qualified\" version=\"1.0.0\">\n");
-  msIO_printf("  <import namespace=\"http://www.opengis.net/wms\" schemaLocation=\"%s/wms/1.3.0/capabilities_1_3_0.xsd\"/>\n", schemalocation);
-  msIO_printf("  <element name=\"GetStyles\" type=\"wms:OperationType\" substitutionGroup=\"wms:_ExtendedOperation\"/>\n");
+  msIO_printf("<schema xmlns=\"http://www.w3.org/2001/XMLSchema\" "
+              "xmlns:wms=\"http://www.opengis.net/wms\" "
+              "xmlns:ms=\"http://mapserver.gis.umn.edu/mapserver\" "
+              "targetNamespace=\"http://mapserver.gis.umn.edu/mapserver\" "
+              "elementFormDefault=\"qualified\" version=\"1.0.0\">\n");
+  msIO_printf("  <import namespace=\"http://www.opengis.net/wms\" "
+              "schemaLocation=\"%s/wms/1.3.0/capabilities_1_3_0.xsd\"/>\n",
+              schemalocation);
+  msIO_printf("  <element name=\"GetStyles\" type=\"wms:OperationType\" "
+              "substitutionGroup=\"wms:_ExtendedOperation\"/>\n");
   msIO_printf("</schema>");
 
   free(schemalocation);
 
-  return(MS_SUCCESS);
+  return (MS_SUCCESS);
 }
 
 #endif /* USE_WMS_SVR */
 
-
 /*
 ** msWMSDispatch() is the entry point for WMS requests.
 ** - If this is a valid request then it is processed and MS_SUCCESS is returned
@@ -4886,19 +5514,20 @@ int msWMSGetSchemaExtension(mapObj *map)
 **   is returned and MapServer is expected to process this as a regular
 **   MapServer request.
 */
-int msWMSDispatch(mapObj *map, cgiRequestObj *req, owsRequestObj *ows_request, int force_wms_mode)
-{
+int msWMSDispatch(mapObj *map, cgiRequestObj *req, owsRequestObj *ows_request,
+                  int force_wms_mode) {
 #ifdef USE_WMS_SVR
-  int nVersion=OWS_VERSION_NOTSET;
-  const char *version=NULL, *request=NULL, *service=NULL, *format=NULL, *updatesequence=NULL, *language=NULL;
+  int nVersion = OWS_VERSION_NOTSET;
+  const char *version = NULL, *request = NULL, *service = NULL, *format = NULL,
+             *updatesequence = NULL, *language = NULL;
   const char *wms_exception_format = NULL;
 
   /*
   ** Process Params common to all requests
   */
   /* VERSION (WMTVER in 1.0.0) and REQUEST must be present in a valid request */
-  for(int i=0; i<req->NumParams; i++) {
-    if(strcasecmp(req->ParamNames[i], "VERSION") == 0)
+  for (int i = 0; i < req->NumParams; i++) {
+    if (strcasecmp(req->ParamNames[i], "VERSION") == 0)
       version = req->ParamValues[i];
     else if (strcasecmp(req->ParamNames[i], "WMTVER") == 0 && version == NULL)
       version = req->ParamValues[i];
@@ -4912,13 +5541,15 @@ int msWMSDispatch(mapObj *map, cgiReques
       service = req->ParamValues[i];
     else if (strcasecmp(req->ParamNames[i], "FORMAT") == 0)
       format = req->ParamValues[i];
-    else if (strcasecmp(req->ParamNames[i], "LANGUAGE") == 0 && msOWSLookupMetadata(&(map->web.metadata), "MO", "inspire_capabilities"))
+    else if (strcasecmp(req->ParamNames[i], "LANGUAGE") == 0 &&
+             msOWSLookupMetadata(&(map->web.metadata), "MO",
+                                 "inspire_capabilities"))
       language = req->ParamValues[i];
   }
 
   /* If SERVICE is specified then it MUST be "WMS" */
   if (service != NULL && strcasecmp(service, "WMS") != 0)
-    return MS_DONE;  /* Not a WMS request */
+    return MS_DONE; /* Not a WMS request */
 
   nVersion = msOWSParseVersionString(version);
   if (nVersion == OWS_VERSION_BADFORMAT) {
@@ -4937,8 +5568,10 @@ int msWMSDispatch(mapObj *map, cgiReques
        strcasecmp(request, "GetCapabilities") == 0) &&
       (nVersion >= OWS_1_0_7 || nVersion == OWS_VERSION_NOTSET)) {
     if (force_wms_mode) {
-      msSetError(MS_WMSERR, "Required SERVICE parameter missing.", "msWMSDispatch");
-      return msWMSException(map, nVersion, "ServiceNotDefined", wms_exception_format);
+      msSetError(MS_WMSERR, "Required SERVICE parameter missing.",
+                 "msWMSDispatch");
+      return msWMSException(map, nVersion, "ServiceNotDefined",
+                            wms_exception_format);
     } else
       return MS_DONE;
   }
@@ -4948,16 +5581,18 @@ int msWMSDispatch(mapObj *map, cgiReques
   ** vs the versions we actually support.
   */
   if (request && (strcasecmp(request, "capabilities") == 0 ||
-                  strcasecmp(request, "GetCapabilities") == 0) ) {
+                  strcasecmp(request, "GetCapabilities") == 0)) {
     const char *enable_request;
     int globally_enabled, disabled = MS_FALSE;
 
     if (nVersion == OWS_VERSION_NOTSET) {
-      version = msOWSLookupMetadata(&(map->web.metadata), "M", "getcapabilities_version");
+      version = msOWSLookupMetadata(&(map->web.metadata), "M",
+                                    "getcapabilities_version");
       if (version)
         nVersion = msOWSParseVersionString(version);
       else
-        nVersion = OWS_1_3_0;/* VERSION is optional with getCapabilities only */
+        nVersion =
+            OWS_1_3_0; /* VERSION is optional with getCapabilities only */
     }
 
     if (msOWSMakeAllLayersUnique(map) != MS_SUCCESS)
@@ -4965,27 +5600,34 @@ int msWMSDispatch(mapObj *map, cgiReques
 
     msOWSRequestLayersEnabled(map, "M", "GetCapabilities", ows_request);
 
-    enable_request = msOWSLookupMetadata(&map->web.metadata, "OM", "enable_request");
-    globally_enabled = msOWSParseRequestMetadata(enable_request, "GetCapabilities", &disabled);
+    enable_request =
+        msOWSLookupMetadata(&map->web.metadata, "OM", "enable_request");
+    globally_enabled =
+        msOWSParseRequestMetadata(enable_request, "GetCapabilities", &disabled);
 
     if (ows_request->numlayers == 0 && !globally_enabled) {
-      msSetError(MS_WMSERR, "WMS request not enabled. Check wms/ows_enable_request settings.", "msWMSGetCapabilities()");
+      msSetError(
+          MS_WMSERR,
+          "WMS request not enabled. Check wms/ows_enable_request settings.",
+          "msWMSGetCapabilities()");
       return msWMSException(map, nVersion, NULL, wms_exception_format);
     }
     msAcquireLock(TLOCK_WxS);
-    const int status=msWMSGetCapabilities(map, nVersion, req, ows_request, updatesequence, wms_exception_format, language);
+    const int status =
+        msWMSGetCapabilities(map, nVersion, req, ows_request, updatesequence,
+                             wms_exception_format, language);
     msReleaseLock(TLOCK_WxS);
     return status;
   } else if (request && (strcasecmp(request, "context") == 0 ||
-                         strcasecmp(request, "GetContext") == 0) ) {
+                         strcasecmp(request, "GetContext") == 0)) {
     /* Return a context document with all layers in this mapfile
      * This is not a standard WMS request.
      * __TODO__ The real implementation should actually return only context
      * info for selected layers in the LAYERS parameter.
      */
     const char *getcontext_enabled;
-    getcontext_enabled = msOWSLookupMetadata(&(map->web.metadata),
-                         "MO", "getcontext_enabled");
+    getcontext_enabled =
+        msOWSLookupMetadata(&(map->web.metadata), "MO", "getcontext_enabled");
 
     if (nVersion != OWS_VERSION_NOTSET) {
       /* VERSION, if specified, is Map Context version, not WMS version */
@@ -4997,7 +5639,7 @@ int msWMSDispatch(mapObj *map, cgiReques
     /* Now set version to 1.1.1 for error handling purposes */
     nVersion = OWS_1_1_1;
 
-    if (getcontext_enabled==NULL || atoi(getcontext_enabled) == 0) {
+    if (getcontext_enabled == NULL || atoi(getcontext_enabled) == 0) {
       msSetError(MS_WMSERR, "GetContext not enabled on this server.",
                  "msWMSDispatch()");
       return msWMSException(map, nVersion, NULL, wms_exception_format);
@@ -5006,17 +5648,17 @@ int msWMSDispatch(mapObj *map, cgiReques
     if (msOWSMakeAllLayersUnique(map) != MS_SUCCESS)
       return msWMSException(map, nVersion, NULL, wms_exception_format);
 
-    msIO_setHeader("Content-Type","text/xml; charset=UTF-8");
+    msIO_setHeader("Content-Type", "text/xml; charset=UTF-8");
     msIO_sendHeaders();
 
-    if ( msWriteMapContext(map, stdout) != MS_SUCCESS )
+    if (msWriteMapContext(map, stdout) != MS_SUCCESS)
       return msWMSException(map, nVersion, NULL, wms_exception_format);
     /* Request completed */
     return MS_SUCCESS;
-  } else if (request && strcasecmp(request, "GetMap") == 0 &&
-             format && strcasecmp(format,  "image/txt") == 0) {
+  } else if (request && strcasecmp(request, "GetMap") == 0 && format &&
+             strcasecmp(format, "image/txt") == 0) {
     /* Until someone adds full support for ASCII graphics this should do. ;) */
-    msIO_setHeader("Content-Type","text/plain; charset=UTF-8");
+    msIO_setHeader("Content-Type", "text/plain; charset=UTF-8");
     msIO_sendHeaders();
     msIO_printf(".\n               ,,ggddY\"\"\"Ybbgg,,\n          ,agd888b,_ "
                 "\"Y8, ___'\"\"Ybga,\n       ,gdP\"\"88888888baa,.\"\"8b    \""
@@ -5040,43 +5682,42 @@ int msWMSDispatch(mapObj *map, cgiReques
   }
 
   /* If SERVICE, VERSION and REQUEST not included than this isn't a WMS req*/
-  if (service == NULL && nVersion == OWS_VERSION_NOTSET && request==NULL)
-    return MS_DONE;  /* Not a WMS request */
+  if (service == NULL && nVersion == OWS_VERSION_NOTSET && request == NULL)
+    return MS_DONE; /* Not a WMS request */
 
   /* VERSION *and* REQUEST required by both getMap and getFeatureInfo */
   if (nVersion == OWS_VERSION_NOTSET) {
-    msSetError(MS_WMSERR,
-               "Incomplete WMS request: VERSION parameter missing",
+    msSetError(MS_WMSERR, "Incomplete WMS request: VERSION parameter missing",
                "msWMSDispatch()");
     return msWMSException(map, OWS_VERSION_NOTSET, NULL, wms_exception_format);
   }
 
   /*check if the version is one of the supported vcersions*/
-  if (nVersion != OWS_1_0_0 &&  nVersion != OWS_1_0_6 &&
-      nVersion != OWS_1_0_7 && nVersion != OWS_1_1_0 &&
-      nVersion != OWS_1_1_1 && nVersion != OWS_1_3_0) {
+  if (nVersion != OWS_1_0_0 && nVersion != OWS_1_0_6 && nVersion != OWS_1_0_7 &&
+      nVersion != OWS_1_1_0 && nVersion != OWS_1_1_1 && nVersion != OWS_1_3_0) {
     msSetError(MS_WMSERR,
-               "Invalid WMS version: VERSION %s is not supported. Supported versions are 1.0.0, 1.0.6, 1.0.7, 1.1.0, 1.1.1, 1.3.0",
+               "Invalid WMS version: VERSION %s is not supported. Supported "
+               "versions are 1.0.0, 1.0.6, 1.0.7, 1.1.0, 1.1.1, 1.3.0",
                "msWMSDispatch()", version);
     return msWMSException(map, OWS_VERSION_NOTSET, NULL, wms_exception_format);
   }
 
-  if (request==NULL) {
-    msSetError(MS_WMSERR,
-               "Incomplete WMS request: REQUEST parameter missing",
+  if (request == NULL) {
+    msSetError(MS_WMSERR, "Incomplete WMS request: REQUEST parameter missing",
                "msWMSDispatch()");
     return msWMSException(map, nVersion, NULL, wms_exception_format);
   }
 
   /* hack !? The function can return MS_DONE ... be sure it's a wms request
    * before checking the enabled layers */
-  if ( (strcasecmp(request, "GetStyles") == 0) ||
-       (strcasecmp(request, "GetLegendGraphic") == 0) ||
-       (strcasecmp(request, "GetSchemaExtension") == 0) ||
-       (strcasecmp(request, "map") == 0 || strcasecmp(request, "GetMap") == 0) ||
-       (strcasecmp(request, "feature_info") == 0 || strcasecmp(request, "GetFeatureInfo") == 0) ||
-       (strcasecmp(request, "DescribeLayer") == 0) ) {
-    const char* request_tmp;
+  if ((strcasecmp(request, "GetStyles") == 0) ||
+      (strcasecmp(request, "GetLegendGraphic") == 0) ||
+      (strcasecmp(request, "GetSchemaExtension") == 0) ||
+      (strcasecmp(request, "map") == 0 || strcasecmp(request, "GetMap") == 0) ||
+      (strcasecmp(request, "feature_info") == 0 ||
+       strcasecmp(request, "GetFeatureInfo") == 0) ||
+      (strcasecmp(request, "DescribeLayer") == 0)) {
+    const char *request_tmp;
     if (strcasecmp(request, "map") == 0)
       request_tmp = "GetMap";
     else if (strcasecmp(request, "feature_info") == 0)
@@ -5086,7 +5727,10 @@ int msWMSDispatch(mapObj *map, cgiReques
 
     msOWSRequestLayersEnabled(map, "M", request_tmp, ows_request);
     if (ows_request->numlayers == 0) {
-      msSetError(MS_WMSERR, "WMS request not enabled. Check wms/ows_enable_request settings.", "msWMSDispatch()");
+      msSetError(
+          MS_WMSERR,
+          "WMS request not enabled. Check wms/ows_enable_request settings.",
+          "msWMSDispatch()");
       return msWMSException(map, nVersion, NULL, wms_exception_format);
     }
   }
@@ -5097,79 +5741,91 @@ int msWMSDispatch(mapObj *map, cgiReques
   bool isContentDependantLegend = false;
   if (strcasecmp(request, "GetLegendGraphic") == 0) {
     /*
-     * check for a BBOX in the request, in that case we have a content-dependant legend request,
-     * and should be following the GetMap path a bit more
+     * check for a BBOX in the request, in that case we have a content-dependant
+     * legend request, and should be following the GetMap path a bit more
      */
     bool found = false;
-    for(int i=0; i<req->NumParams; i++) {
-      if(strcasecmp(req->ParamNames[i], "BBOX") == 0) {
-        if(req->ParamValues[i] && *req->ParamValues[i]) {
+    for (int i = 0; i < req->NumParams; i++) {
+      if (strcasecmp(req->ParamNames[i], "BBOX") == 0) {
+        if (req->ParamValues[i] && *req->ParamValues[i]) {
           found = true;
           break;
         }
       }
     }
-    if(found) {
+    if (found) {
       isContentDependantLegend = true;
-      /* getLegendGraphic uses LAYER= , we need to create a LAYERS= value that is identical
-       * we'll suppose that the client is conformat and hasn't included a LAYERS= parameter
-       * in its request */
-      for(int i=0; i<req->NumParams; i++) {
-        if(strcasecmp(req->ParamNames[i], "LAYER") == 0) {
+      /* getLegendGraphic uses LAYER= , we need to create a LAYERS= value that
+       * is identical we'll suppose that the client is conformat and hasn't
+       * included a LAYERS= parameter in its request */
+      for (int i = 0; i < req->NumParams; i++) {
+        if (strcasecmp(req->ParamNames[i], "LAYER") == 0) {
           req->ParamNames[req->NumParams] = msStrdup("LAYERS");
           req->ParamValues[req->NumParams] = msStrdup(req->ParamValues[i]);
           req->NumParams++;
         }
       }
     } else {
-      return msWMSLegendGraphic(map, nVersion, req->ParamNames, req->ParamValues, req->NumParams,
-                              wms_exception_format, ows_request, NULL);
+      return msWMSLegendGraphic(map, nVersion, req->ParamNames,
+                                req->ParamValues, req->NumParams,
+                                wms_exception_format, ows_request, NULL);
     }
   }
 
   if (strcasecmp(request, "GetStyles") == 0)
-    return msWMSGetStyles(map, nVersion, req->ParamNames, req->ParamValues, req->NumParams,
-                          wms_exception_format);
+    return msWMSGetStyles(map, nVersion, req->ParamNames, req->ParamValues,
+                          req->NumParams, wms_exception_format);
 
   else if (request && strcasecmp(request, "GetSchemaExtension") == 0)
     return msWMSGetSchemaExtension(map);
 
-  /* getMap parameters are used by both getMap, getFeatureInfo, and content dependant legendgraphics */
+  /* getMap parameters are used by both getMap, getFeatureInfo, and content
+   * dependant legendgraphics */
   if (strcasecmp(request, "map") == 0 || strcasecmp(request, "GetMap") == 0 ||
-      strcasecmp(request, "feature_info") == 0 || strcasecmp(request, "GetFeatureInfo") == 0 || strcasecmp(request, "DescribeLayer") == 0 || isContentDependantLegend) {
-
-    const int status = msWMSLoadGetMapParams(map, nVersion, req->ParamNames, req->ParamValues, req->NumParams,
-                                   wms_exception_format, request, ows_request);
-    if (status != MS_SUCCESS) return status;
+      strcasecmp(request, "feature_info") == 0 ||
+      strcasecmp(request, "GetFeatureInfo") == 0 ||
+      strcasecmp(request, "DescribeLayer") == 0 || isContentDependantLegend) {
+
+    const int status = msWMSLoadGetMapParams(
+        map, nVersion, req->ParamNames, req->ParamValues, req->NumParams,
+        wms_exception_format, request, ows_request);
+    if (status != MS_SUCCESS)
+      return status;
   }
 
   /* This function owns validated_language, so remember to free it later*/
-  char* validated_language = msOWSGetLanguageFromList(map, "MO", language);
+  char *validated_language = msOWSGetLanguageFromList(map, "MO", language);
   if (validated_language != NULL) {
     msMapSetLanguageSpecificConnection(map, validated_language);
   }
   msFree(validated_language);
 
   if (strcasecmp(request, "map") == 0 || strcasecmp(request, "GetMap") == 0)
-    return msWMSGetMap(map, nVersion, req->ParamNames, req->ParamValues, req->NumParams, wms_exception_format, ows_request);
-  else if (strcasecmp(request, "feature_info") == 0 || strcasecmp(request, "GetFeatureInfo") == 0)
-    return msWMSFeatureInfo(map, nVersion, req->ParamNames, req->ParamValues, req->NumParams, wms_exception_format, ows_request);
+    return msWMSGetMap(map, nVersion, req->ParamNames, req->ParamValues,
+                       req->NumParams, wms_exception_format, ows_request);
+  else if (strcasecmp(request, "feature_info") == 0 ||
+           strcasecmp(request, "GetFeatureInfo") == 0)
+    return msWMSFeatureInfo(map, nVersion, req->ParamNames, req->ParamValues,
+                            req->NumParams, wms_exception_format, ows_request);
   else if (strcasecmp(request, "DescribeLayer") == 0) {
-    return msWMSDescribeLayer(map, nVersion, req->ParamNames, req->ParamValues, req->NumParams,
-                              wms_exception_format);
+    return msWMSDescribeLayer(map, nVersion, req->ParamNames, req->ParamValues,
+                              req->NumParams, wms_exception_format);
   } else if (isContentDependantLegend) {
-    return msWMSGetContentDependantLegend(map,nVersion, req->ParamNames, req->ParamValues, req->NumParams, wms_exception_format, ows_request);
+    return msWMSGetContentDependantLegend(map, nVersion, req->ParamNames,
+                                          req->ParamValues, req->NumParams,
+                                          wms_exception_format, ows_request);
   }
 
   /* Hummmm... incomplete or unsupported WMS request */
   if (service != NULL && strcasecmp(service, "WMS") == 0) {
-    msSetError(MS_WMSERR, "Incomplete or unsupported WMS request", "msWMSDispatch()");
+    msSetError(MS_WMSERR, "Incomplete or unsupported WMS request",
+               "msWMSDispatch()");
     return msWMSException(map, nVersion, NULL, wms_exception_format);
   } else
-    return MS_DONE;  /* Not a WMS request */
+    return MS_DONE; /* Not a WMS request */
 #else
-  msSetError(MS_WMSERR, "WMS server support is not available.", "msWMSDispatch()");
-  return(MS_FAILURE);
+  msSetError(MS_WMSERR, "WMS server support is not available.",
+             "msWMSDispatch()");
+  return (MS_FAILURE);
 #endif
 }
-
diff -pruN 8.0.1-5/mapwmslayer.c 8.0.2-1/mapwmslayer.c
--- 8.0.1-5/mapwmslayer.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapwmslayer.c	2024-06-11 20:41:34.000000000 +0000
@@ -46,11 +46,10 @@
  *                          msInitWmsParamsObj()
  *
  **********************************************************************/
-int msInitWmsParamsObj(wmsParamsObj *wmsparams)
-{
+int msInitWmsParamsObj(wmsParamsObj *wmsparams) {
   wmsparams->onlineresource = NULL;
   wmsparams->params = msCreateHashTable();
-  wmsparams->numparams=0;
+  wmsparams->numparams = 0;
   wmsparams->httpcookiedata = NULL;
 
   return MS_SUCCESS;
@@ -61,8 +60,7 @@ int msInitWmsParamsObj(wmsParamsObj *wms
  *
  * Frees the contents of the object, but not the object itself.
  **********************************************************************/
-void msFreeWmsParamsObj(wmsParamsObj *wmsparams)
-{
+void msFreeWmsParamsObj(wmsParamsObj *wmsparams) {
   msFree(wmsparams->onlineresource);
   wmsparams->onlineresource = NULL;
 
@@ -71,7 +69,7 @@ void msFreeWmsParamsObj(wmsParamsObj *wm
 
   msFree(wmsparams->httpcookiedata);
 
-  wmsparams->numparams=0;
+  wmsparams->numparams = 0;
 }
 
 /**********************************************************************
@@ -80,10 +78,8 @@ void msFreeWmsParamsObj(wmsParamsObj *wm
  **********************************************************************/
 
 #ifdef USE_WMS_LYR
-static int msSetWMSParamString(wmsParamsObj *psWMSParams,
-                               const char *name, const char * value,
-                               int urlencode, int nVersion)
-{
+static int msSetWMSParamString(wmsParamsObj *psWMSParams, const char *name,
+                               const char *value, int urlencode, int nVersion) {
   if (urlencode) {
     char *pszTmp;
 
@@ -95,14 +91,13 @@ static int msSetWMSParamString(wmsParams
      *  Note: WMS 1.3 removes SRS and FORMAT from the set of
      *        exceptional cases, but renames SRS as CRS in any case.
      */
-    if( strcmp(name,"LAYERS") == 0 ||
-        strcmp(name,"STYLES") == 0 ||
-        strcmp(name,"BBOX") == 0 ) {
-      pszTmp = msEncodeUrlExcept(value,',');
-    } else if ( strcmp(name,"SRS") == 0 ) {
-      pszTmp = msEncodeUrlExcept(value,':');
-    } else if ( nVersion < OWS_1_3_0 && strcmp(name,"FORMAT") == 0 ) {
-      pszTmp = msEncodeUrlExcept(value,'/');
+    if (strcmp(name, "LAYERS") == 0 || strcmp(name, "STYLES") == 0 ||
+        strcmp(name, "BBOX") == 0) {
+      pszTmp = msEncodeUrlExcept(value, ',');
+    } else if (strcmp(name, "SRS") == 0) {
+      pszTmp = msEncodeUrlExcept(value, ':');
+    } else if (nVersion < OWS_1_3_0 && strcmp(name, "FORMAT") == 0) {
+      pszTmp = msEncodeUrlExcept(value, '/');
     } else {
       pszTmp = msEncodeUrl(value);
     }
@@ -124,9 +119,8 @@ static int msSetWMSParamString(wmsParams
  **********************************************************************/
 
 #ifdef USE_WMS_LYR
-static int msSetWMSParamInt(wmsParamsObj *wmsparams,
-                            const char *name, int value)
-{
+static int msSetWMSParamInt(wmsParamsObj *wmsparams, const char *name,
+                            int value) {
   char szBuf[100];
 
   snprintf(szBuf, sizeof(szBuf), "%d", value);
@@ -141,8 +135,7 @@ static int msSetWMSParamInt(wmsParamsObj
  *                          msBuildWMSParamsUrl()
  *
  **********************************************************************/
-static char *msBuildURLFromWMSParams(wmsParamsObj *wmsparams)
-{
+static char *msBuildURLFromWMSParams(wmsParamsObj *wmsparams) {
   const char *key, *value;
   size_t bufferSize = 0;
   int nLen;
@@ -160,8 +153,8 @@ static char *msBuildURLFromWMSParams(wms
     key = msNextKeyFromHashTable(wmsparams->params, key);
   }
 
-  bufferSize = nLen+1;
-  pszURL = (char*)msSmallMalloc(bufferSize);
+  bufferSize = nLen + 1;
+  pszURL = (char *)msSmallMalloc(bufferSize);
 
   /* Start with the onlineresource value and append trailing '?' or '&'
    * if missing.
@@ -171,9 +164,9 @@ static char *msBuildURLFromWMSParams(wms
     strcat(pszURL, "?");
   else {
     char *c;
-    c = pszURL+strlen(pszURL)-1;
+    c = pszURL + strlen(pszURL) - 1;
     if (*c != '?' && *c != '&')
-      strcpy(c+1, "&");
+      strcpy(c + 1, "&");
   }
 
   /* Now add all the parameters
@@ -182,21 +175,17 @@ static char *msBuildURLFromWMSParams(wms
   key = msFirstKeyFromHashTable(wmsparams->params);
   while (key != NULL) {
     value = msLookupHashTable(wmsparams->params, key);
-    snprintf(pszURL+nLen, bufferSize-nLen, "%s=%s&", key, value);
+    snprintf(pszURL + nLen, bufferSize - nLen, "%s=%s&", key, value);
     nLen += strlen(key) + strlen(value) + 2;
     key = msNextKeyFromHashTable(wmsparams->params, key);
   }
 
   /* Get rid of trailing '&'*/
-  pszURL[nLen-1] = '\0';
-
+  pszURL[nLen - 1] = '\0';
 
   return pszURL;
 }
 
-
-
-
 #ifdef USE_WMS_LYR
 /**********************************************************************
  *                          msBuildWMSLayerURLBase()
@@ -214,35 +203,35 @@ static char *msBuildURLFromWMSParams(wms
  * by the caller.
  **********************************************************************/
 static int msBuildWMSLayerURLBase(mapObj *map, layerObj *lp,
-                                  wmsParamsObj *psWMSParams, int nRequestType)
-{
+                                  wmsParamsObj *psWMSParams, int nRequestType) {
   const char *pszOnlineResource, *pszVersion, *pszName, *pszFormat;
   const char *pszFormatList, *pszStyle, /* *pszStyleList,*/ *pszTime;
   const char *pszBgColor, *pszTransparent;
-  const char *pszSLD=NULL, *pszStyleSLDBody=NULL, *pszVersionKeyword=NULL;
-  const char *pszSLDBody=NULL, *pszSLDURL = NULL;
+  const char *pszSLD = NULL, *pszStyleSLDBody = NULL, *pszVersionKeyword = NULL;
+  const char *pszSLDBody = NULL, *pszSLDURL = NULL;
   char *pszSLDGenerated = NULL;
-  int nVersion=OWS_VERSION_NOTSET;
+  int nVersion = OWS_VERSION_NOTSET;
 
   /* If lp->connection is not set then use wms_onlineresource metadata */
   pszOnlineResource = lp->connection;
   if (pszOnlineResource == NULL)
-    pszOnlineResource = msOWSLookupMetadata(&(lp->metadata),
-                                            "MO", "onlineresource");
+    pszOnlineResource =
+        msOWSLookupMetadata(&(lp->metadata), "MO", "onlineresource");
 
-  pszVersion =        msOWSLookupMetadata(&(lp->metadata), "MO", "server_version");
-  pszName =           msOWSLookupMetadata(&(lp->metadata), "MO", "name");
-  pszFormat =         msOWSLookupMetadata(&(lp->metadata), "MO", "format");
-  pszFormatList =     msOWSLookupMetadata(&(lp->metadata), "MO", "formatlist");
-  pszStyle =          msOWSLookupMetadata(&(lp->metadata), "MO", "style");
-  /*pszStyleList =      msOWSLookupMetadata(&(lp->metadata), "MO", "stylelist");*/
-  pszTime =           msOWSLookupMetadata(&(lp->metadata), "MO", "time");
-  pszSLDBody =        msOWSLookupMetadata(&(lp->metadata), "MO", "sld_body");
-  pszSLDURL =         msOWSLookupMetadata(&(lp->metadata), "MO", "sld_url");
-  pszBgColor =        msOWSLookupMetadata(&(lp->metadata), "MO", "bgcolor");
-  pszTransparent =    msOWSLookupMetadata(&(lp->metadata), "MO", "transparent");
+  pszVersion = msOWSLookupMetadata(&(lp->metadata), "MO", "server_version");
+  pszName = msOWSLookupMetadata(&(lp->metadata), "MO", "name");
+  pszFormat = msOWSLookupMetadata(&(lp->metadata), "MO", "format");
+  pszFormatList = msOWSLookupMetadata(&(lp->metadata), "MO", "formatlist");
+  pszStyle = msOWSLookupMetadata(&(lp->metadata), "MO", "style");
+  /*pszStyleList =      msOWSLookupMetadata(&(lp->metadata), "MO",
+   * "stylelist");*/
+  pszTime = msOWSLookupMetadata(&(lp->metadata), "MO", "time");
+  pszSLDBody = msOWSLookupMetadata(&(lp->metadata), "MO", "sld_body");
+  pszSLDURL = msOWSLookupMetadata(&(lp->metadata), "MO", "sld_url");
+  pszBgColor = msOWSLookupMetadata(&(lp->metadata), "MO", "bgcolor");
+  pszTransparent = msOWSLookupMetadata(&(lp->metadata), "MO", "transparent");
 
-  if (pszOnlineResource==NULL || pszVersion==NULL || pszName==NULL) {
+  if (pszOnlineResource == NULL || pszVersion == NULL || pszName == NULL) {
     msSetError(MS_WMSCONNERR,
                "One of wms_onlineresource, wms_server_version, wms_name "
                "metadata is missing in layer %s.  "
@@ -261,13 +250,15 @@ static int msBuildWMSLayerURLBase(mapObj
 
   nVersion = msOWSParseVersionString(pszVersion);
   /* WMS 1.0.8 is really just 1.1.0 */
-  if (nVersion == OWS_1_0_8) nVersion = OWS_1_1_0;
+  if (nVersion == OWS_1_0_8)
+    nVersion = OWS_1_1_0;
 
-  msSetWMSParamString(psWMSParams, pszVersionKeyword, pszVersion, MS_FALSE, nVersion);
-  msSetWMSParamString(psWMSParams, "SERVICE", "WMS",     MS_FALSE, nVersion);
-  msSetWMSParamString(psWMSParams, "LAYERS",  pszName,   MS_TRUE, nVersion);
+  msSetWMSParamString(psWMSParams, pszVersionKeyword, pszVersion, MS_FALSE,
+                      nVersion);
+  msSetWMSParamString(psWMSParams, "SERVICE", "WMS", MS_FALSE, nVersion);
+  msSetWMSParamString(psWMSParams, "LAYERS", pszName, MS_TRUE, nVersion);
 
-  if (pszFormat==NULL && pszFormatList==NULL) {
+  if (pszFormat == NULL && pszFormatList == NULL) {
     msSetError(MS_WMSCONNERR,
                "At least wms_format or wms_formatlist is required for "
                "layer %s.  "
@@ -278,30 +269,30 @@ static int msBuildWMSLayerURLBase(mapObj
   }
 
   if (pszFormat != NULL) {
-    msSetWMSParamString(psWMSParams, "FORMAT",  pszFormat, MS_TRUE, nVersion);
+    msSetWMSParamString(psWMSParams, "FORMAT", pszFormat, MS_TRUE, nVersion);
   } else {
     /* Look for the first format in list that matches */
     char **papszTok;
     int i, n;
     papszTok = msStringSplit(pszFormatList, ',', &n);
 
-    for(i=0; pszFormat==NULL && i<n; i++) {
+    for (i = 0; pszFormat == NULL && i < n; i++) {
       if (0
 #if defined USE_PNG
-          || strcasecmp(papszTok[i], "PNG")
-          || strcasecmp(papszTok[i], "image/png")
+          || strcasecmp(papszTok[i], "PNG") ||
+          strcasecmp(papszTok[i], "image/png")
 #endif
 #if defined USE_JPEG
-          || strcasecmp(papszTok[i], "JPEG")
-          || strcasecmp(papszTok[i], "image/jpeg")
+          || strcasecmp(papszTok[i], "JPEG") ||
+          strcasecmp(papszTok[i], "image/jpeg")
 #endif
-         ) {
+      ) {
         pszFormat = papszTok[i];
       }
     }
 
     if (pszFormat) {
-      msSetWMSParamString(psWMSParams, "FORMAT",  pszFormat, MS_TRUE, nVersion);
+      msSetWMSParamString(psWMSParams, "FORMAT", pszFormat, MS_TRUE, nVersion);
       msFreeCharArray(papszTok, n);
     } else {
       msSetError(MS_WMSCONNERR,
@@ -315,7 +306,7 @@ static int msBuildWMSLayerURLBase(mapObj
     }
   }
 
-  if (pszStyle==NULL) {
+  if (pszStyle == NULL) {
     /* When no style is selected, use "" which is a valid default. */
     pszStyle = "";
   } else {
@@ -346,17 +337,19 @@ static int msBuildWMSLayerURLBase(mapObj
 
   if (pszSLD != NULL) {
     /* Only SLD is set */
-    msSetWMSParamString(psWMSParams, "SLD",    pszSLD,   MS_TRUE, nVersion);
+    msSetWMSParamString(psWMSParams, "SLD", pszSLD, MS_TRUE, nVersion);
   } else if (pszStyleSLDBody != NULL) {
     /* SLDBODY are set */
-    msSetWMSParamString(psWMSParams, "SLD_BODY", pszStyleSLDBody, MS_TRUE, nVersion);
+    msSetWMSParamString(psWMSParams, "SLD_BODY", pszStyleSLDBody, MS_TRUE,
+                        nVersion);
   }
 
   if (msIsLayerQueryable(lp)) {
-    msSetWMSParamString(psWMSParams, "QUERY_LAYERS", pszName, MS_TRUE, nVersion);
+    msSetWMSParamString(psWMSParams, "QUERY_LAYERS", pszName, MS_TRUE,
+                        nVersion);
   }
   if (pszTime && strlen(pszTime) > 0) {
-    msSetWMSParamString(psWMSParams, "TIME",   pszTime,  MS_TRUE, nVersion);
+    msSetWMSParamString(psWMSParams, "TIME", pszTime, MS_TRUE, nVersion);
   }
 
   /* if  the metadata wms_sld_body is set to AUTO, we generate
@@ -372,14 +365,14 @@ static int msBuildWMSLayerURLBase(mapObj
         pszSLDGenerated = msSLDGenerateSLD(map, lp->index, NULL);
 
       if (pszSLDGenerated) {
-        msSetWMSParamString(psWMSParams, "SLD_BODY",
-                            pszSLDGenerated, MS_TRUE, nVersion);
+        msSetWMSParamString(psWMSParams, "SLD_BODY", pszSLDGenerated, MS_TRUE,
+                            nVersion);
         free(pszSLDGenerated);
       }
     } else {
-      msSetWMSParamString(psWMSParams, "SLD_BODY", pszSLDBody, MS_TRUE, nVersion);
+      msSetWMSParamString(psWMSParams, "SLD_BODY", pszSLDBody, MS_TRUE,
+                          nVersion);
     }
-
   }
 
   if (pszSLDURL) {
@@ -391,7 +384,8 @@ static int msBuildWMSLayerURLBase(mapObj
   }
 
   if (pszTransparent) {
-    msSetWMSParamString(psWMSParams, "TRANSPARENT", pszTransparent, MS_TRUE, nVersion);
+    msSetWMSParamString(psWMSParams, "TRANSPARENT", pszTransparent, MS_TRUE,
+                        nVersion);
   } else {
     msSetWMSParamString(psWMSParams, "TRANSPARENT", "TRUE", MS_TRUE, nVersion);
   }
@@ -401,7 +395,6 @@ static int msBuildWMSLayerURLBase(mapObj
 
 #endif /* USE_WMS_LYR */
 
-
 /**********************************************************************
  *                          msBuildWMSLayerURL()
  *
@@ -411,21 +404,19 @@ static int msBuildWMSLayerURLBase(mapObj
  * by the caller.
  **********************************************************************/
 
-static int
-msBuildWMSLayerURL(mapObj *map, layerObj *lp, int nRequestType,
-                   int nClickX, int nClickY, int nFeatureCount,
-                   const char *pszInfoFormat, rectObj *bbox_ret,
-                   int *width_ret, int *height_ret,
-                   wmsParamsObj *psWMSParams)
-{
+static int msBuildWMSLayerURL(mapObj *map, layerObj *lp, int nRequestType,
+                              int nClickX, int nClickY, int nFeatureCount,
+                              const char *pszInfoFormat, rectObj *bbox_ret,
+                              int *width_ret, int *height_ret,
+                              wmsParamsObj *psWMSParams) {
 #ifdef USE_WMS_LYR
   char *pszEPSG = NULL;
   const char *pszVersion, *pszRequestParam,
-        *pszSrsParamName="SRS", *pszLayer=NULL, *pszQueryLayers=NULL,
-        *pszUseStrictAxisOrder;
+      *pszSrsParamName = "SRS", *pszLayer = NULL, *pszQueryLayers = NULL,
+      *pszUseStrictAxisOrder;
   rectObj bbox;
   int bbox_width = map->width, bbox_height = map->height;
-  int nVersion=OWS_VERSION_NOTSET;
+  int nVersion = OWS_VERSION_NOTSET;
   int bUseStrictAxisOrder = MS_FALSE; /* this is the assumption up to 1.1.0 */
   int bFlipAxisOrder = MS_FALSE;
   const char *pszTmp;
@@ -444,14 +435,15 @@ msBuildWMSLayerURL(mapObj *map, layerObj
       ((pszVersion = strstr(lp->connection, "VERSION=")) == NULL &&
        (pszVersion = strstr(lp->connection, "version=")) == NULL &&
        (pszVersion = strstr(lp->connection, "WMTVER=")) == NULL &&
-       (pszVersion = strstr(lp->connection, "wmtver=")) == NULL ) ) {
+       (pszVersion = strstr(lp->connection, "wmtver=")) == NULL)) {
     /* CONNECTION missing or seems incomplete... try to build from metadata */
-    if (msBuildWMSLayerURLBase(map, lp, psWMSParams, nRequestType) != MS_SUCCESS)
-      return MS_FAILURE;  /* An error already produced. */
+    if (msBuildWMSLayerURLBase(map, lp, psWMSParams, nRequestType) !=
+        MS_SUCCESS)
+      return MS_FAILURE; /* An error already produced. */
 
     /* If we received MS_SUCCESS then version must have been set */
     pszVersion = msLookupHashTable(psWMSParams->params, "VERSION");
-    if (pszVersion ==NULL)
+    if (pszVersion == NULL)
       pszVersion = msLookupHashTable(psWMSParams->params, "WMTVER");
 
     nVersion = msOWSParseVersionString(pszVersion);
@@ -461,7 +453,7 @@ msBuildWMSLayerURL(mapObj *map, layerObj
     psWMSParams->onlineresource = msStrdup(lp->connection);
 
     /* Fetch version info */
-    pszVersion = strchr(pszVersion, '=')+1;
+    pszVersion = strchr(pszVersion, '=') + 1;
     pszDelimiter = strchr(pszVersion, '&');
     if (pszDelimiter != NULL)
       *pszDelimiter = '\0';
@@ -471,38 +463,45 @@ msBuildWMSLayerURL(mapObj *map, layerObj
   }
 
   switch (nVersion) {
-    case OWS_1_0_8:
-      nVersion = OWS_1_1_0;    /* 1.0.8 == 1.1.0 */
-      break;
-    case OWS_1_0_0:
-    case OWS_1_0_1:
-    case OWS_1_0_7:
-    case OWS_1_1_0:
-    case OWS_1_1_1:
-      /* All is good, this is a supported version. */
-      break;
-    case OWS_1_3_0:
-      /* 1.3.0 introduces a few changes... */
-      pszSrsParamName = "CRS";
-      bUseStrictAxisOrder = MS_TRUE; /* this is the assumption for 1.3.0 */
-      break;
-    default:
-      /* Not a supported version */
-      msSetError(MS_WMSCONNERR, "MapServer supports only WMS 1.0.0 to 1.3.0 (please verify the VERSION parameter in the connection string).", "msBuildWMSLayerURL()");
-      return MS_FAILURE;
+  case OWS_1_0_8:
+    nVersion = OWS_1_1_0; /* 1.0.8 == 1.1.0 */
+    break;
+  case OWS_1_0_0:
+  case OWS_1_0_1:
+  case OWS_1_0_7:
+  case OWS_1_1_0:
+  case OWS_1_1_1:
+    /* All is good, this is a supported version. */
+    break;
+  case OWS_1_3_0:
+    /* 1.3.0 introduces a few changes... */
+    pszSrsParamName = "CRS";
+    bUseStrictAxisOrder = MS_TRUE; /* this is the assumption for 1.3.0 */
+    break;
+  default:
+    /* Not a supported version */
+    msSetError(MS_WMSCONNERR,
+               "MapServer supports only WMS 1.0.0 to 1.3.0 (please verify the "
+               "VERSION parameter in the connection string).",
+               "msBuildWMSLayerURL()");
+    return MS_FAILURE;
   }
 
   /* ------------------------------------------------------------------
    * For GetFeatureInfo requests, make sure QUERY_LAYERS is included
    * ------------------------------------------------------------------ */
-  if  (nRequestType == WMS_GETFEATUREINFO &&
-       strstr(psWMSParams->onlineresource, "QUERY_LAYERS=") == NULL &&
-       strstr(psWMSParams->onlineresource, "query_layers=") == NULL &&
-       msLookupHashTable(psWMSParams->params, "QUERY_LAYERS") == NULL) {
+  if (nRequestType == WMS_GETFEATUREINFO &&
+      strstr(psWMSParams->onlineresource, "QUERY_LAYERS=") == NULL &&
+      strstr(psWMSParams->onlineresource, "query_layers=") == NULL &&
+      msLookupHashTable(psWMSParams->params, "QUERY_LAYERS") == NULL) {
     pszQueryLayers = msOWSLookupMetadata(&(lp->metadata), "MO", "name");
 
     if (pszQueryLayers == NULL) {
-      msSetError(MS_WMSCONNERR, "wms_name not set or WMS Connection String must contain the QUERY_LAYERS parameter to support GetFeatureInfo requests (with name in uppercase).", "msBuildWMSLayerURL()");
+      msSetError(MS_WMSCONNERR,
+                 "wms_name not set or WMS Connection String must contain the "
+                 "QUERY_LAYERS parameter to support GetFeatureInfo requests "
+                 "(with name in uppercase).",
+                 "msBuildWMSLayerURL()");
       return MS_FAILURE;
     }
   }
@@ -510,14 +509,18 @@ msBuildWMSLayerURL(mapObj *map, layerObj
   /* ------------------------------------------------------------------
    * For GetLegendGraphic requests, make sure LAYER is included
    * ------------------------------------------------------------------ */
-  if  (nRequestType == WMS_GETLEGENDGRAPHIC &&
-       strstr(psWMSParams->onlineresource, "LAYER=") == NULL &&
-       strstr(psWMSParams->onlineresource, "layer=") == NULL &&
-       msLookupHashTable(psWMSParams->params, "LAYER") == NULL) {
+  if (nRequestType == WMS_GETLEGENDGRAPHIC &&
+      strstr(psWMSParams->onlineresource, "LAYER=") == NULL &&
+      strstr(psWMSParams->onlineresource, "layer=") == NULL &&
+      msLookupHashTable(psWMSParams->params, "LAYER") == NULL) {
     pszLayer = msOWSLookupMetadata(&(lp->metadata), "MO", "name");
 
     if (pszLayer == NULL) {
-      msSetError(MS_WMSCONNERR, "wms_name not set or WMS Connection String must contain the LAYER parameter to support GetLegendGraphic requests (with name in uppercase).", "msBuildWMSLayerURL()");
+      msSetError(MS_WMSCONNERR,
+                 "wms_name not set or WMS Connection String must contain the "
+                 "LAYER parameter to support GetLegendGraphic requests (with "
+                 "name in uppercase).",
+                 "msBuildWMSLayerURL()");
       return MS_FAILURE;
     }
   }
@@ -529,10 +532,9 @@ msBuildWMSLayerURL(mapObj *map, layerObj
    * - If map SRS is valid for this layer then use it
    * - Otherwise request layer in its default SRS and we'll reproject later
    * ------------------------------------------------------------------ */
-  msOWSGetEPSGProj(&(map->projection),NULL, NULL, MS_TRUE, &pszEPSG);
-  if ( pszEPSG &&
-      (strncasecmp(pszEPSG, "EPSG:", 5) == 0 ||
-       strncasecmp(pszEPSG, "AUTO:", 5) == 0) ) {
+  msOWSGetEPSGProj(&(map->projection), NULL, NULL, MS_TRUE, &pszEPSG);
+  if (pszEPSG && (strncasecmp(pszEPSG, "EPSG:", 5) == 0 ||
+                  strncasecmp(pszEPSG, "AUTO:", 5) == 0)) {
     const char *pszFound;
     char *pszLyrEPSG;
     int nLen;
@@ -547,61 +549,67 @@ msBuildWMSLayerURL(mapObj *map, layerObj
 
     nLen = strlen(pszEPSG);
 
-    msOWSGetEPSGProj(&(lp->projection), &(lp->metadata), "MO", MS_FALSE, &pszLyrEPSG);
+    msOWSGetEPSGProj(&(lp->projection), &(lp->metadata), "MO", MS_FALSE,
+                     &pszLyrEPSG);
 
     if (pszLyrEPSG == NULL ||
         (pszFound = strstr(pszLyrEPSG, pszEPSG)) == NULL ||
-        ! ((*(pszFound+nLen) == '\0') || isspace(*(pszFound+nLen))) ) {
+        !((*(pszFound + nLen) == '\0') || isspace(*(pszFound + nLen)))) {
       /* Not found in Layer's list of SRS (including projection object) */
       free(pszEPSG);
       pszEPSG = NULL;
     }
     msFree(pszLyrEPSG);
     if (pszEPSG && pszPtr)
-      *pszPtr = ',';  /* Restore full AUTO:... definition */
+      *pszPtr = ','; /* Restore full AUTO:... definition */
   }
 
   if (pszEPSG == NULL) {
-      msOWSGetEPSGProj(&(lp->projection), &(lp->metadata),"MO", MS_TRUE, &pszEPSG);
-      if( pszEPSG == NULL || (strncasecmp(pszEPSG, "EPSG:", 5) != 0 && strncasecmp(pszEPSG, "AUTO:", 5) != 0) )  {
-        msSetError(MS_WMSCONNERR, "Layer must have an EPSG or AUTO projection code (in its PROJECTION object or wms_srs metadata)", "msBuildWMSLayerURL()");
-        msFree(pszEPSG);
-        return MS_FAILURE;
-      }
+    msOWSGetEPSGProj(&(lp->projection), &(lp->metadata), "MO", MS_TRUE,
+                     &pszEPSG);
+    if (pszEPSG == NULL || (strncasecmp(pszEPSG, "EPSG:", 5) != 0 &&
+                            strncasecmp(pszEPSG, "AUTO:", 5) != 0)) {
+      msSetError(MS_WMSCONNERR,
+                 "Layer must have an EPSG or AUTO projection code (in its "
+                 "PROJECTION object or wms_srs metadata)",
+                 "msBuildWMSLayerURL()");
+      msFree(pszEPSG);
+      return MS_FAILURE;
+    }
   }
 
   /* ------------------------------------------------------------------
    * For an AUTO projection, set the Units,lon0,lat0 if not already set
    * ------------------------------------------------------------------ */
-  if (strncasecmp(pszEPSG, "AUTO:", 5) == 0 &&
-      strchr(pszEPSG, ',') == NULL) {
+  if (strncasecmp(pszEPSG, "AUTO:", 5) == 0 && strchr(pszEPSG, ',') == NULL) {
     pointObj oPoint;
     char *pszNewEPSG;
 
     /* Use center of map view for lon0,lat0 */
-    oPoint.x = (map->extent.minx + map->extent.maxx)/2.0;
-    oPoint.y = (map->extent.miny + map->extent.maxy)/2.0;
+    oPoint.x = (map->extent.minx + map->extent.maxx) / 2.0;
+    oPoint.y = (map->extent.miny + map->extent.maxy) / 2.0;
     msProjectPoint(&(map->projection), &(map->latlon), &oPoint);
 
-    pszNewEPSG = (char*)msSmallMalloc(101*sizeof(char));
+    pszNewEPSG = (char *)msSmallMalloc(101 * sizeof(char));
 
-    snprintf(pszNewEPSG, 100, "%s,9001,%.16g,%.16g",
-             pszEPSG, oPoint.x, oPoint.y);
-    pszNewEPSG[100]='\0';
+    snprintf(pszNewEPSG, 100, "%s,9001,%.16g,%.16g", pszEPSG, oPoint.x,
+             oPoint.y);
+    pszNewEPSG[100] = '\0';
     free(pszEPSG);
-    pszEPSG=pszNewEPSG;
+    pszEPSG = pszNewEPSG;
   }
 
   /*
    * Work out whether we'll be wanting to flip the axis order for the request
    */
-  pszUseStrictAxisOrder = msOWSLookupMetadata(&(lp->metadata), "MO", "strict_axis_order");
+  pszUseStrictAxisOrder =
+      msOWSLookupMetadata(&(lp->metadata), "MO", "strict_axis_order");
   if (pszUseStrictAxisOrder != NULL) {
     if (strncasecmp(pszUseStrictAxisOrder, "1", 1) == 0 ||
         strncasecmp(pszUseStrictAxisOrder, "true", 4) == 0) {
       bUseStrictAxisOrder = MS_TRUE;
     } else if (strncasecmp(pszUseStrictAxisOrder, "0", 1) == 0 ||
-        strncasecmp(pszUseStrictAxisOrder, "false", 5) == 0) {
+               strncasecmp(pszUseStrictAxisOrder, "false", 5) == 0) {
       bUseStrictAxisOrder = MS_FALSE;
     }
   }
@@ -616,24 +624,28 @@ msBuildWMSLayerURL(mapObj *map, layerObj
    * ------------------------------------------------------------------ */
   /* No need to set lp->proj if it's already set to the right EPSG code */
   {
-    char* pszEPSGCodeFromLayer = NULL;
-    msOWSGetEPSGProj(&(lp->projection), NULL, "MO", MS_TRUE, &pszEPSGCodeFromLayer);
-    if (pszEPSGCodeFromLayer == NULL || strcasecmp(pszEPSG, pszEPSGCodeFromLayer) != 0) {
+    char *pszEPSGCodeFromLayer = NULL;
+    msOWSGetEPSGProj(&(lp->projection), NULL, "MO", MS_TRUE,
+                     &pszEPSGCodeFromLayer);
+    if (pszEPSGCodeFromLayer == NULL ||
+        strcasecmp(pszEPSG, pszEPSGCodeFromLayer) != 0) {
       char *ows_srs = NULL;
       msOWSGetEPSGProj(NULL, &(lp->metadata), "MO", MS_FALSE, &ows_srs);
       /* no need to set lp->proj if it is already set and there is only
       one item in the _srs metadata for this layer - we will assume
       the projection block matches the _srs metadata (the search for ' '
       in ows_srs is a test to see if there are multiple EPSG: codes) */
-      if( lp->projection.numargs == 0 || ows_srs == NULL || (strchr(ows_srs,' ') != NULL) ) {
-        // Reproject layer extent if lp-projection is set since we might change layer projection
+      if (lp->projection.numargs == 0 || ows_srs == NULL ||
+          (strchr(ows_srs, ' ') != NULL)) {
+        // Reproject layer extent if lp-projection is set since we might change
+        // layer projection
         if (msProjectionsDiffer(&(map->projection), &(lp->projection))) {
-          msProjectRect(&(lp->projection),&(map->projection), &(lp->extent));
+          msProjectRect(&(lp->projection), &(map->projection), &(lp->extent));
         }
 
         if (strncasecmp(pszEPSG, "EPSG:", 5) == 0) {
           char szProj[20];
-          snprintf(szProj, sizeof(szProj), "init=epsg:%s", pszEPSG+5);
+          snprintf(szProj, sizeof(szProj), "init=epsg:%s", pszEPSG + 5);
           if (msLoadProjectionString(&(lp->projection), szProj) != 0) {
             msFree(pszEPSGCodeFromLayer);
             msFree(ows_srs);
@@ -677,38 +689,35 @@ msBuildWMSLayerURL(mapObj *map, layerObj
     /* -------------------------------------------------------------------- */
     {
       const char *nonsquare_ok =
-        msOWSLookupMetadata(&(lp->metadata),
-                            "MO", "nonsquare_ok");
+          msOWSLookupMetadata(&(lp->metadata), "MO", "nonsquare_ok");
 
       /* assume nonsquare_ok is false */
-      if( nonsquare_ok != NULL
-          && (strcasecmp(nonsquare_ok,"no") == 0
-              || strcasecmp(nonsquare_ok,"false") == 0) ) {
-        double cellsize_x = (bbox.maxx-bbox.minx) / bbox_width;
-        double cellsize_y = (bbox.maxy-bbox.miny) / bbox_height;
-
-        if( cellsize_x < cellsize_y * 0.999999 ) {
-          int new_bbox_height =
-            ceil((cellsize_y/cellsize_x) * bbox_height);
+      if (nonsquare_ok != NULL && (strcasecmp(nonsquare_ok, "no") == 0 ||
+                                   strcasecmp(nonsquare_ok, "false") == 0)) {
+        double cellsize_x = (bbox.maxx - bbox.minx) / bbox_width;
+        double cellsize_y = (bbox.maxy - bbox.miny) / bbox_height;
+
+        if (cellsize_x < cellsize_y * 0.999999) {
+          int new_bbox_height = ceil((cellsize_y / cellsize_x) * bbox_height);
 
           if (lp->debug)
-            msDebug("NONSQUARE_OK=%s, adjusted HEIGHT from %d to %d to equalize cellsize at %g.\n",
-                    nonsquare_ok,
-                    bbox_height, new_bbox_height, cellsize_x );
+            msDebug("NONSQUARE_OK=%s, adjusted HEIGHT from %d to %d to "
+                    "equalize cellsize at %g.\n",
+                    nonsquare_ok, bbox_height, new_bbox_height, cellsize_x);
           bbox_height = new_bbox_height;
-        } else if( cellsize_y < cellsize_x * 0.999999 ) {
-          int new_bbox_width =
-            ceil((cellsize_x/cellsize_y) * bbox_width);
+        } else if (cellsize_y < cellsize_x * 0.999999) {
+          int new_bbox_width = ceil((cellsize_x / cellsize_y) * bbox_width);
 
           if (lp->debug)
-            msDebug("NONSQUARE_OK=%s, adjusted WIDTH from %d to %d to equalize cellsize at %g.\n",
-                    nonsquare_ok,
-                    bbox_width, new_bbox_width, cellsize_y );
+            msDebug("NONSQUARE_OK=%s, adjusted WIDTH from %d to %d to equalize "
+                    "cellsize at %g.\n",
+                    nonsquare_ok, bbox_width, new_bbox_width, cellsize_y);
           bbox_width = new_bbox_width;
         } else {
           if (lp->debug)
-            msDebug("NONSQUARE_OK=%s, but cellsize was already square - no change.\n",
-                    nonsquare_ok );
+            msDebug("NONSQUARE_OK=%s, but cellsize was already square - no "
+                    "change.\n",
+                    nonsquare_ok);
         }
       }
     }
@@ -719,37 +728,39 @@ msBuildWMSLayerURL(mapObj *map, layerObj
   /*      projection that matches the request projection, then            */
   /*      consider restricting the BBOX to match the limits.              */
   /* -------------------------------------------------------------------- */
-  if( bbox_width != 0 ) {
+  if (bbox_width != 0) {
     char *ows_srs;
-    rectObj  layer_rect;
+    rectObj layer_rect;
 
-    msOWSGetEPSGProj(&(lp->projection), &(lp->metadata), "MO", MS_FALSE, &ows_srs);
+    msOWSGetEPSGProj(&(lp->projection), &(lp->metadata), "MO", MS_FALSE,
+                     &ows_srs);
 
-    if( ows_srs && strchr(ows_srs,' ') == NULL
-        && msOWSGetLayerExtent( map, lp, "MO", &layer_rect) == MS_SUCCESS ) {
+    if (ows_srs && strchr(ows_srs, ' ') == NULL &&
+        msOWSGetLayerExtent(map, lp, "MO", &layer_rect) == MS_SUCCESS) {
       /* fulloverlap */
-      if( msRectContained( &bbox, &layer_rect ) ) {
+      if (msRectContained(&bbox, &layer_rect)) {
         /* no changes */
       }
 
       /* no overlap */
-      else if( !msRectOverlap( &layer_rect, &bbox ) ) {
+      else if (!msRectOverlap(&layer_rect, &bbox)) {
         bbox_width = 0;
         bbox_height = 0;
       }
 
       else {
-        double cellsize_x = (bbox.maxx-bbox.minx) / bbox_width;
-        double cellsize_y = (bbox.maxy-bbox.miny) / bbox_height;
-        double cellsize = MS_MIN(cellsize_x,cellsize_y);
+        double cellsize_x = (bbox.maxx - bbox.minx) / bbox_width;
+        double cellsize_y = (bbox.maxy - bbox.miny) / bbox_height;
+        double cellsize = MS_MIN(cellsize_x, cellsize_y);
 
-        msRectIntersect( &bbox, &layer_rect );
+        msRectIntersect(&bbox, &layer_rect);
 
         bbox_width = round((bbox.maxx - bbox.minx) / cellsize);
         bbox_height = round((bbox.maxy - bbox.miny) / cellsize);
 
-        /* Force going through the resampler if we're going to receive a clipped BBOX (#4931) */
-        if(msLayerGetProcessingKey(lp, "RESAMPLE") == NULL) {
+        /* Force going through the resampler if we're going to receive a clipped
+         * BBOX (#4931) */
+        if (msLayerGetProcessingKey(lp, "RESAMPLE") == NULL) {
           msLayerSetProcessingKey(lp, "RESAMPLE", "nearest");
         }
       }
@@ -763,10 +774,10 @@ msBuildWMSLayerURL(mapObj *map, layerObj
   if (bbox_ret != NULL)
     *bbox_ret = bbox;
 
-  if( width_ret != NULL )
+  if (width_ret != NULL)
     *width_ret = bbox_width;
 
-  if( height_ret != NULL )
+  if (height_ret != NULL)
     *height_ret = bbox_height;
 
   /* ------------------------------------------------------------------
@@ -796,14 +807,13 @@ msBuildWMSLayerURL(mapObj *map, layerObj
    * Sometimes a requested layer is essential for the map, so if the
    * request fails or an error is delivered, the map has not to be drawn
    * ------------------------------------------------------------------ */
-  if ((pszTmp = msOWSLookupMetadata(&(lp->metadata),
-                                    "MO", "essential")) != NULL) {
-    if( strcasecmp(pszTmp,"true") == 0
-        || strcasecmp(pszTmp,"on") == 0
-        || strcasecmp(pszTmp,"yes") == 0 )
+  if ((pszTmp = msOWSLookupMetadata(&(lp->metadata), "MO", "essential")) !=
+      NULL) {
+    if (strcasecmp(pszTmp, "true") == 0 || strcasecmp(pszTmp, "on") == 0 ||
+        strcasecmp(pszTmp, "yes") == 0)
       bIsEssential = MS_TRUE;
     else
-      bIsEssential = atoi(pszTmp);       
+      bIsEssential = atoi(pszTmp);
   }
 
   if (nRequestType == WMS_GETFEATUREINFO) {
@@ -814,44 +824,49 @@ msBuildWMSLayerURL(mapObj *map, layerObj
     else
       pszRequestParam = "feature_info";
 
-    const char* pszExceptionsParam;
+    const char *pszExceptionsParam;
     if (nVersion >= OWS_1_3_0)
       pszExceptionsParam = "XML";
     else if (nVersion >= OWS_1_1_0) /* 1.1.0 to 1.1.0 */
       pszExceptionsParam = "application/vnd.ogc.se_xml";
-    else if (nVersion > OWS_1_0_0)  /* 1.0.1 to 1.0.7 */
+    else if (nVersion > OWS_1_0_0) /* 1.0.1 to 1.0.7 */
       pszExceptionsParam = "SE_XML";
     else
       pszExceptionsParam = "WMS_XML";
 
-    msSetWMSParamString(psWMSParams, "REQUEST", pszRequestParam, MS_FALSE, nVersion);
-    msSetWMSParamInt(   psWMSParams, "WIDTH",   bbox_width);
-    msSetWMSParamInt(   psWMSParams, "HEIGHT",  bbox_height);
+    msSetWMSParamString(psWMSParams, "REQUEST", pszRequestParam, MS_FALSE,
+                        nVersion);
+    msSetWMSParamInt(psWMSParams, "WIDTH", bbox_width);
+    msSetWMSParamInt(psWMSParams, "HEIGHT", bbox_height);
 
-    msSetWMSParamString(psWMSParams, pszSrsParamName, pszEPSG, MS_FALSE, nVersion);
+    msSetWMSParamString(psWMSParams, pszSrsParamName, pszEPSG, MS_FALSE,
+                        nVersion);
 
     if (bFlipAxisOrder == MS_TRUE) {
-      snprintf(szBuf, sizeof(szBuf), "%.15g,%.15g,%.15g,%.15g",
-               bbox.miny, bbox.minx, bbox.maxy, bbox.maxx);
+      snprintf(szBuf, sizeof(szBuf), "%.15g,%.15g,%.15g,%.15g", bbox.miny,
+               bbox.minx, bbox.maxy, bbox.maxx);
     } else {
-      snprintf(szBuf, sizeof(szBuf), "%.15g,%.15g,%.15g,%.15g",
-               bbox.minx, bbox.miny, bbox.maxx, bbox.maxy);
+      snprintf(szBuf, sizeof(szBuf), "%.15g,%.15g,%.15g,%.15g", bbox.minx,
+               bbox.miny, bbox.maxx, bbox.maxy);
     }
-    msSetWMSParamString(psWMSParams, "BBOX",    szBuf, MS_TRUE, nVersion);
+    msSetWMSParamString(psWMSParams, "BBOX", szBuf, MS_TRUE, nVersion);
 
     if (nVersion >= OWS_1_3_0) {
-      msSetWMSParamInt(   psWMSParams, "I",       nClickX);
-      msSetWMSParamInt(   psWMSParams, "J",       nClickY);
+      msSetWMSParamInt(psWMSParams, "I", nClickX);
+      msSetWMSParamInt(psWMSParams, "J", nClickY);
     } else {
-      msSetWMSParamInt(   psWMSParams, "X",       nClickX);
-      msSetWMSParamInt(   psWMSParams, "Y",       nClickY);
+      msSetWMSParamInt(psWMSParams, "X", nClickX);
+      msSetWMSParamInt(psWMSParams, "Y", nClickY);
     }
 
-    msSetWMSParamString(psWMSParams, "EXCEPTIONS", pszExceptionsParam, MS_FALSE, nVersion);
-    msSetWMSParamString(psWMSParams, "INFO_FORMAT", pszInfoFormat, MS_TRUE, nVersion);
+    msSetWMSParamString(psWMSParams, "EXCEPTIONS", pszExceptionsParam, MS_FALSE,
+                        nVersion);
+    msSetWMSParamString(psWMSParams, "INFO_FORMAT", pszInfoFormat, MS_TRUE,
+                        nVersion);
 
     if (pszQueryLayers) { /* not set in CONNECTION string */
-      msSetWMSParamString(psWMSParams, "QUERY_LAYERS", pszQueryLayers, MS_FALSE, nVersion);
+      msSetWMSParamString(psWMSParams, "QUERY_LAYERS", pszQueryLayers, MS_FALSE,
+                          nVersion);
     }
 
     /* If FEATURE_COUNT <= 0 then don't pass this parameter */
@@ -862,12 +877,13 @@ msBuildWMSLayerURL(mapObj *map, layerObj
     }
 
   } else if (nRequestType == WMS_GETLEGENDGRAPHIC) {
-    if(map->extent.maxx > map->extent.minx && map->width > 0 && map->height > 0) {
+    if (map->extent.maxx > map->extent.minx && map->width > 0 &&
+        map->height > 0) {
       char szBuf[20] = "";
       double scaledenom;
       msCalculateScale(map->extent, map->units, map->width, map->height,
-                     map->resolution, &scaledenom);
-      snprintf(szBuf, 20, "%g",scaledenom);
+                       map->resolution, &scaledenom);
+      snprintf(szBuf, 20, "%g", scaledenom);
       msSetWMSParamString(psWMSParams, "SCALE", szBuf, MS_FALSE, nVersion);
     }
     pszRequestParam = "GetLegendGraphic";
@@ -886,11 +902,14 @@ msBuildWMSLayerURL(mapObj *map, layerObj
       msSetWMSParamString(psWMSParams, "LAYER", pszLayer, MS_FALSE, nVersion);
     }
 
-    msSetWMSParamString(psWMSParams, "REQUEST", pszRequestParam, MS_FALSE, nVersion);
-    msSetWMSParamString(psWMSParams, pszSrsParamName, pszEPSG, MS_FALSE, nVersion);
+    msSetWMSParamString(psWMSParams, "REQUEST", pszRequestParam, MS_FALSE,
+                        nVersion);
+    msSetWMSParamString(psWMSParams, pszSrsParamName, pszEPSG, MS_FALSE,
+                        nVersion);
 
     if (nVersion >= OWS_1_3_0) {
-      msSetWMSParamString(psWMSParams, "SLD_VERSION", "1.1.0", MS_FALSE, nVersion);
+      msSetWMSParamString(psWMSParams, "SLD_VERSION", "1.1.0", MS_FALSE,
+                          nVersion);
     }
 
   } else { /* if (nRequestType == WMS_GETMAP) */
@@ -901,8 +920,8 @@ msBuildWMSLayerURL(mapObj *map, layerObj
     else
       pszRequestParam = "map";
 
-    const char* pszExceptionsParam = msOWSLookupMetadata(&(lp->metadata),
-                         "MO", "exceptions_format");
+    const char *pszExceptionsParam =
+        msOWSLookupMetadata(&(lp->metadata), "MO", "exceptions_format");
 
     if (!bIsEssential) {
       if (pszExceptionsParam == NULL) {
@@ -912,25 +931,29 @@ msBuildWMSLayerURL(mapObj *map, layerObj
           pszExceptionsParam = "INIMAGE";
       }
     } else {
-      /* if layer is essential, do not emit EXCEPTIONS parameter (defaults to XML) */
+      /* if layer is essential, do not emit EXCEPTIONS parameter (defaults to
+       * XML) */
       pszExceptionsParam = NULL;
     }
 
-    msSetWMSParamString(psWMSParams, "REQUEST", pszRequestParam, MS_FALSE, nVersion);
-    msSetWMSParamInt(   psWMSParams, "WIDTH",   bbox_width);
-    msSetWMSParamInt(   psWMSParams, "HEIGHT",  bbox_height);
-    msSetWMSParamString(psWMSParams, pszSrsParamName, pszEPSG, MS_FALSE, nVersion);
+    msSetWMSParamString(psWMSParams, "REQUEST", pszRequestParam, MS_FALSE,
+                        nVersion);
+    msSetWMSParamInt(psWMSParams, "WIDTH", bbox_width);
+    msSetWMSParamInt(psWMSParams, "HEIGHT", bbox_height);
+    msSetWMSParamString(psWMSParams, pszSrsParamName, pszEPSG, MS_FALSE,
+                        nVersion);
 
     if (bFlipAxisOrder == MS_TRUE) {
-      snprintf(szBuf, sizeof(szBuf), "%.15g,%.15g,%.15g,%.15g",
-               bbox.miny, bbox.minx, bbox.maxy, bbox.maxx);
+      snprintf(szBuf, sizeof(szBuf), "%.15g,%.15g,%.15g,%.15g", bbox.miny,
+               bbox.minx, bbox.maxy, bbox.maxx);
     } else {
-      snprintf(szBuf, sizeof(szBuf), "%.15g,%.15g,%.15g,%.15g",
-               bbox.minx, bbox.miny, bbox.maxx, bbox.maxy);
+      snprintf(szBuf, sizeof(szBuf), "%.15g,%.15g,%.15g,%.15g", bbox.minx,
+               bbox.miny, bbox.maxx, bbox.maxy);
     }
-    msSetWMSParamString(psWMSParams, "BBOX",    szBuf, MS_TRUE, nVersion);
-    if( pszExceptionsParam ) {
-      msSetWMSParamString(psWMSParams, "EXCEPTIONS",  pszExceptionsParam, MS_FALSE, nVersion);
+    msSetWMSParamString(psWMSParams, "BBOX", szBuf, MS_TRUE, nVersion);
+    if (pszExceptionsParam) {
+      msSetWMSParamString(psWMSParams, "EXCEPTIONS", pszExceptionsParam,
+                          MS_FALSE, nVersion);
     }
   }
 
@@ -947,10 +970,8 @@ msBuildWMSLayerURL(mapObj *map, layerObj
   return MS_FAILURE;
 
 #endif /* USE_WMS_LYR */
-
 }
 
-
 /**********************************************************************
  *                          msWMSGetFeatureInfoURL()
  *
@@ -959,19 +980,17 @@ msBuildWMSLayerURL(mapObj *map, layerObj
  * Returns a reference to a newly allocated string that should be freed
  * by the caller.
  **********************************************************************/
-char *msWMSGetFeatureInfoURL(mapObj *map, layerObj *lp,
-                             int nClickX, int nClickY, int nFeatureCount,
-                             const char *pszInfoFormat)
-{
+char *msWMSGetFeatureInfoURL(mapObj *map, layerObj *lp, int nClickX,
+                             int nClickY, int nFeatureCount,
+                             const char *pszInfoFormat) {
   wmsParamsObj sThisWMSParams;
   char *pszURL;
 
   msInitWmsParamsObj(&sThisWMSParams);
 
-  if (msBuildWMSLayerURL(map, lp, WMS_GETFEATUREINFO,
-                         nClickX, nClickY, nFeatureCount,
-                         pszInfoFormat, NULL, NULL, NULL,
-                         &sThisWMSParams)!= MS_SUCCESS) {
+  if (msBuildWMSLayerURL(map, lp, WMS_GETFEATUREINFO, nClickX, nClickY,
+                         nFeatureCount, pszInfoFormat, NULL, NULL, NULL,
+                         &sThisWMSParams) != MS_SUCCESS) {
     return NULL;
   }
 
@@ -987,15 +1006,16 @@ char *msWMSGetFeatureInfoURL(mapObj *map
  **********************************************************************/
 
 int msPrepareWMSLayerRequest(int nLayerId, mapObj *map, layerObj *lp,
-                             int nRequestType, enum MS_CONNECTION_TYPE lastconnectiontype,
-                             wmsParamsObj *psLastWMSParams,
-                             int nClickX, int nClickY, int nFeatureCount, const char *pszInfoFormat,
-                             httpRequestObj *pasReqInfo, int *numRequests)
-{
+                             int nRequestType,
+                             enum MS_CONNECTION_TYPE lastconnectiontype,
+                             wmsParamsObj *psLastWMSParams, int nClickX,
+                             int nClickY, int nFeatureCount,
+                             const char *pszInfoFormat,
+                             httpRequestObj *pasReqInfo, int *numRequests) {
 #ifdef USE_WMS_LYR
   char *pszURL = NULL, *pszHTTPCookieData = NULL;
   const char *pszTmp;
-  rectObj bbox = { 0 };
+  rectObj bbox = {0};
   int bbox_width = 0, bbox_height = 0;
   int nTimeout, bOkToMerge, bForceSeparateRequest, bCacheToDisk;
   wmsParamsObj sThisWMSParams;
@@ -1011,34 +1031,29 @@ int msPrepareWMSLayerRequest(int nLayerI
    * compute BBOX in that projection.
    * ------------------------------------------------------------------ */
 
-  switch( nRequestType )
-  {
-      case WMS_GETMAP:
-          ret = msBuildWMSLayerURL(map, lp, WMS_GETMAP,
-                           0, 0, 0, NULL, &bbox, &bbox_width, &bbox_height,
-                           &sThisWMSParams);
-          break;
-
-      case WMS_GETFEATUREINFO:
-          ret = msBuildWMSLayerURL(map, lp, WMS_GETFEATUREINFO,
-                              nClickX, nClickY, nFeatureCount, pszInfoFormat,
-                              NULL, NULL, NULL,
-                              &sThisWMSParams);
-          break;
-
-      case WMS_GETLEGENDGRAPHIC:
-          ret = msBuildWMSLayerURL(map, lp, WMS_GETLEGENDGRAPHIC,
-                                0, 0, 0, NULL,
-                                NULL, NULL, NULL,
-                                &sThisWMSParams);
-          break;
-
-      default:
-          assert(FALSE);
-          break;
+  switch (nRequestType) {
+  case WMS_GETMAP:
+    ret = msBuildWMSLayerURL(map, lp, WMS_GETMAP, 0, 0, 0, NULL, &bbox,
+                             &bbox_width, &bbox_height, &sThisWMSParams);
+    break;
+
+  case WMS_GETFEATUREINFO:
+    ret = msBuildWMSLayerURL(map, lp, WMS_GETFEATUREINFO, nClickX, nClickY,
+                             nFeatureCount, pszInfoFormat, NULL, NULL, NULL,
+                             &sThisWMSParams);
+    break;
+
+  case WMS_GETLEGENDGRAPHIC:
+    ret = msBuildWMSLayerURL(map, lp, WMS_GETLEGENDGRAPHIC, 0, 0, 0, NULL, NULL,
+                             NULL, NULL, &sThisWMSParams);
+    break;
+
+  default:
+    assert(FALSE);
+    break;
   }
 
-  if( ret != MS_SUCCESS) {
+  if (ret != MS_SUCCESS) {
     /* an error was already reported. */
     msFreeWmsParamsObj(&sThisWMSParams);
     return MS_FAILURE;
@@ -1048,24 +1063,26 @@ int msPrepareWMSLayerRequest(int nLayerI
    * Check if the request is empty, perhaps due to reprojection problems
    * or wms_extents restrictions.
    * ------------------------------------------------------------------ */
-  if ((nRequestType == WMS_GETMAP) && (bbox_width == 0 || bbox_height == 0) ) {
+  if ((nRequestType == WMS_GETMAP) && (bbox_width == 0 || bbox_height == 0)) {
     msFreeWmsParamsObj(&sThisWMSParams);
-    return MS_SUCCESS;  /* No overlap. */
+    return MS_SUCCESS; /* No overlap. */
   }
 
   /* ------------------------------------------------------------------
    * Check if layer overlaps current view window (using wms_latlonboundingbox)
    * ------------------------------------------------------------------ */
-  if ((pszTmp = msOWSLookupMetadata(&(lp->metadata),
-                                    "MO", "latlonboundingbox")) != NULL) {
+  if ((pszTmp = msOWSLookupMetadata(&(lp->metadata), "MO",
+                                    "latlonboundingbox")) != NULL) {
     char **tokens;
     int n;
     rectObj ext;
 
     tokens = msStringSplit(pszTmp, ' ', &n);
-    if (tokens==NULL || n != 4) {
-      msSetError(MS_WMSCONNERR, "Wrong number of arguments for 'wms_latlonboundingbox' metadata.",
-                 "msDrawWMSLayer()");
+    if (tokens == NULL || n != 4) {
+      msSetError(
+          MS_WMSCONNERR,
+          "Wrong number of arguments for 'wms_latlonboundingbox' metadata.",
+          "msDrawWMSLayer()");
       msFreeWmsParamsObj(&sThisWMSParams);
       return MS_FAILURE;
     }
@@ -1085,7 +1102,7 @@ int msPrepareWMSLayerRequest(int nLayerI
       /* No overlap... nothing to do */
 
       msFreeWmsParamsObj(&sThisWMSParams);
-      return MS_SUCCESS;  /* No overlap. */
+      return MS_SUCCESS; /* No overlap. */
     }
   }
 
@@ -1094,27 +1111,26 @@ int msPrepareWMSLayerRequest(int nLayerI
    * the case we will use it, else we use the default which is 30 seconds.
    * First check the metadata in the layer object and then in the map object.
    * ------------------------------------------------------------------ */
-  nTimeout = 30;  /* Default is 30 seconds  */
+  nTimeout = 30; /* Default is 30 seconds  */
   if ((pszTmp = msOWSLookupMetadata2(&(lp->metadata), &(map->web.metadata),
-                                    "MO", "connectiontimeout")) != NULL) {
+                                     "MO", "connectiontimeout")) != NULL) {
     nTimeout = atoi(pszTmp);
   }
 
   /* ------------------------------------------------------------------
    * Check if we want to use in memory images instead of writing to disk.
    * ------------------------------------------------------------------ */
-  if ((pszTmp = msOWSLookupMetadata(&(lp->metadata),
-                                    "MO", "cache_to_disk")) != NULL) {
-    if( strcasecmp(pszTmp,"true") == 0
-        || strcasecmp(pszTmp,"on") == 0
-        || strcasecmp(pszTmp,"yes") == 0 )
+  if ((pszTmp = msOWSLookupMetadata(&(lp->metadata), "MO", "cache_to_disk")) !=
+      NULL) {
+    if (strcasecmp(pszTmp, "true") == 0 || strcasecmp(pszTmp, "on") == 0 ||
+        strcasecmp(pszTmp, "yes") == 0)
       bCacheToDisk = MS_TRUE;
     else
       bCacheToDisk = atoi(pszTmp);
   } else
     bCacheToDisk = MS_FALSE;
 
-  if( bCacheToDisk ) {
+  if (bCacheToDisk) {
     /* We'll store the remote server's response to a tmp file. */
     if (map->web.imagepath == NULL || strlen(map->web.imagepath) == 0) {
       msSetError(MS_WMSERR,
@@ -1130,31 +1146,28 @@ int msPrepareWMSLayerRequest(int nLayerI
    * this layer from being combined with any other layer.
    * ------------------------------------------------------------------ */
   bForceSeparateRequest = MS_FALSE;
-  if ((pszTmp = msOWSLookupMetadata(&(lp->metadata),
-                                    "MO", "force_separate_request")) != NULL) {
+  if ((pszTmp = msOWSLookupMetadata(&(lp->metadata), "MO",
+                                    "force_separate_request")) != NULL) {
     bForceSeparateRequest = atoi(pszTmp);
   }
   bOkToMerge = MS_FALSE;
-  if (!bForceSeparateRequest &&
-      lastconnectiontype == MS_WMS &&
+  if (!bForceSeparateRequest && lastconnectiontype == MS_WMS &&
       psLastWMSParams != NULL &&
       sThisWMSParams.numparams == psLastWMSParams->numparams &&
-      strcmp(sThisWMSParams.onlineresource,
-             psLastWMSParams->onlineresource) == 0) {
+      strcmp(sThisWMSParams.onlineresource, psLastWMSParams->onlineresource) ==
+          0) {
     const char *key, *value1, *value2;
     bOkToMerge = MS_TRUE;
 
     key = msFirstKeyFromHashTable(sThisWMSParams.params);
     while (key != NULL && bOkToMerge == MS_TRUE) {
       /* Skip parameters whose values can be different */
-      if (!(strcmp(key, "LAYERS") == 0 ||
-            strcmp(key, "QUERY_LAYERS") == 0 ||
-            strcmp(key, "STYLES") == 0) ) {
+      if (!(strcmp(key, "LAYERS") == 0 || strcmp(key, "QUERY_LAYERS") == 0 ||
+            strcmp(key, "STYLES") == 0)) {
         value1 = msLookupHashTable(psLastWMSParams->params, key);
         value2 = msLookupHashTable(sThisWMSParams.params, key);
 
-        if (value1==NULL || value2==NULL ||
-            strcmp(value1, value2) != 0) {
+        if (value1 == NULL || value2 == NULL || strcmp(value1, value2) != 0) {
           bOkToMerge = MS_FALSE;
           break;
         }
@@ -1168,21 +1181,21 @@ int msPrepareWMSLayerRequest(int nLayerI
    * If Cookie differ between the two connection, it's NOT OK to merge
    * the connection
    * ------------------------------------------------------------------ */
-  if ((pszTmp = msOWSLookupMetadata(&(lp->metadata),
-                                    "MO", "http_cookie")) != NULL) {
-    if(strcasecmp(pszTmp, "forward") == 0) {
-      pszTmp= msLookupHashTable(&(map->web.metadata),"http_cookie_data");
-      if(pszTmp != NULL) {
+  if ((pszTmp = msOWSLookupMetadata(&(lp->metadata), "MO", "http_cookie")) !=
+      NULL) {
+    if (strcasecmp(pszTmp, "forward") == 0) {
+      pszTmp = msLookupHashTable(&(map->web.metadata), "http_cookie_data");
+      if (pszTmp != NULL) {
         pszHTTPCookieData = msStrdup(pszTmp);
       }
     } else {
       pszHTTPCookieData = msStrdup(pszTmp);
     }
-  } else if ((pszTmp = msOWSLookupMetadata(&(map->web.metadata),
-                       "MO", "http_cookie")) != NULL) {
-    if(strcasecmp(pszTmp, "forward") == 0) {
-      pszTmp= msLookupHashTable(&(map->web.metadata),"http_cookie_data");
-      if(pszTmp != NULL) {
+  } else if ((pszTmp = msOWSLookupMetadata(&(map->web.metadata), "MO",
+                                           "http_cookie")) != NULL) {
+    if (strcasecmp(pszTmp, "forward") == 0) {
+      pszTmp = msLookupHashTable(&(map->web.metadata), "http_cookie_data");
+      if (pszTmp != NULL) {
         pszHTTPCookieData = msStrdup(pszTmp);
       }
     } else {
@@ -1190,11 +1203,10 @@ int msPrepareWMSLayerRequest(int nLayerI
     }
   }
 
-  if(bOkToMerge && pszHTTPCookieData != sThisWMSParams.httpcookiedata) {
-    if(pszHTTPCookieData == NULL || sThisWMSParams.httpcookiedata == NULL) {
+  if (bOkToMerge && pszHTTPCookieData != sThisWMSParams.httpcookiedata) {
+    if (pszHTTPCookieData == NULL || sThisWMSParams.httpcookiedata == NULL) {
       bOkToMerge = MS_FALSE;
-    }
-    else if(strcmp(pszHTTPCookieData, sThisWMSParams.httpcookiedata) != 0) {
+    } else if (strcmp(pszHTTPCookieData, sThisWMSParams.httpcookiedata) != 0) {
       bOkToMerge = MS_FALSE;
     }
   }
@@ -1206,20 +1218,21 @@ int msPrepareWMSLayerRequest(int nLayerI
     char *keys[] = {"LAYERS", "QUERY_LAYERS", "STYLES"};
     int i;
 
-    for(i=0; i<3; i++) {
+    for (i = 0; i < 3; i++) {
       value1 = msLookupHashTable(psLastWMSParams->params, keys[i]);
       value2 = msLookupHashTable(sThisWMSParams.params, keys[i]);
       if (value1 && value2) {
         char *pszBuf;
         int nLen;
 
-        nLen = strlen(value1) + strlen(value2) +2;
+        nLen = strlen(value1) + strlen(value2) + 2;
         pszBuf = malloc(nLen);
         MS_CHECK_ALLOC(pszBuf, nLen, MS_FAILURE);
 
         snprintf(pszBuf, nLen, "%s,%s", value1, value2);
         /* TODO should really send the server request version here */
-        msSetWMSParamString(&sThisWMSParams, keys[i], pszBuf,MS_FALSE, OWS_VERSION_NOTSET);
+        msSetWMSParamString(&sThisWMSParams, keys[i], pszBuf, MS_FALSE,
+                            OWS_VERSION_NOTSET);
 
         /* This key existed already, we don't want it counted twice */
         sThisWMSParams.numparams--;
@@ -1229,22 +1242,21 @@ int msPrepareWMSLayerRequest(int nLayerI
     }
   }
 
-
   /* ------------------------------------------------------------------
    * Build new request URL
    * ------------------------------------------------------------------ */
   pszURL = msBuildURLFromWMSParams(&sThisWMSParams);
 
-  if (bOkToMerge && (*numRequests)>0) {
+  if (bOkToMerge && (*numRequests) > 0) {
     /* ------------------------------------------------------------------
      * Update the last request in the array:  (*numRequests)-1
      * ------------------------------------------------------------------ */
-    msFree(pasReqInfo[(*numRequests)-1].pszGetUrl);
-    pasReqInfo[(*numRequests)-1].pszGetUrl = pszURL;
+    msFree(pasReqInfo[(*numRequests) - 1].pszGetUrl);
+    pasReqInfo[(*numRequests) - 1].pszGetUrl = pszURL;
     pszURL = NULL;
-    pasReqInfo[(*numRequests)-1].debug |= lp->debug;
-    if (nTimeout > pasReqInfo[(*numRequests)-1].nTimeout)
-      pasReqInfo[(*numRequests)-1].nTimeout = nTimeout;
+    pasReqInfo[(*numRequests) - 1].debug |= lp->debug;
+    if (nTimeout > pasReqInfo[(*numRequests) - 1].nTimeout)
+      pasReqInfo[(*numRequests) - 1].nTimeout = nTimeout;
   } else {
     /* ------------------------------------------------------------------
      * Add a request to the array (already preallocated)
@@ -1255,26 +1267,25 @@ int msPrepareWMSLayerRequest(int nLayerI
     pszURL = NULL;
     pasReqInfo[(*numRequests)].pszHTTPCookieData = pszHTTPCookieData;
     pszHTTPCookieData = NULL;
-    if( bCacheToDisk ) {
+    if (bCacheToDisk) {
       pasReqInfo[(*numRequests)].pszOutputFile =
-        msTmpFile(map, map->mappath, NULL, "wms.tmp");
+          msTmpFile(map, map->mappath, NULL, "wms.tmp");
     } else
       pasReqInfo[(*numRequests)].pszOutputFile = NULL;
     pasReqInfo[(*numRequests)].nStatus = 0;
     pasReqInfo[(*numRequests)].nTimeout = nTimeout;
-    pasReqInfo[(*numRequests)].bbox   = bbox;
-    pasReqInfo[(*numRequests)].width  = bbox_width;
+    pasReqInfo[(*numRequests)].bbox = bbox;
+    pasReqInfo[(*numRequests)].width = bbox_width;
     pasReqInfo[(*numRequests)].height = bbox_height;
     pasReqInfo[(*numRequests)].debug = lp->debug;
 
-    if (msHTTPAuthProxySetup(&(map->web.metadata), &(lp->metadata),
-                             pasReqInfo, *numRequests, map, "MO") != MS_SUCCESS)
+    if (msHTTPAuthProxySetup(&(map->web.metadata), &(lp->metadata), pasReqInfo,
+                             *numRequests, map, "MO") != MS_SUCCESS)
       return MS_FAILURE;
 
     (*numRequests)++;
   }
 
-
   /* ------------------------------------------------------------------
    * Replace contents of psLastWMSParams with sThisWMSParams
    * unless bForceSeparateRequest is set in which case we make it empty
@@ -1298,10 +1309,9 @@ int msPrepareWMSLayerRequest(int nLayerI
    * ------------------------------------------------------------------ */
   msSetError(MS_WMSCONNERR, "WMS CLIENT CONNECTION support is not available.",
              "msDrawWMSLayer()");
-  return(MS_FAILURE);
+  return (MS_FAILURE);
 
 #endif /* USE_WMS_LYR */
-
 }
 
 /**********************************************************************
@@ -1309,9 +1319,8 @@ int msPrepareWMSLayerRequest(int nLayerI
  *
  **********************************************************************/
 
-int msDrawWMSLayerLow(int nLayerId, httpRequestObj *pasReqInfo,
-                      int numRequests, mapObj *map, layerObj *lp, imageObj *img)
-{
+int msDrawWMSLayerLow(int nLayerId, httpRequestObj *pasReqInfo, int numRequests,
+                      mapObj *map, layerObj *lp, imageObj *img) {
 #ifdef USE_WMS_LYR
   int status = MS_SUCCESS;
   int iReq = -1;
@@ -1327,20 +1336,19 @@ int msDrawWMSLayerLow(int nLayerId, http
    * Sometimes a requested layer is essential for the map, so if the
    * request fails or an error is delivered, the map has not to be drawn
    * ------------------------------------------------------------------ */
-  if ((pszTmp = msOWSLookupMetadata(&(lp->metadata),
-                                    "MO", "essential")) != NULL) {
-    if( strcasecmp(pszTmp,"true") == 0
-        || strcasecmp(pszTmp,"on") == 0
-        || strcasecmp(pszTmp,"yes") == 0 )
+  if ((pszTmp = msOWSLookupMetadata(&(lp->metadata), "MO", "essential")) !=
+      NULL) {
+    if (strcasecmp(pszTmp, "true") == 0 || strcasecmp(pszTmp, "on") == 0 ||
+        strcasecmp(pszTmp, "yes") == 0)
       bIsEssential = MS_TRUE;
     else
-      bIsEssential = atoi(pszTmp);      
+      bIsEssential = atoi(pszTmp);
   }
 
   /* ------------------------------------------------------------------
    * Find the request info for this layer in the array, based on nLayerId
    * ------------------------------------------------------------------ */
-  for(iReq=0; iReq<numRequests; iReq++) {
+  for (iReq = 0; iReq < numRequests; iReq++) {
     if (pasReqInfo[iReq].nLayerId == nLayerId)
       break;
   }
@@ -1352,7 +1360,7 @@ int msDrawWMSLayerLow(int nLayerId, http
     return MS_SUCCESS;
   }
 
-  if ( !MS_HTTP_SUCCESS( pasReqInfo[iReq].nStatus ) ) {
+  if (!MS_HTTP_SUCCESS(pasReqInfo[iReq].nStatus)) {
     /* ====================================================================
           Failed downloading layer... we log an error but we still return
           SUCCESS here so that the layer is only skipped instead of aborting
@@ -1361,9 +1369,8 @@ int msDrawWMSLayerLow(int nLayerId, http
      ==================================================================== */
     msSetError(MS_WMSERR,
                "WMS GetMap request failed for layer '%s' (Status %d: %s).",
-               "msDrawWMSLayerLow()",
-               (lp->name?lp->name:"(null)"),
-               pasReqInfo[iReq].nStatus, pasReqInfo[iReq].pszErrBuf );
+               "msDrawWMSLayerLow()", (lp->name ? lp->name : "(null)"),
+               pasReqInfo[iReq].nStatus, pasReqInfo[iReq].pszErrBuf);
 
     if (!bIsEssential)
       return MS_SUCCESS;
@@ -1380,11 +1387,12 @@ int msDrawWMSLayerLow(int nLayerId, http
    * ------------------------------------------------------------------ */
   if (pasReqInfo[iReq].pszContentType &&
       (strcmp(pasReqInfo[iReq].pszContentType, "text/xml") == 0 ||
-       strcmp(pasReqInfo[iReq].pszContentType, "application/vnd.ogc.se_xml") == 0)) {
+       strcmp(pasReqInfo[iReq].pszContentType, "application/vnd.ogc.se_xml") ==
+           0)) {
     FILE *fp;
     char szBuf[MS_BUFFER_LENGTH];
 
-    if( pasReqInfo[iReq].pszOutputFile ) {
+    if (pasReqInfo[iReq].pszOutputFile) {
       fp = fopen(pasReqInfo[iReq].pszOutputFile, "r");
       if (fp) {
         /* TODO: For now we'll only read the first chunk and return it
@@ -1393,7 +1401,7 @@ int msDrawWMSLayerLow(int nLayerId, http
          */
         size_t nSize;
 
-        nSize = fread(szBuf, sizeof(char), MS_BUFFER_LENGTH-1, fp);
+        nSize = fread(szBuf, sizeof(char), MS_BUFFER_LENGTH - 1, fp);
         if (nSize < MS_BUFFER_LENGTH)
           szBuf[nSize] = '\0';
         else {
@@ -1409,17 +1417,16 @@ int msDrawWMSLayerLow(int nLayerId, http
         strlcpy(szBuf, "(Failed to open exception response)", sizeof(szBuf));
       }
     } else {
-      strlcpy( szBuf, pasReqInfo[iReq].result_data, MS_BUFFER_LENGTH );
+      strlcpy(szBuf, pasReqInfo[iReq].result_data, MS_BUFFER_LENGTH);
     }
 
     if (lp->debug)
       msDebug("WMS GetMap request got XML exception for layer '%s': %s.",
-              (lp->name?lp->name:"(null)"), szBuf );
+              (lp->name ? lp->name : "(null)"), szBuf);
 
     msSetError(MS_WMSERR,
                "WMS GetMap request got XML exception for layer '%s': %s.",
-               "msDrawWMSLayerLow()",
-               (lp->name?lp->name:"(null)"), szBuf );
+               "msDrawWMSLayerLow()", (lp->name ? lp->name : "(null)"), szBuf);
 
     if (!bIsEssential)
       return MS_SUCCESS;
@@ -1431,14 +1438,12 @@ int msDrawWMSLayerLow(int nLayerId, http
    * If the output was written to a memory buffer, then we will need
    * to attach a "VSI" name to this buffer.
    * ------------------------------------------------------------------ */
-  if( pasReqInfo[iReq].pszOutputFile == NULL ) {
-    mem_filename = msTmpFile(map, NULL, "/vsimem/msout/", "img.tmp" );
+  if (pasReqInfo[iReq].pszOutputFile == NULL) {
+    mem_filename = msTmpFile(map, NULL, "/vsimem/msout/", "img.tmp");
 
-    VSIFCloseL(
-      VSIFileFromMemBuffer( mem_filename,
-                            (GByte*) pasReqInfo[iReq].result_data,
-                            (vsi_l_offset) pasReqInfo[iReq].result_size,
-                            FALSE ) );
+    VSIFCloseL(VSIFileFromMemBuffer(
+        mem_filename, (GByte *)pasReqInfo[iReq].result_data,
+        (vsi_l_offset)pasReqInfo[iReq].result_size, FALSE));
   }
 
   /* ------------------------------------------------------------------
@@ -1458,21 +1463,22 @@ int msDrawWMSLayerLow(int nLayerId, http
 
   /* ensure the file connection is closed right away after the layer */
   /* is rendered */
-  msLayerSetProcessingKey( lp, "CLOSE_CONNECTION", "NORMAL");
+  msLayerSetProcessingKey(lp, "CLOSE_CONNECTION", "NORMAL");
 
   if (msOWSLookupMetadata(&(lp->metadata), "MO", "sld_body") ||
       msOWSLookupMetadata(&(lp->metadata), "MO", "sld_url"))
     lp->numclasses = 0;
 
-  if (lp->data) free(lp->data);
-  if( mem_filename != NULL )
+  if (lp->data)
+    free(lp->data);
+  if (mem_filename != NULL)
     lp->data = mem_filename;
   else
-    lp->data =  msStrdup(pasReqInfo[iReq].pszOutputFile);
+    lp->data = msStrdup(pasReqInfo[iReq].pszOutputFile);
 
   /* #3138 If PROCESSING "RESAMPLE=..." is set we cannot use the simple case */
   if (!msProjectionsDiffer(&(map->projection), &(lp->projection)) &&
-      (msLayerGetProcessingKey(lp, "RESAMPLE") == NULL) ) {
+      (msLayerGetProcessingKey(lp, "RESAMPLE") == NULL)) {
     /* The simple case... no reprojection needed... render layer directly. */
     lp->transform = MS_FALSE;
     /* if (msDrawRasterLayerLow(map, lp, img) != 0) */
@@ -1484,44 +1490,40 @@ int msDrawWMSLayerLow(int nLayerId, http
     char *wldfile;
     /* OK, we have to resample the raster to map projection... */
     lp->transform = MS_TRUE;
-    msLayerSetProcessingKey( lp, "LOAD_WHOLE_IMAGE", "YES" );
+    msLayerSetProcessingKey(lp, "LOAD_WHOLE_IMAGE", "YES");
 
     /* Create a world file with raster extents */
     /* One line per value, in this order: cx, 0, 0, cy, ulx, uly */
     wldfile = msBuildPath(szPath, lp->map->mappath, lp->data);
-    if (wldfile && (strlen(wldfile)>=3))
-      strcpy(wldfile+strlen(wldfile)-3, "wld");
+    if (wldfile && (strlen(wldfile) >= 3))
+      strcpy(wldfile + strlen(wldfile) - 3, "wld");
     if (wldfile && (fp = VSIFOpenL(wldfile, "wt")) != NULL) {
-      double dfCellSizeX = MS_OWS_CELLSIZE(pasReqInfo[iReq].bbox.minx,
-                                           pasReqInfo[iReq].bbox.maxx,
-                                           pasReqInfo[iReq].width);
-      double dfCellSizeY = MS_OWS_CELLSIZE(pasReqInfo[iReq].bbox.maxy,
-                                           pasReqInfo[iReq].bbox.miny,
-                                           pasReqInfo[iReq].height);
+      double dfCellSizeX =
+          MS_OWS_CELLSIZE(pasReqInfo[iReq].bbox.minx,
+                          pasReqInfo[iReq].bbox.maxx, pasReqInfo[iReq].width);
+      double dfCellSizeY =
+          MS_OWS_CELLSIZE(pasReqInfo[iReq].bbox.maxy,
+                          pasReqInfo[iReq].bbox.miny, pasReqInfo[iReq].height);
       char world_text[5000];
 
-      sprintf( world_text, "%.12f\n0\n0\n%.12f\n%.12f\n%.12f\n",
-               dfCellSizeX,
-               dfCellSizeY,
-               pasReqInfo[iReq].bbox.minx + dfCellSizeX * 0.5,
-               pasReqInfo[iReq].bbox.maxy + dfCellSizeY * 0.5 );
+      sprintf(world_text, "%.12f\n0\n0\n%.12f\n%.12f\n%.12f\n", dfCellSizeX,
+              dfCellSizeY, pasReqInfo[iReq].bbox.minx + dfCellSizeX * 0.5,
+              pasReqInfo[iReq].bbox.maxy + dfCellSizeY * 0.5);
 
-      VSIFWriteL( world_text, 1, strlen(world_text), fp );
-      VSIFCloseL( fp );
+      VSIFWriteL(world_text, 1, strlen(world_text), fp);
+      VSIFCloseL(fp);
 
       /* GDAL should be called to reproject automatically. */
       if (msDrawLayer(map, lp, img) != 0)
         status = MS_FAILURE;
 
       if (!lp->debug || mem_filename != NULL)
-        VSIUnlink( wldfile );
+        VSIUnlink(wldfile);
     } else {
-      msSetError(MS_WMSCONNERR,
-                 "Unable to create wld file for WMS slide.",
+      msSetError(MS_WMSCONNERR, "Unable to create wld file for WMS slide.",
                  "msDrawWMSLayer()");
       status = MS_FAILURE;
     }
-
   }
 
   /* We're done with the remote server's response... delete it. */
@@ -1546,16 +1548,14 @@ int msDrawWMSLayerLow(int nLayerId, http
    * ------------------------------------------------------------------ */
   msSetError(MS_WMSCONNERR, "WMS CLIENT CONNECTION support is not available.",
              "msDrawWMSLayer()");
-  return(MS_FAILURE);
+  return (MS_FAILURE);
 
 #endif /* USE_WMS_LYR */
-
 }
 
-
-int msWMSLayerExecuteRequest(mapObj *map, int nOWSLayers, int nClickX, int nClickY,
-                             int nFeatureCount, const char *pszInfoFormat, int type)
-{
+int msWMSLayerExecuteRequest(mapObj *map, int nOWSLayers, int nClickX,
+                             int nClickY, int nFeatureCount,
+                             const char *pszInfoFormat, int type) {
 #ifdef USE_WMS_LYR
 
   msIOContext *context;
@@ -1564,27 +1564,28 @@ int msWMSLayerExecuteRequest(mapObj *map
   wmsParamsObj sLastWMSParams;
   int i, numReq = 0;
 
-  pasReqInfo = (httpRequestObj *)msSmallMalloc((nOWSLayers+1)*sizeof(httpRequestObj));
-  msHTTPInitRequestObj(pasReqInfo, nOWSLayers+1);
+  pasReqInfo = (httpRequestObj *)msSmallMalloc((nOWSLayers + 1) *
+                                               sizeof(httpRequestObj));
+  msHTTPInitRequestObj(pasReqInfo, nOWSLayers + 1);
   msInitWmsParamsObj(&sLastWMSParams);
 
   /* Generate the http request */
-  for (i=0; i<map->numlayers; i++) {
-    if (GET_LAYER(map,map->layerorder[i])->status == MS_ON) {
-      if (type == WMS_GETFEATUREINFO ) {
-        if( msPrepareWMSLayerRequest(map->layerorder[i], map, GET_LAYER(map,map->layerorder[i]),
-                                   WMS_GETFEATUREINFO,
-                                   MS_WMS, &sLastWMSParams,
-                                   nClickX, nClickY, nFeatureCount, pszInfoFormat,
-                                   pasReqInfo, &numReq) == MS_FAILURE) {
+  for (i = 0; i < map->numlayers; i++) {
+    if (GET_LAYER(map, map->layerorder[i])->status == MS_ON) {
+      if (type == WMS_GETFEATUREINFO) {
+        if (msPrepareWMSLayerRequest(
+                map->layerorder[i], map, GET_LAYER(map, map->layerorder[i]),
+                WMS_GETFEATUREINFO, MS_WMS, &sLastWMSParams, nClickX, nClickY,
+                nFeatureCount, pszInfoFormat, pasReqInfo,
+                &numReq) == MS_FAILURE) {
           msFreeWmsParamsObj(&sLastWMSParams);
           msFree(pasReqInfo);
           return MS_FAILURE;
         }
-      } else if (msPrepareWMSLayerRequest(map->layerorder[i], map, GET_LAYER(map,map->layerorder[i]),
-                                          WMS_GETLEGENDGRAPHIC,
-                                          MS_WMS, &sLastWMSParams,
-                                          0, 0, 0, NULL,
+      } else if (msPrepareWMSLayerRequest(map->layerorder[i], map,
+                                          GET_LAYER(map, map->layerorder[i]),
+                                          WMS_GETLEGENDGRAPHIC, MS_WMS,
+                                          &sLastWMSParams, 0, 0, 0, NULL,
                                           pasReqInfo, &numReq) == MS_FAILURE) {
         msFreeWmsParamsObj(&sLastWMSParams);
         msFree(pasReqInfo);
@@ -1600,44 +1601,41 @@ int msWMSLayerExecuteRequest(mapObj *map
     return MS_FAILURE;
   }
 
-  context = msIO_getHandler( stdout );
-  if( context == NULL ) {
+  context = msIO_getHandler(stdout);
+  if (context == NULL) {
     msHTTPFreeRequestObj(pasReqInfo, numReq);
     msFree(pasReqInfo);
     msFreeWmsParamsObj(&sLastWMSParams);
     return MS_FAILURE;
   }
 
-  msIO_printf("Content-Type: %s%c%c",pasReqInfo[0].pszContentType, 10,10);
+  msIO_printf("Content-Type: %s%c%c", pasReqInfo[0].pszContentType, 10, 10);
 
-  if( pasReqInfo[0].pszOutputFile ) {
+  if (pasReqInfo[0].pszOutputFile) {
     FILE *fp;
     char szBuf[MS_BUFFER_LENGTH];
 
     fp = fopen(pasReqInfo[0].pszOutputFile, "r");
     if (fp) {
-      while(1) {
+      while (1) {
         size_t nSize;
-        nSize = fread(szBuf, sizeof(char), MS_BUFFER_LENGTH-1, fp);
+        nSize = fread(szBuf, sizeof(char), MS_BUFFER_LENGTH - 1, fp);
         if (nSize > 0)
-          msIO_contextWrite( context,
-                             szBuf,
-                             nSize);
-        if (nSize != MS_BUFFER_LENGTH-1)
+          msIO_contextWrite(context, szBuf, nSize);
+        if (nSize != MS_BUFFER_LENGTH - 1)
           break;
       }
       fclose(fp);
       if (!map->debug)
         unlink(pasReqInfo[0].pszOutputFile);
     } else {
-      msSetError(MS_IOERR, "'%s'.",
-                 "msWMSLayerExecuteRequest()", pasReqInfo[0].pszOutputFile);
+      msSetError(MS_IOERR, "'%s'.", "msWMSLayerExecuteRequest()",
+                 pasReqInfo[0].pszOutputFile);
       return MS_FAILURE;
     }
   } else {
-    msIO_contextWrite( context,
-                       pasReqInfo[0].result_data,
-                       pasReqInfo[0].result_size );
+    msIO_contextWrite(context, pasReqInfo[0].result_data,
+                      pasReqInfo[0].result_size);
   }
 
   msHTTPFreeRequestObj(pasReqInfo, numReq);
@@ -1651,8 +1649,7 @@ int msWMSLayerExecuteRequest(mapObj *map
    * ------------------------------------------------------------------ */
   msSetError(MS_WMSCONNERR, "WMS CLIENT CONNECTION support is not available.",
              "msWMSLayerExecuteRequest()");
-  return(MS_FAILURE);
+  return (MS_FAILURE);
 
 #endif /* USE_WMS_LYR */
-
 }
diff -pruN 8.0.1-5/mapxbase.c 8.0.2-1/mapxbase.c
--- 8.0.1-5/mapxbase.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapxbase.c	2024-06-11 20:41:34.000000000 +0000
@@ -34,7 +34,9 @@
 
 #include "cpl_vsi.h"
 
-static inline void IGUR_sizet(size_t ignored) { (void)ignored; }  /* Ignore GCC Unused Result */
+static inline void IGUR_sizet(size_t ignored) {
+  (void)ignored;
+} /* Ignore GCC Unused Result */
 
 /************************************************************************/
 /*                             SfRealloc()                              */
@@ -42,10 +44,10 @@ static inline void IGUR_sizet(size_t ign
 /*      A realloc cover function that will access a NULL pointer as     */
 /*      a valid input.                                                  */
 /************************************************************************/
-static void * SfRealloc( void * pMem, int nNewSize )
+static void *SfRealloc(void *pMem, int nNewSize)
 
 {
-  return( (void *) realloc(pMem,nNewSize) );
+  return ((void *)realloc(pMem, nNewSize));
 }
 
 /************************************************************************/
@@ -60,9 +62,9 @@ static void writeHeader(DBFHandle psDBF)
 
 {
   uchar abyHeader[32];
-  int   i;
+  int i;
 
-  if( !psDBF->bNoHeader )
+  if (!psDBF->bNoHeader)
     return;
 
   psDBF->bNoHeader = MS_FALSE;
@@ -70,10 +72,10 @@ static void writeHeader(DBFHandle psDBF)
   /* -------------------------------------------------------------------- */
   /*  Initialize the file header information.               */
   /* -------------------------------------------------------------------- */
-  for( i = 0; i < 32; i++ )
+  for (i = 0; i < 32; i++)
     abyHeader[i] = 0;
 
-  abyHeader[0] = 0x03;    /* memo field? - just copying   */
+  abyHeader[0] = 0x03; /* memo field? - just copying   */
 
   /* date updated on close, record count preset at zero */
 
@@ -87,18 +89,18 @@ static void writeHeader(DBFHandle psDBF)
   /*      Write the initial 32 byte file header, and all the field        */
   /*      descriptions.                                             */
   /* -------------------------------------------------------------------- */
-  VSIFSeekL( psDBF->fp, 0, 0 );
-  VSIFWriteL( abyHeader, 32, 1, psDBF->fp );
-  VSIFWriteL( psDBF->pszHeader, 32, psDBF->nFields, psDBF->fp );
+  VSIFSeekL(psDBF->fp, 0, 0);
+  VSIFWriteL(abyHeader, 32, 1, psDBF->fp);
+  VSIFWriteL(psDBF->pszHeader, 32, psDBF->nFields, psDBF->fp);
 
   /* -------------------------------------------------------------------- */
   /*      Write out the newline character if there is room for it.        */
   /* -------------------------------------------------------------------- */
-  if( psDBF->nHeaderLength > 32*psDBF->nFields + 32 ) {
-    char  cNewline;
+  if (psDBF->nHeaderLength > 32 * psDBF->nFields + 32) {
+    char cNewline;
 
     cNewline = 0x0d;
-    VSIFWriteL( &cNewline, 1, 1, psDBF->fp );
+    VSIFWriteL(&cNewline, 1, 1, psDBF->fp);
   }
 }
 
@@ -107,32 +109,31 @@ static void writeHeader(DBFHandle psDBF)
 /*                                                                      */
 /*      Write out the current record if there is one.                   */
 /************************************************************************/
-static void flushRecord( DBFHandle psDBF )
+static void flushRecord(DBFHandle psDBF)
 
 {
   unsigned int nRecordOffset;
 
-  if( psDBF->bCurrentRecordModified && psDBF->nCurrentRecord > -1 ) {
+  if (psDBF->bCurrentRecordModified && psDBF->nCurrentRecord > -1) {
     psDBF->bCurrentRecordModified = MS_FALSE;
 
-    nRecordOffset = psDBF->nRecordLength * psDBF->nCurrentRecord
-                    + psDBF->nHeaderLength;
+    nRecordOffset =
+        psDBF->nRecordLength * psDBF->nCurrentRecord + psDBF->nHeaderLength;
 
-    VSIFSeekL( psDBF->fp, nRecordOffset, 0 );
-    VSIFWriteL( psDBF->pszCurrentRecord, psDBF->nRecordLength, 1, psDBF->fp );
+    VSIFSeekL(psDBF->fp, nRecordOffset, 0);
+    VSIFWriteL(psDBF->pszCurrentRecord, psDBF->nRecordLength, 1, psDBF->fp);
   }
 }
 
-DBFHandle msDBFOpenVirtualFile( VSILFILE * fp )
-{
-  DBFHandle   psDBF;
-  uchar   *pabyBuf;
-  int     nFields, nHeadLen, nRecLen, iField;
+DBFHandle msDBFOpenVirtualFile(VSILFILE *fp) {
+  DBFHandle psDBF;
+  uchar *pabyBuf;
+  int nFields, nHeadLen, nRecLen, iField;
 
   /* -------------------------------------------------------------------- */
   /*      Open the file.                                                  */
   /* -------------------------------------------------------------------- */
-  psDBF = (DBFHandle) calloc( 1, sizeof(DBFInfo) );
+  psDBF = (DBFHandle)calloc(1, sizeof(DBFInfo));
   MS_CHECK_ALLOC(psDBF, sizeof(DBFInfo), NULL);
   psDBF->fp = fp;
 
@@ -146,77 +147,76 @@ DBFHandle msDBFOpenVirtualFile( VSILFILE
   /* -------------------------------------------------------------------- */
   /*  Read Table Header info                                              */
   /* -------------------------------------------------------------------- */
-  pabyBuf = (uchar *) msSmallMalloc(500);
-  if( VSIFReadL( pabyBuf, 32, 1, psDBF->fp ) != 1 )
-  {
-    VSIFCloseL( psDBF->fp );
+  pabyBuf = (uchar *)msSmallMalloc(500);
+  if (VSIFReadL(pabyBuf, 32, 1, psDBF->fp) != 1) {
+    VSIFCloseL(psDBF->fp);
     msFree(psDBF);
     msFree(pabyBuf);
-    return( NULL );
+    return (NULL);
   }
 
-  if( pabyBuf[7] < 128 )
-      psDBF->nRecords = pabyBuf[4] + pabyBuf[5]*256 + pabyBuf[6]*256*256 + pabyBuf[7]*256*256*256;
+  if (pabyBuf[7] < 128)
+    psDBF->nRecords = pabyBuf[4] + pabyBuf[5] * 256 + pabyBuf[6] * 256 * 256 +
+                      pabyBuf[7] * 256 * 256 * 256;
   else
-      psDBF->nRecords = 0;
+    psDBF->nRecords = 0;
 
-  psDBF->nHeaderLength = nHeadLen = pabyBuf[8] + pabyBuf[9]*256;
-  psDBF->nRecordLength = nRecLen = pabyBuf[10] + pabyBuf[11]*256;
+  psDBF->nHeaderLength = nHeadLen = pabyBuf[8] + pabyBuf[9] * 256;
+  psDBF->nRecordLength = nRecLen = pabyBuf[10] + pabyBuf[11] * 256;
 
   if (nHeadLen <= 32) {
-    VSIFCloseL( psDBF->fp );
+    VSIFCloseL(psDBF->fp);
     msFree(psDBF);
     msFree(pabyBuf);
-    return( NULL );
+    return (NULL);
   }
 
   psDBF->nFields = nFields = (nHeadLen - 32) / 32;
 
-  psDBF->pszCurrentRecord = (char *) msSmallMalloc(nRecLen);
+  psDBF->pszCurrentRecord = (char *)msSmallMalloc(nRecLen);
 
   /* -------------------------------------------------------------------- */
   /*  Read in Field Definitions                                           */
   /* -------------------------------------------------------------------- */
-  pabyBuf = (uchar *) SfRealloc(pabyBuf,nHeadLen);
-  psDBF->pszHeader = (char *) pabyBuf;
+  pabyBuf = (uchar *)SfRealloc(pabyBuf, nHeadLen);
+  psDBF->pszHeader = (char *)pabyBuf;
 
-  VSIFSeekL( psDBF->fp, 32, 0 );
-  if( VSIFReadL( pabyBuf, nHeadLen - 32, 1, psDBF->fp ) != 1 )
-  {
+  VSIFSeekL(psDBF->fp, 32, 0);
+  if (VSIFReadL(pabyBuf, nHeadLen - 32, 1, psDBF->fp) != 1) {
     msFree(psDBF->pszCurrentRecord);
-    VSIFCloseL( psDBF->fp );
+    VSIFCloseL(psDBF->fp);
     msFree(psDBF);
     msFree(pabyBuf);
-    return( NULL );
+    return (NULL);
   }
 
-  psDBF->panFieldOffset = (int *) msSmallMalloc(sizeof(int) * nFields);
-  psDBF->panFieldSize = (int *) msSmallMalloc(sizeof(int) * nFields);
-  psDBF->panFieldDecimals = (int *) msSmallMalloc(sizeof(int) * nFields);
-  psDBF->pachFieldType = (char *) msSmallMalloc(sizeof(char) * nFields);
+  psDBF->panFieldOffset = (int *)msSmallMalloc(sizeof(int) * nFields);
+  psDBF->panFieldSize = (int *)msSmallMalloc(sizeof(int) * nFields);
+  psDBF->panFieldDecimals = (int *)msSmallMalloc(sizeof(int) * nFields);
+  psDBF->pachFieldType = (char *)msSmallMalloc(sizeof(char) * nFields);
 
-  for( iField = 0; iField < nFields; iField++ ) {
-    uchar   *pabyFInfo;
+  for (iField = 0; iField < nFields; iField++) {
+    uchar *pabyFInfo;
 
-    pabyFInfo = pabyBuf+iField*32;
+    pabyFInfo = pabyBuf + iField * 32;
 
-    if( pabyFInfo[11] == 'N' || pabyFInfo[11] == 'F' ) {
+    if (pabyFInfo[11] == 'N' || pabyFInfo[11] == 'F') {
       psDBF->panFieldSize[iField] = pabyFInfo[16];
       psDBF->panFieldDecimals[iField] = pabyFInfo[17];
     } else {
-      psDBF->panFieldSize[iField] = pabyFInfo[16] + pabyFInfo[17]*256;
+      psDBF->panFieldSize[iField] = pabyFInfo[16] + pabyFInfo[17] * 256;
       psDBF->panFieldDecimals[iField] = 0;
     }
 
-    psDBF->pachFieldType[iField] = (char) pabyFInfo[11];
-    if( iField == 0 )
+    psDBF->pachFieldType[iField] = (char)pabyFInfo[11];
+    if (iField == 0)
       psDBF->panFieldOffset[iField] = 1;
     else
       psDBF->panFieldOffset[iField] =
-        psDBF->panFieldOffset[iField-1] + psDBF->panFieldSize[iField-1];
+          psDBF->panFieldOffset[iField - 1] + psDBF->panFieldSize[iField - 1];
   }
 
-  return( psDBF );
+  return (psDBF);
 }
 
 /************************************************************************/
@@ -224,45 +224,44 @@ DBFHandle msDBFOpenVirtualFile( VSILFILE
 /*                                                                      */
 /*      Open a .dbf file.                                               */
 /************************************************************************/
-DBFHandle msDBFOpen( const char * pszFilename, const char * pszAccess )
+DBFHandle msDBFOpen(const char *pszFilename, const char *pszAccess)
 
 {
   /* -------------------------------------------------------------------- */
   /*      We only allow the access strings "rb" and "r+".                 */
   /* -------------------------------------------------------------------- */
-  if( strcmp(pszAccess,"r") != 0 && strcmp(pszAccess,"r+") != 0
-      && strcmp(pszAccess,"rb") != 0 && strcmp(pszAccess,"r+b") != 0 )
-    return( NULL );
+  if (strcmp(pszAccess, "r") != 0 && strcmp(pszAccess, "r+") != 0 &&
+      strcmp(pszAccess, "rb") != 0 && strcmp(pszAccess, "r+b") != 0)
+    return (NULL);
 
   /* -------------------------------------------------------------------- */
   /*  Ensure the extension is converted to dbf or DBF if it is      */
   /*  currently .shp or .shx.               */
   /* -------------------------------------------------------------------- */
-  char *pszDBFFilename = (char *) msSmallMalloc(strlen(pszFilename)+1);
-  strcpy( pszDBFFilename, pszFilename );
+  char *pszDBFFilename = (char *)msSmallMalloc(strlen(pszFilename) + 1);
+  strcpy(pszDBFFilename, pszFilename);
 
-  if( strcmp(pszFilename+strlen(pszFilename)-4,".shp") == 0
-      || strcmp(pszFilename+strlen(pszFilename)-4,".shx") == 0 ) {
-    strcpy( pszDBFFilename+strlen(pszDBFFilename)-4, ".dbf");
-  } else if( strcmp(pszFilename+strlen(pszFilename)-4,".SHP") == 0
-             || strcmp(pszFilename+strlen(pszFilename)-4,".SHX") == 0 ) {
-    strcpy( pszDBFFilename+strlen(pszDBFFilename)-4, ".DBF");
+  if (strcmp(pszFilename + strlen(pszFilename) - 4, ".shp") == 0 ||
+      strcmp(pszFilename + strlen(pszFilename) - 4, ".shx") == 0) {
+    strcpy(pszDBFFilename + strlen(pszDBFFilename) - 4, ".dbf");
+  } else if (strcmp(pszFilename + strlen(pszFilename) - 4, ".SHP") == 0 ||
+             strcmp(pszFilename + strlen(pszFilename) - 4, ".SHX") == 0) {
+    strcpy(pszDBFFilename + strlen(pszDBFFilename) - 4, ".DBF");
   }
 
   /* -------------------------------------------------------------------- */
   /*      Open the file.                                                  */
   /* -------------------------------------------------------------------- */
-  VSILFILE *fp = VSIFOpenL( pszDBFFilename, pszAccess );
-  if( fp == NULL )
-  {
-    if( strcmp(pszDBFFilename+strlen(pszDBFFilename)-4,".dbf") == 0 ) {
-      strcpy( pszDBFFilename+strlen(pszDBFFilename)-4, ".DBF");
-      fp = VSIFOpenL( pszDBFFilename, pszAccess );
+  VSILFILE *fp = VSIFOpenL(pszDBFFilename, pszAccess);
+  if (fp == NULL) {
+    if (strcmp(pszDBFFilename + strlen(pszDBFFilename) - 4, ".dbf") == 0) {
+      strcpy(pszDBFFilename + strlen(pszDBFFilename) - 4, ".DBF");
+      fp = VSIFOpenL(pszDBFFilename, pszAccess);
     }
   }
   msFree(pszDBFFilename);
-  if( fp == NULL ) {
-    return( NULL );
+  if (fp == NULL) {
+    return (NULL);
   }
 
   return msDBFOpenVirtualFile(fp);
@@ -272,57 +271,56 @@ DBFHandle msDBFOpen( const char * pszFil
 /*                              msDBFClose()                            */
 /************************************************************************/
 
-void  msDBFClose(DBFHandle psDBF)
-{
+void msDBFClose(DBFHandle psDBF) {
   /* -------------------------------------------------------------------- */
   /*      Write out header if not already written.                        */
   /* -------------------------------------------------------------------- */
-  if( psDBF->bNoHeader )
-    writeHeader( psDBF );
+  if (psDBF->bNoHeader)
+    writeHeader(psDBF);
 
-  flushRecord( psDBF );
+  flushRecord(psDBF);
 
   /* -------------------------------------------------------------------- */
   /*      Update last access date, and number of records if we have       */
   /*  write access.                             */
   /* -------------------------------------------------------------------- */
-  if( psDBF->bUpdated ) {
-    uchar   abyFileHeader[32];
+  if (psDBF->bUpdated) {
+    uchar abyFileHeader[32];
 
-    VSIFSeekL( psDBF->fp, 0, 0 );
-    IGUR_sizet(VSIFReadL( abyFileHeader, 32, 1, psDBF->fp ));
+    VSIFSeekL(psDBF->fp, 0, 0);
+    IGUR_sizet(VSIFReadL(abyFileHeader, 32, 1, psDBF->fp));
 
-    abyFileHeader[1] = 95;      /* YY */
-    abyFileHeader[2] = 7;     /* MM */
-    abyFileHeader[3] = 26;      /* DD */
+    abyFileHeader[1] = 95; /* YY */
+    abyFileHeader[2] = 7;  /* MM */
+    abyFileHeader[3] = 26; /* DD */
 
     abyFileHeader[4] = psDBF->nRecords % 256;
-    abyFileHeader[5] = (psDBF->nRecords/256) % 256;
-    abyFileHeader[6] = (psDBF->nRecords/(256*256)) % 256;
-    abyFileHeader[7] = (psDBF->nRecords/(256*256*256)) % 256;
+    abyFileHeader[5] = (psDBF->nRecords / 256) % 256;
+    abyFileHeader[6] = (psDBF->nRecords / (256 * 256)) % 256;
+    abyFileHeader[7] = (psDBF->nRecords / (256 * 256 * 256)) % 256;
 
-    VSIFSeekL( psDBF->fp, 0, 0 );
-    VSIFWriteL( abyFileHeader, 32, 1, psDBF->fp );
+    VSIFSeekL(psDBF->fp, 0, 0);
+    VSIFWriteL(abyFileHeader, 32, 1, psDBF->fp);
   }
 
   /* -------------------------------------------------------------------- */
   /*      Close, and free resources.                                      */
   /* -------------------------------------------------------------------- */
-  VSIFCloseL( psDBF->fp );
+  VSIFCloseL(psDBF->fp);
 
-  if( psDBF->panFieldOffset != NULL ) {
-    free( psDBF->panFieldOffset );
-    free( psDBF->panFieldSize );
-    free( psDBF->panFieldDecimals );
-    free( psDBF->pachFieldType );
+  if (psDBF->panFieldOffset != NULL) {
+    free(psDBF->panFieldOffset);
+    free(psDBF->panFieldSize);
+    free(psDBF->panFieldDecimals);
+    free(psDBF->pachFieldType);
   }
 
-  free( psDBF->pszHeader );
-  free( psDBF->pszCurrentRecord );
+  free(psDBF->pszHeader);
+  free(psDBF->pszCurrentRecord);
 
   free(psDBF->pszStringField);
 
-  free( psDBF );
+  free(psDBF);
 }
 
 /************************************************************************/
@@ -330,36 +328,37 @@ void  msDBFClose(DBFHandle psDBF)
 /*                                                                      */
 /*      Create a new .dbf file.                                         */
 /************************************************************************/
-DBFHandle msDBFCreate( const char * pszFilename )
+DBFHandle msDBFCreate(const char *pszFilename)
 
 {
   DBFHandle psDBF;
-  VSILFILE  *fp;
+  VSILFILE *fp;
 
   /* -------------------------------------------------------------------- */
   /*      Create the file.                                                */
   /* -------------------------------------------------------------------- */
-  fp = VSIFOpenL( pszFilename, "wb" );
-  if( fp == NULL )
-    return( NULL );
+  fp = VSIFOpenL(pszFilename, "wb");
+  if (fp == NULL)
+    return (NULL);
 
   {
-      char ch = 0;
-      VSIFWriteL(&ch, 1, 1, fp);
+    char ch = 0;
+    VSIFWriteL(&ch, 1, 1, fp);
   }
-  VSIFCloseL( fp );
+  VSIFCloseL(fp);
 
-  fp = VSIFOpenL( pszFilename, "rb+" );
-  if( fp == NULL )
-    return( NULL );
+  fp = VSIFOpenL(pszFilename, "rb+");
+  if (fp == NULL)
+    return (NULL);
 
   /* -------------------------------------------------------------------- */
   /*  Create the info structure.                */
   /* -------------------------------------------------------------------- */
-  psDBF = (DBFHandle) malloc(sizeof(DBFInfo));
+  psDBF = (DBFHandle)malloc(sizeof(DBFInfo));
   if (psDBF == NULL) {
-    msSetError(MS_MEMERR, "%s: %d: Out of memory allocating %u bytes.\n", "msDBFCreate()",
-               __FILE__, __LINE__, (unsigned int)sizeof(DBFInfo));
+    msSetError(MS_MEMERR, "%s: %d: Out of memory allocating %u bytes.\n",
+               "msDBFCreate()", __FILE__, __LINE__,
+               (unsigned int)sizeof(DBFInfo));
     VSIFCloseL(fp);
     return NULL;
   }
@@ -386,7 +385,7 @@ DBFHandle msDBFCreate( const char * pszF
   psDBF->bNoHeader = MS_TRUE;
   psDBF->bUpdated = MS_FALSE;
 
-  return( psDBF );
+  return (psDBF);
 }
 
 /************************************************************************/
@@ -395,22 +394,22 @@ DBFHandle msDBFCreate( const char * pszF
 /*      Add a field to a newly created .dbf file before any records     */
 /*      are written.                                                    */
 /************************************************************************/
-int msDBFAddField(DBFHandle psDBF, const char * pszFieldName, DBFFieldType eType, int nWidth, int nDecimals )
-{
-  char  *pszFInfo;
-  int   i;
+int msDBFAddField(DBFHandle psDBF, const char *pszFieldName, DBFFieldType eType,
+                  int nWidth, int nDecimals) {
+  char *pszFInfo;
+  int i;
 
   /* -------------------------------------------------------------------- */
   /*      Do some checking to ensure we can add records to this file.     */
   /* -------------------------------------------------------------------- */
-  if( psDBF->nRecords > 0 )
-    return( MS_FALSE );
+  if (psDBF->nRecords > 0)
+    return (MS_FALSE);
 
-  if( !psDBF->bNoHeader )
-    return( MS_FALSE );
+  if (!psDBF->bNoHeader)
+    return (MS_FALSE);
 
-  if( eType != FTDouble && nDecimals != 0 )
-    return( MS_FALSE );
+  if (eType != FTDouble && nDecimals != 0)
+    return (MS_FALSE);
 
   /* -------------------------------------------------------------------- */
   /*      SfRealloc all the arrays larger to hold the additional field    */
@@ -418,30 +417,30 @@ int msDBFAddField(DBFHandle psDBF, const
   /* -------------------------------------------------------------------- */
   psDBF->nFields++;
 
-  psDBF->panFieldOffset = (int *)
-                          SfRealloc( psDBF->panFieldOffset, sizeof(int) * psDBF->nFields );
+  psDBF->panFieldOffset =
+      (int *)SfRealloc(psDBF->panFieldOffset, sizeof(int) * psDBF->nFields);
 
-  psDBF->panFieldSize = (int *)
-                        SfRealloc( psDBF->panFieldSize, sizeof(int) * psDBF->nFields );
+  psDBF->panFieldSize =
+      (int *)SfRealloc(psDBF->panFieldSize, sizeof(int) * psDBF->nFields);
 
-  psDBF->panFieldDecimals = (int *)
-                            SfRealloc( psDBF->panFieldDecimals, sizeof(int) * psDBF->nFields );
+  psDBF->panFieldDecimals =
+      (int *)SfRealloc(psDBF->panFieldDecimals, sizeof(int) * psDBF->nFields);
 
-  psDBF->pachFieldType = (char *)
-                         SfRealloc( psDBF->pachFieldType, sizeof(char) * psDBF->nFields );
+  psDBF->pachFieldType =
+      (char *)SfRealloc(psDBF->pachFieldType, sizeof(char) * psDBF->nFields);
 
   /* -------------------------------------------------------------------- */
   /*      Assign the new field information fields.                        */
   /* -------------------------------------------------------------------- */
-  psDBF->panFieldOffset[psDBF->nFields-1] = psDBF->nRecordLength;
+  psDBF->panFieldOffset[psDBF->nFields - 1] = psDBF->nRecordLength;
   psDBF->nRecordLength += nWidth;
-  psDBF->panFieldSize[psDBF->nFields-1] = nWidth;
-  psDBF->panFieldDecimals[psDBF->nFields-1] = nDecimals;
+  psDBF->panFieldSize[psDBF->nFields - 1] = nWidth;
+  psDBF->panFieldDecimals[psDBF->nFields - 1] = nDecimals;
 
-  if( eType == FTString )
-    psDBF->pachFieldType[psDBF->nFields-1] = 'C';
+  if (eType == FTString)
+    psDBF->pachFieldType[psDBF->nFields - 1] = 'C';
   else
-    psDBF->pachFieldType[psDBF->nFields-1] = 'N';
+    psDBF->pachFieldType[psDBF->nFields - 1] = 'N';
 
   /* -------------------------------------------------------------------- */
   /*      Extend the required header information.                         */
@@ -449,18 +448,18 @@ int msDBFAddField(DBFHandle psDBF, const
   psDBF->nHeaderLength += 32;
   psDBF->bUpdated = MS_FALSE;
 
-  psDBF->pszHeader = (char *) SfRealloc(psDBF->pszHeader,psDBF->nFields*32);
+  psDBF->pszHeader = (char *)SfRealloc(psDBF->pszHeader, psDBF->nFields * 32);
 
-  pszFInfo = psDBF->pszHeader + 32 * (psDBF->nFields-1);
+  pszFInfo = psDBF->pszHeader + 32 * (psDBF->nFields - 1);
 
-  for( i = 0; i < 32; i++ )
+  for (i = 0; i < 32; i++)
     pszFInfo[i] = '\0';
 
-  strncpy( pszFInfo, pszFieldName, 10);
+  strncpy(pszFInfo, pszFieldName, 10);
 
-  pszFInfo[11] = psDBF->pachFieldType[psDBF->nFields-1];
+  pszFInfo[11] = psDBF->pachFieldType[psDBF->nFields - 1];
 
-  if( eType == FTString ) {
+  if (eType == FTString) {
     pszFInfo[16] = nWidth % 256;
     pszFInfo[17] = nWidth / 256;
   } else {
@@ -471,10 +470,10 @@ int msDBFAddField(DBFHandle psDBF, const
   /* -------------------------------------------------------------------- */
   /*      Make the current record buffer appropriately larger.            */
   /* -------------------------------------------------------------------- */
-  psDBF->pszCurrentRecord = (char *) SfRealloc(psDBF->pszCurrentRecord,
-                            psDBF->nRecordLength);
+  psDBF->pszCurrentRecord =
+      (char *)SfRealloc(psDBF->pszCurrentRecord, psDBF->nRecordLength);
 
-  return( psDBF->nFields-1 );
+  return (psDBF->nFields - 1);
 }
 
 /************************************************************************/
@@ -485,26 +484,26 @@ int msDBFAddField(DBFHandle psDBF, const
 /*      Based on DBFIsAttributeNULL of shapelib                         */
 /************************************************************************/
 
-static int DBFIsValueNULL( const char* pszValue, char type )
+static int DBFIsValueNULL(const char *pszValue, char type)
 
 {
-  switch(type) {
-    case 'N':
-    case 'F':
-      /* NULL numeric fields have value "****************" */
-      return pszValue[0] == '*';
-
-    case 'D':
-      /* NULL date fields have value "00000000" */
-      return strncmp(pszValue,"00000000",8) == 0;
-
-    case 'L':
-      /* NULL boolean fields have value "?" */
-      return pszValue[0] == '?';
-
-    default:
-      /* empty string fields are considered NULL */
-      return strlen(pszValue) == 0;
+  switch (type) {
+  case 'N':
+  case 'F':
+    /* NULL numeric fields have value "****************" */
+    return pszValue[0] == '*';
+
+  case 'D':
+    /* NULL date fields have value "00000000" */
+    return strncmp(pszValue, "00000000", 8) == 0;
+
+  case 'L':
+    /* NULL boolean fields have value "?" */
+    return pszValue[0] == '?';
+
+  default:
+    /* empty string fields are considered NULL */
+    return strlen(pszValue) == 0;
   }
 }
 
@@ -513,93 +512,104 @@ static int DBFIsValueNULL( const char* p
 /*                                                                      */
 /*      Read one of the attribute fields of a record.                   */
 /************************************************************************/
-static const char *msDBFReadAttribute(DBFHandle psDBF, int hEntity, int iField )
+static const char *msDBFReadAttribute(DBFHandle psDBF, int hEntity, int iField)
 
 {
-  int         i;
+  int i;
   unsigned int nRecordOffset;
   const uchar *pabyRec;
-  const char  *pReturnField = NULL;
+  const char *pReturnField = NULL;
 
   /* -------------------------------------------------------------------- */
   /*  Is the request valid?                             */
   /* -------------------------------------------------------------------- */
-  if( iField < 0 || iField >= psDBF->nFields ) {
-    msSetError(MS_DBFERR, "Invalid field index %d.", "msDBFReadAttribute()",iField );
-    return( NULL );
+  if (iField < 0 || iField >= psDBF->nFields) {
+    msSetError(MS_DBFERR, "Invalid field index %d.", "msDBFReadAttribute()",
+               iField);
+    return (NULL);
   }
 
-  if( hEntity < 0 || hEntity >= psDBF->nRecords ) {
-    msSetError(MS_DBFERR, "Invalid record number %d.", "msDBFReadAttribute()",hEntity );
-    return( NULL );
+  if (hEntity < 0 || hEntity >= psDBF->nRecords) {
+    msSetError(MS_DBFERR, "Invalid record number %d.", "msDBFReadAttribute()",
+               hEntity);
+    return (NULL);
   }
 
   /* -------------------------------------------------------------------- */
   /*  Have we read the record?              */
   /* -------------------------------------------------------------------- */
-  if( psDBF->nCurrentRecord != hEntity ) {
-    flushRecord( psDBF );
+  if (psDBF->nCurrentRecord != hEntity) {
+    flushRecord(psDBF);
 
     nRecordOffset = psDBF->nRecordLength * hEntity + psDBF->nHeaderLength;
 
-    VSIFSeekL( psDBF->fp, nRecordOffset, 0 );
-    if( VSIFReadL( psDBF->pszCurrentRecord, psDBF->nRecordLength, 1, psDBF->fp ) != 1 )
-    {
-      msSetError(MS_DBFERR, "Cannot read record %d.", "msDBFReadAttribute()",hEntity );
-      return( NULL );
+    VSIFSeekL(psDBF->fp, nRecordOffset, 0);
+    if (VSIFReadL(psDBF->pszCurrentRecord, psDBF->nRecordLength, 1,
+                  psDBF->fp) != 1) {
+      msSetError(MS_DBFERR, "Cannot read record %d.", "msDBFReadAttribute()",
+                 hEntity);
+      return (NULL);
     }
 
     psDBF->nCurrentRecord = hEntity;
   }
 
-  pabyRec = (const uchar *) psDBF->pszCurrentRecord;
+  pabyRec = (const uchar *)psDBF->pszCurrentRecord;
   /* DEBUG */
   /* printf("CurrentRecord(%c):%s\n", psDBF->pachFieldType[iField], pabyRec); */
 
   /* -------------------------------------------------------------------- */
   /*  Ensure our field buffer is large enough to hold this buffer.      */
   /* -------------------------------------------------------------------- */
-  if( psDBF->panFieldSize[iField]+1 > psDBF->nStringFieldLen ) {
-    psDBF->nStringFieldLen = psDBF->panFieldSize[iField]*2 + 10;
-    psDBF->pszStringField = (char *) SfRealloc(psDBF->pszStringField,psDBF->nStringFieldLen);
+  if (psDBF->panFieldSize[iField] + 1 > psDBF->nStringFieldLen) {
+    psDBF->nStringFieldLen = psDBF->panFieldSize[iField] * 2 + 10;
+    psDBF->pszStringField =
+        (char *)SfRealloc(psDBF->pszStringField, psDBF->nStringFieldLen);
   }
 
   /* -------------------------------------------------------------------- */
   /*  Extract the requested field.              */
   /* -------------------------------------------------------------------- */
-  strncpy( psDBF->pszStringField,(const char *) pabyRec+psDBF->panFieldOffset[iField], psDBF->panFieldSize[iField] );
+  strncpy(psDBF->pszStringField,
+          (const char *)pabyRec + psDBF->panFieldOffset[iField],
+          psDBF->panFieldSize[iField]);
   psDBF->pszStringField[psDBF->panFieldSize[iField]] = '\0';
 
   /*
   ** Trim trailing blanks (SDL Modification)
   */
-  for(i=strlen(psDBF->pszStringField)-1; i>=0; i--) {
-    if(psDBF->pszStringField[i] != ' ') {
-      psDBF->pszStringField[i+1] = '\0';
+  for (i = strlen(psDBF->pszStringField) - 1; i >= 0; i--) {
+    if (psDBF->pszStringField[i] != ' ') {
+      psDBF->pszStringField[i + 1] = '\0';
       break;
     }
   }
 
-  if(i == -1) psDBF->pszStringField[0] = '\0'; /* whole string is blank (SDL fix)       */
+  if (i == -1)
+    psDBF->pszStringField[0] = '\0'; /* whole string is blank (SDL fix)       */
 
   /*
   ** Trim/skip leading blanks (SDL/DM Modification - only on numeric types)
   */
-  if( psDBF->pachFieldType[iField] == 'N' || psDBF->pachFieldType[iField] == 'F' || psDBF->pachFieldType[iField] == 'D' ) {
-    for(i=0; psDBF->pszStringField[i] != '\0' ; i++) {
-      if(psDBF->pszStringField[i] != ' ')
+  if (psDBF->pachFieldType[iField] == 'N' ||
+      psDBF->pachFieldType[iField] == 'F' ||
+      psDBF->pachFieldType[iField] == 'D') {
+    for (i = 0; psDBF->pszStringField[i] != '\0'; i++) {
+      if (psDBF->pszStringField[i] != ' ')
         break;
     }
-    pReturnField = psDBF->pszStringField+i;
+    pReturnField = psDBF->pszStringField + i;
   } else
     pReturnField = psDBF->pszStringField;
 
   /*  detect null values */
-  if ( DBFIsValueNULL( pReturnField, psDBF->pachFieldType[iField] )  ) {
-    if (psDBF->pachFieldType[iField] == 'N' || psDBF->pachFieldType[iField] == 'F' || psDBF->pachFieldType[iField] == 'D')
-      pReturnField="0";
+  if (DBFIsValueNULL(pReturnField, psDBF->pachFieldType[iField])) {
+    if (psDBF->pachFieldType[iField] == 'N' ||
+        psDBF->pachFieldType[iField] == 'F' ||
+        psDBF->pachFieldType[iField] == 'D')
+      pReturnField = "0";
   }
-  return( pReturnField );
+  return (pReturnField);
 }
 
 /************************************************************************/
@@ -607,10 +617,10 @@ static const char *msDBFReadAttribute(DB
 /*                                                                      */
 /*      Read an integer attribute.                                      */
 /************************************************************************/
-int msDBFReadIntegerAttribute( DBFHandle psDBF, int iRecord, int iField )
+int msDBFReadIntegerAttribute(DBFHandle psDBF, int iRecord, int iField)
 
 {
-  return(atoi(msDBFReadAttribute( psDBF, iRecord, iField )));
+  return (atoi(msDBFReadAttribute(psDBF, iRecord, iField)));
 }
 
 /************************************************************************/
@@ -618,9 +628,8 @@ int msDBFReadIntegerAttribute( DBFHandle
 /*                                                                      */
 /*      Read a double attribute.                                        */
 /************************************************************************/
-double  msDBFReadDoubleAttribute( DBFHandle psDBF, int iRecord, int iField )
-{
-  return(atof(msDBFReadAttribute( psDBF, iRecord, iField )));
+double msDBFReadDoubleAttribute(DBFHandle psDBF, int iRecord, int iField) {
+  return (atof(msDBFReadAttribute(psDBF, iRecord, iField)));
 }
 
 /************************************************************************/
@@ -628,9 +637,8 @@ double  msDBFReadDoubleAttribute( DBFHan
 /*                                                                      */
 /*      Read a string attribute.                                        */
 /************************************************************************/
-const char *msDBFReadStringAttribute( DBFHandle psDBF, int iRecord, int iField )
-{
-  return( msDBFReadAttribute( psDBF, iRecord, iField ) );
+const char *msDBFReadStringAttribute(DBFHandle psDBF, int iRecord, int iField) {
+  return (msDBFReadAttribute(psDBF, iRecord, iField));
 }
 
 /************************************************************************/
@@ -638,55 +646,49 @@ const char *msDBFReadStringAttribute( DB
 /*                                                                      */
 /*      Return the number of fields in this table.                      */
 /************************************************************************/
-int msDBFGetFieldCount( DBFHandle psDBF )
-{
-  return( psDBF->nFields );
-}
+int msDBFGetFieldCount(DBFHandle psDBF) { return (psDBF->nFields); }
 
 /************************************************************************/
 /*                         msDBFGetRecordCount()                        */
 /*                                                                      */
 /*      Return the number of records in this table.                     */
 /************************************************************************/
-int msDBFGetRecordCount( DBFHandle psDBF )
-{
-  return( psDBF->nRecords );
-}
+int msDBFGetRecordCount(DBFHandle psDBF) { return (psDBF->nRecords); }
 
 /************************************************************************/
 /*                          msDBFGetFieldInfo()                         */
 /*                                                                      */
 /*      Return any requested information about the field.               */
 /************************************************************************/
-DBFFieldType msDBFGetFieldInfo( DBFHandle psDBF, int iField, char * pszFieldName, int * pnWidth, int * pnDecimals )
-{
-  if( iField < 0 || iField >= psDBF->nFields )
-    return( FTInvalid );
+DBFFieldType msDBFGetFieldInfo(DBFHandle psDBF, int iField, char *pszFieldName,
+                               int *pnWidth, int *pnDecimals) {
+  if (iField < 0 || iField >= psDBF->nFields)
+    return (FTInvalid);
 
-  if( pnWidth != NULL )
+  if (pnWidth != NULL)
     *pnWidth = psDBF->panFieldSize[iField];
 
-  if( pnDecimals != NULL )
+  if (pnDecimals != NULL)
     *pnDecimals = psDBF->panFieldDecimals[iField];
 
-  if( pszFieldName != NULL ) {
+  if (pszFieldName != NULL) {
     int i;
 
-    strncpy( pszFieldName, (char *) psDBF->pszHeader+iField*32, 11 );
+    strncpy(pszFieldName, (char *)psDBF->pszHeader + iField * 32, 11);
     pszFieldName[11] = '\0';
-    for( i = 10; i > 0 && pszFieldName[i] == ' '; i-- )
+    for (i = 10; i > 0 && pszFieldName[i] == ' '; i--)
       pszFieldName[i] = '\0';
   }
 
-  if( psDBF->pachFieldType[iField] == 'N'
-      || psDBF->pachFieldType[iField] == 'F'
-      || psDBF->pachFieldType[iField] == 'D' ) {
-    if( psDBF->panFieldDecimals[iField] > 0 )
-      return( FTDouble );
+  if (psDBF->pachFieldType[iField] == 'N' ||
+      psDBF->pachFieldType[iField] == 'F' ||
+      psDBF->pachFieldType[iField] == 'D') {
+    if (psDBF->panFieldDecimals[iField] > 0)
+      return (FTDouble);
     else
-      return( FTInteger );
+      return (FTInteger);
   } else {
-    return( FTString );
+    return (FTString);
   }
 }
 
@@ -695,30 +697,30 @@ DBFFieldType msDBFGetFieldInfo( DBFHandl
 /*                  */
 /*  Write an attribute record to the file.        */
 /************************************************************************/
-static int msDBFWriteAttribute(DBFHandle psDBF, int hEntity, int iField, void * pValue )
-{
-  unsigned int          nRecordOffset;
-  int  len;
+static int msDBFWriteAttribute(DBFHandle psDBF, int hEntity, int iField,
+                               void *pValue) {
+  unsigned int nRecordOffset;
+  int len;
   uchar *pabyRec;
-  char  szSField[40];
+  char szSField[40];
 
   /* -------------------------------------------------------------------- */
   /*  Is this a valid record?             */
   /* -------------------------------------------------------------------- */
-  if( hEntity < 0 || hEntity > psDBF->nRecords )
-    return( MS_FALSE );
+  if (hEntity < 0 || hEntity > psDBF->nRecords)
+    return (MS_FALSE);
 
-  if( psDBF->bNoHeader )
+  if (psDBF->bNoHeader)
     writeHeader(psDBF);
 
   /* -------------------------------------------------------------------- */
   /*      Is this a brand new record?                                     */
   /* -------------------------------------------------------------------- */
-  if( hEntity == psDBF->nRecords ) {
-    flushRecord( psDBF );
+  if (hEntity == psDBF->nRecords) {
+    flushRecord(psDBF);
 
     psDBF->nRecords++;
-    for( unsigned i = 0; i < psDBF->nRecordLength; i++ )
+    for (unsigned i = 0; i < psDBF->nRecordLength; i++)
       psDBF->pszCurrentRecord[i] = ' ';
 
     psDBF->nCurrentRecord = hEntity;
@@ -728,42 +730,46 @@ static int msDBFWriteAttribute(DBFHandle
   /*      Is this an existing record, but different than the last one     */
   /*      we accessed?                                                    */
   /* -------------------------------------------------------------------- */
-  if( psDBF->nCurrentRecord != hEntity ) {
-    flushRecord( psDBF );
+  if (psDBF->nCurrentRecord != hEntity) {
+    flushRecord(psDBF);
 
     nRecordOffset = psDBF->nRecordLength * hEntity + psDBF->nHeaderLength;
 
-    VSIFSeekL( psDBF->fp, nRecordOffset, 0 );
-    if( VSIFReadL( psDBF->pszCurrentRecord, psDBF->nRecordLength, 1, psDBF->fp ) != 1 )
+    VSIFSeekL(psDBF->fp, nRecordOffset, 0);
+    if (VSIFReadL(psDBF->pszCurrentRecord, psDBF->nRecordLength, 1,
+                  psDBF->fp) != 1)
       return MS_FALSE;
 
     psDBF->nCurrentRecord = hEntity;
   }
 
-  pabyRec = (uchar *) psDBF->pszCurrentRecord;
+  pabyRec = (uchar *)psDBF->pszCurrentRecord;
 
   /* -------------------------------------------------------------------- */
   /*      Assign all the record fields.                                   */
   /* -------------------------------------------------------------------- */
-  switch( psDBF->pachFieldType[iField] ) {
-    case 'D':
-    case 'N':
-    case 'F':
-      snprintf(szSField, sizeof(szSField), "%*.*f", psDBF->panFieldSize[iField], psDBF->panFieldDecimals[iField], *(double*) pValue); 
-      len = strlen((char *) szSField);
-      memcpy(pabyRec+psDBF->panFieldOffset[iField], szSField, MS_MIN(len, psDBF->panFieldSize[iField]));
-      break;
-
-    default:
-      len = strlen((char *) pValue);
-      memcpy(pabyRec+psDBF->panFieldOffset[iField], pValue, MS_MIN(len, psDBF->panFieldSize[iField]));
-      break;
+  switch (psDBF->pachFieldType[iField]) {
+  case 'D':
+  case 'N':
+  case 'F':
+    snprintf(szSField, sizeof(szSField), "%*.*f", psDBF->panFieldSize[iField],
+             psDBF->panFieldDecimals[iField], *(double *)pValue);
+    len = strlen((char *)szSField);
+    memcpy(pabyRec + psDBF->panFieldOffset[iField], szSField,
+           MS_MIN(len, psDBF->panFieldSize[iField]));
+    break;
+
+  default:
+    len = strlen((char *)pValue);
+    memcpy(pabyRec + psDBF->panFieldOffset[iField], pValue,
+           MS_MIN(len, psDBF->panFieldSize[iField]));
+    break;
   }
 
   psDBF->bCurrentRecordModified = MS_TRUE;
   psDBF->bUpdated = MS_TRUE;
 
-  return( MS_TRUE );
+  return (MS_TRUE);
 }
 
 /************************************************************************/
@@ -771,9 +777,9 @@ static int msDBFWriteAttribute(DBFHandle
 /*                                                                      */
 /*      Write a double attribute.                                       */
 /************************************************************************/
-int msDBFWriteDoubleAttribute( DBFHandle psDBF, int iRecord, int iField, double dValue )
-{
-  return( msDBFWriteAttribute( psDBF, iRecord, iField, (void *) &dValue ) );
+int msDBFWriteDoubleAttribute(DBFHandle psDBF, int iRecord, int iField,
+                              double dValue) {
+  return (msDBFWriteAttribute(psDBF, iRecord, iField, (void *)&dValue));
 }
 
 /************************************************************************/
@@ -782,11 +788,11 @@ int msDBFWriteDoubleAttribute( DBFHandle
 /*      Write a integer attribute.                                      */
 /************************************************************************/
 
-int msDBFWriteIntegerAttribute( DBFHandle psDBF, int iRecord, int iField, int nValue )
-{
-  double  dValue = nValue;
+int msDBFWriteIntegerAttribute(DBFHandle psDBF, int iRecord, int iField,
+                               int nValue) {
+  double dValue = nValue;
 
-  return( msDBFWriteAttribute( psDBF, iRecord, iField, (void *) &dValue ) );
+  return (msDBFWriteAttribute(psDBF, iRecord, iField, (void *)&dValue));
 }
 
 /************************************************************************/
@@ -794,115 +800,113 @@ int msDBFWriteIntegerAttribute( DBFHandl
 /*                                                                      */
 /*      Write a string attribute.                                       */
 /************************************************************************/
-int msDBFWriteStringAttribute( DBFHandle psDBF, int iRecord, int iField, const char * pszValue )
-{
-  return( msDBFWriteAttribute( psDBF, iRecord, iField, (void *) pszValue ) );
+int msDBFWriteStringAttribute(DBFHandle psDBF, int iRecord, int iField,
+                              const char *pszValue) {
+  return (msDBFWriteAttribute(psDBF, iRecord, iField, (void *)pszValue));
 }
 
 /*
 ** Which column number in the .DBF file does the item correspond to
 */
-int msDBFGetItemIndex(DBFHandle dbffile, char *name)
-{
+int msDBFGetItemIndex(DBFHandle dbffile, char *name) {
   int i;
-  int fWidth,fnDecimals; /* field width and number of decimals */
-  char fName[32]; /* field name */
+  int fWidth, fnDecimals; /* field width and number of decimals */
+  char fName[32];         /* field name */
 
-  if(!name) {
+  if (!name) {
     msSetError(MS_MISCERR, "NULL item name passed.", "msGetItemIndex()");
-    return(-1);
+    return (-1);
   }
 
   /* does name exist as a field? */
-  for(i=0; i<msDBFGetFieldCount(dbffile); i++) {
-    msDBFGetFieldInfo(dbffile,i,fName,&fWidth,&fnDecimals);
-    if(strcasecmp(name,fName) == 0) /* found it */
-      return(i);
+  for (i = 0; i < msDBFGetFieldCount(dbffile); i++) {
+    msDBFGetFieldInfo(dbffile, i, fName, &fWidth, &fnDecimals);
+    if (strcasecmp(name, fName) == 0) /* found it */
+      return (i);
   }
 
-  msSetError(MS_DBFERR, "Item '%s' not found.", "msDBFGetItemIndex()",name);
-  return(-1); /* item not found */
+  msSetError(MS_DBFERR, "Item '%s' not found.", "msDBFGetItemIndex()", name);
+  return (-1); /* item not found */
 }
 
 /*
 ** Load item names into a character array
 */
-char **msDBFGetItems(DBFHandle dbffile)
-{
+char **msDBFGetItems(DBFHandle dbffile) {
   char **items;
   int i, nFields;
   char fName[32];
 
-  if((nFields = msDBFGetFieldCount(dbffile)) == 0) {
+  if ((nFields = msDBFGetFieldCount(dbffile)) == 0) {
     msSetError(MS_DBFERR, "File contains no data.", "msGetDBFItems()");
-    return(NULL);
+    return (NULL);
   }
 
-  items = (char **)malloc(sizeof(char *)*nFields);
-  MS_CHECK_ALLOC(items, sizeof(char *)*nFields, NULL);
+  items = (char **)malloc(sizeof(char *) * nFields);
+  MS_CHECK_ALLOC(items, sizeof(char *) * nFields, NULL);
 
-  for(i=0; i<nFields; i++) {
+  for (i = 0; i < nFields; i++) {
     msDBFGetFieldInfo(dbffile, i, fName, NULL, NULL);
     items[i] = msStrdup(fName);
   }
 
-  return(items);
+  return (items);
 }
 
 /*
 ** Load item values into a character array
 */
-char **msDBFGetValues(DBFHandle dbffile, int record)
-{
+char **msDBFGetValues(DBFHandle dbffile, int record) {
   char **values;
   int i, nFields;
 
-  if((nFields = msDBFGetFieldCount(dbffile)) == 0) {
+  if ((nFields = msDBFGetFieldCount(dbffile)) == 0) {
     msSetError(MS_DBFERR, "File contains no data.", "msGetDBFValues()");
-    return(NULL);
+    return (NULL);
   }
 
-  values = (char **)malloc(sizeof(char *)*nFields);
-  MS_CHECK_ALLOC(values, sizeof(char *)*nFields, NULL);
+  values = (char **)malloc(sizeof(char *) * nFields);
+  MS_CHECK_ALLOC(values, sizeof(char *) * nFields, NULL);
 
-  for(i=0; i<nFields; i++)
+  for (i = 0; i < nFields; i++)
     values[i] = msStrdup(msDBFReadStringAttribute(dbffile, record, i));
 
-  return(values);
+  return (values);
 }
 
-int *msDBFGetItemIndexes(DBFHandle dbffile, char **items, int numitems)
-{
-  int *itemindexes=NULL, i;
+int *msDBFGetItemIndexes(DBFHandle dbffile, char **items, int numitems) {
+  int *itemindexes = NULL, i;
 
-  if(numitems == 0) return(NULL);
+  if (numitems == 0)
+    return (NULL);
 
-  itemindexes = (int *)malloc(sizeof(int)*numitems);
-  MS_CHECK_ALLOC(itemindexes, sizeof(int)*numitems, NULL);
+  itemindexes = (int *)malloc(sizeof(int) * numitems);
+  MS_CHECK_ALLOC(itemindexes, sizeof(int) * numitems, NULL);
 
-  for(i=0; i<numitems; i++) {
+  for (i = 0; i < numitems; i++) {
     itemindexes[i] = msDBFGetItemIndex(dbffile, items[i]);
-    if(itemindexes[i] == -1) {
+    if (itemindexes[i] == -1) {
       free(itemindexes);
-      return(NULL); /* item not found */
+      return (NULL); /* item not found */
     }
   }
 
-  return(itemindexes);
+  return (itemindexes);
 }
 
-char **msDBFGetValueList(DBFHandle dbffile, int record, int *itemindexes, int numitems)
-{
+char **msDBFGetValueList(DBFHandle dbffile, int record, int *itemindexes,
+                         int numitems) {
   const char *value;
-  char **values=NULL;
+  char **values = NULL;
   int i;
 
-  if(numitems == 0) return(NULL);
+  if (numitems == 0)
+    return (NULL);
 
-  values = (char **)malloc(sizeof(char *)*numitems);
-  MS_CHECK_ALLOC(values, sizeof(char *)*numitems, NULL);
+  values = (char **)malloc(sizeof(char *) * numitems);
+  MS_CHECK_ALLOC(values, sizeof(char *) * numitems, NULL);
 
-  for(i=0; i<numitems; i++) {
+  for (i = 0; i < numitems; i++) {
     value = msDBFReadStringAttribute(dbffile, record, itemindexes[i]);
     if (value == NULL) {
       free(values);
@@ -911,5 +915,5 @@ char **msDBFGetValueList(DBFHandle dbffi
     values[i] = msStrdup(value);
   }
 
-  return(values);
+  return (values);
 }
diff -pruN 8.0.1-5/mapxml.c 8.0.2-1/mapxml.c
--- 8.0.1-5/mapxml.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapxml.c	2024-06-11 20:41:34.000000000 +0000
@@ -39,8 +39,8 @@
 
 extern int xmlLoadExtDtdDefaultValue;
 
-int msTransformXmlMapfile(const char *stylesheet, const char *xmlMapfile, FILE *tmpfile)
-{
+int msTransformXmlMapfile(const char *stylesheet, const char *xmlMapfile,
+                          FILE *tmpfile) {
   xsltStylesheetPtr cur = NULL;
   int status = MS_FAILURE;
   xmlDocPtr doc = NULL, res = NULL;
@@ -48,29 +48,29 @@ int msTransformXmlMapfile(const char *st
   exsltRegisterAll();
   xsltRegisterTestModule();
 
-  xmlSubstituteEntitiesDefault(1);
-  xmlLoadExtDtdDefaultValue = 1;
-
   cur = xsltParseStylesheetFile((const xmlChar *)stylesheet);
   if (cur == NULL) {
-    msSetError(MS_MISCERR, "Failed to load xslt stylesheet", "msTransformXmlMapfile()");
+    msSetError(MS_MISCERR, "Failed to load xslt stylesheet",
+               "msTransformXmlMapfile()");
     goto done;
   }
 
-  doc = xmlParseFile(xmlMapfile);
+  doc = xmlReadFile(xmlMapfile, NULL, XML_PARSE_NOENT | XML_PARSE_DTDLOAD);
   if (doc == NULL) {
-    msSetError(MS_MISCERR, "Failed to load xml mapfile", "msTransformXmlMapfile()");
+    msSetError(MS_MISCERR, "Failed to load xml mapfile",
+               "msTransformXmlMapfile()");
     goto done;
   }
 
   res = xsltApplyStylesheet(cur, doc, NULL);
   if (res == NULL) {
-    msSetError(MS_MISCERR, "Failed to apply style sheet to %s", "msTransformXmlMapfile()", xmlMapfile);
+    msSetError(MS_MISCERR, "Failed to apply style sheet to %s",
+               "msTransformXmlMapfile()", xmlMapfile);
     goto done;
   }
 
-  if ( xsltSaveResultToFile(tmpfile, res, cur) != -1 )
-    status =  MS_SUCCESS;
+  if (xsltSaveResultToFile(tmpfile, res, cur) != -1)
+    status = MS_SUCCESS;
 
 done:
   if (cur)
diff -pruN 8.0.1-5/mapxmp.c 8.0.2-1/mapxmp.c
--- 8.0.1-5/mapxmp.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/mapxmp.c	2024-06-11 20:41:34.000000000 +0000
@@ -29,7 +29,6 @@
 
 #include "mapserver.h"
 
-
 #ifdef USE_EXEMPI
 
 /* To pull parts out of hash keys */
@@ -40,34 +39,32 @@
 #include <xmpconsts.h>
 
 /**
-* Get standard Exempi namespace URI for a given namespace string
-*/
-static const char*
-msXmpUri(char *ns_name)
-{
+ * Get standard Exempi namespace URI for a given namespace string
+ */
+static const char *msXmpUri(char *ns_name) {
   /* Creative Commons */
-  if( strcmp(ns_name, "cc") == 0 )
+  if (strcmp(ns_name, "cc") == 0)
     return NS_CC;
   /* Dublin Core */
-  else if( strcmp(ns_name, "dc") == 0 )
+  else if (strcmp(ns_name, "dc") == 0)
     return NS_DC;
   /* XMP Meta */
-  else if( strcmp(ns_name, "meta") == 0 )
+  else if (strcmp(ns_name, "meta") == 0)
     return NS_XMP_META;
   /* XMP Rights */
-  else if( strcmp(ns_name, "rights") == 0 )
+  else if (strcmp(ns_name, "rights") == 0)
     return NS_XAP_RIGHTS;
   /* EXIF */
-  else if( strcmp(ns_name, "exif") == 0 )
+  else if (strcmp(ns_name, "exif") == 0)
     return NS_EXIF;
   /* TIFF */
-  else if( strcmp(ns_name, "tiff") == 0 )
+  else if (strcmp(ns_name, "tiff") == 0)
     return NS_TIFF;
   /* Photoshop Camera Raw Schema */
-  else if( strcmp(ns_name, "crs") == 0 )
+  else if (strcmp(ns_name, "crs") == 0)
     return NS_CAMERA_RAW_SETTINGS;
   /* Photoshop */
-  else if( strcmp(ns_name, "photoshop") == 0 )
+  else if (strcmp(ns_name, "photoshop") == 0)
     return NS_PHOTOSHOP;
   else
     return NULL;
@@ -76,11 +73,9 @@ msXmpUri(char *ns_name)
 #endif
 
 /**
-* Is there any XMP metadata in the map file for us to worry about?
-*/
-int
-msXmpPresent( mapObj *map )
-{
+ * Is there any XMP metadata in the map file for us to worry about?
+ */
+int msXmpPresent(mapObj *map) {
 #ifdef USE_EXEMPI
 
   /* Read the WEB.METADATA */
@@ -92,16 +87,16 @@ msXmpPresent( mapObj *map )
   key = msFirstKeyFromHashTable(&hash_metadata);
 
   /* No first key? No license info. */
-  if ( ! key )
+  if (!key)
     return MS_FALSE;
 
   do {
     /* Found one! Break out and return true */
-    if ( strcasestr(key, "xmp_") == key ) {
+    if (strcasestr(key, "xmp_") == key) {
       rv = MS_TRUE;
       break;
     }
-  } while( (key = msNextKeyFromHashTable(&hash_metadata, key)) );
+  } while ((key = msNextKeyFromHashTable(&hash_metadata, key)));
 
   return rv;
 
@@ -110,20 +105,18 @@ msXmpPresent( mapObj *map )
 #endif
 }
 
-
 /**
-* Is there any XMP metadata in the map file for us to worry about?
-*/
-int
-msXmpWrite( mapObj *map, const char *filename )
-{
+ * Is there any XMP metadata in the map file for us to worry about?
+ */
+int msXmpWrite(mapObj *map, const char *filename) {
 #ifdef USE_EXEMPI
 
   /* Should hold our keys */
   hashTableObj hash_metadata = map->web.metadata;
   /* Temporary place for custom name spaces */
   hashTableObj hash_ns;
-  /* We use regex to strip out the namespace and XMP key value from the metadata key */
+  /* We use regex to strip out the namespace and XMP key value from the metadata
+   * key */
   regex_t xmp_regex;
   const char *xmp_ns_str = "^xmp_(.+)_namespace$";
   const char *xmp_tag_str = "^xmp_(.+)_(.+)$";
@@ -140,31 +133,29 @@ msXmpWrite( mapObj *map, const char *fil
   /* Prepare XMP library */
   xmp_init();
   f = xmp_files_open_new(filename, XMP_OPEN_FORUPDATE);
-  if ( ! f ) {
-    msSetError( MS_MISCERR,
-                "Unable to open temporary file '%s' to write XMP info",
-                "msXmpWrite()", filename );
+  if (!f) {
+    msSetError(MS_MISCERR,
+               "Unable to open temporary file '%s' to write XMP info",
+               "msXmpWrite()", filename);
     return MS_FAILURE;
   }
 
   /* Create a new XMP structure if the file doesn't already have one */
   xmp = xmp_files_get_new_xmp(f);
-  if ( xmp == NULL )
+  if (xmp == NULL)
     xmp = xmp_new_empty();
 
   /* Check we can write to the file */
-  if ( ! xmp_files_can_put_xmp(f, xmp) ) {
-    msSetError( MS_MISCERR,
-                "Unable to write XMP information to '%s'",
-                "msXmpWrite()", filename );
+  if (!xmp_files_can_put_xmp(f, xmp)) {
+    msSetError(MS_MISCERR, "Unable to write XMP information to '%s'",
+               "msXmpWrite()", filename);
     return MS_FAILURE;
   }
 
   /* Compile our "xmp_*_namespace" regex */
-  if ( regcomp(&xmp_regex, xmp_ns_str, regflags) ) {
-    msSetError( MS_MISCERR,
-                "Unable compile regex '%s'",
-                "msXmpWrite()", xmp_ns_str );
+  if (regcomp(&xmp_regex, xmp_ns_str, regflags)) {
+    msSetError(MS_MISCERR, "Unable compile regex '%s'", "msXmpWrite()",
+               xmp_ns_str);
     return MS_FAILURE;
   }
 
@@ -173,7 +164,7 @@ msXmpWrite( mapObj *map, const char *fil
   key = msFirstKeyFromHashTable(&hash_metadata);
 
   /* No first key? No license info. We shouldn't get here. */
-  if ( ! key )
+  if (!key)
     return MS_SUCCESS;
 
   do {
@@ -181,7 +172,7 @@ msXmpWrite( mapObj *map, const char *fil
     regmatch_t matches[2];
 
     /* Found a custom namespace entry! Store it for later. */
-    if ( 0 == regexec(&xmp_regex, key, 2, matches, 0) ) {
+    if (0 == regexec(&xmp_regex, key, 2, matches, 0)) {
       size_t ns_size = 0;
       char *ns_name = NULL;
       const char *ns_uri;
@@ -198,28 +189,26 @@ msXmpWrite( mapObj *map, const char *fil
       xmp_register_namespace(ns_uri, ns_name, NULL);
       msFree(ns_name);
     }
-  } while( (key = msNextKeyFromHashTable(&hash_metadata, key)) );
+  } while ((key = msNextKeyFromHashTable(&hash_metadata, key)));
   /* Clean up regex */
   regfree(&xmp_regex);
 
-
   /* Compile our "xmp_*_*" regex */
-  if ( regcomp(&xmp_regex, xmp_tag_str, regflags) ) {
+  if (regcomp(&xmp_regex, xmp_tag_str, regflags)) {
     msFreeHashItems(&hash_ns);
-    msSetError( MS_MISCERR,
-                "Unable compile regex '%s'",
-                "msXmpWrite()", xmp_tag_str );
+    msSetError(MS_MISCERR, "Unable compile regex '%s'", "msXmpWrite()",
+               xmp_tag_str);
     return MS_FAILURE;
   }
 
   /* Check all the keys for "xmp_*_*" pattern */
   key = msFirstKeyFromHashTable(&hash_metadata);
-  for( ; key != NULL; key = msNextKeyFromHashTable(&hash_metadata, key) ) {
+  for (; key != NULL; key = msNextKeyFromHashTable(&hash_metadata, key)) {
     /* Our regex has two match slots */
     regmatch_t matches[3];
 
     /* Found a namespace entry! Write it into XMP. */
-    if ( 0 == regexec(&xmp_regex, key, 3, matches, 0) ) {
+    if (0 == regexec(&xmp_regex, key, 3, matches, 0)) {
       /* Get the namespace and tag name */
       size_t ns_name_size = matches[1].rm_eo - matches[1].rm_so;
       size_t ns_tag_size = matches[2].rm_eo - matches[2].rm_so;
@@ -229,28 +218,30 @@ msXmpWrite( mapObj *map, const char *fil
       memcpy(ns_name, key + matches[1].rm_so, ns_name_size);
       memcpy(ns_tag, key + matches[2].rm_so, ns_tag_size);
       ns_name[ns_name_size] = 0; /* null terminate */
-      ns_tag[ns_tag_size] = 0; /* null terminate */
+      ns_tag[ns_tag_size] = 0;   /* null terminate */
 
-      if ( strcmp(ns_tag,"namespace") == 0 ) {
+      if (strcmp(ns_tag, "namespace") == 0) {
         msFree(ns_name);
         msFree(ns_tag);
         continue;
       }
 
       /* If this is a default name space?... */
-      if ( (ns_uri = msXmpUri(ns_name)) ) {
+      if ((ns_uri = msXmpUri(ns_name))) {
         xmp_register_namespace(ns_uri, ns_name, NULL);
-        xmp_set_property(xmp, ns_uri, ns_tag, msLookupHashTable(&hash_metadata, key), 0);
+        xmp_set_property(xmp, ns_uri, ns_tag,
+                         msLookupHashTable(&hash_metadata, key), 0);
       }
       /* Or maybe it's a custom one?... */
-      else if ( (ns_uri = msLookupHashTable(&hash_ns, ns_name)) ) {
-        xmp_set_property(xmp, ns_uri, ns_tag, msLookupHashTable(&hash_metadata, key), 0);
+      else if ((ns_uri = msLookupHashTable(&hash_ns, ns_name))) {
+        xmp_set_property(xmp, ns_uri, ns_tag,
+                         msLookupHashTable(&hash_metadata, key), 0);
       }
       /* Or perhaps we're screwed. */
       else {
-        msSetError( MS_MISCERR,
-                    "Unable to identify XMP namespace '%s' in metadata key '%s'",
-                    "msXmpWrite()", ns_name, key );
+        msSetError(MS_MISCERR,
+                   "Unable to identify XMP namespace '%s' in metadata key '%s'",
+                   "msXmpWrite()", ns_name, key);
         msFreeHashItems(&hash_ns);
         msFree(ns_name);
         msFree(ns_tag);
@@ -265,20 +256,18 @@ msXmpWrite( mapObj *map, const char *fil
   regfree(&xmp_regex);
 
   /* Write out the XMP */
-  if ( !xmp_files_put_xmp(f, xmp) ) {
+  if (!xmp_files_put_xmp(f, xmp)) {
     msFreeHashItems(&hash_ns);
-    msSetError( MS_MISCERR,
-                "Unable to execute '%s' on pointer %p",
-                "msXmpWrite()", "xmp_files_put_xmp", f );
+    msSetError(MS_MISCERR, "Unable to execute '%s' on pointer %p",
+               "msXmpWrite()", "xmp_files_put_xmp", f);
     return MS_FAILURE;
   }
 
   /* Write out the file and flush */
-  if ( !xmp_files_close(f, XMP_CLOSE_SAFEUPDATE) ) {
+  if (!xmp_files_close(f, XMP_CLOSE_SAFEUPDATE)) {
     msFreeHashItems(&hash_ns);
-    msSetError( MS_MISCERR,
-                "Unable to execute '%s' on pointer %p",
-                "msXmpWrite()", "xmp_files_close", f );
+    msSetError(MS_MISCERR, "Unable to execute '%s' on pointer %p",
+               "msXmpWrite()", "xmp_files_close", f);
     return MS_FAILURE;
   }
 
@@ -292,4 +281,3 @@ msXmpWrite( mapObj *map, const char *fil
   return MS_FAILURE;
 #endif
 }
-
diff -pruN 8.0.1-5/msencrypt.c 8.0.2-1/msencrypt.c
--- 8.0.1-5/msencrypt.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/msencrypt.c	2024-06-11 20:41:34.000000000 +0000
@@ -29,17 +29,14 @@
 
 #include "mapserver.h"
 
-
-
-void PrintUsage()
-{
-  printf("Usage: msencrypt <-keygen filename>|<-key filename string_to_encrypt>\n");
+void PrintUsage() {
+  printf("Usage: msencrypt <-keygen filename>|<-key filename "
+         "string_to_encrypt>\n");
 }
 
-int main(int argc, char *argv[])
-{
+int main(int argc, char *argv[]) {
 
-  if (argc == 3 && strcmp(argv[1], "-keygen")==0) {
+  if (argc == 3 && strcmp(argv[1], "-keygen") == 0) {
 
     /* TODO: Move this to a function */
     unsigned char pabyKey[16];
@@ -55,7 +52,7 @@ int main(int argc, char *argv[])
       printf("ERROR: Failed writing to %s\n", argv[2]);
       return -1;
     }
-  } else if (argc == 4 && strcmp(argv[1], "-key")==0) {
+  } else if (argc == 4 && strcmp(argv[1], "-key") == 0) {
     unsigned char key[16];
     char *pszBuf;
 
@@ -64,8 +61,8 @@ int main(int argc, char *argv[])
       return -1;
     }
 
-    pszBuf = (char*)malloc((strlen(argv[3])*2+17)*sizeof(char));
-    MS_CHECK_ALLOC(pszBuf, (strlen(argv[3])*2+17)*sizeof(char), -1);
+    pszBuf = (char *)malloc((strlen(argv[3]) * 2 + 17) * sizeof(char));
+    MS_CHECK_ALLOC(pszBuf, (strlen(argv[3]) * 2 + 17) * sizeof(char), -1);
 
     msEncryptStringWithKey(key, argv[3], pszBuf);
 
diff -pruN 8.0.1-5/scalebar.c 8.0.2-1/scalebar.c
--- 8.0.1-5/scalebar.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/scalebar.c	2024-06-11 20:41:34.000000000 +0000
@@ -29,34 +29,31 @@
 
 #include "mapserver.h"
 
-
-
-int main(int argc, char *argv[])
-{
-  mapObj *map=NULL;
-  imageObj         *image = NULL;
+int main(int argc, char *argv[]) {
+  mapObj *map = NULL;
+  imageObj *image = NULL;
 
   msSetup();
-  if(argc > 1 && strcmp(argv[1], "-v") == 0) {
+  if (argc > 1 && strcmp(argv[1], "-v") == 0) {
     printf("%s\n", msGetVersion());
     exit(0);
   }
 
   /* ---- check the number of arguments, return syntax if not correct ---- */
-  if( argc < 3 ) {
-    fprintf(stdout,"Syntax: scalebar [mapfile] [output image]\n" );
+  if (argc < 3) {
+    fprintf(stdout, "Syntax: scalebar [mapfile] [output image]\n");
     exit(1);
   }
 
   map = msLoadMap(argv[1], NULL, NULL);
-  if(!map) {
+  if (!map) {
     msWriteError(stderr);
     exit(1);
   }
 
   image = msDrawScalebar(map);
 
-  if(!image) {
+  if (!image) {
     msWriteError(stderr);
     exit(1);
   }
@@ -65,5 +62,5 @@ int main(int argc, char *argv[])
   msFreeImage(image);
 
   msFreeMap(map);
-  return(MS_TRUE);
+  return (MS_TRUE);
 }
diff -pruN 8.0.1-5/shptree.c 8.0.2-1/shptree.c
--- 8.0.1-5/shptree.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/shptree.c	2024-06-11 20:41:34.000000000 +0000
@@ -31,48 +31,44 @@
 #include "maptree.h"
 #include <string.h>
 
-
-
-char* AddFileSuffix ( const char * Filename, const char * Suffix )
-{
-  char  *pszFullname, *pszBasename;
+char *AddFileSuffix(const char *Filename, const char *Suffix) {
+  char *pszFullname, *pszBasename;
   int i;
 
   /* -------------------------------------------------------------------- */
   /*  Compute the base (layer) name.  If there is any extension     */
   /*  on the passed in filename we will strip it off.         */
   /* -------------------------------------------------------------------- */
-  pszBasename = (char *) msSmallMalloc(strlen(Filename)+5);
-  strcpy( pszBasename, Filename );
-  for( i = (int)strlen(pszBasename)-1;
-       i > 0 && pszBasename[i] != '.' && pszBasename[i] != '/'
-       && pszBasename[i] != '\\';
-       i-- ) {}
+  pszBasename = (char *)msSmallMalloc(strlen(Filename) + 5);
+  strcpy(pszBasename, Filename);
+  for (i = (int)strlen(pszBasename) - 1;
+       i > 0 && pszBasename[i] != '.' && pszBasename[i] != '/' &&
+       pszBasename[i] != '\\';
+       i--) {
+  }
 
-  if( pszBasename[i] == '.' )
+  if (pszBasename[i] == '.')
     pszBasename[i] = '\0';
 
   /* -------------------------------------------------------------------- */
   /*  Open the .shp and .shx files.  Note that files pulled from      */
   /*  a PC to Unix with upper case filenames won't work!        */
   /* -------------------------------------------------------------------- */
-  pszFullname = (char *) msSmallMalloc(strlen(pszBasename) + 5);
-  sprintf( pszFullname, "%s%s", pszBasename, Suffix);
+  pszFullname = (char *)msSmallMalloc(strlen(pszBasename) + 5);
+  sprintf(pszFullname, "%s%s", pszBasename, Suffix);
 
   free(pszBasename);
   return (pszFullname);
 }
 
-
-int main(int argc, char *argv[])
-{
+int main(int argc, char *argv[]) {
   shapefileObj shapefile;
 
   treeObj *tree;
   int byte_order = MS_NEW_LSB_ORDER, i;
-  int depth=0;
+  int depth = 0;
 
-  if(argc > 1 && strcmp(argv[1], "-v") == 0) {
+  if (argc > 1 && strcmp(argv[1], "-v") == 0) {
     printf("%s\n", msGetVersion());
     exit(0);
   }
@@ -83,59 +79,66 @@ int main(int argc, char *argv[])
   /* -------------------------------------------------------------------- */
   i = 1;
   /* cppcheck-suppress knownConditionTrueFalse */
-  if( *((uchar *) &i) == 1 )
+  if (*((uchar *)&i) == 1)
     byte_order = MS_NEW_LSB_ORDER;
   else
     byte_order = MS_NEW_MSB_ORDER;
 
-
-  if(argc<2) {
-    fprintf(stdout,"Syntax:\n");
-    fprintf(stdout,"    shptree <shpfile> [<depth>] [<index_format>]\n" );
-    fprintf(stdout,"Where:\n");
-    fprintf(stdout," <shpfile> is the name of the .shp file to index.\n");
-    fprintf(stdout," <depth>   (optional) is the maximum depth of the index\n");
-    fprintf(stdout,"           to create, default is 0 meaning that shptree\n");
-    fprintf(stdout,"           will calculate a reasonable default depth.\n");
-    fprintf(stdout," <index_format> (optional) is one of:\n");
-    fprintf(stdout,"           NL: LSB byte order, using new index format\n");
-    fprintf(stdout,"           NM: MSB byte order, using new index format\n");
-    fprintf(stdout,"       The following old format options are deprecated:\n");
-    fprintf(stdout,"           N:  Native byte order\n");
-    fprintf(stdout,"           L:  LSB (intel) byte order\n");
-    fprintf(stdout,"           M:  MSB byte order\n");
-    fprintf(stdout,"       The default index_format on this system is: %s\n\n",
-            (byte_order == MS_NEW_LSB_ORDER) ? "NL" : "NM" );
+  if (argc < 2) {
+    fprintf(stdout, "Syntax:\n");
+    fprintf(stdout, "    shptree <shpfile> [<depth>] [<index_format>]\n");
+    fprintf(stdout, "Where:\n");
+    fprintf(stdout, " <shpfile> is the name of the .shp file to index.\n");
+    fprintf(stdout,
+            " <depth>   (optional) is the maximum depth of the index\n");
+    fprintf(stdout,
+            "           to create, default is 0 meaning that shptree\n");
+    fprintf(stdout, "           will calculate a reasonable default depth.\n");
+    fprintf(stdout, " <index_format> (optional) is one of:\n");
+    fprintf(stdout, "           NL: LSB byte order, using new index format\n");
+    fprintf(stdout, "           NM: MSB byte order, using new index format\n");
+    fprintf(stdout,
+            "       The following old format options are deprecated:\n");
+    fprintf(stdout, "           N:  Native byte order\n");
+    fprintf(stdout, "           L:  LSB (intel) byte order\n");
+    fprintf(stdout, "           M:  MSB byte order\n");
+    fprintf(stdout, "       The default index_format on this system is: %s\n\n",
+            (byte_order == MS_NEW_LSB_ORDER) ? "NL" : "NM");
     exit(0);
   }
 
-  if(argc >= 3)
+  if (argc >= 3)
     depth = atoi(argv[2]);
 
-  if(argc >= 4) {
-    if( !strcasecmp(argv[3],"N" ))
+  if (argc >= 4) {
+    if (!strcasecmp(argv[3], "N"))
       byte_order = MS_NATIVE_ORDER;
-    if( !strcasecmp(argv[3],"L" ))
+    if (!strcasecmp(argv[3], "L"))
       byte_order = MS_LSB_ORDER;
-    if( !strcasecmp(argv[3],"M" ))
+    if (!strcasecmp(argv[3], "M"))
       byte_order = MS_MSB_ORDER;
-    if( !strcasecmp(argv[3],"NL" ))
+    if (!strcasecmp(argv[3], "NL"))
       byte_order = MS_NEW_LSB_ORDER;
-    if( !strcasecmp(argv[3],"NM" ))
+    if (!strcasecmp(argv[3], "NM"))
       byte_order = MS_NEW_MSB_ORDER;
   }
 
-  if(msShapefileOpen(&shapefile, "rb", argv[1], MS_TRUE) == -1) {
+  if (msShapefileOpen(&shapefile, "rb", argv[1], MS_TRUE) == -1) {
     fprintf(stdout, "Error opening shapefile %s.\n", argv[1]);
     exit(0);
   }
 
-  printf( "creating index of %s %s format\n",(byte_order < 1 ? "old (deprecated)" :"new"),
-          ((byte_order == MS_NATIVE_ORDER) ? "native" :
-           ((byte_order == MS_LSB_ORDER) || (byte_order == MS_NEW_LSB_ORDER)? " LSB":"MSB")));
+  printf(
+      "creating index of %s %s format\n",
+      (byte_order < 1 ? "old (deprecated)" : "new"),
+      ((byte_order == MS_NATIVE_ORDER)
+           ? "native"
+           : ((byte_order == MS_LSB_ORDER) || (byte_order == MS_NEW_LSB_ORDER)
+                  ? " LSB"
+                  : "MSB")));
 
   tree = msCreateTree(&shapefile, depth);
-  if(!tree) {
+  if (!tree) {
 #if MAX_SUBNODE == 2
     fprintf(stdout, "Error generating binary tree.\n");
 #else
@@ -152,5 +155,5 @@ int main(int argc, char *argv[])
   */
   msShapefileClose(&shapefile);
 
-  return(0);
+  return (0);
 }
diff -pruN 8.0.1-5/shptreetst.c 8.0.2-1/shptreetst.c
--- 8.0.1-5/shptreetst.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/shptreetst.c	2024-06-11 20:41:34.000000000 +0000
@@ -35,7 +35,6 @@
 #include <stdlib.h>
 #include <limits.h>
 
-
 #ifdef SHPT_POLYGON
 #undef MAPSERVER
 #else
@@ -43,46 +42,44 @@
 #define SHPT_POLYGON MS_SHP_POLYGON
 #endif
 
-
-char* AddFileSuffix ( const char * Filename, const char * Suffix )
-{
-  char  *pszFullname, *pszBasename;
+char *AddFileSuffix(const char *Filename, const char *Suffix) {
+  char *pszFullname, *pszBasename;
   int i;
 
   /* -------------------------------------------------------------------- */
   /*  Compute the base (layer) name.  If there is any extension     */
   /*  on the passed in filename we will strip it off.         */
   /* -------------------------------------------------------------------- */
-  pszBasename = (char *) msSmallMalloc(strlen(Filename)+5);
-  strcpy( pszBasename, Filename );
-  for( i = (int)strlen(pszBasename)-1;
-       i > 0 && pszBasename[i] != '.' && pszBasename[i] != '/'
-       && pszBasename[i] != '\\';
-       i-- ) {}
+  pszBasename = (char *)msSmallMalloc(strlen(Filename) + 5);
+  strcpy(pszBasename, Filename);
+  for (i = (int)strlen(pszBasename) - 1;
+       i > 0 && pszBasename[i] != '.' && pszBasename[i] != '/' &&
+       pszBasename[i] != '\\';
+       i--) {
+  }
 
-  if( pszBasename[i] == '.' )
+  if (pszBasename[i] == '.')
     pszBasename[i] = '\0';
 
   /* -------------------------------------------------------------------- */
   /*  Open the .shp and .shx files.  Note that files pulled from      */
   /*  a PC to Unix with upper case filenames won't work!        */
   /* -------------------------------------------------------------------- */
-  pszFullname = (char *) msSmallMalloc(strlen(pszBasename) + 5);
-  sprintf( pszFullname, "%s%s", pszBasename, Suffix);
+  pszFullname = (char *)msSmallMalloc(strlen(pszBasename) + 5);
+  sprintf(pszFullname, "%s%s", pszBasename, Suffix);
 
   return (pszFullname);
 }
 
-
-int main( int argc, char ** argv )
+int main(int argc, char **argv)
 
 {
   SHPTreeHandle qix;
 
-  int i,j;
+  int i, j;
   rectObj rect;
 
-  int   pos;
+  int pos;
   ms_bitarray bitmap = NULL;
 
   /*
@@ -90,15 +87,14 @@ int main( int argc, char ** argv )
   */
   treeNodeObj *node = NULL;
 
-
   /* -------------------------------------------------------------------- */
   /*      Display a usage message.                                        */
   /* -------------------------------------------------------------------- */
-  if( argc <= 1 ) {
-    printf( "shptreetst shapefile {minx miny maxx maxy}\n" );
-    exit( 1 );
+  if (argc <= 1) {
+    printf("shptreetst shapefile {minx miny maxx maxy}\n");
+    exit(1);
   }
-  
+
   /*
   i = 1;
   if( *((unsigned char *) &i) == 1 )
@@ -107,73 +103,75 @@ int main( int argc, char ** argv )
     mBigEndian = 1;
   */
 
-  qix = msSHPDiskTreeOpen (AddFileSuffix(argv[1],".qix"), 0 /* no debug*/);
-  if( qix == NULL ) {
+  qix = msSHPDiskTreeOpen(AddFileSuffix(argv[1], ".qix"), 0 /* no debug*/);
+  if (qix == NULL) {
     printf("unable to open index file %s \n", argv[1]);
     exit(-1);
   }
 
-  printf ("This %s %s index supports a shapefile with %d shapes, %d depth \n",
-          (qix->version ? "new": "old"), (qix->LSB_order? "LSB": "MSB"), (int) qix->nShapes, (int) qix->nDepth);
+  printf("This %s %s index supports a shapefile with %d shapes, %d depth \n",
+         (qix->version ? "new" : "old"), (qix->LSB_order ? "LSB" : "MSB"),
+         (int)qix->nShapes, (int)qix->nDepth);
 
   /* -------------------------------------------------------------------- */
   /*  Skim over the list of shapes, printing all the vertices.  */
   /* -------------------------------------------------------------------- */
 
-  pos = ftell (qix->fp);
+  pos = ftell(qix->fp);
   j = 0;
 
-  while( pos && j < 20) {
-    j ++;
+  while (pos && j < 20) {
+    j++;
     /*      fprintf (stderr,"box %d, at %d pos \n", j, (int) ftell(qix));
-    */
+     */
 
-    node = readTreeNode (qix);
-    if (node ) {
-      fprintf (stdout,"shapes %d, node %d, %f,%f,%f,%f \n",(int) node->numshapes,node->numsubnodes,node->rect.minx, node->rect.miny, node->rect.maxx, node->rect.maxy);
+    node = readTreeNode(qix);
+    if (node) {
+      fprintf(stdout, "shapes %d, node %d, %f,%f,%f,%f \n",
+              (int)node->numshapes, node->numsubnodes, node->rect.minx,
+              node->rect.miny, node->rect.maxx, node->rect.maxy);
 
     } else {
       pos = 0;
     }
   }
 
-  printf ("read entire file now at quad box rec %d file pos %ld\n", j, ftell (qix->fp));
+  printf("read entire file now at quad box rec %d file pos %ld\n", j,
+         ftell(qix->fp));
 
   j = qix->nShapes;
-  msSHPDiskTreeClose (qix);
+  msSHPDiskTreeClose(qix);
 
-  if( argc >= 5 ) {
-    rect.minx = atof (argv[2]);
-    rect.miny = atof (argv[3]);
-    rect.maxx = atof (argv[4]);
-    rect.maxy = atof (argv[5]);
+  if (argc >= 5) {
+    rect.minx = atof(argv[2]);
+    rect.miny = atof(argv[3]);
+    rect.maxx = atof(argv[4]);
+    rect.maxy = atof(argv[5]);
   } else {
-    if( node == NULL )
-    {
-        printf("node == NULL");
-        return 1;
+    if (node == NULL) {
+      printf("node == NULL");
+      return 1;
     }
-    printf ("using last read box as a search \n");
-    rect.minx =  node->rect.minx;
-    rect.miny =  node->rect.miny;
-    rect.maxx =  node->rect.maxx;
-    rect.maxy =  node->rect.maxy;
+    printf("using last read box as a search \n");
+    rect.minx = node->rect.minx;
+    rect.miny = node->rect.miny;
+    rect.maxx = node->rect.maxx;
+    rect.maxy = node->rect.maxy;
   }
 
-  bitmap = msSearchDiskTree( argv[1], rect, 0 /* no debug*/, j );
-
-  /* j < INT_MAX - 1 test just to please Coverity untrusted bound loop warning */
-  if ( bitmap && j < INT_MAX - 1 ) {
-    printf ("result of rectangle search was \n");
-    for ( i=0; i<j; i++) {
-      if ( msGetBit(bitmap,i) ) {
-        printf(" %d,",i);
+  bitmap = msSearchDiskTree(argv[1], rect, 0 /* no debug*/, j);
+
+  /* j < INT_MAX - 1 test just to please Coverity untrusted bound loop warning
+   */
+  if (bitmap && j < INT_MAX - 1) {
+    printf("result of rectangle search was \n");
+    for (i = 0; i < j; i++) {
+      if (msGetBit(bitmap, i)) {
+        printf(" %d,", i);
       }
     }
   }
   printf("\n");
 
-
-
-  return(0);
+  return (0);
 }
diff -pruN 8.0.1-5/shptreevis.c 8.0.2-1/shptreevis.c
--- 8.0.1-5/shptreevis.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/shptreevis.c	2024-06-11 20:41:34.000000000 +0000
@@ -27,7 +27,6 @@
  * DEALINGS IN THE SOFTWARE.
  ****************************************************************************/
 
-
 #include "mapserver.h"
 #include <string.h>
 #ifndef _WIN32
@@ -35,8 +34,6 @@
 #endif
 #include <stdlib.h>
 
-
-
 #ifdef SHPT_POLYGON
 #undef MAPSERVER
 #else
@@ -44,71 +41,70 @@
 #define SHPT_POLYGON SHP_POLYGON
 #endif
 
-char* AddFileSuffix ( const char * Filename, const char * Suffix )
-{
-  char  *pszFullname, *pszBasename;
+char *AddFileSuffix(const char *Filename, const char *Suffix) {
+  char *pszFullname, *pszBasename;
   size_t i;
 
   /* -------------------------------------------------------------------- */
   /*  Compute the base (layer) name.  If there is any extension     */
   /*  on the passed in filename we will strip it off.         */
   /* -------------------------------------------------------------------- */
-  pszBasename = (char *) msSmallMalloc(strlen(Filename)+5);
-  strcpy( pszBasename, Filename );
-  for( i = strlen(pszBasename)-1;
-       i > 0 && pszBasename[i] != '.' && pszBasename[i] != '/'
-       && pszBasename[i] != '\\';
-       i-- ) {}
+  pszBasename = (char *)msSmallMalloc(strlen(Filename) + 5);
+  strcpy(pszBasename, Filename);
+  for (i = strlen(pszBasename) - 1;
+       i > 0 && pszBasename[i] != '.' && pszBasename[i] != '/' &&
+       pszBasename[i] != '\\';
+       i--) {
+  }
 
-  if( pszBasename[i] == '.' )
+  if (pszBasename[i] == '.')
     pszBasename[i] = '\0';
 
   /* -------------------------------------------------------------------- */
   /*  Open the .shp and .shx files.  Note that files pulled from      */
   /*  a PC to Unix with upper case filenames won't work!        */
   /* -------------------------------------------------------------------- */
-  pszFullname = (char *) msSmallMalloc(strlen(pszBasename) + 5);
-  sprintf( pszFullname, "%s%s", pszBasename, Suffix);
+  pszFullname = (char *)msSmallMalloc(strlen(pszBasename) + 5);
+  sprintf(pszFullname, "%s%s", pszBasename, Suffix);
 
   free(pszBasename);
   return (pszFullname);
 }
 
-
-int main( int argc, char ** argv )
+int main(int argc, char **argv)
 
 {
   SHPHandle hSHP;
-  DBFHandle   hDBF;
+  DBFHandle hDBF;
   SHPTreeHandle qix;
 
-  char  *myfile = NULL;
+  char *myfile = NULL;
 
   treeNodeObj *node;
 
 #ifdef MAPSERVER
-  shapeObj  shape;
+  shapeObj shape;
   lineObj line[3];
-  pointObj  pts[6];
+  pointObj pts[6];
 #else
   SHPObject *shape;
-  double  X[6], Y[6];
+  double X[6], Y[6];
 #endif
-  int   result;
-  
+  int result;
+
   /*
   char  mBigEndian;
   int   i;
   */
 
-  int   this_rec;
+  int this_rec;
 
   /* -------------------------------------------------------------------- */
   /*      Display a usage message.                                        */
   /* -------------------------------------------------------------------- */
-  if( argc <= 2 ) {
-    printf( "shptreevis shapefile new_shapefile \n" );
-    exit( 1 );
+  if (argc <= 2) {
+    printf("shptreevis shapefile new_shapefile \n");
+    exit(1);
   }
 
   /*
@@ -119,9 +115,8 @@ int main( int argc, char ** argv )
     mBigEndian = 1;
   */
 
-
-  qix = msSHPDiskTreeOpen (AddFileSuffix(argv[1],".qix"), 0 /* no debug*/);
-  if( qix == NULL ) {
+  qix = msSHPDiskTreeOpen(AddFileSuffix(argv[1], ".qix"), 0 /* no debug*/);
+  if (qix == NULL) {
     printf("unable to open index file %s \n", argv[1]);
     exit(-1);
   }
@@ -129,63 +124,63 @@ int main( int argc, char ** argv )
   /* -------------------------------------------------------------------- */
   /*      Open the passed shapefile.                                      */
   /* -------------------------------------------------------------------- */
-  myfile = AddFileSuffix(argv[2],".shp");
+  myfile = AddFileSuffix(argv[2], ".shp");
 
 #ifdef MAPSERVER
-  hSHP = msSHPCreate ( myfile, SHPT_POLYGON );
-  hDBF = msDBFCreate (  AddFileSuffix(argv[2],".dbf") );
+  hSHP = msSHPCreate(myfile, SHPT_POLYGON);
+  hDBF = msDBFCreate(AddFileSuffix(argv[2], ".dbf"));
 #else
-  hSHP = SHPCreate ( myfile, SHPT_POLYGON );
-  hDBF = DBFCreate (  AddFileSuffix(argv[2],".dbf") );
+  hSHP = SHPCreate(myfile, SHPT_POLYGON);
+  hDBF = DBFCreate(AddFileSuffix(argv[2], ".dbf"));
 #endif
 
-  if ( (!hSHP) || (!hDBF) ) {
-    printf ("create error for %s    ... exiting \n", myfile);
-    exit (-1);
+  if ((!hSHP) || (!hDBF)) {
+    printf("create error for %s    ... exiting \n", myfile);
+    exit(-1);
   }
 
   /* add fields to dbf */
 #ifdef MAPSERVER
-  msDBFAddField ( hDBF, "ITEMS", FTInteger, 15,0 );
-  msDBFAddField ( hDBF, "SUBNODES", FTInteger, 15,0 );
-  msDBFAddField ( hDBF, "FACTOR", FTInteger, 15,0 );
-#else
-  DBFAddField ( hDBF, "ITEMS", FTInteger, 15,0 );
-  DBFAddField ( hDBF, "SUBNODES", FTInteger, 15,0 );
-  DBFAddField ( hDBF, "FACTOR", FTInteger, 15,0 );
+  msDBFAddField(hDBF, "ITEMS", FTInteger, 15, 0);
+  msDBFAddField(hDBF, "SUBNODES", FTInteger, 15, 0);
+  msDBFAddField(hDBF, "FACTOR", FTInteger, 15, 0);
+#else
+  DBFAddField(hDBF, "ITEMS", FTInteger, 15, 0);
+  DBFAddField(hDBF, "SUBNODES", FTInteger, 15, 0);
+  DBFAddField(hDBF, "FACTOR", FTInteger, 15, 0);
 #endif
 
 #ifndef MAPSERVER
-  SHPClose ( hSHP );
-  hSHP = SHPOpen ( myfile, "r+b" );
+  SHPClose(hSHP);
+  hSHP = SHPOpen(myfile, "r+b");
 
-  DBFClose (hDBF);
-  hDBF = DBFOpen ( myfile, "r+b");
+  DBFClose(hDBF);
+  hDBF = DBFOpen(myfile, "r+b");
 #endif
 
-  printf ("This %s %s index supports a shapefile with %d shapes, %d depth \n",
-          (qix->version ? "new": "old"), (qix->LSB_order? "LSB": "MSB"), (int) qix->nShapes, (int) qix->nDepth);
-
+  printf("This %s %s index supports a shapefile with %d shapes, %d depth \n",
+         (qix->version ? "new" : "old"), (qix->LSB_order ? "LSB" : "MSB"),
+         (int)qix->nShapes, (int)qix->nDepth);
 
   /* -------------------------------------------------------------------- */
   /*  Skim over the list of shapes, printing all the vertices.  */
   /* -------------------------------------------------------------------- */
 
-  while( 1 ) {
-    node = readTreeNode (qix);
-    if (node ) {
+  while (1) {
+    node = readTreeNode(qix);
+    if (node) {
 
       this_rec = hDBF->nRecords;
 
-#ifdef  MAPSERVER
-      msDBFWriteIntegerAttribute( hDBF, this_rec, 0, node->numshapes);
-      msDBFWriteIntegerAttribute( hDBF, this_rec, 1, node->numsubnodes);
+#ifdef MAPSERVER
+      msDBFWriteIntegerAttribute(hDBF, this_rec, 0, node->numshapes);
+      msDBFWriteIntegerAttribute(hDBF, this_rec, 1, node->numsubnodes);
 #else
-      DBFWriteIntegerAttribute( hDBF, this_rec, 0, node->numshapes);
-      DBFWriteIntegerAttribute( hDBF, this_rec, 1, node->numsubnodes);
+      DBFWriteIntegerAttribute(hDBF, this_rec, 0, node->numshapes);
+      DBFWriteIntegerAttribute(hDBF, this_rec, 1, node->numsubnodes);
 #endif
 
-#ifdef  MAPSERVER
+#ifdef MAPSERVER
       shape.numlines = 1;
       shape.type = SHPT_POLYGON;
 
@@ -205,10 +200,10 @@ int main( int argc, char ** argv )
       shape.line = &line[0];
       shape.bounds = node->rect;
 
-      result = msSHPWriteShape ( hSHP, &shape );
-      if ( result < 0 ) {
-        printf ("unable to write shape \n");
-        exit (0);
+      result = msSHPWriteShape(hSHP, &shape);
+      if (result < 0) {
+        printf("unable to write shape \n");
+        exit(0);
       }
 
 #else
@@ -224,23 +219,23 @@ int main( int argc, char ** argv )
       Y[3] = node->rect.maxy;
       Y[4] = node->rect.miny;
 
-      shape = SHPCreateSimpleObject( SHPT_POLYGON, 5, X, Y, NULL);
+      shape = SHPCreateSimpleObject(SHPT_POLYGON, 5, X, Y, NULL);
       SHPWriteObject(hSHP, -1, shape);
-      SHPDestroyObject ( shape );
+      SHPDestroyObject(shape);
 #endif
     } else
       break;
   }
 
 #ifdef MAPSERVER
-  msSHPClose( hSHP );
-  msDBFClose( hDBF );
+  msSHPClose(hSHP);
+  msDBFClose(hDBF);
 #else
-  SHPClose( hSHP );
-  DBFClose( hDBF );
+  SHPClose(hSHP);
+  DBFClose(hDBF);
 #endif
 
-  msSHPDiskTreeClose (qix);
+  msSHPDiskTreeClose(qix);
 
-  return(0);
+  return (0);
 }
diff -pruN 8.0.1-5/sortshp.c 8.0.2-1/sortshp.c
--- 8.0.1-5/sortshp.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/sortshp.c	2024-06-11 20:41:34.000000000 +0000
@@ -36,201 +36,217 @@
 
 #include "mapserver.h"
 
-
-
 typedef struct {
   double number;
   char string[255];
   int index;
 } sortStruct;
 
-static int compare_string_descending(const void *a, const void *b)
-{
+static int compare_string_descending(const void *a, const void *b) {
   const sortStruct *i = a, *j = b;
-  return(strcmp(j->string, i->string));
+  return (strcmp(j->string, i->string));
 }
 
-static int compare_string_ascending(const void *a, const void *b)
-{
+static int compare_string_ascending(const void *a, const void *b) {
   const sortStruct *i = a, *j = b;
-  return(strcmp(i->string, j->string));
+  return (strcmp(i->string, j->string));
 }
 
-static int compare_number_descending(const void *a, const void *b)
-{
+static int compare_number_descending(const void *a, const void *b) {
   const sortStruct *i = a, *j = b;
-  if(i->number > j->number)
-    return(-1);
-  if(i->number < j->number)
-    return(1);
-  return(0);
+  if (i->number > j->number)
+    return (-1);
+  if (i->number < j->number)
+    return (1);
+  return (0);
 }
 
-static int compare_number_ascending(const void *a, const void *b)
-{
+static int compare_number_ascending(const void *a, const void *b) {
   const sortStruct *i = a, *j = b;
-  if(i->number > j->number)
-    return(1);
-  if(i->number < j->number)
-    return(-1);
-  return(0);
+  if (i->number > j->number)
+    return (1);
+  if (i->number < j->number)
+    return (-1);
+  return (0);
 }
 
-int main(int argc, char *argv[])
-{
-  SHPHandle    inSHP,outSHP; /* ---- Shapefile file pointers ---- */
-  DBFHandle    inDBF,outDBF; /* ---- DBF file pointers ---- */
-  sortStruct   *array;
-  shapeObj     shape;
-  int          shpType, nShapes;
-  int          fieldNumber=-1; /* ---- Field number of item to be sorted on ---- */
+int main(int argc, char *argv[]) {
+  SHPHandle inSHP, outSHP; /* ---- Shapefile file pointers ---- */
+  DBFHandle inDBF, outDBF; /* ---- DBF file pointers ---- */
+  sortStruct *array;
+  shapeObj shape;
+  int shpType, nShapes;
+  int fieldNumber = -1; /* ---- Field number of item to be sorted on ---- */
   DBFFieldType dbfField;
-  char         fName[20];
-  int          fWidth,fnDecimals;
-  char         buffer[1024];
-  int i,j;
+  char fName[20];
+  int fWidth, fnDecimals;
+  char buffer[1024];
+  int i, j;
   int num_fields, num_records;
 
-  if(argc > 1 && strcmp(argv[1], "-v") == 0) {
+  if (argc > 1 && strcmp(argv[1], "-v") == 0) {
     printf("%s\n", msGetVersion());
     exit(0);
   }
 
-  /* ------------------------------------------------------------------------------- */
-  /*       Check the number of arguments, return syntax if not correct               */
-  /* ------------------------------------------------------------------------------- */
-  if( argc != 5 ) {
-    fprintf(stderr,"Syntax: sortshp [infile] [outfile] [item] [ascending|descending]\n" );
+  /* -------------------------------------------------------------------------------
+   */
+  /*       Check the number of arguments, return syntax if not correct */
+  /* -------------------------------------------------------------------------------
+   */
+  if (argc != 5) {
+    fprintf(
+        stderr,
+        "Syntax: sortshp [infile] [outfile] [item] [ascending|descending]\n");
     exit(1);
   }
 
   msSetErrorFile("stderr", NULL);
 
-  /* ------------------------------------------------------------------------------- */
-  /*       Open the shapefile                                                        */
-  /* ------------------------------------------------------------------------------- */
-  inSHP = msSHPOpen(argv[1], "rb" );
-  if( !inSHP ) {
-    fprintf(stderr,"Unable to open %s shapefile.\n",argv[1]);
+  /* -------------------------------------------------------------------------------
+   */
+  /*       Open the shapefile */
+  /* -------------------------------------------------------------------------------
+   */
+  inSHP = msSHPOpen(argv[1], "rb");
+  if (!inSHP) {
+    fprintf(stderr, "Unable to open %s shapefile.\n", argv[1]);
     exit(1);
   }
   msSHPGetInfo(inSHP, &nShapes, &shpType);
 
-  /* ------------------------------------------------------------------------------- */
-  /*       Open the dbf file                                                         */
-  /* ------------------------------------------------------------------------------- */
-  snprintf(buffer, sizeof(buffer), "%s.dbf",argv[1]);
-  inDBF = msDBFOpen(buffer,"rb");
-  if( inDBF == NULL ) {
-    fprintf(stderr,"Unable to open %s XBASE file.\n",buffer);
+  /* -------------------------------------------------------------------------------
+   */
+  /*       Open the dbf file */
+  /* -------------------------------------------------------------------------------
+   */
+  snprintf(buffer, sizeof(buffer), "%s.dbf", argv[1]);
+  inDBF = msDBFOpen(buffer, "rb");
+  if (inDBF == NULL) {
+    fprintf(stderr, "Unable to open %s XBASE file.\n", buffer);
     exit(1);
   }
 
   num_fields = msDBFGetFieldCount(inDBF);
   num_records = msDBFGetRecordCount(inDBF);
 
-  for(i=0; i<num_fields; i++) {
-    msDBFGetFieldInfo(inDBF,i,fName,NULL,NULL);
-    if(strncasecmp(argv[3],fName,(int)strlen(argv[3])) == 0) { /* ---- Found it ---- */
+  for (i = 0; i < num_fields; i++) {
+    msDBFGetFieldInfo(inDBF, i, fName, NULL, NULL);
+    if (strncasecmp(argv[3], fName, (int)strlen(argv[3])) ==
+        0) { /* ---- Found it ---- */
       fieldNumber = i;
       break;
     }
   }
 
-  if(fieldNumber < 0) {
-    fprintf(stderr,"Item %s doesn't exist in %s\n",argv[3],buffer);
+  if (fieldNumber < 0) {
+    fprintf(stderr, "Item %s doesn't exist in %s\n", argv[3], buffer);
     exit(1);
   }
 
-  array = (sortStruct *)malloc(sizeof(sortStruct)*num_records); /* ---- Allocate the array ---- */
-  if(!array) {
+  array = (sortStruct *)malloc(sizeof(sortStruct) *
+                               num_records); /* ---- Allocate the array ---- */
+  if (!array) {
     fprintf(stderr, "Unable to allocate sort array.\n");
     exit(1);
   }
 
-  /* ------------------------------------------------------------------------------- */
-  /*       Load the array to be sorted                                               */
-  /* ------------------------------------------------------------------------------- */
-  dbfField = msDBFGetFieldInfo(inDBF,fieldNumber,NULL,NULL,NULL);
+  /* -------------------------------------------------------------------------------
+   */
+  /*       Load the array to be sorted */
+  /* -------------------------------------------------------------------------------
+   */
+  dbfField = msDBFGetFieldInfo(inDBF, fieldNumber, NULL, NULL, NULL);
   switch (dbfField) {
-    case FTString:
-      for(i=0; i<num_records; i++) {
-        strlcpy(array[i].string, msDBFReadStringAttribute( inDBF, i, fieldNumber), sizeof(array[i].string));
-        array[i].index = i;
-      }
-
-      if(*argv[4] == 'd')
-        qsort(array, num_records, sizeof(sortStruct), compare_string_descending);
-      else
-        qsort(array, num_records, sizeof(sortStruct), compare_string_ascending);
-      break;
-    case FTInteger:
-    case FTDouble:
-      for(i=0; i<num_records; i++) {
-        array[i].number = msDBFReadDoubleAttribute( inDBF, i, fieldNumber);
-        array[i].index = i;
-      }
+  case FTString:
+    for (i = 0; i < num_records; i++) {
+      strlcpy(array[i].string, msDBFReadStringAttribute(inDBF, i, fieldNumber),
+              sizeof(array[i].string));
+      array[i].index = i;
+    }
 
-      if(*argv[4] == 'd')
-        qsort(array, num_records, sizeof(sortStruct), compare_number_descending);
-      else
-        qsort(array, num_records, sizeof(sortStruct), compare_number_ascending);
+    if (*argv[4] == 'd')
+      qsort(array, num_records, sizeof(sortStruct), compare_string_descending);
+    else
+      qsort(array, num_records, sizeof(sortStruct), compare_string_ascending);
+    break;
+  case FTInteger:
+  case FTDouble:
+    for (i = 0; i < num_records; i++) {
+      array[i].number = msDBFReadDoubleAttribute(inDBF, i, fieldNumber);
+      array[i].index = i;
+    }
 
-      break;
-    default:
-      fprintf(stderr,"Data type for item %s not supported.\n",argv[3]);
-      exit(1);
+    if (*argv[4] == 'd')
+      qsort(array, num_records, sizeof(sortStruct), compare_number_descending);
+    else
+      qsort(array, num_records, sizeof(sortStruct), compare_number_ascending);
+
+    break;
+  default:
+    fprintf(stderr, "Data type for item %s not supported.\n", argv[3]);
+    exit(1);
   }
 
-  /* ------------------------------------------------------------------------------- */
-  /*       Setup the output .shp/.shx and .dbf files                                 */
-  /* ------------------------------------------------------------------------------- */
-  outSHP = msSHPCreate(argv[2],shpType);
-  if( outSHP == NULL ) {
-    fprintf( stderr, "Failed to create file '%s'.\n", argv[2] );
-    exit( 1 );
+  /* -------------------------------------------------------------------------------
+   */
+  /*       Setup the output .shp/.shx and .dbf files */
+  /* -------------------------------------------------------------------------------
+   */
+  outSHP = msSHPCreate(argv[2], shpType);
+  if (outSHP == NULL) {
+    fprintf(stderr, "Failed to create file '%s'.\n", argv[2]);
+    exit(1);
   }
 
-  sprintf(buffer,"%s.dbf",argv[2]);
+  sprintf(buffer, "%s.dbf", argv[2]);
   outDBF = msDBFCreate(buffer);
-  if( outDBF == NULL ) {
-    fprintf( stderr, "Failed to create dbf file '%s'.\n", buffer );
-    exit( 1 );
-  }
-
-  for(i=0; i<num_fields; i++) {
-    dbfField = msDBFGetFieldInfo(inDBF,i,fName,&fWidth,&fnDecimals); /* ---- Get field info from in file ---- */
-    msDBFAddField(outDBF,fName,dbfField,fWidth,fnDecimals);
+  if (outDBF == NULL) {
+    fprintf(stderr, "Failed to create dbf file '%s'.\n", buffer);
+    exit(1);
   }
 
-  /* ------------------------------------------------------------------------------- */
-  /*       Write the sorted .shp/.shx and .dbf files                                 */
-  /* ------------------------------------------------------------------------------- */
-  for(i=0; i<num_records; i++) { /* ---- For each shape/record ---- */
+  for (i = 0; i < num_fields; i++) {
+    dbfField = msDBFGetFieldInfo(
+        inDBF, i, fName, &fWidth,
+        &fnDecimals); /* ---- Get field info from in file ---- */
+    msDBFAddField(outDBF, fName, dbfField, fWidth, fnDecimals);
+  }
+
+  /* -------------------------------------------------------------------------------
+   */
+  /*       Write the sorted .shp/.shx and .dbf files */
+  /* -------------------------------------------------------------------------------
+   */
+  for (i = 0; i < num_records; i++) { /* ---- For each shape/record ---- */
 
-    for(j=0; j<num_fields; j++) { /* ---- For each .dbf field ---- */
+    for (j = 0; j < num_fields; j++) { /* ---- For each .dbf field ---- */
 
-      dbfField = msDBFGetFieldInfo(inDBF,j,fName,&fWidth,&fnDecimals);
+      dbfField = msDBFGetFieldInfo(inDBF, j, fName, &fWidth, &fnDecimals);
 
       switch (dbfField) {
-        case FTInteger:
-          msDBFWriteIntegerAttribute(outDBF, i, j, msDBFReadIntegerAttribute( inDBF, array[i].index, j));
-          break;
-        case FTDouble:
-          msDBFWriteDoubleAttribute(outDBF, i, j, msDBFReadDoubleAttribute( inDBF, array[i].index, j));
-          break;
-        case FTString:
-          msDBFWriteStringAttribute(outDBF, i, j, msDBFReadStringAttribute( inDBF, array[i].index, j));
-          break;
-        default:
-          fprintf(stderr,"Unsupported data type for field: %s, exiting.\n",fName);
-          exit(0);
+      case FTInteger:
+        msDBFWriteIntegerAttribute(
+            outDBF, i, j, msDBFReadIntegerAttribute(inDBF, array[i].index, j));
+        break;
+      case FTDouble:
+        msDBFWriteDoubleAttribute(
+            outDBF, i, j, msDBFReadDoubleAttribute(inDBF, array[i].index, j));
+        break;
+      case FTString:
+        msDBFWriteStringAttribute(
+            outDBF, i, j, msDBFReadStringAttribute(inDBF, array[i].index, j));
+        break;
+      default:
+        fprintf(stderr, "Unsupported data type for field: %s, exiting.\n",
+                fName);
+        exit(0);
       }
     }
 
-    msSHPReadShape( inSHP, array[i].index, &shape );
-    msSHPWriteShape( outSHP, &shape );
-    msFreeShape( &shape );
+    msSHPReadShape(inSHP, array[i].index, &shape);
+    msSHPWriteShape(outSHP, &shape);
+    msFreeShape(&shape);
   }
 
   free(array);
@@ -240,5 +256,5 @@ int main(int argc, char *argv[])
   msSHPClose(outSHP);
   msDBFClose(outDBF);
 
-  return(0);
+  return (0);
 }
diff -pruN 8.0.1-5/strptime.c 8.0.2-1/strptime.c
--- 8.0.1-5/strptime.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/strptime.c	2024-06-11 20:41:34.000000000 +0000
@@ -40,65 +40,23 @@
 #include <time.h>
 #include "mapserver.h"
 
-static const char *const abb_weekdays[] = {
-  "Sun",
-  "Mon",
-  "Tue",
-  "Wed",
-  "Thu",
-  "Fri",
-  "Sat",
-  NULL
-};
+static const char *const abb_weekdays[] = {"Sun", "Mon", "Tue", "Wed",
+                                           "Thu", "Fri", "Sat", NULL};
 
-static const char *const full_weekdays[] = {
-  "Sunday",
-  "Monday",
-  "Tuesday",
-  "Wednesday",
-  "Thursday",
-  "Friday",
-  "Saturday",
-  NULL
-};
-
-static const char *const abb_month[] = {
-  "Jan",
-  "Feb",
-  "Mar",
-  "Apr",
-  "May",
-  "Jun",
-  "Jul",
-  "Aug",
-  "Sep",
-  "Oct",
-  "Nov",
-  "Dec",
-  NULL
-};
+static const char *const full_weekdays[] = {"Sunday",    "Monday",   "Tuesday",
+                                            "Wednesday", "Thursday", "Friday",
+                                            "Saturday",  NULL};
+
+static const char *const abb_month[] = {"Jan", "Feb", "Mar", "Apr", "May",
+                                        "Jun", "Jul", "Aug", "Sep", "Oct",
+                                        "Nov", "Dec", NULL};
 
 static const char *const full_month[] = {
-  "January",
-  "February",
-  "Mars",
-  "April",
-  "May",
-  "June",
-  "July",
-  "August",
-  "September",
-  "October",
-  "November",
-  "December",
-  NULL,
+    "January", "February",  "Mars",    "April",    "May",      "June", "July",
+    "August",  "September", "October", "November", "December", NULL,
 };
 
-static const char *const ampm[] = {
-  "am",
-  "pm",
-  NULL
-};
+static const char *const ampm[] = {"am", "pm", NULL};
 
 /*
  * tm_year is relative this year
@@ -109,22 +67,18 @@ static const int tm_year_base = 1900;
  * Return TRUE iff `year' was a leap year.
  * Needed for strptime.
  */
-static int
-is_leap_year (int year)
-{
+static int is_leap_year(int year) {
   return (year % 4) == 0 && ((year % 100) != 0 || (year % 400) == 0);
 }
 
 /* Needed for strptime. */
-static int
-match_string (const char **buf, const char *const*strs)
-{
+static int match_string(const char **buf, const char *const *strs) {
   int i = 0;
 
   for (i = 0; strs[i] != NULL; ++i) {
-    int len = strlen (strs[i]);
+    int len = strlen(strs[i]);
 
-    if (strncasecmp (*buf, strs[i], len) == 0) {
+    if (strncasecmp(*buf, strs[i], len) == 0) {
       *buf += len;
       return i;
     }
@@ -133,13 +87,11 @@ match_string (const char **buf, const ch
 }
 
 /* Needed for strptime. */
-static int
-first_day (int year)
-{
+static int first_day(int year) {
   int ret = 4;
 
   for (; year > 1970; --year)
-    ret = (ret + 365 + is_leap_year (year) ? 1 : 0) % 7;
+    ret = (ret + 365 + is_leap_year(year) ? 1 : 0) % 7;
   return ret;
 }
 
@@ -148,10 +100,8 @@ first_day (int year)
  * Needed for strptime
  */
 
-static void
-set_week_number_sun (struct tm *timeptr, int wnum)
-{
-  int fday = first_day (timeptr->tm_year + tm_year_base);
+static void set_week_number_sun(struct tm *timeptr, int wnum) {
+  int fday = first_day(timeptr->tm_year + tm_year_base);
 
   timeptr->tm_yday = wnum * 7 + timeptr->tm_wday - fday;
   if (timeptr->tm_yday < 0) {
@@ -165,10 +115,8 @@ set_week_number_sun (struct tm *timeptr,
  * Needed for strptime
  */
 
-static void
-set_week_number_mon (struct tm *timeptr, int wnum)
-{
-  int fday = (first_day (timeptr->tm_year + tm_year_base) + 6) % 7;
+static void set_week_number_mon(struct tm *timeptr, int wnum) {
+  int fday = (first_day(timeptr->tm_year + tm_year_base) + 6) % 7;
 
   timeptr->tm_yday = wnum * 7 + (timeptr->tm_wday + 6) % 7 - fday;
   if (timeptr->tm_yday < 0) {
@@ -181,10 +129,8 @@ set_week_number_mon (struct tm *timeptr,
  * Set `timeptr' given `wnum' (week number [0, 53])
  * Needed for strptime
  */
-static void
-set_week_number_mon4 (struct tm *timeptr, int wnum)
-{
-  int fday = (first_day (timeptr->tm_year + tm_year_base) + 6) % 7;
+static void set_week_number_mon4(struct tm *timeptr, int wnum) {
+  int fday = (first_day(timeptr->tm_year + tm_year_base) + 6) % 7;
   int offset = 0;
 
   if (fday < 4)
@@ -201,233 +147,232 @@ set_week_number_mon4 (struct tm *timeptr
 /* extern "C" */
 char *
 /* strptime (const char *buf, const char *format, struct tm *timeptr) */
-strptime (const char *buf, const char *format, struct tm *timeptr)
-{
+strptime(const char *buf, const char *format, struct tm *timeptr) {
   char c;
 
   for (; (c = *format) != '\0'; ++format) {
     char *s;
     int ret;
 
-    if (isspace (c)) {
-      while (isspace (*buf))
+    if (isspace(c)) {
+      while (isspace(*buf))
         ++buf;
     } else if (c == '%' && format[1] != '\0') {
       c = *++format;
       if (c == 'E' || c == 'O')
         c = *++format;
       switch (c) {
-        case 'A' :
-          ret = match_string (&buf, full_weekdays);
-          if (ret < 0)
-            return NULL;
-          timeptr->tm_wday = ret;
-          break;
-        case 'a' :
-          ret = match_string (&buf, abb_weekdays);
-          if (ret < 0)
-            return NULL;
-          timeptr->tm_wday = ret;
-          break;
-        case 'B' :
-          ret = match_string (&buf, full_month);
-          if (ret < 0)
-            return NULL;
-          timeptr->tm_mon = ret;
-          break;
-        case 'b' :
-        case 'h' :
-          ret = match_string (&buf, abb_month);
-          if (ret < 0)
-            return NULL;
-          timeptr->tm_mon = ret;
-          break;
-        case 'C' :
-          ret = strtol (buf, &s, 10);
-          if (s == buf)
-            return NULL;
-          timeptr->tm_year = (ret * 100) - tm_year_base;
-          buf = s;
-          break;
-        case 'c' :
-          abort ();
-        case 'D' :    /* %m/%d/%y */
-          s = strptime (buf, "%m/%d/%y", timeptr);
-          if (s == NULL)
-            return NULL;
-          buf = s;
-          break;
-        case 'd' :
-        case 'e' :
-          ret = strtol (buf, &s, 10);
-          if (s == buf)
-            return NULL;
-          timeptr->tm_mday = ret;
-          buf = s;
-          break;
-        case 'H' :
-        case 'k' :
-          ret = strtol (buf, &s, 10);
-          if (s == buf)
-            return NULL;
+      case 'A':
+        ret = match_string(&buf, full_weekdays);
+        if (ret < 0)
+          return NULL;
+        timeptr->tm_wday = ret;
+        break;
+      case 'a':
+        ret = match_string(&buf, abb_weekdays);
+        if (ret < 0)
+          return NULL;
+        timeptr->tm_wday = ret;
+        break;
+      case 'B':
+        ret = match_string(&buf, full_month);
+        if (ret < 0)
+          return NULL;
+        timeptr->tm_mon = ret;
+        break;
+      case 'b':
+      case 'h':
+        ret = match_string(&buf, abb_month);
+        if (ret < 0)
+          return NULL;
+        timeptr->tm_mon = ret;
+        break;
+      case 'C':
+        ret = strtol(buf, &s, 10);
+        if (s == buf)
+          return NULL;
+        timeptr->tm_year = (ret * 100) - tm_year_base;
+        buf = s;
+        break;
+      case 'c':
+        abort();
+      case 'D': /* %m/%d/%y */
+        s = strptime(buf, "%m/%d/%y", timeptr);
+        if (s == NULL)
+          return NULL;
+        buf = s;
+        break;
+      case 'd':
+      case 'e':
+        ret = strtol(buf, &s, 10);
+        if (s == buf)
+          return NULL;
+        timeptr->tm_mday = ret;
+        buf = s;
+        break;
+      case 'H':
+      case 'k':
+        ret = strtol(buf, &s, 10);
+        if (s == buf)
+          return NULL;
+        timeptr->tm_hour = ret;
+        buf = s;
+        break;
+      case 'I':
+      case 'l':
+        ret = strtol(buf, &s, 10);
+        if (s == buf)
+          return NULL;
+        if (ret == 12)
+          timeptr->tm_hour = 0;
+        else
           timeptr->tm_hour = ret;
-          buf = s;
-          break;
-        case 'I' :
-        case 'l' :
-          ret = strtol (buf, &s, 10);
-          if (s == buf)
-            return NULL;
-          if (ret == 12)
-            timeptr->tm_hour = 0;
-          else
-            timeptr->tm_hour = ret;
-          buf = s;
-          break;
-        case 'j' :
-          ret = strtol (buf, &s, 10);
-          if (s == buf)
-            return NULL;
-          timeptr->tm_yday = ret - 1;
-          buf = s;
-          break;
-        case 'm' :
-          ret = strtol (buf, &s, 10);
-          if (s == buf)
-            return NULL;
-          timeptr->tm_mon = ret - 1;
-          buf = s;
-          break;
-        case 'M' :
-          ret = strtol (buf, &s, 10);
-          if (s == buf)
-            return NULL;
-          timeptr->tm_min = ret;
-          buf = s;
-          break;
-        case 'n' :
-          if (*buf == '\n')
-            ++buf;
-          else
-            return NULL;
-          break;
-        case 'p' :
-          ret = match_string (&buf, ampm);
-          if (ret < 0)
-            return NULL;
-          if (timeptr->tm_hour == 0) {
-            if (ret == 1)
-              timeptr->tm_hour = 12;
-          } else
-            timeptr->tm_hour += 12;
-          break;
-        case 'r' :    /* %I:%M:%S %p */
-          s = strptime (buf, "%I:%M:%S %p", timeptr);
-          if (s == NULL)
-            return NULL;
-          buf = s;
-          break;
-        case 'R' :    /* %H:%M */
-          s = strptime (buf, "%H:%M", timeptr);
-          if (s == NULL)
-            return NULL;
-          buf = s;
-          break;
-        case 'S' :
-          ret = strtol (buf, &s, 10);
-          if (s == buf)
-            return NULL;
-          timeptr->tm_sec = ret;
-          buf = s;
-          break;
-        case 't' :
-          if (*buf == '\t')
-            ++buf;
-          else
-            return NULL;
-          break;
-        case 'T' :    /* %H:%M:%S */
-        case 'X' :
-          s = strptime (buf, "%H:%M:%S", timeptr);
-          if (s == NULL)
-            return NULL;
-          buf = s;
-          break;
-        case 'u' :
-          ret = strtol (buf, &s, 10);
-          if (s == buf)
-            return NULL;
-          timeptr->tm_wday = ret - 1;
-          buf = s;
-          break;
-        case 'w' :
-          ret = strtol (buf, &s, 10);
-          if (s == buf)
-            return NULL;
-          timeptr->tm_wday = ret;
-          buf = s;
-          break;
-        case 'U' :
-          ret = strtol (buf, &s, 10);
-          if (s == buf)
-            return NULL;
-          set_week_number_sun (timeptr, ret);
-          buf = s;
-          break;
-        case 'V' :
-          ret = strtol (buf, &s, 10);
-          if (s == buf)
-            return NULL;
-          set_week_number_mon4 (timeptr, ret);
-          buf = s;
-          break;
-        case 'W' :
-          ret = strtol (buf, &s, 10);
-          if (s == buf)
-            return NULL;
-          set_week_number_mon (timeptr, ret);
-          buf = s;
-          break;
-        case 'x' :
-          s = strptime (buf, "%Y:%m:%d", timeptr);
-          if (s == NULL)
-            return NULL;
-          buf = s;
-          break;
-        case 'y' :
-          ret = strtol (buf, &s, 10);
-          if (s == buf)
-            return NULL;
-          if (ret < 70)
-            timeptr->tm_year = 100 + ret;
-          else
-            timeptr->tm_year = ret;
-          buf = s;
-          break;
-        case 'Y' :
-          ret = strtol (buf, &s, 10);
-          if (s == buf)
-            return NULL;
-          timeptr->tm_year = ret - tm_year_base;
-          buf = s;
-          break;
-        case 'Z' :
-          abort ();
-        case '\0' :
-          --format;
-          /* FALLTHROUGH */
-        case '%' :
-          if (*buf == '%')
-            ++buf;
-          else
-            return NULL;
-          break;
-        default :
-          if (*buf == '%' || *++buf == c)
-            ++buf;
-          else
-            return NULL;
-          break;
+        buf = s;
+        break;
+      case 'j':
+        ret = strtol(buf, &s, 10);
+        if (s == buf)
+          return NULL;
+        timeptr->tm_yday = ret - 1;
+        buf = s;
+        break;
+      case 'm':
+        ret = strtol(buf, &s, 10);
+        if (s == buf)
+          return NULL;
+        timeptr->tm_mon = ret - 1;
+        buf = s;
+        break;
+      case 'M':
+        ret = strtol(buf, &s, 10);
+        if (s == buf)
+          return NULL;
+        timeptr->tm_min = ret;
+        buf = s;
+        break;
+      case 'n':
+        if (*buf == '\n')
+          ++buf;
+        else
+          return NULL;
+        break;
+      case 'p':
+        ret = match_string(&buf, ampm);
+        if (ret < 0)
+          return NULL;
+        if (timeptr->tm_hour == 0) {
+          if (ret == 1)
+            timeptr->tm_hour = 12;
+        } else
+          timeptr->tm_hour += 12;
+        break;
+      case 'r': /* %I:%M:%S %p */
+        s = strptime(buf, "%I:%M:%S %p", timeptr);
+        if (s == NULL)
+          return NULL;
+        buf = s;
+        break;
+      case 'R': /* %H:%M */
+        s = strptime(buf, "%H:%M", timeptr);
+        if (s == NULL)
+          return NULL;
+        buf = s;
+        break;
+      case 'S':
+        ret = strtol(buf, &s, 10);
+        if (s == buf)
+          return NULL;
+        timeptr->tm_sec = ret;
+        buf = s;
+        break;
+      case 't':
+        if (*buf == '\t')
+          ++buf;
+        else
+          return NULL;
+        break;
+      case 'T': /* %H:%M:%S */
+      case 'X':
+        s = strptime(buf, "%H:%M:%S", timeptr);
+        if (s == NULL)
+          return NULL;
+        buf = s;
+        break;
+      case 'u':
+        ret = strtol(buf, &s, 10);
+        if (s == buf)
+          return NULL;
+        timeptr->tm_wday = ret - 1;
+        buf = s;
+        break;
+      case 'w':
+        ret = strtol(buf, &s, 10);
+        if (s == buf)
+          return NULL;
+        timeptr->tm_wday = ret;
+        buf = s;
+        break;
+      case 'U':
+        ret = strtol(buf, &s, 10);
+        if (s == buf)
+          return NULL;
+        set_week_number_sun(timeptr, ret);
+        buf = s;
+        break;
+      case 'V':
+        ret = strtol(buf, &s, 10);
+        if (s == buf)
+          return NULL;
+        set_week_number_mon4(timeptr, ret);
+        buf = s;
+        break;
+      case 'W':
+        ret = strtol(buf, &s, 10);
+        if (s == buf)
+          return NULL;
+        set_week_number_mon(timeptr, ret);
+        buf = s;
+        break;
+      case 'x':
+        s = strptime(buf, "%Y:%m:%d", timeptr);
+        if (s == NULL)
+          return NULL;
+        buf = s;
+        break;
+      case 'y':
+        ret = strtol(buf, &s, 10);
+        if (s == buf)
+          return NULL;
+        if (ret < 70)
+          timeptr->tm_year = 100 + ret;
+        else
+          timeptr->tm_year = ret;
+        buf = s;
+        break;
+      case 'Y':
+        ret = strtol(buf, &s, 10);
+        if (s == buf)
+          return NULL;
+        timeptr->tm_year = ret - tm_year_base;
+        buf = s;
+        break;
+      case 'Z':
+        abort();
+      case '\0':
+        --format;
+        /* FALLTHROUGH */
+      case '%':
+        if (*buf == '%')
+          ++buf;
+        else
+          return NULL;
+        break;
+      default:
+        if (*buf == '%' || *++buf == c)
+          ++buf;
+        else
+          return NULL;
+        break;
       }
     } else {
       if (*buf == c)
diff -pruN 8.0.1-5/sym2img.c 8.0.2-1/sym2img.c
--- 8.0.1-5/sym2img.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/sym2img.c	2024-06-11 20:41:34.000000000 +0000
@@ -32,37 +32,34 @@
 
 #include "mapserver.h"
 
-
-
 #define MAXCOLORS 256
 #define CELLSIZE 100
 #define NCOLS 5
 #define RATIO .5
 #define LBUF 5 /* space to reserve around line symbols */
 
-int main(int argc, char *argv[])
-{
+int main(int argc, char *argv[]) {
   FILE *stream;
-  int ns,n,k;
+  int ns, n, k;
   gdImagePtr img;
   shapeObj p;
-  int i,j;
-  int ncols,nrows;
+  int i, j;
+  int ncols, nrows;
   char buffer[256];
   int gray, green, red, black, white;
   classObj class;
   symbolSetObj symbolSet;
 
   /* ---- check the number of arguments, return syntax if not correct ---- */
-  if( argc < 2 ) {
-    fprintf(stdout, "Syntax: sym2img [symbolset] [outfile]\n" );
+  if (argc < 2) {
+    fprintf(stdout, "Syntax: sym2img [symbolset] [outfile]\n");
     exit(0);
   }
 
   /* Initialize the polygon/polyline */
   p.line = (lineObj *)malloc(sizeof(lineObj));
   p.numlines = 1;
-  p.line[0].point = (pointObj *)malloc(sizeof(pointObj)*4);
+  p.line[0].point = (pointObj *)malloc(sizeof(pointObj) * 4);
   p.line[0].numpoints = 4;
 
   /* Initialize the symbol and font sets */
@@ -71,22 +68,22 @@ int main(int argc, char *argv[])
   /*
   ** load the symbol file
   */
-  if(msLoadSymbolSet(&symbolSet) == -1) {
+  if (msLoadSymbolSet(&symbolSet) == -1) {
     msWriteError(stderr);
     exit(1);
   }
 
   ns = symbolSet.numsymbols;
 
-  if(ns < NCOLS) {
+  if (ns < NCOLS) {
     ncols = ns;
     nrows = 1;
   } else {
     ncols = NCOLS;
-    nrows = (int)ceil((double)ns/NCOLS);
+    nrows = (int)ceil((double)ns / NCOLS);
   }
 
-  img = gdImageCreate(ncols*CELLSIZE, nrows*CELLSIZE);
+  img = gdImageCreate(ncols * CELLSIZE, nrows * CELLSIZE);
 
   gray = gdImageColorAllocate(img, 222, 222, 222);
   white = gdImageColorAllocate(img, 255, 255, 255);
@@ -98,69 +95,71 @@ int main(int argc, char *argv[])
   class.backgroundcolor = white;
   class.outlinecolor = black;
 
-  n=0;
+  n = 0;
 
-  for(i=0; n<ns; i+=CELLSIZE) {
-    k=0;
-    for(j=0; n<ns; j+=CELLSIZE) {
-      if (k == ncols) break;
+  for (i = 0; n < ns; i += CELLSIZE) {
+    k = 0;
+    for (j = 0; n < ns; j += CELLSIZE) {
+      if (k == ncols)
+        break;
       k++;
-      gdImageFilledRectangle(img,j,i,j+CELLSIZE, i+CELLSIZE, gray);
+      gdImageFilledRectangle(img, j, i, j + CELLSIZE, i + CELLSIZE, gray);
 
       class.symbol = n;
 
-      switch(symbolSet.type) {
-        case(MS_MARKERSET):
-          class.sizescaled = RATIO*CELLSIZE;
-          p.line[0].point[0].x = MS_NINT(j + CELLSIZE/2);
-          p.line[0].point[0].y = MS_NINT(i + CELLSIZE/2);
-          p.line[0].numpoints = 1;
-          msDrawMarkerSymbol(&(symbolSet), img, &(p.line[0].point[0]), &(class));
-          break;
-
-        case(MS_LINESET):
-          class.sizescaled = 1;
-          p.line[0].point[0].x = j;
-          p.line[0].point[0].y = i + (CELLSIZE-LBUF) - 1;
-          p.line[0].point[1].x = j + MS_NINT((CELLSIZE-LBUF)/3.0) - 1;
-          p.line[0].point[1].y = i;
-          p.line[0].point[2].x = j + MS_NINT(2*(CELLSIZE-LBUF)/3.0) - 1;
-          p.line[0].point[2].y = i + (CELLSIZE-LBUF) - 1;
-          p.line[0].point[3].x = j + (CELLSIZE-LBUF) - 1;
-          p.line[0].point[3].y = i;
-          p.line[0].numpoints = 4;
-          msDrawLineSymbol(map, img, &p, &(class));
-          break;
-
-        case(MS_SHADESET):
-          class.sizescaled = 5;
-          p.line[0].point[0].x = j;
-          p.line[0].point[0].y = i;
-          p.line[0].point[1].x = j + CELLSIZE-1;
-          p.line[0].point[1].y = i;
-          p.line[0].point[2].x = j + CELLSIZE-1;
-          p.line[0].point[2].y = i + CELLSIZE-1 ;
-          p.line[0].point[3].x = j;
-          p.line[0].point[3].y = i + CELLSIZE-1;
-          p.line[0].numpoints = 4;
-          msDrawShadeSymbol(&(symbolSet), img, &p, &(class));
-          break;
+      switch (symbolSet.type) {
+      case (MS_MARKERSET):
+        class.sizescaled = RATIO * CELLSIZE;
+        p.line[0].point[0].x = MS_NINT(j + CELLSIZE / 2);
+        p.line[0].point[0].y = MS_NINT(i + CELLSIZE / 2);
+        p.line[0].numpoints = 1;
+        msDrawMarkerSymbol(&(symbolSet), img, &(p.line[0].point[0]), &(class));
+        break;
+
+      case (MS_LINESET):
+        class.sizescaled = 1;
+        p.line[0].point[0].x = j;
+        p.line[0].point[0].y = i + (CELLSIZE - LBUF) - 1;
+        p.line[0].point[1].x = j + MS_NINT((CELLSIZE - LBUF) / 3.0) - 1;
+        p.line[0].point[1].y = i;
+        p.line[0].point[2].x = j + MS_NINT(2 * (CELLSIZE - LBUF) / 3.0) - 1;
+        p.line[0].point[2].y = i + (CELLSIZE - LBUF) - 1;
+        p.line[0].point[3].x = j + (CELLSIZE - LBUF) - 1;
+        p.line[0].point[3].y = i;
+        p.line[0].numpoints = 4;
+        msDrawLineSymbol(map, img, &p, &(class));
+        break;
+
+      case (MS_SHADESET):
+        class.sizescaled = 5;
+        p.line[0].point[0].x = j;
+        p.line[0].point[0].y = i;
+        p.line[0].point[1].x = j + CELLSIZE - 1;
+        p.line[0].point[1].y = i;
+        p.line[0].point[2].x = j + CELLSIZE - 1;
+        p.line[0].point[2].y = i + CELLSIZE - 1;
+        p.line[0].point[3].x = j;
+        p.line[0].point[3].y = i + CELLSIZE - 1;
+        p.line[0].numpoints = 4;
+        msDrawShadeSymbol(&(symbolSet), img, &p, &(class));
+        break;
 
-        default:
-          break;
+      default:
+        break;
       }
 
-      if(symbolSet.symbol[n]->name)
-        snprintf(buffer, sizeof(buffer), "%d - %s", n, symbolSet.symbol[n]->name);
+      if (symbolSet.symbol[n]->name)
+        snprintf(buffer, sizeof(buffer), "%d - %s", n,
+                 symbolSet.symbol[n]->name);
       else
         snprintf(buffer, sizeof(buffer), "%d", n);
-      gdImageString(img, gdFontTiny, j+1, i+1, buffer, black);
+      gdImageString(img, gdFontTiny, j + 1, i + 1, buffer, black);
 
       n++;
     }
   }
 
-  if((stream = fopen(argv[2],"wb")) == NULL) { /* open the file */
+  if ((stream = fopen(argv[2], "wb")) == NULL) { /* open the file */
     fprintf(stderr, "Unable to open output file: %s\n", argv[2]);
     exit(1);
   }
@@ -173,6 +172,5 @@ int main(int argc, char *argv[])
   free(symbolSet.filename);
   fclose(stream);
 
-  return(MS_TRUE);
+  return (MS_TRUE);
 }
-
diff -pruN 8.0.1-5/testcopy.c 8.0.2-1/testcopy.c
--- 8.0.1-5/testcopy.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/testcopy.c	2024-06-11 20:41:34.000000000 +0000
@@ -29,12 +29,9 @@
 
 #include "mapserver.h"
 
+void printAtts(mapObj *, const char *);
 
-
-void printAtts(mapObj*, const char*);
-
-int main(int argc, char *argv[])
-{
+int main(int argc, char *argv[]) {
 
   mapObj *original_map, *clone_map;
 
@@ -45,7 +42,7 @@ int main(int argc, char *argv[])
   /* Load map file */
   original_map = msLoadMap("tests/test.map", NULL);
 
-  if (original_map ==  NULL) {
+  if (original_map == NULL) {
     /* Write errors */
     msWriteError(stderr);
     msResetErrorList();
@@ -75,8 +72,7 @@ int main(int argc, char *argv[])
   exit(0);
 }
 
-void printAtts(mapObj *map, const char *title)
-{
+void printAtts(mapObj *map, const char *title) {
   printf("\n%s Attributes\n----------------------\n", title);
   printf("Map Name: %s\n", map->name);
   printf("Numlayers: %d\n", map->numlayers);
diff -pruN 8.0.1-5/testexpr.c 8.0.2-1/testexpr.c
--- 8.0.1-5/testexpr.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/testexpr.c	2024-06-11 20:41:34.000000000 +0000
@@ -33,8 +33,6 @@
 #include "mapparser.h"
 #include "mapfile.h"
 
-
-
 extern int msyyparse();
 extern int msyylex();
 extern char *msyystring_buffer;
@@ -43,17 +41,16 @@ extern int msyyresult; /* result of pars
 extern int msyystate;
 extern char *msyystring;
 
-int main(int argc, char *argv[])
-{
+int main(int argc, char *argv[]) {
   int status;
 
-  if(argc > 1 && strcmp(argv[1], "-v") == 0) {
+  if (argc > 1 && strcmp(argv[1], "-v") == 0) {
     printf("%s\n", msGetVersion());
     exit(0);
   }
 
   /* ---- check the number of arguments, return syntax if not correct ---- */
-  if( argc < 2) {
+  if (argc < 2) {
     fprintf(stdout, "Syntax: testexpr [string]\n");
     exit(0);
   }
@@ -62,7 +59,7 @@ int main(int argc, char *argv[])
   msyystring = argv[1];
 
   status = msyyparse();
-  if(status != 0)
+  if (status != 0)
     printf("Error parsing expression near %s.\n", msyystring_buffer);
   else
     printf("Expression evalulated to: %d.\n", msyyresult);
diff -pruN 8.0.1-5/textlayout.c 8.0.2-1/textlayout.c
--- 8.0.1-5/textlayout.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/textlayout.c	2024-06-11 20:41:34.000000000 +0000
@@ -26,7 +26,6 @@
  * DEALINGS IN THE SOFTWARE.
  *****************************************************************************/
 
-
 #include <float.h>
 #include "mapserver.h"
 
@@ -38,7 +37,7 @@
 #include FT_ADVANCES_H
 #include FT_TYPES_H
 
-typedef struct{
+typedef struct {
   unsigned int *unicodes;
   unsigned int *codepoints;
 #ifdef USE_FRIBIDI
@@ -54,7 +53,8 @@ typedef struct {
   int offset; /* offset in TextInfo entries where the current run is starting */
   int length; /* number of unicode glyphs in this run */
 #ifdef USE_FRIBIDI
-  FriBidiLevel rtl; /* bidi embedding level of run: -1 to skip shaping, otherwise if pair:ltr, odd:rtl */
+  FriBidiLevel rtl;   /* bidi embedding level of run: -1 to skip shaping,
+                         otherwise if pair:ltr, odd:rtl */
   hb_script_t script; /* script: latin, arabic, thai, etc... */
 #endif
   int line_number;
@@ -74,8 +74,8 @@ const char *_ms_script_prefix_cn = "cn:"
 const char *_ms_script_prefix_hy = "hy:";
 const char *_ms_script_prefix_bn = "bn:";
 const char *_ms_script_prefix_iu = "iu";
-const char *_ms_script_prefix_chr= "chr:";
-const char *_ms_script_prefix_cop= "cop:";
+const char *_ms_script_prefix_chr = "chr:";
+const char *_ms_script_prefix_cop = "cop:";
 const char *_ms_script_prefix_ru = "ru:";
 const char *_ms_script_prefix_hi = "hi:";
 const char *_ms_script_prefix_ka = "ka:";
@@ -90,7 +90,7 @@ const char *_ms_script_prefix_lo = "lo:"
 const char *_ms_script_prefix_ml = "ml:";
 const char *_ms_script_prefix_mn = "mn:";
 const char *_ms_script_prefix_or = "or:";
-const char *_ms_script_prefix_syr= "syr:";
+const char *_ms_script_prefix_syr = "syr:";
 const char *_ms_script_prefix_ta = "ta:";
 const char *_ms_script_prefix_te = "te:";
 const char *_ms_script_prefix_th = "th:";
@@ -100,74 +100,114 @@ const char *_ms_script_prefix_km = "km:"
 const char *_ms_script_prefix_my = "my:";
 const char *_ms_script_prefix_si = "si:";
 const char *_ms_script_prefix_dv = "dv:";
-const char *_ms_script_prefix_bku= "bku:";
-const char *_ms_script_prefix_hnn= "hnn:";
+const char *_ms_script_prefix_bku = "bku:";
+const char *_ms_script_prefix_hnn = "hnn:";
 const char *_ms_script_prefix_tl = "tl:";
-const char *_ms_script_prefix_tbw= "tbw:";
-const char *_ms_script_prefix_uga= "uga:";
-const char *_ms_script_prefix_bug= "bug:";
-const char *_ms_script_prefix_peo= "peo:";
-const char *_ms_script_prefix_syl= "syl:";
-const char *_ms_script_prefix_nko= "nko:";
-
-const char* prefix_from_script(hb_script_t script) {
-  switch(script) {
-  case HB_SCRIPT_LATIN:               return _ms_script_prefix_en;
-  case HB_SCRIPT_ARABIC:              return _ms_script_prefix_ar;
-  case HB_SCRIPT_HAN:                 return _ms_script_prefix_cn;
-  case HB_SCRIPT_ARMENIAN:            return _ms_script_prefix_hy;
-  case HB_SCRIPT_BENGALI:             return _ms_script_prefix_bn;
-  case HB_SCRIPT_CANADIAN_ABORIGINAL: return _ms_script_prefix_iu;
-  case HB_SCRIPT_CHEROKEE:            return _ms_script_prefix_chr;
-  case HB_SCRIPT_COPTIC:              return _ms_script_prefix_cop;
-  case HB_SCRIPT_CYRILLIC:            return _ms_script_prefix_ru;
-  case HB_SCRIPT_DEVANAGARI:          return _ms_script_prefix_hi;
-  case HB_SCRIPT_GEORGIAN:            return _ms_script_prefix_ka;
-  case HB_SCRIPT_GREEK:               return _ms_script_prefix_el;
-  case HB_SCRIPT_GUJARATI:            return _ms_script_prefix_gu;
-  case HB_SCRIPT_GURMUKHI:            return _ms_script_prefix_pa;
-  case HB_SCRIPT_HANGUL:              return _ms_script_prefix_ko;
-  case HB_SCRIPT_HEBREW:              return _ms_script_prefix_he;
-  case HB_SCRIPT_HIRAGANA:            return _ms_script_prefix_ja;
-  case HB_SCRIPT_KANNADA:             return _ms_script_prefix_kn;
-  case HB_SCRIPT_KATAKANA:            return _ms_script_prefix_ja;
-  case HB_SCRIPT_LAO:                 return _ms_script_prefix_lo;
-  case HB_SCRIPT_MALAYALAM:           return _ms_script_prefix_ml;
-  case HB_SCRIPT_MONGOLIAN:           return _ms_script_prefix_mn;
-  case HB_SCRIPT_ORIYA:               return _ms_script_prefix_or;
-  case HB_SCRIPT_SYRIAC:              return _ms_script_prefix_syr;
-  case HB_SCRIPT_TAMIL:               return _ms_script_prefix_ta;
-  case HB_SCRIPT_TELUGU:              return _ms_script_prefix_te;
-  case HB_SCRIPT_THAI:                return _ms_script_prefix_th;
-  case HB_SCRIPT_TIBETAN:             return _ms_script_prefix_bo;
-  case HB_SCRIPT_ETHIOPIC:            return _ms_script_prefix_am;
-  case HB_SCRIPT_KHMER:               return _ms_script_prefix_km;
-  case HB_SCRIPT_MYANMAR:             return _ms_script_prefix_my;
-  case HB_SCRIPT_SINHALA:             return _ms_script_prefix_si;
-  case HB_SCRIPT_THAANA:              return _ms_script_prefix_dv;
-  case HB_SCRIPT_BUHID:               return _ms_script_prefix_bku;
-  case HB_SCRIPT_HANUNOO:             return _ms_script_prefix_hnn;
-  case HB_SCRIPT_TAGALOG:             return _ms_script_prefix_tl;
-  case HB_SCRIPT_TAGBANWA:            return _ms_script_prefix_tbw;
-  case HB_SCRIPT_UGARITIC:            return _ms_script_prefix_uga;
-  case HB_SCRIPT_BUGINESE:            return _ms_script_prefix_bug;
-  case HB_SCRIPT_OLD_PERSIAN:         return _ms_script_prefix_peo;
-  case HB_SCRIPT_SYLOTI_NAGRI:        return _ms_script_prefix_syl;
-  case HB_SCRIPT_NKO:                 return _ms_script_prefix_nko;
+const char *_ms_script_prefix_tbw = "tbw:";
+const char *_ms_script_prefix_uga = "uga:";
+const char *_ms_script_prefix_bug = "bug:";
+const char *_ms_script_prefix_peo = "peo:";
+const char *_ms_script_prefix_syl = "syl:";
+const char *_ms_script_prefix_nko = "nko:";
+
+const char *prefix_from_script(hb_script_t script) {
+  switch (script) {
+  case HB_SCRIPT_LATIN:
+    return _ms_script_prefix_en;
+  case HB_SCRIPT_ARABIC:
+    return _ms_script_prefix_ar;
+  case HB_SCRIPT_HAN:
+    return _ms_script_prefix_cn;
+  case HB_SCRIPT_ARMENIAN:
+    return _ms_script_prefix_hy;
+  case HB_SCRIPT_BENGALI:
+    return _ms_script_prefix_bn;
+  case HB_SCRIPT_CANADIAN_ABORIGINAL:
+    return _ms_script_prefix_iu;
+  case HB_SCRIPT_CHEROKEE:
+    return _ms_script_prefix_chr;
+  case HB_SCRIPT_COPTIC:
+    return _ms_script_prefix_cop;
+  case HB_SCRIPT_CYRILLIC:
+    return _ms_script_prefix_ru;
+  case HB_SCRIPT_DEVANAGARI:
+    return _ms_script_prefix_hi;
+  case HB_SCRIPT_GEORGIAN:
+    return _ms_script_prefix_ka;
+  case HB_SCRIPT_GREEK:
+    return _ms_script_prefix_el;
+  case HB_SCRIPT_GUJARATI:
+    return _ms_script_prefix_gu;
+  case HB_SCRIPT_GURMUKHI:
+    return _ms_script_prefix_pa;
+  case HB_SCRIPT_HANGUL:
+    return _ms_script_prefix_ko;
+  case HB_SCRIPT_HEBREW:
+    return _ms_script_prefix_he;
+  case HB_SCRIPT_HIRAGANA:
+    return _ms_script_prefix_ja;
+  case HB_SCRIPT_KANNADA:
+    return _ms_script_prefix_kn;
+  case HB_SCRIPT_KATAKANA:
+    return _ms_script_prefix_ja;
+  case HB_SCRIPT_LAO:
+    return _ms_script_prefix_lo;
+  case HB_SCRIPT_MALAYALAM:
+    return _ms_script_prefix_ml;
+  case HB_SCRIPT_MONGOLIAN:
+    return _ms_script_prefix_mn;
+  case HB_SCRIPT_ORIYA:
+    return _ms_script_prefix_or;
+  case HB_SCRIPT_SYRIAC:
+    return _ms_script_prefix_syr;
+  case HB_SCRIPT_TAMIL:
+    return _ms_script_prefix_ta;
+  case HB_SCRIPT_TELUGU:
+    return _ms_script_prefix_te;
+  case HB_SCRIPT_THAI:
+    return _ms_script_prefix_th;
+  case HB_SCRIPT_TIBETAN:
+    return _ms_script_prefix_bo;
+  case HB_SCRIPT_ETHIOPIC:
+    return _ms_script_prefix_am;
+  case HB_SCRIPT_KHMER:
+    return _ms_script_prefix_km;
+  case HB_SCRIPT_MYANMAR:
+    return _ms_script_prefix_my;
+  case HB_SCRIPT_SINHALA:
+    return _ms_script_prefix_si;
+  case HB_SCRIPT_THAANA:
+    return _ms_script_prefix_dv;
+  case HB_SCRIPT_BUHID:
+    return _ms_script_prefix_bku;
+  case HB_SCRIPT_HANUNOO:
+    return _ms_script_prefix_hnn;
+  case HB_SCRIPT_TAGALOG:
+    return _ms_script_prefix_tl;
+  case HB_SCRIPT_TAGBANWA:
+    return _ms_script_prefix_tbw;
+  case HB_SCRIPT_UGARITIC:
+    return _ms_script_prefix_uga;
+  case HB_SCRIPT_BUGINESE:
+    return _ms_script_prefix_bug;
+  case HB_SCRIPT_OLD_PERSIAN:
+    return _ms_script_prefix_peo;
+  case HB_SCRIPT_SYLOTI_NAGRI:
+    return _ms_script_prefix_syl;
+  case HB_SCRIPT_NKO:
+    return _ms_script_prefix_nko;
   default:
     return NULL;
-
   }
 }
 
-hb_feature_t hbfeatures[2] = {
-    {HB_TAG('v','e','r','t'),0,0,INT_MAX},
-    {HB_TAG('k','e','r','n'),0,0,INT_MAX}
-};
+hb_feature_t hbfeatures[2] = {{HB_TAG('v', 'e', 'r', 't'), 0, 0, INT_MAX},
+                              {HB_TAG('k', 'e', 'r', 'n'), 0, 0, INT_MAX}};
 
-static hb_bool_t _ms_get_glyph_func (hb_font_t *font, void *font_data,
-    hb_codepoint_t unicode, hb_codepoint_t variation_selector, hb_codepoint_t *glyph,
-		void *user_data)
+static hb_bool_t _ms_get_glyph_func(hb_font_t *font, void *font_data,
+                                    hb_codepoint_t unicode,
+                                    hb_codepoint_t variation_selector,
+                                    hb_codepoint_t *glyph, void *user_data)
 
 {
   (void)font;
@@ -178,8 +218,8 @@ static hb_bool_t _ms_get_glyph_func (hb_
   struct _ms_hb_user_data *ud = font_data;
   unsigned int *unicodes = ud->info->unicodes + ud->run->offset;
 
-  for(i=0; i<ud->run->length; i++) {
-    if(unicodes[i] == unicode) {
+  for (i = 0; i < ud->run->length; i++) {
+    if (unicodes[i] == unicode) {
       *glyph = *(ud->info->codepoints + ud->run->offset + i);
       return *glyph != 0;
     }
@@ -190,50 +230,53 @@ static hb_bool_t _ms_get_glyph_func (hb_
 
 #ifdef HAVE_FT_FACE_GETCHARVARIANTINDEX
     if ((variation_selector)) {
-      *glyph = FT_Face_GetCharVariantIndex (ft_face, unicode, variation_selector);
+      *glyph =
+          FT_Face_GetCharVariantIndex(ft_face, unicode, variation_selector);
       return *glyph != 0;
     }
 #endif
 
-    *glyph = FT_Get_Char_Index (ft_face, unicode);
+    *glyph = FT_Get_Char_Index(ft_face, unicode);
     return *glyph != 0;
   }
 }
 
-#if HB_VERSION_ATLEAST(1,2,3)
+#if HB_VERSION_ATLEAST(1, 2, 3)
 static hb_bool_t _ms_get_nominal_glyph_func(hb_font_t *font, void *font_data,
                                             hb_codepoint_t unicode,
                                             hb_codepoint_t *glyph,
-                                            void *user_data)
-{
-    return _ms_get_glyph_func(font, font_data, unicode, 0, glyph, user_data);
+                                            void *user_data) {
+  return _ms_get_glyph_func(font, font_data, unicode, 0, glyph, user_data);
 }
 
 static hb_bool_t _ms_get_variation_glyph_func(hb_font_t *font, void *font_data,
                                               hb_codepoint_t unicode,
                                               hb_codepoint_t variation_selector,
                                               hb_codepoint_t *glyph,
-                                              void *user_data)
-{
-    return _ms_get_glyph_func(font, font_data, unicode, variation_selector, glyph, user_data);
+                                              void *user_data) {
+  return _ms_get_glyph_func(font, font_data, unicode, variation_selector, glyph,
+                            user_data);
 }
 #endif
 
-static hb_position_t _ms_get_glyph_h_advance_func (hb_font_t *font, void *font_data,
-			   hb_codepoint_t glyph, void *user_data)
-{
+static hb_position_t _ms_get_glyph_h_advance_func(hb_font_t *font,
+                                                  void *font_data,
+                                                  hb_codepoint_t glyph,
+                                                  void *user_data) {
   (void)font;
   (void)user_data;
   struct _ms_hb_user_data *ud = font_data;
-  glyph_element *glyphc = msGetGlyphByIndex(ud->run->face,ud->glyph_size,glyph);
-  if(!glyphc)
+  glyph_element *glyphc =
+      msGetGlyphByIndex(ud->run->face, ud->glyph_size, glyph);
+  if (!glyphc)
     return 0;
   return glyphc->metrics.advance * 64;
 }
 
-static hb_position_t _ms_get_glyph_v_advance_func (hb_font_t *font, void *font_data,
-    hb_codepoint_t glyph, void *user_data)
-{
+static hb_position_t _ms_get_glyph_v_advance_func(hb_font_t *font,
+                                                  void *font_data,
+                                                  hb_codepoint_t glyph,
+                                                  void *user_data) {
   (void)font;
   (void)font_data;
   (void)glyph;
@@ -242,97 +285,111 @@ static hb_position_t _ms_get_glyph_v_adv
 }
 #endif
 
-static int check_single_font(fontSetObj *fontset, char *fontkey, text_run *run, TextInfo *glyphs, int ignore_missing) {
+static int check_single_font(fontSetObj *fontset, char *fontkey, text_run *run,
+                             TextInfo *glyphs, int ignore_missing) {
   int i;
   face_element *fcache = NULL;
-  if(fontset && fontkey) {
-    char *fontkey2 = strchr(fontkey,':'); /* try skipping prefix */
-    if(fontkey2) {
-      fcache = msGetFontFace(fontkey2+1, fontset);
+  if (fontset && fontkey) {
+    char *fontkey2 = strchr(fontkey, ':'); /* try skipping prefix */
+    if (fontkey2) {
+      fcache = msGetFontFace(fontkey2 + 1, fontset);
     }
   }
-  if(!fcache)
+  if (!fcache)
     fcache = msGetFontFace(fontkey, fontset);
   run->face = fcache;
-  if(MS_UNLIKELY(!fcache)) return MS_FAILURE;
-  for(i=0; i<run->length; i++) {
-    unsigned int codepoint = msGetGlyphIndex(fcache, glyphs->unicodes[run->offset+i]);
-    if(codepoint || ignore_missing)
-    {
-      if( codepoint == 0 )
-      {
-          msDebug("Unable to find glyph for codepoint %u. Using ? as fallback.\n", glyphs->unicodes[run->offset+i]);
-          codepoint = msGetGlyphIndex(fcache, '?');
+  if (MS_UNLIKELY(!fcache))
+    return MS_FAILURE;
+  for (i = 0; i < run->length; i++) {
+    unsigned int codepoint =
+        msGetGlyphIndex(fcache, glyphs->unicodes[run->offset + i]);
+    if (codepoint || ignore_missing) {
+      if (codepoint == 0) {
+        msDebug("Unable to find glyph for codepoint %u. Using ? as fallback.\n",
+                glyphs->unicodes[run->offset + i]);
+        codepoint = msGetGlyphIndex(fcache, '?');
       }
-      glyphs->codepoints[run->offset+i] = codepoint;
-    }
-    else
+      glyphs->codepoints[run->offset + i] = codepoint;
+    } else
       return MS_FAILURE;
   }
   return MS_SUCCESS;
 }
 
-static int get_face_for_run(fontSetObj *fontset, char *fontlist, text_run *run, TextInfo *glyphs) {
+static int get_face_for_run(fontSetObj *fontset, char *fontlist, text_run *run,
+                            TextInfo *glyphs) {
   char *startfont, *endfont;
 #if defined(USE_HARFBUZZ) && defined(USE_FRIBIDI)
   const char *prefix = NULL;
 #endif
 
-  if(!fontset || !fontlist) {
-    int ok = check_single_font(fontset,fontlist,run,glyphs,0);
+  if (!fontset || !fontlist) {
+    int ok = check_single_font(fontset, fontlist, run, glyphs, 0);
     (void)ok;
     return MS_SUCCESS;
   }
 
 #if defined(USE_HARFBUZZ) && defined(USE_FRIBIDI)
-  if(run->rtl >= 0) {
+  if (run->rtl >= 0) {
     prefix = prefix_from_script(run->script);
   } else {
     prefix = _ms_script_prefix_en;
   }
 
-  if(prefix) {
-    /* we'll first look for a font who's prefixed by the current script prefix, e.g, given the
-     * fontlist "arial,ar:arialuni,cn:cjk" check the "cjk" font first for HAN scripts
+  if (prefix) {
+    /* we'll first look for a font who's prefixed by the current script prefix,
+     * e.g, given the fontlist "arial,ar:arialuni,cn:cjk" check the "cjk" font
+     * first for HAN scripts
      */
     int prefixlen = strlen(prefix);
     startfont = fontlist;
-    for(;;) {
-      if(!*startfont) break;
-      endfont = strchr(startfont,',');
-      if(!strncmp(startfont,prefix,prefixlen)) {
+    for (;;) {
+      if (!*startfont)
+        break;
+      endfont = strchr(startfont, ',');
+      if (!strncmp(startfont, prefix, prefixlen)) {
         startfont += strlen(prefix);
-        if(endfont) *endfont = 0;
-        int ok = check_single_font(fontset,startfont,run,glyphs,0);
-        if(endfont) {
+        if (endfont)
+          *endfont = 0;
+        int ok = check_single_font(fontset, startfont, run, glyphs, 0);
+        if (endfont) {
           *endfont = ',';
-          if(ok == MS_SUCCESS) return MS_SUCCESS;
-          startfont = endfont+1; /* go to next font in list */
+          if (ok == MS_SUCCESS)
+            return MS_SUCCESS;
+          startfont = endfont + 1; /* go to next font in list */
         } else {
-          if(ok == MS_SUCCESS) return MS_SUCCESS;
+          if (ok == MS_SUCCESS)
+            return MS_SUCCESS;
           break;
         }
       }
-      if(endfont)
-       startfont = endfont+1;
-      else break;
+      if (endfont)
+        startfont = endfont + 1;
+      else
+        break;
     }
   }
 #endif
 
   /* no prefix, or prefix search didn't return satisfying result */
   startfont = fontlist;
-  for(;;) {
-    if(!*startfont) break;
-    endfont = strchr(startfont,',');
-    if(endfont) *endfont = 0;
-    int ok = check_single_font(fontset,startfont,run,glyphs,!endfont); /* ignore failing glyphs if we're using the last font in the list */
-    if(endfont) {
+  for (;;) {
+    if (!*startfont)
+      break;
+    endfont = strchr(startfont, ',');
+    if (endfont)
+      *endfont = 0;
+    int ok = check_single_font(fontset, startfont, run, glyphs,
+                               !endfont); /* ignore failing glyphs if we're
+                                             using the last font in the list */
+    if (endfont) {
       *endfont = ',';
-      if(ok == MS_SUCCESS) return MS_SUCCESS;
-      startfont = endfont+1; /* go to next font in list */
+      if (ok == MS_SUCCESS)
+        return MS_SUCCESS;
+      startfont = endfont + 1; /* go to next font in list */
     } else {
-      if(ok == MS_SUCCESS) return MS_SUCCESS;
+      if (ok == MS_SUCCESS)
+        return MS_SUCCESS;
       break;
     }
   }
@@ -341,42 +398,51 @@ static int get_face_for_run(fontSetObj *
 }
 
 #ifdef USE_HARFBUZZ
-hb_font_t* get_hb_font(struct _ms_hb_user_data *font_data) {
+hb_font_t *get_hb_font(struct _ms_hb_user_data *font_data) {
   face_element *fcache = font_data->run->face;
   hb_font_element *hbf = fcache->hbfont;
   FT_Face face = fcache->face;
-  int reqsize = MS_NINT(font_data->glyph_size *96.0 / 72.0);
+  int reqsize = MS_NINT(font_data->glyph_size * 96.0 / 72.0);
 
-  if(reqsize != fcache->face->size->metrics.x_ppem) {
-    FT_Set_Pixel_Sizes(face,0,reqsize);
+  if (reqsize != fcache->face->size->metrics.x_ppem) {
+    FT_Set_Pixel_Sizes(face, 0, reqsize);
   }
 
-  if(!hbf) {
+  if (!hbf) {
     hbf = msSmallMalloc(sizeof(hb_font_element));
-    hbf->hbparentfont = hb_ft_font_create(face,NULL);
+    hbf->hbparentfont = hb_ft_font_create(face, NULL);
     hbf->hbfont = hb_font_create_sub_font(hbf->hbparentfont);
     hbf->funcs = hb_font_funcs_create();
-    hb_font_funcs_set_glyph_h_advance_func(hbf->funcs, _ms_get_glyph_h_advance_func, NULL, NULL);
-#if HB_VERSION_ATLEAST(1,2,3)
-    hb_font_funcs_set_nominal_glyph_func(hbf->funcs, _ms_get_nominal_glyph_func, NULL, NULL);
-    hb_font_funcs_set_variation_glyph_func(hbf->funcs, _ms_get_variation_glyph_func, NULL, NULL);
+    hb_font_funcs_set_glyph_h_advance_func(
+        hbf->funcs, _ms_get_glyph_h_advance_func, NULL, NULL);
+#if HB_VERSION_ATLEAST(1, 2, 3)
+    hb_font_funcs_set_nominal_glyph_func(hbf->funcs, _ms_get_nominal_glyph_func,
+                                         NULL, NULL);
+    hb_font_funcs_set_variation_glyph_func(
+        hbf->funcs, _ms_get_variation_glyph_func, NULL, NULL);
 #else
     hb_font_funcs_set_glyph_func(hbf->funcs, _ms_get_glyph_func, NULL, NULL);
 #endif
-    hb_font_funcs_set_glyph_v_advance_func(hbf->funcs, _ms_get_glyph_v_advance_func, NULL, NULL);
+    hb_font_funcs_set_glyph_v_advance_func(
+        hbf->funcs, _ms_get_glyph_v_advance_func, NULL, NULL);
     hbf->cursize = reqsize;
     fcache->hbfont = hbf;
     hb_font_set_funcs(hbf->hbfont, hbf->funcs, font_data, NULL);
   } else {
-    if(hbf->cursize != reqsize) {
-      hb_font_set_scale (hbf->hbparentfont,
-          ((uint64_t) face->size->metrics.x_scale * (uint64_t) face->units_per_EM) >> 16,
-          ((uint64_t) face->size->metrics.y_scale * (uint64_t) face->units_per_EM) >> 16);
-      hb_font_set_ppem (hbf->hbparentfont, face->size->metrics.x_ppem, face->size->metrics.y_ppem);
+    if (hbf->cursize != reqsize) {
+      hb_font_set_scale(hbf->hbparentfont,
+                        ((uint64_t)face->size->metrics.x_scale *
+                         (uint64_t)face->units_per_EM) >>
+                            16,
+                        ((uint64_t)face->size->metrics.y_scale *
+                         (uint64_t)face->units_per_EM) >>
+                            16);
+      hb_font_set_ppem(hbf->hbparentfont, face->size->metrics.x_ppem,
+                       face->size->metrics.y_ppem);
       hbf->cursize = reqsize;
     }
   }
-  hb_font_set_funcs_data(hbf->hbfont,font_data,NULL);
+  hb_font_set_funcs_data(hbf->hbfont, font_data, NULL);
   return hbf->hbfont;
 }
 
@@ -384,12 +450,12 @@ hb_font_t* get_hb_font(struct _ms_hb_use
  *  Return non-zero (true) if the given unicode array contains
  *  only ASCII and ISO Latin-1 characters, otherwise return zero.
  */
-int unicode_is_latin1(const unsigned int *unicode, long nglyphs)
-{
+int unicode_is_latin1(const unsigned int *unicode, long nglyphs) {
   long i;
 
-  for (i=0; i < nglyphs; i++) {
-    if(unicode[i] < 0x2B0) continue;
+  for (i = 0; i < nglyphs; i++) {
+    if (unicode[i] < 0x2B0)
+      continue;
     return 0;
   }
   return 1;
@@ -406,8 +472,7 @@ void get_scripts(unsigned int *cp, int l
     scripts[i] = hb_unicode_script(ufuncs, cp[i]);
 
     // common/inherit codepoints inherit script from context
-    if (scripts[i] == HB_SCRIPT_COMMON ||
-        scripts[i] == HB_SCRIPT_INHERITED) {
+    if (scripts[i] == HB_SCRIPT_COMMON || scripts[i] == HB_SCRIPT_INHERITED) {
       // unknown is not a valid context
       if (last_script != HB_SCRIPT_UNKNOWN)
         scripts[i] = last_script;
@@ -424,8 +489,7 @@ void get_scripts(unsigned int *cp, int l
   last_script = HB_SCRIPT_UNKNOWN;
   for (i = len - 1; i >= 0 && backwards_scan; i--) {
     // common/inherit codepoints inherit script from context
-    if (scripts[i] == HB_SCRIPT_COMMON ||
-        scripts[i] == HB_SCRIPT_INHERITED) {
+    if (scripts[i] == HB_SCRIPT_COMMON || scripts[i] == HB_SCRIPT_INHERITED) {
       // unknown script is not a valid context
       if (last_script != HB_SCRIPT_UNKNOWN)
         scripts[i] = last_script;
@@ -438,7 +502,7 @@ void get_scripts(unsigned int *cp, int l
 
 /* returns 1 if this is a codepoint we should skip. only checks \r for now */
 static int skip_unicode(unsigned int unicode) {
-  switch(unicode) {
+  switch (unicode) {
   case '\r':
     return 1;
     break;
@@ -451,16 +515,16 @@ static int skip_unicode(unsigned int uni
 #define MS_RTL_RTL 1
 #define MS_RTL_MIXED 2
 
-struct line_desc{
+struct line_desc {
   int length;
   int rtl;
-} ;
+};
 
 int msLayoutTextSymbol(mapObj *map, textSymbolObj *ts, textPathObj *tgret) {
 #define STATIC_GLYPHS 100
 #define STATIC_LINES 10
   text_run static_runs[STATIC_GLYPHS];
-  int i,nruns, start, ret=MS_SUCCESS;
+  int i, nruns, start, ret = MS_SUCCESS;
   size_t text_num_bytes;
   char *inp;
   unsigned int static_unicodes[STATIC_GLYPHS];
@@ -477,38 +541,42 @@ int msLayoutTextSymbol(mapObj *map, text
   int alloc_glyphs = 0;
   struct line_desc *line_descs = NULL;
   text_run *runs;
-  double oldpeny=3455,peny,penx=0; /*oldpeny is set to an unreasonable default initial value */
+  double oldpeny = 3455, peny,
+         penx = 0; /*oldpeny is set to an unreasonable default initial value */
   fontSetObj *fontset = NULL;
 
   TextInfo glyphs;
   int num_glyphs = 0;
 
-  assert(ts->annotext && *ts->annotext); /* ensure we have at least one character/glyph to treat */
-
-  if(map) fontset = &map->fontset;
-  /* go through iconv beforehand, so we know we're handling utf8 */
+  assert(
+      ts->annotext &&
+      *ts->annotext); /* ensure we have at least one character/glyph to treat */
+
+  if (map)
+    fontset = &map->fontset;
+    /* go through iconv beforehand, so we know we're handling utf8 */
 #ifdef USE_ICONV
-  if(ts->label->encoding && strcasecmp(ts->label->encoding,"UTF-8")) {
+  if (ts->label->encoding && strcasecmp(ts->label->encoding, "UTF-8")) {
     iconv_t cd;
     size_t len, bufleft;
-    char *encoded_text,*outp;
+    char *encoded_text, *outp;
     len = strlen(ts->annotext);
-    bufleft = len*6;
-    encoded_text = msSmallMalloc(bufleft+1);
+    bufleft = len * 6;
+    encoded_text = msSmallMalloc(bufleft + 1);
     cd = iconv_open("UTF-8", ts->label->encoding);
 
-    if(cd == (iconv_t)-1) {
+    if (cd == (iconv_t)-1) {
       msSetError(MS_IDENTERR, "Encoding not supported by libiconv (%s).",
-               "msGetEncodedString()", ts->label->encoding);
+                 "msGetEncodedString()", ts->label->encoding);
       return MS_FAILURE;
     }
 
     inp = ts->annotext;
     outp = encoded_text;
 
-    while(len>0) {
+    while (len > 0) {
       const size_t iconv_status = iconv(cd, &inp, &len, &outp, &bufleft);
-      if(iconv_status == (size_t)-1) {
+      if (iconv_status == (size_t)-1) {
         break;
       }
     }
@@ -524,10 +592,10 @@ int msLayoutTextSymbol(mapObj *map, text
     text_num_bytes = strlen(ts->annotext);
   }
 
-  if( text_num_bytes == 0 )
-      return 0;
+  if (text_num_bytes == 0)
+    return 0;
 
-  if(text_num_bytes > STATIC_GLYPHS) {
+  if (text_num_bytes > STATIC_GLYPHS) {
 #ifdef USE_FRIBIDI
     glyphs.bidi_levels = msSmallMalloc(text_num_bytes * sizeof(FriBidiLevel));
     glyphs.ctypes = msSmallMalloc(text_num_bytes * sizeof(FriBidiCharType));
@@ -553,31 +621,33 @@ int msLayoutTextSymbol(mapObj *map, text
 
   /* populate the unicode entries once and for all */
   inp = ts->annotext;
-  while(*inp) {
+  while (*inp) {
     unsigned int unicode;
     inp += msUTF8ToUniChar(inp, &unicode);
-    if(!skip_unicode(unicode)){
+    if (!skip_unicode(unicode)) {
       glyphs.unicodes[num_glyphs++] = unicode;
     }
   }
 
-  if(ts->label->wrap || ts->label->maxlength > 0) {
-    if(ts->label->wrap && ts->label->maxlength == 0) {
-      for(i=0;i<num_glyphs;i++) {
+  if (ts->label->wrap || ts->label->maxlength > 0) {
+    if (ts->label->wrap && ts->label->maxlength == 0) {
+      for (i = 0; i < num_glyphs; i++) {
         /* replace all occurences of the wrap character with a newline */
-        if(glyphs.unicodes[i]== (unsigned)ts->label->wrap)
-          glyphs.unicodes[i]= '\n';
+        if (glyphs.unicodes[i] == (unsigned)ts->label->wrap)
+          glyphs.unicodes[i] = '\n';
       }
     } else {
       assert(ts->label->maxlength > 0);
-      if(num_glyphs > ts->label->maxlength) {
-        int num_cur_glyph_on_line = 0; /*count for the number of glyphs on the current line*/
-        for(i=0; i<num_glyphs; i++) {
+      if (num_glyphs > ts->label->maxlength) {
+        int num_cur_glyph_on_line =
+            0; /*count for the number of glyphs on the current line*/
+        for (i = 0; i < num_glyphs; i++) {
           /* wrap at wrap character or at ZERO WIDTH SPACE (unicode 0x200b), if
            * current line is too long */
-          if((glyphs.unicodes[i] == (unsigned)ts->label->wrap || glyphs.unicodes[i] == (unsigned)0x200b)
-              && num_cur_glyph_on_line >= ts->label->maxlength) {
-            glyphs.unicodes[i]= '\n';
+          if ((glyphs.unicodes[i] == (unsigned)ts->label->wrap ||
+               glyphs.unicodes[i] == (unsigned)0x200b) &&
+              num_cur_glyph_on_line >= ts->label->maxlength) {
+            glyphs.unicodes[i] = '\n';
             num_cur_glyph_on_line = 0;
           } else {
             num_cur_glyph_on_line++;
@@ -586,8 +656,9 @@ int msLayoutTextSymbol(mapObj *map, text
       }
     }
     /*
-     * TODO RFC98: RFC40 negative label->wrap. This is left out for the moment as it requires
-     * handling a realloc and imho is never used and is an overly-complex use-case.
+     * TODO RFC98: RFC40 negative label->wrap. This is left out for the moment
+     * as it requires handling a realloc and imho is never used and is an
+     * overly-complex use-case.
      */
   }
 
@@ -596,30 +667,33 @@ int msLayoutTextSymbol(mapObj *map, text
   start = 0;
   runs[0].offset = 0;
   runs[0].line_number = 0;
-  for(i=0; i<num_glyphs; i++) {
-    if(glyphs.unicodes[i]!= '\n') continue;
+  for (i = 0; i < num_glyphs; i++) {
+    if (glyphs.unicodes[i] != '\n')
+      continue;
     runs[nruns].length = i - start; /* length of current line (without \n) */
-    start = i+1; /* start of next line */
-    runs[nruns+1].line_number = runs[nruns].line_number+1;
-    runs[nruns+1].offset = start;
+    start = i + 1;                  /* start of next line */
+    runs[nruns + 1].line_number = runs[nruns].line_number + 1;
+    runs[nruns + 1].offset = start;
     nruns++;
   }
   /* unless the last glyph was a \n, we need to "close" the last run */
-  if(glyphs.unicodes[num_glyphs-1]!= '\n') {
+  if (glyphs.unicodes[num_glyphs - 1] != '\n') {
     runs[nruns].length = num_glyphs - start;
     nruns++;
   }
 
-  if(runs[nruns-1].line_number+1 > STATIC_LINES) {
-    line_descs = msSmallMalloc((runs[nruns-1].line_number + 1)*sizeof(struct line_desc));
+  if (runs[nruns - 1].line_number + 1 > STATIC_LINES) {
+    line_descs = msSmallMalloc((runs[nruns - 1].line_number + 1) *
+                               sizeof(struct line_desc));
   } else {
     line_descs = static_line_descs;
   }
 
 #ifdef USE_FRIBIDI
-  for(i=0;i<nruns;i++) {
-    /* check the run (at this stage, one run per line), decide if we need to go through bidi and/or shaping */
-    if(unicode_is_latin1(glyphs.unicodes + runs[i].offset, runs[i].length)) {
+  for (i = 0; i < nruns; i++) {
+    /* check the run (at this stage, one run per line), decide if we need to go
+     * through bidi and/or shaping */
+    if (unicode_is_latin1(glyphs.unicodes + runs[i].offset, runs[i].length)) {
       runs[i].rtl = -1;
       line_descs[i].rtl = MS_RTL_LTR;
     } else {
@@ -627,140 +701,155 @@ int msLayoutTextSymbol(mapObj *map, text
     }
   }
 
-  for(i=0; i<nruns; i++) {
+  for (i = 0; i < nruns; i++) {
     /* split the text into bidi runs */
-    if(runs[i].rtl >= 0) {
+    if (runs[i].rtl >= 0) {
       int j, cur_run_start, original_num_glyphs, original_offset;
       FriBidiLevel prevlevel;
       FriBidiParType dir = FRIBIDI_PAR_LTR;
       original_offset = cur_run_start = runs[i].offset;
       original_num_glyphs = runs[i].length;
-      fribidi_get_bidi_types(glyphs.unicodes + original_offset, runs[i].length, glyphs.ctypes + original_offset);
+      fribidi_get_bidi_types(glyphs.unicodes + original_offset, runs[i].length,
+                             glyphs.ctypes + original_offset);
       {
-          FriBidiLevel level = fribidi_get_par_embedding_levels(glyphs.ctypes + original_offset, runs[i].length, &dir, glyphs.bidi_levels + runs[i].offset);
-          (void)level;
+        FriBidiLevel level = fribidi_get_par_embedding_levels(
+            glyphs.ctypes + original_offset, runs[i].length, &dir,
+            glyphs.bidi_levels + runs[i].offset);
+        (void)level;
       }
       /* if we have different embedding levels, create a run for each one */
       runs[i].rtl = prevlevel = glyphs.bidi_levels[original_offset];
-      line_descs[runs[i].line_number].rtl = (prevlevel%2) ? MS_RTL_RTL:MS_RTL_LTR;
-      for(j=1; j<original_num_glyphs; j++) {
-        if(glyphs.bidi_levels[original_offset+j] != prevlevel) {
+      line_descs[runs[i].line_number].rtl =
+          (prevlevel % 2) ? MS_RTL_RTL : MS_RTL_LTR;
+      for (j = 1; j < original_num_glyphs; j++) {
+        if (glyphs.bidi_levels[original_offset + j] != prevlevel) {
           line_descs[runs[i].line_number].rtl = MS_RTL_MIXED;
           /* create a new run for the different embedding level */
           nruns++;
 
           /* first move remaining runs */
-          memmove(runs+i+2,runs+i+1,(nruns-i-2)*sizeof(text_run));
+          memmove(runs + i + 2, runs + i + 1,
+                  (nruns - i - 2) * sizeof(text_run));
 
           i++;
           /* new run inherints line number */
-          runs[i].line_number = runs[i-1].line_number;
+          runs[i].line_number = runs[i - 1].line_number;
           runs[i].offset = original_offset + j;
-          runs[i].length = (runs[i-1].offset + runs[i-1].length) - runs[i].offset;
-          runs[i-1].length = runs[i].offset - runs[i-1].offset;
-
+          runs[i].length =
+              (runs[i - 1].offset + runs[i - 1].length) - runs[i].offset;
+          runs[i - 1].length = runs[i].offset - runs[i - 1].offset;
 
           /* new run starts at current postition */
-          runs[i].rtl = prevlevel = glyphs.bidi_levels[original_offset+j];
+          runs[i].rtl = prevlevel = glyphs.bidi_levels[original_offset + j];
         }
       }
     }
   }
 #else
-  for(i=0;i<nruns;i++) {
+  for (i = 0; i < nruns; i++) {
     line_descs[i].rtl = MS_RTL_LTR;
   }
 #endif
 
 #ifdef USE_FRIBIDI
-  /* determine the scripts of each run, and split again into runs with identical script */
-  for(i=0; i<nruns; i++) {
-    if(runs[i].rtl == -1) {
+  /* determine the scripts of each run, and split again into runs with identical
+   * script */
+  for (i = 0; i < nruns; i++) {
+    if (runs[i].rtl == -1) {
       runs[i].script = HB_SCRIPT_LATIN;
-      continue; /* skip runs we have determined we are latin (no shaping needed) */
+      continue; /* skip runs we have determined we are latin (no shaping needed)
+                 */
     } else {
       int j, cur_run_start, original_num_glyphs, original_offset;
       hb_script_t prevscript;
       original_offset = cur_run_start = runs[i].offset;
       original_num_glyphs = runs[i].length;
-      get_scripts(glyphs.unicodes + original_offset, runs[i].length, glyphs.scripts + original_offset);
+      get_scripts(glyphs.unicodes + original_offset, runs[i].length,
+                  glyphs.scripts + original_offset);
       /* if we have different scripts, create a run for each one */
       runs[i].script = prevscript = glyphs.scripts[original_offset];
-      for(j=1; j<original_num_glyphs; j++) {
-        if(glyphs.scripts[original_offset+j] != prevscript) {
+      for (j = 1; j < original_num_glyphs; j++) {
+        if (glyphs.scripts[original_offset + j] != prevscript) {
           /* create a new run for the different embedding level */
           nruns++;
 
           /* first move remaining runs */
-          memmove(runs+i+2,runs+i+1,(nruns-i-2)*sizeof(text_run));
+          memmove(runs + i + 2, runs + i + 1,
+                  (nruns - i - 2) * sizeof(text_run));
 
           i++;
           /* new run inherints line number and rtl*/
-          runs[i].line_number = runs[i-1].line_number;
-          runs[i].rtl = runs[i-1].rtl;
+          runs[i].line_number = runs[i - 1].line_number;
+          runs[i].rtl = runs[i - 1].rtl;
           runs[i].offset = original_offset + j;
-          runs[i].length = (runs[i-1].offset + runs[i-1].length) - runs[i].offset;
-          runs[i-1].length = runs[i].offset - runs[i-1].offset;
-
+          runs[i].length =
+              (runs[i - 1].offset + runs[i - 1].length) - runs[i].offset;
+          runs[i - 1].length = runs[i].offset - runs[i - 1].offset;
 
-          runs[i].script = prevscript = glyphs.scripts[original_offset+j];
+          runs[i].script = prevscript = glyphs.scripts[original_offset + j];
         }
       }
     }
   }
 #endif
 
-  for(i=0; i<nruns; i++) {
-    ret = get_face_for_run(fontset, ts->label->font, runs+i, &glyphs);
-    if(MS_UNLIKELY(ret == MS_FAILURE))
+  for (i = 0; i < nruns; i++) {
+    ret = get_face_for_run(fontset, ts->label->font, runs + i, &glyphs);
+    if (MS_UNLIKELY(ret == MS_FAILURE))
       goto cleanup;
   }
 
   /*
-   * determine the font face to use for a given run. No splitting needed here for
-   * now, as we suppose that the decomposition of each run into individual bidi
-   * direction and script level is sufficient to ensure that a given run can be
-   * represented by a single font (i.e. there's no need to look into multiple fonts
-   * to find the glyphs of the run)
+   * determine the font face to use for a given run. No splitting needed here
+   * for now, as we suppose that the decomposition of each run into individual
+   * bidi direction and script level is sufficient to ensure that a given run
+   * can be represented by a single font (i.e. there's no need to look into
+   * multiple fonts to find the glyphs of the run)
    */
 
-
-  tgret->numlines = runs[nruns-1].line_number + 1;
+  tgret->numlines = runs[nruns - 1].line_number + 1;
   tgret->bounds.bbox.minx = 0;
   tgret->bounds.bbox.miny = FLT_MAX;
   tgret->bounds.bbox.maxx = tgret->bounds.bbox.maxy = -FLT_MAX;
 
-
-  for(i=0;i<nruns;i++) {
-    if(!runs[i].face) continue;
+  for (i = 0; i < nruns; i++) {
+    if (!runs[i].face)
+      continue;
     peny = (1 - tgret->numlines + runs[i].line_number) * tgret->line_height;
-    if(peny != oldpeny) {
-      if(i>0) line_descs[runs[i-1].line_number].length = penx;
-      if(penx > tgret->bounds.bbox.maxx)
+    if (peny != oldpeny) {
+      if (i > 0)
+        line_descs[runs[i - 1].line_number].length = penx;
+      if (penx > tgret->bounds.bbox.maxx)
         tgret->bounds.bbox.maxx = penx;
       oldpeny = peny;
       penx = 0;
     }
 #if defined(USE_HARFBUZZ) && defined(USE_FRIBIDI)
-    if(runs[i].rtl == -1 || runs[i].script == HB_SCRIPT_LATIN || runs[i].script == HB_SCRIPT_COMMON)
+    if (runs[i].rtl == -1 || runs[i].script == HB_SCRIPT_LATIN ||
+        runs[i].script == HB_SCRIPT_COMMON)
 #endif
     {
       /* use our basic shaper */
       unsigned int *codepoint = glyphs.codepoints + runs[i].offset;
       alloc_glyphs += runs[i].length;
-      tgret->glyphs = msSmallRealloc(tgret->glyphs, alloc_glyphs * sizeof(glyphObj));
-      for(int j=0;j<runs[i].length;j++) {
+      tgret->glyphs =
+          msSmallRealloc(tgret->glyphs, alloc_glyphs * sizeof(glyphObj));
+      for (int j = 0; j < runs[i].length; j++) {
         glyphObj *g = &tgret->glyphs[tgret->numglyphs + j];
-        g->glyph = msGetGlyphByIndex(runs[i].face,tgret->glyph_size, *codepoint);
+        g->glyph =
+            msGetGlyphByIndex(runs[i].face, tgret->glyph_size, *codepoint);
         g->face = runs[i].face;
         codepoint++;
         g->pnt.x = penx;
         g->pnt.y = peny;
         g->rot = 0.0;
         penx += g->glyph->metrics.advance;
-        if(runs[i].line_number == 0 && peny - g->glyph->metrics.maxy < tgret->bounds.bbox.miny) /*compute minimal y, only for the first line */
+        if (runs[i].line_number == 0 &&
+            peny - g->glyph->metrics.maxy <
+                tgret->bounds.bbox
+                    .miny) /*compute minimal y, only for the first line */
           tgret->bounds.bbox.miny = peny - g->glyph->metrics.maxy;
-        if(peny - g->glyph->metrics.miny > tgret->bounds.bbox.maxy)
+        if (peny - g->glyph->metrics.miny > tgret->bounds.bbox.maxy)
           tgret->bounds.bbox.maxy = peny - g->glyph->metrics.miny;
       }
 #if defined(USE_HARFBUZZ) && defined(USE_FRIBIDI)
@@ -769,73 +858,82 @@ int msLayoutTextSymbol(mapObj *map, text
       hb_font_t *font;
       hb_glyph_info_t *glyph_info;
       hb_glyph_position_t *glyph_pos;
-      if(!buf) {
+      if (!buf) {
         buf = hb_buffer_create();
       }
       user_data.info = &glyphs;
       user_data.run = runs + i;
       user_data.glyph_size = tgret->glyph_size;
       hb_buffer_clear_contents(buf);
-      hb_buffer_set_script (buf, runs[i].script);
+      hb_buffer_set_script(buf, runs[i].script);
       font = get_hb_font(&user_data);
-      hb_buffer_set_direction(buf, (runs[i].rtl%2) ? HB_DIRECTION_RTL :HB_DIRECTION_LTR);
-      hb_buffer_add_utf32(buf,glyphs.unicodes + runs[i].offset, runs[i].length, 0, runs[i].length);
-      hb_shape(font,buf,hbfeatures,2);
+      hb_buffer_set_direction(buf, (runs[i].rtl % 2) ? HB_DIRECTION_RTL
+                                                     : HB_DIRECTION_LTR);
+      hb_buffer_add_utf32(buf, glyphs.unicodes + runs[i].offset, runs[i].length,
+                          0, runs[i].length);
+      hb_shape(font, buf, hbfeatures, 2);
 
       unsigned int glyph_count;
       glyph_info = hb_buffer_get_glyph_infos(buf, &glyph_count);
       glyph_pos = hb_buffer_get_glyph_positions(buf, &glyph_count);
       alloc_glyphs += glyph_count;
-      tgret->glyphs = msSmallRealloc(tgret->glyphs, alloc_glyphs * sizeof(glyphObj));
-      for(unsigned j=0;j<glyph_count;j++) {
+      tgret->glyphs =
+          msSmallRealloc(tgret->glyphs, alloc_glyphs * sizeof(glyphObj));
+      for (unsigned j = 0; j < glyph_count; j++) {
         glyphObj *g = &tgret->glyphs[tgret->numglyphs + j];
-        g->glyph = msGetGlyphByIndex(runs[i].face,tgret->glyph_size,glyph_info[j].codepoint);
+        g->glyph = msGetGlyphByIndex(runs[i].face, tgret->glyph_size,
+                                     glyph_info[j].codepoint);
         g->face = runs[i].face;
-        g->pnt.x = penx + glyph_pos[j].x_offset/64;
-        g->pnt.y = peny - glyph_pos[j].y_offset/64;
+        g->pnt.x = penx + glyph_pos[j].x_offset / 64;
+        g->pnt.y = peny - glyph_pos[j].y_offset / 64;
         g->rot = 0;
-        penx += glyph_pos[j].x_advance/64.0;
+        penx += glyph_pos[j].x_advance / 64.0;
         /* peny -= glyph_pos[j].y_advance/64; // we don't do vertical layouts */
-        if(runs[i].line_number == 0 && peny - g->glyph->metrics.maxy < tgret->bounds.bbox.miny) /*compute minimal y, only for the first line */
+        if (runs[i].line_number == 0 &&
+            peny - g->glyph->metrics.maxy <
+                tgret->bounds.bbox
+                    .miny) /*compute minimal y, only for the first line */
           tgret->bounds.bbox.miny = peny - g->glyph->metrics.maxy;
-        if(peny - g->glyph->metrics.miny > tgret->bounds.bbox.maxy)
+        if (peny - g->glyph->metrics.miny > tgret->bounds.bbox.maxy)
           tgret->bounds.bbox.maxy = peny - g->glyph->metrics.miny;
       }
 #endif
     }
     tgret->numglyphs = alloc_glyphs;
-    line_descs[runs[nruns-1].line_number].length = penx;
-    if(penx > tgret->bounds.bbox.maxx)
+    line_descs[runs[nruns - 1].line_number].length = penx;
+    if (penx > tgret->bounds.bbox.maxx)
       tgret->bounds.bbox.maxx = penx;
   }
 
 #ifdef USE_HARFBUZZ
-  if(buf) {
+  if (buf) {
     hb_buffer_destroy(buf);
   }
 #endif
 
-  if(tgret->numlines > 1) {
+  if (tgret->numlines > 1) {
     int max_line_length = 0;
     int line = -1;
     double cur_line_offset = 0;
-    int prev_default_align = MS_ALIGN_LEFT; /* if we have mixed rtl status, use the alignment of the previous
-                                               line. this defaults to left-alignment if the first line is mixed */
+    int prev_default_align =
+        MS_ALIGN_LEFT; /* if we have mixed rtl status, use the alignment of the
+                          previous line. this defaults to left-alignment if the
+                          first line is mixed */
     int cur_default_align = 0;
-    for(i=0; i<tgret->numlines; i++) {
-      if(line_descs[i].length > max_line_length) {
+    for (i = 0; i < tgret->numlines; i++) {
+      if (line_descs[i].length > max_line_length) {
         max_line_length = line_descs[i].length;
       }
     }
     oldpeny = 3455;
-    for(i=0; i<alloc_glyphs; i++) {
-      if(tgret->glyphs[i].pnt.y != oldpeny) {
+    for (i = 0; i < alloc_glyphs; i++) {
+      if (tgret->glyphs[i].pnt.y != oldpeny) {
         oldpeny = tgret->glyphs[i].pnt.y;
         line++;
         /* compute offset to apply to coming line */
-        switch(ts->label->align) {
+        switch (ts->label->align) {
         case MS_ALIGN_CENTER:
-          cur_line_offset = (max_line_length - line_descs[line].length)/2.0;
+          cur_line_offset = (max_line_length - line_descs[line].length) / 2.0;
           break;
         case MS_ALIGN_RIGHT:
           cur_line_offset = (max_line_length - line_descs[line].length);
@@ -845,7 +943,7 @@ int msLayoutTextSymbol(mapObj *map, text
           break;
         case MS_ALIGN_DEFAULT:
         default:
-          switch(line_descs[line].rtl) {
+          switch (line_descs[line].rtl) {
           case MS_RTL_MIXED:
             cur_default_align = prev_default_align;
             break;
@@ -856,7 +954,7 @@ int msLayoutTextSymbol(mapObj *map, text
             cur_default_align = prev_default_align = MS_RTL_LTR;
             break;
           }
-          switch(cur_default_align) {
+          switch (cur_default_align) {
           case MS_RTL_RTL:
             /* align to the right */
             cur_line_offset = (max_line_length - line_descs[line].length);
@@ -871,12 +969,14 @@ int msLayoutTextSymbol(mapObj *map, text
     }
   }
   /*
-   * msDebug("bounds for %s: %f %f %f %f\n",ts->annotext,tgret->bounds.bbox.minx,tgret->bounds.bbox.miny,tgret->bounds.bbox.maxx,tgret->bounds.bbox.maxy);
+   * msDebug("bounds for %s: %f %f %f
+   * %f\n",ts->annotext,tgret->bounds.bbox.minx,tgret->bounds.bbox.miny,tgret->bounds.bbox.maxx,tgret->bounds.bbox.maxy);
    */
 
 cleanup:
-  if(line_descs != static_line_descs) free(line_descs);
-  if(glyphs.codepoints != static_codepoints) {
+  if (line_descs != static_line_descs)
+    free(line_descs);
+  if (glyphs.codepoints != static_codepoints) {
 #ifdef USE_FRIBIDI
     free(glyphs.bidi_levels);
     free(glyphs.ctypes);
@@ -889,6 +989,4 @@ cleanup:
     free(runs);
   }
   return ret;
-
-
 }
diff -pruN 8.0.1-5/tile4ms.c 8.0.2-1/tile4ms.c
--- 8.0.1-5/tile4ms.c	2023-04-17 17:26:04.000000000 +0000
+++ 8.0.2-1/tile4ms.c	2024-06-11 20:41:34.000000000 +0000
@@ -35,100 +35,93 @@
  *****************************************************************************/
 
 /*
-* This is a modified version of Herbie's program that works with MapServer's
-* shapelib and should be using the MapServer makefile.
-*
-*/
+ * This is a modified version of Herbie's program that works with MapServer's
+ * shapelib and should be using the MapServer makefile.
+ *
+ */
 
 #include "mapserver.h"
 #include <string.h>
 
-
-
 /***********************************************************************/
 int process_shapefiles(char *metaFileNameP, char *tileFileNameP,
-                       int tile_path_only)
-{
-  SHPHandle   hSHP, tileSHP;
-  rectObj     extentRect;
-  lineObj     line;
-  shapeObj    shapeRect;
-  DBFHandle   tileDBF;
-  DBFHandle   shpDBF;
+                       int tile_path_only) {
+  SHPHandle hSHP, tileSHP;
+  rectObj extentRect;
+  lineObj line;
+  shapeObj shapeRect;
+  DBFHandle tileDBF;
+  DBFHandle shpDBF;
 
   typedef struct DBFFieldDef_struct {
-    DBFFieldType  type;
-    char          name[12];
-    int           width;
-    int           decimals;
+    DBFFieldType type;
+    char name[12];
+    int width;
+    int decimals;
   } DBFFieldDef;
 
-  DBFFieldDef     *theFields = NULL;
-  char            fldname[256];
-  int             width;
-  int             decimals;
-  int             fieldCnt;
-  int             i;
-
-  FILE        *metaFP = NULL;
-  char        *p;
-  char        tileshapeName[256];
-  char        tiledbfName[256];
-  char        shapeFileName[256];
-  int     entityNum;
+  DBFFieldDef *theFields = NULL;
+  char fldname[256];
+  int width;
+  int decimals;
+  int fieldCnt;
+  int i;
+
+  FILE *metaFP = NULL;
+  char *p;
+  char tileshapeName[256];
+  char tiledbfName[256];
+  char shapeFileName[256];
+  int entityNum;
 
-  int     tilesFound = 0;
-  int     tilesProcessed = 0;
+  int tilesFound = 0;
+  int tilesProcessed = 0;
 
   msInitShape(&shapeRect);
-  line.point = (pointObj *)msSmallMalloc(sizeof(pointObj)*5);
+  line.point = (pointObj *)msSmallMalloc(sizeof(pointObj) * 5);
   line.numpoints = 5;
 
   /* open metafile */
   /* ------------- */
-  if (NULL==(metaFP=fopen(metaFileNameP, "r"))) {
-    printf( "Unable to open:%s\n", metaFileNameP);
-    return(1);
+  if (NULL == (metaFP = fopen(metaFileNameP, "r"))) {
+    printf("Unable to open:%s\n", metaFileNameP);
+    return (1);
   }
 
-
   /* create new tileindex shapefiles and create a header */
   /* -------------------------------------------------- */
   snprintf(tileshapeName, sizeof(tileshapeName), "%s.shp", tileFileNameP);
 
-  if(NULL==(tileSHP=msSHPCreate(tileFileNameP, SHP_POLYGON))) {
+  if (NULL == (tileSHP = msSHPCreate(tileFileNameP, SHP_POLYGON))) {
     fclose(metaFP);
     printf("Unable to create %s.shp (.shx)\n", tileFileNameP);
-    return(1);
+    return (1);
   }
 
-
   /* create new tileindex dbf-file */
   /* ----------------------------- */
   snprintf(tiledbfName, sizeof(tiledbfName), "%s.dbf", tileFileNameP);
-  if (NULL==(tileDBF=msDBFCreate(tiledbfName))) {
+  if (NULL == (tileDBF = msDBFCreate(tiledbfName))) {
     fclose(metaFP);
     msSHPClose(tileSHP);
     printf("DBFCreate(%s) failed.\n", tiledbfName);
-    return(1);
+    return (1);
   }
 
-  if(msDBFAddField(tileDBF, "LOCATION", FTString, 255, 0 )== -1 ) {
+  if (msDBFAddField(tileDBF, "LOCATION", FTString, 255, 0) == -1) {
     fclose(metaFP);
     msSHPClose(tileSHP);
     msDBFClose(tileDBF);
     printf("DBFAddField(fieldname='LOCATION') failed.\n");
-    return(1);
+    return (1);
   }
 
-
-
   /* loop through files listed in metafile */
   /* ===================================== */
   while (fgets(shapeFileName, 255, metaFP)) {
 
-
-    if ((p=strchr(shapeFileName, '\n')) != NULL) *p='\0';
+    if ((p = strchr(shapeFileName, '\n')) != NULL)
+      *p = '\0';
 
     if (!strlen(shapeFileName))
       break;
@@ -140,31 +133,33 @@ int process_shapefiles(char *metaFileNam
 
     shpDBF = msDBFOpen(shapeFileName, "rb");
 
-    if( shpDBF == NULL ) {
-      printf( "Aborted. Unable to open DBF:%s\n", shapeFileName);
+    if (shpDBF == NULL) {
+      printf("Aborted. Unable to open DBF:%s\n", shapeFileName);
       break;
     }
 
-    if( theFields == NULL ) {
+    if (theFields == NULL) {
       fieldCnt = msDBFGetFieldCount(shpDBF);
-      theFields = (DBFFieldDef *) msSmallCalloc(fieldCnt, sizeof(DBFFieldDef));
-      for (i=0; i<fieldCnt; i++) {
-        theFields[i].type = msDBFGetFieldInfo(shpDBF, i,
-                                              theFields[i].name,
-                                              &theFields[i].width, &theFields[i].decimals);
-        if( theFields[i].type == FTInvalid ) {
-          printf( "Aborted. DBF Invalid field (%d of %d) file:%s\n",
-                  i, fieldCnt, shapeFileName);
+      theFields = (DBFFieldDef *)msSmallCalloc(fieldCnt, sizeof(DBFFieldDef));
+      for (i = 0; i < fieldCnt; i++) {
+        theFields[i].type =
+            msDBFGetFieldInfo(shpDBF, i, theFields[i].name, &theFields[i].width,
+                              &theFields[i].decimals);
+        if (theFields[i].type == FTInvalid) {
+          printf("Aborted. DBF Invalid field (%d of %d) file:%s\n", i, fieldCnt,
+                 shapeFileName);
           break;
         }
       }
     } else {
       fieldCnt = msDBFGetFieldCount(shpDBF);
-      for (i=0; i<fieldCnt; i++) {
-        if( theFields[i].type != msDBFGetFieldInfo(shpDBF, i, fldname, &width, &decimals) ||
-            strcmp(theFields[i].name, fldname) ||
-            theFields[i].width != width || theFields[i].decimals != decimals ) {
-          printf( "Aborted. DBF fields do not match for file:%s\n", shapeFileName);
+      for (i = 0; i < fieldCnt; i++) {
+        if (theFields[i].type !=
+                msDBFGetFieldInfo(shpDBF, i, fldname, &width, &decimals) ||
+            strcmp(theFields[i].name, fldname) || theFields[i].width != width ||
+            theFields[i].decimals != decimals) {
+          printf("Aborted. DBF fields do not match for file:%s\n",
+                 shapeFileName);
           break;
         }
       }
@@ -173,7 +168,7 @@ int process_shapefiles(char *metaFileNam
 
     /* Get rid of .shp extension if it was included. */
     if (strlen(shapeFileName) > 4 &&
-        (p=shapeFileName+strlen(shapeFileName)-4) &&
+        (p = shapeFileName + strlen(shapeFileName) - 4) &&
         strcasecmp(p, ".shp") == 0)
       *p = '\0';
 
@@ -184,24 +179,25 @@ int process_shapefiles(char *metaFileNam
     /* -------------------------- */
     hSHP = msSHPOpen(shapeFileName, "rb");
 
-    if( hSHP == NULL )  {
-      printf( "Aborted. Unable to open SHP:%s\n", shapeFileName);
+    if (hSHP == NULL) {
+      printf("Aborted. Unable to open SHP:%s\n", shapeFileName);
       break;
     }
 
     msSHPReadBounds(hSHP, -1, &extentRect);
     /* SHPGetInfo(hSHP, &nEntities, &nShapeType, adfBndsMin, adfBndsMax); */
 
-    /* printf("File:  %s Bounds 0/1: (%15.10lg,%15.10lg)\n\t(%15.10lg,%15.10lg)\n", shapeFileName, adfBndsMin[0], adfBndsMin[1], adfBndsMax[0], adfBndsMax[1] ); */
+    /* printf("File:  %s Bounds 0/1:
+     * (%15.10lg,%15.10lg)\n\t(%15.10lg,%15.10lg)\n", shapeFileName,
+     * adfBndsMin[0], adfBndsMin[1], adfBndsMax[0], adfBndsMax[1] ); */
 
     msSHPClose(hSHP);
 
-
     /* create rectangle describing current shapefile extent */
     /* ---------------------------------------------------- */
 
     line.point[0].x = line.point[4].x = extentRect.minx; /* bottom left */
-    line.point[0].y = line.point[4].y  = extentRect.miny;
+    line.point[0].y = line.point[4].y = extentRect.miny;
     line.point[1].x = extentRect.minx; /* top left */
     line.point[1].y = extentRect.maxy;
     line.point[2].x = extentRect.maxx; /* top left */
@@ -209,13 +205,12 @@ int process_shapefiles(char *metaFileNam
     line.point[3].x = extentRect.maxx; /* bottom right */
     line.point[3].y = extentRect.miny;
 
-
     /* create and add shape object.  Returns link to entry in DBF file */
     /* --------------------------------------------------------------- */
 
     shapeRect.type = MS_SHAPE_POLYGON;
     msAddLine(&shapeRect, &line);
-    entityNum = msSHPWriteShape( tileSHP, &shapeRect );
+    entityNum = msSHPWriteShape(tileSHP, &shapeRect);
 
     msFreeShape(&shapeRect);
 
@@ -226,15 +221,14 @@ int process_shapefiles(char *metaFileNam
     if (tile_path_only) {
       char *pszTmp;
       if ((pszTmp = strrchr(shapeFileName, '/')) != NULL ||
-          (pszTmp = strrchr(shapeFileName, '\\')) != NULL ) {
-        *(pszTmp+1) = '\0';  /* Keep the trailing '/' only. */
+          (pszTmp = strrchr(shapeFileName, '\\')) != NULL) {
+        *(pszTmp + 1) = '\0'; /* Keep the trailing '/' only. */
       }
     }
 
     msDBFWriteStringAttribute(tileDBF, entityNum, 0, shapeFileName);
 
     tilesProcessed++;
-
   }
 
   msSHPClose(tileSHP);
@@ -245,52 +239,46 @@ int process_shapefiles(char *metaFileNam
   free(line.point);
   free(theFields);
 
-
   printf("Processed %i of %i files\n", tilesProcessed, tilesFound);
 
-
   return (0);
-
 }
 
 /***********************************************************************/
-void print_usage_and_exit(void)
-{
+void print_usage_and_exit(void) {
 
   printf("\nusage: tile4ms <meta-file> <tile-file> [-tile-path-only]\n");
-  printf("<meta-file>\tINPUT  file containing list of shapefile names\n\t\t(complete paths 255 chars max, no extension)\n");
-  printf("<tile-file>\tOUTPUT shape file of extent rectangles and names\n\t\tof tiles in <tile-file>.dbf\n");
-  printf("-tile-path-only\tOptional flag.  If specified then only the path to the \n\t\tshape files will be stored in the LOCATION field\n\t\tinstead of storing the full filename.\n\n");
+  printf("<meta-file>\tINPUT  file containing list of shapefile "
+         "names\n\t\t(complete paths 255 chars max, no extension)\n");
+  printf("<tile-file>\tOUTPUT shape file of extent rectangles and "
+         "names\n\t\tof tiles in <tile-file>.dbf\n");
+  printf("-tile-path-only\tOptional flag.  If specified then only the path to "
+         "the \n\t\tshape files will be stored in the LOCATION "
+         "field\n\t\tinstead of storing the full filename.\n\n");
   exit(1);
 }
 
-
-
 /***********************************************************************/
-int main( int argc, char **argv )
-{
+int main(int argc, char **argv) {
   int tile_path_only = 0;
 
   /* stun user with existence of help  */
   /* -------------------------------- */
-  if ((argc == 2)&&(strstr(argv[1], "-h"))) {
+  if ((argc == 2) && (strstr(argv[1], "-h"))) {
     print_usage_and_exit();
   }
 
-
   /* check arguments */
   /* --------------- */
-  if( argc < 3 ) {
+  if (argc < 3) {
     print_usage_and_exit();
   }
 
-  if ( argc == 4 && strcmp(argv[3],"-tile-path-only") == 0) {
+  if (argc == 4 && strcmp(argv[3], "-tile-path-only") == 0) {
     tile_path_only = 1;
   }
 
   process_shapefiles(argv[1], argv[2], tile_path_only);
 
-
   exit(0);
 }
-
